The following subdirectories contain the source files
in liblibr.a.

libr.common : Architecture-independent routines.
libr.arch   : Architecture-dependent routines with preprocessor directives.

*****************

SOURCE CONTROL!!!

If you port the code to another machine, chances are the changes you make to
the code will be local to that machine. Well, it does us no good if you leave
the changes there and do not update the central source.

Additionally, if you copy all the source from libr.arch and libr.common to
one directory and change something, be sure to categorize the new source
accordingly. E.G., if libr.common/dump.F needs an "#ifdef M_*" then move it
to libr.arch after making the changes.

I (Anthony) would suggest symbolically linking to the source in both
directories from one build directory. This way: 1) changes will automatically
be updated to their source files, 2) there is a reduced chance that a file
will coexist in libr.common AND libr.arch, and 3) changes to the central source
will be added automatically to your copies since no one likes CVS.

This directory contains the core files to access and interact with the ACES
environment. Subsystems are described below.

--------------
ACES SUBSYSTEM
--------------

files required/created:
   (see other subsystems)

main routines:
   ACES_INIT - initializes the ACES environment
   ACES_FIN  - finalizes   the ACES environment

calling order:
   call aces_init(iCore,iUHF,bAllocMem)
   ...
   call aces_fin

---------------------
JOB ARCHIVE SUBSYSTEM
---------------------

files required/created:
   JOBARC - the unformatted, direct access file containing all the ACES records
   JAINDX - the unformatted file containing the record statistics (jobarc.com)

main routines:
   ACES_JA_INIT - initializes the job archive environment
   ACES_JA_FIN  - finalizes   the job archive environment
   GETREC - retrieves a record from the job archive
   PUTREC - stores    a record to   the job archive

calling order:
   call aces_ja_init
   call getrec/putrec(...)
   call aces_ja_fin

-------------
I/O SUBSYSTEM
-------------

files required/created:
   MOINTS, GAMLAM, MOABCD, DERINT, DERGAM - the unformatted, direct access
      files containing double precision arrays (each contains up to 100 list
      families of 10 array groups)

main routines:
   ACES_IO_INIT - initializes the I/O environment
   ACES_IO_FIN  - finalizes   the I/O environment
   GETLST - retrieves columns from an array in a storage file
   PUTLST - stores    columns to   an array in a storage file

calling order:
   call aces_io_init(iCore,i0,iMem,bInitCache)
   call getlst/putlst(...)
   call aces_io_fin

---------------
CACHE SUBSYSTEM
---------------

files required/created:
   none

main routines:
   ACES_CACHE_INIT - initializes the cache for list processing

calling order:
   call aces_cache_init(iCore,i0,iMem)
   call getlst/putlst(...)

---------------
CHEMICAL SYSTEM
---------------

files required/created:
   none

related routines:
   ACES_INIT_CHEMSYS - initializes various common blocks

calling order:
   call aces_init_chemsys

NOTES ON OPERATING PROCEDURES by Ajith Perera 06/20001

I was asked many occasions how symcor works, especially
whether it is doing it's supposed job most effeciently.
One of the questions that is frequently asked is whether
symcor is actually taking advantage of the symmetry. For
example, in a C2V molecule such as H2O, are we duplicating
the Force Constant matrix calculations for symmetry
equivalent Hydrogens. Another question that was raised
recently has to deal with the mode of point selction;
single sided or double sided differentiation. In order to
answer these questions,
one has to inner working of the symcor member
executable (ME).

The function of symcor is to set up a table of geometry
points which will be used to generate energies which
will eventually be used to calculate numerical gradients
or Hessians. The symcor ME is used during finite
difference frequency calculations with analytical gradients
and numerical Hessians,
finite difference frequency calculations with numerical
gradients and Hessians and geometry optimizations with numerical
gradients. The symcor ME is not needed for
analytical gradient geometry optimizations. We will address
each mode of operation separately. Let's look at
some of the preliminaries;

 The first step is to make symmetry assignments
 to molecular vibrations (See Group Theory Cotton).
 The basis vectors that are used in here are
 (x,y,z) coordinates of each atoms. The actual
 subroutine that handle this operation is vibinf.f
 This is word by word computer implementation of
vibrational analysis descirbed in Cotton Pg. 309-315.
 Next step is to symmetry adapted vibrational coordiantes.
 This is done in symadq.f. It is somewhat difficult algorithm
 to understand. Once again the basis vectors are (x,y,z)
 coordinates of each nuclei. We take basis vectors for
 atom (eg. x coordinate on atom) and apply symmetry operations
 of the group and multiply by the character of irrep and
 sum over all the operations. It should be clear to people
 for some basis vectros this sum can be zero. That means
 that particular motion doest not constitue a vibration,
 rotation or translation. For eg. H2O, C2V (molecule in
 YZ plane) the x coordinates on H atoms does not contribute
 any of the motions due to symmetry. Only reason I am
 going to such details here is to answer the question
 whether we are doing unnecessary duplicate
 energy or energy gradient calculations.
 The answer is NO!!!! All the displacements are symmetry
 adapted. After appropriate normalizations, we will
 end up with a set of symmerty adapted Cartesian displacements
 (respect to an arbitrary origin). Now one has to transform
 them to the center-of-mass and principle axis (diagonalize
 the moment of inertia matrix). Here it is achived in traprj.f
 and rotprj.f. In my opinion rotational and translational
 projections are unfortunate names: they tend to imply that this
 is a some esoteric operation (it took me a while to figure
 out what the hell is going on those two routines).

 At this point we are ready to generate points for various
 options for numerical derivatives; Note that we always
 run a energy calculation at the reference geometry (E_0).

 NUMERICAL (both first and second derv.) FREQUANCY CALCULATIONS:


  The relevent routines are setpts.f and doener.f. At this point
  we know how many vibrations in each symmetry block. Assume that
  we have N vib. modes in a given symmetry block (q_1...q_n).
  The derivatives that we are trying to calculate are DE/Dq_iDq_j
  for all i and j.
  To get a numerical Hessian for a given mode, we need at least
  3 dispalced points. The reference (E_0), a positive
  displacement and a negative displacement. If particular
  vibration happens to have a plane or center of inversion,
  negative displacement is
  identical except for a oposite sign. In other words
  no explicit energy calculation is not required.

  Maximum # of points = N*(N+1), (or N*(N+1)/2 for A1 modes)
                      + Reference

 NUMERICAL DERIVATIVE GEOMETRTY OPTIMIZATION CALCULATIONS.

  The most of the above discussion apply. However, the total
  displacement has to preserve the symmetry of the molecule.
  That means we only do consider totaly symmetric irreps.
  Also, we only need the derivatives DE/Dq_iDq_j (i=j).

 Maximum # of points = 2*N + Reference

 ANALITICAL DERIVATIVE FREQUANCY CALCULATIONS.


  The relevent routines are setpts.f and dograd.f. At this point
  we know how many vibrations in each symmetry block. Assume that
  you have N modes in a symmetry block (q_1...q_n)
  To calculate Hessian, we need a gradient at a two displaced points.
  What we trying to calculate is DG/Dq_i for all i. For vibrations
  that have plane or center od inversion, we only need positive dispalcements
  since the negative displacement is identical to positive
  one but with an opposite sign.

 Maximum # of Points = 2*N or (N for A1 modes).

 SYMCOR IS NOT NEEDED for ANALYTICAL GRADIENT GEOMETRY OPTIMIZATIONS

 In light of this investigations we can make the
 following conclusions.

  1. There is no repeat of energy calculations for symmetry
     redundent centers. The program take full advantage of
     Abelian symmetry.

  2. The numerical derivatives are calculated in double
     sided fashion. However, for totally symmetric
     irreps single or double sided makes no difference
     since we actualy do not do the energy calculation
     for the negative dispalcement (It is identical
     to the positive displaced value). In the case
     of numerical gradients and Hessians, the routine
     of interest is ener2fcm.f and for the case
     of anlytical gradients and numrical Hessian
     it is grad2fcm.f

  Logic in ener2fcm:

     For totally symmetric irreps:

     Digonal of the Force constant matrix,
                             DE/Dq_iDq_i = 2*(E_pi-E_0)/STPSZ**2

     where E_pi is the positive dispalced energy of ith mode and

STPSZ is the stepsize.

     Off diagonal elements of the FC matrix
                             DE/Dq_iDq_j = (2*(E_pipj-E_0) -
                                               E_pi - E_0) -
                                               E_pj - E_0))/2*STPSZ**2


     E_pipj is the positive dispalced energy of the ith mode
     while jth mode is held constant or vice versa.

     For other irreps:

     Digonal of the Force constant matrix,
                             DE/Dq_iDq_i = (E_pi+E_mi-2*E_0)/STPSZ**2

     where E_mi is the negative dispalced energy of ith mode and
     STPSZ is the stepsize.

     Off diagonal elements of the FC matrix
                             DE/Dq_iDq_j = (E_pipj + E_mimj - 2*E_0) -
                                               E_Pi +E_mi - 2*E_0) -
                                               E_Pj +E_mj - 2*E_0))
                                             /2*STPSZ**2

     E_mimj is the negative dispalced energy of the ith mode
     while jth mode is held constant or vice versa.

  Logic in grad2fcm is straightforward.

      SUBROUTINE A2GET_ANG_TYPE(MAXATMS, NTOTPRIM, MAXSHELL, NSHL, 
     &                          NANGMOMSHL, NPRIMFUNSHL, IANGTYPE,
     &                          COORD, CNT_COORD)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DIMENSION NANGMOMSHL(MAXATMS, MAXSHELL), IP(20), FAC(9,9), 
     &          IOFFST(15), IANGTYPE(NTOTPRIM), NSHL(MAXATMS),
     &          NPRIMFUNSHL(MAXATMS,MAXSHELL), 
     &          CNT_COORD(3, NTOTPRIM), COORD(3*MAXATMS)
C      
      CALL SETRHF(FAC, IOFFST, IP)
C
      NFUNC_COUNT = 0
      DO IATMS = 1, MAXATMS
C                  
            DO ISHL = 1, NSHL(IATMS)
C
               IANGMOM = NANGMOMSHL(IATMS, ISHL)
               IPRIM   = NPRIMFUNSHL(IATMS, ISHL)
               IINTTYP = IOFFST(IANGMOM)
               ITYPE   = IINTTYP
C
               DO IMOMN = 1, IANGMOM
                  ITYPE = ITYPE + 1
                  DO NPRIM = 1, IPRIM
                     NFUNC_COUNT = NFUNC_COUNT + 1
                     IANGTYPE(NFUNC_COUNT) = ITYPE
C
                     ICOORD = (IATMS - 1)*3
                     DO IXYZ = 1, 3
                        CNT_COORD(IXYZ, NFUNC_COUNT) = 
     &                                  COORD(ICOORD + IXYZ)
                     ENDDO
   
                  ENDDO
               ENDDO
C
            ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,I4)") "The number of primitive functions", 
     &                   NFUNC_COUNT 
      Write(6,*)
      write(6,"(a)") "The angular momentum type of each function"
      Write(6,"(6i4)") (IANGTYPE(i), i=1, NFUNC_COUNT)
#endif
      RETURN
      END
 

C---------------------------------------------------------------------
C
      SubroutinE a2read_jarc(FlgACESGeom,FlgACESElec,FlgACESGrad,
     &                       FlgACESHess,FlgACESForc,Natom,Nreal,
     &                       Imap, Coord, Etot, AtmMass, AtmLabel, 
     &                       Vgrad, Grad, Vhess, Hess, Vomega, 
     &                       Omega, IUhf,Nirrep, Nvibs, B2ang, 
     &                       Au2Invcm, Wrt_extrnl)
C
      Implicit double precision (a-h,o-z)
C


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C
      Logical FlgACESGeom,FlgACESElec,FlgACESGrad,FlgACESHess,
     &        FlgACESForc, Wrt_extrnl
      Character*5  AtmLabel(Mxatms)
      character*10 Label
      Character*4  PTGRP
C
      Dimension NOcc(16),AtmMass(Natom),Coord(3,Natom),
     &          VGrad(3,Natom),Grad(3,Nreal),Imap(Nreal),
     &          Hess(3*Nreal,3*Nreal),Freq(3*Nreal),
     &          Vhess(9*Natom*Natom),VOmega(3*Natom),
     &          Omega(Nvibs)

C
      IUnitO=30
C
C---------------------------------------------------------------------
C
C     Read number of atoms
C---------------------------------------------------------------------
C
C
C---------------------------------------------------------------------
C
C     Read coordinate and translate from bohr to angstrom
C---------------------------------------------------------------------
C
      ierr =  1
      If (flgACESGeom) then
C
         Do j=1,3
            Do i=1,Natom
               Coord(j,i)=Coord(j,i)/b2ang
            End do
         End do
         If (Wrt_extrnl) Then
             Open(IUnitO,File='Geom.rate',Status='Unknown')
             Do i=1,Natom
                Do j=2,5
                   jchar=ichar(AtmLabel(i)(j:j))
                   If (jchar .GE. 65 .AND. jchar .LE. 90) then
                       AtmLabel(i)(j:j)=char(jchar+32)
                   End if
                End do
                If (AtmLabel(i)(1:5) .NE. 'X    ') then
                    ierr = 0
                    Do while (ierr .eq. 0) 
                       Read(IUnitO,7000, iostat=ierr) Temp_buff
                    Enddo
                    Write(IUnitO,7000) AtmLabel(i),(Coord(j,i),j=1,3),
     &                                 AtmMass(i)
                End if
             End do
             Write(IUnitO,"") 
         Endif
         Close(IUnitO)
C
      End if
 7000 Format(5X,A5,F15.10,2F18.10,F18.10)
C
C---------------------------------------------------------------------
C
C     Read total energy and degeneracy
C---------------------------------------------------------------------
C
      If (flgACESElec) then
C
C        Read the number of electrons and estimate degeneracy
C        -------------------------------------------------------------
         Call Getrec(20,'JOBARC','OCCUPYA0',NIrRep,NOcc(1)) 
         Nalph=0
         If (iUHF .EQ. 0) then
            Do i=1,NIrRep
               Nalph=Nalph+NOcc(i)
            End do
            Ntotal=Nalph*2
            Mult=1
            Nbeta = Nalph 
            call icopy(8, nocc(1), 1, nocc(9), 1)
         Else if (iUHF .EQ. 1) then
            Call Getrec(20,'JOBARC','OCCUPYB0',NIrRep,NOcc(9))
            Nbeta=0
            Do i=1,NIrRep
               Nalph=Nalph+NOcc(i)
               Nbeta=Nbeta+NOcc(i+8)
            End do
            Ntotal=Nalph+Nbeta
            Mult=(Nalph-Nbeta)+1
         End if
C
C        Calculate degeneracy in the atomic case
C        -------------------------------------------------------------
C
*        --- print out ---





C        Read total energy
C        -------------------------------------------------------------
         CALL Getrec(20,'JOBARC','TOTENERG',IINTFP,Etot)
         If (Wrt_extrnl) Then
            Open(IUnitO,File='Elec.rate',Status='Unknown')
            ierr = 0
            Do while (ierr .eq. 0)
                Read(IUnitO,7000, iostat=ierr) Temp_buff
            Enddo
            Write(IUnitO,6000) Mult,Etot
            Write(IUnitO, "")
            Close(IUnitO)
         Endif
C
      End if
 6000 Format(I3,F20.10)
C
C---------------------------------------------------------------------
C
C     Read gradient
C---------------------------------------------------------------------
C
      If (flgACESGrad) then
C
C   --- IMAP transforms from VMol order to ZMAT order
C
         Call Getrec(20,'JOBARC','GRADIENT',3*Nreal*IINTFP,
     &               VGrad(1,1))
         Do i=1,Nreal
            k=Imap(i)
            Do j=1,3
               Grad(j,k)=VGrad(j,i)
            End do
         End do
         If (Wrt_extrnl) Then
            Open(IUnitO,File='Grad.rate',Status='Unknown')
            ierr = 0
            Do while (ierr .eq. 0)
               Read(IUnitO,7000, iostat=ierr) Temp_buff
            Enddo
            Do i=1,nreal
               Write(IUnitO,5000) (Grad(j,i),j=1,3)
            End do
            Write(IUnitO,"")
            Close(IUnitO)
         Endif
C
      End if
 5000 Format(7X,3F18.10)
C
C---------------------------------------------------------------------
C
C     Read Hessian
C---------------------------------------------------------------------
C
      If (flgACESHess) then
C
         Call Getrec(20,'JOBARC','CART_HES',9*Natom*Natom*IINTFP,
     &               VHess)
         Call output(Vhess,1,3*natom,1,3*natom,3*natom,3*natom,1)

c
c-----Transform to the ZMAT order

         Ioff = 1
         Do Ivmol = 1, Natom
            Iatmzmat = Imap(Ivmol)
            Do Ixyz = 1, 3
               Icol = Ixyz + (Iatmzmat - 1)*3
               Do Jvmol = 1, Natom
                  Jatmzmat = Imap(Jvmol)
                  Irow = 1 + (Jatmzmat - 1)*3
                  Call Blkcpy(Vhess(ioff), 3, 1, Hess, 3*Natom,
     &                        3*Natom, Irow, Icol)
                  Ioff = Ioff + 3
               Enddo
            Enddo
         Enddo
C
C-----Eleminate the entry for dummy atoms
C
         Ix = 0
         Jx = 1
         Do Iatm = 1, 3*Natom
            Do Jatm = 1, 3*Natom
               Ink = 1 + (Iatm - 0.1)*3
               Jnk = 1 + (Jatm - 0.1)*3
               If ((AtmLabel(Ink)(1:5) .NE. 'X    ') .AND.
     &            ( AtmLabel(Jnk)(1:5) .NE. 'X    ')) Then
                   Ix = Ix + 1
                   Hess(Ix, Jx) = Hess(Iatm, Jatm)
                   If (Ix .EQ. 3*Natom) Ix = 0
                   If (Ix .EQ. 0) Jx = Jx + 1
               Endif
           Enddo
         Enddo 
C
         Call output(hess,1,3*natom,1,3*natom,3*natom,3*natom,1)
C
         If (Wrt_extrnl) Then
            Open(IUnitO,File='Hess.rate',Status='Unknown')
C
            ierr = 0
            Do while (ierr .eq. 0)
               Read(IUnitO,7000, iostat=ierr) Temp_buff
            Enddo
C
            Ioff = 0
            Joff = 0
            Do Iatm = 1, Nreal
                  Ioff = Ioff + (Iatm - 1)*3
                  Do Jatm = 1, Iatm
                     Joff = Joff + (Jatm - 1)*3
                     Write(IUnitO,4100) ((Hess(Ioff, Joff), 
     &                                    Ioff = 1, 3), Joff=1,3)
                  Enddo
            Enddo
            Write(IUnitO, "")
            Close(IUnitO)
         Endif
C
      Endif
C
 4100 Format(7X, 3D20.10)
C
      If (FlgACESForc) Call Getrec(20, "JOBARC", 'FORCECON', 
     &                             3*Natom*IINTFP, VOmega)
C
      Ivib = 0
      Do Imode = 1, 3*Natom
C
         If (Vomega(Imode) .lt. 0.0D0) Then
            Vomega(Imode) = - DSQRT(DABS(Vomega(Imode)))*Au2Invcm
         Else
            Vomega(Imode) = DSQRT(Vomega(Imode))*Au2Invcm
         Endif
C
         If (DABS(Vomega(Imode)) .GT. 1.0D0) Then
            Ivib = Ivib + 1
            Omega(Ivib) = Vomega(Imode)
         Endif
C
      Enddo
C

      Write(6,*) "The vibrational Frequencies"
      Write(*,"(4(2X,F10.4))") (Omega(I), I = 1, Nvibs)

C
      Open(IUnitO,File='Freq.rate',Status='Unknown')
      ierr = 0
      Do while (ierr .eq. 0)
         Read(IUnitO,7000, iostat=ierr) Temp_buff
      Enddo
C
      Write(IUnitO,"(4(2X,F18.8))") (Omega(I), I = 1, Nvibs)
      Write(IUnitO, "")
      Close(IUnitO)
C
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine diis_setup(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Establishes the lower triangular array elements for a DIIS calculation.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'saved_data.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer handle, ind
      integer row, col

      integer diis_counter, bhandle
      double precision b_array

      common /diis/b_array(10,10),
     *               diis_counter,bhandle(10)

      save row, col

      if (first_diis_setup) then
         diis_counter = 0
         first_diis_setup = .false.
         row = 1
         col = 1
      endif
      
c-------------------------------------------------------------------------
c   Put the array index in the appropriate slot.
c-------------------------------------------------------------------------

      diis_counter = diis_counter + 1
      if (diis_counter .gt. 55) diis_counter = 1

      handle = op(c_result_array)

c--------------------------------------------------------------------------
c   Make sure the array_type is scalar.
c--------------------------------------------------------------------------

      if (array_table(c_array_type,handle) .ne. scalar_value) then
         print *,'DIIS_SETUP at line ',current_line,': argument should',
     *     ' be declared scalar.'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Save the scalar value in the common block.
c---------------------------------------------------------------------------

      ind    = array_table(c_scalar_index, handle)
      b_array(row, col) = scalar_table(ind)

c---------------------------------------------------------------------------
c   Save handle of diagonal elements for storing results.
c---------------------------------------------------------------------------

      if (row .eq. col) bhandle(row) = handle

c---------------------------------------------------------------------------
c   Adjust row and col for next call.
c---------------------------------------------------------------------------

      col = col + 1
      if (col .gt. 10) then
         row = row + 1
         col = row
      endif

      if (row .gt. 10) then
         row = 1
         col = 1
      endif

      return
      end

c This routine reads an real value.  If it isn't in the namelist,
c it defaults to the value passed in.
c
c Variables which have default values may safely be passed in both
c as the default value and as the value read in.

      subroutine nl_real(key,def,var)
      implicit none

      character*(*) key
      double precision def,var

#include "namelist.com"
#include "callstack.com"

      character*(nllinelen) val
      logical nl_key,present
      integer err

      callstack_prev=callstack_curr
      callstack_curr='NL_REAL'

      var=def

      val=' '
      present=nl_key(key,val)
      if (present) then
         call str2dbl(val,var,err)
         if (err.ne.0) then
            write(*,*) '@NL_REAL: invalid real for ',key
            call errex
         end if
      end if

      if (prt_nl) then
         if (var.eq.def) then
            write(*,900) key,'real',var
  900       format(a20,2x,a10,2x,f20.8)
         else
            write(*,910) key,'real',var,def
  910       format(a20,2x,a10,2x,f20.8,2x,f20.8)
         end if
      end if

      callstack_curr=callstack_prev
      return
c     end subroutine nl_real
      end

      SUBROUTINE A2_PREP4_MOL_READ(ICORE, MAXCOR, NATOMS, NBASP, 
     &                             NBAS, IUCATMS, IUATMS, COORD, 
     &                             IATMCHRG, Norbits_fullG, 
     &                             Norbits_compG,MAXSHELL, MAXANG,
     &                             ITFCT, NUNQSHL, NTOTSHL, NTANGM, 
     &                             LNP1, INext)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      DIMENSION COORD(3*NATOMS), Norbits_fullG(IUATMS), 
     &          Norbits_compG(IUCATMS), ICORE(MAXCOR), 
     &          IATMCHRG(NATOMS),ISHL(6)
C     
#include "flags.h"
#include "machsp.com"
#include "jodaflags.com"
#include "syminf.com"
#include "offsets_2getden.com"
    
      DATA IONE /1/
#ifdef _DEBUG_LVLM2
      print*, "input variables@ prep4_dens_plots"
      print*, NATOMS, IUCATMS, IUATMS,  MAXSHELL
      Write(*,*)
#endif
      IMEMBC       = IONE 
      INUC         = IMEMBC       + NATOMS
      NUFCT        = INUC         + NATOMS
      NUMOM        = NUFCT        + IUCATMS 
      NFCT         = NUMOM        + IUCATMS 
      NANGMOM      = NFCT         + NATOMS
      IATMNAM      = NANGMOM      + NATOMS
      NAOUATM      = IATMNAM      + IUCATMS*IINTFP
      NAOATM       = NAOUATM      + IUCATMS 
      IANGMOMSHL   = NAOATM       + NATOMS
      ICONFUNSHL   = IANGMOMSHL   + MAXSHELL*IUCATMS
      IPRMFUNSHL   = ICONFUNSHL   + MAXSHELL*IUCATMS
      INPRIMSHL    = IPRMFUNSHL   + MAXSHELL*IUCATMS
      IANGMOMTSHL  = INPRIMSHL    + NATOMS 
      ICONFUNTSHL  = IANGMOMTSHL  + NATOMS*MAXSHELL
      IOFFSETPRM   = ICONFUNTSHL  + NATOMS*MAXSHELL
      IOFFSETCON   = IOFFSETPRM   + IUCATMS*MAXSHELL
      IOFFSETSHL   = IOFFSETCON   + IUCATMS*MAXSHELL
      IMAP_SHL2CNT = IOFFSETSHL   + NATOMS*MAXSHELL
      IPRMFUNTSHL  = IMAP_SHL2CNT + NATOMS*MAXSHELL 
      ISHLOFF_TMP  = IPRMFUNTSHL  + NATOMS*MAXSHELL  
      ISHLOFF      = ISHLOFF_TMP  + NATOMS
      IREORD       = ISHLOFF      + NATOMS
      IEND1        = IREORD       + NBAS
C    
      IF (IEND1 .GE. MAXCOR) CALL INSMEM('P4_DEN_PLOTS', IEND1,
     &                                    MAXCOR)
C
      CALL GETREC(20,'JOBARC', 'COMPMEMB', NATOMS, ICORE(IMEMBC))
      IPRINT = iflags(h_IFLAGS_print)
C     
#ifdef _DEBUG_LVL0
      print*, "Entering A2RD_BASIS_4INTGRT: Orbits and Cart. Coord."
      Write(6,"(4I4)"), (Norbits_compG(i), i=1, iucatms)
      Write(*,*)
      Write(6, "(3F10.5)"), (coord(i), i=1,3*natoms)
      Write(*,*)
#endif
      CALL A2RD_BASIS_4INTGRT(IUCATMS,NATOMS,ITFCT,LNP1,LNPO,NTANGM,
     &                        ICORE(IMEMBC),ICORE(INUC),ICORE(NFCT),
     &                        ICORE(NUFCT),ICORE(NANGMOM), 
     &                        ICORE(NUMOM),ICORE(IATMNAM),
     &                        COORD,Norbits_compG,
     &                        ICORE(NAOATM),ICORE(NAOUATM),
     &                        ICORE(IANGMOMSHL),ICORE(ICONFUNSHL),
     &                        ICORE(IPRMFUNSHL),IPRINT,ISHL, 
     &                        ICORE(INPRIMSHL),ICORE(IANGMOMTSHL),
     &                        ICORE(ICONFUNTSHL),ICORE(IOFFSETPRM),
     &                        ICORE(IOFFSETCON),ICORE(IOFFSETSHL),
     &                        ICORE(ISHLOFF_TMP),ICORE(ISHLOFF),
     &                        ICORE(IREORD),MAXSHELL,NUNQSHL,
     &                        NTOTSHL,IATMCHRG,NBAS)
C
      NMOMFCT  = IEND1 
      NMOMAO   = NMOMFCT  + NATOMS*NTANGM 
      IALPHA   = NMOMAO   + NATOMS*NTANGM 
      ICOEFFA  = IALPHA   + ITFCT*IINTFP
      ICOEFFB  = ICOEFFA  + NBASP*NBAS*IINTFP
      IDENSA   = ICOEFFB  + NBASP*NBAS*IINTFP
      IDENSB   = IDENSA   + NBAS*NBAS*IINTFP
      IPCOEFFA = IDENSB   + NBAS*NBAS*IINTFP
      IPCOEFFB = IPCOEFFA + NBASP*ITFCT*IINTFP
      IPCOEFF  = IPCOEFFB + NBASP*ITFCT*IINTFP
      ISCR1    = IPCOEFF  + ITFCT*IINTFP*NBAS
      ISCR2    = ISCR1    + LNP1*IINTFP
      ISTOP    = ISCR2    + LNPO*IINTFP
      INEXT    = ISCR1
C     
      IF(ISTOP.GE.MAXCOR) CALL INSMEM('P4_DEN_PLOTS',ISTOP,MAXCOR)
#ifdef _DEBUG_LVL0
      Write(*,*)
      print*, "Entering A2RD_BASIS_PRIMINF", ITFCT, NTANGM, IALPHA,
     &          LNP1,NUNQSHL

#endif
C
#ifdef _DEBUG_LVLM2
      Print*, "Offsets for various arrays initilized in Pre4_Den_plo."
      Write(*, '(31I9)'), IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                   IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                   ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                   IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                   IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                   IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                   ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                   IPCOEFFB, IPCOEFF,ISCR1,ISCR2
#endif
      CALL A2RD_BASIS_PRIMINF(NATOMS,IUCATMS,ITFCT,NBAS,LNP1,LNPO,
     &                        NTANGM,Norbits_compG,ICORE(NFCT),
     &                        ICORE(NANGMOM),ICORE(NMOMFCT),
     &                        ICORE(NMOMAO),ICORE(IMEMBC),
     &                        ICORE(IANGMOMSHL),ICORE(IPRMFUNSHL),
     &                        ICORE(ICONFUNSHL),ICORE(ICONFUNTSHL), 
     &                        ICORE(INPRIMSHL),ICORE(IMAP_SHL2CNT),
     &                        ICORE(IPRMFUNTSHL),ICORE(IALPHA),
     &                        ICORE(IPCOEFF),ICORE(NAOATM),
     &                        ICORE(ISCR1),ICORE(ISCR2),
     &                        ICORE(ISHLOFF),MAXSHELL,ISHL,MAXANG)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The number of contracted function per shell"
      Write(6,"(4I4)") (ICORE(ICONFUNTSHL - 1 + I), I=1, NTOTSHL)
      Write(6,*) "The shell angular momentum"
      Write(6,"(4I5)") (ICORE(IANGMOMTSHL - 1 + I), I=1, NTOTSHL)
      Write(6,*) "The number of primitive functions per shell"
      Write(6,"(4I5)") (ICORE(IPRMFUNTSHL - 1 + I), I=1, NTOTSHL)
#endif
#ifdef _DEBUG_LVL0
      Print*, "Offsets for various arrays initilized in Pre4_Den_plo."
      Write(*, '(31I9)'), IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                   IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                   ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                   IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                   IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                   IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                   ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                   IPCOEFFB, IPCOEFF,ISCR1,ISCR2
      Print*, "The exponents"
      Call output(icore(ialpha), 1, nfct, 1, 1, 1, nfct, 1, 1, 1)
      Call output(icore(ipcoeff), 1, nfct, 1, nbasp, nfct, nbasp, 1)
      Write(*,*)
      print*, "Exit Prep4_density_plots"
      Write(*,*)
#endif
C     
      RETURN
      END

      subroutine A2get_gridnmlist(GRID_FILE, NMBROF_GRIDPTS)
C
      implicit double precision (a-h,o-z)
      character*80 wrk
      Character*12 GRID_FILE
      
      OPEN(UNIT=4,FILE='ZMAT',FORM='FORMATTED',STATUS='OLD')
      REWIND(4)
C
300   READ(4,'(A)', END=900) WRK
      IF (WRK(1:9) .NE.'*PES_GRID') goto 300
C
C Obtain the number grid points
C
      READ(4,*,END=900) NMBROF_GRIDPTS
C
C The name of the file that the GRID is stored (maximum of 10 
C charaters.

      READ(4,'(A)', END=900) WRK
      GRID_FILE = WRK(1:12)
C







C
      GO TO 99
900   WRITE(6,901)
c
901   FORMAT(T3,'@A2get_gridnmlist, *PES_GRID namelist not found or', 
     &       ' incomplete.')
      GO TO 999 
 999  CONTINUE
C
      CLOSE(UNIT=4,STATUS='KEEP')
      CALL ERREX
C
  99  CONTINUE
      CLOSE(UNIT=4,STATUS='KEEP')
      
      RETURN
      END

#include "flags.h"
      SUBROUTINE A2MAKE_WFN(DENSA, DENSB, NATORBA, NATORBB, EVECA,
     &                      EVECB, EIGVALA, EIGVALB, SCR1, SCR2,
     &                      OCCA, OCCB, NOCCA, NOCCB, MAXOCCA,
     &                      MAXOCCB, NAOBFNS, NBAS, IUHF, TENERGY)

      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
#include "machsp.com"
#include "symm2.com"
#include "jodaflags.com"
C
      DOUBLE PRECISION NATORBA, NATORBB, OCCA(NBAS), OCCB(NBAS)
      LOGICAL SCF, COR
      DIMENSION DENSA(NBAS*NBAS), DENSB(NBAS*NBAS), NOCC(16),
     &          NATORBA(NAOBFNS, NAOBFNS), NATORBB(NAOBFNS, NAOBFNS),
     &          EVECA(NBAS, NBAS), EVECB(NBAS, NBAS),
     &          EIGVALA(NBAS), EIGVALB(NBAS), 
     &          SCR1(NBAS*NBAS), SCR2(NBAS*NBAS)
C
      DATA ZILCH, ONE, HALF/ 0.0D0, 1.0D0, 0.50D0/
C
      SCF = (iflags(h_IFLAGS_calc) .eq.0)
      COR = (iflags(h_IFLAGS_calc) .gt.0)
C
      
      IF (SCF) THEN

         CALL GETREC(20,'JOBARC','SCFEVCA0',NBAS*NBAS*IINTFP, EVECA)
         CALL GETREC(20,'JOBARC','SCFEVLA0',NBAS*IINTFP, EVALA)
         DO IOCC = 1, NOCCA
            OCCA(IOCC) = 2.0D0
         ENDDO
         MAXOCCA = NOCCA
C
         CALL GETREC(20, "JOBARC", "KINETINT", NBAS*NBAS*IINTFP, SCR1)
         CALL GETREC(20, "JOBARC", "SCFDENSA", NBAS*NBAS*IINTFP, SCR2)
         TENERGYA = DDOT(NBAS*NBAS, SCR1, 1, SCR2, 1)
C
         IF (IUHF .EQ. 1) THEN
            CALL GETREC(20,'JOBARC','SCFEVCB0',NBAS*NBAS*IINTFP,
     &                  EVECB)
            CALL GETREC(20,'JOBARC','SCFEVLB0',NBAS*IINTFP, EVALB)
            Do IOCC = 1, NOCCA
               OCCA(IOCC) = 1.0D0
            Enddo
            Do IOCC = 1, NOCCB
                OCCB(IOCC) = 1.0D0
            ENDDO
            MAXOCCB = NOCCB
C
         CALL GETREC(20, "JOBARC", "SCFDENSB", NBAS*NBAS*IINTFP, SCR2)
         TENERGYB = DDOT(NBAS*NBAS, SCR1, 1, SCR2, 1)
C
         ENDIF
         TENERGY = TENERGYA + TENERGYB
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,F10.5)") "The total kinetic energy = ", TENERGY
#endif 
C
      ELSE IF (COR) THEN
C
         CALL GETREC(20,'JOBARC','RELDENSA',NBAS*NBAS*IINTFP,DENSA)
         CALL DCOPY(NBAS*NBAS, DENSA, 1, SCR2, 1)
         CALL MO2AO3(SCR2, DENSA, EVECA, SCR1, NBAS, NBAS, 1, 2)
         CALL GETREC(20, "JOBARC", "KINETINT", NBAS*NBAS*IINTFP, SCR1)
         TENERGYA = DDOT(NBAS*NBAS, DENSA, 1, SCR1, 1)
C
         CALL GETREC(20,'JOBARC','RELDENSA',NBAS*NBAS*IINTFP,DENSA)
C
#ifdef _DEBUG_LVLM1
      Write(6,*) "The Alpha Density read"
      call output(DENSA, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
#endif
C
         CALL EIG(DENSA, SCR1, 1, NBAS, -1)
C
#ifdef _DEBUG_LVLM1
      Write(6,*) "The Alpha Natural orbitals MOxMO"
      call output(SCR1, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
#endif
         CALL DCOPY(NBAS, DENSA, NBAS+1, OCCA, 1)
         CALL DZERO(EVALA, NBAS)
         MAXOCCA = NBAS
         CALL GETREC(20,'JOBARC','SCFEVECA',NBAS*NBAS*IINTFP,DENSA)
         CALL XGEMM('N','N',NBAS,NBAS,NBAS,ONE,DENSA,NBAS,SCR1, 
     &               NBAS,ZILCH,EVECA,NBAS)
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The Alpha Natural orbitals AOxMO"
      call output(EVECA, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
#endif
C
        IF (IUHF.EQ.1) THEN
           CALL GETREC(20,'JOBARC','RELDENSB',NBAS*NBAS*IINTFP,DENSB)
           CALL DCOPY(NBAS*NBAS, DENSB, 1, SCR2, 1)
           CALL MO2AO3(SCR2, DENSB, EVECA, SCR1, NBAS, NBAS, 2, 2)
           CALL GETREC(20, "JOBARC", "KINETINT", NBAS*NBAS*IINTFP, SCR1)
           TENERGYB = DDOT(NBAS*NBAS, DENSB, 1, SCR1, 1)
C
           CALL GETREC(20,'JOBARC','RELDENSB',NBAS*NBAS*IINTFP,DENSB)
C
#ifdef _DEBUG_LVL0
       Write(6,*) "The Beta Density read"
       call output(DENSB, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
#endif
           CALL EIG(DENSB, SCR1, 1, NBAS, -1)
           CALL DCOPY(NBAS, DENSB, NBAS+1, OCCB, 1)
           CALL DZERO(EVALB, NBAS)
           MAXOCCB = NBAS
           CALL GETREC(20,'JOBARC','SCFEVECB',NBAS*NBAS*IINTFP,DENSB)
           CALL XGEMM('N','N',NBAS,NBAS,NBAS,ONE,DENSB,NBAS,SCR1,
     &                 NBAS,ZILCH,EVECB,NBAS)
#ifdef _DEBUG_LVL0
      Write(6,*) "The Beta Natural orbitals AOxMO"
      call output(EVECB, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
#endif
        ENDIF
        TENERGY = TENERGYA + TENERGYB

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,F10.5)") "The total kinetic energy = ", TENERGY
#endif 
C
      ENDIF
C
      CALL GETREC(20,'JOBARC','CMP2ZMAT', NBAS*NAOBFNS*IINTFP, SCR1)
      CALl XGEMM('N','N', NAOBFNS, NBAS, NBAS, ONE, SCR1, NAOBFNS, 
     &            EVECA, NBAS, ZILCH, NATORBA, NAOBFNS)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The Alpha Natural orbitals NAOBFNSxNMO"
      call output(NATORBA, 1, NAOBFNS, 1, NBAS, NAOBFNS,  NBAS, 1)
#endif
C
      IF (IUHF .EQ. 1) THEN
         CALL XGEMM('N','N', NAOBFNS, NBAS, NBAS, ONE, SCR1, NAOBFNS,
     &               EVECB, NBAS, ZILCH, NATORBB, NAOBFNS)
      ENDIF
  
      RETURN
      END

c This routine carves up the kscore(i0) space for using setptr/relptr.
c It's clumsy, but you must communicate with this routine through
c kscore.com by setting ineeded, dneeded, maxicore, etc.

c For dummy runs (when memknown=0), iSize sets maxmem.

c INPUT:
c int iHeap : the first integer in a heap (i.e. icore(i0) in ACES lingo)
c int iSize : the number of INTEGERS in the heap

      subroutine ks_mem_init(iHeap,iSize)
      implicit none

#include "f_types.h"
#include "aces.h"
#include "machsp.com"
#include "kscore.com"
#include "sb_mem.com"

      integer iHeap(*), iSize
      F_ADR c_adr, zheap, ztmp
      external c_adr

      call callstack_push('SB_MEM_INIT')
#ifdef _ASSERT
      if (iSize.le.0) then
         print *, '@KS_MEM_INIT: Assertion failed.'
         print *, '              iSize = ',iSize
         call errex
      end if
#endif
      if (memknown.ne.0) then

         if (dynmem.eq.1) then
            maxmem=iSize
            if (memknown.eq.-1) then
               ineeded=maxicore
               dneeded=(maxmem-maxicore)/iintfp
            end if
            zheap = c_adr(iHeap)
c i0 is the kscore index that addresses iHeap
#ifdef _PTRS_ARE_WORDS
            ztmp = (zheap-c_adr(kscore(1)))
#else
C
c shift zheap up to a 64-bit boundary
            zheap = ifltln * ((zheap+ifltln-1)/ifltln)
            ztmp = (zheap-c_adr(kscore(1)))/iintln
#endif /* _PTRS_ARE_WORDS */
            i0 = 1 + ztmp
            if (i0.ne.1+ztmp) then
               print *, '@KS_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

c i1 is the first kscore index that cannot be used (after the "icore" heap)
c (Yau: shift this up to 64-bit boundary)
            ztmp = ztmp + ineeded + iand(ineeded,iintfp-1)
            i1 = 1 + ztmp
            if (i1.ne.1+ztmp) then
               print *, '@KS_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

c repeat the process for dcore
            zheap = c_adr(kscore(i1))
c d0 is the dcore index that addresses zheap
#ifdef _PTRS_ARE_WORDS
            ztmp = (zheap-c_adr(dcore(1)))
#else
            ztmp = (zheap-c_adr(dcore(1)))/ifltln
#endif /* _PTRS_ARE_WORDS */
            d0 = 1 + ztmp
            if (d0.ne.1+ztmp) then
               print *, '@KS_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

c d1 is the first dcore index that cannot be used (after the "dcore" heap)
            ztmp = ztmp + dneeded
            d1 = 1 + ztmp
            if (d1.ne.1+ztmp) then
               print *, '@KS_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

         else
            maxmem=0
            maxicore=nondynimem
            ineeded=nondynimem
            dneeded=nondyndmem
            i0=1
            d0=1
            i1=nondynimem+1
            d1=nondyndmem+1
         end if
         iptr=i0
         dptr=d0

         call izero(kscore(i0),ineeded)
         call dzero(dcore(d0),dneeded)

      else ! dummy run

         if (dynmem.eq.1) then
            maxmem=iSize
            i1=maxicore+1
            d1=(maxmem-maxicore)/iintfp+1
         else
            maxmem=0
            maxicore=nondynimem
            i1=nondynimem+1
            d1=nondyndmem+1
         end if
         i0=1
         d0=1
         iptr=1
         dptr=1
         ineeded=0
         dneeded=0

      end if

      call callstack_pop
      return
      end

      SUBROUTINE CROSS(A,B,C,IX)
C
C CALCULATES THE (OPTIONALLY) NORMALIZED VECTOR CROSS PRODUCT C=A x B
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(3),B(3),C(3)
      C(3)=A(1)*B(2)-B(1)*A(2)
      C(2)=-A(1)*B(3)+A(3)*B(1)
      C(1)=A(2)*B(3)-A(3)*B(2)
C
C This block is added to avoid calling NORMAL when
C the vector is null. The null vector is reset to
C vector A. Ajith Perera, 10/2010
C
      D2 = 0.0D0
      Do I = 1, 3
         D2 = D2 + C(i)**2
      Enddo
      D2sqrt = Dsqrt(D2)
      If (D2sqrt .LT. 1.0D-14) Then
      Return
      Else
          IF(IX.EQ.1)CALL NORMAL(C,3)
      Endif
C
      RETURN
      END

      subroutine A2rd_geom(natoms,iatchrg,coord,ifuchrg,fucoord,
     &                         iunit,Write_molden_file)
c------------------------------------------------------------------------------
c read coordinates from jobarc 
c------------------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      parameter (nelement=103)
      parameter (btoang=0.52917724924D0)
      character*2 celemol(nelement)
      dimension iatchrg(natoms),ifuchrg(natoms)
      double precision coord(3,natoms), fucoord(3,natoms)
      logical Write_molden_file


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



      data (celemol(i),i=1,nelement)
     & /' H','He',
     & 'Li','Be',' B',' C',' N',' O',' F','Ne',
     & 'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     & ' K','Ca',
     & 'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     & 'Ga','Ge','As','Se','Br','Kr',
     & 'Rb','Sr',
     & ' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     & 'In','Sn','Sb','Te',' I','Xe',
     & 'Cs','Ba','La',
     & 'Ce','Pr','Nd','Pm','Sm','Eu','Gd',
     & 'Tb','Dy','Ho','Er','Tm','Yb','Lu',
     & 'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     & 'Tl','Pb','Bi','Po','At','Rn',
     & 'Fr','Ra','Ac',
     & 'Th','Pa',' U','Np','Pu','Am','Cm',
     & 'Bk','Cf','Es','Fm','Md','No','Lr'/
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      call izero(iatchrg,natoms)
      call zero(coord,3*natoms)
c
c read in the atomic charges and coordinates
c get rid of dummy atoms
c convert from bohr to angstrom
c
      call getrec(20,'JOBARC','ATOMCHRG',natoms,ifuchrg)
      call getrec(20,'JOBARC','COORD',3*natoms*iintfp,fucoord)
      i=1
      do j = 1, natoms
         if (ifuchrg(j).ne.0) then
c            call scopy(3,fucoord(1,j),1,coord(1,i),1)
            coord(1,i)=fucoord(1,j)
            coord(2,i)=fucoord(2,j)
            coord(3,i)=fucoord(3,j)
            iatchrg(i)=ifuchrg(j) 
            i=i+1
         end if
      end do 

      call getrec(20,'JOBARC','NREALATM',1,nrealatm)
      if(i.ne.nrealatm+1)then
        write(6,*)' Problem reading coordinates from JOBARC file'
        call errex
      endif

      natoms = nrealatm
      do i = 1, natoms
         coord(1,i)=coord(1,i)*btoang
         coord(2,i)=coord(2,i)*btoang
         coord(3,i)=coord(3,i)*btoang
      end do

      If (Write_molden_file) Then
         do i = 1, natoms
            write(iunit,'(A2,4X,i2,1X,i2,3X,f10.6,3X,f10.6,3X,f10.6)')
     &            celemol(iatchrg(i)),
     &            i,
     &            iatchrg(i),
     &            (coord(j,i),j=1,3)
           end do
      Endif
      call dscal(3*natoms,1.0D0/btoang,coord,1)
      return
      end

      SUBROUTINE A2EVAL_PRDCINT(IPRIM, JPRIM, INCRF, JNCRF, ITYPE, 
     &                          JTYPE, IPRMCOUNT, JPRMCOUNT,ICFCOUNT, 
     &                          JCFCOUNT, NTOTPRIM, NTOTCRF, MAXPRM, 
     &                          CNTMU, CNTNU, EXPS, PCOEF, CENTER, 
     &                          PRDTINT, TMP1, TMP2, TMP3)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DIMENSION CNTMU(3), CNTNU(3), EXPS(NTOTPRIM), 
     &          PRDTINT(NTOTCRF, NTOTCRF), PCOEF(NTOTPRIM, NTOTCRF),
     &          CENTER(3),TMP1(MAXPRM, MAXPRM),
     &          TMP2(MAXPRM, MAXPRM),TMP3(MAXPRM, MAXPRM),
     &          AAA(27), BBB(27), DISTN(3), LMN(27), JMN(27), 
     &          CNTP(3) 
C
CFAC(9, 9)
C
      COMMON /HIGHL/ LMNVAL(3, 84), ANORM(84)
      DATA   DZERO /0.0D+00/, ONE /1.00D0/
C
      IBTAND(I,J) = IAND(I,J)
      IBTOR(I,J)  = IOR(I,J)
      IBTXOR(I,J) = IEOR(I,J)
      IBTSHL(I,J) = ISHFT(I,J)
      IBTSHR(I,J) = ISHFT(I,-J)
      IBTNOT(I)   = NOT(I)
C
C Loop over number of conttracted functions
C
      ICFINDX = ICFCOUNT
CSSS      CALL ZERO(TMP1, MAXPRM*MAXPRM)
CSSS      CALL ZERO(TMP2, MAXPRM*MAXPRM)
C
      DO ICRF = 1, INCRF
C
         ICFINDX = ICFINDX + 1 
         JCFINDX = JCFCOUNT
C 
         DO JCRF = 1, JNCRF 
C
            JCFINDX = JCFINDX + 1 
C     
C Loop over primitive functions 
C
            IPRMINDX = IPRMCOUNT
            INDX = 0
            JNDX = 0

            DO LFTPRIM = 1, IPRIM
C
               IPRMINDX = IPRMINDX + 1 
               JPRMINDX = JPRMCOUNT
               JNDX = 0

               INDX = INDX + 1 
C                     
               DO RGTPRIM = 1, JPRIM
C                  
                  JPRMINDX = JPRMINDX + 1 
                  JNDX  = JNDX + 1 
C
                  TMP1(INDX, JNDX) = 0.D0
                  TMP2(INDX, JNDX) = 0.D0
C
C We can built the product here for generate correlation hole
C
                  CALL A2BULT_PRDUCT(INDX, JNDX, ITYPE, JTYPE, 
     &                               MAXPRM, EXPS(IPRMINDX), 
     &                               EXPS(JPRMINDX), CENTER,
     &                               CNTMU, CNTNU, TMP2)
C
C Loop over primitives end here!
C
               ENDDO
            ENDDO
C
CSSS            Write(6,*) "The repulsion integral"
CSSS            CALL OUTPUT(TMP1, 1, IPRIM, 1, JPRIM, IPRIM, JPRIM, 1)
            Write(6,*)
            Write(6,*) "The product integral:IPRIM,JPRIM", IPRIM, JPRIM
            CALL OUTPUT(TMP2, 1, IPRIM, 1, JPRIM, MAXPRM, MAXPRM, 1)
 
CSSS            Write(6,*) "CONTRACTION COEFICIENTS"
CSSS            CALL OUTPUT(PCOEF, 1, NTOTPRIM, 1, NTOTCRF, NTOTPRIM,
CSSS     &                  NTOTCRF, 1)
C 
C Built the contracted functions for this shell.
C
            IOFFC = IPRMCOUNT + 1
            JOFFC = JPRMCOUNT + 1
C
C Built the contracted product functions for this shell.
C
            CALL ZERO(TMP3, MAXPRM*MAXPRM)
            CALL XGEMM('N', 'N', IPRIM, 1, JPRIM, ONE, TMP2, MAXPRM, 
     &                  PCOEF(JOFFC, JCFINDX), NTOTPRIM, DZERO, TMP3,
     &                  MAXPRM)
            CALL XGEMM('T', 'N', 1, 1, IPRIM, ONE, 
     &                  PCOEF(IOFFC, ICFINDX), NTOTPRIM, TMP3, MAXPRM,
     &                  DZERO, PRDCT, 1)
C
C$$$            Write(6,*) 
C$$$            Write(6,*) "ICFINDX, JCFINDX =", ICFINDX, JCFINDX
C$$$            Write(6,*) "REPLC, REPLD =", REPLC, REPLD

            PRDTINT(ICFINDX, JCFINDX) = PRDCT            
C
C Loop over contracted functions end here!
C
         ENDDO
      ENDDO
C
      RETURN 
      END

      SUBROUTINE A2RD_BASIS_4INTGRT(IUATMS,NATOMS,ITFCT,LNP1,LNPO,
     &                              NTANGM,IMEMB,NUC,NFCT,NUFCT,
     &                              NANGMOM,NUMOM,ATMNAM,COORD,NPOP,
     &                              NAOATM,NAOUATM,NANGMOMSHL,
     &                              NCONFUNSHL,NPRIMFUNSHL,IPRINT,
     &                              ISHL,NMBERSHL,NANGMOMTSHL,
     &                              NCONFUNTSHL,NOFFSETPRM,
     &                              NOFFSETCON,NOFFSETSHL,ISHLOFF_TMP,
     &                              ISHLOFF,IREORD,MAXSHELL,NUNQSHL,
     &                              NTOTSHL,IATMCHRG,NAOBSFN)
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      CHARACTER*4 ATMNAM
      CHARACTER*80 XLINE
C     
      DIMENSION NUC(IUATMS),NUFCT(IUATMS),NUMOM(IUATMS),NFCT(NATOMS),
     &   NANGMOM(NATOMS),NPOP(IUATMS),NAOATM(NATOMS),NAOUATM(IUATMS),
     &   ATMNAM(IUATMS),COORD(3*NATOMS),IMEMB(NATOMS),ISHL(6), 
     &   NANGMOMSHL(IUATMS,MAXSHELL),NCONFUNSHL(IUATMS,MAXSHELL),
     &   NPRIMFUNSHL(IUATMS,MAXSHELL),NMBERSHL(NATOMS),
     &   NCONFUNTSHL(NATOMS*MAXSHELL),NANGMOMTSHL(NATOMS*MAXSHELL),
     &   NOFFSETPRM(IUATMS,MAXSHELL),NOFFSETCON(IUATMS,MAXSHELL),
     &   NOFFSETSHL(NATOMS*MAXSHELL),IATMCHRG(NATOMS),
     &   ISHLOFF_TMP(NATOMS),ISHLOFF(NATOMS), IREORD(NAOBSFN)
C     
      COMMON /IPAR/ LUOUT
C     
C     Determine the number of functions for each atom, NFCT(IATM), the 
C     largest number of primitives in a single shell, LNP1, the largest
C     number of primitive orbitals, (number of primitive functions 
C     times the number of atomic orbitals), in a single shell, LNPO, 
C     and the total number of primitive functions, ITFCT, for the 
C     molecule.  The number of AOs for each atom NAOATM
C     
C     Open MOL for basis set information.
      OPEN(UNIT=10,FILE='MOL',FORM='FORMATTED',STATUS='OLD')
      REWIND(10)
C     

C     Read the first five lines.
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
C     
      LNP1   = 0
      LNPO   = 0
      LTNP1  = 0
      LTNPO  = 0
      NTANGM = 0
      NDUM   = 0
      IATM   = 0
      LUOUT  = 6
C
      DO IATOMS = 1, NATOMS
         IF (IATMCHRG(IATOMS) .EQ. 0) THEN
             NDUM = NDUM + 1
         Else
             IATM = IATM + 1
             IMEMB(IATM) =  IMEMB(IATM) - NDUM
         ENDIF
      ENDDO

C
      DO 10 IATM=1,IUATMS
         READ(10,1110) ZNUC,IJUNK,NSHL,(ISHL(I),I=1,NSHL)
 1110    FORMAT(F20.1,8I5)
         READ(10,1115) ATMNAM(IATM),COORDX,COORDY,COORDZ
 1115    FORMAT(A4,3F20.12)
         NUFCT(IATM)=0
         NTANGMI=0
         NUNQSHL = 0
C     
         NAOTMP=0
         DO 20 I=1,NSHL
            NPT=0
            NAOT=0
            DO 21 I1=1,ISHL(I)
               READ(10,1120) NP1,NAO
C
               NPT=NPT+NP1
               NAOT=NAOT+NAO
C
CSSS               IF(I.EQ.1) NP2=1
CSSS               IF(I.EQ.2) NP2=3
CSSS               IF(I.EQ.3) NP2=6
CSSS               IF(I.EQ.4) NP2=10
CSSS               IF(I.EQ.5) NP2=15
C
               NP2 = I*(I + 1)/2
C
               NAOTMP=NAOTMP+NP2*NAO
               NUFCT(IATM)=NUFCT(IATM)+NP2*NP1
C
C This commented if statement is wrong from the start. Ajith 01/2000
C Now this code will work for when their are multiple shells for 
C given angular momentum.
C$$$               IF(I1.EQ.ISHL(I)) NTANGMI=NTANGMI+NP2
C
                  NTANGMI=NTANGMI+NP2
                  NUNQSHL = NUNQSHL + 1 
                  NANGMOMSHL(IATM, NUNQSHL)  = NP2
                  NPRIMFUNSHL(IATM, NUNQSHL) = NP1*NP2
                  NCONFUNSHL(IATM, NUNQSHL)  = NAO*NP2
C
               NLN=(NAO-3)/4
               IF((NAO-3).GT.(NLN*4))NLN=NLN+1
               NLN=(NLN+1)*NP1
               DO 30 J=1,NLN
                  READ(10,'(A)') XLINE
 30            CONTINUE
               IF(NPT.GT.LNP1)THEN
                  IF(NPT.GT.LTNP1) LTNP1=NPT
               ENDIF
               ITMP=NPT*NAOT
               IF(ITMP.GT.LNPO)THEN
                  IF(ITMP.GT.LTNPO) LTNPO=ITMP
               ENDIF
 21         CONTINUE
 20      CONTINUE
         IF(LTNP1.GT.LNP1) LNP1=LTNP1
         IF(LTNPO.GT.LNPO) LNPO=LTNPO
         NUMOM(IATM)=NTANGMI
         IF(NTANGMI.GT.NTANGM) NTANGM=NTANGMI
         NAOUATM(IATM)=NAOTMP
         NMBERSHL(IATM) = NUNQSHL
 10   CONTINUE
C     
      ITFCT=0
      DO 110 IATM=1,IUATMS
         DO 120 IEQATM=1,NPOP(IATM)
            ITFCT=ITFCT+NUFCT(IATM)
 120     CONTINUE
 110  CONTINUE
C     
C Fill out NFCT, NAOATM and NMOMFCT for all atoms.

      ICNT=0
      DO 1011 II=1,IUATMS
C
         DO 1020 IJ = 1,NPOP(II)
C
            ICNT=ICNT+1
            NFCT(IMEMB(ICNT))=NUFCT(II)
            NANGMOM(IMEMB(ICNT))=NUMOM(II)
            NAOATM(IMEMB(ICNT))=NAOUATM(II)
            NMBERSHL(IMEMB(ICNT)) = NMBERSHL(II)
C
 1020    CONTINUE
 1011 CONTINUE
         
#ifdef _DEBUG_LVL0
      Write(6,*) "The NANGMOM array"
      Write(6, "(8i4)") (NANGMOM(I), i=1, Natoms)
      Write(6,*) "The NFCT array"
      Write(6, "(8i4)") (NFCT(I), i=1, Natoms)
      Write(6,*) "The NAOATM array"
      Write(6, "(8i4)") (NAOATM(I), i=1, Natoms)
      Write(6,*) "The NPOP array"
      Write(6, "(8i4)") (NPOP(I), i=1, Natoms)
      Write(6,*) "The NMBERSHL array"
      Write(6, "(8i4)") (NMBERSHL(I), i=1, Natoms)
      Write(6,*) "The IMEMB array"
      Write(6, "(8i4)") (IMEMB(I), i=1, Natoms)
#endif
C     
C Built the NCONFUNSHL, NANGMOMSHL arrays for all atoms. Also 
C get the total number of shells for all the atoms. This data
C comes handy when we try to retrive the two particle density.
C Ajith Perera 01/2001.
C

      ISHLOFF_TMP(1) = 1
      DO IATMS = 2, NATOMS
         ISHLOFF_TMP(IATMS) =  ISHLOFF_TMP(IATMS-1) + 
     &                         NMBERSHL(IATMS-1)
      ENDDO
C
#ifdef _DEBUG_LVL0      
      Write(6,*) "The offset array"
      Write(6, "(8i4)") (ISHLOFF_TMP(I), i=1, Natoms)
#endif

      DO IATMS = 1, NATOMS
          ISHLOFF(IATMS) = ISHLOFF_TMP(IMEMB(IATMS))
      ENDDO

#ifdef _DEBUG_LVL0      
      Write(6,*) "The reordered offset array"
      Write(6, "(8i4)") (ISHLOFF(I), i=1, Natoms)
#endif
      NTOTSHL = 0
      ITOTATM = 0
C
      DO IATMS = 1, IUATMS
c
         DO IREDATMS = 1, NPOP(IATMS)
            ITOTATM = ITOTATM + 1
            IATMOFF = ISHLOFF(ITOTATM)

            DO IISHL = 1, NMBERSHL(IATMS)
               
               NTOTSHL = NTOTSHL + 1 

               NCONFUNTSHL(IATMOFF) = NCONFUNSHL(IATMS, IISHL)
               NANGMOMTSHL(IATMOFF) = NANGMOMSHL(IATMS, IISHL)
              
               IATMOFF  = IATMOFF + 1
            ENDDO
         ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The NCONFUNTSHL array @a2rd_basis_4intgrt"
      Write(6, "(8i4)") (NCONFUNTSHL(I), i=1, NTOTSHL)
      Write(6,*) "The NANGMOMTSHL array @a2rd_basis_4intgrt"
      Write(6, "(8i4)") (NANGMOMTSHL(I), i=1, NTOTSHL)
#endif
C Now, I don't know what this was trying to acomplish. Commentted on
C 
CSSS      ICOUNT = 0
CSSS      DO IATMS = 1, IUATMS
CSSS
CSSS         DO IREDATMS = 1, NPOP(IATMS)
CSSS
CSSS            ICOUNT = ICOUNT + 1
CSSS            NMBERSHL(ICOUNT) = NMBERSHL(IATMS)
CSSS         ENDDO
CSSS      ENDDO
#ifdef _DEBUG_LVL0
      Write(6,*) "The NMBERSHL array after expansion"
      Write(6, "(8i4)") (NMBERSHL(I), i=1, Natoms)
#endif
C
C Also bulit the offsets for primitives and contracted functions 
C on each symmetry unique atoms.
C
C$$$      CALL ICOPY(NUFCT, NUC, IUATMS)
      CALL ICOPY(IUATMS, NUFCT, 1, NUC, 1)
      NUFCT(1) = 0
      DO IATMS = 1, (IUATMS - 1)
         NUFCT(IATMS + 1) = NUC(IATMS) + NUFCT(IATMS)
      ENDDO
C
C$$$      CALL ICOPY(NAOUATM, NUC, IUATMS)
      CALL ICOPY(IUATMS, NAOUATM, 1, NUC, 1)  
      NAOUATM(1) = 0 
      DO IATMS = 1, (IUATMS - 1)
         NAOUATM(IATMS + 1) = NUC(IATMS) + NAOUATM(IATMS)
      ENDDO
C
      NOFFSETSHL(1) = 0
      DO KSHL = 1, NTOTSHL
         NOFFSETSHL(KSHL + 1) = NOFFSETSHL(KSHL) + NCONFUNTSHL(KSHL)
      ENDDO
C
C Read the atom charges back into the NUC array.
C
      CALL GETREC(20,'JOBARC','ATOMCHRG',NATOMS, NUC)
C     
     
      DO IATM = 1, IUATMS

         DO KSHL =1, NTOTSHL
C
            IF (IATM.EQ.1.AND.KSHL.EQ.1) THEN
C
               NOFFSETPRM(IATM,KSHL) = 0
               NOFFSETCON(IATM,KSHL) = 0
C
            ELSE IF (IATM .EQ. 1 .AND. KSHL .EQ. 2) THEN
C
               NOFFSETPRM(1, 2) = NPRIMFUNSHL(1, 1)
               NOFFSETCON(1, 2) = NCONFUNSHL(1, 1)
C
            ELSE IF (IATM .EQ. 2 .AND. KSHL .EQ. 1) THEN
C
               NOFFSETPRM(2, 1) = 0
               NOFFSETCON(2, 1) = 0 
C
            ELSE
C
               IF (KSHL .EQ. 1) THEN
                   NOFFSETPRM(IATM, KSHL) = 0
                   NOFFSETCON(IATM, KSHL) = 0
               ELSE

                   NOFFSETPRM(IATM,KSHL) = NOFFSETPRM(IATM, KSHL-1)
     &                                   + NPRIMFUNSHL(IATM, KSHL-1) 
 
                   NOFFSETCON(IATM,KSHL)= NOFFSETCON(IATM, KSHL-1)
     &                                  + NCONFUNSHL(IATM, KSHL-1) 
               ENDIF 
C
            ENDIF
         ENDDO
      ENDDO
C

      ISTART = 1
      KSHELL = 1
      DO IATMS = 1, IUATMS
         DO IANGMOM = 1, NMBERSHL(IATMS)
CSS            LANGMOM = IANGMOM*(IANGMOM+1)/2
            LANGMOM = NANGMOMTSHL(KSHELL)
            NAO =  NCONFUNTSHL(KSHELL)/LANGMOM
            IF (NAO .EQ. 0) GO TO 49
            KSHELL =  KSHELL  + 1
            ITO = ISTART
            DO IAO = 1, NAO
               IFROM =  ISTART + IAO - 1
               DO ISHELL = 1, LANGMOM
                  IREORD(ITO) = IFROM
                  IFROM = IFROM + NAO
                  ITO   = ITO + 1
                END DO
            END DO
            ISTART = ISTART  + NAO*LANGMOM
  49        CONTINUE
         END DO
      ENDDO 
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "The s,p,d,f.. functions ordering" 
      Write(6,"(a,I5)") "@-A2RD_BASIS_ The number of basis functions ",
     &                   NAOBSFN
      Write(6, "(6I4)") (IREORD(I), I =1, NAOBSFN)
#endif 
C
#ifdef _DEBUG_LVL0
C
         WRITE(LUOUT, *) "The debug info for two particle density"
         WRITE(LUOUT, *)  "Total No, shells, Angular momentum components,
     &   No. of contracted functions per shell"
C
         DO 130 IATM=1,IUATMS
            WRITE(LUOUT,1170) IATM,ATMNAM(IATM),NFCT(IATM),
     &         (COORD((IATM-1)*3+J),J=1,3)
         IMANY_SHEL =  NMBERSHL(IATM)
         WRITE(LUOUT, *) (NANGMOMSHL(IATM,I), I= 1, IMANY_SHEL)
         WRITE(LUOUT, *) (NCONFUNSHL(IATM,I), I= 1, IMANY_SHEL)
 130     CONTINUE
         WRITE(LUOUT,1130) NTANGM
         WRITE(LUOUT,1140) ITFCT
         WRITE(LUOUT,1150) LNP1
         WRITE(LUOUT,1160) LNPO
#endif
 1120 FORMAT(2I5)
 1130 FORMAT(/'THE LARGEST NUMBER OF SHELLS FOR ANY ATOM IS',I3)
 1140 FORMAT('THE MOLECULE HAS',I4,' TOTAL PRIMITIVE FUNCTIONS')
 1150 FORMAT('THE LARGEST NUMBER OF PRIMITIVES IN A SINGLE SHELL IS',I3)
 1160 FORMAT('THE LARGEST NUMBER OF PRIMITIVE ORBITALS IN A SINGLE
     &   SHELL IS',I3)
 1170 FORMAT(/'ATOM',I3,' IS ',A2,' WITH',I4,' PRIMITIVE FUNCTIONS'/
     &   '     ITS COORDINATES ARE ',3F15.5)
C     
      RETURN
      END

      SUBROUTINE BULT_DIHANGCRD(CARTCOORD, BMATRX, DANG, ICON1, 
     &                          ICON2, ICON3, ICON4, IDIHS, 
     &                          TOTREDNCO, NRATMS)
C
C Setup the dihedral angle B-matrix elements. 
C It is some what tedious to write down the elements of the B-matrix for
C torsion. Please refer to Wilson, Decius and Cross page 61, 
C Eqns. 21,22,23,24.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      DOUBLE PRECISION VECAB , VECBC , VECBA , DEGPI , VECCD
      INTEGER TOTREDNCO
      DIMENSION CARTCOORD(3*NRATMS), BMATRX(TOTREDNCO, 3*NRATMS),
     &  VECCB(3), VECAB(3), VECBC(3), VECCD(3), VECABC(3), VECBCD(3)
C
      DATA DEGPI /180.0D0/
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0
      PI = (ATAN(DFLOAT(1))*DFLOAT(4))
C
#ifdef _DEBUG_LVLM2
      WRITE(6,"(4I4)") icon1, icon2, icon3, icon4
#endif
      CALL VEC(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2), 
     &         VECAB, 1)
      CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2), 
     &         VECBC, 1)
      CALL VEC(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2), 
     &         VECCB, 1)
      CALL VEC(CARTCOORD(3*ICON4 - 2), CARTCOORD(3*ICON3 - 2), 
     &         VECCD, 1)
C
      DISTAB = DIST(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2))
      DISTBC = DIST(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2))
      DISTCD = DIST(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON4 - 2))
C
C First evaluate the dihedral angle. This is calculated as the 
C angle between the two unit vectors that are perpendicular to 
C the ABC and BCD planes for A-B-C-D pattern. 
C
      CALL CROSS(VECAB, VECBC, VECABC, 1)
C
C We need the vector CD, obtain that from vec DC (note the misnomar)
C
      CALL DSCAL(3, -1.0D0, VECCD, 1)
      CALL CROSS(VECBC, VECCD, VECBCD, 1)
      DANG   = (ANGLE(VECABC, VECBCD, 3))*DINVPI
C
C Retain the vector DC for continuation. 
C
      CALL DSCAL(3, -1.0D0, VECCD, 1)
C
C Now re-evalute the unnormalied vectors along the the perpendicular
C directions to the planes ABC and BCD. 
C
      CALL CROSS(VECAB, VECBC, VECABC, 0)
      CALL CROSS(VECCD, VECCB, VECBCD, 0)
C
      DANG1  = ANGLE(VECAB, VECCB, 3)*DINVPI
      DANG2  = ANGLE(VECBC, VECCD, 3)*DINVPI 
C
      SINABC = DSIN(DANG1)
      COSABC = DCOS(DANG1)
      SINBCD = DSIN(DANG2)
      COSBCD = DCOS(DANG2)
C
      DABC = DDOT(3, VECABC, 1, VECABC, 1)
      DBCD = DDOT(3, VECBCD, 1, VECBCD, 1)
C
C--- Obtainig the sign of the dihedral angle:
C
      SENSE = DDOT(3, VECAB, 1, VECBCD, 1)

      IF (SENSE .GT. 0.0D0) DANG = -DANG
C
#ifdef _DEBUG_LVLM2
      Print*, "The vectors making the dihedral angle"
      Print*,  (CARTCOORD(3*ICON1 - 2 + I), I=0, 2)
      Print*,  (CARTCOORD(3*ICON2 - 2 + I), I=0, 2)
      Print*,  (CARTCOORD(3*ICON3 - 2 + I), I=0, 2)
      Print*,  (CARTCOORD(3*ICON4 - 2 + I), I=0, 2)
      Print*, "The vec. BC: ", (VECBC(I), I=1, 3)
      Print*, "The vec. AB: ", (VECAB(I), I=1, 3)
      Print*, "The vec. CB: ", (VECCB(I), I=1, 3)
      Print*, "The vec. CD: ", (-VECCD(I), I=1, 3)
      Print*, "The vec. ABC:", (VECABC(I), I=1,3)
      Print*, "The vec. BCD:", (VECBCD(I), I=1,3)
      Write(6,"(a,F10.5)") "The dihedral angle", DANG/DINVPI
#endif
C
      IF (DABC .GT. 1.0D-16 .AND. DBCD .GT. 1.0D-16) THEN

      DO 10 IXYZ = 1, 3 
C
         BMATRX(IDIHS, (3*ICON1 - 3) + IXYZ) = 
     &                     -(VECABC(IXYZ)/(DISTAB*SINABC*SINABC))
                                            
         BMATRX(IDIHS, (3*ICON2 - 3) + IXYZ) = 
     &                  ((DISTBC - DISTAB*COSABC)*VECABC(IXYZ)/
     &                        (DISTAB*DISTBC*SINABC*SINABC)) + 
     &                            ((COSBCD*VECBCD(IXYZ))/
     &                            (DISTBC*SINBCD*SINBCD)) 
C
         BMATRX(IDIHS, (3*ICON3 - 3) + IXYZ) = 
     &                     ((DISTBC - DISTCD*COSBCD)*VECBCD(IXYZ)/
     &                         (DISTCD*DISTBC*SINBCD*SINBCD)) + 
     &                                 ((COSABC*VECABC(IXYZ))/
     &                                 (DISTBC*SINABC*SINABC)) 
C
         BMATRX(IDIHS, (3*ICON4 - 3) + IXYZ) = 
     &                     -(VECBCD(IXYZ)/(DISTCD*SINBCD*SINBCD))
         
 10   CONTINUE
      ENDIF 
C
      RETURN
      END


      

      SUBROUTINE A2EVAL_INTS(NTOTPRIM, NTOTCRF, IANGTYPE, 
     &                       XPOINT, YPOINT, ZPOINT, EXPS, PCOEF, 
     &                       PRDTINT, CNT_COORD, TMP1, TMP2, TMP3)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DIMENSION CNTMU(3), CNTNU(3), EXPS(NTOTPRIM), 
     &          PRDTINT(NTOTCRF, NTOTCRF), PCOEF(NTOTPRIM, NTOTCRF),
     &          CENTER(3),TMP1(NTOTPRIM*NTOTPRIM),
     &          TMP2(NTOTPRIM, NTOTPRIM),TMP3(NTOTPRIM*NTOTPRIM),
     &          IANGTYPE(NTOTPRIM), CNT_COORD(3, NTOTPRIM)
C
      COMMON /HIGHL/ LMNVAL(3, 84), ANORM(84)
      DATA   DZERO /0.0D+00/, ONE /1.00D0/
C
C Loop over number of primitive functions
C
      INDX = 0
C
      CENTER(1) = XPOINT
      CENTER(2) = YPOINT
      CENTER(3) = ZPOINT
C
      DO LFTPRIM = 1, NTOTPRIM
C
         INDX  = INDX + 1 
         ITYPE = IANGTYPE(INDX)
         DO IXYZ = 1, 3
            CNTMU(IXYZ) = CNT_COORD(IXYZ, INDX)
         ENDDO 
C                     
         JNDX = 0
         DO RGTPRIM = 1, LFTPRIM
C                  
            JNDX  = JNDX + 1 
            JTYPE = IANGTYPE(JNDX)
            DO IXYZ = 1, 3
               CNTNU(IXYZ) = CNT_COORD(IXYZ, JNDX)
            ENDDO 
C
C We can built the product here!
C
                  CALL A2BULT_PRDUCT(INDX, JNDX, ITYPE, JTYPE, 
     &                               NTOTPRIM, EXPS(INDX), 
     &                               EXPS(JNDX), CENTER,
     &                               CNTMU, CNTNU, TMP2)
C
C Loop over primitives end here!
C
         ENDDO
      ENDDO
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "The product integral in primitive basis"
      CALL OUTPUT(TMP2, 1, NTOTPRIM, 1, NTOTPRIM, NTOTPRIM, 
     &            NTOTPRIM, 1)
#endif
C
C Expand to a square matrix to convert to contracted basis
C
      DO LFTPRIM = 1, NTOTPRIM
         DO RGTPRIM = 1, NTOTPRIM
            TMP2(LFTPRIM, RGTPRIM) = TMP2(RGTPRIM, LFTPRIM)
         ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "The product integral in primitive basis"
      CALL OUTPUT(TMP2, 1, NTOTPRIM, 1, NTOTPRIM, NTOTPRIM, 
     &            NTOTPRIM, 1)
#endif
C
#ifdef _DEBUG_LVLM2
       Write(6,*)
       Write(6,*) "@-a2eval_ints CONTRACTION COEFICIENTS"
       CALL OUTPUT(PCOEF, 1, NTOTPRIM, 1, NTOTCRF, NTOTPRIM,
     IM                  NTOTCRF, 1)
#endif
C 
C Built the contracted product functions for this shell.
C
      CALL XGEMM('N', 'N', NTOTPRIM, NTOTCRF, NTOTPRIM, ONE, TMP2,
     &            NTOTPRIM, PCOEF, NTOTPRIM, DZERO, TMP3, NTOTPRIM)
C
      CALL XGEMM('T', 'N', NTOTCRF, NTOTCRF, NTOTPRIM, ONE, PCOEF, 
     &            NTOTPRIM, TMP3, NTOTPRIM, DZERO, PRDTINT, NTOTCRF)
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The product integral in contracted basis"
      CALL OUTPUT(PRDTINT, 1, NTOTCRF, 1, NTOTCRF, NTOTCRF, NTOTCRF, 1)
#endif
C
      RETURN 
      END

      Subroutine a2_reset_jarc()

      Implicit Double Precision (A-H, O-Z)
C

      Call Putrec(1,'JOBARC','HAVEGEOM', 1, 1)
      Call Getrec(0,'JOBARC','PASS1   ', Length, 1)
C
      Call aces_ja_truncate('JODAOUT ', 1)
      If (Length .gt. 0) Call Putrec(0,'JOBARC','PASS1   ', 1, 0)
C
      Call Putrec(1,'JOBARC','PES_SCAN', 1, 1)
C
      Call aces_ja_fin
      Call aces_ja_init
c
      Return 
      End

      SUBROUTINE SP2SY(N, A, LDA, UPLO, IERR)
C      
C     PURPOSE
C     
C     To expand a symmetric matrix stored in packed storage mode to
C     standard (quadratic) storage mode using the same work array.       
C
C     ARGUMENT LIST
C       ARGUMENTS IN
C
C          N - INTEGER.
C              The order of the matrix A.
C      
C          A - DOUBLE PRECISION array of DIMENSION at least LDA*N.
C              The first  N*(N+1)/2  elements of this array contain the
C              symmetric matrix A in (upper or lower) packed storage
C              mode.   
C              NOTE that this array is overwritten.
C
C        LDA - INTEGER.
C              The leading dimension of array A. After calling SP2SY, A 
C              is stored like an array declared  A(LDA,N) containing a
C              symmetric matrix in its leading N-by-N part.
C      
C     ARGUMENTS OUT
C    
C          A - DOUBLE PRECISION array of DIMENSION at least LDA*N.
C              This array contains the matrix A stored like an array
C              declared  A(LDA,N) containing a symmetric matrix in its 
C              leading N-by-N part.
C
C     MODE PARAMETERS
C
C       UPLO - CHARACTER*1.
C              Indicates whether on input, A is stored in packed lower
C              or packed upper storage mode, i.e. if the columns of the
C              lower or upper trinagle of the matrix A are stored
C              consecutively.
C              UPLO = 'U' or 'u' : Upper triangle is stored in A.
C              UPLO = 'L' or 'l' : Lower triangle is stored in A.
C              NOTE that if UPLO contains any other character, A is
C              treated as packed in lower symmetric storage mode.
C      
C     ERROR INDICATOR
C     
C       IERR - INTEGER. 
C              Unless the routine detects an error (see next section),
C              IERR contains 0 on exit.
C
C     WARNINGS AND ERRORS DETECTED BY THE ROUTINE
C
C      IERR = 1 : (N .LT. 1) or (LDA. LT. N).
C
C     METHOD
C
C     Let
C               ( A(1,1) ... A(1,N) )
C           A = (  ...        ...   ).
C               ( A(N,1) ... A(N,N) ) 
C
C     On input, A is stored in either upper or lower packed storage
C     mode as follows:
C     If UPLO = 'U' or 'u', then the columns of the upper triangle of A
C     are contained in A consecutively, i.e.      
C     
C       A = (A(1,1), A(1,2), A(2,2), A(1,3), ..., A(3,3), A(1,4), ...,
C            A(1,N), ..., A(N,N)).      
C
C     If UPLO = 'L' or 'l', then the columns of the lower triangle of A
C     are contained in A consecutively, i.e.      
C     
C       A = (A(1,1), A(2,1), ..., A(N,1), A(2,2), A(3,2), ..., A(N,2),
C            A(3,3), ..., A(N,N)).      
C   
C     On output, A contains the full symmetric matrix A, i.e. A may be
C     treated as a 2-dimensional array declared A(LDA,N) with the
C     leading N-by-N part containing the symmetric matrix A.
C      
C     REFERENCE
C                 
C     None.
C      
C     CONTRIBUTOR      
C
C     Peter Benner (Technische Universitaet Chemnitz-Zwickau, FRG)
C
C     REVISIONS
C
C     February 21, 1995.
C            
C***********************************************************************
C     
C     .. Scalar Arguments ..      
      INTEGER          IERR, LDA, N
      CHARACTER        UPLO
C     
C     .. Array Arguments ..
      DOUBLE PRECISION A(*)
C
C     .. Local Scalars ..
      INTEGER          I, SPPOS, SYPOS
C
C     .. External Subroutines ..
C     . BLAS, LAPACK .
      EXTERNAL         XCOPY
C     
C     .. Executable Statements ..
C
      IERR = 0
      IF ((N .LT. 1) .OR. (N .GT. LDA))  IERR = 1
      IF (IERR .NE. 0)  GOTO 2001
C      
      IF ((UPLO.EQ.'U').OR.(UPLO.EQ.'u')) THEN
        SPPOS = N*(N+1)/2 + 1
        SYPOS = N*LDA + 1
        DO 100  I = N, 2, -1
          SPPOS = SPPOS - I
          SYPOS = SYPOS - LDA
          CALL XCOPY(I, A(SPPOS), -1, A(SYPOS), -1)
100     CONTINUE       
        SYPOS = 1
        DO 150  I = N-1, 1, -1
          CALL XCOPY(I, A(SYPOS+LDA), LDA, A(SYPOS+1), 1)
          SYPOS = SYPOS + LDA + 1
150     CONTINUE
C       
      ELSE
        SPPOS  = N*(N+1)/2
        SYPOS  = (N-1)*LDA + N
        DO 200  I = 1, N - 1
          CALL XCOPY(I,   A(SPPOS),  -1, A(SYPOS),      -1)
          CALL XCOPY(I-1, A(SYPOS+1), 1, A(SYPOS+LDA), LDA)
          SPPOS = SPPOS - I - 1
          SYPOS = SYPOS - LDA - 1
200     CONTINUE
        CALL XCOPY(N-1, A(2), 1, A(LDA+1), LDA)
      END IF
C      
2001  CONTINUE
      RETURN
C *** Last Line of SP2SY      
      END
      

         

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine JFSOrd (NCen, NBF, BF2Cen, Map)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: jfsord.f,v 1.1.1.1 2003/04/02 19:21:47 aces Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     jfsord -- Make permutation from original order to the "jfs" order
C
C SYNOPSIS
      Integer NCen, NBF
      Integer BF2Cen(NBF), Map(NBF)
C
C ARGUMENTS
C     NCen    Number of centers (input)
C     NBF     Number of basis functions (input)
C     Bf2Cen  Mapping of basis functons to centers (input)
C     Map     Mapping from BF2Cen order to "jfs" order (output)
C
C DESCRIPTION
C     The "jfs" order has all functions on a given center grouped
C     together and the thing in order by center number.  Care is taken
C     to insure that individual basis functions stay in the same
C     relative order.
C
C     The "jfs" order normally implies that the center numbers on which
C     this arrangement is based are the ZMAT center numbers. This
C     routine takes no explicit account of that, but will give the
C     desired result if the Bf2Cen array contains the ZMAT center nrs.
C
C     The result of this routine is Map, which should be used as:
C     Original(i) --> Reordered( Map(i) ).  This is conceptually a
C     "scatter" operation when applied to a vector.
C
C BUGS
C     Does not check for out-of-range center numbers in BF2Cen.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
C     IOff    Offset into Map
C     I       counter over centers
C     J       counter over basis
C
      Integer IOff, I, J
C
      IOff = 1
C
C     Look for each center in sequence
C
      Do 100 I = 1, NCen
C
C        Look for every occurrance of this center and use Map to collect 
C        then together into a contiguous block.
C
         Do 110 J = 1, NBF
            If (BF2Cen(j) .eq. i) then
               Map(j) = IOff
               IOff = IOff + 1
            EndIf
 110     Continue
 100  Continue
      Return
      End

      SUBROUTINE ACES_FREE(FREWRD,IFIRST,IPOS)
      IMPLICIT INTEGER (A-Z)

      DOUBLE PRECISION TELAP

#include "machsp.com"

#ifdef _UNICOS
      IFRE=IPOS+LOC(IFIRST)-1
      ILEN=IHPLEN(IFRE,IERR,0)
      CALL HPDEALLC(IFRE,IERR,0)
#else
      IFRE=lshift(IPOS,2)+LOC(IFIRST)-4
      CALL C_FREE(IFRE)
#endif /* _UNICOS */

      write(*,*) '@ACES_FREE: Released ',FREWRD,
     &           ' integer words of core memory.'

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C Shell to drive LAPACK algorithm.

C A    - REAL SYMMETRIC MATRIX TO BE DIAGONALIZED (E.VALUES IN DIAGS AFTERWARDS)
C B    - EIGENVECTORS RETURNED IN COLUMNS
C JUNK - not used
C N    - SIZE OF MATRIX
C SORT - EIGENVECTORS AND EIGENVALUES ARE REORDERED, with eigenvalues:
c      0     - ascending
c      1     - unordered
c      other - descending

c#include "aces.h"

      subroutine eig(a,b,junk,n,sort)
      implicit none

      integer junk, n, sort
      double precision a(n,n),b(n,n)

      integer i, j, k, index, ierr, lda
      double precision dtmp, reserve(9)

      double precision tolerance
      parameter (tolerance = 1.0d-5)

c ----------------------------------------------------------------------

      if (n.lt.1) return
      if (n.eq.1) then
         b(1,1) = 1.0d0
         return
      end if

      do j = 1, n
         do i = 1, n
            b(i,j) = a(i,j)
         end do
      end do
#ifdef _ASSERT
      dtmp = 0.d0
      do j = 2, n
         do i = 1, j-1
            dtmp = dtmp + dabs(a(j,i)-a(i,j))
         end do
      end do
      if (dtmp.gt.1.d-10) then
         print *, '@EIG: WARNING - the matrix is not symmetric'
         print *, '      sum of differences is ',dtmp
      end if
#endif

      do i = 1, n
      do j = 1, n
         a(i,j) = 0.d0
      enddo
      enddo

      ierr = sort 
      if (n.lt.4) then
         do i = 1, 9
            reserve(i) = 0.d0
         enddo

         call dsyev('V','L',n,b,n,a,reserve,9,      ierr)
      else
         call dsyev('V','L',n,b,n,a,a(1,2), (n*n-n),ierr)
      end if
      if (ierr.ne.0) then
         write(*,*) '@EIG: Eigenvalue not found. Error code: ',ierr
c         call errex
         call abort_job()
      end if

c   o make first significant element of each eigenvector positive
      do j = 1, n
         index = 0
         do i = 1, n
            if (index.eq.0) then
               if (abs(b(i,j)).gt.tolerance) index = i
            end if
         end do
         if (index.ne.0) then
            if (b(index,j).lt.0.0d0) then
               do i = 1, n
                  b(i,j) = -b(i,j)
               end do
            end if
         end if
      end do

      if ((sort.ne.0).and.(sort.ne.1)) then
         do i = 1, n-1
            do j = i+1, n
               if ( a(i,1) .lt. a(j,1) ) then
                  dtmp   = a(i,1)
                  a(i,1) = a(j,1)
                  a(j,1) = dtmp
                  do k = 1, n
                     dtmp   = b(k,i)
                     b(k,i) = b(k,j)
                     b(k,j) = dtmp
                  end do
               end if
            end do
         end do
      end if

c   o put the eigenvalues along the diagonal of A and zero the rest
      do j = 2, n
         do i = 1, n
            a(i,j) = 0.0d0
         end do
      end do
      do i = 1, n
         a(i,i) = a(i,1)
      end do
      do i = 2, n
         a(i,1) = 0.0d0
      end do

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__MEMORY_OVL3C_CSGTO
     +
     +                    ( NALPHA,NCOEFF,
     +                      NCGTO1,NCGTO2,NCGTO3,
     +                      NPGTO1,NPGTO2,NPGTO3,
     +                      SHELL1,SHELL2,SHELL3,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                      ALPHA,CC,
     +                      L1CACHE,NCTROW,
     +                      SPHERIC,
     +
     +                                IMIN,IOPT,
     +                                ZMIN,ZOPT )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__MEMORY_OVL3C_CSGTO
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__OVL3C_SET_ABC
C                OED__OVL3C_F00_DEF_BLOCKS
C  DESCRIPTION : This operation calculates the minimum and optimum
C                integer/flp memory needed for evaluating a batch
C                of contracted 3-center overlap integrals on up to
C                three different centers between cartesian or spherical
C                gaussian type shells.
C
C
C                  Input (x = 1,2 and 3):
C
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1,2 and 3
C                    ALPHA        =  primitive exponents for csh
C                                    1,2 and 3 in that order
C                    CC           =  contraction coefficient for csh
C                                    1,2 and 3 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output:
C
C                    IMIN,IOPT    =  minimum/optimum integer memory
C                    ZMIN,ZOPT    =  minimum/optimum flp memory
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     EMPTY
         LOGICAL     EQUALAB,EQUALAC,EQUALBC
         LOGICAL     MEMORY
         LOGICAL     SPHERIC

         LOGICAL     DUMMYL (1:6)

         INTEGER     IMIN,INEED,IOPT
         INTEGER     L1CACHE,NCTROW
         INTEGER     LCC1,LCC2,LCC3
         INTEGER     LEXP1,LEXP2,LEXP3
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSHELL,MXSIZE
         INTEGER     NALPHA,NCOEFF
         INTEGER     NCGTO1,NCGTO2,NCGTO3
         INTEGER     NCGTOA,NCGTOB,NCGTOC
         INTEGER     NCGTOK,NCGTOIJ
         INTEGER     NCOLHRR,NROTHRR,NXYZHRR
         INTEGER     NCTR
         INTEGER     NIJ,NK,NIJK
         INTEGER     NPGTO1,NPGTO2,NPGTO3
         INTEGER     NPGTOA,NPGTOB,NPGTOC
         INTEGER     NPGTOI,NPGTOJ,NPGTOK,NPGTOIJ
         INTEGER     NROTA,NROTB,NROTC
         INTEGER     NROWA,NROWB,NROWC
         INTEGER     NRYA,NRYB,NRYC
         INTEGER     NXYZA,NXYZB,NXYZC,NXYZFT
         INTEGER     SHELL1,SHELL2,SHELL3
         INTEGER     SHELLA,SHELLB,SHELLC
         INTEGER     SHELLQ
         INTEGER     ZMIN,ZNEED,ZOPT,ZOUT1,ZOUT2

         INTEGER     DUMMYI (1:29)

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)

         DOUBLE PRECISION  DUMMYR (1:24)
C
C
C------------------------------------------------------------------------
C
C
C             ...set initial memory values.
C
C
         IMIN = 0
         IOPT = 0
         ZMIN = 0
         ZOPT = 0
C
C
C             ...fix the A,B,C labels from the 1,2,3 ones. Calculate
C                the relevant data for the A,B,C batch of 3-center
C                overlap integrals. Most of this data is not needed to
C                evaluate the memory requirements and is dumped into
C                the DUMMYx arrays with x=I,R,L standing for integer,
C                real and logical, respectively.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LEXP3 = LEXP2 + NPGTO2

         LCC1  = 1
         LCC2  = LCC1 + NPGTO1 * NCGTO1
         LCC3  = LCC2 + NPGTO2 * NCGTO2

         CALL  OED__OVL3C_SET_ABC
     +
     +              ( NCGTO1,NCGTO2,NCGTO3,
     +                NPGTO1,NPGTO2,NPGTO3,
     +                SHELL1,SHELL2,SHELL3,
     +                X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                ALPHA (LEXP1),ALPHA (LEXP2),ALPHA (LEXP3),
     +                CC (LCC1),CC (LCC2),CC (LCC3),
     +                SPHERIC,
     +
     +                          NCGTOA,NCGTOB,NCGTOC,
     +                          NPGTOA,NPGTOB,NPGTOC,
     +                          SHELLA,SHELLB,SHELLC,
     +                          DUMMYI (1),
     +                          SHELLQ,
     +                          MXSHELL,
     +                          DUMMYR (1), DUMMYR (2), DUMMYR (3),
     +                          DUMMYR (4), DUMMYR (5), DUMMYR (6),
     +                          DUMMYR (7), DUMMYR (8), DUMMYR (9),
     +                          DUMMYL (1),
     +                          EQUALAB,EQUALBC,EQUALAC,
     +                          DUMMYR (10),DUMMYR (11),DUMMYR (12),
     +                          DUMMYR (13),DUMMYR (14),DUMMYR (15),
     +                          DUMMYI (2), DUMMYI (3),
     +                          DUMMYR (16),DUMMYR (17),DUMMYR (18),
     +                          DUMMYR (19),
     +                          NXYZA,NXYZB,NXYZC,
     +                          DUMMYI (4), NXYZFT,
     +                          DUMMYI (5), DUMMYI (6),
     +                          NRYA,NRYB,NRYC,
     +                          DUMMYI (7), DUMMYI (8), DUMMYI (9),
     +                          DUMMYL (2), DUMMYL (3), DUMMYL (4),
     +                          DUMMYI (10),DUMMYI (11),DUMMYI (12),
     +                          DUMMYI (13),DUMMYI (14),DUMMYI (15),
     +                          DUMMYI (16),DUMMYI (17),DUMMYI (18),
     +                          NXYZHRR,NCOLHRR,NROTHRR,
     +                          EMPTY )
     +
     +
         IF (EMPTY) THEN
             RETURN
         END IF
C
C
C             ...simulate the cartesian contracted (f00) batch
C                generation. Set the ij and k primitive data. Again,
C                most of this data is not needed to evaluate the
C                memory requirements, so add it to the DUMMYx arrays.
C
C
         CALL  OED__OVL3C_SET_IJK
     +
     +              ( NCGTOA,NCGTOB,NCGTOC,
     +                NPGTOA,NPGTOB,NPGTOC,
     +                SHELLA,SHELLB,SHELLC,
     +                EQUALAB,EQUALAC,EQUALBC,
     +                DUMMYR (1), DUMMYR (2), DUMMYR (3),
     +                DUMMYR (4), DUMMYR (5), DUMMYR (6),
     +                DUMMYR (7), DUMMYR (8), DUMMYR (9),
     +                DUMMYR (10),DUMMYR (11),DUMMYR (12),
     +                DUMMYI (1), DUMMYI (2), DUMMYI (3),
     +                DUMMYI (4), DUMMYI (5), DUMMYI (6),
     +                DUMMYI (7), DUMMYI (8), DUMMYI (9),
     +                DUMMYI (10),DUMMYI (11),DUMMYI (12),
     +
     +                         DUMMYI (13),DUMMYI (14),
     +                         NCGTOK,NCGTOIJ,
     +                         NPGTOI,NPGTOJ,NPGTOK,NPGTOIJ,
     +                         DUMMYI (15),DUMMYI (16),DUMMYI (17),
     +                         DUMMYL (1), DUMMYL (2), DUMMYL (3),
     +                         DUMMYR (13),DUMMYR (14),DUMMYR (15),
     +                         DUMMYR (16),DUMMYR (17),DUMMYR (18),
     +                         DUMMYR (19),DUMMYR (20),DUMMYR (21),
     +                         DUMMYR (22),DUMMYR (23),DUMMYR (24),
     +                         DUMMYL (4), DUMMYL (5), DUMMYL (6),
     +                         DUMMYI (18),DUMMYI (19),DUMMYI (20),
     +                         DUMMYI (21),DUMMYI (22),DUMMYI (23),
     +                         DUMMYI (24),DUMMYI (25),DUMMYI (26),
     +                         DUMMYI (27),DUMMYI (28),DUMMYI (29) )
     +
     +
C
C
C             ...at this point we would determine the IJ and K
C                exponent sets necessay to evaluate the cartesian
C                contracted (f00) batch after a possible screening
C                of the primitives. Since at the moment we do not
C                apply screening for memory determination, we use the
C                complete set of IJ and K exponents. If this will be
C                changed in the future, this is where a memory routine
C                handling the screening of the IJ and K sets should
C                be placed.
C
C
         NK = NPGTOK
         NIJ = NPGTOIJ
         NIJK = NIJ * NK

         ZNEED = NIJK
         INEED = NPGTOIJ + NPGTOIJ + NPGTOK

         IMIN = MAX0 (IMIN,INEED)
         IOPT = MAX0 (IOPT,INEED)
         ZMIN = MAX0 (ZMIN,ZNEED)
         ZOPT = MAX0 (ZOPT,ZNEED)
C
C
C             ...determine minimum and optimum flp needs for the
C                unnormalized cartesian (f00) contracted 3-center
C                overlap batch generation.
C
C
         NCTR = NCGTOIJ * NCGTOK

         MEMORY = .TRUE.

         CALL  OED__OVL3C_F00_DEF_BLOCKS
     +
     +              ( 0,
     +                NPGTOI,NPGTOJ,NPGTOK,
     +                SHELLQ,
     +                NIJ,NK,NIJK,
     +                NCGTOIJ,NCGTOK,NCTR,
     +                NXYZFT,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                        DUMMYI (1),
     +                        ZOUT1,ZOUT2,
     +                        DUMMYI (2),DUMMYI (3),
     +                        MXPRIM,MNPRIM,
     +                        DUMMYI (4) ,DUMMYI (5) ,DUMMYI (6),
     +                        DUMMYI (7) ,DUMMYI (8) ,DUMMYI (9),
     +                        DUMMYI (10),DUMMYI (11),DUMMYI (12),
     +                        DUMMYI (13),DUMMYI (14),DUMMYI (15),
     +                        DUMMYI (16),DUMMYI (17),DUMMYI (18) )
     +
     +
         INEED = INEED + MXPRIM + MXPRIM + MNPRIM

         IMIN = MAX (IMIN,INEED)
         IOPT = MAX (IOPT,INEED)
         ZMIN = MAX (ZMIN,ZOUT1)
         ZOPT = MAX (ZOPT,ZOUT2)
C
C
C             ...determine the integer/flp memory needs for the next
C                steps:
C
C
C                1) expanding the contraction indices (if any)
C                2) reordering the contraction indices (if any)
C                3) transposing the contraction indices (if any)
C                4) HRR contraction
C                5) cartesian -> spherical transformation or
C                   cartesian normalization
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                 |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                 Zone 1 and 2:  2 batches of HRR maximum size
C
C                       Zone 3:  cart -> spher transformation data
C                                             or
C                                cartesian normalization factors
C
C                       Zone 4:  HRR contraction data
C
C
         NCTR = NCGTO1 * NCGTO2 * NCGTO3
         MXSIZE = NCTR * NXYZHRR
C
C
C             ...memory for Zone 1 and 2.
C
C
         INEED = 0
         ZNEED = MXSIZE + MXSIZE
C
C
C             ...memory for Zone 3.
C
C
         IF (SPHERIC) THEN
             IF (MXSHELL.GT.1) THEN

                 IF (SHELLC.GT.1) THEN
                     NROWC = (SHELLC/2+1)*(SHELLC/2+2)/2
                     NROTC = NROWC * NRYC
                     INEED = INEED + NRYC + NROTC
                     ZNEED = ZNEED + NROTC + NXYZC
                 END IF

                 IF ((SHELLB.GT.1) .AND. (SHELLB.NE.SHELLC)) THEN
                     NROWB = (SHELLB/2+1)*(SHELLB/2+2)/2
                     NROTB = NROWB * NRYB
                     INEED = INEED + NRYB + NROTB
                     ZNEED = ZNEED + NROTB + NXYZB
                 END IF

                 IF ((SHELLA.GT.1) .AND. (SHELLA.NE.SHELLB)
     +                             .AND. (SHELLA.NE.SHELLC)) THEN
                     NROWA = (SHELLA/2+1)*(SHELLA/2+2)/2
                     NROTA = NROWA * NRYA
                     INEED = INEED + NRYA + NROTA
                     ZNEED = ZNEED + NROTA + NXYZA
                 END IF

             END IF
         ELSE
             IF (MXSHELL.GT.1) THEN
                 ZNEED = ZNEED + MXSHELL + 1
             END IF
         END IF
C
C
C             ...memory for Zone 4.
C
C
         INEED = INEED + 4 * NCOLHRR + 2 * NROTHRR
         ZNEED = ZNEED + 2 * NROTHRR

         IMIN = MAX0 (IMIN,INEED)
         IOPT = MAX0 (IOPT,INEED)
         ZMIN = MAX0 (ZMIN,ZNEED)
         ZOPT = MAX0 (ZOPT,ZNEED)
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine distribute_server_info(array_table, narray_table,
     *               index_table, nindex_table,
     *               segment_table, nsegment_table,
     *               block_map_table, nblock_map_table,
     *               iocompany_id, niocompany, scr, nscr,
     *               stack_blocksizes, nstacks )
c---------------------------------------------------------------------------
c   Builds the server table for each server, then sends it to the proper 
c   server.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'server_struct.h'
      include 'mpif.h'
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table, iocompany_id, niocompany, nscr
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer scr(lserver_table_entry,*)
      integer nstacks
      integer stack_blocksizes(nstacks)

      integer i, j, array, nind, segment
      integer start, rank, iblock_map, nwsend, ierr, iserver, nprocs
      integer nblocks
      integer next_entry 
      integer server_rank(niocompany), request(niocompany)
      integer statuses(MPI_STATUS_SIZE,niocompany)
      integer index(mx_array_index)
      integer pst_get_company

      if (niocompany .eq. 0) return   ! no servers

c---------------------------------------------------------------------------
c   Determine the ranks of each server.
c---------------------------------------------------------------------------

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      next_entry = 0
      do i = 1, nprocs
         if (pst_get_company(i-1) .eq. iocompany_id) then
            next_entry = next_entry + 1
            server_rank(next_entry) = i-1
         endif
      enddo

      if (dbg) print *,'Server ranks: ',(server_rank(i),i=1,niocompany)

      next_entry = 0

      print *,'Number of block_map entries ',nblock_map_table

      do iserver = 1, niocompany

c---------------------------------------------------------------------------
c   Build the table for this server.
c---------------------------------------------------------------------------

         rank = server_rank(iserver)
         start = next_entry + 1

c---------------------------------------------------------------------------
c   Find each served array in the array table.
c---------------------------------------------------------------------------

         do array = 1, narray_table
            if (array_table(c_array_type,array) .eq. served_array) then
               iblock_map = array_table(c_block_map,array)
               nind       = array_table(c_nindex,array)
               nblocks    = array_table(c_numblks,array)
                
               do i = 1, nind
                  index(i) = array_table(c_index_array1+i-1,array)
               enddo

c--------------------------------------------------------------------------
c   Scan the block_map_table for the blocks needed by this server.
c--------------------------------------------------------------------------

               do i = 1, nblocks
                  if (block_map_table(c_processor,iblock_map+i-1) .eq.
     *                  rank) then

c--------------------------------------------------------------------------
c   Add an entry to the server table for this rank.
c--------------------------------------------------------------------------

                     next_entry = next_entry + 1
                     if (next_entry*lserver_table_entry .gt. nscr) then
                        print *,'Error: Not enough scratch space ',
     *                     'in distribute_server_info. nscr ',nscr,
     *                     ' but need at least ',
     *                     next_entry*lserver_table_entry
                        call abort_job()
                     endif

                     do j = 1, lserver_table_entry
                        scr(j,next_entry) = 0
                     enddo

                     scr(c_server_array,next_entry) = array
                     scr(c_server_nind,next_entry) = nind

                     do j = 1, nind
                        segment = block_map_table(c_block_map_seg+j-1,
     *                                            iblock_map+i-1)
                        call get_index_segment(index(j), segment,
     *                             segment_table, nsegment_table, 
     *                             index_table, nindex_table, 
     *                             scr(c_server_bsegs+j-1,next_entry),
     *                             scr(c_server_esegs+j-1,next_entry))
                     enddo
                  endif
               enddo    ! block loop
            endif
         enddo          ! array loop

c---------------------------------------------------------------------------
c   Send this table to its server.
c---------------------------------------------------------------------------

         nwsend = (next_entry-start+1)*lserver_table_entry
         call mpi_isend(scr(1,start), nwsend, MPI_INTEGER, rank,
     *                  sip_server_data_message, mpi_comm_world,
     *                  request(iserver), ierr)
      enddo             ! server loop

c--------------------------------------------------------------------------
c   Wait for the requests to be received by the servers.
c-------------------------------------------------------------------------

      call mpi_waitall(niocompany, request, statuses,
     *                 ierr)

c---------------------------------------------------------------------------
c   Send the blkmgr array of stacksizes to each server.
c---------------------------------------------------------------------------

      do iserver = 1, niocompany
         rank = server_rank(iserver)
         call mpi_isend(stack_blocksizes, nstacks, 
     *                  MPI_INTEGER, rank,
     *                  sip_server_data_message, mpi_comm_world,
     *                  request(iserver), ierr)
      enddo

c--------------------------------------------------------------------------
c   Wait for the requests to be received by the servers.
c-------------------------------------------------------------------------

      call mpi_waitall(niocompany, request, statuses,
     *                 ierr)
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine print_server_data(io_company_id)
c---------------------------------------------------------------------------
c   Executed only on the master process at end of a SIAL run.  If the 
c   do_timer flag is set, we receive the accumulated server statistical
c   data from each processor in the I/O company, and print a report.
c----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'server_stat.h'
      include 'timerz.h'
      include 'machine_types.h'
      include 'parallel_info.h'
      include 'interpreter.h'

      integer io_company_id
      integer lendata, niocompany
      integer ierr
      integer status(MPI_STATUS_SIZE)
      integer i, nw
      integer next

      integer pst_get_company

c---------------------------------------------------------------------------
c   Determine the number of IOCOMPANY servers.
c---------------------------------------------------------------------------

      niocompany = 0
      do i = 1, nprocs
         if (pst_get_company(i-1) .eq. io_company_id)
     *       niocompany = niocompany + 1
      enddo

      if (niocompany .eq. 0) return
      if (.not. do_timer) return

c---------------------------------------------------------------------------
c   RECV the data into the master's common block.
c--------------------------------------------------------------------------

      lendata = 12*mx_stat_keys
      call mpi_recv(sstat_tprep, lendata, MPI_DOUBLE_PRECISION, 
     *               MPI_ANY_SOURCE,
     *               sip_server_stat_data_tag, mpi_comm_world,
     *               status, ierr) 
      lendata = 6*mx_stat_keys
      call mpi_recv(sstat_nprep, lendata, MPI_INTEGER, MPI_ANY_SOURCE,
     *               sip_server_stat_data_tag, mpi_comm_world,
     *               status, ierr)

c-----------------------------------------------------------------------------
c   Print the server report.
c-----------------------------------------------------------------------------

c      print *,'              SERVER PERFORMANCE STATISTICS'
c      print *,'              ------ ----------- ----------' 
c
c      print *,'Pardo      Prepares   Preparesums   Requests  Prequests'
c      do i = 1, mx_stat_keys
c         if (sstat_nprep(i) .gt. 0 .or. 
c     *       sstat_nprepsum(i) .gt. 0 .or.
c     *       sstat_nreq(i) .gt. 0 .or.
c     *       sstat_npreq(i) .gt. 0) then
c            print 9000,lineno(i), sstat_nprep(i),sstat_nprepsum(i),
c     *                            sstat_nreq(i), sstat_npreq(i) 
c         endif
c      enddo
c
c      call c_flush_stdout()
c
c 9000 format(1x,i6,4(4x,i8)) 

      print *,'              SERVER PERFORMANCE STATISTICS'
      print *,'              ------ ----------- ----------' 

      print *,'Pardo     PREP   PREPSUM   REQ   PREQ    REST    BACKUP'
      do i = 1, mx_stat_keys
         if (sstat_nprep(i) .gt. 0 .or. 
     *       sstat_nprepsum(i) .gt. 0 .or.
     *       sstat_nreq(i) .gt. 0 .or.
     *       sstat_npreq(i) .gt. 0) then
            print 9000,lineno(i), sstat_nprep(i),sstat_nprepsum(i),
     *                            sstat_nreq(i), sstat_npreq(i),
     *                            sstat_nrestore(i), sstat_nbackup(i)
         endif
      enddo


      print *,'              SERVER PERFORMANCE STATISTICS'
      print *,'              ------ ----------- ----------' 

      print *,'Pardo        PREP      PREPSUM         REQ',
     *        '        PREQ        REST      BACKUP'
      do i = 1, mx_stat_keys
         if (sstat_tprep(i) .gt. 0 .or. 
     *       sstat_tprepsum(i) .gt. 0 .or.
     *       sstat_treq(i) .gt. 0 .or.
     *       sstat_tpreq(i) .gt. 0) then
            print 9001,lineno(i), sstat_tprep(i),sstat_tprepsum(i),
     *                            sstat_treq(i), sstat_tpreq(i),
     *                            sstat_trestore(i), sstat_tbackup(i)
         endif
      enddo


      call c_flush_stdout()
 9000 format(1x,i6,6(4x,i10)) 
 9001 format(1x,i6,6(1x,f20.6))
      return
      end

      subroutine get_server_stats(myline, nprep, nprepsum, nreq,
     *                            npreq)
c---------------------------------------------------------------------------
c   Return server stats for a given line number.
c---------------------------------------------------------------------------
      implicit none
      include 'server_stat.h'
      integer myline, nprep, nprepsum, nreq, npreq

      integer i

      do i = 1, mx_stat_keys
         if (lineno(i) .eq. myline) then
            nprep    = sstat_nprep(i)
            nprepsum = sstat_nprepsum(i)
            nreq     = sstat_nreq(i)
            npreq    = sstat_npreq(i)
            return
         endif
      enddo

c--------------------------------------------------------------------------
c   No data for this lineno.
c--------------------------------------------------------------------------

      nprep    = 0
      nprepsum = 0
      nreq     = 0

      return
      end

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine VBFCen(NOrb, CenOrb, NBFOrb, BF2Cen)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: vbfcen.f,v 1.1.1.1 2003/04/02 19:21:47 aces Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     VBFCen -- generate basis function to center mapping for VMol
C
C SYNOPSIS
      Integer NOrb, CenOrb(NOrb), NBFOrb(NOrb), BF2Cen(*)
C
C ARGUMENTS
C     NOrb    Number of orbits, aka unique centers (input)
C     CenOrb  Number of center in each orbit (input)
C     NBFOrb  Number of basis fns in each orbit (input)
C     BF2Cen  Mapping of basis function into center number (output)
C
C DESCRIPTION
C     Uses an understanding of the innards of VMol to create a mapping
C     of the AO basis set to the corresponding center.
C
C NOTES
C     NBFOrb is the number of basis functions for the whole orbit,
C     not the number of functions on a given center in the orbit.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
C     BF      Counter for basis functions
C     Cen     Cummulative number of centers before the current orbit
C     I       Loop over functions in orbit
C
      Integer BF, Cen, I, IOrb, j
C
C     Initialize counters
C
      BF = 1
      Cen = 0
C
C     Loop over the orbits, aka unique centers
C
      Do 100 IOrb = 1, NOrb
C
C        Place one copy of a basis function on each image equivalent
C        center before moving on to the next basis function.
C
C        Loop over the number of basis fns on each equiv. center.
C
         Do 110 I = 1, ( NBFOrb(IOrb) / CenOrb(IOrb) )
C
C           Loop through the equiv. centers in order to give each
C           a copy of this basis fn.
C
            Do 120 J = 1, CenOrb(IOrb)
               BF2Cen(BF) = Cen + J
               BF = BF + 1
 120        Continue
 110     Continue
C
C        Move Cen up to the beginning of the next orbit
C
         Cen = Cen + CenOrb(IOrb)
 100  Continue
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__MEMORY_NAI_CSGTO
     +
     +                    ( NALPHA,NCOEFF,
     +                      NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      NUCLEI,
     +                      ALPHA,CC,
     +                      L1CACHE,NCTROW,
     +                      SPHERIC,
     +
     +                                IMIN,IOPT,
     +                                ZMIN,ZOPT )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__MEMORY_NAI_CSGTO
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__NAI_SET_AB
C                OED__NAI_E0_DEF_BLOCKS
C  DESCRIPTION : This operation calculates the minimum and optimum
C                integer/flp memory needed for evaluating a batch
C                of contracted electron nuclear attraction integrals
C                between cartesian or spherical gaussian type shells.
C
C
C                  Input (x = 1 and 2):
C
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    NUCLEI       =  # of nuclear attraction centers
C                    ALPHA        =  primitive exponents for csh
C                                    1 and 2 in that order
C                    CC           =  contraction coefficient for csh
C                                    1 and 2 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output:
C
C                    IMIN,IOPT    =  minimum/optimum integer memory
C                    ZMIN,ZOPT    =  minimum/optimum flp memory
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     EMPTY
         LOGICAL     EQUALAB
         LOGICAL     MEMORY
         LOGICAL     SPHERIC

         LOGICAL     DUMMYL (1:3)

         INTEGER     IMIN,INEED,IOPT
         INTEGER     L1CACHE,NCTROW
         INTEGER     LCC1,LCC2
         INTEGER     LEXP1,LEXP2
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSHELL,MXSIZE
         INTEGER     NALPHA,NCOEFF
         INTEGER     NCEN
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NCGTOA,NCGTOB,NCGTOAB
         INTEGER     NCOLHRR,NROTHRR,NXYZHRR
         INTEGER     NCTR
         INTEGER     NGQP,NMOM,NGQSCR
         INTEGER     NIJ
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NPGTOA,NPGTOB,NPGTOAB
         INTEGER     NROTA,NROTB
         INTEGER     NROWA,NROWB
         INTEGER     NRYA,NRYB
         INTEGER     NUCLEI
         INTEGER     NXYZA,NXYZB,NXYZET
         INTEGER     SHELL1,SHELL2
         INTEGER     SHELLA,SHELLB
         INTEGER     SHELLP
         INTEGER     ZMIN,ZNEED,ZOPT,ZOUT1,ZOUT2

         INTEGER     DUMMYI (1:32)

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)

         DOUBLE PRECISION  DUMMYR (1:11)
C
C
C------------------------------------------------------------------------
C
C
C             ...set initial memory values.
C
C
         IMIN = 0
         IOPT = 0
         ZMIN = 0
         ZOPT = 0
C
C
C             ...fix the A,B labels from the 1,2 ones. Calculate the
C                relevant data for the A,B batch of nuclear attraction
C                integrals. Most of this data is not needed to evaluate
C                the memory requirements and is dumped into the DUMMYx
C                arrays with x=I,R,L standing for integer, real and
C                logical, respectively.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LCC1 = 1
         LCC2 = LCC1 + NPGTO1 * NCGTO1

         CALL  OED__NAI_SET_AB
     +
     +              ( NCGTO1,NCGTO2,
     +                NPGTO1,NPGTO2,
     +                SHELL1,SHELL2,
     +                X1,Y1,Z1,X2,Y2,Z2,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                CC (LCC1),CC (LCC2),
     +                SPHERIC,
     +
     +                            NCGTOA,NCGTOB,
     +                            NPGTOA,NPGTOB,
     +                            SHELLA,SHELLB,SHELLP,
     +                            MXSHELL,
     +                            DUMMYR (1), DUMMYR (2), DUMMYR (3),
     +                            DUMMYR (4), DUMMYR (5), DUMMYR (6),
     +                            DUMMYL (1),
     +                            EQUALAB,
     +                            DUMMYR (7), DUMMYR (8), DUMMYR (9),
     +                            DUMMYI (1),
     +                            DUMMYR (10),DUMMYR (11),
     +                            NXYZA,NXYZB,NXYZET,
     +                            DUMMYI (4),
     +                            NRYA,NRYB,
     +                            DUMMYI (2), DUMMYI (3),
     +                            DUMMYL (2), DUMMYL (3),
     +                            DUMMYI (4), DUMMYI (5),
     +                            DUMMYI (6), DUMMYI (7),
     +                            DUMMYI (8), DUMMYI (9),
     +                            NXYZHRR,NCOLHRR,NROTHRR,
     +                            EMPTY )
     +
     +
         IF (EMPTY) THEN
             RETURN
         END IF
C
C
C             ...simulate the cartesian contracted (e|0) nuclear
C                attraction batch generation.
C
C
         IF (EQUALAB) THEN
             NPGTOAB = (NPGTOA*(NPGTOA+1))/2
             NCGTOAB = (NCGTOA*(NCGTOA+1))/2
         ELSE
             NPGTOAB = NPGTOA * NPGTOB
             NCGTOAB = NCGTOA * NCGTOB
         END IF
C
C
C             ...at this point we would determine the IJ exponent
C                pairs and the # of relevant nuclear attraction
C                centers necessay to evaluate the cartesian contracted
C                (e|0) nuclear attraction batch after a possible
C                screening of the primitives. Since at the moment we
C                do not apply screening for memory determination,
C                we use the complete set of IJ pairs and the complete
C                set of nuclear attraction centers. In any event
C                this will be changed in the future, this is where a
C                memory routine handling the IJ pair determination
C                should be placed.
C
C
         NIJ = NPGTOAB
         NCEN = NUCLEI

         ZNEED = NIJ + 4 * NCEN
         INEED = NPGTOAB + NPGTOAB + NUCLEI

         IMIN = MAX (IMIN,INEED)
         IOPT = MAX (IOPT,INEED)
         ZMIN = MAX (ZMIN,ZNEED)
         ZOPT = MAX (ZOPT,ZNEED)
C
C
C             ...determine minimum and optimum flp needs for the
C                unnormalized cartesian (e|0) contracted nuclear
C                attraction batch generation.
C
C
         NGQP = 1 + SHELLP / 2
         NMOM = 2 * NGQP - 1
         NGQSCR = 5 * NMOM + 2 * NGQP - 2

         MEMORY = .TRUE.

         CALL  OED__NAI_E0_DEF_BLOCKS
     +
     +              ( 0,
     +                NPGTOA,NPGTOB,
     +                SHELLP,
     +                NIJ,NCGTOAB,NCEN,
     +                NGQP,NGQSCR,
     +                NXYZET,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                        DUMMYI (1),
     +                        ZOUT1,ZOUT2,
     +                        DUMMYI (2),DUMMYI (3),
     +                        MXPRIM,MNPRIM,
     +                        DUMMYI (4) ,DUMMYI (5) ,DUMMYI (6),
     +                        DUMMYI (7) ,DUMMYI (8) ,DUMMYI (9),
     +                        DUMMYI (10),DUMMYI (11),DUMMYI (12),
     +                        DUMMYI (13),DUMMYI (14),DUMMYI (15),
     +                        DUMMYI (16),DUMMYI (17),DUMMYI (18),
     +                        DUMMYI (19),DUMMYI (20),DUMMYI (21),
     +                        DUMMYI (22),DUMMYI (23),DUMMYI (24),
     +                        DUMMYI (25),DUMMYI (26),DUMMYI (27),
     +                        DUMMYI (28),DUMMYI (29),DUMMYI (30),
     +                        DUMMYI (31),DUMMYI (32) )
     +
     +
         INEED = INEED + MXPRIM + MXPRIM + MNPRIM

         IMIN = MAX (IMIN,INEED)
         IOPT = MAX (IOPT,INEED)
         ZMIN = MAX (ZMIN,ZOUT1)
         ZOPT = MAX (ZOPT,ZOUT2)
C
C
C             ...determine the integer/flp memory needs for the next
C                steps:
C
C
C                1) expanding the contraction indices (if any)
C                2) reordering the contraction indices (if any)
C                3) transposing the contraction indices (if any)
C                4) HRR contraction
C                5) cartesian -> spherical transformation or
C                   cartesian normalization
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                 |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                 Zone 1 and 2:  2 batches of HRR maximum size
C
C                       Zone 3:  cart -> spher transformation data
C                                             or
C                                cartesian normalization factors
C
C                       Zone 4:  HRR contraction data
C
C
         NCTR = NCGTO1 * NCGTO2
         MXSIZE = NCTR * NXYZHRR
C
C
C             ...memory for Zone 1 and 2.
C
C
         INEED = 0
         ZNEED = MXSIZE + MXSIZE
C
C
C             ...memory for Zone 3.
C
C
         IF (SPHERIC) THEN
             IF (MXSHELL.GT.1) THEN

                 IF (SHELLB.GT.1) THEN
                     NROWB = (SHELLB/2+1)*(SHELLB/2+2)/2
                     NROTB = NROWB * NRYB
                     INEED = INEED + NRYB + NROTB
                     ZNEED = ZNEED + NROTB + NXYZB
                 END IF

                 IF ((SHELLA.GT.1) .AND. (SHELLA.NE.SHELLB)) THEN
                     NROWA = (SHELLA/2+1)*(SHELLA/2+2)/2
                     NROTA = NROWA * NRYA
                     INEED = INEED + NRYA + NROTA
                     ZNEED = ZNEED + NROTA + NXYZA
                 END IF

             END IF
         ELSE
             IF (MXSHELL.GT.1) THEN
                 ZNEED = ZNEED + MXSHELL + 1
             END IF
         END IF
C
C
C             ...memory for Zone 4.
C
C
         INEED = INEED + 4 * NCOLHRR + 2 * NROTHRR
         ZNEED = ZNEED + 2 * NROTHRR

         IMIN = MAX0 (IMIN,INEED)
         IOPT = MAX0 (IOPT,INEED)
         ZMIN = MAX0 (ZMIN,ZNEED)
         ZOPT = MAX0 (ZOPT,ZNEED)
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine load_pre_defined_routines()
      implicit none

      integer dummy, load_user_sub
      external sip_barrier
      external energy_denominator
      external energy_product
      external energy_reg_denominator
      external energy_reg_product
      external energy_denominator_reg_deriv
      external init_c
      external init_eps
      external print_scalar
      external trace_on, trace_off
      external load_balance_on, load_balance_off
      external dump_block
      external blocks_to_list
      external list_to_blocks
      external der_int_setup
      external compute_derivative_integrals
      external fmult 
      external server_barrier
      external scont1, hcont1, dcont2
      external eigen_calc, eig_inv, eig_sr, eig_sr_inv
      external copy_fock
      external diis_setup 
      external compute_diis
      external write_blocks_to_list
      external read_list_to_blocks
      external remove_diagonal
      external return_diagonal
      external fock_denominator
      external set_flags
      external set_flags2
      external der2_comp
      external fock_der
      external overlap_der
      external scontxy
      external hcontxy
      external compute_sderivative_integrals
      external read_hess
      external return_h1
      external smon_on
      external smon_off
      external scf_rhf
      external array_copy
      external c1_print, c1b_print, c2aa_print, c2ab_print, c2bb_print

      external comp_ovl3c,dump_amp,open_amp,copy_ff,copy_ba,copy_ab,
     *         remove_dx, remove_sx, remove_sd, removevv_dd,
     *         removeoo_dd, remove_dd, remove_ss, remove_ds,
     *         remove_xd, remove_xs, remove_xxdd, remove_xdxd,
     *         remove_xxsd, remove_xsxd, remove_xdxs, remove_xxss,
     *         remove_xsxs, remove_dddd, remove_ssss,
     *         remove_single_double, remove_double, remove_single, 
     *         set_index, udenominator, read_grad, 
     *         energy_adenominator, energy_bdenominator,
     *         energy_abdenominator
      external check_dconf
      external dropmo_expand_basis
      external square_root, norm_fac, return_sval, return_diagonal4,
     *         symm_force_a, symm_force_i, asymm_force_i, symm_force_ij,
     *         place_sval,
     *         place_one,
     *         place_one2,
     *         place_one3,
     *         place_one4,
     *         place_one5,
     *         place_one6,
     *         place_oneb,
     *         place_one2b,
     *         place_one3b,
     *         place_one4b,
     *         place_one5b,
     *         place_one6b,
     *         smooth,smooth4,
     *         eigen_nonsymm_calc
      external 
     *         eomroot_print,  
     *         eomroot_print_new, 
     *         place_one_dip,
     *         place_one_dip_2,
     *         place_one_dip_3,
     *         place_one_dip_4,
     *         place_one_dip_5,
     *         place_one_dip_6,
     *         place_one_dip_7,
     *         place_one_dip_8,
     *         place_one_dea,
     *         place_one_dea_2,
     *         place_one_dea_3,
     *         place_one_dea_4,
     *         place_one_dea_5,
     *         place_one_dea_6,
     *         place_one_dea_7,
     *         place_one_dea_8
 
      external apply_den2, apply_den4, apply_den4_nodiag
      external apply_den2_nor 
      external energy_tdenominator
      external compute_aaaa_batch, compute_aaab_batch, 
     *         compute_aabb_batch, compute_aabc_batch,
     *         compute_abab_batch, compute_abac_batch,
     *         compute_abcd_batch, compute_no4c_batch,
     *         remove_atom_rud1, remove_atom_rud2
      external der4_comp, set_flags4
      external timestamp
      external pardo_sects, get_ijk, set_ijk_aaa, stripi,
     *         sum_64ss, set_ijk_aab
      external set_ijk_aaa_nosymm, set_ijk_aab_nosymm 
      external get_my_rank, broadcast_array
      external checkpoint, get_restart_status, commit_checkpoint
      external crash
C
C
C             ...Watson: XYZ moment integrals
C
      external print_eom_dens_info
      external return_x,  return_y,  return_z
      external return_xx, return_yy, return_zz
      external return_xy, return_xz, return_yz
      external return_derv_xyz, return_ovl,
     *         dipole_moment, nuc_dipole_moment, nuc_dipole_derivative,
     *         second_moment
      external return_1st_mom, return_2nd_mom 
      external energy_ty_denominator, reorder_energy

c 
c VFL SCF instructions 

      external compute_batch1
      external compute_batch2
      external compute_batch3
      external compute_batch4
      external compute_batch5
      external compute_batch6
      external compute_batch7
      external compute_batch8

      external compute_ubatch1
      external compute_ubatch2
      external compute_ubatch3
      external compute_ubatch4
      external compute_ubatch5
      external compute_ubatch6
      external compute_ubatch7
      external compute_ubatch8

C Ajith Perera, SOI instructions

      external compute_1soi_xbatch, compute_1soi_ybatch,
     &         compute_1soi_zbatch

      external compute_2soi_xbatch, compute_2soi_ybatch,
     &         compute_2soi_zbatch

      external write_vecs2jarc

c------------------------------------------------------
      external form_iad
      external form_ibd
      external set_itol
      external fassign 
      external prefetch_on, prefetch_off
c
c -------------------------------------------------------------------- 
c VFL Instructions needed to perform 'super' T calculations 
c -------------------------------------------------------------------- 
c
      external set_t3blocks_a
      external set_t3blocks_i
      external compt3_a
      external compt3_i
c
c -------------------------------------------------------------------- 
c VFL Instruction needed to perform atomic density guess  
c -------------------------------------------------------------------- 
c
      external scf_atom 
c
c -------------------------------------------------------------------- 
c VFL Instruction needed for printing, FNO, ect.. updated FEB. 29 2012  
c -------------------------------------------------------------------- 
c
      external print_rel_info 
      external temp_x
      external corder
      external form_fno
      external form_fnob
      external maxamp_print
      external form_fock_rohf
c
c --------------------------------------------------------------------
c VFL Instruction needed for DEA/DIP updated AUG. 14 2012
c --------------------------------------------------------------------
c
      external write_scfdata
      external set_np2
      external sdrop
      external asymm_force_a
      external return_h1_nodiag
c
c --------------------------------------------------------------------
c Watson Instruction needed to write the density out
c --------------------------------------------------------------------
c
      external dens2jobarc
      external change_occ_dens,change_vrt_dens
      external add_scal2diag,calc_trace,v_nuc_nuc,vccs_change_x
      external write_coefficients,read_coefficients
      external scf_atom_coeff
c--------------------------------------------------------------------
c Ajith Perera, miscellaneous developments.
c-------------------------------------------------------------------
      external sum_2d_array
c-------------------------------------------------------------------
c
c -------------------------------------------------------------------- 
c Instructions needed in the CCSD(T) gradient and ecpgradient   
c --------------------------------------------------------------------
c
      external index_match 
      external ecp_dercont 
c--------------------------------------------------------------------
c VFL Instruction needed for restricted pardo  updated JULY 22012
c--------------------------------------------------------------------
      external init_section
      external prestrict
      external doprestrict
c--------------------------------------------------------------------
c Jason Byrd misc. development additions
c--------------------------------------------------------------------
      external sort_fno
      external dropcore_fno
c--------------------------------------------------------------------
c Jason Byrd f12
c--------------------------------------------------------------------
       external f12_integrals, f12_c_coef, mkexch,get_grid_size,
     & grid_point_range,f12_2center_moobj,grid_point_weight,int1_setup,
     & f12_2center_mxobj,f12_2center_myobj,f12_2center_mzobj,
     & f12_1el_gen,energy_numerator,lindep_remove,eomiter,eomdiag,
     & eomchunk,eomnewvec,eomovermax,eominitguess_ip,eomcopyroots,
     & apply_den1,apply_den3,addrootindex,eomgetroot,eomprintcorrnorm,
     & setauxvec,eomovertable,make_3body_diag_ip,eomtargetroot,f12info,
     & eomiproots,denom_eomip_pt,apply_den5,frag_index_range
c--------------------------------------------------------------------
c Watson, Interface options for scf_xxxx.sial codes
c--------------------------------------------------------------------
      external read_interface
      external get_interface
      external c1_full_print
c
      dummy = load_user_sub('sip_barrier' // char(0),
     *                       sip_barrier)
      dummy = load_user_sub('energy_denominator' // char(0),
     *                       energy_denominator)
      dummy = load_user_sub('udenominator'//char(0), udenominator)
      call set_upgrade_flag(dummy)
      dummy = load_user_sub('energy_product' // char(0),
     *                       energy_product)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('energy_reg_denominator' // char(0),
     *                       energy_reg_denominator)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('energy_reg_product' // char(0),
     *                       energy_reg_product)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('energy_denominator_reg_deriv' // char(0),
     *                       energy_denominator_reg_deriv)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('print_scalar' // char(0),
     *                       print_scalar)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('trace_on' // char(0),
     *                       trace_on)
      dummy = load_user_sub('trace_off' // char(0),
     *                       trace_off)
      dummy = load_user_sub('dump_block' // char(0),
     *                       dump_block)
      dummy = load_user_sub('load_balance_on' // char(0),
     *                       load_balance_on)
      dummy = load_user_sub('load_balance_off' // char(0),
     *                       load_balance_off)
      dummy = load_user_sub('blocks_to_list' // char(0),
     *                       blocks_to_list)
      dummy = load_user_sub('list_to_blocks' // char(0),
     *                       list_to_blocks)
      dummy = load_user_sub('fmult' // char(0),
     *                       fmult)
      dummy = load_user_sub('der_int_setup' // char(0),
     *                       der_int_setup)
      dummy = load_user_sub('compute_derivative_integrals'//char(0),
     *                       compute_derivative_integrals)
      dummy = load_user_sub('server_barrier'//char(0),
     *                       server_barrier)
      dummy = load_user_sub('scont1'//char(0), scont1)
      dummy = load_user_sub('hcont1'//char(0), hcont1)
      dummy = load_user_sub('dcont2'//char(0), dcont2)
      dummy = load_user_sub('eig'//char(0), eigen_calc)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('eig_inv'//char(0), eig_inv)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('eig_sr'//char(0), eig_sr)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('eig_sr_inv'//char(0), eig_sr_inv)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('copy_fock'//char(0), copy_fock)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('diis_setup'//char(0), diis_setup)
      dummy = load_user_sub('compute_diis'//char(0), compute_diis)
      dummy = load_user_sub('write_blocks_to_list'//char(0), 
     *             write_blocks_to_list)
      dummy = load_user_sub('read_list_to_blocks'//char(0), 
     *             read_list_to_blocks)
      dummy = load_user_sub('remove_diagonal'//char(0), remove_diagonal)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_diagonal'//char(0), return_diagonal)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('fock_denominator'//char(0),
     *            fock_denominator)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('set_flags'//char(0), set_flags)
      dummy = load_user_sub('set_flags2'//char(0), set_flags2)
      dummy = load_user_sub('der2_comp'//char(0), der2_comp)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('fock_der'//char(0), fock_der)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('overlap_der'//char(0), overlap_der)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('scontxy'//char(0), scontxy)
      dummy = load_user_sub('hcontxy'//char(0), hcontxy)
      dummy = load_user_sub('compute_sderivative_integrals'//char(0),
     *                       compute_sderivative_integrals)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('read_hess'//char(0), read_hess)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_h1'//char(0), return_h1)
      call set_upgrade_flag(dummy) 

      dummy = load_user_sub('smon_on'//char(0), 
     *                       smon_on)
      dummy = load_user_sub('smon_off'//char(0), 
     *                       smon_off)
      dummy = load_user_sub('scf_rhf'//char(0), scf_rhf)
      dummy = load_user_sub('array_copy'//char(0), array_copy)
      dummy = load_user_sub('energy_adenominator'//char(0),
     *                       energy_adenominator) 
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('energy_bdenominator'//char(0),
     *                       energy_bdenominator) 
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('energy_abdenominator'//char(0),
     *                       energy_abdenominator) 
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_xd'//char(0), remove_xd)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_ds'//char(0), remove_ds)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_ss'//char(0), remove_ss)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_dd'//char(0), remove_dd)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('removeoo_dd'//char(0), removeoo_dd)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('removevv_dd'//char(0), removevv_dd)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_sd'//char(0), remove_sd)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_sx'//char(0), remove_sx)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_dx'//char(0), remove_dx)
      call set_upgrade_flag(dummy) 
c     dummy = load_user_sub('copy_ab'//char(0), copy_ab)
c     dummy = load_user_sub('copy_ba'//char(0), copy_ba)
      dummy = load_user_sub('copy_ff'//char(0), copy_ff)
      call set_upgrade_flag(dummy) 
c     dummy = load_user_sub('open_amp'//char(0), open_amp)
      dummy = load_user_sub('dump_amp'//char(0), dump_amp)
      dummy = load_user_sub('comp_ovl3c'//char(0), comp_ovl3c)
      dummy = load_user_sub('check_dconf'//char(0), check_dconf)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('dropmo_expand_basis'//char(0), 
     *                       dropmo_expand_basis)
      dummy = load_user_sub('square_root'//char(0), square_root)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('norm_fac'//char(0), norm_fac)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_sval'//char(0), return_sval)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_diagonal4'//char(0),
     *                      return_diagonal4)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('symm_force_a'//char(0),
     *                      symm_force_a)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('symm_force_i'//char(0),
     *                      symm_force_i)
      dummy = load_user_sub('place_sval'//char(0), place_sval)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one'//char(0), place_one)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one2'//char(0), place_one2)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one3'//char(0), place_one3)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one4'//char(0), place_one4)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one5'//char(0), place_one5)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one6'//char(0), place_one6)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_oneb'//char(0), place_oneb)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one2b'//char(0), place_one2b)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one3b'//char(0), place_one3b)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one4b'//char(0), place_one4b)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one5b'//char(0), place_one5b)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one6b'//char(0), place_one6b)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip'//char(0),
     *                                      place_one_dip)
C
C This need to get upgraded as the rest!!, Ajith Perera, 08/2013.
CSSS      call set_upgrade_flag(dummy) 
C
      dummy = load_user_sub('place_one_dip_2'//char(0),
     *                                      place_one_dip_2)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip_3'//char(0),
     *                                      place_one_dip_3)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip_4'//char(0),
     *                                      place_one_dip_4)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip_5'//char(0),
     *                                      place_one_dip_5)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip_6'//char(0),
     *                                      place_one_dip_6)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip_7'//char(0),
     *                                      place_one_dip_7)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dip_8'//char(0),
     *                                      place_one_dip_8)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea'//char(0),
     *                                      place_one_dea)
      dummy = load_user_sub('place_one_dea_2'//char(0),
     *                                      place_one_dea_2)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea_3'//char(0),
     *                                      place_one_dea_3)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea_4'//char(0),
     *                                      place_one_dea_4)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea_5'//char(0),
     *                                      place_one_dea_5)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea_6'//char(0),
     *                                      place_one_dea_6)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea_7'//char(0),
     *                                      place_one_dea_7)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('place_one_dea_8'//char(0),
     *                                      place_one_dea_8)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('eomroot_print'//char(0), eomroot_print)
      dummy = load_user_sub('eomroot_print_new'//char(0), 
     *                       eomroot_print_new)
c     dummy = load_user_sub('smooth'//char(0), smooth)
c     dummy = load_user_sub('smooth4'//char(0), smooth4)
      dummy = load_user_sub('eig_nonsymm'//char(0),
     *                       eigen_nonsymm_calc)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('apply_den2'//char(0), apply_den2)
      dummy = load_user_sub('apply_den2_nor'//char(0), apply_den2_nor)
      dummy = load_user_sub('apply_den4'//char(0), apply_den4)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('apply_den4_nodiag'//char(0),
     *                       apply_den4_nodiag)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('energy_tdenominator'//char(0),
     *                       energy_tdenominator)
      
c     dummy = load_user_sub('compute_aaaa_batch'//char(0),
c    *                       compute_aaaa_batch)
c     dummy = load_user_sub('compute_aaab_batch'//char(0),
c    *                       compute_aaab_batch)
      dummy = load_user_sub('compute_aabb_batch'//char(0),
     *                       compute_aabb_batch)
      call set_upgrade_flag(dummy) 
c     dummy = load_user_sub('compute_aabc_batch'//char(0),
c    *                       compute_aabc_batch)
c     dummy = load_user_sub('compute_abab_batch'//char(0),
c    *                       compute_abab_batch)
c     dummy = load_user_sub('compute_abac_batch'//char(0),
c    *                       compute_abac_batch)
      dummy = load_user_sub('compute_abcd_batch'//char(0),
     *                       compute_abcd_batch)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('compute_no4c_batch'//char(0),
     *                       compute_no4c_batch)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_atom_rud1'//char(0),
     *                       remove_atom_rud1)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('remove_atom_rud2'//char(0),
     *                       remove_atom_rud2)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('der4_comp'//char(0), der4_comp)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('set_flags4'//char(0), set_flags4)
      dummy = load_user_sub('timestamp'//char(0), timestamp)
      dummy = load_user_sub('c1_print'//char(0), c1_print)
      dummy = load_user_sub('c1b_print'//char(0), c1b_print)
      dummy = load_user_sub('c2aa_print'//char(0), c2aa_print)
      dummy = load_user_sub('c2ab_print'//char(0), c2ab_print)
      dummy = load_user_sub('c2bb_print'//char(0), c2bb_print)
      dummy = load_user_sub('pardo_sects'//char(0), pardo_sects)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('get_ijk'//char(0), get_ijk)
      dummy = load_user_sub('set_ijk_aaa'//char(0), set_ijk_aaa)
      dummy = load_user_sub('set_ijk_aaa_nosymm'//char(0), 
     *                       set_ijk_aaa_nosymm)
      dummy = load_user_sub('stripi'//char(0), stripi)
      dummy = load_user_sub('sum_64ss'//char(0), sum_64ss)
      dummy = load_user_sub('set_ijk_aab'//char(0), set_ijk_aab)
      dummy = load_user_sub('set_ijk_aab_nosymm'//char(0), 
     *                       set_ijk_aab_nosymm)
      dummy = load_user_sub('get_my_rank'//char(0), get_my_rank)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('broadcast_array'//char(0), broadcast_array)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('checkpoint'//char(0), checkpoint)
      dummy = load_user_sub('get_restart_status'//char(0), 
     *                       get_restart_status)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('commit_checkpoint'//char(0), 
     *                       commit_checkpoint)
      dummy = load_user_sub('crash'//char(0), crash)
C
C
C             ...Watson: XYZ moment integrals
C
      dummy = load_user_sub('return_ovl'//char(0), return_ovl)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_derv_xyz'//char(0), return_derv_xyz)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('dipole_moment'//char(0), dipole_moment)
      dummy = load_user_sub('second_moment'//char(0), second_moment)
      dummy = load_user_sub('energy_ty_denominator'//char(0),
     *                       energy_ty_denominator)
C      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('reorder_energy'//char(0),reorder_energy)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_1st_mom'//char(0), return_1st_mom)
      dummy = load_user_sub('return_2nd_mom'//char(0), return_2nd_mom)

      dummy = load_user_sub('nuc_dipole_moment'//char(0),
     *                       nuc_dipole_moment)
      dummy = load_user_sub('nuc_dipole_derivative'//char(0),
     *                       nuc_dipole_derivative)

      dummy = load_user_sub('return_x'//char(0), return_x)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_y'//char(0), return_y)
      call set_upgrade_flag(dummy) 
      dummy = load_user_sub('return_z'//char(0), return_z)
      call set_upgrade_flag(dummy) 

      dummy = load_user_sub('return_xx'//char(0), return_xx)
      dummy = load_user_sub('return_yy'//char(0), return_yy)
      dummy = load_user_sub('return_zz'//char(0), return_zz)

      dummy = load_user_sub('return_xy'//char(0), return_xy)
      dummy = load_user_sub('return_xz'//char(0), return_xz)
      dummy = load_user_sub('return_yz'//char(0), return_yz)

      dummy = load_user_sub('print_eom_dens_info'//char(0),
     +                       print_eom_dens_info)
c
c -------------------------------------------------------------------- 
c VFL Instructions needed to perform 'fast' scf calculations 
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('compute_batch1'//char(0), compute_batch1)
      dummy = load_user_sub('compute_batch2'//char(0), compute_batch2)
      dummy = load_user_sub('compute_batch3'//char(0), compute_batch3)
      dummy = load_user_sub('compute_batch4'//char(0), compute_batch4)
      dummy = load_user_sub('compute_batch5'//char(0), compute_batch5)
      dummy = load_user_sub('compute_batch6'//char(0), compute_batch6)
      dummy = load_user_sub('compute_batch7'//char(0), compute_batch7)
      dummy = load_user_sub('compute_batch8'//char(0), compute_batch8)

      dummy = load_user_sub('compute_ubatch1'//char(0), compute_ubatch1)
      dummy = load_user_sub('compute_ubatch2'//char(0), compute_ubatch2)
      dummy = load_user_sub('compute_ubatch3'//char(0), compute_ubatch3)
      dummy = load_user_sub('compute_ubatch4'//char(0), compute_ubatch4)
      dummy = load_user_sub('compute_ubatch5'//char(0), compute_ubatch5)
      dummy = load_user_sub('compute_ubatch6'//char(0), compute_ubatch6)
      dummy = load_user_sub('compute_ubatch7'//char(0), compute_ubatch7)
      dummy = load_user_sub('compute_ubatch8'//char(0), compute_ubatch8)

      dummy = load_user_sub('form_iad'//char(0), form_iad)
      dummy = load_user_sub('form_ibd'//char(0), form_ibd)

      dummy = load_user_sub('set_itol'//char(0), set_itol)
      dummy = load_user_sub('fassign'//char(0), fassign)
c
c -------------------------------------------------------------------- 
c VFL Instructions needed to perform 'super' T calculations 
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('set_t3blocks_a'//char(0), set_t3blocks_a)
      dummy = load_user_sub('set_t3blocks_i'//char(0), set_t3blocks_i)
      dummy = load_user_sub('compt3_a'//char(0), compt3_a)
      dummy = load_user_sub('compt3_i'//char(0), compt3_i)
      dummy = load_user_sub('prefetch_on'//char(0), prefetch_on)
      dummy = load_user_sub('prefetch_off'//char(0), prefetch_off)
c
c -------------------------------------------------------------------- 
c VFL Instruction needed to perform atomic density guess  
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('scf_atom'//char(0), scf_atom) 
c
c -------------------------------------------------------------------- 
c VFL Instruction needed for printing, FNO, ect.. updated FEB. 29 2012  
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('print_rel_info'//char(0),
     *                       print_rel_info)
      dummy = load_user_sub('temp_x'//char(0), temp_x)
      dummy = load_user_sub('corder'//char(0), corder)
      dummy = load_user_sub('form_fno'//char(0), form_fno)
      dummy = load_user_sub('form_fnob'//char(0), form_fnob)
      dummy = load_user_sub('maxamp_print'//char(0), maxamp_print)
      dummy = load_user_sub('form_fock_rohf'//char(0), form_fock_rohf)
c
c --------------------------------------------------------------------
c VFL Instruction needed for DEA/DIP updated AUG. 14 2012
c --------------------------------------------------------------------
c
      dummy = load_user_sub('write_scfdata'//char(0), write_scfdata)
      dummy = load_user_sub('set_np2'//char(0), set_np2)
      dummy = load_user_sub('sdrop'//char(0), sdrop)
      dummy = load_user_sub('asymm_force_a'//char(0), asymm_force_a)
      dummy = load_user_sub('asymm_force_i'//char(0), asymm_force_i)
      dummy = load_user_sub('symm_force_ij'//char(0), symm_force_ij)
      dummy = load_user_sub('return_h1_nodiag'//char(0),
     *                       return_h1_nodiag)
c
c --------------------------------------------------------------------
c Watson instruction needed to write out density
c --------------------------------------------------------------------
c
      dummy = load_user_sub('dens2jobarc'//char(0), dens2jobarc)
      dummy = load_user_sub('change_occ_dens'//char(0), change_occ_dens)
      dummy = load_user_sub('change_vrt_dens'//char(0), change_vrt_dens)
      dummy = load_user_sub('add_scal2diag'//char(0), add_scal2diag)
      dummy = load_user_sub('calc_trace'//char(0), calc_trace)
      dummy = load_user_sub('v_nuc_nuc'//char(0), v_nuc_nuc)
c      dummy = load_user_sub('vccs_change_x'//char(0), vccs_change_x)
      dummy = load_user_sub('write_coefficients'//char(0),
     +                       write_coefficients)
      dummy = load_user_sub('read_coefficients'//char(0),
     +                       read_coefficients)
      dummy = load_user_sub('scf_atom_coeff'//char(0), scf_atom_coeff)
c
c -------------------------------------------------------------------- 
c Ajith Perera, miscellaneous developments.
c-------------------------------------------------------------------
      dummy = load_user_sub('sum_2d_array'//char(0), sum_2d_array)
      call set_upgrade_flag(dummy)

      dummy = load_user_sub('compute_1soi_xbatch'//char(0),
     &                       compute_1soi_xbatch)
      dummy = load_user_sub('compute_1soi_ybatch'//char(0),
     &                       compute_1soi_ybatch)
      dummy = load_user_sub('compute_1soi_zbatch'//char(0),
     &                       compute_1soi_zbatch)

      dummy = load_user_sub('compute_2soi_xbatch'//char(0),
     &                       compute_2soi_xbatch)
      dummy = load_user_sub('compute_2soi_ybatch'//char(0),
     &                       compute_2soi_ybatch)
      dummy = load_user_sub('compute_2soi_zbatch'//char(0),
     &                       compute_2soi_zbatch)

      dummy = load_user_sub('write_vecs2jarc'//char(0),
     &                       write_vecs2jarc)

c Instructions needed in the CCSD(T) gradient and ecpgradient   
c --------------------------------------------------------------------
c
      dummy = load_user_sub('index_match'//char(0), index_match)
      dummy = load_user_sub('ecp_dercont'//char(0), ecp_dercont)
c--------------------------------------------------------------------
c VFL Instruction needed for restricted pardo  updated JULY 22012
c--------------------------------------------------------------------
      dummy = load_user_sub('init_section'//char(0),init_section)
      dummy = load_user_sub('prestrict'//char(0), prestrict)
      dummy = load_user_sub('doprestrict'//char(0),doprestrict)
c--------------------------------------------------------------------
c Jason Byrd misc. development additions
c--------------------------------------------------------------------
      dummy = load_user_sub('sort_fno'//char(0),sort_fno)
      dummy = load_user_sub('dropcore_fno'//char(0),dropcore_fno)
c--------------------------------------------------------------------
c--------------------------------------------------------------------
c Watson, added for general interfaces (ie. read FCIDUMP file for c Molpro)
c--------------------------------------------------------------------
c      dummy = load_user_sub('read_interface'//char(0),read_interface)
c      dummy = load_user_sub('get_interface'//char(0),get_interface)
c      call set_upgrade_flag(dummy)
      dummy = load_user_sub('c1_full_print'//char(0),c1_full_print)
      call set_upgrade_flag(dummy)
c--------------------------------------------------------------------
c
c
c--------------------------------------------------------------------
c- JNB  Explicitly-correlated part
c--------------------------------------------------------------------
      dummy = load_user_sub('f12_integrals'//char(0),
     *                       f12_integrals)
      dummy = load_user_sub('f12_c_coef'//char(0),
     *                       f12_c_coef)
      dummy = load_user_sub('mkexch'//char(0),
     *                       mkexch)
      dummy = load_user_sub('get_grid_size'//char(0),
     *                       get_grid_size)
      dummy = load_user_sub('grid_point_range'//char(0),
     *                       grid_point_range)
      dummy = load_user_sub('f12_2center_moobj'//char(0),
     *                       f12_2center_moobj)
      dummy = load_user_sub('f12_2center_mxobj'//char(0),
     *                       f12_2center_mxobj)
      dummy = load_user_sub('f12_2center_myobj'//char(0),
     *                       f12_2center_myobj)
      dummy = load_user_sub('f12_2center_mzobj'//char(0),
     *                       f12_2center_mzobj)
      dummy = load_user_sub('grid_point_weight'//char(0),
     *                       grid_point_weight)
      dummy = load_user_sub('int1_setup'//char(0),
     *                       int1_setup)
      dummy = load_user_sub('f12_1el_gen'//char(0),
     *                       f12_1el_gen)
      dummy = load_user_sub('energy_numerator'//char(0),
     *                       energy_numerator)
      dummy = load_user_sub('lindep_remove'//char(0),
     *                       lindep_remove)
c--------Equation-of-motion part---------------------------------------
      dummy = load_user_sub('eomiter'//char(0),eomiter)
      dummy = load_user_sub('eomdiag'//char(0),eomdiag)
      dummy = load_user_sub('eomchunk'//char(0),eomchunk)
      dummy = load_user_sub('eomnewvec'//char(0),eomnewvec)
      dummy = load_user_sub('eomovermax'//char(0),eomovermax)
      dummy = load_user_sub('eominitguess_ip'//char(0),eominitguess_ip)
      dummy = load_user_sub('eomcopyroots'//char(0),eomcopyroots)
      dummy = load_user_sub('apply_den1'//char(0),apply_den1)
      dummy = load_user_sub('apply_den3'//char(0),apply_den3) 
      dummy = load_user_sub('addrootindex'//char(0),addrootindex)
      dummy = load_user_sub('eomgetroot'//char(0),eomgetroot)
      dummy = load_user_sub('eomprintcorrnorm'//char(0),
     & eomprintcorrnorm)
      dummy = load_user_sub('setauxvec'//char(0),
     & setauxvec)
      dummy = load_user_sub('eomovertable'//char(0),eomovertable)
      dummy = load_user_sub('make_3body_diag_ip'//char(0),
     & make_3body_diag_ip)
      dummy = load_user_sub('eomtargetroot'//char(0),eomtargetroot)
      dummy = load_user_sub('eomiproots'//char(0),eomiproots) 
c -----------(T) correction for IP-EOMCC  ---------------------------------- 
      dummy = load_user_sub('denom_eomip_pt'//char(0),denom_eomip_pt)
      dummy = load_user_sub('apply_den5'//char(0),apply_den5)
c-------------frozen - orbital F12 calculation -----------------------------
      dummy = load_user_sub('frag_index_range'//char(0),
     &                                      frag_index_range)

c-----------------------f12 info--------------------------------------------
      dummy = load_user_sub('f12info'//char(0),f12info)
c

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
       subroutine cwork4442_unopt(y,na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                     a1,a2,b1,b2,c1,c2,d1,d2,inda, indb, 
     *                     indc, indd, x1,
     *                     ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,
     *                     e1,e2,f1,f2,g1,g2,h1,h2, 
     *                     indx1, x2,
     *                     ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                     i1,i2,j1,j2,k1,k2,l1,l2,
     *                     indx2, cind, flopcount, scr1, scr2) 
c-------------------------------------------------------------------------
c   Performs a "4442" contraction: 
c      4 index output array
c      4 index operand array
c      4 index operand array
c      2 index contraction.
c
c   I. e., contract two of the the 4 indices of the 2nd operand array out 
c   of the first operand array, replacing the indices by the 2nd operand's 
c   non-contracted indices.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ne1,ne2,nf1,nf2,
     *        ng1,ng2,nh1,nh2,
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2
      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2,g1,g2,h1,h2,
     *        i1,i2,j1,j2,k1,k2,l1,l2
      integer inda, indb, indc, indd, indx1(4), indx2(4), indi, indj
      integer cind(2), flopcount

      double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2)
      double precision scr1(*), scr2(*)

      integer ia, ib, ic, id, ix_con1, ix_con2, ix(4), ix2(4), iy
      integer ia2, ib2, ic2, id2
      integer ix2_con1, ix2_con2
      integer bcon1, bcon2, econ1, econ2
      integer i, j, a, b, c, d, e, f, g, h
      integer lda, ldb, ldc, m, n, k, l
      integer next
      double precision x2val, xval
      
      flopcount = 0

c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various y and x2 
c   indices.
c---------------------------------------------------------------------------

      ia = 0
      ib = 0
      ic = 0
      id = 0

      do i = 1, 4
         if (indx1(i) .eq. inda) then 
            ia = i 
         else if (indx1(i) .eq. indb) then
            ib = i 
         else if (indx1(i) .eq. indc) then
            ic = i
         else if (indx1(i) .eq. indd) then
            id = i
         else if (indx1(i) .eq. cind(1)) then
            ix_con1 = i
         else if (indx1(i) .eq. cind(2)) then
            ix_con2 = i 
         else
            print *,'Error: Invalid index for x1 in cwork4442'
            print *,'X1 index is ',indx1(i),' y indices: ',inda, indb,
     *              indc, indd,
     *              ' X1 indices: ',(indx1(j),j=1,4),
     *              ' cind = ',cind(1), cind(2) 
            call abort_job() 
         endif
      enddo

c---------------------------------------------------------------------------
c   Find which indices of the "x2" operand match the various y and x1
c   indices.
c---------------------------------------------------------------------------

      ia2 = 0
      ib2 = 0
      ic2 = 0
      id2 = 0

      do i = 1, 4
         if (indx2(i) .eq. inda) then 
            ia2 = i 
         else if (indx2(i) .eq. indb) then
            ib2 = i 
         else if (indx2(i) .eq. indc) then
            ic2 = i
         else if (indx2(i) .eq. indd) then
            id2 = i
         else if (indx2(i) .eq. cind(1)) then
            ix2_con1 = i
         else if (indx2(i) .eq. cind(2)) then
            ix2_con2 = i
         else
            print *,'Error: Invalid index for x2 in cwork4442'
            print *,'X2 index is ',indx2(i),' y indices: ',inda, indb,
     *              indc, indd,
     *              ' X2 indices: ',(indx2(j),j=1,4),
     *              ' cind = ',cind(1),cind(2)
            call abort_job() 
         endif
      enddo

      if (cind(1) .eq. indx1(1)) then
         bcon1 = e1
         econ1 = e2
      else if (cind(1) .eq. indx1(2)) then
         bcon1 = f1
         econ1 = f2
      else if (cind(1) .eq. indx1(3)) then
         bcon1 = g1
         econ1 = g2
      else if (cind(1) .eq. indx1(4)) then
         bcon1 = h1
         econ1 = h2
      endif

      if (cind(2) .eq. indx1(1)) then
         bcon2 = e1
         econ2 = e2
      else if (cind(2) .eq. indx1(2)) then
         bcon2 = f1
         econ2 = f2
      else if (cind(2) .eq. indx1(3)) then
         bcon2 = g1
         econ2 = g2
      else if (cind(2) .eq. indx1(4)) then
         bcon2 = h1
         econ2 = h2
      endif

      print *,'cwork4442: Unoptimized version lineno ',current_line
      do a = a1, a2
         if (ia .ne. 0) ix(ia)  = a
         if (ia2 .ne. 0) ix2(ia2) = a
      do b = b1, b2
         if (ib .ne. 0) ix(ib) = b
         if (ib2 .ne. 0) ix2(ib2) = b
      do c = c1, c2
         if (ic .ne. 0) ix(ic) = c
         if (ic2 .ne. 0) ix2(ic2) = c
      do d = d1, d2
         if (id .ne. 0) ix(id) = d
         if (id2 .ne. 0) ix2(id2) = d
         y(a,b,c,d) = 0.

         do j = bcon2, econ2
            ix(ix_con2) = j 
            ix2(ix2_con2) = j 
         do i = bcon1, econ1 
            ix(ix_con1) = i
            ix2(ix2_con1) = i
            y(a,b,c,d) = y(a,b,c,d) + 
     *             x2(ix2(1),ix2(2),ix2(3),ix2(4))*
     *             x1(ix(1),ix(2),ix(3),ix(4))
         enddo
         enddo
         
      enddo
      enddo
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__PRINT_BATCH
     +
     +                    ( N1,N2,N3,N4,
     +                      UNITID,
     +                      BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__PRINT_BATCH
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  DESCRIPTION : This routine prints a batch of integrals for testing
C                purposes. Up to 4-dimensional batches are accepted.
C
C
C                  Input:
C
C                    Nx           =  individual array dimensions for
C                                    all four indices x = 1,2,3,4
C                    UNITID       =  the unit identification # to which
C                                    the batch will be printed
C                    BATCH        =  the batch of integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         INTEGER     N1,N2,N3,N4
         INTEGER     I,J,K,L
         INTEGER     UNITID

         DOUBLE PRECISION  BATCH  (1:N1,1:N2,1:N3,1:N4)
C
C
C------------------------------------------------------------------------
C
C
C             ...print the batch to the unit specified.
C
C
         DO 10 L = 1,N4
         DO 10 K = 1,N3
         DO 10 J = 1,N2
         DO 10 I = 1,N1
            WRITE (UNITID,9999) ' [',I,J,'|',K,L,'] = ',BATCH (I,J,K,L)
   10    CONTINUE
 9999    FORMAT (A2,2I3,A1,2I3,A4,F20.10)
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_ATOM_COEFFICIENTS
     +
     +                    ( MIJ,MKL,MIJKL,
     +                      NGQP,MGQIJKL,
     +                      P,
     +                      PINVHF,QINVHF,PQPINV,
     +                      RTS,
     +                      CASE2D,
     +
     +                               B00,B01,B10 )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_ATOM_COEFFICIENTS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation evaluates the atomic VRR coefficients
C                for the 2D integrals for the present set of NGQP roots
C                corresponding to all i,j,k,l exponent quadruplets.
C
C
C                  Input:
C
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the csh pairs A,B (C,D)
C                    MIJKL        =  current # of ijkl primitive
C                                    index quadruplets (= MIJ*MKL)
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    MGQIJKL      =  # of roots times # of ijkl
C                                    quadruplets (= NGQP*MIJKL)
C                    P            =  current MIJ exponent sums for
C                                    csh A and B
C                    P(Q)INVHF    =  current MIJ (MKL) values of
C                                    1/(2*P(Q)), where P and Q are
C                                    the corresponding exponent sums
C                                    for csh A and B (C and D)
C                    PQPINV       =  current MIJKL values of 1/(P+Q)
C                    RTS          =  current MGQIJKL values of all
C                                    quadrature roots
C                    CASE2D       =  integer value within the range
C                                    from 1 to 9, indicating which
C                                    2D coefficient evaluation case
C                                    is present to trigger specific
C                                    simplified sections of the code
C
C                  Output:
C
C                    Bxx          =  the coordinate independent atomic
C                                    B-coefficients (xx=00,01,10)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         INTEGER   CASE2D
         INTEGER   IJ,KL
         INTEGER   M,N
         INTEGER   MIJ,MKL,MIJKL
         INTEGER   NG,NGQP,MGQIJKL

         DOUBLE PRECISION  PIJ
         DOUBLE PRECISION  PSCALE,QSCALE
         DOUBLE PRECISION  ROOT
         DOUBLE PRECISION  TWOP,TWOQ,TWOPQ
         DOUBLE PRECISION  HALF,ONE

         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  PINVHF (1:MIJ)
         DOUBLE PRECISION  QINVHF (1:MKL)

         DOUBLE PRECISION  PQPINV (1:MIJKL)

         DOUBLE PRECISION  B00  (1:MGQIJKL)
         DOUBLE PRECISION  B01  (1:MGQIJKL)
         DOUBLE PRECISION  B10  (1:MGQIJKL)
         DOUBLE PRECISION  RTS  (1:MGQIJKL)

         PARAMETER  (HALF  =  0.5D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 9 different cases that can arise:
C
C                  P-shell = s- ,p- or higher angular momentum
C                  Q-shell = s- ,p- or higher angular momentum
C
C                each leading to simplifications in the VRR formulas.
C                The case present has been evaluated outside this
C                routine and is transmitted via argument.
C
C
         GOTO (1,1,5,1,4,7,6,8,9) CASE2D
C
C
C             ...the cases: P = s-shell and Q = s-shell
C                           P = p-shell and Q = s-shell
C                           P = s-shell and Q = p-shell
C                (no coefficients here)
C
C
    1    RETURN
C
C
C             ...the case P = p-shell and Q = p-shell.
C                (here we know that NGQP = 2)
C
C
    4    N = 1
         DO 400 M = 1,MIJKL
            TWOPQ = HALF * PQPINV (M)
            B00 (N)   = RTS (N)   * TWOPQ
            B00 (N+1) = RTS (N+1) * TWOPQ
            N = N + 2
  400    CONTINUE

         RETURN
C
C
C             ...the case P > p-shell and Q = s-shell.
C
C
    5    M = 0
         N = 0
         DO 500 IJ = 1,MIJ
            PIJ = P (IJ)
            TWOP = PINVHF (IJ)
            DO 510 KL = 1,MKL
               M = M + 1
               QSCALE = ONE - PIJ * PQPINV (M)

               DO 520 NG = 1,NGQP
                  N = N + 1
                  B10 (N)= (ONE - QSCALE * RTS (N)) * TWOP
  520          CONTINUE

  510       CONTINUE
  500    CONTINUE

         RETURN
C
C
C             ...the case P = s-shell and Q > p-shell.
C
C
    6    M = 0
         N = 0
         DO 600 IJ = 1,MIJ
            PIJ = P (IJ)
            DO 610 KL = 1,MKL
               TWOQ = QINVHF (KL)
               M = M + 1
               PSCALE = PIJ * PQPINV (M)

               DO 620 NG = 1,NGQP
                  N = N + 1
                  B01 (N) = (ONE - PSCALE * RTS (N)) * TWOQ
  620          CONTINUE

  610       CONTINUE
  600    CONTINUE

         RETURN
C
C
C             ...the case P > p-shell and Q = p-shell.
C
C
    7    M = 0
         N = 0
         DO 700 IJ = 1,MIJ
            PIJ = P (IJ)
            TWOP = PINVHF (IJ)
            DO 710 KL = 1,MKL
               M = M + 1
               TWOPQ = HALF * PQPINV (M)
               QSCALE = ONE - PIJ * PQPINV (M)

               DO 720 NG = 1,NGQP
                  N = N + 1
                  ROOT = RTS (N)
                  B00 (N) = ROOT * TWOPQ
                  B10 (N) = (ONE - QSCALE * ROOT) * TWOP
  720          CONTINUE

  710       CONTINUE
  700    CONTINUE

         RETURN
C
C
C             ...the case P = p-shell and Q > p-shell.
C
C
    8    M = 0
         N = 0
         DO 800 IJ = 1,MIJ
            PIJ = P (IJ)
            DO 810 KL = 1,MKL
               TWOQ  = QINVHF (KL)
               M = M + 1
               TWOPQ = HALF * PQPINV (M)
               PSCALE = PIJ * PQPINV (M)

               DO 820 NG = 1,NGQP
                  N = N + 1
                  ROOT = RTS (N)
                  B00 (N) = ROOT * TWOPQ
                  B01 (N) = (ONE - PSCALE * ROOT) * TWOQ
  820          CONTINUE

  810       CONTINUE
  800    CONTINUE

         RETURN
C
C
C             ...the case P > p-shell and Q > p-shell.
C
C
    9    M = 0
         N = 0
         DO 900 IJ = 1,MIJ
            PIJ = P (IJ)
            TWOP = PINVHF (IJ)
            DO 910 KL = 1,MKL
               TWOQ  = QINVHF (KL)
               M = M + 1
               TWOPQ = HALF * PQPINV (M)
               PSCALE = PIJ * PQPINV (M)
               QSCALE = ONE - PSCALE

               DO 920 NG = 1,NGQP
                  N = N + 1
                  ROOT = RTS (N)
                  B00 (N) = ROOT * TWOPQ
                  B01 (N) = (ONE - PSCALE * ROOT) * TWOQ
                  B10 (N) = (ONE - QSCALE * ROOT) * TWOP
  920          CONTINUE

  910       CONTINUE
  900    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c INPUT
c int iPrt : a flag signifying whether to dump the ASVs to stdout
c            == 0; do not print
c            != 0; print

c OUTPUT
c int iErr : an error code
c            == 0; no error
c            != 0; error <- gtflgs just dies instead of returning
c int i1-i17 : JODAFLAG record(s)
c char BasNam : the name of the basis set

#include "iachar.h"

      SUBROUTINE ACES3_GTFLGS(iPrt,iErr,
     &                  BasNam)
      IMPLICIT NONE

cJDW 3/94.
c
c Modifications have been made to extend the number of input parameters.
c /FLAGS/ has been extended to 600. In GTFLGS we have ioppar(100 + 500),
c In other subroutines, /FLAGS/ consists of IFLAGS(100) and IFLAGS2(500).
c In this way, no code in other modules which uses IFLAGS will need to be
c altered. IFLAGS2 is written to JOBARC.
c (COMMON /FLAGS2/ IFLAGS2(500)).
c
c It is intended that JFS and JG will use locations 1-100 of IFLAGS2, while
c the RJB group (and contributors other than JFS and JG) will, coordinated
c by JDW, use locations 101-200. Note that
c location N of IFLAGS2 is location 100 + N of ioppar in GTFLGS. Since
c there will be some "holes" in ioppar and nParam has been set to 600.

c Other modifications/additions :
c
c 1a. EOM-EA code (MN) :
c
c    ioppar(h_IOPPAR_ea_calc), ioppar(h_IOPPAR_ea_sym),
c    and corresponding elements of other arrays;
c    EARoot(8,2) array; EA_IRREP JOBARC record.
c    See also cMN comment lines in code.
c
c 1b. EOM-IP code (MN) :
c
c    ioppar(h_IOPPAR_ip_calc), ioppar(h_IOPPAR_ip_sym) ioppar(216) and corresponding elements of
c    other arrays; IPRoot(8,2) array; IP_IRREP JOBARC record. See also cMN
c    comment lines in code.
c
c 1c. EOMREF FLAG (MN) ioppar(h_IOPPAR_eomref) : NONE, CCSD, MBPT(2)
c     SHOULD BE SET AUTOMATICALLY BY TYPE OF CALCULATION.
c
c 2. TDHF code (HS/WJL) :
c
c    ioppar(h_IOPPAR_tdhf) used for the TDHF flag (TDHF options still currently separate
c    namelist). See also CWJL comment lines in code.
c
c 3. Extensions for number of calculation types :
c
c    NCTYPE has been increased to 50 and some of elements 26-50 have been
c    defined. Availability arrays have been extended.
c
c 4. A trap has been put in which will stop the calculation if there are no
c    *'s in the Z-matrix but METHOD has been set to something other than
c    SINGLE_POINT.
c
c 5. A trap has been put in if TDHF is attempted for other than RHF.
c
c 6. Perturbed canonical orbitals are now default for QCISD(T) gradients.
c
c 7. Numerical optimiziations and numerical hessian calculations should not
c    any longer die if analytical gradients are not available (already was
c    done for UHF/RHF numerical optimizations).
c
c 8. HFDFT code (NO) :
c
c    ioppar(204) used for the HFDFT flag which specifies which functional
c    value will be placed in JOBARC as TOTENERG
c
c 9. ABCDFULL flag added. This flag is set if value is 0 on input ('unknown)
c    It determines if abcd integrals are compressed (=2) or not (=1)
c
cJDW  7/21/94. EOM_MAXCYC flag added (element 205; element 105 of flags2)
cJDW 11/ 3/94. EOMPROP, ABCDFULL, INTGRL_TOL flags added (206-208)
cJDW  1/13/95. DAMP_TYP, DAMP_TOL, LSHF_A1, LSHF_B1 flags added (209-212)
cJDW  1/23/95. POLYRATE flag added (213).
cJDW  6/ 6/95. Add arrays iEnAva3, iGrAva3 for TWODET availability. Also
c              logical bTDCalc.
cJDW  6/ 6/95. Rename TRIM to TRMBLK.
cJDW  6/ 6/95. Add options to Ajith's EOMPROP flag; include this option
c              in logic for determining ABCDFULL.
cJDW 10/23/95. NOREORI flag added (225). This is tentative and currently
c              will only be used for POLYRATE=ON and SYMMETRY=OFF. It is
c              used in subroutine SYMMETRY.
cJDW 10/23/95. A series of modifications/additions made by MN, SRG, and AP
c              have been incorporated :
c
c              Addition of JSC_ALL option to PROPERTY ( h_IOPPAR_props)
c              Addition of P-EOMEE and BWMBPT to EXCITE ( h_IOPPAR_excite)
c              Addition of options to EA_CALC (h_IOPPAR_ea_calc) and IP_CALC
c              Modification of EOMPROP keyword options (h_IOPPAR_eomprop)
c              Addition of keyword EE_SEARCH (219)
c              Addition of keyword EOM_PRJCT (220)
c              Addition of keyword NEWVRT    (h_IOPPAR_newvrt)
c              Addition of keyword HBARABCD  (h_IOPPAR_hbarabcd)
c              Addition of keyword HBARABCI  (h_IOPPAR_hbarabci)
c              Addition of keyword KS_POT    (h_IOPPAR_ks_pot)
c
c              Addition of logic to set HBARABCD, HBARABCI
cJDW 3/26/96.  Methods CC5SD(T), CCSD-T, CC3 defined by ioppar(h_IOPPAR_calc)=31,32,33.
c              NT3EOMEE flag introduced, ioppar(224).
cJDW 7/ 9/96.  Method CCSDT-T1T2 defined by ioppar(h_IOPPAR_calc)=34.
cJDW 3/26/97.  New option GRAD_CALC (h_IOPPAR_grad_calc). Takes over role of METHOD=6, so
c              we can do transition state searches with numerical gradients.
c
cMN 7/10/97. A number of changes to incorporate MN_A3 options.
c
c              EE_SYM (h_IOPPAR_ee_sym)   : NUMBER OF ROOTS PER SYMMETRY -> 2-2-2-2/2-2-2-2
c                                                               SINGLET TRIPLET
c THIS KEYWORD CAN REPLACE 'ACES2' ESTATE_SYM -> 2/2/2/2, BOTH CAN BE USED NOW.
c
c              DIP_CALC (h_IOPPAR_dip_calc) : DOUBLE IONIZATION POTENTIALS
c              DIP_SYM (h_IOPPAR_dip_sym)  : NUMBER OF ROOTS PER SYMMETRY -> 2-2-2-2/2-2-2-2
c              DEA_CALC (h_IOPPAR_dea_calc) : DOUBLE ATTAHMENT ENERGIES
c              DEA_SYM (h_IOPPAR_dea_sym)  : NUMBER OF ROOTS PER SYMMETRY -> 2-2-2-2/2-2-2-2
c              PROGRAM (h_IOPPAR_program)  : SPECIFIES ACES2 OR MN_A3, RECOMMENDED: DEFAULT=0
c              CCR12 (233)    : CC-R12 COEFFICIENTS ARE READ IN FROM J. NOGA
c              EOMXFIELD (234): ADD FIELD IN X DIRECTION (SEE ALSO 237)
c              EOMYFIELD (235): ADD FIELD IN Y DIRECTION (SEE ALSO 237)
c              EOMZFIELD (236): ADD FIELD IN Z DIRECTION (SEE ALSO 237)
c              INSERTF (237)  : SPECIFIES POINT AT WHICH TO INSERT FIELD
c              IMEM_SIZE (239): MEMORY USED AS PSEUDO-DISK (NOT USED)
c              MAKERHF (h_IOPPAR_makerhf)  : FORCES REFERENCE TO BE RHF AS REQUIRED IN MN_A3
c              ACC_SYM (247)  : DEFINES ACTIVE SPACE IN CCSD/MBPT(2) CALCULATION
c                                  OCCUPIED/VIRTUAL, E.G. 2-1-1-0/3-2-2-2
c
c   Addition of Makerhf flag: h_IOPPAR_makerhf
c   Forces the final reference (in CCSD) to
c   be RHF. Even if it is constructed in QRHF fashion. The user should be
c   sure that at al stages in the calculation we are dealing with a
c   closed shell. Dangerous keyword!!
c
cJDW 9/16/97. Changing the way PERT_ORB keyword (option h_IOPPAR_pert_orb) works.
c             Handling case of open-shell OCC and apparent REF=RHF.
cJDW 10/30/97. Adding GLOBAL_MEM keyword for use in parallel processing
c              (but don't bet the house on it). This is option 241 (141 of
c              IFLAGS2).
cKJW 01/17/98. Added FNO_KEEP keyword option 243 (143 of IFLAGS2)
c                    FNO_POST keyword option h_IOPPAR_fno_post (144 of IFLAGS2)
c
cKJW 06/03/98. Added FNO_ACTIVE keyword option 245 (145 of IFLAGS2)
cKJW 06/09/98. Added NATURAL keyword option 246 (146 of IFLAGS2)
c
c mn 11/07/98: UNO-REF option. Three keywords
c              UNO_REF   : option h_IOPPAR_uno_ref  (logical)
c              UNO_CHARGE: option 249  ( charge of redefined state)
c              UNO_MULT  : option 250  (multiplicity of
c                          redefined state, high spin)
c AP 07/06/98: RAMAN Option.
cKJW 09/17/99: KUCHARSKI : option 252 (run Stan Kucharski's cc code)
c AP 05/12/99: SCF : Option to specify the SCF type (HF, KS ...etc)
c AP 04/2006 : Logic pertinent to vib freqency calculations diretcly 
c              followed by a geometry optimization. 

c PARAMETERS
#include "io_units.par"
#include "fnamelen.par"
#include "linelen.par"
      integer    dim_iflags,     dim_iflags2
      parameter (dim_iflags=100, dim_iflags2=500)
      INTEGER    nParam
      PARAMETER (nParam = 100 + 500)
      INTEGER    NCTYPE
      PARAMETER (NCTYPE = 50)
c     the number of ints in JODAFLAG
      INTEGER    JPARAM
      PARAMETER (JPARAM = 17)
      INTEGER    nIrMax
      PARAMETER (nIrMax = 8)
      character*4 nl_delims
      parameter  (nl_delims=',;&|')
c This can hold 8x3 64-bit integers/floats (or 192 characters)
      integer    DataSize
      parameter (DataSize = 192)

c ARGUMENTS
      integer iPrt, iErr
      integer i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,i15,i16,i17
      CHARACTER*(*) BasNam

c EXTERNAL FUNCTIONS
      INTEGER FNBLNK,LINBLNK,f_strpbrk
      CHARACTER*(linelen) TRMBLK
      CHARACTER*1 achar
      LOGICAL leq

c INTERNAL VARIABLES
      integer i, j
c     value tokens of arrays
      INTEGER nOcc(8,2),nDrop(2),iDrop(1000,2),iArr(1000)
      INTEGER EARoot(8,2), IPRoot(8,2), EERoot(8,3)
c     absolute file names from gfname
      CHARACTER*(fnamelen) FNAME
c     State Variable index returned from asv_update_kv
      integer iASV
c     logical flags
      logical bExist_JOBARC, bStar, bCCSDT3, bCompress,
     &        bTDCalc, DoABCD, DoABCI, ACES2, bMN_A3, DoQRHF, bSTEOM,
     &        EOM, bGeomOpt, bTDA, bOpenShell
      logical bOpened, bTmp, bDone, bDelLastChar, bHaveKeys, bVerbose
      logical bAutoCart, NO_AGRAD
c     character constants
      character*1 czPercent, czAsterisk, czHash, czSpace, czFirstNLChar
      character*1 czTab
c throwing implicit ints together
      integer iLength, iLine, iLines, ipt, irecal, iSpin, iUHF,
     &        nIrr, nIrrps, ndrgeo,i_havegeom, i_length, iversion
c     statistics for value tokens and line processing
      character*(linelen)  wrk, wrk2, szTmp
      character*(DataSize) szData
      integer iLastC, iOpenP, iCloseP, ValueSize, icycle

c pseudo-registers (one-time temporary integers)
      integer iTmpReg1,  iTmpReg2,  iTmpReg3,  iTmpReg4,  iTmpReg5,
     &        iTmpReg6,  iTmpReg7,  iTmpReg8,  iTmpReg9,  iTmpReg10,
     &        iTmpReg11, iTmpReg12, iTmpReg13, iTmpReg14, iTmpReg15,
     &        iTmpReg16, iTmpReg17, iTmpReg18, iTmpReg19, iTmpReg20,
     &        iTmpReg21, iTmpReg22, iTmpReg23, iTmpReg24, iTmpReg25,
     &        iTmpReg26, iTmpReg27, iTmpReg28, iTmpReg29, iTmpReg30,
     &        iTmpReg31, iTmpReg32, iTmpReg33, iTmpReg34, iTmpReg35

c COMMON BLOCKS
      INTEGER        NX,NXM6,IARCH,NCYCLE,NUNIQUE,NOPT
      COMMON /USINT/ NX,NXM6,IARCH,NCYCLE,NUNIQUE,NOPT
#define MONSTER_FLAGS /* use ioppar */
#include "jodaflags.com"
#include "machsp.com"

c ----------------------------------------------------------------------

c DECLARATIONS AND DATA STATEMENTS

c energy, gradient, and hessian availabilities for each method (technically,
c also part of some predefined structure)
      INTEGER iEnAva1(0:NCTYPE),iEnAva2(0:NCTYPE),iEnAva3(0:NCTYPE),
     &        iGrAva1(0:NCTYPE),iGrAva2(0:NCTYPE),iGrAva3(0:NCTYPE),
     &        iHsAva1(0:NCTYPE),iHsAva2(0:NCTYPE)
c RHF-UHF ENERGY CALCULATION AVAILABILITY
      DATA iEnAva1 /1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,0,0,
     &     1,1,1,1,1,
     &     1,1,0,1,0, 1,1,1,1,1, 1,1,1,1,1, 1,1,0,0,0,
     &     0,0,0,0,0/
c ROHF ENERGY CALCULATION AVAILABILITY
      DATA iEnAva2 /1, 1,1,1,1,0, 0,0,0,0,1, 0,0,1,1,0, 1,1,1,0,0,
     &     0,1,0,1,1,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 1,1,0,0,0,
     &     0,0,0,0,0 /
c TWO-DETERMINANT ENERGY CALCULATION AVAILABILITY
      DATA iEnAva3 /0, 0,0,0,0,0, 0,0,0,0,1, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 1,0,0,0,0,
     &     0,0,0,0,0 /
c RHF-UHF GRADIENT AVAILABILITY
      DATA iGrAva1 /1, 1,1,1,1,0, 0,1,1,1,1, 1,0,0,0,0, 0,0,0,0,0,
     &     1,1,1,0,0,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0/
c ROHF GRADIENT AVAILABILITY
      DATA iGrAva2 /1, 1,1,1,1,0, 0,0,0,0,1, 1,0,0,0,0, 0,0,0,0,0,
     &     0,1,0,0,0,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0/
c TWO-DETERMINANT GRADIENT CALCULATION AVAILABILITY
      DATA iGrAva3 /0, 0,0,0,0,0, 0,0,0,0,1, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 1,0,0,0,0,
     &     0,0,0,0,0 /
c RHF/UHF HESSIAN AVAILABILITY
      DATA iHsAva1 /1, 1,1,1,1,0, 0,0,1,0,1, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,1,0,0,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0/
c ROHF HESSIAN AVAILABILITY
      DATA iHsAva2 /1, 1,0,0,0,0, 0,0,0,0,1, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0,
     &     0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &     0,0,0,0,0/

c ----------------------------------------------------------------------

c   o define character constants
      czAsterisk = achar(_IACHAR_ASTERISK)
      czPercent  = achar(_IACHAR_PERCENT)
      czSpace    = achar(_IACHAR_SPACE)
      czHash     = achar(_IACHAR_HASH)
      czTab      = achar(_IACHAR_TAB)

c ----------------------------------------------------------------------

c   o get the external file name for JOBARC and see if it exists
      call gfname('JOBARC',fname,iLength)
      inquire(file=fname(1:iLength),exist=bExist_JOBARC)

c   o only print the logs and summaries on the first run
      call GetRec(1,'JOBARC','FIRSTRUN',1,iTmpReg1)
      if (iTmpReg1.eq.0) then
         bVerbose = .false.
         call asv_hush
      else
         bVerbose = .true.
      end if

      call putrec(1,'JOBARC','STGF12',1,0)

c   o nIrrps tracks the number of irreps in all of the user's value
c     tokens. Originally, we would load COMPNIRR from JOBARC, but this
c     method fails if a low-order point group finished running in a
c     finite difference calculation.
c      if (bExist_JOBARC) then
c         call igetrec(-1,'JOBARC','COMPNIRR',1,iTmpReg1)
c      else
c         iTmpReg1 = 0
c      end if
c      nIrrps = iTmpReg1
      nIrrps = 0

c   o initialize the occupation values
      do i = 1, 16
         nOcc(i,1) = 0
      enddo

c   o initialize the dropmo values
      do i = 1, 2000
         iDrop(i,1) = 0
      enddo

      nDrop(1) = 0
      nDrop(2) = 0

c   o initialize the IP and EA irrep values
      do i = 1, 16
         EARoot(i,1) = 0
         IPRoot(i,1) = 0
      enddo

      nIrr = 8
      call iputrec(-1,'JOBARC','EA_IRREP',1,nIrr)
      call iputrec(-1,'JOBARC','IP_IRREP',1,nIrr)

      iErr = 0

c ----------------------------------------------------------------------

c LOCATE THE ACES/CRAPS NAMELIST AND COUNT THE NUMBER OF LINES IN IT

c   o open and rewind ZMAT
      inquire(file=ZFil,opened=bOpened)
      if (.not.bOpened) then
         open(unit=LUZ,file=ZFil,form='FORMATTED',status='OLD')
      end if
      rewind(luz)

c   o skip the header
      bTmp = .true.
      do while (bTmp)
         read(luz,'(a)',err=8000) wrk
         i = fnblnk(wrk)
         if (i.ne.0) then
            bTmp = (wrk(i:i).eq.czPercent).or.(wrk(i:i).eq.czHash)
         end if
      end do
c     WRK now holds the title line

c   o read the first atom line and toggle INTERNAL/CARTESIAN coordinates
      read(luz,'(a)',err=8000,end=5400) wrk
      i = 1
      do while (i.lt.80.and.
     &          (wrk(i:i).eq.czSpace.or.wrk(i:i).eq.czTab))
         i = i + 1
      end do
c     [ i=80 || wrk(i:i)!=whitespace ]
      do while (i.lt.80.and.wrk(i:i).ne.czHash.and.
     &          (wrk(i:i).ne.czSpace.and.wrk(i:i).ne.czTab))
         i = i + 1
      end do
c     [ i=80 || wrk(i:i)=whitespace || wrk(i:i)=hash ]
      do while (i.lt.80.and.
     &          (wrk(i:i).eq.czSpace.or.wrk(i:i).eq.czTab))
         i = i + 1
      end do
c     [ i=80 || wrk(i:i)!=whitespace ]
      bAutoCart = (wrk(i:i).ne.czHash.and.
     &             (wrk(i:i).ne.czSpace.and.wrk(i:i).ne.czTab))
c      if (bAutoCart) print *, '@GTFLGS: These are Cartesians.'

c   o skip the system definition but scan the lines for an asterisk
c     (which would denote a geometry optimization)
      bStar = .false.
      bTmp  = .true.
      do while (bTmp)
         read(luz,'(a)',err=8000,end=5400) wrk
         i = fnblnk(wrk)
         if (i.ne.0) then
            if (wrk(i:i).eq.czAsterisk) then
               bTmp = .false.
            else
c            o stop at the first * or # (thus ignoring *'s in comments)
               i = f_strpbrk(wrk,czAsterisk//czHash)
               if (i.ne.0) then
                  bStar = bStar .or. (wrk(i:i).eq.czAsterisk)
               end if
            end if
         end if
      end do
c     WRK now holds line 1 of the first namelist

c   o skip to the ACES2/CRAPS namelist
      bTmp = .true.
      do while (bTmp)
         if ( (wrk(i:(i+5)).eq.'*ACES2') .or.
     &        (wrk(i:(i+5)).eq.'*CRAPS')      ) then
            bTmp = .false.
         else
            i = 0
            do while (i.eq.0)
               read(luz,'(a)',err=8000,end=5400) wrk
               i = fnblnk(wrk)
               if (i.ne.0) then
                  if (wrk(i:i).ne.czAsterisk) i = 0
               end if
            end do
         end if
      end do

c   o While we're counting lines, record the first and last characters
c     for future reconditioning.
      czFirstNLChar = czSpace
      bDelLastChar  = .false.

c   o count the number of lines with keywords on them
c     There are three ways to terminate the ACES2/CRAPS namelist:
c      - there is an unpaired close parenthesis, ')'
c      - an asterisk is the first non-blank character on the line
c      - the end-of-file is reached
      iLines = 1
      bDone  = .false.
      do while (.not.bDone)

c      o recondition the test string and point to the first char
c        (both in the namelist, with czFirstNLChar, and in the line, with i)
         iLastC = index(wrk,czHash)
         if (iLastC.eq.0) then
            wrk2 = trmblk(wrk)
            wrk  = wrk2
            i    = fnblnk(wrk)
         else
c         o pure comments will not terminate the namelist
            i = 1
            if (iLastC.eq.1) then
               wrk = ' '
            else
               wrk2 = trmblk(wrk(1:iLastC-1))
               wrk  = wrk2
            end if
         end if
         if (czFirstNLChar.eq.czSpace) then
            if (iLines.eq.1) then
               j = 6+fnblnk(wrk(7:))
               if (j.ne.6) czFirstNLChar = wrk(j:j)
            else
               j = fnblnk(wrk)
               if (j.ne.0) czFirstNLChar = wrk(j:j)
            end if
         end if

c      o test for a (totally) blank line or a new namelist after the first line
c        (EOF automatically jumps)
         if (i.ne.0) then
            bTmp = (wrk(i:i).eq.czAsterisk)
         else
            bTmp = .false.
         end if
         if ((i.eq.0).or.((iLines.ne.1).and.bTmp)) then
c         o read too far -> jump back and quit counting
            backspace(luz)
            iLines = iLines - 1
            bDone  = .true.
c         o Did we accidentally record an asterisk for the first char of
c           an empty namelist?
            if (czFirstNLChar.eq.czAsterisk) czFirstNLChar = czSpace

         else
c         o wrk has no comments and may be empty (denoting a pure comment
c           in the namelist, which won't terminate parsing)
            iCloseP = index(wrk,')')
            if (iCloseP.eq.0) then
c            o no ')' -> keep going
c              (NOTE: we will check for multiple, unmatched '(' during the
c                     key-value tokenization)
               read(luz,'(a)',end=8012) wrk
               iLines = iLines + 1

c           else if (iCloseP.ne.0) then
            else
c            o measure the parenthetical level (j) from the beginning (i)
               i = 0
               if (iLines.eq.1) then
                  j = 0
               else
c               o This may seem strange, but we have to convince the logic
c                 after the parenthetical count that we are still in the
c                 namelist. If we encounter a closing ')', then we will test
c                 czFirstNLChar to see if it is '('.
                  j = 1
               end if

               iTmpReg2 = f_strpbrk(wrk,'()')
               do while (iTmpReg2.ne.0)

                  i = i + iTmpReg2
                  if (wrk(i:i).eq.'(') then
                     j = j + 1
                  else
                     j = j - 1
                  end if

                  if (i.lt.len(wrk)) then
                     iTmpReg2 = f_strpbrk(wrk(i+1:),'()')
                  else
                     iTmpReg2 = 0
                  end if

c              end do while ([have more parentheses])
               end do

c            o no more parentheses
               if (j.eq.0) then
c               o we should be done with the namelist, but is there any data
c                 after the last ')'?
                  if (i.lt.len(wrk)) then
                     iTmpReg3 = fnblnk(wrk(i+1:))
                     if (iTmpReg3.ne.0) then
                        print *, '@GTFLGS: ERROR - ',
     &         'data found after the terminal ")" in the ACES namelist:'
                        print *, wrk
                        call errex
                     end if
                  end if
c               o since a final ')' was found, make sure the namelist was
c                 started with a '('
                  if (czFirstNLChar.ne.'(') then
                     print *, '@GTFLGS: ERROR - ")" terminates the ',
     &                        'namelist but "(" does not initiate it.'
                     call errex
                  end if
                  bDelLastChar = .true.
                  bDone = .true.

c              else if (j.ne.0) then
               else

                  if (j.eq.1) then
c                  o we should still be somewhere in the namelist
                     read(luz,'(a)',end=8012) wrk
                     iLines = iLines + 1
                  else
                     print *, '@GTFLGS: Error - ',
     &                        'open parentheses in the ACES namelist:'
                     print *, wrk
                     call errex
                  end if

c              end if (j.eq.0)
               end if

c           end if (iCloseP.eq.0)
            end if

c        end if ([blank line].or.[new namelist])
         end if
c     end do while (.not.bDone)
      end do

c   o EOF end jump
 8012 continue

c   o If the namelist is empty, then stop.
      if ((iLines.eq.1).and.(czFirstNLChar.eq.czSpace)) then
         print *, '@GTFLGS: ACES will not run with an empty namelist.'
         call errex
      end if

c ----------------------------------------------------------------------

c PARSE THE ACES NAMELIST

c   o return to the beginning of the namelist
c      print *, 'DEBUG: Lines in namelist = ',iLines
      do i = 1, iLines
         backspace(luz)
      end do

c   o print the ASV registration header
      if (bVerbose) then
         print '(/)'
         print *, '    ',
     &   '                 ACES STATE VARIABLE REGISTRATION LOG'
         print *, '    ', ('-',iTmpReg4=1,70)
      end if

c   o initialize flags to default values
c      call asv_update_kv(achar(0),iASV,wrk,0)
      call init_flags()
      bHaveKeys = .false.

c   o loop over the number of lines
      do iLine = 1, iLines
         read(luz,'(a)') wrk

c      o recondition the token string
         iLastC = index(wrk,czHash)
         if (iLastC.eq.1) then
            wrk = ' '
         else
            if (iLastC.eq.0) then
               wrk2 = trmblk(wrk)
            else
               wrk2 = trmblk(wrk(1:iLastC-1))
            end if
            if (iLine.eq.1) then
c            o throw out the name of the namelist
               wrk  = wrk2(7:)
               wrk2 = trmblk(wrk)
            end if
c         o throw out an opening '('
c           The only time an open parenthesis should appear in the namelist
c           before a key token is in the first line, so this condition should
c           be valid.
            if (f_strpbrk('(',wrk2(1:1)).ne.0) wrk2(1:1) = czSpace
            if ((iLine.eq.iLines).and.bDelLastChar) then
               iTmpReg5 = linblnk(wrk2)
               wrk2(iTmpReg5:iTmpReg5) = czSpace
            end if
            wrk = trmblk(wrk2)
         end if
         wrk2 = wrk

c      print *, 'DEBUG: Attempting to parse'
c      print *, wrk

c      o loop over boolean and key-value tokens
c        (ipt is the roving pointer. It will never point to a delimiter.)
         ipt = fnblnk(wrk)
         bDone = (ipt.eq.0)
         do while (.not.bDone)

            if (ipt.gt.len(wrk)) then
               bDone = .true.
               goto 101
            end if

c         o get off a delimiter and skip empty sets (like ",, ,  ,")
            iTmpReg6 = f_strpbrk(nl_delims,wrk(ipt:ipt))
            do while (iTmpReg6.ne.0)
               ipt = ipt + 1
               if (ipt.gt.len(wrk)) then
                  bDone = .true.
                  goto 101
               end if
               iTmpReg6 = fnblnk(wrk(ipt:))
               if (iTmpReg6.ne.0) then
                  ipt  = ipt-1 + iTmpReg6
                  iTmpReg6 = f_strpbrk(nl_delims,wrk(ipt:ipt))
               end if
            end do

c         o find the next delimiter (boolean) or '=' (kvpair)
            iTmpReg7 = f_strpbrk(wrk(ipt:),nl_delims//'=')
            if (iTmpReg7.eq.0) then
c            o check for a final boolean key token
               iTmpReg8 = fnblnk(wrk(ipt:))
               if (iTmpReg8.ne.0) then
                  iLastC = linblnk(wrk)
                  call asv_update_kv(wrk(ipt:iLastC)//achar(0),iASV,
     &                               szData,0)
                  bHaveKeys = .true.
               end if
               bDone = .true.
               goto 101
            else
               iTmpReg9 = ipt-1 + iTmpReg7
               if (wrk(iTmpReg9:iTmpReg9).eq.'=') then
c               o find the end of the value token (beware empty keys)
                  if (iTmpReg9.eq.ipt) then
                     print *, '@GTFLGS: Missing key token.'
                     print *, wrk
                     call errex
                  end if
                  if (iTmpReg9.eq.len(wrk)) then
                     print *, '@GTFLGS: Missing value token.'
                     print *, wrk
                     call errex
                  end if
                  j = f_strpbrk(wrk(iTmpReg9+1:),nl_delims)
                  if (j.eq.0) then
                     iLastC = linblnk(wrk)
                  else
                     iLastC = iTmpReg9+j-1
                  end if
c               o pass only the key-value tokens to the ASV updater
                  szTmp = wrk(ipt:iLastC)//achar(0)
                  ValueSize = DataSize
cOLD                  call asv_update_kv(szTmp,iASV,szData,ValueSize)
                  call asv_update_kv(wrk(ipt:iLastC)//achar(0),iASV,
     &                               szData,ValueSize)
c               o point to the next key token
                  ipt = iLastC + 2
               else
c               o process the boolean and point to the next key token
                  call asv_update_kv(wrk(ipt:iTmpReg9-1)//achar(0),iASV,
     &                               szData,0)
                  bHaveKeys = .true.
                  ipt = iTmpReg9 + 1
                  goto 101
               end if
            end if

c         o What do we do if the ASV is not recognized: die or skip?
            if (iASV.eq.0) call errex
            bHaveKeys = .true.
c            if (iASV.eq.0) goto 101

c         o Now, process the ASV if it is of type string, array, or double
c           This is not at all efficient in the sense that we if/endif
c           for EVERY ASV, but since Fortran has no switch/case construct,
c           we will deal with self-contained if/endif blocks. You could
c           drop a 'goto 101' at the end of each block, but this might
c           impair performance (as if it counts at this point).

c         o Note: A few ASVs take data up to the maximum number of allowable
c           irreps. OCCUPATION and IP_SYM are two such ASVs. nIrrps is
c           initialized to zero. The first irrep-defining key that is read
c           will set this value. All others will test against it and pass
c           or fail.

c         o BASIS
            if (iASV.eq.h_IOPPAR_basis) then
               if (leq(szData(1:ValueSize),'SPECIAL')) then
                  ioppar(h_IOPPAR_basis) = 0
               else
                  BasNam = szData(1:ValueSize)
                  ioppar(h_IOPPAR_basis) = 1
                  iTmpReg10 = 1+ValueSize
                  call iputrec(1,'JOBARC','BASNAMLN',1,iTmpReg10)
                  call putcrec(1,'JOBARC','BASISNAM',iTmpReg10,BasNam)
               end if
               goto 101
            end if

c---------Explicitly-correlated calculation option----------------------
            if (iASV.eq.h_IOPPAR_stgf12) then
              if (ioppar(h_IOPPAR_stgf12).eq.1) then
              call putrec(1,'JOBARC','STGF12',1,1)
              else
              call putrec(1,'JOBARC','STGF12',1,0)
              endif
              goto 101
            endif
c-----------------------------------------------------------------------

c YAU - add a conditional for SUBGROUP that sets nIrrps

c         o OCCUPATION
            if (iASV.eq.h_IOPPAR_occ) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             nOcc,8,2)
               ioppar(h_IOPPAR_occ) = iSpin
               goto 101
            end if

c         o MN_A3 symmetry arrays
            if (iASV.eq.h_IOPPAR_ea_sym) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             EARoot,8,2)
               call PutRec(-1,'JOBARC','EA_IRREP',1,nIrrps)
               ioppar(h_IOPPAR_ea_sym) = iSpin
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_ip_sym) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             IPRoot,8,2)
               call PutRec(-1,'JOBARC','IP_IRREP',1,nIrrps)
               ioppar(h_IOPPAR_ip_sym) = iSpin
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_ee_sym) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             EERoot,8,3)
               call iputrec(20,'JOBARC','EESYM_A ',8,EERoot(1,1))
               call iputrec(20,'JOBARC','EESYM_B ',8,EERoot(1,2))
               call iputrec(20,'JOBARC','EESYM_C ',8,EERoot(1,3))
               call iputrec(20,'JOBARC','ICOUNT  ',1,nIrrps)
               call iputrec(20,'JOBARC','EESYMINF',nIrrps,EERoot(1,1))
               ioppar(h_IOPPAR_ee_sym) = iSpin
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_dip_sym) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             EERoot,8,3)
               call iputrec(20,'JOBARC','DIPSYMA ',8,EERoot(1,1))
               call iputrec(20,'JOBARC','DIPSYMB ',8,EERoot(1,2))
               call iputrec(20,'JOBARC','DIPSYMC ',8,EERoot(1,3))
               ioppar(h_IOPPAR_dip_sym) = iSpin
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_dea_sym) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             EERoot,8,3)
               call iputrec(20,'JOBARC','DEASYMA ',8,EERoot(1,1))
               call iputrec(20,'JOBARC','DEASYMB ',8,EERoot(1,2))
               call iputrec(20,'JOBARC','DEASYMC ',8,EERoot(1,3))
               ioppar(h_IOPPAR_dea_sym) = iSpin
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_acc_sym) then
               call parse_irp_iarr(szData(1:ValueSize),nIrrps,iSpin,
     &                             EERoot,8,2)
               call iputrec(20,'JOBARC','CCSYM_O ',8,EERoot(1,1))
               call iputrec(20,'JOBARC','CCSYM_V ',8,EERoot(1,2))
               ioppar(h_IOPPAR_acc_sym) = iSpin
               goto 101
            end if

c         o DROPMO
            if (iASV.eq.h_IOPPAR_dropmo) then
               call parse_set_iarr(szData(1:ValueSize),j,iDrop,2000)
               nDrop(1) = j
               ioppar(h_IOPPAR_dropmo) = j
               goto 101
            end if

c         o FD_IRREPS
            if (iASV.eq.h_IOPPAR_fd_irreps) then
               call parse_set_iarr(szData(1:ValueSize),j,iArr,1000)
               call iputrec(20,'JOBARC','NFDIRREP',1,j)
               call iputrec(20,'JOBARC','FDIRREP ',j,iArr)
               ioppar(h_IOPPAR_fd_irreps) = j
               goto 101
            end if

c         o ESTATE_SYM
            if (iASV.eq.h_IOPPAR_estate_sym) then
               call parse_set_iarr(szData(1:ValueSize),j,iArr,8)
               call iputrec(20,'JOBARC','ICOUNT  ',1,j)
               call iputrec(20,'JOBARC','EESYMINF',j,iArr)
               if (j.lt.8) then
                  do i = 1, 8-j
                     iArr(j+i) = 0
                  enddo
               endif
               call iputrec(20,'JOBARC','EESYM_A ',8,iArr)
               do i = 1, 8
                  iArr(i) = 0
               enddo
               call iputrec(20,'JOBARC','EESYM_B ',8,iArr)
               call iputrec(20,'JOBARC','EESYM_C ',8,iArr)
               ioppar(h_IOPPAR_estate_sym) = j
               goto 101
            end if

c         o QRHF orbital arrays
            if (iASV.eq.h_IOPPAR_qrhf_gen) then
               call parse_set_iarr(szData(1:ValueSize),j,iArr,1000)
               call iputrec(20,'JOBARC','QRHFTOT ',1,j)
               call iputrec(20,'JOBARC','QRHFIRR ',j,iArr)
               ioppar(h_IOPPAR_qrhf_gen) = j
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_qrhf_orb) then
               call parse_set_iarr(szData(1:ValueSize),j,iArr,1000)
               call iputrec(20,'JOBARC','QRHFLOC ',j,iArr)
               ioppar(h_IOPPAR_qrhf_orb) = j
               goto 101
            end if
            if (iASV.eq.h_IOPPAR_qrhf_spin) then
               call parse_set_iarr(szData(1:ValueSize),j,iArr,1000)
               call iputrec(20,'JOBARC','QRHFSPN ',j,iArr)
               ioppar(h_IOPPAR_qrhf_spin) = j
               goto 101
            end if

  101       continue
c        end do while (.not.bDone) <- more bools or kvpairs left on line
         end do

c     end do iLine = 1, iLines
      end do

c   o print the ASV registration footer
      if (bVerbose) print *, '    ', ('-',iTmpReg10=1,70)

c   o If the namelist is empty, then stop.
      if (.not.bHaveKeys) then
         print *, '@GTFLGS: ACES will not run with an empty namelist.'
         call errex
      end if

c ----------------------------------------------------------------------

c IMMEDIATE DEATH!!!

c   o If the reference is not RHF, make sure OCC has both spins defined.
c     (Would it be so unreasonable to simply copy the alpha occs into beta?)
      if (ioppar(h_IOPPAR_ref).ne.0.and.
     &    ioppar(h_IOPPAR_occ).eq.1     ) then
          print *, '@GTFLGS: OCCUPATION must define both alpha and beta'
          print *, '         spins, since the reference is not spin ',
     &             'restricted.'
          close(unit=luz,status='KEEP')
          call errex
      end if

c   o two QRHF keys are dependent on qrhf_gen
      if (ioppar(h_IOPPAR_qrhf_orb).ne.0                        .and.
     &    ioppar(h_IOPPAR_qrhf_orb).ne.ioppar(h_IOPPAR_qrhf_gen)
     &   ) then
         print *, '@GTFLGS: The number of orbitals listed in QRHF_ORB',
     &            ' is not the same as'
         print *, '         the number of orbitals listed in QRHF_GEN.'
         call errex
      end if
      if (ioppar(h_IOPPAR_qrhf_spin).ne.0                        .and.
     &    ioppar(h_IOPPAR_qrhf_spin).ne.ioppar(h_IOPPAR_qrhf_gen)
     &   ) then
         print *, '@GTFLGS: The number of orbitals listed in QRHF_SPIN',
     &            ' is not the same as'
         print *, '         the number of orbitals listed in QRHF_GEN.'
         call errex
      end if

c ----------------------------------------------------------------------

c VALIDATE THE ASVs...

c   o print the ASV validation header
      if (bVerbose) then
         print '(/)'
         print *, '    ',
     &   '                  ACES STATE VARIABLE VALIDATION LOG'
         print *, '    ', ('-',iTmpReg11=1,70)
      end if

c   o set the default BASIS string
      if (ioppar(h_IOPPAR_basis).eq.0) BasNam='SPECIAL'

c   o identify the type of coordinates
      if (ioppar(h_IOPPAR_coordinates).eq.3) then
         if (bAutoCart) then
            szTmp = 'COORDINATES=CARTESIAN'//achar(0)
         else
            szTmp = 'COORDINATES=INTERNAL'//achar(0)
         end if
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c   o convert CALC aliases
      if (ioppar(h_IOPPAR_calc).eq.43.or.
     &    ioppar(h_IOPPAR_calc).eq.44    ) then
         if      (ioppar(h_IOPPAR_calc).eq.43) then
            call asv_update_kv('CALC=CCSD(T)'//achar(0),iASV,szData,0)
            call asv_update_kv('KUCHARSKI'//achar(0),iASV,szData,0)
         else if (ioppar(h_IOPPAR_calc).eq.44) then
            call asv_update_kv('CALC=CCSDT'//achar(0),iASV,szData,0)
            call asv_update_kv('KUCHARSKI'//achar(0),iASV,szData,0)
         else
            print *, '@GTFLGS: logic error at line ',__LINE__
            call errex
         end if
      end if

cJDW 9/16/97 Before too long, let's try to get a block of code which sets
c            reference and related keywords all in one place. Then we
c            can understand it better !
c
cMN MAKE RHF REFERENCE !!!
cMN      if (ioppar(h_IOPPAR_makerhf).eq.1) ioppar(h_IOPPAR_ref) = 0

c   o was QRHF_GENERAL set?
      if (ioppar(h_IOPPAR_qrhf_gen).ne.0) then
         call asv_update_kv('NON-HF'//achar(0),iASV,szData,0)
         DoQRHF = .true.
      else
         DoQRHF = .false.
      end if

      if (ioppar(h_IOPPAR_ref).ge.3) then
         call PutRec(20,'JOBARC','OSCALC  ',1,1)
         szTmp = 'REF=UHF'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         bTDCalc = .true.
      else
         bTDCalc = .false.
      end if

c NOW HAVE FINISHED READING IN THE STUFF.  MAKE SURE THAT MANDATORY
c  DEPENDENCIES ARE TAKEN CARE OF.  THIS BRANCH IS ALSO MADE IF THE
c  STRING IS READ IN THE OLD INTEGER LIST FORMAT.
c******************************************************************
c
c Ajith 03/2000, A bug fix to get the QRHF back on track!
c When ioppar(h_IOPPAR_makerhf) is turned on, Marcel would use RHF
c type structure (both Alpha and Beta have the same eigen
c vectors). However, if it is a normal QRHF calcualtion we
c need to force to be ROHF so that other NON-HF flags will
c get set properly. ioppar(h_IOPPAR_makerhf) is off by default. The
c other thing to worry about is the two determinant CC methods
c wich use QRHF key-word to specify the appropriate configurations.
c We can not run two determinant CC as ROHF since that would
c turn on the semi-canonical flag. The following logic will
c satisfy all the requirments and produce correct results for
c QRHF and two determinant calculations. Warning! The changes
c like these should be made with exterme caution and by only
c people who know what they are doing.

c If two determinant, turn it back to UHF. The orbital invariance
c of two determinant CC is a complicated issue. Please consult
c an expert if you have questions about these issues!
      if (DoQRHF) then
         if (ioppar(h_IOPPAR_makerhf).ne.0) then
            do i = 1, nIrMax
               nOcc(i,2) = nOcc(i,1)
            end do
         end if
         if (bTDCalc) then
            szTmp = 'REF=UHF'//achar(0)
         else
            szTmp = 'REF=ROHF'//achar(0)
         end if
         call asv_update_kv(szTmp,iASV,szData,0)
         iSpin = 2
      end if

      if (ioppar(h_IOPPAR_joda_print).gt.999) then
         szTmp = 'JODA_PRINT=999'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

      if (ioppar(h_IOPPAR_joda_print).lt.0) then
         szTmp = 'JODA_PRINT=0'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

      if (ioppar(h_IOPPAR_convergence).gt.10) then
         szTmp = 'CONV=10'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

      if (ioppar(h_IOPPAR_mult).lt.1) then
         print *, '@GTFLGS: Multiplicity must be >= 1'
         call errex
      end if
c
c   o when quadratic convergence is set we need to do 
c     RPP until the density difference fells below a 
c     certain threshold. This is how it is done without
c     introducing a new key-word (see vscf.F).
c     04/2006, Ajith Perera.
c
      if (ioppar(h_IOPPAR_scf_extrap) .eq. 2) then
         call iputrec(10, 'JOBARC', "RPP_1ST ", 1, 1)
      endif

c   o FINDIF_OLD? I thought this was killed. -Yau
      if (ioppar(h_IOPPAR_vib).eq.2.and.
     &    ioppar(h_IOPPAR_sym).gt.1     ) then
         call asv_update_kv('!sym'//achar(0),iASV,szData,0)
      end if

c NOW TAKE CARE OF A FEW SENSIBLE DEPENDENCIES. THESE ARE
c DONE INTERNALLY IF THE OPTCTL STRING IS READ IN.
c HERE, TURN CURVILINEAR TRANSFORMATION ON IF TRANSITION SEARCH IS BEING
c DONE, OR IF HESSIAN IS AVAILABLE AND VIBRATIONAL CALCULATION
c NOT REQUESTED.
      call GFName('FCM',FName,iLength)
      inquire(file=FName(1:iLength),exist=bTmp)
      bTmp = (bTmp                             .and.
     &        ioppar(h_IOPPAR_vib        ).eq.0.and.
     &        ioppar(h_IOPPAR_curvilinear).eq.0     )
      if (bTmp                             .or.
     &    ioppar(h_IOPPAR_opt_method ).eq.4.and.
     &    ioppar(h_IOPPAR_curvilinear).eq.0     ) then
         call asv_update_kv('curvilinear'//achar(0),iASV,szData,0)
c         print *, '@GTFLGS: Hessian will be transformed to ',
c     &            'curvilinear coordinates.'
      end if

c   o Kohn-Sham implies FOCK=AO, NON-HF=ON, ORBITALS=SEMICANONICAL
      if (ioppar(h_IOPPAR_ks_pot).ne.0) then
         szTmp = 'fock=ao'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         szTmp = 'orbitals=semicanonical'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         call asv_update_kv('non-hf'//achar(0),iASV,szData,0)
      end if

c   o vmol cannot do direct integrals
      if (ioppar(h_IOPPAR_integrals).eq.1.and.
     &    ioppar(h_IOPPAR_direct   ).eq.1     ) then
         print *, '@GTFLGS: vmol cannot calculate integrals directly'
         call errex
      end if

c   o direct integrals are only useful for FOCK=AO
      if (ioppar(h_IOPPAR_direct).eq.1) then
         szTmp = 'fock=ao'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c   o UNO ref implies semi-canonical orbitals, NON-HF=ON
      if (ioppar(h_IOPPAR_uno_ref).eq.1) then
         szTmp = 'orbitals=semicanonical'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         call asv_update_kv('non-hf'//achar(0),iASV,szData,0)
      end if

c   o put the UHF stuff in place
      if (ioppar(h_IOPPAR_ref).eq.0) then
         iUHF = 0
      else
         iUHF = 1
      end if
      call iputrec(20,'JOBARC','UHFRHF  ',1,iUHF)
      if (iUHF.eq.1.and.nDrop(1).ne.0) then
         nDrop(2) = nDrop(1)
         do i = 1, nDrop(1)
            iDrop(i,2) = iDrop(i,1)
         end do
      end if

c *****************************************
c ** INITIAL GEOMETRY OPTIMIZATION LOGIC **
c *****************************************

      if (bStar) then
c      o some coordinates have been flagged for relaxation
         if (ioppar(h_IOPPAR_geom_opt).eq.0) then
c         o elevate geom_opt from none to partial
            szTmp = 'geom_opt=partial'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      else
c      o no coordinates have been explicitly flagged for relaxation
         if (ioppar(h_IOPPAR_geom_opt).eq.0) then
c         o geom_opt=none
            if (ioppar(h_IOPPAR_opt_method).ne.0) then
               print *,
     &'@GTFLGS: A geometry relaxation algorithm has been selected,'
               print *,
     &'         but no asterisks appear in the Z-matrix and geom_opt is'
               print *,
     &'         not set to FULL.'
               call errex
            end if
         end if
         if (ioppar(h_IOPPAR_geom_opt).eq.1) then
c         o geom_opt=partial
            print *,
     &'@GTFLGS: A partial geometry optimization has been requested, but'
            print *,
     &'         but no asterisks appear in the Z-matrix.'
            if (ioppar(h_IOPPAR_coordinates).eq.1) then
               print *,
     &'         (Note: Partial geometry optimizations are meaningless'
               print *,
     &'          for systems defined in XYZ coordinates.)'
            end if
            call errex
         end if
      end if
c
c    o Geometry optimizations with exact Hessians need to be told how
c      the Hessian is calcualted. If not specified set it to 1 
c      (at each update Hessian is recalculated!).
c
      if (ioppar(h_IOPPAR_geom_opt)     .gt. 0 .and. 
     &    ioppar(h_IOPPAR_init_hessian) .eq. 3 .and. 
     &    ioppar(h_IOPPAR_eval_hess)    .eq. -1) then
          szTmp = 'eval_hess=0'//achar(0)
          call asv_update_kv(szTmp,iASV,szData,0)
      endif
c
c    o Geometry optimizations with exact Hessians need to be told
c      told to use it. If not, lets do it too. 07/2006, Ajith Perera.
c 
      if (ioppar(h_IOPPAR_geom_opt)     .gt. 0 .and.
     &    ioppar(h_IOPPAR_eval_hess)    .ge. 0 .and.
     &    ioppar(h_IOPPAR_init_hessian) .eq. 0) then
          szTmp = 'init_hessian=3'//achar(0)
          call asv_update_kv(szTmp,iASV,szData,0)
      endif
c
c    o Check to see whether we have a geometry and if not set
c      the jobarc record HAVEGEOM to 0 indicate the geometry optimizations
c      can proceed.
c
      Call igetrec(0, 'JOBARC', 'HAVEGEOM', i_length, i_havegeom)
c#ifdef _DEBUG_LVL0
      Print*, "A geometry for frequency {0,1} present:", i_length 
c#endif 
      if (i_length .lt. 0) Call iputrec(20, 'JOBARC', 'HAVEGEOM', 
     &                                 1, 0) 
c
c    o If the record exsist and it is non zero then either
c      the geometry optimization is successfuly completed (or
c      could even be a frequency calculation without prior 
c      optimization. 
c
      bGeomOpt = (ioppar(h_IOPPAR_geom_opt).ne.0)
c
      Call igetrec(-1, 'JOBARC', 'HAVEGEOM', 1, i_havegeom)
      if (i_havegeom .gt. 0) Then 
          szTmp = 'geom_opt=none'//achar(0)
          call asv_update_kv(szTmp,iASV,szData,0)
          bGeomOpt = (ioppar(h_IOPPAR_geom_opt).ne.0) 
      endif
c
c    o vibrational frequency calculations using a used defined
c      input, then also we have a geometry!
c
      if (.not. bGeomOpt .and. (ioppar(h_IOPPAR_vib).gt.0))  
     &    call iputrec(10, 'JOBARC', 'HAVEGEOM', 1, 1)
c      
      if (bGeomOpt.and.ioppar(h_IOPPAR_opt_method).eq.0) then
c      o set the default optimization algorithm to MANR (Perera 12/2001)
         szTmp = 'opt_method=manr'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c *********************************************
c ** END INITIAL GEOMETRY OPTIMIZATION LOGIC **
c *********************************************
C
C Stop all sorts of reorientations when SYM=NONE except 
C for vibrational frequancy calcualtions. Only the center
C of mass and the principal axis coordinate system separte
C Hamiltonian to vibrational, rotational and traslational
C motions. In arbitrary coordinate systems we need to 
C project those motions from the Hessian, and until that
C is done do not turn on the noreori for SYM=NONE
C runs. Ajith Perera, 12/08.
C
#ifdef _HES_PROJECT_ON
      If (ioppar(h_IOPPAR_sym).eq.0 .and.
     &    ioppar(h_IOPPAR_vib).ge.1 .and. 
     &    ioppar(h_IOPPAR_noreori) .eq. 2 ) then
          szTmp = 'NOREORI=ON'//achar(0)
          call asv_update_kv(szTmp,iASV,szData,0)
      Endif
#endif

c Turn off symmetry if subgroup=C1.

c VFL 3/6/2012 
      szTmp = 'SYMMETRY=NONE'//achar(0)
      call asv_update_kv(szTmp,iASV,szData,0)
c VFL 3/6/2012 

      if (ioppar(h_IOPPAR_subgroup).eq.1) then
         call asv_update_kv('!sym'//achar(0),iASV,szData,0)
      end if
      if ((ioppar(h_IOPPAR_geom_opt) .eq. 2) .or.
     &    (ioppar(h_IOPPAR_geom_opt) .eq. 3)) then
cVFL         szTmp = 'SYMMETRY=NONE'//achar(0)
cVFL         if (ioppar(h_IOPPAR_sym).ne.0) then
cVFL             call asv_update_kv(szTmp,iASV,szData,0)
cVFK         Endif
C
C For geo. opt with FULL/RIC and SYM=NONE turn on the NOREORI
C if it is not given as an input. Ajith Perera, 12/08
C 
          if (ioppar(h_IOPPAR_noreori) .eq. 2 .and. .not.
     &        ioppar(h_IOPPAR_vib).ge.1 ) then
             szTmp = 'NOREORI=ON'//achar(0)
             call asv_update_kv(szTmp,iASV,szData,0)
          endif
      endif
C
c Ajith 11/98.
c Raman intensity calculations:
c    SCF or MBPT(2) -> PROPS to second-order
c    CCSD           -> PROPS to EOM_NLO
      if (ioppar(h_IOPPAR_raman).eq.1) then
         if (ioppar(h_IOPPAR_calc).eq.0.or.
     &       ioppar(h_IOPPAR_calc).eq.1) then
            szTmp = 'props=second_order'//achar(0)
         else
         if (ioppar(h_IOPPAR_calc).eq.10) then
            szTmp = 'props=eom_nlo'//achar(0)
         end if
         end if
         call asv_update_kv(szTmp,iASV,szData,0)
      end if
c
c SCF only analytical second order properties (polarizabilities)
c with PROPS=EOM_NLO is possible (see setmet.f in cphf). So,
c now this PROPS=EOM_NLO and CALC has the proper correspondence
c (note: earlier version one has to use PROPS=SECOND_ORDER for
c SCF and PROPS=EOM_NLO for CCSD). 03/2006. Ajith Perera. 
c
cMN
c    LOGIC FOR DEALING WITH ioppar(h_IOPPAR_program)
c    (DETERMINES ACES2 OR MN_A3 CALCULATION)

c In case xmrcc is not part of the ACES suite, then one cannot run MN_A3
c calculations. At this point we need to set ACES2=.true.
      ACES2 = .true.
      ACES2 = .false.

c OPEN_SHELL, DEA_TDA, DIP_TDA, STEOM, and IP_EOM
      bOpenShell = .not.(ioppar(h_IOPPAR_ref    ).eq.0.or.
     &                   ioppar(h_IOPPAR_makerhf).eq.1.or.
     &                   ioppar(h_IOPPAR_uno_ref).eq.1)
      bTDA = (ioppar(h_IOPPAR_dip_calc).eq.1.or.
     &        ioppar(h_IOPPAR_dea_calc).eq.1)
      bSTEOM = (ioppar(h_IOPPAR_excite  ).eq.9.or.
     &          ioppar(h_IOPPAR_dip_calc).ge.1.or.
     &          ioppar(h_IOPPAR_dea_calc).ge.1)
      bMN_A3 = (bSTEOM                        .or.
     &          bTDA                          .or.
     &          ioppar(h_IOPPAR_ip_calc).ge.1 .or.
     &          ioppar(h_IOPPAR_calc   ).eq.40)

c RHF EA-EOM
      if (ioppar(h_IOPPAR_ea_calc).ge.1.and.
     &    .not.bOpenShell                   ) bMN_A3=.true.

c only SCF, MBPT(2), LCCSD, LCCD, CCD, CCSD, and ACCSD
      if (.not.(ioppar(h_IOPPAR_calc).eq. 0.or.
     &          ioppar(h_IOPPAR_calc).eq. 1.or.
     &          ioppar(h_IOPPAR_calc).eq. 5.or.
     &          ioppar(h_IOPPAR_calc).eq. 6.or.
     &          ioppar(h_IOPPAR_calc).eq. 8.or.
     &          ioppar(h_IOPPAR_calc).eq.10.or.
     &          ioppar(h_IOPPAR_calc).eq.40)
     &   ) ACES2 = .true.

c closed-shell parent state
cSSS      if (.not.(ioppar(h_IOPPAR_ref    ).eq.0.or.
cSSS     &          ioppar(h_IOPPAR_makerhf).eq.1.or.
cSSS     &          ioppar(h_IOPPAR_uno_ref).eq.1)
cSSS     &   ) ACES2 = .true.
c
      if (bOpenShell) ACES2 = .true.

c no properties
      if (ioppar(h_IOPPAR_props).ne.0) ACES2 = .true.

c excite=?
      if (ioppar(h_IOPPAR_excite).eq.2.or.
     &    ioppar(h_IOPPAR_excite).eq.6.or.
     &    ioppar(h_IOPPAR_excite).eq.8
     &   ) ACES2 = .true.

c no brueckner orbitals
cSSS      if (ioppar(h_IOPPAR_brueckner).ne.0.and.
cSSS     &    nDrop(1).gt.0                       ) bMN_A3=.true.

c    CHECK IF ACES CAN DO THE CALCULATION AT ALL

cMN analytical gradients are allowed in certain cases (not for STEOM yet)
c   Later it is decided by default if gradients are calculated analytically.

c      if (bSTEOM.and.
c     &    (.not.(ioppar(h_IOPPAR_opt_method).ge.5.or.
c     &           (ioppar(h_IOPPAR_opt_method).eq.2.and.
c     &            ioppar(h_IOPPAR_grad_calc ).ne.0)
c     &          )
c     &    )
c     &   ) ACES2 = .true.

      if (ACES2.and.bMN_A3) then
         print *, '@GTFLGS: Some combination of features is not'
         print *, '         implemented in MN_A3 or ACES2.'
         print *, ' STEOM -> NO TRIPLES, NO OPEN-SHELL REFERENCE '
         print *, ' NO DROPED CORE + BRUECKNER + OPEN SHELL.'
         call errex
      end if

      if (ioppar(h_IOPPAR_program).eq.2.and.bMN_A3) then
         print *, '@GTFLGS: ACES2 calculation requested, but ',
     &            'MN_A3 is required.'
         call errex
      end if

      if (ioppar(h_IOPPAR_program).eq.3.and.ACES2) then
         print *, '@GTFLGS: MN_A3 calculation requested, but ',
     &            'ACES2 is required.'
c         print *, ' CAN ONLY HAPPEN WHEN DEVELOPING CODE'
         call errex
      end if

c    SET PROGRAM FLAG h_IOPPAR_program
      if (ioppar(h_IOPPAR_program).eq.0) then
         if (bMN_A3.and.ACES2) then
C
cYAU - This was already killed a few conditionals up.
         else
            if (bMN_A3) then
               szTmp = 'program=mn_a3'//achar(0)
            else
               szTmp = 'program=aces2'//achar(0)
            end if
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
c     else if ([program != 0]) then
      else
         if (ioppar(h_IOPPAR_program).eq.2) then
            if (bMN_A3) then
               szTmp = 'program=mn_a3'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
         else
            if (ACES2) then
               print *, '@GTFLGS: I hope you are creating new options ',
     &                  'in MN_A3!'
            end if
         end if
c     end if ([program == 0])
      end if
c
c There are significant changes which are relevent to opt/freq 
c option and also to accomodate the change deriv_level options 
c (from {ANALYTICAL, NUMERICAL, AUTO} to  {NONE, ANALYTICAL, NUMERICAL})
c 04/2006, Ajith Perera
c
      ACES2 = ioppar(h_IOPPAR_program).eq.2
      bTmp = bGeomOpt.or.(ioppar(h_IOPPAR_vib).ge.2) 
      bMN_A3 = .not.ACES2

      if (bMN_A3) then
c
C Write a JOBARC record to tell Marcel that this is a new version.
C So he can write a wrapper to convert all the changes of flags
C to original ones that he enjoy using. This way he is immune to
C whatever the changes that I make to joda flags.
C Ajith Perera, 12/08.
C MN: This could be done always. Taking this out of the if statement.
c
         iversion = 270
         Call iputrec(20, "JOBARC", "ACES2_ID", 1, iversion)
C
C If a geometry optimization or vibrational frequency calculation
C (bTmp=.true.), turn on the analytical gradient flag
C
      if (ioppar(h_IOPPAR_grad_calc).eq.0 .and. bTmp) Then
         szTmp = 'grad_calc=analytical'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      endif
C
c      o set certain flags associated with analytical gradients
         eom = .not.bSTEOM.and.
     &         (ioppar(h_IOPPAR_excite ).ge.3.or.
     &          ioppar(h_IOPPAR_ea_calc).ge.4.or.
     &          ioppar(h_IOPPAR_ip_calc).ge.4)

c      o gradients are not available for qrhf/uno-ref/brueckner
c        calculations.

         if (DoQRHF .or. ioppar(h_IOPPAR_uno_ref).eq.1.or.
     &       ioppar(h_IOPPAR_brueckner).eq.1) NO_AGRAD=.True.
C
C If Gradient flag is set (to analytical), then reset it to based on
C the availability of analytical gradients.
C Ajith Perera, 12/2008.
C
         if (ioppar(h_IOPPAR_grad_calc).gt.0) then
c         o set grad_calc if none (default to analytical)
            if (No_AGRAD) then
               szTmp = 'grad_calc=numerical'//achar(0)
            else
               szTmp = 'grad_calc=analytical'//achar(0)
            end if
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
C
         if (bTmp.and.(ioppar(h_IOPPAR_grad_calc).eq.1)) then
            if (eom.or.ioppar(h_IOPPAR_print).gt.1) then
               szTmp = 'vtran=full'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
            if (eom) then
               szTmp = 'estate_prop=expectation'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
            call asv_update_kv('abcdfull'//achar(0),iASV,szData,0)
         end if
c     else if (ACES2) then
      else
         If (bTmp) then
            if (ioppar(h_IOPPAR_grad_calc).eq.0) then
                szTmp = 'grad_calc=analytical'//achar(0)
                call asv_update_kv(szTmp,iASV,szData,0)
            end if
         endif 
c     end if (bMN_A3)
      end if

c   o SET DERIVATIVE LEVEL and how gradient are evaluated 
c     frequency and geometry optimizations and other instantces
c     where grad_calc is set, but not the derivative level.
c
      if (ioppar(h_IOPPAR_deriv_lev).eq.-1) then
          if (ioppar(h_IOPPAR_grad_calc).ne.0) then
              szTmp = 'deriv=first'//achar(0)
              call asv_update_kv(szTmp,iASV,szData,0)
          end if
          if (ioppar(h_IOPPAR_vib) .eq.1) then
              szTmp = 'deriv=second'//achar(0)
              call asv_update_kv(szTmp,iASV,szData,0)
              if (ioppar(h_IOPPAR_grad_calc).eq.0) then
                  szTmp = 'grad_calc=analytical'//achar(0)
                  call asv_update_kv(szTmp,iASV,szData,0)
              endif 
          else if (ioppar(h_IOPPAR_vib) .gt.1) then
              szTmp = 'deriv=first'//achar(0)
              call asv_update_kv(szTmp,iASV,szData,0)
              if (ioppar(h_IOPPAR_grad_calc).eq.0) then
                  szTmp = 'grad_calc=analytical'//achar(0)
                  call asv_update_kv(szTmp,iASV,szData,0)
              endif
          end if
          if (ioppar(h_IOPPAR_geom_opt).ne.0) Then
              if (ioppar(h_IOPPAR_grad_calc).eq.0) then
                  szTmp = 'grad_calc=analytical'//achar(0)
                  call asv_update_kv(szTmp,iASV,szData,0)
              endif
              iTmpReg13 = -1
              iRecal = ioppar(h_IOPPAR_eval_hess)
CSSS              if (iRecal.ne.0) iTmpReg13 = mod(NCycle-1,iRecal)
CSSS              if (iRecal.eq.0) iTmpReg13 = 0
              if (ioppar(h_IOPPAR_vib).eq.1.or.iTmpReg13.eq.0) then
                  szTmp = 'deriv=second'//achar(0)
                  call asv_update_kv(szTmp,iASV,szData,0)
              end if
          end if
          if (ioppar(h_IOPPAR_resraman).eq.1) then
              szTmp = 'deriv=first'//achar(0)
              call asv_update_kv(szTmp,iASV,szData,0)
          end if
CSSS          if (ioppar(h_IOPPAR_excite).gt.0) Then
CSSS              szTmp = 'deriv=first'//achar(0)
CSSS              call asv_update_kv(szTmp,iASV,szData,0)
CSSS           endif
      end if
C The HF-DFT gradient calculations need solving Z-vector equations.
C So elevate the derivative level to second derivatives. The HF
C DFT grads will be required for geo. opt, vib. freq and single 
C point grads. P. Verma and A. Perera. 08/2008. 
C
          if (ioppar(h_IOPPAR_scf_type).eq.2) Then
C
              if (ioppar(h_IOPPAR_geom_opt)  .ne.0  .or. 
     &            ioppar(h_IOPPAR_vib)       .ne.0  .or.
     &            ioppar(h_IOPPAR_grad_calc) .eq.1) Then
C
                  szTmp = 'deriv=second'//achar(0) 
                  call asv_update_kv(szTmp,iASV,szData,0)
                  call asv_update_kv('save_ints'//achar(0),
     &                                iASV,szData,0)
              EndIF
C
          Endif 
C
#ifdef _DEBUG_LVL0
      Print*, "The value of grad calc", ioppar(h_IOPPAR_grad_calc)
      Print*, "The Deriv. level, havegeom?, and vib? :",
     &     ioppar(h_IOPPAR_deriv_lev),  i_havegeom, 
     &     ioppar(h_IOPPAR_geom_opt), ioppar(h_IOPPAR_vib) 
#endif
c
      If (ioppar(h_IOPPAR_vib)      .eq. 1 .and. 
     &    ioppar(h_IOPPAR_geom_opt) .ne. 0 .and. 
     &    i_havegeom .eq. 0)  Then
              szTmp = 'deriv=first'//achar(0)  
              call asv_update_kv(szTmp,iASV,szData,0)
      Endif
#ifdef _DEBUG_LVL0
      Print*, "The derivative level @exit", ioppar(h_IOPPAR_deriv_lev) 
#endif

c    
c    o If we have not yet change the default deriavative level from
c      -1 to 0, let's do it now. Certain things below this point
c      depends on having derivative level set to zero. 
c
      If (ioppar(h_IOPPAR_deriv_lev).eq.-1) then
         szTmp = 'deriv=zero'//achar(0) 
         call asv_update_kv(szTmp,iASV,szData,0) 
      Endif
c
c   o HF stability check can only be done for
c     single point energy calculations (not vib. freq.
c     or geom. opt.)
      if (ioppar(h_IOPPAR_hfstab  ).ne.0.and.
     &    ioppar(h_IOPPAR_geom_opt).eq.0) then
c      o save ints all the time for post scf and HF stab
c         if (ioppar(h_IOPPAR_hfstab).eq.2) then
            call asv_update_kv('save_ints'//achar(0),iASV,szData,0)
c         end if
      end if

c   o Brueckner calculation
      if (ioppar(h_IOPPAR_brueckner).ne.0) then
         call asv_update_kv('save_ints'//achar(0),iASV,szData,0)
         call asv_update_kv('non-hf'//achar(0),iASV,szData,0)
      end if

cKJW 1/18/98
c turn save_ints on for all fno methods
c props need to be first order for cc densities
      if (ioppar(h_IOPPAR_fno_keep).gt.0) then
         call asv_update_kv('save_ints'//achar(0),iASV,szData,0)
      end if

c   o TRAP METHODS WHICH DON'T WORK YET
      if (ioppar(h_IOPPAR_ref).lt.2) then
         if (iEnAva1(ioppar(h_IOPPAR_calc)).eq.0) then
            print *, '@GTFLGS: CALC=',ioppar(h_IOPPAR_calc),
     &               ' not implemented for RHF/UHF references.'
            call errex
         end if
      else
         if (ioppar(h_IOPPAR_ref).eq.2) then
            if (iEnAva2(ioppar(h_IOPPAR_calc)).eq.0) then
               print *, '@GTFLGS: CALC=',ioppar(h_IOPPAR_calc),
     &                  ' not implemented for ROHF references.'
               call errex
            end if
         end if
      end if

      if (bTDCalc) then
         if (iEnAva3(ioppar(h_IOPPAR_calc)).eq.0) then
            print *, '@GTFLGS: CALC=',ioppar(h_IOPPAR_calc),
     &               ' not implemented for TWODET references.'
            call errex
         end if
      end if

c     Set the initial scf diis iteration and order VFL 1/2/2013 

      if (ioppar(h_IOPPAR_scf_expstar).eq.0) then
         szTmp = 'scf_expstar=2'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

      if (ioppar(h_IOPPAR_scf_exporde).eq.0) then
         szTmp = 'scf_exporde=8'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c   o If CC calc, then set MAXCYC and turn on RLE with order equal to 5
      if (ioppar(h_IOPPAR_calc).ge.5) then
         if (ioppar(h_IOPPAR_cc_maxcyc).eq.0) then
            szTmp = 'cc_maxcyc=50'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
         if (ioppar(h_IOPPAR_cc_exporder).eq.0) then
            szTmp = 'cc_exporder=5'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
         if (ioppar(h_IOPPAR_tamp_sum).eq.0) then
            szTmp = 'tamp_sum=5'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
         if (ioppar(h_IOPPAR_ntop_tamp).eq.0) then
            szTmp = 'ntop_tamp=15'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      else
         szTmp = 'cc_extrap=DIIS'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c   o PROPERTY CALCULATION FOR CORRELATED CALCULATION
#ifdef _DEBUG_LVL0
      Print*, "First order props and grad flags @enter:",
     &         ioppar(h_IOPPAR_props),ioppar(h_IOPPAR_grad_calc) 
#endif
      if (ioppar(h_IOPPAR_props).ge.1) then
         szTmp = 'deriv=first'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         if (ioppar(h_IOPPAR_grad_calc) .eq. 0) then
             szTmp = 'grad_calc=analytical'//achar(0) 
             call asv_update_kv(szTmp,iASV,szData,0) 
         endif 
      end if
#ifdef _DEBUG_LVL0
      Print*, "First order props, deriv level and grad_calc @exit:", 
     &         ioppar(h_IOPPAR_props), ioppar(h_IOPPAR_deriv_lev),
     &         ioppar(h_IOPPAR_grad_calc)
#endif
     
cJDW 6/16/95
c Try to keep ioppar(h_IOPPAR_deriv_lev)=1 for PROP=J_FC, J_SD, J_SO
cJDW/MN 10/23/95
c ioppar(h_IOPPAR_props).ne.13 added; JSC_ALL.
      if (ioppar(h_IOPPAR_props).ge. 2.and.
     &    ioppar(h_IOPPAR_props).ne.11.and.
     &    ioppar(h_IOPPAR_props).ne. 8.and.
     &    ioppar(h_IOPPAR_props).ne. 9.and.
     &    ioppar(h_IOPPAR_props).ne.10.and.
     &    ioppar(h_IOPPAR_props).ne.13     ) then
         szTmp = 'deriv=second'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         if (ioppar(h_IOPPAR_calc).gt. 3.and.
     &       ioppar(h_IOPPAR_calc).ne. 8.and.
     &       ioppar(h_IOPPAR_calc).ne.10.and.
     &       ioppar(h_IOPPAR_calc).ne.23     ) then
            print *, '@GTFLGS: Second-order properties not ',
     &               'available for CALC=',ioppar(h_IOPPAR_calc)
            call errex
         end if
      end if

c If this is a correlated ROHF calculation, then orbitals=semicanonical
c unless turned off explicitly. For second derivatives, however, they
c are turned off.
c SG 1/8/96
c Also set semicanonical for other non-HF triples calculations.
      if (ioppar(h_IOPPAR_orbitals).eq.-1) then
         if ((ioppar(h_IOPPAR_nonhf).eq.1    ).and.
     &       (ioppar(h_IOPPAR_calc).eq. 4.or.
     &        ioppar(h_IOPPAR_calc).eq.13.or.
     &        ioppar(h_IOPPAR_calc).eq.22    )
     &      ) then
               szTmp = 'orbitals=semicanonical'//achar(0)
         end if
         if (ioppar(h_IOPPAR_ref).eq.2) then
            if (ioppar(h_IOPPAR_calc     ).ge.1.and.
     &          ioppar(h_IOPPAR_deriv_lev).le.1     ) then
               szTmp = 'orbitals=semicanonical'//achar(0)
            end if
            if (ioppar(h_IOPPAR_calc     ).ge.1.and.
     &          ioppar(h_IOPPAR_deriv_lev).ne.0     ) then
               szTmp = 'orbitals=standard'//achar(0)
            end if
            if (ioppar(h_IOPPAR_calc).eq.0) then
               szTmp = 'orbitals=standard'//achar(0)
            end if
         else
            szTmp = 'orbitals=standard'//achar(0)
         end if
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c AO-LADDER DEFAULT DEPENDS ON MACHINE ARCHITECTURE!
      if (ioppar(h_IOPPAR_abcdtype).eq.2) then
c ???
      end if

c TRAP GRADIENT OR HESSIAN CALCULATIONS WHICH WON'T WORK FOR SOME REFS.
      if (ioppar(h_IOPPAR_deriv_lev).gt.0) then

         if (ioppar(h_IOPPAR_ref).lt.2) then
c         o check RHF/UHF
            if (iGrAva1(ioppar(h_IOPPAR_calc)).eq.0.and.
     &          ioppar(h_IOPPAR_deriv_lev)    .eq.1.and.
     &          ioppar(h_IOPPAR_grad_calc)    .eq.1     ) then
               print *, '@GTFLGS: RHF/UHF gradient calculations not ',
     &                  'possible for CALC=',ioppar(h_IOPPAR_calc)
               close(unit=LUZ,status='KEEP')
               call errex
            end if
            if (iHsAva1(ioppar(h_IOPPAR_calc)).eq.0.and.
     &          ioppar(h_IOPPAR_deriv_lev)    .eq.2     ) then
               print *, '@GTFLGS: RHF/UHF Hessian calculations not ',
     &                  'possible for CALC=',ioppar(h_IOPPAR_calc)
               close(unit=LUZ,status='KEEP')
               call errex
            end if
         else
         if (ioppar(h_IOPPAR_ref).eq.2) then
c         o check ROHF
            if (iGrAva2(ioppar(h_IOPPAR_calc)).eq.0.and.
     &          ioppar(h_IOPPAR_deriv_lev)    .eq.1.and.
     &          ioppar(h_IOPPAR_grad_calc)    .eq.1     ) then
               print *, '@GTFLGS: ROHF gradient calculations not ',
     &                  'possible for CALC=',ioppar(h_IOPPAR_calc)
               close(unit=LUZ,status='KEEP')
               call errex
            end if
            if (iHsAva2(ioppar(h_IOPPAR_calc)).eq.0.and.
     &          ioppar(h_IOPPAR_deriv_lev)    .eq.2     ) then
               print *, '@GTFLGS: ROHF Hessian calculations not ',
     &                  'possible for CALC=',ioppar(h_IOPPAR_calc)
               close(unit=LUZ,status='KEEP')
               call errex
            end if
c        end if ([ROHF])
         end if
c        end if ([RHF/UHF])
         end if
         if (bTDCalc) then
            if (iGrAva2(ioppar(h_IOPPAR_calc)).eq.0.and.
     &          ioppar(h_IOPPAR_deriv_lev)    .eq.1.and.
     &          ioppar(h_IOPPAR_grad_calc)    .eq.1     ) then
               print *, '@GTFLGS: TWODET gradient calculations not ',
     &                  'possible for CALC=',ioppar(h_IOPPAR_calc)
               close(unit=LUZ,status='KEEP')
               call errex
            end if
         end if

c        FOR GRADIENT CALCULATIONS INVOLVING TRIPLE EXCITATIONS,
c        USE ALWAYS PERTURBED CANONICAL OR SEMI-CANONICAL ORBITALS.
         if (ioppar(h_IOPPAR_pert_orb).eq.2) then
c         o reset UNKNOWN
            if ( ioppar(h_IOPPAR_calc).eq. 4.or.
     &           ioppar(h_IOPPAR_calc).eq. 9.or.
     &          (ioppar(h_IOPPAR_calc).ge.11.and.
     &           ioppar(h_IOPPAR_calc).le.22     )
     &         ) then
               szTmp = 'pert_orb=canonical'//achar(0)
            else
               szTmp = 'pert_orb=standard'//achar(0)
            end if
            call asv_update_kv(szTmp,iASV,szData,0)
         end if

c        Stop calculations for UHF/ROHF if triples and PERT_ORB=STANDARD.
c        This limitation will be removed eventually.
c        (By whom? -YAU)
         if (ioppar(h_IOPPAR_ref     ).ge.1.and.
     &       ioppar(h_IOPPAR_pert_orb).eq.0     ) then
            if ( ioppar(h_IOPPAR_calc).eq. 4.or.
     &           ioppar(h_IOPPAR_calc).eq. 9.or.
     &          (ioppar(h_IOPPAR_calc).ge.11.and.
     &           ioppar(h_IOPPAR_calc).le.22)
     &         ) then
               print *, '@GTFLGS: PERT_ORB=STANDARD for specific CALC'
               print *, '         or REFERENCE is not implemented.'
               call errex
            end if
         end if

c     end if ([deriv>0])
      end if

c   o RELAXED DENSITY -> NATURAL ORBITALS BY DEFAULT
c YAU - As far as I can grep, RDO is not used anywhere (and _relax_dens is dead)
c      if (ioppar(h_IOPPAR_rdo).eq.-1) then
c         if (ioppar(h_IOPPAR_relax_dens).eq.1) then
c            call asv_update_kv('rdo'//achar(0),iASV,szData,0)
c         else
c            call asv_update_kv('!rdo'//achar(0),iASV,szData,0)
c         end if
c      end if

c LOGIC FOR EOM-CC CALCULATIONS AND OTHER STUFF REQUIRING FORMATION OF H-BAR
c
cJDW 6/16/95
c Three lines for PROP=J_FC, J_SD, J_SO.
cMN/JDW 10/23/95
c Extra options for h_IOPPAR_props, h_IOPPAR_excite,
c h_IOPPAR_ea_calc, h_IOPPAR_ip_calc included.
      if (ioppar(h_IOPPAR_excite  ).eq.  3.or.
     &    ioppar(h_IOPPAR_excite  ).eq.  7.or.
     &    ioppar(h_IOPPAR_props   ).eq.  8.or.
     &    ioppar(h_IOPPAR_props   ).eq.  9.or.
     &    ioppar(h_IOPPAR_props   ).eq. 10.or.
     &    ioppar(h_IOPPAR_props   ).eq. 11.or.
     &    ioppar(h_IOPPAR_props   ).eq. 13.or.
     &    ioppar(h_IOPPAR_props   ).ge.100.or.
     &    ioppar(h_IOPPAR_ea_calc ).ge.  4.or.
     &    ioppar(h_IOPPAR_ip_calc ).ge.  4.or.
     &    ioppar(h_IOPPAR_dip_calc).ge.  2.or.
     &    ioppar(h_IOPPAR_dea_calc).ge.  2
     &   ) then

         if (ioppar(h_IOPPAR_estate_prop).eq.3) then
            print *, '@GTFLGS: Analytic response properties not ',
     &               ' available for EOM-CC calculations.'
            call errex
         end if

         if (ioppar(h_IOPPAR_calc).eq.0) then
            szTmp = 'deriv=second'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if

         if      (ioppar(h_IOPPAR_calc).eq. 0) then
            szTmp = 'eomref=none'//achar(0)
         else if (ioppar(h_IOPPAR_calc).eq. 1) then
            szTmp = 'eomref=mbpt(2)'//achar(0)
         else if (ioppar(h_IOPPAR_calc).eq.10.or.
     &            ioppar(h_IOPPAR_calc).eq.13.or.
     &            ioppar(h_IOPPAR_calc).eq.14.or.
     &            ioppar(h_IOPPAR_calc).eq.15.or.
     &            ioppar(h_IOPPAR_calc).eq.16.or.
     &            ioppar(h_IOPPAR_calc).eq.18.or.
     &            ioppar(h_IOPPAR_calc).eq.22.or.
     &            ioppar(h_IOPPAR_calc).eq.33.or.
     &            ioppar(h_IOPPAR_calc).eq.34.or.
     &            ioppar(h_IOPPAR_calc).eq.40
     &           ) then
            szTmp = 'eomref=ccsd'//achar(0)
         else
            print *, '@GTFLGS: EOM calculation not possible with ',
     &               'CALC=',ioppar(h_IOPPAR_calc)
            call errex
         end if
         call asv_update_kv(szTmp,iASV,szData,0)

         call asv_update_kv('hbar'//achar(0),iASV,szData,0)

cMN/JDW 8 EA
         if (ioppar(h_IOPPAR_ea_calc).ge.1) then
            call iputrec(20,'JOBARC','EASYM_A ',8,EARoot(1,1))
            if (ioppar(h_IOPPAR_ref).ge.1) then
               call iputrec(20,'JOBARC','EASYM_B ',8,EARoot(1,2))
            end if
         end if

cMN IP
         if (ioppar(h_IOPPAR_ip_calc).ge.1) then
            call iputrec(20,'JOBARC','IPSYM_A ',8,IPRoot(1,1))
            if (ioppar(h_IOPPAR_ref).ge.1) then
               call iputrec(20,'JOBARC','IPSYM_B ',8,IPRoot(1,2))
            end if
         end if
      end if

cMN
c New parameters in vee (does not work with old vee)
      if (ioppar(h_IOPPAR_zeta_type).eq.1) then
         if (ioppar(h_IOPPAR_zeta_conv).eq.0) then
            szTmp = 'zeta_conv=7'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
         if (ioppar(h_IOPPAR_zeta_maxcyc).eq.0) then
            szTmp = 'zeta_maxcyc=50'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      else
         if (ioppar(h_IOPPAR_zeta_conv).eq.0) then
            szTmp = 'zeta_conv=14'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      end if

      if (ioppar(h_IOPPAR_excite   ).ge.1.and.
     &    ioppar(h_IOPPAR_grad_calc).eq.1     ) then
         if (ioppar(h_IOPPAR_geom_opt ).ne.0.or.
     &       ioppar(h_IOPPAR_vib      ).ne.0.or.
     &       ioppar(h_IOPPAR_resraman ).eq.1.or.
     &       ioppar(h_IOPPAR_deriv_lev).eq.1
     &      ) then
            szTmp = 'estate_prop=unrelaxed'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      end if

c   o CALC=SCF FOR TDA AND =MBPT(2) FOR CIS(D)
      if (ioppar(h_IOPPAR_excite).eq.5.or.
     &    ioppar(h_IOPPAR_excite).eq.1    ) then
         szTmp = 'excite=tda'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         szTmp = 'calc=scf'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      else
         if (ioppar(h_IOPPAR_excite).eq.6) then
            szTmp = 'calc=mbpt(2)'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      end if

c VTRAN=FULL FOR CIS(D) GRADIENT CALCULATIONS
      if ((ioppar(h_IOPPAR_excite  ).eq.6.and.
     &     ioppar(h_IOPPAR_geom_opt).ne.0     ) .or.
     &    (ioppar(h_IOPPAR_excite  ).eq.6.and.
     &     ioppar(h_IOPPAR_vib     ).ne.0     )
     &   ) then
         szTmp = 'vtran=full'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

cMN set vtran/abcdfull to full for dea calculations.
      if (ioppar(h_IOPPAR_dea_calc).ne.0) then
         szTmp = 'vtran=full'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         call asv_update_kv('abcdfull'//achar(0),iASV,szData,0)
      end if

c SG 3/11/96
c  make sure that analytic gradients are available if requested
      if (ioppar(h_IOPPAR_excite   ).gt.0.and.
     &    ioppar(h_IOPPAR_deriv_lev).gt.0     ) then
         if (ioppar(h_IOPPAR_deriv_lev).gt.1) then
            print *, '@GTFLGS: Analytical frequencies are not',
     &               ' available for excited states.'
            call errex
         end if
         if (.not.( ioppar(h_IOPPAR_excite).eq.1.or.
     &              ioppar(h_IOPPAR_excite).eq.3.or.
     &              ioppar(h_IOPPAR_excite).eq.5.or.
     &              ioppar(h_IOPPAR_excite).eq.9.or.
     &             (ioppar(h_IOPPAR_excite).eq.7.and.
     &              ioppar(h_IOPPAR_eomref).eq.2)
     &            )
     &      ) then
            print *, '@GTFLGS: Analytic gradients are not available',
     &               ' for this excited state method.'
            call errex
         end if
      end if

c SG 5/7/96
c For excited state gradients and frequencies, set the convergence at
c   10**-7, otherwise set it at 10**-5
      if (ioppar(h_IOPPAR_estate_tol).eq.-1) then
         if ( ioppar(h_IOPPAR_excite  ).gt.0.and.
     &       (ioppar(h_IOPPAR_geom_opt).ne.0.or.
     &        ioppar(h_IOPPAR_vib     ).ne.0)
     &      ) then
            szTmp = 'estate_tol=7'//achar(0)
         else
            szTmp = 'estate_tol=5'//achar(0)
         end if
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

cYAU - unused
c 7002 FORMAT(T3,'@GTFLGS: Property calculations not compatible ',
c     &     'with analytic TDA gradients.')

c FOR HBAR CALCULATIONS, SET DERIVATIVE LEVEL TO 1
c      if (ioppar(h_IOPPAR_hbar     ).gt.0.and.
c          ioppar(h_IOPPAR_deriv_lev).eq.0     ) then
c         szTmp = 'deriv_lev=1'//achar(0)
c         call asv_update_kv(szTmp,iASV,szData,0)
c      end if

c SG 1/8/97 Set HF2_FILE=SAVE if ABCDTYPE=MULTIPASS
      if (ioppar(h_IOPPAR_abcdtype).eq.1) then
         szTmp = 'hf2_file=save'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

cMN DETERMINE INTEGRAL TRANSFORMATION
      if (ioppar(h_IOPPAR_eomref).ge.1.and.
     &    ioppar(h_IOPPAR_vtran ).eq.0     ) then
         szTmp = 'vtran=full'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

cYAU - This needs to be checked. The original IOPPAR index was called DIRECT,
c      but it was renamed to TURBOMOLE. It makes sense to switch to AOBASIS
c      for direct integrals, but I know nothing about how TURBOMOLE works so
c      I cannot say whether this is an actual dependency.
c SET ABCDTYPE=AOBASIS IF TURBOMOLE=ON
      if (ioppar(h_IOPPAR_turbomole).eq.1) then
         szTmp = 'abcdtype=aobasis'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c IF ABCDTYPE=AOBASIS, SET VTRAN=PARTIAL AND VICE VERSA
c ALSO SET GAMMA_ABCD=DIRECT
      if (ioppar(h_IOPPAR_vtran).eq.2) then
         szTmp = 'abcdtype=aobasis'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if
      if (ioppar(h_IOPPAR_abcdtype).eq.2) then
         szTmp = 'vtran=partial'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
         szTmp = 'gamma_abcd=direct'//achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c IF ROHF AND A CORRELATED CALCULATION, THEN SET NON-HF FLAG.
      if (ioppar(h_IOPPAR_ref).eq.2.and.ioppar(h_IOPPAR_calc).ge.1) then
         call asv_update_kv('non-hf'//achar(0),iASV,szData,0)
      end if

c HANDLE LOGIC FOR ENERGY-ONLY OPTIMIZATIONS AND FREQUENCY CALCULATIONS

c Ajith Perera 06/2001
c All the logic that deals with the FD_STEPSIZE is moved to
c the following block of code.
c      if (ioppar(h_IOPPAR_grad_calc).eq.1) then
      I2 = 0

c if (bGeomOpt) then; geometry optimization (no longer needed,
c here (see below), all we need to know whether we are doing a 
c finite difference gradient calculation. 
c
c   o set FD_STEPSIZE if the user has not
      if (bGeomOpt) then
c
         if (ioppar(h_IOPPAR_grad_calc).eq.2) then
c      o numerical gradients
            if (ioppar(h_IOPPAR_fd_stepsize).eq.0) then
               szTmp = 'fd_stepsize=25'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
         end if
c
         if (ioppar(h_IOPPAR_hess_update).eq.0) then
            if (ioppar(h_IOPPAR_opt_method).le.3) then
               ioppar(h_IOPPAR_hess_update) = 2
            else
               ioppar(h_IOPPAR_hess_update) = 4
            end if
         end if
c
c      o only symmetric distortions
         call iputrec(20,'JOBARC','NFDIRREP',1,1)
         call iputrec(20,'JOBARC','FDIRREP ',1,1)
c
      else if (ioppar(h_IOPPAR_vib).ge.2) then 
c      o vibrational frequency calculation
         if (ioppar(h_IOPPAR_grad_calc).eq.2) then
c          o numerical gradients
            if (ioppar(h_IOPPAR_fd_stepsize).eq.0) then
               szTmp = 'fd_stepsize=200'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
         else
            if (ioppar(h_IOPPAR_fd_stepsize).eq.0) then
               szTmp = 'fd_stepsize=50'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
         endif
c
      else if (ioppar(h_IOPPAR_grad_calc).eq.2) then
c      o numerical gradients 
         if (ioppar(h_IOPPAR_fd_stepsize).eq.0) then
            szTmp = 'fd_stepsize=25'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
c     end if (bGeomOpt)
      end if

c   o restarting something other than finite differences?
      if (ioppar(h_IOPPAR_restart).ne.0) then
         if (ioppar(h_IOPPAR_vib     ).ne.3.and.
     &       ioppar(h_IOPPAR_geom_opt).eq.0     ) then
            szTmp = 'restart=0'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      end if
c
cJDW 10/23/95. Block of code from MN.

c   LOGIC FOR DEALING WITH NEWVRT
      if (ioppar(h_IOPPAR_newvrt).eq.1.or.DoQRHF) then
cMN         if (ioppar(h_IOPPAR_orbitals).eq.1) then
cMN            print *, '@GTFLGS: SEMICANONICAL ORBITALS AND NEWVRT ',
cMN     &               'OPTIONS ARE INCOMPATIBLE'
cMN            call errex
cMN         end if
         call asv_update_kv('non-hf'//achar(0),iASV,szData,0)
      end if

cMN  LOGIC FOR DEALING WITH HBARABCD, HBARABCI
c
cJDW 10/23/95. Note that these settings are biased to the new vee code.
c              for the old vee code, we need DoABCD and DoABCI to be true
c              in the UHF/MO basis code.
c
c  SET HBARABCD/HBARABCI FLAGS: ONLY USED IN ACES2
c
c  FULL HBARABCD/HBARABCI IS REQUIRED FOR EA-EOMCC AND MOST VCCEH CALCULATIONS

      if (ACES2) then
c      o set DoABCD and DoABCI
         if ((ioppar(h_IOPPAR_props).ge. 8.and.
     &        ioppar(h_IOPPAR_props).le.11).or.
     &        ioppar(h_IOPPAR_props).eq.13
     &      ) then
            DoABCD = (ioppar(h_IOPPAR_excite ).lt.7.or.
     &                ioppar(h_IOPPAR_eomprop).gt.1)
            DoABCI = .true.
         else
            DoABCD = .false.
            DoABCI = .false.
         end if
c      o elevate DoABCD and DoABCI
         if (ioppar(h_IOPPAR_ea_calc).ge.5) then
            DoABCD = .true.
            DoABCI = .true.
         end if
         if (ioppar(h_IOPPAR_ea_calc).eq.4.and.
     &       ioppar(h_IOPPAR_eomref ).eq.1)
     &      DoABCI = .true.
         if (ioppar(h_IOPPAR_excite).eq.7.or.
     &       ioppar(h_IOPPAR_excite).eq.8)
     &      DoABCI = .true.
         if (ioppar(h_IOPPAR_eomref).eq.2.and.
     &       ioppar(h_IOPPAR_nonhf ).eq.0)
     &      DoABCI = .false.
c      o update ASVs
         if (DoABCD) then
            if (ioppar(h_IOPPAR_hbarabcd).eq.0) then
               call asv_update_kv('hbarabcd'//achar(0),iASV,szData,0)
            else
               if (ioppar(h_IOPPAR_hbarabcd).eq.1) then
cMN                  print *, '@GTFLGS: HBARABCD should be ON.'
               end if
            end if
         else
            if (ioppar(h_IOPPAR_hbarabcd).eq.0) then
               call asv_update_kv('!hbarabcd'//achar(0),iASV,szData,0)
            else
               if (ioppar(h_IOPPAR_hbarabcd).eq.2) then
cMN                  print *, '@GTFLGS: HBARABCD should be OFF.'
               end if
            end if
         end if
         if (DoABCI) then
            if (ioppar(h_IOPPAR_hbarabci).eq.0) then
               call asv_update_kv('hbarabci'//achar(0),iASV,szData,0)
            else
               if (ioppar(h_IOPPAR_hbarabci).eq.1) then
cMN                  print *, '@GTFLGS: HBARABCI should be ON.'
               end if
            end if
         else
            if (ioppar(h_IOPPAR_hbarabci).eq.0) then
               call asv_update_kv('!hbarabci'//achar(0),iASV,szData,0)
            else
               if (ioppar(h_IOPPAR_hbarabci).eq.2) then
cMN                  print *, '@GTFLGS: HBARABCI should be OFF.'
               end if
            end if
         end if
c     else if (.not.ACES2) then
      else
         call asv_update_kv('!hbarabcd'//achar(0),iASV,szData,0)
         call asv_update_kv('!hbarabci'//achar(0),iASV,szData,0)
c     end if (ACES2)
      end if

c   o Assymetric CCSD(T) or Lambda-based CCSD(T) designated as
c     ACCSD(T) requires to solve for CCSD/Lambda followed by
c     non-iterative triples correction with Lambda.
      if (ioppar(h_IOPPAR_calc).eq.42) then
         if (ioppar(h_IOPPAR_deriv_lev).eq.-1) then
            szTmp = 'deriv=zero'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         endif 
         if (ioppar(h_IOPPAR_grad_calc).eq.1) then
c         o This is an ACCSD(T) analytic derivative calculation,
c           then we need hbar to be formed after lambda.
            if (ioppar(h_IOPPAR_hbarabcd).eq.0) then
               call asv_update_kv('hbarabcd'//achar(0),iASV,szData,0)
            end if
            if (ioppar(h_IOPPAR_hbarabci).eq.0) then
               call asv_update_kv('hbarabci'//achar(0),iASV,szData,0)
            end if
         end if
      end if

cMN COMPRESS
c
c DETERMINE IF COMPRESSED ABCD INTEGRALS ARE TO BE USED.
c
c UNCOMPRESSED ABCD INTEGRALS ARE AT PRESENT REQUIRED FOR
c    1. CCSDT VARIANTS (SEE BELOW).
c    2. ACES2 EA_EOMCC CALCULATIONS.
c    3. ENERGY GRADIENT CALCULATIONS.
c    4. IN CASE OF EOMCC CALCULATIONS THE SETTING IS COMPLICATED.
c        WE FOLLOW THE LOGIC GIVEN BY HBARABCD/HBARABCI
c    5. CERTAIN EOM PROPERTY CALCULATIONS USING VCCEH.
c    6. DEA CALCULATIONS IN MN_A3
c    7. ANALYTICAL GRADIENTS IN MN_A3
c    8. ACCSD CALCULATIONS
c
c  THIS FLAG IS SET IF IT HAS THE DEFAULT VALUE ('UNKNOWN')
c  IN OTHER CASES WE LEAVE THE FLAG AS IS BUT PRINT OUT A WARNING
c
cJDW. 5/13/93.  bCCSDT3 determines whether the calculation is
c                  CCSDT-3, CCSDT-4, or CCSDT. This affects list 233 in
c                  RHF calculations. This variable occurs in the
c                  main program and in DS16AB.
cJDW. 6/28/93.  CCSDT3 extended to include noniterative fifth-order
c                  triples in "CCSD+T*(CCSD)" (CC5SD(T)).
cJDW. 10/14/93. CCSDT3 extended to include other noniterative
c                  fifth-order calculations.

c   o set bCompress
      bCCSDT3 = ( ioppar(h_IOPPAR_calc).eq.12      .or.
     &           (ioppar(h_IOPPAR_calc).ge.26.and.
     &            ioppar(h_IOPPAR_calc).le.31     ).or.
     &           (ioppar(h_IOPPAR_calc).ge.16.and.
     &            ioppar(h_IOPPAR_calc).le.18     ).or.
     &            ioppar(h_IOPPAR_calc).eq.33      .or.
     &            ioppar(h_IOPPAR_calc).eq.34
     &          )
      bCompress = (.not.bCCSDT3)
c   o elevate bCompress
      if (ioppar(h_IOPPAR_ea_calc).ge.5.and.ACES2)
     &   bCompress = .false.
      if (ioppar(h_IOPPAR_dea_calc).ge.1)
     &   bCompress = .false.
      if (ioppar(h_IOPPAR_calc).eq.40)
     &   bCompress = .false.
      if ((ioppar(h_IOPPAR_deriv_lev ).ne.  0.or.
     &     ioppar(h_IOPPAR_props     ).ne.  0     ).and.
     &    (ioppar(h_IOPPAR_excite    ).eq.  0.and.
     &     ioppar(h_IOPPAR_props     ).lt.100     ).and.
     &    (ioppar(h_IOPPAR_excite    ).eq.  0.and.
     &     ioppar(h_IOPPAR_props     ).ne. 11)          )
     &   bCompress = .false.
      if (ioppar(h_IOPPAR_excite     ).ge.3.and.
     &    ioppar(h_IOPPAR_estate_prop).eq.2)
     &   bCompress = .false.
      if (ioppar(h_IOPPAR_hbarabcd).eq.2.or.
     &    ioppar(h_IOPPAR_hbarabci).eq.2)
     &   bCompress = .false.
      if (bMN_A3)
     &   bCompress = .false.
c   o update ABCDFULL
      if (ioppar(h_IOPPAR_abcdfull).eq.0) then
         if (bCompress) then
            call asv_update_kv('!abcdfull'//achar(0),iASV,szData,0)
         else
            call asv_update_kv('abcdfull'//achar(0),iASV,szData,0)
         end if
      else
         if ((.not.bCompress.and.ioppar(h_IOPPAR_abcdfull).eq.2)) then
            print *
            print *, '@GTFLGS: COMPRESSED ABCD INTEGRALS NOT SUPPORTED'
            print *, '         SWITCH ABCDFULL TO ON'
            print *
            call errex
         end if
      end if
cMN END COMPRESS

c CHECK COMPATIBILITY COMPRESSED ABCD/AO ALGORITHM AND HBARABCD/HBARABCI
      if (ioppar(h_IOPPAR_hbarabcd).eq.2.or.
     &    ioppar(h_IOPPAR_hbarabci).eq.2    ) then
         if (ioppar(h_IOPPAR_abcdfull).eq.2) then
            print *, '@GTFLGS: INCOMPATIBLE COMPRESS,HBARABCD,HBARABCI'
            print *, '         JODA NEEDS TO BE FIXED!'
            call asv_update_kv('abcdfull'//achar(0),iASV,szData,0)
         end if
         if (ioppar(h_IOPPAR_abcdtype).eq.2) then
            print *, '@GTFLGS: INCOMPATIBLE AOBASIS,HBARABCD,HBARABCI'
            print *, '         JODA NEEDS TO BE FIXED!'
            szTmp = 'abcdtype=standard'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
         end if
      end if

cMN END

cKB/JDW 10/26/95. Put in block of code to set GUESS=CORE,PERT_ORB=
c                 CANONICAL for dropped core gradient/property/findif
c                 calculations. Also, set ORBITAL=SEMICANONICAL for
c                 ROHF. Write variable NDRGEO to JOBARC. This is 0
c                 if no dropped core and 1 if dropped gradient/prop,
c                 etc.
cJDW 8/26/97.     Removed restriction to core guess for dropped core.
c                 Changes made to scf code.
      NDRGEO = 0
      if (ioppar(h_IOPPAR_geom_opt ).ne.0 .or.
     &    ioppar(h_IOPPAR_grad_calc).eq.1 .or.
     &    ioppar(h_IOPPAR_vib      ).eq.2 .or.
     &    ioppar(h_IOPPAR_vib      ).eq.3 .or.
     &    ioppar(h_IOPPAR_props    ).eq.1
     &   ) then
         if (nDrop(1).gt.0) then
            szTmp = 'pert_orb=canonical'//achar(0)
            call asv_update_kv(szTmp,iASV,szData,0)
            if (ioppar(h_IOPPAR_ref).eq.2) then
               szTmp = 'orbitals=semicanonical'//achar(0)
               call asv_update_kv(szTmp,iASV,szData,0)
            end if
            NDRGEO = 1
         end if
      end if
      call iputrec(20,'JOBARC','NDROPGEO',1,NDRGEO)

c   o reduce MEM to a multiple of 128 Bytes (16 floats)
      iTmpReg12 = ioppar(h_IOPPAR_mem)
      iTmpReg12 = iTmpReg12 / iIntFp
      iTmpReg12 = iTmpReg12 - iAnd(iTmpReg12,15)
      iTmpReg12 = iTmpReg12 * iIntFp
      if (ioppar(h_IOPPAR_mem).ne.iTmpReg12) then
         write(szTmp,*) 'mem=',iTmpReg12,achar(0)
         call asv_update_kv(szTmp,iASV,szData,0)
      end if

c SG 11/15/97
c Call FigIO to calculate CACHE_RECS and FILE_RECSIZ based on MEMORY_SIZE
      iTmpReg15 = ioppar(h_IOPPAR_cache_recs)
      iTmpReg16 = ioppar(h_IOPPAR_file_recsiz)
      call FigIO(ioppar(h_IOPPAR_mem),iTmpReg15,iTmpReg16)
      write(szTmp,*) 'cache_recs=',iTmpReg15,achar(0)
      call asv_update_kv(szTmp,iASV,szData,0)
      write(szTmp,*) 'file_recsiz=',iTmpReg16,achar(0)
      call asv_update_kv(szTmp,iASV,szData,0)

c   o print the ASV validation footer
      if (bVerbose) print *, '    ', ('-',iTmpReg14=1,70)

c ----------------------------------------------------------------------

c WARN THE USER OF ANY FINAL ASV COMBINATIONS OR JUST DIE

c If triples are requested, and standard orbitals are enforced by the user,
c then write out a warning message
      if (ioppar(h_IOPPAR_orbitals).eq.0.and.
     &    ioppar(h_IOPPAR_ref     ).eq.2.and.
     &    (ioppar(h_IOPPAR_calc).eq. 4.or.
     &     ioppar(h_IOPPAR_calc).eq.13.or.
     &     ioppar(h_IOPPAR_calc).eq.22    )
     &   ) then
         print *,
     &'\n',
     &'********** WARNING !!! *******************************\n',
     &'   The requested method is not correct to fourth order\n',
     &'nor satisfies the usual invariance of CC or MBPT\n',
     &'methods with respect to orbital rotations.\n',
     &'   We recommend using semicanonical orbitals!\n',
     &'********** WARNING !!! *******************************\n',
     &'\n'
      end if

cWJL 1/12/94 JDW; 3/14/94
c  Here we need to check that the user is doing a TDHF calculation only for
c  a RHF reference.  If not, then bomb out!
      if (ioppar(h_IOPPAR_ref ).ne.0.and.
     &    ioppar(h_IOPPAR_tdhf).eq.1     ) then
         print *, '@GTFLGS: TDHF calculation only valid for RHF.'
         call errex
      end if

cJDW 3/31/94
c Stop NMR calculations (apart from CCSDeH) which cannot use sphericals.
c Also, always stop if PROP=TDHF has been specified.
      if (ioppar(h_IOPPAR_spherical).eq. 1.and.
     &    ioppar(h_IOPPAR_props    ).ne. 7.and.
     &    ioppar(h_IOPPAR_props    ).ne.11.and.
     &    ioppar(h_IOPPAR_props    ).ge. 3     ) then
         print *, '@GTFLGS: SPHERICAL=ON impossible for this',
     &            ' kind of NMR calculation.'
         call errex
      end if
      if (ioppar(h_IOPPAR_props).eq.7) then
         print *, '@GTFLGS: Use TDHF=ON and $INPUT namelist for',
     &            ' TDHF calculations (see manual).'
         call errex
      end if

c   o SYM=FULL
      if (ioppar(h_IOPPAR_sym).eq.3) then
         if (ioppar(h_IOPPAR_integrals).eq.1) then
            print *, '@GTFLGS: VMOL does not understand high symmetry'
            call errex
         end if
         if (ioppar(h_IOPPAR_integrals).eq.4) then
            print *, '@GTFLGS: seward does not understand high symmetry'
            call errex
         end if
      end if

c   o SYM!=OFF
      if (ioppar(h_IOPPAR_integrals).eq.5.and.
     &    ioppar(h_IOPPAR_sym      ).gt.1     ) then
         print *, '@GTFLGS: GAMESS cannot use symmetry.'
         call errex
      end if

c   o VibFreq AND GeomOpt?
c      if (ioppar(h_IOPPAR_vib     ).ne.0.and.
c     &    ioppar(h_IOPPAR_geom_opt).ne.0     ) then
c         print *,
c     &'@GTFLGS: Geometry optimizations and vibrational frequencies'
c         print *,
c     &'         are currently mutually exclusive.'
c         call errex
c      end if

c   o Response density matrix makes no sense for analytical gradients.
      if (ioppar(h_IOPPAR_density).eq.1.and.
     &    ioppar(h_IOPPAR_grad_calc).eq.1.and.
     &    (ioppar(h_IOPPAR_geom_opt).ne.0.or.ioppar(h_IOPPAR_vib).ne.0)
     &   ) then
         print *, '@GTFLGS: Geometry optimizations or Frequency'
         print *, '         calculations are not valid with the'
         print *, '         response density matrix.'
         call errex
      endif

c   o INTEGRALS=CADPAC?
      if (ioppar(h_IOPPAR_integrals).eq.3) then
         print *, '@GTFLGS: Integral program not available.'
         call errex
      end if

cJDW 9/16/97.
c I am assuming ioppar(h_IOPPAR_ref) will not change further down!
c Trap situation when an open-shell occupation has been
c specified and the reference is RHF. Stop the job in this
c case --- in the past we used to set REFERENCE=UHF.
      if (ioppar(h_IOPPAR_occ).eq.2.and.ioppar(h_IOPPAR_ref).eq.0) then
         print *, '@GTFLGS: Open-shell OCCUPATION is incompatible'
         print *, '         with RHF reference. Please specify an'
         print *, '         appropriate reference.               '
         call errex
      end if

c   o (REF == RHF) && (MULT != 1)
      if (ioppar(h_IOPPAR_ref).eq.0.and.ioppar(h_IOPPAR_mult).ne.1) then
         print *, '@GTFLGS: MULTIPLICITY must be 1 for RHF.'
         call errex
      end if

c   o DROPMO limitations
      if (nDrop(1)+nDrop(2).ne.0) then
         if (ioppar(h_IOPPAR_abcdtype ).ne.0.and.
     &       ioppar(h_IOPPAR_deriv_lev).gt.0    ) then
            print *, '@GTFLGS: No AO-basis gradients with dropped MOs.'
            call errex
         end if
      end if
C
c   o NOREORI and finite difference vibrational frequency calculations.
c
      if (ioppar(h_IOPPAR_vib) .gt. 1) then
         if (ioppar(h_IOPPAR_noreori).eq.1) then
             Print*, " '@GTFLGS: NOREORI=ON is not compatible with"
             Print*, "finite difference frequency calculations"
             call errex
          endif
      endif
c ----------------------------------------------------------------------

c IF REQUESTED, PRINT A NICE TABULAR LISTING OF THE CONTROL PARAMETERS.
      if (iPrt.ne.0) then

c   o dump the handles and integers
      call asv_dump

c   o print the ASV strings header
      print *, '                        ACES STATE VARIABLES (STRINGS)'
      print *, '         ', ('-',iTmpReg17=1,60)

c   o BASIS
      print '(10x,a,a)', 'BASIS = ',BasNam(1:linblnk(BasNam))

c   o OCCUPATION
      if (ioppar(h_IOPPAR_occ).eq.0) then
         print '(10x,a)', 'OCCUPATION = [ESTIMATED BY SCF]'
      else
         print '(10x,a,8i4)', 'OCCUPATION = A: ',(nOcc(j,1),j=1,nIrrps)
         if (ioppar(h_IOPPAR_occ).eq.2) then
         print '(10x,a,8i4)', '             B: ',(nOcc(j,2),j=1,nIrrps)
         end if
      end if

c   o IP_SYM
      if (ioppar(h_IOPPAR_ip_calc).ne.0) then
         call igetrec(20,'JOBARC','IPSYM_A ',nIrrps,iArr)
         print '(10x,a,8i4)', 'IP_SYM = A: ',(iArr(j),j=1,nIrrps)
         if (ioppar(h_IOPPAR_ref).ne.0) then
         call igetrec(20,'JOBARC','IPSYM_B ',nIrrps,iArr)
         print '(10x,a,8i4)', '         B: ',(iArr(j),j=1,nIrrps)
         end if
      end if

c   o EA_SYM
      if (ioppar(h_IOPPAR_ea_calc).ne.0) then
         call igetrec(20,'JOBARC','EASYM_A ',nIrrps,iArr)
         print '(10x,a,8i4)', 'EA_SYM = A: ',(iArr(j),j=1,nIrrps)
         if (ioppar(h_IOPPAR_ref).ne.0) then
         call igetrec(20,'JOBARC','EASYM_B ',nIrrps,iArr)
         print '(10x,a,8i4)', '         B: ',(iArr(j),j=1,nIrrps)
         end if
      end if

c   o DROPMO
      if (nDrop(1).ne.0) then
         iTmpReg19 = min(12,nDrop(1))
         print '(10x,a,12i4)', 'DROPMO = ',(iDrop(j,1),j=1,iTmpReg19)
         if (nDrop(1).gt.12) then
            do while (iTmpReg19.lt.nDrop(1))
               iTmpReg20 = min(12,nDrop(1)-iTmpReg19)
               print '(19x,12i4)', (iDrop(iTmpReg19+j,1),j=1,iTmpReg20)
               iTmpReg19 = iTmpReg19 + iTmpReg20
            end do
         end if
      end if

c   o FD_IRREPS (max 8)
      if (ioppar(h_IOPPAR_fd_irreps).ne.0) then
         iTmpReg21 = ioppar(h_IOPPAR_fd_irreps)
         call igetrec(20,'JOBARC','FDIRREP ',iTmpReg21,iArr)
         print '(10x,a,8i4)', 'FD_IRREPS = ',(iArr(j),j=1,iTmpReg21)
      end if

c   o ESTATE_SYM (max 8)
      if (ioppar(h_IOPPAR_estate_sym).ne.0) then
         iTmpReg28 = ioppar(h_IOPPAR_estate_sym)
         call igetrec(20,'JOBARC','EESYMINF',iTmpReg28,iArr)
         print '(10x,a,8i4)', 'ESTATE_SYM = ',(iArr(j),j=1,iTmpReg28)
      end if

c   o QRHF ASVs
      if (ioppar(h_IOPPAR_qrhf_gen).ne.0) then
         iTmpReg22 = ioppar(h_IOPPAR_qrhf_gen)
         call igetrec(20,'JOBARC','QRHFIRR ',iTmpReg22,iArr)
         iTmpReg23 = min(12,iTmpReg22)
         print '(10x,a,12i4)', 'QRHF_GEN = ',(iArr(j),j=1,iTmpReg23)
         if (iTmpReg22.gt.12) then
            do while (iTmpReg23.lt.iTmpReg22)
               iTmpReg24 = min(12,iTmpReg22-iTmpReg23)
               print '(21x,12i4)', (iArr(iTmpReg23+j),j=1,iTmpReg24)
               iTmpReg23 = iTmpReg23 + iTmpReg24
            end do
         end if
      end if
      if (ioppar(h_IOPPAR_qrhf_orb).ne.0) then
         iTmpReg25 = ioppar(h_IOPPAR_qrhf_orb)
         call igetrec(20,'JOBARC','QRHFLOC ',iTmpReg25,iArr)
         iTmpReg26 = min(12,iTmpReg25)
         print '(10x,a,12i4)', 'QRHF_ORB = ',(iArr(j),j=1,iTmpReg26)
         if (iTmpReg25.gt.12) then
            do while (iTmpReg26.lt.iTmpReg25)
               iTmpReg27 = min(12,iTmpReg25-iTmpReg26)
               print '(21x,12i4)', (iArr(iTmpReg26+j),j=1,iTmpReg27)
               iTmpReg26 = iTmpReg26 + iTmpReg27
            end do
         end if
      end if

c   o print the ASV strings footer
      print *, '         ', ('-',iTmpReg18=1,60)

c     end if (iPrt.ne.0)
      end if

c ----------------------------------------------------------------------

c DUMP IOPPAR AND THE OCCUPATION VECTOR TO JOBARC.

      if (bExist_JOBARC) then

c      o IFLAGS
         call iputrec(20,'JOBARC','IFLAGS  ',dim_iflags,ioppar)
         call iputrec(20,'JOBARC','IFLAGS2 ',dim_iflags2,
     &                                             ioppar(dim_iflags+1))

c      o OCCUPATION
         call iputrec(20,'JOBARC','OCCUPYA ',nIrMax,nOcc(1,1))
         if (ioppar(h_IOPPAR_ref).ne.0) then
            call iputrec(20,'JOBARC','OCCUPYB ',nIrMax,nOcc(1,2))
         end if

c      o DROPMO
         call iputrec(20,'JOBARC','NUMDROPA',1,nDrop(1))
         if (nDrop(1).ne.0) then
            call iputrec(20,'JOBARC','MODROPA ',nDrop(1),iDrop(1,1))
         end if
         if (ioppar(h_IOPPAR_ref).ne.0) then
            call iputrec(20,'JOBARC','NUMDROPB',1,nDrop(2))
            if (nDrop(2).ne.0) then
               call iputrec(20,'JOBARC','MODROPB ',nDrop(2),iDrop(1,2))
            end if
         end if

c      o JODAFLAG (17 consecutive ASVs)
         call iputrec(20,'JOBARC','JODAFLAG',JPARAM,
     &               ioppar(h_IOPPAR_joda_print))
      end if

      i1  = ioppar(h_IOPPAR_joda_print)
      i2  = ioppar(h_IOPPAR_opt_method)
      i3  = ioppar(h_IOPPAR_convergence)
      i4  = ioppar(h_IOPPAR_eigenvector)
      i5  = ioppar(h_IOPPAR_negeval)
      i6  = ioppar(h_IOPPAR_curvilinear)
      i7  = ioppar(h_IOPPAR_stp_siz_ctl)
      i8  = ioppar(h_IOPPAR_max_step)
      i9  = ioppar(h_IOPPAR_vibration)
      i10 = ioppar(h_IOPPAR_eval_hess)
      i11 = ioppar(h_IOPPAR_integrals)
      i12 = ioppar(h_IOPPAR_fd_stepsize)
      i13 = ioppar(h_IOPPAR_points)
      i14 = ioppar(h_IOPPAR_contraction)
      i15 = ioppar(h_IOPPAR_symmetry)
      i16 = ioppar(h_IOPPAR_basis)
      i17 = ioppar(h_IOPPAR_spherical)
cYAU - already initialized to zero
c      iErr = 0

c stop if RESET_FLAGS is ON
      if (ioppar(h_IOPPAR_reset_flags).eq.1) then
         call aces_ja_fin
         call joda_exit(0, '@GTFLGS')
      end if

c      close(unit=LUZ,status='KEEP')
      return

c ----------------------------------------------------------------------

 8000 write(*,*) '@GTFLGS: There was a problem reading ZMAT.'
cYAU - Why set this and then crash?
c      iErr = 1
      call errex

cYAU - not used
c 8111 iErr = 2
c      GOTO 159

 5400 write(*,*) '@GTFLGS: ZMAT is missing the ACES2 namelist.'
      close(unit=luz,status='KEEP')
      call errex

      return
      end

      SUBROUTINE TRACEOO(TYPE,IRREPIN,POP,VRT,LENW,LENZ,W,Z)
C
C THIS ROUTINE ACCEPTS A SYMMETRY PACKED FOUR-INDEX ARRAY AND FORMS
C  ONE OF THE FOLLOWING SUMS.  THE RETURNED ARRAY (Z) IS ALSO SYMMETRY
C  PACKED. (ALL SUMS BELOW ARE OVER M).
C
C           Z(EB) =  SUM   W(ME-BM)     (TYPE = 'OVVO')
C           Z(EB) =  SUM   W(EM-MB)     (TYPE = 'VOOV')
C           Z(EB) =  SUM   W(EM-BM)     (TYPE = 'VOVO')
C           Z(EB) =  SUM   W(ME-MB)     (TYPE = 'OVOV')
C
C
C INPUT: TYPE    (CHARACTER*4)
C        IRREPIN (INTEGER): THE IRREP OF GAMMA(MB) AND GAMMA(EM).
C        POP (INTEGER [8]): OCCUPATION NUMBERS BY IRREP.
C        VRT (INTEGER [8]): # OF VIRTUAL ORBITALS BY IRREP.
C        NSIZ (INTEGER)   : THE DIMENSION OF W (WHICH IS A SQUARE MATRIX).
C        W (DP ARRAY)     : THE FOUR-INDEX ARRAY TO BE SUMMED OVER.
C
C OUTPUT: Z (DP ARRAY)    : THE SUMS DESCRIBED BY THE EQUATIONS ABOVE.
C
CEND
C
C COMPUTE OFFSETS FOR VARIOUS 2 DISTRIBUTION TYPES (OV AND VO) AND
C THE TARGET DISTRIBUTION TYPE (VV).
C
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(LENZ),W(LENW,LENW)
      CHARACTER*4 TYPE
      DIMENSION IOFFVO(8),IOFFOV(8),IOFFVV(8),POP(8),VRT(8)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      INDX(I,J,N)=I+(J-1)*N
      IOFF1=0
      IOFF2=0
      IOFF3=0
      DO 1000 IRREP=1,NIRREP
       IRREPX=DIRPRD(IRREP,IRREPIN)
       IOFFVO(IRREP)  =IOFF1
       IOFFOV(IRREP)  =IOFF2
       IOFFVV(IRREP)=IOFF3
       IOFF1=IOFF1+POP(IRREP)*VRT(IRREPX)
       IOFF2=IOFF2+VRT(IRREP)*POP(IRREPX)
       IOFF3=IOFF3+VRT(IRREP)*VRT(IRREP)
1000  CONTINUE
      CALL ZERO(Z,IOFF3)
      IF(TYPE.EQ.'OVVO')THEN
       DO 10 IRREPMJ=1,NIRREP
        IRREPBE=DIRPRD(IRREPMJ,IRREPIN)
        DO 20 M=1,POP(IRREPMJ)
         J=M
         DO 30 B=1,VRT(IRREPBE)
          DO 40 E=1,VRT(IRREPBE)
           INDEXR=INDX(B,M,VRT(IRREPBE))+IOFFVO(IRREPMJ)
           INDEXL=INDX(J,E,POP(IRREPMJ))+IOFFOV(IRREPBE)
           INDTAR=INDX(E,B,VRT(IRREPBE))+IOFFVV(IRREPBE)
           Z(INDTAR)=Z(INDTAR)+W(INDEXL,INDEXR)
40        CONTINUE
30       CONTINUE
20      CONTINUE
10     CONTINUE 
      ELSEIF(TYPE.EQ.'VOVO')THEN
       DO 110 IRREPMJ=1,NIRREP
        IRREPBE=DIRPRD(IRREPMJ,IRREPIN)
        DO 120 M=1,POP(IRREPMJ)
         J=M
         DO 130 B=1,VRT(IRREPBE)
          DO 140 E=1,VRT(IRREPBE)
           INDEXR=INDX(B,M,VRT(IRREPBE))+IOFFVO(IRREPMJ)
           INDEXL=INDX(E,J,VRT(IRREPBE))+IOFFVO(IRREPMJ)
           INDTAR=INDX(E,B,VRT(IRREPBE))+IOFFVV(IRREPBE)
           Z(INDTAR)=Z(INDTAR)+W(INDEXL,INDEXR)
140       CONTINUE
130      CONTINUE
120     CONTINUE
110    CONTINUE
      ELSEIF(TYPE.EQ.'OVOV')THEN
       DO 210 IRREPMJ=1,NIRREP
        IRREPBE=DIRPRD(IRREPMJ,IRREPIN)
        DO 220 M=1,POP(IRREPMJ)
         J=M
         DO 230 B=1,VRT(IRREPBE)
          DO 240 E=1,VRT(IRREPBE)
           INDEXR=INDX(M,B,POP(IRREPMJ))+IOFFOV(IRREPBE)
           INDEXL=INDX(J,E,POP(IRREPMJ))+IOFFOV(IRREPBE)
           INDTAR=INDX(E,B,VRT(IRREPBE))+IOFFVV(IRREPBE)
           Z(INDTAR)=Z(INDTAR)+W(INDEXL,INDEXR)
240       CONTINUE
230      CONTINUE
220     CONTINUE
210    CONTINUE
      ELSEIF(TYPE.EQ.'VOOV')THEN
       DO 310 IRREPMJ=1,NIRREP
        IRREPBE=DIRPRD(IRREPMJ,IRREPIN)
        DO 320 M=1,POP(IRREPMJ)
         J=M
         DO 330 B=1,VRT(IRREPBE)
          DO 340 E=1,VRT(IRREPBE)
           INDEXR=INDX(M,B,POP(IRREPMJ))+IOFFOV(IRREPBE)
           INDEXL=INDX(E,J,VRT(IRREPBE))+IOFFVO(IRREPMJ)
           INDTAR=INDX(E,B,VRT(IRREPBE))+IOFFVV(IRREPBE)
           Z(INDTAR)=Z(INDTAR)+W(INDEXL,INDEXR)
340       CONTINUE
330      CONTINUE
320     CONTINUE
310    CONTINUE
      ENDIF
      RETURN
      END

C THIS ROUTINE CONVERTS FROM THE MBPT/CC DENOMINATOR
C
C     1/(Fii + Fjj - Faa - Fbb) 
C
C TO THE CI DENOMINATOR
C
C     1/(Fii + Fjj - Faa - Fbb + Ecorr)

      SUBROUTINE CIDENOM(N,ECORR,VEC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(1)
c old
c      DO 10 I=1,N
c       X1=VEC(I)
c       X2=1./X1
c       X2=X2+ECORR
c       VEC(I)=1.0/X2
c10    CONTINUE
c new
      if (n.lt.1) return
      DO I = 1, N
         X = 1.0d0 + ( Ecorr * VEC(I) )
         X = 1.0d0 / X
         VEC(I) = VEC(I) * X
      END DO
c end
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_restart_status(x, nindex, type, bval,
     *                              eval, bdim, edim)
c---------------------------------------------------------------------------
c   Returns 1 or 0 in the scalar argument, depending on whether the current
c   SIAL program has been restarted or not.  If the SIAL program has been
c   restarted, a 1 is returned only for the first call to get_restart_status,
c   all other calls to this instruction will return a 0.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'checkpoint_data.h'

      double precision x
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      double precision val

      if (restart_status) then
         val = 1.0
         restart_status = .false.
      else
         val = 0.0
      endif

      x = val
      return
      end

C POSITIONS POINTER AT END OF SEQUENTIAL FILE. IUNIT IS THE UNIT NUMBER.

      SUBROUTINE ENDSEQ(IUNIT)
      IMPLICIT INTEGER (A-Z)
      parameter (i = 0)
      do while (i.eq.0)
         READ(IUNIT,END=100,ERR=200,IOSTAT=IER) JUNK
      end do
100   RETURN
200   CALL IOERR('ENDSEQ',IUNIT,IER)
      END

         SUBROUTINE  OED__NAI_INT1D_TO_E0_F12
     +
     +                    ( SHELLA,SHELLP,
     +                      NEXP,NGQPCEN,NGEXCEN,
     +                      NXYZET,NXYZP,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_INT1D_TO_E0
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                nuclear attraction integrals:
C
C                             [E|0] , E = A to P = A + B,
C
C                adding up the contributions from all the 1D integrals
C                for all nuclear centers.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                1DX and 1DY integrals, which can be achieved by having
C                the outer loops run over all possible x and y monomial
C                parts and the inner loop over all allowed E shells.
C
C                For details of the algorithm used, especially how the
C                monomial basis is organized and how to find the batch
C                address for a specific x,y,z,E combination, see the
C                corresponding routine for the ERI evaluations.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A and csh sum P=A+B
C                    NEXP        =  current # of exponent pairs
C                    NGQPCEN     =  product of # of gaussian quadrature
C                                   points (roots) times # of nuclear
C                                   attraction centers
C                    NGEXCEN     =  product of # of gaussian quadrature
C                                   points times # of exponent pairs
C                                   times # of nuclear attraction
C                                   centers
C                    NXYZET      =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B
C                    NXYZP       =  # of cartesian monomials for the
C                                   P=A+B shell
C                    INT1Dx      =  all current 1D nuclear attraction
C                                   integrals for each cartesian
C                                   component (x = X,Y,Z)
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1D integral products
C                    SCALE       =  the NGEXCEN scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   nuclear attraction integrals
C                                   corresponding to all current
C                                   exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program OED
C
C    This routine is part of the integral program package OED and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routines of the
C    OED package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,K,M,N
         INTEGER     NEXP,NGQPCEN,NGEXCEN
         INTEGER     NXYZE,NXYZET,NXYZP
         INTEGER     SE,SEEND
         INTEGER     SHELLA,SHELLP
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX
         INTEGER     XEP,XYEP
         INTEGER     XYE
         INTEGER     YEEND

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO,STGEXP,UVAL(1:NEXP)

         DOUBLE PRECISION  SCALE (1:NGEXCEN)
         DOUBLE PRECISION  TEMP1 (1:NGEXCEN)
         DOUBLE PRECISION  TEMP2 (1:NGEXCEN),RTS(1:NGEXCEN)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZET)

         DOUBLE PRECISION  INT1DX (1:NGEXCEN,0:SHELLP)
         DOUBLE PRECISION  INT1DY (1:NGEXCEN,0:SHELLP)
         DOUBLE PRECISION  INT1DZ (1:NGEXCEN,0:SHELLP)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...outer loop over x contributions. No skipping of the
C                x contribution of 0-type can be done here, since
C                the 1DX integrals carry the Rys weight!
C
C
         XEP = NXYZET + 3
         DO 100 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO N = 1,NGEXCEN
               TEMP1 (N) = SCALE (N) * INT1DX (N,XE)
            END DO
C
C
C             ...middle loop over y contributions. Skip multiplication
C                of y contributions, if we have y = 0, as then the
C                1DY integral is equal to 1.
C
C
            XYEP = XEP - XEMAX
            DO 200 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGEXCEN
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGEXCEN
                      TEMP2 (N) = TEMP1 (N) * INT1DY (N,YE)
                   END DO
               END IF
C
C
C             ...inner loop over z,E contributions. Skip multiplication
C                of z,E contributions, if we have z = 0, as then the
C                1DY integral is equal to 1.
C
C
               I = XYEP
               NXYZE = NXYZP
               DO 300 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE
C
C
C             ...all info concerning all three x,y and z contributions
C                have been collected for all exponent pairs, nuclear
C                centers and quadrature points at once. Sum up the
C                1D X,Y,Z integral products over the nuclear centers
C                and the quadrature points to the appropriate place of
C                the [E|0] batch.
C
C
                  IF (ZE.EQ.0) THEN
                      K = 0
                      DO M = 1,NEXP
                         SUM = ZERO
                         DO N = 1,NGQPCEN
                            SUM = SUM + TEMP2 (K+N)*(1.d0-RTS(K+N) )
                         END DO
                         K = K + NGQPCEN
                         BATCH (M,I) = SUM*(2.d0*UVAL(M)/STGEXP)
                      END DO
                  ELSE
                      K = 0
                      DO M = 1,NEXP
                         SUM = ZERO
                         DO N = 1,NGQPCEN
             SUM = SUM + TEMP2 (K+N) * INT1DZ (K+N,ZE)*(1.d0-RTS(K+N) )
                         END DO
                         K = K + NGQPCEN
                         BATCH (M,I) = SUM*(2.d0*UVAL(M)/STGEXP)
                      END DO
                  END IF
C
C
C             ...next z,E contribution.
C
C
                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  300          CONTINUE
C
C
C             ...next y and x contribution.
C
C
  200       CONTINUE
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine prefetch_on(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      call set_prefetch_flag(.true.)
      return
      end
       

c This routine supplies the character*1 function 'achar' if the Fortran
c compiler does not contain it as an intrinsic. This was first seen on
c an OSF/DEC compiler.

c Recall: achar returns the ASCII character of a decimal number while
c         char returns the internal character representation of a decimal.

#ifdef _CHAR_IS_ACHAR
      character*1 function achar(num)
      implicit none
      integer num
      character*1 char
      external char
      achar = char(num)
      return
      end
#else
#include "return.f"
#endif /* _CHAR_IS_ACHAR */

c This routine supplies the character*1 function 'achar' if the Fortran
c compiler does not contain it as an intrinsic. This was first seen on
c an OSF/DEC compiler.

c Recall: achar returns the ASCII character of a decimal number while
c         char returns the internal character representation of a decimal.


c This routine does NOTHING. Other files will include it so rigid
c Fortran compilers have something to do when a cpp define removes all
c of the compilable code in the .f file.

      subroutine to_combat_compiler_stupidity()
      return
      end

      SUBROUTINE CHECK(IAORDS,ISOM,ICHSO,ISOR,ISOC,JAOR)
C
C     CHECK WHETHER IT SI A NEW REDUCTION SET AND COPY IT TO DUMP
C
C     IAORDS ..... CURRENT AO REDUCTION SET
C     INFO(1,I) .. START ADRESS-1 OF I'TH REDUCTION SET
C     INFO(I,2) .. DIMENSIONS #ROWS = # OF SO'S
C     INFO(I,3) .. DIMENSIONS #COLUMNS = # OF AO'S
C
      IMPLICIT INTEGER (A-Z)
C
      DIMENSION ICHSO(ISOR),ISOM(ISOR,ISOC)
      COMMON/WORK/  IDUM(10000),INFO(100,3)
C
      INFO(1,1)=0
C
C     IF NEW REDUCTION SET IS GENERATED
C     DUMP INFORMATION ON IDUM.
C
      IADR=INFO(IAORDS,1)
      INFO(IAORDS+1,1)=ISOR*(ISOC+1)+IADR
      INFO(IAORDS,2) = ISOR
      INFO(IAORDS,3) = ISOC
      DO 110 I=1,ISOR
         IADR=IADR+1
         IDUM(IADR) = ICHSO(I)
 110  CONTINUE
      DO 130 J=1,ISOR
         DO 120 I=1,ISOC
            IADR=IADR+1
            IDUM(IADR)=ISOM(J,I)
 120     CONTINUE
 130  CONTINUE
C
C     COMPARE IF AORDS OCCURS ALREADY.
C
      JJ=IAORDS-1
      IF(JJ.LT.1) GO TO 175
      DO 170 JAORDS=1,JJ
         LAOR=JAORDS
         IF(INFO(JAORDS,2).NE.INFO(IAORDS,2).OR.
     1      INFO(JAORDS,3).NE.INFO(IAORDS,3)) GO TO 170
         DO 140 I=1,ISOR
            IADDR=INFO(JAORDS,1)+I
            IADR=INFO(IAORDS,1)
            IF(IDUM(IADDR).NE.IDUM(IADR+I))GO TO 170
 140     CONTINUE
         DO 160 J=1,ISOR
            IADDR=INFO(JAORDS,1)+ISOR+ISOC*(J-1)
            DO 150 I=1,ISOC
               IF(IDUM(IADDR+I).NE.
     1            ISOM(J,I)) GO TO 170
 150        CONTINUE
 160     CONTINUE
         GO TO 180
 170  CONTINUE
 175  JAOR=IAORDS
      RETURN
 180  CONTINUE
      IAORDS=IAORDS-1
      JAOR=LAOR
      RETURN
      END

c This routine removes dummy atoms from the molecule.  It is necessary
c since JODA stores the molecular information with dummy atoms (it needs
c that information each time), but no other module should ever need
c this.  So, by default, all dummy atoms are removed.

      subroutine sb_removedummy(atommass,coord,atomchrg,
     &                          fullmemb,compmemb,natomsx)
      implicit none

      double precision atommass(*),coord(3,*)
      integer atomchrg(*),fullmemb(*),compmemb(*),natomsx

      integer iatom,iatm,ndum

      iatm=0
      ndum=0
      do iatom=1,natomsx
         if (atomchrg(iatom).eq.0) then
            ndum=ndum+1
         else
            iatm=iatm+1
            atommass(iatm)=atommass(iatom)
            coord(1,iatm)=coord(1,iatom)
            coord(2,iatm)=coord(2,iatom)
            coord(3,iatm)=coord(3,iatom)
            atomchrg(iatm)=atomchrg(iatom)
            fullmemb(iatm)=fullmemb(iatm)-ndum
            compmemb(iatm)=compmemb(iatm)-ndum
c            fullpopv(iatm)=fullpopv(iatom)
c            comppopv(iatm)=comppopv(iatom)
         end if
      end do

      return
      end

      SUBROUTINE T2STAT(T2OLD,T2NEW,SYVEC1,SYVEC2,NSIZET,NSMSZ1,NSMSZ2,
     &                  ISPIN,ICONVG,TOL,NLIST,TYPE)
C
C THIS ROUTINE ACCEPTS TWO T1 VECTORS AND FINDS THE LARGEST
C  AND RMS DIFFERENCE BETWEEN THEIR ELEMENTS AND DETERMINES
C  IF THEY ARE IDENTICAL TO WITHIN A SET TOLERANCE.
C
C INPUT:  
C       T2OLD - ONE OF THE TWO T1 VECTORS.
C       T2NEW - THE OTHER T1 VECTOR.
C       SYVEC1- THE AB SYMMETRY VECTOR FOR THIS SPIN CASE
C       SYVEC2- THE IJ SYMMETRY VECTOR FOR THIS SPIN CASE
C       NSIZET- LENGTH OF THE SYMMETRY-PACKED T2 VECTOR.
C       NSMSZ1- LENGTH OF THE AB SYMMETRY VECTOR 
C       NSMSZ2- LENGTH OF THE IJ SYMMETRY VECTOR 
C       ISPIN - THE SPIN CASE
C       TOL   - THE CONVERGENCE CRITERION
C       NLIST - THE LIST NUMBER ON WHICH THE VALUES RESIDE
C       TYPE  - ?????????
C
C OUTPUT:
C       ICONVG- RETURNED AS "0" IF VALUES ARE CONVERGED, "1"
C               OTHERWISE.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A,B,SYVEC1(NSMSZ1),SYVEC2(NSMSZ2) 
      CHARACTER*1 TYPE
      CHARACTER*2 SPCASE(3)
      DIMENSION T2OLD(NSIZET),T2NEW(NSIZET)
      COMMON /FLAGS/ IFLAGS(100)
      DATA SPCASE /'AA','BB','AB'/
      DATA ONEM /-1.0/
C
      IF(NSIZET.EQ.0)RETURN
C
C FORM T2DIFF = T2NEW - T2OLD
C
      LSTOLD=43+ISPIN+NLIST
      LSTNEW=60+ISPIN
      CALL GETALL(T2OLD,NSIZET,1,LSTOLD)
      CALL GETALL(T2NEW,NSIZET,1,LSTNEW)
      CALL VADD(T2OLD,T2NEW,T2OLD,NSIZET,ONEM)
      RMSDIF=SNRM2(NSIZET,T2OLD,1)
      RMSDIF=RMSDIF/FLOAT(NSIZET)
      MAXDIF=ISAMAX(NSIZET,T2OLD,1)
      DIFMAX=T2OLD(MAXDIF)
      IF(DABS(DIFMAX).GT.TOL)ICONVG=1
      CALL PCKIND(MAXDIF,ISPIN,SYVEC1,SYVEC2,NSMSZ1,NSMSZ2,I,J,A,B)
      IF(IFLAGS(1).GE.10)THEN
       WRITE(*,100)TYPE,'2',SPCASE(ISPIN),RMSDIF,DIFMAX,I,J,A,B
  100  FORMAT(T9,A1,A1,T19,A2,T24,F13.10,T37,F13.10,T52,I3,T57,I3,T62,
     &        I3,T67,I3)
      ENDIF
      RETURN
      END

      subroutine wrt_hyprchm(natoms,coords,freqs,feigs,intens,anum,
     .                       tbohr, hfcrap, linear, iord, itag)
c
c     natoms = the total number of atoms in the calculation (INTEGER)
c
c     coords = a (natoms,3) array of cartesian coordinates (REAL)
c
c     freqs = the array that contains the eigenvalues of the Hessian (REAL)
c
c     feigs = the array that contains the eigenvectors of the Hessian (REAL)
c             (it is presumed the null vectors have been removed)
c
c     intens = the array that contains the IR intensities (REAL)
c
c     anum = the array that contains the atomic numbers (INTEGER)
c
c     atype = the array that contains the atomic symbols (CHARACTER)
c
c     itag = the array that contains the connectivity table (INTEGER)
c            (itag(natoms,10) designates the number of atoms bonded to
c             atom "x")
c
c     hfcrap = .true. if a frequency run was performed
c
c     linear = .true. if the molecular system is linear
c
c
c------ Warnings
c     The character array "line" in "subroutine entscr", dimensioned
c     currently to 10000, limits that array to a little more than 300
c     atomic centers. This is the only known hard-wired size limitation.
c------ Warnings
c

      implicit double precision (a-h,o-z)
      double precision intens(*)
      integer anum(*)
      character*2 atype(111)
      dimension coords(3,natoms),freqs(*),feigs(9*natoms*natoms),
     .          iord(*), itag(natoms,10)
      logical  tbohr, hfcrap, linear

      data bohr / 0.52917724924d0 /

      data atype / ' H', 'He', 'Li', 'Be', ' B', ' C', ' N', ' O', ' F',
     .             'Ne', 'Na', 'Mg', 'Al', 'Si', ' P', ' S', 'Cl', 'Ar',
     .             ' K', 'Ca', 'Sc', 'Ti', ' V', 'Cr', 'Mn', 'Fe', 'Co',
     .             'Ni', 'Cu', 'Zn', 'Ga', 'Ge', 'As', 'Se', 'Br', 'Kr',
     .             'Rb', 'Sr', ' Y', 'Zr', 'Nb', 'Mo', 'Tc', 'Ru', 'Rh',
     .             'Pd', 'Ag', 'Cd', 'In', 'Sn', 'Sb', 'Te', ' I', 'Xe',
     .             'Cs', 'Ba', 'La', 'Ce', 'Pr', 'Nd', 'Pm', 'Sm', 'Eu',
     .             'Gd', 'Tb', 'Dy', 'Ho', 'Er', 'Tm', 'Yb', 'Lu', 'Hf',
     .             'Ta', ' W', 'Re', 'Os', 'Ir', 'Pt', 'Au', 'Hg', 'Tl',
     .             'Pb', 'Bi', 'Po', 'At', 'Rn', 'Fr', 'Ra', 'Ac', 'Th',
     .             'Pa', ' U', 'Np', 'Pu', 'Am', 'Cm', 'Bk', 'Cf', 'Es',
     .             'Fm', 'Md', 'No', 'Lr', 'Rf', 'Db', 'Sg', 'Bh', 'Hs',
     .             'Mt', 'Ds', 'Rg' /

c
c     if the supplied spatial coordinates are in units of
c     Bohr, then logical tbohr = .true., else tbohr = .false.
c
      if (tbohr) then
         do 100 i=1, natoms
            coords(1,i) = coords(1,i) * bohr
            coords(2,i) = coords(2,i) * bohr
            coords(3,i) = coords(3,i) * bohr
 100     continue
      endif

c
c     Generate the HYPERCHEM.hin file
c

      call hinfl(coords,atype,anum,natoms,itag)

c
c     logical hfcrap is set .true. if a frequency run was performed
c     and one wants the HyperChem "name.ent" and "name.scr" files
c     to be generated
c
      if (hfcrap) then
        call entscr(coords,atype,anum,natoms,itag,freqs,feigs,
     .              intens,linear,iord)
      endif

      return
      end




      subroutine entscr(coords,atype,anum,natoms,itag,freqs,feigs,
     .                  intens,linear,iord)
c
c     Subroutine entscr generates the "HYPERCHEN.ent" and "HYPERCHEM.scr"
c     files which HyperChem uses to display the vibrational modes
c
      implicit double precision (a-h,o-z)
      double precision intens(*)
      character*10000 line
      character*2 atype(*)
      integer anum(*)
      logical linear
      dimension coords(3,natoms), feigs(9*natoms*natoms), freqs(*), 
     .          itag(natoms,10), iord(*)
c
c     Generate the "ent" file
c
      open(unit=10,status='unknown',form='formatted',
     .     file='HYPERCHEM.ent')

      write(10,'(a)') 'HEADER'
      write(10,'(a)') 'REMARK From an Aces2 run'

      do 100 i=1, natoms
         write(10,'(a,i4,1x,a,10x,a,4x,3(1x,f7.3),23x,a)') 'HETATM ',i,
     .        atype(anum(i)),'1', (coords(j,i), j=1,3), atype(anum(i))
 100  continue

      do 110 i=1, natoms
         write(10,'(a,i4,9i5)')'CONECT ',i,(itag(i,j),j=1,itag(i,10))
 110  continue

      write(10,'(a)') 'END'
      write(10,'(a)') ' '
      close(unit=10,status='keep')

c
c     Generate the "scr" file
c

      open(unit=10,status='unknown',form='formatted',
     .     file='HYPERCHEM.scr')
c
c     If the system is linear then "linear = .true."
c
      if (linear) then
         nvec = natoms*3 - 5
      else
         nvec = natoms*3 - 6
      endif

      write(10,'(a)') 'file-format pdb'
      write(10,'(a)') 'open-file HYPERCHEM.ent'
      write(10,'(a,i5)') 'ir-band-count =  ', nvec


      do 150 i=1, nvec
         istr = 1
         istp = 10

         do 140 j=1, 3*natoms
            write(unit=line(istr:istp),fmt='(f9.6,a)') 
     .                 feigs((iord(i)-1)*3*natoms + j), ','
            istr = istr + 10
            istp = istp + 10
 140     continue

         write(10,'(a,i3,a,f12.4)') 'ir-frequency(',i,') = ',
     .        freqs(i)
         write(10,'(a,i3,a,f12.4)') 'ir-intensity(',i,') = ',
     .        intens(iord(i))
         write(10,'(a,i3,a,a)') 'ir-normal-mode(',i,') = ', 
     .        line(1:istp-11)
 150  continue

      write(10,'(a)') 'menu-compute-vibrational-spectrum'
      write(10,'(a)') 'exit-script'
      write(10,'(a)') ' '
      close(unit=10,status='keep')

      return
      end



      subroutine hinfl(coords,atype,anum,natoms,itag)
c
c     Subroutine hinfl generates the HyperChem "hin" file
c
      implicit double precision (a-h,o-z)
      character*2 atype(*)
      integer anum(*)
      dimension coords(3,natoms), radii(111), itag(natoms,10)
c
c     It is presumed no atom will have more than 9 valence bonds
c

c
c     The atomic covalent radii in A. 
c
c     From tabulations and averages of C(sp3)-X distances in Allen,
c     F.H., Kennard, O., Watson, D.G., Brammer, L., Orpen, A.G., &
c     Taylor, R. (1987) J.Chem. Soc. Perkin II, p. S1, subtracting
c     0.767 A for the radius of carbon. 
c
c     A value of 0.0d0 implies no value was found
c

      data radii /

c          H       He      Li      Be      B       C       N       O   
     . 0.299d0,0.000d0,1.562d0,1.060d0,0.830d0,0.767d0,0.702d0,0.659d0,
c          F       Ne      Na      Mg      Al      Si      P       S   
     . 0.619d0,0.000d0,1.911d0,1.602d0,1.180d0,1.090d0,1.088d0,1.052d0,
c          Cl      Ar      K       Ca      Sc      Ti      V       Cr  
     . 1.023d0,0.000d0,2.376d0,1.974d0,1.641d0,1.462d0,1.346d0,1.282d0,
c          Mn      Fe      Co      Ni      Cu      Zn      Ga      Ge  
     . 1.264d0,1.274d0,1.252d0,1.246d0,1.278d0,1.394d0,1.250d0,1.220d0,
c          As      Se      Br      Kr      Rb      Sr      Y       Zr  
     . 1.196d0,1.203d0,1.199d0,0.000d0,2.546d0,2.151d0,1.801d0,1.602d0,
c          Nb      Mo      Tc      Ru      Rh      Pd      Ag      Cd  
     . 1.468d0,1.400d0,1.360d0,1.339d0,1.345d0,1.376d0,1.445d0,1.568d0,
c          In      Sn      Sb      Te      I       Xe      Cs      Ba  
     . 1.410d0,1.390d0,1.370d0,1.391d0,1.395d0,0.000d0,2.731d0,2.243d0,
c          La      Ce      Pr      Nd      Pm      Sm      Eu      Gd  
     . 1.877d0,1.825d0,1.828d0,1.821d0,1.810d0,1.802d0,2.042d0,1.802d0,
c          Tb      Dy      Ho      Er      Tm      Yb      Lu      Hf  
     . 1.782d0,1.773d0,1.766d0,1.757d0,1.746d0,1.740d0,1.734d0,1.580d0,
c          Ta      W       Re      Os      Ir      Pt      Au      Hg  
     . 1.467d0,1.408d0,1.375d0,1.353d0,1.357d0,1.387d0,1.442d0,1.573d0,
c          Tl      Pb      Bi      Po      At      Rn      Fr      Ra  
     . 1.716d0,1.750d0,1.700d0,0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,
c          Ac      Th      Pa      U       Np      Pu      Am      Cm  
     . 0.000d0,1.798d0,0.000d0,1.560d0,0.000d0,0.000d0,0.000d0,0.000d0,
c          Bk      Cf      Es      Fm      Md      No      Lr      Rf  
     . 0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,
c          Db      Sg      Bh      Hs      Mt      Ds      Rg  
     . 0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,0.000d0,0.000d0 /

c
c     Initialize itag (connection matrix)
c
      call izero(itag,natoms*10)
c
c     Generate the connection table
c

      do 100 i=1, natoms-1
         do 200 j=i+1, natoms

            rab = r12(i,j,coords,natoms)
            rcv = rchk(i,j,radii,anum)

            if (rab .lt. rcv) then
               itag(i,10) = itag(i,10) + 1
               itag(j,10) = itag(j,10) + 1
               itag(i,itag(i,10)) = j
               itag(j,itag(j,10)) = i
            endif

 200     continue
 100  continue

      do 300 i=1, natoms
         if(itag(i,1) .eq. 0) then
            itag(i,1) = icls(i,coords,natoms)
            itag(i,10) = itag(i,10) + 1
            itag(itag(i,1),10) = itag(itag(i,1),10) + 1
            itag(itag(i,1), itag(itag(i,1),10)) = i
         endif
 300  continue

      call hinout(natoms,itag,anum,atype,coords)

      return
      end


      subroutine hinout(natoms,itag,anum,atype,coords)
c
c     Subroutine hinout writes out the "hin" file
c
      implicit double precision (a-h,o-z)
      dimension itag(natoms,10), coords(3,natoms)
      integer anum(*)
      character*2 atype(*)
      character*80 line

      open(unit=10,form='formatted',status='unknown',
     .     file='HYPERCHEM.hin')
      rewind 10

      write(10,'(a)') 'forcefield mm+'
      write(10,'(a)') 'sys 0'
      write(10,'(a)') 'view 40 0.25458 55 15 0.966211 0.2538206 0.044848
     .8 0.2456284 -0.9594546 0.1382519 0.07812156 -0.1225643 -0.9893811 
     .0.073402 -0.41257 -55.191'
      write(10,'(a)') 'seed -1111'
      write(10,'(a)') 'mol 1'

      do 100 i=1, natoms
         istr=1
         istp=6
         do 110 j=1, itag(i,10)
           write(unit=line(istr:istp),fmt='(a,i3,a)') ' ',itag(i,j),' s'
           istr = istr + 6
           istp = istp + 6
 110     continue

         istp = istp - 6

         write(10,'(a,i3,1x,a,1x,a,a,a,a,3(1x,f8.4),i3,a)') 'atom ',i,
     .        atype(anum(i)),atype(anum(i)),' ** ','h ','0 ',
     .        (coords(j,i), j=1,3), itag(i,10), line(1:istp)
 100  continue

      write(10,'(a)') 'endmol 1'
      write(10,'(a)') ' '
      close (unit=10,status='keep')

      return
      end


      integer function icls(a1,coords,natoms)
c
c     Function icls returns the nearest neighbor of center a1
c
      implicit double precision (a-h,o-z)
      integer a1, a2
      dimension coords(3,natoms)

      rsave = 1.0d10

      do 100 a2=1, natoms
         if(a2 .eq. a1) goto 100
         rtest = r12(a1,a2,coords,natoms)
         if (rsave .gt. rtest ) then
            rsave = rtest
            isave = a2
         endif         
 100  continue

      icls = isave

      return
      end


      double precision function rchk(a1,a2,radii,anum)
c
c     Function rchk returns the scaled summed covalent
c     radii of atoms a1 and a2
c
      implicit double precision (a-h,o-z)
      integer anum(*), a1, a2
      dimension radii(*)

      scal = 1.15d0
      rchk = scal * (radii(anum(a1)) + radii(anum(a2)))

      return
      end



      double precision function r12(a1,a2,coords,natoms)
c
c     Function returns the inter-nuclear distance between
c     centers a1 and a2
c
      implicit double precision (a-h,o-z)
      integer a1, a2
      dimension coords(3,natoms)

      x1 = coords(1,a1)
      y1 = coords(2,a1)
      z1 = coords(3,a1)
      x2 = coords(1,a2)
      y2 = coords(2,a2)
      z2 = coords(3,a2)

      r12 = dsqrt((x1-x2)**2 + (y1-y2)**2 + (z1-z2)**2)

      return 
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function get_barrier_master(myrank)
c----------------------------------------------------------------------------
c   Returns the "barrier master" of the current rank.
c----------------------------------------------------------------------------
      implicit none

      integer myrank
      integer bmaster
 
      bmaster = (myrank / 4)*4
      get_barrier_master = bmaster
      return
      end 

      SUBROUTINE INITP
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER AND,OR,EOR,DSTRT
C-----------------------------------------------------------------------
C     Parameters
C-----------------------------------------------------------------------

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

      PARAMETER (LENK  = 8*MXCBF + 9 + 7 + 8 + 3 + 7*28 + 64 + 8*8*2
     &                 + 8*2 + 100 + MXTNSH*8) 
C-----------------------------------------------------------------------
      COMMON /INDX/ PC(512),K(LENK)
c     COMMON /INDX/ PC(512),K(5011)
c     COMMON /INDX/ PC(512),K(512)
C     INITIALIZE THE POPULATION COUNT FACTOR
      K(1)=0
      N=1
      DO 1 I=1,9
        DO 2 J=1,N
    2   K(J+N) = K(J)+1
    1 N = N + N
      DO 3 I=1,512
    3 PC(I) = DFLOAT(1 - 2*AND(K(I),1))
      RETURN
      END

      Subroutine Stat_thermo_main
c
c Statistical thermodynamic calculation for aces program system.
c
c The original program was written by J. F. Stanton 6/20/89, and
c was modified by S. Beck 10/91, remodified, audited and incorporated
c to the general interface program by Ajith Perera, 04/2006.
c
c The equations used to calculate stat mech data were taken from
c "Statistical Mechanics", Donald A. McQuarrie, HarperCollins
c Publishers, New York, NY.  Chapter 8.
c
      implicit double precision (a-h,o-z)
C
#include "mxatms.par"
#include "machsp.com"
C
      Parameter(Mxdata = 100)
C
      dimension Dmoments(3), Freq(3*Mxatms), Rot(3), Chr_rot(3), 
     &          Chr_freq(3*Mxatms), Dnormmod(9*Mxatms*Mxatms), 
     &          Iatmchrg(Mxatms), Atommass(Mxatms), 
     &          Coord(3*Mxatms), Temp(Mxdata), Press(Mxdata)
C
      logical error, Thermo_exist
      Character*80 infile,line, Fname
      Character*4 Fpgrp
C
      Data Ione, Ithree, I_inunit, I_outunit/1, 3, 15, 25/
C
C Read the temperatures and pressures at which theromodynamic parameters
C are  computed from the "THERMO" file. The thermo file is a simple 
C formatted file. The first line indicating the number of termperatue
C and presure points followed by corresponding temperatures and 
C pressures (one line for each point). The output is written to 
C standard out and the formatted "THERMO.log" file. 
C
      Call Gfname("THERMO  ", FNAME, ILENGTH)
      Inquire(FILE=FNAME(1:ILENGTH), EXIST=Thermo_exist)
      If (Thermo_exist) Then
         Open(UNIT=I_inunit, FILE=FNAME(1:ILENGTH), FORM='FORMATTED')
         Read (I_inunit, *, END=9) Ndata
         If (Ndata .GT. Mxdata) Then
             Print*, "The number of currently allowd data points", 
     &               "are:", Mxdata
             Call Errex
         Endif
         Do Idata = 1, Ndata
            Read (I_inunit, *, END=9) Temp(Idata), Press(Idata)
         Enddo
      Else
         Ndata    = 1
         Temp(1)  = 298.15
         Press(1) = 1
      Endif 
C
   9  Close (I_inunit)
      Open(UNIT=I_outunit, FILE="THERMO.log", FORM='FORMATTED') 
C
      Write(6, 910)
 910  format(8x,//,'*** STATISTICAL THERMODYNAMIC CALCULATION ***',//,
     +'All calculations based on the rigid-rotor, harmonic-oscillator,'
     +,' ideal gas',/,'approximation at given temperatures (K)',
     +'pressures (atm.).', ' The default temperature',/, 
     + 'and pressure are 298 K and 1 atm respectively.',/, 
     +'Effects of nuclear spin on the rotational ',
     +'symmetry factor are ignored.',/,'Corrections to the ',
     +'electronic partition function (assumed to be unity) must'
     +,/,'be made by the user.')
C
C Read in basic data about the molecule from the JOBARC file.
C
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Coord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'ROTCONST', Ithree*Iintfp, Rot)
      Call Getrec(20, 'JOBARC', 'LINEAR  ', Ione, Iamlinear)
      Call Getcrec(20, 'JOBARC', 'PTGP    ', 4, Fpgrp)

#ifdef _DEBUG_LVLM2
      Write(6,*)
      Print*, "The number of real atoms", Natoms 
      Print*, "The atomic masses:", (Atommass(I), I=1, Natoms)
      Print*, "The atomic charges:", (Iatmchrg(I), I=1, Natoms) 
      Print*, "The Cartesian Coordinates", (Coord(I), 
     &         I= 1, 3*Natoms)
      Print*, "The Rotational constants", (Rot(I), I=1, 3)
#endif
C
C Read the vibrational frequncies, mass weighted Cartesian coordiantes,
C normal modes, etc.
C
      If (Iamlinear .EQ. 1) Then
         Nvibs = 3*Natoms - 5
         Ntrro = 5
      Else
         Nvibs = 3*Natoms - 6
         Nttro = 6
      Endif
      Call A2rd_vib(Natoms, Iatmchrg, Freq, Coord, Dnormmod,
     &              Nimag_freqs, Nvibs, Ione, .FALSE.)
#ifdef _DEBUG_LVLM2
      Write(6,*)
      Print*, "The vib. data from NORMCO:"
      Print*, "The Frequencies:", (Freq(I), I=1, Nvibs) 
      Print*, "The normal modes:", (Dnormmod(I), 
     &         I=1, 9*Natoms)
      Write(6,*)
#endif
C 
C Convert the rotational constants to moments of inertias 
C
      Call Rot2moments(Dmoments, Rot)
C 
      Nreal_freqs = Nvibs
      Nreal_freqs = Nreal_freqs - Nimag_freqs 
C
      Do Ivibs = 1, Nreal_freqs 
         Freq(Ivibs) = Freq(Nimag_freqs + Ivibs)
      Enddo
C    
      If (Nimag_freqs .gt. 0) write(6,915) Nimag_freqs
 915  format(/,' There are ',i3,' imaginary frequencies which will not'
     +     ,' be considered.')
C 
C Obtain the symmetry factors
C
      Call Symfac(Fpgrp, Isigma, Ntrro) 

C Calculate the characteristic vibrational temperatures
C
      Call Calccvt(Freq, Nreal_freqs, Nimag_freqs, Chr_freq)
      write(6,*)
      write(6,*),' Vibrational frequencies (cm-1):'
c
      write(6,920)(Freq(i),i=1,Nreal_freqs)
 920  format(7(2x,f8.1))
C
      write(6,*),' Vibrational temperatures (K):'
      write(6,920),(Chr_freq(i),i=1,Nreal_freqs)
C
C Calculate the characteristic rotational temperatures
C
      Call Calccrt(Dmoments, Ntrro, Chr_rot)
C
      write(6,*)
      if (ntrro.eq.5) then
        write(6,925)rot(1)
        write(6,930)rot(1)*29.97925
        write(6,935)dmoments(1)
        write(6,940)Chr_rot(1)
      else
        write(6,925)(rot(i),i=1,3)
        write(6,930)(rot(i)*29.97925,i=1,3)
        write(6,935)(dmoments(i),i=1,3)
        write(6,940)(Chr_rot(i),i=1,3)
      end if
 925  format(' Rotational constants (cm-1):',3(2x,f9.5))
 930  format('                      (GHz) :',3(2x,f9.5))
 935  format(' Moments of inertia (a.u.)  :',3(2x,f9.5))
 940  format(' Rotational temperatures (K):',3(2x,f9.5))
C
C Calculate thermodynamic properties
C
      Call Calczpe(Nreal_freqs, Zpe, Freq)
C
      write(6,945) zpe
      write(6,950) zpe/4.184
 945  format(' Zero point energy (kJ/mole)  :',2x,f9.5)
 950  format('                   (kcal/mole):',2x,f9.5)
C
C Please look at the preamble of each of these routines
C to find out what the do. In general each one of them
C do something described in McQuarrie's statistical mechanics
C book. 
C
      Weight = 0.0D0
      Do Iatm = 1, Natoms
         Weight = Weight + Atommass(Iatm)
      Enddo 
C
#ifdef _DEBUG_LVLM2
      Write(6,*) 
      Print*, "The total weight of the molecule:", weight
      Print*, "The number of Tem. and Pres. points:", Ndata
      Print*, (Temp(I), I=1, Ndata)
      Print*, (Press(I), I=1, Ndata)
#endif     
C
      Write(I_outunit, 960) 
      Write(I_outunit, 961)
 960  Format(2X, 'Temp.', 2X, 'Press.', 2X, 'Enthalpy', 2X, 'Energy',
     &       3X, 'Heat capacity', 4X, 'Entropy') 
 961  Format(4X, 'K', 5X, 'Atm', 4X, 'Kcal/mol', 2X, 'Kcal/mol', 
     &       1X, 'Kcal/mol-K', 7X, 'Kcal/mol-K')
C   
      Do Idata = 1, Ndata
         Call Calce(Nreal_freqs, Etran, Erot, Evib, Etot, 
     &              Chr_Freq, Temp(Idata), Ntrro)
C
         Call Calccv(Nreal_freqs, Cvtran, Cvrot, Cvvib, Cvtot,
     &               Chr_Freq, Temp(Idata), Ntrro)
C
         Call Calcv(Press(Idata), Temp(Idata), Vol)
C
         Call Calcs(Nreal_freqs, Stran, Srot, Svib, Stot, 
     &              Chr_Freq, Temp, Ntrro, Weight, Vol,
     &              Chr_rot, Isigma)
C
        h=etot+6.022045d23*1.380662d-23*Temp(Idata)*0.001
 
         Call Write2_stdout(Etran, Cvtran, Stran, Erot, Cvrot,
     &                      Srot, Evib, Cvvib, Svib, Etot, Cvtot,
     &                      Stot, H)
C
C The most important data that user might want to use are H, E, Cv and S
C (Enthalpy, internal energy, heat capacity and entropy). Write them to
C a file along withe temperature and pressure.
C 
      Write(I_outunit, 970) Temp(Idata), Press(Idata), H/4.184,
     &                      Etot/4.184, Cvtot/4.184, Stot/4.184
 970  Format(1X, F6.1,1X, F5.1, 3X, F7.3, 3X, F7.3, 1X, 
     &       F7.3, 11X, F7.3)
C
      Enddo
C
      Close(I_outunit)
C
      Return 
      End
C
      Subroutine Rot2moments(Dmoments, Rot)
C
c This will extract two or three numbers from string (rotational constants
c separated by spaces), translate them to dmoments of inertia, and then
c return them in the array rot.
c
c The equation for this is given by
c                h              h = 6.626176e-34 J s
c  RC(i) = -------------        c = 2.997925e8   m s-1
c          8 pi c I(i,i)
c
c The rotational constant RC(i) is read in with units of (cm-1) and the
c moment of inertia I(i,i) is in atomic units (amu ao**2 -- ao is the
c bohr radius).  The following conversion factors are necessary:
c   1 ao = 5.291787e-11 m
c   1 amu = 1.660565e-27 kg
c   1 cm-1 = 1.986478e-23 J
c to get: I(i,i) = 60.19936/RC(i).
c
c For linear molecules, only 2 rotational constants are read in (and they
c will both have the same value).  For nonlinear molecules, all 3 rotational
c constansts are read in.
C
      Implicit Double Precision (a-h,o-z)
      dimension dmoments(3),rot(3)
      logical error
      fact=60.19936
      dmoments(1)=fact/rot(1)
      dmoments(2)=fact/rot(2)
      dmoments(3)=0.0d0
      if (rot(3).ne.0.0) dmoments(3)=fact/rot(3)
      return
      end
C
      Subroutine Symfac(Ptgrp, Isigma, Ntrro)
C
c This returns the rotation factor isigma used in stat mech calculations
c in the calculation of Qrot.  In addition, it returns ntrro which is the
c number of translational and rotational degrees of freedom (5 for a
c linear molecule, 6 for a nonlinear one).
C
      implicit integer (a-z)
      character*4 ptgrp
      character*1 c1,c2,c3,c4
      c1=ptgrp(1:1)
      c2=ptgrp(2:2)
      c3=ptgrp(3:3)
      c4=ptgrp(4:4)
      zero=ichar('0')
      ntrro=6
      if (c2.eq.'X') ntrro=5
      if (c4.eq.' ') then
        isigma=ichar(c2)-zero
        if (isigma.lt.1.or.isigma.gt.9) isigma=1
      else
        isigma=(ichar(c2)-zero)*10+(ichar(c3)-zero)
      end if
      if (c1.eq.'C') then
        if (c2.eq.'X'.or.c3.eq.'s'.or.c3.eq.'i') isigma=1
      else if (c1.eq.'D') then
        isigma=2*isigma
        if (c2.eq.'X') isigma=2
      else if (c1.eq.'S')then
        isigma=isigma/2
      else if (c1.eq.'O')then
        isigma=24
      else if (c1.eq.'T')then
        isigma=12
      end if
      return
      end
C
      Subroutine Calccvt(freq, nfreq, nimag, cvt)
C
c This calculates the characteristic vibrational temperatures
c given by:
c  theta(j) = h v(j)/k        k = 1.380662e-23 J K-1
c                             h = 6.626176e-34 J s
c and v(j) is the freqency of the vibration.  The frequencies are
c in wavenumbers, so the conversion factor:  c = 2.997925e10  cm s-1
c is used to get:  theta(j)=XXX*v(j).
c
      Implicit Double Precision (a-h,o-z)
      dimension freq(nfreq),cvt(nfreq)
      factor=1.438787
C As far as I can tell, this must have been an error. When
C frequencies were read, all the imaginaries were neglected
C and Freq array starts from the real frequencies. 04/2006.
CSSS      do 10 i=1+nimag,nfreq
CSSS        cvt(i)=factor*freq(i)
CSSS 10   continue
C
      Do Ivibs = 1, Nfreq
         Cvt(Ivibs)=factor*freq(Ivibs)
      Enddo
C
      return
      end
C
      Subroutine Calccrt(dmoments, ntrro, crt)
C
c This calculates the characteristic rotational temperatures given by:
c                  h**2           k = 1.380662e-23 J K-1
c  theta(A) = --------------      h = 6.626176e-34 J s
c             8 pi**2 k I(A)
c where the dmoments of inertia I(A) are in units of (amu ao**2) which
c involves the conversion factors (1 amu=1.660565e-27 kg,
c 1 ao=5.291787e-11 m).  Using these, we get that
c   theta(A) = 86.61403/moment(A)
c For a linear molecule (ntrro=5), there is only one characteristic
c temperature calculated.  For nonlinear molecules (ntrro=6), all 3 are
c calculated.
c
      implicit integer (i-n)
      implicit real*8 (a-h,o-z)
      real*8 dmoments(3),crt(3)
      factor=8.661403d1
      crt(1)=factor/dmoments(1)
      if (ntrro.eq.6) then
        crt(2)=factor/dmoments(2)
        crt(3)=factor/dmoments(3)
      end if
      return
      end

      Subroutine Calczpe(nfreq, zpe, freq)

c This calculates the zero point energy given by the equation:
c      ZPE = 0.5 h * [ v(1) + v(2) + ... + v(n) ]    h = 6.626176e-34 J s
c      c = v*lambda                                  c = 2.997925e10  cm s-1
c where ZPE is in kJ/mole and the frequencies are in wavenumbers.
c Using the conversion factors 4.359788e-18 J = 627.5057 kcal/mole and
c 1 cal = 4.184 J, you get ZPE = 5.981329e-3 * [ v(1) + ... + v(n) ]
c
      implicit double precision (a-h,o-z)
      implicit integer (i-n)
      dimension freq(nfreq)
      factor=5.981329d-3
      zpe=0.0
      do 10 i=1,nfreq
        zpe=zpe+freq(i)
 10   continue
      zpe=zpe*factor
      return
      end
C
      Subroutine Calce(nfreq, etran, erot, evib, etot, cvt,
     &                 t, ntrro)
C
c This calculates the different contributions to the stat. mech.
c property E given by equations 8-25 and 8-31 in McQuarrie.  All
c are returned in kJ/mole.
c
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
      dimension cvt(nfreq)
      factor1=1.380662d-23*t
      factor2=6.022045d23*factor1/1000.0d0
      etran=1.5
      eelec=0.0D0
      if (ntrro.eq.5) then
        erot=1.0
      else
        erot=1.5
      end if
      evib=0.0
      do 10 i=1,nfreq
        t1=cvt(i)/t
        evib=evib +0.5*t1 +t1/(exp(t1)-1.0d0)
 10   continue
      etran=etran*factor2
      erot=erot*factor2
      evib=evib*factor2
      etot=etran+erot+evib+eelec
      return
      end
C
      Subroutine Calccv(nfreq, cvtran, cvrot, cvvib, cvtot, 
     &                  cvt,t,ntrro)
c
c This calculates the different contributions to the stat. mech.
c property Cv given by equations 8-26 and 8-32 in McQuarrie.  All
c are returned in J/mole-K.
c
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
      dimension cvt(nfreq)
      factor1=1.380662d-23*6.022045d23
      cvtran=1.5
      if (ntrro.eq.5) then
        cvrot=1.0
      else
        cvrot=1.5
      end if
      cvvib=0.0
      do 10 i=1,nfreq
        t1=cvt(i)/t
        t2=exp(t1)
        t3=(t2-1.0)*(t2-1.0)
        cvvib=cvvib +t1*t1*t2/t3
 10   continue
      cvtran=cvtran*factor1
      cvrot=cvrot*factor1
      cvvib=cvvib*factor1
      cvtot=cvtran+cvrot+cvvib
      return
      end
C
      Subroutine Calcv(p, t, v)
c
c This calculates the molar volume of a gas at temperature t (in K) and
c pressure p (in atm.) using:  pV=NkT.  The following conersion
c factor is used:  1 atm = 1.013247e5 N m-2.
C
      implicit double precision (a-z)
      k=1.380662d-23
      n=6.022045d23
      v=n*k*t/(p*1.013247d5)
      return
      end
C
      subroutine calcs(nfreq,stran,srot,svib,stot,cvt,t,ntrro,
     +     weight,v,crt,isigma)
c
c This calculates the different contributions to the stat. mech.
c property S given by equations 8-27 and 8-33 in McQuarrie.  All
c are returned in J/mole-K.
c
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
      dimension cvt(nfreq),crt(3)
      cn=6.022045d23
      ck=1.380662d-23
      ch=6.626176d-34
      ce=exp(1.0)
      cpi=3.141593
      dmass=weight/1000.0/cn
      sigma=real(isigma)
      factor1=ck*cn
      stran=(2.0*cpi*dmass*ck*t/ch/ch)**3
      stran=sqrt(stran)*v*sqrt(ce**5)/cn
      stran=log(stran)
      if (ntrro.eq.5) then
        srot=log(t*ce/sigma/crt(1))
      else
        srot=sqrt(cpi*ce**3)/sigma*sqrt(t**3/(crt(1)*crt(2)*crt(3)))
        srot=log(srot)
      end if
      svib=0.0
      do 10 i=1,nfreq
        t1=cvt(i)/t
        t2=exp(t1)-1.0
        t3=1.0-exp(-t1)
        svib=svib +t1/t2 -log(t3)
 10   continue
      stran=stran*factor1
      srot=srot*factor1
      svib=svib*factor1
      stot=stran+srot+svib
      return
      end
#ifdef _KEEP
      integer function islen(str)
c Compute the length of a string.
      implicit integer (a-z)
      character *(*) str
      character*1 sp,tab
      i=len(str)
      sp=' '
      tab='	'
 10   if (i.ne.0) then
        if (str(i:i).eq.sp .or. str(i:i).eq.tab) then
          i=i-1
          goto 10
        end if
      end if
      islen=i
      return
      end

      real*8 function atod(str,ERROR)
      implicit double precision (a-h,o-z)
      character*80 istr,dstr,estr
      character*1 sp,tab
      logical ERROR
      character*(*) str
      sp=' '
      tab='	'
      ilen=islen(str)
      ERROR=.false.
c Error occurs if str is a null string.
      if (ilen.eq.0) then
        ERROR=.true.
        atod=1.0d0
        return
      end if
c Strip all blanks from the string and get sign.
 10   if (str(1:1).eq.sp .or. str(1:1).eq.tab) then
        str=str(2:ilen)
        ilen=ilen-1
        goto 10
      end if
      isign=1
      if (str(1:1).eq.'+') then
        str=str(2:ilen)
        ilen=ilen-1
      else if (str(1:1).eq.'-') then
        isign=-1
        str=str(2:ilen)
        ilen=ilen-1
      end if
      if (ilen.eq.0) then
        ERROR=.true.
        atod=2.0d0
        return
      end if
 20   if (str(1:1).eq.sp .or. str(1:1).eq.tab) then
        str=str(2:ilen)
        ilen=ilen-1
        goto 20
      end if
c Split the string into integer, decimal, and exponent parts.
      iint=0
      istr=''
      idec=0
      dstr=''
      ndec=0
      iexp=0
      estr=''
      id=if_cidx(str,'.')
      ie=if_clidx(str,'dDeE')
      if ((id.gt.ie.and.ie.ne.0) .or. ie.eq.ilen) then
        ERROR=.true.
        atod=3.0d0
        return
      end if
      if (id.eq.0) then
        if (ie.eq.0) then
          istr=str
        else if (ie.eq.1) then
          istr='1'
          estr=str(2:ilen)
        else
          istr=str(1:ie-1)
          estr=str(ie+1:ilen)
        end if
      else if (id.eq.1) then
        if (ie.eq.0) then
          dstr=str(2:ilen)
          if (dstr(1:1).eq.sp .or. dstr(1:1).eq.tab) then
            ERROR=.true.
            atod=4.0d0
            return
          end if
        else if (ie.eq.2) then
          ERROR=.true.
          atod=5.0d0
          return
        else
          dstr=str(2:ie-1)
          if (dstr(1:1).eq.sp .or. dstr(1:1).eq.tab) then
            ERROR=.true.
            atod=6.0d0
            return
          end if
          estr=str(ie+1:ilen)
        end if
      else if (id.eq.ilen) then
        i=ilen-1
        istr=str(1:i)
        if (istr(i:i).eq.sp .or. istr(i:i).eq.tab) then
          ERROR=.true.
          atod=7.0d0
          return
        end if
      else
        i=id-1
        istr=str(1:i)
        if (istr(i:i).eq.sp .or. istr(i:i).eq.tab) then
          ERROR=.true.
          atod=8.0d0
          return
        end if
        if (ie.eq.0) then
          dstr=str(id+1:ilen)
          if (dstr(1:1).eq.sp .or. dstr(1:1).eq.tab) then
            ERROR=.true.
            atod=9.0d0
            return
          end if
        else if (ie.eq.id+1) then
          estr=str(ie+1:ilen)
        else
          dstr=str(id+1:ie-1)
          if (dstr(1:1).eq.sp .or. dstr(1:1).eq.tab) then
            ERROR=.true.
            atod=10.0d0
            return
          end if
          estr=str(ie+1:ilen)
        end if
      end if
      if (islen(istr).ne.0) iint=i_atoi(istr,ERROR)
      if (ERROR) then
        atod=11.0d0
        return
      end if
      ndec=islen(dstr)
      if (ndec.ne.0) idec=i_atoi(dstr,ERROR)
      if (ERROR) then
        atod=12.0d0
        return
      end if
      if (islen(estr).ne.0) iexp=i_atoi(estr,ERROR)
      if (ERROR) then
        atod=13.0d0
        return
      end if
      d=real(iint)
      if (ndec.ne.0) d=d+ real(idec)/10.0**ndec
      if (iexp.ne.0) d=d*10.0**iexp
      atod=d*real(isign)
      return
      end

      integer function i_atoi(str,ERROR)
      implicit integer (a-z)
      character*(*) str
      character*1 c,sp,tab
      logical ERROR
      i_atoi=0
      ERROR=.false.
      ilen=islen(str)
c Error occurs if str is a null string.
      if (ilen.eq.0) then
        ERROR=.true.
        i_atoi=1
        return
      end if
c isign is the sign
c i is the position of the character currently being examined
c val is the value to date
      sign=1
      i=1
      zero=ichar('0')
      sp=' '
      tab='	'
c The sign section may consist of spaces, tabs, or a single sign.
c A digit means go to the integer section.
      do while (str(i:i).eq.sp .or. str(i:i).eq.tab)
        i=i+1
      end do
      if (str(i:i).eq.'+' .or. str(i:i).eq.'-') then
        if (str(i:i).eq.'-') sign=-1
        i=i+1
      end if
      if (i.gt.ilen) then
        i_atoi=2
        ERROR=.true.
        return
      end if
      do while (str(i:i).eq.sp .or. str(i:i).eq.tab)
        i=i+1
      end do
c The integer section may consist only of digits.
 10   c=str(i:i)
      if (c.lt.'0' .or. c.gt.'9') then
        ERROR=.true.
        i_atoi=3
        return
      end if
      i_atoi=10*i_atoi + ichar(c)-zero
      i=i+1
      if (i.le.ilen) goto 10
      i_atoi=sign*i_atoi
      return
      end

      integer function if_cidx(str,char)
      implicit integer (a-z)
      character *(*) str
      character*1 char
      i=1
      strlen=islen(str)
 10   if (i.gt.strlen) then
        if_cidx=0
        return
      end if
      if (str(i:i).eq.char) then
        if_cidx=i
        return
      end if
      i=i+1
      goto 10
      end

      integer function if_clidx (str,charlist)
      implicit integer (a-z)
      character *(*) str, charlist
      strlen=islen(str)
      i=1
 10   if_clidx=if_cidx(charlist,str(i:i))
      if (if_clidx.ne.0) then
        if_clidx=i
        return
      end if
      i=i+1
      if (i.gt.strlen) return
      goto 10
      end
#endif

      SUBROUTINE DRTSTS(ICORE,MAXCOR,ICYCLE,IUHF,ICONVG,
     &                  ICONTL,SING1,NLIST,TYPE)
C
C DRIVER FOR ROUTINE WHICH LOOKS AT OLD AND NEW T VECTORS,
C   AND RETURNS STATISTICS ON THEM.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION TOL
      CHARACTER*1 TYPE
      CHARACTER*2 SPCASE
      CHARACTER*8 SYMLBV(3),SYMLBO(3),LABEL1,LABEL2,SYMLVO(2)
      LOGICAL SING1
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /FLAGS/ IFLAGS(100)
      DATA SYMLBV /'SVAVA0  ','SVBVB0  ','SVAVB2  '/
      DATA SYMLBO /'SOAOA0  ','SOBOB0  ','SOAOB2  '/
      DATA SYMLVO /'SVAOA2  ','SVBOB2  '/
      NNM1O2(IX)=(IX*(IX-1))/2
      ICONVG=0
      IF(IFLAGS(1).GE.10)THEN
       WRITE(*,100)ICYCLE
  100  FORMAT(T3,' After ',I3,' iterations, amplitude changes are:')
       WRITE(*,101)
  101  FORMAT(T5,67('-'))
       WRITE(*,102)
  102  FORMAT(T18,'Spin',T28,'RMS',T41,'Max.',T51,'Max. change for',/,
     &        T6,'Amplitude',T18,'Case',T27,'Change',T40,'Change',
     &        T53,'i',T58,'j',T63,'a',T68,'b')
       WRITE(*,101)
      ENDIF
      TOL=10.D0**(-ICONTL)
C
C T1 VECTOR STATISTICS IF AVAILABLE
C
      IF(SING1)THEN
       DO 900 ISPIN=1,1+IUHF
        NSMSZ=NVRTO(ISPIN)*NOCCO(ISPIN)
        LABEL1=SYMLVO(ISPIN)
        NSIZET=IRPDPD(1,8+ISPIN)
        I000=1
        I010=I000+NSIZET*IINTFP
        I020=I010+NSIZET*IINTFP
        I030=I020+NSMSZ
        CALL GETREC(20,'JOBARC',LABEL1,NSMSZ,ICORE(I020))
        CALL T1STAT(ICORE,ICORE(I010),ICORE(I020),NSIZET,NSMSZ,
     &             ISPIN,ICONVG,TOL,NLIST,TYPE)
900    CONTINUE
      ENDIF
C
C T2 VECTOR STATISTICS - AA AND BB SPIN CASES
C
      DO 10 ISPIN=1,1+IUHF
       LISTT=43+ISPIN
       NSMSZ1=NNM1O2(NVRTO(ISPIN))
       NSMSZ2=NNM1O2(NOCCO(ISPIN))
       LABEL1=SYMLBV(ISPIN)
       LABEL2=SYMLBO(ISPIN)
       NSIZET=ISYMSZ(ISYTYP(1,LISTT),ISYTYP(2,LISTT))
       I000=1
       I010=I000+NSIZET*IINTFP
       I020=I010+NSIZET*IINTFP
       I030=I020+NSMSZ1
       I040=I030+NSMSZ2
       CALL GETREC(20,'JOBARC',LABEL1,NSMSZ1,ICORE(I020))
       CALL GETREC(20,'JOBARC',LABEL2,NSMSZ2,ICORE(I030))
       CALL T2STAT(ICORE,ICORE(I010),ICORE(I020),ICORE(I030),
     &             NSIZET,NSMSZ1,NSMSZ2,ISPIN,ICONVG,TOL,NLIST,
     &             TYPE)
10    CONTINUE
C
C T2 VECTOR STATISTICS - AB SPIN CASE
C
      LISTT=46
      NSMSZ1=NVRTO(1)*NVRTO(2)
      NSMSZ2=NOCCO(1)*NOCCO(2)
      LABEL1=SYMLBV(3)
      LABEL2=SYMLBO(3)
      NSIZET=ISYMSZ(ISYTYP(1,LISTT),ISYTYP(2,LISTT))
      NT2DSZ=NVRTO(1)*NVRTO(2)
      I000=1
      I010=I000+NSIZET*IINTFP
      I020=I010+NSIZET*IINTFP
      I030=I020+NSMSZ1
      I040=I030+NSMSZ2
      CALL GETREC(20,'JOBARC',LABEL1,NSMSZ1,ICORE(I020))
      CALL GETREC(20,'JOBARC',LABEL2,NSMSZ2,ICORE(I030))
      CALL T2STAT(ICORE,ICORE(I010),ICORE(I020),ICORE(I030),
     &            NSIZET,NSMSZ1,NSMSZ2,3,ICONVG,TOL,NLIST,TYPE)
      IF(IFLAGS(1).GE.10)THEN
       WRITE(*,101)
      ENDIF
      RETURN
      END

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      LOGICAL FUNCTION QSAME(Q1,Q2)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: qsame.f,v 1.1.1.1 2003/04/02 19:21:36 aces Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     qsame -- determine the equivalence of two cartesian coordinates
C
C SYNOPSIS
      DOUBLE PRECISION Q1(3),Q2(3)
C
C DESCRIPTION
C     True if the absolute difference in any component of the cartesian
c     coordinates is less than or equal to 1.0e-6.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Integer I
      Double precision Z
      QSAME=.TRUE.
      DO 10 I=1,3
       Z=ABS(Q1(I)-Q2(I))
       IF(Z.GT.1.D-6)QSAME=.FALSE.
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ARCHIVE( E,V1,V2,STEP,NCOMP,VEC)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "fnamelen.par"
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      Logical IsTher, IsOpn,  XYZIN, NWFINDIF
      CHARACTER*10 CRAP,CRAP2
      CHARACTER*(fnamelen) FNAME
      DIMENSION V1(NXM6),V2(NXM6*NXM6),STEP(NXM6), VEC(NOPT)
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
#include "coord.com"

      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $        ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $        XYZTol
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
#include "io_units.par"
      DATA CRAP /'***CYCLE  '/
C
C SQUASH INTERNAL COORDINATE VECTOR IF NEEDED
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The COORD COMMON BLOCK AT ARCHIVE"
      Write(6, "(3F10.5)") (Q (I), I= 1, 3*NATOMS)
      Write(6,*)
      If (.not. xyzin) Write(6, "(3F10.5)") (R(I), I= 1, 3*NATOMS)
      Write(6,*)
#endif
C
      IF(NCOMP.EQ.1 .AND. .NOT. XYZIN) CALL SQUSH(R,NX)
C
C Open up the archive -- on the 0th cycle, we want to get rid
C of any previous file.  On subsequent cycles, we want to
C open for append.
C
      call gfname(arcfil,fname,ilength)
      If (Ncycle .eq. 0) then
       Inquire (File=fname(1:ilength), Exist=IsTher)
       If (IsTher) then
        Inquire(File=fname(1:ilength), Opened=IsOpn, Number=LuOld)
        If (IsOpn) then
         Close(LuOld, Status='DELETE')
        Else
         Open(LuArc,File=fname(1:ilength),Form='UNFORMATTED',
     &        Status='OLD')
         Close(LuArc, Status='DELETE')
        EndIf
       EndIf
       OPEN(UNIT=LUARC,FILE=fname(1:ilength),FORM='UNFORMATTED',
     &      STATUS='NEW')
      ElseIf (NCYCLE .gt. 0) THEN
       OPEN(UNIT=LUARC,FILE=fname(1:ilength),FORM='UNFORMATTED',
     &      STATUS='OLD')
       DO 10 J=1,NCYCLE
        READ(LuArc)CRAP2
        IF(CRAP2.NE.CRAP) then
         Write (LuErr,*) ' *Problem with optimization ',
     &          'archive file.'
         Call ErrEx
        EndIf
 10    Continue
      ENDIF
C
      WRITE(LuArc)CRAP,iarch,NCYCLE,NATOMS,NX,NUNIQUE,NOPT,IPRNT,INR,
     $     IVEC,
     $   IDIE,IMXSTP,ISTCRT,IVIB,ICURVY,ICONTL,IRECAL,INTTYP,IDISFD,
     $   IGRDFD,ICNTYP,ISYM,IBASIS,
     $   E,(V1(I),I=1,NXM6),(V2(I),I=1,NXM6*NXM6),
     $   (STEP(J),J=1,NXM6),
     $   (R(J),J=1,NXM6),(Q(J),J=1,NX),(NCON(I),I=1,NX),
     $   (ZSYM(I),I=1,NATOMS),
     $   (VARNAM(I),I=1,NX),(PARNAM(I),I=1,NX),
     $   (ISQUASH(J),J=1,NXM6),
     $   (IATNUM(I),I=1,NATOMS),(ATMASS(I),I=1,NATOMS),
     $   (IUNIQUE(J),J=1,NUNIQUE),
     $   (NEQ(J),J=1,NXM6),
     $   ((IEQUIV(I,J),J=1,NEQ(IUNIQUE(I))),I=1,NUNIQUE),
     $   (NOPTI(J),J=1,NOPT), (VEC(J),J=1,NOPT),FPGRP,BPGRP,PGRP,
     $   ((ORIENT(I,J),J=1,3),I=1,3)
      CLOSE(LuArc,STATUS='KEEP')
C
      RETURN
      END

c This routine initializes the info common block.

      subroutine aces_com_info
      implicit none
      integer       nocco(2),nvrto(2)
      common /info/ nocco,   nvrto
      save   /info/
      call getrec(-1,'JOBARC','NOCCORB',2,nocco)
      call getrec(-1,'JOBARC','NVRTORB',2,nvrto)
      return
      end

#include <flags.h>
      Subroutine Constr_search(Coords_K0OM, Coords_K1C, Coords_K1PM,
     &                         Vcoords, Coords, Coords_K1CM, Grad_K1C,
     &                         Grad_K1CM, Grad_K0O, A2Hess, Hess_K1C,
     &                         AtmMass, Vec_K1C0, Vec_K1C1, Vec_K0O, 
     &                         Grad_on_K0O, Grad_on_K1C, Work,
     &                         B2ang, Units, Stride, Delta, 
     &                         First_step, New_IRC, Constr_Min,
     &                         Imap, Ncycles, Nreals, Natoms,
     &                         Opt_Tol, Stride_Total, Stride_Tol,
     &                         Ln_Intrp_Tol, Hess_Eval_Tol,
     &                         Lamsearch_Tol, Binsearch_Tol, 
     &                         G_Cutoff, R_Cutoff, E_currnt)
C
      Implicit Double Precision (A-H, O-Z)
C
#include <machsp.com>
#include <jodaflags.com>
C
      Logical Converged, First_step, Powel_upd, Bfgs_upd, Bohr, 
     &        New_IRC
C
      Double Precision Lamsearch_Tol, Ln_Intrp_Tol
C
      Character*5 Constr_Min
      Character*4 Units

      Dimension Coords_K0OM(3*Nreals), Coords_K1C(3*Nreals),
     &          Coords_K1PM(3*Nreals), Grad_K1C(3,Natoms), 
     &          Imap(Natoms), VEc_K1C_stat(6), Grad_K1CM(3,Natoms), 
     &          Grad_K1C_stat(6), AtmMass(Nreals), Vec_K1C0(3*Nreals),
     &          Grad_on_K1C(3, Nreals), Grad_on_K1C_stat(6),
     &          A2Hess(3*Natoms, 3*Natoms), Coords_K1CM(3*Nreals),
     &          Hess_K1C(3*Natoms, 3*Natoms), Work(36*Nreals*Nreals),
     &          Vcoords(3*Natoms), Coords(3*Natoms), 
     &          Vec_K0O(3*Nreals), Grad_on_K0O(3*Nreals), 
     &          Grad_K0O(3*Nreals), Vec_K1C1(3*Nreals)
C
C Compute the gradients at the current point
C
      Convert = B2Ang
      If (Units .EQ. "Bohr") Convert = 1.0D0
C
      Write(6,*) "First_step, New_IRC", First_step, New_IRC, 
     &            Constr_Min
      If (First_step) Then
C
C Except the reference point, all the subsequent points used
C Cartesian coordinates. The reference point coordiante is choosen
C by the user and can be in internal or Cartesians. If internal
C there could be dummy atoms, and any point other than the reference
C point, the dummy atoms have (0.0,0.0,0.0) coordinates and do not
C enter into the calculation. With this mechanism one can eliminate
C the JOBACR IO error resulting from trying to overwrite an
C exsisting record with record of different length.
C
         If (Iflags(54) .NE. 0)  Iflags(54)   = 0
                                 Iflags2(138) = 1
         If (Iflags(3) .EQ. 2)
     &                           Iflags(3) = 1
C
          Call Dzero(Vcoords, 3*Natoms)
          Call Dzero(Coords, 3*Natoms)
          Call Daxpy(3*Nreals, Convert, Coords_K1C, 1, Vcoords, 1)
          Do Iatoms = 1, Natoms
             If (Imap(Iatoms) .NE. 0) Then
                 Ioff = 3*(Imap(Iatoms) - 1) + 1
                 Joff = 3*(Iatoms - 1) + 1
                 Call Dcopy(3, Vcoords(Joff), 1, Coords(Ioff), 1)
             Endif
          Enddo 
          Call Putrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP,
     &                Coords)
          Call Putrec(1,'JOBARC','IFLAGS  ',   100, iflags)
          Call Putrec(1,'JOBARC','IFLAGS2 ',  500, iflags2)
C
          Call aces_ja_fin
C
          Call Runit("runaces2b")
C
          Call aces_ja_init

      Else if (.NOT. First_step .AND. New_IRC) Then
C
          Call Dzero(Vcoords, 3*Natoms)
          Call Dzero(Coords, 3*Natoms)
          Call Daxpy(3*Nreals, Convert, Coords_K1C, 1, Vcoords, 1)
          Do Iatoms = 1, Natoms
             If (Imap(Iatoms) .NE. 0) Then
                 Ioff = 3*(Imap(Iatoms) - 1) + 1
                 Joff = 3*(Iatoms - 1) + 1
                 Call Dcopy(3, Vcoords(Joff), 1, Coords(Ioff), 1)
             Endif
          Enddo
          Call Putrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP,
     &                Coords)
C
C
          Call a2_reset_jarc
          Call aces_ja_fin
C
          Call Runit("runaces2b")
C
          Call aces_ja_init

      Endif

      Call Getrec(20,'JOBARC','GRADIENT',3*Nreals*IINTFP,
     &               Grad_K1C(1,1))
      Call Getrec(20,'JOBARC','TOTENERG', IINTFP, E_previs)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search Grad_k1C(comp. order)"
      Write(6, "(3F12.8)") ((Grad_K1C(i,j), i=1,3),j=1,Nreals)
      Write(6,*) "@-Constr_search The imap array"
      Write(6, "(5I2)") (Imap(i), i=1, Nreals)
#endif
C
C First convert to ZMAT order and then remove the dummy atoms.
C (Note that the gradient record does not have dummy atom 
C contributions, but in order to map to ZMAT order, we have to
C add dummy contributions (zero) again and then remove).

      If (First_Step .OR. New_IRC) Then
          Call Dzero(grad_K1CM, 3*Natoms)
          Do i=1, Natoms
             k=Imap(i)
             If (k .NE. 0) Then
                Do j=1,3
                   grad_K1CM(j,k)  = Grad_K1C(j,i)
                Enddo
             Endif
          Enddo
C
          Call Dcopy(3*Natoms, grad_K1CM, 1, Grad_K1C, 1)
C
         Do i=1, Natoms
            If (Imap(i) .NE. 0) Then
                Call Dcopy(3, Grad_K1C(1,Imap(i)), 1, 
     &                     grad_K1CM(1,i), 1)
            Endif
         Enddo
         Call Dcopy(3*Nreals, grad_K1CM, 1, Grad_K1C, 1)
C
C During the first step save the gradient of the current point
C in the location reserved for the previous point gradient.
C
         Call Dcopy(3*Nreals, Grad_K1C, 1, Grad_K0O, 1)
      Endif
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search Grad_K1C (ZMAT order)"
      Write(6, "(3F12.8)") ((Grad_K1C(i,j), i=1,3),j=1,Natoms)
#endif
C
C Grad_k1c_stat(1-6) are the largest absolute, the smallest absolute,
C the largest, the largest, the smallest, the norm, and the
C dynamic range
C
      Call Vstat(Grad_K1C, Grad_K1C_stat, 3*Nreals)
      If (Grad_K1C_stat(1) .LT. Opt_Tol .AND. Grad_K1C_stat(5) .LT.
     &    Opt_Tol/3.0D0 .AND. Str_Total .GT. 1.0D0 ) Then
          Converged = .True.
      Else
          Converged = .False.
      Endif
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search Grad_K1C stats"
      Write(6, "(a,2F12.8)") "largest and the norm",Grad_K1C_stat(1),
     &                        Grad_K1C_stat(5)
#endif
C
C      If (First_step .AND. .NOT. New_IRC) Then       
      If (First_step .OR. New_IRC) Then       
         Ioff = 0
         Do Iatom = 1, Nreals
            Do Ixyz = 1, 3
               Grad_K1CM(Ixyz, Iatom) = Grad_K1CM(Ixyz, Iatom)/
     &                                  Dsqrt(AtmMass(Iatom))
               Ioff = Ioff + 1
               Coords_K0OM(Ioff) = Coords_K0OM(Ioff)*
     &                             Dsqrt(AtmMass(Iatom))
               Coords_K1CM(Ioff)= Coords_K1CM(Ioff)*
     &                            Dsqrt(AtmMass(Iatom))
               Coords_K1PM(Ioff) = Coords_K1PM(Ioff)*
     &                             Dsqrt(AtmMass(Iatom))
            Enddo
         Enddo
      Endif

C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a)") "@-Constr_search Mass weighted grads, prev."
     &                  "current and pivot point"
      Write(6, "(3F12.8)") ((Grad_K1CM(i,j), i=1,3),j=1,Nreals)
      Write(6,"(a)")  "The prv. point"
      Write(6, "(3F12.8)") (Coords_K0OM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The curr. point"
      Write(6, "(3F12.8)") (Coords_K1CM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The curr. point (no. mass weight)"
      Write(6, "(3F12.8)") (Coords_K1C(i),i=1,3*Nreals)
      Write(6,"(a)")  "The pivot. point"
      Write(6, "(3F12.8)") (Coords_K1PM(i),i=1,3*Nreals)
#endif
C
C Define the vectors k+1: (qk+1 - qk)
C 
      Do Iatom = 1, Nreals
         Ioff = 1 + 3*(Iatom - 1) 
         Call Vec(Coords_K1PM(Ioff),  Coords_K1CM(Ioff), 
     &            Vec_K1C0(Ioff), 0)
      Enddo
C
      Call Vstat(Vec_K1C0, Vec_K1C_Stat, 3*Nreals)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search Vec_K1C0"
      Write(6, "(3F12.8)") (VEC_K1C0(i),i=1,3*Nreals)
      Write(6,*) "@-Constr_search Vec_K1C_stat"
      Write(6, "(F12.8)") Vec_K1C_stat(5) 
#endif
C
      Vec_K1C_length = Vec_K1C_Stat(5)*Dsqrt(Dble(3*Nreals))
C
      If (Abs(Vec_K1C_length - 0.50D0*Stride) .GT. Stride_Tol) Then
         Write(6, "(a)") "The Norm criteria is violated"
         Call Errex
      Endif
C
      Call Dcopy(3*Nreals, Vec_K1C0, 1, Vec_K1C1, 1)
      Call Dscal(3*Nreals, 1.0D0/(Vec_K1C_Stat(5)*Dsqrt
     &           (Dble(3*Nreals))), Vec_K1C1, 1)
C
C Gradient along the k+1 vectors.
C
      Grad_Proj_K1C =  Ddot(3*Nreals, Vec_K1C1, 1, Grad_K1CM, 1)
C
      Do Iatoms = 1, Nreals
         Ioff = 3*(Iatoms - 1)
         Do Ixyz = 1, 3 
            Ioff = Ioff + 1
            Grad_on_K1C(Ixyz, Iatoms) = Grad_K1CM(Ixyz, Iatoms) - 
     &                                  Vec_K1C1(Ioff)*Grad_Proj_K1C
         Enddo
      Enddo
C               
      Call Vstat(Grad_on_K1C, Grad_on_K1C_stat, 3*Nreals)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search Vec_K1C0 and Grad_on_K1C and state"
      Write(6,*) "Vec_K1C0"
      Write(6, "(3F12.8)") (Vec_K1C0(i),i=1,3*Nreals) 
      Write(6,*)
      Write(6, "(3F12.8)") ((Grad_on_K1C(i,j), i=1,3),j=1,Nreals)
      Write(6, "(a,2F12.8)") "largest and the norm of Grad_on_K1C",
     &                    Grad_on_K1C_stat(1),
     &                    Grad_on_K1C_stat(5)*Dsqrt(Dble(3*Nreals))
#endif
      If (Ncycles .ge. 2) Then
         Powel_upd = .true.
         Call Dcopy(3*Nreals, Grad_K0O, 1, Work, 1)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a)") "@-Constr_search entry to Hess. update"
     &                 "current, previous gradinets and geo. update"
      Write(6,*) "The current gradient"
      Write(6, "(3F12.8)") ((Grad_K1C(i,j), i=1,3),j=1,Nreals)
      Write(6,*) "The previous gradient"
      Write(6, "(3F12.8)") (Work(j), j=1,3*Nreals)
      Write(6,*) "The geo. update"
      Write(6,"(3F12.8)") (Work(9*Nreals+i), i=1,3*Nreals)
      Write(6,*) "The restored Hessian"
      Call output(Hess_K1C, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals,
     &            3*Nreals, 1)
#endif
         Iw_off_pg = 1
         Iw_off_dx = Iw_off_pg + 9*Nreals 
         Iw_off_s1 = Iw_off_dx + 12*Nreals  
         Iw_off_s2 = Iw_off_s1 + 12*Nreals + Nreals*Nreals
         Iw_off_ed = Iw_off_s2 + 3*Nreals*Nreals
         If (Iw_off_ed .GT. 36*Nreals*Nreals) Call Insmem(
     &       "@-Constr_search",Iw_off_ed,36*Nreals*Nreals)
C
         If (Powel_upd) Call Powel_update(Grad_K1C, Work(Iw_off_pg),
     &                                    Hess_K1C, Work(Iw_off_s1),
     &                                    Work(Iw_off_dx),   
     &                                    Work(Iw_off_s2), 1.0D0,
     &                                    3*Nreals)
C
#ifdef _DEBUG_LVL0
      if (Powel_upd) then
      Write(6,*) "The powel updated Hessian"
      Call output(Hess_K1C, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals,
     &            3*Nreals, 1)
      endif
#endif
C
         If (Bfgs_upd) Call Bfgs_update(Grad_K1C, Work(Iw_off_pg), 
     &                      Hess_K1C, Work(Iw_off_s1), 
     &                      Work(Iw_off_dx), Work(Iw_off_s2),
     &                      3*Nreals)
C
#ifdef _DEBUG_LVL0
      if (Bfgs_upd) then
      Write(6,*) "The BFGS updated Hessian"
      Call output(Hess_K1C, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals,
     &            3*Nreals, 1)
      endif
#endif   
C
         Call Ln_interpol(Coords_K0OM, Coords_K1CM, Coords_K1C,
     &                    Coords_K1PM, Grad_on_K0O, Grad_on_K1C, 
     &                    Vec_K0O, Vec_K1C, Grad_K0O, Grad_K1CM, 
     &                    Grad_K1C, Work, Work(3*Nreals+1), 
     &                    Work(6*Nreals+1), AtmMass, Nreals, 
     &                    Ln_Intrp_Tol)
C
#ifdef _DEBUG_LVL0
      Write(6,"(a,a,a)") "@-constr_search After linear interpolation",
     &                 " current point and gradients, M.W. first",
     &                 " and then no M.W"
      Write(6,"(a)")  "The M.W. current geometry " 
      Write(6, "(3F12.8)") (Coords_K1CM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The M.W.current gradient"
      Write(6,"(3F12.8)") ((Grad_K1CM(i,j), i=1,3),j=1,Nreals)
      Write(6,"(a)")  "The no M.W. current geometry " 
      Write(6, "(3F12.8)") (Coords_K1C(i),i=1,3*Nreals)
      Write(6,"(a)")  "The no M.W.current gradient"
      Write(6,"(3F12.8)") ((Grad_K1C(i,j), i=1,3),j=1,Nreals)
#endif
      Endif
C
C Save the current coordinates in the work array. The current coordinates
C will get modified in get_lambda. The unmodified current coordinates are
C needed in subsequent steps. 
      
      Call Dcopy(3*Nreals, Coords_K1C, 1, VCoords, 1)
      Call Get_lambda(Grad_K1CM, Vec_K1C0, Work, Work(3*Nreals+1),  
     &                Hess_K1C, A2Hess, AtmMass, Work(6*Nreals+1), 
     &                Work(9*Nreals + 1), Coords_K1C, Stride, Delta, 
     &                Nreals, Hess_Eval_Tol, Lamsearch_Tol, 
     &                Binsearch_Tol)
      Call Dcopy(3*Nreals, Vcoords, 1, Coords_K1C, 1)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a)") "@-Constr_search The No M. W. updated vector",
     &                 " (Vec_K1C_Updated)"
      Write(6,"(3F12.8)") (Work(6*Nreals+i), i=1,3*Nreals)
      Write(6,*) "@-Constr_search geo. (before updated, no M.W)"
      Write(6,"(3F12.8)") (Coords_K1C(i), i=1,3*Nreals)
#endif
C
C Save the previous point coordinates, gradients and tangent gradients before
C generating the new point.
C
      Call Dcopy(3*Nreals, Coords_K1CM, 1, Coords_K0OM, 1)
      Call Dcopy(3*Nreals, Grad_on_K1C, 1, Grad_on_K0O, 1)
      Call Dcopy(3*Nreals, Grad_K1C, 1, Grad_K0O, 1)
C
C Add the geo. update to the current point and generate a new point.

      Call Daxpy(3*Nreals, 1.0D0, Work(6*Nreals+1), 1, Coords_K1C, 1)
      Call Dcopy(3*Nreals, Work(6*Nreals+1), 1, Work(9*Nreals+1), 1)
C
      Ioff = 0
      Do Iatom = 1, Nreals
         Do Ixyz = 1, 3
               Ioff = Ioff + 1
                Work(6*Nreals+Ioff)= Work(6*Nreals+Ioff)*
     &                               Dsqrt(AtmMass(Iatom))
         Enddo
      Enddo
      Call Daxpy(3*Nreals, 1.0D0, Work(6*Nreals+1), 1, Coords_K1CM, 1)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search The updated no M.W. geo."
      Write(6,"(3F12.8)") (Coords_K1C(i), i=1,3*Nreals)
      Write(6,*) "@-Constr_search The updated M.W. geo."
      Write(6,"(3F12.8)") (Coords_K1CM(i), i=1,3*Nreals)
#endif
C 
      Delta_q = Ddot(3*Nreals, Work(3*Nreals+1), 1, Work(3*Nreals+1),
     &               1)
      Delta_g = Grad_on_K1C_stat(5)*Dsqrt(Dble(3*Nreals))
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Check for convergence"
      Write(6,"(a,2F12.8)") "G_cutoff, R_cutoff",G_cutoff, R_cutoff
      Write(6,"(a,2F12.8)") "Delta_q, Delta_g  ",Delta_q, Delta_g
#endif
      If (Delta_g .LT. G_cutoff .AND. Delta_q .LT. R_cutoff) 
     &   Constr_Min = "Found"       
C
      If (Constr_min .EQ. "Found") Then

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search The IRC is converged "
      Write(*,"(3F12.8)") (Coords_K1C(I), I = 1, 3*Nreals)
#endif
C
         IUnitO = 30
         Open(IUnitO,File='IRC.map',Status='Unknown')
         ierr = 0
         Do while (ierr .eq. 0)
            Read(IUnitO,7000, iostat=ierr) Temp_buff
         Enddo
C
 7000 Format(5X,A5,F15.10,2F18.10,F18.10)
C
         Write(IUnitO,"(3(2X,F12.8))") (Coords_K1C(I), I = 1,3*Nreals)
         Write(IUnitO, "")
         Close(IUnitO)
         Return
      Endif
C
      Call Dzero(Vcoords, 3*Natoms)
      Call Dzero(Coords, 3*Natoms)
      Call Daxpy(3*Nreals, Convert, Coords_K1C, 1, Vcoords, 1)
      Do Iatoms = 1, Natoms
         If (Imap(Iatoms) .NE. 0) Then
             Ioff = 3*(Imap(Iatoms) - 1) + 1
             Joff = 3*(Iatoms - 1) + 1
             Call Dcopy(3, Vcoords(Joff), 1, Coords(Ioff), 1)
         Endif
      Enddo
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-Constr_search updated geo. to JARC"
      Write(6,"(3F12.8)") (Coords(i), i=1,3*Nreals)
#endif    
      Call Putrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP,
     &            Coords)
C
      Call a2_reset_jarc
      Call aces_ja_fin
      Call Runit("runaces2b")
      Call aces_ja_init

      Call Getrec(20,'JOBARC','GRADIENT',3*Nreals*IINTFP,
     &            Grad_K1C(1,1))
      Call Getrec(20,'JOBARC','TOTENERG', IINTFP, E_currnt)

      If (E_currnt .GT. E_previs) Then
          Write(6, "(a,a)") "Warning: The energy is rising ", 
     &                      "during the constrained search." 
           E_Previs = E_currnt
      Endif 
C
      Call Dzero(grad_K1CM, 3*Natoms)
      Ioff = 0
      Do i=1, Natoms
         k=Imap(i)
         If (k .NE. 0) Then
            Do j=1,3
               Grad_K1CM(j,k)  = Grad_K1C(j,i)
            Enddo
         Endif
      Enddo
C
      Call Dcopy(3*Natoms, Grad_K1CM, 1, Grad_K1C, 1)
C
      Do i=1, Natoms
         If (Imap(i) .NE. 0) Then
            Call Dcopy(3, Grad_K1C(1,Imap(i)), 1, Grad_K1CM(1,i), 1)
         Endif
      Enddo
C
      Call Dcopy(3*Nreals, grad_K1CM, 1, Grad_K1C, 1)
C
      Do Iatom = 1, Nreals 
         Do Ixyz = 1, 3
            Grad_K1CM(Ixyz, Iatom) = Grad_K1CM(Ixyz, Iatom)/
     &                               Dsqrt(AtmMass(Iatom))
         Enddo
      Enddo

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a)") "@-Constr_search Grad_K1C at the updated",
     &                 " M. W. gradient. (ZMAT order)."
      Write(6, "(3F12.8)") ((Grad_K1CM(i,j), i=1,3),j=1,Nreals)
#endif
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a)") "@-Constr_search leaving M. W.,"
     &                  "prev current and pivot point"
      Write(6, "(3F12.8)") (Coords_K0OM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The curr. point"
      Write(6, "(3F12.8)") (Coords_K1CM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The pivot. point"
      Write(6, "(3F12.8)") (Coords_K1PM(i),i=1,3*Nreals)
#endif
C  
      Return
      End 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__COMPARE_VECTOR_PAIRS
     +
     +                    ( DDV,DDW,DDP,
     +                      N,
     +                      ABSOLUT,
     +                      THRESH,
     +                      P,
     +                      V,W,
     +
     +                             MATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__COMPARE_VECTOR_PAIRS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : Given two vector pairs V1,V2 and W1,W2, this routine
C                examines, if the components of V1 and W1 and the
C                components of V2 and W2 match to within a threshold
C                accuracy. There is also the option to match only
C                the absolute component values. The procedure is a
C                simple exhaustive comparison between the components.
C
C
C                  Input:
C
C                    DDV,DDW   =  row dimensions of vector pairs V1,V2
C                                 and W1,W2
C                    DDP       =  dimension of index vector P
C                    N         =  # of rows of vector pairs V1,V2 and
C                                 W1,W2
C                    ABSOLUT   =  is true, if the absolute values
C                                 of the vector components are to be
C                                 taken for comparison.
C                    P         =  integer index vector that will hold
C                                 indices of vector pair V1,V2 still
C                                 to be compared with.
C                    V,W       =  N x 2 arrays corresponding to the
C                                 vector pairs V1,V2 and W1,W2.
C
C                  Output:
C
C                    MATCH     =  is true, if the components of the
C                                 vector pairs were found to match,
C                                 false otherwise.
C
C
C                Note: Both vector pairs V1,V2 and W1,W2 will NOT
C                      be destroyed!
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ABSOLUT
         LOGICAL     EQUAL
         LOGICAL     MATCH

         INTEGER     DDV,DDW,DDP
         INTEGER     I,J,K,N
         INTEGER     LEFT

         INTEGER     P (1:DDP)

         DOUBLE PRECISION  D1,D2
         DOUBLE PRECISION  V1,V2,W1,W2
         DOUBLE PRECISION  THRESH

         DOUBLE PRECISION  V (1:DDV,1:2)
         DOUBLE PRECISION  W (1:DDW,1:2)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions of vectors supplied.
C
C
         IF (N.GT.DDV .OR. N.GT.DDW) THEN
             WRITE (*,*) ' Dimensions of vector V and/or W too small! '
             WRITE (*,*) ' nlo__compare_vector_pairs '
             WRITE (*,*) ' DDV,DDW,N = ',DDV,DDW,N
             WRITE (1,*) ' Dimensions of vector V and/or W too small! '
             WRITE (1,*) ' nlo__compare_vector_pairs '
             WRITE (1,*) ' DDV,DDW,N = ',DDV,DDW,N
             STOP
         END IF

         IF (N.GT.DDP) THEN
             WRITE (*,*) ' Dimensions of index vector P too small! '
             WRITE (*,*) ' nlo__compare_vector_pairs '
             WRITE (*,*) ' DDP,N = ',DDP,N
             WRITE (1,*) ' Dimensions of index vector P too small! '
             WRITE (1,*) ' nlo__compare_vector_pairs '
             WRITE (1,*) ' DDP,N = ',DDP,N
             STOP
         END IF
C
C
C             ...proceed with exhaustive search.
C
C
         DO I = 1,N
            P (I) = I
         END DO

         LEFT = N
         MATCH = .TRUE.
C
C
C             ...based on absolute vector component values.
C
C
         IF (ABSOLUT) THEN

             DO 100 I = 1,N

                W1 = DABS (W (I,1))
                W2 = DABS (W (I,2))

                DO J = 1,LEFT
                   K = P (J)
                   V1 = DABS (V (K,1))
                   V2 = DABS (V (K,2))
                   D1 = DABS (V1 - W1)
                   D2 = DABS (V2 - W2)
                   EQUAL = D1.LT.THRESH .AND. D2.LT.THRESH
                   IF (EQUAL) THEN
                       DO K = J+1,LEFT
                          P (K-1) = P (K)
                       END DO
                       GOTO 100
                   END IF
                END DO

                MATCH = .FALSE.
                RETURN

  100        CONTINUE

         ELSE
C
C
C             ...based on true vector component values.
C
C
             DO 200 I = 1,N

                W1 = W (I,1)
                W2 = W (I,2)

                DO J = 1,LEFT
                   K = P (J)
                   V1 = V (K,1)
                   V2 = V (K,2)
                   D1 = DABS (V1 - W1)
                   D2 = DABS (V2 - W2)
                   EQUAL = D1.LT.THRESH .AND. D2.LT.THRESH
                   IF (EQUAL) THEN
                       DO K = J+1,LEFT
                          P (K-1) = P (K)
                       END DO
                       GOTO 200
                   END IF
                END DO

                MATCH = .FALSE.
                RETURN

  200        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_flags(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c---------------------------------------------------------------------------
c   Sets the indices of a 3-d static array in common block values.
c   The first index is assumed to be the atom, the second is the component
c   index (i. e. x,y, or z), and the 3rd is the center.
c
c   These indices are stored in the d2int_com common block, and are meant
c   to indicate the atom, component, and center on which to calculate a 
c   single block of derivative integrals.
c
c   Example:
c      index jatom = 1, natoms
c      index jx = 1,3
c      index jcenter = 1,4      
c      static flags(jatom, jx, jcenter)
c
c      taoint(mu,nu,lambda, sigma) = 0.
c      do jatom
c      do jx
c      do jcenter
c         execute set_flags flags(jatom, jx, jcenter)
c         execute d2int aoint(mu, nu, lambda, sigma)
c         taoint(mu,nu,lambda, sigma) += aoint(mu, nu, lambda, sigma)
c      enddo jcenter
c      enddo jx
c      enddo jatom
c
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter
      double precision flags_value

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer ierr, array, array_type, ind, nind
      integer i

      array = op(c_result_array)
      if (array .lt. 1 .or. array .gt. narray_table) then
         print *,'Error: Invalid array in set_flags, line ',
     *     current_line
         print *,'Array index is ',array,' Allowable values are ',
     *      ' 1 through ',narray_table
         call abort_job()
      endif

      nind = array_table(c_nindex, array)
      if (nind .ne. 3) then
         print *,'Error: set_flags requires a 3-index array.'
         call abort_job()
      endif

c-----------------------------------------------------------------------
c   Atom, component, and center indices are determined from the c_current_seg
c   field of the 1st, 2nd, and 3rd index of the array.
c------------------------------------------------------------------------

      ind   = array_table(c_index_array1,array)
      jatom = index_table(c_current_seg, ind)
      ind   = array_table(c_index_array1+1,array)
      jx    = index_table(c_current_seg, ind)
      ind   = array_table(c_index_array1+2,array)
c     jcenter = index_table(c_current_seg, ind)

c-----------------------------------------------------------------------
c   Set jcenter to 0 as it is not currently being used.  
c-----------------------------------------------------------------------

      jcenter = 0 

      return
      end

      SUBROUTINE NEWRAPH(SCRATCH, GRDHES, HESMOD, DIAGHES, MORSE, 
     &                   NOPT, NX, LUOUT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "mxatms.par"
#include "coord.com"
#include "flags.h"
#include "jodaflags.com"
C
      LOGICAL MORSE, XYZIN, NWFINDIF
C
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
      DIMENSION SCRATCH(NX*NX), GRDHES(NOPT), DIAGHES(NOPT, NOPT),
     &          HESMOD(NOPT, NOPT)
C     
C Do the Normal Newton-Raphson update
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6, "(1x,a,I5)") "The number of degs. of freed. 
     &          at NR:", NOPT
      Write(6,*)
#endif
      DO 10 I = 1, NOPT
         DO 20 J = 1, NOPT
            IF (HESMOD(I,I) .EQ. 0.0D0) Then
                    SCRATCH(J+NOPT) = SCRATCH(J+NOPT) - 0.0D0
            ELSE
C
                SCRATCH(J+NOPT)=SCRATCH(J+NOPT)-GRDHES(I)*
     &                          DIAGHES(J,I)/HESMOD(I,I) 
            ENDIF
 20      CONTINUE
 10   CONTINUE
C
#ifdef _DEBUG_LVL0     
      Write(6,*) "The unmolested step"
      Write(6, "(8F10.4)") (SCRATCH(J+NOPT), J=1, NOPT)
#endif 
C
C Notice that there is no Morse adjustments can be made for
C pure Cartesian OLPtimization (no connections), Also, no 
C Morse scaling can be done for redundent internals.
C Ajith Perera,08/2008, 2011.
C
      IF (MORSE) THEN
         IF (iFlags2(h_IFLAGS2_geom_opt) .ge. 3) THEN
CSSS           CALL DOMORSEXYZ_RIC(SCRATCH, NOPT, NX, LUOUT)
         ELSE IF (iFlags2(h_IFLAGS2_geom_opt) .eq. 1) THEN
           CALL DOMORSEZMT(SCRATCH, NOPT, NX, LUOUT)
         ENDIF  
      ENDIF
C
      RETURN
      END

      SUBROUTINE NEWRAPH(SCRATCH, GRDHES, HESMOD, DIAGHES, MORSE, 
     &                   NOPT, NX, LUOUT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end






























































































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C
      LOGICAL MORSE, XYZIN, NWFINDIF
C
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
      DIMENSION SCRATCH(NX*NX), GRDHES(NOPT), DIAGHES(NOPT, NOPT),
     &          HESMOD(NOPT, NOPT)
C     
C Do the Normal Newton-Raphson update
C
      Write(6,*) 
      Write(6, "(1x,a,I5)") "The number of degs. of freed. 
     &          at NR:", NOPT
      Write(6,*)
      DO 10 I = 1, NOPT
         DO 20 J = 1, NOPT
            IF (HESMOD(I,I) .EQ. 0.0D0) Then
                    SCRATCH(J+NOPT) = SCRATCH(J+NOPT) - 0.0D0
            ELSE
C
                SCRATCH(J+NOPT)=SCRATCH(J+NOPT)-GRDHES(I)*
     &                          DIAGHES(J,I)/HESMOD(I,I) 
            ENDIF
 20      CONTINUE
 10   CONTINUE
C
      Write(6,*) "The unmolested step"
      Write(6, "(8F10.4)") (SCRATCH(J+NOPT), J=1, NOPT)
C
C Notice that there is no Morse adjustments can be made for
C pure Cartesian OLPtimization (no connections), Also, no 
C Morse scaling can be done for redundent internals.
C Ajith Perera,08/2008, 2011.
C
      IF (MORSE) THEN
         IF (iFlags2(5) .ge. 3) THEN
CSSS           CALL DOMORSEXYZ_RIC(SCRATCH, NOPT, NX, LUOUT)
         ELSE IF (iFlags2(5) .eq. 1) THEN
           CALL DOMORSEZMT(SCRATCH, NOPT, NX, LUOUT)
         ENDIF  
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE POLYPRT0(NATOMS,IINTFP,IPRINT,
     &                    LCOORD,LENERG,LGRAD,LHESS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LCOORD,LENERG,LGRAD,LHESS
      PARAMETER(MXATMS=250)
      DIMENSION  SCR(3*MXATMS + 3*MXATMS + 9*MXATMS*MXATMS)
      DIMENSION ISCR(  MXATMS)

      IF (NATOMS.GT.MXATMS) THEN
         WRITE(6,1000) NATOMS, MXATMS
 1000    FORMAT('  @POLYPRT0: Too many atoms. Given ',I3,' Max ',I3)
         CALL ERREX
      END IF

      I000 = 1
      I010 = I000 + 3*NATOMS
      I020 = I010 + 3*NATOMS
      I030 = I020 + 9*NATOMS*NATOMS
      CALL POLYPRT(SCR(I000),SCR(I010),SCR(I020),ISCR,
     &             NATOMS,IINTFP,IPRINT,
     &             LCOORD,LENERG,LGRAD,LHESS)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine collective_sum(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      comm, op)
c---------------------------------------------------------------------------
c   Handler for the collective_sum_op operation.
c   This routine performs a global accumulate of a scalar on all processors,
c   (i. e. mpi_all_reduce).
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table, comm
      double precision scalar_table(nscalar_table)

      integer i, result_array, op1_array
      integer iop1, ires
      integer nprocs
      integer ierr

      result_array = op(c_result_array)
      op1_array    = op(c_op1_array)

c-------------------------------------------------------------------------
c   Check for scalar operands.
c-------------------------------------------------------------------------

      if (array_table(c_array_type,result_array) .ne. 
     *                              scalar_value .or.
     *    array_table(c_array_type,op1_array) .ne. scalar_value) then
         print *,'Error in collective_sum: Arrays are not scalars.'
         print *,'Op1 = ',op1_array,' Result = ',result_array
         print *,'Operation: ',(op(i),i=1,loptable_entry)
         call abort_job()
      endif 

c-------------------------------------------------------------------------
c   Look up the scalar values in the scalar_table.
c-------------------------------------------------------------------------

      iop1 = array_table(c_scalar_index,op1_array)
      ires = array_table(c_scalar_index,result_array)

c-------------------------------------------------------------------------
c   Accumulate the sum into the result value.
c-------------------------------------------------------------------------

      call mpi_comm_size(comm, nprocs, ierr)
      if (nprocs .eq. 1) then
         scalar_table(ires) = scalar_table(ires) + scalar_table(iop1)
      else   
         call mpi_allreduce(scalar_table(iop1), scalar_table(ires), 
     *              1, mpi_double_precision, mpi_sum, comm, ierr)
      endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      character*24 function get_timestamp()
c-----------------------------------------------------------------------
c   Returns the current time.
c-----------------------------------------------------------------------

      implicit none

      character*8 dt
      character*10 tm

#ifdef HP
      character*24 ctime
      integer system_time
      integer time
      external time
      external ctime

      system_time = time()
      get_timestamp = ctime(system_time)
#else
      call date_and_time(dt, tm)

      get_timestamp = tm(1:2)//':'//tm(3:4)//':'//tm(5:6)
#endif
      return
      end

c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     anthony yau, modified directly from idamax

      integer function iiamax(n,iarray,incx)
      integer n,iarray(1),incx
      integer i,ix,imax,itmp

      if (n.le.1) then
         if (n.eq.1) then
            iiamax=1
         else
            iiamax=0
         end if
         return
      end if

      itmp=1
      imax=abs(iarray(1))
      if (incx.eq.1) then
         do i=2,n
            if (abs(iarray(i)).gt.imax) then
               itmp=i
               imax=abs(iarray(i))
            end if
         end do
      else
         ix=1
         do i=2,n
            ix=ix+incx
            if (abs(iarray(ix)).gt.imax) then
               itmp=i
               imax=abs(iarray(ix))
            end if
         end do
      end if
      iiamax=itmp

      return
      end

C THIS SUBROUTINE LOCATES THE FIRST OCCURANCE OF A CHARACTER*(*) STRING
C IN A CHARACTER*(*) VECTOR.
C
C INPUT: 
C    LENGTH - THE LENGTH OF THE VECTOR (# OF ELEMENTS)
C         Z - THE VECTOR TO BE SEARCHED.
C       INC - THE STRIDE LENGTH THROUGH THE VECTOR
C    TARGET - THE CHARACTER STRING WHICH IS TO BE LOCATED.
C
C THIS ROUTINE IS USED BY PUTREC AND GETREC BUT MAY BE USEFUL FOR OTHER
C PURPOSES.
C
C NOTE THAT IF LEN( Z(1) ) .NE. LEN(TARGET) THEY WILL NEVER MATCH!

      INTEGER FUNCTION LOCCHR(LENGTH,Z,INC,TARGET)
      IMPLICIT INTEGER (A-Z)
      CHARACTER*(*) Z(LENGTH)
      CHARACTER*(*) TARGET
#ifdef _STRINGENT_CHECK
      double precision dtmp, dsqrt, dfloat
      if (length.lt.0) dtmp = dsqrt(dfloat(length))
      if (length.eq.0) dtmp = 1/length
      if (inc.lt.0) dtmp = dsqrt(dfloat(inc))
      if (inc.eq.0) dtmp = 1/inc
#endif /* _STRINGENT_CHECK */
      DO LOCCHR = 1, LENGTH, INC
         IF (Z(LOCCHR).EQ.TARGET) RETURN
      END DO
      RETURN
      END

C THIS ROUTINE DRIVES THE FORMATION OF THE FORCE CONSTANTS.

c INPUT
c integer NATOM  : the number of atoms
c integer NIRREP : the number of irreps
c integer IORDGP :
c char*4  TYPE   : (FULL|COMP) point group
c integer NDSCR  : the amount of double scratch at DSCR

c OUTPUT
c char*8  LABEL(NIRREP)     : (scr) symmetry label of each irrep
c integer ISYMIRR(3*NATOM)  : (scr)
c integer INVOP(3*NATOM)    : (scr)
c double  SYOP(3*NATOM)     : (scr)
c double  SYMHESS(3*NATOM)  : Symmetry  coordinate Hessian
c double  CARTHESS(3*NATOM) : Cartesian coordinate Hessian
c double  DIPDER(9*NATOM)   : Symmetry  coordinate dipole derivative
c double  DIPDFUL(9*NATOM)  : Cartesian coordinate dipole derivative
c double  POLDER(27*NATOM)  : Symmetry  coordinate polarizability derivative
c double  POLDFUL(27*NATOM) : Cartesian coordinate polarizability derivative
c double  DSCR(NDSCR)       : (scr) double scratch

c RECORDS
c get 'NUMPOINT'
c get 'ENGPOINT'
c get 'REFENERG'
c get 'GRDPOINT'
c get 'DIPPOINT'
c get 'POLPOINT'
c get 'OPERSREF'
c get 'NUMVIBRT'
c get 'INVPSMAT'
c get 'NPTIRREP'
c get TYPE//'SYQT'
c get TYPE//'DEGN'
c get TYPE//'LABL'
c put 'HESSIANM'

      SUBROUTINE SETFCM(NATOM,NIRREP,IORDGP,TYPE,
     &                  LABEL,ISYMIRR,INVOP,SYOP,
     &                  SYMHESS,CARTHESS,
     &                  DIPDER,DIPDFUL,
     &                  POLDER,POLDFUL,
     &                  DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      CHARACTER*4 TYPE
      CHARACTER*8 LABEL(NIRREP)
      DIMENSION ISYMIRR(3*NATOM),INVOP(3*NATOM),SYOP(9*IORDGP)
      DIMENSION SYMHESS(9*NATOM*NATOM),CARTHESS(9*NATOM*NATOM),
     &          DIPDER(3*3*NATOM),DIPDFUL(3*3*NATOM),
     &          POLDER(3*NATOM*9),POLDFUL(9*3*NATOM)
      double precision dscr(ndscr)

      DIMENSION idegen(100),nptsirr(100)
      LOGICAL PRINTQ, bTmp

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100)
      LOGICAL          ENERONLY,GRADONLY,ROTPROJ,RAMAN,GMTRYOPT,
     &                 SNPTGRAD
      COMMON /CONTROL/ ENERONLY,GRADONLY,ROTPROJ,RAMAN,GMTRYOPT,
     &                 SNPTGRAD 

      PRINTQ=(IFLAGS(1).GT.10)
      STPSIZ=DFLOAT(IFLAGS(57))*10.0D-5
      NSIZE=3*NATOM
      lFREE=1

      CALL GETREC(20,'JOBARC','NUMPOINT',1,NPOINT)
      IF (ENERONLY) THEN
         lENGPNT = lFREE
         lFREE   = lFREE + NPOINT
      ELSE
         lGRDPNT = lFREE
         lFREE   = lFREE + NSIZE*NPOINT
         lDIPPNT = lFREE
         lFREE   = lFREE + 3*NPOINT
         lPOLPNT = lFREE
         lFREE   = lFREE + 9*NPOINT
      END IF
      NDSCRLFT = NDSCR+1-lFREE
      IF (NDSCRLFT.LT.0) THEN
         print *, '@SETFCM: Insufficient memory.'
         print *, '         need ',-ndscrlft*ifltln,' more bytes'
         call aces_exit(1)
      END IF
      IF (ENERONLY) THEN
         CALL GETREC(20,'JOBARC','ENGPOINT',NPOINT*IINTFP,DSCR(lENGPNT))
         Print*, "Energy point"
         Print*, (DSCR(I), I=1, NPOINT)

         do i = 0, npoint-1
            if (dscr(lENGPNT+i).eq.0.d0) then
c            o if any energy is exactly 0, then ACES did not do all points
               print *, '@SETFCM: Assertion failed.'
               print *, '         Energy of point ',1+i,' is 0. a.u.'
               call aces_exit(1)
            end if
         end do
         CALL GETREC(20,'JOBARC','REFENERG',IINTFP,E0)
         Print*, E0
      ELSE
         CALL GETREC(20,'JOBARC','GRDPOINT',
     &               NSIZE*NPOINT*IINTFP,DSCR(lGRDPNT))
         do i = 0, nsize*npoint-1, nsize
            bTmp = .true.
            do j = 0, nsize-1
               if (dscr(lGRDPNT+i+j).ne.0.d0) bTmp = .false.
            end do
            if (bTmp) then
c            o if any gradient is exactly 0, then something is PROBABLY wrong
               print *, '@SETFCM: Assertion failed.'
               print *, '         Gradient of point ',1+(i/nsize),
     &                  ' is 0. a.u.'
               call aces_exit(1)
            end if
         end do

         CALL GETREC(20,'JOBARC','DIPPOINT',
     &               3*NPOINT*IINTFP,DSCR(lDIPPNT))
         CALL GETREC(20,'JOBARC','POLPOINT',
     &               9*NPOINT*IINTFP,DSCR(lPOLPNT))
         CALL GETREC(20,'JOBARC','OPERSREF',IORDGP*9*IINTFP,SYOP)
      END IF

      CALL GETREC(20,'JOBARC','NUMVIBRT',1,NMODE)
      CALL GETREC(20,'JOBARC','INVPSMAT',NMODE,INVOP)
      CALL GETREC(20,'JOBARC','NPTIRREP',NIRREP,NPTSIRR)
      CALL GETREC(20,'JOBARC',TYPE//'SYQT',NSIZE,ISYMIRR)
      CALL GETREC(20,'JOBARC',TYPE//'DEGN',NIRREP,IDEGEN)
      IF (PRINTQ) THEN
      CALL GETREC(20,'JOBARC',TYPE//'LABL',NIRREP*IINTFP,LABEL)
      END IF

C-----------------------------------------------------------------------
CJDW 6/21/96. Initialize other arguments. Try to make sure intensities
C             come out zero in ENERONLY jobs.
CJDW/AP Jul/98 extended to calculate Raman Intensities.
C-----------------------------------------------------------------------
      CALL ZERO(SYMHESS,9*NATOM*NATOM)
      CALL ZERO(DIPDER, 9*NATOM      )
      CALL ZERO(POLDER, 9*NATOM*3    )
C-----------------------------------------------------------------------

      IFIRST=0
      IFIRSTP=0
      IFIRSTD=0
      IFIRSTG=0
      IOFF=1
      IOFFD=1
      IOFFP=1
      IOFFINV=1
      NLEFT=NMODE

c   o loop over symmetry blocks
      DO IRREP=1,NIRREP

c   o find first occurance of this irrep
      ILOC=ISRCHEQ(NMODE,ISYMIRR,1,IRREP)
      IF (ILOC.NE.NMODE+1) THEN
         ILAST=ISRCHNE(NLEFT,ISYMIRR(ILOC),1,IRREP)
         NVIBSYM=ILAST-1
         NVIBUNQ=NVIBSYM/IDEGEN(IRREP)
         IF (PRINTQ) THEN
            WRITE(6,2000)LABEL(IRREP),IDEGEN(IRREP),NVIBSYM
2000        FORMAT(T3,' Symmetry : ',A,' Degeneracy : ',I1,
     &             ' Unique symmetry coordinates : ',I3)
         END IF

C USE FIRST NVIBUNQ VECTORS FOR DEGENERATE REPS SINCE THEY ARE SORTED
C ACCORDING TO SUBGROUP IRREPS.  OTHERS ARE REDUNDANT.

         IF (ENERONLY) THEN

            Print*, "Entering ener2fcm"

            CALL ENER2FCM(NVIBUNQ,DSCR(lENGPNT+IFIRST),SYMHESS(IOFF),
     &                    INVOP(IOFFINV),STPSIZ,E0,DSCR(lFREE),NDSCRLFT)
            IFIRST=IFIRST+NPTSIRR(IRREP)
         ELSE
C 08/16, Extensions to do Raman Intensities, Ajith and John.

            Print*, "Entering the grad2fcm"

            CALL GRAD2FCM(NATOM,NVIBUNQ,
     &                    DSCR(lGRDPNT+IFIRSTG),SYMHESS(IOFF),
     &                    DSCR(lDIPPNT+IFIRSTD),DIPDER(IOFFD),
     &                    DSCR(lPOLPNT+IFIRSTP),POLDER(IOFFP),
     &                    INVOP(IOFFINV),SYOP,STPSIZ,
     &                    DSCR(lFREE),NDSCRLFT)
            IOFFD=IOFFD+3*NVIBUNQ
            IOFFP=IOFFP+9*NVIBUNQ
            IFIRSTG=IFIRSTG+NPTSIRR(IRREP)*NSIZE+NVIBSYM
            IFIRSTD=IFIRSTD+NPTSIRR(IRREP)*3
            IFIRSTP=IFIRSTP+NPTSIRR(IRREP)*9
         END IF
         IOFF=IOFF+NVIBUNQ*NVIBUNQ
         IOFFINV=IOFFINV+NVIBSYM
         NLEFT=NLEFT-NVIBUNQ

      END IF
      END DO

c   o reset the scratch (l*PNT is not used anymore)
      lFREE = 1
      NDSCRLFT = NDSCR

c   o transform and write the Hessian to JOBARC
      CALL TRNFCM(NMODE,NATOM,NIRREP,
     &            SYMHESS,CARTHESS,
     &            ISYMIRR,IDEGEN,TYPE,DSCR(lFREE),NDSCRLFT)
      CALL PUTREC(20,'JOBARC','HESSIANM',NSIZE*NSIZE*IINTFP,CARTHESS)

C Modifications for Raman Intensities Ajith and John 08/98
      CALL TRNDIP(NMODE,NATOM,NIRREP,
     &            DIPDER,DIPDFUL,POLDER,POLDFUL,
     &            ISYMIRR,IDEGEN,TYPE,DSCR(lFREE),NDSCRLFT)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__CTR_TU_EXPAND
     +
     +                    ( NXYZRS,NTU,
     +                      NT,NU,
     +                      X,
     +
     +                             Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__CTR_TU_EXPAND
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine expands the tu contraction indices:
C
C                      x (nxyzt,rs,t>=u) --> y (nxyzt,rs,tu)
C
C
C                  Input:
C
C                      NXYZRS     =  total # of cartesian monomial
C                                    quadruplets times # of contractions
C                                    for contraction shell pair rs
C                                    (invariant indices)
C                      NTU        =  total # of contraction index pairs
C                                    for contraction shells tu before
C                                    expansion
C                      NT(U)      =  # of contractions for contraction
C                                    shells t(u)
C                      X          =  original integral batch with
C                                    contraction index restriction
C                                    t>=u
C
C                  Output:
C
C                      Y          =  new integral batch with complete
C                                    set of contraction indices tu
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     N,T,U
         INTEGER     NT,NU
         INTEGER     NTU
         INTEGER     NXYZRS
         INTEGER     TU

         DOUBLE PRECISION  X (1:NXYZRS,1:NTU)
         DOUBLE PRECISION  Y (1:NXYZRS,1:NT,1:NU)
C
C
C------------------------------------------------------------------------
C
C
C             ...do the expansion.
C
C
         TU = NTU + 1

         DO 100 U = NU,1,-1

            DO 200 T = NT,U+1,-1

               TU = TU - 1

               DO N = 1,NXYZRS
                  Y (N,T,U) = X (N,TU)
               END DO

               DO N = 1,NXYZRS
                  Y (N,U,T) = X (N,TU)
               END DO

  200       CONTINUE

            TU = TU - 1
            DO N = 1,NXYZRS
               Y (N,U,U) = X (N,TU)
            END DO

  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine asymm_force_a(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c The diagonal elements of a four index array are extracted. 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
       double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk, get_block_index
      integer stack
      
      integer comm

      integer val1(mx_array_index), val2(mx_array_index)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      common /epsilon/epsilon(1000), epsilonb(1000)
      double precision epsilon, epsilonb
    
#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      array = op(c_result_array)
      nindex = array_table(c_nindex, array)
      do i = 1, nindex
         index = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg = index_table(c_current_seg,index)

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c---------------------------------------------------------------------------
c   Get array data address.
c---------------------------------------------------------------------------

      if (array_table(c_array_type,array) .eq. static_array) then
         addr = address_table(array)
         indblk = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack = array_table(c_array_stack,array)
         indblk = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif 

      if (nindex .eq. 4) then
         call doasymmforcea4(x(indblk), val1(1),val2(1),type(1),
     *                   val1(2),val2(2),type(2),
     *                   val1(3),val2(3),type(3),
     *                   val1(4),val2(4),type(4), 
     *                   epsilon,epsilonb)
        return 
      endif  
      if (nindex .eq. 2) then
         call doasymmforcea2(x(indblk), val1(1),val2(1),type(1),
     *                   val1(2),val2(2),type(2),
     *                   epsilon,epsilonb)
        return 
      endif
         print *,'Error in return_diagonal_4: Result array ',
     *      'must have 4 indices.'
         print *,'array ',array,' has ',nindex,' indices.'
         call abort_job()
      
      return
      end

      subroutine doasymmforcea4(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision val

c
      if (atype .eq. btype .and. itype .eq. jtype) then 
      do b = b1,b2
      do a = a1,a2
         do j = j1,j2
         do i = i1,i2
            if (i .lt. j)then
               val = x(a,i,b,j)
               x(a,j,b,i)= val*(-1.0d0)
            endif
         enddo
         enddo
      enddo
      enddo
      val = 0.0d0 
      do b = b1,b2
      do a = a1,a2
         do j = j1,j2
         do i = i1,i2
         if(i .eq. j .or. a .eq. b)then
               x(a,i,b,j)= val
         endif
         enddo
         enddo
      enddo
      enddo
      return 
      endif 
c
      if (atype .ne. btype .and. itype .eq. jtype) then 

      do b = b1,b2
      do a = a1,a2
         do j = j1,j2
         do i = i1,i2
            if (i .lt. j)then
               val = x(a,i,b,j)
               x(a,j,b,i)= val*(-1.0d0)
            endif
         enddo
         enddo
      enddo
      enddo

      val = 0.0d0 
      do b = b1,b2
      do a = a1,a2
         do j = j1,j2
         do i = i1,i2
            if (i .eq. j)then
               x(a,j,b,i)= val
            endif
         enddo
         enddo
      enddo
      enddo

      return 

      endif 
c
c
      return
      end

      subroutine doasymmforcea2(x, a1,a2,atype,
     *                      i1,i2,itype,
     *                       epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision val

c
      do a = a1,a2
         do i = i1,i2
            if (a .lt. i)then
               val = x(a,i)
               x(i,a)= val*(-1.0d0)
            endif
         enddo
      enddo
c
      val = 0.0d0 
      do a = a1,a2
         do i = i1,i2
         if(a .eq. i)then
               x(a,i)= val
         endif
         enddo
      enddo
c
      return
      end

      SUBROUTINE CHKVEC(V,LENGTH,NATOMS,PTGRP,SITGRP,IBFATM,IOK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (TOL=1.D-6)
      DIMENSION V(LENGTH),IBFATM(NATOMS)
      CHARACTER*4 PTGRP,ISTGP
      CHARACTER*8 SITGRP(NATOMS)
      common /centre/ numcen0
      IOFF=0
      IOK=0
      DO 10 I=1,NATOMS
       LENATM=IBFATM(I)
       IF(LENATM.EQ.-1)GOTO 10
       DO 20 IPOS=1,LENATM
        IOFF=IOFF+1
        Z=ABS(V(IOFF))
        IF(Z.LT.TOL)GOTO 20
        ISTGP=SITGRP(I)(1:3)
        IF(ISTGP.NE.PTGRP.or.numcen0.eq.1)THEN
         IOK=1
        ENDIF
20     CONTINUE
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C Shell to drive LAPACK algorithm.

C A    - REAL SYMMETRIC MATRIX TO BE DIAGONALIZED (E.VALUES IN DIAGS AFTERWARDS)
C B    - EIGENVECTORS RETURNED IN COLUMNS
C JUNK - not used
C N    - SIZE OF MATRIX
C SORT - EIGENVECTORS AND EIGENVALUES ARE REORDERED, with eigenvalues:
c      0     - ascending
c      1     - unordered
c      other - descending
C DOSQ - THE SQUARE ROOT OF THE DIAGONALIZED MATRIX IS TAKEN 
C      0     - no 
C      1     - yes  
C DOINV- TAKE THE INVERSE OF THE DIAGONALIZED MATRIX
C      0     - no 
C      1     - yes  


      subroutine diag(a,b,junk,n,sort,dosq,doinv)
      implicit none
      include 'machine_types.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'scflindep.h'

      integer junk, n, sort, dosq, doinv,NLINDEP  
      double precision a(n,n),b(n,n),tresh,qqq

      integer i, j

c ----------------------------------------------------------------------
c   Call the ACESII "eig" routine.
c-----------------------------------------------------------------------
      tresh = 10**(-1.d0*lindep_tol)

      call eig(a,b,junk,n,sort)
c
c take the square root if desired 
c ------------------------------- 
c
      if (dosq .eq. 1) then  
c  

         do i = 1, n
            a(i,i) = dsqrt(a(i,i))
         enddo 
c
      endif 
c
c take the inverse if desired 
c --------------------------- 
c
      if (doinv .eq. 1) then  


      if(me.eq.0) then
      write(6,*) '-------------------------------------------'          
      write(6,*) 'Linear dependency threshold',tresh
      write(6,*) '-------------------------------------------'
      endif

      NLINDEP = 0
c------------------------------------------------------------------
         do i = 1, n
            qqq = a(i,i)*a(i,i) 
            IF(dabs(qqq).ge.tresh) then 
            a(i,i) = 1.0d0/a(i,i) 
            ELSE
            a(i,i) = 0.d0
            NLINDEP = NLINDEP + 1
            ENDIF
         enddo 
c------------------------------------------------------------------

        if(me.eq.0) then
         write(6,*)'==================================================='
         write(6,*) 'Basis of atomic orbitals contains', NLINDEP, 
     & 'linear dependecies'
        write(6,*)'===================================================='
        ENDIF

      endif 
c 
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine returns the DACOS of VALUE. If VALUE is within THRESH of 1.d0 or
c -1.d0, then VALUE is set to (-)1.d0 and the DACOS is evaluated and returned.

      double precision function dacosx(dValue,dThresh)
      implicit none
      double precision dValue, dThresh
      if (dabs(dabs(dValue)-1.d0).lt.dThresh) dValue=sign(1.d0,dValue)
      dacosx=dacos(dValue)
      return
      end

c This routine defines the default values for the common blocks in
c parallel_aces.com.

      blockdata aces_bd_parallel_aces
      implicit none
#define NO_EXTERNAL
#include "parallel_aces.com"
      data nprocs,irank /1,0/
      data szcpuname /'localhost'/
      data  icpuname /9/
      end

c This routine defines the default values for the common blocks in
c parallel_aces.com.

      blockdata aces_bd_parallel_aces
      implicit none
c parallel_aces.com : begin

c This common block contains the MPI statistics for each MPI process. The values
c are initialized in the acescore library.





      integer                nprocs, irank, icpuname

      character*(256) szcpuname

      common /parallel_aces/ nprocs, irank, icpuname,
     &                       szcpuname
      save   /parallel_aces/

c parallel_aces.com : end
      data nprocs,irank /1,0/
      data szcpuname /'localhost'/
      data  icpuname /9/
      end

      SUBROUTINE EVAL_QSTLST_PATH_UDI(QST_TANGENT, LST_TANGENT, WORK,
     &                                LST, QST)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

#include "mxatms.par"
#include "machsp.com"
#include "coord.com"

      LOGICAL XYZIN, NWFINDIF, QST, LST
      DOUBLE PRECISION LST_NORM_SQR, LST_NORM_INV, LST_TANGENT

      COMMON /USINT/NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /INPTYP/XYZIN,NWFINDIF

      DIMENSION WORK(NX*NX), LST_TANGENT(*),QST_TANGENT(*)
C
C Use Eqn. 1 and 8 in Schlegel to evaluate the QST and LST normalized
C tangent vectors.
C
C Read the guess structures (user provided) for the transition
C state and the products.
C
      IRECTNT = 1
      IPRDUCT = IRECTNT + 3*NATOMS
      ICURENT = IPRDUCT + 3*NATOMS
      IEND    = ICURENT + 3*NATOMS
 
      IF (IEND .GT. NX*NX) CALL INSMEM("@EVAL_QSTLST_PATH_UDI", 
     &                                  IEND, NX*NX)

C Cautionary note: The reactant coordinates are copied to the 
C memory location desiganted as IPRDUCT. This was as a result
C of a earlier confusion in designating multiple structures. This
C has no effect on actual work done, Ajith Perera, 12/2012
 
      CALL IGETREC(0,'JOBARC','RXSTRUCT',LENGTH,TMP)
      CALL DGETREC(1,'JOBARC','RXSTRUCT',LENGTH,
     &               WORK(IPRDUCT))
      CALL CNVRT2RAD(WORK(IPRDUCT),LENGTH)
      CALL SQUSH(WORK(IPRDUCT),LENGTH)
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Debug-Info: The Reactant Structure"
      Write(6,"(3(1x,F12.6))") (Work(IPRDUCT + I), I= 0,LENGTH-1)
      Write(6,*) 
#endif

      IF (LST) THEN
        CALL IGETREC(0,'JOBARC','PRSTRUCT',LENGTH,TMP)
        CALL DGETREC(1,'JOBARC','PRSTRUCT',LENGTH,
     &                  WORK(IRECTNT))
        CALL CNVRT2RAD(WORK(IRECTNT), LENGTH)
        CALL SQUSH(WORK(IRECTNT), LENGTH)

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Debug-Info: Product Structure"
      Write(6,"(3(1x,F12.6))") (Work(IRECTNT + I), I= 0, LENGTH-1)
#endif
        CALL XDAXPY(LENGTH, -1.0D0, WORK(IRECTNT), 1,
     &             WORK(IPRDUCT), 1)

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,"(a)") "Debug-Info: The Diff. Structure"
      Write(6,"(3(1x,F12.6))") (Work(IPRDUCT + I), I= 0, LENGTH-1)
#endif

CSSS            CALL XDCOPY(NX, WORK(IPRDUCT), 1, LST_TANGENT, 1)
CSSS            CALL GETREC(20, "JOBARC", "BMATRIX ", 3*NATOMS*NOPT*
CSSS     &                  IINTFP, WORK(1))
CSSS            IOFFSET = 3*NATOMS*NOPT + 1
CSSS            CALL XGEMM("N", "N", NOPT, 1, 3*NATOMS, 1.0D0, WORK,
CSSS     &                  NOPT, LST_TANGENT, 3*NATOMS, 0.0D0, WORK
CSSS     &                  (IOFFSET), NOPT)
CSSS            CALL XDCOPY(NOPT, WORK(IOFFSET), 1, LST_TANGENT, 1)

        CALL NORMAL(WORK(IPRDUCT), LENGTH)
        TNORM = XDDOT(LENGTH, WORK(IPRDUCT),1,WORK(IPRDUCT), 1)
C
        CALL SYMUNQONLY(WORK(IPRDUCT), LST_TANGENT)
        CALL XDSCAL(LENGTH, 1.0D0, LST_TANGENT, 1)
        IF (Dabs(TNORM - 1.0D0) .GT. 1.0D-12) THEN
           WRITE(6,*)
           WRITE(6,"(a,a)") "Norm condition for the LST tangent is ",
     &                      "incorrect! Can not proceed."
            CALL ERREX
        ENDIF
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "Checking the Norm of QST tangent"
      Write(6,"(a,1x,F12.6)")"Tangent Norm: ", TNORM
      Write(6,"(a)") "Debug-Info: LST tangent"
      Write(6,"(3(1x,F12.6))") (LST_TANGENT(I), I= 1, NOPT)
#endif

      ELSE IF (QST) THEN

C Cautionary note: The product coordinates are copied to the 
C memory location desiganted as IRECTNT. This was as a result
C of a earlier confusion in designating multiple structures. This
C has no effect on actual work done, Ajith Perera, 12/2012

        CALL IGETREC(0,'JOBARC','PRSTRUCT',LENGTH,TMP)
        CALL DGETREC(1,'JOBARC','PRSTRUCT',LENGTH,
     &                  WORK(IRECTNT))
        CALL CNVRT2RAD(WORK(IRECTNT), LENGTH)
        CALL SQUSH(WORK(IRECTNT), LENGTH)
        CALL XDCOPY(LENGTH, R, 1, WORK(ICURENT), 1)

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Debug-Info: Product Structure"
      Write(6,"(3(1x,F12.6))") (Work(IRECTNT + I), I= 0, LENGTH-1)
      Write(6,"(a)") "Debug-Info: Reactant Structure"
      Write(6,"(3(1x,F12.6))") (Work(IPRDUCT + I), I= 0, LENGTH-1)
      Write(6,"(a)") "Debug-Info: Current Structure"
      Write(6,"(3(1x,F12.6))") (Work(ICURENT + I), I= 0, LENGTH-1)
#endif

        CALL XDAXPY(LENGTH, -1.0D0, WORK(ICURENT), 1,
     &             WORK(IPRDUCT), 1)
        CALL XDAXPY(LENGTH, -1.0D0, WORK(ICURENT), 1,
     &             WORK(IRECTNT), 1)

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Debug-Info: P-X tructure"
      Write(6,"(3(1x,F12.6))") (Work(IPRDUCT + I), I= 0, LENGTH-1)
      Write(6,"(a)") "Debug-Info: R-X Structure"
      Write(6,"(3(1x,F12.6))") (Work(IRECTNT + I), I= 0, LENGTH-1)
#endif
        QST_NORM_SQR_PX = XDDOT(LENGTH, WORK(IPRDUCT), 1,
     &                         WORK(IPRDUCT), 1)
        QST_NORM_SQR_RX = XDDOT(LENGTH, WORK(IRECTNT), 1,
     &                         WORK(IRECTNT), 1)
        QST_NORM_PX_RX  = XDDOT(LENGTH, WORK(IRECTNT), 1,
     &                         WORK(IPRDUCT), 1)

        QST_NORM_PX = DSQRT(QST_NORM_SQR_PX)
        QST_NORM_RX = DSQRT(QST_NORM_SQR_RX)

        IF ((QST_NORM_SQR_PX.LE.1.0D-14).OR.
     &     (QST_NORM_SQR_RX.LE.1.0D-14)    ) THEN
           Write(6,*)
           Write(6,"(a)")"AN INPUT ERROR: INSPECT THE INPUT STRUCTURES"
           CALL ERREX
        END IF

        QST_NORM_PX_INV = 1.0D0/(QST_NORM_SQR_PX)
        QST_NORM_RX_INV = 1.0D0/(QST_NORM_SQR_RX)

        CALL XDSCAL(LENGTH, QST_NORM_PX_INV, WORK(IPRDUCT), 1)
        CALL XDSCAL(LENGTH, QST_NORM_RX_INV, WORK(IRECTNT), 1)

        CALL XDAXPY(LENGTH, -1.0D0, WORK(IRECTNT), 1,
     &               WORK(IPRDUCT), 1)
        DENOM = (QST_NORM_SQR_PX + QST_NORM_SQR_RX -
     &                   2.0D0*QST_NORM_PX_RX)

        IF (DENOM .LE. 1.0D-14) THEN
           Write(6,*)
           Write(6,"(a)")"AN INPUT ERROR: INSPECT THE INPUT STRUCTURES"
           CALL ERREX
        ENDIF

        A_SCALE = DSQRT((QST_NORM_SQR_PX*QST_NORM_SQR_RX)/DENOM)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "Various Norms"
      Write(6,"(a,2(1x,F12.6))") "QST_NORM_SQR_PX,RX :",QST_NORM_SQR_PX,
     &                          QST_NORM_SQR_RX
      Write(6,"(a,2(1x,F12.6))") "QST_NORM_PX,RX     :",QST_NORM_PX,
     &                          QST_NORM_RX
      Write(6,"(a,(1x,F12.6))") "QST_NORM_PX_RX     :",QST_NORM_PX_RX
      Write(6,"(a,(1x,F12.6))") "A_SCALE            :",A_SCALE
     
#endif

CSSS            CALL XDCOPY(3*NATOMS, WORK(IPRDUCT), 1, QST_TANGENT, 1)
CSSS            CALL GETREC(20, "JOBARC", "BMATRIX ", 3*NOPT*NATOMS*
CSSS     &                  IINTFP, WORK(1))
CSSS            IOFFSET = 3*NATOMS*NOPT + 1
CSSS            CALL XGEMM("N", "N", NOPT, 1, 3*NATOMS, 1.0D0, WORK,
CSSS     &                  NOPT, QST_TANGENT, 3*NATOMS, 0.0D0, WORK
CSSS     &                  (IOFFSET), NOPT)
C
        CALL XDSCAL(LENGTH, A_SCALE, WORK(IPRDUCT), 1)

C
        TNORM = XDDOT(LENGTH, WORK(IPRDUCT),1,WORK(IPRDUCT), 1)
C
        IF (Dabs(TNORM - 1.0D0) .GT. 1.0D-12) THEN
           WRITE(6,*)
           WRITE(6,"(a,a)") "Norm condition for the QST tangent is ",
     &                      "incorrect! Can not proceed."
           CALL ERREX
        ENDIF
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Checking the Norm of QST tangent"
      Write(6,"(a,1x,F12.6)")"Tangent: ", TNORM
#endif
C
        CALL SYMUNQONLY(WORK(IPRDUCT), QST_TANGENT)

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,"(a)") "Debug-Info: QST tangent"
      Write(6,"(3(1x,F12.6))") (QST_TANGENT(I), I= 1, NOPT)
#endif

         END IF

       RETURN
       END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE NUCREP(ZNREP,IERR)
C
C DETERMINES THE INTERNUCLEAR REPULSION ENERGY.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     Maximum number of atoms currently allowed
#include "mxatms.par"
#include "coord.com"
C
      IQ(I)=3*I-2
      Z=0.D0
      DO 10 I=1,NATOMS
      DO 10 J=I+1,NATOMS
       BOT=DIST(Q(IQ(I)),Q(IQ(J)))
       IF(BOT.LT.1.D-5)THEN
        IERR=1
        GOTO 10
       ELSE
        IF(IATNUM(I).NE.110.AND.IATNUM(J).NE.110)THEN
c        IGNORE GHOST ATOMS
         TOP=FLOAT(IATNUM(I)*IATNUM(J))
         Z=Z+(TOP/BOT)
        ENDIF
      ENDIF
10    CONTINUE
      ZNREP=Z
      RETURN
      END

      Subroutine Find_Min(nOrder,XStart,A,XMin,RC,XLow,XHi,ENew,
     &                    THR)
      Implicit Double Precision (a-h,o-z)

      DIMENSION A(0:nOrder)
      Logical RC
      DATA ZERO /0.0D0/, ONE /1.0D0/
*
      XValue=XStart
      RC=.True.
c      Write(6,*) nOrder,XStart,XMin,RC,XLow,XHi,ENew,
c     &                    THR
      MaxIter=100
      Do i = 1, MaxIter
         X=XValue
         fnc  = Zero
         XX   = One 
         Do j=0,nOrder
            fnc=fnc+A(j)*XX
            XX = XX*X
         End Do
         dfnc = Zero
         XX   = One 
         Do j=1,nOrder
            tmp = j
            dfnc=dfnc+A(j)*tmp*XX
            XX = XX*X
         End Do
         ddfnc = Zero
         XX    = One 
         Do j=2,nOrder
            tmp = j*j-j
            ddfnc=ddfnc+A(j)*tmp*XX
            XX = XX*X
         End Do
         XInc=dfnc/ddfnc
         XValue=XValue-XInc
c
c         Write (6,*) 'Fnc,dFnc,ddFnc,xinc=',Fnc,dFnc,ddFnc,xinc,
c     &                xvalue
         If (Abs(XInc).lt.Thr) Then
            ENew=fnc
            XMin=XValue
C            Call QExit('Find_Min')
            Return
         End If
         If (XValue.gt.XHi) XValue=XHi
         If (XValue.lt.XLow) XValue=XLow
      End Do
      Write (*,*) '-- Too many iterations in Find_Min'
      RC=.False.
*
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ROTATE_ATOM_NBO
     +
     +                    ( NBAS,NATOM,NDEG,
     +                      NBOSIZE,ROTSIZE,
     +                      NXBA,
     +                      OFFX,OFFA,
     +                      OFFLP,OFFBD,OFFEP,
     +                      OFFAB,OFFRY,OFFRR,
     +                      CENTER,
     +                      RING,NRING,RINGSZ,
     +                      SYMCEN,
     +                      LSYMACC,QSYMACC,
     +                      FIRST,
     +                      IDXDEG,
     +                      NBOBD,
     +                      BDNCEN,BDCEN,
     +                      HYB,
     +                      ROT,ROTIDX,
     +                      SYMCRIT,
     +                      P,
     +                      LOCAL,
     +                      W,Q,
     +                      XVEC,
     +                      XMAT,
     +
     +                              SYMNBO,
     +                              SLTYPE,
     +                              BDNBAS,
     +                              BDBAS,
     +                              B,
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ROTATE_ATOM_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine rotates a degenerate sets of NBOs sitting
C                at the center of symmetry. The present routine deals
C                only with non-platonic symmetry NBOs. The strategy is
C                to reorient the degenerate set such as to maximize the
C                1-norm of the occupation matrix section between the
C                degenerate set and all the already symmetrized NBOs at
C                this stage.
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    NDEG         =  # of degenerate NBOs. Can only
C                                    be equal to 2,3,4 or 5.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    ROTSIZE      =  maximum # of NHOs that will be
C                                    allowed to form NBO hybrids for
C                                    rotationally invariant atomic NBO
C                                    construction.
C                    NXBA         =  # of atomic x-type NBOs on the
C                                    central atom treated here.
C                    OFFX         =  absolute offset index for present
C                                    x-type NBOs. This index indicates
C                                    the totallity of NBOs before the
C                                    x-type NBO set.
C                    OFFA         =  local atomic offset index for
C                                    present atomic x-type NBOs. This
C                                    index is equal to the total number
C                                    of atomic x-type NBOs on all
C                                    x-type NBO atoms preceeding x-type
C                                    NBO atom A.
C                    OFFxy        =  absolute offset indices for x-type
C                                    NBOs. These indices indicate the
C                                    totallity of x-type NBOs before the
C                                    x-type NBO set (xy:LP=Lone-pair,
C                                    BD=Bond, EP=Empty-pair, AB=Anti-
C                                    bond, RY,RR=Rydberg types)
C                    CENTER       =  atomic index of the center on which
C                                    NBO rotation will be performed
C                    RING (A,B)   =  contains all atomic indices A of
C                                    those symmetry related sets that
C                                    have equal distance from center B
C                                    and are of maximum size.
C                    NRING (B)    =  contains the # of sets of maximum
C                                    size related to center B.
C                    RINGSZ (B)   =  contains the maximum size of the
C                                    above found sets related to
C                                    center B.
C                    SYMCEN       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    FIRST        =  index of 1st degenerate NBO inside
C                                    the atomic NXBA-dimensional NBO set.
C                    IDXDEG       =  array that will be used to store
C                                    the NBO indices that will be
C                                    rotated (for example, if sd2
C                                    hybrids will be constructed, this
C                                    array will indicate all the NBO
C                                    indices for the s and the two d
C                                    NBOs).
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th atomic x-type NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/
C                                    NRB. Note that the # of NHB-bonds
C                                    might be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for J-th
C                                    bond. The bond order is NHB-bonds/
C                                    NCB/NRB. Note that the # of
C                                    NHB-bonds might be < NHB size.
C                    HYB          =  will contain the NBO hybridization
C                                    matrix.
C                    ROT          =  will contain the NBO rotation
C                                    matrix.
C                    ROTIDX       =  will contain the NBO rotation
C                                    indices.
C                    SYMCRIT      =  symmetry interaction criterion.
C                                    Any absolute occupation matrix
C                                    interaction element between
C                                    symmetrized NBOs and a degenerate
C                                    set of NBOs is assumed to be zero
C                                    if it falls below this value.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs.
C                    W            =  complete NBO weight vector at
C                                    present stage of symmetrization.
C                    Q            =  complete NBO interaction order
C                                    vector at present stage of
C                                    symmetrization.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    SYMNBO       =  initial integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  initial integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  initial # of basis functions (NHOs)
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  initial NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    before symmetrization.
C
C
C                  Output:
C
C                    SYMNBO       =  updated integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  updated integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  modified # of basis functions
C                                    (NHOs) for J-th bond. The bond
C                                    order is NHB-bonds/NCB/NRB. Note
C                                    that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDBAS (I,J)  =  modified I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  modified NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    after symmetrization.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     HYBRID
         LOGICAL     MAXIMZE
         LOGICAL     SAVEC,SAVEP
         LOGICAL     ZEROSYM

         INTEGER     B1ST,BOND
         INTEGER     CENTER
         INTEGER     D,I,J,N,S
         INTEGER     FIRST
         INTEGER     LOBE
         INTEGER     MROT,NROT
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NBOSIZE,ROTSIZE
         INTEGER     NHO
         INTEGER     NDEG
         INTEGER     NLO__ANGULAR_MOMENTUM_NBO
         INTEGER     NSYM
         INTEGER     NXBA
         INTEGER     OFFA,OFFX
         INTEGER     OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR
         INTEGER     POS
         INTEGER     SYMSIZE,SYMSETS
         INTEGER     TOTSYM

         INTEGER     BDNBAS  (1:NBAS )
         INTEGER     BDNCEN  (1:NBAS )
         INTEGER     IDXDEG  (1:NXBA )
         INTEGER     NBOBD   (1:NBAS )
         INTEGER     NRING   (1:NATOM)
         INTEGER     RINGSZ  (1:NATOM)
         INTEGER     ROTIDX  (1:NBAS )
         INTEGER     SLTYPE  (1:NBAS )
         INTEGER     SYMCEN  (1:NATOM)
         INTEGER     SYMNBO  (1:NBAS )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS )
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS )
         INTEGER     RING    (1:NATOM  ,1:NATOM)

         DOUBLE PRECISION  HIJ
         DOUBLE PRECISION  LSYMACC,QSYMACC
         DOUBLE PRECISION  R11,R12,R21,R22
         DOUBLE PRECISION  SYMCRIT
         DOUBLE PRECISION  X,Y
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  LOCAL (1:NBAS)
         DOUBLE PRECISION  Q     (1:NBAS)
         DOUBLE PRECISION  W     (1:NBAS)
         DOUBLE PRECISION  XVEC  (1:NBAS+NBAS)

         DOUBLE PRECISION  B     (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  C     (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  HYB   (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  P     (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  ROT   (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  XMAT  (1:NBAS   ,1:ROTSIZE)

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check symmetry consistency. Since this routine deals
C                with the non-platonic NBOs, we know that deg = 2
C                always. Otherwise stop with message.
C
C
         IF (NDEG.NE.2) THEN
             WRITE (*,*) ' Degeneracy conflict for atomic case! '
             WRITE (*,*) ' NDEG = ',NDEG
             WRITE (*,*) ' nlo__rotate_atom_nbo '
             WRITE (1,*) ' Degeneracy conflict for atomic case! '
             WRITE (1,*) ' NDEG = ',NDEG
             WRITE (1,*) ' nlo__rotate_atom_nbo '
             STOP
         END IF
C
C
C             ...check dimensions.
C
C
         IF (NDEG.GT.ROTSIZE) THEN
             WRITE (*,*) ' Degeneracy size too large! '
             WRITE (*,*) ' NDEG,ROTSIZE = ',NDEG,ROTSIZE
             WRITE (*,*) ' nlo__rotate_atom_nbo '
             WRITE (1,*) ' Degeneracy size too large! '
             WRITE (1,*) ' NDEG,ROTSIZE = ',NDEG,ROTSIZE
             WRITE (1,*) ' nlo__rotate_atom_nbo '
             STOP
         END IF
C
C
C             ...set some data.
C
C
         SAVEC = .TRUE.
         SAVEP = .TRUE.
C
C
C             ...establish the rotational background.
C
C
         SYMSIZE = RINGSZ (CENTER)

         IF (SYMSIZE.LT.3) THEN
             WRITE (*,*) ' Symmetry conflict for atom case! '
             WRITE (*,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
             WRITE (*,*) ' nlo__rotate_atom_nbo '
             WRITE (1,*) ' Symmetry conflict for atom case! '
             WRITE (1,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
             WRITE (1,*) ' nlo__rotate_atom_nbo '
             STOP
         END IF

         SYMSETS = NRING (CENTER)
         NSYM = SYMSIZE * SYMSETS

         DO N = 1,NSYM
            SYMCEN (N) = RING (N,CENTER)
         END DO
C
C
C             ...rotate the degenerate pair first.
C
C
         D = OFFX + OFFA + FIRST

         CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,2,
     +                NBAS,2,
     +                NBAS,
     +                NBAS,NBAS,2,
     +                0,0,
     +                SAVEC,SAVEP,SAVEC,
     +                C,P,C (1,D),
     +                XVEC,
     +
     +                         XMAT )
     +
     +
         CALL  NLO__FIND_ROTATION_NBO_INDICES
     +
     +              ( NBAS,NATOM,2,
     +                NBOSIZE,
     +                OFFLP,OFFBD,OFFEP,
     +                OFFAB,OFFRY,OFFRR,
     +                CENTER,
     +                SYMSIZE,SYMSETS,SYMCEN,
     +                SYMNBO,
     +                QSYMACC,LSYMACC,
     +                BDNCEN,BDCEN,
     +                NBOBD,
     +                SYMCRIT,
     +                XMAT,
     +                LOCAL,
     +                Q,
     +
     +                         ZEROSYM,
     +                         NROT,
     +                         ROTIDX )
     +
     +
         IF (ZEROSYM) THEN
             WRITE (*,*) ' NO SYMMETRY INTERACTION! '
             WRITE (*,*) ' Rotation failed! '
             RETURN
         END IF

         IF (NROT.EQ.0) THEN
             WRITE (*,*) ' Cannot establish NBO rotation set! '
             WRITE (*,*) ' CENTER = ',CENTER
             WRITE (*,*) ' nlo__rotate_atom_nbo '
             WRITE (1,*) ' Cannot establish NBO rotation set! '
             WRITE (1,*) ' CENTER = ',CENTER
             WRITE (1,*) ' nlo__rotate_atom_nbo '
             STOP
         END IF

         LOBE = ROTIDX (1)
         X    = XMAT (LOBE,1)
         Y    = XMAT (LOBE,2)

         MAXIMZE = .TRUE.

         CALL  NLO__FIND_2DEG_AXIAL_ROTMAT
     +
     +              ( X,Y,
     +                MAXIMZE,
     +
     +                        R11,R12,
     +                        R21,R22 )
     +
     +
         DO N = 1,NBAS
            X = R11 * C (N,D) + R21 * C (N,D+1)
            Y = R12 * C (N,D) + R22 * C (N,D+1)
            C (N,D  ) = X
            C (N,D+1) = Y
         END DO

         ROT (1,1) = R11
         ROT (2,1) = R21
         ROT (1,2) = R12
         ROT (2,2) = R22

         HYB (1,1) = ONE
         HYB (2,1) = ZERO
         HYB (1,2) = ZERO
         HYB (2,2) = ONE

         MROT = 2

         IDXDEG (1) = D
         IDXDEG (2) = D + 1
C
C
C             ...form the necessary hybrids, if possible and
C                necessary. Hybrids for 3-fold symmetry.
C
C
         IF (SYMSIZE.EQ.3) THEN

             TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                     ( NXBA,
     +                       SLTYPE (OFFX+OFFA+1),
     +                       FIRST,FIRST+1,
     +                       0,
     +                       1,
     +                       QSYMACC,LSYMACC,
     +                       W (OFFX+OFFA+1),
     +                       Q (OFFX+OFFA+1),
     +                       LOCAL (OFFX+OFFA+1) )
     +
     +
             HYBRID = TOTSYM .NE. 0

             IF (HYBRID) THEN

                 IF (ROTSIZE.LT.3) THEN
                     WRITE (*,*) ' Cannot form sp2 hybrids! '
                     WRITE (*,*) ' ROTSIZE = ',ROTSIZE
                     WRITE (*,*) ' nlo__rotate_atom_nbo '
                     WRITE (1,*) ' Cannot form sp2 hybrids! '
                     WRITE (1,*) ' ROTSIZE = ',ROTSIZE
                     WRITE (1,*) ' nlo__rotate_atom_nbo '
                     STOP
                 END IF

                 S = OFFX + OFFA + TOTSYM

                 ROT (1,1) = ZERO
                 ROT (2,1) = ZERO
                 ROT (3,1) = ZERO
                 ROT (1,2) = ZERO
                 ROT (2,2) = R11
                 ROT (3,2) = R21
                 ROT (1,3) = ZERO
                 ROT (2,3) = R12
                 ROT (3,3) = R22

                 CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                      ( NBAS,NBAS,
     +                        NBAS,NBAS,
     +                        NBAS,1,
     +                        NBAS,1,
     +                        NBAS,
     +                        NBAS,NBAS,1,
     +                        0,0,
     +                        SAVEC,SAVEP,SAVEC,
     +                        C,P,C (1,S),
     +                        XVEC,
     +
     +                                 XMAT )
     +
     +
                 X = XMAT (LOBE,1)

                 IF (X.LT.ZERO) THEN
                     DO N = 1,NBAS
                        C (N,S) =  - C (N,S)
                     END DO
                     ROT (1,1) = - ONE
                 ELSE
                     ROT (1,1) = ONE
                 END IF

                 CALL  NLO__FORM_SP2_NBO
     +
     +                      ( NBAS,
     +
     +                               HYB (1,1),HYB (1,2),HYB (1,3),
     +                               HYB (2,1),HYB (2,2),HYB (2,3),
     +                               HYB (3,1),HYB (3,2),HYB (3,3),
     +                               C (1,S),
     +                               C (1,D) )
     +
     +
                 MROT = 3

                 IDXDEG (1) = S
                 IDXDEG (2) = D
                 IDXDEG (3) = D + 1

                 SLTYPE (S  ) = -1
                 SLTYPE (D  ) = -1
                 SLTYPE (D+1) = -1

             ELSE

                 WRITE (*,*) ' No s function for sp2 hybrid! '
                 WRITE (*,*) ' Occuring at CENTER = ',CENTER
                 WRITE (*,*) ' Symmetry reduction C3v -> C2v! '
                 WRITE (1,*) ' No s function for sp2 hybrid! '
                 WRITE (1,*) ' Occuring at CENTER = ',CENTER
                 WRITE (1,*) ' Symmetry reduction C3v -> C2v! '

             END IF
C
C
C             ...No hybrids for 4-fold symmetry!.
C
C
         ELSE IF (SYMSIZE.GT.4) THEN

             WRITE (*,*) ' Cannot deal with SYMSIZE > 4! '
             WRITE (*,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
             WRITE (*,*) ' nlo__rotate_atom_nbo '
             WRITE (1,*) ' Cannot deal with SYMSIZE > 4! '
             WRITE (1,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
             WRITE (1,*) ' nlo__rotate_atom_nbo '
             STOP

         END IF
C
C
C             ...form the NBO coefficient matrix in NHO basis.
C
C
         DO J = 1,MROT
            POS = IDXDEG (J)
            DO N = 1,MROT
               B (N,POS) = ZERO
            END DO
         END DO

         DO J = 1,MROT
            POS = IDXDEG (J)
            DO I = 1,MROT
               HIJ = HYB (I,J)
               DO N = 1,MROT
                  B (N,POS) = B (N,POS) + HIJ * ROT (N,I)
               END DO
            END DO
         END DO
C
C
C             ...the matrices containing details about the new NBOs.
C
C
         POS = IDXDEG (1)
         B1ST = NBOBD (POS)
         BDNBAS (B1ST) = MROT

         DO I = 1,MROT
            POS = IDXDEG (I)
            BOND = NBOBD (POS)
            NHO = BDBAS (1,BOND)
            BDBAS (I,B1ST) = NHO
         END DO

         DO J = 2,MROT
            POS = IDXDEG (J)
            BOND = NBOBD (POS)
            BDNBAS (BOND) = MROT
            DO I = 1,MROT
               BDBAS (I,BOND) = BDBAS (I,B1ST)
            END DO
         END DO
C
C
C             ...mark new NBOs as symmetry adapted.
C
C
         DO I = 1,MROT
            POS = IDXDEG (I)
            SYMNBO (POS) = 2
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

         SUBROUTINE  ERD__K12_INT2D_TO_A000
     +
     +                    ( SHELLA,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZA,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_INT2D_TO_A000
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative eris:
C
C                     [A0|00] , [0A|00] , [00|A0] or [00|0A]
C
C                adding up the contributions from all the respective
C                derivative 2D integrals:
C
C                           A000 , 0A00 , 00A0 or 000A
C
C                Simplified version of the general ABCD routine to
C                reduce loop overheads for those cases where there are
C                at least three s-shells. For comments and details see
C                the general ABCD routine.
C
C
C                  Input:
C
C                    SHELLA      =  shell type for contraction shell A
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZA       =  # of cartesian monomials for shell A
C                    INT2Dx      =  all current 2D A000/0A00/00A0/000A
C                                   derivative integrals for each
C                                   cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D A000/0A00/00A0/000A derivative
C                                   integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [A0|00]/[0A|00]/[00|A0]/[00|0A]
C                                   derivative integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,M,N,R,i1,i2
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZA
         INTEGER     SHELLA
         INTEGER     XA,YA,ZA
         INTEGER     YAMAX

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO,STGEXP

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ),RTS(1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ),UVAL(1:NEXQ)

         DOUBLE PRECISION  BATCH  (1:NEXQ,1:NXYZA)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLA)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLA)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLA)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
c           write(6,*) STGEXP,'$$$$$$$$$$$$$'    
              
c            do i1=1,NEXQ
c            write(6,*) UVAL(i1), '!!!!!!!!',i1 
c            enddo

c             do i1=1,NEXQ
c              do i2=NXYZA
c              BATCH(i1,i2) = 0.d0
c              enddo
c             enddo 


c           do i1=1,NGQEXQ
c            write(6,*) SCALE (i1), RTS(i1),'+*******+',i1
c           enddo

c           do i1=1,NGQEXQ
c            do i2=1,SHELLA
c            write(6,*) INT2DX(i1,i2),'----',i1,i2
c            write(6,*) INT2DY(i1,i2),'<---',i1,i2
c            write(6,*) INT2DZ(i1,i2),'<<--',i1,i2
c            enddo
c            enddo

c            write(6,*) NEXQ, NXYZA,'~~~~~~~~~~'
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    I = 0
         DO 100 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 110 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO M = 1,NEXQ
                      TEMP2 (M) = TEMP1 (M)
                   END DO
               ELSE
                   DO M = 1,NEXQ
                      TEMP2 (M) = TEMP1 (M) * INT2DY (M,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   DO M = 1,NEXQ
                      BATCH (M,I) = TEMP2 (M)*
     &                  (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
c                     write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   DO M = 1,NEXQ
                      BATCH (M,I) = TEMP2 (M) * INT2DZ (M,ZA)*
     &                  (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
c                   write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  110       CONTINUE
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    I = 0
         DO 200 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 210 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = (  TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1)) 
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 2
c                     write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 2
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  210       CONTINUE
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    I = 0
         DO 300 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 310 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 3
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 3
c                    write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  310       CONTINUE
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    I = 0
         DO 400 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 410 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                              )*(2.d0*UVAL(M)/STGEXP) 
                      R = R + 4
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA)*(1.d0-RTS(R+3))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 4
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  410       CONTINUE
  400    CONTINUE




         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    I = 0
         DO 500 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 510 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 5
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA)*(1.d0-RTS(R+4))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 5
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  510       CONTINUE
  500    CONTINUE



         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    I = 0
         DO 600 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 610 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 6
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA)*(1.d0-RTS(R+5))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 6
c                      write(6,*) BATCH (M,I),M,I,NGQP                  
                   END DO
               END IF

  610       CONTINUE
  600    CONTINUE




         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    I = 0
         DO 700 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 710 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                              + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 7
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA)*(1.d0-RTS(R+5))
     +                              + TEMP2 (R+6)
     +                              * INT2DZ (R+6,ZA)*(1.d0-RTS(R+6))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 7
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  710       CONTINUE
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    I = 0
         DO 800 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 810 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                              + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                              + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 8
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA)*(1.d0-RTS(R+5))
     +                              + TEMP2 (R+6)
     +                              * INT2DZ (R+6,ZA)*(1.d0-RTS(R+6))
     +                              + TEMP2 (R+7)
     +                              * INT2DZ (R+7,ZA)*(1.d0-RTS(R+7))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 8
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  810       CONTINUE
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    I = 0
         DO 900 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO

            DO 910 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF

               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                              + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                              + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                              + TEMP2 (R+8)*(1.d0-RTS(R+8))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 9
c                       write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 1
                   DO M = 1,NEXQ
                      BATCH (M,I) = ( TEMP2 (R)
     +                              * INT2DZ (R,ZA)*(1.d0-RTS(R))
     +                              + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA)*(1.d0-RTS(R+1))
     +                              + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA)*(1.d0-RTS(R+2))
     +                              + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA)*(1.d0-RTS(R+3))
     +                              + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA)*(1.d0-RTS(R+4))
     +                              + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA)*(1.d0-RTS(R+5))
     +                              + TEMP2 (R+6)
     +                              * INT2DZ (R+6,ZA)*(1.d0-RTS(R+6))
     +                              + TEMP2 (R+7)
     +                              * INT2DZ (R+7,ZA)*(1.d0-RTS(R+7))
     +                              + TEMP2 (R+8)
     +                              * INT2DZ (R+8,ZA)*(1.d0-RTS(R+8))
     +                              )*(2.d0*UVAL(M)/STGEXP)
                      R = R + 9
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF

  910       CONTINUE
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loop over x-contribution. No skipping of
C                x-contribution of 0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    I = 0
         DO 1000 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XA)
            END DO
C
C
C             ...inner loop over y-contribution. Skip the multiplication
C                of y-contributions, if no y-coordinate derivative
C                was formed and we have a 0-contribution, as then the
C                2DY integrals are equal to 1.
C
C
            DO 1010 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA)
                   END DO
               END IF
C
C
C             ...skip multiplication of z-contributions, if we
C                have a 0-type and no derivations were performed
C                on the z-coordinate, as then the 2DZ integrals
C                are equal to 1. All info concerning all three x-,
C                y- and z-contributions have been collected for all
C                exponent quadruplets at once. Sum up the 2D X,Y,Z
C                integral products to the appropriate places of the
C                batch.
C
C
               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   R = 0
                   DO M = 1,NEXQ
                      SUM = ZERO
                      DO N = 1,NGQP
                         SUM = SUM + TEMP2 (R+N)*(1.d0-RTS(R+N))
                      END DO
                      R = R + NGQP
                      BATCH (M,I) = SUM*(2.d0*UVAL(M)/STGEXP)
c                      write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               ELSE
                   R = 0
                   DO M = 1,NEXQ
                      SUM = ZERO
                      DO N = 1,NGQP
                         SUM = SUM + TEMP2 (R+N) * INT2DZ (R+N,ZA)*
     &                                       (1.d0-RTS(R+N))
                      END DO
                      R = R + NGQP
                      BATCH (M,I) = SUM*(2.d0*UVAL(M)/STGEXP)
                      
c                     write(6,*) BATCH (M,I),M,I,NGQP
                   END DO
               END IF
C
C
C             ...next z- and y-contributions.
C
C
 1010       CONTINUE
C
C
C             ...next x-contribution.
C
C
 1000    CONTINUE
C
C
C             ...ready!
C

11111    continue

         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine ptr_check(label,ptr)
      implicit none
      include 'parallel_info.h'
      include 'server.h'
      character*(*) label
      integer ptr

      if (ptr .lt. 1 .or. ptr. gt. nserver_table_entries) then
         print *,'SERVER ',me,label,' PTR ERR: ptr ',ptr,
     *          ' max range = ',
     *          nserver_table_entries
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ROTCON(IT,IPRNT,IERR,NOSILENT)
C
C COMPUTES ROTATIONAL CONSTANTS (IN CM-1), OPTIONALLLY
C  PRINTS THEM AND RETURNS AN ERROR MESSAGE IF INERTIA
C  TENSOR PASSED IS NOT DIAGONAL.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION IT(3,3),RC(3),NORD(3)
      LOGICAL NOSILENT
#include "machsp.com"
      DATA FACTOR /60.198D0/
      Z=0.D0
      IBOT=0
      IERR=0
      CALL ZERO(RC,3)
      DO 10 I=1,3
      DO 10 J=I+1,3
       Z=DABS(IT(I,J))+DABS(IT(J,I))+Z
 10   CONTINUE
      IF(Z.GT.1.D-10)THEN
       WRITE(6,100)
 100   FORMAT(T3,' ***PROGRAM ERROR***, Inertia tensor not '
     &,'diagonal in ROTCON.')
       IERR=1
      ELSE
       IBOT=1
      ENDIF
      DO 20 I=1,3
       IF(DABS(IT(I,I)).GT.1.D-12)THEN
        RC(I)=FACTOR/IT(I,I)
       ELSE
        IBOT=IBOT+1
       ENDIF
 20   CONTINUE
      CALL PIKSR2(3,RC,NORD)
C
C Rotational constants are useful things to have in JOBARC.
C
      CALL DPUTREC(20, 'JOBARC', 'ROTCONST', 3, RC) 
      IF(IPRNT.NE.0 .AND. NOSILENT)THEN
       WRITE(6,200)
       WRITE(6,300)(RC(J),J=IBOT,3)
 200   FORMAT(T3,' Rotational constants (in cm-1): ')
 300   FORMAT((T3,3(F10.5,5X)))
      ENDIF
      RETURN
      END        

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine doloop(optable, noptable, iop, index_table, 
     *                  nindex_table, array_table, narray_table,
     *                  block_map_table, segment_table, nsegment_table,
     *                  debug, prt_flag,
     *                  start_op, end_op)

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      include 'where_table.h'

      integer noptable, iop, start_op, end_op
      integer optable(loptable_entry,noptable)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer block_map_table(lblock_map_entry,*)
      integer nsegment_table
      integer segment_table(lsegment_table_entry,nsegment_table)

      integer i, j, opcode, index, iseg, istat
      integer result_array
      integer bseg, final_seg, next_seg
      integer superindex, superseg 
      logical debug, prt_flag
      logical check_where_conditions
      logical subrange_flag

      integer push_do, pop_do


      opcode = optable(c_opcode, iop)
      if (iop .gt. noptable) then
         print *,'DOLOOP: Called with iop = ',iop,' noptable = ',
     *           noptable
         call abort_job()
      endif

      if (iop .lt. start_op .or. iop .gt. end_op) return
      if (opcode .eq. do_op) then

c--------------------------------------------------------------------------
c   DO operation
c   Increment the "current_seg" field of the loop index.
c--------------------------------------------------------------------------

         call get_loop_index(optable(c_ind1,iop), index, subrange_flag)
         call set_prefetch_context(index, 1)
         if (optable(c_oploop,iop) .eq. 1) then
            index_table(c_current_seg,index) = 
     *        index_table(c_current_seg,index) + 1

c---------------------------------------------------------------------------
c   Update the c_next_seg entry (used in prefetches).
c---------------------------------------------------------------------------

            next_seg = index_table(c_current_seg,index) + 1
            if (next_seg .gt. index_table(c_eseg,index)) next_seg = 0 
            index_table(c_next_seg,index) = next_seg

            if (prt_flag) 
     *         print *,'Task ',me,' index = ',index,' current_seg = ',
     *                 index_table(c_current_seg,index)
            if (debug)
     *         print *,'DO index ',index,' set to ',
     *            index_table(c_current_seg,index)

         else

c--------------------------------------------------------------------------
c   New loop initialization.
c--------------------------------------------------------------------------
         
            call doloop_init(optable, noptable, iop, index_table,
     *                  nindex_table, segment_table, nsegment_table,
     *                  debug, prt_flag,
     *                  start_op, end_op, index, subrange_flag)
         endif

         if (nwhere .gt. 0) then

c---------------------------------------------------------------------------
c   If the segment fails the WHERE conditions, go to end of loop.
c---------------------------------------------------------------------------

            if (.not. check_where_conditions(index, 
     *                       index_table(c_current_seg,index), 1, 
     *                       index_table, nindex_table) ) then 
               iop = end_op
               return 
            endif
         endif
      endif

      if (opcode .eq. enddo_op) then
         call unset_prefetch_context()   ! back out the current context.

c-------------------------------------------------------------------------
c   Reset any temp blocks created in this loop.
c-------------------------------------------------------------------------

         do i = start_op, end_op

c-------------------------------------------------------------------------
c   If a PUT was executed, set the flag in the array_table.
c-------------------------------------------------------------------------

            if (optable(c_opcode,i) .eq. put_op .or.
     *          optable(c_opcode,i) .eq. put_replace_op) then
               result_array = optable(c_result_array,i)
               array_table(c_put_flag,result_array) = 1
            endif

c-------------------------------------------------------------------------
c   If a PREPARE was executed, set the flag in the array_table.
c-------------------------------------------------------------------------

            if (optable(c_opcode,i) .eq. prepare_op .or.
     *          optable(c_opcode,i) .eq. prepare_increment_op) then 
               result_array = optable(c_result_array,i)
               array_table(c_prepare_flag,result_array) = 1
            endif

            if (optable(c_opblock,i) .ne. 0) then

c-------------------------------------------------------------------------
c   Only clear the block_computed_flag if the block is managed by
c   blkmgr.
c-------------------------------------------------------------------------

               result_array = optable(c_result_array,i)
               if (array_table(c_array_type, result_array) .ne. 
     *             static_array) then
                  call block_end_of_loop(result_array, 
     *                  optable(c_opblock,i), optable(c_opblkndx,i),
     *                  array_table, narray_table, index_table,
     *                  nindex_table, block_map_table)
               endif   
               optable(c_opblock,i) = 0
               optable(c_opblkndx,i) = 0
            endif   
         enddo

c-------------------------------------------------------------------------
c   ENDDO operation.
c   Check for final iteration of loop.
c-------------------------------------------------------------------------

         call get_loop_index(optable(c_ind1,iop), index, subrange_flag)
         if (index .ge. 1 .and. index .le. nindex_table) then
            iseg  = index_table(c_current_seg,index)
            if (debug)
     *      print *,'ENDDO for index ',index,' iseg, current_seg = ',
     *         iseg,index_table(c_nsegments,index) 

            if (subrange_flag) then

c--------------------------------------------------------------------------
c   Look up the superindex of this subindex.
c--------------------------------------------------------------------------

               superindex = index_table(c_subindex_ptr,index)
               superseg   = index_table(c_current_seg,superindex)
               if (superseg .eq. undefined_segment) then
                  print *,'Error: Superindex ',superindex,
     *              ' not in scope at line ',current_line
                  call abort_job()
               endif 
   
c--------------------------------------------------------------------------
c   Find the c_subseg2 field of the current segment of the superindex.
c--------------------------------------------------------------------------

               do i = 1, nsegment_table
                  if (segment_table(c_index,i) .eq. superindex .and.
     *                segment_table(c_segment,i) .eq. superseg) then
                     final_seg = segment_table(c_subseg2,i)
                     go to 100
                  endif
               enddo   
  100          continue  
            else
               final_seg = index_table(c_eseg,index)
            endif

            if (iseg .eq. final_seg) then

c----------------------------------------------------------------------------
c   Reset the loop init flag.
c----------------------------------------------------------------------------

               optable(c_oploop, start_op) = 0   ! should be a do instruction

c--------------------------------------------------------------------------
c   Reset the loop index segment to "undefined".
c--------------------------------------------------------------------------

               index_table(c_current_seg, index) = undefined_segment
               index_table(c_next_seg, index) = 0

c--------------------------------------------------------------------------
c   Final pass of the loop.  Pop a new set of iwhere, nwhere values off the
c   stack.
c--------------------------------------------------------------------------

               istat = pop_do(iwhere, nwhere)
               if (istat .lt. 0) then
                  print *,'Task ',me,
     *             ' Error in doloop: stack underflow'
                  call abort_job()
               endif

c--------------------------------------------------------------------------
c   Final pass of the loop.  Pop a new set of start, end values off the
c   stack.
c--------------------------------------------------------------------------

               istat = pop_do(start_op, end_op)
               if (istat .lt. 0) then
                  print *,'Task ',me,
     *             ' Error in doloop: stack underflow'
                  call abort_job()
               endif
            endif
         endif
      endif

      return
      end
       
      subroutine doloop_init(optable, noptable, iop, index_table,
     *                  nindex_table, segment_table, nsegment_table,
     *                  debug, prt_flag,
     *                  start_op, end_op, loop_index, subrange_flag)
c----------------------------------------------------------------------------
c   Initialization code for do loop.
c   Called upon entry to a new loop.
c----------------------------------------------------------------------------
      implicit none

      include 'interpreter.h'
      include 'where_table.h'
      include 'parallel_info.h'
      include 'trace.h'

      integer noptable, iop, start_op, end_op
      integer optable(loptable_entry,noptable)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer nsegment_table
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer loop_index, instr_index
      integer bseg, eseg, next_seg
      integer i, superindex, superseg
      logical debug, prt_flag
      logical subrange_flag
      logical dummy

      integer opcode, index, istat, j
      integer push_do

      if (optable(c_oploop, iop) .ne. 0) return   ! loop init is already done

      opcode = optable(c_opcode, iop)
      if (opcode .ne. do_op) return

      index = loop_index
      if (subrange_flag) then

c---------------------------------------------------------------------------
c   We are looping over the blocks of a subindex that are contained in a
c   single superindex segment.  First look up the superindex.
c---------------------------------------------------------------------------

         superindex = index_table(c_subindex_ptr,index)
        
c---------------------------------------------------------------------------
c   Make sure the superindex is in scope.
c---------------------------------------------------------------------------
   
         superseg = index_table(c_current_seg,superindex)
         if (superseg .eq. undefined_segment) then
            print *,'Error: Superindex ',superindex,' not in scope at ',
     *                'line ',current_line
            call abort_job() 
         endif

c---------------------------------------------------------------------------
c   Set the current segment of the subindex to the c_subseg1 entry of its
c   superindex.
c---------------------------------------------------------------------------
   
         do i = 1, nsegment_table
            if (segment_table(c_index,i) .eq. superindex .and.
     *          segment_table(c_segment,i) .eq. superseg) then
               index_table(c_current_seg,index) =
     *                     segment_table(c_subseg1,i)
               go to 100
            endif 
         enddo
  100    continue
      else
         index_table(c_current_seg,index) = index_table(c_bseg, index)
         next_seg = index_table(c_current_seg,index) + 1
         if (next_seg .gt. index_table(c_eseg,index)) next_seg = 0
         index_table(c_next_seg,index) = next_seg 
      endif

      if (debug) 
     *   print *,'NEW DO index ',index,' set to segment ',
     *     index_table(c_current_seg,index)

      istat = push_do(start_op, end_op)
      if (istat .lt. 0) then
         print *,' Error in doloop: stack overflow'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Push the data for the WHERE conditionals.
c---------------------------------------------------------------------------

      istat = push_do(iwhere, nwhere)
      if (istat .lt. 0) then
         print *,'Task ',me,
     *           ' Error in doloop: stack overflow while ',
     *           'pushing wheres'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Set the c_oploop field in the optable to indicate initialization has
c   been performed.
c---------------------------------------------------------------------------

      optable(c_oploop, iop) = 1

c---------------------------------------------------------------------------
c   Set the new values of start_op, end_op
c---------------------------------------------------------------------------

      start_op = iop
      do j = iop+1,noptable
         if (optable(c_opcode,j) .eq. enddo_op) then
               
c---------------------------------------------------------------------------
c   Does the loop index match the loop index of the DO?
c---------------------------------------------------------------------------

            call get_loop_index(optable(c_ind1,j), instr_index, dummy)
            if (instr_index .eq. index) then
               end_op = j
               if (debug) 
     *            print *,'   New start_op, end_op values = ',
     *              start_op, end_op

c----------------------------------------------------------------------------
c   Get the WHERE conditionals for the current loop.
c----------------------------------------------------------------------------

               call get_where_conditionals(optable, start_op, end_op)
               return
            endif
         endif
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_ABCD_INTEGRALS
     +
     +                    ( SHELLP,SHELLQ,SHELLX,SHELLY,
     +                      SHELLA,SHELLB,SHELLC,SHELLD,
     +                      NGQEXQ,
     +                      WTS,
     +                      B00,B01,B10,C00,D00,
     +                      AB,CD,
     +                      WTAKE,
     +                      CASE2D,
     +                      INTSCR,
     +
     +                               INT2D )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_ABCD_INTEGRALS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 2D ABCD
C                integrals using the Rys vertical recurrence scheme
C                VRR and the Rys horizontal transfer scheme explained
C                below.
C
C                Scheme:
C
C                    i) VRR => generate the (P,0,Q,0) integrals
C                   ii) HRR => generate the (A,B,C,D) integrals
C
C                If WTAKE is set true, the Rys weight is being
C                multiplied to the 2D ABCD integral to reduce overall
C                FLOP count. Note, that the Rys weight factor needs
C                to be introduced only three times for the starting
C                2D ABCD integrals for the VRR recurrence scheme,
C                namely to the (0,0,0,0), (1,0,0,0) and (0,0,1,0)
C                elements. The weight factor is then automatically
C                propagated through the vertical and horizontal
C                transfer equations (see below).
C
C                The recurrence schemes VRR and HRR is due to Rys,
C                Dupuis and King, J. Comp. Chem. 4, p.154-157 (1983).
C
C
C                 i) VRR Scheme:
C
C
C                 INT2D (0,0,0,0) = WEIGHT
C                 INT2D (1,0,0,0) = C00 * WEIGHT
C                 INT2D (0,0,1,0) = D00 * WEIGHT
C
C                 For I = 1,...,SHELLP-1
C                     INT2D (I+1,0,0,0) = I * B10 * INT2D (I-1,0,0,0)
C                                           + C00 * INT2D (I,0,0,0)
C                 For K = 1,...,SHELLQ-1
C                     INT2D (0,0,K+1,0) = K * B01 * INT2D (0,0,K-1,0)
C                                           + D00 * INT2D (0,0,K,0)
C                 For I = 1,...,SHELLP
C                     INT2D (I,0,1,0)   = I * B00 * INT2D (I-1,0,0,0)
C                                           + D00 * INT2D (I,0,0,0)
C                 For K = 2,...,SHELLQ
C                     INT2D (1,0,K,0)   = K * B00 * INT2D (0,0,K-1,0)
C                                           + C00 * INT2D (0,0,K,0)
C                 For K = 2,...,SHELLQ
C                 For I = 2,...,SHELLP
C                     INT2D (I,0,K,0) = (I-1) * B10 * INT2D (I-2,0,K,0)
C                                         + K * B00 * INT2D (I-1,0,K-1,0)
C                                             + C00 * INT2D (I-1,0,K,0)
C
C
C                ii) HRR Scheme:
C
C
C                   For K = 0,SHELLQ
C                   For J = 1,...,SHELLX   (SHELLX = Min (SHELLA,SHELLB)
C                   For I = SHELLP-J,...,0
C                       INT2D (I,J,K,0) =  +/- AB * INT2D (I,J-1,K,0)
C                                                 + INT2D (I+1,J-1,K,0)
C
C                   For L = 1,...,SHELLY   (SHELLY = Min (SHELLC,SHELLD)
C                   For K = SHELLQ-L,...,0
C                   For J = 0,...,SHELLB
C                   For I = 0,...,SHELLA
C                       INT2D (I,J,K,L) =  +/- CD * INT2D (I,J,K,L-1)
C                                                 + INT2D (I,J,K+1,L-1)
C
C
C                The 2D integrals are calculated for all roots (info
C                already present in transmitted VRR coefficients!) and
C                for all exponent quadruples simultaneously and placed
C                into a 5-dimensional array with the combined root and
C                exponent quadruplet index varying fastest.
C
C                An important feature of this routine is that it can
C                be called with shell magnitudes A < B and/or C < D.
C                If these two cases happen, the VRR and HRR have to
C                be processed differently. Lets examine in detail the
C                A < B case (analogous is the C < D situation). If
C                shell A < shell B, the HRR must be defined such that
C                P,0 -> B,A due to efficiency and numerical stability
C                reasons. This in turn needs a redefinition of the
C                C00 coefficients, which now must be such that they
C                are defined with the P shell accumulated on center B
C                instead of A. The C00 coefficients are (example x
C                coordinate):
C
C                  i) P accumulated on center A:
C
C                        C00x = (Px - Ax) + terms independent of Ax,Bx
C
C                 ii) P accumulated on center B:
C
C                        C00x = (Px - Bx) + terms independent of Ax,Bx
C
C                When entering the present routine however, all we have
C                are the C00 values based on case i). If case ii)
C                applies, we have to form new C00 via:
C
C                          C00 -> C00 + (A - B) = C00 + AB
C
C                using the cartesian coordinate differences AB = A - B
C                between centers A and B. The constant AB is thus added
C                to all C00 values presently transmitted. Same applies
C                for D00 -> D00 + CD if shell C < shell D. The B00,B01
C                and B10 coefficients are independent of Ax and Bx and
C                thus need not be modified.
C
C
C                  Input:
C
C                    SHELLx      =  maximum shell sum for electron
C                                   1 and 2 (x = P=A+B,Q=C+D)
C                    SHELLx      =  minimum shell type between A and
C                                   B and between C and D for electron
C                                   1 and 2 (x = X,Y)
C                    SHELLy      =  maximum shell type for electron
C                                   1 on sites y = A,B and electron
C                                   2 on sites y = C,D
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    WTS         =  all quadrature Rys weights
C                    B00,B01,B10 =  VRR expansion coefficients
C                                   (cartesian coordinate independent)
C                    C00,D00     =  cartesian coordinate dependent
C                                   VRR expansion coefficients based
C                                   on centers A and C
C                    AB,CD       =  cartesian coordinate differences
C                                   A - B and C - D between sites A
C                                   and B and between sites C and D,
C                                   respectively
C                    WTAKE       =  if true, the Rys weights will be
C                                   build into the 2D ABCD integrals;
C                                   if false, the Rys weights will not
C                                   be considered
C                    CASE2D      =  logical flag for simplifications
C                                   in 2D integral evaluation for
C                                   low quantum numbers
C                    INTSCR      =  scratch array to perform the VRR
C                                   and HRR schemes.
C
C
C                  Output:
C
C                    INT2D       =  all 2D ABCD integrals with reduced
C                                   PB -> AB and QD -> CD dimensions.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   COPYIJ,COPYKL
         LOGICAL   HRRBA,HRRDC
         LOGICAL   WTAKE

         INTEGER   CASE2D
         INTEGER   I,J,K,L,N
         INTEGER   I1,I2,IP1,JM1,K1,K2,KP1,LM1
         INTEGER   NGQEXQ
         INTEGER   SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER   SHELLI,SHELLJ
         INTEGER   SHELLP,SHELLQ,SHELLX,SHELLY

         DOUBLE PRECISION  AB,CD
         DOUBLE PRECISION  F,F1,F2
         DOUBLE PRECISION  WEIGHT
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  B00  (1:NGQEXQ)
         DOUBLE PRECISION  B01  (1:NGQEXQ)
         DOUBLE PRECISION  B10  (1:NGQEXQ)
         DOUBLE PRECISION  C00  (1:NGQEXQ)
         DOUBLE PRECISION  D00  (1:NGQEXQ)
         DOUBLE PRECISION  WTS  (1:NGQEXQ)

         DOUBLE PRECISION  INT2D  (1:NGQEXQ,0:SHELLA,
     +                                      0:SHELLB,
     +                                      0:SHELLC,
     +                                      0:SHELLD)
         DOUBLE PRECISION  INTSCR (1:NGQEXQ,0:SHELLP,
     +                                      0:SHELLX,
     +                                      0:SHELLQ,
     +                                      0:SHELLY)

         PARAMETER  (ONE  = 1.D0)
         PARAMETER  (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 4 different cases that can arise:
C
C                  P-shell = s- or higher angular momentum
C                  Q-shell = s- or higher angular momentum
C
C                each leading to simplifications in the VRR and HRR
C                formulas. Note, that the HRR is only required if the
C                P-shell and/or Q-shell is higher than s-shell. The
C                case present has been evaluated outside this routine
C                and is transmitted via argument.
C
C
         GOTO (1,2,3,4) CASE2D
C
C
C             ...the case P = s-shell and Q = s-shell (no HRR!).
C                i) VRR => Evaluate: I = 0
C                                    J = 0
C                                    K = 0
C                                    L = 0
C
C
    1    IF (WTAKE) THEN
             DO 100 N = 1,NGQEXQ
                INT2D (N,0,0,0,0) = WTS (N)
  100        CONTINUE
         ELSE
             DO 110 N = 1,NGQEXQ
                INT2D (N,0,0,0,0) = ONE
  110        CONTINUE
         END IF

         RETURN
C
C
C             ...the cases P = s-shell and Q >= p-shell.
C                i) VRR => Evaluate: I = 0
C                                    J = 0
C                                    K = 0,SHELLQ
C                                    L = 0
C
C
    2    HRRDC = SHELLC .LT. SHELLD

         IF (HRRDC .AND. CD.NE.ZERO) THEN
             DO 200 N = 1,NGQEXQ
                D00 (N) = D00 (N) + CD
  200        CONTINUE
         END IF

         IF (WTAKE) THEN
             DO 210 N = 1,NGQEXQ
                WEIGHT = WTS (N)
                INTSCR (N,0,0,0,0) = WEIGHT
                INTSCR (N,0,0,1,0) = D00 (N) * WEIGHT
  210        CONTINUE
         ELSE
             DO 212 N = 1,NGQEXQ
                INTSCR (N,0,0,0,0) = ONE
                INTSCR (N,0,0,1,0) = D00 (N)
  212        CONTINUE
         END IF

         F = ONE
         DO 220 K = 2,SHELLQ
            K1 = K - 1
            K2 = K - 2
            DO 222 N = 1,NGQEXQ
               INTSCR (N,0,0,K,0) = F * B01 (N) * INTSCR (N,0,0,K2,0)
     +                                + D00 (N) * INTSCR (N,0,0,K1,0)
  222       CONTINUE
            F = F + ONE
  220    CONTINUE
C
C
C             ...ii) HRR => Evaluate: I = 0
C                                     J = 0
C                                     K = 0,SHELLQ-SHELLC/SHELLD
C                                     L = 0,SHELLD/SHELLC
C                           and
C
C               iii) Copy INTSCR to INT2D: I = 0
C                                          J = 0
C                                          K = 0,SHELLC
C                                          L = 0,SHELLD
C
C
         IF (.NOT.HRRDC) THEN

             IF (CD.EQ.ZERO) THEN
                 DO 230 L = 1,SHELLD
                    LM1 = L - 1
                    DO 231 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 232 N = 1,NGQEXQ
                          INTSCR (N,0,0,K,L) = INTSCR (N,0,0,KP1,LM1)
  232                  CONTINUE
  231               CONTINUE
  230            CONTINUE
             ELSE
                 DO 233 L = 1,SHELLD
                    LM1 = L - 1
                    DO 234 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 235 N = 1,NGQEXQ
                          INTSCR (N,0,0,K,L) = INTSCR (N,0,0,KP1,LM1)
     +                                  + CD * INTSCR (N,0,0,K,LM1)
  235                  CONTINUE
  234               CONTINUE
  233            CONTINUE
             END IF

             DO 236 L = 0,SHELLD
             DO 236 K = 0,SHELLC
             DO 236 N = 1,NGQEXQ
                INT2D (N,0,0,K,L) = INTSCR (N,0,0,K,L)
  236        CONTINUE

         ELSE

             IF (CD.EQ.ZERO) THEN
                 DO 240 L = 1,SHELLC
                    LM1 = L - 1
                    DO 241 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 242 N = 1,NGQEXQ
                          INTSCR (N,0,0,K,L) = INTSCR (N,0,0,KP1,LM1)
  242                  CONTINUE
  241               CONTINUE
  240            CONTINUE
             ELSE
                 DO 243 L = 1,SHELLC
                    LM1 = L - 1
                    DO 244 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 245 N = 1,NGQEXQ
                          INTSCR (N,0,0,K,L) = INTSCR (N,0,0,KP1,LM1)
     +                                  - CD * INTSCR (N,0,0,K,LM1)
  245                  CONTINUE
  244               CONTINUE
  243            CONTINUE
             END IF

             DO 246 L = 0,SHELLD
             DO 246 K = 0,SHELLC
             DO 246 N = 1,NGQEXQ
                INT2D (N,0,0,K,L) = INTSCR (N,0,0,L,K)
  246        CONTINUE

         END IF

         RETURN
C
C
C             ...the cases P >= p-shell and Q = s-shell.
C                i) VRR => Evaluate: I = 0,SHELLP
C                                    J = 0
C                                    K = 0
C                                    L = 0
C
C
    3    HRRBA = SHELLA .LT. SHELLB

         IF (HRRBA .AND. AB.NE.ZERO) THEN
             DO 300 N = 1,NGQEXQ
                C00 (N) = C00 (N) + AB
  300        CONTINUE
         END IF

         IF (WTAKE) THEN
             DO 310 N = 1,NGQEXQ
                WEIGHT = WTS (N)
                INTSCR (N,0,0,0,0) = WEIGHT
                INTSCR (N,1,0,0,0) = C00 (N) * WEIGHT
  310        CONTINUE
         ELSE
             DO 312 N = 1,NGQEXQ
                INTSCR (N,0,0,0,0) = ONE
                INTSCR (N,1,0,0,0) = C00 (N)
  312        CONTINUE
         END IF

         F = ONE
         DO 320 I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO 322 N = 1,NGQEXQ
               INTSCR (N,I,0,0,0) = F * B10 (N) * INTSCR (N,I2,0,0,0)
     +                                + C00 (N) * INTSCR (N,I1,0,0,0)
  322       CONTINUE
            F = F + ONE
  320    CONTINUE
C
C
C             ...ii) HRR => Evaluate: I = 0,SHELLP-SHELLA/SHELLB
C                                     J = 0,SHELLB/SHELLA
C                                     K = 0
C                                     L = 0
C                           and
C
C               iii) Copy INTSCR to INT2D: I = 0,SHELLA
C                                          J = 0,SHELLB
C                                          K = 0
C                                          L = 0
C
C
         IF (.NOT.HRRBA) THEN

             IF (AB.EQ.ZERO) THEN
                 DO 330 J = 1,SHELLB
                    JM1 = J - 1
                    DO 331 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 332 N = 1,NGQEXQ
                          INTSCR (N,I,J,0,0) = INTSCR (N,IP1,JM1,0,0)
  332                  CONTINUE
  331               CONTINUE
  330            CONTINUE
             ELSE
                 DO 333 J = 1,SHELLB
                    JM1 = J - 1
                    DO 334 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 335 N = 1,NGQEXQ
                          INTSCR (N,I,J,0,0) = INTSCR (N,IP1,JM1,0,0)
     +                                  + AB * INTSCR (N,I,JM1,0,0)
  335                  CONTINUE
  334               CONTINUE
  333            CONTINUE
             END IF

             DO 336 J = 0,SHELLB
             DO 336 I = 0,SHELLA
             DO 336 N = 1,NGQEXQ
                INT2D (N,I,J,0,0) = INTSCR (N,I,J,0,0)
  336        CONTINUE

         ELSE

             IF (AB.EQ.ZERO) THEN
                 DO 340 J = 1,SHELLA
                    JM1 = J - 1
                    DO 341 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 342 N = 1,NGQEXQ
                          INTSCR (N,I,J,0,0) = INTSCR (N,IP1,JM1,0,0)
  342                  CONTINUE
  341               CONTINUE
  340            CONTINUE
             ELSE
                 DO 343 J = 1,SHELLA
                    JM1 = J - 1
                    DO 344 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 345 N = 1,NGQEXQ
                          INTSCR (N,I,J,0,0) = INTSCR (N,IP1,JM1,0,0)
     +                                  - AB * INTSCR (N,I,JM1,0,0)
  345                  CONTINUE
  344               CONTINUE
  343            CONTINUE
             END IF

             DO 346 J = 0,SHELLB
             DO 346 I = 0,SHELLA
             DO 346 N = 1,NGQEXQ
                INT2D (N,I,J,0,0) = INTSCR (N,J,I,0,0)
  346        CONTINUE

         END IF

         RETURN
C
C
C             ...the cases P >= p-shell and Q >= p-shell.
C                i) VRR => Evaluate: I = 0,SHELLP       I = 0
C                                    J = 0              J = 0
C                                    K = 0         and  K = 0,SHELLQ
C                                    L = 0              L = 0
C
C
    4    HRRBA = SHELLA .LT. SHELLB
         HRRDC = SHELLC .LT. SHELLD

         IF (HRRBA .AND. AB.NE.ZERO) THEN
             DO 400 N = 1,NGQEXQ
                C00 (N) = C00 (N) + AB
  400        CONTINUE
         END IF

         IF (HRRDC .AND. CD.NE.ZERO) THEN
             DO 402 N = 1,NGQEXQ
                D00 (N) = D00 (N) + CD
  402        CONTINUE
         END IF

         IF (WTAKE) THEN
             DO 410 N = 1,NGQEXQ
                WEIGHT = WTS (N)
                INTSCR (N,0,0,0,0) = WEIGHT
                INTSCR (N,1,0,0,0) = C00 (N) * WEIGHT
                INTSCR (N,0,0,1,0) = D00 (N) * WEIGHT
  410        CONTINUE
         ELSE
             DO 411 N = 1,NGQEXQ
                INTSCR (N,0,0,0,0) = ONE
                INTSCR (N,1,0,0,0) = C00 (N)
                INTSCR (N,0,0,1,0) = D00 (N)
  411        CONTINUE
         END IF

         F = ONE
         DO 412 I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO 413 N = 1,NGQEXQ
               INTSCR (N,I,0,0,0) = F * B10 (N) * INTSCR (N,I2,0,0,0)
     +                                + C00 (N) * INTSCR (N,I1,0,0,0)
  413       CONTINUE
            F = F + ONE
  412    CONTINUE

         F = ONE
         DO 414 K = 2,SHELLQ
            K1 = K - 1
            K2 = K - 2
            DO 415 N = 1,NGQEXQ
               INTSCR (N,0,0,K,0) = F * B01 (N) * INTSCR (N,0,0,K2,0)
     +                                + D00 (N) * INTSCR (N,0,0,K1,0)
  415       CONTINUE
            F = F + ONE
  414    CONTINUE
C
C
C             ...i) VRR => Evaluate (if any): I = 1,SHELLP
C                                             J = 0
C                                             K = 1,SHELLQ
C                                             L = 0
C
C
         IF (SHELLQ.LE.SHELLP) THEN

             F1 = ONE
             DO 420 K = 1,SHELLQ
                K1 = K - 1
                DO 421 N = 1,NGQEXQ
                   INTSCR (N,1,0,K,0) = 
     +                              F1 * B00 (N) * INTSCR (N,0,0,K1,0)
     +                                 + C00 (N) * INTSCR (N,0,0,K,0)
  421           CONTINUE
                F2 = ONE
                DO 422 I = 2,SHELLP
                   I1 = I - 1
                   I2 = I - 2
                   DO 423 N = 1,NGQEXQ
                      INTSCR (N,I,0,K,0) =
     +                              F1 * B00 (N) * INTSCR (N,I1,0,K1,0)
     +                            + F2 * B10 (N) * INTSCR (N,I2,0,K,0)
     +                                 + C00 (N) * INTSCR (N,I1,0,K,0)
  423              CONTINUE
                   F2 = F2 + ONE
  422           CONTINUE
                F1 = F1 + ONE
  420        CONTINUE

         ELSE

             F1 = ONE
             DO 430 I = 1,SHELLP
                I1 = I - 1
                DO 431 N = 1,NGQEXQ
                   INTSCR (N,I,0,1,0) = 
     +                               F1 * B00 (N) * INTSCR (N,I1,0,0,0)
     +                                  + D00 (N) * INTSCR (N,I,0,0,0)
  431           CONTINUE
                F2 = ONE
                DO 432 K = 2,SHELLQ
                   K1 = K - 1
                   K2 = K - 2
                   DO 433 N = 1,NGQEXQ
                      INTSCR (N,I,0,K,0) =
     +                               F1 * B00 (N) * INTSCR (N,I1,0,K1,0)
     +                             + F2 * B01 (N) * INTSCR (N,I,0,K2,0)
     +                                  + D00 (N) * INTSCR (N,I,0,K1,0)
  433              CONTINUE
                   F2 = F2 + ONE
  432           CONTINUE
                F1 = F1 + ONE
  430        CONTINUE

         END IF
C
C
C             ...ii) HRR => Evaluate: I = 0,SHELLP-SHELLA/SHELLB
C                                     J = 0,SHELLB/SHELLA
C                                     K = 0,SHELLQ
C                                     L = 0
C
C
         IF (.NOT.HRRBA) THEN

             IF (AB.EQ.ZERO) THEN
                 DO 440 K = 0,SHELLQ
                 DO 440 J = 1,SHELLB
                    JM1 = J - 1
                    DO 441 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 442 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,0) = INTSCR (N,IP1,JM1,K,0)
  442                  CONTINUE
  441               CONTINUE
  440            CONTINUE
             ELSE
                 DO 443 K = 0,SHELLQ
                 DO 443 J = 1,SHELLB
                    JM1 = J - 1
                    DO 444 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 445 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,0) = INTSCR (N,IP1,JM1,K,0)
     +                                  + AB * INTSCR (N,I,JM1,K,0)
  445                  CONTINUE
  444               CONTINUE
  443            CONTINUE
             END IF

             COPYIJ = .TRUE.
             SHELLI = SHELLA
             SHELLJ = SHELLB

         ELSE

             IF (AB.EQ.ZERO) THEN
                 DO 450 K = 0,SHELLQ
                 DO 450 J = 1,SHELLA
                    JM1 = J - 1
                    DO 451 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 452 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,0) = INTSCR (N,IP1,JM1,K,0)
  452                  CONTINUE
  451               CONTINUE
  450            CONTINUE
             ELSE
                 DO 453 K = 0,SHELLQ
                 DO 453 J = 1,SHELLA
                    JM1 = J - 1
                    DO 454 I = 0,SHELLP-J
                       IP1 = I + 1
                       DO 455 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,0) = INTSCR (N,IP1,JM1,K,0)
     +                                  - AB * INTSCR (N,I,JM1,K,0)
  455                  CONTINUE
  454               CONTINUE
  453            CONTINUE
             END IF

             COPYIJ = .FALSE.
             SHELLI = SHELLB
             SHELLJ = SHELLA

         END IF
C
C
C             ...ii) HRR => Evaluate: I = 0,SHELLI
C                                     J = 0,SHELLJ
C                                     K = 0,SHELLQ-SHELLC/SHELLD
C                                     L = 0,SHELLD/SHELLC
C
C
         IF (.NOT.HRRDC) THEN

             IF (CD.EQ.ZERO) THEN
                 DO 460 L = 1,SHELLD
                    LM1 = L - 1
                    DO 461 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 462 J = 0,SHELLJ
                       DO 462 I = 0,SHELLI
                       DO 462 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,L) = INTSCR (N,I,J,KP1,LM1)
  462                  CONTINUE
  461               CONTINUE
  460            CONTINUE
             ELSE
                 DO 463 L = 1,SHELLD
                    LM1 = L - 1
                    DO 464 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 465 J = 0,SHELLJ
                       DO 465 I = 0,SHELLI
                       DO 465 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,L) = INTSCR (N,I,J,KP1,LM1)
     +                                  + CD * INTSCR (N,I,J,K,LM1)
  465                  CONTINUE
  464               CONTINUE
  463            CONTINUE
             END IF

             COPYKL = .TRUE.

         ELSE

             IF (CD.EQ.ZERO) THEN
                 DO 470 L = 1,SHELLC
                    LM1 = L - 1
                    DO 471 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 472 J = 0,SHELLJ
                       DO 472 I = 0,SHELLI
                       DO 472 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,L) = INTSCR (N,I,J,KP1,LM1)
  472                  CONTINUE
  471               CONTINUE
  470            CONTINUE
             ELSE

                 DO 473 L = 1,SHELLC
                    LM1 = L - 1
                    DO 474 K = 0,SHELLQ-L
                       KP1 = K + 1
                       DO 475 J = 0,SHELLJ
                       DO 475 I = 0,SHELLI
                       DO 475 N = 1,NGQEXQ
                          INTSCR (N,I,J,K,L) = INTSCR (N,I,J,KP1,LM1)
     +                                  - CD * INTSCR (N,I,J,K,LM1)
  475                  CONTINUE
  474               CONTINUE
  473            CONTINUE
             END IF

             COPYKL = .FALSE.

         END IF
C
C
C             ...iii) Copy INTSCR to INT2D: I = 0,SHELLA
C                                           J = 0,SHELLB
C                                           K = 0,SHELLC
C                                           L = 0,SHELLD
C
C
         IF (COPYIJ .AND. COPYKL) THEN

             DO 480 L = 0,SHELLD
             DO 480 K = 0,SHELLC
             DO 480 J = 0,SHELLB
             DO 480 I = 0,SHELLA
             DO 480 N = 1,NGQEXQ
                INT2D (N,I,J,K,L) = INTSCR (N,I,J,K,L)
  480        CONTINUE

         ELSE IF (COPYIJ) THEN

             DO 482 L = 0,SHELLD
             DO 482 K = 0,SHELLC
             DO 482 J = 0,SHELLB
             DO 482 I = 0,SHELLA
             DO 482 N = 1,NGQEXQ
                INT2D (N,I,J,K,L) = INTSCR (N,I,J,L,K)
  482        CONTINUE

         ELSE IF (COPYKL) THEN

             DO 484 L = 0,SHELLD
             DO 484 K = 0,SHELLC
             DO 484 J = 0,SHELLB
             DO 484 I = 0,SHELLA
             DO 484 N = 1,NGQEXQ
                INT2D (N,I,J,K,L) = INTSCR (N,J,I,K,L)
  484        CONTINUE

         ELSE

             DO 486 L = 0,SHELLD
             DO 486 K = 0,SHELLC
             DO 486 J = 0,SHELLB
             DO 486 I = 0,SHELLA
             DO 486 N = 1,NGQEXQ
                INT2D (N,I,J,K,L) = INTSCR (N,J,I,L,K)
  486        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      double precision function nn_repulsion_energy(coord, charge, 
     *                           natoms)
c-------------------------------------------------------------------------
c   Returns the nuclear-nuclear repulsion energy term.
c-------------------------------------------------------------------------
      implicit none
      integer natoms
      double precision coord(3,natoms), charge(natoms)

      integer i, j
      double precision sum, x,y,z,r

      sum = 0.
      do i = 1, natoms
      do j = i + 1, natoms
         x = coord(1,i)-coord(1,j)
         y = coord(2,i)-coord(2,j)
         z = coord(3,i)-coord(3,j)
         r = dsqrt(x*x + y*y + z*z)
         sum = sum + charge(i) * charge(j) / r
      enddo
      enddo

      nn_repulsion_energy = sum
      return
      end

      Subroutine Screen_ang_typ1(L, M, Nx, Ny, NZ, Lam, Mu, SKIP)

      Implicit Double Precision (A-H, O-Z)
      Logical Skip

#include "ecp.par"
#include "ecp.com"

      Id = L*(L+1) - M + 1

      IMn = Lmf(Id)
      Imx = Lmf(Id+1) - 1

      JD = Lam*(Lam+1) - Mu + 1

      JMn = Lmf(Jd)
      Jmx = Lmf(Jd+1) - 1
  
      Skip = .False.

      If (Mod(Nx+1,2) .EQ. Mod(Lmx(Jmn),2) .OR.
     &    Mod(Ny+1,2) .EQ. Mod(Lmy(Jmn),2) .OR.
     &    Mod(Nz+1,2) .EQ. Mod(Lmz(Jmn),2)) Skip = .TRUE.

#ifdef _DEBUG_LVLM1
      Write(6, "(a,1x,l)") "@-Screen_ang_typ1, Skip: ", Skip
      Write(6,*)
#endif 
      Return
      End

C  *******************************************************
C  Conversion of the hessian from cartesian to red. internal
C  coordinates.
C  Luis Galiano, 07/07/03
C  *******************************************************

      SUBROUTINE CART2INT_HESS(FI,HC,TOTREDNCO,NRATMS,HI)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INTEGER TOTREDNCO
#include "io_units.par"
#include "fnamelen.par"
#include "mxatms.par"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
#include "ric_heap.com"

C The following arrays are need to be dynamically allocated
C and deallocated.
C
C DIFTEMP: The is used in COMPKMAT as a temporary array to keep
C          an intermediate. It is of length 9*MXATMS*MXATMS.
C TEMP1  : Antoher temporary array to keep intermediates during
C          the transformations of the Cartesian Hessian. It is
C          of length 3*MAXREDUNCO*MXATMS.
C GMINBT : Keep the G-mat for Hessian transformations. It is of
C          length 9*MXATMS*MXATMS.
C GMINB  : To keep the  transpose of the G-mat, and it is of
C          the same lengthe as GMINBT.
C PFI    : Keep the gradients during the gradient projection.
C          It is of length MAXREDUNCO.
      DIMENSION DIFTEMP(9*MXATMS*MXATMS),FI(TOTREDNCO),PFI(MAXREDUNCO),
     &          HC(3*NRATMS,3*NRATMS),
     &          HI(TOTREDNCO*TOTREDNCO),
     &          GMINBT(3*MXATMS*MAXREDUNCO),
     &          TEMP1(MAXREDUNCO*3*MXATMS),
     &          GMINB(MAXREDUNCO*MAXREDUNCO)

      CALL GETREC(-1,'JOBARC','REDNCORD',1,TOTREDNCO)

C Build the K-matrix and the (H-K) matrix as shown in JCP, 117, 9160, 2002.
#ifdef _DEBUG_LVLM1
      Print*, "The Cartesian force constant matrix"
      CALL OUTPUT(HC,1,3*NRATMS,1,3*NRATMS,3*NRATMS,3*NRATMS, 1)
#endif
      CALL COMPKMAT(dRICHeap(z_DerBMat),NRATMS,TOTREDNCO,FI,HC,DIFTEMP)

      LENGTH_BGMAT =3*NRATMS*TOTREDNCO
      CALL GETREC(20,'JOBARC','BTGMIN',IINTFP*LENGTH_BGMAT,
     &            dRICHeap(z_BTGInv))
#ifdef _DEBUG_LVL0
         print *, 'The BTGINV matrix'
         CALL OUTPUT(dRICHeap(z_BTGInv), 1, 3*NRATMS, 1, TOTREDNCO, 
     &               3*NRATMS, TOTREDNCO, 1)
#endif
      CALL GETREC(20,'JOBARC','GMATRIX',IINTFP*LENGTH_BGMAT,
     &            GMINBT)

#ifdef _DEBUG_LVL0
         print *, 'The G matrix'
         CALL OUTPUT(GMINBT, 1, 3*NRATMS, 1, TOTREDNCO, 
     &               3*NRATMS, TOTREDNCO, 1)
#endif
C   Here we transpose the GMATRIX from JOBARC, because it was stored as
C   (G(-)*B)t and we need (G(-)*B)

      CALL TRANSP(GMINBT,GMINB,TOTREDNCO,3*NRATMS)

C   And here what we do is G(-)*B*(HC-K)*B(t)*G(-)

      CALL XGEMM('N','N',TOTREDNCO,3*NRATMS,3*NRATMS,1.0D0,
     &           GMINB,TOTREDNCO,DIFTEMP,3*NRATMS,0.0D0,
     &           TEMP1,TOTREDNCO)

      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,3*NRATMS,1.0D0,
     &           TEMP1,TOTREDNCO,dRICHeap(z_BTGInv),3*NRATMS,0.0D0,
     &           HI,TOTREDNCO)

C Now we have the the Hessian in Redundant Internal Coordinates
#ifdef _DEBUG_LVL0
         print *, 'Hessian in redundant internals'
         CALL OUTPUT(HI, 1, TOTREDNCO, 1, TOTREDNCO, TOTREDNCO,
     &               TOTREDNCO, 1)
#endif
C Purify the Hessian as recommended by Schlegel et al. (JCC,17,49,1996).
C G and G{^-1} have been created in the built_bgmatrix.F. The P=GG{^-1}
C is the projection into the redundant spaces that correspond to actual
C Cartesian displacements.

      LENGMAT=TOTREDNCO*TOTREDNCO
      CALL GETREC(20,'JOBARC','G-MATRX ',LENGMAT*IINTFP,DIFTEMP)
      CALL GETREC(20,'JOBARC','GI-MATRX',LENGMAT*IINTFP,
     &            dRICHeap(z_BTGInv))

      CALL ZERO(TEMP1,LENGMAT)
      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,TOTREDNCO,1.0D0,
     &           DIFTEMP,TOTREDNCO,dRICHeap(z_BTGInv),TOTREDNCO,0.0D0,
     &           TEMP1,TOTREDNCO)

      CALL PUTREC(20,'JOBARC',"PROJECTR",LENGMAT*IINTFP,TEMP1)

      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,TOTREDNCO,1.0D0,
     &           TEMP1,TOTREDNCO,HI,TOTREDNCO,0.0D0,GMINB,
     &           TOTREDNCO)
      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,TOTREDNCO,1.0D0,
     &           GMINB,TOTREDNCO,TEMP1,TOTREDNCO,0.0D0, HI,
     &           TOTREDNCO)

C Also project the gradients. Then copy the projected gradient
C to the FI array so that the rest of the code can proceed.
      CALL XGEMM('N', 'N',TOTREDNCO,1,TOTREDNCO,1.0D0,
     &           TEMP1,TOTREDNCO,FI,TOTREDNCO,0.0D0,
     &           PFI,TOTREDNCO)
      CALL DCOPY(TOTREDNCO,PFI,1,FI,1)

C Use GMINB to store the identity matrix.
      CALL ZERO(GMINB,TOTREDNCO*TOTREDNCO)
      DO I=1,TOTREDNCO
         GMINB((I-1)*TOTREDNCO+I) = 1.d0
      END DO

C Let's do the PHP + 1000.0(1-P) (note that we have already
C built the PHP and stored in HI).
      CALL DAXPY(TOTREDNCO*TOTREDNCO,-1.d0,GMINB,1,TEMP1,1)

      CALL DSCAL(TOTREDNCO*TOTREDNCO,1000.0D0,TEMP1,1)
      CALL DAXPY(TOTREDNCO*TOTREDNCO,-1.d0,TEMP1,1,HI,1)
#ifdef _DEBUG_LVL0
          print*,'The projected hessian in redundent internals '
          CALL OUTPUT(HI,1,TOTREDNCO,1,TOTREDNCO,TOTREDNCO,
     &                TOTREDNCO,1)
#endif
      RETURN
      END

C  *******************************************************
C  Conversion of the hessian from cartesian to red. internal
C  coordinates.
C  Luis Galiano, 07/07/03
C  *******************************************************

      SUBROUTINE CART2INT_HESS(FI,HC,TOTREDNCO,NRATMS,HI)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INTEGER TOTREDNCO
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
c ric_heap.com : begin

c This common block contains the heap address and array indices for
c processing RICs. New additions must be initialized to 1 in
c bd_ric_heap.F and set in init_ric_heap.F.

      external bd_ric_heap

      double precision dRICHeap(1)
      integer          z_RICHeap, z_DerBMat, z_BMat, z_GMat, z_BTGInv

      common /ric_heap_com/ dRICHeap,
     &                      z_RICHeap, z_DerBMat, z_BMat, z_GMat,
     &                      z_BTGInv
      save   /ric_heap_com/

c ric_heap.com : end

C The following arrays are need to be dynamically allocated
C and deallocated.
C
C DIFTEMP: The is used in COMPKMAT as a temporary array to keep
C          an intermediate. It is of length 9*MXATMS*MXATMS.
C TEMP1  : Antoher temporary array to keep intermediates during
C          the transformations of the Cartesian Hessian. It is
C          of length 3*MAXREDUNCO*MXATMS.
C GMINBT : Keep the G-mat for Hessian transformations. It is of
C          length 9*MXATMS*MXATMS.
C GMINB  : To keep the  transpose of the G-mat, and it is of
C          the same lengthe as GMINBT.
C PFI    : Keep the gradients during the gradient projection.
C          It is of length MAXREDUNCO.
      DIMENSION DIFTEMP(9*MXATMS*MXATMS),FI(TOTREDNCO),PFI(MAXREDUNCO),
     &          HC(3*NRATMS,3*NRATMS),
     &          HI(TOTREDNCO*TOTREDNCO),
     &          GMINBT(3*MXATMS*MAXREDUNCO),
     &          TEMP1(MAXREDUNCO*3*MXATMS),
     &          GMINB(MAXREDUNCO*MAXREDUNCO)

      CALL GETREC(-1,'JOBARC','REDNCORD',1,TOTREDNCO)

C Build the K-matrix and the (H-K) matrix as shown in JCP, 117, 9160, 2002.
      CALL COMPKMAT(dRICHeap(z_DerBMat),NRATMS,TOTREDNCO,FI,HC,DIFTEMP)

      LENGTH_BGMAT =3*NRATMS*TOTREDNCO
      CALL GETREC(20,'JOBARC','BTGMIN',IINTFP*LENGTH_BGMAT,
     &            dRICHeap(z_BTGInv))
         print *, 'The BTGINV matrix'
         CALL OUTPUT(dRICHeap(z_BTGInv), 1, 3*NRATMS, 1, TOTREDNCO, 
     &               3*NRATMS, TOTREDNCO, 1)
      CALL GETREC(20,'JOBARC','GMATRIX',IINTFP*LENGTH_BGMAT,
     &            GMINBT)

         print *, 'The G matrix'
         CALL OUTPUT(GMINBT, 1, 3*NRATMS, 1, TOTREDNCO, 
     &               3*NRATMS, TOTREDNCO, 1)
C   Here we transpose the GMATRIX from JOBARC, because it was stored as
C   (G(-)*B)t and we need (G(-)*B)

      CALL TRANSP(GMINBT,GMINB,TOTREDNCO,3*NRATMS)

C   And here what we do is G(-)*B*(HC-K)*B(t)*G(-)

      CALL XGEMM('N','N',TOTREDNCO,3*NRATMS,3*NRATMS,1.0D0,
     &           GMINB,TOTREDNCO,DIFTEMP,3*NRATMS,0.0D0,
     &           TEMP1,TOTREDNCO)

      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,3*NRATMS,1.0D0,
     &           TEMP1,TOTREDNCO,dRICHeap(z_BTGInv),3*NRATMS,0.0D0,
     &           HI,TOTREDNCO)

C Now we have the the Hessian in Redundant Internal Coordinates
         print *, 'Hessian in redundant internals'
         CALL OUTPUT(HI, 1, TOTREDNCO, 1, TOTREDNCO, TOTREDNCO,
     &               TOTREDNCO, 1)
C Purify the Hessian as recommended by Schlegel et al. (JCC,17,49,1996).
C G and G{^-1} have been created in the built_bgmatrix.F. The P=GG{^-1}
C is the projection into the redundant spaces that correspond to actual
C Cartesian displacements.

      LENGMAT=TOTREDNCO*TOTREDNCO
      CALL GETREC(20,'JOBARC','G-MATRX ',LENGMAT*IINTFP,DIFTEMP)
      CALL GETREC(20,'JOBARC','GI-MATRX',LENGMAT*IINTFP,
     &            dRICHeap(z_BTGInv))

      CALL ZERO(TEMP1,LENGMAT)
      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,TOTREDNCO,1.0D0,
     &           DIFTEMP,TOTREDNCO,dRICHeap(z_BTGInv),TOTREDNCO,0.0D0,
     &           TEMP1,TOTREDNCO)

      CALL PUTREC(20,'JOBARC',"PROJECTR",LENGMAT*IINTFP,TEMP1)

      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,TOTREDNCO,1.0D0,
     &           TEMP1,TOTREDNCO,HI,TOTREDNCO,0.0D0,GMINB,
     &           TOTREDNCO)
      CALL XGEMM('N','N',TOTREDNCO,TOTREDNCO,TOTREDNCO,1.0D0,
     &           GMINB,TOTREDNCO,TEMP1,TOTREDNCO,0.0D0, HI,
     &           TOTREDNCO)

C Also project the gradients. Then copy the projected gradient
C to the FI array so that the rest of the code can proceed.
      CALL XGEMM('N', 'N',TOTREDNCO,1,TOTREDNCO,1.0D0,
     &           TEMP1,TOTREDNCO,FI,TOTREDNCO,0.0D0,
     &           PFI,TOTREDNCO)
      CALL DCOPY(TOTREDNCO,PFI,1,FI,1)

C Use GMINB to store the identity matrix.
      CALL ZERO(GMINB,TOTREDNCO*TOTREDNCO)
      DO I=1,TOTREDNCO
         GMINB((I-1)*TOTREDNCO+I) = 1.d0
      END DO

C Let's do the PHP + 1000.0(1-P) (note that we have already
C built the PHP and stored in HI).
      CALL DAXPY(TOTREDNCO*TOTREDNCO,-1.d0,GMINB,1,TEMP1,1)

      CALL DSCAL(TOTREDNCO*TOTREDNCO,1000.0D0,TEMP1,1)
      CALL DAXPY(TOTREDNCO*TOTREDNCO,-1.d0,TEMP1,1,HI,1)
          print*,'The projected hessian in redundent internals '
          CALL OUTPUT(HI,1,TOTREDNCO,1,TOTREDNCO,TOTREDNCO,
     &                TOTREDNCO,1)
      RETURN
      END

      function bess(z,l)
      implicit double precision (a-h,o-z)

#include "ecp.par"
#include "ecp.com"

      data am1,a0,accrcy,a1s2,a1,a5,a16p1
     1   /-1.0d0,0.0d0,5.0d-14,0.5d0,1.0d0,5.0d0,16.1d0/

      if(z.gt.a5) go to 50
      if(z.eq.a0) go to 40
      if(z.lt.a0) go to 35
      zp=a1s2*z*z
      term=(z**l)/fac2(l+l+3-2)
      bess=term
      j=0
 5    j=j+1
      fjlj1=(j*(l+l+j+j+1))
      term=term*zp/fjlj1
      bess=bess+term
      if(dabs(term/bess).gt.accrcy) go to 5
      bess=bess*dexp(-z)
      go to 100
 35   bess=a0
      go to 100
 40   if(l.ne.0)go to 45
      bess=a1
      go to 100
 45   bess=a0
      go to 100
 50   if(z.gt.a16p1) go to 60
      rp=a0
      rm=a0
      tzp=z+z
      tzm=-tzp
      l1=l+1
      do 55 k1=1,l1
      k=k1-1
      rp=rp+fprod(k1,l1)/tzp**k
      rm=rm+fprod(k1,l1)/tzm**k
 55   continue
      bess=(rm-(am1**l)*rp*dexp(tzm))/tzp
      go to 100
 60   rm=a0
      tzm=-z-z
      l1=l+1
      do 65 k1=1,l1
      k=k1-1
      rm=rm+fprod(k1,l1)/tzm**k
 65   continue
      bess=rm/(-tzm)
 100  return
      end


                                   

      SUBROUTINE EXPDDP(DDP,NCOORD,ITRANS,NUCIND)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
      INTEGER DIRPRD
C
      DIMENSION DDP(3,NCOORD),ITRANS(NUCIND-1,3)
C
      COMMON/SYMINF/NSTART,NIRREP,IRREPA(255,2),DIRPRD(8,8) 
      COMMON/PERT/NTPERT,NPERT(8),IPERT(8),IXPERT,IYPERT,IZPERT,
     &            IXYPERT,IXZPERT,IYZPERT,ITRANSX,ITRANSY,
     &            ITRANSZ,NUCIND1
C
      IOFF=0
C
      DO 1000 IRREP=1,NIRREP
C
       N=NPERT(IRREP)
       IF(IXPERT.EQ.IRREP) N=N+1
       IF(IYPERT.EQ.IRREP) N=N+1
       IF(IZPERT.EQ.IRREP) N=N+1
C
       IF(IRREP.EQ.IXPERT) THEN
        IX=ITRANSX+IOFF
        DDP(1,IX)=0
        DDP(2,IX)=0
        DDP(3,IX)=0
        DO 100 INUC=1,NUCIND-1
         IX2=ITRANS(INUC,1)+IOFF
         DDP(1,IX)=DDP(1,IX)-DDP(1,IX2)
         DDP(2,IX)=DDP(2,IX)-DDP(2,IX2)
         DDP(3,IX)=DDP(3,IX)-DDP(3,IX2)
100     CONTINUE
       ENDIF
C
       IF(IRREP.EQ.IYPERT) THEN
        IY=ITRANSY+IOFF
        DDP(1,IY)=0
        DDP(2,IY)=0
        DDP(3,IY)=0
        DO 200 INUC=1,NUCIND-1
         IY2=ITRANS(INUC,2)+IOFF
         DDP(1,IY)=DDP(1,IY)-DDP(1,IY2)
         DDP(2,IY)=DDP(2,IY)-DDP(2,IY2)
         DDP(3,IY)=DDP(3,IY)-DDP(3,IY2)
200     CONTINUE
       ENDIF
C
       IF(IRREP.EQ.IZPERT) THEN
        IZ=ITRANSZ+IOFF
        DDP(1,IZ)=0
        DDP(2,IZ)=0
        DDP(3,IZ)=0
        DO 300 INUC=1,NUCIND-1
         IZ2=ITRANS(INUC,3)+IOFF
         DDP(1,IZ)=DDP(1,IZ)-DDP(1,IZ2)
         DDP(2,IZ)=DDP(2,IZ)-DDP(2,IZ2)
         DDP(3,IZ)=DDP(3,IZ)-DDP(3,IZ2)
300     CONTINUE
       ENDIF
C
       IOFF=IOFF+N
C
1000  CONTINUE
C
      RETURN
      END

      SUBROUTINE VIB1(H,HBUF,HINT,SCRATCH,ECKART,BUF1,BMAT,GRAD,
     &                POLDER,POLTMP,RINT,RDPL,NRX,IPROJ,SCR2)
C
C NORMAL MODE ANALYSIS FOR ACES II.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)
C TOLERANCE FOR DEGENERACY OF EIGENVALUES.
      PARAMETER (DEGTLX = 1.D-6)
      CHARACTER*1 XYZ(3),FLAG(3*MXATMS)
      CHARACTER*11 TYPE(3*MXATMS)
      CHARACTER*4 IRREP(3*MXATMS)
      CHARACTER*10 LABEL
      CHARACTER*4 TMPSTR, CIRREP(3*MXATMS), CHA_TMP1,
     &            CHA_TMP2, IRPCHAR(8)
      CHARACTER*(fnamelen) FNAME
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      LOGICAL YESNO,DIPOLE,READIS,RAMAN,POLDER_EXIST,
     &        SYMINFO_EXSIST
      INTEGER EOR(8, 8), KA(8, 3)
      DIMENSION SCRATCH(3*NRX),ECKART(2*NRX),IPT(3),BUF1(NXM6,NRX),
     &          SCR2(NRX*NRX),SYOP(72)
      DIMENSION BMAT(NXM6,NRX),GRAD(NRX), POLDER(9*NRX), POLTMP(9,NRX)
      DIMENSION H(NRX,NRX),HBUF(NRX,NRX),HINT(NRX),NORD(6*MXATMS),
     &          RINT(NRX),RDPL(NRX)
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
C
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
C
      Character*4 FPGrp, BPGrp, PGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      DATA XYZ /'X','Y','Z'/
      DATA HALF,FACT01 /0.5D0,2.85914392D-03/
      NREAL=NRX/3
      DEGTOL=DEGTLX
C
      Print*, "The point group", FPGrp, BPGrp, PGrp 
      ione = 1
      ibad = 0
      call getrec(-1, 'JOBARC', '12SWITCH', ione, ibad)
      if (ibad .eq. 1) then
         write(6,*) ' Atom 3 is to be connected to atom 2'
         write(6,*) ' Internal vibrational coordinates will be wrong'
         write(6,*) ' see Reconstruct Zmat at beginning of output file'
C         if (iflags2(3) .eq. 1) then
C            write(6,*) ' RESRAMAN output is definitely nonsense '
C         call errex
C         endif
      endif
C
C RELAX CRITERION FOR DEGENERACY IF THIS IS A FINITE DIFFERENCE 
C CALCULATION 
C
      RAMAN=(IFLAGS2(151).EQ. 1)
      IF(IVIB.ge.2)DEGTOL=DEGTOL*10.D0
C
C RELAX FURTHER IF IT IS SINGLE-SIDED.
C
      IF(IVIB.GE.2.AND.IGRDFD.EQ.1)DEGTOL=DEGTOL*10.D0
      istop=0
      IF(MOD(NRX,3).NE.0)THEN
       WRITE(6,8701)
 8701 FORMAT(T3,'@VIB1-F, Something very wrong with passed parameters.')
      Call ErrEx
      ENDIF
      IF(IPRNT.GE.8)THEN
       WRITE(LUOUT,8708)NREAL*3
 8708  FORMAT(T3,'@VIB1-I, The rank of the Hessian is ',I3)
      ENDIF
      IF(NREAL.EQ.0)THEN
       WRITE(LUOUT,8702)
 8702  FORMAT(T3,'@VIB1-F, No real atoms found in ATMASS string.')
       Call ErrEx
      ENDIF
C
C READ IN ISOTOPIC MASSES IF REQUIRED
C
      CALL GFNAME('ISOMASS ',FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=READIS)
      IF(READIS)THEN
       OPEN(UNIT=70,FILE=FNAME(1:ILENGTH),FORM='FORMATTED',STATUS='OLD')
       READ(70,*)(ATMASS(J),J=1,NREAL)
       WRITE(6,3030)
3030   FORMAT(T3,'@VIB1-I, Non-standard isotopic masses used.')
       WRITE(6,3031)
3031   FORMAT(T16,'Atom',T29,'Atomic mass')
       DO 3040 IPOS=1,NREAL
        WRITE(6,3032)IPOS,ATMASS(IPOS)
3032    FORMAT(T17,I2,T30,F9.5)
3040   CONTINUE
       CLOSE(UNIT=70,STATUS='KEEP')
      ENDIF
C
C MASS-WEIGHT HESSIAN MATRIX
C
      DO 15 I=1,NRX
      DO 15 J=1,NRX
      FACT=DSQRT(ATMASS(1+(I-1)/3)*ATMASS(1+(J-1)/3))
      IF(FACT.LT.1.D-3)THEN
       H(I,J)=0.D0
      ELSE
       H(I,J)=H(I,J)/FACT
      ENDIF
   15 CONTINUE
      Write(6,*)
      Write(6,*) "@-VIB1 Hessian after mass weighing"
      call output(h, 1, nrx, 1, nrx, nrx, nrx, 1)
C
C WRITE OUT FCM TO SCRATCH FILE IN CASE IT IS NEEDED LATER.
C
C
C FIRST MAKE SURE IT IS NOT THERE.
C
      INQUIRE(FILE='FCMSCR',EXIST=YESNO)
      IF(YESNO)THEN
       INQUIRE(FILE='FCMSCR',OPENED=YESNO,NUMBER=LUOLD)
       IF(YESNO)THEN
        CLOSE(LUOLD,STATUS='DELETE')
       ELSE
        OPEN(UNIT=78,FILE='FCMSCR',STATUS='OLD',FORM='UNFORMATTED')
        CLOSE(UNIT=78,STATUS='DELETE')
       ENDIF
       WRITE(LUOUT,341)
 341   FORMAT(T3,'@VIB1-I, File FCMSCR was on disk and was deleted.')
      ENDIF
      OPEN(UNIT=78,FILE='FCMSCR',STATUS='NEW',FORM=
     &'UNFORMATTED')
C     REWIND(78)
      WRITE(78)((H(I,J),J=1,NRX),I=1,NRX)
C
C DIAGONALIZE - EIGENVALUES AND EIGENVECTORS RETURNED SORTED -
C   EIGENVALUES ARE IN DIAGONAL ELEMENTS OF H, EIGENVECTORS ARE
C   COLUMNS OF HBUF.  EIGENVECTORS ARE IN *MASS-WEIGHTED* CARTESIAN
C   COORDINATES HERE.
C
      CALL EIG(H,HBUF,NRX,NRX,0)
      Write(6,*)
      Write(6,*) "Eigenvalues of the un-projected Hessian"
      Write(6, "(5F10.5)") (H(I,I), I=1, nrx)
C
C CHECK FOR NEGATIVE EIGENVALUES - SET BIT TO PRINT 'i' IF ENCOUNTERED.
C
      DO 26 I=1,NRX
      FLAG(I)=' '
      IF(H(I,I).LT.0.D0)FLAG(I)='i'
   26 CONTINUE
C
C CONVERT EIGENVALUES TO CORRESPONDING FREQUENCIES
C
      DO 25 I=1,NRX
   25 H(I,I)=DSQRT(DABS(H(I,I)))*5.14048D03
C
C WRITE NORMCO FILE
C (used to produce interfaces to various visualization programs such as
C  MOLDEN or HYPERCHEM.)
C
      OPEN(UNIT=56,FILE='NORMCO',FORM='FORMATTED',STATUS='UNKNOWN')
      WRITE(56,7500)
7500  FORMAT('% mass weighted coordinates')
      IOFF=1
      DO 20 I=1,NRX/3
       WRITE(56,'(3F20.10)')(SQRT(ATMASS(I))*Q(J),J=IOFF,IOFF+2)
       IOFF=IOFF+3
20    CONTINUE
      DO 21 IMODE=1,NRX
       WRITE(56,7501)
7501   FORMAT('% frequency')
       WRITE(56,'(F20.10,A1)')H(IMODE,IMODE),FLAG(IMODE)
       WRITE(56,7502)
7502   FORMAT('% normal coordinate ')
       WRITE(56,'((3F20.10))')(HBUF(J,IMODE),J=1,NRX)
21    CONTINUE
C Note that the intensities are written to the NORMCO file below.
      CALL SCOPY(NRX,H,NRX+1,SCRATCH,1)
      CALL PUTREC(20,'JOBARC','FREQUENC',NRX*IINTFP,SCRATCH)
C
C CHECK EIGENVECTORS AGAINST ECKART CONDITIONS.  ONLY DO THIS IF
C FREQUENCIES ARE UNPROJECTED.
C
      IF(IVIB.NE.3.OR.(IVIB.EQ.3.AND.IFLAGS(80).NE.0))THEN
C
CJDW 9/11/96. Note that CHKECK makes dimension of HBUF MASS * DISTANCE.
C             Below (in this part of the IF-block) we divide by the square
C             root of mass to recover the original eigenvectors. It is
C             these MASS**1/2 * DISTANCE eigenvectors which are printed
C             out under "Normal Coordinates".
C
       CALL CHKECK(NRX,HBUF,ECKART)
C
C NOW SORT ECKART VECTOR SO THAT WE CAN FIND THE MOST "ROTATIONLIKE" AND
C  "TRANSLATIONLIKE" MODES.  NEED TO PUT IN A CHECK HERE FOR LINEARITY
C  OF THE MOLECULE.
C
C INITIALIZE ALL TYPES TO VIBRATION
C
       DO 1032 I=1,NRX
        TYPE(I)=' VIBRATION '
 1032  CONTINUE
C
C PREPARE VECTOR WHICH WILL EVENTUALLY CONTAIN POINTERS TO THE TRANS.
C   AND ROTS.
C

       DO 5702 I=1,NRX
        NORD(I)=I
        NORD(NRX+I)=I
 5702  CONTINUE
C
C TRANSLATIONS FIRST.  ALWAYS THREE OF THESE.
C
       CALL PIKSR2(NRX,ECKART(NRX+1),NORD(NRX+1))
       DO 5703 I=0,2
       TYPE(NORD(2*NRX-I))='TRANSLATION'
 5703  CONTINUE
C
C CHECK INERTIA TENSOR FOR ZERO ELEMENT, MEANING MOLECULE IS LINEAR.
C
       CALL INERTIA(SCRATCH,.FALSE.)
       ILINER=0
       DO 5704 I=1,9,4
       IF(DABS(SCRATCH(I)).LT.1.D-5)ILINER=ILINER+1
 5704  CONTINUE
       ZIX=SCRATCH(1)
       ZIY=SCRATCH(5)
       ZIZ=SCRATCH(9)
       IF(ILINER.GT.1)THEN
        WRITE(LUOUT,5705)
 5705   FORMAT(T3,'@VIB1-F, Problem with inertia tensor.')
        WRITE(LUOUT,*)(SCRATCH(I),I=1,9)
        Call ErrEx
       ENDIF
C
C NOW ASSIGN ROTATIONAL MODES.
C
       CALL PIKSR2(NRX,ECKART,NORD)
       DO 5706 I=0,2-ILINER
       TYPE(NORD(NRX-I))=' ROTATION '
 5706  CONTINUE
C
C PUT EIGENVECTORS BACK INTO SQRT(MASS)*DISTANCE DIMENSION
C
       DO 323 I=1,NRX
       DO 333 J=1,NRX
       HBuf(J,I)=HBuf(J,I)/DSQRT(ATMASS(1+(J-1)/3))
 333   CONTINUE
       CALL NORMAL(HBUF(1,I),NRX)
 323   CONTINUE
      ELSE
       DO 334 I=1,NRX
        TYPE(I)=' VIBRATION '
        IF(H(I,I).LT.0.01)TYPE(I)=' --------- '
334    CONTINUE
      ENDIF
C
C NOW CHECK TO SEE IF THE DIPOLE DERIVATIVES ARE AVAILABLE.  IF
C  THEY ARE, THEN TRANSFORM THEM TO NORMAL COORDINATES AND DETERMINE
C  THE INTENSITY OF THE BANDS.
C
      INQUIRE(FILE='DIPDER',EXIST=DIPOLE)
      IF(DIPOLE)THEN
C
C DIPOLE DERIVATIVES.
C
C ANALYTIC CALCULATION
C
       IF(IVIB.LE.1)THEN
C
C GET INFORMATION ABOUT ATOMIC ORDERING
C
        CALL GETREC(20,'JOBARC','DUMSTRIP',NATOMS,NORD)
        CALL GETREC(20,'JOBARC','MAP2ZMAT',NATOMS,NORD(NATOMS+1))
        OPEN(UNIT=90,FILE='DIPDER',FORM='FORMATTED',STATUS='OLD')
C
C READ THE DIPDERS INTO THE SCRATCH VECTOR AND MASS WEIGHT THEM.
C
        JBOT=1
        DO 1033 I=1,3
         READ(90,*)
         JBOT0=1+(I-1)*3*NREAL
         DO 1034 J=1,NREAL
          JZ=NORD(NATOMS+J)
          JZREAL=NORD(JZ)
          JBOT=JBOT0+(JZREAL-1)*3
          READ(90,'(4F20.10)')ZJUNK,(SCRATCH(K),K=JBOT,JBOT+2)
          Z=1.D0/DSQRT(ATMASS(JZREAL))
         DO 1049 K=JBOT,JBOT+2
           SCRATCH(K)=SCRATCH(K)*Z
1049      CONTINUE
1034     CONTINUE
1033    CONTINUE
        CLOSE(UNIT=90,STATUS='KEEP')
       ELSE
          OPEN(UNIT=90,FILE='DIPDER',FORM='FORMATTED',STATUS='OLD')
          JBOT=1
          DO 1043 I=1,3
             READ(90,*)
             DO 1044 J=1,NREAL
                READ(90,'(4F20.10)')ZJUNK,(SCRATCH(K),K=JBOT,JBOT+2)
                Z=1.D0/DSQRT(ATMASS(J))
                DO 1059 K=JBOT,JBOT+2
                   SCRATCH(K)=SCRATCH(K)*Z
 1059           CONTINUE
                JBOT=JBOT+3
 1044        CONTINUE
 1043     CONTINUE
C
C Read The Polarizability Derivative file, Ajith and John 09/98.
C
        INQUIRE(FILE='POLDER',EXIST=POLDER_EXIST)
        IF (POLDER_EXIST) THEN
           OPEN(UNIT=91,FILE='POLDER',FORM='FORMATTED',STATUS='OLD')
           JBOT=1
           DO 1045 I=1,9
              READ(91,*)
              DO 1046 J=1,NREAL
                 READ(91,'(4F20.10)')ZJUNK,(POLDER(K),K=JBOT,JBOT+2)
                 Z=1.D0/DSQRT(ATMASS(J))
                 DO 1047 K=JBOT,JBOT+2
                    POLDER(K)=POLDER(K)*Z
 1047            CONTINUE
                 JBOT=JBOT+3
 1046         CONTINUE
 1045      CONTINUE
C
           CLOSE(UNIT=91,STATUS='KEEP')
        ENDIF
C
        CLOSE(UNIT=90,STATUS='KEEP')
       ENDIF
C
C TRANSFORM THEM TO THE NORMAL COORDINATE REP. AND WRITE TO SCRATCH FILE
C
C       WRITE(6,*) "POLDER just after Read"
C       CALL OUTPUT(POLDER, 1, 9, 1, NRX, 9, 1)
       CALL MTRAN2(HBUF,NRX)
       CALL MODMATMUL(SCRATCH,HBUF,SCRATCH,NRX,NRX,3,NRX,NRX,3)
       CALL MODMATMUL(POLDER,HBUF,POLDER,NRX,NRX,9,NRX,NRX,9)
       CALL MTRAN2(HBUF,NRX)
C       CALL OUTPUT(SCRATCH, 1, 3, 1, NRX, 3, NRX, 1)
C       CALL OUTPUT(POLDER, 1, 9, 1, NRX, 9, NRX, 1)
C
C Reorder The Polarizability Derivative Matrix and Diagonalize
C Ajith and John 09/98
C
       IF (POLDER_EXIST) THEN
          DO I= 1, NRX
             DO J= 1, 9
                POLTMP(J, I) = POLDER(NRX*(J-1) + I)
             END DO
          END DO
C          CALL OUTPUT(POLDER, 1, 9, 1, NRX, 9, NRX, 1)
          DO I= 1, NRX
             CALL EIG(POLTMP(1,I), POLDER, 3, 3, 1)
          END DO
C          CALL OUTPUT(POLTMP, 1, 9, 1, NRX, 9, NRX, 1)
       END IF
       OPEN(UNIT=95,FILE='DIPSCR',FORM='UNFORMATTED',STATUS='UNKNOWN')
       REWIND(95)
       WRITE(95)SCRATCH
       CLOSE(95)
C
C Calculate Raman Intensities and Depolarization Ratios.
C Ajith and John, 09/98
C
       IF (POLDER_EXIST) THEN
          DO IMODE = 1, NRX
             ALPHA = (1.0D0/3.0D0)*(   POLTMP(1,IMODE)
     &                               + POLTMP(5,IMODE)
     &                               + POLTMP(9,IMODE))
             BETAS = (1.0D0/2.0D0)*(
     &               (POLTMP(1,IMODE)-POLTMP(5,IMODE))**2
     &             + (POLTMP(5,IMODE)-POLTMP(9,IMODE))**2
     &             + (POLTMP(9,IMODE)-POLTMP(1,IMODE))**2)
             RINT(IMODE) = 0.0784159D0*(45.0D0*ALPHA**2 + 7.0D0*BETAS)
             IF (ALPHA .NE. 0.0D0 .AND. BETAS .NE. 0.0D0) THEN
                RDPL(IMODE) = 3.D0*BETAS/(45.0D0*ALPHA**2 + 4.0D0*BETAS)
             ELSE IF (BETAS .EQ. 0.0D0) THEN
                RDPL(IMODE) = 0.00D0
             ELSE
                RDPL(IMODE) = 0.75D0
             ENDIF
             IF (H(IMODE,IMODE) .LT. 1.0D-3) RDPL(IMODE) = 0.0D0
          END DO
       END IF
C
C COMPUTE INDIVIDUAL BAND INTENSITIES IN KM/MOL.
C
       CALL ZERO(HINT,NRX)
       DO 1035 I=1,NRX
        DO 1036 J=1,3
         Z=SCRATCH(NRX*(J-1)+I)
         HINT(I)=HINT(I)+Z*Z
1036    CONTINUE
1035   CONTINUE
       DO 1038 I=1,NRX
        HINT(I)=HINT(I)*974.868
c     o write the intensities to the NORMCO file
        WRITE(56,7503)
7503    FORMAT('% IR intensity')
        WRITE(56,'(F20.10)')HINT(I)
1038   CONTINUE
      ENDIF
C
C COMMENCE PRINTING OUT THE STUFF, FREQUENCIES FIRST AND THEN
C  NORMAL COORDINATES.
C
 900   IBOT=1
C
C PUT MOLECULE AND EIGENVECTORS IN PA ORIENTATION, SO THAT THE IRREPS
C  CAN BE DETERMINED.
C
C
      CALL STDORT(Q,SCRATCH,3*NREAL,0)

      DO 5002 I=IBOT,NRX
       CALL STDORT(HBUF(1,I),SCRATCH,3*NREAL,0)
 5002 CONTINUE
C
C  DEGENERATATE "Computational IRREPS" FOR FREQUENCIES NOW.
C
c
       CALL ZERO(SCRATCH,3*NRX)
C
C START AT BOTTOM OF LIST.
C
       I=IBOT
C
C CHECK HERE FOR LEVEL OF DEGENERACY AND PASS ALL MEMBERS OF A
C  DEGENERATE SET TO THE GENERATOR
C
        DO 6215 J=IBOT,NRX
        IRREP(J)='----'
 6215   CONTINUE
C
C
C The follwing block of code is completely replaced. The reason
C is that some one other than I (or under my watch) have decided
C to limit the symmetry assignment to the computational point group
C rather than the full point. This is fixed and the logic is simplified.
C For the time being I am keeping this block of code but at a latter
C stage when VIB1.F is cleaned up, all of this will be removed. 
C Ajith Perera, 006/2007.

CSSS          if(ndeg.gt.1)then
C
C RESOLVE DEGENERATE NORMAL COORDINATES ACCORDING TO PURE IRREDUCIBLE
C REPRESENTATIONS OF ABELIAN SUBGROUP
C
CSSS           call getrec(20,'JOBARC','COMPORDR',1,iorcomp)
CSSS           call putrec(20,'JOBARC','HOLDDEGQ',iintfp*5*nrx,hbuf(1,i))
CSSS           call resolve(ndeg,hbuf(1,i),scratch,syop,nord,
CSSS     &                  eckart,scr2,nrx,nrx/3,natoms,iorcomp,ierr)
CSSS          endif
CSSS
cSSS           if(ierr.eq.1)then
cSSS            write(6,*)' normal coordinate cannot be resolved '
cSSS            call getrec(20,'JOBARC','HOLDDEGQ',iintfp*ndeg*nrx,
cSSS     &                  hbuf(1,i))
cSSS           endif
cSSS
C I have done some clean up here. IRREPS() needs to be called for both
C degenerate and non-degenerate cases with the correct arguments to Hbuf
C and CIrrep (controlled by J).
C 01/2006, Ajith Perera.
CSSS          do j = 0, ndeg - 1
CSSS          CALL IRREPS(Q,PGrp,1,HBuf(1,I+J),NRX,CIrrep(i+J),Scratch)
CSSS          enddo
CSSS           do j = 0, ndeg-1
CSSS           CALL IRREPS(Q,FPGrp,NDEG,HBuf(1,I),NRX,Irrep(i),Scratch)
CSSS            do j= 0, ndeg-1
CSSS              Print*, TMPSTR, Irrep(i+J)
CSSS              TMPSTR = IRREP(I)
CSSS              IRREP(I+J) = TMPSTR
CSSS              CIRREP(I+J) = TMPSTR
CSSS           end do
CSSS           Print*, (IRREP(J), J=1, 10)
CSSS          else 
CSSS             CALL IRREPS(Q,PGrp,1,HBuf(1,I),NRX,Irrep(i),Scratch) 
CSSS             CIRREP(I) = IRREP(I) 
CSSS          endif 
CSSS
C ENDIF for the (TYPE(I).EQ.' VIBRATION ') block.
CSSS        ENDIF
CSSS
CSSS        I=I+NDEG
CSSS       IF(I.LE.NRX)GOTO 6218
C
 6218  NDEG = 1
C
      IF (TYPE(I).EQ.' VIBRATION ')THEN
         DO J=1,4
            P=1.D0-H(I+J,I+J)/H(I,I)
            IF(DABS(P).LT.DEGTOL)NDEG=NDEG+1
         ENDDO
 
         if (ndeg.gt.1)then
C 
C RESOLVE DEGENERATE NORMAL COORDINATES ACCORDING TO PURE IRREDUCIBLE
C REPRESENTATIONS OF ABELIAN SUBGROUP
C
           call getrec(20,'JOBARC','COMPORDR',1,iorcomp)
           call putrec(20,'JOBARC','HOLDDEGQ',iintfp*5*nrx,hbuf(1,i))
           call resolve(ndeg,hbuf(1,i),scratch,syop,nord,
     &                  eckart,scr2,nrx,nrx/3,natoms,iorcomp,ierr)
         endif       
C
         CALL IRREPS(Q,FPGrp,NDEG,HBuf(1,I),NRX,Irrep(i),Scratch)
         DO J = 1, NDEG - 1
                  TMPSTR = IRREP(I)
            IRREP(I + J) = TMPSTR
         ENDDO
      ENDIF 
      I = I + NDEG
      IF (I .LE. NRX) GO TO 6218 

C
C Isn't what's below a repeat from above? Someone has done something
C crazy. 01/2006, Ajith Perera.
C
      IF (.FALSE.) THEN
C
C DEGENERATATE "Computational IRREPS" FOR FREQUENCIES NOW.
C
       CALL ZERO(SCRATCH,3*NRX)

C START AT BOTTOM OF LIST.
C
       I=IBOT
C
        DO 2215 J=IBOT,NRX
        IRREP(J)='----'
 2215   CONTINUE
 2218    NDEG=1
        IF(TYPE(I).EQ.' VIBRATION ')THEN
         DO 3215 J=1,4
          P=1.D0-H(I+J,I+J)/H(I,I)
          IF(DABS(P).LT.DEGTOL)NDEG=NDEG+1
 3215 CONTINUE
          IF(TYPE(I).EQ.' VIBRATION ')
     &    CALL IRREPS(Q,FPGrp,NDeg,HBuf(1,I),NRX,Irrep(i),Scratch)
         DO 3216 J=1,NDEG-1
C These two lines were not in the block above. Let's copy them there.
          TMPSTR=IRREP(I)
          IRREP(I+J)=TMPSTR
 3216    CONTINUE
        ENDIF
        I=I+NDEG
        IF(I.LE.NRX)GOTO 2218
      END IF
C
C Appropriate averaging for degenerate irreps, Ajith and John 09/98
C
      IOFF = 1
      DO 1399 IMODE = 1, NRX
C
         DO 1499 I = 1, 4
            IF(IRREP(IOFF)(I:I).EQ.'A'.OR.IRREP(IOFF)(I:I).EQ.'B') THEN
               IOFF = IOFF + 1
            ELSE IF (IRREP(IOFF)(I:I) .EQ. 'E') THEN
               RINT(IOFF) = (RINT(IOFF)+RINT(IOFF+1))/4.0D0
               RINT(IOFF+1) = RINT(IOFF)
               IOFF = IOFF + 2
            ELSE IF (IRREP(IOFF)(I:I) .EQ. 'T') THEN
               RINT(IOFF)=(RINT(IOFF)+RINT(IOFF+1)+RINT(IOFF+2))/9.0D0
               RINT(IOFF+1) = RINT(IOFF)
               RINT(IOFF+2) = RINT(IOFF)
               IOFF = IOFF + 3
            ENDIF
 1499    CONTINUE
         IOFF = IOFF + 1
C
 1399 CONTINUE
C
C NOW PUT EVERYTHING BACK INTO ACES2 ORIENTATION.
C
      CALL STDORT(Q,SCRATCH,3*NREAL,1)
      DO 5001 I=IBOT,NRX
       CALL STDORT(HBUF(1,I),SCRATCH,3*NREAL,1)
 5001 CONTINUE
C
C This record is specifically added for Coriolis coupling constant 
C work. Unlike what is in NORMCO file these are symmetry adapted
C and matches with what is on the output.  Ajith Perera, 02/2009.
C
       CALL PUTREC(20, "JOBARC", "SYM_NMDS", NRX*NRX*IINTFP, HBUF)
       CALL PUTCREC(20, "JOBARC", "VIB_SYMS", NRX*4, IRREP)
C
C
      WRITE(LUOUT,1000)
1000  FORMAT(T22,'Normal Coordinate Analysis')
C
      IF (RAMAN) THEN 
          WRITE(LUOUT,2222)
          WRITE(LUOUT,2001)
          WRITE(LUOUT,2002)
          WRITE(LUOUT,2222)
          WRITE(LUOUT,2003)
          WRITE(LUOUT,2222)
C
2001  FORMAT(T2,' Irreducible',T18,' Harmonic ',T34,' Infrared ',
     &T48,'Raman', T63, 'Depolarization',T80,' Type ')
2002  FORMAT(T2,'Representation',T18,' Frequency ',T34,
     &' Intensity ',T48, 'Intensity', T63, 'Ratio')
2003  FORMAT(T20,'(cm-1)',T36,'(km/mol)', T48, '(A**4/AMU)')
C
      ELSE 
C
          WRITE(LUOUT,1111)
          WRITE(LUOUT,3001)
          WRITE(LUOUT,3002)
          WRITE(LUOUT,1111)
          WRITE(LUOUT,3003)
          WRITE(LUOUT,1111)
C
3001  FORMAT(T4,' Irreducible',T24,' Harmonic ',T39,' Infrared ',
     &T55,' Type ')
3002  FORMAT(T4,'Representation',T24,' Frequency ',T39,
     &' Intensity ')
3003  FORMAT(T26,'(cm-1)',T40,'(km/mol)')
C   
      ENDIF 
C
      DO 45 I=IBOT,NRX
         IF (RAMAN) THEN
             WRITE(LUOUT,4000)IRREP(I),H(I,I),FLAG(I),
     &                        HINT(I),RINT(I), RDPL(I), 
     &                        TYPE(I)
4000  FORMAT(T7,A4,T15,F10.4,A1,T30,F10.4,T45,F10.4,T60,F10.4,T75,A11)
C
         ELSE
             WRITE(LUOUT,4005)IRREP(I),H(I,I),FLAG(I),HINT(I),TYPE(I)
 4005 FORMAT(T7,A4,T24,F10.4,A1,T39,F10.4,T55,A11)
C
         ENDIF
C
45    CONTINUE
C
      IF (RAMAN) THEN
          WRITE(LUOUT,2222)
      ELSE
          WRITE(LUOUT,1111)
      ENDIF
C
1111   FORMAT(64('-'))
2222   FORMAT(80('-'))
C
      WRITE(LUOUT,*)
C
      WRITE(LUOUT,5000)
5000  FORMAT(T35,' Normal Coordinates ',/,
     &       T26,' [Dimensions are Mass**-1/2 Distance] ')
C
C NOW SET UP POINTER LIST SO THAT TRANSLATIONS AND ROTATIONS ARE
C   NOT PRINTED
C
C8000  ITOP=MIN(IBOT+2,NRX)
 8000 J=IBOT
      IX=1
 4007 IF(TYPE(J).EQ.' VIBRATION ')THEN
       IPT(IX)=J
       IX=IX+1
       J=J+1
       IF(IX.LT.4.AND.J.LT.NRX+1)GOTO 4007
      ELSE
       J=J+1
       IF(J.LT.NRX+1)GOTO 4007
      ENDIF
      IBOT=J
      WRITE(LUOUT,1100)(IRREP(IPT(I)),I=1,IX-1)
      WRITE(LUOUT,1101)(H(IPT(I),IPT(I)),FLAG(IPT(I)),I=1,IX-1)
      WRITE(LUOUT,1102)(TYPE(IPT(I)),I=1,IX-1)
1100  FORMAT(/,14X,3(A4,22X))
1101  FORMAT(14X,3(F7.2,A1,18X))
1102  FORMAT(12X,3(A11,15X))
      WRITE(LUOUT,1103)((XYZ(J),J=1,3),I=1,IX-1)
1103  FORMAT(T10,3(A1,7X),T36,3(A1,7X),T62,3(A1,7X))
       DO 65 JBT=1,NRX-2,3
C
C SKIP OVER UNINTERESTING DUMMY ATOMS.
C
       WRITE(LUOUT,1105)ZSYM(1+(JBT-1)/3),
     &((HBUF(J,IPT(I)),J=JBT,JBT+2),I=1,IX-1)
1105   FORMAT(T1,A,   F7.4,T14,F7.4,T22,F7.4,T32,F7.4,T40,F7.4,
     &T48,F7.4,T58,F7.4,T66,F7.4,T74,F7.4)
c1105   FORMAT(T2,A,1X,F7.4,T14,F7.4,T22,F7.4,T32,F7.4,T40,F7.4,
c     &T48,F7.4,T58,F7.4,T66,F7.4,T74,F7.4)
65     CONTINUE
C       IBOT=IBOT+3
c      IF(IBOT.GE.NRX)GOTO 9000
CJDW 9/11/96. I think we want the following for linear molecules to
C             work. Format statement 1105 also changed.
       IF(IBOT.GT.NRX)GOTO 9000
       GOTO 8000
9000   CONTINUE
C
C CONVERT GRADIENT VECTOR TO NORMAL COORDINATE REPRESENTATION UNLESS
C VIB = FINDIF
C
       IF(IVIB.LT.2.AND.IFLAGS2(103).NE.0)THEN
        WRITE(6,8004)
        WRITE(6,8001)
        WRITE(6,8002)
        WRITE(6,8001)
        JBOT=1
        DO 2044 J=1,NREAL
         Z=1.D0/DSQRT(ATMASS(J))
         DO 2059 K=JBOT,JBOT+2
          GRAD(K)=GRAD(K)*Z
2059     CONTINUE
         JBOT=JBOT+3
2044    CONTINUE
c     
        CALL XGEMM('N','N',1,NRX,NRX,1.0D0,GRAD,1,HBUF,NRX,
     &             0.0D0,SCRATCH,1)
c
c
c Comments on unit conversion  (from JFS)
c   V = 1/2 k x^2 = 1/2 [4 * pi * pi * nu * nu] * mu * x^2
c
c    = 1/2 [ 4 * pi *pi *nu *nu ] Q^2
c
c   or
c
c     V/hc  =  1/2 omega q^2
c
c     where q = sqrt(2 * pi * c * omega /hbar) * Q
c    and omega is the vibrational frequency in cm-1
c
c  therefore, the energy gradient is
c
c    dE/dq = dE/dQ * dQ/dq
c
c      = dE/dQ * sqrt(hbar/2*pi*c*omega)
c
c   ->   FRED = 0.09114 amu^1/2 bohr divided by sqrt(2.997925d10)
c  (the factor c is taken in the sqrt, see below)
c
c      = 5.265D-7
c
        JBOT=1
        DO 3044 J=1,NREAL
         Z=DSQRT(ATMASS(J))
         DO 3059 K=JBOT,JBOT+2
          GRAD(K)=GRAD(K)*Z
3059     CONTINUE
         JBOT=JBOT+3
3044    CONTINUE
C
        SMAX=0.0D0
        DO 8499 I=1,NRX
         IF(TYPE(I).EQ.' VIBRATION ')THEN
          SCRATCH(NRX+I)=(SCRATCH(I)*SCRATCH(I))/H(I,I)
         ENDIF
8499    CONTINUE
        ILOC=ISAMAX(NRX,SCRATCH(NRX+1),1)
        CALL SSCAL(NRX,1.0D0/SCRATCH(NRX+ILOC),SCRATCH(NRX+1),1)
        DO 8500 I=1,NRX
         IF(TYPE(I).EQ.' VIBRATION ')THEN
          FRED=5.26353359D-07
          C=2.997925D10
          GRADRED1=219474.1D0*SCRATCH(I)/(FRED*DSQRT(C*DABS(H(I,I))))
          GRADRED2=27.2116D0*SCRATCH(I)/(FRED*DSQRT(C*DABS(H(I,I))))
          WRITE(6,8003)I,H(I,I),FLAG(I),SCRATCH(I),GRADRED1,
     &                 GRADRED2,SCRATCH(NRX+I)
         ENDIF
8500    CONTINUE
C 
        WRITE(6,8001)
C
8001   FORMAT(T10,58('-'))
8002   FORMAT(T4,'i',T9,'W(I)',T18,'dE/dQ(i)',T31,'dE/dq',T42,'dE/dq',
     &        T52,'|dE/dq|^2',/,
     &        T31,'(cm-1)',T43,'(eV)',T55,'(relative)')
8003   FORMAT(T3,I3,T7,F8.2,A1,T15,F14.10,T30,F10.3,T41,F10.6,
     &        T52,F14.10)
8004   FORMAT(T13,'Gradient vector in normal coordinate representation')
C
cmn Print out second table in which units / symmetries are displayed
cmn for use with xsim (simulation of vibronic coupling issues.
c
       ione = 1
       ifinal = 0
       call getrec(-1,'JOBARC', 'FINALSYM', ione, ifinal)
c
c to determine symmetries read in irpchar from file syminfo
c
        inquire(file='SYMINFO', exist=SYMINFO_EXSIST)
        if (SYMINFO_EXSIST) then
        open(unit=10, FILE='SYMINFO',STATUS='OLD')
        do i = 1, 8
           read(10,579) j,  (irpchar(i)(k:k),k=1,4)
        enddo
 579    format(i4,2x,4a1)
        close(unit=10,STATUS='KEEP')
        endif
C
c Construct group multiplication table as in vmol
c
C     Determine KA(I,J)
c
      DO I=1,8
        IS=0
        DO K=1,3
          KA(I,K)=(I-1)/(2**(K-1))-2*((I-1)/(2**K))
          IS=IS+KA(I,K)
       enddo
       enddo
c
      DO I=1,8
        DO J=1,8
        IAN=1
        IOR=1
        DO 102 Kk=1,3
          IAN=IAN+MIN0(KA(I,Kk),KA(J,Kk))*2**(Kk-1)
  102   IOR=IOR+MAX0(KA(I,Kk),KA(J,Kk))*2**(Kk-1)
        EOR(I,J)=IOR-IAN+1
      enddo
      enddo
c
      ione = 1
        call getrec(-1, 'JOBARC', 'COMPNIRR', ione, nirrep)
cYAU - We don't have to keep printing this matrix out.
c      WRITE (6,2112)
c2112  format(/,'   Group multiplication table :',/)
c      DO 1113 I=1,nirrep
c1113  WRITE (6,1114) (EOR(I,J),J=1,nirrep)
c1114  FORMAT (6x,8I4)
c      write(6,*)

 7001  FORMAT(T3,75('-'))
 7004  format(t13, 'Gradient vector data in eV plus symmetry info')
 7007  format(t13, 'Computational Irrep of electronic state ', a4,
     $      ' -> [',i1,']')
 7005  format(t4, 'Irreps of vibrations ',t32,'Frequencies',
     $ t51, 'Gradient', t62, 'Coupling Sym')
 7002  format(t5,'#', t8, 'FULL  COMP  [#]', t30, 'cm-1',t42,'eV', t51,
     $      'dE/dq(i)',t63,'Irrep',t70,'[#]')
 7006  format(t3,i3,t8,A4,t14,A4, '  [',i1,']', t25, F10.2,A1,' ',
     $ F10.7,A1,t48,F10.7,t62,A4, t70,'[',i1,']')

        WRITE(6,7004)
        if (ifinal .eq. 0) then
           CHA_TMP2 = '----'
        else
           CHA_TMP2 = irpchar(ifinal)
        endif
                                                       
       WRITE(6,7007) CHA_TMP2, ifinal
        write(6,*)
        WRITE(6,7001)
        WRITE(6,7005)
        WRITE(6,7002)
        WRITE(6,7001)
c
        JBOT=1
        DO J=1,NREAL
           Z=1.D0/DSQRT(ATMASS(J))
           DO K=JBOT,JBOT+2
              GRAD(K)=GRAD(K)*Z
           ENDDO
           JBOT=JBOT+3
        ENDDO
c
        CALL XGEMM('N','N',1,NRX,NRX,1.0D0,GRAD,1,HBUF,NRX,
     &             0.0D0,SCRATCH,1)
c
        JBOT=1
        DO J=1,NREAL
         Z=DSQRT(ATMASS(J))
         DO K=JBOT,JBOT+2
            GRAD(K)=GRAD(K)*Z
         ENDDO
            JBOT=JBOT+3
         ENDDO
c
        SMAX=0.0D0
        DO I=1,NRX
           IF(TYPE(I).EQ.' VIBRATION ')THEN
              SCRATCH(NRX+I)=(SCRATCH(I)*SCRATCH(I))/H(I,I)
           ENDIF
        ENDDO
C
        DO I=1,NRX
         IF(TYPE(I).EQ.' VIBRATION ')THEN
c
          FRED=5.26353359D-07
          C=2.997925D10
          GRADRED2=27.2116D0*SCRATCH(I)/(FRED*DSQRT(C*DABS(H(I,I))))
          VIBEV=H(I,I) * 27.2116D0 / 219474.1D0
          i1=0
          do k=1, 8
             if (cirrep(i) .eq. irpchar(k)) i1=k
          enddo
          if (i1 .eq. 0) then
             i2 = 0
          else
          I2=EOR(i1, ifinal)
          endif
          if (i2 .ne. 0) then
             CHA_TMP1 = irpchar(i2)
           else
             CHA_TMP1 = '----'
          endif
          WRITE(6,7006)I,IRREP(I),CIRREP(I),I1 , H(I,I),
     $         flag(i), VIBEV,flag(i), GRADRED2, CHA_TMP1,
     &         I2
         ENDIF
         ENDDO
        WRITE(6,7001)

        ENDIF  
C
C CONVERT VIBRATIONAL COORDINATES TO INTERNALS
C
C
C FIRST PUT EIGENVECTORS BACK INTO DISTANCE DIMENSION
C
       DO 623 I=1,NRX
        IF(TYPE(I).EQ.' VIBRATION ')THEN
         DO 633 J=1,NRX
          HBuf(J,I)=HBuf(J,I)/DSQRT(ATMASS(1+(J-1)/3))

633      CONTINUE
        ELSE
         CALL ZERO(HBUF(1,I),NRX)
        ENDIF
 623   CONTINUE
C
C Note that the REALATOM record is also written eleswhere. The normal
C modes in NORMCORD record is without mass weighing. The SYM_NMDS
C record essentially have the same info with out mass weights. May
C be we can use this record to store normal modes in internal coordiantes.
C Ajith Perera, 02/09. 

       CALL PUTREC(20,'JOBARC','REALATOM',1,INT(NRX/3))
       CALL PUTREC(20,'JOBARC','NORMCORD',NRX*NRX*IINTFP,HBUF)
       CALL PUTCREC(20,'JOBARC','VIB_TYPE',NRX*11*IINTFP,TYPE)
C
       IF(IFLAGS(68).NE.1) THEN
C
        CALL GETREC(20,'JOBARC','BMATRIXC',IINTFP*NRX*NXM6,BMAT)
        CALL XGEMM('N','N',NXM6,NRX,NRX,1.0D0,BMAT,NXM6,HBUF,NRX,
     &             0.0D0,BUF1,NXM6)
        DO 624 I=1,NRX
         IF(TYPE(I).EQ.' VIBRATION ')THEN
          CALL NORMAL(BUF1(1,I),NXM6)
         ENDIF
624     CONTINUE
        IBOT=1
        WRITE(6,*)
        WRITE(6,3117)
3117    FORMAT(T20,'   Normal modes in internal coordinates ')
3114    ITOP=MIN(IBOT+4,NRX)
        WRITE(6,3116)
3116    FORMAT(75('-'))
        WRITE(6,'(5X,5(5X,F9.3))')(H(J,J),J=IBOT,ITOP)
        WRITE(6,3116)
        DO 3115 ICOORD=1,NXM6
         WRITE(6,'(A,5(5X,F9.6))')VARNAM(ISQUASH(ICOORD)),
     &         (BUF1(ICOORD,J),J=IBOT,ITOP)
3115    CONTINUE
        IBOT=ITOP+1
        IF(IBOT.LT.NRX)GOTO 3114
        WRITE(6,3116)
        WRITE(6,*)
       ENDIF
C
C IF DIPDERS WERE EVALUATED, WRITE OUT DIPOLE MOMENT FUNCTION.
C
      IF(DIPOLE)THEN
       OPEN(UNIT=95,FILE='DIPSCR',FORM='UNFORMATTED',STATUS='OLD')
       READ(95)SCRATCH
       CLOSE(UNIT=95,STATUS='DELETE')
       CLOSE(95)
       WRITE(LUOUT,1111)
       WRITE(LUOUT,1109)
1109   FORMAT(T21,'Dipole Moment Function',/,T20,'(Normal ',
     & 'Coordinate Basis)')
       WRITE(LUOUT,1111)
       WRITE(LUOUT,1112)
1112   FORMAT(T5,'Mode',T14,'Symmetry',T26,'d(Mu(x))/dQ',T40,
     &'d(Mu(y))/dQ',T54,'d(Mu(z))/dQ')
       WRITE(LUOUT,1111)
       DO 1115 I=1,NRX
        IF(TYPE(I).EQ.' VIBRATION ')THEN
         IF(I/10.EQ.0)THEN
          WRITE(LUOUT,1121)I,IRREP(I),(SCRATCH(NRX*(J-1)+I),J=1,3)
         ELSEIF(I/100.EQ.0)THEN
          WRITE(LUOUT,1122)I,IRREP(I),(SCRATCH(NRX*(J-1)+I),J=1,3)
         ELSEIF(I/1000.EQ.0)THEN
          WRITE(LUOUT,1123)I,IRREP(I),(SCRATCH(NRX*(J-1)+I),J=1,3)
         ENDIF
1121     FORMAT(T6,'Q',I1,T16,A4,T27,F9.6,T41,F9.6,T55,F9.6)
1122     FORMAT(T6,'Q',I2,T16,A4,T27,F9.6,T41,F9.6,T55,F9.6)
1123     FORMAT(T5,'Q',I3,T16,A4,T27,F9.6,T41,F9.6,T55,F9.6)
        ENDIF
1115   CONTINUE
       WRITE(LUOUT,1111)
      ENDIF
C
C WRITE INFORMATION TO FREQUENCY ARCHIVE FILE FOR SUBSEQUENT
C  PICKUP BY STAT. THERMO. PROGRAM
C
C
C FIRST FILL SCRATCH VECTOR WITH "VIBRATIONAL" FREQUENCIES.
C
      ZMASS=0.D0
      DO 1039 I=1,NRX/3
      ZMASS=ZMASS+ATMASS(I)
 1039 CONTINUE
      CALL ZERO(SCRATCH,NRX)
      IX=0
      NIMAG=0
      DO 2231 I=1,NRX
      IF(TYPE(I).EQ.' VIBRATION ')THEN
       IX=IX+1
       SCRATCH(IX)=H(I,I)
       IF(FLAG(I).EQ.'i')NIMAG=NIMAG+1
      ENDIF
 2231 CONTINUE
      OPEN(UNIT=79,FILE='FRQARC',FORM='UNFORMATTED',STATUS='UNKNOWN')
      REWIND(79)
      IREC=0
 2233 READ(79,END=2234,ERR=2234)LABEL
      IREC=IREC+1
      GOTO 2233
 2234 REWIND(79)
      DO 2251 I=1,IREC
       READ(79,ERR=2239,END=2239)LABEL
 2251 CONTINUE
      GOTO 6666
 2239 WRITE(LUOUT,781)
 781  FORMAT(T3,'@VIB1-W, Mysterious problem with FRQARC file.  ',
     &/,T5,' Existing version will be deleted.')
      CLOSE(UNIT=79,STATUS='DELETE')
      OPEN(UNIT=79,FILE='FRQARC',FORM='UNFORMATTED',STATUS='NEW')
 6666 LABEL='***FRQC***'
      WRITE(79)LABEL,FPGRP,NRX,NIMAG,ZMASS,ZIX,ZIY,ZIZ,
     &(SCRATCH(J),J=1,IX)
      CLOSE(UNIT=79,STATUS='KEEP')
C
C COMPUTE ROTATIONALLY PROJECTED FREQUENCIES ACCORDING TO THE MILLER-HAN
C METHOD
C
      ITIM=0
      CALL ZERO(SCRATCH,3*NX)
C
C CHECK TO SEE IF THIS IS A LINEAR MOLECULE.
C
      ILINER=0
      IF(FPGRP(2:2).EQ.'X')ILINER=1
c      DO 10 I=1,NRX
c      IPOS=1+ITIM*NRX
c      IF(TYPE(I).EQ.'TRANSLATION')THEN
c       CALL VADD(SCRATCH(IPOS),SCRATCH(IPOS),HBUF(1,I),NRX,1)
c       ITIM=ITIM+1
c      ENDIF
c10    CONTINUE
C
C COMPUTE ROTATIONAL PART OF PROJECTOR.
      Write(6,*) "The coordinates used in Vib/rot projection"
      Write(6, "(3F10.7)") (Q(I), I=1, NX)
C
      DO 10 I=1,NRX-2,3
      NAT=1+(I-1)/3
      ZZ=DSQRT(ATMASS(NAT))
      SCRATCH(I)=0.D0
      SCRATCH(I+1)=-Q(I+2)*ZZ
      SCRATCH(I+2)=Q(I+1)*ZZ
      SCRATCH(NRX+I)=Q(I+2)*ZZ
      SCRATCH(NRX+I+1)=0.D0
      SCRATCH(NRX+I+2)=-Q(I)*ZZ
      SCRATCH(2*NRX+I)=-Q(I+1)*ZZ
      SCRATCH(2*NRX+I+1)=Q(I)*ZZ
      SCRATCH(2*NRX+I+2)=0.D0
 10   CONTINUE
      CALL NORMAL(SCRATCH,NRX)
      CALL NORMAL(SCRATCH(NRX+1),NRX)
      CALL NORMAL(SCRATCH(2*NRX+1),NRX)
      ITIM=3
      IF(ILINER.EQ.1)ITIM=2
      CALL ZERO(HBUF,NRX*NRX)
      CALL OUTERP(HBUF,SCRATCH,NRX,ITIM,0)
      Write(6,*)
      Write(6,*) "@-VIB1 The rot. projector"
      call output(Hbuf, 1, Nrx, 1, Nrx, Nrx, Nrx, 1)
CSSS      CALL ZERO(HBUF,NRX*NRX)
C
C NOW DO TRANSLATIONAL PART OF PROJECTOR.
C
      CALL ZERO(SCRATCH,3*NRX)
      DO 11 I=1,NRX-2,3
      ZZ=DSQRT(ATMASS(1+(I-1)/3))
      SCRATCH(I)=ZZ
      SCRATCH(NRX+I+1)=ZZ
      SCRATCH(2*NRX+I+2)=ZZ
 11   CONTINUE
      CALL NORMAL(SCRATCH,NRX)
      CALL NORMAL(SCRATCH(NRX+1),NRX)
      CALL NORMAL(SCRATCH(2*NRX+1),NRX)
      CALL ZERO(H,NRX*NRX)
      ITIM=3
      CALL OUTERP(H,SCRATCH,NRX,ITIM,1)
      CALL VADD (HBUF,H,HBUF,NRX*NRX,-1.D0)
      Write(6,*)
      Write(6,*) "@-VIB1 The trn. projector"
      call output(Hbuf, 1, Nrx, 1, Nrx, Nrx, Nrx, 1)
      REWIND(78)
      READ(78)((H(I,J),J=1,NRX),I=1,NRX)
      CALL MODMATMUL(H,H,HBUF,NRX,NRX,NRX,NRX,NRX,NRX)
      WRITE(78)((H(I,J),J=1,NRX),I=1,NRX)
      CALL ZERO(H,NRX*NRX)
      CALL MTRANSP(HBUF,H,NRX,NRX,NRX,NRX)
      BACKSPACE(78)
      READ(78)((HBUF(I,J),J=1,NRX),I=1,NRX)
      CALL MODMATMUL(H,H,HBUF,NRX,NRX,NRX,NRX,NRX,NRX)
      CALL ZERO(HBUF,NRX*NRX)
      Write(6,*)
      Write(6,*) "The projected Hessian"
      call output(H, 1, nrx, 1, nrx, nrx, nrx, 1)

      CALL EIG(H,HBUF,NRX,NRX,0)
      Write(6,*)
      Write(6,*) "Eigenvalues of the projected Hessian"
      Write(6, "(5F10.5)") (H(I,I), I=1, nrx)

c   o gather the diagonal eigenvalues back into column 1 for dumping to JOBARC
c     (Obviously we cannot use this matrix afterward.)
      do i = 2, nrx
         h(i,1) = h(i,i)
      end do
      call putrec(20,'JOBARC','FORCECON',IINTFP*NRX,h)
      WRITE(LUOUT,9901)
9901  FORMAT(T3,' Vibrational frequencies after rotational projection ',
     &' of ',/,T3,' Cartesian force constants: ')
      FACT=5.14048D03
      ZPE=0.0D0
      DO 9902 I=1,NRX
      IF(H(I,I).LT.0.D0)THEN
       H(I,I)=FACT*DSQRT(-H(I,I))
       FLAG(I)='i'
      ELSE
       H(I,I)=FACT*DSQRT(H(I,I))
       FLAG(I)=' '
       ZPE=ZPE+H(I,I)
      ENDIF
      WRITE(LUOUT,9903)I,H(I,I),FLAG(I)
9903  FORMAT(T10,I4,T25,F10.4,A1)
9902  CONTINUE
      WRITE(LUOUT,9904)HALF*ZPE*FACT01
9904  FORMAT(T3,'Zero-point vibrational energy = ',F9.4,' kcal/mole.')
      ISTOP=100
      CLOSE(UNIT=78,STATUS='DELETE')
      CLOSE(UNIT=56,STATUS='KEEP')
      CALL CHKECK(NRX,HBUF,ECKART)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C     THIS IS A MODIFICATION OF THE MKVMOL.F
C     FILE. THE PURPOSE IS TO WRITE A .MOL-LIKE
C     FILE WHICH INCLUDES ALL NON-DUMMY
C     ATOMS AND NOT JUST THE SYMMETRY UNIQUE CENTERS.
C     THIS ROUTINE IS ONLY EXECUTED WHEN THE
C     USER HAS CHOSEN AN NDDO INITIAL GUESS
C     -CARLOS TAYLOR

#include "flags.h"

      SUBROUTINE MKNDDO(geom, PTGRP,NATMS,NUNIQUE,ZSYM,ATNR,GENBY,
     $     SCRATCH, ISTAT, BasName)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "baslims.par"
#include "mxatms.par"
#include "io_units.par"
#include "linelen.par"
#include "molstrct.com"
#include "coord.com"

C SET UNIT NUMBER CARLOS TAYLOR
      parameter(lunddo=30,lunddo_input=40,ATOB=.529177d0)
      character*10 NddoFil
      character*4 CREF(3),CREFJ
      data CREF/' RHF',' UHF','ROHF'/,NddoFil/"NDDO.INPUT"/
      character*(*) BasName

      Character*(*) PtGrp, ZSym(NAtms)
      Integer AtNr(NAtms), GenBy(NAtms), IStat, AtoI,IZLoc(MxAtms)
      Character*(linelen) JobTtl, Wrk
      Character*3 Ka(3)
      Character*6 Slask,NullSt
      Character*1 Lb
      Character*1 Indxx(150)

cYAU - parse ZMAT like fetchz()
      integer izl(2,7)
      logical bTmp

csb 1/97 Hold long basis set names
#include "baslen.par"
      character*(baslen) BasNam(MxAtms),BlnkBN,ScrBas,EcpNam(MxAtms)

      dimension icrcor(mxatms)
      common /turbo / iturbo,matom,ioffsh

CJDW  11/2/94. We now use IFLAGS2(108) to set TLA.
C     Parameter (TLA = 1.D-9)
CSSS      INTEGER SHELLANG,SHELLLOC,SHELLSIZ,SHELLPRM
CSSS      INTEGER SHELLORB,SHOFFSET,PRIMORBT,PROFFSET
      double precision geom(3*mxatms)
C
      LOGICAL XYZIN,NWFINDIF
      Logical Opn,bad123
CKJW 5-24-00
      logical seward
      data seward /.false./
      Integer OldLu
      Dimension Nord(2*MxAtms),Scratch(NAtms)
C
CSSS      COMMON /MOLSTR1/ SHELLANG(100),SHELLLOC(100),SHELLSIZ(100),
CSSS     &                 SHELLPRM(100),BASISEXP(10000),BASISCNT(10000)
CSSS      COMMON /MOLSTR2/ NTOTPRIM,NTOTSHEL,IOFFPRIM,IOFFSHEL,IIATOM
CSSS      COMMON /MOLSTR3/ SHELLORB(100),SHOFFSET(100),PRIMORBT(100),
CSSS     &                 PROFFSET(100)

      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /INPTYP/XYZIN,NWFINDIF
      COMMON /FLAGS/IFLAGS(100),IFLAGS2(500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
C     Length of BasNam is fixed by the basis library
C
C
C     This length is fixed by ABINITIO's input section
C
      Data Indxx /'1','2','3','4','5','6','7','8','9','0','A'
     &,'B','C','D','E','F','G','H','I','J','K','L','M','N'
     &,'O','P','Q','R','S','T','U','V','W','X','Y','Z','a'
     &,'b','c','d','e','f','g','h','i','j','k','l','m','n'
     &,'o','p','q','r','s','t','u','v','w','x','y','z',88*'*'/

c ----------------------------------------------------------------------

C
C Initialize some things.
C
      do i=1,baslen
        BlnkBN(i:i)=' '
      end do
      ScrBas=BlnkBN

      bad123 = .false.
      Slask='INTGRL'
      NullSt='      '
      LB='#'
      J=0
      I=0
      IGENER=1
      IF10=0
      IF18=1
      ID3=0
      IONE=1
      IRSTRT=0
      IECP=IFLAGS(71)
      IECPU=0
      IPRINT=0
      INUTMP=0
      ISTATS=0
      ISTAT=0
      IOFFPRIM=1
      IOFFSHEL=1
C
      ICOUNT=0
C
C     Cautiously open the ZMAT file
C
      Inquire (FILE=ZFil, OPENED=Opn)
      If (.not.Opn) Open (LuZ, FILE=ZFil, STATUS='OLD')
      Rewind LuZ

C     skip the header
      bTmp = .true.
      do while (bTmp)
         read (LuZ, '(A)') JobTtl
         call parsez(JobTtl,izl)
         i = izl(1,1)
         bTmp = ((i.eq.0).or.(JobTtl(i:i).EQ.'%'))
      end do

      IF ((.NOT.XYZIN).OR.(NWFINDIF)) THEN
         i = 1
         do while (i.le.natms)
            read (LuZ,'(A)') Wrk
            call parsez(wrk,izl)
            if (i.eq.3) then
               izz = AtoI(wrk(izl(1,2):izl(2,2)))
               bad123 = ( izz.eq.1            .and.
     &                    zsym(1)(1:1).ne.'X' .and.
     &                    zsym(2)(1:1).ne.'X'       )
            end if
            i = i + 1
         end do
      ELSE
         DO I = 1, NATMS
            READ (LUZ,'(A)') WRK
         END DO
      END IF
      Read (LuZ,'(A)') Wrk
      IF (IFLAGS(68) .EQ. 0) THEN
         Do i = 1, NUnique
            Read (LuZ, '(A)') Wrk
         End Do
      END IF
      Read (LuZ, '(A)') Wrk

      IPrnt  = iFlags(h_IFLAGS_joda_print)
      INR    = iFlags(h_IFLAGS_opt_method)
      IContl = iFlags(h_IFLAGS_convergence)
      IVec   = iFlags(h_IFLAGS_eigenvector)
      IDie   = iFlags(h_IFLAGS_negeval)
      ICurvy = iFlags(h_IFLAGS_curvilinear)
      IStCrt = iFlags(h_IFLAGS_stp_siz_ctl)
      IMxStp = iFlags(h_IFLAGS_max_step)
      IVib   = iFlags(h_IFLAGS_vibration)
      IRecal = iFlags(h_IFLAGS_eval_hess)
      IntTyp = iFlags(h_IFLAGS_integrals)
      IDisFD = iFlags(h_IFLAGS_fd_stepsize)
      IGrdFD = iFlags(h_IFLAGS_points)
      ICNTYP = iFlags(h_IFLAGS_contraction)
      ISym   = iFlags(h_IFLAGS_symmetry)
      IBasis = iFlags(h_IFLAGS_basis)
      IDFGHI = iFlags(h_IFLAGS_spherical)
c   o if ([basis=special]) then [scroll ZMAT down to the basis set definitions]
c     WARNING: THIS IS A HACK!
c     Basis set information handling should be totally revamped.
      if (iBasis.eq.0) then
         bTmp = .true.
         do while (bTmp)
            read(LuZ,'(A)') wrk
            bTmp = (wrk(2:2).ne.':'.and.wrk(3:3).ne.':')
         end do
c      o go back for the next read
         backspace(luz)
      end if
c YAU : end
      If (IContl.eq.0) IContl = 4

C     Now read the basis sets - each line corresponds to a (non-dummy)
C     center in the Z-matrix, in the order of appearance.  We put this
C     into an array length NAtms, with blanks for dummies.  This makes
C     it easier to match the basis with the right coordinates later.
C     NOTE: blank line after basis names.
      Do 250 i = 1, NAtms
         BasNam(i) = BlnkBN
         if (AtNr(i).ne.0) then
            if (iBasis.eq.0) then
c            o read special
               read(LuZ,'(A)') BasNam(i)
            else
csb 1/97 Allow arbitrary basis set names
               BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
     &                   BasName(1:linblnk(BasName))
            end if
c        end if ([not dummy atom])
         end if
 250  Continue
      If(IBasis.eq.0)Read (LuZ,'(A)') Wrk
C ADDITION (JFS,4/90)
C Now take care of situation which occurs when 2--1--3 Z-matrix
C  specification and nonstandard basis set input is used.  In this case,
C  the basis sets for atoms #1 and #2 must be switched.
C
      If(Bad123.and.IBasis.eq.0)then
       ScrBas=BasNam(1)
       BasNam(1)=BasNam(2)
       BasNam(2)=ScrBas
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Count number of centers having *different* atomic numbers in this grou
C   Top half of Nord contains the number of symmetry equivalent atoms
C   for a given atomic number.
C
      Do I = 1, NAtms
C  MAKING THIS LOOP UNCONDITIONAL RESULTS IN ALL ATOMIC CENTERS
C  BEING WRITTEN TO FILE INSTEAD OF JUST SYMMETRY UNIQUE CENTERS
C -CARLOS TAYLOR
C         If (GenBy(i).eq.0.and.AtMass(i).gt.1.D-2) Then
            J = J + 1
            Scratch(J) = AtMass(I)
            Nord(J) = I
c         End If
      End Do
      If (IVIB.ne.2) Then
c         Call PikSr2(J,Scratch,Nord)
         NonTyp = 1
         If (J.Eq.1) Then
            Nord(MxAtms+1) = 1
         Else
            Do I = 2, J
               Dif = Dabs(Scratch(i)-Scratch(i-1))
               If (NonTyp.eq.1) IBot=0
c               If (Dif.lt.1.D-14) GoTo 314
               Nord(MxAtms+Nontyp) = I - (IBot+1)
               IBot = IBot + Nord(MxAtms+Nontyp)
               NonTyp = NonTyp + 1
 314           If (I.eq.J) Nord(MxAtms+Nontyp) = I - Ibot
            End Do
         End If
      Else If (ivib.eq.2) Then
C
C For finite difference calcs, reset this so that it writes out the
C  atoms to the MOL
C  file in exactly the same order as they appear in the ZMAT.  This
C  ordering is assumed in FINDIF!
C
         NonTyp = J
         Do I = 1, J
            Nord(MxAtms+I) = 1
         End Do
      End If

C Now get symmetry information written by SYMMETRY to file VMINF.
      If (PtGrp.EQ.'C1 ') Then
         Do I = 1, 3
            KA(I)='   '
         End Do
         NSymOp = 0
      End If
C
C     Now we've got (pretty much) all the information we need, so
C     we can start writing out the MOL file.
C     Begin with a very cautious opening of the file.
C
        Opn = .False.
        Open (LUNDDO, FILE='MOL_NDDO', FORM='FORMATTED',
     $     STATUS='UNKNOWN')
        Rewind LUNDDO
C
C Write lines of VMOL deck.  All of this mysterious SLASK stuff, etc.
C
        idosph=1-IDFGHI
cYAU        Write(LUNDDO,'(A6,4X,10I5)')Slask,IGENER,If10,If18,IECP,IECPU,
cYAU     &    IPRINT,INUTMP,ISTATS,IDOSPH
        Write(LUNDDO,'(A6,4X,10I5)')
     &     'INTGRL',IGENER,If10,If18,IECP,IECPU,
     &              IPRINT,INUTMP,ISTATS,IDOSPH
        Write(LUNDDO,'(8x,a)')
     &     ' *** ACES2 Program System (Release V0.1) *** '
        Write(LUNDDO,'(A)') JobTtl(:linblnk(JobTtl))
CJDW  11/2/94
        TLA = DBLE(10.0D+00**(-IFLAGS2(108)))
        Write(LUNDDO,'(2I5,3A3,1X,E10.2,10X,2I5)')NonTyp,NSymop,Ka,Tla,
     &    ID3,IRstrt
        Zink=9999.0
        Zink2=3.0
        Write(LUNDDO,'(2F10.2)')Zink,Zink2
C
C Now write the "real" input.
C
      IINFIL=0
      SHOFFSET(1)=1
      PROFFSET(1)=1
      Do 318 I = 1, Nontyp
C
C     THE FOLLOWING IF-THEN SOLVES THE PROBLEM WITH DUMMY ATOMS - CARLOS TAYLOR
C
       if(atnr(i).eq.0)goto 318
       NStart = 1
       Do J = 1, I-1
          NStart = NStart + Nord(MxAtms+J)
       End Do
       SCRBAS=BASNAM(NORD(NSTART))
       IATTYP=1
       IIATOM=NORD(NSTART)
       IATOM=IATNUM(IIATOM)
       IF(IATOM.GT.2)IATTYP=2
       IF(IATOM.GT.10)IATTYP=3
C
C     I'M NOT SURE ABOUT THE FOLLOWING CHANGE LUNDDO FOR LUVMOL
C
        CALL RDBAS(SCRBAS,0,IFLAGS(64+IATTYP),LUNDDO,
     &             IntTyp,NullSt,IAtnum(Nord(NStart)),
     &             Nord(MxAtms+I),seward,.false.,6)
       Do J = 1, Nord(MxAtms+J)
          IBotm = -2 + 3*Nord(NStart-1+J)
          IINFIL = IINFIL + 1
          IZLOC(IINFIL) = NORD(NSTART+J-1)
          Icount = Icount + 1
          Write(LUNDDO,'(A2,A1,A1,3F20.12)')
     &                  ZSym(Nord(NStart)),LB,Indxx(ICOUNT),
     &                  (geom(IJ),IJ=IBotm,Ibotm+2)
       End Do
        CALL RDBAS(SCRBAS,1,IFLAGS(64+IATTYP),LUNDDO,
     &             ijunk,ijunk,ijunk,ijunk,seward,.false.,6)
        SHOFFSET(I+1)=IOFFSHEL
        PROFFSET(I+1)=IOFFPRIM
        SHELLORB(I)=SHOFFSET(I+1)-SHOFFSET(I)
        PRIMORBT(I)=PROFFSET(I+1)-PROFFSET(I)
 318    Continue
        Write(LUNDDO,'(A6)')'FINISH'
C
C Also open the "NDDO.INPUT" file for Carlos Taylor's NDDO program. Note
C that projected NDDO is used as the initial guess for the SCF program when
C it is requested by the user (GUESS=NDDO). A. Perera, 10/2004
C
C     Determine if RHF or UHF (IREF=1 FOR RHF AND IREF=2 FOR UHF)
      IREF=IFLAGS(11)+1
      IMULT=IFLAGS(29)
      ICHG=IFLAGS(28)
      OPEN(UNIT=LUNDDO_INPUT, FILE=NddoFil,Form="Formatted",
     &     STATUS="UNKNOWN")
      WRITE(LUNDDO_INPUT,'(A40)') "'NDDO INPUT GENERATED VIA ACES2'"
      IF(IREF.EQ.1)WRITE(LUNDDO_INPUT,151)ICHG
      IF(IREF.EQ.2)WRITE(LUNDDO_INPUT,150)IMULT,ICHG
      CALL IGETREC(20, 'JOBARC', 'ATOMCHRG', NATOMS, ICRCOR)
      DO IATOMS = 1, NATOMS
         ISTART = 3*(IATOMS - 1)
         WRITE(LUNDDO_INPUT, 99) ICRCOR(IATOMS), GEOM(ISTART+ 1)*
     &                           ATOB, GEOM(ISTART+ 2)*ATOB,
     &                           GEOM(ISTART+3)*ATOB
 99      FORMAT(I2,F10.5,F10.5,F10.5)
 150     FORMAT( "'AM1 XYZ UHF MULT=",I1," CHARGE=",I1,"'")
 151     FORMAT( "'AM1 XYZ RHF CHARGE=",I1,"'")
      END DO
      CLOSE(LUNDDO)
      CLOSE(LUNDDO_INPUT)
      Close (LuZ)
C
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
        DOUBLE PRECISION FUNCTION ANGMAG(ORBIT,D,IORDER,IRETURN)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        IRETURN=0
        ANGMAG=0.D0
        DTOR=DACOS(-1.D0)/180.D0
        ORDER=DFLOAT(IORDER)
        A1=180.D0/ORDER
        IF(DABS(A1-90.D0).LT.1.D-3)THEN
          ANGMAG=0.D0
        RETURN
        ENDIF
        X=ORBIT**2-0.25D0*D**2/DSIN(DTOR*A1)**2
        TOP=D/DTAN(DTOR*A1)
        IF(X.LT.-1.D-12)THEN
C
C THE ROTATION IS IMPOSSIBLE
C
         IRETURN=1
         RETURN
        ENDIF
        IF(DABS(X).LT.1.D-6)THEN
          ANGMAG=90.D0
        ELSE
        BOT=2.D0*DSQRT(X)
          ANGMAG=DATAN(TOP/BOT)/DTOR
        ENDIF
        RETURN
        END         

      SUBROUTINE SCANVC(V,VE,IE,NUMEL,LEN)
C
C THIS ROUTINE SCANS A VECTOR AND PLACES THE NUMEL LARGEST
C  ELEMENTS IN VE AND THEIR INDICES IN IE.
C
C INPUT:
C       V - THE VECTOR TO BE SEARCHED (LENGTH: LEN).
C      VE - THE VECTOR WHICH CONTAINS THE NUMEL LARGEST ABSOLUTE
C           VALUES IN V (LENGTH: LEN).
C      IE - THE INDICES CORRESPONDING TO THE ENTRIES IN VE (LENGTH: LEN).
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION V(LEN),VE(NUMEL),IE(NUMEL)
      CALL ZERO(VE,NUMEL)
      CALL IZERO(IE,NUMEL) 
      VE(1)=V(1)
      IE(1)=1
      DO 10 I=2,LEN,1
       IF(DABS(V(I)).GT.DABS(VE(NUMEL)))THEN
        DO 20 J=NUMEL,1,-1
         IF(DABS(V(I)).GT.DABS(VE(J)))JHIT=J
 20     CONTINUE
        CALL SHIFTV(VE,IE,JHIT,NUMEL)
        VE(JHIT)=V(I)
        IE(JHIT)=I
       ENDIF
10    CONTINUE
      RETURN
      END

c The following routines print out a matrix.  Because of the many ways that
c matrices are stored, this is a complicated set of tasks.
c
c Variables are:
c   mat    : an nrow x ncol rectangular matrix OR and nrow x nrow square
c            matrix
c   title  : a string containing the title
c   collab : a (short) label for columns
c   rowlab : a (short) label for rows
c   numwid : the width of each number when printed (W in fW.D)
c   ndec   : the number of decimal places to print (D in fW.D)
c   r0,r1  : the first/last row to print
c   c0,c1  : the first/last column to print
c   which  : 'U' or 'L' for upper/lower diagonal
c   diag   : 'D' or 'N' for inclusion or not of the diagonal

c The simplest sort of matrix is a rectangular matrix with all numbers
c stored and printing a rectangular part of the matrix.  The following
c two routines print all or part of a matrix.

      subroutine mat_print(mat,nrow,ncol,title,collab,rowlab,
     &                     numwid,ndec)
      implicit none
      integer nrow,ncol,numwid,ndec
      double precision mat(nrow,ncol)
      character*(*) title,collab,rowlab
      call mat_print_sub(mat,nrow,ncol,title,collab,rowlab,
     &                   numwid,ndec,1,nrow,1,ncol)
      return
      end

#include "flags.h"
      subroutine Wrt_Prim_Main(Icore, Icrsiz)
c
      implicit double precision (a-h,o-z)
      parameter (mxcoef=30)
c
#include "machsp.com"
#include "jodaflags.com"
#include "mxatms.par"
#include "baslims.par"
#include "offsets_2getden.com"
C
      character*32 szFile
      logical bExist
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Nocc(16), Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Coord(3*Mxatms), Norbits_fullG(Mxatms), 
     &          NOrbits_compG(Mxatms),Nbsfns_4irrep(8)
      Dimension Icore(Icrsiz)
C
      Data Ione, Ieight /1, 8/
C
      Iuhf = 1
      If (iflags(h_IFLAGS_ref).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Mxangmom = Nht
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      
      Call Getrec(-1, 'JOBARC', 'NUMDROPA', Length, Ijunk)       
      If (Length .GT. 0) Then 
         Print*, "Frozen-core is not allowed density plots"
         Call Errex
      Endif
c 
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(20, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'FULLNORB', Ione, Iful_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COMPNORB', Ione, Icmp_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Coord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(20, 'JOBARC', 'OCCUPYA ', Nirrep, Nocc(1))
      Call Getrec(20, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(20, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(20, 'JOBARC', 'NUMBASIR', Nirrep, Nbsfns_4irrep)
      Call Getrec(20, 'JOBARC', 'FULLPOPV', Iful_unq_atoms, 
     &            Norbits_fullG)
      Call Getrec(20, 'JOBARC', 'COMPPOPV', Icmp_unq_atoms, 
     &            Norbits_compG)
C
      nOCCa = 0
      Do Irrep = 1, Nirrep
         Nocca = Nocca + Nocc(Irrep)
      End Do
      If (Iuhf .EQ. 1) Then
         Call Getrec(20, 'JOBARC', 'OCCUPYB', Nirrep, Nocc(I+8)) 
         Noccb = 0
         Do Irrep = 1, Nirrep
            Noccb = Noccb + Nocc(8+I) 
         End Do
      Else
         Noccb = Nocca
      Endif 
C
      Call Getcrec(20, 'JOBARC', 'COMPPTGP', 4, Comp_pgrp)
      Call Getcrec(20, 'JOBARC', 'FULLPTGP', 4, Full_pgrp)
C
#ifdef _DEBUG_LVLM2
      print*, "Entering A2_PREP4_MOL_READ.."
      Write(6,"(4I4)") (Norbits_compG(i), i=1, Icmp_unq_atoms)
      Write(6,*)
      Write(6,"(4I4)"), (Norbits_fullG(i), i=1, Iful_unq_atoms)
#endif 
      Call A2_PREP4_MOL_READ(Icore, Maxcor, Natoms, Nbfns, 
     &                       Naobfns, Icmp_unq_atoms, 
     &                       Iful_unq_atoms, Coord, Iatmchrg,
     &                       Norbits_fullG, Norbits_compG, 
     &                       Mxshel, Mxangmom, Itot_prim, Iunqshl, 
     &                       Ntotshl, Max_prim_4atom, 
     &                       Max_prim_4shell, Inext)

#ifdef _DEBUG_LVLM2
      Write(6,*)
      Print*, "Offsets for various arrays initilized in Wrt_Prim_Main."
      Write(*, '(31I5)'), IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                   IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                   ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                   IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                   IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                   IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                   ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                   IPCOEFFB, IPCOEFF,ISCR1,ISCR2
C
      Write(6,*) 
      Print*, "The orbital exponents in main", Itot_prim, ialpha
      call output(icore(ialpha), 1, Itot_prim, 1, 1, 1, Itot_prim,
     &            1,1,1)  
      Print*, "The Contraction Coefs."
      call output(icore(ipcoeff), 1, Itot_prim, 1, Naobfns, Itot_prim,
     &            Naobfns, 1)
#endif
       Itype            = Inext
       Icnt_xyz         = Itype            + Itot_prim
       Inext            = Icnt_xyz         + 3*Itot_prim*Iintfp
       Ileft            = Maxcor - Inext

       If (INext .ge. Maxcor) Call Insmem("Write_primt_main", Inext, 
     &                                     Maxcor)
C
      Call Write_prims(Natoms, Itot_prim, Nbfns, Naobfns, Coord, 
     &                 Icore(Ialpha), Icore(Ipcoeff), Ntotshl,
     &                 Icore(Inprimshl), Icore(Iangmomshl), 
     &                 Icore(Iconfunshl), Icore(Iprmfunshl),
     &                 Icore(Icnt_xyz), Icore(Itype), Iatmchrg)
C
      Return
      End

c This function returns the number of doubles per column of an MOIO array.

c INPUT
c int ILEFT  : the left  index in MOIO
c int IRIGHT : the right index in MOIO

      integer function aces_list_rows(iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iLeft, iRight

c INTERNAL VARIABLES
      integer iTmp

c COMMON BLOCKS
#include "lists.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert iLeft and iRight are properly bound
      if ((iLeft .lt.1).or.(_MAX_IO_GRPS.lt.iLeft ).or.
     &    (iRight.lt.1).or.(_MAX_IO_FAMS.lt.iRight)    ) then
         print *, '@ACES_LIST_ROWS: Assertion failed.'
         print *, '   iLeft  = ',iLeft
         print *, '   iRight = ',iRight
         print *, '   MOIO rows = ',_MAX_IO_GRPS
         print *, '   MOIO cols = ',_MAX_IO_FAMS
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

      aces_list_rows = moiosz(iLeft,iRight)

      return
c     end function aces_list_rows
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE BULT_LANGCRD(CARTCOORD, BMATRX, ANGL, ICON1, ICON2, 
     &                        ICON3, ICON4, IANGS, NRATMS, TOTREDNCO,
     &                        EPSILON)
C
C Setup the angle bending B-matrix elements for linear bonds. In this case
C we must define two angle bend coordinates.
C
C Assuming that the projection is done on XY-plane. The Z-axis is the 
C perpendicular axis. Given r_i = r_ba and r_j = r_bc then SinG_ij =  
C (x_1*y_2 - y_1*x_2)/R_i*R_j
C
C B(*,a,*,*)(x) =0.0, B(*,*,*,c)(x) = 0.0, 
C B(*,*,b,*) = B(*,a,*,*) - B(*,*,*,c)
C B(*,a,*,*)(y) = -(z_a-z_b)/R_BA, B(*,a,*,*)(z) =  (y_a-y_b)/R_BA
C B(*,*,*,c)(y) =  (z_c-z_b)/R_BC, B(*,*,*,c)(z) = -(y_c-y_b)/R_BC
C B(*,*,b,*)(y) = B(*,a,*,*)(y) + B(*,*,*,c)(y)
C B(*,*,b,*)(z) = B(*,a,*,*)(z) + B(*,*,*,c)(z)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      INTEGER TOTREDNCO
      DIMENSION CARTCOORD(3*NRATMS), BMATRX(TOTREDNCO, 3*NRATMS),
     &          VECBA(3), VECBC(3), VECAC(3), VECX(3), VECY(3), 
     &          VECZ(3), VECBCX(3), VECBAX(3),  VECN2AC(3),
     &          VECBN2A(3), VECBN2B(3), VECW(3)

C
      DATA VECX /1,0,0/, VECY /0,1,0/, VECZ /0,0,1/
      DATA ZERO /0.0D0/
      DATA MONE /-1/
C
#ifdef _DEBUG_LVL0
          Write(6,*)
          Write(6, "(a)") "Entering the special linear angle block"
#endif
C
      DISTBA = DIST(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2))
      DISTBC = DIST(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2))
 
      CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON1 - 2), 
     &         VECBA, 1)
      CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2), 
     &         VECBC, 1)
      CALL VEC(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON3 - 2), 
     &         VECAC, 1)     
C
      CALL NORMAL(VECBA, 3)
      CALL NORMAL(VECBC, 3)
      CALL CROSS(VECBA, VECBC, VECN2AC, 0)
      CALL NORMAL(VECN2AC, 3)

#ifdef _DEBUG_LVL0
          Write(6, *)
          Write(6, *) "The normal vector"
          Write(6, "(a, 3F10.4)") "VECN2AC", (VECN2AC(I), I=1,3)
#endif
C
      CALL CROSS(VECBC, VECN2AC, VECW, 1)
      CALL CROSS(VECBC, VECW, VECBN2A, 1)
      CALL CROSS(VECW, VECBA, VECBN2B, 1)
C
#ifdef _DEBUG_LVL0
          Write(6, *)
          Write(6, *) "The basis vctors for special angles"
          Write(6, "(a, 3F10.4)") "VECBN2A", (VECBN2A(I), I=1,3)
          Write(6, "(a, 3F10.4)") "VECBN2B", (VECBN2B(I), I=1,3)
          Write(6,*)
#endif
C
      DO IXYZ = 1, 3
         BMATRX(IANGS, (3*ICON3 - 3) + IXYZ) =
     &                                 VECBN2A(IXYZ)/DISTBC
         BMATRX(IANGS, (3*ICON2 - 3) + IXYZ) =
     &                               - VECBN2A(IXYZ)/DISTBC
     &                               - VECBN2B(IXYZ)/DISTBA
         BMATRX(IANGS, (3*ICON1 - 3) + IXYZ) =
     &                                 VECBN2B(IXYZ)/DISTBA
      ENDDO
C
C Assign the perpendicular bond angle
C

      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0
      ANGL = 180.0D0*DINVPI

#ifdef _USE_OLD
      IAXIX = 0
      PRON_X = DABS(XDOT(3, VECX, 1, VECAC, 1))
      PRON_Y = DABS(XDOT(3, VECY, 1, VECAC, 1))
      PRON_Z = DABS(XDOT(3, VECZ, 1, VECAC, 1))
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(A)") "The projections along X, Y and Z axis"
      Write(6, "(3F10.5)") PRON_X, PRON_Y, PRON_Z
#endif
C
      IF (PRON_X .LT. EPSILON) THEN
C
C The molecule is in YZ plane, X-axis is the perpendicular axis for 
C one of the two angles
C 
         IF (PRON_Y .LT. EPSILON) THEN
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 1 
            ELSE
               IAXIX = 2
            ENDIF
         ENDIF
C         
         IF (PRON_Z .LT. EPSILON) THEN
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 1
            ELSE
               IAXIX = 3
            ENDIF
         ENDIF
C
      ELSE IF (PRON_Y .LT. EPSILON) THEN
C
C The molecule is in XZ plane, Y-axis  is the perpendicular axis for 
C one of the two angles
C
         IF (PRON_X .LT. EPSILON) THEN
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 2
            ELSE
               IAXIX = 1
            ENDIF
         ENDIF
C         
         IF (PRON_Z .LT. EPSILON) THEN
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 2
            ELSE
               IAXIX = 3
            ENDIF
         ENDIF
C
      ELSE IF (PRON_Z .LT. EPSILON) THEN
C
C The molecule is in XY plane Z-axis is the perpendicular axis for 
C one of the two angles
C
         IF (PRON_X .LT. EPSILON) THEN
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 3
            ELSE
               IAXIX = 1
            ENDIF
         ENDIF
C         
         IF (PRON_Y .LT. EPSILON) THEN
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 3
            ELSE
               IAXIX = 2 
            ENDIF
         ENDIF
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(a,a,i)") "The Iaxix after the projection logic",
     &                   " level 1:", IAXIX
      Write(6,*)
#endif
C
      ELSE
C
C Molecule is not in any of the above planes. We have to look at the 
C size of the projections on XY, YZ, XZ planes to decide axises.
C  
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(a,3F10.5)") "The AC vector",(VECAC(I), I=1,3)
      Write(6,*)
#endif
C     
         IF (DABS(VECAC(1)) .LT. DABS(VECAC(2)) .AND. DABS(VECAC(1))
     &       .LT. DABS(VECAC(3))) THEN            
C 
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 1
            ELSE
               IF (ABS(VECAC(2)) .LT. ABS(VECAC(3))) THEN
                  IAXIX = 2
               ENDIF
            ENDIF
C
         ELSE IF (ABS(VECAC(2)) .LT. ABS(VECAC(1)) .AND. ABS(VECAC(2))
     &            .LT. ABS(VECAC(3))) THEN            
C
            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 2
            ELSE
               IF (ABS(VECAC(1)) .LT. ABS(VECAC(3))) THEN
                  IAXIX = 1
               ENDIF
            ENDIF
C
         ELSE IF (ABS(VECAC(3)) .LT. ABS(VECAC(1)) .AND. ABS(VECAC(3)) 
     &            .LT. ABS(VECAC(2))) THEN            

            IF (ICON4 .EQ. MONE) THEN
               IAXIX = 3
            ELSE
               IF (ABS(VECAC(1)) .LT. ABS(VECAC(2))) THEN
                  IAXIX = 1
               ENDIF
            ENDIF
C
         ENDIF
C
      ENDIF
C
C Get the projection vectors on appropriate planes, That means setting the 
C the component of BA and BC vectors along the projection axis to zero!
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(a,i)") "The Iaxix after the projection logic:", IAXIX
      Write(6,*)
#endif     
      VECBA(IAXIX) = ZERO
      VECBC(IAXIX) = ZERO
      ANGL         = ZERO 
      DISTBA = DIST(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2))
      DISTBC = DIST(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2))
C     
      IF (IAXIX .EQ. 1) THEN
C
         CALL CROSS(VECX, VECBA, VECBAX, 0) 
         CALL CROSS(VECX, VECBC, VECBCX, 0) 
         BMATRX(IANGS, 3*ICON1 + 2) = -VECBAX(3)/DISTBA
         BMATRX(IANGS, 3*ICON3 + 2) =  VECBCX(3)/DISTBC
         BMATRX(IANGS, 3*ICON2 + 2) = -VECBAX(3)/DISTBA
     &                                +VECBCX(3)/DISTBC 
         BMATRX(IANGS, 3*ICON1 + 3) =  VECBAX(2)/DISTBA
         BMATRX(IANGS, 3*ICON3 + 3) = -VECBCX(2)/DISTBC
         BMATRX(IANGS, 3*ICON2 + 3) =  VECBAX(2)/DISTBA
     &                                -VECBCX(2)/DISTBC
C
      ELSE IF (IAXIX .EQ. 2) THEN
C
         CALL CROSS(VECY, VECBA, VECBAX, 0) 
         CALL CROSS(VECY, VECBC, VECBCX, 0) 
         BMATRX(IANGS, 3*ICON1 + 1) =  VECBAX(3)/DISTBA
         BMATRX(IANGS, 3*ICON3 + 1) = -VECBCX(3)/DISTBC
         BMATRX(IANGS, 3*ICON2 + 1) =  VECBAX(3)/DISTBA  
     &                                -VECBCX(3)/DISTBC
         BMATRX(IANGS, 3*ICON1 + 3) = -VECBAX(1)/DISTBA
         BMATRX(IANGS, 3*ICON3 + 3) =  VECBCX(1)/DISTBC
         BMATRX(IANGS, 3*ICON2 + 3) = -VECBAX(1)/DISTBA  
     &                                +VECBCX(1)/DISTBC
C
      ELSE IF (IAXIX .EQ. 3) THEN
C
         CALL CROSS(VECZ, VECBA, VECBAX, 0) 
         CALL CROSS(VECZ, VECBC, VECBCX, 0) 
         BMATRX(IANGS, 3*ICON1 + 1) =  VECBAX(2)/DISTBA
         BMATRX(IANGS, 3*ICON3 + 1) = -VECBCX(2)/DISTBC 
         BMATRX(IANGS, 3*ICON2 + 1) =  VECBAX(2)/DISTBA
     &                                -VECBCX(2)/DISTBC 
         BMATRX(IANGS, 3*ICON1 + 2) = -VECBAX(1)/DISTBA
         BMATRX(IANGS, 3*ICON3 + 2) =  VECBCX(1)/DISTBC
         BMATRX(IANGS, 3*ICON2 + 2) = -VECBAX(1)/DISTBA  
     &                                +VECBCX(1)/DISTBC
C
      ENDIF
#endif
C
      RETURN
      END
         

      SUBROUTINE T1T2AB1(ZT,Z1,W,Z,TA,TB,POP1,POP2,VRT1,VRT2,DISSYZ,
     &                   DISSYWA,DISSYWB,NUMSYZ,NUMSYWA,NUMSYWB,
     &                   NTASIZ,NTBSIZ,LISTZ,LISTWA,LISTWB,IRREP,
     &                   IUHF,TMP)
C
C PRIMITIVE CONTRACTION ROUTINE FOR T2<-T1
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSYZ,DISSYWA,DISSYWB,DIRPRD,POP1,POP2,VRT1,VRT2
      DIMENSION Z(DISSYZ,NUMSYZ),W(DISSYWA,1),TA(NTASIZ)
      DIMENSION ZT(NUMSYZ,DISSYZ),Z1(DISSYZ,NUMSYZ),TB(NTBSIZ)
      DIMENSION TMP(1),POP1(8),POP2(8),VRT1(8),VRT2(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
C
      DATA AZERO,ONE,ONEM /0.0D0,1.0D0,-1.0D0/
C
      CALL ZERO(ZT,NUMSYZ*DISSYZ)
C
C   GET INTEGRALS <Ij//Am> FROM (LISTWA1,LISTWA2)
C
C   NOTE IN THE RHF CASE WE GET ACTUALLY THE INTEGRALS <Ij//Ma>
C   WE TRANSPOSE THEM AND TRANSPOSE AS WELL THE RESULT
C
      IF(MIN(NUMSYWA,DISSYWA).NE.0) THEN
      CALL GETLST(W,1,NUMSYWA,2,IRREP,LISTWA)
      IF(IUHF.EQ.0) THEN
       CALL SYMTR1(IRREP,POP1,VRT2,DISSYWA,W,TMP,TMP(1+DISSYWA),
     &             TMP(1+2*DISSYWA))
      ENDIF
C
C   PERFORM MULTIPLICATION
C
      JOFFW=1
      JOFFZ=1     
      IOFF=1
      DO 90 IRREPJ=1,NIRREP
C
       NOCCJ=POP2(IRREPJ)
       NVRTJ=VRT2(IRREPJ)
C
       IRREPI=DIRPRD(IRREPJ,IRREP)
C
       NVRTI=VRT1(IRREPI)
C
       IF(NVRTI.EQ.0) GO TO 80 
C
       IF(NOCCJ.EQ.0) GO TO 80
C
       CALL XGEMM('N','T',DISSYWA*NVRTI,NVRTJ,NOCCJ,ONEM,W(1,JOFFW), 
     &            DISSYWA*NVRTI,TB(IOFF),NVRTJ,
     &            AZERO,ZT(1,JOFFZ),NUMSYZ*NVRTI)
C
       JOFFW=JOFFW+NVRTI*NOCCJ
80     CONTINUE
       JOFFZ=JOFFZ+NVRTI*NVRTJ
       IOFF=IOFF+NVRTJ*NOCCJ
90    CONTINUE
      ENDIF
C
      IF(IUHF.EQ.0) THEN
      IF(MIN(NUMSYWA,DISSYWA).EQ.0) RETURN
C
C   IN RHF THIS IS SIMPLY A TRANSPOSITION
C
       CALL SYMTRA(IRREP,VRT2,VRT1,NUMSYZ,ZT,Z)
       CALL TRANSP(Z,Z1,DISSYZ,NUMSYZ)
       CALL GETLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
       CALL VADD(Z,Z,Z1,NUMSYZ*DISSYZ,ONE)
       CALL SYMTR1(IRREP,POP1,POP2,DISSYZ,Z1,TMP,TMP(1+DISSYZ),
     &            TMP(1+2*DISSYZ))
       CALL SYMTR3(IRREP,VRT1,VRT2,DISSYZ,NUMSYZ,Z1,TMP,
     &             TMP(1+NUMSYZ),TMP(1+2*NUMSYZ))
       CALL VADD(Z,Z,Z1,NUMSYZ*DISSYZ,ONE)
       CALL PUTLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
    
      ELSE
       CALL SYMTR1(IRREP,VRT1,VRT2,NUMSYZ,ZT,TMP,TMP(1+NUMSYZ),
     &             TMP(1+2*NUMSYZ))
       IF(MIN(NUMSYWB,DISSYWB).NE.0) THEN
C
C   GET INTEGRALS <Ij//Mb> FROM (LISTWB1,LISTWB2)
C
      CALL GETLST(W,1,NUMSYWB,2,IRREP,LISTWB)
      CALL SYMTR1(IRREP,POP1,VRT2,DISSYWB,W,TMP,TMP(1+DISSYWB),
     &            TMP(1+2*DISSYWB))
C
       JOFFZ=1  
       JOFFW=1   
       IOFF=1
       DO 190 IRREPI=1,NIRREP
C
        NOCCI=POP1(IRREPI)
        NVRTI=VRT1(IRREPI)
C
C
        IRREPJ=DIRPRD(IRREPI,IRREP)
C
        NVRTJ=VRT2(IRREPJ)
C
C
        CALL XGEMM('N','T',DISSYWB*NVRTJ,NVRTI,NOCCI,ONEM,W(1,JOFFW), 
     &             NVRTJ*DISSYWB,TA(IOFF),NVRTI,
     &             ONE,ZT(1,JOFFZ),NVRTJ*NUMSYZ)
C
        JOFFZ=JOFFZ+NVRTJ*NVRTI
        JOFFW=JOFFW+NVRTJ*NOCCI
        IOFF=IOFF+NVRTI*NOCCI
190    CONTINUE
       ENDIF
       CALL SYMTRA(IRREP,VRT2,VRT1,NUMSYZ,ZT,Z)
       CALL TRANSP(Z,Z1,DISSYZ,NUMSYZ)
       CALL GETLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
       CALL VADD(Z,Z,Z1,NUMSYZ*DISSYZ,ONE)
       CALL PUTLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
       ENDIF
       RETURN
       END

      SUBROUTINE SYMUNQ(NATOM,IORDGP,IATNUM,SYMOPS,IPTR,
     &IATLST,MEMBER,TRNMAT,ORBPOP,IORBIT,PTGRP)
C
C ARRAYS:
C
C  MEMBER  -  GIVES ATOM LIST GROUPED ACCORDING TO ORBITS.
C  TRNMAT(I)- GIVES INDEX OF SYMOP WHICH MAPS THE REFERENCE ATOM FOR
C              THE ORBIT TO WHICH I BELONGS INTO I.
C  ORBPOP(I)- THE POPULATION OF ORBIT(I).
C
C
C THIS ROUTINE GROUPS THE ATOMS INTO SYMMETRY EQUIVALENT SETS.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
      COMMON /LOCAL/ STSYM(MXATMS)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
 
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      CHARACTER*4 PTGRP
      CHARACTER*8 STSYM,SITGRP
      INTEGER TRNMAT(NATOM),CHKINT,IATNUM(NATOM),
     &MEMBER(NATOM),ORBPOP(NATOM)
      LOGICAL FULGRP
      DIMENSION SYMOPS(9*IORDGP),IPTR(NATOM,IORDGP),IATLST(NATOM)
      IP(I)=1+9*(I-1)
      FULGRP=.FALSE.
      IF(FPGRP(2:2).EQ.'X'.AND.PTGRP(2:2).EQ.'8'.AND.FPGRP(1:1).EQ.
     &   PTGRP(1:1).OR.PTGRP.EQ.FPGRP)FULGRP=.TRUE.
      IORBIT=0
      CALL IZERO(IATLST,NATOM)
      CALL IZERO(TRNMAT,NATOM)
C
C SET ALL DUMMY ATOM POSITIONS TO 999.
C
      DO 5 I=1,NATOM
       IF(IATNUM(I).EQ.0)IATLST(I)=999
5     CONTINUE
C
C FIND FIRST ZERO IN IATLST AND USE THIS AS THE POSITION FOR THE
C  REFERENCE ATOM OF ORBIT IORBIT.
C
      ICOUNT=0
 1    IREF=CHKINT(IATLST,NATOM,0)
      JCOUNT=0
      IF(IREF.EQ.0)GOTO 999
      IORBIT=IORBIT+1
C
C CREATE TRNMAT AND MEMBER LISTS FOR THIS PARTICULAR ORBIT.
C
      CALL FRMLST(NATOM,IREF,IORBIT,IORDGP,TRNMAT,IATLST,IPTR,
     &                  MEMBER,ICOUNT,JCOUNT)
      ORBPOP(IORBIT)=JCOUNT
      GOTO 1
C
C NOW WRITE OUT TRANSFORMATION MATRICES, POINTER LISTS AND TRNMAT
C  LIST TO DISK FOR LATER PICKUP.  PUT TRNMAT AND MEMBER ON A
C  SEPARATE RECORD SINCE THEY COULD BE CHANGED IN PIKXYZ IF THE
C  REFERENCE ATOM FOR A PARTICULAR ORBIT IS NOT THE FIRST MEMBER
C  IN Z-MATRIX ORDERING.
C
999   DO 153 I=1,IORDGP
C       CALL MTRAN2(SYMOPS(IP(I)),3)
153   CONTINUE
C
C WRITE THIS STUFF ONLY IF THE CALCULATION IS A FINITE DIFFERENCE
C  CALC. AND FDARC IS NOT THERE.
C
      IF(IVIB.EQ.2.AND.FULGRP)THEN
       OPEN(UNIT=15,FILE='FDARC',FORM='UNFORMATTED',
     &     STATUS='UNKNOWN')
       REWIND(15)
       WRITE(15)NATOM,IORDGP,IORBIT,ORBPOP,SYMOPS,IPTR
       WRITE(15)MEMBER,TRNMAT
       CLOSE(UNIT=15,STATUS='KEEP')
      ENDIF
C
C WRITE OUT THIS INFORMATION FOR FINDIF ONLY.
C
      IF(IPRNT.GE.5.OR.(IVIB.EQ.2.AND.FULGRP))
     &THEN
       WRITE(LUOUT,8080)IORBIT,PTGRP
8080   FORMAT(T3,'@SYMUNQ-I, There are ',I3,' orbits in the ',
     &          A,' point group.')
       CALL IZERO(TRNMAT,NATOM)
       WRITE(LUOUT,9000)
       WRITE(LUOUT,5002)
       WRITE(LUOUT,9000)
5002   FORMAT(T5,'Set',T11,' Site Group',T45,'Members of set')
      ENDIF
      ICOUNT=0
      IOFF=0
      DO 30 I=1,IORBIT
       NORBIT=ORBPOP(I)
 
C
C GET SITE GROUP FOR ORBIT
C
       STSYM(I)=SITGRP(PTGRP,IORDGP,ORBPOP(I))//'    '
       IF(STSYM(I)(1:3).EQ.'XXX')THEN
C
C THIS IS EITHER C2h OR Dnd, FOR WHICH THE SITE GROUP MUST
C   BE EITHER Cs OR C2.  FIGURE THIS OUT NOW.
C
        CHRMIN=10.D0
        DO 55 IOP=1,IORDGP
         IREFER=MEMBER(IOFF+1)
         IF(IPTR(IREFER,IOP).EQ.IREFER)THEN
          CHRMIN=MIN(CHRMIN,TRACE(SYMOPS(IP(IOP)),3))
         ENDIF
55      CONTINUE
        STSYM(I)(1:4)='C2  '
        IF(CHRMIN+0.9D0.GT.0.D0)STSYM(I)(1:4)='C s '
       ENDIF
C
C GO ON.
C
       IF((IVIB.EQ.2.AND.FULGRP).OR.IPRNT.GT.5)
     & WRITE(LUOUT,5001)I,STSYM(I)(1:3),(MEMBER(IOFF+K),K=1,NORBIT)
5001   FORMAT(T5,I3,T14,A,(T30,15I3,/))
       IOFF=IOFF+ORBPOP(I)
 30   CONTINUE
      IF(IPRNT.GT.5.OR.(IVIB.EQ.2.AND.FULGRP))
     &WRITE(LUOUT,9000)
9000  FORMAT(72('-'))
      RETURN
      END

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It returns the size of used numerical grid                   |     
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|
      subroutine get_grid_size(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)


c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'F12.h'
      include 'F12_gr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

c---------------Variables--------------------------------------------

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array
      integer op(loptable_entry),sind
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block

      integer array_type, nindex, inda(2), indb(2)

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, farray, indblk, get_block_index
      integer*8 integral_scr
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack

      double precision x(1),int_type_p
      double precision dbuf(1), temp
      integer ibuf(1)
      integer int_type
c----------------------------------------------------------------------
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      array = op(c_result_array)

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c-------------------------------------------------------------------
        
c-------------------------------------------------------------------

c--------------------------------------------------------------------

c------------Information about scalar--------------------------------------

      array = op(c_result_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The Second argument in get_ijk  
     *            must be a scalar.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in get_ijk, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

      scalar_table(sind) = NPT

c---------------------------------------------------------------------------
c   Compute the block of integrals.
c---------------------------------------------------------------------------

c         if (intpkg .eq. flocke_package) then
c            integral_scr = dpkgscr
c            maxblk  = zmax
c         else if (intpkg .eq. gamess_package .or.
c     *            intpkg .eq. gamess_derivative_package) then
c            integral_scr = i0wrk
c            maxblk = 15**4    ! max. angular momentum for GAMESS is 15.
c         endif



      return
      end

c This routine changes the number of doubles per column of one array (irrep)
c in an MOIO family. The array may only have one column (like T1(A,I)).
c    This is really a shameful routine. The entire list processing subsystem
c forces the caller to retrieve at least one entire column of an array.
c However, some programmers do not feel the need to work around this
c 'feature' and instead change the size/length of the array depending
c on the data that is stored there. We use a 'private' common block
c to hold the original length of the array (set in aces_list_touch).
c If a caller attempts to resize above the original length, the program
c will die. People should consider better algorithms...

c INPUT
c int ILEFT  : the left  index in MOIO
c int IRIGHT : the right index in MOIO
c int ISIZE  : the number of doubles per column

      subroutine aces_list_resize(iLeft,iRight,iSize)
      implicit none

c ARGUMENTS
      integer iLeft, iRight, iSize

c INTERNAL VARIABLES
      integer iTmp

c COMMON BLOCKS
#include "lists.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_LIST_RESIZE: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iTmp = 1
      end if
c   o assert iLeft and iRight are properly bound
      if ((iLeft .lt.1).or.(_MAX_IO_GRPS.lt.iLeft ).or.
     &    (iRight.lt.1).or.(_MAX_IO_FAMS.lt.iRight)    ) then
         print *, '@ACES_LIST_RESIZE: Assertion failed.'
         print *, '   iLeft  = ',iLeft
         print *, '   iRight = ',iRight
         print *, '   MOIO rows = ',_MAX_IO_GRPS
         print *, '   MOIO cols = ',_MAX_IO_FAMS
         iTmp = 1
      end if
c   o assert iSize is whole
      if (iSize.lt.0) then
         print *, '@ACES_LIST_RESIZE: Assertion failed.'
         print *, '   iSize = ',iSize
         iTmp = 1
      end if
c   o assert the new data is <= the initialized data
      if ((iSize*moiods(iLeft,iRight)).gt.
     &         moiomxsz(iLeft,iRight)     ) then
         print *, '@ACES_LIST_RESIZE: Assertion failed.'
         print *, '   nCols = ',moiods(iLeft,iRight)
         print *, '   nRows = ',moiosz(iLeft,iRight)
         print *, '   iSize = ',iSize
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o assign the new column length
      moiosz(iLeft,iRight) = iSize

cYAU - There should be an isytyp modifier here as well; however, most one-
c      dimensional arrays are tacked onto the end of some other family.
c      isytyp(1,iRight) = ???

c   o mark MOIO as modified
      bIOMod = .true.

      return
c     end subroutine aces_list_resize
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE GET_MOPAC_HESS(A, SCRATCH, IMAP, HC, HI, AT, NATOMS,
     &                          NX, NXM6, NREAL, NREAL3, NREAL3M6)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "machsp.com"
#include "fnamelen.par"
#include "io_units.par"

      DOUBLE PRECISION HC(NX*NX),SCRATCH(NX*NX), A(NX*NXM6),
     &                 AT(NXM6*NX), HI(NXM6, NXM6)
      INTEGER IMAP(NATOMS)
      COMMON /OPTCTL/ IPRNT, INR, IVEC, IDIE, ICURVY, IMXSTP, ISTCRT,
     &                IVIB, ICONTL, IRECAL, INTTYP, IDISFD, IGRDFD,
     &                ICNTYP, ISYM, IBASIS, XYZTol
      CHARACTER*(fnamelen) FNAME
      PARAMETER (IMOPAC_UNIT = 99)

      CALL GFNAME('NDDO_HES',FNAME, ILENGTH)
      OPEN(UNIT=IMOPAC_UNIT, FILE=FNAME(1:ILENGTH), FORM=
     &     "UNFORMATTED", STATUS="OLD")

      LTRIN = NREAL*3 *(NREAL*3 + 1)/2
      READ(IMOPAC_UNIT) (SCRATCH(I), I=1, LTRIN)
      CALL EXPND2(SCRATCH, HC, NREAL3)
c      Print*, "The Hessian just read from MOPAC"
CSSS      CALL OUTPUT(SCRATCH, 1, NREAL3, 1, NREAL3, NREAL3,
CSSS     &            NREAL3, 1)

C Take care of the cases that invlove dummy or ghost atoms.
      NDUMMYN = NX*NX
      IF (NREAL3.NE.NX) THEN
         NREALN  = NREAL3*NREAL3
         CALL ZERO(SCRATCH, NDUMMYN)
         CALL IGETREC(1,'JOBARC','MAP2ZMAT',NATOMS,IMAP)
         IOFF = 1
         DO IATREL = 1, NATOMS
            IATMZMAT = IMAP(IATREL)
            DO IXYZ = 1, 3
               ICOL = IXYZ + (IATMZMAT-1)*3
               DO JATREL = 1, NATOMS
                  JATMZMAT = IMAP(JATREL)
                  IF (IATMZMAT .NE.0 .AND. JATMZMAT .NE. 0) THEN
                     IROW = 1 + (JATMZMAT-1)*3
                     CALL BLKCPY(HC(IOFF), 3, 1, SCRATCH, NX,
     &                           NX, IROW, ICOL)
                     IOFF = IOFF + 3
                  END IF
               END DO
            END DO
         END DO
         CALL DCOPY(NDUMMYN, SCRATCH, 1, HC, 1)
      END IF

C According to Keith Runge, the MOPAC Hessian is in mdynes/picometer.
C The conversion factor was provided by him.  Priv. comm.  12/2004
C
      CONVERT_TO_AU = (6.2414D0/27.2113957D0)*
     &                (1.0D0/0.529177249D0)**2
      CALL DSCAL(NDUMMYN, CONVERT_TO_AU, HC, 1)
C
C Convert to internal coordinates using the A matrix.
C
      CALL MODMATMUL(SCRATCH,HC,A,NX,NX,NXM6,NX,NX,NXM6)
      CALL MTRANSP(A,AT,NX,NXM6,NX,NXM6)
      CALL MODMATMUL(HI,AT,SCRATCH,NXM6,NX,NXM6,NXM6,NX,NXM6)

      IF (IPRNT.GE.10) THEN
         WRITE(LUOUT,110)
 110     FORMAT(T3,' @GET_MOPAC_HESS, Full Cartesian Hessian: ')
         CALL OUTPUT(HC, 1, NX, 1, NX, NX, NX, 1)
         Write(Luout, 111)
 111     FORMAT(T3,' @GET_MOPAC_HESS, Full internal coordinate
     & Hessian: ')
          CALL OUTPUT(HI, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
      END IF
      CLOSE(IMOPAC_UNIT)

      RETURN
      END

      SUBROUTINE DEANG(CARTCOORD,M,O,N,BMATRX,NRATMS,TOTREDNCO,IREDUNCO,
     &                MAXREDUNCO,IANGS,DERBMAT)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      DOUBLE PRECISION LU,LV
      INTEGER A,B,M,O,N,NRATMS,TOTREDNCO,IREDUNCO,MAXREDUNCO,IANGS
      DIMENSION CARTCOORD(3*NRATMS),VECU(3),VECV(3),
     &          IREDUNCO(4,MAXREDUNCO),BMATRX(TOTREDNCO,3*NRATMS),
     &          DERBMAT(3*NRATMS,3*NRATMS*TOTREDNCO)

      CALL VEC(CARTCOORD(3*O-2),CARTCOORD(3*M-2),VECU,1)
      CALL VEC(CARTCOORD(3*O-2),CARTCOORD(3*N-2),VECV,1)

      LU = DIST(CARTCOORD(3*O-2),CARTCOORD(3*M-2))
      LV = DIST(CARTCOORD(3*O-2),CARTCOORD(3*N-2))
      COSQ= DDOT(3,VECU,1,VECV,1)
      SINQ= DSQRT(1-(COSQ**2))
      D1 = (LU**2)*SINQ
      D2 = (LV**2)*SINQ
      D3 = (LU*LV)*SINQ

CSSS      print *,'*****Entering DEANG*****'
CSSS      print *,'vecu',vecu(1),vecu(2),vecu(3)
CSSS      print *,'vecv',vecv(1),vecv(2),vecv(3)
CSSS      PRINT *,'MON',M,O,N
CSSS      Print *, "SINQ,COSQ", SINQ, COSQ

      DO 10 I=1,3
         BM1=BMATRX(IANGS,(3*O-3)+I)
         BM2=BMATRX(IANGS,(3*M-3)+I)
         BM3=BMATRX(IANGS,(3*N-3)+I)
      DO 20 J=1,3
         BM4=BMATRX(IANGS,(3*O-3)+J)
         BM5=BMATRX(IANGS,(3*M-3)+J)
         BM6=BMATRX(IANGS,(3*N-3)+J)
C MM TERM
         BMMM=(COSQ/SINQ)*BM5*BM2
C OO TERM
         BMOO=(COSQ/SINQ)*BM4*BM1
C NN TERM
         BMNN=(COSQ/SINQ)*BM6*BM3
C MO TERM
         BMMO=(COSQ/SINQ)*BM4*BM2
C NO TERM
         BMNO=(COSQ/SINQ)*BM4*BM3
C MN TERM
         BMMN=(COSQ/SINQ)*BM6*BM2

         T1= (VECU(I)*VECV(J)+VECU(J)*VECV(I)-3.0D0*VECU(I)
     &       *VECU(J)*COSQ+DELTA(I,J)*COSQ)/D1
         T2= (VECV(I)*VECU(J)+VECV(J)*VECU(I)-3.0D0*VECV(I)
     &       *VECV(J)*COSQ+DELTA(I,J)*COSQ)/D2
         T3= (VECU(I)*VECU(J)+VECV(J)*VECV(I)-VECU(I)*VECV(J)*COSQ-
     &       DELTA(I,J))/D3
         T4= (VECV(I)*VECV(J)+VECU(J)*VECU(I)-VECV(I)*VECU(J)*COSQ-
     &       DELTA(I,J))/D3

C Diagonal Terms
C  11
         DERBMAT((O-1)*3+I,3*NRATMS*(IANGS-1)+(O-1)*3+J)=
     &          t1+t2+t3+t4-BMOO
C  22
         DERBMAT((M-1)*3+I,3*NRATMS*(IANGS-1)+(M-1)*3+J)=
     &          t1-BMMM
C  33
         DERBMAT((N-1)*3+I,3*NRATMS*(IANGS-1)+(N-1)*3+J)=
     &          t2-BMNN

C  Offdiagonal Term
C  23
         DERBMAT((M-1)*3+I,3*NRATMS*(IANGS-1)+(N-1)*3+J)=
     &          t3-BMMN

         DERBMAT((N-1)*3+J,3*NRATMS*(IANGS-1)+(M-1)*3+I)=
     &   DERBMAT((M-1)*3+I,3*NRATMS*(IANGS-1)+(N-1)*3+J)
C  21
         DERBMAT((M-1)*3+I,3*NRATMS*(IANGS-1)+(O-1)*3+J)=
     &           -t1-t3-BMMO
         DERBMAT((O-1)*3+J,3*NRATMS*(IANGS-1)+(M-1)*3+I)=
     &   DERBMAT((M-1)*3+I,3*NRATMS*(IANGS-1)+(O-1)*3+J)
C  31
         DERBMAT((N-1)*3+I,3*NRATMS*(IANGS-1)+(O-1)*3+J)=
     &           -t2-t4-BMNO
         DERBMAT((O-1)*3+J,3*NRATMS*(IANGS-1)+(N-1)*3+I)=
     &   DERBMAT((N-1)*3+I,3*NRATMS*(IANGS-1)+(O-1)*3+J)

  20  CONTINUE
  10  CONTINUE

CSSS       print *,'DERIVATIVE OF THE BMAT FOR ATOMS',M,O,N
CSSS       CALL OUTPUT(DERBMAT,1,3*NRATMS,3*NRATMS*(IANGS-1)+1,
CSSS     &              3*NRATMS*(IANGS-1)+3*NRATMS,3*NRATMS,
CSSS     &              3*NRATMS*TOTREDNCO,1)

      RETURN
      END

C THIS ROUTINE INITIALIZES ALL RECORDS IN THE JOBARC FILE, STARTING
C AFTER THE EXISTING RECORD SPECIFIED BY THE LABEL WHICH IS PASSED IN

      SUBROUTINE ZEROJA(LABEL)
      IMPLICIT INTEGER (A-Z)
      CHARACTER*8 LABEL
      CHARACTER*8 MARKER
      PARAMETER (LENGTH = 1000)
      COMMON /JOBARC/ MARKER(LENGTH),LOC(LENGTH),SIZE(LENGTH),NRECS,
     &                IRECWD,IRECLN

      IPOS = LOCCHR(LENGTH,MARKER,1,LABEL) + 1
      IF (IPOS.EQ.LENGTH+1) RETURN

      CALL IZERO(LOC(IPOS),LENGTH-IPOS+1) 
      CALL IZERO(SIZE(IPOS),LENGTH-IPOS+1) 
      DO I = IPOS, LENGTH
         MARKER(I) = 'OPENSLOT'
      END DO

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine contract_oed_derv_integrals(type, density, z,
     *                       da1, da2, db1, db2)
c---------------------------------------------------------------------------
c  Computes the set of OED derivative integrals matching "type" and 
c  and contracts them with density block (da1:da2, db1:db2).
c
c   type = 1 --> NAI integrals
c          2 --> KIN integrals
c          3 --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer type
      integer da1, da2, db1, db2
      double precision density(da1:da2, db1:db2)
      double precision z(da1:da2, db1:db2)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif
      integer i, ix, m, n, nfirst, nints, nalpha, ncoeff, iatom, ncsum
      integer component
      integer a, b, a1,a2,b1,b2,lastao, igrad
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc
      integer ind(2)
      integer flopcount
      logical spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, y
c
c ECP derivative integrals 
c 
      integer natoms 
c     double precision decp_erd 
c     common /DECP/natoms, decp_erd(50,3,1000,1000) 

      common /flags/ iflags
      integer iflags(100)

      if (type .lt. 1 .or. type .gt. 3) then
         print *,'Error: Invalid type in contract_oed_integrals'
         print *,'type = ',type
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      spherical = (ispherical .eq. 1)
      lastao    = end_nfps(nshells)

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: contract_oed_derv_integrals requires ERD ',
     *           'integral package.'
call abort_job()
      endif

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block of density data.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)
      
c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       do m = m1, m2
       do n = n1, n2

            ncsum = ncfps(m) + ncfps(n) 
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)
 
            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend), 
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

       if (type .eq. 1) then 

c loop over derivatives on centers 

         do ixderc = 1, ncenters 

            iatom = ixderc 
 
            do component = 1, 3   ! component is x, y, or z term of gradient

c-------------------------------------------------------------------------
c   Clear the integral block.
c-------------------------------------------------------------------------

               do b = db1, db2
               do a = da1, da2
                  z(a,b) = 0.
               enddo
               enddo
c--------------------------------------------------------------------------

c-------------------------------------------------------------------------
c   Initialize the derivative array.
c-------------------------------------------------------------------------

               der1x = 0 
               der1y = 0 
               der1z = 0 
               der2x = 0 
               der2y = 0 
               der2z = 0 

               dercx  = 0 
               dercy  = 0 
               dercz  = 0 

c-------------------------------------------------------------------------
c   Set the derivative array.
c-------------------------------------------------------------------------

               if (component .eq. 1) dercx = 1 
               if (component .eq. 2) dercy = 1 
               if (component .eq. 3) dercz = 1 

               if (ixderc .eq. atom(m)) then 
                  if (component .eq. 1) der1x = 1 
                  if (component .eq. 2) der1y = 1 
                  if (component .eq. 3) der1z = 1 
               endif 

               if (ixderc .eq. atom(n)) then 
                  if (component .eq. 1) der2x = 1 
                  if (component .eq. 2) der2y = 1 
                  if (component .eq. 3) der2z = 1 
               endif 

               call oed__gener_nai_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 ncenters, xn,yn,zn, charge, ixderc,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, 
     *                 dercx, dercy, dercz, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst, 
     *                 dbuf(dpkgscr))     

               if (nints .gt. 0) then
                  a2 = end_nfps(m)
                  if (m .eq. 1) then
                     a1 = 1
                  else
                     a1 = end_nfps(m-1)+1
                  endif

                  b2 = end_nfps(n)
                  if (n .eq. 1) then
                     b1 = 1
                  else
                     b1 = end_nfps(n-1)+1
                  endif

                 call move_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)
c--------------------------------------------------------------------------
c   If ECP add ecp derivative integrals  
c                 if (iflags(71) .eq. 1) then  
c                 do a = a1, a2 
c                 do b = b1, b2 
c                    z(a,b) = z(a,b) + decp_erd(iatom, component, a, b) 
#ifdef _DEBUG_LVL0
c                 Write(6,"(a)") "Adding ECP derivative integrals"
c                 Write(6,"(1x, 2I3, 1x,f12.7)") a, b, decp_erd(iatom,
c    *                                    component, a, b)
#endif
c                 enddo 
c                 enddo 
c                 endif 
c
c--------------------------------------------------------------------------
c   Contract the density block with the block of integrals.
c--------------------------------------------------------------------------

                 call cwork0222(y,
     *                          density,da1,da2,db1,db2,
     *                          da1,da2,db1,db2, ind,
     *                          z,da1,da2,db1,db2,
     *                          da1,da2,db1,db2,ind(1), ind(2),
     *                          flopcount)

c---------------------------------------------------------------------------
c   Sum into the gradient.
c---------------------------------------------------------------------------

                igrad = (iatom-1)*3 + component 
                gradient_data(igrad) = gradient_data(igrad) + y

               endif ! nints 

            enddo ! component
            enddo ! ixderc  
         endif ! type = 1 

       if (type .eq. 2 .or. type .eq. 3) then 

c loop over derivatives on centers

         do component = 1, 3   ! component is x, y, or z term of gradient
         do ix = 1, 2          ! index of desired center

c-------------------------------------------------------------------------
c   Clear the integral block.
c-------------------------------------------------------------------------

          do b = db1, db2
          do a = da1, da2
             z(a,b) = 0.
          enddo
          enddo


             der1x = 0
             der1y = 0
             der1z = 0
             der2x = 0
             der2y = 0
             der2z = 0

             ixderc = 0
             dercx  = 0
             dercy  = 0
             dercz  = 0

             if (component .eq. 1) then
                if (ix .eq. 1) then
                   der1x = 1
                   if (atom(m) .eq. atom(n)) der2x = 1
                   iatom = atom(m)
                else
                   der2x = 1
                   if (atom(m) .eq. atom(n)) der1x = 1
                   iatom = atom(n)
                endif
             endif

             if (component .eq. 2) then
                if (ix .eq. 1) then
                   der1y = 1
                   if (atom(m) .eq. atom(n)) der2y = 1
                   iatom = atom(m)
                else
                   der2y = 1
                   if (atom(m) .eq. atom(n)) der1y = 1
                   iatom = atom(n)
                endif
             endif

             if (component .eq. 3) then
                if (ix .eq. 1) then
                   der1z = 1
                   if (atom(m) .eq. atom(n)) der2z = 1
                   iatom = atom(m)
                else
                   der2z = 1
                   if (atom(m) .eq. atom(n)) der1z = 1
                   iatom = atom(n)
                endif
             endif

               if (type .eq. 2) then
                  call oed__gener_kin_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               else if (type .eq. 3) then
                  call oed__gener_ovl_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,spherical,
     *                 .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               endif

            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

                call move_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)

c--------------------------------------------------------------------------
c   Contract the density block with the block of integrals.
c--------------------------------------------------------------------------

               call cwork0222(y,
     *                        density,da1,da2,db1,db2,
     *                        da1,da2,db1,db2, ind,
     *                        z,da1,da2,db1,db2,
     *                        da1,da2,db1,db2,ind(1), ind(2),
     *                        flopcount)

c---------------------------------------------------------------------------
c   Sum into the gradient.
c---------------------------------------------------------------------------

              igrad = (iatom-1)*3 + component
              gradient_data(igrad) = gradient_data(igrad) + y

             endif

         enddo ! ix
         enddo ! component

         endif ! ktype = 2,3

         enddo   ! n shells
         enddo   ! m shells

      return
      end

      Integer Function IOrGrp ( PtGrp )
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Purpose:
C     Return the order of the given point group
C
C Arguments:
C     PtGrp    String containing the Schoenflies symbol for the
C              group of interest. (input)
C              The order must begin with the second character of PtGrp.
C              The last non-blank character is taken to be the "modifier"
C              in the group symbol. It may be in upper- or lowercase.
C              A group of infinite order is denoted with an 'X' for the
C              order.
C
C Returns:
C     IOrGrp   Returns the order of the group.
C              In case of error, returns error codes a follows:
C              = -1  Unrecognizable point group
C
C Dependents:
C     AtoI     Converts string to integer
C     linblnk   Returns the index of the last non-blank character
C
C Bugs:
C     Since most machines can't actually handle a value of infinity,
C     infinite groups return >= 1,000,000 - which should be suitably
C     large to clue someone in.  Recall that Ih is order 120.
C
C     Doesn't check the modifier against the group - thus things like
C     C4d won't be flagged as an error.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Implicit Integer (A-Z)
      Character*(*) PtGrp
      Integer AtoI, linblnk
C
C     PGMod is the "modifier" lifted from the name
C
      Character*1 PGMod
C
C     Get the "modifier" from the end of the symbol
C
      i = linblnk(PtGrp)
      PGMod = PtGrp(i:i)
C
C     Figure out the order of the axis.  If there is no number 
C     there, AtoI returns 0
C
      OrdAx = AtoI( PtGrp(2:) )
C
C     Assume the symbol is bad.  If it isn't, it will be changed
C     as we go through everything.  Otherwise, this is the right
C     thing to return.
C     
      IOrGrp = -1
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Now check for the cubics & other groups without explicit orders
C     in the Schoenflies symbol.
C
      If (OrdAx .eq. 0) then
         If (PtGrp(1:1) .eq. 'T') then
            IOrGrp = 12
         ElseIf (PtGrp(1:1) .eq. 'O') then
            IOrGrp = 24
         ElseIf (PtGrp(1:1) .eq. 'I') then
            IOrGrp = 60
         ElseIf (PtGrp(1:1) .eq. 'K') then
            IOrGrp = 1000000
         ElseIf (PtGrp(1:2) .eq. 'CX' .OR. PtGrp(1:2) .eq. 'DX') then
            IOrGrp = 1000000
         ElseIf (PtGrp(1:1) .eq. 'C' .AND. (PGMod .eq. 's' .OR.
     $         PGMod .eq. 'S' .OR. PGMod .eq. 'i' .OR.
     $         PGMod .eq. 'I')) then
            IOrGrp = 2
         EndIf
      Else
C
C     For Cn and Sn, the order is n.  For Dn, it is 2n.
C
         If (PtGrp(1:1) .eq. 'C' .OR. PtGrp(1:1) .eq. 'S') then
            IOrGrp = OrdAx
         ElseIf (PtGrp(1:1) .eq. 'D') then
            IOrGrp = 2 * OrdAx
         EndIf
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Now handle the possible modifiers:
C     v, h, & d are all 2x the number for the base group.
C
      If (PGMod .eq. 'v' .OR. PGMod .eq. 'V' .OR. PGMod .eq. 'h'
     $   .OR. PGMod .eq. 'H' .OR. PGMod .eq. 'd' .OR. PGMod .eq. 'D')
     $   then
         IOrGrp = 2 * IOrGrp
      EndIf
C
C     Make sure we return the right error code.
C
      If (IOrGrp .lt. 0) IOrGrp = -1
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE TRANSP(A,B,NUM,DIS)
C
C    THIS ROUTINE PERFORMS A GENERAL MATRIX  TRANSPOSITION 
C
C       B(P,Q) <---  A(Q,P)
C
C    INPUT:
C             A  ......   MATRIX TO BE TRANSPOSED
C             NUM .....   LENGTH OF SECOND INDEX OF A
C                         (NUMBER OF DISTRIBUTIONS IN A)
C             DIS .....   LENGTH OF FIRST INDEX OF A
C                         (DISTRIBUTION LENGTH IN A)
C
C    OUTPUT:
C             B .......   TRANSPOSED MATRIX
C
CEND
C
C  CODED JULY/90  JG
C  unrolled 8/95 SG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIS 
      DIMENSION A(DIS,NUM),B(NUM,DIS)
C
      IST = MOD(DIS,8)
      DO 1 IAB = 1,IST
        DO 2 IJ = 1,NUM
          B(IJ,IAB)=A(IAB,IJ)
 2      CONTINUE
 1    CONTINUE
      DO 10 IAB=IST+1,DIS,8
        DO 20 IJ=1,NUM
          B(IJ,IAB)=A(IAB,IJ)
          B(IJ,IAB+1)=A(IAB+1,IJ)
          B(IJ,IAB+2)=A(IAB+2,IJ)
          B(IJ,IAB+3)=A(IAB+3,IJ)
          B(IJ,IAB+4)=A(IAB+4,IJ)
          B(IJ,IAB+5)=A(IAB+5,IJ)
          B(IJ,IAB+6)=A(IAB+6,IJ)
          B(IJ,IAB+7)=A(IAB+7,IJ)
 20     CONTINUE
 10   CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork4331(y,na1,na2,nb1,nb2,nc1,nc2,nd1,nd2, 
     *                     a1,a2,b1,b2,c1,c2,d1,d2,inda, indb,
     *                     indc, indd,x1,ne1,ne2,nf1,nf2,ng1,ng2,
     *                     e1,e2,f1,f2,g1,g2,
     *                     indx1, x2,ni1,ni2,nj1,nj2,nk1,nk2,
     *                     i1,i2,j1,j2,k1,k2,indi,indj,indk,
     *                     cind, flopcount,scr1, scr2)
c-------------------------------------------------------------------------
c   Performs a "4331" contraction:
c      4 index output array
c      3 index operand array
c      3 index operand array
c      1 index contraction.
c
c   I. e., contract one of the the 2 indices of the 2nd operand array out
c   of the first operand array, replacing the index by the 2nd operand's
c   2nd index.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'
      include 'saved_data.h'
      include 'parallel_info.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2 
      integer ne1,ne2,nf1,nf2,ng1,ng2
      integer ni1, ni2, nj1, nj2, nk1, nk2 
      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2,g1,g2,
     *        i1,i2,j1,j2,k1,k2  
      integer inda, indb, indc, indd, indx1(3), indi, indj, indk  
      integer cind(2), flopcount

      double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
      double precision yS(na1:na2,nb1:nb2,nc1:nc2)
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2)
      double precision x2S(ni1:ni2,nj1:nj2)

      double precision scr1(*)
      double precision scr2(*)
      integer next

      integer ia, ib, ic, id, icontract, ix(3), iy
      integer i, j, a, b, c, d  
      integer indy(4), map(4)
      integer ie, if, ig
      integer e, f, g 
      integer alast, dlast
      integer iprint
      double precision cval

      integer*8 ixx, c_loc64

#ifdef __crayx1
      integer*8 m, n, k, lda, ldb, ldc
#else
      integer m, n, k, lda, ldb, ldc
#endif

      iprint = cwork_iprint
 
c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various y and x2
c   indices.
c---------------------------------------------------------------------------

      ia = 0
      ib = 0
      ic = 0
      id = 0
      do i = 1, 3

         if (indx1(i) .eq. inda) then
            ia = i
         else if (indx1(i) .eq. indb) then
            ib = i
         else if (indx1(i) .eq. indc) then
            ic = i
         else if (indx1(i) .eq. indd) then
            id = i
         else if (indx1(i) .eq. cind(1)) then
            icontract = i
         else
            print *,'Error: Invalid index in cwork4331'
            print *,'X1 index is ',indx1(i),' y indices: ',inda, indb,
     *              indc,indd,    
     *              ' x2 indices: ',indi,indj,indk,' cind(1) = ',cind(1)
            call abort_job()
         endif
      enddo

      indy(1) = ia
      indy(2) = ib
      indy(3) = ic
      indy(4) = id
      do i = 1, 4
         if (indy(i) .eq. 0) indy(i) = icontract
      enddo

c     write(6,*) ' CIND = ', cind(1), 'indi = ', indi, 
c    *           'icontract = ', icontract 

c     write(6,*) ' indy(i):', (indy(i),i=1,4) 
      if (indi .eq. cind(1)) then

c--------------------------------------------------------------------------
c   Contract over the first index in X2.
c--------------------------------------------------------------------------

         flopcount = 2*(i2-i1+1)*(c2-c1+1)*(b2-b1+1)*(a2-a1+1)
         if (indy(1) .eq. 1 .and. indy(2) .eq. 2 .and.
     *       indy(3) .eq. 3) then !  .and. indy(4) .eq. 4) then  

            if (icontract .eq. 1) then

c--------------------------------------------------------------------------
c   Contract over the 1st index of X1.
c
c   Y(a,b,c,d) = X1(i,b,c)*X2(i,a,d)
c--------------------------------------------------------------------------

            do d = d1, d2 

               do i = i1, i2 
               do j = j1, j2 
                  x2S(i,j) = x2(i,j,d) 
               enddo 
               enddo 

               m = (a2-a1+1)
               n = (b2-b1+1)*(c2-c1+1)
               k = i2-i1+1
               lda = (ni2-ni1+1)
               ldb = ne2-ne1+1
               ldc = (na2-na1+1)
               call dgemm('T', 'N', m,n,k,1.d0, x2S(i1,j1), lda,
     *                 x1(i1,b1,c1), ldb,
     *                 0.d0, yS(a1,b1,c1), ldc)

               do a = a1, a2 
               do b = b1, b2 
               do c = c1, c2 
                  y(a,b,c,d) = yS(a,b,c)
               enddo 
               enddo 
               enddo 

            enddo ! d 

               return

            endif

            if (icontract .eq. 2) then
c              write(6,*) ' Entering dgemm --> icontract = 2' 

c--------------------------------------------------------------------------
c   Contract over the 2nd index of X1.
c
c   Y(a,b,c,d) = X1(a,i,c) * X2(i,b,d)
c--------------------------------------------------------------------------

            do d = d1, d2 

               do i = i1, i2 
               do j = j1, j2 
                  x2S(i,j) = x2(i,j,d) 
               enddo 
               enddo 

               m = (a2-a1+1)
               n = (b2-b1+1)
               k = i2-i1+1
               lda = (ne2-ne1+1)
               ldb = (ni2-ni1+1)
               ldc = (na2-na1+1)
               do c = c1, c2
                  call dgemm('N', 'N', m,n,k,1.d0, x1(a1,i1,c), lda,
     *                        x2S(i1,j1), ldb, 0.d0,
     *                        yS(a1,b1,c), ldc)
               enddo

               do a = a1, a2 
               do b = b1, b2 
               do c = c1, c2 
                  y(a,b,c,d) = yS(a,b,c)
               enddo 
               enddo 
               enddo 

            enddo ! d 

               return
            endif

            if (icontract .eq. 3) then

c--------------------------------------------------------------------------
c   Contract over the 3rd index of X1.
c
c   Y(a,b,c,d) + X1(a,b,i)*X2(i,c,d)
c--------------------------------------------------------------------------

            do d = d1, d2 

               do i = i1, i2 
               do j = j1, j2 
                  x2S(i,j) = x2(i,j,d) 
               enddo 
               enddo 

               m = (a2-a1+1)*(b2-b1+1)
               n = (c2-c1+1)
               k = i2-i1+1
               lda = (ne2-ne1+1)*(nf2-nf1+1)
               ldb = (ni2-ni1+1)
               ldc = (na2-na1+1)*(nb2-nb1+1)
                  call dgemm('N', 'N', m,n,k,1.d0, x1(a1,b1,i1), lda,
     *                        x2S(i1,j1), ldb, 0.d0,
     *                        yS(a1,b1,c1), ldc)

               do a = a1, a2 
               do b = b1, b2 
               do c = c1, c2 
                  y(a,b,c,d) = yS(a,b,c)
               enddo 
               enddo 
               enddo 

            enddo ! d 
            endif
            return

         endif 

      endif 

      print *,'Error: Invalid contraction at line ',current_line
      print *,'X1 index is ',(indx1(i),i=1,3),' y indices: ',inda, indb,
     *              indc,indd,    
     *              ' x2 indices: ',indi,indj,indk,' cind(1) = ',cind(1)
      call abort_job()  
111   continue 
      return
      end
       

      SUBROUTINE T1T2AA1(ZT,Z,W,ZT1,Z1,T,POP,VRT,DISSYZ,DISSYW,NUMSYZ,
     &                   NUMSYW,NVRTSQ,LISTZ,LISTW,IRREP,TMP)
C
C PRIMITIVE CONTRACTION ROUTINE FOR T2<-T1
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSYZ,DISSYW,DIRPRD,POP,VRT
      DIMENSION Z(DISSYZ,NUMSYZ),W(DISSYW,NUMSYW),T(1)
      DIMENSION ZT(NUMSYZ,NVRTSQ),Z1(DISSYZ,NUMSYZ),ZT1(NUMSYZ,DISSYZ)
      DIMENSION TMP(1),POP(8),VRT(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
C
      DATA AZERO,ONE,ONEM /0.0D0,1.0D0,-1.0D0/
C
      CALL ZERO(ZT,NUMSYZ*NVRTSQ)
C
C   GET INTEGRALS <IJ//MA> FROM LISTW
C
C   TRANSPOSE THEM 
C
      IF(MIN(NUMSYW,DISSYW).EQ.0) RETURN
      CALL GETLST(W,1,NUMSYW,2,IRREP,LISTW)
      CALL SYMTR1(IRREP,POP,VRT,DISSYW,W,TMP,TMP(1+DISSYW),
     &            TMP(1+2*DISSYW))
C
C   PERFORM MULTIPLICATION
C
      JOFFW=1
      JOFFZ=1     
      IOFF=1
      DO 90 IRREPJ=1,NIRREP
C
       NOCCJ=POP(IRREPJ)
       NVRTJ=VRT(IRREPJ)
C
       IRREPI=DIRPRD(IRREPJ,IRREP)
C
       NVRTI=VRT(IRREPI)
C
C
C
       CALL XGEMM('N','T',DISSYW*NVRTI,NVRTJ,NOCCJ,ONE,W(1,JOFFW), 
     &            DISSYW*NVRTI,T(IOFF),NVRTJ,
     &            AZERO,ZT(1,JOFFZ),NUMSYZ*NVRTI)
C
       JOFFW=JOFFW+NVRTI*NOCCJ
       JOFFZ=JOFFZ+NVRTI*NVRTJ
       IOFF=IOFF+NVRTJ*NOCCJ
90    CONTINUE
C
      CALL ASSYM(IRREP,VRT,NUMSYZ,NUMSYZ,ZT1,ZT)
      CALL TRANSP(ZT1,Z,DISSYZ,NUMSYZ)
      CALL GETLST(Z1,1,NUMSYZ,1,IRREP,LISTZ)
      CALL VADD(Z1,Z1,Z,NUMSYZ*DISSYZ,ONE)
      CALL PUTLST(Z1,1,NUMSYZ,1,IRREP,LISTZ)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_uintegrals7(a1,a2,b1,b2,c1,c2,d1,d2,scr,
     *                 maxblk, iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 out, nsend, ca, cb, nc1,nc2, nd1, nd2,
     *                 fa,fb) 
c---------------------------------------------------------------------------
c   The block of integrals (a1:a2,b1:b2,c1:c2,d1:d2) is computed for the 
c   following 'types' of integrals based on atomic labels.
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2 
      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim  
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, n, m, r, s
      integer a,b,c,d

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer me, ierr
      integer nc1, nc2, nd1, nd2 

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision out(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision ca(nc1:nc2,nd1:nd2)
      double precision cb(nc1:nc2,nd1:nd2)
      double precision fa(nc1:nc2,nc1:nc2)
      double precision fb(nc1:nc2,nc1:nc2)
      double precision scr(*)   
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      integer*8 ccbeg_pack64(max_dim_coeff), ccend_pack64(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      integer*8 arg64(25)

      common /Imax_com/sz_max(max_shells,max_shells), delta 
      double precision sz_max, delta
      double precision itol, bmax, dtemp, emax    

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter 

      save me,alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack,
     *     ccbeg_pack64, ccend_pack64

      call mpi_comm_rank(mpi_comm_world, me, ierr)
c      print *,'Task ',me,' computing integrals for ',a1,a2,b1,b2,
c     *     c1,c2,d1,d2
c      call c_flush_stdout()

      adim = a2-a1+1
      bdim = b2-b1+1
      cdim = c2-c1+1
      ddim = d2-d1+1 
      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical

c Set the integral tolerance 

      call set_itol(delta,itol)

c     write(6,*) ' DELTA = ', delta, itol  
c     itol = delta ! 1.0d-9 
  
      nsend = adim*bdim*cdim*ddim
      if (nsend .lt. 0) then
         print *,'ERROR IN INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim,cdim,ddim = ',adim,bdim,cdim,ddim
         call mpi_abort(mpi_comm_world, ierr)
      endif

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         call lookup_shell(end_nfps, nshells, a1, m1)
         call lookup_shell(end_nfps, nshells, a2, m2)
         call lookup_shell(end_nfps, nshells, b1, n1)
         call lookup_shell(end_nfps, nshells, b2, n2)
         call lookup_shell(end_nfps, nshells, c1, r1)
         call lookup_shell(end_nfps, nshells, c2, r2)
         call lookup_shell(end_nfps, nshells, d1, s1)
         call lookup_shell(end_nfps, nshells, d2, s2)

         do m = m1, m2
            if (m .eq. 1) then
               aa1 = 1
            else
               aa1 = end_nfps(m-1) + 1
            endif
            aa2 = end_nfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (n .eq. 1) then
               bb1 = 1
            else
               bb1 = end_nfps(n-1) + 1
            endif
            bb2 = end_nfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if (r .eq. 1) then
               cc1 = 1
            else
               cc1 = end_nfps(r-1) + 1
            endif
            cc2 = end_nfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)
         do s = s1, s2
            if (s .eq. 1) then
               dd1 = 1
            else
               dd1 = end_nfps(s-1) + 1
            endif
            dd2 = end_nfps(s)

c-----------------------------------------------------------------------
c   Determine the largest density element.
c-----------------------------------------------------------------------

            emax = 1.0 
c           do d = aa1, aa2  
c           do b = cc1, cc2  
c              dtemp = 0.0 
c              do a = 1, nalpha_occupied ! nd1,nd2
c                  dtemp = dtemp + ca(b,a)*ca(d,a) 
c              enddo 
c              dtemp = dabs(dtemp) 
c              if (dtemp .gt. emax) emax = dtemp  
c           enddo
c           enddo
c           do d = bb1, bb2  
c           do b = dd1, dd2  
c              dtemp = 0.0 
c              do a = 1, nalpha_occupied ! nd1,nd2
c                  dtemp = dtemp + ca(b,a)*ca(d,a) 
c              enddo 
c              dtemp = dabs(dtemp) 
c              if (dtemp .gt. emax) emax = dtemp  
c           enddo
c           enddo

            bmax = sz_max(m,n)*sz_max(r,s) 
            bmax = dsqrt(bmax)*emax  
c           if ((sz_max(m,r) .gt. 0.0) .or. 
c    &           sz_max(n,s) .gt. 0.0)  
c    &      write(6,*) m,n,r,s,sz_max(m,r),sz_max(n,s),bmax 
            if (bmax .lt. itol) go to 30 
            if (intpkg .eq. flocke_package) then
               x4 = coords(1,s)
               y4 = coords(2,s)
               z4 = coords(3,s)
               call pack_coeffs(alphas, ixalpha, coeffs, ixpcoef, 
     *                          ncfps, npfps, m, n, 
     *                          r, s, alpha_pack, nalpha_pack, 
     *                          pcoeff_pack, npcoeff_pack, 
     *                          ccbeg, ccend, indx_cc,
     *                          ccbeg_pack, ccend_pack) 

c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

                  call ERD__GENER_ERI_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum, 
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n), 
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4, alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints, 
     *                nfirst, scr)    
            else if (intpkg .eq. gamess_package .or.
     *               intpkg .eq. gamess_derivative_package) then
            else 
               print *,'Error: Invalid integral package: ',intpkg
               call abort_job()
            endif

c---------------------------------------------------------------------------
c   Move the integrals into the output block.  (For the GAMESS integral 
c   package, this has been already performed.)
c---------------------------------------------------------------------------

           if (intpkg .ne. gamess_package .and.
     *         intpkg .ne. gamess_derivative_package .and.
     *         nints .gt. 0) then
 
              call uscf_tp7a(jx,nc1,nc2,nd1,nd2,ca,cb,a1,a2,b1,b2,
     *                             c1,c2,d1,d2,
     *                             scr(nfirst), 
     *                             aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                             Fa,Fb)

            endif

30       continue 
         enddo   ! s
20       continue 
         enddo   ! r

10       continue 
         enddo   ! n
100      continue 
         enddo   ! m

c     write(6,*) ' Fock_a inside' 
c     write(6,*) ' -------------' 
c     do b = nc1, nc2
c     do a = nc1, nc2
c        write(6,*) a, b, Fa(a,b) 
c     enddo
c     enddo 

      return
      end
 
c ------------------------------------------------------------------- 
c  Used if 
c ------------------------------------------------------------------- 
c 
      subroutine uscf_tp7a(jx,nc1,nc2,nd1,nd2,ca,cb,va1,va2,vb1,vb2,
     &                vc1,vc2,
     &                vd1,vd2,intblk, a1, a2, b1, b2, c1, c2, d1, d2,
     &                Fa,Fb)
      implicit none
      include 'int_gen_parms.h'
      integer va1, va2, vb1,vb2, vc1, vc2, vd1, vd2
      integer a1, a2, b1, b2, c1, c2, d1, d2
      integer a,b,c,d,sym 
      integer nc1,nc2,nd1,nd2,p  
      integer drange1, drange2
      integer crange1, crange2
      integer brange1, brange2
      integer arange1, arange2
      integer dstart, dend  
      integer delta_a, ainc, amax, jx,itype  

      double precision ca(nc1:nc2,nd1:nd2)
      double precision cb(nc1:nc2,nd1:nd2)

      double precision Xa(nc1:nc2,nd1:nd2)
      double precision Xb(nc1:nc2,nd1:nd2)

      double precision cab(nc1:nc2,nd1:nd2)
      double precision Fa(nc1:nc2,nc1:nc2)
      double precision Fb(nc1:nc2,nc1:nc2)
      double precision intblk(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision dtemp, etemp, itemp(5), dcrit, factor  
      double precision dtemp1, etemp1 
      double precision dtemp2, etemp2 
      double precision dtemp3, etemp3 
      double precision etemp_cd, etempa_ac, etempb_ac  
      double precision ca_bd, cb_bd 

      dcrit = 0.0 
      drange1 = max(vd1, d1)
      drange2 = min(vd2, d2)
      crange1 = max(vc1, c1)
      crange2 = min(vc2, c2)
      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

c ----------------------------------------------------------------- 


      dstart = min(arange1,brange1,crange1,drange1)
      dend = max(arange2,brange2,crange2,drange2)

      do d = dstart, dend ! nd1, nd2 
      do c = dstart, dend ! nc1, nc2 

      if (jx .eq. 1) then

             dtemp = 0.0
             do p = 1, nalpha_occupied ! nd1,nd2
                dtemp = dtemp + ca(c,p)*ca(d,p)
             enddo
             xa(c,d) = dtemp

             dtemp = 0.0
             do p = 1, nbeta_occupied ! nd1,nd2
                dtemp = dtemp + cb(c,p)*cb(d,p)
             enddo
             xb(c,d) = dtemp

      else

             xa(c,d) = ca(c,d)
             xb(c,d) = cb(c,d)

      endif

      enddo
      enddo

      do b = brange1, brange2
      do a = arange1, arange2
         cab(a,b) = xa(a,b) + xb(a,b)  
      enddo 
      enddo 

      do d = drange1, drange2
      do c = crange1, crange2

         dtemp = xa(c,d) + xb(c,d)  
         etemp_cd = 0.0 

            do b = brange1, brange2

               ca_bd = xa(b,d) 
               cb_bd = xb(b,d) 

            do a = arange1, arange2, 5 
                  amax = min(arange2-a,4)
                  ainc = 0

                                   itemp(1)  = intblk(a  ,b,c,d)
                  if (amax .ge. 1) itemp(2)  = intblk(a+1,b,c,d)
                  if (amax .ge. 2) itemp(3)  = intblk(a+2,b,c,d)
                  if (amax .ge. 3) itemp(4)  = intblk(a+3,b,c,d)
                  if (amax .ge. 4) itemp(5)  = intblk(a+4,b,c,d) 
33       continue 

c              itemp  = intblk(a+ainc,b,c,d) 

               etemp  = dtemp *itemp(ainc+1)  

               Fa(a+ainc,b) = Fa(a+ainc,b) + etemp 
               Fb(a+ainc,b) = Fb(a+ainc,b) + etemp 

               etempa_ac = ca_bd*itemp(ainc+1)  
               etempb_ac = cb_bd*itemp(ainc+1)  

               etemp_cd = etemp_cd + cab(a+ainc,b)*itemp(ainc+1)  

               Fa(a+ainc,c) = Fa(a+ainc,c) - etempa_ac  
               Fa(c,a+ainc) = Fa(c,a+ainc) - etempa_ac  

               Fb(a+ainc,c) = Fb(a+ainc,c) - etempb_ac  
               Fb(c,a+ainc) = Fb(c,a+ainc) - etempb_ac 

                  ainc = ainc + 1
                  if (ainc .le. amax) go to 33

            enddo

            enddo

            Fa(c,d) = Fa(c,d) + etemp_cd 
            Fb(c,d) = Fb(c,d) + etemp_cd  
      enddo
      enddo

      return
      end
c

      SUBROUTINE FOLOWDFLT(HESMOD, DIAGHES, SCRATCH, VEC, TS, NRORMANR,
     &                     RFA, IVEC, IMODE, NCYCLE, NX, NOPT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      LOGICAL TS, NRORMANR, RFA

#include "io_units.par"

      DIMENSION HESMOD(NOPT, NOPT), DIAGHES(NOPT, NOPT),
     &          SCRATCH(NX*NX), VEC(NOPT)

      DATA IONE /1/

#include "jodaflags.com"

      CALL GETREC(-1,'JOBARC','FIRSTCAL',IONE,ICYCLE)

      INEG = 0
      DO 1101 J=1, MAX(IVEC, 1)
         Z=100.D0
         DO 1100 I = 1, NOPT
            IF (SCRATCH(I).LT.Z) THEN
c              Assignment of eigenvector to be followed
               IF (ICYCLE.EQ.0.AND.TS) IMODE = I
               IMODE = I
               Z = SCRATCH(I)
            ENDIF
            IF (J.EQ.1.AND.HESMOD(I,I).LT.0.D0) INEG = INEG + 1
 1100    CONTINUE
         IF (ICYCLE.EQ.0.AND.TS) SCRATCH(IMODE) = 99.0D00
 1101 CONTINUE

C We follow nothing for minimas. Do this just to be on safe grounds.
      IF (NRORMANR) IMODE = 0

C On latter passes, determine overlap between Hessian eigenvectors
C and VEC (saved from the previous run). I am not sure whether this
C is the only strategy we should follow. See above for explanation.
C Ajith Perera 07/04

      IF (ICYCLE.GT.0.AND.TS) THEN
         ZOVLP = 0.d0
         DO 1833 I=1, NOPT
            SVH = xdot(NOPT,VEC,1,DIAGHES(1,I),1)
            IF (DABS(SVH).GT.ZOVLP) THEN
               ZOVLP = DABS(SVH)
               IMODE = I
            END IF
 1833    CONTINUE
         WRITE(LUOUT, 1351)IMODE, ZOVLP
 1351    FORMAT(T3,' Eigenvector ',i2,' has largest overlap with last ',
     &          'mode followed.',/,T3,' Magnitude of overlap is ',
     &           f8.5,'.')
      END IF
#ifdef _DEBUG_LVLM1

      WRITE(LUOUT, 2102) INEG
 2102 FORMAT(T3,' There are ',i2,' Negative Eigenvalues.')
#endif

      IF (INEG.GT.0.AND.NRORMANR) THEN
         IDIE = IFLAGS(50)
         IF (IDIE.EQ.0) then
            Write (LUOUT, 3131)
 3131       FORMAT(' @ANLYSHES, Negative eigenvalues in Hessian.')
            Call ERREX
         ElSE IF (IDIE.EQ.2) THEN
            WRITE(LUOUT,7141)
 7141       FORMAT(T3,' Negative eigenvalues are present in the ',
     $           'Hessian.'/t3,' Mode switched to rational function ',
     $           'approximation.')
            RFA = .TRUE.
            NRORMANR = .FALSE.
            IMODE = 0
         ELSE IF (IDIE.EQ.1) THEN
            DO 2411 I=1, NOPT
               HESMOD(I,I) = DABS(HESMOD(I,I))
 2411       CONTINUE
            WRITE(LUOUT,1241)
 1241       FORMAT(T3,' Negative eigenvalues present in Hessian have ',
     &         'been converted to their absolute values.')
         END IF
      ELSE IF (INEG.GT.0.AND.RFA) THEN
            IMODE = 0
      ENDIF

c Save the eigenvector being followed for use in the next step
      DO 10 I = 1, NOPT
         VEC(I) = DIAGHES(I, IMODE)
 10   CONTINUE

C Now clean up the scratch array for future use.
      CALL PUTREC(1,'JOBARC','FIRSTCAL',IONE,NCYCLE)
      CALL ZERO(SCRATCH, NX*NX)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__RYS_1_ROOTS_WEIGHTS
     +
     +                    ( NT,
     +                      TVAL,
     +
     +                             RTS,
     +                             WTS )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__RYS_1_ROOTS_WEIGHTS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation returns Rys polynomial roots and weights
C                in case the number of roots and weights required
C                is = 1. All T's are treated at once so the complete
C                set of roots and weights is returned.
C
C                For the moment taken essentially unchanged from the
C                GAMESS package (routine RTS123, but removing their
C                'spaghetti' code from the 70's of unreadable
C                internested IFs and GOTOs!).
C
C                One interesting aspect of the GAMESS routines is that
C                their code returns scaled roots, i.e. their roots
C                do not ly between the range 0 and 1. To get to the
C                proper roots as needed for our package, we simply
C                set:
C
C                   root (our) = root (gamess) / (1 + root (games))
C
C
C                  Input:
C
C                    NT           =  # of T-exponents
C                    TVAL         =  the set of NT T-exponents defining
C                                    the Rys weight functions
C
C                  Output:
C
C                    RTS          =  all NT quadrature roots
C                    WTS          =  all NT quadrature weights
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    N
         INTEGER    NT
         INTEGER    TCASE

         INTEGER    JUMP1 (1:34)

         DOUBLE PRECISION   E,T,X
         DOUBLE PRECISION   F1
         DOUBLE PRECISION   PI4
         DOUBLE PRECISION   T1MAX
         DOUBLE PRECISION   R1,W1
         DOUBLE PRECISION   FIFTH,THIRD,HALF,ONE,TWO,FOUR

         DOUBLE PRECISION   TVAL (1:NT)
         DOUBLE PRECISION   RTS  (1:NT)
         DOUBLE PRECISION   WTS  (1:NT)

         PARAMETER  (PI4     = 7.85398163397448D-01)
         PARAMETER  (T1MAX   = 34.D0)
         PARAMETER  (FIFTH   = 0.2D0)
         PARAMETER  (THIRD   = 0.333333333333333D0)
         PARAMETER  (HALF    = 0.5D0)
         PARAMETER  (ONE     = 1.D0)
         PARAMETER  (TWO     = 2.D0)
         PARAMETER  (FOUR    = 4.D0)

         DATA  JUMP1  /1,2,2,3,3,4,4,4,4,4,
     +                 5,5,5,5,5,6,6,6,6,6,
     +                 6,6,6,6,6,6,6,6,6,6,
     +                 6,6,6,7/
C
C
C------------------------------------------------------------------------
C
C
C                 ********************************
C             ... *  # of roots and weights = 1  *
C                 ********************************
C
C
      DO 100 N = 1,NT

         T = TVAL (N)

         IF (T. LE. 3.0D-07) THEN
C
C
C             ...T-range: T essentially 0
C
C
             R1 = HALF - T * FIFTH

             WTS (N) = ONE  - T * THIRD
             RTS (N) = R1 / (ONE + R1)
             GOTO 100
         END IF

         TCASE = INT ( MIN (T+ONE,T1MAX))

         GOTO (1100,1200,1300,1400,1500,1600,1700) JUMP1 (TCASE)
C
C
C             ...T-range: 0 < T < 1
C
C
 1100    F1 = ((((((((-8.36313918003957D-08  * T
     +                +1.21222603512827D-06) * T
     +                -1.15662609053481D-05) * T
     +                +9.25197374512647D-05) * T
     +                -6.40994113129432D-04) * T
     +                +3.78787044215009D-03) * T
     +                -1.85185172458485D-02) * T
     +                +7.14285713298222D-02) * T
     +                -1.99999999997023D-01) * T
     +                +3.33333333333318D-01

         W1 = (T + T) * F1 + DEXP (-T)
         R1 = F1 / (W1 - F1)

         WTS (N) = W1
         RTS (N) = R1 / (ONE + R1)

         GOTO 100
C
C
C             ...T-range: 1 =< T < 3
C
C
 1200    X = T - TWO

         F1 = ((((((((((-1.61702782425558D-10  * X
     +                  +1.96215250865776D-09) * X
     +                  -2.14234468198419D-08) * X
     +                  +2.17216556336318D-07) * X
     +                  -1.98850171329371D-06) * X
     +                  +1.62429321438911D-05) * X
     +                  -1.16740298039895D-04) * X
     +                  +7.24888732052332D-04) * X
     +                  -3.79490003707156D-03) * X
     +                  +1.61723488664661D-02) * X
     +                  -5.29428148329736D-02) * X
     +                  +1.15702180856167D-01

         W1 = (T + T) * F1 + DEXP (-T)
         R1 = F1 / (W1 - F1)

         WTS (N) = W1
         RTS (N) = R1 / (ONE + R1)

         GOTO 100
C
C
C             ...T-range: 3 =< T < 5
C
C
 1300    X = T - FOUR

         F1 = ((((((((((-2.62453564772299D-11  * X
     +                  +3.24031041623823D-10) * X
     +                  -3.614965656163D-09)   * X
     +                  +3.760256799971D-08)   * X
     +                  -3.553558319675D-07)   * X
     +                  +3.022556449731D-06)   * X
     +                  -2.290098979647D-05)   * X
     +                  +1.526537461148D-04)   * X
     +                  -8.81947375894379D-04) * X
     +                  +4.33207949514611D-03) * X
     +                  -1.75257821619926D-02) * X
     +                  +5.28406320615584D-02

         W1 = (T + T) * F1 + DEXP (-T)
         R1 = F1 / (W1 - F1)

         WTS (N) = W1
         RTS (N) = R1 / (ONE + R1)

         GOTO 100
C
C
C             ...T-range: 5 =< T < 10
C
C
 1400    E = DEXP (-T)
         X = ONE / T

         W1 = (((((( 4.6897511375022D-01  * X
     +              -6.9955602298985D-01) * X
     +              +5.3689283271887D-01) * X
     +              -3.2883030418398D-01) * X
     +              +2.4645596956002D-01) * X
     +              -4.9984072848436D-01) * X
     +              -3.1501078774085D-06) * E + DSQRT (PI4*X)

         F1 = (W1 - E) / (T + T)
         R1 = F1 / (W1 - F1)

         WTS (N) = W1
         RTS (N) = R1 / (ONE + R1)

         GOTO 100
C
C
C             ...T-range: 10 =< T < 15
C
C
 1500    E = DEXP (-T)
         X = ONE / T

         W1 = (((-1.8784686463512D-01  * X
     +           +2.2991849164985D-01) * X
     +           -4.9893752514047D-01) * X
     +           -2.1916512131607D-05) * E + DSQRT (PI4*X)

         F1 = (W1 - E) / (T + T)
         R1 = F1 / (W1 - F1)

         WTS (N) = W1
         RTS (N) = R1 / (ONE + R1)

         GOTO 100
C
C
C             ...T-range: 15 =< T < 33
C
C
 1600    E = DEXP (-T)
         X = ONE / T

         W1 = (( 1.9623264149430D-01  * X
     +          -4.9695241464490D-01) * X
     +          -6.0156581186481D-05) * E + DSQRT (PI4*X)

         F1 = (W1 - E) / (T + T)
         R1 = F1 / (W1 - F1)

         WTS (N) = W1
         RTS (N) = R1 / (ONE + R1)

         GOTO 100
C
C
C             ...T-range: T >= 33
C
C
 1700    WTS (N) = DSQRT (PI4/T)
C         R1 = HALF / (T - HALF)
C         RTS (N) = R1 / (ONE + R1)
         RTS (N) = HALF / T

  100 CONTINUE
C
C
C             ...ready!
C
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pack_coeffs_2co(alpha, ixalpha, pcoeff, ixpcoeff, 
     *                       ncfps, npfps, m,
     *                       alpha_pack, nalpha, pcoeff_pack, 
     *                       npcoeff, ccbeg, ccend, indx_cc,
     *                       ccbeg_pack, ccend_pack, 
     *                       maxpack)
c---------------------------------------------------------------------------
c   Formats the integral exponents and contraction coefficients for use
c   in the ERD integral package.
c---------------------------------------------------------------------------
      implicit none
      include 'machine_types.h'
      
      integer ncfps(*), npfps(*), ixalpha(*), ixpcoeff(*)
      integer ccbeg(*), ccend(*), indx_cc(*)
      integer ccbeg_pack(*), ccend_pack(*)
      integer maxpack
      integer m, n
      integer nalpha, npcoeff
      integer ialpha
      integer ipcoeff
      integer quad(2)
      double precision alpha(*), pcoeff(*)
      double precision alpha_pack(*), pcoeff_pack(*)
      integer i, j, num, ishell
      integer k, l, icc

      quad(1) = m
ccc      quad(2) = n

      ialpha = 1
      ipcoeff = 1
      nalpha = 0
      npcoeff = 0
      do j = 1, 1 
         ishell = quad(j)
         do i = 1, npfps(ishell)
            alpha_pack(ialpha+i-1) = alpha(ixalpha(ishell)+i-1)
         enddo

         ialpha = ialpha + npfps(ishell)
         nalpha = nalpha + npfps(ishell)
         if (nalpha .gt. maxpack) then
            print *,'Error: Pack buffer overflow, shell ',
     *           quad(1), quad(2),' nalpha ',nalpha,
     *           ' maxpack ',maxpack  
            call abort_job()
         endif
      enddo
  
      icc = 1
      do j = 1, 1
         ishell = quad(j)
         num    = npfps(ishell)*ncfps(ishell)
 
         do i = 1, num
            pcoeff_pack(ipcoeff+i-1) = pcoeff(ixpcoeff(ishell)+i-1)
         enddo

         ipcoeff = ipcoeff + num
         npcoeff = npcoeff + num
         if (npcoeff .gt. maxpack) then
            print *,'Error: pcoeff buffer overflow shell ',
     *            quad(1),quad(2)
            call abort_job()
         endif  
      enddo

         icc = 1
         do j = 1, 1
            ishell = quad(j)
            if (icc .gt. maxpack) then
               print *,'Error : ccbeg, ccend overflow shell ',
     *              quad(1),quad(2)
               call abort_job() 
            endif 

            do k = 1, ncfps(ishell)
               ccbeg_pack(icc) = ccbeg(indx_cc(ishell)+k-1)
               ccend_pack(icc) = ccend(indx_cc(ishell)+k-1)
               icc = icc + 1
            enddo
         enddo

      return
      end  

       Subroutine Read_file(NATOMS, NVIBS, Input_Array, Scratch1)
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C












































































































































































































































































































































































































































































































































c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end










c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C#include "istart.com"                      
C    
      Double Precision Input_Array
      Character*80 junk
      Character*2 Zsym(Natoms)
      Logical NORMCO_EXSIST
      Dimension Input_array(3*Nvibs,3*Nvibs), Scratch1
     &          (Natoms*(Nvibs/3+3),9)
C
      DATA XTANG /0.529177249D0/ 
C
      Iunit = 4
      INQUIRE(FILE='NORMCO',EXIST=NORMCO_EXSIST)
      IF(NORMCO_EXSIST)THEN
        OPEN(UNIT=Iunit,FILE='NORMCO',FORM='FORMATTED',STATUS='OLD')
        REWIND(Iunit)
      ELSE
        WRITE(6,20)
 20      format(T3,'@-READ_file, NORMCO file not present.')
        Call Errex
      ENDIF
     
      Ncols = 3
      Nfull = Nvibs/3
      Nleft = Nvibs - 3*Nfull
      

      Write(6,*) "Nfull and Nleft", Nfull, Nleft

      Ioff = 1
      Do Jcount = 1, Nfull
     
         Do Ijunk = 1, 4
            Read(Iunit,*) junk
         Enddo
         Do Iatoms = 1, Natoms
            Read(Iunit,10) Zsym(Iatoms), (Scratch1(Ioff, joff), 
     &                     joff=1,9)
            Ioff = Ioff + 1
         Enddo
      Enddo
  
      Do Jcount = 1, Nleft

         Do Ijunk = 1, 4
            Read(Iunit,*) junk
         Enddo
         Do Iatoms = 1, Natoms
            Read(Iunit,10) Zsym(Iatoms), (Scratch1(Ioff, joff), 
     &                     joff=1,3*Nleft)
            Ioff = Ioff + 1
         Enddo
      Enddo

      nt = nfull + Nleft
      Write(6,*) "Data as read from the external file"
      Call output(Scratch1, 1, Natoms*nt, 1, 9, natoms*(nfull+3), 9, 
     &           1)
 10   FORMAT(A2, 3X, 3(3(F7.4,1X), 2x))
	
      Ntotal = Nfull + Nleft
      Do Indx = 1, Natoms*Ntotal 
         Ioff = 0

          Do Jndx = 1, NvibS, 3
             Ioff = Ioff + 1
             
             Do ixyz =Jndx, Jndx + 2
       
                Input_array(Jndx, Ioff) = Scratch1(Indx, Jndx) 

             Enddo
          Enddo
      Enddo

      nt = nfull + Nleft
      Write(6,*) "Reordered data from  external file"
      Call output(Input_array, 1, Natoms*3, 1, natoms*(nfull+3), 9, 
     &           1)
      Return
      End

       Subroutine Read_file(NATOMS, NVIBS, Input_Array, Scratch1)
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "flags.h"
#include "machsp.com"
#include "jodaflags.com"                   
#include "mxatms.par"
C#include "istart.com"                      
C    
      Double Precision Input_Array
      Character*80 junk
      Character*2 Zsym(Natoms)
      Logical NORMCO_EXSIST
      Dimension Input_array(3*Nvibs,3*Nvibs), Scratch1
     &          (Natoms*(Nvibs/3+3),9)
C
      DATA XTANG /0.529177249D0/ 
C
      Iunit = 4
      INQUIRE(FILE='NORMCO',EXIST=NORMCO_EXSIST)
      IF(NORMCO_EXSIST)THEN
        OPEN(UNIT=Iunit,FILE='NORMCO',FORM='FORMATTED',STATUS='OLD')
        REWIND(Iunit)
      ELSE
        WRITE(6,20)
 20      format(T3,'@-READ_file, NORMCO file not present.')
        Call Errex
      ENDIF
     
      Ncols = 3
      Nfull = Nvibs/3
      Nleft = Nvibs - 3*Nfull
      

#ifdef _DEBUG_LVL0
      Write(6,*) "Nfull and Nleft", Nfull, Nleft
#endif

      Ioff = 1
      Do Jcount = 1, Nfull
     
         Do Ijunk = 1, 4
            Read(Iunit,*) junk
         Enddo
         Do Iatoms = 1, Natoms
            Read(Iunit,10) Zsym(Iatoms), (Scratch1(Ioff, joff), 
     &                     joff=1,9)
            Ioff = Ioff + 1
         Enddo
      Enddo
  
      Do Jcount = 1, Nleft

         Do Ijunk = 1, 4
            Read(Iunit,*) junk
         Enddo
         Do Iatoms = 1, Natoms
            Read(Iunit,10) Zsym(Iatoms), (Scratch1(Ioff, joff), 
     &                     joff=1,3*Nleft)
            Ioff = Ioff + 1
         Enddo
      Enddo

#ifdef _DEBUG_LVL0
      nt = nfull + Nleft
      Write(6,*) "Data as read from the external file"
      Call output(Scratch1, 1, Natoms*nt, 1, 9, natoms*(nfull+3), 9, 
     &           1)
#endif
 10   FORMAT(A2, 3X, 3(3(F7.4,1X), 2x))
	
      Ntotal = Nfull + Nleft
      Do Indx = 1, Natoms*Ntotal 
         Ioff = 0

          Do Jndx = 1, NvibS, 3
             Ioff = Ioff + 1
             
             Do ixyz =Jndx, Jndx + 2
       
                Input_array(Jndx, Ioff) = Scratch1(Indx, Jndx) 

             Enddo
          Enddo
      Enddo

#ifdef _DEBUG_LVL0
      nt = nfull + Nleft
      Write(6,*) "Reordered data from  external file"
      Call output(Input_array, 1, Natoms*3, 1, natoms*(nfull+3), 9, 
     &           1)
#endif
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__XYZ_INIT_00_INTS
     +
     +                    ( SHELLP,SHELLB,
     +                      NEXP,
     +                      XP,YP,ZP,
     +                      PINVHF,
     +                      MOMENTX,MOMENTY,MOMENTZ,
     +                      XMINUS,YMINUS,ZMINUS,
     +                      SCRMTX,SCRMTY,SCRMTZ,
     +
     +                               INT1DX,
     +                               INT1DY,
     +                               INT1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_INIT_00_INTS 
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED                 
C  SUBROUTINES : none                                 p q r               
C  DESCRIPTION : This operation computes all the (0| X Y Z |0) moment
C                integrals
C
C
C                  Input:
C
C                    SHELLx       =  the shell type for csh x = A,B,P
C                    NEXP         =  # of exponent pairs
C                    xP           =  current NEXP coordinate x=X,Y,Z
C                                    Gaussian Product centers
C                    PINVHF       =  current NEXP values of 1/(2*P),
C                                    where P are the exponent sums
C                                    for contraction shells A and B
C                    MOMENTx      =  tells which power of X,Y, or Z
C                                    integrals to compute
C                    SCRMTx       =  holds all previous integrals 
C                                    needed for the recursion relations
C                    xMINUS       =  holds previous (0|mu-2|0) integrals
C
C
C                  Output:
C
C                    INT1Dx       =  all 1D moment integrals for each
C                                    cartesian component x = X,Y,Z
C                                    for the current exponent pairs
C
C  
C  AUTHOR      : Norbert Flocke
C                  - Wrote original OED package
C
C  MODIFIER    : Thomas Watson Jr.                   p  q  r
C                  - Modified OED package to handle X, Y, Z integrals
C------------------------------------------------------------------------
C                      
C             
C             ...include files and declare variables.
C
C        
         IMPLICIT   NONE

         INTEGER     MOM,N,I,J
         INTEGER     SHELLP,SHELLB
         INTEGER     NEXP
         INTEGER     MOMENTX,MOMENTY,MOMENTZ

         DOUBLE PRECISION  F,P1
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  PINVHF (1:NEXP)

         DOUBLE PRECISION  XP (1:NEXP)
         DOUBLE PRECISION  YP (1:NEXP)
         DOUBLE PRECISION  ZP (1:NEXP)

         DOUBLE PRECISION  XMINUS (1:NEXP)
         DOUBLE PRECISION  YMINUS (1:NEXP)
         DOUBLE PRECISION  ZMINUS (1:NEXP)

         DOUBLE PRECISION  SCRMTX (1:NEXP,0:SHELLP,0:SHELLB)
         DOUBLE PRECISION  SCRMTY (1:NEXP,0:SHELLP,0:SHELLB) 
         DOUBLE PRECISION  SCRMTZ (1:NEXP,0:SHELLP,0:SHELLB) 

         DOUBLE PRECISION  INT1DX (1:NEXP,0:SHELLP,0:SHELLB) 
         DOUBLE PRECISION  INT1DY (1:NEXP,0:SHELLP,0:SHELLB) 
         DOUBLE PRECISION  INT1DZ (1:NEXP,0:SHELLP,0:SHELLB) 

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...initialize 1D moment integrals.
C
C
         DO 200 N = 1,NEXP
            INT1DX (N,0,0) = ONE
            INT1DY (N,0,0) = ONE
            INT1DZ (N,0,0) = ONE
            SCRMTX (N,0,0) = ZERO
            SCRMTY (N,0,0) = ZERO
            SCRMTZ (N,0,0) = ZERO
  200    CONTINUE

         IF (SHELLP .EQ. 0) THEN

             IF (MOMENTX .GE. 1) THEN
                 F = ZERO
                 DO 205 MOM = 1,MOMENTX
                    DO N = 1,NEXP
                       P1 = F * PINVHF (N)
                       XMINUS (N)     = SCRMTX (N,0,0)
                       SCRMTX (N,0,0) = INT1DX (N,0,0)
                       INT1DX (N,0,0) = XP (N) * SCRMTX (N,0,0)
     +                                   +  P1 * XMINUS (N)
                    END DO
                 F = F + ONE
  205            CONTINUE
             END IF

             IF (MOMENTY .GE. 1) THEN
                 F = ZERO
                 DO 215 MOM = 1,MOMENTY
                    DO N = 1,NEXP
                       P1 = F * PINVHF (N)
                       YMINUS (N)     = SCRMTY (N,0,0)
                       SCRMTY (N,0,0) = INT1DY (N,0,0)
                       INT1DY (N,0,0) = YP (N) * SCRMTY (N,0,0)
     +                                   +  P1 * YMINUS (N)
                    END DO
                 F = F + ONE
  215            CONTINUE
             END IF

             IF (MOMENTZ .GE. 1) THEN
                 F = ZERO
                 DO 225 MOM = 1,MOMENTZ
                    DO N = 1,NEXP
                       P1 = F * PINVHF (N)
                       ZMINUS (N)     = SCRMTZ (N,0,0)
                       SCRMTZ (N,0,0) = INT1DZ (N,0,0)
                       INT1DZ (N,0,0) = ZP (N) * SCRMTZ (N,0,0)
     +                                   +  P1 * ZMINUS (N)
                    END DO
                 F = F + ONE
  225            CONTINUE
             END IF
C
C
C             ...handle the cases where SHELLP > 0
C
C                For moment integrals we need the set
C                of (0|XYZ|0) integrals as well as 
C                the set (0|XYZ-1|0) of integrals.
C                The latter go into SCRMTx.
C
C
         ELSE

             IF (MOMENTX .GT. 0) THEN
                 DO 300 N = 1,NEXP
                    INT1DX (N,0,0) = XP (N)
                    SCRMTX (N,0,0) = ONE
  300            CONTINUE
             END IF

             IF (MOMENTY .GT. 0) THEN
                 DO 310 N = 1,NEXP
                    INT1DY (N,0,0) = YP (N)
                    SCRMTY (N,0,0) = ONE
  310            CONTINUE  
             END IF

             IF (MOMENTZ .GT. 0) THEN
                 DO 320 N = 1,NEXP
                    INT1DZ (N,0,0) = ZP (N)
                    SCRMTZ (N,0,0) = ONE
  320            CONTINUE  
             END IF

         END IF
C
C             ...ready!
C
C
         RETURN
         END

C MOVES SYMMETRY PACKED LIST LIST1 TO SYMMETRY PACKED LIST LIST2.

      SUBROUTINE MVSYM(ICORE,MAXCOR,IUHF,ICACHE,LIST1,LIST2)
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(MAXCOR)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),IJUNK(18)
      NSIZE = 0
      ILIST1 = LIST1
cYAU      IF (LIST1.GT.100) ILIST1 = ILIST1
      DO IRREP = 1, NIRREP
         NUMSYM = IRPDPD(IRREP,ISYTYP(2,ILIST1))
         DSZSYM = IRPDPD(IRREP,ISYTYP(1,ILIST1))
         NSIZE  = NSIZE + ( DSZSYM * NUMSYM )
      END DO
      CALL GETALL(ICORE,NSIZE,ICACHE,LIST1)
      CALL PUTALL(ICORE,NSIZE,ICACHE,LIST2)
      RETURN
      END

      subroutine setangfct (
     &     maxshl, angfct)
c
c This routine calculate the angular factors (lx, ly, lz) of Gaussian
c primitives x**lx * y**ly * z**lz * exp (..) for each shell from 1 to
c MAXSHL. The loop is taken from KS.SRC/INTGRT/INITGRID.
c
c Igor Schweigert, Jul 2004
c $Id: setangfct.F,v 1.1 2004/12/21 17:41:16 igor Exp $
c
      implicit none
c
c     Arguments
c
      integer
     &     maxshl, angfct (3, maxshl)
c
c     Local variables
c
      integer
     &     iang, jang, kang, ishl, x, y, z
c
c     Loop over angular momentum and set the angular factors for each
c     shell.
c     
c     angfct (1, *) = 0  100  211000  3221110000  ...
c     angfct (2, *) = 0  010  010210  0102103210  ...
c     angfct (3, *) = 0  001  001012  0010120123  ...
c
      ishl = 1
      do iang = 1, 100
         if (ishl.gt.maxshl) goto 100
         x = iang - 1
         do jang = 1, iang
            y = jang - 1
            z = 0
            do kang = 1, jang
               angfct (1, ishl) = x
               angfct (2, ishl) = y
               angfct (3, ishl) = z

c               write(6,*) 'X=', angfct (1, ishl), ishl
c               write(6,*) 'Y=', angfct (2, ishl), ishl
c               write(6,*) 'Y=', angfct (3, ishl), ishl

               y = y - 1
               z = z + 1
               ishl = ishl + 1
            enddo
            x = x - 1
         enddo
      enddo
c
 100  continue
      return
      end

#ifdef USE_SP_BLAS
      subroutine daxpy(n,da,dx,incx,dy,incy)
      double precision dx(*),dy(*),da
      integer incx,incy,n
      call saxpy(n,da,dx,incx,dy,incy)
      return
      end

      subroutine dcopy(n,dx,incx,dy,incy)
      double precision dx(*),dy(*)
      integer incx,incy,n
      call scopy(n,dx,incx,dy,incy)
      return
      end

      subroutine dgeev(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,
     &                 work,lwork,info)
      character jobvl,jobvr
      integer info,lda,ldvl,ldvr,lwork,n
      double precision a(lda,*),vl(ldvl,*),vr(ldvr,*),wi(*)
      double precision work(*),wr(*)
      call sgeev(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,
     &           work,lwork,info)
      return
      end

      subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
      character transa,transb
      integer lda,ldb,ldc,m,n,k
      double precision alpha,beta,a(lda,*),b(ldb,*),c(ldc,*)
      call sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
      return
      end

      subroutine dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
      character trans
      integer incx,incy,lda,m,n
      double precision alpha,beta,a(lda,*),x(*),y(*)
      call sgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
      return
      end

      subroutine dgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
      integer lda,ldb,n,nrhs,ipiv(*)
      double precision a(lda,*),b(ldb,*)
      call sgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
      return
      end

      subroutine dgetrf(m,n,a,lda,ipiv,info)
      integer info,lda,m,n,ipiv(*)
      double precision a(lda,*)
      call sgetrf(m,n,a,lda,ipiv,info)
      return
      end

      subroutine dgetri(n,a,lda,ipiv,work,lwork,info)
      integer info,lda,lwork,n,ipiv(*)
      double precision a(lda,*),work(*)
      call sgetri(n,a,lda,ipiv,work,lwork,info)
      return
      end

      subroutine drot(n,dx,incx,dy,incy,c,s)
      double precision dx(*),dy(*),c,s
      integer incx,incy,n
      call srot(n,dx,incx,dy,incy,c,s)
      return
      end

      subroutine dscal(n,da,dx,incx)
      double precision da,dx(*)
      integer incx,n
      call sscal(n,da,dx,incx)
      return
      end

      subroutine dswap(n,dx,incx,dy,incy)
      double precision dx(*),dy(*)
      integer incx,incy,n
      call sswap(n,dx,incx,dy,incy)
      return
      end

      subroutine dsyev(jobz,uplo,n,a,lda,w,work,lwork,info)
      character jobz,uplo
      integer info,lda,lwork,n
      double precision a(lda,*),w(*),work(*)
      call ssyev(jobz,uplo,n,a,lda,w,work,lwork,info)
      return
      end

      subroutine dsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
      character side,uplo
      integer lda,ldb,ldc,m,n
      double precision alpha,beta,a(lda,*),b(ldb,*),c(ldc,*)
      call ssymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
      return
      end

      subroutine dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
      character uplo
      integer lda,n,incx,incy
      double precision alpha,beta,a(lda,*),x(*),y(*)
      call ssymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
      return
      end

      subroutine dsyr(uplo,n,alpha,x,incx,a,lda)
      character uplo
      integer incx,lda,n
      double precision alpha,a(lda,*),x(*)
      call ssyr(uplo,n,alpha,x,incx,a,lda)
      return
      end

      subroutine dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
      character uplo
      integer incx,incy,lda,n
      double precision alpha,a(lda,*),x(*),y(*)
      call ssyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
      return
      end

      double precision function dasum(n,dx,incx)
      double precision dx(*),sasum
      integer incx,n
      dasum=sasum(n,dx,incx)
      return
      end

      double precision function ddot(n,dx,incx,dy,incy)
      double precision dx(*),dy(*),sdot
      integer incx,incy,n
      ddot=sdot(n,dx,incx,dy,incy)
      return
      end

      double precision function dlamch(cmach)
      character cmach
      double precision slamch
      dlamch=slamch(cmach)
      return
      end

      double precision function dnrm2(n,x,incx)
      double precision x(*),snrm2
      integer incx,n
      dnrm2=snrm2(n,x,incx)
      return
      end

      double precision function dsum(n,dx,incx)
      double precision dx(*),ssum
      integer incx,n
      dsum=ssum(n,dx,incx)
      return
      end

      integer function idamax(n,dx,incx)
      double precision dx(*)
      integer incx,n,isamax
      idamax=isamax(n,dx,incx)
      return
      end
#else
#include "return.f"
#endif /* USE_SP_BLAS */

c This routine does NOTHING. Other files will include it so rigid
c Fortran compilers have something to do when a cpp define removes all
c of the compilable code in the .f file.

      subroutine to_combat_compiler_stupidity()
      return
      end

C THIS PROGRAM DETERMINES SYMMETRY ADAPTED COORDINATES WHICH
C ARE USED FOR NUMERICAL HARMONIC FREQUENCY CALCULATIONS.  IT
C CAN EASILY BE ADAPTED TO CONSTRUCT OTHER SYMMETRY ADAPTED
C QUANTITIES, SUCH AS BASIS FUNCTIONS.  IT CURRENTLY WORKS FOR
C ALL POINT GROUPS OTHER THAN THOSE WHICH CONTAIN COMPLEX
C REPRESENTATIONS (CN, SN, CNH (N>2) AND T AND TH).  FOR THESE
C "DANGEROUS GROUPS", THE ABELIAN SUBGROUP IS USED.
C WRITTEN BY J.F. STANTON, 1991-1992.

c The entire operating procedure of symcor is explained in README.




































































































































































































































































































































































































































































































































      SUBROUTINE SYMCOR(ICORE,ICRSIZ)
      IMPLICIT INTEGER (A-Z)
      INTEGER ICORE(ICRSIZ), I0

C The dimension of IRRNM array is changed to 14 to accomodate the
C largest possible dimension. Note that in joda D_infh and C_infv
C are set to D_8h and C_8v. Ajith 08/2001

      DOUBLE PRECISION E, TRAD, PRD_ENRG_CHNG, TAU, TotEng
      CHARACTER*8 GRPSYM,IRRNM(14)
      CHARACTER*4 DOIT
      LOGICAL FIRST_PASS,GRAD_EXIST,I_HAVEAGEOM

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100), IFLAGS2(500)
c      COMMON /FLAGS2/ IFLAGS2(500)
      LOGICAL          ENERONLY,GRADONLY,ROTPROJ,RAMAN,GMTRYOPT,
     &                 SNPTGRAD
      COMMON /CONTROL/ ENERONLY,GRADONLY,ROTPROJ,RAMAN,GMTRYOPT,
     &                 SNPTGRAD 
c parallel_aces.com : begin

c This common block contains the MPI statistics for each MPI process. The values
c are initialized in the acescore library.

      external aces_bd_parallel_aces




      integer                nprocs, irank, icpuname

      character*(256) szcpuname

      common /parallel_aces/ nprocs, irank, icpuname,
     &                       szcpuname
      save   /parallel_aces/

c parallel_aces.com : end

      DATA IZERO /0/

c   o initialize the free-space index in iCore
      I0=1

C The values get assigned for PASS1 JOBARC record has very important
C function in joda when it is executing any calculation that involve
C numerical derivatives.
C
C When the execution transfers to here for the first time, joda
C has run one time as a single point calculation. There are no
C JOBARC records GRADIENT or PASS1. So GRAD_EXIST is false,
C PASS1 is 0 and GMTRYOPT is true or false depending on whether
C we are doing geometry optimizations or vibrational frequencies.
C
C Numerical geometry optimization - PASS1 is set to 1 until
C full set of gradients available. Then it is set to 0.
C
C Analytical gradient frequencies  - PASS1 is set to 1 in the
C very first time. It remains as 1 until the full Hessian is
C is available, then it is set to 0.
C
C Numerical gradient frequencies  - PASS1 get set to -1 in the
C first run. Before the next execution joda, this  get reset
C back to 1. When the full Hessian is available it get reset to 0.
C (-1 in the first call tell the code that it has to do energy
C points). 03/2003 Ajith Perera.

      CALL GETREC(-1,'JOBARC','PASS1',1,PASS1)
      CALL GETREC(0,'JOBARC','GRADIENT',LENGTH,ITMP)
      Call GETREC(-1,  'JOBARC', 'HAVEGEOM',1 , LEN_HAVEGEOM)
      I_HAVEAGEOM = (LEN_HAVEGEOM .EQ. 1)
      GRAD_EXIST  = LENGTH.NE.-1

c   o initialize /CONTROL/
      ENERONLY = IFLAGS2(138).EQ.2
      GRADONLY = IFLAGS2(138).EQ.1
      ROTPROJ  = IFLAGS (80).EQ.0
      RAMAN    = IFLAGS2(151).EQ.1
      GMTRYOPT = IFLAGS2(5).NE.0 .AND. .NOT.
     &           I_HAVEAGEOM
      SNPTGRAD = .NOT. (GMTRYOPT.OR.IFLAGS(54).NE.0)

c   o detect dangerous point groups and avoid them like hell
      CALL GETCREC(20,'JOBARC','FULLPTGP',8,GRPSYM)
      IPOS = LINBLNK(GRPSYM(1:4))
      IF (PASS1.NE.1.AND.
     &    (GRPSYM(1:1).EQ.'C'.AND.GRPSYM(IPOS:IPOS).NE.'v'.OR.
     &     GRPSYM(1:3).EQ.'T h'.OR.
     &     GRPSYM(1:3).EQ.'T  '.OR.
     &     GRPSYM(1:1).EQ.'S'
     &    )
     &   ) THEN
         DOIT='COMP'
         WRITE(6,410)
 410     FORMAT(T3,'@SYMCOR: Full point group is dangerous! ',
     &             'Abelian subgroup will be used.')
         ITMP=1
         CALL PUTREC(20,'JOBARC','DANGERUS',1,ITMP)
      ELSE
         CALL GETREC(-1,'JOBARC','DANGERUS',1,ITMP)
         IF (IFLAGS(79).EQ.0.AND.ITMP.EQ.0) THEN
            DOIT='FULL'
         ELSE
            DOIT='COMP'
            ITMP=0
         END IF
         IF (PASS1.NE.1) CALL PUTREC(20,'JOBARC','DANGERUS',1,ITMP)
      END IF

      CALL GETREC(20,'JOBARC','NATOMS',1,NATOM)

      IF (PASS1.EQ.-1) THEN
         IF (IFLAGS(87).EQ.0) THEN
            CALL GETREC(20,'JOBARC','TOTENERG',IINTFP,E)
         ELSE
            CALL GETREC(20,'JOBARC','TOTENER2',IINTFP,E)
         END IF
         CALL PUTREC(20,'JOBARC','REFENERG',IINTFP,E)
         PASS1=1
         CALL PUTREC(20,'JOBARC','PASS1',1,PASS1)
      ELSE
         E = 0.d0
      END IF

      FIRST_PASS = ( (PASS1.EQ.0) .OR. (GRAD_EXIST.AND.GMTRYOPT) )
      Print*, "Geo opt flag set?, vlaue of pass1, gradient exist",
     &        "geometry optimization?, energy only?:"
      Print*, IFLAGS2(5), PASS1, GRAD_EXIST, GMTRYOPT, 
     &        ENERONLY
      IF (FIRST_PASS) THEN

c      o zero icore so we can use it to initialize some records
         do i = 1, iintfp*3*natom
            icore(i) = 0
         end do

c      o create a record for the force constants so we can use them in testing
         IF (.NOT.GMTRYOPT) THEN
            CALL PUTREC(20,'JOBARC','FORCECON',IINTFP*3*NATOM,ICORE)
         END IF

c      o create records that must survive truncating JOBARC
         CALL PUTREC(20,'JOBARC','REFENERG',IINTFP,E)
         CALL PUTREC(20,'JOBARC','LASTGEOM',1,IZERO)
c      - these records are used by the new geometry stepping algorithms
         CALL GETREC(-1,'JOBARC','T_RADIUS',IINTFP,TRAD)
         CALL GETREC(-1,'JOBARC','PRDENCHN',IINTFP,PRD_ENRG_CHNG)
         CALL GETREC(-1,'JOBARC','PRVIUTAU',IINTFP,TAU)
         CALL GETREC(-1,'JOBARC','OLDENERG',IINTFP,TotEng)
         CALL PUTREC(20,'JOBARC','T_RADIUS',IINTFP,TRAD)
         CALL PUTREC(20,'JOBARC','PRDENCHN',IINTFP,PRD_ENRG_CHNG)
         CALL PUTREC(20,'JOBARC','PRVIUTAU',IINTFP,TAU)
         CALL PUTREC(20,'JOBARC','OLDENERG',IINTFP,TotEng)
c         - these three records are used by vee and vcceh
            CALL PUTREC(20,'JOBARC','PRINSPIN',1,IZERO)
            CALL PUTREC(20,'JOBARC','PRINFROM',IINTFP,E)
            CALL PUTREC(20,'JOBARC','PRININTO',IINTFP,E)
c      - these are used for "restarts"
         CALL PUTCREC(20,'JOBARC','PREVPTGP',4,'NONE')
         CALL PUTREC(0,'JOBARC','TGSSOCCA',8,0)
         CALL PUTREC(0,'JOBARC','TGSSOCCB',8,0)

c      o initialize the finite difference grid
         call init_fd(doit,natom,icore,icrsiz,nener,
     &                IFLAGS(1).GE.10)

         IF (.NOT.GMTRYOPT.AND.NENER.NE.0.AND.IRANK.EQ.0) THEN
c         o do the reference geom iff this is a vib freq calc with numerical
c           gradients and it is the root process
            PASS1=-1
         ELSE
            PASS1=1
         END IF
         CALL PUTREC(20,'JOBARC','PASS1',1,PASS1)
C The following record no matter how awkward it looks is essential. Note at
C this point we ran xjoda and there are certain records in JOBARC and then we
C add the "NEXTGEOM" record as a marker (initialized to junk at icore). Then we
C continue with vmol2ja and so on. In the next pass we are going  to fill the
C "NEXTGEOM" (see below the call to NEXTGEO) with proper data. The call to
C ACES_JA_TRUNCATE would delete all the records that comes after "NEXTGEOM"
C record. If we don't fixed the position of the "NEXTGEOM" record after the
C first JODA run, the records that are dependent on the symmetry get  written
C to the JOBARC before the "NEXTGEOM" appear and ACES_JA_TRUNCATE call would do
C nothing to erase them. Then When it times to run the lower symmtry points,
C the PUTREC is going to cry since we will be trying to change the record
C lengths!  Ajith Perera 08/2000.
         CALL PUTREC(20,'JOBARC','NEXTGEOM',3*NATOM*IINTFP,ICORE)
         IF (PASS1.EQ.-1) RETURN

      END IF

C THIS MUST BE CALLED ON EVERY PASS
C-----------------------------------------------------------------------
CJDW May/June 1996. Modified allocation for subroutine UPD_FD.
CJDW/AP Jul/1998. Extensions for Raman intensities.
C-----------------------------------------------------------------------

      I000=I0
      I010=I000 + IINTFP*9*NATOM*NATOM
      I020=I010 + IINTFP*9*NATOM*NATOM*3*NATOM
      I030=I020 + IINTFP*9*NATOM*NATOM*3
      I040=I030 + IINTFP*9*NATOM*NATOM*9
      I200=I040 + 9*NATOM*NATOM + IAND(NATOM,1)

      CALL UPD_FD(NATOM,DOIT,IMORE,
     &            ICORE(I000),ICORE(I010),ICORE(I020),ICORE(I030),
     &            ICORE(I040),ICORE(I200),(ICRSIZ-I200+I0)/IINTFP)

      IF (IMORE.EQ.1) THEN
c      o if there are more points, delete all the geometry-dependent records
         CALL ACES_JA_TRUNCATE('NEXTGEOM',1)
      ELSE
         CALL GETREC(-1,'JOBARC',DOIT//'NIRX',1,NIRREPF)
         IF (GMTRYOPT .OR. SNPTGRAD) THEN
            I010=I0
            I020=I010 + 3*NATOM + IAND(NATOM,1)
            I030=I020 + IINTFP*3*NATOM
            I200=I030 + IINTFP*3*NATOM
            CALL SETGRD(NATOM,NIRREPF,DOIT,
     &                  IRRNM,ICORE(I010),
     &                  ICORE(I020),ICORE(I030),
     &                  ICORE(I200),(ICRSIZ-I200+I0)/IINTFP
     &                 )
         ELSE
            CALL GETREC(20,'JOBARC','ORDERREF',1,IORDERF)
            I010=I0
            I011=I010 + 3*NATOM
            I012=I011 + 3*NATOM
            I020=I012 + IINTFP*9*IORDERF
            I030=I020 + IINTFP*9*NATOM*NATOM
            I040=I030 + IINTFP*9*NATOM*NATOM
            I050=I040 + IINTFP*9*NATOM
            I060=I050 + IINTFP*9*NATOM
            I070=I060 + IINTFP*9*NATOM*3
            I200=I070 + IINTFP*9*NATOM*3
            CALL SETFCM(NATOM,NIRREPF,IORDERF,DOIT,
     &                  IRRNM,ICORE(I010),ICORE(I011),ICORE(I012),
     &                  ICORE(I020),ICORE(I030),
     &                  ICORE(I040),ICORE(I050),
     &                  ICORE(I060),ICORE(I070),
     &                  ICORE(I200),(ICRSIZ-I200+I0)/IINTFP
     &                 )
         END IF

c      o signal the end of this findiff series
         call putrec(1,'JOBARC','FNDFDONE',1,1)

         PASS1=0
         CALL PUTREC(20,'JOBARC','PASS1',1,PASS1)
      END IF

c   o mark the symmetry of the previous geometry
      CALL GETCREC(20,'JOBARC','COMPPTGP',4,DOIT)
      CALL PUTCREC(20,'JOBARC','PREVPTGP',4,DOIT)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_DERV_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      NKIN1D,
     +                      NOVL1DX,NOVL1DY,NOVL1DZ,
     +                      MIJ,NIJ,NIJBEG,NIJEND,
     +                      NPGTOA,NPGTOB,
     +                      NXYZA,NXYZB,
     +                      SHELLA,SHELLB,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      DIFFA,DIFFB,
     +                      ALPHAA,ALPHAB,
     +                      CENSQX,CENSQY,CENSQZ,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      EA,EB,E2A,E2B,E2AB,
     +                      PAX,PAY,PAZ,PINVHF,SCALE,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_DERV_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__OVL_1D_AB_INTEGRALS
C                OED__OVL_1D_DERV_INTEGRALS
C                OED__KIN_1D_DERV_INTEGRALS
C                OED__KIN_DERV_INT1D_TO_00
C                OED__KIN_DERV_INT1D_TO_A0
C                OED__KIN_DERV_INT1D_TO_AB
C  DESCRIPTION : This operation calculates a batch of derivated unnormed
C                kinetic integrals between primitive cartesian gaussians
C
C                                  [A|B]
C                                       ij
C
C                for a block of ij exponent pairs. The total number
C                of kinetic integrals generated here is thus given by
C                the total number of cartesian monomials NXYZA * NXYZB
C                times the total number of exponent pairs MIJ in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyza*nxyzb)
C
C
C                  Input:
C
C                    NBATCH       =  size of the array that will hold
C                                    the final primitive cartesian
C                                    derivative integral batch as well
C                                    as intermediate differentiated
C                                    1D integrals
C                    NKIN1D       =  space needed for each of the
C                                    kinetic 1D X,Y,Z integral arrays
C                    NOVL1Dx      =  space needed for each of the 1D
C                                    overlap x = X,Y,Z integral arrays
C                                    (they might be different due to
C                                    different orders of differentiation
C                                    for each cartesian component)
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZx        =  # of cartesian monomials for
C                                    each contraction shell x = A,B
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERxp        =  the order of differentiation on
C                                    centers x = A,B with respect to
C                                    the p = x,y,z coordinates
C                    DIFFp        =  is true, if differentiation will
C                                    be performed on centers p = A,B
C                                    involving the p = x,y,z coordinates
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    CENSQp       =  derivative center sequence array
C                                    for the p = x,y,z coordinates
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    Ex           =  will hold current MIJ exponents
C                                    from centers x = A,B
C                    E2x          =  will hold current MIJ double
C                                    exponent values from centers
C                                    x = A,B
C                    E2AB         =  will hold current MIJ double
C                                    exponent products between centers
C                                    A and B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current MIJ values of
C                                    scaling factors
C                    EXP2x        =  will hold current double primitive
C                                    exponent values in MIJ order for
C                                    each contracted shell x = A,B
C                    KIN1Dx       =  will hold all current derivated
C                                    kinetic 1D integrals for each
C                                    cartesian component (x = X,Y,Z)
C                    OVL1Dx       =  will hold all current derivated
C                                    overlap 1D integrals for each
C                                    cartesian component (x = X,Y,Z)
C                                    during all stages of derivation
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    derivative cartesian kinetic
C                                    [A|B] integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFA,DIFFB
         LOGICAL     DIFFX,DIFFY,DIFFZ

         INTEGER     CENTER
         INTEGER     DERA,DERB
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DEROPA,DEROPB
         INTEGER     I,J,M,N
         INTEGER     IJ
         INTEGER     MIJ
         INTEGER     NBATCH
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NINT
         INTEGER     NKIN1D
         INTEGER     NOVL1DX,NOVL1DY,NOVL1DZ
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB,SHELLP

         INTEGER     CENSQX (0:NDERX)
         INTEGER     CENSQY (0:NDERY)
         INTEGER     CENSQZ (0:NDERZ)

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  PINV,PVAL
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,HALF,ONE,ONEP5,TWO

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  EA      (1:MIJ)
         DOUBLE PRECISION  EB      (1:MIJ)
         DOUBLE PRECISION  E2A     (1:MIJ)
         DOUBLE PRECISION  E2B     (1:MIJ)
         DOUBLE PRECISION  E2AB    (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)
         DOUBLE PRECISION  SCALE   (1:MIJ)

         DOUBLE PRECISION  KIN1DX  (1:NKIN1D)
         DOUBLE PRECISION  KIN1DY  (1:NKIN1D)
         DOUBLE PRECISION  KIN1DZ  (1:NKIN1D)
         DOUBLE PRECISION  OVL1DX  (1:NOVL1DX)
         DOUBLE PRECISION  OVL1DY  (1:NOVL1DY)
         DOUBLE PRECISION  OVL1DZ  (1:NOVL1DZ)

         PARAMETER  (ZERO  = 0.D0)
         PARAMETER  (HALF  = 0.5D0)
         PARAMETER  (ONE   = 1.D0)
         PARAMETER  (ONEP5 = 1.5D0)
         PARAMETER  (TWO   = 2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D kinetic integrals.
C
C
         M = 0
         DO IJ = NIJBEG,NIJEND
            M = M + 1
            I = PRIMA (M)
            J = PRIMB (M)
            EXPA = ALPHAA (I)
            EXPB = ALPHAB (J)
            EA (M) = EXPA
            EB (M) = EXPB
            E2AB (M) = TWO * EXPA * EXPB
            PINV = ONE / (EXPA + EXPB)
            PVAL = - EXPB * PINV
            PAX (M) = PVAL * ABX
            PAY (M) = PVAL * ABY
            PAZ (M) = PVAL * ABZ
            PINVHF (M) = HALF * PINV
            SCALE  (M) = (PINV ** ONEP5)
     +                   * NORMA (I) * NORMB (J) * RHOAB (IJ)
         END DO
C
C
C             ...calculate the derivative 1D overlap integral
C                coefficents (if needed). These are the double
C                exponent values for differentiation on centers
C                A and/or B.
C
C
         IF (DIFFA) THEN
             DO IJ = 1,MIJ
                I = PRIMA (IJ)
                E2A (IJ) = ALPHAA (I) + ALPHAA (I)
             END DO
         END IF

         IF (DIFFB) THEN
             DO IJ = 1,MIJ
                J = PRIMB (IJ)
                E2B (IJ) = ALPHAB (J) + ALPHAB (J)
             END DO
         END IF
C
C
C             ...start assembling the 1D A+1,B+1 derivative overlap
C                integrals. Assemble first the starting 1DX integrals
C                and perform differentiation sequence, if necessary.
C
C
         IF (DIFFX) THEN

             DERA = DERAX
             DERB = DERBX

             CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERA+DERB+2,
     +                      MIN (SHELLA+DERA+1,SHELLB+DERB+1),
     +                      SHELLA+DERA+1,SHELLB+DERB+1,
     +                      MIJ,
     +                      PAX,
     +                      PINVHF,
     +                      ABX,
     +                      BATCH,
     +
     +                                OVL1DX )
     +
     +
             DO N = 1,NDERX

                NINT = MIJ * (SHELLA+DERA+2) * (SHELLB+DERB+2)

                DO M = 1,NINT
                   BATCH (M) = OVL1DX (M)
                END DO

                CENTER = CENSQX (N)

                IF (CENTER.EQ.1) THEN
                    DEROPA = 1
                    DEROPB = 0
                ELSE
                    DEROPA = 0
                    DEROPB = 1
                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB

                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming ovlp x-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__kin_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__OVL_1D_DERV_INTEGRALS
     +
     +                       ( SHELLA+DERA+1,SHELLB+DERB+1,
     +                         DEROPA,DEROPB,
     +                         MIJ,
     +                         E2A,E2B,
     +                         BATCH,
     +
     +                                  OVL1DX )
     +
     +
             END DO

         ELSE

             CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+2,MIN (SHELLA+1,SHELLB+1),
     +                      SHELLA+1,SHELLB+1,
     +                      MIJ,
     +                      PAX,
     +                      PINVHF,
     +                      ABX,
     +                      BATCH,
     +
     +                                OVL1DX )
     +
     +
         END IF
C
C
C             ...assemble the starting 1DY AB integrals and perform
C                differentiation sequence, if necessary.
C
C
         IF (DIFFY) THEN

             DERA = DERAY
             DERB = DERBY

             CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERA+DERB+2,
     +                      MIN (SHELLA+DERA+1,SHELLB+DERB+1),
     +                      SHELLA+DERA+1,SHELLB+DERB+1,
     +                      MIJ,
     +                      PAY,
     +                      PINVHF,
     +                      ABY,
     +                      BATCH,
     +
     +                                OVL1DY )
     +
     +
             DO N = 1,NDERY

                NINT = MIJ * (SHELLA+DERA+2) * (SHELLB+DERB+2)

                DO M = 1,NINT
                   BATCH (M) = OVL1DY (M)
                END DO

                CENTER = CENSQY (N)

                IF (CENTER.EQ.1) THEN
                    DEROPA = 1
                    DEROPB = 0
                ELSE
                    DEROPA = 0
                    DEROPB = 1
                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB

                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming ovlp y-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__kin_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__OVL_1D_DERV_INTEGRALS
     +
     +                       ( SHELLA+DERA+1,SHELLB+DERB+1,
     +                         DEROPA,DEROPB,
     +                         MIJ,
     +                         E2A,E2B,
     +                         BATCH,
     +
     +                                  OVL1DY )
     +
     +
             END DO

         ELSE

             CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+2,MIN (SHELLA+1,SHELLB+1),
     +                      SHELLA+1,SHELLB+1,
     +                      MIJ,
     +                      PAY,
     +                      PINVHF,
     +                      ABY,
     +                      BATCH,
     +
     +                                OVL1DY )
     +
     +
         END IF
C
C
C             ...assemble the starting 1DZ AB integrals and perform
C                differentiation sequence, if necessary.
C
C
         IF (DIFFZ) THEN

             DERA = DERAZ
             DERB = DERBZ

             CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERA+DERB+2,
     +                      MIN (SHELLA+DERA+1,SHELLB+DERB+1),
     +                      SHELLA+DERA+1,SHELLB+DERB+1,
     +                      MIJ,
     +                      PAZ,
     +                      PINVHF,
     +                      ABZ,
     +                      BATCH,
     +
     +                                OVL1DZ )
     +
     +
             DO N = 1,NDERZ

                NINT = MIJ * (SHELLA+DERA+2) * (SHELLB+DERB+2)

                DO M = 1,NINT
                   BATCH (M) = OVL1DZ (M)
                END DO

                CENTER = CENSQZ (N)

                IF (CENTER.EQ.1) THEN
                    DEROPA = 1
                    DEROPB = 0
                ELSE
                    DEROPA = 0
                    DEROPB = 1
                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB

                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming ovlp z-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__kin_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__OVL_1D_DERV_INTEGRALS
     +
     +                       ( SHELLA+DERA+1,SHELLB+DERB+1,
     +                         DEROPA,DEROPB,
     +                         MIJ,
     +                         E2A,E2B,
     +                         BATCH,
     +
     +                                  OVL1DZ )
     +
     +
             END DO

         ELSE

             CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+2,MIN (SHELLA+1,SHELLB+1),
     +                      SHELLA+1,SHELLB+1,
     +                      MIJ,
     +                      PAZ,
     +                      PINVHF,
     +                      ABZ,
     +                      BATCH,
     +
     +                                OVL1DZ )
     +
     +
         END IF
C
C
C             ...combine the 1D X,Y,Z A+1,B+1 derivative overlap
C                integrals to the 1D X,Y,Z AB kinetic integrals.
C
C
         CALL    OED__KIN_1D_DERV_INTEGRALS
     +
     +                ( SHELLA,SHELLB,
     +                  MIJ,
     +                  EA,EB,E2AB,
     +                  OVL1DX,OVL1DY,OVL1DZ,
     +
     +                            KIN1DX,
     +                            KIN1DY,
     +                            KIN1DZ )
     +
     +
C
C
C             ...assemble the 1D AB derivative overlap integrals
C                and the 1D AB derivative kinetic integrals to the
C                [A|B] batch.
C
C
         IF (SHELLP.EQ.0) THEN

             CALL    OED__KIN_DERV_INT1D_TO_00
     +
     +                    ( MIJ,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      EA,EB,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLB.EQ.0) THEN

             CALL    OED__KIN_DERV_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      MIJ,
     +                      NXYZA,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      EA,EB,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE
             CALL    OED__KIN_DERV_INT1D_TO_AB
     +
     +                    ( SHELLA,SHELLB,
     +                      MIJ,
     +                      NXYZA,NXYZB,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      EA,EB,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE GEN_REDNINTRNLS(CARTCOORD, REDUNCO, INTLABEL,
     &                           IBNDTO, BMATRX, GMATRX,
     &                           TOTREDNCO, IATOMICNMBER, NRATMS,
     &                           IREDUNCO, TOTNOFBND, TOTNOFANG, 
     &                           TOTNOFDIH, BTGMIN, EIGVECTORS)
C
C Generate the famous B matrix (Molecular vibrations, Wilson, Decius 
C and Cross)  that transform the difference Cartesian corrdiantes to 
C the rectilinear nternal coordinates (the curvelinear and rectilinear 
C are identical for small displacements. The transformations matix is
C generated by using the formuals given in Pariseau et al. JCP, 2335, 
C 1965 and a good description of rec. and curv. coordinates can be 
C found in Hoy et al.. Molecular Physics, 1266, 1972.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "mxatms.par"
#include "io_units.par"
C 
      PARAMETER(THRESHOLD = 5.0D00, EPSILON = 1.0D-10)
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH,
     &        FRAGSCR
      CHARACTER*4 INTLABEL(MAXREDUNCO)
C
C The following arrays need to be managed dynamically:
C
C BNDLENGTHS: Keep the bond lengths of atom pairs. It is
C             of length MXATMS*MXATMS
C IATOMICNMBER: Keep the atomic numbers of all atoms and
C               it is MAXATMS long.
C SMOFCOVRAD: The sum of covalent radius of pairs of atoms
C             and of MXATMS*MXATMS long.
C NCONPRCNTR: The number of connectivities for an atom. The
C             maximum number is set to 10, so this is a
C             rather small (it is not currently being
C             used, but needs in the future).
      DIMENSION CARTCOORD(3*MXATMS), BNDLENTHS(MXATMS, MXATMS), 
     &          IATOMICNMBER(MXATMS), SMOFCOVRADI(MXATMS, MXATMS),
     &          IBNDTO(MXATMS*MXATMS), NCONPRCNTR(MXATMS),
     &          IREDUNCO(4, MAXREDUNCO), BMATRX(9*MXATMS*MXATMS),
     &          GMATRX(9*MXATMS*MXATMS), REDUNCO(MAXREDUNCO),
     &          MARK_FRAGMENTS(MXATMS, MXATMS),
     &          LENGTH_FRAGMENTS(MXATMS),FRAGSCR(MXATMS*MXATMS)
      DIMENSION EIGVECTORS(MAXREDUNCO, MAXREDUNCO),
     &          BTGMIN(3*NRATMS,MAXREDUNCO),BLNGT_IJFRGS(MXATMS)
#include "ric_heap.com"
C      
      DATA  IZERO /0/
C
      TOTREDNCO = IZERO
C
C Assign Connectivities: We need this to proceed! At this point this is 
C some what experimental. We need to improve this to include hydrogen 
C bonds, dimer bonds and so on. This should be improved as we gain 
C more experience with this stuff.
C     
#ifdef _DEBUG_LVL0
      Print*, "Entering assign connectivities"
#endif 
      CALL ASIGN_CNTVTES(CARTCOORD, BNDLENTHS, IATOMICNMBER, 
     &                   SMOFCOVRADI, NCONPRCNTR, IBNDTO, MAXCNTVS,
     &                   NRATMS, MARK_FRAGMENTS, LENGTH_FRAGMENTS,
     &                   FRAGSCR, BLNGT_IJFRGS)
C 
C Assign bond length Coordinates.
C
#ifdef _DEBUG_LVL0 
      Print*, "Entering assign bonds"
      Write(6,*)
#endif 

      CALL ASSIGN_BONDS(IBNDTO, IREDUNCO, TOTREDNCO, TOTNOFBND, NRATMS,
     &                  MAXREDUNCO)
C
C Assign bond angle Coordinates.
C
#ifdef _DEBUG_LVL0
      Print*, "Entering assign angles"
      Print*, "Total # of bonds:", TOTNOFBND
#endif 

      CALL ASSIGN_ANGLS(CARTCOORD, IBNDTO, IREDUNCO, TOTREDNCO,
     &                  TOTNOFBND, TOTNOFANG, NRATMS, MAXREDUNCO,
     &                  THRESHOLD)
C
C Assign bond dihedral angle Coordinates.
C
#ifdef _DEBUG_LVL0 
      Print*, "Entering assign dihedral angles"
      Print*, "Total # of Angles:", TOTNOFANG 
#endif 

      CALL ASSIGN_DIHLS(IBNDTO, IREDUNCO, TOTREDNCO, TOTNOFBND,
     &                  TOTNOFANG, NRATMS, TOTNOFDIH, MAXREDUNCO)
C
C Assign dihedral angles for nearly planar structures.
C
#ifdef _TRY_LINEAR_DIHS
C
C This is a highly experimental version to handle molecules that
C are linear since there are no dihedral when 3 or 4 atoms are
C linear. 
      IF (TOTNOFDIH .EQ. IZERO) THEN
#ifdef _DEBUG_LVL0
      Print*, "Entering assign planar dihedrals"
#endif 

         CALL ASSIGN_DIHLSNPL(CARTCOORD, IBNDTO, IREDUNCO, TOTREDNCO, 
     &                        TOTNOFBND, TOTNOFANG, TOTNOFDIH, NRATMS, 
     &                        MAXREDUNCO, THRESHOLD)
      ENDIF
#endif
C
C Assign Label for redundent internal coordinates.
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "Entering assign lables"
      Print*, "Total # of dihedrals:", TOTNOFDIH 
      Print*, "The total redundent internal", TOTREDNCO 
#endif 

      CALL ASSIGN_LABELS(IREDUNCO, TOTREDNCO, TOTNOFBND, TOTNOFANG,
     &                   TOTNOFDIH, INTLABEL)
#ifdef _DEBUG_LVL0
      Print*, "The redundent internal coordinates assignments"
      Write(6,*)
      Do i = 1, TOTREDNCO
         Write(6,111) (iredunco(j, i), j=1, 4)
      Enddo
 111  Format(5X, 4(I3, 1X))

#endif 
C
C Make sure the number of RICs has not increased.
C
      CALL GETREC(0,'JOBARC','REDNCORD',ITMP,0)
      IF (ITMP.GE.0) THEN
         CALL GETREC(1,'JOBARC','REDNCORD',1,ITMP)
         IF (ITMP.LT.TOTREDNCO) THEN
            WRITE(*,*) '@GEN_REDNINTRNLS: The number of internal ',
     &                 'coordinates has increased.'
            WRITE(*,*) '                  At the very least, this ',
     &                 'system has become unstable.'
            CALL ERREX
         END IF
      END IF
C
C Now built the B and G matrices.
C
#ifdef _DEBUG_LVL0 
      Write(6,*)
      Print*, "Entering B and G matrix generation"
      Write(6,*)
#endif 
      CALL BUILT_BGMTRX(CARTCOORD, REDUNCO, IREDUNCO, TOTREDNCO,
     &                  TOTNOFBND, TOTNOFANG, TOTNOFDIH, 
     &                  NRATMS, BMATRX, GMATRX, 
     &                  EIGVECTORS,EPSILON,BTGMIN,dRICHeap(z_DerBMat))
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Print*, "The redundent internal coordinates:"
      write(6,*)
      Write(6, 9) (redunco(i), I=1, TOTREDNCO)
  9   Format (5(1X,F10.6))
#endif

C
C some labels for internal coords...
C   
CSSS      CALL OUTPUT(BMATRX, 1, TOTREDNCO, 1, 3*NRATMS, TOTREDNCO, 
CSSS     &            3*NRATMS, 1)
C
      RETURN
      END

      SUBROUTINE GEN_REDNINTRNLS(CARTCOORD, REDUNCO, INTLABEL,
     &                           IBNDTO, BMATRX, GMATRX,
     &                           TOTREDNCO, IATOMICNMBER, NRATMS,
     &                           IREDUNCO, TOTNOFBND, TOTNOFANG, 
     &                           TOTNOFDIH, BTGMIN, EIGVECTORS)
C
C Generate the famous B matrix (Molecular vibrations, Wilson, Decius 
C and Cross)  that transform the difference Cartesian corrdiantes to 
C the rectilinear nternal coordinates (the curvelinear and rectilinear 
C are identical for small displacements. The transformations matix is
C generated by using the formuals given in Pariseau et al. JCP, 2335, 
C 1965 and a good description of rec. and curv. coordinates can be 
C found in Hoy et al.. Molecular Physics, 1266, 1972.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
C 
      PARAMETER(THRESHOLD = 5.0D00, EPSILON = 1.0D-10)
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH,
     &        FRAGSCR
      CHARACTER*4 INTLABEL(MAXREDUNCO)
C
C The following arrays need to be managed dynamically:
C
C BNDLENGTHS: Keep the bond lengths of atom pairs. It is
C             of length MXATMS*MXATMS
C IATOMICNMBER: Keep the atomic numbers of all atoms and
C               it is MAXATMS long.
C SMOFCOVRAD: The sum of covalent radius of pairs of atoms
C             and of MXATMS*MXATMS long.
C NCONPRCNTR: The number of connectivities for an atom. The
C             maximum number is set to 10, so this is a
C             rather small (it is not currently being
C             used, but needs in the future).
      DIMENSION CARTCOORD(3*MXATMS), BNDLENTHS(MXATMS, MXATMS), 
     &          IATOMICNMBER(MXATMS), SMOFCOVRADI(MXATMS, MXATMS),
     &          IBNDTO(MXATMS*MXATMS), NCONPRCNTR(MXATMS),
     &          IREDUNCO(4, MAXREDUNCO), BMATRX(9*MXATMS*MXATMS),
     &          GMATRX(9*MXATMS*MXATMS), REDUNCO(MAXREDUNCO),
     &          MARK_FRAGMENTS(MXATMS, MXATMS),
     &          LENGTH_FRAGMENTS(MXATMS),FRAGSCR(MXATMS*MXATMS)
      DIMENSION EIGVECTORS(MAXREDUNCO, MAXREDUNCO),
     &          BTGMIN(3*NRATMS,MAXREDUNCO),BLNGT_IJFRGS(MXATMS)
c ric_heap.com : begin

c This common block contains the heap address and array indices for
c processing RICs. New additions must be initialized to 1 in
c bd_ric_heap.F and set in init_ric_heap.F.

      external bd_ric_heap

      double precision dRICHeap(1)
      integer          z_RICHeap, z_DerBMat, z_BMat, z_GMat, z_BTGInv

      common /ric_heap_com/ dRICHeap,
     &                      z_RICHeap, z_DerBMat, z_BMat, z_GMat,
     &                      z_BTGInv
      save   /ric_heap_com/

c ric_heap.com : end
C      
      DATA  IZERO /0/
C
      TOTREDNCO = IZERO
C
C Assign Connectivities: We need this to proceed! At this point this is 
C some what experimental. We need to improve this to include hydrogen 
C bonds, dimer bonds and so on. This should be improved as we gain 
C more experience with this stuff.
C     
      Print*, "Entering assign connectivities"
      CALL ASIGN_CNTVTES(CARTCOORD, BNDLENTHS, IATOMICNMBER, 
     &                   SMOFCOVRADI, NCONPRCNTR, IBNDTO, MAXCNTVS,
     &                   NRATMS, MARK_FRAGMENTS, LENGTH_FRAGMENTS,
     &                   FRAGSCR, BLNGT_IJFRGS)
C 
C Assign bond length Coordinates.
C
      Print*, "Entering assign bonds"
      Write(6,*)

      CALL ASSIGN_BONDS(IBNDTO, IREDUNCO, TOTREDNCO, TOTNOFBND, NRATMS,
     &                  MAXREDUNCO)
C
C Assign bond angle Coordinates.
C
      Print*, "Entering assign angles"
      Print*, "Total # of bonds:", TOTNOFBND

      CALL ASSIGN_ANGLS(CARTCOORD, IBNDTO, IREDUNCO, TOTREDNCO,
     &                  TOTNOFBND, TOTNOFANG, NRATMS, MAXREDUNCO,
     &                  THRESHOLD)
C
C Assign bond dihedral angle Coordinates.
C
      Print*, "Entering assign dihedral angles"
      Print*, "Total # of Angles:", TOTNOFANG 

      CALL ASSIGN_DIHLS(IBNDTO, IREDUNCO, TOTREDNCO, TOTNOFBND,
     &                  TOTNOFANG, NRATMS, TOTNOFDIH, MAXREDUNCO)
C
C Assign dihedral angles for nearly planar structures.
C
C
C Assign Label for redundent internal coordinates.
C
      Write(6,*)
      Print*, "Entering assign lables"
      Print*, "Total # of dihedrals:", TOTNOFDIH 
      Print*, "The total redundent internal", TOTREDNCO 

      CALL ASSIGN_LABELS(IREDUNCO, TOTREDNCO, TOTNOFBND, TOTNOFANG,
     &                   TOTNOFDIH, INTLABEL)
      Print*, "The redundent internal coordinates assignments"
      Write(6,*)
      Do i = 1, TOTREDNCO
         Write(6,111) (iredunco(j, i), j=1, 4)
      Enddo
 111  Format(5X, 4(I3, 1X))

C
C Make sure the number of RICs has not increased.
C
      CALL GETREC(0,'JOBARC','REDNCORD',ITMP,0)
      IF (ITMP.GE.0) THEN
         CALL GETREC(1,'JOBARC','REDNCORD',1,ITMP)
         IF (ITMP.LT.TOTREDNCO) THEN
            WRITE(*,*) '@GEN_REDNINTRNLS: The number of internal ',
     &                 'coordinates has increased.'
            WRITE(*,*) '                  At the very least, this ',
     &                 'system has become unstable.'
            CALL ERREX
         END IF
      END IF
C
C Now built the B and G matrices.
C
      Write(6,*)
      Print*, "Entering B and G matrix generation"
      Write(6,*)
      CALL BUILT_BGMTRX(CARTCOORD, REDUNCO, IREDUNCO, TOTREDNCO,
     &                  TOTNOFBND, TOTNOFANG, TOTNOFDIH, 
     &                  NRATMS, BMATRX, GMATRX, 
     &                  EIGVECTORS,EPSILON,BTGMIN,dRICHeap(z_DerBMat))
      Write(6,*) 
      Print*, "The redundent internal coordinates:"
      write(6,*)
      Write(6, 9) (redunco(i), I=1, TOTREDNCO)
  9   Format (5(1X,F10.6))

C
C some labels for internal coords...
C   
CSSS      CALL OUTPUT(BMATRX, 1, TOTREDNCO, 1, 3*NRATMS, TOTREDNCO, 
CSSS     &            3*NRATMS, 1)
C
      RETURN
      END

      subroutine rdecp(iunit,iecp,npecp,ncore,llmax,kfirst,klast,
     &                 nlp,clp,zlp,lmxecp,max27,igotit)

      implicit double precision (a-h,o-z)
c
c read pseudopotential parameters
c design as follows :
c --- <nickname> (as for basis sets)
c --- * (indicates start of data) (this is the actual position)
c --- ncore=<...> llmax=<...>
c     ncore = number of core electrons
c     llmax = lmax+1 where lmax = max. l-quantum number within core
C     note that lsymb(i+1)=type corresponding to l-quantum number i
c     lsymb(1)=s,lsymb(2)=p and so on
c --- <lsymb(llmax)>
c     ... data for lmax+1 
c --- loop : l=0,...,lmax
c --- <lsymb(l)>-<lsymb(llmax)>
c     ... data for l
c --- end of loop
c --- * (indicates end of data)
c
c input : lmxecp = max. allowed value for llmax (now, lmxecp<=7)
c
      dimension npecp(iecp),nlp(max27),clp(max27),zlp(max27),
     1          kfirst(lmxecp),klast(lmxecp)

      character*80 zeile,scrzl
      character*8 lsymb
      character cdummy
c
      data lsymb /'spdfghij'/
c
c --- provide the offsets (sum over ecp's 1,...,iecp-1)
c
      noff=0
      do  i=1, iecp-1
          noff=noff+npecp(i)
      enddo

      noffst=noff
c
      igotit=-1
c
c--- initialize kfirst and klast to 1 and 0, respectively
c
      do i=1,lmxecp
        kfirst(i)=1
        klast(i)=0
      enddo 
      
      Write(6,*)
c
c     --- get ncore,llmax for the new ecp
c
  100 read(iunit,'(a)',end=900) zeile
      call wisch(zeile,80)

      if(zeile(1:1).eq.' '.or.zeile(1:1).eq.'#') goto 100

c --- asterisk terminates input

      if(zeile(1:1).eq.'*') goto 900

      icore=index(zeile,'NCORE')
      ilmax=index(zeile,'LMAX')
      scrzl=zeile(icore+5:80)

      call rdebbs(scrzl,80,1,0,0,isucc,iwert,rdummy,cdummy)

      if(isucc.le.0) then
        write(6,'(/,2x,a,/)')
     1   'CANNOT READ NCORE = NUMBER OF CORE ELECTRONS'
        return
      endif

      ncore=iwert 

      scrzl=zeile(ilmax+4:80)
      call rdebbs(scrzl,80,1,0,0,isucc,iwert,rdummy,cdummy)

      if(isucc.le.0) then
        write(6,'(/,2x,a,/)')
     1   'CANNOT READ LMAX = MAX. L-QUANTUM NUMBER'
        return
      endif

      llmax=iwert
c
c --- loop : look for strings of the type <l> or <k-l> with
c     k,l out of s,p,d,f,g,h,i 

      lsvtyp=0

  200 read(iunit,'(a)',end=900) zeile
      call wisch(zeile,80)

      if(zeile(1:1).eq.' '.or.zeile(1:1).eq.'#') goto 200
C
c  --- asterisk terminates input
c
      if(zeile(1:1).eq.'*') then
        if(lsvtyp.gt.0) klast(lsvtyp)=noff
        goto 250
      endif

c --- data for l=ltyp

      ltyp=0
      do 210 ityp=1,lmxecp
        if(zeile(1:1).eq.lsymb(ityp:ityp)) ltyp=ityp
  210 continue 

      if(ltyp.eq.0.and.lsvtyp.eq.0) stop ' scheisse '


      if(ltyp.gt.llmax+1) then
        write(6,'(/,2x,a,/)')
     1   'ecp data are for an illegal l-quantum number'
        return
      endif

      if(ltyp.eq.0) then

        noff=noff+1

        if(noff.gt.max27) then
          write(6,'(/,2x,a,/)') 'too many primitive ecp terms'
          call errex
        endif

        call rdebbs(zeile,80,0,1,0,isucc,idummy,rwert,cdummy)

        if(isucc.le.0) then
          write(6,'(/,2x,a,/)')
     1          'error in reading coefficient of gaussian'
          return
        endif

        clp(noff)=rwert

        call rdebbs(zeile,80,1,0,0,isucc,iwert,rdummy,cdummy)

        if(isucc.le.0) then
          write(6,'(/,2x,a,/)') 'error in reading exponent of r'
          return
        endif

        nlp(noff)=iwert

        call rdebbs(zeile,80,0,3,0,isucc,idummy,rwert,cdummy)

        if(isucc.le.0) then
          write(6,'(/,2x,a,/)')
     1     'error in reading exponent of gaussian'
          return
        endif

        zlp(noff)=rwert

      elseif(ltyp.gt.0) then

        kfirst(ltyp)=noff+1
        if(lsvtyp.gt.0) klast(lsvtyp)=noff
        lsvtyp=ltyp

      endif

      goto 200

  250 continue

      npecp(iecp)= noff-noffst
      igotit=1
c
      ifscr=kfirst(llmax+1)
      ilscr=klast(llmax+1)

      do i=llmax,1,-1
        kfirst(i+1)=kfirst(i)
        klast(i+1)=klast(i)
      enddo
     
      kfirst(1)=ifscr
      klast(1)=ilscr
c
      return
c
  900 continue
      write(6,'(/,2x,a,/)') 'RDECP : END OF FILE ENCOUNTERED - SORRY'
      return
c
      end

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It performs selection of maximal overlap from the overlap    |
C      table of current eom root                                |
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|

      subroutine eomovermax
     +                 (array_table,
     *                  narray_table, index_table,
     *                  nindex_table, segment_table, nsegment_table,
     *                  block_map_table, nblock_map_table,
     *                  scalar_table, nscalar_table,
     *                  address_table, op)

c--------------------------------------------------------------------------
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'epsilon.h'
      include 'daveom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index,iarray,daddr
      integer stack
      integer nsend
      integer array_type, evec_type
      integer comm
      integer sind, ind(mx_array_index),root_index
      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(mx_array_index), findex(mx_array_index)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2,n1,n2
      integer*8 addr, get_index_from_base
      double precision x(1)


      double precision overmax_index

#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------|
c   Locate the data for the input matrix which is to be analyses.           |
c   First array: set of overlaps for current root                           |
c---------------------------------------------------------------------------|

      array      = op(c_result_array)
      array_type = array_table(c_array_type, array)
      sind =  array_table(c_scalar_index, array)

      root_index = scalar_table(sind)  


c---------------------------------------------------------------------------|
c               Selection of maximal root                                   |
c---------------------------------------------------------------------------|

                 IF(RL.eq.1) then
                 overmax_index = DavOverRmax(root_index)
                 ENDIF

                 IF(RL.eq.0) then
                 overmax_index = DavOverLmax(root_index)
                 ENDIF

        

c---------------------------------------------------------------------------|
c   Scalar part: the output scalar will contain index of root               |
c                   with maximal overlap                                    |
c---------------------------------------------------------------------------|

      array = op(c_op1_array)
      array_type = array_table(c_array_type, array)
      sind =  array_table(c_scalar_index, array)

      scalar_table(sind) = overmax_index


      return
      end
c===========================================================================|
c===========================================================================|



C---------------------------------------------------------------------------|

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      double precision function dacosd(angle_in_radians)
      implicit none
      double precision angle_in_radians
      double precision a180_div_pi,zilch

      zilch=0.0d0
      a180_div_pi=90.0d0/acos(zilch)
      dacosd = acos(angle_in_radians)*a180_div_pi
      return
      end

      Subroutine Ecp_int_4shell(Cint, Ecpint_4shell, La, Lb, Numcoi,
     &                          Numcoj, Indnpri, Indnprj, Iprim, Jprim,
     &                          Jnt, Grads)

      Implicit Double Precision (A-H, O-Z)
      Logical Grads

#include "ecp.par"
#include "ecp.com"
      
      Dimension Cint(*), Ecpint_4shell(*)

      If (Grads) Then
         La_lo = Istart_grd(La)
         La_hi = Iend_grd(La)
         Lb_lo = Istart(Lb)
         Lb_hi = Iend(Lb)
      Else
         La_lo = Istart(La)
         La_hi = Iend(La)
         Lb_lo = Istart(Lb)
         Lb_hi = Iend(Lb)
      Endif
      Int   = 0
      Jnt   = 0
C
       Do Ia = La_lo, La_hi
          Do Ib = Lb_lo, Lb_hi
             Int = Int + 1

             Do Icon = 1, Numcoi
                Do Jcon = 1, Numcoj
                   Jnt = Jnt + 1
                   Ecpint_4shell(Jnt) = Ecpint_4shell(Jnt) +
     &                                  Cint(Int)*
     &                                  Contr(Indnpri, Icon)*
     &                                  Contr(Indnprj, Jcon)*Fpi
C
#ifdef _DEBUG_LVL0
      Write(6, "(a,2(1x,I4))") "Jnt: ", Jnt
      Write(6,"(a,2(1x,I2))")
     &"Contracting ECP integral for primitive pair", Iprim, Jprim
      Write(6,"(2(1x,F20.13))")Contr(Indnpri,Icon),Contr(Indnprj,JCon)
      Write(6,"(2(1x,F20.13))")Ecpint_4shell(Jnt),Cint(Int)
#endif
                Enddo
             Enddo

          Enddo
       Enddo
       
       Return
       End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C     FORMS THREE DIMENSIONAL ROTATION MATRIX
C     (IX=0 IF ANG IN RADS,
C      IX=1 IF DEG,
C      ADD 10 TO IX TO GET TRANSPOSE)

      SUBROUTINE ROTM( IAXIS, ANG, IX, RT )
      implicit double precision (a-h,o-z)

      integer iaxis, ix
      dimension rt(3,3)

      integer iaxis1, iaxis2

      CALL ZERO(RT,9)
      IF (mod(IX,10).EQ.1) THEN
         TANG=ANG*DACOS(-1.D0)/180.D0
      ELSE
         TANG=ANG
      END IF

      if (ix/10.gt.0) then
         sign = -1.d0
      else
         sign = 1.0d0
      end if

c     next two axes
c     --  really mod( (iaxis-1)+1, 3 ) + 1 (clock, not mod, arithmetic)
      iaxis1 = mod(iaxis ,3)+1
      iaxis2 = mod(iaxis1,3)+1

      rt(iaxis,iaxis) = 1.0 d0
      RT(iaxis1,iaxis1) = COS(TANG)
      RT(iaxis2,iaxis2) = COS(TANG)

      rt(iaxis1,iaxis2) = sin(tang) * sign
      rt(iaxis2,iaxis1) = -rt(iaxis1,iaxis2)

      RETURN
      END

      SUBROUTINE BLTAOTOSO(I2,ITRAN,CUN,CONTUN,CTEMP,NU,NR,AT,KABS,
     &                  I1,NXYZ,NUC,NRC,NBAS,CORR,KA,C,JCO,PT,
     &                  TITLE,JTRAN,A,CTRAN,ICDS,NDEG,CHARGT,X,
     &                  IAD,NFUNMX,NHT2,KWD,NH4,
     &                  JtranC, ITranC, CTranC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C-----------------------------------------------------------------------
C     (Other) Parameters
C-----------------------------------------------------------------------
C

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

C
      PARAMETER (NPRIMX = 10)
      PARAMETER (NCONTS = 15, NCONTP = 8, NCONTD = 4)
      PARAMETER (NCONTF = 2, NCONTG = 1)
      PARAMETER (NCONTH = 1, NCONTI = 1)
C-----------------------------------------------------------------------
      INTEGER  NAMN(MXCBF),LAMN(MXTNSH),MAMN(MXCBF)
      INTEGER  IAD(NHT2)
      INTEGER  IFBA(100)
      INTEGER  NCONTR(7)
C
      character*6 kaset
      character*6 slask
      character*8 hblnk
      character*8 nanum(8)
      character*1 ispd(7)
      character*1 ko(3)
      character*1 kka(8,3) 
      character*1 iblank
      character*2 koko(3)
      character*4 kwo(84)
      character*4 jprx(MXCBF)
      character*4 jjprx(MXCBF)
      character*4 kktyp(84,2)
      character*6 iblnk
cch
      INTEGER   AND,OR,EOR,DSTRT
      LOGICAL IFIF,LPRT,LHARM,DELE,LABBASIS_EXIST
      DIMENSION NXBAS(8),JCNTAM(28,7),KDELB(200)
      DIMENSION I2(21), ITRAN(MXCBF,224), CUN(MXTNCC),
     1            CONTUN(MXTNCC), CTEMP(NFUNMX,NFUNMX), 
     2            NU(NFUNMX), NR(NFUNMX), AT(NFUNMX),
     3            KABS(MXSHEL,28,15,8)
      dimension iadq(8),charm(1596)
C SG 6/25/97 Changed to agree with Stanton's code to use 500 functions
      dimension last(MXCBF),iast(MXCBF)
      dimension nast(MXCBF),jaast(MXCBF)
C
C     DIMENSION I1(50),NXYZ(KWD,3),NUC(NHT2,25),NRC(NHT2,25),
      DIMENSION I1(50),NXYZ(KWD,3),NUC(NHT2,NFUNMX),NRC(NHT2,NFUNMX),
     1 NBAS(8),
     2 CORR(100,3),KA(8,3),C(MXTNCC),JCO(NHT2),PT(8),TITLE(18),
     3 JTRAN(MxCBF),A(50),CTRAN(MxCBF,224),
     4 ICDS(MXTNPR), NDEG(100), CHARGT(100), X(3)
C
C     To hold SOAO matrix pointers for cartesian basis
C
      Integer JTranC(MxCBF), ITranC(MxCBF, 224)
      Double precision CTranC(MxCBF, 224)
C
      DOUBLE PRECISION CJUNK(MxCBF*MxCBF)
C
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD 
      COMMON /REP/ NEWIND(MXCBF) , MSTOLD(8) 
      COMMON /INDX/ PC(512),DSTRT(8,MXCBF),NTAP,LU2,NRSS,NUCZ,ITAG,
     1 MAXLOP,MAXLOT,KMAX,NMAX,KHKT(7),MULT(8),ISYTYP(3),ITYPE(7,28),
     2 AND(8,8),OR(8,8),EOR(8,8),NPARSU(8),NPAR(8),MULNUC(100),
     3 NHKT(MXTNSH),MUL(MXTNSH),NUCO(MXTNSH),NRCO(MXTNSH),JSTRT(MXTNSH),
     4 NSTRT(MXTNSH),MST(MXTNSH),JRS(MXTNSH)
      COMMON /DAT/  ALPHA(MXTNPR),CONT(MXTNCC),CENT(3,MXTNSH),
     1              CORD(100,3),CHARGE(100),FMULT(8),TLA, TLC
      COMMON /SYMIND/ LABORB(MXCBF)
      COMMON /FLAGS/ IFLAGS(100)
C
      DATA IECPU /35/
      DATA INU /5/, IF10 /0/, IF18 /0/
      DATA HBLNK/'        '/
      DATA JCNTAM /
     & 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     & 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     & 0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     & 0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     & 0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     & 0,0,0,0,0,1,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     & 0,0,0,0,0,0,0,0,0,1,0,0,1,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1/
C
      DATA LUGRAD /36/, LUT /6/, LUAUX /62/, LUSCR /13/
C
      DATA NANUM /'       1','       2','       3','       4',
     1            '       5','       6','       7','       8'/
      DATA ISPD /'s', 'p','d','f','g','h','i'/
      DATA KO /'X','Y','Z'/   , IBLANK /' '/
      DATA KOKO /'YZ','XZ','XY'/
      DATA (KWO(I),I=1,56)
     O         /'S   ', 'X   ', 'Y   ', 'Z   ',
     1          'XX  ', 'XY  ', 'XZ  ', 'YY  ',
     2          'YZ  ', 'ZZ  ', 'F300', 'F210',
     3          'F201', 'F120', 'F111', 'F102',
     4          'F030', 'F021', 'F012', 'F003',
     5          'G400', 'G310', 'G301', 'G220',
     6          'G211', 'G202', 'G130', 'G121',
     7          'G112', 'G103', 'G040', 'G031',
     8          'G022', 'G013', 'G004', 'H500',
     9          'H410', 'H401', 'H320', 'H311',
     O          'H302', 'H230', 'H221', 'H212',
     1          'H203', 'H140', 'H131', 'H122',
     2          'H113', 'H104', 'H050', 'H041',
     3          'H032', 'H023', 'H014', 'H005'/
      data (kwo(i),i=57,84) /
     $ 'I600', 'I510', 'I501', 'I420', 'I411', 'I402',
     $ 'I330', 'I321', 'I312', 'I303', 'I240', 'I231',
     $ 'I222', 'I213', 'I204', 'I150', 'I141', 'I132',
     $ 'I123', 'I114', 'I105', 'I060', 'I051', 'I042',
     $ 'I033', 'I024', 'I015', 'I006'/
      DATA NCONTR /NCONTS, NCONTP, NCONTD, NCONTF, NCONTG,
     $ NCONTH, NCONTI/
      data iadq/0,1,10,46,146,371,812,1596/
      data (charm(i),i = 1,146) /1,  1,0,0, 0,1,0, 0,0,1,
     D       -1., 0 , 0 ,-1., 0 , 2.,
     D        0 , 1., 0 , 0 , 0 , 0 ,
     D        0 , 0 , 1., 0 , 0 , 0 ,
     D        1., 0 , 0 ,-1., 0 , 0 ,
     D        0 , 0 , 0 , 0 , 1., 0 ,
     D        1., 0 , 0 , 1., 0 , 1.,
     F       -1., 0 , 0 ,-1., 0 , 4 , 0 , 0 , 0 , 0 ,
     F        0 ,-1., 0 , 0 , 0 , 0 ,-1., 0 , 4 , 0 ,
     F        0 , 0 ,-3., 0 , 0 , 0 , 0 ,-3., 0 , 2.,
     F        1., 0 , 0 ,-3., 0 , 0 , 0 , 0 , 0 , 0 ,
     F        0 , 0 , 0 , 0 , 1., 0 , 0 , 0 , 0 , 0 ,
     F        1., 0 , 0 , 1., 0 , 1., 0 , 0 , 0 , 0 ,
     F        0 , 3., 0 , 0 , 0 , 0 ,-1., 0 , 0 , 0 ,
     F        0 , 0 , 1., 0 , 0 , 0 , 0 ,-1., 0 , 0 ,
     F        0 , 1., 0 , 0 , 0 , 0 , 1., 0 , 1., 0 ,
     F        0 , 0,  1., 0 , 0 , 0 , 0 , 1., 0 , 1./
      data (charm(i),i = 147,371) /
     G  3., 0 , 0 , 6 , 0 ,-24, 0 , 0 , 0 , 0 , 3., 0 ,-24, 0 , 8 ,
     G  0 ,-1., 0 , 0 , 0 , 0 ,-1., 0 , 6 , 0 , 0 , 0 , 0 , 0 , 0 ,
     G  0 , 0 ,-3., 0 , 0 , 0 , 0 ,-3., 0 , 4 , 0 , 0 , 0 , 0 , 0 ,
     G  1., 0 , 0 ,-6 , 0 , 0 , 0 , 0 , 0 , 0 , 1., 0 , 0 , 0 , 0 ,
     G  0 , 0 , 0 , 0 , 3., 0 , 0 , 0 , 0 , 0 , 0 ,-1., 0 , 0 , 0 ,
     G -1., 0 , 0 , 0 , 0 , 6 , 0 , 0 , 0 , 0 , 1., 0 ,-6 , 0 , 0 ,
     G  0 , 1., 0 , 0 , 0 , 0 ,-1., 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
     G  0 , 0 , 1., 0 , 0 , 0 , 0 ,-3., 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
     G  0 , 1., 0 , 0 , 0 , 0 , 1., 0 , 1., 0 , 0 , 0 , 0 , 0 , 0 ,
     G  0 , 0 , 1., 0 , 0 , 0 , 0 , 1., 0 , 1., 0 , 0 , 0 , 0 , 0 ,
     G  1., 0 , 0 , 2., 0 , 2., 0 , 0 , 0 , 0 , 1., 0 , 2., 0 , 1.,
     G  0 , 0 , 0 , 0 ,-3., 0 , 0 , 0 , 0 , 0 , 0 ,-3., 0 , 4 , 0 ,
     G  1., 0 , 0 , 0 , 0 , 1., 0 , 0 , 0 , 0 ,-1., 0 ,-1., 0 , 0 ,
     G  0 , 0 , 0 , 0 , 1., 0 , 0 , 0 , 0 , 0 , 0 , 1., 0 , 1., 0 ,
     G -1., 0 , 0 ,-2., 0 , 1., 0 , 0 , 0 , 0 ,-1., 0 , 1., 0 , 2./
      DATA (charm(I),I = 372,539) /
     H  1.,0.,0.,2.,0.,-12.,0.,0.,0.,0.,1.,0.,
     H    -12.,0.,8.,0.,0.,0.,0.,0.,0.,
     H  0.,1.,0.,0.,0.,0.,2.,0.,-12.,0.,0.,0.,
     H     0.,0.,0.,1.,0.,-12.,0.,8.,0.,
     H  0.,0.,-1.,0.,0.,0.,0.,0.,0.,2.,0.,0.,
     H     0.,0.,0.,0.,1.,0.,-2.,0.,0.,
     H -1.,0.,0.,2.,0.,8.,0.,0.,0.,0.,3.,0.,
     H    -24.,0.,0.,0.,0.,0.,0.,0.,0.,
     H  0.,0.,0.,0.,1.,0.,0.,0.,0.,0.,0.,-1.,
     H     0.,0.,0.,0.,0.,0.,0.,0.,0.,
     H  1.,0.,0.,2.,0.,2.,0.,0.,0.,0.,1.,0.,
     H     2.,0.,1.,0.,0.,0.,0.,0.,0.,
     H  0.,5.,0.,0.,0.,0.,-10.,0.,0.,0.,0.,0.,
     H     0.,0.,0.,1.,0.,0.,0.,0.,0.,
     H  0.,0.,1.,0.,0.,0.,0.,-6.,0.,0.,0.,0.,
     H     0.,0.,0.,0.,1.,0.,0.,0.,0. /
      DATA (charm(I),I = 540,707) /
     H  0.,-3.,0.,0.,0.,0.,-2.,0.,24.,0.,0.,0.,
     H     0.,0.,0.,1.,0.,-8.,0.,0.,0.,
     H  0.,0.,15.,0.,0.,0.,0.,30.,0.,-40.,0.,0.,
     H     0.,0.,0.,0.,15.,0.,-40.,0.,8.,
     H  1.,0.,0,-10.,0.,0.,0.,0.,0.,0.,5.,0.,
     H     0.,0.,0.,0.,0.,0.,0.,0.,0.,
     H  0.,0.,0.,0.,1.,0.,0.,0.,0.,0.,0.,1.,
     H     0.,1.,0.,0.,0.,0.,0.,0.,0.,
     H  1.,0.,0.,-2.,0.,1.,0.,0.,0.,0.,-3.,0.,
     H    -3.,0.,0.,0.,0.,0.,0.,0.,0.,
     H  0.,0.,0.,0.,-1.,0.,0.,0.,0.,0.,0.,-1.,
     H     0.,2.,0.,0.,0.,0.,0.,0.,0.,
     H -1.,0.,0.,-2.,0.,3.,0.,0.,0.,0.,-1.,0.,
     H     3.,0.,4.,0.,0.,0.,0.,0.,0.,
     H  0.,1.,0.,0.,0.,0.,2.,0.,2.,0.,0.,0.,
     H     0.,0.,0.,1.,0.,2.,0.,1.,0. /
      DATA (charm(I),I = 708,812) /
     H  0.,0.,1.,0.,0.,0.,0.,2.,0.,2.,0.,0.,
     H     0.,0.,0.,0.,1.,0.,2.,0.,1.,
     H  0.,3.,0.,0.,0.,0.,2.,0.,3.,0.,0.,0.,
     H     0.,0.,0.,-1.,0.,-1.,0.,0.,0.,
     H  0.,0.,1.,0.,0.,0.,0.,0.,0.,1.,0.,0.,
     H     0.,0.,0.,0.,-1.,0.,-1.,0.,0.,
     H  0.,-1.,0.,0.,0.,0.,-2.,0.,3.,0.,0.,0.,
     H     0.,0.,0.,-1.,0.,3.,0.,4.,0.,
     H  0.,0.,-3.,0.,0.,0.,0.,-6.,0.,-1.,0.,0.,
     H     0.,0.,0.,0.,-3.,0.,-1.,0.,2. /
      DATA (charm(I),I = 813,980) /
     I   1.,   0.,   0., -15.,   0.,   0.,   0.,   0.,   0.,   0.,
     I  15.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -1.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   1.,   0.,   0.,   0.,   0.,   2.,   0., -16.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   1.,   0., -16.,   0.,  16.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   1.,   0.,   0.,   0.,   0., -10.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   5.,   0.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I  -1.,   0.,   0.,   5.,   0.,  10.,   0.,   0.,   0.,   0.,
     I   5.,   0., -60.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -1.,   0.,  10.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   5.,   0.,   0.,   0.,   0.,   0.,
     I   0., -10.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   1.,   0.,   0.,   0.,   0.,   0.,
     I   1.,   0.,   0.,   1.,   0., -16.,   0.,   0.,   0.,   0.,
     I  -1.,   0.,   0.,   0.,  16.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -1.,   0.,  16.,   0., -16.,   0.,   0. /
      DATA (charm(I),I = 981,1148) /
     I   0.,   6.,   0.,   0.,   0.,   0., -20.,   0.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   6.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,  -3.,   0.,   0.,   0.,   0.,   6.,   0.,   8.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   9.,   0., -24.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -4.,   0.,   0.,   0.,   0.,   0.,   0.,  40.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   4.,   0., -40.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   1.,   0.,   0.,   0.,   0.,  -2.,   0.,   1.,
     I   0.,   0.,   0.,   0.,   0.,   0.,  -3.,   0.,  -3.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I  -5.,   0.,   0., -15.,   0.,  90.,   0.,   0.,   0.,   0.,
     I -15.,   0., 180.,   0.,-120.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -5.,   0.,  90.,   0.,-120.,   0.,  16.,
     I   0.,   0.,   0.,   0.,  -9.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -6.,   0.,  24.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   3.,   0.,  -8.,   0.,   0.,   0. /
      DATA (charm(I),I = 1149,1316) /
     I   1.,   0.,   0.,  -5.,   0.,   1.,   0.,   0.,   0.,   0.,
     I  -5.,   0.,  -6.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   1.,   0.,   1.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   0.,   0.,  10.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  20.,   0., -40.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,  10.,   0., -40.,   0.,  16.,   0.,
     I  -1.,   0.,   0.,  -1.,   0.,   5.,   0.,   0.,   0.,   0.,
     I   1.,   0.,   0.,   0.,   6.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   1.,   0.,  -5.,   0.,  -6.,   0.,   0.,
     I   0.,  -1.,   0.,   0.,   0.,   0.,  -2.,   0.,   5.,   0.,
     I   0.,   0.,   0.,   0.,   0.,  -1.,   0.,   5.,   0.,   6.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,  10.,   0.,   0.,   0.,   0.,  20.,   0., -40.,
     I   0.,   0.,   0.,   0.,   0.,   0.,  10.,   0., -40.,   0.,
     I  16.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   1.,   0.,   0.,   0.,   0.,   0.,   0.,   1.,   0.,
     I   0.,   0.,   0.,   0.,   0.,  -1.,   0.,  -1.,   0.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0. /
      DATA (charm(I),I = 1317,1484) /
     I   0.,   0.,  -3.,   0.,   0.,   0.,   0.,  -6.,   0.,   1.,
     I   0.,   0.,   0.,   0.,   0.,   0.,  -3.,   0.,   1.,   0.,
     I   4.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   1.,   0.,   0.,   0.,   0.,   2.,   0.,   2.,   0.,
     I   0.,   0.,   0.,   0.,   0.,   1.,   0.,   2.,   0.,   1.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   1.,   0.,   0.,   0.,   0.,   2.,   0.,   2.,
     I   0.,   0.,   0.,   0.,   0.,   0.,   1.,   0.,   2.,   0.,
     I   1.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     I  -1.,   0.,   0.,  -3.,   0.,   0.,   0.,   0.,   0.,   0.,
     I  -3.,   0.,   0.,   0.,   3.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -1.,   0.,   0.,   0.,   3.,   0.,   2.,
     I   0.,   0.,   0.,   0.,   3.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   2.,   0.,   3.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,  -1.,   0.,  -1.,   0.,   0.,   0.,
     I   1.,   0.,   0.,   1.,   0.,   2.,   0.,   0.,   0.,   0.,
     I  -1.,   0.,   0.,   0.,   1.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -1.,   0.,  -2.,   0.,  -1.,   0.,   0. /
      DATA (charm(I),I = 1485,1596) /
     I   0.,   0.,   0.,   0.,  -3.,   0.,   0.,   0.,   0.,   0.,
     I   0.,  -6.,   0.,   1.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,  -3.,   0.,   1.,   0.,   4.,   0.,
     I   3.,   0.,   0.,   9.,   0., -21.,   0.,   0.,   0.,   0.,
     I   9.,   0., -42.,   0., -16.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   3.,   0., -21.,   0., -16.,   0.,   8.,
     I   0.,   0.,   0.,   0.,   1.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   2.,   0.,   2.,   0.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   0.,   1.,   0.,   2.,   0.,   1.,   0.,
     I   1.,   0.,   0.,   3.,   0.,   3.,   0.,   0.,   0.,   0.,
     I   3.,   0.,   6.,   0.,   3.,   0.,   0.,   0.,   0.,   0.,
     I   0.,   1.,   0.,   3.,   0.,   3.,   0.,   1. /
      DATA (KKTYP(I,1),I = 1,84) /'S000', 'P100', 'P010', 'P001',
     1            'D200', 'D110', 'D101', 'D020', 'D011', 'D002',
     2            'F300', 'F210', 'F201', 'F120', 'F111', 'F102',
     3            'F030', 'F021', 'F012', 'F003',
     4            'G400', 'G310', 'G301', 'G220', 'G211', 'G202',
     5            'G130', 'G121', 'G112', 'G130', 'G040', 'G031',
     6            'G022', 'G031', 'G004',
     7            'H500', 'H410', 'H401', 'H320', 'H311', 'H302',
     8            'H230', 'H221', 'H212', 'H203', 'H140', 'H131',
     9            'H122', 'H113', 'H104', 'H050', 'H041', 'H032',
     O            'H023', 'H014', 'H005',
     1            'I600', 'I510', 'I501', 'I420', 'I411', 'I402',
     1            'I330', 'I321', 'I312', 'I303', 'I240', 'I231',
     1            'I222', 'I213', 'I204', 'I150', 'I141', 'I132',
     1            'I123', 'I114', 'I105', 'I060', 'I051', 'I042',
     1            'I033', 'I024', 'I015', 'I006'/
      DATA (KKTYP(I,2),I = 1,84) /'1s  ', '2px ', '2py ', '2pz ',
     1            '3d0 ', '3d2-', '3d1+', '3d2+', '3d1-', '3s  ',
     2            '4f1+', '4f1-', '4f0 ', '4f3+', '4f2-', '4px ',
     3            '4f3-', '4f2+', '4py ', '4pz ',
     4            '5g0 ', '5g2-', '5g1+', '5g4+', '5g3-', '5g2+',
     5            '5g4-', '5g3+', '5d2-', '5d1+', '5s  ', '5g1-',
     6            '5d2+', '5d1-', '5d0' ,
     H '6h1+','6h1-','6h2+','6h3+','6h4-','6px ','6h5-','6h4+','6h3-',
     H   '6h0 ','6h5+','6f2-','6f3+','6h2-','6f1+','6py ','6pz ',
     H   '6f3-','6f2+','6f1-','6f0 ',
     I            '7i6+', '7i2-', '7i5+', '7i4+', '7i5-', '7i2+',
     I            '7i6-', '7i3+', '7i4-', '7g3+', '7i0 ', '7i3-',
     I            '7g4+', '7i1-', '7g2+', '7g2-', '7i1+', '7g4-',
     I            '7g1+', '7d2-', '7d1+', '7d0 ', '7g3-', '7d2+',
     I            '7g1-', '7g0 ', '7d1-', '7s  '/
      DATA IBLNK/'      '/
      DATA NCMAX /100/
C
C...  STATEMENT FUNCTIONS
C
      PTAND(I,J) = PC(AND(I,J))
C
C  OPEN INPUT FILE MOL
C
      OPEN(UNIT=INU,FILE='MOL',FORM='FORMATTED',STATUS='OLD')
      OPEN(UNIT=LUSCR,FILE='VMSCR1',FORM='UNFORMATTED',STATUS='UNKNOWN')
C
      IPRINT = IFLAGS(1)
      IECP=0
      ISTATS=0
      ID3=0 
      TLA=1.D-10 
      SCALE=0.0
      JUNK=1
      NONT=1 
      TLC=0.D0
      NTAP=2

      DO 3335 I = 1, 3
         ISYTYP(I) = 1
 3335 CONTINUE
C
      NM=0
      DO I = 0, NHT2
         DO IX = I, 0, -1
            DO  IY =I-IX, 0, -1
               NM = NM + 1
               NXYZ(NM,1) = IX
               NXYZ(NM,2) = IY
               NXYZ(NM,3) = I-IX-IY
            ENDDO
         ENDDO
      ENDDO
C
      PI=2.D0*DACOS(0.0D00)
      PIPPI=(0.5D0/PI)**0.75D0
C
C-----------------------------------------------------------------------
C     Begin reading the MOL file.
C-----------------------------------------------------------------------
C
      READ(INU,83383) SLASK,IGENER,IF10,IF18,IECP,IECPU,IJUNK,
     &                INUTMP,ISTATS,NHARM,IDELA,IDELB,IBORTH
83383 FORMAT(A6,4X,12I5)
C
      IF (SLASK .EQ. 'SUPMAT') THEN
         WRITE(6,88777) 
         CALL ERREX
      ENDIF
88777 FORMAT(///,'* * * *  THIS CODE DOES NOT GENERATE SUPERMATRICES',
     1         '  * * * *')
C
      LHARM = NHARM .EQ. 0
C
      IF (LHARM) THEN
        IDOSPH = 1
      ELSE
         IDOSPH = 0
         idela=1
      ENDIF
C
      IF (INUTMP .NE. 0) INU = INUTMP
      LPRT=.FALSE.
      IF(IPRINT.GE.1)LPRT = .TRUE.
C
      READ(INU, 833) TITLE
  833 FORMAT (9A8)
C
C-----------------------------------------------------------------------
C Read number of nuclear types (NONTYP), symmetry information
C NSYMOP, KKA), tolerances (TLA, TLC), and coordinate units (ID3).
C IRSTRT is not used anywhere.
C-----------------------------------------------------------------------
      READ(INU,8800) NONTYP, NSYMOP, ((KKA(J,I),I=1,3),J=1,3),
     1              TLA,  TLC, ID3, IRSTRT
8800  FORMAT(2I5,9A1,1X,E10.2,E10.2,I5,I5)
C
      IF (TLC.eq.0.0) TLC=0.1*TLA
      READ(INU,180)TIML,SAFL
 180  FORMAT (2F10.5)
C
C-----------------------------------------------------------------------
C     Process symmetry information and construct symmetry arrays.
C-----------------------------------------------------------------------
C
C MAXLOP = NUMBER OF IRREDUCIBLE REPRESENTATIONS,
C THE LOOPS ARE ALWAYS FROM 1 TO MAXLOP
C
C ISYTYP DETERMINES THE BEHAVIOUR OF X,Y,Z UNDER THE SYMMETRY
C OPERATIONS: BIT 1,2,3 ARE SET TO ONE IF X, OR Y OR Z ARE
C CHANGING UNDER THIS PARTICULAR OPERATIONS.
C !ATTENTION! ISYTYP IS INITIALIZED TO 1 AND NOT TO 0 IN VMOL.
C THIS HAS TO BE CONSIDERED BY USING THE DEFINITION OF ISYTYP
C GIVEN ABOVE!
C EXAMPLE: ISYTYP(2)=2 MEANS THE VALUE OF Y CHANGES UNDER
C          1 SYMMETRYOPERATION.
C GENERATORS:
C NSYMOP: NUMBER OF GENERATORS,
C MAXLOP: NUMBER OF SYMMETRYOPERATIONS (NUMBER OF IRREPS).
C
      MAXLOP=2**NSYMOP
C
      IF(NSYMOP.GT.0) THEN
         DO J=1,NSYMOP
            NBL=1
            DO I=1,3
               IF (KKA(J,I).EQ.IBLANK) NBL=NBL+1
               DO K=1,3
                  IF (KKA(J,I).EQ.KO(K)) ISYTYP(K)=ISYTYP(K)+2**(J-1)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
C
C Determine KA(I,J), PT(I), MULT(I) and FMULT(I)
C KA, PT: fixed
C MULT (FMULT): depend only on the value of NSYMOP
C
      DO I=1,8
         IS = 0
         DO K=1,3
            KA(I,K)=(I-1)/(2**(K-1))-2*((I-1)/(2**K))
            IS=IS+KA(I,K)
         ENDDO
         PT(I)=(-1.0)**IS
         MULT(I)=2**MAX0(0,NSYMOP-IS)
         FMULT(I)=DFLOAT(MULT(I))
      ENDDO
C
      DO I=1,8
         DO J=1,8
            IAN=1
            IOR=1
            DO K=1,3
               IAN=IAN+MIN0(KA(I,K),KA(J,K))*2**(K-1)
               IOR=IOR+MAX0(KA(I,K),KA(J,K))*2**(K-1)
            ENDDO
            AND(I,J)=IAN
            OR(I,J)=IOR
            EOR(I,J)=IOR-IAN+1
         ENDDO
      ENDDO
C
C CREATE ITYPE-ARRAY
C ITYPE(1,1)=1: BEHAVIOUR OF R^0 (NO CHANGE OF SIGN AT ALL!)
C ITYPE(2,1..3)=ISYTYP(1..3): BEHAVIOUR OF R^1 (X, Y, Z)
C AND SO ON UP TO R^6.
C
      ITYPE(1,1)=1
      NDO=0
      NFO=0
      NGO=0
      NHO=0
      NIO=0
C
      DO JQM=1,3
         ITYPE(2,JQM)=ISYTYP(JQM)
         DO KQM=JQM,3
            NDO=NDO+1
            ITYPE(3,NDO) = EOR(ISYTYP(JQM),ISYTYP(KQM))
            DO LQM=KQM,3
               NFO=NFO+1
               ITYPE(4,NFO)=EOR(ITYPE(3,NDO),ISYTYP(LQM))
               DO M2M=LQM,3
                  NGO=NGO+1
                  ITYPE(5,NGO)=EOR(ITYPE(4,NFO),ISYTYP(M2M))
                  DO M3M=M2M,3
                     NHO=NHO+1
                     ITYPE(6,NHO)=EOR(ITYPE(5,NGO),ISYTYP(M3M))
                     DO M4M=M3M,3
                        NIO=NIO+1
                        ITYPE(7,NIO)=EOR(ITYPE(6,NHO),ISYTYP(M4M))
                     ENDDO
                  ENDDO   
               ENDDO
            ENDDO
         ENDDO
      ENDDO
C
C ENTARTUNG OF L-QUANTUM NUMBERS 1-7
C
      DO JJ=1,7
         KHKT(JJ)=JJ*(JJ+1)/2
      ENDDO
C
C RUN OVER TYPES OF ATOMS IN THE MOLECULE
C
      KMAX=0
      LMAX=0
      LLMAX = 0
      LLMAX = 0
      NMAX=0
      MAXLO=8
      NHTYP=2
C-----------------------------------------------------------------------
C     Begin loop over center (nuclear) types.
C-----------------------------------------------------------------------
      DO I=1,NONTYP
         DO J = 1,5
            IAD(J) = 0
         ENDDO
C
         READ(INU,11) KASET, Q,NONT,IQM,(JCO(J),J=1,IQM), IGENES
 11      FORMAT (A6,F14.8,12I5)
         LUBAS = INU
         IQM4 = MAX0(IQM,1)
         NMIN=NMAX+1
C     
C LOOP OVER SYMMETRY INDEPENDENT ATOMS IN THE MOLECULE
C
         DO N=1, NONT
C
C NMAX IS THE TOTAL NUMBER OF SYMMETRY INDEPENDENT ATOMS
C     
            NMAX = NMAX + 1
            IF (NMAX .LE. NCMAX) GO TO 113
            WRITE(6,1305) NCMAX
 1305       FORMAT ('1',5X,'SPACE LIMITATION ENCOUNTERED IN READIN'
     1         /11X,'NUMBER OF CENTERS EXCEEDS',I4)
            CALL ERREX
C
 113        IFBA(NMAX) = IQM
            READ(INU,12)NAMN(NMAX),(CORD(NMAX,J),J=1,3),IDX
 12         FORMAT (A4,3F20.12,I5)
            IF (IDX .EQ. 0) GO TO 115
            READ(INU,30)(CORD(NMAX,J),J=1,3)
 30         FORMAT (3F20.5)
 115        CONTINUE
C
            IF (ID3 .EQ. 1) THEN
               DO J=1,3
                  CORD(NMAX,J)=CORD(NMAX,J)/0.5291771
               ENDDO
            ENDIF
         ENDDO
C-----------------------------------------------------------------------
C     End loop over symmetry inequivalent centers of each type.
C-----------------------------------------------------------------------
         IMAX=0
         IIMAX = 0
         IF(IQM.EQ.0) GO TO 1272
C-----------------------------------------------------------------------
C     Loop over angular momentum for each nuclear type.
C-----------------------------------------------------------------------
         DO J=1,IQM
            KM=JCO(J) + IAD(J)
C
 13         FORMAT (10I5)
 211        FORMAT(8F10.4)
 213        FORMAT(4F18.4)
 14         FORMAT (8F9.4)
C
C
            IF (JCO(J) .EQ. 0 .AND. IAD(J) .EQ. 0) GOTO 2
C-----------------------------------------------------------------------
C     Loop over shells of each angular momentum. Read number of primit-
C     ives and contracted functions.
C-----------------------------------------------------------------------
            DO K = 1, KM
               IF (IGENER .EQ. 0 .AND. IGENES .EQ. 0) THEN
                  READ(LUSCR) NUC(J,K), NRC(J,K)
               ELSE
                  IF (K .LE. JCO(J)) THEN
                     READ(LUBAS,13) NUC(J,K), NRC(J,K)
                  ELSE
                     READ(INU,13) NUC(J,K), NRC(J,K)
                  ENDIF
               ENDIF
C
               IF(NUC(J,K) .GT. NFUNMX)THEN
               WRITE(6,*)' @READIN-F, Too many primitives in this shell'
               WRITE(6,*) '             Value is ',NUC(J,K)
               WRITE(6,*) '             Limit is ',NFUNMX
               CALL ERREX
               ENDIF
C
               IF(NRC(J,K) .GT. NFUNMX)THEN
               WRITE(6,*)' @READIN-F, Too many cont. fns. in this shell'
               WRITE(6,*) '             Value is ',NRC(J,K)
               WRITE(6,*) '             Limit is ',NFUNMX
               CALL ERREX
               ENDIF
C
               IMIN = IMAX+1
               IMAX = IMAX+NUC(J,K)
C-----------------------------------------------------------------------
C Loop over primitives in each shell, reading exponents and cont-
C raction coefficients.
C-----------------------------------------------------------------------
               DO LL = 1, NUC(J,K)
C
                  IF (IGENER .EQ. 0 .AND. IGENES .EQ. 0) THEN
                     READ(LUSCR) A(IMIN-1+LL), (CTEMP(LL,MC), 
     &                           MC = 1, NRC(J,K))
                  ELSE
                     IF (KASET .NE. '      ') THEN
                        IF (K .LE. JCO(J)) THEN
                           IF (IF10 .EQ. 1) THEN
                              READ(LUBAS,211) A(IMIN-1+LL),
     &                                     (CTEMP(LL,MC),MC=1,NRC(J,K))
                           ELSE
                              READ(LUBAS,14) A(IMIN-1+LL),
     &                                     (CTEMP(LL,MC),MC=1,NRC(J,K))
                           ENDIF
C
C SCALE S FUNCTIONS IF DESIRED
C     
                           IF (J .EQ. 1 .AND. SCALE .NE. 0.) THEN
                              DO L = IMIN, IMAX
                                 A(L) = A(L)*SCALE*SCALE
                              ENDDO
                           ENDIF
                        ELSE
                           IF (IF10 .EQ. 1) THEN
                              READ(INU,211) A(IMIN-1+LL),
     &                                     (CTEMP(LL,MC),MC=1,NRC(J,K))
                           ELSE
                              READ(INU,14) A(IMIN-1+LL), 
     &                                     (CTEMP(LL,MC),MC=1,NRC(J,K))
                           ENDIF
                        ENDIF
                     ELSE
                        IF(IF18.EQ.1)GO TO 88212
                        IF(IF10.EQ.1)GO TO 88210
C
                        READ(INU,14) A(IMIN-1+LL), 
     &                              (CTEMP(LL,MC),MC = 1,NRC(J,K))
                        GO TO 88215
C
88210                   CONTINUE
                        READ(INU,211) A(IMIN-1+LL), 
     &                               (CTEMP(LL,MC),MC = 1,NRC(J,K))
                        GO TO 88215
C
88212                   CONTINUE
                        READ(INU,213) A(IMIN-1+LL), 
     &                                (CTEMP(LL,MC),MC = 1,NRC(J,K))
C
88215                   CONTINUE
                     ENDIF
                  ENDIF
               ENDDO
C
C NOW RENORMALIZE COEFFICIENT ARRAY AND MOVE FROM CTEMP TO C.
C INPUT COEFFICIENTS (POSSIBLY UNNORMALIZED) ARE HELD IN CUN.
C
               IF (IBORTH .EQ. 0) THEN
C
C Loop over contracted functions in each shell.
C
                  DO MC = 1, NRC(J,K)
                     IIMIN = IIMAX
                     SUM = 0.
                     DO LL = 1, NUC(J,K)
                        AL = A(IMIN-1+LL)
                        DO LM = 1, LL
                           AM = A(IMIN-1+LM)
                           T = CTEMP(LL,MC)*CTEMP(LM,MC)*
     &                         (2.0*DSQRT(AL*AM)/(AL+AM))**(J+0.5)
                           SUM = SUM + T
                           IF (LL .NE. LM) SUM = SUM + T
                        ENDDO
                     ENDDO

                     XNORM = 1./DSQRT(SUM)
                     DO LL = 1, NUC(J,K)
                        AL = A(IMIN-1+LL)
                        CUN(IIMIN+LL) = CTEMP(LL,MC)
                        C(IIMIN+LL) = CTEMP(LL,MC)*PIPPI*
     &                                XNORM*(4.*AL)**(0.5*J+0.25)
                     ENDDO
                     IIMAX = IIMAX + NUC(J,K)
C-----------------------------------------------------------------------
C     End of loop over contracted functions.
C-----------------------------------------------------------------------
                  ENDDO
               ELSE
C-----------------------------------------------------------------------
C     Loop over contracted functions in each shell.
C-----------------------------------------------------------------------
                  DO MB = 1, NRC(J,K)
                     IIMIN = IIMAX
                     DO MC = 1, MB
                        SUM = 0.0D0
                        DO LL = 1, NUC(J,K)
                           AL = A(IMIN-1+LL)
                           DO LM = 1, NUC(J,K)
                              AM = A(IMIN-1+LM)
                              T = CTEMP(LL,MB)*CTEMP(LM,MC)*
     &                            (2.0*DSQRT(AL*AM)/(AL+AM))**(J+0.5)
                              SUM = SUM+T
                           ENDDO
                        ENDDO
C
                        IF (MC .eq. MB) THEN
                           DO ll=nuc(j,k),1,-1
                              if(abs(ctemp(ll,mc)).gt.0.1) goto 88202
                           ENDDO
C
                           Write(6,*)' Normalization failed. C<0.1'
                           CALL ERREX
C
88202                      ac=ctemp(ll,mc)/abs(ctemp(ll,mc))
C
                           DO LL = 1, NUC(J,K)
                              AL = A(IMIN-1+LL)
                              ctemp(ll,mc) = ac*ctemp(ll,mc)/sqrt(SUM)
                              CUN(IIMIN+LL) = CTEMP(LL,MC)
                              C(IIMIN+LL)=CTEMP(LL,MC)*PIPPI*
     &                                    (4.*AL)**(0.5*J+0.25)
                           ENDDO
                           IIMAX = IIMAX + NUC(J,K)
                        ELSE
                           DO  LL=1, NUC(J,K)
                              CTEMP(LL,MB) = CTEMP(LL,MB) -
     &                                       SUM*CTEMP(LL,MC)
                           ENDDO
                        ENDIF
                     ENDDO
                  ENDDO
C-----------------------------------------------------------------------
C End of loop over contracted functions.
C-----------------------------------------------------------------------
               ENDIF
C
            ENDDO
C-----------------------------------------------------------------------
C End of loop over shells of each angular momentum.
C-----------------------------------------------------------------------
            IF (IGENER .NE.0.OR.IGENES.NE.0) JCO(J) = JCO(J) + IAD(J)
 2          CONTINUE
C
         ENDDO
C-----------------------------------------------------------------------
C End of loop over angular momentum for each nuclear type.
C-----------------------------------------------------------------------
C
 1272    CONTINUE
C
C-----------------------------------------------------------------------
C Loop over centers of current type, fill arrays with exponents,
C contraction coefficients, symmetry information, and data for each
C shell.
C-----------------------------------------------------------------------
         DO N = NMIN,NMAX
C
C-----------------------------------------------------------------------
C Load up exponents of primitives.
C-----------------------------------------------------------------------
            IF(LMAX+IMAX .GT. MXTNPR)THEN
               WRITE(6,*)' @READIN-F, Too many primitives. Limit is ',
     &                   MXTNPR
               CALL ERREX
            ENDIF
C
            DO L=1,IMAX
               ALPHA(L+LMAX) = A(L)
            ENDDO
            LMAX = LMAX + IMAX
C
C-----------------------------------------------------------------------
C Load up contraction coefficients.
C-----------------------------------------------------------------------
            IF(LLMAX+IIMAX .GT. MXTNCC)THEN
               WRITE(6,*)' @READIN-F, Too many contraction coefficients'
               WRITE(6,*)' The limit is', MXTNCC
               CALL ERREX
            ENDIF
C
            DO L=1,IIMAX
               CONTUN(L+LLMAX) = CUN(L)
               CONT(L+LLMAX) = C(L)
            ENDDO
            LLMAX = LLMAX+ IIMAX
            MULK=1
            LL=1
            DO L=1,NSYMOP
               DO M=1,3
                  IF(AND(LL+1,ISYTYP(M)).NE.1 .AND. 
     &               ABS(CORD(N,M)).GE.1.E-6) GO TO 9

               ENDDO
               MULK=MULK+LL
 9             CONTINUE
               LL=2*LL
            ENDDO
C     
            MAXLO=AND(MULK,MAXLO)
            MULNUC(N)=MULK
            CHARGE(N)=Q
            NHTYP=MAX0(NHTYP,IQM)
C
            IF (.NOT.(IQM.EQ.0))THEN
               DO J=1,IQM
                  JCOJ=JCO(J)
                  DO K=1,JCOJ
                     KMAX=KMAX+1
C
                     IF(KMAX .GT. MXTNSH)THEN
                        WRITE(6,*) ' @READIN-F, Too many shells.'
                        WRITE(6,*) ' Limit is ',MXTNSH
                        CALL ERREX
                     ENDIF
C     
                     NUCO(KMAX)=NUC(J,K)
                     NRCO(KMAX) = NRC(J,K)
                     LAMN(KMAX)=NAMN(N)
                     MUL(KMAX)=MULK
                     NHKT(KMAX)=J
C
                     DO M=1,3
                        CENT(M,KMAX)=CORD(N,M)
                     ENDDO
C
                  ENDDO
               ENDDO
            ENDIF
C
         ENDDO
      ENDDO
C
C-----------------------------------------------------------------------
C End of loop over nuclear types. All of MOL file has now been read.
C-----------------------------------------------------------------------
C
      if(idelb .gt. 0) read 828, (kdelb(i), i=1,idelb)
 828  format (25i3)
C
      NPARSU(1)=0
      MST(1) = 0
      NORB=1
      norxb=0
C
C Tracks the number of deleted orbitals and where
C their symmetry transformations are stored
C
      NOrbDel = MxCBF
C     
      IBBAS=0
      DO LA=1,MAXLOP
         IF(LA.EQ.1) IABAS=0
         KABAS=0
         NBAS(LA)=0
         JSTRT(1)=0
         JRS(1) = 0
         NSTRT(1)=0
         DO IA=1,KMAX
            NHKTA=NHKT(IA)
            KHKTA=KHKT(NHKTA)
            IF(IA.NE.KMAX) THEN
               JSTRT(IA+1)=JSTRT(IA)+NUCO(IA)
               JRS(IA+1) = JRS(IA) + NRCO(IA) * NUCO(IA)
               NSTRT(IA+1)=NSTRT(IA)+KHKTA
            ENDIF
            DO NA=1,KHKTA
               MXYZ=((NHKT(IA)+1)*NHKT(IA)*(NHKT(IA)-1))/6+NA
               IFIF = AND(MUL(IA),EOR(LA,ITYPE(NHKT(IA),NA))) .EQ. 1
               DO JAA = 1, NRCO(IA)
                  JKB=0
                  DO KB=1,MAXLOP
                     IF (.NOT.(AND(KB,MUL(IA)) . NE . 1)) THEN
                        JKB=JKB+1
                        KABAS=KABAS+1
C
                        IF(NORB.GT.MXCBF)THEN
                           WRITE(6,*)' @READIN-F, NORB too large ',NORB
                           CALL ERREX
                        ELSEIF(JKB.GT.224)THEN
                           WRITE(6,*)' @READIN-F, JKB too large ',JKB
                           CALL ERREX
                        ENDIF
C
                        CTRAN(NORB,JKB)=
     $                  PC(AND(KB,EOR(LA,ITYPE(NHKT(IA),NA))))
                        ITRAN(NORB,JKB)=KABAS
                        JTranC(NOrb) = JKB
                        CTranC(NOrb, JKB) = CTran(NOrb, JKB)
                        ITranC(NOrb, JKB) = ITran(NOrb, JKB)
                     ENDIF
                  ENDDO
C
                  IF(IFIF) THEN
                     dele=(idela.eq.0).and.(jcntam(na,nhkta).eq.1)
                     if(idelb .gt. 0) then
                        do i=1,idelb
                           dele = dele .or. kdelb(i).eq.norb
                        enddo
                     endif
                     if (dele) then
                        newind(norb)= -NOrbDel
C
                        IF(NORBDEL.GT.MXCBF)THEN
                           WRITE(6,*)' @READIN-F, NORBDEL too large',
     &                                 NORBDEL
                           CALL ERREX
                        ENDIF
C
                        JTRAN(NOrbDel)=JKB
                        JPRX(NOrbDel)=KWO(MXYZ)
                        MAMN(NOrbDel)=LAMN(IA)
C     
C NOrbDel starts at a useful value, so the update is done _after_ the
C value is used.
C     
                        NOrbDel = NOrbDel - 1
                     else
C
                        IF(NORXB.GT.MXCBF)THEN
                           WRITE(6,*)' @READIN-F, NORXB too large ',
     &                                 NORXB
                           CALL ERREX
                        ENDIF
C
                        norxb=norxb+1
                        newind(norb)=norxb
                        JTRAN(NORXB)=JKB
                        JPRX(NORXB)=KWO(MXYZ)
                        MAMN(NORXB)=LAMN(IA)
                     endif
C
                     NORB=NORB+1
                     NBAS(LA)=NBAS(LA)+1
                  ENDIF
               ENDDO
            ENDDO
         ENDDO
C
         IF(LA.GT.1) THEN
            NPARSU(LA)=NPARSU(LA-1)+NPAR(LA-1)
            MST(LA) = MST(LA-1) +  NBAS(LA-1)
         ENDIF
C
         NPAR(LA)=NBAS(LA)*(NBAS(LA)+1)/2
      ENDDO
C
      if (lharm) then
         kab=0
         do ia=1,kmax
            khkta=khkt(nhkt(ia))
            khkta=nhkt(ia)*(nhkt(ia)+1)/2
            do nb=1,khkta
               do jaa=1,nrco(ia)
                  do kb=1,maxlop
                     if (and(kb,mul(ia))  .eq.  1) then
                        kab=kab+1
                        kabs(ia,nb,jaa,kb)=kab
                     endif
                  enddo
               enddo
            enddo
         enddo
C
C map 1-dim. seqno onto la,ia,na and jaa
C
         noryb=0
C
         do la=1,maxlop
            do ia=1,kmax
               khkta=nhkt(ia)*(nhkt(ia)+1)/2
               do na=1,khkta
                  do jaa=1,nrco(ia)
                     if (.not.(and(mul(ia),eor(la,itype(nhkt(ia),
     &                    na))) .ne. 1)) then
                        noryb=noryb+1
C     
                        IF(NORYB.GT.MXCBF)THEN
                           WRITE(6,*)'@READIN-F, NORYB too large ',
     &                                 NORYB
                           CALL ERREX
                        ENDIF
C     
                        last(noryb)=la
                        iast(noryb)=ia
                        nast(noryb)=na
                        jaast(noryb)=jaa
                     endif
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
c     
c find connection between SO's and CGTO's
C NOTE: NOrb is one too _large_ from the way it is updated.  Hence
C the limit norb-1.  The value of NOrb is corrected later on.
C
         do i=1,norb-1
            inew=newind(i)
C
            IF(INEW.GT.MXCBF)THEN
               WRITE(6,*) ' @READIN-F, INEW too large ',INEW
               CALL ERREX
            ENDIF
C
C Instead of skiping deleted functions, construct their
C transformations.  Remember they live at the very end of
C the JTran/CTran/ITran arrays, so they won't harm anything.
C
            if(inew .le. 0) inew = -inew
            jkb=0
            la=last(i)
            ia=iast(i)
            khkta=khkt(nhkt(ia))
            na=nast(i)
            jaa=jaast(i)
            iaq=iadq(nhkt(ia))+(na-1)*khkta
            inx=(nhkt(ia)+1)*(nhkt(ia)-1)*nhkt(ia)/6 + na
C
            do kb=1,maxlop
               if (.not.(and(kb,mul(ia)) .ne. 1)) then
                  p=pc(and(kb,eor(la,itype(nhkt(ia),na))))
                  do nb=1,khkta
                     ch=charm(iaq+nb)
                     if (.not.(abs(ch) .lt. 1.e-03)) then
                        kab=kabs(ia,nb,jaa,kb)
                        jkb=jkb+1
                        ctran(inew,jkb)=p*ch
                        itran(inew,jkb)=kab
                     endif
                  enddo
               endif
            enddo
C
            jtran(inew)=jkb
            jjprx(inew) = kktyp(inx,1+idosph)
C
         enddo
C
      endif
C
CJDW 6/6/95. Add Ajith's block of PUTRECs.
C
C  &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C  &                                                               &
C  & Added by ajith 03/94. Information required to symmetry adapt  &
C  & nuclear perturbations.                                        &
C  &                                                               &
C  &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C      
      CALL PUTREC (20, 'JOBARC', 'MULCINP ', 100, MULNUC)
      CALL PUTREC (20, 'JOBARC', 'SYMTYPE ', 3 , ISYTYP)
      CALL PUTREC (20, 'JOBARC', 'NOSYMMOP', 1 , NSYMOP)
      CALL PUTREC (20, 'JOBARC', 'NOSYATOM', 1 , NMAX) 
      CALL PUTREC (20, 'JOBARC', 'ATOMSYMB', 300, NAMN)
C
c      IAB=0
c      KNTR=0
c      JBBAS = 0
c      DO IA=1,KMAX
c         NHKTA=NHKT(IA)
c         NAK=(NHKTA*(NHKTA+1)*(NHKTA-1))/6
c         KHKTA=KHKT(NHKTA)
c         MULA=MUL(IA)
c         LAM=LAMN(IA)
c         JRSIA = JRS(IA)
c         JSTRIA = JSTRT(IA)
c         NSTRIA = NSTRT(IA)
c         DO 1141 NA=1,KHKTA
c            NUCA=NUCO(IA)
c            NRCA = NRCO(IA)
c            NAKNA=NAK+NA
c            NAKO=KWO(NAKNA)
C
C CONSTRUCT PSEUDO-SEGMENTED BASIS FOR PROPERTIES AND ECP
C PROGRAMS BY DUPLICATING PRIMITIVES IN CONTRACTED FUNCTIONS.
C
c            DO JAA = 1,NRCA
c               DO KB=1,MAXLOP
c                  IF (.NOT. (AND(KB,MULA).NE.1)) THEN
c                     KBBAS = 0
c                     DO JA = 1,NUCA
c                        EX = ALPHA(JSTRIA+JA)
c                        CON = CONTUN(JRSIA+JA+(JAA-1)*NUCA)
c                        IF (ABS(CON) .GT. 1.E-8) THEN
c                           JBBAS = JBBAS + 1
c                           KBBAS = KBBAS + 1
c                           WRITE(LUSCR) LAM, KB, NAKO, EX, CON
c                        ENDIF
c                     ENDDO
c                  KNTR = KNTR + 1
c                  ICDS(KNTR) = KBBAS
c               ENDDO
c            ENDDO
C
c            DO KB =1, MAXLOP
c               IF(AND(KB,MULA).NE.1) GO TO 1142
c                DO 1144 JA=1,NUCA
c                  IAB=IAB+1
c                  IOVERP = ' '
c                  IF (JA .EQ. 1) IOVERP = '+'
c 1144          CONTINUE
c            ENDDO
c         ENDDO
c      ENDDO
C
      ji=0
      norxb  = 0
      do i=1,maxlop
         nxbas(i) = 0
         do j=1,nbas(i)
            ji=ji+1
            if (.not.(newind(ji) .le. 0)) Then
               nxbas(i) = nxbas(i) + 1
               norxb = norxb+1
               LABORB(NORXB) = I*1024 + NXBAS(I)
            endif
         enddo
      enddo
C
C After the actual transformation, write the rest of the
C matrix (deleted orbitals) necessary to make it square.
C Earlier we placed these at the very end of the arrays.
C    
C NOTE: NOrbDel is one too _small_ because if the way it is updated.
C Hence, the limit NOrbDel+1.
C         
      NORB = NORB - 1 
      CALL ZERO(CJUNK,NORB*NORB)
      DO I=1,NORXB
         J=JTRAN(I)
         DO K=1,J
            CJUNK( (I-1)*NORB +  ITRAN(I,K)) = CTRAN(I,K)
         ENDDO
      ENDDO
C
      IF(NORXB.LT.NORB)THEN
         IOLD=MXCBF
         DO I=NORXB+1,NORB
            J = JTRAN(IOLD)
            DO K=1,J
               CJUNK( (I-1)*NORB + ITRAN(IOLD,K)) = CTRAN(IOLD,K)
            ENDDO
            IOLD = IOLD-1
         ENDDO
      ENDIF
C
      CALL PUTREC(20,'JOBARC','NIRREP  ',1,MAXLOP)
      CALL PUTREC(20,'JOBARC','NUMBASIR',MAXLOP,NXBAS)
      CALL PUTREC(20,'JOBARC','FULLSOAO',NORB*NORB*IINTFP,CJUNK)

C#ifdef 1
      Write(6,"(a,i4)") "The number of irreps", Maxlop
      Write(6,"(a)") "The number of basis function for irrep"
      Write(6,"(8i4)") (Nxbas(i), i=1, maxlop)
      Write(6,*)
      WRITE(6,*) '  @READIN-I, SYMTRANS matrix '
      CALL OUTPUT(CJUNK,1,NORB,1,NORB,NORB,NORB,1)
C#endif
C
C This is the full cartesian basis AO -> SO transformation.
C Include in this info the number of function in each irrep too,
C because there is nowhere else to get it.
C NOTE: Write this record ONLY if it is different from the
C computational basis.
C
      If ( LHarm .OR. NOrb .ne. Norxb) then
C
         DO 3022 I = 1, NOrb
            J = JTranC(I)
 3022    Continue
      EndIf
C
      CALL ZERO(CJUNK,NORB*NORB)
      DO I=1,NORB
         J=JTranC(I)
         DO K=1,J
            CJUNK( (I-1)*NORB + ITranC(I,K) ) = CTranC(I,K)
         ENDDO
      ENDDO
      
cSSS      WRITE(6,*) '  @READIN-I, CSYMTRAN matrix '
cSSS      CALL OUTPUT(CJUNK,1,NORB,1,NORB,NORB,NORB,1)
C
C Write some of the Cartesian stuff to JOBARC.
C
      CALL PUTREC(20,'JOBARC','NAOBASFN',      1,NORB)
C
C     Population of symmetry blocks in full SO space.
C
      CALL PUTREC(20,'JOBARC','FAOBASIR', MAXLOP,NBAS)
C
      CALL PUTREC(20,'JOBARC','CSYMTRAN',NORB*NORB*IINTFP,CJUNK)

      INQUIRE(FILE="LABBASIS",EXIST=LABBASIS_EXIST)

      IF (LABBASIS_EXIST) THEN
          OPEN(UNIT=1, FILE='LABBASIS',STATUS='OLD')
      ELSE
          OPEN(UNIT=1, FILE='LABBASIS',STATUS='NEW')
      ENDIF 
      DO I = 1, NORXB
         WRITE(1,'(3X, A4,3X,A4)') MAMN(I), JPRX(I)
      ENDDO
      CLOSE(UNIT=1, STATUS='KEEP')

C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pardo_loadb_update_batch(iop, optable, index_table, 
     *                segment_table, nsegment_table,
     *                next_batch, last_batch) 
c---------------------------------------------------------------------------
c   Gets the next batch of the current pardo instruction from the
c   pardo master of the current rank.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'where_table.h'

      integer iop, noptable, next_batch, last_batch
      integer optable(loptable_entry, 1)
      integer index_table(lindex_table_entry, *)
      integer nsegment_table
      integer segment_table(lsegment_table_entry, *)

      integer indx(mx_array_index)
      integer ind(mx_array_index)
      integer bseg(mx_array_index)
      integer eseg(mx_array_index)
      integer seg(mx_array_index)
      integer i, j, max_batch, nind
      integer chunk_size
      integer last_chunk
      integer iwhere_save, nwhere_save 
      integer cluster_size, get_pardo_cluster_size
      integer cluster_start, cluster_end
      integer pardo_master, get_pardo_master

c---------------------------------------------------------------------------
c   This pardo loop may not have been entered on the current processor
c   at this time.  If that is the case, we must execute the code that sets 
c   the maximum number of batches for the loop.
c---------------------------------------------------------------------------

c      print *,'Task ',me,' PARDO_LOADB_UPDATE_BATCH: iop ',iop
c      print *,'   pardo_info: ',(optable(c_pardo_info+i-1,iop),i=1,6)
c      call c_flush_stdout()
      if (optable(c_pardo_max_batch,iop) .eq. 0) then
         do i = 1, mx_array_index
            indx(i) = optable(c_ind1+i-1,iop)
         enddo
      endif

c----------------------------------------------------------------------------
c   Get the workload distribution for the current pardo cluster.
c----------------------------------------------------------------------------

      call set_pardo_workload(optable(c_pardo_max_batch,iop), 
     *                        cluster_start, cluster_end)
      cluster_size = get_pardo_cluster_size()

      if (optable(c_pardo_next_batch_start,iop) .eq. 0) 
     *    optable(c_pardo_next_batch_start,iop) = cluster_start

      if (optable(c_pardo_next_batch_start,iop) .eq. -1) then
      
c--------------------------------------------------------------------------
c   If c_pardo_signal = cluster_size, then each processor has previously
c   received a "-1" signal from this pardo loop.  This means we are starting
c   a fresh loop execution, and the pardo counters must be reset.
c--------------------------------------------------------------------------

         cluster_size = get_pardo_cluster_size()
         if (optable(c_pardo_signal,iop) .eq. cluster_size) then
            optable(c_pardo_batch,iop)  = 0
            optable(c_pardo_next_batch_start,iop) = cluster_start
            optable(c_pardo_batch_end,iop)       = 0  
c            print *,'LOOP RESTART CODE: ',
c     *         (optable(c_pardo_info+i-1,iop),i=1,6)
         else
            
c--------------------------------------------------------------------------
c   Bump the signal counter, return a -1.
c--------------------------------------------------------------------------

            optable(c_pardo_signal,iop)=optable(c_pardo_signal,iop)+1
            next_batch = -1
            last_batch = 0
c            print *,'ALT RETURN: iop ',iop,' pardo_info ',
c     *       (optable(c_pardo_info+i-1,iop),i=1,6)
            return
         endif
      endif

c--------------------------------------------------------------------------
c   A new batch is needed.  Update the counters.
c--------------------------------------------------------------------------

         optable(c_pardo_batch,iop) = 
     *                   optable(c_pardo_next_batch_start,iop)
         last_chunk = optable(c_pardo_chunk_size,iop)

         pardo_master = get_pardo_master() 
         optable(c_pardo_chunk_size,iop) =
     *          chunk_size(optable(c_pardo_next_batch_start,iop),
     *                     cluster_end, cluster_size,
     *                     last_chunk)
         if (my_company_rank .eq. pardo_master) then
            optable(c_pardo_chunk_size,iop) = 
     *        max(optable(c_pardo_chunk_size,iop)/4, 1)
         endif

         optable(c_pardo_batch_end,iop) = optable(c_pardo_batch,iop)+
     *                   optable(c_pardo_chunk_size,iop) - 1
         if (optable(c_pardo_batch_end,iop) .gt. cluster_end)
     *      optable(c_pardo_batch_end,iop) = cluster_end
         optable(c_pardo_next_batch_start,iop) = 
     *     optable(c_pardo_next_batch_start,iop) +
     *     optable(c_pardo_chunk_size,iop)

c--------------------------------------------------------------------------
c   Check to determine if the loop maximum has been exceeded.  If so, a -1
c   batch number is returned.
c--------------------------------------------------------------------------

      if (optable(c_pardo_batch,iop) .gt. cluster_end) then
        optable(c_pardo_batch,iop) = -1
        optable(c_pardo_signal,iop) = 1
        optable(c_pardo_next_batch_start,iop) = -1
      endif

c---------------------------------------------------------------------------
c   Set the return value.
c---------------------------------------------------------------------------

      next_batch = optable(c_pardo_batch,iop)    
      last_batch = optable(c_pardo_batch_end, iop)
c      print *,'Task ',me,' PARDO_LOADB_UPDATE_BATCH: return ',
c     *   'next_batch, last_batch ',next_batch,last_batch
c      print *,'   pardo_info at end of routine ',
c     *   (optable(c_pardo_info+i-1,iop),i=1,6)
c      call c_flush_stdout()
      return
      end


      subroutine pardo_loadb_get_my_batch(iop, next_batch, last_batch)
c--------------------------------------------------------------------------
c   Determines the address of the optable, uses this to call 
c   pardo_loadb_update_batch.
c--------------------------------------------------------------------------
      implicit none
      include 'sip_tables.h'
      include 'parallel_info.h'
      include 'interpreter.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer iop, next_batch, last_batch
      integer optable(1)
      integer index_table(1)
      integer segment_table(1)
#ifdef ALTIX
      pointer (ptr_optable, optable)
      pointer (ptr_index_table, index_table)
      pointer (ptr_segment_table, segment_table)
#else
      common optable
#endif

      integer next_batch_save, last_batch_save
      integer inext, ilast

      integer*8 iiopt, get_index_from_base
      integer*8 iindext
      integer*8 isegt
      integer i, ipardoinfo

#ifdef ALTIX
      ptr_optable = ishptr
      ptr_index_table = ishptr
      ptr_segment_table = ishptr
#endif

      iiopt = get_index_from_base(optable_base, optable, 1)
      iindext = get_index_from_base(index_table_base, index_table, 1)
      isegt = get_index_from_base(segment_table_base, segment_table, 1)

c------------------------------------------------------------------------
c   Save table values needed by the master (rank 0) process.
c------------------------------------------------------------------------

      inext = (iop-1)*loptable_entry + c_pardo_batch
      ilast = (iop-1)*loptable_entry + c_pardo_batch_end
      next_batch_save = optable(iiopt+inext-1)
      last_batch_save = optable(iiopt+ilast-1)

c--------------------------------------------------------------------------
c   Update table entries.
c--------------------------------------------------------------------------

c      print *,'SERVER CALL to pardo_loadb_update_batch: saved ',
c     *   'next_batch, last_batch = ',next_batch_save,last_batch_save
c      ipardoinfo = (iop-1)*loptable_entry + c_pardo_info 
c      print *,'Pardo_info from calling routine ',
c     *   (optable(iiopt+ipardoinfo+i-2),i=1,6)
      call pardo_loadb_update_batch(iop, optable(iiopt), 
     *         index_table(iindext), segment_table(isegt),
     *         nsegment_table_sip,
     *         next_batch, last_batch)

c---------------------------------------------------------------------------
c   Restore the master's private values.
c---------------------------------------------------------------------------

      optable(iiopt+inext-1) = next_batch_save
      optable(iiopt+ilast-1) = last_batch_save
c      print *,'SERVER CALL pardo_info after call = ',
c     *     (optable(iiopt+ipardoinfo+i-2),i=1,6)
      return
      end

      function is_connected(atom1, atom2, connectiontable, natoms,
     &                      connectlist)
C
C Determines if two atoms are connected by constructing a full
C connection list and then searching it.
C
      implicit none
C
C Input Variables
C
      integer atom1,atom2,natoms,connectiontable(natoms,natoms)
C
C Function Variables
C
      logical is_connected
C
C Pre-allocated Local Variables
C
      integer connectlist(natoms), i
C
C External Procedures
C
      external followconnect

C Local Variables

      integer listatoms
      logical shortcircuit
C - - -- - - - - - - - - - - - - -- - - - - - - -- - - -  -- - 

      if (connectiontable(atom1,atom2).eq.1) then
         is_connected=.true.
         return
      else
         call izero(connectlist,natoms)
C
C Follow atom1 connections
C
         listatoms=0
         shortcircuit=.false.
         call followconnect(atom2,atom1,connectlist,listatoms,
     &      connectiontable,natoms,followconnect,shortcircuit)
         is_connected=shortcircuit
      endif
C
#ifdef _DEBUG_LVLM1
      Print*, "The connectionlist in is_connected"
      Print*, "atom1 & atom2", (connectlist(i), i=1, natoms),
     &         atom1, atom2
#endif
c
      return
      end
C
      subroutine followconnect(atom,taratom,list,listatoms,
     &   connectiontable,natoms,follow2,shortcircuit)
C
C Constructs list of connections pseudo-recursively
C by calling follow2 (which is a pointer to followconnect)
C
      implicit none
C Input Variables
      integer atom,natoms,connectiontable(natoms,natoms),taratom

C Input/Output Variables
      integer list(natoms),listatoms
      logical shortcircuit

C External Procedures
      external follow2,bin_search
      logical bin_search

C Local Variables
      integer ii
      integer iatom 
      logical new
C - - - - - - -- - - - - - - - - - - - - - - -- - - - - - - - -- - -
      
      if (atom.eq.taratom) then
         shortcircuit=.true.
      else
C
C Determine if atom is already in the list
C
         if (listatoms.gt.0) then
            new=.not.bin_search(atom,list,listatoms)
         else
            new=.true.
         endif
      
         if (new) then
C Insert in sorted list
            ii=listatoms
            do while ((ii.ge.1).and.(list(ii).gt.atom))
               list(ii+1)=list(ii)
               ii=ii-1
            end do
            list(ii+1)=atom
            listatoms=listatoms+1
C Follow the connections down a level
            do 2 ii=1,natoms
               if (connectiontable(ii,atom).eq.1) then
                  iatom = ii
                  call follow2(iatom,taratom,list,listatoms,
     &               connectiontable,
     &               natoms,follow2,shortcircuit)
C Short circuit indicates that the target atom taratom has been found
                  if (shortcircuit) return
               endif
 2          continue
         endif
      endif
      
      return
      end

      function bin_search(atom,list,listatoms)
C
C Binary search routine returns true if atom is in list false 
C otherwise
C
      implicit none
C Input Variables
      integer atom,listatoms,list(listatoms)

C Function Variables
      logical bin_search

C Local Variables
      integer left,right,mid
C - - - - -- - -- - - - - - -- - - - - -- - - - - - - - - - - -
      left=1
      right=listatoms
      do while (left .le. right)
         mid=int(dble(right-left)/2.0d0)+left
         if (list(mid).eq.atom) then
            bin_search=.true.
            return
         else if (atom .lt. list(mid)) then
            right=mid-1
         else
            left=mid+1
         endif
      end do
      bin_search=.false.
      return
      end

C TRANSFORMS SYMMETRY OPERATIONS TO AN ORIENTATION SPECIFIED BY
C MATRIX "GOOFY".

      SUBROUTINE TRNOPS(OPS,GOOFY,IORDGP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION OPS(9*IORDGP),GOOFY(9),SCR(9)


      if (iordgp.lt.0) then
         print *, '@TRNOPS: Assertion failed.'
         print *, '         iordgp = ',iordgp
         call errex
      end if


      DO I = 1, IORDGP
         IADD = -8 + (9*I)
         CALL XGEMM('N','N',3,3,3,
     &              1.0d0,GOOFY,    3,
     &                    OPS(IADD),3,
     &              0.0d0,SCR,      3)
         CALL XGEMM('N','T',3,3,3,
     &              1.0d0,SCR,      3,
     &                    GOOFY,    3,
     &              0.0d0,OPS(IADD),3)
      END DO

      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C TRANSFORMS SYMMETRY OPERATIONS TO AN ORIENTATION SPECIFIED BY
C MATRIX "GOOFY".

      SUBROUTINE TRNOPS(OPS,GOOFY,IORDGP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION OPS(9*IORDGP),GOOFY(9),SCR(9)

#ifdef _ASSERT
      if (iordgp.lt.0) then
         print *, '@TRNOPS: Assertion failed.'
         print *, '         iordgp = ',iordgp
         call errex
      end if
#endif /* _ASSERT */

      DO I = 1, IORDGP
         IADD = -8 + (9*I)
         CALL XGEMM('N','N',3,3,3,
     &              1.0d0,GOOFY,    3,
     &                    OPS(IADD),3,
     &              0.0d0,SCR,      3)
         CALL XGEMM('N','T',3,3,3,
     &              1.0d0,SCR,      3,
     &                    GOOFY,    3,
     &              0.0d0,OPS(IADD),3)
      END DO

      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__W_EQ_ZERO_INTEGER
     +
     +                    ( DDVEC,
     +                      VEC,
     +
     +                              W )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__W_EQ_ZERO_INTEGER
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation builds a zero vector W of integer type.
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         INTEGER    DDVEC
         INTEGER    I
         INTEGER    VEC

         INTEGER    W (1:DDVEC)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimension.
C
C
         IF  ( VEC .GT. DDVEC )  THEN

               WRITE (1,*) ' Dimension of vector W too small: '
               WRITE (1,*) ' mat__w_eq_zero_integer '
               WRITE (1,*) ' DDVEC,VEC = ',
     +                       DDVEC,VEC

               WRITE (*,*) ' Dimension of vector W too small: '
               WRITE (*,*) ' mat__w_eq_zero_integer '
               WRITE (*,*) ' DDVEC,VEC = ',
     +                       DDVEC,VEC

               STOP

         END IF
C
C
C             ...build zero vector.
C
C
         DO  10  I = 1,VEC  
             W (I) = 0
   10    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE COMPKMAT(DERBMAT,NRATMS,TOTREDNCO,FI,HC,
     &                    DIFTEMP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INTEGER TOTREDNCO
      DOUBLE PRECISION KMAT

C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

C KMAT is used as temporary storge while building DIFTEMP and it is of
C size 9*MXATMS*MXATMS (so it needs to be managed dynamically).

      DIMENSION DERBMAT(3*NRATMS,3*NRATMS*TOTREDNCO),
     &          FI(TOTREDNCO),HC(3*NRATMS,3*NRATMS),
     &          KMAT(3*MXATMS,3*MXATMS),
     &          DIFTEMP(3*NRATMS,3*NRATMS)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      CALL ZERO(KMAT,9*NRATMS*NRATMS)

      LENDBMAT = 9*NRATMS*NRATMS*TOTREDNCO
      CALL GETREC(20,'JOBARC','DERBMAT',IINTFP*LENDBMAT,DERBMAT)

      DO I=1, TOTREDNCO
         IND=3*NRATMS*(I-1)+1
C
         Write(6, "(a,4F10.5)"),'The gradients Compkmat: ',
     &        (FI(J), J=1, TOTREDNCO)
         CALL DSCAL(9*NRATMS*NRATMS,FI(I),DERBMAT(1,IND),1)
      END DO

      DO I=1,3*NRATMS
         DO J=1,3*NRATMS
            DO K=1,TOTREDNCO
               JTMP = (K-1)*3*NRATMS+J
               KMAT(I,J) = KMAT(I,J)+ DERBMAT(I,JTMP)
            END DO
         END DO
      END DO
C
      Write(6,"(a)"),'The  Cartesian Hess'
      CALL OUTPUT(HC,1,3*NRATMS,1,3*NRATMS,3*NRATMS,
     &            3*NRATMS,1)
C
      DO I=1,3*NRATMS
         DO J=1,3*NRATMS
            DIFTEMP(I,J)=HC(I,J)-KMAT(I,J)
         END DO
      END DO
C
      Write(6,*),'In COMPKMAT: The (HC-K) Matrix'
      CALL OUTPUT(DIFTEMP,1,3*NRATMS,1,3*NRATMS,3*NRATMS,
     &            3*NRATMS,1)


      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine copy_fock(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c   Copies one array into a Fock array and copies the diagonal elements
c   into the corresponding eigenvalue array.
c
c   execute Array1 fock_a 
c         OR
c   execute Array1 fock_b
c 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*) 
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      integer i, n
 
      n = edim(1) - bdim(1) + 1 
      do i = 1, n*n
         x2(i) = x(i)
      enddo

c-------------------------------------------------------------------------
c   Copy diagonal elements into epsilon or epsilonb.
c-------------------------------------------------------------------------

      if (type(1) .eq. moaindex) then
         call copy_diag(x2, n, epsilon)
      else
         call copy_diag(x2, n, epsilonb)
      endif

      return
      end

      subroutine copy_diag(x, n, y)
      implicit none
      integer i, n
      double precision x(n,n), y(n)

      do i = 1, n
         y(i) = x(i,i)
      enddo
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine parses a string, szData, and extracts a one-dimensional
c array of integers up to nMax. The elements are separated by forward slashes,
c ranges are defined with dashes or '>', and elements can be enclosed by
c parentheses. nInts is returned, telling the caller how many integers were
c read. iArr is NOT initialized to zero.

c EXAMPLE:
c    szData=' 1 / 3 / 4>6 / (-7)-(-9) '
c This string yields: { 1, 3, 4, 5, 6, -7, -8, -9 }

c NOTES:
c  - The data is not checked for duplicates; therefore, '1/2/1-3' will
c    yield 5 separate elements.
c  - The data is not checked for consecutiveness, meaning the caller
c    must assume the data is in random order.

      subroutine parse_set_iarr(szData,nInts,iArr,nMax)
      implicit none

c ARGUMENTS
      character*(*) szData
      integer nInts, nMax
      integer iArr(nMax)

c EXTERNAL FUNCTIONS
      integer fnblnk

c INTERNAL VARIABLES
      integer iInts
      integer iStart, iEnd, inc, nChars, iErrPos
      integer iLength, pStart, iFirst, i
      character*(1) czData
      logical bDone

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iInts = 0
c   o assert nMax is natural
      if (nMax.lt.1) then
         print *, '@PARSE_SET_IARR: The destination array is ',
     &            'ill-defined.'
         print *, '   nMax = ',nMax
         iInts = -1
      end if
      if (iInts.ne.0) then
         call errex
      end if
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o quit if the string is empty
      iFirst = fnblnk(szData)
      if (iFirst.eq.0) then
         nInts = 0
         return
      end if

c   o initialize the iArr index (we increment just before writing a
c     new element)
      iInts = 0

c   o start reading from the first character
      pStart  = iFirst
      iLength = len(szData)
      bDone   = .false.
      do while (.not.bDone)

c      o find a number
         nChars = 0
         if (pStart.le.iLength) then
            call parse_int(szData(pStart:),iStart,nChars,iErrPos)
            if (iErrPos.ne.0) then
               print *, '@PARSE_SET_IARR: error near position ',
     &                  pStart - 1 + iErrPos
               print *, '"',szData,'"'
               call errex
            end if
            pStart = pStart + nChars
            iEnd   = iStart
         end if
         if (nChars.eq.0) then
            print *, '@PARSE_SET_IARR: missing value at position ',
     &               pStart
            print *, '"',szData,'"'
            call errex
         end if

c      o point to the next character
         iFirst = 0
         if (pStart.le.iLength) iFirst = fnblnk(szData(pStart:))

c      o check for a range
         if (iFirst.ne.0) then
            i = pStart - 1 + iFirst
            czData = szData(i:i)
            if (czData.eq.'-'.or.czData.eq.'>') then
               nChars = 0
               if (i.lt.iLength) then
                  call parse_int(szData(i+1:),iEnd,nChars,iErrPos)
                  if (iErrPos.ne.0) then
                     print *, '@PARSE_SET_IARR: error near position ',
     &                        i + iErrPos
                     print *, '"',szData,'"'
                     call errex
                  end if
                  pStart = i + nChars + 1
               end if
               if (nChars.eq.0) then
                  print *, '@PARSE_SET_IARR: missing end of range ',
     &                     'after position ',i
                  print *, '"',szData,'"'
                  call errex
               end if
            end if
         end if

         inc = 1
         if (iStart.gt.iEnd) inc = -1

c      o check for overflow
         i = abs(iEnd+inc-iStart)
         if (iInts+i.gt.nMax) then
            print *, '@PARSE_SET_IARR: exceeded limit of',nMax,' values'
            print *, '"',szData,'"'
            call errex
         end if

c      o enter the values
         do i = iStart, iEnd, inc
            iInts = iInts + 1
            iArr(iInts) = i
         end do

c      o point to the next character
         iFirst = 0
         if (pStart.le.iLength) iFirst = fnblnk(szData(pStart:))
         bDone = (iFirst.eq.0)

         if (.not.bDone) then
            i = pStart - 1 + iFirst
            czData = szData(i:i)
            if (czData.ne.'/') then
               print *, '@PARSE_SET_IARR: invalid character at ',
     &                  'position ',i
               print *, '"',szData,'"'
               call errex
            end if
            pStart = i + 1
         end if

c     end do while (.not.bDone)
      end do

c      print *, 'DEBUG: ',(iArr(i),i=1,iInts)

c   o record the output
      nInts = iInts

      return
      end

c This initializes the timer if type=0; otherwise, it gets time info.

      subroutine timer(type)

#include <aces.h>
#include <const.par>
#include <timeinfo.com>

      integer type
      M_REAL t

#ifdef _UNICOS
C     Is this a system intrinsic function?
      double precision second
      t = second()
#else
      M_REAL tarray(2)
      call a3time(tarray)
      t = tarray(1)
#endif /* _UNICOS */

      if (type.eq.0) then
         timein  = t
         timenew = zero
         timetot = zero
      else
         timenew = t - timenow
         timetot = t - timein
      end if
      timenow = t

      return
      end

      SUBROUTINE SYMMET3(IRREP,LISTG,DISSYG,SCR,MAXSIZE)
C
C   THIS ROUTINE SYMMETRIZES A MATRIX A(N,N) :
C
C    B(I,J) = 1/2 ( A(I,J) + A(J,I))
C
C   THIS VERSION HANDLES THE CASES WHERE THE MATRIX A DOES NOT FIT INTO
C   CORE
C
CEND
C 
C  CODED JG/SEPT/90
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSYG,DISLEFT,DISREAD
      DIMENSION SCR(MAXSIZE)
C
      DATA HALF /0.5D0/
C
C  DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN CORE
C
      MAXDIS=MAXSIZE/DISSYG
C
C  CHECK IF A FITS INTO THE AVAILABLE CORE MEMORY
C
      IF(MAXDIS.GE.DISSYG) THEN
C
C   DO IT IN CORE BY USING SYMMET2 
C
       CALL GETLST(SCR,1,DISSYG,1,IRREP,LISTG)
       CALL SYMMET2(SCR,DISSYG) 
       CALL PUTLST(SCR,1,DISSYG,1,IRREP,LISTG)
C
      ELSE
C
C  WE HAVE TO DO IT OUT OF CORE
C
C  HOWEVER, ONE DISTRIBUTION IS REQUIRED AS BUFFER, SO SUBTRACT ONE
C
       MAXDIS=MAXDIS-1
       IF(MAXDIS.LE.0) STOP 'SYMMET3'
C
C  ALLOCATE MEMORY
C
       IBUF=1+MAXDIS*DISSYG
C
C  SET THE NUMBER OF DISTRIBUTIONS WHICH MUST BE TREATED
C
       DISREAD=DISSYG
C
C  SET THE NUMBER oF DISTRIBUTIONS LEFT ON DISK
C
       DISLEFT=DISSYG
C
C  SET OFFSET FOR LIST LISTG 
C 
       IOFFSET=1
C
10     CONTINUE
C
C  DETERMINE THE NUMBER OF DISTRIBUTIONS PROCESSED DURING THIS
C  PATH
C
        DISREAD=MIN(DISLEFT,MAXDIS)
        DISLEFT=DISLEFT-DISREAD
C 
C READ IN THE DISTRIBUTIONS WHICH ARE UPDATED
C
        CALL GETLST(SCR,IOFFSET,DISREAD,1,IRREP,LISTG)
C
C SET IFIRST (FIRST DISTRIBUTION IN CORE)
C
        IFIRST=IOFFSET
C
C UPDATE IOFFSET
C
        IOFFSET=IOFFSET+DISREAD
C
C SET ILAST (LAST DISTRIBUTION IN CORE)
C
        ILAST=IOFFSET-1
C
C  WE HAVE NOW THREE DIFFERENT CATEGORIES OF DISTRIBUTIONS
C
C   1)  THE DISTRIBUTIONS IN MEMORY
C   2)  THE DISTRIBUTIONS ON DISK WHICH ARE ALREADY SYMMETRIZED
C   3)  THE DISTRBIBUTIONS ON DISK WHICH ARE STILL NOT SYMMETRIZED
C
C WE HAVE ONLY TO LOOP OVER THE THIRS SET !
C
C   USE FIRST THE DISTRIBUTIONS IN CORE FOR SYMMETRIZATION
C
C   THIS IS DONE IN SYMMET4
C
        CALL SYMMET4(SCR(IFIRST),DISSYG,DISREAD)
C
C   NOW PROCESS THE THIRD SET OF DISTRIBUTIONS
C
C   LOOP OVER ALL REMAINING AND READ THEM
C
        DO 100 IDIS=IOFFSET,DISSYG
C
C  GET THE DISTRIBUTION IN THE BUFFER
C
         CALL GETLST(SCR(IBUF),IDIS,1,1,IRREP,LISTG)
C
C  NOW SYMMETRIZE THE PART WHICH CORRESPONDS TO THAT IN CORE
C
C  APPLY IVDEP DIRECTIVE IN ORDER TO VECTORIZE
C
CDIR$ IVDEP
*VOCL LOOP,NOVREC
         DO 150 IPOS=IFIRST,ILAST
          SCR(IBUF+IPOS-1)=HALF*(SCR(IBUF+IPOS-1)+ 
     &                           SCR(IDIS+(IPOS-IFIRST)*DISSYG))
150      CONTINUE
C
C  COPY THE SYMMETRIZED ELEMENTS TO THE UODATING AREA
C
C  APPLY IVDEP DIRECTIVE TO VECTORIZE
C
CDIR$ IVDEP
*VOCL LOOP,NOVREC
         DO 160 IPOS=IFIRST,ILAST
          SCR(IDIS+(IPOS-IFIRST)*DISSYG)=SCR(IBUF+IPOS-1)
160      CONTINUE
C
C  WRITE THE DISTRIBUTION IN THE BUFFER BACK TO DISK
C
         CALL PUTLST(SCR(IBUF),IDIS,1,1,IRREP,LISTG)
C
100     CONTINUE
C
C SAVE THE UPDATES DISTRIBUTIONS ON DISK
C
        CALL PUTLST(SCR,IFIRST,DISREAD,1,IRREP,LISTG)
C
C  IF NOT ALL DISTRIBUTIONS HAVE BEEN PROCESSED, GO BACK TO 10 
C
       IF(DISLEFT.NE.0) GO TO 10
C
C  ALL DONE, RETURN
C
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__PPPP_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      ATOMIC,ATOM12,ATOM34,
     +                      MIJ,MKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      X12,Y12,Z12,X34,Y34,Z34,
     +                      ALPHA1,ALPHA2,ALPHA3,ALPHA4,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIM1,PRIM2,PRIM3,PRIM4,
     +                      NORM1,NORM2,NORM3,NORM4,
     +                      RHO12,RHO34,
     +                      P,PX,PY,PZ,SCALEP,
     +                      Q,QX,QY,QZ,SCALEQ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__PPPP_PCGTO_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation is designed to provide ultrafast block
C                evaluation of a batch of normalized electron repulsion
C                integrals between p-shell primitive spherical gaussian
C                type orbitals.
C
C                A batch is defined here as containing all possible
C                integrals, that is its dimension is determined by
C                the total number of primitive functions (here = 81)
C                times the total number of ij and kl exponent pair
C                combinations.
C
C                The integrals are ordered in the batch the following
C                way (first index varying fastest):
C
C                    batch (nxyz1,nxyz2,nxyz3,nxyz4,kl,ij)
C
C                where ij and kl indicates alpha exponent pairs
C                defining the present block.
C
C                The present routine evaluates batches of the type:
C
C                                         pppp
C
C                The cartesian primitive integrals are evaluated using
C                the auxillary functions technique, described by
C                V.R. Saunders, "An Introduction to Molecular Integral
C                Evaluation" in "Computational Techniques in Quantum
C                Chemistry and Molecular Physics" edited by
C                GHF Diercksen, BT Sutcliff and A Veillard, D. Reidel
C                Publ. Comp. Dordrecht (1975), p. 347.
C
C                The cartesian primitive integrals are each evaluated
C                explicitely using common multipliers if possible and
C                avoiding array addresses.
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    pppp integral batch
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    ATOM12(34)   =  indicates, if centers 1 and 2
C                                    (3 and 4) coincide
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the contracted shell pairs 1,2
C                                    (3,4)
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair 1,2
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NKL          =  total # of kl primitive index
C                                    pairs for the contracted shell
C                                    pair 3,4
C                    NKLBEG(END)  =  first(last) kl primitive index
C                                    defining the kl block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = 1,2,3,4
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = 1,2,3,4
C                    Xxx,Yxx,Zxx  =  the x,y,z-coordinate differences
C                                    between centers xx = 12 and 34
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = 1,2,3,4
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j,k,l labels of primitives for
C                                    the respective contraction shells
C                                    x = 1,2,3,4
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = 1,2,3,4
C                    RHO12(34)    =  the complete set of NIJ (NKL)
C                                    exponential prefactors between
C                                    contraction shells 1 and 2
C                                    (3 and 4)
C                    P            =  will hold current MIJ exponent
C                                    sums for contraction shells 1
C                                    and 2
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=1+2
C                    SCALEP       =  will hold current MIJ values of
C                                    scaling factors related to point P
C                    Q            =  will hold current MKL exponent
C                                    sums for contraction shells 3
C                                    and 4
C                    Qx           =  will hold current MKL coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers Q=3+4
C                    SCALEQ       =  will hold current MKL values of
C                                    scaling factors related to point Q
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian pppp integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOM12,ATOM34

         INTEGER     CASE
         INTEGER     I,J,K,L,M
         INTEGER     IJ,KL
         INTEGER     MGRID,NGRID,TGRID
         INTEGER     MIJ,MKL
         INTEGER     NBATCH
         INTEGER     NIJ,NKL
         INTEGER     NIJBEG,NIJEND,NKLBEG,NKLEND
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4

         INTEGER     PRIM1 (1:MIJ)
         INTEGER     PRIM2 (1:MIJ)
         INTEGER     PRIM3 (1:MKL)
         INTEGER     PRIM4 (1:MKL)

         DOUBLE PRECISION  A,B,C,D,E,F,G,H,R
         DOUBLE PRECISION  AA,BB,CC,DD,EE,FF,GG,HH,RR
         DOUBLE PRECISION  DELTA1,DELTA2,DELTA3,DELTA4,DELTA5,DELTA6
         DOUBLE PRECISION  EXP1,EXP2,EXP3,EXP4
         DOUBLE PRECISION  F0,F1,F2,F3,F4
         DOUBLE PRECISION  GXXXX,GXXXY,GXXXZ,GXXYX,GXXYY,GXXYZ,
     +                     GXXZX,GXXZY,GXXZZ,GXYXX,GXYXY,GXYXZ,
     +                     GXYYX,GXYYY,GXYYZ,GXYZX,GXYZY,GXYZZ,
     +                     GXZXX,GXZXY,GXZXZ,GXZYX,GXZYY,GXZYZ,
     +                     GXZZX,GXZZY,GXZZZ,GYXXX,GYXXY,GYXXZ,
     +                     GYXYX,GYXYY,GYXYZ,GYXZX,GYXZY,GYXZZ,
     +                     GYYXX,GYYXY,GYYXZ,GYYYX,GYYYY,GYYYZ,
     +                     GYYZX,GYYZY,GYYZZ,GYZXX,GYZXY,GYZXZ,
     +                     GYZYX,GYZYY,GYZYZ,GYZZX,GYZZY,GYZZZ,
     +                     GZXXX,GZXXY,GZXXZ,GZXYX,GZXYY,GZXYZ,
     +                     GZXZX,GZXZY,GZXZZ,GZYXX,GZYXY,GZYXZ,
     +                     GZYYX,GZYYY,GZYYZ,GZYZX,GZYZY,GZYZZ,
     +                     GZZXX,GZZXY,GZZXZ,GZZYX,GZZYY,GZZYZ,
     +                     GZZZX,GZZZY,GZZZZ
         DOUBLE PRECISION  PVAL,QVAL
         DOUBLE PRECISION  PQPLUS,PQMULT,PQPINV
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL,QXVAL,QYVAL,QZVAL
         DOUBLE PRECISION  RNPQSQ
         DOUBLE PRECISION  SCALE
         DOUBLE PRECISION  T,TINV,T2INV,TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  U0,U1,U2,U3,U4,U5,U6,U7,U8,U9,U10
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4
         DOUBLE PRECISION  X12,Y12,Z12,X34,Y34,Z34
         DOUBLE PRECISION  XSSSP1,XSSPS1,XSPSS1,XPSSS1,XSSPP1,XSPSP1,
     +                     XPSSP1,XSPPS1,XPSPS1,XPPSS1,XSPPP1,XPSPP1,
     +                     XPPSP1,XPPPS1,XPPPP1,XSSSP2,XSPSS2,XSSPP2,
     +                     XSPSP2,XPSSP2,XSPPS2,XPSPS2,XPPSS2,XSPPP2,
     +                     XPSPP2,XPPSP2,XPPPS2,XPPPP2,XSSPP3,XSPSP3,
     +                     XPPSS3,XSPPP3,XPSPP3,XPPSP3,XPPPS3,XPPPP3,
     +                     XSPPP4,XPPSP4,XPPPP4,XPPPP5,
     +                     YSSSP1,YSSPS1,YSPSS1,YPSSS1,YSSPP1,YSPSP1,
     +                     YPSSP1,YSPPS1,YPSPS1,YPPSS1,YSPPP1,YPSPP1,
     +                     YPPSP1,YPPPS1,YPPPP1,YSSSP2,YSPSS2,YSSPP2,
     +                     YSPSP2,YPSSP2,YSPPS2,YPSPS2,YPPSS2,YSPPP2,
     +                     YPSPP2,YPPSP2,YPPPS2,YPPPP2,YSSPP3,YSPSP3,
     +                     YPPSS3,YSPPP3,YPSPP3,YPPSP3,YPPPS3,YPPPP3,
     +                     YSPPP4,YPPSP4,YPPPP4,YPPPP5,
     +                     ZSSSP1,ZSSPS1,ZSPSS1,ZPSSS1,ZSSPP1,ZSPSP1,
     +                     ZPSSP1,ZSPPS1,ZPSPS1,ZPPSS1,ZSPPP1,ZPSPP1,
     +                     ZPPSP1,ZPPPS1,ZPPPP1,ZSSSP2,ZSPSS2,ZSSPP2,
     +                     ZSPSP2,ZPSSP2,ZSPPS2,ZPSPS2,ZPPSS2,ZSPPP2,
     +                     ZPSPP2,ZPPSP2,ZPPPS2,ZPPPP2,ZSSPP3,ZSPSP3,
     +                     ZPPSS3,ZSPPP3,ZPSPP3,ZPPSP3,ZPPPS3,ZPPPP3,
     +                     ZSPPP4,ZPPSP4,ZPPPP4,ZPPPP5
         DOUBLE PRECISION  ZERO,FIFTH,THIRD,HALF,ONE,THREE,PI,FIVE,
     +                     SIX,SEVEN

         DOUBLE PRECISION  ALPHA1 (1:NPGTO1)
         DOUBLE PRECISION  ALPHA2 (1:NPGTO2)
         DOUBLE PRECISION  ALPHA3 (1:NPGTO3)
         DOUBLE PRECISION  ALPHA4 (1:NPGTO4)

         DOUBLE PRECISION  NORM1  (1:NPGTO1)
         DOUBLE PRECISION  NORM2  (1:NPGTO2)
         DOUBLE PRECISION  NORM3  (1:NPGTO3)
         DOUBLE PRECISION  NORM4  (1:NPGTO4)

         DOUBLE PRECISION  RHO12  (1:NIJ)
         DOUBLE PRECISION  RHO34  (1:NKL)

         DOUBLE PRECISION  BATCH  (1:NBATCH)

         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  PX     (1:MIJ)
         DOUBLE PRECISION  PY     (1:MIJ)
         DOUBLE PRECISION  PZ     (1:MIJ)
         DOUBLE PRECISION  SCALEP (1:MIJ)

         DOUBLE PRECISION  Q      (1:MKL)
         DOUBLE PRECISION  QX     (1:MKL)
         DOUBLE PRECISION  QY     (1:MKL)
         DOUBLE PRECISION  QZ     (1:MKL)
         DOUBLE PRECISION  SCALEQ (1:MKL)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (ZERO    =  0.D0 )
         PARAMETER  (FIFTH   =  0.2D0)
         PARAMETER  (THIRD   =  0.333333333333333D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0 )
         PARAMETER  (THREE   =  3.D0 )
         PARAMETER  (PI      =  3.141592653589793D0)
         PARAMETER  (FIVE    =  5.D0 )
         PARAMETER  (SIX     =  6.D0 )
         PARAMETER  (SEVEN   =  7.D0 )
C
C
C------------------------------------------------------------------------
C
C
C             ...predetermine in 'K2' loops the quantities associated
C                with the 1,2-part and 3,4-part.
C
C
         CASE = 5

         IF (ATOMIC.OR.ATOM12) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                P (M) = ALPHA1 (I) + ALPHA2 (J)
                SCALEP (M) = NORM1 (I) * NORM2 (J)
  100        CONTINUE
             CASE = CASE - 1
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                EXP1 = ALPHA1 (I)
                EXP2 = ALPHA2 (J)
                PVAL = EXP1 + EXP2
                P (M) = PVAL
                PVAL = EXP1 / PVAL
                PX (M) = PVAL * X12 + X2
                PY (M) = PVAL * Y12 + Y2
                PZ (M) = PVAL * Z12 + Z2
                SCALEP (M) = NORM1 (I) * NORM2 (J) * RHO12 (IJ)
  110        CONTINUE
         END IF

         IF (ATOMIC.OR.ATOM34) THEN
             M = 0
             DO 200 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                Q (M) = ALPHA3 (K) + ALPHA4 (L)
                SCALEQ (M) = NORM3 (K) * NORM4 (L)
  200        CONTINUE
             CASE = CASE - 2
         ELSE
             M = 0
             DO 220 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                EXP3 = ALPHA3 (K)
                EXP4 = ALPHA4 (L)
                QVAL = EXP3 + EXP4
                Q (M) = QVAL
                QVAL = EXP3 / QVAL
                QX (M) = QVAL * X34 + X4
                QY (M) = QVAL * Y34 + Y4
                QZ (M) = QVAL * Z34 + Z4
                SCALEQ (M) = NORM3 (K) * NORM4 (L) * RHO34 (KL)
  220        CONTINUE
         END IF

         IF (ATOMIC) THEN
             CASE = CASE - 1
         END IF
C
C
C             ...jump according to type of 'K4' loop:
C
C                       CASE  |  Integral center type
C                     --------|-----------------------
C                         1   |     (AA|AA)  atomic
C                         2   |     (AA|CC)  2-center
C                         3   |     (AB|CC)  3-center
C                         4   |     (AA|CD)  3-center
C                         5   |     (AB|CD)  4-center
C
C
         GOTO (10,20,30,40,50) CASE
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic (AA|AA)
C                type integrals.
C
C
   10    M = 0
         DO 1000 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1100 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               F0 = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))
               U0 = HALF * PQPINV
C
C
C             ...assemble the non-zero atomic (AA|AA) type integrals.
C
C
               A = U0 * F0 * FIFTH
               B = U0 * A

               GXYXY = B
               GXXYY = GXYXY + F0 / (SIX * PQMULT)
               GXXXX = GXXYY + A * PQPINV

               BATCH (M+ 1) =  GXXXX
               BATCH (M+ 2) =  ZERO
               BATCH (M+ 3) =  ZERO
               BATCH (M+ 4) =  ZERO
               BATCH (M+ 5) =  GXXYY
               BATCH (M+ 6) =  ZERO
               BATCH (M+ 7) =  ZERO
               BATCH (M+ 8) =  ZERO
               BATCH (M+ 9) =  GXXYY
               BATCH (M+10) =  ZERO
               BATCH (M+11) =  GXYXY
               BATCH (M+12) =  ZERO
               BATCH (M+13) =  GXYXY
               BATCH (M+14) =  ZERO
               BATCH (M+15) =  ZERO
               BATCH (M+16) =  ZERO
               BATCH (M+17) =  ZERO
               BATCH (M+18) =  ZERO
               BATCH (M+19) =  ZERO
               BATCH (M+20) =  ZERO
               BATCH (M+21) =  GXYXY
               BATCH (M+22) =  ZERO
               BATCH (M+23) =  ZERO
               BATCH (M+24) =  ZERO
               BATCH (M+25) =  GXYXY
               BATCH (M+26) =  ZERO
               BATCH (M+27) =  ZERO
               BATCH (M+28) =  ZERO
               BATCH (M+29) =  GXYXY
               BATCH (M+30) =  ZERO
               BATCH (M+31) =  GXYXY
               BATCH (M+32) =  ZERO
               BATCH (M+33) =  ZERO
               BATCH (M+34) =  ZERO
               BATCH (M+35) =  ZERO
               BATCH (M+36) =  ZERO
               BATCH (M+37) =  GXXYY
               BATCH (M+38) =  ZERO
               BATCH (M+39) =  ZERO
               BATCH (M+40) =  ZERO
               BATCH (M+41) =  GXXXX
               BATCH (M+42) =  ZERO
               BATCH (M+43) =  ZERO
               BATCH (M+44) =  ZERO
               BATCH (M+45) =  GXXYY
               BATCH (M+46) =  ZERO
               BATCH (M+47) =  ZERO
               BATCH (M+48) =  ZERO
               BATCH (M+49) =  ZERO
               BATCH (M+50) =  ZERO
               BATCH (M+51) =  GXYXY
               BATCH (M+52) =  ZERO
               BATCH (M+53) =  GXYXY
               BATCH (M+54) =  ZERO
               BATCH (M+55) =  ZERO
               BATCH (M+56) =  ZERO
               BATCH (M+57) =  GXYXY
               BATCH (M+58) =  ZERO
               BATCH (M+59) =  ZERO
               BATCH (M+60) =  ZERO
               BATCH (M+61) =  GXYXY
               BATCH (M+62) =  ZERO
               BATCH (M+63) =  ZERO
               BATCH (M+64) =  ZERO
               BATCH (M+65) =  ZERO
               BATCH (M+66) =  ZERO
               BATCH (M+67) =  ZERO
               BATCH (M+68) =  ZERO
               BATCH (M+69) =  GXYXY
               BATCH (M+70) =  ZERO
               BATCH (M+71) =  GXYXY
               BATCH (M+72) =  ZERO
               BATCH (M+73) =  GXXYY
               BATCH (M+74) =  ZERO
               BATCH (M+75) =  ZERO
               BATCH (M+76) =  ZERO
               BATCH (M+77) =  GXXYY
               BATCH (M+78) =  ZERO
               BATCH (M+79) =  ZERO
               BATCH (M+80) =  ZERO
               BATCH (M+81) =  GXXXX

               M = M + 81

 1100       CONTINUE
 1000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center (AA|CC)
C                type integrals.
C
C
   20    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX*PQX + PQY*PQY + PQZ*PQZ

         M = 0
         DO 2000 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            U3 = HALF / PVAL
            DO 2200 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F4 = ((((( FTABLE (10,TGRID) * DELTA6
     +                      + FTABLE (9,TGRID)) * DELTA5
     +                      + FTABLE (8,TGRID)) * DELTA4
     +                      + FTABLE (7,TGRID)) * DELTA3
     +                      + FTABLE (6,TGRID)) * DELTA2
     +                      + FTABLE (5,TGRID)) * DELTA1
     +                      + FTABLE (4,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3
                   F4 = SCALE * F4

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2
                   F4 = SEVEN * T2INV * F3

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U4 = HALF / QVAL
               U5 = U2 + PQPINV
               U6 = U5 + U5
               U7 = - U0 * U4
               U8 = U1 * U3
               U9 = U3 * U4
               U10 = U2 * U5
C
C
C             ...the X-terms.
C
C
               XSSSP2 = PQX * U0
               XSPSS2 = PQX * U1
               XSPSP3 = XSSSP2 * XSPSS2
               XSSPP3 = XSSSP2 * XSSSP2
               XPPSS3 = XSPSS2 * XSPSS2
               XSPPP2 = XSPSS2 * U4
               XPPSP2 = XSSSP2 * U3
               XSPPP3 = XSSSP2 * U5
               XPPSP3 = XSPSS2 * U5
               XSPPP4 = XSSPP3 * XSPSS2
               XPPSP4 = XPPSS3 * XSSSP2
               XPPPP3 = U3 * XSSPP3 + U4 * XPPSS3 + U10
               XPPPP4 = XSPSP3 * U6
               XPPPP5 = XSSPP3 * XPPSS3
C
C
C             ...the Y-terms.
C
C
               YSSSP2 = PQY * U0
               YSPSS2 = PQY * U1
               YSPSP3 = YSSSP2 * YSPSS2
               YSSPP3 = YSSSP2 * YSSSP2
               YPPSS3 = YSPSS2 * YSPSS2
               YSPPP2 = YSPSS2 * U4
               YPPSP2 = YSSSP2 * U3
               YSPPP3 = YSSSP2 * U5
               YPPSP3 = YSPSS2 * U5
               YSPPP4 = YSSPP3 * YSPSS2
               YPPSP4 = YPPSS3 * YSSSP2
               YPPPP3 = U3 * YSSPP3 + U4 * YPPSS3 + U10
               YPPPP4 = YSPSP3 * U6
               YPPPP5 = YSSPP3 * YPPSS3
C
C
C             ...the Z-terms.
C
C
               ZSSSP2 = PQZ * U0
               ZSPSS2 = PQZ * U1
               ZSPSP3 = ZSSSP2 * ZSPSS2
               ZSSPP3 = ZSSSP2 * ZSSSP2
               ZPPSS3 = ZSPSS2 * ZSPSS2
               ZSPPP2 = ZSPSS2 * U4
               ZPPSP2 = ZSSSP2 * U3
               ZSPPP3 = ZSSSP2 * U5
               ZPPSP3 = ZSPSS2 * U5
               ZSPPP4 = ZSSPP3 * ZSPSS2
               ZPPSP4 = ZPPSS3 * ZSSSP2
               ZPPPP3 = U3 * ZSSPP3 + U4 * ZPPSS3 + U10
               ZPPPP4 = ZSPSP3 * U6
               ZPPPP5 = ZSSPP3 * ZPPSS3
C
C
C             ...assemble the 2-center (AA|CC) type integrals.
C
C
               A = U9 * (F0 + (U1 - U0) * F1)

               GXXXX = A + XPPPP3 * F2 + XPPPP4 * F3 + XPPPP5 * F4
               GYYYY = A + YPPPP3 * F2 + YPPPP4 * F3 + YPPPP5 * F4
               GZZZZ = A + ZPPPP3 * F2 + ZPPPP4 * F3 + ZPPPP5 * F4

               A = XPPSP2 * F2 + XPPSP3 * F3 + XPPSP4 * F4
               B = XSPPP2 * F2 + XSPPP3 * F3 + XSPPP4 * F4
               C = YPPSP2 * F2 + YPPSP3 * F3 + YPPSP4 * F4
               D = YSPPP2 * F2 + YSPPP3 * F3 + YSPPP4 * F4
               E = ZPPSP2 * F2 + ZPPSP3 * F3 + ZPPSP4 * F4
               F = ZSPPP2 * F2 + ZSPPP3 * F3 + ZSPPP4 * F4

               GXXXY = A * YSSSP2
               GXYXX = B * YSPSS2
               GXXXZ = A * ZSSSP2
               GXZXX = B * ZSPSS2
               GYYXY = C * XSSSP2
               GXYYY = D * XSPSS2
               GYYYZ = C * ZSSSP2
               GYZYY = D * ZSPSS2
               GZZXZ = E * XSSSP2
               GXZZZ = F * XSPSS2
               GZZYZ = E * YSSSP2
               GYZZZ = F * YSPSS2

               AA = U3 * F2
               BB = U8 * F3
               CC = (U4 * F0 + U7 * F1) * U3
               DD = (U4 * F1 + U7 * F2) * U8
               EE = (U4 * F2 + U7 * F3)
               FF = AA + BB

               A = CC + XSSPP3 * AA
               B = DD + XSSPP3 * BB
               C = EE + XSSPP3 * F4
               D = CC + YSSPP3 * AA
               E = DD + YSSPP3 * BB
               F = EE + YSSPP3 * F4
               G = CC + ZSSPP3 * AA
               H = DD + ZSSPP3 * BB
               R = EE + ZSSPP3 * F4

               GXXYY = D + E + F * XPPSS3
               GXXZZ = G + H + R * XPPSS3
               GYYXX = A + B + C * YPPSS3
               GYYZZ = G + H + R * YPPSS3
               GZZXX = A + B + C * ZPPSS3
               GZZYY = D + E + F * ZPPSS3
               GYZXX = C * YSPSS2 * ZSPSS2
               GXZYY = F * XSPSS2 * ZSPSS2
               GXYZZ = R * XSPSS2 * YSPSS2
               GXXYZ = (FF + XPPSS3 * F4) * YSSSP2 * ZSSSP2
               GYYXZ = (FF + YPPSS3 * F4) * XSSSP2 * ZSSSP2
               GZZXY = (FF + ZPPSS3 * F4) * XSSSP2 * YSSSP2

               AA = U2 * F2
               BB = U2 * F3
               CC = AA * U2

               A = CC + XSPSP3 * BB
               B = BB + XSPSP3 * F4
               C = CC + YSPSP3 * BB
               D = BB + YSPSP3 * F4
               E = AA + ZSPSP3 * F3
               F = BB + ZSPSP3 * F4

               GXYXY = A + B * YSPSP3
               GXZXZ = A + B * ZSPSP3
               GYZYZ = C + D * ZSPSP3
               GXYXZ = B * YSPSS2 * ZSSSP2
               GXYYZ = D * XSPSS2 * ZSSSP2
               GXZXY = B * ZSPSS2 * YSSSP2
               GXZYZ = F * XSPSS2 * YSSSP2
               GYZXY = D * ZSPSS2 * XSSSP2
               GYZXZ = F * YSPSS2 * XSSSP2

               BATCH (M+ 1) =  GXXXX
               BATCH (M+ 2) =  GXYXX
               BATCH (M+ 3) =  GXZXX
               BATCH (M+ 4) =  GXYXX
               BATCH (M+ 5) =  GYYXX
               BATCH (M+ 6) =  GYZXX
               BATCH (M+ 7) =  GXZXX
               BATCH (M+ 8) =  GYZXX
               BATCH (M+ 9) =  GZZXX
               BATCH (M+10) =  GXXXY
               BATCH (M+11) =  GXYXY
               BATCH (M+12) =  GXZXY
               BATCH (M+13) =  GXYXY
               BATCH (M+14) =  GYYXY
               BATCH (M+15) =  GYZXY
               BATCH (M+16) =  GXZXY
               BATCH (M+17) =  GYZXY
               BATCH (M+18) =  GZZXY
               BATCH (M+19) =  GXXXZ
               BATCH (M+20) =  GXYXZ
               BATCH (M+21) =  GXZXZ
               BATCH (M+22) =  GXYXZ
               BATCH (M+23) =  GYYXZ
               BATCH (M+24) =  GYZXZ
               BATCH (M+25) =  GXZXZ
               BATCH (M+26) =  GYZXZ
               BATCH (M+27) =  GZZXZ
               BATCH (M+28) =  GXXXY
               BATCH (M+29) =  GXYXY
               BATCH (M+30) =  GXZXY
               BATCH (M+31) =  GXYXY
               BATCH (M+32) =  GYYXY
               BATCH (M+33) =  GYZXY
               BATCH (M+34) =  GXZXY
               BATCH (M+35) =  GYZXY
               BATCH (M+36) =  GZZXY
               BATCH (M+37) =  GXXYY
               BATCH (M+38) =  GXYYY
               BATCH (M+39) =  GXZYY
               BATCH (M+40) =  GXYYY
               BATCH (M+41) =  GYYYY
               BATCH (M+42) =  GYZYY
               BATCH (M+43) =  GXZYY
               BATCH (M+44) =  GYZYY
               BATCH (M+45) =  GZZYY
               BATCH (M+46) =  GXXYZ
               BATCH (M+47) =  GXYYZ
               BATCH (M+48) =  GXZYZ
               BATCH (M+49) =  GXYYZ
               BATCH (M+50) =  GYYYZ
               BATCH (M+51) =  GYZYZ
               BATCH (M+52) =  GXZYZ
               BATCH (M+53) =  GYZYZ
               BATCH (M+54) =  GZZYZ
               BATCH (M+55) =  GXXXZ
               BATCH (M+56) =  GXYXZ
               BATCH (M+57) =  GXZXZ
               BATCH (M+58) =  GXYXZ
               BATCH (M+59) =  GYYXZ
               BATCH (M+60) =  GYZXZ
               BATCH (M+61) =  GXZXZ
               BATCH (M+62) =  GYZXZ
               BATCH (M+63) =  GZZXZ
               BATCH (M+64) =  GXXYZ
               BATCH (M+65) =  GXYYZ
               BATCH (M+66) =  GXZYZ
               BATCH (M+67) =  GXYYZ
               BATCH (M+68) =  GYYYZ
               BATCH (M+69) =  GYZYZ
               BATCH (M+70) =  GXZYZ
               BATCH (M+71) =  GYZYZ
               BATCH (M+72) =  GZZYZ
               BATCH (M+73) =  GXXZZ
               BATCH (M+74) =  GXYZZ
               BATCH (M+75) =  GXZZZ
               BATCH (M+76) =  GXYZZ
               BATCH (M+77) =  GYYZZ
               BATCH (M+78) =  GYZZZ
               BATCH (M+79) =  GXZZZ
               BATCH (M+80) =  GYZZZ
               BATCH (M+81) =  GZZZZ

               M = M + 81

 2200       CONTINUE
 2000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center (AB|CC)
C                type integrals.
C
C
   30    M = 0
         DO 3000 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PQX = PXVAL - X3
            PQY = PYVAL - Y3
            PQZ = PZVAL - Z3
            RNPQSQ = PQX*PQX + PQY*PQY + PQZ*PQZ
            PSCALE = SCALEP (IJ)
            U3 = HALF / PVAL
            XSPSS1 = PXVAL - X2
            XPSSS1 = PXVAL - X1
            YSPSS1 = PYVAL - Y2
            YPSSS1 = PYVAL - Y1
            ZSPSS1 = PZVAL - Z2
            ZPSSS1 = PZVAL - Z1
            DO 3300 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F4 = ((((( FTABLE (10,TGRID) * DELTA6
     +                      + FTABLE (9,TGRID)) * DELTA5
     +                      + FTABLE (8,TGRID)) * DELTA4
     +                      + FTABLE (7,TGRID)) * DELTA3
     +                      + FTABLE (6,TGRID)) * DELTA2
     +                      + FTABLE (5,TGRID)) * DELTA1
     +                      + FTABLE (4,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3
                   F4 = SCALE * F4

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2
                   F4 = SEVEN * T2INV * F3

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U4 = HALF / QVAL
               U5 = U2 + PQPINV
               U6 = U5 + PQPINV
               U7 = - U0 * U4
               U8 = U1 * U3
C
C
C             ...the X-terms (with exception of XSPSS1 and XPSSS1,
C                which can be evaluated in the P-loop).
C
C
               XSSSP2 = PQX * U0
               XSPSS2 = PQX * U1
               B      = XSPSS1 + XPSSS1
               XSSPP1 = U4
               XPPSS1 = XSPSS1 * XPSSS1 + U3
               XSPSP2 = XSPSS1 * XSSSP2 + U2
               XPSSP2 = XPSSS1 * XSSSP2 + U2
               XSSPP2 = U7
               XPPSS2 = B * XSPSS2 + U8
               XSPSP3 = XSSSP2 * XSPSS2
               XSSPP3 = XSSSP2 * XSSSP2
               XPPSS3 = XSPSS2 * XSPSS2
               XSPPP1 = XSSPP1 * XSPSS1
               XPSPP1 = XSSPP1 * XPSSS1
               D      = XSPSS2 * XSSPP1
               XPPSP2 = XSSSP2 * XPPSS1 + B * U2
               XSPPP2 = XSPSS1 * XSSPP2 + D
               XPSPP2 = XPSSS1 * XSSPP2 + D
               D      = XSSSP2 * U5
               XPPSP3 = B * XSPSP3 + XSPSS2 * U5
               XSPPP3 = XSPSS1 * XSSPP3 + D
               XPSPP3 = XPSSS1 * XSSPP3 + D
               XSPPP4 = XSSPP3 * XSPSS2
               XPPSP4 = XPPSS3 * XSSSP2
               D      = B * XSSSP2 + U2
               XPPPP1 = XSSPP1 * XPPSS1
               XPPPP2 = XSSPP2 * XPPSS1 + XPPSS2 * XSSPP1
               XPPPP3 = XPPSS1 * XSSPP3 + XSSPP1 * XPPSS3 + U5 * D
               XPPPP4 = XSPSP3 * (D + U6)
               XPPPP5 = XSSPP3 * XPPSS3
C
C
C             ...the Y-terms (with exception of YSPSS1 and YPSSS1,
C                which can be evaluated in the P-loop).
C
C
               YSSSP2 = PQY * U0
               YSPSS2 = PQY * U1
               B      = YSPSS1 + YPSSS1
               YSSPP1 = U4
               YPPSS1 = YSPSS1 * YPSSS1 + U3
               YSPSP2 = YSPSS1 * YSSSP2 + U2
               YPSSP2 = YPSSS1 * YSSSP2 + U2
               YSSPP2 = U7
               YPPSS2 = B * YSPSS2 + U8
               YSPSP3 = YSSSP2 * YSPSS2
               YSSPP3 = YSSSP2 * YSSSP2
               YPPSS3 = YSPSS2 * YSPSS2
               YSPPP1 = YSSPP1 * YSPSS1
               YPSPP1 = YSSPP1 * YPSSS1
               D      = YSPSS2 * YSSPP1
               YPPSP2 = YSSSP2 * YPPSS1 + B * U2
               YSPPP2 = YSPSS1 * YSSPP2 + D
               YPSPP2 = YPSSS1 * YSSPP2 + D
               D      = YSSSP2 * U5
               YPPSP3 = B * YSPSP3 + YSPSS2 * U5
               YSPPP3 = YSPSS1 * YSSPP3 + D
               YPSPP3 = YPSSS1 * YSSPP3 + D
               YSPPP4 = YSSPP3 * YSPSS2
               YPPSP4 = YPPSS3 * YSSSP2
               D      = B * YSSSP2 + U2
               YPPPP1 = YSSPP1 * YPPSS1
               YPPPP2 = YSSPP2 * YPPSS1 + YPPSS2 * YSSPP1
               YPPPP3 = YPPSS1 * YSSPP3 + YSSPP1 * YPPSS3 + U5 * D
               YPPPP4 = YSPSP3 * (D + U6)
               YPPPP5 = YSSPP3 * YPPSS3
C
C
C             ...the Z-terms (with exception of ZSPSS1 and ZPSSS1,
C                which can be evaluated in the P-loop).
C
C
               ZSSSP2 = PQZ * U0
               ZSPSS2 = PQZ * U1
               B      = ZSPSS1 + ZPSSS1
               ZSSPP1 = U4
               ZPPSS1 = ZSPSS1 * ZPSSS1 + U3
               ZSPSP2 = ZSPSS1 * ZSSSP2 + U2
               ZPSSP2 = ZPSSS1 * ZSSSP2 + U2
               ZSSPP2 = U7
               ZPPSS2 = B * ZSPSS2 + U8
               ZSPSP3 = ZSSSP2 * ZSPSS2
               ZSSPP3 = ZSSSP2 * ZSSSP2
               ZPPSS3 = ZSPSS2 * ZSPSS2
               ZSPPP1 = ZSSPP1 * ZSPSS1
               ZPSPP1 = ZSSPP1 * ZPSSS1
               D      = ZSPSS2 * ZSSPP1
               ZPPSP2 = ZSSSP2 * ZPPSS1 + B * U2
               ZSPPP2 = ZSPSS1 * ZSSPP2 + D
               ZPSPP2 = ZPSSS1 * ZSSPP2 + D
               D      = ZSSSP2 * U5
               ZPPSP3 = B * ZSPSP3 + ZSPSS2 * U5
               ZSPPP3 = ZSPSS1 * ZSSPP3 + D
               ZPSPP3 = ZPSSS1 * ZSSPP3 + D
               ZSPPP4 = ZSSPP3 * ZSPSS2
               ZPPSP4 = ZPPSS3 * ZSSSP2
               D      = B * ZSSSP2 + U2
               ZPPPP1 = ZSSPP1 * ZPPSS1
               ZPPPP2 = ZSSPP2 * ZPPSS1 + ZPPSS2 * ZSSPP1
               ZPPPP3 = ZPPSS1 * ZSSPP3 + ZSSPP1 * ZPPSS3 + U5 * D
               ZPPPP4 = ZSPSP3 * (D + U6)
               ZPPPP5 = ZSSPP3 * ZPPSS3
C
C
C             ...assemble the 3-center (AB|CC) type integrals.
C
C
               GXXXX = XPPPP1*F0+XPPPP2*F1+XPPPP3*F2+XPPPP4*F3+XPPPP5*F4
               GYYYY = YPPPP1*F0+YPPPP2*F1+YPPPP3*F2+YPPPP4*F3+YPPPP5*F4
               GZZZZ = ZPPPP1*F0+ZPPPP2*F1+ZPPPP3*F2+ZPPPP4*F3+ZPPPP5*F4

               A = XPPSP2 * F2 + XPPSP3 * F3 + XPPSP4 * F4
               B = XPSPP1 * F0 + XPSPP2 * F1 + XPSPP3 * F2 + XSPPP4 * F3
               C = XPSPP1 * F1 + XPSPP2 * F2 + XPSPP3 * F3 + XSPPP4 * F4
               D = XSPPP1 * F0 + XSPPP2 * F1 + XSPPP3 * F2 + XSPPP4 * F3
               E = XSPPP1 * F1 + XSPPP2 * F2 + XSPPP3 * F3 + XSPPP4 * F4

               GXXXY = A * YSSSP2
               GXYXX = B * YSPSS1 + C * YSPSS2
               GYXXX = D * YPSSS1 + E * YSPSS2
               GXXXZ = A * ZSSSP2
               GXZXX = B * ZSPSS1 + C * ZSPSS2
               GZXXX = D * ZPSSS1 + E * ZSPSS2

               A = YPPSP2 * F2 + YPPSP3 * F3 + YPPSP4 * F4
               B = YPSPP1 * F0 + YPSPP2 * F1 + YPSPP3 * F2 + YSPPP4 * F3
               C = YPSPP1 * F1 + YPSPP2 * F2 + YPSPP3 * F3 + YSPPP4 * F4
               D = YSPPP1 * F0 + YSPPP2 * F1 + YSPPP3 * F2 + YSPPP4 * F3
               E = YSPPP1 * F1 + YSPPP2 * F2 + YSPPP3 * F3 + YSPPP4 * F4

               GYYXY = A * XSSSP2
               GYXYY = B * XSPSS1 + C * XSPSS2
               GXYYY = D * XPSSS1 + E * XSPSS2
               GYYYZ = A * ZSSSP2
               GYZYY = B * ZSPSS1 + C * ZSPSS2
               GZYYY = D * ZPSSS1 + E * ZSPSS2

               A = ZPPSP2 * F2 + ZPPSP3 * F3 + ZPPSP4 * F4
               B = ZPSPP1 * F0 + ZPSPP2 * F1 + ZPSPP3 * F2 + ZSPPP4 * F3
               C = ZPSPP1 * F1 + ZPSPP2 * F2 + ZPSPP3 * F3 + ZSPPP4 * F4
               D = ZSPPP1 * F0 + ZSPPP2 * F1 + ZSPPP3 * F2 + ZSPPP4 * F3
               E = ZSPPP1 * F1 + ZSPPP2 * F2 + ZSPPP3 * F3 + ZSPPP4 * F4

               GZZXZ = A * XSSSP2
               GZXZZ = B * XSPSS1 + C * XSPSS2
               GXZZZ = D * XPSSS1 + E * XSPSS2
               GZZYZ = A * YSSSP2
               GZYZZ = B * YSPSS1 + C * YSPSS2
               GYZZZ = D * YPSSS1 + E * YSPSS2

               A = XSSPP1 * F0 + XSSPP2 * F1 + XSSPP3 * F2
               B = XSSPP1 * F1 + XSSPP2 * F2 + XSSPP3 * F3
               C = XSSPP1 * F2 + XSSPP2 * F3 + XSSPP3 * F4
               D = YSSPP1 * F0 + YSSPP2 * F1 + YSSPP3 * F2
               E = YSSPP1 * F1 + YSSPP2 * F2 + YSSPP3 * F3
               F = YSSPP1 * F2 + YSSPP2 * F3 + YSSPP3 * F4
               G = ZSSPP1 * F0 + ZSSPP2 * F1 + ZSSPP3 * F2
               H = ZSSPP1 * F1 + ZSSPP2 * F2 + ZSSPP3 * F3
               R = ZSSPP1 * F2 + ZSSPP2 * F3 + ZSSPP3 * F4

               GXXYY = D * XPPSS1 + E * XPPSS2 + F * XPPSS3
               GXXZZ = G * XPPSS1 + H * XPPSS2 + R * XPPSS3
               GYYXX = A * YPPSS1 + B * YPPSS2 + C * YPPSS3
               GYYZZ = G * YPPSS1 + H * YPPSS2 + R * YPPSS3
               GZZXX = A * ZPPSS1 + B * ZPPSS2 + C * ZPPSS3
               GZZYY = D * ZPPSS1 + E * ZPPSS2 + F * ZPPSS3

               GYZXX = (A * YPSSS1 + B * YSPSS2) * ZSPSS1 +
     +                 (B * YPSSS1 + C * YSPSS2) * ZSPSS2
               GZYXX = (A * ZPSSS1 + B * ZSPSS2) * YSPSS1 +
     +                 (B * ZPSSS1 + C * ZSPSS2) * YSPSS2
               GXZYY = (D * XPSSS1 + E * XSPSS2) * ZSPSS1 +
     +                 (E * XPSSS1 + F * XSPSS2) * ZSPSS2
               GZXYY = (D * ZPSSS1 + E * ZSPSS2) * XSPSS1 +
     +                 (E * ZPSSS1 + F * ZSPSS2) * XSPSS2
               GXYZZ = (G * XPSSS1 + H * XSPSS2) * YSPSS1 +
     +                 (H * XPSSS1 + R * XSPSS2) * YSPSS2
               GYXZZ = (G * YPSSS1 + H * YSPSS2) * XSPSS1 +
     +                 (H * YPSSS1 + R * YSPSS2) * XSPSS2

               GXXYZ = (XPPSS1*F2+XPPSS2*F3+XPPSS3*F4) * YSSSP2 * ZSSSP2
               GYYXZ = (YPPSS1*F2+YPPSS2*F3+YPPSS3*F4) * XSSSP2 * ZSSSP2
               GZZXY = (ZPPSS1*F2+ZPPSS2*F3+ZPPSS3*F4) * XSSSP2 * YSSSP2

               AA = XSPSP3 * F3
               BB = XSPSP3 * F4
               CC = YSPSP3 * F3
               DD = YSPSP3 * F4
               EE = ZSPSP3 * F3
               FF = ZSPSP3 * F4

               A = XPSSP2 * F2 + AA
               B = XPSSP2 * F3 + BB
               C = YPSSP2 * F2 + CC
               D = YPSSP2 * F3 + DD
               E = ZPSSP2 * F2 + EE
               F = ZPSSP2 * F3 + FF

               GXYXY = A * YSPSP2 + B * YSPSP3
               GXZXZ = A * ZSPSP2 + B * ZSPSP3
               GYXXY = C * XSPSP2 + D * XSPSP3
               GYZYZ = C * ZSPSP2 + D * ZSPSP3
               GZXXZ = E * XSPSP2 + F * XSPSP3
               GZYYZ = E * YSPSP2 + F * YSPSP3

               GXYXZ = (A * YSPSS1 + B * YSPSS2) * ZSSSP2
               GXZXY = (A * ZSPSS1 + B * ZSPSS2) * YSSSP2
               GYXYZ = (C * XSPSS1 + D * XSPSS2) * ZSSSP2
               GYZXY = (C * ZSPSS1 + D * ZSPSS2) * XSSSP2
               GZXYZ = (E * XSPSS1 + F * XSPSS2) * YSSSP2
               GZYXZ = (E * YSPSS1 + F * YSPSS2) * XSSSP2

               A = XSPSP2 * F2 + AA
               B = XSPSP2 * F3 + BB
               C = YSPSP2 * F2 + CC
               D = YSPSP2 * F3 + DD
               E = ZSPSP2 * F2 + EE
               F = ZSPSP2 * F3 + FF

               GYXXZ = (A * YPSSS1 + B * YSPSS2) * ZSSSP2
               GZXXY = (A * ZPSSS1 + B * ZSPSS2) * YSSSP2
               GXYYZ = (C * XPSSS1 + D * XSPSS2) * ZSSSP2
               GZYXY = (C * ZPSSS1 + D * ZSPSS2) * XSSSP2
               GXZYZ = (E * XPSSS1 + F * XSPSS2) * YSSSP2
               GYZXZ = (E * YPSSS1 + F * YSPSS2) * XSSSP2

               BATCH (M+ 1) =  GXXXX
               BATCH (M+ 2) =  GYXXX
               BATCH (M+ 3) =  GZXXX
               BATCH (M+ 4) =  GXYXX
               BATCH (M+ 5) =  GYYXX
               BATCH (M+ 6) =  GZYXX
               BATCH (M+ 7) =  GXZXX
               BATCH (M+ 8) =  GYZXX
               BATCH (M+ 9) =  GZZXX
               BATCH (M+10) =  GXXXY
               BATCH (M+11) =  GYXXY
               BATCH (M+12) =  GZXXY
               BATCH (M+13) =  GXYXY
               BATCH (M+14) =  GYYXY
               BATCH (M+15) =  GZYXY
               BATCH (M+16) =  GXZXY
               BATCH (M+17) =  GYZXY
               BATCH (M+18) =  GZZXY
               BATCH (M+19) =  GXXXZ
               BATCH (M+20) =  GYXXZ
               BATCH (M+21) =  GZXXZ
               BATCH (M+22) =  GXYXZ
               BATCH (M+23) =  GYYXZ
               BATCH (M+24) =  GZYXZ
               BATCH (M+25) =  GXZXZ
               BATCH (M+26) =  GYZXZ
               BATCH (M+27) =  GZZXZ
               BATCH (M+28) =  GXXXY
               BATCH (M+29) =  GYXXY
               BATCH (M+30) =  GZXXY
               BATCH (M+31) =  GXYXY
               BATCH (M+32) =  GYYXY
               BATCH (M+33) =  GZYXY
               BATCH (M+34) =  GXZXY
               BATCH (M+35) =  GYZXY
               BATCH (M+36) =  GZZXY
               BATCH (M+37) =  GXXYY
               BATCH (M+38) =  GYXYY
               BATCH (M+39) =  GZXYY
               BATCH (M+40) =  GXYYY
               BATCH (M+41) =  GYYYY
               BATCH (M+42) =  GZYYY
               BATCH (M+43) =  GXZYY
               BATCH (M+44) =  GYZYY
               BATCH (M+45) =  GZZYY
               BATCH (M+46) =  GXXYZ
               BATCH (M+47) =  GYXYZ
               BATCH (M+48) =  GZXYZ
               BATCH (M+49) =  GXYYZ
               BATCH (M+50) =  GYYYZ
               BATCH (M+51) =  GZYYZ
               BATCH (M+52) =  GXZYZ
               BATCH (M+53) =  GYZYZ
               BATCH (M+54) =  GZZYZ
               BATCH (M+55) =  GXXXZ
               BATCH (M+56) =  GYXXZ
               BATCH (M+57) =  GZXXZ
               BATCH (M+58) =  GXYXZ
               BATCH (M+59) =  GYYXZ
               BATCH (M+60) =  GZYXZ
               BATCH (M+61) =  GXZXZ
               BATCH (M+62) =  GYZXZ
               BATCH (M+63) =  GZZXZ
               BATCH (M+64) =  GXXYZ
               BATCH (M+65) =  GYXYZ
               BATCH (M+66) =  GZXYZ
               BATCH (M+67) =  GXYYZ
               BATCH (M+68) =  GYYYZ
               BATCH (M+69) =  GZYYZ
               BATCH (M+70) =  GXZYZ
               BATCH (M+71) =  GYZYZ
               BATCH (M+72) =  GZZYZ
               BATCH (M+73) =  GXXZZ
               BATCH (M+74) =  GYXZZ
               BATCH (M+75) =  GZXZZ
               BATCH (M+76) =  GXYZZ
               BATCH (M+77) =  GYYZZ
               BATCH (M+78) =  GZYZZ
               BATCH (M+79) =  GXZZZ
               BATCH (M+80) =  GYZZZ
               BATCH (M+81) =  GZZZZ

               M = M + 81

 3300       CONTINUE
 3000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center (AA|CD)
C                type integrals.
C
C
   40    M = 0
         DO 4000 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            U3 = HALF / PVAL
            DO 4400 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = X1 - QXVAL
               PQY = Y1 - QYVAL
               PQZ = Z1 - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F4 = ((((( FTABLE (10,TGRID) * DELTA6
     +                      + FTABLE (9,TGRID)) * DELTA5
     +                      + FTABLE (8,TGRID)) * DELTA4
     +                      + FTABLE (7,TGRID)) * DELTA3
     +                      + FTABLE (6,TGRID)) * DELTA2
     +                      + FTABLE (5,TGRID)) * DELTA1
     +                      + FTABLE (4,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3
                   F4 = SCALE * F4

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2
                   F4 = SEVEN * T2INV * F3

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U4 = HALF / QVAL
               U5 = U2 + PQPINV
               U6 = U5 + PQPINV
               U7 = - U0 * U4
               U8 = U1 * U3
C
C
C             ...the X-terms.
C
C
               XSSSP1 = QXVAL - X4
               XSSPS1 = QXVAL - X3
               XSSSP2 = PQX * U0
               XSPSS2 = PQX * U1
               A      = XSSSP1 + XSSPS1
               XSSPP1 = XSSSP1 * XSSPS1 + U4
               XPPSS1 = U3
               XSPSP2 = XSSSP1 * XSPSS2 + U2
               XSPPS2 = XSSPS1 * XSPSS2 + U2
               XSSPP2 = A * XSSSP2 + U7
               XPPSS2 = U8
               XSPSP3 = XSSSP2 * XSPSS2
               XSSPP3 = XSSSP2 * XSSSP2
               XPPSS3 = XSPSS2 * XSPSS2
               XPPSP1 = XPPSS1 * XSSSP1
               XPPPS1 = XPPSS1 * XSSPS1
               XSPPP2 = XSPSS2 * XSSPP1 + A * U2
               E      = XSSSP2 * XPPSS1
               XPPSP2 = XSSSP1 * XPPSS2 + E
               XPPPS2 = XSSPS1 * XPPSS2 + E
               XSPPP3 = A * XSPSP3 + XSSSP2 * U5
               E      = XSPSS2 * U5
               XPPSP3 = XSSSP1 * XPPSS3 + E
               XPPPS3 = XSSPS1 * XPPSS3 + E
               XSPPP4 = XSSPP3 * XSPSS2
               XPPSP4 = XPPSS3 * XSSSP2
               D      = A * XSPSS2 + U2
               XPPPP1 = XSSPP1 * XPPSS1
               XPPPP2 = XSSPP2 * XPPSS1 + XPPSS2 * XSSPP1
               XPPPP3 = XPPSS1 * XSSPP3 + XSSPP1 * XPPSS3 + U5 * D
               XPPPP4 = XSPSP3 * (D + U6)
               XPPPP5 = XSSPP3 * XPPSS3
C
C
C             ...the Y-terms.
C
C
               YSSSP1 = QYVAL - Y4
               YSSPS1 = QYVAL - Y3
               YSSSP2 = PQY * U0
               YSPSS2 = PQY * U1
               A      = YSSSP1 + YSSPS1
               YSSPP1 = YSSSP1 * YSSPS1 + U4
               YPPSS1 = U3
               YSPSP2 = YSSSP1 * YSPSS2 + U2
               YSPPS2 = YSSPS1 * YSPSS2 + U2
               YSSPP2 = A * YSSSP2 + U7
               YPPSS2 = U8
               YSPSP3 = YSSSP2 * YSPSS2
               YSSPP3 = YSSSP2 * YSSSP2
               YPPSS3 = YSPSS2 * YSPSS2
               YPPSP1 = YPPSS1 * YSSSP1
               YPPPS1 = YPPSS1 * YSSPS1
               YSPPP2 = YSPSS2 * YSSPP1 + A * U2
               E      = YSSSP2 * YPPSS1
               YPPSP2 = YSSSP1 * YPPSS2 + E
               YPPPS2 = YSSPS1 * YPPSS2 + E
               YSPPP3 = A * YSPSP3 + YSSSP2 * U5
               E      = YSPSS2 * U5
               YPPSP3 = YSSSP1 * YPPSS3 + E
               YPPPS3 = YSSPS1 * YPPSS3 + E
               YSPPP4 = YSSPP3 * YSPSS2
               YPPSP4 = YPPSS3 * YSSSP2
               D      = A * YSPSS2 + U2
               YPPPP1 = YSSPP1 * YPPSS1
               YPPPP2 = YSSPP2 * YPPSS1 + YPPSS2 * YSSPP1
               YPPPP3 = YPPSS1 * YSSPP3 + YSSPP1 * YPPSS3 + U5 * D
               YPPPP4 = YSPSP3 * (D + U6)
               YPPPP5 = YSSPP3 * YPPSS3
C
C
C             ...the Z-terms.
C
C
               ZSSSP1 = QZVAL - Z4
               ZSSPS1 = QZVAL - Z3
               ZSSSP2 = PQZ * U0
               ZSPSS2 = PQZ * U1
               A      = ZSSSP1 + ZSSPS1
               ZSSPP1 = ZSSSP1 * ZSSPS1 + U4
               ZPPSS1 = U3
               ZSPSP2 = ZSSSP1 * ZSPSS2 + U2
               ZSPPS2 = ZSSPS1 * ZSPSS2 + U2
               ZSSPP2 = A * ZSSSP2 + U7
               ZPPSS2 = U8
               ZSPSP3 = ZSSSP2 * ZSPSS2
               ZSSPP3 = ZSSSP2 * ZSSSP2
               ZPPSS3 = ZSPSS2 * ZSPSS2
               ZPPSP1 = ZPPSS1 * ZSSSP1
               ZPPPS1 = ZPPSS1 * ZSSPS1
               ZSPPP2 = ZSPSS2 * ZSSPP1 + A * U2
               E      = ZSSSP2 * ZPPSS1
               ZPPSP2 = ZSSSP1 * ZPPSS2 + E
               ZPPPS2 = ZSSPS1 * ZPPSS2 + E
               ZSPPP3 = A * ZSPSP3 + ZSSSP2 * U5
               E      = ZSPSS2 * U5
               ZPPSP3 = ZSSSP1 * ZPPSS3 + E
               ZPPPS3 = ZSSPS1 * ZPPSS3 + E
               ZSPPP4 = ZSSPP3 * ZSPSS2
               ZPPSP4 = ZPPSS3 * ZSSSP2
               D      = A * ZSPSS2 + U2
               ZPPPP1 = ZSSPP1 * ZPPSS1
               ZPPPP2 = ZSSPP2 * ZPPSS1 + ZPPSS2 * ZSSPP1
               ZPPPP3 = ZPPSS1 * ZSSPP3 + ZSSPP1 * ZPPSS3 + U5 * D
               ZPPPP4 = ZSPSP3 * (D + U6)
               ZPPPP5 = ZSSPP3 * ZPPSS3
C
C
C             ...assemble the 3-center (AA|CD) type integrals.
C
C
               GXXXX = XPPPP1*F0+XPPPP2*F1+XPPPP3*F2+XPPPP4*F3+XPPPP5*F4
               GYYYY = YPPPP1*F0+YPPPP2*F1+YPPPP3*F2+YPPPP4*F3+YPPPP5*F4
               GZZZZ = ZPPPP1*F0+ZPPPP2*F1+ZPPPP3*F2+ZPPPP4*F3+ZPPPP5*F4

               A = XPPPS1 * F0 + XPPPS2 * F1 + XPPPS3 * F2 + XPPSP4 * F3
               B = XPPPS1 * F1 + XPPPS2 * F2 + XPPPS3 * F3 + XPPSP4 * F4
               C = XPPSP1 * F0 + XPPSP2 * F1 + XPPSP3 * F2 + XPPSP4 * F3
               D = XPPSP1 * F1 + XPPSP2 * F2 + XPPSP3 * F3 + XPPSP4 * F4
               E = XSPPP2 * F2 + XSPPP3 * F3 + XSPPP4 * F4

               GXXXY = A * YSSSP1 + B * YSSSP2
               GXXYX = C * YSSPS1 + D * YSSSP2
               GXYXX = E * YSPSS2
               GXXXZ = A * ZSSSP1 + B * ZSSSP2
               GXXZX = C * ZSSPS1 + D * ZSSSP2
               GXZXX = E * ZSPSS2

               A = YPPPS1 * F0 + YPPPS2 * F1 + YPPPS3 * F2 + YPPSP4 * F3
               B = YPPPS1 * F1 + YPPPS2 * F2 + YPPPS3 * F3 + YPPSP4 * F4
               C = YPPSP1 * F0 + YPPSP2 * F1 + YPPSP3 * F2 + YPPSP4 * F3
               D = YPPSP1 * F1 + YPPSP2 * F2 + YPPSP3 * F3 + YPPSP4 * F4
               E = YSPPP2 * F2 + YSPPP3 * F3 + YSPPP4 * F4

               GYYYX = A * XSSSP1 + B * XSSSP2
               GYYXY = C * XSSPS1 + D * XSSSP2
               GXYYY = E * XSPSS2
               GYYYZ = A * ZSSSP1 + B * ZSSSP2
               GYYZY = C * ZSSPS1 + D * ZSSSP2
               GYZYY = E * ZSPSS2

               A = ZPPPS1 * F0 + ZPPPS2 * F1 + ZPPPS3 * F2 + ZPPSP4 * F3
               B = ZPPPS1 * F1 + ZPPPS2 * F2 + ZPPPS3 * F3 + ZPPSP4 * F4
               C = ZPPSP1 * F0 + ZPPSP2 * F1 + ZPPSP3 * F2 + ZPPSP4 * F3
               D = ZPPSP1 * F1 + ZPPSP2 * F2 + ZPPSP3 * F3 + ZPPSP4 * F4
               E = ZSPPP2 * F2 + ZSPPP3 * F3 + ZSPPP4 * F4

               GZZZX = A * XSSSP1 + B * XSSSP2
               GZZXZ = C * XSSPS1 + D * XSSSP2
               GXZZZ = E * XSPSS2
               GZZZY = A * YSSSP1 + B * YSSSP2
               GZZYZ = C * YSSPS1 + D * YSSSP2
               GYZZZ = E * YSPSS2

               A = XPPSS1 * F0 + XPPSS2 * F1 + XPPSS3 * F2
               B = XPPSS1 * F1 + XPPSS2 * F2 + XPPSS3 * F3
               C = XPPSS1 * F2 + XPPSS2 * F3 + XPPSS3 * F4
               D = YPPSS1 * F0 + YPPSS2 * F1 + YPPSS3 * F2
               E = YPPSS1 * F1 + YPPSS2 * F2 + YPPSS3 * F3
               F = YPPSS1 * F2 + YPPSS2 * F3 + YPPSS3 * F4
               G = ZPPSS1 * F0 + ZPPSS2 * F1 + ZPPSS3 * F2
               H = ZPPSS1 * F1 + ZPPSS2 * F2 + ZPPSS3 * F3
               R = ZPPSS1 * F2 + ZPPSS2 * F3 + ZPPSS3 * F4

               GXXYY = A * YSSPP1 + B * YSSPP2 + C * YSSPP3
               GXXZZ = A * ZSSPP1 + B * ZSSPP2 + C * ZSSPP3
               GYYXX = D * XSSPP1 + E * XSSPP2 + F * XSSPP3
               GYYZZ = D * ZSSPP1 + E * ZSSPP2 + F * ZSSPP3
               GZZXX = G * XSSPP1 + H * XSSPP2 + R * XSSPP3
               GZZYY = G * YSSPP1 + H * YSSPP2 + R * YSSPP3

               GXXYZ = (A * YSSPS1 + B * YSSSP2) * ZSSSP1 +
     +                 (B * YSSPS1 + C * YSSSP2) * ZSSSP2
               GXXZY = (A * ZSSPS1 + B * ZSSSP2) * YSSSP1 +
     +                 (B * ZSSPS1 + C * ZSSSP2) * YSSSP2
               GYYXZ = (D * XSSPS1 + E * XSSSP2) * ZSSSP1 +
     +                 (E * XSSPS1 + F * XSSSP2) * ZSSSP2
               GYYZX = (D * ZSSPS1 + E * ZSSSP2) * XSSSP1 +
     +                 (E * ZSSPS1 + F * ZSSSP2) * XSSSP2
               GZZXY = (G * XSSPS1 + H * XSSSP2) * YSSSP1 +
     +                 (H * XSSPS1 + R * XSSSP2) * YSSSP2
               GZZYX = (G * YSSPS1 + H * YSSSP2) * XSSSP1 +
     +                 (H * YSSPS1 + R * YSSSP2) * XSSSP2

               GYZXX = (XSSPP1*F2+XSSPP2*F3+XSSPP3*F4) * YSPSS2 * ZSPSS2
               GXZYY = (YSSPP1*F2+YSSPP2*F3+YSSPP3*F4) * XSPSS2 * ZSPSS2
               GXYZZ = (ZSSPP1*F2+ZSSPP2*F3+ZSSPP3*F4) * XSPSS2 * YSPSS2

               AA = XSPSP3 * F3
               BB = XSPSP3 * F4
               CC = YSPSP3 * F3
               DD = YSPSP3 * F4
               EE = ZSPSP3 * F3
               FF = ZSPSP3 * F4

               A = XSPPS2 * F2 + AA
               B = XSPPS2 * F3 + BB
               C = YSPPS2 * F2 + CC
               D = YSPPS2 * F3 + DD
               E = ZSPPS2 * F2 + EE
               F = ZSPPS2 * F3 + FF

               GXYXY = A * YSPSP2 + B * YSPSP3
               GXZXZ = A * ZSPSP2 + B * ZSPSP3
               GXYYX = C * XSPSP2 + D * XSPSP3
               GYZYZ = C * ZSPSP2 + D * ZSPSP3
               GXZZX = E * XSPSP2 + F * XSPSP3
               GYZZY = E * YSPSP2 + F * YSPSP3

               GXYXZ = YSPSS2 * (A * ZSSSP1 + B * ZSSSP2)
               GXZXY = ZSPSS2 * (A * YSSSP1 + B * YSSSP2)
               GXYYZ = XSPSS2 * (C * ZSSSP1 + D * ZSSSP2)
               GYZYX = ZSPSS2 * (C * XSSSP1 + D * XSSSP2)
               GXZZY = XSPSS2 * (E * YSSSP1 + F * YSSSP2)
               GYZZX = YSPSS2 * (E * XSSSP1 + F * XSSSP2)

               A = XSPSP2 * F2 + AA
               B = XSPSP2 * F3 + BB
               C = YSPSP2 * F2 + CC
               D = YSPSP2 * F3 + DD
               E = ZSPSP2 * F2 + EE
               F = ZSPSP2 * F3 + FF

               GXYZX = YSPSS2 * (A * ZSSPS1 + B * ZSSSP2)
               GXZYX = ZSPSS2 * (A * YSSPS1 + B * YSSSP2)
               GXYZY = XSPSS2 * (C * ZSSPS1 + D * ZSSSP2)
               GYZXY = ZSPSS2 * (C * XSSPS1 + D * XSSSP2)
               GXZYZ = XSPSS2 * (E * YSSPS1 + F * YSSSP2)
               GYZXZ = YSPSS2 * (E * XSSPS1 + F * XSSSP2)

               BATCH (M+ 1) =  GXXXX
               BATCH (M+ 2) =  GXYXX
               BATCH (M+ 3) =  GXZXX
               BATCH (M+ 4) =  GXYXX
               BATCH (M+ 5) =  GYYXX
               BATCH (M+ 6) =  GYZXX
               BATCH (M+ 7) =  GXZXX
               BATCH (M+ 8) =  GYZXX
               BATCH (M+ 9) =  GZZXX
               BATCH (M+10) =  GXXYX
               BATCH (M+11) =  GXYYX
               BATCH (M+12) =  GXZYX
               BATCH (M+13) =  GXYYX
               BATCH (M+14) =  GYYYX
               BATCH (M+15) =  GYZYX
               BATCH (M+16) =  GXZYX
               BATCH (M+17) =  GYZYX
               BATCH (M+18) =  GZZYX
               BATCH (M+19) =  GXXZX
               BATCH (M+20) =  GXYZX
               BATCH (M+21) =  GXZZX
               BATCH (M+22) =  GXYZX
               BATCH (M+23) =  GYYZX
               BATCH (M+24) =  GYZZX
               BATCH (M+25) =  GXZZX
               BATCH (M+26) =  GYZZX
               BATCH (M+27) =  GZZZX
               BATCH (M+28) =  GXXXY
               BATCH (M+29) =  GXYXY
               BATCH (M+30) =  GXZXY
               BATCH (M+31) =  GXYXY
               BATCH (M+32) =  GYYXY
               BATCH (M+33) =  GYZXY
               BATCH (M+34) =  GXZXY
               BATCH (M+35) =  GYZXY
               BATCH (M+36) =  GZZXY
               BATCH (M+37) =  GXXYY
               BATCH (M+38) =  GXYYY
               BATCH (M+39) =  GXZYY
               BATCH (M+40) =  GXYYY
               BATCH (M+41) =  GYYYY
               BATCH (M+42) =  GYZYY
               BATCH (M+43) =  GXZYY
               BATCH (M+44) =  GYZYY
               BATCH (M+45) =  GZZYY
               BATCH (M+46) =  GXXZY
               BATCH (M+47) =  GXYZY
               BATCH (M+48) =  GXZZY
               BATCH (M+49) =  GXYZY
               BATCH (M+50) =  GYYZY
               BATCH (M+51) =  GYZZY
               BATCH (M+52) =  GXZZY
               BATCH (M+53) =  GYZZY
               BATCH (M+54) =  GZZZY
               BATCH (M+55) =  GXXXZ
               BATCH (M+56) =  GXYXZ
               BATCH (M+57) =  GXZXZ
               BATCH (M+58) =  GXYXZ
               BATCH (M+59) =  GYYXZ
               BATCH (M+60) =  GYZXZ
               BATCH (M+61) =  GXZXZ
               BATCH (M+62) =  GYZXZ
               BATCH (M+63) =  GZZXZ
               BATCH (M+64) =  GXXYZ
               BATCH (M+65) =  GXYYZ
               BATCH (M+66) =  GXZYZ
               BATCH (M+67) =  GXYYZ
               BATCH (M+68) =  GYYYZ
               BATCH (M+69) =  GYZYZ
               BATCH (M+70) =  GXZYZ
               BATCH (M+71) =  GYZYZ
               BATCH (M+72) =  GZZYZ
               BATCH (M+73) =  GXXZZ
               BATCH (M+74) =  GXYZZ
               BATCH (M+75) =  GXZZZ
               BATCH (M+76) =  GXYZZ
               BATCH (M+77) =  GYYZZ
               BATCH (M+78) =  GYZZZ
               BATCH (M+79) =  GXZZZ
               BATCH (M+80) =  GYZZZ
               BATCH (M+81) =  GZZZZ

               M = M + 81

 4400       CONTINUE
 4000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center (AB|CD)
C                type integrals.
C
C
   50    M = 0
         DO 5000 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            U3 = HALF / PVAL
            XSPSS1 = PXVAL - X2
            XPSSS1 = PXVAL - X1
            YSPSS1 = PYVAL - Y2
            YPSSS1 = PYVAL - Y1
            ZSPSS1 = PZVAL - Z2
            ZPSSS1 = PZVAL - Z1
            DO 5500 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = PXVAL - QXVAL
               PQY = PYVAL - QYVAL
               PQZ = PZVAL - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F4 = ((((( FTABLE (10,TGRID) * DELTA6
     +                      + FTABLE (9,TGRID)) * DELTA5
     +                      + FTABLE (8,TGRID)) * DELTA4
     +                      + FTABLE (7,TGRID)) * DELTA3
     +                      + FTABLE (6,TGRID)) * DELTA2
     +                      + FTABLE (5,TGRID)) * DELTA1
     +                      + FTABLE (4,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3
                   F4 = SCALE * F4

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2
                   F4 = SEVEN * T2INV * F3

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U4 = HALF / QVAL
               U5 = U2 + PQPINV
               U6 = U5 + PQPINV
               U7 = - U0 * U4
               U8 = U1 * U3
C
C
C             ...the X-terms (with exception of XSPSS1 and XPSSS1,
C                which can be evaluated in the P-loop).
C
C
               XSSSP1 = QXVAL - X4
               XSSPS1 = QXVAL - X3
               XSSSP2 = PQX * U0
               XSPSS2 = PQX * U1
               A      = XSSSP1 + XSSPS1
               B      = XSPSS1 + XPSSS1
               C      = A * B
               XSPSP1 = XSPSS1 * XSSSP1
               XPSSP1 = XPSSS1 * XSSSP1
               XSPPS1 = XSPSS1 * XSSPS1
               XPSPS1 = XPSSS1 * XSSPS1
               XSSPP1 = XSSSP1 * XSSPS1 + U4
               XPPSS1 = XSPSS1 * XPSSS1 + U3
               D      = XSSSP1 * XSPSS2 + U2
               E      = XSSPS1 * XSPSS2 + U2
               XSPSP2 = XSPSS1 * XSSSP2 + D
               XPSSP2 = XPSSS1 * XSSSP2 + D
               XSPPS2 = XSPSS1 * XSSSP2 + E
               XPSPS2 = XPSSS1 * XSSSP2 + E
               XSSPP2 = A * XSSSP2 + U7
               XPPSS2 = B * XSPSS2 + U8
               XSPSP3 = XSSSP2 * XSPSS2
               XSSPP3 = XSSSP2 * XSSSP2
               XPPSS3 = XSPSS2 * XSPSS2
               XSPPP1 = XSSPP1 * XSPSS1
               XPSPP1 = XSSPP1 * XPSSS1
               XPPSP1 = XPPSS1 * XSSSP1
               XPPPS1 = XPPSS1 * XSSPS1
               D      = XSPSS2 * XSSPP1 + A * U2
               E      = XSSSP2 * XPPSS1 + B * U2
               XSPPP2 = XSPSS1 * XSSPP2 + D
               XPSPP2 = XPSSS1 * XSSPP2 + D
               XPPSP2 = XSSSP1 * XPPSS2 + E
               XPPPS2 = XSSPS1 * XPPSS2 + E
               D      = A * XSPSP3 + XSSSP2 * U5
               E      = B * XSPSP3 + XSPSS2 * U5
               XSPPP3 = XSPSS1 * XSSPP3 + D
               XPSPP3 = XPSSS1 * XSSPP3 + D
               XPPSP3 = XSSSP1 * XPPSS3 + E
               XPPPS3 = XSSPS1 * XPPSS3 + E
               XSPPP4 = XSSPP3 * XSPSS2
               XPPSP4 = XPPSS3 * XSSSP2
               D      = B * XSSSP2 + A * XSPSS2 + U2
               XPPPP1 = XSSPP1 * XPPSS1
               XPPPP2 = XSSPP2 * XPPSS1 + XPPSS2 * XSSPP1 + C*U2
               XPPPP3 = XPPSS1 * XSSPP3 + XSSPP1 * XPPSS3 + XSPSP3 * C
     +                + U5 * D
               XPPPP4 = XSPSP3 * (D + U6)
               XPPPP5 = XSSPP3 * XPPSS3
C
C
C             ...the Y-terms (with exception of YSPSS1 and YPSSS1,
C                which can be evaluated in the P-loop).
C
C
               YSSSP1 = QYVAL - Y4
               YSSPS1 = QYVAL - Y3
               YSSSP2 = PQY * U0
               YSPSS2 = PQY * U1
               A      = YSSSP1 + YSSPS1
               B      = YSPSS1 + YPSSS1
               C      = A * B
               YSPSP1 = YSPSS1 * YSSSP1
               YPSSP1 = YPSSS1 * YSSSP1
               YSPPS1 = YSPSS1 * YSSPS1
               YPSPS1 = YPSSS1 * YSSPS1
               YSSPP1 = YSSSP1 * YSSPS1 + U4
               YPPSS1 = YSPSS1 * YPSSS1 + U3
               D      = YSSSP1 * YSPSS2 + U2
               E      = YSSPS1 * YSPSS2 + U2
               YSPSP2 = YSPSS1 * YSSSP2 + D
               YPSSP2 = YPSSS1 * YSSSP2 + D
               YSPPS2 = YSPSS1 * YSSSP2 + E
               YPSPS2 = YPSSS1 * YSSSP2 + E
               YSSPP2 = A * YSSSP2 + U7
               YPPSS2 = B * YSPSS2 + U8
               YSPSP3 = YSSSP2 * YSPSS2
               YSSPP3 = YSSSP2 * YSSSP2
               YPPSS3 = YSPSS2 * YSPSS2
               YSPPP1 = YSSPP1 * YSPSS1
               YPSPP1 = YSSPP1 * YPSSS1
               YPPSP1 = YPPSS1 * YSSSP1
               YPPPS1 = YPPSS1 * YSSPS1
               D      = YSPSS2 * YSSPP1 + A * U2
               E      = YSSSP2 * YPPSS1 + B * U2
               YSPPP2 = YSPSS1 * YSSPP2 + D
               YPSPP2 = YPSSS1 * YSSPP2 + D
               YPPSP2 = YSSSP1 * YPPSS2 + E
               YPPPS2 = YSSPS1 * YPPSS2 + E
               D      = A * YSPSP3 + YSSSP2 * U5
               E      = B * YSPSP3 + YSPSS2 * U5
               YSPPP3 = YSPSS1 * YSSPP3 + D
               YPSPP3 = YPSSS1 * YSSPP3 + D
               YPPSP3 = YSSSP1 * YPPSS3 + E
               YPPPS3 = YSSPS1 * YPPSS3 + E
               YSPPP4 = YSSPP3 * YSPSS2
               YPPSP4 = YPPSS3 * YSSSP2
               D      = B * YSSSP2 + A * YSPSS2 + U2
               YPPPP1 = YSSPP1 * YPPSS1
               YPPPP2 = YSSPP2 * YPPSS1 + YPPSS2 * YSSPP1 + C*U2
               YPPPP3 = YPPSS1 * YSSPP3 + YSSPP1 * YPPSS3 + YSPSP3 * C
     +                + U5 * D
               YPPPP4 = YSPSP3 * (D + U6)
               YPPPP5 = YSSPP3 * YPPSS3
C
C
C             ...the Z-terms (with exception of ZSPSS1 and ZPSSS1,
C                which can be evaluated in the P-loop).
C
C
               ZSSSP1 = QZVAL - Z4
               ZSSPS1 = QZVAL - Z3
               ZSSSP2 = PQZ * U0
               ZSPSS2 = PQZ * U1
               A      = ZSSSP1 + ZSSPS1
               B      = ZSPSS1 + ZPSSS1
               C      = A * B
               ZSPSP1 = ZSPSS1 * ZSSSP1
               ZPSSP1 = ZPSSS1 * ZSSSP1
               ZSPPS1 = ZSPSS1 * ZSSPS1
               ZPSPS1 = ZPSSS1 * ZSSPS1
               ZSSPP1 = ZSSSP1 * ZSSPS1 + U4
               ZPPSS1 = ZSPSS1 * ZPSSS1 + U3
               D      = ZSSSP1 * ZSPSS2 + U2
               E      = ZSSPS1 * ZSPSS2 + U2
               ZSPSP2 = ZSPSS1 * ZSSSP2 + D
               ZPSSP2 = ZPSSS1 * ZSSSP2 + D
               ZSPPS2 = ZSPSS1 * ZSSSP2 + E
               ZPSPS2 = ZPSSS1 * ZSSSP2 + E
               ZSSPP2 = A * ZSSSP2 + U7
               ZPPSS2 = B * ZSPSS2 + U8
               ZSPSP3 = ZSSSP2 * ZSPSS2
               ZSSPP3 = ZSSSP2 * ZSSSP2
               ZPPSS3 = ZSPSS2 * ZSPSS2
               ZSPPP1 = ZSSPP1 * ZSPSS1
               ZPSPP1 = ZSSPP1 * ZPSSS1
               ZPPSP1 = ZPPSS1 * ZSSSP1
               ZPPPS1 = ZPPSS1 * ZSSPS1
               D      = ZSPSS2 * ZSSPP1 + A * U2
               E      = ZSSSP2 * ZPPSS1 + B * U2
               ZSPPP2 = ZSPSS1 * ZSSPP2 + D
               ZPSPP2 = ZPSSS1 * ZSSPP2 + D
               ZPPSP2 = ZSSSP1 * ZPPSS2 + E
               ZPPPS2 = ZSSPS1 * ZPPSS2 + E
               D      = A * ZSPSP3 + ZSSSP2 * U5
               E      = B * ZSPSP3 + ZSPSS2 * U5
               ZSPPP3 = ZSPSS1 * ZSSPP3 + D
               ZPSPP3 = ZPSSS1 * ZSSPP3 + D
               ZPPSP3 = ZSSSP1 * ZPPSS3 + E
               ZPPPS3 = ZSSPS1 * ZPPSS3 + E
               ZSPPP4 = ZSSPP3 * ZSPSS2
               ZPPSP4 = ZPPSS3 * ZSSSP2
               D      = B * ZSSSP2 + A * ZSPSS2 + U2
               ZPPPP1 = ZSSPP1 * ZPPSS1
               ZPPPP2 = ZSSPP2 * ZPPSS1 + ZPPSS2 * ZSSPP1 + C*U2
               ZPPPP3 = ZPPSS1 * ZSSPP3 + ZSSPP1 * ZPPSS3 + ZSPSP3 * C
     +                + U5 * D
               ZPPPP4 = ZSPSP3 * (D + U6)
               ZPPPP5 = ZSSPP3 * ZPPSS3
C
C
C             ...assemble the 4-center (AB|CD) type integrals.
C
C
               GXXXX = XPPPP1*F0+XPPPP2*F1+XPPPP3*F2+XPPPP4*F3+XPPPP5*F4
               GYYYY = YPPPP1*F0+YPPPP2*F1+YPPPP3*F2+YPPPP4*F3+YPPPP5*F4
               GZZZZ = ZPPPP1*F0+ZPPPP2*F1+ZPPPP3*F2+ZPPPP4*F3+ZPPPP5*F4

               A = XPPPS1 * F0 + XPPPS2 * F1 + XPPPS3 * F2 + XPPSP4 * F3
               B = XPPPS1 * F1 + XPPPS2 * F2 + XPPPS3 * F3 + XPPSP4 * F4
               C = XPPSP1 * F0 + XPPSP2 * F1 + XPPSP3 * F2 + XPPSP4 * F3
               D = XPPSP1 * F1 + XPPSP2 * F2 + XPPSP3 * F3 + XPPSP4 * F4
               E = XPSPP1 * F0 + XPSPP2 * F1 + XPSPP3 * F2 + XSPPP4 * F3
               F = XPSPP1 * F1 + XPSPP2 * F2 + XPSPP3 * F3 + XSPPP4 * F4
               G = XSPPP1 * F0 + XSPPP2 * F1 + XSPPP3 * F2 + XSPPP4 * F3
               H = XSPPP1 * F1 + XSPPP2 * F2 + XSPPP3 * F3 + XSPPP4 * F4

               GXXXY = A * YSSSP1 + B * YSSSP2
               GXXYX = C * YSSPS1 + D * YSSSP2
               GXYXX = E * YSPSS1 + F * YSPSS2
               GYXXX = G * YPSSS1 + H * YSPSS2
               GXXXZ = A * ZSSSP1 + B * ZSSSP2
               GXXZX = C * ZSSPS1 + D * ZSSSP2
               GXZXX = E * ZSPSS1 + F * ZSPSS2
               GZXXX = G * ZPSSS1 + H * ZSPSS2

               A = YPPPS1 * F0 + YPPPS2 * F1 + YPPPS3 * F2 + YPPSP4 * F3
               B = YPPPS1 * F1 + YPPPS2 * F2 + YPPPS3 * F3 + YPPSP4 * F4
               C = YPPSP1 * F0 + YPPSP2 * F1 + YPPSP3 * F2 + YPPSP4 * F3
               D = YPPSP1 * F1 + YPPSP2 * F2 + YPPSP3 * F3 + YPPSP4 * F4
               E = YPSPP1 * F0 + YPSPP2 * F1 + YPSPP3 * F2 + YSPPP4 * F3
               F = YPSPP1 * F1 + YPSPP2 * F2 + YPSPP3 * F3 + YSPPP4 * F4
               G = YSPPP1 * F0 + YSPPP2 * F1 + YSPPP3 * F2 + YSPPP4 * F3
               H = YSPPP1 * F1 + YSPPP2 * F2 + YSPPP3 * F3 + YSPPP4 * F4

               GYYYX = A * XSSSP1 + B * XSSSP2
               GYYXY = C * XSSPS1 + D * XSSSP2
               GYXYY = E * XSPSS1 + F * XSPSS2
               GXYYY = G * XPSSS1 + H * XSPSS2
               GYYYZ = A * ZSSSP1 + B * ZSSSP2
               GYYZY = C * ZSSPS1 + D * ZSSSP2
               GYZYY = E * ZSPSS1 + F * ZSPSS2
               GZYYY = G * ZPSSS1 + H * ZSPSS2

               A = ZPPPS1 * F0 + ZPPPS2 * F1 + ZPPPS3 * F2 + ZPPSP4 * F3
               B = ZPPPS1 * F1 + ZPPPS2 * F2 + ZPPPS3 * F3 + ZPPSP4 * F4
               C = ZPPSP1 * F0 + ZPPSP2 * F1 + ZPPSP3 * F2 + ZPPSP4 * F3
               D = ZPPSP1 * F1 + ZPPSP2 * F2 + ZPPSP3 * F3 + ZPPSP4 * F4
               E = ZPSPP1 * F0 + ZPSPP2 * F1 + ZPSPP3 * F2 + ZSPPP4 * F3
               F = ZPSPP1 * F1 + ZPSPP2 * F2 + ZPSPP3 * F3 + ZSPPP4 * F4
               G = ZSPPP1 * F0 + ZSPPP2 * F1 + ZSPPP3 * F2 + ZSPPP4 * F3
               H = ZSPPP1 * F1 + ZSPPP2 * F2 + ZSPPP3 * F3 + ZSPPP4 * F4

               GZZZX = A * XSSSP1 + B * XSSSP2
               GZZXZ = C * XSSPS1 + D * XSSSP2
               GZXZZ = E * XSPSS1 + F * XSPSS2
               GXZZZ = G * XPSSS1 + H * XSPSS2
               GZZZY = A * YSSSP1 + B * YSSSP2
               GZZYZ = C * YSSPS1 + D * YSSSP2
               GZYZZ = E * YSPSS1 + F * YSPSS2
               GYZZZ = G * YPSSS1 + H * YSPSS2

               A = XPPSS1 * F0 + XPPSS2 * F1 + XPPSS3 * F2
               B = XPPSS1 * F1 + XPPSS2 * F2 + XPPSS3 * F3
               C = XPPSS1 * F2 + XPPSS2 * F3 + XPPSS3 * F4
               D = YPPSS1 * F0 + YPPSS2 * F1 + YPPSS3 * F2
               E = YPPSS1 * F1 + YPPSS2 * F2 + YPPSS3 * F3
               F = YPPSS1 * F2 + YPPSS2 * F3 + YPPSS3 * F4
               G = ZPPSS1 * F0 + ZPPSS2 * F1 + ZPPSS3 * F2
               H = ZPPSS1 * F1 + ZPPSS2 * F2 + ZPPSS3 * F3
               R = ZPPSS1 * F2 + ZPPSS2 * F3 + ZPPSS3 * F4

               GXXYY = A * YSSPP1 + B * YSSPP2 + C * YSSPP3
               GXXZZ = A * ZSSPP1 + B * ZSSPP2 + C * ZSSPP3
               GYYXX = D * XSSPP1 + E * XSSPP2 + F * XSSPP3
               GYYZZ = D * ZSSPP1 + E * ZSSPP2 + F * ZSSPP3
               GZZXX = G * XSSPP1 + H * XSSPP2 + R * XSSPP3
               GZZYY = G * YSSPP1 + H * YSSPP2 + R * YSSPP3

               GXXYZ = (A * YSSPS1 + B * YSSSP2) * ZSSSP1 +
     +                 (B * YSSPS1 + C * YSSSP2) * ZSSSP2
               GXXZY = (A * ZSSPS1 + B * ZSSSP2) * YSSSP1 +
     +                 (B * ZSSPS1 + C * ZSSSP2) * YSSSP2
               GYYXZ = (D * XSSPS1 + E * XSSSP2) * ZSSSP1 +
     +                 (E * XSSPS1 + F * XSSSP2) * ZSSSP2
               GYYZX = (D * ZSSPS1 + E * ZSSSP2) * XSSSP1 +
     +                 (E * ZSSPS1 + F * ZSSSP2) * XSSSP2
               GZZXY = (G * XSSPS1 + H * XSSSP2) * YSSSP1 +
     +                 (H * XSSPS1 + R * XSSSP2) * YSSSP2
               GZZYX = (G * YSSPS1 + H * YSSSP2) * XSSSP1 +
     +                 (H * YSSPS1 + R * YSSSP2) * XSSSP2

               AA = XSPSP3 * F2
               BB = XSPSP3 * F3
               CC = XSPSP3 * F4
               DD = YSPSP3 * F2
               EE = YSPSP3 * F3
               FF = YSPSP3 * F4
               GG = ZSPSP3 * F2
               HH = ZSPSP3 * F3
               RR = ZSPSP3 * F4

               A = XPSPS1 * F0 + XPSPS2 * F1 + AA
               B = XPSPS1 * F1 + XPSPS2 * F2 + BB
               C = XPSPS1 * F2 + XPSPS2 * F3 + CC
               D = YPSPS1 * F0 + YPSPS2 * F1 + DD
               E = YPSPS1 * F1 + YPSPS2 * F2 + EE
               F = YPSPS1 * F2 + YPSPS2 * F3 + FF
               G = ZPSPS1 * F0 + ZPSPS2 * F1 + GG
               H = ZPSPS1 * F1 + ZPSPS2 * F2 + HH
               R = ZPSPS1 * F2 + ZPSPS2 * F3 + RR

               GXYXY = A * YSPSP1 + B * YSPSP2 + C * YSPSP3
               GXZXZ = A * ZSPSP1 + B * ZSPSP2 + C * ZSPSP3
               GYXYX = D * XSPSP1 + E * XSPSP2 + F * XSPSP3
               GYZYZ = D * ZSPSP1 + E * ZSPSP2 + F * ZSPSP3
               GZXZX = G * XSPSP1 + H * XSPSP2 + R * XSPSP3
               GZYZY = G * YSPSP1 + H * YSPSP2 + R * YSPSP3

               GXYXZ = (A * YSPSS1 + B * YSPSS2) * ZSSSP1 +
     +                 (B * YSPSS1 + C * YSPSS2) * ZSSSP2
               GXZXY = (A * ZSPSS1 + B * ZSPSS2) * YSSSP1 +
     +                 (B * ZSPSS1 + C * ZSPSS2) * YSSSP2
               GYXYZ = (D * XSPSS1 + E * XSPSS2) * ZSSSP1 +
     +                 (E * XSPSS1 + F * XSPSS2) * ZSSSP2
               GYZYX = (D * ZSPSS1 + E * ZSPSS2) * XSSSP1 +
     +                 (E * ZSPSS1 + F * ZSPSS2) * XSSSP2
               GZXZY = (G * XSPSS1 + H * XSPSS2) * YSSSP1 +
     +                 (H * XSPSS1 + R * XSPSS2) * YSSSP2
               GZYZX = (G * YSPSS1 + H * YSPSS2) * XSSSP1 +
     +                 (H * YSPSS1 + R * YSPSS2) * XSSSP2

               A = XPSSP1 * F0 + XPSSP2 * F1 + AA
               B = XPSSP1 * F1 + XPSSP2 * F2 + BB
               C = XPSSP1 * F2 + XPSSP2 * F3 + CC
               D = YPSSP1 * F0 + YPSSP2 * F1 + DD
               E = YPSSP1 * F1 + YPSSP2 * F2 + EE
               F = YPSSP1 * F2 + YPSSP2 * F3 + FF
               G = ZPSSP1 * F0 + ZPSSP2 * F1 + GG
               H = ZPSSP1 * F1 + ZPSSP2 * F2 + HH
               R = ZPSSP1 * F2 + ZPSSP2 * F3 + RR

               GXYYX = A * YSPPS1 + B * YSPPS2 + C * YSPSP3
               GXZZX = A * ZSPPS1 + B * ZSPPS2 + C * ZSPSP3
               GYXXY = D * XSPPS1 + E * XSPPS2 + F * XSPSP3
               GYZZY = D * ZSPPS1 + E * ZSPPS2 + F * ZSPSP3
               GZXXZ = G * XSPPS1 + H * XSPPS2 + R * XSPSP3
               GZYYZ = G * YSPPS1 + H * YSPPS2 + R * YSPSP3

               GXYZX = (A * YSPSS1 + B * YSPSS2) * ZSSPS1 +
     +                 (B * YSPSS1 + C * YSPSS2) * ZSSSP2
               GXZYX = (A * ZSPSS1 + B * ZSPSS2) * YSSPS1 +
     +                 (B * ZSPSS1 + C * ZSPSS2) * YSSSP2
               GYXZY = (D * XSPSS1 + E * XSPSS2) * ZSSPS1 +
     +                 (E * XSPSS1 + F * XSPSS2) * ZSSSP2
               GYZXY = (D * ZSPSS1 + E * ZSPSS2) * XSSPS1 +
     +                 (E * ZSPSS1 + F * ZSPSS2) * XSSSP2
               GZXYZ = (G * XSPSS1 + H * XSPSS2) * YSSPS1 +
     +                 (H * XSPSS1 + R * XSPSS2) * YSSSP2
               GZYXZ = (G * YSPSS1 + H * YSPSS2) * XSSPS1 +
     +                 (H * YSPSS1 + R * YSPSS2) * XSSSP2

               A = XSPPS1 * F0 + XSPPS2 * F1 + AA
               B = XSPPS1 * F1 + XSPPS2 * F2 + BB
               C = XSPPS1 * F2 + XSPPS2 * F3 + CC
               D = YSPPS1 * F0 + YSPPS2 * F1 + DD
               E = YSPPS1 * F1 + YSPPS2 * F2 + EE
               F = YSPPS1 * F2 + YSPPS2 * F3 + FF
               G = ZSPPS1 * F0 + ZSPPS2 * F1 + GG
               H = ZSPPS1 * F1 + ZSPPS2 * F2 + HH
               R = ZSPPS1 * F2 + ZSPPS2 * F3 + RR

               GYXXZ = (A * YPSSS1 + B * YSPSS2) * ZSSSP1 +
     +                 (B * YPSSS1 + C * YSPSS2) * ZSSSP2
               GZXXY = (A * ZPSSS1 + B * ZSPSS2) * YSSSP1 +
     +                 (B * ZPSSS1 + C * ZSPSS2) * YSSSP2
               GXYYZ = (D * XPSSS1 + E * XSPSS2) * ZSSSP1 +
     +                 (E * XPSSS1 + F * XSPSS2) * ZSSSP2
               GZYYX = (D * ZPSSS1 + E * ZSPSS2) * XSSSP1 +
     +                 (E * ZPSSS1 + F * ZSPSS2) * XSSSP2
               GXZZY = (G * XPSSS1 + H * XSPSS2) * YSSSP1 +
     +                 (H * XPSSS1 + R * XSPSS2) * YSSSP2
               GYZZX = (G * YPSSS1 + H * YSPSS2) * XSSSP1 +
     +                 (H * YPSSS1 + R * YSPSS2) * XSSSP2

               A = XSPSP1 * F0 + XSPSP2 * F1 + AA
               B = XSPSP1 * F1 + XSPSP2 * F2 + BB
               C = XSPSP1 * F2 + XSPSP2 * F3 + CC
               D = YSPSP1 * F0 + YSPSP2 * F1 + DD
               E = YSPSP1 * F1 + YSPSP2 * F2 + EE
               F = YSPSP1 * F2 + YSPSP2 * F3 + FF
               G = ZSPSP1 * F0 + ZSPSP2 * F1 + GG
               H = ZSPSP1 * F1 + ZSPSP2 * F2 + HH
               R = ZSPSP1 * F2 + ZSPSP2 * F3 + RR

               GYXZX = (A * YPSSS1 + B * YSPSS2) * ZSSPS1 +
     +                 (B * YPSSS1 + C * YSPSS2) * ZSSSP2
               GZXYX = (A * ZPSSS1 + B * ZSPSS2) * YSSPS1 +
     +                 (B * ZPSSS1 + C * ZSPSS2) * YSSSP2
               GXYZY = (D * XPSSS1 + E * XSPSS2) * ZSSPS1 +
     +                 (E * XPSSS1 + F * XSPSS2) * ZSSSP2
               GZYXY = (D * ZPSSS1 + E * ZSPSS2) * XSSPS1 +
     +                 (E * ZPSSS1 + F * ZSPSS2) * XSSSP2
               GXZYZ = (G * XPSSS1 + H * XSPSS2) * YSSPS1 +
     +                 (H * XPSSS1 + R * XSPSS2) * YSSSP2
               GYZXZ = (G * YPSSS1 + H * YSPSS2) * XSSPS1 +
     +                 (H * YPSSS1 + R * YSPSS2) * XSSSP2

               A = XSSPP1 * F0 + XSSPP2 * F1 + XSSPP3 * F2
               B = XSSPP1 * F1 + XSSPP2 * F2 + XSSPP3 * F3
               C = XSSPP1 * F2 + XSSPP2 * F3 + XSSPP3 * F4
               D = YSSPP1 * F0 + YSSPP2 * F1 + YSSPP3 * F2
               E = YSSPP1 * F1 + YSSPP2 * F2 + YSSPP3 * F3
               F = YSSPP1 * F2 + YSSPP2 * F3 + YSSPP3 * F4
               G = ZSSPP1 * F0 + ZSSPP2 * F1 + ZSSPP3 * F2
               H = ZSSPP1 * F1 + ZSSPP2 * F2 + ZSSPP3 * F3
               R = ZSSPP1 * F2 + ZSSPP2 * F3 + ZSSPP3 * F4

               GYZXX = (A * YPSSS1 + B * YSPSS2) * ZSPSS1 +
     +                 (B * YPSSS1 + C * YSPSS2) * ZSPSS2
               GZYXX = (A * ZPSSS1 + B * ZSPSS2) * YSPSS1 +
     +                 (B * ZPSSS1 + C * ZSPSS2) * YSPSS2
               GXZYY = (D * XPSSS1 + E * XSPSS2) * ZSPSS1 +
     +                 (E * XPSSS1 + F * XSPSS2) * ZSPSS2
               GZXYY = (D * ZPSSS1 + E * ZSPSS2) * XSPSS1 +
     +                 (E * ZPSSS1 + F * ZSPSS2) * XSPSS2
               GXYZZ = (G * XPSSS1 + H * XSPSS2) * YSPSS1 +
     +                 (H * XPSSS1 + R * XSPSS2) * YSPSS2
               GYXZZ = (G * YPSSS1 + H * YSPSS2) * XSPSS1 +
     +                 (H * YPSSS1 + R * YSPSS2) * XSPSS2

               BATCH (M+ 1) =  GXXXX
               BATCH (M+ 2) =  GYXXX
               BATCH (M+ 3) =  GZXXX
               BATCH (M+ 4) =  GXYXX
               BATCH (M+ 5) =  GYYXX
               BATCH (M+ 6) =  GZYXX
               BATCH (M+ 7) =  GXZXX
               BATCH (M+ 8) =  GYZXX
               BATCH (M+ 9) =  GZZXX
               BATCH (M+10) =  GXXYX
               BATCH (M+11) =  GYXYX
               BATCH (M+12) =  GZXYX
               BATCH (M+13) =  GXYYX
               BATCH (M+14) =  GYYYX
               BATCH (M+15) =  GZYYX
               BATCH (M+16) =  GXZYX
               BATCH (M+17) =  GYZYX
               BATCH (M+18) =  GZZYX
               BATCH (M+19) =  GXXZX
               BATCH (M+20) =  GYXZX
               BATCH (M+21) =  GZXZX
               BATCH (M+22) =  GXYZX
               BATCH (M+23) =  GYYZX
               BATCH (M+24) =  GZYZX
               BATCH (M+25) =  GXZZX
               BATCH (M+26) =  GYZZX
               BATCH (M+27) =  GZZZX
               BATCH (M+28) =  GXXXY
               BATCH (M+29) =  GYXXY
               BATCH (M+30) =  GZXXY
               BATCH (M+31) =  GXYXY
               BATCH (M+32) =  GYYXY
               BATCH (M+33) =  GZYXY
               BATCH (M+34) =  GXZXY
               BATCH (M+35) =  GYZXY
               BATCH (M+36) =  GZZXY
               BATCH (M+37) =  GXXYY
               BATCH (M+38) =  GYXYY
               BATCH (M+39) =  GZXYY
               BATCH (M+40) =  GXYYY
               BATCH (M+41) =  GYYYY
               BATCH (M+42) =  GZYYY
               BATCH (M+43) =  GXZYY
               BATCH (M+44) =  GYZYY
               BATCH (M+45) =  GZZYY
               BATCH (M+46) =  GXXZY
               BATCH (M+47) =  GYXZY
               BATCH (M+48) =  GZXZY
               BATCH (M+49) =  GXYZY
               BATCH (M+50) =  GYYZY
               BATCH (M+51) =  GZYZY
               BATCH (M+52) =  GXZZY
               BATCH (M+53) =  GYZZY
               BATCH (M+54) =  GZZZY
               BATCH (M+55) =  GXXXZ
               BATCH (M+56) =  GYXXZ
               BATCH (M+57) =  GZXXZ
               BATCH (M+58) =  GXYXZ
               BATCH (M+59) =  GYYXZ
               BATCH (M+60) =  GZYXZ
               BATCH (M+61) =  GXZXZ
               BATCH (M+62) =  GYZXZ
               BATCH (M+63) =  GZZXZ
               BATCH (M+64) =  GXXYZ
               BATCH (M+65) =  GYXYZ
               BATCH (M+66) =  GZXYZ
               BATCH (M+67) =  GXYYZ
               BATCH (M+68) =  GYYYZ
               BATCH (M+69) =  GZYYZ
               BATCH (M+70) =  GXZYZ
               BATCH (M+71) =  GYZYZ
               BATCH (M+72) =  GZZYZ
               BATCH (M+73) =  GXXZZ
               BATCH (M+74) =  GYXZZ
               BATCH (M+75) =  GZXZZ
               BATCH (M+76) =  GXYZZ
               BATCH (M+77) =  GYYZZ
               BATCH (M+78) =  GZYZZ
               BATCH (M+79) =  GXZZZ
               BATCH (M+80) =  GYZZZ
               BATCH (M+81) =  GZZZZ

               M = M + 81

 5500       CONTINUE
 5000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pack_coeffs_ovl3c(alpha, ixalpha, pcoeff, ixpcoeff, 
     *                       ncfps, npfps, m, n, r,
     *                       alpha_pack, nalpha, pcoeff_pack, 
     *                       npcoeff, ccbeg, ccend, indx_cc,
     *                       ccbeg_pack, ccend_pack)
c---------------------------------------------------------------------------
c   Formats the integral exponents and contraction coefficients for use
c   in the ERD integral package.
c---------------------------------------------------------------------------
      implicit none
      include 'machine_types.h'
 
      integer ncfps(*), npfps(*), ixalpha(*), ixpcoeff(*)
      integer ccbeg(*), ccend(*), indx_cc(*)
      integer ccbeg_pack(*), ccend_pack(*)
      integer m, n, r, s
      integer nalpha, npcoeff
      integer ialpha
      integer ipcoeff
      integer quad(4)
      double precision alpha(*), pcoeff(*)
      double precision alpha_pack(*), pcoeff_pack(*)
      integer i, j, num, ishell
      integer k, l, icc

      quad(1) = m
      quad(2) = n
      quad(3) = r

      ialpha = 1
      ipcoeff = 1
      nalpha = 0
      npcoeff = 0
      do j = 1, 3
         ishell = quad(j)
         do i = 1, npfps(ishell)
            alpha_pack(ialpha+i-1) = alpha(ixalpha(ishell)+i-1)
         enddo

         ialpha = ialpha + npfps(ishell)
         nalpha = nalpha + npfps(ishell)
      enddo
  
      icc = 1
      do j = 1, 3
         ishell = quad(j)
         num    = npfps(ishell)*ncfps(ishell)
         do i = 1, num
            pcoeff_pack(ipcoeff+i-1) = pcoeff(ixpcoeff(ishell)+i-1)
         enddo

         ipcoeff = ipcoeff + num
         npcoeff = npcoeff + num
      enddo

         icc = 1
         do j = 1, 3
            ishell = quad(j)
            do k = 1, ncfps(ishell)
               ccbeg_pack(icc) = ccbeg(indx_cc(ishell)+k-1)
               ccend_pack(icc) = ccend(indx_cc(ishell)+k-1)
               icc = icc + 1
            enddo
         enddo

      return
      end  

C THIS ROUTINE RETURNS THE TOTAL SIZE OF A SYMMETRY PACKED
C DISTRIBUTION (FOR ALL IRREPS).  ITYPL IS THE SYMMETRY TYPE
C OF THE DISTRIBUTION MEMBERS, ITYPR IS THE SYMMETRY TYPE OF
C THE DISTRIBUTIONS.  NOTE THAT CHANGING THE MEANING OF THESE
C VARIABLES MAKES NO DIFFERENCE.

      INTEGER FUNCTION ISYMSZ(ITYPL,ITYPR)
      IMPLICIT INTEGER (A-Z)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
#ifdef _ASSERT
      if ((ITYPL.lt.1).or.(22.lt.ITYPL).or.
     &    (ITYPR.lt.1).or.(22.lt.ITYPR)    ) then
         print *, '@ISYMSZ: Assertion failed.'
         print *, '   ITYPL = ',ITYPL
         print *, '   ITYPR = ',ITYPR
         call errex
      end if
#endif /* _ASSERT */
      ISYMSZ = 0
      DO IRREP = 1, NIRREP
         ISYMSZ = ISYMSZ + ( IRPDPD(IRREP,ITYPL)*IRPDPD(IRREP,ITYPR) )
      END DO
      RETURN
      END

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It makes diagonal elements of 3-body terms of EOM-IP matrix  |
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|


      subroutine make_3body_diag_ip(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'trace.h'
      include 'epsilon.h'  
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer*8 indblk, get_block_index
      integer block, blkndx, seg
      integer find_current_block

      integer i, j, ii, source, target, company, comm, ierr
      integer source_type, target_type
      integer nindex_source, nindex_target, stack
      integer*8 isource, itarget
      integer n(mx_array_index),ind(mx_array_index) 
      integer sval1(mx_array_index),sval2(mx_array_index)  
      integer tval1(mx_array_index),tval2(mx_array_index)  
      integer msg(len_sip_server_message)
      integer status(MPI_STATUS_SIZE) 
      integer type(mx_array_index)
   
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif


c--------------------------------------------------------------------------
c   Locate the data for both arrays.  
c--------------------------------------------------------------------------

      target = op(c_op1_array)
      source = op(c_result_array)

c---------------------------------------------------------------------------
c   Look up source's address.
c---------------------------------------------------------------------------

      block  = find_current_block(source, array_table(1,source),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,source)
      isource = get_block_index(source, block, stack, blkndx, x, .true.) 

c---------------------------------------------------------------------------
c   Look up target's address.
c---------------------------------------------------------------------------

      block  = find_current_block(target, array_table(1,target),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,target)
      itarget = get_block_index(target, block, stack, blkndx, x, .true.) 

c--------------------------------------------------------------------------
c   Check the dimensions of both arrays both arrays.  
c--------------------------------------------------------------------------
      
      source_type = array_table(c_array_type, source)
      target_type = array_table(c_array_type, target)

      nindex_source = array_table(c_nindex, source)
      nindex_target = array_table(c_nindex, target)

c-------------------------------------------------------------------------
c   Get segment ranges of the array source.
c-------------------------------------------------------------------------

      do i = 1, nindex_source 
         ind(i) = array_table(c_index_array1+i-1,source)
         n(i)   = index_table(c_index_size, ind(i))  ! pick up length of index 
         seg    = index_table(c_current_seg,ind(i)) 
         type(i) = index_table(c_index_type,ind(i))

         call get_index_segment(ind(i), seg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, sval1(i), sval2(i))

      enddo

c-------------------------------------------------------------------------
c   Get segment ranges of the array target.
c-------------------------------------------------------------------------

      do i = 1, nindex_target 
         ind(i) = array_table(c_index_array1+i-1,target)
         n(i)   = index_table(c_index_size, ind(i))  ! pick up length of index 
         seg    = index_table(c_current_seg,ind(i)) 

         call get_index_segment(ind(i), seg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, tval1(i), tval2(i))

      enddo

      call three_body_diag(x(isource),x(itarget),
     *                      sval1(1),sval2(1),sval1(2),sval2(2),
     *                      sval1(3),sval2(3),sval1(4),sval2(4), 
     *                      tval1(1),tval2(1),tval1(2),tval2(2),
     *                      tval1(3),tval2(3),epsilon,epsilonb, 
     *                      type(1),type(2),type(3),type(4) ) 

      return
      end

c------------------------------------------------------------------------|
c------------------------------------------------------------------------|

      subroutine three_body_diag(T2,diagel,b1,b2,j1,j2,a1,a2,i1,i2,
     & k1,k2,l1,l2,c1,c2,epsilon,epsilonb,btype,jtype,atype,itype)
      implicit none  
      include 'interpreter.h' 
      include 'parallel_info.h'       


      integer a1,a2,i1,i2,b1,b2,j1,j2,k1,k2,l1,l2,c1,c2,
     & a,b,c,i,j,k,l 
      double precision T2(b1:b2,j1:j2,a1:a2,i1:i2), 
     & diagel(k1:k2,l1:l2,c1:c2) 
      double precision epsilon(*), epsilonb(*)
      integer atype, itype, btype, jtype

      double precision eps, epsa, epsb, epsi, epsj
      double precision val


c-------------Step 1 - contraction---------------------------|

        do a=a1,a2
      
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif

 
c--------------------------------------------|

         do b=b1,b2

          if (btype .eq. mobindex) then
             epsb = epsilonb(b)
          else
             epsb = epsilon(b)
          endif

c--------------------------------------------|

          do i=i1,i2

          if (itype .eq. mobindex) then
            epsi = epsilonb(i)
          else
            epsi = epsilon(i)
          endif

c--------------------------------------------|

           do j=j1,j2
     
          if (jtype .eq. mobindex) then
            epsj = epsilonb(j)
         else
            epsj = epsilon(j)
         endif

c--------------------------------------------|

        eps = epsi + epsj - epsa - epsb

        diagel(j,i,a) = diagel(j,i,a) - T2(b,j,a,i)*T2(b,j,a,i)*eps

 
           enddo
          enddo       
         enddo
        enddo   


c------------ Step 2 - diagonal elements---------------------| 

c           if(me.eq.0) then

             do j=j1,j2
             do i=i1,i2
             do a=a1,a2
c             do b=b1,b2 
c             write(6,*) diagel(j,i,a),'--->',j,i,a
c             enddo
             enddo
             enddo
             enddo 

c             write(6,*) '#########################################'

c           endif  

       return
       end  

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine removeoo_dd(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      if (dryrun) return

       call retnooodd(x,x2,bval(1),eval(1),bval(2),eval(2))

      return 
      end 

      subroutine retnooodd(array1,array2,a1,a2,b1,b2)

c---------------------------------------------------------------------------
c
c
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'

      integer i, a, b, c, d, a1, a2, b1, b2, c1, c2, d1, d2
      double precision array1(a1:a2,b1:b2)
      double precision array2(a1:a2,b1:b2)
      integer nzero, zero(100), index1, index2, index3, index4
      integer nszero, ndzero, szero(100), dzero(100)
      common /SINDEX/index1, index2, index3, index4
c
c     Determine range of doubly occupied indices to be removed.
c     ---------------------------------------------------------

      b      = 0
      ndzero = 0
      if (nalpha_occupied .gt. nbeta_occupied) then
         do a = 1, nbeta_occupied
            ndzero = ndzero + 1
            b = b + 1
            dzero(b) = a
         enddo
      endif
      if (nbeta_occupied .gt. nalpha_occupied) then
         do a = 1, nalpha_occupied
            ndzero = ndzero + 1
            b = b + 1
            dzero(b) = a
         enddo
      endif
c
c     Initialize output array to input array.
c     ---------------------------------------

      do a = a1, a2
      do b = b1, b2

         array2(a,b) = array1(a,b)

      enddo ! b
      enddo ! a
c
c     Reduce first index.
c     -------------------

      do i = 1,  ndzero
      do a = a1, a2
         if (dzero(i) .eq. a) then
         do b = b1, b2

            array2(a,b) = 0.0

         enddo ! b
         endif
      enddo ! a
      enddo ! i

100   continue
c
      return
      end

      subroutine Read_IRCnmlist(Stride, Trans_state, Direction, 
     &                          Max_IRC_Step)
C
      Implicit Double Precision (a-h,o-z)
C
      Logical Printdef, Trans_state, Forward
      Character*80  Direction 

c Call to nl_init find the *IRC namelist if it is in the ZMAT

      printdef = .True.
      call nl_init('IRC', ierr, printdef)

C Step size control the size of the individual steps.

      call nl_real('STEP_SIZE', 0.3D0, Stride)

c Starting point for the IRC search, it can be from the
C saddle point or any other point on the IRC. The saddle
C point (the default) is preferred. 

      call nl_log('SADDLE', .TRUE., Trans_state)

C The direction of the search, Forward=.true. towards products
C and false the opposite. 
 
      call nl_str('IRC_SEARCH', "FORWARD", Direction)

C The number of steps for the entire IRC search
  
      call nl_int("MAX_IRC_STEPS", 20, Max_IRC_Step)
C
      call nl_term

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__HANDLE_MATRIX_SECTIONS
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDROWY,DDCOLY,
     +                      DDTSEC,DDNSEC,
     +                      NSEC,
     +                      SECIDX,SECDIM,SECOFF,
     +                      EXTRACT,
     +                      LTRG,
     +                      X,
     +
     +                              M,
     +                              Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__HANDLE_MATRIX_SECTIONS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : Given a square matrix X divided into sections, the
C                routine extracts or replaces the submatrix Y of
C                sections specified. The sections can be of different
C                lengths but must have the same decomposition along
C                the rows as well the columns of matrix X.
C
C                The following example (this one extracts/replaces
C                a lower triangle from/to X) makes this clear:
C
C
C                If X is:
C
C
C                               A       B       C      D    E
C             offset A ->   -----------------------------------
C                          |*        |     |         |   |     |
C                          |* *      |     |         |   |     |
C                        A |* * *    |     |         |   |     |
C                          |* * * *  |     |         |   |     |
C                          |* * * * *|     |         |   |     |
C             offset B ->   -----------------------------------
C                          |* * * * *|*    |         |   |     |
C                        B |* * * * *|* *  |         |   |     |
C                          |* * * * *|* * *|         |   |     |
C             offset C ->   -----------------------------------
C                          |         |     |         |   |     |
C                          |         |     |         |   |     |
C                        C |         |     |         |   |     |
C                          |         |     |         |   |     |
C                          |         |     |         |   |     |
C             offset D ->   -----------------------------------
C                          |* * * * *|* * *|         |*  |     |
C                        D |* * * * *|* * *|         |* *|     |
C             offset E ->   -----------------------------------
C                          |         |     |         |   |     |
C                        E |         |     |         |   |     |
C                          |         |     |         |   |     |
C                           -----------------------------------
C
C
C
C                then, if the above marked sections A,B and D are
C                extracted from the X matrix, Y is:
C
C
C                                A       B    D
C                            -------------------
C                           |*        |     |   |
C                           |* *      |     |   |
C                         A |* * *    |     |   |
C                           |* * * *  |     |   |
C                           |* * * * *|     |   |
C                            -------------------
C                           |* * * * *|*    |   |
C                         B |* * * * *|* *  |   |
C                           |* * * * *|* * *|   |
C                            -------------------
C                           |* * * * *|* * *|*  |
C                         D |* * * * *|* * *|* *|
C                            -------------------
C
C
C                and if Y is to be replaced into X, then the sections
C                of Y go into the above marked sections A,B and D of X.
C
C
C                Each section is characterized by two numbers:
C
C                     i) offset position inside the X matrix.
C                        This is the first index - 1 of where
C                        the section starts (see above picture
C                        of X). 
C
C                    ii) the # of rows/columns the section is
C                        made of.
C
C
C                  Input:
C
C                    DDROWz,DDCOLz  =  row and column dimensions for
C                                      matrices z=X,Y
C                    DDTSEC         =  dimension for total # of
C                                      sections
C                    DDNSEC         =  dimension for chosen # of
C                                      sections to be extracted or
C                                      replaced
C                    NSEC           =  # of sections to be extracted
C                                      from matrix X
C                    SECIDX         =  section labels indicating
C                                      which sections are going to
C                                      be extracted
C                    SECDIM         =  # of elements in each section
C                    SECOFF         =  offset index in matrix X for
C                                      each section
C                    EXTRACT        =  is true, if an extraction is
C                                      wanted, false if a replacement
C                                      is to be performed
C                    LTRG           =  is true, if only lower triangle
C                                      of X is to be extracted and
C                                      placed in lower triangle of Y
C                    X (if extract) =  matrix X from which the sections
C                                      are going to be extracted in
C                                      case of an extraction
C                    Y (if replace) =  matrix Y which is to be replaced
C
C
C                  Output:
C
C                    M (if extract) =  dimension of M x M extraction
C                                      matrix Y
C                    Y (if extract) =  extracted matrix Y
C                    X (if replace) =  replaced matrix X
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     EXTRACT
         LOGICAL     LTRG

         INTEGER     DDROWX,DDCOLX,DDROWY,DDCOLY
         INTEGER     DDNSEC,DDTSEC
         INTEGER     DIM
         INTEGER     I,J,K,L,M,N
         INTEGER     IDX,IXI,IXJ
         INTEGER     NCOL,NROW
         INTEGER     NSEC
         INTEGER     OLDOFF,NEWOFF
         INTEGER     XCOFF,YCOFF,XROFF,YROFF
         INTEGER     XCOL,YCOL

         INTEGER     SECDIM (1:DDTSEC)
         INTEGER     SECIDX (1:DDNSEC)
         INTEGER     SECOFF (1:DDTSEC)

         DOUBLE PRECISION  X (1:DDROWX,1:DDCOLX)
         DOUBLE PRECISION  Y (1:DDROWY,1:DDCOLY)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine any inconsistencies in the sections
C                provided and check dimensions of X and Y matrices
C                supplied.
C
C
         IF (NSEC.GT.DDNSEC) THEN
             WRITE (*,*) ' Dimensions for chosen # of sects too small! '
             WRITE (*,*) ' nlo__handle_matrix_sections '
             WRITE (*,*) ' DDNSEC,NSEC = ',DDNSEC,NSEC
             WRITE (1,*) ' Dimensions for chosen # of sects too small! '
             WRITE (1,*) ' nlo__handle_matrix_sections '
             WRITE (1,*) ' DDNSEC,NSEC = ',DDNSEC,NSEC
             STOP
         END IF

         M = 0
         N = 0
         OLDOFF = 0
         DO 10 I = 1,NSEC
            IDX = SECIDX (I)
            DIM = SECDIM (IDX)
            M = M + DIM
            NEWOFF = SECOFF (IDX)
            IF (NEWOFF .LT. OLDOFF) THEN
                WRITE (*,*) ' Overlapping sections for extraction! '
                WRITE (*,*) ' Occuring at section # ',I
                WRITE (*,*) ' nlo__handle_matrix_sections '
                WRITE (1,*) ' Overlapping sections for extraction! '
                WRITE (1,*) ' Occuring at section # ',I
                WRITE (1,*) ' nlo__handle_matrix_sections '
                STOP
            END IF
            OLDOFF = NEWOFF + DIM
            N = MAX0 (N,OLDOFF)
   10    CONTINUE

         IF (N.GT.DDROWX .OR. N.GT.DDCOLX) THEN
             WRITE (*,*) ' Dimensions of matrix X too small! '
             WRITE (*,*) ' nlo__handle_matrix_sections '
             WRITE (*,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
             WRITE (1,*) ' Dimensions of matrix X too small! '
             WRITE (1,*) ' nlo__handle_matrix_sections '
             WRITE (1,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
             STOP
         END IF

         IF (M.GT.DDROWY .OR. M.GT.DDCOLY) THEN
             WRITE (*,*) ' Dimensions of matrix Y too small! '
             WRITE (*,*) ' nlo__handle_matrix_sections '
             WRITE (*,*) ' DDROWY,DDCOLY,M = ',DDROWY,DDCOLY,M
             WRITE (1,*) ' Dimensions of matrix Y too small! '
             WRITE (1,*) ' nlo__handle_matrix_sections '
             WRITE (1,*) ' DDROWY,DDCOLY,M = ',DDROWY,DDCOLY,M
             STOP
         END IF
C
C
C             ...decide on extraction or replacement.
C                Outer loops will run over column sections and
C                elements, inner loops over row sections and
C                elements.
C
C
         IF (EXTRACT) THEN
C
C
C             ...lower triangular extraction.
C
C
             IF (LTRG) THEN

                 YCOFF = 0
                 DO 100 J = 1,NSEC
                    IXJ = SECIDX (J)
                    NCOL = SECDIM (IXJ)
                    XCOFF = SECOFF (IXJ)
                    DO 110 L = 1,NCOL
                       XCOL = XCOFF + L
                       YCOL = YCOFF + L

                       DO 120 K = L,NCOL
                          Y (YCOFF+K,YCOL) = X (XCOFF+K,XCOL)
  120                  CONTINUE

                       YROFF = YCOFF + NCOL
                       DO 130 I = J+1,NSEC
                          IXI = SECIDX (I)
                          NROW = SECDIM (IXI)
                          XROFF = SECOFF (IXI)
                          DO 140 K = 1,NROW
                             Y (YROFF+K,YCOL) = X (XROFF+K,XCOL)
  140                     CONTINUE
                          YROFF = YROFF + NROW
  130                  CONTINUE

  110               CONTINUE
                    YCOFF = YCOFF + NCOL
  100            CONTINUE

             ELSE
C
C
C             ...full matrix extraction.
C
C
                 YCOFF = 0
                 DO 200 J = 1,NSEC
                    IXJ = SECIDX (J)
                    NCOL = SECDIM (IXJ)
                    XCOFF = SECOFF (IXJ)
                    DO 210 L = 1,NCOL
                       XCOL = XCOFF + L
                       YCOL = YCOFF + L

                       YROFF = 0
                       DO 220 I = 1,NSEC
                          IXI = SECIDX (I)
                          NROW = SECDIM (IXI)
                          XROFF = SECOFF (IXI)
                          DO 230 K = 1,NROW
                             Y (YROFF+K,YCOL) = X (XROFF+K,XCOL)
  230                     CONTINUE
                          YROFF = YROFF + NROW
  220                  CONTINUE

  210               CONTINUE
                    YCOFF = YCOFF + NCOL
  200            CONTINUE

             END IF

         ELSE
C
C
C             ...lower triangular replacement.
C
C
             IF (LTRG) THEN

                 YCOFF = 0
                 DO 300 J = 1,NSEC
                    IXJ = SECIDX (J)
                    NCOL = SECDIM (IXJ)
                    XCOFF = SECOFF (IXJ)
                    DO 310 L = 1,NCOL
                       XCOL = XCOFF + L
                       YCOL = YCOFF + L

                       DO 320 K = L,NCOL
                          X (XCOFF+K,XCOL) = Y (YCOFF+K,YCOL)
  320                  CONTINUE

                       YROFF = YCOFF + NCOL
                       DO 330 I = J+1,NSEC
                          IXI = SECIDX (I)
                          NROW = SECDIM (IXI)
                          XROFF = SECOFF (IXI)
                          DO 340 K = 1,NROW
                             X (XROFF+K,XCOL) = Y (YROFF+K,YCOL)
  340                     CONTINUE
                          YROFF = YROFF + NROW
  330                  CONTINUE

  310               CONTINUE
                    YCOFF = YCOFF + NCOL
  300            CONTINUE

             ELSE
C
C
C             ...full matrix replacement.
C
C
                 YCOFF = 0
                 DO 400 J = 1,NSEC
                    IXJ = SECIDX (J)
                    NCOL = SECDIM (IXJ)
                    XCOFF = SECOFF (IXJ)
                    DO 410 L = 1,NCOL
                       XCOL = XCOFF + L
                       YCOL = YCOFF + L

                       YROFF = 0
                       DO 420 I = 1,NSEC
                          IXI = SECIDX (I)
                          NROW = SECDIM (IXI)
                          XROFF = SECOFF (IXI)
                          DO 430 K = 1,NROW
                             X (XROFF+K,XCOL) = Y (YROFF+K,YCOL)
  430                     CONTINUE
                          YROFF = YROFF + NROW
  420                  CONTINUE

  410               CONTINUE
                    YCOFF = YCOFF + NCOL
  400            CONTINUE

             END IF
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine rd_intcoord(RINT)
      implicit none

      DOUBLE PRECISION DACOS, RINT
      INTRINSIC DACOS
      INTEGER LINBLNK
      EXTERNAL LINBLNK

c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c     Maximum string length of terminal lines
      INTEGER LINELEN
      PARAMETER (LINELEN=80)
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      DOUBLE PRECISION dSmallNumber
      DIMENSION RINT(3*MXATMS)
      PARAMETER (dSmallNumber=5.361d-21)

      INTEGER        NX,NXM6,IARCH,NCYCLE,NUNIQUE,NOPT
      COMMON /USINT/ NX,NXM6,IARCH,NCYCLE,NUNIQUE,NOPT

      INTEGER        IFLAGS(100),IFLAGS2(500)
      COMMON /FLAGS/ IFLAGS,IFLAGS2

      DOUBLE PRECISION RTOA, dTmp
      INTEGER I, J, IBOMB, ISTP
      CHARACTER*(linelen) DUMSTR
      CHARACTER*5 CHTEST
      CHARACTER*1 czTab
      LOGICAL PRINTI

c ----------------------------------------------------------------------

C NEW (5/89) VARIABLE INPUT. NO LONGER HAVE TO INCLUDE REDUNDANCIES, AN
C UNIQUE COORDINATES CAN BE READ IN ANY ORDER. VARIABLE NAMES AND VAL
C ARE SEPARATED BY AN EQUALS (=) SIGN. MUCH BETTER THAN THE WAY IT WA
C DONE BEFORE. START BY FILLING R VECTOR WITH BOGUS VALUES.

      IF (IFLAGS(68).EQ.2) THEN

c Ajith Perera 12/2001.
C This block corresponds to the COORINATES=XYZ2INT option. To
C understand what this means, one needs to know the difference
C between COORDINATES=CARTESIAN and COORDINATES=XYZINT. In the first
C case, our input is the atomic symbol followed by the Cartesian
C coordinates of the each atom. There is no information about
C the internal coordinates. In the latter case, as one would
C have done for entering internal coordinates, one would enter
C the connectivity data in ZMAT format followed by (one blank
C in between) the Cartesian coordinates of the each atom in free
C format form.
C At present, this option does not understand the symmetry unless
C the user imposes it by ZMAT input. The advantage of having
C this capability is that one can use the Cartesian coordinates
C directly without first converting them to internal.
C In the future, we plan to extend this to include symmetry
C without user specfications. That way one can do optimiations
C with Cartesian input.
C
C Originaly, we had a routine called XTOR2.F which was pretty
C much doing what XTOR.F was doing except for the conversion of
C angles to radians. I obsoleted the XTOR2.F and extended the
C XTOR.F. The IPRT flag (don't know why it was named that)
C controls whether the conversion is needed (IPRT==1) or not
C (IPRT!=1).
         WRITE(LUOUT,*) '@RD_INTCOORD: Input coordinates are ',
     &      'transformed to internal representation.'
         READ(LUZ,*) (Q(I),I=1,NX)
         CALL XTOR(R,1)

      ELSE

         CALL GETREC(1,'JOBARC','FIRSTRUN',1,I)
         PRINTI = (I.NE.0)
         czTab  = achar(9)
         RTOA   = 180.D0/DACOS(-1.D0)
         IBOMB  = 0
         DO I = 1, NX
            R(I) = dSmallNumber
         END DO

         READ(LUZ,'(A)',END=987) DUMSTR
         do while (linblnk(dumstr(1:80)).ne.0)
            ISTP = INDEX(DUMSTR(1:),'=')
            I    = INDEX(DUMSTR(1:),'*')
            if ((i.ne.0).or.(istp.eq.0)) then
               write(*,*) '@RD_INTCOORD: Coordinate list is not ',
     &                    'terminated with a blank line.'
               call errex
            end if
            i = 1
            do while ((i.lt.istp).and.
     &                (dumstr(i:i).eq.' '.or.dumstr(i:i).eq.czTab))
               i = i + 1
            end do
            if (i.eq.istp) then
               write(*,*) '@RD_INTCOORD: Coordinate name is missing.'
               call errex
            end if
            j = i + 1
            do while ((j.lt.istp).and.
     &                (dumstr(j:j).ne.' '.and.dumstr(j:j).ne.czTab))
               j = j + 1
            end do
            CHTEST = DUMSTR(I:J-1)
            READ(DUMSTR(ISTP+1:),*) dTmp
            ISTP = 0
            I = 1
            do while (ISTP.eq.0.and.I.le.NXM6)
               IF (CHTEST.EQ.VARNAM(ISQUASH(I))) THEN
                  ISTP = 1
                  IF (RINT(I).NE.dSmallNumber) THEN
                     IBOMB = 1
                     WRITE(*,*) '@RD_INTCOORD: ',CHTEST,
     &                          ' multiply defined.'
                  ELSE IF (VARNAM(ISQUASH(I)).EQ.'TDA  ') THEN
                     RINT(I) = RTOA*DACOS(-1.0D0/3.0D0)
                     IF (PRINTI) WRITE(LUOUT,*)
     & '@RD_INTCOORD: Variable TDA set to exact tetrahedral angle.'
                  ELSE IF (VARNAM(ISQUASH(I)).EQ.'IHA  ') THEN
                     RINT(I) = RTOA*DACOS(1.D0/DSQRT(5.D0))
                     IF (PRINTI) WRITE(LUOUT,*)
     & '@RD_INTCOORD: Variable IHA set to exact icosahedral angle.'
                  ELSE IF (VARNAM(ISQUASH(I)).EQ.'OA   ') THEN
                     RINT(I) = RTOA*DACOS(-1.D0/3.D0)*0.5D0
                     IF (PRINTI) WRITE(LUOUT,*)
     & '@RD_INTCOORD: Variable OA set to 0.5 * exact tetrahedral angle.'
                  ELSE
                     R(I) = dTmp
                  END IF
               END IF
               I = I + 1
c           end do while (ISTP.eq.0.and.I.le.NXM6)
            end do
            IF (ISTP.EQ.0) THEN
               IBOMB = 1
               WRITE(*,*) '@RD_INTCOORD: ',CHTEST,' not in Z-matrix.'
            END IF
            READ(LUZ,'(A)',END=987) DUMSTR
c        end do while (linblnk(dumstr(1:80)).ne.0)
         end do
  987    CONTINUE

c      o copy unique coordinate definitions
         DO I = 1, NUNIQUE
            DO J = 1, NEQ(IUNIQUE(I))
               RINT(IEQUIV(I,J)) = RINT(IUNIQUE(I))
            END DO
         END DO

c      o check if all coordinates have been defined
         DO I = 1, NXM6
            IF (RINT(I).EQ.dSmallNumber) THEN
               IBOMB = 1
               WRITE(*,*)
     &               '@RD_INTCOORD: ',VARNAM(ISQUASH(I)),' is not ',
     &               'defined at ',ISQUASH(I)
            END IF
         END DO

c      o stop on all errors
         IF (IBOMB.EQ.1) CALL ERREX

      END IF

c   o unsquash R
      CALL USQUSH(R,NXM6)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE DCHECK(RREF,RVEC,ISIZE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RVEC(ISIZE),RREF(ISIZE)
      PI=DACOS(-1.D0)
      DO 55 I=6,ISIZE,3
       IF(DABS(RVEC(I)).GT.3.D0)THEN
        IF(SIGN(1.D0,RVEC(I)).NE.SIGN(1.D0,RREF(I)))
     &  RVEC(I)=SIGN(1.D0,RREF(I))*(2.D0*PI-DABS(RVEC(I)))
       ENDIF
 55   CONTINUE
      RETURN
      END

         SUBROUTINE  ERD__K12_INT2D_TO_E0CD
     +
     +                    ( SHELLA,SHELLP,SHELLC,SHELLD,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZET,NXYZP,NXYZC,NXYZD,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_INT2D_TO_E0CD
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative eris [E0|CD] , E = A to P, adding up the
C                contributions from all the 2D PCD derivative integrals.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                2DX and 2DY integrals, which can be achieved by having
C                the outer loops run over all possible x and y monomial
C                parts and the inner loops over all allowed E shell
C                combinations. The price to pay for such loop ordering
C                is the scattered addressing of locations within the
C                batch array, which has its rows and columns ordered
C                such that the E shells are increasing and within each
C                E shell the monomials are ordered such that x>y>z in
C                exponents.
C
C                An example follows:
C                -------------------
C
C                Let E = 0,2 and C = 0 and D = 1. Then we have the left
C                and right hand of the batch array ordered as follows:
C
C                          left xyz              right xyz
C
C                             000               000     100
C                             ---                       010
C                             100                       001
C                             010
C                             001
C                             ---
C                             200 -> -5
C                             110
C                             101 -> -3
C                             020
C                             011
C                             002 -> 0
C                        
C                The batch would thus have dimensions 10 x 1 x 3.
C                For the left side the reduced multiplication scheme
C                would have its outermost loop run over x=0,2, followed
C                by the next loop y=0,2-x. The innermost loop would then
C                run over the allowed shells E=E(max),max(E(min),x+y).
C                In this case all x,y-triples can be reused for all
C                appropriate shell combinations.
C
C                To find the address of a specific x,y,z,E combination
C                inside the batch array, we first note that the z-part
C                is dependent on the x,y-parts and is hence not needed.
C                Lets look at the E-part first. The E-part is evaluated
C                from its dimension formula (E+1)*(E+2)/2. Organizing
C                the inner E-loop to run from E(max) always, the
C                dimension for E(max) is passed as the argument NXYZP
C                and all lower E dimensions are calculated by the
C                formula relating dimensions between E and E+1:
C
C                           dim(E+1) = dim(E) + E + 2
C
C                In this way multiplications in the E-part can be
C                entirely avoided. The x,y-part is defined as the
C                part which has to be subtracted from dim(E) to
C                reach the xyz monomial position inside the E shell.
C                It can be divided into an x-part and a y-part. The
C                x-part is given by the fomula:
C
C                          x-part = - x*E + x(x-3)/2
C
C                and for the example above has been given for E=2
C                and marked with arrows ->. The last term of the x-part
C                involves 1 multiplication and division, however it
C                can be changed to:
C
C                                               x-1
C                          x-part = - x*E - x + sum i
C                                               i=0
C
C                and clever additions inside the x-loop avoid the use
C                of multiplications and divisions. The y-part is trivial
C                and is simply equal to -y. The overall conclusion is
C                thus that the location of a specific x,y,z,E quadruple
C                inside the batch comes at the cost of one x*E(max)
C                multiplication in the outermost x-loops, since the
C                other x*E ones can again be reached via stepwise
C                subtraction of x from x*E(max).
C
C                Due to the very computational intensive steps inside
C                the x,y,z,E loops, special sections of identical
C                x,y,z,E loop structures have been given for each
C                # of roots =< 9, thus saving considerable computing
C                time over the general case.
C
C                For comments on how the x,y,z,E loop structures are
C                coded please refer to the general root case.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A,C,D and csh sum P=A+B
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZET      =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B
C                    NXYZy       =  # of cartesian monomials for
C                                   y = P,C,D shells
C                    INT2Dx      =  all current 2D PCD derivative
C                                   integrals for each cartesian
C                                   component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D PCD derivative integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [E0|CD] derivative integrals
C                                   corresponding to all current
C                                   exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,J,K,M,N,R
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZE,NXYZET,NXYZP,NXYZC,NXYZD
         INTEGER     SE
         INTEGER     SEEND
         INTEGER     SHELLA,SHELLP,SHELLC,SHELLD
         INTEGER     XC,YC,ZC,XD,YD,ZD
         INTEGER     XCP,XDP
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX
         INTEGER     XEP,XYEP
         INTEGER     XYE
         INTEGER     YCMAX,YDMAX
         INTEGER     YEEND

         DOUBLE PRECISION  SUM,QQQ
         DOUBLE PRECISION  ZERO,STGEXP

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ),RTS(1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ),UVAL(1:NEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ,1:NXYZET,1:NXYZC,1:NXYZD)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP,0:SHELLC,0:SHELLD)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP,0:SHELLC,0:SHELLD)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP,0:SHELLC,0:SHELLD)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XDP = 0
         DO 100 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 102 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 104 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 110 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 112 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 114 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO M = 1,NEXQ
                                  TEMP2 (M) = TEMP1 (M)
                               END DO
                           ELSE
                               DO M = 1,NEXQ
                                  TEMP2 (M) = TEMP1 (M)
     +                                      * INT2DY (M,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 120 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = TEMP2 (M)*
     &                               (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
                                  END DO
                              ELSE
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) =
     +                                            TEMP2 (M)
     +                                          * INT2DZ (M,ZE,ZC,ZD)*
     +                               (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  120                      CONTINUE
  114                   CONTINUE
  112                CONTINUE
  110             CONTINUE
  104          CONTINUE
               XCP = J
  102       CONTINUE
            XDP = K
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XDP = 0
         DO 200 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 202 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 204 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 210 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 212 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 214 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 220 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                             BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                     + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                         )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 2
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                                          + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 2
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  220                      CONTINUE
  214                   CONTINUE
  212                CONTINUE
  210             CONTINUE
  204          CONTINUE
               XCP = J
  202       CONTINUE
            XDP = K
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XDP = 0
         DO 300 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 302 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 304 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 310 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 312 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 314 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 320 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                   + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                   + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                       )*(2.d0*UVAL(M)/STGEXP)    
                                     R = R + 3
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 3
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  320                      CONTINUE
  314                   CONTINUE
  312                CONTINUE
  310             CONTINUE
  304          CONTINUE
               XCP = J
  302       CONTINUE
            XDP = K
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XDP = 0
         DO 400 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 402 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 404 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 410 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 412 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 414 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 420 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = (  TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 4
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                           + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZE,ZC,ZD)*(1.d0-RTS(R+3))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 4
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  420                      CONTINUE
  414                   CONTINUE
  412                CONTINUE
  410             CONTINUE
  404          CONTINUE
               XCP = J
  402       CONTINUE
            XDP = K
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XDP = 0
         DO 500 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 502 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 504 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 510 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 512 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 514 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 520 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                       )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 5
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                           + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZE,ZC,ZD)*(1.d0-RTS(R+3))
     +                           + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZE,ZC,ZD)*(1.d0-RTS(R+4))
     +                                         )*(2.d0*UVAL(M)/STGEXP) 
                                     R = R + 5
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  520                      CONTINUE
  514                   CONTINUE
  512                CONTINUE
  510             CONTINUE
  504          CONTINUE
               XCP = J
  502       CONTINUE
            XDP = K
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XDP = 0
         DO 600 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 602 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 604 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 610 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 612 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 614 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 620 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                       )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 6
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                           + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZE,ZC,ZD)*(1.d0-RTS(R+3))
     +                           + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZE,ZC,ZD)*(1.d0-RTS(R+4))
     +                           + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZE,ZC,ZD)*(1.d0-RTS(R+5))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 6
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  620                      CONTINUE
  614                   CONTINUE
  612                CONTINUE
  610             CONTINUE
  604          CONTINUE
               XCP = J
  602       CONTINUE
            XDP = K
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XDP = 0
         DO 700 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 702 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 704 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 710 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 712 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 714 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 720 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                    + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                       )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 7
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                           + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZE,ZC,ZD)*(1.d0-RTS(R+3))
     +                           + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZE,ZC,ZD)*(1.d0-RTS(R+4))
     +                           + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZE,ZC,ZD)*(1.d0-RTS(R+5))
     +                           + TEMP2 (R+6)
     +                           * INT2DZ (R+6,ZE,ZC,ZD)*(1.d0-RTS(R+6))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 7
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  720                      CONTINUE
  714                   CONTINUE
  712                CONTINUE
  710             CONTINUE
  704          CONTINUE
               XCP = J
  702       CONTINUE
            XDP = K
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XDP = 0
         DO 800 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 802 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 804 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 810 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 812 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 814 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 820 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                    + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                    + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                                       )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 8
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                           + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZE,ZC,ZD)*(1.d0-RTS(R+3))
     +                           + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZE,ZC,ZD)*(1.d0-RTS(R+4))
     +                           + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZE,ZC,ZD)*(1.d0-RTS(R+5))
     +                           + TEMP2 (R+6)
     +                           * INT2DZ (R+6,ZE,ZC,ZD)*(1.d0-RTS(R+6))
     +                           + TEMP2 (R+7)
     +                           * INT2DZ (R+7,ZE,ZC,ZD)*(1.d0-RTS(R+7))
     +                                        )*(2.d0*UVAL(M)/STGEXP)   
                                     R = R + 8
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  820                      CONTINUE
  814                   CONTINUE
  812                CONTINUE
  810             CONTINUE
  804          CONTINUE
               XCP = J
  802       CONTINUE
            XDP = K
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XDP = 0
         DO 900 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 902 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 904 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO

                  K = XDP
                  DO 910 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 912 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 914 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF

                           I = XYEP
                           NXYZE = NXYZP
                           DO 920 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 1
                                  DO M = 1,NEXQ
                           BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                    + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                    + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                                    + TEMP2 (R+8)*(1.d0-RTS(R+8))
     +                                       )*(2.d0*UVAL(M)/STGEXP)  
                                     R = R + 9
                                  END DO
                              ELSE
                                  R = 1
                                  DO M = 1,NEXQ
                                     BATCH (M,I,J,K) = (
     +                                            TEMP2 (R)
     +                           * INT2DZ (R,ZE,ZC,ZD)*(1.d0-RTS(R))
     +                           + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZE,ZC,ZD)*(1.d0-RTS(R+1))
     +                           + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZE,ZC,ZD)*(1.d0-RTS(R+2))
     +                           + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZE,ZC,ZD)*(1.d0-RTS(R+3))
     +                           + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZE,ZC,ZD)*(1.d0-RTS(R+4))
     +                           + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZE,ZC,ZD)*(1.d0-RTS(R+5))
     +                           + TEMP2 (R+6)
     +                           * INT2DZ (R+6,ZE,ZC,ZD)*(1.d0-RTS(R+6))
     +                           + TEMP2 (R+7)
     +                           * INT2DZ (R+7,ZE,ZC,ZD)*(1.d0-RTS(R+7))
     +                           + TEMP2 (R+8)
     +                           * INT2DZ (R+8,ZE,ZC,ZD)*(1.d0-RTS(R+8))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                                     R = R + 9
                                  END DO
                              END IF

                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
  920                      CONTINUE
  914                   CONTINUE
  912                CONTINUE
  910             CONTINUE
  904          CONTINUE
               XCP = J
  902       CONTINUE
            XDP = K
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x,x-triples. No skipping of the
C                x,x,x-contribution of 0,0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XDP = 0
         DO 1000 XD = SHELLD,0,-1
            YDMAX = SHELLD - XD
            XCP = 0
            DO 1002 XC = SHELLC,0,-1
               YCMAX = SHELLC - XC

               XEP = NXYZET + 3
               DO 1004 XE = 0,SHELLP
                  XEP = XEP + XE - 2
                  XEMAX = XE * SHELLP
                  YEEND = SHELLP - XE

                  DO M = 1,NGQEXQ
                     TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XC,XD)
                  END DO
C
C
C             ...middle loops over y,y,y-triples. Skip multiplication
C                of y,y,y-contributions, if no y-coordinate derivative
C                was formed and we have a 0,0,0-triple, as then the 2DY
C                PCD integrals are equal to 1.
C
C
                  K = XDP
                  DO 1010 YD = YDMAX,0,-1
                     K = K + 1
                     ZD = YDMAX - YD
                     J = XCP
                     DO 1012 YC = YCMAX,0,-1
                        J = J + 1
                        ZC = YCMAX - YC

                        XYEP = XEP - XEMAX
                        DO 1014 YE = 0,YEEND
                           XYE = XE + YE
                           XYEP = XYEP - 1
                           SEEND = MAX0 (SHELLA,XYE)

                           IF (.NOT.DIFFY .AND. YE+YC+YD.EQ.0) THEN
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
                               END DO
                           ELSE
                               DO N = 1,NGQEXQ
                                  TEMP2 (N) = TEMP1 (N)
     +                                      * INT2DY (N,YE,YC,YD)
                               END DO
                           END IF
C
C
C             ...inner loop over E shells. Skip multiplication of
C                z,z,z-contributions, if we have a 0,0,0-triple and
C                no derivations were performed on the z-coordinate,
C                as then the 2DZ PCD integrals are equal to 1.
C                All info concerning all three x,x,x-, y,y,y- and
C                z,z,z-triples have been collected for all exponent
C                quadruplets at once. Sum up the 2D X,Y,Z integral
C                products to the appropriate place of the [E0|CD]
C                batch.
C
C
                           I = XYEP
                           NXYZE = NXYZP
                           DO 1020 SE = SHELLP,SEEND,-1
                              ZE = SE - XYE

                              IF (.NOT.DIFFZ .AND. ZE+ZC+ZD.EQ.0) THEN
                                  R = 0
                                  DO M = 1,NEXQ
                                     SUM = ZERO
                                     DO N = 1,NGQP
                               QQQ = TEMP2 (R+N)*(1.d0-RTS(R+N))
                                        SUM = SUM + QQQ
                                     END DO
                                     R = R + NGQP
                             BATCH (M,I,J,K) = SUM*(2.d0*UVAL(M)/STGEXP)
                                  END DO
                              ELSE
                                  R = 0
                                  DO M = 1,NEXQ
                                     SUM = ZERO
                                     DO N = 1,NGQP
        QQQ = TEMP2 (R+N)* INT2DZ (R+N,ZE,ZC,ZD) * (1.d0-RTS(R+N))  
                                        SUM = SUM + QQQ
                                     END DO
                                     R = R + NGQP
                             BATCH (M,I,J,K) = SUM*(2.d0*UVAL(M)/STGEXP)
                                  END DO
                              END IF
C
C
C             ...next z,z,z-triple.
C
C
                              I = I - NXYZE + XE
                              NXYZE = NXYZE - SE - 1
 1020                      CONTINUE
C
C
C             ...next y,y,y-triple and next x,x,x-triple.
C
C
 1014                   CONTINUE
 1012                CONTINUE
 1010             CONTINUE

 1004          CONTINUE
               XCP = J
 1002       CONTINUE
            XDP = K
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine find_jobflow(calc,dropmo,ref,geom_opt,
     *                                       vib, excite, instab, props,
     *                                       grad_calc, density, 
     *                                       dip_calc, dea_calc, 
     *                                       jobflow)
c-------------------------------------------------------------------------
c   Writes the SIAL_PROGRAM parameters for a default set of SIAL programs
c   determined by the parameters calc, dropmo, ref, geom_opt, and vib.
c   The SIAL_PROGRAM parameters are written to ZMAT.AUTO.
c-------------------------------------------------------------------------
      implicit none
      integer calc,dropmo,ref,geom_opt, vib, excite, instab, props,
     &        density, dip_calc, dea_calc, dip_singlet_root,
     &        dip_triplet_root, dea_singlet_root, dea_triplet_root

      integer grad_calc 
      character*80 jobflow
      integer ierr
      integer n, str_trimlen

c---------------------------------------------------------------------------
c   Determine the jobflow required for the combination of parameters.
c---------------------------------------------------------------------------

c      print *,'ref, calc, dropmo, geom_opt, vib ',
c     *   ref, calc, dropmo, geom_opt, vib, excite
      jobflow = 'UNDEFINED'

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'SCF_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'SCF_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'SCF_RHF_GRADIENT'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'SCF_UHF_GRADIENT'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'SCF_RHF_HESSIAN'     ! analytical hessian calc
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 3) then
         if (grad_calc .eq. 2) then
            jobflow = 'SCF_RHF_ENERGY'    ! numerical gradient calc
         else
            jobflow = 'SCF_RHF_GRADIENT'    ! numerical hessian calc
         endif 
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'SCF_UHF_HESSIAN'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'SCF_UHF_ENERGY'
         else
            jobflow = 'SCF_UHF_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'MP2_RHF_HESSIAN'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'MP2_RHF_ENERGY'
         else
            jobflow = 'MP2_RHF_GRADIENT'
         endif
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'MP2_UHF_HESSIAN'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'MP2_UHF_ENERGY'
         else
            jobflow = 'MP2_UHF_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'MP2_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'MP2_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'MP2_RHF_GRADIENT'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'MP2_UHF_GRADIENT'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_RHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_UHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'LCCSD_RHF_ENERGY'
         else
            jobflow = 'LCCSD_RHF_GRADIENT'
         endif
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'LCCSD_UHF_ENERGY'
         else 
            jobflow = 'LCCSD_UHF_GRADIENT'
         endif  
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         jobflow = 'LCCSD_RHF_DROPMO_GRADIENT'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         jobflow = 'LCCSD_UHF_DROPMO_GRADIENT'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_RHF_ENERGY'
         else
            jobflow = 'CCSD_RHF_GRADIENT'
         endif
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_UHF_ENERGY'
         else
            jobflow = 'CCSD_UHF_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_RHF_DROPMO_ENERGY'
         else
            jobflow = 'CCSD_RHF_DROPMO_GRADIENT'
         endif 
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_UHF_DROPMO_GRADIENT'
         else
            jobflow = 'CCSD_UHF_DROPMO_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 22 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_TRIPLES_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 22 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_TRIPLES_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 22 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_DROPMO_TRIPLES_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 22 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_DROPMO_TRIPLES_ENERGY'
      endif

      n = str_trimlen(jobflow)
      if (instab .gt. 0) jobflow((n+1):(n+7)) = '_INSTAB'

      if (excite .eq. 3) then
         if (ref .eq. 0 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0) then
            jobflow = 'EOM_RHF_CCSD_ENERGY'
         endif

         if (ref .eq. 0 .and.
     *       calc .eq. 10 .and.
     *       dropmo .ne. 0) then
            jobflow = 'EOM_RHF_CCSD_DROPMO_ENERGY'
         endif

         if (ref .eq. 1 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0) then
            jobflow = 'EOM_UHF_CCSD_ENERGY'
         endif

         if (ref .eq. 1 .and.
     *       calc .eq. 10 .and.
     *       dropmo .ne. 0) then
            jobflow = 'EOM_UHF_CCSD_DROPMO_ENERGY'
         endif
C
C   Watson
C
         if (ref .eq. 0 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0  .and.
     *       props  .eq. 1)   then
            jobflow = 'EOM_RHF_CCSD_DENS_ENERGY'
         endif

         if (ref .eq. 1 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0  .and.
     *       props   .eq. 1)  then
            jobflow = 'EOM_UHF_CCSD_DENS_ENERGY'
         endif
C
C   Watson
C
      endif
C
C Ajith Perera, 07/2013. The isotropic Hyperfine coupling 
c Constants.
C  
   
      if (ref .eq. 1 .and. Calc .eq. 0 .and. props .eq. 1) 
     &   jobflow = 'HF_AISO'

      if (ref .eq. 1 .and. Calc .eq. 1 .and. props .eq. 1) 
     &   jobflow = 'MBPT2_AISO'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. props .eq. 1 .and.
     &   density .eq. 0) jobflow = 'CCSD_RELAX_DENS_AISO'

      if (ref .eq. 1 .and. Calc .eq. 22 .and. props .eq. 1 .and.
     &   density .eq. 0) jobflow = 'CCSDT_RELAX_DENS_AISO'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. props .eq. 1 .and.
     &   density .eq. 1) jobflow = 'CCSD_RESPONSE_DENS_AISO'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. props .eq. 1 .and.
     &   density .eq. 0 .and. dropmo .ne. 0) 
     &   jobflow = 'CCSD_RELAX_DENS_DROPMO_AISO'
  
C
C EOM-DIP and DEA (singlets and triplets)
C
C Note that currently singlet states only DIP/DEA calculations
C require UHF refrence and it is not necessary and need to be
C changed (require new SIAL codes).


      call Igetrec(-1,'JOBARC','DIPSYMA ',1, dip_singlet_root)
      call Igetrec(-1,'JOBARC','DIPSYMB ',1, dip_triplet_root)

      call Igetrec(-1,'JOBARC','DEASYMA ',1, dea_singlet_root)
      call Igetrec(-1,'JOBARC','DEASYMB ',1, dea_triplet_root)

      if (ref .eq. 1 .and. Calc .eq. 10 .and.dip_calc .eq. 2 .and.
     &    dip_singlet_root .gt. 0) jobflow = 'EOMDIP_CCSD_SINGLET'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. dip_calc .eq. 2 .and.
     &    dip_triplet_root .gt. 0) jobflow = 'EOMDIP_CCSD_TRIPLET'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. dea_calc .eq. 2 .and.
     &    dea_singlet_root .gt. 0) jobflow = 'EOMDEA_CCSD_SINGLET'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. dea_calc .eq. 2 .and.
     &    dea_triplet_root) jobflow = 'EOMDEA_CCSD_TRIPLET'

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function get_symbolic_constant(ival)
c---------------------------------------------------------------------------
c   Returns the appropriate symbolic constant from the "ival" argument.
c---------------------------------------------------------------------------
      implicit none
      include 'symbolic_constants.h'
      include 'trace.h'

      integer ival
      integer value

      if (ival .ge. 0 .and. ival .lt. nsymbolic_constants) then
         value = symbolic_constant_table(ival+1)
      else
         print *,'Error: Invalid value for symbolic constant ',
     *      ival,' line ',current_line
         call abort_job()
      endif
          

      get_symbolic_constant = value
      return 
      end

      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine push_clean_block(iblock, server_table, nserver_table)
c---------------------------------------------------------------------------
c   Push a block number onto the clean block stack.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'parallel_info.h'

      integer i,j, ptr, iblock
      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)

      do i = 1, clean_block_ptr
         if (iblock .eq. clean_blocks(i)) then
            return  ! no need to add block
         endif
      enddo

      clean_block_ptr = clean_block_ptr + 1
      if (clean_block_ptr .gt. nserver_memblocks) then
         print *,'Error: clean block stack overflow '
         print *,'nserver_memblocks ',nserver_memblocks
         print *,'mx_server_memblocks ',mx_server_memblocks
         do i = 1, nserver_memblocks
            print *,'entry ',i,' clean_blocks(i) ',clean_blocks(i)
         enddo
         call server_abort_job(server_table, nserver_table)
      endif

      clean_blocks(clean_block_ptr) = iblock 
      nclean_blocks = nclean_blocks + 1
      return
      end

c ---------------------------------------------------------------
c --- "TRANSPOSE" AN UPPER- OR LOWER- PACKED TRIANGULAR ARRAY ---
c ---                ANTHONY YAU, 29 JULY 2000                ---
c ---------------------------------------------------------------

c CALL TRANSPOSE_SP(UPLO,M,DY,IX)
c
c UPLO = { "U", "u", "L", "l" }
c        the condition of DY on entry (upper- or lower-packed)
c
c M    = { integer }
c        the order of the square array
c
c DY   = { double precision array of dimension M*(M+1)/2 }
c        the double precision array to be transposed
c
c IX   = { integer array of dimension M*(M+1)/2 }
c        a work array

      subroutine transpose_sp(uplo,m,dy,ix)
      implicit none

c ARGUMENT LIST
      character*1 uplo
      integer m
      integer ix(m*(m+1)/2)
      double precision dy(m*(m+1)/2)

c INTERNAL VARIABLES
      double precision dtmp
      integer offset, row, rowptr, col, colsum

c DISCARD THE CHAFF
      if (m.lt.0) then
         print *, "@TRANSPOSE_SP: The order of the array to",
     &            " transpose cannot"
         print *, "               be less than zero."
         call c_exit(1)
      end if
      if ((m.eq.0).or.(m.eq.1).or.(m.eq.2)) return
      if (m.eq.3) then
         dtmp =dy(3)
         dy(3)=dy(4)
         dy(4)=dtmp
         return
      end if

c GET TO WORK
c   o If m is 4 then the code is short enough to implement by hand
c     and will be much faster than treating it generally; otherwise,
c     create the integer array to be sorted. This is a list of the
c     destination addresses for the elements in dy.
      if ((uplo.eq."U").or.(uplo.eq."u")) then
         if (m.eq.4) then
            dtmp =dy(3)
            dy(3)=dy(4)
            dy(4)=dy(7)
            dy(7)=dy(8)
            dy(8)=dy(6)
            dy(6)=dy(5)
            dy(5)=dtmp
            return
         end if
         ix(1)=1
         offset=2
         do row = 2,m
            ix(offset)=row
            offset=offset+1
            colsum=0
            do col=1,(row-1)
               colsum=colsum+(m-col)
               ix(offset)=row+colsum
               offset=offset+1
            end do
         end do
      else if ((uplo.eq."L").or.(uplo.eq."l")) then
         if (m.eq.4) then
            dtmp =dy(3)
            dy(3)=dy(5)
            dy(5)=dy(6)
            dy(6)=dy(8)
            dy(8)=dy(7)
            dy(7)=dy(4)
            dy(4)=dtmp
            return
         end if
         offset=1
         do row = 1,(m-1)
            rowptr=ishft((row*(row+1)),-1)
            ix(offset)=rowptr
            offset=offset+1
            colsum=0
            do col=row,(m-1)
               colsum=colsum+col
               ix(offset)=rowptr+colsum
               offset=offset+1
            end do
         end do
         ix(offset)=ishft((m*(m+1)),-1)
      else
         print *, "@TRANSPOSE_SP: An invalid character has been",
     &            " received."
         print *, "               The character ", uplo,
     &            " should be U, u, L, or l."
         call c_exit(1)
      end if

c   o We're done with the counting variables so we can pass them as
c     arguments to idsort.
      colsum=ishft((m*(m+1)),-1)
      offset=2
      call idsort(ix,dy,colsum,offset)

      return
      end

c This subroutine creates a new LIFO indexing structure (i.e. stack).

c OUTPUT
c int ID : the new stack handle

c INPUT
c int INDEX1 : the first index to count from (cannot be -1)
c int LENGTH : the maximum number of elements in the stack
c              <  0; infinite number of elements (cf. LIFO_DEL)
c              >= 0; finite number of elements

      subroutine lifo_new(id,index1,length)
      implicit none

      integer id, index1, length



      integer           lifo(4,100), nStacks
      common /lifo_com/ lifo, nStacks
      save   /lifo_com/


      external lifo_bd

      if (nStacks.eq.100) then
         print *, '@LIFO_NEW: No more stacks allowed.'
         call c_exit(1)
      end if
      if (index1.eq.-1) then
         print *, '@LIFO_NEW: Invalid initial index.'
         call c_exit(1)
      end if
      if (index1.lt.-1.and.-1.le.index1+length) then
         print *, '@LIFO_NEW: Invalid index range ',index1,index1+length
         call c_exit(1)
      end if

      nStacks = nStacks+1
      id = nStacks

      lifo(1,nStacks) = index1
      lifo(2,nStacks) = index1
      lifo(3,nStacks) = index1
      lifo(4,nStacks) = index1+length-1

      return
c     end subroutine lifo_new
      end

c ----------------------------------------------------------------------

      blockdata lifo_bd
      implicit none


      integer           lifo(4,100), nStacks
      common /lifo_com/ lifo, nStacks
      save   /lifo_com/


      integer l
      parameter(l=4*100)
      data lifo /l*-1/
      data nStacks /0/
      end

C Purpose: Produce an VMOL .MOL file based on the ZMAT file
C
C Arguments:
C     PtGrp   Symbol for the point group symmetry to use in (input)
C             making the INP file.
C     NAtms   Number of atoms (input)
C     AtNr    Atomic numbers for each center (input)
C     NUnique Number of unique internal coordinates (input)
C     geom    Cartesian coordinates (input)
c             will not be the same as Q in FINDIF
C     GenBy   To hold the Genby list (internal)
C     IStat   Error codes (output)
C             = 0  Successful
C             = 1  Fatal error from dependent
C             = 3  I/O Error on AbiFil
C             = 5  I/O Error on ZFil
C             = 7  No non-dummy centers!
C             = 8  ZFil ends after Z-matrix
C             = 10 ZFil ends after JODA control info
C     BasName Holds the basis set name given in the ZMAT file
C
C Common blocks used:
C     LUnits  Sets unit names & numbers
C     Coord
C
C Internal Variables:
C     JobTtl  Holds the job title given in the ZMAT file
C     Wrk     Scratch string to copy lines form ZMAT to ABI
C
C Dependents
C     PitPtG  Translates a schoenflies symbol into Pitzer's form
C     WrPBas  Lookup & write basis set in Pitzer style
C
C Files used:
C     ZFil   Holds the basis specification & the "rest" of INP
C     AbiFil Gets written out here (kills previous one)
C     BasFil The basis set library
C
C Limitations:
C     Only looks up bases for the geometrically unique atoms.
c
C     Extra blank lines at the end of a "truncated" ZFil will cause
C     it to act like it encountered a real error on reading the file.

#include "flags.h"

      SUBROUTINE MKVMOL(geom, PTGRP,NATMS,NUNIQUE,ZSYM,ATNR,GENBY,
     $     SCRATCH, ISTAT, BasName)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
#include "io_units.par"
#include "linelen.par"
#include "baslims.par"
#include "molstrct.com"
#include "coord.com"

      character*(*) BasName

      integer    lusew
      parameter (lusew  =  15)
      character*(*) SewFil
      parameter    (SewFil = 'MOLCAS.INP')

      Character*(*) PtGrp, ZSym(NAtms)
      Integer AtNr(NAtms), GenBy(NAtms), IStat, AtoI,IZLoc(MxAtms)
      Character*(linelen) JobTtl, Wrk
      Character*3 Ka(3)
      Character*6 Slask,NullSt
      Character*1 Lb
      Character*1 Indxx(150)
      Character*2 Symbol

cYAU - parse ZMAT like fetchz()
      integer izl(2,7)
      logical bTmp

csb 1/97 Hold long basis set names
#include "baslen.par"
      character*(baslen) BasNam(MxAtms), BasNam_hold(MxAtms), BlnkBN,
     &                   ScrBas,EcpNam(MxAtms),EcpNam_hold(MxAtms)

      dimension icrcor(mxatms)
      common /turbo / iturbo,matom,ioffsh

CJDW  11/2/94. We now use IFLAGS2(108) to set TLA.
C     Parameter (TLA = 1.D-9)
CSSS      INTEGER SHELLANG,SHELLLOC,SHELLSIZ,SHELLPRM
CSSS      INTEGER SHELLORB,SHOFFSET,PRIMORBT,PROFFSET
      double precision geom(3*mxatms)
C
      LOGICAL XYZIN,NWFINDIF
      Logical Opn,bad123, GENBAS
CKJW 5-24-00
      logical seward,bCpBasis,bExist,bOpened
      Integer OldLu
      Dimension Nord(2*MxAtms),Scratch(NAtms)

      integer  atomnumb
C
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
CSSS      COMMON /MOLSTR1/ SHELLANG(MXTNSH),SHELLLOC(MXTNSH),
CSSS     &                 SHELLSIZ(MXTNSH),SHELLPRM(MXTNSH),
CSSS     &                 BASISEXP(10000),BASISCNT(10000)
CSSS      COMMON /MOLSTR2/ NTOTPRIM,NTOTSHEL,IOFFPRIM,IOFFSHEL,IIATOM
CSSS      COMMON /MOLSTR3/ SHELLORB(MXTNSH),SHOFFSET(MXTNSH),
CSSS     &                 PRIMORBT(MXTNSH),PROFFSET(MXTNSH)

      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /INPTYP/XYZIN,NWFINDIF
      COMMON /FLAGS/IFLAGS(100),IFLAGS2(500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
C     Length of BasNam is fixed by the basis library
C
C
C     This length is fixed by ABINITIO's input section
C
      Data Indxx /'1','2','3','4','5','6','7','8','9','0','A'
     &,'B','C','D','E','F','G','H','I','J','K','L','M','N'
     &,'O','P','Q','R','S','T','U','V','W','X','Y','Z','a'
     &,'b','c','d','e','f','g','h','i','j','k','l','m','n'
     &,'o','p','q','r','s','t','u','v','w','x','y','z',88*'*'/

csb
csb      DATA BASIS /'PBS     ','STO-3G  ','DZ      ',
csb     &            'VDZ     ','3-21G   ','6-31G   ',
csb     &            '4-31G   ','TZ      ','PVTZ    ',
csb     &            '6-311G  ','DZP     ','PVDZ    ',
csb     &            'TZP     ','PVQZ    ','TZ2P    ',
csb     &            'WMR     ','6-31G*  ','6-31G** ',
csb     &            '6-311G* ','6-311G**','PV5Z    ',
csb     &            'sv      ','svp     ','dz      ',
csb     &            'dzp     ','tzp     ','tz2p    ',
csb     &            'tzpl    ','tz2pl   ','qzp     ',
csb     &            'qz2p    ','pz2p    '/

c ----------------------------------------------------------------------

      external atomnumb
C
C Initialize some things.
C
      do i=1,baslen
        BlnkBN(i:i)=' '
      end do
      ScrBas=BlnkBN

      bad123 = .false.
      Slask='INTGRL'
      NullSt='      '
      LB='#'
      J=0
      I=0
      IGENER=1
      IF10=0
      IF18=1
      ID3=0
      IONE=1
      IRSTRT=0
      CALL IGETREC(-1,'JOBARC','PASS1   ',IONE,INEWFD)
      IECP=IFLAGS(71)
      IECPU=0
      IPRINT=0
      INUTMP=0
      ISTATS=0
      ISTAT=0
      IOFFPRIM=1
      IOFFSHEL=1
C
      ICOUNT=0
c
c iturbo = 1: create an interfacefile to TURBOMOLE
c
      iturbo=IFLAGS(h_IFLAGS_turbomole)
      if (iturbo.eq.1) then
        matom=0
        ioffsh=0
      endif
C
C SEE IF A GENBAS FILE IS PRESENT
C
      INQUIRE(FILE='GENBAS',EXIST=GENBAS)
      IF (.NOT.GENBAS) INQUIRE(FILE='ZMAT.BAS',EXIST=GENBAS)
C
C     Cautiously open the ZMAT file
C
      Inquire (FILE=ZFil, OPENED=Opn)
      If (.not.Opn) Open (LuZ, FILE=ZFil, STATUS='OLD')
      Rewind LuZ

C     skip the header
      bTmp = .true.
      do while (bTmp)
         read (LuZ, '(A)', ERR=8500, END=8510) JobTtl
         call parsez(JobTtl,izl)
         i = izl(1,1)
         bTmp = ((i.eq.0).or.(JobTtl(i:i).EQ.'%'))
      end do

      IF ((.NOT.XYZIN).OR.(NWFINDIF)) THEN
         i = 1
         do while (i.le.natms)
            read (LuZ,'(A)', ERR=8500, END=8510) Wrk
            call parsez(wrk,izl)
            if (i.eq.3) then
               izz = AtoI(wrk(izl(1,2):izl(2,2)))
               bad123 = ( izz.eq.1            .and.
     &                    zsym(1)(1:1).ne.'X' .and.
     &                    zsym(2)(1:1).ne.'X'       )
            end if
            i = i + 1
         end do
      ELSE
         DO I = 1, NATMS
            READ (LUZ,'(A)', ERR=8500, END=8510) WRK
         END DO
      END IF
      IF (IFLAGS(68) .EQ. 0) THEN
         Read (LuZ,'(A)', ERR=8500, END=8510) Wrk
         Do i = 1, NUnique
            Read (LuZ, '(A)', ERR=8500, END=8510) Wrk
         End Do
      END IF
      Read (LuZ, '(A)', ERR=8500, END=8800) Wrk

c YAU : old
c     Get the optimizer settings & another blank line after
c      Call GtFlgs(0,IErr,
c     &            IPrnt, INR,   IContl,IVec,  IDie,
c     &            ICurvy,IStCrt,IMxStp,IVib,  IRecal,
c     &            IntTyp,IDisFD,IGrdFD,ICNTYP,ISym,
c     &            IBasis,IDFGHI,
c     &            BasName)
c      If (IErr.eq.2) Goto 8800
c      If (IErr.eq.1) Goto 8500
cC      Read (LuZ, '(11I3)', ERR=8500, END=8800) IPrnt, INR, IContl,
cC     $ IVec, IDie, ICurvy, IStCrt, IMxStp, IVib, IRecal, IntTyp
c      Read (LuZ, '(A)', ERR=8500, END=8810) Wrk
c YAU : new
      IPrnt  = iFlags(h_IFLAGS_joda_print)
      INR    = iFlags(h_IFLAGS_opt_method)
      IContl = iFlags(h_IFLAGS_convergence)
      IVec   = iFlags(h_IFLAGS_eigenvector)
      IDie   = iFlags(h_IFLAGS_negeval)
      ICurvy = iFlags(h_IFLAGS_curvilinear)
      IStCrt = iFlags(h_IFLAGS_stp_siz_ctl)
      IMxStp = iFlags(h_IFLAGS_max_step)
      IVib   = iFlags(h_IFLAGS_vibration)
      IRecal = iFlags(h_IFLAGS_eval_hess)
      IntTyp = iFlags(h_IFLAGS_integrals)
      IDisFD = iFlags(h_IFLAGS_fd_stepsize)
      IGrdFD = iFlags(h_IFLAGS_points)
      ICNTYP = iFlags(h_IFLAGS_contraction)
      ISym   = iFlags(h_IFLAGS_symmetry)
      IBasis = iFlags(h_IFLAGS_basis)
      IDFGHI = iFlags(h_IFLAGS_spherical)
c   o if ([basis=special]) then [scroll ZMAT down to the basis set definitions]
c     WARNING: THIS IS A HACK!
c     Basis set information handling should be totally revamped.
      if (iBasis.eq.0) then
         bTmp = .true.
         do while (bTmp)
            read(LuZ,'(A)',ERR=8500,END=8800) wrk
            bTmp = (wrk(2:2).ne.':'.and.wrk(3:3).ne.':')
         end do
c      o go back for the next read
         backspace(luz)
      end if
c YAU : end
      If (IContl.eq.0) IContl = 4
      IF (IPrnt.ge.100) THEN
         Write (LuOut, '(4X,A,I3)') 'Print Level: ', IPrnt
         Write (LuOut, '(4X,A,I3)') 'Step-taking: ', INR
         Write (LuOut, '(4X,A,I3)') 'E-Vec to follow: ',IVec
         Write (LuOut, '(4X,A,I3)') 'Die: ',IDie
         Write (LuOut, '(4X,A,I3)') 'Use curvilinear xform: ',ICurvy
         Write (LuOut, '(4X,A,I3)') 'Max Step: ',IMxStp
         Write (LuOut, '(4X,A,I3)') 'Step Contol: ', IStCrt
         Write (LuOut, '(4X,A,I3)') 'Vibrational Analysis: ', IVib
         Write (LuOut, '(4X,A,I3)') 'Recalculation of Hessian: ',IRecal
         Write (LuOut, '(4X,A,I3)') 'Convergence cutoff: ',IContl
         Write (LuOut, '(4X,A,I3)') 'Integral type: ',IntTyp
      END IF

C     Now read the basis sets - each line corresponds to a (non-dummy)
C     center in the Z-matrix, in the order of appearance.  We put this
C     into an array length NAtms, with blanks for dummies.  This makes
C     it easier to match the basis with the right coordinates later.
C     NOTE: blank line after basis names.
C     
C Having to type the same basis set name for every atom is error prone
C and time consuming for when the molecule is large (> 10 atoms). In
C order to aviod that this new logic will ask the user to input the 
C number of distinct atoms in the molecule and the use specify the 
C basis for those distinct atoms and the rest will get generated 
C automatically. If the user wants to have different basis sets for
C distinct atoms then he/she has to specify the basis set for each
C line correspond to a center in the Z-matrix. The distinct atom 
C basis pair do not need need to be in particular order. The 
C same applies for ECP basis sets. Ajith Perera, 06/2013.
C
C
      If (Ibasis .EQ. 0) Then
          backspace(luz)
          read(LuZ,'(i4)',err=8500,end=8510,iostat=IOS) Num_unique
      Else
          Num_unique = 0
      Endif

      If (Num_unique .EQ. Natms .OR. Num_unique .EQ. 0) Then

          Do 250 i = 1, NAtms
             BasNam(i) = BlnkBN
             if (AtNr(i).ne.0) then
               if (iBasis.eq.0) then

c   o read special
                 read(LuZ,'(A)',err=8500,end=8510,iostat=IOS) BasNam(i)

               else
C
csb 1/97 Allow arbitrary basis set names

                  BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
     &                      BasName(1:linblnk(BasName))
C
csb               izz=index(Basis(IBasis),'*')
csb               ixx=index(Basis(IBasis),'**')
csb               ipop=0
csbCJDW 8/29/94. 1.5 ---> 4.5 (what about He ?)
csb               if(ixx.ne.0.and.atmass(i).gt.4.5)ipop=1
csb               if(izz.ne.ixx.and.atmass(i).lt.4.5)ipop=1
csb               BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
csb     &                   Basis(IBasis)(1:linblnk(Basis(IBasis))-ipop)
               end if

c        end if ([not dummy atom])
             end if
 250      Continue
     
      Else
        
          Do Iatm = 1,  Num_unique
             read(LuZ,'(A)',err=8500,end=8510,iostat=IOS)
     &                      BasNam_hold(Iatm)
          Enddo 
C
          Katm = 0
          Do Iatm = 1, NAtms
             If (AtNr(Iatm).EQ.0) Katm = Katm + 1

             Do Jatm = 1, Num_unique
                Ilen   = Index(Basnam_hold(Jatm), ":")
                Symbol = Basnam_hold(Jatm)(1:Ilen-1)
                JAtnr  = ATOMNUMB(Symbol)
                If (AtNr(Iatm) .EQ. JAtNr) Then
                   Katm  = Katm + 1
                   Basnam(Katm) = Basnam_hold(Jatm)
                Endif
             Enddo
          Enddo

          If(Bad123)then
            ScrBas=BasNam(1)
            BasNam(1)=BasNam(2)
            BasNam(2)=ScrBas
          EndIf
C
      Endif 

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The basis set definitions"
      do i=1,natms
         Write(6,"(1x,i3,1x,A20)") Atnr(i), basnam(i)
      enddo
#endif
C
      If(IBasis.eq.0)Read (LuZ,'(A)', ERR=8500, END=8510) Wrk

C ADDITION (JFS,4/90)
C Now take care of situation which occurs when 2--1--3 Z-matrix
C  specification and nonstandard basis set input is used.  In this case,
C  the basis sets for atoms #1 and #2 must be switched.
C
      If(Bad123.and.IBasis.eq.0)then
       ScrBas=BasNam(1)
       BasNam(1)=BasNam(2)
       BasNam(2)=ScrBas
      EndIf
C
C DEAL WITh ECPs
C
      IF (IECP.EQ.1) THEN

csb        IF (IBASIS.EQ.0) THEN
C
C  NOW READ THE NAMES OF THE ECPS. JODA TRIES TO READ THEM FROM
C  THE ZMAT FILE. THE USE OF ECPS REQUIRES "BASIS = SPECIAL"
C
        Read (LuZ,'(A)', ERR=8500, END=8510) Wrk
        If (Wrk(2:2) .EQ. ":" .OR. Wrk(3:3) .EQ. ":") Then
           backspace(Luz)
           Num_unique = 0
        Else
           backspace(Luz)
           read(LuZ,'(i4)',err=8500,end=8510,iostat=IOS) Num_unique
        ENdif

        If (Num_unique .EQ. Natms .OR. Num_unique .EQ. 0) Then

           DO 255 I = 1, NATMS
              ECPNAM(I) = BLNKBN
              IF (ATNR(i) .NE. 0 .AND. IBASIS .EQ. 0) THEN
                 READ (LUZ, '(A)', ERR=8500, END=8510, IOSTAT=IOS)
     &           ECPNAM(I)
csb
              ElseIf(AtNr(i) .ne. 0 .and. IBasis .ne. 0)then

                 EcpNam(i)=BasName

              ENDIF
 255       CONTINUE

        Else

          Do Iatm = 1,  Num_unique
              read(LuZ,'(A)',err=8500,end=8510,iostat=IOS)
     &                   Ecpnam_hold(Iatm)
          Enddo
C
          Katm = 0
          Do Iatm = 1, NAtms
             If (AtNr(Iatm).EQ.0) Katm = Katm + 1

             Do Jatm = 1, Num_unique
                Ilen   = Index(Basnam_hold(Jatm), ":")
                Symbol = Ecpnam_hold(Jatm)(1:Ilen-1)
                JAtnr  = ATOMNUMB(Symbol)
                If (AtNr(Iatm) .EQ. JAtNr) Then
                   Katm  = Katm + 1
                   Ecpnam(Katm) = Ecpnam_hold(Jatm)
                Endif
             Enddo
          Enddo

          If(Bad123)then
            ScrBas=BasNam(1)
            BasNam(1)=BasNam(2)
            BasNam(2)=ScrBas
          EndIf
C
        Endif

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The ECP definitions"
      do i=1,natms
         Write(6,"(1x,i3,1x,A20)") Atnr(i), ecpnam(i)
      enddo
      Write(6,*)
#endif

        IF(IBASIS.EQ.0)READ (LUZ,'(A)', ERR=8500, END=8510) WRK

C ADDITION (JFS,4/90)
C Now take care of situation which occurs when 2--1--3 Z-matrix
C  specification and nonstandard basis set input is used.  In this case,
C  the basis sets for atoms #1 and #2 must be switched.
C
        IF(BAD123.AND.IBASIS.EQ.0) THEN
          SCRBAS=ECPNAM(1)
          ECPNAM(1)=ECPNAM(2)
          ECPNAM(2)=SCRBAS
        ENDIF
C
C NOW CORRECT THE CHARGES OF THE ATOMS BY THE CORE-ELECTRONS
C DESCRIBED BY THE ECP
C
        CALL CORCHR(ECPNAM,ATNR,ICRCOR,NATMS)
        DO 94 I=1,NATMS
          IF (ATNR(I).NE.0) THEN
            ICRCOR(i)=ATNR(I)-ICRCOR(i)
          ENDIF
   94   CONTINUE
        CALL PUTREC(10,'JOBARC','ECPNAM',80*NATMS,ECPNAM)
        CALL PUTREC(10,'JOBARC','NATOLD',1,NATMS)
C
csb        ELSE
csb          WRITE(*,*) 'INCOMPATIBLE KEYWORDS IN MKVMOL!'
csb          CALL ERREX
csb        ENDIF
      ENDIF
C
CCH END OF READING ECP NAMES

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Let's find out which centers are equivalent
C
      Call SymEqv ( NAtms, GenBy)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Count number of centers having *different* atomic numbers in this grou
C   Top half of Nord contains the number of symmetry equivalent atoms
C   for a given atomic number.
C
      Do I = 1, NAtms
         If (GenBy(i).eq.0.and.AtMass(i).gt.1.D-2) Then
            J = J + 1
            Scratch(J) = AtMass(I)
            Nord(J) = I
         End If
      End Do
      If (IVIB.ne.2) Then
c         Call PikSr2(J,Scratch,Nord)
         NonTyp = 1
         If (J.Eq.1) Then
            Nord(MxAtms+1) = 1
         Else
            Do I = 2, J
               Dif = Dabs(Scratch(i)-Scratch(i-1))
               If (NonTyp.eq.1) IBot=0
c               If (Dif.lt.1.D-14) GoTo 314
               Nord(MxAtms+Nontyp) = I - (IBot+1)
               IBot = IBot + Nord(MxAtms+Nontyp)
               NonTyp = NonTyp + 1
 314           If (I.eq.J) Nord(MxAtms+Nontyp) = I - Ibot
            End Do
         End If
      Else If (ivib.eq.2) Then
C
C For finite difference calcs, reset this so that it writes out the
C  atoms to the MOL
C  file in exactly the same order as they appear in the ZMAT.  This
C  ordering is assumed in FINDIF!
C
         NonTyp = J
         Do I = 1, J
            Nord(MxAtms+I) = 1
         End Do
      End If

C Now get symmetry information written by SYMMETRY to file VMINF.
      Opn = .False.
      OldLu = 0
      IF (PTGRP.EQ.'C1 ') THEN
         INQUIRE(FILE='VMLSYM',EXIST=Opn)
         IF (OPN) THEN
            OPEN(UNIT=30,FILE='VMLSYM',FORM='UNFORMATTED',
     &           STATUS='OLD')
            CLOSE(UNIT=30,STATUS='DELETE')
         END IF
         GOTO 5400
      END IF
      Inquire (FILE='VMLSYM', OPENED=Opn, NUMBER=OldLu)
      If (Opn) Close (OldLu)
C
      Open (30, FILE='VMLSYM', STATUS='OLD',FORM='UNFORMATTED')
      Rewind(30)
      Read (30,Err=9400) NSymOp, (KA(i),i=1,3)
      Close(30, Status='Delete')
5400  CONTINUE
      If (PtGrp.EQ.'C1 ') Then
         Do I = 1, 3
            KA(I)='   '
         End Do
         NSymOp = 0
      End If
C
C     Now we've got (pretty much) all the information we need, so
C     we can start writing out the MOL file.
C     Begin with a very cautious opening of the file.
C
        Opn = .False. 
        Inquire (file=molfil, OPENED=Opn)
        If ( .not. Opn ) Open (LuVMol, FILE=molFil, FORM='FORMATTED',
     $     STATUS='UNKNOWN')
        Rewind LuVMol
C
C Write lines of VMOL deck.  All of this mysterious SLASK stuff, etc.
C
        idosph=1-IDFGHI
cYAU        Write(LuVMol,'(A6,4X,10I5)')Slask,IGENER,If10,If18,IECP,IECPU,
cYAU     &    IPRINT,INUTMP,ISTATS,IDOSPH
        Write(LuVMol,'(A6,4X,10I5)')
     &     'INTGRL',IGENER,If10,If18,IECP,IECPU,
     &              IPRINT,INUTMP,ISTATS,IDOSPH
        Write(LuVMol,'(8x,a)')
     &     ' *** ACES2 Program System (Release V0.1) *** '
        Write(LuVMol,'(A)',ERR=8300) JobTtl(:linblnk(JobTtl))
CJDW  11/2/94
        TLA = DBLE(10.0D+00**(-IFLAGS2(108)))
        Write(LuVMol,'(2I5,3A3,1X,E10.2,10X,2I5)')NonTyp,NSymop,Ka,Tla,
     &    ID3,IRstrt
        Zink=9999.0
        Zink2=3.0
        Write(LuVMol,'(2F10.2)',ERR=8300)Zink,Zink2
      if(inttyp.eq.4) then
        seward = .true.
        opn = .false.
        inquire(file=sewfil,opened=opn)
        if (.not. opn)open(lusew,file=sewfil,form='FORMATTED',
     &    status='UNKNOWN')
        rewind lusew
        write(lusew,'(A)')' &SEWARD  &END'
        write(lusew,'(A)')'ACES'
        write(lusew,'(A)')'TITLE'
        write(lusew,'(A)') JobTtl(:linblnk(JobTtl))
        write(lusew,'(A)')'MOLECULE'
        write(lusew,'(A)')'THRESHOLD'
        write(lusew,'(E10.2)') DBLE(10.0D+00**(-IFLAGS2(108)))
c kjw 7-27-00 bug fix for cases with no symmetry
        if(ka(1).eq.'   '.and.ka(2).eq.'   '.and.ka(3).eq.'   ')then
        else
          write(lusew,'(A)')'SYMMETRY'
          write(lusew,'(3a3)') Ka
        endif
      endif

c   o open a basis set file for rdbas and create ZMAT.BAS if necessary
      inquire(unit=12,opened=bOpened)
      inquire(file='ZMAT.BAS',exist=bExist)
      if (bExist) then
         if (.not.bOpened) then
            open(unit=12,file='ZMAT.BAS',form='formatted',status='old')
         end if
         bCpBasis = .false.
         rewind(12)
      else
         if (.not.bOpened) then
            open(unit=12,file='GENBAS',form='formatted',status='old')
         else
            print *, '@MKVMOL: Assertion failed.'
            print *, '         ZMAT.BAS does not exist but unit 12 is ',
     &               'already open.'
            call errex
         end if
         open(unit=13,file='ZMAT.BAS',form='formatted',status='new')
         rewind(13)
         bCpBasis = .true.
      end if

C
C     Charge & multiplicity
C
c      Read (LuZ, '(A)', ERR=8500, END=8510) Wrk
C      Read (LuZ, '(A)', ERR=8500, END=8510) Wrk
C
C Now write the "real" input.
C
      IINFIL=0
      SHOFFSET(1)=1
      PROFFSET(1)=1
      Do 318 I = 1, Nontyp
       NStart = 1
       Do J = 1, I-1
          NStart = NStart + Nord(MxAtms+J)
       End Do
c       If(IntTyp.Eq.1)Then
c        Write(LuVMol,7000,ERR=8300)
c     &  NullSt,Float(IAtnum(Nord(NStart))),Nord(MxAtms+I)
c       Elseif(IntTyp.Eq.2)Then
c        WRITE(LUVMOL,7001,ERR=8300)
c     &  Float(IAtnum(Nord(NStart))),Nord(MxAtms+I)
c       ENDIF
c7000   Format(A6,F14.8,I5,$)
c7001   Format(F10.1,I5,$)
       SCRBAS=BASNAM(NORD(NSTART))
       IATTYP=1
       IIATOM=NORD(NSTART)
       IATOM=IATNUM(IIATOM)
       IF(IATOM.GT.2)IATTYP=2
       IF(IATOM.GT.10)IATTYP=3
       IF(GENBAS)THEN
        CALL RDBAS(SCRBAS,0,IFLAGS(64+IATTYP),LUVMOL,
     &             IntTyp,NullSt,IAtnum(Nord(NStart)),
     &             Nord(MxAtms+I),seward,.false.,13)
       ELSE
        Call WrPBas (LuBasL,BasFil,SCRBAS,
     &  LuVMol,0,1,IStat,IntTyp,Nullst,IAtnum(Nord(Nstart)),
     &  Nord(MxAtms+I))
       ENDIF
       Do J = 1, Nord(MxAtms+J)
          IBotm = -2 + 3*Nord(NStart-1+J)
          IINFIL = IINFIL + 1
          IZLOC(IINFIL) = NORD(NSTART+J-1)
          Icount = Icount + 1
          Write(LuVMol,'(A2,A1,A1,3F20.12)',ERR=8300)
     &                  ZSym(Nord(NStart)),LB,Indxx(ICOUNT),
     &                  (geom(IJ),IJ=IBotm,Ibotm+2)
       End Do
       IF(GENBAS)THEN
        CALL RDBAS(SCRBAS,1,IFLAGS(64+IATTYP),LUVMOL,
     &             ijunk,ijunk,ijunk,ijunk,seward,bCpBasis,13)
        if(inttyp.eq.4)then
          if(iflags(62).eq.0)then
            write(lusew,'(A)')'Cartesian all'
          else
            write(lusew,'(A)')'Spherical all'
          endif      
          wrk=zsym(nord(nstart))
          isew=index(wrk,' ')
          write(lusew,'(a6,3f20.12)') wrk(1:isew-1)//indxx(icount),
     &      (geom(isew),isew=ibotm,ibotm+2)
          write(lusew,'(A)')'End of Basis Set'
        endif
        SHOFFSET(I+1)=IOFFSHEL
        PROFFSET(I+1)=IOFFPRIM
        SHELLORB(I)=SHOFFSET(I+1)-SHOFFSET(I)
        PRIMORBT(I)=PROFFSET(I+1)-PROFFSET(I)
       ELSE
        Call WrPBas (LuBasL,BasFil,SCRBAS,
     &  LuVMol,1,1,IStat,ijunk,ijunk,ijunk,ijunk)
       ENDIF
C
C           Handle errors in WrPBas
C
            If (Mod(IStat,2) .eq. 1) then
               IStat = 1
               Write (LuErr, 9910)
               Close (LuZ)
               Close (LuVMol)
               Return
            ElseIf (IStat .eq. 8) then
               IStat = 3
               Write (LuErr, 9935) AbiFil, LuVMol
               Close (LuZ)
               Close (LuVMol)
               Return
            EndIf
 318    Continue
        Write(LuVMol,'(A6)',ERR=8300)'FINISH'
        if(inttyp.eq.4)then
          write(lusew,'(A)')'End of input'
        endif

c   o if we created ZMAT.BAS, then close GENBAS and connect ZMAT.BAS to unit 12
      if (bCpBasis) then
         close(12,status='keep')
         close(13,status='keep')
         open(unit=12,file='ZMAT.BAS',form='formatted',status='old')
         bCpBasis = .false.
      end if

c
c create the interfacefile to TURBOMOLE
c
      if (iturbo.eq.1) then
cYAU        ispher=iflags(62)
cYAU        call mkturb(basnam,geom,zsym,atmass,iatnum,natms,nontyp,
cYAU     &              ispher)
         write(*,*) '@MKVMOL: MkTurb was temporarily removed.'
         write(*,*) '         This calculation cannot complete.'
         call errex
      end if
C
C     Dump vector to disk which relates the atoms listed in the
C     MOL file to their position in the user supplied Z-matrix.
C
      CALL IPUTREC(20,'JOBARC','MPVMZMAT',NATOMS,IZLOC)
C
 9910 Format (' @MKDECK-F, Dependent terminated with FATAL error.')
 9935 Format (' @MKDECK-F, Dependent reports error accessing file ',
     $   A,' on unit ',I3,'.')
C
C This better not happen.
C
      If (Nontyp .eq. 0) then
         IStat = 7
         Write (LuErr, 9970)
         Close (LuZ)
         Close (LuVmol)
         Return
 9970    Format (' @MKDECK-F, No non-dummy centers in Z-matrix.')
      EndIf
C
C     The rest of this just copied from ZMAT
C
C
C     Make sure every body gets closed & stuff
C
 8000 If(IntTyp.ne.0)Close (LuVMol)
      if(inttyp.eq.4)close (lusew)
      Close (LuZ)
C
C WRITE BASIS SET INFORMATION TO JOBARC
C
      IONE=1
      NTOTPRIM=IOFFPRIM-1
      NTOTSHEL=IOFFSHEL-1
      IF(IECP.EQ.1) THEN
       CALL IPUTREC(20,'JOBARC','ATOMCHRG',NATOMS,ICRCOR)
      ELSE
       CALL IPUTREC(20,'JOBARC','ATOMCHRG',NATOMS,IATNUM)
      ENDIF
      IF(INEWFD.EQ.0)THEN
       CALL IPUTREC(20,'JOBARC','NTOTSHEL',IONE,NTOTSHEL)
       CALL IPUTREC(20,'JOBARC','NTOTPRIM',IONE,NTOTPRIM)
       CALL DPUTREC(20,'JOBARC','BASISEXP',NTOTPRIM,BASISEXP)
       CALL DPUTREC(20,'JOBARC','BASISCNT',NTOTPRIM,BASISCNT)
       CALL IPUTREC(20,'JOBARC','SHELLSIZ',NTOTSHEL,SHELLSIZ)
       CALL IPUTREC(20,'JOBARC','SHELLPRM',NTOTSHEL,SHELLPRM)
       CALL IPUTREC(20,'JOBARC','SHELLANG',NTOTSHEL,SHELLANG)
       CALL IPUTREC(20,'JOBARC','SHELLLOC',NTOTSHEL,SHELLLOC)
       CALL IPUTREC(20,'JOBARC','SHOFFSET',NONTYP,SHOFFSET)
       CALL IPUTREC(20,'JOBARC','SHELLORB',NONTYP,SHELLORB)
       CALL IPUTREC(20,'JOBARC','PROFFSET',NONTYP,PROFFSET)
       CALL IPUTREC(20,'JOBARC','PRIMORBT',NONTYP,PRIMORBT)
      ENDIF
C
CJDW  6/ 6/95. Add JFS call to SHELLINF.
C
      call shellinf(nontyp,natoms,ntotshel,shellorb,shoffset,shellang,
     &              shellsiz)
C
      Return
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Get here via an I/O error on LuAbi or LuVMol
C
 8300 IStat = 3
      If(IntTyp.ne.0)then
       Write (LuErr, 9930) MolFil
       Close (LuVMol)
      else
       Write (LuErr, 9930) AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 9930 Format (' @MKDECK-F, I/O error on file ',A,'.')
C
C     Get here via an I/O error on VMLSYM
C
 9400 IStat=3
      Write (LuErr, 9930)'VMLSYM'
      Close(LuVMol)
      Close(LuZ)
      Return
C
C     Get here via an I/O error on LuZ
C
 8500 IStat = 5
      If(IntTyp.ne.0)then
       Write (LuErr, 9950) MolFil
       Close (LuVMol)
      else
       Write (LuErr, 9950) AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 8510 IStat = 5
      If(IntTyp.ne.0)then
       Write (LuErr, 9955) MolFil
       Close (LuVMol)
      else
       Write (LuErr, 9955) AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
C
C     If the ZFil ends after the Z-matrix or the optimization control
C     info, it probably means that JODA is being used "stand-alone"
C     and we want to allow for that possibility.
C
 8800 IStat = 8
      If(IntTyp.ne.0)then
       Write (LuOut, 9800) ZFil, MolFil
       Close (LuVMol)
      else
       Write (LuOut, 9800) ZFil, AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 8810 IStat = 10
      If(IntTyp.ne.0)then
       Write (LuOut, 9810) ZFil, MolFil
       Close (LuVMol)
      else
       Write (LuOut, 9810) ZFil, AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 9950 Format (' @MKDECK-F, I/O error on file ',A,'.')
 9955 Format (' @MKDECK-F, Premature end-of-file on ',A,'.')
 9800 Format (/1X,A,' ends after Z-matrix - cannot ',
     $   'finish making ',A,'.')
 9810 Format (/1X,A,' ends after JODA control info - cannot ',
     $   'finish making ',A,'.')
      End

      Subroutine A3_Ecpgrd_int(Ecpint_4shell, La, Lb, 
     &                         Idegen_grd, Idegen, Jdegen, Numcoi,
     &                         Numcoj, Iprim, Jprim, Exp1, EXp2, 
     &                         Ecpgrd_x, Ecpgrd_y, Ecpgrd_z, Natoms,
     &                         Iatom, Jatom)

      Implicit Double Precision (A-H, O-Z)

#include "ecp.par"
#include "ecp.com"
     
      Dimension Ecpint_4shell(*), Ecpgrd_x(*), Ecpgrd_y(*), 
     &          Ecpgrd_z(*)
      
      Length = Idegen*Jdegen*Numcoi*Numcoj
      Call Dzero(Ecpgrd_x, Length)
      Call Dzero(Ecpgrd_y, Length)
      Call Dzero(Ecpgrd_z, Length)

      Texp1 = 2.0D0*Exp1
      Texp2 = 2.0D0*Exp2
      
      La_lo = Istart_grd(La)
      La_hi = Iend_grd(La)
      
      Lb_lo = Istart_grd(Lb)
      Lb_hi = Iend_grd(Lb) 

      Do Ndegen_grd = 1, Idegen_grd

         Ix = Lmnval_grd(4, Ndegen_grd + La_lo - 1)
         Iy = Lmnval_grd(5, Ndegen_grd + La_lo - 1)
         Iz = Lmnval_grd(6, Ndegen_grd + La_lo - 1)
         
         Tax = Texp1
         Tay = Texp1
         Taz = Texp1

         If (Lmnval_grd(7, Ndegen_grd + La_lo - 1) .Lt. 0) Then

            Tax = -(Lmnval_grd(1, Ndegen_grd + La_lo - 1) +1)
            Tay = -(Lmnval_grd(2, Ndegen_grd + La_lo - 1) +1)
            Taz = -(Lmnval_grd(3, Ndegen_grd + La_lo - 1) +1)

         Endif

#ifdef _DEBUG_LVLM
         Write(6,"(3I4,3(1x,F10.5))") ix, Iy, Iz, Tax, Tay, Taz
#endif

         Ndim = Jdegen*Numcoi*Numcoj

         If (Ix .NE. 0) Then
            Ioff = (Ndegen_grd-1)*Ndim+1
            Joff = (Ix-1)*Ndim+1
            Call daxpy(Ndim, Tax, Ecpint_4shell(Ioff), 1, 
     &                 Ecpgrd_x(Joff), 1)
         Endif


         If (Iy .NE. 0) Then
            Ioff = (Ndegen_grd-1)*Ndim+1
            Joff = (Iy-1)*Ndim+1
            Call daxpy(Ndim, Tay, Ecpint_4shell(Ioff), 1, 
     &                 Ecpgrd_y(Joff), 1)
         Endif
             
         If (Iz .NE. 0) Then
            Ioff = (Ndegen_grd-1)*Ndim+1
            Joff = (Iz-1)*Ndim+1
            Call daxpy(Ndim, Taz, Ecpint_4shell(Ioff), 1, 
     &                 Ecpgrd_z(Joff), 1)
         Endif

      Enddo

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The differentiated integrals"
      Write(6,"(a,4(1x,I2))")
      Write(6,"(a)") "d/dx integrals"
      Write(6,"(4(1x,F20.13))")(Ecpgrd_x(j), J=1,Length)

      Write(6,"(a)") "d/dy integrals"
      Write(6,"(4(1x,F20.13))")(Ecpgrd_y(j), J=1,Length)

      Write(6,"(a)") "d/dz integrals"
      Write(6,"(4(1x,F20.13))")(Ecpgrd_z(j), J=1,Length)
#endif
#ifdef _OBSOLETED
      Grad_x = Ddot(Length, Ecpgrd_x, 1, Dens_4shell, 1)
      Grad_y = Ddot(Length, Ecpgrd_y, 1, Dens_4shell, 1)
      Grad_z = Ddot(Length, Ecpgrd_z, 1, Dens_4shell, 1)

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,"(a)") "Grad_xyz"
      Write(6,"(3(1x,F20.13))") Grad_x, Grad_y, Grad_z
      Write(99, '(2I4)') Iatom, Jatom
      Write(99,"(3(1x,F20.13))") Grad_x, Grad_y, Grad_z
#endif
      
      Grad_xyz(1, Iatom) = Grad_x + Grad_xyz(1, Iatom)
      Grad_xyz(2, Iatom) = Grad_y + Grad_xyz(2, Iatom)
      Grad_xyz(3, Iatom) = Grad_z + Grad_xyz(3, Iatom) 

      Grad_xyz(1, Jatom) = -Grad_x + Grad_xyz(1, Jatom)
      Grad_xyz(2, Jatom) = -Grad_y + Grad_xyz(2, Jatom)
      Grad_xyz(3, Jatom) = -Grad_z + Grad_xyz(3, Jatom) 
#endif

      Return
      End

      double precision function xdot(n,dx,incx,dy,incy)

      double precision dx(*),dy(*),ddot
      integer incx, incy, n

#ifdef _32BIT_BLAS
      integer*4 int_n, int_incx, int_incy
#else
      integer   int_n, int_incx, int_incy
#endif /* _32BIT_BLAS */

      if (n.le.0) return

      int_incx = incx
      int_incy = incy
      int_n    = n

#ifdef USE_SP_BLAS
      xdot = sdot(int_n,dx,int_incx,dy,int_incy)
#else
      xdot = ddot(int_n,dx,int_incx,dy,int_incy)
#endif

      return
      end

      double precision function xdot(n,dx,incx,dy,incy)

      double precision dx(*),dy(*),ddot
      integer incx, incy, n




      integer   int_n, int_incx, int_incy


      if (n.le.0) return

      int_incx = incx
      int_incy = incy
      int_n    = n




      xdot = ddot(int_n,dx,int_incx,dy,int_incy)


      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine global_accumulate(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, address_table,
     *                      comm, op, comm_timer, instruction_timer)
c---------------------------------------------------------------------------
c   If the current block of the result array is mapped locally,   
c   global_accumulate sums the operand array into the local block.
c
c   If the current block is mapped to another processor, we perform an 
c   accumulate operation.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      include 'trace.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      integer*8 address_table(narray_table)
      double precision scalar_table(nscalar_table)

      integer result_array, op1_array, dest
      integer result_block, op1_block
      integer find_block_destination
      integer ierr
      integer i
      integer flopcount, send_count
      double precision send_time
      integer find_current_block
      integer blkndx
      integer find_current_block_map
      integer comm
      integer local_block, result_blkndx
      integer op1_type
      integer comm_timer, instruction_timer

      result_array = op(c_result_array)
      op1_array    = op(c_op1_array)
      op1_type     = array_table(c_array_type,op1_array)
      if (op1_type .eq. static_array) then
         print *,'Error: Attempt to use a static block in an ',
     *           'accumulate instruction.'
         print *,'Local array is array ',op1_array
         call abort_job() 
      endif

c-------------------------------------------------------------------------
c   Locate the current block of the operand array.
c-------------------------------------------------------------------------

      op1_block = find_current_block(op1_array, 
     *                             array_table(1,op1_array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)
      if (op1_block .le. 0) then
         print *,'Error in global_accumulate on task ',me,
     *          ' Cannot find block for op1_array = ',op1_array
         print *,'Line ',current_line
         print *,'current segs = ',(index_table(c_current_seg,i),
     *        i=1,nindex_table)
         call dump_block_ids()
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Locate the current block of the result array.
c-------------------------------------------------------------------------

      result_block = find_current_block_map(result_array, 
     *                                  array_table(1,result_array),
     *                                  index_table, nindex_table,
     *                                  block_map_table,
     *                                  nblock_map_table)

c--------------------------------------------------------------------------
c   Determine location of the mapping of the result_array's current block.
c--------------------------------------------------------------------------

      dest = find_block_destination(result_array, array_table,
     *               narray_table, index_table, nindex_table,
     *               block_map_table, nblock_map_table)
 
      if (dest .eq. my_company_rank) then

c--------------------------------------------------------------------------
c   Result block must exist already.
c--------------------------------------------------------------------------

         if (result_block .le. 0) then
            print *,'Error in global_accumulate on task ',me,
     *          ' Cannot find block for result_array = ',result_array
            print *,'current segs = ',(index_table(c_current_seg,i),
     *        i=1,nindex_table) 
            print *,'dest, me, my_company_rank = ',
     *            dest, me, my_company_rank
            call dump_block_ids()
            call abort_job()
         endif

         local_block = find_current_block(result_array,
     *                             array_table(1,result_array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, result_blkndx)
      else
         result_blkndx = 0
      endif

c---------------------------------------------------------------------------
c   Accumulate into the block at the destination processor.
c---------------------------------------------------------------------------

      call accumulate_block(op1_array, op1_block, blkndx,
     *                 result_array, result_block, result_blkndx,
     *                 dest, array_table,
     *                 narray_table, index_table, nindex_table,
     *                 segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table,
     *                 scalar_table, nscalar_table, address_table,
     *                 send_count, send_time, comm, my_company_rank,
     *                 op(c_opcode), comm_timer, instruction_timer) 
      return
      end

      SUBROUTINE EXPND4(VPACK,VFULL,LENGTH,IDIM)
C
C THIS ROUTINE EXPANDS A "PACKED" MATRIX TO FULL FORMAT, WHERE
C   THE PACKED ORDER IS :  V(1,1),V(2,1),...,V(N,1),V(2,2),...
C
C THIS IS USEFUL FOR EXPANDING THE D FUNCTION REPRESENTATIONS TO
C   A FULL 3x3 MATRIX
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DLOC(6),FLOC(10),GLOC(15),DPAK,FPAK,GPAK,DSIZ,FSIZ,GSIZ
      DIMENSION VPACK(1),VFULL(LENGTH*LENGTH)
      DIMENSION DFAC(6),FFAC(10),GFAC(15)
C
      PARAMETER (HALF = 0.5D0)
      PARAMETER (ONE  = 1.0D0)
      PARAMETER (TWO  = 2.0D0)
      PARAMETER (THIRD=1.0D0/3.0D0)
      PARAMETER (SIXTH=1.0D0/6.0D0)
      PARAMETER (FOURTH=0.25D0)
      PARAMETER (TWELFTH=1.0D0/12.0D0)
C   
      DATA DPAK /6/
      DATA FPAK /10/
      DATA GPAK /15/
      DATA DSIZ /9/
      DATA FSIZ /27/
      DATA GSIZ /81/
      DATA DLOC /1,2,3,5,6,9/
      DATA FLOC /1,2,3,5,6,9,14,15,18,27/
      DATA GLOC /1,2,3,5,6,9,14,15,18,27,41,42,45,54,81/
      DATA DFAC /ONE,HALF,HALF,ONE,HALF,ONE/
      DATA FFAC /ONE,THIRD,THIRD,THIRD,SIXTH,THIRD,ONE,THIRD,
     &           THIRD,ONE/
      DATA GFAC /ONE,FOURTH,FOURTH,SIXTH,TWELFTH,
     &           SIXTH,FOURTH,TWELFTH,TWELFTH,FOURTH,
     &           ONE,FOURTH,SIXTH,FOURTH,ONE/
C
      INDX2(I,J)=I+3*(J-1)
      INDX3(I,J,K)=I+3*(J-1)+9*(K-1)
      INDX4(I,J,K,L)=I+3*(J-1)+9*(K-1)+27*(L-1) 
C
C CODE FOR TWO DIMENSIONAL MATRICES (SUCH AS d FUNCTIONS)
C
      IF(IDIM.EQ.2)THEN
       CALL ZERO  (VFULL,DSIZ)
       CALL VECPRD(DFAC,VPACK,VPACK,DPAK)
       CALL SCATTER(DPAK,VFULL,DLOC,VPACK)
       DO 10 I=1,LENGTH
        DO 20 J=I,LENGTH
         X=VFULL(INDX2(J,I))
         VFULL(INDX2(I,J))=X
20      CONTINUE
10     CONTINUE
C
C CODE FOR THREE DIMENSIONAL MATRICES (SUCH AS f FUNCTIONS)
C
      ELSEIF(IDIM.EQ.3)THEN
       CALL ZERO  (VFULL,FSIZ)
       CALL VECPRD (FFAC,VPACK,VPACK,FPAK)
       CALL SCATTER(FPAK,VFULL,FLOC,VPACK)
       DO 110 I=1,LENGTH
        DO 120 J=I,LENGTH
         DO 130 K=J,LENGTH
          X=VFULL(INDX3(K,J,I))
          VFULL(INDX3(J,I,K))=X
          VFULL(INDX3(J,K,I))=X
          VFULL(INDX3(K,I,J))=X
          VFULL(INDX3(I,J,K))=X
          VFULL(INDX3(I,K,J))=X
130      CONTINUE
120     CONTINUE
110    CONTINUE
C
C CODE FOR FOUR DIMENSIONAL MATRICES (g FUNCTIONS)
C
      ELSEIF(IDIM.EQ.4)THEN
       CALL ZERO  (VFULL,GSIZ)
       CALL VECPRD (GFAC,VPACK,VPACK,GPAK)
       CALL SCATTER(GPAK,VFULL,GLOC,VPACK)
       DO 210 I=1,LENGTH
        DO 220 J=I,LENGTH
         DO 230 K=J,LENGTH
CDIR$ NOVECTOR
*VOCL LOOP,SCALAR
          DO 240 L=K,LENGTH
           X=VFULL(INDX4(L,K,J,I))
C
           VFULL(INDX4(I,J,K,L))=X
           VFULL(INDX4(I,J,L,K))=X
           VFULL(INDX4(I,L,J,K))=X
           VFULL(INDX4(I,L,K,J))=X
           VFULL(INDX4(I,K,J,L))=X
           VFULL(INDX4(I,K,L,J))=X
C
           VFULL(INDX4(J,I,K,L))=X
           VFULL(INDX4(J,I,L,K))=X
           VFULL(INDX4(J,L,I,K))=X
           VFULL(INDX4(J,L,K,I))=X
           VFULL(INDX4(J,K,I,L))=X
           VFULL(INDX4(J,K,L,I))=X
C
           VFULL(INDX4(K,I,J,L))=X
           VFULL(INDX4(K,I,L,J))=X
           VFULL(INDX4(K,J,I,L))=X
           VFULL(INDX4(K,J,L,I))=X
           VFULL(INDX4(K,L,I,J))=X
           VFULL(INDX4(K,L,J,I))=X
C
           VFULL(INDX4(L,I,J,K))=X
           VFULL(INDX4(L,I,K,J))=X
           VFULL(INDX4(L,K,I,J))=X
           VFULL(INDX4(L,J,I,K))=X
           VFULL(INDX4(L,J,K,I))=X
C        
240       CONTINUE
230      CONTINUE
220     CONTINUE
210    CONTINUE
C
      ENDIF
C
      RETURN
      END

      Subroutine App_cart_constrains(HES, TMP, PMAT, GRD, GRDTMP,
     &                               CONSTRAINS, NUM_CONSTRAINS, NX)
 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      INTEGER CONSTRAINS

      DIMENSION HES(NX, NX), TMP(NX, NX), PMAT(NX,NX),
     &          GRD(NX), GRDTMP(NX), CONSTRAINS(NUM_CONSTRAINS)
C
C Build the projected Hessian and gradients for constrained Cartesian
C optimizations. Ajith Perera, 06/2013.
C
      Call Dzero(Pmat, Nx*Nx)
      
      Do Idim = 1, Nx
            Pmat(Idim,Idim) = 1.0D0
      Enddo

      Do Idim = 1, NUM_CONSTRAINS
         Indx = Constrains(Idim) 
         Pmat(Indx, Indx) = 0.0D0
      Enddo

#ifdef _DEBUG_LVL0
      call xgemm("N", "T", Nx, Nx, Nx, 1.0D0, Pmat, Nx, Pmat, Nx,
     &            0.0d0, tmp, nx)
      write(6,"(a)") "The test for the projector: P^P"
      call output(tmp, 1, nx, 1, nx, nx, nx, 1)
      Write(6,"(a)") "The gradients, g"
      Write(6,"(5(1x,F15.7))") (Grd(I), I=1,NX)
      Write(6,"(a)") "The Hessian: H"
      call output(hes, 1, nx, 1, nx, nx, nx, 1)
#endif
C
C Project the Hessian
C
      CALL XGEMM("N", "N", NX, NX, NX, 1.0D0, PMAT, NX, HES, NX,
     &            0.0D0, TMP, NX)
      CALL XGEMM("N", "N", NX, NX, NX, 1.0D0, TMP, NX, PMAT, NX,
     &            0.0D0, HES, NX)

C Also project the gradients ie. form PG. Then copy the projected
C gradient  to the FI array so that the rest of the code can proceed.
C
      CALL XGEMM('N', 'N', NX, 1, NX, 1.0D0, PMAT, NX, GRDTMP, 
     &            NX, 0.0D0, GRD, NX)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The projected gradients: Pg"
      Write(6,"(6(1x,F15.7))") (Grd(I), I=1,NX)
      Write(6,"(a)") "The projected Hessian: PHP"
      call output(HES, 1, nx, 1, nx,  nx, nx, 1)
#endif
      
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__CHECK_LINEAR_DEPENDENCY
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDROWS,DDCOLS,
     +                      ROW,COL,
     +                      X,S,
     +
     +                              DEPEND )
     +
C-----------------------------------------------------------------------
C  OPERATION   : NLO__CHECK_LINEAR_DEPENDENCY
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine checks, if a system of COL columns
C                is linearly dependent or not. The routine simply
C                calculates the overlap matrix S between these
C                columns and attempts a Cholesky decomposition on
C                S. Any linear dependency will show up as a very
C                small (near zero) diagonal element during the
C                Cholesky decomposition. As soon as the routine
C                encounters such a situation we exit with the
C                linear dependency indicator DEPEND set true.
C
C                The Cholesky decomposition is performed in place,
C                that is the originally calculated overlap matrix S
C                will be destroyed. The column matrix X is conserved.
C
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DEPEND

         INTEGER     DDROWX,DDCOLX,DDROWS,DDCOLS
         INTEGER     I,J,K
         INTEGER     ROW,COL

         DOUBLE PRECISION   ROOT
         DOUBLE PRECISION   SQRARG
         DOUBLE PRECISION   SUM
         DOUBLE PRECISION   VSMALL
         DOUBLE PRECISION   ZERO

         DOUBLE PRECISION  X (1:DDROWX,1:DDCOLX)
         DOUBLE PRECISION  S (1:DDROWS,1:DDCOLS)

         DATA   ZERO      /0.D0/
         DATA   VSMALL    /1.D-8/
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions of X and S matrices supplied.
C
C
         IF (ROW.GT.DDROWX .OR. COL.GT.DDCOLX) THEN
             WRITE (*,*) ' Dimensions of matrix X too small! '
             WRITE (*,*) ' nlo__check_linear_dependency '
             WRITE (*,*) ' DDROWX,DDCOLX,ROW,COL = ',
     +                     DDROWX,DDCOLX,ROW,COL
             WRITE (1,*) ' Dimensions of matrix X too small! '
             WRITE (1,*) ' nlo__check_linear_dependency '
             WRITE (1,*) ' DDROWX,DDCOLX,ROW,COL = ',
     +                     DDROWX,DDCOLX,ROW,COL
             STOP
         END IF

         IF (COL.GT.DDROWS .OR. COL.GT.DDCOLS) THEN
             WRITE (*,*) ' Dimensions of matrix S too small! '
             WRITE (*,*) ' nlo__check_linear_dependency '
             WRITE (*,*) ' DDROWS,DDCOLS,COL = ',DDROWS,DDCOLS,COL
             WRITE (1,*) ' Dimensions of matrix S too small! '
             WRITE (1,*) ' nlo__check_linear_dependency '
             WRITE (1,*) ' DDROWS,DDCOLS,COL = ',DDROWS,DDCOLS,COL
             STOP
         END IF
C
C
C             ...calculate lower triangle of overlap matrix.
C
C
         DO 100 J = 1,COL
         DO 100 I = J,COL
            SUM = ZERO
            DO 110 K = 1,ROW
               SUM = SUM + X (K,I) * X (K,J)
  110       CONTINUE
            S (I,J) = SUM
  100    CONTINUE
C
C
C             ...do the Cholesky decomposition on S.
C
C
         DEPEND = .FALSE.

         IF (S (1,1).LE.VSMALL) THEN
             DEPEND = .TRUE.
             RETURN
         END IF

         ROOT  =  DSQRT ( S (1,1) )
         S (1,1)  =  ROOT

         DO 200 I = 2,COL
            S (I,1)  =  S (I,1) / ROOT
  200    CONTINUE

         DO 210 J = 2,COL

            SQRARG  =  S (J,J)
            DO 220  K = 1,J-1
               SQRARG  =  SQRARG  -  S (J,K) ** 2
  220       CONTINUE

            IF (SQRARG.LE.VSMALL) THEN
                DEPEND = .TRUE.
                RETURN
            END IF

            ROOT  =  DSQRT (SQRARG)
            S (J,J)  =  ROOT

            DO 230 I = J+1,COL
               SUM  =  S (I,J)
               DO 240 K = 1,J-1
                  SUM  =  SUM  -  S (I,K) * S (J,K)
  240          CONTINUE
               S (I,J)  =  SUM / ROOT
  230       CONTINUE

  210    CONTINUE
C
C
C             ...finished!
C
C
         RETURN
         END

c This routine flushes any memory-resident list pointed to by quikget.
c The operation is also called a "write-back". This routine DOES NOT zero
c (destroy) the contents of quikget since doing so would perpetuate sloppy
c programming by losing the memory pointers.

      subroutine aces_auxcache_flush
      implicit none

c EXTERNAL FUNCTIONS
      integer aces_list_cols

c INTERNAL VARIABLES
      integer iFam, iGrp, iNdx, nCols

c COMMON BLOCKS
#include "icore.com" /* for icore */
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

c   o write out any in-core list
      do iFam = 1, _MAX_IO_FAMS
      do iGrp = 1, _MAX_IO_GRPS
         if (quikget(iGrp,iFam).ne.0) then
            iNdx  = quikget(iGrp,iFam)
            nCols = aces_list_cols(iGrp,iFam)
            quikget(iGrp,iFam) = 0
            call putlst(icore(iNdx),1,nCols,1,iGrp,iFam)
            quikget(iGrp,iFam) = iNdx
         end if
      end do
      end do

      return
c     end subroutine aces_auxcache_flush
      end

c This routine flushes any memory-resident list pointed to by quikget.
c The operation is also called a "write-back". This routine DOES NOT zero
c (destroy) the contents of quikget since doing so would perpetuate sloppy
c programming by losing the memory pointers.

      subroutine aces_auxcache_flush
      implicit none

c EXTERNAL FUNCTIONS
      integer aces_list_cols

c INTERNAL VARIABLES
      integer iFam, iGrp, iNdx, nCols

c COMMON BLOCKS


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end








c auxcache.com : begin

c The auxiliary cache is a programmer-controlled list cache. The dimensions are
c the same as those of the MOIO arrays. The programmer may load lists into icore
c memory and set quikget(?,?) to their icore addresses. When getlst and putlst
c operate on ANY list, quikget is checked to see if the list lives in icore.
c If so, the operation is performed on the in-core data instead of hitting the
c storage file(s).

c WARNING
c    There is no automatic updating of storage files with data in the auxiliary
c cache. If the memory-resident data is altered and must be stored to disk, then
c the quikget value must be destroyed (zeroed) and the actual location of the
c data must then be passed to putlst. The aces_auxcache_flush routine
c systematically stores the quikget values, calls putlst, and restores the
c quikget values.





      integer           quikget(10,500)
      common /auxcache/ quikget
      save   /auxcache/

c auxcache.com : end

c ----------------------------------------------------------------------

c   o write out any in-core list
      do iFam = 1, 500
      do iGrp = 1, 10
         if (quikget(iGrp,iFam).ne.0) then
            iNdx  = quikget(iGrp,iFam)
            nCols = aces_list_cols(iGrp,iFam)
            quikget(iGrp,iFam) = 0
            call putlst(icore(iNdx),1,nCols,1,iGrp,iFam)
            quikget(iGrp,iFam) = iNdx
         end if
      end do
      end do

      return
c     end subroutine aces_auxcache_flush
      end

      subroutine molden_nlorb(ener,iocc,orb,dens,nlorb,edens,scr,
     &                        nao,nbas,maxcor,iuhf,iexx,iunit,
     +                        DLABEL,iroot,dens_diff)
c-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      double precision ener(nbas),orb(nao,nbas),scr(maxcor)
      double precision dens(nbas,nbas),edens(nbas,nbas),nlorb(nbas,nbas)
      double precision nelec
      logical  dens_diff
      character*8 DLABEL
      character*2 iroot
      character*8 cscfener(2)
      character*8 cscforb(2)
      character*8 cexxcoef(2)
      character*8 cnumdrop(2)
      character*5 sptype(2)
      double precision  iocc(nbas)
      integer  idrppop(8),idrpvrt(8)



c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c info.com : begin
      integer       nocco(2), nvrto(2)
      common /info/ nocco,    nvrto
c info.com : end
c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end
c sym.com : begin
      integer      pop(8,2), vrt(8,2), nt(2), nfmi(2), nfea(2)
      common /sym/ pop,      vrt,      nt,    nfmi,    nfea
c sym.com : end
      parameter (one=1.0D0)
      parameter (zilch=0.0D0)
      parameter (DENS_THRESH=1.0D-08)
      data cscfener /'SCFEVLA0','SCFEVLB0'/
      data cscforb  /'SCFEVCA0','SCFEVCB0'/
      data cexxcoef /'EXXCOEFA','EXXCOEFB'/
      data cnumdrop /'NUMDROPA','NUMDROPB'/  
      data sptype   /'Alpha','Beta '/
      call aces_com_info
      call aces_com_syminf
      call aces_com_sym
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c the mo ordering is important for getting the occupations right
c
c depending on the place in the program (if the user is not using xaces2)
c it may be either scf or correlated
c
c    so            mo                        mo
c ao CMP2ZMAT   so cscforb(ispin)    =    ao AOBASMOS
c
c the so ordering is zmat
c the mo ordering is correlated if calc is greater than scf 
c or if this is a vibrational calculation
c
      i000=1
      i010=i000+nbas*nbas
      i020=i010+nbas*nbas
      i030=i020+nbas*nbas
      iend=i030+2*nbas*nbas

      if(i030.gt.maxcor/iintfp)
     &  call insmem('NLORB-F',iend*iintfp,maxcor)

      do 10 ispin=1,iuhf+1
C
C Watson
C   Grab the AO density and transform to MO basis
C
        call getrec(20,'JOBARC','SCFEVCA0',nbas*nbas*iintfp,scr(i000))
        call getrec(20,'JOBARC','AOOVRLAP',nbas*nbas*iintfp,scr(i010))

        CALL XGEMM('N','N',nbas,nbas,nbas,
     +                     1.0D0,SCR(I010),  nbas,  ! Overlap
     +                           SCR(I000),  nbas,  ! Coeff
     +                     0.0D0,SCR(I020),  nbas ) ! SC

        CALL XGEMM('T','N',nbas,nbas,nbas,
     +                     1.0D0,SCR(I000),  nbas,  ! Ct
     +                           SCR(I020),  nbas,  ! SC
     +                     0.0D0,DENS     ,  nbas ) ! Ct SC

C        CALL OUTPUT(DENS,1,NBAS,1,NBAS,NBAS,NBAS,1) ! = 1

        call getrec(20,'JOBARC',DLABEL,nbas*nbas*iintfp,dens)

        if (dens_diff) then
          call getrec(20,'JOBARC','EXCDEN'//iroot,
     +                       nbas*nbas*iintfp,edens)

          DO i = 1, nbas
          DO j = 1, nbas
             dens (i,j) = edens (i,j) - dens (i,j)
          ENDDO
          ENDDO
        endif

        CALL  DCOPY (NBAS*NBAS,DENS,1,SCR(I000),1)

        CALL XGEMM('N','N',nbas,nbas,nbas,
     +                     1.0D0,SCR(I000),  nbas,
     +                           SCR(I010),  nbas,
     +                     0.0D0,SCR(I020),  nbas )

        CALL XGEMM('N','N',nbas,nbas,nbas,
     +                     1.0D0,SCR(I010),  nbas,
     +                           SCR(I020),  nbas,
     +                     0.0D0,SCR(I000),  nbas )

        CALL  DCOPY (NBAS*NBAS,SCR(I000),1,DENS,1)

        call ao2mo2(scr(i000),dens,nlorb,scr(i030),nbas,nbas,ispin)

        DO imo = 1,NBAS
        DO jmo = 1,NBAS
           DVAL = DABS (DENS (imo,jmo))
           IF (DVAL .LT. DENS_THRESH) DENS (imo,jmo) = 0.0D0
        ENDDO
        ENDDO

        WRITE (*,*) ' CSDSC before eig! '
        CALL OUTPUT(DENS,1,NBAS,1,NBAS,NBAS,NBAS,1) ! = 1
C
C
C     Diagonalize MO basis density
C
C
        call zero(nlorb,NBAS*NBAS)
        WRITE (*,*) ' Nat. Orbs. MO x MO ! '
        call eig (dens,nlorb,ijunk,nbas,-1)
        CALL OUTPUT(nlorb,1,NBAS,1,NBAS,NBAS,NBAS,1) ! = 1
        call dcopy(nbas,dens,nbas+1,iocc,1)
        nelec = 0.0D0
        DO imo = 1, nbas
           nelec = nelec + iocc(imo)
        ENDDO
        WRITE (*,*) ' Trace of diagonalized MO density matrix - ',nelec

        call getrec(20,'JOBARC','SCFEVCA0',nbas*nbas*iintfp,dens)
        CALL XGEMM('N','N',nbas,nbas,nbas,
     +                     1.0D0,DENS,   nbas,
     +                           NLORB,  nbas,
     +                     0.0D0,SCR(I010),    nbas )

        WRITE (*,*) ' Nat. Orbs. AO x MO ! '
        CALL OUTPUT(SCR(I010),1,NBAS,1,NBAS,NBAS,NBAS,1) ! = 1


        call getrec(20,'JOBARC','CMP2ZMAT',nao*nbas*iintfp,scr(i000))
        WRITE (*,*) ' CMP2ZMAT ! '
        CALL OUTPUT(scr(i000),1,NAO,1,NBAS,NAO,NBAS,1) ! = 1
        call xgemm('n','n',nao,nbas,nbas,one,scr(i000),nao,scr(i010),
     &    nbas,zilch,orb,nao)


        WRITE (*,*) ' Nat. Orbs. NAOBFNS x MO ! '
        CALL OUTPUT(orb,1,NAO,1,NBAS,NAO,NBAS,1) ! = 1

        call getrec(-1,'JOBARC',cscfener,nbas*iintfp,ener)



        do 80 imo=1,nbas
          write(iunit,90)' Ene=   ',ener(imo)
90        format(A,F8.4)
          write(iunit,100)' Spin= ' // sptype(ispin)
100       format(A)
          write(iunit,110)'  Occup=   ',iocc(imo)
110       format(A,F12.6)
          do 120 iao=1,nao
            write(iunit,130)iao,'  ',orb(iao,imo)
130         format(I4,A,F12.6)
120       continue
80      continue 
10    continue
      return
      end

C SUBROUTINE FORMS X-X(transpose) AND RETURNS RESULT IN X.

      SUBROUTINE MMMT(X,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N,N)
c old
c      DO I = 1, N
c         DO J = 1, I
c            dtmp   = X(I,J) - X(J,I)
c            X(I,J) =  dtmp
c            X(J,I) = -dtmp
c         END DO
c      END DO
c new
      if (n.lt.1) return
      if (n.eq.1) then
         x(1,1) = 0.0d0
      else
         do j = 1, n
            do i = j, n
               x(i,j) = x(i,j) - x(j,i)
            end do
         end do
         do j = 1, n
            do i = 1, j
               x(i,j) = -x(j,i)
            end do
         end do
      end if
c end
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      double precision function ddot(n,dx,incx,dy,incy)

      double precision dx(*),dy(*),dsum
#ifdef ACES64
      integer*8 incx, incy, n
#else
      integer incx, incy, n
#endif

      if (n.le.0) return

      dsum = 0.d0
      do i = 1, n
         dsum = dsum + dx(1+(i-1)*incx) * dy(1+(i-1)*incy)
      enddo
 
      ddot = dsum
      return
      end

      SUBROUTINE KILLGAM
C
C THIS ROUTINE DISPENSES WITH THE GAMLAM FILE AND ZEROS OUT ALL OF
C  THE ASSOCIATED LIST POINTERS
C
CEND
      IMPLICIT INTEGER(A-Z)
      LOGICAL YESNO,ISOPEN
      CHARACTER*80 FNAME
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &              MOIODS(10,500),MOIOFL(10,500)
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
C
CJDW,AP  2/28/97. Add call to GFNAME so we can locate GAMLAM properly.
C                 This is important when GAMLAM is not in main working
C                 directory.
c     write(6,*) ' @killgam-i, executing modified killgam ! '
      CALL GFNAME('GAMLAM  ',FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO,OPENED=ISOPEN)
      IF(YESNO) THEN
      IF(.NOT.ISOPEN)OPEN(UNIT=51,FILE=FNAME(1:ILENGTH),STATUS='OLD')
      CLOSE(UNIT=51,STATUS='DELETE')
      CALL IZERO(MOIO(1,101),1000)
      CALL IZERO(MOIOWD(1,101),1000)
      CALL IZERO(MOIODS(1,101),1000)
      CALL IZERO(MOIOSZ(1,101),1000)
      CALL IZERO(MOIOFL(1,101),1000)
C 
      DO 10 I=1,100
       IF(CACHFILE(I).EQ.51)CACHFILE(I)=0
10    CONTINUE   
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      Subroutine DoSyOp (Type, Order, Count, Axis, NAtms, Q, NewQ, Err,
     &                   IMode)
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose: Perform the given symmetry transformation on Q
C
C Usage:
C     To do all of the symmetry operations of a given point group:
C     Call GrpOps (...)
C     Do Op = 1, NrOps
C        Do Count = 1, Max(1, Order(Op))
C           Call DoSyOp (Type(Op), Order(Op), Count,...)
C           Actions using NewQ
C        EndDo
C     EndDo
C
C Limitations:
C     Knows all proper & improper rotations, reflections using the
C     cartesian axes.  Knows inversion centers. CANNOT do rotations
C     and reflections which do not coincide with the cartesian axes.
C
C Arguments:
C     Type    Type of symmetry operation (input)
C     Order   Order of the axis (0 if not an axis) (input)
C     Count   Do the Count-th rotation defined by the op. (input)
C             Ignored if Type is not a rotation.
C     Axis    Cartesian axis/plane for rotation/reflection (input)
C     NAtms   Number of atoms - length of Q (input)
C     Q       Cartesian coordinates to be transformed (input)
C     NewQ    Resulting cartesian coordinates (output)
C     Err     Non-zero in case of any error (output)
C             = 1   Unknown operation specified.
C     IMode   = 0 for real Sn.
C              = 1 means that S_n^q is actually C_n followed by
C                a reflection.  Although this is really not what
C                a S_n^q is, it makes generation of symops easier.
C
C Internal Variables:
C     RMat    Rotational transformation matrix
C
C Dependents:
C     RotM    Make a rotation matrix for any rotation
C     MatMulV Matrix-vector multiply
C     Reflect Reflect coordinates through a plane
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C $Log: dosyop.f,v $
C Revision 1.4.14.1  2011/10/10 04:00:27  bhoj
C *** empty log message ***
C
C Revision 1.4  2010/10/07 14:33:58  ponton
C Add symcor changes, fix bugs in optimization code, change numerical lib calls to use proper routines
C
C Revision 1.2  2010/02/10 17:20:47  ponton
C Add GNU GPL info to each source file
C
C Revision 1.1.1.1  2009/07/01 18:54:34  ponton
C Initial import for ACESIII Release 3.0
C
C Revision 1.1.1.1  2003/04/02 19:21:35  aces
C INITIAL 2.4 IMPORT
C
C Revision 4.3  89/09/21  14:59:48  jstanton
C   Fixed bug in Sn operations where reflection was performed
C regardless of the operation "count".
C 
C Revision 4.2  89/08/19  13:42:13  jstanton
C Add missing declaration of array NewQ
C 
C Revision 4.1  89/05/15  11:01:05  jstanton
C Replaced ICCOD (bug!) with ICOORD.
C 
C Revision 4.0  89/03/14  01:15:28  bernhold
C Baseline for Sun & VAX prior to porting everywhere
C 
C Revision 3.0  89/01/29  23:09:43  bernhold
C First working release for VAX
C 
C Revision 1.1  89/01/28  12:07:35  bernhold
C Initial revision
C 
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Implicit double precision (A-H, O-Z)
      Character*1 Type
      Double Precision NewQ
      Double Precision ONE,ZILCH
      Integer Order, Count, Axis, Natms, Err
      Dimension Q(3*NAtms), NewQ(3*NAtms)
C
      Dimension RMat(3,3)
C
      DATA ONE,ZILCH /1.0D+00,0.0D+00/
C
C     Initialize things
C
      Err = 0
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     
C     Proper and improper rotations (C and S)
C     
      If (Type .eq. 'C' .OR. Type .eq. 'S') then
         Angle = Count*360.0/Order
         Call RotM (Axis, Angle, 1, RMat)
C
CJDW 1/6/98. MATMULV call replaced by XGEMM call. NewQ=(RMat)^T * Q.
C
C        Call MatMulV (NewQ, Q, RMat, NAtms, 3, 3)
C
         CALL XGEMM('T','N',3,NAtms,3,ONE,RMat,3,Q,3,ZILCH,NewQ,3)
C
         If (Type.eq.'S'.and.Mod(Count,2).eq.1.Or.Type.eq.'S'.
     &         and.IMode.eq.1)then
            Call Reflect (NewQ, NewQ, NAtms, Axis)
         EndIf
C     
C     Reflection planes
C     
      ElseIf (Type .eq. 'P') then
         Call Reflect (Q, NewQ, NAtms, Axis)
C     
C     Inversion
C     
      ElseIf (Type .eq. 'I') then
         Do 1200 icoord = 1, 3*NAtms
            NewQ(icoord) = - Q(icoord)
 1200    Continue
C     
C     Unknown operation - set Err & return
C     
      Else
         Err = 1
      EndIf
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine stores a record to the JOBARC file.

c INPUT
c int IFLAG : a behavior flag
c             == 0; nInts are flushed with zeroes (ignoring iSrc)
c             != 0; nInts are copied from iSrc
c char*(*) SZARCHIVE : the internal filename of the record archive
c                      NOTE: Currently this is unused because all the archive
c                            statistics relate to JOBARC alone; however, we
c                            could expand the functionality to name any
c                            arbitrary archive.
c char*(*) SZRECNAME : the name of the record to store
c int IRECLEN : the integer-length of the record to store
c int ISRC : the source array
c            NOTE: The record length is in units of integers regardless of
c                  the type of data actually stored in the record.

#include "jobarc.h" /* for _JA_RECWD */
c#define TRAP_PUTREC_LEAKS

      subroutine putrec(iFlag,szArchive,szRecName,iRecLen,iSrc)
      implicit none

c ARGUMENTS
      integer iFlag, iRecLen
      integer*8 iSrc(*)
      character*(*) szArchive, szRecName

c EXTERNAL FUNCTIONS
      integer iszeq

c INTERNAL VARIABLES
      character*80 szJOBARC
      integer       iJOBARC
      integer iRecNdx
      integer iRec, iBufNdx, iTmp
      integer iRec0, iRec1
      integer nLeft, nPut, iOff
      integer iStat, i
      integer*8 iBuf(_JA_RECWD)

c COMMON BLOCKS
#include "jobarc.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert job archive subsystem is up
      if (.not.bJAUp) then
         print *, '@PUTREC: Assertion failed.'
         print *, '   bJAUp = ',bJAUp
         iTmp = 1
      end if
c   o assert record length is >= 0
      if (iRecLen.lt.0) then
         print *, '@PUTREC: Assertion failed.'
         print *, '   iRecLen = ',iRecLen
         iTmp = 1
      end if
c   o the record name must be between 1 and 8 characters
      if ((len(szRecName).lt.1).or.(len(szRecName).gt.8)) then
         print *, '@PUTREC: Assertion failed.'
         print *, '   szRecName = ',szRecName
         iTmp = 1
      end if
c   o the record cannot be named 'OPENSLOT' or '. LOST .'
      if (len(szRecName).eq.8) then
      if (szRecName.eq.'OPENSLOT'.or.szRecName.eq.'. LOST .') then
         print *, '@PUTREC: Assertion failed.'
         print *, '   szRecName = ',szRecName
         iTmp = 1
      end if
      end if
      if (iTmp.ne.0) then
         print *, '   record name = "',szRecName,'"'
         call c_exit(iTmp)
      end if
#endif /* _ASSERT */

      if (iRecLen.lt.0) return

c ----------------------------------------------------------------------

c   o see if the record exists already
      iRecNdx = iszeq(_MAX_JA_RECS,marker,1,szRecName)

c   o accomodate unsafe programming that increases record lengths
      if (iRecNdx.gt.0) then
         if (iRecLen.gt.rsize(iRecNdx)) then
            print *, '@PUTREC: "',szRecName,'" record length ',
     &               'mismatch'
            print *, '         requested length = ',iRecLen
            print *, '         stored    length = ',rsize(iRecNdx)
#ifdef TRAP_PUTREC_LEAKS
            call c_exit(1)
#endif
            print *, '!WARNING! LOSING DISK SPACE WHILE WRITING ',
     &               'LARGER RECORD'
            marker(iRecNdx) = '. LOST .'
            iRecNdx = 0
         end if
      end if

c   o It is possible to recover some lost disk space by first searching
c     for any ". LOST ." record that is larger than the new record. The
c     two concepts to keep in mind are 1) stepping through marker(:)
c     since multiple records could be lost and 2) not updating rsize().

      if (iRecNdx.eq.0) then
c      o the record is not found, so find an open slot
         iRecNdx = iszeq(_MAX_JA_RECS,marker,1,'OPENSLOT')
         if (iRecNdx.eq.0) then
c         o complain and die since there are no open slots left
            print *, '@PUTREC: maximum number of JOBARC records ',
     &               'exceeded while attempting to write'
            print *, '         record "',szRecName,'"'
            call c_exit(1)
         end if
c      o update the statistics for this new record
         marker(iRecNdx) = szRecName
         if (iRecNdx.ne.1) rloc(iRecNdx) =   rloc(iRecNdx-1)
     &                                     + rsize(iRecNdx-1)
         if (2.le.iRecLen.and.iRecLen.le.irecwd) then
c         o make sure the logical record is on one physical record
            iRec0 = 1 + (rloc(iRecNdx)-1)/irecwd
            iTmp  = rloc(iRecNdx)+iRecLen-1
            iRec1 = 1 + (iTmp-1)/irecwd
            if (iRec0.ne.iRec1) then
               iTmp = 1 + (iRec1-1)*irecwd
c               print *, '@PUTREC: Fragmenting JOBARC'
c               print *, '         ',rloc(iRecNdx),
c     &                  ' -> ',iTmp,
c     &                  ' for ',iRecLen,' ints (wasting',
c     &                  1.d2*(iTmp-rloc(iRecNdx))/(iTmp+iRecLen-1),'%)'
               rloc(iRecNdx) = iTmp
            end if
         end if
         rsize(iRecNdx) = iRecLen
      end if
      if (iRecLen.eq.0) then
         bJAMod = .true.
         return
      end if

c   o find the first physical record and integer index that point to
c     the first element
      iBufNdx = rloc(iRecNdx)
      iTmp    = (iBufNdx-1)/irecwd
      iRec    = 1       + iTmp
      iBufNdx = iBufNdx - iTmp*irecwd

#ifdef OPEN_JOBARC_AS_NEEDED
c   o open the JOBARC file
      call gfname('JOBARC',szJOBARC,iJOBARC)
      open(unit=_JA_UNIT,file=szJOBARC(1:iJOBARC),
     &     form='UNFORMATTED',access='DIRECT',
     &     status='OLD',recl=irecln,err=666,iostat=iStat)
#endif

c   o read/copy/write the record
      if (iRec.le.nrecs) then
         read(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
      end if
      if (iRecLen.eq.1) then
         if (iFlag.ne.0) then
            iBuf(iBufNdx) = iSrc(1)
         else
            iBuf(iBufNdx) = 0
         end if
         write(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
         nrecs = max(nrecs,iRec)
      else
         nLeft = iRecLen
         nPut  = min(nLeft,irecwd+1-iBufNdx)
         if (iFlag.ne.0) then
c            call icopy(nPut,iSrc,1,iBuf(iBufNdx),1)
            do i = 1, nPut
               iBuf(iBufNdx+i-1) = iSrc(i)
            enddo 
         else
            do i = 0, nPut-1
               iBuf(iBufNdx+i) = 0
            end do
         end if
         write(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
         nrecs = max(nrecs,iRec)
         iOff  = 1     + nPut
         nLeft = nLeft - nPut
         do while (nLeft.ne.0)
            nPut = min(nLeft,irecwd)
            iRec = iRec + 1
            if (iRec.le.nrecs) then
               read(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
            end if
            if (iFlag.ne.0) then
c               call icopy(nPut,iSrc(iOff),1,iBuf,1)
               do i = 1, nPut
                  iBuf(i) = iSrc(iOff+i-1)
               enddo
            else
               do i = 1, nPut
                  iBuf(i) = 0
               end do
            end if
            write(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
            nrecs = max(nrecs,iRec)
            iOff  = iOff  + nPut
            nLeft = nLeft - nPut
         end do
      end if

#ifdef OPEN_JOBARC_AS_NEEDED
c   o close the JOBARC file
      close(unit=_JA_UNIT,status='KEEP',err=666,iostat=iStat)
#endif

c   o mark JOBARC as modified
      bJAMod = .true.

      return

c   o JOBARC I/O error
 666  print *, '@PUTREC: I/O error on JOBARC'
      print *, '         record name = "',szRecName,'"'
      print '(/)'
c      call aces_io_error('PUTREC',_JA_UNIT,iStat)
      call abort_job()

c     end subroutine putrec
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__CHECK_NHO_X_CENTERS
     +
     +                    ( NHCEN,
     +                      NBOSIZE,
     +                      MXNHBA,MXNBA,
     +                      ATHIDX,ATNHB,ATHVAL,ATHOFF,
     +                      RYD2HYB,
     +                      NHB,NHA,
     +                      WBOND,WSTAR,
     +                      SAH,
     +                      PH,PHSUB,
     +                      INDEX,USED,DEPLET,
     +                      OVLAVG,
     +                      XVEC,XMAT,
     +
     +                              FAILED,
     +                              NBOND,
     +                              NHYB,
     +                              BDNCEN,
     +                              BDCEN,
     +                              BDNBAS,
     +                              BDBAS,
     +                              BDOCC,
     +                              W,H,
     +                              PHDEP )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__CHECK_NHO_X_CENTERS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine checks, if bond forming pre-NHO orbitals
C                can be constructed from the present hybrid occupation
C                matrix PH spreading over fixed NHCEN atomic hybrid
C                centers.
C
C                Procedure (rough sketch, more details in code below):
C
C                    i) Set up submatrix PHSUB of PH by taking
C                       appropriate subblocks of PH matrix
C                       corresponding to the fixed NHCEN atomic
C                       hybrid centers combination.
C
C                   ii) Diagonalize PHSUB and consider those
C                       eigenfunctions which have eigenvalues
C                       > WBOND.
C
C                  iii) For each such eigenfunction find the NHCEN-1
C                       partner eigenfunction as those having maximum
C                       average atomic overlap and check if they
C                       correspond to eigenvalues > WBOND or < WSTAR.
C                       If such a partner set can be found for
C                       the original eigenfunction, accept this
C                       eigenfunction for atomic pre-NHO decomposition
C                       (splitting of eigenfunction into the individual
C                       normalized Hybrid NAO components for each atom
C                       to define the pre-NHOs).
C
C                   iv) Deplete PHSUB from all eigenvalues > WBOND
C                       corresponding to the eigenfunctions + their
C                       partners found in steps ii) and iii) used
C                       for NHO decomposition.
C
C                    v) Replace PHSUB section of PH by the depleted
C                       PHSUB matrix, if depletion was performed at all.
C
C
C                  Input:
C
C                    NHCEN        =  # of atomic hybrid centers to be
C                                    checked for bond construction.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    MXNHBA       =  maximum # of Hybrid NAOs per atom.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    ATHIDX (I)   =  atomic label (index) for I-th
C                                    atomic hybrid center out of the
C                                    NHCEN atomic centers entering a
C                                    NHCEN centered bond construction.
C                    ATNHB (A)    =  # of Hybrid NAOs on hybrid atom A.
C                    ATHVAL (A)   =  # of Valence NAOs on hybrid atom A.
C                    ATHOFF (A)   =  index offset for Hybrid NAOs for
C                                    hybrid atom A. This index is equal
C                                    to the total number of Hybrid NAOs
C                                    on all hybrid atoms preceeding
C                                    hybrid atom A.
C                    RYD2HYB      =  is true, if the Rydberg NAO space
C                                    should be included next to the
C                                    Valence NAO space for natural 
C                                    hybrid orbital (NHO) construction.
C                                    If false, only the Valence NAO
C                                    space will be used.
C                    NHB          =  total # of Hybrid NAOs.
C                    NHA          =  total # of hybrid atoms.
C                    WBOND        =  lowest weight above which a
C                                    NHCEN-centered bond formation
C                                    is accepted.
C                    WSTAR        =  highest weight below which a
C                                    NHCEN-centered antibond formation
C                                    is accepted.
C                    SAH          =  will contain the atomic hybrid
C                                    overlap matrices between pre-NHOs.
C                    PH           =  current (possibly frequently large
C                                    eigenvalue depleted) NHB x NHB
C                                    hybrid occupation matrix.
C                    PHSUB        =  will contain the submatrix of
C                                    the occupation matrix PH
C                                    corresponding to a specific
C                                    NHCEN atomic hybrid center
C                                    combination.
C                    INDEX (I)    =  index for ordering the average
C                                    atomic overlap values.
C                    USED (I)     =  indicator for which eigenfunctions
C                                    have been used during the PHSUB
C                                    eigenfunctions analysis.
C                    DEPLET (I)   =  index for which eigenfunctions
C                                    of the PHSUB matrix have to be
C                                    used for depletion from the PHSUB
C                                    matrix.
C                    OVLAVG (I)   =  will contain the average atomic
C                                    overlap values.
C                    XVEC         =  flp scratch array of vector type
C                    XMAT         =  flp scratch array of matrix type
C
C
C                  Output:
C
C                    FAILED       =  is true, if any problems were
C                                    found such that the present
C                                    and subordinate routines cannot
C                                    proceed.
C                    NBOND        =  current total # of bonds.
C                    NHYB (A)     =  current total # of pre-NHOs on
C                                    each hybrid atom A.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                    BDCEN (I,J)  =  I-th atomic center index for
C                                    J-th bond.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    J-th bond.
C                    BDBAS (I,J)  =  I-th global basis (NHO) index for
C                                    J-th bond.
C                    BDOCC (J)    =  # of occupied levels for J-th bond.
C                    W            =  pre-NHO weight vector to accumulate
C                                    the weights for WSW procedure.
C                    H (I,J)      =  MXNBA x NHB matrix containing the
C                                    current found set of pre-NHOs for
C                                    each hybrid atom. I is the local
C                                    atomic index labeling the atomic
C                                    hybrid NAOs from which the NHOs are
C                                    constructed. J is the global NHO
C                                    index running over all NHB space
C                                    pre-NHOs in that order, with all
C                                    pre-NHOs belonging to a specific
C                                    atomic center being grouped
C                                    together.
C                    PHDEP        =  used for accumulation of the 
C                                    depleted occupation matrix PH.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ABSOLUT
         LOGICAL     DEPEND
         LOGICAL     EXTRACT
         LOGICAL     FAILED
         LOGICAL     INCRESE
         LOGICAL     LTRG
         LOGICAL     REVERS
         LOGICAL     RYD2HYB

         INTEGER     ATOM
         INTEGER     I,J,K,L,M,N
         INTEGER     MLARGE
         INTEGER     MXNHBA,MXNBA
         INTEGER     NBOND
         INTEGER     NBOSIZE
         INTEGER     NCOUNT
         INTEGER     NDEP,NPAR
         INTEGER     NHOIDX
         INTEGER     NHYBA
         INTEGER     NHB,NHBA,NHA
         INTEGER     NHCEN
         INTEGER     NITER
         INTEGER     NVAL
         INTEGER     OFF
         INTEGER     ROWX

         INTEGER     ATHIDX  (1:NHCEN)
         INTEGER     ATNHB   (1:NHA  )
         INTEGER     ATHOFF  (1:NHA  )
         INTEGER     ATHVAL  (1:NHA  )
         INTEGER     BDNBAS  (1:NHB  )
         INTEGER     BDNCEN  (1:NHB  )
         INTEGER     BDOCC   (1:NHB  )
         INTEGER     DEPLET  (1:NHCEN)
         INTEGER     INDEX   (1:NHB  )
         INTEGER     NHYB    (1:NHA  )
         INTEGER     USED    (1:NHB  )

         INTEGER     BDBAS   (1:NBOSIZE,1:NHB)
         INTEGER     BDCEN   (1:NBOSIZE,1:NHB)

         DOUBLE PRECISION  DENOM
         DOUBLE PRECISION  E,F
         DOUBLE PRECISION  EFRAC
         DOUBLE PRECISION  NORM
         DOUBLE PRECISION  OVLSUM
         DOUBLE PRECISION  SJJ,SKJ,SKK
         DOUBLE PRECISION  VALSQR,VALTOL
         DOUBLE PRECISION  WBOND,WSTAR,WHIGH
         DOUBLE PRECISION  XJ,XK
         DOUBLE PRECISION  ZERO,ONE,TWO,TINY

         DOUBLE PRECISION  OVLAVG (1:NHB)
         DOUBLE PRECISION  W      (1:NHB)
         DOUBLE PRECISION  XVEC   (1:NHB)

         DOUBLE PRECISION  H      (1:MXNBA ,1:NHB   )
         DOUBLE PRECISION  PH     (1:NHB   ,1:NHB   )
         DOUBLE PRECISION  PHDEP  (1:NHB   ,1:NHB   )
         DOUBLE PRECISION  PHSUB  (1:NHB   ,1:NHB   )
         DOUBLE PRECISION  SAH    (1:MXNHBA,1:MXNHBA)
         DOUBLE PRECISION  XMAT   (1:NHB   ,1:NHB   )

         DATA  ONE      /1.D0/
         DATA  TWO      /2.D0/
         DATA  ZERO     /0.D0/
         DATA  EFRAC    /1.D-6/
         DATA  TINY     /1.D-10/
         DATA  VALTOL   /0.5D0/
         DATA  REVERS   /.TRUE./
C
C
C------------------------------------------------------------------------
C
C
C             ...extract lower triangle of PHSUB matrix from PH matrix.
C
C
         WRITE (1,*) ' Atomic Centers = ',(ATHIDX(I),I=1,NHCEN)

         LTRG = .TRUE.
         FAILED = .FALSE.
         EXTRACT = .TRUE.

         CALL  NLO__HANDLE_MATRIX_SECTIONS
     +
     +              ( NHB,NHB,
     +                NHB,NHB,
     +                NHA,NHCEN,
     +                NHCEN,
     +                ATHIDX,ATNHB,ATHOFF,
     +                EXTRACT,
     +                LTRG,
     +                PH,
     +
     +                        M,
     +                        PHSUB )
     +
     +
C         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
C     +
C     +                ( 1,
C     +                  ' PHSUB matrix ',
C     +                  NHB,NHB,
C     +                  M,0,
C     +                  PHSUB )
C     +
C     +
C
C
C             ...if the Rydberg space has been added to the Valence
C                space for the pre-NHO construction and the number
C                of centers > 2, there is a danger of accidental
C                degeneracies present in the PHSUB matrix, which
C                will result in a mixing of eigenvectors belonging
C                to different symmetry species. The presence of the
C                Rydberg space can lower the eigenvalues of the
C                highest occupied states to almost exactly = 2 even
C                if they belong to different symmetries. A way out
C                of this is to remove a tiny fraction of an electron
C                on the diagonal elements which are highest in
C                absolute value for each atom. That way one introduces
C                a negligible negative shift on these eigenvalues
C                removing the accidental degeneracy.
C
C                The idea is based on including a controlled
C                perturbation on the eigenvalues of PHSUB. The key
C                result is Eq.(44.10) of Wilkinsons book "The
C                Algebraic Eigenvalue Problem", Oxford 1965, which
C                states that when a matrix B (not necessarily small)
C                is added to matrix A as a perturbation, then the
C                eigenvalues of A are changed by an amount which
C                lies between the smallest and greatest of the
C                eigenvalues of B. In our case we know the exact
C                eigenvalues of the pertrubation matrix B, since
C                we define it to be diagonal with zeroes or very
C                small negative numbers -X. Hence if the original
C                eigenvalues of PHSUB are denoted by p(i) and the
C                perturbed ones by p'(i), we then have:
C
C
C                        p(i)-|X(max)| =< p'(i) =< p(i)
C
C
C                The fraction of electron to be removed on each
C                atomic center should be large enough to remove
C                the degeneracy but small enough such that it will
C                not affect further searches for atomic NHOs. Since
C                each atomic center can have only a very limited
C                number of bond forming NHOs, applying the perturbation
C                a couple of times to the overall PH matrix will
C                result in a removal of several tiny fractions of
C                electrons from the PH matrix at each atomic center.
C                An electron fraction of 1.D-6 is an appropriate
C                value for this purpose.
C
C
C
         IF (RYD2HYB .AND. NHCEN.GT.2) THEN

             DO N = 1,NHCEN
                ATOM = ATHIDX (N)
                INDEX (N) = ATNHB (ATOM)
             END DO

             CALL  NLO__PERTURB_OCCUPATION_MATRIX
     +
     +                  ( NHB,NHB,
     +                    M,NHCEN,
     +                    INDEX,
     +                    EFRAC,
     +                    USED,XVEC,
     +
     +                             PHSUB )
     +
     +
         END IF
C
C
C             ...diagonalize PHSUB matrix.
C
C
         CALL  NLO__SYMMETRIC_JACOBI
     +
     +              ( NHB,NHB,
     +                NHB,NHB,
     +                NHB,
     +                M,
     +                1,M,
     +                REVERS,
     +                USED,
     +                PHSUB,
     +
     +                         NITER,
     +                         XVEC,
     +                         XMAT )
     +
     +
C         CALL  MAT__C_EQ_A_FLOAT
C     +
C     +              ( NHB,NHB,
C     +                NHB,NHB,
C     +                M,M,
C     +                PHSUB,
C     +
C     +                        XMAT )
C     +
C     +
C         CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
C     +
C     +              ( NHB,NHB,NHB,
C     +                M,
C     +                REVERS,
C     +
C     +                        XVEC,
C     +                        XMAT )
C     +
C     +
C
C
C             ...we now identify those eigenfunctions, which have
C                eigenvalues > WBOND. Let us take the first such
C                eigenfunction Psi (1). Since it is formaly an
C                expansion over one NHO at each atomic center,
C                we can write:
C
C                        Psi (1) = sum  c (i) NHO (i)
C                                   i
C
C                where i runs over all NHCEN atomic centers. Psi (1)
C                has now (NHCEN - 1) partner functions:
C
C
C                        Psi' (x) = sum  c' (i) NHO' (i)
C                                    i
C
C                which however do not have the exact structure of
C                the NHOs as for Psi (1), that is:
C
C                        NHO' (i) = only approximately NHO (i)
C
C                The goal is thus to identify which eigenfunctions
C                of the whole set obey this NHO approximation to
C                a maximum extent. For this, we look at the NHCEN
C                atomic overlaps of each normalized (to eliminate the
C                c(i) and c'(i) dependence!) atomic NHO and NHO'
C                for any pair of eigenfunctions Psi (1) and Psi (x),
C                where x runs over all the eigenfunctions different
C                from Psi (1) and determine the average over all the
C                atomic overlaps. As a result we will obtain a set of
C                x average atomic overlaps for each Psi (1)/Psi (x)
C                pair. The (NHCEN - 1) eigenfunctions Psi (x)
C                corresponding to the largest average atomic overlaps
C                are then identified as the (NHCEN - 1) partner
C                functions of Psi (1).
C
C                All partners of Psi (1) correspond to (NHCEN - 1)
C                eigenvalues, which, for Psi (1) to be accepted
C                for NHO decomposition, should either be > WBOND
C                or < WSTAR. If any eigenvalue of the partners is found
C                to ly outside that range, we discard Psi (1) for NHO
C                decomposition and look at the next remaining unused
C                Psi (2) in the set of eigenfunctions with eigenvalues
C                > WBOND.
C                
C                First, select the high weight space of eigenfunctions
C                with eigenvalues > WBOND.
C
C
C
         MLARGE = 0
         DO J = 1,M
            IF (XVEC (J) .GT. WBOND) THEN
                MLARGE = MLARGE + 1
            END IF
         END DO
C
C
C             ...before we start checking the high weight eigenfunctions
C                for their partners in case of NHCEN > 1, we must be
C                sure that we order them in such a way that those
C                which will be checked for NHO decomposition have
C                actually all c(i) expansion coefficients nonzero.
C                Otherwise we might run into the problem of
C                generating a zero pre-NHO on an atomic site, which
C                is unacceptable. Since we start checking the
C                eigenfunctions for NHO decomposition from the first
C                one on, it is sufficient to order (if necessary)
C                them in such a way that those high weight
C                eigenfunctions with all their c(i) nonzero come
C                first. This is checked by forming the sum of squares
C                of the atomic valence part expansion coefficients
C                for each eigenfunction and moving the latter if
C                necessary.
C
C
         IF (NHCEN.GT.1) THEN

             DO J = 1,MLARGE
                ROWX = 0
                OVLSUM = ONE
                DO N = 1,NHCEN
                   ATOM = ATHIDX (N)
                   NHBA = ATNHB (ATOM)
                   NVAL = ATHVAL (ATOM)

                   SJJ = ZERO
                   DO I = 1,NVAL
                      XJ = XMAT (ROWX+I,J)
                      SJJ = SJJ + XJ * XJ
                   END DO
                   OVLSUM = DMIN1 (OVLSUM,SJJ)
                   ROWX = ROWX + NHBA
                END DO
                OVLAVG (J) = OVLSUM
             END DO

             ABSOLUT = .FALSE.
             INCRESE = .FALSE.

             CALL  NLO__SORT_FLP_VECTOR_ELEMENTS
     +
     +                  ( MLARGE,MLARGE,
     +                    1,MLARGE,
     +                    ABSOLUT,INCRESE,
     +                    0,
     +                    OVLAVG,
     +
     +                             USED )
     +
     +
             DO J = 1,MLARGE
                INDEX (USED (J)) = J
             END DO

             CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +                  ( NHB,NHB,
     +                    NHB,
     +                    NHB,
     +                    NHB,
     +                    M,MLARGE,
     +                    INDEX,
     +                    USED,
     +                    OVLAVG,
     +
     +                             XMAT )
     +
     +
             CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +                  ( NHB,
     +                    NHB,
     +                    NHB,
     +                    MLARGE,
     +                    INDEX,
     +                    OVLAVG,
     +
     +                             XVEC )
     +
     +
             CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
     +
     +                    ( 1,
     +                      ' Eigenvalues of PHSUB matrix ',
     +                      NHB,
     +                      M,
     +                      XVEC )
     +
     +
C             CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
C     +
C     +                    ( 1,
C     +                      ' Eigenfunctions of PHSUB matrix ',
C     +                      NHB,NHB,
C     +                      M,M,
C     +                      XMAT )
C     +
C     +
         END IF
C
C
C             ...loop over the high weight space eigenfunctions.
C
C
         DO J = 1,MLARGE
            USED (J) = 0
         END DO

         ABSOLUT = .FALSE.
         INCRESE = .FALSE.

         DO 1000 J = 1,MLARGE

            WHIGH = XVEC (J)
            IF (USED (J).EQ.0) THEN

                NDEP = 1
                DEPLET (1) = J
C
C
C             ...if the number of atomic centers is > 1, determine
C                all average valence atomic overlaps between the
C                current eigenfunction J and all the others.
C                Note, that if an atomic overlap is found to be
C                very small, this is an indication that one of the
C                corresponding c's in the expansion:
C
C
C                            Psi = sum  c (i) NHO (i)
C                                   i
C
C                is nearly equal to zero. In such a case we do
C                not include the corresponding atomic overlap in
C                the determination of the average.
C
C                The atomic overlaps will be determined for the
C                atomic Valence space only, as the Rydberg space
C                (if present) has only complimentary character
C                (i.e. small expansion coefficients) for the
C                partner functions of interest. Hence an eigenfunction
C                will be rejected for atomic overlap determination,
C                if its Valence expansion coefficient squares sum
C                up to less than a Valence tolerance value VALTOL.
C                These kind of eigenfunctions are dominated by the
C                Rydberg space and not of interest for partner search.
C
C
                IF (NHCEN.GT.1) THEN

                    DO K = 1,M
                       OVLAVG (K) = ZERO
                       IF (K.NE.J) THEN

                           ROWX = 0
                           VALSQR = ZERO
                           DO N = 1,NHCEN
                              ATOM = ATHIDX (N)
                              NHBA = ATNHB (ATOM)
                              NVAL = ATHVAL (ATOM)
                              DO I = 1,NVAL
                                 XK = XMAT (ROWX+I,K)
                                 VALSQR = VALSQR + XK * XK
                              END DO
                              ROWX = ROWX + NHBA
                           END DO

                           IF (VALSQR.GT.VALTOL) THEN
                               ROWX = 0
                               NCOUNT = 0
                               OVLSUM = ZERO
                               DO N = 1,NHCEN
                                  ATOM = ATHIDX (N)
                                  NHBA = ATNHB (ATOM)
                                  NVAL = ATHVAL (ATOM)

                                  SJJ = ZERO
                                  SKJ = ZERO
                                  SKK = ZERO
                                  DO I = 1,NVAL
                                     XJ = XMAT (ROWX+I,J)
                                     XK = XMAT (ROWX+I,K)
                                     SJJ = SJJ + XJ * XJ
                                     SKJ = SKJ + XK * XJ
                                     SKK = SKK + XK * XK
                                  END DO

                                  DENOM = SJJ * SKK
                                  IF (DENOM.GT.TINY) THEN
                                      NCOUNT = NCOUNT + 1
                                      OVLSUM = OVLSUM + (SKJ*SKJ)/DENOM
                                  END IF

                                  ROWX = ROWX + NHBA
                               END DO

                               IF (NCOUNT.GT.0) THEN
                                   OVLSUM = OVLSUM / DFLOAT (NCOUNT)
                               END IF

                               OVLAVG (K) = DMIN1 (OVLSUM+TINY,ONE)
                           END IF
                       END IF
                    END DO
C
C
C             ...sort all M average atomic overlaps in decreasing
C                order. Use the INDEX array to store the ordered
C                eigenfunction indices. Select the (NHCEN - 1) highest
C                average atomic overlaps as partners to the J-th
C                eigenfunction and test their eigenvalues. If an
C                eigenvalue passes the test, mark the corresponding
C                eigenfunction as used. If also the eigenvalue
C                is > WBOND mark the eigenfunction as ready for
C                depletion.
C
C
                    CALL  NLO__SORT_FLP_VECTOR_ELEMENTS
     +
     +                         ( M,M,
     +                           1,M,
     +                           ABSOLUT,INCRESE,
     +                           0,
     +                           OVLAVG,
     +
     +                                   INDEX )
     +
     +
                    NPAR = NHCEN - 1

                    DO N = 1,NPAR
                       K = INDEX (N)
                       E = XVEC (K)
                       IF (E.GT.WBOND .OR. DABS (E).LT.WSTAR) THEN
                           USED (K) = 1
                           IF (K.LE.MLARGE) THEN
                               NDEP = NDEP + 1
                               DEPLET (NDEP) = K
                           END IF
                       ELSE
                           GOTO 1000
                       END IF
                    END DO

                END IF
C
C
C             ...we get here, if the correct number of partners
C                with the desired properties have been found for
C                the current J-th eigenfunction. Deplete the J-th
C                eigenvalue and all its partners with eigenvalues
C                > WBOND from the PHSUB matrix.
C
C
                EXTRACT = .TRUE.

                CALL  NLO__HANDLE_MATRIX_SECTIONS
     +
     +                     ( NHB,NHB,
     +                       NHB,NHB,
     +                       NHA,NHCEN,
     +                       NHCEN,
     +                       ATHIDX,ATNHB,ATHOFF,
     +                       EXTRACT,
     +                       LTRG,
     +                       PHDEP,
     +
     +                               M,
     +                               PHSUB )
     +
     +
                DO N = 1,NDEP
                   I = DEPLET (N)
                   E = XVEC (I)
                   DO L = 1,M
                      F = E * XMAT (L,I)
                      DO K = L,M
                         PHSUB (K,L) = PHSUB (K,L) - F * XMAT (K,I)
                      END DO
                   END DO
                END DO

                EXTRACT = .FALSE.

                CALL  NLO__HANDLE_MATRIX_SECTIONS
     +
     +                     ( NHB,NHB,
     +                       NHB,NHB,
     +                       NHA,NHCEN,
     +                       NHCEN,
     +                       ATHIDX,ATNHB,ATHOFF,
     +                       EXTRACT,
     +                       LTRG,
     +
     +                               PHDEP,
     +
     +                       M,
     +                       PHSUB )
     +
     +
C
C
C             ...incorporate the present atomic parts of the J-th
C                averaged eigenfunction as an additional bond forming
C                pre-NHO on each atom, including their common weight.
C                If the # of bond forming pre-NHOs on any hybrid atom
C                exceeds the # of valence NAOs on that atom, the
C                routine is considered to have failed and we return.
C
C

                NBOND = NBOND + 1
                BDOCC (NBOND) = NDEP
                BDNBAS (NBOND) = NHCEN
                BDNCEN (NBOND) = NHCEN

                ROWX = 0
                DO 2000 N = 1,NHCEN
                   ATOM = ATHIDX (N)
                   OFF = ATHOFF (ATOM)
                   NVAL = ATHVAL (ATOM)
                   NHBA = ATNHB (ATOM)
                   NHYBA = NHYB (ATOM)

                   NHYBA = NHYBA + 1

                   IF (NHYBA .GT. NVAL) THEN
                       WRITE (*,*) ' # of bond pre-NHO > # of val NAO! '
                       WRITE (*,*) ' At#,#NHO,#NAO = ',ATOM,NHYBA,NVAL
                       WRITE (*,*) ' nlo__check_nho_x_centers '
                       WRITE (1,*) ' # of bond pre-NHO > # of val NAO! '
                       WRITE (1,*) ' At#,#NHO,#NAO = ',ATOM,NHYBA,NVAL
                       WRITE (1,*) ' nlo__check_nho_x_centers '
                       FAILED = .TRUE.
                       RETURN
                   END IF

                   NHOIDX = OFF + NHYBA

                   NORM = ZERO
                   DO I = 1,NHBA
                      NORM = NORM + XMAT (ROWX+I,J)**2
                   END DO
                   NORM = ONE / DSQRT (NORM)

                   DO I = 1,NHBA
                      H (I,NHOIDX) = NORM * XMAT (ROWX+I,J)
                   END DO

                   W (NHOIDX) = WHIGH
C
C
C             ...we now have to check, if the current (possibly still
C                incomplete) set of bond forming pre-NHOs on the
C                present hybrid atom is still a linearly independent
c                set. If not, we have failed and return. If everything
C                is ok, save the pre-NHO data for further use.
C
C
                   CALL  NLO__CHECK_LINEAR_DEPENDENCY
     +
     +                        ( MXNBA,NHYBA,
     +                          MXNHBA,MXNHBA,
     +                          NHBA,NHYBA,
     +                          H (1,OFF+1),
     +                          SAH,
     +
     +                                 DEPEND )
     +
     +
                   IF (DEPEND) THEN
                       WRITE (*,*) ' Linear dep. bond pre-NHO set! '
                       WRITE (*,*) ' Atom number = ',ATOM
                       WRITE (*,*) ' nlo__check_nho_x_centers '
                       WRITE (1,*) ' Linear dep. bond pre-NHO set! '
                       WRITE (1,*) ' Atom number = ',ATOM
                       WRITE (1,*) ' nlo__check_nho_x_centers '
                       FAILED = .TRUE.
                       RETURN
                   END IF

                   BDCEN (N,NBOND) = ATOM
                   BDBAS (N,NBOND) = NHOIDX

                   NHYB (ATOM) = NHYBA
                   ROWX = ROWX + NHBA

 2000           CONTINUE

            END IF
C
C
C             ...check next high weight space eigenfunction.
C
C
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__HRR_STEP
     +
     +                    ( NAB,NABO,MROWIN,MROWOUT,
     +                      NXYZX,NXYZP,NXYZA,NXYZB,NXYZAO,
     +                      SHELLX,SHELLP,SHELLB,
     +                      ABX,ABY,ABZ,
     +                      CPAIR,
     +                      NROWIN,ROWIN,
     +                      WIN,
     +
     +                                NROWOUT,ROWOUT,
     +                                WOUT )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__HRR_STEP
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single horizontal recurrence
C                relation (HRR) step on the input transformation matrix
C                WIN of formal dimension NXYZET x NAB, where NXYZET is
C                the dimension of the starting shell combination (e0|.
C                The columns of the matrix WIN are combined such that:
C
C                   (a(b+1i)| = ((a+1i)b| + (Ai-Bi)(ab| ; i=x,y,z
C
C                Note, that the shell symbol a stands for a range of
C                shells, starting from shell x and ending at shell p-1
C                for (a(b+1i)| and (ab| and ending at shell p for
C                ((a+1i)b|.
C
C                Since the input transformation matrix WIN contains
C                already all the HRR info from previous steps, the
C                output transformation matrix will have the complete
C                information for performing a HRR of the following
C                kind:
C
C                           (e0| --> (a(b+1i)|
C
C
C                Strategy used to perform the HRR step:
C                -------------------------------------
C
C                The HRR is split into two parts: part I) deals with
C                the (Ai-Bi)(ab| part and part II) with the ((a+1i)b|
C                part.
C
C                Part I):  In this case we have the following scheme,
C                          with a-shell range a = x to p-1:
C
C                           W = WIN (xa,ya,za,xb,yb,zb) ->
C
C                               + ABX*W to WOUT (xa,ya,za,xb+1,yb,zb)
C                               + ABY*W to WOUT (xa,ya,za,xb,yb+1,zb)
C                               + ABZ*W to WOUT (xa,ya,za,xb,yb,zb+1)
C
C                Part II): Here we have the following scheme, with
C                          a-shell range a = x+1 to p:
C
C                           W = WIN (xa,ya,za,xb,yb,zb) ->
C
C                               + W to WOUT (xa-1,ya,za,xb+1,yb,zb)
C                               + W to WOUT (xa,ya-1,za,xb,yb+1,zb)
C                               + W to WOUT (xa,ya,za-1,xb,yb,zb+1)
C
C
C                How to get from the b- to the (b+1)-shell monomials:
C                ---------------------------------------------------
C
C                To perform parts I) and II) of the HRR we need an
C                algorithm which creates a unique set of (b+1)-shell
C                monomials from those of the b-shell. The following
C                strategy is adopted:
C
C                     1) if x-exponent in b-shell monomial is > 0,
C                        add +1 to x-exponent.
C
C                     2) if x-exponent in b-shell monomial is = 0
C                        and y-exponent is > 0, add +1 to x-exponent
C                        and y-exponent.
C
C                     3) if x-exponent and y-exponent in b-shell
C                        monomial is = 0, add +1 to all exponents.
C
C                Example for b=2 --> b+1=3 case:
C
C                            200 --> 300
C                            110 --> 210
C                            101 --> 201
C                            020 --> 120,030
C                            011 --> 111,021
C                            002 --> 102,012,003
C
C
C                  Input:
C
C                    NAB          =  total # of monomials of the
C                                    input ((a+1i)b| part, i.e. #
C                                    of columns of input transformation
C                                    matrix
C                    NABO         =  total # of monomials of the
C                                    output (a(b+1i)| part, i.e. #
C                                    of columns of output transformation
C                                    matrix
C                    MROWIN       =  maximum # of nonzero row elements
C                                    per column in input transformation
C                                    matrix
C                    MROWOUT      =  maximum # of nonzero row elements
C                                    per column in output transformation
C                                    matrix
C                    NXYZX        =  total # of monomials for shell x
C                    NXYZP        =  total # of monomials for shell p
C                    NXYZA        =  sum of total # of monomials for
C                                    shell range a = x to p
C                    NXYZB        =  total # of monomials for shell b
C                    NXYZAO       =  sum of total # of monomials for
C                                    shell range a = x to p-1
C                    SHELLx       =  shell type for shells x = X,P,B
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    CPAIR        =  integer array that will hold the
C                                    pair of column indices of the input
C                                    transformation matrix that have
C                                    to be combined to form each output
C                                    transformation matrix column
C                    NROWIN (J)   =  # of nonzero row elements of J-th
C                                    input transformation matrix column
C                    ROWIN (I,J)  =  nonzero row indices of J-th input
C                                    transformation matrix column
C                    WIN (I,J)    =  nonzero elements of the input
C                                    transformation matrix corresponding
C                                    to nonzero row index I and column J
C                  Output:
C
C                    NROWOUT (J)  =  # of nonzero row elements of J-th
C                                    output transformation matrix column
C                    ROWOUT (I,J) =  nonzero row indices of J-th output
C                                    transformation matrix column
C                    WOUT (I,J)   =  nonzero elements of the output
C                                    transformation matrix corresponding
C                                    to nonzero row index I and column J
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     B,I,J,M,N
         INTEGER     C1,C2
         INTEGER     I1,I2
         INTEGER     MROWIN,MROWOUT
         INTEGER     NAB,NABO
         INTEGER     NOUT
         INTEGER     NROW1,NROW2
         INTEGER     NXBGT0
         INTEGER     NXYZAO
         INTEGER     NXYZA,NXYZB,NXYZX,NXYZP
         INTEGER     OFFYA,OFFYBO
         INTEGER     RDIFF
         INTEGER     ROW1,ROW2
         INTEGER     SHELLA,SHELLX,SHELLP,SHELLB
         INTEGER     X,Y,Z,XO,YO,ZO
         INTEGER     XA,YA

         INTEGER     NROWIN  (1:NAB)
         INTEGER     NROWOUT (1:NABO)

         INTEGER     CPAIR  (1:NABO,1:2)
         INTEGER     ROWIN  (1:MROWIN,1:NAB)
         INTEGER     ROWOUT (1:MROWOUT,1:NABO)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  COEFF
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  WIN  (1:MROWIN,1:NAB)
         DOUBLE PRECISION  WOUT (1:MROWOUT,1:NABO)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine some useful constants.
C
C
         NXBGT0 = NXYZB - SHELLB - 1
         OFFYBO = NXYZAO * (SHELLB + 1)
C
C
C             ...determine the column pairs to be 'added' to define
C                the output tranformation matrix.
C
C                      ------- Part I) section ---------
C
C                Outer loop over b- to (b+1)-shell monomials with
C                xb-exponent > 0. Inner loop over a-part contractions
C                for part I) of HRR for a-shell range a = x to p-1.
C
C
         X = - NXYZA
         XO = - NXYZAO
         DO 100 B = 1,NXBGT0
            X = X + NXYZA
            XO = XO + NXYZAO
            IF (DABS(ABX).GT.ZERO) THEN
                DO 102 J = 1,NXYZAO
                   CPAIR (XO+J,1) = X + J
  102           CONTINUE
            END IF
  100    CONTINUE
C
C
C             ...outer loop over b- to (b+1)-shell monomials with
C                xb-exponent = 0 and yb-exponent > 0. Inner loop over
C                a-part contractions for part I) of HRR for a-shell
C                range a = x to p-1.
C
C
         YO = XO + OFFYBO
         DO 110 B = 1,SHELLB
            X = X + NXYZA
            XO = XO + NXYZAO
            YO = YO + NXYZAO
            IF (DABS(ABX).GT.ZERO) THEN
                DO 112 J = 1,NXYZAO
                   CPAIR (XO+J,1) = X + J
  112           CONTINUE
            END IF
            IF (DABS(ABY).GT.ZERO) THEN
                DO 114 J = 1,NXYZAO
                   CPAIR (YO+J,1) = X + J
  114           CONTINUE
            END IF
  110    CONTINUE
C
C
C             ...last b- to (b+1)-shell monomial with xb-exponent = 0
C                and yb-exponent = 0. Inner loop over a-part
C                contractions for part I) of HRR for a-shell range
C                a = x to p-1.
C
C
         X = X + NXYZA
         XO = XO + NXYZAO
         YO = YO + NXYZAO
         ZO = YO + NXYZAO
         IF (DABS(ABX).GT.ZERO) THEN
             DO 120 J = 1,NXYZAO
                CPAIR (XO+J,1) = X + J
  120        CONTINUE
         END IF
         IF (DABS(ABY).GT.ZERO) THEN
             DO 122 J = 1,NXYZAO
                CPAIR (YO+J,1) = X + J
  122        CONTINUE
         END IF
         IF (DABS(ABZ).GT.ZERO) THEN
             DO 124 J = 1,NXYZAO
                CPAIR (ZO+J,1) = X + J
  124        CONTINUE
         END IF
C
C
C                      ------- Part II) section ---------
C
C             ...outer loop over b- to (b+1)-shell monomials with
C                xb-exponent > 0. Inner loop over a-part contractions
C                for part II) of HRR for a-shell range a = x+1 to p.
C
C
         X = 0
         XO = 0
         DO 200 B = 1,NXBGT0
            X = X + NXYZX
            DO 202 SHELLA = SHELLX,SHELLP-1
               DO 204 XA = SHELLA,0,-1
               DO 204 YA = SHELLA-XA,0,-1
                  X = X + 1
                  XO = XO + 1
                  CPAIR (XO,2) = X
  204          CONTINUE
               X = X + SHELLA + 2
  202       CONTINUE
  200    CONTINUE
C
C
C             ...outer loop over b- to (b+1)-shell monomials with
C                xb-exponent = 0 and yb-exponent > 0. Inner loop over
C                a-part contractions for part II) of HRR for a-shell
C                range a = x+1 to p.
C
C

         YO = XO + OFFYBO
         DO 210 B = 1,SHELLB
            X = X + NXYZX
            DO 212 SHELLA = SHELLX,SHELLP-1
               OFFYA = 0
               DO 214 XA = SHELLA,0,-1
                  OFFYA = OFFYA + 1
                  DO 216 YA = OFFYA-1,0,-1
                     X = X + 1
                     Y = X + OFFYA
                     XO = XO + 1
                     YO = YO + 1
                     CPAIR (XO,2) = X
                     CPAIR (YO,2) = Y
  216             CONTINUE
  214          CONTINUE
               X = Y + 1
  212       CONTINUE
  210    CONTINUE
C
C
C             ...last b- to (b+1)-shell monomial with xb-exponent = 0
C                and yb-exponent = 0. Inner loop over a-part
C                contractions for part II) of HRR for a-shell range
C                a = x+1 to p.
C
C
         X = X + NXYZX
         ZO = YO + NXYZAO
         DO 220 SHELLA = SHELLX,SHELLP-1
            OFFYA = 0
            DO 222 XA = SHELLA,0,-1
               OFFYA = OFFYA + 1
               DO 224 YA = OFFYA-1,0,-1
                  X = X + 1
                  Y = X + OFFYA
                  Z = Y + 1
                  XO = XO + 1
                  YO = YO + 1
                  ZO = ZO + 1
                  CPAIR (XO,2) = X
                  CPAIR (YO,2) = Y
                  CPAIR (ZO,2) = Z
  224          CONTINUE
  222       CONTINUE
            X = Z
  220    CONTINUE
C
C
C             ...the column pairs are ready. Construct the new
C                transformation matrix.
C
C
         DO 300 N = 1,NABO

            IF (N.LE.XO) THEN
                COEFF = ABX
            ELSE IF (N.LE.YO) THEN
                COEFF = ABY
            ELSE
                COEFF = ABZ
            END IF

            IF (DABS(COEFF).GT.ZERO) THEN

                C1 = CPAIR (N,1)
                C2 = CPAIR (N,2)
                NROW1 = NROWIN (C1)
                NROW2 = NROWIN (C2)

                M = MIN (NROW1,NROW2)
                I1 = 1
                I2 = 1
                NOUT = 0

                DO 310 I = 2,M
                   ROW1 = ROWIN (I1,C1)
                   ROW2 = ROWIN (I2,C2)
                   RDIFF = ROW1 - ROW2
                   IF (RDIFF.EQ.0) THEN
                       NOUT = NOUT + 1
                       WOUT (NOUT,N) = COEFF * WIN (I1,C1) + WIN (I2,C2)
                       ROWOUT (NOUT,N) = ROW1
                       I1 = I1 + 1
                       I2 = I2 + 1
                   ELSE IF (RDIFF.LT.0) THEN
                       NOUT = NOUT + 1
                       WOUT (NOUT,N) = COEFF * WIN (I1,C1)
                       ROWOUT (NOUT,N) = ROW1
                       I1 = I1 + 1
                   ELSE
                       NOUT = NOUT + 1
                       WOUT (NOUT,N) = WIN (I2,C2)
                       ROWOUT (NOUT,N) = ROW2
                       I2 = I2 + 1
                   END IF
  310           CONTINUE

 3000           ROW1 = ROWIN (I1,C1)
                ROW2 = ROWIN (I2,C2)
                RDIFF = ROW1 - ROW2
                IF (RDIFF.EQ.0) THEN
                    NOUT = NOUT + 1
                    WOUT (NOUT,N) = COEFF * WIN (I1,C1) + WIN (I2,C2)
                    ROWOUT (NOUT,N) = ROW1
                    I1 = I1 + 1
                    I2 = I2 + 1
                ELSE IF (RDIFF.LT.0) THEN
                    NOUT = NOUT + 1
                    WOUT (NOUT,N) = COEFF * WIN (I1,C1)
                    ROWOUT (NOUT,N) = ROW1
                    I1 = I1 + 1
                ELSE
                    NOUT = NOUT + 1
                    WOUT (NOUT,N) = WIN (I2,C2)
                    ROWOUT (NOUT,N) = ROW2
                    I2 = I2 + 1
                END IF

                IF (I1.GT.NROW1) THEN
                    DO 320 I = I2,NROW2
                       ROW2 = ROWIN (I,C2)
                       NOUT = NOUT + 1
                       WOUT (NOUT,N) = WIN (I,C2)
                       ROWOUT (NOUT,N) = ROW2
  320               CONTINUE
                ELSE IF (I2.GT.NROW2) THEN
                    DO 330 I = I1,NROW1
                       ROW1 = ROWIN (I,C1)
                       NOUT = NOUT + 1
                       WOUT (NOUT,N) = COEFF * WIN (I,C1)
                       ROWOUT (NOUT,N) = ROW1
  330               CONTINUE
                ELSE
                    GOTO 3000
                END IF

                NROWOUT (N) = NOUT

            ELSE

                C2 = CPAIR (N,2)
                NROW2 = NROWIN (C2)

                DO 340 I2 = 1,NROW2
                   WOUT (I2,N) = WIN (I2,C2)
                   ROWOUT (I2,N) = ROWIN (I2,C2)
  340           CONTINUE

                NROWOUT (N) = NROW2

            END IF

  300    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_abab_integrals(a1,a2,b1,b2,c1,c2,d1,d2,scr,
     *                 maxblk, iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 out, nsend)
c---------------------------------------------------------------------------
c   The block of integrals (a1:a2,b1:b2,c1:c2,d1:d2) is computed for the 
c   following 'types' of integrals based on atomic labels.
c
c   1. AAAA 
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2 
      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim  
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, n, m, r, s
      integer a,b,c,d

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer me, ierr

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision out(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision scr(*)   
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter 

      save me,alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack

      call mpi_comm_rank(mpi_comm_world, me, ierr)
c      print *,'Task ',me,' computing integrals for ',a1,a2,b1,b2,
c     *     c1,c2,d1,d2
c      call c_flush_stdout()

      adim = a2-a1+1
      bdim = b2-b1+1
      cdim = c2-c1+1
      ddim = d2-d1+1 
      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical
  
      nsend = adim*bdim*cdim*ddim
      if (nsend .lt. 0) then
         print *,'ERROR IN INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim,cdim,ddim = ',adim,bdim,cdim,ddim
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do d = d1,d2
      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         out(a,b,c,d) = 0.d0
      enddo
      enddo
      enddo
      enddo

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         call lookup_shell(end_nfps, nshells, a1, m1)
         call lookup_shell(end_nfps, nshells, a2, m2)
         call lookup_shell(end_nfps, nshells, b1, n1)
         call lookup_shell(end_nfps, nshells, b2, n2)
         call lookup_shell(end_nfps, nshells, c1, r1)
         call lookup_shell(end_nfps, nshells, c2, r2)
         call lookup_shell(end_nfps, nshells, d1, s1)
         call lookup_shell(end_nfps, nshells, d2, s2)

         do m = m1, m2
            if (m .eq. 1) then
               aa1 = 1
            else
               aa1 = end_nfps(m-1) + 1
            endif
            aa2 = end_nfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (atom(n) .eq. atom(m)) go to 10 
            if (n .eq. 1) then
               bb1 = 1
            else
               bb1 = end_nfps(n-1) + 1
            endif
            bb2 = end_nfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if (atom(r) .ne. atom(m)) go to 20 
            if (r .eq. 1) then
               cc1 = 1
            else
               cc1 = end_nfps(r-1) + 1
            endif
            cc2 = end_nfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)
         do s = s1, s2
            if (atom(s) .ne. atom(n)) go to 30 
               x4 = coords(1,s)
               y4 = coords(2,s)
               z4 = coords(3,s)
               call pack_coeffs(alphas, ixalpha, coeffs, ixpcoef, 
     *                          ncfps, npfps, m, n, 
     *                          r, s, alpha_pack, nalpha_pack, 
     *                          pcoeff_pack, npcoeff_pack, 
     *                          ccbeg, ccend, indx_cc,
     *                          ccbeg_pack, ccend_pack)
c               print *,'Task ',me,' After pack_coeffs, m,n,r,s ',
c     *             m,n,r,s
c               call c_flush_stdout()

c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

                  call ERD__GENER_ERI_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum, 
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n), 
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4, alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints, 
     *                nfirst, scr)    

c---------------------------------------------------------------------------
c   Move the integrals into the output block.  
c---------------------------------------------------------------------------

            if (nints .gt. 0) then
               
               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)
 
               call move_integrals(out, a1,a2,b1,b2,c1,c2,d1,d2,
     *                             scr(nfirst), 
     *                             aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2)
            endif

30       continue 
         enddo   ! s
20       continue 
         enddo   ! r

10       continue 
         enddo   ! n
100      continue 
         enddo   ! m

      return
      end

      

      Subroutine Gen_curr_coords(React, Prodt, Currn, Ndim, XYZ)

      Implicit Double Precision (A-H,O-Z)
 
      Logical XYZ

#include "mxatms.par"
#include "machsp.com"
#include "coord.com"

      Dimension React(Ndim), Prodt(Ndim), Currn(Ndim)

      Call DGetrec(20, "JOBARC", "RXSTRUCT", Ndim, React)
      Call DGetrec(20, "JOBARC", "PRSTRUCT", Ndim, Prodt)

CSSS      Call XDcopy(Ndim, React, 1, Currn, 1)

      If (XYZ) Then
      
         Do Iatm = 1, Ndim/3
            Do jatm = 1, Iatm
               Distij = Dist(React(3*(Iatm-1)+1), React(3*(Jatm-1)+1))
               Distkl = Dist(Prodt(3*(Iatm-1)+1), Prodt(3*(Jatm-1)+1))
               
               Distmn = Distij + (Distkl - Distij)/2.0D0
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Distij, Distkl, Distmn"
      Write(6,"(3(1x,F12.6))") Distij, Distkl, Distmn*0.529177249D0
#endif
            Enddo
         Enddo
C
         Call DPutrec(1,'JOBARC','CUSTRUCT',Ndim,Currn)
      
      Else
  
         Do idim = 1, Ndim
 
CSSS            Currn(Idim) = React(Idim) + (Prodt(Idim) - 
CSSS     &                                   React(Idim))/2.0D0
         Enddo
 
CSSS         Call XDcopy(Ndim, Currn, 1, R, 1)
         Call DPutrec(20, "JOBARC", "RXSTRUCT", Ndim, Currn)

      Endif
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The current structue for LST optimizations"
      Write(6,"(3(1x,F12.6))") (currn(i),i=1, Ndim)
#endif 
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ASSIRR(PTGRPX,CHRVEC,NDEG,IRREP)
C
C THIS FUNCTION RETURNS THE IRREDUCIBLE REPRESENTATION CORRESPONDING
C TO A VECTOR OF LENGTH H (THE ORDER OF THE GROUP) WHICH CONTAINS THE
C CHARACTERS UNDER ALL OPERATIONS.
C
C INPUT:
C    PTGRPX (CHARACTER*4) - THE POINT GROUP OF THE MOLECULE
C    CHRVEC               - A VECTOR WHICH CONTAINS THE CHARACTERS
C                           OF ALL OPERATIONS IN THE POINT GROUP
C
C RETURNED:
C
C    IRREP                - THE IRREDUCIBLE REPRESENTATION OF V
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER ATOI
      DIMENSION ANGLE(50)
      PARAMETER (MXATMS=50)
      PARAMETER (TOL = 1.D-2)
      CHARACTER*4 PTGRP,PTGRPX,IRREP
      CHARACTER*2 GREEK(6)     
      DIMENSION CHRVEC(*)
      DATA GREEK /'SG','PI','DE','PH','GA','IO'/
C
C SET INTEGER TO POSITION OF LAST NONBLANK CHARACTER IN THE STRING
C
      ICLST=linblnk(PTGRPX)
C
C SOME USEFUL CONSTANTS
C
      PI=DACOS(-1.D0)
      TWOPI=2.D0*PI
C
C INITIALIZE IRREP TO BLANKS
C
      IRREP='    '
C
C**********************************************************************
C DEAL FIRST WITH NON-CUBIC GROUPS WHICH CAN NOT BE HANDLED BY
C THE GENERAL C(nh), C(nv), D(nh), D(nd), D(n), C(n) AND S(2n)
C ALGORITHMS.  TREAT Cs AS C1h, Ci AS S2.
C**********************************************************************
C
      PTGRP=PTGRPX
      IF(PTGRPX(1:3).EQ.'C s')PTGRP='C1h '
      IF(PTGRPX(1:3).EQ.'C i')PTGRP='S2  '
C
C**********************************************************************
C WE REQUIRE SPECIAL CODE FOR D2 AND D2h.  HERE IT IS.
C**********************************************************************
C
      IF(PTGRP(1:3).EQ.'D2 ')THEN
       CHARC2Z=CHRVEC(1)
       CHARC2X=CHRVEC(2)
       IF(DABS(CHARC2Z-1.D0).LT.TOL.AND.DABS(CHARC2X-1.D0).LT.TOL)THEN
        IRREP(4:4)='A'
       ENDIF
       IF(DABS(CHARC2Z-1.D0).LT.TOL.AND.DABS(CHARC2X+1.D0).LT.TOL)THEN
        IRREP(3:4)='B1'
       ENDIF
       IF(DABS(CHARC2Z+1.D0).LT.TOL.AND.DABS(CHARC2X+1.D0).LT.TOL)THEN
        IRREP(3:4)='B2'
       ENDIF
       IF(DABS(CHARC2Z+1.D0).LT.TOL.AND.DABS(CHARC2X-1.D0).LT.TOL)THEN
        IRREP(3:4)='B3'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D2h')THEN
       CHARC2Z=CHRVEC(1)
CJDW 8/4/97. I think next line is wrong.
C      CHARC2X=CHRVEC(4)
C            I think it should be :
       CHARC2X=CHRVEC(3)
       CHARINV=CHRVEC(2)
       IF(DABS(CHARINV-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(CHARINV+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(CHARC2Z-1.D0).LT.TOL.AND.DABS(CHARC2X-1.D0).LT.TOL)THEN
        IRREP(3:3)='A'
       ENDIF
       IF(DABS(CHARC2Z-1.D0).LT.TOL.AND.DABS(CHARC2X+1.D0).LT.TOL)THEN
        IRREP(2:3)='B1'
       ENDIF
       IF(DABS(CHARC2Z+1.D0).LT.TOL.AND.DABS(CHARC2X+1.D0).LT.TOL)THEN
        IRREP(2:3)='B2'
       ENDIF
       IF(DABS(CHARC2Z+1.D0).LT.TOL.AND.DABS(CHARC2X-1.D0).LT.TOL)THEN
        IRREP(2:3)='B3'
       ENDIF
       RETURN
C
C**********************************************************************
C  THE FOLLOWING CODE PERTAINS TO THE INFINITE GROUPS CXv AND DXh.
C**********************************************************************
C
      ELSEIF(PTGRP(1:3).EQ.'DXh')THEN
       CHAR=CHRVEC(14)
       CHAR2=CHRVEC(31)
       CHAR3=CHRVEC(1)
       IF(NDEG.EQ.1)IRREP(1:2)='SG'
       IF(NDEG.EQ.2)THEN
       IRREP(1:2)='PI'
        DO 3100 J=1,4
         Z=2.D0*DCOS(DFLOAT(J)*DACOS(-1.D0)/4.D0)
         IF(DABS(CHAR3-Z).LT.TOL)IRREP(1:2)=GREEK(J+1)
 3100   CONTINUE
        CHAR=CHAR/2.0
       ENDIF
       IF(DABS(CHAR+1.D0).LT.TOL)IRREP(3:3)='u'
       IF(DABS(CHAR-1.D0).LT.TOL)IRREP(3:3)='g'
       IF(NDEG.EQ.1)THEN
        IF(DABS(CHAR+1.D0).LT.TOL)IRREP(4:4)='-'
        IF(DABS(CHAR-1.D0).LT.TOL)IRREP(4:4)='+'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'CXv')THEN
       CHAR=CHRVEC(15)
       CHAR3=CHRVEC(1)
       IF(NDEG.EQ.1)THEN
        IRREP(2:3)='SG'
        IF(DABS(CHAR+1.D0).LT.TOL)IRREP(4:4)='-'
        IF(DABS(CHAR-1.D0).LT.TOL)IRREP(4:4)='+'
       ELSE
        IRREP(3:4)='PI'
        DO 3101 J=1,3
         Z=2.D0*DCOS(DFLOAT(J)*DACOS(-1.D0)/4.D0)
         IF(DABS(CHAR3-Z).LT.TOL)IRREP(3:4)=GREEK(J+1)
 3101   CONTINUE
       ENDIF
C
C**********************************************************************
C C(nh) GROUPS.  SEPARATE CODE FOR n ODD AND EVEN
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.PTGRP(ICLST:ICLST).EQ.'h')THEN
       IORDER=ATOI(PTGRP(2:ICLST-1))
       ITOP=(IORDER-1)/2
       DO 100 I=1,ITOP
        ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
100    CONTINUE
       IF(MOD(IORDER,2).NE.0)THEN
        CHARCN=CHRVEC(1)
        CHARSGH=CHRVEC(IORDER*2)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARSGH=CHARSGH/DFLOAT(NDEG)
        IF(DABS(CHARSGH-1.0D0).LT.TOL)IRREP(3:4)=''''
        IF(DABS(CHARSGH+1.0D0).LT.TOL)IRREP(3:4)=''''''
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARCN-1.D0).LT.TOL)IRREP(2:2)='A'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(1:1)='E'
          DO 101 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(2:2),'(I1)')I
101       CONTINUE
         ELSE
          IRREP(2:2)='E'
         ENDIF
        ENDIF
C
       ELSE 
C
        CHARCN=CHRVEC(1)
        CHARINV=CHRVEC(IORDER+IORDER/2)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARINV=CHARINV/DFLOAT(NDEG)
        IF(DABS(CHARINV-1.D0).LT.TOL)IRREP(4:4)='g'
        IF(DABS(CHARINV+1.D0).LT.TOL)IRREP(4:4)='u'
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARCN-1.D0).LT.TOL)IRREP(3:3)='A'
         IF(DABS(CHARCN+1.D0).LT.TOL)IRREP(3:3)='B'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(2:2)='E'
          DO 102 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(3:3),'(I1)')I
102       CONTINUE
         ELSE
          IRREP(3:3)='E'
         ENDIF
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C C(nv) GROUPS.  SEPARATE CODE FOR n ODD AND EVEN
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.PTGRP(ICLST:ICLST).EQ.'v')THEN
       IORDER=ATOI(PTGRP(2:ICLST-1))
       ITOP=(IORDER-1)/2
       DO 200 I=1,ITOP
        ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
200    CONTINUE
       IF(MOD(IORDER,2).NE.0)THEN
        CHARCN=CHRVEC(1)
        CHARSGV=CHRVEC(IORDER)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARSGV=CHARSGV/DFLOAT(NDEG)
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARSGV-1.D0).LT.TOL)IRREP(3:4)='A1'
         IF(DABS(CHARSGV+1.D0).LT.TOL)IRREP(3:4)='A2'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(3:3)='E'
          DO 201 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(4:4),'(I1)')I
201       CONTINUE
         ELSE
          IRREP(4:4)='E'
         ENDIF
        ENDIF
C
       ELSE 
C
        CHARCN=CHRVEC(1)
        CHARSGD=CHRVEC(IORDER+(IORDER/2))
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARSGD=CHARSGD/DFLOAT(NDEG)
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARCN-1.D0).LT.TOL)IRREP(3:3)='A'
         IF(DABS(CHARCN+1.D0).LT.TOL)IRREP(3:3)='B'
         IF(DABS(CHARSGD-1.D0).LT.TOL)IRREP(4:4)='1'
         IF(DABS(CHARSGD+1.D0).LT.TOL)IRREP(4:4)='2'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(3:3)='E'
          DO 202 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(4:4),'(I1)')I
202       CONTINUE
         ELSE
          IRREP(4:4)='E'
         ENDIF
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C D(nd) GROUPS.  SEPARATE CODE FOR n ODD AND EVEN
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.PTGRP(ICLST:ICLST).EQ.'d')THEN
       IORDER=ATOI(PTGRP(2:ICLST-1))
       IF(MOD(IORDER,2).NE.0)THEN
        ITOP=(IORDER-1)/2
        DO 300 I=1,ITOP
         ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
300     CONTINUE
        CHARCN=CHRVEC(1)
        CHARC2=CHRVEC(2*IORDER)
        CHARINV=CHRVEC(2*IORDER-1)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARC2=CHARC2/DFLOAT(NDEG)
        CHARINV=CHARINV/DFLOAT(NDEG)
        IF(DABS(CHARINV-1.0D0).LT.TOL)IRREP(4:4)='g'
        IF(DABS(CHARINV+1.0D0).LT.TOL)IRREP(4:4)='u'
        IF(NDEG.EQ.1)THEN
         IRREP(2:2)='A'
         IF(DABS(CHARC2-1.D0).LT.TOL)IRREP(3:3)='1'
         IF(DABS(CHARC2+1.D0).LT.TOL)IRREP(3:3)='2'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(2:2)='E'
          DO 301 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(3:3),'(I1)')I
301       CONTINUE
         ELSE
          IRREP(3:3)='E'
         ENDIF
        ENDIF
C
       ELSE 
C
        ITOP=(2*IORDER-1)/2
        DO 302 I=1,ITOP
         ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(2*IORDER)
302     CONTINUE
        CHARCN=CHRVEC(1)
        CHARS2N=CHRVEC(IORDER)
        CHARC2=CHRVEC(2*IORDER)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARC2=CHARC2/DFLOAT(NDEG)
        CHARS2N=CHARS2N/DFLOAT(NDEG)
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARS2N-1.D0).LT.TOL)IRREP(3:3)='A'
         IF(DABS(CHARS2N+1.D0).LT.TOL)IRREP(3:3)='B'
         IF(DABS(CHARC2-1.D0).LT.TOL)IRREP(4:4)='1'
         IF(DABS(CHARC2+1.D0).LT.TOL)IRREP(4:4)='2'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN 
          DO 303 I=1,ITOP
           IRREP(3:3)='E'
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARS2N-Z).LT.TOL)WRITE(IRREP(4:4),'(I1)')I
303       CONTINUE
         ELSE
          IRREP(4:4)='E'
         ENDIF
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C D(nh) GROUPS.  SEPARATE CODE FOR n ODD AND EVEN. 
C   DOES NOT WORK FOR D2h
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.PTGRP(ICLST:ICLST).EQ.'h')THEN
       IORDER=ATOI(PTGRP(2:ICLST-1))
       ITOP=(IORDER-1)/2
       DO 400 I=1,ITOP
        ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
400     CONTINUE
       IF(MOD(IORDER,2).NE.0)THEN
        CHARCN=CHRVEC(1)
        CHARC2=CHRVEC(2*IORDER-1)
        CHARSGH=CHRVEC(4*IORDER-1)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARC2=CHARC2/DFLOAT(NDEG)
        CHARSGH=CHARSGH/DFLOAT(NDEG)
        IF(NDEG.EQ.1)THEN
         IRREP(1:1)='A'
         IF(DABS(CHARC2-1.D0).LT.TOL)IRREP(2:2)='1'
         IF(DABS(CHARC2+1.D0).LT.TOL)IRREP(2:2)='2'
         IF(DABS(CHARSGH-1.0D0).LT.TOL)IRREP(3:4)=''''
         IF(DABS(CHARSGH+1.0D0).LT.TOL)IRREP(3:4)=''''''
        ELSEIF(NDEG.EQ.2)THEN
         IF(DABS(CHARSGH-1.0D0).LT.TOL)IRREP(3:4)=''''
         IF(DABS(CHARSGH+1.0D0).LT.TOL)IRREP(3:4)=''''''
         IF(ITOP.NE.1)THEN
          IRREP(1:1)='E'
          DO 401 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(2:2),'(I1)')I
401       CONTINUE
         ELSE
          IRREP(2:2)='E'
         ENDIF
        ENDIF
C
       ELSE 
C
        CHARCN=CHRVEC(1)
        CHARC2=CHRVEC(2*IORDER-1)
        CHARINV=CHRVEC(2*IORDER-2)
        CHARCN=CHARCN/DFLOAT(NDEG)
        CHARC2=CHARC2/DFLOAT(NDEG)
        CHARINV=CHARINV/DFLOAT(NDEG)
        IF(DABS(CHARINV-1.0D0).LT.TOL)IRREP(3:3)='g'
        IF(DABS(CHARINV+1.0D0).LT.TOL)IRREP(3:3)='u'
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARCN-1.D0).LT.TOL)IRREP(1:1)='A'
         IF(DABS(CHARCN+1.D0).LT.TOL)IRREP(1:1)='B'
         IF(DABS(CHARC2-1.D0).LT.TOL)IRREP(2:2)='1'
         IF(DABS(CHARC2+1.D0).LT.TOL)IRREP(2:2)='2'
        ELSEIF(NDEG.EQ.2)THEN
         DO 402 I=1,ITOP
          IRREP(1:1)='E'
          Z=DCOS(ANGLE(I))
          IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(2:2),'(I1)')I
402      CONTINUE
        ELSE
         IRREP(2:2)='E'
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C S(2n) GROUPS.  SEPARATE CODE FOR n ODD AND EVEN
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'S')THEN
       IORDER=ATOI(PTGRP(2:ICLST))
       ITOP=(IORDER-1)/2
       DO 500 I=1,ITOP
        ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
500     CONTINUE
       IF(MOD(IORDER,2).NE.0)THEN
        CHARSN=CHRVEC(1)
        CHARINV=CHRVEC(IORDER/2)
        CHARSN=CHARSN/DFLOAT(NDEG)
        CHARINV=CHARINV/DFLOAT(NDEG)
        IF(DABS(CHARINV-1.0D0).LT.TOL)IRREP(4:4)='g'
        IF(DABS(CHARINV+1.0D0).LT.TOL)IRREP(4:4)='u'
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARSN-1.D0).LT.TOL)IRREP(3:3)='A'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(2:2)='E'
          DO 501 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(3:3),'(I1)')I
501       CONTINUE
         ELSE
          IRREP(3:3)='E'
         ENDIF
        ENDIF
C
       ELSE 
C
        CHARSN=CHRVEC(1)
        CHARSN=CHARSN/DFLOAT(NDEG)
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHARSN-1.D0).LT.TOL)IRREP(3:3)='A'
         IF(DABS(CHARSN+1.D0).LT.TOL)IRREP(3:3)='B'
        ELSEIF(NDEG.EQ.2)THEN
         IF(ITOP.NE.1)THEN
          IRREP(3:3)='E'
          DO 502 I=1,ITOP
           Z=DCOS(ANGLE(I))
           IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(4:4),'(I1)')I
502       CONTINUE
         ELSE
          IRREP(4:4)='E'
         ENDIF
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C C(n) GROUPS.
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.PTGRP(ICLST:ICLST).NE.'h'.AND.
     &       PTGRP(ICLST:ICLST).NE.'v')THEN
       IORDER=ATOI(PTGRP(2:ICLST))
       ITOP=IORDER/2
       DO 600 I=1,ITOP
        ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
600    CONTINUE
       CHARCN=CHRVEC(1)
       CHARCN=CHARCN/DFLOAT(NDEG)
       IF(NDEG.EQ.1)THEN
        IF(DABS(CHARCN-1.D0).LT.TOL)IRREP(4:4)='A'
        IF(DABS(CHARCN+1.D0).LT.TOL)IRREP(4:4)='B'
       ELSEIF(NDEG.EQ.2)THEN
        IF(ITOP.NE.1)THEN
         IRREP(3:3)='E'
         DO 601 I=1,ITOP
          Z=DCOS(ANGLE(I))
          IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(4:4),'(I1)')I
601      CONTINUE
        ELSE
         IRREP(4:4)='E'
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C D(n) GROUPS.  DOES NOT WORK FOR D2.
C**********************************************************************
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.PTGRP(ICLST:ICLST).NE.'h'.AND.
     &       PTGRP(ICLST:ICLST).NE.'d')THEN
       IORDER=ATOI(PTGRP(2:ICLST))
       ITOP=IORDER/2
       DO 700 I=1,ITOP
        ANGLE(I)=DFLOAT(I)*TWOPI/DFLOAT(IORDER)
700    CONTINUE
       CHARCN=CHRVEC(1)
       CHARC2=CHRVEC(IORDER)
       CHARCN=CHARCN/DFLOAT(NDEG)
       CHARC2=CHARC2/DFLOAT(NDEG)
       IF(NDEG.EQ.1)THEN
        IF(DABS(CHARCN-1.D0).LT.TOL)IRREP(3:3)='A'
        IF(DABS(CHARCN+1.D0).LT.TOL)IRREP(3:3)='B'
        IF(DABS(CHARC2-1.D0).LT.TOL)IRREP(4:4)='1'
        IF(DABS(CHARC2+1.D0).LT.TOL)IRREP(4:4)='2'
       ELSEIF(NDEG.EQ.2)THEN
        IF(ITOP.NE.1)THEN
         IRREP(3:3)='E'
         DO 701 I=1,ITOP
          Z=DCOS(ANGLE(I))
          IF(DABS(CHARCN-Z).LT.TOL)WRITE(IRREP(4:4),'(I1)')I
701      CONTINUE
        ELSE
         IRREP(4:4)='E'
        ENDIF
       ENDIF
       RETURN
C
C**********************************************************************
C  THE FOLLOWING CODE PERTAINS TO THE CUBIC GROUPS T, Td, O, Th, Oh,
C  I AND Ih.  STANDARD ORIENTATIONS FOR THESE GROUPS ARE DESCRIBED IN
C  THE ACES II PROGRAM MANUAL 
C**********************************************************************
C
      ELSEIF(PTGRP(1:3).EQ.'T d')THEN
       IF(NDEG.EQ.2)THEN
        IRREP='   E'
        RETURN
       ELSE
        CHAR=CHRVEC(1)
        IF(NDEG.EQ.1)THEN
         IF(DABS(CHAR+1.D0).LT.TOL)IRREP='  A2'
         IF(DABS(CHAR-1.D0).LT.TOL)IRREP='  A1'
        ELSE
         IF(DABS(CHAR+1.D0).LT.TOL)IRREP='  T2'
         IF(DABS(CHAR-1.D0).LT.TOL)IRREP='  T1'
        ENDIF
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'O h')THEN
       CHAR=CHRVEC(47)
       Z=CHAR/DFLOAT(NDEG)
       IF(DABS(Z+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(Z-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.2)THEN
        IRREP(2:3)=' E'
        RETURN
       ENDIF
       Z1=CHRVEC(1)
       IF(DABS(Z1+1.D0).LT.TOL)IRREP(3:3)='2'
       IF(DABS(Z1-1.D0).LT.TOL)IRREP(3:3)='1'
       IF(NDEG.EQ.3)IRREP(2:2)='T'
       IF(NDEG.EQ.1)IRREP(2:2)='A'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'O  ')THEN
       CHAR=CHRVEC(1)
       IF(DABS(CHAR-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(DABS(CHAR+1.D0).LT.TOL)IRREP(4:4)='2'
       IF(NDEG.EQ.1)IRREP(3:3)='A'
       IF(NDEG.EQ.2)IRREP='   E'
       IF(NDEG.EQ.3)IRREP(3:3)='T'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'T  ')THEN
       IF(NDEG.EQ.1)IRREP='   A'
       IF(NDEG.EQ.2)IRREP='   E'
       IF(NDEG.EQ.3)IRREP='   T'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'T h')THEN
       CHAR=CHRVEC(23)
       CHAR=CHAR/DFLOAT(NDEG)
       IF(DABS(CHAR+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(CHAR-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.1)IRREP(1:3)='  A'
       IF(NDEG.EQ.2)IRREP(1:3)='  E'
       IF(NDEG.EQ.3)IRREP(1:3)='  T'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'I h')THEN
       CHAR=CHRVEC(119)
       CHAR=CHAR/DFLOAT(NDEG)
       IF(DABS(CHAR+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(CHAR-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.1)IRREP(3:3)='A'
       IF(NDEG.EQ.4)IRREP(3:3)='G'
       IF(NDEG.EQ.5)IRREP(3:3)='H'
       IF(NDEG.EQ.3)THEN
        ETAP=0.5D0*(1.D0+SQRT(5.D0))
        ETAM=0.5D0*(1.D0-SQRT(5.D0))
        CHAR=CHRVEC(1)
        IF(DABS(CHAR-ETAP).LT.TOL)IRREP(2:3)='T1'
        IF(DABS(CHAR-ETAM).LT.TOL)IRREP(2:3)='T2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'I  ')THEN
       IF(NDEG.EQ.1)IRREP(4:4)='A'
       IF(NDEG.EQ.2)IRREP(4:4)='E'
       IF(NDEG.EQ.4)IRREP(4:4)='G'
       IF(NDEG.EQ.5)IRREP(4:4)='H'
       IF(NDEG.EQ.3)THEN
        ETAP=0.5D0*(1.D0+SQRT(5.D0))
        ETAM=0.5D0*(1.D0-SQRT(5.D0))
        CHAR=CHRVEC(1)
        IF(DABS(CHAR-ETAP).LT.TOL)IRREP(3:4)='T1'
        IF(DABS(CHAR-ETAM).LT.TOL)IRREP(3:4)='T2'
       ENDIF
       RETURN
      ELSE
C
C ERROR HANDLING IF PTGRP IS NOT RECOGNIZED IN CODE ABOVE
C
       WRITE(6,2500)PTGRP
2500   FORMAT(T3,'@DETIRR-W, Point group ',A,' unknown.')
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_DERV_DEF_BLOCKS
     +
     +                    ( ZMAX,
     +                      NPGTOA,NPGTOB,
     +                      SHELLA,SHELLB,SHELLP,
     +                      NIJ,NRS,
     +                      NXYZT,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      L1CACHE,NCTROW,
     +                      MEMORY,
     +
     +                              NIJBLK,
     +                              NBATCH,
     +                              NPSIZE,NCSIZE,NWSIZE,
     +                              NINT1DX,NINT1DY,NINT1DZ,
     +                              MXPRIM,MNPRIM,
     +                              ZCBATCH,ZPBATCH,ZWORK,
     +                              ZNORMA,ZNORMB,
     +                              ZRHOAB,
     +                              ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +                              ZEXP2A,ZEXP2B,
     +                              ZINT1DX,ZINT1DY,ZINT1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_DERV_DEF_BLOCKS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the memory partitions for the
C                generation of the entire contracted derivative (a|b)
C                overlap batch. It determines the block size partitions
C                (if any) for the ij exponent paris of the whole
C                primitive [a|b] batch and returns pointers to the flp
C                data sections needed by the (a|b) generation.
C
C                The routine is also equipped with the possibility
C                of returning just the minimum / optimum flp memory
C                needed, without evaluating the (a|b) generation flp
C                pointers. This is useful for establishing just the
C                overall memory size needed for the (a|b) generation.
C                The keyword MEMORY has to be set true for this case
C                and obviously the value of ZMAX passed is irrelevant.
C
C
C                  Input:
C
C                    ZMAX         =  maximum flp memory
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x=A,B
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    NIJ          =  total # of ij primitive index
C                                    pairs corresponding to the csh
C                                    pairs A,B
C                    NRS          =  total # of rs contraction index
C                                    pairs corresponding to the csh
C                                    pairs A,B
C                    NXYZT        =  total # of cartesian monomial
C                                    pairs
C                    DERxp        =  the order of differentiation on
C                                    centers x = A,B with respect to
C                                    the p = x,y,z coordinates
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    MEMORY       =  if this keyword is true, the
C                                    routine will only determine the
C                                    minimum / optimum flp memory and
C                                    store these values into NPSIZE and
C                                    NCSIZE, respectively (see below)
C
C                  Output:
C
C                    NIJBLK       =  contains the block size for the
C                                    ij primitive indices in order to
C                                    perform efficient contractions.
C                    NBATCH       =  size of the integral batch array
C                                    during primitive integral block
C                                    generation. This array is also
C                                    needed for 1D integral derivative
C                                    evaluation, hence its size might
C                                    be larger than the final primitive
C                                    integral block
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays.
C                                    If MEMORY is true, NPSIZE and
C                                    NCSIZE will contain respectively
C                                    the minimum and optimum flp memory
C                    NINT1Dx      =  space needed for each of the 1D
C                                    x = X,Y,Z integral arrays (they
C                                    might be different due to different
C                                    orders of differentiation for
C                                    each cartesian component)
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = max (i,j)
C                    MNPRIM       =  the minimum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = min (i,j)
C                    Z.....       =  pointers for space partition of
C                                    the flp array (see below)
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                      |  Zone 1  |  Zone 2  |  Zone 3  |
C
C
C                   Zone 1 : final (a|b) derivative batch
C                   Zone 2 : complete set of A,B norms and complete
C                            set (after screening!) of exponential
C                            prefactors
C                   Zone 3 : will be used at two different stages:
C                             i) during derivated primitive [a|b]
C                                block generation
C                            ii) during the contraction stage
C
C
C                While the first two Zones are straightforward in
C                their definition, Zone 3 requires some more detailed
C                explanation:
C
C                 Stage i) : During this stage the primitive blocks
C                            have to be assembled from the derivated
C                            1D integrals, which in turn are generated
C                            in single derivative steps. The derivation
C                            of the 1D integrals needs an extra work
C                            space for accumulation, which will be
C                            provided at the same memory location where
C                            the final primitive block will be. This
C                            can be done, because the primitive block
C                            can only be assembled after! all the
C                            derivated 1D integrals are ready.
C
C                Stage ii) : This stage needs the primitive blocks
C                            plus some workspace for performing the
C                            contraction step.
C
C
C                Memory allocation offsets for the primitive [a|b]
C                derivative batches generation + contraction to (a|b):
C
C
C                  --- Zone 1 ---
C
C                   ZCBATCH = offset for contracted (a|b) batch
C
C                  --- Zone 2 ---
C
C                   ZNORMA = offset for all A norms
C                   ZNORMB = offset for all B norms
C                   ZRHOAB = offset for all AB exponential prefactors
C
C                  --- Zone 3: for Stage i) only ---
C
C                   ZPBATCH = offset for derivated 1D integrals
C                             accumulation work space and for
C                             (blocked) derivated [a|b] batch
C
C                   ZPAX = offset for (blocked) PAX values
C                   ZPAY = offset for (blocked) PAY values
C                   ZPAZ = offset for (blocked) PAZ values
C                   ZPINVHF = offset for (blocked) 1/2P values
C                   ZSCALE = offset for (blocked) scale values
C
C                   ZEXP2A = offset for 2 x A-exponent values
C                   ZEXP2B = offset for 2 x B-exponent values
C
C                   ZINT1DX = offset for (blocked) derivative 1DX
C                             integrals accumulation
C                   ZINT1DY = offset for (blocked) derivative 1DY
C                             integrals accumulation
C                   ZINT1DZ = offset for (blocked) derivative 1DZ
C                             integrals accumulation
C
C                  --- Zone 3: for Stage ii) only ---
C
C                   ZPBATCH = offset for (blocked) derivated [a|b]
C                             batch
C
C                   ZWORK = offset for contraction working array
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     MEMORY

         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     IJDIV
         INTEGER     ISHELLX,ISHELLY,ISHELLZ
         INTEGER     L1CACHE,NCTROW
         INTEGER     MIJ,MIJBIG
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSTEP
         INTEGER     N
         INTEGER     NBATCH
         INTEGER     NIJ,NIJBLK
         INTEGER     NINT1DX,NINT1DY,NINT1DZ
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NRS
         INTEGER     NXYZT
         INTEGER     PFACT
         INTEGER     POW2IJ
         INTEGER     PSHELL
         INTEGER     SHELLA,SHELLB,SHELLP
         INTEGER     SHELLX,SHELLY,SHELLZ
         INTEGER     WCOL
         INTEGER     ZMAX
         INTEGER     ZONE1,ZONE2,ZONE3,ZONE3B,ZONE3C
         INTEGER     ZONEMIN,ZONEOPT
         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,ZRHOAB,
     +               ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +               ZEXP2A,ZEXP2B,
     +               ZINT1DX,ZINT1DY,ZINT1DZ

         DOUBLE PRECISION   DLOG2

         PARAMETER  (DLOG2  =  0.6931471805599D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine optimum size of [a|b] blocks:
C
C                The next few lines of code are among the most
C                important for performance of the entire overlap
C                integral package. Any badly chosen sizes for the
C                primitive blocks has a severe effect on the integral
C                evaluation timing. Two opposite effects have
C                to be considered:
C
C                1) Reuse level 1 cache data as much as possible,
C                   i.e. choose the primitive blocks in such a
C                   way that most of the heavy computational work
C                   is being done reusing data in each cache line.
C
C                2) Choose the size of the primitive blocks as
C                   large as possible observing point 1), to reduce
C                   subroutine call overheads as much as possible.
C
C                After some experimenting, the following procedure
C                was found to work best:
C
C                  i) The optimum [a|b] block size is assumed to
C                     be directly proportional to the level 1 cache
C                     size.
C
C                 ii) The proportionality factor PFACT has to be
C                     determined by 'experiment', running a real
C                     molecular case with fully contracted basis sets.
C
C
         PFACT = 4

         MIJ = PFACT * L1CACHE / NXYZT
         MIJ = MAX (1,MIJ)
         MIJ = MIN (MIJ,NIJ)
C
C
C             ...the optimum block size MIJ has been determined.
C                We have to see now how it fits with the rest of
C                the needed data into the maximum memory given.
C                If necessary subdivide the optimum MIJ block size
C                into convenient subblocks that fit into memory.
C
C                The subdivision of the MIJ block is done in such
C                a way that successive powers of 2 are checked as
C                divisors of MIJ. The maximum # of division steps
C                MXSTEP can thus be calculated beforehand by knowing
C                the fact that the smallest subdivided MIJ block
C                is of size 1. The succesive divisors are checked
C                in the following order:
C
C
C                            step  |  div of MIJ
C                           ----------------------
C                              1   |       1
C                              2   |       2
C                              3   |       4
C                              4   |       8
C                              5   |      16
C                             ...         ...
C
C                The routine stops, if even a MIJ block of minimum
C                size 1 cannot be accomodated into the memory.
C
C
         SHELLX =   (SHELLP + DERAX + DERBX + 1)
     +            * MIN ((SHELLA + DERAX + 1),(SHELLB + DERBX + 1))
         SHELLY =   (SHELLP + DERAY + DERBY + 1)
     +            * MIN ((SHELLA + DERAY + 1),(SHELLB + DERBY + 1))
         SHELLZ =   (SHELLP + DERAZ + DERBZ + 1)
     +            * MIN ((SHELLA + DERAZ + 1),(SHELLB + DERBZ + 1))

         PSHELL = MAX (SHELLX,SHELLY,SHELLZ)

         ISHELLX = (SHELLA + DERAX + 1) * (SHELLB + DERBX + 1)
         ISHELLY = (SHELLA + DERAY + 1) * (SHELLB + DERBY + 1)
         ISHELLZ = (SHELLA + DERAZ + 1) * (SHELLB + DERBZ + 1)

         MXPRIM = MAX (NPGTOA,NPGTOB)
         MNPRIM = MIN (NPGTOA,NPGTOB)

         NCSIZE  = NXYZT * NRS

         ZONE2 = NPGTOA + NPGTOB + NIJ
C
C
C             ...if the MEMORY keyword is activated, the routine
C                will only determine the optimum and minimum flp
C                memory (in that order), place them respectively
C                into the NCSIZE and NPSIZE variables and exit.
C
C
         IF (MEMORY) THEN

             NINT1DX = MIJ * ISHELLX
             NINT1DY = MIJ * ISHELLY
             NINT1DZ = MIJ * ISHELLZ
             NBATCH  = MIJ * MAX (PSHELL,NXYZT)
             NPSIZE  = NXYZT * MIJ
             WCOL    = MNPRIM
             NWSIZE  = NCTROW * WCOL
             NPSIZE  = MAX (NPSIZE,NWSIZE)
             NWSIZE  = NPSIZE
             ZONE1   = NCSIZE
             ZONE3B  = NBATCH + NINT1DX + NINT1DY + NINT1DZ + 7*MIJ
             ZONE3C  = NPSIZE + NWSIZE
             ZONE3   = MAX (ZONE3B,ZONE3C)

             ZONEOPT = ZONE1 + ZONE2 + ZONE3

             MIJ     = 1
             NINT1DX = MIJ * ISHELLX
             NINT1DY = MIJ * ISHELLY
             NINT1DZ = MIJ * ISHELLZ
             NBATCH  = MIJ * MAX (PSHELL,NXYZT)
             NPSIZE  = NXYZT * MIJ
             WCOL    = MNPRIM
             NWSIZE  = NCTROW * WCOL
             NPSIZE  = MAX (NPSIZE,NWSIZE)
             NWSIZE  = NPSIZE
             ZONE1   = NCSIZE
             ZONE3B  = NBATCH + NINT1DX + NINT1DY + NINT1DZ + 7*MIJ
             ZONE3C  = NPSIZE + NWSIZE
             ZONE3   = MAX (ZONE3B,ZONE3C)

             ZONEMIN = ZONE1 + ZONE2 + ZONE3

             NPSIZE  = ZONEMIN
             NCSIZE  = ZONEOPT

             RETURN

         ELSE
C
C
C             ...the actual fitting into the maximum memory given.
C
C
             POW2IJ = DLOG ( DFLOAT (MIJ) ) / DLOG2
             MXSTEP = POW2IJ + 1

             IJDIV = 1
             MIJBIG = MIJ

             DO 100 N = 1,MXSTEP

                MIJ = MAX (1, MIJBIG / IJDIV )

                NINT1DX = MIJ * ISHELLX
                NINT1DY = MIJ * ISHELLY
                NINT1DZ = MIJ * ISHELLZ
                NBATCH  = MIJ * MAX (PSHELL,NXYZT)
                NPSIZE  = NXYZT * MIJ
                WCOL    = MNPRIM
                NWSIZE  = NCTROW * WCOL
                NPSIZE  = MAX (NPSIZE,NWSIZE)
                NWSIZE  = NPSIZE
                ZONE1   = NCSIZE
                ZONE3B  = NBATCH + NINT1DX + NINT1DY + NINT1DZ + 7*MIJ
                ZONE3C  = NPSIZE + NWSIZE
                ZONE3   = MAX (ZONE3B,ZONE3C)

                IF (ZONE1+ZONE2+ZONE3.LE.ZMAX) THEN

                    NIJBLK = MIJ
                    NWSIZE = ZMAX - ZONE1 - ZONE2 - NPSIZE
C
C
C             ...generate the memory allocation pointers.
C
C
                    ZCBATCH = 1

                    ZNORMA = ZCBATCH + NCSIZE
                    ZNORMB = ZNORMA + NPGTOA
                    ZRHOAB = ZNORMB + NPGTOB

                    ZPBATCH = ZRHOAB + NIJ

                    ZPAX = ZPBATCH + NBATCH
                    ZPAY = ZPAX + MIJ
                    ZPAZ = ZPAY + MIJ
                    ZPINVHF = ZPAZ + MIJ
                    ZSCALE = ZPINVHF + MIJ

                    ZEXP2A = ZSCALE + MIJ
                    ZEXP2B = ZEXP2A + MIJ

                    ZINT1DX = ZEXP2B + MIJ
                    ZINT1DY = ZINT1DX + NINT1DX
                    ZINT1DZ = ZINT1DY + NINT1DY

                    ZWORK = ZPBATCH + NPSIZE

                    RETURN
                END IF

                IJDIV = IJDIV + IJDIV

  100        CONTINUE

             WRITE (*,*) ' Memory allocation failed for derv (a|b) ! '
             WRITE (*,*) ' NIJ,MIJ = ',NIJ,MIJ
             WRITE (*,*) ' Increase flp memory! '
             WRITE (*,*) ' (oed__ovl_derv_def_blocks) '

             STOP

         END IF
C
C
C             ...ready!
C
C
         END

      SUBROUTINE PUTALL(Z,LENGTH,IRREPX,LSTNUM)
C
C THIS ROUTINE WRITES OUT ALL IRREPS OF A SYMMETRY PACKED DISTRIBUTION.
C
C      Z  - VECTOR HOLDING THE LIST.
C  LENGTH - THE TOTAL LENGTH.
C  ICACHE - THE CACHE TO BE USED IN I/O OPERATIONS.
C  LSTNUM - THE LIST NUMBER WHICH Z IS WRITTEN TO.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(LENGTH)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),D(18)
C
C  LOOP OVER IRREPS.
C
      IOFF=1
      ILIST=LSTNUM
      DO 10 IRREPR=1,NIRREP
       IRREPL=DIRPRD(IRREPR,IRREPX)
C
C GET NUMBER OF DISTRIBUTIONS AND DISTRIBUTION SIZE.
C
       NUMDIS=IRPDPD(IRREPR,ISYTYP(2,ILIST))
       DISSIZ=IRPDPD(IRREPL,ISYTYP(1,ILIST))
C
C PLUNK VECTOR ON MOINTS.
C
       IF(NUMDIS.EQ.0)GOTO 10
       CALL PUTLST(Z(IOFF),1,NUMDIS,1,IRREPR,LSTNUM)
       IOFF=IOFF+NUMDIS*DISSIZ
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine finalizes the job archive environment (via the JAINDX file)
c in order for getrec and putrec to work properly for other member executables.

#include "jobarc.h"

      subroutine aces_ja_fin
      implicit none

c INTERNAL VARIABLES
      character*80 szJAINDX
      integer       iJAINDX
      integer i, iStat
      logical bOpened

c COMMON BLOCKS
#include "jobarc.com"

c ----------------------------------------------------------------------

c   o make sure the job archive subsystem is up
      if (.not.bJAUp) return

#ifdef _TAG_JA_DIRTY
c   o mark the job archive as closed
      call iputrec(1,'JOBARC','JADIRTY',1,0)
#endif

#ifndef OPEN_JOBARC_AS_NEEDED
c   o close the JOBARC file
      inquire(unit=_JA_UNIT,opened=bOpened,err=666,iostat=iStat)
      if (bOpened) then
         close(unit=_JA_UNIT,status='KEEP',err=666,iostat=iStat)
      end if
#endif

c   o only update JAINDX if a record has been added
      if (bJAMod) then

c      o update JAINDX (dump the jobarc common block)
         call gfname('JAINDX',szJAINDX,iJAINDX)
         open(unit=_JA_UNIT,file=szJAINDX(1:iJAINDX),
     &        form='UNFORMATTED',status='UNKNOWN',err=666,iostat=iStat)
         rewind(_JA_UNIT,err=666,iostat=iStat)
         write(_JA_UNIT,err=666,iostat=iStat) marker, rloc, rsize, nrecs
         close(unit=_JA_UNIT,status='KEEP',err=666,iostat=iStat)
c      o reset the JOBARC modification flag
         bJAMod = .false.
c     end if (bJAMod)
      end if

#ifdef _DEBUG
c   o destroy the jobarc contents so nothing gets "lost"
      do i = 1, _MAX_JA_RECS
         marker(i) = ' '
      end do
#endif

c   o turn off the job archive subsystem flag
      bJAUp = .false.

      return

c   o I/O error
 666  print *, '@ACES_JA_FIN: I/O error'
      print '(/)'
c      call aces_io_error('ACES_JA_FIN',_JA_UNIT,iStat)
      call abort_job()

c     end subroutine aces_ja_fin
      end

      SUBROUTINE ANALYZE(SCRATCH,A)
C
C ANALYZES INTERNAL COORDINATE STRUCTURE, OBTAINS NUMBER OF
C CONFORMATIONAL DEGREES OF FREEDOM AND CHECKS FOR OBVIOUS
C REDUNDANCIES AND POTENTIAL ERRORS IN THE Z-MATRIX INPUT.
C SCRATCH IS THE SAME VECTOR USED IN SUBROUTINE SYMMETRY.
C THIS REQUIRES THE TRANSFORMATION MATRIX FROM CARTESIAN
C DERIVATIVES TO INTERNAL DERIVATIVES, AND USES A SIMPLE
C TOTALLY SYMMETRIC PROPERTY (CLOSELY RELATED TO THE NUCLEAR
C REPULSION ENERGY) AS A REFERENCE FUNTION.  NORD IS A AN
C INTEGER SCRATCH ARRAY USED ONLY HERE AND IN DEPENDENTS.
C
C This routine is cleaned up to generate messages that
C make sense for redundent internals. Some of the analysis
C done here is not useful for RICs (not valid). 
C Ajith Perera, 04/2006. 
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)




























































































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


c
      COMMON /MACHSP/ IINTLN, IFLTLN, IINTFP, IALONE, IBITWD
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
C
      DIMENSION SCRATCH(6*NATOMS),NORD(6*MXATMS),A(3*NATOMS,NXM6),
     &          ITIE(3*MxAtms)

      Character*5 ChScr(3*MxAtms)
      LOGICAL RIC_INUSE
      DOUBLE PRECISION ICHGI,ICHGJ
C
      IDIDIT=0
      NDFU=0
      NPFU=0
      ITRASH=0
      IPNDAP=0
      IERR=0
      IERROR=0
      ZREPUL=0.D0
      ICOORE=0
      RIC_INUSE = ((iFlags2(5) .EQ. 3  .OR.
     &              iFlags2(5) .EQ. 4) .AND.
     &              iFlags(68)      .EQ. 1)
C
C LOOP THROUGH CARTESIAN COORDINATES AND OBTAIN DERIVATIVES
C OF THE REFERENCE FUNCTION WRT TO CARTESIAN DISPLACEMENTS.  DONE
C ANALYTICALLY.
C
      CALL ZERO(SCRATCH,6*NATOMS)
      Write(6,*)
      WRITE(6,*)' R VECTOR IN ANALYZE '
      Write(6,*)
      WRITE(6,'(3f20.12)')(R(I),I=1,NXM6)
14    FORMAT(3(2X,I2))
      Write(6,*)
      WRITE(6,"(6I4)")(IATNUM(J),J=1,NATOMS) 
      NOPT0=NOPT
      NDERIV=0
      WRITE(6,150)
      WRITE(6,149)
      WRITE(6,150)
      CALL NUCREP(ZREPUL,ICOORE)
C
      IF(ICOORE.NE.0)THEN
       WRITE(6,547)
       WRITE(6,158)
       WRITE(6,150)
      ELSE
       WRITE(6,546)ZREPUL
       call putrec(1, ' ', 'NUCREP', iintfp, zrepul )
      ENDIF
C
149   FORMAT(T3,' Analysis of internal coordinates specified by '
     &,'Z-matrix ')
150   FORMAT(80('-'))
158   FORMAT(T3,' Thank you for using the ACES2 program system.')
546   FORMAT(T3,' *The nuclear repulsion energy is ',f10.5,' a.u.')
547   FORMAT(T3,' **PROGRAM ERROR** Problem with coordinate vector.')
C
      CALL VADD(SCRATCH,SCRATCH,Q,3*NATOMS,1.D0)
C
C EVALUATE DERIVATIVES IN CARTESIAN REPRESENTATION.
C DIFFERENTIATED FUNCTION IS:
C
C         SUM    [CHARGE(I)*CHARGE(J)]**0.50/d(I,J)
C         I<J
C (TAKING ROOT REDUCES SIZE OF SCALING FACTOR
C  FOR HEAVY--HEAVY INTERACTIONS)
C
      DO 10 I=1, 3*NATOMS
        IXYZ=MOD(I,3)
        IF(IXYZ.EQ.0)IXYZ=3
        ICUT=3-IXYZ
        IATOMI=(I+2)/3
        IF(IATNUM(IATOMI).EQ.0)GOTO 10
        ICHGI=DFLOAT(IATNUM(IATOMI))**0.50
        JBOT=3-ICUT
        ZARF=0.D0
        DO 50 J=JBOT,3*NATOMS,3
         IF(J.EQ.I)GOTO 50
         IATOMJ=(J+2)/3
         IF(IATNUM(IATOMJ).EQ.0)GOTO 50
         ICHGJ=DFLOAT(IATNUM(IATOMJ))**0.50
         DISIJ=DIST(Q(3*IATOMI-2),Q(3*IATOMJ-2))
         FACTOR=ICHGI*ICHGJ/DISIJ**3
         ZARF=ZARF+FACTOR*(SCRATCH(I)-SCRATCH(J))
 50     CONTINUE
        SCRATCH(3*NATOMS+I)=ZARF
 10   CONTINUE
C 
C
C NOW DETERMINE TOTAL NUMBER OF DEGREES OF FREEDOM WITHIN THE
C TOTALLY SYMMETRIC SUBSPACE.
C
      ITRNDF=ITNDF()
C
C DERIVATIVE VECTOR NOW IN TOP HALF OF SCRATCH.  TRANSFORM IT
C TO INTERNAL COORDINATES, PLACED IN LOWER PART OF SCRATCH.
C
      CALL ZERO(SCRATCH,3*NATOMS)
      DO 35 J=1,NXM6
      Z1=0.D0
      DO 15 I=1,3*NATOMS
15    Z1=SCRATCH(3*NATOMS+I)*A(I,J)+Z1
35    SCRATCH(J)=Z1
C
C
C NOW GO THROUGH LIST OF OPTIMIZED PARAMETERS, COUNTING NUMBER OF
C PROBABLE POSITIVE/NEGATIVE DIHEDRAL ANGLE PAIRS.  THEN
C EVENTUALLY (AT THE BOTTOM OF THE 30 DO LOOP)
C DECREMENT NUMBER OF "Z-MATRIX DEGREES OF FREEDOM" (NUMBER
C OF "INDEPENDENTLY" ADJUSTED PARAMETERS) BY THIS NUMBER.
C
      IF ((iFlags2(5) .EQ. 1)) THEN
C
C This test is meaningless for Cartesian opts.
C
      DO 423 I=1,NOPT
       ISTP=0
       DO 424 J=I+1,NOPT
        IF(ISTP.NE.0)GOTO 424
        ZIF=DABS(R(ISQUASH(NOPTI(I)))+R(ISQUASH(NOPTI(J))))
        IF(ZIF.LT.1.D-6)THEN
         ZIF2=DABS(SCRATCH(NOPTI(I))+SCRATCH(NOPTI(J)))
         IF(ZIF2.LT.1.D-6.AND.DABS(R(ISQUASH(NOPTI(J))))
     &   .GT.1.D-6)THEN
          IPNDAP=IPNDAP+1
C
C Keep track of the dihedral pairs, 05/2011
C       
          ITIE(I) = IPNDAP
          ITIE(J) = IPNDAP
C
          ISTP=1
         ENDIF
        ENDIF
424    CONTINUE
423   CONTINUE
C
C Endif of iFlags2(5) .EQ.1 
C
      CALL PUTREC(20,'JOBARC','TIEDCORD',3*MXATMS,ITIE)
      ENDIF
C
C SORT INTERNAL COORDINATE DERIVATIVE VECTOR AND THEN ANALYZE IT.
C
      DO 20 I=1,NXM6
      NORD(I)=I
20    SCRATCH(I)=DABS(SCRATCH(I))
      CALL PIKSR2(NXM6,SCRATCH,NORD)
      NDF=0
C      IF(SCRATCH(1).GT.1.D-6)NDERIV=1
C
C FIRST CHECK TO SEE IF ALL INTERNAL COORDINATES WITH THE
C SAME NAME ARE APPARENTLY EQUIVALENT.
C
      DO 501 K = 1, NOPT
         DO 502 I = 1, NXM6-1
         IF (VARNAM(ISQUASH(NORD(I))).EQ.PARNAM(K)) THEN
            DO 503 J = I+1, NXM6
            IF (VARNAM(ISQUASH(NORD(J))).EQ.PARNAM(K)) THEN
               DENOM = DABS(SCRATCH(I))
               IF (DENOM.LT.1.D-12) DENOM = 1.D0
               CRIT = DABS(SCRATCH(I)-SCRATCH(J))/DENOM
               IF (CRIT.GE.1.D-4) THEN
                  WRITE(6,155) NORD(I),NORD(J),VARNAM(ISQUASH(NORD(I)))
                  IERROR = 1
               END IF
            END IF
 503        CONTINUE
         END IF
 502     CONTINUE
 501  CONTINUE
C
      IF(IERROR.EQ.1)THEN
        WRITE(6,311)
        WRITE(6,158)
        WRITE(6,150)
        Call ErrEx
      ENDIF
C
155   FORMAT(T3,'*ERROR* Parameters ',i2,' and ',i2,' are not '
     &,'equivalent [both called ',a5,'].')
311   FORMAT(T3,' *Reconstruct Z-matrix and try again.')
C
C NOW LOOP THROUGH PARAMETERS WHICH ARE TO BE OPTIMIZED TO
C MAKE SURE THAT ALL OF THESE CAN HAVE NON-ZERO GRADIENTS.
C
      IF ((iFlags2(5) .EQ. 1)) THEN
C
C This test is meaningless for pure Cartesian optmizations.
C
      DO 840 I=1,NOPT
      CHSCR(1)=PARNAM(I)
       IERR=0
       DO 841 J=1,NXM6
       IF(VARNAM(ISQUASH(NORD(J))).EQ.CHSCR(1).AND.
     &    SCRATCH(J).LT.1.D-8)THEN
          WRITE(6,159)VARNAM(ISQUASH(NORD(J))),
     &    NORD(J)
       IERR=IERR+1
       ENDIF
 841   CONTINUE
C
       IF(IERR.GE.1)THEN
       ITRASH=ITRASH+1
       ENDIF
 840   CONTINUE
C
      ENDIF
C
      IBOT=1
      NPNDPC=0
      NOPNPC=0
      DO 30 I=1,NXM6
      IQUIT=0
      DENOM=DABS(SCRATCH(I))
      IF(DENOM.GT.1.D-15)THEN
       ZIFF=DABS(SCRATCH(I+1)-SCRATCH(I))/DENOM
      ELSE
       ZIFF=DABS(SCRATCH(I+1)-SCRATCH(I))
      ENDIF
C
159   FORMAT(T3,'*WARNING* Parameter ',a5,'[',i3,'] cannot have '
     &,'a nonzero derivative,',/,T4,' but is being optimized. '
     &,' Reconstruction of Z-matrix recommended.')
C
      IF ((iFlags2(5) .EQ. 1)) THEN
C
C This test is meaningless for full Cartesian opts.
C
      IF(ZIFF.LT.1.D-4)THEN
         IF(DABS(SCRATCH(I)).GT.1.D-6)THEN 
C
C CHECK NOW FOR APPARENT EQUIVALENCES BETWEEN PARAMETERS HAVING
C DIFFERENT NAMES.  IF AN EVENT IS ENCOUNTERED, CHECK FIRST TO
C SEE IF IT IS A POS/NEG DIHEDRAL ANGLE PAIR.  IF IT ISN'T PRINT
C WARNING MESSAGE.  R IS UNSQUASHED IN THIS ROUTINE.
C
        IF(IPRNT.GE.100)WRITE(6,154)
     &     VARNAM(ISQUASH(NORD(I+1))),
     &     VARNAM(ISQUASH(NORD(IBOT)))
C
        IF(VARNAM(ISQUASH(NORD(I+1))).NE.
     &   VARNAM(ISQUASH(NORD(IBOT))))THEN
         CRIT=DABS(R(ISQUASH(NORD(I+1)))+R(ISQUASH(NORD(IBOT))))
         IF(CRIT.LT.1.D-8 .AND.  .NOT. RIC_INUSE)THEN
          WRITE(6,169)VARNAM(ISQUASH(NORD(I+1))),
     &    VARNAM(ISQUASH(NORD(IBOT)))
         ELSE
C
C THIS IS PROBABLY A POS/NEG DIHEDRAL ANGLE PAIR.  THIS IS NOT
C A PROBLEM. EXIT LOOP.
C
         ENDIF
        ENDIF
       ENDIF
C Endif for (iFlags2(5) .EQ. 1)
       ENDIF
C
154   FORMAT(2X,A5,2X,A5,2X,'(*')
169   FORMAT(T3,'*WARNING* Parameters ',a5,' and ',a5,' appear '
     &,'to be equivalent.')
C
      ELSE
C
C NEW VARIABLE.  (NPNDAP IS NUMBER
C OF POSITIVE/NEGATIVE DIHEDRAL ANGLE PAIRS WHICH CAN HAVE NONZERO
C DERIVATIVES, NOPNDP IS NUMBER OF THESE THAT ARE OPTIMIZED).
C INCREMENT NDERIV (THE NUMBER OF DISTINCT PARAMETERS WHICH CAN
C HAVE NONVANISHING GRADIENTS).
C
       IBOT=I+1
       IDID=0
       IDID2=0
       IF(SCRATCH(I).GT.1.D-8)NDERIV=NDERIV+1
       IF(IPRNT.GE.100)WRITE(6,157)NDERIV,I
       NORD(NX+NDERIV)=NORD(I)
       IATOM=(NORD(I)+8)/3
       IF(NORD(I).EQ.1)IATOM=2
       IF(IPRNT.GE.100)WRITE(6,*)IATOM,ZIFF,SCRATCH(I)
       IF(ATMASS(IATOM).LT.1.D-3)THEN
C
C DUMMY ATOM.  NOW SEE IF THERE IS AN EQUIVALENT VALUE WHICH CORRESPONDS
C TO ONE OF THE ATOMIC ICs.  RIGHT NOW, THIS INFORMATION IS NOT USED
C EXTENSIVELY, BUT IT MAY PROVE USEFUL WHEN WE FIGURE OUT A WAY TO
C DETERMINE HOW MANY OF THE Z-MATRIX PARAMETERS HAVE TO BE VARIED TO
C RELEASE ALL CONSTRAINTS ON THE OPTIMIZATION (NOT ALWAYS EQUAL TO ITRN
C
        NDFU=NDFU+1
        IPSO=0
        DO 33 J=I-1,1,-1
         IF(IPSO.EQ.1)GOTO 33
         ZIFF2=DABS(SCRATCH(J)-SCRATCH(I))
         IF(ZIFF2.GT.1.D-5)GOTO 33
         JATOM=(NORD(J)+8)/3
         IF(NORD(J).EQ.1)JATOM=2
         IF(ATMASS(JATOM).GT.1.D-3)THEN
          NDF=NDF+1
          IPSO=1
          ZREF=R(NORD(I))
         ENDIF
33      CONTINUE
        GOTO 30
       ENDIF
       IF(SCRATCH(I).LT.1.D-8)GOTO 30
       ZREF=R(NORD(I))
       NDF=NDF+1
       NDFU=NDFU+1
       IF(IPRNT.GE.100)WRITE(6,88)I,NDF
      ENDIF
30    CONTINUE
C
      NOPT0=NOPT-IPNDAP
C
 88   FORMAT(T3,' On cycle ',i2,' NDF incremented to ',i3)
157   FORMAT(T3,' NDERIV incremented to ',i2,' on cycle ',i3)
C
C NOW PRINT OUT WHAT WE HAVE LEARNED.
C
C WRITE(6,170)NDF (WE DON'T KNOW HOW TO DETERMINE THIS YET.)
C170  FORMAT(T3,' *In the Z-matrix, there are ',i3,' parameters which '
C ,'must be optimized.')
C
      IF(ITRNDF.EQ.1)WRITE(6,152)ITRNDF
C
C This is somewhat cheating. In the case of RIC we assume all the
C degrees of freedoms that are optimized belong to the totally 
C symmetric subspace (until we develop a routine similar to ITNDF
C that works with RICs not with Cartesian directions per symmetry
C equivalent atoms. It can be done. All we need is to find out
C how many uniques RICs and then subtract the rotational and vibrational
C degrees of freedoms that transform as totaly symm. Unfotunately, 
C I don't see the value of it since redundent simply implies 
C that we are optimizing more than minimum required. Ajith Perera,04/2006. 
C
      IF(ITRNDF.GT.1 .AND. .NOT. RIC_INUSE) THEN
        WRITE(6,151)ITRNDF
      ELSE
        WRITE(6,151)NOPT
      ENDIF
C
      WRITE(6,171)NOPT
      IF(IPNDAP.GT.0)THEN
         WRITE(6,545)IPNDAP,NOPT0
      ENDIF
      ICON=2
C
      IF (RIC_INUSE) THEN
          ICON =0
          WRITE(6,176) 
      ELSE
C 
         IF(ITRNDF.EQ.NOPT0.AND.ITRASH.EQ.0.AND.NDERIV.EQ.ITRNDF)THEN
            WRITE(6,172)
            ICON=0
         ELSEIF(ITRNDF.EQ.NOPT0.AND.ITRASH.EQ.0.AND.NDERIV.GT.
     &          ITRNDF)THEN
            WRITE(6,142)
            ICON=11
         ELSEIF(ITRNDF.GT.NOPT0)THEN
            ICON=-1
            WRITE(6,173)
         ELSEIF(ITRNDF.LT.NOPT0.AND.NDERIV.EQ.NOPT0)THEN
            ICON=1
            WRITE(6,174)
         ELSEIF(ITRNDF.LT.NOPT0.AND.NDERIV.GT.NOPT0)THEN
            ICON=6
            WRITE(6,178)
         ENDIF
      ENDIF
C
142   FORMAT(T3,' *Although the number of optimized parameters is '
     &,'equal to the true ',/,t4,' number of degrees of freedom, '
     &,' the optimization may be constrained.')
151   FORMAT(T3,' *There are ',i3,' degrees of freedom within the '
     &,'tot. symm. molecular subspace.')
152   FORMAT(T3,' *There is ',i3,' degree of freedom within the '
     &,'tot. symm. molecular subspace.')
171   FORMAT(T3,' *Z-matrix requests optimization of ',i3,
     &' coordinates.')
172   FORMAT(T3,' *The optimization is unconstrained and your Z-matrix '
     &,'is great.')
173   FORMAT(T3,' *The optimization is constrained.')
174   FORMAT(T3,' *The optimization problem may be overdetermined:')
176   FORMAT(T3,' *The RIC optimization is unconstrained and your',  
     &       ' input is great.')
178   FORMAT(T3,' *The optimization problem is poorly defined by '
     &,'your Z-matrix, and may be',/,T4,'overdetermined.')
545   FORMAT(T3,' *There are ',i3,' positive-negative dihedral '
     &,'angle pairs, ',/,t4,' resulting in ',i3,' Z-matrix '
     &,'degrees of freedom.')
C
      IF(ICON.NE.0)THEN
C 
       WRITE(6,180)NDERIV
       WRITE(6,181)(VARNAM(ISQUASH(NORD
     &    (3*NATOMS+J))),NORD(3*NATOMS+J),J=1,NDERIV)
       WRITE(6,183)NOPT
       WRITE(6,181)(PARNAM(K),NOPTI(K),K=1,NOPT)
C
C
180   FORMAT(T3,' *The following ',I3,' parameters can have non-zero',
     &      'derivatives within the ',/,t4, ' totally symmetric ',
     &       'subspace:')
181   FORMAT((T14,6(A5,'[',I3,']',2x)))
183   FORMAT(T3,' *The following ',I3,' parameters are to be '
     & ,'optimized:')
C
C BLOW OFF THIS LOOP IF NPFU.NE.0 -  THIS IS LIKELY TO BE UNUSUAL
C (CORRESPONDING TO OPTIMIZING ONLY ONE PART OF AN EQUIVALENT
C POS/NEG DIHEDRAL PAIR).  WITH MORE THOUGHT, THIS LOOP CAN BE
C ADJUSTED FOR NONZERO NPFUs, BUT LEAVE IT OUT FOR NOW.
C
       IF(NPFU.EQ.0)THEN
        IF(ICON.EQ.11)WRITE(6,198)
        IF(ICON.EQ.-1.AND.NDF.NE.NDFU)WRITE(6,191)ITRNDF-NOPT0
C
        IF(ICON.EQ.11)THEN
         WRITE(6,190)
         WRITE(6,290)
        ENDIF
C
        IF(ICON.EQ.1)THEN
         WRITE(6,193)NOPT0-ITRNDF
        ENDIF
C
        IF(ICON.EQ.6)THEN
         WRITE(6,193)NOPT0-ITRNDF
         WRITE(6,190)
        ENDIF

190   FORMAT(T3,' *Care should be taken that the following coordinates '
     &,'are dependent ',/,t4,' upon the set of optimized parameters.')
193   FORMAT(T3,' *Among the set of internal coordinates listed above, '
     &,'it is possible that ',/,t4,' as many as ',i3,' may be fixed ')
198   FORMAT(T3,' *There is room for improvement in the Z-matrix.')
290   FORMAT(T3,' *If this is true, optimization is unconstrained.')
191   FORMAT(T3,' *Among the set of internal coordinates listed below, '
     &,'at least ',/,t4,i3,' must be allowed to vary.  Those not '
     &,'varied must not be independent',/,t4,' coordinates.')
C
        IF(ICON.EQ.-1.AND.NDF.EQ.NDFU)WRITE(6,192)
        IDEP=0
C
        DO 890 I=1,NDERIV
         IDP=0
         DO 891 J=1,NOPT
891      IF(VARNAM(ISQUASH(NORD(3*NATOMS+I))).NE.PARNAM(J))IDP=IDP+1
         IF(IDP.EQ.NOPT)THEN
          IDEP=IDEP+1
          NORD(IDEP)=NORD(3*NATOMS+I)
          CHSCR(IDEP)=VARNAM(ISQUASH(NORD(3*NATOMS+I)))
         ENDIF
890     CONTINUE
C
        WRITE(6,181)(CHSCR(JX),NORD(JX),JX=1,IDEP)
        WRITE(6,150)
        IDIDIT=1
C
       ENDIF
      ENDIF
      IF(IDIDIT.EQ.0)WRITE(6,150)
C
80    FORMAT(3(2X,F20.14))

 192   FORMAT(T3,' *The following coordinates must be varied in an '
     &,' unconstrained optimization.')
C
      RETURN
      END
C
CSSS129   FORMAT(T3,' *Parameters ',a5,' and ',a5,' are '
CSSS     &     ,'a pos/neg dihedral angle pair.')
CSSS141   FORMAT(T3,' *The optimization will be unconstrained only if '
CSSS     &,'the following parameters',/,t4,' do not represent independent '
CSSS     &,'coordinates.')
CSSS145   FORMAT(T3,' *All of these are optimized, meaning that '
CSSS     &,'that there ',/,t4,' are ',i3,' Z-matrix degrees of '
CSSS     &,'freedom.')
CSSS192   FORMAT(T3,' *The following coordinates must be varied in an '
CSSS     &,' unconstrained optimization.')
CSSS345   FORMAT(T3,' *Of these,',i3,' are optimized, meaning that '
CSSS     &,'that there ',/,t4,' are ',i3,' Z-matrix degrees of '
CSSS     &,'freedom.')

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_t3blocks_a(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c  The arrays to be used in the (T 4v) calculation are defined and their 
c  handles put into a common block.  
c  Input: array index of array to be used in compt3a  
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'saved_data.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer array, array_type, nscalar_table, sind 
      double precision scalar_table(nscalar_table), tind 
      integer*8 address_table(narray_table)

      integer Na, i, j, k
      integer flag, handle, index, nindex, ierr
      integer blk, blkndx

      integer t3ablocks  
      common /T3a_blocks/Na, t3ablocks(20) 

c-------------------------------------------------------------------------
c   Put the array index in the appropriate slot.
c-------------------------------------------------------------------------

      array      = op(c_op1_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The Second argument in set_t3_blocksa  
     *            must be a scalar.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in set_t3_blocksa, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

      tind = scalar_table(sind)

      handle = op(c_result_array)
      if (tind .eq. 1.0) t3ablocks(1) = handle 
      if (tind .eq. 2.0) t3ablocks(2) = handle 
      if (tind .eq. 3.0) t3ablocks(3) = handle 
      if (tind .eq. 4.0) t3ablocks(4) = handle 
      if (tind .eq. 5.0) t3ablocks(5) = handle 
      if (tind .eq. 6.0) t3ablocks(6) = handle 
      if (tind .eq. 7.0) t3ablocks(7) = handle 
      if (tind .eq. 8.0) t3ablocks(8) = handle 
      if (tind .eq. 9.0) t3ablocks(9) = handle 
      if (tind .eq. 10.0) t3ablocks(10) = handle 
      if (tind .eq. 11.0) t3ablocks(11) = handle 
      if (tind .eq. 12.0) t3ablocks(12) = handle 
      if (tind .eq. 13.0) t3ablocks(13) = handle 
      if (tind .eq. 14.0) t3ablocks(14) = handle 
      if (tind .eq. 15.0) t3ablocks(15) = handle 
      if (tind .eq. 16.0) t3ablocks(16) = handle 
      if (tind .eq. 17.0) t3ablocks(17) = handle 
      if (tind .eq. 18.0) t3ablocks(18) = handle 
      if (tind .eq. 19.0) t3ablocks(19) = handle 
      if (tind .eq. 20.0) t3ablocks(20) = handle 

      if (tind .gt. 20.0) then 
         write(6,*) ' Only 20 arrays are currently allowed in 
     *                set_t3blocks_a' 
         write(6,*) ' There are at least :', tind 
         call abort_job()
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_geometry(iatom, coord, atom_charge)
c--------------------------------------------------------------------------
c   Stores the atomic charge and geometry data.
c--------------------------------------------------------------------------

      implicit none
      include 'int_gen_parms.h'
      common /flags/ iflags
      integer iflags(100)

      integer iatom
      double precision coord(3)
      double precision atom_charge  
      integer i

      if (iatom .gt. max_centers .or. iatom .le. 0)  then
         print *,'Error in set_geometry: Attempt to set iatom ',
     *     iatom,' but max_centers is ',max_centers
         call abort_job()
      endif

      if (iflags(71) .eq. 0) charge(iatom) = atom_charge
      do i = 1, 3
         acenter(iatom,i) = coord(i)
      enddo   

      return
      end

      subroutine get_geometry(iatom, atom_charge, coord)
c-------------------------------------------------------------------------
c   Retrieves atomic coordinate and charge info for atom number "iatom".
c-------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'

      integer iatom
      double precision atom_charge, coord(3)

      integer i

      if (iatom .gt. max_centers .or. iatom .le. 0)  then
         print *,'Error in get_geometry: Attempt to get iatom ',
     *     iatom,' but max_centers is ',max_centers
         call abort_job()
      endif

      atom_charge = charge(i)
      do i = 1, 3
         coord(i) = acenter(iatom,i)
      enddo 

      return
      end

      integer function get_ncenters()
c--------------------------------------------------------------------------
c   Retrieves the number of atomic centers.
c--------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'

      get_ncenters = ncenters
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
       CHARACTER*(*) FUNCTION ITOA (NR, FRCPLS)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose:      Convert NR to a left justified string
C
C Arguments:
C     NR       number to be converted (input only)
C     FRCPLS   Force leading '+' if NR positive (input only)
C
C Limitations:
C     May return with incomplete conversion if length of ITOA is too
C     short.  Puts '*' in last position of ITOA to indicate overlow.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C $Log: itoa.f,v $
C Revision 1.4  2010/10/07 14:33:58  ponton
C Add symcor changes, fix bugs in optimization code, change numerical lib calls to use proper routines
C
C Revision 1.2  2010/02/10 17:20:48  ponton
C Add GNU GPL info to each source file
C
C Revision 1.1.1.1  2009/07/01 18:54:34  ponton
C Initial import for ACESIII Release 3.0
C
C Revision 1.1.1.1  2003/04/02 19:21:35  aces
C INITIAL 2.4 IMPORT
C
C Revision 4.0  89/03/14  01:15:45  bernhold
C Baseline for Sun & VAX prior to porting everywhere
C 
C Revision 3.0  89/01/29  23:10:22  bernhold
C First working release for VAX
C 
C Revision 2.1  89/01/02  20:36:12  bernhold
C To keep consistent with .u file just checked in.
C 
C     Revision 1.1  88/12/07  13:38:51  bernhold
C     Initial revision
C     
C
C System:       Standard FORTRAN 77
C
C Copyright 1988 David E. Bernholdt
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      INTEGER NR, FRCPLS, NRABS
      INTEGER I, J
C
C     Clear out the string
C
      DO 10 I = 1, LEN(ITOA)
         ITOA = ' '
 10   CONTINUE
C
C     Start counting position in string
C
      J = 1
      NRABS = ABS (NR)
C
C     Put in sign as appropriate
C
      IF (NR .LT. 0) THEN
         ITOA(J:J) = '-'
         J = J + 1
      ENDIF
      IF (FRCPLS .NE. 0 .AND. NR .GT. 0) THEN
         ITOA(J:J) = '+'
         J = J + 1
      ENDIF
C
C     Check if we are about to overflow the string
C
      IF (J .GT. LEN(ITOA)) THEN
         ITOA(J-1:J-1) = '*'
         RETURN
      ENDIF
C
C     Loop over nr of digits in number
C
      NDIG = INT( LOG10( FLOAT(NRABS)) ) + 1
      DO 100 I = NDIG, 1, -1
         N = MOD ( ( NRABS / (10**(I-1) ) ), 10)
         ITOA(J:J) = CHAR(N + 48)
         J = J + 1
C
C        Check for overflow of the string, but if this is last digit
C        then its okay.
C
         IF (J .GT. LEN(ITOA) .AND. I .GT. 1) THEN
            ITOA(J-1:J-1) = '*'
            RETURN
         ENDIF
 100  CONTINUE
C
      RETURN
      END

      SUBROUTINE SHELLINF(NORBIT,NTOTATOM,NTOTSHEL,INUMSHEL,ISHLOFF,
     &                   ISHELTP,ISHELSZ)
C
C GENERATE SHELL INFORMATION FOR ATOMS AS ORDERED IN THE ZMAT
C FILE.
C
CJDW 10/28/96. Modifications to check value of IMOL and to check we do
C              not exceed fixed dimensions. For dummy atoms IMOL is set
C              to 999 and we have troubles. Thanks to Roger Edberg of ANU
C              for finding this error.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION INUMSHEL(NORBIT),ISHLOFF(NORBIT)
      DIMENSION ISHELTP(NTOTSHEL),ISHELSZ(NTOTSHEL)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

C
      DIMENSION IZMT2MOL(mxatms)
C
C I am going to set these two arrays to the maximum number of
C atoms times maximum number of shells. Ajith Perera, 11/07.
C
      DIMENSION ISHELTP2(mxatms*mxshel),ISHELSZ2(mxatms*mxshel)
C
      IF(NTOTATOM.GT.200)THEN
       WRITE(6,1000)
       CALL ERREX
      ENDIF
C
      CALL GETREC(20,'JOBARC','ZMAT2MOL',NTOTATOM,IZMT2MOL)
      Write(6,*) norbit
      Print*, "ZMAT2MOL", (IZMT2MOL(I), I=1, NTOTATOM)
      Print*, "ISHELTP", (ISHELTP(I), I=1, NTOTSHEL)
      Print*, "ISHELSZ", (ISHELSZ(I), I=1, NTOTSHEL)
C
C LOOP OVER ATOMS IN ZMAT
C
      IOFFZMAT=1
      DO 10 IZMAT=1,NTOTATOM
C
C GET MOL FILE POSITION
C
       IMOL=IZMT2MOL(IZMAT)
C
       IF(IMOL.GE.1 .AND. IMOL.LE.NORBIT)THEN
C
C GET SHELL INFORMATION FOR THIS ATOM
C
        NSHELL=INUMSHEL(IMOL)
        IOFFMOL=ISHLOFF(IMOL)
        if (IOFFZMAT+NSHELL.gt.500) then
           print *, '@SHELLINF: Assertion failed.'
           print *, '           maximum number of shells = 500'
           print *, '           require at least ',IOFFZMAT+NSHELL
           call errex
        end if
        CALL ICOPY(NSHELL,ISHELTP(IOFFMOL),1,ISHELTP2(IOFFZMAT),1)
        CALL ICOPY(NSHELL,ISHELSZ(IOFFMOL),1,ISHELSZ2(IOFFZMAT),1)
        IOFFZMAT=IOFFZMAT+NSHELL
C
       ELSE
C
        IF(IMOL.NE.999)THEN
         WRITE(6,1010) IMOL
         CALL ERREX
        ENDIF
C
       ENDIF
C
10    CONTINUE
C
      NSHELTOT=IOFFZMAT-1
C
      IF(NSHELTOT.GT.500)THEN
       WRITE(6,1020) NSHELTOT
       CALL ERREX
      ENDIF
C
C
      CALL PUTREC(20,'JOBARC','FULSHLNM',1,NSHELTOT)
      CALL PUTREC(20,'JOBARC','FULSHLTP',NSHELTOT,ISHELTP2)
      CALL PUTREC(20,'JOBARC','FULSHLSZ',NSHELTOT,ISHELSZ2)
C
C
      RETURN
 1000 FORMAT(' @SHELLINF-F, Too many atoms (over 200) ',I10)
 1010 FORMAT(' @SHELLINF-F, Invalid value of IMOL ',I10)
 1020 FORMAT(' @SHELLINF-F, Too many shells (over 500) ',I10)
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_1D_DERV_INTEGRALS
     +
     +                    ( SHELLA,SHELLB,
     +                      NEXP,
     +                      EA,EB,E2AB,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +
     +                               KIN1DX,
     +                               KIN1DY,
     +                               KIN1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_1D_DERV_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of kinetic 1D
C                X,Y,Z derivative integrals using the previously
C                established overlap 1D X,Y,Z derivative integrals.
C
C                The I,J-th 1D kinetic derivative integral is given
C                by the following formula:
C
C                    KIN1D (I,J)  =    1/2 * I * J * OVL1D (I-1,J-1)
C                                   -   I * ALPHAB * OVL1D (I-1,J+1)
C                                   -   J * ALPHAA * OVL1D (I+1,J-1)
C                           +  2 * ALPHAA * ALPHAB * OVL1D (I+1,J+1)
C
C
C                The 1D kinetic derivative integrals are calculated
C                for all exponent pairs simultaneously and placed into
C                a 3-dimensional array with the exponent pair index
C                varying fastest.
C
C
C                  Input:
C
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A and B
C                    NEXP         =  current # of exponent pairs
C                    Ex           =  current MIJ exponents from centers
C                                    x = A,B
C                    E2AB         =  current MIJ double exponent
C                                    products between centers A and B
C                    OVL1Dx       =  current 1D overlap derivative
C                                    integrals for each cartesian
C                                    component (x=X,Y,Z)
C
C                  Output:
C
C                    KIN1Dx       =  current 1D kinetic derivative
C                                    integrals for each cartesian
C                                    component (x=X,Y,Z)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         INTEGER   CASE1D
         INTEGER   I,J,N
         INTEGER   IM1,IP1,JM1,JP1
         INTEGER   NEXP
         INTEGER   SHELLA,SHELLB

         DOUBLE PRECISION  HALF,HALFJ,HALFIJ
         DOUBLE PRECISION  XI,XJ,XIB,XJA,X2AB

         DOUBLE PRECISION  EA     (1:NEXP)
         DOUBLE PRECISION  EB     (1:NEXP)
         DOUBLE PRECISION  E2AB   (1:NEXP)

         DOUBLE PRECISION  KIN1DX (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  KIN1DY (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  KIN1DZ (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  OVL1DX (1:NEXP,0:SHELLA+1,0:SHELLB+1)
         DOUBLE PRECISION  OVL1DY (1:NEXP,0:SHELLA+1,0:SHELLB+1)
         DOUBLE PRECISION  OVL1DZ (1:NEXP,0:SHELLA+1,0:SHELLB+1)

         PARAMETER  (HALF = 0.5D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...the case A = s-shell and B = s-shell.
C
C
         DO N = 1,NEXP
            X2AB = E2AB (N)
            KIN1DX (N,0,0) = X2AB * OVL1DX (N,1,1)
            KIN1DY (N,0,0) = X2AB * OVL1DY (N,1,1)
            KIN1DZ (N,0,0) = X2AB * OVL1DZ (N,1,1)
         END DO
C
C
C             ...jump according to the 4 different cases that can arise:
C
C                  A-shell = s- or higher angular momentum
C                  B-shell = s- or higher angular momentum
C
C                each leading to specific simplifications.
C
C
         CASE1D = 2 * MIN (1,SHELLA) + MIN (1,SHELLB) + 1

         GOTO (1,2,3,4) CASE1D
C
C
C             ...the case A = s-shell and B = s-shell (done already,
C                immediate return).
C
C
    1    RETURN
C
C
C             ...the cases A = s-shell and B >= p-shell.
C
C
    2    DO J = 1,SHELLB
            JM1 = J - 1
            JP1 = J + 1
            XJ = DFLOAT (J)

            DO N = 1,NEXP
               XJA = XJ * EA (N)
               X2AB = E2AB (N)
               KIN1DX (N,0,J)  =  -  XJA * OVL1DX (N,1,JM1)
     +                            + X2AB * OVL1DX (N,1,JP1)
               KIN1DY (N,0,J)  =  -  XJA * OVL1DY (N,1,JM1)
     +                            + X2AB * OVL1DY (N,1,JP1)
               KIN1DZ (N,0,J)  =  -  XJA * OVL1DZ (N,1,JM1)
     +                            + X2AB * OVL1DZ (N,1,JP1)
            END DO
         END DO

         RETURN
C
C
C             ...the cases A >= p-shell and B = s-shell.
C
C
    3    DO I = 1,SHELLA
            IM1 = I - 1
            IP1 = I + 1
            XI = DFLOAT (I)
            DO N = 1,NEXP
               XIB = XI * EB (N)
               X2AB = E2AB (N)
               KIN1DX (N,I,0)  =  -  XIB * OVL1DX (N,IM1,1)
     +                            + X2AB * OVL1DX (N,IP1,1)
               KIN1DY (N,I,0)  =  -  XIB * OVL1DY (N,IM1,1)
     +                            + X2AB * OVL1DY (N,IP1,1)
               KIN1DZ (N,I,0)  =  -  XIB * OVL1DZ (N,IM1,1)
     +                            + X2AB * OVL1DZ (N,IP1,1)
            END DO
         END DO

         RETURN
C
C
C             ...the cases A >= p-shell and B >= p-shell.
C
C
    4    DO I = 1,SHELLA
            IM1 = I - 1
            IP1 = I + 1
            XI = DFLOAT (I)
            DO N = 1,NEXP
               XIB = XI * EB (N)
               X2AB = E2AB (N)
               KIN1DX (N,I,0)  =  -  XIB * OVL1DX (N,IM1,1)
     +                            + X2AB * OVL1DX (N,IP1,1)
               KIN1DY (N,I,0)  =  -  XIB * OVL1DY (N,IM1,1)
     +                            + X2AB * OVL1DY (N,IP1,1)
               KIN1DZ (N,I,0)  =  -  XIB * OVL1DZ (N,IM1,1)
     +                            + X2AB * OVL1DZ (N,IP1,1)
            END DO
         END DO

         DO J = 1,SHELLB
            JM1 = J - 1
            JP1 = J + 1
            XJ = DFLOAT (J)

            DO N = 1,NEXP
               XJA = XJ * EA (N)
               X2AB = E2AB (N)
               KIN1DX (N,0,J)  =  -  XJA * OVL1DX (N,1,JM1)
     +                            + X2AB * OVL1DX (N,1,JP1)
               KIN1DY (N,0,J)  =  -  XJA * OVL1DY (N,1,JM1)
     +                            + X2AB * OVL1DY (N,1,JP1)
               KIN1DZ (N,0,J)  =  -  XJA * OVL1DZ (N,1,JM1)
     +                            + X2AB * OVL1DZ (N,1,JP1)
            END DO

            HALFJ = HALF * XJ
            DO I = 1,SHELLA
               IM1 = I - 1
               IP1 = I + 1
               XI = DFLOAT (I)
               HALFIJ = HALFJ * XI
               DO N = 1,NEXP
                  XIB = XI * EB (N)
                  XJA = XJ * EA (N)
                  X2AB = E2AB (N)

                  KIN1DX (N,I,J)  =  HALFIJ * OVL1DX (N,IM1,JM1)
     +                               -  XIB * OVL1DX (N,IM1,JP1)
     +                               -  XJA * OVL1DX (N,IP1,JM1)
     +                               + X2AB * OVL1DX (N,IP1,JP1)
                  KIN1DY (N,I,J)  =  HALFIJ * OVL1DY (N,IM1,JM1)
     +                               -  XIB * OVL1DY (N,IM1,JP1)
     +                               -  XJA * OVL1DY (N,IP1,JM1)
     +                               + X2AB * OVL1DY (N,IP1,JP1)
                  KIN1DZ (N,I,J)  =  HALFIJ * OVL1DZ (N,IM1,JM1)
     +                               -  XIB * OVL1DZ (N,IM1,JP1)
     +                               -  XJA * OVL1DZ (N,IP1,JM1)
     +                               + X2AB * OVL1DZ (N,IP1,JP1)
               END DO
            END DO
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

#include "flags.h"
      subroutine Qntm_Topl_Main(Icore, Icrsiz)
c
      implicit double precision (a-h,o-z)
      parameter (mxcoef=30)
c
#include "machsp.com"
#include "jodaflags.com"
#include "mxatms.par"
#include "baslims.par"
#include "offsets_2getden.com"
C
      character*32 szFile
      logical bExist, Iwrite_H, Iwrite_T
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Nocc(16), Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Fucoord(3,Mxatms), Coord(3,Mxatms),
     &          Norbits_fullG(Mxatms), NOrbits_compG(Mxatms),
     &          Nbsfns_4irrep(8)
      Dimension Icore(Icrsiz)
C
      Data Ione, Ieight, Iunit /1, 8, 10/
     
C
      Iuhf = 1
      If (iflags(h_IFLAGS_ref).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Mxangmom = Nht
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      
      Call Getrec(-1, 'JOBARC', 'NUMDROPA', Length, Ijunk)       
      If (Length .GT. 0) Then 
         Print*, "Frozen-core is not allowed density plots"
         Call Errex
      Endif
c 
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(20, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'FULLNORB', Ione, Iful_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COMPNORB', Ione, Icmp_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Fucoord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(20, 'JOBARC', 'OCCUPYA ', Nirrep, Nocc(1))
      Call Getrec(20, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(20, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(20, 'JOBARC', 'NUMBASIR', Nirrep, Nbsfns_4irrep)
      Call Getrec(20, 'JOBARC', 'FULLPOPV', Iful_unq_atoms, 
     &            Norbits_fullG)
      Call Getrec(20, 'JOBARC', 'COMPPOPV', Icmp_unq_atoms, 
     &            Norbits_compG)
C
      nOCCa = 0
      Do Irrep = 1, Nirrep
         Nocca = Nocca + Nocc(Irrep)
      End Do
      If (Iuhf .EQ. 1) Then
         Call Getrec(20, 'JOBARC', 'OCCUPYB', Nirrep, Nocc(I+8)) 
         Noccb = 0
         Do Irrep = 1, Nirrep
            Noccb = Noccb + Nocc(8+I) 
         End Do
      Else
         Noccb = Nocca
      Endif 
C
      I = 1
      Do Iatm = 1, Natoms
         If (Iatmchrg(Iatm) .NE. 0) Then
            Coord(1, I) = Fucoord(1, Iatm)
            Coord(2, I) = Fucoord(2, Iatm)
            Coord(3, I) = Fucoord(3, Iatm)
            I = I + 1
         Endif
      Enddo
C
      Call Getcrec(20, 'JOBARC', 'COMPPTGP', 4, Comp_pgrp)
      Call Getcrec(20, 'JOBARC', 'FULLPTGP', 4, Full_pgrp)
C
#ifdef _DEBUG_LVL0
      print*, "Entering a2_prep4_mol_read"
      Print*, (Norbits_compG(i), i=1, Icmp_unq_atoms)
      Print*, (Norbits_fullG(i), i=1, Iful_unq_atoms)
#endif 
      Call a2_prep4_mol_read(Icore, Maxcor, Natoms, Nbfns, 
     &                       Naobfns, Icmp_unq_atoms, 
     &                       Iful_unq_atoms, Coord, Iatmchrg, 
     &                       Norbits_fullG, Norbits_compG, 
     &                       Mxshel, Mxangmom, Itot_prim, Iunqshl, 
     &                       Ntotshl, Max_prim_4atom, 
     &                       Max_prim_4shell, Inext)

      Do i=1, 3
      Write(6, "(3F10.5)"), (coord(i,j), J=1,nreal_atoms)
      Enddo

#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "Offsets for various arrays initilized in Pre4_Den_plo."
      Write(*, '(31I5)'), IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                   IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                   ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                   IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                   IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                   IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                   ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                   IPCOEFFB, IPCOEFF,ISCR1,ISCR2
C
      Write(6,*) 
      Print*, "The orbital exponents in main", Itot_prim, ialpha
      call output(icore(ialpha), 1, Itot_prim, 1, 1, 1, Itot_prim,
     &            1,1,1)  
      Print*, "The Contraction Coefs."
      call output(icore(ipcoeff), 1, Itot_prim, 1, Naobfns, Itot_prim,
     &            Naobfns, 1)

#endif
C
      Icordens_a = Inext
      Icordens_b = Icordens_a + Nbfns*Nbfns*Iintfp
      Inatorbs_a = Icordens_b + Nbfns*Nbfns*Iintfp
      Inatorbs_b = Inatorbs_a + Naobfns*Nbfns*Iintfp
      Ieigvecs_a = Inatorbs_b + Naobfns*Nbfns*Iintfp
      Ieigvecs_b = Ieigvecs_a + Nbfns*Nbfns*Iintfp
      Ieigvals_a = Ieigvecs_b + Nbfns*Nbfns*Iintfp
      Ieigvals_b = Ieigvals_a + Nbfns*Iintfp
      Iscftmp1   = Ieigvals_b + Nbfns*Iintfp
      Iscftmp2   = Iscftmp1   + Nbfns*Nbfns*Iintfp 
      Iocca      = Iscftmp2   + Nbfns*Nbfns*Iintfp 
      Ioccb      = Iocca      + Nbfns*Iintfp
      Inext      = Ioccb      + Nbfns*Iintfp
#ifdef _DEBUG_LVL0
      Write(6,*)
      print*, "Entering A2make_wfn, The geometry:"
    
      Do i=1, 3
      Write(6, "(3F10.5)") (coord(i,j), J=1,nreal_atoms)
      Enddo
#endif 
      Call A2make_wfn(Icore(Icordens_a), Icore(Icordens_b),
     &                Icore(Inatorbs_a), Icore(Inatorbs_b),
     &                Icore(Ieigvecs_a), Icore(Ieigvecs_b),
     &                ICore(Ieigvals_a), Icore(Ieigvals_b), 
     &                Icore(Iscftmp1), Icore(Iscftmp2), 
     &                ICore(Iocca), Icore(Ioccb), Nocca, Noccb,
     &                Maxocca, Maxoccb, Naobfns, Nbfns, Iuhf,
     &                Tenergy)
C
       Lnp1             = Max_prim_4shell
       Icnterbf         = Inext 
       Inatorbs_reord_a = Icnterbf         + Nbfns
       Inatorbs_reord_b = Inatorbs_reord_a + Naobfns*Nbfns*Iintfp 
       Icoef_a          = Inatorbs_reord_b + Nbfns*Naobfns*Iintfp
       Icoef_b          = Icoef_a          + Nbfns*Itot_prim*Iintfp
       Itype            = Icoef_b          + Nbfns*Itot_prim*Iintfp
       ICent            = Itype            + Itot_prim*Iintfp
       IOrdr            = ICent            + Itot_prim*Iintfp
       IScr             = IOrdr            + Itot_prim
       INext            = Iscr             + Itot_prim*Iintfp
c
#ifdef _DEBUG_LVLM2
      print*, "Entering Reord_MOs:"
      Print*, "Input variables", Inext, Max_prim_4atom, Itot_prim, 
     &         icnterbf, Iscfcoef_reord_a, Iscfcoef_reord_b,
     &         Icoef_a, Icoef_b, Nangmom, Nmomao, Naoatm,ipcoeff
      write(*,*)
#endif 
C
       Call Reord_mos(0, Nreal_atoms, Naobfns, Nbfns, Max_prim_4atom, 
     &                Icore(Icnterbf), ICore(Inatorbs_a),  
     &                ICore(Inatorbs_reord_a), Icore(Nangmom),
     &                Icore(Nmomao), Icore(Naoatm),.True.)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "Alpha orbital for Quantum Topology analysis"
      Call output(Icore(Inatorbs_a), 1, nbfns, 1, Nbfns, Nbfns,
     &            Nbfns, 1)
#endif
C
      CALL Xgemm('N','N',Itot_prim,Nbfns,Naobfns,1.0D+00,
     &            Icore(Ipcoeff),Itot_prim,Icore(Inatorbs_a),
     &            Naobfns,0.0D+00,Icore(Icoef_a),Itot_prim)

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "Alpha orbital for Quantum Topology analysis"
      Call output(Icore(Icoef_a), 1, Itot_prim, 1, Nbfns, Itot_prim,
     &            Nbfns, 1)
#endif 
      If (Iuhf .ne. 0) Then
         Call Reord_mos(0, Nreal_atoms, Naobfns, Nbfns, 
     &                  Max_prim_4atom, Icore(Icnterbf), 
     &                  ICore(Inatorbs_b), ICore(Inatorbs_reord_b), 
     &                  Icore(Nangmom), Icore(Nmomao), Icore(Naoatm),
     &                  .True.)
C
         Call Xgemm('N','N',Itot_prim,Nbfns,Naobfns,1.0D+00,
     &               Icore(Ipcoeff),Itot_prim,
     &               Icore(Inatorbs_b), Naobfns,0.0D+00,
     &               Icore(Icoef_b),Itot_prim)

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "Beta orbital for Quantum Topology analysis"
      Call output(Icore(Icoef_b), 1, Itot_prim, 1, Nbfns, Itot_prim,
     &            Nbfns, 1)
#endif

      End if

#ifdef _DEBUG_LVLM2
      print*, "Entering Nodummy:"
      write(*,*)
#endif 
      Call Nodummy(Natoms, Max_prim_4atom, Iatmchrg, Fucoord,
     &            Icore(Nangmom), Icore(Nmomfct), Icore(Inuctr))
C
      if (Comp_pgrp .Eq. "C1") Iful_unq_atoms = Icmp_unq_atoms
C
#ifdef _DEBUG_LVL0            
      Write(6,*)              
      Write(6,*) "The number of contracted function per shell"
      Write(6,*) (ICORE(ICONFUNTSHL - 1 + I), I=1, Ntotshl)
      Write(6,*) "The shell angular momentum"
      Write(6,*) (ICORE(IANGMOMTSHL - 1 + I), I=1, Ntotshl)
      Write(6,*) "The number of primitive functions per shell"
      Write(6,*) (ICORE(IPRMFUNTSHL - 1 + I), I=1, Ntotshl)
#endif
      Open(unit=Iunit, File="WFANAL", Form="Formatted", 
     &     Status="New")

      If (Iuhf .ne. 0) Then
         Iwrite_T = .False.
         Iwrite_H = .True.
      Else
         Iwrite_T = .True.
         Iwrite_H = .True.
      Endif 
C
      Call A2write_wfn(Icore(Icoef_a), Icore(Nangmom), Icore(Ialpha),
     &                 Icore(Iprmfuntshl), Icore(Iangmomtshl), 
     &                 Icore(Inprimshl), Icore(Itype), Icore(Icent),
     &                 ICore(Ieigvals_a), Icore(Iocca), Icore(Iordr),
     &                 ICore(Iscr),Coord, Maxocca, Mxshel, Itot_prim, 
     &                 Nbfns, Nreal_atoms,
     &                 Iatmchrg, Iunit, Iuhf, Iwrite_H, Iwrite_T, 
     &                 Tenergy)
C
      If (Iuhf .Eq. 0) Then
         Close (Iunit) 
      Else 
         Open(unit=Iunit, File="WFANAL", Form="Formatted",
     &        Status="Old")
         Ierr = 0
         Do While (Ierr .eq. 0)
            Read(Iunit, Iostat=Ierr) Temp_buff
         Enddo
      Endif
      If (Iuhf .ne. 0)  Call A2write_wfn(Icore(Icoef_b), 
     &                                   Icore(Nangmom), 
     &                                   Icore(Ialpha) , 
     &                                   Icore(Iprmfuntshl)   , 
     &                                   Icore(Iangmomtshl),
     &                                   Icore(Inprimshl),
     &                                   Icore(Itype), Icore(Icent),
     &                                   ICore(Ieigvals_b),
     &                                   Icore(Ioccb), Icore(Iordr),
     &                                   Icore(Iscr), Coord, Maxoccb, 
     &                                   Mxshel, Itot_prim, Nbfns, 
     &                                   Nreal_atoms, Iatmchrg,
     &                                   Iunit, Iuhf, .False., 
     &                                   .True., Tenergy)
C
#ifdef _DEBUG_LVLM1
      print*, "Entering Generate_12Dgrid:"
      Write(6,*)
      Print*, "The start of Icore", Inext, ialpha, Ileft,
     &         Iful_unq_atoms, Ipcoeff, Iunqshl, Inprimshl,
     &         Iangmomshl, Iconfunshl, Iprmfunshl, Nufct,
     &         Naouatm, Ioffsetprm, Ioffsetcon, Ioffsetprm,
     &         Ioffsetcon, Itmp1, Itmp2, Itmp3, Iprductint
C   
      Print*, "The exponents at entry 2 Gen_12Grid" 
      call output(icore(ialpha), 1, Itot_prim, 1, 1, 1, Itot_prim,
     &            1,1,1)
      Write(6,*)
      print*, "The offsets for primitives and contr. functions"
      Write(6,"(4i5)") (Icore(Nufct -1 +i), i=1, Iful_unq_atoms)
      Write(6,"(4i5)") (Icore(naouatm -1 +i), i=1, Iful_unq_atoms)
      Write(6,*)
      Iunqshl=7
      Write(6,"(4i5)") (Icore(Iangmomshl -1 +i), 
     &                 i=1,Iunqshl*Iful_unq_atoms)
      Write(6,"(4i5)") (Icore(Inprimshl -1 +i), 
     &                 i=1,iful_unq_atoms)
      Write(6,"(4i5)") (Icore(Iconfunshl -1 +i), 
     &                 i=1,iful_unq_atoms*Iunqshl)
      Write(6,"(4i5)") (Icore(Iprmfunshl -1 +i), 
     &                 i=1,iful_unq_atoms*Iunqshl)
      Write(6,"(4i5)") (Icore(Ioffsetprm -1 +i), 
     &                 i=1,iful_unq_atoms*Iunqshl)
      Write(6,"(4i5)") (Icore(Ioffsetcon-1 +i), 
     &                 i=1,iful_unq_atoms*Iunqshl)

#endif 
      Return
      End

C THIS ROUTINE WRITES OUT INFORMATION WHICH ALLOWS LATER MODULES TO
C RUN SUCCESSFULLY. THIS MUST BE CALLED BY THE LAST EXECUTABLE STATEMENT
C IN ALL PROGRAMS.

      SUBROUTINE CRAPSO
      IMPLICIT NONE

      CHARACTER*80 FNAME
      INTEGER ILENGTH
      LOGICAL bExist,bOpened

      CALL GFNAME('MOINTS  ',FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=bExist,OPENED=bOpened)
      IF (bExist.AND.bOpened) CALL TERMIO
      CALL ACES_JA_FIN

      RETURN
      END

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It performs a diagonalization of davidson matrix             |
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|

      subroutine eomdiag
     +                 (array_table, 
     *                  narray_table, index_table,
     *                  nindex_table, segment_table, nsegment_table,
     *                  block_map_table, nblock_map_table,
     *                  scalar_table, nscalar_table, 
     *                  address_table, op)

c--------------------------------------------------------------------------
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'daveom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base, daddr
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer sind, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer*8 get_block_index
      integer stack

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif




c----------------------------------------------------------------------------
c   Locate the data for the input matrix which is to be analyses.
c---------------------------------------------------------------------------

      array      = op(c_result_array)

      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      daddr = address_table(array)
      iarray  = get_index_from_base(daddr, x, 2)

      if (array .eq. 0) then
         print *,'Error: The first argument in return_sval  
     *            must be an array.'  
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index


C--------------Diagonalization itselfs---------------------------------------

      call eom_diag(x(iarray),1,n1,1,n2,iter,nroots,DavRvec,DavLvec,
     & DavRoots)

C----------------------------------------------------------------------------

      return 
      end 
C#############################################################################

      subroutine eom_diag(DAV_Haux,a1,a2,b1,b2,iter,nroots,DavRvec,
     & DavLvec,DavRoots)
      IMPLICIT NONE
      include 'parallel_info.h'

      integer i,j,a1,a2,b1,b2,iter,nroots,IWRK,INFO,LCI,KK,ICK,
     & INDX(800),k
      double precision DAV_Haux(a1:a2,b1:b2),PPP
      double precision EIG(iter*nroots+nroots),EIG1(iter*nroots+nroots),
     & VECTOR(iter*nroots+nroots,iter*nroots+nroots),
     & VECTOR1(iter*nroots+nroots,iter*nroots+nroots),
     & LWRK(8*(iter*nroots+nroots)),WR5(iter*nroots+nroots),
     & HTEST(iter*nroots+nroots,iter*nroots+nroots),
     & TV(iter*nroots+nroots),WR4(iter*nroots+nroots),
     & DavRvec(800,800),DavLvec(800,800),DavRoots(800)
      
      IWRK = 8*(iter*nroots+nroots) 
      LCI = iter*nroots+nroots

c-----------Matrix for diagonalization----------------------------------------

           DO i=1,LCI
           DO j=1,LCI
           HTEST(i,j) = DAV_Haux(i,j)
c           if(me.eq.0) write(6,*) HTEST(i,j),'!!!!!!!!!!!!!!!!!',i,j 
           ENDDO
           ENDDO
c-----------Diagonalization itselfs-------------------------------------------
       CALL DGEEV('V','V',LCI,HTEST,LCI,EIG,EIG1,VECTOR1,LCI,VECTOR,LCI,
     & LWRK,IWRK,INFO)

          if(me.eq.0) write(6,*) 'On iteration',iter,'eigenvalues are:' 
          DO i=1,LCI
          WR4(i) = EIG(i)
          WR5(i) = WR4(i)
          if(me.eq.0) write(6,*) EIG(i),EIG1(i),'~~~~~~~>',i
          ENDDO
c--------- Align the eigenvalues in the discending order------------------|

63    CONTINUE

      ICK=0
      DO KK=1,LCI-1
      IF( (WR4(KK+1)).lt.(WR4(KK)) ) then
      PPP = WR4(KK)
      WR4(KK) = WR4(KK+1)
      WR4(KK+1) = PPP
      ICK=ICK+1
      ENDIF
      ENDDO
      IF(ICK.NE.0) goto 63

      call zero(INDX,800)
      DO j=1,LCI
      DO i=1,LCI
      IF(WR4(i).eq.EIG(j)) INDX(i)=j
      ENDDO
      ENDDO

c-------Copy roots of small matrix to the common block------------------------
      call zero(DavRoots,800)

      do i=1,LCI
      DavRoots(i) = WR4(i)
      if(me.eq.0) write(6,*) DavRoots(i), '/\/\/\/\/\/\/\/\/',i  
      enddo

c-------Copy left and right auxiliary vectors to the common block-------------

      call zero(DavRvec,800*800)
      call zero(DavLvec,800*800)

         DO i=1,LCI
         DO j=1,LCI
         DavRvec(i,j) = VECTOR(i, INDX(j) )
         DavLvec(i,j) = VECTOR1(i,INDX(j) ) 
         ENDDO
         ENDDO

c      do i=1,LCI
c      do j=1,LCI
c         ppp = 0.d0
c         do k=1,LCI
c         ppp = ppp+DavLvec(k,i)*DavRvec(k,j)
c        enddo
c         if(me.eq.0) write(6,*) ppp,'<--',i,j
c      enddo
c      enddo



      return
      end
c-----------------------------------------------------------------------------

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_NBO_RESULTS
     +
     +                    ( UNITID,
     +                      NBAS,NATOM,
     +                      NBOSIZE,
     +                      MXSHELL,
     +                      NCA,NLA,NEA,NYA,NRA,
     +                      NCB,NLB,NBB,NEB,NAB,NYB,NRB,
     +                      ZATOM,
     +                      ATNCB,ATCIDX,ATCOFF,
     +                      ATNLB,ATLIDX,ATLOFF,
     +                      ATNEB,ATEIDX,ATEOFF,
     +                      ATNYB,ATYIDX,ATYOFF,
     +                      ATNRB,ATRIDX,ATROFF,
     +                      BDNCEN,BDCEN,BDNBAS,BDBAS,
     +                      NBOBD,
     +                      LOCAL,
     +                      ANGNBO,
     +                      W,Q,B )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_NBO_RESULTS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints details of the set of obtained
C                natural bond orbitals (NBOs) to a file specified
C                by its unit identification number. When entering this
C                routine, the NBO expansion coefficients in terms of
C                the atomic NHOs have been ordered such that all
C                Lone-pair, Bond, Empty-pair, Antibond and Rydberg NBOs
C                are clustered together and each set is in the order
C                mentioned. Also the overall weight vector has been
C                ordered to match the order of the NBO expansion
C                coefficients in the NBO part, and additionally the
C                remaining Core and Rydberg NHOs not used for NBO
C                construction were placed in front and at the end,
C                respectively. A picture of what is present at this
C                stage helps:
C
C                Order of NBO expansion coefficients (B matrix):
C
C                        |  LP  |   B  |  EP  |  AB  |RY(nbo)|
C                          (NLB)  (NBB)  (NEB)  (NAB)  (NYB)
C
C                Order of overall weights (W array):
C
C                 | C(nho) |  LP  |   B  |  EP  |  AB  |RY(nbo)|RY(nho)|
C                    (NCB)  (NLB)  (NBB)  (NEB)  (NAB)   (NYB)   (NRB)
C
C                where the variables below in parenthesis indicate the
C                number of elements present in each set.
C
C                The following is printed:
C
C                   1) The occupation numbers (weights) and
C                      occupation interaction orders of the
C                      NBOs and their characterization as Core,
C                      Lone-pair (1-center), Bond and Antibond
C                      (x-center, x=2,3,...), and Rydberg type
C                      NBOs.
C
C                   2) A population chart indicating the NBO
C                      populations broken down in Lewis, Delocalized
C                      and Rest populations:
C
C                       Lewis: Core + Lone-pairs + 1- and 2-cen Bonds
C                       Delocalized: >2-cen Bonds
C                       Rest: Antibonds + Rydbergs
C
C                   3) The NBO atomic localization map.
C
C                   4) The NBO angular momentum weight table.
C
C
C                  Input:
C
C                    UNITID       =  printout unit identification #
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atoms
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    MXSHELL      =  largest l-shell value
C                    NxA          =  total # of Core, Lone-pair,
C                                    Empty-pair and Rydberg atoms
C                                    found (x=C,L,E,Y,R).
C                    NxB          =  total # of NHO Core, NBO Lone-
C                                    pairs, NBO Bonds, NBO Empty-pairs,
C                                    NBO Antibonds, NBO Rydbergs and NHO
C                                    Rydbergs found(x=C,L,B,E,A,Y,R).
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    ATNCB (A)    =  # of Core NHOs on core atom A.
C                    ATCIDX (A)   =  atomic index for core atom A.
C                    ATCOFF (A)   =  index offset for Core NHOs for
C                                    core atom A. This index is equal
C                                    to the total number of Core NHOs
C                                    on all core atoms preceeding core
C                                    atom A.
C                    ATNLB (A)    =  # of Lone-pair NBOs on Lone-pair
C                                    atom A.
C                    ATLIDX (A)   =  atomic index for Lone-pair atom A.
C                    ATLOFF (A)   =  index offset for Lone-pair NBOs for
C                                    Lone-pair atom A. This index is
C                                    equal to the total number of
C                                    Lone-pair NBOs on all Lone-pair
C                                    atoms preceeding Lone-pair atom A.
C                    ATNEB (A)    =  # of Empty-pair NBOs on Empty-pair
C                                    atom A.
C                    ATEIDX (A)   =  atomic index for Empty-pair atom A.
C                    ATEOFF (A)   =  index offset for Empty-pair NBOs for
C                                    Empty-pair atom A. This index is
C                                    equal to the total number of
C                                    Empty-pair NBOs on all Empty-pair
C                                    atoms preceeding Empty-pair atom A.
C                    ATNYB (A)    =  # of Rydberg NBOs on Rydberg atom A.
C                    ATYIDX (A)   =  atomic index for Rydberg atom A.
C                    ATYOFF (A)   =  index offset for Rydberg NBOs for
C                                    Rydberg atom A. This index is
C                                    equal to the total number of
C                                    Rydberg NBOs on all Rydberg atoms
C                                    preceeding Rydberg atom A.
C                    ATNRB (A)    =  # of Rydberg NHOs on core atom A.
C                    ATRIDX (A)   =  atomic index for Rydberg atom A.
C                    ATROFF (A)   =  index offset for Rydberg NHOs for
C                                    Rydberg atom A. This index is equal
C                                    to the total number of Rydberg NHOs
C                                    on all Rydberg atoms preceeding
C                                    Rydberg atom A.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/NRB.
C                                    Note that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  I-th global basis (NHO) index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th NBO. This array is
C                                    the handle for accessing info of
C                                    the NHO bonds sitting in the arrays
C                                    BDNCEN,BDCEN,BDBAS and BDOCC. The
C                                    NBOBD elements are in NCB/NLB/NBB/
C                                    NEB/NAB/NYB/NRB order.
C                    LOCAL (A,I)  =  NBO atom locality map for each
C                                    atom A and with NBOs in NCB/NLB/
C                                    NBB/NEB/NAB/NYB/NRB order.
C                    ANGNBO (J,L) =  NBAS x (MXSHELL+1) matrix containing
C                                    the sum of the square of the NAO
C                                    coefficients per L-type angular
C                                    momentum for the J-th NBO. The NBO
C                                    order is NCB/NLB/NBB/NEB/NAB/NYB/
C                                    NRB.
C                    W            =  NBO weight vector with elements
C                                    in NCB/NLB/NBB/NEB/NAB/NYB/NRB
C                                    order.
C                    Q            =  NBO occupation interaction order
C                                    vector with elements in NCB/NLB/
C                                    NBB/NEB/NAB/NYB/NRB order.
C                    B (I,J)      =  NBOSIZE x NBAS matrix containing
C                                    the J-th NBO expansion coefficients
C                                    in terms of the I-th atomic NHOs
C                                    forming the J-th NBO. The NBO
C                                    column index is in NCB/NLB/NBB/NEB/
C                                    NAB/NYB/NRB order.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*2   ATCHAR
         CHARACTER*1   BAR,DASH
         CHARACTER*12  NBOCHAR

         CHARACTER*2   ATSYMB  (1:104)
         CHARACTER*12  NBOSYMB (1:6)

         INTEGER     ATOM
         INTEGER     BOND
         INTEGER     I,J,N
         INTEGER     MXSHELL
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NBO
         INTEGER     NBOSIZE
         INTEGER     NCA,NLA,NEA,NYA,NRA
         INTEGER     NCB,NLB,NBB,NEB,NAB,NYB,NRB
         INTEGER     NCBA,NLBA,NEBA,NYBA,NRBA
         INTEGER     NCEN
         INTEGER     NHO,NNHO,NNHOOLD
         INTEGER     OFF
         INTEGER     OFFLP,OFFBB,OFFEP,OFFAB,OFFRY,OFFRR
         INTEGER     UNITID
         INTEGER     ZVAL

         INTEGER     ATNCB  (1:NCA  )
         INTEGER     ATNLB  (1:NLA  )
         INTEGER     ATNEB  (1:NEA  )
         INTEGER     ATNYB  (1:NYA  )
         INTEGER     ATNRB  (1:NRA  )
         INTEGER     ATCIDX (1:NCA  )
         INTEGER     ATLIDX (1:NLA  )
         INTEGER     ATEIDX (1:NEA  )
         INTEGER     ATYIDX (1:NYA  )
         INTEGER     ATRIDX (1:NRA  )
         INTEGER     ATCOFF (1:NCA  )
         INTEGER     ATLOFF (1:NLA  )
         INTEGER     ATEOFF (1:NEA  )
         INTEGER     ATYOFF (1:NYA  )
         INTEGER     ATROFF (1:NRA  )
         INTEGER     BDNBAS (1:NBAS )
         INTEGER     BDNCEN (1:NBAS )
         INTEGER     NBOBD  (1:NBAS )
         INTEGER     ZATOM  (1:NATOM)

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS)
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS)

         DOUBLE PRECISION  COEFF
         DOUBLE PRECISION  LEWIS,DELOC,REST
         DOUBLE PRECISION  LOCVAL
         DOUBLE PRECISION  ORDER
         DOUBLE PRECISION  WEIGHT
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  Q (1:NBAS)
         DOUBLE PRECISION  W (1:NBAS)

         DOUBLE PRECISION  B      (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  LOCAL  (1:NATOM  ,1:NBAS   )
         DOUBLE PRECISION  ANGNBO (1:NBAS   ,0:MXSHELL)

         DATA ATSYMB /' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     +                'Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca',
     +                'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     +                'Ga','Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr',
     +                'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     +                'Sb','Te',' I','Xe','Cs','Ba','La','Ce','Pr','Nd',
     +                'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     +                'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     +                'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     +                'Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     +                'Md','No','Lr','xx'/
         DATA  BAR     /'|'/
         DATA  DASH    /'-'/
         DATA  NBOSYMB /'    Core    ',
     +                  '  Lone-pair ',
     +                  '    Bond    ',
     +                  ' Empty-pair ',
     +                  '  Anti-bond ',
     +                  '   Rydberg  '/

         PARAMETER  (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...print out title.
C
C
         WRITE (UNITID,8000) 'Natural bond orbital analysis'
 8000    FORMAT (//,30X,A29,//)
C
C
C             ...print out header line.
C
C
         WRITE (UNITID,9000) 'NBO #',BAR,'Atom',BAR,'Atom #',BAR,
     +                       'NHO #',BAR,'NHO coeffs',BAR,
     +                       'NBO-type',BAR,'Occupancy',BAR,
     +                       'Int. Orders',BAR,'Locality'
         WRITE (UNITID,9010) (DASH,I=1,104)
C
C
C             ...print out Core NAO information.
C
C
         LEWIS = ZERO
         DELOC = ZERO
         REST  = ZERO

         IF (NCA.GT.0) THEN

             NBOCHAR = NBOSYMB (1)

             DO 1000 N = 1,NCA
                OFF = ATCOFF (N)
                NCBA = ATNCB (N)
                ATOM = ATCIDX (N)
                ZVAL = MIN (ZATOM (ATOM),104)
                ATCHAR = ATSYMB (ZVAL)
                NNHOOLD = 0

                DO J = 1,NCBA
                   NBO = OFF + J
                   BOND = NBOBD (NBO)
                   NNHO = BDNBAS (BOND)
                   WEIGHT = W (NBO)
                   ORDER  = Q (NBO)
                   LOCVAL = LOCAL (ATOM,NBO)
                   LEWIS = LEWIS + WEIGHT

                   IF (NNHO.EQ.1) THEN
                       NHO = BDBAS (1,BOND)
                       COEFF = B (1,NBO)
                       IF (J.EQ.1) THEN
                           WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,ATOM,
     +                                         BAR,NHO,BAR,COEFF,BAR,
     +                                         NBOCHAR,BAR,WEIGHT,BAR,
     +                                         ORDER,BAR,LOCVAL
                       ELSE
                           WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,BAR,
     +                                         COEFF,BAR,NBOCHAR,BAR,
     +                                         WEIGHT,BAR,ORDER,BAR,
     +                                         LOCVAL
                       END IF
                   ELSE
                       IF (NNHOOLD.EQ.1) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                       DO I = 1,NNHO
                          NHO = BDBAS (I,BOND)
                          COEFF = B (I,NBO)

                          IF (J.EQ.1 .AND. I.EQ.1) THEN
                              WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,
     +                                            ATOM,BAR,NHO,BAR,
     +                                            COEFF,BAR,NBOCHAR,BAR,
     +                                            WEIGHT,BAR,ORDER,BAR,
     +                                            LOCVAL
                          ELSE IF (I.EQ.1) THEN
                              WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,NBOCHAR,
     +                                            BAR,WEIGHT,BAR,ORDER,
     +                                            BAR,LOCVAL
                          ELSE
                              WRITE (UNITID,9920) BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,BAR,
     +                                            BAR,BAR
                          END IF
                       END DO
                       IF (J.LT.NCBA) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                   END IF

                   NNHOOLD = NNHO

                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 1000        CONTINUE
         END IF
C
C
C             ...print out Lone-pair NBO information.
C
C
         IF (NLB.GT.0) THEN

             OFFLP = NCB
             NBOCHAR = NBOSYMB (2)

             DO 2000 N = 1,NLA
                OFF = ATLOFF (N)
                NLBA = ATNLB (N)
                ATOM = ATLIDX (N)
                ZVAL = MIN (ZATOM (ATOM),104)
                ATCHAR = ATSYMB (ZVAL)
                NNHOOLD = 0

                DO J = 1,NLBA
                   NBO = OFFLP + OFF + J
                   BOND = NBOBD (NBO)
                   NNHO = BDNBAS (BOND)
                   WEIGHT = W (NBO)
                   ORDER  = Q (NBO)
                   LOCVAL = LOCAL (ATOM,NBO)
                   LEWIS = LEWIS + WEIGHT

                   IF (NNHO.EQ.1) THEN
                       NHO = BDBAS (1,BOND)
                       COEFF = B (1,NBO)
                       IF (J.EQ.1) THEN
                           WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,ATOM,
     +                                         BAR,NHO,BAR,COEFF,BAR,
     +                                         NBOCHAR,BAR,WEIGHT,BAR,
     +                                         ORDER,BAR,LOCVAL
                       ELSE
                           WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,BAR,
     +                                         COEFF,BAR,NBOCHAR,BAR,
     +                                         WEIGHT,BAR,ORDER,BAR,
     +                                         LOCVAL
                       END IF
                   ELSE
                       IF (NNHOOLD.EQ.1) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                       DO I = 1,NNHO
                          NHO = BDBAS (I,BOND)
                          COEFF = B (I,NBO)

                          IF (J.EQ.1 .AND. I.EQ.1) THEN
                              WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,
     +                                            ATOM,BAR,NHO,BAR,
     +                                            COEFF,BAR,NBOCHAR,BAR,
     +                                            WEIGHT,BAR,ORDER,BAR,
     +                                            LOCVAL
                          ELSE IF (I.EQ.1) THEN
                              WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,NBOCHAR,
     +                                            BAR,WEIGHT,BAR,ORDER,
     +                                            BAR,LOCVAL
                          ELSE
                              WRITE (UNITID,9920) BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,BAR,
     +                                            BAR,BAR
                          END IF
                       END DO
                       IF (J.LT.NLBA) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                   END IF

                   NNHOOLD = NNHO

                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 2000        CONTINUE
         END IF
C
C
C             ...print out Bond NBO information.
C
C
         IF (NBB.GT.0) THEN

             OFFBB = NCB + NLB
             NBOCHAR = NBOSYMB (3)

             DO 3000 N = 1,NBB
                NBO = OFFBB + N
                BOND = NBOBD (NBO)
                NCEN = BDNCEN (BOND)
                WEIGHT = W (NBO)
                ORDER  = Q (NBO)

                IF (NCEN.EQ.2) THEN
                    LEWIS = LEWIS + WEIGHT
                ELSE
                    DELOC = DELOC + WEIGHT
                END IF

                LOCVAL = ZERO
                DO I = 1,NCEN
                   ATOM = BDCEN (I,BOND)
                   LOCVAL = LOCVAL + LOCAL (ATOM,NBO)
                END DO

                DO I = 1,NCEN
                   NHO = BDBAS (I,BOND)
                   ATOM = BDCEN (I,BOND)
                   COEFF = B (I,NBO)
                   ZVAL = MIN (ZATOM (ATOM),104)
                   ATCHAR = ATSYMB (ZVAL)

                   IF (I.EQ.1) THEN
                       WRITE (UNITID,9040) NBO,BAR,ATCHAR,BAR,ATOM,BAR,
     +                                     NHO,BAR,COEFF,BAR,NBOCHAR,
     +                                     BAR,WEIGHT,BAR,ORDER,BAR,
     +                                     LOCVAL
                   ELSE
                       WRITE (UNITID,9050) BAR,ATCHAR,BAR,ATOM,BAR,
     +                                     NHO,BAR,COEFF,BAR,BAR,
     +                                     BAR,BAR
                   END IF
                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 3000        CONTINUE
         END IF
C
C
C             ...print out Empty-pair NBO information.
C
C
         IF (NEB.GT.0) THEN

             OFFEP = NCB + NLB + NBB
             NBOCHAR = NBOSYMB (4)

             DO 4000 N = 1,NEA
                OFF = ATEOFF (N)
                NEBA = ATNEB (N)
                ATOM = ATEIDX (N)
                ZVAL = MIN (ZATOM (ATOM),104)
                ATCHAR = ATSYMB (ZVAL)
                NNHOOLD = 0

                DO J = 1,NEBA
                   NBO = OFFEP + OFF + J
                   BOND = NBOBD (NBO)
                   NNHO = BDNBAS (BOND)
                   WEIGHT = W (NBO)
                   ORDER  = Q (NBO)
                   LOCVAL = LOCAL (ATOM,NBO)
                   REST = REST + WEIGHT

                   IF (NNHO.EQ.1) THEN
                       NHO = BDBAS (1,BOND)
                       COEFF = B (1,NBO)
                       IF (J.EQ.1) THEN
                           WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,ATOM,
     +                                         BAR,NHO,BAR,COEFF,BAR,
     +                                         NBOCHAR,BAR,WEIGHT,BAR,
     +                                         ORDER,BAR,LOCVAL
                       ELSE
                           WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,BAR,
     +                                         COEFF,BAR,NBOCHAR,BAR,
     +                                         WEIGHT,BAR,ORDER,BAR,
     +                                         LOCVAL
                       END IF
                   ELSE
                       IF (NNHOOLD.EQ.1) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                       DO I = 1,NNHO
                          NHO = BDBAS (I,BOND)
                          COEFF = B (I,NBO)

                          IF (J.EQ.1 .AND. I.EQ.1) THEN
                              WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,
     +                                            ATOM,BAR,NHO,BAR,
     +                                            COEFF,BAR,NBOCHAR,BAR,
     +                                            WEIGHT,BAR,ORDER,BAR,
     +                                            LOCVAL
                          ELSE IF (I.EQ.1) THEN
                              WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,NBOCHAR,
     +                                            BAR,WEIGHT,BAR,ORDER,
     +                                            BAR,LOCVAL
                          ELSE
                              WRITE (UNITID,9920) BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,BAR,
     +                                            BAR,BAR
                          END IF
                       END DO
                       IF (J.LT.NEBA) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                   END IF

                   NNHOOLD = NNHO

                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 4000        CONTINUE
         END IF
C
C
C             ...print out Antibond NBO information.
C
C
         IF (NAB.GT.0) THEN

             OFFAB = NCB + NLB + NBB + NEB
             NBOCHAR = NBOSYMB (5)

             DO 5000 N = 1,NAB
                NBO = OFFAB + N
                BOND = NBOBD (NBO)
                NCEN = BDNCEN (BOND)
                WEIGHT = W (NBO)
                ORDER  = Q (NBO)
                REST = REST + WEIGHT

                LOCVAL = ZERO
                DO I = 1,NCEN
                   ATOM = BDCEN (I,BOND)
                   LOCVAL = LOCVAL + LOCAL (ATOM,NBO)
                END DO

                DO I = 1,NCEN
                   NHO = BDBAS (I,BOND)
                   ATOM = BDCEN (I,BOND)
                   COEFF = B (I,NBO)
                   ZVAL = MIN (ZATOM (ATOM),104)
                   ATCHAR = ATSYMB (ZVAL)

                   IF (I.EQ.1) THEN
                       WRITE (UNITID,9040) NBO,BAR,ATCHAR,BAR,ATOM,BAR,
     +                                     NHO,BAR,COEFF,BAR,NBOCHAR,
     +                                     BAR,WEIGHT,BAR,ORDER,BAR,
     +                                     LOCVAL
                   ELSE
                       WRITE (UNITID,9050) BAR,ATCHAR,BAR,ATOM,BAR,
     +                                     NHO,BAR,COEFF,BAR,BAR,
     +                                     BAR,BAR
                   END IF
                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 5000        CONTINUE
         END IF
C
C
C             ...print out Rydberg NBO information.
C
C
         IF (NYB.GT.0) THEN

             OFFRY = NCB + NLB + NBB + NEB + NAB
             NBOCHAR = NBOSYMB (6)

             DO 6000 N = 1,NYA
                OFF = ATYOFF (N)
                NYBA = ATNYB (N)
                ATOM = ATYIDX (N)
                ZVAL = MIN (ZATOM (ATOM),104)
                ATCHAR = ATSYMB (ZVAL)
                NNHOOLD = 0

                DO J = 1,NYBA
                   NBO = OFFRY + OFF + J
                   BOND = NBOBD (NBO)
                   NNHO = BDNBAS (BOND)
                   WEIGHT = W (NBO)
                   ORDER  = Q (NBO)
                   LOCVAL = LOCAL (ATOM,NBO)
                   REST = REST + WEIGHT

                   IF (NNHO.EQ.1) THEN
                       NHO = BDBAS (1,BOND)
                       COEFF = B (1,NBO)
                       IF (J.EQ.1) THEN
                           WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,ATOM,
     +                                         BAR,NHO,BAR,COEFF,BAR,
     +                                         NBOCHAR,BAR,WEIGHT,BAR,
     +                                         ORDER,BAR,LOCVAL
                       ELSE
                           WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,BAR,
     +                                         COEFF,BAR,NBOCHAR,BAR,
     +                                         WEIGHT,BAR,ORDER,BAR,
     +                                         LOCVAL
                       END IF
                   ELSE
                       IF (NNHOOLD.EQ.1) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                       DO I = 1,NNHO
                          NHO = BDBAS (I,BOND)
                          COEFF = B (I,NBO)

                          IF (J.EQ.1 .AND. I.EQ.1) THEN
                              WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,
     +                                            ATOM,BAR,NHO,BAR,
     +                                            COEFF,BAR,NBOCHAR,BAR,
     +                                            WEIGHT,BAR,ORDER,BAR,
     +                                            LOCVAL
                          ELSE IF (I.EQ.1) THEN
                              WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,NBOCHAR,
     +                                            BAR,WEIGHT,BAR,ORDER,
     +                                            BAR,LOCVAL
                          ELSE
                              WRITE (UNITID,9920) BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,BAR,
     +                                            BAR,BAR
                          END IF
                       END DO
                       IF (J.LT.NYBA) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                   END IF

                   NNHOOLD = NNHO

                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 6000        CONTINUE
         END IF
C
C
C             ...print out Rydberg NBO information.
C
C
         IF (NRA.GT.0) THEN

             OFFRR = NCB + NLB + NBB + NEB + NAB + NYB
             NBOCHAR = NBOSYMB (6)

             DO 7000 N = 1,NRA

                OFF = ATROFF (N)
                NRBA = ATNRB (N)
                ATOM = ATRIDX (N)
                ZVAL = MIN (ZATOM (ATOM),104)
                ATCHAR = ATSYMB (ZVAL)
                NNHOOLD = 0

                DO J = 1,NRBA
                   NBO = OFFRR + OFF + J
                   BOND = NBOBD (NBO)
                   NNHO = BDNBAS (BOND)
                   WEIGHT = W (NBO)
                   ORDER  = Q (NBO)
                   LOCVAL = LOCAL (ATOM,NBO)
                   REST = REST + WEIGHT

                   IF (NNHO.EQ.1) THEN
                       NHO = BDBAS (1,BOND)
                       COEFF = B (1,NBO)
                       IF (J.EQ.1) THEN
                           WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,ATOM,
     +                                         BAR,NHO,BAR,COEFF,BAR,
     +                                         NBOCHAR,BAR,WEIGHT,BAR,
     +                                         ORDER,BAR,LOCVAL
                       ELSE
                           WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,BAR,
     +                                         COEFF,BAR,NBOCHAR,BAR,
     +                                         WEIGHT,BAR,ORDER,BAR,
     +                                         LOCVAL
                       END IF
                   ELSE
                       IF (NNHOOLD.EQ.1) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                       DO I = 1,NNHO
                          NHO = BDBAS (I,BOND)
                          COEFF = B (I,NBO)

                          IF (J.EQ.1 .AND. I.EQ.1) THEN
                              WRITE (UNITID,9900) NBO,BAR,ATCHAR,BAR,
     +                                            ATOM,BAR,NHO,BAR,
     +                                            COEFF,BAR,NBOCHAR,BAR,
     +                                            WEIGHT,BAR,ORDER,BAR,
     +                                            LOCVAL
                          ELSE IF (I.EQ.1) THEN
                              WRITE (UNITID,9910) NBO,BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,NBOCHAR,
     +                                            BAR,WEIGHT,BAR,ORDER,
     +                                            BAR,LOCVAL
                          ELSE
                              WRITE (UNITID,9920) BAR,BAR,BAR,NHO,
     +                                            BAR,COEFF,BAR,BAR,
     +                                            BAR,BAR
                          END IF
                       END DO
                       IF (J.LT.NRBA) THEN
                           WRITE (UNITID,9930) BAR,BAR,BAR,BAR,
     +                                         BAR,BAR,BAR,BAR
                       END IF
                   END IF

                   NNHOOLD = NNHO

                END DO

                WRITE (UNITID,9010) (DASH,I=1,104)
 7000        CONTINUE
         END IF
C
C
C             ...formats for printing the NBO information.
C
C
 9000    FORMAT (1X,A5,1X,     A1, 1X,A4,1X,    A1, 1X,A6,1X,  A1,
     +           1X,A5,1X,     A1, 1X,A10,1X,   A1, 3X,A8,3X,  A1,
     +           3X,A9,3X,     A1, 2X,A11,2X,   A1, 2X,A8,2X)
 9010    FORMAT (1X,104A1)
 9040    FORMAT (2X,I3,2X,     A1, 2X,A2,2X,    A1, 2X,I3,3X,  A1,
     +           2X,I3,2X,     A1, 1X,F10.6,1X, A1, 1X,A12,1X, A1,
     +           2X,F12.10,1X, A1, 2X,F12.10,1X,A1, 2X,F8.4,2X)
 9050    FORMAT (2X,3X,2X,     A1, 2X,A2,2X,    A1, 2X,I3,3X,  A1,
     +           2X,I3,2X,     A1, 1X,F10.6,1X, A1, 1X,12X,1X, A1,
     +           2X,12X,1X,    A1, 2X,12X,1X,   A1)
 9900    FORMAT (2X,I3,2X,     A1, 2X,A2,2X,    A1, 2X,I3,3X,  A1,
     +           2X,I3,2X,     A1, 1X,F10.6,1X, A1, 1X,A12,1X, A1,
     +           2X,F12.10,1X, A1, 2X,F12.10,1X,A1, 2X,F8.4,2X)
 9910    FORMAT (2X,I3,2X,     A1, 2X,2X,2X,    A1, 2X,3X,3X,  A1,
     +           2X,I3,2X,     A1, 1X,F10.6,1X, A1, 1X,A12,1X, A1,
     +           2X,F12.10,1X, A1, 2X,F12.10,1X,A1, 2X,F8.4,2X)
 9920    FORMAT (2X,3X,2X,     A1, 2X,2X,2X,    A1, 2X,3X,3X,  A1,
     +           2X,I3,2X,     A1, 1X,F10.6,1X, A1, 1X,12X,1X, A1,
     +           2X,12X,1X,    A1, 2X,12X,1X,   A1, 2X,8X,2X)
 9930    FORMAT (2X,3X,2X,     A1, 2X,2X,2X,    A1, 2X,3X,3X,  A1,
     +           2X,3X,2X,     A1, 1X,10X,1X,   A1, 1X,12X,1X, A1,
     +           2X,12X,1X,    A1, 2X,12X,1X,   A1, 2X,8X,2X)
C
C
C             ...print out population chart.
C
C
         WRITE (UNITID,9060) 'Population Chart'
 9060    FORMAT (//,20X,A16,//)

         WRITE (UNITID,9070) 'NBO-type',BAR,'Occupancy'
         WRITE (UNITID,9080) (DASH,I=1,28)
         WRITE (UNITID,9090) 'Lewis',BAR,LEWIS
         WRITE (UNITID,9100) 'Delocalized',BAR,DELOC
         WRITE (UNITID,9110) 'Rest',BAR,REST
         WRITE (UNITID,9080) (DASH,I=1,28)
         WRITE (UNITID,9120) 'Total',BAR,LEWIS+DELOC+REST

 9070    FORMAT (3X,A8,2X,  A1, 4X,A9)
 9080    FORMAT (2X,28A1)
 9090    FORMAT (7X,A5,1X,  A1, 1X,F12.8)
 9100    FORMAT (1X,A11,1X, A1, 1X,F12.8)
 9110    FORMAT (8X,A4,1X,  A1, 1X,F12.8)
 9120    FORMAT (7X,A5,1X,  A1, 1X,F12.8)
C
C
C             ...print out the NBO angular momentum weight table.
C
C
         WRITE (UNITID,9130) 'NBO Angular Momentum Weight Table'
 9130    FORMAT (//,20X,A33)

         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows = NBOs ; Cols = L-value (1=s,2=p,...) ',
     +                  NBAS,MXSHELL+1,
     +                  NBAS,MXSHELL+1,
     +                  ANGNBO )
     +
     +
C
C
C             ...print out the NBO atomic localization map.
C
C
         WRITE (UNITID,9140) 'NBO Atomic Localization Map'
 9140    FORMAT (//,20X,A27)

         CALL    MAT__PRINT_A_FLOAT_3_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows = Atoms ; Columns = NBOs ',
     +                  NATOM,NBAS,
     +                  NATOM,NBAS,
     +                  LOCAL )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE FSGETT1(Z,ILIST1,ILIST2,IOTYPE,SYMTYP)
C
C THIS ROUTINE READS A "STANDARD" TWO INDEX LIST IN A
C NONSTANDARD WAY.  IT ALLOWS ONE TO READ LISTS OF THE TYPE:
C
C           W(PQ)  WITH IOTYPE = 'N1'
C
C WHERE 1 IS A SPECIAL TYPE OF ORBITAL (ACTIVE OR INACTIVE).  ANY
C INDEX CAN REFER TO A "SPECIAL" ORBITAL
C
C  'N' - NORMAL CASE.  READ ALL ORBITALS OF THIS TYPE
C  'A' - ACTIVE ORBITALS ONLY.
C  'I' - INACTIVE ORBITALS ONLY.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(1)
      CHARACTER*2 IOTYPE
      COMMON // ICORE(1)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FSIOLOC/ IFSPOS(8,22,8),ISCRLC,IFSPOSZ(8,22,8)
      COMMON /SYMPOP  / IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /FSSYMPOP/ FSDPDAN(8,22),FSDPDNA(8,22),FSDPDAA(8,22),
     &                  FSDPDIN(8,22),FSDPDNI(8,22),FSDPDII(8,22),
     &                  FSDPDAI(8,22),FSDPDIA(8,22)
C
C     It is convenient to consider all of the FSDPD__ arrays as a
C     single large array.
C
      Integer FSDPD(8,22,8)
      Equivalence (FSDPDAN(1,1), FSDPD(1, 1, 1) )
C
C     Common block to hold labels for the index types
C
      Character*2 FSDsLbl(8)
      Common /FSIOC/ FSDsLbl
C
C&      Include 'tempio.inc'
C
C     For temporary I/O vectors, etc.
C
C     TIOBas  Pointer to space allocated in ICore for temporary I/O
C     TIOSiz  Size of space allocated in ICore for temporary I/O
C     TIOPos  Pointer to gather vector in ICore
C     TIOZPos Position of zero list in ICore
C     TIODPD  Distribution size
C     TIOFull If it is set to 1, the lists are 'right' after 
C             FSPUT and FSPUTT1. Otherwise only the active part
C	      can be used.
C     TIOBufSz FSIO buffer size -- needed by FSMAP to properly
C              handle writing lists of TIOFull=1.
C
C     Dimensions are: 8 irrpes, 22 list types (even though we
C     don't use most of them), up to 5 different types of distributions.
C
C     TIOZPos is only used by UPLE and UPLT packing schemes.  For the
C     others, TIOZPos(*, IType, IDsTyp) must be 0 or FSGET/FSPUT will be
C     very confused.
C
      Integer TMxDsTy
      Parameter (TMxDsTy = 5)
C
      Integer TIOBas, TIOSiz, TIOPos(8, 22, TMxDsTy),
     $   TIOZPos(8, 22, TMxDsTy), TIODPD(8, 22, TMxDsTy), TIOFull,
     $   TIOBufSz
C
C     Text labels for the names of the temp. I/O distributions
C     (slowest dimension of TIO info arrays).
C
      Character*2 TDsLbl(TMxDsTy)
C
      Common /TempIO/ TIOBas, TIOSiz, TIOPos, TIOZPos, TIODPD, TIOFull,
     $   TIOBufSz
      Common /TempIOC/ TDsLbl
C
      IOFF=1
C
C     Note that T1 lists are always Irrep=1 for symmetry purposes, 
C     though they may not be stored on the first sublist.
C
      If (IOType(1:2) .eq. 'NN') then
         LType = 0
      Else
         LType = iszeq(8, FSDsLbl, 1, IOType(1:2))
         If (LType .ne. 0) then
            IPosLeft = IFSPos(  1, SymTyp, LType)
            IZPosL   = IFSPosZ( 1, SymTyp, LType)
            NSize    = FSDPD(   1, SymTyp, LType)
         Else
            LType = iszeq(TMxDsTy, TDsLbl, 1, IOType(1:2))
            If (LType .ne. 0) then
               IPosLeft = TIOPos (1, SymTyp, LType)
               IZPosL   = TIOZPos(1, SymTyp, LType)
               NSize    = TIODPD (1, SymTyp, LType)
            Else
               Write (6, 9000) IOType(1:2)
               Call ErrEx
            EndIf
         EndIf
      EndIf
C
 9000 Format(T3,'@FSGETT1-F, Unknown index type ', A, ' requested.')
C
      CALL GETLST(ICORE(ISCRLC),1,1,1,ILIST1,ILIST2)
C
C     Allow 'NN' requests to work too
C
      If (LType .eq. 0) then
         Call SCopy(NSize, ICore(IScrlc), 1, Z, 1)
      Else
         CALL GATHER(NSIZE,Z,ICORE(ISCRLC),ICORE(IPOSLEFT))
      EndIf
C
      If (IZPosL .ne. 0) then
         Do 15 I = 1, NSize
            Z(I) = ICore(IZPosL + I - 1) * Z(I)
 15      Continue
      EndIf
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine build_pst(nprocs, master_is_worker, 
     *                     managers_are_workers, maxmem,
     *                     io_company_id)

c------------------------------------------------------------------------
c   build_pst: Builds the pst (process status table).
c   
c   1. Assigns the master task.
c   2. The master task broadcasts a hostid request to each task.
c   3. The master obtains the hostid responses, and assigns each task
c      one or more roles (i. e. worker, manager, or both).
c   4. Communicators are built for each set of tasks on teh same host.
c   5. A communicator is built containing all the managers.
c   6. The pst is built from this data and distributed to each task.
c
c-----------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'proto_defines.h'
      include 'proto_events.h'
      include 'pst.h'
      include 'company.h'
      include 'dbugcom.h'

      integer me, nprocs
      integer master
      integer ihosts(nprocs), task_status(nprocs)
      integer io_company_id

      integer i, j, ierr, local_rank
      integer ihost_id
      integer local_comm
      integer nlocal_grp, my_manager
      integer next, len

      integer id, nmgr, mgr_mem, nwrkr, wrkr_mem
      integer maxmem
      integer mpi_group_world, ngroup, new_group
      integer icompany, my_role, mem
      integer nw
      integer company_comm, company_rank
      integer lenmode, nproc_per_node, nodes
      integer pst_get_company_comm
      integer sip_pst_tag
      parameter (sip_pst_tag = 9999)

      logical master_is_worker
      logical managers_are_workers

      character*(MPI_MAX_PROCESSOR_NAME ) hname
      character*(MPI_MAX_PROCESSOR_NAME ) hosts(nprocs)
      character*256 modevar

      character*15 role(5)
      data role/'Worker', 'Manager', 'Manager/Worker',
     *          'Master', 'Master/Worker'/
      master = 0
      call mpi_comm_rank(mpi_comm_world, me, ierr)

c-----------------------------------------------------------------------
c   Get the host names from each processor on the master.
c-----------------------------------------------------------------------

      hname = ' '
      call mpi_get_processor_name(hname, len, ierr)
      call mpi_gather(hname, MPI_MAX_PROCESSOR_NAME, MPI_CHARACTER, 
     *                hosts, MPI_MAX_PROCESSOR_NAME, 
     *                MPI_CHARACTER, master, mpi_comm_world, 
     *                ierr)
      if (ierr .ne. 0) then
         print *,'Processor ',me,' ERROR IN MPI_GATHER: ',ierr
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

c-----------------------------------------------------------------------
c   Form a list of unique host identifiers from the processor names.
c-----------------------------------------------------------------------

      do i = 1, nprocs
         ihosts(i) = 0
      enddo

      next = 0
      do i = 1, nprocs
         if (ihosts(i) .eq. 0) then
            next = next + 1
            hname = hosts(i)

            do j = i, nprocs
               if (hname .eq. hosts(j)) then
                  ihosts(j) = next
               endif
            enddo
         endif 
      enddo

#ifdef BLUEGENE
      call c_getenv('mode'//char(0), modevar, lenmode, ierr)
      if (ierr .eq. 0) then
         if (modevar(1:3) .eq. 'smp') then
            nproc_per_node = 1
         else if (modevar(1:4) .eq. 'dual') then
            nproc_per_node = 2
         else if (modevar(1:2) .eq. 'vn') then
            nproc_per_node = 4
         endif 
      else
         print *,'Error: mode environment variable is required ',
     *           'on BLUE GENE.'
         call abort_job()
      endif 

      next = 0
      nodes = nprocs / nproc_per_node
      if (nprocs .gt. nodes * nproc_per_node) nodes = nodes + 1
      DO I = 1, nodes
         do j = 1, nproc_per_node
            next = next + 1 
            if (next .le. nprocs) ihosts(next) = i 
         enddo 
      ENDDO
#endif

c-----------------------------------------------------------------------
c   Assign each task its status.
c-----------------------------------------------------------------------

      if (me .eq. master) then
         call proto_assign_status(master, ihosts, nprocs, task_status,
     *                    master_is_worker, managers_are_workers)

         if (dbg) then
            print *,'----------- Prototype setup -----------------'
            print *,'Number of tasks.................',nprocs
            print *,'Rank of master task.............',master
            print *,'Assigned status of tasks:'
            do i = 1, nprocs
	       print *,'     Host Name: ',
     *              hosts(i)(1:MPI_MAX_PROCESSOR_NAME),
     *              role(task_status(i))
            enddo
         endif
      endif

      call mpi_barrier(mpi_comm_world, ierr)
 
c-----------------------------------------------------------------------
c   Broadcast the ihosts and status arrays.
c----------------------------------------------------------------------- 

      call mpi_bcast(task_status, nprocs, MPI_INTEGER, master, 
     *               mpi_comm_world, ierr)
      if (ierr .ne. 0) then
         print *,'Broadcast of status array failed.'
         print *,'ierr ',ierr
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_bcast(ihosts, nprocs, MPI_INTEGER, master, 
     *               mpi_comm_world, ierr)
      if (ierr .ne. 0) then
         print *,'Broadcast of ihosts array failed.'
         print *,'ierr ',ierr
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

c------------------------------------------------------------------------
c   Fill in the "role"  and "status" fields of the pst.
c------------------------------------------------------------------------

      do i = 1, nprocs
         pst(i, r_role)   = task_status(i)
      enddo

c-----------------------------------------------------------------------
c   Create a local comm for each node.
c-----------------------------------------------------------------------

      nlocal_grp = 0
      ihost_id = ihosts(me+1)
      my_manager = 0
      do i = 1, nprocs
         if (ihosts(i) .eq. ihost_id) then
            nlocal_grp = nlocal_grp + 1

c------------------------------------------------------------------------
c   Find the manager of this group.
c------------------------------------------------------------------------

            if (task_status(i) .eq. manager_status .or.
     *          task_status(i) .eq. both_status) then
               if (master .ne. i-1)
     *            my_manager = nlocal_grp-1  ! rank within this grp
            endif
         endif
      enddo

c-------------------------------------------------------------------------
c   Perform the company/platoon assignments.
c-------------------------------------------------------------------------

      if (me .eq. master) then
#ifdef BLUEGENE
         call bluegene_assign_companies(ihosts, nprocs, nproc_per_node,
     *                  pst(1,r_company_id), pst(1,r_platoon_id))
#else
         call assign_companies(ihosts, nprocs, 
     *                         pst(1,r_company_id), 
     *                         managers_are_workers,
     *                         master_is_worker,
     *                         io_company_id)
#endif
      endif 

      call mpi_barrier(mpi_comm_world, ierr)
 
c-------------------------------------------------------------------------
c   Broadcast the table as completed to this point.
c-------------------------------------------------------------------------

      call mpi_bcast(pst, r_last*maxprocs, MPI_INTEGER, master,
     *               mpi_comm_world, ierr)
      if (ierr .ne. 0) then
         print *,'Broadcast of pst failed.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

c-------------------------------------------------------------------------
c   Form an MPI communicator for each of the companies.
c-------------------------------------------------------------------------

      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_comm_split(mpi_comm_world, pst(me+1,r_company_id),
     *                    me, pst(me+1,r_company_comm), ierr)
      company_comm = pst(me+1,r_company_comm)   ! save communicator id

      if (ierr .ne. 0) then
         print *,'MPI_comm_split on company_id failed.'
         print *,'ierr = ',ierr
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

c--------------------------------------------------------------------------
c   Gather the rank within company to the master.
c--------------------------------------------------------------------------

      if (pst(me+1,r_company_comm) .eq. MPI_UNDEFINED) then
         company_rank = MPI_UNDEFINED
      else
        call mpi_comm_rank(pst(me+1,r_company_comm), 
     *                   company_rank, ierr)
      endif
      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_gather(company_rank, 1, MPI_INTEGER, 
     *                pst(1,r_company_rank), 1, MPI_INTEGER,
     *                master, mpi_comm_world, ierr)
      
c         if (me .eq. 0) then
c            print *,'NODE-TO-RANK MAPPING'
c            do i = 1, nprocs
c               print *,'Rank ',i-1,' node ',ihosts(i),' company ',
c     *            pst(i,r_company_id),' company rank ',
c     *             pst(i,r_company_rank) 
c            enddo
c         endif

      if (ierr .ne. 0) then
         print *,'Gather on company_rank failed.'
         print *,'ierr ',ierr
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      call mpi_barrier(mpi_comm_world, ierr)
      if (me .eq. 0) print *,'Gather on company_rank succeeded.'

      if (dbg .and. me .eq. master) then
         print *,'------------ Initial PST table ------------'
         do i = 1, nprocs
            print *,(pst(i,j),j=1,r_last)
         enddo
      endif
      
c-------------------------------------------------------------------------
c   Broadcast the completed table.
c-------------------------------------------------------------------------

      call mpi_bcast(pst, r_last*maxprocs, MPI_INTEGER, master, 
     *               mpi_comm_world, ierr)
      if (ierr .ne. 0) then
         print *,'Broadcast of pst failed.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      call mpi_barrier(mpi_comm_world, ierr)
      pst(me+1,r_company_comm) = company_comm  ! store comm id in table. 
 
      return
      end

      SUBROUTINE CMP_ANGLE(ILFTEND, IMIDLE, IRHTEND, CARTCOORD,
     &                     VLUANGLE, NRATMS) 
C
C This is a simple routine to calculate the angle between two vectors,
C ILFTEND and IRHTEND and the center is IMIDLE. The angle is retrun
C in VLUANGLE.
C      
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION CARTCOORD(3*NRATMS), VEC1(3), VEC2(3)


      CALL VEC(CARTCOORD(IMIDLE*3 - 2), CARTCOORD(ILFTEND*3 - 2), 
     &         VEC1, 1)
C
      CALL VEC(CARTCOORD(IMIDLE*3 - 2), CARTCOORD(IRHTEND*3 - 2), 
     &         VEC2, 1)

      VLUANGLE = ANGLE(VEC1, VEC2, 3)
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_request_message(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a request message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind1, ind2
      integer ptr, ptr2, msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile
      integer status(MPI_STATUS_SIZE)
      logical flag, restore_data_flag
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      double precision trestore

#ifdef ALTIX
      dptr = dshptr
#endif

      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then

c---------------------------------------------------------------------------
c   Check the server_table to determine if the data is available on disk or
c   in memory.
c---------------------------------------------------------------------------

         ptr = server_msg(c_msg_stptr,node)
         memloc = server_table(c_server_memloc,ptr)
         diskloc = server_table(c_server_diskloc,ptr)

         if (memloc .eq. 0 .and. 
     *       diskloc .eq. 0) then

c--------------------------------------------------------------------------
c   Calculate the integrals, storing them in the message buffer..
c--------------------------------------------------------------------------

            indblk = get_index_from_base(base_mem_addr, x, 2)
            msgbuffer = server_msg(c_msg_msgbuffer,node)
            indblk = indblk + (msgbuffer-1)*server_mem_blocksize
c            call compute_integrals_wrapper(
c     *                          server_msg(c_msg_bsegs,node),
c     *                          server_msg(c_msg_esegs,node),
c     *                          server_msg(c_msg_nind,node),
c     *                          x(indblk))
            print *,'Task ',me,' REQUEST ERROR: Attempt to request a',
     *          ' non-existent block'
            print *,'node ',node,' array ',server_msg(c_msg_array,node)
            print *,'Requested at line ',
     *          server_msg(c_msg_current_line,node)
            call server_abort_job(server_table, nserver_table) 
            server_msg(c_msg_flag,node) = integral_calculation_flag

c---------------------------------------------------------------------------
c   Send the data to the source processor.
c--------------------------------------------------------------------------

            call mpi_isend(x(indblk), server_msg(c_msg_size,node),
     *            mpi_double_precision, server_msg(c_msg_source,node),
     *            server_msg(c_msg_tag,node),mpi_comm_world,
     *            server_msg(c_msg_request,node), ierr)
            server_msg(c_msg_state,node) = wait_for_send_state
        else if (memloc .eq. 0 .and. diskloc .ne. 0) then
           
c-------------------------------------------------------------------------
c   Read data from disk into the message buffer.
c-------------------------------------------------------------------------

           msgbuffer = server_msg(c_msg_msgbuffer,node)
           indblk    = get_index_from_base(base_mem_addr, x, 2)
           size      = server_table(c_server_size,ptr)
           ind2      = indblk +(msgbuffer-1)*server_mem_blocksize
           ifile     = server_table(c_server_file, ptr)
           diskloc   = server_table(c_server_diskloc,ptr)

           if (do_stats) trestore = mpi_wtime()
           call f_restoreram(server_unit(ifile), diskloc,
     *                           server_blocksizes(ifile),
     *                           x(ind2), size)
ccccc           server_msg(c_msg_flag,node) = restore_flag

           if (do_stats .and. stat_key .gt. 0) then
              trestore = mpi_wtime() - trestore
              sstat_trestore(stat_key) = sstat_trestore(stat_key) + 
     *                         trestore
              sstat_trestore2(stat_key) = sstat_trestore2(stat_key) + 
     *                         trestore * trestore
              sstat_nrestore(stat_key) = sstat_nrestore(stat_key) + 1
           endif

c---------------------------------------------------------------------------
c   Send the data to its target.
c---------------------------------------------------------------------------

            call mpi_isend(x(ind2), size, mpi_double_precision,
     *               server_msg(c_msg_source,node),
     *               server_msg(c_msg_tag,node),mpi_comm_world,
     *               server_msg(c_msg_request,node), ierr)
	   server_msg(c_msg_state,node) = wait_for_send_state
        else if (memloc .ne. 0) then
             server_msg(c_msg_state,node) = wait_for_block_state
             server_msg(c_msg_flag,node)  = 0
        endif
      endif    ! begin_state

      if (server_msg(c_msg_state,node) .eq. 
     *                           wait_for_block_state) then
 
c-------------------------------------------------------------------------
c   Check the flags to see if the data is free.  It could be busied by a
c   prepare or preparesum operation that is partially complete.
c-------------------------------------------------------------------------

c          call claim_memory_block(node, server_table, nserver_table,
c     *                            .true.)
c          if (server_msg(c_msg_state,node) .ne. null_state) return
c          server_msg(c_msg_flag,node) = 0

c--------------------------------------------------------------------------
c   The data is free and in memory now.  Find the pointer to the data block.
c--------------------------------------------------------------------------

ccc          iblock = server_msg(c_msg_memptr,node)
ccc          ptr    = server_table_ptr(iblock)
           ptr = server_msg(c_msg_stptr,node)
           iblock = server_table(c_server_memloc,ptr)

c----------------------------------------------------------------------------
c   Free the block (it may have been busied by the claim_memory_block 
c   subroutine.
c---------------------------------------------------------------------------

ccc          server_table(c_server_flags,ptr) = xor(server_busy_flag,
ccc     *              server_table(c_server_flags,ptr))
ccc          server_table(c_server_busy_node,ptr) = 0

c--------------------------------------------------------------------------
c   Copy the data to the message buffer.
c--------------------------------------------------------------------------

          msgbuffer = server_msg(c_msg_msgbuffer,node)
          indblk = get_index_from_base(base_mem_addr, x, 2)
          ind1   = indblk + (iblock-1)*server_mem_blocksize
          ind2   = indblk + (msgbuffer-1)*server_mem_blocksize
          size   = server_table(c_server_size,ptr)
        
          do i = 1, size
             x(ind2+i-1) = x(ind1+i-1)
          enddo
             
c---------------------------------------------------------------------------
c   Post a mpi_isend using the data buffer as the data address.
c---------------------------------------------------------------------------

         call mpi_isend(x(ind2), size, mpi_double_precision,
     *               server_msg(c_msg_source,node),
     *               server_msg(c_msg_tag,node),mpi_comm_world,
     *               server_msg(c_msg_request,node), ierr)
         server_msg(c_msg_state,node) = wait_for_send_state

	 if (size .ne. server_msg(c_msg_size,node)) then
            print *,'Server ',me,' Error: size > msg_size'
            print *,'ptr ',ptr,' array ',
     *        server_table(c_server_array,ptr),' segs ',
     *        (server_table(c_server_bsegs+i-1,ptr),
     *         server_table(c_server_esegs+i-1,ptr),i=1,4)
            print *,'msg array ',server_msg(c_msg_array,node),
     *       ' segs ',(server_msg(c_msg_bsegs+i-1,node),
     *          server_msg(c_msg_esegs+i-1,node),i=1,4)
            call server_abort_job(server_table,nserver_table)
         endif
      endif   ! wait_for_block_state

      if (server_msg(c_msg_state,node) .eq.
     *                         wait_for_send_state) then

c-------------------------------------------------------------------------
c   Test for completion of the send.
c-------------------------------------------------------------------------

         if (server_msg(c_msg_request,node) .eq. 
     *                               MPI_REQUEST_NULL) then
            flag = .true.
         else
            call mpi_test(server_msg(c_msg_request,node), flag,
     *                 status, ierr)
         endif

         if (flag) then
CXXXX            if (server_msg(c_msg_flag,node) .eq. 0) then
               server_msg(c_msg_state,node) = null_state   ! done
CXXXX            else
CXXXX               server_msg(c_msg_state,node) = request_cleanup_state
CXXXX            endif
         else 
            return 
         endif
      endif

      if (server_msg(c_msg_state,node) .eq. request_cleanup_state) then
         
c--------------------------------------------------------------------------
c   Look up the node's data in the server_table.  If its entry points to 
c   a memory block, then another message has brought this data into 
c   memory, and no further processing is required.
c--------------------------------------------------------------------------

         ptr = server_msg(c_msg_stptr,node)
         iblock = server_table(c_server_memloc, ptr)
         if (iblock .le. 0) then
            server_msg(c_msg_state,node) = null_state
            return
         endif

c--------------------------------------------------------------------------
c   Find a new buffer, and swap the message buffer and data buffers, so 
c   that the message buffer enters the processing flow as a data buffer.
c--------------------------------------------------------------------------

         call make_free_block(node, server_table, nserver_table)
         if (server_msg(c_msg_state,node) .eq. null_state) then
            iblock    = server_msg(c_msg_memptr,node)
            msgbuffer = server_msg(c_msg_msgbuffer,node)
            ptr2      = server_table_ptr(iblock)
            if (ptr2 .gt. 0) then
               server_table(c_server_memloc,ptr2) = 0
            endif

            server_table_ptr(iblock)          = -1        ! new msg buffer
            server_table_ptr(msgbuffer)       = ptr
            server_table(c_server_memloc,ptr) = msgbuffer
            server_msg(c_msg_msgbuffer,node)  = iblock
            server_msg(c_msg_memptr,node)     = msgbuffer
         endif
      endif

      return
      end

      SUBROUTINE QRHFSET
C
C  THIS ROUTINE SETS UP THE QRHFINF COMMON BLOCK, WHICH IS
C  VERY USEFUL FOR THE EVALUATION OF THE QRHF Z-VECTOR EQUATIONS
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      INTEGER POP,VRT,POPRHF,VRTRHF,POPDOC,VRTDOC,DIRPRD
C
c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end
      DIMENSION ISET(255),SCR(2*MAXBASFN)
C
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2) 
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/QRHFINF/POPRHF(8),VRTRHF(8),NOSH1(8),NOSH2(8),
     &               POPDOC(8),VRTDOC(8),NAI,N1I,N2A,
     &               NUMISCF,NUMASCF
      COMMON/SYMINF/NSTART,NIRREP,IRREPA(255,2),DIRPRD(8,8)
      COMMON /FLAGS/ IFLAGS(100)
C
      IONE=1
C
      CALL GETREC(20,'JOBARC','QRHFTOT ',IONE,NMOD)
      if (nmod.gt.255) then
         print *, '@QRHFSET: Assertion failed.'
         print *, '          iset dimension = 255'
         print *, '          nmod = ',nmod
         call errex
      end if
      CALL GETREC(20,'JOBARC','QRHFIRR ',NMOD,ISET)
c
c this is a temporary kludge until qrhfx, etc routines are
c available
c
c      if(iset(1).lt.0)iflags(32)=-iset(1)
c      if(iset(1).gt.0)iflags(33)=iset(1)
c Uncommenting the next line will break QRHF first-order props.
c They were tested numerically just to make sure that they are correct.
c 04/2006, Ajith Perera.
c      iflags(38)=0
C
      CALL ICOPY(NIRREP,POP(1,1),1,POPRHF,1)
      CALL ICOPY(NIRREP,VRT(1,2),1,VRTRHF,1)
C 
      DO 10 I=1,NMOD
       INDEX=ISET(I)
       IF(INDEX.GT.0)THEN
        POPRHF(INDEX)=POPRHF(INDEX)-1
       ELSE
        VRTRHF(-INDEX)=VRTRHF(-INDEX)-1
       ENDIF
10    CONTINUE
C
      NAI=0
      N1I=0
      N2A=0
      NUMISCF=0
      NUMASCF=0
      DO 20 IRREP=1,NIRREP
       POPDOC(IRREP)=POP(IRREP,2)
       VRTDOC(IRREP)=VRT(IRREP,1)
       NOSH1 (IRREP)=POPRHF(IRREP)-POP(IRREP,2)
       NOSH2 (IRREP)=POP(IRREP,1)-POPRHF(IRREP)
       NAI=NAI+POPRHF(IRREP)*VRTRHF(IRREP)
       N1I=N1I+NOSH1(IRREP)*POPDOC(IRREP)
       N2A=N2A+NOSH2(IRREP)*VRTDOC(IRREP)
       NUMISCF=NUMISCF+POPRHF(IRREP)
       NUMASCF=NUMASCF+VRTRHF(IRREP)
20    CONTINUE
      NBAS=NUMISCF+NUMASCF
C
      IF(IFLAGS(1).GE.10)THEN
       WRITE(6,1000)
1000   FORMAT(T3,'@QRHFSET-I, Contents of QRHFINF common block:')
       WRITE(6,1001)(POPRHF(I),I=1,NIRREP)
       WRITE(6,1001)(VRTRHF(I),I=1,NIRREP)
       WRITE(6,1001)(NOSH1(I),I=1,NIRREP)
       WRITE(6,1001)(NOSH2(I),I=1,NIRREP)
       WRITE(6,1001)(POPDOC(I),I=1,NIRREP)
       WRITE(6,1001)(VRTDOC(I),I=1,NIRREP)
       WRITE(6,1002)NAI
       WRITE(6,1003)N1I
       WRITE(6,1004)N2A
       WRITE(6,1005)NUMISCF
       WRITE(6,1006)NUMASCF
1001   FORMAT(8I5)
1002   FORMAT(T3,'Length of AI vector   : ',I5)
1003   FORMAT(T3,'Length of 1I vector   : ',I5)
1004   FORMAT(T3,'Length of 2A vector   : ',I5)
1005   FORMAT(T3,'Occupied RHF orbitals : ',I5)
1006   FORMAT(T3,'Virtual  RHF orbitals : ',I5)
      ENDIF
C 
C REORDER SCF EIGENVALUES BASED ON *RHF OCCUPATION*
C
      CALL GETREC(20,'JOBARC','QRHFEVAL',NBAS*IINTFP,SCR)
      IOFFIRR =1
      IOFFOCC2=NBAS+1
      IOFFVRT2=NBAS+NUMISCF+1
      DO 100 IRREP=1,NIRREP
       NOCC=POPRHF(IRREP)
       NVRT=VRTRHF(IRREP)
       IOFFOCC=IOFFIRR
       IOFFVRT=IOFFIRR+NOCC
       CALL SCOPY(NOCC,SCR(IOFFOCC),1,SCR(IOFFOCC2),1)
       CALL SCOPY(NVRT,SCR(IOFFVRT),1,SCR(IOFFVRT2),1)
       IOFFIRR=IOFFIRR+NOCC+NVRT
       IOFFOCC2=IOFFOCC2+NOCC
       IOFFVRT2=IOFFVRT2+NVRT
100   CONTINUE
      CALL PUTREC(20,'JOBARC','RHFEVAL ',NBAS*IINTFP,SCR(NBAS+1))
C      
      RETURN
      END

      SUBROUTINE ROLLT(ICORE,MAXCOR,IUHF,RLECYC,SINGLE,IENTRY,
     &                 RLETYP,LAMBDA,MAXORD)
C
C UPDATES THE RLE T AMPLITUDE AREA.  IENTRY = -1 PUTS THE 
C  INITIAL T AMPLITUDE ONTO LIST 70.  FOR NONHF CASES, THEN
C  WE HAVE TO ALSO PUT OUT THE T1 AMPLITUDES.
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL SINGLE,NONHF,LAMBDA
      DIMENSION ICORE(MAXCOR)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF(2),NF1(2)
      COMMON /RLEIO/ IOLDEST
      MAXORD=IFLAGS(12)
      IF(IENTRY.EQ.-1)THEN
       IF(MAX(IFLAGS(32),IFLAGS(33),IFLAGS(38)).NE.0)THEN
        NONHF=.TRUE.
       ELSE
        NONHF=.FALSE.
       ENDIF
       DO 100 ISPIN=3,1,IUHF-2
        ISIZE=ISYMSZ(ISYTYP(1,43+ISPIN),ISYTYP(2,43+ISPIN))
        I000=1
        I010=I000+IINTFP*ISIZE
        CALL GETALL(ICORE,ISIZE,1,43+ISPIN)
        IF(SINGLE.AND.ISPIN.LT.3)THEN
         IF(SINGLE.AND.(NONHF.OR.LAMBDA))THEN
          CALL GETLST(ICORE(I010),1,1,1,ISPIN,90)
         ELSE
          CALL IZERO(ICORE(I010),NT(ISPIN)*IINTFP)
         ENDIF
        ENDIF
        CALL PUTLST(ICORE,1,1,1,ISPIN,70)
        IF(RLETYP.EQ.2.OR.RLETYP.EQ.3)THEN
         CALL PUTLST(ICORE,1,1,1,ISPIN+3,70)
        ENDIF
        CALL PUTLST(ICORE,1,1,1,ISPIN,89)
        IOLDEST=2
100    CONTINUE
       RETURN
      ENDIF 
C
      DO 30 ISPIN=3,1,IUHF-2
       ISIZE=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
       I000=1
       I010=I000+IINTFP*ISIZE
       CALL GETALL(ICORE,ISIZE,1,60+ISPIN)
       IF(SINGLE.AND.ISPIN.NE.3)CALL GETLST(ICORE(I010),1,1,1,
     &    2+ISPIN,90)
       CALL PUTLST(ICORE,IOLDEST,1,1,ISPIN,70)
30    CONTINUE
      IOLDEST=1+MOD(IOLDEST,MAXORD+1)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__DETERMINE_ORBITAL_LOCALITY
     +
     +                    ( NBAS,NATOM,
     +                      ATIDX,
     +                      BASBEG,BASEND,
     +                      C,
     +                      SHALF,
     +
     +                              LOCAL )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__DETERMINE_ORBITAL_LOCALITY
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine analyzes the locality of the orbitals,
C                which are given as the coefficient matrix in AO basis.
C                The quantity that is determined here is the atomic
C                localization, which measures the degree of atomic
C                orbital involvment in each orbital. We can extract
C                the content of the correponding AOs in the coefficent
C                expansion via the following analysis:
C
C                In order to get rid of the AO nonorthogonality
C                problem, we express each orbital in terms of the
C                orthonormal symmetrized AO basis (SAO), which
C                resembles most closely the original AO basis. The
C                new orbital expansion coefficients c' in terms of SAOs
C                are then given by:
C
C                                 c' = S**(1/2) * c
C
C                where c is the coefficient vector for the orbitals in
C                AO basis. Suppose that we want to calculate the atomic
C                content due to atom A in an orbital. Then we form
C                the quantity:
C
C                                 x = c'(T)*c'
C
C                where we restrict the summation over elements of c'
C                only to those corresponding to atom A. This in turn
C                means that we only take those rows of S**(1/2)
C                corresponding to atom A in evaluating c'. The obtained
C                number x we identify as the atomic localization
C                content corresponding to atom A in the orbital.
C
C                The routine evaluates the complete atomic localization
C                map LOCAL (ATOM,NXO) for each atom ATOM and orbital
C                NXO.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atoms
C                    ATIDX (A)    =  will contain atomic index for
C                                    atom A.
C                    BASBEG (A)   =  first basis index number for
C                                    atom A.
C                    BASEND (A)   =  last basis index number for
C                                    atom A.
C                    C            =  NBAS x NBAS orbital coefficient
C                                    matrix in AO basis.
C                    SHALF        =  full NBAS x NBAS square root of
C                                    the overlap matrix in AO basis.
C
C
C                  Output:
C
C                    LOCAL (A,I)  =  atomic localization content of
C                                    atom A for I-th orbital.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     TOTAL

         INTEGER     ATOM
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NXO

         INTEGER     ATIDX  (1:NATOM)
         INTEGER     BASBEG (1:NATOM)
         INTEGER     BASEND (1:NATOM)

         DOUBLE PRECISION  C     (1:NBAS ,1:NBAS)
         DOUBLE PRECISION  LOCAL (1:NATOM,1:NBAS)
         DOUBLE PRECISION  SHALF (1:NBAS ,1:NBAS)
C
C
C------------------------------------------------------------------------
C
C
C             ...form general atomic index vector.
C
C
         DO ATOM = 1,NATOM
            ATIDX (ATOM) = ATOM
         END DO
C
C
C             ...calculate the individual atomic localization contents
C                for each orbital.
C
C
         TOTAL = .FALSE.

         DO NXO = 1,NBAS
            CALL  NLO__EXTRACT_ATOMIC_CONTENT
     +
     +                 ( NBAS,NATOM,
     +                   NATOM,
     +                   ATIDX,
     +                   BASBEG,BASEND,
     +                   TOTAL,
     +                   C (1,NXO),
     +                   SHALF,
     +
     +                           LOCAL (1,NXO) )
     +
     +
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE BLKCPY2(MATFRM,NROWFRM,NCOLFRM,MATTAR,NROWTAR,NCOLTAR,
     &                  IROWFRM,ICOLFRM)
C
C THIS ROUTINE COPIES AN NROWTAR BY NCOLTAR BLOCK SUBMATRIX 
C  INTO AN NROWTAR BY NCOLTAR TARGET MATRIX (MATTAR) SUCH THAT 
C  THE IROWFRM,ICOLFRM ELEMENT IN MATFRM BECOMES THE (1,1) ELEMENT 
C  IN MATTAR.
C
C THE PHYSICAL DIMENSION OF MATFRM IS (NROWFRM,NCOLFRM)
C THE PHYSICAL DIMENSION OF MATTAR IS THE SAME AS THE SUBMATRIX SIZE
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION MATTAR(NROWTAR,NCOLTAR),MATFRM(NROWFRM,NCOLFRM)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      DO 10 ICOL=1,NCOLTAR
       ICOL0=ICOL+ICOLFRM-1
       IROW0=IROWFRM
       CALL SCOPY(NROWTAR,MATFRM(IROW0,ICOL0),1,MATTAR(1,ICOL),1)
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function str_trimlen(str)
c--------------------------------------------------------------------------
c 
c   str_trimlen: Determines the length of a FORTRAN string from the first
c                character to the last non-blank character.
c
c--------------------------------------------------------------------------
      implicit none
      character*(*) str
      integer i

      do i = len(str), 1, -1
         if (str(i:i) .ne. ' ' .and.
     *       str(i:i) .ne. char(0)) then
            str_trimlen = i
            return
         endif
      enddo

      str_trimlen = 0
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork2311(y,na1,na2,nb1,nb2,a1,a2,b1,b2,inda, indb, 
     *                     x1,nc1,nc2,nd1,nd2,ne1,ne2,
     *                     c1,c2,d1,d2,e1,e2, indx1,
     *                     x2,ni1,ni2,
     *                     i1,i2,indi, 
     *                     scr1, scr2,flopcount) 
c-------------------------------------------------------------------------
c   Performs a "2311" contraction: 
c      2 index output array
c      3 index operand array
c      1 index operand array
c      1 index contraction.
c
c   I. e., contract the 2 indices of the 2nd operand array out of the 
c   first operand array into the 2-index output array.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ne1,ne2,nf1,nf2,
     *        ni1,ni2,nj1,nj2
      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2,i1,i2,j1,j2
      integer inda, indb, indx1(3), indi, indj
      integer flopcount

      double precision y(na1:na2,nb1:nb2)
      double precision x1(nc1:nc2,nd1:nd2,ne1:ne2)
      double precision x2(ni1:ni2)
      double precision scr1(*), scr2(*) 

      character*2 char2
      character*1 char(3) 
      integer h(3), perm(3), indy(2)  
      double precision etemp 

      integer ia, ib, ii, ij, ix(4)
      integer i, j, a, b, c, d, e, f 
#ifdef __crayx1
      integer*8 ncount, m, n, k, lda, ldb, ldc 
#else
      integer ncount, m, n, k, lda, ldb, ldc 
#endif

      logical check
      check = .false.

c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various y and x2 
c   indices.
c---------------------------------------------------------------------------

c      flopcount = 2 * (i2-i1+1)*(j2-j1+1)*(b2-b1+1)*(a2-a1+1)
 
       flopcount = 2 * (i2-i1+1)*(b2-b1+1)*(a2-a1+1)

c---------------------------------------------------------------------------
c   Determine permutation required to put output array into desired order 
c---------------------------------------------------------------------------

      indy(1) = inda 
      indy(2) = indb 

      char(1) = '1'
      char(2) = '2'
      char(3) = '3'

      h(1) = indx1(1)
      h(2) = indx1(2)
      h(3) = indx1(3)

      do i = 1, 3
      do j = 1, 2
         if (h(i) .eq. indy(j)) perm(j) = i
      enddo
      enddo

      char2 = char(perm(1))//char(perm(2))

c---------------------------------------------------------------------------
c   Only do ONE permutation for now  
c---------------------------------------------------------------------------

c      if (char2 .eq. '12') then 
         DO a = a1, a2       
         DO b = b1, b2       
            etemp = 0.d0 
            DO c = c1, c2 
               etemp = etemp + x1(a,b,c)*x2(c)  
            ENDDO 
            y(a,b) = etemp 
         ENDDO 
         ENDDO 
         return 
c      endif  


c       write(6,*) ' PERMUTATION ', char4, 
c     *     ' NOT OPTIMIZED IN cwork2422 line ',current_line 

      return
      end

C SIMPLE SORTER FROM NUMERICAL RECIPES.

      SUBROUTINE PIKSR2(N,ARR,NLIST)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION ARR(N),NLIST(N)
      if (n.lt.2) return
      DO J = 2, N
         A = ARR(J)
         NLST = NLIST(J)
         DO I = J-1, 1, -1
            IF (ARR(I).LE.A) GOTO 10
            ARR(I+1) = ARR(I)
            NLIST(I+1) = NLIST(I)
         END DO
         I = 0
   10    ARR(I+1) = A
         NLIST(I+1) = NLST
      END DO
      RETURN
      END

      subroutine A3_symadapt_main(Work, Icrsiz)
c
      implicit double precision (a-h,o-z)
c


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end










c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

C
      character*32 szFile
      logical bExist, Spherical
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Fucoord(3,Mxatms), Coord(3,Mxatms),
     &          Norbits_fullG(Mxatms), NOrbits_compG(Mxatms),
     &          Nbfns_4irrep(8)
C
      Dimension Work(Icrsiz/iintfp)
C
      Data Ione, Ieight, Iunit /1, 8, 10/
C
      Iuhf = 1
      If (iflags(11).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(20, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Fucoord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(20, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(20, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(20, 'JOBARC', 'NUMBASIR', Nirrep, Nbfns_4irrep)
C
      I = 1
      Do Iatm = 1, Natoms
         If (Iatmchrg(Iatm) .NE. 0) Then
            Coord(1, I) = Fucoord(1, Iatm)
            Coord(2, I) = Fucoord(2, Iatm)
            Coord(3, I) = Fucoord(3, Iatm)
            I = I + 1
         Endif
      Enddo
C
      Call Getcrec(20, 'JOBARC', 'COMPPTGP', 4, Comp_pgrp)
      Call Getcrec(20, 'JOBARC', 'FULLPTGP', 4, Full_pgrp)
      
      Spherical = .False. 
      If (iflags(62).eq.1) Spherical = .True.

      Write(6,*)
      Print*, "Variable at symadapt main"
      Write(*, '(a)'), "Nreal_atoms, Natoms, Nirrep, Nbfns,"
      Write(*, '(a,5i4)')"Naobfns: ", Nreal_atoms, 
     &                    Natoms, Nirrep, Nbfns,Naobfns
      Write(6,*) "Spherical :", Spherical 
      Write(6,"(a,2A4)")"Comp_pgrp, Full_pgrp: ", Comp_pgrp, Full_pgrp
      Write(6,*)
C
      IScfvec_a = I0
      IScfvec_b = IScfvec_a  + Naobfns*Naobfns
      ITmp1     = IScfvec_b  + Naobfns*Naobfns
      ITmp2     = ITmp1      + Naobfns*Naobfns
      IScfevl_a = ITmp2      + Naobfns*Naobfns
      IScfevl_b = IScfevl_a  + Naobfns
      Ioed2a_sc = IScfevl_b  + Naobfns
      Ioed2a_or = Ioed2a_sc  + Naobfns
      Inext     = Ioed2a_or  + Naobfns

      Imemleft = (Icrsiz - Inext)
C
      Call a3_symadapt_scfvecs(Work(IScfvec_a), Work(IScfvec_b), 
     &                         Work(IScfevl_a), Work(IScfevl_b),
     &                         Work(Itmp1), Work(Itmp2),
     &                         Work(Ioed2a_sc), Work(Ioed2a_or),
     &                         Nbfns,
     &                         Naobfns, Nbfns_4irrep, Nirrep, Iuhf,
     &                         Spherical, Work(Inext), Imemleft)

      Return
      End

#include "flags.h"
      subroutine A3_symadapt_main(Work, Icrsiz)
c
      implicit double precision (a-h,o-z)
c
#include "machsp.com"
#include "jodaflags.com"
#include "mxatms.par"
#include "baslims.par"
C
      character*32 szFile
      logical bExist, Spherical
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Fucoord(3,Mxatms), Coord(3,Mxatms),
     &          Norbits_fullG(Mxatms), NOrbits_compG(Mxatms),
     &          Nbfns_4irrep(8)
C
      Dimension Work(Icrsiz/iintfp)
C
      Data Ione, Ieight, Iunit /1, 8, 10/
C
      Iuhf = 1
      If (iflags(h_IFLAGS_ref).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(20, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Fucoord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(20, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(20, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(20, 'JOBARC', 'NUMBASIR', Nirrep, Nbfns_4irrep)
C
      I = 1
      Do Iatm = 1, Natoms
         If (Iatmchrg(Iatm) .NE. 0) Then
            Coord(1, I) = Fucoord(1, Iatm)
            Coord(2, I) = Fucoord(2, Iatm)
            Coord(3, I) = Fucoord(3, Iatm)
            I = I + 1
         Endif
      Enddo
C
      Call Getcrec(20, 'JOBARC', 'COMPPTGP', 4, Comp_pgrp)
      Call Getcrec(20, 'JOBARC', 'FULLPTGP', 4, Full_pgrp)
      
      Spherical = .False. 
      If (iflags(h_IFLAGS_spherical).eq.1) Spherical = .True.

#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "Variable at symadapt main"
      Write(*, '(a)'), "Nreal_atoms, Natoms, Nirrep, Nbfns,"
      Write(*, '(a,5i4)')"Naobfns: ", Nreal_atoms, 
     &                    Natoms, Nirrep, Nbfns,Naobfns
      Write(6,*) "Spherical :", Spherical 
      Write(6,"(a,2A4)")"Comp_pgrp, Full_pgrp: ", Comp_pgrp, Full_pgrp
      Write(6,*)
#endif
C
      IScfvec_a = I0
      IScfvec_b = IScfvec_a  + Naobfns*Naobfns
      ITmp1     = IScfvec_b  + Naobfns*Naobfns
      ITmp2     = ITmp1      + Naobfns*Naobfns
      IScfevl_a = ITmp2      + Naobfns*Naobfns
      IScfevl_b = IScfevl_a  + Naobfns
      Ioed2a_sc = IScfevl_b  + Naobfns
      Ioed2a_or = Ioed2a_sc  + Naobfns
      Inext     = Ioed2a_or  + Naobfns

      Imemleft = (Icrsiz - Inext)
C
      Call a3_symadapt_scfvecs(Work(IScfvec_a), Work(IScfvec_b), 
     &                         Work(IScfevl_a), Work(IScfevl_b),
     &                         Work(Itmp1), Work(Itmp2),
     &                         Work(Ioed2a_sc), Work(Ioed2a_or),
     &                         Nbfns,
     &                         Naobfns, Nbfns_4irrep, Nirrep, Iuhf,
     &                         Spherical, Work(Inext), Imemleft)

      Return
      End

      SUBROUTINE POLYPRT0(NATOMS,IINTFP,IPRINT,
     &                    LCOORD,LENERG,LGRAD,LHESS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LCOORD,LENERG,LGRAD,LHESS
      PARAMETER(MXATMS=250)
      DIMENSION  SCR(3*MXATMS + 3*MXATMS + 9*MXATMS*MXATMS)
      DIMENSION ISCR(  MXATMS)

      IF (NATOMS.GT.MXATMS) THEN
         WRITE(6,1000) NATOMS, MXATMS
 1000    FORMAT('  @POLYPRT0: Too many atoms. Given ',I3,' Max ',I3)
         CALL ERREX
      END IF

      I000 = 1
      I010 = I000 + 3*NATOMS
      I020 = I010 + 3*NATOMS
      I030 = I020 + 9*NATOMS*NATOMS
      CALL POLYPRT(SCR(I000),SCR(I010),SCR(I020),ISCR,
     &             NATOMS,IINTFP,IPRINT,
     &             LCOORD,LENERG,LGRAD,LHESS)

      RETURN
      END

      subroutine qsdminorts(scratch, grad, ehess, eigvh, dmr1, dmr2,
     &                      stp, eps, igts, qsd, nx, ndim, ncycle)
c
c This subroutine implements the quadratic image gradient and hessian
c algorithm of J.-Q. Sun and K.Ruedenberg in JCP 101, 2157 (1994).
c
c Input variables: 
c ndim - Integer number of coordinates
c grad - Real vector of gradients
c ehess - Real matrix of hessian elements
c dmr# - Dummy real matrix
c scratch - Dummy real vector
c
c  Output variables:
c  grad - Real vector of image gradient
c  ehess - Real matrix of image hessian
c
c  Date written : 12/14/99
c
c  Last modified :
c
c  Author : Keith Runge, Ajith Perera
c  Modifications and adaptation to ACES II 04/03/2000
c
      implicit double precision (a-h, o-z)
c
      logical qsd, igts
c
      dimension scratch(nx*nx), grad(ndim), ehess(ndim, ndim),
     &           eigvh(ndim, ndim), dmr1(ndim, ndim), dmr2(ndim, ndim)
c
c Rebuild the hessian in symmetry coordinates.
c
      do 10 i = 1, ndim
         call xgemm('n', 't', ndim, ndim, 1, ehess(i, i), eigvh(1, i),
     &               ndim, eigvh(1, i), ndim, 1.0d0, dmr1,  ndim)
 10   continue
c
      call scopy(ndim*ndim, dmr1, 1, ehess, 1)
c
c Find the bond critical point (H^-1g)
c
      call minv(dmr1, ndim, ndim, dmr2, Det, 1.0d-8, 0, 1)
      call xgemm('n', 'n', ndim, 1, ndim, 1.d0, dmr1, ndim, grad, ndim,
     &            0.d0, scratch(ndim + 1), ndim)
c
      if (igts) then
c
c Build the image hessian and image gradient.
c    
         call zero(dmr2, ndim*ndim)

         do 20 i = 1, ndim
            dmr2(i, i) = 1.0d0
c            do 30 j = 1, ndim
c               dmr2(i, j) = dmr2(i, j) - 2.d0*eigvh(i,1)*eigvh(j,1)
c 30         continue
 20      continue

         call xgemm('n', 't', ndim, ndim, 1, -2.0d0, eigvh(1, 1),
     &               ndim, eigvh(1, 1), ndim, 1.0d0, dmr2,  ndim)
c
c The image hessian
c    
         call xgemm('n', 'n', ndim, ndim, ndim, 1.d0, ehess, ndim, dmr2,
     &               ndim, 0.d0, dmr1, ndim)
c
c The image gradient
c    
         call xgemm('n', 'n', ndim, 1, ndim, 1.d0, dmr1, ndim, grad,
     &               ndim, 0.d0, scratch(1 + 2*ndim), ndim)
c
         call scopy(ndim, scratch(1+ 2*ndim) , 1, grad, 1)
         call scopy(ndim*ndim, dmr1, 1, ehess, 1)
c
c Use the Quadratic Steepest Descent method to locate the image minimum.
c
         call flowqsdmin(scratch, grad, ehess, eigvh, dmr1, dmr2, stp,
     &                   eps, nx, ndim, ncycle)
c    
      else
c
c Look for a minimum using Quadratic Steepest Descent.
c
         call flowqsdmin(scratch, grad, ehess, eigvh, dmr1, dmr2, stp,
     &                   eps, nx, ndim, ncycle)
c        
      endif
c     
      return
      end

c ZEROS OUT THE FIRST LEN ELEMENTS OF INTEGER VECTOR IVEC.

      SUBROUTINE IZERO(IVEC,LEN)
      DIMENSION IVEC(LEN)
      if (len.lt.1) return
      DO I = 1, LEN
         IVEC(I) = 0
      END DO
      RETURN
      END

       SUBROUTINE GSSTRNG(WIN,WOUT,NSIZIN,NSIZOT,ISCR,SPTYPE,IRREPX)
C
C THIS ROUTINE ACCEPTS A SYMMETRY PACKED FOUR-INDEX LIST AND RETURNS
C   THE SAME LIST BUT WITH AN ALTERNATIVE SCHEME FOR SYMMETRY PACKING.
C
C THE LIST (A,I;B,J) IS PRESUMED TO BE PACKED AI-BJ.  THIS ROUTINE RETUR
C   THE LIST PACKED AJ-BI.  USEFUL FOR RINGS AND ALSO FOR THE T1 CONTRIB
C   TO THE RING INTERMEDIATE.  
C
C INPUT: 
C           WIN  - THE SYMMETRY PACKED AI-BJ LIST.
C         NSIZIN - THE TOTAL SIZE OF THE SYM. PACKED INPUT VECTOR.
C         NSIZOT - THE TOTAL SIZE OF THE SYM. PACKED OUTPUT VECTOR.
C         SPTYPE - THE SPIN TYPE FOR THE INPUT LIST
C
C                        'AAAA' FOR (AI-BJ)  (AJ-BI returned)
C                        'BBBB' FOR (ai-bj)  (aj-bi returned)
C                        'ABAB' FOR (Ai-Bj)  (Aj-Bi returned)
C                        'BABA' FOR (aI-bJ)  (aJ-bI returned)
C                        'ABBA' FOR (Ai-bJ)  (AJ-bi returned (type AABB)
C                        'BAAB' FOR (aI-Bj)  (aj-BI returned (type BBAA)
C                        'AABB' FOR (AI-bj)  (Aj-bI returned (type ABBA)
C                        'BBAA' FOR (ai-BJ)  (aJ-Bi returned (type BAAB)
C
C OUTPUT: 
C          WOUT  - THE SYMMETRY PACKED AJ-BI LIST.
C       
C SCRATCH:
C         ISCR   - SCRATCH AREA TO HOLD THE SYMMETRY VECTORS AND INVERSE
C                   SYMMETRY VECTORS WHICH ARE NEEDED. (SIZE: 2*NOCCI*NV
C                   IF SPCASE IS AAAA, BBBB, ABAB OR BABA; 
C                   NVRTA*(NOCCI+NOCCJ)+NVRTB(NOCCI+NOCCJ) OTHERWISE.
C         
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION WIN(NSIZIN),WOUT(NSIZOT),X
      CHARACTER*4 SPTYPE
      DIMENSION ISCR(1),ISPIN(4)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
C
      DO 10 I=1,4
       IF(SPTYPE(I:I).EQ.'A')ISPIN(I)=1
       IF(SPTYPE(I:I).EQ.'B')ISPIN(I)=2
10    CONTINUE
C
      CALL SSTGEN(WIN,WOUT,NSIZIN,VRT(1,ISPIN(1)),POP(1,ISPIN(2)),
     &            VRT(1,ISPIN(3)),POP(1,ISPIN(4)),ISCR,IRREPX,'1432')
C
      RETURN
      END

c The Broyden-Fletcher-Goldfarb-Shanno update.

      SUBROUTINE BFGS(V,H,SCRATCH,STEP,TBT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)












































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/





      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION V(NXM6),H(NXM6*NXM6),SCRATCH(NX*NX),TBT(3*NXM6*NXM6),
     $          STEP(NXM6)

      N2=1+NXM6
      N3=1+2*NXM6
      N4=1+3*NXM6
      NX2=1+NXM6*NXM6
C
C SCRATCH(N2) = DG
C
      CALL VADD(SCRATCH(N2),V,SCRATCH(1),NXM6,-1.D0)
C
C TBT(1) =  [1/DG{dot}DX][DGxDG]
C
      CALL MODMATMUL(TBT(1),SCRATCH(N2),SCRATCH(N2),NXM6,1,NXM6,
     $               NXM6,1,NXM6)
      X0=1.D0/xdot(NXM6,SCRATCH(N2),1,STEP,1)
      CALL xscal(NXM6*NXM6,X0,TBT(1),1)
C
C SCRATCH(N3) = HDX, SCRATCH(N4) = DXH, TBT(NX2)= HDX{x}DXH
C
      CALL MODMATMUL(SCRATCH(N3),H,STEP,NXM6,NXM6,1,NXM6,NXM6,1)
      CALL MODMATMUL(SCRATCH(N4),STEP,H,1,NXM6,NXM6,1,NXM6,NXM6)
      CALL MODMATMUL(TBT(NX2),SCRATCH(N3),SCRATCH(N4),NXM6,1,NXM6,
     $               NXM6,1,NXM6)
C
C Z0 = 1/DXHDX, TBT(NX2) = [1/DXHDX][HDX{x}DXH]
C
      Z0=1.D0/xdot(NXM6,STEP,1,SCRATCH(N3),1)
      CALL xscal(NXM6*NXM6,Z0,TBT(NX2),1)
C
C H(updated) = H(old) + [1/DG{dot}DX][DGxDG] - [1/DXHDX][HDX{x}DXH]
C
      CALL VADD(TBT(1),TBT(1),TBT(NX2),NXM6*NXM6,-1.D0)
      CALL VADD(H,H,TBT(1),NXM6*NXM6,1.D0)
C
C DON'T WRITE ENTIRE HESSIAN UNLESS SPECIFICALLY REQUESTED.
C FOR NOW, JUST USE AN IN-CODE PARAMETER.
C
      RETURN
      END

      subroutine parse_cli
      implicit none

      integer iLast
      integer i, f_iargc, num_args
      character arg*80
      logical bDoNext

      character*1 achar
      integer  f_strpbrk, c_atol
      external f_strpbrk, c_atol

c parallel_aces.com : begin

c This common block contains the MPI statistics for each MPI process. The values
c are initialized in the acescore library.

      external aces_bd_parallel_aces




      integer                nprocs, irank, icpuname

      character*(256) szcpuname

      common /parallel_aces/ nprocs, irank, icpuname,
     &                       szcpuname
      save   /parallel_aces/

c parallel_aces.com : end

c ----------------------------------------------------------------------

      num_args = f_iargc()

c   o loop over arguments
      bDoNext = .true.
      do i = 1, num_args

         if (bDoNext) then
c         o process this argument

            arg=' '
            call f_getarg(i,arg)

c         o MPI_COMM_SIZE
            if (arg(1:6).eq.'-procs') then
               if (i+1.le.num_args) then
                  call f_getarg(i+1,arg)
                  iLast = f_strpbrk(arg,' ')
                  arg(iLast:iLast) = achar(0)
                  nprocs = c_atol(arg)
                  bDoNext = .false.
                  print *, 'nprocs = ',nprocs
               else
                  print *, '@PARSE_CLI: -procs is missing an argument'
                  call aces_exit(1)
               end if
            end if

c         o MPI_COMM_RANK
            if (arg(1:5).eq.'-rank') then
               if (i+1.le.num_args) then
                  call f_getarg(i+1,arg)
                  iLast = f_strpbrk(arg,' ')
                  arg(iLast:iLast) = achar(0)
                  irank = c_atol(arg)
                  bDoNext = .false.
                  print *, 'irank = ',irank
               else
                  print *, '@PARSE_CLI: -rank is missing an argument'
                  call aces_exit(1)
               end if
            end if

c        else if (.not.bDoNext) then
         else

c         o resume processing arguments
            bDoNext = .true.

c        end if (bDoNext)
         end if

c     end do i = 1, num_args
      end do

c ----------------------------------------------------------------------

c   o check consistency

c   o MPI_COMM_SIZE
      if (nprocs.lt.1) then
         print *, '@PARSE_CLI: resetting number of processes to 1'
         nprocs = 1
      end if

c   o MPI_COMM_RANK
      if (irank.lt.0) then
         print *, '@PARSE_CLI: resetting process rank to 0'
         irank = 0
      end if
      if (irank.ge.nprocs) then
         print *, '@PARSE_CLI: resetting process rank to ',nprocs-1
         irank = nprocs-1
      end if

c ----------------------------------------------------------------------

      return
c     end subroutine parse_cli
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine create_current_block(array,array_table, 
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op, 
     *                 release_flag, direct_flag, blk, ierr)
c---------------------------------------------------------------------------
c   Creates the current block of the array from scratch.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer array, ierr, narray_table, nindex_table, nsegment_table
      integer nblock_map_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer op(loptable_entry)

      integer allocate_block
      integer i, j, blk, stack, blkndx, nwblock
      integer find_current_block
      integer find_current_block_map
      integer nind, dummy
      integer ind(mx_array_index)
      integer iseg(mx_array_index)
      integer lookup, block_map_lookup
      logical release_flag
      logical direct_flag

      integer nb, offset 

      ierr = 0

c----------------------------------------------------------------------------
c   direct_flag = .true. implies that it is already known that the block
c   is not present and must be allocated.  Therefore we can skip the 
c   search for the block in this case.
c---------------------------------------------------------------------------

      if (.not. direct_flag) then
         blk = find_current_block(array, array_table(1,array),
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           block_map_table, blkndx)
         if (blk .gt. 0) then
            ierr = blkndx
            return   !  Block already exists.
         endif
      endif

c----------------------------------------------------------------------------
c   Block is not present.  Allocate a new block and set it up for this
c   operation.
c
c   Determine the size of the data to be allocated.
c---------------------------------------------------------------------------

      nind = array_table(c_nindex, array)
      do i = 1, nind
         ind(i) = array_table(c_index_array1+i-1, array)
      enddo

      call determine_current_block_size(ind, nind,
     *        index_table, nindex_table,
     *        segment_table, nsegment_table, nwblock)

c--------------------------------------------------------------------------
c   Block is not present.  Allocate it and compute it.
c--------------------------------------------------------------------------

      blk = find_current_block_map(array, array_table(1,array),
     *                   index_table, nindex_table,
     *                   block_map_table, nblock_map_table)
      
      ierr = allocate_block(array, blk, nwblock, array_table,
     *                      narray_table, index_table, nindex_table,
     *                      block_map_table)
      if (ierr .le. 0) then
         print *,'Create_current_block: ',
     *              'Cannot allocate block for array in create, 
     *              block = ',
     *              array, blk,' release_flag = ',release_flag 
         call array_block_summary(array_table, narray_table)
         print *,'Current segments:'
         do i = 1, nindex_table
            print *,'   index ',i,' current segment ',
     *          index_table(c_current_seg,i)
         enddo
         call dump_block_ids()
         call abort_job()
      else
         blkndx = ierr
      endif

      call blkmgr_insert_block_in_list(array_table(c_block_list,array), 
     *              dummy, blkndx, c_block_list_ptr, .false.)

c--------------------------------------------------------------------------
c   Store the block indices in the block header.
c--------------------------------------------------------------------------

      call set_block_indices(array, blk, blkndx, array_table(1,array))

c--------------------------------------------------------------------------
c   Set the current segment settings in the block header.
c--------------------------------------------------------------------------

      call set_block_segments(array, blk, blkndx, index_table,
     *                           nindex_table)

c---------------------------------------------------------------------------
c   Zero out the block.
c---------------------------------------------------------------------------

      stack = array_table(c_array_stack,array)
c      call clear_block(array, blk, stack, blkndx, nwblock)

      call set_opblock(array, blk, blkndx, op)

c---------------------------------------------------------------------------
c   If this is a distributed array, store the blkndx in the block_map_table
c   entry.
c---------------------------------------------------------------------------

      if (array_table(c_array_type,array) .eq. distributed_array) then 
         do i = 1, nind
            iseg(i) = index_table(c_current_seg,ind(i))
         enddo

         lookup = block_map_lookup(iseg, nind, array,
     *                          array_table(1,array), index_table, 
     *                          nindex_table)

         block_map_table(c_bmap_blkndx, lookup) = blkndx
      endif

      return
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C
      LOGICAL FUNCTION CHECK_PM_PAIR(IBGN, IMD1, IMD2, IEND, JEND, 
     &                             SAME_PLANE, NATOMS)
      INTEGER NATOMS
      LOGICAL SAME_PLANE(NATOMS), SM_PLANE_BM, SM_PLANE_END
     
CSSS      WRITE(6,*) IBGN, IMD1, IMD2, IEND, JEND

      IF (IEND .EQ. IBGN .OR. IEND .EQ. IMD1 .OR. IEND. EQ. IMD2)
     &    THEN
          CHECK_PM_PAIR = .FALSE. 
          RETURN
      ENDIF
      IF (JEND .EQ. IBGN .OR. JEND .EQ. IMD1 .OR. JEND. EQ. IMD2)
     &    THEN 
          CHECK_PM_PAIR = .FALSE. 
          RETURN
      ENDIF
C
      IF (SAME_PLANE(IBGN) .AND. SAME_PLANE(IMD1) .AND. 
     &    SAME_PLANE(IMD2)) SM_PLANE_BM = .TRUE.
      
      SM_PLANE_END = SAME_PLANE(IEND) .AND.  SAME_PLANE(JEND)
CSSS      WRITE(6,*) SM_PLANE_BM, SM_PLANE_END
     
      IF ((SM_PLANE_BM .AND. SM_PLANE_END) .OR. (.NOT. 
     &     SM_PLANE_BM .AND. .NOT. SM_PLANE_END)) THEN
          CHECK_PM_PAIR = .FALSE.
          RETURN
      ENDIF
      IF ((SM_PLANE_BM .AND. .NOT. SM_PLANE_END) .OR. (.NOT. 
     &    SM_PLANE_BM .AND. SM_PLANE_END)) THEN
          CHECK_PM_PAIR = .TRUE.
          RETURN
      ENDIF
     
      END

C FORMS THE QUANTITY:
C
C         E = SUM  [E(1) + TAU(i) * [E(i)-E(1)]]   
C
C FOR QCISD, LCCD AND CCD, ONLY THE T2 PART OF THE ENERGY IS ADDED IN,
C WHILE THE T1**2 PIECE IS ADDED FOR ALL OTHER CC MODELS.
C
C WHICH IS USED TO COMPUTE THE RLE ENERGY APPROXIMANT.

      SUBROUTINE FRMTAU_EXTRAP(Z,ETOT,ET2,TAU,ERLE,IORDER,SINGLE,RLETYP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL SINGLE
      INTEGER RLETYP
      DIMENSION ETOT(IORDER),ET2(IORDER),TAU(IORDER)

      if (iorder.lt.0) then
         print *, '@FRMTAU_EXTRAP: Assertion failed.'
         print *, '                iorder = ',iorder
         call errex
      end if

      IF (RLETYP.EQ.1) THEN
         ERLE = 0.0
         DO I = 1, IORDER
            ERLE = ERLE + TAU(I)*ET2(IORDER+1-I)
         END DO
      ELSE
         ERLE = Z
         DO I = 1, IORDER
            ERLE = ERLE + TAU(I)*(ET2(IORDER+1-I)-Z)
         END DO
      END IF
      RETURN
      END 

C THIS ROUTINE SERVES AS AN INTERFACE BETWEEN THE GETREC/PUTREC I/O
C TO THE JOBARC FILE AND THE DIFFERENT PROGRAMS IN THE PROGRAM SYSTEM.
C IT IS A DEPENDENT OF BOTH CRAPSI AND CRAPSO AND SHOULD NEVER NEED
C TO BE CALLED EXPLICITLY.
c
c Now opens or initializes JOBARC, so GET/PUTREC do not have to.
C
C INPUT:
C        IENTRY - 'I' FOR INITIATION OF PROGRAM (READS IN WORD ADDRESSES
C                         AND LABELS FROM JASMRY)
C
C                 'O' FOR EXIT FROM PROGRAM (DUMPS WORD ADDRESS AND LABELS
C                         TO JASMRY)

      SUBROUTINE DUMPJA(IENTRY)
      IMPLICIT INTEGER (A-Z)
      LOGICAL YESNO, isopn
      CHARACTER*1 IENTRY
      CHARACTER*8 MARKER
      CHARACTER*80 FNAME1,FNAME2
      integer lufil
      parameter ( lufil = 75 )
      PARAMETER (IBUFLN = 128)
      integer ibuf(ibufln)
      PARAMETER (LENGTH = 1000)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
 
#include "icdacc.com"

      COMMON /JOBARC/ MARKER(LENGTH),LOC(LENGTH),SIZE(LENGTH),NRECS,
     &                IRECWD,IRECLN

      CALL GFNAME('JOBARC  ',FNAME1,ILENGTH1)
      CALL GFNAME('JAINDX  ',FNAME2,ILENGTH2)

      IF(IENTRY.EQ.'O')THEN
c         close ( lufil )
         OPEN(UNIT=lufil,FILE=FNAME2(1:ILENGTH2),FORM='UNFORMATTED',
     &        STATUS='UNKNOWN')
         REWIND(lufil)
         WRITE(lufil)MARKER,LOC,SIZE,NRECS
         CLOSE(UNIT=lufil,STATUS='KEEP')
      ELSE
         INQUIRE(FILE=FNAME2(1:ILENGTH2),EXIST=YESNO)
         IF(YESNO)THEN
            OPEN(UNIT=lufil,FILE=FNAME2(1:ILENGTH2),
     &           FORM='UNFORMATTED',STATUS='OLD')
            REWIND(lufil)
            READ(lufil)MARKER,LOC,SIZE,NRECS
            CLOSE(UNIT=lufil,STATUS='KEEP')
         ENDIF
         INQUIRE(FILE=FNAME1(1:ILENGTH1),EXIST=YESNO,OPENED=ISOPN)
         IF(.NOT.YESNO)THEN
            IRECWD=IBUFLN
c YAU - old
cC Nevin
c            if(iintfp.eq.1)then
c               ITMPP=IINTLN
c            else
c               ITMPP=idaccm
c            endif
c            IRECLN=IBUFLN*ITMPP
c YAU - new
            IRECLN=IBUFLN*idaccm
c YAU - end
            nrecs = 0
C Bug fix, AP 03/25/97.
            CALL IZERO(IBUF,IBUFLN)
            OPEN(UNIT=LUFIL,FILE=FNAME1(1:ILENGTH1),
     &           FORM='UNFORMATTED',STATUS='NEW',
     &           ACCESS='DIRECT',RECL=IRECLN)
            WRITE(LUFIL,REC=1)IBUF
            close(lufil)
            DO 5 I=1,1000
               MARKER(I)='OPENSLOT'
 5          CONTINUE
         ENDIF
         IF(.NOT.ISOPN)THEN
            IRECWD=IBUFLN
c YAU - old
cC Nevin
c            if(iintfp.eq.1)then
c               ITMPP=IINTLN
c            else
c               ITMPP=idaccm
c            endif
c            IRECLN=IBUFLN*ITMPP
c YAU - new
            IRECLN=IBUFLN*idaccm
c YAU - end
c            OPEN(UNIT=LUFIL,FILE=FNAME1(1:ILENGTH1),
c     &           FORM='UNFORMATTED',STATUS='OLD',
c     &           ACCESS='DIRECT',RECL=IRECLN)
         ENDIF
      ENDIF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_preparesum_message(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a prepare message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, j, iblock
      integer*8 indblk, ind1, ind2, get_index_from_base
      integer ptr, iorequest, msgbuffer, state, ierr
      logical flag, done
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      integer status(mpi_status_size)
      integer*8 n64, ixx

#ifdef ALTIX
      dptr = dshptr
#endif

      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then

c---------------------------------------------------------------------------
c   Post a recv for the prepare data into the dedicated message buffer.
c---------------------------------------------------------------------------

         indblk = get_index_from_base(base_mem_addr, x, 2)
         msgbuffer = server_msg(c_msg_msgbuffer,node)
         ind1= indblk + (msgbuffer-1)*server_mem_blocksize
c         print *,'Server ',me,' RECV: node ',node,' msgbuf ',
c     *      msgbuffer,' source ',server_msg(c_msg_source,node),
c     *     ' array ',
c     *     server_msg(c_msg_array,node),' segs ',
c     *    (server_msg(c_msg_bsegs+j-1,node),
c     *     server_msg(c_msg_esegs+j-1,node),j=1,4),
c     *     ' size ',server_msg(c_msg_size,node),' seqno ',
c     *     server_msg(c_msg_seqno,node),' tag ',
c     *     server_msg(c_msg_tag,node)

         call mpi_irecv(x(ind1), server_msg(c_msg_size,node),
     *          MPI_DOUBLE_PRECISION, 
     *          server_msg(c_msg_source,node),
     *          server_msg(c_msg_tag,node), mpi_comm_world,
     *          server_msg(c_msg_request,node), ierr)
         server_msg(c_msg_state,node) = recv_block_state
      endif

      if (server_msg(c_msg_state,node) .eq. recv_block_state) then

c----------------------------------------------------------------------------
c   Test for completion of the data transfer.
c----------------------------------------------------------------------------

         if (server_msg(c_msg_request,node) .eq. 
     *       MPI_REQUEST_NULL) then
            flag = .true.
         else
            call mpi_test(server_msg(c_msg_request,node), flag,
     *                 status, ierr)
         endif

         if (flag) then
c            print *,'Server ',me,' PREPARESUM RECV COMPLETE',
c     *         ': node ',node,
c     *         ' msgbuffer ',server_msg(c_msg_msgbuffer,node),
c     *         ' iblock ',server_msg(c_msg_memptr,node)
            server_msg(c_msg_state,node) = wait_for_block_state
         endif
      endif

      if (server_msg(c_msg_state,node) .eq. wait_for_block_state) then
         call claim_memory_block(node, server_table, nserver_table,
     *                           .true.)

         if (server_msg(c_msg_state,node) .eq. null_state) then

c---------------------------------------------------------------------------
c   All necessary data is now in memory.  Compute the sum if necessary.
c---------------------------------------------------------------------------

            iblock = server_msg(c_msg_memptr,node)
            msgbuffer = server_msg(c_msg_msgbuffer, node)

            if (server_msg(c_msg_flag,node) .eq. 
     *                       preparesum_copy_flag) then
               
c---------------------------------------------------------------------------
c   No need to sum, simply change the pointers to make the message buffer
c   available as the data buffer.
c---------------------------------------------------------------------------

               ptr = server_msg(c_msg_stptr,node)
               server_table_ptr(iblock) = -1  ! iblock becomes msg buffer
               server_msg(c_msg_msgbuffer,node) = iblock
               server_table_ptr(msgbuffer) = ptr
               server_msg(c_msg_memptr,node) = msgbuffer
               server_table(c_server_memloc,ptr) = msgbuffer

               iblock = server_msg(c_msg_memptr,node)
               indblk = get_index_from_base(base_mem_addr, x, 2)
               ind1 = indblk + (iblock-1) * server_mem_blocksize

c                print *,'Server ',me,' Swap data in node ',node,
c     *                ' new iblock ',
c     *                server_msg(c_msg_memptr,node),' contents ',
c     *                x(ind1), ' new msgbuffer ',
c     &                server_msg(c_msg_msgbuffer,node),
c     *                ' new pointer target for ptr ',ptr,' is ',
c     *                server_table(c_server_memloc,ptr),' diskloc ',
c     *                server_table(c_server_diskloc,ptr)
            else

c--------------------------------------------------------------------------
c   Sum the 2 buffers.
c--------------------------------------------------------------------------

               indblk = get_index_from_base(base_mem_addr, x, 2)
               ind1 = indblk + (iblock-1) * server_mem_blocksize
               ind2 = indblk + (msgbuffer-1)* server_mem_blocksize

               do i = 1, server_msg(c_msg_size,node)
                  x(ind1+i-1) = x(ind1+i-1) + x(ind2+i-1)
               enddo
            endif

c--------------------------------------------------------------------------
c   The block is now dirty, since we have put new data into it.
c--------------------------------------------------------------------------

            call mark_block_dirty(server_msg(c_msg_memptr,node), 
     *                            server_table, nserver_table)
         endif
      endif
      return
      end

      subroutine runit(string)
      character*(*) string
      integer length, linblnk
      external linblnk

c#ifdef _DEBUG
      length=linblnk(string)
      write(*,'(3a)') ' @ACES2: Executing "',string(1:length),'"'
c#endif

      istat=ishell(string)
cYAU - Somehow, exit(istat) doesn't tell the OS the program failed.
c      So, running `xaces2 || echo failure` never worked.
c      if (istat.ne.0) call exit(istat)
      if (istat.ne.0) call c_exit(1)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__CARTESIAN_NORMS
     +
     +                    ( L,
     +
     +                         NORM )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__CARTESIAN_NORMS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation generates all partial cartesian
C                normalization factors. The cartesian normalization
C                factors are xyz-exponent dependent and are given for
C                a specific monomial as:
C
C                                    ______________________
C                     l m n         /       2^(2L)
C                    x y z -->     / -----------------------
C                                \/ (2l-1)!!(2m-1)!!(2n-1)!!
C
C
C                where L = l+m+n. The best way to deal with these
C                factors for a complete set of monomials for fixed L
C                is to split up each factor into its l-,m- and n-
C                component:
C
C                       _______        _______        _______
C                      / 2^(2l)       / 2^(2m)       / 2^(2n)
C                     / -------  *   / -------  *   / -------
C                   \/ (2l-1)!!    \/ (2m-1)!!    \/ (2n-1)!!
C
C
C                and to precalculate each possible partial factor
C                only once for the range l = 0,1,...,L, where L denotes
C                the maximum shell quantum number that can possibly
C                arise during integral evaluation.
C
C                Note, that the first two factors for l = 0 and 1
C                are equal to 1 and 2 and in fact these are the only
C                ones that are needed for s- and p-functions.
C
C
C                  Input:
C
C                       L         =  maximum shell quantum number
C
C                  Output:
C
C                       NORM (I)  =  cartesian norms from I=0,1,...,L
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I,L

         DOUBLE PRECISION  ODD,ONE,TWO

         DOUBLE PRECISION  NORM (0:L)

         PARAMETER  (ONE = 1.D0)
         PARAMETER  (TWO = 2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the partial norms for shell = 0 up to L.
C
C
         NORM (0) = ONE
         NORM (1) = TWO

         ODD = ONE

         DO 10 I = 2,L
            ODD = ODD + TWO
            NORM (I) = TWO * NORM (I-1) / DSQRT (ODD)
   10    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.



c This routine removes a file (or directory) without having to open it and
c then close it with status='DELETE'.

c WARNING:
c Fortran blank-pads all strings. This routine will simply append the
c null character to szFile and pass it to f_remove_core. If there are trailing
c blanks in the file name, then f_remove_core will not remove it and the process
c will die.



      subroutine f_remove(szFile)
      implicit none

c ARGUMENTS
      character*(*) szFile

c EXTERNAL FUNCTIONS
      integer f_remove_core
      character*1 achar

c INTERNAL VARIABLES
      integer iLength, iTmp
      character*(256) sz

c ----------------------------------------------------------------------


      iLength = 1
      do while (szFile(iLength:iLength).ne.' '.and.
     &          iLength.le.len(szFile))
         iLength = iLength + 1
      end do
      iLength = iLength - 1
      if (iLength.eq.0) return

c ----------------------------------------------------------------------

      if (iLength.lt.256) then
         sz   = szFile(1:iLength)//achar(0)
         iTmp = f_remove_core(sz)
         if (iTmp.eq.0) return
         print *, '@F_REMOVE: The file "',szFile,
     &            '" could not be removed.'
         print *, '           error code = ',iTmp
      else
         print *, '@F_REMOVE: The sz buffer is too small ',
     &            'to contain the input string.'
         print *, '           Recompile with at least ',iLength+1,
     &            ' characters in the buffer.'
         print *, '           (Currently ',256,' characters.)'
      end if

      call c_exit(1)
      end

C THIS ROUTINE RETRIEVES A LOGICAL RECORD FROM THE JOBARC FILE.

C   INPUT:
C         LUJNK - INTEGER 
c                 > 0 missing records are reported and run aborts
c                 = 0 length of record returned in length
c                 < 0 zeros are silently returned
C         FILNAM- CHARACTER*(*) ignored
C         LABEL - IDENTIFIER FOR LOGICAL RECORD.  CHARACTER*(*) STRING.
C         LENGTH- LENGTH OF LOGICAL RECORD IN *INTEGER* WORDS.
C
C   OUTPUT:
C         ISTUFF- CONTENTS OF LOGICAL RECORD (lujnk .ne. 0 )
c         length- length of record in *integer* words ( lujnk = 0)

      SUBROUTINE GETREC(LUJNK,FILNAM,LABEL,LENGTH,ISTUFF)
      IMPLICIT INTEGER(A-Z)

      PARAMETER (LUFIL = 75)
      PARAMETER (IBUFLN = 128)
      CHARACTER*(*) LABEL
      CHARACTER*8 MARKER
      CHARACTER*80 FNAME1
      CHARACTER*(*) FILNAM
      DIMENSION ISTUFF(LENGTH),IBUF(IBUFLN)
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /JOBARC/ MARKER(1000),LOC(1000),SIZE(1000),NRECS,
     &                IRECWD,IRECLN

      IF(LUJNK .GT. 0 .AND. LENGTH.EQ.0)RETURN

      CALL GFNAME('JOBARC  ',FNAME1,ILENGTH1)

          OPEN(UNIT=LUFIL,FILE=FNAME1(1:ILENGTH1),
     &         FORM='UNFORMATTED',STATUS='OLD',
     &         ACCESS='DIRECT',RECL=IRECLN)
 
c
C
C LOCATE POINTER TO THE RECORD WHICH IS TO BE READ.
C
      ILOC=LOCCHR(1000,MARKER,1,LABEL)
c
c  if record not found
c
      IF (ILOC.EQ.1001) THEN
c
         IF (LUJNK.GT.0) THEN
            WRITE(LUOUT,50)LUFIL,LABEL
 50         FORMAT(T3,'@GETREC-F, File attached to unit ',I3,
     $           ' does not contain record ',A8,'.')
            CALL ERREX
         else if ( lujnk .eq. 0 ) then
            length = -1
            close(LUFIL)
            return
         ELSE
            CALL IZERO(ISTUFF,MAX(1,LENGTH))
            close(LUFIL)
            RETURN
         ENDIF 
c
      ENDIF
c
c  record found
c
      if ( lujnk .eq. 0 ) then
         length = size(iloc)
         close(LUFIL)
         return
      endif
c     
c  this warning should not appear -- if it does not, change to ERROR
      if ( length .gt. size(iloc) ) then
         write (6,*) '@GETREC: requested length of vector ', label,
     $        ' is longer than actual'
         write (6,*) 'Actual -- ', size(iloc), ' Requested -- ', length
      endif         
C
C FIND WORD ADDRESS OF FIRST ELEMENT ON RECORD, COMPUTE ADDRESS OF LAST
C  WORD AND THEN COMPUTE BEGINNING AND ENDING RECORD NUMBERS, AND WORD
C  OFFSETS.
C
C  IWRDST - THE ABSOLUTE WORD ADDRESS WHERE THE ARRAY BEGINS.
C  IWRDEN - THE ABSOLUTE WORD ADDRESS WHERE THE ARRAY ENDS.
C  IRECST - THE PHYSICAL RECORD WHERE IWRDST IS LOCATED.
C  IRECEN - THE PHYSICAL RECORD WHERE IWRDEN IS LOCATED.
C  IOFFST - THE RELATIVE WORD ADDRESS OF IWRDST ON RECORD IRECST.
C  IOFFEN - THE RELATIVE WORD ADDRESS OF IWRDEN ON RECORD IRECEN.
C
      IWRDST=LOC(ILOC)
      IRECST=1+IWRDST/IRECWD
      IOFFST=MOD(IWRDST,IRECWD)
      IF(IOFFST.EQ.0)THEN
       IRECST=IRECST-1
       IOFFST=IRECWD
      ENDIF
      NWRDST=IRECWD-IOFFST+1
      IWRDEN=LOC(ILOC)+LENGTH-1
      IRECEN=1+IWRDEN/IRECWD
      IOFFEN=MOD(IWRDEN,IRECWD)
      IF(IOFFEN.EQ.0)THEN
       IRECEN=IRECEN-1
       IOFFEN=IRECWD
      ENDIF
      NWRDEN=IOFFEN
      IF(IRECEN.EQ.IRECST)THEN
C
C CASE ONE.  ALL INFORMATION ON ONE RECORD.
C
       READ(LUFIL,REC=IRECST,ERR=999,IOSTAT=IOS)IBUF
       CALL ICOPY(LENGTH,IBUF(IOFFST),1,ISTUFF,1)
       close(LUFIL)
       RETURN
      ELSE
C
C CASE TWO.  INFORMATION SPREAD ACROSS SEVERAL RECORDS.  FIRST GET STUFF
C  FROM FIRST RECORD.
C
       READ(LUFIL,REC=IRECST,ERR=999,IOSTAT=IOS)IBUF
       CALL ICOPY(NWRDST,IBUF(IOFFST),1,ISTUFF,1)
       IF(IRECEN.EQ.IRECST)then
         close(LUFIL)
         RETURN
       endif
C
C NOW PICK UP STUFF FROM INTERVENING RECORDS.
C
       IOFF = 1 + NWRDST
       DO 10 I=IRECST+1,IRECEN-1
        READ(LUFIL,REC=I,ERR=999,IOSTAT=IOS)IBUF
        CALL ICOPY(IRECWD,IBUF,1,ISTUFF(IOFF),1)
        IOFF=IOFF+IRECWD
10     CONTINUE
C
C NOW GET STUFF OFF LAST RECORD
C
       READ(LUFIL,REC=IRECEN,ERR=999,IOSTAT=IOS)IBUF
       CALL ICOPY(NWRDEN,IBUF,1,ISTUFF(IOFF),1)
       close(LUFIL)
       RETURN
      ENDIF
c
999   CONTINUE

      WRITE(LUOUT,*) '@GETREC: I/O error on unit ',LUFIL,
     &               ' searching for : ',LABEL
      WRITE(LUOUT,*) '         System error code : ',IOS
      CALL ERREX

      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c     subroutine twork431(y,na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
c    *                     a1,a2,b1,b2,c1,c2,d1,d2,indy,
c    *                     x1,ne1,ne2,nf1,nf2,ng1,ng2,
c    *                     e1,e2,f1,f2,g1,g2,indx1,
c    *                     x2,ni1,ni2,
c    *                     i1,i2,indx2,
c    *                     flopcount) 
      subroutine twork431(y,ne1,ne2,nf1,nf2,ng1,ng2,ni1,ni2,
     *                     e1,e2,f1,f2,g1,g2,i1,i2,indy,
     * 
     *                     x1,na1,na2,nb1,nb2,nc1,nc2,
     *                     a1,a2,b1,b2,c1,c2,indx1,
     * 
     *                     x2,nd1,nd2,
     *                     d1,d2,indx2,
     *                     flopcount) 
c-------------------------------------------------------------------------
c   Performs a "431" tensor contraction: 
c      4 index output array 
c      3 index operand array
c      1 index operand array
c
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ne1,ne2,nf1,nf2,ng1,ng2,
     *        ni1,ni2
      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2,g1,g2,i1,i2
      integer indy(4), indx1(3), indx2(1)
      integer flopcount

      double precision y(ne1:ne2,nf1:nf2,ng1:ng2,ni1:ni2)
      double precision x1(na1:na2,nb1:nb2,nc1:nc2)
      double precision x2(nd1:nd2)

      integer ia, ib, ic, id, ia2, ib2, ic2, id2
      integer i, j, a, b, c, d
      integer perm(4), h(4), ncount   

      character*4 char4 
      character*1 char(4) 

      flopcount = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1)
     
c---------------------------------------------------------------------------
c   Determine permutation required to put output array into desired order 
c---------------------------------------------------------------------------

      char(1) = '1'
      char(2) = '2'
      char(3) = '3'
      char(4) = '4'

      h(1) = indx1(1) 
      h(2) = indx1(2)  
      h(3) = indx1(3)  
      h(4) = indx2(1)  

      ncount = 0
      do i = 1, 4
      do j = 1, 4
         if (h(i) .eq. indy(j)) then 
            perm(j) = i
            ncount = ncount + 1
         endif
      enddo
      enddo

      if (ncount .ne. 4) then
         write(6,*) ' Problem with twork431 at line :', current_line
         call abort_job()
      endif 


      char4 = char(perm(1))//char(perm(2))//char(perm(3))//char(perm(4))

c
      if (char4 .eq. '1234') then
c          write(6,*) '11111111111' 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
      if (char4 .eq. '1243') then
c           write(6,*) '22222222222' 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,d,c) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
      if (char4 .eq. '2143') then 
c           write(6,*) '33333333333'
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(b,a,d,c) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c

      if (char4 .eq. '1324') then 
c           write(6,*) '4444444444'
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,c,b,d) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
      if (char4 .eq. '3214') then
c           write(6,*) '5555555555' 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(c,b,a,d) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
c-----------------------

      if (char4 .eq. '4231') then
c        write(6,*) '++++++++++++++++++++++++++++'  

c        write(6,*) ' ne nd:', ne1, ne2, ':', nd1, nd2 
c        write(6,*) ' e d:', e1, e2, ':', d1, d2
c        write(6,*) ' Problem with twork431 at line :', current_line
       
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(d,b,c,a) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c

      if (char4 .eq. '2134') then 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(b,a,c,d) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c

c permutation 3142 
      if (char4 .eq. '3142') then 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(c,a,d,b) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
c permutation 4231  
      if (char4 .eq. '4231') then 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(d,b,c,a) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
c permutation 3124 
      if (char4 .eq. '3124') then 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(c,a,b,d) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
c permutation 2341 
      if (char4 .eq. '2341') then 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(b,c,d,a) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c
c permutation 4123  
      if (char4 .eq. '4123') then 
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(d,a,b,c) = x1(a,b,c)*x2(d)
         enddo 
         enddo 
         enddo 
         enddo 
         return
      endif 
c

      print *,'twork431: Your tensor operation does not fit',
     *    ' any valid pattern; This sucks.', char4 
      call abort_job() 

      return
      end

      SUBROUTINE HESSOUT(X,IR,IC,NSYM)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end

































































































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
      DIMENSION X(IR,IC)
C
      JX=1
 1    ITOP=MIN(JX+4,IR)
      
CSS     IF(NSYM.EQ.1)
CSS     $   WRITE(LuOut,90)(VARNAM(ISQUASH(NOPTI(IX))),IX=JX,ITOP)
CSS      IF(NSYM.EQ.0)WRITE(LuOut,90)(VARNAM(ISQUASH(IX)),IX=JX,ITOP)
CSS 90   FORMAT(T15,A5,T25,A5,T35,A5,T45,A5,T55,A5)
CSS
      IF (iFlags2(5) .eq. 2) THEN
         CALL OUTPUT(X, 1, NX, 1, NX, NX, NX, 1)
      ELSE
         CALL OUTPUT(X, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
      ENDIF
       
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_1D_INTEGRALS
     +
     +                    ( SHELLA,SHELLB,SHELLP,
     +                      ATOMIC,
     +                      NEXP,
     +                      EA,EB,E2AB,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +
     +                               KIN1DX,
     +                               KIN1DY,
     +                               KIN1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_1D_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of kinetic 1D
C                X,Y,Z integrals using the previously established
C                overlap 1D X,Y,Z overlap integrals.
C
C                The I,J-th 1D kinetic integral is given by the
C                following formula:
C
C                    KIN1D (I,J)  =    1/2 * I * J * OVL1D (I-1,J-1)
C                                   -   I * ALPHAB * OVL1D (I-1,J+1)
C                                   -   J * ALPHAA * OVL1D (I+1,J-1)
C                           +  2 * ALPHAA * ALPHAB * OVL1D (I+1,J+1)
C
C
C                The 1D kinetic integrals are calculated for all
C                exponent pairs simultaneously and placed into a
C                3-dimensional array with the exponent pair index
C                varying fastest.
C
C
C                  Input:
C
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    NEXP         =  current # of exponent pairs
C                    Ex           =  current MIJ exponents from centers
C                                    x = A,B
C                    E2AB         =  current MIJ double exponent
C                                    products between centers A and B
C                    OVL1Dx       =  current overlap 1D integrals for
C                                    each cartesian component (x=X,Y,Z)
C
C                  Output:
C
C                    KIN1Dx       =  current kinetic 1D integrals for
C                                    each cartesian component (x=X,Y,Z)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   ATOMIC

         INTEGER   I,J,N
         INTEGER   IM1,IP1,JM1,JP1
         INTEGER   NEXP
         INTEGER   SHELLA,SHELLB,SHELLP

         DOUBLE PRECISION  HALF,HALFJ,HALFIJ
         DOUBLE PRECISION  XI,XJ,XIB,XJA,X2AB

         DOUBLE PRECISION  EA     (1:NEXP)
         DOUBLE PRECISION  EB     (1:NEXP)
         DOUBLE PRECISION  E2AB   (1:NEXP)

         DOUBLE PRECISION  KIN1DX (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  KIN1DY (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  KIN1DZ (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  OVL1DX (1:NEXP,0:SHELLP+2,0:SHELLB+1)
         DOUBLE PRECISION  OVL1DY (1:NEXP,0:SHELLP+2,0:SHELLB+1)
         DOUBLE PRECISION  OVL1DZ (1:NEXP,0:SHELLP+2,0:SHELLB+1)

         PARAMETER  (HALF = 0.5D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...pure atomic/nonatomic s-shell integrals first.
C
C
         DO 10 N = 1,NEXP
            X2AB = E2AB (N)
            KIN1DX (N,0,0) = X2AB * OVL1DX (N,1,1)
            KIN1DY (N,0,0) = X2AB * OVL1DY (N,1,1)
            KIN1DZ (N,0,0) = X2AB * OVL1DZ (N,1,1)
   10    CONTINUE

         IF (SHELLP.EQ.0) RETURN
C
C
C             ...check atomic or nonatomic case for extra integrals
C                (if any).
C
C
         IF (ATOMIC) THEN
C
C
C             ...atomic even-even column s-shell integrals.
C
C
             DO 100 I = 2,SHELLA,2
                IM1 = I - 1
                IP1 = I + 1
                XI = DFLOAT (I)

                DO 102 N = 1,NEXP
                   XIB = XI * EB (N)
                   X2AB = E2AB (N)
                   KIN1DX (N,I,0)  =  -  XIB * OVL1DX (N,IM1,1)
     +                                + X2AB * OVL1DX (N,IP1,1)
                   KIN1DY (N,I,0)  =  -  XIB * OVL1DY (N,IM1,1)
     +                                + X2AB * OVL1DY (N,IP1,1)
                   KIN1DZ (N,I,0)  =  -  XIB * OVL1DZ (N,IM1,1)
     +                                + X2AB * OVL1DZ (N,IP1,1)
  102           CONTINUE
  100        CONTINUE
C
C
C             ...atomic odd-odd column non s-shell integrals.
C
C
             DO 110 J = 1,SHELLB,2
                JM1 = J - 1
                JP1 = J + 1
                XJ = DFLOAT (J)
                HALFJ = HALF * XJ

                DO 112 I = 1,SHELLA,2
                   IM1 = I - 1
                   IP1 = I + 1
                   XI = DFLOAT (I)
                   HALFIJ = HALFJ * XI

                   DO 114 N = 1,NEXP
                      XIB = XI * EB (N)
                      XJA = XJ * EA (N)
                      X2AB = E2AB (N)

                      KIN1DX (N,I,J)  =  HALFIJ * OVL1DX (N,IM1,JM1)
     +                                   -  XIB * OVL1DX (N,IM1,JP1)
     +                                   -  XJA * OVL1DX (N,IP1,JM1)
     +                                   + X2AB * OVL1DX (N,IP1,JP1)
                      KIN1DY (N,I,J)  =  HALFIJ * OVL1DY (N,IM1,JM1)
     +                                   -  XIB * OVL1DY (N,IM1,JP1)
     +                                   -  XJA * OVL1DY (N,IP1,JM1)
     +                                   + X2AB * OVL1DY (N,IP1,JP1)
                      KIN1DZ (N,I,J)  =  HALFIJ * OVL1DZ (N,IM1,JM1)
     +                                   -  XIB * OVL1DZ (N,IM1,JP1)
     +                                   -  XJA * OVL1DZ (N,IP1,JM1)
     +                                   + X2AB * OVL1DZ (N,IP1,JP1)
  114              CONTINUE
  112           CONTINUE
  110        CONTINUE
C
C
C             ...atomic even-even column non s-shell integrals.
C
C
             DO 120 J = 2,SHELLB,2
                JM1 = J - 1
                JP1 = J + 1
                XJ = DFLOAT (J)

                DO 122 N = 1,NEXP
                   XJA = XJ * EA (N)
                   X2AB = E2AB (N)
                   KIN1DX (N,0,J)  =  -  XJA * OVL1DX (N,1,JM1)
     +                                + X2AB * OVL1DX (N,1,JP1)
                   KIN1DY (N,0,J)  =  -  XJA * OVL1DY (N,1,JM1)
     +                                + X2AB * OVL1DY (N,1,JP1)
                   KIN1DZ (N,0,J)  =  -  XJA * OVL1DZ (N,1,JM1)
     +                                + X2AB * OVL1DZ (N,1,JP1)
  122           CONTINUE

                HALFJ = HALF * XJ
                DO 124 I = 2,SHELLA,2
                   IM1 = I - 1
                   IP1 = I + 1
                   XI = DFLOAT (I)
                   HALFIJ = HALFJ * XI
                   DO 126 N = 1,NEXP
                      XIB = XI * EB (N)
                      XJA = XJ * EA (N)
                      X2AB = E2AB (N)

                      KIN1DX (N,I,J)  =  HALFIJ * OVL1DX (N,IM1,JM1)
     +                                   -  XIB * OVL1DX (N,IM1,JP1)
     +                                   -  XJA * OVL1DX (N,IP1,JM1)
     +                                   + X2AB * OVL1DX (N,IP1,JP1)
                      KIN1DY (N,I,J)  =  HALFIJ * OVL1DY (N,IM1,JM1)
     +                                   -  XIB * OVL1DY (N,IM1,JP1)
     +                                   -  XJA * OVL1DY (N,IP1,JM1)
     +                                   + X2AB * OVL1DY (N,IP1,JP1)
                      KIN1DZ (N,I,J)  =  HALFIJ * OVL1DZ (N,IM1,JM1)
     +                                   -  XIB * OVL1DZ (N,IM1,JP1)
     +                                   -  XJA * OVL1DZ (N,IP1,JM1)
     +                                   + X2AB * OVL1DZ (N,IP1,JP1)
  126              CONTINUE
  124           CONTINUE
  120        CONTINUE

         ELSE
C
C
C             ...nonatomic column s-shell integrals.
C
C
             DO 200 I = 1,SHELLA
                IM1 = I - 1
                IP1 = I + 1
                XI = DFLOAT (I)
                DO 202 N = 1,NEXP
                   XIB = XI * EB (N)
                   X2AB = E2AB (N)
                   KIN1DX (N,I,0)  =  -  XIB * OVL1DX (N,IM1,1)
     +                                + X2AB * OVL1DX (N,IP1,1)
                   KIN1DY (N,I,0)  =  -  XIB * OVL1DY (N,IM1,1)
     +                                + X2AB * OVL1DY (N,IP1,1)
                   KIN1DZ (N,I,0)  =  -  XIB * OVL1DZ (N,IM1,1)
     +                                + X2AB * OVL1DZ (N,IP1,1)
  202           CONTINUE
  200        CONTINUE
C
C
C             ...nonatomic column non s-shell integrals.
C
C
             DO 210 J = 1,SHELLB
                JM1 = J - 1
                JP1 = J + 1
                XJ = DFLOAT (J)

                DO 212 N = 1,NEXP
                   XJA = XJ * EA (N)
                   X2AB = E2AB (N)
                   KIN1DX (N,0,J)  =  -  XJA * OVL1DX (N,1,JM1)
     +                                + X2AB * OVL1DX (N,1,JP1)
                   KIN1DY (N,0,J)  =  -  XJA * OVL1DY (N,1,JM1)
     +                                + X2AB * OVL1DY (N,1,JP1)
                   KIN1DZ (N,0,J)  =  -  XJA * OVL1DZ (N,1,JM1)
     +                                + X2AB * OVL1DZ (N,1,JP1)
  212           CONTINUE

                HALFJ = HALF * XJ
                DO 214 I = 1,SHELLA
                   IM1 = I - 1
                   IP1 = I + 1
                   XI = DFLOAT (I)
                   HALFIJ = HALFJ * XI
                   DO 216 N = 1,NEXP
                      XIB = XI * EB (N)
                      XJA = XJ * EA (N)
                      X2AB = E2AB (N)

                      KIN1DX (N,I,J)  =  HALFIJ * OVL1DX (N,IM1,JM1)
     +                                   -  XIB * OVL1DX (N,IM1,JP1)
     +                                   -  XJA * OVL1DX (N,IP1,JM1)
     +                                   + X2AB * OVL1DX (N,IP1,JP1)
                      KIN1DY (N,I,J)  =  HALFIJ * OVL1DY (N,IM1,JM1)
     +                                   -  XIB * OVL1DY (N,IM1,JP1)
     +                                   -  XJA * OVL1DY (N,IP1,JM1)
     +                                   + X2AB * OVL1DY (N,IP1,JP1)
                      KIN1DZ (N,I,J)  =  HALFIJ * OVL1DZ (N,IM1,JM1)
     +                                   -  XIB * OVL1DZ (N,IM1,JP1)
     +                                   -  XJA * OVL1DZ (N,IP1,JM1)
     +                                   + X2AB * OVL1DZ (N,IP1,JP1)
  216              CONTINUE
  214           CONTINUE
  210        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine molden_rdbasis(natoms,iatchrg,gexp,coef,iunit)
c-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      parameter (mxatoms=100)
      parameter (nelement=103)
      parameter(toler=0.0000000D0)
      parameter(mxangmom=7)
      parameter(mxcoef=30)
      logical yesno
      character*2 celeaces(nelement)
      character*1 cangmom(mxangmom)
      character*80 wrk
      character*80 wrk2
      character*80 wrk3 
      character*30 cbasnam(mxatoms)
      character*30 cbasnam2(mxatoms)
      integer iatchrg(natoms),iangmom(mxangmom),
     &  icbf(mxangmom),iexp(mxangmom),ireorder(mxatoms),
     &  lsearch(mxatoms)

      double precision gexp(mxangmom,mxcoef)
      double precision coef(mxangmom,mxcoef,mxcoef)

c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
      data (celeaces(i),i=1,nelement)
     & /'H ','HE',
     & 'LI','BE','B ','C ','N ','O ','F ','NE',
     & 'NA','MG','AL','SI','P ','S ','CL','AR',
     & 'K ','CA',
     & 'SC','TI','V ','CR','MN','FE','CO','NI','CU','ZN',
     & 'GA','GE','AS','SE','BR','KR',
     & 'RB','SR',
     & 'Y ','ZR','NB','MO','TC','RU','RH','PD','AG','CD',
     & 'IN','SN','SB','TE','I ','XE',
     & 'CS','BA','LA',
     & 'CE','PR','ND','PM','SM','EU','GD',
     & 'TB','DY','HO','ER','TM','YB','LU',
     & 'HF','TA','W ','RE','OS','IR','PT','AU','HG',
     & 'TL','PB','BI','PO','AT','RN',
     & 'FR','RA','AC',
     & 'TH','PA','U ','NP','PU','AM','CM',
     & 'BK','CF','ES','FM','MD','NO','LR'/
      data (cangmom(i),i=1,mxangmom)
     &  /'s','p','d','f','g','h','i'/
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      if(iflags(61).eq.1) then
c
c>>>>>>>>>>>>>>>>>>>>>>> BASIS SET IS NOT SPECIAL<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c
        wrk = ' '
        call getrec(1,'JOBARC','BASNAMLN',1,lbasnam)
        call getcrec(1,'JOBARC','BASISNAM',lbasnam,wrk)
        do iatom=1,natoms
           i=2
           if (celeaces(iatchrg(iatom))(2:2).ne.' ') i=3
           cbasnam(iatom)=celeaces(iatchrg(iatom))
           cbasnam(iatom)(i:i)=':'
           cbasnam(iatom)(i+1:)=wrk
         end do
      else
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>BASIS IS SPECIAL<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c
c When BASIS=SPECIAL is choosen, the basis set entries are made at the
c bottom of ZMAT (after *ACES2 namelist), and the basis entires are made
c in the same order as the atom entries. A problem can arise if ACES II
c switches the first two atoms to get 2-1-3 connectivity pattern. We
c need to take care of that situation. Ajith Perera, 05/2005.
c
c get basis set name from ZMAT
c
        INQUIRE(FILE='ZMAT',EXIST=YESNO)
        IF(YESNO)THEN
          OPEN(UNIT=4,FILE='ZMAT',FORM='FORMATTED',STATUS='OLD')
          rewind(4)
        else
          write(6,'(T3,a)')'@RDBASIS-f, ZMAT file not present.'
          call errex
        ENDIF
c
300     READ(4,'(A)',END=900)WRK
        if (wrk(1:6).ne.'*ACES2') goto 300
c now look for a blank line
310     READ(4,'(A)',END=904)WRK
        i=1
        do while ((wrk(i:i).eq.' '.or.wrk(i:i).eq.achar(9)).and.
     &            i.le.len(wrk))
           i=i+1
        end do
        if (i.le.len(wrk)) goto 310
        do iatom=1,natoms
           read(4,'(A)',end=910)cbasnam(iatom)
        end do
        call getrec(-1,'JOBARC','12SWITCH',1,iswitch)
        if (iswitch.gt.0) then
           wrk        = cbasnam(2)
           cbasnam(2) = cbasnam(1)
           cbasnam(1) = wrk
        end if
c
100     CLOSE(UNIT=4,STATUS='KEEP')
      endif 
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>GENBAS<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      INQUIRE(FILE='GENBAS',EXIST=YESNO)
      IF(YESNO)THEN
        OPEN(UNIT=4,FILE='GENBAS',FORM='FORMATTED',STATUS='OLD')
      else
        write(6,340)
340     format(T3,'@RDBASIS-F, GENBAS file not preset.')
        call errex
      ENDIF
c
c loop over atoms, searching for basis set 
c
      do 400 iatom=1,natoms
        rewind(4)
        wrk=cbasnam(iatom)
410     READ(4,'(A)',END=906)WRK2
        if(wrk2.ne.wrk)goto 410

        READ(4,'(A)',END=908)WRK
        read(4,'(A)',END=908)wrk
 
        read(4,*)nshells
        read(4,*)(iangmom(i),i=1,nshells)
        read(4,*)(icbf(i),i=1,nshells)
        read(4,*)(iexp(i),i=1,nshells)
c
c loop over shells reading the exponents and coefficents
c note the coefficents are in columns
c
        do 420 ishell=1,nshells
          read(4,*)
     &      (gexp(ishell,j),j=1,iexp(ishell))

          do 430 icoef=1,iexp(ishell)
            read(4,*)
     &        (coef(ishell,ibas,icoef),ibas=1,icbf(ishell)) 
430       continue
420     continue
c ----------------------------------------------------------------------
c debug
c        write(6,*)' here is what has been read in for: '
c        write(6,2000)wrk2(1:lsearch)
c        write(6,3000)nshells
c3000    format(I3)
c        write(6,3001)(iangmom(i),i=1,nshells)
c3001    format(I5)
c        write(6,3002)(icbf(i),i=1,nshells)
c3002    format(I5)
c        write(6,3003)(iexp(i),i=1,nshells)
c3003    format(I5)
c ----------------------------------------------------------------------
        write(iunit,440)iatom
440     format(I3,' 0')
        do 450 ishell=1,nshells
          do 460 ibas=1,icbf(ishell)
c
c figure out how many primitives are needed to descripe this basis function
c
            ineed=0
            do 470 iprim=1,iexp(ishell)
              if(abs(coef(ishell,ibas,iprim)).gt.toler)then
                ineed=ineed+1
              endif
470         continue
c
c write out the primitives and coefficents
c
            write(iunit,480)' ',cangmom(iangmom(ishell)+1),ineed
480         format(A1,A1,3x,I2,' 1.00')
            do 490 iprim=1,iexp(ishell)
              if(abs(coef(ishell,ibas,iprim)).gt.toler)then
                write(iunit,500)' ',gexp(ishell,iprim),
     &            ' ',coef(ishell,ibas,iprim)
500             format(A,d18.10,A,d18.10)
              endif
490         continue 
460       continue
450     continue
        write(iunit,*)
c ----------------------------------------------------------------------
400   continue
      close(unit=4,status='KEEP')
      goto 1000 
900   WRITE(6,901)
901   FORMAT(T3,'@RDBASIS-F, *ACES2 namelist not found on ZMAT.')
      goto 911

902   WRITE(6,903)
903   FORMAT(T3,'@RDBASIS-F, keyword BASIS= not found in namelist.')
      goto 911

904   WRITE(6,905)
905   FORMAT(T3,'@RDBASIS-F, blank line is missing.  This specifies ',
     & 'the end of the namelist.')
      goto 911

906   write(6,907)
907   format('@RDBASIS-F, the following basis set not ',
     & 'present in GENBAS.')
      write(6,2000)cbasnam(iatom)
      goto 911

908   write(6,909)
909   format('@RDBASIS-F, GENBAS file terminates after ',
     & 'basis set specification for:')
      write(6,2000)cbasnam(iatom)
      goto 911

910   write(6,*)' ZMAT file terminates unexpectly'
      write(6,*)' basis sets read in: ',iatom
      write(6,*)' total basis sets needed: ',natoms
      goto 911

911   continue
      CLOSE(UNIT=4,STATUS='KEEP')
      CALL ERREX

1000  continue
      return
2000  format(A)
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__SPPP_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      ATOMIC,ATOM12,ATOM34,
     +                      MIJ,MKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL3,SHELLP,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      X12,Y12,Z12,X34,Y34,Z34,
     +                      ALPHA1,ALPHA2,ALPHA3,ALPHA4,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIM1,PRIM2,PRIM3,PRIM4,
     +                      NORM1,NORM2,NORM3,NORM4,
     +                      RHO12,RHO34,
     +                      P,PX,PY,PZ,SCALEP,
     +                      Q,QX,QY,QZ,SCALEQ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__SPPP_PCGTO_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation is designed to provide ultrafast block
C                evaluation of a batch of normalized electron repulsion
C                integrals between s-shell and p-shell primitive
C                spherical gaussian type orbitals.
C
C                A batch is defined here as containing all possible
C                integrals, that is its dimension is determined by
C                the total number of primitive functions (here = 27)
C                times the total number of ij and kl exponent pair
C                combinations.
C
C                The integrals are ordered in the batch the following
C                way (first index varying fastest):
C
C                    batch (nxyz1,nxyz2,nxyz3,nxyz4,kl,ij)
C
C                where ij and kl indicates alpha exponent pairs
C                defining the present block.
C
C                The present routine evaluates batches of the type:
C
C                            sppp , pspp , ppsp , ppps
C
C                The cartesian primitive integrals are evaluated using
C                the auxillary functions technique, described by
C                V.R. Saunders, "An Introduction to Molecular Integral
C                Evaluation" in "Computational Techniques in Quantum
C                Chemistry and Molecular Physics" edited by
C                GHF Diercksen, BT Sutcliff and A Veillard, D. Reidel
C                Publ. Comp. Dordrecht (1975), p. 347.
C
C                The cartesian primitive integrals are each evaluated
C                explicitely using common multipliers if possible and
C                avoiding array addresses.
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    sppp/pspp/ppsp/ppps integral batch
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    ATOM12(34)   =  indicates, if centers 1 and 2
C                                    (3 and 4) coincide
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the contracted shell pairs 1,2
C                                    (3,4)
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair 1,2
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NKL          =  total # of kl primitive index
C                                    pairs for the contracted shell
C                                    pair 3,4
C                    NKLBEG(END)  =  first(last) kl primitive index
C                                    defining the kl block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = 1,2,3,4
C                    SHELLx       =  the shell type for contraction
C                                    shells x = 1,3,P=1+2
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = 1,2,3,4
C                    Xxx,Yxx,Zxx  =  the x,y,z-coordinate differences
C                                    between centers xx = 12 and 34
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = 1,2,3,4
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j,k,l labels of primitives for
C                                    the respective contraction shells
C                                    x = 1,2,3,4
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = 1,2,3,4
C                    RHO12(34)    =  the complete set of NIJ (NKL)
C                                    exponential prefactors between
C                                    contraction shells 1 and 2
C                                    (3 and 4)
C                    P            =  will hold current MIJ exponent
C                                    sums for contraction shells 1
C                                    and 2
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=1+2
C                    SCALEP       =  will hold current MIJ values of
C                                    scaling factors related to point P
C                    Q            =  will hold current MKL exponent
C                                    sums for contraction shells 3
C                                    and 4
C                    Qx           =  will hold current MKL coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers Q=3+4
C                    SCALEQ       =  will hold current MKL values of
C                                    scaling factors related to point Q
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian sppp/pspp/ppsp/ppps
C                                    integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOM12,ATOM34

         INTEGER     CASE
         INTEGER     I,J,K,L,M
         INTEGER     IJ,KL
         INTEGER     MGRID,NGRID,TGRID
         INTEGER     MIJ,MKL
         INTEGER     NBATCH
         INTEGER     NIJ,NKL
         INTEGER     NIJBEG,NIJEND,NKLBEG,NKLEND
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4
         INTEGER     SHELL1,SHELL3,SHELLP

         INTEGER     PRIM1 (1:MIJ)
         INTEGER     PRIM2 (1:MIJ)
         INTEGER     PRIM3 (1:MKL)
         INTEGER     PRIM4 (1:MKL)

         DOUBLE PRECISION  A,B,C,D,E,F,G,H,R
         DOUBLE PRECISION  AA,BB
         DOUBLE PRECISION  DELTA1,DELTA2,DELTA3,DELTA4,DELTA5,DELTA6
         DOUBLE PRECISION  EXP1,EXP2,EXP3,EXP4
         DOUBLE PRECISION  F0,F1,F2,F3
         DOUBLE PRECISION  GXXX,GXXY,GXXZ,GXYX,GXYY,GXYZ,GXZX,GXZY,GXZZ,
     +                     GYXX,GYXY,GYXZ,GYYX,GYYY,GYYZ,GYZX,GYZY,GYZZ,
     +                     GZXX,GZXY,GZXZ,GZYX,GZYY,GZYZ,GZZX,GZZY,GZZZ
         DOUBLE PRECISION  PVAL,QVAL,PINV,QINV
         DOUBLE PRECISION  PQPLUS,PQMULT,PQPINV
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE
         DOUBLE PRECISION  PXSUB,PYSUB,PZSUB,QXSUB,QYSUB,QZSUB
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL,QXVAL,QYVAL,QZVAL
         DOUBLE PRECISION  RNPQSQ
         DOUBLE PRECISION  SCALE
         DOUBLE PRECISION  T,TINV,T2INV,TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  U0,U1,U2,U3,U4,U5
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4
         DOUBLE PRECISION  X12,Y12,Z12,X34,Y34,Z34
         DOUBLE PRECISION  XSSP1,XSPS1,XPSS1,XSSP2,XSPS2,XPSS2,
     +                     XSPP1,XPSP1,XPPS1,XSPP2,XPSP2,XPPS2,
     +                     XSPP3,XPSP3,XPPS3,XPPP1,XPPP2,XPPP3,XPPP4,
     +                     YSSP1,YSPS1,YPSS1,YSSP2,YSPS2,YPSS2,
     +                     YSPP1,YPSP1,YPPS1,YSPP2,YPSP2,YPPS2,
     +                     YSPP3,YPSP3,YPPS3,YPPP1,YPPP2,YPPP3,YPPP4,
     +                     ZSSP1,ZSPS1,ZPSS1,ZSSP2,ZSPS2,ZPSS2,
     +                     ZSPP1,ZPSP1,ZPPS1,ZSPP2,ZPSP2,ZPPS2,
     +                     ZSPP3,ZPSP3,ZPPS3,ZPPP1,ZPPP2,ZPPP3,ZPPP4
         DOUBLE PRECISION  FIFTH,THIRD,HALF,ONE,THREE,PI,FIVE

         DOUBLE PRECISION  ALPHA1 (1:NPGTO1)
         DOUBLE PRECISION  ALPHA2 (1:NPGTO2)
         DOUBLE PRECISION  ALPHA3 (1:NPGTO3)
         DOUBLE PRECISION  ALPHA4 (1:NPGTO4)

         DOUBLE PRECISION  NORM1  (1:NPGTO1)
         DOUBLE PRECISION  NORM2  (1:NPGTO2)
         DOUBLE PRECISION  NORM3  (1:NPGTO3)
         DOUBLE PRECISION  NORM4  (1:NPGTO4)

         DOUBLE PRECISION  RHO12  (1:NIJ)
         DOUBLE PRECISION  RHO34  (1:NKL)

         DOUBLE PRECISION  BATCH  (1:NBATCH)

         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  PX     (1:MIJ)
         DOUBLE PRECISION  PY     (1:MIJ)
         DOUBLE PRECISION  PZ     (1:MIJ)
         DOUBLE PRECISION  SCALEP (1:MIJ)

         DOUBLE PRECISION  Q      (1:MKL)
         DOUBLE PRECISION  QX     (1:MKL)
         DOUBLE PRECISION  QY     (1:MKL)
         DOUBLE PRECISION  QZ     (1:MKL)
         DOUBLE PRECISION  SCALEQ (1:MKL)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (FIFTH   =  0.2D0)
         PARAMETER  (THIRD   =  0.333333333333333D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0 )
         PARAMETER  (THREE   =  3.D0 )
         PARAMETER  (PI      =  3.141592653589793D0)
         PARAMETER  (FIVE    =  5.D0 )
C
C
C------------------------------------------------------------------------
C
C
C             ...predetermine in 'K2' loops the quantities associated
C                with the 1,2-part and 3,4-part.
C
C
         CASE = 5

         IF (ATOMIC.OR.ATOM12) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                P (M) = ALPHA1 (I) + ALPHA2 (J)
                SCALEP (M) = NORM1 (I) * NORM2 (J)
  100        CONTINUE
             CASE = CASE - 1
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                EXP1 = ALPHA1 (I)
                EXP2 = ALPHA2 (J)
                PVAL = EXP1 + EXP2
                P (M) = PVAL
                PVAL = EXP1 / PVAL
                PX (M) = PVAL * X12 + X2
                PY (M) = PVAL * Y12 + Y2
                PZ (M) = PVAL * Z12 + Z2
                SCALEP (M) = NORM1 (I) * NORM2 (J) * RHO12 (IJ)
  110        CONTINUE
         END IF

         IF (ATOMIC.OR.ATOM34) THEN
             M = 0
             DO 200 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                Q (M) = ALPHA3 (K) + ALPHA4 (L)
                SCALEQ (M) = NORM3 (K) * NORM4 (L)
  200        CONTINUE
             CASE = CASE - 2
         ELSE
             M = 0
             DO 220 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                EXP3 = ALPHA3 (K)
                EXP4 = ALPHA4 (L)
                QVAL = EXP3 + EXP4
                Q (M) = QVAL
                QVAL = EXP3 / QVAL
                QX (M) = QVAL * X34 + X4
                QY (M) = QVAL * Y34 + Y4
                QZ (M) = QVAL * Z34 + Z4
                SCALEQ (M) = NORM3 (K) * NORM4 (L) * RHO34 (KL)
  220        CONTINUE
         END IF

         IF (ATOMIC) THEN
             CASE = CASE - 1
         END IF
C
C
C             ...jump according to where the s-type function is
C                located and the type of 'K4' loop:
C
C                 SHELLP CASE  |        Integral center type
C                --------------|------------------------------------
C                    1     1   |  (AA|AA)  atomic     sppp and pspp
C                    1     2   |  (AA|CC)  2-center   sppp and pspp
C                    1     3   |  (AB|CC)  3-center   sppp and pspp
C                    1     4   |  (AA|CD)  3-center   sppp and pspp
C                    1     5   |  (AB|CD)  4-center   sppp and pspp
C
C                    2     1   |  (AA|AA)  atomic     ppsp and ppps
C                    2     2   |  (AA|CC)  2-center   ppsp and ppps
C                    2     3   |  (AB|CC)  3-center   ppsp and ppps
C                    2     4   |  (AA|CD)  3-center   ppsp and ppps
C                    2     5   |  (AB|CD)  4-center   ppsp and ppps
C
C
         GOTO (11,12,13,14,15,21,22,23,24,25) 5*(SHELLP-1)+CASE
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic sppp and
C                pspp integrals. All these integrals are zero by
C                symmetry.
C
C
   11    RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center sppp and
C                pspp (AA|CC) type integrals.
C
C
   12    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

         M = 0
         DO 1200 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1220 KL = 1,MKL
               QVAL = Q (KL)
               QINV = ONE / QVAL
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U4 = HALF * QINV
C
C
C             ...the X-terms.
C
C
               XSSP2 = PQX * U0
               XPSS2 = PQX * U1
               XSPP3 = XSSP2 * XSSP2
               XPSP3 = XSSP2 * XPSS2
               XPPP2 = U4 * XPSS2
               XPPP3 = U3 * XSSP2
               XPPP4 = XPSS2 * XSPP3
C
C
C             ...the Y-terms.
C
C
               YSSP2 = PQY * U0
               YPSS2 = PQY * U1
               YSPP3 = YSSP2 * YSSP2
               YPSP3 = YSSP2 * YPSS2
               YPPP2 = U4 * YPSS2
               YPPP3 = U3 * YSSP2
               YPPP4 = YPSS2 * YSPP3
C
C
C             ...the Z-terms.
C
C
               ZSSP2 = PQZ * U0
               ZPSS2 = PQZ * U1
               ZSPP3 = ZSSP2 * ZSSP2
               ZPSP3 = ZSSP2 * ZPSS2
               ZPPP2 = U4 * ZPSS2
               ZPPP3 = U3 * ZSSP2
               ZPPP4 = ZPSS2 * ZSPP3
C
C
C             ...assemble the 2-center (AA|CC) type integrals.
C
C
               GXXX = XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               A = U4 * (F1 - U0 * F2)
               B = U2 * F2
               C = B + XPSP3 * F3
               D = A + XSPP3 * F3

               GXXY = YSSP2 * C
               GXXZ = ZSSP2 * C
               GYXX = YPSS2 * D
               GZXX = ZPSS2 * D

               C = B + YPSP3 * F3
               D = A + YSPP3 * F3

               GYXY = XSSP2 * C
               GYYZ = ZSSP2 * C
               GXYY = XPSS2 * D
               GZYY = ZPSS2 * D

               C = B + ZPSP3 * F3
               D = A + ZSPP3 * F3

               GZXZ = XSSP2 * C
               GZYZ = YSSP2 * C
               GXZZ = XPSS2 * D
               GYZZ = YPSS2 * D

               GXYZ = YSSP2 * ZSSP2 * XPSS2 * F3
               GYXZ = XSSP2 * ZSSP2 * YPSS2 * F3
               GZXY = XSSP2 * YSSP2 * ZPSS2 * F3

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GYXX
               BATCH (M+ 3) = GZXX
               BATCH (M+ 4) = GXXY
               BATCH (M+ 5) = GYXY
               BATCH (M+ 6) = GZXY
               BATCH (M+ 7) = GXXZ
               BATCH (M+ 8) = GYXZ
               BATCH (M+ 9) = GZXZ
               BATCH (M+10) = GXXY
               BATCH (M+11) = GYXY
               BATCH (M+12) = GZXY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GZYY
               BATCH (M+16) = GXYZ
               BATCH (M+17) = GYYZ
               BATCH (M+18) = GZYZ
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GYXZ
               BATCH (M+21) = GZXZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GZYZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 1220       CONTINUE
 1200    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center sppp and
C                pspp (AB|CC) type integrals.
C
C
   13    IF (SHELL1.EQ.1) THEN
             PXSUB = X1
             PYSUB = Y1
             PZSUB = Z1
         ELSE
             PXSUB = X2
             PYSUB = Y2
             PZSUB = Z2
         END IF

         M = 0
         DO 1300 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PQX = PXVAL - X3
            PQY = PYVAL - Y3
            PQZ = PZVAL - Z3
            RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ 
            PSCALE = SCALEP (IJ)
            XPSS1 = PXVAL - PXSUB
            YPSS1 = PYVAL - PYSUB
            ZPSS1 = PZVAL - PZSUB
            DO 1330 KL = 1,MKL
               QVAL = Q (KL)
               QINV = ONE / QVAL
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U4 = HALF * QINV
               U5 = - U0 * U4
C
C
C             ...the X-terms.
C
C
               XSSP2 = PQX * U0
               XPSS2 = PQX * U1
               XPSP2 = XPSS1 * XSSP2 + U2
               XSPP3 = XSSP2 * XSSP2
               XPSP3 = XSSP2 * XPSS2
               XPPP1 = XPSS1 * U4
               XPPP2 = XPSS1 * U5 + U4 * XPSS2
               XPPP3 = XPSS1 * XSPP3 + U3 * XSSP2
               XPPP4 = XPSS2 * XSPP3
C
C
C             ...the Y-terms.
C
C
               YSSP2 = PQY * U0
               YPSS2 = PQY * U1
               YPSP2 = YPSS1 * YSSP2 + U2
               YSPP3 = YSSP2 * YSSP2
               YPSP3 = YSSP2 * YPSS2
               YPPP1 = YPSS1 * U4
               YPPP2 = YPSS1 * U5 + U4 * YPSS2
               YPPP3 = YPSS1 * YSPP3 + U3 * YSSP2
               YPPP4 = YPSS2 * YSPP3
C
C
C             ...the Z-terms.
C
C
               ZSSP2 = PQZ * U0
               ZPSS2 = PQZ * U1
               ZPSP2 = ZPSS1 * ZSSP2 + U2
               ZSPP3 = ZSSP2 * ZSSP2
               ZPSP3 = ZSSP2 * ZPSS2
               ZPPP1 = ZPSS1 * U4
               ZPPP2 = ZPSS1 * U5 + U4 * ZPSS2
               ZPPP3 = ZPSS1 * ZSPP3 + U3 * ZSSP2
               ZPPP4 = ZPSS2 * ZSPP3
C
C
C             ...assemble the 3-center (AB|CC) type integrals.
C
C
               GXXX = XPPP1 * F0 + XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP1 * F0 + YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP1 * F0 + ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               A = U4 * F0 + U5 * F1
               B = U4 * F1 + U5 * F2
               C = XPSP2 * F2 + XPSP3 * F3
               D = A + XSPP3 * F2
               E = B + XSPP3 * F3

               GXXY = YSSP2 * C
               GXXZ = ZSSP2 * C
               GYXX = YPSS1 * D + YPSS2 * E
               GZXX = ZPSS1 * D + ZPSS2 * E

               C = YPSP2 * F2 + YPSP3 * F3
               D = A + YSPP3 * F2
               E = B + YSPP3 * F3

               GYXY = XSSP2 * C
               GYYZ = ZSSP2 * C
               GXYY = XPSS1 * D + XPSS2 * E
               GZYY = ZPSS1 * D + ZPSS2 * E

               C = ZPSP2 * F2 + ZPSP3 * F3
               D = A + ZSPP3 * F2
               E = B + ZSPP3 * F3

               GZXZ = XSSP2 * C
               GZYZ = YSSP2 * C
               GXZZ = XPSS1 * D + XPSS2 * E
               GYZZ = YPSS1 * D + YPSS2 * E

               GXYZ = YSSP2 * ZSSP2 * (XPSS1 * F2 + XPSS2 * F3)
               GYXZ = XSSP2 * ZSSP2 * (YPSS1 * F2 + YPSS2 * F3)
               GZXY = XSSP2 * YSSP2 * (ZPSS1 * F2 + ZPSS2 * F3)

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GYXX
               BATCH (M+ 3) = GZXX
               BATCH (M+ 4) = GXXY
               BATCH (M+ 5) = GYXY
               BATCH (M+ 6) = GZXY
               BATCH (M+ 7) = GXXZ
               BATCH (M+ 8) = GYXZ
               BATCH (M+ 9) = GZXZ
               BATCH (M+10) = GXXY
               BATCH (M+11) = GYXY
               BATCH (M+12) = GZXY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GZYY
               BATCH (M+16) = GXYZ
               BATCH (M+17) = GYYZ
               BATCH (M+18) = GZYZ
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GYXZ
               BATCH (M+21) = GZXZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GZYZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 1330       CONTINUE
 1300    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center sppp and
C                pspp (AA|CD) type integrals.
C
C
   14    M = 0
         DO 1400 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1440 KL = 1,MKL
               QVAL = Q (KL)
               QINV = ONE / QVAL
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = X1 - QXVAL
               PQY = Y1 - QYVAL
               PQZ = Z1 - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U4 = HALF * QINV
               U5 = U0 * U4
C
C
C             ...the X-terms.
C
C
               XSSP1 = QXVAL - X4
               XSPS1 = QXVAL - X3
               XSSP2 = PQX * U0
               XPSS2 = PQX * U1
               A     = XSPS1 + XSSP1
               XSPP1 = XSPS1 * XSSP1 + U4
               XSPP2 = A * XSSP2 - U5
               XSPP3 = XSSP2 * XSSP2
               XPSP2 = XSSP1 * XPSS2 + U2
               XPSP3 = XSSP2 * XPSS2
               XPPS2 = XSPS1 * XPSS2 + U2
               XPPP2 = XSPP1 * XPSS2 + A * U2
               XPPP3 = A * XPSP3 + U3 * XSSP2
               XPPP4 = XPSS2 * XSPP3
C
C
C             ...the Y-terms.
C
C
               YSSP1 = QYVAL - Y4
               YSPS1 = QYVAL - Y3
               YSSP2 = PQY * U0
               YPSS2 = PQY * U1
               A     = YSPS1 + YSSP1
               YSPP1 = YSPS1 * YSSP1 + U4
               YSPP2 = A * YSSP2 - U5
               YSPP3 = YSSP2 * YSSP2
               YPSP2 = YSSP1 * YPSS2 + U2
               YPSP3 = YSSP2 * YPSS2
               YPPS2 = YSPS1 * YPSS2 + U2
               YPPP2 = YSPP1 * YPSS2 + A * U2
               YPPP3 = A * YPSP3 + U3 * YSSP2
               YPPP4 = YPSS2 * YSPP3
C
C
C             ...the Z-terms.
C
C
               ZSSP1 = QZVAL - Z4
               ZSPS1 = QZVAL - Z3
               ZSSP2 = PQZ * U0
               ZPSS2 = PQZ * U1
               A     = ZSPS1 + ZSSP1
               ZSPP1 = ZSPS1 * ZSSP1 + U4
               ZSPP2 = A * ZSSP2 - U5
               ZSPP3 = ZSSP2 * ZSSP2
               ZPSP2 = ZSSP1 * ZPSS2 + U2
               ZPSP3 = ZSSP2 * ZPSS2
               ZPPS2 = ZSPS1 * ZPSS2 + U2
               ZPPP2 = ZSPP1 * ZPSS2 + A * U2
               ZPPP3 = A * ZPSP3 + U3 * ZSSP2
               ZPPP4 = ZPSS2 * ZSPP3
C
C
C             ...assemble the 3-center (AA|CD) type integrals.
C
C
               GXXX = XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               AA = XPSP3 * F2
               BB = XPSP3 * F3

               A = XPPS2 * F1 + AA
               B = XPPS2 * F2 + BB
               C = XPSP2 * F1 + AA
               D = XPSP2 * F2 + BB
               F = XSPP1 * F1 + XSPP2 * F2 + XSPP3 * F3

               GXXY = YSSP1 * A + YSSP2 * B
               GXXZ = ZSSP1 * A + ZSSP2 * B
               GXYX = YSPS1 * C + YSSP2 * D
               GXZX = ZSPS1 * C + ZSSP2 * D
               GYXX = YPSS2 * F
               GZXX = ZPSS2 * F

               AA = YPSP3 * F2
               BB = YPSP3 * F3

               A = YPPS2 * F1 + AA
               B = YPPS2 * F2 + BB
               C = YPSP2 * F1 + AA
               D = YPSP2 * F2 + BB
               F = YSPP1 * F1 + YSPP2 * F2 + YSPP3 * F3

               GYYX = XSSP1 * A + XSSP2 * B
               GYYZ = ZSSP1 * A + ZSSP2 * B
               GYXY = XSPS1 * C + XSSP2 * D
               GYZY = ZSPS1 * C + ZSSP2 * D
               GXYY = XPSS2 * F
               GZYY = ZPSS2 * F

               AA = ZPSP3 * F2
               BB = ZPSP3 * F3

               A = ZPPS2 * F1 + AA
               B = ZPPS2 * F2 + BB
               C = ZPSP2 * F1 + AA
               D = ZPSP2 * F2 + BB
               F = ZSPP1 * F1 + ZSPP2 * F2 + ZSPP3 * F3

               GZZX = XSSP1 * A + XSSP2 * B
               GZZY = YSSP1 * A + YSSP2 * B
               GZXZ = XSPS1 * C + XSSP2 * D
               GZYZ = YSPS1 * C + YSSP2 * D
               GXZZ = XPSS2 * F
               GYZZ = YPSS2 * F

               A = XSSP1 * F1 + XSSP2 * F2
               B = XSSP1 * F2 + XSSP2 * F3
               C = YSSP1 * F1 + YSSP2 * F2
               D = YSSP1 * F2 + YSSP2 * F3
               E = ZSSP1 * F1 + ZSSP2 * F2
               F = ZSSP1 * F2 + ZSSP2 * F3

               GXYZ = (YSPS1 * E + YSSP2 * F) * XPSS2
               GXZY = (ZSPS1 * C + ZSSP2 * D) * XPSS2
               GYXZ = (XSPS1 * E + XSSP2 * F) * YPSS2
               GYZX = (ZSPS1 * A + ZSSP2 * B) * YPSS2
               GZXY = (XSPS1 * C + XSSP2 * D) * ZPSS2
               GZYX = (YSPS1 * A + YSSP2 * B) * ZPSS2

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GYXX
               BATCH (M+ 3) = GZXX
               BATCH (M+ 4) = GXYX
               BATCH (M+ 5) = GYYX
               BATCH (M+ 6) = GZYX
               BATCH (M+ 7) = GXZX
               BATCH (M+ 8) = GYZX
               BATCH (M+ 9) = GZZX
               BATCH (M+10) = GXXY
               BATCH (M+11) = GYXY
               BATCH (M+12) = GZXY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GZYY
               BATCH (M+16) = GXZY
               BATCH (M+17) = GYZY
               BATCH (M+18) = GZZY
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GYXZ
               BATCH (M+21) = GZXZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GZYZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 1440       CONTINUE
 1400    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center sppp and
C                pspp (AB|CD) type integrals.
C
C
   15    IF (SHELL1.EQ.1) THEN
             PXSUB = X1
             PYSUB = Y1
             PZSUB = Z1
         ELSE
             PXSUB = X2
             PYSUB = Y2
             PZSUB = Z2
         END IF

         M = 0
         DO 1500 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            XPSS1 = PXVAL - PXSUB
            YPSS1 = PYVAL - PYSUB
            ZPSS1 = PZVAL - PZSUB
            DO 1550 KL = 1,MKL
               QVAL = Q (KL)
               QINV = ONE / QVAL
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = PXVAL - QXVAL
               PQY = PYVAL - QYVAL
               PQZ = PZVAL - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U4 = HALF * QINV
               U5 = U0 * U4
C
C
C             ...the X-terms.
C
C
               XSSP1 = QXVAL - X4
               XSPS1 = QXVAL - X3
               XSSP2 = PQX * U0
               XPSS2 = PQX * U1
               A     = XSPS1 + XSSP1
               B     = XPSS1 * XSSP2 + U2
               XSPP1 = XSPS1 * XSSP1 + U4
               XSPP2 = A * XSSP2 - U5
               XSPP3 = XSSP2 * XSSP2
               XPSP1 = XPSS1 * XSSP1
               XPSP2 = XSSP1 * XPSS2 + B
               XPSP3 = XSSP2 * XPSS2
               XPPS1 = XPSS1 * XSPS1
               XPPS2 = XSPS1 * XPSS2 + B
               XPPP1 = XPSS1 * XSPP1
               XPPP2 = XPSS1 * XSPP2 + XSPP1 * XPSS2 + A * U2
               XPPP3 = XPSS1 * XSPP3 + A * XPSP3 + U3 * XSSP2
               XPPP4 = XPSS2 * XSPP3
C
C
C             ...the Y-terms.
C
C
               YSSP1 = QYVAL - Y4
               YSPS1 = QYVAL - Y3
               YSSP2 = PQY * U0
               YPSS2 = PQY * U1
               A     = YSPS1 + YSSP1
               B     = YPSS1 * YSSP2 + U2
               YSPP1 = YSPS1 * YSSP1 + U4
               YSPP2 = A * YSSP2 - U5
               YSPP3 = YSSP2 * YSSP2
               YPSP1 = YPSS1 * YSSP1
               YPSP2 = YSSP1 * YPSS2 + B
               YPSP3 = YSSP2 * YPSS2
               YPPS1 = YPSS1 * YSPS1
               YPPS2 = YSPS1 * YPSS2 + B
               YPPP1 = YPSS1 * YSPP1
               YPPP2 = YPSS1 * YSPP2 + YSPP1 * YPSS2 + A * U2
               YPPP3 = YPSS1 * YSPP3 + A * YPSP3 + U3 * YSSP2
               YPPP4 = YPSS2 * YSPP3
C
C
C             ...the Z-terms.
C
C
               ZSSP1 = QZVAL - Z4
               ZSPS1 = QZVAL - Z3
               ZSSP2 = PQZ * U0
               ZPSS2 = PQZ * U1
               A     = ZSPS1 + ZSSP1
               B     = ZPSS1 * ZSSP2 + U2
               ZSPP1 = ZSPS1 * ZSSP1 + U4
               ZSPP2 = A * ZSSP2 - U5
               ZSPP3 = ZSSP2 * ZSSP2
               ZPSP1 = ZPSS1 * ZSSP1
               ZPSP2 = ZSSP1 * ZPSS2 + B
               ZPSP3 = ZSSP2 * ZPSS2
               ZPPS1 = ZPSS1 * ZSPS1
               ZPPS2 = ZSPS1 * ZPSS2 + B
               ZPPP1 = ZPSS1 * ZSPP1
               ZPPP2 = ZPSS1 * ZSPP2 + ZSPP1 * ZPSS2 + A * U2
               ZPPP3 = ZPSS1 * ZSPP3 + A * ZPSP3 + U3 * ZSSP2
               ZPPP4 = ZPSS2 * ZSPP3
C
C
C             ...assemble the 4-center (AB|CD) type integrals.
C
C
               GXXX = XPPP1 * F0 + XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP1 * F0 + YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP1 * F0 + ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               AA = XPSP3 * F2
               BB = XPSP3 * F3

               A = XPPS1 * F0 + XPPS2 * F1 + AA
               B = XPPS1 * F1 + XPPS2 * F2 + BB
               C = XPSP1 * F0 + XPSP2 * F1 + AA
               D = XPSP1 * F1 + XPSP2 * F2 + BB
               E = XSPP1 * F0 + XSPP2 * F1 + XSPP3 * F2
               F = XSPP1 * F1 + XSPP2 * F2 + XSPP3 * F3

               GXXY = YSSP1 * A + YSSP2 * B
               GXXZ = ZSSP1 * A + ZSSP2 * B
               GXYX = YSPS1 * C + YSSP2 * D
               GXZX = ZSPS1 * C + ZSSP2 * D
               GYXX = YPSS1 * E + YPSS2 * F
               GZXX = ZPSS1 * E + ZPSS2 * F

               AA = YPSP3 * F2
               BB = YPSP3 * F3

               A = YPPS1 * F0 + YPPS2 * F1 + AA
               B = YPPS1 * F1 + YPPS2 * F2 + BB
               C = YPSP1 * F0 + YPSP2 * F1 + AA
               D = YPSP1 * F1 + YPSP2 * F2 + BB
               E = YSPP1 * F0 + YSPP2 * F1 + YSPP3 * F2
               F = YSPP1 * F1 + YSPP2 * F2 + YSPP3 * F3

               GYYX = XSSP1 * A + XSSP2 * B
               GYYZ = ZSSP1 * A + ZSSP2 * B
               GYXY = XSPS1 * C + XSSP2 * D
               GYZY = ZSPS1 * C + ZSSP2 * D
               GXYY = XPSS1 * E + XPSS2 * F
               GZYY = ZPSS1 * E + ZPSS2 * F

               AA = ZPSP3 * F2
               BB = ZPSP3 * F3

               A = ZPPS1 * F0 + ZPPS2 * F1 + AA
               B = ZPPS1 * F1 + ZPPS2 * F2 + BB
               C = ZPSP1 * F0 + ZPSP2 * F1 + AA
               D = ZPSP1 * F1 + ZPSP2 * F2 + BB
               E = ZSPP1 * F0 + ZSPP2 * F1 + ZSPP3 * F2
               F = ZSPP1 * F1 + ZSPP2 * F2 + ZSPP3 * F3

               GZZX = XSSP1 * A + XSSP2 * B
               GZZY = YSSP1 * A + YSSP2 * B
               GZXZ = XSPS1 * C + XSSP2 * D
               GZYZ = YSPS1 * C + YSSP2 * D
               GXZZ = XPSS1 * E + XPSS2 * F
               GYZZ = YPSS1 * E + YPSS2 * F

               A = XPSS1 * F0 + XPSS2 * F1
               B = XPSS1 * F1 + XPSS2 * F2
               C = XPSS1 * F2 + XPSS2 * F3
               D = YPSS1 * F0 + YPSS2 * F1
               E = YPSS1 * F1 + YPSS2 * F2
               F = YPSS1 * F2 + YPSS2 * F3
               G = ZPSS1 * F0 + ZPSS2 * F1
               H = ZPSS1 * F1 + ZPSS2 * F2
               R = ZPSS1 * F2 + ZPSS2 * F3

               GXYZ = YSPS1*(ZSSP1*A+ZSSP2*B) + YSSP2*(ZSSP1*B+ZSSP2*C)
               GXZY = ZSPS1*(YSSP1*A+YSSP2*B) + ZSSP2*(YSSP1*B+YSSP2*C)
               GYXZ = XSPS1*(ZSSP1*D+ZSSP2*E) + XSSP2*(ZSSP1*E+ZSSP2*F)
               GYZX = ZSPS1*(XSSP1*D+XSSP2*E) + ZSSP2*(XSSP1*E+XSSP2*F)
               GZXY = XSPS1*(YSSP1*G+YSSP2*H) + XSSP2*(YSSP1*H+YSSP2*R)
               GZYX = YSPS1*(XSSP1*G+XSSP2*H) + YSSP2*(XSSP1*H+XSSP2*R)

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GYXX
               BATCH (M+ 3) = GZXX
               BATCH (M+ 4) = GXYX
               BATCH (M+ 5) = GYYX
               BATCH (M+ 6) = GZYX
               BATCH (M+ 7) = GXZX
               BATCH (M+ 8) = GYZX
               BATCH (M+ 9) = GZZX
               BATCH (M+10) = GXXY
               BATCH (M+11) = GYXY
               BATCH (M+12) = GZXY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GZYY
               BATCH (M+16) = GXZY
               BATCH (M+17) = GYZY
               BATCH (M+18) = GZZY
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GYXZ
               BATCH (M+21) = GZXZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GZYZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 1550       CONTINUE
 1500    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic ppsp and
C                ppps integrals. All these integrals are zero by
C                symmetry.
C
C
   21    RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center ppsp and
C                ppps (AA|CC) type integrals.
C
C
   22    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

         M = 0
         DO 2200 IJ = 1,MIJ
            PVAL = P (IJ)
            PINV = ONE / PVAL
            PSCALE = SCALEP (IJ)
            U4 = HALF * PINV
            DO 2220 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U5 = U1 * U4
C
C
C             ...the X-terms.
C
C
               XSSP2 = PQX * U0
               XSPS2 = PQX * U1
               XSPP3 = XSSP2 * XSPS2
               XPPS3 = XSPS2 * XSPS2
               XPPP2 = U4 * XSSP2
               XPPP3 = U3 * XSPS2
               XPPP4 = XSSP2 * XPPS3
C
C
C             ...the Y-terms.
C
C
               YSSP2 = PQY * U0
               YSPS2 = PQY * U1
               YSPP3 = YSSP2 * YSPS2
               YPPS3 = YSPS2 * YSPS2
               YPPP2 = U4 * YSSP2
               YPPP3 = U3 * YSPS2
               YPPP4 = YSSP2 * YPPS3
C
C
C             ...the Z-terms.
C
C
               ZSSP2 = PQZ * U0
               ZSPS2 = PQZ * U1
               ZSPP3 = ZSSP2 * ZSPS2
               ZPPS3 = ZSPS2 * ZSPS2
               ZPPP2 = U4 * ZSSP2
               ZPPP3 = U3 * ZSPS2
               ZPPP4 = ZSSP2 * ZPPS3
C
C
C             ...assemble the 2-center (AA|CC) type integrals.
C
C
               GXXX = XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               A = U4 * (F1 + U1 * F2)
               B = U2 * F2
               C = A + XPPS3 * F3
               D = B + XSPP3 * F3

               GXXY = YSSP2 * C
               GXXZ = ZSSP2 * C
               GXYX = YSPS2 * D
               GXZX = ZSPS2 * D

               C = A + YPPS3 * F3
               D = B + YSPP3 * F3

               GYYX = XSSP2 * C
               GYYZ = ZSSP2 * C
               GXYY = XSPS2 * D
               GYZY = ZSPS2 * D

               C = A + ZPPS3 * F3
               D = B + ZSPP3 * F3

               GZZX = XSSP2 * C
               GZZY = YSSP2 * C
               GXZZ = XSPS2 * D
               GYZZ = YSPS2 * D

               GXYZ = XSPS2 * YSPS2 * ZSSP2 * F3
               GXZY = XSPS2 * ZSPS2 * YSSP2 * F3
               GYZX = YSPS2 * ZSPS2 * XSSP2 * F3

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GXYX
               BATCH (M+ 3) = GXZX
               BATCH (M+ 4) = GXYX
               BATCH (M+ 5) = GYYX
               BATCH (M+ 6) = GYZX
               BATCH (M+ 7) = GXZX
               BATCH (M+ 8) = GYZX
               BATCH (M+ 9) = GZZX
               BATCH (M+10) = GXXY
               BATCH (M+11) = GXYY
               BATCH (M+12) = GXZY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GYZY
               BATCH (M+16) = GXZY
               BATCH (M+17) = GYZY
               BATCH (M+18) = GZZY
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GXYZ
               BATCH (M+21) = GXZZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GYZZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 2220       CONTINUE
 2200    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center ppsp and
C                ppps (AB|CC) type integrals.
C
C
   23    M = 0
         DO 2300 IJ = 1,MIJ
            PVAL = P (IJ)
            PINV = ONE / PVAL
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PQX = PXVAL - X3
            PQY = PYVAL - Y3
            PQZ = PZVAL - Z3
            RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
            PSCALE = SCALEP (IJ)
            U4 = HALF * PINV
            XSPS1 = PXVAL - X2
            XPSS1 = PXVAL - X1
            YSPS1 = PYVAL - Y2
            YPSS1 = PYVAL - Y1
            ZSPS1 = PZVAL - Z2
            ZPSS1 = PZVAL - Z1
            DO 2330 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U5 = U1 * U4
C
C
C             ...the X-terms.
C
C
               XSSP2 = PQX * U0
               XSPS2 = PQX * U1
               A     = XPSS1 + XSPS1
               XSPP2 = XSPS1 * XSSP2 + U2
               XSPP3 = XSSP2 * XSPS2
               XPSP2 = XPSS1 * XSSP2 + U2
               XPPS1 = XPSS1 * XSPS1 + U4
               XPPS2 = A * XSPS2 + U5
               XPPS3 = XSPS2 * XSPS2
               XPPP2 = XPPS1 * XSSP2 + A * U2
               XPPP3 = A * XSPP3 + U3 * XSPS2
               XPPP4 = XSSP2 * XPPS3
C
C
C             ...the Y-terms.
C
C
               YSSP2 = PQY * U0
               YSPS2 = PQY * U1
               A     = YPSS1 + YSPS1
               YSPP2 = YSPS1 * YSSP2 + U2
               YSPP3 = YSSP2 * YSPS2
               YPSP2 = YPSS1 * YSSP2 + U2
               YPPS1 = YPSS1 * YSPS1 + U4
               YPPS2 = A * YSPS2 + U5
               YPPS3 = YSPS2 * YSPS2
               YPPP2 = YPPS1 * YSSP2 + A * U2
               YPPP3 = A * YSPP3 + U3 * YSPS2
               YPPP4 = YSSP2 * YPPS3
C
C
C             ...the Z-terms.
C
C
               ZSSP2 = PQZ * U0
               ZSPS2 = PQZ * U1
               A     = ZPSS1 + ZSPS1
               ZSPP2 = ZSPS1 * ZSSP2 + U2
               ZSPP3 = ZSSP2 * ZSPS2
               ZPSP2 = ZPSS1 * ZSSP2 + U2
               ZPPS1 = ZPSS1 * ZSPS1 + U4
               ZPPS2 = A * ZSPS2 + U5
               ZPPS3 = ZSPS2 * ZSPS2
               ZPPP2 = ZPPS1 * ZSSP2 + A * U2
               ZPPP3 = A * ZSPP3 + U3 * ZSPS2
               ZPPP4 = ZSSP2 * ZPPS3
C
C
C             ...assemble the 3-center (AB|CC) type integrals.
C
C
               GXXX = XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               AA = XSPP3 * F2
               BB = XSPP3 * F3

               A = XPPS1 * F1 + XPPS2 * F2 + XPPS3 * F3
               B = XPSP2 * F1 + AA
               C = XPSP2 * F2 + BB
               D = XSPP2 * F1 + AA
               E = XSPP2 * F2 + BB

               GXXY = YSSP2 * A
               GXXZ = ZSSP2 * A
               GXYX = YSPS1 * B + YSPS2 * C
               GXZX = ZSPS1 * B + ZSPS2 * C
               GYXX = YPSS1 * D + YSPS2 * E
               GZXX = ZPSS1 * D + ZSPS2 * E

               AA = YSPP3 * F2
               BB = YSPP3 * F3

               A = YPPS1 * F1 + YPPS2 * F2 + YPPS3 * F3
               B = YPSP2 * F1 + AA
               C = YPSP2 * F2 + BB
               D = YSPP2 * F1 + AA
               E = YSPP2 * F2 + BB

               GYYX = XSSP2 * A
               GYYZ = ZSSP2 * A
               GYXY = XSPS1 * B + XSPS2 * C
               GYZY = ZSPS1 * B + ZSPS2 * C
               GXYY = XPSS1 * D + XSPS2 * E
               GZYY = ZPSS1 * D + ZSPS2 * E

               AA = ZSPP3 * F2
               BB = ZSPP3 * F3

               A = ZPPS1 * F1 + ZPPS2 * F2 + ZPPS3 * F3
               B = ZPSP2 * F1 + AA
               C = ZPSP2 * F2 + BB
               D = ZSPP2 * F1 + AA
               E = ZSPP2 * F2 + BB

               GZZX = XSSP2 * A
               GZZY = YSSP2 * A
               GZXZ = XSPS1 * B + XSPS2 * C
               GZYZ = YSPS1 * B + YSPS2 * C
               GXZZ = XPSS1 * D + XSPS2 * E
               GYZZ = YPSS1 * D + YSPS2 * E

               A = XPSS1 * F1 + XSPS2 * F2
               B = XPSS1 * F2 + XSPS2 * F3
               C = YPSS1 * F1 + YSPS2 * F2
               D = YPSS1 * F2 + YSPS2 * F3
               E = ZPSS1 * F1 + ZSPS2 * F2
               F = ZPSS1 * F2 + ZSPS2 * F3

               GXYZ = (YSPS1 * A + YSPS2 * B) * ZSSP2
               GXZY = (ZSPS1 * A + ZSPS2 * B) * YSSP2
               GYXZ = (XSPS1 * C + XSPS2 * D) * ZSSP2
               GYZX = (ZSPS1 * C + ZSPS2 * D) * XSSP2
               GZXY = (XSPS1 * E + XSPS2 * F) * YSSP2
               GZYX = (YSPS1 * E + YSPS2 * F) * XSSP2

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GYXX
               BATCH (M+ 3) = GZXX
               BATCH (M+ 4) = GXYX
               BATCH (M+ 5) = GYYX
               BATCH (M+ 6) = GZYX
               BATCH (M+ 7) = GXZX
               BATCH (M+ 8) = GYZX
               BATCH (M+ 9) = GZZX
               BATCH (M+10) = GXXY
               BATCH (M+11) = GYXY
               BATCH (M+12) = GZXY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GZYY
               BATCH (M+16) = GXZY
               BATCH (M+17) = GYZY
               BATCH (M+18) = GZZY
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GYXZ
               BATCH (M+21) = GZXZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GZYZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 2330       CONTINUE
 2300    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center ppsp and
C                ppps (AA|CD) type integrals.
C
C
   24    IF (SHELL3.EQ.1) THEN
             QXSUB = X3
             QYSUB = Y3
             QZSUB = Z3
         ELSE
             QXSUB = X4
             QYSUB = Y4
             QZSUB = Z4
         END IF

         M = 0
         DO 2400 IJ = 1,MIJ
            PVAL = P (IJ)
            PINV = ONE / PVAL
            PSCALE = SCALEP (IJ)
            U4 = HALF * PINV
            DO 2440 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = X1 - QXVAL
               PQY = Y1 - QYVAL
               PQZ = Z1 - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U5 = U1 * U4
C
C
C             ...the X-terms.
C
C
               XSSP1 = QXVAL - QXSUB
               XSSP2 = PQX * U0
               XSPS2 = PQX * U1
               XSPP2 = XSSP1 * XSPS2 + U2
               XSPP3 = XSSP2 * XSPS2
               XPPS3 = XSPS2 * XSPS2
               XPPP1 = XSSP1 * U4
               XPPP2 = XSSP1 * U5 + U4 * XSSP2
               XPPP3 = XSSP1 * XPPS3 + U3 * XSPS2
               XPPP4 = XSSP2 * XPPS3
C
C
C             ...the Y-terms.
C
C
               YSSP1 = QYVAL - QYSUB
               YSSP2 = PQY * U0
               YSPS2 = PQY * U1
               YSPP2 = YSSP1 * YSPS2 + U2
               YSPP3 = YSSP2 * YSPS2
               YPPS3 = YSPS2 * YSPS2
               YPPP1 = YSSP1 * U4
               YPPP2 = YSSP1 * U5 + U4 * YSSP2
               YPPP3 = YSSP1 * YPPS3 + U3 * YSPS2
               YPPP4 = YSSP2 * YPPS3
C
C
C             ...the Z-terms.
C
C
               ZSSP1 = QZVAL - QZSUB
               ZSSP2 = PQZ * U0
               ZSPS2 = PQZ * U1
               ZSPP2 = ZSSP1 * ZSPS2 + U2
               ZSPP3 = ZSSP2 * ZSPS2
               ZPPS3 = ZSPS2 * ZSPS2
               ZPPP1 = ZSSP1 * U4
               ZPPP2 = ZSSP1 * U5 + U4 * ZSSP2
               ZPPP3 = ZSSP1 * ZPPS3 + U3 * ZSPS2
               ZPPP4 = ZSSP2 * ZPPS3
C
C
C             ...assemble the 3-center (AA|CD) type integrals.
C
C
               GXXX = XPPP1 * F0 + XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP1 * F0 + YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP1 * F0 + ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               A = U4 * F0 + U5 * F1
               B = U4 * F1 + U5 * F2
               C = A + XPPS3 * F2
               D = B + XPPS3 * F3
               E = XSPP2 * F2 + XSPP3 * F3

               GXXY = YSSP1 * C + YSSP2 * D
               GXXZ = ZSSP1 * C + ZSSP2 * D
               GXYX = YSPS2 * E
               GXZX = ZSPS2 * E

               C = A + YPPS3 * F2
               D = B + YPPS3 * F3
               E = YSPP2 * F2 + YSPP3 * F3

               GYYX = XSSP1 * C + XSSP2 * D
               GYYZ = ZSSP1 * C + ZSSP2 * D
               GXYY = XSPS2 * E
               GYZY = ZSPS2 * E

               C = A + ZPPS3 * F2
               D = B + ZPPS3 * F3
               E = ZSPP2 * F2 + ZSPP3 * F3

               GZZX = XSSP1 * C + XSSP2 * D
               GZZY = YSSP1 * C + YSSP2 * D
               GXZZ = XSPS2 * E
               GYZZ = YSPS2 * E

               GXYZ = XSPS2 * YSPS2 * (ZSSP1 * F2 + ZSSP2 * F3)
               GXZY = XSPS2 * ZSPS2 * (YSSP1 * F2 + YSSP2 * F3)
               GYZX = YSPS2 * ZSPS2 * (XSSP1 * F2 + XSSP2 * F3)

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GXYX
               BATCH (M+ 3) = GXZX
               BATCH (M+ 4) = GXYX
               BATCH (M+ 5) = GYYX
               BATCH (M+ 6) = GYZX
               BATCH (M+ 7) = GXZX
               BATCH (M+ 8) = GYZX
               BATCH (M+ 9) = GZZX
               BATCH (M+10) = GXXY
               BATCH (M+11) = GXYY
               BATCH (M+12) = GXZY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GYZY
               BATCH (M+16) = GXZY
               BATCH (M+17) = GYZY
               BATCH (M+18) = GZZY
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GXYZ
               BATCH (M+21) = GXZZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GYZZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 2440       CONTINUE
 2400    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center ppsp and
C                ppps (AB|CD) type integrals.
C
C
   25    IF (SHELL3.EQ.1) THEN
             QXSUB = X3
             QYSUB = Y3
             QZSUB = Z3
         ELSE
             QXSUB = X4
             QYSUB = Y4
             QZSUB = Z4
         END IF

         M = 0
         DO 2500 IJ = 1,MIJ
            PVAL = P (IJ)
            PINV = ONE / PVAL
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            U4 = HALF * PINV
            XSPS1 = PXVAL - X2
            XPSS1 = PXVAL - X1
            YSPS1 = PYVAL - Y2
            YPSS1 = PYVAL - Y1
            ZSPS1 = PZVAL - Z2
            ZPSS1 = PZVAL - Z1
            DO 2550 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = PXVAL - QXVAL
               PQY = PYVAL - QYVAL
               PQZ = PZVAL - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F3 = ((((( FTABLE (9,TGRID)  * DELTA6
     +                      + FTABLE (8,TGRID)) * DELTA5
     +                      + FTABLE (7,TGRID)) * DELTA4
     +                      + FTABLE (6,TGRID)) * DELTA3
     +                      + FTABLE (5,TGRID)) * DELTA2
     +                      + FTABLE (4,TGRID)) * DELTA1
     +                      + FTABLE (3,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2
                   F3 = SCALE * F3

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1
                   F3 = FIVE  * T2INV * F2

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               U2 = HALF * PQPINV
               U3 = U2 + PQPINV
               U5 = U1 * U4
C
C
C             ...the X-terms.
C
C
               XSSP1 = QXVAL - QXSUB
               XSSP2 = PQX * U0
               XSPS2 = PQX * U1
               A     = XPSS1 + XSPS1
               B     = XSSP1 * XSPS2 + U2
               XSPP1 = XSPS1 * XSSP1
               XSPP2 = XSPS1 * XSSP2 + B
               XSPP3 = XSSP2 * XSPS2
               XPSP1 = XPSS1 * XSSP1
               XPSP2 = XPSS1 * XSSP2 + B
               XPPS1 = XPSS1 * XSPS1 + U4
               XPPS2 = A * XSPS2 + U5
               XPPS3 = XSPS2 * XSPS2
               XPPP1 = XSSP1 * XPPS1
               XPPP2 = XSSP1 * XPPS2 + XPPS1 * XSSP2 + A * U2
               XPPP3 = XSSP1 * XPPS3 + A * XSPP3 + U3 * XSPS2
               XPPP4 = XSSP2 * XPPS3
C
C
C             ...the Y-terms.
C
C
               YSSP1 = QYVAL - QYSUB
               YSSP2 = PQY * U0
               YSPS2 = PQY * U1
               A     = YPSS1 + YSPS1
               B     = YSSP1 * YSPS2 + U2
               YSPP1 = YSPS1 * YSSP1
               YSPP2 = YSPS1 * YSSP2 + B
               YSPP3 = YSSP2 * YSPS2
               YPSP1 = YPSS1 * YSSP1
               YPSP2 = YPSS1 * YSSP2 + B
               YPPS1 = YPSS1 * YSPS1 + U4
               YPPS2 = A * YSPS2 + U5
               YPPS3 = YSPS2 * YSPS2
               YPPP1 = YSSP1 * YPPS1
               YPPP2 = YSSP1 * YPPS2 + YPPS1 * YSSP2 + A * U2
               YPPP3 = YSSP1 * YPPS3 + A * YSPP3 + U3 * YSPS2
               YPPP4 = YSSP2 * YPPS3
C
C
C             ...the Z-terms.
C
C
               ZSSP1 = QZVAL - QZSUB
               ZSSP2 = PQZ * U0
               ZSPS2 = PQZ * U1
               A     = ZPSS1 + ZSPS1
               B     = ZSSP1 * ZSPS2 + U2
               ZSPP1 = ZSPS1 * ZSSP1
               ZSPP2 = ZSPS1 * ZSSP2 + B
               ZSPP3 = ZSSP2 * ZSPS2
               ZPSP1 = ZPSS1 * ZSSP1
               ZPSP2 = ZPSS1 * ZSSP2 + B
               ZPPS1 = ZPSS1 * ZSPS1 + U4
               ZPPS2 = A * ZSPS2 + U5
               ZPPS3 = ZSPS2 * ZSPS2
               ZPPP1 = ZSSP1 * ZPPS1
               ZPPP2 = ZSSP1 * ZPPS2 + ZPPS1 * ZSSP2 + A * U2
               ZPPP3 = ZSSP1 * ZPPS3 + A * ZSPP3 + U3 * ZSPS2
               ZPPP4 = ZSSP2 * ZPPS3
C
C
C             ...assemble the 4-center (AB|CD) type integrals.
C
C
               GXXX = XPPP1 * F0 + XPPP2 * F1 + XPPP3 * F2 + XPPP4 * F3
               GYYY = YPPP1 * F0 + YPPP2 * F1 + YPPP3 * F2 + YPPP4 * F3
               GZZZ = ZPPP1 * F0 + ZPPP2 * F1 + ZPPP3 * F2 + ZPPP4 * F3

               AA = XSPP3 * F2
               BB = XSPP3 * F3

               A = XPPS1 * F0 + XPPS2 * F1 + XPPS3 * F2
               B = XPPS1 * F1 + XPPS2 * F2 + XPPS3 * F3
               C = XPSP1 * F0 + XPSP2 * F1 + AA
               D = XPSP1 * F1 + XPSP2 * F2 + BB
               E = XSPP1 * F0 + XSPP2 * F1 + AA
               F = XSPP1 * F1 + XSPP2 * F2 + BB

               GXXY = YSSP1 * A + YSSP2 * B
               GXXZ = ZSSP1 * A + ZSSP2 * B
               GXYX = YSPS1 * C + YSPS2 * D
               GXZX = ZSPS1 * C + ZSPS2 * D
               GYXX = YPSS1 * E + YSPS2 * F
               GZXX = ZPSS1 * E + ZSPS2 * F

               AA = YSPP3 * F2
               BB = YSPP3 * F3

               A = YPPS1 * F0 + YPPS2 * F1 + YPPS3 * F2
               B = YPPS1 * F1 + YPPS2 * F2 + YPPS3 * F3
               C = YPSP1 * F0 + YPSP2 * F1 + AA
               D = YPSP1 * F1 + YPSP2 * F2 + BB
               E = YSPP1 * F0 + YSPP2 * F1 + AA
               F = YSPP1 * F1 + YSPP2 * F2 + BB

               GYYX = XSSP1 * A + XSSP2 * B
               GYYZ = ZSSP1 * A + ZSSP2 * B
               GYXY = XSPS1 * C + XSPS2 * D
               GYZY = ZSPS1 * C + ZSPS2 * D
               GXYY = XPSS1 * E + XSPS2 * F
               GZYY = ZPSS1 * E + ZSPS2 * F

               AA = ZSPP3 * F2
               BB = ZSPP3 * F3

               A = ZPPS1 * F0 + ZPPS2 * F1 + ZPPS3 * F2
               B = ZPPS1 * F1 + ZPPS2 * F2 + ZPPS3 * F3
               C = ZPSP1 * F0 + ZPSP2 * F1 + AA
               D = ZPSP1 * F1 + ZPSP2 * F2 + BB
               E = ZSPP1 * F0 + ZSPP2 * F1 + AA
               F = ZSPP1 * F1 + ZSPP2 * F2 + BB

               GZZX = XSSP1 * A + XSSP2 * B
               GZZY = YSSP1 * A + YSSP2 * B
               GZXZ = XSPS1 * C + XSPS2 * D
               GZYZ = YSPS1 * C + YSPS2 * D
               GXZZ = XPSS1 * E + XSPS2 * F
               GYZZ = YPSS1 * E + YSPS2 * F

               A = XPSS1 * F0 + XSPS2 * F1
               B = XPSS1 * F1 + XSPS2 * F2
               C = XPSS1 * F2 + XSPS2 * F3
               D = YPSS1 * F0 + YSPS2 * F1
               E = YPSS1 * F1 + YSPS2 * F2
               F = YPSS1 * F2 + YSPS2 * F3
               G = ZPSS1 * F0 + ZSPS2 * F1
               H = ZPSS1 * F1 + ZSPS2 * F2
               R = ZPSS1 * F2 + ZSPS2 * F3

               GXYZ = YSPS1*(ZSSP1*A+ZSSP2*B) + YSPS2*(ZSSP1*B+ZSSP2*C)
               GXZY = ZSPS1*(YSSP1*A+YSSP2*B) + ZSPS2*(YSSP1*B+YSSP2*C)
               GYXZ = XSPS1*(ZSSP1*D+ZSSP2*E) + XSPS2*(ZSSP1*E+ZSSP2*F)
               GYZX = ZSPS1*(XSSP1*D+XSSP2*E) + ZSPS2*(XSSP1*E+XSSP2*F)
               GZXY = XSPS1*(YSSP1*G+YSSP2*H) + XSPS2*(YSSP1*H+YSSP2*R)
               GZYX = YSPS1*(XSSP1*G+XSSP2*H) + YSPS2*(XSSP1*H+XSSP2*R)

               BATCH (M+ 1) = GXXX
               BATCH (M+ 2) = GYXX
               BATCH (M+ 3) = GZXX
               BATCH (M+ 4) = GXYX
               BATCH (M+ 5) = GYYX
               BATCH (M+ 6) = GZYX
               BATCH (M+ 7) = GXZX
               BATCH (M+ 8) = GYZX
               BATCH (M+ 9) = GZZX
               BATCH (M+10) = GXXY
               BATCH (M+11) = GYXY
               BATCH (M+12) = GZXY
               BATCH (M+13) = GXYY
               BATCH (M+14) = GYYY
               BATCH (M+15) = GZYY
               BATCH (M+16) = GXZY
               BATCH (M+17) = GYZY
               BATCH (M+18) = GZZY
               BATCH (M+19) = GXXZ
               BATCH (M+20) = GYXZ
               BATCH (M+21) = GZXZ
               BATCH (M+22) = GXYZ
               BATCH (M+23) = GYYZ
               BATCH (M+24) = GZYZ
               BATCH (M+25) = GXZZ
               BATCH (M+26) = GYZZ
               BATCH (M+27) = GZZZ

               M = M + 27

 2550       CONTINUE
 2500    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine eigen_calc(x, nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c   Calculates the eigenvalues and eigenvectors of a 2-d square matrix.
c   The matrix is also diagonalized on output.
c
c   The eigenvalues are stored in a common block.  
c   The instruction is executed as follows:
c   
c   execute eig Array1 Array2
c
c   where Array1 is the input matrix that is to be diagonalized.
c         Array2 is the matrix whose columns are the eigenvectors of Array1.
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      integer n, ierr, junk

      ierr = 0
      if (nindex .ne. 2) then
         ierr = ierr + 1
         print *,'Error in eig, line ',current_line,' Number of array',
     *           ' indices must be 2, actual number is ',nindex
      endif

      if (nindex2 .ne. 2) then
         ierr = ierr + 1
         print *,'Error in eig, line ',current_line,' Number of array',
     *           ' indices must be 2, actual number is ',nindex2
      endif

      if (ierr .ne. 0) call abort_job()

      n = edim(1) - bdim(1) + 1
      call diag(x, x2, junk, n, 0, 0, 0)

      return
      end

      subroutine print_eig(cstr, x, eigval, n)
      integer n
      character*(*) cstr
      double precision x(n,n)
      double precision eigval(n,n)  

      print *,cstr
      do j = 1, n
         print *,'Eigenvalue ',j,' is ',eigval(j,j)
        print *,'Col. ',j,': ',(x(i,j),i=1,n) 
      enddo

      return
      end

      SUBROUTINE WRTARG(ITAPE,TITLE,NTATOM,NSYT,NGEN,IAORDS,
     1                JJCH,IBF,NNSTV,IGR,NSTV,
     2                RR,IATM,ATNM,LOGO,IMAGE,NEQ,ICCN,
     3                NGENG,IATN)
C
C     ACTUAL WRITING OF FILE ARGOS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXSHL = 20)
      PARAMETER (NPRIMAX = 1000)
      PARAMETER (NCNTMAX = 10)
      CHARACTER*(*) TITLE,IBF
      DOUBLE PRECISION EXP(NPRIMAX),COEFF(NCNTMAX),RR(3,200),ATNM(1),ONE
      DIMENSION IATN(2),ICL(NCNTMAX)
      COMMON/WORK/ IDUM(10000),INFO(100,3)
      COMMON/IRD/ IRD(5),IFL1(100)
      DIMENSION NSYT(1),IBF(1),NNSTV(1),NSTV(3,7),ICCN(1)
      DIMENSION IATM(1),LOGO(1),IMAGE(200,3),NEQ(200)
      CHARACTER*60 IATM
      LOGICAL LOGO
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      INTEGER SHELLLOC,SHELLSIZ
      COMMON /MOLSTR1/ LMNP1(100),SHELLLOC(100),SHELLSIZ(100),
     &                 ICONU(100),BASISEXP(10000),BASISCNT(10000)
      COMMON /MOLSTR2/ NTOTPRIM,NTOTSHEL,IOFFPRIM,IOFFSHEL,IATOM
      DATA ONE/1.0D0/
      DATA IONE/1/
      DATA IZER/0/
C
C     SET DEFAULTS
C
      ITOL=20
      ICUT=9
      NSUPP=0
      NTAPE=4
      INRM=0
      NCRS=0
      NS=NTATOM
C      
      ICX=0
      INP=ITAPE
CW      NITER=1
CW      INP2=31
CW      REWIND INP2
CW      IF(ITGEOM.EQ.1) WRITE(INP2,995) NITER
CW      IF(ITGEOM.EQ.1) INP=INP2
CW  995 FORMAT(20I4)
C
      REWIND ITAPE
      WRITE(ITAPE,101) TITLE
  101 FORMAT(A)
CW      WRITE(ITAPE,101) (LFMT(I),I=1,2)
C
CW      WRITE(ITAPE,103) NGEN,NS,IAORDS,NTOTSHEL,IAORDS,ITOL,ICUT,NTAPE,
CW     1NSUPP,ITGEOM,IZER,IZER,IZER
      WRITE(ITAPE,103) NGEN,NS,IAORDS,NTOTSHEL,IAORDS,ITOL,ICUT,NTAPE,
     1   NSUPP,INRM,NCRS,IZER,IZER,IZER,IZER,IZER
 103  FORMAT(26I3)
C
      IDEG=1
      WRITE(ITAPE,104) JJCH,(IDEG,IBF(I),I=1,JJCH)
 104  FORMAT(I3,8(I3,A3))
C
      NNNSTV=NNSTV(IGR)
      WRITE(ITAPE,103) NNNSTV
      IF(NNNSTV.EQ.0) GO TO 106
      WRITE(ITAPE,105) ((NSTV(I,J),I=1,3),J=1,NNNSTV)
 105  FORMAT(3I3)
 106  CONTINUE
C
      DO 108 I=1,IAORDS
         INF2=INFO(I,2)
         IAD=INFO(I,1)
         WRITE(ITAPE,103) INF2,(IDUM(IAD+L),L=1,INF2)
 108  CONTINUE
C
      DO 110 I=1,IAORDS
         INF1=INFO(I,1)
         INF2=INFO(I,2)
         INF3=INFO(I,3)
         WRITE(ITAPE,103) INF2,INF3,I
         INF1=INF1+INF2
         DO 110 J=1,INF2
            KKLL=INF1+(J-1)*INF3
            WRITE(ITAPE,107) (IDUM(KKLL+K),K=1,INF3)
 107        FORMAT(15I5)
 110  CONTINUE
      IOFFPR=1
C
      DO 112 I=1,NTOTSHEL
         ICNN=ICONU(I)
         NCONT=SHELLSIZ(I)
         CALL IZERO(ICL,ICNN)
         IF(IFLAGS(59).EQ.0) THEN
C
C   IF SEGMENTED CONTRACTION IS REQUIRED, GET RID OF ZERO COEFFICIENTS
C
            IF(NCONT.NE.1) STOP ' FATAL ERROR IN WRTARG'
            IOFF=IOFFPR
            ICLNUM=0
            DO 313 J=1,ICNN
               IF(DABS(BASISCNT(IOFF)).LT.1.D-8)THEN
                  ICL(J)=1
                  ICLNUM=ICLNUM+1
               ENDIF
               IOFF=IOFF+1
 313        CONTINUE
            WRITE(ITAPE,103) ICNN-ICLNUM,LMNP1(I)+1,NCONT
         ELSE
            WRITE(ITAPE,103) ICNN,LMNP1(I)+1,NCONT
         ENDIF
         CALL SCOPY(ICNN,BASISEXP(IOFFPR),1,EXP,1)
         IOFF=IOFFPR
         DO 111 J=1,ICNN
            CALL SCOPY(NCONT,BASISCNT(IOFF),ICNN,COEFF,1)
            IOFF=IOFF+1
            IF(ICL(J).NE.1) WRITE(ITAPE,113) EXP(J),(COEFF(K),K=1,NCONT)
 111     CONTINUE
         IOFFPR=IOFFPR+ICNN*NCONT
 112  CONTINUE
      IF(IOFFPR.NE.IOFFPRIM) STOP ' FATAL ERROR IN WRTARG'
 113  FORMAT(5F14.8)
C
      KK=0
      LL=0
      IFLW=0
      DO 120 I=1,NTATOM
         IXX=NSYT(I)
         ICY=ICCN(I)
         LL=LL+1
         NQQ=NEQ(LL)
         WRITE(INP,114) IATM(I),IXX,NQQ,ATNM(I),IATN(I)
 114     FORMAT(1X,A2,2I3,F3.0,I3)
         DO 115 J=1,NQQ
            KK=KK+1
            WRITE(INP,116) RR(1,KK),RR(2,KK),RR(3,KK),ONE
 115     CONTINUE
 116     FORMAT(4F14.8)
         IF(NGEN.EQ.0) GO TO 119
         IF(NQQ.EQ.1) GO TO 129
         DO 118 K=1,NGENG
            IF(LOGO(K)) GO TO 118
            WRITE(ITAPE,103) (IMAGE(IFLW+MM,K),MM=1,NQQ)
 118     CONTINUE
 129     IFLW=IFLW+NQQ
 119     CONTINUE
         DO 200 IL=1,IXX
            ICX=ICX+1
            ICY=ICY+1
            WRITE(ITAPE,103) ICY,IFL1(ICX)
 200     CONTINUE
 120  CONTINUE
C
      RETURN
      END

      INTEGER FUNCTION IFINDNE(N,A,ISKIP,TARGET,TOLER)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(ISKIP,*)
      I = 1
      DO WHILE (ABS(A(1,I)-TARGET).LT.TOLER.AND.I.LT.N+1)
         I = I + 1
      END DO
      IFINDNE = I
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine nuclear_nuclear_gradient(hess, nnhess, natoms)
c--------------------------------------------------------------------------
c   Calculates the nuclear-nuclear contribution to the gradient.
c--------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'hess.h'
      include 'dbugcom.h'

      integer i, j, k, natoms
      integer ihess, jhess, khess, iatom, jatom
      double precision x, y, z, r, r3, r5, pkl
      double precision hess(3*natoms,3*natoms)
      double precision NNhess(3*natoms,3*natoms)
      double precision d(natoms,natoms)

      if (natoms .gt. max_centers) then
         print *,'Error: natoms = ',natoms,' is larger than ',
     *      'max_centers ',max_centers
         call abort_job()
      endif
  
      DO I = 1, NATOMS  
C
         DO J = 1, NATOMS  

            if (i .ne. j) then 
C
            X = acenter(I,1) - acenter(J,1)          
            Y = acenter(I,2) - acenter(J,2)          
            Z = acenter(I,3) - acenter(J,3)          
            R = (X**2 + Y**2 + Z**2) 
            D(i,j) = -1.0d0/R**(1.5)  
c
            endif 
C
         ENDDO ! J 
C
      ENDDO ! I 
C
C     ----- FORM CONTRIBUTION TO GRADIENT -----
C
      DO J = 1, NATOMS 
         DO I = 1, 3
            NNgrad(I,J) = 0.0d0 
            DO K = 1, NATOMS 
               IF (J .ne. K) then 
                  PKL = (acenter(J,I)-acenter(K,I))
                  NNgrad(I,J) = NNgrad(I,J)+PKL*D(K,J)*charge(k)
     &                                                *charge(j) 
               ENDIF 
            ENDDO 
         ENDDO 
      ENDDO 

      if (dbg) then
         do j = 1, natoms
            print *,'NNgrad for atom ',j,' : ',(nngrad(i,j),i=1,3)
         enddo
      endif
C
C Compute the Nuclear-Nuclear contribution to the Hessian.  
C -------------------------------------------------------- 
C
      DO I = 1, NATOMS  
C
         DO J = 1, NATOMS  

            if (i .ne. j) then 
C
            X = acenter(I,1) - acenter(J,1)          
            Y = acenter(I,2) - acenter(J,2)          
            Z = acenter(I,3) - acenter(J,3)          
            R = (X**2 + Y**2 + Z**2) 
            D(i,j) = 1.0d0/R**(2.5)  
c
            endif 
C
         ENDDO ! J 
C
      ENDDO ! I 
C
      DO IATOM = 1, NATOMS 
      DO JATOM = 1, NATOMS 
         DO I = 1, 3
         DO J = 1, 3
c
            ihess = (iatom-1)*3 + i 
            jhess = (jatom-1)*3 + j 
            hess(jhess,ihess) = 0.0d0 
c
         ENDDO ! J 
         ENDDO ! I 
      ENDDO ! JATOM 
      ENDDO ! IATOM 
C
      DO IATOM = 1, NATOMS 
      DO JATOM = 1, NATOMS 
         DO I = 1, 3
         DO J = 1, 3
c
            ihess = (iatom-1)*3 + i 
            khess = (iatom-1)*3 + j
            jhess = (jatom-1)*3 + j 
c 
            if ((i .ne. j) .and. (iatom .ne. jatom)) then 
c
               hess(jhess,ihess) = hess(jhess,ihess) 
     *                           - 3.0d0*charge(iatom)*charge(jatom)   
     *                           * (acenter(iatom,i) - acenter(jatom,i))  
     *                           * (acenter(iatom,j) - acenter(jatom,j))  
     *                           * D(iatom,jatom)  
c
               hess(khess,ihess) = hess(khess,ihess)
     *                           + 3.0d0*charge(iatom)*charge(jatom)
     *                           * (acenter(iatom,i) - acenter(jatom,i))
     *                           * (acenter(iatom,j) - acenter(jatom,j))
     *                           * D(iatom,jatom)
            endif 
c 
         ENDDO ! J 
         ENDDO ! I 
      ENDDO ! JATOM 
      ENDDO ! IATOM 
C
      DO IATOM = 1, NATOMS 
      DO JATOM = 1, NATOMS 
C
         if (iatom .ne. jatom) then
            X = acenter(IATOM,1) - acenter(JATOM,1)          
            Y = acenter(IATOM,2) - acenter(JATOM,2)          
            Z = acenter(IATOM,3) - acenter(JATOM,3)          
            R = (X**2 + Y**2 + Z**2) 
            R5 = 1.0d0/R**(2.5)  
            R3 = 1.0d0/R**(1.5)  
c
            DO I = 1, 3
            DO J = 1, 3
               ihess = (iatom-1)*3 + i 
               jhess = (jatom-1)*3 + j 
               if (i .eq. j) then 
                  hess(jhess,ihess) = hess(jhess,ihess) 
     *                    - 3.0d0*charge(iatom)*charge(jatom)   
     *                    * (acenter(iatom,i) - acenter(jatom,i))  
     *                    * (acenter(iatom,j) - acenter(jatom,j))  
     *                    * R5    
     *                    + charge(iatom)*charge(jatom)*R3   

                  hess(ihess,ihess) = hess(ihess,ihess) 
     *                    + 3.0d0*charge(iatom)*charge(jatom)   
     *                    * (acenter(iatom,i) - acenter(jatom,i))  
     *                    * (acenter(iatom,j) - acenter(jatom,j))  
     *                    * R5    
     *                    - charge(iatom)*charge(jatom)*R3   
               endif 
            ENDDO ! J 
            ENDDO ! I 
         endif ! iatom .ne. jatom
      ENDDO ! JATOM 
      ENDDO ! IATOM 

c--------------------------------------------------------------------------
c   Write out Hessian data
c--------------------------------------------------------------------------
 
      if (dbg) then
        write(6,*) ' '
        write(6,*) ' Nuclear-Nuclear Hessian data '

        do i = 1, NATOMS  
        do j = 1, NATOMS  

c          do ix = 1, 3
c          do jx = 1, 3

c             ihess = (i-1)*3 + ix
c             jhess = (j-1)*3 + jx

              write(6,33) hess((i-1)*3+1,(j-1)*3+1),
     *                   hess((i-1)*3+1,(j-1)*3+2),
     *                   hess((i-1)*3+1,(j-1)*3+3)

              write(6,33) hess((i-1)*3+2,(j-1)*3+1),
     *                   hess((i-1)*3+2,(j-1)*3+2),
     *                   hess((i-1)*3+2,(j-1)*3+3)

              write(6,33) hess((i-1)*3+3,(j-1)*3+1),
     *                   hess((i-1)*3+3,(j-1)*3+2),
     *                   hess((i-1)*3+3,(j-1)*3+3)

c          enddo ! jx = 1, 3
c          enddo ! ix = 1, 3

        enddo ! j
        enddo ! i
      endif

33      format(3F16.8) 
c
c Zero out the Hessian so then the N-N contribution is not included 
C
      DO IATOM = 1, NATOMS 
      DO JATOM = 1, NATOMS 
         DO I = 1, 3
         DO J = 1, 3
 
            ihess = (iatom-1)*3 + i 
            jhess = (jatom-1)*3 + j 
            NNhess(ihess,jhess) = hess(ihess,jhess)
            hess(ihess,jhess) = 0.0d0 
 
         ENDDO ! J 
         ENDDO ! I 
      ENDDO ! JATOM 
      ENDDO ! IATOM 

      return
      end

c This routine returns the index of the smallest number in T(*).
c BEWARE - IMINPOS is 1 if n=0

      INTEGER FUNCTION IMINPOS(N,T,INC)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION T(*)
#ifdef _ASSERT
      if (n.lt.0) then
         print *, '@IMINPOS: Assertion failed.'
         print *, '          n = ',n
         call errex
      end if
#endif /* _ASSERT */
      itmp = 1
      XMIN = T(1)
      ndx  = 1 + inc
      DO I = 2, n
         IF (T(ndx).LT.XMIN) THEN
            itmp = i
            XMIN = T(ndx)
         END IF
         ndx = ndx + inc
      END DO
      IMINPOS = itmp
      RETURN
      END

C
C DRIVER FOR DETERMINATION OF ORBITAL SYMMETRIES. From ACES II. 
C 
      SUBROUTINE GET_IRREPS(SCFVEC,SCFEVAL,ICORE,MAXCOR,NBAS,NBASX,
     &                      ISPIN, NOCC, IUHF)
C
      IMPLICIT INTEGER (A-Z)

      DIMENSION ICORE(MAXCOR), IREPS(9), NBFIRR(8), NOCC(8,2)
      DOuble Precision Scfvec(Nbasx*Nbas), Scfeval(Nbas)
      CHARACTER*1 SP(2)
C


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



C
      DATA IONE /1/
      DATA SP /'A','B'/

C FOR SPHERICAL HARMONICS, DIMENSION OF COMPUTATIONAL BASIS
C IS SMALLER THAN THE CARTESIAN SET.  READ THAT VALUE NOW.

      CALL GETREC(-1,'JOBARC','NATOMS  ',IONE,NATOMS)
      CALL GETREC(-1,'JOBARC','COMPNIRR',IONE,NIRREP)
      CALL GETREC(-1,'JOBARC','FULLORDR',IONE,IORDGP)
      CALL GETREC(-1,'JOBARC','NUMBASIR',NIRREP, NBFIRR)

      CALL IZERO(ICORE(1),MAXCOR)
      NSIZE = MAX(NBAS,NATOMS,NIRREP,NBASX)

      I020 = 1
      I030 = I020 + IINTFP*MAX(NBASX*10,NATOMS)
      I040 = I030 + MAX(NBASX+MOD(NBASX,2),IINTFP*3*NATOMS)
      I060 = I040 + MAX(NBASX+MOD(NBASX,2),NATOMS+MOD(NATOMS,2))
      I080 = I060 + MAX(1080,NATOMS+MOD(NATOMS,2),IINTFP*NBASX*5)
      I090 = I080 + MAX(NATOMS*5+MOD(NATOMS,2),IINTFP*NBASX)
      I100 = I090 + NATOMS*5+MOD(NATOMS,2)
      I070 = I100 + IINTFP*IORDGP
      I110 = I070 + MAX(2000,NATOMS+MOD(NATOMS,2),NBASX+MOD(NBASX,2),
     &                  NBASX*NBASX*IINTFP)

      CALL IRRORB(SCFVEC,SCFEVAL,ICORE(I020),ICORE(I030),
     &            ICORE(I040),NBAS,                   ICORE(I060),
     &            ICORE(I070),ICORE(I080),ICORE(I090),ICORE(I100),
     &            NATOMS,     ISPIN,      NBASX)
C
C Write a Table of Eigenvalues and their symmetry. 
C
      IREPS(1) = 1
      DO IRREP = 1, NIRREP
         IREPS(IRREP+1) = IREPS(IRREP) + NBFIRR(IRREP)
      ENDDO 

      I020 = 1
      I030 = I020 + NBASX
      I040 = I030 + NBASX
  
      CALL EVLOUT(SCFEVAL, ICORE(I020), ICORE(I030), IREPS, NBAS,
     &            NIRREP, NOCC, ISPIN)

      RETURN
      END

      SUBROUTINE SY2SP(N, A, LDA, UPLOI, UPLOO, IERR)
C      
C     PURPOSE
C     
C     To store a symmetric or triangular matrix given in packed storage
C     mode using the same work array.        
C
C     ARGUMENT LIST
C       ARGUMENTS IN
C
C          N - INTEGER.
C              The order of the matrix A.
C      
C          A - DOUBLE PRECISION array of DIMENSION (LDA,N).
C              On input, the leading N-by-N part contains the upper or
C              lower triangular part of A depending upon UPLOI (see
C              section MODE PARAMETERS).
C              NOTE that this array is overwritten.
C
C        LDA - INTEGER.
C              The leading dimension of array A. 
C      
C     ARGUMENTS OUT
C    
C          A - DOUBLE PRECISION array of DIMENSION (LDA,N).
C              On output, A contains an  N*(N+1)/2  vector containing
C              the symmetric matrix A in packed storage mode (lower or
C              upper, depending upon UPLOO (see section MODE
C              PARAMETERS)). 
C
C     MODE PARAMETERS
C
C      UPLOI - CHARACTER*1.
C              Indicates whether on input, A contains the upper or lower
C              triangular part of A.
C              UPLOI = 'U' or 'u' : Upper triangle is stored in A.
C              UPLOI = 'L' or 'l' : Lower triangle is stored in A.
C              NOTE that if UPLOI contains any other character, A is
C              considered as containing the lower triangular part of A.
C      
C      UPLOO - CHARACTER*1.
C              Indicates whether on output, A is packed in upper or
C              lower symmetric storage mode.
C              UPLOO = 'U' or 'u' : A is stored in packed upper
C                                   storage mode.
C              UPLOO = 'L' or 'l' : A is stored in packed lower
C                                   storage mode.
C              NOTE that if UPLOO contains any other character, A is
C              packed to lower storage mode.
C
C     ERROR INDICATOR
C     
C       IERR - INTEGER. 
C              Unless the routine detects an error (see next section),
C              IERR contains 0 on exit.
C
C     WARNINGS AND ERRORS DETECTED BY THE ROUTINE
C
C      IERR = 1 : (N .LT. 1) or (LDA. LT. N).
C
C     METHOD
C
C     Let
C               ( A(1,1) ... A(1,N) )
C           A = (  ...        ...   ).
C               ( A(N,1) ... A(N,N) ) 
C
C     On input, A contains either the upper or lower triangular part of
C     A depending upon the input parameter UPLOI. This triangular part
C     of A then is packed to either lower or upper storage mode as
C     follows:
C     If UPLOO = 'U' or 'u', then the columns of the upper triangle of A
C     are contained in A consecutively, i.e.      
C     
C       A = (A(1,1), A(1,2), A(2,2), A(1,3), ..., A(3,3), A(1,4), ...,
C            A(1,N), ..., A(N,N)).      
C
C     If UPLOO = 'L' or 'l', then the columns of the lower triangle of A
C     are contained in A consecutively, i.e.      
C     
C       A = (A(1,1), A(2,1), ..., A(N,1), A(2,2), A(3,2), ..., A(N,2),
C            A(3,3), ..., A(N,N)).      
C   
C     REFERENCE
C                 
C     None.
C      
C     CONTRIBUTOR      
C
C     Peter Benner (Technische Universitaet Chemnitz-Zwickau, FRG)
C
C     REVISIONS
C
C     February 21, 1995.
C            
C***********************************************************************
C     
C     .. Scalar Arguments ..      
      INTEGER          IERR, LDA, N
      CHARACTER        UPLOI, UPLOO
C     
C     .. Array Arguments ..
      DOUBLE PRECISION A(*)
C
C     .. Local Scalars ..
      INTEGER          I, SPPOS, SYPOS
C
C     .. External Functions ..
C     . LAPACK .
      LOGICAL          LSAME
      EXTERNAL         LSAME
C      
C     .. External Subroutines ..
C     . BLAS, LAPACK .
      EXTERNAL         DCOPY
C     
C     .. Executable Statements ..
C
      IERR = 0
      IF ((N .LT. 1) .OR. (N .GT. LDA))  IERR = 1
      IF (IERR .NE. 0)  GOTO 2001
C      
      IF (LSAME(UPLOI,'U') .AND. LSAME(UPLOO,'L')) THEN
        SYPOS = 1
        DO 100  I = N-1, 1, -1
          CALL DCOPY(I, A(SYPOS+LDA), LDA, A(SYPOS+1), 1)
          SYPOS = SYPOS + LDA + 1
100     CONTINUE
      ELSE IF (LSAME(UPLOI,'L') .AND. LSAME(UPLOO,'U')) THEN
        SYPOS = 1
        DO 200  I = N-1, 1, -1
          CALL DCOPY(I, A(SYPOS+1), 1, A(SYPOS+LDA), LDA)
          SYPOS = SYPOS + LDA + 1
200     CONTINUE
      ENDIF
C      
      IF (LSAME(UPLOO,'U')) THEN
        SPPOS = 2
        SYPOS = LDA + 1
        DO 300  I = 2, N
          CALL DCOPY(I, A(SYPOS), 1, A(SPPOS), 1)
          SPPOS = SPPOS + I
          SYPOS = SYPOS + LDA
300     CONTINUE       
C         
      ELSE
        SPPOS  = N + 1
        SYPOS  = LDA + 2
        DO 400  I = N-1, 1, -1
          CALL DCOPY(I, A(SYPOS), 1, A(SPPOS), 1)
          SPPOS = SPPOS + I 
          SYPOS = SYPOS + LDA + 1
400     CONTINUE
      END IF
C      
2001  CONTINUE
      RETURN
C *** Last Line of SY2SP      
      END
      

         

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE UNITRY(A,B,C,N)
C
C PERFORMS UNITARY TRANSFORMATION C = A(t) B A
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N,N),C(N,N)
      CALL MODMATMUL(C,B,A,N,N,N,N,N,N)
      CALL MTRAN2(A,N)
      CALL MODMATMUL(C,A,C,N,N,N,N,N,N)
      CALL MTRAN2(A,N)
      RETURN
      END

c This routine gets all of the standard information from the JOBARC file
c for the molecule.

      subroutine ks_com_mol
      implicit none

#include "aces.h"
#include "machsp.com"
#include "kscore.com"
#include "symm2_ks.com"
#include "mol.com"

      integer setptr
      character*8 szInt8

      call callstack_push('SB_COM_MOL')

      call getrec(1,'JOBARC','NATOMS',1,natoms)
      natomsx=natoms
      if (memknown.ne.1) then
         call getrec( 1,'JOBARC','NREALATM',1,         nrealatm)
         call getrec( 1,'JOBARC','NUCREP  ',iintfp,    nucrep)
         call getrec(-1,'JOBARC','LINEAR  ',1,         linear)
         call getrec(-1,'JOBARC','ORIENTMT',3*3*iintfp,orientmt)
         call getrec(-1,'JOBARC','NMPROTON',1,         nmproton)
         call getrec(-1,'JOBARC','NOCCORB ',2,         noccorb)
         call getrec(-1,'JOBARC','NVRTORB ',2,         nvrtorb)
      end if

      patomchrg=setptr(1,F_INTEGER,natoms)
      zatommass=setptr(1,F_REAL,   natoms)
      zcoord   =setptr(1,F_REAL,   3*natoms)
      if (memknown.ne.0) then
         call getrec(1,'JOBARC','ATOMCHRG',natoms,kscore(patomchrg))
         call getrec(1,'JOBARC','ATOMMASS',natoms*iintfp,
     &               dcore(zatommass))
         call getrec(1,'JOBARC','COORD',3*iintfp*natoms,dcore(zcoord))
      end if

      if (memknown.ne.1) then
c        Reading strings!!!
         call getrec(1,'JOBARC','COMPPTGP',iintfp,szInt8)
         compptgp(1:4)=szInt8(1:4)
         call getrec(1,'JOBARC','FULLPTGP',iintfp,szInt8)
         fullptgp(1:4)=szInt8(1:4)
         c1symmet=0
         if (compptgp.eq.'C1  ') c1symmet=1

         compnirr=nirrep
         call getrec( 1,'JOBARC','FULLNIRR',1,fullnirr)
         call getrec( 1,'JOBARC','COMPNORB',1,compnorb)
         call getrec( 1,'JOBARC','FULLNORB',1,fullnorb)
         call getrec(-1,'JOBARC','COMPORDR',1,compordr)
         call getrec(-1,'JOBARC','FULLORDR',1,fullordr)

         spinc(1)='A'
         spinc(2)='B'
      end if

      pfullclss=setptr(1,F_INTEGER,fullordr)
      pcompclss=setptr(1,F_INTEGER,compordr)
      pfullpopv=setptr(1,F_INTEGER,natoms)
      pcomppopv=setptr(1,F_INTEGER,natoms)
      pfullmemb=setptr(1,F_INTEGER,natoms)
      pcompmemb=setptr(1,F_INTEGER,natoms)
      if (memknown.ne.0) then
         call getrec(-1,'JOBARC','FULLCLSS',fullordr,kscore(pfullclss))
         call getrec(-1,'JOBARC','COMPCLSS',compordr,kscore(pcompclss))
         call getrec( 1,'JOBARC','FULLPOPV',natoms,  kscore(pfullpopv))
         call getrec( 1,'JOBARC','COMPPOPV',natoms,  kscore(pcomppopv))
         call getrec( 1,'JOBARC','FULLMEMB',natoms,  kscore(pfullmemb))
         call getrec( 1,'JOBARC','COMPMEMB',natoms,  kscore(pcompmemb))
      end if

c   o remove dummy atoms
      if (memknown.ne.0) then
         call sb_removedummy(dcore(zatommass),dcore(zcoord),
     &                       kscore(patomchrg),kscore(pfullmemb),
     &                       kscore(pcompmemb),natomsx)
      end if
      natoms=nrealatm

c ----------------------------------------------------------------------
c sb_getbas()

      if (memknown.ne.1) then
         call getrec(1,'JOBARC','NAOBASFN',1,naobasfn)
         call getrec(1,'JOBARC','NBASTOT ',1,nbastot)
      end if

      pnprimatom =setptr(1,F_INTEGER,natoms)
      pnshellatom=setptr(1,F_INTEGER,natoms)
      pnangatom  =setptr(1,F_INTEGER,natoms)
      pnaoatom   =setptr(1,F_INTEGER,natoms)

      call sb_basis(kscore(pcomppopv),kscore(pcompmemb),
     &              kscore(pnangatom),
     &              kscore(pnshellatom),kscore(pnprimatom),
     &  kscore(pnaoatom)) 
 

      pnshellprim=setptr(1,F_INTEGER,maxshell*natoms)
      pnshellao  =setptr(1,F_INTEGER,maxshell*natoms)
      pprimoff   =setptr(1,F_INTEGER,maxshell*natoms)
      paooff     =setptr(1,F_INTEGER,maxshell*natoms)

      zalpha     =setptr(1,F_REAL,totprim)
      zprimcoef  =setptr(1,F_REAL,totprim*naobasfn)

      if (memknown.ne.0) then
         call sb_prim(kscore(pcomppopv),kscore(pcompmemb),
     &                kscore(pnshellatom),
     &                kscore(pnshellprim),kscore(pnshellao),
     &                kscore(pprimoff),kscore(paooff),
     &                dcore(zalpha),dcore(zprimcoef))
      end if

c ----------------------------------------------------------------------

      call callstack_pop
      return
      end

c This routine gets all of the standard information from the JOBARC file
c for the molecule.

      subroutine ks_com_mol
      implicit none















c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler


























cYAU - ACES3 stuff . . . we hope - #include <aces.par>






c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end





c Two different "stacks" of memory will be available in the course of an
c Aces3 calculation.  Integer memory will be stored in icore.  Real memory
c will be stored in dcore.
c
c Memory allocation is done in one of two ways, dynamic or nondynamic.  This
c is controlled by the parameter dynmem.  If dynmem is 1, dynamic memory
c is used.  Otherwise, nondynamic memory is used.
c
c Two additional parameters nondynimem and nondyndmem control how much
c nondynamic memory is allocated initially in the icore and dcore stacks.
c If dynmem is 1, both of these parameters SHOULD be 1.

c Dynamic memory allocation is done in a fairly straighforward way.  The
c program runs through everything twice.  The first time is just to determine
c how much dynamic memory is required.  The second time is use to actually
c allocate the memory and use it.  In some cases, it may be difficult to
c determine how much memory to use in advance in each of the stacks.  To
c aid this, there is also the option of only running through a program a
c single time.  When this happens, both stacks are allocated initially and
c used throughout the program.  If the memory requirement for either stack
c is exceeded, the program crashes.
c
c Two parameters which are used in either case are memknown and maxicore.
c Both MUST be set in the calling program.
c
c   memknown : 0 if a dummy run is being done to determine memory usage
c              1 if the memory usage is known from a previous dummy run
c             -1 if no dummy run is done (only one run through the program)
c   maxicore : the maximum amount of icore to allocate (this MAY be
c              adjusted IF a dummy run detects that more is needed, but in
c              the case of a single run, this will be rigidly applied)
c
c This include file is required whenever calls to any of the memory functions
c (setptr and relptr) are called or when part of the execution depends on
c whether the first or second run is being performed.
c
c ***NOTE***
c It is important that icore be aligned on a floating point boundary.  One
c way which seems to insure this is to have icore the FIRST element in the
c common block.  So, make sure that no integer is ever inserted before icore
c in the common block declaration.

      integer dynmem,nondynimem,nondyndmem
      parameter (dynmem=1)
      parameter (nondynimem=1)
      parameter (nondyndmem=1)

      double precision   dcore(nondyndmem)
      common /dcore_com/ dcore
      save   /dcore_com/

      integer    kscore(nondynimem)
      common /kscore_mem / kscore

      integer            memknown,maxicore
      common /kscore_com/ memknown,maxicore
      save   /kscore_com/





      integer maxirrep,num2comb,max2comb
      parameter (maxirrep=8)
      parameter (num2comb=22)
      parameter (max2comb=25)

c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end
      integer        nirrep, numbasir(8),
     &               irpsz1(36),irpsz2(28),irpds1(36),irpds2(56),
     &               old_irpoff(9), irrorboff(9), dirprd(8,8),
     &               old_iwoff1(37), old_iwoff2(29),
     &               inewvc(maxbasfn), idxvec(maxbasfn),
     &               irrtrilen(9), irrtrioff(8),
     &               irrsqrlen(9), irrsqroff(8)
      common /symm2/ nirrep, numbasir,
     &               irpsz1,    irpsz2,    irpds1,    irpds2,
     &               old_irpoff,    irrorboff,    dirprd,
     &               old_iwoff1,     old_iwoff2,
     &               inewvc,           idxvec,
     &               irrtrilen,    irrtrioff,
     &               irrsqrlen,    irrsqroff
      save   /symm2/

      integer             occup(8,2),totocc(2),totocca,totoccb,
     &                    maxirrtri,maxirrsqr,irrtritot,irrsqrtot
      common /sym_ks_com/ occup,     totocc,   totocca,totoccb,
     &                    maxirrtri,maxirrsqr,irrtritot,irrsqrtot
      save   /sym_ks_com/




c This common block contains the molecule and basis set information
c read in from the JOBARC file.  Since much of this information is
c used in a large number of modules, and since most of the information
c is relatively small compared to the other things held in memory,
c a large percentage of the data stored in the JOBARC file is stored
c here, even though some modules will not use all of it.

c   maxangshell - The maximum number of angular momentum shells.  Since this
c                 is used VERY infrequently, set it high enough to never
c                 cause a problem.
c   spinc(2)    - The characters 'A' and 'B' (useful for alpha/beta labels)
c   natoms      - The number of atoms in the Z-matrix (including X/GH).  After
c                 remove is called, natoms becomes equivalent to nrealatm.
c   natomsx     - The number of atoms in the Z-matrix (including X/GH).  This
c                 does not change.
c   nrealatm    - The number of atoms in the Z-matrix (including GH).
c   naobasfn    - The number of AOs in the basis
c   nbastot     - The number of symmetry adapted orbitals in the basis (the AO
c                 basis may be larger than the SO basis if spherical orbitals
c                 are used since harmonic contaminants are deleted)
c   linear      - 1 if the molecule is linear
c   orientmt    - 3x3 matrix which relates the computational and canonical
c                 orientations
c   nucrep      - Nuclear repulsion energy in a.u.
c   nmproton    - Number of protons in the molecule.
c
c   compptgp    - Point group
c   fullptgp    -
c   compordr    - Order of the point group
c   fullordr    -
c   compnirr    - Number of irreps in the point group
c   fullnirr    -
c   compnorb    - Number of unique atoms (orbits) in the point group
c   fullnorb    -
c   c1symmet    - 1 if the molecule is C1 symmetry
c   nirrep      - The same as compnirr (since nirrep is used so commonly,
c                 this is included for conveniance)
c                 ***NOTE*** nirrep is read in twice and is stored in /sym/
c                            so it is not actually included here
c   totprim     - Total number of primitive functions in the molecule
c   maxshlprim  - Largest number of primitives in a single shell
c   maxshlao    - Largest number of AOs in a single shell
c   maxshlorb   - Largest number of primitive orbitals (primitive functions
c                 times the number of AOs) in a single shell
c   maxangmom   - Largest angular momentum for any atom
c   maxshell    - Larges number of angular momentum shells for any atom
c   noccorb(2)  - The number of alpha and beta occupied orbitals
c   nvrtorb(2)  - The number of alpha and beta virtual orbitals

c The parameter maxorbit is needed because of how dynamic memory is used.
c Two runs of the program are needed.  The first to calculate memory usage,
c the second to use it.  In order to calculate totprim, we have to know the
c orbit population vector (the number of each type of atom).  BUT, this is
c stored in dynamic memory since we do not know how long this vector is.
c In the future, joda or vmol will write this information to JOBARC, and
c this problem will disappear.  In the meantime, we have to introduce a
c genuine limit on the size of the molecule.  It may have no more than
c maxorbit sets of unique atoms.  This limit is ONLY used in the subroutine
c basis, so it probably will disappear when the information in the MOL file
c is put in JOBARC.
c    maxorbit   - the number of symmetry unique atoms

c The following are pointers to real arrays
c
c   zatommass(natoms)  - Atomic mass of all atoms (X=0.0, GH=100.0)
c   zcoord(3,natoms)   - Coordinates of all atoms (computational orientation)
c   zalpha(totprim)    - The alpha for each primitive function
c   zprimcoef(totprim,naobasfn)
c                      - The primitive to AO coefficients
c
c The following are pointers to integer arrays
c
c   patomchrg(natoms)  - Atomic number of all atoms (X=0, GH=110)
c   pfullclss(fullordr)- Class type vector
c   pcompclss(compordr)-
c   pfullpopv(natoms)  - Number of atoms in each orbit
c   pcomppopv(natoms)  -
c   pfullmemb(natoms)  - Atoms sorted by point group orbits
c   pcompmemb(natoms)  -
c   pnprimatom(natoms) - Number of primitive functions for each atom
c   pnshellatom(natoms)- Number of different angular momentum shells for each
c                        atom (takes on values of 1,4,9,16, etc.)
c   pnangatom(natoms)  - The number of different angular momentum for each
c                        atom (takes on values of 1,2,3,4, etc.)
c   pnaoatom(natoms)   - Number of AOs for each atom
c   pnshellprim(maxshell,natoms)
c                      - The number of primitive functions in each shell
c                        of each atom
c   pnshellao(maxshell,natoms)
c                      - The number of AOs in each shell of each atom
c   pprimoff(maxshell,natoms)
c   paooff(maxshell,natoms)
c                      - The primcoef matrix is a block diagonal matrix.
c                        Each shell of each atom has a block.  If you have
c                        a list of all primitive functions, pprimoff(ishell,
c                        iatom) tells the location of the first primitive
c                        function in the block (ishell,iatom) and paooff
c                        contains similar information for the AOs.
c
c ***NOTE***  Because joda stores pfullpopv/pcomppopv as size natoms, we
c             do to, but they should be of size fullnorb/compnorb.  The
c             first ones have real values.  The remaining ones are 0.

      double precision orientmt(3,3),nucrep
      integer natoms,nrealatm,naobasfn,nbastot,linear,compnirr,
     &    fullnirr,compnorb,fullnorb,compordr,fullordr,nmproton,
     &    c1symmet,totprim,maxshlprim,maxshlorb,maxshell,noccorb(2),
     &    nvrtorb(2),maxshlao,maxangmom,natomsx
      integer patomchrg,zatommass,zcoord,pfullclss,pcompclss,
     &    pfullpopv,pcomppopv,pfullmemb,pcompmemb,pnprimatom,
     &    pnshellatom,pnaoatom,pnshellprim,pnshellao,
     &    zalpha,zprimcoef,pprimoff,paooff,pnangatom

      common /mol_com/ orientmt,nucrep,
     &    natoms,nrealatm,naobasfn,nbastot,linear,compnirr,
     &    fullnirr,compnorb,fullnorb,compordr,fullordr,nmproton,
     &    c1symmet,totprim,maxshlprim,maxshlorb,maxshell,noccorb,
     &    nvrtorb,maxshlao,maxangmom,natomsx,
     &    patomchrg,zatommass,zcoord,pfullclss,pcompclss,
     &    pfullpopv,pcomppopv,pfullmemb,pcompmemb,pnprimatom,
     &    pnshellatom,pnaoatom,pnshellprim,pnshellao,zalpha,
     &    zprimcoef,pprimoff,paooff,pnangatom
      save   /mol_com/

      character*4 compptgp,fullptgp
      character*1 spinc(2)
      common /molc_com/ compptgp,fullptgp,spinc
      save   /molc_com/



      integer setptr
      character*8 szInt8

      call callstack_push('SB_COM_MOL')

      call getrec(1,'JOBARC','NATOMS',1,natoms)
      natomsx=natoms
      if (memknown.ne.1) then
         call getrec( 1,'JOBARC','NREALATM',1,         nrealatm)
         call getrec( 1,'JOBARC','NUCREP  ',iintfp,    nucrep)
         call getrec(-1,'JOBARC','LINEAR  ',1,         linear)
         call getrec(-1,'JOBARC','ORIENTMT',3*3*iintfp,orientmt)
         call getrec(-1,'JOBARC','NMPROTON',1,         nmproton)
         call getrec(-1,'JOBARC','NOCCORB ',2,         noccorb)
         call getrec(-1,'JOBARC','NVRTORB ',2,         nvrtorb)
      end if

      patomchrg=setptr(1,0,natoms)
      zatommass=setptr(1,1,   natoms)
      zcoord   =setptr(1,1,   3*natoms)
      if (memknown.ne.0) then
         call getrec(1,'JOBARC','ATOMCHRG',natoms,kscore(patomchrg))
         call getrec(1,'JOBARC','ATOMMASS',natoms*iintfp,
     &               dcore(zatommass))
         call getrec(1,'JOBARC','COORD',3*iintfp*natoms,dcore(zcoord))
      end if

      if (memknown.ne.1) then
c        Reading strings!!!
         call getrec(1,'JOBARC','COMPPTGP',iintfp,szInt8)
         compptgp(1:4)=szInt8(1:4)
         call getrec(1,'JOBARC','FULLPTGP',iintfp,szInt8)
         fullptgp(1:4)=szInt8(1:4)
         c1symmet=0
         if (compptgp.eq.'C1  ') c1symmet=1

         compnirr=nirrep
         call getrec( 1,'JOBARC','FULLNIRR',1,fullnirr)
         call getrec( 1,'JOBARC','COMPNORB',1,compnorb)
         call getrec( 1,'JOBARC','FULLNORB',1,fullnorb)
         call getrec(-1,'JOBARC','COMPORDR',1,compordr)
         call getrec(-1,'JOBARC','FULLORDR',1,fullordr)

         spinc(1)='A'
         spinc(2)='B'
      end if

      pfullclss=setptr(1,0,fullordr)
      pcompclss=setptr(1,0,compordr)
      pfullpopv=setptr(1,0,natoms)
      pcomppopv=setptr(1,0,natoms)
      pfullmemb=setptr(1,0,natoms)
      pcompmemb=setptr(1,0,natoms)
      if (memknown.ne.0) then
         call getrec(-1,'JOBARC','FULLCLSS',fullordr,kscore(pfullclss))
         call getrec(-1,'JOBARC','COMPCLSS',compordr,kscore(pcompclss))
         call getrec( 1,'JOBARC','FULLPOPV',natoms,  kscore(pfullpopv))
         call getrec( 1,'JOBARC','COMPPOPV',natoms,  kscore(pcomppopv))
         call getrec( 1,'JOBARC','FULLMEMB',natoms,  kscore(pfullmemb))
         call getrec( 1,'JOBARC','COMPMEMB',natoms,  kscore(pcompmemb))
      end if

c   o remove dummy atoms
      if (memknown.ne.0) then
         call sb_removedummy(dcore(zatommass),dcore(zcoord),
     &                       kscore(patomchrg),kscore(pfullmemb),
     &                       kscore(pcompmemb),natomsx)
      end if
      natoms=nrealatm

c ----------------------------------------------------------------------
c sb_getbas()

      if (memknown.ne.1) then
         call getrec(1,'JOBARC','NAOBASFN',1,naobasfn)
         call getrec(1,'JOBARC','NBASTOT ',1,nbastot)
      end if

      pnprimatom =setptr(1,0,natoms)
      pnshellatom=setptr(1,0,natoms)
      pnangatom  =setptr(1,0,natoms)
      pnaoatom   =setptr(1,0,natoms)

      call sb_basis(kscore(pcomppopv),kscore(pcompmemb),
     &              kscore(pnangatom),
     &              kscore(pnshellatom),kscore(pnprimatom),
     &  kscore(pnaoatom)) 
 

      pnshellprim=setptr(1,0,maxshell*natoms)
      pnshellao  =setptr(1,0,maxshell*natoms)
      pprimoff   =setptr(1,0,maxshell*natoms)
      paooff     =setptr(1,0,maxshell*natoms)

      zalpha     =setptr(1,1,totprim)
      zprimcoef  =setptr(1,1,totprim*naobasfn)

      if (memknown.ne.0) then
         call sb_prim(kscore(pcomppopv),kscore(pcompmemb),
     &                kscore(pnshellatom),
     &                kscore(pnshellprim),kscore(pnshellao),
     &                kscore(pprimoff),kscore(paooff),
     &                dcore(zalpha),dcore(zprimcoef))
      end if

c ----------------------------------------------------------------------

      call callstack_pop
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine apply_den4_nodiag(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c   Each element of the array source(i,j,k,l) is divided by the 
c   corresponding element of the array target(i,j,k,l).  
c   Dividing is not performed when i = k or j = l or if the absolute 
c   value of the target element is below 1.0d-8
c
c   Format of command is :
c
c   execute apply_den4_nodiag source target
c
c   There is no resriction on the type of array of source or target. 
c
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      if (nindex .ne. nindex2) then
         print *,'Error: Both arrays in apply_den4 must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex2,' indices.'
         call abort_job()
      endif

      if (nindex .ne. 4) then 
         print *,'Arrays in apply_den4 must have 4 indices' 
         call abort_job()
      endif

      call do_div4nd(x,x2,
     *                      bval(1),eval(1),bval(2),eval(2),
     *                      bval(3),eval(3),bval(4),eval(4), 
     *                      bval2(1),eval2(1),bval2(2),eval2(2),
     *                      bval2(3),eval2(3),bval2(4),eval2(4)) 

      return
      end

      subroutine do_div4nd(x,y,
     *                   a1,a2,b1,b2,c1,c2,d1,d2,
     *                   i1,i2,j1,j2,k1,k2,l1,l2)
      implicit none 
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer i1,i2,j1,j2,k1,k2,l1,l2
      double precision x(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision y(i1:i2,j1:j2,k1:k2,l1:l2)

      integer i,j,k,l 
      double precision val, div

      do i = i1, i2 
      do j = j1, j2 
      do k = k1, k2 
      do l = l1, l2 
      if(i .ne. k .and. j .ne. l)then
         div = y(i,j,k,l) 
         val = x(i,j,k,l)/div   
         x(i,j,k,l) = val 
      else
         x(i,j,k,l) = 0.0d+0
      endif
      enddo 
      enddo 
      enddo 
      enddo 

      return 
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_batch7(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block 

      integer array_type, nindex, inda(2), indb(2)    

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, farray, indblk, get_block_index
      integer*8 integral_scr
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack

      double precision x(1)
      double precision dbuf(1), temp 
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      array = op(c_result_array)
      direct_flag = .false. 

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c------------------------------------------------------------------------
c   Make sure the requested block exists.  create_current_block will
c   create the block if it does not exist, and simply return if the 
c   block is already present.
c------------------------------------------------------------------------

      call create_current_block(array,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., direct_flag, blk, ierr)
      blkndx = ierr
      call get_block_computed_flag(array, blk, blkndx, flag)
      if (flag .eq. 0) then
         call set_opblock(array, blk, blkndx, op)
         call set_block_computed_flag(array, blk, blkndx, 1)
      endif

      stack = array_table(c_array_stack,array)
      indblk = get_block_index(array, blk, stack,
     *                         blkndx, x, .true.)

c--------------------------------------------------------------------------
c   Get the segment ranges for each index of the integral array.
c--------------------------------------------------------------------------

      nind = array_table(c_nindex,array)
      if (nind .ne. 4) then
         print *,'Error: local_integral_block was called with array ',
     *        array,' which has ',nind,' indices.'
         print *,'       This routine requires 4 indices.'
         call abort_job()
      endif

      do i = 1, nind
         ind = array_table(c_index_array1+i-1,array)
         seg = index_table(c_current_seg,ind)
         call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c--------------------------------------------------------------------------
c   Form the address of the current data block.
c--------------------------------------------------------------------------

      block = find_current_block(array, array_table(1,array),
     *                          index_table, nindex_table,
     *                          segment_table, nsegment_table,
     *                          block_map_table, blkndx)

      stack = array_table(c_array_stack, array)
      indblk = get_block_data_index(array, block, stack,
     *                              blkndx, x)

c---------------------------------------------------------------------------
c   Compute the block of integrals.
c---------------------------------------------------------------------------

         if (intpkg .eq. flocke_package) then
            integral_scr = dpkgscr
            maxblk  = zmax
         else if (intpkg .eq. gamess_package .or.
     *            intpkg .eq. gamess_derivative_package) then
            integral_scr = i0wrk
            maxblk = 15**4    ! max. angular momentum for GAMESS is 15.
         endif

c----------------------------------------------------------------------------
c   Get the coefficient array.
c----------------------------------------------------------------------------

c     if (jx .eq. 2) then 
         array = 13 
c      else 
c        array = 2
c     endif 
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Coefficient arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: Coefficient array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      iarray = get_index_from_base(address_table(array), x, 2)
c     call scfa(x(iarray),nindex, inda(1),inda(2))

c----------------------------------------------------------------------------
c   Get the output array.
c----------------------------------------------------------------------------

      array = 17 ! Fockrohf_a for a placeholder   
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Fock arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: Fock array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      farray = get_index_from_base(address_table(array), x, 2)

      if (.not. dryrun) 
     *   call compute_integrals7(val1(1),val2(1), val1(2),val2(2),
     *                       val1(3),val2(3),val1(4),val2(4),
     *                 dbuf(integral_scr),maxblk, ibuf(ipkgscr),
     *                 dbuf(icoord),dbuf(ipcoeff),dbuf(ialpha), 
     *                 ibuf(iccbeg), ibuf(iccend), 
     *                 x(indblk), nsend, 
     *                 x(iarray), 1, inda(1), 1,inda(2), 
     *                 x(farray))

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__close_logfile
c------------------------------------------------------------------------
c  operation   : ofh__close_logfile
c  module      : output files handler
c  module-id   : ofh
c  description : This operation terminates the connections between the
c                unit 1 and the logfile. the contents of the logfile
c                will be saved.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         logical    is_open
c
c
c------------------------------------------------------------------------
c
c
c             ...inquire the open status of the logfile unit.
c
c
         inquire  (unit   = 1,
     +             opened = is_open)
c
c
c             ...close the logfile unit if it is open.
c
c
         if (is_open) then
             close (unit = 1)
         endif
c
c
c             ...ready!
c
c
         return
         end

C
C INITIALIZES I/O SYSTEM.  DEPENDENT OF CRAPSI, SHOULD PROBABLY *NEVER*
C  BE CALLED EXPLICITLY.
C
      SUBROUTINE INITIO(INTIME,I0)
      IMPLICIT INTEGER (A-Z)
      LOGICAL YESNO,GAMLAM
      CHARACTER*8 NAMES(5)
      CHARACTER*80 FNAME
      INTEGER USEC,USECIN,TSTART,WSTART
      COMMON / / ICORE(1)
      COMMON /INCORE/ ICREC(2),USEC,IXT(2),IMOD(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIODS(10,500),
     &               MOIOSZ(10,500),MOIOFL(10,500)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /FILSPC/ IBUFLN,IPRCLN,IPRCWD
      COMMON /CACHEINF/ CACHSIZ,CACHSZP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      DATA NAMES /'MOINTS  ','GAMLAM  ','MOABCD  ','DERINT  ',
     &            'DERGAM  '/
C
      LENMOIO=5000
C
C INITIALIZE FILE IO INFORMATION IF INTIME = -1 (INTPROC ONLY)
C
      IF(INTIME.EQ.-1)THEN
c YAU : old
c      CALL IZERO(MOIO,LENMOIO)
c      CALL IZERO(MOIODS,LENMOIO)
c      CALL IZERO(MOIOSZ,LENMOIO)
c      CALL IZERO(MOIOWD,LENMOIO)
c      CALL IZERO(MOIOFL,LENMOIO)
c YAU : new
       call aces_io_zero
c YAU : end
      ELSE
       DO 10 I=50,54
        IPOS=IIEQ(LENMOIO,MOIOFL,1,I)
        IF(IPOS.NE.0)THEN
         CALL GFNAME(NAMES(I-49),FNAME,ILENGTH)
         INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO)
         IF(YESNO)THEN
          CALL ACES_IO_OPEN(I-49)
         ELSE
          WRITE(6,1000)I
1000      FORMAT(T3,'@INITIO-F, Unit ',I3,' contained in list directory'
     &             ,' but is not on disk.')
          CALL ERREX
         ENDIF
        ENDIF
10     CONTINUE
      ENDIF
C
C INITIALIZE ALL OF THE CACHE INFORMATION
C
      IF(INTIME.NE.0)CALL IZERO(CACHDIR,100)
      OLDEST=1
      RETURN
      END

      Subroutine WrPBas (LuB,BasFil,BasNam,LuAbi,IRet,IForm,IStat,
     &                   INTTYP,NULLST,IATNUM,NORD)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: wrpbas.F,v 1.2 2004/05/06 15:09:20 yau Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose: Read the basis library for a given basis name & write it
C          on LuAbi in the appropriate format.
C
C Arguments:
C     LuB     Unit to attach basis library to (input)
C     BasFil  Name of basis library (input)
C             NOTE: This file is opened and closed within WrPBas
C     BasNam  Name of basis set to look for (input)
C     LuAbi   Unit on which to write Pitzer-style basis info (input)
C             NOTE: This file is assumed to be open and in position
C                   on entry to WrPBas.
C     IRet    Tells if routine is to return after locating basis and
C               getting some information.
C             = 0  Just get contraction levels and highest L value.
C             = 1  Pull *and* write out basis.
C     IForm   Format to write basis set in
C             = 0  Pitzer
C             = 1  VMol
C             = 2  Cadpac
C     IStat   Completion status (output)
C             = 0  Successful
C             = 1  Named basis not found
C             = 3  Basis library file not found
C             = 5  I/O error while reading basis library
C             = 8  I/O error while writing on LuAbi
C
C Note:
C     IStat = 8 should really be a fatal error, but we don't know enough
C     to give proper error messages, so we just send it up.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Integer LuB, LuAbi
      Character*(*) BasFil, BasNam
C     Define the "Standard I/O" units to use throughout the code
      Parameter (LuIn  = 5)
      Parameter (LuOut = 6)
      Parameter (LuErr = 6)
C
C     For checking to open BasFil nicely
C
      Integer OldLu
      Logical IsTher, Opn
C
C     These guys are used to input & output the basis info
C
      Integer LMax, NCF, NExp
      Integer NCon(7), NPri(250), NUMSHL(250),NPRSHL(250),NINSHL(250)
      Double Precision Expnt(100), Coef(100), ARRAY(25,10)
c     Maximum string length of terminal lines
      INTEGER LINELEN
      PARAMETER (LINELEN=80)
      Character*(linelen) Name, Cmnt
C     Cadpac uses these & it can handle up to f fns.  Pitzer up to d.
      Character*1 LLab(7)
      double precision xyztol
      COMMON /OPTCTL/ JUNK(13),ICNTYP,JUNK2(2), xyztol
      SAVE NUMSHL,NPRSHL,NINSHL,NPRI,ISHELL,LMAX,NCF,NEXP,NAME
      Data LLab/'S','P','D','F','G','H','I'/
C
C Initialize some stuff.
C
      IsTher = .False.
      Opn = .False.
      OldLu = 0
C
C     First, carefully open the basis library
C
      Inquire (FILE=BasFil, EXIST=IsTher, OPENED=Opn, NUMBER=OldLu)
      If (.not. IsTher) then
         IStat = 3
         Write (LuErr,9930) BasFil
         Return
      EndIf
 9930 Format (' @WRPBAS-F, Basis library ',A,' not found.')
C
      If (IForm .Eq. 0 .OR. IForm .eq. 2) Then
         If (Opn) Close (OldLu)
         Open (LuB, FILE=BasFil, STATUS='OLD', FORM='FORMATTED',
     $      ERR=7000)
         Rewind LuB
      Else
         If (.not. Opn) Open (LuB, FILE=BasFil,STATUS='OLD',ERR=7000)
         If (IRet.eq.0) Rewind LuB
         If (IRet.ne.0) Then
            Backspace LuB
            NLINES=1+(LMAX+NCF)/26
            IF(MOD(LMAX+NCF,26).EQ.0)NLINES=NLINES-1
            DO 333 IBACK=1,NLINES
             Backspace LuB
333         CONTINUE
            GoTo 370
         Endif
      Endif
C
C     Now lets look...read in each basis consecutively
C
 1000 Read (LuB, '(A)', End=6000, Err=7000) Name
      Read (LuB, '(A)', End=6000, Err=7000) Cmnt
 370  Read (LuB, '(3i3)', End=6000, Err=7000) LMAX, NCF, NExp
      Read (LuB, '((26i3))', End=6000, Err=7000) (NCon(i),i=1,LMax),
     $   (NPri(i),i=1,NCF)
      If(Name(:linblnk(Name)).eq.BasNam(:linblnk(BasNam)).and.
     &   IRet.eq.0) Then
C
C Write some of this information to MOL deck and then return.
C
         ISET=0
         CALL IZERO(NUMSHL,250)
         CALL IZERO(NPRSHL,250)
         CALL IZERO(NINSHL,250)
         ISHELL=0
         IF(ICNTYP.EQ.0)THEN
          Do 455 LANG=1,LMAX
           NUMSHL(LANG)=NCON(LANG)
           DO 466 ISHEL=1,NUMSHL(LANG)
            ISHELL=ISHELL+1
            NINSHL(ISHELL)=NPRI(ISHELL)
            NPRSHL(ISHELL)=NPRI(ISHELL)
466        CONTINUE
455       CONTINUE
         ELSE
          Do 555 LANG=1,LMAX
           NUMSHL(LANG)=1+NCON(LANG)/8
           DO 566 ISHEL=1,NUMSHL(LANG)
            ITMP=NCON(LANG)-(ISHEL-1)*7
            ISHELL=ISHELL+1
            NINSHL(ISHELL)=MIN(7,ITMP)
            DO 567 ICOUNT=1,NINSHL(ISHELL)
             ISET=ISET+1
             NPRSHL(ISHELL)=NPRSHL(ISHELL)+NPRI(ISET)
567         CONTINUE
566        CONTINUE
555       CONTINUE
         ENDIF
CJDW 9/20/96. Allow for Seward.
CADY 5/06/04. Allow for GAMESS.
         IF(INTTYP.EQ.1.OR.INTTYP.EQ.4.OR.INTTYP.EQ.5) THEN
         WRITE(LUABI,4030)NULLST,FLOAT(IATNUM),NORD,
     &                    LMAX,(NUMSHL(I),I=1,LMAX)
         ELSE IF(INTTYP.EQ.2) THEN
         WRITE(LUABI,4031)FLOAT(IATNUM),NORD,
     &                    LMAX,(NUMSHL(I),I=1,LMAX)
         ENDIF
 4030    Format(A6,F14.8,I5,8I5)
 4031    FORMAT(F10.5,I5,8I5)
         Return
      Endif
 
      Read (LuB, '(4f18.0)', End=6000, Err=7000) (Expnt(i),i=1,NExp),
     $   (Coef(i),i=1,NExp)
C
      If ( Name(:linblnk(Name)) .ne. BasNam(:linblnk(BasNam)) )
     $   goto 1000
C
C     Now we've go to make Pitzer happy...
C
      n = 0
      nfn = 0
      IF(IForm.EQ.0)THEN
         Do 2000 l = 1, LMax
            Do 2100 ICon = 1, NCon(l)
               n = n + 1
               Write (LuAbi, 8000, Err=6100) ICon, LLab(l), NPri(n)
               Do 2200 IPri = 1, NPri(n)
                  nfn = nfn + 1
                  Write (LuAbi, 8010, Err=6100) IPri,Expnt(nfn),
     $               Coef(nfn)
 2200          Continue
 2100       Continue
 2000    Continue
 8000    Format (I5, 1X, A4, I5)
 8010    Format (I5, 1X, E14.9, E20.12)
C
C     Now we've got to make VMol happy...
C
      ElseIf (IForm .eq. 1) then
         ISTART=1
         ITHRU=0
         NROWST=1
         DO 3000 NUMSH=1,ISHELL
          CALL ZERO(ARRAY,250)
          NPRIM=NPRSHL(NUMSH)
          NSIZE=1
          IF(ICNTYP.EQ.1)NSIZE=NINSHL(NUMSH)
          WRITE(LUABI,'(2I5)')NPRIM,NSIZE
          CALL SCOPY(NPRIM,EXPNT(ISTART),1,ARRAY(1,1),1)
          IBEGIN=ISTART
          ISTART=ISTART+NPRIM
          NROWST=1
          DO 3001 I=1,NSIZE
           ITHRU=ITHRU+1
           NROW=NPRI(ITHRU)
           CALL SCOPY(NROW,COEF(IBEGIN),1,ARRAY(NROWST,I+1),1)
           IBEGIN=IBEGIN+NROW
           NROWST=NROWST+NROW
3001      CONTINUE
          DO 3002 ICOUNT=1,NPRIM
           WRITE(LUABI,3010,ERR=6100)(ARRAY(ICOUNT,J),J=1,NSIZE+1)
3002      CONTINUE
3000     CONTINUE
3010     FORMAT((4F18.9))
C
C     Cadpac is almost exactly like Pitzer, but requires fixed
C     format numbers.
C
      ElseIf (IForm .eq. 2) then
         Do 4000 l = 1, LMax
            Do 4100 ICon = 1, NCon(l)
               n = n + 1
               Write (LuAbi, 8000, Err=6100) ICon, LLab(l), NPri(n)
               Do 4200 IPri = 1, NPri(n)
                  nfn = nfn + 1
                  Write (LuAbi, 8020, Err=6100) IPri,Expnt(nfn),
     $               Coef(nfn)
 4200          Continue
 4100       Continue
 4000    Continue
 8020    Format (I5, 1X, 2F30.15)
      ENDIF
C
      Return
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     We got to the end of the file & never found a match
C
 6000 Close (LuB)
      IStat = 1
      Write (LuErr,9910) BasNam(:linblnk(BasNam)), BasFil
      Return
 9910 Format (' @WRPBAS-F, Basis set ',A,' not found in library ',A,'.')
C
C     An error occurred in writing to LuAbi
C
 6100 Close (LuB)
      IStat = 7
      Write (LuErr, 9880) LuAbi
      Return
 9880 Format (' @WRPBAS-W, I/O error writing to unit ',I3,'.')
C
C     If we get here, there's trouble - some unusual error
C
 7000 Continue
      IStat = 5
      Write (LuErr, 9950) BasFil
 9950 Format (' @WRPBAS-F, I/O error on basis library ',A,'.')
      Return
      End

C
      SUBROUTINE SET_2UNIT_MATRIX(A, LEN)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LEN, LEN)
C
      if (len.lt.1) return
 
      CALL ZERO(A, LEN*LEN)
C
      DO I = 1, LEN
         A(I, I) = 1.0D0
      END DO
C
      RETURN
      END

         SUBROUTINE  ERD__K12_INT2D_TO_ABC0
     +
     +                    ( SHELLA,SHELLB,SHELLC,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZA,NXYZB,NXYZC,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_INT2D_TO_ABC0
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative eris:
C
C                       [AB|C0] , [AB|0C] , [A0|BC] or [0A|BC]
C
C                adding up the contributions from all the respective
C                derivative 2D integrals:
C
C                          ABC0 , AB0C , A0BC or 0ABC
C
C                Simplified version of the general ABCD routine to
C                reduce loop overheads for those cases where there is
C                at least one s-shell. For comments and details see
C                the general ABCD routine.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x = A,B,C
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZx       =  # of cartesian monomials for
C                                   x = A,B,C shells
C                    INT2Dx      =  all current 2D ABC0/AB0C/A0BC/0ABC
C                                   derivative integrals for each
C                                   cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D ABC0/AB0C/A0BC/0ABC derivative
C                                   integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [AB|C0]/[AB|0C]/[A0|BC]/[0A|BC]
C                                   derivative integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,J,K,M,N,R,i1,i2,i3,i4
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZA,NXYZB,NXYZC
         INTEGER     SHELLA,SHELLB,SHELLC
         INTEGER     XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         INTEGER     XAP,XBP,XCP
         INTEGER     YAMAX,YBMAX,YCMAX

         DOUBLE PRECISION  SUM,QQQ
         DOUBLE PRECISION  ZERO,STGEXP

         DOUBLE PRECISION  SCALE (1:NGQEXQ),RTS(1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ),UVAL(1:NEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH  (1:NEXQ,1:NXYZA,1:NXYZB,1:NXYZC)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLA,0:SHELLB,0:SHELLC)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLA,0:SHELLB,0:SHELLC)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLA,0:SHELLB,0:SHELLC)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C


c           write(6,*) STGEXP,'$$$$$$$$$$$$$'    

c            do i1=1,NEXQ
c            write(6,*) UVAL(i1), '!!!!!!!!',i1 
c            enddo

c             do i1=1,NEXQ
c              do i2=NXYZA
c              BATCH(i1,i2) = 0.d0
c              enddo
c             enddo 


c           do i1=1,NGQEXQ
c            write(6,*) SCALE (i1), RTS(i1),'+*******+',i1
c           enddo

c           do i1=1,NGQEXQ
c            do i2=1,SHELLA
c             do i3=1,SHELLB
c              do i4=1,SHELLC
c            write(6,*) INT2DX(i1,i2,i3,i4),'----',i1,i2,i3,i4
c            write(6,*) INT2DY(i1,i2,i3,i4),'<---',i1,i2,i3,i4
c            write(6,*) INT2DZ(i1,i2,i3,i4),'<<--',i1,i2,i3,i4
c              enddo
c             enddo
c            enddo
c           enddo

c            write(6,*) NEXQ, NXYZA, NXYZB, NXYZC,'#######'






         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XCP = 0
         DO 100 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 102  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 104 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 110 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 112 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 114 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M)
                         END DO
                     ELSE
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M) * INT2DY (M,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = TEMP2 (M)*
     &                           (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0    
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF  

                         END DO
                     ELSE
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) =   TEMP2 (M)
     +                                        * INT2DZ (M,ZA,ZB,ZC)*
     &                            (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))

                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  114              CONTINUE
  112            CONTINUE
  110          CONTINUE
               XAP = I
  104        CONTINUE
             XBP = J
  102      CONTINUE
           XCP = K
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XCP = 0
         DO 200 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 202  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 204 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 210 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 212 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 214 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 2

                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 2
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  214              CONTINUE
  212            CONTINUE
  210          CONTINUE
               XAP = I
  204        CONTINUE
             XBP = J
  202      CONTINUE
           XCP = K
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XCP = 0
         DO 300 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 302  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 304 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 310 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 312 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 314 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = (  TEMP2 (R)*(1.d0-RTS(R))
     +                                     + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                     + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 3
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF



                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 3
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF



                         END DO
                     END IF

  314              CONTINUE
  312            CONTINUE
  310          CONTINUE
               XAP = I
  304        CONTINUE
             XBP = J
  302      CONTINUE
           XCP = K
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XCP = 0
         DO 400 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 402  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 404 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 410 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 412 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 414 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 4
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF


                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZA,ZB,ZC)*(1.d0-RTS(R+3))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 4
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  414              CONTINUE
  412            CONTINUE
  410          CONTINUE
               XAP = I
  404        CONTINUE
             XBP = J
  402      CONTINUE
           XCP = K
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XCP = 0
         DO 500 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 502  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 504 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 510 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 512 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 514 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 5
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZA,ZB,ZC)*(1.d0-RTS(R+3))
     +                                        + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZA,ZB,ZC)*(1.d0-RTS(R+4))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 5
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  514              CONTINUE
  512            CONTINUE
  510          CONTINUE
               XAP = I
  504        CONTINUE
             XBP = J
  502      CONTINUE
           XCP = K
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XCP = 0
         DO 600 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 602  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 604 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 610 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 612 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 614 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 6
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZA,ZB,ZC)*(1.d0-RTS(R+3))
     +                                        + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZA,ZB,ZC)*(1.d0-RTS(R+4))
     +                                        + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZA,ZB,ZC)*(1.d0-RTS(R+5))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 6
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  614              CONTINUE
  612            CONTINUE
  610          CONTINUE
               XAP = I
  604        CONTINUE
             XBP = J
  602      CONTINUE
           XCP = K
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XCP = 0
         DO 700 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 702  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 704 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 710 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 712 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 714 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                    + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 7
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))   
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZA,ZB,ZC)*(1.d0-RTS(R+3))
     +                                        + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZA,ZB,ZC)*(1.d0-RTS(R+4))
     +                                        + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZA,ZB,ZC)*(1.d0-RTS(R+5))
     +                                        + TEMP2 (R+6)
     +                           * INT2DZ (R+6,ZA,ZB,ZC)*(1.d0-RTS(R+6))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 7
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  714              CONTINUE
  712            CONTINUE
  710          CONTINUE
               XAP = I
  704        CONTINUE
             XBP = J
  702      CONTINUE
           XCP = K
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XCP = 0
         DO 800 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 802  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 804 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 810 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 812 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 814 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                    + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                    + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                                        )*(2.d0*UVAL(M)/STGEXP) 
                            R = R + 8
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZA,ZB,ZC)*(1.d0-RTS(R+3))
     +                                        + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZA,ZB,ZC)*(1.d0-RTS(R+4))
     +                                        + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZA,ZB,ZC)*(1.d0-RTS(R+5))
     +                                        + TEMP2 (R+6)
     +                           * INT2DZ (R+6,ZA,ZB,ZC)*(1.d0-RTS(R+6))
     +                                        + TEMP2 (R+7)
     +                           * INT2DZ (R+7,ZA,ZB,ZC)*(1.d0-RTS(R+7))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 8
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  814              CONTINUE
  812            CONTINUE
  810          CONTINUE
               XAP = I
  804        CONTINUE
             XBP = J
  802      CONTINUE
           XCP = K
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XCP = 0
         DO 900 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 902  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 904 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO

               K = XCP
               DO 910 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 912 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 914 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                    + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                    + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                    + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                    + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                                    + TEMP2 (R+8)*(1.d0-RTS(R+8))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 9
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J,K) = ( TEMP2 (R)
     +                           * INT2DZ (R,ZA,ZB,ZC)*(1.d0-RTS(R))
     +                                        + TEMP2 (R+1)
     +                           * INT2DZ (R+1,ZA,ZB,ZC)*(1.d0-RTS(R+1))
     +                                        + TEMP2 (R+2)
     +                           * INT2DZ (R+2,ZA,ZB,ZC)*(1.d0-RTS(R+2))
     +                                        + TEMP2 (R+3)
     +                           * INT2DZ (R+3,ZA,ZB,ZC)*(1.d0-RTS(R+3))
     +                                        + TEMP2 (R+4)
     +                           * INT2DZ (R+4,ZA,ZB,ZC)*(1.d0-RTS(R+4))
     +                                        + TEMP2 (R+5)
     +                           * INT2DZ (R+5,ZA,ZB,ZC)*(1.d0-RTS(R+5))
     +                                        + TEMP2 (R+6)
     +                           * INT2DZ (R+6,ZA,ZB,ZC)*(1.d0-RTS(R+6))
     +                                        + TEMP2 (R+7)
     +                           * INT2DZ (R+7,ZA,ZB,ZC)*(1.d0-RTS(R+7))
     +                                        + TEMP2 (R+8)
     +                           * INT2DZ (R+8,ZA,ZB,ZC)*(1.d0-RTS(R+8))
     +                                        )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 9
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF

  914              CONTINUE
  912            CONTINUE
  910          CONTINUE
               XAP = I
  904        CONTINUE
             XBP = J
  902      CONTINUE
           XCP = K
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x,x-triples. No skipping of
C                x,x,x-contribution of 0,0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XCP = 0
         DO 1000 XC = SHELLC,0,-1
           YCMAX = SHELLC - XC
           XBP = 0
           DO 1002  XB = SHELLB,0,-1
             YBMAX = SHELLB - XB
             XAP = 0
             DO 1004 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC)
               END DO
C
C
C             ...inner loops over y,y,y-triples. Skip the
C                multiplication of y,y,y-contributions, if no
C                y-coordinate derivative was formed and we have a
C                0,0,0-triple, as then the 2DY integrals are
C                equal to 1.
C
C
               K = XCP
               DO 1010 YC = YCMAX,0,-1
                 K = K + 1
                 ZC = YCMAX - YC
                 J = XBP
                 DO 1012 YB = YBMAX,0,-1
                   J = J + 1
                   ZB = YBMAX - YB
                   I = XAP
                   DO 1014 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB+YC.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB,YC)
                         END DO
                     END IF
C
C
C             ...skip multiplication of z,z,z-contributions, if we
C                have a 0,0,0-triple and no derivations were performed
C                on the z-coordinate, as then the 2DZ integrals
C                are equal to 1. All info concerning all three x,x,x-,
C                y,y,y- and z,z,z-triples have been collected for all
C                exponent quadruplets at once. Sum up the 2D X,Y,Z
C                integral products to the appropriate places of the
C                batch.
C
C
                     IF (.NOT.DIFFZ .AND. ZA+ZB+ZC.EQ.0) THEN
                         R = 0
                         DO M = 1,NEXQ
                            SUM = ZERO
                            DO N = 1,NGQP
                               QQQ = TEMP2 (R+N)*(1.d0-RTS(R+N)) 
                               SUM = SUM + QQQ
                            END DO
                            R = R + NGQP
                            BATCH (M,I,J,K) = SUM*(2.d0*UVAL(M)/STGEXP)
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--==',NGQP
                     ENDIF

                         END DO
                     ELSE
                         R = 0
                         DO M = 1,NEXQ
                            SUM = ZERO
                            DO N = 1,NGQP
           QQQ = TEMP2 (R+N) * ( 1.d0-RTS(R+N) ) * INT2DZ(R+N,ZA,ZB,ZC)
           SUM = SUM + QQQ
                       if( isnan(QQQ) ) then 
                       write(6,*) TEMP2 (R+N),INT2DZ(R+N,ZA,ZB,ZC)
                       write(6,*) ( 1.d0-RTS(R+N) ),R,N,'<====='
                       endif

                            END DO
                            R = R + NGQP
                            BATCH (M,I,J,K) = SUM*(2.d0*UVAL(M)/STGEXP)
                     IF( isnan( BATCH (M,I,J,K) ) ) then
                                BATCH (M,I,J,K) = 0.d0
                                write(6,*) 'NaN detected <--',NGQP
                     ENDIF

                         END DO
                     END IF
C
C
C             ...next z,z,z-triple and y,y,y-triple.
C
C
 1014              CONTINUE
 1012            CONTINUE
 1010          CONTINUE
C
C
C             ...next x,x,x-triple.
C
C
               XAP = I
 1004        CONTINUE
             XBP = J
 1002      CONTINUE
           XCP = K
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE T1STAT(T1OLD,T1NEW,SYVEC,NSIZET,NSMSZ,
     &                  ISPIN,ICONVG,TOL,NLIST,TYPE)
C
C THIS ROUTINE ACCEPTS TWO T1 VECTORS AND FINDS THE LARGEST
C  AND RMS DIFFERENCE BETWEEN THEIR ELEMENTS AND DETERMINES
C  IF THEY ARE IDENTICAL TO WITHIN A SET TOLERANCE.
C
C INPUT:  
C       T1OLD - ONE OF THE TWO T1 VECTORS.
C       T1NEW - THE OTHER T1 VECTOR.
C       SYVEC - THE AI SYMMETRY VECTOR FOR THIS SPIN CASE
C       NSIZET- LENGTH OF THE SYMMETRY-PACKED T1 VECTOR.
C       NSMSZ - LENGTH OF THE AI SYMMETRY VECTOR (Na*na OR Nb*nb)
C       ISPIN - THE SPIN CASE
C       TOL   - THE CONVERGENCE CRITERION
C       NLIST - THE LIST NUMBER ON WHICH THE VALUES RESIDE
C       TYPE  - ???????
C
C OUTPUT:
C       ICONVG- RETURNED AS "0" IF VALUES ARE CONVERGED, "1"
C               OTHERWISE.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A,SYVEC(NSMSZ)
      CHARACTER*2 SPCASE(3) 
      CHARACTER*1 TYPE
      DIMENSION T1OLD(NSIZET),T1NEW(NSIZET)
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /FLAGS/ IFLAGS(100)
      DATA SPCASE /'AA','BB','AB'/
      DATA ONEM /-1.0/
      IGETI(IX,N)=1+(IX-1)/N
      IGETA(IX,N)=IX-(IGETI(IX,N)-1)*N 
C
      IF(NSIZET.EQ.0)RETURN
C
C FORM T2DIFF = T2NEW - T2OLD
C
      CALL GETLST(T1OLD,1,1,1,ISPIN,90+NLIST)
      CALL GETLST(T1NEW,1,1,1,ISPIN+2,90)
      CALL VADD(T1OLD,T1NEW,T1OLD,NSIZET,ONEM)
      RMSDIF=SNRM2(NSIZET,T1OLD,1)
      RMSDIF=RMSDIF/FLOAT(NSIZET)
      MAXDIF=ISAMAX(NSIZET,T1OLD,1)
      DIFMAX=T1OLD(MAXDIF)
      IF(DABS(DIFMAX).GT.TOL)ICONVG=1
C
C MAXDIF IS THE OFFSET OF THE INDICES IN THE PACKED LIST.  WE NEED TO
C  GET THE OFFSET IN THE UNPACKED LIST.
C
      IOFFUNP=SYVEC(MAXDIF)
      I=IGETI(IOFFUNP,NVRTO(ISPIN))
      A=IGETA(IOFFUNP,NVRTO(ISPIN))+NOCCO(ISPIN)
      IF(IFLAGS(1).GE.10)THEN
       WRITE(*,100)TYPE,'1',SPCASE(ISPIN),RMSDIF,DIFMAX,I,A
  100  FORMAT(T9,A1,A1,T19,A2,T24,F13.10,T37,F13.10,T52,I3,T62,I3)
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE EVAL_QSTLST_PATH(QST_TANGENT, LST_TANGENT, WORK,
     &                            LST, QST)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

#include "mxatms.par"
#include "machsp.com"
#include "coord.com"

      LOGICAL XYZIN, NWFINDIF, QST, LST
      DOUBLE PRECISION LST_NORM_SQR, LST_NORM_INV, LST_TANGENT

      COMMON /USINT/NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /INPTYP/XYZIN,NWFINDIF

      DIMENSION WORK(NX*NX), LST_TANGENT(3*NATOMS),
     &          QST_TANGENT(3*NATOMS)
C
C Use Eqn. 1 and 8 in Schlegel to evaluate the QST and LST normalized
C tangent vectors.
C
C Read the guess structures (user provided) for the transition
C state and the products.
C
c      Write(6,*) (Q(I), I = 1, 3*NATOMS)
      IF (XYZIN) THEN
         CALL DGETREC(1,'JOBARC','PRSTRUCT',3*NATOMS,WORK)
      ELSE

         IRECTNT = 1
         IPRDUCT = IRECTNT + 3*NATOMS

         CALL DGETREC(1,'JOBARC','PRSTRUCT',3*NATOMS,
     &               WORK(IPRDUCT))
         CALL CNVRT2RAD(WORK(IPRDUCT),3*NATOMS)
         CALL SQUSH(WORK(IPRDUCT),3*NATOMS)
c         Write(6,*) "Debug-Info: The Product Structure"
c         Write(6,*) (Work(IPRDUCT + I), I= 0,3*NATOMS-1)

         IF (LST) THEN
            CALL DCOPY(3*NATOMS, R, 1, WORK(IRECTNT), 1)
c            Write(6,*) "Debug-Info: Current Structure"
c            Write(6,*) (Work(IRECTNT + I), I= 0, NATOMS)
            CALL XDAXPY(3*NATOMS, -1.0D0, WORK(IRECTNT), 1,
     &                 WORK(IPRDUCT), 1)
c            Write(6,*) "Debug-Info: The Diff Structure"
c            Write(6,*) (Work(IPRDUCT + I), I= 0, NATOMS)

CSSS            CALL DCOPY(NX, WORK(IPRDUCT), 1, LST_TANGENT, 1)
CSSS            CALL DGETREC(20, "JOBARC", "BMATRIX ", 3*NATOMS*NOPT,
CSSS     &                  WORK(1))
CSSS            IOFFSET = 3*NATOMS*NOPT + 1
CSSS            CALL XGEMM("N", "N", NOPT, 1, 3*NATOMS, 1.0D0, WORK,
CSSS     &                  NOPT, LST_TANGENT, 3*NATOMS, 0.0D0, WORK
CSSS     &                  (IOFFSET), NOPT)
CSSS            CALL DCOPY(NOPT, WORK(IOFFSET), 1, LST_TANGENT, 1)

            CALL SYMUNQONLY(WORK(IPRDUCT), LST_TANGENT)
            CALL NORMAL(LST_TANGENT, NOPT)

c            Write(6,*) "Debug-Info: LST tangent"
c            Write(6,*) (LST_TANGENT(I), I= 1, NOPT)

         ELSE IF (QST) THEN

            ICURENT = IPRDUCT + 3*NATOMS

            CALL DGETREC(1,'JOBARC','RXSTRUCT',3*NATOMS,
     &                  WORK(IRECTNT))
            CALL CNVRT2RAD(WORK(IRECTNT), 3*NATOMS)
            CALL SQUSH(WORK(IRECTNT), 3*NATOMS)
            CALL DCOPY(3*NATOMS, R, 1, WORK(ICURENT), 1)

c            Write(6,*) "Debug-Info: Rectant Structure"
c            Write(6,*) (Work(IRECTNT + I), I= 0, 3*NATOMS)
c            Write(6,*) "Debug-Info: Product Structure"
c            Write(6,*) (Work(IPRDUCT + I), I= 0, 3*NATOMS)
c            Write(6,*) "Debug-Info: Current Structure"
c            Write(6,*) (Work(ICURENT + I), I= 0, 3*NATOMS)

            CALL XDAXPY(3*NATOMS, -1.0D0, WORK(ICURENT), 1,
     &                 WORK(IPRDUCT), 1)
            CALL XDAXPY(3*NATOMS, -1.0D0, WORK(ICURENT), 1,
     &                 WORK(IRECTNT), 1)

            QST_NORM_SQR_PX = DDOT(3*NATOMS, WORK(IPRDUCT), 1,
     &                             WORK(IPRDUCT), 1)
            QST_NORM_SQR_RX = DDOT(3*NATOMS, WORK(IRECTNT), 1,
     &                             WORK(IRECTNT), 1)
            IF ((QST_NORM_SQR_PX.LE.1.0D-14).OR.
     &          (QST_NORM_SQR_RX.LE.1.0D-14)    ) THEN
               PRINT*, "AN INPUT ERROR: INSPECT THE INPUT STRUCTURES"
c               CALL ACES_EXIT
                call errex
            END IF

            QST_NORM_PX_INV = 1.0D0/(QST_NORM_SQR_PX)
            QST_NORM_RX_INV = 1.0D0/(QST_NORM_SQR_RX)

            CALL DSCAL(3*NATOMS, QST_NORM_PX_INV, WORK(IPRDUCT), 1)
            CALL DSCAL(3*NATOMS, QST_NORM_RX_INV, WORK(IRECTNT), 1)

            CALL XDAXPY(3*NATOMS, -1.0D0, WORK(IRECTNT), 1,
     &                 WORK(IPRDUCT), 1)

CSSS            CALL DCOPY(3*NATOMS, WORK(IPRDUCT), 1, QST_TANGENT, 1)
CSSS            CALL DGETREC(20, "JOBARC", "BMATRIX ", 3*NOPT*NATOMS,
CSSS     &                  WORK(1))
CSSS            IOFFSET = 3*NATOMS*NOPT + 1
CSSS            CALL XGEMM("N", "N", NOPT, 1, 3*NATOMS, 1.0D0, WORK,
CSSS     &                  NOPT, QST_TANGENT, 3*NATOMS, 0.0D0, WORK
CSSS     &                  (IOFFSET), NOPT)

            CALL SYMUNQONLY(WORK(IPRDUCT), QST_TANGENT)
            CALL NORMAL(QST_TANGENT, NOPT)
c            Write(6,*) "Debug-Info: QST tangent"
c            Write(6,*) (QST_TANGENT(I), I= 1, NOPT)

         END IF
      END IF

CSSS      LST_NORM_SQR = DDOT(3*NATOMS, WORK(IPRDUCT), 1,
CSSS     &                              WORK(IPRDUCT), 1)
CSSS      IF (DSQRT(LST_NORM_SQR).LE.1.0D-14) THEN
CSSS         PRINT*, "AN INPUT ERROR: INSPECT THE INPUT STRUCTURES"
CSSS         CALL ACES_EXIT
CSSS      END IF
CSSS      LST_NORM_INV = 1.0D0/DSQRT(LST_NORM_SQR)
CSSS      CALL DSCAL(3*NATOMS, LST_NORM_INV, WORK(IPRDUCT), 1)

CSSS      ASQURD = (QST_NORM_SQR_RX)*(QST_NORM_SQR_PX)/
CSSS     &         (QST_NORM_SQR_RX + QST_NORM_SQR_PX - 2.0D0*
CSSS     &          DSQRT((QST_NORM_SQR_RX)*(QST_NORM_SQR_PX)))

CSSS      QST_NORM = DDOT(3*NATOMS, WORK(IPRDUCT), 1,
CSSS     &                          WORK(IPRDUCT), 1)
CSSS      CALL DSCAL(3*NATOMS, DSQRT(QST_NORM), WORK(IPRDUCT), 1)

       RETURN
       END

      SUBROUTINE TIEDIHED(STEP, NOPT, ITIE)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION STEP(NOPT),ITIE(NOPT)
C
      CALL GETREC(20,'JOBARC','TIEDCORD',NOPT, ITIE)

      DO  I=1,NOPT
          IF (ITIE(I).NE.0)THEN
             DO J=I+1,NOPT
                IF (ITIE(J).EQ.ITIE(I))THEN
                    STEP(J)=-STEP(I)
      Write(6, "(1x,a,I4,a,a,F13.8)") "Optimized coordinate ",J, 
     &                             " automatically ","set to ",
     &                              -step(i)
 
                ENDIF 
             ENDDO
         ENDIF
      ENDDO
C
      RETURN
      END 

c This routine prints the top of a table of namelist values.

      subroutine nl_prttop(nltitle)
      implicit none
      character*(*) nltitle
      write(*,990)
      write(*,900)
      write(*,910) nltitle
      write(*,920) 'KEYWORD','TYPE','VALUE','DEFAULT'
      write(*,930)
      write(*,920) 'print_nl','logical','true'
  990 format(' ')
  900 format(76('='))
  910 format('NAMELIST: ',a)
  920 format(a20,2x,a10,2x,a20,2x,a20)
  930 format(20('-'),2x,10('-'),2x,20('-'),2x,20('-'),2x)
      return
      end

      Subroutine AllocTIO(MAvail, Reserve)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: alloctio.f,v 1.1.1.1 2003/04/02 19:21:39 aces Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     AllocTIO -- Determine memory to reserve for temporary I/O vectors
C
C SYNOPSIS
C&      Include 'implicitnone.inc'
      Integer MAvail, Reserve
C
C ARGUMENTS
C     MAvail  Words of memory available after all permanent I/O needs
C             are satisfied [IN]
C     Reserve Number of words of memory required for temporary I/O
C             vectors [OUT]
C
C DESCRIPTION
C     Estimate the amount of memory required for any temporary I/O
C     vectors we might generate later in the code.  Decision may be
C     based on the particular model being calculated, the memory
C     available, etc.
C
C COMMON BLOCKS
C&      Include 't3ctrl.inc'
C
C     Control execution of triples contributions
C     T3Meth(1)  Level of T3 inclusion.
C                < 0  Non-iterative models:
C                     -3 => FS CCSD+T(3)
C                     -4 => FS CCSD+T(CCSD) [not yet implemented]
C                = 0  No triples.
C                > 0  Iterative triples models [not yet implemented]
C     T3Meth(2)  Symmetries of T3(0,1)(lab,kij) required.
C                = 1  Only totally symmetric (k,l).
C                = 8  All symmetries of (k,l). [not yet implemented]
C     T3Meth(3)  Types of T3(0,1)(lab,kij) required.
C                = 0  Spectator amplitudes (k=l).
C                = 1  Active-active block of (k,l).
C                = 2  All possible (k,l).
C     T3Meth(4)  Use H or Hbar in contractions
C                = 0  Use H
C                = 1  Use Hbar
C
C     See T3MetInf for information about the "standard" (named) triples
C     models in their T3Meth vectors.
C
      Integer LT3Meth
      Parameter (LT3Meth = 4)
      Integer T3Meth(LT3Meth)
      Common /T3Ctrl/ T3Meth
C
      Integer NOccO(2), NVrtO(2)
      Common /Info/ NOccO, NVrtO
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
C     I       General Use.
C     J       General Use.
C
      Integer I, J
C
C     Basic CCSD requires no temporary space.
C
      Reserve = 0
C
C     Handle T3 models which compute vectors for each set of fixed
C     indices: spectator-T(3), T(3)
C
C     There are 2 fixed indices (in general, 1 for spectator-only models).
C     There are 11 relevant ITypes for each spin of the fixed indices.
C     The longest is at most MAX( virtual, occupied) orbitals.
C     Four of the ITypes are UPLT or UPLE, which require a "zero list"
C     as long as their gather vector.
C
C     *** If accomodating multiple (K,L) in a single pass ***
C     The number of fixed indices done at a time is bounded by the number
C     of occupied orbitals in one case and number of active in the other.
C     Allocate for the number of occupied for both -- very generous.
C
      I = Max( NOccO(1), NOccO(2) )
      J = Max( I, NVrtO(1), NVrtO(2) )
C
      If (T3Meth(1) .eq. -3) then
         If (T3Meth(3) .eq. 0) then
            Reserve = (11 + 6) * J
         Else
            Reserve = 2 * (11 + 6) * J
         EndIf
      EndIf
C
      Return
      End

      Subroutine Angs2bohr(R, NX)
C 
      Implicit Double Precision (A-H, O-Z)
      Dimension R(NX)
C
      ATOR = DACOS(-1.0D0)/180.0D0
      ATOB = 0.529177249D0
c
      Do IDeg = 8, NX-1, 3
         If (Ideg .NE. 8) R(Ideg + 1) = R(Ideg + 1)*ATOR
                          R(ideg) = R(Ideg)*ATOR
      Enddo

      Do IDeg = 4, NX-2, 3
         R(Ideg) =  R(Ideg)/ATOB
      Enddo

      Return
      End

      SUBROUTINE JPRI(J,NCOORD,NUCIND,MULT,NAMEX,NAMES,PRINT)
C
C THIS ROUTINE PRINTS THE TENSOR FOR INDIRECT SPIN SPIN
C COUPLINGS IN NMR THEORY
C
C NOTE THAT THIS ROUTINE MULTIPLIES THE GIVEN TENSOR (IN J)
C WITH THE G-FACTORS FOR THE TWO INVOLVED NUCLEI
C
CEND
C
C 4/93 JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER BEGIN
      DOUBLE PRECISION J
      LOGICAL PRINT
C
      DIMENSION NAMEX(3*NCOORD),MULT(1)
      DIMENSION NAMES(3*NCOORD)
      DIMENSION J(NCOORD,NCOORD)
      DIMENSION GTAB(36),LABELS(36)
      CHARACTER*6 NAMEX
      CHARACTER*6 NAMES
      CHARACTER*2 LABELS
      CHARACTER*2 LAB1,LAB2
C 
      DATA AZERO/0.D0/
C
C GTAB CONTAINS THE G-VALUES FOR THE MOST COMMON ISOTOPES USED IN NMR
C 1H,11B,13C,15C,17O,31P,29SI,27AL,19F 
C
C AND SHOULD BE UPDATED WHENEVER POSSIBLE
C
C  update and check ! No guarantee for correct results
C
C NOTE g(D) IS 0.8574376
C NOTE g(6LI) IS 0.8220514
C NOTE g(10B) IS 0.600216
C NOTE g(14N) IS 0.4037607
C NOTE g(37CL) IS 0.4560820
C NOTE g(49TI) IS -0.315477
C NOTE g(65CU) IS 1.588
C NOTE g(71GA) IS 1.70818
C NOTE g(81BR) IS 1.513706
C
C               1H         3HE          7LI         9BE    
      DATA GTAB/5.5856912D0,-4.255248D0,2.170961D0,-0.7850D0,
C               11B
     &          1.792424D0,
C               13C        15N        17O          19F       
     &          1.40482D0,-0.5663784D0,-0.757516D0,5.257732D0,
C               21NE
     &          -0.441197D0,
C               23NA       25MG       27AL       29SI      31P      
     &          1.478391D0,-0.34218D0,1.456601D0,-1.1106D0,2.26320D0,
C               33S       35CL         39AR   39K
     &          0.42911D0,0.5479157D0,-.37D0,0.2609909D0,
C               43CA       45SC      47TI       51V
     &          -0.376414D0,1.35906D0,-0.31539D0,1.46836D0,
C               53CR      55MN     57FE    59CO     61NI
     &          -.3147D0,1.3819D0,0.1806D0,1.318D0,-0.50001D0,
C               63CU    67ZN       69GA     73GE
     &          1.484D0,0.350312D0,1.34439D0,-0.1954371D0,
C               75AS       77SE     79BR       83KR
     &          0.959647D0,1.0693D0,1.404266D0,-0.215704D0/

C
      DATA LABELS/'H ','HE','LI','BE','B ','C ','N ','O ','F ',
     &            'NE','NA','MG','AL','SI','P ','S ','CL','AR',
     &            'K ','CA','SC','TI','V ','CR','MN','FE','CO',
     &            'NI','CU','ZN','GA','GE','AS','SE','BR','KR'/
      KCOL=6
C
C GET LABELS FOR THE NUCLEI, A LITTLE BIT TRICKY DUE TO SYMMETRY
C
      I=0
      DO 10 IATOM=1,NUCIND
       MULTI=MULT(IATOM)
       ISTR=3*IATOM-3
       IF(MULTI.EQ.1) THEN
        DO 30 ICOOR=1,3
         I=I+1
         NAMES(I)=NAMEX(ISTR+ICOOR)(1:4)//' '//NAMEX(ISTR+ICOOR)(6:6)
30      CONTINUE
       ELSE
        DO 40 JJ=1,MULTI
         DO 50 ICOOR=1,3
          I=I+1
          NAMES(I)=NAMEX(ISTR+ICOOR)(1:4)//' '//NAMEX(ISTR+ICOOR)(6:6)
50       CONTINUE
40      CONTINUE
       ENDIF
10    CONTINUE  
C
C DETERMINE THE G-FACTORS FOR THE TWO NUCLEI 
C
      DO 11 IATOM=1,NCOORD
       LAB1=NAMES(IATOM)(1:2)
       DO 12 ILAB=1,18
        JLAB=ILAB
        IF(LAB1.EQ.LABELS(ILAB)) GO TO 13
12     CONTINUE
       write(*,*) ' no g-factor found for ',lab1
13     FACT=gtab(jlab)
       DO 11 JATOM=1,NCOORD
        LAB2=NAMES(jATOM)(1:2)
        DO 14 ILAB=1,18
         JLAB=ILAB
         IF(LAB2.EQ.LABELS(ILAB)) GO TO 15
14     CONTINUE
       write(*,*) ' no g-factor found for ',lab2
       IF((IATOM-1)/3.EQ.(JATOM-1)/3) FACT=AZERO 
15     FACT2=FACT*gtab(jlab)
C
       J(IATOM,JATOM)=FACT2*J(IATOM,JATOM)
11    CONTINUE
C
      IF(PRINT) THEN
C
       NROW = NCOORD
       LAST = MIN(NROW,KCOL)
       BEGIN= 1 
51     CONTINUE
        WRITE (6,1000) (NAMES(I),I = BEGIN,LAST)
        WRITE (6,'()')
        NCOL = 1
        DO 101 K = BEGIN,NROW
         DO 201 I = 1,NCOL
          IF (J(K,(BEGIN-1)+I) .NE. AZERO) GO TO 401
201      CONTINUE
         GO TO 301
401      WRITE (6,2000)' ',NAMES(K),
     &         (J(K,(BEGIN-1)+JJ),JJ=1,NCOL)
         IF (MOD(K,3) .EQ. 0) WRITE (6,'()')
301      IF (K .LT. (BEGIN+KCOL-1)) NCOL = NCOL + 1
101     CONTINUE
        WRITE (6,'()')
        LAST = MIN(LAST+KCOL,NROW)
        BEGIN= BEGIN+NCOL
       IF (BEGIN.LE.NROW) GO TO 51
C
      ENDIF
C
1000  FORMAT (8X,6(3X,A6,3X),(3X,A6,3X))
2000  FORMAT (A1,A6,6F12.6)
C
      RETURN
C
      END

      SUBROUTINE T1T2AA2(Z,Z1,W,MAXSIZE,T,POP,VRT,DISSYZ,DISSYW,
     &                   NUMSYZ,NUMSYW,NOCCSQ,LISTZ,LISTW,IRREP,TMP)
C
C PRIMITIVE CONTRACTION ROUTINE FOR T2<-T1
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSYZ,DISSYW,DISMAX,DISREAD,DISLEFT,DIRPRD,POP,VRT
      DIMENSION Z(DISSYZ,NOCCSQ),W(DISSYW,1),T(1),Z1(DISSYZ,NUMSYZ)
      DIMENSION TMP(1),POP(8),VRT(8),IPT(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
C
      DATA AZERO,ONE,ONEM /0.0D0,1.0D0,-1.0D0/
C
C     ZERO FIRST OUTPUT ARRAY (NECCESARY BECAUSE THIS IS NOT NECCESARILY
C     DONE IN THE MATRIX MULTIPLICATION
C
      CALL ZERO(Z,NOCCSQ*DISSYZ)
C
C     IF THERE ARE NO WA INTEGRALS THERE IS NOTHING TO DO
C
      IF(MIN(NUMSYW,DISSYW).EQ.0) RETURN
C
C  DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN CORE
C
      MAXDIS=MAXSIZE/DISSYW
C
C     DETERMINE ALGORITHM BY CHECKING MAXSIZE
C
      IF(MAXDIS.GE.NUMSYW) THEN
C
C   WE CAN DO EVERYTHING IN CORE
C
C   GET INTEGRALS <AB//EI> FROM LISTW
C
       CALL GETLST(W,1,NUMSYW,2,IRREP,LISTW)
       CALL SYMTR1(IRREP,VRT,POP,DISSYW,W,TMP,TMP(1+DISSYW),
     &             TMP(1+2*DISSYW))
C
C   PERFORM MULTIPLICATION
C
       JOFFW=1
       JOFFZ=1     
       IOFF=1
       DO 90 IRREPJ=1,NIRREP
C
        NOCCJ=POP(IRREPJ)
        NVRTJ=VRT(IRREPJ)
C
C
        IRREPI=DIRPRD(IRREPJ,IRREP)
C
        NOCCI=POP(IRREPI)
C  
C      NOTHING TO COMPUTE IF ANy Of THE OCCUPATIONS IS ZERO
C
C
         CALL XGEMM('N','N',DISSYW*NOCCI,NOCCJ,NVRTJ,ONEM,W(1,JOFFW), 
     &              DISSYW*NOCCI,T(IOFF),NVRTJ,
     &              ONE,Z(1,JOFFZ),DISSYZ*NOCCI)
C
C
C     UPDATE POINTERS
C
        IOFF=IOFF+NVRTJ*NOCCJ
        JOFFW=JOFFW+NVRTJ*NOCCI
        JOFFZ=JOFFZ+NOCCI*NOCCJ
C
90     CONTINUE
C
      ELSE
C
C    WE HAVE TO DO IT OUT OF CORE
C
C    CALCULATE FIRST OFFSETS FOR THE T1 AMPLITUDES
C
       IPT(1)=1
       DO 50 IRREPJ=1,NIRREP-1
        IRREPI=DIRPRD(IRREP,IRREPJ)
        IPT(IRREPJ+1)=IPT(IRREPJ)+POP(IRREPJ)*VRT(IRREPJ)
50     CONTINUE
C
C  SET OFFSETS FOR INTEGRAL LIST AND FOR Z ARRAY
C
       IOFFSET=1
       IOFFZ=1
C
C  LOOP OVER IRREPS OF THE LAST INDEX
C
       DO 200 IRREPJ=1,NIRREP
C
        NOCCJ=POP(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NOCCI=POP(IRREPI)
        NVRTI=VRT(IRREPI)
        IF(MIN(NOCCI,NVRTI,NOCCJ).NE.0) THEN
C
C  GET MAXIMUM NUMBER OF (A<B,E) BLOCKS WHICH CAN BE HELD IN CORE
C
         DISMAX=MAXDIS/NVRTI
         IF(DISMAX.LE.0) STOP 'T1T2AA2'
C
C  DETERMINE NUMBER OF (A<B,E) BLOCKS WHICH MUST BE READ
C
         DISLEFT=NOCCJ
C
10       CONTINUE 
C
C  GET NUMBER OF (A<B,E) BLOCKS WHICH ARE READ IN THIS PASS
C
          DISREAD=MIN(DISLEFT,DISMAX)
          DISLEFT=DISLEFT-DISREAD
C
C   GET THE DISTRIBUTIONS FROM DISK
C
          CALL GETLST(W,IOFFSET,DISREAD*NVRTI,2,IRREP,LISTW) 
C
C  UPDATE IOFFSET
C
          IOFFSET=IOFFSET+DISREAD*NVRTI
C
C  LOOP OVER ALL DISTRIBUTIONS AND PERFOM MULTIPLICATION
C
          IOFFW=1
          IOFFT1=IPT(IRREPI)
C
          DO 250 NUM=1,DISREAD
C
           CALL XGEMM('N','N',DISSYW,NOCCI,NVRTI,ONE,W(1,IOFFW),
     &                DISSYW,T(IOFFT1),NVRTI,ONE,Z(1,IOFFZ),DISSYZ)
C
C  UPDATE OFFSETS
C
           IOFFW=IOFFW+NVRTI
           IOFFZ=IOFFZ+NOCCI
C
250       CONTINUE
C
C   IF NOT ALL (A<B,E) BLOCKS HAVE BEEN PROCESSED, GO TO 10 
C
         IF(DISLEFT.NE.0) GO TO 10
C
        ELSE
C
C  UPDATE OFFSETS IN THE CASE NOTHING HAS BEEN DONE
C
         IOFFZ=IOFFZ+NOCCI*NOCCJ
         IOFFSET=IOFFSET+NOCCJ*NVRTI
        ENDIF
C
200    CONTINUE
      ENDIF
C
C  ANTISYMMETRIZE THE Z(IJ,AB) ARRAY IN ORDER TO GET THE
C  T2 INCREMENTS
C
      CALL ASSYM(IRREP,POP,DISSYZ,DISSYZ,Z1,Z)
C
C  UPDATE THE T2 INCREMENTS ON DISK
C
      CALL GETLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
      CALL VADD(Z,Z,Z1,NUMSYZ*DISSYZ,ONE)
      CALL PUTLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
C   
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      CHARACTER*8 FUNCTION SITGRP(PTGRP,IORGRP,ORBPOP)
      IMPLICIT INTEGER (A-Z)
      LOGICAL ISH,ISD,ISV
C
C COMPUTES THE SITE GROUP FOR A PARTICULAR ORBIT, GIVEN THE
C   FULL POINT GROUP AND THE ORBIT POPULATION
C
      CHARACTER*4 PTGRP,TMP,some_string_func
      MULT=IORGRP/ORBPOP
      SITGRP = '--      '
C
      ISH=.TRUE.
      ISD=.TRUE.
      ISV=.TRUE.
      IH=INDEX(PTGRP,'h')
      IV=INDEX(PTGRP,'v')
      ID=INDEX(PTGRP,'d')
      IF(IH.EQ.0)ISH=.FALSE.
      IF(ID.EQ.0)ISD=.FALSE.
      IF(IV.EQ.0)ISV=.FALSE.
      IL=LINBLNK(PTGRP)
C
C CASE 1 - CN GROUPS
C
      IF(PTGRP(1:1).EQ.'C'.AND..NOT.ISV.AND..NOT.ISH)THEN
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP
C
C CASE 2 - DN GROUPS
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND..NOT.ISD.AND..NOT.ISH)THEN
       ORDER=IORGRP/2
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.2)SITGRP(1:4)='C2  '
       IF(MULT.EQ.ORDER)SITGRP(1:IL)='C'//PTGRP(2:IL)
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP
C
C CASE 3 - CNV GROUPS
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.ISV)THEN
       ORDER=IORGRP/2
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.2)SITGRP(1:4)='C s '
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP
C
C CASE 4 - CNH GROUPS
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.ISH)THEN
       ORDER=IORGRP/2
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.2)SITGRP(1:4)='C s '
       IF(MULT.EQ.ORDER)SITGRP(1:IH-1)=PTGRP(1:IH-1)
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP 
       IF(ORDER.EQ.2.AND.MULT.EQ.2)SITGRP(1:4)='XXXX'
C
C CASE 5 - DNH GROUPS
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.ISH)THEN
       ORDER=IORGRP/4
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.2)SITGRP(1:4)='C s '
       IF(MULT.EQ.4)SITGRP(1:4)='C2v '
       IF(MULT.EQ.2*ORDER)SITGRP(1:IL)='C'//PTGRP(2:IL-1)//'v'
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP
C
C CASE 6 - DND GROUPS
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.ISD)THEN
       ORDER=IORGRP/4
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.2)SITGRP(1:4)='XXX '
       IF(MULT.EQ.2*ORDER)SITGRP(1:IL)='C'//PTGRP(2:IL-1)//'v'
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP
C
C CASE 7 - SN GROUPS
C
      ELSEIF(PTGRP(1:1).EQ.'S')THEN
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.IORGRP/2)THEN
        TMP='CN  '
        SITGRP(1:4)=some_string_func(TMP,IORGRP/2)
       ENDIF
       IF(MULT.EQ.IORGRP)SITGRP(1:4)=PTGRP
C
C CASE 8 - Cs AND Ci
C
      ELSEIF(PTGRP.EQ.'C s'.OR.PTGRP.EQ.'C i')THEN
       IF(MULT.EQ.1)SITGRP(1:4)='C1  '
       IF(MULT.EQ.2)SITGRP(1:4)=PTGRP
C
C CUBIC GROUPS
C
      ELSEIF(PTGRP.EQ.'T  ')THEN
       IF(ORBPOP.EQ.12)SITGRP(1:4)='C1  '
       IF(ORBPOP.EQ.6)SITGRP(1:4)='C2  '
       IF(ORBPOP.EQ.4)SITGRP(1:4)='C3  '
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ELSEIF(PTGRP.EQ.'T d')THEN
       IF(ORBPOP.EQ.24)SITGRP(1:4)='C1  '
       IF(ORBPOP.EQ.12)SITGRP(1:4)='C s '
       IF(ORBPOP.EQ.6)SITGRP(1:4)='C2v '
       IF(ORBPOP.EQ.4)SITGRP(1:4)='C3v '
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ELSEIF(PTGRP.EQ.'T h')THEN
       IF(ORBPOP.EQ.24)SITGRP(1:4)='C1  '
       IF(ORBPOP.Eq.12)SITGRP(1:4)='C s '
       IF(ORBPOP.EQ.8)SITGRP(1:4)='C3  '
       IF(ORBPOP.EQ.6)SITGRP(1:4)='C2v '
       IF(ORBPOP.EQ.IORGRP)SITGRP(1:4)=PTGRP
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ELSEIF(PTGRP.EQ.'O  ')THEN
       IF(ORBPOP.EQ.24)SITGRP(1:4)='C1  '
       IF(ORBPOP.Eq.12)SITGRP(1:4)='C2  '
       IF(ORBPOP.EQ.8)SITGRP(1:4)='C3  '
       IF(ORBPOP.EQ.6)SITGRP(1:4)='C4  '
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ELSEIF(PTGRP.EQ.'O h')THEN
       IF(ORBPOP.EQ.48)SITGRP(1:4)='C1  '
       IF(ORBPOP.EQ.24)SITGRP(1:4)='C s '
       IF(ORBPOP.Eq.12)SITGRP(1:4)='C2v '
       IF(ORBPOP.EQ.8)SITGRP(1:4)='C3v '
       IF(ORBPOP.EQ.6)SITGRP(1:4)='C4v '
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ELSEIF(PTGRP.EQ.'I  ')THEN
       IF(ORBPOP.EQ.60)SITGRP(1:4)='C1  '
       IF(ORBPOP.EQ.30)SITGRP(1:4)='C2  '
       IF(ORBPOP.Eq.20)SITGRP(1:4)='C3  '
       IF(ORBPOP.EQ.12)SITGRP(1:4)='C5  '
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ELSEIF(PTGRP.EQ.'I h')THEN
       IF(ORBPOP.EQ.120)SITGRP(1:4)='C1  '
       IF(ORBPOP.EQ.60)SITGRP(1:4)='C s '
       IF(ORBPOP.EQ.30)SITGRP(1:4)='C2v '
       IF(ORBPOP.Eq.20)SITGRP(1:4)='C3v '
       IF(ORBPOP.EQ.12)SITGRP(1:4)='C5v '
       IF(ORBPOP.EQ.1)SITGRP(1:4)=PTGRP
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL3C_F00_PCGTO_BLOCK
     +
     +                    ( NBATCH,NINT1D,
     +                      ATOMIC,
     +                      MIJ,MK,MIJK,
     +                      NIJ,NIJBEG,NIJEND,NK,NKBEG,NKEND,
     +                      NPGTOI,NPGTOJ,NPGTOK,
     +                      NXYZFT,NXYZQ,
     +                      SHELLA,SHELLQ,
     +                      XA,YA,ZA,XI,YI,ZI,XJ,YJ,ZJ,XK,YK,ZK,
     +                      ALPHAI,ALPHAJ,ALPHAK,
     +                      PRIMI,PRIMJ,PRIMK,
     +                      NORMI,NORMJ,NORMK,
     +                      RHOIJK,
     +                      QAX,QAY,QAZ,QINVHF,SCALE,
     +                      INT1DX,INT1DY,INT1DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL3C_F00_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__OVL_1D_INTEGRALS
C                OED__OVL_INT1D_TO_E0
C  DESCRIPTION : This operation calculates a batch of unnormed 3-center
C                overlap integrals between primitive cartesian gaussians
C                for the shell range:
C
C                              [F00]     , F = A to Q = A + B + C
C                                   ij,k
C
C                for the block of ij exponent pairs and the block
C                of k exponents. The total number of 3-center overlap
C                integrals generated here is thus given by the total
C                number of cartesian monomials NXYZFT times the total
C                number of exponents MIJK in the present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,k,nxyzft)
C
C                Note especially that the labels corresponding to the
C                cartesian monomials part refer to the A,B,C shells,
C                while the the labels corresponding to the primitives
C                and contraction indices refer to the I,J,K shells.
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    integral batch
C                    NINT1D       =  space needed for each of the 1D
C                                    X,Y,Z integral arrays
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pair I,J
C                    MK           =  current # of k exponent indices
C                                    corresponding to the contracted
C                                    shell K
C                    MIJK         =  current # of ij primitive index
C                                    pairs times current # of k
C                                    exponent indices
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair I,J
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NK           =  total # of k exponent indices
C                                    corresponding to the contracted
C                                    shell K
C                    NKBEG(END)   =  first(last) k primitive index
C                                    defining the k block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = I,J,K
C                    NXYZFT       =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    F = A,...,Q=A+B+C
C                    NXYZQ        =  # of cartesian monomials for
C                                    the Q=A+B+C shell
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A and Q=A+B+C
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,I,J,K
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = I,J,K
C                    PRIMx        =  i,j,k labels of primitives for
C                                    the respective contraction shells
C                                    x = I,J,K
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = I,J,K
C                    RHOIJK       =  the complete set of NIJ * NK
C                                    exponential prefactors between
C                                    contraction shells I,J and K
C                    QAx          =  will hold current MIJK coordinate
C                                    x=X,Y,Z differences Q-A between
C                                    centers Q and A
C                    QINVHF       =  will hold current MIJK values of
C                                    1/(2*Q), where Q are the exponent
C                                    sums for contraction shells I,J
C                                    and K
C                    SCALE        =  will hold current MIJK values of
C                                    scaling factors
C                    INT1Dx       =  will hold all current 1D integrals
C                                    for each cartesian component
C                                    (x = X,Y,Z)
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian 3-center overlap [F00]
C                                    integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     I,J,K,M,P
         INTEGER     IJ
         INTEGER     MIJ,MK,MIJK
         INTEGER     NBATCH,NINT1D
         INTEGER     NIJ,NIJBEG,NIJEND,NK,NKBEG,NKEND
         INTEGER     NPGTOI,NPGTOJ,NPGTOK
         INTEGER     NXYZFT,NXYZQ
         INTEGER     SHELLA,SHELLQ

         INTEGER     PRIMI (1:NIJ)
         INTEGER     PRIMJ (1:NIJ)
         INTEGER     PRIMK (1:NK)

         DOUBLE PRECISION  EXPI,EXPJ,EXPK
         DOUBLE PRECISION  KNORM
         DOUBLE PRECISION  QINV
         DOUBLE PRECISION  QXI,QXJ,QXK,QYI,QYJ,QYK,QZI,QZJ,QZK
         DOUBLE PRECISION  XA,YA,ZA,XI,YI,ZI,XJ,YJ,ZJ,XK,YK,ZK
         DOUBLE PRECISION  ZERO,HALF,ONE,ONEP5

         DOUBLE PRECISION  ALPHAI  (1:NPGTOI)
         DOUBLE PRECISION  ALPHAJ  (1:NPGTOJ)
         DOUBLE PRECISION  ALPHAK  (1:NPGTOK)

         DOUBLE PRECISION  NORMI   (1:NPGTOI)
         DOUBLE PRECISION  NORMJ   (1:NPGTOJ)
         DOUBLE PRECISION  NORMK   (1:NPGTOK)

         DOUBLE PRECISION  RHOIJK  (1:NIJ,1:NK)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  QAX     (1:MIJK)
         DOUBLE PRECISION  QAY     (1:MIJK)
         DOUBLE PRECISION  QAZ     (1:MIJK)
         DOUBLE PRECISION  QINVHF  (1:MIJK)
         DOUBLE PRECISION  SCALE   (1:MIJK)

         DOUBLE PRECISION  INT1DX  (1:NINT1D)
         DOUBLE PRECISION  INT1DY  (1:NINT1D)
         DOUBLE PRECISION  INT1DZ  (1:NINT1D)

         PARAMETER  (ZERO  = 0.D0)
         PARAMETER  (HALF  = 0.5D0)
         PARAMETER  (ONE   = 1.D0)
         PARAMETER  (ONEP5 = 1.5D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D overlap integrals.
C
C
         IF (ATOMIC) THEN
             M = 0
             DO 100 P = NKBEG,NKEND
                K = PRIMK (P)
                EXPK = ALPHAK (K)
                KNORM = NORMK (K)
                DO 110 IJ = NIJBEG,NIJEND
                   M = M + 1
                   I = PRIMI (IJ)
                   J = PRIMJ (IJ)
                   QINV = ONE / (ALPHAI (I) + ALPHAJ (J) + EXPK)
                   QINVHF (M) = HALF * QINV
                   SCALE  (M) = NORMI (I) * NORMJ (J) * KNORM
     +                           * (QINV ** ONEP5)
  110           CONTINUE
  100        CONTINUE
         ELSE
             M = 0
             DO 200 P = NKBEG,NKEND
                K = PRIMK (P)
                EXPK = ALPHAK (K)
                KNORM = NORMK (K)
                QXK = EXPK * XK
                QYK = EXPK * YK
                QZK = EXPK * ZK
                DO 220 IJ = NIJBEG,NIJEND
                   M = M + 1
                   I = PRIMI (IJ)
                   J = PRIMJ (IJ)
                   EXPI = ALPHAI (I)
                   EXPJ = ALPHAJ (J)
                   QXI = EXPI * XI
                   QYI = EXPI * YI
                   QZI = EXPI * ZI
                   QXJ = EXPJ * XJ
                   QYJ = EXPJ * YJ
                   QZJ = EXPJ * ZJ
                   QINV = ONE / (EXPI + EXPJ + EXPK)
                   QAX (M) = QINV * (QXI + QXJ + QXK) - XA
                   QAY (M) = QINV * (QYI + QYJ + QYK) - YA
                   QAZ (M) = QINV * (QZI + QZJ + QZK) - ZA
                   QINVHF (M) = HALF * QINV
                   SCALE  (M) = NORMI (I) * NORMJ (J) * KNORM
     +                           * RHOIJK (IJ,K) * (QINV ** ONEP5)
  220           CONTINUE
  200        CONTINUE
         END IF
C
C
C             ...perform the following steps:
C
C                1) construct all 1D x,y,z overlap integrals for
C                   all present ij,k triples.
C
C                2) assemble the complete [F00] 3-center overlap
C                   batch for all ij,k triples using the 1D integrals.
C                   Arrays QAX and QAY are passed as scratch arrays.
C                   Note, that for that purpose we can use the routine
C                   which generates the [E|0] batches for the normal
C                   2-center overlap integrals.
C
C
         CALL    OED__OVL_1D_INTEGRALS
     +
     +                ( SHELLQ,0,
     +                  ATOMIC,
     +                  MIJK,
     +                  QAX,QAY,QAZ,
     +                  QINVHF,
     +                  ZERO,ZERO,ZERO,
     +
     +                            INT1DX,
     +                            INT1DY,
     +                            INT1DZ )
     +
     +
         CALL    OED__OVL_INT1D_TO_E0
     +
     +                ( SHELLA,SHELLQ,
     +                  ATOMIC,
     +                  MIJK,
     +                  NXYZFT,NXYZQ,
     +                  INT1DX,INT1DY,INT1DZ,
     +                  QAX,QAY,
     +                  SCALE,
     +
     +                            BATCH )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine expands a packed super-matrix dA(p<q,*) to dB(pq,*).
c NOTE: dB may alias dA in which case the matrix is expanded "in place".

c CODED JG JUNE/90
c rewritten Q1 2002 ADY

c INPUT
c int irp_pq   : irrep of dA bra (pq pairs)
c int pop(*)   : p/q population vector (orbitals per irrep)
c int max_pq   : distribution size of dB (number of rows)
c int max_pltq : distribution size of dA (number of rows)
c int nCols    : distributions in dA and dB (number of columns)
c double dA(max_pltq,nCols) : source array

c OUTPUT
c double dB(max_pq,nCols) : destination array (may alias dA)

      subroutine symexp2(irp_pq,pop,max_pq,max_pltq,nCols,dB,dA)
      implicit none

c ARGUMENTS
      integer irp_pq, pop(*), max_pq, max_pltq, nCols
      double precision dA(max_pltq,nCols), dB(max_pq,nCols)

c INTERNAL VARIABLES
      integer pq
      integer p, irp_p, max_p
      integer q, irp_q, max_q
      integer off_pltq(8), off_pq(8)
      integer iCol, ndx1, ndx2
      integer iTmp

c COMMON BLOCKS
#include "syminf.com" /* for nirrep and dirprd(,) */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert irp_pq is properly bound
      if ((irp_pq.lt.1).or.(nirrep.lt.irp_pq)) then
         print *, '@SYMEXP2: Assertion failed.'
         print *, '   irp_pq = ',irp_pq
         iTmp = 1
      end if
c   o assert array dimensions are whole
      if ((max_pq.lt.0).or.(max_pltq.lt.0).or.(nCols.lt.0)) then
         print *, '@SYMEXP2: Assertion failed.'
         print *, '   max_pltq = ',max_pltq
         print *, '   max_pq   = ',max_pq
         print *, '   nCols    = ',nCols
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif

      if ((max_pq.lt.0).or.(nCols.lt.0)) return

c ----------------------------------------------------------------------

c   o expand dA into dB (backwards)
      do iCol = nCols, 1, -1
      do pq = max_pltq, 1, -1
         dB(pq,iCol) = dA(pq,iCol)
      end do
      end do

      if (irp_pq.eq.1) then

c      o fill in tables of offsets
         off_pltq(1) = 0
         off_pq(1)   = 0
         do irp_q = 1, nirrep-1
            max_q = pop(irp_q)
            off_pltq(irp_q+1) = off_pltq(irp_q) + max_q*(max_q-1)/2
            off_pq(irp_q+1)   = off_pq(irp_q)   + max_q*max_q
         end do

         do iCol = 1, nCols

            do irp_q = nirrep, 1, -1
               max_q = pop(irp_q)
            if (max_q.gt.1) then

c            o expand the upper-triangle
                  ndx1 = 1 + off_pltq(irp_q) + (max_q-1)*(max_q-2)/2
                  ndx2 = 1 + off_pq(irp_q)   + max_q*(max_q-1)
               do q = max_q-1, 1, -1
               do p = q-1, 0, -1
                  dB(ndx2+p,iCol) = dB(ndx1+p,iCol)
               end do
                  ndx1 = ndx1 - q + 1
                  ndx2 = ndx2 - max_q
               end do

c            o zero the diagonal
                  iTmp = ndx2
               do q = 1, max_q
                  dB(iTmp,iCol) = 0.d0
                  iTmp = iTmp + max_q + 1
               end do

c            o fill in the lower-triangle
               do q = 1, max_q-1
                  ndx1 = ndx2 + max_q + q - 1
               do p = q, max_q-1
                  dB(ndx2+p,iCol) = -dB(ndx1,iCol)
                  ndx1 = ndx1 + max_q
               end do
                  ndx2 = ndx2 + max_q
               end do

c           else if (max_q.lt.2) then
            else

               if (max_q.eq.1) dB(1+off_pq(irp_q),iCol) = 0.d0

c           end if (max_q.gt.1) then
            end if
c           end do irp_q = nirrep, 1, -1
            end do

c        end do iCol = 1, nCols
         end do

c     else if (irp_pq.ne.1) then
      else

c      o fill in tables of offsets
         off_pltq(1) = 0
         off_pq(1)   = 0
         do irp_q = 1, nirrep-1
            irp_p = dirprd(irp_q,irp_pq)
            if (irp_p.lt.irp_q) then
               max_p = pop(irp_p)
               max_q = pop(irp_q)
               iTmp = max_p*max_q
               off_pltq(irp_q+1) = off_pltq(irp_q) + iTmp
               off_pq(irp_q+1)   = off_pq(irp_q)   + iTmp
            else
               max_q = pop(irp_q)
               max_p = pop(irp_p)
               off_pltq(irp_q+1) = off_pltq(irp_q)
               off_pq(irp_q+1)   = off_pq(irp_q) + max_p*max_q
            end if
         end do

         do iCol = 1, nCols

c         o expand the p<q elements
            do irp_q = nirrep, 1, -1
               irp_p = dirprd(irp_q,irp_pq)
               if (irp_p.lt.irp_q) then
                  max_p = pop(irp_p)
                  max_q = pop(irp_q)
                  ndx1 = 1 + off_pltq(irp_q)
                  ndx2 = 1 + off_pq(irp_q)
                  do pq = (max_p*max_q)-1, 0, -1
                     dB(ndx2+pq,iCol) = dB(ndx1+pq,iCol)
                  end do
               end if
            end do

c         o fill in the q<p elements
            do irp_q = 1, nirrep
               irp_p = dirprd(irp_q,irp_pq)
               if (irp_q.lt.irp_p) then
                  max_q = pop(irp_q)
                  max_p = pop(irp_p)
                     ndx2 = 1 + off_pq(irp_q)
                     iTmp = 1 + off_pq(irp_p)
                  do q = 1, max_q
                     ndx1 = iTmp
                  do p = 1, max_p
                     dB(ndx2,iCol) = -dB(ndx1,iCol)
                     ndx1 = ndx1 + max_q
                     ndx2 = ndx2 + 1
                  end do
                     iTmp = iTmp + 1
                  end do
               end if
            end do

c        end do iCol = 1, nCols
         end do

c     end if (irp_pq.eq.1)
      end if

      return
c     end subroutine symexp2
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C
      Subroutine built_cmp2zmat(Natoms, Iordgp) 
C
      implicit none
      include 'machine_types.h'
C
      Character*4 CMPPGP      
      integer Natoms, Iordgp
      integer Norbits, Ncen
      integer i
      integer itype, L
      Integer NCenW1(Natoms), NCenW2(Natoms), CenMap(Natoms)
      Double precision Coord1(3, Natoms), Coord2(3, IOrdGp)

      Call GetCRec(10, 'JOBARC', 'COMPPTGP', 4, CMPPGP) 
      Call igetrec(10, 'JOBARC', 'COMPNORB', 1, NOrbits)
      if (Norbits .gt. Natoms) then
         print *,'Error: COMPPOPV has ',norbits,' entries in GETREC,',
     *     ' should be less than natoms = ',natoms
         call abort_job()
      endif
 
      Call igetrec(10 , 'JOBARC', 'COMPPOPV', NOrbits, NCenW1) 
      Call igetrec(0 , 'JOBARC', 'COMPMEMB', NCen, NCenW2) 
      if (Ncen .gt. Natoms) then
         print *,'Error: COMPMEMB has ',ncen,' entries in GETREC,',
     *     ' should be less than natoms = ',natoms
         call abort_job()
      endif

      Call igetrec(10 , 'JOBARC', 'COMPMEMB', NCen, NCenW2)
      L = 3 * NCen 
      Call dgetrec( -1, 'JOBARC', 'COORD   ', L, Coord1)
      if (CMPPGP(1:3) .eq. 'D2 ')
     *   CALL igetrec(20,'JOBARC','D2TYPXYZ',1,ITYPE)
C
      Call Remapx(CMPPGP, IORDGP, NCen, NOrbits, Coord1, Coord2,
     &           NCenW2, NCenW1, CenMap, itype)
c
      Call iputrec( 20, 'JOBARC', 'MAP2ZMAT', NCen, CenMap) 
      
      Return
      ENd

      subroutine testnuc(NUCLEI,XX)

      implicit none 
      
      integer NUCLEI,i
      integer XX(1:NUCLEI)

           do i=1,NUCLEI

           write(6,*) XX(i), i , '<<----'
      
           enddo

        return
        end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine send_static_data(need_predef, npre_defined)
c---------------------------------------------------------------------------
c   Post the mpi_isends needed to distribute the static data to each worker.
c---------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'parallel_info.h'
      include 'proto_events.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer npre_defined
      logical need_predef(npre_defined)

      double precision dbuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
#else
      common dbuf
#endif
      integer master, pst_get_master, pst_get_company
      integer i
      integer mpierr
      
#ifdef ALTIX
      dptr = dshptr
#endif
      master = pst_get_master()
      if (me .eq. master) then

c--------------------------------------------------------------------------
c   Check that the io_company_id is different from the company id.
c--------------------------------------------------------------------------

         do i = 1, nprocs
            scfa_req(i) = mpi_request_null
            scfb_req(i) = mpi_request_null
            epsa_req(i) = mpi_request_null
            epsb_req(i) = mpi_request_null
            focka_req(i) = mpi_request_null
            fockb_req(i) = mpi_request_null
            if (pst_get_company(i-1) .ne. io_company_id) then 
               if (need_predef(1) .or.
     *             need_predef(2)) 
     *            call mpi_isend(dbuf(iscfa), nscfa,
     *                           mpi_double_precision, i-1,
     *                           scfa_coeff_request_event,
     *                           mpi_comm_world, scfa_req(i), mpierr)

               if (need_predef(3))
     *            call  mpi_isend(dbuf(iscfb), nscfb,
     *                           mpi_double_precision, i-1,
     *                           scfb_coeff_request_event,
     *                           mpi_comm_world, scfb_req(i), mpierr)

               if (iuhf .eq. 2) then
                  if (need_predef(9))
     *               call mpi_isend(dbuf(ifockrohfa), nscfa,
     *                           mpi_double_precision, i-1,
     *                           focka_coeff_request_event,
     *                           mpi_comm_world, focka_req(i), mpierr)
              
                  if (need_predef(10))
     *               call  mpi_isend(dbuf(ifockrohfb), nscfb,
     *                           mpi_double_precision, i-1,
     *                           fockb_coeff_request_event,
     *                           mpi_comm_world, fockb_req(i), mpierr)
               endif

               call  mpi_isend(dbuf(iepsa), nepsa,
     *                           mpi_double_precision, i-1,
     *                           epsa_coeff_request_event,
     *                           mpi_comm_world, epsa_req(i), mpierr)
               if (nepsb .gt. 0)
     *            call  mpi_isend(dbuf(iepsb), nepsb,
     *                           mpi_double_precision, i-1,
     *                           epsb_coeff_request_event,
     *                           mpi_comm_world, epsb_req(i), mpierr)
            endif
         enddo
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine move_integrals(v, va1,va2,vb1,vb2,vc1,vc2,vd1,vd2,
     *                          intblk, a1, a2, b1, b2, c1, c2, d1, d2)
      implicit none
      integer va1, va2, vb1,vb2, vc1, vc2, vd1, vd2
      integer a1, a2, b1, b2, c1, c2, d1, d2
      integer a,b,c,d
      integer drange1, drange2
      integer crange1, crange2
      integer brange1, brange2
      integer arange1, arange2

      double precision v(va1:va2,vb1:vb2,vc1:vc2,vd1:vd2)
      double precision intblk(a1:a2,b1:b2,c1:c2,d1:d2)

      drange1 = max(vd1, d1)
      drange2 = min(vd2, d2)
      crange1 = max(vc1, c1)
      crange2 = min(vc2, c2)
      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

         do d = drange1, drange2
         do c = crange1, crange2
         do b = brange1, brange2
         do a = arange1, arange2
            v(a,b,c,d) = intblk(a,b,c,d)
         enddo
         enddo
         enddo
         enddo

      return
      end


      subroutine add_integrals(v, va1,va2,vb1,vb2,vc1,vc2,vd1,vd2,
     *                 intblk, a1, a2, b1, b2, c1, c2, d1, d2, fact)
      implicit none
      integer va1, va2, vb1,vb2, vc1, vc2, vd1, vd2
      integer a1, a2, b1, b2, c1, c2, d1, d2
      integer a,b,c,d
      integer drange1, drange2
      integer crange1, crange2
      integer brange1, brange2
      integer arange1, arange2

      double precision v(va1:va2,vb1:vb2,vc1:vc2,vd1:vd2)
      double precision intblk(a1:a2,b1:b2,c1:c2,d1:d2), fact 

      drange1 = max(vd1, d1)
      drange2 = min(vd2, d2)
      crange1 = max(vc1, c1)
      crange2 = min(vc2, c2)
      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

         do d = drange1, drange2
         do c = crange1, crange2
         do b = brange1, brange2
         do a = arange1, arange2
            v(a,b,c,d) = intblk(a,b,c,d) + v(a,b,c,d)*fact 
         enddo
         enddo
         enddo
         enddo

      return
      end



      subroutine move_integrals2(v, va1,va2,vb1,vb2,
     *                          intblk, a1, a2, b1, b2)
c---------------------------------------------------------------------------
c   Moves a 2-dimensional tile of integrals into a larger 2-dimensional
c   block, adjusting for ERD-to-VMOL indexing and scaling at the same time.
c---------------------------------------------------------------------------
      implicit none
      integer va1, va2, vb1,vb2
      integer a1, a2, b1, b2
      integer a,b
      integer brange1, brange2
      integer arange1, arange2

      double precision v(va1:va2,vb1:vb2)
      double precision intblk(a1:a2,b1:b2)
      double precision sum

      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

         do b = brange1, brange2
         do a = arange1, arange2
            v(a,b) = intblk(a,b)
         enddo
         enddo

      return
      end


      subroutine move_integrals2_scale(v, va1,va2,vb1,vb2,
     *                          intblk, a1, a2, b1, b2, 
     *                          erdind, scale)
c---------------------------------------------------------------------------
c   Moves a 2-dimensional tile of integrals into a larger 2-dimensional
c   block, adjusting for ERD-to-VMOL indexing and scaling at the same time.
c---------------------------------------------------------------------------
      implicit none
      integer va1, va2, vb1,vb2
      integer a1, a2, b1, b2
      integer erdind(*)
      double precision scale(*)
      integer a,b, aa, bb
      integer brange1, brange2
      integer arange1, arange2

      double precision v(va1:va2,vb1:vb2)
      double precision intblk(a1:a2,b1:b2)

      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

         do b = b1, b2
            bb = erdind(b)
         do a = a1, a2
            aa = erdind(a)
            if (aa .ge. va1 .and. aa .le. va2 .and.
     *          bb .ge. vb1 .and. bb .le. vb2) then
               v(aa,bb) = intblk(a,b)*scale(a)*scale(b)
            else
               print *,'a,b,aa,bb ',a,b,aa,bb,' out of range ',
     *               va1,va2,vb1,vb2
               call abort_job()
            endif
         enddo
         enddo

      return
      end



      subroutine add_integrals2(v, va1,va2,vb1,vb2,
     *                          intblk, a1, a2, b1, b2, fact)
c---------------------------------------------------------------------------
c   Moves a 2-dimensional tile of integrals into a larger 2-dimensional
c   block, adjusting for ERD-to-VMOL indexing and scaling at the same time.
c---------------------------------------------------------------------------
      implicit none
      integer va1, va2, vb1,vb2
      integer a1, a2, b1, b2
      integer a,b
      integer brange1, brange2
      integer arange1, arange2

      double precision v(va1:va2,vb1:vb2)
      double precision intblk(a1:a2,b1:b2)
      double precision fact, temp  

      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

      if ((va1 .gt. a1) .or. (va2. lt. a2) .or. 
     *    (vb1 .gt. b1) .or. (vb2. lt. b2)) then 
         write(6,*) ' Error in add_integrals2: indices mismatch ' 
         write(6,*) va1, va2, vb1, vb2   
         write(6,*) a1, a2, b1, b2   
      endif 

      do b = brange1, brange2
      do a = arange1, arange2
         v(a,b) = v(a,b)*fact + intblk(a,b) 
      enddo
      enddo

      return
      end

      subroutine move_OVL3C(v, va1,va2,vb1,vb2,vc1,vc2,intblk,
     *                      a1, a2, b1, b2, c1, c2)
      implicit none
      integer va1, va2, vb1,vb2, vc1, vc2
      integer a1, a2, b1, b2, c1, c2
      integer a,b,c
      integer crange1, crange2
      integer brange1, brange2
      integer arange1, arange2

      double precision      v(va1:va2,vb1:vb2,vc1:vc2)
      double precision intblk(a1:a2,b1:b2,c1:c2)

      crange1 = max(vc1, c1)
      crange2 = min(vc2, c2)
      brange1 = max(vb1, b1)
      brange2 = min(vb2, b2)
      arange1 = max(va1, a1)
      arange2 = min(va2, a2)

         do c = crange1, crange2
         do b = brange1, brange2
         do a = arange1, arange2
            v(a,b,c) = intblk(a,b,c)
         enddo
         enddo
         enddo

      return
      end

c This transforms a square block of a matrix
      subroutine mat_trans_sqr_sqr(in,out,inlen,outlen,inoff,outoff)
#include <aces.h>
      implicit none
#include <callstack.com>
      integer inoff,outoff,inlen,outlen
      M_REAL in(inlen,inlen),out(outlen,outlen)

      integer len,i

      callstack_curr='MAT_TRANS_SQR_SQR'
      len=min(inlen,outlen)
      do i=1,len
        call B_COPY(len,in(inoff,inoff+i-1),1,out(outoff,outoff+i-1),1)
      enddo
      return
      end

c This transforms a square block of a matrix
      subroutine mat_trans_sqr_sqr(in,out,inlen,outlen,inoff,outoff)


















c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler


























cYAU - ACES3 stuff . . . we hope - #include <aces.par>




      implicit none


c This contains the global string for identifying the current subroutine
c or function (provided the programmer set it).  cf. tools/callstack.F
c BE GOOD AND RESET CURR ON EXIT!

      character*64                callstack_curr,callstack_prev
      common /callstack_curr_com/ callstack_curr,callstack_prev
      save   /callstack_curr_com/


      integer inoff,outoff,inlen,outlen
      double precision in(inlen,inlen),out(outlen,outlen)

      integer len,i

      callstack_curr='MAT_TRANS_SQR_SQR'
      len=min(inlen,outlen)
      do i=1,len
        call dcopy(len,in(inoff,inoff+i-1),1,out(outoff,outoff+i-1),1)
      enddo
      return
      end

      Subroutine Screen_ang_typ2(L, M, Nx, Ny, NZ, Lam, Mu, SKIP)

      Implicit Double Precision (A-H, O-Z)
      Logical Skip

#include "ecp.par"
#include "ecp.com"

      Id = L*(L+1) - M + 1

      IMn = Lmf(Id)
      Imx = Lmf(Id+1) - 1

      JD = Lam*(Lam+1) - Mu + 1

      JMn = Lmf(Jd)
      Jmx = Lmf(Jd+1) - 1
  
      Skip = .False.

      If (Mod(Nx+1 + Lmx(Imn) + Lmx(Jmn), 2) .NE. 1 .OR.
     &    Mod(Ny+1 + Lmy(Imn) + Lmy(Jmn), 2) .NE. 1 .OR.
     &    Mod(Nz+1 + Lmz(Imn) + Lmz(Jmn), 2) .NE. 1)
     &    Skip = .TRUE.

#ifdef _DEBUG_LVLM1
      Write(6,*) NX+1, Lmx(Imn), Lmx(Jmn)
      Write(6,*) Ny+1, Lmy(Imn), Lmy(Jmn)
      Write(6,*) Nz+1, Lmz(Imn), Lmz(Jmn)
      Write(6, "(a,1x,l)") "@-Screen_ang_typ2, Skip: ", Skip
#endif 
      Return
      End

c
c MIMICS:
c    dy(i) += (factor*da)*dx(i)
c OUTPUT:
c    label(start+(i*step)) += factor * da * dx(1+(i*incx))
c
      subroutine daxpy_prt(n,da,dx,incx,dy,incy,
     &                     label,start,step,factor)
      double precision dx(*),dy(*),da
      integer i,incx,incy,n
      character*(*) label
      integer start, step
      double precision factor
      if (n.le.0) return
      if (da.eq.(0.0d0)) return
      do i = 0,(n-1)
         print '(A,A,I3,3(A,F10.6))',
     &      label,'(',start+(i*step),') += ',
     &      factor,' * ',da,' * ',dx(1+(i*incx))
      end do
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine prequest_copy_slice(node, source, target,
     *                server_table, nserver_table)
c-------------------------------------------------------------------------
c   Copies a slice of data from "source" to "target" based on description
c   of data contained in a message node of the server.
c-------------------------------------------------------------------------
      implicit none
      include 'server.h'

      integer i, node
      integer nserver_table
      integer server_table(*)
      double precision source(*), target(*)
 
      integer nind
      integer bsrc(mx_array_index), esrc(mx_array_index)
      integer btar(mx_array_index), etar(mx_array_index)

c-------------------------------------------------------------------------
c   Determine the number of indices.
c-------------------------------------------------------------------------

      nind = server_msg(c_msg_nind,node)
    
c--------------------------------------------------------------------------
c   Gather the source and target segment ranges.
c--------------------------------------------------------------------------

      do i = 1, nind
         bsrc(i) = server_msg(c_msg_bsegs2+i-1,node) 
         esrc(i) = server_msg(c_msg_esegs2+i-1,node) 
         btar(i) = server_msg(c_msg_bsegs+i-1,node) 
         etar(i) = server_msg(c_msg_esegs+i-1,node) 
      enddo
      
c---------------------------------------------------------------------------
c   Call the appropriate routine to handle the copy.
c---------------------------------------------------------------------------

      if (nind .eq. 1) then
         call preq_copy1(source, bsrc(1), esrc(1),
     *                   target, btar(1), etar(1))  
      else if (nind .eq. 2) then
         call preq_copy2(source, bsrc(1), esrc(1), bsrc(2), esrc(2),
     *                   target, btar(1), etar(1), btar(2), etar(2))
      else if (nind .eq. 3) then
         call preq_copy3(source, bsrc(1), esrc(1), bsrc(2), esrc(2),
     *                           bsrc(3), esrc(3),
     *                   target, btar(1), etar(1), btar(2), etar(2),
     *                           btar(3), etar(3))
      else if (nind .eq. 4) then
         call preq_copy4(source, bsrc(1), esrc(1), bsrc(2), esrc(2),
     *                           bsrc(3), esrc(3), bsrc(4), esrc(4),
     *                   target, btar(1), etar(1), btar(2), etar(2),
     *                           btar(3), etar(3),  btar(4), etar(4))
      else if (nind .eq. 5) then
         call preq_copy5(source, bsrc(1), esrc(1), bsrc(2), esrc(2),
     *                           bsrc(3), esrc(3), bsrc(4), esrc(4),
     *                           bsrc(5), esrc(5),
     *                   target, btar(1), etar(1), btar(2), etar(2),
     *                           btar(3), etar(3), btar(4), etar(4),
     *                           btar(5), etar(5))
      else if (nind .eq. 6) then
         call preq_copy6(source, bsrc(1), esrc(1), bsrc(2), esrc(2),
     *                           bsrc(3), esrc(3), bsrc(4), esrc(4),
     *                           bsrc(5), esrc(5), bsrc(6), esrc(6),
     *                   target, btar(1), etar(1), btar(2), etar(2),
     *                           btar(3), etar(3), btar(4), etar(4),
     *                           btar(5), etar(5), btar(6), etar(6))
      else
         print *,'Error: PREQUEST can only handle up to 6 indices.'
         call server_abort_job(server_table, nserver_table)
      endif
      return
      end

      subroutine preq_copy1(x, a1, a2, y, i1, i2)
      implicit none
      integer a1, a2, i1, i2
      double precision x(a1:a2)
      double precision y(i1:i2)

      integer a, i

      do i = i1, i2
         y(i) = x(i)
      enddo
     
      return
      end

      subroutine preq_copy2(x, a1, a2, b1, b2, 
     *                      y, i1, i2, j1, j2)
      implicit none
      integer a1, a2, b1, b2,
     *        i1, i2, j1, j2
      double precision x(a1:a2,b1:b2)
      double precision y(i1:i2,j1:j2)

      integer a, b, i, j

      do j = j1, j2
      do i = i1, i2
         y(i,j) = x(i,j)
      enddo
      enddo

      return
      end

      subroutine preq_copy3(x, a1, a2, b1, b2, c1, c2,
     *                      y, i1, i2, j1, j2, k1, k2)
      implicit none
      integer a1, a2, b1, b2, c1, c2,
     *        i1, i2, j1, j2, k1, k2
      double precision x(a1:a2,b1:b2,c1:c2)
      double precision y(i1:i2,j1:j2,k1:k2)

      integer a, b, c, i, j, k

      do k = k1, k2
      do j = j1, j2
      do i = i1, i2
         y(i,j,k) = x(i,j,k)
      enddo
      enddo
      enddo

      return
      end

      subroutine preq_copy4(x, a1, a2, b1, b2, c1, c2, d1, d2,
     *                      y, i1, i2, j1, j2, k1, k2, l1, l2)
      implicit none
      integer a1, a2, b1, b2, c1, c2, d1, d2,
     *        i1, i2, j1, j2, k1, k2, l1, l2
      double precision x(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision y(i1:i2,j1:j2,k1:k2,l1:l2)

      integer a, b, c, d, i, j, k, l

      do l = l1, l2
      do k = k1, k2
      do j = j1, j2
      do i = i1, i2
         y(i,j,k,l) = x(i,j,k,l)
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine preq_copy5(x, a1, a2, b1, b2, c1, c2, d1, d2, e1, e2,
     *                      y, i1, i2, j1, j2, k1, k2, l1, l2, m1, m2)
      implicit none
      integer a1, a2, b1, b2, c1, c2, d1, d2, e1, e2,
     *        i1, i2, j1, j2, k1, k2, l1, l2, m1, m2
      double precision x(a1:a2,b1:b2,c1:c2,d1:d2,e1:e2)
      double precision y(i1:i2,j1:j2,k1:k2,l1:l2,m1:m2)

      integer a, b, c, d, e, i, j, k, l, m

      do m = m1, m2
      do l = l1, l2
      do k = k1, k2
      do j = j1, j2
      do i = i1, i2
         y(i,j,k,l,m) = x(i,j,k,l,m)
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine preq_copy6(x, a1, a2, b1, b2, c1, c2, d1, d2, e1, e2,
     *                         f1, f2,
     *                      y, i1, i2, j1, j2, k1, k2, l1, l2, m1, m2,
     *                         n1, n2)
      implicit none
      integer a1, a2, b1, b2, c1, c2, d1, d2, e1, e2, f1, f2,
     *        i1, i2, j1, j2, k1, k2, l1, l2, m1, m2, n1, n2
      double precision x(a1:a2,b1:b2,c1:c2,d1:d2,e1:e2,f1:f2)
      double precision y(i1:i2,j1:j2,k1:k2,l1:l2,m1:m2,n1:n2)

      integer a, b, c, d, e, f, i, j, k, l, m, n

      do n = n1, n2
      do m = m1, m2
      do l = l1, l2
      do k = k1, k2
      do j = j1, j2
      do i = i1, i2
         y(i,j,k,l,m,n) = x(i,j,k,l,m,n)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE COMPARE(Q1,Q2,ATMASS,IMAP,NATOM,IERR,TOL)
C
C THIS ROUTINE CHECKS WHETHER COORDINATE VECTORS Q1 AND
C Q2 ARE RELATED BY A SIMPLE PERMUTATION.  IF THEY ARE,
C IERR IS RETURNED AS "0", AND IMAP CONTAINS THE PERMUTATION
C VECTOR
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL IMATCH
      DIMENSION Q1(3*NATOM),Q2(3*NATOM),ATMASS(NATOM),IMAP(NATOM)
      DIMENSION TMP(3)
C
      DATA ZILCH / 0.0/
      DATA ONEM  /-1.0/ 
C
      IERR=0
      IOFF1=1
c      CALL IZERO(IMAP,NATOM)
      do i = 1, natom
         imap(i) = 0
      enddo

      DO 10 IATOM1=1,NATOM
       IF(ATMASS(IATOM1).NE.ZILCH)THEN
        IOFF2=1
        IMATCH=.FALSE.
        DO 20 IATOM2=1,NATOM
         IF(ATMASS(IATOM2).EQ.ATMASS(IATOM1))THEN
          CALL VADD(TMP,Q1(IOFF1),Q2(IOFF2),3,ONEM)
          I=ISAMAX(3,TMP,1)
          IF(ABS(TMP(I)).LT.TOL)THEN
           IMAP(IATOM1)=IATOM2
           IMATCH=.TRUE.
          ENDIF
         ENDIF
         IOFF2=IOFF2+3
20      CONTINUE
        IF(.NOT.IMATCH)IERR=IERR+1
       ENDIF
       IOFF1=IOFF1+3
10    CONTINUE
C
      RETURN
      END

c This routine takes one or two arrays of a given length, and
c returns a value depending on the values of op and neg.
c
c   op  neg   val
c    0    0   max( abs(a(i)-b(i)),           i=1,length )
c    0    1   max( a(i)-b(i),                i=1,length )
c    0   -1   max( b(i)-a(i),                i=1,length )
c    0    2   max( abs(abs(a(i))-abs(b(i))), i=1,length )
c    1    0   max( abs(a(i)),                i=1,length )
c    1    1   max( a(i),                     i=1,length )
c   -1    0   min( abs(a(i)),                i=1,length )
c   -1    1   min( a(i),                     i=1,length )
c
c When op!=0, the matrix b is ignored.

      subroutine mat_minmax(op,neg,val,length,a,b)
      implicit none

      integer op,neg,length
      double precision a(*),b(*),val

      integer i

      if (op.eq.0) then
         if (neg.eq.0) then
            val=abs(a(1)-b(1))
            do i=2,length
               val=max(val,abs(a(i)-b(i)))
            end do
         else if (neg.eq.1) then
            val=a(1)-b(1)
            do i=2,length
               val=max(val,a(i)-b(i))
            end do
         else if (neg.eq.-1) then
            val=b(1)-a(1)
            do i=2,length
               val=max(val,b(i)-a(i))
            end do
         else if (neg.eq.2) then
            val=abs(abs(a(1))-abs(b(1)))
            do i=2,length
               val=max(val,abs(abs(a(i))-abs(b(i))))
            end do
         else
            write(*,*) '@MAT_MINMAX: invalid value of neg'
            stop
         end if

      else if (op.eq.1) then
         if (neg.eq.0) then
            val=abs(a(1))
            do i=2,length
               val=max(val,abs(a(i)))
            end do
         else if (neg.eq.1) then
            val=a(1)
            do i=2,length
               val=max(val,a(i))
            end do
         else
            write(*,*) '@MAT_MINMAX: invalid value of neg'
            stop
         end if

      else if (op.eq.-1) then
         if (neg.eq.0) then
            val=abs(a(1))
            do i=2,length
               val=min(val,abs(a(i)))
            end do
         else if (neg.eq.1) then
            val=a(1)
            do i=2,length
               val=min(val,a(i))
            end do
         else
            write(*,*) '@MAT_MINMAX: invalid value of neg'
            stop
         end if

      else
         write(*,*) '@MAT_MINMAX: invalid value of op'
         stop
      end if

      return
      end

      SUBROUTINE SYMTR3(IRREP,NUM1,NUM2,DIS,NUM,A,SCR1,SCR2,ISCR)
C
C THIS ROUTINE TRNSPOSES THE FIRT TWO INDICES OF A GIVEN MATRIX A
C
C  A(I,J,K,L) ----> A(J,I,K,L) 
C
C NOTE THAT THIS TRANSPOSITION IS CARRIED OUT HERE IN PLACE AND
C ONLY THREE ADDITIONAL ARRAYS OF SIZE NUM ARE REQUIRED
C
C INPUT : IRREP .......... IRREP OF THE GIVEN PAR OF A
C         NUM1 ........... POPULATION VECTOR OF I
C         NUM2 ........... POPULATION VECTOR OF J
C         DIS ............ DISTRIBUTION SIZE OF A
C         NUM ............ NUMBER OF DISTRIBUTIONS IN A
C         A .............. INPUT MATRIX A
C         SCR1,SCR2 ...... TWO SCRATCH ARRAYS OF DIMENSION NUM
C         ISCR ........... INTEGER SCRATCH ARRAY OF DIMENSION DIS
C
C  OUTPUT : A ............ TRANSPOSED MATRIX A
C 
CEND
C
C CODED JULY/90  JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL ICONT
      INTEGER DIS,DIRPRD
      DIMENSION A(DIS,NUM),SCR1(1),SCR2(1),ISCR(2),NUM1(8),NUM2(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      DIMENSION IPI(8),IPJ(8)
C
      IPI(1)=0
      IPJ(1)=0          
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IPJ(IRREPJ+1)=IPJ(IRREPJ)+NUM2(IRREPJ)*NUM1(IRREPI)
       IPI(IRREPJ+1)=IPI(IRREPJ)+NUM1(IRREPJ)*NUM2(IRREPI)
10    CONTINUE
       
C
C  GET FIRST THE NEW ADDRESSES AND STORE THEM IN ISCR
C
      NTOTAL=0
      DO 20  IRREPJ=1,NIRREP
       NUMJ=NUM2(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUM1(IRREPI)
        NTOTAL=NTOTAL+NUMI*NUMJ
        DO 15 J=1,NUMJ
        DO 15 I=1,NUMI
         IND1=IPJ(IRREPJ)+(J-1)*NUMI+I
         IND2=IPI(IRREPI)+(I-1)*NUMJ+J
         ISCR(IND1)=IND2
15      CONTINUE
20      CONTINUE
C
C  NOW TRANSPOSE
C
      DO 100 IJ=1,NTOTAL
       IF(ISCR(IJ).EQ.0) GO TO 100
       INDNEW2=IJ
       DO 2 L=1,NUM
        SCR1(L)=A(IJ,L)    
2      CONTINUE
1      CONTINUE
       INDOLD1=INDNEW2
       INDNEW1=ISCR(INDOLD1) 
       ISCR(INDOLD1)=0
       ICONT=.FALSE.  
       IF(ISCR(INDNEW1).NE.0) THEN
        DO 3 L=1,NUM
         SCR2(L)=A(INDNEW1,L)
3       CONTINUE
        ICONT=.TRUE.
       ENDIF
       DO 4 L=1,NUM
        A(INDNEW1,L)=SCR1(L)
4      CONTINUE
       IF(.NOT.ICONT) GO TO 100
       INDOLD2=INDNEW1
       INDNEW2=ISCR(INDOLD2)
       ISCR(INDOLD2)=0
       ICONT=.FALSE. 
       IF(ISCR(INDNEW2).NE.0) THEN
        DO 5 L=1,NUM
         SCR1(L)=A(INDNEW2,L)
5       CONTINUE
        ICONT=.TRUE.
       ENDIF
       DO 6 L=1,NUM
        A(INDNEW2,L)=SCR2(L)
6      CONTINUE
       IF(ICONT) GO TO 1
100   CONTINUE
      RETURN
      END

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It performs calculation of a batch of F12-related integrals  |     
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|
      subroutine f12_c_coef(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)


c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'F12.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

c---------------Variables--------------------------------------------

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array
      integer op(loptable_entry),sind
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block

      integer array_type, nindex, inda(2), indb(2)

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, farray, indblk, get_block_index
      integer*8 integral_scr
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack

      double precision x(1),int_type_p
      double precision dbuf(1), temp
      integer ibuf(1)
      integer int_type
c----------------------------------------------------------------------
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      array = op(c_result_array)
      direct_flag = .false.

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c-------------------------------------------------------------------
        
c-------------------------------------------------------------------

c--------------------------------------------------------------------
c  At this step we create array aoint if it was not created before  |
c--------------------------------------------------------------------

      call create_current_block(array,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., direct_flag, blk, ierr)
      blkndx = ierr



      call get_block_computed_flag(array, blk, blkndx, flag)
      if (flag .eq. 0) then
         call set_opblock(array, blk, blkndx, op)
         call set_block_computed_flag(array, blk, blkndx, 1)
      endif

      stack = array_table(c_array_stack,array)
      indblk = get_block_index(array, blk, stack,
     *                         blkndx, x, .true.)

c--------------------------------------------------------------------------
c   Get the segment ranges for each index of the integral array.
c--------------------------------------------------------------------------

      block = find_current_block(array, array_table(1,array),
     *                          index_table, nindex_table,
     *                          segment_table, nsegment_table,
     *                          block_map_table, blkndx)

      stack = array_table(c_array_stack, array)
      indblk = get_block_data_index(array, block, stack,
     *                              blkndx, x)




c---------------------------------------------------------------------------
c--------------------------------------------------------------------------
c   Get the segment ranges for each index of the integral array.
c--------------------------------------------------------------------------

      nind = array_table(c_nindex,array)
      if (nind .ne. 4) then
         print *,'Error: local_integral_block was called with array ',
     *        array,' which has ',nind,' indices.'
         print *,'       This routine requires 4 indices.'
         call abort_job()
      endif

      do i = 1, nind
         ind = array_table(c_index_array1+i-1,array)
         seg = index_table(c_current_seg,ind)
         call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c------------Information about scalar--------------------------------------

      array = op(c_op1_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The Second argument in get_ijk  
     *            must be a scalar.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in get_ijk, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

       scalar_table(sind) = F12GAMMA
c      int_type_p = scalar_table(sind)
c      int_type= int_type_p

c---------------------------------------------------------------------------
c   Compute the block of integrals.
c---------------------------------------------------------------------------

         if (intpkg .eq. flocke_package) then
            integral_scr = dpkgscr
            maxblk  = zmax
         else if (intpkg .eq. gamess_package .or.
     *            intpkg .eq. gamess_derivative_package) then
            integral_scr = i0wrk
            maxblk = 15**4    ! max. angular momentum for GAMESS is 15.
         endif

c           write(6,*) val1(1),val2(1),'<----'
c           write(6,*) val1(2),val2(2),'<----'
c           write(6,*) val1(3),val2(3),'<----'
c           write(6,*) val1(4),val2(4),'<----'

c           write(6,*) 'Exponential parameter',F12GAMMA

      if (.not. dryrun) then 

            call do_c_coef(val1(1),val2(1), val1(2),val2(2),
     &                     val1(3),val2(3),val1(4),val2(4), 
     &                     x(indblk) )
            
       endif

       return
       end
c-------------------------------------------------------------------------------------
c-------------------------------------------------------------------------------------
       subroutine do_c_coef(a1,a2,b1,b2,c1,c2,d1,d2,C_coef)

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'F12.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2
      double precision C_coef(a1:a2,b1:b2,c1:c2,d1:d2)
      integer i,j,k,l

       do i=a1,a2
        do j=b1,b2
         do k=c1,c2
          do l=d1,d2   
          C_coef(i,j,k,l)=0.d0
       if(i.eq.j.and.i.eq.k.and.i.eq.l) C_coef(i,j,k,l)=-0.5d0/F12GAMMA
          if(k.ne.i) then
       if(i.eq.j.and.k.eq.l) C_coef(i,j,k,l)=-(3.d0/8.d0)/F12GAMMA
       if(i.eq.l.and.k.eq.j) C_coef(i,j,k,l)=-(1.d0/8.d0)/F12GAMMA
           endif
          enddo
         enddo
        enddo
       enddo


      return
      end

C THIS ROUTINE DETERMINES WHICH GRADIENTS ARE CALCULATED TO
C EVALUATE THE FORCE CONSTANT MATRIX
C AND GENERATES THE APPROPRIATE *CARTESIAN* GEOMETRIES

c INPUT
c integer NATOM              : NUMBER OF ATOMS IN THE MOLECULE (WITH DUMMIES)
c integer NDIM               : NUMBER OF COORDINATES IN THIS IRREP
c double  SYMQ(3*NATOM,NDIM) : SYMMETRY ADAPTED COORDINATES FOR THIS IRREP
c double  COORD(3*NATOM)     : CARTESIAN COORDINATES OF THE REFERENCE STRUCTURE
c double  STPSIZ             : STEP SIZE FOR DISPLACEMENTS IN MASS-WEIGHTED
c                              CARTESIAN COORDINATES
c double  VMASS(NATOM)       : INVERSE SQUARE ROOTS OF THE ATOMIC MASSES
c integer INVOP(NDIM)
c logical PRINTQ             : VERBOSE PRINTING FLAG
c integer NDSCR              : AMOUNT OF DOUBLE SCRATCH AT DSCR

c OUTPUT
c double  POINTS(3*NATOM,*) : COORDINATES USED IN FD GRADIENT CALCULATIONS
c integer NPOINT            : NUMBER OF GRADIENT CALCS REQ'D FOR THIS IRREP
c double  DSCR(NDSCR)       : (scr) double scratch

      SUBROUTINE DOGRAD(NATOM,NDIM,SYMQ,COORD,STPSIZ,VMASS,
     &                  POINTS,NPOINT,
     &                  INVOP,PRINTQ,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SYMQ(3*NATOM,NDIM),COORD(3*NATOM),VMASS(NATOM)
      DIMENSION POINTS(*),INVOP(NDIM),DSCR(NDSCR)
      LOGICAL PRINTQ

      LOGICAL ONEGRD
      CHARACTER*5 PHASE

      NSIZE=3*NATOM

      if (ndscr.lt.nsize) then
         print *, '@DOGRAD: Insufficient memory.'
         print *, '         have ',ndscr,' doubles'
         print *, '         need ',nsize,' doubles'
         call aces_exit(1)
      end if

      IOFFP=1
      NPOINT=0

c   o loop over dimensionality of subspace
      DO IDIM=1,NDIM
         ONEGRD=(INVOP(IDIM).GT.0)

c      o scale symmetry coordinate vector
         CALL DCOPY(NSIZE,SYMQ(1,IDIM),1,DSCR,1)
         CALL DSCAL(NSIZE,STPSIZ,DSCR,1)

c      o transform from mass-weighted cartesians to pure cartesians
         NDX = 1
         DO IATOM=1,NATOM
            DSCR(NDX+0) = DSCR(NDX+0)*VMASS(IATOM)
            DSCR(NDX+1) = DSCR(NDX+1)*VMASS(IATOM)
            DSCR(NDX+2) = DSCR(NDX+2)*VMASS(IATOM)
            NDX = NDX+3
         END DO

c      o generate positive displacement
         CALL VADD(POINTS(IOFFP),COORD,DSCR,NSIZE,1.d0)
         IOFFP=IOFFP+NSIZE
         NPOINT=NPOINT+1

c      o generate negative displacement (totally symmetric irrep only)
         IF (.NOT.ONEGRD) THEN
            CALL VADD(POINTS(IOFFP),COORD,DSCR,NSIZE,-1.d0)
            IOFFP=IOFFP+NSIZE
            NPOINT=NPOINT+1
         END IF

      END DO

      IF (PRINTQ) THEN
         IOFF=1
         DO IPOINT=1,NPOINT
            IF (.NOT.ONEGRD.AND.MOD(IPOINT,2).EQ.0) THEN
               PHASE='minus'
               ISYCOR=1+(IPOINT-1)/2
            ELSE IF (.NOT.ONEGRD.AND.MOD(IPOINT,2).EQ.1) THEN
               ISYCOR=(IPOINT+1)/2
               PHASE='plus '
            ELSE IF (ONEGRD) THEN
               ISYCOR=IPOINT
               PHASE='plus'
            END IF
            WRITE(6,1001)ISYCOR,PHASE
1001        FORMAT(T3,'Symmetry coordinate : ',i3,' Phase : ',a,
     &             ' Type : Gradient')
            DO IATOM=1,NATOM
               WRITE(6,1002)IATOM,(POINTS(IPOS),IPOS=IOFF,IOFF+2)
1002           FORMAT(T3,I5,3F20.10)
               IOFF=IOFF+3
            END DO
         END DO
      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine build_segment_table(index_table, nindex_table, 
     *                        end_nfps, nshells, mx_ao_seg_size,
     *                        mx_occ_seg_size, mx_virt_seg_size,
     *                        sip_sub_segsize, sip_sub_occ_segsize,
     *                        sip_sub_virt_segsize, sip_sub_ao_segsize,
     *                        nocc_orbitals, naocc_orbitals,
     *                        nbocc_orbitals, 
     *                        nvirt_orbitals, navirt_orbitals,
     *                        nbvirt_orbitals, 
     *                        isegbase, nsegment_table,
     *                        stack_blocksizes, nstacks,
     *                        array_table, narray_table, 
     *                        atom_based, atoms)
c--------------------------------------------------------------------------
c   Builds the segment table from the indices defined in the index_table 
c   and the basis function shell definitions.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'machine_types.h'
      include 'symbolic_constants.h'
c      include 'int_gen_parms.h'
      include 'frag_def.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      
      integer nindex_table, nshells, nsegment_table
      integer nocc_orbitals, naocc_orbitals, nbocc_orbitals
      integer nvirt_orbitals, navirt_orbitals, nbvirt_orbitals 
      integer index_table(lindex_table_entry,nindex_table)
      integer end_nfps(nshells)
      integer*8 isegbase
      integer*8 c_loc64
      integer nstacks
      integer stack_blocksizes(nstacks)
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer atoms(nshells)
      integer nfocc, nfvirt  
      integer nafocc, nafvirt  
      integer nbfocc, nbfvirt

      integer segtable(2)
#ifdef ALTIX
      pointer (iptr, segtable)
#endif
      integer naosegs
      integer aosegs(nshells)
      integer norbitals, nsegs, i, j, k, l, type, size, next
      integer bseg, eseg, bseg_table, eseg_table
      integer brange, erange, ierr
      integer minrange, maxrange
      integer*8 itable, ktable
      integer boccval, eoccval, bvirtval, evirtval
      integer baoccval, eaoccval, bavirtval, eavirtval
      integer bboccval, eboccval, bbvirtval, ebvirtval
      integer mx_ao_seg_size, mx_occ_seg_size, mx_virt_seg_size
      integer sip_sub_segsize, sip_sub_occ_segsize,
     *        sip_sub_virt_segsize, sip_sub_ao_segsize
      integer superindex, superindex_type
      integer factor, factore
      integer segsize, range, nsubseg, norb_subseg, nrem, brange_s,
     *        erange_s, nseg_total, subsegment_counter
      integer get_subindex_segsize

      integer translate_symbolic_constant
      logical atom_based

#ifdef ALTIX
      iptr = ishptr
#endif

c---------------------------------------------------------------------------
c     If this is a fragment calculation set up the orbital ranges. 
c---------------------------------------------------------------------------

      if (frag_calc) then
         call fragment_orbitals(end_nfps, nshells, atoms)
      endif
c---------------------------------------------------------------------------
c   Map the ao shells defined by basis function data into segments.
c--------------------------------------------------------------------------- 

c     norbitals = end_nfps(nshells)
      norbitals = naocc_orbitals + navirt_orbitals   
      call shells_to_segments(end_nfps, nshells, mx_ao_seg_size,
     *                        aosegs, naosegs, atom_based, atoms)

      if (frag_calc)
     *call fshells_to_segments(end_nfps, nshells, mx_ao_seg_size,
     *                         aosegs, naosegs, atoms)

c----------------------------------------------------------------------------
c   Translate the symbolic constants needed for index segment checking.
c----------------------------------------------------------------------------

      if (.not. frag_calc) then

      boccval = translate_symbolic_constant(bocc, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      eoccval = translate_symbolic_constant(eocc, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      baoccval = translate_symbolic_constant(baocc, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      eaoccval = translate_symbolic_constant(eaocc, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      bboccval = translate_symbolic_constant(bbocc, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      eboccval = translate_symbolic_constant(ebocc, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      bvirtval = translate_symbolic_constant(bvirt, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      evirtval = translate_symbolic_constant(evirt, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      bavirtval = translate_symbolic_constant(bavirt, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      eavirtval = translate_symbolic_constant(eavirt, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      bbvirtval = translate_symbolic_constant(bbvirt, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      ebvirtval = translate_symbolic_constant(ebvirt, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
      endif

c----------------------------------------------------------------------------
c   If this is a fragment calculation we need to make sure that the 
c   segments and number of segments are set correctly. 
c----------------------------------------------------------------------------

      if (frag_calc) then
      nafocc = 0
      nbfocc = 0
      nafvirt = 0
      nbfvirt = 0
c     do i = 1, nfrags 
c        write(6,*) 'VFL NOCC:', n_aocc(i), n_bocc(i)  
c        write(6,*) 'VFL NOCC:', n_avirt(i), n_bvirt(i)  
c     enddo 
      call set_naocc_segs(nafocc, naocc_orbitals, mx_occ_seg_size)
      call set_nbocc_segs(nbfocc, nbocc_orbitals, mx_occ_seg_size)
      call set_navirt_segs(nafvirt, naocc_orbitals, navirt_orbitals,
     *                     mx_virt_seg_size)
      call set_nbvirt_segs(nbfvirt, nbocc_orbitals, nbvirt_orbitals,
     *                     mx_virt_seg_size)

      baoccval  = 1
      eaoccval  = nafocc
      bboccval  = 1
      eboccval  = nbfocc

      bavirtval = nafocc + 1
      eavirtval = bavirtval + nafvirt - 1
      bbvirtval = nbfocc + 1
      ebvirtval = bbvirtval + nbfvirt - 1

      boccval   = baoccval
      eoccval   = eaoccval
      bvirtval  = bavirtval
      evirtval  = eavirtval

      write(6,*) 'VFL boccval = ', boccval
      write(6,*) 'eoccval = ', eoccval
      write(6,*) 'baoccval = ', baoccval
      write(6,*) 'eaoccval = ', eaoccval
      write(6,*) 'bboccval = ', bboccval
      write(6,*) 'eboccval = ', eboccval

      write(6,*) 'bvirtval = ', bvirtval
      write(6,*) 'evirtval = ', evirtval
      write(6,*) 'bavirtaval = ', bavirtval
      write(6,*) 'eavirtaval = ', eavirtval
      write(6,*) 'bbvirtbval = ', bbvirtval
      write(6,*) 'ebvirtbval = ', ebvirtval

c Set the lists defining which segments belong to which fragments 

      call set_frag_segs()

      endif

c----------------------------------------------------------------------------
c   Store some values in the "symbolic_constants" table.
c-----------------------------------------------------------------------------

      symbolic_constant_table(1) = naosegs               ! norb
      symbolic_constant_table(2) = eoccval-boccval+1     ! nocc
      symbolic_constant_table(3) = evirtval-bvirtval+1   ! nvirt
      symbolic_constant_table(4) = boccval               ! bocc
      symbolic_constant_table(5) = eoccval               ! eocc
      symbolic_constant_table(6) = bvirtval              ! bvirt
      symbolic_constant_table(7) = evirtval              ! evirt
      symbolic_constant_table(8) = eaoccval-baoccval+1   ! naocc
      symbolic_constant_table(9) = eboccval-bboccval+1   ! nbocc
      symbolic_constant_table(10) = eavirtval-bavirtval+1   ! navirt
      symbolic_constant_table(11) = ebvirtval-bbvirtval+1   ! nbvirt
      symbolic_constant_table(12) = baoccval                ! baocc
      symbolic_constant_table(13) = bboccval                ! bbocc
      symbolic_constant_table(14) = eaoccval                ! eaocc
      symbolic_constant_table(15) = eboccval                ! ebocc
      symbolic_constant_table(16) = bavirtval               ! bavirt
      symbolic_constant_table(17) = bbvirtval               ! bbvirt
      symbolic_constant_table(18) = eavirtval               ! eavirt
      symbolic_constant_table(19) = ebvirtval               ! ebvirt
      symbolic_constant_table(20) = nocc_orbitals           ! noccorb
      symbolic_constant_table(21) = nvirt_orbitals          ! nvirtorb
      symbolic_constant_table(22) = 1                       ! boccorb
      symbolic_constant_table(23) = nocc_orbitals           ! eoccorb
      symbolic_constant_table(24) = nocc_orbitals+1         ! bvirtorb
      symbolic_constant_table(25) = norbitals               ! evirtorb
      symbolic_constant_table(26) = naocc_orbitals          ! naoccorb
      symbolic_constant_table(27) = nbocc_orbitals          ! nboccorb
      symbolic_constant_table(28) = navirt_orbitals         ! navirtorb
      symbolic_constant_table(29) = nbvirt_orbitals         ! nbvirtorb
      symbolic_constant_table(30) = 1                       ! baoccorb
      symbolic_constant_table(31) = 1                       ! bboccorb
      symbolic_constant_table(32) = naocc_orbitals          ! eaoccorb
      symbolic_constant_table(33) = nbocc_orbitals          ! eboccorb
      symbolic_constant_table(34) = naocc_orbitals+1        ! bavirtorb
      symbolic_constant_table(35) = nbocc_orbitals+1        ! bbvirtorb
      symbolic_constant_table(36) = norbitals               ! eavirtorb
      symbolic_constant_table(37) = norbitals               ! ebvirtorb

c----------------------------------------------------------------------------
c   Make a pass through the index table to count the number of segments needed.
c----------------------------------------------------------------------------

      nsegs = 0
      do 100 i = 1, nindex_table

c------------------------------------------------------------------------------
c   Set the superindex in the c_subindex_ptr field if this is a subindex type.
c------------------------------------------------------------------------------

         if (index_table(c_index_type,i) .eq. subindex) then

c------------------------------------------------------------------------------
c   The compiler has filled in the superindex in the bseg field of the table
c   as it is written to disk.  We must store it in the subindex_ptr field.
c------------------------------------------------------------------------------

            superindex = index_table(c_bseg, i) + 1 ! convert to a Fortran index
            superindex_type = index_table(c_index_type,superindex)
            index_table(c_subindex_ptr,i) = superindex

c------------------------------------------------------------------------------
c   Fill in the ranges from the superindex into the index_table entry for the 
c   subindex.
c------------------------------------------------------------------------------

            index_table(c_bseg,i) = index_table(c_bseg,superindex)
            index_table(c_eseg,i) = index_table(c_eseg,superindex)

c----------------------------------------------------------------------------
c   Compiler puts "norb" in table for some moindex indices.
c   Change the symbolic "norb" value to one that is unambiguous.
c----------------------------------------------------------------------------

            if (eseg_table .eq. norb) then
               if (superindex_type .eq. moindex) then
                  eseg_table = evirt
               else if (superindex_type .eq. moaindex) then
                  eseg_table = eavirt
               else if (superindex_type .eq. mobindex) then
                  eseg_table = ebvirt
               endif
            endif
         else    ! not a subindex
            index_table(c_subindex_ptr,i) = 0
         endif

         bseg_table = index_table(c_bseg,i)
         eseg_table = index_table(c_eseg,i)

c----------------------------------------------------------------------------
c   Compiler puts "norb" in table for some moindex indices.
c   Change the symbolic "norb" value to one that is unambiguous.
c----------------------------------------------------------------------------

         if (eseg_table .eq. norb) then
            if (index_table(c_index_type,i) .eq. moindex) then
               eseg_table = evirt
               if (frag_calc) eseg_table = eavirtval
            else if (index_table(c_index_type,i) .eq. moaindex) then
               eseg_table = eavirt
               if (frag_calc) eseg_table = eavirtval
            else if (index_table(c_index_type,i) .eq. mobindex) then
               eseg_table = ebvirt
               if (frag_calc) eseg_table = ebvirtval
            endif
            index_table(c_bseg,i) = bseg_table
            index_table(c_eseg,i) = eseg_table
         endif

c----------------------------------------------------------------------------
c   If the table segment is a symbolic segment value, translate it now.
c----------------------------------------------------------------------------
 
         if (bseg_table .le. 0) then
            bseg = translate_symbolic_constant(bseg_table, naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals,
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
         else
            bseg = bseg_table
            call check_index_range(bseg, index_table(c_index_type,i),
     *               i, naosegs, boccval, eoccval, bvirtval, evirtval,
     *               baoccval, eaoccval, bavirtval, eavirtval,
     *               bboccval, eboccval, bbvirtval, ebvirtval)
         endif

         if (eseg_table .le. 0) then
            eseg = translate_symbolic_constant(eseg_table,  naosegs,
     *                       norbitals, nocc_orbitals, naocc_orbitals, 
     *                       nbocc_orbitals, mx_ao_seg_size,
     *                       mx_occ_seg_size, mx_virt_seg_size)
         else
            eseg = eseg_table
            call check_index_range(eseg, index_table(c_index_type,i),
     *               i, naosegs, boccval, eoccval, bvirtval, evirtval,
     *               baoccval, eaoccval, bavirtval, eavirtval,
     *               bboccval, eboccval, bbvirtval, ebvirtval)
         endif
33       continue

         if (index_table(c_index_type,i) .eq. subindex) then

c---------------------------------------------------------------------------
c   Loop over the segments of the superindex.
c---------------------------------------------------------------------------

            bseg = index_table(c_bseg,superindex)
            eseg = index_table(c_eseg,superindex)

            nseg_total = 0
            do j = bseg, eseg

c---------------------------------------------------------------------------
c   Determine the subindex segsize for this segment.
c---------------------------------------------------------------------------

               segsize = get_subindex_segsize(superindex_type, j, 
     *                      sip_sub_segsize,
     *                      sip_sub_ao_segsize, sip_sub_occ_segsize,
     *                      sip_sub_virt_segsize, boccval, eoccval,
     *                      baoccval, eaoccval, bboccval, eboccval)
            
c----------------------------------------------------------------------------
c   Find the range of orbitals in the superindex segment.
c----------------------------------------------------------------------------

               call segment_get_range(superindex_type, j, 
     *                       aosegs, naosegs,
     *                       norbitals, nocc_orbitals,
     *                       naocc_orbitals, nbocc_orbitals,
     *                       mx_ao_seg_size, mx_occ_seg_size,
     *                       mx_virt_seg_size,
     *                       brange, erange)

c----------------------------------------------------------------------------
c   Calculate the number of subindex segments for this superindex segment.
c----------------------------------------------------------------------------

               range   = erange - brange + 1 
               nsubseg = range / segsize 
               if (nsubseg * segsize .ne. range) nsubseg = nsubseg + 1 
               nseg_total = nseg_total + nsubseg
            enddo

            bseg = 1
            eseg = nseg_total
         endif

c---------------------------------------------------------------------------
c   Set remaining fields of index_table entry.
c---------------------------------------------------------------------------

         index_table(c_bseg,i) = bseg
         index_table(c_eseg,i) = eseg
         index_table(c_nsegments,i) = eseg - bseg + 1

c---------------------------------------------------------------------------
c   Count the number of segments.
c---------------------------------------------------------------------------

         nsegs = nsegs + eseg - bseg + 1
  100 continue

c--------------------------------------------------------------------------
c   Allocate the memory for the segment_table.
c--------------------------------------------------------------------------

      call mem_alloc(segtable, lsegment_table_entry*nsegs, intsize, 
     *               itable, .true., ierr)
      if (ierr .ne. 0) then
         print *,'Memory allocation error: ',
     *     ' Cannot allocate segment_table. nsegs = ', nsegs
         call abort_job()
      endif

      isegbase = c_loc64(segtable, itable, intsize)

c--------------------------------------------------------------------------
c   Make a second pass through the index_table, creating segment_table 
c   entries for each segment of each regular index.
c--------------------------------------------------------------------------

      nsegment_table = 0
      do 200 i = 1, nindex_table
         bseg = index_table(c_bseg,i)
         eseg = index_table(c_eseg,i)
         type = index_table(c_index_type,i)
         if (type .eq. subindex) go to 200 ! do normal index entries first 

         minrange = 1000000
         maxrange = 0
         do j = bseg, eseg
            call segment_get_range(type, j, aosegs, naosegs,
     *                       norbitals, nocc_orbitals, 
     *                       naocc_orbitals, nbocc_orbitals, 
     *                       mx_ao_seg_size, mx_occ_seg_size,
     *                       mx_virt_seg_size, 
     *                       brange, erange)
            ktable = itable + nsegment_table * lsegment_table_entry
            segtable(ktable + c_index - 1)   = i
            segtable(ktable + c_segment - 1) = j
            segtable(ktable + c_range1 - 1)  = brange
            segtable(ktable + c_range2 - 1)  = erange
            segtable(ktable + c_subseg1 - 1) = 0
            segtable(ktable + c_subseg2 - 1) = 0
            if (brange .gt. erange) then
               print *,'Error: Index ',i,' segment ',j,' has ',
     *            'brange =',brange,' erange = ',erange,
     *            ' index type ',type
               print *,'Index table:'
               do k = 1, nindex_table
                  print *,'Entry ',k,': ',
     *               (index_table(l,k),l=1,lindex_table_entry)
               enddo
               print *,'norbitals ',norbitals,' nocc_orbitals ',
     *               nocc_orbitals,' naocc_orbitals ',
     *               naocc_orbitals,' nbocc_orbitals ',
     *               nbocc_orbitals
               call abort_job()
            endif
            nsegment_table = nsegment_table + 1
            minrange = min(brange, minrange)
            maxrange = max(erange, maxrange)
         enddo

         index_table(c_index_size,i) = maxrange - minrange + 1
  200 continue

c------------------------------------------------------------------------------
c   Make another pass through the index table, creating the segtable entries
c   for each subindex.
c------------------------------------------------------------------------------

      do 300 i = 1, nindex_table
         type = index_table(c_index_type,i)
         if (type .ne. subindex) go to 300

c-----------------------------------------------------------------------------
c   Determine the superindex and its type, use the superindex size as the
c   subindex size.
c-----------------------------------------------------------------------------

         superindex = index_table(c_subindex_ptr,i)
         type       = index_table(c_index_type, superindex)
         index_table(c_index_size,i) = 
     *                index_table(c_index_size,superindex)

c----------------------------------------------------------------------------
c   Loop over the segments of the superindex.
c----------------------------------------------------------------------------

         bseg = index_table(c_bseg, superindex)
         eseg = index_table(c_eseg, superindex)
         subsegment_counter = 0
         do j = bseg, eseg

c----------------------------------------------------------------------------
c   Recalculate the brange, erange of the superindex segment.
c----------------------------------------------------------------------------

            call segment_get_range(type, j, aosegs, naosegs,
     *                       norbitals, nocc_orbitals,
     *                       naocc_orbitals, nbocc_orbitals,
     *                       mx_ao_seg_size, mx_occ_seg_size,
     *                       mx_virt_seg_size,
     *                       brange, erange)

c----------------------------------------------------------------------------
c   Determine the correct segment size to use for this subindex segment.
c----------------------------------------------------------------------------

            segsize = get_subindex_segsize(type, j, sip_sub_segsize,
     *                      sip_sub_ao_segsize, sip_sub_occ_segsize,
     *                      sip_sub_virt_segsize, boccval, eoccval,
     *                      baoccval, eaoccval, bboccval, eboccval)

c----------------------------------------------------------------------------
c   Determine the number of subindex segments needed to fill up the 
c   superindex segment.
c----------------------------------------------------------------------------

            range   = erange-brange+1
            nsubseg = range/segsize
            if (segsize * nsubseg .ne. range) 
     *           nsubseg = nsubseg + 1  
            norb_subseg = range / nsubseg    ! orbitals per subsegment
            nrem        = range - norb_subseg * nsubseg   ! num extra segs

c----------------------------------------------------------------------------
c   Fill in the subindex segment table entries.
c----------------------------------------------------------------------------

            brange_s = brange
            do k = 1, nsubseg
               erange_s = brange_s + norb_subseg - 1
               if (k .le. nrem) erange_s = erange_s + 1
               subsegment_counter = subsegment_counter + 1
 
               ktable = itable + nsegment_table * lsegment_table_entry
               segtable(ktable + c_index - 1)   = i
               segtable(ktable + c_segment - 1) = subsegment_counter
               segtable(ktable + c_range1 - 1)  = brange_s
               segtable(ktable + c_range2 - 1)  = erange_s
               segtable(ktable + c_subseg1 - 1) = 0
               segtable(ktable + c_subseg2 - 1) = 0

               nsegment_table = nsegment_table + 1
               brange_s = erange_s + 1 
            enddo    ! k
         enddo       ! j
  300 continue       ! i

c-----------------------------------------------------------------------------
c   Now make another pass, indexing the subsegment ranges for each superindex
c   segment.  This will be used later in "do ii in i" constructs.      
c-----------------------------------------------------------------------------

      call set_subsegment_ranges(index_table, nindex_table, 
     *                           segtable(itable), nsegment_table)

c------------------------------------------------------------------------------
c   Determine the stack size for each individual type of data used.
c------------------------------------------------------------------------------

      call determine_stack_blocksizes(index_table, nindex_table,
     *         segtable(itable), nsegment_table, boccval, eoccval,
     *         baoccval, eaoccval, bboccval, eboccval,
     *         stack_blocksizes, nstacks)
      return
      end

      integer function translate_symbolic_constant(iseg, naosegs,
     *                              norbitals, nocc_orbitals,
     *                              naocc_orbitals, nbocc_orbitals, 
     *                              mx_ao_seg_size, mx_occ_seg_size,
     *                              mx_virt_seg_size)
      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'frag_def.h'
      integer i,j
      integer iseg, naosegs, norbitals, nocc_orbitals
      integer mx_ao_seg_size, mx_occ_seg_size, mx_virt_seg_size
      integer naocc_orbitals, nbocc_orbitals
      integer seg, bo, eo, bv, ev
      integer bao, eao, bav, eav
      integer bbo, ebo, bbv, ebv
      integer n_frag
      
      bo = 1
      eo = (nocc_orbitals - 1) / mx_occ_seg_size + 1
      bv = eo + 1
      ev = (norbitals - nocc_orbitals - 1) / mx_virt_seg_size + bv

      bao = 1
      eao = (naocc_orbitals - 1) / mx_occ_seg_size + 1
      bav = eao + 1
      eav = (norbitals -naocc_orbitals - 1) / mx_virt_seg_size + bav

      bbo = 1
      ebo = (nbocc_orbitals - 1) / mx_occ_seg_size + 1
      bbv = ebo + 1
      ebv = (norbitals - nbocc_orbitals - 1) / mx_virt_seg_size + bbv

      if (frag_calc) then

         n_frag = nfrags
         if (fdrop_flag) n_frag = 1

         eao = 0
         do i = 1, nfrags
             eao = eao + n_aocc(i)
         enddo
         eo = eao

         bav = eao + 1
         bv  = bav
         eav = eao

         do i = 1, n_frag
             eav = eav + n_avirt(i)
         enddo

         ev = eav
         ebo = 0
         do i = 1, nfrags
             ebo = ebo + n_bocc(i)
         enddo

         ebv = ebo
         bbv = ebo + 1
         do i = 1, n_frag
             ebv = ebv + n_bvirt(i)
         enddo
      endif

      if (iseg .eq. norb) then
         seg = naosegs
      else if (iseg .eq. bocc) then
         seg = bo
      else if (iseg .eq. eocc) then
         seg = eo
      else if (iseg .eq. bvirt) then
         seg = bv
      else if (iseg .eq. evirt) then
         seg = ev
      else if (iseg .eq. naocc) then
         seg = naocc_orbitals
      else if (iseg .eq. baocc) then
         seg = bao
      else if (iseg .eq. eaocc) then
         seg = eao
      else if (iseg .eq. bavirt) then
         seg = bav
      else if (iseg .eq. eavirt) then
         seg = eav
      else if (iseg .eq. nbocc) then
         seg = nbocc_orbitals
      else if (iseg .eq. bbocc) then
         seg = bbo
      else if (iseg .eq. ebocc) then
         seg = ebo
      else if (iseg .eq. bbvirt) then
         seg = bbv
      else if (iseg .eq. ebvirt) then
         seg = ebv
      else if (iseg .eq. noccorb) then
         seg = nocc_orbitals
      else if (iseg .eq. nvirtorb) then
         seg = norbitals - nocc_orbitals
      else if (iseg .eq. boccorb) then
         seg = 1
      else if (iseg .eq. eoccorb) then
         seg = nocc_orbitals
      else if (iseg .eq. bvirtorb) then
         seg = nocc_orbitals + 1
      else if (iseg .eq. evirtorb) then
         seg = norbitals
      else if (iseg .eq. naoccorb) then
         seg =  naocc_orbitals
      else if (iseg .eq. nboccorb) then
         seg = nbocc_orbitals
      else if (iseg .eq. navirtorb) then
          seg = norbitals - naocc_orbitals
      else if (iseg .eq. nbvirtorb) then
          seg = norbitals - nbocc_orbitals 
      else if (iseg .eq. baoccorb) then
          seg = 1
      else if (iseg .eq. bboccorb) then
          seg = 1
      else if (iseg .eq. eaoccorb) then
          seg = naocc_orbitals
      else if (iseg .eq. eboccorb) then
          seg = nbocc_orbitals
      else if (iseg .eq. bavirtorb) then
          seg = naocc_orbitals + 1
      else if (iseg .eq. bbvirtorb) then
          seg = nbocc_orbitals + 1
      else if (iseg .eq. eavirtorb) then
          seg = norbitals
      else if (iseg .eq. ebvirtorb) then
          seg = norbitals 
      else if (iseg .eq. cc_iter_cons) then
         seg = cc_iter
      else if (iseg .eq. cc_hist_cons) then
         seg = cc_hist
      else if (iseg .eq. cc_beg_cons) then
         seg = cc_beg
      else if (iseg .eq. scf_iter_cons) then
         seg = scf_iter
      else if (iseg .eq. scf_hist_cons) then
         seg = scf_hist
      else if (iseg .eq. scf_beg_cons) then
         seg = scf_beg
      else if (iseg .eq. natoms_cons) then
         seg = ncenters
      else if (iseg .eq. subb_parm) then
         seg = subb
      else if (iseg .eq. sube_parm) then
         seg = sube
      else if (iseg .eq. sip_sub_segsize_parm) then
         seg = sip_sub_segsize
      else if (iseg .eq. sip_sub_occ_segsize_parm) then
         seg = sip_sub_occ_segsize
      else if (iseg .eq. sip_sub_virt_segsize_parm) then 
         seg = sip_sub_virt_segsize
      else if (iseg .eq. sip_sub_ao_segsize_parm) then 
          seg = sip_sub_ao_segsize 
      else  
         print *,'Error in translate_symbolic_constant: ',
     *         'Unknown symbolic constant ',iseg
         call abort_job()
      endif

      translate_symbolic_constant = seg
      return
      end                       

      subroutine segment_get_range(type, seg, aosegs, naosegs,
     *                       norbitals, nocc_orbitals, 
     *                       naocc_orbitals, nbocc_orbitals, 
     *                       mx_ao_seg_size, mx_occ_seg_size,
     *                       mx_virt_seg_size,
     *                       brange, erange)
      implicit none
      include 'interpreter.h'
      include 'frag_def.h'
      integer type, seg, naosegs, norbitals, nocc_orbitals
      integer i,j
      integer naocc_orbitals, nbocc_orbitals
      integer no_per_seg, no_left, nv_per_seg, nv_left, nvorbitals
      integer nosegs, nvsegs
      integer mx_ao_seg_size, mx_occ_seg_size, mx_virt_seg_size,
     *        brange, erange
      integer aosegs(naosegs)

      if (frag_calc) then

      if (type .eq. aoindex) then
         if (seg .eq. 1) then
            brange = 1
         else
            brange = aosegs(seg-1) + 1
         endif
         erange = aosegs(seg)

      else if (type .eq. moaindex .or. type .eq. moindex) then
         nosegs = 0
         nvsegs = 0
         do i = 1, nfrags
            nosegs = nosegs + n_aocc(i)
            nvsegs = nvsegs + n_avirt(i)
         enddo

         if (seg .le. nosegs) then
            nosegs = 0
            do i = 1, nfrags
            do j = 1, n_aocc(i)
               nosegs = nosegs + 1
               if (nosegs .eq. seg) then
                  brange = baocc_frag(i,j)
                  erange = eaocc_frag(i,j)
               endif
            enddo
            enddo
         else
            nosegs = 0
            do i = 1, nfrags
               nosegs = nosegs + n_aocc(i)
            enddo
            do i = 1, nfrags
            do j = 1, n_avirt(i)
               nosegs = nosegs + 1
               if (nosegs .eq. seg) then
                  brange = bavirt_frag(i,j)
                  erange = eavirt_frag(i,j)
               endif
            enddo
            enddo
         endif

      else if (type .eq. mobindex) then
         nosegs = 0
         nvsegs = 0
         do i = 1, nfrags
            nosegs = nosegs + n_bocc(i)
            nvsegs = nvsegs + n_bvirt(i)
         enddo

         if (seg .le. nosegs) then
            nosegs = 0
            do i = 1, nfrags
            do j = 1, n_bocc(i)
               nosegs = nosegs + 1
               if (nosegs .eq. seg) then
                  brange = bbocc_frag(i,j)
                  erange = ebocc_frag(i,j)
               endif
            enddo
            enddo
         else
         nosegs = 0
         do i = 1, nfrags
            nosegs = nosegs + n_bocc(i)
         enddo
            do i = 1, nfrags
            do j = 1, n_bvirt(i)
               nosegs = nosegs + 1
               if (nosegs .eq. seg) then
                  brange = bbvirt_frag(i,j)
                  erange = ebvirt_frag(i,j)
               endif
            enddo
            enddo
         endif
      else if (type .eq. simple_index) then
         brange = seg
         erange = seg
      else if (type .eq. laindex) then
         brange = 1
         erange = 1
      else if (type .eq. subindex) then
         brange = seg
         erange = seg
      else
         print *,'Error in segment_get_range: Unknown type ',type
         call abort_job()
      endif
         return
      endif !  frag_calc        

90    continue
      if( .not. frag_calc) then
      if (type .eq. aoindex) then
         if (seg .eq. 1) then
            brange = 1
         else
            brange = aosegs(seg-1) + 1
         endif

         erange = aosegs(seg)
      else if (type .eq. moindex) then
         nosegs = (nocc_orbitals - 1) / mx_occ_seg_size + 1
         if (seg .le. nosegs) then
            no_per_seg = (nocc_orbitals - 1)/nosegs
            no_left    = nocc_orbitals - nosegs * no_per_seg
            if (seg .le. no_left) then
               brange = (seg-1) * (no_per_seg+1) + 1
               erange = min0(nocc_orbitals, brange + no_per_seg)
            else
               brange = no_left + (seg-1)*no_per_seg + 1
               erange = min0(nocc_orbitals, brange + no_per_seg-1)
            endif
         else
            nvorbitals = norbitals - nocc_orbitals
            nvsegs = (norbitals - nocc_orbitals - 1) / 
     *                                  mx_virt_seg_size + 1
            nv_per_seg = (nvorbitals - 1)/nvsegs
            nv_left    = nvorbitals - nvsegs * nv_per_seg

            if (seg .le. nosegs + nv_left) then
               brange = (seg-nosegs-1) * (nv_per_seg + 1) + 
     *                   nocc_orbitals + 1
               erange = min0(norbitals, brange + nv_per_seg)
            else
               brange = nv_left + (seg-nosegs-1)*nv_per_seg +
     *                  nocc_orbitals + 1
               erange =  min0(norbitals, brange + nv_per_seg - 1)
            endif
         endif

      else if (type .eq. moaindex) then
         nosegs = (naocc_orbitals - 1) / mx_occ_seg_size + 1
         nvsegs = (norbitals - naocc_orbitals - 1) / 
     *                               mx_virt_seg_size + 1
         if (seg .le. nosegs) then
            no_per_seg = (naocc_orbitals - 1)/nosegs
            no_left    = naocc_orbitals - nosegs * no_per_seg
            if (seg .le. no_left) then
               brange = (seg-1) * (no_per_seg+1) + 1
               erange = min0(naocc_orbitals, brange + no_per_seg)
            else
               brange = no_left + (seg-1)*no_per_seg + 1
               erange = min0(naocc_orbitals, brange + no_per_seg-1)
            endif
         else
            nvorbitals = norbitals - naocc_orbitals
            nv_per_seg = (nvorbitals - 1)/nvsegs
            nv_left    = nvorbitals - nvsegs * nv_per_seg

            if (seg .le. nosegs + nv_left) then
               brange = (seg-nosegs-1) * (nv_per_seg + 1) + 
     *                   naocc_orbitals + 1
               erange = min0(norbitals, brange + nv_per_seg)
            else
               brange = nv_left + (seg-nosegs-1)*nv_per_seg +
     *                  naocc_orbitals + 1
               erange =  min0(norbitals, brange + nv_per_seg - 1)
            endif
         endif

      else if (type .eq. mobindex) then
         nosegs = (nbocc_orbitals - 1) / mx_occ_seg_size + 1
         nvsegs = (norbitals - nbocc_orbitals - 1) / 
     *                                  mx_virt_seg_size + 1
         if (seg .le. nosegs) then
            no_per_seg = (nbocc_orbitals - 1)/nosegs
            no_left    = nbocc_orbitals - nosegs * no_per_seg
            if (seg .le. no_left) then
               brange = (seg-1) * (no_per_seg+1) + 1
               erange = min0(nbocc_orbitals, brange + no_per_seg)
            else
               brange = no_left + (seg-1)*no_per_seg + 1
               erange = min0(nbocc_orbitals, brange + no_per_seg-1)
            endif
         else
            nvorbitals = norbitals - nbocc_orbitals
            nv_per_seg = (nvorbitals - 1)/nvsegs
            nv_left    = nvorbitals - nvsegs * nv_per_seg

            if (seg .le. nosegs + nv_left) then
               brange = (seg-nosegs-1) * (nv_per_seg + 1) + 
     *                   nbocc_orbitals + 1
               erange = min0(norbitals, brange + nv_per_seg)
            else
               brange = nv_left + (seg-nosegs-1)*nv_per_seg +
     *                  nbocc_orbitals + 1
               erange =  min0(norbitals, brange + nv_per_seg - 1)
            endif
         endif
      else if (type .eq. simple_index) then
         brange = seg
         erange = seg
      else if (type .eq. laindex) then
         brange = 1
         erange = 1
      else if (type .eq. subindex) then
         brange = seg
         erange = seg
      else 
         print *,'Error in segment_get_range: Unknown type ',type
         call abort_job()
      endif
      endif ! .not. frag_calc
     
      return
      end

      subroutine check_index_range(seg, type, index_id, naosegs, 
     *                       ibocc, ieocc, ibvirt, ievirt, 
     *                       ibaocc, ieaocc, ibavirt, ieavirt,
     *                       ibbocc, iebocc, ibbvirt, iebvirt)
c--------------------------------------------------------------------------
c   Verifies that a given segment is within the actual range for its
c   index type. If an error is detected, an error message is printed,
c   and the job aborts.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'frag_def.h'

      integer seg, type, naosegs, ibocc, ieocc, ibvirt, ievirt
      integer ibavirt, ieavirt, ibaocc, ieaocc
      integer ibbvirt, iebvirt, ibbocc, iebocc
      integer seg1, seg2, ierr
      integer index_id

      ierr = 0
      if (type .eq. aoindex) then
         if (seg .lt. 1 .or. seg .gt. naosegs) then
            ierr = 1
            seg1 = 1
            seg2 = naosegs
         endif
      else if (type .eq. moindex) then
         if (seg .lt. ibocc .or. seg .gt. ievirt) then
            ierr = 1
            seg1 = ibocc
            seg2 = ievirt
         endif
      else if (type .eq. moaindex) then
         if (seg .lt. ibaocc .or. seg .gt. ieavirt) then
            ierr = 1
            seg1 = ibaocc
            seg2 = ieavirt
         endif
      else if (type .eq. mobindex) then
         if (seg .lt. ibbocc .or. seg .gt. iebvirt) then
            ierr = 1
            seg1 = ibbocc
            seg2 = iebvirt
         endif
      else if (type .eq. simple_index) then
         if (seg .le. 0) then
            print *,'Error: Invalid range for index number ',index_id
            print *,'Range must be > 0, code has index value of ',
     *           seg
            call abort_job() 
         endif
      else if (type .eq. laindex) then
      else if (type .eq. subindex) then
      else
         print *,'Error: Invalid index type in check_index_range: ',
     *     'Index = ',index_id, ' Type = ',type
         call abort_job()
      endif

      if (ierr .eq. 1) then
         print *,'Error: Index range error for index ',index_id,
     *               ' type = ',type
         print *,'Index should be between ',seg1,' and ',seg2
         call abort_job()
      endif
      return
      end

      integer function get_subindex_segsize(superindex_type, seg, 
     *                      sip_sub_segsize,
     *                      sip_sub_ao_segsize, sip_sub_occ_segsize,
     *                      sip_sub_virt_segsize, boccval, eoccval,
     *                      baoccval, eaoccval, bboccval, eboccval)
c---------------------------------------------------------------------------
c   Function to return the correct segment size for a subindex segment 
c   corresponding to segment "seg" of a superindex of type "superindex_type".
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'

      integer superindex_type, seg
      integer sip_sub_segsize, sip_sub_ao_segsize, sip_sub_occ_segsize,
     *        sip_sub_virt_segsize
      integer boccval, eoccval, baoccval, eaoccval, bboccval, eboccval

      if (superindex_type .eq. aoindex) then
         get_subindex_segsize = sip_sub_ao_segsize
      else if (superindex_type .eq. simple_index) then
         get_subindex_segsize = sip_sub_segsize
      else if (superindex_type .eq. moindex) then
         if (seg .ge. boccval .and. seg .le. eoccval) then
            get_subindex_segsize = sip_sub_occ_segsize
         else
            get_subindex_segsize = sip_sub_virt_segsize
         endif
      else if (superindex_type .eq. moaindex) then
         if (seg .ge. baoccval .and. seg .le. eaoccval) then
            get_subindex_segsize = sip_sub_occ_segsize
         else
            get_subindex_segsize = sip_sub_virt_segsize
         endif
      else if (superindex_type .eq. mobindex) then
         if (seg .ge. bboccval .and. seg .le. eboccval) then
            get_subindex_segsize = sip_sub_occ_segsize
         else
            get_subindex_segsize = sip_sub_virt_segsize
         endif
      endif

      return
      end 

      subroutine set_subsegment_ranges(index_table, nindex_table,
     *                 segment_table, nsegment_table)
c-------------------------------------------------------------------------
c   For each superindex segment, fills in the beginning and ending 
c   segment of its corresponding subindex.
c-------------------------------------------------------------------------
     
      implicit none
      include 'interpreter.h'
      integer nsegment_table
      integer nindex_table 
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)

      integer i, j, k
      integer subindex_seg, superindex, super_bseg, super_eseg
      integer bseg, eseg

      do k = 1, nindex_table
         if (index_table(c_index_type, k) .eq. subindex) then

c----------------------------------------------------------------------------
c   We have a subindex.  Process all the segments of its superindex.
c----------------------------------------------------------------------------

            superindex = index_table(c_subindex_ptr,k)
            super_bseg = index_table(c_bseg, superindex)
            super_eseg = index_table(c_eseg, superindex)
    
            do j = super_bseg, super_eseg

c---------------------------------------------------------------------------
c   Find the bseg and eseg of the subindex corresponding to superindex
c   segment j.
c---------------------------------------------------------------------------

               call get_subrange_segments(superindex, j, k,
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           bseg, eseg)

c----------------------------------------------------------------------------
c   Now look up the segment_table entry for this superindex segment, and
c   store the bseg and eseg.  This data may be used in a "do ii in i"
c   type loop.
c----------------------------------------------------------------------------

               do i = 1, nsegment_table
                  if (segment_table(c_index,i) .eq. superindex .and.
     *                segment_table(c_segment,i) .eq. j) then
                     segment_table(c_subseg1,i) = bseg
                     segment_table(c_subseg2,i) = eseg
                     go to 100
                  endif
               enddo   ! i

  100          continue
            enddo  !  j
         endif
      enddo    ! k  

      return
      end

      subroutine set_naocc_segs(nocc, nocc_orbitals, mx_occ_seg_size) 
      implicit none 
      include 'frag_def.h'
      integer nocc, nocc_orbitals, mx_occ_seg_size
      integer i, j, start   
      integer n_frag, occ_frag(100), nocc_frag(100)

c     logical frag_calc 
c     integer nfrags, natoms_frag, watom_frag 
c     common /FRAGDEF/frag_calc, nfrags, natoms_frag(100), 
c    *                watom_frag(100,100) 

c     integer fragAO, n_occ, n_aocc, n_bocc, n_virt, n_avirt, n_bvirt
c     common /FORBS/fragAO(100), n_occ(100), n_aocc(100), n_bocc(100), 
c    *              n_virt(100),
c    *              n_avirt(100),
c    *              n_bvirt(100) 

c     integer bocc_frag, eocc_frag, baocc_frag, eaocc_frag,  
c    *        bbocc_frag, ebocc_frag,  
c 
c    *        bvirt_frag, evirt_frag, bavirt_frag, eavirt_frag,  
c    *        bbvirt_frag, ebvirt_frag  

c     common /SEGRANGE/bocc_frag(100,100), eocc_frag(100,100),  
c    *                 baocc_frag(100,100), eaocc_frag(100,100),  
c    *                 bbocc_frag(100,100), ebocc_frag(100,100),  
c 
c    *                 bvirt_frag(100,100), evirt_frag(100,100),  
c    *                 bavirt_frag(100,100), eavirt_frag(100,100),  
c    *                 bbvirt_frag(100,100), ebvirt_frag(100,100)  


c As a test just set occ fragmants 

      n_frag = nfrags 
      do i = 1, n_frag 
         occ_frag(i) = n_aocc(i)  
      enddo 

      nocc = 0 
      do i = 1, n_frag 
         if (mx_occ_seg_size .ge. occ_frag(i)) then 
            nocc         = nocc + 1 
            nocc_frag(i) = 1 
            bocc_frag(i,nocc_frag(i)) = 1 
            eocc_frag(i,nocc_frag(i)) = bocc_frag(i,nocc_frag(i)) 
     *                                + occ_frag(i) - 1  
         else  
            nocc_frag(i) = occ_frag(i)/mx_occ_seg_size 
            if (nocc_frag(i)*mx_occ_seg_size .lt. occ_frag(i)) 
     *          nocc_frag(i) = nocc_frag(i) + 1 
            nocc = nocc + nocc_frag(i) 

            do j = 1, nocc_frag(i) 
               if (j .eq. 1) then 
                  bocc_frag(i,j) = 1 
                  eocc_frag(i,j) = bocc_frag(i,j) + mx_occ_seg_size - 1  
               endif 

               if (j .gt. 1) then 
                  bocc_frag(i,j) = eocc_frag(i,j-1) + 1 
                  eocc_frag(i,j) = bocc_frag(i,j) + mx_occ_seg_size - 1  
               endif 
            enddo 

            if (eocc_frag(i,nocc_frag(i)) .gt. occ_frag(i)) 
     *         eocc_frag(i,nocc_frag(i)) = occ_frag(i) 

         endif 

      enddo 

      write(6,*) ' NaOCC = ', nocc 
      start = 0 
      do i = 1, n_frag 
         n_aocc(i) = nocc_frag(i) 
         write(6,*) '    ', i, n_aocc(i)
         do j = 1, nocc_frag(i)
            baocc_frag(i,j) = bocc_frag(i,j) + start  
            eaocc_frag(i,j) = eocc_frag(i,j) + start  
            write(6,*) '          ', baocc_frag(i,j), eaocc_frag(i,j) 
         enddo 
         start = start + (eaocc_frag(i,nocc_frag(i)) -
     *                    baocc_frag(i,1) + 1)   
      enddo 


      end

      subroutine set_navirt_segs(nvirt,nocc_orbitals,nvirt_orbitals,
     *                           mx_virt_seg_size) 
      implicit none 
      include 'frag_def.h'
      integer nvirt, nocc_orbitals, nvirt_orbitals, mx_virt_seg_size
      integer i, j, start   
      integer n_frag, virt_frag(100), nvirt_frag(100) 

c     logical frag_calc 
c     integer nfrags, natoms_frag, watom_frag 
c     common /FRAGDEF/frag_calc, nfrags, natoms_frag(100), 
c    *                watom_frag(100,100) 

c     integer fragAO, n_occ, n_aocc, n_bocc, n_virt, n_avirt, n_bvirt
c     common /FORBS/fragAO(100), n_occ(100), n_aocc(100), n_bocc(100), 
c    *              n_virt(100),
c    *              n_avirt(100),
c    *              n_bvirt(100) 

c     integer bocc_frag, eocc_frag, baocc_frag, eaocc_frag,  
c    *        bbocc_frag, ebocc_frag,  
c 
c    *        bvirt_frag, evirt_frag, bavirt_frag, eavirt_frag,  
c    *        bbvirt_frag, ebvirt_frag  

c     common /SEGRANGE/bocc_frag(100,100), eocc_frag(100,100),  
c    *                 baocc_frag(100,100), eaocc_frag(100,100),  
c    *                 bbocc_frag(100,100), ebocc_frag(100,100),  
c 
c    *                 bvirt_frag(100,100), evirt_frag(100,100),  
c    *                 bavirt_frag(100,100), eavirt_frag(100,100),  
c    *                 bbvirt_frag(100,100), ebvirt_frag(100,100)  


c As a test just set virt fragmants 

      n_frag = nfrags 
      if (fdrop_flag) n_frag = 1 

      do i = 1, n_frag 
         virt_frag(i) = n_avirt(i)  
      enddo 

      nvirt = 0 
      do i = 1, n_frag 
         if (mx_virt_seg_size .ge. virt_frag(i)) then 
            nvirt         = nvirt + 1 
            nvirt_frag(i) = 1 
            bvirt_frag(i,nvirt_frag(i)) = 1 
            evirt_frag(i,nvirt_frag(i)) = bvirt_frag(i,nvirt_frag(i)) 
     *                                + virt_frag(i) - 1  
         else  
            nvirt_frag(i) = virt_frag(i)/mx_virt_seg_size 
            if (nvirt_frag(i)*mx_virt_seg_size .lt. virt_frag(i)) 
     *          nvirt_frag(i) = nvirt_frag(i) + 1 
            nvirt = nvirt + nvirt_frag(i) 

            do j = 1, nvirt_frag(i) 
               if (j .eq. 1) then 
                  bvirt_frag(i,j) = 1 
                  evirt_frag(i,j) = bvirt_frag(i,j) + mx_virt_seg_size-1  
               endif 

               if (j .gt. 1) then 
                  bvirt_frag(i,j) = evirt_frag(i,j-1) + 1 
                  evirt_frag(i,j) = bvirt_frag(i,j) + mx_virt_seg_size-1  
               endif 
            enddo 

            if (evirt_frag(i,nvirt_frag(i)) .gt. virt_frag(i)) 
     *         evirt_frag(i,nvirt_frag(i)) = virt_frag(i) 

         endif 

      enddo 

      write(6,*) ' NaVIRT = ', nvirt 
      start = nocc_orbitals 
      do i = 1, n_frag 
         n_avirt(i) = nvirt_frag(i) 
         write(6,*) '    ', i, n_avirt(i)
         do j = 1, nvirt_frag(i)
            bavirt_frag(i,j) = bvirt_frag(i,j) + start  
            eavirt_frag(i,j) = evirt_frag(i,j) + start  
            write(6,*) '          ', bavirt_frag(i,j), eavirt_frag(i,j) 
         enddo 
         start = eavirt_frag(i,nvirt_frag(i)) 
      enddo 


      end

      subroutine set_nbocc_segs(nocc, nocc_orbitals, mx_occ_seg_size) 
      implicit none 
      include 'frag_def.h'
      integer nocc, nocc_orbitals, mx_occ_seg_size
      integer i, j, start   
      integer n_frag, occ_frag(100), nocc_frag(100) 

c     logical frag_calc 
c     integer nfrags, natoms_frag, watom_frag 
c     common /FRAGDEF/frag_calc, nfrags, natoms_frag(100), 
c    *                watom_frag(100,100) 

c     integer fragAO, n_occ, n_aocc, n_bocc, n_virt, n_avirt, n_bvirt
c     common /FORBS/fragAO(100), n_occ(100), n_aocc(100), n_bocc(100), 
c    *              n_virt(100),
c    *              n_avirt(100),
c    *              n_bvirt(100) 

c     integer bocc_frag, eocc_frag, baocc_frag, eaocc_frag,  
c    *        bbocc_frag, ebocc_frag,  
c 
c    *        bvirt_frag, evirt_frag, bavirt_frag, eavirt_frag,  
c    *        bbvirt_frag, ebvirt_frag  

c     common /SEGRANGE/bocc_frag(100,100), eocc_frag(100,100),  
c    *                 baocc_frag(100,100), eaocc_frag(100,100),  
c    *                 bbocc_frag(100,100), ebocc_frag(100,100),  
c 
c    *                 bvirt_frag(100,100), evirt_frag(100,100),  
c    *                 bavirt_frag(100,100), eavirt_frag(100,100),  
c    *                 bbvirt_frag(100,100), ebvirt_frag(100,100)  


c As a test just set occ fragmants 

      n_frag = nfrags 
      do i = 1, n_frag 
         occ_frag(i) = n_bocc(i)  
      enddo 

      nocc = 0 
      do i = 1, n_frag 
         if (mx_occ_seg_size .ge. occ_frag(i)) then 
            nocc         = nocc + 1 
            nocc_frag(i) = 1 
            bocc_frag(i,nocc_frag(i)) = 1 
            eocc_frag(i,nocc_frag(i)) = bocc_frag(i,nocc_frag(i)) 
     *                                + occ_frag(i) - 1  
         else  
            nocc_frag(i) = occ_frag(i)/mx_occ_seg_size 
            if (nocc_frag(i)*mx_occ_seg_size .lt. occ_frag(i)) 
     *          nocc_frag(i) = nocc_frag(i) + 1 
            nocc = nocc + nocc_frag(i) 

            do j = 1, nocc_frag(i) 
               if (j .eq. 1) then 
                  bocc_frag(i,j) = 1 
                  eocc_frag(i,j) = bocc_frag(i,j) + mx_occ_seg_size - 1  
               endif 

               if (j .gt. 1) then 
                  bocc_frag(i,j) = eocc_frag(i,j-1) + 1 
                  eocc_frag(i,j) = bocc_frag(i,j) + mx_occ_seg_size - 1  
               endif 
            enddo 

            if (eocc_frag(i,nocc_frag(i)) .gt. occ_frag(i)) 
     *         eocc_frag(i,nocc_frag(i)) = occ_frag(i) 

         endif 

      enddo 

      write(6,*) ' NbOCC = ', nocc 
      start = 0 
      do i = 1, n_frag 
         n_bocc(i) = nocc_frag(i) 
         write(6,*) '    ', i, n_bocc(i)
         do j = 1, nocc_frag(i)
            bbocc_frag(i,j) = bocc_frag(i,j) + start  
            ebocc_frag(i,j) = eocc_frag(i,j) + start  
            write(6,*) '          ', bbocc_frag(i,j), ebocc_frag(i,j) 
         enddo 
         start = start + (ebocc_frag(i,nocc_frag(i)) -
     *                    bbocc_frag(i,1) + 1)   
      enddo 

      end

      subroutine set_nbvirt_segs(nvirt,nocc_orbitals,nvirt_orbitals,
     *                           mx_virt_seg_size) 
      implicit none 
      include 'frag_def.h'
      integer nvirt, nocc_orbitals, nvirt_orbitals, mx_virt_seg_size
      integer i, j, start   
      integer n_frag, virt_frag(100), nvirt_frag(100) 

c     logical frag_calc 
c     integer nfrags, natoms_frag, watom_frag 
c     common /FRAGDEF/frag_calc, nfrags, natoms_frag(100), 
c    *                watom_frag(100,100) 

c     integer fragAO, n_occ, n_aocc, n_bocc, n_virt, n_avirt, n_bvirt
c     common /FORBS/fragAO(100), n_occ(100), n_aocc(100), n_bocc(100), 
c    *              n_virt(100),
c    *              n_avirt(100),
c    *              n_bvirt(100) 

c     integer bocc_frag, eocc_frag, baocc_frag, eaocc_frag,  
c    *        bbocc_frag, ebocc_frag,  
c 
c    *        bvirt_frag, evirt_frag, bavirt_frag, eavirt_frag,  
c    *        bbvirt_frag, ebvirt_frag  

c     common /SEGRANGE/bocc_frag(100,100), eocc_frag(100,100),  
c    *                 baocc_frag(100,100), eaocc_frag(100,100),  
c    *                 bbocc_frag(100,100), ebocc_frag(100,100),  
c 
c    *                 bvirt_frag(100,100), evirt_frag(100,100),  
c    *                 bavirt_frag(100,100), eavirt_frag(100,100),  
c    *                 bbvirt_frag(100,100), ebvirt_frag(100,100)  

c As a test just set virt fragmants 

      n_frag = nfrags 
      if (fdrop_flag) n_frag = 1 

      do i = 1, n_frag 
         virt_frag(i) = n_bvirt(i)  
      enddo 

      nvirt = 0 
      do i = 1, n_frag 
         if (mx_virt_seg_size .ge. virt_frag(i)) then 
            nvirt         = nvirt + 1 
            nvirt_frag(i) = 1 
            bvirt_frag(i,nvirt_frag(i)) = 1 
            evirt_frag(i,nvirt_frag(i)) = bvirt_frag(i,nvirt_frag(i)) 
     *                                + virt_frag(i) - 1  
         else  
            nvirt_frag(i) = virt_frag(i)/mx_virt_seg_size 
            if (nvirt_frag(i)*mx_virt_seg_size .lt. virt_frag(i)) 
     *          nvirt_frag(i) = nvirt_frag(i) + 1 
            nvirt = nvirt + nvirt_frag(i) 

            do j = 1, nvirt_frag(i) 
               if (j .eq. 1) then 
                  bvirt_frag(i,j) = 1 
                  evirt_frag(i,j) = bvirt_frag(i,j) + mx_virt_seg_size-1  
               endif 

               if (j .gt. 1) then 
                  bvirt_frag(i,j) = evirt_frag(i,j-1) + 1 
                  evirt_frag(i,j) = bvirt_frag(i,j) + mx_virt_seg_size-1  
               endif 
            enddo 

            if (evirt_frag(i,nvirt_frag(i)) .gt. virt_frag(i)) 
     *         evirt_frag(i,nvirt_frag(i)) = virt_frag(i) 

         endif 

      enddo 

      write(6,*) ' NbVIRT = ', nvirt 
      start = nocc_orbitals 
      do i = 1, n_frag 
         n_bvirt(i) = nvirt_frag(i) 
         write(6,*) '    ', i, n_bvirt(i)
         do j = 1, nvirt_frag(i)
            bbvirt_frag(i,j) = bvirt_frag(i,j) + start  
            ebvirt_frag(i,j) = evirt_frag(i,j) + start  
            write(6,*) '          ', bbvirt_frag(i,j), ebvirt_frag(i,j) 
         enddo 
         start = ebvirt_frag(i,nvirt_frag(i)) 
      enddo 

      end

      subroutine set_frag_segs() 
      implicit none 
      include 'frag_def.h'
      integer i, j, n, n_frag  

c     write(6,*) ' Defining FRAGMENT lists' 

c Determine the AO frag segment list 

c     write(6,*) ' AO list ' 
c     n = 0 
c     do i = 1, nfrags 
c     do j = 1, fragAO(i) 
c        n = n + 1 
c        w_frag_AO(n) = i 
c        write(6,*) n, w_frag_AO(n) 
c     enddo 
c     enddo 

c Determine the occupied frag segment list 

c Determine the AO frag segment list 

      write(6,*) ' OCC list ' 

      n = 0 
      do i = 1, nfrags 
      do j = 1, n_aocc(i) 
         n = n + 1 
         w_frag_occ(n) = i 
         write(6,*) n, w_frag_occ(n) 
      enddo 
      enddo 

      write(6,*) ' OCCA list ' 

      n = 0 
      do i = 1, nfrags 
      do j = 1, n_aocc(i) 
         n = n + 1 
         w_frag_aocc(n) = i 
         write(6,*) n, w_frag_aocc(n) 
      enddo 
      enddo 

      write(6,*) ' OCCB list ' 

      n = 0 
      do i = 1, nfrags 
      do j = 1, n_bocc(i) 
         n = n + 1 
         w_frag_bocc(n) = i 
         write(6,*) n, w_frag_bocc(n) 
      enddo 
      enddo 

c Determine the virtual frag segment list 

      write(6,*) ' VIRT list ' 

      n_frag = nfrags 
      if (fdrop_flag) n_frag = 1 

      n = 0 
      do i = 1, n_frag 
      do j = 1, n_avirt(i) 
         n = n + 1 
         w_frag_virt(n) = i 
         write(6,*) n, w_frag_virt(n) 
      enddo 
      enddo 

      write(6,*) ' VIRTA list ' 

      n_frag = nfrags 
      if (fdrop_flag) n_frag = 1 

      n = 0 
      do i = 1, n_frag 
      do j = 1, n_avirt(i) 
         n = n + 1 
         w_frag_avirt(n) = i 
         write(6,*) n, w_frag_avirt(n) 
      enddo 
      enddo 

      write(6,*) ' VIRTB list ' 

      n_frag = nfrags 
      if (fdrop_flag) n_frag = 1 

      n = 0 
      do i = 1, n_frag 
      do j = 1, n_bvirt(i) 
         n = n + 1 
         w_frag_bvirt(n) = i 
         write(6,*) n, w_frag_bvirt(n) 
      enddo 
      enddo 


      end 

c finds dsqrt(a*a+b*b) without overflow or destructive underflow

      double precision function pythag(a,b)
      implicit none

      double precision a,b
      double precision p,r,s,t,u,dtmp
      integer i

      p = max(abs(a),abs(b))

      if (p .eq. 0.0d0) then
         pythag = 0.0d0
         return
      end if

      r = min(abs(a),abs(b)) / p
      r = r*r

      i = 0
      do while (i.lt.100)
         t = 4.0d0 + r
         if (t .eq. 4.0d0) then
            pythag = p
            return
         end if
         s = r * (1/t)
         u = 1.0d0 + ( 2.0d0 * s )
         p = p * u
         dtmp = s * (1/u)
         r = r * dtmp * dtmp
         i = i + 1
      end do

c     At this point, the careful algorithm did not converge.
c     Screw it; just calculate the square root.

#ifdef _DEBUG
      write(*,*) '@PYTHAG: The careful algorithm did not converge.'
      write(*,*) '         Calculating by brute force:'
      write(*,*) '         pythag = sqrt( ',a,'**2 + ',b,'**2 )'
#endif
      pythag = sqrt( (a*a) + (b*b) )

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__CLOSE_FILES
     +
     +                    ( UNITID,UNITDB )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__OPEN_FILES
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This operation closes the two sequential files:
C
C                         UNITID : printout file
C                         UNITDB : diagnostic/debug file
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         INTEGER    UNITID,UNITDB
C
C
C------------------------------------------------------------------------
C
C
C             ...close the files.
C
C
         CALL  OFH__CLOSE_UNIT (UNITID)
         CALL  OFH__CLOSE_UNIT (UNITDB)
C
C
C             ...ready!
C
C
         RETURN
         END

c This program writes a drives creation of HYPERCHEM  format file containing 
c the coordinates, frequencies, normal mode vectors and intensities.
c
c for frequencies NORMCO
c 
c Using Ken Wilson's March 1998, Marshall Cory & Ajith Perera, 10/04.

      subroutine hyprchm_main
      implicit double precision (a-h,o-z)
      logical tbohr,hfcrap,linear
C
#include "icore.com"
#include "machsp.com"
#include "flags.com"
#include "istart.com"
#include "flags.h"
C
      maxcor=icrsiz
C
      call getrec(20,'JOBARC','NATOMS',1,natoms)

      iatchrg  = i0
      icoord   = iatchrg  + natoms+mod(natoms,2)
      ifuchrg  = icoord   + 3*natoms*iintfp
      ifucoord = ifuchrg  + natoms+mod(natoms,2)
      ifreqco  = ifucoord + 3*natoms*iintfp
      ifreq    = ifreqco  + 3*natoms*iintfp
      inormmd  = ifreq    + 3*natoms*iintfp
      intnsty  = inormmd  + 9*natoms*natoms*iintfp
      iord     = intnsty  + 3*natoms*iintfp
      itag     = iord     + 3*natoms
      inext    = itag     + 10*natoms
C
      if(inext-i0.gt.maxcor)call insmem('hyprchm-main',inext-i0,
     &                                   maxcor)

      call hyprchm_rd_geomvib(natoms,icore(iatchrg),icore(icoord),
     &                        icore(ifuchrg),icore(ifucoord),
     &                        icore(ifreqco),icore(ifreq),
     &                        icore(inormmd),icore(intnsty),
     &                        icore(iord),hfcrap,linear)


      tbohr = .true.
      if (iflags(h_IFLAGS_vib) .ne.0) hfcrap = .true.

      if(natoms .gt. 1) call wrt_hyprchm( natoms, icore(icoord), 
     .                  icore(ifreq), icore(inormmd), icore(intnsty),
     .                  icore(iatchrg),tbohr,hfcrap,linear,icore(iord),
     .                  icore(itag))

      print *, '@HYPERCHEM: successfully created interface files'

      return
      end

c This program writes a drives creation of HYPERCHEM  format file containing 
c the coordinates, frequencies, normal mode vectors and intensities.
c
c for frequencies NORMCO
c 
c Using Ken Wilson's March 1998, Marshall Cory & Ajith Perera, 10/04.

      subroutine hyprchm_main
      implicit double precision (a-h,o-z)
      logical tbohr,hfcrap,linear
C


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end














c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end













































































































































































































































































































































































































































































C
      maxcor=icrsiz
C
      call getrec(20,'JOBARC','NATOMS',1,natoms)

      iatchrg  = i0
      icoord   = iatchrg  + natoms+mod(natoms,2)
      ifuchrg  = icoord   + 3*natoms*iintfp
      ifucoord = ifuchrg  + natoms+mod(natoms,2)
      ifreqco  = ifucoord + 3*natoms*iintfp
      ifreq    = ifreqco  + 3*natoms*iintfp
      inormmd  = ifreq    + 3*natoms*iintfp
      intnsty  = inormmd  + 9*natoms*natoms*iintfp
      iord     = intnsty  + 3*natoms*iintfp
      itag     = iord     + 3*natoms
      inext    = itag     + 10*natoms
C
      if(inext-i0.gt.maxcor)call insmem('hyprchm-main',inext-i0,
     &                                   maxcor)

      call hyprchm_rd_geomvib(natoms,icore(iatchrg),icore(icoord),
     &                        icore(ifuchrg),icore(ifucoord),
     &                        icore(ifreqco),icore(ifreq),
     &                        icore(inormmd),icore(intnsty),
     &                        icore(iord),hfcrap,linear)


      tbohr = .true.
      if (iflags(54) .ne.0) hfcrap = .true.

      if(natoms .gt. 1) call wrt_hyprchm( natoms, icore(icoord), 
     .                  icore(ifreq), icore(inormmd), icore(intnsty),
     .                  icore(iatchrg),tbohr,hfcrap,linear,icore(iord),
     .                  icore(itag))

      print *, '@HYPERCHEM: successfully created interface files'

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__start
c------------------------------------------------------------------------
c  operation   : ofh__start
c  module      : output files handler
c  module-id   : ofh
c  description : This operation starts the output files handler.
c                The following is done in this routine:
c
c                       1) the logfile is opened.
c                       2) all unit numbers (identifiers) currently
c                          not in use are set free.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         logical    unit_exists

         integer    i
c
c
c------------------------------------------------------------------------
c
c
c             ...set initial values.
c
c
         logfile_exists = .false.

         do i = 2,MAX_OUTPUT_FILES
            file_handle (i)  =  free
         end do
c
c
c             ...open logfile.
c
c
         call  ofh__open_logfile
c
c
c             ...set all i/o units to free with exception of:
c
c                     unit 1  =  logfile
c                     unit 5  =  standard input unit (system)
c                     unit 6  =  standard output unit (system)
c                     unit x  =  all units which are currently in use
c
c
         file_handle (1) = used
         file_handle (5) = used
         file_handle (6) = used

         do i = 2,MAX_OUTPUT_FILES
            if (file_handle (i).eq.free) then
                inquire  (unit   = i,
     +                    exist  = unit_exists)
                if (unit_exists) then
                    file_handle (i) = used
                end if
            end if
         end do
c
c
c             ...print information on screen.
c
c
         write (*,*) ' Logfile opened and all I/O units ready! '
c
c
c             ...ready!
c
c
         return
         end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine translate_key(current_line, key)
c-----------------------------------------------------------------------
c   Translates a SIAL line number into a table of keys used for statistical
c   data collection.
c-------------------------------------------------------------------------
      implicit none
      include 'server_stat.h'

      integer i, current_line, key

c--------------------------------------------------------------------------
c  Searching table of line numbers for a match to the current line number.   
c--------------------------------------------------------------------------

      do i = 1, mx_stat_keys
         if (current_line .eq. lineno(i)) then
            key = i
            return
         endif

c--------------------------------------------------------------------------
c   If lineno(i) is 0, we have reached the end of the line numbers that
c   have already been entered in the table.  Create a new entry and return.
c--------------------------------------------------------------------------

         if (lineno(i) .eq. 0) then
            lineno(i) = current_line
            key = i
            return 
         endif
      enddo

c---------------------------------------------------------------------------
c   No more entries are available.
c---------------------------------------------------------------------------

      key = 0
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine fmult(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Multiplies the each sample of the block given by the array argument by 
c   diagonal eigenvalue matrix.  The eigenvalues matrix is not stored in
c   a 2-dimensional form, since it can be represented by a vector of
c   the diagonal elements.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
       double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, seg
      integer find_current_block
      integer blkndx
      integer*8 indblk, get_block_index
      integer stack
      
      integer comm

      integer val1(mx_array_index), val2(mx_array_index)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif
c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      array = op(c_result_array)
      nindex = array_table(c_nindex, array)
      if (nindex .ne. 2) then
         print *,'Error: FMULT argument must be a 2-dimensional array.'
         call abort_job()
      endif

      do i = 1, nindex
         index = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg = index_table(c_current_seg,index)

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c---------------------------------------------------------------------------
c   Get array data address.
c---------------------------------------------------------------------------

      if (array_table(c_array_type,array) .eq. static_array) then
         addr = address_table(array)
         indblk = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack = array_table(c_array_stack,array)
         indblk = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif 

      if (array_table(c_array_type,array) .eq. static_array) then
         na1 = array_table(c_index_range1, array)
         na2 = array_table(c_index_range2,array)
         ni1 = array_table(c_index_range1+1,array)
         ni2 = array_table(c_index_range2+1,array)
      else
         na1 = val1(1)
         na2 = val2(1)
         ni1 = val1(2)
         ni2 = val2(2)
      endif 

      call eps_mult2(x(indblk), val1(1),val2(1),type(1),
     *                    na1, na2,
     *                    val1(2),val2(2),type(2),ni1,ni2,
     *                    epsilon,epsilonb)    
      
      return
      end

      subroutine eps_mult2(x, i1,i2,itype,ni1,ni2,j1,j2,jtype,
     *                       nj1,nj2,epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer i1,i2,j1,j2
      integer jtype, itype
      integer nj1, nj2, ni1, ni2
      double precision x(ni1:ni2,nj1:nj2)

      double precision epsilon(*), epsilonb(*)

      integer j,i
      double precision eps, epsa, epsi
      double precision val

      if (itype .eq. mobindex) then
         do j = j1, j2
         do i = i1, i2
            x(i,j) = epsilonb(i)*x(i,j)
         enddo
         enddo
      else
         do j = j1, j2
         do i = i1, i2
            x(i,j) = epsilon(i)*x(i,j)
         enddo
         enddo
      endif

      return
      end

      SUBROUTINE T1RA01(ICORE,MAXCOR,IUHF,LAMBDA)
C
C THIS SUBROUTINE COMPUTES ONE OF TWO T1*W CONTRIBUTIONS TO THE
C  W(mbej) INTERMEDIATE.  
C
C           W(MBEJ) = - SUM T(J,F) * <FE||BM> + SUM T(N,B) * <NM||JE>    (1)
C           W(mbej) = - SUM T(j,f) * <fe||bm> + SUM T(n,b) * <nm||je>    (2)
C
C ALSO COMPUTED IS THE T1*W CONTRIBUTIONS TO THE F(ea) INTERMEDIATE
C
C           F(EA)   =  SUM T(M,F) * <FE||MA> = - SUM T(M,F) * <FE||AM>  (3)
C           F(ea)   =  SUM T(m,f) * <fe||ma> = - SUM T(m,f) * <fe||am>  (4)
C
C WHICH ARE OBTAINED BY TAKING GENERALIZED TRACES (N**3 DEPENDENCE) OVER THE
C TERMS CALCULATED IN EQS 1 AND 2.
C
C THIS ROUTINE USES IN-CORE ALGORITHMS!!!
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL LAMBDA
      DOUBLE PRECISION ONE,ONEM,ZILCH,ALPHA,BETA,FACTOR
      CHARACTER*4 SPCASE(2)
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2),ABFULL(8),MNFULL(8),IZOFF(8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,
     &             NF1BB,NF2BB
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
      DATA SPCASE /'AAAA','BBBB'/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
C
C FIRST PICK UP T1 VECTOR.
C
      CALL GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
C
C SPIN CASES AAAA AND BBBB
C
      LSTFEA=92
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=53+ISPIN
       IF(LAMBDA)THEN
        LSTOUT=122+ISPIN
        FACTOR=ONEM
       ELSE
        LSTOUT=LSTTAR
        FACTOR=ONE
       ENDIF 
C
C COMPUTE A,B DPD SIZE FOR ALL IRREPS
C
       DO 1000 IRREP=1,NIRREP
        ICOUNT=0
        ICOUNT2=0
        DO 1001 IRREPE=1,NIRREP
         IRREPF=DIRPRD(IRREPE,IRREP)
         ICOUNT=ICOUNT+VRT(IRREPF,ISPIN)*VRT(IRREPE,ISPIN)
         ICOUNT2=ICOUNT2+POP(IRREPF,ISPIN)*POP(IRREPE,ISPIN)
1001    CONTINUE
        ABFULL(IRREP)=ICOUNT
        MNFULL(IRREP)=ICOUNT2
1000   CONTINUE
C
C LOOP OVER IRREPS - IN THE FIRST BLOCK OF CODE THIS CORRESPONDS TO BM,
C                    WHILE IT IS JE IN THE SECOND BLOCK.
C
C
C FIRST DO THE   W(MBEJ) =  SUM T(J,F) * <FE||BM>  CONTRIBUTION.
C  THE PRODUCT IS INITIALLY PACKED AS A I(BM;EJ) MATRIX.
C
       DO 20 IRREPDO=1,NIRREP
        ALPHA=ONE*FACTOR
        BETA=ONE
        LSTINT=26+ISPIN
        IF(IUHF.EQ.0)LSTINT=30
        DISTAR=aces_list_cols(IRREPDO,22+ISPIN)
        DSZTAR=aces_list_rows(IRREPDO,22+ISPIN)
        DSZW  =aces_list_rows(IRREPDO,LSTINT)
        DISW  =aces_list_cols(IRREPDO,LSTINT)
        DSZEXP=ABFULL(IRREPDO)
        I000=1
        I010=I000+IINTFP*DISTAR*DSZTAR
        I020=I010+DSZEXP*DISW*IINTFP
        I030=I020+DSZW*IINTFP
        if ((i030.lt.0).or.(i030.gt.maxcor)) then
           call insmem('T1RA01',i030,maxcor)
        end if
        CALL IZERO(ICORE,IINTFP*DISTAR*DSZTAR)
C
C READ IN TRANSPOSE OF INTEGRAL MATRIX
C
C RETURNED MATRIX IS I(BM;F<E) [I(bm;f<e)].
C
        IF(IUHF.NE.0)THEN
         CALL GETTRN(ICORE(I010),ICORE(I020),DSZW,DISW,2,IRREPDO,
     &                LSTINT)
        ELSE
         CALL GETTRN(ICORE(I010),ICORE(I020),DSZEXP,DISW,2,IRREPDO,
     &                LSTINT)
         CALL ASSYM2(IRREPDO,VRT(1,1),DISW,ICORE(I010))
        ENDIF
C
C CHANGE MEANINGS OF DSZ AND DIS.
C
        DSZW=DISW
        DISW=DSZEXP
C
C EXPAND TO I(BM;FE) [I(bm;fe)] AND TRANSPOSE KET INDICES.
C
        CALL SYMEXP(IRREPDO,VRT(1,ISPIN),DSZW,ICORE(I010))
C
C NOW LOOP OVER IRREPS OF F AND FORM THE MATRIX PRODUCT
C
C             Z(BME;J) = I(BME;F)*T(F,J)  [ISPIN=1]
C             Z(bme;j) = I(bme;f)*T(f,j)  [ISPIN=2]
C
        IOFFI=I010
        IOFFZ=I000
        DO 4101 IRREPF=1,NIRREP
C
C FIGURE OUT THE DIMENSIONS OF THE MATRICES INVOLVED IN THE 
C   MULTIPLICATION
C 
         IRREPE=DIRPRD(IRREPF,IRREPDO)
         IRREPJ=IRREPF
         NROWI=DSZW*VRT(IRREPE,ISPIN)
         NROWZ=NROWI
         NCOLZ=POP(IRREPJ,ISPIN)
         NCOLI=VRT(IRREPF,ISPIN)
         NROWT=VRT(IRREPF,ISPIN)
         NCOLT=POP(IRREPJ,ISPIN)
         IOFFT=IOFFT1(IRREPJ,ISPIN)
         IF(MIN(NROWI,NCOLT,NCOLI).GT.0)THEN
          CALL XGEMM('N','N',NROWZ,NCOLZ,NCOLI,ALPHA,ICORE(IOFFI),
     &               NROWI,ICORE(IOFFT),NROWT,BETA,ICORE(IOFFZ),
     &               NROWZ)
         ENDIF
         IOFFI=IOFFI+NROWI*NCOLI*IINTFP
         IOFFZ=IOFFZ+NROWZ*NCOLZ*IINTFP
4101    CONTINUE
C
C NOW GET CONTRIBUTION TO F(ea) INTERMEDIATE FROM TRACEOO.
C
        I020=I010+ABFULL(1)*IINTFP
        I030=I020+ABFULL(1)*IINTFP
        IF(.NOT.LAMBDA) THEN
        CALL TRACEOO('VOVO',IRREPDO,POP(1,ISPIN),VRT(1,ISPIN),
     &               DISTAR,ABFULL(1),ICORE(I000),
     &               ICORE(I020))
        CALL SYMTRA(1,VRT(1,ISPIN),VRT(1,ISPIN),1,
     &              ICORE(I020),ICORE(I010))
        CALL SUMSYM3(ICORE(I010),ICORE(I020),ABFULL(1),1,ISPIN,LSTFEA)
        ENDIF
C
C NOW REORDER W(BM;EJ) TO W(JE;MB).
C
        I020=I010+IINTFP*MAX(DSZTAR,DISTAR)
        I030=I020+IINTFP*MAX(DSZTAR,DISTAR)
        I040=I030+IINTFP*MAX(DSZTAR,DISTAR)
        CALL SYMTR1(IRREPDO,VRT(1,ISPIN),POP(1,ISPIN),DSZTAR,
     &              ICORE(I000),ICORE(I020),ICORE(I030),
     &              ICORE(I040))
        CALL SYMTR3(IRREPDO,VRT(1,ISPIN),POP(1,ISPIN),DSZTAR,DISTAR,
     &              ICORE(I000),ICORE(I020),ICORE(I030),ICORE(I040))
        CALL MTRAN2(ICORE(I000),DISTAR)
C
C NOW DO THE  -SUM(N,B) * <NM||JE>  CONTRIBUTION - THIS IS ORDERED
C          B,M-J,E
C
        ALPHA=ONEM*FACTOR
        BETA=ONE
        LSTINT=6+ISPIN
        DISW  =aces_list_cols(IRREPDO,LSTINT)
        DSZW  =aces_list_rows(IRREPDO,LSTINT)
        DSZEXP=MNFULL(IRREPDO)
        I020=I010+DSZEXP*DISW*IINTFP
        I030=I020+DSZW*IINTFP
C
C READ IN TRANSPOSE OF INTEGRAL MATRIX
C
C RETURNED MATRIX IS I(JE;N<M) [I(je;n<m)].
C
        CALL GETTRN(ICORE(I010),ICORE(I020),DSZW,DISW,2,IRREPDO,
     &              LSTINT)
C
C CHANGE MEANINGS OF DSZ AND DIS.
C
        DSZW=DISW
        DISW=DSZEXP
C
C EXPAND TO I(JE;NM) [I(je;nm)] AND THEN NEGATE, GIVING
C       I(JE;MN) [I(je;mn)].
C
        CALL SYMEXP(IRREPDO,POP(1,ISPIN),DSZW,ICORE(I010))
C
C NOW LOOP OVER IRREPS OF F AND FORM THE MATRIX PRODUCT
C
C             Z(JEM;B) = I(JEM;N)*T(B,N)(t)  [ISPIN=1]
C             Z(jem;b) = I(jem;n)*T(b,n)(t)  [ISPIN=2]
C
C FIRST CALCULATE Z MATRIX OFFSETS FOR EACH IRREP OF B.
C
        IZOFF(1)=I000
        DO 5100 IRREP=2,NIRREP
         IRREPB=IRREP-1
         IRREPM=DIRPRD(IRREPB,IRREPDO)
         IZOFF(IRREP)=IZOFF(IRREP-1)+DSZW*POP(IRREPM,ISPIN)*
     &                VRT(IRREPB,ISPIN)*IINTFP
5100    CONTINUE
        IOFFI=I010
        DO 5101 IRREPN=1,NIRREP
C
C FIGURE OUT THE DIMENSIONS OF THE MATRICES INVOLVED IN THE 
C   MULTIPLICATION
C
         IRREPM=DIRPRD(IRREPN,IRREPDO)
         IRREPB=IRREPN
         NROWI=DSZW*POP(IRREPM,ISPIN)
         NCOLI=POP(IRREPN,ISPIN)
         NROWT=POP(IRREPN,ISPIN)
         NCOLT=VRT(IRREPB,ISPIN)
         IOFFT=IOFFT1(IRREPB,ISPIN)
         IOFFZ=IZOFF(IRREPB)
         IF(MIN(NROWI,NCOLT,NCOLI).GT.0)THEN
          CALL XGEMM('N','T',NROWI,NCOLT,NCOLI,ALPHA,ICORE(IOFFI),
     &               NROWI,ICORE(IOFFT),NCOLT,BETA,ICORE(IOFFZ),
     &               NROWI)
         ENDIF
         IOFFI=IOFFI+NROWI*NCOLI*IINTFP
5101    CONTINUE
C
C NOW SWITCH ORDERING TO EJBM AND WRITE THESE QUANTITIES TO DISK FOR
C  EACH IRREP.
C
        I020=I010+IINTFP*MAX(DSZTAR,DISTAR)
        I030=I020+IINTFP*MAX(DSZTAR,DISTAR)
        I040=I030+IINTFP*MAX(DSZTAR,DISTAR)
        CALL SYMTR1(IRREPDO,POP(1,ISPIN),VRT(1,ISPIN),DSZTAR,
     &              ICORE(I000),ICORE(I020),ICORE(I030),ICORE(I040))
        CALL SYMTR3(IRREPDO,POP(1,ISPIN),VRT(1,ISPIN),DSZTAR,DISTAR,
     &              ICORE(I000),ICORE(I020),ICORE(I030),ICORE(I040))
        CALL PUTLST(ICORE(I000),1,DISTAR,2,IRREPDO,LSTOUT)
20     CONTINUE
C
C NOW SWITCH ORDERING TO E,M-B,J
C
       ISCSIZ=NOCCO(ISPIN)*NVRTO(ISPIN)*2
       TARSIZ=ISYMSZ(ISYTYP(1,LSTTAR),ISYTYP(2,LSTTAR))
       I000=1
       I010=I000+TARSIZ*IINTFP
       I020=I010+TARSIZ*IINTFP
       I030=I020+ISCSIZ
       IF(I030.GT.MXCOR)CALL INSMEM('T1RAAAAI',I030,MXCOR)
       CALL GETALL(ICORE(I010),TARSIZ,1,LSTOUT)
       CALL SSTRNG(ICORE(I010),ICORE(I000),TARSIZ,TARSIZ,ICORE(I020),
     &             SPCASE(ISPIN))
C
C   FOR LAMBDA UPDATE TARGET LIST AND COPY ORIGINAL INTERMEDIATES
C   TO LSTOUT
C
       IF(LAMBDA) THEN
        CALL GETALL(ICORE(I010),TARSIZ,1,LSTTAR)
        CALL PUTALL(ICORE(I010),TARSIZ,1,LSTOUT)
        CALL SAXPY(TARSIZ,ONE,ICORE(I010),1,ICORE(I000),1)
       ENDIF
C
       CALL PUTALL(ICORE(I000),TARSIZ,1,LSTTAR)
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine eomroot_print_new(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Calculates the eigenvalues and eigenvectors of a 2-d square matrix.
c   The matrix is also diagonalized on output.
c
c   The eigenvalues are stored in a common block.  
c   The instruction is executed as follows:
c   
c   execute eig Array1 Array2
c
c   where Array1 is the input matrix that is to be diagonalized.
c         Array2 is the matrix whose columns are the eigenvectors of Array1.
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'int_gen_parms.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer i, j, n
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer ind(mx_array_index)
      integer junk

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix.
c---------------------------------------------------------------------------

      array = op(c_result_array)
      evec_array = op(c_op1_array)
      if (array .eq. 0 .or. evec_array .eq. 0) then
         print *,'Error: eom_root_print_new routine requires 
     *            2 array arguments.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      array_type = array_table(c_array_type, array)
      evec_type  = array_table(c_array_type, evec_array)
      if (array_type .ne. static_array .or. 
     *    evec_type .ne. static_array) then
         print *,'Error: Both arrays in eom_root_print_new routine 
     *            must be static.'
         call abort_job()
      endif

#ifdef ALTIX
      dptr = dshptr
#endif

      nindex = array_table(c_nindex, array)
      nindex_evec = array_table(c_nindex, evec_array)
      if (nindex .ne. nindex_evec) then
         print *,'Error: Both arrays in EIG must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex_evec,' indices.'
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      iarray = get_index_from_base(address_table(array), x, 2)
      ievec  = get_index_from_base(address_table(evec_array), x, 2)

CSSS   n = index_table(c_index_size, ind(1))  ! pick up length of index
C Print exactly the number of roots requested in the input

      n = Int(eom_roots)
      call doeomroot_print_new(x(iarray), x(ievec), n)

      return
      end

      subroutine doeomroot_print_new (rootmat,resdmat,n)
      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'parallel_info.h'
      integer i,j,n, ieom_roots, amax  
      double precision rootmat(n,1),resdmat(n,1)
      double precision root,resd
      ieom_roots = eom_roots
      amax = max(ieom_roots,6)

      if (me .eq. 0)then

      write(66,*) ' '
      write(66,'(1x,57("-"))')
      write(66,*) '                      EOM-CCSD energies '
      write(66,99) 'root','Hartree','eV','residuum'
      write(66,'(1x,57("-"))') 
c
      do i = 1, n
         if (i .le. amax) then  
            root = rootmat (i,1)
            resd = resdmat (i,1)
            write(66,100) i, root, root*27.21138505, resd
         endif 
      enddo

      write(66,*) ' '
      write(66,'(1x,57("-"))')
      write(66,'(1x,57("-"))') 
      write(6,*) ' '
c
      endif

 99   format(3x,A4,8x,A7,12x,A2,12x,A8)
100   format(2x,I4,5x,F12.8,5x,F12.8,5x,F12.8)

      return
      end

      subroutine rdcchr(iunit,ncore,igotit)

      implicit double precision (a-h,o-z)
c
c --- <rdcchr> reads the number of core-electrons from
c ---          the ecpdata record
c
c     iunit    : unitnumber of file containing the ecpdata  (input)
c     ncore    : number of core electrons                   (output)
c     igotit   : check of successfull search                (output)
c
      character*80 zeile,scrzl
      character*8 lsymb
      character cdummy
c
      data lsymb /'spdfghij'/

      igotit=-1
c
  100 read(iunit,'(a)',end=900) zeile
        call wisch(zeile,80)
        if(zeile(1:1).eq.' '.or.zeile(1:1).eq.'#') goto 100
c     --- asterisk terminates input
        if(zeile(1:1).eq.'*') goto 900
        icore=index(zeile,'NCORE')
        scrzl=zeile(icore+5:80)
        call rdebbs(scrzl,80,1,0,0,isucc,iwert,rdummy,cdummy)
        if(isucc.le.0) then
          write(6,'(/,2x,a,/)')
     1     'CANNOT READ NCORE = NUMBER OF CORE ELECTRONS'
          return
        else
          igotit=1
        endif
        ncore=iwert
c
      return
c
  900 continue
      write(6,'(/,2x,a,/)') 'RDECP : END OF FILE ENCOUNTERED - SORRY'
      return
c
      end

      SUBROUTINE GENNBO_MAIN
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      CALL GETREC(-1,'JOBARC','NREALATM',1,NATOMS)
      CALL GETREC(-1,'JOBARC','NAOBASFN',1,NBAS)
      CALL GENNBO_GENFILE(NATOMS,NBAS)

      RETURN
      END

      program main
      implicit none

      integer i, j, k1, k2, icomp, ifile, irec

      integer ipack, upackr, upackf
      integer ipack2, upackr2, upackf2

      IPACK(I,J)=IOR(ISHFT(I-49,29),J)
      UPACKR(I) =IAND(I,((2**29)-1))
      UPACKF(I) =IAND(ISHFT(I,-29),7)+49

      ipack2(ifile,irec) = ior(lshift(ifile-49,29),irec)
      upackr2(icomp) = iand(icomp,((2**29)-1))
      upackf2(icomp) = rshift(icomp,29)+49

      do i = 50, 54
         do j = 1, 5
            k1 = ipack(i,j)
            k2 = ipack2(i,j)
            if (k1.ne.k2) print *, 'ipack(',i,',',j,') = ',k1,',',k2
            if (upackr(k1).ne.upackr2(k2))
     &         print *, 'upackr(',k1,') = ',upackr(k1),
     &                '; upackr2(',k2,') = ',upackr2(k2)
            if (upackf(k1).ne.upackf2(k2))
     &         print *, 'upackf(',k1,') = ',upackf(k1),
     &                '; upackf2(',k2,') = ',upackf2(k2),
     &                '; i,j = ',i,j
         end do
      end do

      end

C EMULATOR OF CRAY SCILIB ROUTINE. LOCATES ALL ELEMENTS OF AN INTEGER
C VECTOR (IA) EQUAL TO A PARTICULAR VALUE (TARGET).

c The UNICOS man page for wheneq is appended to this file.
c NOTE: Since Cray computers always use 64-bit integers, the vendor's
c       wheneq accepts both integers and floats in the array argument.
c       This version only accepts integer arrays.

      subroutine wheneq(n,ia,inc,target,index,nn)
      implicit none
      integer n, ia(*), inc, target, index(*), nn
      integer i, ndx


      if (n.lt.0) then
         print *, '@WHENEQ: Assertion failed.'
         print *, '         n = ',n
         call errex
      end if


      if (inc.ge.0) then
         if (inc.eq.1) then
            nn = 0
            do i = 1, n
               if (ia(i).eq.target) then
                  nn = nn + 1
                  index(nn) = i
               end if
            end do
         else
            nn = 0
            ndx = 1
            do i = 1, n
               if (ia(ndx).eq.target) then
                  nn = nn + 1
                  index(nn) = i
               end if
               ndx = ndx + inc
            end do
         end if
c     else if (inc.lt.0) then
      else
         print *, '@WHENEQ: negative increments must be coded'
         call errex
c     end if (inc.ge.0)
      end if

      return
      end

c NAME
c      WHENEQ, WHENNE - Searches a vector for all elements equal or not
c      equal to a target
c
c SYNOPSIS
c      CALL WHENEQ(n,x,incx,target,index,nn)
c      CALL WHENNE(n,x,incx,target,index,nn)
c
c DESCRIPTION
c      WHENEQ searches a real or integer vector for all elements equal to a
c      real or integer target.
c
c      WHENNE searches a real or integer vector for all elements not equal
c      to a real or integer target.
c
c      When using the Cray Fortran compiler UNICOS systems, all arguments
c      must be of default kind unless documented otherwise.  On UNICOS
c      systems, default kind is KIND=8 for integer, real, complex, and
c      logical arguments.
c
c      These routines have the following arguments:
c
c      n      Integer.  (input)
c             Number of elements to be searched.
c
c      x      Real or integer array of dimension (n-1)* |incx| + 1.  (input)
c             Array x containing the vector to be searched.
c
c      incx   Integer.  (input)
c             Increment between elements of the searched array.
c
c      target Real or integer.  (input)
c             Value for which to search in the array.
c
c      index  Integer array of dimension n.  (output)
c             Array index contains the indices in the array elements that
c             match target.
c
c      nn     Integer.  (output)
c             Number of values put in the index array.
c
c NOTES
c      When scanning backward (incx < 0), each routine starts at the end of
c      the vector and moves backward, as follows:
c
c      x(1-incx*(n-1)), x(1-incx*(n-2)), ..., x(1)
c
c      The desired values are at:
c
c      x(1+(index(k)-1)*incx) when incx > 0
c      x(1+(index(k)-n)*incx) when incx < 0
c
c      for all k = 1, 2, ..., nn .

         SUBROUTINE  ERD__2D_K12_ABCD_INTEGRALS
     +
     +                    ( SHELLA,SHELLB,SHELLC,SHELLD,
     +                      DERA,DERB,DERC,DERD,
     +                      NGQEXQ,
     +                      EXP2A,EXP2B,EXP2C,EXP2D,
     +                      DER1,DER2,DER3,DER4,
     +                      INT2D,NNN,SWAP12,SWAP34,
     +
     +                               OUT2D,OUT2D_2 )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_DERV_ABCD_INTEGRALS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single derivation step on
C                the input 2D ABCD integrals:
C
C         I'(n,a,b,c,d) = delta (DERA,1) *
C                         [-a*I(n,a-1,b,c,d) + 2*expa(n)*I(n,a+1,b,c,d)]
C                       + delta (DERB,1) *
C                         [-b*I(n,a,b-1,c,d) + 2*expb(n)*I(n,a,b+1,c,d)]
C                       + delta (DERC,1) *
C                         [-c*I(n,a,b,c-1,d) + 2*expc(n)*I(n,a,b,c+1,d)]
C                       + delta (DERD,1) *
C                         [-d*I(n,a,b,c,d-1) + 2*expd(n)*I(n,a,b,c,d+1)]
C
C                and returns the result in a separate array.
C
C                The derivatives of the 2D integrals are calculated for
C                all roots and the present set of exponent quadruplets.
C                The values of DERA,DERB,DERC and DERD can be only 1
C                or 0. A set of 1's among these variables indicates
C                that these centers were identified as equal.
C
C
C                  Input:
C
C                    SHELLx      =  maximum shell type for centers
C                                   x = A,B,C,D after differentiation
C                    DERx        =  indicator, if differentiation is
C                                   to be performed with respect to
C                                   centers x = A,B,C,D. Two possible
C                                   values: 0 = no differentiation,
C                                   1 = differentiate, i.e. d/dx
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    EXP2x       =  the NGQEXQ exponents x 2 for all
C                                   centers x = A,B,C,D in the
C                                   appropriate order.
C                    INT2D       =  all input 2D ABCD integrals before
C                                   differentiation.
C
C
C                  Output:
C
C                    OUT2D       =  all differentiated 2D ABCD
C                                   integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   FIRST
         LOGICAL   SWAP12,SWAP34

         INTEGER   A,B,C,D,N,NNN
         INTEGER   AM,AP,BM,BP,CM,CP,DM,DP
         INTEGER   DERA,DERB,DERC,DERD
         INTEGER   NGQEXQ,DER1,DER2,DER3,DER4
         INTEGER   SHELLA,SHELLB,SHELLC,SHELLD

         DOUBLE PRECISION  F, FUCK1,FUCK2,FUCK3,FUCK4
         DOUBLE PRECISION  NEGONE,NEGTWO

         DOUBLE PRECISION  EXP2A (1:NGQEXQ)
         DOUBLE PRECISION  EXP2B (1:NGQEXQ)
         DOUBLE PRECISION  EXP2C (1:NGQEXQ)
         DOUBLE PRECISION  EXP2D (1:NGQEXQ)

         DOUBLE PRECISION  INT2D (1:NGQEXQ,0:SHELLA+DERA,
     +                                     0:SHELLB+DERB,
     +                                     0:SHELLC+DERC,
     +                                     0:SHELLD+DERD)
         DOUBLE PRECISION  OUT2D (1:NGQEXQ,0:SHELLA,
     +                                     0:SHELLB,
     +                                     0:SHELLC,
     +                                     0:SHELLD)

         DOUBLE PRECISION  OUT2D_2 (1:NGQEXQ,0:SHELLA,
     +                                       0:SHELLB,
     +                                       0:SHELLC,
     +                                       0:SHELLD)
      



         PARAMETER  (NEGONE = -1.D0)
         PARAMETER  (NEGTWO = -2.D0)
C-------------------------------------------------------------------------
C  Since we calculate integrals of [T12,f12] first derivatives of        | 
C  C and D centers should be taken with minus sign. Second derivatives   |
C  will be generated as a derivatives from first derivatives. So we need |
C  minus sign only once. Variable FUCK will take care of that minus sign |
C-------------------------------------------------------------------------

         FUCK1 = 1.d0
         FUCK2 = 1.d0
         FUCK3 = 1.d0
         FUCK4 = 1.d0 
           
         IF(NNN.eq.1) then 

               IF(.not.SWAP12) THEN
               FUCK1=   1.d0    
               FUCK2=  -1.d0
                 ELSE
               FUCK1=  -1.d0
               FUCK2=   1.d0
               ENDIF

               IF(.not.SWAP34) THEN
               FUCK3 =  1.d0
               FUCK4=  -1.d0
                 ELSE
               FUCK3=  -1.d0
               FUCK4=   1.d0
               ENDIF


         ENDIF
C------------------------------------------------------------------------
C
C
C             ...derivative on center A (if any).
C
         

c         write(6,*) '==================================='
c         write(6,*) DERA,DERB,DERC,DERD
c         write(6,*) '==================================='
C
c    

         FIRST = .TRUE.

c--------Jump to the corresponding derivative-------------------------
         IF(DER1.eq.1) goto 1111
         IF(DER2.eq.1) goto 6666
         IF(DER3.eq.1) goto 7777
         IF(DER4.eq.1) goto 8888
c---------------------------------------------------------------------

1111     continue   
         IF (DERA.EQ.1) THEN

           IF (SHELLA.EQ.0) THEN

             DO 100 D = 0,SHELLD
             DO 100 C = 0,SHELLC
             DO 100 B = 0,SHELLB
             DO 100 N = 1,NGQEXQ
                OUT2D (N,0,B,C,D) = FUCK1*EXP2A (N) * INT2D (N,1,B,C,D)
  100        CONTINUE

           ELSE IF (SHELLA.EQ.1) THEN
             DO 110 D = 0,SHELLD
             DO 110 C = 0,SHELLC
             DO 110 B = 0,SHELLB
             DO 110 N = 1,NGQEXQ
                OUT2D (N,0,B,C,D) = FUCK1*EXP2A (N) * INT2D (N,1,B,C,D)
                OUT2D (N,1,B,C,D) = FUCK1*(EXP2A (N) * INT2D (N,2,B,C,D)
     +                                        - INT2D (N,0,B,C,D) )
  110        CONTINUE

           ELSE

             DO 120 D = 0,SHELLD
             DO 120 C = 0,SHELLC
             DO 120 B = 0,SHELLB
                DO 122 N = 1,NGQEXQ
                 OUT2D (N,0,B,C,D) = FUCK1*EXP2A (N) * INT2D (N,1,B,C,D)
                 OUT2D (N,1,B,C,D) = FUCK1*(EXP2A(N) * INT2D (N,2,B,C,D)
     +                                           - INT2D (N,0,B,C,D))
  122           CONTINUE
                F = NEGTWO
                DO 124 A = 2,SHELLA
                   AM = A - 1
                   AP = A + 1
                   DO 126 N = 1,NGQEXQ
               OUT2D (N,A,B,C,D) = FUCK1*(EXP2A (N) * INT2D (N,AP,B,C,D)
     +                                        + F * INT2D (N,AM,B,C,D) )
  126              CONTINUE
                   F = F + NEGONE
  124           CONTINUE
  120        CONTINUE

           END IF

           FIRST = .FALSE.

         END IF

         goto 9999
C
C
C             ...derivative on center B (if any).
C
C
6666     continue
         IF (DERB.EQ.1) THEN

          IF (FIRST) THEN

           IF (SHELLB.EQ.0) THEN

             DO 200 D = 0,SHELLD
             DO 200 C = 0,SHELLC
             DO 200 A = 0,SHELLA
             DO 200 N = 1,NGQEXQ
                OUT2D (N,A,0,C,D) = FUCK2*EXP2B (N) * INT2D (N,A,1,C,D)
  200        CONTINUE

           ELSE IF (SHELLB.EQ.1) THEN

             DO 210 D = 0,SHELLD
             DO 210 C = 0,SHELLC
                DO 212 A = 0,SHELLA
                DO 212 N = 1,NGQEXQ
                OUT2D (N,A,0,C,D) = FUCK2*EXP2B (N) * INT2D (N,A,1,C,D)
  212           CONTINUE
                DO 214 A = 0,SHELLA
                DO 214 N = 1,NGQEXQ
                OUT2D (N,A,1,C,D) = FUCK2*(EXP2B (N) * INT2D (N,A,2,C,D)
     +                                            - INT2D (N,A,0,C,D) )
  214           CONTINUE
  210        CONTINUE

           ELSE

             DO 220 D = 0,SHELLD
             DO 220 C = 0,SHELLC
                DO 222 A = 0,SHELLA
                DO 222 N = 1,NGQEXQ
                OUT2D (N,A,0,C,D) = FUCK2*EXP2B (N) * INT2D (N,A,1,C,D)
  222           CONTINUE
                DO 224 A = 0,SHELLA
                DO 224 N = 1,NGQEXQ
                OUT2D (N,A,1,C,D) = FUCK2*(EXP2B (N) * INT2D (N,A,2,C,D)
     +                                            - INT2D (N,A,0,C,D) )
  224           CONTINUE
                F = NEGTWO
                DO 226 B = 2,SHELLB
                   BM = B - 1
                   BP = B + 1
                   DO 228 A = 0,SHELLA
                   DO 228 N = 1,NGQEXQ
               OUT2D (N,A,B,C,D) = FUCK2*(EXP2B (N) * INT2D (N,A,BP,C,D)
     +                                        + F * INT2D (N,A,BM,C,D) )
  228              CONTINUE
                   F = F + NEGONE
  226           CONTINUE
  220        CONTINUE

           END IF

           FIRST = .FALSE.

          ELSE
 
           IF (SHELLB.EQ.0) THEN

             DO 230 D = 0,SHELLD
             DO 230 C = 0,SHELLC
             DO 230 A = 0,SHELLA
             DO 230 N = 1,NGQEXQ
                OUT2D (N,A,0,C,D) = OUT2D (N,A,0,C,D) +
     +                              FUCK2*EXP2B (N) * INT2D (N,A,1,C,D)
  230        CONTINUE

           ELSE IF (SHELLB.EQ.1) THEN

             DO 240 D = 0,SHELLD
             DO 240 C = 0,SHELLC
                DO 242 A = 0,SHELLA
                DO 242 N = 1,NGQEXQ
                   OUT2D (N,A,0,C,D) = OUT2D (N,A,0,C,D) +
     +                               FUCK2*EXP2B (N) * INT2D (N,A,1,C,D)
  242           CONTINUE
                DO 244 A = 0,SHELLA
                DO 244 N = 1,NGQEXQ
                   OUT2D (N,A,1,C,D) = OUT2D (N,A,1,C,D) +
     +                              FUCK2*(EXP2B (N) * INT2D (N,A,2,C,D)
     +                                           - INT2D (N,A,0,C,D) )
  244           CONTINUE
  240        CONTINUE

           ELSE

             DO 250 D = 0,SHELLD
             DO 250 C = 0,SHELLC
                DO 252 A = 0,SHELLA
                DO 252 N = 1,NGQEXQ
                   OUT2D (N,A,0,C,D) = OUT2D (N,A,0,C,D) +
     +                               FUCK2*EXP2B (N) * INT2D (N,A,1,C,D)
  252           CONTINUE
                DO 254 A = 0,SHELLA
                DO 254 N = 1,NGQEXQ
                   OUT2D (N,A,1,C,D) = OUT2D (N,A,1,C,D) +
     +                            FUCK2*(EXP2B (N) * INT2D (N,A,2,C,D)
     +                                           - INT2D (N,A,0,C,D) )
  254           CONTINUE
                F = NEGTWO
                DO 256 B = 2,SHELLB
                   BM = B - 1
                   BP = B + 1
                   DO 258 A = 0,SHELLA
                   DO 258 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = OUT2D (N,A,B,C,D) +
     +                             FUCK2*(EXP2B (N) * INT2D (N,A,BP,C,D)
     +                                        + F * INT2D (N,A,BM,C,D) )
  258              CONTINUE
                   F = F + NEGONE
  256           CONTINUE
  250        CONTINUE

           END IF

          END IF

         END IF
         goto 9999
C
C
C             ...derivative on center C (if any).
C
C
c 
7777     continue  
         IF (DERC.EQ.1) THEN

          IF (FIRST) THEN
c             write(6,*) '@@@@@@@@@@@@@@@@@@'

           IF (SHELLC.EQ.0) THEN

             DO 300 D = 0,SHELLD
             DO 300 B = 0,SHELLB
             DO 300 A = 0,SHELLA
             DO 300 N = 1,NGQEXQ
                OUT2D (N,A,B,0,D) = FUCK3*EXP2C (N) * INT2D (N,A,B,1,D)
  300        CONTINUE

           ELSE IF (SHELLC.EQ.1) THEN
c                write(6,*) '@@@@@@@@@@@@@@@@&&&&&&&&&&&&&&&&&@@'
             DO 310 D = 0,SHELLD
                DO 312 B = 0,SHELLB
                DO 312 A = 0,SHELLA
                DO 312 N = 1,NGQEXQ
                 OUT2D (N,A,B,0,D) = FUCK3*EXP2C (N) * INT2D (N,A,B,1,D)
  312           CONTINUE
                DO 314 B = 0,SHELLB
                DO 314 A = 0,SHELLA
                DO 314 N = 1,NGQEXQ
                OUT2D (N,A,B,1,D) = FUCK3*(EXP2C (N) * INT2D (N,A,B,2,D)
     +                                           - INT2D (N,A,B,0,D) )
  314           CONTINUE
  310        CONTINUE

           ELSE

             DO 320 D = 0,SHELLD
                DO 322 B = 0,SHELLB
                DO 322 A = 0,SHELLA
                DO 322 N = 1,NGQEXQ
                 OUT2D (N,A,B,0,D) = FUCK3*EXP2C (N) * INT2D (N,A,B,1,D)
  322           CONTINUE
                DO 324 B = 0,SHELLB
                DO 324 A = 0,SHELLA
                DO 324 N = 1,NGQEXQ
                OUT2D (N,A,B,1,D) = FUCK3*(EXP2C (N) * INT2D (N,A,B,2,D)
     +                                             - INT2D (N,A,B,0,D) )
  324           CONTINUE
                F = NEGTWO
                DO 326 C = 2,SHELLC
                   CM = C - 1
                   CP = C + 1
                   DO 328 B = 0,SHELLB
                   DO 328 A = 0,SHELLA
                   DO 328 N = 1,NGQEXQ
               OUT2D (N,A,B,C,D) = FUCK3*(EXP2C (N) * INT2D (N,A,B,CP,D)
     +                                        + F * INT2D (N,A,B,CM,D) )
  328              CONTINUE
                   F = F + NEGONE
  326           CONTINUE
  320        CONTINUE

           END IF

           FIRST = .FALSE.

          ELSE

           IF (SHELLC.EQ.0) THEN

             DO 330 D = 0,SHELLD
             DO 330 B = 0,SHELLB
             DO 330 A = 0,SHELLA
             DO 330 N = 1,NGQEXQ
                OUT2D (N,A,B,0,D) = OUT2D (N,A,B,0,D) +
     +                        FUCK3* EXP2C (N) * INT2D (N,A,B,1,D)
  330        CONTINUE

           ELSE IF (SHELLC.EQ.1) THEN

             DO 340 D = 0,SHELLD
                DO 342 B = 0,SHELLB
                DO 342 A = 0,SHELLA
                DO 342 N = 1,NGQEXQ
                   OUT2D (N,A,B,0,D) = OUT2D (N,A,B,0,D) +
     +                        FUCK3* EXP2C (N) * INT2D (N,A,B,1,D)
  342           CONTINUE
                DO 344 B = 0,SHELLB
                DO 344 A = 0,SHELLA
                DO 344 N = 1,NGQEXQ
                   OUT2D (N,A,B,1,D) = OUT2D (N,A,B,1,D) +
     +                        FUCK3*(EXP2C (N) * INT2D (N,A,B,2,D)
     +                                         - INT2D (N,A,B,0,D) )
  344           CONTINUE
  340        CONTINUE

           ELSE

             DO 350 D = 0,SHELLD
                DO 352 B = 0,SHELLB
                DO 352 A = 0,SHELLA
                DO 352 N = 1,NGQEXQ
                   OUT2D (N,A,B,0,D) = OUT2D (N,A,B,0,D) +
     +                            FUCK3* EXP2C (N) * INT2D (N,A,B,1,D)
  352           CONTINUE
                DO 354 B = 0,SHELLB
                DO 354 A = 0,SHELLA
                DO 354 N = 1,NGQEXQ
                   OUT2D (N,A,B,1,D) = OUT2D (N,A,B,1,D) +
     +                             FUCK3* (EXP2C (N) * INT2D (N,A,B,2,D)
     +                                         - INT2D (N,A,B,0,D) )
  354           CONTINUE
                F = NEGTWO
                DO 356 C = 2,SHELLC
                   CM = C - 1
                   CP = C + 1
                   DO 358 B = 0,SHELLB
                   DO 358 A = 0,SHELLA
                   DO 358 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = OUT2D (N,A,B,C,D) +
     +                            FUCK3* (EXP2C (N) * INT2D (N,A,B,CP,D)
     +                                        + F * INT2D (N,A,B,CM,D) )
  358              CONTINUE
                   F = F + NEGONE
  356           CONTINUE
  350        CONTINUE

           END IF

          END IF

         END IF
         goto 9999
C
C
C             ...derivative on center D (if any).
C
C
8888     continue    
          

         IF (DERD.EQ.1) THEN


          IF (FIRST) THEN
 
           IF (SHELLD.EQ.0) THEN
             DO 400 C = 0,SHELLC
             DO 400 B = 0,SHELLB
             DO 400 A = 0,SHELLA
             DO 400 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = FUCK4*EXP2D (N) * INT2D (N,A,B,C,1)
  400        CONTINUE

           ELSE IF (SHELLD.EQ.1) THEN

             
             DO 410 C = 0,SHELLC
             DO 410 B = 0,SHELLB
             DO 410 A = 0,SHELLA
             DO 410 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = FUCK4*EXP2D (N) * INT2D (N,A,B,C,1)

  410        CONTINUE
             DO 412 C = 0,SHELLC
             DO 412 B = 0,SHELLB
             DO 412 A = 0,SHELLA
             DO 412 N = 1,NGQEXQ
           OUT2D (N,A,B,C,1) = FUCK4*(EXP2D (N) * INT2D (N,A,B,C,2)
     +       *1.d0 
     +                                       - INT2D (N,A,B,C,0) )


  412        CONTINUE

           ELSE
             DO 420 C = 0,SHELLC
             DO 420 B = 0,SHELLB
             DO 420 A = 0,SHELLA
             DO 420 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = FUCK4*EXP2D (N) * INT2D (N,A,B,C,1)
  420        CONTINUE
             DO 422 C = 0,SHELLC
             DO 422 B = 0,SHELLB
             DO 422 A = 0,SHELLA
             DO 422 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = FUCK4*(EXP2D (N) * INT2D (N,A,B,C,2)
     +                                        - INT2D (N,A,B,C,0) )
  422        CONTINUE
             F = NEGTWO
             DO 424 D = 2,SHELLD
                DM = D - 1
                DP = D + 1
                DO 426 C = 0,SHELLC
                DO 426 B = 0,SHELLB
                DO 426 A = 0,SHELLA
                DO 426 N = 1,NGQEXQ
               OUT2D (N,A,B,C,D) = FUCK4*(EXP2D (N) * INT2D (N,A,B,C,DP)
     +                                       + F * INT2D (N,A,B,C,DM) )
  426           CONTINUE
                F = F + NEGONE
  424        CONTINUE

           END IF

          ELSE

           IF (SHELLD.EQ.0) THEN

             DO 430 C = 0,SHELLC
             DO 430 B = 0,SHELLB
             DO 430 A = 0,SHELLA
             DO 430 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = OUT2D (N,A,B,C,0) +
     +                          FUCK4*EXP2D (N) * INT2D (N,A,B,C,1)
  430        CONTINUE

           ELSE IF (SHELLD.EQ.1) THEN

             DO 440 C = 0,SHELLC
             DO 440 B = 0,SHELLB
             DO 440 A = 0,SHELLA
             DO 440 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = OUT2D (N,A,B,C,0) +
     +                          FUCK4*EXP2D (N) * INT2D (N,A,B,C,1)
  440        CONTINUE
             DO 442 C = 0,SHELLC
             DO 442 B = 0,SHELLB
             DO 442 A = 0,SHELLA
             DO 442 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = OUT2D (N,A,B,C,1) +
     +                       FUCK4*(EXP2D (N) * INT2D (N,A,B,C,2)
     +                                      - INT2D (N,A,B,C,0) )
  442        CONTINUE

           ELSE

             DO 450 C = 0,SHELLC
             DO 450 B = 0,SHELLB
             DO 450 A = 0,SHELLA
             DO 450 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = OUT2D (N,A,B,C,0) +
     +                          FUCK4*EXP2D (N) * INT2D (N,A,B,C,1)
  450        CONTINUE
             DO 452 C = 0,SHELLC
             DO 452 B = 0,SHELLB
             DO 452 A = 0,SHELLA
             DO 452 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = OUT2D (N,A,B,C,1) +
     +                         FUCK4*(EXP2D (N) * INT2D (N,A,B,C,2) 
     +                                      - INT2D (N,A,B,C,0) )
  452        CONTINUE
             F = NEGTWO
             DO 454 D = 2,SHELLD
                DM = D - 1
                DP = D + 1
                DO 456 C = 0,SHELLC
                DO 456 B = 0,SHELLB
                DO 456 A = 0,SHELLA
                DO 456 N = 1,NGQEXQ
                   OUT2D (N,A,B,C,D) = OUT2D (N,A,B,C,D) +
     +                         FUCK4*( EXP2D (N) * INT2D (N,A,B,C,DP)
     +                                     + F * INT2D (N,A,B,C,DM) )
  456           CONTINUE
                F = F + NEGONE
  454        CONTINUE

           END IF

          END IF

         END IF
C
9999      continue
C
C             ...ready!
C
C--------Copy second derivatives into the scratch array---------------

         IF(NNN.eq.2) then

          IF(DER1.eq.1) then
c----------Accumulate second derivatives in OUT2D_2 array ------------
             DO D = 0,SHELLD
             DO C = 0,SHELLC
             DO B = 0,SHELLB
             DO A = 0,SHELLA 
              DO N = 1,NGQEXQ
              OUT2D_2 (N,A,B,C,D) = OUT2D (N,A,B,C,D)
              ENDDO
             ENDDO
             ENDDO
             ENDDO
             ENDDO
            
          ELSE
              
             DO D = 0,SHELLD
             DO C = 0,SHELLC
             DO B = 0,SHELLB
             DO A = 0,SHELLA
              DO N = 1,NGQEXQ
              OUT2D_2 (N,A,B,C,D) = OUT2D_2 (N,A,B,C,D) + 
     &                                     OUT2D (N,A,B,C,D)
              ENDDO
             ENDDO
             ENDDO
             ENDDO
             ENDDO
c------------Copy the sum of second derivatives to OUT2D array----------
          ENDIF

          IF(DER4.eq.1) then
             DO D = 0,SHELLD
             DO C = 0,SHELLC
             DO B = 0,SHELLB
             DO A = 0,SHELLA
              DO N = 1,NGQEXQ
              OUT2D (N,A,B,C,D) = OUT2D_2 (N,A,B,C,D)
              ENDDO
             ENDDO
             ENDDO
             ENDDO
             ENDDO
      

          ENDIF
 
         ENDIF

         RETURN
         END

      subroutine ecpget(npecp,cnick,natoms,ishow)

      implicit double precision (a-h,o-z)
c
c --- this subroutine reads ecp data for unique ecp definitions
c     and assigns arrays llmax,nelecp,kfirst and klast indexed
c     by atoms (not by unique ecp definitions) ---
c
c     ipseux   : index of ecp belonging to an atom
c     npecp    : number of primitive terms per ecp
c     llmax    : maximum l-quantum number of ecp
c     nelecp   : number of core electrons per atom
c     clp,nlp,zlp   : specifications of primitive terms
c     cnick    : nicknames of ecp's
c
c     kfirst, klast: gives the starting and ending points
c                    for each angular momentum blocks (first
c                    U(llmax) U(0-llmax)
c  --- note : atoms with no ecp are marked by nelecp=0
c
#include "ecp.par"
#include "ecp.com"
C
      dimension npecp(natoms),lfirst(lmxecp),llast(lmxecp)
      character*80 filnam,zeile
      character*80 cnick(natoms)

c --- look for the flag $ecp in control file fcntri and get 
c     alternate file name if specified ---
c
      iunit=44
      filnam='ECPDATA'
c
c --- now we are ready for reading
c
      lenfil=index(filnam,' ')-1
      Write(6,*)
      write(6,'(3a)') ' Reading data block $ecp from file <',
     1                  filnam(1:lenfil),'>'
      open(unit=iunit,file=filnam(1:lenfil),form='formatted')

      necp=0
      do 10 i=1,natoms
         if(ipseux(i).gt.necp) necp=ipseux(i)
   10 continue

      if(necp.eq.0) return
c
c loop over ecp sets in $ecp data block :
c
      do 400 iecp=1,necp
C
      call getstr(iunit,1,igotit,zeile,cnick(iecp))
c
      if(igotit.le.0) then
        write(6,4091) cnick(iecp),filnam(1:lenfil)
 4091   format(/,1x,' ECPGET ABEND : ECP SET WITH NICKNAME ',A,/,
     1           1x,' IS NOT CONTAINED WITHIN FILE ',A,/)
        goto 999
      endif
c
  11  call getstr(iunit,-1,ifound,zeile,'*')
c
c '*' has to be the first character in the line :

      if(ifound.gt.1) goto 11

      if(ifound.gt.0) call rdecp(iunit,iecp,npecp,nelecp(iecp),
     1   llmax(iecp),kfirst(1,iecp),klast(1,iecp),nlp,clp,zlp,
     2   lmxecp,Mxecpprim,igotit)
c
      if(igotit.le.0 .or. ifound.le.0) then
        write(6,4092) cnick(iecp)
 4092   format(/,1x,' ecpget abend : ecp set with nickname ',a,/,
     1           1x,' cannot be read in properly ',/)
        goto 999
      endif
c
  400 continue
c
C --- icopy is the number of ecp's already assigned
C
      icopy=0

   15 iecp=0
   20 iecp=iecp+1
      if(iecp.gt.necp) goto 15
      iwhere=iecp

   25 iat=iattop(iecp,natoms,ipseux)

      if(iat.eq.0) goto 20

      if(iat.eq.iecp) then
        ipseux(iat)=-ipseux(iat)
        icopy=icopy+1
        if(icopy.eq.necp) goto 90
        goto 20
      endif

      if(iat.gt.necp) then

        nelecp(iat)=nelecp(iwhere)
        llmax(iat)=llmax(iwhere)

        do k=1,llmax(iwhere)+1
          kfirst(k,iat)=kfirst(k,iwhere)
          klast(k,iat)=klast(k,iwhere)
        enddo
      
        ipseux(iat)=-ipseux(iat)
        icopy=icopy+1
        if(icopy.eq.necp) goto 90
        goto 20

      endif

      nelecs=nelecp(iat) 
      llmaxs=llmax(iat)

      do k=1,llmax(iat)+1
        lfirst(k)=kfirst(k,iat)
        llast(k)=klast(k,iat)
      Enddo
c
c --- iwhere is the location of ecp data to be assigned 
c
      nelecp(iat)=nelecp(iwhere)
      llmax(iat)=llmax(iwhere)

      do  k=1,llmax(iwhere)+1
        kfirst(k,iat)=kfirst(k,iwhere)
        klast(k,iat)=klast(k,iwhere)
      Enddo

      ipseux(iat)=-ipseux(iat)
      icopy=icopy+1
      if(icopy.eq.necp) goto 90

      nelecp(iwhere)=nelecs
      llmax(iwhere)=llmaxs

      do k=1,llmax(iwhere)+1
        kfirst(k,iwhere)=lfirst(k)
        klast(k,iwhere)=llast(k)
      Enddo

c  --- number of the ecp which is to be assigned next
      iecp=iat
      goto 25

   90 continue

      do 100 iat=1,natoms
        if(ipseux(iat).lt.0) ipseux(iat)=-ipseux(iat)
  100 continue

c  --- assign remaining data

      if(necp.eq.natoms) return

      do 200 iat=1,natoms
        iecp=ipseux(iat)

        if(iecp.eq.0) then
          nelecp(iat)=0
          goto 200
        endif

        iwhere=iattop(iecp,natoms,ipseux) 
        if(iwhere.eq.iat) goto 200
        nelecp(iat)=nelecp(iwhere)
        llmax(iat)=llmax(iwhere)

        do k=1,llmax(iwhere)+1
          kfirst(k,iat)=kfirst(k,iwhere)
          klast(k,iat)=klast(k,iwhere)
        Enddo

  200 continue
c
      close(iunit)
      return
c
  999 continue
      write(6,901)
  901 format(/,1x,' <ECPGET> : CANNOT ASSIGN ECP DATA ',/)
      close(iunit)
      CALL ERREX
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_program_context(instruction, start_context,
     *                               end_context)
c----------------------------------------------------------------------------
c   Sets the current program instruction execution context.
c----------------------------------------------------------------------------
      implicit none
      include 'context.h'
      integer instruction, start_context, end_context

      iop      = instruction
      start_op = start_context
      end_op   = end_context 
      return
      end

      subroutine get_program_context(instruction, start_context,
     *                               end_context)
c----------------------------------------------------------------------------
c   Returns the current program instruction execution context.
c----------------------------------------------------------------------------
      implicit none
      include 'context.h'
      integer instruction, start_context, end_context

      instruction   = iop
      start_context = start_op
      end_context   = end_op
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine prestrict

     +                     (array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)

c--------------------------------------------------------------------------
c   
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'pst_functions.h'
      include 'int_gen_parms.h'
      include 'restrict_pardo.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base, daddr
      integer i, j, n1, n2, n3, n4
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer evec_array1, evec_type1, nindex_evec1
      integer sind, sind1, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index),
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer*8 get_block_index
      integer stack

      integer pcount

      integer nakuldebug

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the scalars. --> bproc and eproc  
c---------------------------------------------------------------------------

      evec_array  = op(c_result_array)
      evec_type   = array_table(c_array_type, evec_array)
      nindex_evec = array_table(c_nindex, evec_array)

      evec_array1 = op(c_op1_array)
      evec_type1  = array_table(c_array_type, evec_array1)
      nindex_evec1= array_table(c_nindex, evec_array1)


      if (evec_type .ne. scalar_value) return
      if (evec_type1.ne. scalar_value) return

      sind =  scalar_table(array_table(c_scalar_index, evec_array))
      sind1=  scalar_table(array_table(c_scalar_index, evec_array1))

c     if (evec_array .lt. 1 .or. evec_array .gt. nscalar_table) then
c        print *,'Scalar table index 1 out of range in prestrict, ',
c    *           'line ',current_line
c        print *,'Index for array ',evec_array,'is',sind,' should be ',
c    *           'between 1 and ',nscalar_table
c        call abort_job()
c     endif

c     if (evec_array1.lt. 1 .or. evec_array1 .gt. nscalar_table) then
c        print *,'Scalar table index 2 out of range in prestrict, ',
c    *           'line ',current_line
c        print *,'Index for array ',evec_array,'is',sind1,' should be ',
c    *           'between 1 and ',nscalar_table
c        call abort_job()
c     endif

c     write(6,*) ' SIND :', sind, sind1 

      pcount = 0
      do i = 1, nprocs
         if (pst_get_company(i-1) .eq. io_company_id) then
c           write(6,*) ' IO SERVER :', i
            do_prestrict(i) = 0
         else
            pcount = pcount + 1
            if (pcount .ge. sind .and. pcount .le. sind1) then
               do_prestrict(i) = 1
            else
               do_prestrict(i) = 0
            endif
c           write(6,*) ' WORKER :', i
         endif
c         print *, i, do_prestrict(i), ' in prestrict'
      enddo

c       nakuldebug = 0

c       do i = 1, nprocs
c           if (do_prestrict(i) .eq. 1) 
c     *          nakuldebug = nakuldebug +1
c       enddo

c      print *, me, ' ', nakuldebug
c       if (nakuldebug .ne. 24 .and. 
c     *      nakuldebug .ne. 4. and.
c     *      nakuldebug .ne. 17)
c     *      print *, ' corrupted do_prestrict table'



c     write(6,*) ' DO_PRESTRICT:', (do_prestrict(i), i=1, nprocs) 


      return
      end

c This routine stores the transpose of a rectangular matrix to the upper-left
c rectangular submatrix of an MOIO array. For a stored matrix
c dList(1:nRows,1:nCols) and given the input dSrc(1:iCol,1:iRow), the updated
c stored data would be dList(1:iRow:nRows,1:iCol:nCols).

c INPUT
c double DSRC(ICOL,IROW) : the transposed source array
c double DSCR(*) : scratch array to hold at least one column of the MOIO array
c int IROW   : number of rows    in the submatrix (columns in the transpose)
c int ICOL   : number of columns in the submatrix (rows    in the transpose)
c int IJUNK  : (obsolete integer)
c int ILEFT  : the left  MOIO index
c int IRIGHT : the right MOIO index

      subroutine puttrn(dSrc,dScr,iRow,iCol,iJunk,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iRow, iCol, iJunk, iLeft, iRight
      double precision dSrc(iCol,iRow), dScr(*)

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer i

c ----------------------------------------------------------------------


      i = 0
c   o assert dimensions are properly bound (zero rows or cols returns)
      if ((iRow.lt.0).or.(iRow.gt.aces_list_rows(iLeft,iRight)).or.
     &    (iCol.lt.0).or.(iCol.gt.aces_list_cols(iLeft,iRight))
     &   ) then
         print *, '@PUTTRN: Assertion failed.'
         print *, '   MOIO list = ',iLeft,iRight
         print *, '   MOIO rows = ',aces_list_rows(iLeft,iRight)
         print *, '   MOIO cols = ',aces_list_cols(iLeft,iRight)
         print *, '   iRow = ',iRow
         print *, '   iCol = ',iCol
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)


c ----------------------------------------------------------------------

      if ((iRow.lt.1).or.(iCol.lt.1)) return

      if (iRow.eq.aces_list_rows(iLeft,iRight)) then
         do i = 1, iCol
            call dcopy(iRow,dSrc(i,1),iCol,dScr,1)
            call putlst(dScr,i,1,0,iLeft,iRight)
         end do
      else
         do i = 1, iCol
            call getlst(dScr,i,1,0,iLeft,iRight)
            call dcopy(iRow,dSrc(i,1),iCol,dScr,1)
            call putlst(dScr,i,1,0,iLeft,iRight)
         end do
      end if

      return
c     end subroutine puttrn
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_subrange_segments(superindex, superseg, sindex,
     *                              index_table, nindex_table,
     *                              segment_table, nsegment_table,
     *                              bseg, eseg)
c----------------------------------------------------------------------------
c   Looks up the beginning and ending segments of the sindex relative to 
c   the current segment of its superindex.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer sindex, nindex_table, nsegment_table, bseg, eseg
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)

      integer superindex, superseg, r1, r2
      integer i, r1min, r2max, r1sub, r2sub

c----------------------------------------------------------------------------
c   Look up relevant superindex info.
c----------------------------------------------------------------------------

      r1 = segment_table(c_range1,superseg)
      r2 = segment_table(c_range2,superseg)

c---------------------------------------------------------------------------
c   Search segment table.
c---------------------------------------------------------------------------

      r1min = 100000000
      r2max = 0
      bseg = 0
      eseg = 0

      do i = 1, nsegment_table
         if (segment_table(c_index,i) .eq. sindex) then
            r1sub = segment_table(c_range1,i)
            r2sub = segment_table(c_range2,i)

            if (r1sub .ge. r1 .and. r2sub .le. r2) then
               if (r1sub .le. r1min) then
                  r1min = r1sub
                  bseg  = segment_table(c_segment,i)
               endif
 
               if (r2sub .ge. r2max) then
                  r2max = r2sub
                  eseg  = segment_table(c_segment,i)
               endif
            endif
         endif
      enddo

      if (bseg .eq. 0 .or. eseg .eq. 0) then
         print *,'Error in get_subrange_segments: bseg, eseg ',
     *           bseg,eseg
         print *,'Superindex, superseg, sindex ',
     *        Superindex, superseg, sindex
         call abort_job()
      endif
 
      return
      end
 

      Subroutine Ang_int(L, M, Ii, Jj, Kk, Lam, Mu, Angi)
      
      Implicit Double Precision (A-H, O-Z)
C
#include "ecp.par"
#include "ecp.com"
     
      Id = L*(L+1) - M + 1

      IMn = Lmf(Id)
      Imx = Lmf(Id+1) - 1
   
      JD = Lam*(Lam+1) - Mu + 1
     
      JMn = Lmf(Jd)
      Jmx = Lmf(Jd+1) - 1
C
      Angi = 0.0D0

#ifdef _DEBUG_LVLM1
      Write(6,"(a,9(1x,I3))") "At entry to Ang_int ", II,JJ,KK,
     &                          lam,mu,Imn,Imx,Jmn,Jmx
#endif

      Do I = Imn, Imx
         Angj = 0.D0
         Do J = Jmn, Jmx
            Jx = Lmx(I) + Ii + Lmx(J) 
            Jy = Lmy(I) + Jj + Lmy(J) 
            Jz = Lmz(I) + Kk + Lmz(J) 
            Angj = Angj + Zlm(j)*Fijk(Jx, Jy, Jz)
C
#ifdef _DEBUG_LVLM1
      Write(6,*) "The angular part of Ints"
      Write(6,"(3(1x,i2),3(1x,F15.8))"), jx,jy,jz,
     &          Zlm(J),Fijk(Jx, Jy, Jz),angj
#endif
         Enddo
         Angi = Angi + Angj*Zlm(i)
C
      Enddo
     
      Return
      End
            
           

      SUBROUTINE FANCYGET(Z,BUF,GETTYP,PERM,NUMP,NUMQ,NUMR,NUMS,
     &                    IFIRST,NUMREC,ICACHE,IRREPGET,LIST)
C
C WITH THIS SUBROUTINE, CERTAIN GAMES CAN BE PLAYED WITH I/O
C  WHICH ALLOW SOME CONTRACTIONS TO BE CARRIED OUT EASILY WITH
C  MATRIX MULTIPLICATION.  THE PURPOSE OF THE ROUTINE IS TO READ
C  A SYMMETRY PACKED FOUR-INDEX LIST [I(PQ,RS) OR I(P<Q,RS) WITH 
C  A GAMMA(PQ)=GAMMA(RS) DPD] ACCORDING TO AN ALTERNATIVE DPD.
C  SPECIFICALLY IT ALLOWS THE FOLLOWING:
C
C          ON DISK                  READ AS
C          -------                  -------
C         I(PQ,RS)        I(PS,RQ), I(PS,QR), I(PR,QS) OR I(PR,SQ)
C         I(PQ,RS)                 I(RQ,PS), I(QR,PS) OR I(QS,PR)
C         I(P<Q,RS)       I(PS,RQ), I(PS,QR), I(PR,QS) OR I(PR,SQ)
C         I(P<Q,RS)                I(RQ,PS), I(QR,PS)
C         
C
C THIS ROUTINE ACCESSES ALL IRREPS FOR A GIVEN LIST TO FILL ONE
C  IRREP OF THE ALTERNATIVE DPD LIST, AND THEREFORE SHOULD BE USED
C  ONLY WHEN THE REORDERING CANNOT BE DONE EASILY IN CORE.  THE
C  DISK ACCESS IS SEQUENTIAL WITH NON-SEQUENTIAL MEMORY ADDRESSING.
C
C INPUT:
C       Z - TARGET VECTOR FOR I/O OPERATIONS (AS IN GETLST).
C     BUF - SCRATCH ARRAY.  THE LENGTH OF THIS ARRAY MUST BE
C            AT LEAST THAT OF THE LARGEST LOGICAL RECORD FOR
C            THIS SPECIFIC LIST (MAX(IRPDPD(1..NIRREP,ISYTYP(1,LIST)).
C  GETTYP - REFERS TO THE MODE OF STORAGE AND THE WAY THAT THE
C            ARRAY WILL BE READ. (CHARACTER*2) 
C
C            'FF' - ARRAY IS STORED ON DISK AS I(PQ,RS)
C            'PF' - ARRAY IS STORED ON DISK AS I(P<Q,RS)
C
C            ("P" REFERS TO PACKED, "F" TO FULL)
C
C    NUMP - POPULATION BY IRREP CORRESPONDING TO FASTEST LEFT INDEX ON DISK.
C    NUMQ - POPULATION BY IRREP CORRESPONDING TO SLOWEST LEFT INDEX ON DISK.
C    NUMR - POPULATION BY IRREP CORRESPONDING TO FASTEST RIGHT INDEX ON DISK.
C    NUMS - POPULATION BY IRREP CORRESPONDING TO SLOWEST RIGHT INDEX ON DISK.
C
C    PERM - PERMUTATION TYPE FOR DPD (CHARACTER*4)
C 
C            '1432' - I(PQ,RS) -> I(PS,RQ)
C            '1423' - I(PQ,RS) -> I(PS,QR)
C            '1324' - I(PQ,RS) -> I(PR,QS)
C            '1342' - I(PQ,RS) -> I(PR,SQ)
C
C  IFIRST - FIRST LOGICAL RECORD OF *ALTERNATIVE DPD* WHICH IS
C           REQUIRED (LIKE GETLST).
C  NUMREC - THE NUMBER OF LOGICAL RECORDS TO RETRIEVE (LIKE GETLST).
C  ICACHE - THE I/O CACHE TO BE USED (LIKE GETLST).
CIRREPGET - THE IRREP OF THE ALTERNATIVE DPD WHICH IS REQUESTED
C           (LIKE GETLST).
C    LIST - THE MOINTS LIST NUMBER (LIKE GETLST).
C
C ***IMPORTANT*** 
C   1. THIS ROUTINE HAS NOT BEEN EXTENSIVELY DEBUGGED.  DO NOT
C      ASSUME THAT IT IS CORRECT FOR ALL CASES.
C   2. PRESENTLY, THE ARGUMENTS IFIRST AND NUMREC ARE IGNORED, AND
C      THIS ROUTINE WILL RETRIEVE THE FULL LIST FOR A GIVEN IRREP.
C   3. CURRENTLY, THE ROUTINE CAN NOT HANDLE LISTS WITH PACKED KET
C      INDICES.  THIS MAY BE ADDED IF THE NEED ARISES.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(1),BUF(1)
      CHARACTER*2 GETTYP
      CHARACTER*4 PERM
      EQUIVALENCE (ONDISK(1),ICOUNT1)
      EQUIVALENCE (ONDISK(2),ICOUNT2)
      EQUIVALENCE (ONDISK(3),ICOUNT3)
      EQUIVALENCE (ONDISK(4),ICOUNT4)
      DIMENSION DISDSK(8,8),DSZDSK(8,8),DISMEM(8,8),DSZMEM(8,8)
      DIMENSION NUMP(8),NUMQ(8),NUMR(8),NUMS(8),PQFULL(8),DSZPCK(8)
      DIMENSION NUMP2(8),NUMQ2(8),NUMR2(8),NUMS2(8),IPTR(4)
      DIMENSION IRPTAR(4),ONDISK(4),IPTRI(4)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPX(255,2),DIRPRD(8,8)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      INDX(I,J,N)=I+(J-1)*N
C
C COMPUTE OFFSETS INTO DISTRIBUTIONS AND OFFSETS INTO DISTRIBUTION
C  MEMBERS.
C
      IF(PERM.EQ.'1432')THEN
       CALL ICOPY(NIRREP,NUMP,1,NUMP2,1)
       CALL ICOPY(NIRREP,NUMS,1,NUMQ2,1)
       CALL ICOPY(NIRREP,NUMR,1,NUMR2,1)
       CALL ICOPY(NIRREP,NUMQ,1,NUMS2,1)
       IPTR(1)=1
       IPTR(2)=4
       IPTR(3)=3
       IPTR(4)=2
       IPTRI(1)=1
       IPTRI(2)=4
       IPTRI(3)=3
       IPTRI(4)=2
      ELSEIF(PERM.EQ.'1423')THEN
       CALL ICOPY(NIRREP,NUMP,1,NUMP2,1)
       CALL ICOPY(NIRREP,NUMQ,1,NUMR2,1)
       CALL ICOPY(NIRREP,NUMR,1,NUMS2,1)
       CALL ICOPY(NIRREP,NUMS,1,NUMQ2,1)
       IPTR(1)=1
       IPTR(2)=3
       IPTR(3)=4
       IPTR(4)=2
       IPTRI(1)=1
       IPTRI(2)=4
       IPTRI(3)=2
       IPTRI(4)=3
      ELSEIF(PERM.EQ.'1324')THEN
       CALL ICOPY(NIRREP,NUMP,1,NUMP2,1)
       CALL ICOPY(NIRREP,NUMQ,1,NUMR2,1)
       CALL ICOPY(NIRREP,NUMR,1,NUMQ2,1)
       CALL ICOPY(NIRREP,NUMS,1,NUMS2,1)
       IPTR(1)=1
       IPTR(2)=3
       IPTR(3)=2
       IPTR(4)=4
       IPTRI(1)=1
       IPTRI(2)=3
       IPTRI(3)=2
       IPTRI(4)=4
      ELSEIF(PERM.EQ.'1342')THEN 
       CALL ICOPY(NIRREP,NUMP,1,NUMP2,1)
       CALL ICOPY(NIRREP,NUMQ,1,NUMS2,1)
       CALL ICOPY(NIRREP,NUMR,1,NUMQ2,1)
       CALL ICOPY(NIRREP,NUMS,1,NUMR2,1)
       IPTR(1)=1
       IPTR(2)=4
       IPTR(3)=2
       IPTR(4)=3
       IPTRI(1)=1
       IPTRI(2)=3
       IPTRI(3)=4
       IPTRI(4)=2
      ENDIF
      DO 10 IRREPON=1,NIRREP
       IOFFDS1=1
       IOFFDZ1=1
       IOFFDS2=1
       IOFFDZ2=1
       DO 20 IRREPQS=1,NIRREP
        IRREPPR=DIRPRD(IRREPQS,IRREPON)
        DISDSK(IRREPQS,IRREPON)=IOFFDS1
        DSZDSK(IRREPQS,IRREPON)=IOFFDZ1
        DISMEM(IRREPQS,IRREPON)=IOFFDS2
        DSZMEM(IRREPQS,IRREPON)=IOFFDZ2
        IOFFDS1=IOFFDS1+NUMR(IRREPPR)*NUMS(IRREPQS)
        IOFFDZ1=IOFFDZ1+NUMP(IRREPPR)*NUMQ(IRREPQS)
        IOFFDS2=IOFFDS2+NUMR2(IRREPPR)*NUMS2(IRREPQS)
        IOFFDZ2=IOFFDZ2+NUMP2(IRREPPR)*NUMQ2(IRREPQS)
20     CONTINUE
       PQFULL(IRREPON)=IOFFDZ1-1
       DSZPCK(IRREPON)=IRPDPD(IRREPON,ISYTYP(1,LIST))
       IF(IRREPON.EQ.IRREPGET)THEN
        DSZTAR=IOFFDZ2-1
        DISTAR=IOFFDS2-1
       ENDIF
10    CONTINUE
C
C
C LOOP THROUGH ALL IRREPS FOR THIS LIST.
C
      DO 110 IRREPON=1,NIRREP
       LOGREC=0
C
C LOOP OVER ALL IRREP PAIRS SUCH THAT DIRPRD(IRREPR,IRREPS)=IRREPDO
C  AND DETERMINE IRREPS OF P2,Q2,R2,S2 (TARGET INDICES - IRPTAR) 
C  FROM THIS INFORMATION.
C
       DO 120 IRREPS=1,NIRREP
        CALL IZERO(IRPTAR,4)
        IRPTAR(IPTR(4))=IRREPS
        IRREPR=DIRPRD(IRREPS,IRREPON)
        IRPTAR(IPTR(3))=IRREPR
        CALL FILIRP(IRPTAR,IRREPGET)
        IRREPQ=IRPTAR(IPTR(2))
        IRREPP=IRPTAR(IPTR(1))
        IOFFS2=DISMEM(IRPTAR(4),IRREPGET)-1
        IOFFQ2=DSZMEM(IRPTAR(2),IRREPGET)-1
C
C READ ALL LOGICAL RECORDS FOR THIS IRREPR,IRREPS SET
C
        DO 130 ICOUNT4=1,NUMS(IRREPS)
         DO 140 ICOUNT3=1,NUMR(IRREPR)
          LOGREC=LOGREC+1
          CALL GETLST(BUF,LOGREC,1,1,IRREPON,LIST)
          IF(GETTYP(1:1).EQ.'P')THEN
           CALL SYMEXP2(IRREPON,NUMP,PQFULL(IRREPON),
     &                   DSZPCK(IRREPON),1,BUF,BUF)
          ENDIF
C
C NOW EACH RECORD HAS SOME STUFF THAT WE WANT.  LOCATE STARTING 
C  POINT FOR THE BLOCK OF VALUES WHICH WE WANT.
C
          ISTART=DSZDSK(IRREPQ,IRREPON)
C
C NOW LOOP OVER THE Q VALUES, CALCULATE ADDRESSES IN THE
C  TARGET VECTOR AND PUT THE ELEMENTS IN POSITION.
C  
          DO 150 ICOUNT2=1,NUMQ(IRREPQ)
           LENGTH=NUMP(IRREPP)
C
C CALCULATE THE DISTRIBUTION NUMBER THAT THIS R2,S2 PAIR CORRESPONDS TO
C   WITHIN THE IRREPS2 BLOCK AND ABSOLUTE STARTING ADDRESS FOR THE
C   (XXR2S2) DISTRIBUTION.
C
           DISOFF1=IOFFS2+INDX(ONDISK(IPTRI(3)),ONDISK(IPTRI(4)),
     &                          NUMR2(IRPTAR(3)))
           DISREL=DISOFF1-IFIRST+1
           IF(DISREL.LE.NUMREC.AND.DISREL.GT.0)THEN
            IADDR1 =INDX(1,DISrel,DSZTAR)
c            IADDR1 =INDX(1,DISOFF1,DSZTAR)
C
C NOW CALCULATE RELATIVE OFFSET WITHIN THIS DISTRIBUTION FOR THIS
C  VALUE OF S.
C
            IADDR2 =IOFFQ2+INDX(1,ONDISK(IPTRI(2)),NUMP2(IRPTAR(1)))
C
C CALCULATE TOTAL ABSOLUTE ADDRESS AND PUT ELEMENTS IN POSITION 
C
            OFFSET=IADDR1+IADDR2-1
            CALL SCOPY(LENGTH,BUF(ISTART),1,Z(OFFSET),1)
           endif
           ISTART=ISTART+LENGTH
150       CONTINUE
140      CONTINUE
130     CONTINUE
120    CONTINUE
110   CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine build_company(id, nmgr, mgr_mem, nwrkr, wrkr_mem)
c-------------------------------------------------------------------------
c   
c   Configures the data for a company, and saves it in a table.
c
c   Arguments:
c	id			Integer identifier for the company.
c	nmgr			Number of managers in the company.
c	mgr_mem			Memory (in Mbytes) for each manager.
c	nwrkr			Number of workers in the company.
c	wrkr_mem		Memory (in Mbytes) for each worker.
c
c-------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'company.h'

      integer id, nmgr, mgr_mem, nwrkr, wrkr_mem
      integer i, ierr

c--------------------------------------------------------------------------
c   Find the first unused entry in c_table.
c--------------------------------------------------------------------------

      do i = 1, max_company
         if (c_table(i,c_company_id) .eq. MPI_UNDEFINED) then

c--------------------------------------------------------------------------
c   Store the arguments in the table's entry.
c--------------------------------------------------------------------------

           c_table(i,c_company_id) = id
           c_table(i,c_nmgr) = nmgr
           c_table(i,c_mgr_mem) = mgr_mem
           c_table(i,c_nwrkr) = nwrkr
           c_table(i,c_wrkr_mem) = wrkr_mem
           return
         endif
      enddo
 
      print *,'Error: Limit of ', max_company,
     *        ' companies has been exceeded.'
      call mpi_abort(mpi_comm_world, 1, ierr)
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine scontxy(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Performs the contraction of second derivative 1-electron integrals in 
c   the AO domain with an intermediate term derived from the 
c   back-transformed gamma matrix. The contraction is performed on an 
c   atom-by-atom basis and summed into the appropriate component of the 
c   gradient array.
c
c   scontxy must be executed with the following syntax:
c   execute scontxy i(mu,nu)
c
c   The block i(mu,nu) is the intermediate term which is 
c   to be contracted with the second derivative of "S" integrals for its 
c   block of (mu,nu) across all the atoms in the molecule.
c
c   Note that second-derivatives are only available usind ERD!! 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'hess.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      integer array, nind, ind(mx_array_index), seg(mx_array_index)
      integer a1, a2, b1, b2
      integer i, m, n, nl2
      integer shandle, iatom
      integer*8 iscr, indblk
      integer find_current_block
      integer*8 get_block_data_index
      integer block, blkndx, stack
      integer igrad, component, intermediate
      integer allocate_scratch_block
      integer ierr

      double precision dummy, y
      integer flopcount
      integer a,b

      nl2 = (nbasis * nbasis + nbasis)/2
      write_hess = .true.

      if (dbg) write(6,*) 'Task ',me,' ENTERING SCONTXY ' 

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Allocate a scratch block to use in the contractions.
c---------------------------------------------------------------------------

      ierr =  allocate_scratch_block(x, iscr, shandle, array_table,
     *                            narray_table, index_table, 
     *                            nindex_table, block_map_table)
      if (ierr .ne. 0) then
         print *,'Error in SCONTXY: Cannot allocate scratch block'
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Find the ranges of the AO indices of the input block.
c--------------------------------------------------------------------------

         array = op(c_result_array)

         nind  = array_table(c_nindex,array)
         if (nind .ne. 2) then
            print *,'Error: SCONTXY requires a 2-index argument array.'
            print *,'Array ',array,' is defined with ',nind,' indices.'
            call abort_job()
         endif       
   
         do i = 1, nind
            ind(i) = array_table(c_index_array1+i-1,array)
            seg(i) = index_table(c_current_seg,ind(i))
         enddo

          call get_index_segment(ind(1), seg(1), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, a1, a2)
          call get_index_segment(ind(2), seg(2), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, b1, b2)

c--------------------------------------------------------------------------
c   Form the address of the current data block.
c--------------------------------------------------------------------------

         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)
         if (block .le. 0) then
            print *,'Task ',me,
     *         ' Error: SCONTXY cannot find current block',
     *         ' of array ',array,' indices ',ind(1),ind(2),' segs ',
     *         seg(1),seg(2)
            call abort_job()
         endif

         stack = array_table(c_array_stack, array)
         indblk = get_block_data_index(array, block, stack,
     *                                        blkndx, x)

c---------------------------------------------------------------------------
c   Perform contraction of the data block with the integrals.
c---------------------------------------------------------------------------

      if (intpkg .eq.flocke_package) then
         call contract_oed_2derv_integrals(3, x(indblk), x(iscr),
     *                  a1, a2, b1, b2, x(ix_hess))
      else
          print *,'Second derivatives only use ERD'
          call abort_job()
      endif 

      call free_scratch_block(shandle)
      return
      end

      Subroutine Run_ref(Deltaq, Deltax, Norm_coords, NReals, 
     &                   Nvibs)
C 
      Implicit Double Precision (A-H, O-Z)
C
#include "machsp.com"
C
      Double Precision Norm_coords
C
      Dimension Deltaq(Nvibs), Norm_coords(3*Nreals, Nvibs), 
     &          Deltax(3*Nreals)
      
      Call Xgemm("N", "N", 3*Nreals, 1, Nvibs, 1.0D0, Norm_coords,
     &            3*Nreals, Deltaq, Nvibs, 1.0D0, Deltax, 3*Nreals)
   
      Call Putrec(20, "JOBARC", "COORD  ", Nreals*3*IINTFP, Deltax)
C
#ifdef _DEBUG_LVL0
                Write(6,*)
                Write(6, "(a)") "The refrence geometry"
                Write(6, "(3F10.5)") (Deltax(i),i=1,3*Nreals)
#endif          
C
      Call aces_ja_fin
C    
C Run the point and read the energy and the gradients
C
      Call Runit("runaces2b")
      Call aces_ja_init

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_ATOM_PQ_INTEGRALS
     +
     +                    ( SHELLP,SHELLQ,
     +                      NGQEXQ,
     +                      WTS,
     +                      B00,B01,B10,
     +                      CASE2D,
     +
     +                               INT2DX,
     +                               INT2DY,
     +                               INT2DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_ATOM_PQ_INTEGRALS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 2D PQ X,Y,Z
C                atomic integrals using the Rys vertical recurrence
C                scheme VRR explained below. The present atomic case
C                differs from the general nonatomic case in the sense
C                that only B00,B01 and B10 coefficients are required
C                (hence no C00x and D00x with x=X,Y,Z coefficients
C                need to be ever calculated) and only nonzero 2D PQ
C                integrals arise in case the sum of both indices
C                corresponding to P and Q is even.
C
C                The Rys weight is multiplied to the 2DX PQ integral
C                to reduce overall FLOP count. Note, that the Rys weight
C                factor needs to be introduced only two times for
C                the starting atomic 2DX PQ integrals for the recurrence
C                scheme, namely to the (0,0) and (1,1) elements. The
C                weight factor is then automatically propagated
C                through the vertical transfer equations.
C
C                The recurrence scheme VRR is due to Rys, Dupuis and
C                King, J. Comp. Chem. 4, p.154-157 (1983) and details
C                about the scheme can be found in the general nonatomic
C                2D PQ X,Y,Z integral generation routine.
C
C                The 2D PQ integrals are calculated for all roots (info
C                already present in transmitted VRR coefficients!) and
C                for all exponent quadruples simultaneously and placed
C                into a 3-dimensional array.
C
C
C                  Input:
C
C                    SHELLx      =  maximum shell type for electrons
C                                   1 and 2 (x = P,Q)
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    WTS         =  all quadrature weights
C                    B00,B01,B10 =  cartesian coordinate independent
C                                   VRR expansion coefficients
C                    CASE2D      =  logical flag for simplifications
C                                   in 2D integral evaluation for
C                                   low quantum numbers
C
C
C                  Output:
C
C                    INT2Dx      =  all 2D PQ atomic integrals for each
C                                   cartesian component (x = X,Y,Z)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         INTEGER   CASE2D
         INTEGER   I,K,N
         INTEGER   I1,I2,K1,K2,KP1
         INTEGER   NGQEXQ
         INTEGER   SHELLP,SHELLQ

         DOUBLE PRECISION  B0,B1
         DOUBLE PRECISION  ONE
         DOUBLE PRECISION  WEIGHT
         DOUBLE PRECISION  XI,XK,XI1,XK1,XKP1

         DOUBLE PRECISION  B00 (1:NGQEXQ)
         DOUBLE PRECISION  B01 (1:NGQEXQ)
         DOUBLE PRECISION  B10 (1:NGQEXQ)
         DOUBLE PRECISION  WTS (1:NGQEXQ)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP,0:SHELLQ)

         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 4 different cases that can arise:
C
C                  P-shell = s- or higher angular momentum
C                  Q-shell = s- or higher angular momentum
C
C                each leading to simplifications in the VRR formulas.
C                The case present has been evaluated outside this
C                routine and is transmitted via argument.
C
C
         GOTO (1,3,3,2,4,4,2,4,4) CASE2D
C
C
C             ...the case P = s-shell and Q = s-shell.
C
C
    1    DO 100 N = 1,NGQEXQ
            INT2DX (N,0,0) = WTS (N)
            INT2DY (N,0,0) = ONE
            INT2DZ (N,0,0) = ONE
  100    CONTINUE

         RETURN
C
C
C             ...the cases P = s-shell and Q >= p-shell.
C                Evaluate I=0 and K=0.
C
C
    2    DO 200 N = 1,NGQEXQ
            INT2DX (N,0,0) = WTS (N)
            INT2DY (N,0,0) = ONE
            INT2DZ (N,0,0) = ONE
  200    CONTINUE
C
C
C             ...evaluate I=0 and even K's in range K=2,SHELLQ
C                (if any).
C
C
         DO 210 K = 2,SHELLQ,2
            K2 = K - 2
            XK1 = DFLOAT (K-1)

            DO 212 N = 1,NGQEXQ
               B1 = B01 (N) * XK1
               INT2DX (N,0,K) = B1 * INT2DX (N,0,K2)
               INT2DY (N,0,K) = B1 * INT2DY (N,0,K2)
               INT2DZ (N,0,K) = B1 * INT2DZ (N,0,K2)
  212       CONTINUE
  210    CONTINUE

         RETURN
C
C
C             ...the cases P >= p-shell and Q = s-shell.
C                Evaluate I=0 and K=0.
C
C
    3    DO 300 N = 1,NGQEXQ
            INT2DX (N,0,0) = WTS (N)
            INT2DY (N,0,0) = ONE
            INT2DZ (N,0,0) = ONE
  300    CONTINUE
C
C
C             ...evaluate even I's in range I=2,SHELLP (if any)
C                and K=0.
C
C
         DO 310 I = 2,SHELLP,2
            I2 = I - 2
            XI1 = DFLOAT (I-1)

            DO 312 N = 1,NGQEXQ
               B1 = B10 (N) * XI1
               INT2DX (N,I,0) = B1 * INT2DX (N,I2,0)
               INT2DY (N,I,0) = B1 * INT2DY (N,I2,0)
               INT2DZ (N,I,0) = B1 * INT2DZ (N,I2,0)
  312       CONTINUE
  310    CONTINUE

         RETURN
C
C
C             ...the cases P >= p-shell and Q >= p-shell.
C                Evaluate I=0,K=0 and I=1,K=1 pairs.
C
C
    4    DO 400 N = 1,NGQEXQ
            B0 = B00  (N)
            WEIGHT = WTS (N)
            INT2DX (N,0,0) = WEIGHT
            INT2DX (N,1,1) = WEIGHT * B0
            INT2DY (N,0,0) = ONE
            INT2DY (N,1,1) = B0
            INT2DZ (N,0,0) = ONE
            INT2DZ (N,1,1) = B0
  400    CONTINUE
C
C
C             ...evaluate: i) even I's in range I=2,SHELLP (if any)
C                             and K=0.
C                         ii) odd I's in range I=3,SHELLP (if any)
C                             and K=1.
C
C                Note, that step i) must be evaluated before step ii)
C                since the even I integrals are needed to evaluate
C                the odd I ones.
C
C
         DO 410 I = 2,SHELLP,2
            I2 = I - 2
            XI1 = DFLOAT (I-1)
            DO 412 N = 1,NGQEXQ
               B1 = B10 (N) * XI1
               INT2DX (N,I,0) = B1 * INT2DX (N,I2,0)
               INT2DY (N,I,0) = B1 * INT2DY (N,I2,0)
               INT2DZ (N,I,0) = B1 * INT2DZ (N,I2,0)
  412       CONTINUE
  410    CONTINUE

         DO 414 I = 3,SHELLP,2
            I1 = I - 1
            XI = DFLOAT (I)
            DO 416 N = 1,NGQEXQ
               B0 = B00 (N) * XI
               INT2DX (N,I,1) = B0 * INT2DX (N,I1,0)
               INT2DY (N,I,1) = B0 * INT2DY (N,I1,0)
               INT2DZ (N,I,1) = B0 * INT2DZ (N,I1,0)
  416       CONTINUE
  414    CONTINUE
C
C
C             ...evaluate I=0,SHELLP and K=2,SHELLQ (if any),
C                matching even I's with even K's and odd I's
C                with odd K's. Note that the even K integrals
C                are needed to evaluate the odd K ones, hence
C                the K loop needs to consider both even K and
C                odd K+1 cases consecutively.
C
C
         DO 420 K = 2,SHELLQ,2
            K1 = K - 1
            K2 = K - 2
            XK = DFLOAT (K)
            XK1 = DFLOAT (K1)

            DO 422 N = 1,NGQEXQ
               B1 = B01 (N) * XK1
               INT2DX (N,0,K) = B1 * INT2DX (N,0,K2)
               INT2DY (N,0,K) = B1 * INT2DY (N,0,K2)
               INT2DZ (N,0,K) = B1 * INT2DZ (N,0,K2)
  422       CONTINUE

            DO 424 I = 2,SHELLP,2
               I1 = I - 1
               I2 = I - 2
               XI1 = DFLOAT (I1)

               DO 426 N = 1,NGQEXQ
                  B0 = B00 (N) * XK
                  B1 = B10 (N) * XI1
                  INT2DX (N,I,K) =   B1 * INT2DX (N,I2,K)
     +                             + B0 * INT2DX (N,I1,K1)
                  INT2DY (N,I,K) =   B1 * INT2DY (N,I2,K)
     +                             + B0 * INT2DY (N,I1,K1)
                  INT2DZ (N,I,K) =   B1 * INT2DZ (N,I2,K)
     +                             + B0 * INT2DZ (N,I1,K1)
  426          CONTINUE
  424       CONTINUE

            IF (K.EQ.SHELLQ) GOTO 420

            KP1 = K + 1
            XKP1 = DFLOAT (KP1)

            DO 421 N = 1,NGQEXQ
               B0 = B00 (N) * XKP1
               INT2DX (N,1,KP1) = B0 * INT2DX (N,0,K)
               INT2DY (N,1,KP1) = B0 * INT2DY (N,0,K)
               INT2DZ (N,1,KP1) = B0 * INT2DZ (N,0,K)
  421       CONTINUE

            DO 423 I = 3,SHELLP,2
               I1 = I - 1
               I2 = I - 2
               XI1 = DFLOAT (I1)

               DO 425 N = 1,NGQEXQ
                  B0 = B00 (N) * XKP1
                  B1 = B10 (N) * XI1
                  INT2DX (N,I,KP1) =   B1 * INT2DX (N,I2,KP1)
     +                               + B0 * INT2DX (N,I1,K)
                  INT2DY (N,I,KP1) =   B1 * INT2DY (N,I2,KP1)
     +                               + B0 * INT2DY (N,I1,K)
                  INT2DZ (N,I,KP1) =   B1 * INT2DZ (N,I2,KP1)
     +                               + B0 * INT2DZ (N,I1,K)
  425          CONTINUE
  423       CONTINUE

  420    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C READS A RECORD FROM DIRECT ACCESS UNIT IUNIT.
C
C  INPUT:
C        IUNIT - UNIT NUMBER FOR DIRECT ACCESS FILE.
C        IREC  - NUMBER OF RECORD TO BE READ.
C        LENGTH- LENGTH OF VECTOR IN *INTEGER* WORDS.
C        IMOD  - RETURNED AS ZERO.
C
C        IVEC  - CONTENTS OF RECORD IREC.

      SUBROUTINE RDDIR(IUNIT,IREC,IVEC,LENGTH,IMOD)
      IMPLICIT INTEGER (A-Z)
      DIMENSION IVEC(LENGTH)
      READ(IUNIT,REC=IREC,ERR=555,IOSTAT=IER)IVEC
      IMOD=0
      RETURN
555   CALL IOERR('RDDIR',IUNIT,IER)
      END

C RETURNS THE RMS VALUE OF THE FIRST LENGTH ELEMENTS IN VECTOR VEC.  VALUES
C BELOW TOL ARE NOT CONSIDERED.

      DOUBLE PRECISION FUNCTION RMSVEC(VEC,LENGTH,TOL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(LENGTH)
      RMSVEC = 0.0d0
      if (length.lt.1) return
      NIN = 0
      DO I = 1, LENGTH
         Z = VEC(I)
         IF (ABS(Z).GT.TOL) THEN
            NIN = NIN + 1
            RMSVEC = RMSVEC + ( Z * Z )
         END IF
      END DO
      RMSVEC = DSQRT(RMSVEC) / NIN
      RETURN
      END

c This routine redimensions the array sizes for an MOIO family of arrays
c based on two vectors: one, the number of rows, and the other, the number
c of columns. It requires the groups to be 'packed' in the sense that
c aces_list_touch was not told to start each group on a physical record
c boundary (besides the first one). Although it updates the auxiliary cache
c addresses, every array in the family MUST be in memory with no spaces between
c them (just like the disk storage requirement).
c    This is really a shameful routine. Only one routine uses it: vea/updlsts2.
c NO ONE should use this routine besides sloppy programmers. (The reason why
c it lives here is that only the acescore library knows about lists.com.)

c INPUT
c int IO_ROWS : the number of arrays in the family
c int IFAMNDX : the family index of the arrays to redimension
c int ROWS_PER_IRP(IO_ROWS) : the one-dimensional array of rows by irrep
c int COLS_PER_IRP(IO_ROWS) : the one-dimensional array of cols by irrep
c int ISYTYP1 : the value (distribution type) to enter in to isytyp(1,IFAMNDX)
c int ISYTYP2 : the value (distribution type) to enter in to isytyp(2,IFAMNDX)

#include "lists.h" /* for MOIO dimensions */

      subroutine aces_family_danger(IO_Rows,     iFamNdx,
     &                              Rows_Per_Irp,Cols_Per_Irp,
     &                              iSyTyp1,     iSyTyp2)
      implicit none

c ARGUMENTS
      integer IO_Rows,               iFamNdx
      integer Rows_Per_Irp(IO_Rows), Cols_Per_Irp(IO_Rows)
      integer iSyTyp1,               iSyTyp2

c INTERNAL VARIABLES
      integer nRows, nCols, nWords
      integer irrep
      integer iRec, iWrdNdx
      integer quiktmp(_MAX_IO_GRPS)
      integer iTmp

c COMMON BLOCKS
#include "lists.com"
#include "filspc.com" /* for iprcwd */
#include "sympop.com" /* for irpdpd and isytyp */
#include "syminf.com" /* for nirrep and dirprd */
#include "auxcache.com" /* for quikget */
#include "machsp.com" /* for iintfp */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_FAMILY_DANGER: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iTmp = 1
      end if
c   o assert IO_Rows is properly bound
      if ((IO_Rows.lt.1).or.(_MAX_IO_GRPS.lt.IO_Rows)) then
         print *, '@ACES_FAMILY_DANGER: Assertion failed.'
         print *, '   IO_Rows = ',IO_Rows
         print *, '   max ndx = ',_MAX_IO_GRPS
         iTmp = 1
      end if
c   o assert iFamNdx is properly bound
      if ((iFamNdx.lt.1).or.(_MAX_IO_FAMS.lt.iFamNdx)) then
         print *, '@ACES_FAMILY_DANGER: Assertion failed.'
         print *, '   iFamNdx = ',iFamNdx
         print *, '   max ndx = ',_MAX_IO_FAMS
         iTmp = 1
      end if
c   o assert dimensions are whole
      do irrep = 1, IO_Rows
         if ((Rows_Per_Irp(irrep).lt.0).or.
     &       (Cols_Per_Irp(irrep).lt.0)    ) then
            print *, '@ACES_FAMILY_DANGER: Assertion failed.'
            print *, '   Rows = ',Rows_Per_Irp(irrep)
            print *, '   Cols = ',Cols_Per_Irp(irrep)
            iTmp = 1
         end if
      end do
c   o assert distribution types are in [1,22]
      if ((iSyTyp1.lt.1).or.(22.lt.iSyTyp1).or.
     &    (iSyTyp2.lt.1).or.(22.lt.iSyTyp2)    ) then
         print *, '@ACES_FAMILY_DANGER: Assertion failed.'
         print *, '   iSyTyp1  = ',iSyTyp1
         print *, '   iSyTyp2  = ',iSyTyp2
         print *, '   max type = ',22
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

      if (IO_Rows.lt.1) return

c ----------------------------------------------------------------------

c   o process the first row/group/irrep (peeled off the do loop)
      nRows = Rows_Per_Irp(1)
      nCols = Cols_Per_Irp(1)
      moiosz(1,iFamNdx) = nRows
      moiods(1,iFamNdx) = nCols

c   o process 'the others'
      if (nirrep.ne.1) then
         nWords = nRows*nCols*iintfp
         quiktmp(1) = nWords
         iWrdNdx = moiowd(1,iFamNdx) + nWords
         iTmp    = (iWrdNdx-1)/iprcwd
         iRec    = moio(1,iFamNdx) + iTmp
         iWrdNdx = iWrdNdx         - iTmp*iprcwd
         do irrep = 2, nirrep
            nRows  = Rows_Per_Irp(irrep)
            nCols  = Cols_Per_Irp(irrep)
            nWords = nRows*nCols*iintfp
            moiosz(irrep,iFamNdx) = nRows
            moiods(irrep,iFamNdx) = nCols
            moio  (irrep,iFamNdx) = iRec
            moiowd(irrep,iFamNdx) = iWrdNdx
            quiktmp(irrep) = nWords
            iWrdNdx = iWrdNdx + nWords
            iTmp    = (iWrdNdx-1)/iprcwd
            iRec    = iRec    + iTmp
            iWrdNdx = iWrdNdx - iTmp*iprcwd
         end do
         if (quikget(1,iFamNdx).ne.0) then
            do irrep = 2, nirrep
               quikget(irrep,iFamNdx) =   quikget(irrep-1,iFamNdx)
     &                                  + quiktmp(irrep-1)
            end do
         end if
c     end if (nirrep.ne.1)
      end if

c   o update the type lookup table
      isytyp(1,iFamNdx) = iSyTyp1
      isytyp(2,iFamNdx) = iSyTyp2

c   o mark MOIO as modified
      bIOMod = .true.

      return
c     end subroutine aces_family_danger
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__rewind_unit
     +
     +                    ( unitid )
     +
c------------------------------------------------------------------------
c  operation   : ofh__rewind_unit
c  module      : output files handler
c  module-id   : ofh
c  description : This operation rewinds the specified unit. If the unit
c                is not connected to the unit number, processing will
c                be aborted.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         logical    is_open

         integer    unitid
c
c
c------------------------------------------------------------------------
c
c
c             ...check unit number and print message/stop if necessary.
c
c
         if ( unitid.lt.2  .or.  unitid.gt.MAX_OUTPUT_FILES ) then
              write (*,*) ' Unit number out of range in routine: '
              write (*,*) ' ofh__rewind_unit '
              write (1,*) ' Unit number out of range in routine: '
              write (1,*) ' ofh__rewind_unit '
              call  ofh__stop
         end if
c
c
c             ...inquire the open status of the unit.
c
c
         inquire  (unit   = unitid,
     +             opened = is_open)
c
c
c             ...rewind unit.
c
c
         if ( is_open  .and.  file_handle (unitid) .eq. used ) then
              rewind ( unit = unitid )
         else
              write (*,*) ' Unit not connected in routine: '
              write (*,*) ' ofh__rewind_unit '
              write (1,*) ' Unit not connected in routine: '
              write (1,*) ' ofh__rewind_unit '
              call  ofh__stop
         end if
c
c
c             ...ready!
c
c
         return
         end

      SUBROUTINE DRMOVE(ICORE,MAXCOR,IUHF,NLIST,SING1)
C
C DRIVER FOR CALLS WHICH MOVE THE T AMPLITUDE INCREMENT LISTS (LIST 61 - 63
C AND 90-91) INTO THE REFERENCE T AMPLITUDE LIST AREA (LIST 44+NLIST - 46+
C NLIST AND 90+NLIST 91+NLIST)
C
C NLIST = 0   USUAL REFERENCE LIST    NLIST=100   LAMBDA REFERENCE LIST
C
C SING1 = TRUE, SINGLES SHOULD BE MOVED AS WELL
C SING1 = FALSE, NO SINGLES 
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL SING1
      DIMENSION ICORE(MAXCOR)
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ ISTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYM/ POP1(8),POP2(8),VRT1(8),VRT2(8),NTAA,NTBB,
     &             NF1AA,NF1BB,NF2AA,NF2BB
      COMMON /FLAGS/ IFLAGS(100)
C
C DO AA SPIN CASE.
C
      DO 10 ISPIN=1,IUHF+1
       CALL MVSYM(ICORE,MAXCOR,IUHF,1,60+ISPIN,43+ISPIN+NLIST)
10    CONTINUE
C
C DO AB SPIN CASE
C
      CALL MVSYM(ICORE,MAXCOR,IUHF,1,63,46+NLIST)
C
C     SINGLES IN CCSD AND QCISD
C
      IF(.NOT.SING1) RETURN
C
      CALL MVLIST(ICORE,NTAA,1,90,90+NLIST,3,1,1,1)
      IF(IUHF.EQ.1) CALL MVLIST(ICORE,NTBB,1,90,90+NLIST,4,2,1,1)
      RETURN
      END

cSG/JDW 6/6/95
c Change of name for compatibility with newer IBM operating systems (XLF 3.2).

      character*(*) function trmblk(sz)
      implicit none

      character*(*) sz
      integer i, fnblnk, linblnk, iStart, iEnd

      trmblk=' '

      iStart = fnblnk(sz)
      if (iStart.ne.0) then
         iEnd = min(linblnk(sz),iStart-1+len(trmblk))
         trmblk = sz(iStart:iEnd)
      end if

      return
      end

      SUBROUTINE NEWTYP(LIST,SYTYPL,SYTYPR,CHANGE)
      IMPLICIT NONE
      INTEGER LIST,SYTYPL,SYTYPR
      LOGICAL CHANGE
      CALL ACES_FAMILY_REDIST(1,LIST,SYTYPL,SYTYPR,CHANGE)
      RETURN
      END

      SUBROUTINE MKabin(geom, PTGRP,NATMS,NUNIQUE,ZSYM,ATNR,GENBY,
     $     SCRATCH, ISTAT)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Purpose: Produce an VMOL .MOL file based on the ZMAT file
C
C Arguments:
C     PtGrp   Symbol for the point group symmetry to use in (input)
C             making the INP file.
C     NAtms   Number of atoms (input)
C     AtNr    Atomic numbers for each center (input)
C     NUnique Number of unique internal coordinates (input)
C     geom    Cartesian coordinates (input)
c             will not be the same as Q in FINDIF
C     GenBy   To hold the Genby list (internal)
C     IStat   Error codes (output)
C             = 0  Successful
C             = 1  Fatal error from dependent
C             = 3  I/O Error on AbiFil
C             = 5  I/O Error on ZFil
C             = 7  No non-dummy centers!
C             = 8  ZFil ends after Z-matrix
C             = 10 ZFil ends after JODA control info
C
C Common blocks used:
C     LUnits  Sets unit names & numbers
C     Coord
C
C Internal Variables:
C     BasNam  Holds the basis set name given in the ZMAT file
C     JobTtl  Holds the job title given in the ZMAT file
C     Wrk     Scratch string to copy lines form ZMAT to ABI
C
C Dependents
C     PitPtG  Translates a schoenflies symbol into Pitzer's form
C     WrPBas  Lookup & write basis set in Pitzer style
C
C Files used:
C     ZFil   Holds the basis specification & the "rest" of INP
C     AbiFil Gets written out here (kills previous one)
C     BasFil The basis set library
C
C Limitations:
C     Only looks up bases for the geometrically unique atoms.
C
C     Extra blank lines at the end of a "truncated" ZFil will cause
C     it to act like it encountered a real error on reading the file.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
      Character*(*) PtGrp, ZSym(NAtms)
      Integer AtNr(NAtms), GenBy(NAtms), IStat, AtoI,IZLoc(MxAtms)
      Character*80 JobTtl, Wrk
      Character*3 Ka(3)
      Character*6 Slask,NullSt
      Character*1 Lb
      Character*1 Indxx(150)

csb 1/97 Hold long basis set names
      integer baslen
      parameter (baslen=80)
      Character*(baslen) BasNam(MxAtms),BlnkBN,ScrBas,BasName

      Parameter (TLA = 1.D-9)
      INTEGER SHELLANG,SHELLLOC,SHELLSIZ,SHELLPRM
      INTEGER SHELLORB,SHOFFSET,PRIMORBT,PROFFSET
      integer fnblnk 
      double precision geom(3*mxatms)
C
      Logical Opn,bad123, GENBAS
      Integer OldLu
      Dimension Nord(2*MxAtms),Scratch(NAtms)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /MOLSTR1/ SHELLANG(100),SHELLLOC(100),SHELLSIZ(100),
     &                 SHELLPRM(100),BASISEXP(10000),BASISCNT(10000)
      COMMON /MOLSTR2/ NTOTPRIM,NTOTSHEL,IOFFPRIM,IOFFSHEL,IIATOM
      COMMON /MOLSTR3/ SHELLORB(100),SHOFFSET(100),PRIMORBT(100),
     &                 PROFFSET(100)
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /FLAGS/IFLAGS(100),IFLAGS2(500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /COORD/ Q(3*MXATMS), R(3*MXATMS), NCON(3*MXATMS),
     1     NR(MXATMS),ISQUASH(3*MXATMS),IATNUM(MXATMS),ATMASS(MXATMS),
     2     IUNIQUE(3*MXATMS),NEQ(3*MXATMS),IEQUIV(3*MXATMS,3*MXATMS),
     3     NOPTI(3*MXATMS), NATOMS
#include "io_units.par"
C
C     Length of BasNam is fixed by the basis library
C
C
C     This length is fixed by ABINITIO's input section
C
      Data Indxx /'1','2','3','4','5','6','7','8','9','0','A'
     &,'B','C','D','E','F','G','H','I','J','K','L','M','N'
     &,'O','P','Q','R','S','T','U','V','W','X','Y','Z','a'
     &,'b','c','d','e','f','g','h','i','j','k','l','m','n'
     &,'o','p','q','r','s','t','u','v','w','x','y','z',88*'*'/
csb      DATA BASIS /'PBS     ','STO-3G  ','DZ      ',
csb     &            'VDZ     ','3-21G   ','6-31G   ',
csb     &            '4-31G   ','TZ      ','PVTZ    ',
csb     &            '6-311G  ','DZP     ','PVDZ    ',
csb     &            'TZP     ','PVQZ    ','TZ2P    ',
csb     &            'WMR     ','6-31G*  ','6-31G** ',
csb     &            '6-311G* ','6-311G**','PV5Z    '/
C
C Initialize some things.
C
csb
      do i=1,baslen
        BlnkBN(i:i)=' '
      end do
      ScrBas=BlnkBN

      bad123 = .false.
      Slask='INTGRL'
      NullSt='      '
      LB='#'
      J=0
      I=0
      IGENER=1
      IF10=0
      IF18=1
      ID3=0
      IONE=1
      IRSTRT=0
      CALL GETREC(-1,'JOBARC','PASS1   ',IONE,INEWFD)
      IECP=IFLAGS(71)
      IECPU=0
      IPRINT=0
      INUTMP=0
      ISTATS=0
      ISTAT=0
      IOFFPRIM=1
      IOFFSHEL=1
C
      ICOUNT=0
C
C SEE IF A GENBAS FILE IS PRESENT
C
      INQUIRE(FILE='GENBAS',EXIST=GENBAS)
C
C     Cautiously open the ZMAT file
C
      Inquire (FILE=ZFil, OPENED=Opn)
      If (.not.Opn) Open (LuZ, FILE=ZFil, STATUS='OLD')
      Rewind LuZ
C
C     Read ZMAT: Get title, skip Z-matrix, skip parameters
C     NOTE: blank line after Z-matrix, and parameters required.
C
      Read (LuZ, '(A)', ERR=8500, END=8510) JobTtl
CCH   READ COORDINATES OR Z-MATRIX
      Do 200 i = 1, NAtms
         Read (LuZ,'(A)', ERR=8500, END=8510) Wrk
C
C     ADDITION (JFS, 4/1990): Check third atom in Z-matrix in
C     order to detect 2--1--3 connectivity.
C
         If(I.Eq.3)then
          iblank=index(wrk,' ')
          istrt2=fnblnk(wrk(iblank+1:))+iblank
          iendd2=index(wrk(istrt2+1:),' ')+istrt2-1
          izz=AtoI(wrk(istrt2:iendd2))
          if(izz.eq.1.and.zsym(1)(1:1).ne.'X'.and.zsym(2)(1:1).ne.'X')
     &       bad123=.true.
         endif
C     END OF ADDITION
 
 
 200  Continue
      Read (LuZ,'(A)', ERR=8500, END=8510) Wrk
      Do 205 i = 1, NUnique
         Read (LuZ, '(A)', ERR=8500, END=8510) Wrk
 205  Continue
      Read (LuZ, '(A)', ERR=8500, END=8800) Wrk
C
C     Get the optimizer settings & another blank line after
C
      Call GtFlgs(0,IErr,IPrnt,INR,IContl,IVec,IDie,ICurvy,IStCrt,
     & IMxStp,IVib,IRecal,IntTyp,IDisFD,IGrdFD,ICNTYP,ISym,IBasis,
     & IDFGHI,BasName)
      If(IErr.eq.2)Goto 8800
      If(IErr.eq.1)Goto 8500
C      Read (LuZ, '(11I3)', ERR=8500, END=8800) IPrnt, INR, IContl,
C     $ IVec, IDie, ICurvy, IStCrt, IMxStp, IVib, IRecal, IntTyp
      If(IContl.eq.0)IContl = 4
      IF(IPrnt.ge.100)then
      Write (LuOut, '(4X,A,I3)') 'Print Level: ', IPrnt
      Write (LuOut, '(4X,A,I3)') 'Step-taking: ', INR
      Write (LuOut, '(4X,A,I3)') 'E-Vec to follow: ',IVec
      Write (LuOut, '(4X,A,I3)') 'Die: ',IDie
      Write (LuOut, '(4X,A,I3)') 'Use curvilinear xform: ',ICurvy
      Write (LuOut, '(4X,A,I3)') 'Max Step: ',IMxStp
      Write (LuOut, '(4X,A,I3)') 'Step Contol: ', IStCrt
      Write (LuOut, '(4X,A,I3)') 'Vibrational Analysis: ', IVib
      Write (LuOut, '(4X,A,I3)') 'Recalculation of Hessian: ',
     &IRecal
      Write (LuOut, '(4X,A,I3)') 'Convergence cutoff: ',IContl
      Write (LuOut, '(4X,A,I3)') 'Integral type: ',IntTyp
      Endif
      Read (LuZ, '(A)', ERR=8500, END=8810) Wrk
C
C     Now read the basis sets - each line corresponds to a (non-dummy)
C     center in the Z-matrix, in the order of appearance.  We put this
C     into an array length NAtms, with blanks for dummies.  This makes
C     it easier to match the basis with the right coordinates later.
C     NOTE: blank line after basis names.
C
      Do 250 i = 1, NAtms
         BasNam(i) = BlnkBN
         If (AtNr(i) .ne. 0 .and. IBasis .eq. 0) then
            Read (LuZ, '(A)', ERR=8500, END=8510, IOSTAT=IOS) BasNam(i)
         ElseIf(AtNr(i) .ne. 0 .and. IBasis .ne. 0)then
            BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
     &          BasName(1:linblnk(BasName))
csb            izz=index(Basis(IBasis),'*')
csb            ixx=index(Basis(IBasis),'**')
csb            ipop=0
csb            if(ixx.ne.0.and.atmass(i).gt.4.5)ipop=1
csb            if(izz.ne.ixx.and.atmass(i).lt.4.5)ipop=1
csb            BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
csb     &                Basis(IBasis)(1:linblnk(Basis(IBasis))-ipop)
         EndIf
 250  Continue
      If(IBasis.eq.0)Read (LuZ,'(A)', ERR=8500, END=8510) Wrk
C ADDITION (JFS,4/90)
C Now take care of situation which occurs when 2--1--3 Z-matrix
C  specification and nonstandard basis set input is used.  In this case,
C  the basis sets for atoms #1 and #2 must be switched.
C
      If(Bad123.and.IBasis.eq.0)then
       ScrBas=BasNam(1)
       BasNam(1)=BasNam(2)
       BasNam(2)=ScrBas
      EndIf
C END OF ADDITION
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Let's find out which centers are equivalent
C
      Call SymEqv ( NAtms, GenBy)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Count number of centers having *different* atomic numbers in this grou
C   Top half of Nord contains the number of symmetry equivalent atoms
C   for a given atomic number.
C
      Do 312 I=1,NAtms
       If(GenBy(i).eq.0.and.AtMass(i).gt.1.D-2)Then
        J=J+1
        Scratch(J)=AtMass(I)
        Nord(J)=I
       EndIf
 312  Continue
      If(IVIB.ne.2)then
c       Call PikSr2(J,Scratch,Nord)
       NonTyp=1
       If(J.Eq.1)Then
        Nord(MxAtms+1)=1
       Else
        Do 313 I=2,J
         Dif=Dabs(Scratch(i)-Scratch(i-1))
         If(NonTyp.eq.1)IBot=0
c         If(Dif.lt.1.D-14)GoTo 314
         Nord(MxAtms+Nontyp)=I-1-IBot
         IBot=Nord(MxAtms+Nontyp)+IBot
         NonTyp=NonTyp+1
  314    If(I.eq.J)Nord(MxAtms+Nontyp)=I-Ibot
 313    Continue
       EndIf
C
C For finite difference calcs, reset this so that it writes out the
C  atoms to the MOL
C  file in exactly the same order as they appear in the ZMAT.  This
C  ordering is assumed in FINDIF!
C
      ElseIf(ivib.eq.2)then
       NonTyp=J
       Do 315 I=1,J
        Nord(MxAtms+I)=1
315    Continue
      EndIf
C
C Now get symmetry information written by SYMMETRY to file VMINF.
C
      Opn = .False.
      OldLu = 0
      IF(PTGRP.EQ.'C1 ')THEN
       INQUIRE(FILE='VMLSYM',EXIST=Opn)
       IF(OPN)THEN
        OPEN(UNIT=30,FILE='VMLSYM',FORM='UNFORMATTED',
     &       STATUS='OLD')
        CLOSE(UNIT=30,STATUS='DELETE')
       ENDIF
       GOTO 5400
      ENDIF
      Inquire (FILE='VMLSYM', OPENED=Opn, NUMBER=OldLu)
      If (Opn) Close (OldLu)
C
      Open (30, FILE='VMLSYM', STATUS='OLD',FORM='UNFORMATTED')
      Rewind(30)
      Read (30,Err=9400)NSymOp,(KA(i),i=1,3)
      Close(30, Status='Delete')
5400  If(PtGrp.EQ.'C1 ')Then
       Do 412 I=1,3
        KA(I)='   '
412    Continue
       NSymOp=0
      EndIf
C
C     Now we've got (pretty much) all the information we need, so
C     we can start writing out the MOL file.
C     Begin with a very cautious opening of the file.
C
      Opn = .False.
      Inquire (file=abifil, OPENED=Opn)
      If ( .not. Opn ) Open (Luabi, FILE=abiFil, FORM='FORMATTED',
     $     STATUS='UNKNOWN')
      Rewind Luabi
C     

       IF(GENBAS)THEN
          CALL MKARGOS(KA,NSYMOP,PTGRP,NONTYP,ZSYM,BASNAM,NORD,GEOM,
     $           JOBTTL,IATNUM,luabi,natms,izloc)
       else
          write(luerr,9913)
 9913     format(' @MKDECK-F, Sorry, GENBAS file required')
          call errex
       endif
C
C     Dump vector to disk which relates the atoms listed in the
C     MOL file to their position in the user supplied Z-matrix.
C
      CALL PUTREC(20,'JOBARC','MAP2ZMAT',NATMS,IZLOC)
C
C This better not happen.
C
      If (Nontyp .eq. 0) then
         IStat = 7
         Write (LuErr, 9970)
         Close (LuZ)
         Close (LuAbi)
         Return
 9970    Format (' @MKDECK-F, No non-dummy centers in Z-matrix.')
      EndIf
C
C     The rest of this just copied from ZMAT
C
C
C     Make sure every body gets closed & stuff
C
 8000 Close (LuAbi)
      Close (LuZ)
C
C     WRITE SCF INPUT FILE
C
      IF(IFLAGS(17).NE.999) CALL SCFINP(JOBTTL,LUABI)
C
C WRITE BASIS SET INFORMATION TO JOBARC
C
      IONE=1
      NTOTPRIM=IOFFPRIM-1
      NTOTSHEL=IOFFSHEL-1
      CALL PUTREC(20,'JOBARC','ATOMCHRG',NATOMS,IATNUM)
      IF(INEWFD.EQ.0)THEN
       CALL PUTREC(20,'JOBARC','NTOTSHEL',IONE,NTOTSHEL)
       CALL PUTREC(20,'JOBARC','NTOTPRIM',IONE,NTOTPRIM)
       CALL PUTREC(20,'JOBARC','BASISEXP',NTOTPRIM*IINTFP,BASISEXP)
       CALL PUTREC(20,'JOBARC','BASISCNT',NTOTPRIM*IINTFP,BASISCNT)
       CALL PUTREC(20,'JOBARC','SHELLSIZ',NTOTSHEL,SHELLSIZ)
       CALL PUTREC(20,'JOBARC','SHELLPRM',NTOTSHEL,SHELLPRM)
       CALL PUTREC(20,'JOBARC','SHELLANG',NTOTSHEL,SHELLANG)
       CALL PUTREC(20,'JOBARC','SHELLLOC',NTOTSHEL,SHELLLOC)
       CALL PUTREC(20,'JOBARC','SHOFFSET',NONTYP,SHOFFSET)
       CALL PUTREC(20,'JOBARC','SHELLORB',NONTYP,SHELLORB)
       CALL PUTREC(20,'JOBARC','PROFFSET',NONTYP,PROFFSET)
       CALL PUTREC(20,'JOBARC','PRIMORBT',NONTYP,PRIMORBT)
      ENDIF
      Return
C
C     Get here via an I/O error on VMLSYM
C
 9400 IStat=3
      Write (LuErr, 9930)'VMLSYM'
      Close(LuAbi)
      Close(LuZ)
      Return
C
C     Get here via an I/O error on LuZ
C
 8500 IStat = 5
      If(IntTyp.ne.0)then
       Write (LuErr, 9950) MolFil
       Close (LuVMol)
      else
       Write (LuErr, 9950) AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 8510 IStat = 5
      If(IntTyp.ne.0)then
       Write (LuErr, 9955) MolFil
       Close (LuVMol)
      else
       Write (LuErr, 9955) AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
C
C     If the ZFil ends after the Z-matrix or the optimization control
C     info, it probably means that JODA is being used "stand-alone"
C     and we want to allow for that possibility.
C
 8800 IStat = 8
      If(IntTyp.ne.0)then
       Write (LuOut, 9800) ZFil, MolFil
       Close (LuVMol)
      else
       Write (LuOut, 9800) ZFil, AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 8810 IStat = 10
      If(IntTyp.ne.0)then
       Write (LuOut, 9810) ZFil, MolFil
       Close (LuVMol)
      else
       Write (LuOut, 9810) ZFil, AbiFil
       Close (LuAbi)
      EndIf
      Close (LuZ)
      Return
 9930 Format (' @MKDECK-F, I/O error on file ',A,'.')
 9950 Format (' @MKDECK-F, I/O error on file ',A,'.')
 9955 Format (' @MKDECK-F, Premature end-of-file on ',A,'.')
 9800 Format (/1X,A,' ends after Z-matrix - cannot ',
     $   'finish making ',A,'.')
 9810 Format (/1X,A,' ends after JODA control info - cannot ',
     $   'finish making ',A,'.')
      End

      Subroutine Set_lmn

      Implicit Integer (A-H, O-Z)

#include "ecp.par"
#include "ecp.com"
C
      II = 0
      DO LVAL = 0,MAXANG-1
         DO L = LVAL,0,-1
            LEFT = LVAL - L
            DO M = LEFT,0,-1
               N = LEFT - M
               II = II + 1
               LMNVAL(1,II) = L
               LMNVAL(2,II) = M
               LMNVAL(3,II) = N
             ENDDO
          ENDDO
      ENDDO
C     
#ifdef _DEBUG_LVL0     
      Write(6,"(a)") "The lmn values"
      Do i=1, 3
         Write(6,"(10I3)") (lmnval(i, i1),i1=1,84)
         Write(6,*)
      Enddo
#endif
c     
      Return
      End

      SUBROUTINE SUBGROUP(INGROUP,ABGRP0,FUGRP0,IROTATE)
C
C THIS ROUTINE ORIENTS THE MOLECULE IN TERMS OF AN EXTERNALLY
C SPECIFIED ABELIAN SUBGROUP AND PROCEEDS TO CHECK ITS OPERATIONS.
C
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*3 GRPS(8),GROUP
      CHARACTER*4 ABGRP,ABGRP0,FUGRP,FUGRP0
C
      DATA GRPS /'C1 ','C2 ','C s','C i','C2v','C2h','D2 ','D2h'/
C
CSSS      LASTF=linblnk(FUGRP)
C A bug fix. This subroutine knows nothing about FUGRP. I am suprised
C that did not show up eariler than this, but I guess it is rare that
C we do frequencies with subgroup is specified. Ajith Perera, 05/2006.
C
      LASTF=linblnk(FUGRP0)
      GROUP=GRPS(INGROUP)
      ABGRP=ABGRP0(1:3)
      FUGRP=FUGRP0(1:LASTF)
c

      Print*, "Abelian group, full group"
      Print*, ABGRP, FUGRP, GROUP


C
      IROTATE=0
C
      IF(ABGRP.EQ.GROUP)THEN
C
C QUIETLY RETURN IF SPECIFIED GROUP IS IDENTICAL TO ABELIAN SUBGROUP.
C
       ABGRP0(1:3)=GROUP
       RETURN
C
      ELSEIF(ABGRP.EQ.'D2h')THEN
C
C CASE I.  TRUE ABELIAN SUBGROUP IS D2H.  THEN ALL SUBGROUPS ARE
C OK AND ALL ARE PROPERLY ORIENTED.
C
       ABGRP0(1:3)=GROUP
       RETURN
C
      ELSEIF(ABGRP.EQ.'C2v')THEN
C
C CASE II.  TRUE ABELIAN SUBGROUP IS C2V.  ALLOWABLE GROUPS ARE
C C2 AND CS, BOTH OF WHICH ARE PROPERLY ORIENTED.
C
       IF(GROUP.EQ.'C2 '.OR.GROUP.EQ.'C s')THEN
        ABGRP0(1:3)=GROUP
        RETURN
       ELSEIF(GROUP.EQ.'D2 '.AND.FUGRP.EQ.'T d'.OR.
     &        GROUP.EQ.'D2 '.AND.FUGRP(LASTF:LASTF).EQ.'d')THEN
C
C TRICKY STUFF.  HAVE TO ROTATE BY 45 DEGREES ABOUT Z.
C
        IROTATE=1
        ABGRP0(1:3)=GROUP
       ELSE
        WRITE(6,1000)GROUP,FUGRP
        CALL ERREX
       ENDIF
C
      ELSEIF(ABGRP.EQ.'D2 ')THEN
C
C CASE III.  TRUE ABELIAN SUBGROUP IS D2.  ALLOWABLE GROUP IS C2.
C
       IF(GROUP.EQ.'C2 ')THEN
        ABGRP0(1:3)=GROUP
        RETURN
       ELSEIF(GROUP.EQ.'C2v'.AND.FUGRP.EQ.'T d'.OR.
     &        GROUP.EQ.'C2v'.AND.FUGRP(LASTF:LASTF).EQ.'d')THEN
        IROTATE=1
        ABGRP0(1:3)=GROUP
       ELSE
        WRITE(6,1000)GROUP,FUGRP
        CALL ERREX
       ENDIF
      ELSEIF(ABGRP.EQ.'C2h')THEN
C
C CASE IV.  TRUE ABELIAN SUBGROUP IS C2H.  ALLOWABLE GROUPS ARE C2,
C CS AND CI.
C
       IF(GROUP.EQ.'C2 '.OR.GROUP.EQ.'Ci '.OR.GROUP.EQ.'C s')THEN
        ABGRP0(1:3)=GROUP
        RETURN
       ELSE
        WRITE(6,1000)GROUP,FUGRP
        CALL ERREX
       ENDIF
C
C FOR ALL OTHER ABELIAN SUBGROUPS, THE INPUT GROUP MUST MATCH THE
C TRUE ABELIAN SUBGROUP, WHICH IS TRAPPED AT THE TOP OF THIS ROUTINE.
C
      ELSE
       WRITE(6,1000)GROUP,FUGRP
C       CALL ERREX
C
C There is really no reason to stop; calculation can proceed in the
C abelian sub-group, but we need to warn the user that we disobyed
C him/her when one or few finite difference points happen to have
C point group for which the user requested subgroup is no longer a
C a subgroup of the full group. 05/2006, Ajith Perera

      CALL WRITE_WARN_LOG("INVALID SUBGROUP")

      ENDIF
C
1000  FORMAT(T3,'@SUBGROUP-F, Group ',A,' is not a subgroup of ',A,'.')
      RETURN
      END

      Subroutine Ecp_Ang_int2(Xph, Yph, Zph, Lamu, lab, Nx, Ny, Nz, 
     &                        Lprj, PQS_xyz, Ang)

      Implicit Double Precision (A-H, O-Z)
      Logical Skip

#include "ecp.par"
#include "ecp.com"

      Dimension PQS_Xyz(0:2*Maxang,3),TPQ_Xyz(0:2*Maxang,3),
     &          Ang(0:2*Maxang,-Maxproj:Maxproj,0:2*Maxang)

#ifdef _DEBUG_LVLM
      Write(6,*) "@-Ecp_Ang_int2: The PQS_xyz array"
      Write(6,*)
      Write(6,"(3F10.6)") ((PQS_xyz(i,j), j=1, 3),i=0,lab)
      Write(6,*) 
       Write(6,"(a,F10.6)") "Ftab:", Fijk(3, 3, 0)
#endif
       Call make_BC_PQ_xyz(Nx, PQS_xyz(0,1), TPQ_xyz(0,1))
       Call make_BC_PQ_xyz(Ny, PQS_xyz(0,2), TPQ_xyz(0,2))
       Call make_BC_PQ_xyz(Nz, PQS_xyz(0,3), TPQ_xyz(0,3))
C
#ifdef _DEBUG_LVLM
      Write(6,*) "The SUm1_xyz array"
      do j=1, 3
         Write(6,*) "The J value :", J
         if (j .eq. 1) k=Nx
         if (j .eq. 2) k=Ny
         if (j .eq. 3) k=Nz
         Write(6,"(6(1x,F10.5))") (TPQ_xyz(i,j), i=0,k)
      enddo
#endif
C loop over Mprj (Mprj= -Lprj:Lprj)
       Do Iang = 0, 2*Maxang
          Do iprj = -Maxproj, Maxproj
              Do Jang = 0, 2*Maxang
                 Ang(Jang, Iprj, Iang) = 0.0D0
              Enddo
          Enddo
      Enddo
C
      Do Mprj = -Lprj, Lprj
C
c Now we have loops over Nax, Nay, NaZ
c
         Do ix = 0, Nx
            Do iy = 0, Ny
               Do iz = 0, Nz
#ifdef _DEBUG_LVLM
      Write(6,*)
      Write(6,'(a,4(1x,I2))') "@-Ecp_Ang_int2: Lprj,Nxyz: ", Lprj,Ix,
     &                         Iy, Iz
#endif
C
                  Ixyz = ix+iy+iz

                  l_high = Min(Lprj+Ixyz, Lamu)

                  Do Lam = 0, Lamu

c Loops over mu (-la to +la and -lb to +lb)

                     Ang_N_lam = 0.0D0

                     Do mu = -Lam, Lam
C
                        If (Lam .LE. Ixyz+Lprj .and. 
     &                      Mod(Lam+Lprj+Ixyz,2) .NE. 1) Then

CSSS                           Write(6,*) Lam, Ixyz+Lprj, Lam+Lprj+Ixyz
                            Call Screen_ang_typ2(Lprj, MPrj, Ix, Iy,
     &                                           Iz, Lam, Mu, Skip)
CSSS                            If (.NOT. Skip) Then

                               Call Make_res(Lam, Mu, Xph, Yph, Zph,
     &                                       Res)
C
                               Call Ang_int(Lprj, Mprj, Ix, Iy, Iz, 
     &                                      Lam, Mu, Ang_N_lam_mu)
#ifdef _DEBUG_LVLM
      Write(6,"(a,1x,a,2I2,3(1x,F15.8))") "Before Sum:", "L and M",
     &                                    LPrj, MPRj,  Ang_N_lam,
     &                                    ANg_N_lam_mu, Res
#endif
                               Ang_N_lam = Ang_N_lam + Ang_N_lam_mu*
     &                                     Res*Sqrt_fpi
C
#ifdef _DEBUG_LVLM
      Write(6,"(a)") "The angular part of the ints in Main"
      Write(6,"(5(1x,i2),(2(1x,F15.8)))"),Lam,mu,Ix,Iy,Iz,
     &                                 Ang_N_lam
      Write(6,*) 
#endif
CSSS                           Endif
                        Endif
C
                     Enddo

                     If (Lam .LE. Ixyz+Lprj .and. Mod(Lam+Lprj+Ixyz,2)
     &                   .NE. 1) Then
CSSS                        Write(6,*) Lam, Ixyz+Lprj, Lam+Lprj+Ixyz

#ifdef _DEBUG_LVLM
       Write(6,"(a, 3(1x,i2),1x,F15.8)")"The angular int:",Ixyz,
     &                                   Mprj,Lam,
     &                                   Ang(Ixyz, Mprj, Lam)
       Write(6,*)
#endif
                         Ang(Ixyz, Mprj, Lam) = Ang(Ixyz, Mprj, Lam) +
     &                                          Ang_N_lam*
     &                                          TPQ_xyz(Ix,1)*
     &                                          TPQ_xyz(Iy,2)*
     &                                          TPQ_xyz(Iz,3)
C
#ifdef _DEBUG_LVLM
       Write(6,"(a, 3(1x,i2),1x,F15.8)")"The angular int:",Ixyz,
     &                                   Mprj,Lam,
     &                                   Ang(Ixyz, Mprj, Lam)
       Write(6,*)
#endif
                     Endif

                  Enddo

                Enddo
            Enddo
         Enddo
C
      Enddo

      Return
      End

      SUBROUTINE MAKER(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,SINGLE,
     &                 RLETYP)
C
C DRIVER FOR FORMATION OF THE RLE R MATRIX.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(MAXCOR)
      DOUBLE PRECISION R
      LOGICAL SINGLE
      COMMON /RMAT/ R(400)
      INDX(I,J)=I+(J-1)*MAXORD
C
C SET ALL R(I,J)=R(I-1,J-1).
C
      DO 10 IROW=MAXORD,2,-1
       DO 20 ICOL=MAXORD,2,-1
        IPOS1=INDX(IROW,ICOL)
        IPOS2=INDX(IROW-1,ICOL-1)
        R(IPOS1)=R(IPOS2)
20     CONTINUE
10    CONTINUE
C
C NOW JUST COMPUTE THE FIRST ROW AND FIRST COLUMN OF RLE MATRIX. 
C
      IF(RLETYP.EQ.0)THEN
       CALL FRMRIJ(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,0,1,SINGLE)
       CALL FRMRIJ(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,1,0,SINGLE)
      ELSEIF(RLETYP.EQ.1.OR.RLETYP.EQ.3)THEN
       CALL FRMRIJ2(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,0,1,SINGLE,
     &              RLETYP)
       CALL FRMRIJ2(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,1,0,SINGLE,
     &              RLETYP)
      ELSEIF(RLETYP.EQ.2)THEN
       CALL FRMRIJ3(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,0,1,SINGLE)
       CALL FRMRIJ3(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,1,0,SINGLE)
      ENDIF
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE OUTPUT (MATRIX,ROWLOW,ROWHI,COLLOW,COLHI,ROWDIM,COLDIM,
     $                   NCTL)
C
C.......................................................................
C
C
C OUTPUT PRINTS A REAL*8 MATRIX IN FORMATTED FORM WITH NUMBERED ROWS
C
C AND COLUMNS.  THE INPUT IS AS FOLLOWS;
C
C        MATRIX(*,*).........MATRIX TO BE OUTPUT
C
C        ROWLOW..............ROW NUMBER AT WHICH OUTPUT IS TO BEGIN
C
C        ROWHI...............ROW NUMBER AT WHICH OUTPUT IS TO END
C
C        COLLOW..............COLUMN NUMBER AT WHICH OUTPUT IS TO BEGIN
C
C        COLHI...............COLUMN NUMBER AT WHICH OUTPUT IS TO END
C
C        ROWDIM..............ROW DIMENSION OF MATRIX(*,*)
C
C        COLDIM..............COLUMN DIMENSION OF MATRIX(*,*)
C
C        NCTL................CARRIAGE CONTROL FLAG; 1 FOR SINGLE SPACE
C                                                   2 FOR DOUBLE SPACE
C                                                   3 FOR TRIPLE SPACE
C
C        [ NCTL does not do what is claimed, and as far as I know
C          never has in the last decade. JDW 1/8/98. ]
C
C THE PARAMETERS THAT FOLLOW MATRIX ARE ALL OF TYPE INTEGER*4.  THE
C
C PROGRAM IS SET UP TO HANDLE 5 COLUMNS/PAGE WITH A 1P5D24.15 FORMAT FOR
C
C THE COLUMNS.  IF A DIFFERENT NUMBER OF COLUMNS IS REQUIRED, CHANGE
C
C FORMATS 1000 AND 2000, AND INITIALIZE KCOL WITH THE NEW NUMBER OF
C
C COLUMNS.
C
C AUTHOR;  NELSON H.F. BEEBE, QUANTUM THEORY PROJECT, UNIVERSITY OF
C          FLORIDA, GAINESVILLE
C
C REVISED;  FEBRUARY 26, 1971
C
C Revised to work with f90 : 1/8/98. JDW.
C
C.......................................................................
CSW      1
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER ROWLOW,ROWHI,COLLOW,COLHI,ROWDIM,COLDIM,BEGIN,KCOL
CSW      1
      REAL*8 MATRIX(ROWDIM,COLDIM)
CNSW     1
C     REAL   MATRIX(ROWDIM,COLDIM)
      CHARACTER*1 ASA,BLANK,CTL
      CHARACTER*6 COLUMN
      DIMENSION ASA(3)
      DATA COLUMN/'COLUMN'/,ASA/' ','0','-'/, BLANK/' '/
      DATA KCOL/4/
      DATA ZERO/0.D00/
      DO 10 I=ROWLOW,ROWHI
      DO 10 J=COLLOW,COLHI
      IF (MATRIX(I,J).NE.ZERO) GO TO 15
   10 CONTINUE
      WRITE (6,3000)
 3000 FORMAT ('0ZERO MATRIX.')
      GO TO 3
   15 CONTINUE
      CTL = BLANK
      IF ((NCTL.LE.3).AND.(NCTL.GT.0)) CTL = ASA(NCTL)
      IF (ROWHI.LT.ROWLOW) GO TO 3
      IF (COLHI.LT.COLLOW) GO TO 3
      LAST = MIN0(COLHI,COLLOW+KCOL-1)
      DO 2 BEGIN = COLLOW,COLHI,KCOL
      WRITE (6,1000) (COLUMN,I,I = BEGIN,LAST)
      DO 1 K = ROWLOW,ROWHI
      DO 4 I=BEGIN,LAST
      IF (MATRIX(K,I).NE.ZERO) GO TO 5
    4 CONTINUE
      GO TO 1
    5 WRITE (6,2000) CTL,K,(MATRIX(K,I), I = BEGIN,LAST)
    1 CONTINUE
    2 LAST = MIN0(LAST+KCOL,COLHI)
    3 RETURN
 1000 FORMAT (/,1X,16X,3(A6,I4,7X),(A6,I4))
 2000 FORMAT (A1,'ROW',I4,2X,4F17.11)
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

cSG/JDW 6/6/95
c Change of name for compatibility with newer IBM operating systems (XLF 3.2).

      character*(*) function trmblk(sz)
      implicit none

      character*(*) sz
      integer i, fnblnk, linblnk, iStart, iEnd

      trmblk=' '

      iStart = fnblnk(sz)
      if (iStart.ne.0) then
         iEnd = min(linblnk(sz),iStart-1+len(trmblk))
         trmblk = sz(iStart:iEnd)
      end if

      return
      end

      SUBROUTINE LINSRC(ICRD,MCRD,GRAD,GRADOL,STEP,STEPOL,
     &     TMPVEC,TMPVC2,ACTIVE,EMOD)
C
C     This routine calculates the step that should be taken to obtain
C     the next geometry.
C
      PARAMETER (IPRMIN = 0, IPRMED = 3, IPRMAX = 5, IPRDBG = 12)
      PARAMETER (D0 = 0.0D0)
      LOGICAL ACTIVE
      DIMENSION GRAD(MCRD), GRADOL(MCRD), STEP(MCRD), STEPOL(MCRD)
      DIMENSION TMPVEC(MCRD), TMPVC2(MCRD)
      ACTIVE = .TRUE.
      CALL DZERO(TMPVEC,MCRD)
      CALL DZERO(STEP,MCRD)
      STNM = SQRT(DDOT(ICRD,STEPOL,1,STEPOL,1))
      DO 10 I = 1, ICRD
         TMPVEC(I) = -STEPOL(I)/STNM
 10   CONTINUE
      GRAD0 = DDOT(ICRD,GRADOL,1,TMPVEC,1)
      GRAD1 = DDOT(ICRD,GRAD,1,TMPVEC,1)
      IF ((ABS(GRAD0) .LT. 1.0D-6) .OR. (ABS(GRAD1) .LT. 1.0D-6)) THEN
         IF (IPRINT .GE. IPRDBG) THEN
            WRITE(LUPRI,*)
            WRITE(LUPRI,*) 'Too close to minimum, line search skipped.'
         END IF
         ACTIVE = .FALSE.
         RETURN
      END IF
C
C     The energy and gradient from the last and current point, are
C     fitted to a quartic polynomial.
C
      CA = ABS(5.0D0*GRAD0 - 2.0D0*GRAD1 + 3.0D0*ERGOLD - 3.0D0*ENERGY)
      CB = GRAD1 + GRAD0 + 2.0D0*ERGOLD - 2.0D0*ENERGY - 2.0D0*CA
      CC = ENERGY - ERGOLD - GRAD0 - CA - CB
      CD = GRAD0
      CE = ERGOLD
C
C     The line search methdod is only used if the minimum lies
C     between the two points.
C
      IF ((GRAD0 .LT. D0) .AND. (GRAD1 .GT. D0)) THEN
         THRG = 1.0D-5*MIN(ABS(GRAD0),ABS(GRAD1))
         CRDA = D0
         CRDB = 1.0D0
         GRDA = GRAD0
         GRDB = GRAD1
         ISAFE = 0
 15      CONTINUE
         ISAFE = ISAFE + 1
         IF (ISAFE .GE. 200) THEN
            ACTIVE = .FALSE.
            IF (IPRINT .GE. IPRDBG) THEN
               WRITE(LUPRI,*)
               WRITE(LUPRI,*) 'Line search failed, ignoring.'
            END IF
            RETURN
         END IF
         CRDC = CRDA + (CRDB-CRDA)*
     &        MAX(0.1D0,MIN(0.9D0,ABS(GRDA/GRDB)*0.5D0))
         GRDC = ((4.0D0*CA*CRDC + 3.0D0*CB)*CRDC + 2.0D0*CC)*CRDC + CD
         IF (ABS(GRDC) .GT. THRG) THEN
            IF (GRDC .GT. D0) THEN
               CRDB = CRDC
               GRDB = GRDC
            ELSE
               CRDA = CRDC
               GRDA = GRDC
            END IF
            GOTO 15
         END IF
C
C     If the line search ends up almost back at the previous point, we do
C     not trust it and simply discard it.
C
         IF (CRDC .LT. 0.15D0) CRDC = 1.D0
C
         DO 20 I = 1, ICRD
            STEP(I) = STEPOL(I)*(1.0D0-CRDC)
            GRAD(I) = GRADOL(I) + (GRAD(I)-GRADOL(I))*CRDC
 20      CONTINUE
         EMOD = (((CA*CRDC + CB)*CRDC + CC)*CRDC + CD)*CRDC + CE
         IF (IPRINT .GE. IPRDBG) THEN
            CALL HEADER('Interpolated step',-1)
            CALL OUTPUT(STEP,1,1,1,ICRD,1,MCRD,1,LUPRI)
            CALL HEADER('Interpolated gradient',-1)
            CALL OUTPUT(GRAD,1,1,1,ICRD,1,MCRD,1,LUPRI)
            WRITE(LUPRI,*)
            WRITE(LUPRI,*) 'Interpolated energy: ',EMOD
         END IF
      ELSE
         IF (IPRINT .GE. IPRDBG) THEN
            WRITE(LUPRI,*)
            WRITE(LUPRI,*) 'Line search skipped.'
         END IF
         ACTIVE = .FALSE.
         RETURN
      END IF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_NAO_ORBITALS
     +
     +                    ( NBAS,NATOM,
     +                      MXSHELL,MXLSIZE,MXNAL,MXNBA,
     +                      NSHELLS,SHELLS,NBASAL,
     +                      P,PA,S,
     +                      SAL,CAL,WAL,
     +                      TSYM,
     +                      MJUMP,
     +                      NMB,NRB,
     +                      LSIZE,
     +                      BASBEG,BASEND,
     +                      PSYMACC,
     +                      SYMMAP,
     +                      ATDONE,IDXSYM,
     +                      COLMAP,
     +                      NRYDAL,
     +                      IVEC,XVEC,XMAT,
     +                      WPRE,
     +
     +                              BDSIZE,
     +                              BDATOM,
     +                              ANGSYM,
     +                              W,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_NAO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine generates the final set of NAO's in
C                atomic order from the input set of pre-NAO's in atomic
C                order. The steps performed are:
C
C
C                   1) Reorder the weights and pre-NAO coefficients
C                      from atomic to NMB/NRB order.
C
C
C                        ----- Orthonormalization of pre-NAO set ------
C
C
C                   2) Peform a WSW (weighted) orthonormalization on
C                      the NMB pre-NAO's to obtain the orthonormal
C                      NMB pre-NAO's.
C
C                           If NRB = 0, jump directly to step 10)
C
C                   3) Schmidt orthogonalize the NRB pre-NAO's to the
C                      orthogonal NMB pre-NAO's.
C
C                   4) Restore the pre-NAO character of the NRB space
C                      by diagonalizing the systems of equations
C                      P(AL)C(AL) = S(AL)C(AL)W(AL) for all Rydberg
C                      (AL) spaces.
C
C                   5) Divide the NRB pre-NAO's into two sets NRBINT
C                      and NRBEXT, depending on their weights.
C
C                   6) Reorder the NRB weigths and pre-NAO coefficients
C                      from NRB to NRBINT/NRBEXT order.
C
C                   7) Perform a scaled WSW (weighted) orthonormalization
C                      on the NRBINT pre-NAO's to obtain new orthonormal
C                      NRBINT pre-NAO's.
C
C                   8) Schmidt orthogonalize the NRBEXT pre-NAO's to the
C                      orthonormal NRBINT pre-NAO's.
C
C                   9) Perform a Loewdin orthonormalization on the
C                      NRBEXT pre-NAO's to obtain new orthonormal
C                      NRBEXT NAO's.
C
C                  10) Reorder the orthonormal pre-NAO coefficients from
C                      NMB/NRBINT/NRBEXT to atomic order.
C
C
C                        ----- Formation of final NAO set ------
C
C
C                  11) Form the NAO's by diagonalizing the systems of
C                      equations P(AL)C(AL) = S(AL)C(AL)W(AL) for all
C                      (AL) spaces.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    MXSHELL      =  largest l-shell value
C                    MXLSIZE      =  largest l-size value, i.e. maximum
C                                    m-degeneracy.
C                    MXNAL        =  maximum size of atomic l-shell
C                                    space. The atomic l-shell space
C                                    is the total # of contractions for
C                                    an atomic l-shell.
C                    MXNBA        =  maximum # of AOs per atom
C                    NSHELLS (A)  =  # of l-shells for atom A.
C                    SHELLS (I,A) =  I-th l-shell type (s=0,p=1,etc...)
C                                    for atom A (in increasing order!).
C                    NBASAL (I,A) =  size of I-th atomic l-shell space
C                                    for atom A.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    PA           =  atomic occupation matrix.
C                    S            =  full NBAS x NBAS overlap matrix.
C                    SAL,CAL,WAL  =  submatrices S(AL) and C(AL) for
C                                    overlap and density/pre-NAO coeffs
C                                    and subvector W(AL) for weights.
C                    TSYM         =  MXLSIZE x MXLSIZE matrix that will
C                                    be used to hold the l-sitesymmetry
C                                    transformation matrix.
C                    MJUMP        =  is .true., if the m values in the
C                                    m-space are ordered such that the
C                                    same m values are separated. This
C                                    keyword is necessary because some
C                                    AO basis functions are m-ordered
C                                    differently within each l-shell.
C                                    It invokes different types of
C                                    m-averaging algorithms.
C                    NMB,NRB      =  # of minimal and Rydberg type
C                                    pre-NAO's.
C                    LSIZE (I)    =  I-th l-shell size
C                    BASBEG (A)   =  first basis index number for atom A
C                    BASEND (A)   =  last basis index number for atom A
C                    PSYMACC      =  symmetry accuracy for occupation
C                                    matrix values (including weights)
C                    SYMMAP (A,B) =  has been set equal to 1 if atoms
C                                    A and B were found to be symmetry
C                                    related at the present stage of
C                                    calculation. A value of 0 indicates
C                                    no symmetry relation up to now.
C                    ATDONE (A)   =  will be used as an indicator if
C                                    atom A has been checked for
C                                    symmetry or not.
C                    IDXSYM       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    COLMAP (I)   =  column map in the active sense,
C                                    such that COLMAP (I) contains the
C                                    position index of I-th pre-NAO,
C                                    based on atomic order, in the
C                                    NMB/NRB order.
C                    NRYDAL (I,A) =  # of Rydberg pre-NAO's found for
C                                    the I-th atomic l-shell for atom A.
C                    IVEC,XVEC    =  int/flp scratch array of vector
C                                    type.
C                    XMAT         =  flp scratch array of matrix type.
C                    WPRE         =  pre-NAO weight vector in atomic
C                                    order.
C                    C            =  pre-NAO coefficient matrix in AO
C                                    basis with columns in atomic order.
C
C
C                  Output:
C
C                    BDSIZE (I)   =  NAO bond sizes, i.e. the # of atoms
C                                    which form the I-th NAO. Of course,
C                                    this is trivially = 1 for all NAO. 
C                    BDATOM (I)   =  Atomic index map for the NAOs.
C                                    Atomic index forming the I-th
C                                    NAO.
C                    ANGSYM (I)   =  angular symmetry of I-th NAO.
C                                    This is equal to the lowest l-shell
C                                    value that can mix with the I-th
C                                    NAO and is dependent on the site
C                                    symmetry of the atom to which the
C                                    I-th NAO belongs.
C                    W            =  NAO weight vector in atomic order.
C                    C            =  NAO coefficient matrix in AO basis
C                                    with columns in atomic order.
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ADD
         LOGICAL     FAILED
         LOGICAL     LOWDIN
         LOGICAL     LTRG,UTRG
         LOGICAL     MJUMP
         LOGICAL     NEW
         LOGICAL     NOOVLP
         LOGICAL     ORDER
         LOGICAL     REVERS
         LOGICAL     SAVEC,SAVEP,SAVES

         INTEGER     A,B
         INTEGER     ATOM
         INTEGER     BASB,BASL,BASNR
         INTEGER     I,J,K,N
         INTEGER     INDEX
         INTEGER     LDIM,LTOT,LTYPE
         INTEGER     MXSHELL,MXLSIZE,MXNAL,MXNBA
         INTEGER     NBAS,NATOM
         INTEGER     NAL
         INTEGER     NLTYPE
         INTEGER     NMB,NRB,NRBINT,NRBEXT
         INTEGER     NSYM
         INTEGER     NXBA

         INTEGER     ANGSYM  (1:NBAS     )
         INTEGER     ATDONE  (1:NATOM    )
         INTEGER     BASBEG  (1:NATOM    )
         INTEGER     BASEND  (1:NATOM    )
         INTEGER     BDATOM  (1:NBAS     )
         INTEGER     BDSIZE  (1:NBAS     )
         INTEGER     COLMAP  (1:NBAS     )
         INTEGER     IDXSYM  (1:NATOM    )
         INTEGER     IVEC    (1:NBAS+NBAS)
         INTEGER     LSIZE   (0:MXSHELL  )
         INTEGER     NSHELLS (1:NATOM    )

         INTEGER     NBASAL  (1:MXSHELL+1,1:NATOM)
         INTEGER     NRYDAL  (1:MXSHELL+1,1:NATOM)
         INTEGER     SHELLS  (1:MXSHELL+1,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM    ,1:NATOM)

         DOUBLE PRECISION  PSYMACC
         DOUBLE PRECISION  WEIGHT,WTHRESH,WSCALE
         DOUBLE PRECISION  X
         DOUBLE PRECISION  ZERO,ONE,WEQZERO

         DOUBLE PRECISION  W    (1:NBAS     )
         DOUBLE PRECISION  WAL  (1:MXNAL    )
         DOUBLE PRECISION  WPRE (1:NBAS     )
         DOUBLE PRECISION  XVEC (1:NBAS+NBAS)

         DOUBLE PRECISION  C    (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  S    (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  P    (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  PA   (1:MXNBA  ,1:MXNBA  )
         DOUBLE PRECISION  SAL  (1:MXNAL  ,1:MXNAL  )
         DOUBLE PRECISION  CAL  (1:MXNAL  ,1:MXNAL  )
         DOUBLE PRECISION  TSYM (1:MXLSIZE,1:MXLSIZE)
         DOUBLE PRECISION  XMAT (1:NBAS   ,1:NBAS   )

         DATA  ONE      /1.D0/
         DATA  ZERO     /0.D0/
         DATA  REVERS   /.TRUE./
         DATA  WTHRESH  /1.D-4/
         DATA  WEQZERO  /1.D-12/
C
C
C------------------------------------------------------------------------
C
C
C             ...save original pre-NAO weight vector in atomic order,
C                and reorder the pre-NAO coefficient matrix and the
C                weight vector from atomic to NMB/NRB order.
C
C
C         CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
C     +
C     +                ( 6,
C     +                  ' pre-NAO weight vector ',
C     +                  NBAS,
C     +                  NBAS,
C     +                  WPRE )
C     +
C     +
         CALL  MAT__W_EQ_U_FLOAT
     +
     +              ( NBAS,
     +                NBAS,
     +                NBAS,
     +                WPRE,
     +
     +                        W )
     +
         CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +              ( NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,
     +                COLMAP,
     +                XVEC,
     +
     +                        W )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBAS,NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,NBAS,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        C )
     +
     +
C
C
C             ...perform a WSW orthonormalization on the NMB part.
C
C
         SAVES = .TRUE.
         LOWDIN = .FALSE.
         NOOVLP = .FALSE.

         CALL    NLO__WSW_ORTHONORMALIZE
     +
     +                ( NBAS,NMB,
     +                  NBAS,NBAS,
     +                  NMB,
     +                  NBAS,NMB,
     +                  S,
     +                  W,
     +                  LOWDIN,
     +                  NOOVLP,
     +                  SAVES,
     +                  XVEC,XVEC (NMB+1),
     +                  XMAT,
     +
     +                          FAILED,
     +                          C )
     +
     +
         IF (FAILED) THEN
             WRITE (*,*) ' WSW orthonormalize failed for NMB part! '
             WRITE (*,*) ' nlo__gener_nao_orbitals '
             WRITE (1,*) ' WSW orthonormalize failed for NMB part! '
             WRITE (1,*) ' nlo__gener_nao_orbitals '
             STOP
         END IF
C
C
C             ...enter the Rydberg space processing (only, if Rydberg
C                space exists). Schmidt orthogonalize the NRB set of
C                pre-NAO's to the already orthonormal NMB set of
C                pre-NAO's.
C
C
         IF (NRB.NE.0) THEN

             SAVEC = .TRUE.
             SAVES = .TRUE.

             CALL    NLO__PARTIAL_SCHMIDT
     +
     +                    ( NBAS,NMB,
     +                      NBAS,NRB,
     +                      NBAS,NBAS,
     +                      NBAS,NMB,NRB,
     +                      MAX (NMB,NRB),MIN (NMB,NRB),
     +                      S,
     +                      SAVEC,SAVES,SAVEC,
     +                      C (1,1),
     +                      XVEC,
     +                      XMAT,
     +
     +                               C (1,NMB+1) )
     +
     +
C
C
C             ...restore the natural character of the Rydberg pre-NAO
C                basis, which has been modified during the above
C                Schmidt orthogonalization of the NRB pre-NAO set to
C                the orthogonal NMB pre-NAO set.
C
C                The structure of the algorithm is the same as for
C                the determination of the pre-NAO's, only this time
C                we look at the Rydberg space only. Symmetry related
C                atoms are treated on an equal footing.
C
C
             LTRG  = .TRUE.
             UTRG  = .FALSE.
             SAVEP = .TRUE.
             SAVES = .TRUE.

             BASB = NMB
             DO B = 1,NATOM
                IVEC (B) = BASB
                NLTYPE = NSHELLS (B)
                DO N = 1,NLTYPE
                   BASB = BASB + NRYDAL (N,B)
                END DO
             END DO

             DO A = 1,NATOM
                ATDONE (A) = 0
             END DO

             DO A = 1,NATOM
                NEW = ATDONE (A) .EQ. 0
                IF (NEW) THEN

                    NSYM = 0
                    DO B = 1,NATOM
                       IF (SYMMAP (B,A) .EQ. 1) THEN
                           NSYM = NSYM + 1
                           IDXSYM (NSYM) = B
                           ATDONE (B) = 1
                       END IF
                    END DO

                    BASL = 0
                    ATOM = IDXSYM (1)
                    NLTYPE = NSHELLS (ATOM)

                    DO N = 1,NLTYPE
                       LTOT = NRYDAL (N,ATOM)

                       IF (LTOT.NE.0) THEN
                           LTYPE = SHELLS (N,ATOM)
                           LDIM = LSIZE (LTYPE)
                           IF ( MOD (LTOT,LDIM).NE.0 ) THEN
                                WRITE (*,*) ' Bad NRB space size! '
                                WRITE (*,*) ' ATOM,SHELL = ',ATOM,LTYPE
                                WRITE (*,*) ' nlo__gener_nao_orbitals '
                                WRITE (1,*) ' Bad NRB space size! '
                                WRITE (1,*) ' ATOM,SHELL = ',ATOM,LTYPE
                                WRITE (1,*) ' nlo__gener_nao_orbitals '
                                STOP
                           END IF
                           NAL = LTOT / LDIM

                           DO I = 1,NSYM
                              B = IDXSYM (I)
                              BASB = IVEC (B)
                              BASNR = BASB + BASL
                              ADD = I.GT.1

                              CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                                   ( NBAS,LTOT,
     +                                     NBAS,NBAS,
     +                                     NBAS,LTOT,
     +                                     LTOT,
     +                                     LTOT,NBAS,
     +                                     0,
     +                                     SAVEP,LTRG,UTRG,
     +                                     C (1,BASNR+1),
     +                                     P,
     +                                     XVEC,
     +
     +                                             XMAT )
     +
     +
                              CALL  NLO__FORM_M_AVERAGED_MATRIX
     +
     +                                   ( NBAS,NBAS,
     +                                     MXNAL,MXNAL,
     +                                     LTOT,LDIM,
     +                                     0,
     +                                     MJUMP,LTRG,ADD,
     +                                     XMAT,
     +
     +                                             CAL )
     +
     +
                              CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                                   ( NBAS,LTOT,
     +                                     NBAS,NBAS,
     +                                     NBAS,LTOT,
     +                                     LTOT,
     +                                     LTOT,NBAS,
     +                                     0,
     +                                     SAVES,LTRG,UTRG,
     +                                     C (1,BASNR+1),
     +                                     S,
     +                                     XVEC,
     +
     +                                             XMAT )
     +
     +
                              CALL  NLO__FORM_M_AVERAGED_MATRIX
     +
     +                                   ( NBAS,NBAS,
     +                                     MXNAL,MXNAL,
     +                                     LTOT,LDIM,
     +                                     0,
     +                                     MJUMP,LTRG,ADD,
     +                                     XMAT,
     +
     +                                             SAL )
     +
     +
                           END DO

                           IF (NSYM.GT.1) THEN
                               X = ONE / DFLOAT (NSYM)
                               DO J = 1,NAL
                               DO I = J,NAL
                                  CAL (I,J) = X * CAL (I,J)
                                  SAL (I,J) = X * SAL (I,J)
                               END DO
                               END DO
                           END IF

                           CALL  MAT__GEN_EIGSYS_REAL_SYMMETRIC
     +
     +                                ( MXNAL,MXNAL,
     +                                  MXNAL,MXNAL,
     +                                  MXNAL,
     +                                  NAL,
     +                                  REVERS,
     +
     +                                          WAL,
     +                                          SAL,
     +                                          CAL )
     +
     +
                           DO I = 1,NSYM
                              B = IDXSYM (I)
                              BASB = IVEC (B)
                              BASNR = BASB + BASL

                              CALL  MAT__C_EQ_A_FLOAT
     +
     +                                   ( NBAS,LTOT,
     +                                     NBAS,LTOT,
     +                                     NBAS,LTOT,
     +                                     C (1,BASNR+1),
     +
     +                                             XMAT )
     +
     +
                              CALL  NLO__FORM_M_EXPANDED_COEFFS
     +
     +                                   ( NBAS,LTOT,
     +                                     MXNAL,MXNAL,
     +                                     NBAS,LTOT,
     +                                     NBAS,LTOT,NAL,
     +                                     MJUMP,
     +                                     XMAT,CAL,
     +
     +                                             C (1,BASNR+1) )
     +
     +
                              CALL  NLO__FORM_M_EXPANDED_WEIGHTS
     +
     +                                   ( MXNAL,
     +                                     LTOT,
     +                                     LTOT,NAL,
     +                                     MJUMP,
     +                                     WAL,
     +
     +                                             W (BASNR+1) )
     +
     +
                           END DO

                           BASL = BASL + LTOT

                       END IF
                    END DO
                END IF
             END DO
C
C
C             ...split the NRB Rydberg pre-NAO's into two sets
C                according to their weights. The first set will
C                contain those Rydberg pre-NAO's whose rescaled
C                weights (defined such that the largest weight
C                within the entire NRB set is equal to 1) are
C                larger than a threshold value WTHRESH. The second
C                set contains all the rest. The first set containing
C                NRBINT elements, will be subjected to a weighted
C                orthonormalization procedure with rescaled weights.
C                The rest, containing NRBEXT elements, will be
C                subjected to a normal Loewdin orthonormalization,
C                which can be performed with the same routine used
C                for weighted orthonormalizations but with all weights
C                equal to a constant value.
C
C                The first steps that follow are the rescaling of the
C                NRB weights, the decomposition of the NRB space into
C                NRBINT and NRBEXT, the determination of the Rydberg
C                column mapping (this is a local mapping!), the
C                local reordering of the Rydberg part of the pre-NAO
C                coefficient matrix and the update of the global
C                column permutation map.
C
C
             WSCALE = ZERO
             DO I = 1,NRB
                WSCALE = MAX (WSCALE,W (NMB+I))
             END DO
             WSCALE = ONE / WSCALE

             NRBINT = 0
             NRBEXT = 0

             DO I = 1,NRB
                WEIGHT = WSCALE * W (NMB+I)
                IF (WEIGHT.GT.WTHRESH) THEN
                    NRBINT = NRBINT + 1
                    IVEC (I) = NRBINT
                    XVEC (I) = WEIGHT
                ELSE
                    NRBEXT = NRBEXT + 1
                    IVEC (I) = NRBEXT + NBAS
                END IF
             END DO
         
             DO I = 1,NRB
                INDEX = IVEC (I)
                IF (INDEX.GT.NBAS) THEN
                    INDEX = INDEX - NBAS + NRBINT
                    IVEC (I) = INDEX
                ELSE
                    W (NMB+INDEX) = XVEC (I)
                END IF
             END DO

             CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +                  ( NBAS,NRB,
     +                    NRB,
     +                    NRB,
     +                    NBAS,
     +                    NBAS,NRB,
     +                    IVEC,
     +                    IVEC (NRB+1),
     +                    XVEC,
     +
     +                            C (1,NMB+1))
     +
     +
             DO I = 1,NBAS
                INDEX = COLMAP (I)
                IF (INDEX.GT.NMB) THEN
                    COLMAP (I) = IVEC (INDEX-NMB) + NMB
                END IF
             END DO
C
C
C             ...perform a WSW orthonormalization on the NRBINT part.
C
C
             SAVES = .TRUE.
             LOWDIN = .FALSE.
             NOOVLP = .FALSE.

             CALL  NLO__WSW_ORTHONORMALIZE
     +
     +                  ( NBAS,NRBINT,
     +                    NBAS,NBAS,
     +                    NRBINT,
     +                    NBAS,NRBINT,
     +                    S,
     +                    W (NMB+1),
     +                    LOWDIN,
     +                    NOOVLP,
     +                    SAVES,
     +                    XVEC,XVEC (NRBINT+1),
     +                    XMAT,
     +
     +                            FAILED,
     +                            C (1,NMB+1) )
     +
     +
             IF (FAILED) THEN
                 WRITE (*,*) ' WSW orthonorm failed for NRBINT part! '
                 WRITE (*,*) ' nlo__gener_nao_orbitals '
                 WRITE (1,*) ' WSW orthonorm failed for NRBINT part! '
                 WRITE (1,*) ' nlo__gener_nao_orbitals '
                 STOP
             END IF
C
C
C             ...Schmidt orthogonalize the NRBEXT set of pre-NAO's to
C                the already orthonormal NRBINT set of pre-NAO's.
C
C
             SAVEC = .TRUE.
             SAVES = .TRUE.

             CALL  NLO__PARTIAL_SCHMIDT
     +
     +                  ( NBAS,NRBINT,
     +                    NBAS,NRBEXT,
     +                    NBAS,NBAS,
     +                    NBAS,NRBINT,NRBEXT,
     +                    MAX (NRBINT,NRBEXT),MIN (NRBINT,NRBEXT),
     +                    S,
     +                    SAVEC,SAVES,SAVEC,
     +                    C (1,NMB+1),
     +                    XVEC,
     +                    XMAT,
     +
     +                             C (1,NMB+NRBINT+1) )
     +
     +
C
C
C             ...perform a WSW orthonormalization with equal weights
C                (i.e. a Loewdin orthonormalization) on the NRBEXT part.
C
C
             SAVES = .TRUE.
             LOWDIN = .TRUE.
             NOOVLP = .FALSE.

             CALL  NLO__WSW_ORTHONORMALIZE
     +
     +                  ( NBAS,NRBEXT,
     +                    NBAS,NBAS,
     +                    NRBEXT,
     +                    NBAS,NRBEXT,
     +                    S,
     +                    W (NMB+NRBINT+1),
     +                    LOWDIN,
     +                    NOOVLP,
     +                    SAVES,
     +                    XVEC,XVEC (NRBEXT+1),
     +                    XMAT,
     +
     +                            FAILED,
     +                            C (1,NMB+NRBINT+1) )
     +
     +
             IF (FAILED) THEN
                 WRITE (*,*) ' WSW orthonorm failed for NRBEXT part! '
                 WRITE (*,*) ' nlo__gener_nao_orbitals '
                 WRITE (1,*) ' WSW orthonorm failed for NRBEXT part! '
                 WRITE (1,*) ' nlo__gener_nao_orbitals '
                 STOP
             END IF
C
C
C             ...end Rydberg space manipulations.
C
C
         END IF
C
C
C             ...find invers of map: atomic -> NMB/NRBINT/NRBEXT
C                and restore the now orthonormal pre-NAO coefficient
C                matrix to atomic order.
C
C
         DO I = 1,NBAS
            IVEC (COLMAP (I)) = I
         END DO

         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBAS,NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,NBAS,
     +                IVEC,
     +                IVEC (NBAS+1),
     +                XVEC,
     +
     +                        C )
     +
     +
C
C
C             ...form the final NAO weights and coefficients in
C                atomic order. Note, that the present set of pre-NAO's
C                is now orthonormal, hence no atomic overlap submatrix
C                evaluation is necessary. Check the resulting NAO
C                weights for zeros to within numerical accuracy and
C                set them exactly equal to zero. This step is necessary
C                to avoid a later preliminary (unnecessary) stop
C                of the program when analyzing the NAO weights.
C                Set the NAO bond size array trivially equal to 1 and
C                fill in the NAO bond atom index array with the
C                appropriate atomic indices.
C
C                The structure of the code is essentially the same as
C                the one used to generate the initital pre-NAOs.
C                Symmetry equivalent atoms are treated together to
C                ensure NAO coefficient equalities.
C
C                Also, within each l-space, the NAOs will be ordered
C                such that the m-space is in separate order. For
C                example the p-shell NAOs will be ordered in the
C                form px,py,pz,px,py,pz,...This is achieved by
C                determining the column reordering map within each
C                l-space if MJUMP is .false.
C
C
         LTRG  = .TRUE.
         UTRG  = .FALSE.
         SAVEP = .TRUE.
         ORDER = .NOT.MJUMP

         DO A = 1,NATOM
            ATDONE (A) = 0
         END DO

         DO A = 1,NATOM
            NEW = ATDONE (A) .EQ. 0
            IF (NEW) THEN

                NSYM = 0
                DO B = 1,NATOM
                   IF (SYMMAP (B,A) .EQ. 1) THEN
                       NSYM = NSYM + 1
                       IDXSYM (NSYM) = B
                       ATDONE (B) = 1
                   END IF
                END DO

                BASL = 0
                ATOM = IDXSYM (1)
                NLTYPE = NSHELLS (ATOM)

                DO N = 1,NLTYPE
                   NAL = NBASAL (N,ATOM)
                   LTYPE = SHELLS (N,ATOM)
                   LDIM = LSIZE (LTYPE)
                   LTOT = NAL * LDIM

                   IF (ORDER) THEN
                       K = 0
                       DO I = 1,NAL
                       DO J = 1,LDIM
                          K = K + 1
                          COLMAP (K) = (J-1) * LDIM + I
                       END DO
                       END DO
                   END IF

                   DO I = 1,NSYM
                      B = IDXSYM (I)
                      BASB = BASBEG (B) - 1
                      BASNR = BASB + BASL
                      ADD = I.GT.1

                      CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                           ( NBAS,LTOT,
     +                             NBAS,NBAS,
     +                             NBAS,LTOT,
     +                             LTOT,
     +                             LTOT,NBAS,
     +                             0,
     +                             SAVEP,LTRG,UTRG,
     +                             C (1,BASNR+1),
     +                             P,
     +                             XVEC,
     +
     +                                     XMAT )
     +
     +
                      CALL  NLO__FORM_M_AVERAGED_MATRIX
     +
     +                           ( NBAS,NBAS,
     +                             MXNAL,MXNAL,
     +                             LTOT,LDIM,
     +                             0,
     +                             MJUMP,LTRG,ADD,
     +                             XMAT,
     +
     +                                     CAL )
     +
     +
                   END DO

                   IF (NSYM.GT.1) THEN
                       X = ONE / DFLOAT (NSYM)
                       DO J = 1,NAL
                       DO I = J,NAL
                          CAL (I,J) = X * CAL (I,J)
                       END DO
                       END DO
                   END IF

              WRITE (*,*) ' LTYPE,NAL = ',LTYPE,NAL

         CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +              ( 6,
     +                ' CAL matrix ',
     +                MXNAL,MXNAL,
     +                NAL,0,
     +                CAL )
     +
     +
                   CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
     +
     +                        ( MXNAL,MXNAL,MXNAL,
     +                          NAL,
     +                          REVERS,
     +
     +                                  WAL,
     +                                  CAL )
     +
     +
         CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +              ( 6,
     +                ' CAL eigenvalues ',
     +                MXNAL,1,
     +                NAL,1,
     +                WAL )
     +
     +
         CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +              ( 6,
     +                ' CAL eigenvectors ',
     +                MXNAL,MXNAL,
     +                NAL,NAL,
     +                CAL )
     +
     +
                   DO I = 1,NSYM
                      B = IDXSYM (I)
                      BASB = BASBEG (B) - 1
                      BASNR = BASB + BASL

                      CALL  MAT__C_EQ_A_FLOAT
     +
     +                           ( NBAS,LTOT,
     +                             NBAS,LTOT,
     +                             NBAS,LTOT,
     +                             C (1,BASNR+1),
     +
     +                                     XMAT )
     +
     +
                      CALL  NLO__FORM_M_EXPANDED_COEFFS
     +
     +                           ( NBAS,LTOT,
     +                             MXNAL,MXNAL,
     +                             NBAS,LTOT,
     +                             NBAS,LTOT,NAL,
     +                             MJUMP,
     +                             XMAT,CAL,
     +
     +                                     C (1,BASNR+1) )
     +
     +
                      IF (ORDER) THEN
                          CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +                               ( NBAS,LTOT,
     +                                 LTOT,
     +                                 LTOT,
     +                                 NBAS,
     +                                 NBAS,LTOT,
     +                                 COLMAP,
     +                                 IVEC,
     +                                 XVEC,
     +
     +                                     C (1,BASNR+1) )
     +
     +
                      END IF

                      CALL  NLO__FORM_L_SITESYM_COEFFS
     +
     +                           ( NBAS,MXLSIZE,
     +                             LTOT,LDIM,NAL,
     +                             TSYM,
     +                             P,
     +                             XVEC,
     +                             XMAT,
     +
     +                                     C (1,BASNR+1) )
     +
     +
                      CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                           ( NBAS,LTOT,
     +                             NBAS,NBAS,
     +                             NBAS,LTOT,
     +                             LTOT,
     +                             LTOT,NBAS,
     +                             0,
     +                             SAVEP,.FALSE.,.FALSE.,
     +                             C (1,BASNR+1),
     +                             P,
     +
     +                                     W (BASNR+1),
     +
     +                             XMAT )
     +
     +
                      DO J = 1,LTOT
                         WEIGHT = W (BASNR+J)
                         IF (DABS (WEIGHT).LT.WEQZERO) THEN
                             W (BASNR+J) = ZERO
                         END IF
                         BDSIZE (BASNR+J) = 1
                         BDATOM (BASNR+J) = B
                      END DO
                   END DO

                   BASL = BASL + LTOT

                END DO
            END IF
         END DO
C
C
C             ...determine the NAO angular symmetry.
C
C
         LTRG  = .TRUE.
         UTRG  = .FALSE.
         SAVEP = .TRUE.

         BASNR = 0

         DO ATOM = 1,NATOM

            NXBA = BASEND (ATOM) - BASBEG (ATOM) + 1

            CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                 ( NBAS,NXBA,
     +                   NBAS,NBAS,
     +                   NBAS,NXBA,
     +                   NXBA,
     +                   NXBA,NBAS,
     +                   0,
     +                   SAVEP,LTRG,UTRG,
     +                   C (1,BASNR+1),
     +                   P,
     +                   XVEC,
     +
     +                            XMAT )
     +
     +
            CALL  MAT__BLOCKDIAG_REAL_SYMMETRIC
     +
     +                 ( NBAS,NXBA,
     +                   MXNBA,NXBA,
     +                   NXBA,NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   PSYMACC,
     +                   REVERS,
     +                   IVEC (1),
     +                   IVEC (NXBA+1),
     +                   XMAT,
     +
     +                            XVEC,
     +                            PA )
     +
     +
            NLTYPE = NSHELLS (ATOM)

            BASL = NXBA

            DO N = NLTYPE,1,-1
               NAL = NBASAL (N,ATOM)
               LTYPE = SHELLS (N,ATOM)
               LDIM = LSIZE (LTYPE)
               LTOT = NAL * LDIM

               DO J = 1,NXBA
                  X = ZERO
                  DO I = 1,LTOT
                     X = X + PA (BASL-I+1,J)**2
                  END DO
                  XVEC (J) = ZERO
                  XVEC (NXBA+J) = X
               END DO

               DO J = 1,NXBA
                  X = XVEC (NXBA+J)
                  DO I = 1,NXBA
                     XVEC (I) = XVEC (I) + X * PA (I,J)**2
                  END DO
               END DO

               DO I = 1,NXBA
                  IF (XVEC (I).GT.PSYMACC) THEN
                      ANGSYM (BASNR+I) = LTYPE
                  END IF
               END DO

               BASL = BASL - LTOT

            END DO

            BASNR = BASNR + NXBA

         END DO
C
C
C             ...printout of NAO weights and coefficient matrix for
C                testing.
C
C
C         CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
C     +
C     +                ( 6,
C     +                  ' NAO weight vector ',
C     +                  NBAS,
C     +                  NBAS,
C     +                  W )
C     +
C     +
C         CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
C     +
C     +              ( 6,
C     +                ' NAO coefficient matrix in AO basis ',
C     +                NBAS,NBAS,
C     +                NBAS,NBAS,
C     +                C )
C     +
C     +
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine returns the index of the first element in a string array
c that matches a target string.

c NOTE: Fortran blank-pads strings and the native string comparison
c will return true if the strings are of different sizes but their
c non-blank data is equal. A different utility 'iszaleq' will return
c complete matches only.

c INPUT
c int N                : the total number of strings to test in SZA
c character*(*) SZA(*) : an array of character strings
c int INC              : the increment (leading dimension) of SZA
c character*(*) SZ     : the target string to match

      integer function iszeq(n,sza,inc,sz)
      implicit none

c ARGUMENTS
      character*(*) sza(*), sz
      integer n,inc

c INTERNAL VARIABLES
      integer i, ndx

c ----------------------------------------------------------------------

      iszeq = 0
      if ((n.lt.1).or.(inc.lt.1)) return

      if (inc.eq.1) then
         do i = 1, n
            if (sza(i).eq.sz) then
               iszeq = i
               return
            end if
         end do
      else
         ndx = 1
         do i = 1, n
            if (sza(ndx).eq.sz) then
               iszeq = i
               return
            end if
            ndx = ndx + inc
         end do
c     end if (inc.eq.1)
      end if

      return
      end

      SUBROUTINE ASSIGN_DIHLSNPL(CARTCOORD, IBNDTO, IREDUNCO, 
     &                           TOTREDNCO, TOTNOFBND, TOTNOFANG,
     &                           TOTNOFDIH, NRATMS, MAXREDUNCO,
     &                           THRESHOLD)
C
C This routine setup the connectivity array to define dihedral angles
C for nearly planar molecules. This  array is dimensioned to 
C (4, MAXREDUNCO).
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH
      DIMENSION IREDUNCO(4, MAXREDUNCO), IBNDTO(NRATMS, NRATMS),
     &          CARTCOORD(3*NRATMS), TMPVEC1(3), TMPVEC2(3),
     &          TMPVEC3(3)
C
      DATA IZERO /0/
C
      NOOFNEW = IZERO
      
      DO 10 IBNDS = 1, TOTNOFBND
         IBND1 = IREDUNCO(1, IBNDS)
         IBND2 = IREDUNCO(2, IBNDS)
C
         IF (IBND2 .GT. IZERO) THEN
C
            DO 20 IANGLS = (TOTNOFBND + 1), (TOTNOFANG + TOTNOFBND)
C
               IANG1 = IREDUNCO(1, IANGLS)
               IANG2 = IREDUNCO(2, IANGLS)
               IANG3 = IREDUNCO(3, IANGLS)
              
               IF ((IBND1 .EQ. IANG2 .AND. IBND2 .GT. IANG1 .AND. IBND2
     &             .GT. IANG3) .OR. (IBND2 .EQ. IANG2 .AND. IBND1 .GT.
     &             IANG1  .AND. IBND1 .GT. IANG3)) THEN
C     
                  ICON1 = IANG2
                  ICON2 = IANG1
                  ICON3 = IBND1
                  ICON4 = IANG3
C
                  IF (IBND1 .EQ. IANG2) ICON3 = IBND2
C
C Take care of linear angles if they are present
C     
                  IF ((IBNDTO(ICON2, ICON3)) .EQ. -99) THEN
                     ICON4 = ICON3
                     ICON3 = IANG3
                  ELSE IF ((IBNDTO(ICON3, ICON4)) .EQ. -99) THEN
                     ICON4 = ICON2
                     ICON2 = IANG1
                  ENDIF
C
C If there is an atom bonded to the ICON1 and not in the ICON2, ICON3, 
C ICON4 plane, we can define angle bends to take care of the 
C out-of-plane coordinate, no need of a dihedral angle coordinate.
C
                  CALL VEC(CARTCOORD(3*ICON3+1), CARTCOORD(3*ICON2+1), 
     &                     TMPVEC1, 0)
                  CALL VEC(CARTCOORD(3*ICON3+1), CARTCOORD(3*ICON4+1), 
     &                     TMPVEC2, 0)
                  CALL CROSS(TMPVEC1, TMPVEC2, TMPVEC3, 1)
C
                  DO 30 KBNDS = 1, TOTNOFBND
                     KBND1 = IREDUNCO(1, KBNDS) 
                     KBND2 = IREDUNCO(2, KBNDS) 
C
                     IF (KBND2 .GT. IZERO) THEN
C
                        IF (KBND1 .EQ. ICON1 .AND. KBND2 .NE. ICON2
     &                      .AND. KBND2 .NE. ICON3 .AND. KBND2 .NE.
     &                      ICON4) THEN
C
                           CALL VEC(CARTCOORD(3*ICON3 + 1), 
     &                              CARTCOORD(3*KBND2 + 1), 
     &                              TMPVEC1, 0)
                         IF (XDOT(3, TMPVEC1, 1, TMPVEC3, 1) .GT.
     &                   THRESHOLD) 
     &                   GO TO 20
                        
                        ELSE IF (KBND2 .EQ. ICON1 .AND. KBND1 .NE. 
     &                           ICON2 .AND. KBND1 .NE. ICON3 .AND.
     &                           KBND1 .NE. ICON4) THEN

                        CALL VEC(CARTCOORD(3*ICON3 + 1), 
     &                           CARTCOORD(3*KBND1 + 1), 
     &                            TMPVEC1, 0)
                        IF (XDOT(3, TMPVEC1, 1, TMPVEC3, 1) .GT. 
     &                  THRESHOLD)  
     &                  GO TO 20
C
                        ENDIF
                     ENDIF
 30               CONTINUE
C
                  NOOFNEW = NOOFNEW + 1
C     
                  IREDUNCO(1, TOTREDNCO + NOOFNEW) = ICON3
                  IREDUNCO(2, TOTREDNCO + NOOFNEW) = ICON2
                  IREDUNCO(3, TOTREDNCO + NOOFNEW) = ICON1
                  IREDUNCO(4, TOTREDNCO + NOOFNEW) = ICON4
C
               ENDIF
C            ENDIF
C
 20      CONTINUE
        ENDIF
 10   CONTINUE
C
      TOTNOFDIH = TOTNOFDIH + NOOFNEW
      TOTREDNCO = TOTREDNCO + NOOFNEW
C
      IF (TOTREDNCO .GE. MAXREDUNCO) THEN
        WRITE(6, 99) TOTREDNCO, MAXREDUNCO
 99     FORMAT(T3,'Maximum No. of redundent coordinates allowed',
     &         '/', 'exceeded','/',
     &         T3,' Required:',I3,' Current Maximum:',I3)
        CALL ERREX
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__PRINT_V_FLOAT_5_NOZEROS
     +
     +                    ( UNITID,
     +                      TITLE,
     +                      DDVEC,
     +                      VEC,
     +                      V )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__PRINT_V_FLOAT_5_NOZEROS
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation prints a vector V to the unit specified
C                by UNITID in floating point format F11.5 . Values
C                below 5.0D-6 are not printed.
C
C                The vector is printed in one column.                    
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         INTEGER    DDVEC
         INTEGER    I
         INTEGER    UNITID
         INTEGER    VEC

         CHARACTER*11       S
         CHARACTER*(*)      TITLE

         DOUBLE PRECISION   LIMIT

         DOUBLE PRECISION   V (1:DDVEC)

         DATA LIMIT  /5.0D-6/
C
C
C------------------------------------------------------------------------
C
C
C             ...printout title.
C
C
         WRITE (UNITID,6000)
         WRITE (UNITID, *  ) TITLE
         WRITE (UNITID,7000)
C
C
C             ...immediate return if length is zero.
C
C
         IF  ( VEC.EQ.0 )  RETURN
C
C
C             ...check dimension.
C
C
         IF  ( VEC .GT. DDVEC )  THEN

               WRITE (1,*) ' Dimension of vector V too small: '
               WRITE (1,*) ' mat__print_v_float_5_nozeros '
               WRITE (1,*) ' DDVEC,VEC = ',
     +                       DDVEC,VEC

               WRITE (*,*) ' Dimensions of vector V too small: '
               WRITE (*,*) ' mat__print_v_float_5_nozeros '
               WRITE (*,*) ' DDVEC,VEC = ',
     +                       DDVEC,VEC

               STOP

         END IF
C
C
C             ...print vector.
C
C
         DO  10  I = 1,VEC

             IF  ( ABS ( V(I) ) .LT. LIMIT )  THEN
                   S = ' '
             ELSE 
                   WRITE (S,8000) V(I)
             END IF

             WRITE (UNITID,9000) I,S

   10    CONTINUE
C
C
C             ...formats of printing.
C
C
 6000    FORMAT  (/)
 7000    FORMAT  (/)
 8000    FORMAT  (F11.5)
 9000    FORMAT  (1X,I8,A11)
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine hyprchm_rd_geomvib(natoms, iatchrg, coord,ifuchrg,
     &                            fucoord,freqco,freq,dnormmd, 
     &                            intensites,iord,normco_exsist,linear)
c------------------------------------------------------------------------------
c read coordinates from jobarc 
c------------------------------------------------------------------------------
      implicit double precision (a-h, o-z)
      dimension iatchrg(natoms),ifuchrg(natoms),iord(3*natoms)
      character*1 askip
      character*80 line
      double precision coord(3,natoms), fucoord(3,natoms),
     &                 freqco(natoms, 3), dnormmd(9*natoms*natoms),
     &                 intensites(3*natoms), freq(3*natoms)
      logical normco_exsist, linear, tbohr
      data IONE /1/
C-----------------------------------------------------------------------------


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      call izero(iatchrg,natoms)
      call zero(coord,3*natoms)
c
c read in the atomic charges and coordinates and remove dummy atoms
c convert from bohr to angstrom
c
      call getrec(20,'JOBARC','ATOMCHRG',natoms,ifuchrg)
      call getrec(20,'JOBARC','COORD',3*natoms*iintfp,fucoord)
C
      i=1
      do j = 1, natoms
         if (ifuchrg(j).ne.0) then
            coord(1,i)=fucoord(1,j)
            coord(2,i)=fucoord(2,j)
            coord(3,i)=fucoord(3,j)
            iatchrg(i)=ifuchrg(j) 
            i=i+1
         end if
      end do 

      call getrec(20,'JOBARC','NREALATM',1,nrealatm)

      if(i.ne.nrealatm+1)then
        write(6,*)' Problem reading coordinates from JOBARC file'
        call errex
      endif
C
      natoms = nrealatm

      inquire(file='NORMCO',exist=normco_exsist)

      if(normco_exsist)then
        open(unit=4,file='NORMCO',form='formatted',status='old')
        rewind(4)
      else
         goto 5
      endif
C
      call getrec(20, 'JOBARC', 'LINEAR  ',IONE, ILINEAR)
      linear = .false.
      IF (ILINEAR .EQ. 1) linear = .TRUE.
C
C Read the mass weigthed Cartesian coordinates
C
      read(4,*) askip
      do 20 iatom=1,natoms
        read(4,*)(freqco(i,iatom),i=1,3)
20    continue

c      
c Read vibrational frequncies and normal coordinates
c 

      do 30 i=1,3*natoms
         read(4,'(a)') askip
         read(4,'(a)') line(1:21)
         read(unit=line(1:20),fmt=*) freqy
         if (line(21:21) .eq. 'i') freqy = -freqy
         freq(i) = freqy
         read(4,*) askip

         do 40 j=1,natoms
            read(4,*)(dnormmd((i-1)*3*natoms+(j-1)*3+k), k=1,3)
 40      continue

 30   continue

c
c     Identify the null vectors
c

      do 44 i=1, natoms*3
         iord(i) = i
 44   continue

      do 45 i=1, 3*natoms - 1
         do 46 j=i+1,3*natoms
            if(dabs(freq(i)) .lt. dabs(freq(j))) then
               save = freq(i)
               freq(i) = freq(j)
               freq(j) = save
               isave = iord(i)
               iord(i) = iord(j)
               iord(j) = isave
            endif
 46      continue
 45   continue

      if (linear) then
         istp = 3*natoms - 5
      else
         istp = 3*natoms - 6
      endif


      do 47 i=1, istp - 1
         do 48 j=i+1, istp
            if(freq(j) .lt. freq(i)) then
               save = freq(i)
               freq(i) = freq(j)
               freq(j) = save
               isave = iord(i)
               iord(i) = iord(j)
               iord(j) = isave
            endif
 48      continue
 47   continue

c
c Read intensities
c
      do 50 i = 1, 3*natoms
         read(4, *)  askip
         read(4, *) intensites(i)
50    continue

      close(unit=4,status='KEEP')

 5    return
      end

      SUBROUTINE GENREP(BIGX,R,IPTR,NATOM)
C
C GENERATES THE (3*NATOM,3*NATOM) REPRESENTATION OF
C THE SYMMETRY OPERATION GIVEN BY THE 3x3 CARTESIAN
C MATRIX R AND THE POINTER VECTOR IPTR
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION R(3,3),IPTR(NATOM),BIGX(3*NATOM,3*NATOM)
      DATA ONE,ONEM,ZILCH/1.0D0,-1.0D0,0.0D0/
      CALL ZERO(BIGX,9*NATOM*NATOM)
      NX=3*NATOM
c      CALL MTRAN2(R,3)
      DO 10 IATOM=1,NATOM
       JATOM=IPTR(IATOM)
       I=1+3*(IATOM-1)
       J=1+3*(JATOM-1)
       CALL BLKCPY(R,3,3,BIGX,NX,NX,I,J)
10    CONTINUE
      RETURN
      END  

c The call stack is a list of routine names. Every time you call a routine,
c the name of that routine should be pushed onto the stack. When you exit,
c you should remove the name from the stack.

c This is useful for tracking down where errors occur, but it requires
c discipline since stack management is not automatic.

c The "stack" has two components: the array of strings ("invisible" to
c the rest of the code) and callstack_curr (from include/callstack.com).
c The reason is that in many routines, the overhead from calling push/pop
c would have a major impact on performance. Other times, it is completely
c negligible. You should try to use push/pop whenever possible and revert
c to setting callstack_curr manually when performance is critical. Using
c callstack_curr too deeply defeats the purpose of a stack, but it can
c be used as a tracer.

c Prototypes:
c    subroutine callstack_init(szRoutine)
c    subroutine callstack_push(szRoutine)
c    subroutine callstack_print
c    subroutine callstack_pop
c    subroutine callstack_term

#define _CALLSTACK_LEN 32 /* max length of routine name */
#define _CALLSTACK_NUM 100 /* max depth of stack */
c#define _CALLSTACK_TRACE /* for verbose program tracing */

#ifdef _FAIL_TO_COMPILE_
c Copy this block to each routine:
#undef _CALLSTACK_COM_
#include "callstack.com" /* for callstack_curr */
      external callstack_bd
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
#endif /* _FAIL_TO_COMPILE_ */

c ----------------------------------------------------------------------

      blockdata callstack_bd
      implicit none
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
      data callstack /_CALLSTACK_NUM*' '/
      data csn /0/
      end

c ----------------------------------------------------------------------

      subroutine callstack_init(szRoutine)
      implicit none
#undef _CALLSTACK_COM_
#include "callstack.com" /* for callstack_curr */
      external callstack_bd
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
      character*(*) szRoutine
      integer i
      callstack_curr = szRoutine
      callstack(1)   = szRoutine
      do i = 2, _CALLSTACK_NUM
         callstack(i) = ' '
      end do
      csn = 1
#ifdef _CALLSTACK_TRACE
      write(*,*) '@CALLSTACK_INIT: initialized callstack for ',szRoutine
#endif
      return
      end

c ----------------------------------------------------------------------

      subroutine callstack_push(szRoutine)
      implicit none
#undef _CALLSTACK_COM_
#include "callstack.com" /* for callstack_curr */
      external callstack_bd
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
      character*(*) szRoutine
#ifdef _CALLSTACK_TRACE
      write(*,*) '@CALLSTACK_PUSH: callstack(',csn+1,') = ',szRoutine
#endif
      callstack_curr = szRoutine
      csn = csn+1
      if (csn.le._CALLSTACK_NUM) then
         callstack(csn) = szRoutine
      else
         write(*,*) '@CALLSTACK_PUSH: stack length exceeded by ',
     &              szRoutine
      end if
      return
      end

c ----------------------------------------------------------------------

      subroutine callstack_print
      implicit none
#undef _CALLSTACK_COM_
#include "callstack.com" /* for callstack_curr */
      external callstack_bd
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
      integer i, j
      write(*,*) '@CALLSTACK: ',callstack_curr
      j = csn
      if (callstack(csn).eq.callstack_curr) j = csn-1
      do i = j, 1, -1
         write(*,*) ' called by: ',callstack(i)
      end do
      return
      end

c ----------------------------------------------------------------------

      subroutine callstack_pop
      implicit none
#undef _CALLSTACK_COM_
#include "callstack.com" /* for callstack_curr */
      external callstack_bd
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
      if (csn.le.0) then
         write(*,*) '@CALLSTACK_POP: callstack is empty.'
         call c_exit(1)
      end if
#ifdef _CALLSTACK_TRACE
      if (csn.le._CALLSTACK_NUM) then
         write(*,*) '@CALLSTACK_POP: popped ',callstack(csn)
      else
         write(*,*) '@CALLSTACK_POP: popping overflow level ',csn
      end if
#endif
      csn = csn-1
      callstack_curr = 'UNKNOWN'
      if (csn.le._CALLSTACK_NUM) callstack_curr = callstack(csn)
      return
      end

c ----------------------------------------------------------------------

      subroutine callstack_term
      implicit none
#undef _CALLSTACK_COM_
#include "callstack.com" /* for callstack_curr */
      external callstack_bd
      character*(_CALLSTACK_LEN) callstack(_CALLSTACK_NUM)
      integer csn
      common /callstack_com/ callstack, csn
      save   /callstack_com/
      if (csn.gt.1) then
         write(*,*) '@CALLSTACK_TERM: callstack is not empty.'
         call callstack_print
         call c_exit(1)
      end if
#ifdef _CALLSTACK_TRACE
      write(*,*) '@CALLSTACK_TERM: done with ',callstack(1)
#endif
      callstack(1) = ' '
      csn = 0
      return
      end

C
C THIS ROUTINE CHANGES THE CHARACTERISTICS OF A LIST, AND
C  SHOULD BE USED ONLY BY EXPERIENCED CRAPS PROGRAMMERS!
C  
C INPUT: LIST   - THE LIST NUMBER WHICH IS TO BE CHANGED.
C        SYTYPL - THE NEW SYMMETRY TYPE FOR THE BRA INDICES.
C        SYTYPR - THE NEW SYMMETRY TYPE FOR THE KET INDICES.
C        CHANGE - LOGICAL VARIABLE WHICH CONTROLS WHETHER OR
C                 NOT THE CORRESPONDING ISYTYP ENTRIES ARE
C                 CHANGED TO CORRESPOND TO THE NEW LIST TYPE.
C                 SET THIS TO .TRUE. UNLESS YOU REALLY KNOW
C                 WHAT YOU ARE DOING.
C
      SUBROUTINE NEWTYP(LIST,SYTYPL,SYTYPR,CHANGE)
      IMPLICIT INTEGER (A-Z)
      LOGICAL CHANGE
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &              MOIODS(10,500),MOIOFL(10,500)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /AUXCACHE/ QUIKGET(10,500)
#ifdef _ASSERT
      if ((SYTYPL.lt.1).or.(22.lt.SYTYPL).or.
     &    (SYTYPR.lt.1).or.(22.lt.SYTYPR)    ) then
         print *, '@NEWTYP: Assertion failed.'
         print *, '   SYTYPL = ',SYTYPL
         print *, '   SYTYPR = ',SYTYPR
         print *, '   LIST   = ',LIST
         call errex
      end if
#endif /* _ASSERT */ 
      TOTNEW=0
      TOTOLD=0
      IWORD2=QUIKGET(1,LIST)
      IWORD=MOIOWD(1,LIST)
      IREC =MOIO(1,LIST)
      ILIST=LIST
      IF(LIST.GT.100) ILIST=LIST
      DO 10 IRREP=1,NIRREP
       NUMDIS=IRPDPD(IRREP,SYTYPR)
       DISSIZ=IRPDPD(IRREP,SYTYPL)
       TOTNEW=TOTNEW+NUMDIS*DISSIZ
       TOTOLD=TOTOLD+IRPDPD(IRREP,ISYTYP(1,ILIST))*
     &               IRPDPD(IRREP,ISYTYP(2,ILIST))
       MOIODS(IRREP,LIST)=NUMDIS
       MOIOSZ(IRREP,LIST)=DISSIZ
       MOIOWD(IRREP,LIST)=IWORD
       MOIO  (IRREP,LIST)=IREC
       IF(QUIKGET(IRREP,LIST).NE.0)QUIKGET(IRREP,LIST)=IWORD2
       IWORD=IWORD+NUMDIS*DISSIZ*IINTFP
       IWORD2=IWORD2+NUMDIS*DISSIZ*IINTFP
       IF(IWORD.GT.LENREC)THEN
        INC=(IWORD-1)/LENREC
        IWORD=IWORD-INC*LENREC
        IREC=IREC+INC
       ENDIF
10    CONTINUE
      IF(CHANGE) THEN
      ISYTYP(1,ILIST)=SYTYPL
      ISYTYP(2,ILIST)=SYTYPR
      ENDIF
      IF(TOTNEW.GT.TOTOLD)THEN
       WRITE(6,100)LIST,TOTNEW,TOTOLD
100    FORMAT(T3,'@NEWTYP-F, Length of new list ',I3,'[',I8,' words]',
     &          /,'exceeds original length [',I8,' words].')
       CALL ERREX
      ENDIF
      RETURN
      END 

C
      SUBROUTINE CSHIFTPRI(CSHIFT, INDEX)
C
C Print out the total shielding tensor and orientation of the shielding
C tensor. Coded by Ajith 04/96.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION CSHIFT (3, 3)
C
      CHARACTER*5 COORD(3)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C
      DATA COORD/'x    ','y    ','z    '/
C
      WRITE (6, 10)
C
      DO 5 I = 1, 3
         WRITE(6, 20) ZSYM(INDEX), COORD(I), (CSHIFT(I,J),J=1,3)
    5 CONTINUE
C
 10   FORMAT(/)
 20   FORMAT(15X, A2, 1X, A2, 3F12.6)
C
      RETURN
      END

C CHARACTER*8 FUNCTION WHICH RETURNS THE TYPE OF AN ORBITAL (OCCUPIED
C OR VIRTUAL) FOR AN GIVEN ORBITAL BY CHECKING ITS INDEX

      CHARACTER*8 FUNCTION TYPEO(I,NI)
      IF (I.LE.NI) THEN
         TYPEO='occupied'
      ELSE
         TYPEO=' virtual'
      END IF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c RECORDS
c get TYPE//'SYMQ'
c get TYPE//'SYQT'
c get TYPE//'NSYQ'
c get TYPE//'LABL'
c get 'LINEAR'
c get ROTREC(IXYZ)
c get TRAREC(IXYZ)
c put 'NVIBSYM'
c put TYPE//'SYMQ'
c put TYPE//'SYQT'
c put 'NUMVIBRT'

      SUBROUTINE COLLECT(NATOM,NIRREP,SCRIN,SCROUT,
     &                   ISCRIN,ISCROUT,LABEL,TYPE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SCRIN(*),SCROUT(*),ISCRIN(*),ISCROUT(*)
      CHARACTER*8 LABEL(NIRREP)
      CHARACTER*4 TYPE

      CHARACTER*8 ROTREC(3),TRAREC(3)
      DIMENSION NVIBSYM(20)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
#include "control.com"

      DATA TOL/1.D-8/
      DATA ROTREC /'ROTVECX ','ROTVECY ','ROTVECZ '/
      DATA TRAREC /'TRAVECX ','TRAVECY ','TRAVECZ '/

      IPOSOUT=0
      NSIZE=3*NATOM

c   o read in symmetry adapted coordinates and their symmetries
      CALL DGETREC(20,'JOBARC',TYPE//'SYMQ',NSIZE*NSIZE,SCRIN)
      CALL IGETREC(20,'JOBARC',TYPE//'SYQT',NSIZE,ISCRIN)
      CALL IGETREC(20,'JOBARC',TYPE//'NSYQ',1,NCOORD)
      CALL DGETREC(20,'JOBARC',TYPE//'LABL',NIRREP,LABEL)
      CALL IGETREC(20,'JOBARC','LINEAR  ',1,ILINEAR)

c   o loop over coordinates and remove zero entries
      CALL IZERO(NVIBSYM,NIRREP)
      DO IPOSIN=1,NCOORD
         LOCIN=1+(IPOSIN-1)*NSIZE
         X=DNRM2(NSIZE,SCRIN(LOCIN),1)
         IF (X.GT.TOL) THEN
            IPOSOUT=IPOSOUT+1
            LOCOUT=1+(IPOSOUT-1)*NSIZE
            CALL XDCOPY(NSIZE,SCRIN(LOCIN),1,SCROUT(LOCOUT),1)
            ISCROUT(IPOSOUT)=ISCRIN(IPOSIN)
            NVIBSYM(ISCROUT(IPOSOUT))=NVIBSYM(ISCROUT(IPOSOUT))+1
         END IF
      END DO

      NMODE=IPOSOUT

      ILOC=IPOSOUT*NSIZE+1

c   o put rotations and translations in rest of matrix
      IF (ROTPROJ) THEN
         ITOP=3-ILINEAR
         DO IXYZ=1,ITOP
            CALL DGETREC(20,'JOBARC',ROTREC(IXYZ),NSIZE,
     &                  SCROUT(ILOC))
            ILOC=ILOC+NSIZE
         END DO
      END IF
      DO IXYZ=1,3
         CALL DGETREC(20,'JOBARC',TRAREC(IXYZ),NSIZE,SCROUT(ILOC))
         ILOC=ILOC+NSIZE
      END DO

      CALL IPUTREC(20,'JOBARC','NVIBSYM ',NIRREP,NVIBSYM)
      CALL DPUTREC(20,'JOBARC',TYPE//'SYMQ',NSIZE*NCOORD,SCROUT)
      CALL IPUTREC(20,'JOBARC',TYPE//'SYQT',NSIZE,ISCROUT)
      CALL IPUTREC(20,'JOBARC','NUMVIBRT',1,NMODE)

      RETURN
      END

      SUBROUTINE GSCHMIDT(VORTH,NSIZE,NDIM,TMP,RESID)
C
C THIS PROJECTS OUT ALL PARTS OF AN INPUT VECTOR (VEC)
C WHICH LIE IN THE SPACE SPANNED BY THE ORTHOGONAL BASIS
C VORTH.
C
C   |v'> = |v> - SUM <i|v> |i>
C                 i 
C
C WHERE THE |i> ARE NORMALIZED BASIS VECTORS FOR THE SPACE VORTH
C
C INPUT:
C       VEC : THE VECTOR WHICH IS TO BE ORTHOGONALIZED TO
C             THE EXISTING BASIS.  *IT IS ASSUMED THAT VEC
C             IS NORMALIZED ON INPUT)
C     VORTH : THE BASIS VECTORS FOR THE EXISTING ORTHOGONAL
C             BASIS
C     NSIZE : THE LENGTH OF THE BASIS VECTORS
C      NDIM : THE DIMENSION OF THE ORTHOGONAL SPACE
C       TMP : A SCRATCH VECTOR OF LENGTH NSIZE
C     RESID : THE NORM OF VEC, AFTER ORTHONALIZATION AND
C             BEFORE NORMALIZATION
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VORTH(NSIZE,NDIM),TMP(NSIZE)
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      write(6,"(a)") 'Non-orthogonal vectors in gschmidt'
      call output(vorth,1,nsize,1,ndim,nsize,ndim,1)
      do i = 1, ndim
         TMP(i)=XDDOT(NSIZE,VORTH(1,I),1,VORTH(1,I),1)
      enddo  
      Write(6,*)
      write(6,"(a)") 'Old overlap in gschmidt'
      Write(6, "(6(1x,F12.6))") (TMP(i), i=1, NSIZE)
#endif
C
      DO I=2, NDIM 
         DO J=1, I-1
            FACT=XDDOT(NSIZE,VORTH(1,I),1,VORTH(1,J),1)
            CALL XDAXPY(NSIZE,-FACT, VORTH(1,J), 1,VORTH(1,I),1)
            TMP(I)=XDDOT(NSIZE,VORTH(1,I),1,VORTH(1,I),1)
            CALL XDSCAL(NSIZE, TMP(I), VORTH(1,I), 1)
         ENDDO
      ENDDO 

C
      DO I = 2, NDIM
         TMP(I)=XDDOT(NSIZE,VORTH(1,I),1,VORTH(1,I),1)

         CALL XDSCAL(NSIZE, 1.0D0/DSQRT(TMP(I)), VORTH(1,I), 1)
      ENDDO

#ifdef _DEBUG_LVL0
      write(6,*)
      write(6,"(a)") 'Orthogonal vectors in gschmidt'
      call output(vorth,1,nsize,1,ndim,nsize,ndim,1)
      do i = 1, ndim
         TMP(i)=XDDOT(NSIZE,VORTH(1,I),1,VORTH(1,I),1)
      enddo
      Write(6,*)
      write(6,"(a)") 'Current overlap in gschmidt'
      Write(6, "(6(1x,F12.6))") (Tmp(i), i=1, NSIZE)
#endif
C
      RETURN
      END

      Subroutine Dfactorial 
C 
C Compute Double factorial of n!! (n(n-2)...531) or (n(n-2)..6421) 
C depending on n is odd or even. 0!!,-1!! = 0
c
      Implicit Double Precision(A-H, O-Z)

#include "ecp.par"
#include "ecp.com"
      
      Fac2(-1) = 1.0D0
      Fac2(0)  = 1.0D0
      Fac2(1)  = 1.0D0
      Fac2(2)  = 2.0D0

      FI = 2.0D0

      Do I = 2, 4*Maxang-1
         FI = FI + 1.0D0
         Fac2(I+1) =  FI*Fac2(I-1)
      EndDo

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine energy_denominator(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Divides each sample of the block given by the array argument by the 
c   MP2 denominator
c       eps = epsilon(i)+epsilon(j)-epsilon(a)-epsilon(b)
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
       double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk, get_block_index
      integer stack
      
      integer comm

      integer val1(mx_array_index), val2(mx_array_index)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      array = op(c_result_array)
      nindex = array_table(c_nindex, array)
      do i = 1, nindex
         index = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg = index_table(c_current_seg,index)

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c---------------------------------------------------------------------------
c   Get array data address.
c---------------------------------------------------------------------------

      if (array_table(c_array_type,array) .eq. static_array) then
         addr = address_table(array)
         indblk = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack = array_table(c_array_stack,array)
         indblk = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif 

      if (nindex .eq. 4) then
         call eps_divide4(x(indblk), val1(1),val2(1),type(1),
     *                   val1(2),val2(2),type(2),
     *                   val1(3),val2(3),type(3),
     *                   val1(4),val2(4),type(4), 
     *                   epsilon,epsilonb)
      else if (nindex .eq. 6) then
         call eps_divide6(x(indblk), val1(1),val2(1),type(1),
     *                   val1(2),val2(2),type(2),
     *                   val1(3),val2(3),type(3),
     *                   val1(4),val2(4),type(4),
     *                   val1(5),val2(5),type(5),
     *                   val1(6),val2(6),type(6),
     *                   epsilon,epsilonb)
      else if (nindex .eq. 2) then
         if (array_table(c_array_type,array) .eq. static_array) then
            na1 = array_table(c_index_range1, array)
            na2 = array_table(c_index_range2,array)
            ni1 = array_table(c_index_range1+1,array)
            ni2 = array_table(c_index_range2+1,array)
         else
            na1 = val1(1)
            na2 = val2(1)
            ni1 = val1(2)
            ni2 = val2(2)
         endif 

         call eps_divide2(x(indblk), val1(1),val2(1),type(1),
     *                    na1, na2,
     *                    val1(2),val2(2),type(2),ni1,ni2,
     *                    epsilon,epsilonb)    
      else
         print *,'Error in energy_denominator: Result array ',
     *      'must have either 4 or 2 indices.'
         print *,'array ',array,' has ',nindex,' indices.'
         call abort_job()
      endif
      
      return
      end

      subroutine eps_divide4(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision eps, epsa, epsb, epsi, epsj
      double precision val

      do j = j1,j2
         if (jtype .eq. mobindex) then
            epsj = epsilonb(j)
         else
            epsj = epsilon(j)
         endif
      do b = b1,b2
         if (btype .eq. mobindex) then
            epsb = epsilonb(b)
         else
            epsb = epsilon(b)
         endif
      do i = i1, i2
         if (itype .eq. mobindex) then
            epsi = epsilonb(i)
         else
            epsi = epsilon(i)
         endif
      do a = a1,a2
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif
         val =  x(a,i,b,j)
         eps = epsi + epsj - epsa - epsb
         if (eps .ne. 0.0) x(a,i,b,j) = val/eps
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine eps_divide6(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, c1, c2, ctype, 
     *                      k1, k2, ktype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2,i1,i2,j1,j2,k1,k2
      integer atype, itype, btype, jtype, ctype, ktype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2,c1:c2,k1:k2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,c,i,j,k
      double precision eps, epsa, epsb, epsc, epsi, epsj, epsk
      double precision val

c--------------------------------------------------------------------
c Set index types if necassary and perform simple check. 
c--------------------------------------------------------------------

      if (atype .eq. simple_index) atype = itype 
      if (itype .eq. simple_index) itype = atype 

      if (btype .eq. simple_index) btype = jtype 
      if (jtype .eq. simple_index) jtype = btype 

      if (ctype .eq. simple_index) ctype = ktype 
      if (ktype .eq. simple_index) ktype = ctype 

      do k = k1,k2
         if (ktype .eq. mobindex) then
            epsk = epsilonb(k)
         else
            epsk = epsilon(k)
         endif
      do c = c1,c2
         if (ctype .eq. mobindex) then
            epsc = epsilonb(c)
         else
            epsc = epsilon(c)
         endif
      do j = j1,j2
         if (jtype .eq. mobindex) then
            epsj = epsilonb(j)
         else
            epsj = epsilon(j)
         endif
      do b = b1,b2
         if (btype .eq. mobindex) then
            epsb = epsilonb(b)
         else
            epsb = epsilon(b)
         endif
      do i = i1, i2
         if (itype .eq. mobindex) then
            epsi = epsilonb(i)
         else
            epsi = epsilon(i)
         endif
      do a = a1,a2
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif
         val =  x(a,i,b,j,c,k)
         eps = epsi + epsj + epsk - epsa - epsb - epsc
         if (eps .ne. 0.0) x(a,i,b,j,c,k) = val/eps
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine eps_divide2(x, a1,a2,atype,na1,na2,i1,i2,itype,
     *                       ni1,ni2,epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,i1,i2
      integer atype, itype
      integer na1, na2, ni1, ni2
      double precision x(na1:na2,ni1:ni2)

      double precision epsilon(*), epsilonb(*)

      integer a,i
      double precision eps, epsa, epsi
      double precision val

      do i = i1, i2
         if (itype .eq. mobindex) then
            epsi = epsilonb(i)
         else
            epsi = epsilon(i)
         endif
      do a = a1,a2
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif
         val =  x(a,i)
         eps = epsi - epsa
         if (eps .ne. 0.0) x(a,i) = val/eps
         if (dabs(eps) .lt. 1.0d-10) then
            if (a .ne. i) write(6,*) ' Small denominator being
     *         eliminated in energy_denominator',
     *         'a, i', a,i, 'den' ,eps, 'value', x(a,i)
            x(a,i) = 0.0d0
         endif

      enddo
      enddo

      return
      end

c This transforms a triangular block of a matrix to a square one
      subroutine mat_trans_tri_sqr(tri,sqr,trilen,sqrlen,sqroff)
#include <aces.h>
      implicit none
#include <callstack.com>
      integer trilen,sqrlen,sqroff
      M_REAL tri(trilen),sqr(sqrlen,sqrlen)

      integer i,j,itri,len

      callstack_curr='MAT_TRANS_TRI_SQR'
      len=int(sqrt(real(1+8*trilen))-1)/2
      itri=0
      do i=sqroff,sqroff+len-1
        do j=sqroff,i
          itri=itri+1
          sqr(i,j)=tri(itri)
          sqr(j,i)=tri(itri)
        end do
      end do
      return
      end

c This transforms a triangular block of a matrix to a square one
      subroutine mat_trans_tri_sqr(tri,sqr,trilen,sqrlen,sqroff)


















c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler


























cYAU - ACES3 stuff . . . we hope - #include <aces.par>




      implicit none


c This contains the global string for identifying the current subroutine
c or function (provided the programmer set it).  cf. tools/callstack.F
c BE GOOD AND RESET CURR ON EXIT!

      character*64                callstack_curr,callstack_prev
      common /callstack_curr_com/ callstack_curr,callstack_prev
      save   /callstack_curr_com/


      integer trilen,sqrlen,sqroff
      double precision tri(trilen),sqr(sqrlen,sqrlen)

      integer i,j,itri,len

      callstack_curr='MAT_TRANS_TRI_SQR'
      len=int(sqrt(real(1+8*trilen))-1)/2
      itri=0
      do i=sqroff,sqroff+len-1
        do j=sqroff,i
          itri=itri+1
          sqr(i,j)=tri(itri)
          sqr(j,i)=tri(itri)
        end do
      end do
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_actual_blocksize(array, array_block, blkndx,
     *              array_table, narray_table,
     *              index_table, nindex_table,
     *              segment_table, nsegment_table, nwblock)
c--------------------------------------------------------------------------
c   Returns the actual size of data in a given block of an array.
c   No check is made to determine whether or not the block exists.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'

      integer array, array_block, narray_table, nindex_table,
     *        nsegment_table, nwblock, blkndx
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer nind, iblk, i, val1, val2
      integer ind(mx_array_index), seg(mx_array_index)

      nind = array_table(c_nindex, array)
      iblk = blkndx
      if (iblk .lt. 0) then
         print *,'Error: get_actual_blocksize could not find array ',
     *         array,' block ',array_block
         call dump_block_ids()
         call abort_job()
      endif
 
      call get_block_indices(iblk, ind)
      call get_block_segments(iblk, seg)

      nwblock = 1
      do i = 1, nind
         call get_index_segment(ind(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
         nwblock = nwblock * (val2-val1+1)
      enddo

      return
      end

      SUBROUTINE PROJPLD(NATOM,NIRREP,IORDER,ATMASS,PLD,PLDSCR,
     &                   SYOP,IPTR,NBFATM,ILCATM,SCR)
C
C THIS ROUTINE PROJECTS THE TOTALLY SYMMETRIC COMPONENT FROM A
C "PETITE" POLARIZABILITY DERIVATIVE MATRIX USING THE SYMMETRY
C OPERATIONS OF THE FULL POINT GROUP, Ajith and John 10/1998
C 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL YESNO
      DIMENSION PLD(3*NATOM,9),SCR(84*NATOM),PLDSCR(3*NATOM,9)
      DIMENSION SYOP(9*IORDER),IPTR(NATOM,IORDER),NBFATM(NATOM)
      DIMENSION ILCATM(NATOM),ATMASS(NATOM), POLTMP1(3,3),
     &          POLTMP2(3,3)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100),IFLAGS2(500)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
C
      INQUIRE(FILE='POLDER',EXIST=YESNO)
      IF(.NOT.YESNO)RETURN
C
      IF(IFLAGS(1).GE.1)THEN
       WRITE(6,1000)
      ENDIF
      ININE=9
C
      OPEN(UNIT=61,FILE='POLDER',FORM='FORMATTED',STATUS='OLD')
      REWIND(61)
      CALL ZERO(PLD,9*3*NATOM)
      DO 10 IXYZ=1,9
       IOFF=1
       READ(61,*)
       DO 11 IATOM=1,NATOM
        IF(ATMASS(IATOM).NE.ZILCH)THEN
         READ(61,'(4F20.10)')ZJUNK,(PLD(J,IXYZ),J=IOFF,IOFF+2)
        ENDIF
        IOFF=IOFF+3
11     CONTINUE
10    CONTINUE
      CLOSE(UNIT=61,STATUS='KEEP')
C      Write(6,*) "Just after Readin"
C      Call output(PLD, 1,3*NATOM, 1,9, 3*NATOM, 9, 1)
C
C GET SOME INFORMATION FROM JOBARC
C
      CALL FILTER(PLD, 27*NATOM,1.0d-8)
      CALL GETREC(20,'JOBARC','FULLSYOP',9*IORDER*IINTFP,SYOP)
      CALL GETREC(20,'JOBARC','FULLPERM',NATOM*IORDER,IPTR)
      CALL GETREC(20,'JOBARC','ORIENTMT',ININE*IINTFP,SCR)
      CALL TRNOPS(SYOP,SCR,IORDER)
C
C FILL BASIS VECTOR.  SKIP DUMMY ATOMS.
C
      DO 5 IATOM=1,NATOM
       NBFATM(IATOM)=3
       ILCATM(IATOM)=3*(IATOM-1)+1
5     CONTINUE
C
      ZNORM=ONE/DFLOAT(IORDER)
C
C HALF-PROJECT CARTESIAN POLARIZABILITY DERIVATIVES
C
C LOOP OVER CARTESIAN DIRECTIONS
C
      IOFFS=54*NATOM+1
      CALL ZERO(PLDSCR,27*NATOM)
      DO 30 IOP=1,IORDER
         ITMP=IPTR(IOP,1)
         CALL SCOPY(27*NATOM,PLD,1,SCR,1)
         IOFFA=1
         IOFFB=27*NATOM+1
         DO 20 IBAS=1,9
            CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &                 SCR(IOFFA),SCR(IOFFB),SCR(IOFFS),1,3*NATOM,
     &                 SYOP,0)
            IOFFA=IOFFA+3*NATOM
            IOFFB=IOFFB+3*NATOM
 20      CONTINUE 
C         Write(6,*) "Half Projection"
C         Call output(SCR(27*NATOM+1), 1,9, 1,3*NATOM, 9, 3*NATOM, 1)
C
         CALL TRANSP(SCR(27*NATOM+1),SCR(54*NATOM+1),9,3*NATOM)
         CALL SCOPY(27*NATOM,SCR(54*NATOM+1),1,SCR(27*NATOM+1),1)
      
         IOFFA=27*NATOM+1
         IOFFB=1
         IPTR(IOP,1)=1
C
         DO 22 IBAS=1,3*NATOM
            CALL SCOPY(9, SCR(IOFFA), 1, POLTMP1, 1)
            DO 23 I = 1, 3
               CALL IMAGE(1,3,1,IOP,IPTR,NBFATM,ILCATM,
     &                    POLTMP1(1,I),POLTMP2(1,I),SCR(IOFFS),1,3,
     &                    SYOP,0)
 23         CONTINUE
            CALL TRANSP(POLTMP2, POLTMP1, 3, 3)
            DO 24 I = 1, 3
               CALL IMAGE(1,3,1,IOP,IPTR,NBFATM,ILCATM,
     &                    POLTMP1(1,I),POLTMP2(1,I),SCR(IOFFS),1,3,
     &                    SYOP,0)
 24         CONTINUE
            CALL SCOPY(9, POLTMP2, 1, SCR(IOFFA), 1)
            IOFFA=IOFFA+9
 22   CONTINUE
C
C         Write(6,*) "Full Projection-1"
C         Call output(SCR, 1,9, 1,3*NATOM, 9, 3*NATOM, 1)

         IPTR(IOP,1)=ITMP
         CALL SAXPY(27*NATOM,ONE,SCR,1,PLDSCR,1)
 30   CONTINUE
C
C      Write(6,*) "Full Projection-2"
C      Call output(PLDSCR, 1,9,1,3*NATOM,9,3*NATOM, 1)
C
      CALL SSCAL(27*NATOM,ZNORM,PLDSCR,1)
      CALL TRANSP(PLDSCR,SCR,3*NATOM,9)
      CALL SAXPY(27*NATOM,ONEM,SCR,1,PLD,1)
      ILOC=ISAMAX(27*NATOM,PLD,1)
      DIFMAX=PLD(ILOC,1)
      IF(IFLAGS(1).GE.1)WRITE(6,1001)DIFMAX
      IF(DIFMAX.GT.1.D-4)THEN
       WRITE(6,1002)
      ENDIF
C      CALL TRANSP(PLDSCR,PLD,3*NATOM,9)
C
C      Write(6,*) "Full Projection-3"
C      Call output(PLDSCR, 1,3*NATOM, 1,9, 3*NATOM,9,  1)

C
      OPEN(UNIT=61,FILE='POLDER',FORM='FORMATTED',STATUS='OLD')
      REWIND(61)
      ZJUNK=0.0D0
      DO 12 IXYZ=1,9
       IOFF=1
       WRITE(61,'(I5)')IXYZ
       DO 13 IATOM=1,NATOM
        IF(ATMASS(IATOM).NE.ZILCH)THEN
         WRITE(61,'(4F20.10)')ZJUNK,(PLDSCR(J,IXYZ),J=IOFF,IOFF+2)
        ENDIF
        IOFF=IOFF+3
13     CONTINUE
12    CONTINUE
      CLOSE(UNIT=61,STATUS='KEEP')
C
      RETURN
1000  FORMAT(T3,'@PROJDLD-I, Projecting polarizability derivatives ',
     &          'on to totally symmetric subspace.')
1001  FORMAT(T3,'Largest difference between matrix elements of ',
     &          'symmetrized',/,T3,'and unsymmetrized PLD : ',F15.10,
     &          '.')
1002  FORMAT(T3,'@PROJPLD-W, The input PLD was not totally symmetric.')
      END

c The original ator (now a more complete str2dbl_old) forgave all kinds
c of spaces and tabs in the input string, but it did not allow fractional
c exponents.  str2dbl now ignores all whitespace and simply uses the
c internal unit numbers of Fortran.  It might be slower than str2dbl_old,
c but the parsing logic for all valid reals with embedded whitespace is
c just crazy.

      subroutine str2dbl(str,val,err)
      implicit none
      character*(*) str
      double precision val
      integer err
      integer i, j
      character*132 sz
      character*1 achar, spc, tab
      spc = achar(32)
      tab = achar(9)
      sz = ' '
      j = 1
      do i = 1, len(str)
         if (str(i:i).ne.spc.and.str(i:i).ne.tab.and.j.le.132) then
            sz(j:j) = str(i:i)
            j = j+1
         end if
      end do
      read(sz,fmt=*,err=10,iostat=err) val
 10   continue
c      print *, '@STR2DBL: "',str,'" = ',val
      return
      end

c This routine takes a string, which should contain a single valid float,
c and returns the value of that float. If an error occurs, err is set to:
c     1   if the string is empty
c     2   string contains a sign but no number
c     3   integer part contains non-digit characters (masked by err=5)
c     4   decimal part contains non-digit characters (masked by err=5)
c     5   exponent part doesn't start with 'E' or 'D'
c     6   exponent part empty
c     7   exponent part contains non-digit characters
c     8   a decimal point with no integer or decimal part entered

c For those keen to regular expressions, valid floats are of the form:
c   '^ *[+-]? *([0-9]+[.]?|[0-9]*\.[0-9]+) *([DdEe] *[0-9]+)? *$'

      subroutine str2dbl_old(str,val,err)
      implicit none
      character*(*) str
      double precision val
      integer err

      integer iachar, strlen, i, zref, ipm, j, k
      integer ii, id, il, ie
      character*1 achar, spc, tab, c

      zref = iachar('0')
      spc = achar(32)
      tab = achar(9)

c   o Skip trailing whitespace.
      i = len(str)
      do while ((str(i:i).eq.spc.or.str(i:i).eq.tab)
     &          .and.i.gt.0)
         i = i-1
      end do
      strlen = i

c   o Skip leading whitespace.
      i = 1
      do while ((str(i:i).eq.spc.or.str(i:i).eq.tab)
     &          .and.i.le.strlen)
         i = i+1
      end do
      if (i.gt.strlen) then
         err = 1
         return
      end if
      c = str(strlen:strlen)
      if (c.eq.'D'.or.c.eq.'d'.or.c.eq.'E'.or.c.eq.'e') then
         err = 6
         return
      end if

c   o Register sign and skip whitespace.
      ipm = 1
      if (str(i:i).eq.'-'.or.str(i:i).eq.'+') then
         if (str(i:i).eq.'-') ipm = -1
         i = i+1
         do while ((str(i:i).eq.spc.or.str(i:i).eq.tab)
     &             .and.i.le.strlen)
            i = i+1
         end do
         if (i.gt.strlen) then
            err = 2
            return
         end if
      end if
      c = str(i:i)
      if (c.eq.'D'.or.c.eq.'d'.or.c.eq.'E'.or.c.eq.'e') then
         err = 8
         return
      end if

c   o Read the integer.
      ii = 0
      j = i
      k = iachar(str(j:j))-zref
      do while (0.le.k.and.k.le.9.and.j.le.strlen)
         j = j+1
         k = iachar(str(j:j))-zref
      end do
      if (j.ne.i) call str2int(str(i:j-1),ii,err)
      i = j

c   o Read the decimal up to the exponent.
      id = 0
      il = 0
      if (str(i:i).eq.'.') then
         i = i+1
         j = i
         k = iachar(str(j:j))-zref
         do while (0.le.k.and.k.le.9.and.j.le.strlen)
            j = j+1
            k = iachar(str(j:j))-zref
         end do
         if (j.ne.i) then
            call str2int(str(i:j-1),id,err)
            il = j-i
         end if
         do while ((str(j:j).eq.spc.or.str(j:j).eq.tab)
     &             .and.j.le.strlen)
            j = j+1
         end do
         i = j
      end if

c   o Read the exponent.
      ie = 0
      if (str(i:i).eq.'D'.or.str(i:i).eq.'d'.or.
     &    str(i:i).eq.'E'.or.str(i:i).eq.'e'    ) then
         i = i+1
         if (i.le.strlen) then
            call str2int(str(i:strlen),ie,err)
            if (err.ne.0) then
               err = 7
               return
            end if
         end if
         i = strlen+1
      end if

      if (i.le.strlen) then
         err = 5
         return
      end if

      val = ii*1.d0 + id*10.d0**(-il)
      val = sign(val*10.d0**(ie),dble(ipm))

c      print *, '@STR2DBL: "',str(1:strlen),'" = ',val

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine aces_to_erd(nfps, iangular, nshells, ispherical,
     *                       erd_index, scalars) 
c-----------------------------------------------------------------------------
c   Using the shell angular momentum and basis function information, this
c   subroutine calculates an array which maps the ACES integral order to 
c   the ERD integral order.  This array may be used to re-order a block 
c   of integrals calculated by the ERD package into a format corresponding
c   to the ACES (VMOL-based) integrals.
c
c   Arguments:
c      nfps		Number of basis functions per shell.
c      iangular		Shell type (based on angular momentum) per shell.
c			(i. e. an S shell = 0, P = 1, etc.)
c      nshells		Number of shells contained in nfps and iangular.
c      ispherical       1 = spherical coordinates, 0 = Cartesian
c      erd_index	An array (output) of nbasis indices.  The ith
c			value of erd_index is the index in the ERD-based 
c        		system corresponding to index "i" in the ACES-based
c			system.
c      scalars          An array (output) of scale factors to adjust the
c                       ERD integrals to match VMOL integrals.
c-----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'saved_data.h'
c     include 'int_gen_parms.h'

      integer n, nshells, ispherical
      integer nfps(nshells), iangular(nshells)
      integer erd_index(*)
      double precision scalars(*)

      integer istart, iend, ishell
      integer i, j, ierd
      integer nctr, nsh_coords
  
      integer smap(1)   
      integer pmap(3)
      integer dmap(5)
      integer fmap(7)
      integer gmap(9)
      integer hmap(11)
      integer imap(13)

      double precision d_scale(5)
      double precision f_scale(7)
      double precision g_scale(9)
      double precision h_scale(11)
      double precision i_scale(13)
      double precision xscale

      double precision x_scale(0:6,1:28) 

      common /flags/ iflags
      integer iflags(100)

      save smap, pmap, dmap, fmap, gmap, hmap, imap
      save d_scale, f_scale, g_scale, h_scale, i_scale

      data smap/1/
      data pmap/1,2,3/
      data dmap/4,3,1,5,2/
      data fmap/4,7,1,3,2,5,6/
      data gmap/4,8,6,3,1,9,2,5,7/
      data hmap/10,7,4,3,1,9,2,11,8,5,6/
      data imap/1,3,4,8,6,13,10,12,2,11,9,5,7/
    
      if (first_aces_to_erd) then
         first_aces_to_erd = .false.
         d_scale(1) = 2.d0 * dsqrt(3.d0)
         d_scale(2) = 1.d0
         d_scale(3) = 1.d0
         d_scale(4) = 2.d0
         d_scale(5) = 1.d0

         f_scale(1) = 2.d0 * dsqrt(10.d0)
         f_scale(2) = 2.d0 * dsqrt(10.d0)
         f_scale(3) = 2.d0 * dsqrt(15.d0)
         f_scale(4) = 2.d0 * dsqrt(6.d0)
         f_scale(5) = 1.d0
         f_scale(6) = 2.d0 * dsqrt(6.d0)
         f_scale(7) = 2.d0  

         g_scale(1) = 8.d0 * dsqrt(105.d0)
         g_scale(2) = 2.d0 * dsqrt(21.d0)
         g_scale(3) = 2.d0 * dsqrt(42.d0)
         g_scale(4) = 8.d0 * dsqrt(3.d0)
         g_scale(5) = 2.d0 * dsqrt(6.d0)
         g_scale(6) = 4.d0 * dsqrt(21.d0)
         g_scale(7) = 2.d0 * dsqrt(3.d0)
         g_scale(8) = 2.d0 * dsqrt(6.d0)
         g_scale(9) = 2.d0 * dsqrt(42.d0)

         h_scale(1) = 24.d0 * dsqrt(7.d0)
         h_scale(2) = 24.d0 * dsqrt(7.d0)
         h_scale(3) = 12.d0
         h_scale(4) = 24.d0 * dsqrt(6.d0)
         h_scale(5) = 2.d0 * dsqrt(3.d0)
         h_scale(6) = 8.d0 * dsqrt(30.d0)
         h_scale(7) = 8.d0 * dsqrt(3.d0)
         h_scale(8) = 24.d0 * dsqrt(6.d0)
         h_scale(9) = 24.d0 * dsqrt(105.d0)
         h_scale(10) = 8.d0 * dsqrt(30.d0)
         h_scale(11) = 6.d0

         i_scale(1) = 48.d0 * dsqrt(10.d0)
         i_scale(2) = 24.d0 * dsqrt(22.d0)
         i_scale(3) = 8.d0 * dsqrt(30.d0)
         i_scale(4) = 16.d0 * dsqrt(165.d0)
         i_scale(5) = 8.d0 * dsqrt(30.d0)
         i_scale(6) = 48.d0 * dsqrt(22.d0)
         i_scale(7) = 48.d0 * dsqrt(10.d0)
         i_scale(8) = 24.d0 * dsqrt(22.d0)
         i_scale(9) = 16.d0 * dsqrt(165.d0)
         i_scale(10) = 48.d0 * dsqrt(1155.d0)
         i_scale(11) = 24.d0 * dsqrt(22.d0)
         i_scale(12) = 48.d0 * dsqrt(55.d0)
         i_scale(13) = 48.d0 * dsqrt(55.d0)
      endif

      istart = 1 
      ierd   = 1

c     write(6,*) ' IFLAGS 71 =', iflags(71) 
c     go to 2000 
      if (iflags(71) .eq. 1) go to 1000 
      if (ispherical .ne. 1) go to 1000

c--------------------------------------------------------------------------
c   Spherical coordinates.
c--------------------------------------------------------------------------

      do ishell = 1, nshells
         iend = istart + nfps(ishell) - 1

c---------------------------------------------------------------------------
c   Angular momentum of the shell determines the number of shell components.
c---------------------------------------------------------------------------

         nsh_coords = 2 * iangular(ishell) + 1
         nctr      = nfps(ishell) / nsh_coords
         if (nsh_coords .eq. 1) then 
            do i = istart, iend
               erd_index(ierd) = ierd
               scalars(ierd)   = 1.d0
               ierd = ierd + 1
            enddo
         else

c----------------------------------------------------------------------------
c   Calculate indices for all elements of the current shell.
c----------------------------------------------------------------------------
         
            if (iangular(ishell) .eq. 1) then    ! p shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (pmap(j)-1)*nctr + i - 1
                     scalars(ierd) = 1.d0
                     ierd = ierd + 1
                  enddo
               enddo
            else if (iangular(ishell) .eq. 2) then    ! d shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (dmap(j)-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do j = 1, nsh_coords
                  do i = 1, nctr
                     scalars(ierd) = d_scale(j)
                     ierd = ierd + 1
                  enddo
               enddo
            else if (iangular(ishell) .eq. 3) then    ! f shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (fmap(j)-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do j = 1, nsh_coords
                  do i = 1, nctr
                     scalars(ierd) = f_scale(j)
                     ierd = ierd + 1
                  enddo
               enddo
            else if (iangular(ishell) .eq. 4) then   ! g shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (gmap(j)-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do j = 1, nsh_coords
                  do i = 1, nctr
                     scalars(ierd) = g_scale(j)
                     ierd = ierd + 1
                  enddo
               enddo
            else if (iangular(ishell) .eq. 5) then   ! h shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (hmap(j)-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do j = 1, nsh_coords
                  do i = 1, nctr
                     scalars(ierd) = h_scale(j)
                     ierd = ierd + 1
                  enddo
               enddo
            else if (iangular(ishell) .eq. 6) then   ! i shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (imap(j)-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do j = 1, nsh_coords
                  do i = 1, nctr
                     scalars(ierd) = i_scale(j)
                     ierd = ierd + 1
                  enddo
               enddo
            else
               print *,'Cannot have shell types > i.'
               call abort_job()
            endif 
         endif

         istart = istart + nfps(ishell)
      enddo
      return

1000  continue

c---------------------------------------------------------------------------
c   Cartesian coordinates.
c---------------------------------------------------------------------------

c --- s-functions --- 
      x_scale(0,1) = 1.0 
c --- p-functions --- 
      do i = 1, 3 
         x_scale(1,i) = 1.0 
      enddo 

c --- d-functions --- 
      x_scale(2,1) = 1.0*dsqrt(3.0d0)  
      x_scale(2,2) = 1.0 
      x_scale(2,3) = 1.0 
      x_scale(2,4) = 1.0*dsqrt(3.0d0)  
      x_scale(2,5) = 1.0 
      x_scale(2,6) = 1.0*dsqrt(3.0d0)  

c --- f-functions --- 
      x_scale(3, 1) = 1.0*dsqrt(15.0d0) 
      x_scale(3, 2) = 1.0*dsqrt(3.0d0) 
      x_scale(3, 3) = 1.0*dsqrt(3.0d0) 
      x_scale(3, 4) = 1.0*dsqrt(3.0d0) 
      x_scale(3, 5) = 1.0*dsqrt(1.0d0) 
      x_scale(3, 6) = 1.0*dsqrt(3.0d0) 
      x_scale(3, 7) = 1.0*dsqrt(15.0d0) 
      x_scale(3, 8) = 1.0*dsqrt(3.0d0) 
      x_scale(3, 9) = 1.0*dsqrt(3.0d0) 
      x_scale(3, 10) = 1.0*dsqrt(15.0d0)

c --- g-functions --- 
      x_scale(4, 1) = 1.0*dsqrt(105.0d0) 
      x_scale(4, 2) = 1.0*dsqrt(15.0d0) 
      x_scale(4, 3) = 1.0*dsqrt(15.0d0) 
      x_scale(4, 4) = 1.0*dsqrt(9.0d0) 
      x_scale(4, 5) = 1.0*dsqrt(3.0d0) 
      x_scale(4, 6) = 1.0*dsqrt(9.0d0) 
      x_scale(4, 7) = 1.0*dsqrt(15.0d0) 
      x_scale(4, 8) = 1.0*dsqrt(8.0d0) 
      x_scale(4, 9) = 1.0*dsqrt(3.0d0) 
      x_scale(4, 10) = 1.0*dsqrt(15.0d0) 
      x_scale(4, 11) = 1.0*dsqrt(105.0d0) 
      x_scale(4, 12) = 1.0*sqrt(15.0d0) 
      x_scale(4, 13) = 1.0*dsqrt(9.0d0) 
      x_scale(4, 14) = 1.0*dsqrt(15.0d0) 
      x_scale(4, 15) = 1.0*dsqrt(105.0d0) 

c --- h-functions --- 
      x_scale(5, 1) = 1.0*dsqrt(945.0d0) 
      x_scale(5, 2) = 1.0*dsqrt(105.0d0) 
      x_scale(5, 3) = 1.0*dsqrt(105.0d0) 
      x_scale(5, 4) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 5) = 1.0*dsqrt(15.0d0) 
      x_scale(5, 6) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 7) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 8) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 9) = 1.0*dsqrt(9.0d0) 
      x_scale(5, 10) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 11) = 1.0*dsqrt(105.0d0) 
      x_scale(5, 12) = 1.0*dsqrt(15.0d0) 
      x_scale(5, 13) = 1.0*dsqrt(9.0d0) 
      x_scale(5, 14) = 1.0*dsqrt(15.0d0) 
      x_scale(5, 15) = 1.0*dsqrt(105.0d0) 
      x_scale(5, 16) = 1.0*dsqrt(945.0d0) 
      x_scale(5, 17) = 1.0*dsqrt(105.0d0) 
      x_scale(5, 18) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 19) = 1.0*dsqrt(45.0d0) 
      x_scale(5, 20) = 1.0*dsqrt(105.0d0) 
      x_scale(5, 21) = 1.0*dsqrt(945.0d0) 

c --- i-functions --- 
      x_scale(6, 1) = 1.0*dsqrt(10395.0d0) 
      x_scale(6, 2) = 1.0*dsqrt(945.0d0) 
      x_scale(6, 3) = 1.0*dsqrt(945.0d0) 
      x_scale(6, 4) = 1.0*dsqrt(315.0d0) 
      x_scale(6, 5) = 1.0*dsqrt(105.0d0) 
      x_scale(6, 6) = 1.0*dsqrt(315.0d0) 
      x_scale(6, 7) = 1.0*dsqrt(225.0d0) 
      x_scale(6, 8) = 1.0*dsqrt(45.0d0) 
      x_scale(6, 9) = 1.0*dsqrt(45.0d0) 
      x_scale(6, 10) = 1.0*dsqrt(225.0d0) 
      x_scale(6, 11) = 1.0*dsqrt(315.0d0) 
      x_scale(6, 12) = 1.0*dsqrt(45.0d0) 
      x_scale(6, 13) = 1.0*dsqrt(27.0d0) 
      x_scale(6, 14) = 1.0*dsqrt(45.0d0) 
      x_scale(6, 15) = 1.0*dsqrt(315.0d0) 
      x_scale(6, 16) = 1.0*dsqrt(945.0d0) 
      x_scale(6, 17) = 1.0*dsqrt(105.0d0) 
      x_scale(6, 18) = 1.0*dsqrt(45.0d0) 
      x_scale(6, 19) = 1.0*dsqrt(45.0d0) 
      x_scale(6, 20) = 1.0*dsqrt(105.0d0) 
      x_scale(6, 21) = 1.0*dsqrt(945.0d0) 
      x_scale(6, 22) = 1.0*dsqrt(10395.0d0) 
      x_scale(6, 23) = 1.0*dsqrt(945.0d0) 
      x_scale(6, 24) = 1.0*dsqrt(315.0d0) 
      x_scale(6, 25) = 1.0*sqrt(225.0d0) 
      x_scale(6, 26) = 1.0*dsqrt(315.0d0) 
      x_scale(6, 27) = 1.0*dsqrt(945.0d0) 
      x_scale(6, 28) = 1.0*dsqrt(10395.0d0) 


      do ishell = 1, nshells
         iend = istart + nfps(ishell) - 1

c---------------------------------------------------------------------------
c   Angular momentum of the shell determines the number of shell components.
c---------------------------------------------------------------------------

         nsh_coords = (iangular(ishell)+1)*(iangular(ishell)+2)/2
         nctr      = nfps(ishell) / nsh_coords

         if (iangular(ishell) .lt. 2) then 

         do i = 1, nctr
         do j = 1, nsh_coords
            erd_index(ierd) = istart + (j-1)*nctr + i - 1
            scalars(ierd)   = 1.d0 
            ierd = ierd + 1
         enddo
         enddo

         endif 

         if (iangular(ishell) .ge. 2) then 

         do i = 1, nctr
         do j = 1, nsh_coords
c           xscale = 1.0 
c           if (j .eq. 1 .or. j .eq. 4 .or. j .eq. 6) 
c    #          xscale=1.0/dsqrt(3.0d0) 
            erd_index(ierd) = istart + (j-1)*nctr + i - 1
            scalars(ierd)   = x_scale(iangular(ishell),j)  
            ierd = ierd + 1
         enddo
         enddo

         endif 

c        if (iangular(ishell) .gt. 2) then 

c        do i = 1, nctr
c        do j = 1, nsh_coords
c           xscale = 1.0 
c           erd_index(ierd) = ierd  
c           scalars(ierd)   = 1.d0   
c           ierd = ierd + 1
c        enddo
c        enddo

c        endif 

        istart = istart + nfps(ishell)
      enddo

      return

2000  continue

c---------------------------------------------------------------------------
c   Do not allow any scaling OR reordering  
c   NOT used currently ??? 
c---------------------------------------------------------------------------
CSSS
CSSS     do ishell = 1, nshells
CSSS         if (iangular(ishell) .eq. 0) xscale=1.0    ! s shell
CSSS         if (iangular(ishell) .eq. 1) xscale=1.0    ! p shell
CSSS         if (iangular(ishell) .eq. 2) xscale=1.0/dsqrt(3.0d0) ! d shell
CSSS         if (iangular(ishell) .eq. 3) xscale=1.0/dsqrt(4.0d0) ! f shell
CSSS
c---------------------------------------------------------------------------
c   Angular momentum of the shell determines the number of shell components.
c---------------------------------------------------------------------------
CSSS
CSSS         nsh_coords = (iangular(ishell)+1)*(iangular(ishell)+2)/2
CSSS         nctr      = nfps(ishell) / nsh_coords

CSSS         do i = 1, nctr
CSSS         do j = 1, nsh_coords
CSSS            erd_index(ierd) = ierd  
CSSS            scalars(ierd)   = xscale  
CSSS            write(6,*) ' SCALARS :', ierd, scalars(ierd) 
CSSS            ierd = ierd + 1
CSSS         enddo
CSSS         enddo
CSSS
CSSS      enddo

      return
      end

      SUBROUTINE SWPORD(NLIST1,NLIST2,VECIN,VECOUT,NSIZ)
C 
C SUBROUTINE SWAPS ORDERING OF COORDINATES IN VECIN DEPENDING ON
C  POINTER LISTS NLIST1 AND NLIST2.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION NLIST1(NSIZ),NLIST2(NSIZ),VECIN(3*NSIZ),VECOUT(3*NSIZ)
      CALL ZERO(VECOUT,3*NSIZ)
      DO 10 I=1,NSIZ
       IP1=3*NLIST1(I)-2
       IP2=3*NLIST2(I)-2
       CALL VADD(VECOUT(IP1),VECOUT(IP1),VECIN(IP2),3,1.D0)
 10   CONTINUE
      RETURN
      END

c This routine supplies the integer function 'iachar' if the Fortran
c compiler does not contain it as an intrinsic.

c Recall: iachar returns the decimal number of an ASCII character while
c         ichar returns the internal decimal of a character representation.

#ifdef _ICHAR_IS_IACHAR
      integer function iachar(cz)
      implicit none
      character*1 cz
      integer ichar
      external ichar
      iachar = ichar(cz)
      return
      end
#else
#include "return.f"
#endif /* _ICHAR_IS_IACHAR */

c This routine supplies the integer function 'iachar' if the Fortran
c compiler does not contain it as an intrinsic.

c Recall: iachar returns the decimal number of an ASCII character while
c         ichar returns the internal decimal of a character representation.


c This routine does NOTHING. Other files will include it so rigid
c Fortran compilers have something to do when a cpp define removes all
c of the compilable code in the .f file.

      subroutine to_combat_compiler_stupidity()
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine energy_abdenominator(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c   Divides each sample of the block given by the array argument by the 
c       eps = f_alpha(i)+f_beta(i)-f_alpha(a)-f_beta(a)
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      if (nindex .eq. 2) then
         call epsab_divide2(x, bval(1),eval(1),type(1),
     *                    bdim(1), edim(1),
     *                    bval(2),eval(2),type(2),
     *                    bdim(2), edim(2),
     *                    epsilon,epsilonb)    
      else
         print *,'Error in energy_abdenominator: Result array ',
     *      'must have 2 indices.'
         print *,'array has ',nindex,' indices.'
         call abort_job()
      endif
      
      return
      end

      subroutine epsab_divide2(x, a1,a2,atype,na1,na2,i1,i2,itype,
     *                       ni1,ni2,epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,i1,i2
      integer atype, itype
      integer na1, na2, ni1, ni2
      double precision x(na1:na2,ni1:ni2)

      double precision epsilon(*), epsilonb(*)

      integer a,i
      double precision eps, epsa, epsi
      double precision val

      do i = i1, i2
            epsi = epsilon(i) + epsilonb(i)
      do a = a1,a2
            epsa = epsilon(a) + epsilonb(a)
         val =  x(a,i)
         eps = epsi - epsa
         if (eps .ne. 0.0) x(a,i) = val/eps

         if (dabs(eps) .lt. 1.0d-10) then 
            if (a .ne. i) write(6,*) ' Small denominator being
     *         eliminated in energy_denominator', 
     *         'a, i', a,i, 'den' ,eps, 'value', x(a,i) 
            x(a,i) = 0.0d0  
c           x(a,i) = val   
         endif 
c
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ASIGN_CNTVTES(CARTCOORD, BNDLENTHS, IATOMICNMBER, 
     &                         SMOFCOVRADI, NCONPRCNTR, IBNDTO,
     &                         MAXCNTVS, NRATMS, MARK_FRAGMENTS, 
     &                         LENGTH_FRAGMENTS,FRAGSCR,
     &                         BLNGT_IJFRGS)
C
C We need to decide some sort of a connectivity pattern if want to do
C Cartesian optimizations based on RIC. I prefer that the user specify the 
C connectivities, but Gaussian crowd certainly going to cry!
C So Let's use this covalent radii scheme Dr. Fau is talking about. 
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      DOUBLE PRECISION PNTSEV
      LOGICAL FLAG, NOPClFPS, FRAGMENT, CONN_FILE_EXISTS, REGULAR_BND
      INTEGER AATOM, BATOM, VALENCY, iND, IDUM,
     &        JDUM, CONNECTED_ATOMS
C
C Watson
C
      INTEGER  FRAGSCR (1:NRATMS*NRATMS)
      INTEGER  IPRINT,IERR,MAXFRAG,NFRAG_TMP
C
C Watson
C
CSSS    NEIGHBORS(NRATMS, NRATMS)
C
      DIMENSION CARTCOORD(3*NRATMS), BNDLENTHS(NRATMS, NRATMS), 
     &          IATOMICNMBER(NRATMS), SMOFCOVRADI(NRATMS, NRATMS),
     &          IBNDTO(NRATMS, NRATMS), NCONPRCNTR(NRATMS),
     &          VALENCY(86), MARK_FRAGMENTS(NRATMS, NRATMS), 
     &          LENGTH_FRAGMENTS(NRATMS),BLNGT_IJFRGS(NRATMS)
C      
      DIMENSION VRADII(17)
      DATA VRADII /1.20D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0, 1.7D0,
     &             1.55D0, 1.52D0, 1.35D0, 0.0D0, 0.0D0, 0.0D0,
     &             0.0D0, 0.0D0, 1.90D0, 1.85D0, 1.80D0/
      DATA VALENCY /1, 0, 1, 2, 3, 4, 4, 2, 1, 0, 1, 2, 6, 6, 5,
     &              6, 1, 0, 1, 2, 6, 6, 6, 8, 6, 6, 6, 6, 6, 3,
     &              4, 3, 2, 1, 0, 1, 2, 6, 6, 6, 6, 6, 6, 6, 6,
     &              6, 6, 3, 4, 3, 2, 1, 0, 1, 2, 12, 6, 6, 6, 
     &              6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
     &              6, 6, 6, 6, 6, 3, 4, 3, 2, 1, 0, 1/
C
      DATA PNTSEV /0.71D0/, ZZERO /0.D0/, HALF/0.50D0/
      DATA IONE /1/, JZERO /0/
      DATA ZIONE /1.D0/
      DATA AMTOBOHR /1.8897265/
C
C
C Calculate internuclear distances; The calculated distances are 
C in Angstroms Call Zero sets up a 0 matrix for bond lenghts
C
      CALL ZERO(BNDLENTHS, NRATMS*NRATMS)
      CALL IZERO(IBNDTO, NRATMS*NRATMS)
C      
      INDEX1 = 1
      INDEX2 = 4
      IUNIT  = 199
C
      INQUIRE(FILE='CONNECT',EXIST=CONN_FILE_EXISTS)
      IF (CONN_FILE_EXISTS) THEN
          OPEN(UNIT=IUNIT,FILE='CONNECT',FORM='FORMATTED',
     &         STATUS='OLD')
#ifdef _DEBUG_LVL0
          Write(6,*) "Entering Read Connectivities"
#endif 
          CALL READ_CNTVTES(IBNDTO, IUNIT, NRATMS)
          CLOSE (IUNIT)
          RETURN
      ENDIF
C
      DO 10 IBNDS = 2, NRATMS
         DO 20 JBNDS = 1, IBNDS - 1
            BNDLENTHS(JBNDS, IBNDS) = DIST(CARTCOORD(INDEX1),
     &                                CARTCOORD(INDEX2))
            BNDLENTHS(IBNDS, JBNDS) = BNDLENTHS(JBNDS, IBNDS)
            INDEX1 = INDEX1 + 3 
 20      CONTINUE
         INDEX2 = INDEX2 + 3 
         INDEX1 = IONE
 10   CONTINUE
C
C Now calculate the scaled sum of the covalent radii for each unique
C pair of atoms
C     
cSSS CALL GETREC(20, 'JOBARC', 'ATOMCHRG', NRATMS, IATOMICNMBER)
C      
      CALL GETCOVLRADI(IATOMICNMBER, SMOFCOVRADI, NRATMS)
C      
C Now assign preliminary connectivites based on simple fact that
C length between two centers is less than or equal to 1.3 times sum of the 
C covalent radii of the centers. If they are connected, assign integer
C 1 for that pair, if not leave it as 0.
C This simple criteria is used by Helgaker and many others to assign 
C connectivities. 
C
      DO IBNDS = 2, NRATMS
         DO JBNDS = 1, (IBNDS - 1)
            IF (IBNDTO(JBNDS,IBNDS).EQ.JZERO.AND.
     &          BNDLENTHS(JBNDS,IBNDS).LE.SMOFCOVRADI(JBNDS,IBNDS)
     &         ) THEN
                IBNDTO(JBNDS,IBNDS) = IONE
#ifdef _DEBUG_LVLM1
            Print*, "Bonded atoms, bond-length, sum of c-radii"
            Print*,jbnds, ibnds, BNDLENTHS(JBNDS, IBNDS)*0.529177249d0, 
     &             SMOFCOVRADI(JBNDS,IBNDS)*0.529177249d0, 
     &             SMOFCOVRADI(IBNDS,JBNDS)*0.529177249d0
#endif
            END IF
         END DO
      END DO
C
C These condition pretty much take care of regular bonds. Now we
C need to consider isolated fragments and connect them.
C Identifying isolated fragments is a graph theory problem and I don't
C claim to be an expert on graph theory. There are efficient algorithms 
C and specialized programs to do this. The following is very simple
C and hopefully will work 90% of the time without heavy penalty. 
C 
C First, count the total number of connections for each atom and
C store the index of the other atoms that are connected to the
C given atom (in NCONPRCNTR, ICONNECTO arrays respectively). 
C Reorder these two arrays in descending order with respect to the
C number of connections.  
C Take a pair of atoms (starting with maximum connectivities) 
C and check whether they are connected. If they are not
C connected then search outwards (at predefined maxlevels
C representing a maximum possible chain length, for our
C cases I am thinking of 5). The searching is done as follows;
C Take the number of connections for the chosen pair and test whether at
C least one of them is connected; if so, then the choosen pair is not
C part of a disconnected fragment. If all of the atoms are not
C connected, then we look at the next level. When we consider all pairs
C and the FRAGMENT is still true then we have to mark that pair as a
C part of an isolated fragment. 
C 
      CALL IZERO(NCONPRCNTR, NRATMS)
      DO IBNDS = 1, NRATMS
         DO JBNDS = 1, NRATMS
            IF (IBNDTO(JBNDS, IBNDS) .NE. JZERO .OR.
     &          IBNDTO(IBNDS, JBNDS) .NE. JZERO) THEN
                NCONPRCNTR(IBNDS) = NCONPRCNTR(IBNDS) + 1
                IF (NCONPRCNTR(IBNDS) .GT. MAXCNTVS) THEN
                    WRITE(6, 9) MAXCNTVS
                    CALL ERREX
                ENDIF
            ENDIF 
         ENDDO 
      ENDDO
  9   FORMAT(T4, 'The maximum no. of connectvities allowed for',
     &       'for a center ', I2, ' exceeded')
C
#ifdef _DEBUG_LVLM1
      Print*, "The number of connectivities per center"
      Print*,  (NCONPRCNTR(I), I=1, NRATMS)
#endif 
C
C Lets identify hydrogen bonds. H-bonds are assigned if H-X distance
C is within the sum of the covalent radii of H and X(=N, O, P, Cl, F,
C P, S) and 0.9 times the Van der Walls radii and Y...H-X angle
C is greater than 90 degrees.
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Print*, "The connectivity assignments before H-bond block"
      Print*, ((ibndto(j, i), j=1, nratms), I=1, nratms)     
      Write(6,*)
#endif
C
      NHBONDS = 0
      CALL DSCAL(NRATMS*NRATMS, 1.0D0/1.3D0, SMOFCOVRADI, 1)
      DO IBNDS = 1, NRATMS
         IF (IATOMICNMBER(IBNDS) .EQ. 1) THEN
            DO JBNDS = 1, (IBNDS - 1)
               NOPClFPS = ((IATOMICNMBER(JBNDS).EQ. 7)  .OR.
     &                    (IATOMICNMBER(JBNDS) .EQ. 8)  .OR.
     &                    (IATOMICNMBER(JBNDS) .EQ. 9)  .OR.
     &                    (IATOMICNMBER(JBNDS) .EQ. 10) .OR.
     &                    (IATOMICNMBER(JBNDS) .EQ. 15) .OR.
     &                    (IATOMICNMBER(JBNDS) .EQ. 16) .OR.
     &                    (IATOMICNMBER(JBNDS) .EQ. 17))

C
C The check for regular bond is required in order to avoid treating
C previoulsly assigned h-bond connections to assign new hydrogren
C bonds. 02/22, Ajith Perera.
C
               DIST_IJ =  BNDLENTHS(JBNDS, IBNDS)
               COVR_IJ = SMOFCOVRADI(JBNDS,IBNDS)*1.30D0
               IF (DIST_IJ .LE. COVR_IJ) THEN
                    REGULAR_BND = .TRUE.
               ELSE
                    REGULAR_BND = .FALSE.
               ENDIF
C
               IF (NOPClFPS.AND.IBNDTO(JBNDS,IBNDS).NE.JZERO) THEN
                  DO KBNDS = 1, NRATMS
                     IF (((IATOMICNMBER(KBNDS) .EQ. 7)  .OR.
     &                   (IATOMICNMBER(KBNDS)  .EQ. 8)  .OR.
     &                   (IATOMICNMBER(KBNDS)  .EQ. 9)  .OR.
     &                   (IATOMICNMBER(KBNDS)  .EQ. 10) .OR.
     &                   (IATOMICNMBER(KBNDS)  .EQ. 15) .OR.
     &                   (IATOMICNMBER(KBNDS)  .EQ. 16) .OR.
     &                   (IATOMICNMBER(KBNDS)  .EQ. 17)) .AND.
     &                   ((KBNDS .NE. IBNDS) .AND. (KBNDS .NE.
     &                    JBNDS))) THEN
                        IF (IBNDS .GT. KBNDS) THEN
                           DIST_HY     = BNDLENTHS(KBNDS, IBNDS)
                           SMOFCOVLRAD = SMOFCOVRADI(KBNDS,IBNDS)
                        ELSE
                           DIST_HY = BNDLENTHS(IBNDS, KBNDS)
                           SMOFCOVLRAD = SMOFCOVRADI(IBNDS,KBNDS)
                        END IF
                        CALL CMP_ANGLE(JBNDS, IBNDS, KBNDS,
     &                                 CARTCOORD, ANG_XHY, NRATMS)
                        KATOM = IATOMICNMBER(KBNDS)
                        IATOM = IATOMICNMBER(IBNDS)
                        SMOFVRADII = (VRADII(KATOM)+VRADII(IATOM))
     &                               *0.9D0
                        SMOFVRADII = AMTOBOHR*SMOFVRADII
#ifdef _DEBUG_LVLM1
                  Write(6,"(a)") "Critical parameters for H-bonds"
                  Write(6,"(4(1x,F10.5))") DIST_HY, ANG_XHY , 
     &                          SMOFVRADII, SMOFCOVLRAD
#endif
                        IF ((DIST_HY .GT. SMOFCOVLRAD).AND.
     &                      (DIST_HY .LT. SMOFVRADII).AND.
     &                      (ANG_XHY .GT. 90.0D0)) THEN
                           NHBONDS = NHBONDS + 1
                           IF (IBNDS .GT. KBNDS) THEN
                              IBNDTO(KBNDS, IBNDS) = IONE
                           ELSE
                              IBNDTO(IBNDS, KBNDS) = IONE
                           END IF
                        END IF
                     END IF
                  END DO
               END IF
            END DO
         END IF
      END DO
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,"(a,I4)") "The no. of H bonds", NHBONDS
#endif
C
C#ifdef _NOSKIP
C
C
CSSS      do iatoms=2,nratms
CSSS         do jatoms=1,(iatoms-1)
CSSS            if (ibndto(jatoms,iatoms).eq.1) ibndto(iatoms,jatoms)=1
CSSS
CSSS      call identfy_fragments(nratms,ibndto,connected_atoms,nfrags,
CSSS     &                       length_fragments,mark_fragments)
CSSS          enddo
CSSS      enddo
C
C Watson
C
#ifdef _DEBUG_LVL0
      iprint = 50
#else
      iprint =0
#endif
      
      CALL  FRAG__INIT (nratms,ibndto,iprint,ierr,fragscr,
     +                  nfrags,length_fragments,mark_fragments)
C
C Watson
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,i3)") "The number of isolated fragments per center", 
     &  nfrags
      Write(6,*)
      Write(6,"(a)") "The length_fragment array"
      Write(6,*)
      Write(6,"(4I3)")  (length_fragments(I), I=1, NRATMS)
      Write(6,*)
      Write(6,"(a)") "Fragment atom lables"
      Write(6,*)
      Write(6,"(4I3)") ((mark_fragments(I, J), I=1, nratms),
     &         J=1, NRATMS)
#endif
C
C Assign the primary interfragment connectivity
C
      IF (NFRAGS .GT. 1) THEN
         INDEX = 1
         DO IATMS = 1, NFRAGS
            DO JATMS = NFRAGS, IATMS+1, -1
               ARCH_DIST = 20.0D0
             DIST_IJFRAG =  0.0D0
               DO IFRAGS = 1, LENGTH_FRAGMENTS(IATMS)
                  DO JFRAGS = 1, LENGTH_FRAGMENTS(JATMS)
                     IFRAG_CENT  = MARK_FRAGMENTS(IATMS, IFRAGS)
                     JFRAG_CENT  = MARK_FRAGMENTS(JATMS, JFRAGS)
C
                     DIST_IJFRAG = BNDLENTHS(IFRAG_CENT,
     &                                       JFRAG_CENT)
C               
#ifdef _DEBUG_LVL0
                     Write(6,"(4I4)") IATMS, JATMS, IFRAG_CENT, 
     &                                JFRAG_CENT
                     Write(6,"(2F10.5)") DIST_IJFRAG, ARCH_DIST
#endif

                     IF (DIST_IJFRAG .LE. ARCH_DIST) THEN
                         ARCH_DIST = DIST_IJFRAG
                         I_ARCH    = IFRAG_CENT
                         J_ARCH    = JFRAG_CENT
                     ENDIF
                  ENDDO
               ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a,F10.5)") "The smallest distance between ",
     &                       "fragments: ", ARCH_DIST
      Write(6,"(a,2I3)") "The atom indices of corrs. to smalest: ", 
     &         I_ARCH, J_ARCH
#endif
C
C In order to avoid connecting fragments that are way too far apart
C let's have a minimum reasonble threshold to the distance between the 
C fragment's atoms to a assign a connectivity. The choice for this
C distance must be reevlauted as we learn more about this. At the moment
C the threshold is 2.5 sum of the covalent radii of the fragment atoms.
C This supposedly connect the nearest neighbors. Ajith Perera, 08/2008 
C 
                   BLNGT_IJFRGS(INDEX) = ARCH_DIST
                                 INDEX = INDEX + 1
C
             THRESHOLD_4NEARST = 2.50D0*SMOFCOVRADI(I_ARCH, J_ARCH)
             IF (ARCH_DIST .LE. THRESHOLD_4NEARST) THEN

                IBNDTO(J_ARCH, I_ARCH) = IONE
                IBNDTO(I_ARCH, J_ARCH) = IONE

             ENDIF
C
             ENDDO
         ENDDO
      ENDIF
C
C Assign auxilary interfragment connectivities
C
C#ifdef _NOSKIP
C
      IF (NFRAGS .GT. 1) THEN
         INDEX = 1
         DO IATMS = 1, NFRAGS
            DO JATMS = NFRAGS, IATMS+1, -1
               ARCH_DIST = BLNGT_IJFRGS(INDEX)
               DO IFRAGS = 1, LENGTH_FRAGMENTS(IATMS)
                  DO JFRAGS = 1, LENGTH_FRAGMENTS(JATMS)
                     IFRAG_CENT  = MARK_FRAGMENTS(IATMS, IFRAGS)
                     JFRAG_CENT  = MARK_FRAGMENTS(JATMS, JFRAGS)
C
                     DIST_IJFRAG  = BNDLENTHS(IFRAG_CENT,
     &                                        JFRAG_CENT)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,a,F10.5)") "The smallest distance between ",
     &                       "fragments: ", ARCH_DIST
      Write(6,"(a,a,2I3,F10.5)") "The frag. atom indices and the",
     &          " distance: ", IFRAG_CENT, JFRAG_CENT, DIST_IJFRAG
#endif

                     IF (DIST_IJFRAG .LT. 1.30D0*ARCH_DIST
     &                   .OR. DIST_IJFRAG .LT. 2.0D0*
     &                   AMTOBOHR) THEN
                                      I_ARCH    = IFRAG_CENT
                                      J_ARCH    = JFRAG_CENT
                         IBNDTO(J_ARCH, I_ARCH) = IONE
                         IBNDTO(I_ARCH, J_ARCH) = IONE
                     ENDIF
                   ENDDO
                ENDDO
                INDEX = INDEX + 1
             ENDDO
         ENDDO
      ENDIF
C
C#endif  
C#endif
C
C 
C Symmetrize the connectivity array.
C
cSSS      DO 50 IATMS = 1, NRATMS
cSSS         DO 60 IBNDS = 1, NCONPRCNTR(IATMS)
cSSS            KBNDS = IBNDTO(IBNDS, IATMS)
cSSS            FLAG = .FALSE.
cSSS            DO 70 JBNDS = 1, NCONPRCNTR(KBNDS)
cSSS
cSSS                  IF (IBNDTO(JBNDS, KBNDS) .EQ. IATMS) THEN
cSSS                  FLAG = .TRUE.
cSSS                  CALL WRITE(LUOUT, 2000)
cSSS                  CALL ERREX
cSSS               ENDIF
cSSS
cSSS 70         CONTINUE
cSSS 60      CONTINUE
cSSS     
cSSS         IF (.NOT. FLAG) THEN
cSSS            NCONPRCNTR(KBNDS) = NCONPRCNTR(KBNDS) + 1
cSSS            IBNDTO(NCONPRCNTR(KBNDS), KBNDS) = IATMS
cSSS         ENDIF
cSSS
cSSS 50   CONTINUE
cSSS
cSSS 1000 FORMAT("@-assign_connectvities - Exceeds the maximum number of 
cSSS     &        bonds allowed for a center")
cSSS
cSSS 2000 FORMAT("@-assign_connectvitis - Duplicate connectivity", " I=",I5,
cSSS              " IB=",I3," J=",I5," JB=",I3,'.')

      RETURN
      END
 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c RECORDS
c get DOIT//'ORDR'
c get DOIT//'NORB'
c get DOIT//'NIRX'
c get 'COMPORDR'
c get 'COMPNORB'
c get 'COMPNIRX'

#include "flags.h"

      subroutine init_fd(doit,natom,icore,icrsiz,nener,bprint)
      implicit none

      character*4 doit
      integer natom, icore(*), icrsiz, nener
      logical bprint

      integer iorder, iorderf, iorderc
      integer norbit, norbitf, norbitc
      integer nirrep, nirrepf, nirrepc
      integer I000, I010, I020, I030, I040, I050, I060, I070, I080, I090
      integer I100, I110, I120, I130, I140, I150, I160, I170, I180, I190
      integer I200, I0
      character*8 irrnm(32), label(32)

#include "control.com" /* for ROTPROJ */
#include "machsp.com"

      CALL IGETREC(20,'JOBARC',DOIT//'ORDR',1,IORDERF)
      CALL IGETREC(20,'JOBARC',DOIT//'NORB',1,NORBITF)
      CALL IGETREC(20,'JOBARC','COMPORDR',1,IORDERC)
      CALL IGETREC(20,'JOBARC','COMPNORB',1,NORBITC)
      IORDER=MAX(IORDERF,IORDERC)
      NORBIT=MAX(NORBITF,NORBITC)

      I0 = 1

      I000=I0
      I010=I000 + IINTFP*IORDER*9
      I020=I010 + IINTFP*IORDER*IORDER*9
      I030=I020 + IINTFP*IORDER*IORDER
      I040=I030 + IINTFP*IORDER*IORDER
      I050=I040 + 3*IORDER
      I060=I050 + IORDER*IORDER
      I080=I060 + IORDER + IAND(IORDER,1)
      I090=I080 + 6*IORDER
      I100=I090 + IINTFP*3*IORDER

      CALL CHRTABLE(IORDERF,ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030),ICORE(I040),ICORE(I050),ICORE(I060),
     &              IRRNM,ICORE(I080),DOIT,ICORE(I090))
      CALL CHRTABLE(IORDERC,ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030),ICORE(I040),ICORE(I050),ICORE(I060),
     &              IRRNM,ICORE(I080),'COMP',ICORE(I090))

      CALL IGETREC(-1,'JOBARC',DOIT//'NIRX',1,NIRREPF)
      CALL IGETREC(-1,'JOBARC','COMPNIRX',1,NIRREPC)
      NIRREP=MAX(NIRREPF,NIRREPC)

      I010=I000 + IINTFP*NATOM*NATOM*9
      I020=I010 + IINTFP*NATOM*NATOM*9
      I030=I020 + IINTFP*NATOM*NATOM*9
      I040=I030 + IINTFP*MAX(3*NATOM,NIRREPF*IORDER)
      I050=I040 + IINTFP*MAX(6*NATOM,9*IORDER)
      I060=I050 + IINTFP*MAX(6*NATOM,NIRREPF)
      I060=I050
      I070=I060 + IINTFP*9*NATOM*NATOM*3*NATOM
      I080=I070 + MAX(MAX(2,IORDER)*NATOM,9*NATOM*NATOM)
      I090=I080 + NATOM
      I100=I090 + NATOM + IAND(NATOM,1)
      I110=I100 + IINTFP*NATOM*NATOM*MAX(18,IORDER)
      I120=I110 + IINTFP*NATOM*NATOM*18
      I130=I120 + IINTFP*NATOM*NATOM*18
      BPRINT =.TRUE.

      CALL VIBINF(NATOM,NIRREPF,IORDERF,ICORE(I000),
     &            ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &            LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &            ICORE(I090),ICORE(I100),DOIT)
      CALL SYMADQ(NATOM,NIRREPC,IORDERC,NORBITC,ICORE(I000),
     &            ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &            LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &            ICORE(I090),ICORE(I100),ICORE(I110),ICORE(I120),
     &            ICORE(I130),'COMP',1)

      CALL TRAPRJ(NATOM,ICORE(I000),ICORE(I010),ICORE(I020),
     &            ICORE(I030))

      IF (ROTPROJ) THEN
         CALL ROTPRJ(NATOM,ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030))
      END IF

      CALL SCHMIDT(NATOM,ICORE(I010),ICORE(I020))

      CALL COLLECT(NATOM,NIRREPC,ICORE(I000),
     &             ICORE(I010),ICORE(I020),ICORE(I030),LABEL,
     &             'COMP')

      IF (BPRINT) THEN
         CALL PRTCOORD(NATOM,NIRREPC,0,ICORE(I000),ICORE(I010),
     &                 LABEL,'COMP',.FALSE.)
      END IF

      CALL SYMADQ(NATOM,NIRREPF,IORDERF,NORBITF,ICORE(I000),
     &            ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &            LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &            ICORE(I090),ICORE(I100),ICORE(I110),ICORE(I120),
     &            ICORE(I130),DOIT,2)
      CALL PRDEGEN(NATOM,NIRREPF,IORDERF,NORBITF,ICORE(I000),
     &             ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &             LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &             ICORE(I090),ICORE(I100),DOIT)

      IF (BPRINT) THEN
         CALL PRTCOORD(NATOM,NIRREPF,NIRREPC,ICORE(I000),ICORE(I010),
     &                 LABEL,DOIT,.TRUE.)
      END IF

      I010=I000
      I020=I010 + 3*NATOM
      I030=I020 + 9*NATOM*NATOM
      I040=I030 + 3*NATOM + IAND(NATOM,1)
      I200=I040 + IINTFP*9*NATOM*NATOM*3*NATOM
#ifdef _DEBUG_LVL0
      Print*, "Entering set points"
#endif
      CALL SETPTS(NATOM,NIRREPF,DOIT,
     &            NENER,IRRNM,ICORE(I010),ICORE(I020),ICORE(I030),
     &            ICORE(I040),ICORE(I200),(ICRSIZ-I200+I0)/IINTFP)

      return
c     end subroutine init_fd
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c A debugging routine that turns dline(izl(1,i):izl(2,i)) to carets (^)
c repeating for j while making the rest spaces.

#include "iachar.h"

      subroutine prep_dline_2(dline,izl,i,j)
      implicit none

#include "linelen.par"

      character*(linelen) dline
      integer izl(2,7), i, j

      integer ndx, k

      character*1 achar, czTmp, czSpace, czCaret

c ----------------------------------------------------------------------

      czCaret = achar(_IACHAR_CARET)
      czSpace = achar(_IACHAR_SPACE)

      do ndx = 1, 7
         if (izl(1,ndx).ne.0) then
            if ((ndx.eq.i).or.(ndx.eq.j)) then
               czTmp = czCaret
            else
               czTmp = czSpace
            end if
            do k = izl(1,ndx), izl(2,ndx)
               dline(k:k) = czTmp
            end do
         end if
      end do

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function find_server_table_ptr(node, server_table,
     *                                       nserver_table, abort_flag)
c----------------------------------------------------------------------------
c   Finds the match for "node" in the server table and returns its
c   pointer.  If no match is found, and the abort_flag = .true.,
c   it is a fatal error and the job is aborted.
c----------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'parallel_info.h'
      integer node, nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      logical abort_flag

      integer i, j, nind, array, istart, nsearch
      integer msgtype

      array = server_msg(c_msg_array,node)
      nind  = server_msg(c_msg_nind,node) 
      find_server_table_ptr = 0
      if (nind .lt. 1 .or. nind .gt. mx_array_index) then
         print *,'Task ',me,' Error in find_server_table_ptr: nind = ',
     *       nind
         call server_abort_job(server_table, nserver_table)
      endif

      do i = 1, nserved_arrays
         if (served_array_table(i) .eq. array) then
            istart = served_array_entry(i)
            nsearch = served_numblocks(i)
            go to 50
         endif
      enddo

      print *,'Error: Cannot find array ',array,
     *       ' in served array table'
      call server_abort_job(server_table, nserver_table)
   50 continue

      if (istart .lt. 1 .or. istart .gt. nserver_table_entries) then
         print *,'Task ',me,' Error in find_server_table_ptr'
         print *,'istart = ',istart,' nserver_table_entries ',
     *           nserver_table_entries
         call server_abort_job(server_table, nserver_table)
      endif

      if (istart+nsearch-1 .lt. 1 .or. istart+nsearch-1 .gt.
     *          nserver_table_entries) then
         print *,'Task ',me,' Error in find_server_table_ptr'
         print *,'istart = ',istart,' nserver_table_entries ',
     *           nserver_table_entries
         print *,'nsearch = ',nsearch,' istart+nsearch-1 ',
     *           istart+nsearch-1
         call server_abort_job(server_table, nserver_table)
      endif

      msgtype = server_msg(c_msg_type, node)

      do 100 i = istart, istart+nsearch-1
         if (msgtype .eq. server_prequest_msg) then

c--------------------------------------------------------------------------
c   For a partial request, the secondary set of segments is searched.
c--------------------------------------------------------------------------

            do j = 1, nind
               if (server_msg(c_msg_bsegs2+j-1,node) .ne.
     *             server_table(c_server_bsegs+j-1,i)) go to 100
               if (server_msg(c_msg_esegs2+j-1,node) .ne.
     *             server_table(c_server_esegs+j-1,i)) go to 100
            enddo
         else

c---------------------------------------------------------------------------
c   Normal search.
c---------------------------------------------------------------------------

            do j = 1, nind
               if (server_msg(c_msg_bsegs+j-1,node) .ne. 
     *             server_table(c_server_bsegs+j-1,i)) go to 100
               if (server_msg(c_msg_esegs+j-1,node) .ne.
     *             server_table(c_server_esegs+j-1,i)) go to 100
            enddo 
         endif

         find_server_table_ptr = i

         if (array .ne. server_table(c_server_array,i)) then
            print *,'Error: server_table array value doesnt match',
     *             ' expected value.'
            print *,'Actual value = ',server_table(c_server_array,i)
            print *,'Expected value = ',array
            call server_abort_job(server_table, nserver_table)
         endif

         if (msgtype .ne. server_prequest_msg .and.
     *       server_table(c_server_size,i) .ne. 
     *                  server_msg(c_msg_size,node)) then
            print *,'Server ',me,' Size mismatch: ptr ',i,
     *       ' size ',server_table(c_server_size,i),' node ',
     *       node, ' msg_size ',server_msg(c_msg_size,node)
            call server_abort_job(server_table, nserver_table)
         endif
         return
  100 continue

      if (abort_flag) then  
         print *,'Error: Entry for node not found in server_table'
         if (msgtype .eq. server_prequest_msg) then
            print *,'node ',node,' array ',array,' segs ',
     *        (server_msg(c_msg_bsegs2+j-1,node),
     *        server_msg(c_msg_esegs2+j-1,node),j=1,nind)
         else
            print *,'node ',node,' array ',array,' segs ',
     *        (server_msg(c_msg_bsegs+j-1,node),
     *        server_msg(c_msg_esegs+j-1,node),j=1,nind)
         endif
         call server_abort_job(server_table, nserver_table)
      endif   ! abort_flag
      return
      end

      SUBROUTINE DOT24(IRREP,Z,Z1,W,BUF,DISSIZ,POPP,POPQ,
     &                 POP1,POP2,POP3,POP4,TYPE)
C
C THIS ROUTINE PERFORMS UNCOMPLICATED BUT MESSY CONTRACTIONS OF
C  THE GENERIC FORM
C
C      Z(P,Q) = Z1(M,N) * I(MP,NQ)  [TYPE='STST']
C      
C      Z(P,Q) = Z1(M,N) * I(PM,NQ)  [TYPE='TSST']
C
C      Z(P,Q) = Z1(M,N) * I(PM,QN)  [TYPE='TSTS']
C
C      Z(P,Q) = Z1(M,N) * I(MP,QN)  [TYPE='STTS']
C
C WHERE I IS ASSUMED TO BE ONE IRREP OF A SYMMETRY PACKED 
C  [GAMMA(MP)=GAMMA(NQ)] FOUR-INDEX QUANTITY AND Z1 AND Z
C  ARE TWO INDEX ARRAYS WHICH ARE SYMMETRY PACKED IN THE USUAL
C  MANNER.  THIS ROUTINE SHOULD BE USED FOR THESE CASES SINCE
C  THEY HAVE ONLY AN N**4 COMPUTATIONAL DEPENDENCE AND ALTERNATIVES
C  SUCH AS FANCYGET/FANCYPUT CALLS CANNOT BE JUSTIFIED.
C
C INPUT:
C       IRREP - THE IRREDUCIBLE REPRESENTATION TO WHICH THE FOUR-INDEX
C               LIST BELONGS.
C       Z     - THE TARGET VECTOR 
C       Z1    - THE TWO-INDEX QUANTITY WHICH WILL BE CONTRACTED WITH
C               THE FOUR-INDEX LIST.
C       W     - THE FOUR-INDEX QUANTITY
C       BUF   - A SCRATCH ARRAY WHICH HAS THE SAME LENGTH AS Z1.
C       DISSIZ- THE DISTRIBUTION SIZE OF THE FOUR-INDEX QUANTITY
C       POPP  - POPULATION VECTOR FOR P.
C       POPQ  - POPULATION VECTOR FOR Q.
C       POP1  - POPULATION VECTOR FOR FASTEST INDEX IN W.
C       POP2  - POPULATION VECTOR FOR SECOND FASTEST INDEX IN W.
C       POP3  - POPULATION VECTOR FOR THIRD FASTEST INDEX IN W.
C       POP4  - POPULATION VECTOR FOR SLOWEST INDEX IN W.
C       TYPE  - SPECIFIES THE ORDERING OF THE FOUR-INDEX INDICES
C               ON INPUT (CHARACTER*4).
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION W,Z,Z1,BUF,X,SDOT
      CHARACTER*4 TYPE
      DIMENSION W(1),Z(1),Z1(1),IOFFX(8),IOFFDS(8),IOFFDZ(8)
      DIMENSION POPP(NIRREP),POPQ(NIRREP),POP1(NIRREP),POP2(NIRREP)
      DIMENSION POP3(NIRREP),POP4(NIRREP),BUF(1)
      DIMENSION POPM(8),POPN(8),IOFFX1(8)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
C
C COMPUTE OFFSETS INTO Z AND Z1 AND OFFSETS FOR INTEGRAL DISTRIBUTION
C  NUMBER AND DISTRIBUTION ELEMENTS
C
      IOFFX1(1)=1
      IOFFX(1)=1
      IOFFDS(1)=0
      IOFFDZ(1)=0
      DO 10 IRREPDO=1,NIRREP-1
       IOFFX(IRREPDO+1)=IOFFX(IRREPDO)+POPP(IRREPDO)*POPQ(IRREPDO)
C 
       IRREPX=DIRPRD(IRREPDO,IRREP)
       IOFFDS(IRREPDO+1)=IOFFDS(IRREPDO)+POP3(IRREPX)*POP4(IRREPDO)
       IOFFDZ(IRREPDO+1)=IOFFDZ(IRREPDO)+POP1(IRREPX)*POP2(IRREPDO)
10    CONTINUE
      IF(TYPE.EQ.'STST')THEN
       CALL ICOPY(NIRREP,POP1,1,POPM,1)
       CALL ICOPY(NIRREP,POP3,1,POPN,1)
       DO 301 IRRP=1,NIRREP-1
        IOFFX1(IRRP+1)=IOFFX1(IRRP)+POPM(IRRP)*POPN(IRRP)
301    CONTINUE
       DO 100 IRREPPQ=1,NIRREP
        IRREPMN=DIRPRD(IRREPPQ,IRREP)
        NUMM  =POPM(IRREPMN)
        NUMP  =POPP(IRREPPQ)
        NUMN  =POPN(IRREPMN)
        NUMQ  =POPQ(IRREPPQ)
        IOFFZ1=IOFFX1(IRREPMN)
        IOFFZ =IOFFX(IRREPPQ)-1
        ITHRU =0
        DO 110 Q=1,NUMQ
         IOFFR=IOFFDS(IRREPPQ)+1+(Q-1)*NUMN
         DO 120 P=1,NUMP
          IOFFL=IOFFDZ(IRREPPQ)+1+(P-1)*NUMM
          IOFFW=IOFFL+(IOFFR-1)*DISSIZ
          IOFFB =1
          ITHRU=ITHRU+1
C
C COLLECT ALL MN FROM THE I(MP,NQ) MATRIX INTO A SCRATCH VECTOR
C
          DO 130 N=1,NUMN
           CALL SCOPY(NUMM,W(IOFFW),1,BUF(IOFFB),1)
           IOFFW=IOFFW+DISSIZ
           IOFFB=IOFFB+NUMM
130       CONTINUE
          X=SDOT(NUMM*NUMN,BUF,1,Z1(IOFFZ1),1)
          Z(IOFFZ+ITHRU)=Z(IOFFZ+ITHRU)+X
120      CONTINUE
110     CONTINUE
100    CONTINUE
      ELSEIF(TYPE.EQ.'TSST')THEN
       CALL ICOPY(NIRREP,POP2,1,POPM,1)
       CALL ICOPY(NIRREP,POP3,1,POPN,1)
       DO 302 IRRP=1,NIRREP-1
        IOFFX1(IRRP+1)=IOFFX1(IRRP)+POPM(IRRP)*POPN(IRRP)
302    CONTINUE
       DO 200 IRREPPQ=1,NIRREP
        IRREPMN=DIRPRD(IRREPPQ,IRREP)
        NUMM  =POPM(IRREPMN)
        NUMP  =POPP(IRREPPQ)
        NUMN  =POPN(IRREPMN)
        NUMQ  =POPQ(IRREPPQ)
        IOFFZ1=IOFFX1(IRREPMN)
        IOFFZ =IOFFX(IRREPPQ)-1
        ITHRU =0
        DO 210 Q=1,NUMQ
         IOFFR=IOFFDS(IRREPPQ)+1+(Q-1)*NUMN
         DO 220 P=1,NUMP
          IOFFL=IOFFDZ(IRREPMN)+P
          IOFFW=IOFFL+(IOFFR-1)*DISSIZ
          IOFFB =1
          ITHRU=ITHRU+1
C
C COLLECT ALL MN FROM THE I(PM,NQ) MATRIX INTO A SCRATCH VECTOR
C
          DO 230 N=1,NUMN
           CALL SCOPY(NUMM,W(IOFFW),NUMP,BUF(IOFFB),1)
           IOFFW=IOFFW+DISSIZ
           IOFFB=IOFFB+NUMM
230       CONTINUE
          X=SDOT(NUMM*NUMN,BUF,1,Z1(IOFFZ1),1)
          Z(IOFFZ+ITHRU)=Z(IOFFZ+ITHRU)+X
220      CONTINUE
210     CONTINUE
200    CONTINUE
      ELSEIF(TYPE.EQ.'TSTS')THEN
       CALL ICOPY(NIRREP,POP2,1,POPM,1)
       CALL ICOPY(NIRREP,POP4,1,POPN,1)
       DO 303 IRRP=1,NIRREP-1
        IOFFX1(IRRP+1)=IOFFX1(IRRP)+POPM(IRRP)*POPN(IRRP)
303    CONTINUE
       DO 300 IRREPPQ=1,NIRREP
        IRREPMN=DIRPRD(IRREPPQ,IRREP)
        NUMM  =POPM(IRREPMN)
        NUMP  =POPP(IRREPPQ)
        NUMN  =POPN(IRREPMN)
        NUMQ  =POPQ(IRREPPQ)
        IOFFZ1=IOFFX1(IRREPMN)
        IOFFZ =IOFFX(IRREPPQ)-1
        ITHRU =0
        DO 310 Q=1,NUMQ
         IOFFR=IOFFDS(IRREPMN)+Q
         DO 320 P=1,NUMP
          IOFFL=IOFFDZ(IRREPMN)+P
          IOFFW=IOFFL+(IOFFR-1)*DISSIZ
          IOFFB =1
          ITHRU=ITHRU+1
C
C COLLECT ALL MN FROM THE I(PM,QN) MATRIX INTO A SCRATCH VECTOR
C
          DO 330 N=1,NUMN
           CALL SCOPY(NUMM,W(IOFFW),NUMP,BUF(IOFFB),1)
           IOFFW=IOFFW+DISSIZ*NUMQ
           IOFFB=IOFFB+NUMM
330       CONTINUE
          X=SDOT(NUMM*NUMN,BUF,1,Z1(IOFFZ1),1)
          Z(IOFFZ+ITHRU)=Z(IOFFZ+ITHRU)+X
320      CONTINUE
310     CONTINUE
300    CONTINUE
      ELSEIF(TYPE.EQ.'STTS')THEN
       CALL ICOPY(NIRREP,POP1,1,POPM,1)
       CALL ICOPY(NIRREP,POP4,1,POPN,1)
       DO 304 IRRP=1,NIRREP-1
        IOFFX1(IRRP+1)=IOFFX1(IRRP)+POPM(IRRP)*POPN(IRRP)
304    CONTINUE
       DO 400 IRREPPQ=1,NIRREP
        IRREPMN=DIRPRD(IRREPPQ,IRREP)
        NUMM  =POPM(IRREPMN)
        NUMP  =POPP(IRREPPQ)
        NUMN  =POPN(IRREPMN)
        NUMQ  =POPQ(IRREPPQ)
        IOFFZ1=IOFFX1(IRREPMN)
        IOFFZ =IOFFX(IRREPPQ)-1
        ITHRU =0
        IOFFB =1
        DO 410 Q=1,NUMQ
         IOFFR=IOFFDS(IRREPMN)+Q
         DO 420 P=1,NUMP
          IOFFL=IOFFDZ(IRREPPQ)+1+(P-1)*NUMM
          IOFFW=IOFFL+(IOFFR-1)*DISSIZ
          IOFFB =1
          ITHRU=ITHRU+1
C
C COLLECT ALL MN FROM THE I(MP,QN) MATRIX INTO A SCRATCH VECTOR
C
          DO 430 N=1,NUMN
           CALL SCOPY(NUMM,W(IOFFW),1,BUF(IOFFB),1)
           IOFFW=IOFFW+DISSIZ*NUMQ
           IOFFB=IOFFB+NUMM
430       CONTINUE
          X=SDOT(NUMM*NUMN,BUF,1,Z1(IOFFZ1),1)
          Z(IOFFZ+ITHRU)=Z(IOFFZ+ITHRU)+X
420      CONTINUE
410     CONTINUE
400    CONTINUE
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C RETURNS THE FIRST POSITION OF AN INTEGER IN AN INTEGER VECTOR V.

      INTEGER FUNCTION CHKINT(V,LEN,INT)
      IMPLICIT INTEGER(A-Z)
      DIMENSION V(LEN)
      I = 1
      CHKINT = 0
      DO WHILE ((CHKINT.EQ.0).AND.(I.LE.LEN))
         IF (V(I).EQ.INT) CHKINT = I
         I = I + 1
      END DO
      RETURN
      END

      SUBROUTINE VSTAT(V,ZQ,LENGTH)
C
C RETURNS STATISTICAL INFO ABOUT VECTOR V in ZQ
C     ZQ(1)  Largest absolute magnitude
C     ZQ(2)  Smallest absolute magnitude
C     ZQ(3)  Largest value
C     ZQ(4)  Smallest value
C     ZQ(5)  2-norm
C     ZQ(6)  Dynamic range of the vector (abs. min. - abs. max.)
C   

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION V(LENGTH),ZQ(6)
      U=0.D0
      CALL ZERO(ZQ,6)
      ZQ(2)=DABS(V(1))
      ZQ(4)=V(1)
      DO 20 I=1,LENGTH
      ZQ(1)=MAX(ZQ(1),DABS(V(I)))
      ZQ(2)=MIN(ZQ(2),DABS(V(I)))
      ZQ(3)=MAX(ZQ(3),V(I))
      ZQ(4)=MIN(ZQ(4),V(I))
20    U=U+V(I)*V(I)
      If (Length .ne. 0) ZQ(5)=DSQRT(U/LENGTH)
      ZQ(6)=ZQ(2)-ZQ(1)
      RETURN
      END

      SUBROUTINE EXPJFC(JFC,JFC2,NCOORD)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION JFC,JFC2
      DIMENSION JFC(NCOORD,NCOORD),JFC2(3*NCOORD,3*NCOORD)


      if (ncoord.lt.0) then
         print *, '@EXPJFC: Assertion failed.'
         print *, '         ncoord = ',ncoord
         call errex
      end if


      CALL ZERO(JFC2,9*NCOORD*NCOORD)

      INEW = 1
      DO I = 1, NCOORD
         JNEW = 0
         DO J = 1, NCOORD
            INEW1 = INEW
            JNEW  = JNEW + 1
            JFC2(INEW1,JNEW) = JFC(I,J)
            JNEW  = JNEW  + 1
            INEW1 = INEW1 + 1
            JFC2(INEW1,JNEW) = JFC(I,J)
            JNEW  = JNEW  + 1
            INEW1 = INEW1 + 1
            JFC2(INEW1,JNEW) = JFC(I,J)
         END DO
         INEW = INEW + 3
      END DO

      RETURN
      END

C THIS ROUTINE ACCEPTS A FLOATING POINT VECTOR (VEC) AND
C RETURNS VEC(I)=1.0/SQRT(VEC(I)) FOR THE FIRST n
C ELEMENTS FOR STRIDE OFFSET inc.
c BEWARE - Do not use this (yet) if inc is negative!

      SUBROUTINE INVSQT(VEC,inc,n)
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION VEC(*)
c old
c      IOFF = 1
c      DO I = 1, ICOUNT
c         VEC(IOFF) = 1.0d0 / SQRT(VEC(IOFF))
c         IOFF = IOFF + ISTRID
c      END DO
c new
      if (n.lt.1) return
      if (inc.eq.1) then
         do i = 1, n
            vec(i) = 1.0d0 / sqrt(vec(i))
         end do
      else
         itmp = 1 + inc*(n-1)
         do i = 1, itmp, inc
            vec(i) = 1.0d0 / sqrt(vec(i))
         end do
      end if
c end
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C
      SUBROUTINE CSHIFTPRI(CSHIFT, INDEX)
C
C Print out the total shielding tensor and orientation of the shielding
C tensor. Coded by Ajith 04/96.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION CSHIFT (3, 3)
C
      CHARACTER*5 COORD(3)
C
#include "mxatms.par"
#include "cbchar.com"
#include "coord.com"
C
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C
      DATA COORD/'x    ','y    ','z    '/
C
      WRITE (6, 10)
C
      DO 5 I = 1, 3
         WRITE(6, 20) ZSYM(INDEX), COORD(I), (CSHIFT(I,J),J=1,3)
    5 CONTINUE
C
 10   FORMAT(/)
 20   FORMAT(15X, A2, 1X, A2, 3F12.6)
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine determine_array_indices(op, array_table, narray_table,
     *                                   debug)
      implicit none
      include 'interpreter.h'

      integer narray_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)

      integer x1, x2, y, opcode
      integer ny, nx1, nmatches, i, j, matches(4)
      integer x1_unmatch(4), x2_unmatch(4), nx1_unmatch, nx2_unmatch
      integer iy, ix2, x1_index

      logical debug

      opcode = op(c_opcode)
      x1     = op(c_op1_array)
      x2     = op(c_op2_array)
      y      = op(c_result_array)

      ny = array_table(c_nindex,y)
      nx1 = array_table(c_nindex,x1)
      if (debug) print *,'@@@ opcode, x1, x2, y, ny, nx1 = ',
     *             opcode, x1, x2, y, ny, nx1

      if (opcode .eq. sum_op) then
         call find_matching_indices(x1, x2, array_table, narray_table,
     *                                 matches, nmatches) 
         if (nmatches .ne. nx1) then
            print *,'Error: All indices must match for sum operation.'
            print *,'Arrays ',x1,' and ',x2,' have ',nmatches,
     *                ' matches out of ',nx1
            call abort_job()
         endif

         do i = 1, ny
            array_table(c_index_array1+i-1,y) = matches(i)
         enddo

      else if (opcode .eq. contraction_op) then
         if (debug) print *,'Before find_non_matching_indices...'
         call find_non_matching_indices(x1, x2, 
     *                                  array_table, narray_table,
     *                                  x1_unmatch, nx1_unmatch,
     *                                  x2_unmatch, nx2_unmatch)

c--------------------------------------------------------------------------
c   Step through the indices of x1, replacing each matching index with an
c   unmatched one.
c-------------------------------------------------------------------------- 

         iy = 0
         ix2 = 0
         do i = 1, nx1
            x1_index = array_table(c_index_array1+i-1, x1)
            if (debug) print *,'@@@ i = ',i,' x1_index = ',x1_index
            do j = 1, nx1_unmatch
               if (x1_index .eq. x1_unmatch(j)) then
                  iy = iy + 1
                  array_table(c_index_array1+iy-1,y) = x1_index
                  go to 100
               endif
            enddo

c--------------------------------------------------------------------------
c   This index matches an index in x2.  Replace it with an unmatching one
c   from the x2_unmatch array.
c--------------------------------------------------------------------------

            if (debug) print *,'   @@@ After j loop...'
            ix2 = ix2 + 1
            if (ix2 .gt. nx2_unmatch) go to 100
            iy  = iy + 1
            if (debug) print *,'   @@@ ix2, iy = ',ix2,iy
            array_table(c_index_array1+iy-1,y) = x2_unmatch(ix2) 
  100    continue
            if (debug) print *,'@@@ Statement 100'
         enddo
      endif

      return
      end

C THIS ROUTINE DRIVES THE FORMATION OF THE GRADIENT.

c INPUT
c integer NATOM  : the number of atoms
c integer NIRREP : the number of irreps
c char*4  TYPE   : (FULL|COMP) point group
c integer NDSCR  : the amount of double scratch at DSCR

c OUTPUT
c char*8  LABEL(NIRREP)    : (scr) symmetry label of each irrep
c integer ISYMIRR(3*NATOM) : (scr)
c double  SYMGRD(3*NATOM)  : Symmetry  coordinate gradient
c double  CARTGRD(3*NATOM) : Cartesian coordinate gradient
c double  DSCR(NDSCR)      : (scr) double scratch

c RECORDS
c get 'NUMVIBRT'
c get TYPE//'SYQT'
c get TYPE//'LABL'
c get TYPE//'DEGN'
c get 'NUMPOINT'
c get 'ENGPOINT'
c get 'INVPSMAT'
c put 'GRADIENT'

      SUBROUTINE SETGRD(NATOM,NIRREP,TYPE,
     &                  LABEL,ISYMIRR,
     &                  SYMGRD,CARTGRD,
     &                  DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      CHARACTER*4 TYPE
      CHARACTER*8 LABEL(NIRREP)
      DIMENSION ISYMIRR(3*NATOM)
      DIMENSION SYMGRD(3*NATOM),CARTGRD(3*NATOM)
      double precision dscr(ndscr)

      DIMENSION idegen(100)
      LOGICAL PRINTQ

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100)
#include "control.com"

      PRINTQ=(IFLAGS(1).GT.10)
      STPSIZ=DFLOAT(IFLAGS(57))*10.0D-5

      NSIZE=3*NATOM
      CALL GETREC(20,'JOBARC','NUMPOINT',1,NPOINT)
      if (ndscr.lt.npoint) then
         print *, '@SETGRD: Insufficient memory.'
         print *, '         need ',npoint,' doubles'
         print *, '         have ',ndscr,' doubles'
         call aces_exit(1)
      end if
      CALL GETREC(20,'JOBARC','ENGPOINT',NPOINT*IINTFP,DSCR)
#ifdef _ASSERT
      if (gmtryopt) then
c      o only check the points in irrep 1
         CALL GETREC(20,'JOBARC','NPTIRREP',1,n)
      else
         n = npoint
      end if
      do i = 1, n
         if (dscr(i).eq.0.d0) then
c         o if any energy is exactly 0, then ACES did not do all points
            print *, '@SETGRD: Assertion failed.'
            print *, '         Energy of point ',i,' is 0. a.u.'
            call aces_exit(1)
         end if
      end do
#endif
      CALL GETREC(20,'JOBARC','NUMVIBRT',1,NMODE)
      CALL GETREC(20,'JOBARC','INVPSMAT',1,INVOP)
      CALL GETREC(20,'JOBARC',TYPE//'SYQT',NSIZE,ISYMIRR)
      CALL GETREC(20,'JOBARC',TYPE//'DEGN',NIRREP,IDEGEN)
      IF (PRINTQ) THEN
      CALL GETREC(20,'JOBARC',TYPE//'LABL',NIRREP*IINTFP,LABEL)
      END IF

      CALL ZERO(SYMGRD,3*NATOM)

      IRREP=1

c   o find first occurance of this irrep
      ILOC=ISRCHEQ(NMODE,ISYMIRR,1,IRREP)
      IF (ILOC.NE.NMODE+1) THEN
         ILAST=ISRCHNE(NMODE,ISYMIRR(ILOC),1,IRREP)
         NVIBSYM=ILAST-1
         NVIBUNQ=NVIBSYM/IDEGEN(IRREP)
         IF (PRINTQ) THEN
            WRITE(6,2000)LABEL(IRREP),IDEGEN(IRREP),NVIBUNQ
2000        FORMAT(T3,' Symmetry : ',A,' Degeneracy : ',I1,
     &             ' Unique symmetry coordinates : ',I3)
         END IF
         if (invop.gt.0) then
            print *, '@SETGRD: Assertion failed.'
            print *, '         Gradients are not implemented for',
     &               ' these displacements.'
            call aces_exit(1)
         end if
         CALL ENER2GRD(NVIBSYM,DSCR,SYMGRD,STPSIZ)
      END IF

c   o transform and write the gradient to JOBARC
      CALL TRNGRD(NATOM,SYMGRD,CARTGRD,DSCR,NDSCR,TYPE,PRINTQ)
      CALL PUTREC(20,'JOBARC','GRADIENT',NSIZE*IINTFP,CARTGRD)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__INT2D_TO_E000
     +
     +                    ( SHELLA,SHELLP,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZET,NXYZP,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__INT2D_TO_E000
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                eris:
C
C                        [E0|00] or [00|E0] , E = A to P
C
C                adding up all the contributions from all the
C                respective 2D integrals:
C
C                                   P0 or 0P
C
C                Simplified version of the general E0F0 routine to
C                reduce loop overheads for those cases where there is
C                at least one s-shell on the bra or ket side. For
C                comments and details see the general E0F0 routine.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A and csh sum P=A+B
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZET      =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B
C                    NXYZP       =  # of cartesian monomials for the
C                                   P=A+B shell
C                    INT2Dx      =  all current 2D P0/0P integrals for
C                                   each cartesian component
C                                   (x = X,Y,Z)
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D P0/0P integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [E0|00] integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,K,M,N
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZE,NXYZET,NXYZP
         INTEGER     SE,SEEND
         INTEGER     SHELLA,SHELLP
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX
         INTEGER     XEP,XYEP
         INTEGER     XYE
         INTEGER     YEEND

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ,1:NXYZET)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XEP = NXYZET + 3
         DO 100 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 110 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO M = 1,NEXQ
                      TEMP2 (M) = TEMP1 (M)
                   END DO
               ELSE
                   DO M = 1,NEXQ
                      TEMP2 (M) = TEMP1 (M) * INT2DY (M,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 120 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      DO M = 1,NEXQ
                         BATCH (M,I) = TEMP2 (M)
                      END DO
                  ELSE
                      DO M = 1,NEXQ
                         BATCH (M,I) = TEMP2 (M) * INT2DZ (M,ZE)
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  120          CONTINUE

  110       CONTINUE
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XEP = NXYZET + 3
         DO 200 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 210 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 220 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
                         K = K + 2
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
                         K = K + 2
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  220          CONTINUE

  210       CONTINUE
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XEP = NXYZET + 3
         DO 300 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 310 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 320 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
                         K = K + 3
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
                         K = K + 3
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  320          CONTINUE

  310       CONTINUE
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XEP = NXYZET + 3
         DO 400 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 410 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 420 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
     +                                 + TEMP2 (K+3)
                         K = K + 4
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
     +                                 + TEMP2 (K+3)
     +                                 * INT2DZ (K+3,ZE)
                         K = K + 4
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  420          CONTINUE

  410       CONTINUE
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XEP = NXYZET + 3
         DO 500 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 510 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 520 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
     +                                 + TEMP2 (K+3)
     +                                 + TEMP2 (K+4)
                         K = K + 5
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
     +                                 + TEMP2 (K+3)
     +                                 * INT2DZ (K+3,ZE)
     +                                 + TEMP2 (K+4)
     +                                 * INT2DZ (K+4,ZE)
                         K = K + 5
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  520          CONTINUE

  510       CONTINUE
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XEP = NXYZET + 3
         DO 600 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 610 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 620 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
     +                                 + TEMP2 (K+3)
     +                                 + TEMP2 (K+4)
     +                                 + TEMP2 (K+5)
                         K = K + 6
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
     +                                 + TEMP2 (K+3)
     +                                 * INT2DZ (K+3,ZE)
     +                                 + TEMP2 (K+4)
     +                                 * INT2DZ (K+4,ZE)
     +                                 + TEMP2 (K+5)
     +                                 * INT2DZ (K+5,ZE)
                         K = K + 6
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  620          CONTINUE

  610       CONTINUE
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XEP = NXYZET + 3
         DO 700 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 710 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 720 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
     +                                 + TEMP2 (K+3)
     +                                 + TEMP2 (K+4)
     +                                 + TEMP2 (K+5)
     +                                 + TEMP2 (K+6)
                         K = K + 7
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
     +                                 + TEMP2 (K+3)
     +                                 * INT2DZ (K+3,ZE)
     +                                 + TEMP2 (K+4)
     +                                 * INT2DZ (K+4,ZE)
     +                                 + TEMP2 (K+5)
     +                                 * INT2DZ (K+5,ZE)
     +                                 + TEMP2 (K+6)
     +                                 * INT2DZ (K+6,ZE)
                         K = K + 7
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  720          CONTINUE

  710       CONTINUE
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XEP = NXYZET + 3
         DO 800 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 810 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 820 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
     +                                 + TEMP2 (K+3)
     +                                 + TEMP2 (K+4)
     +                                 + TEMP2 (K+5)
     +                                 + TEMP2 (K+6)
     +                                 + TEMP2 (K+7)
                         K = K + 8
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
     +                                 + TEMP2 (K+3)
     +                                 * INT2DZ (K+3,ZE)
     +                                 + TEMP2 (K+4)
     +                                 * INT2DZ (K+4,ZE)
     +                                 + TEMP2 (K+5)
     +                                 * INT2DZ (K+5,ZE)
     +                                 + TEMP2 (K+6)
     +                                 * INT2DZ (K+6,ZE)
     +                                 + TEMP2 (K+7)
     +                                 * INT2DZ (K+7,ZE)
                         K = K + 8
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  820          CONTINUE

  810       CONTINUE
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XEP = NXYZET + 3
         DO 900 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 910 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 920 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (ZE.EQ.0) THEN
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 + TEMP2 (K+1)
     +                                 + TEMP2 (K+2)
     +                                 + TEMP2 (K+3)
     +                                 + TEMP2 (K+4)
     +                                 + TEMP2 (K+5)
     +                                 + TEMP2 (K+6)
     +                                 + TEMP2 (K+7)
     +                                 + TEMP2 (K+8)
                         K = K + 9
                      END DO
                  ELSE
                      K = 1
                      DO M = 1,NEXQ
                         BATCH (M,I) =   TEMP2 (K)
     +                                 * INT2DZ (K,ZE)
     +                                 + TEMP2 (K+1)
     +                                 * INT2DZ (K+1,ZE)
     +                                 + TEMP2 (K+2)
     +                                 * INT2DZ (K+2,ZE)
     +                                 + TEMP2 (K+3)
     +                                 * INT2DZ (K+3,ZE)
     +                                 + TEMP2 (K+4)
     +                                 * INT2DZ (K+4,ZE)
     +                                 + TEMP2 (K+5)
     +                                 * INT2DZ (K+5,ZE)
     +                                 + TEMP2 (K+6)
     +                                 * INT2DZ (K+6,ZE)
     +                                 + TEMP2 (K+7)
     +                                 * INT2DZ (K+7,ZE)
     +                                 + TEMP2 (K+8)
     +                                 * INT2DZ (K+8,ZE)
                         K = K + 9
                      END DO
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  920          CONTINUE

  910       CONTINUE
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x-contributions. No skipping of the
C                x-contributions of 0-type can be done here, since
C                the 2DX integrals carry the Rys weight!
C
C
   10    XEP = NXYZET + 3
         DO 1000 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO
C
C
C             ...middle loops over y-contributions. Skip multiplication
C                of y-contributions, if we have a 0-type, as then the
C                2DY integral is equal to 1.
C
C
            XYEP = XEP - XEMAX
            DO 1010 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF
C
C
C             ...inner loops over E-pairs. Skip multiplication
C                of z-contributions, if we have a 0-type, as
C                then the 2DZ integral is equal to 1.
C
C
               I = XYEP
               NXYZE = NXYZP
               DO 1020 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE
C
C
C             ...all info concerning all x-, y- and z-contributions
C                have been collected for all exponent quadruplets at
C                once. Sum up the 2D X,Y,Z integral products to the
C                appropriate place of the batch.
C
C
                  IF (ZE.EQ.0) THEN
                      K = 0
                      DO M = 1,NEXQ
                         SUM = ZERO
                         DO N = 1,NGQP
                            SUM = SUM + TEMP2 (K+N)
                         END DO
                         K = K + NGQP
                         BATCH (M,I) = SUM
                      END DO
                  ELSE
                      K = 0
                      DO M = 1,NEXQ
                         SUM = ZERO
                         DO N = 1,NGQP
                            SUM = SUM + TEMP2 (K+N) * INT2DZ (K+N,ZE)
                         END DO
                         K = K + NGQP
                         BATCH (M,I) = SUM
                      END DO
                  END IF
C
C
C             ...next z-contribution.
C
C
                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
 1020          CONTINUE
C
C
C             ...next y- and x-contribution.
C
C
 1010       CONTINUE
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C THIS ARRAY CALCUATES THE INVERSE OF A GIVEN VECTOR A OF LENGTH N
C    A(I) = ONE/A(I)

      SUBROUTINE INVERS(A,N)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(N)
      if (n.lt.1) return
      DO I = 1, N
         A(I) = 1.0d0 / A(I)
      END DO
      RETURN
      END

#include "flags.h"
      SUBROUTINE SYMMETRY(SCRATCH,QTMP,NEWQ,NOSILENT)
C
C This is a front end routine that handles geometry/symmetry related
C issues. With this, we can smoothly turn off the symmetry
C processing when it is requested. Also, the logic that pertains
C to the reorientation is much simpler. Ajith Perera, 11/05
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "fnamelen.par"
#include "coord.com"
#include "cbchar.com"

      DOUBLE PRECISION IT(3,3),CM(3),IV(3,3),NEWQ(NX),dtmp
      DOUBLE PRECISION RM(3,3),QTMP(NX),TATB(3),QOLD(100)
      DOUBLE PRECISION SCRATCH(3*NX),MOLWT,ORIEN2(9)
      LOGICAL XYZIN,NWFINDIF,NOSILENT
      INTEGER IORGRP, MEMBER(MXATMS)
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      COMMON /TOLERS/ SYMTOL,DEGTOL
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $     ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $     XYZTol
      COMMON /INPTYP/ XYZIN, NWFINDIF
      Character*(8*mxatms) szStSymTmp
      Character*8 STSYM(MXATMS)
C
      CHARACTER*(5*MXATMS) ZSYMUNI
C
#include "io_units.par"
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp, PTGrp
      Character*8 TMPGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
#include "machsp.com"
      DATA IONE, ININE /1, 9/
      DATA ONE   / 1.0D+00/
      DATA ONEM  /-1.0D+00/
      DATA ZILCH / 0.0D+00/
      DTOR=DACOS(ONEM)/180.D0
C
C TRANSLATE TO CENTER OF MASS
C
      IDEGEN=0
C
      IF(IPRNT.GE.3 .AND. NOSILENT) WRITE(LUOUT,7733)
     &                              (ATMASS(J),J = 1,NATOMS)
 7733 FORMAT(1X,F15.10)
C
#ifdef _DEBUG_LVL0
      Write(6,"(a, 5I)"), "The number of atoms", Natoms
      Write(6,*)
      Print*, "The Cartesians before translations to CM" 
      Write(6, "(3F10.5)"), (Q(I), I=1, 3*NATOMS)
      Write(6,*)
#endif
      CALL DCOPY(3*NATOMS, Q, 1, QOLD, 1)
C
      CMX=0.D0
      CMY=0.D0
      CMZ=0.D0
      MOLWT=0.D0
      DO 20 I = 1,NATOMS
        CMX = ATMASS(I)*Q(3*I-2)+CMX
        CMY = ATMASS(I)*Q(3*I-1)+CMY
        CMZ = ATMASS(I)*Q(3*I)+CMZ
   20 MOLWT = MOLWT+ATMASS(I)
      IF (MOLWT.LT.1.0D-8) THEN
         WRITE(LUOUT,*) '@SYMMETRY: No real atoms in Z-matrix.'
cYAU         CALL GFNAME(ARCFIL,FNAME,ILENGTH)
cYAU         OPEN(UNIT=LUARC,File=fname(1:ilength),STATUS='OLD')
cYAU         CLOSE(UNIT=LUARC,STATUS='DELETE')
         CALL ERREX
      END IF
      CM(1) = CMX/MOLWT
      CM(2) = CMY/MOLWT
      CM(3) = CMZ/MOLWT
      DO 30 I = 1,NATOMS
        DO 301 J = 0,2
          Q(3*I-J) = Q(3*I-J)-CM(3-J)
  301   continue
   30 continue
#ifdef _DEBUG_LVL0
      Write(6,*), "The Cartesians in center of mass coords"
      Write(6, "(3F12.7)"), (Q(I), I=1, 3*NATOMS)
      Write(6,*)
#endif     
      IF(IPRNT .GE. 4 .AND. NOSILENT)WRITE(LUOUT,*)
     &     'After translation to center of mass coordinates '
      IF(IPRNT .GE. 4 .AND. NOSILENT)WRITE(LUOUT,80)(Q(I),I = 1,NX)
   80 FORMAT((4X,3(2X,F16.12)))
c
cjdw 5/26/95
c
      IF (IPRNT .GE. 4 .AND. NOSILENT) THEN
      write(6,*)
      write(6,*) ' @symmetry-i, Coordinates after  COM shift '
      do 1010 i=1,natoms
        write(6,'(3F20.12)') q(3*i-2),q(3*i-1),q(3*i)
 1010 continue
      write(6,*)
      ENDIF
C
C     BUILD INERTIA TENSOR
C
      CALL INERTIA(IT, NOSILENT)
      IF(IPRNT .GE. 4 .AND. NOSILENT)WRITE(LUOUT,*)'Inertia tensor:'
      IF(IPRNT .GE. 4 .AND. NOSILENT)WRITE(LUOUT,80)((IT(I,J),J = 1,3),
     &                               I = 1,3)
C
C DIAGONALIZE INERTIA TENSOR.
C
      CALL FILTER(IT,9,1.D-12)
      CALL EIG(IT,IV,3,3,0)
      CALL XDCOPY(9,IV,1,ORIEN2,1)
C
C CHECK *NOW* FOR DEGENERACY OF EIGENVALUES -- IF PRESENT, THEN SEE IF
C  UNIQUE MOMENT OF INERTIA IS ALONG X.  IF SO, CHANGE THIS AXIS TO Z
C  BY ROTATING THE EIGENVECTOR MATRIX ABOUT Y.  THIS GUARANTEES THAT
C  THE UNIQUE AXIS WILL LIE ALONG Z.
C
      ABSDIF=ABS(IT(2,2)-IT(3,3))
      Z=ABS(MAX(IT(2,2),IT(3,3)))
      IF(Z.NE.0.0)THEN
        RELDIF=ABSDIF/Z
      ELSE
        RELDIF=0.0
      ENDIF
      IF(RELDIF.LT.DEGTOL)THEN
        RANG=90.D0
        CALL ROTM(2,RANG,1,RM)
        CALL MODMATMUL(IV,IV,RM,3,3,3,3,3,3)
        ATMP=IT(1,1)
        IT(1,1)=IT(3,3)
        IT(3,3)=ATMP
      ENDIF

CJDW 1/6/98. Replace MATMULV by XGEMM call. NEWQ = (IV)^T * Q.
C     CALL MATMULV(NEWQ,Q,IV,NATOMS,3,3)
      CALL XGEMM('T','N',3,NATOMS,3,ONE,IV,3,Q,3,ZILCH,NEWQ,3)
      IF(IPRNT .GE. 4 .AND. NOSILENT)THEN
        WRITE(LUOUT,*)'   Diagonalized inertia tensor:'
        WRITE(LUOUT,80)((IT(I,J),J = 1,3),I = 1,3)
        WRITE(LUOUT,*)'   Eigenvectors of inertia tensor: '
        WRITE(LUOUT,80)((Iv(I,J),J = 1,3),I = 1,3)
        WRITE (LUOUT,*) '   Principal axis orientation ',
     $       'for molecular system: '
        WRITE (LUOUT,80) (NEWQ(I),I = 1,NX)
      ENDIF
C
C     Print out the rotational constants from the inertia
C
#ifdef _DEBUG_LVL1
      Print*, "Rotational constant computation"
#endif
      Call RotCon (IT, 1, IErr, NOSILENT)
C
C CHECK HANDEDNESS OF INERTIAL AXES AND SWAP IF NECESSARY.  DETERMINANT
C   HAS TO BE UNITY.
C
      CALL CROSS(IV(1,1),IV(1,2),TATB,1)
      XXX=xdot(3,TATB,1,IV(1,3),1)
      IF(IPRNT.GE.4 .AND. NOSILENT)THEN
        WRITE(LUOUT,3143)XXX
 3143   FORMAT(T3,'@SYMMETRY-I, Handedness of inertial frame:',F8.5)
      ENDIF
      IF(XXX.LT.0.D0)THEN
        IF(IPRNT.GE.4 .AND. NOSILENT)WRITE(LUOUT,3142)
 3142   FORMAT(T3,'@SYMMETRY-I, Sense of inertial frame ',
     &       'y-axis will be changed.')
        DO 1451 I=2,NX-1,3
 1451   NEWQ(I)=-NEWQ(I)
      ENDIF
C
C First, check the degeneracies if the inertia matrix to identify 
C whether we have a degenracy in the inertia matrix. When there
C is no degenaracy, we know immediately that the molecule has 
C abelian point group (see symmetry_auto for symmetry processing). 
C Also, we can assess the linearity by looking at the diagonal of
C the moments of inertia matrix.
C
         ILINEAR = 0
         NP1  = NATOMS+1
         JAX  = NX+1
         JAX2 = NX+JAX
         X    = ONEM
         DO I = 1, 3
            Z      = IT(I,I)
            ABSDIF = ABS(Z-X)
            Z0     = ABS(MAX(X,Z))
            IF (Z0.LT.1.0D-14) THEN
               IF (ABSDIF.LT.1.0D-14) THEN
                  RELDIF=0.0D0
               ELSE
                  RELDIF=1.0D0
               END IF
            ELSE
               RELDIF=ABSDIF/Z0
            END IF
            IF (RELDIF.LT.DEGTOL) IDEGEN = IDEGEN + 1
            X = Z
            IF (DABS(IT(I,I)).LT.SYMTOL) ILINEAR=1
         END DO

         IF (IPRNT.GE.4 .AND. NOSILENT) WRITE(6,3146) IDEGEN+1
 3146    FORMAT(T3,'@SYMMETRY-I, The symmetry group is ',i1,'-fold ',
     &          'degenerate.')
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The symmetry processing begins"
#endif

      IF (IFLAGS(h_IFLAGS_symmetry).EQ.0) THEN
#ifdef _DEBUG_LVL0
      Print*, "The symmetry is not used for anything"
      Write(6,*)
#endif
C        
C Undo the rotation and translation
C 
CSSS      CALL XGEMM('N','N',3,NATOMS,3,ONE,IV,3,NEWQ,3,ZILCH,Q,3)
CSSS      DO I = 1,NATOMS
CSSS         DO J = 0,2
CSSS            Q(3*I-J) = Q(3*I-J)+ CM(3-J)
CSSS         ENDDO
CSSS      ENDDO
#ifdef _DEBUG_LVL0
      Print*, "The Cartesians wrt CM origin"
      Write(6, "(3F10.5)"), (Q(I), I=1, 3*NATOMS)
      Write(6,*)
#endif   
c
C The user does not want to use symmetry. Therefore, skip
C all symmetry-related work beside automatically setting the
C full point group, computational point, and largest abelian subgroup.
C (all are C1). Let's re-orient the molecule to the principal
C axis coordinate system unless the user specificaly says NO.
C
         FPGRP = "C1  "
         PGRP  = "C1  "
         BPGRP = "C1  "
         DO I = 1, 3
            ORIENT(I,I) = ONE
         END DO
         CALL DCOPY(9, ORIEN2, 1, SCRATCH, 1)
C
C Since under this condition no call are made to SYMDRV.F, so all
C the JOBACR records that are created by FLUSH.F (call by SYMDRV.F)
C recorded. The content of these records can be trivialy generated
C for SYM=NONE (same as SYM=C1). 
C 
C Note that increasing the length of records COMPPERM, FULLPERM,
C FULLSYOP, COMPSYOP has no effect on ACESIII execution. This
C increase was needed to post ACES II run where full symmetry
C can be used to assign symmetry to eigenvectors, excited states etc. 
C 07/2013. Ajith Perera. 

         CALL IPUTREC(20,'JOBARC','LINEAR  ',IONE,ILINEAR)
         CALL IPUTREC(20,'JOBARC','FULLNORB',IONE,NATOMS)
         CALL IPUTREC(20,'JOBARC','COMPNORB',IONE,NATOMS)
C
         ISIZE=NATOMS
         iNdx = IONE
         do i = 1, iSize
             STSYM(i)  = 'C1      '
             MEMBER(i) = i
             szStSymTmp(iNdx:iNdx+7) = STSYM(i)(1:8)
           iNdx = iNdx + 8
         end do
         CALL PUTCREC(20,'JOBARC','FULLSTGP',iSize*8,
     &                szStSymTmp(1:iSize))
         CALL PUTCREC(20, 'JOBARC', 'FULLPTGP', 8, STSYM(1))
         CALL PUTCREC(20, 'JOBARC', 'COMPPTGP', 8, STSYM(1))
         CALL IPUTREC(20,'JOBARC','COMPMEMB',ISIZE,MEMBER)
         CALL IPUTREC(20,'JOBARC','FULLMEMB',ISIZE,MEMBER)
         CALL IPUTREC(20,'JOBARC','COMPPERM',ISIZE*8,MEMBER)
         CALL IPUTREC(20,'JOBARC','FULLPERM',ISIZE*8,MEMBER)

         DO i = 1, iSize
            MEMBER(i) = 1
         ENDDO

         CALL IPUTREC(20,'JOBARC','COMPPOPV',ISIZE,MEMBER) 
         CALL IPUTREC(20,'JOBARC','FULLPOPV',ISIZE,MEMBER) 
         CALL IPUTREC(20,'JOBARC','COMPNIRR',IONE,IONE)
         CALL IPUTREC(20,'JOBARC','FULLNIRR',IONE,IONE)
         CALL IPUTREC(20,'JOBARC','FULLORDR',IONE,IONE)
         CALL IPUTREC(20,'JOBARC','COMPORDR',IONE,IONE)
C
         CALL IDNMAT(RM,3,IJUNK)
         CALL DPUTREC(20,'JOBARC','FULLSYOP',ININE*8,RM) 
         CALL DPUTREC(20,'JOBARC','COMPSYOP',ININE*8,RM) 
C
         CALL IGETREC(-1, 'JOBARC', '12SWITCH', ione, ibad)

         II = 0
         DO I = 1, NATOMS
C
C Minor fix to get Symmetry=none to work with dummy atoms; 02/2012
C Ajith Perera
C
            IF (IATNUM(I) .EQ. 0) Then
               MEMBER(I) = 999
            ELSE
               II = II + 1
               MEMBER(I) = II
            ENDIF
         ENDDO

         IF (IBAD .EQ. 1) THEN
            MEMBER(2) = 1
            MEMBER(1) = 2
         ENDIF

         CALL IPUTREC(20,'JOBARC','ZMAT2MOL',ISIZE,MEMBER)
C
C Copy the principal axis orientation (NEWQ to Q) and print it.
C It will be put into JOBARC (see below). 
C
         IF (IFLAGS2(h_IFLAGS2_noreori).EQ.1) THEN
C
C Undo the rotation and translation, if xxx less than zero, then 
C Handedness of the inertial frame has changed and we must undo
C that before undo the principal axix rotation (See above). 
C
            IF (XXX .LT. 0.0D0) Then
               DO I=2,NX-1,3
                  NEWQ(I)=-NEWQ(I) 
               ENDDO
            ENDIF  
C
            CALL XGEMM('N','N',3,NATOMS,3,ONE,IV,3,NEWQ,3,ZILCH,Q,3)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The Cartesians after no-principal axis rot. "
      Write(6, "(3F10.5)"), (Q(I), I=1, 3*NATOMS)
#endif
            DO I = 1,NATOMS
               DO J = 0,2
                  Q(3*I-J) = Q(3*I-J)+ CM(3-J)
               ENDDO
            ENDDO
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The Cartesians after no-reorintation CM"
      Write(6, "(3F10.5)"), (Q(I), I=1, 3*NATOMS)
#endif
         ELSE
C
C When symmetry is none NOREORI is turned on by default and so
C in principle this block is inactive.
C 
            CALL DCOPY(3*nAtoms, NEWQ, 1, Q, 1)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The Cartesians used when sym=none,noreori=off"
      Write(6, "(3F10.5)"), (NEWQ(I), I=1, 3*NATOMS)
#endif
         END IF
C
         IF (IPRNT .GT. 4 .AND. NOSILENT) THEN
             WRITE(6,1040) 
 1040        FORMAT(/,' @SYMMETRY-I, ',
     &              'Cartesian coordinates (Bohr): ',/)
             do i = 1, natoms
                write(6,'(3F20.12)') q(3*i-2),q(3*i-1),q(3*i)
             end do
         ENDIF
        IF (NOSILENT) THEN
           WRITE(LUOUT,788)
           WRITE(LUOUT,789)
  789      FORMAT('The symmetry processing is fully turned',
     &            ' off and no symmetry opertion are',
     &            ' applied.')
           WRITE(LUOUT, *)
           WRITE(LUOUT,1881)FPGRP
 1881      FORMAT(T3,' The full molecular point group is ',a,'.')
           WRITE(LUOUT,177)BPGRP
           WRITE(LUOUT,712)PGRP
           WRITE(LUOUT,788)
           WRITE(LUOUT,*)
  788      FORMAT(80('*'))
  712      FORMAT(T3,' The computational point group is ',A,'.')
  177      FORMAT(T3,' The largest Abelian subgroup of the full ',
     $               'molecular point group is ',a,'.')
        ENDIF
C
      ELSE
C
#ifdef _DEBUG_LVL1
      Print*, "Entering the symmetry auto procedure"
#endif
#ifdef _NOSKIP
C
            CALL XGEMM('N','N',3,NATOMS,3,ONE,IV,3,NEWQ,3,ZILCH,
     &                     QOLD,3)
#ifdef _DEBUG_LVL0
      Print*, "The Cartesians before translations to CM:NO REORIENT"
      Print*, (QOLD(I), I=1, 3*NATOMS)
#endif
            DO I = 1,NATOMS
               DO J = 0,2
                  QOLD(3*I-J) = QOLD(3*I-J)+CM(3-J)
               ENDDO
            ENDDO
#endif
            CALL SYMMETRY_AUTO(SCRATCH, QTMP, NEWQ, IT, IDEGEN, 
     &                         ORIEN2, NOSILENT)
C
C All of the no reorientation stuff should be here. Two things can happen:
C molecule can be in principal axis orientation, or it could be in
C another orientation dictated by the point group of the molecule.
C
         IF (IFLAGS2(h_IFLAGS2_noreori).EQ.1) THEN
            IF (PGRP.EQ."C1  ") THEN
C
C Undo the rotation and translation, if xxx less than zero, then
C Handedness of the inertial frame has changed and we must undo
C that before undo the principal axix rotation (See above).
C
            IF (XXX .LT. 0.0D0) Then
               DO I=2,NX-1,3
                  NEWQ(I)=-NEWQ(I)
               ENDDO
            ENDIF

#ifdef _DEBUG_LVL0
      Write(6,*), "The Cartesians in the principal axis rotation ori."
      Write(6, "(3F12.7)"), (NEWQ(I), I=1, 3*NATOMS)                  
      Write(6,*)
      Write(6,*) "The transformation matrix"
      Write(6,"(3F12.7)")((Iv(I,J),J = 1,3),I = 1,3)
      Write(6,*)
#endif
C
C Reorientation is due to rotation of the principal axis.
C If no reorientation is requested, undo the rotation and translation. 
C
               CALL XGEMM('N','N',3,NATOMS,3,ONE,IV,3,NEWQ,3,ZILCH,
     &                     QTMP,3)
#ifdef _DEBUG_LVL0
      Write(6,*), "The Cartesians in center of mass coords"
      Write(6, "(3F12.7)"), (QTMP(J), J=1, 3*NATOMS)                  
      Write(6,*)
#endif
               DO I = 1,NATOMS
                  DO J = 0,2
                     QTMP(3*I-J) = QTMP(3*I-J)+CM(3-J)
                  ENDDO
               ENDDO
               CALL DPUTREC(20,'JOBARC','NOREOCOR',3*NATOMS,
     &                     QTMP)
               CALL DCOPY(3*NATOMS, QTMP, 1, Q, 1)

#ifdef _DEBUG_LVL0
      Write(6,*), "The Cartesians after undoing the sym. REORIENT"
      Write(6, "(3F12.7)"), (QTMP(J), J=1, 3*NATOMS)                  
#endif
C
            ELSE
C
C We can stop the reorientation (perhaps easily), but let's leave that
C for another round. I need to know something about the irrep
C labels in the rest of the code. Best thing to do is to do the
C calculation in the original geometry but leave the symmetry
C labeling to match with the rotated geometry.
C
               CALL DPUTREC(20,'JOBARC','NOREOCOR',3*NATOMS,
     &                     QOLD)

#ifdef _DEBUG_LVL0     
      Print*, "The Cartesians before translations to CM:NO REORIENT"
      Print*, (QOLD(I), I=1, 3*NATOMS)
#endif
C
            END IF
         END IF
C
C No reorientation is requested and the symmetry can be C1 or any
C othe point group. For those cases let it be that it always use
C center of mass/principal axis defined with respect to the moment of inertia 
C tensor as the base coordinate system. When there is symmetry, the
C molecule is oriented according to the standard group theory conventions.
C THE WORKING COORDINATES ARE IN THE ARRAY Q of the /COORD/ common block.
C NOTE THAT THE COORDS IN Q ARE ORIENTED ACCORDING TO GROUP THOERY CONVENTIONS
C AND THE ACTUAL PROCESS OF REORIENTING HAPPENS IN SYMMETRY_AUTO AND 
C SYMMETRY_AUTO IS CALLED FOR BOTH SYMMETRY{ON, OFF}.
C
      END IF
C
C DUMP SOME NECESSARIES TO JOBARC
C
      CALL DPUTREC(20,'JOBARC','ORIENT2 ',ININE,SCRATCH)
      CALL IPUTREC(20,'JOBARC','NATOMS  ',IONE,NATOMS)
      CALL DPUTREC(20,'JOBARC','COORD   ',3*NATOMS,Q)
      CALL DPUTREC(20,'JOBARC','ORIENTMT',ININE,ORIENT)
      CALL DPUTREC(20,'JOBARC','ATOMMASS',NATOMS,ATMASS)
      CALL PUTCREC(20, 'JOBARC', "PTGP    ", 4, FPGRP)
      CALL PUTCREC(20, 'JOBARC', "ABL_PTGP", 4, BPGRP)
      CALL PUTCREC(20, 'JOBARC', "CMP_PTGP", 4, PGRP) 
      call IGETREC(0,'JOBARC','ZSYM',iTmp,indx)
C
      if (iTmp.lt.0) then
c      o write the atom symbols to JOBARC
c        (currently, this is only used by `xa2proc xyz`)
         indx = 1
         do i = 1, NATOMS
            ZSYMUNI(indx:indx+4) = ZSYM(i)(1:5)
            indx = indx + 5
         end do
         CALL PUTCREC(1,'JOBARC','ZSYM',5*NATOMS,ZSYMUNI)
      end if
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE STDORT(VEC,SCRATCH,LEN,ICNTL)
C
C SUBROUTINE ROTATES MOLECULE TO THE PRINCIPAL AXIS ORIENTATION FOR
C  THE FULL MOLECULAR POINT GROUP.  ICNTL=0 ROTATES THE MOLECULE FROM
C  THE ACES2 ORIENTATION TO THE PAO, ANY OTHER VALUE ROTATES FROM THE
C  PAO TO ACES2 ORIENTATION.  LEN IS THE LENGTH OF THE VECTOR PASSED
C  IN.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "io_units.par"
      Common /Orient/ Orient(3,3)
      DIMENSION VEC(LEN),SCRATCH(LEN)
C
#ifdef _DEBUG_LVLM1
      Print*, "The orient in stdort", Orient 
#endif
c
      NTIMES=LEN/3
      IOK=0
      IF(MOD(LEN,3).NE.0)THEN
       WRITE(LUOUT,133)LEN
 133   FORMAT(T3,'@STDORT-F, Vector with strange length [',i6,'] passed'
     &' to STDORT.')
       Call ErrEx
      ENDIF
      DO 30 I=1,3
       DO 31 J=1,3
       IF(ABS(ORIENT(I,J)).GT.1.D-3)IOK=IOK+1
 31    CONTINUE
 30   CONTINUE
      IF(IOK.EQ.0)THEN
       WRITE(6,5432)
 5432 FORMAT(T3,'@STDORT-W, Orientation matrix is empty.  Unit ',
     &'matrix used.')
      DO 40 I=1,3
       ORIENT(I,I)=1.D0
 40   CONTINUE
      ENDIF
      CALL ZERO (SCRATCH,LEN)
      CALL VADD (SCRATCH,SCRATCH,VEC,LEN,1.D0)
      CALL ZERO (VEC,LEN)
      IF(ICNTL.EQ.0)CALL MTRAN2(ORIENT,3)
      CALL MODMATMUL(VEC,ORIENT,SCRATCH,3,3,NTIMES,3,3,NTIMES)
      IF(ICNTL.EQ.0)CALL MTRAN2(ORIENT,3)
      IF(IOK.EQ.0)CALL ZERO(ORIENT,9)
      RETURN
      END

      subroutine list_next_ele(str,ptr,ele,err)
      implicit none
      character*(*) str,ele
      integer ptr,err
      integer l,pos
      integer  strlen,ncindex
      external strlen,ncindex
      err=0
      l=strlen(str)
      ptr=max(ptr,0)
      ptr=min(ptr,l+1)
      if (ptr.eq.l+1) then
         err=-1
         ele=' '
         return
      end if
      pos=ncindex(str,',',ptr)
      if (pos.eq.0) then
         ele=str(ptr+1:l)
         ptr=l+1
      else
         ele=str(ptr+1:pos-1)
         ptr=pos
      end if
      return
      end

       SUBROUTINE SST03I(WIN,WOUT,NSIZIN,NSIZOT,ISCR,SPTYPE)
C
C THIS ROUTINE ANTISYMMETRIZES THE RING INCREMENT LIST FOR AA AND BB
C   SPIN CASES. 
C
C THE INCREMENT LIST (A,J;B,I) IS PRESUMED TO BE PACKED AJ-BI.  THIS 
C   ROUTINE RETURNS THE ANTISYMMETRIZED INCREMENT LIST AS (A<B;I<J) PACKED
C   AS AB-IJ.  THIS ROUTINE FUNCTIONS AS THE INVERSE OF ROUTINE SST
C   THE LIST AS (A<B;I<J) PACKED AS AB-IJ.  
C
C *** IMPORTANT *** : THE SPACE ALLOCATED FOR BOTH WIN AND WOUT IN THE
C                     CALLING ROUTINE MUST BE EQUAL TO THE SIZE OF
C                     *WIN*
C
C INPUT: 
C           WIN  - THE SYMMETRY PACKED AB-IJ LIST.
C         NSIZIN - THE TOTAL SIZE OF THE SYM. PACKED INPUT VECTOR.
C         NSIZOT - THE TOTAL SIZE OF THE SYM. PACKED OUTPUT VECTOR.
C         SPTYPE - THE SPIN TYPE FOR THE INPUT LIST
C
C                        'AAAA' FOR (AJ-BI)
C                        'BBBB' FOR (aj-bi)
C
C OUTPUT: 
C          WOUT  - THE SYMMETRY PACKED A<B-I<J OR a<b-i<j LIST.
C       
C SCRATCH:
C         ISCR   - SCRATCH AREA TO HOLD THE SYMMETRY VECTORS AND INVERSE
C                   SYMMETRY VECTORS WHICH ARE NEEDED. 
C                   (SIZE: NVRT*(NVRT-1)/2+NOCC*(NOCC-1)/2+NOCC*NVRT)
C         
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*4 REORTP,SPTYPE,RERDTP
      DOUBLE PRECISION WIN(NSIZIN),WOUT(NSIZOT),ISCR(*)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYMINF/NSTART,NIRREP,IRREP0(255,2),DIRPRD(8,8)
      COMMON/SYMPOP/IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
C
      IRREPX=1
C
      IF(SPTYPE.EQ.'AAAA')THEN
       ISPIN=1
      ELSEIF(SPTYPE.EQ.'BBBB')THEN
       ISPIN=2
      ELSE
       WRITE(6,1000)SPTYPE
1000   FORMAT(T3,'@SST03I-F, Unknown spin type ',A4,' passed in.')
       CALL ERREX
      ENDIF
C
      CALL SSTGEN(WIN,WOUT,NSIZIN,VRT(1,ISPIN),POP(1,ISPIN),
     &            VRT(1,ISPIN),POP(1,ISPIN),ISCR,IRREPX,'1324')
C
C ANTISYMMETRIZE AND COMPRESS TO A<B,I<J
C
      IOFFT=1
      IOFFF=1
      DO 10 IRREPR=1,NIRREP
       IRREPL=DIRPRD(IRREPR,IRREPX)
       DISSZT=IRPDPD(IRREPL,ISPIN)
       NUMDST=IRPDPD(IRREPR,2+ISPIN)
       DISSZF=IRPDPD(IRREPL,18+ISPIN)
       NUMDSF=IRPDPD(IRREPR,20+ISPIN)
       CALL ASSYM2(IRREPR,POP(1,ISPIN),DISSZF,WOUT(IOFFF))
       CALL TRANSP(WOUT(IOFFF),WIN,NUMDST,DISSZF)
       CALL ASSYM2(IRREPL,VRT(1,ISPIN),NUMDST,WIN)
       CALL TRANSP(WIN,WOUT(IOFFT),DISSZT,NUMDST)
       IOFFF=IOFFF+NUMDSF*DISSZF
       IOFFT=IOFFT+NUMDST*DISSZT
10    CONTINUE
C
      RETURN
      END

      SUBROUTINE NHFENG(ICORE,MAXCOR,ETOT,NLIST2,NLIST1,NLIST1A,IUHF,
     &                  DOTAU)
C
C  DRIVER FOR THE CALCULATION OF THE CORRELATION ENERGY FOR A GIVEN SET
C  OF AMPLITUDES WHICH IS USED IN ROHF PERTURBATION THEORY CALCULATIONS
C 
C  ARGUMENTS :  ICORE ..... ICORE ARRAY
C               MAXCOR .... DIMENSION OF ICORE
C               NLIST2 .... OFFSET OF T2 LIST ON MOINTS (WITH RESPECT TO
C                            TYPE)
C               NLIST1 .... OFFSET OF T1 LISTS ON MOINTS (WITH RESPECT TO
C                            SPIN TYPE) FOR F-T1 PIECE
C               NLIST1 .... OFFSET OF T1 LISTS ON MOINTS (WITH RESPECT TO
C                            SPIN TYPE) FOR W-T1**2 PIECE
C               TECORR ..... RETURNS THE CORRELATION ENERGY FOR ALL SPIN CASES
C               IUHF .....  IUHF FLAG
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL TAU,NONHF,DOTAU
      LOGICAL MBPT3,MBPT4,CC,TRPEND,SNGEND,GRAD,MBPTT,SING1 
      CHARACTER*2 SPCASE(3)
      DOUBLE PRECISION E,ETOT,FACTOR,ECORR(3),ESPIN,ET2,ETOTT2,
     &                 ESING,SDOT
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SWITCH/ MBPT3,MBPT4,CC,TRPEND,SNGEND,GRAD,MBPTT,SING1,
     &                QCISD
      COMMON /NHFREF/NONHF
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
C
      DIMENSION I0T(2),I0F(2)
C
      EQUIVALENCE (IFLAGS(2),METHOD)
C
      DATA SPCASE /'AA','BB','AB'/
C
      MXCOR=MAXCOR
C
C   ALLOCATE MEMORY FOR T1 AMPLITUDES
C
      I0T(1)=MXCOR+1-NT(1)*IINTFP
      MXCOR=MXCOR-NT(1)*IINTFP
      CALL GETLST(ICORE(I0T(1)),1,1,1,1+NLIST1,90)
      IF(IUHF.EQ.0) THEN
       I0T(2)=I0T(1)
      ELSE
       I0T(2)=I0T(1)-NT(2)*IINTFP
       MXCOR=MXCOR-NT(2)*IINTFP
       CALL GETLST(ICORE(I0T(2)),1,1,1,2+NLIST1,90)
      ENDIF
C
C   ALLOCATE MEMORY FOR f(a,I)
C
      I0F(1)=I0T(2)-NT(1)*IINTFP
      MXCOR=MXCOR-NT(1)*IINTFP
      CALL GETLST(ICORE(I0F(1)),1,1,1,3,93)
      IF(IUHF.EQ.0) THEN  
       I0F(2)=I0F(1)
      ELSE
       I0F(2)=I0F(1)-NT(2)*IINTFP
       MXCOR=MXCOR-NT(2)*IINTFP
       CALL GETLST(ICORE(I0F(2)),1,1,1,4,93)
      ENDIF
C
      ET1F=0.0
      ET2W=0.0
      ET12W=0.0
      ETOT=0.D0
      ETOTT2=0.D0
      FACTOR=1.D0
      IF(IUHF.EQ.0)FACTOR=2.D0
      DO 10 ISPIN=1,IUHF+1
       LISTT=43+ISPIN
       ESPIN=0.D0
C
C  COMPUTE THE F-T1 PIECE
C
       ESING=SDOT(NT(ISPIN),ICORE(I0T(ISPIN)),1,ICORE(I0F(ISPIN)),1)
       ESPIN=ESPIN+ESING
       ETOT=ETOT+FACTOR*ESING
       ETOTT2=ETOTT2+FACTOR*ESING
       ET1F=ET1F+ESING
C
C  COMPUTE THE TAU-W PIECE WITH AN APPROPRIATE TAU
C
       DO 100 IRREP=1,NIRREP
        DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
        NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
        IF(MIN(NUMSYT,DISSYT).NE.0) THEN
        I001=1
        I002=I001+IINTFP*NUMSYT*DISSYT
        I003=I002+IINTFP*NUMSYT*DISSYT
        I004=I003+NUMSYT
        IF(DOTAU)THEN
         CALL GETLST(ICORE(I0T(ISPIN)),1,1,1,ISPIN+NLIST1A,90)
        ELSE
         CALL IZERO(ICORE(I0T(ISPIN)),NT(ISPIN)*IINTFP)
        ENDIF 
        IF(I004.LT.MXCOR) THEN
         CALL TENER(NLIST2,ET2,E,NUMSYT,DISSYT,ICORE(I001),
     &             ICORE(I002),ICORE(I0T(ISPIN)),ICORE(I0T(ISPIN)),
     &             ISPIN,DOTAU,IRREP,POP(1,ISPIN),POP(1,ISPIN),
     &             VRT(1,ISPIN),VRT(1,ISPIN),ICORE(I003))
        ELSE
         CALL INSMEM('CMPENG',I004,MXCOR)
        ENDIF
        ETOTT2=ETOTT2+FACTOR*ET2
        ETOT=ETOT+FACTOR*E
        ESPIN=ESPIN+E
        ENDIF
100    CONTINUE
       ECORR(ISPIN)=ESPIN
10    CONTINUE
C
C  THE TAU(Ij,Ab) <Ij//Ab> CONTRIBUTION TO THE ENERGY (SPIN CASE AB)
C
      ESPIN=0.D0
      DO 200 IRREP=1,NIRREP
       DISSYT=IRPDPD(IRREP,ISYTYP(1,46))
       NUMSYT=IRPDPD(IRREP,ISYTYP(2,46))
       IF(MIN(NUMSYT,DISSYT).NE.0) THEN
        I001=1
        I002=I001+IINTFP*NUMSYT*DISSYT
        I003=I002+IINTFP*NUMSYT*DISSYT
        I004=I003+NUMSYT
        IF(DOTAU)THEN
         CALL GETLST(ICORE(I0T(1)),1,1,1,1+NLIST1A,90)
         CALL GETLST(ICORE(I0T(2)),1,1,1,2+NLIST1A,90)
        ELSE
         CALL IZERO(ICORE(I0T(1)),NT(1))
         CALL IZERO(ICORE(I0T(2)),NT(2))
        ENDIF 
        IF(I004.LT.MXCOR) THEN
         CALL TENER(NLIST2,ET2,E,NUMSYT,DISSYT,ICORE(I001),
     &              ICORE(I002),ICORE(I0T(1)),ICORE(I0T(2)),3,DOTAU,
     &              IRREP,POP(1,1),POP(1,2),VRT(1,1),VRT(1,2),
     &              ICORE(I003))
        ELSE
         CALL INSMEM('CMPENG',I004,MXCOR)
        ENDIF
        ETOTT2=ETOTT2+ET2
        ETOT=ETOT+E
        ESPIN=ESPIN+E
       ENDIF
200   CONTINUE
      ECORR(3)=ESPIN
      WRITE(*,81)ETOT
81    FORMAT(T3,' The total correlation energy is ',F15.12,' a.u.')
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ENTRY(BasNam, We_havegeom, Can_do_freq)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      character*(*) BasNam

      CHARACTER*10 TRASH
#include "fnamelen.par"
#include "flags.h"
      CHARACTER*(fnamelen) FNAME
      LOGICAL OLDARC,XYZIN,NWFINDIF,YESNO,IGNORE,OPTRES,
     &        We_havegeom, Can_do_freq
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      COMMON/RESTART_COM/IGNORE
      COMMON/RESTART2/OPTRES
C 
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
#include "io_units.par"
C From COMMON:
C     USINT:  IARCH, NCYCLE, NX
C     LUINTS:  Archive unit & name, Abinitio unit & name
C
      Call igetrec(0, 'JOBARC', 'HESSIANM', Length, Scr)
C
C If analytical hessians are available and the Hessian is on 
C the disk we can transfer the logic to simply print out the
C frequencies.
C
      If (Length .GT. 0) Then
         CALL GTFLGS(0,IERR,IPRNT1,INR,ICONTL,IVEC,IDIE,
     &               ICURVY,ISTCRT,IMXSTP,IVIB,  IRECAL,
     &               INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,
     &               IBASIS,IDFGHI,
     &               BasNam)
          If (IVIB .EQ. 1) Then
              Iarch = 1
              Call igetrec(20, 'JOBARC', 'NREALATM', 1, NATOMS)
              Call igetrec(20, 'JOBARC', 'LINEAR  ', 1, ILINEAR)
             If (ILINEAR .EQ. 1) Then
                 NX   = 3*NATOMS
                 NXM6 = NX - 5
             Else
                 NX   = 3*NATOMS
                 NXM6 = NX -6
             Endif
           Endif
           Can_do_freq = (IVIB .GT. 0 .AND. We_havegeom)
           If (Can_do_freq) Then
               Return
           Endif
      Endif

C See if there is an existing archive file
C
      CALL GFNAME(ARCFIL,FNAME,ILENGTH)
      INQUIRE (FILE=FNAME(1:ILENGTH), EXIST=OLDARC)

#ifdef _DEBUG_LVL0
      Print*, "The OPTARC is here?", OLDARC, We_havegeom 
      Print*, "Do we have geom?", We_havegeom
      Print*, "Hessian in JOBARC?", Length
#endif
C
      IF (OLDARC .AND. We_havegeom) Then
C
C This is where prepartion are made to read the optimized geometry. 
C The OPTARC has the final optimized geometry (written by summary.F) 
C and it is read by retrive.F (in geopt) and prepare for the 
C vibrational frequency calculation.
C

         Call igetrec(20, 'JOBARC', 'NREALATM', 1, NATOMS)
         Call igetrec(20, 'JOBARC', 'LINEAR  ', 1, ILINEAR)
         CALL GTFLGS(0,IERR,
     &               IPRNT1,INR,   ICONTL,IVEC,  IDIE,
     &               ICURVY,ISTCRT,IMXSTP,IVIB,  IRECAL,
     &               INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,
     &               IBASIS,IDFGHI,
     &               BasNam)
         IF (ILINEAR .EQ. 1) Then
             NX   = 3*NATOMS
             NXM6 = NX - 5
         ELSE
             NX   = 3*NATOMS
             NXM6 = NX -6 
         ENDIF
         Return
      Endif
C
      IF (OLDARC) THEN
C
C This block is executed during a geometry optimization.
C
         OPEN (LUARC,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
     &         STATUS='OLD')
         REWIND (LUARC)
C Read until the last recorded cycle

 10      READ (LUARC, END=20) TRASH, IARCH, NCYCLE, NJUNK, NX, NUNIQUE,
     $      NOPT, IPRNT, INR, IVEC, IDIE, IMXSTP, ISTCRT , IVIB ,
     &      ICURVY, ICONTL, IRECAL, INTTYP, IDISFD, IGRDFD, ICNTYP
     &      ISYM, IBASIS
         IF (ICONTL.EQ.0) ICONTL=4
         GOTO 10
 20      CONTINUE
         Close (LuArc, Status='KEEP')
C
C This is a continuation, so set bit indicating existance of
C the archive file. The iarch is tested in geopt to switch the
C the geometry optimization block
C
              idump = 0
              iarch = 1
             itmp   = iflags(18)
         iflags(18) = mod(itmp,100)
         IF (IVIB.NE.0.OR.
     &       IFLAGS(18).EQ. 3.OR.         ! NMR
     &       IFLAGS(18).EQ. 8.OR.         ! J_SO
     &       IFLAGS(18).EQ. 9.OR.         ! J_FC
     &       IFLAGS(18).EQ.10.OR.         ! J_SD
     &       IFLAGS(18).EQ. 4.OR.         ! NMR_SWTCH
     &       IFLAGS(18).EQ. 5    )THEN    ! CONVENTIONAL
            CALL GTFLGS(0,IERR,
     &                  IPRNT1,INR,   ICONTL,IVEC,  IDIE,
     &                  ICURVY,ISTCRT,IMXSTP,IVIB,  IRECAL,
     &                  INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,
     &                  IBASIS,IDFGHI,
     &                  BasNam)
                  itmp = iflags(18)
            iflags(18) = mod(itmp,100)
            XYZIN      = (IFLAGS(68).EQ.1)
         END IF
C
         iflags(18)=itmp
C
C Else for the (IF OLDARC)
C
      ELSE
C
         CALL igetrec(1,'JOBARC','FIRSTRUN',1,iDump)
C
         INQUIRE(FILE=ZFIL,EXIST=YESNO)
         IF (.NOT.YESNO) THEN
            WRITE(LUOUT,9003)
 9003       FORMAT(T3,'@ENTRY-F, ZMAT file not present.')
            CALL ERREX
         END IF
C
C Endif for The IF (OLDARC)
C 
      END IF
C
C This statement is executed pratically all situations except 
C in the case Freq. followed by an optimizations in which case
c the control is transfered to the first block (see above).
C
      CALL GTFLGS(IDUMP,IERR,IPRNT,INR,ICONTL,IVEC,IDIE,ICURVY,ISTCRT,
     &IMXSTP,IVIB,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     &IDFGHI,BasNam)

      OPTRES = OLDARC.AND.(.NOT.IGNORE)
C
      IF (OPTRES) THEN
         WRITE(LUOUT,9009) NCYCLE
 9009    FORMAT(T3,' JODA restarting optimization with cycle #',I3,'.')
      END IF
C
             itmp = iflags(18)
      iflags(18)  = mod(itmp,100)
      Can_do_freq = (IVIB .GT. 0 .AND. We_havegeom) 
C
      IF((.NOT. Can_do_freq ) .AND.IFLAGS(18).NE.3.
     &   AND.IFLAGS(18).NE.8.AND.IFLAGS(18).NE.9.
     &   AND.IFLAGS(18).NE.10.AND.IFLAGS2(3).NE.1.
     &   AND.IFLAGS(18).NE.4.AND.IFLAGS(18).NE.5.AND.OLDARC)THEN
C
       IF(.NOT.OPTRES) WRITE(LUOUT, 9010) NCYCLE+1
       IF(.NOT.OPTRES) WRITE(66, 9100) NCYCLE+1
C
      ENDIF
C
      iflags(18) = itmp
C
9010  FORMAT (T3,' JODA beginning optimization cycle #', I3,'.')
9100  FORMAT (T3,' Finished optimization cycle #', I3,'.')

      RETURN
      END

c This routine sorts columns according to a source vector:
c    dA(1:nRows,i) = dA(1:nRows,iFromNdx(i))
c
c On output, iFromNdx(i) will contain the same values but negated.
c Observe the iFromNdx values:
c      INPUT       OUTPUT
c    (1,2,3,4)  (-1,-2,-3,-4) : identity operation
c    (1,3,2,4)  (-1,-3,-2,-4) : 2x2 ket transpose
c    (2,3,4,1)  (-2,-3,-4,-1) : left  circular shift by one column
c    (4,1,2,3)  (-4,-1,-2,-3) : right circular shift by one column
c
c If iFromNdx(i) is zero, then the routine will not attempt to replace
c column i. There are ways to hack the inner workings using iFromNdx,
c but the safest type of sort is a 1-to-1 and onto mapping. These
c should always succede.
c
c The purpose of returning iFromNdx as a negative iToNdx vector is that
c the sort can be undone with sort_cols_to_index after negating
c the values.

c INPUT:
c int nRows = number of rows to move per column
c int nCols = number of columns/entries in dA/iFromNdx
c int lda   = number of rows in dA
c
c INPUT/OUTPUT:
c double dA(lda,nCols) = data to sort
c int iFromNdx(nCols)  = vector of source indices
c
c OUTPUT:
c double dBuf(nRows) = scratch buffer
c int iErr = return code
c            <0 -> problem with input arguments
c            =0 -> sort successful
c            >0 -> base column when an error is encountered

      subroutine sort_cols_from_index(nRows,nCols,dA,lda,dBuf,
     &                                iFromNdx,iErr)
      implicit none

c   o ARGUMENTS
      integer nRows, nCols, lda, iErr
      double precision dA(lda,nCols), dBuf(nRows)
      integer iFromNdx(nCols)

c   o VARIABLES
      integer i, pStart, iOpen
      logical bNotDone, bTrace, bVerbose
      data bTrace/.false./, bVerbose/.false./

c ----------------------------------------------------------------------


      if (lda.lt.nRows) then
         print *, '@SORT_COLS_FROM_INDEX: Assertion failed.'
         print *, '                       nRows = ',nRows
         print *, '                       lda   = ',lda
         iErr = -1
         return
      end if


      iErr = 0
      if (nRows.lt.1.or.nCols.lt.1) return

      if (bVerbose) print *, 'iFromNdx=',(iFromNdx(i),i=1,nCols)
      pStart = 1
      do while (iFromNdx(pStart).le.0.and.pStart.le.nCols)
         pStart = pStart + 1
      end do
      do while (pStart.le.nCols)
         if (bVerbose) print *, 'DEBUG: new pStart = ',pStart
         if (bVerbose) print *, 'DEBUG: ',pStart,' <- ',iFromNdx(pStart)

c      o this column must be replaced
         if (pStart.ne.iFromNdx(pStart)) then

c         o copy column pStart into buffer
            if (bTrace) print *, 'DEBUG: cp ',pStart,' buffer'
            call xcopy(nRows,dA(1,pStart),1,dBuf,1)
            iOpen = pStart
            bNotDone = .true.

            do while (bNotDone)
            if (iFromNdx(iOpen).ne.pStart) then

               if (iFromNdx(iOpen).lt.1.or.
     &             iFromNdx(iOpen).gt.nCols) then
c               o read out of bounds
                  print *, '@SORT_COLS_FROM_INDEX: read out of bounds'
                  print *, ' Column ',iOpen,' wants ',iFromNdx(iOpen),
     &                     ' out of ',nCols,' columns'
                  iErr = pStart
                  return
               end if

c            o replace the column
               if (bTrace) print *, 'DEBUG: cp ',iFromNdx(iOpen),iOpen
               call xcopy(nRows,dA(1,iFromNdx(iOpen)),1,dA(1,iOpen),1)
               iFromNdx(iOpen) = -iFromNdx(iOpen)
               iOpen = -iFromNdx(iOpen)

c           else if (iFromNdx(iOpen).eq.pStart) then
            else

               if (bTrace) print *, 'DEBUG: cp buffer',iOpen
               call xcopy(nRows,dBuf,1,dA(1,iOpen),1)
               iFromNdx(iOpen) = -iFromNdx(iOpen)
               bNotDone = .false.

c           end if (iFromNdx(iOpen).ne.pStart)
            end if
               if (bVerbose) print *,'iFromNdx=',(iFromNdx(i),i=1,nCols)
c           end do while (bNotDone)
            end do

c        end if (pStart.ne.iFromNdx(pStart))
         end if

c      o mark the replacement
         iFromNdx(pStart) = -abs(iFromNdx(pStart))
         if (bVerbose) print *, 'iFromNdx=',(iFromNdx(i),i=1,nCols)

c      o find the next column to replace
         do while (iFromNdx(pStart).le.0.and.pStart.le.nCols)
            pStart = pStart + 1
         end do

c     end do while (pStart.le.nCols)
      end do

      return
c     end subroutine sort_cols_from_index
      end

      SUBROUTINE T1RB01(ICORE,MAXCOR,IUHF,LAMBDA)
C
C THIS SUBROUTINE COMPUTES TWO T1*W CONTRIBUTIONS TO THE
C  W(mbej) INTERMEDIATE.  
C
C     W(mBEj) =  SUM T(j,f) * <fE|mB> - SUM T(N,B) * <mN|jE>
C     W(MbeJ) =  SUM T(J,F) * <Fe|Mb> - SUM T(n,b) * <Mn|Je> (UHF only)
C
C ALSO COMPUTE ONE OF THE CONTRIBUTIONS TO THE F(ea) INTERMEDIATE:
C
C     F(EA)   = SUM T(m,f) * <fE|mA> 
C     F(EA)   = SUM T(M,F) * <Fe|Ma>  (UHF only)
C
C BY TAKING A GENERALIZED TRACE OVER THE FIRST TERM IN THE FIRST TWO EQUATIONS
C  ABOVE.
C
C THIS ROUTINE USES IN-CORE ALGORITHMS
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL LAMBDA
      DOUBLE PRECISION ONE,ONEM,ZILCH,ALPHA,BETA,FACTOR
      CHARACTER*4 SSTSPN(2)
      LOGICAL RHF
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2),SIZEVV(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,
     &             NF1BB,NF2BB
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
      DATA SSTSPN /'ABAB','BABA'/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
C
C FIRST PICK UP T1 VECTOR.
C
      CALL GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
      RHF=.FALSE.
      IF(IUHF.EQ.0)RHF=.TRUE.
      LSTFEA=92
C
C COMPUTE SIZES OF A FULL VV DISTRIBUTION WHICH TRANSFORMS AS THE
C  TOTALLY SYMMETRIC REP.
C
      CALL IZERO(SIZEVV,2)
      DO 3000 ISPIN=1,2
       DO 3001 IRREP=1,NIRREP
        SIZEVV(ISPIN)=SIZEVV(ISPIN)+VRT(IRREP,ISPIN)*VRT(IRREP,ISPIN)
3001   CONTINUE
3000  CONTINUE

C
C SPIN CASES BAAB AND ABBA, RESPECTIVELY.
C
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=57+ISPIN
       IF(LAMBDA)THEN
        LSTOUT=124+ISPIN
        FACTOR=ONEM
       ELSE
        LSTOUT=LSTTAR
        FACTOR=ONE
       ENDIF
C
C LOOP OVER IRREPS - IN THE FIRST BLOCK OF CODE THIS CORRESPONDS TO mB,
C                    WHILE IT IS jE IN THE SECOND BLOCK.
C
C
       DO 20 IRREPDO=1,NIRREP
C
C COMPUTE DIMENSIONS OF TARGET MATRIX.
C
        DISTAR=aces_list_cols(IRREPDO,LSTTAR)
        DSZTAR=aces_list_rows(IRREPDO,LSTTAR)
        TARSIZ=DISTAR*DSZTAR
C
C FIRST DO  W(mBEj) =   SUM T(j,f) * <Ef|Bm>  
C           W(MbeJ) =   SUM T(J,F) * <Fe|Mb>  (UHF only)
C
C THIS PRODUCT IS INITIALLY PACKED Bm-Ej [Mb-eJ].
C
        ALPHA=ONE*FACTOR
        BETA=ONE
        LISTW1=31-ISPIN
        DISW  =aces_list_cols(IRREPDO,LISTW1)
        DSZW  =aces_list_rows(IRREPDO,LISTW1)
        I000  =1
        I010  =I000+IINTFP*DISTAR*DSZTAR
        I020  =I010+IINTFP*DISW*DSZW
        I030  =I020+IINTFP*DSZW
        CALL IZERO(ICORE,IINTFP*DISTAR*DSZTAR)
C
C PICK UP THE INTEGRALS AND HOLD THEM IN A MATRIX I(Bm;Ef) [Mb;Fe].
C
        CALL GETTRN(ICORE(I010),ICORE(I020),DSZW,DISW,2,IRREPDO,
     &              LISTW1)
C
C CHANGE MEANINGS OF DSZ AND DIS AND TRANSPOSE KET INDICES OF
C   THE INTEGRALS IF ISPIN=2.  THIS GIVES
C
C               I(Bm;Ef) [ISPIN=1]
C               I(Mb,eF) [ISPIN=2]
C
        ITMP=DISW
        DISW=DSZW
        DSZW=ITMP
        IF(ISPIN.EQ.2)THEN
         I030=I020+IINTFP*DSZW
         I040=I030+IINTFP*DSZW
         I050=I040+IINTFP*DSZW
         CALL SYMTR1(IRREPDO,VRT(1,1),VRT(1,2),DSZW,
     &              ICORE(I010),ICORE(I020),ICORE(I030),
     &              ICORE(I040))
        ENDIF
C
C PERFORM PREAMBLE FOR THE MATRIX PRODUCT 
C
C      Z(Bm;Ej) = I(BmE;f) * T(f,j)
C      Z(Mb;eJ) = I(Mbe;F) * T(F,J)  
C
        IOFFI=I010
        IOFFZ=I000
        DO 100 IRREPF=1,NIRREP
         IRREPE=DIRPRD(IRREPF,IRREPDO)
         IRREPJ=IRREPF
         NROWI=DSZW*VRT(IRREPE,ISPIN) 
         NCOLI=VRT(IRREPF,3-ISPIN)
         NROWT=VRT(IRREPF,3-ISPIN)
         NCOLT=POP(IRREPF,3-ISPIN)
         NROWZ=NROWI
         NCOLZ=NCOLT
         IOFFT=IOFFT1(IRREPJ,3-ISPIN)
         IF(MIN(NROWI,NCOLT,NCOLI).GT.0)THEN
          CALL XGEMM('N','N',NROWZ,NCOLZ,NCOLI,ALPHA,ICORE(IOFFI),
     &               NROWI,ICORE(IOFFT),NROWT,BETA,ICORE(IOFFZ),
     &               NROWZ)
         ENDIF
         IOFFI=IOFFI+NROWI*NCOLI*IINTFP
         IOFFZ=IOFFZ+NROWZ*NCOLZ*IINTFP
100     CONTINUE
C
C NOW GET CONTRIBUTION TO THE F(EA) [F(ea)] INTERMEDIATE
C
        ABFULL=SIZEVV(ISPIN)
        I020=I010+ABFULL*IINTFP
        I030=I020+ABFULL*IINTFP
        IF(.NOT.LAMBDA) THEN
         IF(ISPIN.EQ.1)THEN
          CALL TRACEOO('VOVO',IRREPDO,POP(1,2),VRT(1,1),
     &                  DISTAR,ABFULL,ICORE(I000),ICORE(I010))
         ELSE
          CALL TRACEOO('OVVO',IRREPDO,POP(1,1),VRT(1,2),
     &                  DISTAR,ABFULL,ICORE(I000),ICORE(I010))
         ENDIF
         CALL SUMSYM3(ICORE(I010),ICORE(I020),ABFULL,1,ISPIN,LSTFEA)
        ENDIF
C
C THE CODE ABOVE PRODUCES mbej INTERMEDIATES IN THE ORDER:
C
C                   Bm-Ej (ISPIN=1)
C                   Mb-eJ (ISPIN=2)
C
C NOW DO SECOND CONTRACTION:
C
C           W(mBEj) = W(mBEj) - SUM T(N,B) * <Nm|Ej> (ISPIN=1)
C           W(MbeJ) = W(MbeJ) - SUM T(n,b) * <Mn|Je> (ISPIN=2 OR RHF)
C
C WE NEED TO REORDER WHAT WE HAVE SO THAT IT WILL MATCH UP AND
C  CAN BE ACCUMULATED BY XGEMM. 
C
C THIS PRODUCT WILL BE PACKED Ej-mB [Je-Mb], SO WE NEED TO SWITCH
C  TO THIS ORDERING.
C
        IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
         I020=I010+IINTFP*DSZTAR*DISTAR
         CALL TRANSP(ICORE(I000),ICORE(I010),DISTAR,DSZTAR)
c YAU : old
c        CALL ICOPY(IINTFP*DISTAR*DSZTAR,ICORE(I010),1,ICORE(I000),1)
c YAU : new
         CALL DCOPY(DISTAR*DSZTAR,ICORE(I010),1,ICORE(I000),1)
c YAU : end
         I020=I010+IINTFP*DSZTAR 
         I030=I020+IINTFP*DSZTAR 
         I040=I030+IINTFP*DSZTAR 
         CALL SYMTR1(IRREPDO,VRT(1,1),POP(1,2),DSZTAR,
     &               ICORE(I000),ICORE(I010),ICORE(I020),
     &               ICORE(I030))
        ELSE
         I020=I010+IINTFP*DSZTAR 
         I030=I020+IINTFP*DSZTAR 
         I040=I030+IINTFP*DSZTAR 
         CALL SYMTR1(IRREPDO,VRT(1,2),POP(1,1),DSZTAR,
     &               ICORE(I000),ICORE(I010),ICORE(I020),
     &               ICORE(I030))
         I020=I010+IINTFP*DSZTAR*DISTAR
         CALL TRANSP(ICORE(I000),ICORE(I010),DISTAR,DSZTAR)
c YAU : old
c        CALL ICOPY(IINTFP*DISTAR*DSZTAR,ICORE(I010),1,ICORE(I000),1)
c YAU : new
         CALL DCOPY(DISTAR*DSZTAR,ICORE(I010),1,ICORE(I000),1)
c YAU : end
        ENDIF
        IF(RHF)THEN
         I020=I010+IINTFP*DSZTAR 
         I030=I020+IINTFP*DSZTAR 
         I040=I030+IINTFP*DSZTAR 
         CALL SYMTR1(IRREPDO,VRT(1,1),POP(1,1),DSZTAR,
     &               ICORE(I000),ICORE(I010),ICORE(I020),
     &               ICORE(I030))
        ENDIF  
C 
C  
C
C NOW DO    W(mBEj) = W(mBEj) - SUM T(N,B) * <Nm|Ej> (ISPIN=1)
C           W(MbeJ) = W(MbeJ) - SUM T(n,b) * <Mn|Je> (ISPIN=2 OR RHF)
C
        LISTW2=8+ISPIN
        IF(RHF)LISTW2=10
        ALPHA=ONEM*FACTOR
        BETA=ONE
        DISW  =aces_list_cols(IRREPDO,LISTW2)
        DSZW  =aces_list_rows(IRREPDO,LISTW2)
        I020  =I010+IINTFP*DSZW*DISW
        I030  =I020+IINTFP*DSZW
C
C GET THE INTEGRALS AND PLACE INTO A MATRIX 
C
C            I(Ej,Nm)   [ISPIN=1]
C            I(Je,Mn)   [ISPIN=2 OR RHF]
C
        CALL GETTRN(ICORE(I010),ICORE(I020),DSZW,DISW,2,IRREPDO,
     &              LISTW2)
        ITMP=DISW
        DISW=DSZW
        DSZW=ITMP
C
C TRANSPOSE KET INDICES FOR ISPIN=1.  THIS GIVES
C
C               I(Ej,mN) [ISPIN=1]
C               I(Je,Mn) [ISPIN=2 OR RHF]
C
        IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
         I030=I020+IINTFP*DSZW
         I040=I030+IINTFP*DSZW
         I050=I040+IINTFP*DSZW
         CALL SYMTR1(IRREPDO,POP(1,1),POP(1,2),DSZW,
     &              ICORE(I010),ICORE(I020),ICORE(I030),
     &              ICORE(I040))
        ENDIF
C
C NOW DO MATRIX MULTIPLICATION AS ABOVE, WITH THE MATRICES
C
C                                   t
C       Z(Ej,mB) = I(Ejm,N) * T(B,N)
C         
C                                   t
C       Z(Je,Mb) = I(JeM,n) * T(b,n)
C
        IOFFI=I010
        IOFFZ=I000
        DO 200 IRREPN=1,NIRREP
         IRREPM=DIRPRD(IRREPN,IRREPDO)
         IRREPB=IRREPN
         NROWI=DSZW*POP(IRREPM,3-ISPIN)
         NCOLI=POP(IRREPN,ISPIN)
         NROWT=VRT(IRREPB,ISPIN)
         NCOLT=POP(IRREPB,ISPIN)
         NROWZ=NROWI
         NCOLZ=NROWT
         IOFFT=IOFFT1(IRREPN,ISPIN)
         IF(MIN(NROWI,NCOLT,NCOLI).GT.0)THEN
          CALL XGEMM('N','T',NROWZ,NCOLZ,NCOLI,ALPHA,ICORE(IOFFI),
     &               NROWI,ICORE(IOFFT),NROWT,BETA,ICORE(IOFFZ),
     &               NROWZ)
         ENDIF
         IOFFI=IOFFI+NROWI*NCOLI*IINTFP
         IOFFZ=IOFFZ+NROWZ*NCOLZ*IINTFP
200     CONTINUE
C
C WE NOW HAVE
C                   Z(Ej,mB)  [ISPIN=1]
C                   Z(Je,Mb)  [ISPIN=2 OR RHF]
C
C AND WE WANT TO RESORT THESE FIRST TO
C
C                   Z(Ej,Bm)  [ISPIN=1]
C                   Z(eJ,bM)  [ISPIN=2]
C
C NOW TRANSPOSE BRA INDICES FOR TARGET IF ISPIN=2, AND KET INDICES IN
C  EITHER CASE
C
        IF(ISPIN.EQ.2.OR.RHF)THEN
         I020=I010+IINTFP*MAX(DSZTAR,DISTAR)
         I030=I020+IINTFP*MAX(DSZTAR,DISTAR)
         I040=I030+IINTFP*MAX(DSZTAR,DISTAR)
         CALL SYMTR3(IRREPDO,POP(1,1),VRT(1,2),DSZTAR,DISTAR,
     &              ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030))
        ENDIF
        I020=I010+IINTFP*DSZTAR
        I030=I020+IINTFP*DSZTAR
        I040=I030+IINTFP*DSZTAR
        CALL SYMTR1(IRREPDO,POP(1,3-ISPIN),VRT(1,ISPIN),DSZTAR,
     &              ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030))
C
C NOW DUMP THESE TO DISK IRREP BY IRREP
C
C
        CALL PUTLST(ICORE(I000),1,DISTAR,1,IRREPDO,LSTOUT)
20     CONTINUE
C
C NOW SWITCH ORDERING FROM 
C
C             Z(Ej,Bm) -> Z(Em,Bj) [ISPIN=1]
C             Z(eJ,bM) -> Z(eM,bJ) [ISPIN=2 OR RHF]
C
C AND PUT BACK ON DISK.
C
       ISCSIZ=(NVRTO(1)+NVRTO(2))*(NOCCO(1)+NOCCO(2))
       TARSIZ=ISYMSZ(ISYTYP(1,LSTTAR),ISYTYP(2,LSTTAR))
       I000=1
       I010=I000+TARSIZ*IINTFP
       I020=I010+TARSIZ*IINTFP
       I030=I020+ISCSIZ
       IF(I030.GT.MXCOR)CALL INSMEM('T1RB01',I030,MXCOR)
       CALL GETALL(ICORE(I010),TARSIZ,1,LSTOUT)
       CALL SSTRNG(ICORE(I010),ICORE(I000),TARSIZ,TARSIZ,ICORE(I020),
     &             SSTSPN(ISPIN))
C
C   FOR LAMBDA UPDATE TARGET LSIT AND COPY ORIGINAL INTERMEDIATES TO
C   LSTOUT
C
       IF(LAMBDA) THEN
        CALL GETALL(ICORE(I010),TARSIZ,1,LSTTAR)
        CALL PUTALL(ICORE(I010),TARSIZ,1,LSTOUT)
        CALL SAXPY(TARSIZ,ONE,ICORE(I010),1,ICORE(I000),1)
       ENDIF
       CALL PUTALL(ICORE(I000),TARSIZ,1,LSTTAR)
10    CONTINUE
      RETURN
      END

      subroutine mat_print_sub(mat,nrow,ncol,title,collab,rowlab,
     &                         numwid,ndec,r0,r1,c0,c1)
      implicit none

      integer nrow,ncol,numwid,ndec,r0,r1,c0,c1
      double precision mat(nrow,ncol)
      character*(*) title,collab,rowlab

      integer pagewid
      parameter (pagewid=80)

      character*80 f,fn,fb,frh,frb,fch,fc
      character*10 tmpn,tmpm,tmpl,tmpw,tmpd,tmp
      integer rownumlen,numcol,col0,col1,n,irow,icol,cols(pagewid)
      integer  strlen
      external strlen

c Check some error conditions...
      if (nrow.lt.1 .or. ncol.lt.1 .or. ndec.lt.0 .or. numwid.lt.1
     &    .or. numwid.gt.pagewid/2 .or. ndec.gt.numwid-2 .or.
     &    r0.lt.1 .or. r0.gt.nrow .or. c0.lt.1 .or. c0.gt.ncol .or.
     &    r0.gt.r1 .or. c0.gt.c1) then
         write(*,*) '@MAT_PRINT_SUB: invalid parameter'
         stop
      end if

c The number of digits in the row
      rownumlen=1+(log10(nrow*1.d0))
c The maximum number of columns to print
      numcol=(pagewid-(strlen(rowlab)+1+rownumlen))/(numwid+1)

c Formats are:
c   fn = '(x,fW.D)'            : a single number
c   fb = '(W+1x)'              : a blank number field
c   frh= '(aN,x,iM,'           : a row header
c   frb= '(N+M+1x,'            : a blank row header
c   f  = '(aN,x,iM,L(x,fW.D))' : a left justified set of numbers
c   fch= '(aN+M+1,L(x,iW))'    : a column header
c   fc = '(N+M+1x,L(x,W('-')))': the 2nd line of the column header
c where
c   N : strlen(rowlab)
c   M : rownumlen
c   L : numcol
c   W : numwid
c   D : ndec

      write(tmpw,'(i10)') numwid
      write(tmpd,'(i10)') ndec
      call delspc(tmpw,tmpw)
      call delspc(tmpd,tmpd)
      fn='(x,f'//tmpw(1:strlen(tmpw))//'.'//tmpd(1:strlen(tmpd))//')'
      write(tmp,'(i10)') numwid+1
      call delspc(tmp,tmp)
      fb='('//tmp(1:strlen(tmp))//'x)'

      write(tmpn,'(i10)') strlen(rowlab)
      write(tmpm,'(i10)') rownumlen
      call delspc(tmpn,tmpn)
      call delspc(tmpm,tmpm)
      frh='(a'//tmpn(1:strlen(tmpn))//',x,i'//tmpm(1:strlen(tmpm))//','
      write(tmp,'(i10)') strlen(rowlab)+rownumlen+1
      call delspc(tmp,tmp)
      frb='('//tmp(1:strlen(tmp))//'x,'

      write(tmpl,'(i10)') numcol
      call delspc(tmpl,tmpl)
      f=frh(1:strlen(frh))//tmpl(1:strlen(tmpl))//fn(1:strlen(fn))//')'

      fch='(a'//tmp(1:strlen(tmp))//','
     &        //tmpl(1:strlen(tmpl))//'(x,i'
     &        //tmpw(1:strlen(tmpw))//'))'

      col0=c0
      col1=c0+numcol-1
      if (col1.gt.c1) col1=c1
      write(*,*) title
      write(*,*)

   10 continue

c The actual number of columns to print
      n=col1-col0+1
      write(tmpn,'(i10)') n
      call delspc(tmpn,tmpn)
      fc=frb(1:strlen(frb))//tmpn(1:strlen(tmpn))//'(x,'//
     &   tmpw(1:strlen(tmpw))//'(''-'')))'

      do icol=col0,col1
         cols(icol-col0+1)=icol
      end do
      write(*,fch) collab,(cols(icol-col0+1),icol=col0,col1)
      write(*,fc)

      do irow=r0,r1
         write(*,f) rowlab,irow,(mat(irow,icol),icol=col0,col1)
      end do
      write(*,*)

      if (col1.lt.c1) then
         col0=col0+numcol
         col1=col1+numcol
         if (col1.gt.c1) col1=c1
         goto 10
      end if

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_MOLECULE_INFO
     +
     +                    ( UNITID,
     +                      NATOM,
     +                      XYZ,ZATOM,
     +                      GPOINT,
     +                      DOMAT,
     +                      SOMAT,
     +                      BOMAT )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_MOLECULE_INFO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints the molecular info such as atom
C                coordinates, several atomic order matrices, etc to
C                the output file specified by its unit identification
C                number.
C
C
C                  Input:
C
C                    UNITID       =  printout unit identification #
C                    NATOM        =  total # of atoms
C                    XYZ          =  x,y,z-coordinates for all the
C                                    atoms in 3 x NATOM matrix format.
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    GPOINT       =  if the center of mass of the
C                                    atomic arrangement coincides with
C                                    one of the atoms, this variable
C                                    will contain the corresponding
C                                    atomic index. If no atom coincided
C                                    with the center of mass location
C                                    it contains a value of 0.
C                    DOMAT        =  distance order matrix
C                    SOMAT        =  atomic overlap order matrix
C                    BOMAT        =  bond order matrix
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*3   ANSWER
         CHARACTER*2   ATCHAR
         CHARACTER*1   BAR,DASH

         CHARACTER*2   ATSYMB  (1:104)

         INTEGER     ATOM
         INTEGER     GPOINT
         INTEGER     I
         INTEGER     NATOM
         INTEGER     UNITID
         INTEGER     ZVAL

         INTEGER     ZATOM   (1:NATOM)

         DOUBLE PRECISION  X,Y,Z

         DOUBLE PRECISION  BOMAT (1:NATOM,1:NATOM)
         DOUBLE PRECISION  DOMAT (1:NATOM,1:NATOM)
         DOUBLE PRECISION  SOMAT (1:NATOM,1:NATOM)
         DOUBLE PRECISION  XYZ   (1:3    ,1:NATOM)

         DATA ATSYMB /' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     +                'Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca',
     +                'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     +                'Ga','Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr',
     +                'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     +                'Sb','Te',' I','Xe','Cs','Ba','La','Ce','Pr','Nd',
     +                'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     +                'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     +                'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     +                'Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     +                'Md','No','Lr','xx'/
         DATA  BAR     /'|'/
         DATA  DASH    /'-'/
C
C
C------------------------------------------------------------------------
C
C
C             ...print out header.
C
C
         WRITE (UNITID,8000) 'Molecular Info'
 8000    FORMAT (//,20X,A14,//)
C
C
C             ...print out header of atomic coordinates.
C
C
         WRITE (UNITID,9000) 'Atom',BAR,'Atom #',BAR,
     +                       'X coordinate',BAR,
     +                       'Y coordinate',BAR,
     +                       'Z coordinate',BAR,
     +                       'is at center of mass'
         WRITE (UNITID,9010) (DASH,I=1,99)
C
C
C             ...print out atomic coordinates.
C
C
         DO ATOM = 1,NATOM
            X = XYZ (1,ATOM)
            Y = XYZ (2,ATOM)
            Z = XYZ (3,ATOM)
            ZVAL = ZATOM (ATOM)

            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            IF (ATOM.EQ.GPOINT) THEN
                ANSWER = 'YES'
            ELSE
                ANSWER = ' NO'
            END IF

            WRITE (UNITID,9020) ATCHAR,BAR,ATOM,BAR,
     +                          X,BAR,Y,BAR,Z,BAR,
     +                          ANSWER
         END DO
C
C
C             ...formats for printing atomic coordinates.
C
C
 9000    FORMAT (1X,A4,1X,     A1, 1X,A6,1X,     A1,
     +           3X,A12,5X,    A1, 3X,A12,5X,    A1, 3X,A12,5X,    A1,
     +           1X,A20)
 9010    FORMAT (1X,99A1)
 9020    FORMAT (2X,A2,2X,     A1, 2X,I3,3X,     A1,
     +           1X,F18.14,1X, A1, 1X,F18.14,1X, A1, 1X,F18.14,1X, A1,
     +           9X,A3,9X)
C
C
C             ...print out the distance order matrix.
C
C
         WRITE (UNITID,8010) 'Distance Order Matrix'
 8010    FORMAT (//,20X,A21)

         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows , Columns = Atom indices ',
     +                  NATOM,NATOM,
     +                  NATOM,NATOM,
     +                  DOMAT )
     +
     +
C
C
C             ...print out the atomic overlap order matrix.
C
C
         WRITE (UNITID,8020) 'Atomic Overlap Order Matrix'
 8020    FORMAT (//,20X,A27)

         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows , Columns = Atom indices ',
     +                  NATOM,NATOM,
     +                  NATOM,NATOM,
     +                  SOMAT )
     +
     +
C
C
C             ...print out the bond order matrix.
C
C
         WRITE (UNITID,8030) 'Bond Order Matrix'
 8030    FORMAT (//,20X,A17)

         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows , Columns = Atom indices ',
     +                  NATOM,NATOM,
     +                  NATOM,NATOM,
     +                  BOMAT )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE SHELLINF(NORBIT,NTOTATOM,NTOTSHEL,INUMSHEL,ISHLOFF,
     &                   ISHELTP,ISHELSZ)
C
C GENERATE SHELL INFORMATION FOR ATOMS AS ORDERED IN THE ZMAT
C FILE.
C
CJDW 10/28/96. Modifications to check value of IMOL and to check we do
C              not exceed fixed dimensions. For dummy atoms IMOL is set
C              to 999 and we have troubles. Thanks to Roger Edberg of ANU
C              for finding this error.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION INUMSHEL(NORBIT),ISHLOFF(NORBIT)
      DIMENSION ISHELTP(NTOTSHEL),ISHELSZ(NTOTSHEL)
C
#include <mxatms.par>
#include <baslims.par>
C
      DIMENSION IZMT2MOL(mxatms)
C
C I am going to set these two arrays to the maximum number of
C atoms times maximum number of shells. Ajith Perera, 11/07.
C
      DIMENSION ISHELTP2(mxatms*mxshel),ISHELSZ2(mxatms*mxshel)
C
      IF(NTOTATOM.GT.200)THEN
       WRITE(6,1000)
       CALL ERREX
      ENDIF
C
      CALL IGETREC(20,'JOBARC','ZMAT2MOL',NTOTATOM,IZMT2MOL)
#ifdef _DEBUG_LVLM1
      Print*, "ZMAT2MOL", (IZMT2MOL(I), I=1, NTOTATOM)
      Print*, "ISHELTP", (ISHELTP(I), I=1, NTOTSHEL)
      Print*, "ISHELSZ", (ISHELSZ(I), I=1, NTOTSHEL)
#endif 
C
C LOOP OVER ATOMS IN ZMAT
C
      IOFFZMAT=1
      DO 10 IZMAT=1,NTOTATOM
C
C GET MOL FILE POSITION
C
       IMOL=IZMT2MOL(IZMAT)
C
       IF(IMOL.GE.1 .AND. IMOL.LE.NORBIT)THEN
C
C GET SHELL INFORMATION FOR THIS ATOM
C
        NSHELL=INUMSHEL(IMOL)
        IOFFMOL=ISHLOFF(IMOL)
        if (IOFFZMAT+NSHELL.gt.500) then
           print *, '@SHELLINF: Assertion failed.'
           print *, '           maximum number of shells = 500'
           print *, '           require at least ',IOFFZMAT+NSHELL
           call errex
        end if
        CALL ICOPY(NSHELL,ISHELTP(IOFFMOL),1,ISHELTP2(IOFFZMAT),1)
        CALL ICOPY(NSHELL,ISHELSZ(IOFFMOL),1,ISHELSZ2(IOFFZMAT),1)
        IOFFZMAT=IOFFZMAT+NSHELL
C
       ELSE
C
        IF(IMOL.NE.999)THEN
         WRITE(6,1010) IMOL
         CALL ERREX
        ENDIF
C
       ENDIF
C
10    CONTINUE
C
      NSHELTOT=IOFFZMAT-1
C
      IF(NSHELTOT.GT.500)THEN
       WRITE(6,1020) NSHELTOT
       CALL ERREX
      ENDIF
C
#ifdef _DEBUG_LVLM1
      Print*, "+++++++++++++++++", NSHELTOT
      Print*, "ISHELTP", (ISHELTP2(I), I=1, NTOTSHEL)
      Print*, "ISHELSZ", (ISHELSZ2(I), I=1, NTOTSHEL)                          
#endif
C
      CALL IPUTREC(20,'JOBARC','FULSHLNM',1,NSHELTOT)
      CALL IPUTREC(20,'JOBARC','FULSHLTP',NSHELTOT,ISHELTP2)
      CALL IPUTREC(20,'JOBARC','FULSHLSZ',NSHELTOT,ISHELSZ2)
C
#ifdef _DEBUG_LVLM1
      Print*, "++++++++++++++++++"
      Print*, "ISHELTP", (ISHELTP2(I), I=1, NTOTSHEL)
      Print*, "ISHELSZ", (ISHELSZ2(I), I=1, NTOTSHEL)
#endif
C
      RETURN
 1000 FORMAT(' @SHELLINF-F, Too many atoms (over 200) ',I10)
 1010 FORMAT(' @SHELLINF-F, Invalid value of IMOL ',I10)
 1020 FORMAT(' @SHELLINF-F, Too many shells (over 500) ',I10)
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_stack(depth)
c---------------------------------------------------------------------------
c   Sets up a stack for the (start, end) operation pairs that define a 
c   do loop.
c
c   "Depth" is the maximum stack depth.
c---------------------------------------------------------------------------
      implicit none
      include 'machine_types.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      
      integer x(2) 
#ifdef ALTIX
      pointer (iptr, x)
#else
      common x
#endif
      integer depth
      integer size, ierr
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      stack_depth = depth
      sp = 1

#ifdef ALTIX
      iptr = ishptr
#endif

      call mem_alloc(x, 2*depth, intsize, ixstack, .true., ierr)
      if (ierr .ne. 0) then
         print *,'Error: Unable to allocate memory for do stack.'
         call abort_job()
      endif
      return
      end

      integer function push_do(start, end)
c--------------------------------------------------------------------------
c   Push a pair of start, end values onto the do stack.
c   Stack overflow --> function returns -1, else 0.
c--------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer x(2) 
#ifdef ALTIX
      pointer (iptr, x)
#else 
      common x
#endif
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      integer*8 ix
      integer start, end
 
#ifdef ALTIX
      iptr = ishptr
#endif

      if (sp .gt. stack_depth) then
         push_do = -1
      else
         ix = ixstack + 2*(sp-1)
         x(ix)   = start   
         x(ix+1) = end
         sp      = sp + 1
         push_do = 0
      endif

c      print *,'Task ',me,' PUSH ix ',ix,' start, end ',start,end
c      call c_flush_stdout()
      return
      end

      integer function pop_do(start, end)
c---------------------------------------------------------------------------
c   Pops a pair of start, end values off the stack, returns 0 if successful,
c   or -1 if stack underflow results.
c---------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer x(2)
#ifdef ALTIX
      pointer (iptr, x)
#else
      common x
#endif
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      integer start, end
      integer*8 ix

#ifdef ALTIX
      iptr = ishptr
#endif

      if (sp .eq. 1) then
         pop_do = -1
      else
         pop_do = 0
         sp = sp - 1
         ix = ixstack + 2*(sp-1)
         start = x(ix)
         end   = x(ix+1)
      endif

c      print *,'Task ',me,' POP ix ',ix,' start end ',start,end
      return
      end

  
      subroutine checkpoint_instruction_stack(unit)
c---------------------------------------------------------------------------
c   Saves the instruction stack to a checkpoint file.
c---------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer x(2)
#ifdef ALTIX
      pointer (iptr, x)
#else
      common x
#endif
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      integer i, n, unit

#ifdef ALTIX
      iptr = ishptr
#endif

      write (unit) sp
      if (sp .gt. 1) then
         n = (2*(sp-1))/4
         write (unit) (x(ixstack+i-1),i=1,4*n)
      endif
 
      return
      end

      subroutine restore_instruction_stack(unit)
c---------------------------------------------------------------------------
c   Reads the instruction stack from the checkpoint file.
c---------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer x(2)
#ifdef ALTIX
      pointer (iptr, x)
#else
      common x
#endif
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      integer i, n, unit

#ifdef ALTIX
      iptr = ishptr
#endif

      read (unit) sp
      if (sp .gt. 1) then
         n = (2*(sp-1)) / 4    ! each entry is startop, endop, iwhere, nwhere
         read (unit) (x(ixstack+i-1),i=1,4*n)
      endif

      return
      end

      subroutine broadcast_instruction_stack(comm)
c---------------------------------------------------------------------------
c   Broadcasts the instruction stack to each process in the communicator.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer x(2)
#ifdef ALTIX
      pointer (iptr, x)
#else
      common x
#endif
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      integer i, comm, ierr

#ifdef ALTIX
      iptr = ishptr
#endif

      call mpi_bcast(x(ixstack), 2*stack_depth, MPI_INTEGER, 0,
     *               comm, ierr)
      call mpi_bcast(sp, 1, MPI_INTEGER, 0, comm, ierr)
      return
      end

      subroutine restore_do_loops(optable, noptable, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      checkpoint_seg, ckpt_start_op, ckpt_end_op) 
c---------------------------------------------------------------------------
c   Reinitializes each doloop instruction in the instruction stack during 
c   a checkpoint/restart operation.
c
c   The normal do_loop_init routine is first called, then the current_seg 
c   entry in the index_table is set to the corresponding entry from the 
c   checkpoint_seg array.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'parallel_info.h'
      include 'interpreter.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer noptable, nindex_table, nsegment_table
      integer optable(loptable_entry,noptable)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer checkpoint_seg(nindex_table)
      integer ckpt_start_op, ckpt_end_op

      integer x(2)
#ifdef ALTIX
      pointer (iptr, x)
#else
      common x
#endif
      integer*8 ixstack
      integer sp, stack_depth
      common /dostack/ixstack, sp, stack_depth

      integer i, n, comm, ierr
      integer index, start_op, end_op, iop
      logical subrange_flag

#ifdef ALTIX
      iptr = ishptr
#endif

      n = (2*(sp-1))/4   ! number of stack entries.

      do i = 1, n
         iop = x(ixstack+4*(i-1))

         if (optable(c_opcode,iop) .eq. do_op) then
            optable(c_oploop, iop) = 1  ! loop init flag
            call get_loop_index(optable(c_ind1,iop), index, 
     *                  subrange_flag)
         endif
      enddo
      
c------------------------------------------------------------------------
c   Carry out the same procedure for the checkpointed start_op and 
c   end_op.  It is possible that this is also a doloop instruction, and
c   therefore that loop must also be initialized to execute correctly.
c------------------------------------------------------------------------

      iop = ckpt_start_op
      if (optable(c_opcode,iop) .eq. do_op) then
         optable(c_oploop, iop) = 1  ! loop init flag
         call get_loop_index(optable(c_ind1,iop), index,
     *                  subrange_flag)
      endif
 
      return
      end

c This routine creates storage statistics for a new double-precision array,
c and extends the proper storage unit by the requested amount of data.
c It will bomb if there is not enough disk space.

c INPUT
c int NCOLS : the number of columns in the array
c int NROWS : the number of rows    in the array
c int ILEFT  : the left  index in MOIO
c int IRIGHT : the right index in MOIO
c int INOFRAG : a behavior flag
c               >= 0; start the array at the next available location
c                < 0; start the array at the next available physical record
c               NOTE: A few routines (e.g., aces_family_redist) require all the
c                     arrays in one family to be packed together with no space
c                     between them.

c#define _FLUSH_WITH_NaN
c#define _TRAP_LIST_FAM 6 /* iRight */
c#define _TRAP_LIST_GRP 1 /* iLeft */
c#define _WARN_LIST_FAM 165
c#define _WARN_LIST_GRP 1

      subroutine aces_list_touch(nCols,nRows,iLeft,iRight,iNoFrag)
      implicit none

c ARGUMENTS
      integer nCols, nRows, iLeft, iRight, iNoFrag

c INTERNAL VARIABLES
#include "szfiles.dat"
      character*80 szFile
      integer      iLength
      integer ihFile, iUnit, pRecOld, nWords
      integer iStat, iJunk
      logical bExist, bOpened

c COMMON BLOCKS
#include "lists.com"
#include "machsp.com" /* for iintfp */
#include "icdacc.com" /* for idaccm */
#include "filspc.com" /* for iprcwd */
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iStat = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_LIST_TOUCH: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iStat = 1
      end if
c   o assert columns and rows are whole
      if ((nCols.lt.0).or.(nRows.lt.0)) then
         print *, '@ACES_LIST_TOUCH: Assertion failed.'
         print *, '   nRows = ',nRows
         print *, '   nCols = ',nCols
         iStat = 1
      end if
c   o assert left and right indices are properly bound
      if ((iLeft .lt.1).or.(_MAX_IO_GRPS.lt.iLeft ).or.
     &    (iRight.lt.1).or.(_MAX_IO_FAMS.lt.iRight)    ) then
         print *, '@ACES_LIST_TOUCH: Assertion failed.'
         print *, '   iLeft  = ',iLeft
         print *, '   iRight = ',iRight
         print *, '   MOIO rows = ',_MAX_IO_GRPS
         print *, '   MOIO cols = ',_MAX_IO_FAMS
         iStat = 1
      end if
c   o assert quikget is not set if the list does not exist yet
      if (moio(iLeft,iRight).eq.0) then
      if (quikget(iLeft,iRight).ne.0) then
         print *, '@ACES_LIST_TOUCH: Assertion failed.'
         print *, '   iLeft  = ',iLeft
         print *, '   iRight = ',iRight
         print *, '   quikget(,) = ',quikget(iLeft,iRight)
         iStat = 1
      end if
      end if
      if (iStat.ne.0) call aces_exit(iStat)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

#if defined(_TRAP_LIST_FAM) && defined(_TRAP_LIST_GRP)
      if ((iRight.eq._TRAP_LIST_FAM).and.
     &    (iLeft .eq._TRAP_LIST_GRP)     ) call c_abort
#endif
#if defined(_WARN_LIST_FAM) && defined(_WARN_LIST_GRP)
      if ((iRight.eq._WARN_LIST_FAM).and.
     &    (iLeft .eq._WARN_LIST_GRP)     ) then
         print *, '@ACES_LIST_TOUCH: touching ',iLeft,iRight
      end if
#endif

c   o if the array already exists, check to make sure it is still the same size
      if (moio(iLeft,iRight).ne.0) then
         if (moiosz(iLeft,iRight).ne.nRows.or.
     &       moiods(iLeft,iRight).ne.nCols    ) then
            print *, '@ACES_LIST_TOUCH: list (',iLeft,',',iRight,
     &               ') already exists and is of different dimensions'
            print *, '   currently: ',moiosz(iLeft,iRight),' x ',
     &                                moiods(iLeft,iRight)
            print *, '   requested: ',nRows,' x ',nCols
            call aces_exit(1)
         end if
         return
      end if

c   o ihFile is the integer handle of the file storing the array
      ihFile = 1 + (iRight-1)/_FAMS_PER_FILE

c   o open and/or create the unit
      call aces_io_open(ihFile)

c   o save the current record pointer
      pRecOld = pRec(ihFile)

c   o shift the free-space pointers if desired
      if ((iNoFrag.lt.0).and.(iIntOff(ihFile).ne.0)) then
         pRec(ihFile) = pRec(ihFile) + 1
         iIntOff(ihFile) = 0
      end if

c   o convert the handle to an external unit
      iUnit = ihFile-1+_FIRST_IO_LUN

c   o assign storage statistics
      moio  (iLeft,iRight) = pRec(ihFile)
      moiowd(iLeft,iRight) = 1 + iIntOff(ihFile)
      moiosz(iLeft,iRight) = nRows
      moiods(iLeft,iRight) = nCols
      moiofl(iLeft,iRight) = iUnit

c   o record the number of doubles as an upper bound for resizing
      moiomxsz(iLeft,iRight) = nRows*nCols

cYAU - There should be an isytyp modifier here.
c      isytyp(1,iRight) = ???
c      isytyp(2,iRight) = ???

c   o re-position the free-space pointers
      nWords = nRows*nCols*iintfp + iIntOff(ihFile)
      pRec(ihFile) = pRec(ihFile) + (nWords/iprcwd)
      iIntOff(ihFile) = mod(nWords,iprcwd)

#ifdef _2GB_FILES
      if (iprcln*pRec(ihFile).lt.0) then
         print *, '@ACES_LIST_TOUCH: Files over 2GB are not supported',
     &            ' by this binary.'
         call aces_exit(1)
      end if
#endif

c   o arrest disk space by writing to the highest record
      if (pRec(ihFile).gt.pRecOld) then
         write(unit=iUnit,rec=pRec(ihFile),err=666,iostat=iStat) 0
      end if

#ifdef _DEBUG_ACES_IO
c   o do nasty things to trap calling getlst before putlst
#ifdef _FLUSH_WITH_NaN
      call aces_list_memset(iLeft,iRight,255)
#else
      call aces_list_memset(iLeft,iRight,0)
#endif
#endif

c   o mark MOIO as modified
      bIOMod = .true.

      return

c   o write-error jump
 666  call gfname(szFiles(ihFile),szFile,iLength)
      print *, '@ACES_LIST_TOUCH: An error occurred while attempting ',
     &         'to extend the size of the file:'
      print *, '                  ',szFile(1:iLength)
      call aces_io_error('ACES_LIST_TOUCH',iUnit,iStat)

c     end subroutine aces_list_touch
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine list_to_blocks(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table,  op)
c--------------------------------------------------------------------------
c   Reads block data from a list file and distributes them to their owners.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'saved_data.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k, n
      integer array, index(mx_array_index), nindex, ierr
      integer block, seg(mx_array_index)
      integer blkndx, get_block_number
      integer saveseg(mx_array_index)
      integer*8 indblk, get_block_data_index
      integer stack
      integer f_form_msg_tag
      integer datatag
      integer type, kreq, ireq, nreq
      
      integer mx_blk
      parameter (mx_blk = 25000)
      integer request(mx_blk)
      integer drequest(mx_blk)
      integer desc_msg(2,mx_blk)
      integer statuses(MPI_STATUS_SIZE,mx_blk)

      integer my_comm_rank, comm
      integer home, iblk
      integer val1(mx_array_index), val2(mx_array_index)
    
      integer nb, proc, map, company_comm
      integer tag
      integer pst_get_company_comm, pst_get_company_rank
      integer status(MPI_STATUS_SIZE)

      if (first_list_to_blocks) then
         first_list_to_blocks = .false.
         narray_list          = 0
      endif

      narray_list = narray_list + 1
      if (narray_list .gt. max_array_list) then
         print *,'Error: LIST_TO_BLOCKS arrays exceeds maximum of ',
     *       max_array_list
         call abort_job()
      endif

      array_list(narray_list) = op(c_result_array)
      return
      end

      SUBROUTINE MSOMAT(IAOM,IAOR,IAOC,ISOM,ISOR,ISOC,ICHAO,ICHSO,NAT,
     +      NGENG)
C
C     CONSTRUCT AO --> SO MATRIXES
C
      IMPLICIT INTEGER (A-Z)
C
      INTEGER IAOM(IAOR,IAOC),ISOM(ISOR,ISOC),ICHAO(3,IAOC),ICHSO
     1 (ISOR),ISCR(15,3),ISCS(3)
C     SCRATCH VECTOR ISCR SUFFICIENT UP TO G-AO
      COMMON/IB/IBING(3,3),ICHAT(8,8),ICHGEN(8,3),IMAGE(200,3),NEQA
      COMMON/JJJ/ JJ(8),JJPP(8)
C
C     CONSTRUCT CURRENT REDUCTION MATRIX (AO TO SO)
C     AS DIRECT PRODUCT OF MATRICES IAOM * ICHAT
C
      II=0
      DO 40 I=1,NEQA
         DO 30 J=1,IAOR
            II=II+1
            KK=0
            DO 20 K=1,NEQA
               DO 10 L=1,IAOC
                  KK=KK+1
                  ISOM(KK,II)=IAOM(J,L)*ICHAT(K,I)
 10            CONTINUE
 20         CONTINUE
 30      CONTINUE
 40   CONTINUE
C
C     DETERMINE CHARACTER OF SO'S
C
      IF (NGENG.GT.0) GO TO 60
C
C     TRIVIAL CASE OF NO SYMMETRY
C
      DO 50 I=1,ISOR
         ICHSO(I)=1
 50   CONTINUE
      RETURN
C
   60 CONTINUE
C
C     DETERMINE FIRST CHARACTERS OF AO W.R. TO GENERATORS
C
      DO 80 I=1,NGENG
         DO 70 J=1,IAOR
            ISCR(J,I)= ICHAO(1,J)**IBING(1,I)
     1         *ICHAO(2,J)**IBING(2,I)
     2         *ICHAO(3,J)**IBING(3,I)
 70      CONTINUE
 80   CONTINUE
C
C     NOW CHARACTERS OF SO'S
C
      IFLW=NAT-NEQA
      DO 140 L=1,ISOR
         DO 110 I=1,NGENG
            II=0
            ISUM=0
            DO 100 J=1,NEQA
               KK=(IMAGE(IFLW+J,I)-1)*IAOR
               DO 90 K=1,IAOR
                  II=II+1
                  ISUM=ISUM+ISOM(L,II)*ISOM(L,KK+K)*ISCR(K,I)
 90            CONTINUE
 100        CONTINUE
            ISCS(I)=1
            IF (ISUM.LT.0) ISCS(I)=-1
 110     CONTINUE
C
C     DETERMINE NUMBER OR IRREP BY COMPARISON WITH CHARACT. OF GENER.
C     OF IRREP AS GIVEN IN ICHGEN
C
         M=2**NGENG
         DO 130 I=1,M
            ISUM=0
            DO 120 J=1,NGENG
               JCHGEN=ICHGEN(I,1)**IBING(1,J)*
     1            ICHGEN(I,2)**IBING(2,J)*
     2            ICHGEN(I,3)**IBING(3,J)
               ISUM=ISUM+IABS(ISCS(J)-JCHGEN)
 120        CONTINUE
            IF (ISUM.EQ.0) ICHSO(L)=JJ(I)
 130     CONTINUE
 140  CONTINUE
C
      RETURN
      END

      SUBROUTINE FULL_T1(T1_EXPAND, T1_DROP, NVRT_ACT, NOCC_ACT,
     &                   NVRT, NOCC, NVRT_DRP, NOCC_DRP)

      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      DIMENSION T1_EXPAND(NVRT,NOCC), T1_DROP(NVRT_ACT,NOCC_ACT)

      CALL ZERO(T1_EXPAND,NVRT*NOCC)
      DO IORBS = 1, NVRT_ACT
         DO JORBS = 1, NOCC_ACT
cSSS            IF_INDEX = IORBS + NVRT_DRP
            IF_INDEX = IORBS
            JF_INDEX = JORBS + NOCC_DRP
            T1_EXPAND(IF_INDEX,JF_INDEX) = T1_DROP(IORBS,JORBS)
         END DO
      END DO

      RETURN
      END

      Subroutine Build_cmatrix(Nxm6, Cmat)

      Implicit Double Precision (A-H, O-Z)

#include "mxatms.par"
      Integer Constrained 
      Dimension Cmat(Nxm6, Nxm6), Constrained(Maxredunco)
C
      Nxm62 = Nxm6*Nxm6
      Call Dzero(Cmat, Nxm62)
C
C The constrained designates the constrains. It is prepared and
C archived in gen_redinternals. 
C
      Call IGetrec( 0, "JOBARC", "CONSTRNS", Ilength, Ijunk)
      Call IGetrec(20, "JOBARC", "CONSTRNS", Ilength, Constrained)

#ifdef _DEBUG_LVL0
      write(6,"(a)") "The constrained array"
      Write(6,"(6(1x,i4))") (Constrained(i),i=1, Ilength)
#endif
      Do Idim =1, Nxm6
      
         If (constrained(Idim) .EQ. 1) Then
             Cmat(Idim, Idim) = 1.0D0
         Endif

      Enddo

#ifdef _DEBUG_LVL0
      write(6,"(a)") "The constrain Matrix"
      call output(Cmat, 1, Nxm6, 1, Nxm6, Nxm6, Nxm6, 1)
#endif
      Return
      End

      SUBROUTINE INERTIA(IT, NOSILENT)
C
C BUILD INERTIA TENSOR
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
 
      Parameter (LuOut = 6)
      DOUBLE PRECISION IT(3,3),SCRATCH(9)
      LOGICAL NOSILENT
C
      IND(I,J)=3*(I-1)+J
C   
      CALL ZERO(SCRATCH,9)
      CALL ZERO(IT,9)
      DO 100 I=1,3
         DO 100 K=1,NATOMS
            X1=DIST(Q(3*K-2),SCRATCH(1))
            X2=Q(3*(K-1)+I)
 100        IT(I,I)=ATMASS(K)*(X1*X1-X2*X2)+IT(I,I)
c     $         (DIST(Q(3*K-2),SCRATCH(1))**2-Q(3*(K-1)+I)**2)+IT(I,I)
      DO 200 I=1,3
         DO 300 J=1,3
            IF(I.EQ.J)GOTO 300
            DO 400 K=1,NATOMS
               IT(I,J)=-ATMASS(K)*(Q(IND(K,I))*Q(IND(K,J)))+IT(I,J)
 400        Continue
 300     Continue
 200  CONTINUE
      IF(IPRNT.GE.4 .AND. NOSILENT)WRITE(LuOut,*)' Inertia tensor'
      IF(IPRNT .GE. 4 .AND. NOSILENT) WRITE(LuOut,80)
     &                                ((IT(I,J),J=1,3),I=1,3)
 80   FORMAT(3(1X,F10.5))
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__close_all_units
c------------------------------------------------------------------------
c  operation   : ofh__close_all_units
c  module      : output files handler
c  module-id   : ofh
c  description : This operation terminates the connections between all
c                previously opened files and their associated units.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         integer    i
c
c
c------------------------------------------------------------------------
c
c
c             ...loop over all possible I/O units and close them.
c
c
         do i = 2,MAX_OUTPUT_FILES
            call  ofh__close_unit (i)
         end do
c
c
c             ...ready!
c
c
         return
         end

      SUBROUTINE flushcache
C
cjp
cjp   necessary for work with iref-replicated moints, moabcd files
cjp
      IMPLICIT INTEGER (A-Z)
      DIMENSION ZLIST(1)
      COMMON // ICORE(1)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MACHSP2/ MASK1,MASK2,ISHFSZ
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
C
cjp for debug purposes in order to identify exactly, when some
cjp modifications of files occured, switch off caching mechanism
cjp by flushing caches immediatelly

cjp will be needed anyway in the mr-cc to flush after work with a set of amplitudes
cjp of one reference before starting with the other one

      IPACK(I,J)=IOR(J,ISHFT(I-49,ISHFSZ))
      UPACKR(I) =IAND(I,MASK1)
      UPACKF(I) =IAND(ISHFT(I,-ISHFSZ),MASK2)+49

cjp this flush procedure is taken from termio
      do 15 i=1,cachnum
       file=cachfile(i)
       if(file.ne.0)then
        record=upackr(cachdir(i))
        ipos  =cachpos(i)
        if(cachmod(i).ne.0.and.record.ne.0)
     +       call aces_io_write(file,record,icore(ipos),lenrec)
        cachmod(i)=0
       endif
15    continue

cjp mark also the cache positions as empty
cjp in order that subsequent calls of getlst/fetch do not hit the cache
cjp full of old stuff from other reference configuration!!!
cjp code from initio
      call izero(cachdir,100)
      call izero(cachfile,100)
      call izero(cachmod,100)
      oldest=1
      return
      end

      SUBROUTINE DIF
C     
C     This subroutine determines the density
C     difference in the two input cubes. Note
C     that the proram assumes that both the
C coordinates of the atoms and the points
C     are identical.
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      CHARACTER*25 LINE1
      CHARACTER*25 LINE2
C     
      DIMENSION P(6),Q(6),O(6)
C     
C     I apologize for the following series of commands, but I
C couldn't get things to work otherwise.
      I=ISHELL('cp den.cube denone.cube')
      I=ISHELL('cp den2.cube dentwo.cube')
      I=ISHELL('rm den.cube den2.cube')
C     
      OPEN(UNIT=13,FILE='dentwo.cube')
      OPEN(UNIT=12,FILE='denone.cube')
      OPEN(UNIT=14,FILE='dif.cube')
C     
      READ(12,"(A25)") LINE1
      READ(12,"(A25)") LINE2
      WRITE(14,*) LINE1
      WRITE(14,*) "The Delta Density"
C
      READ(12,*) NATOMS,P1,P2,P3
      WRITE(14,"(I5,3 F12.6)") NATOMS,P1,P2,P3
      READ(12,*) IXPTS,P1,P2,P3
      WRITE(14,"(I5,3 F12.6)") IXPTS,P1,P2,P3
      READ(12,*) IYPTS,P1,P2,P3
      WRITE(14,"(I5,3 F12.6)") IYPTS,P1,P2,P3
      READ(12,*) IZPTS,P1,P2,P3
      WRITE(14,"(I5,3 F12.6)") IZPTS,P1,P2,P3
C     
      DO 10 I=1,ABS(NATOMS)
         READ(12,*) INT,P1,P2,P3,P4
         WRITE(14,"(I5,4 F12.6)") INT,P1,P2,P3,P4
 10   CONTINUE
C
      MODVAL=mod(IZPTS,6)
      NGRPS=IZPTS/6
C
      DO 25 K=1,(6+ABS(NATOMS))
         READ(13,*)
 25   CONTINUE
C
      DO 20 I=1,(IXPTS*IYPTS)
C
         DO 30 J=1,NGRPS
            READ(12,*) (P(K),K=1,6)
            READ(13,*) (Q(K),K=1,6)
            DO 40 K=1,6
               O(K)=P(K)-Q(K)
 40         CONTINUE
            WRITE(14,"(6(D13.5))") (O(K),K=1,6)
 30      CONTINUE
C
         IF (MODVAL.NE.0) THEN
            READ(12,*) (P(K),K=1,MODVAL)
            READ(13,*) (Q(K),K=1,MODVAL)
            DO 50 K=1,MODVAL
               O(K)=P(K)-Q(K)
 50         CONTINUE
            WRITE(14,"(6(D13.5))") (O(K),K=1,MODVAL)
         END IF
C
 20   CONTINUE
C
      I=ISHELL('cp denone.cube den.cube')
      I=ISHELL('cp dentwo.cube den2.cube')
      I=ISHELL('rm denone.cube dentwo.cube')
C     
      END SUBROUTINE DIF

      SUBROUTINE CLMOIO(ICORE,MAXCOR,NOCCO,NVRTO,IUHF)
C
C THIS ROUTINE CALCULATES THE ADDRESSES OF THE VARIOUS LISTS
C  IN THE MOINTS FILE.  
C
C THIS ROUTINE IS CALLED IN INTPRC TO INITIALIZE THE MOINTS FILE
C AND TO CREATE ALL THE INTEGRAL AND AMPLITUDE LISTS ON MOINTS
C (AT LEAST THE STANDARD LISTS)
C
CEND
      IMPLICIT INTEGER(A-H,O-Z)
      DOUBLE PRECISION DSPPCT
      LOGICAL DOALL,ABIJ,NOABCD
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      COMMON /CONTROL/ IPRNT,IXXX,IXXX2
      COMMON /DOINTS/ DOALL,ABIJ,NOABCD
      DIMENSION NOCCO(2),NVRTO(2),ICORE(MAXCOR)
      IX1(I)=(I*(I-1))/2
      IX2(I)=(I*(I+1))/2
      NOCCA=NOCCO(1)
      NOCCB=NOCCO(2)
      NVRTA=NVRTO(1)
      NVRTB=NVRTO(2)
      NINT=0
      NAMP=0
      IMODE=1
      IMODE3=1
      CALL IZERO(MOIO,8000)
      NFULL=NOCCA*NOCCB*NVRTA*NVRTB
C***********************************************************************
C PHHH INTEGRALS.
C
      IF(.NOT.ABIJ)THEN
       CALL INIPCK(1,3,16,7,IMODE,0,1)
       IF(IUHF.NE.0)THEN
        CALL INIPCK(1,4,17,8,IMODE,0,1)
        CALL INIPCK(1,14,11,9,IMODE,0,1)
       ENDIF
       CALL INIPCK(1,14,18,10,IMODE,0,1)
C***********************************************************************
C PHPH INTEGRALS.
C
       CALL INIPCK(1,9,9,23,IMODE,0,1)
       IF(IUHF.NE.0)CALL INIPCK(1,10,10,24,IMODE,0,1)
       CALL INIPCK(1,11,11,25,IMODE,0,1)
       IF(IUHF.NE.0)CALL INIPCK(1,12,12,26,IMODE,0,1)
C***********************************************************************
C PPPH INTEGRALS.
C
       CALL INIPCK(1,1,9,27,IMODE,0,1)
       IF(IUHF.NE.0)THEN
        CALL INIPCK(1,2,10,28,IMODE,0,1)
        CALL INIPCK(1,13,18,29,IMODE,0,1)
       ENDIF
       CALL INIPCK(1,13,11,30,IMODE,0,1)
      ENDIF
C**********************************************************************
C PPPP INTEGRALS.  AA TYPE ARE STORED SYMMETRY PACKED SO WE NEED
C  TO GET THE APPROPRIATE SYMMETRY INFORMATION FIRST.  THESE AND
C  THE HHHH INTEGRALS ARE DONE ONLY IF THE CALCLEVEL IS HIGHER THAN
C  MBPT(2).
C
      IF(.NOT.NOABCD)THEN
       IF(IUHF.NE.0)THEN
        CALL INIPCK(1,1,1,231,IMODE3,0,1)
        CALL INIPCK(1,2,2,232,IMODE3,0,1)
        CALL INIPCK(1,13,13,233,IMODE3,0,1)
       ELSE
C
C  CURRENTLY WE ARE USING FOR GRADIENT RUNS A DIFFERENT THAN IN
C  ENERGY CALCULATIONS
C
        IF(IFLAGS(3).NE.0.OR.IFLAGS(18).NE.0.OR.
     &     IFLAGS(19).NE.0) THEN
         CALL INIPCK(1,13,13,233,IMODE3,0,1)
        ELSE 
         CALL INIPCK(1,5,13,233,IMODE3,0,1)
        ENDIF
       ENDIF
      ENDIF
C**********************************************************************
C HHHH INTEGRALS.  AA TYPE ARE STORED SYMMETRY PACKED SO WE NEED
C  TO GET THE APPROPRIATE SYMMETRY INFORMATION FIRST.
C
      IF(.NOT.ABIJ)THEN
       IF(IUHF.NE.0)THEN
        CALL INIPCK(1,3,3,11,IMODE,0,1)
        CALL INIPCK(1,4,4,12,IMODE,0,1)
       ENDIF
       CALL INIPCK(1,14,14,13,IMODE,0,1)
      ENDIF
C***********************************************************************
C DENOMINATOR ARRAYS
C
      CALL INIPCK(1,1,3,48,IMODE,0,1)
      CALL INIPCK(1,13,14,50,IMODE,0,1)
      IF(IUHF.NE.0)CALL INIPCK(1,2,4,49,IMODE,0,1)
      IF(IFLAGS(21).NE.3)THEN
       CALL INIPCK(1,1,3,64,IMODE,0,1)
       CALL INIPCK(1,13,14,66,IMODE,0,1)
       IF(IUHF.NE.0)CALL INIPCK(1,2,4,65,IMODE,0,1)
      ENDIF
C***********************************************************************
C PPHH INTEGRALS.  THESE SIT NEXT TO T AMPLITUDES ON DISK.
C
      CALL INIPCK(1,1,3,14,IMODE,0,1)
      IF(IUHF.NE.0)THEN
       CALL INIPCK(1,2,4,15,IMODE,0,1)
       CALL INIPCK(1,10,9,17,IMODE,0,1)
       CALL INIPCK(1,10,10,20,IMODE,0,1)
       CALL INIPCK(1,12,11,22,IMODE,0,1)
      ENDIF
      CALL INIPCK(1,13,14,16,IMODE,0,1)
      CALL INIPCK(1,9,10,18,IMODE,0,1)
      CALL INIPCK(1,9,9,19,IMODE,0,1)
      CALL INIPCK(1,11,12,21,IMODE,0,1)
C
C***********************************************************************
C T2 AMPLITUDES (START ON PHYSICAL RECORD BOUNDARY)
C
      CALL INIPCK(1,13,14,46,IMODE,-1,1)
      CALL INIPCK(1,1,3,44,IMODE,0,1)
      IF(IUHF.NE.0)CALL INIPCK(1,2,4,45,IMODE,0,1)
C
C ONLY NEED THE REST FOR POST-MBPT(2) STUFF.
C
      IF(IFLAGS(2).GT.1)THEN
       CALL INIPCK(1,9,9,34,IMODE,0,1)
       CALL INIPCK(1,9,10,37,IMODE,0,1)
       CALL INIPCK(1,11,12,39,IMODE,0,1)
       IF(IUHF.NE.0)THEN
        CALL INIPCK(1,10,9,36,IMODE,0,1)
        CALL INIPCK(1,12,11,38,IMODE,0,1)
        CALL INIPCK(1,10,10,35,IMODE,0,1)
       ENDIF
      ENDIF
      IF(IFLAGS(1).GT.100)CALL FILSUM(IUHF)
      RETURN
      END

      SUBROUTINE DOT24X(IRREPCD,Z,D,Y,POPA,POPB,POPC,POPD,LISTG,
     &                  ISYMZ,ISYMD,ISYMY,TYPE,
     &                  IRRZ,IRRD,IRRY)
C
C *****     OUT-OF-CORE VERSION OF DOT24  ******
C
C ... BUT ALSO CAN HANDLE NONSYMMETRIC CASES!
C
C **IMPORTANT** THIS ROUTINE ASSUMES THAT THE SYMLOC COMMON
C BLOCK HAS BEEN FILLED BY CALLING ACES_COM_SYMLOC!!!!!
C
C THIS ROUTINE PERFORMS UNCOMPLICATED BUT MESSY CONTRACTIONS OF
C  THE GENERIC FORM
C
C      Z(P,Q) = D(M,N) * Y(MP,NQ)  [TYPE='STST']
C      
C      Z(P,Q) = D(M,N) * Y(PM,NQ)  [TYPE='TSST']
C
C      Z(P,Q) = D(M,N) * Y(PM,QN)  [TYPE='TSTS']
C
C      Z(P,Q) = D(M,N) * Y(MP,QN)  [TYPE='STTS']
C
C INPUT:
C       IRREPCD - SYMMETRY OF KET INDICES OF I
C       Z       - THE TARGET VECTOR
C       D       - THE TWO-INDEX QUANTITY WHICH WILL BE CONTRACTED WITH
C                 THE FOUR-INDEX LIST.
C       Y       - THE FOUR-INDEX QUANTITY (PROCESSED OUT OF CORE)
C       POPA  - POPULATION VECTOR FOR FASTEST INDEX IN Y.
C       POPB  - POPULATION VECTOR FOR SECOND FASTEST INDEX IN Y.
C       POPC  - POPULATION VECTOR FOR THIRD FASTEST INDEX IN Y.
C       POPD  - POPULATION VECTOR FOR SLOWEST INDEX IN Y.
C       ISYMZ - INDEX TYPE OF Z (SEE ACES_COM_SYMLOC)
C       ISYMD - INDEX TYPE OF D (SEE ACES_COM_SYMLOC)
C       ISYMY - INDEX TYPE OF Y BRA INDICES (SEE ACES_COM_SYMLOC)
C       TYPE  - SPECIFIES THE CONTRACTION TYPE
C       IRRZ  - OVERALL SYMMETRY OF Z
C       IRRD  - OVERALL SYMMETRY OF D
C       IRRY  - OVERALL SYMMETRY OF Y
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*4 TYPE
      INTEGER VRT,POP,DIRPRD,POPA,POPB,POPC,POPD
      DIMENSION Y(*),D(*),Z(*),POPA(*),POPB(*),POPC(*),POPD(*)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON/SYMINF/NSTART,NIRREP,IRREPY(255,2),DIRPRD(8,8)
      COMMON/SYMLOC/ISYMOFF(8,8,25)
C
      IF(TYPE.EQ.'STTS')THEN
C
C CASE I: Z(bc) = D(ad) * Y(ab,cd) 'STTS'
C
       ITHRU=1
       IRREPAB=DIRPRD(IRRY,IRREPCD)
       DO 20 IRREPD=1,NIRREP
        IRREPC=DIRPRD(IRREPD,IRREPCD)
        IRREPA=DIRPRD(IRRD,IRREPD)
        IRREPB=DIRPRD(IRRZ,IRREPC)
        NUMD=POPD(IRREPD)
        NUMC=POPC(IRREPC)
        NUMB=POPB(IRREPB)
        NUMA=POPA(IRREPA)
        DO 21 INDXD=1,NUMD
         DO 22 INDXC=1,NUMC
          CALL GETLST(Y,ITHRU,1,1,IRREPCD,LISTG)
          ITHRU=ITHRU+1
          IOFFD=NUMA*(INDXD-1)+ISYMOFF(IRREPD,IRRD,ISYMD)
          DO 23 INDXB=1,NUMB 
           IOFFZ=INDXB+NUMB*(INDXC-1)+ISYMOFF(IRREPC,IRRZ,ISYMZ)-1
           IOFFY=NUMA*(INDXB-1)+ISYMOFF(IRREPB,IRREPAB,ISYMY)
           Z(IOFFZ)=Z(IOFFZ)+SDOT(NUMA,D(IOFFD),1,Y(IOFFY),1)
23        CONTINUE
22       CONTINUE
21      CONTINUE
20     CONTINUE
C
      ELSEIF(TYPE.EQ.'TSST')THEN
C
C CASE II: Z(ad) = D(bc) * Y(ab,cd) 'TSST'
C
       ITHRU=1
       IRREPAB=DIRPRD(IRRY,IRREPCD)
       DO 30 IRREPD=1,NIRREP
        IRREPC=DIRPRD(IRREPD,IRREPCD)
        IRREPA=DIRPRD(IRRZ,IRREPD)
        IRREPB=DIRPRD(IRRD,IRREPC)
        NUMD=POPD(IRREPD)
        NUMC=POPC(IRREPC)
        NUMB=POPB(IRREPB)
        NUMA=POPA(IRREPA)
        DO 31 INDXD=1,NUMD
         DO 32 INDXC=1,NUMC
          CALL GETLST(Y,ITHRU,1,1,IRREPCD,LISTG)
          ITHRU=ITHRU+1
          IOFFD=NUMB*(INDXC-1)+ISYMOFF(IRREPC,IRRD,ISYMD)
          DO 33 INDXA=1,NUMA 
           IOFFZ=INDXA+NUMA*(INDXD-1)+ISYMOFF(IRREPD,IRRZ,ISYMZ)-1
           IOFFY=INDXA+ISYMOFF(IRREPB,IRREPAB,ISYMY)-1
           Z(IOFFZ)=Z(IOFFZ)+SDOT(NUMB,D(IOFFD),1,Y(IOFFY),NUMA)
33        CONTINUE
32       CONTINUE
31      CONTINUE
30     CONTINUE
C
      ELSEIF(TYPE.EQ.'STST')THEN
C
C CASE III: Z(bd) = D(ac) * Y(ab,cd) 'STST'
C
       ITHRU=1
       IRREPAB=DIRPRD(IRRY,IRREPCD)
       DO 40 IRREPD=1,NIRREP
        IRREPC=DIRPRD(IRREPD,IRREPCD)
        IRREPA=DIRPRD(IRRD,IRREPC)
        IRREPB=DIRPRD(IRRZ,IRREPD)
        NUMD=POPD(IRREPD)
        NUMC=POPC(IRREPC)
        NUMB=POPB(IRREPB)
        NUMA=POPA(IRREPA)
        DO 41 INDXD=1,NUMD
         DO 42 INDXC=1,NUMC
          CALL GETLST(Y,ITHRU,1,1,IRREPCD,LISTG)
          ITHRU=ITHRU+1
           IOFFD=NUMA*(INDXC-1)+ISYMOFF(IRREPC,IRRD,ISYMD)
          DO 43 INDXB=1,NUMB 
           IOFFZ=INDXB+NUMB*(INDXD-1)+ISYMOFF(IRREPD,IRRZ,ISYMZ)-1
           IOFFY=NUMA*(INDXB-1)+ISYMOFF(IRREPB,IRREPAB,ISYMY)
           Z(IOFFZ)=Z(IOFFZ)+SDOT(NUMA,D(IOFFD),1,Y(IOFFY),1)
43        CONTINUE
42       CONTINUE
41      CONTINUE
40     CONTINUE
C
      ELSEIF(TYPE.EQ.'TSTS')THEN
C
C CASE IV: Z(ac) = D(bd) * Y(ab,cd) 'TSTS'
C
       ITHRU=1
       IRREPAB=DIRPRD(IRRY,IRREPCD)
       DO 50 IRREPD=1,NIRREP
        IRREPC=DIRPRD(IRREPD,IRREPCD)
        IRREPA=DIRPRD(IRRZ,IRREPC)
        IRREPB=DIRPRD(IRRD,IRREPD)
        NUMD=POPD(IRREPD)
        NUMC=POPC(IRREPC)
        NUMB=POPB(IRREPB)
        NUMA=POPA(IRREPA)
        DO 51 INDXD=1,NUMD
         DO 52 INDXC=1,NUMC
          CALL GETLST(Y,ITHRU,1,1,IRREPCD,LISTG)
          ITHRU=ITHRU+1
          IOFFD=NUMB*(INDXD-1)+ISYMOFF(IRREPD,IRRD,ISYMD)
          DO 53 INDXA=1,NUMA 
           IOFFZ=INDXA+NUMA*(INDXC-1)+ISYMOFF(IRREPC,IRRZ,ISYMZ)-1
           IOFFY=INDXA+ISYMOFF(IRREPB,IRREPAB,ISYMY)-1
           Z(IOFFZ)=Z(IOFFZ)+SDOT(NUMB,D(IOFFD),1,Y(IOFFY),NUMA)
53        CONTINUE
52       CONTINUE
51      CONTINUE
50     CONTINUE
C
      ELSE
C
       WRITE(6,1000)TYPE
1000   FORMAT(T3,'@DOT24X-F, Contraction type ',A4,' unknown.')
       CALL ERREX
C
      ENDIF
C
      RETURN
      END

C GENERATE DIIS EXPANSION COEFFICIENTS, GIVEN THE ERROR MATRIX

      SUBROUTINE DODIIS(ERR,AUGERR,TMP,NPHYS,NDIM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION ERR(NPHYS,NPHYS),AUGERR(NPHYS+1,NPHYS+2)
      DIMENSION TMP(*)
      integer    MaxDim
      parameter (MaxDim=64)
      integer ipiv(MaxDim)

      if (ndim.lt.0) then
         print *, '@DODIIS: Assertion failed.'
         print *, '         ndim = ',ndim
         call errex
      end if
c what if ndim == 0?

      if (ndim.ge.MaxDim) then
         print *, '@DODIIS: Assertion failed.'
         print *, '         maxdim = ',maxdim
         print *, '         ndim   = ',ndim
         call aces_exit(1)
      end if
c   o build R (column ndim+2 is the RHS vector)
      augerr(1,1)      =  0.d0
      augerr(1,ndim+2) = -1.d0
      do j = 0, ndim-1
         augerr(2+j,1) = -1.d0
         augerr(1,2+j) = -1.d0
         do i = 0, ndim-1
            augerr(2+i,2+j) = err(1+i,1+j)
         end do
         augerr(2+j,ndim+2) = 0.d0
      end do
c   o get the lambda/coefficient vector
c      call c_gtod(is0,ius0)
c MINV  takes 0.0001s for a 6x6 on crisp
c DSYSV takes 0.0001s for a 6x6 on crisp
c DGESV takes 0.00009s for a 6x6 on crisp
      call dgesv(ndim+1,1,augerr,nphys+1,ipiv,
     &                    augerr(1,ndim+2),nphys+1,i)
c      call c_gtod(is1,ius1)
      if (i.ne.0) then
         print *, '@DODIIS: linear solver failed'
         print *, '         INFO = ',i
         call aces_exit(i)
      end if
c      print *, '@DODIIS: linear solver took ',
c     &         is1-is0+1.d-6*(ius1-ius0),' seconds'
      do i = 1, ndim
         tmp(i) = augerr(1+i,ndim+2)
      end do
      RETURN
      END

         SUBROUTINE  ERD__INT2D_TO_E0F0_F12
     +
     +                    ( SHELLA,SHELLP,SHELLC,SHELLQ,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__INT2D_TO_E0F0
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                eris [E0|F0] , E = A to P, F = C to Q, adding up all
C                the contributions from all the 2D PQ integrals.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                2DX and 2DY integrals, which can be achieved by having
C                the outer loops run over all possible x and y monomial
C                parts and the inner loops over all allowed E and F
C                shell combinations. The price to pay for such loop
C                ordering is the scattered addressing of locations
C                within the batch array, which has its rows and columns
C                ordered such that the E and F shells are increasing
C                and within each E and F shell the monomials are
C                ordered such that x>y>z in exponents.
C
C                An example follows:
C                -------------------
C
C                Let E = 0,2 and F = 0,1. Then we have the left and
C                right hand of the batch array ordered as follows:
C
C                          left xyz        right xyz
C
C                             000             000
C                             ---             ---
C                             100             100
C                             010             010
C                             001             001
C                             ---
C                             200 -> -5
C                             110
C                             101 -> -3
C                             020
C                             011
C                             002 -> 0
C                        
C                The batch would thus have dimensions 10 x 4. For
C                the left side (and analogous for the right side) the
C                reduced multiplication scheme would have its outer
C                most loop run over x=0,2, followed by the next loop
C                y=0,2-x. The innermost loop would then run over the
C                allowed shells E=E(max),max(E(min),x+y). In this
C                case all x,y-pairs can be reused for all appropriate
C                shell combinations.
C
C                To find the address of a specific x,y,z,E combination
C                inside the batch array, we first note that the z-part
C                is dependent on the x,y-parts and is hence not needed.
C                Lets look at the E-part first. The E-part is evaluated
C                from its dimension formula (E+1)*(E+2)/2. Organizing
C                the inner E-loop to run from E(max) always, the
C                dimension for E(max) is passed as the argument NXYZP
C                and all lower E dimensions are calculated by the
C                formula relating dimensions between E and E+1:
C
C                           dim(E+1) = dim(E) + E + 2
C
C                In this way multiplications in the E-part can be
C                entirely avoided. The x,y-part is defined as the
C                part which has to be subtracted from dim(E) to
C                reach the xyz monomial position inside the E shell.
C                It can be divided into an x-part and a y-part. The
C                x-part is given by the fomula:
C
C                          x-part = - x*E + x(x-3)/2
C
C                and for the example above has been given for E=2
C                and marked with arrows ->. The last term of the x-part
C                involves 1 multiplication and division, however it
C                can be changed to:
C
C                                               x-1
C                          x-part = - x*E - x + sum i
C                                               i=0
C
C                and clever additions inside the x-loop avoid the use
C                of multiplications and divisions. The y-part is trivial
C                and is simply equal to -y. The overall conclusion is
C                thus that the location of a specific x,y,z,E quadruple
C                inside the batch comes at the cost of one x*E(max)
C                multiplication in the outermost x-loops, since the
C                other x*E ones can again be reached via stepwise
C                subtraction of x from x*E(max).
C
C                Due to the very computational intensive steps inside
C                the x,y,z,E loops, special sections of identical
C                x,y,z,E loop structers have been given for each
C                # of roots =< 9, thus saving considerable computing
C                time over the general case.
C
C                For comments on how the x,y,z,E loop structures are
C                coded please refer to the general root case.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A,C and csh sums P=A+B,Q=C+D
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZE(F)T   =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B and in the range
C                                   F = C,...,Q=C+D
C                    NXYZy       =  # of cartesian monomials for
C                                   y = P,Q shells
C                    INT2Dx      =  all current 2D PQ integrals for
C                                   each cartesian component
C                                   (x = X,Y,Z)
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D PQ integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [E0|F0] integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,J,K,M,N
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZE,NXYZF,NXYZET,NXYZFT,NXYZP,NXYZQ
         INTEGER     SE,SF
         INTEGER     SEEND,SFEND
         INTEGER     SHELLA,SHELLP,SHELLC,SHELLQ
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX,XFMAX
         INTEGER     XEP,XFP,XYEP,XYFP
         INTEGER     XF,YF,ZF
         INTEGER     XYE,XYF
         INTEGER     YEEND,YFEND

         DOUBLE PRECISION  SUM,STGEXP,UVAL(1:NEXQ)
         DOUBLE PRECISION  ZERO,RTS(1:NGQEXQ),QQQ

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ,1:NXYZET,1:NXYZFT)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP,0:SHELLQ)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XFP = NXYZFT + 3
         DO 100 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 102 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 110 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 112 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M)
                         END DO
                     ELSE
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M) * INT2DY (M,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 120 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 122 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = ( TEMP2 (M)*(1.d0-RTS(M) )
     +                                     )*(2.d0*UVAL(M)/STGEXP)
                               END DO
                           ELSE
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = (  TEMP2 (M)*(1.d0-RTS(M) )
     +                                       * INT2DZ (M,ZE,ZF)
     +                                     )*(2.d0*UVAL(M)/STGEXP) 
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  122                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  120                CONTINUE
  112             CONTINUE
  110          CONTINUE
  102       CONTINUE
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XFP = NXYZFT + 3
         DO 200 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 202 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 210 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 212 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 220 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 222 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                     )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 2
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                 * INT2DZ (K,ZE,ZF)
     +                                 + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                     )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 2
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  222                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  220                CONTINUE
  212             CONTINUE
  210          CONTINUE
  202       CONTINUE
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XFP = NXYZFT + 3
         DO 300 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 302 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 310 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 312 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 320 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 322 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = (  TEMP2 (K)*(1.d0-RTS(K)   )
     +                                    + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                    + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                           )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 3
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = (  TEMP2 (K)*(1.d0-RTS(K)  )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                           )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 3
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  322                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  320                CONTINUE
  312             CONTINUE
  310          CONTINUE
  302       CONTINUE
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XFP = NXYZFT + 3
         DO 400 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 402 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 410 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 412 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 420 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 422 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) =( TEMP2 (K)*(1.d0-RTS(K) )
     +                                  + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                  + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                  + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                           )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 4
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) =( TEMP2 (K)*(1.d0-RTS(K) )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                   + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                    )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 4
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  422                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  420                CONTINUE
  412             CONTINUE
  410          CONTINUE
  402       CONTINUE
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XFP = NXYZFT + 3
         DO 500 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 502 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 510 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 512 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 520 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 522 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                          BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                  + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                  + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                  + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                  + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                    )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 5
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                          BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                  + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                  + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                  + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                  + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                    )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 5
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  522                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  520                CONTINUE
  512             CONTINUE
  510          CONTINUE
  502       CONTINUE
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XFP = NXYZFT + 3
         DO 600 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 602 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 610 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 612 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 620 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 622 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                        BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                  )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 6
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                        BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                  )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 6
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  622                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  620                CONTINUE
  612             CONTINUE
  610          CONTINUE
  602       CONTINUE
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XFP = NXYZFT + 3
         DO 700 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 702 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 710 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 712 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 720 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 722 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) =(  TEMP2 (K)*(1.d0-RTS(K) )
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                   + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                   + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                   + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                   + TEMP2 (K+6)*(1.d0-RTS(K+6) )
     +                                    )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 7
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                            BATCH (M,I,J) =( TEMP2 (K)*(1.d0-RTS(K) )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                    + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                    + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                    + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                    + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                    + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                    + TEMP2 (K+6)*(1.d0-RTS(K+6) )
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                    )*(2.d0*UVAL(M)/STGEXP) 
                                  K = K + 7
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  722                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  720                CONTINUE
  712             CONTINUE
  710          CONTINUE
  702       CONTINUE
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XFP = NXYZFT + 3
         DO 800 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 802 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 810 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 812 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 820 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 822 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) =( TEMP2 (K)*(1.d0-RTS(K) )
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                   + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                   + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                   + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                   + TEMP2 (K+6)*(1.d0-RTS(K+6) )
     +                                   + TEMP2 (K+7)*(1.d0-RTS(K+7) )
     +                                    )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 8
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) =( TEMP2 (K)*(1.d0-RTS(K) )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                   + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                   + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                   + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                   + TEMP2 (K+6)*(1.d0-RTS(K+6) )
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                   + TEMP2 (K+7)*(1.d0-RTS(K+7) )
     +                                            * INT2DZ (K+7,ZE,ZF)
     +                                   )*(2.d0*UVAL(M)/STGEXP)  
                                  K = K + 8
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  822                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  820                CONTINUE
  812             CONTINUE
  810          CONTINUE
  802       CONTINUE
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XFP = NXYZFT + 3
         DO 900 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 902 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 910 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 912 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 920 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 922 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                   + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                   + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                   + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                   + TEMP2 (K+6)*(1.d0-RTS(K+6) )
     +                                   + TEMP2 (K+7)*(1.d0-RTS(K+7) )
     +                                   + TEMP2 (K+8)*(1.d0-RTS(K+8) )
     +                                     )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 9
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                           BATCH (M,I,J) = ( TEMP2 (K)*(1.d0-RTS(K) )
     +                                            * INT2DZ (K,ZE,ZF)
     +                                   + TEMP2 (K+1)*(1.d0-RTS(K+1) )
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                   + TEMP2 (K+2)*(1.d0-RTS(K+2) )
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                   + TEMP2 (K+3)*(1.d0-RTS(K+3) )
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                   + TEMP2 (K+4)*(1.d0-RTS(K+4) )
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                   + TEMP2 (K+5)*(1.d0-RTS(K+5) )
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                   + TEMP2 (K+6)*(1.d0-RTS(K+6) )
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                   + TEMP2 (K+7)*(1.d0-RTS(K+7) )
     +                                            * INT2DZ (K+7,ZE,ZF)
     +                                   + TEMP2 (K+8)*(1.d0-RTS(K+8) )
     +                                            * INT2DZ (K+8,ZE,ZF)
     +                                     )*(2.d0*UVAL(M)/STGEXP)
                                  K = K + 9
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  922                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  920                CONTINUE
  912             CONTINUE
  910          CONTINUE
  902       CONTINUE
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x-pairs. No skipping of the
C                x,x-contribution of 0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XFP = NXYZFT + 3
         DO 1000 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 1002 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO
C
C
C             ...middle loops over y,y-pairs. Skip multiplication
C                of y,y-contributions, if we have a 0,0-pair, as
C                then the 2DY integral is equal to 1.
C
C
               XYFP = XFP - XFMAX
               DO 1010 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 1012 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF
C
C
C             ...inner loops over E,F-pairs. Skip multiplication
C                of z,z-contributions, if we have a 0,0-pair, as
C                then the 2DZ integral is equal to 1.
C
C
                     J = XYFP
                     NXYZF = NXYZQ
                     DO 1020 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 1022 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
C
C
C             ...all info concerning all three x,x-, y,y- and z,z-pairs
C                have been collected for all exponent quadruplets at
C                once. Sum up the 2D X,Y,Z integral products to the
C                appropriate place of the [E0|F0] batch.
C
C
                           IF (ZE+ZF.EQ.0) THEN
                               K = 0
                               DO M = 1,NEXQ
                                  SUM = ZERO
                                  DO N = 1,NGQP
                              QQQ = TEMP2 (K+N)*(1.d0-RTS(N+K) )
                              SUM = SUM + QQQ
                                  END DO
                                  K = K + NGQP
                              BATCH (M,I,J) = SUM*(2.d0*UVAL(M)/STGEXP)
                               END DO
                           ELSE
                               K = 0
                               DO M = 1,NEXQ
                                  SUM = ZERO
                                  DO N = 1,NGQP
                     QQQ=TEMP2(K+N)*(1.d0-RTS(N+K) )* INT2DZ(K+N,ZE,ZF)
                              SUM = SUM + QQQ
                                  END DO
                                  K = K + NGQP
                              BATCH (M,I,J) = SUM*(2.d0*UVAL(M)/STGEXP)
                               END DO
                           END IF
C
C
C             ...next z,z-pair.
C
C
                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
 1022                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
 1020                CONTINUE
C
C
C             ...next y,y-pair and next x,x-pair.
C
C
 1012             CONTINUE
 1010          CONTINUE
 1002       CONTINUE
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__DERV_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      NINT2DX,NINT2DY,NINT2DZ,
     +                      ATOMAB,ATOMCD,
     +                      MIJ,MKL,MIJKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NGQP,NMOM,NGQSCR,MGQIJKL,
     +                      NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                      NZSHELL,NZNXYZ,
     +                      NXYZET,NXYZP,
     +                      NXYZA,NXYZB,NXYZC,NXYZD,
     +                      SHELLA,SHELLB,SHELLC,SHELLD,
     +                      SHELLP,SHELLQ,SHELLT,
     +                      XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD,
     +                      ABX,ABY,ABZ,CDX,CDY,CDZ,
     +                      NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DERCX,DERCY,DERCZ,
     +                      DERDX,DERDY,DERDZ,
     +                      DERPX,DERPY,DERPZ,
     +                      DERQX,DERQY,DERQZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      DIFFA,DIFFB,DIFFC,DIFFD,
     +                      PRIMTYP,ANGMTYP,
     +                      ALPHAA,ALPHAB,ALPHAC,ALPHAD,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      CENEQS,
     +                      CENSQX,CENSQY,CENSQZ,
     +                      PRIMA,PRIMB,PRIMC,PRIMD,
     +                      NORMA,NORMB,NORMC,NORMD,
     +                      RHOAB,RHOCD,
     +                      P,PX,PY,PZ,PAX,PAY,PAZ,PINVHF,SCALEP,
     +                      Q,QX,QY,QZ,QCX,QCY,QCZ,QINVHF,SCALEQ,
     +                      RTS,WTS,GQSCR,TVAL,PQPINV,SCALEPQ,
     +                      B00,B01,B10,C00X,C00Y,C00Z,D00X,D00Y,D00Z,
     +                      EXP2A,EXP2B,EXP2C,EXP2D,
     +                      INT2DX,INT2DY,INT2DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_PCGTO_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__RYS_ROOTS_WEIGHTS
C                ERD__2D_COEFFICIENTS
C                ERD__2D_PCD_INTEGRALS
C                ERD__2D_DERV_PCD_INTEGRALS
C                ERD__2D_ABCD_INTEGRALS
C                ERD__2D_DERV_ABCD_INTEGRALS
C                ERD__DERV_INT2D_TO_0000
C                ERD__DERV_INT2D_TO_E0C0
C                ERD__DERV_INT2D_TO_E0CD
C                ERD__DERV_INT2D_TO_A000
C                ERD__DERV_INT2D_TO_AB00
C                ERD__DERV_INT2D_TO_ABC0
C                ERD__DERV_INT2D_TO_ABCD
C  DESCRIPTION : This operation calculates a batch of derivated
C                unnormed electron repulsion integrals between
C                primitive cartesian gaussians.
C
C                The shell quadruplet ranges depend on where the
C                derivation is being performed:
C
C                   i) Derivation(s) on centers C and/or D:
C
C                        [E0|CD]     , E = A to P
C                               ijkl
C
C                  ii) Derivation(s) on centers (A and/or B)
C                      and on centers (C and/or D):
C
C                        [AB|CD]
C                               ijkl
C
C                The index ijkl stands for the block of ij and kl
C                exponent pairs used. The total number of eris
C                generated here is thus also determined by the
C                center(s) of derivation(s):
C
C                   Case i) # of eris: NXYZT = NXYZET*NXYZC*NXYYD
C                  Case ii) # of eris: NXYZT = NXYZA*NXYZB*NXYZC*NXYYD
C
C                times the total number of exponent pairs MIJKL in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (kl,ij,nxyzt)
C
C
C                  Input:
C
C                    NBATCH       =  size of the array that will hold
C                                    the final primitive cartesian
C                                    derivative integral batch as well
C                                    as intermediate differentiated
C                                    2D integrals
C                    NINT2Dx      =  space needed for each of the 2D
C                                    x = X,Y,Z integral arrays (they
C                                    might be different due to different
C                                    orders of differentiation for
C                                    each cartesian component)
C                    ATOMAB(CD)   =  indicates, if centers A and B
C                                    (C and D) coincide
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the contracted shell pairs A,B
C                                    (C,D)
C                    MIJKL        =  current # of ijkl primitive
C                                    index quadruplets (= MIJ*MKL)
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NKL          =  total # of kl primitive index
C                                    pairs for the contracted shell
C                                    pair C,D
C                    NKLBEG(END)  =  first(last) kl primitive index
C                                    defining the kl block
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    MGQIJKL      =  # of roots times # of ijkl
C                                    quadruplets (= NGQP*MIJKL)
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B,C,D
C                    NXYZET       =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    E = A,...,P=A+B
C                    NXYZP        =  # of cartesian monomials for
C                                    the P=A+B shell
C                    NXYZx        =  # of cartesian monomials for
C                                    each contraction shell x = A,B,C,D
C                    SHELLx       =  the shell type for each contraction
C                                    shell x = A,B,C,D
C                    SHELLx       =  the shell type summations for
C                                    shells x = P=A+B,Q=C+D,T=A+B+C+D
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B,C,D
C                    ABm(CDm)     =  the m=x,y,z-coordinate differences
C                                    between centers A and B (C and D)
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERxp        =  the order of differentiation on
C                                    centers x = A,B,C,D,P=A+B,Q=C+D
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DIFFp        =  is true, if differentiation will be
C                                    performed on centers p = A,B,C,D
C                                    involving the p = x,y,z coordinates
C                    PRIMTYP      =  character variable, indicating
C                                    which type of primitives will
C                                    be generated and contracted. Can
C                                    be only 'E0CD' or 'ABCD'
C                    ANGMTYP      =  character variable, indicating
C                                    the overall angular momentum type
C                                    combination without observing
C                                    the order. Can be only 'SSSS',
C                                    'SSSX','SSXX','SXXX' or 'XXXX',
C                                    where the S-symbol indicates the
C                                    presence of an s-shell and the
C                                    X-symbol the presence of a shell
C                                    >= p-shell
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B,C,D
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    CENEQS (I,J) =  center equality indicator of size
C                                    4 x 4. The matrix is defined as
C                                    follows: if the centers indexed by
C                                    I and J are equal => value = 1,
C                                    if not => value = 0. The indices
C                                    correspond to the A,B,C,D ordering,
C                                    i.e. 1st index -> A, 2nd -> B, etc
C                    CENSQp       =  center differentiation sequence
C                                    array for the p = x,y,z coordinates
C                    PRIMx        =  i,j,k,l labels of primitives for
C                                    the respective contraction shells
C                                    x = A,B,C,D
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B,C,D
C                    RHOAB(CD)    =  the complete set of NIJ (NKL)
C                                    exponential prefactors between
C                                    contraction shells A and B
C                                    (C and D)
C                    P            =  will hold current MIJ exponent
C                                    sums for contraction shells A
C                                    and B
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=A+B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALEP       =  will hold current MIJ values of
C                                    scaling factors related to point P
C                    Q            =  will hold current MKL exponent
C                                    sums for contraction shells C
C                                    and D
C                    Qx           =  will hold current MKL coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers Q=C+D
C                    QCx          =  will hold current MKL coordinate
C                                    x=X,Y,Z differences Q-C between
C                                    centers Q and C
C                    QINVHF       =  will hold current MKL values of
C                                    1/(2*Q), where Q are the exponent
C                                    sums for contraction shells C
C                                    and D
C                    SCALEQ       =  will hold current MKL values of
C                                    scaling factors related to point Q
C                    RTS          =  will hold all current MGQIJKL
C                                    quadrature roots
C                    WTS          =  will hold all current MGQIJKL
C                                    quadrature weights
C                    GQSCR        =  will be used as scratch space
C                                    for determining the quadrature
C                                    roots and weights
C                    TVAL         =  will hold current MIJKL values
C                                    of T-exponents defining the Rys
C                                    weight functions
C                    PQPINV       =  will hold current MIJKL values
C                                    of 1/(P+Q), i.e. the inverses
C                                    of all total exponent sums
C                    SCALEPQ      =  will hold current distinct MIJKL
C                                    (expanded to MGQIJKL) values of
C                                    the overal scaling factors for
C                                    the derivative integrals
C                    Bxx          =  will hold the current MGQIJKL
C                                    coordinate independent VRR
C                                    B-coefficients (xx=00,01,10)
C                    C00x         =  will hold the current MGQIJKL
C                                    VRR C-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    D00x         =  will hold the current MGQIJKL
C                                    VRR D-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center Q
C                    EXP2x        =  will hold current double primitive
C                                    exponent values in MIJKL order
C                                    (expanded to MGQIJKL) for each
C                                    contracted shell x = A,B,C,D
C                    INT2Dx       =  will hold all current derivated
C                                    2D integrals for each cartesian
C                                    component (x = X,Y,Z) during all
C                                    stages of differentiation
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    derivative cartesian [E0|CD] or
C                                    [AB|CD] integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT      NONE

         LOGICAL       ATOMAB,ATOMCD
         LOGICAL       DIFFA,DIFFB,DIFFC,DIFFD
         LOGICAL       DIFFX,DIFFY,DIFFZ

         CHARACTER*4   ANGMTYP
         CHARACTER*4   PRIMTYP

         INTEGER       CASE2D,CASEAT
         INTEGER       CENTER
         INTEGER       DER1,DER2,DER3,DER4
         INTEGER       DERAX,DERBX,DERCX,DERDX
         INTEGER       DERAY,DERBY,DERCY,DERDY
         INTEGER       DERAZ,DERBZ,DERCZ,DERDZ
         INTEGER       DEROP1,DEROP2,DEROP3,DEROP4
         INTEGER       DERPX,DERPY,DERPZ
         INTEGER       DERQX,DERQY,DERQZ
         INTEGER       G000,G010,G020,G030,G040,G050,G060
         INTEGER       I,J,K,L,M,N
         INTEGER       IJ,KL
         INTEGER       MGRID,NGRID
         INTEGER       MIJ,MKL,MIJKL,MGQKL,MGQIJKL
         INTEGER       NBATCH
         INTEGER       NDERX,NDERY,NDERZ
         INTEGER       NGQP,NMOM,NGQSCR
         INTEGER       NIJ,NKL
         INTEGER       NIJBEG,NIJEND,NKLBEG,NKLEND
         INTEGER       NINT,NINT2DX,NINT2DY,NINT2DZ
         INTEGER       NPGTOA,NPGTOB,NPGTOC,NPGTOD
         INTEGER       NXYZET,NXYZP
         INTEGER       NXYZA,NXYZB,NXYZC,NXYZD
         INTEGER       SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER       SHELLP,SHELLQ,SHELLT

         INTEGER       CENSQX (0:NDERX)
         INTEGER       CENSQY (0:NDERY)
         INTEGER       CENSQZ (0:NDERZ)

         INTEGER       NZNXYZ  (1:4)
         INTEGER       NZSHELL (1:4)

         INTEGER       PRIMA  (1:MIJ)
         INTEGER       PRIMB  (1:MIJ)
         INTEGER       PRIMC  (1:MKL)
         INTEGER       PRIMD  (1:MKL)

         INTEGER       CENEQS (1:4,1:4)

         DOUBLE PRECISION  ABX,ABY,ABZ,CDX,CDY,CDZ
         DOUBLE PRECISION  EXPA,EXPB,EXPC,EXPD
         DOUBLE PRECISION  INVERS
         DOUBLE PRECISION  PINV,QINV,PVAL,QVAL
         DOUBLE PRECISION  PQPLUS,PQMULT
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL
         DOUBLE PRECISION  RNPQSQ
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD
         DOUBLE PRECISION  ZERO,HALF,ONE

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)
         DOUBLE PRECISION  ALPHAC  (1:NPGTOC)
         DOUBLE PRECISION  ALPHAD  (1:NPGTOD)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)
         DOUBLE PRECISION  NORMC   (1:NPGTOC)
         DOUBLE PRECISION  NORMD   (1:NPGTOD)

         DOUBLE PRECISION  RHOAB   (1:NIJ)
         DOUBLE PRECISION  RHOCD   (1:NKL)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  P       (1:MIJ)
         DOUBLE PRECISION  PX      (1:MIJ)
         DOUBLE PRECISION  PY      (1:MIJ)
         DOUBLE PRECISION  PZ      (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)
         DOUBLE PRECISION  SCALEP  (1:MIJ)

         DOUBLE PRECISION  Q       (1:MKL)
         DOUBLE PRECISION  QX      (1:MKL)
         DOUBLE PRECISION  QY      (1:MKL)
         DOUBLE PRECISION  QZ      (1:MKL)
         DOUBLE PRECISION  QCX     (1:MKL)
         DOUBLE PRECISION  QCY     (1:MKL)
         DOUBLE PRECISION  QCZ     (1:MKL)
         DOUBLE PRECISION  QINVHF  (1:MKL)
         DOUBLE PRECISION  SCALEQ  (1:MKL)

         DOUBLE PRECISION  B00     (1:MGQIJKL)
         DOUBLE PRECISION  B01     (1:MGQIJKL)
         DOUBLE PRECISION  B10     (1:MGQIJKL)
         DOUBLE PRECISION  C00X    (1:MGQIJKL)
         DOUBLE PRECISION  C00Y    (1:MGQIJKL)
         DOUBLE PRECISION  C00Z    (1:MGQIJKL)
         DOUBLE PRECISION  D00X    (1:MGQIJKL)
         DOUBLE PRECISION  D00Y    (1:MGQIJKL)
         DOUBLE PRECISION  D00Z    (1:MGQIJKL)
         DOUBLE PRECISION  EXP2A   (1:MGQIJKL)
         DOUBLE PRECISION  EXP2B   (1:MGQIJKL)
         DOUBLE PRECISION  EXP2C   (1:MGQIJKL)
         DOUBLE PRECISION  EXP2D   (1:MGQIJKL)
         DOUBLE PRECISION  RTS     (1:MGQIJKL)
         DOUBLE PRECISION  SCALEPQ (1:MGQIJKL)
         DOUBLE PRECISION  WTS     (1:MGQIJKL)
         DOUBLE PRECISION  GQSCR   (1:NGQSCR)
         DOUBLE PRECISION  TVAL    (1:MIJKL)
         DOUBLE PRECISION  PQPINV  (1:MIJKL)

         DOUBLE PRECISION  INT2DX  (1:NINT2DX)
         DOUBLE PRECISION  INT2DY  (1:NINT2DY)
         DOUBLE PRECISION  INT2DZ  (1:NINT2DZ)

         DOUBLE PRECISION  FTABLE  (0:MGRID,0:NGRID)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (HALF  =  0.5D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...predetermine in 'K2' loops the quantities associated
C                with the A,B-part and C,D-part. Set the atom equality
C                case CASEAT here to exploit simplifications due to
C                center equalities later on:
C
C                CASEAT = 1  -->  2-center (AA|CC) derivative integrals
C                       = 2  -->  3-center (AB|CC) derivative integrals
C                       = 3  -->  3-center (AA|CD) derivative integrals
C                       = 4  -->  4-center (AB|CD) derivative integrals
C
C
         CASEAT = 4

         IF (ATOMAB) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                PVAL = ALPHAA (I) + ALPHAB (J)
                P (M) = PVAL
                PX (M) = XA
                PY (M) = YA
                PZ (M) = ZA
                PINVHF (M) = HALF / PVAL
                SCALEP (M) = NORMA (I) * NORMB (J)
  100        CONTINUE
             CASEAT = CASEAT - 1
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                PVAL = EXPA + EXPB
                PINV = ONE / PVAL
                P (M) = PVAL
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PX (M) = PAX (M) + XA
                PY (M) = PAY (M) + YA
                PZ (M) = PAZ (M) + ZA
                PINVHF (M) = HALF * PINV
                SCALEP (M) = NORMA (I) * NORMB (J) * RHOAB (IJ)
  110        CONTINUE
         END IF

         IF (ATOMCD) THEN
             M = 0
             DO 200 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIMC (M)
                L = PRIMD (M)
                QVAL = ALPHAC (K) + ALPHAD (L)
                Q (M) = QVAL
                QX (M) = XC
                QY (M) = YC
                QZ (M) = ZC
                QINVHF (M) = HALF / QVAL
                SCALEQ (M) = NORMC (K) * NORMD (L)
  200        CONTINUE
             CASEAT = CASEAT - 2
         ELSE
             M = 0
             DO 220 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIMC (M)
                L = PRIMD (M)
                EXPC = ALPHAC (K)
                EXPD = ALPHAD (L)
                QVAL = EXPC + EXPD
                QINV = ONE / QVAL
                Q (M) = QVAL
                QVAL = - EXPD * QINV
                QCX (M) = QVAL * CDX
                QCY (M) = QVAL * CDY
                QCZ (M) = QVAL * CDZ
                QX (M) = QCX (M) + XC
                QY (M) = QCY (M) + YC
                QZ (M) = QCZ (M) + ZC
                QINVHF (M) = HALF * QINV
                SCALEQ (M) = NORMC (K) * NORMD (L) * RHOCD (KL)
  220        CONTINUE
         END IF
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block to calculate all T's
C                and scaling factors for the cases:
C
C                CASEAT = 1  -->  2-center (AA|CC) derivative integrals
C                       = 2  -->  3-center (AB|CC) derivative integrals
C                       = 3  -->  3-center (AA|CD) derivative integrals
C                       = 4  -->  4-center (AB|CD) derivative integrals
C
C                4-center (AB|CD) integrals are checked first
C                (most common occurence in large systems).
C
C
         IF (CASEAT.EQ.4) THEN

             M = 1
             DO 4000 IJ = 1,MIJ
                PVAL = P (IJ)
                PXVAL = PX (IJ)
                PYVAL = PY (IJ)
                PZVAL = PZ (IJ)
                PSCALE = SCALEP (IJ)
                DO 4400 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS
                   PQX = PXVAL - QX (KL)
                   PQY = PYVAL - QY (KL)
                   PQZ = PZVAL - QZ (KL)

                   TVAL (M) = (PQX * PQX + PQY * PQY + PQZ * PQZ)
     +                                  * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 4400           CONTINUE
 4000        CONTINUE

         ELSE IF (CASEAT.EQ.3) THEN

             M = 1
             DO 3000 IJ = 1,MIJ
                PVAL = P (IJ)
                PSCALE = SCALEP (IJ)
                DO 3300 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS
                   PQX = XA - QX (KL)
                   PQY = YA - QY (KL)
                   PQZ = ZA - QZ (KL)

                   TVAL (M) = (PQX * PQX + PQY * PQY + PQZ * PQZ)
     +                                  * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 3300           CONTINUE
 3000        CONTINUE

         ELSE IF (CASEAT.EQ.2) THEN

             M = 1
             DO 2000 IJ = 1,MIJ
                PVAL = P (IJ)
                PXVAL = PX (IJ)
                PYVAL = PY (IJ)
                PZVAL = PZ (IJ)
                PQX = PXVAL - XC
                PQY = PYVAL - YC
                PQZ = PZVAL - ZC
                RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
                PSCALE = SCALEP (IJ)
                DO 2200 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS

                   TVAL (M) = RNPQSQ * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 2200           CONTINUE
 2000        CONTINUE

         ELSE

             PQX = XA - XC
             PQY = YA - YC
             PQZ = ZA - ZC
             RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

             M = 1
             DO 1000 IJ = 1,MIJ
                PVAL = P (IJ)
                PSCALE = SCALEP (IJ)
                DO 1100 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS

                   TVAL (M) = RNPQSQ * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 1100           CONTINUE
 1000        CONTINUE

         END IF
C
C
C             ...if necessary, expand the scaling array size from
C                MIJKL to MGQIJKL starting from the last elements.
C
C
         IF (NGQP.GT.1) THEN
             N = MGQIJKL + 1
             DO 10 M = MIJKL,1,-1
                DO 20 I = 1,NGQP
                   SCALEPQ (N-I) = SCALEPQ (M)
   20           CONTINUE
                N = N - NGQP
   10        CONTINUE
         END IF
C
C
C             ...determine memory allocation offsets for the scratch
C                arrays used to calculate the quadrature roots +
C                weights:
C
C                   G000 = offset for A coefficients (Jacobi/Laguerre)
C                   G010 = offset for B coefficients (Jacobi/Laguerre)
C                   G020 = offset for moments (Jacobi/Laguerre)
C                   G030 = offset for diagonals of symmetric termat
C                   G040 = offset for offdiagonals of symmetric termat
C                   G050 = offset for first row intermediates during
C                          evaluation of symmetric termat
C                   G060 = offset for second row intermediates during
C                          evaluation of symmetric termat
C
C
         G000 = 1
         G010 = G000 + NMOM
         G020 = G010 + NMOM - 1
         G030 = G020 + NMOM
         G040 = G030 + NGQP
         G050 = G040 + NGQP
         G060 = G050 + NMOM
C
C
C             ...calculate all roots and weights. Array B00 is passed
C                as a scratch array.
C
C
         CALL    ERD__RYS_ROOTS_WEIGHTS
     +
     +                ( MIJKL,MGQIJKL,
     +                  NGQP,NMOM,
     +                  TVAL,B00,
     +                  FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                  GQSCR(G000),GQSCR(G010),
     +                  GQSCR(G020),
     +                  GQSCR(G030),GQSCR(G040),
     +                  GQSCR(G050),GQSCR(G060),
     +
     +                           RTS,
     +                           WTS )
     +
     +
C
C
C             ...calculate all needed double exponent values for
C                differentiation. First the double exponents on
C                centers A and/or B (if needed).
C
C
         MGQKL = NGQP * MKL

         IF (DIFFA) THEN
             M = 0
             DO 300 IJ = 1,MIJ
                I = PRIMA (IJ)
                EXPA = ALPHAA (I) + ALPHAA (I)
                DO 310 N = 1,MGQKL
                   EXP2A (M+N) = EXPA
  310           CONTINUE
                M = M + MGQKL
  300        CONTINUE
         END IF

         IF (DIFFB) THEN
             M = 0
             DO 320 IJ = 1,MIJ
                J = PRIMB (IJ)
                EXPB = ALPHAB (J) + ALPHAB (J)
                DO 330 N = 1,MGQKL
                   EXP2B (M+N) = EXPB
  330           CONTINUE
                M = M + MGQKL
  320        CONTINUE
         END IF
C
C
C             ...next the double exponents on centers C and/or D
C                (if needed).
C
C
         IF (DIFFC) THEN
             M = 0
             DO 400 KL = 1,MKL
                K = PRIMC (KL)
                EXPC = ALPHAC (K) + ALPHAC (K)
                DO 410 N = 1,NGQP
                   EXP2C (M+N) = EXPC
  410           CONTINUE
                M = M + NGQP
  400        CONTINUE
             M = 0
             DO 420 IJ = 2,MIJ
                DO 430 N = M+1,M+MGQKL
                   EXP2C (MGQKL+N) = EXP2C (N)
  430           CONTINUE
                M = M + MGQKL
  420        CONTINUE
         END IF

         IF (DIFFD) THEN
             M = 0
             DO 440 KL = 1,MKL
                L = PRIMD (KL)
                EXPD = ALPHAD (L) + ALPHAD (L)
                DO 450 N = 1,NGQP
                   EXP2D (M+N) = EXPD
  450           CONTINUE
                M = M + NGQP
  440        CONTINUE
             M = 0
             DO 460 IJ = 2,MIJ
                DO 470 N = M+1,M+MGQKL
                   EXP2D (MGQKL+N) = EXP2D (N)
  470           CONTINUE
                M = M + MGQKL
  460        CONTINUE
         END IF
C
C
C             ...determine the 2D integral VRR coefficent evaluation
C                case and generate all VRR coefficients. The case is
C                determined as follows:
C
C                    This is done in order to distinguish the maximum
C                    P- and maximum Q-shell combinations for efficient
C                    evaluation of the needed initial 2D integrals
C                    before differentiation and their VRR coefficients.
C                    The cases distinguished are summarized in the
C                    following table, indicating the value of CASE2D:
C
C                                 maximum Q-shell
C                                   s    p   >p
C                                 ---------------
C                                |
C                              s |  1    4    7
C                                |
C             maximum P-shell  p |  2    5    8
C                                |
C                             >p |  3    6    9
C                                |
C
C                    Note, that maximum P- and Q-shells refer to the
C                    overall maximum value of these shells between
C                    the different coordinate components.
C
C
         CASE2D = 3 * MIN0 (2,SHELLQ + MAX0 (DERQX,DERQY,DERQZ))
     +              + MIN0 (2,SHELLP + MAX0 (DERPX,DERPY,DERPZ)) + 1

         CALL    ERD__2D_COEFFICIENTS
     +
     +                ( MIJ,MKL,MIJKL,
     +                  NGQP,MGQIJKL,
     +                  ATOMAB,ATOMCD,
     +                  P,Q,
     +                  PX,PY,PZ,QX,QY,QZ,
     +                  PAX,PAY,PAZ,QCX,QCY,QCZ,
     +                  PINVHF,QINVHF,PQPINV,
     +                  RTS,
     +                  CASE2D,
     +
     +                            B00,B01,B10,
     +                            C00X,C00Y,C00Z,
     +                            D00X,D00Y,D00Z )
     +
     +
C
C
C             ...VRR coefficients are ready. We now assemble the
C                initial 2D integrals and differentiate them for
C                each x,y,z coordinate separately. For each step
C                we determine the 2D integral evaluation cases
C                CASE2D individually. Note, that since the VRR
C                coefficients were evaluated using the overall
C                maximum P- and Q-shell values that can possibly
C                occur, there is no danger in having some VRR
C                coefficients left undefined.
C
C
         IF (PRIMTYP .EQ. 'E0CD') THEN
C
C
C             ...the case where differentiation is to be performed
C                on centers C and/or D only. Generate initial 2DX PCD
C                integrals. If differentiation on x-component is to
C                be done, perform sequence of differentiation to
C                get final differentiated 2DX PCD integrals. Use the
C                BATCH array as scratch.
C
C
             CASE2D = 2 * MIN0 (1,SHELLP) + MIN0 (1,SHELLQ+DERQX) + 1

             CALL    ERD__2D_PCD_INTEGRALS
     +
     +                    ( SHELLP,
     +                      SHELLQ+DERQX,
     +                      MIN0 (SHELLC+DERCX,SHELLD+DERDX),
     +                      SHELLC+DERCX,
     +                      SHELLD+DERDX,
     +                      MGQIJKL,
     +                      WTS,
     +                      B00,B01,B10,C00X,D00X,
     +                      CDX,
     +                      .TRUE.,
     +                      CASE2D,
     +                      BATCH,
     +
     +                                INT2DX )
     +
     +
             IF (DIFFX) THEN

                 DER3 = DERCX
                 DER4 = DERDX

                 DO 500 N = 1,NDERX

                    NINT = MGQIJKL * (SHELLP+1)
     +                             * (SHELLC+DER3+1)
     +                             * (SHELLD+DER4+1)

                    DO 505 M = 1,NINT
                       BATCH (M) = INT2DX (M)
  505               CONTINUE

                    CENTER = CENSQX (N)

                    DEROP3 = CENEQS (3,CENTER)
                    DEROP4 = CENEQS (4,CENTER)

                    DER3 = DER3 - DEROP3
                    DER4 = DER4 - DEROP4

                    CALL    ERD__2D_DERV_PCD_INTEGRALS
     +
     +                           ( SHELLP,
     +                             SHELLC+DER3,
     +                             SHELLD+DER4,
     +                             DEROP3,DEROP4,
     +                             MGQIJKL,
     +                             EXP2C,EXP2D,
     +                             BATCH,
     +
     +                                      INT2DX )
     +
     +
  500            CONTINUE

             END IF
C
C
C             ...generate initial 2DY PCD integrals (if needed).
C                If differentiation on y-component is to be done,
C                perform sequence of differentiation to get final
C                differentiated 2DY PCD integrals. Use the BATCH
C                array as scratch.
C
C
             IF (SHELLT.GT.0 .OR. DIFFY) THEN

                 CASE2D =   2 * MIN0 (1,SHELLP)
     +                        + MIN0 (1,SHELLQ+DERQY) + 1

                 CALL    ERD__2D_PCD_INTEGRALS
     +
     +                        ( SHELLP,
     +                          SHELLQ+DERQY,
     +                          MIN0 (SHELLC+DERCY,SHELLD+DERDY),
     +                          SHELLC+DERCY,
     +                          SHELLD+DERDY,
     +                          MGQIJKL,
     +                          WTS,
     +                          B00,B01,B10,C00Y,D00Y,
     +                          CDY,
     +                          .FALSE.,
     +                          CASE2D,
     +                          BATCH,
     +
     +                                    INT2DY )
     +
     +
             END IF

             IF (DIFFY) THEN

                 DER3 = DERCY
                 DER4 = DERDY

                 DO 510 N = 1,NDERY

                    NINT = MGQIJKL * (SHELLP+1)
     +                             * (SHELLC+DER3+1)
     +                             * (SHELLD+DER4+1)

                    DO 515 M = 1,NINT
                       BATCH (M) = INT2DY (M)
  515               CONTINUE

                    CENTER = CENSQY (N)

                    DEROP3 = CENEQS (3,CENTER)
                    DEROP4 = CENEQS (4,CENTER)

                    DER3 = DER3 - DEROP3
                    DER4 = DER4 - DEROP4

                    CALL    ERD__2D_DERV_PCD_INTEGRALS
     +
     +                           ( SHELLP,
     +                             SHELLC+DER3,
     +                             SHELLD+DER4,
     +                             DEROP3,DEROP4,
     +                             MGQIJKL,
     +                             EXP2C,EXP2D,
     +                             BATCH,
     +
     +                                      INT2DY )
     +
     +
  510            CONTINUE

             END IF
C
C
C             ...generate initial 2DZ PCD integrals. If differentiation
C                on z-component is to be done, perform sequence of
C                differentiation to get final differentiated 2DZ PCD
C                integrals. Use the BATCH array as scratch.
C
C
             IF (SHELLT.GT.0 .OR. DIFFZ) THEN

                 CASE2D =   2 * MIN0 (1,SHELLP)
     +                        + MIN0 (1,SHELLQ+DERQZ) + 1

                 CALL    ERD__2D_PCD_INTEGRALS
     +
     +                        ( SHELLP,
     +                          SHELLQ+DERQZ,
     +                          MIN0 (SHELLC+DERCZ,SHELLD+DERDZ),
     +                          SHELLC+DERCZ,
     +                          SHELLD+DERDZ,
     +                          MGQIJKL,
     +                          WTS,
     +                          B00,B01,B10,C00Z,D00Z,
     +                          CDZ,
     +                          .FALSE.,
     +                          CASE2D,
     +                          BATCH,
     +
     +                                    INT2DZ )
     +
     +
             END IF

             IF (DIFFZ) THEN

                 DER3 = DERCZ
                 DER4 = DERDZ

                 DO 520 N = 1,NDERZ

                    NINT = MGQIJKL * (SHELLP+1)
     +                             * (SHELLC+DER3+1)
     +                             * (SHELLD+DER4+1)

                    DO 525 M = 1,NINT
                       BATCH (M) = INT2DZ (M)
  525               CONTINUE

                    CENTER = CENSQZ (N)

                    DEROP3 = CENEQS (3,CENTER)
                    DEROP4 = CENEQS (4,CENTER)

                    DER3 = DER3 - DEROP3
                    DER4 = DER4 - DEROP4

                    CALL    ERD__2D_DERV_PCD_INTEGRALS
     +
     +                           ( SHELLP,
     +                             SHELLC+DER3,
     +                             SHELLD+DER4,
     +                             DEROP3,DEROP4,
     +                             MGQIJKL,
     +                             EXP2C,EXP2D,
     +                             BATCH,
     +
     +                                      INT2DZ )
     +
     +
  520            CONTINUE

             END IF
C
C
C             ...assemble the 2D PCD integrals to the [E0|CD] batch
C                according to the angular shell case present.
C
C
             IF (SHELLT.EQ.0 .AND. NGQP.EQ.1) THEN

                 DO 530 M = 1,MIJKL
                    BATCH (M) = INT2DX (M) * SCALEPQ (M)
  530            CONTINUE

                 IF (DIFFY) THEN
                     DO 532 M = 1,MIJKL
                        BATCH (M) = BATCH (M) * INT2DY (M)
  532                CONTINUE
                 END IF

                 IF (DIFFZ) THEN
                     DO 534 M = 1,MIJKL
                        BATCH (M) = BATCH (M) * INT2DZ (M)
  534                CONTINUE
                 END IF

             ELSE IF (SHELLT.EQ.0) THEN

                 CALL    ERD__DERV_INT2D_TO_0000
     +
     +                        ( NGQP,MIJKL,MGQIJKL,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE IF (ANGMTYP.EQ.'SSXX') THEN

                 CALL    ERD__DERV_INT2D_TO_E000
     +
     +                        ( SHELLA,SHELLP,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZP,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                    BATCH )
     +
     +
             ELSE IF (ANGMTYP.EQ.'SXXX') THEN

                 CALL    ERD__DERV_INT2D_TO_E0C0
     +
     +                        ( SHELLA,SHELLP,NZSHELL (1),
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZP,NZNXYZ (1),
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                    BATCH )
     +
     +
             ELSE

                 CALL    ERD__DERV_INT2D_TO_E0CD
     +
     +                        ( SHELLA,SHELLP,SHELLC,SHELLD,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZP,NXYZC,NXYZD,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                    BATCH )
     +
     +
             END IF

         ELSE IF (PRIMTYP .EQ. 'ABCD') THEN
C
C
C             ...the case where differentiation is to be performed on
C                centers A and/or B and on centers C and/or D. Generate
C                initial 2DX ABCD integrals. If differentiation on
C                x-component is to be done, perform sequence of
C                differentiation to get final differentiated 2DX ABCD
C                integrals. Use the BATCH array as scratch.
C
C
             CASE2D = 2*MIN0(1,SHELLP+DERPX) + MIN0(1,SHELLQ+DERQX) + 1

             CALL    ERD__2D_ABCD_INTEGRALS
     +
     +                    ( SHELLP+DERPX,
     +                      SHELLQ+DERQX,
     +                      MIN0 (SHELLA+DERAX,SHELLB+DERBX),
     +                      MIN0 (SHELLC+DERCX,SHELLD+DERDX),
     +                      SHELLA+DERAX,
     +                      SHELLB+DERBX,
     +                      SHELLC+DERCX,
     +                      SHELLD+DERDX,
     +                      MGQIJKL,
     +                      WTS,
     +                      B00,B01,B10,C00X,D00X,
     +                      ABX,CDX,
     +                      .TRUE.,
     +                      CASE2D,
     +                      BATCH,
     +
     +                                INT2DX )
     +
     +
             IF (DIFFX) THEN

                 DER1 = DERAX
                 DER2 = DERBX
                 DER3 = DERCX
                 DER4 = DERDX

                 DO 600 N = 1,NDERX

                    NINT = MGQIJKL * (SHELLA+DER1+1)
     +                             * (SHELLB+DER2+1)
     +                             * (SHELLC+DER3+1)
     +                             * (SHELLD+DER4+1)

                    DO 605 M = 1,NINT
                       BATCH (M) = INT2DX (M)
  605               CONTINUE

                    CENTER = CENSQX (N)

                    DEROP1 = CENEQS (1,CENTER)
                    DEROP2 = CENEQS (2,CENTER)
                    DEROP3 = CENEQS (3,CENTER)
                    DEROP4 = CENEQS (4,CENTER)

                    DER1 = DER1 - DEROP1
                    DER2 = DER2 - DEROP2
                    DER3 = DER3 - DEROP3
                    DER4 = DER4 - DEROP4

                    CALL    ERD__2D_DERV_ABCD_INTEGRALS
     +
     +                           ( SHELLA+DER1,
     +                             SHELLB+DER2,
     +                             SHELLC+DER3,
     +                             SHELLD+DER4,
     +                             DEROP1,DEROP2,DEROP3,DEROP4,
     +                             MGQIJKL,
     +                             EXP2A,EXP2B,EXP2C,EXP2D,
     +                             BATCH,
     +
     +                                      INT2DX )
     +
     +
  600            CONTINUE

             END IF
C
C
C             ...generate initial 2DY ABCD integrals (if needed).
C                If differentiation on y-component is to be done,
C                perform sequence of differentiation to get final
C                differentiated 2DY ABCD integrals. Use the BATCH
C                array as scratch.
C
C
             IF (SHELLT.GT.0 .OR. DIFFY) THEN

                 CASE2D =   2 * MIN0 (1,SHELLP+DERPY)
     +                        + MIN0 (1,SHELLQ+DERQY) + 1

                 CALL    ERD__2D_ABCD_INTEGRALS
     +
     +                        ( SHELLP+DERPY,
     +                          SHELLQ+DERQY,
     +                          MIN0 (SHELLA+DERAY,SHELLB+DERBY),
     +                          MIN0 (SHELLC+DERCY,SHELLD+DERDY),
     +                          SHELLA+DERAY,
     +                          SHELLB+DERBY,
     +                          SHELLC+DERCY,
     +                          SHELLD+DERDY,
     +                          MGQIJKL,
     +                          WTS,
     +                          B00,B01,B10,C00Y,D00Y,
     +                          ABY,CDY,
     +                          .FALSE.,
     +                          CASE2D,
     +                          BATCH,
     +
     +                                    INT2DY )
     +
     +
             END IF

             IF (DIFFY) THEN

                 DER1 = DERAY
                 DER2 = DERBY
                 DER3 = DERCY
                 DER4 = DERDY

                 DO 610 N = 1,NDERY

                    NINT = MGQIJKL * (SHELLA+DER1+1)
     +                             * (SHELLB+DER2+1)
     +                             * (SHELLC+DER3+1)
     +                             * (SHELLD+DER4+1)

                    DO 615 M = 1,NINT
                       BATCH (M) = INT2DY (M)
  615               CONTINUE

                    CENTER = CENSQY (N)

                    DEROP1 = CENEQS (1,CENTER)
                    DEROP2 = CENEQS (2,CENTER)
                    DEROP3 = CENEQS (3,CENTER)
                    DEROP4 = CENEQS (4,CENTER)

                    DER1 = DER1 - DEROP1
                    DER2 = DER2 - DEROP2
                    DER3 = DER3 - DEROP3
                    DER4 = DER4 - DEROP4

                    CALL    ERD__2D_DERV_ABCD_INTEGRALS
     +
     +                           ( SHELLA+DER1,
     +                             SHELLB+DER2,
     +                             SHELLC+DER3,
     +                             SHELLD+DER4,
     +                             DEROP1,DEROP2,DEROP3,DEROP4,
     +                             MGQIJKL,
     +                             EXP2A,EXP2B,EXP2C,EXP2D,
     +                             BATCH,
     +
     +                                      INT2DY )
     +
     +
  610            CONTINUE

             END IF
C
C
C             ...generate initial 2DZ ABCD integrals (if needed).
C                If differentiation on z-component is to be done,
C                perform sequence of differentiation to get final
C                differentiated 2DZ ABCD integrals. Use the BATCH
C                array as scratch.
C
C
             IF (SHELLT.GT.0 .OR. DIFFZ) THEN

                 CASE2D =   2 * MIN0 (1,SHELLP+DERPZ)
     +                        + MIN0 (1,SHELLQ+DERQZ) + 1

                 CALL    ERD__2D_ABCD_INTEGRALS
     +
     +                        ( SHELLP+DERPZ,
     +                          SHELLQ+DERQZ,
     +                          MIN0 (SHELLA+DERAZ,SHELLB+DERBZ),
     +                          MIN0 (SHELLC+DERCZ,SHELLD+DERDZ),
     +                          SHELLA+DERAZ,
     +                          SHELLB+DERBZ,
     +                          SHELLC+DERCZ,
     +                          SHELLD+DERDZ,
     +                          MGQIJKL,
     +                          WTS,
     +                          B00,B01,B10,C00Z,D00Z,
     +                          ABZ,CDZ,
     +                          .FALSE.,
     +                          CASE2D,
     +                          BATCH,
     +
     +                                    INT2DZ )
     +
     +
             END IF

             IF (DIFFZ) THEN

                 DER1 = DERAZ
                 DER2 = DERBZ
                 DER3 = DERCZ
                 DER4 = DERDZ

                 DO 620 N = 1,NDERZ

                    NINT = MGQIJKL * (SHELLA+DER1+1)
     +                             * (SHELLB+DER2+1)
     +                             * (SHELLC+DER3+1)
     +                             * (SHELLD+DER4+1)

                    DO 625 M = 1,NINT
                       BATCH (M) = INT2DZ (M)
  625               CONTINUE

                    CENTER = CENSQZ (N)

                    DEROP1 = CENEQS (1,CENTER)
                    DEROP2 = CENEQS (2,CENTER)
                    DEROP3 = CENEQS (3,CENTER)
                    DEROP4 = CENEQS (4,CENTER)

                    DER1 = DER1 - DEROP1
                    DER2 = DER2 - DEROP2
                    DER3 = DER3 - DEROP3
                    DER4 = DER4 - DEROP4

                    CALL    ERD__2D_DERV_ABCD_INTEGRALS
     +
     +                           ( SHELLA+DER1,
     +                             SHELLB+DER2,
     +                             SHELLC+DER3,
     +                             SHELLD+DER4,
     +                             DEROP1,DEROP2,DEROP3,DEROP4,
     +                             MGQIJKL,
     +                             EXP2A,EXP2B,EXP2C,EXP2D,
     +                             BATCH,
     +
     +                                      INT2DZ )
     +
     +
  620            CONTINUE

             END IF
C
C
C             ...assemble the 2D ABCD integrals to the [AB|CD] batch
C                according to the angular shell case present.
C
C
             IF (ANGMTYP.EQ.'SSSS' .AND. NGQP.EQ.1) THEN

                 DO 630 M = 1,MIJKL
                    BATCH (M) = INT2DX (M) * SCALEPQ (M)
  630            CONTINUE

                 IF (DIFFY) THEN
                     DO 632 M = 1,MIJKL
                        BATCH (M) = BATCH (M) * INT2DY (M)
  632                CONTINUE
                 END IF

                 IF (DIFFZ) THEN
                     DO 634 M = 1,MIJKL
                        BATCH (M) = BATCH (M) * INT2DZ (M)
  634                CONTINUE
                 END IF

             ELSE IF (ANGMTYP.EQ.'SSSS') THEN

                 CALL    ERD__DERV_INT2D_TO_0000
     +
     +                        ( NGQP,MIJKL,MGQIJKL,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE IF (ANGMTYP.EQ.'SSSX') THEN

                 CALL    ERD__DERV_INT2D_TO_A000
     +
     +                        ( NZSHELL (1),
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NZNXYZ (1),
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE IF (ANGMTYP.EQ.'SSXX') THEN

                 CALL    ERD__DERV_INT2D_TO_AB00
     +
     +                        ( NZSHELL (1),NZSHELL (2),
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NZNXYZ (1),NZNXYZ (2),
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE IF (ANGMTYP.EQ.'SXXX') THEN

                 CALL    ERD__DERV_INT2D_TO_ABC0
     +
     +                        ( NZSHELL (1),NZSHELL (2),NZSHELL (3),
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NZNXYZ (1),NZNXYZ (2),NZNXYZ (3),
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE

                 CALL    ERD__DERV_INT2D_TO_ABCD
     +
     +                        ( SHELLA,SHELLB,SHELLC,SHELLD,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZA,NXYZB,NXYZC,NXYZD,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          DIFFY,DIFFZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE PCKIND(IVALUE,ISPIN,SYVEC1,SYVEC2,NSMSZ1,NSMSZ2,
     &                  I,J,A,B)
C
C THIS ROUTINE RETURNS I,J,A AND B FOR IVALUE, WHICH IS THE ABSOLUTE
C  OFFSET IN THE SYMMETRY PACKED LIST.  T
C  IF ISPIN IS 1 OR 2, THE LIST STRUCTURE IS ASSUMED TO BE A<B;I<J AND
C  a<b;i,j RESPECTIVELY.  IF ISPIN IS 3, IT IS ASSUMED TO BE A,b;I,j.
C  NDISSZ IS THE SIZE OF THE DISTRIBUTIONS.
C
CEND
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION SYVEC1(NSMSZ1),SYVEC2(NSMSZ2)
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),N(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      ILRG(IX)=INT(0.5D0*(1.D0+DSQRT(8.d0*IX-7)))+1
      NNM1O2(IX)=(IX*(IX-1))/2
      IGETI(LSTELM,NUMA)=1+(LSTELM-1)/NUMA
      IGETA(LSTELM,NUMA)=LSTELM-(IGETI(LSTELM,NUMA)-1)*NUMA
      IF(IVALUE.Eq.0)THEN
       I=0
       J=0
       A=0
       B=0
       RETURN
      ENDIF
      IF(ISPIN.EQ.3)LIST=46
      IF(ISPIN.EQ.2)LIST=45
      IF(ISPIN.EQ.1)LIST=44
C
C DETERMINE THE DPD IRREP FOR IVALUE.
C
      NSIZ=0
      IBOTL=0
      IBOTR=0
      DO 10 IRREP=1,NIRREP
       NSYDIS=IRPDPD(IRREP,ISYTYP(2,LIST))
       NSYDSZ=IRPDPD(IRREP,ISYTYP(1,LIST))
       NSIZ=NSIZ+NSYDIS*NSYDSZ
       IF(IVALUE.LE.NSIZ)GOTO 20
       IBOTR=IBOTR+NSYDIS
       IBOTL=IBOTL+NSYDSZ
10    CONTINUE
20    NOFF=NSIZ-NSYDIS*NSYDSZ
C
C THE DPD IRREP IS KNOWN, SO DETERMINE THE OFFSET WITHIN THIS IRREP.
C
      IOFF=IVALUE-NOFF
      NSYDIS=IRPDPD(IRREP,ISYTYP(2,LIST))
      NSYDSZ=IRPDPD(IRREP,ISYTYP(1,LIST))
C
C DETERMINE OFFSETS IN BOTH ELEMENTS OF THE DPD LIST FOR THIS IRREP.
C
      if(ioff.eq.0)then
        idisp=0
        ielemp=0
       else
      IDISP=IGETI(IOFF,NSYDSZ)
      IELEMP=IGETA(IOFF,NSYDSZ)
      endif
C
C DETERMINE OFFSETS IN UNPACKED LIST.
C
      IELEMU=SYVEC1(IBOTL+IELEMP)
      IDISU=SYVEC2(IBOTR+IDISP)
      IF(ISPIN.EQ.3)THEN
       J=1+(IDISU-1)/NOCCO(1)
       I=IDISU-(J-1)*NOCCO(1)
       B=1+NOCCO(2)+(IELEMU-1)/NVRTO(1)
       IB=B-NOCCO(2)
       A=NOCCO(1)+IELEMU-(IB-1)*NVRTO(1)
      ELSEIF(ISPIN.LT.3)THEN
       I=ILRG(IDISU)
       A=NOCCO(ISPIN)+ILRG(IELEMU)
       J=IDISU-NNM1O2(I-1)
       B=NOCCO(ISPIN)+IELEMU-NNM1O2(ILRG(IELEMU)-1)
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_SET_DERV_AB
     +
     +                    ( NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      EXP1,EXP2,
     +                      CC1,CC2,
     +                      DER1X,DER1Y,DER1Z,
     +                      DER2X,DER2Y,DER2Z,
     +                      SPHERIC,
     +
     +                                 NCGTOA,NCGTOB,
     +                                 NPGTOA,NPGTOB,
     +                                 SHELLA,SHELLB,SHELLP,
     +                                 MXSHELL,
     +                                 XA,YA,ZA,XB,YB,ZB,
     +                                 NDERX,NDERY,NDERZ,
     +                                 DERAX,DERAY,DERAZ,
     +                                 DERBX,DERBY,DERBZ,
     +                                 DIFFA,DIFFB,
     +                                 DIFFX,DIFFY,DIFFZ,
     +                                 ABX,ABY,ABZ,RNABSQ,
     +                                 SPNORM,
     +                                 NXYZA,NXYZB,NXYZT,
     +                                 NRYA,NRYB,
     +                                 INDEXA,INDEXB,
     +                                 SWAP12,SWAPRS,
     +                                 LEXPA,LEXPB,
     +                                 LCCA,LCCB,
     +                                 LCCSEGA,LCCSEGB,
     +                                 EMPTY )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_SET_DERV_AB
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the logistics on how to evaluate
C                the (1|2) derivative overlap integral batch in the
C                most efficient way. It performs the label map:
C
C                               (1|2) --> (A|B)
C
C                and returns some additional data of crucial importance
C                for evaluation of the (A|B) derivative overlap
C                integrals.
C
C                The freedom we have in making the internal association
C                1,2 -> A,B follows from the 2-fold permutational
C                symmetry of the overlap integrals in (1|2):
C
C                                 (1|2) = (2|1)
C
C                Note, that this permutational symmetry only holds as
C                long as we permute the differential operators with it.
C
C                Application of the 1 <-> 2 switch is pretty irrelevant
C                here, due to the fact the routine which generates the
C                initial 1D integrals has the possibility to either
C                apply the HRR steps on the A or B shell. Still we
C                choose here to have A>=B for convenience and possibly
C                slightly better performance.
C
C
C                  Input (x = 1 and 2):
C
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    EXPx         =  primitive exponents for csh x
C                    CCx          =  contraction coeffs for csh x
C                    DERyp        =  the order of differentiation on
C                                    centers y = 1 and 2 with respect
C                                    to the p = x,y,z coordinates
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output (x = A and B):
C
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    SHELLP       =  the shell sum A+B
C                    MXSHELL      =  the largest (maximum) shell type
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = A and B
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERyp        =  the order of differentiation on
C                                    centers y = A and B with respect
C                                    to the p = x,y,z coordinates
C                    DIFFy        =  is true, if differentiation will
C                                    be performed on centers y = A and B
C                                    involving the y = x,y,z coordinates
C                    ABX,ABY,ABZ  =  the x,y,z-coordinate differences
C                                    between centers A and B
C                    RNABSQ       =  square of the magnitude of the
C                                    distance between centers A and B
C                    SPNORM       =  normalization factor due to
C                                    presence of s- and p-type shells.
C                                    For each s-type shell there is a
C                                    factor of 1 and for each p-type
C                                    shell a factor of 2
C                    NXYZx        =  # of cartesian monomials for csh x
C                    NXYZT        =  total # cartesian monomial
C                                    combinations, that is NXYZA * NXYZB
C                    NRYx         =  # of spherical functions for csh x
C                    INDEXx       =  index A,B -> 1,2 map
C                    SWAP12       =  is .true., if a swap 1 <-> 2 has
C                                    been performed
C                    SWAPRS       =  is set .true. if the contraction
C                                    order of the primitives pair AB
C                                    will be performed in reverse order
C                                    BA for efficiency reasons
C                    LEXPx        =  pointers to locate appropriate
C                                    section of the exponent array
C                                    corresponding to csh x
C                    LCCx         =  pointers to locate appropriate
C                                    section of the contraction coeff
C                                    array corresponding to csh x
C                    LCCSEGx      =  pointers to locate appropriate
C                                    section of the lowest and highest
C                                    primitive index array defining
C                                    segmented contraction boundaries
C                                    for csh x
C                    EMPTY        =  logical flag, indicating if an
C                                    empty batch of integrals is
C                                    expected.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     DIFFA,DIFFB
         LOGICAL     DIFFX,DIFFY,DIFFZ
         LOGICAL     EMPTY
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAPRS

         INTEGER     DER1X,DER1Y,DER1Z
         INTEGER     DER2X,DER2Y,DER2Z
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     INDEXA,INDEXB
         INTEGER     LCCSEGA,LCCSEGB
         INTEGER     LCCA,LCCB
         INTEGER     LEXPA,LEXPB
         INTEGER     MXSHELL
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NCGTOA,NCGTOB
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NRYA,NRYB
         INTEGER     NXYZA,NXYZB,NXYZT
         INTEGER     SHELL1,SHELL2
         INTEGER     SHELLA,SHELLB
         INTEGER     SHELLP

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  RNABSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  EXP1 (1:NPGTO1)
         DOUBLE PRECISION  EXP2 (1:NPGTO2)

         DOUBLE PRECISION  CC1 (1:NPGTO1,1:NCGTO1)
         DOUBLE PRECISION  CC2 (1:NPGTO2,1:NCGTO2)

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (ONE     =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...generate all 1,2 data. Decide as early as possible,
C                if a zero batch of overlap derivative integrals is
C                expected.
C
C
         ATOMIC = (X1.EQ.X2) .AND. (Y1.EQ.Y2) .AND. (Z1.EQ.Z2)

         IF (ATOMIC) THEN
             EMPTY = .TRUE.
             RETURN
         END IF

         EMPTY  = .FALSE.
         SHELLP = SHELL1 + SHELL2
         MXSHELL = MAX0 (SHELL1,SHELL2)
C
C
C             ...decide on the 1 <-> 2 swapping.
C
C
         SWAP12 = SHELL1 .LT. SHELL2
C
C
C             ...according to the previously gathered info, set the
C                new A,B shells, # of primitives + contraction coeffs
C                as well as pointers to the alpha exponents and
C                contraction coefficients.
C
C
         IF (.NOT.SWAP12) THEN
             XA = X1
             YA = Y1
             ZA = Z1
             XB = X2
             YB = Y2
             ZB = Z2
             SHELLA = SHELL1
             SHELLB = SHELL2
             NPGTOA = NPGTO1
             NPGTOB = NPGTO2
             NCGTOA = NCGTO1
             NCGTOB = NCGTO2
             DERAX = DER1X
             DERAY = DER1Y
             DERAZ = DER1Z
             DERBX = DER2X
             DERBY = DER2Y
             DERBZ = DER2Z
             INDEXA = 1
             INDEXB = 2
             LEXPA = 1
             LEXPB = LEXPA + NPGTO1
             LCCA = 1
             LCCB = LCCA + NPGTO1 * NCGTO1
             LCCSEGA = 1
             LCCSEGB = LCCSEGA + NCGTO1
         ELSE
             XA = X2
             YA = Y2
             ZA = Z2
             XB = X1
             YB = Y1
             ZB = Z1
             SHELLA = SHELL2
             SHELLB = SHELL1
             NPGTOA = NPGTO2
             NPGTOB = NPGTO1
             NCGTOA = NCGTO2
             NCGTOB = NCGTO1
             DERAX = DER2X
             DERAY = DER2Y
             DERAZ = DER2Z
             DERBX = DER1X
             DERBY = DER1Y
             DERBZ = DER1Z
             INDEXA = 2
             INDEXB = 1
             LEXPB = 1
             LEXPA = LEXPB + NPGTO1
             LCCB = 1
             LCCA = LCCB + NPGTO1 * NCGTO1
             LCCSEGB = 1
             LCCSEGA = LCCSEGB + NCGTO1
         END IF
C
C
C             ...the new A and B shells are set. Calculate the
C                following info:
C
C                1) control variable to determine contraction order
C                2) cartesian monomial dimensions
C                3) spherical dimensions (= cartesian, if no spherical)
C                4) the overall norm factor due to s- or p-type shells
C
C
         SWAPRS = NPGTOA .GT. NPGTOB

         NXYZA  = (SHELLA+1)*(SHELLA+2)/2
         NXYZB  = (SHELLB+1)*(SHELLB+2)/2
         NXYZT  = NXYZA * NXYZB

         NRYA = SHELLA + SHELLA + 1
         NRYB = SHELLB + SHELLB + 1

         IF (.NOT.SPHERIC) THEN
             NRYA = NXYZA
             NRYB = NXYZB
         END IF

         SPNORM = ONE
         IF (SHELLA.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELLB.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
C
C
C             ...calculate the coordinate differences between centers
C                A and B and calculate the square of the magnitude
C                of the distance between A and B. Set also the A,B
C                equality index and determine if differentiation is
C                is to be performed on centers A and/or B and x,y,z-
C                component. Total differentiation orders for each
C                component are also determined.
C
C
         ABX = XA - XB
         ABY = YA - YB
         ABZ = ZA - ZB
         RNABSQ = ABX * ABX + ABY * ABY + ABZ * ABZ

         NDERX = DERAX + DERBX
         NDERY = DERAY + DERBY
         NDERZ = DERAZ + DERBZ

         DIFFA = (DERAX + DERAY + DERAZ) .NE. 0
         DIFFB = (DERBX + DERBY + DERBZ) .NE. 0

         DIFFX = NDERX .NE. 0
         DIFFY = NDERY .NE. 0
         DIFFZ = NDERZ .NE. 0
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE T1RA02(ICORE,MAXCOR,IUHF,LAMBDA)
C
C THIS SUBROUTINE COMPUTES ONE OF TWO T1*W CONTRIBUTIONS TO THE
C  W(mbej) INTERMEDIATE.  
C
C           W(MBEJ) = - SUM T(J,F) * <FE||BM> + SUM T(N,B) * <NM||JE>    (1)
C           W(mbej) = - SUM T(j,f) * <fe||bm> + SUM T(n,b) * <nm||je>    (2)
C
C ALSO COMPUTED IS THE T1*W CONTRIBUTIONS TO THE F(ea) INTERMEDIATE
C
C           F(EA)   =  SUM T(M,F) * <FE||MA> = - SUM T(M,F) * <FE||AM>  (3)
C           F(ea)   =  SUM T(m,f) * <fe||ma> = - SUM T(m,f) * <fe||am>  (4)
C
C WHICH ARE OBTAINED BY TAKING GENERALIZED TRACES (N**3 DEPENDENCE) OVER THE
C TERMS CALCULATED IN EQS 1 AND 2.
C
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL LAMBDA
      DOUBLE PRECISION ONE,ONEM,ZILCH,ALPHA,BETA,FACTOR
      CHARACTER*4 SPCASE(2)
      LOGICAL INCORE
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2),ABFULL(8),MNFULL(8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,
     &             NF1BB,NF2BB
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
      DATA SPCASE /'AAAA','BBBB'/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
C
C FIRST PICK UP T1 VECTOR.
C
      CALL GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
C
C SPIN CASES AAAA AND BBBB
C
      LSTFEA=92
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=53+ISPIN
       IF(LAMBDA)THEN
        LSTOUT=122+ISPIN
        FACTOR=ONEM
       ELSE
        LSTOUT=LSTTAR
        FACTOR=ONE
       ENDIF
C
C COMPUTE A,B DPD SIZE FOR ALL IRREPS
C
       DO 1000 IRREP=1,NIRREP
        ICOUNT=0
        ICOUNT2=0
        DO 1001 IRREPE=1,NIRREP
         IRREPF=DIRPRD(IRREPE,IRREP)
         ICOUNT=ICOUNT+VRT(IRREPF,ISPIN)*VRT(IRREPE,ISPIN)
         ICOUNT2=ICOUNT2+POP(IRREPF,ISPIN)*POP(IRREPE,ISPIN)
1001    CONTINUE
        ABFULL(IRREP)=ICOUNT
        MNFULL(IRREP)=ICOUNT2
1000   CONTINUE
C
C LOOP OVER IRREPS - IN THE FIRST BLOCK OF CODE THIS CORRESPONDS TO BM,
C                    WHILE IT IS JE IN THE SECOND BLOCK.
C
       DO 20 IRREPDO=1,NIRREP
        DISTAR=aces_list_cols(IRREPDO,22+ISPIN)
        DSZTAR=aces_list_rows(IRREPDO,22+ISPIN)
        CALL IZERO(ICORE,IINTFP*DISTAR*DSZTAR)
C
C FIRST DO THE   W(MBEJ) =  SUM T(J,F) * <FE||BM>  CONTRIBUTION.
C
C THIS PRODUCT IS INITIALLY PACKED J,E-B,M
C
        LSTINT=26+ISPIN
        IF(IUHF.EQ.0) LSTINT=30
        DISW  =aces_list_cols(IRREPDO,LSTINT)
        DSZW  =aces_list_rows(IRREPDO,LSTINT)
        DSZEXP=ABFULL(IRREPDO)
C
C I000 HOLDS THE W(JEBM) TARGET FOR GAMMA(BM).
C I010 HOLDS AREA EVENTUALLY USED AS SCRATCH IN SYMTR AND THE F(ea)
C          CONTRIBUTION COMPUTED BY TRACEOO.
C I020 HOLDS THE <EF||BM> INTEGRALS (ENOUGH SPACE IS ALLOCATED TO HOLD
C      FULL LIST (E,F;B,M)).
C
        I000  =1
        I010  =I000+IINTFP*DISTAR*DSZTAR
        I011  =I010+IINTFP*MAX(DSZTAR,DSZEXP,ABFULL(1))
        I012  =I011+IINTFP*DSZTAR
        I020  =I012+IINTFP*DSZTAR
        I030  =I020+IINTFP*DSZEXP*DISW
        I040  =I030+IINTFP*MAX(DSZEXP,DISW)*(1-IUHF)
        IEND  =I040+IINTFP*MAX(DSZEXP,DISW)*(1-IUHF)
        IF(IEND.LE.MXCOR)THEN
         INCORE=.TRUE.
         CALL GETLST(ICORE(I020),1,DISW,2,IRREPDO,LSTINT)
         IF(IUHF.NE.0) THEN
          CALL SYMEXP2(IRREPDO,VRT(1,ISPIN),DSZEXP,DSZW,DISW,
     &                ICORE(I020),ICORE(I020))
         ELSE
          CALL ASSYM2A(IRREPDO,VRT(1,ISPIN),DSZEXP,DISW,
     &                ICORE(I020),ICORE(I030),ICORE(I040))
         ENDIF
        ELSE
         INCORE=.FALSE.
         I030=I020+IINTFP*DSZW
         I040=I030+IINTFP*MAX(DSZEXP,DISW)*(1-IUHF)
         IEND=I040+IINTFP*MAX(DSZEXP,DISW)*(1-IUHF)
         IF(IEND.GE.MXCOR) CALL INSMEM('T1RA02',IEND,MXCOR)
        ENDIF
        DO 30 INUMBM=1,DISW
         IF(INCORE)THEN
          IOFFW1R=(INUMBM-1)*DSZEXP*IINTFP+I020
         ELSE
          CALL GETLST(ICORE(I020),INUMBM,1,2,IRREPDO,LSTINT)
          IF(IUHF.NE.0) THEN
           CALL SYMEXP2(IRREPDO,VRT(1,ISPIN),DSZEXP,DSZW,1,
     &                  ICORE(I020),ICORE(I020))
          ELSE
           CALL ASSYM2A(IRREPDO,VRT(1,ISPIN),DSZEXP,1,
     &                 ICORE(I020),ICORE(I030),ICORE(I040))
          ENDIF
          IOFFW1R=I020
         ENDIF
         IOFFW1L=0
         IOFFZL=0
         IOFFZR=(INUMBM-1)*DSZTAR*IINTFP+I000
         DO 40 IRREPE=1,NIRREP
          IRREPT=DIRPRD(IRREPE,IRREPDO)
          IOFFT=IOFFT1(IRREPT,ISPIN)
          IOFFW1=IOFFW1R+IOFFW1L
          IOFFZ=IOFFZR+IOFFZL
          NROW=POP(IRREPT,ISPIN)
          NCOL=VRT(IRREPE,ISPIN)
          NSUM=VRT(IRREPT,ISPIN)
          ALPHA=ONEM*FACTOR
          BETA=ZILCH
          IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
           CALL XGEMM('T','N',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NSUM,
     &                ICORE(IOFFW1),NSUM,BETA,ICORE(IOFFZ),NROW)
          ENDIF
          IOFFW1L=IOFFW1L+NCOL*NSUM*IINTFP
          IOFFZL=IOFFZL+NROW*NCOL*IINTFP
40       CONTINUE
30      CONTINUE
C
C NOW GET CONTRIBUTION TO F(ea) INTERMEDIATE FROM TRACEOO.
C
        IF(.NOT.LAMBDA) THEN
        CALL TRACEOO('OVVO',IRREPDO,POP(1,ISPIN),VRT(1,ISPIN),
     &               DISTAR,ABFULL(1),ICORE(I000),
     &               ICORE(I010))
        CALL SUMSYM3(ICORE(I010),ICORE(I020),ABFULL(1),1,ISPIN,LSTFEA)
        ENDIF
C
C NOW TRANSPOSE IT TO GET IT IN THE SAME ORDERING AS THE NEXT PIECE.
C                           (B,M-J,E)
C  
        CALL MTRAN2(ICORE(I000),DSZTAR)
C
C NOW DO THE  -SUM(N,B) * <NM||JE>  CONTRIBUTION - THIS IS ORDERED
C          B,M-J,E
C
        DISW  =aces_list_cols(IRREPDO,6+ISPIN)
        DSZW  =aces_list_rows(IRREPDO,6+ISPIN)
        DSZEXP=MNFULL(IRREPDO)
C
C I020 HOLDS THE <NM||JE> INTEGRALS (ENOUGH SPACE IS ALLOCATED TO HOLD
C      FULL LIST (N,M;J,E).
C
        I020  =I010+IINTFP*MAX(DSZEXP,MNFULL(1))
        I030  =I020+IINTFP*DSZEXP*DISW
        IF(I030.LE.MXCOR)THEN
         INCORE=.TRUE.
         CALL GETLST(ICORE(I020),1,DISW,2,IRREPDO,6+ISPIN)
         CALL SYMEXP2(IRREPDO,POP(1,ISPIN),DSZEXP,DSZW,DISW,
     &               ICORE(I020),ICORE(I020))
        ELSE
         INCORE=.FALSE.
         I030=I020+IINTFP*DSZW
        ENDIF
        DO 50 INUMJE=1,DISW
         IF(INCORE)THEN
          IOFFW2R=(INUMJE-1)*DSZEXP*IINTFP+I020
         ELSE
          CALL GETLST(ICORE(I020),INUMJE,1,2,IRREPDO,6+ISPIN)
          CALL SYMEXP2(IRREPDO,POP(1,ISPIN),DSZEXP,DSZW,1,
     &                 ICORE(I020),ICORE(I020))
          IOFFW2R=I020
         ENDIF
         IOFFW2L=0
         IOFFZR=(INUMJE-1)*DSZTAR*IINTFP+I000
         IOFFZL=0
         DO 60 IRREPM=1,NIRREP
          IRREPT=DIRPRD(IRREPM,IRREPDO)
          IOFFT=IOFFT1(IRREPT,ISPIN)
          IOFFW2=IOFFW2R+IOFFW2L
          IOFFZ=IOFFZR+IOFFZL
          NROW=VRT(IRREPT,ISPIN)
          NCOL=POP(IRREPM,ISPIN)
          NSUM=POP(IRREPT,ISPIN)
          ALPHA=ONE*FACTOR
          BETA=ONE
          IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
           CALL XGEMM('N','N',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NROW,
     &                ICORE(IOFFW2),NSUM,BETA,ICORE(IOFFZ),NROW)
          ENDIF
          IOFFW2L=IOFFW2L+NCOL*NSUM*IINTFP
          IOFFZL=IOFFZL+NROW*NCOL*IINTFP
60       CONTINUE
50      CONTINUE
C
C NOW SWITCH ORDERING TO B,M-E,J AND WRITE THESE QUANTITIES TO DISK FOR
C  EACH IRREP.
C
        CALL SYMTR1(IRREPDO,POP(1,ISPIN),VRT(1,ISPIN),
     &             DSZTAR,ICORE(I000),ICORE(I010),
     &             ICORE(I011),ICORE(I012))
        CALL PUTLST(ICORE(I000),1,DISTAR,1,IRREPDO,LSTOUT)
20     CONTINUE
C
C NOW SWITCH ORDERING TO B,J-E,M
C
       ISCSIZ=NOCCO(ISPIN)*NVRTO(ISPIN)*2
       TARSIZ=ISYMSZ(ISYTYP(1,LSTTAR),ISYTYP(2,LSTTAR))
       I000=1
       I010=I000+TARSIZ*IINTFP
       I020=I010+TARSIZ*IINTFP
       I030=I020+ISCSIZ
       IF(I030.GT.MXCOR)CALL INSMEM('WMBEJ2',I030,MXCOR)
       CALL GETALL(ICORE(I010),TARSIZ,1,LSTOUT)
       CALL SSTRNG(ICORE(I010),ICORE(I000),TARSIZ,TARSIZ,ICORE(I020),
     &             SPCASE(ISPIN))
C
C NOW DO TRANSPOSITION TO GET E,M-B,J ORDERING IRREP BY IRREP.
C
       IOFF=1
       DO 5000 IRREP=1,NIRREP
        DSZTAR=aces_list_rows(IRREP,LSTTAR)
        DISTAR=DSZTAR
        CALL MTRAN2(ICORE(IOFF),DSZTAR)
C
C  FOR LAMBDA UPDATE TARGET LIST AND COPY ORIGINAL INTERMEDIATES TO LSTOUT
C
        IF(LAMBDA) THEN 
         CALL GETLST(ICORE(I010),1,DISTAR,2,IRREP,LSTTAR)
         CALL PUTLST(ICORE(I010),1,DISTAR,2,IRREP,LSTOUT)
         CALL SAXPY(DISTAR*DSZTAR,ONE,ICORE(I010),1,ICORE(IOFF),1)
        ENDIF
C
        CALL PUTLST(ICORE(IOFF),1,DISTAR,2,IRREP,LSTTAR)
        IOFF=IOFF+IINTFP*DISTAR*DSZTAR
5000   CONTINUE
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PARTIAL_SCHMIDT
     +
     +                    ( DDROWC,DDCOLC,
     +                      DDROWD,DDCOLD,
     +                      DDROWS,DDCOLS,
     +                      ROW,COLC,COLD,
     +                      COLMAX,COLMIN,
     +                      S,
     +                      SAVES,SAVEC,SAVED,
     +                      C,
     +                      XVEC,
     +                      XMAT,
     +
     +                              D )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PARTIAL_SCHMIDT
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine orthogonalizes a set of MO vectors to
C                an already orthogonalized set of MO vectors using
C                the Schmidt orthogonalization method. The overlaps
C                needed between the two sets are evaluated from the
C                MO expansion coefficients in terms of AO's and the
C                AO overlap matrix.
C
C                The Schmidt orthogonalization leads to the following
C                expression of the new orthogonal D vectors:
C
C
C                                       M1
C                        D(i) = D(i) - sum S(k,i) C(k)
C                                       k
C
C                where i refers to the initially non-orthogonal D
C                functions and S (k,i) denotes the MO overlap matrix
C                element between the k-th orthogonal C function and
C                the i-th D function.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     SAVES,SAVEC,SAVED

         INTEGER     COLMAX,COLMIN
         INTEGER     DDROWC,DDCOLC,DDROWD,DDCOLD,DDROWS,DDCOLS
         INTEGER     I,J,K
         INTEGER     ROW,COLC,COLD

         DOUBLE PRECISION  X

         DOUBLE PRECISION  XVEC  (1:COLMAX)

         DOUBLE PRECISION  C     (1:DDROWC,1:DDCOLC)
         DOUBLE PRECISION  D     (1:DDROWD,1:DDCOLD)
         DOUBLE PRECISION  S     (1:DDROWS,1:DDCOLS)
         DOUBLE PRECISION  XMAT  (1:ROW,   1:COLMIN)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions of C,D and S matrices supplied.
C
C
         IF (ROW.GT.DDROWC .OR. COLC.GT.DDCOLC) THEN
             WRITE (*,*) ' Dimensions of matrix C too small! '
             WRITE (*,*) ' nlo__partial_schmidt '
             WRITE (*,*) ' DDROWC,DDCOLC,ROW,COLC = ',
     +                     DDROWC,DDCOLC,ROW,COLC
             WRITE (1,*) ' Dimensions of matrix C too small! '
             WRITE (1,*) ' nlo__partial_schmidt '
             WRITE (1,*) ' DDROWC,DDCOLC,ROW,COLC = ',
     +                     DDROWC,DDCOLC,ROW,COLC
             STOP
         END IF

         IF (ROW.GT.DDROWD .OR. COLD.GT.DDCOLD) THEN
             WRITE (*,*) ' Dimensions of matrix D too small! '
             WRITE (*,*) ' nlo__partial_schmidt '
             WRITE (*,*) ' DDROWD,DDCOLD,ROW,COLD = ',
     +                     DDROWD,DDCOLD,ROW,COLD
             WRITE (1,*) ' Dimensions of matrix D too small! '
             WRITE (1,*) ' nlo__partial_schmidt '
             WRITE (1,*) ' DDROWD,DDCOLD,ROW,COLD = ',
     +                     DDROWD,DDCOLD,ROW,COLD
             STOP
         END IF

         IF (ROW.GT.DDROWS .OR. ROW.GT.DDCOLS) THEN
             WRITE (*,*) ' Dimensions of matrix S too small! '
             WRITE (*,*) ' nlo__partial_schmidt '
             WRITE (*,*) ' DDROWS,DDCOLS,ROW = ',DDROWS,DDCOLS,ROW
             WRITE (1,*) ' Dimensions of matrix S too small! '
             WRITE (1,*) ' nlo__partial_schmidt '
             WRITE (1,*) ' DDROWS,DDCOLS,ROW = ',DDROWS,DDCOLS,ROW
             STOP
         END IF
C
C
C             ...check dimensions of working arrays XVEC and XMAT.
C
C
         IF (COLMAX.LT.MAX (COLC,COLD)) THEN
             WRITE (*,*) ' Dimensions of array XVEC too small! '
             WRITE (*,*) ' nlo__partial_schmidt '
             WRITE (*,*) ' COLMAX,MAX (COLC,COLD) = ',
     +                     COLMAX,MAX (COLC,COLD)
             WRITE (1,*) ' Dimensions of array XVEC too small! '
             WRITE (1,*) ' nlo__partial_schmidt '
             WRITE (1,*) ' COLMAX,MAX (COLC,COLD) = ',
     +                     COLMAX,MAX (COLC,COLD)
             STOP
         END IF

         IF (COLMIN.LT.MIN (COLC,COLD)) THEN
             WRITE (*,*) ' Dimensions of array XMAT too small! '
             WRITE (*,*) ' nlo__partial_schmidt '
             WRITE (*,*) ' COLMIN,MIN (COLC,COLD) = ',
     +                     COLMIN,MIN (COLC,COLD)
             WRITE (1,*) ' Dimensions of array XMAT too small! '
             WRITE (1,*) ' nlo__partial_schmidt '
             WRITE (1,*) ' COLMIN,MIN (COLC,COLD) = ',
     +                     COLMIN,MIN (COLC,COLD)
             STOP
         END IF
C
C
C             ...proceed according to sizes of C and D. If the size of
C                C is smaller than D, then we generate the COLD x COLC
C                molecular orbital overlap matrix, otherwise we generate
C                its transpose of COLC x COLD size.
C
C
         IF (COLC.LT.COLD) THEN

             CALL    MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                    ( DDROWD,DDCOLD,
     +                      DDROWS,DDCOLS,
     +                      DDROWC,DDCOLC,
     +                      ROW,COLC,
     +                      COLD,
     +                      COLD,ROW,COLC,
     +                      0,0,
     +                      SAVED,SAVES,SAVEC,
     +                      D,S,C,
     +                      XVEC,
     +
     +                             XMAT )
     +
     +
             DO I = 1,COLC
             DO J = 1,COLD
                X = XMAT (J,I)
                DO K = 1,ROW
                   D (K,J) = D (K,J) - X * C (K,I)
                END DO
             END DO
             END DO

         ELSE

             CALL    MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                    ( DDROWC,DDCOLC,
     +                      DDROWS,DDCOLS,
     +                      DDROWD,DDCOLD,
     +                      ROW,COLD,
     +                      COLC,
     +                      COLC,ROW,COLD,
     +                      0,0,
     +                      SAVEC,SAVES,SAVED,
     +                      C,S,D,
     +                      XVEC,
     +
     +                             XMAT )
     +
     +
             DO J = 1,COLD
             DO I = 1,COLC
                X = XMAT (I,J)
                DO K = 1,ROW
                   D (K,J) = D (K,J) - X * C (K,I)
                END DO
             END DO
             END DO

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine reads a character string from the job archive.

c WARNING!
c    The "record length" that is associated with the logical record is the
c number of whole integers that contain the string. Therefore, calling getrec
c with IFLAG=0 may not return the actual length of the string.

c INPUT
c int      IFLAG     : (same as getrec)
c char*(*) SZARCHIVE : (same as getrec)
c char*(*) SZRECNAME : (same as getrec)

c INPUT/OUTPUT
c int ILENGTH : on input, this is the substring-length of the record to get
c               on output, if IFLAG=0, the string-length of the logical record
c                  is returned

c OUTPUT
c char*(*) SZDEST : (same as getrec)

#define _MAXLEN 1024 /* 4096 or 8192 characters */

#ifdef F_64BIT
#  define _IINTLN 8
#else
#  define _IINTLN 4
#endif

      subroutine getcrec(iFlag,szArchive,szRecName,iLength,szDest)
      implicit none

c ARGUMENTS
      integer iFlag, iLength
      character*(*) szArchive, szRecName, szDest(*)

c INTERNAL VARIABLES
      integer i, iNdx, nLeft, iBuf(_MAXLEN), iRecLen

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert substring fits in iBuf
      if (iLength.gt.(_MAXLEN*_IINTLN)) then
         print *, '@GETCREC: Assertion failed.'
         print *, '   iLength = ',iLength
         print *, '   maximum = ',_MAXLEN*_IINTLN
         i = 1
      end if
cYAU: Since szDest is now an array pointer, we have no idea if iLength is good.
cc   o assert substring is within szDest
c      if (len(szDest).lt.iLength) then
c         print *, '@GETCREC: Assertion failed.'
c         print *, '   iLength = ',iLength
c         print *, '   len(sz) = ',len(szDest)
c         i = 1
c      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o assume the length of the record from iLength
      iRecLen = (iLength+_IINTLN-1)/_IINTLN

c   o read from the job archive
      call getrec(iFlag,szArchive,szRecName,iRecLen,iBuf)

c   o comply with getrec queries
      if (iFlag.eq.0) then
         iLength = iRecLen*_IINTLN
         return
      end if

c   o copy the string from the integer buffer
      call c_memmove(szDest,iBuf,iLength)

      return
c     end subroutine getcrec
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine identfy_fragments(nratms,ibndto,connected_atoms,
     &                             nfrags, ifraglen,ifragmat)
C     This routine separates all of the atoms into disconnected fragments.
C     Each column of ifragmat will have the atom numbers of all the atoms
C     in that fragment.  Fragment lengths are stored in ifraglen, and 
C     the number of fragments is nfrags.
C     This routine calls the logical function is_connected, which determines
C     whether two atoms have a path connecting them.
C     AGT 11/06
      implicit none
C     Input variables
      integer nratms
      integer ibndto(nratms,nratms),connected_atoms(nratms)
C     Output variables
      integer nfrags,ifraglen(nratms),ifragmat(nratms,nratms)
C     Function variables
      logical is_connected
C     External Procedures
      external is_connected
C     Local Variables
      integer iatoms,jatoms,unfrag,unfrag2,ii
      logical iam_connected
C     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C     Initial number of fragments = 0
      nfrags=0
      call izero(ifragmat,nratms*nratms)
      Call izero(ifraglen,nratms)
C     Initialize all atoms in first column of ifragmat
      do iatoms=1,nratms
         ifragmat(1,iatoms)=iatoms
      end do
C     Unfrag is a counter for the atoms where we haven't determined what
C     fragment they are on.
      unfrag=nratms
C     Maximum number of fragments is the number of atoms
C
      do while ((unfrag.ne.0).and.(nfrags.lt.nratms))
C     If all atoms have been assigned to fragments, stop.
         nfrags=nfrags+1
         ifraglen(nfrags)=1
         iatoms=ifragmat(nfrags,1)
C     unfrag2: Temporary counter for the changing number of unassigned
C              atoms
         unfrag2=unfrag-1
         do ii=2,unfrag
            jatoms=ifragmat(nfrags,ii)
            iam_connected = is_connected(iatoms,jatoms,ibndto,nratms,
     &                       connected_atoms)
            if (iam_connected) then
C     If connected, put it in the correct place and in/de - crement counters
               ifraglen(nfrags)=ifraglen(nfrags)+1
               ifragmat(nfrags,ifraglen(nfrags))=jatoms
               unfrag2=unfrag2-1
            else
C     Otherwise, move atom to the next column, and we will repeat
               ifragmat(nfrags+1,ii-(unfrag-unfrag2))=jatoms               
            endif
         end do
         do ii=ifraglen(nfrags)+1,unfrag
C     To make sure there is no confusion, zero out extraneous elements
            ifragmat(nfrags,ii)=0
         end do
         unfrag=unfrag2
      end do
c
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C THIS ROUTINE CALCULATES THE TRANSFORMATION MATRIX WHICH MAPS
C THE SET OF COORDINATES Q1 INTO THOSE GIVEN BY Q2
C         Q2 = W Q1
C IT IS ASSUMED THAT THEY ARE RELATED BY A SIMPLE ROTATION
C (I.E. W HAS A DETERMINANT OF ONE)

C THE SCRATCH VECTOR (SCR) MUST HAVE A LENGTH OF 18+2*MAX(3*NATOM,9)

      SUBROUTINE Q2QPRIME(Q1,Q2,ATMASS,SCR,W,NATOM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION Q1(3,NATOM),Q2(3,NATOM),ATMASS(NATOM),W(3,3)
      DIMENSION SCR(*)

      DIMENSION W1(3,3),W2(3,3)

      DATA TOL   /1.D-8/
      DATA ZILCH /0.0/
      DATA ONE   /1.0/
      DATA ONEM  /-1.0/
      DATA THRESH /1.D-12/

c debug
c      write(6,*)' on entry : q1 and q2 are '
c      write(6,'((3f20.10))')(q1(i,1),i=1,3*natom)
c      write(6,*)
c      write(6,'((3f20.10))')(q2(i,1),i=1,3*natom)
c      write(6,*)' on exit : q1 and q2 are '

      PI=DACOSX(ONEM,THRESH)
      CALL ZERO(W,9)

C PICK A REFERENCE ATOM WHICH IS NOT AT THE ORIGIN AND IS NOT A DUMMY ATOM

      IREFATM=-1
      DO IATOM=1,NATOM
         X=DNRM2(3,Q1(1,IATOM),1)*ATMASS(IATOM)
         IF(X.GT.TOL)IREFATM=IATOM
      END DO

C IF NO REFERENCE ATOM IS FOUND, THEN THIS MUST BE AN ATOM OR
C SOMETHING ELSE STRANGE.  W IS THE IDENTITY FOR SUCH A CASE.

      IF (IREFATM.EQ.-1) THEN
         W(1,1)=ONE
         W(2,2)=ONE
         W(3,3)=ONE
         RETURN
      END IF

C 1. NORMALIZE VECTORS IN BOTH Q1 AND Q2 [ORIGINAL NORMS SHOULD
C    BE IDENTICAL BUT CALCULATE ANYWAY].  NORMALIZED VECTORS
C    STORED IN SCR(1..3) AND SCR(4..6), RESPECTIVELY.

      CALL XDCOPY(3,Q1(1,IREFATM),1,SCR(1),1)
      CALL XDCOPY(3,Q2(1,IREFATM),1,SCR(4),1)
      X1=DNRM2(3,SCR(1),1)
      X2=DNRM2(3,SCR(4),1)
      Z1=ONE/X1
      Z2=ONE/X2
      CALL XDSCAL(3,Z1,SCR(1),1)
      CALL XDSCAL(3,Z2,SCR(4),1)

C 2. CALCULATE POLAR AND AZIMUTHAL ANGLES

      TPOL1=DACOSX(SCR(3),THRESH)
      TPOL2=DACOSX(SCR(6),THRESH)

C IF POLAR ANGLE IS ZERO, THEN THE AZIMUTHAL ANGLE IS ZERO.
C OTHERWISE, CALCULATE IT.

      IF (TPOL1.LT.TOL.OR.ABS(PI-TPOL1).LT.TOL) THEN
         TAZIM1=ZILCH
      ELSE
         XYNORM1=DNRM2(2,SCR(1),1)
         FACT=ONE/XYNORM1
         CALL XDSCAL(2,FACT,SCR,2)
         TAZIM1=DACOSX(SCR(1),THRESH)
         TAZIM1=SIGN(TAZIM1,SCR(2))
      END IF
      IF (TPOL2.LT.TOL.OR.ABS(PI-TPOL2).LT.TOL) THEN
         TAZIM2=ZILCH
      ELSE
         XYNORM2=DNRM2(2,SCR(4),1)
         FACT=ONE/XYNORM2
         CALL XDSCAL(2,FACT,SCR(4),2)
         TAZIM2=DACOSX(SCR(4),THRESH)
         TAZIM2=SIGN(TAZIM2,SCR(5))
      END IF

C COMPUTE MATRICES TO ROTATE ATOMS TO Z AXIS.  FIRST ROTATE ABOUT Z
C BY THE AZIMUTHAL ANGLE TO BRING ATOMS PROJECTION ALONG X, AND THEN
C ABOUT Y BY THE POLAR ANGLE (RIGHT-HANDED COORDINATE SYSTEM).
C COMPOSITE MATRICES STORED IN W1 AND W2

      CALL ROTM(3,TAZIM1,0,SCR(7))
      CALL ROTM(2,TPOL1 ,0,SCR(16))
      CALL XGEMM('N','N',3,3,3,ONE,SCR(16),3,SCR(7),3,ZILCH,W1,3)

      CALL ROTM(3,TAZIM2,0,SCR(7))
      CALL ROTM(2,TPOL2 ,0,SCR(16))
      CALL XGEMM('N','N',3,3,3,ONE,SCR(16),3,SCR(7),3,ZILCH,W2,3)

C NOW TRANSFORM COORDINATES. HOLD IN SCRATCH VECTOR.

      I1=1
      I2=I1+MAX(9,3*NATOM)
      I000=I2+MAX(9,3*NATOM)
      I010=I000+9
      CALL XGEMM('N','N',3,NATOM,3,ONE,W1,3,Q1,3,ZILCH,SCR(I1),3)
      CALL XGEMM('N','N',3,NATOM,3,ONE,W2,3,Q2,3,ZILCH,SCR(I2),3)

C NOW FIND ANOTHER ATOM WHICH IS NOT ALONG THE NEW Z AXIS

      IOFF=0
      IREFATM=-1
      XMAX=ZILCH
      DO IATOM=1,NATOM
         X=DNRM2(2,SCR(I1+IOFF),1)*ATMASS(IATOM)
         IF (X.GT.XMAX) THEN
            IREFATM=IATOM
            XMAX=X
         END IF
         IOFF=IOFF+3
      END DO

C IF NO ATOMS FOUND, THE MOLECULE IS LINEAR AND WE SKIP THE NEXT PART

      IF (IREFATM.NE.-1) THEN

C FIND MATRIX WHICH ROTATES PROJECTION OF VECTOR ALONG AXIS

         IOFF1=I1+3*(IREFATM-1)
         IOFF2=I2+3*(IREFATM-1)
         X1=DNRM2(2,SCR(IOFF1),1)
         X2=DNRM2(2,SCR(IOFF2),1)
         FACT1=ONE/X1
         FACT2=ONE/X2
         CALL XDSCAL(2,FACT1,SCR(IOFF1),1)
         CALL XDSCAL(2,FACT2,SCR(IOFF2),1)
         THETA1=DACOSX(SCR(IOFF1),THRESH)
         THETA2=DACOSX(SCR(IOFF2),THRESH)
         THETA1=SIGN(THETA1,SCR(IOFF1+1))
         THETA2=SIGN(THETA2,SCR(IOFF2+1))
         CALL ROTM(3,THETA1,0,SCR(I000))
         CALL ROTM(3,THETA2,0,SCR(I010))

C CALCULATE COMPLETE W1 AND W2 TRANSFORMATION MATRICES

         CALL XGEMM('N','N',3,3,3,ONE,SCR(I000),3,W1,3,ZILCH,SCR(I1),3)
         CALL XGEMM('N','N',3,3,3,ONE,SCR(I010),3,W2,3,ZILCH,SCR(I2),3)
         CALL XDCOPY(9,SCR(I1),1,W1,1)
         CALL XDCOPY(9,SCR(I2),1,W2,1)

      END IF

C NOW WE KNOW THAT THE COORDINATES DEFINED BY
C              Q1' = W1 Q1
C                  AND
C              Q2' = W2 Q2
C                                    +                   +
C ARE EQUIVALENT.  THEREFORE, Q2 = W2  W1 Q1, HENCE W = W2  W1

      CALL XGEMM('T','N',3,3,3,ONE,W2,3,W1,3,ZILCH,W,3)

C CHECK THAT THE TRANSFORMATION WORKS
c      call xgemm('N','N',3,natom,3,one,w,3,q1,3,zilch,scr,3)
c      write(6,'((3f20.10))')(scr(i),i=1,3*natom)
c      write(6,*)
c      write(6,'((3f20.10))')(q2(i,1),i=1,3*natom)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine check_stack_pop(array_table, narray_table, index_table,
     *                           nindex_table, block_map_table) 
c-------------------------------------------------------------------------
c The population of the stacks is checked. If pop is too great a wait is
c enforced so the subsequent operations can proceed.  
c-------------------------------------------------------------------------

      implicit none
      integer i, j, nblocks, blkndx   

      include 'interpreter.h' 
      include 'blkmgr.h' 
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'server_monitor.h'
      include 'trace.h'
      include 'timerz.h' 

      integer array_table, narray_table, index_table, nindex_table 
      integer block_map_table(*) 

      integer array, block, type, request, instruction_timer,
     *        comm_timer, iblkndx, n_used, n_free, min_blocks  
      integer stack, ncount, min_block, max_siter 
      integer ierr
      integer status(MPI_STATUS_SIZE)
      logical flag

c     if (me .eq. 0) then 
c     write(6,*) 'Checking stack population ' 
c     write(6,*) 'Number of stacks:', nblkmgr_stacks  
c     endif 

      min_blocks = 7 
      max_siter  = 5000001  

      nblocks = 0 
      do i = nblkmgr_stacks, 1, -1 ! nblkmgr_stacks-1, -1 
            stack = i 
            nblocks = nblocks + nblocks_stack(stack) 
            ncount = 0 
            min_block = min(min_blocks,nblocks_stack(stack))  
c           min_block = min_block/3    
            call find_free_stack(stack,iblkndx) 
            if (iblkndx .lt. 0) then 
               n_free = 0 
               n_used = nblocks_stack(stack) 
            else 
               n_free = iblkndx - stack_start(stack) + 1 
               n_used = nblocks_stack(stack) - n_free  
            endif 

            if (n_free .ge. min_block) go to 11  

            if (n_free .lt. min_block) then 
10             continue 
               ncount = ncount + 1 

               call scrub_from_stack(stack, array_table,
     *              narray_table, index_table, nindex_table,
     *              block_map_table, ierr)

               if (ierr .eq. 0) n_free = n_free + 1  
               if (n_free .ge. min_block) go to 11  

               call reclaim_persistent_block_from_stack(stack,
     *              array_table,narray_table, index_table, nindex_table,
     *              block_map_table, ierr)

               if (ierr .eq. 0) n_free = n_free + 1  
               if (n_free .ge. min_block) go to 11  

               if (ncount .lt. max_siter) go to 10 
            endif  

c     write(6,*) ' ME STACK NFREE :', me, i, n_free, 'AFTER :', ncount  
            write(6,*) ' nused nfree ', i, n_used, n_free, 
     *                 ' ntot ', nblocks_stack(i), 
     *                 ' start ', stack_start(i),    
     *                 ' iblkndx', iblkndx , 
     *                 ' after ', ncount, 'iterations on proc', me   
11       continue 
      enddo 

      return 
      end 


      subroutine find_min_stack_op_pardo(optable, noptable,
     *                   array_table,
     *                   narray_table,
     *                   array_labels, index_table, nindex_table,
     *                   segment_table, nsegment_table, block_map_table,
     *                   nblock_map_table,
     *                   scalar_table, nscalar_table, proctab,
     *                   address_table,
     *                   iopsave, need_stack, nstacks)
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_barrier_data.h'
      include 'scratchpad.h'
      include 'dbugcom.h'
      include 'where_table.h'
      include 'context.h'
      include 'checkpoint_data.h'
      include 'pst_functions.h'
      include 'int_gen_parms.h'
      include 'blkmgr.h'

      integer noptable, narray_table, nindex_table, nsegment_table
      integer nblock_map_table, nscalar_table
      integer comm
      integer optable(loptable_entry,noptable)
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer proctab(2,*)
      character*10 array_labels(narray_table)
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer ierr
      integer iopsave, iblk
      integer index, result_array, result_type
      integer block_map_entry(lblock_map_entry)
      integer op1_block_map_entry(lblock_map_entry)
      integer op2_block_map_entry(lblock_map_entry)
      integer opcode
      integer i, j, k, ind, nind, nseg
      integer stack, nblock, nwild, nstacks, need_stack(nstacks)
      integer array, type 
      integer n_allocate

c----------------------------------------------------------------------- 
c     Initialize the stack population 
c----------------------------------------------------------------------- 

      do i = 1, nstacks
         need_stack(i) = 0
      enddo
      n_allocate = 0

c----------------------------------------------------------------------- 
c     Loop through optable between(opsave, end_pardo) counting blocks
c     needed.  
c----------------------------------------------------------------------- 

      opcode = optable(c_opcode, iopsave)
      if (opcode .ne. pardo_op) then
         write(6,*) ' Attemping to find stack population needed for a
     *                pardo but the opcode is:', opcode
         call abort_job()
      endif

      do i = iopsave+1, noptable

c----------------------------------------------------------------------- 
c        If end of pardo exit 
c----------------------------------------------------------------------- 

         opcode = optable(c_opcode, i)
         if (opcode .eq. endpardo_op) go to 100

         do j = 1, 171 
            stack  = array_table(c_array_stack, j)
            write(6,*) j, stack 
         enddo 
         STOP 

c----------------------------------------------------------------------- 
c        Check for allocation of local array  
c----------------------------------------------------------------------- 

         if (opcode .eq. allocate_op) then
            array  = optable(c_result_array, i)
            type   = array_table(c_array_type,array) 
            if (type .ne. local_array) then
                print *,'Error: Deallocate instruction requires 
     *                   a local_array'
                print *,'Array, type = ',array,type
            endif 
            stack  = array_table(c_array_stack, array)
            nind   = array_table(c_nindex, array)
            if(array.eq.171) write(6,*) 'ARRAY NIND STACK:', array, 
     *        nind, stack 
            nblock = 1
            nwild  = 0
            do j = 1, nind
               ind = array_table(c_index_array1+j-1, array)
               nseg = index_table(c_nsegments, ind)
               if (optable(c_ind1+j-1,i) .eq. wildcard_indicator) then
                   nblock = nblock*nseg
                   nwild = nwild + 1 
               endif
            enddo
            need_stack(stack) = need_stack(stack) + nblock
            n_allocate = n_allocate + 1
         endif ! allocate 

c----------------------------------------------------------------------- 
c        Check for array assignment  
c----------------------------------------------------------------------- 

         if (opcode .eq. assignment_op) then
            array               = optable(c_result_array, i)
            type                = array_table(c_array_type,array) 
            if (type .ne. scalar_value) then 
                stack               = array_table(c_array_stack, array)
                need_stack(stack)   = need_stack(stack) + 3
                need_stack(nstacks) = need_stack(nstacks) + 3
            endif 
         endif ! assignment_op 

c----------------------------------------------------------------------- 
c        Check for contraction  
c----------------------------------------------------------------------- 

         if (opcode .eq. contraction_op) then
            array               = optable(c_result_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1

            array               = optable(c_op1_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1

            array               = optable(c_op2_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1

            need_stack(nstacks) = need_stack(nstacks) + 3
         endif ! assignment_op 

c----------------------------------------------------------------------- 
c        Check for summation  
c----------------------------------------------------------------------- 

         if ((opcode .eq. sum_op) .or. (opcode .eq. subtract_op)) then
            array               = optable(c_result_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1

            array               = optable(c_op1_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1

            array               = optable(c_op2_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1

            need_stack(nstacks) = need_stack(nstacks) + 3
         endif ! summation  

c----------------------------------------------------------------------- 
c        Check for get/request   
c----------------------------------------------------------------------- 

         if ((opcode .eq. get_op) .or. (opcode .eq. request_op)) then
            array               = optable(c_result_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1
         endif ! get/request   

c----------------------------------------------------------------------- 
c        Check for put/prepare  
c----------------------------------------------------------------------- 

         if ((opcode .eq. put_op) .or. (opcode .eq. prepare_op)) then
            array               = optable(c_result_array, i)
            stack               = array_table(c_array_stack, array)
            need_stack(stack)   = need_stack(stack) + 1
         endif ! get/request   

c----------------------------------------------------------------------- 
c        Check for deallocation of local array  
c----------------------------------------------------------------------- 

         if (opcode .eq. deallocate_op) then
            n_allocate = n_allocate - 1
         endif ! deallocate 

      enddo ! i 

100   continue

      current_line = optable(c_lineno,iopsave) 
      if (n_allocate .ne. 0) then
         write(6,*) ' You have not deallocated all local arrays in 
     *                the pardo at line :', current_line
      endif

      write(6,*) ' Stack requirements for pardo at line', current_line
      do i = 1, nstacks
         write(6,*) '    ', i, need_stack(i) 
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine  read_coefficients(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer read_type
      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block 

      integer array_type, nindex, inda(2), indb(2), indc(2), indd(2)
      integer inde(2), indf(2), ne, nf, nindex_evec

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk, evec_array, evec_type
      integer*8 iarray, ca_array, cb_array, indblk, get_block_index
      integer*8 fa_array, fb_array, ea_array, eb_array 
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack
      integer sind,type  

      double precision x(1)
      double precision dbuf(1), temp 
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Get the CA
c----------------------------------------------------------------------------

      array = 2
      array_type = array_table(c_array_type, array)
      nindex = array_table(c_nindex, array)
      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo
      ca_array = get_index_from_base(address_table(array), x, 2)

      array = 3
      array_type = array_table(c_array_type, array)
      nindex = array_table(c_nindex, array)
      do i = 1, nindex
         nb = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, nb)  ! pick up length of index
      enddo
      cb_array = get_index_from_base(address_table(array), x, 2)

      array = 9
      array_type = array_table(c_array_type, array)
      nindex = array_table(c_nindex, array)
      do i = 1, nindex
         nc = array_table(c_index_array1+i-1,array)
         indc(i) = index_table(c_index_size, nc)  ! pick up length of index
      enddo
      fa_array = get_index_from_base(address_table(array), x, 2)

      array = 10
      array_type = array_table(c_array_type, array)
      nindex = array_table(c_nindex, array)
      do i = 1, nindex
         nd = array_table(c_index_array1+i-1,array)
         indd(i) = index_table(c_index_size, nd)  ! pick up length of index
      enddo
      fb_array = get_index_from_base(address_table(array), x, 2)

      evec_array  = op(c_result_array)
      evec_type   = array_table(c_array_type, evec_array)
      nindex_evec = array_table(c_nindex, evec_array)

      if (evec_type .ne. scalar_value) return

      if (evec_array .lt. 1 .or. evec_array .gt. narray_table) then
         print *,'Error: Invalid scalar in return_sval, line ',
     *     current_line
         print *,'Array index is ',array,' Allowable values are ',
     *      ' 1 through ',narray_table
         call abort_job()
      endif
      
      sind =  array_table(c_scalar_index, evec_array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in return_sval, ',
     *           'line ',current_line
         print *,'Index for array ',evec_array,' is ',ind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

      if ( (abs (scalar_table(sind) - 1.0)) .lt. 0.0001 ) read_type = 1
      if ( (abs (scalar_table(sind) - 2.0)) .lt. 0.0001 ) read_type = 2

      CALL   READ_C (x(ca_array),inda(1),inda(2),
     +               x(cb_array),indb(1),indb(2),
     +               x(fa_array),indc(1),indc(2),
     +               x(fb_array),indd(1),indd(2),
     +               epsilon,
     +               epsilonb,read_type)

      return
      end
c---------------------------------------------------------------------------

      SUBROUTINE   READ_C (CA,ADIM1,ADIM2,
     +                     CB,BDIM1,BDIM2,
     +                     FA,CDIM1,CDIM2,
     +                     FB,DDIM1,DDIM2,
     +                     EA,
     +                     EB,read_type)

      IMPLICIT    NONE

      INCLUDE 'interpreter.h'
      INCLUDE 'int_gen_parms.h'
      INCLUDE 'parallel_info.h'

      INTEGER    read_type
      INTEGER    ADIM1,ADIM2,BDIM1,BDIM2
      INTEGER    CDIM1,CDIM2,DDIM1,DDIM2
      INTEGER    EDIM1,FDIM1,NALPHA,NBETA
      INTEGER    ALPHA_ORB,BETA_ORB
      INTEGER    TYPE,P,Q,MU

      LOGICAL    ASWAP,BSWAP,BREAK_SYM

      DOUBLE PRECISION  DROOT2

      DOUBLE PRECISION  CA (1:ADIM1,1:ADIM2)
      DOUBLE PRECISION  CB (1:BDIM1,1:BDIM2)
      DOUBLE PRECISION  FA (1:CDIM1,1:CDIM2)
      DOUBLE PRECISION  FB (1:DDIM1,1:DDIM2)
      DOUBLE PRECISION  EA (1:CDIM1)
      DOUBLE PRECISION  EB (1:DDIM1)

      DOUBLE PRECISION  TMP (1:BDIM1,1:BDIM2)
C
C
C   Reading the orbitals to perform the exact N-1 calculation
C
C
      IF (read_type .EQ. 1) THEN
      IF (me .EQ. 0) THEN
C
C
C   Read the coefficients for the N electron system!
C
C
         OPEN(UNIT=500,FILE='COEFF',STATUS='UNKNOWN')
         REWIND (500)

         DO MU = 1, ADIM1
         DO Q = 1, ADIM2
            READ (500,*) CA (MU,Q)
         ENDDO
         ENDDO

         DO MU = 1, BDIM1
         DO Q = 1, BDIM2
            READ (500,*) CB (MU,Q)
         ENDDO
         ENDDO

         DO P = 1, CDIM1
         DO Q = 1, CDIM2
            READ (500,*) FA (P,Q)
         ENDDO
         ENDDO

         DO P = 1, DDIM1
         DO Q = 1, DDIM2
            READ (500,*) FB (P,Q)
         ENDDO
         ENDDO

         DO P = 1, CDIM1
            EA (P) = FA (P,P)
         ENDDO 

         DO Q = 1, DDIM1
            EB (Q) = FB (Q,Q)
         ENDDO
C
C
C   Now determine the N-X electron system information
C
C
         NBETA     = 29   ! Number of occupied beta  electrons (HOMO)
         NALPHA    = 29   ! Number of occupied alpha electrons (HOMO)
         BETA_ORB  = 1    ! MO number to swap to valence
         ALPHA_ORB = 0    ! MO number to swap to valence
         ASWAP  = .TRUE.  ! Swap an alpha MO
         BSWAP  = .TRUE.  ! Swap a  beta  MO
         BREAK_SYM = .TRUE.
         IF (ALPHA_ORB .EQ. 0) ASWAP = .FALSE.
         IF (BETA_ORB  .EQ. 0) BSWAP = .FALSE.
C
C   Symmetry breaking
C
         IF (BREAK_SYM) THEN

            WRITE (*,*) ' BREAKING SYMMETRY OF ORBITALS 1 AND 2 '

            DROOT2 = 1.D0 / DSQRT (2.0D0)

            DO MU = 1, ADIM1
               TMP (MU,1) = DROOT2 * (CA (MU,1) + CA (MU,2))
               TMP (MU,2) = DROOT2 * (CA (MU,1) - CA (MU,2))
            ENDDO

            DO MU = 1, ADIM1
               CA (MU,1) = TMP (MU,1)
               CA (MU,2) = TMP (MU,2)
            ENDDO

            DO MU = 1, ADIM1
               TMP (MU,1) = DROOT2 * (CB (MU,1) + CB (MU,2))
               TMP (MU,2) = DROOT2 * (CB (MU,1) - CB (MU,2))
            ENDDO

            DO MU = 1, ADIM1
               CB (MU,1) = TMP (MU,1)
               CB (MU,2) = TMP (MU,2)
            ENDDO

         ENDIF
C
C   Beta Swap
C
         IF (BSWAP) THEN

            WRITE (*,1000) ' SWAPPING BETA  ORBITAL ',BETA_ORB,
     +                     ' WITH ',NBETA
C
C
C   Put the orbital to be swapped in the temp virtual created spot
C
C
            DO MU = 1, BDIM1
               TMP (MU,NBETA) = CB (MU,BETA_ORB)
            ENDDO
C
C
C   Move every orbital above the ionized orbital down one
C
C
            IF (BETA_ORB .GT. 1) THEN
               DO Q = 1, BETA_ORB
                  DO MU = 1, BDIM1
                     TMP (MU,Q) = CB (MU,Q)
                  ENDDO
               ENDDO
            ENDIF

            DO Q = BETA_ORB, NBETA-1
               DO MU = 1, BDIM1
                  TMP (MU,Q) = CB (MU,Q+1)
               ENDDO
            ENDDO
C
C
C   Now copy the rearranged coefficient array in the the real CB
C
C
            DO Q = 1, NBETA
               DO MU = 1, BDIM1
                  CB (MU,Q) = TMP (MU,Q)
               ENDDO
            ENDDO

         ENDIF
C
C   Alpha Swap
C
         IF (ASWAP) THEN

            WRITE (*,1000) ' SWAPPING ALPHA ORBITAL ',ALPHA_ORB,
     +                     ' WITH ',NALPHA
C
C
C   Put the orbital to be swapped in the temp virtual created spot
C
C
            DO MU = 1, ADIM1
               TMP (MU,NALPHA) = CA (MU,ALPHA_ORB)
            ENDDO
C
C
C   Move every orbital above the ionized orbital down one
C
C
            IF (ALPHA_ORB .GT. 1) THEN
               DO P = 1, ALPHA_ORB
                  DO MU = 1, ADIM1
                     TMP (MU,P) = CA (MU,P)
                  ENDDO
               ENDDO
            ENDIF

            DO P = ALPHA_ORB, NALPHA-1
               DO MU = 1, ADIM1
                  TMP (MU,P) = CA (MU,P+1)
               ENDDO
            ENDDO
C
C
C   Now copy the rearranged coefficient array in the the real CB
C
C
            DO P = 1, NALPHA
               DO MU = 1, ADIM1
                  CA (MU,P) = TMP (MU,P)
               ENDDO
            ENDDO

         ENDIF
C
C
C   Break the symmetry in the approximate IP-VCCS version!
C
C
      ENDIF
      ELSE IF (read_type .EQ. 2) THEN

         BREAK_SYM = .TRUE.

         IF (BREAK_SYM) THEN

            IF (me .EQ. 0) 
     +         WRITE (*,*) ' BREAKING SYMMETRY OF ORBITALS 1 AND 2',
     +                     ' IN APPROXIMATE SCHEME '

            DROOT2 = 1.0D0 / DSQRT (2.0D0)

            DO MU = 1, ADIM1
               TMP (MU,1) = DROOT2 * (CA (MU,1) + CA (MU,2))
               TMP (MU,2) = DROOT2 * (CA (MU,1) - CA (MU,2))
            ENDDO

            DO MU = 1, ADIM1
               CA (MU,1) = TMP (MU,1)
               CA (MU,2) = TMP (MU,2)
            ENDDO

            DO MU = 1, BDIM1
               TMP (MU,1) = DROOT2 * (CB (MU,1) + CB (MU,2))
               TMP (MU,2) = DROOT2 * (CB (MU,1) - CB (MU,2))
            ENDDO

            DO MU = 1, BDIM1
               CB (MU,1) = TMP (MU,1)
               CB (MU,2) = TMP (MU,2)
            ENDDO

         ENDIF

      ENDIF ! (read_type)

 1000 FORMAT(A24,I3,A6,I3)
 1001 FORMAT (A4,I3,A6,F20.8)

      RETURN
      END

C THIS ROUTINE PRINTS THE FIRST LENGTH ELEMENTS OF VECTOR VEC
C AND THEIR INDICES IN I3,F13.10 FORMAT.  USEFUL FOR QUANTITIES
C WHICH HAVE MAGNITUDES COMPARABLE TO INTEGRALS AND AMPLITUDES.

      SUBROUTINE PRVECR(VEC,LENGTH)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(LENGTH)
      if (length.lt.1) return
      WRITE(*,100) (I,VEC(I),I=1,LENGTH)
100   FORMAT(4(1X,:'[',I3,']',F13.10))
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__SET_DERV_SEQUENCE
     +
     +                    ( NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DERCX,DERCY,DERCZ,
     +                      DERDX,DERDY,DERDZ,
     +                      CENEQS,
     +
     +                               CENSQX,CENSQY,CENSQZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__SET_DERV_SEQUENCE
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine determines the sequence of centers for
C                the x,y,z coordinate derivations. The info is stored
C                in arrays CENSQp for each coordinate p=X,Y,Z. Take
C                the x coordinate for example and let CENSQX have the
C                following elements on exit from this routine:
C
C                            CENSQX (I) = 2,4,4,1
C
C                Then the sequence of single derivations is (observing
C                the index convention I=1,2,3,4 -> A,B,C,D):
C
C                     dx/dAx  dx/dDx  dx/dDx  dx/dBx  (AB|CD)
C
C                Note, that the indexing of the CENSQp arrays start
C                with 0. The reason is that the NDERp values might
C                be equal to zero.
C
C
C                  Input:
C
C                   NDERp         =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                   DERxp         =  the order of differentiation on
C                                    centers x = A,B,C,D with respect
C                                    to the p = x,y,z coordinates
C                   CENEQS (I,J)  =  center equality indicator of size
C                                    4 x 5. The first 4 columns are
C                                    defined as follows: if the
C                                    centers indexed by I and J are
C                                    equal => value = 1, if not =>
C                                    value = 0. Indexes correspond
C                                    to the A,B,C,D ordering, i.e.
C                                    1st index -> A, 2nd index -> B,
C                                    etc...
C
C                  Output:
C
C                   CENSQp        =  center sequence array for the
C                                    p = x,y,z coordinates
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     DER1,DER2,DER3,DER4
         INTEGER     DERAX,DERBX,DERCX,DERDX
         INTEGER     DERAY,DERBY,DERCY,DERDY
         INTEGER     DERAZ,DERBZ,DERCZ,DERDZ
         INTEGER     I,M,N
         INTEGER     NDERX,NDERY,NDERZ

         INTEGER     CENSQX (0:NDERX)
         INTEGER     CENSQY (0:NDERY)
         INTEGER     CENSQZ (0:NDERZ)

         INTEGER     CENEQS (1:4,1:4)
C
C
C------------------------------------------------------------------------
C
C
C             ...center sequence for x coordinate.
C
C
         IF (NDERX.GT.0) THEN

             N = 0

             DER1 = DERAX
             DER2 = DERBX
             DER3 = DERCX
             DER4 = DERDX

             IF (DER1.GT.0) THEN
                 M = DER1
                 DO 110 I = 1,M
                    CENSQX (I) = 1
                    DER1 = DER1 - CENEQS (1,1)
                    DER2 = DER2 - CENEQS (2,1)
                    DER3 = DER3 - CENEQS (3,1)
                    DER4 = DER4 - CENEQS (4,1)
  110            CONTINUE
                 N = M
             END IF

             IF (DER2.GT.0) THEN
                 M = DER2
                 DO 120 I = 1,M
                    CENSQX (N+I) = 2
                    DER1 = DER1 - CENEQS (1,2)
                    DER2 = DER2 - CENEQS (2,2)
                    DER3 = DER3 - CENEQS (3,2)
                    DER4 = DER4 - CENEQS (4,2)
  120            CONTINUE
                 N = N + M
             END IF

             IF (DER3.GT.0) THEN
                 M = DER3
                 DO 130 I = 1,M
                    CENSQX (N+I) = 3
                    DER1 = DER1 - CENEQS (1,3)
                    DER2 = DER2 - CENEQS (2,3)
                    DER3 = DER3 - CENEQS (3,3)
                    DER4 = DER4 - CENEQS (4,3)
  130            CONTINUE
                 N = N + M
             END IF

             IF (DER4.GT.0) THEN
                 M = DER4
                 DO 140 I = 1,M
                    CENSQX (N+I) = 4
                    DER1 = DER1 - CENEQS (1,4)
                    DER2 = DER2 - CENEQS (2,4)
                    DER3 = DER3 - CENEQS (3,4)
                    DER4 = DER4 - CENEQS (4,4)
  140            CONTINUE
                 N = N + M
             END IF

             IF (N.NE.NDERX) THEN
                 WRITE (*,*) ' Inconsistent x derivatives! '
                 WRITE (*,*) ' N,NDERX = ',N,NDERX
                 WRITE (*,*) ' erd__set_derv_sequence '
                 STOP
             END IF

         END IF
C
C
C             ...center sequence for y coordinate.
C
C
         IF (NDERY.GT.0) THEN

             N = 0

             DER1 = DERAY
             DER2 = DERBY
             DER3 = DERCY
             DER4 = DERDY

             IF (DER1.GT.0) THEN
                 M = DER1
                 DO 210 I = 1,M
                    CENSQY (I) = 1
                    DER1 = DER1 - CENEQS (1,1)
                    DER2 = DER2 - CENEQS (2,1)
                    DER3 = DER3 - CENEQS (3,1)
                    DER4 = DER4 - CENEQS (4,1)
  210            CONTINUE
                 N = M
             END IF

             IF (DER2.GT.0) THEN
                 M = DER2
                 DO 220 I = 1,M
                    CENSQY (N+I) = 2
                    DER1 = DER1 - CENEQS (1,2)
                    DER2 = DER2 - CENEQS (2,2)
                    DER3 = DER3 - CENEQS (3,2)
                    DER4 = DER4 - CENEQS (4,2)
  220            CONTINUE
                 N = N + M
             END IF

             IF (DER3.GT.0) THEN
                 M = DER3
                 DO 230 I = 1,M
                    CENSQY (N+I) = 3
                    DER1 = DER1 - CENEQS (1,3)
                    DER2 = DER2 - CENEQS (2,3)
                    DER3 = DER3 - CENEQS (3,3)
                    DER4 = DER4 - CENEQS (4,3)
  230            CONTINUE
                 N = N + M
             END IF

             IF (DER4.GT.0) THEN
                 M = DER4
                 DO 240 I = 1,M
                    CENSQY (N+I) = 4
                    DER1 = DER1 - CENEQS (1,4)
                    DER2 = DER2 - CENEQS (2,4)
                    DER3 = DER3 - CENEQS (3,4)
                    DER4 = DER4 - CENEQS (4,4)
  240            CONTINUE
                 N = N + M
             END IF

             IF (N.NE.NDERY) THEN
                 WRITE (*,*) ' Inconsistent y derivatives! '
                 WRITE (*,*) ' N,NDERY = ',N,NDERY
                 WRITE (*,*) ' erd__set_derv_sequence '
                 STOP
             END IF

         END IF
C
C
C             ...center sequence for z coordinate.
C
C
         IF (NDERZ.GT.0) THEN

             N = 0

             DER1 = DERAZ
             DER2 = DERBZ
             DER3 = DERCZ
             DER4 = DERDZ

             IF (DER1.GT.0) THEN
                 M = DER1
                 DO 310 I = 1,M
                    CENSQZ (I) = 1
                    DER1 = DER1 - CENEQS (1,1)
                    DER2 = DER2 - CENEQS (2,1)
                    DER3 = DER3 - CENEQS (3,1)
                    DER4 = DER4 - CENEQS (4,1)
  310            CONTINUE
                 N = M
             END IF

             IF (DER2.GT.0) THEN
                 M = DER2
                 DO 320 I = 1,M
                    CENSQZ (N+I) = 2
                    DER1 = DER1 - CENEQS (1,2)
                    DER2 = DER2 - CENEQS (2,2)
                    DER3 = DER3 - CENEQS (3,2)
                    DER4 = DER4 - CENEQS (4,2)
  320            CONTINUE
                 N = N + M
             END IF

             IF (DER3.GT.0) THEN
                 M = DER3
                 DO 330 I = 1,M
                    CENSQZ (N+I) = 3
                    DER1 = DER1 - CENEQS (1,3)
                    DER2 = DER2 - CENEQS (2,3)
                    DER3 = DER3 - CENEQS (3,3)
                    DER4 = DER4 - CENEQS (4,3)
  330            CONTINUE
                 N = N + M
             END IF

             IF (DER4.GT.0) THEN
                 M = DER4
                 DO 340 I = 1,M
                    CENSQZ (N+I) = 4
                    DER1 = DER1 - CENEQS (1,4)
                    DER2 = DER2 - CENEQS (2,4)
                    DER3 = DER3 - CENEQS (3,4)
                    DER4 = DER4 - CENEQS (4,4)
  340            CONTINUE
                 N = N + M
             END IF

             IF (N.NE.NDERZ) THEN
                 WRITE (*,*) ' Inconsistent z derivatives! '
                 WRITE (*,*) ' N,NDERZ = ',N,NDERZ
                 WRITE (*,*) ' erd__set_derv_sequence '
                 STOP
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function chunk_size(next_batch_start, max_batch, np,
     *                            last_chunk)
c---------------------------------------------------------------------------
c   Determines the next chunk size for the load-balancing parallel loop.
c
c   Arguments:
c      next_batch_start - The beginning of the next chunk of work to be
c                         performed.
c      max_batch        - The total number of loop iterations to be performed.
c      np               - The number of processors executing the loop.
c----------------------------------------------------------------------------
      implicit none
      include 'trace.h'
      integer next_batch_start, max_batch, np
      integer n, npcut
      integer last_chunk
      integer max_chunk, avg_batch
      parameter (max_chunk = 100)
      integer cutoff
      integer distribute_batch
      double precision slope, dchunk

      if (max_batch .le. np) then
         chunk_size = 1
         return
      endif

      n = max_batch - next_batch_start + 1   ! number of iterations left
      if (n .le. 0) then
         chunk_size = 1
         return
      endif

      distribute_batch = 0.9 * max_batch  ! feed out 90% of work in first pass
      avg_batch = (distribute_batch + np -1) / np
      cutoff = avg_batch * np
      if (next_batch_start .lt. cutoff) then
         chunk_size = min(avg_batch, max_chunk)
      else
            slope = real(next_batch_start-cutoff)/(max_batch-cutoff)
            dchunk = avg_batch + (1.0-avg_batch)*slope
             chunk_size = dchunk + 0.5
            chunk_size = max(min(chunk_size,max_chunk), 1)
c         endif
      endif

      chunk_size = min(chunk_size, n)
      return
      end
 

      Subroutine reorder(Vecin, Vecout, Iang, nao)

      Implicit Double Precision (A-H, O-Z)
      Double Precision Vecin(nao), Vecout(nao)
      Integer Iang(nao)
c
      Call Dcopy(nao, Vecin, 1, Vecout, 1)

      index = 1
      Do while (index .lt. nao)
         If (iang(index) .Le. 1) then
C
c handle s and p functions (ie, do nothing)
C
             index = index + 1

         Else if (iang(index) .eq. 2) Then
c
c handle d functions
C
             vecout(index)   = Vecin(index)
             vecout(index+1) = Vecin(index+3)
             vecout(index+2) = Vecin(index+5)
             vecout(index+3) = Vecin(index+1)
             vecout(index+4) = Vecin(index+4)
             vecout(index+5) = Vecin(index+2)
             index = index + 6

         Else if (iang(index) .EQ. 3) Then
c
c handle f functions 

             vecout(index)   = Vecin(index)
             vecout(index+1) = Vecin(index+6)
             vecout(index+2) = Vecin(index+9)
             vecout(index+3) = Vecin(index+3)
             vecout(index+4) = Vecin(index+1)
             vecout(index+5) = Vecin(index+2)
             vecout(index+6) = Vecin(index+5)
             vecout(index+7) = Vecin(index+8)
             vecout(index+8) = Vecin(index+7)
             vecout(index+9) = Vecin(index+4)
             Index = Index + 10
         
         Else if (iang(index) .ge. 4) Then
          
             Write(6, "(a,a,a)") " MOLDEN display of orbitals for",
     &                           " angluar momentum higher",
     &                           " than f functions are incorrect."  
             Return
         Endif
C
      Enddo

      Return
      End

C INITIALIZES I/O SYSTEM COMMON BLOCKS.
C DEPENDENT OF CRAPSI, SHOULD *NEVER* BE CALLED DIRECTLY.

      SUBROUTINE POPCORN(MEMSIZ)
      IMPLICIT INTEGER (A-Z)

      COMMON /INCORE/ ICREC(2),USEC,IXT(2),IMOD(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFFX(2),LENREC
      COMMON /FILSPC/ IBUFLN,IPRCLN,IPRCWD
      COMMON /ISTART/ I0
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST

      if (memsiz.lt.1) return

C SET IOPOS COMMON BLOCK PARAMETERS

      CALL IZERO(CACHDIR,400)

C   o SIZE OF INDIVIDUAL CACHE RECORD
      ICHCSZ=IFLAGS(37)

C   o NUMBER OF RECORDS IN I/O CACHE
      CACHNUM=IFLAGS(44)
      CACHNMP1=CACHNUM+1

C   o CORE SIZE LEFT AFTER ALLOCATING CACHE AREA
      ICRSIZ=MEMSIZ-CACHNUM*ICHCSZ
c NO - make sure that icrsiz is even for alignment
      icrsiz=icrsiz-mod(icrsiz,2)

C   o PHYSICAL RECORD SIZE (INTEGERS)
      LENREC=ICHCSZ

C   o PHYSICAL RECORD SIZE (INTEGERS)
      IPRCWD=ICHCSZ

C   o PHYSICAL RECORD SIZE (BYTES)
      IPRCLN=ICHCSZ*IINTLN

c YAU - This was obsoleted by replacing the only two occurances of idaccr
c with iprcwd*idaccm.
cC   o PHYSICAL RECORD SIZE (RECLS)
c      idaccr=iprcwd*idaccm

C CACHE OFFSETS IN ICORE ARRAY
      IOFF=I0
      DO I=1,CACHNUM
         CACHPOS(I)=IOFF
         IOFF=IOFF+LENREC
      END DO
      I0=IOFF

      RETURN
      END

c This subroutine deletes a stack. WARNING: It is possible to delete any
c stack, but the number of active stacks will be decremented iff the id
c is that of the last stack.

c OUTPUT
c int HIGHPT : the high-water mark of used indices
c              NOTE: HighPt is not the number of touched elements unless
c              INDEX1 (from LIFO_NEW) is 1.

c INPUT
c int ID : the stack id to delete

      subroutine lifo_del(id,HighPt)
      implicit none

      integer id, HighPt



      integer           lifo(4,100), nStacks
      common /lifo_com/ lifo, nStacks
      save   /lifo_com/



      if (id.lt.1.or.nStacks.lt.id) then
         print *, '@LIFO_DEL: Invalid stack id ',id
         print *, '           Must be between 1 and ',nStacks
         call c_exit(1)
      end if
      if (lifo(2,id).eq.-1) then
         print *, '@LIFO_DEL: stack ',id,' is invalid'
         call c_exit(1)
      end if

      lifo(2,id) = -1
      HighPt = lifo(3,id)-1
      if (id.eq.nStacks) nStacks = nStacks-1

      return
c     end subroutine lifo_del
      end

C EMULATOR OF CRAY SCILIB ROUTINE. LOCATES ALL ELEMENTS OF A DOUBLE
C VECTOR (X) LESS THAN A PARTICULAR VALUE (TARGET).

c The UNICOS man page for whenflt is appended to this file.

      subroutine whenflt(n,x,incx,target,index,nn)
      implicit none
      integer n, incx, index(*), nn
      double precision x(*), target
      integer i, ndx


      if (n.lt.0) then
         print *, '@WHENFLT: Assertion failed.'
         print *, '          n = ',n
         call errex
      end if


      if (incx.ge.0) then
         if (incx.eq.1) then
            nn = 0
            do i = 1, n
               if (x(i).lt.target) then
                  nn = nn + 1
                  index(nn) = i
               end if
            end do
         else
            nn = 0
            ndx = 1
            do i = 1, n
               if (x(ndx).lt.target) then
                  nn = nn + 1
                  index(nn) = i
               end if
               ndx = ndx + incx
            end do
         end if
c     else if (incx.lt.0) then
      else
         print *, '@WHENFLT: negative increments must be coded'
         call errex
c     end if (incx.ge.0)
      end if

      return
      end

c NAME
c      WHENFLT, WHENFLE, WHENFGT, WHENFGE - Searches a real vector for all
c      elements with a specified logical relationship to a real target
c
c SYNOPSIS
c      CALL WHENFLT(n,x,incx,target,index,nn)
c      CALL WHENFLE(n,x,incx,target,index,nn)
c      CALL WHENFGT(n,x,incx,target,index,nn)
c      CALL WHENFGE(n,x,incx,target,index,nn)
c
c DESCRIPTION
c      WHENFLT searches a real vector for all elements that are less than a
c      real target.
c
c      WHENFLE searches a real vector for all elements that are less than or
c      equal to a real target.
c
c      WHENFGT searches a real vector for all elements that are greater than
c      a real target.
c
c      WHENFGE searches a real vector for all elements that are greater than
c      or equal to a real target.
c
c      When using the Cray Fortran compiler UNICOS systems, all arguments
c      must be of default kind unless documented otherwise.  On UNICOS
c      systems, default kind is KIND=8 for integer, real, complex, and
c      logical arguments.
c
c      These routines have the following arguments:
c
c      n      Integer.  (input)
c             Number of elements of the array to be searched.
c
c      x      Real array of dimension (n-1)* |incx| + 1.  (input)
c             Array x contains the vector to be searched.
c
c      incx   Integer.  (input)
c             Increment between elements of the searched array.
c
c      target Real.  (input)
c             Value for which array is searched.
c
c      index  Integer array of dimension n.  (output)
c             Array index contains the indices in the array elements that
c             match target.
c
c      nn     Integer.  (output)
c             Number of values put in the index array.
c
c NOTES
c      When scanning backward (incx < 0), each routine starts at the end of
c      the vector and moves backward, as follows:
c
c      x(1-incx*(n-1)), x(1-incx*(n-2)), ..., x(1)
c
c      The desired values are at:
c
c      x(1+(index(k)-1)*incx) when incx > 0
c      x(1+(index(k)-n)*incx) when incx < 0
c
c      for all k = 1, 2, ..., nn.

      Subroutine Get_shell_den(Dens, Dens_4shell, Naobfns, La, Lb, 
     &                         Iloc, Jloc, Numcoi, Numcoj)
      
      Implicit Double Precision(A-H, O-Z)
     
      Dimension Dens(Naobfns,*), Dens_4shell(*)

#include "ecp.par"
#include "ecp.com"

#ifdef _DEBUG_LVLM
      Write(6,"(a)")"@-Get-shell:The reordered AO basis density matrix"
      call debugout(Dens, naobfns)
#endif

      Ind = 0
      Do Iang = 1, (La+1)*(La+2)/2
         Do Jang = 1, (Lb+1)*(Lb+2)/2
C
             Do Icon = 1, Numcoi
                Do Jcon = 1, Numcoj

                   Ind  = Ind  + 1
                   Indx = Iloc + (Icon-1)*(La+1)*(La+2)/2 + Iang
                   Jndx = Jloc + (Jcon-1)*(Lb+1)*(Lb+2)/2 + Jang
                   
                   Dens_4shell(Ind) = Dens(Indx,Jndx)

                Enddo
             Enddo
C
         Enddo
      Enddo

#ifdef _DEBUG_LVLM
      length = Numcoi*Numcoj*(La+1)*(La+2)*(Lb+1)*(LB+2)/4
      Write(6,*) 
      Write(6,"(a)") "Shell Densities"
      Write(6, "(6(1x,F10.7))") (dens_4shell(i), i=1, length)
#endif

   
      Return
      End

c This routine prepares the SB environment to use lists (getlst and putlst).

      subroutine sb_io_init
      implicit none

#include "aces.h"
#include "machsp.com"
#include "kscore.com"
#include "flags.com"

      integer iMem, piocache, setptr
      logical bInitCache

      call callstack_push('SB_IO_INIT')

      bInitCache = (memknown.ne.0)
      iMem       = iintfp*iflags(37)*iflags(44)
      piocache   = setptr(1,F_INTEGER,iMem)
cTODO      call aces_io_init(KSCore,piocache,iMem,bInitCache)

      call callstack_pop
      return
      end

c This routine prepares the SB environment to use lists (getlst and putlst).

      subroutine sb_io_init
      implicit none
















c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler


























cYAU - ACES3 stuff . . . we hope - #include <aces.par>






c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end





c Two different "stacks" of memory will be available in the course of an
c Aces3 calculation.  Integer memory will be stored in icore.  Real memory
c will be stored in dcore.
c
c Memory allocation is done in one of two ways, dynamic or nondynamic.  This
c is controlled by the parameter dynmem.  If dynmem is 1, dynamic memory
c is used.  Otherwise, nondynamic memory is used.
c
c Two additional parameters nondynimem and nondyndmem control how much
c nondynamic memory is allocated initially in the icore and dcore stacks.
c If dynmem is 1, both of these parameters SHOULD be 1.

c Dynamic memory allocation is done in a fairly straighforward way.  The
c program runs through everything twice.  The first time is just to determine
c how much dynamic memory is required.  The second time is use to actually
c allocate the memory and use it.  In some cases, it may be difficult to
c determine how much memory to use in advance in each of the stacks.  To
c aid this, there is also the option of only running through a program a
c single time.  When this happens, both stacks are allocated initially and
c used throughout the program.  If the memory requirement for either stack
c is exceeded, the program crashes.
c
c Two parameters which are used in either case are memknown and maxicore.
c Both MUST be set in the calling program.
c
c   memknown : 0 if a dummy run is being done to determine memory usage
c              1 if the memory usage is known from a previous dummy run
c             -1 if no dummy run is done (only one run through the program)
c   maxicore : the maximum amount of icore to allocate (this MAY be
c              adjusted IF a dummy run detects that more is needed, but in
c              the case of a single run, this will be rigidly applied)
c
c This include file is required whenever calls to any of the memory functions
c (setptr and relptr) are called or when part of the execution depends on
c whether the first or second run is being performed.
c
c ***NOTE***
c It is important that icore be aligned on a floating point boundary.  One
c way which seems to insure this is to have icore the FIRST element in the
c common block.  So, make sure that no integer is ever inserted before icore
c in the common block declaration.

      integer dynmem,nondynimem,nondyndmem
      parameter (dynmem=1)
      parameter (nondynimem=1)
      parameter (nondyndmem=1)

      double precision   dcore(nondyndmem)
      common /dcore_com/ dcore
      save   /dcore_com/

      integer    kscore(nondynimem)
      common /kscore_mem / kscore

      integer            memknown,maxicore
      common /kscore_com/ memknown,maxicore
      save   /kscore_com/



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end

      integer iMem, piocache, setptr
      logical bInitCache

      call callstack_push('SB_IO_INIT')

      bInitCache = (memknown.ne.0)
      iMem       = iintfp*iflags(37)*iflags(44)
      piocache   = setptr(1,0,iMem)
cTODO      call aces_io_init(KSCore,piocache,iMem,bInitCache)

      call callstack_pop
      return
      end

      Subroutine get_lambda(Grad_K1CM, Vec_K1C, Vec_K1C_On_Evecs, 
     &                      Grad_K1C_On_Evecs, Hess_K1C, Evecs, 
     &                      AtmMass, Vec_K1C_Updated, Work, 
     &                      Coords_K1C, Stride, Delta, Nreals,
     &                      Hess_Eval_Tol, Lamsearch_Tol, 
     &                      Binsearch_Tol)

      Implicit Double Precision (A-H, O-Z)
C
      Double Precision L_bound,  Lamsearch_Tol, Mass, Lamda
C
      Logical lamda_found, Bracket_end
C
      Dimension Grad_K1CM(3*Nreals), Hess_K1C(3*Nreals, 3*Nreals), 
     &          AtmMass(Nreals), Evecs(3*Nreals, 3*Nreals),
     &          Vec_K1C(3*Nreals), Vec_K1C_On_Evecs(3*Nreals),
     &          Grad_K1C_On_Evecs(3*Nreals), Work(27*Nreals*Nreals),
     &          Vec_K1C_Updated(3*Nreals), Coords_K1C(3*Nreals)
C
C Mass weigh the Hessian and obtain the eigenvectors.
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The Hessian"
      Call output(Hess_K1C, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals, 
     &            3*Nreals, 1)
#endif
      Call Dcopy(9*Nreals*Nreals, Hess_K1C, 1,
     &                            Work(18*nreals*nreals + 1), 1)
C
      Do Ideg = 1, 3*Nreals
         Do Jdeg = 1, 3*Nreals  
            Mass = DSQRT(AtmMass(1+(Ideg-1)/3)*AtmMass(1+(Jdeg-1)/3))
            IF (Mass .lt. 1.0D-3) Then
               Hess_K1C(Ideg, Jdeg) = 0.0D0
            Else
               Hess_K1C(Ideg, Jdeg) = Hess_K1C(Ideg, Jdeg)/Mass
            Endif
         Enddo
      Enddo
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The mass weighted Hessian"
      Call output(Hess_K1C, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals, 
     &            3*Nreals, 1)
#endif
C
C Project the mass-weighted Hessian and diagonalize to define normal
C modes.

      Call Projec_FC(Coords_K1C, Hess_K1C, AtmMass, Grad_K1CM, Work, 
     &               WorK(9*Nreals*Nreals+1), 1.0D-8, Nreals, .True., 
     &               .True., .False.)
C
#ifdef _DEBUG_LVL0
      NX = 3*Nreals
      Write(6,"(a)") "The projected Hessian"
      CALL OUTPUT(Hess_K1C, 1, NX, 1, Nx, Nx, Nx, 1)
#endif

      Call Eig(Hess_K1C, Evecs, 3*Nreals, 3*Nreals, 0)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      NX = 3*Nreals
      Write(6,"(a)") "The eigen vectors of the projected Hessian"
      CALL OUTPUT(Evecs, 1, NX, 1, Nx, Nx, Nx, 1)
      Write(6,"(a)") "The eigenvalues of the  projected Hessian"
      Write(6, "(4F17.13)") (Hess_K1C(I,I), I=1, NX)
#endif
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-get_lambda Grad_K1CM (ZMAT order)"
      Write(6, "(3F17.13)") (Grad_K1CM(i), i=1,3*Nreals)
      Write(6,*)
      Write(6,*) "@-get_lambda VEC_K1C (ZMAT order)"
      Write(6, "(3F17.13)") (Vec_K1C(i), i=1,3*Nreals)
#endif
C
C Gradient along the eigenvectors of the Hessian
C   
      Do Imode = 1, 3*Nreals
         Grad_K1C_on_Evecs(Imode) = Ddot(3*Nreals, Grad_K1CM, 1, 
     &                                  Evecs(1, Imode), 1)
         Vec_K1C_on_Evecs(Imode)  = Ddot(3*Nreals, Vec_K1C, 1,
     &                                  Evecs(1, Imode), 1)
C
         If (Dabs(Hess_K1C(Imode, Imode)) .LT. Hess_Eval_Tol) Then
             Grad_K1C_on_Evecs(Imode) = 0.0D0
             Vec_K1C_on_Evecs(Imode)  = 0.0D0
             Hess_K1C(Imode, Imode)   = 0.0D0
         Endif 
C
      Enddo
C 
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The position and gradient vectors along e-vecs"
      Write(6, "(F17.13)") (Grad_K1C_on_EvecS(I), I=1, 3*Nreals)
      Write(6,*)
      Write(6, "(F17.13)") (Vec_K1C_on_EvecS(I), I=1, 3*Nreals)
#endif
C
      Imode = 3*Nreals
      Eval_min  = Hess_K1C(Imode, Imode) 
      Do While (Hess_K1C(Imode, Imode) .NE. 0.0D0 .OR. Imode .GT. 0)
         Imode  = Imode - 1
         If (Hess_K1C(Imode, Imode) .NE. 0.0D0) Eval_min  = 
     &                                Hess_K1C(Imode, Imode) 
      Enddo 
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The lowest eiegnvalue of hess. and the tolerance"
      Write(6, "(a,F17.13,a,F13.10)") "Eval_min =", Eval_min, 
     &          " Hess_Eval_Tol =",Hess_Eval_Tol 
#endif
C
C The solution to Eq. 26 im JPC, vol. 94, 5525, 1990 must be
C lower than the lowst eigenvalue of the Hessian. Another words
C Lambda < Eval_min. 
C 
      halfs      = 0.50D0*Stride
      L_bound    = Eval_min - (2.0D0)*Delta 
      U_bound    = Eval_min - (1/2.0D0)*Delta 
      Halfs2     = halfs*halfs
      niter      = 1
      Lbound_Tol = max((Eval_min)*Lamsearch_Tol,
     &                   10.0D0*Lamsearch_Tol)
      Ubound_Tol = max(1.0D03, Abs(Eval_min))
      Ubound_Tol = 1.0D03*Ubound_Tol
C
#ifdef _DEBUG_LVLM1
        Write(6,*) "Lambda iterations" 
        Write(6,*) "Starting lower and upper limits"
        Write(6,"(2F17.13)") L_bound, U_bound
#endif
C
      Bracket_end = .FALSE. 
      Do while (.NOT. Bracket_end) 
         F_Lowr = 0.0D0
         F_Uppr = 0.0D0
C
         Do Imode = 1, 3*Nreals     
            Dnumer = Hess_K1C(Imode, Imode)*Vec_K1C_on_Evecs(Imode) - 
     &               Grad_K1C_on_Evecs(Imode)
            Denomi = Hess_K1C(Imode, Imode) - L_bound
            F_Lowr = Dnumer**2/Denomi**2 + F_Lowr 
            Denomi = Hess_K1C(Imode, Imode) - U_bound 
            F_Uppr = Dnumer**2/Denomi**2 + F_Uppr
         Enddo
#ifdef _DEBUG_LVLM1
        Write(6,*) "The F_Lowr and F_Uppr"
        Write(6,"(2F17.13)") F_Lowr, F_Uppr
#endif
C
         F_Lowr = F_lowr - Halfs2
         F_Uppr = F_Uppr - Halfs2
         If (F_Lowr*F_Uppr .LT. 0.0D0) Then 
             Bracket_end = .TRUE.
             Go to 10
         Endif
C
         niter   = niter  + 1
         L_bound = Eval_min - (2.0D0)**niter*Delta
         U_bound = Eval_min - (1.0D0/(2.0D0)**niter)*Delta
c
#ifdef _DEBUG_LVLM1
        Write(6,*) "Lower and upper limits during its."
        Write(6,"(2F17.13)") L_bound, U_bound
#endif
         
         If (L_bound .LT. -Ubound_Tol .AND. ABS(Eval_min-U_bound) .LT. 
     &       Lbound_Tol)  Then 
             L_bound = -Ubound_Tol
             U_bound = Eval_min - Lbound_Tol
             Write(6, "(a,a)") "@-get_lambda Bracketing for lambda", 
     &             "is failed"

             Call Errex
         Endif
      Enddo
C
   10 Continue
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The upper and lower bound for lambda"
      Write(6, "(a,F17.13,a,F17.13)") " L_bound =",  L_bound,
     &          " U_bound  =",U_bound
#endif
C
C The binary search portion to extract the value in the range 
C L_bound - U_bound.
C
      Tmp_lamda    = 0.0D0
      Lamda_found = .False.
      Niter        = 0
      
      Do while (.Not. lamda_found) 
         F_Lowr = 0.0D0
         F_Uppr = 0.0D0
         F_Midl = 0.0D0
         Lamda  = 0.50D0*(L_bound + U_bound) 
#ifdef _DEBUG_LVLM1
       Write(6,*) "The starting lambda"
       Write(6, "(F17.13)") lamda
#endif
         Do Imode = 1, 3*Nreals
            Dnumer = Hess_k1C(Imode, Imode)*Vec_K1C_on_Evecs(Imode) -
     &               Grad_K1C_on_Evecs(Imode)
            Denomi = Hess_K1C(Imode, Imode) - L_bound
            F_Lowr = Dnumer**2/Denomi**2 + F_Lowr
            Denomi = Hess_K1C(Imode, Imode) - U_bound
            F_Uppr = Dnumer**2/Denomi**2 + F_Uppr
            Denomi = Hess_K1C(Imode, Imode) - Lamda       
            F_Midl = Dnumer**2/Denomi**2 + F_Midl
         Enddo
#ifdef _DEBUG_LVLM1
        Write(6,*) "The FL, FU, FM during iterations"
        Write(6,"(3F17.13)") F_Lowr, F_Uppr, F_Midl
#endif 

            F_Lowr = F_lowr - Halfs2
            F_Uppr = F_Uppr - Halfs2
            F_Midl = F_midl - Halfs2       
C
            If (Abs(Tmp_lamda -lamda) .LT. Binsearch_Tol) 
     &           lamda_found = .True.
            
            Niter = Niter + 1
            If (Niter .gt. 1000) Then
                Write(6, "(a,a)") "@-Get_lambda: The binary search",
     &                            " for lambda failed!"
                Call Errex
            Endif 
C
            Tmp_lamda = Lamda
C
#ifdef _DEBUG_LVLM1
        Write(6,*) "The FL, FU, FM post halfs2"
        Write(6,"(3F17.13)") F_Lowr, F_Uppr, F_Midl
#endif
            if (F_Lowr*F_Midl .LT. 0.0D0) U_bound = Lamda
            If (F_Uppr*F_Midl .LT. 0.0D0) L_bound = Lamda
C
#ifdef _DEBUG_LVLM1
        Write(6,*) "The L_bound and U_bound during iterations"
        Write(6,"(2F17.13)") L_bound, U_bound
#endif
       Enddo
       
       If (Lamda .GT. Eval_min) Then 
           Write(6, "(a,a,2F10.5)")
     &    "@-Get_lambda: Warning, lambda is grater than the lowest",
     &    "eigenvalue", lamda, Eval_min
          Call Errex
       Endif
       
       If (Abs(Lamda - Eval_min) .LT. Binsearch_Tol) Then
          Write(6, "(a,a,F10.5)") "@-Get_lambda: Lamda is too close",
     &                            "to the lowest eigenvalue", Lamda,
     &                             Eval_min 
          Call Errex
       Endif 
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The value of lambda after binary search"
      Write(6, "(a,F17.13)") " Lambda  =", Lamda 
#endif
C
C Make the Newton-Raphson Step
C
       Call Dzero(Vec_K1C_Updated, 3*Nreals)
       Do Imode = 1, 3*Nreals
          If (Hess_K1C(Imode, Imode) .EQ. 0.0D0) Then
             Do Jmode = 1, 3*Nreals 
                Vec_K1C_Updated(Jmode) = Vec_K1C_Updated(Jmode) + 
     &                                   Hess_K1C(Imode, Imode)*
     &                                   Evecs(Jmode,Imode)
             Enddo
          Else
             Denomi = (Lamda*Vec_K1C_on_Evecs(Imode) - 
     &                 Grad_K1C_on_Evecs(Imode))
             Dnumer = Hess_K1C(Imode, Imode) - Lamda
             Do Jmode = 1, 3*Nreals
                Vec_K1C_Updated(Jmode) = Vec_K1C_Updated(Jmode) + 
     &                                   (Denomi/Dnumer)*
     &                                   Evecs(Jmode,Imode)
  
             Enddo 
          Endif
       Enddo
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The M. W. updated vector (Vec_K1C_Updated)"
      Write(6,"(3F17.13)") (Vec_K1C_Updated(i), i=1,3*Nreals) 
#endif
C
C Eleminate mass weighing from the updated vector.
C
      Ioff = 0
      Do Iatom = 1, Nreals
         Do Ixyz = 1, 3
            Ioff = Ioff + 1
            Vec_K1C_updated(Ioff) = Vec_K1C_updated(Ioff)/
     &                              Dsqrt(AtmMass(Iatom))
         Enddo 
      Enddo    
C 
      Call Dcopy(9*Nreals*Nreals, Work(18*Nreals*Nreals+1), 1,
     &           Hess_K1C, 1)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,*) "The restored Hessian"
      Call output(Hess_K1C, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals,
     &            3*Nreals, 1)
#endif                          
C
       Return
       End
             

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE READGH(IGRD,IHES,NATOM,G,H,IMAP,SCR,IAVGRD,IAVHES)
C
C READS IN THE GRADIENT AND HESSIAN MATRICES
C
C INPUT :
C
C   IGRD = -1 DON'T READ GRADIENT, RETURN G UNTOUCHED
C        =  0 READ GRADIENT, ASSUMING VMOL ORDER
C        =  1 READ GRADIENT, ASSUMING ZMAT ORDER (DUMMIES INCLUDED)
C   IHES -  HESSIAN READ CONTROL FLAG.  VALUES HAVE SAME MEANING AS 
C           ABOVE
C  NATOM -  THE NUMBER OF ATOMS
C
C OUTPUT :
C
C      G -  THE GRADIENT VECTOR
C IAVGRD -  =1 GRADIENT FOUND; =0 GRADIENT NOT FOUND
C      H -  THE HESSIAN MATRIX
C IAVHES -  =1 HESSIAN FOUND;  =0 HESSIAN NOT FOUND
C
C SCRATCH :
C
C    SCR - LENGTH 9*NATOM*NATOM
C   IMAP - LENGTH NATOM
C
C The vmol and seward both generates symm. redundant atoms in the same
C order. So the MAP2ZMAT remains unchanged. See vmol2ja (v2ja.f) for
C detailed notes. Ajith Perera 07/2000
C
CEND       
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL YESNO
      DIMENSION H(3*NATOM,3*NATOM),G(3,NATOM),SCR(9*NATOM*NATOM)
      DIMENSION IMAP(NATOM)
C
      PARAMETER (TOL = 1.D-8)
C
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C
      IONE=1
      IAVGRD=0
      IAVHES=0
      NSIZE=3*NATOM
      CALL IGETREC(20,'JOBARC','NREALATM',IONE,NREAL)
      CALL IGETREC(20,'JOBARC','MAP2ZMAT',NATOM,IMAP)
C
      IF(IGRD.GE.0)THEN
C
C READ IN GRADIENT
C 
       CALL ZERO(G,NSIZE)
       NREAD=NREAL
       IF(IGRD.EQ.1)NREAD=NATOM
       CALL DGETREC(-1,'JOBARC','GRADIENT',3*NREAD,SCR)
       X=XDNRM2(3*NREAD,SCR,1)
       IF(X.GT.TOL)IAVGRD=1
C
       IF(IGRD.EQ.0)THEN
C
C ASSUME VMOL ORDERING
C
         IOFF=1
          DO 10 IATMVML=1,NATOM
           IATMZMAT=IMAP(IATMVML)
           IF(IATMZMAT.NE.0)THEN
           CALL XDCOPY(3,SCR(IOFF),1,G(1,IATMZMAT),1) 
c           G(1,IATMZMAT) = SCR(IOFF)
c           G(2,IATMZMAT) = SCR(IOFF+1)
c           G(3,IATMZMAT) = SCR(IOFF+2)
           IOFF=IOFF+3
           ENDIF
10        CONTINUE
       ELSE
C
C ASSUME ZMAT ORDERING
C
        CALL XDCOPY(NSIZE,SCR,1,G,1)
       ENDIF
      ENDIF
C
      IF(IHES.GE.0)THEN
C
C READ IN HESSIAN
C
       NGET=3*NREAL
       IF(IHES.EQ.1)NGET=NSIZE
       CALL ZERO(H,NSIZE*NSIZE)
       CALL DGETREC(-1,'JOBARC','HESSIANM',NGET*NGET,SCR)
       X=XDNRM2(9*NREAL*NREAL,SCR,1)
       IF(X.GT.TOL)IAVHES=1
       IF(IFLAGS2(3).EQ.1)THEN
        INQUIRE(FILE='FCMFINAL',EXIST=YESNO)
        IF(.NOT.YESNO)THEN
         WRITE(6,200)
         CALL ERREX
        ENDIF
        OPEN(UNIT=15,FILE='FCMFINAL')
        READ(15,*)
        READ(15,'((3F20.10))')SCR
        CLOSE(UNIT=15, STATUS="KEEP")
       ENDIF
C
       IF(IHES.EQ.0)THEN
C
C ASSUME VMOL ORDERING
C
        IO=1
        DO 110 IATVML=1,NATOM
         IATMZMAT=IMAP(IATVML)
         DO 115 IXYZ=1,3
          ICOL =IXYZ+(IATMZMAT-1)*3
          DO 120 JATVML=1,NATOM
           JATMZMAT=IMAP(JATVML)
           IF(IATMZMAT.NE.0.AND.JATMZMAT.NE.0)THEN
            IROW=1+(JATMZMAT-1)*3
            CALL BLKCPY(SCR(IO),3,1,H,NSIZE,NSIZE,IROW,ICOL)
            IO=IO+3
           ENDIF
120       CONTINUE
115      CONTINUE
110     CONTINUE
C
C ASSUME ZMAT ORDERING
C
       ELSE
        CALL XDCOPY(NSIZE*NSIZE,SCR,1,H,1)
       ENDIF
      ENDIF
C
      OPEN(UNIT=13,FILE='FCMFINAL',FORM='FORMATTED')
      WRITE(13,'(2I5)')NATOM,3*NATOM
      WRITE(13,'((3F20.10))')H
      CLOSE(UNIT=13,STATUS='KEEP')
C
200   FORMAT(T3,'@READGH-F, Resonance Raman intensities require ',
     &       'reference state FCMFINAL file.',/,
     &       T3,'Save JOBARC and JAINDX file and run ',
     &       'xjoda twice with FCMFINAL file in place.')
C
      RETURN
      END

C  Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
C  USA
      subroutine v_nuc_nuc(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)

c--------------------------------------------------------------------------
c
c
c
c
c   
c--------------------------------------------------------------------------

      implicit none
      include 'int_gen_parms.h'
      include 'interpreter.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer natoms, imoment
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer sind, xind, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer stack

      double precision VNUC,XCOORD,YCOORD,ZCOORD,DIST
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the scalar
c---------------------------------------------------------------------------

      array      = op(c_result_array)
      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The argument in nn_dipole_moment
     *            must be a scalar.'  
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
        print *,'Scalar table index out of range in nn_dipole_moment, ',
     *          'line ',current_line
        print *,'Index for array ',array,' is ',sind,' should be ',
     *          'between 1 and ',nscalar_table
        call abort_job()
      endif
C
C
C   Compute the nuclear nuclear potential energy
C
C 
      natoms = scalar_table(sind)
      scalar_table(sind) = 0.0D0
      VNUC = 0.0D0
      DO I = 1, natoms
      DO J = I + 1, natoms
         XCOORD = acenter(I,1) - acenter(J,1)
         YCOORD = acenter(I,2) - acenter(J,2)
         ZCOORD = acenter(I,3) - acenter(J,3)
         DIST   = DSQRT (XCOORD*XCOORD + YCOORD*YCOORD + ZCOORD*ZCOORD)
         VNUC = VNUC + charge(I)*charge(J) / DIST
      ENDDO ! J
      ENDDO ! I
      scalar_table(sind) = VNUC

      return 
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sial_compile_and_send_tables1()
c----------------------------------------------------------------------------
c   This subroutine does the following:
c   Master:   
c      1. Compiles the SIAL programs used for each company.
c      2. Sends the descriptions of the compiled tables to each processor 
c         in the company.
c      3. Sends the relevant tables to each processor in the company.
c
c   Worker:
c      1. Receives the table description from the master.
c      2. Creates the tables.
c      3. Receives the table data from the master.
c----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'company.h'
      include 'int_gen_parms.h'
      include 'proto_defines.h'

      integer master
      integer pst_get_master
      integer me, nprocs, ierr

      integer company, target_company
      integer i, j, k, n
      integer interpretface, str_trimlen
      integer pst_get_company
      integer req(1000), status(mpi_status_size, 1000)
      integer wait_status(mpi_status_size)
      integer ireq, nreq

      character*80 sial_file
      call mpi_comm_rank(mpi_comm_world, me, ierr)
      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      master = pst_get_master()

      call load_pre_defined_routines()

      if (master .eq. me) then
         do i = 1, max_company
            if (c_table(i,c_company_id) .ne. MPI_UNDEFINED) then 

c---------------------------------------------------------------------------
c   Compile the SIAL code (or read an object file) for this company.
c---------------------------------------------------------------------------

              sial_file = company_sial_prog(i)
              if (sial_file(1:1) .eq. ' ') go to 100 ! no program
              target_company   = c_table(i,c_company_id)

              n = str_trimlen(sial_file)
              if (sial_file(n-3:n) .eq. '.sio') then
                 call read_tables(sial_file(1:n) // char(0))
              else if (sial_file(n-4:n) .eq. '.sial') then
                  print *,'Error: Cannot use .sial files.'
                  call abort_job()
c                 ierr = interpretface(sial_file(1:n) // char(0) )
c                 if (ierr .ne. 0) then
c                    print *,'Error: SIAL compile errors.'
c                    call abort_job()
c                 endif
              else
                 print *,'Error: Invalid file format for SIAL program.'
                 print *,'File extension must be .sial or .sio'
                 print *,'SIAL_FILE = ',sial_file(1:n)
                 call abort_job()
              endif

c--------------------------------------------------------------------------
c   Distribute the tables to all processors in the company.
c--------------------------------------------------------------------------

              nreq = 0
              do j = 1, nprocs
                 company = pst_get_company(j-1)
                 if (company .eq. target_company) then
                    if (nreq .eq. 1000) then
                       do k = 1, 5   ! Need 5 empty slots per call 

c---------------------------------------------------------------------------
c   We have exhausted the amount of requests.  Wait for completion of one
c   and move req(nreq) to it's slot.
c---------------------------------------------------------------------------

                          call mpi_waitany(nreq, req, ireq, 
     *                                  wait_status, ierr)
                          if (ireq .ne. nreq) then
                             req(ireq) = req(nreq)  ! move last req down
                          endif
                          nreq = nreq - 1
                       enddo
                    endif

                    call send_tables(j-1, req, nreq)
                 endif 
              enddo

c---------------------------------------------------------------------------
c   Free the SIP tables.
c---------------------------------------------------------------------------

              call mpi_waitall(nreq, req, status, ierr)

              company = pst_get_company(me)
              if (company .eq. io_company_id)
     *             call free_sip_tables()
            endif
  100       continue
         enddo 
      else

c---------------------------------------------------------------------------
c   Receive the worker's tables from the master.
c---------------------------------------------------------------------------

         company = pst_get_company(me)
         if (company .ne. io_company_id) 
     *      call recv_tables(master) 
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_NLMO_ORBITALS
     +
     +                    ( NBAS,NOCC,
     +                      MAXOCC,
     +                      USED,
     +                      PSYMACC,QSYMACC,
     +                      P,
     +                      XMAT,
     +
     +                             W,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_NLMO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine generates the natural localized molecular
C                orbitals (NLMOs) from the previously found set of
C                NBOs.
C
C                Procedure:
C
C                The NLMO expansion coefficients C in terms of NBOs
C                are found by carefully zeroing the offdiagonal NBO
C                occupation matrix block P(AB,NBO), where A represents
C                the high occupancy block (core, lone-pair, bond NBOs)
C                and B the low occupancy block (anti-bond, Rydberg
C                NBOs). The NLMO expansion coefficients C are thus
C                defined as:
C
C
C
C    |            |            |          |           |           |
C    | P(AA,NLMO) |      0     |          | P(AA,NBO) | P(AB,NBO) |
C    |            |            |          |           |           |
C    |------------|------------|  =  C(T) |-----------|-----------| C
C    |            |            |          |           |           |
C    |     0      | P(BB,NLMO) |          | P(BA,NBO) | P(BB,NBO) |
C    |            |            |          |           |           |
C
C
C
C                Note that if the one-electron occupation matrix used
C                for finding the NAO and NBO sets corresponds to the
C                closed shell SCF density, then P(AA,NLMO) will be
C                equal to the diagonal matrix 2I (with I = unit matrix)
C                and P(BB,NLMO) will become a zero matrix. Only if
C                we use originally a correlated one-electron occupation
C                matrix we will have non-diagonal P(AA,NLMO) and
C                P(BB,NLMO) blocks.
C
C                To find the NLMO expansion coefficient matrix, a
C                sequence of well controlled symmetrized Jacobi
C                rotations is performed on P(NBO):
C
C                   1) Find largest element Pij of P(AB,NBO)
C                      in magnitude. If |Pij| below certain
C                      threshold => stop.
C
C                   2) Find all elements Pkl of P(AB,NBO) for
C                      which |Pkl| = |Pij|, Pkk = Pii and Pll = Pjj
C                      (within certain accuracy limits). All these
C                      2x2 subblocks of P(AB,NBO) are related by
C                      symmetry and should be treated all at once
C                      in order not to break the symmetry.
C
C                   3) Perform a symmetrized Jacobi rotation on
C                      all the 2x2 subblocks found in 2).
C
C                   4) Return to 1).
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis.
C                    NOCC         =  # of occupied (large weight) NBOs.
C                    MAXOCC       =  maximum orbital occupancy number
C                                    (can be only 1 or 2).
C                    USED         =  int vector that will be used
C                                    for the symmetrized Jacobi routine.
C                    PSYMACC      =  symmetry accuracy for occupation
C                                    matrix values (including weights)
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    P            =  full NBAS x NBAS occupation matrix
C                                    in AO basis.
C                    XMAT         =  flp scratch array of matrix type.
C                    C            =  NBO coefficient matrix in AO basis.
C
C
C                  Output:
C
C                    W            =  NLMO weight vector in original NBO
C                                    order.
C                    C            =  NLMO coefficient matrix in AO basis
C                                    with columns in original NBO order.
C
C
C                  Note that the occupation matrix P in AO basis will
C                  be destroyed here.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     LTRG,UTRG
         LOGICAL     REVERS
         LOGICAL     SAVEP

         INTEGER     NBAS
         INTEGER     NITER
         INTEGER     NOCC

         INTEGER     USED  (1:NBAS)

         DOUBLE PRECISION  MAXOCC
         DOUBLE PRECISION  PSYMACC,QSYMACC
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  W (1:NBAS)

         DOUBLE PRECISION  C     (1:NBAS,1:NBAS)
         DOUBLE PRECISION  P     (1:NBAS,1:NBAS)
         DOUBLE PRECISION  XMAT  (1:NBAS,1:NBAS)

         DATA  ZERO   /0.D0/
C
C
C------------------------------------------------------------------------
C
C
C             ...set up the lower triangle of the ocupation matrix
C                in NBO basis.
C
C
         LTRG  = .TRUE.
         UTRG  = .TRUE.
         SAVEP = .FALSE.

         CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,
     +                NBAS,NBAS,
     +                0,
     +                SAVEP,LTRG,UTRG,
     +                C,
     +                P,
     +                W,
     +
     +                        XMAT )
     +
     +
         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                XMAT,
     +
     +                        P )
     +
     +
C
C
C             ...refine the ocupation matrix. By this we mean to
C                set the offdiagonal elements of the occupation
C                matrix corresponding to zero and MAXOCC diagonal
C                elements equal to exactly zero, thereby eliminating
C                any chance of (possibly incorrect) symmetry mixing.
C
C
         CALL  NLO__REFINE_OCCUPATION_MATRIX
     +
     +              ( NBAS,NBAS,
     +                NBAS,
     +                MAXOCC,
     +                QSYMACC,
     +
     +                         P )
     +
     +
C
C
C             ...balance the ocupation matrix. By this we mean to
C                set the offdiagonal elements of the occupation
C                matrix equal if they differ only by the symmetry
C                accuracy.
C
C
         CALL  MAT__BALANCE_SYMMETRIC_MATRIX
     +
     +              ( NBAS,NBAS,
     +                NBAS,
     +                NBAS,
     +                PSYMACC,
     +                W,
     +
     +                         P )
     +
     +
         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                ( 6,
     +                  ' P matrix ',
     +                  NBAS,NBAS,
     +                  NBAS,0,
     +                  P )
     +
     +
C         CALL  MAT__C_EQ_ZERO_FLOAT
C     +
C     +              ( NBAS,NBAS,
C     +                NBAS,NBAS,
C     +                XMAT )
C     +
C     +
C         CALL  MAT__C_EQ_A_TIMES_B_FLOAT
C     +
C     +              ( NBAS,NBAS,
C     +                NBAS,NBAS,
C     +                NBAS,NBAS,
C     +                NBAS,NBAS,NBAS,
C     +                P,P,
C     +
C     +                         XMAT )
C     +
C     +
C         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
C     +
C     +                ( 6,
C     +                  ' P * P ',
C     +                  NBAS,NBAS,
C     +                  NBAS,0,
C     +                  XMAT )
C     +
C     +
C
C
C             ...invoke the symmetrized Jacobi rotations.
C
C
         REVERS = .FALSE.

         CALL  NLO__SYMMETRIC_JACOBI
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,
     +                NBAS,
     +                NOCC+1,NOCC,
     +                REVERS,
     +                USED,
     +                P,
     +
     +                         NITER,
     +                         W,
     +                         XMAT )
     +
     +
         WRITE (*,*) ' NLMO converged after ',NITER,' iterations! '
         WRITE (1,*) ' NLMO converged after ',NITER,' iterations! '
C
C
C             ...generate the NLMO coefficient matrix in AO basis.
C
C
         CALL  MAT__C_EQ_A_TIMES_B_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,NBAS,
     +                C,XMAT,
     +
     +                         P )
     +
     +
         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                P,
     +
     +                        C )
     +
     +
         CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
     +
     +                ( 1,
     +                  ' NLMO weight vector ',
     +                  NBAS,
     +                  NBAS,
     +                  W )
     +
     +
         CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                ( 1,
     +                  ' C (NLMO) in AO basis ',
     +                  NBAS,NBAS,
     +                  NBAS,NBAS,
     +                  C )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine dump_block(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Print the first and last sample of a block.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
       double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index(mx_array_index), nindex, ierr
      integer block, blkndx, seg(mx_array_index)
      integer find_current_block
      integer*8 indblk, get_block_index
      integer*8 daddr, get_index_from_base
      integer type
      integer stack
      
      integer comm

      integer val1(mx_array_index), val2(mx_array_index)

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      integer n, nb, proc, map, company_comm
      integer na1,na2,ni1,ni2
      integer pst_get_company_comm, pst_get_company_rank
      company_comm    = pst_get_company_comm(me)
      proc  = pst_get_company_rank(me)

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      array = op(c_result_array)
      type  = array_table(c_array_type,array)
      nb = array_table(c_numblks, array)
      map = array_table(c_block_map, array)

      nindex = array_table(c_nindex, array)
      n = 1
      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         seg(i) = index_table(c_current_seg,index(i))

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         call get_index_segment(index(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
         n = n * (val2(i)-val1(i)+1)
      enddo

c---------------------------------------------------------------------------
c   Get array data address.
c---------------------------------------------------------------------------

      if (type .eq. static_array) then
         daddr = address_table(array)
         indblk = get_index_from_base(daddr, x, 2)
         print *,'Dump of static array ',array,' daddr = ',daddr,
     *      ' range = ',(val1(i),val2(i),i=1,nindex)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)
         print *,'Task ',me,' at line number ',current_line,
     *     ' ARRAY ',array,' BLOCK ',block,' ind = ',
     *   (index(i),i=1,nindex),' seg = ',(seg(i),i=1,nindex),
     *   ' actual size = ',n 
         if (block .lt. 0) return 

         if (type .eq. distributed_array .and.
     *       block_map_table(c_processor,map+block-1).eq.proc) then
            call dump_block_data(array,block)
         else
            call dump_block_data(array,block)
         endif

         stack = array_table(c_array_stack, array)
         indblk = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

      if (nindex .eq. 4) then
         call print_samples(me, array, block, 
     *                   x(indblk), val1(1),val2(1),
     *                   val1(2),val2(2),
     *                   val1(3),val2(3),
     *                   val1(4),val2(4))
      else if (nindex .eq. 2) then
         if (type .eq. static_array) then
            na1 = array_table(c_index_range1,array)
            na2 = array_table(c_index_range2,array)
            ni1 = array_table(c_index_range1+1,array)
            ni2 = array_table(c_index_range2+1,array)
         else
            na1 = val1(1)
            na2 = val2(1)
            ni1 = val1(2)
            ni2 = val2(2)
         endif
         call print_samples2(me, array, block,
     *                   x(indblk), val1(1),val2(1),
     *                   val1(2),val2(2), na1,na2,ni1,ni2)
      endif
      
      return
      end

      subroutine print_samples(me, array, block, x, 
     *                           a1,a2,i1,i2,b1,b2,j1,j2)
      implicit none
      include 'trace.h'

      integer me, array, block
      integer a1,a2,b1,b2,i1,i2,j1,j2
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2)


      integer a,b,i,j
      double precision eps
      double precision val
      double precision xmax, xmin, sumsq

      xmax = x(a1,i1,b1,j1)
      xmin = x(a1,i1,b1,j1)
      sumsq = 0.
      do j = j1,j2
      do b = b1,b2
      do i = i1,i2
      do a = a1,a2
         xmax = max(x(a,i,b,j), xmax)
         xmin = min(x(a,i,b,j), xmin)
         sumsq = sumsq + x(a,i,b,j)*x(a,i,b,j)
      enddo
      enddo
      enddo
      enddo
 
      print *,'Task ',me,' line ',current_line,
     *        ' Array, block = ',array,block,
     *        ' first = ',
     *        x(a1,i1,b1,j1), 
     *        ' last = ',x(a2,i2,b2,j2),
     *        ' xmin, xmax, sumsq = ',xmin,xmax,sumsq,
     *        ' ranges ',a1,a2,i1,i2,b1,b2,j1,j2
      return
      end

      subroutine print_samples2(me, array, block, x, 
     *                           a1,a2,i1,i2, na1, na2,ni1,ni2)
      implicit none
      include 'trace.h'

      integer me, array, block
      integer a1,a2,i1,i2
      integer na1,na2,ni1,ni2
      double precision x(na1:na2,ni1:ni2)


      integer a,i
      double precision eps
      double precision val
      double precision xmax, xmin, sumsq

      xmax = x(a1,i1)
      xmin = x(a1,i1)
      sumsq = 0.
      do i = i1,i2
      do a = a1,a2
         xmax = max(x(a,i), xmax)
         xmin = min(x(a,i), xmin)
         sumsq = sumsq + x(a,i)*x(a,i)
      enddo
      enddo
 
      print *,'Task ',me,' line ',current_line,
     *        ' Array, block = ',array,block,
     *        ' first = ',
     *        x(a1,i1), 
     *        ' last = ',x(a2,i2),
     *        ' xmin, xmax, sumsq = ',xmin,xmax,sumsq,
     *        ' ranges ',a1,a2,i1,i2
c      do i = i1,i2
c      do a = a1,a2
c         print *,'Task ',me,' array, a,b ',array,a,i,' value ',
c     *         x(a,i)
c      enddo
c      enddo
      return
      end

      Subroutine Ecp_int_typ1(Iecp_cnt, Lamu, Ltot, La, Lb, Exp12, 
     &                        Xhat, Yhat, Zhat, Xp, Yp, Zp, Xc, Yc, 
     &                        Zc, Acs_xyz, Bcs_xyz, Pc2, Fact_ab, 
     &                        PC_zero, Cint, Int, Rad1_zero, Grads)

      Implicit Double Precision (A-H, O-Z)

#include "ecp.par"
#include "ecp.com"
   
      Dimension ACS_xyz(0:2*Maxang,3),BCS_xyz(0:2*Maxang,3)
      Dimension Rad(0:2*Maxang,0:2*Maxang), 
     &          Ang(0:2*maxang,0:2*Maxang),Cint(Maxmem_a3)
      
      Logical PC_zero, Rad1_zero, Grads

      Kcrl  = Kfirst(1, Iecp_cnt)
      Kcru  = Klast(1, Iecp_cnt)
C
C This is the U(lmax) term (kcrl to kcru keep track how many terms
C in the Sum Sum{j}D_{jl}r^njexp(-zeta_J)r^2) and the Clp, nlp and 
C Zlp arrays have D_{jl}, nj and Zeta_j respectively. 
C
      Call Dzero(Rad,(2*Maxang+1)**2)
C
#ifdef _DEBUG_LVL0
CSS      write(6,*) "Initialize debug values for Kcrl and Kcru"
CSS      Kcrl = 1
CSSS      Kcru = 1
      Write(6, "(a, 2(1x,i2))") "Debug values of Kcrl:Kcru : ", 
     &      Kcrl, Kcru
#endif
C
      Do Kcr = Kcrl, kcru
       
         Zeta = Zlp(Kcr)
         Np   = Nlp(Kcr)
         Dlj  = Clp(Kcr)

#ifdef _DEBUG_LVL0
      Write(6,*) "Initialize debug values for Zeta, Np and Dlj"
CSSS      Zeta = 3.0D0
CSSS      NP   = 3
CSSS      Dlj  = 2.0D0
      Write(6, "(a,(1x,i2,F10.6,1x,F10.6))") "Np,Zeta,Dlj: ",
     &      Np, Zeta, Dlj
#endif
C
         Call Ecp_rad_int_typ1(Lamu, Ltot, Np, Dlj, Exp12, Zeta, 
     &                         Xp, Yp, Zp, Xc, Yc, Zc, Pc2,
     &                         Fact_ab, Rad, Rad1_zero)

      Enddo

#ifdef _DEBUG_LVL0
      Write(6,*)
#endif

      If (.Not. Rad1_zero) Call Ecp_ang_int_typ1(Xhat, Yhat, Zhat,
     &                                           La, Lb, Ltot, Lamu, 
     &                                           Acs_xyz, Bcs_xyz, 
     &                                           Rad, Ang, Cint, Int,
     &                                           Grads)

#ifdef _DEBUG_LVL0
      If (.Not. Rad1_zero) Then
      Write(6,"(a)") "The Type1 integral"
      Write(6,"(6(1x,F15.13))")(Cint(i), i=1,Int)
      Endif
#endif

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C CALCULATES THE DISTANCE BETWEEN TWO POINTS IN CARTESIAN SPACE

      Double Precision FUNCTION DIST(A,B)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(3),B(3)
cYAU - I warn you, expanding all of these out does not ensure Z is positive.
      Z=  (A(1)-B(1))**2
      Z=Z+(A(2)-B(2))**2
      Z=Z+(A(3)-B(3))**2
      DIST = SQRT(Z)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_block(op, array_table, narray_table,
     *                         index_table, nindex_table, 
     *                         block_map_table, nblock_map_table,
     *                         segment_table, nsegment_table,
     *                         scalar_table, nscalar_table,
     *                         address_table, 
     *                         debugit, validate, 
     *                         flopcount, comm, comm_timer, 
     *                         instruction_timer)
c--------------------------------------------------------------------------
c   Compute the block corresponding to the result array of the "op" 
c   entry. 
c
c   op             	Operation table entry.
c   array_table		Table of array information.
c   narray_table	Number of arrays in table.
c   debug		Logical flag for debug print
c   validate            Logical flag for block validation.
c   flopcount           Number of floating point operations performed.
c   send_count          Returned number of blocks sent (0 or 1).
c   comm                MPI Communicator
c   comm_timer          Timer handle to accumulate wait time on blocks.
c   instruction_timer   Timer handle for current instruction timer.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blkmgr.h'
      include 'machine_types.h'
      include 'dbugcom.h'
      include 'checkpoint_data.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table
      integer nindex_table, index_table(lindex_table_entry,nindex_table)
      integer op(*), array_table(larray_table_entry,narray_table)
      integer nblock_map_table
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nsegment_table
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer comm
      integer comm_timer, instruction_timer
      logical debugit, debug, validate, create_block
      logical partial_create

      integer find_current_block
      integer find_current_block_map
      integer i, j, k, opcode, block, blkndx, result
      integer op1_blkndx, op2_blkndx
      integer nindex, nindex1, nindex2
      integer op1, op2
      integer op1_block, op2_block
      integer ncind, cind(mx_array_index)
      integer flag, flag1, flag2
      integer result_type, op1_type, op2_type
      integer flopcount
      integer ind(mx_array_index), segsave(mx_array_index), 
     *        nb, iblock, l,ind_input(mx_array_index)
      integer iblock_map
      integer get_block_number
      integer request
      integer get_block_request
      integer status(MPI_STATUS_SIZE)
      integer ierr, allocate_block
      integer result_flag
      integer size
      integer dummy
      integer stack
      integer uflag, nargs
      integer type(mx_array_index), bval(mx_array_index), 
     *        eval(mx_array_index), bdim(mx_array_index),
     *        edim(mx_array_index)
      integer*8 indblk
      integer type1(mx_array_index), bval1(mx_array_index), 
     *        eval1(mx_array_index), bdim1(mx_array_index),
     *        edim1(mx_array_index)
      integer type2(mx_array_index), bval2(mx_array_index), 
     *        eval2(mx_array_index), bdim2(mx_array_index),
     *        edim2(mx_array_index)
      integer*8 indblk1
      integer*8 indblk2
      
      integer push_do, pop_do
      logical direct_flag
      logical prefetch_flag

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

      opcode = op(c_opcode)
      if (opcode .eq. do_op .or.
     *    opcode .eq. enddo_op .or.
     *    opcode .eq. pardo_op .or.
     *    opcode .eq. endpardo_op .or.
     *    opcode .eq. go_to_op .or.
     *    opcode .eq. jz_op .or.
     *    opcode .eq. exit_op .or.
     *    opcode .eq. cycle_op .or.
     *    opcode .eq. where_op) return

      result = op(c_result_array)
      result_type = array_table(c_array_type, result)
      if (result .lt. 0) then
         print *,'Error: Invalid array handle in operation'
         print *,'Array = ',result
         print *,'OP: ',(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      create_block = .false.
      debug        = debugit
      flopcount    = 0
      
      if (opcode .eq. reindex_op) then

c---------------------------------------------------------------------------
c   Reindex operation. 
c---------------------------------------------------------------------------

         nindex = array_table(c_nindex,result)
         do i = 1, nindex
            cind(i) = op(c_ind1+i-1)
            if (cind(i) .le. 0 .or.
     *          cind(i) .gt. nindex_table) then
               print *,'Task ',me,' Error: Invalid index in operation'
               print *,'Operation: ',(op(j),j=1,loptable_entry)
               call abort_job()
            endif
         enddo

         if (nindex .lt. mx_array_index) then
            do i = nindex+1,mx_array_index
               cind(i) = 0
            enddo
         endif
 
         call set_effective_indices(array_table(1,result), cind)
         return
      endif

c---------------------------------------------------------------------------
c   Index arithmetic and logic operations
c---------------------------------------------------------------------------

      if ((opcode .ge. sp_add_op .and. 
     *    opcode .le. sp_ldindex_op) .or.
     *    opcode .eq. sp_ldi_sym_op) then
         call handle_sp_op(op, index_table, nindex_table)
         return
      endif

c--------------------------------------------------------------------------
c   Scalar logic and arithmetic instructions.
c--------------------------------------------------------------------------

      if (opcode .ge. fl_add_op .and.
     *    opcode .le. fl_load_value_op) then
         call handle_fsp_op(op, array_table, narray_table,
     *                      scalar_table, nscalar_table)
         return
      endif

c---------------------------------------------------------------------------
c   If a distributed array is being used in any instruction except "create"
c   (or reindex_op), check to make sure it has already been created.
c---------------------------------------------------------------------------

      call check_create_flag(op, array_table, narray_table)

c--------------------------------------------------------------------------
c   See if the instruction's result array block is available.
c--------------------------------------------------------------------------

      direct_flag = .false.
      if (result .gt. 0 .and. result_type .ne. static_array) then
         block = find_current_block(result, array_table(1,result),
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           block_map_table, blkndx)
         if (block .gt. 0) then

c--------------------------------------------------------------------------
c   Check the block's communication request to make sure it is
c   not engaged in communication.  If it is, we must wait until
c   the communication is complete before proceeding with the calculation.
c
c   The only exceptions are the GET and REQUEST instructions (get_op, 
c   request_op), which are checked internally to their handler subroutines.
c--------------------------------------------------------------------------

            if (opcode .ne. get_op .and.
     *          opcode .ne. request_op) then
               request = get_block_request(result, block, blkndx)
               if (request .ne. mpi_request_null) 
     *             call wait_on_block(result, block, blkndx,
     *                result_type, request,
     *                instruction_timer, comm_timer)
            endif   
         else
            direct_flag = .true.   ! block does not exist, no need to attempt
                                   ! further lookups.
         endif
      endif

      if (opcode .eq. user_sub_op) then
         call get_upgrade_flag(op(c_user_sub), uflag)

         if (uflag .eq. 1) then
            nargs = 0
            if (op(c_result_array) .ne. 0) then
               nargs = nargs + 1

c---------------------------------------------------------------------------
c   Get system info about the result array's block.
c---------------------------------------------------------------------------

            call retrieve_block_info(x, op(c_result_array), 
     *               array_table, narray_table,
     *               index_table, nindex_table, segment_table,
     *               nsegment_table, block_map_table, nblock_map_table,
     *               scalar_table, nscalar_table,
     *               address_table, op,
     *               indblk, nindex,
     *               type, bval, eval, bdim, edim)
            endif

            if (op(c_op1_array) .ne. 0) then
               nargs = nargs + 1

c---------------------------------------------------------------------------
c   Get system info about the current block of the 1st operand array.
c---------------------------------------------------------------------------

               call retrieve_block_info(x, op(c_op1_array), 
     *               array_table, narray_table,
     *               index_table, nindex_table, segment_table,
     *               nsegment_table, block_map_table, nblock_map_table,
     *               scalar_table, nscalar_table,
     *               address_table, op,
     *               indblk1, nindex1,
     *               type1, bval1, eval1, bdim1, edim1)
            endif   

            if (op(c_op2_array) .ne. 0) then
               nargs = nargs + 1

c---------------------------------------------------------------------------
c   Get system info about the current block of the 2nd operand array.
c---------------------------------------------------------------------------

               call retrieve_block_info(x, op(c_op2_array), 
     *               array_table, narray_table,
     *               index_table, nindex_table, segment_table,
     *               nsegment_table, block_map_table, nblock_map_table,
     *               scalar_table, nscalar_table,
     *               address_table, op,
     *               indblk2, nindex2,
     *               type2, bval2, eval2, bdim2, edim2)
            endif   

            if (nargs .gt. 0) then 
             
c---------------------------------------------------------------------------
c   Call user-written code with only system info arguments.
c---------------------------------------------------------------------------

                  call exec_user_sub2(op(c_user_sub), x(indblk), 
     *                  nindex, type, 
     *                  bval, eval, bdim, edim,
     *                 x(indblk1), nindex1, type1, bval1, eval1,
     *                  bdim1, edim1,
     *                 x(indblk2), nindex2, type2, bval2, eval2,
     *                  bdim2, edim2, nargs)
         else
            print *,'Error:User instruction with upgrade, but no args.'
            call abort_job()
         endif   ! uflag
      else  

c---------------------------------------------------------------------------
c   Call user-written code with standard args.
c---------------------------------------------------------------------------

         call exec_user_sub(op(c_user_sub), array_table, narray_table,
     *               index_table, nindex_table, segment_table, 
     *               nsegment_table, block_map_table, nblock_map_table,
     *               scalar_table, nscalar_table, address_table,
     *               op)
         endif
         return
      endif

      if (opcode .eq. put_op .or.
     *    opcode .eq. put_replace_op) then

c------------------------------------------------------------------------
c   Accumulate operation.
c------------------------------------------------------------------------

         call global_accumulate(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, address_table,
     *                      comm, op, comm_timer, instruction_timer)
         return
      endif

      if (opcode .eq. collective_sum_op) then

c------------------------------------------------------------------------
c   Collective sum operation (i. e., scalar accumulate on all procs).
c------------------------------------------------------------------------

         call collective_sum(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      comm, op)
         return
      endif

c---------------------------------------------------------------------------
c   Create operation.   Create the blocks of a distributed array.
c---------------------------------------------------------------------------

      if (opcode .eq. create_op) then
         if (result_type .ne. distributed_array) then
            print *,'Error: Create operation called for array ',
     *               result,'.  Array is not distributed.'
            print *,'Array type is ',result_type
            call abort_job()
         endif
         
         if (array_table(c_create_flag, result) .ne. 0) then

            nindex = array_table(c_nindex,result)
            partial_create = .false.
            do k = 1, nindex
               if (op(c_ind1+k-1) .eq. wildcard_indicator) 
     *               partial_create = .true.
            enddo
            if (partial_create .eq. .false.) then 
            print *,'Task ',me,' Error: Attempt to create an array ',
     *              'that has already been created.', partial_create 
            print *,'Wild Array = ', (op(c_ind1+k-1), k=1, nindex) 
c           print *,'Array = ',result,' Array_table entry = ',
c    *              (array_table(j,result),j=1,larray_table_entry)
            call abort_job()
            endif 
         endif

c----------------------------------------------------------------------------
c   Save the segment states of this array.
c----------------------------------------------------------------------------

         nindex = array_table(c_nindex,result)
         do k = 1, nindex
            ind(k) = array_table(c_index_original+k-1,result)
            segsave(k) = index_table(c_current_seg,ind(k))
            ind_input(k) = array_table(c_index_array1+k-1,result)
            array_table(c_index_array1+k-1,result) =
     *          array_table(c_index_original+k-1,result)
         enddo

c---------------------------------------------------------------------------
c   Warn user if the array was declared with repeated indices.
c---------------------------------------------------------------------------

         do k = 1, nindex
            do l = 1, nindex
               if (k .ne. l .and.
     *             ind(k) .eq. ind(l)) then
                  print *,'*** WARNING *** Array number ',result,
     *               ' was declared with repeated indices.  This could',
     *               ' result in the creation of only the diagonal ',
     *               'blocks of the array, causing surprising results.'
                  go to 100
               endif
            enddo
         enddo

c--------------------------------------------------------------------------
c   Partial create, or full create?
c---------------------------------------------------------------------------

         partial_create = .false.
         do k = 1, nindex
            if (op(c_ind1+k-1) .eq. wildcard_indicator) 
     *            partial_create = .true.
         enddo
         if (dbg .and. partial_create) 
     *      print *,'PARTIAL CREATE at line ',
     *         current_line,' op ',(op(l),l=1,loptable_entry)
 
  100    continue
         nb = array_table(c_numblks, result)
         iblock_map = array_table(c_block_map, result)

         do 200 k = 1, nb
            if (block_map_table(c_processor,iblock_map+k-1) .eq. 
     *          my_company_rank) then

               if (partial_create) then
                  do l = 1, nindex
                     if (op(c_ind1+l-1) .ne. wildcard_indicator) then

c-----------------------------------------------------------------------------
c   Check block_map table's index values against the one's saved in ind.
c   If all such indices match, we fall through, and the block will be 
c   created.
c-----------------------------------------------------------------------------

                        if (index_table(c_current_seg,ind(l)) .ne.
     *                      block_map_table(c_block_map_seg+l-1,
     *                               iblock_map+k-1)) go to 200
                     endif
                  enddo
               endif
 
c----------------------------------------------------------------------------
c   Set up the "current segments" of this block and calculate the blocksize.
c----------------------------------------------------------------------------

               do l = 1, nindex
                  index_table(c_current_seg,ind(l)) =
     *               block_map_table(c_block_map_seg+l-1,
     *                               iblock_map+k-1)
               enddo

               if (dbg) then
                  if (partial_create) print *,'Creating block ',k,
     *            ' indices ',
     *            (index_table(c_current_seg,ind(l)),l=1,nindex)
               endif

               call determine_current_block_size(ind, 
     *                    nindex, index_table, nindex_table,
     *                    segment_table, nsegment_table, size)

c----------------------------------------------------------------------------
c   Attempt to set up the new block.
c----------------------------------------------------------------------------

               block = get_block_number(result,k)
               if (block .le. 0) then

c----------------------------------------------------------------------------
c   Now allocate the block.
c----------------------------------------------------------------------------

                  ierr = allocate_block(result, k, size,
     *                            array_table, narray_table,
     *                            index_table, nindex_table,
     *                            block_map_table)
                  if (ierr .le. 0) then
                     print *,'Error: During create operation.'
                     print *,'Cannot allocate a block for ',
     *                  'array',result,' block number ',k,
     *                  ' on processor ',me
                     call array_block_summary(array_table, 
     *                                        narray_table)
                     call dump_block_ids()
                     call abort_job()
                  else
                     blkndx = ierr
                  endif

c--------------------------------------------------------------------------
c   Store the block's index and segment data in the blkmgr table.
c---------------------------------------------------------------------------

                  call blkmgr_insert_block_in_list(
     *                      array_table(c_block_list,result),dummy,
     *                      blkndx, c_block_list_ptr, .false.)
                  call set_block_indices(result, k, blkndx,
     *                                   array_table(1,result))
                  call set_block_segments(result, k, blkndx, 
     *                        index_table, nindex_table)
               else

c-------------------------------------------------------------------------
c   The block is left over from previous operations. 
c   Since the block was not allocated through the allocate_block routine
c   it must be busied.
c-------------------------------------------------------------------------

                 blkndx = block
                  call set_block_busy_flag(result, k, blkndx, 1)

                 call blkmgr_insert_block_in_list(
     *                     array_table(c_block_list,result), dummy,
     *                     blkndx, c_block_list_ptr, .false.) 
               endif  

c-------------------------------------------------------------------------
c   Set the block_computed_flag so the data will be preserved until 
c   a delete occurs.
c-------------------------------------------------------------------------

               call set_block_computed_flag(result, k, blkndx, 1)
               call set_block_created_flag(result,k, blkndx, 1)

c---------------------------------------------------------------------------
c   Store the blkndx in the block_map_table entry.
c---------------------------------------------------------------------------

               block_map_table(c_bmap_blkndx,iblock_map+k-1) = 
     *                              blkndx

c---------------------------------------------------------------------------
c   Clear the block.  Only the actual extent of the block's data is zeroed.
c---------------------------------------------------------------------------

               stack = array_table(c_array_stack,result)
               call clear_block(result, k, stack, blkndx, size)
            endif
  200    enddo 

c---------------------------------------------------------------------------

c   Set the create flag in the array_table entry.
c---------------------------------------------------------------------------

         array_table(c_create_flag, result) = 1

c----------------------------------------------------------------------------
c   Restore the saved segment values.
c----------------------------------------------------------------------------

         do k = 1, nindex
            index_table(c_current_seg, ind(k)) = segsave(k)
            array_table(c_index_array1+k-1,result) = ind_input(k)
         enddo
    
c---------------------------------------------------------------------------
c   Add the create data to the checkpoint data common block.
c---------------------------------------------------------------------------

         if (.not. restart_job) then
            do i = 1, nactive_create_table
               if (active_create_table(i) .eq. result .and.
     *          active_create_op(i) .eq. current_op) go to 300
            enddo

            nactive_create_table   = nactive_create_table + 1
            active_create_table(nactive_create_table) = result
            active_create_op(nactive_create_table)    = current_op
         endif
  300    continue

         return
      endif

c---------------------------------------------------------------------------
c   Delete operation.  Delete the blocks of a distributed array.
c---------------------------------------------------------------------------

      if (opcode .eq. delete_op) then
         if (result_type .ne. distributed_array) then
            print *,'Error: Delete operation called for array ',
     *               result,'.  Array is not distributed.'
            call abort_job()
         endif

c         call scrub_blocks(.false., array_table, narray_table, 
c     *                     index_table, nindex_table, 
c     *                     block_map_table, ierr)

         nb = array_table(c_numblks, result)
         iblock_map = array_table(c_block_map, result)
         do k = 1, nb
c            iblock = get_block_number(result, k)
            iblock = block_map_table(c_bmap_blkndx,iblock_map+k-1)
            if (iblock .gt. 0) then

c---------------------------------------------------------------------------
c   Check the block request to determine if there is an outstanding
c   GET or PUT still going on.
c---------------------------------------------------------------------------

               request = get_block_request(result, k, iblock)
               if (request .ne. MPI_REQUEST_NULL) 
     *            call wait_on_block(result, k, iblock,
     *                result_type, 
     *                request, instruction_timer, comm_timer)

               call clear_block_created_flag(result, k, iblock)
               call_marker = 20202
               call free_block(result, k, iblock, array_table,
     *                    narray_table, index_table, nindex_table,
     *                    block_map_table)
            endif   
         enddo 

c---------------------------------------------------------------------------
c   Clear the create flag in the array_table entry.
c---------------------------------------------------------------------------

         array_table(c_create_flag, result) = 0

c---------------------------------------------------------------------------
c   Remove the last create data for this array from the checkpoint_data 
c   common block.
c---------------------------------------------------------------------------

         do i = nactive_create_table, 1, -1
            if (active_create_table(i) .eq. result) then

c--------------------------------------------------------------------------
c   Shift remaining table data over this entry.
c--------------------------------------------------------------------------

               do j = i+1, nactive_create_table
                  active_create_table(j-1) = active_create_table(j)
                  active_create_op(j-1)    = active_create_op(j)
               enddo

               nactive_create_table = nactive_create_table - 1
               return
            endif
         enddo

         return
      endif   ! delete_op

c--------------------------------------------------------------------------
c   allocate_op: Allocate the (non-wildcard) blocks of a local array.
c--------------------------------------------------------------------------

      if (opcode .eq. allocate_op) then
         call allocate_instruction(array_table, narray_table,
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op)
         return
      endif

c--------------------------------------------------------------------------
c   deallocate_op: Deallocate the (non-wildcard) blocks of a local array.
c--------------------------------------------------------------------------

      if (opcode .eq. deallocate_op) then
         call deallocate_instruction(array_table, narray_table,
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      block_map_table, op, 
     *                      comm_timer, instruction_timer)
         return
      endif

c--------------------------------------------------------------------------
c   get_op: Fetch a block of a distributed array into a static copy.
c--------------------------------------------------------------------------

      if (opcode .eq. get_op) then
         call fetch_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, direct_flag)
         return
      endif

c---------------------------------------------------------------------------
c   request_op: Request a block of a "served" array.
c---------------------------------------------------------------------------

      if (opcode .eq. request_op) then
         call request_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer, 
     *                      direct_flag)

#ifdef BLUEGENE
         call get_prefetch_flag(prefetch_flag)
         if (prefetch_flag) then
            call pre_request_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer,
     *                      direct_flag)
         endif
#endif
         return
      endif

c----------------------------------------------------------------------------
c   Partial request (prequest).
c----------------------------------------------------------------------------

      if (opcode .eq. prequest_op) then
         call prequest_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer,
     *                      direct_flag)
         return
      endif

c----------------------------------------------------------------------------
c   prepare_op: Sends a static block of a "served" array to a server.
c----------------------------------------------------------------------------

      if (opcode .eq. prepare_op .or.
     *    opcode .eq. prepare_increment_op) then
         call prepare_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer)
         return
      endif

c----------------------------------------------------------------------------
c   Destroy: Frees blocks of a served array on the server side, allows reuse
c            of the array's disk space for other blocks.
c----------------------------------------------------------------------------

      if (opcode .eq. destroy_op) then
         call destroy_instruction(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer)
         return
      endif

c----------------------------------------------------------------------------
c   compute_integrals_op: Compute a block of integrals locally.
c----------------------------------------------------------------------------

      if (opcode .eq. compute_integrals_op) then
         call local_integral_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, direct_flag)
         return
      endif

      if (result_type .eq. static_array .or.
     *    result_type .eq. scalar_value) then
         
c--------------------------------------------------------------------------
c   The result array is "static".  Do not look for a block
c   since it is not managed by blkmgr.
c--------------------------------------------------------------------------
 
         block = -1
         go to 1000
      endif

c--------------------------------------------------------------------------
c    Must we do the computation of the result block?
c--------------------------------------------------------------------------

      if (block .le. 0) then

c----------------------------------------------------------------------------
c   Block is not present.  Create a new block on the fly.
c----------------------------------------------------------------------------

         call create_current_block(result,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op, 
     *                 .true., .true., block, ierr)
         create_block = .true.
         if (ierr .le. 0) then
            print *,'Error in compute_block: Cannot create block for ',
     *            'array ',result
            call dump_block_ids()
            call abort_job()
         else
            blkndx = ierr
         endif
      endif

c---------------------------------------------------------------------------
c   Compute the block if one or more of the operands has been updated.
c---------------------------------------------------------------------------

 1000    continue
         op1    = op(c_op1_array)
         op2    = op(c_op2_array)
         op1_type = array_table(c_array_type,op1)
         op2_type = array_table(c_array_type,op2)

c---------------------------------------------------------------------------
c   Unpack the array_table data for the operands.
c---------------------------------------------------------------------------

         if (debug) print *,'op1, op2 = ',op1,op2
         if (op1_type .eq. static_array .or.
     *       op1_type .eq. scalar_value) then
            op1_block = -1 
            flag1     = 0
         else
            op1_block = find_current_block(op1, array_table(1,op1),
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           block_map_table, op1_blkndx)
            if (op1_block .le. 0) then
               print *,'Task ',me,' Error: line ',current_line,
     *                 ' op1 array = ',
     *                op1,' block = ',op1_block
               print *,'Cannot compute result unless blocks exist.'
               print *,'optable entry: ',(op(j),j=1,loptable_entry)
               print *,'Array table entry for ',op1,' is ',
     *           (array_table(j,op1),j=1,larray_table_entry)
               call dump_array_list(op1, array_table, narray_table,
     *              'DUMP OF ARRAY BLOCKS LIST: ')
               call array_block_summary(array_table, narray_table)
               print *,'Current indices:'
               do i = 1, nindex_table
                  print *,'   index ',i,' current segment ',
     *              index_table(c_current_seg,i)
               enddo
               call dump_block_ids()
               call abort_job()
            endif

            call get_block_computed_flag(op1, op1_block, op1_blkndx,
     *                                   flag1)

c--------------------------------------------------------------------------
c   Check for possible block communication in progress, wait if necessary.
c--------------------------------------------------------------------------

            request = get_block_request(op1, op1_block, op1_blkndx)
            if (request .ne. mpi_request_null) 
     *          call wait_on_block(op1, op1_block, op1_blkndx,
     *              op1_type, request,
     *             instruction_timer, comm_timer)
         endif
         if (debug) print *,'op1_block,flag1 = ',op1_block, flag1
        
         if (op2_type .eq. static_array .or.
     *       op2_type .eq. scalar_value .or.
     *       opcode .eq. assignment_op) then
            op2_block = -1
            flag2     = 0
         else
            op2_block = find_current_block(op2, array_table(1,op2),
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           block_map_table, op2_blkndx)
            if (op2_block .le. 0) then
               print *,'Error: op2 array = ',op2,' block = ',op2_block
               print *,'Cannot compute result unless both blocks exist.'
               print *,'optable entry: ',(op(j),j=1,loptable_entry)
               call array_block_summary(array_table, narray_table)
               print *,'Current indices:'
               do i = 1, nindex_table
                  print *,'   index ',i,' current segment ',
     *              index_table(c_current_seg,i)
               enddo
               call dump_block_ids()
               call abort_job()
            endif

            call get_block_computed_flag(op2, op2_block, op2_blkndx,
     *                                    flag2)

c--------------------------------------------------------------------------
c   Check for possible block communication in progress, wait if necessary.
c--------------------------------------------------------------------------

            request = get_block_request(op2, op2_block, op2_blkndx)
            if (request .ne. mpi_request_null) 
     *          call wait_on_block(op2, op2_block, op2_blkndx,
     *             op2_type, request,
     *             instruction_timer, comm_timer)
         endif

         if (debug) print *,'op2_block,flag2 = ',op2_block, flag2

c-----------------------------------------------------------------------
c   If neither of the operands were computed on this pass, there is no
c   need to compute the block. 
c-----------------------------------------------------------------------

         if (.not. create_block) then
            if (flag1 .eq. 0 .and. flag2 .eq. 0) then

c--------------------------------------------------------------------------
c   Check for a scalar-scalar --> scalar operation
c--------------------------------------------------------------------------

               if (result_type .eq. scalar_value .and.
     *             array_table(c_array_type,op1) .eq. scalar_value .and.
     *             array_table(c_array_type,op2) .eq. scalar_value) then
                  call handle_sss_op(op, array_table, narray_table,
     *                      scalar_table, nscalar_table)
                  return
               else if (result_type .eq. scalar_value .and.
     *                  array_table(c_array_type,op1) .eq. 
     *                                       scalar_value .and.
     *                  opcode .eq. assignment_op) then
                  call handle_sss_op(op, array_table, narray_table,
     *                      scalar_table, nscalar_table)
                  return
               endif
            endif
         endif

         if (opcode .eq. contraction_op) then

c---------------------------------------------------------------------------
c   Contraction.
c---------------------------------------------------------------------------

            ncind = 0
            do i = 1, mx_array_index
               cind(i) = op(c_ind1+i-1)
               if (cind(i) .ne. 0) ncind = ncind + 1
            enddo
       
c            print *,'Contraction: ',(op(k),k=1,loptable_entry) 
            call contract_blocks(op1, op1_block, op1_blkndx,
     *                           op2, op2_block, op2_blkndx,
     *                           result, block, blkndx, cind, ncind,
     *                           array_table, narray_table,
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           scalar_table, nscalar_table,
     *                           address_table, block_map_table,
     *                           flopcount)
         else if (opcode .eq. tensor_op) then
            call tensor_contraction(op1, op1_block, op1_blkndx,
     *                           op2, op2_block, op2_blkndx,
     *                           result, block, blkndx,
     *                           array_table, narray_table,
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           scalar_table, nscalar_table,
     *                           address_table, flopcount)
         else if (opcode .eq. sum_op .or.
     *            opcode .eq. subtract_op) then

c---------------------------------------------------------------------------
c   Summation.
c---------------------------------------------------------------------------

            call sum_blocks(op1, op1_block, op1_blkndx,
     *                      op2, op2_block, op2_blkndx,
     *                      result, block, blkndx, opcode, array_table,
     *                      narray_table, index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
         else if (opcode .eq. assignment_op) then
            call assign_block(op1, op1_block, op1_blkndx, 
     *                      result, block, blkndx,
     *                         array_table,
     *                      narray_table, index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
         else
            print *,'Error: Invalid opcode in compute_block.' 
            print *,'       optable entry is ',
     *                (op(i),i=1,loptable_entry)
            call abort_job()
         endif

c--------------------------------------------------------------------------
c   Set the "block_computed_flag" with the blkmgr.
c--------------------------------------------------------------------------

      if (result_type .ne. scalar_value .and.
     *    result_type .ne. static_array) then
         call get_block_computed_flag(result, block, blkndx,
     *                                result_flag)
         if (result_flag .eq. 0) then
            call get_block_created_flag(result, block, blkndx, 
     *                                  result_flag)
            if (result_flag .eq. 0) then
               call set_opblock(result, block, blkndx, op)
               call set_block_computed_flag(result, block, blkndx, 1)
            endif
         endif
      endif

      return
      end
      
      subroutine check_create_flag(op, array_table, narray_table)
      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
      integer narray_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)

      integer i, ierr
      integer result, result_type
      integer op1, op1_type, op2, op2_type

      if (op(c_opcode) .eq. create_op .or.
     *    op(c_opcode) .eq. reindex_op .or.
     *    (op(c_opcode) .ge. sp_add_op .and. 
     *     op(c_opcode) .le. sp_ldindex_op)) return

      ierr = 0
      result = op(c_result_array)
      if (result .gt. 0) then
         result_type = array_table(c_array_type, result)

         if (result_type .eq. distributed_array) then
            if (array_table(c_create_flag,result) .eq. 0) then
              print *,'Task ',me,
     *              ' Error: Attempt to use a distributed ',
     *              'array before it has been created.'
              print *,'Line ',current_line,' array ',result
              print *,'Operation = ',(op(i),i=1,loptable_entry)
              print *,'Result array = ',result,' has not been created.'
              ierr = 1
            endif
         endif
      endif

      op1 = op(c_op1_array)
      if (op1 .gt. 0) then
         op1_type = array_table(c_array_type,op1)
         if (op1_type .eq. distributed_array) then
            if (array_table(c_create_flag,op1) .eq. 0) then
               print *,'Task ',me,
     *               ' Error: Attempt to use a distributed ',
     *              'array before it has been created.'
               print *,'Line ',current_line,' array ',op1
               print *,'Operation = ',(op(i),i=1,loptable_entry)
               print *,'Operand 1 array = ',op1,' has not been created.'
               ierr = 1
            endif
         endif
      endif

      op2 = op(c_op2_array)
      if (op2 .gt. 0) then
         op2_type = array_table(c_array_type,op2)
         if (op2_type .eq. distributed_array) then
            if (array_table(c_create_flag,op2) .eq. 0) then
               print *,'Task ',me,
     *                 ' Error: Attempt to use a distributed ',
     *              'array before it has been created.'
               print *,'Line ',current_line,' array ',op2
               print *,'Operation = ',(op(i),i=1,loptable_entry)
               print *,'Operand 1 array = ',op2,' has not been created.'
               ierr = 1
            endif
         endif
      endif

      if (ierr .eq. 1) then
         print *,'Error at line number ',current_line
         call c_flush_stdout()
         call abort_job()
      endif 
      
      return
      end

      subroutine array_block_summary(array_table, narray_table)
c-------------------------------------------------------------------------
c   Prints a summary of the blocks in use for each array in the array_table.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer get_block_array_handle

      integer i, j, nblks
      integer ierr

      do i = 1, nblkmgr_stacks
         print *,'Stack ',i,' start block ',stack_start(i),
     *      ' end block ',
     *      stack_start(i)+stack_size(i)-1,' blocksize ',
     *      stack_blocksize(i),' stack pointer ',free_stack_ptr(i)
      enddo

      print *,'ARRAY BLOCK SUMMARY FOR TASK ',me
      print *,'Array    Type     Total blks    Blks in use '
      print *,'-----    -----    ----------    -----------'

      do i = 1, narray_table
         if (array_table(c_array_type,i) .ne. scalar_value) then
            nblks = 0
            do j = 1, blkmgr_blocks
               if (get_block_array_handle(j) .eq. i) 
     *            nblks = nblks + 1
            enddo

            if (nblks .gt. 0) then
               print 100,i,array_table(c_array_type,i),
     *                array_table(c_numblks,i),nblks
            endif
         endif
      enddo

  100 format(i5,6x,i4,6x,i5,5x,i6)

      return
      end      

      subroutine dump_array_list(array, array_table, narray_table,
     *                           msg)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      character*(*) msg
      integer next, i, x, nind, flag
      integer seg(mx_array_index)
      integer blkndx
      integer get_block_array_handle

      next = array_table(c_block_list,array)
      nind = array_table(c_nindex, array)
      print *,msg
      print *,'Blocks for array ',array
  100 continue
      if (next .eq. 0) return
      blkndx = next
      x = get_block_array_handle(blkndx)
      call get_block_segments(blkndx, seg)
      call get_blk_header(flag, blkndx,c_block_flags)
      print 200,x,blkndx,flag, (seg(i),i=1,nind)
  200 format(' array, blkndx ',2i5,' flags ',i8,' segs ',6(i3,1x))
      call get_blk_header(next, blkndx,c_block_list_ptr) 
      go to 100

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C
      SUBROUTINE POLYPRT(COORD,GRAD,HESS,IORDER,NATOMS,IINTFP,IPRINT,
     &                   LCOORD,LENERG,LGRAD,LHESS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     This subroutine creates a file called POLYRATE and writes to it
C     the Cartesian coordinates, energy, gradient, and hessian, which
C     are read from JOBARC. The units are atomic and the order of atoms
C     is computational.
C
C     TO BE UPDATED :
C     It is
C     called from GEOPT at the time that a vibrational analysis is
C     performed. The main limitation is that it probably will not work
C     when dummy atoms are present.
C
CEND
C
      LOGICAL YESNO,LCOORD,LENERG,LGRAD,LHESS
      DIMENSION COORD(3,NATOMS),GRAD(3,NATOMS),HESS(3*NATOMS,3*NATOMS)
      DIMENSION IORDER(NATOMS)
C
C     LCOORD --- Tells whether to read and write Cartesian coordinates
C     LENERG --- Tells whether to read and write energy
C     LGRAD  --- Tells whether to read and write gradient
C     LHESS  --- Tells whether to read and write hessian
C
C     Make sure this routine has got the correct message about what it is
C     supposed to do.
C
      WRITE(6,3000)
 3000 FORMAT(/,' ----- Entering POLYPRT ----- ',/)
      IF(     LCOORD) WRITE(6,3010)
      IF(.NOT.LCOORD) WRITE(6,3020)
      IF(     LENERG) WRITE(6,3030)
      IF(.NOT.LENERG) WRITE(6,3040)
      IF(     LGRAD ) WRITE(6,3050)
      IF(.NOT.LGRAD ) WRITE(6,3060)
      IF(     LHESS ) WRITE(6,3070)
      IF(.NOT.LHESS ) WRITE(6,3080)
 3010 FORMAT('  @POLYPRT-I, Coordinates will be written. ')
 3020 FORMAT('  @POLYPRT-I, Coordinates will not be written. ')
 3030 FORMAT('  @POLYPRT-I, Energy      will be written. ')
 3040 FORMAT('  @POLYPRT-I, Energy      will not be written. ')
 3050 FORMAT('  @POLYPRT-I, Gradient    will be written. ')
 3060 FORMAT('  @POLYPRT-I, Gradient    will not be written. ')
 3070 FORMAT('  @POLYPRT-I, Hessian     will be written. ')
 3080 FORMAT('  @POLYPRT-I, Hessian     will not be written. ')
C
      IF(LCOORD)THEN
        CALL DGETREC(20,'JOBARC','COORD'   ,3*NATOMS,COORD)
      ENDIF
C
      IF(LENERG)THEN
        CALL DGETREC(20,'JOBARC','TOTENERG',1,ENRG)
      ENDIF
C
      IF(LGRAD)THEN
        CALL DGETREC(20,'JOBARC','GRADIENT',3*NATOMS,GRAD)
      ENDIF
C
      IF(LHESS)THEN
        CALL DGETREC(20,'JOBARC','HESSIANM',9*NATOMS*NATOMS,HESS)
      ENDIF
C
      CALL IGETREC(20,'JOBARC','MAP2ZMAT',NATOMS,IORDER)
C
      IF(IPRINT.GE.1)THEN
C
      WRITE(6,1000)
 1000 FORMAT(/,' Data to be written to POLYRATE file ')
C
      IF(LCOORD)THEN
C
      WRITE(6,1010)
 1010 FORMAT(/,' Cartesian Coordinates ',/)
C
      DO 10 J=1,NATOMS
      WRITE(6,1020) (COORD(I,IORDER(J)),I=1,3)
   10 CONTINUE
 1020 FORMAT(10X,3F20.10)
C
       ENDIF
C
      IF(LENERG)THEN
C
      WRITE(6,1030)
 1030 FORMAT(/,' Total energy ',/)
C
      WRITE(6,1040) ENRG
 1040 FORMAT(F20.12)
C
      ENDIF
C
      IF(LGRAD)THEN
C
      WRITE(6,1050)
 1050 FORMAT(/,' Molecular Gradient (x,y,z for each atom) ',/)
C
      DO 20 J=1,NATOMS
      WRITE(6,1060) (GRAD(I,J),I=1,3)
   20 CONTINUE
 1060 FORMAT(10X,3F20.10)
C
      ENDIF
C
      IF(LHESS)THEN
C
      WRITE(6,1070)
 1070 FORMAT(/,' Molecular Hessian ',/)
C
      DO 40 JOFF=0,3*NATOMS-3,3
      DO 30 I   =1,3*NATOMS
      WRITE(6,1060) (HESS(I,JOFF + J),J=1,3)
   30 CONTINUE
      WRITE(6,1080)
   40 CONTINUE
 1080 FORMAT(/)
C
      ENDIF
C
      ENDIF
C
C     Get the lowest available unit number.
C
      IUNIT=0
      DO 100 I=1,99
C
      IF(IUNIT.EQ.0)THEN
        INQUIRE(UNIT=I,OPENED=YESNO)
          IF(.NOT.YESNO)THEN
            IUNIT = I
            WRITE(6,2000) IUNIT
          ENDIF
      ENDIF
  100 CONTINUE
C
      IF(IUNIT.EQ.0)THEN
      WRITE(6,2010)
      CALL ERREX
      ENDIF
C
C     If POLYRATE already exists, remove it.
C
      INQUIRE(FILE='POLYRATE',EXIST=YESNO)
      IF(YESNO)THEN
      OPEN(UNIT=IUNIT,FILE='POLYRATE',STATUS='OLD',ACCESS='SEQUENTIAL',
     &     FORM='FORMATTED')
      CLOSE(UNIT=IUNIT,STATUS='DELETE')
      ENDIF 
C
C     Create fresh POLYRATE file for current coordinates, energy,
C     gradient, and hessian.
C
      OPEN(UNIT=IUNIT,FILE='POLYRATE',STATUS='NEW',ACCESS='SEQUENTIAL',
     &     FORM='FORMATTED')
C
      WRITE(IUNIT,1080)
C
      IF(LCOORD)THEN
C
      DO 110 J=1,NATOMS
      WRITE(IUNIT,1020) (COORD(I,IORDER(J)),I=1,3)
  110 CONTINUE
C
      WRITE(IUNIT,1080)
C
      ENDIF
C
      IF(LENERG)THEN
C
      WRITE(IUNIT,1040) ENRG
      WRITE(IUNIT,1080)
C
      ENDIF
C
      IF(LGRAD)THEN
C
      DO 120 J=1,NATOMS
      WRITE(IUNIT,1020) (GRAD(I,J),I=1,3)
  120 CONTINUE
C
      WRITE(IUNIT,1080)
C
      ENDIF
C
      IF(LHESS)THEN
C
      DO 140 JOFF=0,3*NATOMS-3,3
      DO 130 I   =1,3*NATOMS
      WRITE(IUNIT,1020) (HESS(I,JOFF + J),J=1,3)
  130 CONTINUE
      WRITE(IUNIT,1080)
  140 CONTINUE
C
      ENDIF
C
      CLOSE(UNIT=IUNIT,STATUS='KEEP')
C
      RETURN
 2000 FORMAT(/,
     & ' @POLYPRT-I, Unit ',I3,' will be used for POLYRATE file. ',/)
 2010 FORMAT(/,' @POLYPRT-F, No available unit for POLYRATE ! ')
      END

C     mkc2z1 -- First step in producing the transformation from the
C     computational basis to the "nice" ZMAT-ordered basis
C
C DESCRIPTION
C     Transforms EVEC from the VMol AO basis (not SO basis!) to the
C     "ZMAT" order preferred for symmetry analysis.  Primarily, this
C     means changing the order of the atoms.  Also produces reordered
C     versions of CENTERBF and ANGMOMBF on the JOBARC.
C
C NOTES
C     Some blocks of comments in the code have been marked with "C--"
C     before and after them.  These were the original comments put in
C     by the author.  Other comments have been added in an attempt to
C     understand what the heck is going on in this routine!

      SUBROUTINE MkC2Z1(EVEC,SCR,LSCR,NBASCN,COORD,IMEMCMP,IPOPCMP,
     &                  IANGCMP,IMAP,IDummy,NBAS,NATOMS,ICheck,NAO)

      Integer NAO, LScr, NBas, NAtoms
      Double precision EVEC(NAO,NBAS), SCR(LSCR,LSCR), Coord(3,NAtoms)
      Integer NBASCN(NATOMS),IMEMCMP(NAO),IPOPCMP(NATOMS),
     $   IMAP(NATOMS),IANGCMP(NAO), IDUMMY(NAO)
      Integer ICheck(NAO)
C     LSCR should be Max(NAO, NBas, 3, NAtoms)

      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      Integer I, IOne, IThr, IOrdGp, NOrbit
      CHARACTER*4 CMPPGP

#ifdef _TRACE_VMOL2JA
      write(*,*) '@VMOL2JA: Entered ', __FILE__
#endif /* _TRACE_VMOL2JA */

      IONE=1
      ITHR=3*IINTFP
C
C--
C PICK UP SOME INFORMATION FROM THE JOBARC FILE
C--
C
      CALL GETREC(-1,'JOBARC','COMPNORB',IONE,NORBIT)
      CALL GetREC(20,'JOBARC','MAP2ZMAT',NATOMS,IMAP)
      Call GetRec(20,'JOBARC','CENTERBF',NAO,IDummy)
C
C     Renumber the centers from VMol to ZMAT arrangement
C
      Do 10 I = 1, NAO
         IDummy(i) = IMap( IDummy(i) )
 10   Continue
C
C     John's preferred ordering
C
      Call JFSOrd(NAtoms, NAO, IDummy, ICheck)

C     Reorder CENTERBF, already in core.
      Call ISctr(NAO,IDummy,ICheck,IAngCmp)
#ifdef _DEBUG_V2JA
      write(*,*) '@MKC2Z1: Recording CNTERBF0 as '
      write(*,*) '         ', (IAngCmp(i), i=1,NAO)
#endif /* _DEBUG_V2JA */
      Call PutRec(20,'JOBARC','CNTERBF0',NAO,IAngCmp)

C     Reorder ANGMOMBF
      Call GetRec(20,'JOBARC','ANGMOMBF',NAO,IDummy)
      Call ISctr(NAO,IDummy,ICheck,IAngCmp)
#ifdef _DEBUG_V2JA
      write(*,*) '@MKC2Z1: Recording ANMOMBF0 as '
      write(*,*) '         ', (IAngCmp(i), i=1,NAO)
#endif /* _DEBUG_V2JA */
      Call PutRec(20,'JOBARC','ANMOMBF0',NAO,IAngCmp)

cSSS      Call GetRec( 20, 'JOBARC', 'CNTERBF0', NAO, IDummy)
cSSS      Call NewPD (NAO, IDummy, IAngCmp, IMemCmp, I)
cSSS      Write (6, 9000) 'NEWPD', (i, IMemCmp(i), i = 1, NAO)
C
C     Reorder the transformation; written back out by the caller.
C
      Do 100 I = 1, NAO
         Call xCOPY(NBas, Evec(i, 1), NAO, Scr( ICheck(i), 1), NAO)
 100  Continue
      Call xCOPY(NAO*NBas, Scr, 1, Evec, 1)
C
 9000 Format(1X,'new style ', A,':'/(2I5))

#ifdef _TRACE_VMOL2JA
      write(*,*) '@VMOL2JA: Leaving ', __FILE__
#endif /* _TRACE_VMOL2JA */

      RETURN 
      END

C     mkc2z1 -- First step in producing the transformation from the
C     computational basis to the "nice" ZMAT-ordered basis
C
C DESCRIPTION
C     Transforms EVEC from the VMol AO basis (not SO basis!) to the
C     "ZMAT" order preferred for symmetry analysis.  Primarily, this
C     means changing the order of the atoms.  Also produces reordered
C     versions of CENTERBF and ANGMOMBF on the JOBARC.
C
C NOTES
C     Some blocks of comments in the code have been marked with "C--"
C     before and after them.  These were the original comments put in
C     by the author.  Other comments have been added in an attempt to
C     understand what the heck is going on in this routine!

      SUBROUTINE MkC2Z1(EVEC,SCR,LSCR,NBASCN,COORD,IMEMCMP,IPOPCMP,
     &                  IANGCMP,IMAP,IDummy,NBAS,NATOMS,ICheck,NAO)

      Integer NAO, LScr, NBas, NAtoms
      Double precision EVEC(NAO,NBAS), SCR(LSCR,LSCR), Coord(3,NAtoms)
      Integer NBASCN(NATOMS),IMEMCMP(NAO),IPOPCMP(NATOMS),
     $   IMAP(NATOMS),IANGCMP(NAO), IDUMMY(NAO)
      Integer ICheck(NAO)
C     LSCR should be Max(NAO, NBas, 3, NAtoms)

      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      Integer I, IOne, IThr, IOrdGp, NOrbit
      CHARACTER*4 CMPPGP





      IONE=1
      ITHR=3*IINTFP
C
C--
C PICK UP SOME INFORMATION FROM THE JOBARC FILE
C--
C
      CALL GETREC(-1,'JOBARC','COMPNORB',IONE,NORBIT)
      CALL GetREC(20,'JOBARC','MAP2ZMAT',NATOMS,IMAP)
      Call GetRec(20,'JOBARC','CENTERBF',NAO,IDummy)
C
C     Renumber the centers from VMol to ZMAT arrangement
C
      Do 10 I = 1, NAO
         IDummy(i) = IMap( IDummy(i) )
 10   Continue
C
C     John's preferred ordering
C
      Call JFSOrd(NAtoms, NAO, IDummy, ICheck)

C     Reorder CENTERBF, already in core.
      Call ISctr(NAO,IDummy,ICheck,IAngCmp)




      Call PutRec(20,'JOBARC','CNTERBF0',NAO,IAngCmp)

C     Reorder ANGMOMBF
      Call GetRec(20,'JOBARC','ANGMOMBF',NAO,IDummy)
      Call ISctr(NAO,IDummy,ICheck,IAngCmp)




      Call PutRec(20,'JOBARC','ANMOMBF0',NAO,IAngCmp)

cSSS      Call GetRec( 20, 'JOBARC', 'CNTERBF0', NAO, IDummy)
cSSS      Call NewPD (NAO, IDummy, IAngCmp, IMemCmp, I)
cSSS      Write (6, 9000) 'NEWPD', (i, IMemCmp(i), i = 1, NAO)
C
C     Reorder the transformation; written back out by the caller.
C
      Do 100 I = 1, NAO
         Call xCOPY(NBas, Evec(i, 1), NAO, Scr( ICheck(i), 1), NAO)
 100  Continue
      Call xCOPY(NAO*NBas, Scr, 1, Evec, 1)
C
 9000 Format(1X,'new style ', A,':'/(2I5))





      RETURN 
      END

c This routine returns .TRUE. if the two strings are lexically equal.
c WARNING: Since Fortran pads the end of all strings with spaces,
c be sure to pass only the relevant substring.

      logical function leq(s1,s2)
      implicit none

      character*(*) s1, s2

      integer length, fortran_strncasecmp

      length = len(s1)
      if (length.ne.len(s2)) then
         leq = .false.
      else
         leq = (fortran_strncasecmp(s1,s2,length).eq.0)
      end if

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_fock(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table, 
     *                      address_table, op)
      implicit none
      include 'int_gen_parms.h'
      include 'interpreter.h'
      include 'mpif.h'
      include 'proto_events.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer*8 address_table(narray_table)

      integer*8 addr, ixeps, get_index_from_base
      integer fock, i, j, n, ind
      integer ierr
      integer master, pst_get_master
      integer status(MPI_STATUS_SIZE)
      double precision xxx(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, xxx)
#else
      common xxx
      equivalence (ibuf, xxx)
#endif

c      include 'int_gen_parms.h'

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif
c-------------------------------------------------------------------------
c   Locate array address in array_table.
c-------------------------------------------------------------------------

      fock    = op(c_result_array)
      addr = address_table(fock)
      ixeps  = get_index_from_base(addr, xxx, 2)

c--------------------------------------------------------------------------
c   Determine size of epsilon array.
c--------------------------------------------------------------------------

      ind = array_table(c_index_array1,fock)
      n   = index_table(c_index_size,ind)
      master = pst_get_master()

      do i = 1, n*n
         xxx(ixeps+i-1) = 0.
      enddo

c--------------------------------------------------------------------------
c   Non-ROHF case: FOCK data is initialized by forming a 2D matrix whose
c   diagonal elements are the SCF eigenvalues.
c--------------------------------------------------------------------------

         if (index_table(c_index_type,ind) .eq. moaindex) then
            do i = 1, n
               j = (i-1)*n+i    ! diagonal element of the ith column
               xxx(ixeps+j-1) = epsilon(i)
            enddo
         else if (index_table(c_index_type,ind) .eq. mobindex) then
            do i = 1, n
               j = (i-1)*n+i    ! diagonal element of the ith column
               xxx(ixeps+j-1) = epsilonb(i)
            enddo
         else
            print *,'Error: Invalid index type for FOCK matrix'
            print *,'Index = ',ind,' index_type = ',
     *       index_table(c_index_type,ind)
            call abort_job()
         endif

      return
      end


      subroutine apply_erd_fockorder(fock, n, erd_ind,scale)
c---------------------------------------------------------------------------
c   Reorders the C array column by column into an order compatible with
c   integrals produced by the ERD integral package.
c---------------------------------------------------------------------------
      implicit none
      integer n, erd_ind(n)
      double precision fock(n,n)
      double precision temp(n,n)
      double precision scale(n)

      integer i, j

      do j = 1, n
         do i = 1, n
            temp(i,j) = fock(erd_ind(i),erd_ind(j))
     *                  /scale(erd_ind(i))/scale(erd_ind(j))   
         enddo
      enddo

      do j = 1, n
         do i = 1, n
            fock(i,j) = temp(i,j)  
         enddo
      enddo

      return
      end

         SUBROUTINE  ERD__K12_INT2D_TO_AB00
     +
     +                    ( SHELLA,SHELLB,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZA,NXYZB,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_INT2D_TO_AB00
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative eris:
C
C                  [AB|00],[A0|B0],[A0|0B],[0A|B0],[0A|0B] or [00|AB]
C
C                adding up the contributions from all the respective
C                derivative 2D integrals:
C
C                        AB00,A0B0,A00B,0AB0,0A0B or 00AB
C
C                Simplified version of the general ABCD routine to
C                reduce loop overheads for those cases where there are
C                at least two s-shells. For comments and details see
C                the general ABCD routine.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x = A and B
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZx       =  # of cartesian monomials for
C                                   x = A and B shells
C                    INT2Dx      =  all current 2D AB00/A0B0/A00B/0AB0/
C                                   0A0B/00AB derivative integrals for
C                                   each cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D AB00/A0B0/A00B/0AB0/0A0B/00AB
C                                   derivative integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [AB|00]/[A0|B0]/[A0|0B]/[0A|B0]/
C                                   [0A|0B]/[00|AB] derivative
C                                   integrals corresponding to all
C                                   current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,J,M,N,R
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB
         INTEGER     XA,YA,ZA,XB,YB,ZB
         INTEGER     XAP,XBP
         INTEGER     YAMAX,YBMAX

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO,STGEXP

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ),RTS(1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ),UVAL(1:NEXQ)

         DOUBLE PRECISION  BATCH  (1:NEXQ,1:NXYZA,1:NXYZB)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLA,0:SHELLB)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XBP = 0
         DO 100  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 102 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 110 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 112 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M)
                         END DO
                     ELSE
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M) * INT2DY (M,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = TEMP2 (M)*
     &                          (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
                         END DO
                     ELSE
                         DO M = 1,NEXQ
                           BATCH (M,I,J) = TEMP2 (M) * INT2DZ (M,ZA,ZB)*
     &                          (2.d0*UVAL(M)/STGEXP)*(1.d0-RTS(M))
                         END DO
                     END IF

  112             CONTINUE
  110          CONTINUE
               XAP = I
  102       CONTINUE
            XBP = J
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XBP = 0
         DO 200  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 202 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 210 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 212 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                  + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 2
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 2
                         END DO
                     END IF

  212             CONTINUE
  210          CONTINUE
               XAP = I
  202       CONTINUE
            XBP = J
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XBP = 0
         DO 300  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 302 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 310 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 312 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                   + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                   + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                      )*(2.d0*UVAL(M)/STGEXP) 
                            R = R + 3
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 3
                         END DO
                     END IF

  312             CONTINUE
  310          CONTINUE
               XAP = I
  302       CONTINUE
            XBP = J
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XBP = 0
         DO 400  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 402 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 410 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 412 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                    + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                    + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                    + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 4
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA,ZB)*(1.d0-RTS(R+3))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 4
                         END DO
                     END IF

  412             CONTINUE
  410          CONTINUE
               XAP = I
  402       CONTINUE
            XBP = J
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XBP = 0
         DO 500  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 502 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 510 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 512 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                  + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                  + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                  + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                  + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 5
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA,ZB)*(1.d0-RTS(R+3))
     +                                      + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA,ZB)*(1.d0-RTS(R+4))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 5
                         END DO
                     END IF

  512             CONTINUE
  510          CONTINUE
               XAP = I
  502       CONTINUE
            XBP = J
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XBP = 0
         DO 600  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 602 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 610 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 612 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                  + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                  + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                  + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                  + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                  + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                      )*(2.d0*UVAL(M)/STGEXP) 
                            R = R + 6
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA,ZB)*(1.d0-RTS(R+3))
     +                                      + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA,ZB)*(1.d0-RTS(R+4))
     +                                      + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA,ZB)*(1.d0-RTS(R+5))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 6
                         END DO
                     END IF

  612             CONTINUE
  610          CONTINUE
               XAP = I
  602       CONTINUE
            XBP = J
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XBP = 0
         DO 700  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 702 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 710 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 712 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                  + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                  + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                  + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                  + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                  + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                  + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 7
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA,ZB)*(1.d0-RTS(R+3))
     +                                      + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA,ZB)*(1.d0-RTS(R+4))
     +                                      + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA,ZB)*(1.d0-RTS(R+5))
     +                                      + TEMP2 (R+6)
     +                              * INT2DZ (R+6,ZA,ZB)*(1.d0-RTS(R+6))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 7
                         END DO
                     END IF

  712             CONTINUE
  710          CONTINUE
               XAP = I
  702       CONTINUE
            XBP = J
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XBP = 0
         DO 800  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 802 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 810 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 812 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                  + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                  + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                  + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                  + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                  + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                  + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                  + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 8
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA,ZB)*(1.d0-RTS(R+3))
     +                                      + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA,ZB)*(1.d0-RTS(R+4))
     +                                      + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA,ZB)*(1.d0-RTS(R+5))
     +                                      + TEMP2 (R+6)
     +                              * INT2DZ (R+6,ZA,ZB)*(1.d0-RTS(R+6))
     +                                      + TEMP2 (R+7)
     +                              * INT2DZ (R+7,ZA,ZB)*(1.d0-RTS(R+7))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 8
                         END DO
                     END IF

  812             CONTINUE
  810          CONTINUE
               XAP = I
  802       CONTINUE
            XBP = J
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XBP = 0
         DO 900  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 902 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO

               J = XBP
               DO 910 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 912 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF

                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)*(1.d0-RTS(R))
     +                                  + TEMP2 (R+1)*(1.d0-RTS(R+1))
     +                                  + TEMP2 (R+2)*(1.d0-RTS(R+2))
     +                                  + TEMP2 (R+3)*(1.d0-RTS(R+3))
     +                                  + TEMP2 (R+4)*(1.d0-RTS(R+4))
     +                                  + TEMP2 (R+5)*(1.d0-RTS(R+5))
     +                                  + TEMP2 (R+6)*(1.d0-RTS(R+6))
     +                                  + TEMP2 (R+7)*(1.d0-RTS(R+7))
     +                                  + TEMP2 (R+8)*(1.d0-RTS(R+8))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 9
                         END DO
                     ELSE
                         R = 1
                         DO M = 1,NEXQ
                            BATCH (M,I,J) = ( TEMP2 (R)
     +                                  * INT2DZ (R,ZA,ZB)*(1.d0-RTS(R))
     +                                      + TEMP2 (R+1)
     +                              * INT2DZ (R+1,ZA,ZB)*(1.d0-RTS(R+1))
     +                                      + TEMP2 (R+2)
     +                              * INT2DZ (R+2,ZA,ZB)*(1.d0-RTS(R+2))
     +                                      + TEMP2 (R+3)
     +                              * INT2DZ (R+3,ZA,ZB)*(1.d0-RTS(R+3))
     +                                      + TEMP2 (R+4)
     +                              * INT2DZ (R+4,ZA,ZB)*(1.d0-RTS(R+4))
     +                                      + TEMP2 (R+5)
     +                              * INT2DZ (R+5,ZA,ZB)*(1.d0-RTS(R+5))
     +                                      + TEMP2 (R+6)
     +                              * INT2DZ (R+6,ZA,ZB)*(1.d0-RTS(R+6))
     +                                      + TEMP2 (R+7)
     +                              * INT2DZ (R+7,ZA,ZB)*(1.d0-RTS(R+7))
     +                                      + TEMP2 (R+8)
     +                              * INT2DZ (R+8,ZA,ZB)*(1.d0-RTS(R+8))
     +                                      )*(2.d0*UVAL(M)/STGEXP)
                            R = R + 9
                         END DO
                     END IF

  912             CONTINUE
  910          CONTINUE
               XAP = I
  902       CONTINUE
            XBP = J
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x-pairs. No skipping of
C                x,x-contribution of 0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XBP = 0
         DO 1000  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 1002 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB)
               END DO
C
C
C             ...inner loops over y,y-pairs. Skip the multiplication
C                of y,y-contributions, if no y-coordinate derivative
C                was formed and we have a 0,0-pair, as then the 2DY
C                integrals are equal to 1.
C
C
               J = XBP
               DO 1010 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 1012 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YA,YB)
                         END DO
                     END IF
C
C
C             ...skip multiplication of z,z-contributions, if we
C                have a 0,0-pair and no derivations were performed
C                on the z-coordinate, as then the 2DZ integrals
C                are equal to 1. All info concerning all three x,x-,
C                y,y- and z,z-pairs have been collected for all
C                exponent quadruplets at once. Sum up the 2D X,Y,Z
C                integral products to the appropriate places of the
C                batch.
C
C
                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         R = 0
                         DO M = 1,NEXQ
                            SUM = ZERO
                            DO N = 1,NGQP
                               SUM = SUM + TEMP2 (R+N)*(1.d0-RTS(R+N))
                            END DO
                            R = R + NGQP
                            BATCH (M,I,J) = SUM*(2.d0*UVAL(M)/STGEXP)
                         END DO
                     ELSE
                         R = 0
                         DO M = 1,NEXQ
                            SUM = ZERO
                            DO N = 1,NGQP
                               SUM = SUM + TEMP2 (R+N)
     +                            * INT2DZ (R+N,ZA,ZB)*(1.d0-RTS(R+N))
                            END DO
                            R = R + NGQP
                            BATCH (M,I,J) = SUM*(2.d0*UVAL(M)/STGEXP)
                         END DO
                     END IF
C
C
C             ...next z,z-pair and y,y-pair.
C
C
 1012             CONTINUE
 1010          CONTINUE
C
C
C             ...next x,x-pair.
C
C
               XAP = I
 1002       CONTINUE
            XBP = J
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sum_64ss(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c--------------------------------------------------------------------------
c   array1 --> 6D
c   array2 --> 4D
c   The last two indeces of array1 MUST be simple.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index
      integer stack

      integer comm

      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(6), findex(4)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base
      double precision x(1)
      double precision y(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the first array: c_result_array
c---------------------------------------------------------------------------

      array = op(c_result_array)
      nindex = array_table(c_nindex, array)

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         sindex(i) = index
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, sop1(i), sop2(i))
      enddo

      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk1 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk1 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the second array: c_op1_array
c---------------------------------------------------------------------------

      array = op(c_op1_array)
      nindex = array_table(c_nindex, array)

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         findex(i) = index
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, fop1(i), fop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk2 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk2 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c     write(6,*) ' ******************** '
c     write(6,*) ' OP1 :', (sindex(i), i=1,4)
c     write(6,*) ' OP2 :', (findex(i), i=1,4)

      call dosum_64ss(x(indblk1), sindex,
     *                  sop1(1), sop2(1), sop1(2), sop2(2),
     *                  sop1(3), sop2(3), sop1(4), sop2(4),
     *                  sop1(5), sop2(5), sop1(6), sop2(6),
     *                  x(indblk2), findex,
     *                  fop1(1), fop2(1), fop1(2), fop2(2),
     *                  fop1(3), fop2(3), fop1(4), fop2(4))

      return
      end

      subroutine dosum_64ss(x, sindex, a1, a2, b1, b2, c1, c2, d1, d2,
     *                                 s1, s2, ss1, ss2,
     *                        y, findex, e1, e2, f1, f2, g1, g2, h1, h2)
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer s1, s2, ss1, ss2
      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(6), findex(4)

      integer i, j, k, a, b, c, d
      integer m, n, lda, ldb, ldc

      double precision x(a1:a2,b1:b2,c1:c2,d1:d2,s1:s2,ss1:ss2)
      double precision y(e1:e2,f1:f2,g1:g2,h1:h2), xtemp

      do d = d1, d2
      do c = c1, c2
      do b = b1, b2
      do a = a1, a2

c        xtemp = y(a,b,c,d)
c        do i = s1, s2
c        do j = ss1, ss2

            x(a,b,c,d,s1,ss1) = x(a,b,c,d,s1,ss1) +  y(a,b,c,d) ! xtemp
c           x(a,b,c,d,i,j) = x(a,b,c,d,i,j) +  xtemp

c        enddo
c        enddo

      enddo
      enddo
      enddo
      enddo

      return
      end

         SUBROUTINE  OED__NAI_DERV_INT1D_TO_AB_F12
     +
     +                    ( SHELLA,SHELLB,
     +                      NEXP,NGQPCEN,NGEXCEN,
     +                      NXYZA,NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_DERV_INT1D_TO_AB
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative nuclear attraction integrals [A|B], adding
C                up the contributions from all the 1D AB integrals
C                for all nuclear centers.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                1DX and 1DY integrals.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x = A and B
C                    NEXP        =  current # of exponent pairs
C                    NGQPCEN     =  product of # of gaussian quadrature
C                                   points (roots) times # of nuclear
C                                   attraction centers
C                    NGEXCEN     =  product of # of gaussian quadrature
C                                   points times # of exponent pairs
C                                   times # of nuclear attraction
C                                   centers
C                    NXYZx       =  # of cartesian monomials for
C                                   x = A and B shells
C                    INT1Dx      =  all current 1D AB derivative
C                                   nuclear attraction integrals for
C                                   each cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1D AB derivative integral products
C                    SCALE       =  the NGEXCEN scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian [A|B]
C                                   derivative nuclear attraction
C                                   integrals corresponding to all
C                                   current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program OED
C
C    This routine is part of the integral program package OED and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routines of the
C    OED package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,J,K,M,N
         INTEGER     NEXP,NGQPCEN,NGEXCEN
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB
         INTEGER     XA,YA,ZA,XB,YB,ZB
         INTEGER     XAP,XBP
         INTEGER     YAMAX,YBMAX

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO,STGEXP,UVAL(1:NEXP),RTS(1:NGEXCEN)

         DOUBLE PRECISION  SCALE (1:NGEXCEN)
         DOUBLE PRECISION  TEMP1 (1:NGEXCEN)
         DOUBLE PRECISION  TEMP2 (1:NGEXCEN)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZA,1:NXYZB)

         DOUBLE PRECISION  INT1DX (1:NGEXCEN,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT1DY (1:NGEXCEN,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT1DZ (1:NGEXCEN,0:SHELLA,0:SHELLB)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...outer loops over x,x-pairs. No skipping of
C                x,x-contribution of 0,0-type can be done here,
C                since the 1DX integrals carry the Rys weight!
C
C
         XBP = 0
         DO 100  XB = SHELLB,0,-1
            YBMAX = SHELLB - XB
            XAP = 0
            DO 110 XA = SHELLA,0,-1
               YAMAX = SHELLA - XA

               DO N = 1,NGEXCEN
                  TEMP1 (N) = SCALE (N) * INT1DX (N,XA,XB)
               END DO
C
C
C             ...inner loops over y,y-pairs. Skip the multiplication
C                of y,y-contributions, if no y-coordinate derivative
C                was formed and we have a 0,0-pair, as then the 1DY
C                integrals are equal to 1.
C
C
               J = XBP
               DO 120 YB = YBMAX,0,-1
                  J = J + 1
                  ZB = YBMAX - YB
                  I = XAP
                  DO 130 YA = YAMAX,0,-1
                     I = I + 1
                     ZA = YAMAX - YA

                     IF (.NOT.DIFFY .AND. YA+YB.EQ.0) THEN
                         DO N = 1,NGEXCEN
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGEXCEN
                            TEMP2 (N) = TEMP1 (N) * INT1DY (N,YA,YB)
                         END DO
                     END IF
C
C
C             ...skip multiplication of z,z-contributions, if we
C                have a 0,0-pair and no derivations were performed
C                on the z-coordinate, as then the 1DZ integrals
C                are equal to 1. All info concerning all three
C                x,y and z contributions have been collected for all
C                exponent pairs, nuclear centers and quadrature points
C                at once. Sum up the 1D X,Y,Z integral products over
C                the nuclear centers and the quadrature points to
C                the appropriate place of the [A|B] batch.
C
C
                     IF (.NOT.DIFFZ .AND. ZA+ZB.EQ.0) THEN
                         K = 0
                         DO M = 1,NEXP
                            SUM = ZERO
                            DO N = 1,NGQPCEN
                               SUM = SUM + TEMP2 (K+N)*(1.d0-RTS(K+N) )
                            END DO
                            K = K + NGQPCEN
                            BATCH (M,I,J) = SUM*(2.d0*UVAL(M)/STGEXP)
                         END DO
                     ELSE
                         K = 0
                         DO M = 1,NEXP
                            SUM = ZERO
                            DO N = 1,NGQPCEN
                               SUM = SUM + TEMP2 (K+N)
     +                             * INT1DZ (K+N,ZA,ZB)*(1.d0-RTS(K+N) )
                            END DO
                            K = K + NGQPCEN
                            BATCH (M,I,J) = SUM*(2.d0*UVAL(M)/STGEXP)
                         END DO
                     END IF
C
C
C             ...next z,z-pair and y,y-pair.
C
C
  130             CONTINUE
  120          CONTINUE
C
C
C             ...next x,x-pair.
C
C
               XAP = I
  110       CONTINUE
            XBP = J
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      function qcomp_sps(n,l,alpha,beta,xval)
c     ----- computes q(n,l)                                -----
c     ----- scaled by exp(-t) to prevent overflows         -----
c     ----- arguments are alpha, beta, and xval=beta**2/(4*alpha) -----
c     ----- no restriction on the magnitude of xval           -----

      implicit double precision (a-h,o-z)

      dimension tmin(9)

      data tmin/31.0d0,28.0d0,25.0d0,23.0d0,22.0d0,20.0d0,19.0d0,
     1   18.0d0,15.0d0/

      data am1,   a0,   accpow, accasy, a1,   a2,   a4
     1    /-1.0d0,0.0d0,1.0d-14,1.0d-10,1.0d0,2.0d0,4.0d0/

      if(mod(n+l,2).ne.0.or.n.le.l) go to 30
c     ----- use alternating series (n+l.le.22.and.l.le.10) -----

      if(l.eq.0) xkp=a1
      if(l.ne.0) xkp=(beta/(alpha+alpha))**l
      prefac=sqpi2*xkp*fac2(n+l+1-2)/
     1   ((alpha+alpha)**((n-l)/2)*dsqrt(alpha+alpha)*fac2(l+l+3-2))
      num=l-n+2
      xden=(l+l+3)
      term=a1
      sum=term
      xc=am1
 10   if(num.eq.0) go to 20
      fnum=num
      term=term*fnum*xval/(xden*xc)
      xc=xc+am1
      sum=sum+term
      num=num+2
      xden=xden+a2
      go to 10
   20 qcomp=prefac*sum
      return

   30 if(xval.lt.tmin(min0(n,8)+1)) go to 60
c     ----- use asymptotic series (arbitrary n,l) -----
      xkp=(beta/(alpha+alpha))**(n-2)
      prefac=xkp*sqpi2/((alpha+alpha)*dsqrt(alpha+alpha))
      sum=a1
      term=a1
      faca=(l-n+2)
      facb=(1-l-n)
      xc=a1
   40 term=term*faca*facb/(a4*xc*xval)
      if(term.eq.a0) go to 50
      sum=sum+term
      if(dabs(term/sum).lt.accasy) go to 50
      faca=faca+a2
      facb=facb+a2
      xc=xc+a1
      go to 40
   50 qcomp=prefac*sum
      return

c     ----- use power series (n+l.le.22.and.l.le.10) -----
   60 if(l.eq.0) xkp=a1
      if(l.ne.0) xkp=(beta/(alpha+alpha))**l
      prefac=dexp(-xval)*xkp/(alpha+alpha)**((n-l+1)/2)
      if(mod(n+l,2).eq.0) prefac=prefac*sqpi2/dsqrt(alpha+alpha)
      xnum=(l+n-1)
      xden=(l+l+1)
      term=fac2(l+n+1-2)/fac2(l+l+3-2)
      sum=term
      xj=a0
   70 xnum=xnum+a2
      xden=xden+a2
      xj=xj+a1
      term=term*xval*xnum/(xj*xden)
      sum=sum+term
      if((term/sum).gt.accpow) go to 70
      qcomp_sps=prefac*sum
      return
      end

      blockdata sb_bd_vmol
      implicit none


c ilnbuf : the length of a buffer to read in chunks of integral files
c (There is no practical reason why this would be anything but 600.)

      integer           ilnbuf
      common /vmol_com/ ilnbuf
      save   /vmol_com/






      data ilnbuf /600/
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_ATOMIC_NONVALENCE_NHO
     +
     +                    ( NBAS,MXNBA,
     +                      NBOSIZE,
     +                      ATNXB,ATXIDX,ATXOFF,
     +                      NXB,NXA,
     +                      OCCNUM,BASOFF,
     +                      NAO2NHO,
     +                      P,
     +                      C,
     +                      IDX1,IDX2,
     +                      XVEC,
     +                      XMAT,
     +
     +                              BDNCEN,
     +                              BDCEN,
     +                              BDNBAS,
     +                              BDBAS,
     +                              BDOCC,
     +                              H )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_ATOMIC_NONVALENCE_NHO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine establishes the atomic nonvalence (Core
C                and Rydberg) NHOs by the following two choices:
C
C
C                Choice NAO2NHO = .true.
C                ------------------------
C                Here the NHOs are simply taken as the previously
C                found NAOs in 1 to 1 correspondence. This simply
C                means placing unit matrices into the H matrix
C                containing the expansion coeffs of the NHOs in terms
C                of the NAOs. Observe, that since the NAOs are
C                already site-symmetry adapted, the NHOs will be as
C                well.
C
C
C                Choice NAO2NHO = .false.
C                ------------------------
C                In this case, the NHOs are not simply taken as the
C                previously determined NAOs, rather the entire NAO
C                set of each atom is mixed together by diagonalizing
C                the atomic NAO occupation matrix:
C
C                    Loop over all relevant atoms having nonvalence NAOs
C                         For each such atom
C                             1) Set up the occupation matrix in
C                                NAO space
C                             2) Diagonalize that matrix
C                             3) Save the eigenvectors as the atomic
C                                nonvalence NHOs into the NHO collection
C                                matrix H and generate some additional
C                                data associated with it
C                    continue
C
C                The atomic nonvalence NHOs will also reflect the
C                correct atomic site symmetry. Before executing however
C                the diagonalization step 2), the NAO occupation matrix
C                is analyzed for matrix subblocks, which occur when
C                different symmetry components are present. Each
C                such submatrix is diagonalized separately and the
C                eigenvectors of the complete matrix are assembled
C                from those of the submatrix having zeroes elsewhere.
C                In this form the eigenvectors reflect the correct
C                symmetry, i.e. they are expanded in the proper set
C                of NAOs. Symmetry mixing does not occur when all
C                the eigenvalues of the occupation matrix are non-zero.
C                But sometimes several eigenvalues will be zero and
C                a brute force diagonalization of the entire occupation
C                matrix will mix eigenvectors belonging to different
C                symmetries.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    MXNBA        =  maximum # of NHOs per atom.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    ATNXB (A)    =  # of atomic nonvalence NAOs on
C                                    atom A having nonvalence NAOs.
C                    ATXIDX (A)   =  atomic index for atom A having
C                                    nonvalence NAOs.
C                    ATXOFF (A)   =  index offset for atomic nonvalence
C                                    NAOs for atom A having nonvalence
C                                    NAOs. This index is equal to the
C                                    total number of atomic nonvalence
C                                    NAOs on all nonvalence NAO atoms
C                                    preceeding nonvalence NAO atom A.
C                    NXB          =  total # of nonvalence NAOs.
C                    NXA          =  total # of nonvalence NAO atoms.
C                    OCCNUM       =  occupation number for present type
C                                    of atomic nonvalence NHOs. Can be
C                                    only 1 (Core) or 0 (Rydberg).
C                    BASOFF       =  global NHO basis offset index.
C                                    This number is needed to find the
C                                    global NHO basis index for the
C                                    J-th NXB-type bond (see output
C                                    below)
C                    NAO2NHO      =  is true, if the NHOs are set equal
C                                    to the previously determined NAOs.
C                                    If false, the complete atomic
C                                    NAO occupation matrix will be
C                                    diagonalized to generate the NHOs.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    C            =  section of the NAO coefficient
C                                    matrix in AO basis corresponding
C                                    to the nonvalence NAOs treated
C                                    here.
C                    IDX1,IDX2    =  integer vectors used for indexing.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C
C
C                  Output:
C
C                    BDNCEN (J)   =  # of atomic centers for the J-th
C                                    NXB-type bond. This is always = 1
C                                    here.
C                    BDCEN (1,J)  =  the atomic center index for the
C                                    J-th NXB-type bond.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    the J-th NXB-type bond. This is
C                                    always = 1 here.
C                    BDBAS (1,J)  =  the global basis (NHO) index for
C                                    the J-th NXB-type bond.
C                    BDOCC (J)    =  # of occupied levels for the J-th
C                                    NXB-type bond. Can be only 1 or 0.
C                    H (I,J)      =  MXNBA x NXB matrix containing the
C                                    atomic nonvalence NHOs. I is the
C                                    local atomic index labeling the
C                                    atomic NAOs from which the
C                                    nonvalence NHOs were constructed.
c                                    J is the global NHO index running
C                                    over all nonvalence NXB space
C                                    NHOs, with all NHOs belonging to
C                                    a specific atomic center being
C                                    grouped together.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ADD
         LOGICAL     CASE1,CASE2
         LOGICAL     CHANGE
         LOGICAL     LTRG,UTRG
         LOGICAL     NAO2NHO
         LOGICAL     REVERS
         LOGICAL     SAVEP

         INTEGER     ATIDX
         INTEGER     ATOM
         INTEGER     BASOFF
         INTEGER     COL,ROW
         INTEGER     I,J,K,L,M,N
         INTEGER     LAST
         INTEGER     MXNBA
         INTEGER     NBAS
         INTEGER     NBOSIZE
         INTEGER     NSUB
         INTEGER     NSWEEP
         INTEGER     NXB,NXA
         INTEGER     NXBA
         INTEGER     OCCNUM
         INTEGER     OFF
         INTEGER     SWEEP

         INTEGER     ATNXB   (1:NXA  )
         INTEGER     ATXIDX  (1:NXA  )
         INTEGER     ATXOFF  (1:NXA  )
         INTEGER     BDNBAS  (1:NXB  )
         INTEGER     BDNCEN  (1:NXB  )
         INTEGER     BDOCC   (1:NXB  )
         INTEGER     IDX1    (1:MXNBA)
         INTEGER     IDX2    (1:MXNBA)

         INTEGER     BDBAS   (1:NBOSIZE,1:NXB)
         INTEGER     BDCEN   (1:NBOSIZE,1:NXB)

         DOUBLE PRECISION  X
         DOUBLE PRECISION  ZERO,MATZERO

         DOUBLE PRECISION  XVEC  (1:MXNBA)

         DOUBLE PRECISION  C     (1:NBAS ,1:NXB  )
         DOUBLE PRECISION  H     (1:MXNBA,1:NXB  )
         DOUBLE PRECISION  P     (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  XMAT  (1:NBAS ,1:MXNBA)

         DATA  REVERS   /.TRUE./
         DATA  MATZERO  /1.D-12/
         DATA  ZERO     /0.D0  /
C
C
C------------------------------------------------------------------------
C
C
C             ...if requested, set the NHOs equal to the NAOs.
C
C
         IF (NAO2NHO) THEN

             DO ATOM = 1,NXA
                OFF = ATXOFF (ATOM)
                NXBA = ATNXB (ATOM)
                ATIDX = ATXIDX (ATOM)

                CALL  MAT__C_EQ_UNIT_FLOAT
     +
     +                     ( MXNBA,NXBA,
     +                       NXBA,NXBA,
     +
     +                                 H (1,OFF+1) )
     +
     +
                DO I = 1,NXBA
                   BDNBAS (OFF+I) = 1
                   BDNCEN (OFF+I) = 1
                   BDCEN (1,OFF+I) = ATIDX
                   BDBAS (1,OFF+I) = BASOFF + OFF + I
                   BDOCC (OFF+I) = OCCNUM
                END DO

             END DO

             RETURN

         END IF
C
C
C             ...the complete atomic NAO occupation matrices will
C                be diagonalized. Loop over all atoms having the
C                particular nonvalence set of NAOs.
C
C
         LTRG = .TRUE.
         UTRG  = .TRUE.
         SAVEP = .TRUE.

         DO 1000 ATOM = 1,NXA

            OFF = ATXOFF (ATOM)
            NXBA = ATNXB (ATOM)
            ATIDX = ATXIDX (ATOM)

            CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                 ( NBAS,NXBA,
     +                   NBAS,NBAS,
     +                   NBAS,NXBA,
     +                   NXBA,
     +                   NXBA,NBAS,
     +                   0,
     +                   SAVEP,LTRG,UTRG,
     +                   C (1,OFF+1),
     +                   P,
     +                   XVEC,
     +
     +                           XMAT )
     +
     +
            CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                   ( 6,
     +                     ' Atomic occupation matrix ',
     +                     NBAS,NXBA,
     +                     NXBA,0,
     +                     XMAT )
     +
     +
C
C
C             ...determine the presence of submatrices. NSUB will
C                contain the # of such submatrices and IDX1 has
C                the submatrix number on those rows of the NAO
C                occupation matrix belonging together. MATZERO is
C                the threshold for when a matrix element is considered
C                to be zero.
C
C
            DO N = 1,NXBA
               IDX1 (N) = 0
            END DO

            NSUB = 0

            DO N = 1,NXBA
               IF (IDX1 (N).EQ.0) THEN

                   NSUB = NSUB + 1
                   IDX1 (N) = NSUB

                   DO I = N+1,NXBA
                      CASE1 =         IDX1 (I) .EQ. 0
                      CASE2 = ABS (XMAT (I,N)) .GT. MATZERO
                      IF (CASE1.AND.CASE2) THEN
                          IDX1 (I) = NSUB
                      END IF
                   END DO

                   CHANGE = .TRUE.
                   NSWEEP = NXBA - N

                   DO SWEEP = 1,NSWEEP
                      IF (CHANGE) THEN
                          CHANGE = .FALSE.
                          DO J = N+1,NXBA
                             ADD = .FALSE.
                             DO I = J,NXBA
                                CASE1 =         IDX1 (I) .EQ. NSUB
                                CASE2 = ABS (XMAT (I,J)) .GT. MATZERO
                                ADD = ADD .OR. (CASE1.AND.CASE2)
                             END DO
                             IF (ADD) THEN
                               DO I = J,NXBA
                                  IF (ABS (XMAT (I,J)).GT.MATZERO) THEN
                                      IDX1 (I) = NSUB
                                      CHANGE = .TRUE.
                                  END IF
                               END DO
                             END IF
                          END DO
                      END IF
                   END DO

               END IF
            END DO

            DO N = 1,NXBA
               WRITE (*,*) ' N,IDX1 = ',N,IDX1 (N)
            END DO
C
C
C             ...loop over all submatrices, assemble them, diagonalize
C                them and form the overall eigenvectors of the NAO
C                occupation matrix. If only 1 submatrix, perform
C                straightforward overall diagonalization.
C
C
            IF (NSUB.EQ.1) THEN

                CALL  MAT__C_EQ_A_FLOAT
     +
     +                     ( NBAS,NXBA,
     +                       MXNBA,NXBA,
     +                       NXBA,NXBA,
     +                       XMAT,
     +
     +                               H (1,OFF+1) )
     +
     +
                CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
     +
     +                     ( MXNBA,NXBA,NXBA,
     +                       NXBA,
     +                       REVERS,
     +
     +                               XVEC,
     +                               H (1,OFF+1) )
     +
     +
            ELSE

                LAST = 0

                DO K = 1,NSUB
                   M = 0
                   DO N = 1,NXBA
                      IF (IDX1 (N).EQ.K) THEN
                          M = M + 1
                          IDX2 (M) = N
                      END IF
                   END DO

                   DO J = 1,M
                      COL = IDX2 (J)
                      DO I = J,M
                         ROW = IDX2 (I)
                         H (I,OFF+LAST+J) = XMAT (ROW,COL)
                      END DO
                   END DO

                   CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                          ( 6,
     +                            ' Atomic occupation submatrix ',
     +                            MXNBA,M,
     +                            M,0,
     +                            H (1,OFF+LAST+1) )
     +
     +
                   CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
     +
     +                        ( MXNBA,M,M,
     +                          M,
     +                          REVERS,
     +
     +                                  XVEC (LAST+1),
     +                                  H (1,OFF+LAST+1) )
     +
     +
                   CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                          ( 6,
     +                            ' Eigenvectors ',
     +                            MXNBA,M,
     +                            M,M,
     +                            H (1,OFF+LAST+1) )
     +
     +
                   DO J = 1,M
                      L = NXBA
                      COL = OFF + LAST + J
                      DO I = M,1,-1
                         ROW = IDX2 (I)
                         DO N = L,ROW+1,-1
                            H (N,COL) = ZERO
                         END DO
                         H (ROW,COL) = H (I,COL)
                         L = ROW - 1
                      END DO
                      DO N = L,1,-1
                         H (N,COL) = ZERO
                      END DO
                   END DO

                   LAST = LAST + M

                END DO
C
C
C             ...put eigenvalues and eigenvectors of NAO occupation
C                matrix in desired order.
C
C
                DO I = 1,NXBA-1
                   K = I
                   X = XVEC (I)

                   IF (REVERS) THEN
                       DO J = I+1,NXBA
                          IF (XVEC (J).GT.X) THEN
                              K = J
                              X = XVEC (J)
                          END IF
                       END DO
                   ELSE
                       DO J = I+1,NXBA
                          IF (XVEC (J).LT.X) THEN
                              K = J
                              X = XVEC (J)
                          END IF
                       END DO
                   END IF

                   IF (K.NE.I) THEN
                       XVEC (K) = XVEC (I)
                       XVEC (I) = X
                       DO J = 1,NXBA
                          X = H (J,OFF+I)
                          H (J,OFF+I) = H (J,OFF+K)
                          H (J,OFF+K) = X
                       END DO
                   END IF

                END DO

            END IF

C            CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
C     +
C     +                   ( 6,
C     +                     ' NHO matrix Eigenvalues ',
C     +                     NXBA,
C     +                     NXBA,
C     +                     XVEC )
C     +
C     +
C            CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
C     +
C     +                   ( 6,
C     +                     ' NHO matrix Eigenvectors ',
C     +                     MXNBA,NXBA,
C     +                     NXBA,NXBA,
C     +                     H (1,OFF+1) )
C     +
C     +
            DO I = 1,NXBA
               BDNBAS (OFF+I) = 1
               BDNCEN (OFF+I) = 1
               BDCEN (1,OFF+I) = ATIDX
               BDBAS (1,OFF+I) = BASOFF + OFF + I
               BDOCC (OFF+I) = OCCNUM
            END DO

 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine ecp_renorm(nbasis, erd_index, scalars) 
c-----------------------------------------------------------------------------
c   Using the shell angular momentum and basis function information, this
c   subroutine calculates an array which maps the ACES integral order to 
c   the ERD integral order.  This array may be used to re-order a block 
c   of integrals calculated by the ERD package into a format corresponding
c   to the ACES (VMOL-based) integrals.
c
c   Arguments:
c      nfps		Number of basis functions per shell.
c      iangular		Shell type (based on angular momentum) per shell.
c			(i. e. an S shell = 0, P = 1, etc.)
c      nshells		Number of shells contained in nfps and iangular.
c      ispherical       1 = spherical coordinates, 0 = Cartesian
c      erd_index	An array (output) of nbasis indices.  The ith
c			value of erd_index is the index in the ERD-based 
c        		system corresponding to index "i" in the ACES-based
c			system.
c      scalars          An array (output) of scale factors to adjust the
c                       ERD integrals to match VMOL integrals.
c-----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
c     include 'saved_data.h'
      include 'dropmo.h' 

      integer erd_index(*)
      double precision scalars(*)
      double precision ecp_vmol(max_basis,max_basis)
      double precision etemp(max_basis*max_basis),W,ws

      integer i, j, k, ii, jj, kk  
      integer nctr, nsh_coords

      integer Ierror 

      integer nbasis, ndim, natoms  
      double precision ecp_erd, decp_erd
      common /FECP/ndim, ecp_erd(2500,2500)  
c     common /DECP/natoms, decp_erd(50,3,1000,1000)  

      integer map(max_basis) 
      logical bexist 
      logical dexist 
      double precision scale(max_basis) 

      INQUIRE(file='ecpint.dat',exist=bExist) 

      if (bexist) then 

      OPEN (Unit = 77, File = 'ecpint.dat', Form = 'Unformatted', 
     *      Status = 'Old', Iostat = Ierror) 

      rewind 77 
      read(77) ndim 
      read(77) (etemp(i), i=1, ndim*(ndim+1)/2)  
      close(77) 

      else 
           return 

      endif ! bexist 

#ifdef _DEBUG_LVL0
      write(6,*) ' Renormalizing the ECP integrals '
      write(6,*) ' NDIM = ', ndim 
#endif

      if (ndim .ne. nbasis) then 
         write(6,*) ' The number of functions from ECP read is not 
     *   what is expected:', ndim, nbasis 
      endif 

      do i = 1, ndim 
         ii = erd_index(i) 
         map(ii) = i 
         scale(ii) = scalars(i) 
      enddo 

      do i = 1, ndim  
      do j = 1, i 
           ecp_vmol(i,j) = 0.0  
           ecp_vmol(j,i) = 0.0  
      enddo 
      enddo 

      k = 0 
      do i = 1, ndim  
      do j = 1, i 
           k = k + 1 
           ecp_vmol(i,j) = etemp(k) ! * scalars(ii) * scalars(jj) 
           ecp_vmol(j,i) = etemp(k) ! * scalars(ii) * scalars(jj)   
      enddo 
      enddo 

      do i = 1, ndim  
      do j = 1, ndim  
           ii = map(i) 
           jj = map(j) 
           ecp_erd(i,j) = ecp_vmol(i,j) *scalars(i) * scalars(j)  

#ifdef _DEBUG_LVL0
           write(6,"(a,1x,i2,1x,i2,4(1x,F15.7))")
     &         ' ECP :', i, j, ecp_erd(i,j), ecp_vmol(i,j),
     &                                scalars(i),
     &                                scalars(j)
#endif

      enddo
      enddo

#ifdef _DEBUG_LVL0
      Do i = 1, ndim
         write(6,"(4(2x,F15.8))") (ecp_erd(i,j), j=1,ndim)
         Write(6,*)
         do j = i, ndim
         w  = w +ecp_erd(i, j)
         Ws = ws + ecp_erd(i,j)*ecp_erd(i,j)
         enddo
      enddo
      Write(6,*) "Linear and checksums"
      Write(6, "(2(1x, F20.10))") w, Ws
#endif

      return
      end

      SUBROUTINE COPY(SOURCE,TARGET,LENGTH)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION SOURCE(LENGTH),TARGET(LENGTH)
      DO 10 I=1,LENGTH
       TARGET(I)=SOURCE(I)
10    CONTINUE
      RETURN
      END

      SUBROUTINE CNVRT2RAD(R,NX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      DIMENSION R(NX)
      ATOR=DACOS(-1.D0)/180.D0
      ATOB=0.529177249D0
      DO IX = 8, NX-1, 3
         IF (IX.NE.8) R(IX+1) = R(IX+1)*ATOR
         R(IX) = R(IX)*ATOR
      END DO
      IF (IFLAGS(78).EQ.0) THEN
         DO IX = 4, NX-2, 3
            R(IX) = R(IX)/ATOB
         END DO
      END IF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine contract_ecp_derv_integrals(density,
     *                       da1, da2, db1, db2)
c---------------------------------------------------------------------------
c  Computes the set of OED derivative integrals matching "type" and 
c  and contracts them with density block (da1:da2, db1:db2).
c
c   type = 1 --> NAI integrals
c          2 --> KIN integrals
c          3 --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer type
      integer da1, da2, db1, db2
      double precision density(da1:da2, db1:db2)
      double precision z(da1:da2, db1:db2)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif
      integer i, ix, m, n, nfirst, nints, nalpha, ncoeff, iatom, ncsum
      integer component
      integer a, b, a1,a2,b1,b2,lastao, igrad
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc
      integer ind(2)
      integer flopcount
      logical spherical
      logical dexist 
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, y
c
c ECP derivative integrals 
c 
      integer natoms 
      integer ndim, j, jj, kk  
      integer Ierror 
      double precision etemp((da2-da1)*(db2-db1))

      common /flags/ iflags
      integer iflags(100)

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      spherical = (ispherical .eq. 1)
      lastao    = end_nfps(nshells)

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: contract_oed_derv_integrals requires ERD ',
     *           'integral package.'
call abort_job()
      endif

      INQUIRE(file='decpint.dat',exist=dExist)

      if (dexist) then

      OPEN (Unit = 88, File = 'decpint.dat', Form = 'Unformatted',
     *      Status = 'Old', Iostat = Ierror)
      rewind 88
#ifdef _DEBUG_LVL0
      write(6,*) ' Reading the ECP derivative integrals '
10    Format(2x,'ATOM NUMBER ',2x,I8)
20    Format(6x,'Coordinate ',2x,I8)
30    Format(12x,'Integrals ',2x,2I8,2x,F16.8)
#endif

      endif 

      call ecp_to_erd(nfps, ivangmom, nshells, ispherical,
     *                         ibuf(ierdind), dbuf(iscale_fac)) 

c--------------------------------------------------------------------------
c   If ECP add ecp derivative integrals  

      read(88) natoms 
      do iatom = 1, natoms 
         do component = 1, 3 
            read(88) ndim 
            read(88) (etemp(i), i=1, ndim*(ndim+1)/2) 

            kk = 0 
            do i = 1, ndim 
            do j = 1, i 
               kk = kk + 1 
               z(i,j) = etemp(kk) ! * scalars(i) * scalars(j)  
               z(j,i) = etemp(kk) ! * scalars(i) * scalars(j)  
            enddo 
            enddo 

            call decp_renorm(ndim, z, ibuf(ierdind), dbuf(iscale_fac))
  
c            do a = a1, a2 
c            do b = b1, b2 
c                z(a,b) = decp_erd(a, b) 
#ifdef _DEBUG_LVL0
c                 Write(6,"(a)") "Adding ECP derivative integrals"
c                 Write(6,"(1x, 2I3, 1x,f12.7)") a, b, decp_erd(iatom,
c    *                                    component, a, b)
#endif
c            enddo 
c            enddo 

c--------------------------------------------------------------------------
c   Contract the density block with the block of integrals.
c--------------------------------------------------------------------------

                 call cwork0222(y,
     *                          density,da1,da2,db1,db2,
     *                          da1,da2,db1,db2, ind,
     *                          z,da1,da2,db1,db2,
     *                          da1,da2,db1,db2,ind(1), ind(2),
     *                          flopcount)

c---------------------------------------------------------------------------
c   Sum into the gradient.
c---------------------------------------------------------------------------

                igrad = (iatom-1)*3 + component 
                gradient_data(igrad) = gradient_data(igrad) + y
         enddo ! icomponent = 1, 3 
      enddo ! iatom = 1, natoms 
      close(88) 

      return
      end

      subroutine decp_renorm(nbasis, z, erd_index, scalars)
c-----------------------------------------------------------------------------
c   Using the shell angular momentum and basis function information, this
c   subroutine calculates an array which maps the ACES integral order to 
c   the ERD integral order.  This array may be used to re-order a block 
c   of integrals calculated by the ERD package into a format
corresponding
c   to the ACES (VMOL-based) integrals.
c
c   Arguments:
c      nfps             Number of basis functions per shell.
c      iangular         Shell type (based on angular momentum) per shell.
c                       (i. e. an S shell = 0, P = 1, etc.)
c      nshells          Number of shells contained in nfps and iangular.
c      ispherical       1 = spherical coordinates, 0 = Cartesian
c      erd_index        An array (output) of nbasis indices.  The ith
c                       value of erd_index is the index in the ERD-based 
c                       system corresponding to index "i" in the ACES-based
c                       system.
c      scalars          An array (output) of scale factors to adjust the
c                       ERD integrals to match VMOL integrals.
c-----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
c     include 'saved_data.h'
      include 'dropmo.h'
      integer erd_index(*)
      double precision scalars(*)
      double precision z(nbasis,nbasis)

      integer i, j

      integer nbasis, ndim, natoms

      integer map(max_basis)
      logical bexist
      logical dexist
      double precision scale(max_basis)

      do i = 1, nbasis 
      do j = 1, nbasis 
         z(i,j) = z(i,j)*scalars(i)*scalars(j)  
      enddo 
      enddo 

      return 
      end 

      SUBROUTINE SORTXYZ(XX,Y,NORD,NATOMS)
C
C     SORTS VECTOR OF NUCLEAR COORDINATES - TO CHECK FOR EQUIVALENCE
C     OF TWO ORIENTATIONS - NEEDS Q VECTOR AND ATOMIC MASS VECTOR 
C     FOR MASS WEIGHTING.  THE SORT IS FIRST DONE ON THE X COORDINATE,
C     BUT IF IDENTICAL X VALUES ARE ENCOUNTERED, THE Y COORDINATE
C     IS THEN SORTED AS WELL, AND ALSO THE Z IF NECESSARY.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     Maximum number of atoms currently allowed
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3, MXATMS), R(3, MAXREDUNCO/3), 
     &     NCON(3, MAXREDUNCO/3), NR(MXATMS),
     &     ISQUASH(MAXREDUNCO),IATNUM(MXATMS),ATMASS(MXATMS),
     &     IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS_WITHDUMMY

C coord.com : end


C
      COMMON /TOLERS/ SYMTOL,DEGTOL
C
C The purpose of the above coord common block was to get the value of the
C number of atoms, mass, and charge. However, it was a serious mistake
C to obtain the number of atoms from this common block.
C NATOMS in the COORD common block corresponds to the total number
C of atoms including the dummy atoms. There were calls to this
C routine from IRREPS() and COMVEC() with the assumption
C that NATOMS corresponds to the number of real atoms. This
C caused memory errors for sufficiently large systems (>20 atoms), but
C was hidden for smaller systems. The correct thing
C to do is to let the caller pass in the correct value as an
C argument and ignore the last entry of the COORD common block.
C 01/2006, Ajith Perera.
C
      DIMENSION X(3*MXATMS),XX(3*NATOMS),Y(3*NATOMS),NORD(MXATMS*2)
      DIMENSION SCR(3*MXATMS)
C
      CALL ZERO(X,3*MXATMS)
C
C SORT THE X COORDINATES AND MASS WEIGHT THEM
C
      CALL SCOPY(3*NATOMS,XX,1,SCR,1)
      IOFF=1
      DO 10 I=1,NATOMS
       NORD(I+MXATMS)=I
       IOFF=IOFF+3
10    CONTINUE
    
      CALL SCOPY(NATOMS,SCR,3,X,1)
C
C GIVE DUMMY ATOMS RIDICULOUS X COORDINATES
C
      DO 5 I=1,NATOMS
       IF(ATMASS(I).LT.1.D-8)X(I)=-99999.
5     CONTINUE
      CALL PIKSR3(NATOMS,X,NORD(MXATMS+1))
      DO 11 ITARGET=1,NATOMS
       ISOURCE=NORD(ITARGET+MXATMS)
       IOFFSRC=3*(ISOURCE-1)+1
       IOFFTAR=3*(ITARGET-1)+1
       CALL SCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
11    CONTINUE
C
C NOW WE MUST SEARCH FOR CLUSTERS OF VALUES IN THE X VECTOR
C
      IFINDX=1
1     NLEFT=NATOMS-IFINDX+1
      ILOC=IFINDNE(NLEFT,X(IFINDX),1,X(IFINDX),SYMTOL)+IFINDX-1
      ICLSIZX=ILOC-IFINDX
      IF(ILOC.NE.IFINDX+1)THEN
C
C CLUSTER HAS BEEN LOCATED.  SORT THE ASSOCIATED Y VALUES.
C
       CALL SCOPY(ICLSIZX,Y(2+3*(IFINDX-1)),3,X,1)
       CALL PIKSR3(ICLSIZX,X,NORD(MXATMS+IFINDX))
       DO 13 ITARGET0=1,ICLSIZX
        ISOURCE=NORD(ITARGET0+MXATMS+IFINDX-1)
        ITARGET=ITARGET0+IFINDX-1
        IOFFSRC=3*(ISOURCE-1)+1
        IOFFTAR=3*(ITARGET-1)+1
        CALL SCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
13     CONTINUE
C
C NOW WE MUST SEARCH FOR CLUSTERS OF VALUES IN THE Y VECTOR WITHIN
C  THIS X VECTOR CLUSTER
C
       IFINDY=1
2      NLEFTY=ICLSIZX-IFINDY+1
       ILOC=IFINDNE(NLEFTY,X(IFINDY),1,X(IFINDY),SYMTOL)+IFINDY-1
       ICLSIZY=ILOC-IFINDY
       IF(ICLSIZY.NE.1)THEN
C
C CLUSTER HAS BEEN LOCATED.  SORT THE Z VALUES.
C
        IPOS=IFINDX+IFINDY-1
        CALL SCOPY(ICLSIZY,Y(3+3*(IPOS-1)),3,X,1)
        CALL PIKSR3(ICLSIZY,X,NORD(MXATMS+IPOS))
        DO 14 ITARGET0=1,ICLSIZY
         ISOURCE=NORD(ITARGET0+MXATMS+IPOS-1)
         ITARGET=ITARGET0+IPOS-1
         IOFFSRC=3*(ISOURCE-1)+1
         IOFFTAR=3*(ITARGET-1)+1
         CALL SCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
14      CONTINUE
       ENDIF
       IFINDY=IFINDY+ICLSIZY
       IF(IFINDY.LT.ICLSIZX)GOTO 2
      ENDIF
      IFINDX=IFINDX+ICLSIZX
      IF(IFINDX.LT.NATOMS)GOTO 1
C
      IOFF=1
      DO 100 I=1,NATOMS
       Z=FLOAT(IATNUM(NORD(MXATMS+I)))
       CALL SSCAL(3,Z,Y(IOFF),1)
       IOFF=IOFF+3
100   CONTINUE
      CALL ICOPY(MXATMS,NORD(MXATMS+1),1,NORD,1)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C Read the Z-matrix and associated variables

#include "iachar.h"

      SUBROUTINE read_zmat_internal_coords()
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
#include "linelen.par"

      LOGICAL PRINTI,PRINTF,BTMP

c     This number is supposed to be a unique tag to see whether some
c     internal coordinates were not defined.
      DOUBLE PRECISION dSmallNumber
      PARAMETER (dSmallNumber=5.361d-21, EPSILON= 1.0D-07)

#include "io_units.par"
#include "flags.h"

C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      CHARACTER*(linelen) ZLINE, DUMSTR
      integer izline(80), izl(2,7)
      INTEGER ATOI, TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH 
      CHARACTER*10 VARTMP(3*MXATMS)
      CHARACTER*5 CHTEST
      CHARACTER*4 INTLABEL(3*MXATMS)
      CHARACTER*1 achar, czTmp, czPercent, czAsterisk
      Character*4 FPGrp, BPGrp, PGrp
      LOGICAL YESNO,BAD123,XYZIN,NWFINDIF,I_UNIQUE(MAXREDUNCO),
     &        VERY_FIRST_TIME, UNCONSTRAINED
      logical bStruct
C
      double precision rtmp(3*MXATMS)

C
      DIMENSION JAX(3*MXATMS), JLIST(3*MXATMS)
C
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(3*MXATMS),
     &     PARNAM(3*MXATMS)
#include "coord.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     &                ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,
     &                IBASIS,XYZTol
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
C
      DATA BTOA /0.529177249D0/
      DATA ZILCH /0.0/
C
      ISQ(N) = MAX( N-6 , (N/3)+MOD(N,3)-1 )

      czPercent  = achar(_IACHAR_PERCENT)
      czAsterisk = achar(_IACHAR_ASTERISK)

c ----------------------------------------------------------------------

C     Symbol to indicate optimized coordinate
      CALL IGETREC(1,'JOBARC','FIRSTRUN',1,iTmp)
      PRINTI = (iTmp.NE.0)
      PRINTF = .TRUE.
      IONE = 1
C
      do i = 1, 3*MXATMS
         jlist(i) = 0
         jax(i)   = 0
         vartmp(i) = ' '
      enddo
C
      XYZIN   = .FALSE.
      BAD123  = .FALSE.
      IERR    = 0
      RTOA    = 180.0D0/DACOS(-1.0D0)
      NUNIQUE = 0
      NOPT    = 0

c ----------------------------------------------------------------------

c   o open up the main input file
      open(LuZ,FILE=ZFil,STATUS='OLD')
      rewind LuZ

c   o skip the header (zline=TITLE on end do)
      btmp = .true.
      do while (btmp)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         i = izl(1,1)
         btmp = (i.eq.0).or.(zline(i:i).eq.czPercent)
      end do

c   o count the number of elements
      btmp = .true.
      natoms = 0
      do while (btmp)
         read(luz,'(a)') zline
         if (linblnk(zline).eq.0) then
            btmp = .false.
         else
            natoms = natoms + 1
         end if
         if (natoms.gt.mxatms) then
            write(*,*)
            write(*,*) '@READ_ZMAT: The number of atoms has ',
     &                 'exceeded the maximum allowed of ',mxatms
            write(*,*)
            write(66,*)
            write(66,*) '@READ_ZMAT: The number of atoms has ',
     &                 'exceeded the maximum allowed of ',mxatms
            write(66,*)
            call errex
         end if
      end do
      if (printi)
     &   write(*,'(a,i3,a)') ' ',natoms,' entries found in Z-matrix '

c     set number of coordinates based on number of elements found in Z-matrix
      NX = 3 * NATOMS

c Create an array that relates TR invariant (squashed) coords to full
c space for use as lookup during compression/decompression.
      ISQUASH(1) = 4
      ISQUASH(2) = 7
      ISQUASH(3) = 8

c Set NXM6 to 3*NATOMS-6 or just 1 if it is a diatomic.
      NXM6 = MAX(NX-6,1)
      DO I = 4,NXM6
         ISQUASH(I) = I+6
      END DO

c ----------------------------------------------------------------------

c Retrieve the Z-matrix:
c     atomic symbols into ZSYM
c     variable names into VARTMP
c     connectivity into NCON
c
c Do this by reading in each line as text and picking it apart using
c the positions of white space determined in PARSEZ.

c   o skip the header (zline=TITLE on end do)
      rewind(luz)
      btmp = .true.
      do while (btmp)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         i = izl(1,1)
         btmp = (i.eq.0).or.(zline(i:i).eq.czPercent)
      end do

c   o save the title
      if (printi) then
         i = linblnk(zline)
         if (i.lt.68) then
            write(LuOut,*)
            write(LuOut,'(2a)') ' Job Title : ', zline(1:i)
            write(LuOut,*)
         else
            write(LuOut,*)
            write(LuOut,'(1a)') ' Job Title : '
            write(LuOut,'(a)') zline(1:i)
            write(LuOut,*)
         end if
      end if
c YAU : old
c      read(zline,'(80a1)') izline
c      call iputrec(1,' ','TITLE',80,izline)
c YAU : new
      call putcrec(1,' ','TITLE',80,zline(1:80))
c YAU : end

c   o first element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,1).eq.0.or.izl(1,2).ne.0) call debug_zmat
      ZSYM(1) = ZLINE(izl(1,1):izl(2,1))
      VARTMP(1) = ' '
      VARTMP(2) = ' '
      VARTMP(3) = ' '
      NCON(1)   = 0
      NCON(2)   = 0
      NCON(3)   = 0
      IF (NATOMS.EQ.1) THEN
         NXM6 = 0
c SB: Fixed output for atomic calculations
         nunique = 0
         nopt = 0
         goto 3441
      END IF

c   o second element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,3).eq.0.or.izl(1,4).ne.0) call debug_zmat
      ZSYM(2)   = ZLINE(izl(1,1):izl(2,1))
      VARTMP(4) = ZLINE(izl(1,3):izl(2,3))
      VARTMP(5) = ' '
      VARTMP(6) = ' '
      NCON(4)   = 1
      NCON(5)   = 0
      NCON(6)   = 0
      IF (NATOMS.EQ.2) GOTO 34

c   o third element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,5).eq.0.or.izl(1,6).ne.0) call debug_zmat
      ZSYM(3)   = ZLINE(izl(1,1):izl(2,1))
      VARTMP(7) = ZLINE(izl(1,3):izl(2,3))
      VARTMP(8) = ZLINE(izl(1,5):izl(2,5))
      VARTMP(9) = ' '
      NCON(7)   = 2
      NCON(8)   = 1
      NCON(9)   = 0

c SET A FLAG IF THIS IS NOT A 2--1--3 Z-MATRIX.
      JUNK   = ATOI( ZLINE(izl(1,2):izl(2,2)) )
      BAD123 = (JUNK.EQ.1)

c Ajith Perera 07/2000
c The extended (to handle MOLCAS integrals) vmol2ja needs to know whether
c the first two atoms have been switched.
      IF (BAD123) CALL IPUTREC(20,'JOBARC','12SWITCH',1,JUNK)

c   o remaining elements
      do i = 4, natoms
         read(luz,'(a)') zline
         if (zline(1:1).eq.czAsterisk) then
            write(*,*)
     &         '@READ_ZMAT: The Z-matrix was not terminated properly.'
            call errex
         end if
         call parsez(zline,izl)
         if (izl(1,7).eq.0) call debug_zmat
         ZSYM(I)       =       ZLINE(izl(1,1):izl(2,1))
         VARTMP(3*I-2) =       ZLINE(izl(1,3):izl(2,3))
         VARTMP(3*I-1) =       ZLINE(izl(1,5):izl(2,5))
         VARTMP(3*I)   =       ZLINE(izl(1,7):izl(2,7))
         NCON(3*I-2)   = ATOI( ZLINE(izl(1,2):izl(2,2)) )
         NCON(3*I-1)   = ATOI( ZLINE(izl(1,4):izl(2,4)) )
         NCON(3*I)     = ATOI( ZLINE(izl(1,6):izl(2,6)) )
c      o catch basic errors and immediately dump to debug_zmat()
         J = 3*I-2
         IF ( (NCON(J  ).EQ.NCON(J+1)) .OR.
     &        (NCON(J  ).EQ.NCON(J+2)) .OR.
     &        (NCON(J+1).EQ.NCON(J+2))      ) call debug_zmat
         IF ( (NCON(J  ).EQ.0) .OR.
     &        (NCON(J+1).EQ.0) .OR.
     &        (NCON(J+2).EQ.0)      ) call debug_zmat
         IF ( (NCON(J  ).GE.I) .OR.
     &        (NCON(J+1).GE.I) .OR.
     &        (NCON(J+2).GE.I)      ) call debug_zmat
c     end do i = 4, natoms
      end do

c IF CONNECTIVITY OF THE FIRST THREE ATOMS IS 3--1--2. SWITCH
c ATOMS 1 AND 2 AND THEN ALL REFERENCES TO THEM.
   34 CONTINUE
      IF (BAD123) THEN
         CHTEST  = ZSYM(1)
         ZSYM(1) = ZSYM(2)
         ZSYM(2) = CHTEST
         DO J = 9, NX
            ITMP = 0
            IF (NCON(J).EQ.2) ITMP = 1
            IF (NCON(J).EQ.1) ITMP = 2
            IF (ITMP.NE.0)    NCON(J) = ITMP
         END DO
         IF (PRINTI) WRITE(LUOUT,*) '@READ_ZMAT: The ordering of the ',
     &      'first two atoms in the Z-matrix has been changed.'
      END IF

      IF (PRINTI .AND. IPRNT.GE.2) THEN
         WRITE (LUOUT,*) '@READ_ZMAT: plain Z-matrix'
         J = 1
         DO I = 1, NAtoms
            WRITE (LUOUT,'(I2,A,1X,A,3(1X,I3,1X,A))')
     &            I,':',ZSYM(I),
     &            NCON(J+0),VARTMP(J+0),
     &            NCON(J+1),VARTMP(J+1),
     &            NCON(J+2),VARTMP(J+2)
            J = J + 3
         END DO
         WRITE (LUOUT,*)
      END IF

c REDUNDANCY CHECKING AND GENERATE VECTORS CONTAINING POSITIONS
c OF COORDINATES TO BE OPTIMIZED AND CORRESPONDING REDUNDANT
c COORDINATES. LISTS USE INTERNAL COORDINATE NUMBERING WHICH
c CORRESPONDS TO THE "SQUASHED" SCHEME (1,2,3,4,... vs 4,7,8 etc)

      do i = 1, 3*NATOMS
         neq(i) = 0
      enddo

      DO 210 I = 1, NX
         ISQ_I = ISQ(I)
         IF (.NOT.(I.LT.4.OR.I.EQ.5.OR.I.EQ.6.OR.I.EQ.9)) THEN
            IRED = 0
            DO J = 1, I-1
               IF (VARTMP(J).EQ.VARTMP(I)) THEN
                  IRED = 1
                  ISQ_J = ISQ(J)
                  NEQ(ISQ_J) = NEQ(ISQ_J) + 1
                  IEQUIV(JLIST(ISQ_J),NEQ(ISQ_J)) = ISQ_I
               END IF
            END DO
            IF (IRED.LE.0) THEN
               NUNIQUE = NUNIQUE + 1
               IUNIQUE(NUNIQUE) = ISQ_I
               JLIST(ISQ_I) = NUNIQUE
            END IF
C
C CHECKING FOR PARAMETERS TO BE OPTIMIZED
C
            JAX(I) = INDEX(VARTMP(I),czAsterisk)
            VARNAM(I) = VARTMP(I)
            IF (JAX(I).NE.0.OR.iFlags2(h_IFLAGS2_geom_opt).EQ.2) THEN
               IF (JAX(I).NE.0) VARNAM(I) = VARTMP(I)(:JAX(I)-1)
               IF (IRED.EQ.1) GOTO 210
               NOPT = NOPT + 1
               PARNAM(NOPT) = VARNAM(I)
               NOPTI(NOPT) = ISQ_I
            END IF
         END IF
  210 CONTINUE

c   o read the blank line after the Z-matrix
      READ(LUZ,'(A)') ZLINE

c   o load the first structure into R
      call rd_intcoord(r)
      print *,'R after RD_INTCOORD: '
      do i = 1, 3*natoms
         print *,'i, r(i) ',i,r(i)
      enddo

c   o read additional structures until we hit a namelist
c     (iStruct corresponds to the structure we expect to read)
      iStruct = 1
      bStruct = .true.
      do while (bStruct.and.iStruct.lt.3)
         iStruct = iStruct + 1
         read(luz,'(a)') zline
         backspace(luz)
         ISTP = INDEX(zline(1:),'=')
         I    = INDEX(zline(1:),'*')
         bStruct = ((i.eq.0).and.(istp.ne.0))
         if (bStruct) then
            call rd_intcoord(rtmp)
            if (iStruct.eq.2) then
c            o read the next line and see if this structure was the TS or PR
               read(luz,'(a)') zline
               backspace(luz)
               ISTP = INDEX(zline(1:),'=')
               I    = INDEX(zline(1:),'*')
               btmp = ((i.ne.0).or.(istp.eq.0))
            else
               btmp = .true.
            end if
            if (btmp) then
               call dputrec(1,'JOBARC','PRSTRUCT',nx,rtmp)
            else
c            o move R to RXSTRUCT since we are optimizing the TS structure
               call dputrec(1,'JOBARC','RXSTRUCT',nx,R)
               call dcopy(nx,rtmp,1,R,1)
            end if
c        end if (bStruct)
         end if
c     end do while (bStruct)
      end do

 3441 continue

C WRITE OUT RELEVANT INFORMATION
      IF (PRINTI.AND. ncycle.EQ.0) THEN
         WRITE(LUOUT,*)
     &      ' There are ',NUNIQUE,' unique internal coordinates.'
         WRITE(LUOUT,*)
     &      ' Of these, ',NOPT ,' will be optimized.'
      END IF
      IF (IPRNT.GE.2.AND.PRINTI) THEN
         DO I = 1, NOPT
            WRITE(LUOUT,*) ' Parameter #',I,' to be optimized is ',
     &         PARNAM(I)
         END DO
      END IF

C PRINT OUT Z-MATRIX SO THAT USER CAN RECONSTRUCT LATER IF NEED BE.
      IF (IPRNT.GE.0.AND.PRINTI) THEN
         WRITE(LUOUT,1001)
 1001    FORMAT(T3,' User supplied Z-matrix: ',/,80('-'),/
     &          T8,'SYMBOL',T18,'BOND',
     &          T28,'LENGTH',T38,'ANGLE',T48,'ANGLE',T58,'DIHED',T68,
     &              'ANGLE',/,
     &          T18,' TO ',T27,'(ANGST)',T37,' WRT ',T47,'(DEG)',T57,
     &              ' WRT ',
     &          T67,'(DEG)',/,80('-'))
         WRITE(LUOUT,734) ZSYM(1)
c SB fixed output for atomic and diatomic calculations
         if (natoms.gt.1) WRITE(LUOUT,734) ZSYM(2),NCON(4),VARNAM(4)
         if (natoms.gt.2) WRITE(LUOUT,734) ZSYM(3),NCON(7),VARNAM(7),
     &                                     NCON(8),VARNAM(8)
         DO I = 4, NATOMS
            IT3 = 3 * I
                          WRITE(LUOUT,734) ZSYM(I),
     &                       (NCON(IT3-J),VARNAM(IT3-J),J=2,0,-1)
         END DO
  734    FORMAT(T9,A,T19,I2,T30,A,T40,I2,T50,A,T60,I2,T70,A)
         if (nunique.gt.0) then
            WRITE(LUOUT,1000)
 1000       FORMAT(T18,' *Initial values for internal coordinates* ',/,
     &             T23,'Name',t40,'Value')
 1002       FORMAT(T18,' *Initial values for reactant coordinates* ',/,
     &             T23,'Name',t40,'Value')
 1003       FORMAT(T18,' *Initial values for product  coordinates* ',/,
     &             T23,'Name',t40,'Value')
            DO I = 1, NUNIQUE
               WRITE(LUOUT,'(T25,A,T38,F11.6)')
     &            VARNAM(ISQUASH(IUNIQUE(I))),R(ISQUASH(IUNIQUE(I)))
            END DO
c         o reactant
            call getrec(0,'JOBARC','RXSTRUCT',J,rtmp)
            if (j.gt.0) then
               call getrec(1,'JOBARC','RXSTRUCT',J,rtmp)
               write(luout,1002)
               DO I = 1, NUNIQUE
                  WRITE(LUOUT,'(T25,A,T38,F11.6)')
     &               VARNAM(ISQUASH(IUNIQUE(I))),
     &               RTMP(ISQUASH(IUNIQUE(I)))
               END DO
            end if
c         o product
            call getrec(0,'JOBARC','PRSTRUCT',J,rtmp)
            if (j.gt.0) then
               call getrec(1,'JOBARC','PRSTRUCT',J,rtmp)
               write(luout,1003)
               DO I = 1, NUNIQUE
                  WRITE(LUOUT,'(T25,A,T38,F11.6)')
     &               VARNAM(ISQUASH(IUNIQUE(I))),
     &               RTMP(ISQUASH(IUNIQUE(I)))
               END DO
            end if
         END IF
         WRITE(LUOUT,735)
 735  FORMAT(80('-'))
      END IF

c ----------------------------------------------------------------------

cSSS 3431 continue

C GET ATOMIC MASSES, ATOMIC NUMBERS FROM PERIODIC TABLE SUBROUTINE
C
      CALL PERTABLE
C
 3431 continue
C
C FOR FINDIF CALCULATIONS, READ IN NEW CARTESIAN COORDINATES AND
C TRANSFORM THESE BACK INTO MODIFIED INTERNALS
C 
      IONE = 1
      CALL IGETREC(-1,'JOBARC','PASS1   ',IONE,INWFND)
      IF (INWFND.EQ.1) THEN
         XYZIN = .TRUE.
         IFLAGS(68) = 1
         CALL GETREC(20,'JOBARC','NEXTGEOM',3*NATOMS*IINTFP,Q)
      END IF

C COUNT NUMBER OF REAL ATOMS
C Also add a record that contains the sum of both real and dummy atoms.
C This is needed for external programs that use ACES II JOBARC records
C most of which are based on the total number of atoms, not just the
C number of real atoms. 01/2006, Ajith Perera.
C
      CALL IPUTREC(20,'JOBARC','ZMATATMS',IONE,NATOMS)
      NREAL = 0
      DO IATOM = 1, NATOMS
         IF (ATMASS(IATOM).NE.ZILCH) NREAL = NREAL + 1
      END DO
      CALL IPUTREC(20,'JOBARC','NREALATM',IONE,NREAL)

c   
c   Convert to Cartesian coords.
c
      call gmetry()
      print *,'Cartesian coordinates after gen_cart_coord:'
      do i = 1, 3*natoms
         print *,'i, q(i) ',i,q(i)
      enddo

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_M_EXPANDED_MATRIX
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDROWY,DDCOLY,
     +                      M,N,
     +                      ROWOFF,
     +                      MJUMP,LTRG,ZEROY,
     +                      X,
     +
     +                              Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_M_EXPANDED_MATRIX
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine forms the new m-expanded matrix Y of size
C                N x N from an input matrix X of size M x M. The
C                m-expansion of a matrix is only defined, if N is
C                divisible by M. The following example for m=x,y,z
C                makes the procedure clear:
C
C
C                                                   x y z x y z 
C                                                   -----------
C                                                x |a    |b    |
C                                                y |  a  |  b  |
C                  a  b     x,y,z expanded       z |    a|    b|
C                         ------------------>       ----------- 
C                  c  d      6 x 6 matrix        x |c    |d    |
C                                                y |  c  |  d  |
C                                                z |    c|    d|
C                                                   -----------
C
C                X matrix                            Y matrix
C
C
C                If the x,y,z basis functions are ordered such that
C                each x,y,z are consecutive, then we would have the
C                following m-expansion:
C
C
C                                                   x x y y z z 
C                                                   -----------
C                                                x |a b|   |   |
C                                                x |c d|   |   |
C                                                   -----------
C                  a  b     x,y,z expanded       y |   |a b|   |
C                         ------------------>    y |   |c d|   |
C                  c  d      6 x 6 matrix           -----------
C                                                z |   |   |a b|
C                                                z |   |   |c d|
C                                                   -----------
C
C                X matrix                            Y matrix
C
C
C                Thus the m-expansion can proceed via two possible
C                ways, depending on the m-order of the basis set.
C                For each Y matrix element:
C
C
C                 1) Spaced form:
C
C                       Y (r+[N/M]*[k-1],r+[N/M]*[l-1])  =  X (k,l)
C
C                 2) Consecutive form:
C
C                       Y (k+M*[r-1],l+M*[r-1])  =  X (k,l)
C
C
C                where r=1,[N/M]. In case N is not divisible by M,
C                the routine stops with an error message.
C
C                  Input:
C
C                    DDROWz,DDCOLz  =  declared dimensions of matrices
C                                      z = X and Y
C                              M,N  =  # of rows and columns of matrices
C                                      X and Y
C                           ROWOFF  =  row offset value for placing
C                                      the N rows of N x N matrix Y
C                            MJUMP  =  is true, if the m values in
C                                      the m-space are ordered such
C                                      that the same m values are
C                                      separated. Hence this needs
C                                      evaluation of the spaced
C                                      expansion. If false, the
C                                      consecutive expansion is done
C                             LTRG  =  is true, if only the lower
C                                      triangle of Y is wanted. In this
C                                      case also only the lower triangle
C                                      of X has to be passed. If false,
C                                      the full matrix Y is calculated
C                            ZEROY  =  is true, if the output Y matrix
C                                      needs to be zeroed first. This
C                                      is necessary because not all
C                                      elements of Y are addressed
C                                      during the m-expansion. If false,
C                                      the zeroing of Y is bypassed
C                                X  =  original matrix of size M x M
C
C                  Output:
C
C                                Y  =  m-expanded matrix of sixe N x N
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     MJUMP,LTRG,ZEROY

         INTEGER     DDROWX,DDCOLX,DDROWY,DDCOLY
         INTEGER     I,J,K,L,M,N,R
         INTEGER     NM
         INTEGER     ROWOFF

         DOUBLE PRECISION  XKL
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  X (1:DDROWX,1:DDCOLX)
         DOUBLE PRECISION  Y (1:DDROWY,1:DDCOLY)

         PARAMETER   (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check, if N is divisible by M and the dimensions
C                of X and Y.
C
C
         IF  (MOD (N,M).NE.0)  THEN
              WRITE (*,*) ' Cannot form expanded matrix! '
              WRITE (*,*) ' nlo__form_m_expanded_matrix '
              WRITE (*,*) ' N,M = ',N,M
              WRITE (1,*) ' Cannot form expanded matrix! '
              WRITE (1,*) ' nlo__form_m_expanded_matrix '
              WRITE (1,*) ' N,M = ',N,M
              STOP
         END IF

         IF  (M.GT.DDROWX .OR. M.GT.DDCOLX)  THEN
              WRITE (*,*) ' Dimensions of matrix X too small: '
              WRITE (*,*) ' nlo__form_m_expanded_matrix '
              WRITE (*,*) ' DDROWX,DDCOLX,M = ',DDROWX,DDCOLX,M
              WRITE (1,*) ' Dimensions of matrix X too small: '
              WRITE (1,*) ' nlo__form_m_expanded_matrix '
              WRITE (1,*) ' DDROWX,DDCOLX,M = ',DDROWX,DDCOLX,M
              STOP
         END IF

         IF  ((N+ROWOFF).GT.DDROWY .OR. N.GT.DDCOLY)  THEN
              WRITE (*,*) ' Dimensions of matrix Y too small: '
              WRITE (*,*) ' nlo__form_m_expanded_matrix '
              WRITE (*,*) ' DDROWY,DDCOLY,N = ',DDROWY,DDCOLY,N
              WRITE (1,*) ' Dimensions of matrix Y too small: '
              WRITE (1,*) ' nlo__form_m_expanded_matrix '
              WRITE (1,*) ' DDROWY,DDCOLY,N = ',DDROWY,DDCOLY,N
              STOP
         END IF
C
C
C             ...everything ok => form the m-expansion in desired form,
C                zeroing Y, if wanted.
C
C
         NM = N / M

         IF (LTRG) THEN
C
C
C             ...lower triangle of Y.
C
C
             IF (ZEROY) THEN
                 DO 10 J = 1,N
                 DO 10 I = J,N
                    Y (I+ROWOFF,J) = ZERO
   10            CONTINUE
             END IF

             IF (MJUMP) THEN
C
C
C             ...lower triangle m-expansion in spaced form.
C
C
                 J = 0
                 DO 100 L = 1,M
                    I = ROWOFF
                    DO 110 K = L,M
                       XKL = X (K,L)
                       DO 120 R = 1,NM
                          Y (I+R,J+R) = X (K,L)
  120                  CONTINUE
                       I = I + NM
  110               CONTINUE
                    J = J + NM
  100            CONTINUE
             ELSE
C
C
C             ...lower triangle m-expansion in consecutive form.
C
C
                 I = ROWOFF
                 J = 0
                 DO 200 R = 1,NM
                    DO 210 L = 1,M
                    DO 210 K = L,M
                       Y (I+K,J+L) = X (K,L)
  210               CONTINUE
                    I = I + M
                    J = J + M
  200            CONTINUE
             END IF

         ELSE
C
C
C             ...full matrix Y.
C
C
             IF (ZEROY) THEN
                 DO 20 J = 1,N
                 DO 20 I = 1,N
                    Y (I+ROWOFF,J) = ZERO
   20            CONTINUE
             END IF

             IF (MJUMP) THEN
C
C
C             ...full m-expansion in spaced form.
C
C
                 J = 0
                 DO 300 L = 1,M
                    I = ROWOFF
                    DO 310 K = 1,M
                       XKL = X (K,L)
                       DO 320 R = 1,NM
                          Y (I+R,J+R) = X (K,L)
  320                  CONTINUE
                       I = I + NM
  310               CONTINUE
                    J = J + NM
  300            CONTINUE
             ELSE
C
C
C             ...full m-expansion in consecutive form.
C
C
                 I = ROWOFF
                 J = 0
                 DO 400 R = 1,NM
                    DO 410 L = 1,M
                    DO 410 K = 1,M
                       Y (I+K,J+L) = X (K,L)
  410               CONTINUE
                    I = I + M
                    J = J + M
  400            CONTINUE
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE ATPT(PCOORD,NPTS,IPT,ACOORD,NATOM,ALPHA,
     $     PCOEFFN,MOMFCT,MAXANG,NTANGM,ITFCT,NBASP,PVAL,
     $     NBAS,PVAL2,IPCNT,APDX,APDY,
     $     APDZ,APDR,PCOEFSO,FINMO,FINSALC,IDORO,NORBOUTN)     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION IXPWR(15),IYPWR(15),IZPWR(15)
      DIMENSION PCOORD(3*(NPTS+1))
      DIMENSION ACOORD(3*NATOM)
      DIMENSION APDX(NATOM),APDY(NATOM),APDZ(NATOM),
     $     APDR(NATOM)
      DIMENSION ALPHA(ITFCT)
      DIMENSION PCOEFFN(ITFCT*NBASP),PVAL(ITFCT*NBASP)
      DIMENSION PVAL2(ITFCT*NBASP)
      DIMENSION MOMFCT(NATOM*NTANGM)
      DIMENSION IPCNT(NBAS)
      DIMENSION PCOEFSO(ITFCT*NBASP)
      DIMENSION FINMO(NBASP),FINSALC(NBASP)
C     
C     Calculate the distance from this point to each atom
       CALL DIS(IPT,ACOORD,NATOM,PCOORD,NPTS,APDR,
     $     APDX,APDY,APDZ)
C     
CXXXXXXXXX
C     
C     Calculate the value of each primitive,for each
C     molecular orbital and sale, at each point
C     
CXXXXXXXXX
C
       IF (IDORO.NE.0) THEN
          DO 5 J=0,(NORBOUTN-1)
             K=1
             N=0
             FINMO(J+1)=0.0
             DO 10 I=1,NATOM
C     
                DO 20 NUMSHL=1,MAXANG
C     
                   M=0
                   DO 30 IIII=1,NUMSHL
                      M=M+IIII
 30                CONTINUE
C     
                   CALL LAME(NUMSHL,IXPWR,IYPWR,IZPWR,M)
C     
                   N=N+M
C     
                   DO 50 IJ=1,M
                      TEMPVAL1=(APDX(I)**REAL(IXPWR(IJ)))*
     $                     (APDY(I)**REAL(IYPWR(IJ)))*
     $                     (APDZ(I)**REAL(IZPWR(IJ)))
                      DO 40 ML=1,MOMFCT(N-(M-1))
C     Calculate the value of each primitive,for each
C     molecular orbital, at each point
                         PVAL(J*ITFCT+K)=TEMPVAL1*PCOEFFN(J*ITFCT+K)*
     $                        DEXP(-ALPHA(K)*(APDR(I))**2)
                         FINMO(J+1)=FINMO(J+1)+PVAL(J*ITFCT+K)
C     IF (IPT.EQ.1) THEN
C     WRITE(*,*) "PVAL(",J*ITFCT+K,")=~,PVAL(J*ITFCT+K)
C     WRITE(*,*) "XPWR=",IXPWR(IJ),",","YPWR=",IYPWR(IJ),
C     & ",","ZPWR=",IZPWR(IJ)
C     END IF
                         K=K+1
 40                   CONTINUE
 50                CONTINUE
C     
 20             CONTINUE
 10          CONTINUE
 5        CONTINUE
C     
       END IF
C     
CXXXXXXX
C     
       IF (IDORO.NE.1) THEN
C     
          DO 105 J=0,(NBASP-1)
             K=1
             N=0
             FINSALC(J+1)=0.0
             DO 110 I=1,NATOM
C     
                DO 120 NUMSHL=1,MAXANG
C     
                   M=0
                   DO 130 IIII=1,NUMSHL
                      M=M+IIII
 130               CONTINUE
C     
                   CALL LAME(NUMSHL,IXPWR,IYPWR,IZPWR,M)
C     
                   N=N+M
C     
                   DO 150 IJ=1,M
                        TEMPVAL2=(APDX(I)**REAL(IXPWR(IJ)))*
     $                     (APDY(I)**REAL(IYPWR(IJ)))*
     $                     (APDZ(I)**REAL(IZPWR(IJ)))
                        DO 140 ML=1,MOMFCT(N-(M-1))
C     Calculate the value of each primitive,for each
C     SALC, at each point
                           PVAL2(J*ITFCT+K)=TEMPVAL2*PCOEFSO(J*ITFCT+K)*
     $                          DEXP(-ALPHA(K)*(APDR(I))**2)
                           FINSALC(J+1)=FINSALC(J+1)+PVAL2(J*ITFCT+K)
C     IF (IPT.EQ.1) THEN
C     WRITE(*,*) "PVAL2(",J*ITFCT+K,")=",PVAL2(J*ITFCT+K)
C     WRITE(*,*) "XPWR=",IXPWR(IJ),",","YPWR=",IYPWR(IJ),
C     $ ",","ZPWR=",IZPWR(IJ)
C     END IF
                           K=K+1
 140                    CONTINUE
 150                 CONTINUE
C     
 120              CONTINUE
 110           CONTINUE
 105        CONTINUE
         END IF
C     
C     
C     IF (IPT.EQ.1) THEN
C     WRITE(*,*) ''pval''
C     CALL PRINTMAT(PVAL,ITFCT,NBASP)
C     WRITE(*,*) "pval2~'
C     CALL PRINTMAT(PVAL2,ITFCT,NBASP)
C     END IF
C     
         RETURN
         END SUBROUTINE ATPT
         
         
         

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine send_master_barrier_msg()
c-----------------------------------------------------------------------------
c     Sends a "msg_master_barrier" msg to each other worker in the master's 
c     company, and waits for completion of all the messages.  This messaging
c     is done by the master, after he has received a message from each 
c     worker indicating that it has reached a sip_barrier or server_barrier.
c-----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      integer statuses(MPI_STATUS_SIZE,my_company_size)      
      integer requests(my_company_size)
      integer msg(5)
      integer i
      integer ierr
      integer company_comm, pst_get_company_comm

      if (dbg) then
         print *,'MASTER: send_master_barrier_msg() was entered.'
         call c_flush_stdout()
      endif

      if (my_company_size .eq. 1) return

      company_comm = pst_get_company_comm(me)

c-----------------------------------------------------------------------------
c   Send out the messages to each worker in my company.
c-----------------------------------------------------------------------------

      msg(1) = -8   ! signal is -8, send with tag 3456.
      do i = 1, my_company_size
         if (i-1 .ne. my_company_rank) then
            call mpi_isend(msg, 1, MPI_INTEGER, i-1,
     *                     3456, company_comm, requests(i), ierr)
         else
            requests(i) = MPI_REQUEST_NULL
         endif
      enddo

c-----------------------------------------------------------------------------
c   Wait for completion of the messages.
c-----------------------------------------------------------------------------

      if (dbg) print *,'Task ',me,' Master sent master_barrier_msg ',
     *   ' to each worker.'
      call mpi_waitall(my_company_size, requests, statuses, ierr)
      if (dbg) print *,'Task ',me,
     *   ' After mpi_waitall in send_master_barrier_msg, line ',
     *                     current_line
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine tensor_contraction(x1handle, x1_block, x1_ndx,
     *                      x2handle, x2_block, x2_ndx,
     *                      yhandle, y_block, yndx,
     *                      array_table, narray_table, 
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table, 
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
c--------------------------------------------------------------------------
c   Forms the tensor contraction of blocks x1 and x2, resulting in block y.
c   x1, x2, and y are the array_table entries for their respective arrays.
c   x1_block, x2_block, and y_block are the actual block indices of the
c   blocks to be summed.
c
c   The "cind" argument is an array of indices over which the contraction
c   is performed.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table
      integer nscalar_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table) 
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer x1handle, x2handle, yhandle
      integer x1_block, x2_block, y_block 
      integer x1_ndx, x2_ndx, yndx
      integer flopcount

      integer n1, n2, ny
      integer nw, iseg, range1, range2
      integer*8 iy, ix1, ix2, daddr
      integer*8 get_block_index, get_index_from_base
      integer stack
      integer i, j, k
      integer x1_type, x2_type, ytype
      double precision value

      double precision y(1), x1(1), x2(2)
#ifdef ALTIX
      pointer (ptry, y)
      pointer (ptrx1, x1)
      pointer (ptrx2, x2)
#else
      common y, x1, x2
#endif

      integer indy(8), segy(8), ya(8), yb(8)
      integer indx1(8), segx1(8), x1a(8), x1b(8)
      integer indx2(8), segx2(8), x2a(8), x2b(8)
      integer numy(8), numx1(8), numx2(8)
      integer nya(8), nyb(8), nx1a(8), nx1b(8), nx2a(8), nx2b(8)

      flopcount = 0

#ifdef ALTIX
      ptry = dshptr
      ptrx1 = dshptr
      ptrx2 = dshptr
#endif

c------------------------------------------------------------------------
c   Chcek for any scalar operands.
c------------------------------------------------------------------------

      x1_type = array_table(c_array_type,x1handle)
      x2_type = array_table(c_array_type,x2handle)
      ytype = array_table(c_array_type,yhandle)
      if (x1_type .eq. scalar_value .or.
     *    x2_type .eq. scalar_value .or.
     *    ytype .eq. scalar_value) then
         print *,'Error: tensor_contraction was called with ',
     *          'one or more scalar operands.'
         print *,'Operands are ',x1handle, x2handle, yhandle 
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Block contraction operation.
c-------------------------------------------------------------------------

      n1 = array_table(c_nindex, x1handle)
      n2 = array_table(c_nindex, x2handle)
      ny = array_table(c_nindex, yhandle)

c---------------------------------------------------------------------------
c   Get the array segments and ranges of each block.
c---------------------------------------------------------------------------

      do i = 1, ny
         indy(i) = array_table(c_index_array1+i-1, yhandle)
         segy(i) = index_table(c_current_seg,indy(i))
         call get_index_segment(indy(i), segy(i), segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, ya(i), yb(i))  
         numy(i) = yb(i) - ya(i) + 1
      enddo

      stack = array_table(c_array_stack,yhandle)
      iy = get_block_index(yhandle, y_block, stack, yndx, y, .true.)
      if (iy .eq. -1) then
         daddr = address_table(yhandle)
         if (daddr .eq. 0) then
            print *,'Error: Cannot form address for array ',yhandle,
     *                ' block ',y_block,'.'
            call dump_block_ids()
            call abort_job()
         endif

         iy = get_index_from_base(daddr, y, 2)

         do i = 1, ny
            nya(i) = array_table(c_index_range1+i-1,yhandle)
            nyb(i) = array_table(c_index_range2+i-1,yhandle)
         enddo
      else
         do i = 1, ny
            nya(i) = ya(i)
            nyb(i) = yb(i)
         enddo
      endif

      do i = 1, n1
         indx1(i) = array_table(c_index_array1+i-1, x1handle)
         segx1(i) = index_table(c_current_seg,indx1(i))
         call get_index_segment(indx1(i), segx1(i), segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, x1a(i), x1b(i))  
         numx1(i) = x1b(i) - x1a(i) + 1
      enddo

      stack = array_table(c_array_stack,x1handle)
      ix1 = get_block_index(x1handle, x1_block, stack, 
     *                      x1_ndx, x1, .true.)
      if (ix1 .eq. -1) then
         daddr = address_table(x1handle)
         if (daddr .eq. 0) then
            print *,'Error: Cannot form address for array ',x1handle,
     *                ' block ',x1_block,'.'
            call dump_block_ids()
            call abort_job()
         endif

         ix1 = get_index_from_base(daddr, x1, 2)
         do i = 1, n1
            nx1a(i) = array_table(c_index_range1+i-1,x1handle)
            nx1b(i) = array_table(c_index_range2+i-1,x1handle)
         enddo
      else
         do i = 1, n1
            nx1a(i) = x1a(i)
            nx1b(i) = x1b(i)
         enddo
      endif

      do i = 1, n2
         indx2(i) = array_table(c_index_array1+i-1, x2handle)
         segx2(i) = index_table(c_current_seg,indx2(i))
         call get_index_segment(indx2(i), segx2(i), segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, x2a(i), x2b(i))  
         numx2(i) = x2b(i) - x2a(i) + 1
      enddo

      stack = array_table(c_array_stack,x2handle)
      ix2 = get_block_index(x2handle, x2_block, stack,
     *                      x2_ndx, x2, .true.)
      if (ix2 .eq. -1) then
         daddr = address_table(x2handle)
         if (daddr .eq. 0) then
            print *,'Error: Cannot form address for array ',x2handle,
     *                ' block ',x2_block,'.'
            call dump_block_ids()
            call abort_job()
         endif

         ix2 = get_index_from_base(daddr, x2, 2)
         do i = 1, n2
            nx2a(i) = array_table(c_index_range1+i-1,x2handle)
            nx2b(i) = array_table(c_index_range2+i-1,x2handle)

         enddo
      else
         do i = 1, n2
            nx2a(i) = x2a(i)
            nx2b(i) = x2b(i)
         enddo
      endif

c     if (ny .ne. 4 .or. n1 .ne. 2 .or. n2 .ne. 2) then
c        print *,'Error: Improper array dimensions for ',
c    *            ' tensor_contraction: got ny, n1, n2 = ',
c    *            ny,n1,n2,' should be 4, 2, 2.'
c        print *,'Array handles: ',yhandle, x1handle, x2handle
c        print *,' y: ',yhandle,y_block, yndx
c        print *,' x1: ',x1handle, x1_block,x1_ndx
c        print *,' x2: ',x2handle, x2_block,x2_ndx
c        call abort_job()
c     endif
      if (ny .eq. 4 .and. n1 .eq. 2 .and. n2 .eq. 2) then

      call twork4222(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                     nya(3),nyb(3),nya(4),nyb(4),
     * 
     *                     ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),
     *                     ya(4),yb(4),indy,
     * 
     *                     x1(ix1),nx1a(1),nx1b(1), nx1a(2),nx1b(2),
     *                     x1a(1),x1b(1),x1a(2),x1b(2), indx1,
     * 
     *                     x2(ix2),nx2a(1),nx2b(1), nx2a(2),nx2b(2),
     *                     x2a(1),x2b(1),x2a(2),x2b(2),indx2,
     * 
     *                     flopcount)
         return 

      endif 

      if (ny .eq. 2 .and. n1 .eq. 1 .and. n2 .eq. 1) then 
      call twork2111(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                     ya(1),yb(1),ya(2),yb(2), indy,
     *                     x1(ix1),nx1a(1),nx1b(1), 
     *                     x1a(1),x1b(1), indx1,
     *                     x2(ix2),nx2a(1),nx2b(1), 
     *                     x2a(1),x2b(1),indx2,
     *                     flopcount)
         return

        endif


      if (ny .eq. 4 .and. n1 .eq. 3 .and. n2 .eq. 1) then

         call twork431(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                     nya(3),nyb(3),nya(4),nyb(4),
     *                     ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),
     *                     ya(4),yb(4),indy,
     *                     x1(ix1),nx1a(1),nx1b(1), nx1a(2),nx1b(2),
     *                     nx1a(3),nx1b(3),
     *                     x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *                     indx1,
     *
cVFL     *                     x2(ix2),nx2a(1),x2b(1), 
     *                         x2(ix2),nx2a(1),nx2b(1),
     *
     *                     x2a(1),x2b(1),indx2,
     *                     flopcount)
         return
      endif


      if (ny .eq. 6 .and. n1 .eq. 4 .and. n2 .eq. 2) then

      call twork642(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                    nya(3),nyb(3),nya(4),nyb(4),
     *                    nya(5),nyb(5),nya(6),nyb(6),
     * 
     *                    ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),
     *                    ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *                    indy,
     * 
     *                    x1(ix1),nx1a(1),nx1b(1), nx1a(2),nx1b(2),
     *                    nx1a(3),nx1b(3),nx1a(4),nx1b(4), 
     *                    x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3), 
     *                    x1a(4),x1b(4), indx1,
     *
     *                    x2(ix2),nx2a(1),nx2b(1), nx2a(2),nx2b(2),
     *                    x2a(1),x2b(1),x2a(2),x2b(2),indx2,
     * 
     *                    flopcount)
         return 

      endif 

      if (ny .eq. 6 .and. n1 .eq. 2 .and. n2 .eq. 4) then

      call twork642(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                    nya(3),nyb(3),nya(4),nyb(4),
     *                    nya(5),nyb(5),nya(6),nyb(6),
     * 
     *                    ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),
     *                    ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *                    indy,
     * 
     *                    x2(ix2),nx2a(1),nx2b(1), nx2a(2),nx2b(2),
     *                    nx2a(3),nx2b(3),nx2a(4),nx2b(4), 
     *                    x2a(1),x2b(1),x2a(2),x2b(2),x2a(3),x2b(3), 
     *                    x2a(4),x2b(4), indx2,
     *
     *                    x1(ix1),nx1a(1),nx1b(1), nx1a(2),nx1b(2),
     *                    x1a(1),x1b(1),x1a(2),x1b(2),indx1,
     * 
     *                    flopcount)
         return 

      endif 


      write(6,*) ' Cannot perform tensor contraction but am 
     *                 continuing anyway for now ' 


      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_derivative_integrals(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Multiplies the each sample of the block given by the array argument by 
c   diagonal eigenvalue matrix.  The eigenvalues matrix is not stored in
c   a 2-dimensional form, since it can be represented by a vector of
c   the diagonal elements.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'int_gen_parms.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer array, index, nindex, ierr
      integer blk, blkndx, seg
      integer nsend
      integer*8 indblk(12), get_block_data_index
      integer der_flags(12)
      integer stack
      
      integer me, my_comm_rank, comm

      integer val1(mx_array_index,12), val2(mx_array_index,12)
      double precision x(1)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (iptr, ibuf)
      pointer (xptr, x)
#else
      equivalence (ibuf, dbuf)
      common dbuf
#endif

      integer flag, iarray, handle

      integer dx1,dy1,dz1,dx2,dy2,dz2,dx3,dy3,dz3,dx4,dy4,dz4,
     *        derint_counter
      integer derint_array(12)
      common /derint/dx1,dy1,dz1,dx2,dy2,dz2,dx3,dy3,dz3,dx4,dy4,dz4,
     *               derint_counter
      equivalence (derint_array(1), dx1)

      if (derint_counter .ne. 12) then
         print *,'Error: compute_derivative_integrals mapping ',
     *     'is not set properly. Number of arrays is ',derint_counter
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Create a block for each of the arrays.
c---------------------------------------------------------------------------

      do iarray = 1, 12
         handle = derint_array(iarray)
         call create_current_block(handle,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., .false., blk, ierr)
         blkndx = ierr

         call get_block_computed_flag(handle, blk, blkndx, flag)
         if (flag .eq. 0) then
            call set_opblock(handle, blk, blkndx, op)
            call set_block_computed_flag(handle, blk, blkndx, 1)
         endif
                                                                                
         stack = array_table(c_array_stack,handle)
         indblk(iarray) = get_block_data_index(handle, blk, stack,
     *                                         blkndx, x)

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
         nindex = array_table(c_nindex, handle)

         do i = 1, nindex
            index = array_table(c_index_array1+i-1,handle)
            seg = index_table(c_current_seg,index)

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

            call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i,iarray), 
     *                             val2(i,iarray))
         enddo   ! index loop
      enddo      ! array loop

c--------------------------------------------------------------------------
c   Block ranges must match to be valid.
c--------------------------------------------------------------------------

      a1 = val1(1,1)
      a2 = val2(1,1)
      b1 = val1(2,1)
      b2 = val2(2,1)
      c1 = val1(3,1)
      c2 = val2(3,1)
      d1 = val1(4,1)
      d2 = val2(4,1)

      do i = 2, 12
         if (val1(1,i) .ne. a1 .or. val2(1,i) .ne. a2 .or.
     *       val1(2,i) .ne. b1 .or. val2(2,i) .ne. b2 .or.
     *       val1(3,i) .ne. c1 .or. val2(3,i) .ne. c2 .or.
     *       val1(4,i) .ne. d1 .or. val2(4,i) .ne. d2) then
            print *,'Error: Indices for all der_int_setup arrays ',
     *              'must match.'
            print *,'Array ',i,' does not match array 1.'
            call abort_job()
         endif
      enddo

c-----------------------------------------------------------------------------
c   Calculate the integral blocks.
c-----------------------------------------------------------------------------

      if (intpkg .eq. flocke_package) then
         do i = 1, 12
            do j = 1, 12
               der_flags(j) = 0
            enddo

            der_flags(i) = 1
            call compute_erd_2e_derv_integrals(a1,a2,b1,b2,c1,c2,d1,d2,
     *                 der_flags,
     *                 dbuf(dpkgscr),zmax, ibuf(ipkgscr),
     *                 dbuf(icoord),dbuf(ipcoeff),dbuf(ialpha),
     *                 ibuf(iccbeg), ibuf(iccend),
     *                 x(indblk(i)), nsend)
         enddo
      else
         print *,'Error: Invalid integral package for',
     *            ' derivative integrals: ',intpkg
         call abort_job() 
      endif

      return
      end

C ERROR HANDLER FOR I/O ROUTINES. SHOULD BE CALLED ON ALL I/O ERRORS.
C PRINTS OUT FATAL ERROR MESSAGE AND CALLS THE CRAPS EXIT HANDLER.
C
C INPUT:
C    ROUTINE - THE ROUTINE FROM WHICH IOERR IS CALLED [CHARACTER*(*)]
C    IUNIT   - THE UNIT ON WHICH THE I/O ERROR OCCURED.
C    IERTYP  - THE I/O ERROR NUMBER (FROM IOSTAT=XXX).

      SUBROUTINE IOERR(ROUTINE,IUNIT,IERTYP)
      IMPLICIT NONE
  
      CHARACTER*(*) ROUTINE
      INTEGER IUNIT, IERTYP

cYAU      WRITE(*,100) ROUTINE,IERTYP,IUNIT
cYAU100   FORMAT(T3,'@',A,'-F, I/O Error (IOSTAT = ',I3,') on Unit ',I3,'.')
      WRITE(*,100) ROUTINE
 100  FORMAT(/,' @',A,': An I/O Error has occurred.')
      CALL ERRMSG

      CALL ERREX
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE GENDIH(OPRTYP,OPRORD,OPRTIM,OPRAXS,NUMCLS,
     &                  NORDER,NTIME,TRNMAT)
C
C THIS ROUTINE GENERATES TRANSFORMATION MATRICES FOR DIHEDRAL
C  PLANES AND DIHEDRAL C2 ROTATION AXES.  THESE ARE NOT COINCIDENT
C  WITH THE CARTESIAN AXIS SYSTEM OF THE CANONICAL JODA ORIENTATION
C  AND HENCE ARE A PAIN IN THE ASS.  
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION TRNMAT(3,3),SCR1(3,3),SCR2(3,3)
      INTEGER OPRORD(2),OPRTIM(2),OPRAXS(2),NUMCLS(2)
      CHARACTER*1 OPRTYP(2)
      IERR=0
C
C GET TRANS. MAT. FOR THE V, RATHER THAN THE H OPERATION.
C
      CALL IDNMAT(SCR1,3,NTIME)
      CALL DOSYOP(OPRTYP(1),OPRORD(1),OPRTIM(1),OPRAXS(1),
     &            3,SCR1,TRNMAT,IERR,1)
C
C GET APPROPRIATE ROTATION MATRIX FOR TRANSFORMATION.
C
      NTIME=NTIME-1
      CALL IDNMAT(SCR1,3,NTIME)
      CALL DOSYOP('C',2*NORDER,1,3,3,SCR1,SCR2,IERR,1)
C
C TRANSFORM THE V OP TO A D OP.
C
      CALL UNITRY(SCR2,TRNMAT,TRNMAT,3)
C
C NOW FILL IN THE CLASS VECTORS WITH INFO ABOUT THIS OP.
C
      OPRTYP(2)=OPRTYP(1)
      OPRORD(2)=OPRORD(1)
      OPRAXS(2)=4
      OPRTIM(2)=OPRTIM(1)
      NUMCLS(2)=NUMCLS(1)
      RETURN
      END

      SUBROUTINE DBND(CARTCOORD,M,N,IBNDS,MAXREDUNCO,NRATMS,
     &                DERBMAT,IREDUNCO,TOTREDNCO)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DOUBLE PRECISION LU
      INTEGER TOTREDNCO,A,B,M,N,IBNDS,NRATMS,IREDUNCO

      DIMENSION CARTCOORD(3*NRATMS),VECU(3),IREDUNCO(4,MAXREDUNCO),
c    &          DERBMAT(9*NRATMS*NRATMS*TOTREDNCO),
     &          DERBMAT(3*NRATMS,3*NRATMS*TOTREDNCO)

      DATA MONE/-1/

c     PRINT *,'*****ENTERING DBOND*****'
      LU = DIST(CARTCOORD(3*N-2),CARTCOORD(3*M-2))
      CALL VEC(CARTCOORD(3*M-2),CARTCOORD(3*N-2),VECU,1)
CSSS      print *,'BONDS'
CSSS      print *,'vecu',vecu(1),vecu(2),vecu(3)

      DO 20 IA=1,2
         A=IREDUNCO(IA,IBNDS)
         DO 30 IB=1,2
            B=IREDUNCO(IB,IBNDS)
            DO 40 I=1,3
            DO 50 J=1,3
               T1=(MONE**DELTA(A,B))*(VECU(I)*VECU(J)-DELTA(I,J))/LU
c               DERBMAT((3*B-3)+J,3*NRATMS*(IBNDS-1)+(3*A-3)+I)=T1
               DERBMAT((3*A-3)+I,3*NRATMS*(IBNDS-1)+(3*B-3)+J)=T1
50          CONTINUE
40          CONTINUE
30       CONTINUE
20    CONTINUE

CSSS       PRINT *,'DERIVATIVE OF THE BMAT FOR ATOMS',M,O,N
CSSS       CALL OUTPUT(DERBMAT,1,3*NRATMS,3*NRATMS*(IBNDS-1)+1,
CSSS     &              3*NRATMS*(IBNDS-1)+3*NRATMS,3*NRATMS,
CSSS     &              3*NRATMS*TOTREDNCO,1)

      RETURN
      END

C
C THIS SUBROUTINE GETS FOR A FILE WITH THE DEFAULT NAME
C 'NAME1' THE FULL FILENAME WHICH IS THEN RETURNED ON
C 'NAME2'. IEND2 GIVES THE LENGTH (NUMBER OF CHARACTERS)
C OF THE FILE NAME RETURNED IN 'NAME2'.
cjp
cjp for mr-bwcc moints moabcd are affixed with .iref
cjp
C
CEND
C
      SUBROUTINE GFNAME(NAME1,NAME2,IEND2)
      IMPLICIT INTEGER (A-Z)
      LOGICAL YESNO
      CHARACTER*80 NAME2,A
      CHARACTER*(*) NAME1

cjp
#include "bwcc.com"

c ----------------------------------------------------------------------

      iLen = min(8,len(Name1))
      DO 10 I = 1, iLen
         IF (NAME1(I:I).EQ.' ') THEN
            IEND = I-1
            GO TO 11
         END IF
10    CONTINUE
      IEND = iLen
11    CONTINUE

      INQUIRE(FILE='FILES',EXIST=YESNO)
      IF (YESNO) THEN
         OPEN(UNIT=90,FILE='FILES',STATUS='OLD',FORM='FORMATTED')
         REWIND(UNIT=90)
 1000    READ(90,9000,END=2000) A
 9000    FORMAT(A80)
         IF (A(1:IEND).EQ.NAME1(1:IEND).AND.
     &       A(IEND+1:IEND+1).EQ.' '        ) THEN
            DO 20 I = IEND+2, 80
               IF (A(I:I).EQ.' ') THEN
                  IEND1 = I-1
                  GO TO 21
               END IF
20          CONTINUE
            CALL ERREX
21          CONTINUE
            IEND2 = IEND1-IEND+1
            NAME2(1:IEND2) = A(IEND+2:IEND1)
            close(90)
cjp            RETURN
            goto 3000
         END IF
         GO TO 1000
 2000    CONTINUE
      END IF

      NAME2(1:IEND) = NAME1(1:IEND)
      IEND2 = IEND
      close(90)

3000  continue
      if (isbwcc) then
      if (.not.masik) then
cjp   affix with iref number for mr-bwcc
      if(name1(1:iend).eq.'MOINTS' .or. name1(1:iend).eq.'MOABCD'
     +        .or. name1(1:iend).eq.'FOCKCD') then
cjp affix number to name2
      name2(iend2+1:iend2+1)='.'
cjp ASCII assumed
      name2(iend2+2:iend2+2)=char(48+iref/10)
      name2(iend2+3:iend2+3)=char(48+iref-10*(iref/10))
      iend2=iend2+3
      endif
      endif
      endif
      if (bwgossip) write(6,*)'@GFNAME',isbwcc,masik,iref,' '
     +,name1(1:iend),'->',name2(1:iend2)

c      print *, '@GFNAME: (debug) "',NAME1,'" is "',NAME2(1:IEND2),'"'

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_work_queue_entry(node, server_table, 
     *                                    nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of the server messages.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_stat.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      integer node
      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)

      integer msg_type, ierr
      integer i, array, ix, ptr, ptr2

      msg_type = server_msg(c_msg_type,node)

      if (msg_type .eq. server_request_msgtype) then

c-------------------------------------------------------------------------
c   REQUEST MESSAGE
c-------------------------------------------------------------------------

         call process_request_message(node, server_table, nserver_table)
      else  if (msg_type .eq. server_prepare_msgtype) then

c-------------------------------------------------------------------------
c   PREPARE MESSAGE
c--------------------------------------------------------------------------

         call process_prepare_message(node, server_table, nserver_table)
      else if (msg_type .eq. server_prepare_increment) then

c--------------------------------------------------------------------------
c   PREPARESUM MESSAGE
c--------------------------------------------------------------------------

         call process_preparesum_message(node, server_table, 
     *                       nserver_table)
      else if (msg_type .eq. server_prequest_msg) then

c-------------------------------------------------------------------------
c   PREQUEST MESSAGE
c-------------------------------------------------------------------------

         call process_prequest_message(node, server_table, 
     *                                 nserver_table)
      else if (msg_type .eq. server_quit_msgtype) then

c--------------------------------------------------------------------------
c   QUIT MESSAGE
c--------------------------------------------------------------------------

         server_msg(c_msg_state,node) = quit_state
      else if (msg_type .eq. server_barrier_signal) then

c--------------------------------------------------------------------------
c   BARRIER MESSAGE
c--------------------------------------------------------------------------

         barrier_in_progress = .true.
         barrier_seqno       = server_msg(c_msg_seqno,node)
         barrier_msg_count   = barrier_msg_count + 1

c--------------------------------------------------------------------------
c   Pull out the line number and translate it into a key for the server
c   data collection.
c--------------------------------------------------------------------------

         if (dbg) print *,'Server ',me,' Entering barrier logic, line ',
     *      server_msg(c_msg_tag,node), ' seqno ',
     *      barrier_seqno,' source ',server_msg(c_msg_source,node),
     *      ' barrier count = ',barrier_msg_count

         call prt_time('Server time')
         server_msg(c_msg_state,node) = null_state
      else if (msg_type .eq. server_copy_msg) then
c----------------------------------------------------------------------------
c   SERVER_COPY MESSAGE - server-side copy of an array to a new array.
c----------------------------------------------------------------------------
         call process_server_copy_message(node, server_table,
     *                 nserver_table)
      else if (msg_type .eq. server_delete_msg) then
c----------------------------------------------------------------------------
c   SERVER_DELETE MESSAGE - server-side delete of an array's blocks.  
c      The blocks are not actually removed, they simply become available
c      for use of other arrays. 
c----------------------------------------------------------------------------
         call process_server_delete_message(node, server_table,
     *                 nserver_table)
      else if (msg_type .eq. server_blocks_to_list_msg) then
         if (mpi_io_support) then
            call process_server_blocks_to_list_msg(node, server_table,
     *                 nserver_table)
         else
            call process_server_blocks_to_list_no_mpi_io(node, 
     *                 server_table, nserver_table)
         endif
      else if (msg_type .eq. server_list_to_blocks_msg) then
         if (mpi_io_support) then
            call process_server_list_to_blocks_msg(node, server_table,
     *                 nserver_table)
         else
            print *,'Error: Received read_list_to_blocks_msg, but ',
     *              'system does not support MPI_IO.'
            call server_abort_job(server_table, nserver_table)
         endif
      else if (msg_type .eq. server_checkpoint_msg) then
         call process_server_checkpoint_msg(node, server_table,
     *                 nserver_table)
      else if (msg_type .eq. server_restart_msg) then
         call process_server_restart_msg(node, server_table,
     *                 nserver_table)
      else if (msg_type .eq. server_commit_msg) then
         call process_server_commit_msg(node, server_table,
     *                 nserver_table)
      else
         print *,'Error: Invalid message type in server: ',
     *         msg_type
         call server_abort_job(server_table, nserver_table)
      endif
      
      return
      end

c This routine takes a string, which should contain a single valid integer,
c and returns the value of that integer. If an error occurs, err is set to:
c     1   if the string is empty
c     2   string contains a sign but no integer
c     3   integer part contains non-digit characters

c For those keen to regular expressions, valid integers are of the form:
c   '^ *[+-]? *[0-9]+ *$'

      subroutine str2int(str,val,err)
      implicit none
      character*(*) str
      integer val, err

      integer iachar, strlen, i, zref, ipm, j
      character*1 achar, spc, tab

      zref = iachar('0')
      spc = achar(32)
      tab = achar(9)

c   o Skip trailing whitespace.
      i = len(str)
      do while ((str(i:i).eq.spc.or.str(i:i).eq.tab)
     &          .and.i.gt.0)
         i = i-1
      end do
      strlen = i

c   o Skip leading whitespace.
      i = 1
      do while ((str(i:i).eq.spc.or.str(i:i).eq.tab)
     &          .and.i.le.strlen)
         i = i+1
      end do
      if (i.gt.strlen) then
         err = 1
         return
      end if

c   o Register sign and skip whitespace.
      ipm = 1
      if (str(i:i).eq.'-'.or.str(i:i).eq.'+') then
         if (str(i:i).eq.'-') ipm = -1
         i = i+1
         do while ((str(i:i).eq.spc.or.str(i:i).eq.tab)
     &             .and.i.le.strlen)
            i = i+1
         end do
         if (i.gt.strlen) then
            err = 2
            return
         end if
      end if

c   o Parse the integer.
      val = 0
      err = 0
      do while (i.le.strlen)
         j = iachar(str(i:i))-zref
         if (j.lt.0.or.j.gt.9) err = 3
         val = 10*val + j
         i = i+1
      end do
      val = ipm*val

c      print *, '@STR2INT: "',str(1:strlen),'" = ',val

      return
      end

c      program unittest
c      implicit none
c      integer i, ierr
c      call str2int("   ",i,ierr)
c      if (ierr.ne.1) stop "ERROR: passes empty string"
c      call str2int(" + ",i,ierr)
c      if (ierr.ne.2) stop "ERROR: passes lone sign"
c      call str2int(" - ",i,ierr)
c      if (ierr.ne.2) stop "ERROR: passes lone sign"
c      call str2int(" 1 0 ",i,ierr)
c      if (ierr.ne.3) stop "ERROR: passes interstitial whitespace"
c      call str2int(" 10 ",i,ierr)
c      if (i.ne.10) stop "ERROR: fails to recognize ' 10 '"
c      call str2int("-10",i,ierr)
c      if (i.ne.-10) stop "ERROR: fails to recognize '-10'"
c      call str2int("+ 10",i,ierr)
c      if (i.ne.10) stop "ERROR: fails to recognize '+ 10'"
c      call str2int(" 10",i,ierr)
c      print *, 'STR2INT unit test: all tests pass'
c      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_M_AVERAGED_MATRIX
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDROWY,DDCOLY,
     +                      N,M,
     +                      ROWOFF,
     +                      MJUMP,LTRG,ADD,
     +                      X,
     +
     +                              Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_M_AVERAGED_MATRIX
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine forms the m-averaged matrix of size
C                N/M x N/M from an input matrix of size N x N. By
C                m-averaged it is meant that m-diagonal elements 
C                of X are summed over all different m-values and
C                the average is formed. Pictorially this can be
C                seen as follows. For an example in which m=x,y,z:
C
C
C                x y z x y z 
C                -----------
C             x |a    |d    |
C             y |  b  |  e  |                    (a+b+c)/3  (d+e+f)/3
C             z |    c|    f|   x,y,z averaged   
C                -----------   --------------->
C             x |g    |j    |    2 x 2 matrix
C             y |  h  |  k  |                    (g+h+i)/3  (j+k+l)/3
C             z |    i|    l|
C                -----------
C
C
C                If the x,y,z basis functions are ordered such that
C                each x,y,z are consecutive, then we would have:
C
C
C                x x y y z z 
C                -----------
C             x |a b|   |   |
C             x |c d|   |   |                    (a+e+i)/3  (b+f+j)/3
C                -----------     x,y,z averaged
C             y |   |e f|   |   --------------->
C             y |   |g h|   |     2 x 2 matrix
C                -----------                     (c+g+k)/3  (d+h+l)/3
C             z |   |   |i j|
C             z |   |   |k l|
C                ----------- 
C
C
C
C                Thus the m-average is only defined, if N is divisible
C                by M and can be evaluated in the above two ways,
C                depending on the m-order of the basis set. For each
C                m-averaged matrix element:
C
C
C                 1) Spaced form, taking M subblock diagonal elements
C                    from the X matrix spaced by M:
C
C                                           M
C                       Y (i,j) =  (1/M) * sum  X (M*[i-1]+k,M*[j-1]+k)
C                                           k
C
C                 2) Consecutive form, taking M subblock elements
C                    from the X matrix:
C
C                                           M
C                       Y (i,j) =  (1/M) * sum  X (i+M*[k-1],j+M*[k-1])
C                                           k
C
C                where i,j=1,N/M. In case N is not divisible by M,
C                the routine stops with an error message.
C
C                  Input:
C
C                    DDROWz,DDCOLz  =  declared dimensions of matrices
C                                      z = X and Y
C                                N  =  size of square N x N matrix X
C                                M  =  size of m-space
C                           ROWOFF  =  row offset value for picking
C                                      the N rows of N x N matrix X
C                            MJUMP  =  is .true., if the m values in
C                                      the m-space are ordered such
C                                      that the same m values are
C                                      separated. Hence this needs
C                                      evaluation of the spaced average.
C                                      If false, the consecutive average
C                                      form is generated
C                             LTRG  =  is .true., if only the lower
C                                      triangle of Y is wanted. In this
C                                      case also only the lower triangle
C                                      of X has to be passed. If false,
C                                      the full matrix Y is calculated
C                              ADD  =  is .true., if the averaged matrix
C                                      is to be added to existing values
C                                      in the Y matrix.
C                                X  =  matrix of size N x N from which
C                                      the average is calculated
C
C                  Output:
C
C                                Y  =  averaged matrix of size N/M x N/M
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ADD,LTRG,MJUMP

         INTEGER     DDROWX,DDCOLX,DDROWY,DDCOLY
         INTEGER     I,J,K,L,M,N
         INTEGER     MSTEP,NSIZE
         INTEGER     ROWOFF

         DOUBLE PRECISION  FACTOR
         DOUBLE PRECISION  YIJ
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  X (1:DDROWX,1:DDCOLX)
         DOUBLE PRECISION  Y (1:DDROWY,1:DDCOLY)

         PARAMETER   (ZERO = 0.D0 )
         PARAMETER   (ONE  = 1.D0 )
C
C
C------------------------------------------------------------------------
C
C
C             ...check, if N is divisible by M and the dimensions
C                of X and Y.
C
C
         IF  (MOD (N,M).NE.0)  THEN
              WRITE (1,*) ' Cannot form average matrix! '
              WRITE (1,*) ' nlo__form_m_averaged_matrix '
              WRITE (1,*) ' N,M = ',N,M
              WRITE (*,*) ' Cannot form average matrix! '
              WRITE (*,*) ' nlo__form_m_averaged_matrix '
              WRITE (*,*) ' N,M = ',N,M
              STOP
         END IF

         NSIZE = N / M

         IF  ((N+ROWOFF).GT.DDROWX .OR. N.GT.DDCOLX)  THEN
              WRITE (1,*) ' Dimensions of matrix X too small: '
              WRITE (1,*) ' nlo__form_m_averaged_matrix '
              WRITE (1,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
              WRITE (*,*) ' Dimensions of matrix X too small: '
              WRITE (*,*) ' nlo__form_m_averaged_matrix '
              WRITE (*,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
              STOP
         END IF

         IF  (NSIZE.GT.DDROWY .OR. NSIZE.GT.DDCOLY)  THEN
              WRITE (1,*) ' Dimensions of matrix Y too small: '
              WRITE (1,*) ' nlo__form_m_averaged_matrix '
              WRITE (1,*) ' DDROWY,DDCOLY,NSIZE = ',DDROWY,DDCOLY,NSIZE
              WRITE (*,*) ' Dimensions of matrix Y too small: '
              WRITE (*,*) ' nlo__form_m_averaged_matrix '
              WRITE (*,*) ' DDROWY,DDCOLY,NSIZE = ',DDROWY,DDCOLY,NSIZE
              STOP
         END IF
C
C
C             ...everything ok => form the m-average in desired form.
C
C
         FACTOR = ONE / DFLOAT (M)

         IF (MJUMP) THEN
             IF (LTRG) THEN
                 IF (ADD) THEN
C
C
C             ...lower triangle m-average in spaced form, adding
C                result to existing Y matrix.
C
C
                     L = 0
                     DO J = 1,NSIZE
                        K = L + ROWOFF
                        DO I = J,NSIZE
                           YIJ = ZERO
                           DO MSTEP = 1,M
                              YIJ = YIJ + X (K+MSTEP,L+MSTEP)
                           END DO
                           Y (I,J) = Y (I,J) + FACTOR * YIJ
                           K = K + M
                        END DO
                        L = L + M
                     END DO
                 ELSE
C
C
C             ...lower triangle m-average in spaced form, creating
C                new Y matrix.
C
C
                     L = 0
                     DO J = 1,NSIZE
                        K = L + ROWOFF
                        DO I = J,NSIZE
                           YIJ = ZERO
                           DO MSTEP = 1,M
                              YIJ = YIJ + X (K+MSTEP,L+MSTEP)
                           END DO
                           Y (I,J) = FACTOR * YIJ
                           K = K + M
                        END DO
                        L = L + M
                     END DO
                 END IF
             ELSE
                 IF (ADD) THEN
C
C
C             ...full m-average matrix in spaced form, adding result
C                to existing Y matrix.
C
C
                     L = 0
                     DO J = 1,NSIZE
                        K = ROWOFF
                        DO I = 1,NSIZE
                           YIJ = ZERO
                           DO MSTEP = 1,M
                              YIJ = YIJ + X (K+MSTEP,L+MSTEP)
                           END DO
                           Y (I,J) = Y (I,J) + FACTOR * YIJ
                           K = K + M
                        END DO
                        L = L + M
                     END DO
                 ELSE
C
C
C             ...full m-average matrix in spaced form, creating new
C                Y matrix.
C
C
                     L = 0
                     DO J = 1,NSIZE
                        K = ROWOFF
                        DO I = 1,NSIZE
                           YIJ = ZERO
                           DO MSTEP = 1,M
                              YIJ = YIJ + X (K+MSTEP,L+MSTEP)
                           END DO
                           Y (I,J) = FACTOR * YIJ
                           K = K + M
                        END DO
                        L = L + M
                     END DO
                 END IF
             END IF
         ELSE
             IF (LTRG) THEN
                 IF (ADD) THEN
C
C
C             ...lower triangle m-average in consecutive form, adding
C                result to existing Y matrix.
C
C
                     DO J = 1,NSIZE
                     DO I = J,NSIZE
                        K = I + ROWOFF
                        L = J
                        YIJ = ZERO
                        DO MSTEP = 1,M
                           YIJ = YIJ + X (K,L)
                           K = K + NSIZE
                           L = L + NSIZE
                        END DO
                        Y (I,J) = Y (I,J) + FACTOR * YIJ
                     END DO
                     END DO
                 ELSE
C
C
C             ...lower triangle m-average in consecutive form, creating
C                new Y matrix.
C
C
                     DO J = 1,NSIZE
                     DO I = J,NSIZE
                        K = I + ROWOFF
                        L = J
                        YIJ = ZERO
                        DO MSTEP = 1,M
                           YIJ = YIJ + X (K,L)
                           K = K + NSIZE
                           L = L + NSIZE
                        END DO
                        Y (I,J) = FACTOR * YIJ
                     END DO
                     END DO
                 END IF
             ELSE
                 IF (ADD) THEN
C
C
C             ...full m-average matrix in consecutive form, adding
C                result to existing Y matrix.
C
C
                     DO J = 1,NSIZE
                     DO I = 1,NSIZE
                        K = I + ROWOFF
                        L = J
                        YIJ = ZERO
                        DO MSTEP = 1,M
                           YIJ = YIJ + X (K,L)
                           K = K + NSIZE
                           L = L + NSIZE
                        END DO
                        Y (I,J) = Y (I,J) + FACTOR * YIJ
                     END DO
                     END DO
                 ELSE
C
C
C             ...full m-average matrix in consecutive form, creating
C                new Y matrix.
C
C
                     DO J = 1,NSIZE
                     DO I = 1,NSIZE
                        K = I + ROWOFF
                        L = J
                        YIJ = ZERO
                        DO MSTEP = 1,M
                           YIJ = YIJ + X (K,L)
                           K = K + NSIZE
                           L = L + NSIZE
                        END DO
                        Y (I,J) = FACTOR * YIJ
                     END DO
                     END DO
                 END IF
             END IF
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE A2GET_ANG_TYPE(MAXATMS, NTOTPRIM, MAXSHELL, NSHL, 
     &                          NANGMOMSHL, NPRIMFUNSHL, IANGTYPE,
     &                          COORD, CNT_COORD)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DIMENSION NANGMOMSHL(MAXATMS, MAXSHELL), IP(20), FAC(9,9), 
     &          IOFFST(15), IANGTYPE(NTOTPRIM), NSHL(MAXATMS),
     &          NPRIMFUNSHL(MAXATMS,MAXSHELL), 
     &          CNT_COORD(3, NTOTPRIM), COORD(3*MAXATMS)
C      
      CALL SETRHF(FAC, IOFFST, IP)
C
      NFUNC_COUNT = 0
      DO IATMS = 1, MAXATMS
C                  
            DO ISHL = 1, NSHL(IATMS)
C
               IANGMOM = NANGMOMSHL(IATMS, ISHL)
               IPRIM   = NPRIMFUNSHL(IATMS, ISHL)
               IINTTYP = IOFFST(IANGMOM)
               ITYPE   = IINTTYP
C
               DO IMOMN = 1, IANGMOM
                  ITYPE = ITYPE + 1
                  DO NPRIM = 1, IPRIM
                     NFUNC_COUNT = NFUNC_COUNT + 1
                     IANGTYPE(NFUNC_COUNT) = ITYPE
C
                     ICOORD = (IATMS - 1)*3
                     DO IXYZ = 1, 3
                        CNT_COORD(IXYZ, NFUNC_COUNT) = 
     &                                  COORD(ICOORD + IXYZ)
                     ENDDO
   
                  ENDDO
               ENDDO
C
            ENDDO
      ENDDO
C

      Write(6,*)
      Write(6,"(a,I4)") "The number of primitive functions", 
     &                   NFUNC_COUNT 
      Write(6,*)
      write(6,"(a)") "The angular momentum type of each function"
      Write(6,"(6i4)") (IANGTYPE(i), i=1, NFUNC_COUNT)

      RETURN
      END
 

c This routine allocates a heap for processing RICs and creates pointers
c into the heap for various arrays.

      subroutine init_ric_heap
      implicit none

#include "machsp.com"
#include "ric_heap.com"
#include "mxatms.par"

      integer iNeed, ndx
      integer s_DerBMat, s_BMat, s_GMat, s_BTGInv

      integer vp(2)
      data vp /0,0/

c   o don't allocate memory more than once
      call c_memmove(vp,dRICHeap,ifltln)
      if (vp(1).ne.0.or.vp(2).ne.0) return

      iNeed = 0

c   o DerBMat: The derivative of the B-matrix for transforming the
c              Hessian between RICs and Cartesians.
      s_DerBMat = 9*mxatms*mxatms*maxredunco
      iNeed = iNeed + s_DerBMat

c   o BMat: The B-matrix for RIC/Cartesian transformations.
      s_BMat = 9*mxatms*mxatms
      iNeed = iNeed + s_BMat

c   o GMat: The G-matrix for RIC/Cartesian gradient transformations.
      s_GMat = 9*mxatms*mxatms
      iNeed = iNeed + s_GMat

c   o BTGInv: inv(trans(B)*G) required for transforming the Hessian.
      s_BTGInv = 3*mxatms*maxredunco
      iNeed = iNeed + s_BTGInv

      ndx = iintfp*iNeed
      call aces_malloc(ndx,dRICHeap,z_RICHeap)
      call c_memmove(vp,dRICHeap,ifltln)
      if (vp(1).eq.0.and.vp(2).eq.0) then
         print *, '@INIT_RIC_HEAP: Failed to allocate memory.'
         print *, '                need ',iNeed/1024/1024,' MB'
         call errex
      end if
      z_RICHeap = (z_RICHeap+iintfp-1)/iintfp
      ndx = z_RICHeap
#ifdef _DEBUG
      call c_memset(dRICHeap(z_RICHeap),255,ifltln*iNeed)
#endif

c   o DerBMat location
      z_DerBMat = ndx
      ndx = ndx + s_DerBMat

c   o BMat location
      z_BMat = ndx
      ndx = ndx + s_BMat

c   o GMat location
      z_GMat = ndx
      ndx = ndx + s_GMat

c   o BTGInv location
      z_BTGInv = ndx
      ndx = ndx + s_BTGInv

c      print *, '@INIT_RIC_HEAP: RIC HEAP INDICES'
c      print *, '                z_RICHeap = ',z_RICHeap
c      print *, '                z_DerBMat = ',z_DerBMat
c      print *, '                z_BMat    = ',z_BMat
c      print *, '                z_GMat    = ',z_GMat
c      print *, '                z_BTGInv  = ',z_BTGInv

      return
c     end subroutine init_ric_heap
      end

c This routine allocates a heap for processing RICs and creates pointers
c into the heap for various arrays.

      subroutine init_ric_heap
      implicit none



c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end






c ric_heap.com : begin

c This common block contains the heap address and array indices for
c processing RICs. New additions must be initialized to 1 in
c bd_ric_heap.F and set in init_ric_heap.F.

      external bd_ric_heap

      double precision dRICHeap(1)
      integer          z_RICHeap, z_DerBMat, z_BMat, z_GMat, z_BTGInv

      common /ric_heap_com/ dRICHeap,
     &                      z_RICHeap, z_DerBMat, z_BMat, z_GMat,
     &                      z_BTGInv
      save   /ric_heap_com/

c ric_heap.com : end
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

      integer iNeed, ndx
      integer s_DerBMat, s_BMat, s_GMat, s_BTGInv

      integer vp(2)
      data vp /0,0/

c   o don't allocate memory more than once
      call c_memmove(vp,dRICHeap,ifltln)
      if (vp(1).ne.0.or.vp(2).ne.0) return

      iNeed = 0

c   o DerBMat: The derivative of the B-matrix for transforming the
c              Hessian between RICs and Cartesians.
      s_DerBMat = 9*mxatms*mxatms*maxredunco
      iNeed = iNeed + s_DerBMat

c   o BMat: The B-matrix for RIC/Cartesian transformations.
      s_BMat = 9*mxatms*mxatms
      iNeed = iNeed + s_BMat

c   o GMat: The G-matrix for RIC/Cartesian gradient transformations.
      s_GMat = 9*mxatms*mxatms
      iNeed = iNeed + s_GMat

c   o BTGInv: inv(trans(B)*G) required for transforming the Hessian.
      s_BTGInv = 3*mxatms*maxredunco
      iNeed = iNeed + s_BTGInv

      ndx = iintfp*iNeed
      call aces_malloc(ndx,dRICHeap,z_RICHeap)
      call c_memmove(vp,dRICHeap,ifltln)
      if (vp(1).eq.0.and.vp(2).eq.0) then
         print *, '@INIT_RIC_HEAP: Failed to allocate memory.'
         print *, '                need ',iNeed/1024/1024,' MB'
         call errex
      end if
      z_RICHeap = (z_RICHeap+iintfp-1)/iintfp
      ndx = z_RICHeap

c   o DerBMat location
      z_DerBMat = ndx
      ndx = ndx + s_DerBMat

c   o BMat location
      z_BMat = ndx
      ndx = ndx + s_BMat

c   o GMat location
      z_GMat = ndx
      ndx = ndx + s_GMat

c   o BTGInv location
      z_BTGInv = ndx
      ndx = ndx + s_BTGInv

c      print *, '@INIT_RIC_HEAP: RIC HEAP INDICES'
c      print *, '                z_RICHeap = ',z_RICHeap
c      print *, '                z_DerBMat = ',z_DerBMat
c      print *, '                z_BMat    = ',z_BMat
c      print *, '                z_GMat    = ',z_GMat
c      print *, '                z_BTGInv  = ',z_BTGInv

      return
c     end subroutine init_ric_heap
      end

C VERY IMPORTANT ROUTINE. INITIALIZES ENVIRONMENT FOR A CRAPS MODULE.
C THIS MUST BE CALLED IN THE FIRST EXECUTABLE STATEMENT IN ALL PROGRAMS.
C
C TO USE THE AUTOMATIC MEMORY ALLOCATION, IENTRY MUST BE SET TO A
C VALUE OTHER THAN -1.

c#define _DEBUG_CRAPSI

      SUBROUTINE CRAPSI(ICORE,IUHF,IENTRY)
      IMPLICIT INTEGER (A-Z)

      INTEGER ICORE(1), tmp
      DOUBLE PRECISION X

c PARAMETERS
      INTEGER IONE
      PARAMETER (IONE=1)

c COMMON BLOCKS
#include "istart.com"
#include "flags.com"
#include "flags2.com"
#include "machsp.com"
#include "crapsx_time.com"
      integer iflag
      common /iflag/ iflag
      data    iflag /0/

c ----------------------------------------------------------------------

#ifdef _TRAPFPE
cYAU Enable floating-point exception handling if the compiler cannot.
      call trapfpe
#endif /* _TRAPFPE */

cjp setup stdout buffering in order to see output immediatelly
      call bufferlines

      NFLAGS  = 100
      NFLAGS2 = 500
      CALL MCHPRM

      call dumpja('I')
c      CALL GETREC(20,'JOBARC','IENDSTAT',IONE,ISTAT)
      CALL CHECKIN
      call wallclock(year_i,mon_i,mday_i,hour_i,min_i,sec_i)

      IF (IENTRY.NE.-1) THEN
         CALL GETREC(20,'JOBARC','IFLAGS  ',NFLAGS,IFLAGS)
         CALL GETREC(20,'JOBARC','IFLAGS2 ',NFLAGS2,IFLAGS2)

C ABACUS CAUSES SOME MEMORY PROBLEMS WHEN REQUIRING THE FULL CORE
C WE THEREFORE REDUCE THE REQUESTED CORE SIZE BY A CERTAIN AMOUNT
C BUT WE MAKE SURE THAT A MINIMUM IS ALWAYS ALLOCATED
C CALL CRAPSI THERFORE WITH IENTRY = 100
         IF (IENTRY.EQ.100) THEN
            IENTRY=0
            MEM=IFLAGS(36)
C         o set to run efficiently in the 8MW queue of a YMP
            MEMMIN=MIN(3500000,IFLAGS(36))
            MEMMAX=MAX(MEMMIN,IFLAGS(36)-3000000)
         ELSE
            MEMMAX=IFLAGS(36)
         END IF

c      o allocate memory once (iflag is only used by BWCC currently)
         if (iflag.eq.0) then
            call aces_malloc(memmax,i0)
            if (i0.eq.-1) then
               write(*,*) '@CRAPSI: Request for ',MEMMAX,
     &                    ' words of memory failed.'
               call errex
            end if
#ifdef _DEBUG_CRAPSI
            write(*,*) '@CRAPSI: memmax = ',memmax
            write(*,*) '         i0     = ',i0
#endif /* _DEBUG_CRAPSI */
            iflag=1
         end if

C Make sure that I0 starts on a double precision word boundary

#ifdef _UNICOS
         I0 = I0 + IINTFP - MOD(I0,IINTFP) - 1
#else
C Coded by Marcel Nooijen and incorporated by Ajith
         IPASS = 0
 100     tmp=(LOC(ICORE(I0)) - LOC(X))
         IF (MOD(tmp, IFLTLN) .NE. 0) THEN
            IF (IPASS .GE. IINTFP) THEN
               WRITE(6, *) '@CRAPSI: Memory alignment failed.'
               CALL ERREX
            END IF
            I0     = I0 + 1
            MEMMAX = MEMMAX - 1
            IPASS  = IPASS + 1
            GO TO 100
         END IF
         tmp = (LOC(ICORE(I0)) - LOC(X))
         IF (MOD(tmp,IFLTLN) .NE. 0) THEN
            WRITE(6,*) '@CRAPSI: Memory alignment problem persists.'
            CALL ERREX
         END IF
#endif /* _UNICOS */

         CALL POPCORN(MEMMAX)
      ELSE
         I0=1
      END IF

      CALL GETSTF(ICORE(I0),IUHF,IENTRY)

      RETURN
      END

      subroutine do_oed_to_vmol(nbasis, erd_index, scalars, ovlp_oed,
     &                          ovlp_vmol)
c-----------------------------------------------------------------------------
c   Using the shell angular momentum and basis function information, this
c   subroutine calculates an array which maps the ACES integral order to 
c   the ERD integral order.  This array may be used to re-order a block 
c   of integrals calculated by the ERD package into a format corresponding
c   to the ACES (VMOL-based) integrals.
c
c-----------------------------------------------------------------------------
      implicit none

      integer erd_index(*)
      double precision scalars(*)
      double precision ovlp_vmol(nbasis,nbasis),Ovlp_oed(nbasis,nbasis)

      integer i, j, k, ii, jj, kk  
      integer nbasis, n


      Write(6,"(6(1x,i5))") (erd_index(i), i=1, nbasis)
      Write(6,*)
      Write(6,"(6(1x,F10.5))") (scalars(i), i=1, nbasis)


      do i = 1, nbasis
         do j = 1, nbasis 

             ii = erd_index(i) 

             Ovlp_vmol(ii,j) = ovlp_oed(i,j)/scalars(ii)







      enddo
      enddo


      write(6,"(a)") "The reordered and renormalized SCF veactors"
      call output(ovlp_vmol, 1, nbasis, 1, nbasis, nbasis, nbasis,1)

      return
      end

      SUBROUTINE SQUSH(VEC,LEN)
C
C SUBROUTINE USED TO "SQUASH" R VECTOR.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(LEN)
      VEC(1)=VEC(4)
      VEC(2)=VEC(7)
      VEC(3)=VEC(8)
      DO 10 I=4,LEN-6
      VEC(I)=VEC(I+6)
 10   CONTINUE
      CALL ZERO(VEC(MAX(LEN-5,2)),6)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE SIAZ(VEC,ROT,IAXIS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(3),ROT(3,3),RM(3,3)
C 
C DETERMINE LENGTH OF VECTOR.
C
      DIS=DSQRT(xdot(3,VEC,1,VEC,1))
C
C RETURNS ROTATION MATRIX NEEDED TO PLACE VECTOR
C   VEC ALONG THE X (IAXIS=1), Y (IAXIS=2) OR Z (IAXIS=3)
C   AXIS.  TAIL OF VECTOR IMPLICITLY ASSUMED TO BE AT 
C   THE ORIGIN.
C
      IF(IAXIS.EQ.3)THEN
        ARG1=VEC(3)/DIS
        IF(DABS(ARG1).GT.1.D0)ARG1=ARG1/DABS(ARG1)
        AZIM=-1.D0*DACOS(ARG1)
        DISP=DSQRT(xdot(2,VEC,1,VEC,1))
        IF(ABS(DISP).LT.1.D-10)THEN
         CALL ROTM(3,0.0D0,1,ROT)
         RETURN
        ENDIF
        ARG2=VEC(1)/DISP
        IF(DABS(ARG2).GT.1.D0)ARG2=ARG2/DABS(ARG2)
        IF(DABS(DABS(ARG2)-1.D0).LT.1.D-10)ARG2=SIGN(1.D0,ARG2)
        ANG1=DACOS(ARG2)
        ANG1=SIGN(ANG1,-1.D0*VEC(2))
        CALL ROTM(3,ANG1,0,RM)
        CALL ROTM(2,AZIM,0,ROT)
        CALL MODMATMUL(ROT,RM,ROT,3,3,3,3,3,3)
      ELSEIF(IAXIS.EQ.1)THEN
        ARG1=VEC(1)/DIS
        IF(DABS(ARG1).GT.1.D0)ARG1=ARG1/DABS(ARG1)
        AZIM=-1.D0*DACOS(ARG1)
        DISP=DSQRT(xdot(2,VEC(2),1,VEC(2),1))
        IF(ABS(DISP).LT.1.D-10)THEN
         CALL ROTM(3,0.0D0,1,ROT)
         RETURN
        ENDIF
        ARG2=VEC(2)/DISP
        IF(DABS(ARG2).GT.1.D0)ARG2=ARG2/DABS(ARG2)
        IF(DABS(DABS(ARG2)-1.D0).LT.1.D-10)ARG2=SIGN(1.D0,ARG2)
        ANG1=DACOS(ARG2)
        ANG1=SIGN(ANG1,-1.D0*VEC(3))
        CALL ROTM(1,ANG1,0,RM)
        CALL ROTM(3,AZIM,0,ROT)
        CALL MODMATMUL(ROT,RM,ROT,3,3,3,3,3,3)
      ELSEIF(IAXIS.EQ.2)THEN
        ARG1=VEC(2)/DIS
        IF(DABS(ARG1).GT.1.D0)ARG1=ARG1/DABS(ARG1)
        AZIM=-1.D0*DACOS(ARG1)
        DISP=DSQRT(DIS**2-VEC(2)**2)
        IF(ABS(DISP).LT.1.D-10)THEN
         CALL ROTM(3,0.0D0,1,ROT)
         RETURN
        ENDIF
        ARG2=VEC(3)/DISP
        IF(DABS(ARG2).GT.1.D0)ARG2=ARG2/DABS(ARG2)
        IF(DABS(DABS(ARG2)-1.D0).LT.1.D-10)ARG2=SIGN(1.D0,ARG2)
        ANG1=DACOS(ARG2)
        ANG1=SIGN(ANG1,-1.D0*VEC(1))
        CALL ROTM(2,ANG1,0,RM)
        CALL ROTM(1,AZIM,0,ROT)
        CALL MODMATMUL(ROT,RM,ROT,3,3,3,3,3,3)
       ENDIF
       RETURN
       END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sip_server_work()
      implicit none
      include 'server.h'
      include 'parallel_info.h'
      integer*8 iserver_table, get_index_from_base 
      integer i
      integer itab(1)
#ifdef ALTIX
      include 'sheap.h'
    
      pointer (iptr, itab)
#endif

c---------------------------------------------------------------------------
c   Find the location of the server table in memory.
c---------------------------------------------------------------------------

#ifdef ALTIX
      iptr = ishptr
#endif
      iserver_table = get_index_from_base(server_table_base_addr, 
     *                                    itab, 1)

c-----------------------------------------------------------------------------
c   Enter the server work routine.
c-----------------------------------------------------------------------------

      call sip_server(itab(iserver_table), nserver_table_entries)

c------------------------------------------------------------------------------
c   Remove the server's files.
c------------------------------------------------------------------------------

      do i = 1, nserver_blocksizes
         call f_deletefile(server_filename(i), server_unit(i))
      enddo
      return
      end

      subroutine sip_server(server_table, nserver_table)
c--------------------------------------------------------------------------
c   Driver routine for the sip data server.
c--------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_ckpt_data.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
      include 'server_delay.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table) 

      integer nactive, i, j, n, next, imsg, nind
      integer iblock, msgbuffer
      integer ierr, ptr
      integer ifile
      logical flag
      integer status(MPI_STATUS_SIZE)
      integer status2(MPI_STATUS_SIZE)
      integer msg(100)
      integer*8 msg8(50)
      equivalence (msg, msg8)

      integer*8 indblk, get_index_from_base
      integer lendata
      integer array, size, diskloc, nbackup_threshold
      integer source, tag
      integer flagval
      integer comm
      integer pst_get_company_comm
      integer find_server_table_ptr
      integer count
      integer str_trimlen

      double precision x(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, x)
      pointer (iptr, ibuf)
#else
      common x
      equivalence (ibuf, x)
#endif
      integer signal
      double precision tmsg, tmsg_sq, trestore

      save signal

#ifdef ALTIX
      dptr = dshptr
      iptr = ishptr

      server_msgs_before_delay = -1
#else
      server_msgs_before_delay = -1
#endif
      delay_flag = 0
      server_msg_count = 0

      nserved_arrays = 0
      do i = 1, nserver_table

c---------------------------------------------------------------------------
c   Create a table of served arrays.
c---------------------------------------------------------------------------

         array = server_table(c_server_array,i)
         do j = 1, nserved_arrays
            if (served_array_table(j) .eq. array) then
               served_numblocks(j) = served_numblocks(j) + 1
               go to 10
            endif
         enddo

c----------------------------------------------------------------------------
c   Create entries for a new array.
c---------------------------------------------------------------------------

         nserved_arrays = nserved_arrays + 1
         served_array_table(nserved_arrays)  = array
         served_array_status(nserved_arrays) = 0
         served_array_entry(nserved_arrays)  = i
         served_numblocks(nserved_arrays)    = 1
   10    continue

c---------------------------------------------------------------------------
c   Fill in the blocksize entry for each block in the server table.
c---------------------------------------------------------------------------

         nind = server_table(c_server_nind,i)
         n = 1
         do j = 1, nind
            n = n * (server_table(c_server_esegs+j-1,i) - 
     *               server_table(c_server_bsegs+j-1,i) + 1)
         enddo
         server_table(c_server_size,i) = n
         server_table(c_server_iblk,i) = -99999999

c---------------------------------------------------------------------------
c   Determine the appropriate file on which to store this block.
c---------------------------------------------------------------------------

         do j = 1, nserver_blocksizes
            if (server_blocksizes(j) .ge. n) then
               server_table(c_server_file,i) = j
               go to 50
            endif
         enddo
   50 continue
      enddo

      nactive = 0
      nbackup_threshold = nserver_memblocks / 10
  100 continue

      if (nactive .eq. 0 .and.
     *    delay_flag .eq. 1) then
         delay_flag = 0
         server_msg_count = 0
      endif

c---------------------------------------------------------------------------
c   Do we have a message buffer available?
c---------------------------------------------------------------------------

      if (nactive .lt. nmessage_buffers) then
         
c----------------------------------------------------------------------------
c   Probe for a "ready" message from any source.
c----------------------------------------------------------------------------

         call mpi_iprobe(MPI_ANY_SOURCE, server_readytag, 
     *                   MPI_COMM_WORLD, 
     *                   flag, status, ierr)

  500    continue
         if (flag) then
            source = status(MPI_SOURCE)
            call mpi_get_count(status, MPI_INTEGER, count, ierr)

c--------------------------------------------------------------------------
c  Receive the new message.
c--------------------------------------------------------------------------

            nactive = nactive + 1
            do i = 1, count
               msg(i) = 0
            enddo
    
            call mpi_recv(msg, count, MPI_INTEGER,
     *                    source,server_readytag,
     *                    MPI_COMM_WORLD, status2,ierr)
            if (msg(1) .lt. 0) then
               print *,'Server ',me,' Recieved invalid message: ',
     *              (msg(j),j=1,count)
               call server_abort_job(server_table, nserver_table) 
            endif

            server_seqno = server_seqno + 1 

c--------------------------------------------------------------------------
c   Set delay flag if necessary.
c--------------------------------------------------------------------------

            server_msg_count = server_msg_count + 1
            if (.not. barrier_in_progress .and. 
     *           delay_flag .eq. 0) then
               if (server_msg_count .eq. server_msgs_before_delay)
     *             delay_flag = 1
            endif

c--------------------------------------------------------------------------
c   Decode the message into a message node.
c-------------------------------------------------------------------------

            call pop_work_node(imsg)
            server_msg(c_msg_type,imsg) = msg(1)
            server_msg(c_msg_array,imsg) = msg(2)
            server_msg(c_msg_source,imsg)   = source
            server_msg(c_msg_nind,imsg)     = msg(3)
            server_msg(c_msg_tag,imsg)      = msg(4)
            server_msg(c_msg_seqno,imsg)    = server_seqno
            server_msg(c_msg_current_line,imsg) = msg(5)
            server_msg(c_msg_stat_key,imsg)     = msg(6)
            server_msg(c_msg_iblk,imsg)         = msg(7) 
            if (barrier_in_progress) barrier_seqno = server_seqno

            nind = server_msg(c_msg_nind,imsg)
            if (nind .lt. 1 .or. nind .gt. mx_array_index) then
               nind = 0
               server_msg(c_msg_stptr,imsg) = 0
               server_msg(c_msg_size,imsg)  = 0
            else
               next = 7+mx_array_index
               n = 1
               do i = 1, nind
                  server_msg(c_msg_bsegs+i-1,imsg) = msg(next)
                  server_msg(c_msg_esegs+i-1,imsg) = msg(next+1)
                  n = n * (msg(next+1)-msg(next)+1)
                  next = next + 2
               enddo

               server_msg(c_msg_size,imsg)   = n
            endif

            server_msg(c_msg_state,imsg)  = begin_state
            server_msg(c_msg_cause, imsg) = null_cause
            server_msg(c_msg_memptr,imsg) = 0
            server_msg(c_msg_flag,imsg)   = 0

            if (msg(1) .eq. server_blocks_to_list_msg .or. 
     *          msg(1) .eq. server_list_to_blocks_msg) then
               blk_to_list_offset(1,imsg) = msg8(2)
               blk_to_list_offset(2,imsg) = msg8(3)
               blk_to_list_offset(3,imsg) = msg8(4)
            endif

c------------------------------------------------------------------------
c   Decode a second set of indices/segment ranges if the messsage is 
c   a partial request (prequest).
c-------------------------------------------------------------------------

            if (msg(1) .eq. server_prequest_msg) then
               next = 7 + 4 * mx_array_index
               do i = 1, nind
                  server_msg(c_msg_bsegs2+i-1,imsg) = msg(next)
                  server_msg(c_msg_esegs2+i-1,imsg) = msg(next+1)
                  next = next + 2
               enddo
            endif

c--------------------------------------------------------------------------
c   Perform the server array checking to maintain data integrity.
c--------------------------------------------------------------------------

            call check_for_server_array(imsg, server_table, 
     *                                  nserver_table)

c--------------------------------------------------------------------------
c   Find the data block in the server_table.
c--------------------------------------------------------------------------

            if (nind .gt. 0) then
               ptr = find_server_table_ptr(imsg,server_table,
     *                                     nserver_table, .true.)
               server_msg(c_msg_stptr,imsg) = ptr
               server_table(c_server_iblk,ptr) = msg(7)   ! iblk entry
            endif

 
c---------------------------------------------------------------------------
c   Add to performance stats.
c---------------------------------------------------------------------------

            if (do_stats) then
               stat_key = server_msg(c_msg_stat_key,imsg)
               if (stat_key .gt. 0) then
                  if (server_msg(c_msg_type,imsg) .eq. 
     *                               server_prepare_msgtype) then    
                     sstat_nprep(stat_key) = sstat_nprep(stat_key) + 1
                  else if (server_msg(c_msg_type,imsg) .eq.
     *                               server_prepare_increment) then
                     sstat_nprepsum(stat_key) = sstat_nprepsum(stat_key) 
     *                                        + 1
                  else if (server_msg(c_msg_type,imsg) .eq.
     *                               server_request_msgtype) then
                     sstat_nreq(stat_key) = sstat_nreq(stat_key) + 1
                  else if (server_msg(c_msg_type,imsg) .eq.
     *                               server_prequest_msg) then
                     sstat_npreq(stat_key) = sstat_npreq(stat_key) + 1
                  endif

                  sstat_msg_time1(imsg) = mpi_wtime()
               endif
            endif

             call insert_work_node(imsg)   ! add to tail of work queue
         endif   ! flag
      endif

c----------------------------------------------------------------------------
c   Grab the head of the work queue entry.
c---------------------------------------------------------------------------

      call remove_work_head(imsg)
      if (imsg .le. 0) then
         if (barrier_in_progress .and.
     *       .not. flag .and.
     *       barrier_msg_count .eq. nbarrier_msgs) then

c---------------------------------------------------------------------------
c   Barrier exit logic.
c---------------------------------------------------------------------------

            if (.not. flag) then

c---------------------------------------------------------------------------
c   Sleep, then do 1 more probe just to make sure there are no more 
c   messages waiting.
c---------------------------------------------------------------------------

#ifndef __crayx1
               call f_usleep(1000)
               call mpi_iprobe(MPI_ANY_SOURCE, server_readytag,
     *                   MPI_COMM_WORLD,
     *                   flag, status, ierr)
               if (flag) go to 500
#endif
               
               barrier_in_progress = .false.
               barrier_seqno       = 0
               barrier_msg_count   = 0

c---------------------------------------------------------------------------
c   Clear delay flag settings.
c---------------------------------------------------------------------------

               delay_flag = 0
               server_msg_count = 0

c---------------------------------------------------------------------------
c   Clear all the array statuses.
c---------------------------------------------------------------------------

               do i = 1, nserved_arrays
                  served_array_status(i) = 0
               enddo

c--------------------------------------------------------------------------
c   Send an acknowledgement message back to the sender of the barrier.
c   The message tag is a server_barrier_signal to avoid confusion with 
c   other messages being sent back from the server.
c--------------------------------------------------------------------------

               signal = server_barrier_signal
               call mpi_send(signal, 1, MPI_INTEGER,
     *                 0, server_barrier_signal, mpi_comm_world, 
     *                 status, ierr)
               call prt_time('Server leaving barrier mode')
            endif
         else

c--------------------------------------------------------------------------
c   Clear delay flag if necessary.
c--------------------------------------------------------------------------

            if (delay_flag .eq. 1) then
               if (.not. barrier_in_progress .and. 
     *             .not. flag) then

c---------------------------------------------------------------------------
c   We are not in a barrier mode, all work in the message buffers has 
c   been cleared, and the probe indicates no messages waiting.  Thus, we
c   may clear the delay flag for this server.
c---------------------------------------------------------------------------

                  delay_flag = 0
                  server_msg_count = 0
               endif
            endif 
         endif   ! barrier_in_progress, etc...
      else

c----------------------------------------------------------------------------
c   Perform the next step in processing this data.
c----------------------------------------------------------------------------

         call process_work_queue_entry(imsg, server_table, 
     *                                  nserver_table)
         if (server_msg(c_msg_state,imsg) .eq. null_state) then

c---------------------------------------------------------------------------
c   Message is completed.  Capture performance data.
c---------------------------------------------------------------------------

            if (do_stats .and. stat_key .gt. 0) then
               tmsg = mpi_wtime() - sstat_msg_time1(imsg)

               if (server_msg(c_msg_type,imsg) .eq.
     *                               server_prepare_msgtype) then
                  sstat_tprep(stat_key) = sstat_tprep(stat_key) + 
     *                                     tmsg
                  sstat_tprep2(stat_key) = sstat_tprep2(stat_key) +
     *                                     tmsg_sq
               else if (server_msg(c_msg_type,imsg) .eq.
     *                               server_prepare_increment) then
                  sstat_tprepsum(stat_key) = 
     *                     sstat_tprepsum(stat_key) + tmsg
                  sstat_tprepsum2(stat_key) =
     *                     sstat_tprepsum2(stat_key) + tmsg_sq
               else if (server_msg(c_msg_type,imsg) .eq.
     *                               server_request_msgtype) then
                  sstat_treq(stat_key) = sstat_treq(stat_key) + tmsg
                  sstat_treq2(stat_key) = 
     *                   sstat_treq2(stat_key) + tmsg_sq
               else if (server_msg(c_msg_type,imsg) .eq.
     *                               server_prequest_msg) then
                  sstat_tpreq(stat_key) = sstat_tpreq(stat_key) + tmsg
                  sstat_tpreq2(stat_key) = 
     *                   sstat_tpreq2(stat_key) + tmsg_sq
               endif
            endif

            call push_work_node(imsg)   ! thru with this one.
            nactive = nactive - 1

c---------------------------------------------------------------------------
c   Reset the busy flag on both the data buffer (if any) and the msg buffer.
c---------------------------------------------------------------------------
               
               iblock = server_msg(c_msg_memptr,imsg)
               if (iblock .gt. 0) then
                  ptr = server_table_ptr(iblock)
                  if (ptr .gt. 0)  then
                    flagval = and(server_table(c_server_flags,ptr),
     *                         server_busy_flag)
                    if (flagval .ne. 0) 
     *                  server_table(c_server_flags,ptr) = 
     *                   xor(server_busy_flag,
     *                   server_table(c_server_flags,ptr))
                     server_table(c_server_busy_node,ptr) = 0
                  endif
               endif
     
               msgbuffer = server_msg(c_msg_msgbuffer,imsg)
               if (msgbuffer .gt. 0) then
                  ptr = server_table_ptr(msgbuffer)
                  if (ptr .gt. 0) then
                    flagval = and(server_table(c_server_flags,ptr),
     *                         server_busy_flag)
                    if (flagval .ne. 0)
     *                 server_table(c_server_flags,ptr) =
     *                 xor(server_busy_flag,
     *                 server_table(c_server_flags,ptr))
                     server_table(c_server_busy_node,ptr) = 0
                  endif
               endif 
         else if (server_msg(c_msg_state,imsg) .eq. quit_state) then
            go to 1000                  ! job is done
         else
        
c------------------------------------------------------------------------
c   Check the msg_flag field of the node to see if a restore
c   is required.
c------------------------------------------------------------------------

            if (server_msg(c_msg_cause,imsg) .eq. restore_cause) then 

c------------------------------------------------------------------------
c   Perform a restore operation on the "memptr" block.
c------------------------------------------------------------------------

               iblock = server_msg(c_msg_memptr,imsg)
               ptr = server_table_ptr(iblock)
               diskloc = server_table(c_server_diskloc,ptr)
               ifile   = server_table(c_server_file,ptr)

               indblk = get_index_from_base(base_mem_addr, x, 2)
               indblk = (iblock-1)*server_mem_blocksize + indblk
               size = server_table(c_server_size,ptr)

               if (do_stats .and. stat_key .gt. 0)
     *                trestore = mpi_wtime()
c               print *,'RESTORE block restore cause',iblock
               call f_restoreram(server_unit(ifile), diskloc, 
     *                           server_blocksizes(ifile),
     *                           x(indblk), size)
               if (do_stats .and. stat_key .gt. 0) then
                  trestore = mpi_wtime() - trestore
                  sstat_trestore(stat_key) = 
     *                    sstat_trestore(stat_key) + trestore
                  sstat_trestore2(stat_key) =
     *              sstat_trestore2(stat_key) + trestore * trestore
                  sstat_nrestore(stat_key) = 
     *                  sstat_nrestore(stat_key) + 1 
               endif
               server_msg(c_msg_cause,imsg) = null_cause
            endif

c------------------------------------------------------------------------
c   Back up a block if necessary.
c   A backup is necessary if (1) message processing requires a clean
c   block and can't get it, or (2) the number of clean blocks drops below 
c   the numbr of idle message buffers.
c------------------------------------------------------------------------

             if (server_msg(c_msg_cause,imsg) .eq.
     *            backup_agent_cause ) then
                  iblock = server_msg(c_msg_memptr,imsg)
                  call do_backup(iblock, server_table, 
     *                              nserver_table)
c                  if (iblock .eq. -1) then
c                     call find_clean_block(iblock,server_table,
c     *                     nserver_table)
c                     if (iblock .eq. -1) then
c                        print *,'SERVER DEADLOCK'
c                        call server_abort_job(server_table,
c     *                                       nserver_table)
c                     else
c                        call mark_block_clean(iblock, server_table,
c     *                                   nserver_table)
c                     endif
c                  endif
                  server_msg(c_msg_cause,imsg) = null_cause
            endif

c-------------------------------------------------------------------------
c   Put the node back at the end of the work queue.
c-------------------------------------------------------------------------

            if (imsg .lt. 1 .or. imsg .gt. mx_server_msg) then
               print *,'Task ',me,' NODE OUT OF RANGE: ',imsg
               call server_abort_job(server_table, nserver_table) 
            endif
            call insert_work_node(imsg) ! go to the end of the line.
            call check_work_stack_for_delay(flag, delay_flag,
     *                  server_msg_count)
         endif
      endif 

      go to 100

 1000 continue

      if (do_stats) then
         
c---------------------------------------------------------------------------
c   Get the IOCOMPANY communicator.
c---------------------------------------------------------------------------

         comm = pst_get_company_comm(me)
         call mpi_comm_size(comm, my_company_size, ierr)
         call mpi_comm_rank(comm, my_company_rank, ierr)

c----------------------------------------------------------------------------
c   Perform reduction operations on server stats.
c----------------------------------------------------------------------------

         if (my_company_size .eq. 1) go to 2000

         call mpi_reduce(sstat_tprep, x, mx_stat_keys, 
     *                   MPI_DOUBLE_PRECISION, MPI_SUM, 
     *                   0, comm, ierr)
         
         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tprep(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tprep2, x, mx_stat_keys,
     *                   MPI_DOUBLE_PRECISION, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tprep2(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tprepsum, x, mx_stat_keys, 
     *                   MPI_DOUBLE_PRECISION, MPI_SUM, 
     *                   0, comm, ierr)
         
         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tprepsum(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tprepsum2, x, mx_stat_keys,
     *                   MPI_DOUBLE_PRECISION, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tprepsum2(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_treq, x, mx_stat_keys, 
     *                   MPI_DOUBLE_PRECISION, MPI_SUM, 
     *                   0, comm, ierr)
         
         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_treq(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_treq2, x, mx_stat_keys,
     *                   MPI_DOUBLE_PRECISION, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_treq2(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tpreq, x, mx_stat_keys, 
     *                   MPI_DOUBLE_PRECISION, MPI_SUM, 
     *                   0, comm, ierr)
         
         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tpreq(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tpreq2, x, mx_stat_keys,
     *                   MPI_DOUBLE_PRECISION, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tpreq2(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_trestore, x, mx_stat_keys, 
     *                   MPI_DOUBLE_PRECISION, MPI_SUM, 
     *                   0, comm, ierr)
         
         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_trestore(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_trestore2, x, mx_stat_keys,
     *                   MPI_DOUBLE_PRECISION, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_trestore2(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tbackup, x, mx_stat_keys, 
     *                   MPI_DOUBLE_PRECISION, MPI_SUM, 
     *                   0, comm, ierr)
         
         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tbackup(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_tbackup2, x, mx_stat_keys,
     *                   MPI_DOUBLE_PRECISION, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_tbackup2(i) = x(i)
            enddo
         endif

         call mpi_reduce(sstat_nprep, ibuf, mx_stat_keys,
     *                   MPI_INTEGER, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_nprep(i) = ibuf(i)
            enddo
         endif

         call mpi_reduce(sstat_nprepsum, ibuf, mx_stat_keys,
     *                   MPI_INTEGER, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_nprepsum(i) = ibuf(i)
            enddo
         endif

         call mpi_reduce(sstat_nreq, ibuf, mx_stat_keys,
     *                   MPI_INTEGER, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_nreq(i) = ibuf(i)
            enddo
         endif

         call mpi_reduce(sstat_npreq, ibuf, mx_stat_keys,
     *                   MPI_INTEGER, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_npreq(i) = ibuf(i)
            enddo
         endif

         call mpi_reduce(sstat_nrestore, ibuf, mx_stat_keys,
     *                   MPI_INTEGER, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_nrestore(i) = ibuf(i)
            enddo
         endif

         call mpi_reduce(sstat_nbackup, ibuf, mx_stat_keys,
     *                   MPI_INTEGER, MPI_SUM,
     *                   0, comm, ierr)

         if (my_company_rank .eq. 0) then
            do i = 1, mx_stat_keys
               sstat_nbackup(i) = ibuf(i)
            enddo
         endif 

c-------------------------------------------------------------------------
c   Send accumulated data to the master.
c-------------------------------------------------------------------------

 2000    continue
         if (my_company_rank .eq. 0) then
            lendata = 12*mx_stat_keys
            call mpi_send(sstat_tprep, lendata, MPI_DOUBLE_PRECISION,  
     *                  0, server_stat_data_tag, mpi_comm_world,
     *                  status, ierr) 
            lendata = 6*mx_stat_keys
            call mpi_send(sstat_nprep, lendata, MPI_INTEGER,
     *                  0, server_stat_data_tag, mpi_comm_world,
     *                  status, ierr)
         endif
      endif

c---------------------------------------------------------------------------
c   Remove checkpoint files if they exist.
c---------------------------------------------------------------------------

      n = str_trimlen(ckpt_dat_filename)
      inquire (file=ckpt_dat_filename,exist=flag)
      if (flag) call f_deletefile(ckpt_dat_filename(1:n)//char(0),-1)
      n = str_trimlen(ckpt_ndx_filename)
      inquire (file=ckpt_ndx_filename,exist=flag)
      if (flag) call f_deletefile(ckpt_ndx_filename(1:n)//char(0),-1)
      return
      end

      SUBROUTINE SORTT1(ICORE,MAXCOR,ISPIN,ILIST,NTOP,TYPE)
C
C DRIVER FOR ROUTINE WHICH PICKS UP THE T1 VECTOR FROM DISK FOR A 
C  SPIN CASE AND FIND THE NTOP LARGEST ELEMENTS BY MAGNITUDE.  THESE ARE
C  PRINTED OUT AT THE END OF THE ROUTINE.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*8 LABEL1
      CHARACTER*1 TYPE
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      NOCC=NOCCO(ISPIN)
      NVRT=NVRTO(ISPIN)
      NT1SIZ=IRPDPD(1,8+ISPIN)
      IF(ISPIN.EQ.1)THEN
       NSMSZ=NVRT*NOCC
       LABEL1='SVAOA2  '
      ELSEIF(ISPIN.EQ.2)THEN
       NSMSZ=NVRT*NOCC
       LABEL1='SVBOB2  '
      ENDIF
C
C ALLOCATE CORE FOR T VECTOR, SYMMETRY VECTORS AND INDICES.
C
      I000=1
      I010=I000+IINTFP*NT1SIZ
      I020=I010+IINTFP*NTOP
      I030=I020+NSMSZ
      I040=I030+NTOP
      I050=I040+NTOP
      I060=I050+NTOP
      CALL GETREC(20,'JOBARC',LABEL1,NSMSZ,ICORE(I020))
      CALL TOPT1S(ISPIN,ILIST,NTOP,NT1SIZ,NOCC,
     &            NVRT,NSMSZ,ICORE(I000),ICORE(I010),
     &            ICORE(I020),ICORE(I030),ICORE(I040),ICORE(I050),
     &            TYPE)
      RETURN
      END

      SUBROUTINE TRNLST(IRREP, LISTG, DISSIZE, NUMDIS, SCR, MAXSIZE)
C
C This routine transpose a ACES II list and write it back to disk. 
C This version handle both in and out-of-core transpositions and 
C work with both square and rectangular matrices (NMO < NAO). The 
C original implementation (JG and JFS) was limited to square matrices,
C and generalized version was implemented by Ajith Perera 11/2001. 
C 
C Implementation Notes: In the case of NMO < NAO (DROPMO, 
C SPHERICAL=ON) the DISSIZE  > NUMDIS. What is done here 
C is to add the appropriate numeber of empty distributions to
C make DISSIZE=NUMDIS. With that both in-core and out-of-core
C algorithms can proceed painlessly.  
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER DISSIZE, DISLEFT, DISREAD
      DIMENSION SCR(MAXSIZE)
C
C Determine the maximum number of distributions which can be held 
C in available memory.
C
      MAXDIS = MAXSIZE/DISSIZE
C
C Check to see if we can fit the whole list into available memory.
C
      IF (MAXDIS .GE. DISSIZE) THEN
C
          CALL ZERO(SCR, DISSIZE*DISSIZE)
C
C Do it in core by using mtran2 (in place in transpose routine)
C Notice the dimension in mtran2 is dissize (not numdis). This is
C to make a square matrix with the padded zeros. 
C
         CALL GETLST(SCR, 1, NUMDIS, 1, IRREP, LISTG)
         CALL MTRAN2(SCR, DISSIZE, DISSIZE) 
         CALL PUTLST(SCR, 1, DISSIZE, 1, IRREP, LISTG)
C
      ELSE
C 
C General out-of-core algorithm. Pad the LISTG with empty
C distributions for cases where DISSIZE not equal to NUMDIS.
C
          IF (DISSIZE .NE. NUMDIS) THEN
              NPADD = DISSIZE - NUMDIS
              IF (NPADD .GT. MAXDIS) CALL INSMEM('@TRNLST',
     &            DISSIZE*NPADD, MAXSIZE)
              CALL ZERO(SCR, DISSIZE*NPADD)
              CALL PUTLST(SCR, NUMDIS+1, NPADD, 1, IRREP,
     &                    LISTG) 
          ENDIF
C
C Leave a length of one distribution for buffer space. 
C
         MAXDIS = MAXDIS - 1
C
         IF (MAXDIS .LE. 0 ) THEN
            WRITE(6,1000) 2*DISSIZE
 1000       FORMAT(T3,'@TRNLST-F, Less than ',I10,' words available',
     &        ' for transposition')
            CALL ERREX
         ENDIF
C
C Compute offset for the buffer area
C
         IBUF = 1 + MAXDIS*DISSIZE
C
C Set the number of distributions need to be treated.
C
         DISREAD = DISSIZE
C
C Set the number of distributions left.
C
         DISLEFT = DISSIZE
C
C Set OFFSET for list LISTG 
C 
         IOFFSET = 1
         IPASS   = 0
         IREAD   = 0
C
 10      CONTINUE

         IPASS = IPASS + 1
         IREAD = IREAD + DISSIZE - IOFFSET + 1
C
C Determine the number of distributions processed during this pass.
C
         DISREAD = MIN(DISLEFT, MAXDIS)
         DISLEFT = DISLEFT - DISREAD
C 
C Read the appropriate number distributions for this path.
C
         CALL GETLST(SCR, IOFFSET, DISREAD, 1, IRREP, LISTG)
C
C Set IFIRST (first distribution in core)
C
         IFIRST = IOFFSET
C
C Update the offset
C
         IOFFSET = IOFFSET + DISREAD
C
C Set ILAST (last distribution in core)
C
         ILAST = IOFFSET - 1
C
C We have now three different categories of distributions 
C
C 1. The distributions in memory 
C 2. The distributions on disk which are already the transpose of the 
C    original matrix. 
C 3. The distributions on disk which are still not the transpose of the
C    original matrix 
C
C First, do an in-place transposition of the elements that are already 
C in memory. 
C
         CALL MTRAN3(SCR(IFIRST), DISSIZE, DISREAD)
C
C Loop over the remaining distributions 
C
         DO 100 IDIS = IOFFSET, DISSIZE 

            CALL GETLST(SCR(IBUF), IDIS, 1, 1, IRREP, LISTG)
C
C  Move A(I,J) [i<j] in main memory to A(i,j) in buffer. 
C
            DO 150 IPOS = IFIRST, ILAST
               X = SCR(IBUF+IPOS-1)
               SCR(IBUF + IPOS - 1) = SCR(IDIS + (IPOS-IFIRST)*DISSIZE)
               SCR(IDIS + (IPOS-IFIRST)*DISSIZE) = X
 150        CONTINUE
C
C Write the distribution in the buffer to the disk. 
C
            CALL PUTLST(SCR(IBUF), IDIS, 1, 1, IRREP, LISTG)
C
 100     CONTINUE
C
C Also, write the transposed main area of the memory to the disk.
C
      CALL PUTLST(SCR, IFIRST, DISREAD, 1, IRREP, LISTG)
C
C Continue untill we exhaust all the distributions 
C
         IF (DISLEFT .NE. 0) GO TO 10

cSSS      WRITE(6,2000)IPASS,IREAD
cSSS 2000  FORMAT(T3,'@TRNLST-I, Transpostion required ',I5,' passes and ',
cSSS     &       I10,' reads.')
cSSS
      ENDIF
C
      RETURN
      END

      SUBROUTINE IMAGE(NATOMS,LENGTH,IDEGEN,IOPNUM,
     &                 IPTR,NBFATM,ILCATM,VREF,VGEN,
     &                 SCR,IANG,NBAS,SYOP,INORM)
C
C THIS ROUTINE COMPUTES THE CHARACTER OF A GROUP REPRESENTATION 
C  AND IS USED IN DETERMINING THE IRREDUCIBLE REPRESENTATION OF
C  MOLECULAR ORBITALS, VIBRATIONS, ETC.  
C
C INPUT:
C
C       NATOMS        - THE NUMBER OF "ATOMS" IN THE VECTOR VREF
C       LENGTH        - THE LENGTH OF EACH COMPONENT OF THE REPRESENTATION
C                       (THERE ARE IDEGEN COMPONENTS)
C       IDEGEN        - THE DEGENERACY ASSOCIATED WITH VREF
C       IOPNUM        - THE SYMMETRY OPERATION NUMBER
C       IPTR          - THE PERMUTATION ARRAY FOR THE SYMMETRY OPERATIONS
C       NBFATM        - THE NUMBER OF ELEMENTS ASSOCIATED WITH EACH 
C                       CENTER (STORED AS A VECTOR)
C       ILCATM        - THE OFFSET IN THE VECTOR WHERE EACH ATOM BEGINS
C       VREF          - THE REFERENCE VECTOR (NORMALIZED ON OUTPUT)
C       SCR           - A SCRATCH VECTOR OF LENGTH MAX(3,NATOMS)*3
C       IANG          - THE TYPE OF REPRESENTATION (0 FOR S, 1 FOR P,
C                       ETC)
C       NBAS          - THE MAXIMUM OF ALL ELEMENTS IN THE LENGTH ARRAY
C       SYOP          - A VECTOR WHICH CONTAINS THE GROUP SYMMETRY OPS 
C
C RETURNED:
C
C       VGEN          - THE IMAGE OF VREF UNDER THE GROUP OPERATION 
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VREF(LENGTH,IDEGEN),VGEN(LENGTH*IDEGEN),IPTR(1)
      DIMENSION NBFATM(NATOMS),ILCATM(NATOMS),SCR(1)
      DIMENSION SYOP(1),DBUF(81),DBUF2(81)
C
      COMMON /SYMCHAR/ CHAR
C
      DATA ZILCH /0.0/
C
      IPOS(I) =1+(I-1)*NATOMS
      IPOS2(I)=1+(I-1)*9
C
      CALL ZERO(VGEN,LENGTH*IDEGEN)
      CHAR=ZILCH
C
C LOOP OVER THE LEVEL OF DEGENERACY OF THE REPRESENTATION
C
      DO 10 ICOUNT=1,IDEGEN
       C=ZILCH
       ZIT=ZILCH
       ZRT=ZILCH
       IOFFGEN=(ICOUNT-1)*LENGTH
C
C NORMALIZE VECTOR
C
       IF(INORM.NE.0)THEN
        Z=SNRM2(LENGTH,VREF(1,ICOUNT),1)
        IF(Z.EQ.ZILCH) THEN
         RETURN
        ELSE
         X=1.0/Z
         CALL SSCAL(LENGTH,X,VREF(1,ICOUNT),1)
        ENDIF
       ENDIF
C
C NOW APPLY THE PERMUTATION COMPONENT OF THE OPERATION
C
       DO 20 I=1,NATOMS
        LENATM=NBFATM(I)
        IF(LENATM.EQ.-1)GOTO 20
        ISTART=ILCATM(I)
        ICENGEN=IPTR(I+IPOS(IOPNUM)-1)
        ISTART2=ILCATM(ICENGEN)+IOFFGEN
        CALL SCOPY(LENATM,VREF(ISTART,ICOUNT),1,VGEN(ISTART2),1)
20     CONTINUE
C
       IF(IANG.EQ.0)THEN
        ZI=SNRM2(LENGTH,VGEN(IOFFGEN+1),1)
        ZR=SNRM2(LENGTH,VREF(1,ICOUNT),1)
        ZIT=ZI*ZI
        ZRT=ZR*ZR
        C=SDOT(LENGTH,VGEN(IOFFGEN+1),1,VREF(1,ICOUNT),1)
C
C IF THIS IS A P FUNCTION REP. THEN ROTATE THE X,Y AND Z COMPONENTS BY
C   THE CARTESIAN REPRESENTATION OF THE SYMMETRY OPERATION
C
       ELSEIF(IANG.EQ.1)THEN
        ITOTATM=LENGTH/3
        CALL MXM(SYOP(IPOS2(IOPNUM)),3,VGEN(IOFFGEN+1),3,SCR,ITOTATM)
        CALL SCOPY(ITOTATM*3,SCR,1,VGEN(IOFFGEN+1),1)
        ZI=SNRM2(LENGTH,VGEN(IOFFGEN+1),1)
        ZR=SNRM2(LENGTH,VREF(1,ICOUNT),1)
        ZIT=ZI*ZI
        ZRT=ZR*ZR
        C=SDOT(LENGTH,VGEN(IOFFGEN+1),1,VREF(1,ICOUNT),1)
C
C IF THIS IS A D FUNCTION REP. THEN ROTATE THIS AS WELL.
C
       ELSEIF(IANG.EQ.2)THEN
        ITOTATM=LENGTH/6
        IOFF1=1+IOFFGEN
        IOFFV=1
        DO 30 NATOM=1,ITOTATM
         CALL EXPND4(VGEN(IOFF1),DBUF2,3,2)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF2,3,SCR,3)
         CALL TRANSP(SCR,DBUF,3,3)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF,3,SCR,3)
         CALL TRANSP(SCR,DBUF,3,3)
         CALL EXPND4(VREF(IOFFV,ICOUNT),DBUF2,3,2)
         ZI=SNRM2(9,DBUF,1)
         ZR=SNRM2(9,DBUF2,1)
         ZIT=ZIT+ZI*ZI
         ZRT=ZRT+ZR*ZR
         C=C+SDOT(9,DBUF,1,DBUF2,1)
         CALL SQUEZ4(DBUF,VGEN(IOFF1),3,2)
         IOFF1=IOFF1+6
         IOFFV=IOFFV+6
30      CONTINUE 
C
C F FUNCTIONS - UGH
C
       ELSEIF(IANG.EQ.3)THEN
        ITOTATM=LENGTH/10
        IOFF1=1+IOFFGEN
        IOFFV=1
        DO 40 NATOM=1,ITOTATM
         CALL EXPND4(VGEN(IOFF1),DBUF2,3,3)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF2,3,SCR,9)
         CALL TRANSP(SCR,DBUF,3,9)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF,3,SCR,9)
         CALL TRANSP(SCR,DBUF,3,9)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF,3,SCR,9)
         CALL TRANSP(SCR,DBUF,3,9)
         CALL SQUEZ4(DBUF,VGEN(IOFF1),3,3)
         CALL EXPND4(VREF(IOFFV,ICOUNT),DBUF2,3,3)
         ZI=SNRM2(27,DBUF,1)
         ZR=SNRM2(27,DBUF2,1)
         ZIT=ZIT+ZI*ZI
         ZRT=ZRT+ZR*ZR
         C=C+SDOT(27,DBUF,1,DBUF2,1)
         IOFF1=IOFF1+10
         IOFFV=IOFFV+10
40      CONTINUE
C
C G FUNCTIONS - VOMITROCIOUS
C
       ELSEIF(IANG.EQ.4)THEN
        ITOTATM=LENGTH/15
        IOFF1=1+IOFFGEN
        IOFFV=1
        DO 50 NATOM=1,ITOTATM
         CALL EXPND4(VGEN(IOFF1),DBUF2,3,4)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF2,3,SCR,27)
         CALL TRANSP(SCR,DBUF,3,27)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF,3,SCR,27)
         CALL TRANSP(SCR,DBUF,3,27)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF,3,SCR,27)
         CALL TRANSP(SCR,DBUF,3,27)
         CALL MXM(SYOP(IPOS2(IOPNUM)),3,DBUF,3,SCR,27)
         CALL TRANSP(SCR,DBUF,3,27)
         CALL SQUEZ4(DBUF,VGEN(IOFF1),3,4)
         CALL EXPND4(VREF(IOFFV,ICOUNT),DBUF2,3,4)
         ZI=SNRM2(81,DBUF,1)
         ZR=SNRM2(81,DBUF2,1)
         ZIT=ZIT+ZI*ZI
         ZRT=ZRT+ZR*ZR
         C=C+SDOT(81,DBUF,1,DBUF2,1)
         IOFF1=IOFF1+15
         IOFFV=IOFFV+15
50      CONTINUE
C 
       ENDIF       
C
       Z=SQRT(ZIT)*SQRT(ZRT)
       IF(Z.NE.ZILCH)THEN
        C=C/Z
       ELSE
        C=ZILCH
       ENDIF
       CHAR=CHAR+C
C
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sip_server_init(local_scratch, x, nx, msg_buffers,
     *                           blocksize, niocompany, do_timer)
c---------------------------------------------------------------------------
c   Initialization routine for the SIP server process.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_ckpt_data.h'
      include 'server_stat.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'machine_types.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer*8 c_loc64, ixx

      character*(*) local_scratch
      integer nx, msg_buffers, blocksize
      integer niocompany
      logical do_timer

      integer sip_server_datatag
      parameter (sip_server_datatag = 3335)
      integer status(mpi_status_size)

      integer i, nleft
      double precision x(nx)
      character*256 fn
      integer n
      integer str_trimlen
      integer ios
      integer server_table(1)
      integer*8 indtable, get_index_from_base
      integer nwtable, ndouble, nbtable, ierr
      integer pst_get_company_comm
      integer comm

#ifdef ALTIX
      pointer (iptr, server_table)
#endif

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      call mpi_comm_size(mpi_comm_world, nprocs, ierr)

#ifdef ALTIX
      iptr = ishptr
#endif

c----------------------------------------------------------------------------
c   Receive the server_table from the master.
c----------------------------------------------------------------------------

      call mpi_recv(x, nx, mpi_integer, MPI_ANY_SOURCE, 
     *       sip_server_datatag, mpi_comm_world, status, ierr)

      call mpi_get_count(status, mpi_integer, nwtable, ierr)

c---------------------------------------------------------------------------
c   The second message from the master gives us the number of stacks used
c   and their respective blocksizes.
c----------------------------------------------------------------------------

      call mpi_recv(server_blocksizes, mx_server_blocksizes,
     *       mpi_integer, MPI_ANY_SOURCE,
     *       sip_server_datatag, mpi_comm_world, status, ierr)

      call mpi_get_count(status, mpi_integer, nserver_blocksizes, ierr)

c----------------------------------------------------------------------------
c   The server table is at the beginning of our allocated memory.
c   The memory blocks go at the end of the server table.
c----------------------------------------------------------------------------

      ixx = 1
      server_table_base_addr = c_loc64(x, ixx, bytes_per_double)
      nserver_table_entries = nwtable/lserver_table_entry

c----------------------------------------------------------------------------
c   Increase nwtable to be a multiple of the size of a double word.
c----------------------------------------------------------------------------

      nbtable = (nwtable * intsize + bytes_per_double - 1)/
     *           bytes_per_double * bytes_per_double
      ndouble = nbtable / bytes_per_double
      
c---------------------------------------------------------------------------
c   Calculate the base address of the memory blocks.
c---------------------------------------------------------------------------

      indtable = get_index_from_base(server_table_base_addr, 
     *                               server_table, 1)
      base_mem_addr = c_loc64(server_table, indtable+nbtable/intsize, 
     *                        intsize)
      nleft = nx - ndouble   ! num. of remaining doubles.

      nmessage_buffers      = msg_buffers
      server_mem_blocksize  = blocksize
      server_seqno          = 0
      server_work_list_head = 0
      server_work_list_tail = 0
      server_node_ptr       = 0
      dirty_list_head       = 0
      dirty_list_tail       = 0
      nserver_memblocks     = nleft/blocksize
      nserver_memblocks     = min(nserver_memblocks,mx_server_memblocks)
      dirty_threshold       = (nserver_memblocks-msg_buffers)/10
      max_backup            = min(msg_buffers/2,dirty_threshold)
      barrier_in_progress   = .false.
      barrier_msg_count     = 0
      nbarrier_msgs         = nprocs - niocompany

      do_stats = do_timer
      if (do_stats) call clear_server_stats()   ! initialize server statistics

      if (nmessage_buffers .ge. nserver_memblocks) then
         print *,'Error: Server requires at least ',nmessage_buffers,
     *     ' message buffers, but only ',nserver_memblocks,
     *     ' are available.'
         call abort_job()
      endif

      if (dbg) then
         print *,'Server ',me,' was initialized with ',
     *     nserver_memblocks,
     *    ' blocks of ',blocksize,' words each.'
         print *,'Backup threshold ',dirty_threshold,
     *         ' max_backup ',max_backup
      endif



c----------------------------------------------------------------------------
c   Print Server Info
c----------------------------------------------------------------------------

         comm = pst_get_company_comm(me)
         call mpi_comm_size(comm, my_company_size, ierr)
         call mpi_comm_rank(comm, my_company_rank, ierr)

         if (my_company_rank .eq. 0) then
            print *,'Servers were initialized with ', nserver_memblocks,
     *          ' blocks of ',blocksize,' words each.'
         endif    

      


c----------------------------------------------------------------------------
c   Open the server's scratch files.
c----------------------------------------------------------------------------

      do i = 1, nserver_blocksizes
         fn = ' '
         call generate_scratch_filename(fn, 'server'//char(0))
         n = str_trimlen(local_scratch)
         if (local_scratch(n:n) .eq. '/') then
            server_filename(i) = local_scratch(1:n)//fn
         else
            server_filename(i) = local_scratch(1:n) // '/' // fn
         endif

         n = str_trimlen(server_filename(i))
         call f_creatfile(server_filename(i)(1:n) // char(0), 
     *                       server_unit(i))
         if (dbg) print *,'Server ',me,' Opened file ',
     *              server_filename(i)(1:n),' file handle ',
     *              server_unit(i) 
         next_server_diskloc(i) = 0
      enddo

c----------------------------------------------------------------------------
c   Set up checkpoint files for fine-grained restart.  These files are 
c   only opened if a checkpoint message is processed by the server.
c----------------------------------------------------------------------------

      write (ckpt_ndx_filename, 100) me,'.ndx'
  100 format('./CKPT',i5,A4)
      write (ckpt_dat_filename, 100) me, '.dat'

c-----------------------------------------------------------------------------
c   Change blanks in filenames to 0's.
c-----------------------------------------------------------------------------

      call convert_chars(ckpt_ndx_filename,' ', '0')
      call convert_chars(ckpt_dat_filename,' ', '0')

c----------------------------------------------------------------------------
c   Initialize the message buffers.
c----------------------------------------------------------------------------

      do i = 1, nmessage_buffers
         server_msg(c_msg_msgbuffer,i) = i   ! fill in msg buffer field
         call push_work_node(i)
         server_table_ptr(i) = -1            ! mark block as msg_buffer
      enddo

      clean_block_ptr = 0  
      nclean_blocks = 0 

c---------------------------------------------------------------------------
c   Remaining blocks are all set up as "clean", i. e. ready for use.
c---------------------------------------------------------------------------

      do i = nmessage_buffers+1, nserver_memblocks
         server_table_ptr(i) = 0
         call push_clean_block(i, server_table, nserver_table_entries) 
      enddo

      return
      end

     

      Subroutine Make_xyz(Nxyz, Cxyz, CS_xyz)
C
c This routine compute arrays PI{n_i=n,,k_i=0...n_i}CA_i^^(n_i-k_i) i=x,y,z
C where i=x,y,z
C

      Implicit Double Precision (A-H, O-Z)

#include "ecp.par"
    
      Dimension CS_xyz(0:2*Maxang)

      CS_xyz(0) = 1.0D0
      CS_xyz(1) = Cxyz
      IF (NXyz .EQ. 0 .OR. Nxyz .EQ. 1) Return

      Do I = 2, Nxyz

            CS_xyz(I) = CS_xyz(I-1)*CS_xyz(1)

      Enddo
    
      Return
      End

C EMULATOR OF CRAY SCILIB ROUTINE. RETURNS THE LARGEST ABSOLUTE VALUE IN A
C VECTOR (X).

c There is no UNICOS man page available for this routine.

      double precision function fndlrgab(x,n)
      integer n,ndx,idamax
      double precision x(n)
      external idamax
      if (n.gt.0) then
         ndx = idamax(n,x,1)
         fndlrgab = abs(x(ndx))
      else
         fndlrgab = 0.d0
      end if
      return
      end

*DECK ISORT
      SUBROUTINE ISORT (IX, IY, N, KFLAG)
C***BEGIN PROLOGUE  ISORT
C***PURPOSE  Sort an array and optionally make the same interchanges in
C            an auxiliary array.  The array may be sorted in increasing
C            or decreasing order.  A slightly modified QUICKSORT
C            algorithm is used.
C***LIBRARY   SLATEC
C***CATEGORY  N6A2A
C***TYPE      INTEGER (SSORT-S, DSORT-D, ISORT-I)
C***KEYWORDS  SINGLETON QUICKSORT, SORT, SORTING
C***AUTHOR  Jones, R. E., (SNLA)
C           Kahaner, D. K., (NBS)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C   ISORT sorts array IX and optionally makes the same interchanges in
C   array IY.  The array IX may be sorted in increasing order or
C   decreasing order.  A slightly modified quicksort algorithm is used.
C
C   Description of Parameters
C      IX - integer array of values to be sorted
C      IY - integer array to be (optionally) carried along
C      N  - number of values in integer array IX to be sorted
C      KFLAG - control parameter
C            =  2  means sort IX in increasing order and carry IY along.
C            =  1  means sort IX in increasing order (ignoring IY)
C            = -1  means sort IX in decreasing order (ignoring IY)
C            = -2  means sort IX in decreasing order and carry IY along.
C
C***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
C                 for sorting with minimal storage, Communications of
C                 the ACM, 12, 3 (1969), pp. 185-187.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   761118  DATE WRITTEN
C   810801  Modified by David K. Kahaner.
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   901012  Declared all variables; changed X,Y to IX,IY. (M. McClain)
C   920501  Reformatted the REFERENCES section.  (DWL, WRB)
C   920519  Clarified error messages.  (DWL)
C   920801  Declarations section rebuilt and code restructured to use
C           IF-THEN-ELSE-ENDIF.  (RWC, WRB)
C***END PROLOGUE  ISORT
C     .. Scalar Arguments ..
      INTEGER KFLAG, N
C     .. Array Arguments ..
      INTEGER IX(*), IY(*)
C     .. Local Scalars ..
      REAL R
      INTEGER I, IJ, J, K, KK, L, M, NN, T, TT, TTY, TY
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. External Subroutines ..
c      EXTERNAL XERMSG
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C***FIRST EXECUTABLE STATEMENT  ISORT
      NN = N
      IF (NN .LT. 1) THEN
         print *, '@ISORT:',
     +      'The number of values to be sorted is not positive.'
         call c_exit(1)
      ENDIF
C
      KK = ABS(KFLAG)
      IF (KK.NE.1 .AND. KK.NE.2) THEN
         print *, '@ISORT:',
     +      'The sort control parameter, K, is not 2, 1, -1, or -2.'
         call c_exit(1)
      ENDIF
C
C     Alter array IX to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 10 I=1,NN
            IX(I) = -IX(I)
   10    CONTINUE
      ENDIF
C
      IF (KK .EQ. 2) GO TO 100
C
C     Sort IX only
C
      M = 1
      I = 1
      J = NN
      R = 0.375E0
C
   20 IF (I .EQ. J) GO TO 60
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
   30 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = IX(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (IX(I) .GT. T) THEN
         IX(IJ) = IX(I)
         IX(I) = T
         T = IX(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than than T, interchange with T
C
      IF (IX(J) .LT. T) THEN
         IX(IJ) = IX(J)
         IX(J) = T
         T = IX(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (IX(I) .GT. T) THEN
            IX(IJ) = IX(I)
            IX(I) = T
            T = IX(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
   40 L = L-1
      IF (IX(L) .GT. T) GO TO 40
C
C     Find an element in the first half of the array which is greater
C     than T
C
   50 K = K+1
      IF (IX(K) .LT. T) GO TO 50
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = IX(L)
         IX(L) = IX(K)
         IX(K) = TT
         GO TO 40
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 70
C
C     Begin again on another portion of the unsorted array
C
   60 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
   70 IF (J-I .GE. 1) GO TO 30
      IF (I .EQ. 1) GO TO 20
      I = I-1
C
   80 I = I+1
      IF (I .EQ. J) GO TO 60
      T = IX(I+1)
      IF (IX(I) .LE. T) GO TO 80
      K = I
C
   90 IX(K+1) = IX(K)
      K = K-1
      IF (T .LT. IX(K)) GO TO 90
      IX(K+1) = T
      GO TO 80
C
C     Sort IX and carry IY along
C
  100 M = 1
      I = 1
      J = NN
      R = 0.375E0
C
  110 IF (I .EQ. J) GO TO 150
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
  120 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = IX(IJ)
      TY = IY(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (IX(I) .GT. T) THEN
         IX(IJ) = IX(I)
         IX(I) = T
         T = IX(IJ)
         IY(IJ) = IY(I)
         IY(I) = TY
         TY = IY(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than T, interchange with T
C
      IF (IX(J) .LT. T) THEN
         IX(IJ) = IX(J)
         IX(J) = T
         T = IX(IJ)
         IY(IJ) = IY(J)
         IY(J) = TY
         TY = IY(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (IX(I) .GT. T) THEN
            IX(IJ) = IX(I)
            IX(I) = T
            T = IX(IJ)
            IY(IJ) = IY(I)
            IY(I) = TY
            TY = IY(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
  130 L = L-1
      IF (IX(L) .GT. T) GO TO 130
C
C     Find an element in the first half of the array which is greater
C     than T
C
  140 K = K+1
      IF (IX(K) .LT. T) GO TO 140
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = IX(L)
         IX(L) = IX(K)
         IX(K) = TT
         TTY = IY(L)
         IY(L) = IY(K)
         IY(K) = TTY
         GO TO 130
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 160
C
C     Begin again on another portion of the unsorted array
C
  150 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
  160 IF (J-I .GE. 1) GO TO 120
      IF (I .EQ. 1) GO TO 110
      I = I-1
C
  170 I = I+1
      IF (I .EQ. J) GO TO 150
      T = IX(I+1)
      TY = IY(I+1)
      IF (IX(I) .LE. T) GO TO 170
      K = I
C
  180 IX(K+1) = IX(K)
      IY(K+1) = IY(K)
      K = K-1
      IF (T .LT. IX(K)) GO TO 180
      IX(K+1) = T
      IY(K+1) = TY
      GO TO 170
C
C     Clean up
C
  190 IF (KFLAG .LE. -1) THEN
         DO 200 I=1,NN
            IX(I) = -IX(I)
  200    CONTINUE
      ENDIF
      RETURN
      END

*DECK DTRSM
      SUBROUTINE DTRSM (SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,
     $   B, LDB)
C***BEGIN PROLOGUE  DTRSM
C***PURPOSE  Solve one of the matrix equations.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1B6
C***TYPE      DOUBLE PRECISION (STRSM-S, DTRSM-D, CTRSM-C)
C***KEYWORDS  LEVEL 3 BLAS, LINEAR ALGEBRA
C***AUTHOR  Dongarra, J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S. (NAG)
C***DESCRIPTION
C
C  DTRSM  solves one of the matrix equations
C
C     op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
C
C  where alpha is a scalar, X and B are m by n matrices, A is a unit, or
C  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
C
C     op( A ) = A   or   op( A ) = A'.
C
C  The matrix X is overwritten on B.
C
C  Parameters
C  ==========
C
C  SIDE   - CHARACTER*1.
C           On entry, SIDE specifies whether op( A ) appears on the left
C           or right of X as follows:
C
C              SIDE = 'L' or 'l'   op( A )*X = alpha*B.
C
C              SIDE = 'R' or 'r'   X*op( A ) = alpha*B.
C
C           Unchanged on exit.
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the matrix A is an upper or
C           lower triangular matrix as follows:
C
C              UPLO = 'U' or 'u'   A is an upper triangular matrix.
C
C              UPLO = 'L' or 'l'   A is a lower triangular matrix.
C
C           Unchanged on exit.
C
C  TRANSA - CHARACTER*1.
C           On entry, TRANSA specifies the form of op( A ) to be used in
C           the matrix multiplication as follows:
C
C              TRANSA = 'N' or 'n'   op( A ) = A.
C
C              TRANSA = 'T' or 't'   op( A ) = A'.
C
C              TRANSA = 'C' or 'c'   op( A ) = A'.
C
C           Unchanged on exit.
C
C  DIAG   - CHARACTER*1.
C           On entry, DIAG specifies whether or not A is unit triangular
C           as follows:
C
C              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
C
C              DIAG = 'N' or 'n'   A is not assumed to be unit
C                                  triangular.
C
C           Unchanged on exit.
C
C  M      - INTEGER.
C           On entry, M specifies the number of rows of B. M must be at
C           least zero.
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the number of columns of B.  N must be
C           at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
C           zero then  A is not referenced and  B need not be set before
C           entry.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, k ), where k is m
C           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
C           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
C           upper triangular part of the array  A must contain the upper
C           triangular matrix  and the strictly lower triangular part of
C           A is not referenced.
C           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
C           lower triangular part of the array  A must contain the lower
C           triangular matrix  and the strictly upper triangular part of
C           A is not referenced.
C           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
C           A  are not referenced either,  but are assumed to be  unity.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
C           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
C           then LDA must be at least max( 1, n ).
C           Unchanged on exit.
C
C  B      - DOUBLE PRECISION array of DIMENSION ( LDB, n ).
C           Before entry,  the leading  m by n part of the array  B must
C           contain  the  right-hand  side  matrix  B,  and  on exit  is
C           overwritten by the solution matrix  X.
C
C  LDB    - INTEGER.
C           On entry, LDB specifies the first dimension of B as declared
C           in  the  calling  (sub)  program.   LDB  must  be  at  least
C           max( 1, m ).
C           Unchanged on exit.
C
C***REFERENCES  Dongarra, J., Du Croz, J., Duff, I., and Hammarling, S.
C                 A set of level 3 basic linear algebra subprograms.
C                 ACM TOMS, Vol. 16, No. 1, pp. 1-17, March 1990.
C***ROUTINES CALLED  LSAME, XERBLA
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910605  Modified to meet SLATEC prologue standards.  Only comment
C           lines were modified.  (BKS)
C***END PROLOGUE  DTRSM
C     .. Scalar Arguments ..
      CHARACTER*1        SIDE, UPLO, TRANSA, DIAG
      INTEGER            M, N, LDA, LDB
      DOUBLE PRECISION   ALPHA
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
C
C     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
C     .. External Subroutines ..
      EXTERNAL           XERBLA
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Local Scalars ..
      LOGICAL            LSIDE, NOUNIT, UPPER
      INTEGER            I, INFO, J, K, NROWA
      DOUBLE PRECISION   TEMP
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C***FIRST EXECUTABLE STATEMENT  DTRSM
C
C     Test the input parameters.
C
      LSIDE  = LSAME( SIDE  , 'L' )
      IF( LSIDE )THEN
         NROWA = M
      ELSE
         NROWA = N
      END IF
      NOUNIT = LSAME( DIAG  , 'N' )
      UPPER  = LSAME( UPLO  , 'U' )
C
      INFO   = 0
      IF(      ( .NOT.LSIDE                ).AND.
     $         ( .NOT.LSAME( SIDE  , 'R' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.UPPER                ).AND.
     $         ( .NOT.LSAME( UPLO  , 'L' ) )      )THEN
         INFO = 2
      ELSE IF( ( .NOT.LSAME( TRANSA, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) )      )THEN
         INFO = 3
      ELSE IF( ( .NOT.LSAME( DIAG  , 'U' ) ).AND.
     $         ( .NOT.LSAME( DIAG  , 'N' ) )      )THEN
         INFO = 4
      ELSE IF( M  .LT.0               )THEN
         INFO = 5
      ELSE IF( N  .LT.0               )THEN
         INFO = 6
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 9
      ELSE IF( LDB.LT.MAX( 1, M     ) )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DTRSM ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( N.EQ.0 )
     $   RETURN
C
C     And when  alpha.eq.zero.
C
      IF( ALPHA.EQ.ZERO )THEN
         DO 20, J = 1, N
            DO 10, I = 1, M
               B( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
         RETURN
      END IF
C
C     Start the operations.
C
      IF( LSIDE )THEN
         IF( LSAME( TRANSA, 'N' ) )THEN
C
C           Form  B := alpha*inv( A )*B.
C
            IF( UPPER )THEN
               DO 60, J = 1, N
                  IF( ALPHA.NE.ONE )THEN
                     DO 30, I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
   30                CONTINUE
                  END IF
                  DO 50, K = M, 1, -1
                     IF( B( K, J ).NE.ZERO )THEN
                        IF( NOUNIT )
     $                     B( K, J ) = B( K, J )/A( K, K )
                        DO 40, I = 1, K - 1
                           B( I, J ) = B( I, J ) - B( K, J )*A( I, K )
   40                   CONTINUE
                     END IF
   50             CONTINUE
   60          CONTINUE
            ELSE
               DO 100, J = 1, N
                  IF( ALPHA.NE.ONE )THEN
                     DO 70, I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
   70                CONTINUE
                  END IF
                  DO 90 K = 1, M
                     IF( B( K, J ).NE.ZERO )THEN
                        IF( NOUNIT )
     $                     B( K, J ) = B( K, J )/A( K, K )
                        DO 80, I = K + 1, M
                           B( I, J ) = B( I, J ) - B( K, J )*A( I, K )
   80                   CONTINUE
                     END IF
   90             CONTINUE
  100          CONTINUE
            END IF
         ELSE
C
C           Form  B := alpha*inv( A' )*B.
C
            IF( UPPER )THEN
               DO 130, J = 1, N
                  DO 120, I = 1, M
                     TEMP = ALPHA*B( I, J )
                     DO 110, K = 1, I - 1
                        TEMP = TEMP - A( K, I )*B( K, J )
  110                CONTINUE
                     IF( NOUNIT )
     $                  TEMP = TEMP/A( I, I )
                     B( I, J ) = TEMP
  120             CONTINUE
  130          CONTINUE
            ELSE
               DO 160, J = 1, N
                  DO 150, I = M, 1, -1
                     TEMP = ALPHA*B( I, J )
                     DO 140, K = I + 1, M
                        TEMP = TEMP - A( K, I )*B( K, J )
  140                CONTINUE
                     IF( NOUNIT )
     $                  TEMP = TEMP/A( I, I )
                     B( I, J ) = TEMP
  150             CONTINUE
  160          CONTINUE
            END IF
         END IF
      ELSE
         IF( LSAME( TRANSA, 'N' ) )THEN
C
C           Form  B := alpha*B*inv( A ).
C
            IF( UPPER )THEN
               DO 210, J = 1, N
                  IF( ALPHA.NE.ONE )THEN
                     DO 170, I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
  170                CONTINUE
                  END IF
                  DO 190, K = 1, J - 1
                     IF( A( K, J ).NE.ZERO )THEN
                        DO 180, I = 1, M
                           B( I, J ) = B( I, J ) - A( K, J )*B( I, K )
  180                   CONTINUE
                     END IF
  190             CONTINUE
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( J, J )
                     DO 200, I = 1, M
                        B( I, J ) = TEMP*B( I, J )
  200                CONTINUE
                  END IF
  210          CONTINUE
            ELSE
               DO 260, J = N, 1, -1
                  IF( ALPHA.NE.ONE )THEN
                     DO 220, I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
  220                CONTINUE
                  END IF
                  DO 240, K = J + 1, N
                     IF( A( K, J ).NE.ZERO )THEN
                        DO 230, I = 1, M
                           B( I, J ) = B( I, J ) - A( K, J )*B( I, K )
  230                   CONTINUE
                     END IF
  240             CONTINUE
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( J, J )
                     DO 250, I = 1, M
                       B( I, J ) = TEMP*B( I, J )
  250                CONTINUE
                  END IF
  260          CONTINUE
            END IF
         ELSE
C
C           Form  B := alpha*B*inv( A' ).
C
            IF( UPPER )THEN
               DO 310, K = N, 1, -1
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( K, K )
                     DO 270, I = 1, M
                        B( I, K ) = TEMP*B( I, K )
  270                CONTINUE
                  END IF
                  DO 290, J = 1, K - 1
                     IF( A( J, K ).NE.ZERO )THEN
                        TEMP = A( J, K )
                        DO 280, I = 1, M
                           B( I, J ) = B( I, J ) - TEMP*B( I, K )
  280                   CONTINUE
                     END IF
  290             CONTINUE
                  IF( ALPHA.NE.ONE )THEN
                     DO 300, I = 1, M
                        B( I, K ) = ALPHA*B( I, K )
  300                CONTINUE
                  END IF
  310          CONTINUE
            ELSE
               DO 360, K = 1, N
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( K, K )
                     DO 320, I = 1, M
                        B( I, K ) = TEMP*B( I, K )
  320                CONTINUE
                  END IF
                  DO 340, J = K + 1, N
                     IF( A( J, K ).NE.ZERO )THEN
                        TEMP = A( J, K )
                        DO 330, I = 1, M
                           B( I, J ) = B( I, J ) - TEMP*B( I, K )
  330                   CONTINUE
                     END IF
  340             CONTINUE
                  IF( ALPHA.NE.ONE )THEN
                     DO 350, I = 1, M
                        B( I, K ) = ALPHA*B( I, K )
  350                CONTINUE
                  END IF
  360          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of DTRSM .
C
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c These routines localize the recasting of integer types for the system's iargc
c and getarg routines, which handle the command line arguments for Fortran
c programs.

c#define NO_GETARG
#if defined(_OSF) || defined(_CRAY_PVP)
#   define INTTYPE integer
#else
#   define INTTYPE integer*4
#endif

#ifdef NO_GETARG

      integer function f_iargc()
      f_iargc = 0
      return
      end

      subroutine f_getarg(ndx,sz)
      integer ndx
      character*(*) sz
      if (len(sz).gt.0) sz = " "
      return
      end

#else /* HAVE_GETARG */

      integer function f_iargc()
      INTTYPE iargc
#ifdef _UNICOS
      f_iargc = ipxfargc()
#else
      f_iargc = iargc()
#endif
      return
      end

      subroutine f_getarg(ndx,sz)
      integer ndx, ierr
      character*(*) sz
      INTTYPE i, i2, i3
      i = ndx
#ifdef _UNICOS
      call pxfgetarg(i,sz,i2,i3)
      if (i3.ne.0) then
         write(*,*) '@F_GETARG: pxfgetarg failed'
         write(*,*) '           i = ',i
         ierr = i3
         call c_exit(ierr)
      end if
#else
      call getarg(i,sz)
#endif
      return
      end

#endif /* NO_GETARG */

c This routine opens the unformatted, direct access files used by ACES
c for double precision array (list) storage.

c INPUT
c int IHFILE : the internal unit number (handle) of the file to open

c#define _DEBUG_ACES_IO_OPEN

      subroutine aces_io_open(ihFile)
      implicit none

c ARGUMENTS
      integer ihFile

c INTERNAL VARIABLES
#include "szfiles.dat"
      character*80 szFile
      integer      iLen
      integer iStat
      logical bExist

c COMMON BLOCKS
#include "lists.com" /* for bIOUp */
#include "filspc.com" /* for iprcrl */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iLen = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_IO_OPEN: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iLen = 1
      end if
c   o assert iprcrl was initialized
      if (iprcrl.lt.1) then
         print *, '@ACES_IO_OPEN: Assertion failed.'
         print *, '   iprcrl = ',iprcrl
         iLen = 1
      end if
c   o assert ihFile is properly bound
      if ((ihFile.lt.1).or.(_MAX_IO_LUNS.lt.ihFile)) then
         print *, '@ACES_IO_OPEN: Assertion failed.'
         print *, '   ihFile = ',ihFile
         iLen = 1
      end if
      if (iLen.ne.0) call aces_exit(iLen)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

      call gfname(szFiles(ihFile),szFile,iLen)
      inquire(file=szFile(1:iLen),exist=bExist)

#ifdef _DEBUG_ACES_IO_OPEN
      print *, '@ACES_IO_OPEN: unit=',ihFile-1+_FIRST_IO_LUN,
     &                      ', file=',szFile(1:iLen),
     &                      ', recl=',iprcrl
      print *, '               (iprcwd=',iprcwd,')'
#endif

      if (bExist) then
         open(unit=ihFile-1+_FIRST_IO_LUN,file=szFile(1:iLen),
     &        form='UNFORMATTED',access='DIRECT',recl=iprcrl,
     &        status='OLD',err=9999,iostat=iStat)
      else
         open(unit=ihFile-1+_FIRST_IO_LUN,file=szFile(1:iLen),
     &        form='UNFORMATTED',access='DIRECT',recl=iprcrl,
     &        status='NEW',err=9999,iostat=iStat)
      end if
      return

 9999 call aces_io_error('ACES_IO_OPEN',ihFile-1+_FIRST_IO_LUN,iStat)

c     end subroutine aces_io_open
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__NORMALIZE_OVERLAP_DENSITY
     +
     +                    ( NBAS,
     +                      X,
     +                      LABEL,
     +
     +                             DENORM,
     +                             D,S )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__NORMALIZE_OVERLAP_DENSITY
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine normalizes the overlap matrix and also
C                updates the density matrix. This is necessary to get
C                the proper weighting in the averaging of the density
C                matrix blocks over the m-quantum number.
C
C                The density matrix elements D (i,j) are defined as the
C                expansion coefficients of the one electron density
C                rho (r,r) in terms of atomic orbital basis products:
C
C
C                          rho (r,r) = sum  D (i,j) |i> <j|
C                                       ij
C
C                Lets assume the AO basis is not normalized, that is:
C
C                             S (i,i) = <i|i> neq 1
C                             S (j,j) = <j|j> neq 1
C
C                We obtain new normalized AO's via:
C
C                                 ___________
C                        |i'> = \/ (1/S(i,i)) * |i>
C                                 ___________
C                        |j'> = \/ (1/S(j,j)) * |j>
C
C                which we can use to write a new rho (r,r) expansion:
C
C
C                          rho (r,r) = sum  D'(i,j) |i'> <j'|
C                                       ij
C
C                from which we deduce that:
C
C                                   _______     _______
C                       D'(i,j) = \/ S(i,i) * \/ S(j,j) * D(i,j)
C
C
C                The normalized matrix elements are then given by:
C
C                                ___________     ___________
C                    S'(i,j) = \/ (1/S(i,i)) * \/ (1/S(j,j)) * S(i,j)
C
C
C                Since the square roots of the diagonal overlap matrix
C                elements will be needed in order to express the
C                natural orbitals in the original unnormalized AO basis,
C                they are stored in a special array and returned.
C
C
C
C                Input:
C
C                     NBAS = size of AO basis.
C                        X = storage array of floating type.
C                    LABEL = storage array of integer type of size
C                            NBAS.
C                      D,S = original density and overlap matrix.
C
C                Output:
C
C                   DENORM = denormalization factors.
C                      D,S = normalized density and overlap matrix.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I,J,K,N
         INTEGER    NBAS

         INTEGER    LABEL (1:NBAS)

         DOUBLE PRECISION  SDIAG
         DOUBLE PRECISION  SSQR
         DOUBLE PRECISION  ONE
         DOUBLE PRECISION  TINY
         DOUBLE PRECISION  XK,YK

         DOUBLE PRECISION  DENORM (1:NBAS)
         DOUBLE PRECISION  X      (1:NBAS)

         DOUBLE PRECISION  D (1:NBAS,1:NBAS)
         DOUBLE PRECISION  S (1:NBAS,1:NBAS)

         PARAMETER    (ONE   =  1.D0 )
         PARAMETER    (TINY  =  1.D-10)
C
C
C------------------------------------------------------------------------
C
C
C             ...search through the diagonal elements of the
C                overlap matrix S and identify those which are
C                different from 1 within a tolerance limit.
C                Save the square root and the inverse of the
C                square root for further use.
C
C
         N = 0
         DO 10 I = 1,NBAS
            SDIAG = S (I,I)
            IF ( DABS (SDIAG - ONE).GT.TINY ) THEN
                 SSQR = DSQRT (SDIAG)
                 N = N + 1
                 X (N) = SSQR
                 DENORM (N) = ONE / SSQR
                 LABEL (N) = I
            END IF
   10    CONTINUE
C
C
C             ...update the overlap and density matrix with inner
C                loops over rows to minimize cache misses.
C
C
         IF (N.NE.0) THEN
             DO 20 J = 1,NBAS
             DO 20 K = 1,N
                I = LABEL (K)
                D (I,J) =      X (K) * D (I,J)
                S (I,J) = DENORM (K) * S (I,J)
   20        CONTINUE

             DO 30 K = 1,N
                J = LABEL (K)
                XK = X (K)
                YK = DENORM (K)
                DO 32 I = 1,NBAS
                   D (I,J) = XK * D (I,J)
                   S (I,J) = YK * S (I,J)
   32           CONTINUE
   30        CONTINUE
         END IF
C
C
C             ...generate the denormalization array.
C
C
         DO 40 I = 1,NBAS
            DENORM (I) = ONE
   40    CONTINUE

         DO 50 K = 1,N
            I = LABEL (K)
            DENORM (I) = X (K)
   50    CONTINUE
C
C
C             ...print for checking.
C
C
C         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
C     +
C     +                ( 1,
C     +                  ' Overlap matrix after normalization',
C     +                  NBAS,NBAS,
C     +                  NBAS,NBAS,
C     +                  S )
C     +
C     +
         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
     +
     +                ( 1,
     +                  ' Density matrix after normalization',
     +                  NBAS,NBAS,
     +                  NBAS,NBAS,
     +                  D )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE RETRIEVE(E, V1,V2,STEP,VEC)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
      LOGICAL XYZIN, NWFINDIF
      CHARACTER*(fnamelen) FNAME
C
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $        ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $        XYZTol
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      CHARACTER*10 CRAP,CRAP2
      DIMENSION V1(NXM6),V2(NXM6*NXM6),STEP(NXM6),VEC(NOPT)
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
      DATA CRAP /'***CYCLE  '/
C
      IF( ncycle .NE. 0 )WRITE(6,933)
933   FORMAT(T3,' Retrieving information from last optimization cycle.')
      CALL GFNAME(ARCFIL,FNAME,ILENGTH)
      OPEN(UNIT=LuArc,FILE=fname(1:ilength),STATUS='OLD',
     &     FORM='UNFORMATTED')
C
C NUMBER OF RECORDS IN .OPT IS ONE GREATER THAN THE NUMBER OF
C  OPTIMIZATION CYCLES.
C
      DO 101 K=1,nCYCLE
         READ(LuArc)CRAP2
         IF(CRAP2.NE.CRAP)then
            Write (LuErr,*) ' *Problem with optimization archive file.'
            Call ErrEx
         EndIf
 101  Continue
      Write(6,*)
      Print*, "Start Reading Archive file NXM6: ", NXM6
C
      READ(LuArc)CRAP2,iarchx,ICYCLE,NATOMS,NX,NUNIQUE,NOPT,IPRNT,INR,
     $     IVEC,
     $ IDIE,IMXSTP,ISTCRT,IVIB,ICURVY,ICONTL,IRECAL,INTTYP,IDISFD,
     $ IGRDFD,ICNTYP,ISYM,IBASIS,E,
     $   (V1(I),I=1,NXM6),
     $   (V2(I),I=1,NXM6*NXM6),(STEP(J),J=1,NXM6),(R(J),J=1,NXM6),
     $   (Q(J),J=1,NX),(NCON(I),I=1,NX),(ZSYM(I),I=1,NATOMS),
     &   (VARNAM(I),I=1,NX),(PARNAM(I),I=1,NX),(ISQUASH(J),J=1,NXM6),
     &   (IATNUM(I),I=1,NATOMS),(ATMASS(I),I=1,NATOMS),
     $   (IUNIQUE(J),J=1,NUNIQUE),(NEQ(J),J=1,NXM6),
     $   ((IEQUIV(I,J),J=1,NEQ(IUNIQUE(I))),I=1,NUNIQUE),
     &   (NOPTI(J),J=1,NOPT), (VEC(J),J=1,NOPT),FPGRP,BPGRP,PGRP,
     $   ((ORIENT(I,J),J=1,3),I=1,3)
         IF(CRAP2.NE.CRAP)then
            Write (LuErr,*) ' *Problem with optimization archive file.'
            Call ErrEx
         EndIf
C

C
C DECOMPRESS INTERNAL COORINATE VECTOR
C
      XYZIN = IFLAGS(68) .GT. 0
C
      IF (.NOT. XYZIN) THEN 
         DO J=NX,10,-1
            R(J)=R(J-6)
         ENDDO 
         R(8)=R(3)
         R(7)=R(2)
         R(4)=R(1)
         R(1)=0.D0
         R(2)=0.D0
         R(3)=0.D0
         R(5)=0.D0
         R(6)=0.D0
         R(9)=0.D0
       ENDIF
C

C
      CLOSE(77,STATUS='KEEP')
      RETURN
      END

C  Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
C  USA
         SUBROUTINE  OED__XYZ_DERV_CSGTO
     +
     +                    ( IMAX,ZMAX,
     +                      NALPHA,NCOEFF,NCSUM,
     +                      NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      DER1X,DER1Y,DER1Z,
     +                      DER2X,DER2Y,DER2Z,
     +                      XMOMD,YMOMD,ZMOMD,             ! Watson Added
     +                      ALPHA,CC,CCBEG,CCEND,
     +                      L1CACHE,TILE,NCTROW,
     +                      SPHERIC,SCREEN,
     +                      ICORE,
     +
     +                                NBATCH,
     +                                NFIRST,
     +                                ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_DERV_CSGTO
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__XYZ_SET_DERV_AB
C                OED__OVL_SET_IJ_PAIRS
C                OED__OVL_SET_DERV_SEQUENCE
C                OED__XYZ_DERV_DEF_BLOCKS
C                OED__OVL_PREPARE_CTR
C                OED__XYZ_DERV_PCGTO_BLOCK
C                OED__CTR_2INDEX_BLOCK
C                OED__CTR_2INDEX_REORDER
C                OED__TRANSPOSE_BATCH
C                OED__XYZ_TO_RY_AB
C                OED__CARTESIAN_NORMS
C                OED__SPHERICAL_TRANSFORM
C                OED__NORMALIZE_CARTESIAN
C                OED__MOVE_RY
C  DESCRIPTION : This operation calculates a batch of differentiated
C                contracted moment integrals on up to two different
C                centers between spherical or cartesian gaussian type
C                shells.
C
C
C                  Input (x = 1 and 2):
C
C                    IMAX,ZMAX    =  maximum integer,flp memory
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCSUM        =  total # of contractions
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    DERyp        =  the order of differentiation on
C                                    centers y = 1 and 2 with respect
C                                    to the p = x,y,z coordinates
C                    xMOMD        =  type of moment integral to be
C                                    differentiated. x = X, Y, or Z
C                    ALPHA        =  primitive exponents for csh
C                                    1 and 2 in that order
C                    CC           =  full set (including zeros) of
C                                    contraction coefficients for csh
C                                    1 and 2 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction
C                    CC(BEG)END   =  (lowest)highest nonzero primitive
C                                    index for contractions for csh
C                                    1 and 2 in that order. They are
C                                    different from (1)NPGTOx only for
C                                    segmented contractions
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C                    SCREEN       =  is true, if screening will be
C                                    done at primitive integral level
C                    ICORE        =  integer scratch space
C                    ZCORE (part) =  flp scratch space
C
C                  Output:
C
C                    NBATCH       =  # of derivative integrals in batch
C                    NFIRST       =  first address location inside the
C                                    ZCORE array containing the first
C                                    derivative integral
C                    ZCORE        =  full batch of contracted (1|2)
C                                    derivative overlap integrals over
C                                    cartesian or spherical gaussians
C                                    starting at ZCORE (NFIRST)
C
C
C
C              --- NOTES ABOUT THE OVERALL OVLP INTEGRAL PREFACTOR ---
C
C                The overal overlap integral prefactor is defined here
C                as follows. Consider the normalization factors for a
C                primitive cartesian GTO and for a spherical GTO
C                belonging to the angular momentum L = l+m+n:
C
C
C                    lmn                        l m n           2
C                 GTO  (x,y,z) = N (l,m,n,a) * x y z  * exp (-ar )
C                    a
C
C
C                    LM                     L    LM                2
C                 GTO  (r,t,p) = N (L,a) * r  * Y  (t,p) * exp (-ar )
C                    a
C
C
C                where a = alpha exponent, t = theta and p = phi and
C                N (l,m,n,a) and N (L,a) denote the respective
C                cartesian and spherical normalization factors such
C                that:
C
C
C                              lmn            lmn
C                 integral {GTO  (x,y,z) * GTO   (x,y,z) dx dy dz} = 1
C                              a              a
C
C
C                              LM             LM
C                 integral {GTO  (r,t,p) * GTO  (r,t,p) dr dt dp} = 1
C                              a              a
C
C
C                The normalization constants have then the following
C                values, assuming the spherical harmonics are
C                normalized:
C
C                              _____________________________________
C                             /      2^(2L+1+1/2) * a^((2L+3)/2)
C            N (l,m,n,a) =   / ----------------------------------------
C                          \/ (2l-1)!!(2m-1)!!(2n-1)!! * pi * sqrt (pi)
C
C
C                                   ____________________________
C                                  / 2^(2L+3+1/2) * a^((2L+3)/2)
C                     N (L,a) =   / -----------------------------
C                               \/     (2L+1)!! * sqrt (pi)
C
C
C                Note, that the extra pi under the square root in
C                N (l,m,n,a) belongs to the normalization of the
C                spherical harmonic functions and therefore does not
C                appear in the expression for N (L,a). The common
C                L-,l-,m-,n- and a-independent part of the cartesian
C                norm is a scalar quantity needed for all integrals
C                no matter what L-,l-,m-,n- and a-values they have:
C
C                                       _____________
C                                      /  2^(1+1/2)
C                     N (0,0,0,0) =   / --------------
C                                   \/  pi * sqrt (pi)
C
C
C                Also every overlap integral has a factor of pi**(3/2)
C                associated with it, hence the overall common factor
C                for all overlap integrals will be N(0,0,0,0)**2 times
C                pi**(3/2), which is equal to:
C
C                                          ___
C                            PREFACT  =  \/ 8 
C
C
C                and is set as a parameter inside the present routine.
C                The alpha exponent dependent part of the norms:
C
C                                   ______________
C                                 \/ a^((2L+3)/2)
C
C                will be calculated separately (see below) and their
C                inclusion in evaluating the primitive cartesian
C                derivative overlap [A|B] integrals will be essential
C                for numerical stability during contraction.
C
C
C  AUTHOR      : Norbert Flocke
C
C  MODIFIED    : Thomas Watson
C                   - Changed to do derivatives of moment integrals
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     BLOCKED
         LOGICAL     DIFFA,DIFFB
         LOGICAL     DIFFX,DIFFY,DIFFZ
         LOGICAL     EMPTY
         LOGICAL     EQUALAB
         LOGICAL     MEMORY
         LOGICAL     REORDER
         LOGICAL     SCREEN
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAPRS

         INTEGER     XMOMD,YMOMD,ZMOMD                     ! Watson Added
         INTEGER     DER1X,DER1Y,DER1Z
         INTEGER     DER2X,DER2Y,DER2Z
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     ICENSQX,ICENSQY,ICENSQZ
         INTEGER     IMAX,ZMAX
         INTEGER     IN,OUT
         INTEGER     INDEXA,INDEXB
         INTEGER     INDEXR,INDEXS
         INTEGER     IPRIMA,IPRIMB
         INTEGER     IPUSED,IPSAVE,IPPAIR
         INTEGER     ISNROWA,ISNROWB
         INTEGER     ISROWA,ISROWB
         INTEGER     IUSED,ZUSED
         INTEGER     L1CACHE,TILE,NCTROW
         INTEGER     LCC1,LCC2
         INTEGER     LCCA,LCCB
         INTEGER     LCCSEGA,LCCSEGB
         INTEGER     LEXP1,LEXP2
         INTEGER     LEXPA,LEXPB
         INTEGER     MIJ
         INTEGER     NOVRLP,NOVRSCR                        ! Watson Added
         INTEGER     MOVE,NOTMOVE
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSHELL
         INTEGER     NALPHA,NCOEFF,NCSUM
         INTEGER     NBATCH,NFIRST
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NCGTOA,NCGTOB,NCGTOAB
         INTEGER     NCGTOR,NCGTOS
         INTEGER     NCTR
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NIJ,NIJBLK,NIJBEG,NIJEND
         INTEGER     NINT1DX,NINT1DY,NINT1DZ
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NPGTOA,NPGTOB,NPGTOAB
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NROTA,NROTB
         INTEGER     NROWA,NROWB
         INTEGER     NRYA,NRYB
         INTEGER     NXYZA,NXYZB,NXYZT
         INTEGER     SHELL1,SHELL2
         INTEGER     SHELLA,SHELLB,SHELLP
         INTEGER     TEMP

         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,
     +               ZBASE,ZCNORM,
     +               ZRHOAB,
     +               ZPAX,ZPAY,ZPAZ,
     +               ZPINVHF,ZSCALE,ZEXP2A,ZEXP2B,
     +               ZINT1DX,ZINT1DY,ZINT1DZ,
     +               ZSROTA,ZSROTB,
     +               ZIP,ZOVRLP,ZOVRSCR,ZPINVA,ZPINVB      ! Watson Added

         INTEGER     CCBEG (1:NCSUM)
         INTEGER     CCEND (1:NCSUM)
         INTEGER     ICORE (1:IMAX)
         INTEGER     IXOFF (1:2)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  PREFACT
         DOUBLE PRECISION  RNABSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
         DOUBLE PRECISION  ZCORE (1:ZMAX)

         PARAMETER  (PREFACT = 2.828427124746190D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...fix the A,B labels from the 1,2 ones. Calculate
C                the relevant data for the A,B batch of derivative
C                overlap integrals.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LCC1  = 1
         LCC2  = LCC1 + NPGTO1 * NCGTO1

         CALL  OED__XYZ_SET_DERV_AB
     +
     +              ( NCGTO1,NCGTO2,
     +                NPGTO1,NPGTO2,
     +                SHELL1,SHELL2,
     +                X1,Y1,Z1,X2,Y2,Z2,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                CC (LCC1),CC (LCC2),
     +                DER1X,DER1Y,DER1Z,
     +                DER2X,DER2Y,DER2Z,
     +                XMOMD,YMOMD,ZMOMD,                   ! Watson Added
     +                SPHERIC,
     +
     +                            NCGTOA,NCGTOB,
     +                            NPGTOA,NPGTOB,
     +                            SHELLA,SHELLB,SHELLP,
     +                            MXSHELL,
     +                            XA,YA,ZA,XB,YB,ZB,
     +                            NDERX,NDERY,NDERZ,
     +                            DERAX,DERAY,DERAZ,
     +                            DERBX,DERBY,DERBZ,
     +                            DIFFA,DIFFB,
     +                            DIFFX,DIFFY,DIFFZ,
     +                            ABX,ABY,ABZ,RNABSQ,
     +                            SPNORM,
     +                            NXYZA,NXYZB,NXYZT,
     +                            NRYA,NRYB,
     +                            INDEXA,INDEXB,
     +                            SWAP12,SWAPRS,
     +                            LEXPA,LEXPB,
     +                            LCCA,LCCB,
     +                            LCCSEGA,LCCSEGB,
     +                            EMPTY )
     +
     +
C         WRITE (*,*) ' Finished set derivative ab '
C         WRITE (*,*) ' Index A,B = ',INDEXA,INDEXB

         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...enter the cartesian contracted (a|b) overlap batch
C                generation. Set the i and j primitive exponent
C                sets and the corresponding exponential prefactors.
C                Since all derivatives of the overlap integrals on
C                atoms are equal to zero, we set variables ATOMIC
C                EQUALAB equals to false once and for all for further
C                use.
C
C             ...Watson: Disregard the latter part of the previous
C                        paragraph.  The variables will still be set
C                        to false once and for all, but the atomic 
C                        integrals are taken care of.
C
C
         ATOMIC = .FALSE.
         EQUALAB = .FALSE.

         NPGTOAB = NPGTOA * NPGTOB
         NCGTOAB = NCGTOA * NCGTOB

         IPRIMA = 1
         IPRIMB = IPRIMA + NPGTOAB

         CALL  OED__OVL_SET_IJ_PAIRS
     +
     +              ( NPGTOA,NPGTOB,NPGTOAB,
     +                ATOMIC,EQUALAB,
     +                SWAPRS,
     +                RNABSQ,
     +                PREFACT,
     +                ALPHA (LEXPA),ALPHA (LEXPB),
     +                SCREEN,
     +
     +                         EMPTY,
     +                         NIJ,
     +                         ICORE (IPRIMA),ICORE (IPRIMB),
     +                         ZCORE (1) )
     +
     +
         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...determine the sequence of centers for derivation
C                for each coordinate.
C
C
         ICENSQX = IPRIMB + NPGTOAB
         ICENSQY = ICENSQX + NDERX + 1
         ICENSQZ = ICENSQY + NDERY + 1

         CALL  OED__OVL_SET_DERV_SEQUENCE
     +
     +              ( NDERX,NDERY,NDERZ,
     +                DERAX,DERAY,DERAZ,
     +                DERBX,DERBY,DERBZ,
     +
     +                            ICORE (ICENSQX),
     +                            ICORE (ICENSQY),
     +                            ICORE (ICENSQZ) )
     +
     +
C
C
C             ...decide on the primitive [a|b] block size and
C                return array sizes and pointers for the primitive
C                [a|b] generation. Perform also some preparation
C                steps for contraction.
C
C
         MEMORY = .FALSE.

         CALL  OED__XYZ_DERV_DEF_BLOCKS
     +
     +              ( ZMAX,
     +                NPGTOA,NPGTOB,
     +                SHELLA,SHELLB,SHELLP,
     +                NIJ,NCGTOAB,
     +                NXYZT,
     +                DERAX,DERAY,DERAZ,
     +                DERBX,DERBY,DERBZ,
     +                XMOMD,YMOMD,ZMOMD,                   ! Watson Added
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                        NIJBLK,
     +                        NBATCH,
     +                        NOVRLP,NOVRSCR,              ! Watson Added
     +                        NPSIZE,NCSIZE,NWSIZE,
     +                        NINT1DX,NINT1DY,NINT1DZ,
     +                        MXPRIM,MNPRIM,
     +                        ZCBATCH,ZPBATCH,ZWORK,
     +                        ZNORMA,ZNORMB,
     +                        ZRHOAB,
     +                        ZPAX,ZPAY,ZPAZ,                ! Watson Added
     +                        ZPINVHF,ZSCALE,
     +                        ZEXP2A,ZEXP2B,
     +                        ZINT1DX,ZINT1DY,ZINT1DZ,
     +                        ZIP,ZOVRLP,ZOVRSCR,ZPINVA,ZPINVB )
     +
     +
         BLOCKED = NIJBLK .LT. NIJ

         CALL  OED__OVL_PREPARE_CTR
     +
     +              ( NCSIZE,
     +                NIJ,
     +                NPGTOA,NPGTOB,
     +                SHELLA,SHELLB,
     +                ALPHA (LEXPA),ALPHA (LEXPB),
     +                PREFACT,SPNORM,
     +                EQUALAB,
     +                BLOCKED,
     +                ZCORE (1),
     +
     +                          ZCORE (ZNORMA),ZCORE (ZNORMB),
     +                          ZCORE (ZRHOAB),
     +                          ZCORE (ZCBATCH) )
     +
     +
         IPUSED = ICENSQZ + NDERZ + 1
         IPSAVE = IPUSED + MNPRIM
         IPPAIR = IPSAVE + MXPRIM
C
C
C             ...evaluate unnormalized rescaled [a|b] derivative
C                overlap integrals in blocks over ij pairs and add to
C                final contracted (a|b) derivative overlap integrals.
C                The keyword REORDER indicates, if the primitive [a|b]
C                derivative overlap integrals need to be transposed
C                before being contracted.
C
C
         REORDER = .TRUE.

         DO 1000 NIJBEG = 1,NIJ,NIJBLK
            NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
            MIJ = NIJEND - NIJBEG + 1

            CALL  OED__XYZ_DERV_PCGTO_BLOCK
     +
     +                 ( NBATCH,
     +                   NOVRLP,NOVRSCR,                   ! Watson Added
     +                   NINT1DX,NINT1DY,NINT1DZ,
     +                   MIJ,NIJ,NIJBEG,NIJEND,
     +                   NPGTOA,NPGTOB,
     +                   NXYZA,NXYZB,
     +                   SHELLA,SHELLB,SHELLP,
     +                   XA,YA,ZA,XB,YB,ZB,
     +                   ABX,ABY,ABZ,
     +                   XMOMD,YMOMD,ZMOMD,                ! Watson Added
     +                   NDERX,NDERY,NDERZ,
     +                   DERAX,DERAY,DERAZ,
     +                   DERBX,DERBY,DERBZ,
     +                   DIFFX,DIFFY,DIFFZ,
     +                   DIFFA,DIFFB,
     +                   ALPHA (LEXPA),ALPHA (LEXPB),
     +                   ICORE (ICENSQX),
     +                   ICORE (ICENSQY),
     +                   ICORE (ICENSQZ),
     +                   ICORE (IPRIMA+NIJBEG-1),
     +                   ICORE (IPRIMB+NIJBEG-1),
     +                   ZCORE (ZNORMA),ZCORE (ZNORMB),
     +                   ZCORE (ZRHOAB),
     +                   ZCORE (ZPAX),ZCORE (ZPAY),ZCORE (ZPAZ),
     +                   ZCORE (ZPINVA),ZCORE (ZPINVB),    ! Watson Added
     +                   ZCORE (ZPINVHF),ZCORE (ZSCALE),
     +                   ZCORE (ZEXP2A),ZCORE (ZEXP2B),
     +                   ZCORE (ZINT1DX),
     +                   ZCORE (ZINT1DY),
     +                   ZCORE (ZINT1DZ),
     +                   ZCORE (ZIP),ZCORE (ZOVRLP),ZCORE (ZOVRSCR),! Watson
     +
     +                             ZCORE (ZPBATCH) )
     +
     +
C            WRITE (*,*) ' Finished ab overlap pcgto derv block '

            CALL  OED__CTR_2INDEX_BLOCK
     +
     +                 ( NPSIZE,NCSIZE,NWSIZE,
     +                   NXYZT,
     +                   MIJ,NCGTOAB,
     +                   NPGTOA,NPGTOB,
     +                   NCGTOA,NCGTOB,
     +                   MXPRIM,MNPRIM,
     +                   CC (LCCA),CC (LCCB),
     +                   CCBEG (LCCSEGA),CCBEG (LCCSEGB),
     +                   CCEND (LCCSEGA),CCEND (LCCSEGB),
     +                   ICORE (IPRIMA+NIJBEG-1),
     +                   ICORE (IPRIMB+NIJBEG-1),
     +                   L1CACHE,TILE,NCTROW,
     +                   EQUALAB,
     +                   SWAPRS,
     +                   REORDER,
     +                   BLOCKED,
     +                   ICORE (IPUSED),
     +                   ICORE (IPSAVE),
     +                   ICORE (IPPAIR),
     +                   ZCORE (ZPBATCH),
     +                   ZCORE (ZWORK),
     +
     +                             ZCORE (ZCBATCH) )
     +
     +
C            WRITE (*,*) ' Finished 2 index ctr block '

 1000    CONTINUE
C
C
C             ...the unnormalized cartesian (a|b) contracted overlap
C                derivative batch is ready. Reorder the contraction
C                index part (if necessary):
C
C                   batch (nxyzt,r,s) --> batch (nxyzt,1,2)
C
C                The array IXOFF (x) indicates the total # of indices
C                to the left of x without including the nxyzet-part.
C                For the left most IXOFF value it is convenient to
C                set it equal to 1 instead of 0. Note, that the IXOFF
C                array indicates the true # of indices to the left
C                after! the batch has been transposed (see below) and
C                can be used as initial values when moving the
C                ry-components later during the cartesian -> spherical
C                transformation procedure.
C                
C                Efficient application of the cartesian -> spherical
C                transformation requires the batch elements to be
C                ordered as:
C
C                            batch (1,2,nxyzt)
C
C                hence we transpose the batch after the reordering.
C
C                The space partitioning of the flp array for all of
C                these steps will be as follows:
C
C
C                          |  Zone 1  |  Zone 2  |
C
C                in which Zone 1 and 2 are 2 batches of cartesian
C                (a|b) size.
C
C
         IXOFF (1) = 1
         IXOFF (2) = NCGTO1

         NCTR = NCGTO1 * NCGTO2
         NBATCH = NCTR * NXYZT

         IN = ZCBATCH
         OUT = IN + NBATCH

         REORDER = SWAP12 .NEQV. SWAPRS

         IF (REORDER .AND. NCTR.GT.1) THEN

             IF (SWAPRS) THEN
                 INDEXR = INDEXB
                 INDEXS = INDEXA
                 NCGTOR = NCGTOB
                 NCGTOS = NCGTOA
             ELSE
                 INDEXR = INDEXA
                 INDEXS = INDEXB
                 NCGTOR = NCGTOA
                 NCGTOS = NCGTOB
             END IF

             CALL  OED__CTR_2INDEX_REORDER
     +
     +                  ( NXYZT,NCTR,
     +                    NCGTOR,NCGTOS,
     +                    IXOFF (INDEXR),IXOFF (INDEXS),
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished ctr reorder '

             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

         IF (NXYZT.GT.1 .AND. NCTR.GT.1) THEN

             CALL  OED__TRANSPOSE_BATCH
     +
     +                  ( NXYZT,NCTR,
     +                    TILE,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished transpose batch '

             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF
C
C
C             ...enter the cartesian -> spherical transformation or
C                cartesian normalization section. After one shell
C                is transformed it is moved to its final position.
C                This leads to the sequence of events (where ' means
C                spherical or cartesian normalization and [] means the
C                indices are in positional correspondence):
C
C                       batch (ij,a,b) --> batch (ij,a,b')
C                       batch (ij,a,b') --> batch (ij[b'],a)
C                       batch (ij[b'],a) --> batch (ij[b'],a')
C                       batch (ij[b'],a') --> batch (ij[a'b'])
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                     |  Zone 1  |  Zone 2  |  Zone 3  |
C
C
C                 Zone 1 and 2:  2 batches of cartesian (a|b) size
C                                (set previously)
C
C                       Zone 3:  cart -> spher transformation data
C                                             or
C                                cartesian normalization factors
C
C
C                Determine the memory allocation offsets for the
C                cartesian -> spherical transformations or cartesian
C                normalizations and generate the transformation
C                matrices + associated data for those shells > p-shell.
C                The offsets are as follows (x=A,B):
C
C                    IN = offset for input cartesian (a|b) batch
C                   OUT = offset for output cartesian (a|b) batch
C
C                ZSROTx = offset for x-part transformation matrix
C               ISNROWx = offset for # of non-zero XYZ contribution row
C                         labels for x-part transformation matrix
C                ISROWx = offset for non-zero XYZ contribution row
C                         labels for x-part transformation matrix
C
C
C                In case of s- or p-shells no transformation matrix is
C                generated, hence if we have s- and/or p-shells, then
C                no call to the cartesian -> spherical transformation
C                or cartesian normalization routines needs to be done.
C                Instead all integrals have to be multiplied by a factor
C                SPNORM, which has the following value for each s- and
C                p-shell:
C
C                       For s-type shell  =  1
C
C                       For p-type shell  =  2 * norm for s-type
C
C                This factor was introduced together with the overall
C                prefactor during evaluation of the primitive integrals
C                in order to save multiplications.
C
C
         ZBASE = MAX (IN,OUT) + NBATCH

         IF (SPHERIC) THEN
             IF (MXSHELL.GT.1) THEN
                 CALL  OED__XYZ_TO_RY_AB
     +
     +                      ( NXYZA,NXYZB,
     +                        NRYA,NRYB,
     +                        SHELLA,SHELLB,
     +                        1,ZBASE,
     +
     +                                 NROWA,NROWB,
     +                                 NROTA,NROTB,
     +                                 ZSROTA,ZSROTB,
     +                                 ISNROWA,ISNROWB,
     +                                 ISROWA,ISROWB,
     +                                 IUSED,ZUSED,
     +                                 ICORE,ZCORE )
     +
     +
C                 WRITE (*,*) ' Finished xyz to ry ab '
             ELSE
                 IUSED = 0
                 ZUSED = 0
             END IF
         ELSE
             IF (MXSHELL.GT.1) THEN
                 ZCNORM = ZBASE
                 CALL  OED__CARTESIAN_NORMS
     +
     +                      ( MXSHELL,
     +
     +                                 ZCORE (ZCNORM))
     +
     +
C                 WRITE (*,*) ' Finished cartesian partial norms '
                 IUSED = 0
                 ZUSED = MXSHELL + 1
             ELSE
                 IUSED = 0
                 ZUSED = 0
             END IF
         END IF
C
C
C             ...do cart -> spher transformation / cart normalization
C                (if b > 1):
C
C                        (ij,a,b) --> (ij,a,b')
C
C
         IF (SHELLB.GT.1) THEN
             IF (SPHERIC) THEN
                 CALL  OED__SPHERICAL_TRANSFORM
     +
     +                      ( NCTR*NXYZA,
     +                        NROWB,NXYZB,NRYB,
     +                        ICORE (ISNROWB),
     +                        ICORE (ISROWB),
     +                        ZCORE (ZSROTB),
     +                        ZCORE (IN),
     +
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished sph quart b '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             ELSE
                 CALL  OED__NORMALIZE_CARTESIAN
     +
     +                      ( NCTR*NXYZA,
     +                        NXYZB,
     +                        SHELLB,
     +                        ZCORE (ZCNORM),
     +
     +                                ZCORE (IN) )
     +
     +
C                 WRITE (*,*) ' Finished normalized cart b '
             END IF
         END IF
C
C
C             ...move transformed b shell (if size > 1):
C
C                        (ij,a,b') --> (ij[b'],a)
C
C
         IF (NRYB.GT.1) THEN
             NBATCH = NCTR * NXYZA * NRYB
             NOTMOVE = IXOFF (INDEXB)
             MOVE = NBATCH / (NOTMOVE * NRYB)
             IF (MOVE.GT.1) THEN

                 CALL  OED__MOVE_RY
     +
     +                      ( NBATCH,2,
     +                        NOTMOVE,MOVE,NRYB,
     +                        INDEXB,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry b '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF
C
C
C             ...do cart -> spher / cart normalization (if a > 1):
C
C                        (ij[b'],a) --> (ij[b'],a')
C
C
         IF (SHELLA.GT.1) THEN
             IF (SPHERIC) THEN
                 CALL  OED__SPHERICAL_TRANSFORM
     +
     +                      ( NCTR*NRYB,
     +                        NROWA,NXYZA,NRYA,
     +                        ICORE (ISNROWA),
     +                        ICORE (ISROWA),
     +                        ZCORE (ZSROTA),
     +                        ZCORE (IN),
     +
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished sph quart a '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             ELSE
                 CALL  OED__NORMALIZE_CARTESIAN
     +
     +                      ( NCTR*NRYB,
     +                        NXYZA,
     +                        SHELLA,
     +                        ZCORE (ZCNORM),
     +
     +                                ZCORE (IN) )
     +
     +
C                 WRITE (*,*) ' Finished normalized cart a '
             END IF
         END IF
C
C
C             ...move transformed a shell (if size > 1):
C
C                        (ij[b'],a') --> (ij[a'b'])
C
C
         NBATCH = NCTR * NRYB * NRYA

         IF (NRYA.GT.1) THEN
             NOTMOVE = IXOFF (INDEXA)
             MOVE = NBATCH / (NOTMOVE * NRYA)
             IF (MOVE.GT.1) THEN

                 CALL  OED__MOVE_RY
     +
     +                      ( NBATCH,2,
     +                        NOTMOVE,MOVE,NRYA,
     +                        INDEXA,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry a '

                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF
C
C
C             ...set final pointer to integrals in ZCORE array.
C
C
         NFIRST = IN
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine saxpy(n,da,dx,incx,dy,incy)
      double precision dx(*),dy(*),da
      integer incx,incy,n
      call daxpy(n,da,dx,incx,dy,incy)
      return
      end

      subroutine scopy(n,dx,incx,dy,incy)
      double precision dx(*),dy(*)
      integer incx,incy,n
      call dcopy(n,dx,incx,dy,incy)
      return
      end

      subroutine sscal(n,da,dx,incx)
      double precision da,dx(*)
      integer incx,n
      call dscal(n,da,dx,incx)
      return
      end

      double precision function sdot(n,dx,incx,dy,incy)
      double precision dx(*),dy(*),ddot
      integer incx,incy,n
      sdot=ddot(n,dx,incx,dy,incy)
      return
      end

      double precision function snrm2(n,x,incx)
      double precision x(*),dnrm2
      integer incx,n
      snrm2=dnrm2(n,x,incx)
      return
      end

      double precision function ssum(n,dx,incx)
      double precision dx(*),dsum
      integer incx,n
      ssum=dsum(n,dx,incx)
      return
      end

      integer function isamax(n,dx,incx)
      double precision dx(*)
      integer incx,n,idamax
      isamax=idamax(n,dx,incx)
      return
      end

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It performs calculation of values of molecular orbitals      |
C   at current grid point g                                     |     
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|
      subroutine f12_2center_moobj(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)


c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'F12.h'
      include 'F12_gr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

c---------------Variables--------------------------------------------

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array
      integer op(loptable_entry),sind
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block

      integer array_type, nindex, inda(2), indb(2)

      logical direct_flag

      integer i, j, k
      integer nind, nsend,n_orb
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, scfevec, indblk, get_block_index
      integer*8 integral_scr
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack

      double precision x(1),int_type_p
      double precision dbuf(1), temp,g
      integer ibuf(1)
      integer int_type, obj_type,g1
c----------------------------------------------------------------------
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      array = op(c_result_array)
      direct_flag = .false.

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c-------------------------------------------------------------------
        
c-------------------------------------------------------------------

c--------------------------------------------------------------------
c  At this step we create array aoint if it was not created before  |
c--------------------------------------------------------------------

      call create_current_block(array,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., direct_flag, blk, ierr)
      blkndx = ierr



      call get_block_computed_flag(array, blk, blkndx, flag)
      if (flag .eq. 0) then
         call set_opblock(array, blk, blkndx, op)
         call set_block_computed_flag(array, blk, blkndx, 1)
      endif

      stack = array_table(c_array_stack,array)
      indblk = get_block_index(array, blk, stack,
     *                         blkndx, x, .true.)

c--------------------------------------------------------------------------
c   Get the segment ranges for each index of the integral array.
c--------------------------------------------------------------------------

      block = find_current_block(array, array_table(1,array),
     *                          index_table, nindex_table,
     *                          segment_table, nsegment_table,
     *                          block_map_table, blkndx)

      stack = array_table(c_array_stack, array)
      indblk = get_block_data_index(array, block, stack,
     *                              blkndx, x)




c---------------------------------------------------------------------------
c--------------------------------------------------------------------------
c   Get the segment ranges for each index of the integral array.
c--------------------------------------------------------------------------

      nind = array_table(c_nindex,array)
      if (nind .ne. 1) then
         print *,'Error: must be only 1 index. This sucks ',
     *        array,' which has ',nind,' indices.'
         print *,'       This routine requires 1 indices.'
         call abort_job()
      endif

      do i = 1, nind
         ind = array_table(c_index_array1+i-1,array)
         seg = index_table(c_current_seg,ind)
         call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c------------Information about scalar--------------------------------------

      array = op(c_op1_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The Second argument in get_ijk  
     *            must be a scalar.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in get_ijk, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

      g = scalar_table(sind)
      g1 = g
c---------------------------------------------------------------------------

c           write(6,*) val1(1),val2(1),'<----'

      array = 2 ! SCF vectors alpha   
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: SCF vectors arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: SCF vectors array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, na)  ! pick up length
      enddo

      scfevec = get_index_from_base(address_table(array), x, 2)
      n_orb = indb(1)
C----------------------------------------------------------------------|
c       Calculation of values of molecular orbitals of given segment   |
c                    for current point g                               |
                 obj_type = 1
c-----------------------------------------------------------------------
              
      if (.not. dryrun) then 
       call twocenter_obj(n_orb,x(scfevec),g1,val1(1),val2(1),x(indblk),
     & obj_type)
         
       endif


      return
      end

#include "flags.h"
      SUBROUTINE ANLYSHES(HESMOD, DIAGHES, QST_TANGENT, LST_TANGENT,
     &                    HES, GRDMOD, SCRATCH, PMAT, VEC, NOPT, NX,
     &                    NCYCLE, INR, IVEC, IMODE, IDIE, TS, 
     &                    NRORMANR, RFA, EVFTS, IGTS, QSD, LUOUT,
     &                    QSTLST_CLIMB, NATOMS,
     &                    IPRNT)
C
C Do some printing, and based on the character of the Hessian 
C plus user input decide the what we are going to do.
C
C HES    : The symmetrized Hessian
C HESMOD : The eigenvalues of the symmetrized Hessian
C DIAGHES: The eigenvectors of the symmetrized Hessian
C GRDMOD : The symmetrized gradients
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      LOGICAL TS, NRORMANR, RFA, EVFTS, IGTS, QSD
      LOGICAL LST, QST, QSTORLST, QSTLST_CLIMB, FAILED, RX_PR_EXIST
C
#include "jodaflags.com"
C
      DIMENSION HESMOD(NOPT, NOPT), DIAGHES(NOPT, NOPT), 
     &          SCRATCH(NX*NX), VEC(NOPT), PMAT(NX*NX)
      DIMENSION QST_TANGENT(NOPT), LST_TANGENT(NOPT), GRDMOD(NOPT),
     &          HES(NOPT, NOPT)
C
      INEG = 0
      ZOVLP = 0.0D00
C
      TS       = (INR .EQ. 4 .OR. INR .EQ. 5)
      NRORMANR = (INR .EQ. 1 .OR. INR .EQ. 3)
      RFA      = (INR .EQ. 2)
      EVFTS    = (INR .EQ. 4 .OR. INR .EQ. 5)
      IGTS     = (INR .EQ. 6)
      QSD      = (INR .EQ. 7)
      QSTLST_CLIMB = .FALSE. 
C     
C Let's Print out the eigenvalues and eigenvectors of the Hessian
C
#ifdef _DEBUG_LVL0
          Write(6,*)
          WRITE(LUOUT,2110)
 2110     FORMAT (T3,' The eigenvectors of the Hessian matrix: ')
          CALL HESSOUT(DIAGHES, NOPT, NOPT, 1)
#endif
#ifdef _DEBUG_LVL0
          Write(6,*)
          WRITE(LUOUT,2103)
2103      FORMAT(T3,' The eigenvalues of the Hessian matrix: ')
          WRITE(LUOUT,2101)((HESMOD(I,J),J=I,I),I=1,NOPT)
2101      FORMAT((T3, 6(F10.5,1X)))
#endif
C
      Do Imode = 1, NOPT
         If (Dabs(HesMoD(Imode, Imode)) .LT.  1.0D-09)
     &           HesMOD(Imode, Imode) = 0.0D0
         If (Dabs(GrdMod(Imode)) .LT. 1.0D-09) GrdMod(Imode) = 0.0D0
      Enddo 
       
      DO 1102 J = 1, NOPT
         SCRATCH(J) = HESMOD(J,J)
         IF (HESMOD(J,J).LT.0.0D0) INEG = INEG + 1
 1102 CONTINUE
C
      Write(6,*)
      WRITE(LUOUT, 2102) INEG
 2102 FORMAT(T1,' There are ',i2,' Negative Eigenvalues.')
C
      CALL DGETREC(0,'JOBARC','RXSTRUCT',ILENGTH1,TMP)
      CALL DGETREC(0,'JOBARC','PRSTRUCT',ILENGTH2,TMP)
      IF (ILENGTH1 .GT. 0 .AND. ILENGTH2 .GT. 0) RX_PR_EXIST = .TRUE. 

      IF (IFLAGS2(h_IFLAGS2_opt_control) .EQ. 1 
     &                                   .AND. RX_PR_EXIST) THEN
         LST = .TRUE. 
      ELSE IF (IFLAGS2(h_IFLAGS2_opt_control) .EQ. 2 
     &                                   .AND. RX_PR_EXIST) THEN
         QST = .TRUE.
      ENDIF 
 
      QSTORLST = (NCYCLE.LE.4.AND.(QST.OR.LST).AND.TS)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,3l)") "Logicals;LST,QST,QSTORLST :", LST, QST, 
     &                                                 QSTORLST
      Write(6,*)
#endif

C I doubt that if we are following an eigenvector that does not
C correspond to the lowest eiegenvalue, the QST or LST is
C useful. That is the reason for test IVEC > 1.
C
      IF (TS.AND.IVEC.GE.1.AND.QSTORLST) THEN

C Get the LST and QST direction vectors. The formulas directly taken from the
C Schlegel, Isreal Journal of Chemistry 33, 449, 1993.

         If (iFlags2(h_IFLAGS2_geom_opt) .EQ. 1) Then
            CALL EVAL_QSTLST_PATH_UDI(QST_TANGENT, LST_TANGENT, 
     &                                SCRATCH, LST, QST)
         Else if (iFlags2(h_IFLAGS2_geom_opt) .EQ. 2) then
            CALL EVAL_QSTLST_PATH_XYZ(QST_TANGENT, LST_TANGENT, 
     &                                SCRATCH, LST, QST)
         Else if (iFlags2(h_IFLAGS2_geom_opt) .Gt. 2) Then
            CALL EVAL_QSTLST_PATH_RIC(QST_TANGENT, LST_TANGENT, 
     &                                SCRATCH, PMAT, LST, QST)   
         Endif
         
C We need to decide whether we choose QST or LST climbing or eigenvector
C following.
C The recommendation in Schlegel et al. is "estimated displacement
C along the tangent vector is greater than 0.05 au. to use climbing.
C Otherwise it is a standard eigenvector following. With regards to
C eigenvector following Schlegel recommend that when the overlap
C between LST or QST tangent with the Hessian eigenvectors is greater
C than 0.08 au, then switch the eigenvectors to follow the one with
C the maximum overlap with the tangent; otherwise, the eigenvector
C with the smallest eigenvalue is followed.
C
C Also, Schlegel recommend to cap the QST or LST climbing steps to 4.
C Since I do not know an empirical formula to estimate the displacement,
C I am going to use simple Newton-Raphson to estimate the stepsize to
C decide whether we are going to climb. That is what's decided in
C QSTLST_OR_EVEC. There is one aspect that is not clear from the papers:
C the direction of the climb. Since the tangent is not an eigenvector
C of the Hessian, I presume when he says that "the tangent to the
C path is used to choose the best eigenvectors for ascent..." what he
C meant is that the eigenvector that has maximum overlap with the tangent.

         IF (LST) THEN
            CALL QSTLST_OR_EVEC(LST_TANGENT, GRDMOD, HESMOD, DIAGHES,
     &                          HES, SCRATCH, IMODE, QSTLST_CLIMB)
            IF (QSTLST_CLIMB) THEN
               CALL FOLOWTANGENT(HESMOD, DIAGHES, LST_TANGENT,
     &                           SCRATCH, NX, NOPT, IMODE)
            ELSE
               CALL WHAT2FOLLOW(HESMOD, DIAGHES, LST_TANGENT,
     &                          SCRATCH, NX, NOPT, IMODE)
   
               CALL FOLOWDFLT(HESMOD, DIAGHES, SCRATCH, VEC, TS,
     &                        NRORMANR, RFA, IVEC, IMODE, NCYCLE,
     &                        NX, NOPT)
            END IF
         ELSE IF (QST) THEN
            CALL QSTLST_OR_EVEC(QST_TANGENT, GRDMOD, HESMOD, DIAGHES,
     &                          HES, SCRATCH, IMODE, QSTLST_CLIMB)
            IF (QSTLST_CLIMB) THEN
               CALL FOLOWTANGENT(HESMOD, DIAGHES, QST_TANGENT,
     &                           SCRATCH, NX, NOPT, IMODE)
            ELSE
               CALL WHAT2FOLLOW(HESMOD, DIAGHES, QST_TANGENT,
     &                          SCRATCH, NX, NOPT, IMODE)

               CALL FOLOWDFLT(HESMOD, DIAGHES, SCRATCH, VEC, TS,
     &                        NRORMANR, RFA, IVEC, IMODE, NCYCLE,
     &                        NX, NOPT)
            END IF
         END IF
         RETURN

C     ELSE IF (.NOT.TS.OR.IVEC.LT.1.OR..NOT.QSTORLST) THEN
      ELSE

C The following logic (bit cleaned up) is what we have been using. It
C is retained just in case the user did not want to do any QST or LST
C eigenvector following. The logic pertains to identifying the eigenvector
C that corresponds to the lowest (IVEC=1, the default), next to the lowest
C (IVEC=2), and so on (user's choice) during the first cycle and then for
C the subsequent steps use the eigenvector that has the largest overlap with
C the previous vector. I think we should add the capability to follow the
C lowest, next to lowest, and so on regardless of what happens in the previous
C cycle. It might just even work better!!!
C Ajith Perera 07/04.
C
  10       CONTINUE
C
           QSTLST_CLIMB = .FALSE. 
C
           CALL FOLOWDFLT(HESMOD, DIAGHES, SCRATCH, VEC, TS, NRORMANR,
     &                    RFA, IVEC, IMODE, NCYCLE, NX, NOPT)

      END IF
C
      RETURN
      END
      

      subroutine list_prev_num(str,ptr,num,err)
      implicit none
      character*(*) str
      integer ptr,err
      double precision num
      integer l,pos
      integer  strlen,pcindex
      external strlen,pcindex
      err=0
      l=strlen(str)
      ptr=max(ptr,0)
      ptr=min(ptr,l+1)
      if (ptr.eq.0) then
         err=-1
         num=0.d0
         return
      end if
      pos=pcindex(str,',',ptr)
      if (pos.eq.0) then
         call str2dbl(str(1:ptr-1),num,err)
      else
         call str2dbl(str(pos+1:ptr-1),num,err)
      end if
      if (err.eq.0) ptr=pos
      return
      end

      SUBROUTINE ADM(Q, Natoms)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      PARAMETER (BA = 0.529177249d0)
      PARAMETER (NCOL = 6)
C
      DIMENSION Q(3*Natoms), SCR(5)
C
      IQ(I)=3*I-2

      iexit = 0

      WRITE(6,'(t3,a)') ' Interatomic distance matrix (Angstroms) '

      JBOT = 1
      NTIMES = 1 + (NATOMS-1)/5
      DO ICOUNT = 1, NTIMES
         WRITE(6,*)
         WRITE(6,144) (ICN,ICN=JBOT,MIN(NATOMS,JBOT+4))
 144     FORMAT(16X,:'[',I2,']',4(8X,:'[',I2,']'))
         DO I = JBOT, NATOMS
            ITMP = MIN(I,JBOT+4)-JBOT+1
            IF (ITMP.GT.5) THEN
               WRITE(6,*) '@ADM: Loop limit exceeded. ',I,JBOT,ITMP
            END IF
            DO J = 1, ITMP
               SCR(J) = BA * DIST(Q(IQ(I)),Q(IQ(J+JBOT-1)))
            END DO
            WRITE(6,143) I,(SCR(J),J=1,ITMP)
 143        FORMAT(T3,'[',I2,']',5(2X,F10.5))
         END DO
         JBOT = JBOT + 5
      END DO

       RETURN
       END

C
C     THIS SUBROUTINE CALCULATES THE FOLLOWING CONTRIBUTIOBN TO 
C     THE T1 INCREMENT (LAMBDA = .FALSE.)
C    
C      Z(I,A) = - SUM M<N,E T(MN,AE) <MN//IE>
C
C OR   Z(i,a) = - SUM m<n,e T(mn,ea) <mn//ej)
C
C     OR THE L1 INCREMENT (LAMBDA = .FALSE.)
C 
C      Z(I,A) = - SUM M<N,E L(MN,AE) <MN//IE>
C
C OR   Z(i,a) = - SUM m<n,e L(mn,ea) <mn//ej)
C 
      SUBROUTINE T2T1AA2(W,ICORE,MAXCOR,POP,VRT,ISPIN,LAMBDA,LSTOFF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LAMBDA
      INTEGER DIRPRD,POP,VRT,DISSYT,DISSYW
      DIMENSION ICORE(MAXCOR),POP(8),VRT(8)
      DIMENSION W(1)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /FLAGS/ IFLAGS(100)
C
      DATA AZERO,ONE,ONEM /0.0D0,1.0D0,-1.0D0/
C
C  The iflags(39) flag, reserved for "standard" or "semicanonical" 
C  orbitals, is used here to determine which list is needed for the
C  ROHF-MBPT code, since this routine is called by two others at
C  different times.  The value of "99" is set before the second call
C  to E3S in ROHFPT.
C
      IF(LAMBDA) THEN 
       LISTT=143+ISPIN
      ELSEIF(IFLAGS(11).EQ.2.AND.IFLAGS(39).EQ.99) THEN
       LISTT=ISPIN+93
      ELSE
       LISTT=ISPIN+43
      ENDIF
      LISTW=ISPIN+6+LSTOFF
C
C    LOOP OVER IRREPS
C
      DO 1000 IRREP=1,NIRREP
       NVRTSQ=0
       DO 1001 IRREPJ=1,NIRREP
        NVRTSQ=NVRTSQ+VRT(IRREPJ)*VRT(DIRPRD(IRREP,IRREPJ))
1001   CONTINUE
       DISSYW=IRPDPD(IRREP,ISYTYP(1,LISTW))
       DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
       NUMSYW=IRPDPD(IRREP,ISYTYP(2,LISTW))
       NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
       I001=1
       I002=I001+IINTFP*NUMSYT*NVRTSQ
       I003=I002+IINTFP*MAX(NUMSYW*DISSYW,NUMSYT*DISSYT)
       I004=I003+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
       I005=I004+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
       I006=I005+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
       IF(I006.LT.MAXCOR) THEN 
        CALL GETLST(ICORE(I002),1,NUMSYT,1,IRREP,LISTT)
        CALL TRANSP(ICORE(I002),ICORE(I001),NUMSYT,DISSYT)
        CALL SYMEXP(IRREP,VRT,NUMSYT,ICORE(I001))
        CALL GETLST(ICORE(I002),1,NUMSYW,2,IRREP,LISTW)
        CALL SYMTR1(IRREP,POP,VRT,DISSYW,ICORE(I002),ICORE(I003),
     &              ICORE(I004),ICORE(I005))
        IOFFT=0
        IOFFW=0 
        IOFFS=1
        DO 100 IRREPJ=1,NIRREP 
         NVRTJ=VRT(IRREPJ)
         NOCCJ=POP(IRREPJ)
         IRREPI=DIRPRD(IRREPJ,IRREP)
         NVRTI=VRT(IRREPI)
C
         CALL XGEMM('T','N',NVRTJ,NOCCJ,NVRTI*DISSYW,ONE,
     &              ICORE(I001+IOFFT*IINTFP),NUMSYT*NVRTI,
     &              ICORE(I002+IINTFP*IOFFW),DISSYW*NVRTI,ONE,
     &              W(IOFFS),NVRTJ)
        IOFFT=IOFFT+NVRTI*NVRTJ*NUMSYT
        IOFFW=IOFFW+NVRTI*NOCCJ*DISSYW
        IOFFS=IOFFS+NVRTJ*NOCCJ
100    CONTINUE
      ELSE
       STOP 'W5AA'
      ENDIF
1000  CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine fshells_to_segments(end_nfps, nshells, mx_seg_size,
     *                        segs, nsegs, atoms)
c---------------------------------------------------------------------------
c   Fit the shells into index segments, based on the maximum segment size.
c
c   If the "atom_based" flag is .true., we will use a segmentation scheme 
c   that forces the segments to occur on atomic boundaries.  Otherwise,
c   the shells are arranged for most efficient packing within the segment
c   boundaries.
c---------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
      include 'frag_def.h'

      integer nshells, mx_seg_size, nsegs
      integer end_nfps(nshells), segs(nshells)
      integer atoms(nshells), last_frag 

      integer i, j, ishell, jshell, iatom, jatom, last_shell(100), 
     *        nsh, number, number0, sum, sumT 

      integer fseg(100) 
      integer n_frags 

c     logical frag_calc 
c     integer nfrags, natoms_frag, watom_frag 
c     common /FRAGDEF/frag_calc, nfrags, natoms_frag(100), 
c    *                watom_frag(100,100) 

c     integer fragAO, n_occ, n_aocc, n_bocc, n_virt, n_avirt, n_bvirt
c     common /FORBS/fragAO(100), n_occ(100), n_aocc(100), n_bocc(100), 
c    *              n_virt(100), n_avirt(100), n_bvirt(100) 


      n_frags = nfrags  
      if (fdrop_flag) n_frags = 1 

      nsegs = 0 
      do i = 1, n_frags 
         sum   = 0 
         sumT  = 0 
         number = fragAO(i)   
         if (fragAO(i) .gt. mx_seg_size) then  
             number = fragAO(i)/mx_seg_size + 1 
             number = fragAO(i)/number 
             number = mx_seg_size !/2 
             number0 = number 
         endif 
         if (fragAO(i) .le. mx_seg_size) then  
             number = fragAO(i)/mx_seg_size + 1 
             number = fragAO(i) 
             number0 = number 
         endif 

c        if (fragAO(i) .ne. mx_seg_size) then
c            number = fragAO(i)/mx_seg_size + 1
c            number = fragAO(i)/number
c        endif
c        number = mx_seg_size/2
c        number0 = number

      do j = 1, natoms_frag(i) 
         jatom = watom_frag(i,j) 
      do ishell = 1, nshells 
         iatom = atoms(ishell) 
         if (iatom .eq. jatom)then 

            if (ishell .eq. 1) sum = sum + end_nfps(ishell)  
            if (ishell .gt. 1) sum = sum + end_nfps(ishell) 
     *                                   - end_nfps(ishell-1) 
            if (ishell .eq. 1) sumT= sumT+ end_nfps(ishell)  
            if (ishell .gt. 1) sumT= sumT+ end_nfps(ishell) 
     *                                   - end_nfps(ishell-1) 

            if (sum .eq. fragAO(i)) then 
               nsegs = nsegs + 1 
               segs(nsegs) = end_nfps(ishell) 
               fseg(nsegs) = i 
               sum = 0 
               go to 10 
            endif 

            if (sumT .eq. fragAO(i)) then 
               nsegs = nsegs + 1 
               segs(nsegs) = end_nfps(ishell) 
               fseg(nsegs) = i 
               sum = 0 
               go to 10 
            endif 
            if ((sum .lt. fragAO(i)) .and. 
c    *          (sum .le. mx_seg_size) .and.   
     *          (sum .ge. number)) then  
               nsegs = nsegs + 1 
               segs(nsegs) = end_nfps(ishell) 
               fseg(nsegs) = i 
               sum = 0 
            endif 

         endif 
      enddo 
      enddo 
10       continue 
      enddo 

      write(6,*) '*********************************************'  
      write(6,*)' Final AO segments ', nsegs  
      do i = 1, nsegs 
         write(6,*) i, segs(i), fseg(i) 
         w_frag_AO(i) = fseg(i)   
      enddo 
      return
      end

      subroutine Den_Plots_Main(Icore, Icrsiz)
c
      implicit double precision (a-h,o-z)
      parameter (mxcoef=30)
c


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end










c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)


      COMMON /OFF_4INTGRT/IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                    IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                    ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                    IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                    IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                    IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                    ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                    IPCOEFFB, IPCOEFF,ISCR1,ISCR2,IREORD 




C
      character*32 szFile
      logical bExist
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Nocc(16), Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Coord(3*Mxatms), Norbits_fullG(Mxatms), 
     &          NOrbits_compG(Mxatms),Nbsfns_4irrep(8)
      Dimension Icore(Icrsiz)
C
      Data Ione, Ieight /1, 8/
C
      Iuhf = 1
      If (iflags(11).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Mxangmom = Nht
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      
      Call Getrec(-1, 'JOBARC', 'NUMDROPA', Length, Ijunk)       
      If (Length .GT. 0) Then 
         Print*, "Frozen-core is not allowed density plots"
         Call Errex
      Endif
c 
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(20, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'FULLNORB', Ione, Iful_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COMPNORB', Ione, Icmp_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Coord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(20, 'JOBARC', 'OCCUPYA ', Nirrep, Nocc(1))
      Call Getrec(20, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(20, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(20, 'JOBARC', 'NUMBASIR', Nirrep, Nbsfns_4irrep)
      Call Getrec(20, 'JOBARC', 'FULLPOPV', Iful_unq_atoms, 
     &            Norbits_fullG)
      Call Getrec(20, 'JOBARC', 'COMPPOPV', Icmp_unq_atoms, 
     &            Norbits_compG)
C
      nOCCa = 0
      Do Irrep = 1, Nirrep
         Nocca = Nocca + Nocc(Irrep)
      End Do
      If (Iuhf .EQ. 1) Then
         Call Getrec(20, 'JOBARC', 'OCCUPYB', Nirrep, Nocc(I+8)) 
         Noccb = 0
         Do Irrep = 1, Nirrep
            Noccb = Noccb + Nocc(8+I) 
         End Do
      Else
         Noccb = Nocca
      Endif 
C
      Call Getcrec(20, 'JOBARC', 'COMPPTGP', 4, Comp_pgrp)
      Call Getcrec(20, 'JOBARC', 'FULLPTGP', 4, Full_pgrp)
C
      Call A2_PREP4_MOL_READ(Icore, Maxcor, Natoms, Nbfns, 
     &                       Naobfns, Icmp_unq_atoms, 
     &                       Iful_unq_atoms, Coord, Iatmchrg,
     &                       Norbits_fullG, Norbits_compG, 
     &                       Mxshel, Mxangmom, Itot_prim, Iunqshl, 
     &                       Ntotshl, Max_prim_4atom, 
     &                       Max_prim_4shell, Inext)

C
       Lnp1             = Itot_prim
       Icnterbf         = Inext 
       Iscfcoef_a       = Icnterbf         + Nbfns
       Iscfcoef_b       = Iscfcoef_a       + Naobfns*Nbfns*Iintfp
       Iscfcoef_reord_a = Iscfcoef_b       + Naobfns*Nbfns*Iintfp 
       iSCfcoef_reord_b = Iscfcoef_reord_a + Nbfns*Naobfns*Iintfp
       Icoef_a          = Iscfcoef_reord_b + Nbfns*Naobfns*Iintfp
       Icoef_b          = Icoef_a          + Nbfns*Itot_prim*Iintfp
       Itmp1            = Icoef_b          + Nbfns*Itot_prim*Iintfp
       Itmp2            = Itmp1            + Lnp1*Lnp1*Iintfp
       Itmp3            = Itmp2            + Lnp1*Lnp1*Iintfp
       Iprductint       = Itmp3            + Lnp1*Lnp1*Iintfp
       Inuctr           = Iprductint       + Naobfns*Naobfns*Iintfp
       Itype            = Inuctr           + Natoms
       Icnt_xyz         = Itype            + Itot_prim
       Inext            = Icnt_xyz         + 3*Itot_prim*Iintfp
       Ileft            = Maxcor - Inext

       If (INext .ge. Maxcor) Call Insmem("Den_plot_main", Inext, 
     &                                     Maxcor)
C
      print*, "Entering Reord_MOs:"
      Print*, "Input variables", Inext, Max_prim_4atom, Itot_prim, 
     &         icnterbf, Iscfcoef_reord_a, Iscfcoef_reord_b,
     &         Icoef_a, Icoef_b, Nangmom, Nmomao, Naoatm,ipcoeff
      write(*,*)
C
       Call Reord_mos(0, Nreal_atoms, Naobfns, Nbfns, Max_prim_4atom, 
     &                Icore(Icnterbf), ICore(Iscfcoef_a),  
     &                ICore(Iscfcoef_reord_a), Icore(Nangmom),
     &                Icore(Nmomao), Icore(Naoatm), .False.)
C
      CALL Xgemm('N','N',Itot_prim,Nbfns,Naobfns,1.0D+00,
     &            Icore(Ipcoeff),Itot_prim,Icore(Iscfcoef_reord_a),
     &            Naobfns,0.0D+00,Icore(Icoef_a),Itot_prim)


      If (Iuhf .ne. 0) Then
         Call Reord_mos(1, Nreal_atoms, Naobfns, Nbfns, 
     &                  Max_prim_4atom, Icore(Icnterbf), 
     &                  ICore(Iscfcoef_b), ICore(Iscfcoef_reord_b), 
     &                  Icore(Nangmom), Icore(Nmomao), Icore(Naoatm),
     &                  .False.)
C
         Call Xgemm('N','N',Itot_prim,Nbfns,Naobfns,1.0D+00,
     &               Icore(Ipcoeff),Itot_prim,
     &               Icore(Iscfcoef_reord_b), Naobfns,0.0D+00,
     &               Icore(Icoef_b),Itot_prim)
      End if

      print*, "Entering Nodummy:"
      write(*,*)
      CALL Nodummy(Natoms, Max_prim_4atom, Iatmchrg, Coord,
     &            Icore(Nangmom), Icore(Nmomfct), Icore(Inuctr))
C
      if (Comp_pgrp .Eq. "C1") Iful_unq_atoms = Icmp_unq_atoms
C
      Call Generate_12Dgrid(Icore(Inext), Ileft, Natoms, Itot_prim,
     &                      Nbfns, Naobfns, Lnp1, Norbits_compG,
     &                      Iful_unq_atoms, Coord, Icore(Ialpha),
     &                      Icore(Ipcoeff), Ntotshl,Icore(Inprimshl), 
     &                      Icore(Iangmomshl), Icore(Iconfunshl), 
     &                      Icore(Iprmfunshl), Icore(Nufct), 
     &                      Icore(Naouatm), Icore(Ioffsetprm),
     &                      Icore(Ioffsetcon), Icore(Itmp1),
     &                      Icore(Itmp2), Icore(Itmp3),
     &                      Icore(Iprductint), Icore(Icnt_xyz),
     &                      Icore(Ireord), Icore(Itype), 
     &                      Iatmchrg, Iuhf)
      write(6,*)
      Write(6,"(t3,50a)")"@-den_plot_main: The density distribution ",
     &                  "calculation is succesfully completed."
      Return
      End

#include "flags.h"
      subroutine Den_Plots_Main(Icore, Icrsiz)
c
      implicit double precision (a-h,o-z)
      parameter (mxcoef=30)
c
#include "machsp.com"
#include "jodaflags.com"
#include "mxatms.par"
#include "baslims.par"
#include "offsets_2getden.com"
C
      character*32 szFile
      logical bExist
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Nocc(16), Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Coord(3*Mxatms), Norbits_fullG(Mxatms), 
     &          NOrbits_compG(Mxatms),Nbsfns_4irrep(8)
      Dimension Icore(Icrsiz)
C
      Data Ione, Ieight /1, 8/
C
      Iuhf = 1
      If (iflags(h_IFLAGS_ref).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Mxangmom = Nht
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      
      Call Getrec(-1, 'JOBARC', 'NUMDROPA', Length, Ijunk)       
      If (Length .GT. 0) Then 
         Print*, "Frozen-core is not allowed density plots"
         Call Errex
      Endif
c 
      Call Getrec(20, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(20, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(20, 'JOBARC', 'FULLNORB', Ione, Iful_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COMPNORB', Ione, Icmp_unq_atoms)
      Call Getrec(20, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Coord)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(20, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(20, 'JOBARC', 'OCCUPYA ', Nirrep, Nocc(1))
      Call Getrec(20, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(20, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(20, 'JOBARC', 'NUMBASIR', Nirrep, Nbsfns_4irrep)
      Call Getrec(20, 'JOBARC', 'FULLPOPV', Iful_unq_atoms, 
     &            Norbits_fullG)
      Call Getrec(20, 'JOBARC', 'COMPPOPV', Icmp_unq_atoms, 
     &            Norbits_compG)
C
      nOCCa = 0
      Do Irrep = 1, Nirrep
         Nocca = Nocca + Nocc(Irrep)
      End Do
      If (Iuhf .EQ. 1) Then
         Call Getrec(20, 'JOBARC', 'OCCUPYB', Nirrep, Nocc(I+8)) 
         Noccb = 0
         Do Irrep = 1, Nirrep
            Noccb = Noccb + Nocc(8+I) 
         End Do
      Else
         Noccb = Nocca
      Endif 
C
      Call Getcrec(20, 'JOBARC', 'COMPPTGP', 4, Comp_pgrp)
      Call Getcrec(20, 'JOBARC', 'FULLPTGP', 4, Full_pgrp)
C
#ifdef _DEBUG_LVLM2
      print*, "Entering A2_PREP4_MOL_READ.."
      Write(6,"(4I4)") (Norbits_compG(i), i=1, Icmp_unq_atoms)
      Write(6,*)
      Write(6,"(4I4)"), (Norbits_fullG(i), i=1, Iful_unq_atoms)
#endif 
      Call A2_PREP4_MOL_READ(Icore, Maxcor, Natoms, Nbfns, 
     &                       Naobfns, Icmp_unq_atoms, 
     &                       Iful_unq_atoms, Coord, Iatmchrg,
     &                       Norbits_fullG, Norbits_compG, 
     &                       Mxshel, Mxangmom, Itot_prim, Iunqshl, 
     &                       Ntotshl, Max_prim_4atom, 
     &                       Max_prim_4shell, Inext)

#ifdef _DEBUG_LVLM2
      Write(6,*)
      Print*, "Offsets for various arrays initilized in Pre4_Den_plo."
      Write(*, '(31I5)'), IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                   IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                   ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                   IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                   IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                   IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                   ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                   IPCOEFFB, IPCOEFF,ISCR1,ISCR2
C
      Write(6,*) 
      Print*, "The orbital exponents in main", Itot_prim, ialpha
      call output(icore(ialpha), 1, Itot_prim, 1, 1, 1, Itot_prim,
     &            1,1,1)  
      Print*, "The Contraction Coefs."
      call output(icore(ipcoeff), 1, Itot_prim, 1, Naobfns, Itot_prim,
     &            Naobfns, 1)
#endif
#ifdef _ARCHIVED
C This block is archived. Obtaining the density need to be handled
C somewhat genrelly and now it is done inside generate_12Dgrid.F 
C using a2get_den.F
C
      Inturldens = Inext
      Iscfdens_t = Inturldens + Nbfns*Nbfns*Iintfp
      Iscfdens_d = Iscfdens_t + Naobfns*Naobfns*Iintfp
      Icordens_t = Iscfdens_d + Naobfns*Naobfns*Iintfp 
      Icordens_d = Icordens_t + Naobfns*Naobfns*Iintfp 
      Iscfcoef_a = Icordens_d + Naobfns*Naobfns*Iintfp  
      Iscfcoef_b = Iscfcoef_a + Naobfns*Nbfns*Iintfp 
      Isphr2cart = Iscfcoef_b + Naobfns*Nbfns*Iintfp
      Iscftmp1   = Isphr2cart + Naobfns*Nbfns*Iintfp
      Iscftmp2   = Iscftmp1   + Nbfns*Nbfns*Iintfp 
      Inext      = Iscftmp2   + Nbfns*Nbfns*Iintfp 
c      
#ifdef _DEBUG_LVLM2
      print*, "Entering A2get_den."
#endif 
      Call A2get_den(Icore(Iscfcoef_a), Icore(Inturldens),
     &               Icore(Iscfdens_t), Icore(Icordens_t), 
     &               Icore(Isphr2cart), Icore(IScftmp1), Naobfns,
     &               Nbfns, Nocc, Nbfns_4irrep, Iuhf+1)
     &               
      If (Iuhf .GT. 0) Then

         Call A2get_den(Icore(Iscfcoef_b), Icore(Inturldens),
     &                  Icore(Iscfdens_d), Icore(Icordens_d), 
     &                  Icore(Isphr2cart), Icore(IScftmp1), Naobfns,
     &                  Nbfns, Nocc, Nbsfn_4irrep, Iuhf+1)
     &               
      Endif 
C
      Call Generate_12Dgrid(Icore(Inext), Ileft, Natoms, Itot_prim,
     &                      Nbfns, Naobfns, Lnp1, Norbits_compG,
     &                      Iful_unq_atoms, Coord, Icore(Ialpha),
     &                      Icore(Ipcoeff), Iunqshl,Icore(Inprimshl),
     &                      Icore(Iangmomshl), Icore(Iconfunshl),
     &                      Icore(Iprmfunshl), Icore(Nufct),
     &                      Icore(Naouatm), Icore(Ioffsetprm),
     &                      Icore(Ioffsetcon), Icore(Itmp1),
     &                      Icore(Itmp2), Icore(Itmp3),
     &                      Icore(Iscfdens_t), Icore(Iscfdens_d),
     &                      Icore(Icordens_t), Icore(Icordens_d),
     &                      Icore(Iprductint), Iatmchrg, Iuhf)
c
#endif
C
       Lnp1             = Itot_prim
       Icnterbf         = Inext 
       Iscfcoef_a       = Icnterbf         + Nbfns
       Iscfcoef_b       = Iscfcoef_a       + Naobfns*Nbfns*Iintfp
       Iscfcoef_reord_a = Iscfcoef_b       + Naobfns*Nbfns*Iintfp 
       iSCfcoef_reord_b = Iscfcoef_reord_a + Nbfns*Naobfns*Iintfp
       Icoef_a          = Iscfcoef_reord_b + Nbfns*Naobfns*Iintfp
       Icoef_b          = Icoef_a          + Nbfns*Itot_prim*Iintfp
       Itmp1            = Icoef_b          + Nbfns*Itot_prim*Iintfp
       Itmp2            = Itmp1            + Lnp1*Lnp1*Iintfp
       Itmp3            = Itmp2            + Lnp1*Lnp1*Iintfp
       Iprductint       = Itmp3            + Lnp1*Lnp1*Iintfp
       Inuctr           = Iprductint       + Naobfns*Naobfns*Iintfp
       Itype            = Inuctr           + Natoms
       Icnt_xyz         = Itype            + Itot_prim
       Inext            = Icnt_xyz         + 3*Itot_prim*Iintfp
       Ileft            = Maxcor - Inext

       If (INext .ge. Maxcor) Call Insmem("Den_plot_main", Inext, 
     &                                     Maxcor)
C
#ifdef _DEBUG_LVL0
      print*, "Entering Reord_MOs:"
      Print*, "Input variables", Inext, Max_prim_4atom, Itot_prim, 
     &         icnterbf, Iscfcoef_reord_a, Iscfcoef_reord_b,
     &         Icoef_a, Icoef_b, Nangmom, Nmomao, Naoatm,ipcoeff
      write(*,*)
#endif 
C
       Call Reord_mos(0, Nreal_atoms, Naobfns, Nbfns, Max_prim_4atom, 
     &                Icore(Icnterbf), ICore(Iscfcoef_a),  
     &                ICore(Iscfcoef_reord_a), Icore(Nangmom),
     &                Icore(Nmomao), Icore(Naoatm), .False.)
C
      CALL Xgemm('N','N',Itot_prim,Nbfns,Naobfns,1.0D+00,
     &            Icore(Ipcoeff),Itot_prim,Icore(Iscfcoef_reord_a),
     &            Naobfns,0.0D+00,Icore(Icoef_a),Itot_prim)


      If (Iuhf .ne. 0) Then
         Call Reord_mos(1, Nreal_atoms, Naobfns, Nbfns, 
     &                  Max_prim_4atom, Icore(Icnterbf), 
     &                  ICore(Iscfcoef_b), ICore(Iscfcoef_reord_b), 
     &                  Icore(Nangmom), Icore(Nmomao), Icore(Naoatm),
     &                  .False.)
C
         Call Xgemm('N','N',Itot_prim,Nbfns,Naobfns,1.0D+00,
     &               Icore(Ipcoeff),Itot_prim,
     &               Icore(Iscfcoef_reord_b), Naobfns,0.0D+00,
     &               Icore(Icoef_b),Itot_prim)
      End if

#ifdef _DEBUG_LVL0
      print*, "Entering Nodummy:"
      write(*,*)
#endif 
      CALL Nodummy(Natoms, Max_prim_4atom, Iatmchrg, Coord,
     &            Icore(Nangmom), Icore(Nmomfct), Icore(Inuctr))
C
      if (Comp_pgrp .Eq. "C1") Iful_unq_atoms = Icmp_unq_atoms
C
#ifdef _DEBUG_LVLM2
      print*, "Entering Generate_12Dgrid:"
      Write(6,*)
      Print*, "The start of Icore", Inext, ialpha, Ileft,
     &         Iful_unq_atoms, Ipcoeff, Iunqshl, Inprimshl,
     &         Iangmomshl, Iconfunshl, Iprmfunshl, Nufct,
     &         Naouatm, Ioffsetprm, Ioffsetcon, Ioffsetprm,
     &         Ioffsetcon, Itmp1, Itmp2, Itmp3, Iprductint
C   
      Write(6,*)
      print*, "The offsets for primitives and contr. functions"
      Write(6,"(4i5)") (Icore(Nufct -1 +i), i=1, Iful_unq_atoms)
      Write(6,"(4i5)") (Icore(naouatm -1 +i), i=1, Iful_unq_atoms)
#endif 
      Call Generate_12Dgrid(Icore(Inext), Ileft, Natoms, Itot_prim,
     &                      Nbfns, Naobfns, Lnp1, Norbits_compG,
     &                      Iful_unq_atoms, Coord, Icore(Ialpha),
     &                      Icore(Ipcoeff), Ntotshl,Icore(Inprimshl), 
     &                      Icore(Iangmomshl), Icore(Iconfunshl), 
     &                      Icore(Iprmfunshl), Icore(Nufct), 
     &                      Icore(Naouatm), Icore(Ioffsetprm),
     &                      Icore(Ioffsetcon), Icore(Itmp1),
     &                      Icore(Itmp2), Icore(Itmp3),
     &                      Icore(Iprductint), Icore(Icnt_xyz),
     &                      Icore(Ireord), Icore(Itype), 
     &                      Iatmchrg, Iuhf)
      write(6,*)
      Write(6,"(t3,50a)")"@-den_plot_main: The density distribution ",
     &                  "calculation is succesfully completed."
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      Subroutine Post_opt_update
c
      Implicit Double Precision (A-H, O-Z)
c
#include "mxatms.par"
#include "flags.h"
#include "baslen.par"
#include "jodaflags.com"
#include "machsp.com"
#include "coord.com"
c
      Integer Genby(Mxatms) 
      Double Precision Orient(3, 3)
      Character*(baslen) BasNam(Mxatms)
      Character*4 FPGrp, BPGrp, PGrp 
      Character*5, Zsym(Mxatms)
      Dimension Scratch(Mxatms) 
      Logical Can_do_freq 
c
      Common /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
c
      Call Entry(BasNam, .True., Can_do_freq)
c
      Call igetrec(20, 'JOBARC', 'ZMATATMS', 1, NATOMS)
      Call igetrec(20, 'JOBARC', 'LINEAR  ', 1, ILINEAR)
      If (ILINEAR .EQ. 1) Then
          NX   = 3*NATOMS
          NXM6 = NX - 5
      Else
          NX   = 3*NATOMS
          NXM6 = NX -6
      Endif  
c
      Call dgetrec(20, "JOBARC", "COORD   ", NX*IINTFP, Q)
      Call igetrec(20, 'JOBARC', 'CONCTVTY', NX, NCON)
      Call dgetrec(-1, 'JOBARC', 'CORD_INT', NX*IINTFP, R)
      Call Bohr2angs(R, NX)
      Call dgetrec(20, 'JOBARC', 'ATOMMASS', NATOMS*IINTFP,
     &           ATMASS)
      Call dgetrec(20, 'JOBARC', 'ORIENTMT', 9*IINTFP,
     &            ORIENT)
      Call igetrec(20, 'JOBARC', 'ATOMCHRG', NATOMS, IATNUM)
      Call igetrec(20, 'JOBARC', 'ICSQUASH', NX, ISQUASH)
      Call Getcrec(20, 'JOBARC', "PTGP    ", 4, FPGRP)
      Call Getcrec(20, 'JOBARC', "ABL_PTGP", 4, BPGRP)
      Call Getcrec(20, 'JOBARC', "CMP_PTGP", 4, PGRP)
      Call Getcrec(20, 'JOBARC', "ZSYM", 5*NATOMS, ZSYM)
#ifdef _DEBUG_LVL0
           Print*, "The data read from JOBARC in post_opt_update"
           Print*, "The NATOMS:", NATOMS
           Print*, "Internal coords:",(R(I), I=1, NX)
           Print*, "The Cartesian coords:", (Q(I), I=1, NX) 
           print*, "The connectivities:", (NCON(I), I=1, NX)
           Print*, "The atomic charges:", (IATNUM(I), I=1, NX/3)
           Print*, "The point group", PGRP 
#endif
c
c The scratch and Nunique are not used. Genby, istat and Genby
c are internal 

      Call MkVMOL(Q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &            GenBy, Scratch, IStat, BasNam)
      
#ifdef _DEBUG_LVL0
      Print*, "out from Mkvmol in post_opt_update"
#endif
      Return
      End

cYAU - WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING
c
c    For some reason, which I am not privy to, the original xgeev was not bound
c the same way dgemm is. I moved the original one to libr/mn_geev.f

      subroutine xgeev( jobvl, jobvr, n, a, lda, wr, wi, vl, ldvl, vr,
     &                  ldvr, work, lwork, info )
      implicit none

      character*1 jobvl, jobvr
      integer info, lda, ldvl, ldvr, lwork, n
      double precision a(lda,*), vl(ldvl,*), vr(ldvr,*)
      double precision wi(*), work(*), wr(*)

#ifdef _32BIT_BLAS
      integer*4 int_n, int_lda, int_ldvl, int_ldvr, int_lwork, int_info
#else
      integer   int_n, int_lda, int_ldvl, int_ldvr, int_lwork, int_info
#endif /* _32BIT_BLAS */

      if (n.eq.0) return

      int_n     = n
      int_lda   = lda
      int_ldvl  = ldvl
      int_ldvr  = ldvr
      int_lwork = lwork

#ifdef USE_SP_BLAS
      call sgeev(jobvl,jobvr,int_n,a,int_lda,wr,wi,
     &           vl,int_ldvl,vr,int_ldvr,work,int_lwork,int_info)
#else
      call dgeev(jobvl,jobvr,int_n,a,int_lda,wr,wi,
     &           vl,int_ldvl,vr,int_ldvr,work,int_lwork,int_info)
#endif

      info = int_info

      return
      end

C THIS ROUTINE TESTS ALL SYMMETRY OPERATIONS OF THE GROUP ON A
C PARTICULAR SET OF COORDINATES. ALSO RETURNS POINTER LISTS
C FOR ALL SYMMETRY OPERATIONS.

c#define _DEBUG_TSTOPS

      SUBROUTINE TSTOPS(NORDER,Q,V,CLSTYP,IPTR,SCR,NORD,NATOM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates

      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /TOLERS/ SYMTOL,DEGTOL
 
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
 
      DIMENSION V(9*NORDER),Q(3*NATOM),SCR(3*NATOM)
      DIMENSION NORD(2*NATOM),IPTR(NATOM,NORDER)
      INTEGER CLSTYP(NORDER)
      CHARACTER*6 RESULT

      ICOMP = 0
      CALL ZERO(SCR,3*NATOM)
      CALL IZERO(NORD,NATOM)
      DO I = 1, NATOM
         NORD(I) = I
      END DO
      CALL SORTXYZ(Q,SCR,NORD,NATOM)

      IF (IPRNT.GE.100) THEN
         WRITE(LUOUT,999)
         WRITE(LUOUT,2000)
         WRITE(LUOUT,1000)
         WRITE(LUOUT,2000)
      END IF
 999  FORMAT(T3,'@TSTOPS: Results of symmetry operation testing:')
 2000 FORMAT(80('-'))
 1000 FORMAT(T3,' Sym. Op.',T20,' Class ',T30,' Trace ',T40,' Result ')

      ISUCC = 0
      NFAIL = 0
      DO I = 1, NORDER
         itmp = -8 + ( 9 * I )
         CALL XGEMM('T','N',3,NATOM,3,
     &              1.0d0,V(itmp),       3,
     &                    Q,             3,
     &              0.0d0,SCR(3*NATOM+1),3)
         CALL COMPARE2(SCR(3*NATOM+1),SCR,NORD,ICOMP,SYMTOL)
         CALL STPTR(NATOM,NORD,NORD(NATOM+1),IPTR(1,I))
         IF (ICOMP.EQ.0) THEN
            RESULT = 'Passed'
            ISUCC  = ISUCC + 1
         ELSE
            RESULT = 'Failed'
            NFAIL  = NFAIL + 1
         END IF
         IF (IPRNT.GE.100) THEN
            itmp = -8 + ( 9 * I )
            TRACE = V(itmp) + V(itmp+4) + V(itmp+8)
            WRITE(LUOUT,1001) I,CLSTYP(I),TRACE,RESULT
         END IF
 1001    FORMAT(T6,I3,T22,I3,T30,F8.5,T41,A6)
      END DO
      IF (NFAIL.GT.0) THEN
         WRITE(*,*) '@TSTOPS: ',NFAIL,' operations failed.'
         CALL ERREX
      END IF
      IF (IPRNT.GE.100) WRITE(LUOUT,2000)
      IF (IPRNT.GT.5) THEN
         WRITE(*,*) '@TSTOPS: ',ISUCC,' operations verified.'
      END IF

      RETURN
      END

      SUBROUTINE CDCONST(FREQ,DIDQ,NX)
C
C CALCULATE CENTRIFUGAL DISTORTION TENSOR ELEMENTS
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION TMP(3,3),TAU(3,3,3,3),DIDQ(3,3,NX),FREQ(NX)
      DIMENSION CORVEC(3),BSRMBPP(3),BSRMB(3),BSRMBP(3)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/LINEAR/ILINEAR
C
C READ IN MOMENTS OF INERTIA
C
      CALL GETREC(20,'JOBARC','I4CDCALC',IINTFP*9,TMP)
      TMAX=MAX(TMP(1,1),TMP(2,2),TMP(3,3))
      TMIN=MIN(TMP(1,1),TMP(2,2),TMP(3,3))
      DO 5 I=1,3
       IF(TMP(I,I).EQ.TMAX)IC=I
       IF(TMP(I,I).EQ.TMIN)IA=I
5     CONTINUE
C
CWARNING: FANCY LOGIC
C
      IB=6-IC-IA
C   
C
C LOOP OVER INDICES DISREGARDING REDUNDANCIES
C
      FACTOR=60.19968599D0
      FACT=-872720.3477677D0
      FACT2=29979.2458D0
      WRITE(6,1001)
      WRITE(6,1000)
      WRITE(6,1002)
      WRITE(6,1001)
      DO 10 I=1,3-ILINEAR
       DO 20 J=1,3-ILINEAR
        DO 30 K=1,3-ILINEAR
         DO 40 L=1,3-ILINEAR
          Z=0.0D0
          DO 41 IMODE=7-ILINEAR,NX
           Z=Z+DIDQ(I,J,IMODE)*DIDQ(K,L,IMODE)/(FREQ(IMODE)**2)
41        CONTINUE
          if(abs(tmp(i,i)*tmp(j,j)*tmp(k,k)*tmp(l,l)).gt.1.D-8) then
          TAU(I,J,K,L)=fact*Z/(TMP(I,I)*TMP(J,J)*TMP(K,K)*TMP(L,L))
          write(6,'(4i5,e20.10,F20.10)')i,j,k,l,tau(i,j,k,l),
     &             tau(i,j,k,l)*29979.2458D0
          else
           write(6,*) ' skipped ',i,j,k,l
           tau(i,j,k,l)=0.D0
          endif
40       CONTINUE
30      CONTINUE
20     CONTINUE
10    CONTINUE
      WRITE(6,1001)
C
C CALCULATE B''-B FOR ROTATIONAL CONSTANTS.
C
      BXPPMBX=-0.5D0*(TAU(2,2,3,3)+0.5D0*TAU(2,3,2,3)+TAU(1,2,1,2)+
     &      TAU(1,3,1,3))*FACT2
      BYPPMBY=-0.5D0*(TAU(1,1,3,3)+0.5D0*TAU(1,3,1,3)+TAU(2,3,2,3)+
     &      TAU(1,2,1,2))*FACT2
      BZPPMBZ=-0.5D0*(TAU(1,1,2,2)+0.5D0*TAU(1,2,1,2)+TAU(2,3,2,3)+
     &      TAU(1,3,1,3))*FACT2
C
C CALCULATE B''-B' FOR ROTATIONAL CONSTANTS
C
      BXPPMBXP=-0.5D0*(TAU(2,2,3,3)+2.0D0*TAU(2,3,2,3))*FACT2
      BYPPMBYP=-0.5D0*(TAU(1,1,3,3)+2.0D0*TAU(1,3,1,3))*FACT2
      BZPPMBZP=-0.5D0*(TAU(1,1,2,2)+2.0D0*TAU(1,2,1,2))*FACT2
C
C NOTE THAT CODE WHICH FOLLOWS HEREAFTER IS BASED ON THE
C A-B-C REPRESENTATION.
C
C CALCULATE B'-B FOR ROTATIONAL CONSTANTS AS THESE ARE NEEDED FOR
C THE ASYMMETRY PARAMETER
C
      APMA=0.25D0*(3.0D0*TAU(IB,IC,IB,IC)-2.0D0*TAU(IA,IC,IA,IC)-
     &     2.0D0*TAU(IA,IB,IA,IB))
      BPMB=0.25D0*(3.0D0*TAU(IA,IC,IA,IC)-2.0D0*TAU(IB,IC,IB,IC)-
     &     2.0D0*TAU(IA,IB,IA,IB))
      CPMC=0.25D0*(3.0D0*TAU(IA,IB,IA,IB)-2.0D0*TAU(IB,IC,IB,IC)-
     &     2.0D0*TAU(IA,IC,IA,IC))
C
C EVALUATE A',B',C' CONSTANTS FROM RIGID-ROTOR A,B,C (in MHz).
C ALSO CALCULATE SIGMA PARAMETER (WHICH IS AN APPROXIMATION,
C AS IT IS CURRENTLY BASED ON Be' RATHER THAN B0' CONSTANTS)
C
      DO 1010 I=1,3
       IF(ABS(TMP(I,I)).GT.1.D-8) THEN
        TMP(I,I)=FACTOR/TMP(I,I)
       ELSE
        TMP(I,I)=1.D+99
       ENDIF
1010  CONTINUE
      TMP(IA,IA)=TMP(IA,IA)+APMA
      TMP(IB,IB)=TMP(IB,IB)+BPMB
      TMP(IC,IC)=TMP(IC,IC)+CPMC
      IF(ABS(TMP(IB,IB)-TMP(IC,IC)).GT.1.D-08) THEN
       SIGMA=(2.0D0*TMP(IA,IA)-TMP(IB,IB)-TMP(IC,IC))/
     &                       (TMP(IB,IB)-TMP(IC,IC))
      ELSE
       SIGMA=1.D+80
      ENDIF
C
C CALCULATE R5 AND R6 PARAMETERS
C
      R5=-(TAU(IB,IB,IB,IB)-TAU(IC,IC,IC,IC)-2.0D0*TAU(IA,IA,IB,IB)-
     &   4.0D0*TAU(IA,IB,IA,IB)+2.0D0*TAU(IC,IC,IA,IA)+
     &   4.0D0*TAU(IA,IC,IA,IC))/32.0D0
      R6=(TAU(IB,IB,IB,IB)+TAU(IC,IC,IC,IC)-2.0D0*
     &    TAU(IB,IB,IC,IC)-4.0D0*TAU(IB,IC,IB,IC))/64.0D0
c      write(6,*)' R5 and R6 ',r5,r6
C
C CALCULATE BSR-B (S-REDUCED HAMILTONIAN CONSTANTS = BSR)
C
c      ASRMA=(6.0D0*R6-5.0D0*R5/SIGMA)*FACT2
c      BSRMB=(-4.0D0*R6+2.0D0*(2.0D0+1.0D0/SIGMA)*R5)*FACT2
c      CSRMC=(-4.0D0*R6-2.0D0*(2.0D0-1.0D0/SIGMA)*R5)*FACT2
c      write(6,*)asrma,bsrmb,csrmc,'*** bs -> bprime '
      BSRMB(IA)=(6.0D0*R6-5.0D0*R5/SIGMA+0.25D0*
     &      (3.0D0*TAU(IB,IC,IB,IC)-2.0D0*TAU(IA,IC,IA,IC)
     &      -2.0D0*TAU(IA,IB,IA,IB)))*FACT2
      BSRMB(IB)=(-4.0D0*R6+2.0D0*(2.0D0+1.0D0/SIGMA)*R5+0.25D0*
     &      (3.0D0*TAU(IA,IC,IA,IC)-2.0D0*TAU(IB,IC,IB,IC)
     &      -2.0D0*TAU(IA,IB,IA,IB)))*FACT2
      BSRMB(IC)=(-4.0D0*R6-2.0D0*(2.0D0-1.0D0/SIGMA)*R5+0.25D0*
     &      (3.0D0*TAU(IA,IB,IA,IB)-2.0D0*TAU(IB,IC,IB,IC)
     &      -2.0D0*TAU(IA,IC,IA,IC)))*FACT2
c      write(6,*)bsrmb,'*** bs -> b '
C
C CALCULATE FANCY PARAMETERS FOR WATSON'S A-REDUCED HAMILTONIAN
C
      DDJ=-(3.0D0*(TAU(IC,IC,IC,IC)+TAU(IB,IB,IB,IB))+2.0D0*
     &     (TAU(IB,IB,IC,IC)+2.0D0*TAU(IB,IC,IB,IC)))/32.0D0
      DDK =DDJ-0.25D0*(TAU(IA,IA,IA,IA)-TAU(IA,IA,IB,IB)-2.0D0*
     &        TAU(IA,IB,IA,IB)-TAU(IA,IA,IC,IC)-2.0D0*
     &        TAU(IA,IC,IA,IC))
      DDJK=-DDJ-DDK-0.25D0*TAU(IA,IA,IA,IA)
c      write(6,*)ddj,ddk,tau(ia,ia,ia,ia)
      DELJ=DDJ-2.D0*R6
      DELK=DDK-10.0D0*R6
      DELJK=DDJK+12.0D0*R6
      DEL2J=-(TAU(IB,IB,IB,IB)-TAU(IC,IC,IC,IC))/16.0D0
      DEL2K=-2.0D0*R5-4.0D0*R6*SIGMA
c      write(6,*)' A-reduced Hamiltonian centrifugal constants'
c      write(6,*)' r6 is ',r6,2.0d0*r5,4.0d0*r6*sigma
c      write(6,*)' DJ is ',ddj,ddj*fact2
c      write(6,*)' DK is ',ddk,ddk*fact2
c      write(6,*)' DJK is ',ddjk,ddjk*fact2
c      write(6,*)' DELJ is ',delj,delj*fact2
c      write(6,*)' DELK is ',delk,delk*fact2
c      write(6,*)' DELJK is ',d(6,*)' DELK is ',delk,delk*fact2
c      write(6,*)' DELJK is ',deljk,deljk*fact2
c      write(6,*)' delJ is ',del2j,del2j*fact2
c      write(6,*)' delK is ',del2k,del2k*fact2
c      write(6,*)' SIGMA is ',sigma
C
C WRITE OUT THE STUFF
C
      WRITE(6,304)
      WRITE(6,305)
      WRITE(6,304)
      WRITE(6,*)
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'R6',r6*fact2,r6
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'R5',R5*FACT2,R5
      WRITE(6,'(T12,A2,T42,E12.6)')'SIGMA',SIGMA
      WRITE(6,*)
      WRITE(6,*)' A-reduced centrifugal distortion parameters '
      WRITE(6,*)
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'DJ',DDJ*FACT2,DDJ
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'DK',DDK*FACT2,DDK
      WRITE(6,'(T12,A3,T30,E12.6,T53,E12.6)')'DJK',DDJK*FACT2,DDJK
      WRITE(6,'(T12,A4,T30,E12.6,T53,E12.6)')'DELJ',DELJ*FACT2,DELJ
      WRITE(6,'(T12,A4,T30,E12.6,T53,E12.6)')'DELK',DELK*FACT2,DELK
      WRITE(6,'(T12,A5,T30,E12.6,T53,E12.6)')'DELJK',DELJK*FACT2,DELJK
      WRITE(6,'(T12,A4,T30,E12.6,T53,E12.6)')'delJ',DEL2J*FACT2,DEL2J
      WRITE(6,'(T12,A4,T30,E12.6,T53,E12.6)')'delK',DEL2K*FACT2,DEL2K
      WRITE(6,*)
      WRITE(6,*)' S-reduced centrifugal distortion parameters '
      WRITE(6,*)
C
C CALCULATE FANCY PARAMETERS FOR WATSON'S S-REDUCED HAMILTONIAN
C
      DDJ=DDJ+R5/SIGMA
      DDK=DDK+R5*5.0D0/SIGMA
      DDJK=DDJK-6.0D0*R5/SIGMA
      D1=-DEL2J
      D2=R6+R5/(2.0D0*SIGMA)
C
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'DJ',DDJ*FACT2,DDJ
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'DK',DDK*FACT2,DDK
      WRITE(6,'(T12,A3,T30,E12.6,T53,E12.6)')'DJK',DDJK*FACT2,DDJK      
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'D1',D1*FACT2,D1
      WRITE(6,'(T12,A2,T30,E12.6,T53,E12.6)')'D2',D2*FACT2,D2
      WRITE(6,304)

c      write(6,*)' d2 is ',d2
c      write(6,*)' S-reduced Hamiltonian centrifugal constants'
c      write(6,*)' r6 is ',r6,r6*fact2
c      write(6,*)' DJ is ',ddj,ddj*fact2
c      write(6,*)' DK is ',ddk,ddk*fact2
c      write(6,*)' DJK is ',ddjk,ddjk*fact2
c      write(6,*)' d1 is ',D1,D1*fact2
c      write(6,*)' d2 is ',D2,D2*fact2
c      write(6,*)' SIGMA is ',sigma
c
c      write(6,*)' debug stuff '
      BSRMBPP(IB)=-(2.0D0*ddj+ddjk+2.0d0*(d1+2.0d0*d2))*FACT2
      BSRMBPP(IC)=-(2.0D0*ddj+ddjk+2.0d0*(-d1+2.0d0*d2))*FACT2
      BSRMBPP(IA)=-(2.0D0*ddj+6.0d0*d2)*FACT2
c      write(6,*)z3*fact2,z1*fact2,z2*fact2,' **** bs -> bdprime '
      BSRMBP(IB)=-(4.0D0*r6-4.0D0*r5-2.0d0*r5/sigma)*FACT2
      BSRMBP(IC)=-(4.0D0*r6+4.0d0*r5-2.d0*r5/sigma)*FACT2
      BSRMBP(IA)=-(6.0d0*r6-5.0d0*r5/sigma)*FACT2
C
      WRITE(6,*)' Centrifugal corrections for various types of ',
     &          'rotational constants (MHz) ...'
      WRITE(6,300)BXPPMBX,BYPPMBY,BZPPMBZ
300   FORMAT(T3,' Bx''''-Bx ',F20.10,/,T3,' By''''-By ',F20.10,/,
     &       T3,' Bz''''-Bz ',F20.10)
      WRITE(6,301)BXPPMBXP,BYPPMBYP,BZPPMBZP
301   FORMAT(T3,' Bx''''-Bx'' ',F20.10,/,T3,' By''''-By'' ',F20.10,/,
     &       T3,' Bz''''-Bz'' ',F20.10)
      WRITE(6,302)BXPPMBX-BXPPMBXP,BYPPMBY-BYPPMBYP,BZPPMBZ-BZPPMBZP
302   FORMAT(T3,' Bx''-Bx ',F20.10,/,T3,' By''-By ',F20.10,/,
     &       T3,' Bz''-Bz ',F20.10)
      WRITE(6,303)BSRMB(1),BSRMB(2),BSRMB(3)
303   FORMAT(T3,' BxSR-Bx ',F20.10,/,T3,' BySR-By ',F20.10,/,
     &       T3,' BzSR-Bz ',F20.10)
      WRITE(6,308)BSRMBPP(1),BSRMBPP(2),BSRMBPP(3)
308   FORMAT(T3,' BxSR-Bx'''' ',F20.10,/,T3,' BySR-By'''' ',F20.10,/,
     &       T3,' BzSR-Bz'''' ',F20.10)
      WRITE(6,309)BSRMBP(1),BSRMBP(2),BSRMBP(3)
309   FORMAT(T3,' BxSR-Bx'' ',F20.10,/,T3,' BySR-By'' ',F20.10,/,
     &       T3,' BzSR-Bz'' ',F20.10)
C
305   FORMAT(T9,'Parameter',T34,'(MHz)',T56,'(CM-1)')
304   FORMAT(60('-'))
C
1000  FORMAT(T10,' Quartic centrifugal distortion parameters ')
1002  FORMAT(T33,'CM-1',T53,'MHz')
1001  FORMAT(75('-'))
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      ATOMIC,
     +                      NEXP,
     +                      NXYZA,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_INT1D_TO_A0
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                kinetic integrals [A|0] or [0|A], adding up all
C                contributions from all the kinetic and overlap 1D
C                integrals:
C
C                        X = KIN (XA) * OVL (YA) * OVL (ZA)
C                        Y = OVL (XA) * KIN (YA) * OVL (ZA)
C                        Z = OVL (XA) * OVL (YA) * KIN (ZA)
C
C                    [A|0] = [0|A] = [XA,YA,ZA] = X + Y + Z
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between the
C                kinetic and overlap 1DX integrals with the scaling
C                factors.
C
C
C                  Input:
C
C                    SHELLA      =  shell type for contracted shell A
C                    ATOMIC      =  indicates, if purely atomic [A|0]
C                                   or [0|A] integrals will be
C                                   evaluated
C                    NEXP        =  current # of exponent pairs
C                    NXYZx       =  # of cartesian monomials for
C                                   shell A
C                    KIN1Dx      =  all current kinetic 1D integrals
C                                   for each cartesian component
C                                   x = X,Y,Z
C                    OVL1Dx      =  all current overlap 1D integrals
C                                   for each cartesian component
C                                   x = X,Y,Z
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1DX kinetic and overlap integral
C                                   times scaling factor products
C                    SCALE       =  the NEXP scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian [A|0]
C                                   or [0|A] kinetic integrals
C                                   corresponding to all current
C                                   exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     I,N
         INTEGER     NEXP
         INTEGER     NXYZA
         INTEGER     SHELLA
         INTEGER     XA,YA,ZA
         INTEGER     YAMAX

         DOUBLE PRECISION  X,Y,Z
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NEXP)
         DOUBLE PRECISION  TEMP1 (1:NEXP)
         DOUBLE PRECISION  TEMP2 (1:NEXP)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZA)

         DOUBLE PRECISION  KIN1DX (1:NEXP,0:SHELLA)
         DOUBLE PRECISION  KIN1DY (1:NEXP,0:SHELLA)
         DOUBLE PRECISION  KIN1DZ (1:NEXP,0:SHELLA)

         DOUBLE PRECISION  OVL1DX (1:NEXP,0:SHELLA+2,0:1)
         DOUBLE PRECISION  OVL1DY (1:NEXP,0:SHELLA+2,0:1)
         DOUBLE PRECISION  OVL1DZ (1:NEXP,0:SHELLA+2,0:1)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...the atomic case. Outer loop is over x contributions,
C                inner loop over y,z contributions. Skip any odd
C                and x,y and z contributions.
C
C
         IF (ATOMIC) THEN

             DO I = 1,NXYZA
             DO N = 1,NEXP
                BATCH (N,I) = ZERO
             END DO
             END DO

             I = 0
             DO 100 XA = SHELLA,0,-1
                YAMAX = SHELLA - XA

                IF (MOD (XA,2).NE.0) THEN
                    I = I + YAMAX + 1
                ELSE
                    IF (XA.GT.0) THEN
                        DO N = 1,NEXP
                           TEMP1 (N) = SCALE (N) * KIN1DX (N,XA)
                           TEMP2 (N) = SCALE (N) * OVL1DX (N,XA,0)
                        END DO
                    ELSE
                        DO N = 1,NEXP
                           TEMP1 (N) = SCALE (N) * KIN1DX (N,XA)
                           TEMP2 (N) = SCALE (N)
                        END DO
                    END IF

                    DO 110 YA = YAMAX,0,-1
                       I = I + 1
                       ZA = YAMAX - YA

                       IF (MOD (YA,2).EQ.0 .AND. MOD (ZA,2).EQ.0) THEN

                           IF (YA.GT.0 .AND. ZA.GT.0) THEN

                               DO N = 1,NEXP
                                  X = TEMP1 (N) * OVL1DY (N,YA,0)
     +                                          * OVL1DZ (N,ZA,0)
                                  Y = TEMP2 (N) * KIN1DY (N,YA)
     +                                          * OVL1DZ (N,ZA,0)
                                  Z = TEMP2 (N) * OVL1DY (N,YA,0)
     +                                          * KIN1DZ (N,ZA)
                                  BATCH (N,I) = X + Y + Z
                               END DO

                           ELSE IF (YA.GT.0) THEN

                               DO N = 1,NEXP
                                  X = TEMP1 (N) * OVL1DY (N,YA,0)
                                  Y = TEMP2 (N) * KIN1DY (N,YA)
                                  Z = TEMP2 (N) * OVL1DY (N,YA,0)
     +                                          * KIN1DZ (N,ZA)
                                  BATCH (N,I) = X + Y + Z
                               END DO

                           ELSE IF (ZA.GT.0) THEN

                               DO N = 1,NEXP
                                  X = TEMP1 (N) * OVL1DZ (N,ZA,0)
                                  Y = TEMP2 (N) * KIN1DY (N,YA)
     +                                          * OVL1DZ (N,ZA,0)
                                  Z = TEMP2 (N) * KIN1DZ (N,ZA)
                                  BATCH (N,I) = X + Y + Z
                               END DO

                           ELSE

                               DO N = 1,NEXP
                                  X = TEMP1 (N)
                                  Y = TEMP2 (N) * KIN1DY (N,YA)
                                  Z = TEMP2 (N) * KIN1DZ (N,ZA)
                                  BATCH (N,I) = X + Y + Z
                               END DO

                           END IF

                       END IF

  110               CONTINUE
                END IF

  100        CONTINUE

         ELSE
C
C
C             ...the nonatomic case. Outer loop is over x contributions,
C                inner loop over y,z contributions.
C
C
             I = 0
             DO 200 XA = SHELLA,0,-1
                YAMAX = SHELLA - XA

                IF (XA.GT.0) THEN
                    DO N = 1,NEXP
                       TEMP1 (N) = SCALE (N) * KIN1DX (N,XA)
                       TEMP2 (N) = SCALE (N) * OVL1DX (N,XA,0)
                    END DO
                ELSE
                    DO N = 1,NEXP
                       TEMP1 (N) = SCALE (N) * KIN1DX (N,XA)
                       TEMP2 (N) = SCALE (N)
                    END DO
                END IF

                DO 210 YA = YAMAX,0,-1
                   I = I + 1
                   ZA = YAMAX - YA

                   IF (YA.GT.0 .AND. ZA.GT.0) THEN

                       DO N = 1,NEXP
                          X = TEMP1 (N) * OVL1DY (N,YA,0)
     +                                  * OVL1DZ (N,ZA,0)
                          Y = TEMP2 (N) * KIN1DY (N,YA)
     +                                  * OVL1DZ (N,ZA,0)
                          Z = TEMP2 (N) * OVL1DY (N,YA,0)
     +                                  * KIN1DZ (N,ZA)
                          BATCH (N,I) = X + Y + Z
                       END DO

                   ELSE IF (YA.GT.0) THEN

                       DO N = 1,NEXP
                          X = TEMP1 (N) * OVL1DY (N,YA,0)
                          Y = TEMP2 (N) * KIN1DY (N,YA)
                          Z = TEMP2 (N) * OVL1DY (N,YA,0)
     +                                  * KIN1DZ (N,ZA)
                          BATCH (N,I) = X + Y + Z
                       END DO

                   ELSE IF (ZA.GT.0) THEN

                       DO N = 1,NEXP
                          X = TEMP1 (N) * OVL1DZ (N,ZA,0)
                          Y = TEMP2 (N) * KIN1DY (N,YA)
     +                                  * OVL1DZ (N,ZA,0)
                          Z = TEMP2 (N) * KIN1DZ (N,ZA)
                          BATCH (N,I) = X + Y + Z
                       END DO

                   ELSE

                       DO N = 1,NEXP
                          X = TEMP1 (N)
                          Y = TEMP2 (N) * KIN1DY (N,YA)
                          Z = TEMP2 (N) * KIN1DZ (N,ZA)
                          BATCH (N,I) = X + Y + Z
                       END DO

                   END IF

  210           CONTINUE
  200        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine RdBLab (LUN, NewVM, NSO, Cen, AngMom)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: rdblab.F,v 1.2 2004/07/30 02:20:08 yau Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     rdblab -- read basis function labels from Molecule-style integrals
C
C SYNOPSIS
      Integer LUN, NSO
      Character*4 Cen(NSO), AngMom(NSO)
      Logical NewVM
C
C ARGUMENTS
C     LUN     Unit for integral file (input)
C     NewVM   New VMol or old VMol (input)
C     NSO     Nr. of symmetry adapted basis functions (input)
C     Cen     SO function center labels (output)
C     AngMom  SO function angular momentum labels (output)
C
C ROUTINES REQUIRED
C     Locate  Find a give record label in a Molecule-style int. file
C
C DESCRIPTION
C     Reads the center an angular momentum text labels from a Molecule-
C     style integral file.
C
C     Center labels really identify the center selected to be the origin
C     of each orbit (set of equivalent centers).
C
C BUGS
C     Molecule record label is fixed as SYMTRANS for old VMol and
C     LABBASIS for new VMol.
C     Variable IIntFP in common block MACHSP must be 1 or 2.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Include 'mach.inc'
C $Id: rdblab.F,v 1.2 2004/07/30 02:20:08 yau Exp $
      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100)
C LOCAL VARIABLES
C     i       General counter
C     j       General counter
C     Junk    To skip over center and ang. mom. labels neatly.
C             
      Character*4 Junk
      Integer I, j, IACESIII
      LOGICAL SEWARD, ACESIII
C
      SEWARD = IFLAGS(56) .EQ. 4
      CALL GETREC(-1, "JOBARC", "AIIIJARC", 1, IACESIII)
      IF (IACESIII .GT. 0) ACESIII = .TRUE.

      IF (SEWARD .OR. ACESIII) THEN
         OPEN(UNIT=1,FILE='LABBASIS',STATUS='OLD')
         DO I = 1,NSO
            READ(1,'(3X,A4,3X,A4)') CEN(I),ANGMOM(I)
         END DO
         CLOSE(UNIT=1,STATUS='KEEP')
         RETURN
      END IF
C
C     New and old VMol put the data in different places
C
      If (NewVM) then
         Call Locate( LUN, 'LABBASIS')
      Else
         Call Locate( LUN, 'SYMTRANS')
      EndIf
C
C     Also have to worry about padding due to word length considerations
C
C SG 8/26/98 Not anymore, since these are written as character*4
      Do 200 I = 1, NSO
         Read (LUN) J, Cen(j), AngMom(j)
 200  Continue
C
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE PROJFCM(NATOM,NIRREP,IORDER,FCM,FCMSCR,
     &                   SYOP,IPTR,NBFATM,ILCATM,SCR)
C
C THIS ROUTINE PROJECTS THE TOTALLY SYMMETRIC COMPONENT FROM A
C "PETITE" CARTESIAN FORCE CONSTANT MATRIX USING THE SYMMETRY
C OPERATIONS OF THE FULL POINT GROUP.
C
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FCM(3*NATOM,3*NATOM),SCR(1),FCMSCR(3*NATOM,3*NATOM)
      DIMENSION SYOP(9*IORDER),IPTR(NATOM,IORDER),NBFATM(NATOM)
      DIMENSION ILCATM(NATOM)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100),IFLAGS2(500)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
C
      ININE=9
C
      IF(IFLAGS(1).GE.1)THEN
       WRITE(6,1000)
      ENDIF
      NSIZE=3*NATOM
C
C GET SOME INFORMATION FROM JOBARC
C
      CALL FILTER(FCM,9*NATOM*NATOM,1.0D-08)
      CALL DGETREC(20,'JOBARC','FULLSYOP',9*IORDER,SYOP)
      CALL IGETREC(20,'JOBARC','FULLPERM',NATOM*IORDER,IPTR)
      CALL DGETREC(20,'JOBARC','ORIENTMT',ININE,SCR)
      CALL TRNOPS(SYOP,SCR,IORDER)
C
C FILL BASIS VECTOR.  SKIP DUMMY ATOMS.
C
      DO 5 IATOM=1,NATOM
       NBFATM(IATOM)=3
       ILCATM(IATOM)=3*(IATOM-1)+1
5     CONTINUE
C
      ZNORM=ONE/DFLOAT(IORDER)
C
C HALF-PROJECT CARTESIAN FCM
C
C LOOP OVER CARTESIAN DIRECTIONS
C
      IOFFS=18*NATOM*NATOM+1
      CALL ZERO(FCMSCR,9*NATOM*NATOM)
      DO 30 IOP=1,IORDER
       CALL XDCOPY(9*NATOM*NATOM,FCM,1,SCR,1)
       IOFFA=1
       IOFFB=9*NATOM*NATOM+1
       DO 20 IBAS=1,3*NATOM
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &             SCR(IOFFA),SCR(IOFFB),SCR(IOFFS),1,3*NATOM,
     &             SYOP,0)
         IOFFA=IOFFA+3*NATOM
         IOFFB=IOFFB+3*NATOM
20      CONTINUE 
        CALL MTRAN2(SCR(9*NATOM*NATOM+1),3*NATOM)
        IOFFA=9*NATOM*NATOM+1
        IOFFB=1
        DO 21 IBAS=1,3*NATOM
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &             SCR(IOFFA),SCR(IOFFB),SCR(IOFFS),1,3*NATOM,
     &             SYOP,0)
         IOFFA=IOFFA+3*NATOM
         IOFFB=IOFFB+3*NATOM
21      CONTINUE
       CALL XDAXPY(9*NATOM*NATOM,ONE,SCR,1,FCMSCR,1)
30    CONTINUE
C
      CALL XDSCAL(9*NATOM*NATOM,ZNORM,FCMSCR,1)
      CALL VADD (SCR,FCM,FCMSCR,9*NATOM*NATOM,ONEM)
      ILOC=ISAMAX(9*NATOM*NATOM,SCR,1)
      DIFMAX=SCR(ILOC)
      IF(IFLAGS(1).GE.1)WRITE(6,1001)DIFMAX
      IF(DIFMAX.GT.1.D-4)THEN
       WRITE(6,1002)
      ENDIF
      CALL XDCOPY(9*NATOM*NATOM,FCMSCR,1,FCM,1)
C
C WRITE SYMMETRIZED FCM BACK TO DISK
C
      OPEN(UNIT=21,FILE='FCM',FORM='FORMATTED',STATUS='UNKNOWN')
      OPEN(UNIT=22,FILE='FCMFINAL',FORM='FORMATTED',STATUS='UNKNOWN')
      WRITE(21,'(2I5)')NATOM,3*NATOM
      WRITE(21,'((3F20.10))')(FCM(I,1),I=1,9*NATOM*NATOM)
      WRITE(22,'(2I5)')NATOM,3*NATOM
      WRITE(22,'((3F20.10))')(FCM(I,1),I=1,9*NATOM*NATOM)
      CLOSE(UNIT=21,STATUS='KEEP')
      CLOSE(UNIT=22,STATUS='KEEP')
C
      RETURN
1000  FORMAT(T3,'@PROJFCM-I, Projecting force constant matrix onto ',
     &          'totally symmetric subspace.')
1001  FORMAT(T3,'Largest difference between matrix elements of ',
     &          'symmetrized',/,T3,'and unsymmetrized FCM : ',F15.10,
     &          '.')
1002  FORMAT(T3,'@PROJFCM-W, The input FCM was not totally symmetric.')
      END

         SUBROUTINE  OED__SOI_CSGTOyz
     +
     +                    ( IMAX,ZMAX,
     +                      NALPHA,NCOEFF,NCSUM,
     +                      NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      NUCLEI,
     +                      XN,YN,ZN,NCHARGE,
     +                      IXDERC,
     +                      DER1X,DER1Y,DER1Z,
     +                      DER2X,DER2Y,DER2Z,
     +                      DERCX,DERCY,DERCZ,
     +                      ALPHA,CC,CCBEG,CCEND,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      L1CACHE,TILE,NCTROW,
     +                      SPHERIC,SCREEN,
     +                      ICORE,
     +
     +                                NBATCH,
     +                                NFIRST,
     +                                ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_DERV_CSGTO
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__NAI_SET_DERV_AB
C                OED__NAI_SET_DERV_IJC_TRIPLES
C                OED__NAI_SET_DERV_SEQUENCE
C                OED__NAI_DERV_DEF_BLOCKS
C                OED__NAI_PREPARE_CTR
C                OED__NAI_DERV_PCGTO_BLOCK
C                OED__CTR_2INDEX_BLOCK
C                OED__CTR_RS_EXPAND
C                OED__CTR_2INDEX_REORDER
C                OED__TRANSPOSE_BATCH
C                OED__XYZ_TO_RY_AB
C                OED__CARTESIAN_NORMS
C                OED__SPHERICAL_TRANSFORM
C                OED__NORMALIZE_CARTESIAN
C                OED__MOVE_RY
C  DESCRIPTION : This operation calculates a batch of differentiated
C                contracted nuclear attraction integrals for a set of
C                nuclear attraction centers on up to two different
C                electronic centers between spherical or cartesian
C                gaussian type shells.
C
C
C                  Input (x = 1 and 2):
C
C                    IMAX,ZMAX    =  maximum integer + flp memory
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCSUM        =  total # of contractions
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    NUCLEI       =  # of nuclear attraction centers
C                    XN,YN,ZN     =  the x,y,z-coordinates for all
C                                    nuclear attraction centers
C                    NCHARGE      =  the nuclear charges for all
C                                    nuclear attraction centers
C                    IXDERC       =  the index of which of the nuclear
C                                    attraction centers is to be
C                                    differentiated. If that index
C                                    corresponds to one of the centers
C                                    1 and/or 2, it will already be
C                                    differentiated along with these
C                                    centers, hence values transmitted
C                                    for DERCX,DERCY,DERCZ are
C                                    irrelevant in that case. If no
C                                    nuclear attraction center is to
C                                    be differentiated besides those
C                                    which are possibly equal to
C                                    centers 1 and/or 2, set this
C                                    index value =< 0
C                    DERyp        =  the order of differentiation on
C                                    centers y = 1 and 2 with respect
C                                    to the p = x,y,z coordinates
C                    DERCp        =  the order of differentiation for
C                                    the IXDERC-th nuclear attraction
C                                    center with respect to the
C                                    p = x,y,z coordinates
C                    ALPHA        =  primitive exponents for csh
C                                    1 and 2 in that order
C                    CC           =  full set (including zeros) of
C                                    contraction coefficients for csh
C                                    1 and 2 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    CC(BEG)END   =  (lowest)highest nonzero primitive
C                                    index for contractions for csh
C                                    1 and 2 in that order. They are
C                                    different from (1)NPGTOx only for
C                                    segmented contractions
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C                    SCREEN       =  is true, if screening will be
C                                    done at primitive integral level
C                    ICORE        =  integer scratch space
C                    ZCORE (part) =  flp scratch space
C
C                  Output:
C
C                    NBATCH       =  # of derivative integrals in batch
C                    NFIRST       =  first address location inside the
C                                    ZCORE array containing the first
C                                    derivative integral
C                    ZCORE        =  full batch of contracted (1|2)
C                                    derivative nuclear attraction
C                                    integrals over cartesian or
C                                    spherical gaussians starting at
C                                    ZCORE (NFIRST)
C
C
C
C              --- NOTES ABOUT THE OVERALL NAI INTEGRAL PREFACTOR ---
C
C                The overal nuclear attraction integral prefactor is
C                defined here as follows. Consider the normalization
C                factors for a primitive cartesian GTO and for a
C                spherical GTO belonging to the angular momentum
C                L = l+m+n:
C
C
C                    lmn                        l m n           2
C                 GTO  (x,y,z) = N (l,m,n,a) * x y z  * exp (-ar )
C                    a
C
C
C                    LM                     L    LM                2
C                 GTO  (r,t,p) = N (L,a) * r  * Y  (t,p) * exp (-ar )
C                    a
C
C
C                where a = alpha exponent, t = theta and p = phi and
C                N (l,m,n,a) and N (L,a) denote the respective
C                cartesian and spherical normalization factors such
C                that:
C
C
C                              lmn            lmn
C                 integral {GTO  (x,y,z) * GTO   (x,y,z) dx dy dz} = 1
C                              a              a
C
C
C                              LM             LM
C                 integral {GTO  (r,t,p) * GTO  (r,t,p) dr dt dp} = 1
C                              a              a
C
C
C                The normalization constants have then the following
C                values, assuming the spherical harmonics are
C                normalized:
C
C                              _____________________________________
C                             /      2^(2L+1+1/2) * a^((2L+3)/2)
C            N (l,m,n,a) =   / ----------------------------------------
C                          \/ (2l-1)!!(2m-1)!!(2n-1)!! * pi * sqrt (pi)
C
C
C                                   ____________________________
C                                  / 2^(2L+3+1/2) * a^((2L+3)/2)
C                     N (L,a) =   / -----------------------------
C                               \/     (2L+1)!! * sqrt (pi)
C
C
C                Note, that the extra pi under the square root in
C                N (l,m,n,a) belongs to the normalization of the
C                spherical harmonic functions and therefore does not
C                appear in the expression for N (L,a). The common
C                L-,l-,m-,n- and a-independent part of the cartesian
C                norm is a scalar quantity needed for all integrals
C                no matter what L-,l-,m-,n- and a-values they have:
C
C                                       _____________
C                                      /  2^(1+1/2)
C                     N (0,0,0,0) =   / --------------
C                                   \/  pi * sqrt (pi)
C
C
C                Also every nuclear attraction integral has a factor
C                of 2*pi associated with it, hence the overall common
C                factor for all nuclear attraction integrals will be
C                N(0,0,0,0)**2 times 2*pi. In order to avoid sign
C                changes of the nuclear charges, the negative sign of
C                these is incorporated also into the prefactor, which
C                is thus equal to:
C
C                                            _________
C                            PREFACT  =  - \/ 32 / pi 
C
C
C                and is set as a parameter inside the present routine.
C                The alpha exponent dependent part of the norms:
C
C                                   ______________
C                                 \/ a^((2L+3)/2)
C
C                will be calculated separately (see below) and their
C                inclusion in evaluating the primitive cartesian
C                derivative nuclear attraction [A|B] integrals will be
C                essential for numerical stability during contraction.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     BLOCKED
         LOGICAL     CASEI,CASEII,CASEIII
         LOGICAL     DIFFA,DIFFB,DIFFC
         LOGICAL     DIFFX,DIFFY,DIFFZ
         LOGICAL     EMPTY
         LOGICAL     EQUALAB
         LOGICAL     MEMORY
         LOGICAL     ONECASE
         LOGICAL     REORDER
         LOGICAL     SCREEN
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAPRS

         INTEGER     DER1X,DER1Y,DER1Z
         INTEGER     DER2X,DER2Y,DER2Z
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DERCX,DERCY,DERCZ
         INTEGER     IMAX,ZMAX
         INTEGER     IN,OUT
         INTEGER     INDEXA,INDEXB
         INTEGER     INDEXR,INDEXS
         INTEGER     INUCCEN
         INTEGER     IPRIMA,IPRIMB
         INTEGER     IPUSED,IPSAVE,IPPAIR
         INTEGER     ISNROWA,ISNROWB
         INTEGER     ISROWA,ISROWB
         INTEGER     IUSED,ZUSED
         INTEGER     IXAEQB,IXCEQA,IXCEQB
         INTEGER     IXDERC
         INTEGER     L1CACHE,TILE,NCTROW
         INTEGER     LCC1,LCC2
         INTEGER     LCCA,LCCB
         INTEGER     LCCSEGA,LCCSEGB
         INTEGER     LEXP1,LEXP2
         INTEGER     LEXPA,LEXPB
         INTEGER     MGRID,NGRID
         INTEGER     MIJ,MIJCEN,MGQPIJ,MGIJCEN
         INTEGER     MOVE,NOTMOVE
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSHELL
         INTEGER     NALPHA,NCOEFF,NCSUM
         INTEGER     NBATCH,NFIRST
         INTEGER     NCENA,NCENB,NCENC
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NCGTOA,NCGTOB,NCGTOAB
         INTEGER     NCGTOR,NCGTOS
         INTEGER     NCTR
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NGQP,NMOM,NGQSCR
         INTEGER     NIJ,NIJBLK,NIJBEG,NIJEND
         INTEGER     NINT1DX,NINT1DY,NINT1DZ
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NPGTOA,NPGTOB,NPGTOAB
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NROTA,NROTB
         INTEGER     NROWA,NROWB
         INTEGER     NRYA,NRYB
         INTEGER     NUCLEI
         INTEGER     NXYZA,NXYZB,NXYZT
         INTEGER     SHELL1,SHELL2
         INTEGER     SHELLA,SHELLB,SHELLP
         INTEGER     TEMP

         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,
     +               ZBASE,ZCNORM,
     +               ZRHOAB,
     +               ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +               ZRTS,ZWTS,ZGQSCR,ZTVAL,
     +               ZR1X,ZR1Y,ZR1Z,ZR2,
     +               ZEXP2A,ZEXP2B,ZEXP2AB,
     +               ZINT1DX,ZINT1DY,ZINT1DZ,
     +               ZSROTA,ZSROTB

         INTEGER     CCBEG (1:NCSUM)
         INTEGER     CCEND (1:NCSUM)
         INTEGER     ICORE (1:IMAX)
         INTEGER     IXOFF (1:2)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  PREFACT
         DOUBLE PRECISION  RNABSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB

         DOUBLE PRECISION  XN      (1:NUCLEI)
         DOUBLE PRECISION  YN      (1:NUCLEI)
         DOUBLE PRECISION  ZN      (1:NUCLEI)
         DOUBLE PRECISION  NCHARGE (1:NUCLEI)

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
         DOUBLE PRECISION  ZCORE (1:ZMAX)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (PREFACT = -3.191538243211461D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...fix the A,B labels from the 1,2 ones. Calculate
C                the relevant data for the A,B batch of derivative
C                nuclear attraction integrals.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LCC1  = 1
         LCC2  = LCC1 + NPGTO1 * NCGTO1

         CALL  OED__SOI_SET_AB
     +
     +              ( NCGTO1,NCGTO2,
     +                NPGTO1,NPGTO2,
     +                SHELL1,SHELL2,
     +                X1,Y1,Z1,X2,Y2,Z2,
     +                NUCLEI,
     +                XN,YN,ZN,
     +                IXDERC,
     +                DER1X,DER1Y,DER1Z,
     +                DER2X,DER2Y,DER2Z,
     +                DERCX,DERCY,DERCZ,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                CC (LCC1),CC (LCC2),
     +                SPHERIC,
     +
     +                            NCGTOA,NCGTOB,
     +                            NPGTOA,NPGTOB,
     +                            SHELLA,SHELLB,SHELLP,
     +                            MXSHELL,
     +                            XA,YA,ZA,XB,YB,ZB,
     +                            NDERX,NDERY,NDERZ,
     +                            DERAX,DERAY,DERAZ,
     +                            DERBX,DERBY,DERBZ,
     +                            DIFFA,DIFFB,DIFFC,
     +                            DIFFX,DIFFY,DIFFZ,
     +                            IXAEQB,IXCEQA,IXCEQB,
     +                            ATOMIC,EQUALAB,
     +                            ABX,ABY,ABZ,RNABSQ,
     +                            SPNORM,
     +                            NXYZA,NXYZB,NXYZT,
     +                            NRYA,NRYB,
     +                            INDEXA,INDEXB,
     +                            SWAP12,SWAPRS,
     +                            LEXPA,LEXPB,
     +                            LCCA,LCCB,
     +                            LCCSEGA,LCCSEGB,
     +                            EMPTY )
     +
     +
c         WRITE (*,*) ' Finished set derivative ab '
c         WRITE (*,'(a,2I3)') ' Index A,B = ',INDEXA,INDEXB
c         write(*,*)
         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...set the i and j primitive exponent sets, the relevant
C                nuclear attraction centers and the corresponding
C                exponential prefactors.
C
C
         IF (EQUALAB) THEN
             NPGTOAB = (NPGTOA*(NPGTOA+1))/2
             NCGTOAB = (NCGTOA*(NCGTOA+1))/2
         ELSE
             NPGTOAB = NPGTOA * NPGTOB
             NCGTOAB = NCGTOA * NCGTOB
         END IF

         IPRIMA = 1
         IPRIMB = IPRIMA + NPGTOAB
         INUCCEN = IPRIMB + NPGTOAB

         CALL  OED__SOI_SET_DERV_IJC_TRIPLES
     +
     +              ( NUCLEI,
     +                XN,YN,ZN,NCHARGE,
     +                NPGTOA,NPGTOB,NPGTOAB,
     +                DIFFC,IXDERC,
     +                ATOMIC,EQUALAB,
     +                SWAPRS,
     +                XA,YA,ZA,XB,YB,ZB,
     +                RNABSQ,
     +                PREFACT,
     +                ALPHA (LEXPA),ALPHA (LEXPB),
     +                FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                SCREEN,
     +
     +                        EMPTY,
     +                        NIJ,NCENA,NCENB,NCENC,
     +                        ICORE (IPRIMA),ICORE (IPRIMB),
     +                        IXCEQA,IXCEQB,
     +                        ICORE (INUCCEN),
     +                        ZCORE (1) )
     +
     +
c         WRITE (*,*) ' Finished set derivative ijc triples '
c          write(*,*)
         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...we are now ready to calculate the cartesian contracted
C                (a|b) derivative nuclear attraction batch, which is
C                obtained as a sum over all attraction centers:
C
C                           dxdydz (a|b)  =  sum dxdydz (a|C|b)
C                                             C
C
C                Three cases can arise for each basic (a|C|b) derivative
C                integral, each of which has to be dealt separately and
C                summed into (a|b):
C
C                    Case I    =  2-center integrals of type (a|A|b)
C                    Case II   =  2-center integrals of type (a|B|b)
C                    Case III  =  3-center integrals of type (a|C|b)
C
C                Note, that cases I and II cannot arise once dxdydz
C                operates on a center C different from A and B. In that
C                case we only have case III integrals.
C
C                Cases I,II and III differ mainly in the necessary
C                initial shell dimensions for the 1D integrals. We
C                have:
C
C                    Case I   : dxdydz operator will be applied on
C                               the b shell only => initial shell
C                               sizes (x-component as example):
C
C                                     a shell = SHELLA
C                                     b shell = SHELLB + DERAX + DERBX
C
C                    Case II  : dxdydz operator will be applied on
C                               the a shell only => initial shell
C                               sizes (x-component as example):
C
C                                     a shell = SHELLA + DERAX + DERBX
C                                     b shell = SHELLB
C
C                    Case III : dxdydz operator will be applied on
C                               both a and b shells => initial shell
C                               sizes (x-component as example):
C
C                                     a shell = SHELLA + DERAX
C                                     b shell = SHELLB + DERBX
C
C
C                Determine next which of the cases are present and
C                decide on the primitive [a|b] block size and return
C                array sizes and pointers for the primitive [a|b]
C                generation. Perform also some preparation steps
C                for contraction.
C
C
cPV         CASEI   = NCENA .GT. 0
cPV         CASEII  = NCENB .GT. 0
cPV         CASEIII = NCENC .GT. 0
          casei=.false.
          caseii=.false.
          caseIII=.true.
c          write(*,*)
cPV         WRITE (*,*) ' CASEI   = ',CASEI
cPV         WRITE (*,*) ' CASEII  = ',CASEII
cPV         WRITE (*,*) ' CASEIII = ',CASEIII
c          write(*,*)
         ONECASE =      (CASEI  .AND.(.NOT.CASEII).AND.(.NOT.CASEIII))
     +             .OR. (CASEII .AND.(.NOT.CASEI) .AND.(.NOT.CASEIII))
     +             .OR. (CASEIII.AND.(.NOT.CASEI) .AND.(.NOT.CASEII) )

         NGQP = 1 + (SHELLP + NDERX + NDERY + NDERZ) / 2
         NMOM = 2 * NGQP - 1
         NGQSCR = 5 * NMOM + 2 * NGQP - 2


         MEMORY = .FALSE.

         CALL  OED__NAI_DERV_DEF_BLOCKS
     +
     +              ( ZMAX,
     +                NPGTOA,NPGTOB,
     +                SHELLA,SHELLB,SHELLP,
     +                NIJ,NCGTOAB,
     +                MAX (NCENA,NCENB,NCENC),
     +                NGQP,NGQSCR,
     +                NXYZT,
     +                DERAX,DERAY,DERAZ,
     +                DERBX,DERBY,DERBZ,
     +                CASEI,CASEII,CASEIII,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                       NIJBLK,
     +                       NBATCH,
     +                       NPSIZE,NCSIZE,NWSIZE,
     +                       NINT1DX,NINT1DY,NINT1DZ,
     +                       MXPRIM,MNPRIM,
     +                       ZCBATCH,ZPBATCH,ZWORK,
     +                       ZNORMA,ZNORMB,
     +                       ZRHOAB,
     +                       ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +                       ZRTS,ZWTS,ZGQSCR,ZTVAL,
     +                       ZR1X,ZR1Y,ZR1Z,ZR2,
     +                       ZEXP2A,ZEXP2B,ZEXP2AB,
     +                       ZINT1DX,ZINT1DY,ZINT1DZ )
     +
     +
         BLOCKED = (.NOT.ONECASE) .OR. (NIJBLK .LT. NIJ)

c         WRITE (*,*) ' BLOCKED = ',BLOCKED
c          write(*,*)
         CALL  OED__NAI_PREPARE_CTR
     +
     +              ( NCSIZE,
     +                NIJ,
     +                NPGTOA,NPGTOB,
     +                SHELLA,SHELLB,
     +                ALPHA (LEXPA),ALPHA (LEXPB),
     +                PREFACT,SPNORM,
     +                EQUALAB,
     +                BLOCKED,
     +                ZCORE (1),
     +
     +                        ZCORE (ZNORMA),ZCORE (ZNORMB),
     +                        ZCORE (ZRHOAB),
     +                        ZCORE (ZCBATCH) )
     +
     +
         IPUSED = INUCCEN + NCENC
         IPSAVE = IPUSED + MNPRIM
         IPPAIR = IPSAVE + MXPRIM
C
C
C             ...evaluate unnormalized rescaled [a|b] derivative
C                nuclear attraction integrals in blocks over ij pairs
C                and add to final contracted (a|b) derivative nuclear
C                attraction integrals. The keyword REORDER indicates,
C                if the primitive [a|b] derivative nuclear attraction
C                integrals need to be transposed before being
C                contracted.
C
C
         REORDER = .TRUE.
             DO 3000 NIJBEG = 1,NIJ,NIJBLK
                NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
                MIJ = NIJEND - NIJBEG + 1
                MIJCEN  = MIJ * NCENC
                MGIJCEN = NGQP * MIJCEN
                CALL  OED__SOI_3CEN_PCGTO_BLOCKyz
     +
     +                     ( NBATCH,
     +                       NINT1DX,NINT1DY,NINT1DZ,
     +                       ATOMIC,
     +                       MIJ,NCENC,MIJCEN,
     +                       NIJ,NIJBEG,NIJEND,
     +                       NGQP,NMOM,NGQSCR,MGIJCEN,
     +                       NPGTOA,NPGTOB,
     +                       NXYZA,NXYZB,
     +                       SHELLA,SHELLB,SHELLP,
     +                       XA,YA,ZA,XB,YB,ZB,
     +                       ABX,ABY,ABZ,
     +                       NUCLEI,
     +                       XN,YN,ZN,NCHARGE,
     +                       ICORE (INUCCEN),
     +                       DERAX,DERAY,DERAZ,
     +                       DERBX,DERBY,DERBZ,
     +                       DERCX,DERCY,DERCZ,
     +                       DIFFX,DIFFY,DIFFZ,
     +                       DIFFA,DIFFB,DIFFC,
     +                       IXAEQB,
     +                       ALPHA (LEXPA),ALPHA (LEXPB),
     +                       FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                       ICORE (IPRIMA+NIJBEG-1),
     +                       ICORE (IPRIMB+NIJBEG-1),
     +                       ZCORE (ZNORMA),ZCORE (ZNORMB),
     +                       ZCORE (ZRHOAB),
     +                       ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                       ZCORE (ZPAX),ZCORE (ZPAY),ZCORE (ZPAZ),
     +                       ZCORE (ZPINVHF),ZCORE (ZSCALE),
     +                       ZCORE (ZRTS),ZCORE (ZWTS),ZCORE (ZGQSCR),
     +                       ZCORE (ZTVAL),
     +                       ZCORE (ZR1X),ZCORE (ZR1Y),ZCORE (ZR1Z),
     +                       ZCORE (ZR2),
     +                       ZCORE (ZEXP2A),ZCORE (ZEXP2B),
     +                       ZCORE (ZEXP2AB),
     +                       ZCORE (ZINT1DX),
     +                       ZCORE (ZINT1DY),
     +                       ZCORE (ZINT1DZ),
     +
     +                                 ZCORE (ZPBATCH) )
     +
     +
c            WRITE (*,*) ' Finished case III ab nai pcgto derv block '
c       write(*,*)
                CALL  OED__CTR_2INDEX_BLOCK
     +
     +                     ( NPSIZE,NCSIZE,NWSIZE,
     +                       NXYZT,
     +                       MIJ,NCGTOAB,
     +                       NPGTOA,NPGTOB,
     +                       NCGTOA,NCGTOB,
     +                       MXPRIM,MNPRIM,
     +                       CC (LCCA),CC (LCCB),
     +                       CCBEG (LCCSEGA),CCBEG (LCCSEGB),
     +                       CCEND (LCCSEGA),CCEND (LCCSEGB),
     +                       ICORE (IPRIMA+NIJBEG-1),
     +                       ICORE (IPRIMB+NIJBEG-1),
     +                       L1CACHE,TILE,NCTROW,
     +                       EQUALAB,
     +                       SWAPRS,
     +                       REORDER,
     +                       BLOCKED,
     +                       ICORE (IPUSED),
     +                       ICORE (IPSAVE),
     +                       ICORE (IPPAIR),
     +                       ZCORE (ZPBATCH),
     +                       ZCORE (ZWORK),
     +
     +                                 ZCORE (ZCBATCH) )
     +
     +
c                WRITE (*,*) ' Finished case III 2 index ctr block '
c       write(*,*)
 3000        CONTINUE

C
C
C             ...the unnormalized cartesian (a|b) contracted nuclear
C                attraction derivative batch is ready. Expand the
C                contraction indices (if necessary):
C
C                   batch (nxyzt,r>=s) --> batch (nxyzt,r,s)
C
C                and reorder the contraction index part (if necessary):
C
C                   batch (nxyzt,r,s) --> batch (nxyzt,1,2)
C
C                The array IXOFF (x) indicates the total # of indices
C                to the left of x without including the nxyzt-part.
C                For the left most IXOFF value it is convenient to
C                set it equal to 1 instead of 0. Note, that the IXOFF
C                array indicates the true # of indices to the left
C                after! the batch has been transposed (see below) and
C                can be used as initial values when moving the
C                ry-components later during the cartesian -> spherical
C                transformation procedure.
C                
C                Efficient application of the cartesian -> spherical
C                transformation requires the batch elements to be
C                ordered as:
C
C                            batch (1,2,nxyzt)
C
C                hence we transpose the batch after the reordering.
C
C                The space partitioning of the flp array for all of
C                these steps will be as follows:
C
C
C                          |  Zone 1  |  Zone 2  |
C
C                in which Zone 1 and 2 are 2 batches of cartesian
C                (a|b) size.
C
C
         IXOFF (1) = 1
         IXOFF (2) = NCGTO1

         NCTR = NCGTO1 * NCGTO2
         NBATCH = NCTR * NXYZT

         IN = ZCBATCH
         OUT = IN + NBATCH

         IF (EQUALAB .AND. NCGTOAB.GT.1) THEN
             CALL  OED__CTR_RS_EXPAND
     +
     +                  ( NXYZT,NCGTOAB,
     +                    NCGTOA,NCGTOB,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
c             WRITE (*,*) ' Finished ctr rs expansion '
c         write(*,*)
             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

         REORDER = SWAP12 .NEQV. SWAPRS

         IF (REORDER .AND. NCTR.GT.1) THEN

             IF (SWAPRS) THEN
                 INDEXR = INDEXB
                 INDEXS = INDEXA
                 NCGTOR = NCGTOB
                 NCGTOS = NCGTOA
             ELSE
                 INDEXR = INDEXA
                 INDEXS = INDEXB
                 NCGTOR = NCGTOA
                 NCGTOS = NCGTOB
             END IF

             CALL  OED__CTR_2INDEX_REORDER
     +
     +                  ( NXYZT,NCTR,
     +                    NCGTOR,NCGTOS,
     +                    IXOFF (INDEXR),IXOFF (INDEXS),
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
c             WRITE (*,*) ' Finished ctr reorder '
c          write(*,*)
             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

         IF (NXYZT.GT.1 .AND. NCTR.GT.1) THEN

             CALL  OED__TRANSPOSE_BATCH
     +
     +                  ( NXYZT,NCTR,
     +                    TILE,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
c             WRITE (*,*) ' Finished transpose batch '
c          write(*,*)
             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF
C
C
C             ...enter the cartesian -> spherical transformation or
C                cartesian normalization section. After one shell
C                is transformed it is moved to its final position.
C                This leads to the sequence of events (where ' means
C                spherical or cartesian normalization and [] means the
C                indices are in positional correspondence):
C
C                       batch (ij,a,b) --> batch (ij,a,b')
C                       batch (ij,a,b') --> batch (ij[b'],a)
C                       batch (ij[b'],a) --> batch (ij[b'],a')
C                       batch (ij[b'],a') --> batch (ij[a'b'])
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                     |  Zone 1  |  Zone 2  |  Zone 3  |
C
C
C                 Zone 1 and 2:  2 batches of cartesian (a|b) size
C                                (set previously)
C
C                       Zone 3:  cart -> spher transformation data
C                                             or
C                                cartesian normalization factors
C
C
C                Determine the memory allocation offsets for the
C                cartesian -> spherical transformations or cartesian
C                normalizations and generate the transformation
C                matrices + associated data for those shells > p-shell.
C                The offsets are as follows (x=A,B):
C
C                    IN = offset for input cartesian (a|b) batch
C                   OUT = offset for output cartesian (a|b) batch
C
C                ZSROTx = offset for x-part transformation matrix
C               ISNROWx = offset for # of non-zero XYZ contribution row
C                         labels for x-part transformation matrix
C                ISROWx = offset for non-zero XYZ contribution row
C                         labels for x-part transformation matrix
C
C
C                In case of s- or p-shells no transformation matrix is
C                generated, hence if we have s- and/or p-shells, then
C                no call to the cartesian -> spherical transformation
C                or cartesian normalization routines needs to be done.
C                Instead all integrals have to be multiplied by a factor
C                SPNORM, which has the following value for each s- and
C                p-shell:
C
C                       For s-type shell  =  1
C
C                       For p-type shell  =  2 * norm for s-type
C
C                This factor was introduced together with the overall
C                prefactor during evaluation of the primitive integrals
C                in order to save multiplications.
C
C
         ZBASE = MAX (IN,OUT) + NBATCH

         IF (SPHERIC) THEN
             IF (MXSHELL.GT.1) THEN
                 CALL  OED__XYZ_TO_RY_AB
     +
     +                      ( NXYZA,NXYZB,
     +                        NRYA,NRYB,
     +                        SHELLA,SHELLB,
     +                        1,ZBASE,
     +
     +                                 NROWA,NROWB,
     +                                 NROTA,NROTB,
     +                                 ZSROTA,ZSROTB,
     +                                 ISNROWA,ISNROWB,
     +                                 ISROWA,ISROWB,
     +                                 IUSED,ZUSED,
     +                                 ICORE,ZCORE )
     +
     +
C                 WRITE (*,*) ' Finished xyz to ry ab '
             ELSE
                 IUSED = 0
                 ZUSED = 0
             END IF
         ELSE
             IF (MXSHELL.GT.1) THEN
                 ZCNORM = ZBASE
                 CALL  OED__CARTESIAN_NORMS
     +
     +                      ( MXSHELL,
     +
     +                                 ZCORE (ZCNORM))
     +
     +
C                 WRITE (*,*) ' Finished cartesian partial norms '
                 IUSED = 0
                 ZUSED = MXSHELL + 1
             ELSE
                 IUSED = 0
                 ZUSED = 0
             END IF
         END IF
C
C
C             ...do cart -> spher transformation / cart normalization
C                (if b > 1):
C
C                        (ij,a,b) --> (ij,a,b')
C
C
         IF (SHELLB.GT.1) THEN
             IF (SPHERIC) THEN
                 CALL  OED__SPHERICAL_TRANSFORM
     +
     +                      ( NCTR*NXYZA,
     +                        NROWB,NXYZB,NRYB,
     +                        ICORE (ISNROWB),
     +                        ICORE (ISROWB),
     +                        ZCORE (ZSROTB),
     +                        ZCORE (IN),
     +
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished sph quart b '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             ELSE
                 CALL  OED__NORMALIZE_CARTESIAN
     +
     +                      ( NCTR*NXYZA,
     +                        NXYZB,
     +                        SHELLB,
     +                        ZCORE (ZCNORM),
     +
     +                                ZCORE (IN) )
     +
     +
C                 WRITE (*,*) ' Finished normalized cart b '
             END IF
         END IF
C
C
C             ...move transformed b shell (if size > 1):
C
C                        (ij,a,b') --> (ij[b'],a)
C
C
         IF (NRYB.GT.1) THEN
             NBATCH = NCTR * NXYZA * NRYB
             NOTMOVE = IXOFF (INDEXB)
             MOVE = NBATCH / (NOTMOVE * NRYB)
             IF (MOVE.GT.1) THEN

                 CALL  OED__MOVE_RY
     +
     +                      ( NBATCH,2,
     +                        NOTMOVE,MOVE,NRYB,
     +                        INDEXB,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry b '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF
C
C
C             ...do cart -> spher / cart normalization (if a > 1):
C
C                        (ij[b'],a) --> (ij[b'],a')
C
C
         IF (SHELLA.GT.1) THEN
             IF (SPHERIC) THEN
                 CALL  OED__SPHERICAL_TRANSFORM
     +
     +                      ( NCTR*NRYB,
     +                        NROWA,NXYZA,NRYA,
     +                        ICORE (ISNROWA),
     +                        ICORE (ISROWA),
     +                        ZCORE (ZSROTA),
     +                        ZCORE (IN),
     +
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished sph quart a '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             ELSE
                 CALL  OED__NORMALIZE_CARTESIAN
     +
     +                      ( NCTR*NRYB,
     +                        NXYZA,
     +                        SHELLA,
     +                        ZCORE (ZCNORM),
     +
     +                                ZCORE (IN) )
     +
     +
C                 WRITE (*,*) ' Finished normalized cart a '
             END IF
         END IF
C
C
C             ...move transformed a shell (if size > 1):
C
C                        (ij[b'],a') --> (ij[a'b'])
C
C
         NBATCH = NCTR * NRYB * NRYA

         IF (NRYA.GT.1) THEN
             NOTMOVE = IXOFF (INDEXA)
             MOVE = NBATCH / (NOTMOVE * NRYA)
             IF (MOVE.GT.1) THEN

                 CALL  OED__MOVE_RY
     +
     +                      ( NBATCH,2,
     +                        NOTMOVE,MOVE,NRYA,
     +                        INDEXA,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry a '

                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF
C
C
C             ...set final pointer to integrals in ZCORE array.
C
C
         NFIRST = IN
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE NORBMAKE(DENRELA,DENRELB,TEMPNOCOEFF,ANOCOEFF,
     $     BNOCOEFF,MOREORD,NBASP,XNOOCC,WORK)
C
c Diagonalize the alpha and beta correlated densities to obtain
C the NOs in the MO basis
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION DENRELA(NBASP*NBASP),DENRELB(NBASP*NBASP),
     $     TEMPNOCOEFF(NBASP*NBASP),ANOCOEFF(NBASP*NBASP),
     $     MOREORD(NBASP),XNOOCC(NBASP*NBASP),WORK(3*NBASP-1),
     $     BNOCOEFF(NBASP*NBASP)
C     
      WRITE(*,*) "DENRELA:"
      CALL PRINTMAT(DENRELA,NBASP,NBASP)
      WRITE(*,*) "DENRELB:"
      CALL PRINTMAT(DENRELB,NBASP,NBASP)
      WRITE(*,*)
C
C ALPHA PART
C
      DO 10 I=1,(NBASP*NBASP)
         XNOOCC(I)=DENRELA(I)
 10   CONTINUE
C
C Diagonalize the correlated density matrix
      CALL EIG(XNOOCC,TEMPNOCOEFF,WORK,(NBASP),2)
C     
      WRITE(*,*) "Eigenvalues of alpha density matrix:"
      SUM=0.0
      DO 100 I=1,NBASP
         SUM=SUM+XNOOCC((I-1)*NBASP+I)
         WRITE(*,*) XNOOCC((I-1)*NBASP+I)
 100  CONTINUE
      WRITE(*,*)
      WRITE(*,*) "SUM=",SUM
      WRITE(*,*)
      WRITE(*,*) "Alpha NOs in MO basis in correlated order"
      CALL PRINTMAT(TEMPNOCOEFF,NBASP,NBASP)
C     Reorder the MOs (rows) to get ANOCOEFF
C We are going from Correlated to SCF ordering.
      DO 11 I=1,NBASP
         DO 12 J=0,(NBASP-1)
            ANOCOEFF(MOREORD(I)+J*NBASP)=TEMPNOCOEFF(I+J*NBASP)
 12      CONTINUE
 11   CONTINUE
      WRITE(*,*)
      WRITE(*,*) "Alpha NOs ln MO basis in scf order"
      CALL PRINTMAT(ANOCOEFF,NBASP,NBASP)
C
C     BETA PART
C     
      DO 20 I=1,(NBASP*NBASP)
         XNOOCC(I)=DENRELB(I)
 20   END DO
C     
C     Diagonalize the correlated density matrix
      CALL EIG(XNOOCC,TEMPNOCOEFF,WORK,(NBASP),2)
C
      WRITE(*,*) "Eigenvalues of beta density matrix:"
      SUM=0.0
      DO 200 I=1,NBASP
         SUM=SUM+XNOOCC((I-1)*NBASP+I)
         WRITE(*,*) XNOOCC((I-1)*NBASP+I)
 200  CONTINUE
      WRITE(*,*)
      WRITE(*,*) "SUM=",SUM
      WRITE(*,*)
         WRITE(*,*) "Beta NOs in MO basis in correlated order"
         CALL PRINTMAT(TEMPNOCOEFF,NBASP,NBASP)
C     Reorder the MOs (rows) to get BNOCOEFF
         DO 21 I=1,NBASP
            DO 22 J=0,(NBASP-1)
               BNOCOEFF(MOREORD(I)+J*NBASP)=TEMPNOCOEFF(I+J*NBASP)
 22         CONTINUE
 21      CONTINUE
         WRITE(*,*)
         WRITE(*,*) "Beta NOs in MO basis in scf order"
         CALL PRINTMAT(BNOCOEFF,NBASP,NBASP)
C     
C
         RETURN
         END SUBROUTINE NORBMAKE
         

C THIS PROJECTS OUT LINEARLY DEPENDENT PARTS OF THE INTERNAL COORDINATES

c INPUT
c integer NATOM

c OUTPUT
c double SCR(*)
c double SYMQ(*)

c RECORDS
c get 'COMPNSYQ'
c get 'COMPSYMQ'
c put 'COMPSYMQ'

      SUBROUTINE SCHMIDT(NATOM,SCR,SYMQ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SCR(*),SYMQ(*)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA TOL /1.D-8/

      NSIZE=3*NATOM

      CALL GETREC(20,'JOBARC','COMPNSYQ',1,NSYMOLD)
      CALL GETREC(20,'JOBARC','COMPSYMQ',NSIZE*NSIZE*IINTFP,SCR)

c   o loop over vectors
      DO I=2,NSYMOLD
         IPOS=(I-1)*NSIZE+1
         CALL GSCHMIDT(SCR(IPOS),SCR,NSIZE,I-1,SYMQ,ZJUNK,1.D-8)
      END DO
      CALL DCOPY(NSIZE*NSIZE,SCR,1,SYMQ,1)

c   o renormalize
      IOFF=1
      DO I=1,NSYMOLD
         X=DNRM2(NSIZE,SYMQ(IOFF),1)
         IF (ABS(X).GT.TOL) THEN
            Z=1.d0/X
            CALL DSCAL(NSIZE,Z,SYMQ(IOFF),1)
         END IF
         IOFF=IOFF+NSIZE
      END DO

      CALL PUTREC(20,'JOBARC','COMPSYMQ',NSIZE*NSIZE*IINTFP,SYMQ)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE MORSEA(IATOM,JATOM,A)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(80,80)
      CALL ZERO(VEC,6400)
      VEC(1,1)=0.993509D0
      VEC(17,13)=0.702441D0
      VEC(13,9)=1.224876D0
      VEC(13,1)=0.685881D0
      VEC(13,8)=1.089910D0
      VEC(5,5)=0.927159D0
      VEC(17,5)=0.843132D0
      VEC(17,4)=0.779540D0
      VEC(9,4)=0.962386D0
      VEC(4,1)=0.731181D0
      VEC(8,4)=1.064388D0
      VEC(9,5)=1.143940D0
      VEC(5,1)=0.866977D0    
      VEC(7,5)=1.122298D0
      VEC(8,5)=1.129189D0
      VEC(6,6)=1.078581D0
      VEC(17,6)=0.385271D0
      VEC(6,1)=0.996595D0
      VEC(17,17)=1.077926D0
      VEC(17,9)=1.422952D0
      VEC(7,6)=1.187941D0
      VEC(8,6)=1.238251D0
      VEC(16,6)=0.970701D0
      VEC(17,1)=0.920386D0
      VEC(9,1)=1.196723D0
      VEC(3,3)=0.388674D0
      VEC(3,1)=0.582811D0
      VEC(7,7)=1.296765D0
      VEC(11,11)=0.372353D0
      VEC(11,1)=0.562428D0
      VEC(8,7)=1.316422D0
      VEC(8,8)=1.266555D0
      VEC(8,1)=1.142097D0
      VEC(16,16)=0.870337D0
      VEC(17,14)=0.753723D0
      VEC(14,9)=0.939980D0
      VEC(14,7)=1.008525D0
      VEC(14,8)=1.011156D0
      VEC(16,8)=1.040830D0
      I1=MAX(IATOM,JATOM)
      J1=MIN(IATOM,JATOM)
      A=VEC(I1,J1)
      RETURN
      END

      SUBROUTINE ONED2TWOD (PUTIN,OUTPUT,NUMROWS,NUMCOLS)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C Takes a 1D array into a 2D matrix.
C       1      2      3      4      5
C Ex: (1,1)->(2,1)->(3,1)->(1,2)->(2,2)->etc.
C
      DIMENSION OUTPUT(NUMROWS,NUMCOLS)
      DIMENSION PUTIN(NUMROWS*NUMCOLS)
C     
      DO 10 I=1,NUMCOLS
         DO 20 II=(NUMROWS-1),0,-1
            OUTPUT(NUMROWS-II,I)=PUTIN(I*NUMROWS-II)
C     WRITE(*,*) "OUTPUT(",(NUMROWS-II),",",I,")=PUTIN(",
C     & (I*NUMROWS-II),")=",PUTIN(I*NUMROWS-II)
 20      CONTINUE
 10   CONTINUE
C     
      RETURN
      END SUBROUTINE ONED2TWOD
      

      subroutine triangs(ain,aout,nsiz,idiag,half)
C
C This routine accepts an NSIZ by NSIZ symmetric or antisymmetric matrix AIN
C and returns its upper or lower triangle  in packed triangular form in AOUT.
C
C IDIAG   'Y'  diagonal is included.
C         'N'  diagonal is excluded.
C
C HALF    'U'  upper triangle is returned.
C         'L'  lower triangle is returned.
C
CEND
C RPM March 1994
C      implicit double precision (a-h,o-z)
      implicit none
      integer nsiz
      double precision ain(nsiz,nsiz),aout(1)
      character *1 idiag,half
      character *(*) rtn
      parameter ( rtn = '  @lwrtri')
C
      integer i, j, k
C
      integer ind, idum,jdum
      ind(idum,jdum)=(idum-k)*(idum-1)/2 + jdum
C
C      write (*,*) ' for i = 1, ', nsiz
      if ( half .eq. 'L'  .or.  half .eq. 'l' ) then
C         write (*,*) ' lower triangle'
         if (idiag .eq. 'N' .or. idiag .eq. 'n') then
C            write (*,*) ' No diagonals'
            k = 2
            do 20, i = 1, nsiz
               do 10, j = 1, i-1
C               write (*,*) i, j, ' | ', ind(i,j)
                  aout(ind(i,j))=ain(i,j)
 10            continue
 20         continue
         elseif (idiag .eq. 'Y' .or. idiag .eq. 'y') then
C         write (*,*)' Diagonals'
            k = 0
            do 40, i=1,nsiz
               do 30, j=1,i
C               write (*,*) i, j, ' | ', ind(i,j)
                  aout(ind(i,j))=ain(i,j)
 30            continue
 40         continue
         else
            write (*,*) rtn,'-I: idiag must be ''Y'' or ''N'''
            write (*,*) rtn,'-F: Don''t recognize idiag ''',idiag,''''
            call errex
         endif
      elseif ( half .eq. 'U' .or. half .eq. 'u' ) then
C         write(*,*) ' Upper triangle'
         if (idiag .eq. 'N' .or. idiag .eq. 'n') then
C         write (*,*) ' No diagonals'
            k = 2
            do 60, i = 1, nsiz
               do 50, j = 1, i-1
C               write (*,*) i, j, ' | ', ind(i,j)
                  aout(ind(i,j))=ain(j,i)
 50            continue
 60         continue
         elseif (idiag .eq. 'Y'  .or. idiag .eq. 'y') then
C         write (*,*)' Diagonals'
            k = 0
            do 80, i=1,nsiz
               do 70, j=1,i
C               write (*,*) i, j, ' | ', ind(i,j)
                  aout(ind(i,j))=ain(j,i)
 70            continue
 80         continue
         else
            write (*,*) rtn,'-I: IDIAG must be ''Y'' or ''N'''
            write (*,*) rtn,'-F: Don''t recognize IDIAG ''',idiag,''''
            call errex
         endif
      else
         write (*,*) rtn,'-I: HALF must be ''U'' or ''L'''
         write (*,*) rtn,'-F: Don''t recognize HALF ''',half,''''
         call errex
      endif
C
      return
      end

      SUBROUTINE FORCEOUT(V)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
#include "io_units.par"
 
      DIMENSION V(NXM6)
C   
      WRITE(LuOut,80)
 80   FORMAT(T3,' Internal coordinate forces and energy gradients ',
     &'(atomic units): '
     &,/,T12,'R',T20,'dV/dR',T38,'R',T46,'dV/dR',T64,'R',T72,'dV/dR')

      WRITE(LUOUT, *)
      WRITE(LUOUT,81)(VARNAM(ISQUASH(I)),R(I),V(I),I=1,NXM6)
cYAU 81   FORMAT(3(1X,:'[',A,']',1X,F8.5,1X,F10.7))
 81   FORMAT(3(1X,:'[',A,']',1X,F8.5,1X,F8.5))
      WRITE(LUOUT, *)

      RETURN
      END

      subroutine triang(ain,aout,nsiz,idiag)
C
C This routine accepts an NSIZ by NSIZ symmetric or antisymmetric matrix AIN
C and returns the its UPPER TRIANGLE in packed triangular form in AOUT.
C If IDIAG is set to 'Y', then the diagonal is included, if 'N' then 
C it is excluded. 
C
CEND
C      implicit double precision (a-h,o-z)
      implicit none
      integer nsiz
      double precision ain(nsiz,nsiz),aout(1)
      character *1 idiag
      character *(*) rtn
      parameter ( rtn = '  @uprtri')
C
      integer i, j, k
C
      integer ind, idum,jdum
      ind(idum,jdum)=(idum-k)*(idum-1)/2 + jdum
C
C      write (*,*) ' for i = 1, ', nsiz
      if (idiag .eq. 'N' .or. idiag .eq. 'n') then
C         write (*,*) ' No diagonals'
         k = 2
         do 40, i = 1, nsiz
            do 30, j = 1, i-1
C               write (*,*) i, j, ' | ', ind(i,j)
               aout(ind(i,j))=ain(j,i)
 30         continue
 40      continue
      elseif (idiag .eq. 'Y'  .or. idiag .eq. 'y') then
C         write (*,*)' Diagonals'
         k = 0
         do 20, i=1,nsiz
            do 10, j=1,i
C               write (*,*) i, j, ' | ', ind(i,j)
               aout(ind(i,j))=ain(j,i)
 10         continue
 20      continue
      else
         write (*,*) rtn,'-I: idiag must be ''Y'' or ''N'''
         write (*,*) rtn,'-F: Don''t recognize idiag ''',idiag,''''
         call errex
      endif
C
      return
      end

C GEOPT:  A Z-matrix input and geometry optimization module for
C         the ACES2 program system.
C
C By: J.F. Stanton, 7/88
C Modifications for portability by: D.E. Bernholdt 12/88
C Modifications for [name it] by: The ACES Development Team

#include "flags.h"

      PROGRAM GEOPT
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
#include "fnamelen.par"
      LOGICAL IGNORE,OPTRES,VIBRES,YESNO
      CHARACTER*(fnamelen) FNAME
C     Allocate more than enough core for the present needs
C     Estimated  by NX-6 => NX, and assume the worst!
      PARAMETER (MEMREQ = 14*9*MXATMS*MXATMS + 16*3*MXATMS +
     &           5*9*3*MXATMS + 2*3*MXATMS)
      DIMENSION Z(MEMREQ)
CJDW  Arrays for the POLYPRT routine.
CJDW  10/23/95. Should not now be needed as we are using POLYPRT0.
C      dimension xyzcor(3*mxatms),grad(3*mxatms),hess(9*mxatms*mxatms)
C      dimension iordco(  mxatms)
C
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
      CHARACTER*5 ZSYM, VARNAM, PARNAM

cYAU passed down to entry for mkvmol
#include "baslen.par"
      character*(baslen) BasNam
      INTEGER TOTREDNCO

      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(3*MXATMS),
     1     PARNAM(3*MXATMS)
      COMMON /COORD/ Q(3*MXATMS), R(3*MXATMS), NCON(3*MXATMS),
     1     NR(MXATMS),ISQUASH(3*MXATMS),IATNUM(MXATMS),ATMASS(MXATMS),
     2     IUNIQUE(3*MXATMS),NEQ(3*MXATMS),IEQUIV(3*MXATMS,3*MXATMS),
     3     NOPTI(3*MXATMS), NATOMS
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /TOLERS/ SYMTOL,DEGTOL
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $     ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $     XYZTol

C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      LOGICAL  XYZIN,NWFINDIF
      Common /SymInf/ FPGrp, BPGrp, PGrp
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON/RESTART/IGNORE
      COMMON/RESTART2/OPTRES
      COMMON/RESTART3/VIBRES
      Common /Orient/ Orient(3,3)
#include "io_units.par"
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
C     Use to fix orientation for C2v and D2h from one step to the next
      Integer At1, At2, XYOri
C
      integer genby(mxatms)

c ----------------------------------------------------------------------

#ifdef _TRAPFPE
c   o since JODA does not call crapsi, have it turn on FPEs
      call trapfpe
#endif /* _TRAPFPE */

      IJUNK=1
      XYZTol=1.0d-6
      SYMTOL=1.D-6
      DEGTOL=1.D-10
      ISTAT=0
      E=0.D0
      IPrnt = 0

c   o initialize the runtime environment
      call aces_init_rte

c   o evaluate and repair the health of the current file set
      call dfiles(ignore)

c   o initialize the job archive subsystem
      call aces_ja_init

c   o perform any first-run commands
      if (ignore) then
c      o JOBARC exists (somewhere)
         call putrec(1,'JOBARC','FIRSTRUN',1,0)
         call putrec(1,'JOBARC','DIRTYFLG',1,1)
      else
c      o this is the first time joda is being executed
         call putrec(1,'JOBARC','FIRSTRUN',1,1)
         call putrec(1,'JOBARC','DIRTYFLG',1,0)
         call firstrun
      end if

C IF .OPT FILE NOT THERE, READ Z-MATRIX AND GET THINGS SET UP
      CALL ENTRY(BasNam)

c      inquire(file='ALLDONE',exist=yesno)
c      if( (iflags2(138).eq.1) .and. .not. yesno)iarch=0
      call getrec(1,'JOBARC','FNDFDONE',1,iTmp)
      if ((iflags2(138).eq.1).and.(iTmp.eq.0)) iarch=0
C
C The logical argument to FETCHZ, controls whether it is the
C the very first call to the FETCHZ. In the case of user
C defined internal coordinates geometry optimizations, FETCHZ
C is called only once and this argument has no use, but in the
C case of redundent internal coordinate (RIC) optimizations, the FETCHZ
C is called repeatedly during a optimization with this argument
C set to .FALSE. During the first call it will generate RICs,
C B-matrix and A-matirx. During the next calls it will generate
C B-matrix and A-matrix that corresponds to new coordiantes using the
C RIC's generated in the first call. Ajith Perera, 08/2002
C
      IF ( iarch .NE.1) CALL FETCHZ(.TRUE., Z, MAXMEM)
C
c Marcel Nooijen 2001
c print warning if atoms are connected 3 to 1 and vibrations.
c Abort if resraman calculation
c
      if (iarch .ne. 1) then
c
         ione = 1
         ijunk = 0
         call getrec(-1, 'JOBARC', '12SWITCH', ione, ijunk)
         if (ijunk .eq. 1 .and. (iflags2(3) .eq. 1
     $        .or. ivib .ge. 1)) then
c
            write(6,*) ' *** Warning *** '
            write(6,*)
            WRITE(6,*)' Please reconstruct ZMAT file '
            WRITE(6,*)' Third atom should connect to second atom '
            WRITE(6,*)' Interchange atoms 1 and 2 in ZMAT '
            WRITE(6,*)' Replace all 1->2 and 2->1 '
            WRITE(6,*)' in third through last lines of ZMAT '
            WRITE(6,*)' Our apologies for the inconvenience'
            write(6,*)
            write(6,*)' Necessary for RESRAMAN calculations!!'
            write(6,*)' Erroneous representation of'
            write(6,*)' Normal Coordinates in internal representation'
            write(6,*)
            if (iflags2(3) .eq. 1) call errex
         endif
      endif
C
      IONE=1
      CALL GETREC(-1,'JOBARC','PASS1   ',IONE,IFNDIF)
      CALL GETREC( 0,'JOBARC','PASS1   ',IONE,IX)
      NWFINDIF=(IONE.GT.0)
      IF (NWFINDIF.AND.(.NOT.IGNORE)) THEN
        VIBRES=.true.
        IONE=1
        CALL PUTREC(20,'JOBARC','VIBRES  ',IONE,IONE)
      ELSE
        VIBRES=.false.
      ENDIF
      IONE=1
C
C Allocate memory, Note that in the case of Cartesian Optimizations
C the number of internal coordinates is not always correspond to
C NX-6, where NX=3*NATOMS. The fetchz.F dependency, gen_rednintrnls.F
C create the "REDNCORD" record. Ajith Perera, 09/2002.
C
      CALL GETREC(-1, 'JOBARC','REDNCORD', 1, TOTREDNCO)
      NXM6 = TOTREDNCO
      IF (iFlags(68).eq.0 .OR. NWFINDIF) NXM6 = MAX(NX-6, 1)
C
C FOR DUMMY B-MATRIX (AND CARTESIAN HESSIAN AFTER BUIL
    2 N1 = (NX * NX) + 1
C FOR B MATRIX (OCCUPIED BY A(TRSPSE) AFTER BUILDB.
      N2 = (NX * NX) + N1
C FOR G MATRIX (AND INTERNAL COORD HESSIAN AFT
      N3 = (NX * NX) + N2
C FOR A MATRIX
      N4 = (NX * NXM6) + N3
C FOR B TRANSPOSE
      N5 = (NX * NXM6) + N4
C FOR SCRATCH ARRAY IN BUILDB
      N6 = (NXM6 * 2) + N5
C CARTESIAN GRADIENT VECTOR
      N7 = NX + N6
C INTERNAL COORDINATE GRADIENT VECTOR
      N8 = NXM6 + N7
C INTERNAL COORDINATE HESSIAN FOR ARCHIVING
      N9 = (NXM6 * NXM6) + N8
C FOR STEP IN UPDATE
      N10 = NXM6 + N9
C FOR SCRATCH ARRAYS IN UPDATE
      N11 = ((NXM6 * NXM6) * 3) + N10
C FOR SCRATCH ARRAYS IN SYMMETRY
      N12 = (3 * NX) + N11
C    "    "       "     "    "
      N13 = NX + N12
C    "    "       "     "    "
      N14 = NX + N13
C FOR CONSTRAINED HESSIAN IN NEWRAP
      N15 = (NOPT * NOPT) + N14
C     FOR CONSTRAINED GRADIENT VECTOR IN NEWRAP
      N16 = NOPT + N15
C     CONSTRAINED ORTHOG. BASIS GRADIENT & HESSIAN IN EFOL
      N17 = NOPT + N16
      N18 = NOPT*NOPT + N17
C     Eigenvector followed on previous iter. (EFOL)
      N19 = NOPT + N18
C     Scratch matrices for EFOL - Used for augmented Hessian in RFA
C      and TS searches.  Dimension must be NOPT+1 for RFA.
      N20 = (NOPT+1)*(NOPT+1) + N19
      N21 = (NOPT+1)*(NOPT+1) + N20
      N22 = NX + N21
      N23 = NX + N22
      N24 = NX + N23
      N25 = NX*NX + N24
C
C A Bug fix (Only occured when extended to do Raman intensiies)
C Ajith 08/98, Note the generous allocation.
C
      N26 = NX*NX + N25
C
C Marcel Need a bigger scracth space.
cSSS N27 = NXM6*NXM6 + N26
C
      N27 = NX*NX + N26
C
C Allocate room for polarizabiliity derivatives Ajith & John, 08/98
C
      N28 = 9*NX + N27
      N29 = 9*NX + N28
      N30 =   NX + N29
      N31 =   NX + N30

      MEMTOP = N31
      IF(MEMTOP.GT.MEMREQ)THEN
        WRITE(LUOUT,5010)IINTFP*MEMTOP,IINTFP*MEMREQ
 5010   FORMAT(T3,'@GEOPT-F, Not enough core.',/,
     &       T3,'Words required:',I9,' Words available:',I9)
        CALL ERREX
      ENDIF

C     Dump memory information.
      IF (IPRNT .GE. 8) THEN
        WRITE (LUOUT, 9100)  MEMTOP,MEMREQ
 9100   FORMAT (T3,'@GEOPT-I, Words available: ',I9,
     &       ' Words Used ',I9,'.')
        IF(IPRNT.GT.900)THEN
          WRITE(LUOUT,9101)N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,
     &         N11,N12,N13,N14,N15,N16,N17,N18,N19,N20,N21,N22,
     &         N23,N24,N25,N26,N27,N28,N29,N30,N31
 9101     FORMAT(T3,'@GEOPT-I, Offsets into core vector: ',
     &         (/,9I6))
        ENDIF
      ENDIF
C
C Gets information from OPTARC file for subsequent steps (after
C the first call)
C
      IF ( iarch .EQ.1) THEN
        CALL RETRIEVE( E, Z(N4), Z(N8), Z(1), Z(N18))
        CALL ZERO(Z, N11)
      ELSE
C
C CALL SYMMETRY PACKAGE AND NEW FINDIF SYMMETRY ROUTINES.
C
        IF (.NOT. XYZIN) CALL GMETRY
        IF (.NOT. XYZIN .OR. NWFINDIF)  CALL SYMMETRY(Z(N11), Z(N12),
     &       Z(N13))


CJDW 4/1/97. Write COMPSYOP with maximum possible length at beginning
C            of finite difference calculation.
C            Also COMPPERM, COMPCLSS.
        IF(.NOT.NWFINDIF)THEN
         CALL ZERO(Z,8*9)
         CALL PUTREC(20,'JOBARC','COMPSYOP',8*9*IINTFP,Z)
         CALL ZERO(Z,8*NATOMS)
         CALL PUTREC(20,'JOBARC','COMPPERM',8*NATOMS,Z)
         CALL ZERO(Z,8)
         CALL PUTREC(20,'JOBARC','COMPCLSS',8,Z)
        ENDIF
C
        IOFF=1+120*9+NATOMS*9
        MLTINT=IINTFP*(MEMREQ-120)
        CALL SYMDRV(Z(IOFF),Z,MLTINT,IOFF,FPGRP,'FULL')
        ITMP=IPRNT
        IF(PGRP.EQ.FPGRP)IPRNT=0
        CALL SYMDRV(Z(IOFF),Z,MLTINT,IOFF,PGRP,'COMP')
        IPRNT=ITMP
        CALL ZERO(Z,MEMREQ)
C
c SB : The if(.not.nwfindif) block used to be inside the if(natoms.gt.1)
c block.  I moved it outside so that the call to geomout is made
c even in the case of an atom.
C
        If (NAtoms .gt. 1) THEN
C
C        Call the Z-matrix analyzer - requires A matrix from BUILDB.
C
          IF (.NOT. XYZIN .OR. NWFINDIF) THEN
             CALL BUILDB(Z(1),Z(N1),Z(N2),Z(N3),Z(N4),Z(N5),Z(N10))
             IF(.NOT.NWFINDIF)Call Analyze (Z(N10), Z(N3))
          ELSE
C
C Note, this is part is executed only in the first call to joda, and
C no need to re-run since it had alredy been run with the argument set
C to .TRUE, and the following records for the starting  geometry is in
C the JOBARC. Ajith Perera 08/2002.
C
             CALL GETREC(20, 'JOBARC','REDNCORD', 1, TOTREDNCO)
             LENGTH_GMAT=3*NATOMS*TOTREDNCO
             CALL GETREC(20, 'JOBARC', 'GMATRIX ',LENGTH_GMAT*IINTFP,
     &                   Z(N3))
CSSS             WRITE(6,*) IFLAGS2(
CSSS     &           h_IFLAGS2_geom_opt), NWFINDIF
             IF (.NOT. NWFINDIF .AND. .NOT. IFLAGS2(
     &           h_IFLAGS2_geom_opt).EQ.0) CALL ANALYZE(Z(N10), Z(N3))
          ENDIF
        endif
C
C Print out the coordinates and distance matrix
C
        IF(.NOT.NWFINDIF)THEN
          Call GeomOut
          if (natoms.gt.1) Call ADM
        EndIf
C
C IF THIS IS A FINITE DIFFERENCE CALCULATION AND ALL POINTS HAVE
C BEEN RUN, THEN CALL VIBRATIONAL ANALYSIS CODE
C
C Make the appropriate input deck
C
        IF (INTTYP .EQ. 0) THEN
cYAU          Call MkAbIn (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
cYAU     &         GenBy, Z(N11), IStat)
           write(*,*) '@GEOPT: MkAbin was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
CJDW 9/20/96. Allow for Seward (currently must make MOL file).
        ElseIf (IntTyp .eq. 1 .or. IntTyp .eq. 2
     &                        .or. IntTyp .eq. 4) then
          Call MkVMOL (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &         GenBy, Z(N11), IStat, BasNam)
        ElseIf (IntTyp .eq. 3) then
cYAU          Call MkCadp (PGrp, NAtoms, NUnique, ZSym, IAtNum, Q,
cYAU     &         GenBy, IStat)
           write(*,*) '@GEOPT: MkCadp was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
        ENDIF
        If (Mod(IStat,2) .eq. 1) then
           Call ErrEx
        ElseIf (IStat .eq. 8 .OR. IStat .eq. 10) then
          IStat = 0
c            Write (LuErr, 9810)
C           Eventually we will want to do more things here...
C           Probably want to change to program to chain to
C           Probably want to write out a CON file or similar
        EndIF
C
C NOW WRITE COORDINATE INFORMATION TO INPUT FOR INTS.  THIS IS CRUDE,
C BUT THINGS HAVE TO BE DONE THIS WAY FOR NOW. (OBSOLETE LONG AGO).
C
        CALL ZERO(Z, N13)
C        CALL PUTGEOM(3)
        itmp=iflags(18)
        iflags(18)=mod(itmp,100)
        IF (NOpt .ne. 0 .AND. NAtoms .gt. 1 .or. IVib .eq. 1 .or.
     &       IVIB.EQ.2
     &       .OR. IFLAGS(18).EQ.3
     &       .OR. IFLAGS(18).EQ.4
     &       .OR. IFLAGS(18).EQ.5
     &       .OR. IFLAGS(18).EQ.8
     &       .OR. IFLAGS(18).EQ.9
     &       .OR. IFLAGS(18).EQ.10
     &       .OR. IFLAGS2(3).NE.0
     &       ) then
          CALL ARCHIVE(E, Z(N7), Z(N8), Z(NXM6 + 1), 1,
     &                 Z(N18))
        ElseIf (NOpt .eq. 0) then
          Write (LuOut, 9820) 'single-point'
        ElseIf (NAtoms .eq. 1) then
          Write (LuOut, 9820) 'atomic'
        Endif
        iflags(18)=itmp
c
c         inquire(file='ALLDONE',exist=yesno)
c         if(.not.yesno)then
        if(.not. nwfindif .or. nwfindif .and. ifndif .eq. 1)then
          IF(IPRNT.EQ.999)WRITE(LUOUT,8888)(I,Z(I),I=1,N27)
          CALL PUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
          CALL ACES_JA_FIN
          Stop
        endif
      END IF
 9820 Format (' @GEOPT-W, Archive file not created for ',A,
     $     ' calculation.')
C
C CALL ROUTINE TO BUILD B MATRIX.
C
      IF(.NOT.XYZIN.AND.IFLAGS(68).NE.1)THEN
        CALL BUILDB(Z(1), Z(N1), Z(N2), Z(N3), Z(N4), Z(N5), Z(N10))
      ELSE
C
C This block is executed for each iteration during a optimiation and
C requires a call to FETCHZ with argument set to .FALSE. to create
C B and A matrices for the new coordinates using the IRC's genereated
C in the first call to FETCHZ. Ajith Perera 08/2002
C
        CALL FETCHZ(.FALSE., Z, MAXMEM)
        CALL GETREC(20, 'JOBARC','REDNCORD', 1, TOTREDNCO)
        LENGTH_GMAT = 3*NATOMS*TOTREDNCO
        CALL GETREC(20, 'JOBARC', 'GMATRIX ',LENGTH_GMAT*IINTFP,
     &              Z(N3))
        CALL GETREC(20, 'JOBARC', 'BMATRIXT', LENGTH_GMAT*IINTFP,
     &              Z(N4))
      ENDIF
C
C IF THIS IS A VIBRATIONAL CALCULATION - DO ALL THE STUFF HERE AND
C THEN STOP.
C
      itmp=iflags(18)
      iflags(18)=mod(itmp,100)
      IF(IVIB.GE.1.OR.IFLAGS2(3).NE.0)THEN
C
CJDW  1/ 5/95 Write polyrate data for Rozeanne Steckler. This almost
C             certainly will not work if there are dummy atoms present.
C             In addition, it should only be called when we do analytical
C             hessians, as in the finite difference case it will not get
C             the coordinates, energy, and gradient for the reference
C             geometry. Also, POLYRATE must be ON.
CJDW 10/23/95 Change from POLYPRT to POLYPRT0 in standard code.
C
        IF(IFLAGS(54).EQ.1.AND.IFLAGS2(113).EQ.1)THEN
          CALL POLYPRT0(NATOMS,IINTFP,IFLAGS(1),
     &                  .TRUE.,.TRUE.,.TRUE.,.TRUE.)
        ENDIF
C
        IHES=0
        IF(IVIB.EQ.3.OR.IFLAGS2(3).NE.0)IHES=1
        Call READGH (0,IHES,NATOMS,Z(N6),Z(1),Z(N1),Z(N2),IAVGRD,
     &       IAVHES)
        IF(ISTAT.NE.0)THEN
          WRITE(LUOUT,3432)
 3432     FORMAT(T3,'@GEOPT-F, Problem with FCM or GRD file.')
          CALL ERREX
        ENDIF
C
C PROJECT FORCE CONSTANT MATRIX AND DIPOLE DERIVATIVE MATRIX ONTO
C TOTALLY SYMMETRIC SUBSPACE FOR VIB=FINDIF CALCULATIONS
C
        IF(IVIB.EQ.3)THEN
          CALL GETREC(20,'JOBARC','FULLORDR',IONE,IORDER)
          CALL GETREC(20,'JOBARC','FULLNIRR',IONE,NIRREP)
          I000=N4
          I00A=I000+9*NATOMS*NATOMS
          I010=I00A+9*NATOMS*NATOMS
          I020=I010+9*NATOMS*NATOMS
          I030=I020+IORDER*9
          I040=I030+NATOMS*IORDER
          I050=I040+NATOMS
          I060=I050+NATOMS
          CALL SCOPY(9*NATOMS*NATOMS,Z(1),1,Z(I00A),1)
          CALL PROJFCM(NATOMS,NIRREP,IORDER,Z(I00A),
     &         Z(I010),Z(I020),Z(I030),Z(I040),Z(I050),
     &         Z(I060))
          CALL SCOPY(9*NATOMS*NATOMS,Z(I00A),1,Z(1),1)
          CALL PROJDPD(NATOMS,NIRREP,IORDER,ATMASS,Z(I00A),
     &         Z(I010),Z(I020),Z(I030),Z(I040),Z(I050),
     &         Z(I060))
          I000=N4
          I010=I000+27*NATOMS
          I020=I010+27*NATOMS
          I030=I020+IORDER*9
          I040=I030+NATOMS*IORDER
          I050=I040+NATOMS
          I060=I050+NATOMS
          I070=I060+84*NATOMS
          IF(I070.GT.MEMREQ)THEN
             WRITE(LUOUT,5020)IINTFP*I090,IINTFP*MEMREQ
 5020        FORMAT(T3,'@GEOPT-F, Not enough core.',/,
     &            T3,'Words required:',I9,' Words available:',I9)
             CALL ERREX
          ENDIF
          CALL PROJPLD(NATOMS,NIRREP,IORDER,ATMASS,Z(I000),
     &                 Z(I010),Z(I020),Z(I030),Z(I040),Z(I050),
     &                 Z(I060))
        ENDIF
C
C CONVERT TO IC AND DUMP TO DISK NOW.
C
        CALL CONVHESS(Z(N3),Z(N4),Z(1),Z(N2),Z(N1),-1)
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N6))
        CALL VIB1(Z(1),Z(N24),Z(N21),Z(N25),Z(N12),Z(N25),Z(N1),Z(N6),
     &            Z(N27), Z(N28), Z(N29), Z(N30),NRX,IStat,Z(N26))
        CALL PUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
        CALL ACES_JA_FIN
        STOP
      ELSEIF(IFLAGS(18).EQ.3
     &       .OR.IFLAGS(18).EQ.4
     &       .OR.IFLAGS(18).EQ.5)THEN
C
C NMR CALCULATION, Note that the last argument is just a
C dummy argument. This is to aviod having two subroutines that
C basically do same things except for one thing. Note the
C above call to PREVIB this arguement has the gradient
C vector. In the following calls Z(N26) does not contain
C any useful info. Ajith Perera 12/2001.
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL NMR1(Z(1),Z(9*NRX+1),Z(10*NRX+1),Z(11*NRX+1),NRX)
        CALL GFNAME('JSO     ',FNAME,ILENGTH)
        INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO)
        IF(YESNO) CALL JSO1(Z(1),Z(NRX*9+1),NRX)
        CALL PUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
        CALL ACES_JA_FIN
        STOP
      ELSEIF(IFLAGS(18).EQ.8) THEN
C
C NMR COUPLING CONSTANT (SO CONTRIBUTION) CALCULATION
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL JSO1(Z(1),Z(NRX*9+1),NRX)
        CALL PUTREC(20,'JOBARC','JODAOUT',IONE,IJUNK)
        CALL ACES_JA_FIN
        STOP

      ELSEIF(IFLAGS(18).EQ.9) THEN
C
C NMR COUPLING CONSTANT (FC CONTRIBUTION) CALCULATION
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL JFC1(Z(1),Z(NRX*9+1),NRX)
        CALL PUTREC(20,'JOBARC','JODAOUT',IONE,IJUNK)
        CALL ACES_JA_FIN
        STOP
      ELSEIF(IFLAGS(18).EQ.10) THEN
C
C NMR COUPLING CONSTANT (SD CONTRIBUTION) CALCULATION
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL JSD1(Z(1),Z(NRX*9+1),NRX)
        CALL PUTREC(20,'JOBARC','JODAOUT',IONE,IJUNK)
        CALL ACES_JA_FIN
        STOP
      ENDIF
      iflags(18)=itmp
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Non-vibrational calculations really begin here
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Save some information about the xy orientation of the molecule
C     before taking the step.  Used later to give new geometry same
C     orientation.
C
      Err = 0
      IF(OPTRES) CALL GETREC(20,'JOBARC','COORD   ',IINTFP*NX,Q)
      Call SavOri (FPGrp, NAtoms, Q, IAtNum, At1, At2, XYOri, Err)
      IF(OPTRES) GO TO 9876
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Get gradient and Hessian from disk
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     IRecal controls how often we should look for an analytic
C     Hessian.  For a "full-x" optimization, IRecal should be 1.
C
C     NOTE: IRecal is not used elsewhere.  Eventually it should be
C     used to generate input decks that insure the Hessian will be
C     recalculated every IRecal steps.
C
      IHes = -1
      If (IRecal .ne. 0) then
        If (Mod(ncycle, IRecal) .eq. 0 ) IHes = 0
      Else
        If ( ncycle .eq. 0) IHes = 0
      EndIf
C
C If this is the first cycle, and an internal coordinate Hessian
C  is available, then snatch it.
C
      IGRD=0
      IF(IFLAGS2(h_IFLAGS2_geom_opt).EQ.0 .OR. IFLAGS2(138).EQ.1)IGRD=1
      Call READGH (IGRD,IHES,NATOMS,Z(N6),Z(1),Z(N1),Z(N2),IAVGRD,
     &     IAVHES)
      If ( ncycle .eq.0 .and. ihes .eq. 0)THEN
        CALL GETICFCM(Z(N2),NXM6,IICFCM)
        IF(IICFCM.EQ.1)IHES=-1
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Convert gradient to internal coordinates & print it out
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      CALL CONVQ(Z(N3), Z(N6), Z(N7), 0, 1)
      CALL FORCEOUT(Z(N7))
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     If we have an analytic Hessian, convert it also...
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      If ( ncycle .eq. 0 .OR. IHES.EQ.0) THEN
        IF(IICFCM.EQ.0)THEN
          CALL CONVHESS(Z(N3),Z(N4),Z(1),Z(N2),Z(N1),1-IAVHES)
        ENDIF
C
C FORCE CURVILINEAR <-- RECTILINEAR TRANSFORMATION IF TS SEARCH
C    AND TRANSFORMATION HAS NOT BEEN TURNED OFF BY EXTERNAL
C    REQUEST (ICURVY>1).
C
        IF((INR.EQ.4.OR.INR.EQ.5).AND.ICURVY.EQ.0)ICURVY=1
        IF(ICURVY.GT.1.AND.INR.EQ.4)WRITE(6,9920)
 9920   FORMAT(T3,' Transformation to curvilinear coordinates has ',
     &       'been turned off.')
        WRITE(6,*) "IAM HERE"
        IF (ICURVY .EQ. 1 .AND. IICFCM .EQ. 0)
     &       CALL TWIDLE(Z(N3),Z(N2),Z(N7),Z(N25),Z(N21),Z(N22),
     &       Z(N23),Z(N24),Z(N26))
        WRITE(6,*) "IAM HERE"
C
C DO NOT WRITE OUT WHOLE HESSIAN UNLESS IT HAS BEEN SPECIFICALLY
C   REQUESTED.  THIS CAN EVENTUALLY BE MADE INTO AN ADJUSTABLE
C   PARAMETER, BUT WILL BE IN CODE FOR NOW.
C
        IF(IPRNT.GE.10) THEN
cSSS             WRITE(6,*) (NOPTI(III), III =1, NXM6)
cSSS             CALL HESSOUT(Z(N2), NXM6, NXM6, 0)
        ENDIF
      ELSE
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     ...otherwise update the Hessian
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     IUPD=2 GIVES BFGS; IUPD=1 GIVES POWELL.
C
        IUPD = 2
        IF (INR .EQ. 4.OR.INR.EQ.5) IUPD = 1
        CALL HUPDATE(Z(N7), Z(N2), Z(1), Z(N9), Z(N10), IUPD)
      END IF
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Compute the step (in internal coordinates
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     SAVE HESSIAN FOR ARCHIVING BEFORE IT IS DESTROYED IN STEP TAKING
C     EMPTY Z(N11) FIRST
C
      CALL ZERO(Z(N10), NXM6 * NXM6)
      CALL ZERO(Z(N1), NXM6)
      CALL VADD(Z(N8), Z(N2), Z(N10), NXM6 * NXM6, 1.D0)
C
C SET FLAG WHICH DETERMINES DIMENSION OF AUGMENTED HESSIAN, WHICH IS
C  USED IN RFA AND TS SEARCHES.  NEED TO BE CAREFUL ABOUT NR AND MANR
C  OPTIONS, HOWEVER, SINCE THESE MAY BE SWITCHED TO RFA IF HESSIAN HAS
C  NEGATIVE EIGENVALUES.  FORCE DIMENSION TO BE (NOPT+1) FOR EVERYTHING
C  BUT TS, WHERE IS MUST BE NOPT.
C
      IAUGHS = 1
      IF(INR .EQ. 4 .OR. INR .EQ. 5) IAUGHS=0
C
      CALL TKSTEP(Z(N7), Z(N2), Z(1), Z(N14), Z(N15), Z(N1), Z(N16),
     &            Z(N17), Z(N18), Z(N19), Z(N20), IAUGHS)
C
      IF ( ncycle .GE. iflags(92)) then
        Write (LuErr,*) '*Maximum number of optimization steps ',
     $       'exceeded.'
        Call ErrEx
      EndIf
 9876 CONTINUE
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Generate new cartesian coordiantes from internals and determine
C the point group.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IF (XYZIN) THEN
         CALL PROCESTEP_XYZ(Z(1), Z(N3), Z(N4), NATOMS, TOTREDNCO)
C
C Here I force, NX=3*NATOMS so that symmetry.F would no complain
C when it try to retrive the Cartesiian coordiantes (the record
C length is 3*NATOMS regardles of the number of internal coordinates.
C Note that NX is set back again to MAX (TOREDUNCO, 3*NATOMS) just
C before archiving. Ajith Perera, 10/2002
C
         NX = 3*NATOMS
      ELSE
         CALL GMETRY
      ENDIF
      CALL SYMMETRY(Z(N11), Z(N12), Z(N13))
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Do some fudging with the orientations
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Eventually, symmetry will always leave the molecule in Cotton's
C     orientation and orientation "fudging" to accomodate specific
C     integral packages will be done here.
C
C     It is possible (in a few points groups like C2v & maybe D2h)
C     for the relative orders of the moments of inertia to switch
C     from one step to the next.  This effectively interchanges
C     the x and y axes, and thus some of the irreps -- wreaking havoc
C     on occupations specified by symmetry irrep.  The solution is
C     to base everything on the orientation of the zeroeth step.
C
c      IF(INR.NE.6)Call FixOri (NAtoms, Q, At1, At2, XYOri)
      Call FixOri (NAtoms, Q, At1, At2, XYOri)
      ITMP=IPRNT
      IF(PGRP.EQ.FPGRP)IPRNT=0
      IOFF=N19+1+120*9+NATOMS*9
      MLTINT=IINTFP*(MEMREQ-N19)
      CALL SYMDRV(Z(IOFF),Z(N19),MLTINT,IOFF,PGRP,'COMP')
      CALL SYMDRV(Z(IOFF),Z(N19),MLTINT,IOFF,FPGRP,'FULL')
      IPRNT=ITMP

C   o print out coordintes and distance matrix
C     Note that all orientation fudging has already been done. These
C     coordinates should match the integral program's except for
C     permutations of equivalent atoms.
      Call GeomOut
      Call ADM

C   o make input decks for the integral program using new coordinates
      If (IntTyp.Eq.0) Then
cYAU         Call MkAbIn (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
cYAU     &                GenBy, Z(N11), IStat)
           write(*,*) '@GEOPT: MkAbin was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
CJDW 9/20/96. Allow for Seward (currently must make MOL file).
      Else If (IntTyp .eq. 1 .or.
     &         IntTyp .eq. 2 .or.
     &         IntTyp .eq. 4) Then
         Call MkVMol (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &                GenBy, Z(N11), IStat, BasNam)
      Else If (IntTyp .eq. 3) Then
cYAU         Call MkCadp (PGrp, NAtoms, NUnique, ZSym, IAtNum, Q,
cYAU     &                GenBy, IStat)
           write(*,*) '@GEOPT: MkCadp was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
      End If
      If (Mod(IStat,2) .eq. 1) then
         Call ErrEx
      Else If (IStat .eq. 8 .OR. IStat .eq. 10) then
         IStat = 0
         Write (LuErr, 9810)
C        Eventually we will want to do more things here...
C        Probably want to change to program to chain to
C        Probably want to write out a CON file or similar
      End IF

c o save the information about this step to disk
c   THE GRADIENT IS IN Z(N7)
c   THE HESSIAN  IS IN Z(N8)
C
      NX = MAX(TOTREDNCO, 3*NATOMS)
      IF (.NOT.OPTRES) CALL ARCHIVE(E,Z(N7),Z(N8),Z(N1),1,Z(N18))
      IF (IPRNT.EQ.999) WRITE(LUOUT,8888) (I,Z(I),I=1,N27)
      CALL PUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
      CALL ACES_JA_FIN

      IF (NCYCLE.GE.IFLAGS(92)) THEN
         WRITE(LUOUT,*)
     &      '@GEOPT: Maximum number of optimization cycles exceeded.'
         WRITE(LUOUT,*)
     &      '        Geometry optimization failed.'
         CALL ERREX
      END IF

c     FORMAT STATEMENTS USED MORE THAN ONCE
 8888 FORMAT(T3,'@GEOPT: Dump of core vector:',/,
     &       T5,'Element',T40,'Value',/,(T5,I6,T36,E15.10))
 9810 FORMAT(T3,'@GEOPT: Standard ACES2 routing impossible. ',/,
     &       T3,'        User must supply gradient and Hessian.')

cYAU - cleans up output
c      STOP
      END

C
      SUBROUTINE PRINT_COORD(COORD, LABEL, B2ANG, NATOMS)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      CHARACTER*5 LABEL(NATOMS)
      DIMENSION COORD(NATOMS*3)
C
      Write(6,*)
      WRITE(6, 5000) 
      WRITE(6, *)
      WRITE(6, 5005)
      WRITE(6, 5010)
      WRITE(6, 5015)
      WRITE(6, 5005)
C
      Ioff =1 
      Convr2A = 1.0D0/B2Ang
C
      DO 3 I = 1, NATOMS
         WRITE(6, 5020) LABEL(I), (Convr2A*COORD(Ioff-1+K), K = 1, 3)
         Ioff = Ioff + 3
 3    CONTINUE
C
      WRITE(6, 5005)
            
 5000 FORMAT (T5, 'The normal modes corresponds to the following',
     &      /, T5,'         orientation and atomic ordering.')

 5005 FORMAT (T4, 56('-'))      
 5010 FORMAT (T20, 'Cartesian coordinates (Angs)')
 5015 FORMAT (T5, '       ', T22, 'X', T34, 'Y', T46, 'Z')
 5020 FORMAT (T5, A, T17, F10.7, T29, F10.7, T41, F10.7)
C
      RETURN
      END

      SUBROUTINE QSTLST_OR_EVEC(QSTLST_TANGENT, GRDMOD, HESMOD, DIAGHES,
     &                          HES, SCRATCH, IMODE, QSTLST_CLIMB)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      LOGICAL QSTLST_CLIMB
      PARAMETER (THRESHOLD = 5.0D-2, WGHT= 1.0D-3)

#include "mxatms.par"
#include "coord.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DATA HALF, ONE /0.50D0, 1.0D0 /

      DIMENSION HESMOD(NOPT, NOPT), GRDMOD(NOPT), QSTLST_TANGENT(NOPT),
     &          SCRATCH(NX*NX), DIAGHES(NOPT, NOPT),
     &          HES(NOPT, NOPT)

      CALL ZERO(SCRATCH, NOPT)

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,"(a)") "The QST/LST tangent in QSTLST_OR_EVEC"
      Write(6,"(3(1x,F12.6))") (QSTLST_TANGENT(I), I= 1, NOPT)
#endif
      CALL XGEMM('N','N', NOPT, 1, NOPT, 1.0D0, HES, NOPT,
     &            QSTLST_TANGENT, NOPT, 0.0D0, SCRATCH, NOPT)

      EIGVALUE = XDDOT(NOPT, QSTLST_TANGENT, 1, SCRATCH, 1)
      GRDVALUE = XDDOT(NOPT, QSTLST_TANGENT, 1, GRDMOD,  1)

      EST_STEP = (EIGVALUE + DSQRT(EIGVALUE**2 + 4.0D0*(GRDVALUE)
     &            **2))*HALF
      EST_STEP =  -GRDVALUE/(EST_STEP - EIGVALUE)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)")"Relevent parameter that is used to decide a climb"
      Write(6,"(a,2(1x,F12.6))") "The EIGVALUE,GRDVALUE : ", EIGVALUE, 
     &                            GRDVALUE
      Write(6,"(a,F12.6)") "The estimated step size     :",EST_STEP
      Write(6,*)
      Write(6,"(a)") "The HT vector"
      Write(6,"(3(1x,F12.6))") (Scratch(i), i=1, NOPT)
#endif 
C
C Let's check that the estimated step size is greater than 0.05 au.
C If so, then follow the QST or LST tangent (I am interpreting Schlegel's
C "estimated displacement along the tangent vector is greater than the 0.05".
C At this point I am not sure whether he meant the largest absolute
C displacement. Also cap the QST/LST to first four cycle (also rec. by Schlegel)
C
      QSTLST_CLIMB = ((DABS(EST_STEP).GE.THRESHOLD.AND.NCYCLE.LE.4).OR.
     &                NCYCLE.LE.2)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,l)") "The climbing Phase if true", QSTLST_CLIMB
#endif
C
C Compute the gradient along the tangent vector, copy the tangent
C vector to the eigenvector matrix (to the first eigenvector) and the
C eigenvalue (EIGVALUE) to the first eigenvalue and set the IMODE
C to 1.
C
      IF (QSTLST_CLIMB) THEN
         WEIGHT = ONE - WGHT
         CALL MODFY_HESSIAN(DIAGHES, HESMOD, HES, QSTLST_TANGENT,
     &                      SCRATCH, EIGVALUE, WEIGHT, NOPT)
      END IF
C
C This is just to be safe in subsequent steps.
C
      CALL ZERO(SCRATCH,NOPT*NOPT)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sip_barrier(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer status(MPI_STATUS_SIZE)
      integer request
      integer msg(5)
      integer i
      integer ierr
      integer company_comm, pst_get_company_comm
      integer company_rank, pst_get_company_rank
      integer nmessages, nmessages_global
      integer query_message_counter
      integer bmaster
      integer get_barrier_master
    
      if (dbg) then
         print *, 'Task ',me,
     *   ' is waiting at SIP barrier:  line number ',
     *   current_line
         call c_flush_stdout()
      endif

      if (my_company_size .eq. 1) return
      company_comm = pst_get_company_comm(me)
      company_rank = pst_get_company_rank(me)

      bmaster = get_barrier_master(company_rank)
      if (company_rank .ne. bmaster) then

c---------------------------------------------------------------------------
c   Send a barrier message to the master.
c---------------------------------------------------------------------------

         do i = 1, 5
             msg(i) = 0
         enddo
         msg(1) = -7   ! barrier signal is -7, send with tag 3456.
         call mpi_isend(msg, 5, MPI_INTEGER, bmaster,
     *                  3456, company_comm, request, ierr)
      endif

c---------------------------------------------------------------------------
c   Subroutine exec_server_threads blocks until there is no thread on this
c   processor that is actively engaged in communication.
c---------------------------------------------------------------------------

      call exec_thread_server(1)
      if (dbg) print *,'Task ',me,' After exec_thread_server line ',
     *              current_line

c---------------------------------------------------------------------------
c   Wait for the request to be satisfied (should be done at this point).
c---------------------------------------------------------------------------

      if (company_rank .ne. bmaster) then
         call mpi_wait(request, status, ierr)
         if (dbg) print *,'Task ',me,
     *                    ' SIP_BARRIER: After mpi_wait, line ',
     *                     current_line
      endif

  100 continue
 
c---------------------------------------------------------------------------
c   Get the collective number of sent messages (i. e. GETs/PUTs) and the
c   number of received messages.
c---------------------------------------------------------------------------

      nmessages =  query_message_counter()   ! number on this processor
      call mpi_reduce(nmessages, nmessages_global, 1, MPI_INTEGER, 
     *                MPI_SUM, 0, company_comm, ierr)
      call mpi_bcast(nmessages_global, 1, MPI_INTEGER, 0,
     *               company_comm, ierr)
      if (dbg) print *,'Task ',me,' After exec_thread_server line ',
     *              current_line ,' nmessages, nmessages_global ',
     *              nmessages, nmessages_global
      if (nmessages_global .ne. 0) then
         call exec_thread_server(2)   ! checks for more messages
         go to 100
      endif

c---------------------------------------------------------------------------
c   Reset all persistent blocks  of all arrays which have had a "PUT' since
c   the last barrier.
c   This is done to insure data integrity.
c---------------------------------------------------------------------------

      do i = 1, narray_table
         if (array_table(c_put_flag,i) .ne. 0)  then
            call free_persistent_blocks(i, array_table, narray_table,
     *               index_table, nindex_table, block_map_table)
            array_table(c_put_flag,i) = 0
         endif
      enddo
     
      if (dbg) then
         print *,'Task ',me,' After free loop at line ',
     *      current_line
         call c_flush_stdout()
      endif 
      
c---------------------------------------------------------------------------
c   Reset the message counter in the thread server code.
c---------------------------------------------------------------------------

      call clear_message_counter()

c---------------------------------------------------------------------------
c   The final barrier guarantees that all processors have achieved a
c   quiet state with their threads.
c---------------------------------------------------------------------------

       call mpi_barrier(company_comm, ierr)
       if (dbg) then
          print *,'Task ',me,' Passed sip_barrier'
          call c_flush_stdout()
       endif

c--------------------------------------------------------------------------
c   Dont proceed unless there are enough free blocks.  
c               EXPERIMENTAL 
c--------------------------------------------------------------------------

c     call check_stack_pop(array_table, narray_table, index_table,
c    *                           nindex_table, block_map_table)

      return
      end

c This routine converts a date and time (in integers) to seconds since Jan. 1
c of THAT year, not the Epoch.

c INPUT
c int yr, mo, dy
c     hh, mm, ss : the year, month, day, hour, minute, and second

c OUTPUT
c int secs : the total seconds since 1/1

c#define _DEBUG_DT2IS

      subroutine dt2is(yr,mo,dy,hh,mm,ss,secs)
      implicit none

c ARGUMENTS
      integer yr, mo, dy, hh, mm, ss, secs

c INTERNAL VARIABLES
      integer day
      integer days(12)
      data days /0,31,59,90,120,151,181,212,243,273,304,334/

c ----------------------------------------------------------------------

#ifdef _ASSERT
c   o assert date and time are all positive
      if ((yr.lt.1).or.
     &    (mo.lt.1).or.
     &    (dy.lt.1).or.
     &    (hh.lt.0).or.
     &    (mm.lt.0).or.
     &    (ss.lt.0)    ) then
         print *, '@DT2IS: Assertion failed.'
         print *, '   yr/mo/dy = ',yr,mo,dy
         print *, '   hh:mm:ss = ',hh,mm,ss
         call c_exit(1)
      end if
#endif /* _ASSERT */

c ----------------------------------------------------------------------

      if ((mo.gt.2).and.(iand(yr,3).eq.0)) then
         day = days(mo) + dy + 1
      else
         day = days(mo) + dy
      end if

      secs = (((day*24)+hh)*60+mm)*60+ss

      return
      end

      DOUBLE PRECISION FUNCTION DACOSX(VALUE)
C
C FUNCTION WHICH ROUNDS ARGUMENTS VERY NEAR -1.0/1.0 TO -1.0/1.0.  
C NECESSARY FOR SOME THINGS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (TOL = 1.D-12)
      DATA ONE /1.0/
      X=ABS(ABS(VALUE)-ONE)
      IF(X.LT.TOL)VALUE=SIGN(ONE,VALUE)
      DACOSX=DACOS(VALUE)
      RETURN
      END

      SUBROUTINE FRMLST(NATOM,IREF,IORBIT,IORDGP,TRNMAT,IATLST,IPTR,
     &                  MEMBER,ICOUNT,JCOUNT)
C
C THIS ROUTINE CREATES THE MEMBER AND TRNMAT ARRAYS FOR A PARTICULAR
C  ORBIT, GIVEN THE REFERENCE ATOM AND IPTR ARRAYS. 
C
      IMPLICIT INTEGER (A-H,O-Z)
      DIMENSION IPTR(NATOM,IORDGP),IATLST(NATOM) 
      INTEGER TRNMAT(NATOM),MEMBER(NATOM)
      PARAMETER (LUOUT = 6)
      JIN=0  
      IFIRST=0
      DO 10 I=1,IORDGP
       IATLST(IPTR(IREF,I))=IORBIT
       TRNMAT(IPTR(IREF,I))=I
       IF(IREF.EQ.IPTR(IREF,I))TRNMAT(IPTR(IREF,I))=0
10    CONTINUE
      DO 33 I=1,NATOM
       IF(IATLST(I).EQ.IORBIT)THEN
        JIN=JIN+1
        ICOUNT=ICOUNT+1
        JCOUNT=JCOUNT+1
        IF(JIN.EQ.1)IFIRST=ICOUNT
        MEMBER(ICOUNT)=I
       ENDIF
 33   CONTINUE
C
C MAKE SURE THAT THE FIRST ENTRY FOR THIS ORBIT IN MEMBER IS THE
C  REFERENCE ATOM. IF NOT, SWAP THE ORDERING.
C
      JLOC=CHKINT(MEMBER,NATOM,IREF)
      IF(JLOC.NE.IFIRST)THEN
       WRITE(LUOUT,100)
100    FORMAT(T3,'@FRMLST-I, Member ordering differs from Z-matrix',
     &           ' order.')
       ITEMP=MEMBER(IFIRST)
       MEMBER(IFIRST)=IREF
       MEMBER(JLOC)=ITEMP
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine read_hess(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c     The 4-index array (hessian at present) is read in and summed 
c     into an array in a common block. 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'int_gen_parms.h'
      include 'hess.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      double precision xx(1)
#ifdef ALTIX
      pointer (dptr, xx)
#else
      common xx
#endif

      if (dryrun) return
      write_hess = .true.

#ifdef ALTIX
      dptr = dshptr
#endif

      if (nindex .ne. 4) then
         print *,'Error in read_hess: ',
     *      'Hessian must be a 4-index array!.'
         print *,'array has ',nindex,' indices at line ',
     *            current_line,'.'
         call abort_job()
      endif

      call add_hess(x,bval(1),eval(1),bval(2),eval(2),
     *                        bval(3),eval(3),bval(4),eval(4),
     *                        xx(ix_hess))
      
      return
      end


      subroutine add_hess(x,iatoms,iatome,icomponents,icomponente,
     *                      jatoms,jatome,jcomponents,jcomponente, 
     *                      hess) 
      implicit none
      include 'parallel_info.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'dbugcom.h'

      integer i,j,ihess,jhess 
      integer iatoms,iatome,icomponents,icomponente  
      integer jatoms,jatome,jcomponents,jcomponente  
      double precision x(iatoms:iatome,icomponents:icomponente,
     *                   jatoms:jatome,jcomponents:jcomponente)
      double precision hess(3*ncenters,3*ncenters) 


      if (dbg) then
         write(6,*) ' HCOORD :', iatoms,icomponents,jatoms,
     *                    jcomponents
         write(6,*) ' Hessian from Loops ',x(iatoms,icomponents, 
     *                                    jatoms,jcomponents)  
      endif

      if (me .ne. 0) return  

      ihess = (iatoms-1)*3 + icomponents 
      jhess = (jatoms-1)*3 + jcomponents 

      hess(jhess,ihess) = hess(jhess,ihess) 
     *                  + x(iatoms,icomponents,jatoms,jcomponents) 

c     if (ihess .ne. jhess) 
c      hess(jhess,ihess) = hess(jhess,ihess) 
c     *                  + x(iatoms,icomponents,jatoms,jcomponents) 

33    format(3F16.8)

      return
      end

      subroutine rmdummy (
     &     natmx, natm, compnorb, comppopv, compmemb, 
     &     atmchr, atmmas, atmcrd)
c
c This routine removes dummy (but not ghost!) atoms from the arrays that
c contain information about the molecule.
c
c Note that all molecular info arrays written into JOBARC by JODA
c include dummy and ghost atoms.
c
c Similar routine are LIBRA3/A3REMOVEDUMMY and HFDFT/REMOVE.
c
c Note that the proper way to go through all the atoms is to loop over
c 1..COMPNORB and 1..COMPPOPV, i.e. through the symmetry ordered atoms,
c since VMOL has already taken care of dummy atoms while building these
c arrays. This routine is needed only if later on somebody decide to
c loop over atoms just by cycling over 1..NATM, thus including the dummy
c atoms.
c
c Igor Schweigert, Feb 2004
c $Id: rmdummy.F,v 1.1 2004/03/01 18:38:30 igor Exp $
c 
      implicit none
c
c     Arguments
c     
      integer
     &     natmx, natm, compnorb, comppopv (compnorb),
     &     compmemb (natmx), atmchr (natmx)
c     
      double precision
     &     atmmas (natmx), atmcrd (3, natmx)
c
c     Local variables
c     
      integer i, j, k, l, n, ndum
c
c     Messages to the user
c     
 5900 format (
     &     t3,'@RMDUMMY-F: The JOBARC record NREALATM does not ',/
     &     t3,'correspond to the number of non-dummy atoms.',/)
c
c     Remove dummy (but not ghost!) atoms from the arrays. Note that
c     COMPPOPV does not count dummy atoms already, but COMPMEMB points
c     to the arrays of atoms including dummy atoms. So COMPMEMB has to
c     be modified as well. Note that we do not modify FULLMEMB.
c     
      j = 0
      ndum = 0
      do i = 1, natmx
         if (atmchr (i) .ne. 0) then
            j = j + 1
            atmmas (j) = atmmas (i)
            atmchr (j) = atmchr (i)
            call dcopy (3, atmcrd (1, i), 1, atmcrd (1, j), 1)
         else
            ndum = ndum + 1
            n = 1
            do k = 1, compnorb
               do l = 1, comppopv (k)
                  if (compmemb (n) + ndum .gt. i)
     &                 compmemb (n) = compmemb (n) - 1
                  n = n + 1
               enddo
            enddo
         endif
      enddo
c
      if (j.ne.natm) then
         write (6,5900)
         call errex
      endif
c    
c          do i=1,natmx
c          write(6,*) atmcrd (1, i), atmcrd (2, i), atmcrd (3, i)
c          enddo
      return
      end

      SUBROUTINE GEN_RICS(CARTCOORD,TOTREDNCO, TOTNOFBND, TOTNOFANG,
     &                    TOTNOFDIH, IREDUNCO, REDUNCO)
C
C Generate the redundent internal coordinates given the bond, angle and
C dihedral angle assignments.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "mxatms.par"
#include "io_units.par"
#include "cbchar.com"
C 
      PARAMETER(THRESHOLD = 5.0D00, EPSILON = 1.0D-10)
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH,
     &        FRAGSCR
      LOGICAL TEST_4CHANGE
C
      DIMENSION CARTCOORD(3*MXATMS), BNDLENTHS(MXATMS, MXATMS), 
     &          IREDUNCO(4, MAXREDUNCO), 
     &          REDUNCO(MAXREDUNCO),        
     &          VECBA(3), VECBC(3), 
     &          VECBAD(3), VECCB(3), VECAB(3), VECCD(3), VECABC(3),
     &          VECBCD(3)
C      
      DATA  IZERO, MONE, ZERO /0, -1, 0.0D0/
C
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0 
      PI     = (ATAN(DFLOAT(1))*DFLOAT(4))
C
      NW_TOTREDNCO = IZERO
      BHORTOANG    = 0.529177249D0
C
#ifdef _DEBUG_LVL0 
      Write(6,"(a)"), "The redundent internal coordinate assignments"
      Write(6,*)
      Do i = 1, TOTREDNCO
         Write(6,111) (iredunco(j, i), j=1, 4)
      Enddo
 111  Format(5X, 4(I3, 1X))
#endif
C
C Assign bond coordiante
C
#ifdef _DEBUG_LVL0
      Write(6,*)
#endif
  
      DO IBNDS = 1, TOTNOFBND
         IF (IREDUNCO(2, IBNDS) .NE. 0) THEN
            ICON1  = IREDUNCO(1, IBNDS)
            ICON2  = IREDUNCO(2, IBNDS)
            DISTAB = DIST(CARTCOORD(3*ICON1 - 2), 
     &               CARTCOORD(3*ICON2 - 2))
            REDUNCO(IBNDS) = DISTAB
C     
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The bond distance =",DISTAB*0.529177249d0
#endif
         ENDIF
      ENDDO
C
C Assign bond angle Coordinates.
C
#ifdef _DEBUG_LVL0
      Write(6,*)
#endif
      DO IANGS = (TOTNOFBND + 1), (TOTNOFANG + TOTNOFBND)
     
         IF (IREDUNCO(4, IANGS) .EQ. MONE) THEN
C
C This is for linear arrangements (two angle coordinates are
C required). 
C
            REDUNCO(IANGS) = 180.0D0*DINVPI
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The Bond Angle =", ANGL/DINVPI
#endif
C
         ELSE
C
C This is for the non-linear arrangements.
C
            ICON1  = IREDUNCO(1, IANGS)
            ICON2  = IREDUNCO(2, IANGS)  
            ICON3  = IREDUNCO(3, IANGS)
            CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2),
     &               VECBC, 1)
            CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON1 - 2),
     &               VECBA, 1)
            ANGL    = ANGLE(VECBC, VECBA, 3)*DINVPI
            REDUNCO(IANGS) = ANGL
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The Bond Angle =", ANGL/DINVPI
#endif
         ENDIF
C
      ENDDO
C
C Assign bond dihedral angle Coordinates.
C
#ifdef _DEBUG_LVL0
      Write(6,*)
#endif
      DO IDIHS = (TOTNOFANG + TOTNOFBND + 1),  TOTREDNCO
         ICON1  = IREDUNCO(1, IDIHS)
         ICON2  = IREDUNCO(2, IDIHS)
         ICON3  = IREDUNCO(3, IDIHS)
         ICON4  = IREDUNCO(4, IDIHS)
         CALL VEC(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2),
     &         VECAB, 1)
         CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2),
     &         VECBC, 1)
         CALL VEC(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2),
     &         VECCB, 1)
         CALL VEC(CARTCOORD(3*ICON4 - 2), CARTCOORD(3*ICON3 - 2),
     &         VECCD, 1)
C
         DISTAB = DIST(CARTCOORD(3*ICON1 - 2), 
     &            CARTCOORD(3*ICON2 - 2))
         DISTBC = DIST(CARTCOORD(3*ICON3 - 2), 
     &            CARTCOORD(3*ICON2 - 2))
         DISTCD = DIST(CARTCOORD(3*ICON3 - 2), 
     &            CARTCOORD(3*ICON4 - 2))
C
C First evaluate the dihedral angle. This is calculated as the
C angle between the two unit vectors that are perpendicular to
C the ABC and BCD planes for A-B-C-D pattern.
C
         CALL CROSS(VECAB, VECBC, VECABC, 1)
C
C We need the vector CD, obtain that from vec DC (note the misnomar)
C
         CALL DSCAL(3, -1.0D0, VECCD, 1)
         CALL CROSS(VECBC, VECCD, VECBCD, 1)
C
         DANG = (ANGLE(VECABC, VECBCD, 3))*DINVPI
C
C--- Obtainig the sign of the dihedral angle:
C
         CALL DSCAL(3, -1.0D0, VECCD, 1)
         CALL CROSS(VECCD, VECCB, VECBCD, 0)
C
         SENSE = DDOT(3, VECAB, 1, VECBCD, 1)

         IF (SENSE .GT. 0.0D0) DANG = -DANG
         REDUNCO(IDIHS) = DANG
         
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The Dihedral Angle =", DANG/DINVPI
#endif
C
#ifdef _DEBUG_LVLM1
      Print*, "The vectors making the dihedral angle"
      Print*,  (CARTCOORD(3*ICON1 - 2 + I), I=0, 2)
      Print*,  (CARTCOORD(3*ICON2 - 2 + I), I=0, 2)
      Print*,  (CARTCOORD(3*ICON3 - 2 + I), I=0, 2)
      Print*,  (CARTCOORD(3*ICON4 - 2 + I), I=0, 2)
      Print*, "The vec. BC: ", (VECBC(I), I=1, 3)
      Print*, "The vec. AB: ", (VECAB(I), I=1, 3)
      Print*, "The vec. CB: ", (VECCB(I), I=1, 3)
      Print*, "The vec. CD: ", (-VECCD(I), I=1, 3)
      Print*, "The vec. ABC:", (VECABC(I), I=1,3)
      Print*, "The vec. BCD:", (VECBCD(I), I=1,3)
      Write(6,"(a,F10.5)") "The dihedral angle", DANG/DINVPI
#endif
C
      ENDDO 
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_blocks_to_list_no_mpi_io(node, 
     *                        server_table, nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_blocks_to_list message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, j, istart, nsearch, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind, imsg
      integer msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile, nxt
      integer request, status(MPI_STATUS_SIZE)
      integer array, nindex, tag, f_form_msg_tag 
      integer msglen
      integer msg(100)
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif
      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then
         array = server_msg(c_msg_array,node)

c---------------------------------------------------------------------------
c   Locate the server_table entries for this array.
c---------------------------------------------------------------------------

         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               istart = served_array_entry(i)
               nsearch = served_numblocks(i)
               go to 50
            endif
         enddo

c---------------------------------------------------------------------------
c   Array not found on this server.   We have nothing to do.
c---------------------------------------------------------------------------

         go to 1000
 
   50    continue
         indblk = get_index_from_base(base_mem_addr, x, 2)

c---------------------------------------------------------------------------
c   Calculate the index of the message buffer.
c--------------------------------------------------------------------------

         msgbuffer = server_msg(c_msg_msgbuffer,node)
         imsg = indblk + (msgbuffer-1)* server_mem_blocksize

c---------------------------------------------------------------------------
c   Process each block of the array found in the server_table.
c---------------------------------------------------------------------------

         do iblock = istart, istart+nsearch-1
            if (server_table(c_server_array,iblock) .eq. array) then
               if (server_table(c_server_iblk,iblock) .eq. 
     *                               99999999) then
                  print *,'No message for iblock ',iblock
                  print *,(server_table(i,iblock),
     *                     i=1,lserver_table_entry)
                  call server_abort_job(server_table, nserver_table)
               endif

c---------------------------------------------------------------------------
c   Form a descriptor message and send it to the master.
c---------------------------------------------------------------------------

               msg(1) = server_blocks_to_list_msg 
               msg(2) = array
               nindex = server_table(c_server_nind,iblock)
               msg(3) = nindex
               tag    = f_form_msg_tag()
               msg(4) = tag
               msg(5) = 0
               msg(7) = server_table(c_server_iblk,iblock)
               nxt = 7 + mx_array_index
               do i = 1, mx_array_index
                  if (i .le. nindex) then
                     msg(nxt) = server_table(c_server_bsegs+i-1,iblock)
                     msg(nxt+1)=server_table(c_server_esegs+i-1,iblock)
                  else
                     msg(nxt) = 0
                     msg(nxt+1) = 0
                  endif
                  nxt = nxt + 2
               enddo
               msglen = nxt - 1


               if (server_table(c_server_memloc,iblock) .ne. 0) then
                  
c---------------------------------------------------------------------------
c   Send the data from the memory block to the master.
c---------------------------------------------------------------------------
   
                  j = server_table(c_server_memloc,iblock)
                  ind = indblk + (j-1) * server_mem_blocksize
                  call mpi_isend(x(ind), 
     *                          server_table(c_server_size,iblock),
     *                          mpi_double_precision, 0,
     *                          tag, mpi_comm_world,
     *                          request, ierr)

               else if (server_table(c_server_diskloc,iblock) .gt. 
     *                      0) then 

c---------------------------------------------------------------------------
c   Read the data from disk into the node's message buffer.
c---------------------------------------------------------------------------

                  diskloc = server_table(c_server_diskloc,iblock)
                  size    = server_table(c_server_size,iblock)
                  ifile   = server_table(c_server_file, iblock)
                  call f_restoreram(server_unit(ifile), diskloc,
     *                           server_blocksizes(ifile),
     *                           x(imsg), size)

                  call mpi_isend(x(imsg), size,
     *                          mpi_double_precision, 0,
     *                          tag, mpi_comm_world,
     *                          request, ierr)
               else
                  print *,'Server ',me,': Error in write_blocks_to_list'
                  print *,'   Array ',array,
     *                    ' erroneous server_table entry'
                  print *,(server_table(i,iblock),i=1,
     *                      lserver_table_entry)
                  call server_abort_job(server_table, nserver_table)
               endif
            endif

c-------------------------------------------------------------------------
c   Send the descriptor message.
c-------------------------------------------------------------------------

            call mpi_send(msg, msglen, mpi_integer, 0,
     *                        server_blocks_to_list_msg, 
     *                        mpi_comm_world,
     *                        status, ierr)

c--------------------------------------------------------------------------
c   Wait for the data send to complete.
c--------------------------------------------------------------------------

            call mpi_wait(request, status, ierr)
         enddo
 
c--------------------------------------------------------------------------
c   Complete the processing of this message by entering the null state.
c--------------------------------------------------------------------------

1000     continue   
         server_msg(c_msg_state,node) = null_state   ! done
      endif
      return
      end

c This routine shuts down the ACES I/O subsystem in the SB environment.

      subroutine sb_io_fin
      implicit none
      call callstack_push('SB_IO_FIN')
cTODO      call aces_io_fin
      call callstack_pop
      return
      end

      SUBROUTINE FSINIPOP(IVECTOR,IVECDIM,IUHF)
C
C INITIALIZES THE FSSYM COMMON BLOCK.  TRICKY STUFF, SORT OF.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION IVECTOR(IVECDIM,3,2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /FSSYMPOP/ FSDPDAN(8,22),FSDPDNA(8,22),FSDPDAA(8,22),
     &                  FSDPDIN(8,22),FSDPDNI(8,22),FSDPDII(8,22),
     &                  FSDPDAI(8,22),FSDPDIA(8,22)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON /FSSYM/ POPA(8,2),POPI(8,2),VRTA(8,2),VRTI(8,2),
     &               NTAN(2),NTNA(2),NTAA(2),
     &               NTIN(2),NTNI(2),NTII(2),
     &               NTAI(2),NTIA(2),
     &               NF1AN(2),NF1AA(2),NF1IN(2),NF1II(2),NF1AI(2),
     &               NF2AN(2),NF2AA(2),NF2IN(2),NF2II(2),NF2AI(2)
C
C DIRTY STUFF!
C
      CALL IZERO(POPA,100)
C
C DETERMINE ACTIVE POPULATIONS
C
      DO 10 ISPIN=1,1+IUHF
       ITHRU=0
       DO 20 IRREP=1,NIRREP
        NOCC=POP(IRREP,ISPIN)
        IX=0
        DO 30 I=1,NOCC
         ITHRU=ITHRU+1
         IF(IVECTOR(ITHRU,2,ISPIN).EQ.0)IX=IX+1
30      CONTINUE
        POPA(IRREP,ISPIN)=IX
        POPI(IRREP,ISPIN)=POP(IRREP,ISPIN)-POPA(IRREP,ISPIN)
20     CONTINUE
C
       DO 21 IRREP=1,NIRREP
        NVRT=VRT(IRREP,ISPIN)
        IX=0
        DO 31 I=1,NVRT
         ITHRU=ITHRU+1
         IF(IVECTOR(ITHRU,2,ISPIN).EQ.0)IX=IX+1
31      CONTINUE
        VRTA(IRREP,ISPIN)=IX
        VRTI(IRREP,ISPIN)=VRT(IRREP,ISPIN)-VRTA(IRREP,ISPIN)
21     CONTINUE       
C
       DO 22 IRREP=1,NIRREP
C
        NF1AN(ISPIN)=NF1AN(ISPIN)+POPA(IRREP,ISPIN)*POP(IRREP,ISPIN)
        NF1AA(ISPIN)=NF1AA(ISPIN)+POPA(IRREP,ISPIN)*POPA(IRREP,ISPIN)
        NF1IN(ISPIN)=NF1IN(ISPIN)+POPI(IRREP,ISPIN)*POP(IRREP,ISPIN)
        NF1II(ISPIN)=NF1II(ISPIN)+POPI(IRREP,ISPIN)*POPI(IRREP,ISPIN)
        NF1AI(ISPIN)=NF1AI(ISPIN)+POPA(IRREP,ISPIN)*POPI(IRREP,ISPIN)
C
        NF2AN(ISPIN)=NF2AN(ISPIN)+VRTA(IRREP,ISPIN)*VRT(IRREP,ISPIN)
        NF2AA(ISPIN)=NF2AA(ISPIN)+VRTA(IRREP,ISPIN)*VRTA(IRREP,ISPIN)
        NF2IN(ISPIN)=NF2IN(ISPIN)+VRTI(IRREP,ISPIN)*VRT(IRREP,ISPIN)
        NF2II(ISPIN)=NF2II(ISPIN)+VRTI(IRREP,ISPIN)*VRTI(IRREP,ISPIN)
        NF2AI(ISPIN)=NF2AI(ISPIN)+VRTA(IRREP,ISPIN)*VRTI(IRREP,ISPIN)
C
        NTAN(ISPIN)=NTAN(ISPIN)+VRTA(IRREP,ISPIN)*POP(IRREP,ISPIN)
        NTNA(ISPIN)=NTNA(ISPIN)+VRT(IRREP,ISPIN)*POPA(IRREP,ISPIN)
        NTAA(ISPIN)=NTAA(ISPIN)+VRTA(IRREP,ISPIN)*POPA(IRREP,ISPIN)
        NTIN(ISPIN)=NTIN(ISPIN)+VRTI(IRREP,ISPIN)*POP(IRREP,ISPIN)
        NTNI(ISPIN)=NTNI(ISPIN)+VRT(IRREP,ISPIN)*POPI(IRREP,ISPIN)
        NTII(ISPIN)=NTII(ISPIN)+VRTI(IRREP,ISPIN)*POPI(IRREP,ISPIN)
        NTAI(ISPIN)=NTAI(ISPIN)+VRTA(IRREP,ISPIN)*POPI(IRREP,ISPIN)
        NTIA(ISPIN)=NTIA(ISPIN)+VRTI(IRREP,ISPIN)*POPA(IRREP,ISPIN)
C
22     CONTINUE
C
10    CONTINUE
C
      RETURN
      END

C IN-PLACE TRANSPOSITION OF AN N x N MATRIX.

      SUBROUTINE MTRAN2(A,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N)
      if (n.lt.1) return
      DO I = 1, N
         DO J = 1, I-1
            Z      = A(I,J)
            A(I,J) = A(J,I)
            A(J,I) = Z
         END DO 
      END DO
      RETURN
      END

C THIS ROUTINE PRINTS OUT A SUMMARY OF ALL RECORDS IN THE JOBARC FILE,
C THEIR LOCATION (WORD ADDRESS) AND THE NUMBER OF INTEGER WORDS THAT
C THE LOGICAL RECORD TAKES UP.

      SUBROUTINE JASMRY
      IMPLICIT INTEGER (A-Z)
      CHARACTER*8 MARKER
      PARAMETER (LENGTH = 1000)
      COMMON /JOBARC/ MARKER(LENGTH),LOC(LENGTH),SIZE(LENGTH),NRECS,
     &                IRECWD,IRECLN
      WRITE(*,30)
30    FORMAT(T14,'Summary of JOBARC file contents',/,
     &       T5,'LABEL',T25,'FILE LOCATION',T54,'LENGTH',/,
     &       T22,'(absolute word offset)',T50,'(integer words)')
      DO I = 1, 1000
         IF (MARKER(I).EQ.'OPENSLOT') GOTO 20
         WRITE(*,'(T3,A8,T26,I9,T51,I9)') MARKER(I),LOC(I),SIZE(I)
      END DO
20    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_SET_IJ_PAIRS
     +
     +                    ( NPGTOA,NPGTOB,NPGTOAB,
     +                      ATOMIC,EQUALAB,
     +                      SWAPRS,
     +                      RNABSQ,
     +                      PREFACT,
     +                      ALPHAA,ALPHAB,
     +                      SCREEN,
     +
     +                               EMPTY,
     +                               NIJ,
     +                               PRIMA,PRIMB,
     +                               RHO )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_SET_IJ_PAIRS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation determines the ij primitive exponent
C                pairs which will actually be considered for
C                contraction. It is here where the internal prescreening
C                (if any) of overlap primitives must be applied.
C
C                There are two ways the ij pairs can be ordered:
C                1) i runs fastest or 2) j runs fastest. The ordering
C                to be chosen depends on the order the contraction will
C                be performed. We have the following rule:
C
C                     If # primitives on A > # primitives on B
C                     (i.e. the SWAPRS = .true. case), the contraction
C                     will be performed first on the A primitives
C                     followed by the B primitives in order to save
C                     intermediate storage space for the 1st half
C                     transformation. Hence each B primitive will have
C                     associated a set of A primitives for the 1st
C                     half contraction and thus the order for the
C                     primitive pairs ij must be such that i runs
C                     fastest. If # primitives on A =< # primitives
C                     on B we have to let j run fastest.
C
C                The prescreening will be based on the fact that
C                for normalized cartesian integrals the primitive
C                (s|s) overlap integrals will be largest in magnitude
C                for all exponent combinations. The normalized (s|s)
C                overlap integral value expression is:
C
C                 Sqrt (8) * (ab)**(3/4) * (a+b)**(-3/2) * rho (a,b)
C
C                where a and b are the i-th and j-th gaussian exponents,
C                and rho (a,b) is the exponential prefactor given by the
C                expression:
C
C                                      - (ab/(a+b)) * R(AB)**2
C                       rho (a,b) = exp
C
C                where R(AB)**2 is the square of the distance between
C                the i-th and j-th atomic centers A and B.
C
C                The prescreening will be done in a 'K2' fashion,
C                running over all exponent pairs. An ij exponent pair
C                will be rejected, if the corresponding upper bound
C                of the (s|s) integral is less than a certain tolerance
C                value TOL.
C
C                Since evaluation of the exponential prefactors is
C                rather costly, the ones surviving the prescreening
C                are transmitted back to the calling routine for
C                further use.
C
C
C                  Input:
C
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NPGTOAB      =  # of primitive pairs for
C                                    contraction shell pair AB
C                    ATOMIC       =  indicates, if atomic integrals are
C                                    evaluated
C                    EQUALAB      =  indicates, if csh A and csh B are
C                                    considered to be equal
C                    SWAPRS       =  is .true. if the contraction order
C                                    of the primitive pairs AB will
C                                    be performed in reverse order
C                                    BA for efficiency reasons
C                    RNABSQ       =  the square distance R(AB)**2
C                                    between centers A and B
C                    PREFACT      =  the value of sqrt (8)
C                    ALPHAx       =  primitive exponents for centers
C                                    x=A,B
C                    SCREEN       =  is true, if screening will be
C                                    performed
C
C                  Output:
C
C                    EMPTY        =  is true, if no ij pairs were
C                                    established
C                    NIJ          =  # of ij pairs after screening
C                    PRIMx        =  i,j labels of primitives for x=A,B
C                    RHO          =  NIJ exponential prefactors rho(a,b)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   ATOMIC
         LOGICAL   EMPTY
         LOGICAL   EQUALAB
         LOGICAL   SCREEN
         LOGICAL   SWAPRS

         INTEGER   I,J
         INTEGER   NIJ
         INTEGER   NPGTOA,NPGTOB,NPGTOAB

         INTEGER   PRIMA (1:NPGTOAB)
         INTEGER   PRIMB (1:NPGTOAB)

         DOUBLE PRECISION  A,B,AB
         DOUBLE PRECISION  P
         DOUBLE PRECISION  PREFACT
         DOUBLE PRECISION  RHOAB
         DOUBLE PRECISION  RNABSQ
         DOUBLE PRECISION  SS
         DOUBLE PRECISION  ZP75,ONE,NEG1P5,TOL

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  RHO (*)

         PARAMETER  (ZP75    =  0.75D0)
         PARAMETER  (ONE     =  1.D0)
         PARAMETER  (NEG1P5  = -1.5D0)
         PARAMETER  (TOL     =  1.D-14)
C
C
C------------------------------------------------------------------------
C
C
C             ...the no screening section.
C
C
         EMPTY = .FALSE.

         IF (.NOT.SCREEN) THEN

             NIJ = 0
             IF (EQUALAB) THEN
                 DO I = 1,NPGTOA
                 DO J = 1,I
                    NIJ = NIJ + 1
                    RHO (NIJ) = ONE
                    PRIMA (NIJ) = I
                    PRIMB (NIJ) = J
                 END DO
                 END DO
             ELSE
                 IF (SWAPRS) THEN
                     IF (ATOMIC) THEN
                         DO J = 1,NPGTOB
                         DO I = 1,NPGTOA
                            NIJ = NIJ + 1
                            RHO (NIJ) = ONE
                            PRIMA (NIJ) = I
                            PRIMB (NIJ) = J
                         END DO
                         END DO
                     ELSE
                         DO J = 1,NPGTOB
                            B = ALPHAB (J)
                            DO I = 1,NPGTOA
                               A = ALPHAA (I)
                               NIJ = NIJ + 1
                               RHO (NIJ) = DEXP (- A*B*RNABSQ / (A+B))
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                            END DO
                         END DO
                     END IF
                 ELSE
                     IF (ATOMIC) THEN
                         DO I = 1,NPGTOA
                         DO J = 1,NPGTOB
                            NIJ = NIJ + 1
                            RHO (NIJ) = ONE
                            PRIMA (NIJ) = I
                            PRIMB (NIJ) = J
                         END DO
                         END DO
                     ELSE
                         DO I = 1,NPGTOA
                            A = ALPHAA (I)
                            DO J = 1,NPGTOB
                               B = ALPHAB (J)
                               NIJ = NIJ + 1
                               RHO (NIJ) = DEXP (- A*B*RNABSQ / (A+B))
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                            END DO
                         END DO
                     END IF
                 END IF
             END IF

             RETURN

         END IF
C
C
C             ...perform screening on ij exponent pairs.
C
C
         NIJ = 0

         IF (EQUALAB) THEN

             DO I = 1,NPGTOA
                A = ALPHAA (I)
                DO J = 1,I
                   B = ALPHAB (J)

                   SS = PREFACT * ((A*B)**ZP75) * ((A+B)**NEG1P5)

                   IF (SS.GE.TOL) THEN
                       NIJ = NIJ + 1
                       RHO (NIJ) = ONE
                       PRIMA (NIJ) = I
                       PRIMB (NIJ) = J
                   ELSE
C                       WRITE (*,*) ' Skip atom ovlp I J = ',I,J
                   END IF

                END DO
             END DO

         ELSE

             IF (SWAPRS) THEN
                 IF (ATOMIC) THEN
                     DO J = 1,NPGTOB
                        B = ALPHAB (J)
                        DO I = 1,NPGTOA
                           A = ALPHAA (I)

                           SS = PREFACT*((A*B)**ZP75)*((A+B)**NEG1P5)

                           IF (SS.GE.TOL) THEN
                               NIJ = NIJ + 1
                               RHO (NIJ) = ONE
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip atom ovlp I J = ',I,J
                           END IF

                        END DO
                     END DO
                 ELSE
                     DO J = 1,NPGTOB
                        B = ALPHAB (J)
                        DO I = 1,NPGTOA
                           A = ALPHAA (I)
                           P = A + B
                           AB = A * B
                           RHOAB = DEXP (- AB * RNABSQ / P)

                           SS = PREFACT*(AB**ZP75)*(P**NEG1P5)*RHOAB

                           IF (SS.GE.TOL) THEN
                               NIJ = NIJ + 1
                               RHO (NIJ) = RHOAB
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip ovlp I J = ',I,J
                           END IF

                        END DO
                     END DO
                 END IF
             ELSE
                 IF (ATOMIC) THEN
                     DO I = 1,NPGTOA
                        A = ALPHAA (I)
                        DO J = 1,NPGTOB
                           B = ALPHAB (J)

                           SS = PREFACT*((A*B)**ZP75)*((A+B)**NEG1P5)

                           IF (SS.GE.TOL) THEN
                               NIJ = NIJ + 1
                               RHO (NIJ) = ONE
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip atom ovlp I J = ',I,J
                           END IF

                        END DO
                     END DO
                 ELSE
                     DO I = 1,NPGTOA
                        A = ALPHAA (I)
                        DO J = 1,NPGTOB
                           B = ALPHAB (J)
                           P = A + B
                           AB = A * B
                           RHOAB = DEXP (- AB * RNABSQ / P)

                           SS = PREFACT*(AB**ZP75)*(P**NEG1P5)*RHOAB

                           IF (SS.GE.TOL) THEN
                               NIJ = NIJ + 1
                               RHO (NIJ) = RHOAB
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip ovlp I J = ',I,J
                           END IF

                        END DO
                     END DO
                 END IF
             END IF

         END IF

         IF (NIJ.EQ.0) THEN
             EMPTY = .TRUE.
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      Subroutine projec_FC(Coords, Hess, AtmMass, Grad, Hess_project, 
     &                     Work, Threshold, Nreals, Move_CMass, 
     &                     Proj_rots, Proj_grads)
C
      Implicit Double Precision (A-H, O-Z)
C
      Double Precision MO_Inertia(3,3)
      Logical Proj_rots, Proj_grads, Move_CMass
      Integer L_Index, R_Index
C
      Dimension Coords(3*Nreals), Grad(3*Nreals), AtmMass(Nreals), 
     &          Hess(3*Nreals, 3*Nreals), Hess_Project(3*Nreals, 
     &          3*Nreals), Work(3*Nreals, 3*Nreals), Asym_ten(3,3,3),
     &          CM(3), Center_Mass(3)
 
      Data Asym_ten/ 0.0D+00,  0.0D+00,  0.0D+00,
     &               0.0D+00,  0.0D+00, -1.0D+00,
     &               0.0D+00,  1.0D+00,  0.0D+00,
     &               0.0D+00,  0.0D+00,  1.0D+00,
     &               0.0D+00,  0.0D+00,  0.0D+00,
     &              -1.0D+00,  0.0D+00,  0.0D+00,
     &               0.0D+00, -1.0D+00,  0.0D+00,
     &               1.0D+00,  0.0D+00,  0.0D+00, 
     &               0.0D+00,  0.0D+00,  0.0D+00  /
      Data Cut8 /1.0D-08/
C
C Normalize the gradinet vector. 
C
      If (Proj_grads) Then
         Grad_sqr = Ddot(3*Nreals, Grad, 1, Grad, 1)   
         If (Grad_sqr .GT. Threshold)  Call Normal(Grad, 3*Nreals)
      Endif
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "@-Projec_FC At enetry the Coords and grads"
      Write(6, "(3F17.13)") (Coords(i),i=1,3*Nreals)
      Write(6,*)
      Write(6, "(3F17.13)") (Grad(i),i=1,3*Nreals)
#endif
C
C Move to the center of Mass coordinate system.
C
      If (Move_CMass) Then
         Call Zero(CM, 3)
         TotMass = 0.0D0
         Do Iatoms = 1, Nreals
            Ioff = 3*(Iatoms - 1)
            TotMass = TotMass + AtmMass(Iatoms)
            Do Ixyz = 1, 3
               CM(Ixyz)   = Coords(Ioff + Ixyz)*AtmMass(Iatoms) +
     &                      CM(Ixyz)
            Enddo
         Enddo
C
         Do Ixyz = 1, 3
            If (TotMass .GT. Threshold) Then
                Center_Mass(IxYz) = CM(Ixyz)/TotMass
            Else
                Write(6, "(a)") "@-Project_FC Zero total mass"
                Call Errex
            Endif
         Enddo
C         
         Do Iatoms = 1, Nreals
            Ioff  = 3*(Iatoms - 1)
            Do Ixyz = 1, 3
               Coords(Ioff + Ixyz) = Coords(Ioff + Ixyz) - 
     &                               Center_Mass(Ixyz)
            Enddo
         Enddo
      Endif
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "@-Projec_FC The center of mass Coords"
      Write(6, "(3F17.13)") (Coords(i),i=1,3*Nreals)
#endif
C
C compute the inverse of inertia matrix.
c 
      Call CalMOI(NReals, Coords, AtmMass, MO_Inertia)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "@-Projec_FC the moments of inertia matrix"
      Call output(MO_Inertia, 1, 3, 1, 3, 3, 3,1)
#endif

      Check_3d = MO_Inertia(1,1)*MO_Inertia(2,2)*MO_Inertia(3,3)
      
      If (Dabs(Check_3d) .lt. Cut8) Then
C

C X=0
         If (Dabs(MO_Inertia(1,1)) .lt. Cut8) Then
C
            If (Dabs(MO_Inertia(2,2)) .lt. Cut8)  then
C Y=0, Z=/0
                MO_Inertia(3,3) = 1.0D0/MO_Inertia(3,3)
            Else
C Y,Z=/0
                Det= MO_Inertia(2,2)*MO_Inertia(3,3) -
     &               MO_Inertia(2,3)*MO_Inertia(2,3)
                Tmp = MO_Inertia(3,3)
                MO_Inertia(3,3) =  MO_Inertia(2,2)/Det
                MO_Inertia(2,2) =  Tmp/Det
                MO_Inertia(3,2) = - MO_Inertia(3,2)/Det
                MO_Inertia(2,3) = - MO_Inertia(2,3)/Det
            Endif
C Y=0
         Else if (Dabs(MO_Inertia(2,2)) .lt. Cut8) Then 
C
            If (Dabs(MO_Inertia(3,3)) .lt. Cut8)  then
C Z=0 X=/0
                MO_Inertia(1,1) = 1.0D0/MO_Inertia(1,1)
            Else
C X,Z=/0 
                Det= MO_Inertia(1,1)*MO_Inertia(3,3) -
     &               MO_Inertia(1,3)*MO_Inertia(3,1)
                Tmp = MO_Inertia(1,1)
                MO_Inertia(1,1) =  MO_Inertia(3,3)/Det
                MO_Inertia(3,3) =  Tmp/Det
                MO_Inertia(1,3) = - MO_Inertia(1,3)/Det
                MO_Inertia(3,1) = - MO_Inertia(3,1)/Det
            Endif
C Z=0
 
         Else if (Dabs(MO_Inertia(3,3)) .lt. Cut8) Then

           If (Dabs(MO_Inertia(1,1)) .lt. Cut8)  then
C x=0 ,Y=/0
                MO_Inertia(2,2) = 1.0D0/MO_Inertia(2,2)

           Else
C X,Y=/0
                Det= MO_Inertia(1,1)*MO_Inertia(2,2) -
     &               MO_Inertia(1,2)*MO_Inertia(2,1)
                Tmp = MO_Inertia(1,1)
                MO_Inertia(1,1) =  MO_Inertia(2,2)/Det
                MO_Inertia(2,2) =  Tmp/Det
                MO_Inertia(1,2) = - MO_Inertia(1,2)/Det
                MO_Inertia(2,1) = - MO_Inertia(2,1)/Det
           Endif
C
         Endif

      Else 
          Call Minv(MO_Inertia, 3, 3, Work, Det, 1.0D-8, 0, 1)
      Endif
C
C Mass weigh the incomming Cartesians
C
      Ioff = 1
      Do Iatoms = 1, Nreals
          Sqrtmass = Dsqrt(AtmMass(Iatoms))
          Do Ixyz = 1, 3
             Coords(Ioff) = Coords(Ioff)*Sqrtmass
             Ioff = Ioff + 1
          Enddo
      Enddo
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "@-Projec_FC Mass weighted center of mass Coords"
      Write(6, "(3F17.13)") (Coords(i),i=1,3*Nreals)
      Write(6,*)
      Write(6,"(a)") "@-Projec_FC Inv. of the moms. of inertia matrix"
      Call output(MO_Inertia, 1, 3, 1, 3, 3, 3,1)
#endif
C
C Build the Hessian projector See, Miller, Handy and Adams, JCP, 
C 72, 99, (1980).
C
      Do Iatms = 1, Nreals
         Ioff = 3*(Iatms - 1)
CSSS         Itmp = Max(3*(Iatms - 1), 6*(Iatms -1)-3*Nreals)

         Do Jatms = 1, Iatms
          Joff = 3*(Jatms - 1)
CSSS          Jtmp = Max(3*(Jatms - 1), 6*(Jatms -1)-3*Nreals)
#ifdef _DEBUG_LVLM1
       Write(6,"(4I3)") Ioff,Joff, Itmp, jtmp
       Write(6,*)
#endif

            Do Iz = 1, 3
               L_index = Ioff + Iz
CSSS               Itmp_L = Itmp + Iz
               Jz_end = 3
               If (Iatms .EQ. Jatms)  Jz_end = Iz
C
                 Do Jz = 1, Jz_end
                    R_index = Joff + Jz
CSSS                    Jtmp_R =  Jtmp + JZ
                    Sum = 0.0D0
C
                    If (Proj_rots) Then 

                        Do Ix = 1, 3
 
                           Do Iy = 1, 3
C
                              If (Asym_ten(Ix, Iy, Iz) .NE. 0.0D0) 
     &                            Then
                                   
                                   Do Jx = 1, 3

                                      Do Jy = 1, 3
                                         If (Asym_ten(Jx, Jy, Jz) .NE. 
     &                                       0.0D0) Then
                                             Sum = Sum + 
     &                                             Coords(Ioff + IY)*
     &                                             Coords(Joff + Jy)*
     &                                            MO_inertia(Ix, Jx)*
     &                                          Asym_ten(Ix, Iy, Iz)*
     &                                          Asym_ten(Jx, Jy, Jz)
                                         Endif
                                      Enddo
                                   Enddo 
                              Endif
                           Enddo
                        Enddo
                    Endif
C 
                    Hess_project(L_index, R_index) = Sum
C
#ifdef _DEBUG_LVLM1
CSSS                    Hess_project(L_index, R_index) = 0.0D0
       Write(6,"(2I3,F17.13)") L_index,R_index, sum 
CSSS   Itmp_L, Jtmp_R
      NX = 3*Nreals
      Write(6,*)
      Write(6,"(a)") "The Hessian projector (after rots)."

      CALL OUTPUT(Hess_project, 1, NX, 1, Nx, Nx, Nx, 1)
#endif
                    If (Proj_grads) Hess_project(L_index, R_index) = 
     &                              Hess_project(L_index, R_index) + 
     &                              Grad(R_Index)*Grad(L_index)
C
                    If (Iz .EQ. Jz) Then
#ifdef _DEBUG_LVLM1
        Write(6,"(4I3)") L_index,R_index, iatms, jatms
#endif
                        Hess_project(L_index, R_index) =
     &                  Hess_project(L_index, R_index) + 
     &                  Dsqrt(AtmMass(Iatms)*AtmMass(Jatms))/
     &                  Totmass
                    Endif
C
                 Enddo 
            Enddo 
C
         Enddo
      Enddo
C
#ifdef _DEBUG_LVLM1
      NX = 3*Nreals
      Write(6,*)
      Write(6,"(a)") "The Hessian projector:P", Threshold
      CALL OUTPUT(Hess_project, 1, NX, 1, Nx, Nx, Nx, 1)
#endif
C
C Build the projector (I - P)
C
      Do Jdeg = 1, 3*Nreals
          Do Ideg = 1, Jdeg
              Hess_project(Jdeg, Ideg) = -Hess_project(Jdeg, Ideg)
             If (Ideg .Eq. Jdeg)  Hess_project(Jdeg, Ideg) = 1.0D0 +
     &                            Hess_project(Jdeg, Ideg)   
             If (Dabs(Hess_project(Jdeg, Ideg)) .LT. Threshold) 
     &                            Hess_project(Jdeg, Ideg) = 0.0D0
              Hess_project(Ideg, Jdeg) = Hess_project(Jdeg, Ideg)
          Enddo
      Enddo
C 
C
#ifdef _DEBUG_LVL0
      NX = 3*Nreals
      Write(6,*)
      Write(6,"(a)") "The Hessian projector:(I-P)"
      CALL OUTPUT(Hess_project, 1, NX, 1, Nx, Nx, Nx, 1)
      
#endif
C
#ifdef _DEBUG_LVLM1
      NX = 3*Nreals
      Call Eig(Hess, Work, NX, Nx, 0) 
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the Hessian"
      CALL OUTPUT(Work, 1, NX, 1, Nx, Nx, Nx, 1)
      Write(6,"(a)") "The eigenvalues of the   Hessian"
      Write(6, "(4F10.5)") (Hess(I,I), I=1, NX)
#endif
C
C Project the Hessian (I - P)H(I - P)
C
      Call Xgemm("N", "N", 3*Nreals, 3*Nreals, 3*Nreals, 1.0D0, 
     &            Hess_project, 3*Nreals, Hess, 3*Nreals, 0.0D0, 
     &            Work, 3*Nreals)
C
      Call Xgemm("N", "N", 3*Nreals, 3*Nreals, 3*Nreals, 1.0D0, 
     &            Work, 3*Nreals, Hess_project, 3*Nreals, 0.0D0, 
     &            Hess, 3*Nreals)
C
#ifdef _DEBUG_LVLM1
      NX = 3*Nreals
      Write(6,*) "The projected Hessian"
      CALL OUTPUT(Hess, 1, NX, 1, Nx, Nx, Nx, 1)
      Call Eig(Hess, Work, NX, Nx, 0) 
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the projected Hessian"
      CALL OUTPUT(HESS, 1, NX, 1, Nx, Nx, Nx, 1)
#endif
      Return
      End
     

C Read the Z-matrix and associated variables

#include "iachar.h"

      SUBROUTINE FETCHZ(VERY_FIRST_TIME, Z, MAXMEM)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
#include "linelen.par"
#include "coord.com"

      LOGICAL PRINTI,PRINTF,BTMP

c     This number is supposed to be a unique tag to see whether some
c     internal coordinates were not defined.
      DOUBLE PRECISION dSmallNumber
      PARAMETER (dSmallNumber=5.361d-21, EPSILON= 1.0D-07)

#include "io_units.par"
#include "flags.h"

C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
      CHARACTER*(linelen) ZLINE, DUMSTR
      integer izline(80), izl(2,7)
      INTEGER ATOI, TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH 
      CHARACTER*10 VARTMP(3*MXATMS)
      CHARACTER*5 CHTEST
      CHARACTER*4 INTLABEL(MAXREDUNCO)
      CHARACTER*1 achar, czTmp, czPercent, czAsterisk
      Character*4 FPGrp, BPGrp, PGrp
      LOGICAL YESNO,BAD123,XYZIN,NWFINDIF,I_UNIQUE(MAXREDUNCO),
     &        VERY_FIRST_TIME, UNCONSTRAINED
      logical bStruct, Write_as_read
C
      double precision rtmp(3*mxatms), ptmp(3*mxatms)

C The arrays in FETCHZ that need to be managed dynamically are:
C
C REDUNCO: Store the RICs. It is of length 3*MXATMS.
C
C IBNDTO : Bonding connectivities for RICs. It is of length MXATMS*MXATMS.
C IREDUNCO : The connectivities for RICs. It is of length
C            4*MAXREDUNCO.
C EIGVECTORS: Keep the eigenvectors of the B-matrix. Needs to
C             to create the Gen. inverse of B-matrix. It is
C             of length MAXREDUNCO*MAXREDUNCO.
C
      DIMENSION JAX(3*MXATMS), JLIST(3*MXATMS), Z(MAXMEM),
     &          REDUNCO(3*MXATMS), IBNDTO(MXATMS*MXATMS), 
     &          IREDUNCO(4, MAXREDUNCO)
      DIMENSION EIGVECTORS(MAXREDUNCO, MAXREDUNCO)
C
#include "cbchar.com"
c
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     &                ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,
     &                IBASIS,XYZTol
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
#include "ric_heap.com"
C
      DATA BTOA /0.529177249D0/
      DATA ZILCH /0.0/
C
      ISQ(N) = MAX( N-6 , (N/3)+MOD(N,3)-1 )

      czPercent  = achar(_IACHAR_PERCENT)
      czAsterisk = achar(_IACHAR_ASTERISK)

c ----------------------------------------------------------------------

c   o fill COORD with zeroes
      if (VERY_FIRST_TIME) then
         call zero(q,3*MXATMS)
C         call zero(r, MAXREDUNCO)
         call zero(r, 3*MXATMS)
         call zero(atmass,MXATMS)
      end if

C     Symbol to indicate optimized coordinate
      CALL IGETREC(1,'JOBARC','FIRSTRUN',1,iTmp)
      PRINTI = (iTmp.NE.0)
      PRINTF = .TRUE.
      IONE = 1

#ifdef _DEBUG_LVLM1
         Print*, "@-Entry to fetchz logic", 
     &           iFlags2(h_IFLAGS2_geom_opt)
#endif
C
      IF (IFLAGS(68).EQ.1) THEN
C
C The logic here pertains to the Cartesian Coordinate input. Until, 
C 2002, ACES was only capable of doing single point calculations
C with Cartesian coordinates. The internal redundent coordinate
C geometry optimizations with Cartesian coordinate input was
C long anticipated and much desired, but remanind only as such
C until 2000. During early 2000 Ajith Perera developed the routines
C that are needed for IRC, but they were remained not debugged or
C incorporated in to the general structure, since he had other 
C important commitments and had no help until summer 2002, when
C he finally got some help from Luis Galiano to complete what 
C started in 2000.
C  
         XYZIN = .TRUE.
         IF (iFlags2(h_IFLAGS2_geom_opt).eq.0) THEN
            CALL GETXYZ
            GO TO 3431
         END IF 
C          
         IF (iFlags2(h_IFLAGS2_geom_opt).eq.2) THEN
#ifdef _DEBUG_LVLM1
         Print*, "Entering Cartesian Optimization block"
#endif
            CALL GETXYZ                     
C
#ifdef _DEBUG_LVLM1
            Write(6, "(a,I5)") "The # of atoms", Natoms
            ioff = 0
            Do I = 1, Natoms
               Write(6, "(3F10.5)") (Q(ioff+j), J=1,3)
               ioff = ioff + 3
            Enddo
#endif
            ISCRATCH = 1
            ITMPQ    = ISCRATCH + 9*NATOMS
            INEWQ    = ITMPQ    + 3*NATOMS
            ILAST    = INEWQ    + 3*NATOMS
            CALL SYMMETRY(Z(ISCRATCH), Z(ITMPQ), Z(INEWQ), .TRUE.)
            CALL DCOPY(3*NATOMS, Q, 1, R, 1)
C
#ifdef _DEBUG_LVLM1
               Write(6, "(3F10.5)") (R(j), J=1,3*NATOMS)
#endif
            NXM6 = 3*NATOMS 
            NX   = 3*NATOMS
C
            CALL IZERO(NCON, 3*MXATMS)
            CALL ASSIGN_XYZ_LABELS(3*NATOMS, INTLABEL)
C
            NUNIQUE = 0
            NOPT    = 0
C
            DO IVAR = 1, 3*NATOMS
               I_UNIQUE(IVAR) = .TRUE.
               IF (I_UNIQUE(IVAR)) THEN
                   NUNIQUE = NUNIQUE + 1
                   IUNIQUE(NUNIQUE) = IVAR
               END IF
C
C This is the place where info about constrained optimizations
C are added. At the moment all the unique coordinates are
C optimized.   

               UNCONSTRAINED  = .TRUE.
               IF (UNCONSTRAINED) THEN
                  IF (I_UNIQUE(IVAR)) THEN
                      NOPT         = NOPT  + 1
                      VARNAM(IVAR) = INTLABEL(IVAR)
                      PARNAM(NOPT) = INTLABEL(IVAR)
                      NOPTI(NOPT)  = IVAR
                  ELSE
                      VARNAM(IVAR) = INTLABEL(IVAR)
                  ENDIF
               ENDIF
            END DO
C
#ifdef _DEBUG_LVLM1
            WRITE(6,"(a,3(1x,I3))") "The number of Degrees of Fre =", 
     &                  NOPT, NUNIQUE, 3*NATOMS
            Write(6,*)
            Write(6, "(a7)") (Varnam(I), I=1,NOPT)
#endif
            DO I = 1, 3*NATOMS
               ISQUASH(I) = I
            END DO
C
C We have to rebuilt the NEQ array so that it represents the number
C of symmetry equivalent atoms for given symmetry unique atoms. The
C NEQ that comes out from PROCESS_REDINTRNLS corresponds to the
C natural order (ordered according to the unique degree of freedoms
C regardless of the atoms involved)
C
            CALL IZERO(NEQ, 3*NATOMS)
            DO ICOORD = 1, 3*NATOMS
               NCON(IUNIQUE(ICOORD)) = NEQ(ICOORD)
            ENDDO
C
            CALL ICOPY(3*NATOMS, NCON, 1, NEQ, 1)
C
#ifdef _DEBUG_LVLM1
         WRITE(6,*) "@FETCHZ the NEQ"
         WRITE(6,"(5I2)") (NCON(IIIK), IIIK = 1, 3*NATOMS)
     &        
#endif
            GO TO 3431
C
         END IF      
C
         IF (iFlags2(h_IFLAGS2_geom_opt).ge.3) THEN

         IF (VERY_FIRST_TIME) THEN
            TOTREDNCO = maxredunco
            CALL IPUTREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)
         ENDIF
C
C Redundent Internal Optimizations Starts Here
C
c      o allocate the RIC heap and create the pointers
         call init_ric_heap

         IF (VERY_FIRST_TIME) THEN
C
            CALL GETXYZ
            ISCRATCH = 1
            ITMPQ    = ISCRATCH + 9*NATOMS
            INEWQ    = ITMPQ    + 3*NATOMS
            ILAST    = INEWQ    + 3*NATOMS
            CALL SYMMETRY(Z(ISCRATCH), Z(ITMPQ), Z(INEWQ), .TRUE.)
C#ifdef _DEBUG_LVLM1
            Print*, "Entering the Redundent Internal block"
C#endif
            CALL GEN_REDNINTRNLS(Q, REDUNCO, INTLABEL, IBNDTO,
     &                           dRICHeap(z_BMat), dRICHeap(z_GMat),
     &                           TOTREDNCO, IATNUM, NATOMS, IREDUNCO,
     &                           TOTNOFBND, TOTNOFANG, TOTNOFDIH,
     &                           dRICHeap(z_BTGInv), EIGVECTORS)
C
            CALL IPUTREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)
            CALL IPUTREC(20, 'JOBARC', 'CONTEVIT', 4*TOTREDNCO, 
     &                  IREDUNCO)
            CALL IPUTREC(20, 'JOBARC', 'TNUMOBND', 1, TOTNOFBND)
            CALL IPUTREC(20, 'JOBARC', 'TNUMOANG', 1, TOTNOFANG)
            CALL IPUTREC(20, 'JOBARC', 'TNUMODIH', 1, TOTNOFDIH)
            CALL IPUTREC(20, 'JOBARC', 'IBONDTO ', NATOMS*NATOMS, 
     &                  IBNDTO)
C
C To fix the printing problem in summary.F if the input geometry
C is already optimum, Ajith Perera, 11,2012
C
            CALL DPUTREC(20,'JOBARC','COORD_OP',3*NATOMS,Q)
C
            IF (IFLAGS(h_IFLAGS_symmetry).EQ. 2 .AND. 
     &          FPGRP .NE. 'C1') THEN
               CALL PROCESS_REDINTRNLS(Q, REDUNCO, IREDUNCO, IBNDTO,
     &                                 I_UNIQUE, FPGRP, TOTNOFBND,
     &                                 TOTNOFANG, TOTNOFDIH, TOTREDNCO,
     &                                 NEQ, IEQUIV, NATOMS, NCON, IPRNT,
     &                                 EPSILON)
               CALL IPUTREC(20,'JOBARC','PLSMINSP',TOTREDNCO,NCON)
            ELSE
               CALL IZERO(NCON,TOTREDNCO)
               CALL IZERO(NEQ, TOTREDNCO)
               DO IREDNCO = 1, TOTREDNCO
                  I_UNIQUE(IREDNCO) = .TRUE.
               ENDDO
            ENDIF
            CALL IPUTREC(20,'JOBARC','PLSMINSP',TOTREDNCO,NCON) 
            CALL IPUTREC(20, 'JOBARC', 'UNIQUEDF', TOTREDNCO, 
     &                  I_UNIQUE)
C
         ELSE
C
            CALL IGETREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)
            CALL IGETREC(20, 'JOBARC', 'CONTEVIT', 4*TOTREDNCO, 
     &                  IREDUNCO)
            CALL IGETREC(20, 'JOBARC', 'TNUMOBND', 1, TOTNOFBND)
            CALL IGETREC(20, 'JOBARC', 'TNUMOANG', 1, TOTNOFANG)
            CALL IGETREC(20, 'JOBARC', 'TNUMODIH', 1, TOTNOFDIH)
C
            CALL BUILT_BGMTRX(Q, REDUNCO, IREDUNCO, TOTREDNCO,
     &                        TOTNOFBND, TOTNOFANG, TOTNOFDIH,
     &                        NATOMS,dRICHeap(z_BMat),dRICHeap(z_GMat),
     &                        EIGVECTORS,EPSILON,dRICHeap(z_BTGInv),
     &                        dRICHeap(z_DerBMat))
         ENDIF
C
C At this point, we need to update the /COORD/, /CBCHR/ common blocks  
C so that a geometry optimization can proceed with using the standard
C code. 
C  
         LENGTH_BGMAT = TOTREDNCO*NATOMS*3
         CALL DPUTREC(20,'JOBARC', 'BMATRIXT', LENGTH_BGMAT,
     &               dRICHeap(z_BMat))
         CALL DPUTREC(20,'JOBARC', 'GMATRIX ', LENGTH_BGMAT,
     &               dRICHeap(z_GMat))
C
C Copy the intial values of the RIC to R array. Before that we need 
C mark the plus-minus pairs.
C        
         IF (IFLAGS(h_IFLAGS_symmetry).EQ. 2) THEN
            CALL IGETREC(20,'JOBARC','PLSMINSP',TOTREDNCO,NCON)
            DO ICOORD = 1, TOTREDNCO
               IF (NCON(ICOORD).EQ.1) REDUNCO(ICOORD) = -REDUNCO(ICOORD)
            END DO
         END IF
C
         CALL XDCOPY(TOTREDNCO, REDUNCO, 1, R, 1)
         NXM6 = TOTREDNCO
         NX   = MAX(TOTREDNCO, 3*NATOMS)
C
         IF (.NOT. VERY_FIRST_TIME) RETURN
C
         CALL IZERO(NCON, 3*MXATMS)
C
         NUNIQUE = 0
         NOPT    = 0
C
         DO IVAR = 1, TOTREDNCO
C
            IF (I_UNIQUE(IVAR)) THEN
                NUNIQUE = NUNIQUE + 1
                IUNIQUE(NUNIQUE) = IVAR
            END IF
C
C This is the place where info about constrained optimizations
C are added. At the moment all the unique coordinates are 
C optimized. Constrained optimizations are added (11/2012). The
C constrined RIC optimizations are handlled by projectors to maintain
C that there are no displacements along the constrained coordinates.
C As a result even for constrained optimizations, there is no 
C difference between total number of coordinates and the ones that
C are optimized, Ajith Perera, 12/2012.
C
            UNCONSTRAINED  = .TRUE.  
            IF (UNCONSTRAINED) THEN
               IF (I_UNIQUE(IVAR)) THEN
                  NOPT         = NOPT  + 1
                  VARNAM(IVAR) = INTLABEL(IVAR)
                  PARNAM(NOPT) = INTLABEL(IVAR)
                  NOPTI(NOPT)  = IVAR 
               ELSE
                  VARNAM(IVAR) = INTLABEL(IVAR) 
               ENDIF
            ENDIF
C
         END DO 
C
#ifdef _DEBUG_LVLM1
         WRITE(6,"(a,3(1x,I3))") "The number of Degrees of Fre =", 
     &         NOPT, NUNIQUE, TOTREDNCO
#endif
C
         DO I = 1, TOTREDNCO
            ISQUASH(I) = I
         END DO
C 
C We have to rebuilt the NEQ array so that it represents the number
C of symmetry equivalent atoms for given symmetry unique atoms. The
C NEQ that comes out from PROCESS_REDINTRNLS corresponds to the 
C natural order (ordered according to the unique degree of freedoms
C regardless of the atoms involved)
C
         DO ICOORD = 1, TOTREDNCO
            NCON(IUNIQUE(ICOORD)) = NEQ(ICOORD)
         ENDDO
C
         CALL IZERO(NEQ, TOTREDNCO)
         CALL ICOPY(TOTREDNCO, NCON, 1, NEQ, 1)
C
#ifdef _DEBUG_LVLM1
         WRITE(6,*) "@FETCHZ the NEQ"
         WRITE(6,"(5I3,I)") (NCON(IIIK), IIIK = 1, TOTREDNCO),
     &         TOTREDNCO
#endif
         NXM6 = TOTREDNCO
         NX   = MAX(TOTREDNCO, 3*NATOMS)
C 
         GO TO 3431
C
C Endif for GEOM_OPT=RIC
       ENDIF
C
C Endif for COORD=CARTESIAN
      END IF
C
      CALL IZERO(JLIST,3*MXATMS)
      CALL IZERO(JAX,3*MXATMS)
C
      XYZIN   = .FALSE.
      BAD123  = .FALSE.
      IERR    = 0
      RTOA    = 180.0D0/DACOS(-1.0D0)
      NUNIQUE = 0
      NOPT    = 0

c ----------------------------------------------------------------------

c   o open up the main input file
      open(LuZ,FILE=ZFil,STATUS='OLD')
      rewind LuZ

c   o skip the header (zline=TITLE on end do)
      btmp = .true.
      do while (btmp)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         i = izl(1,1)
         btmp = (i.eq.0).or.(zline(i:i).eq.czPercent)
      end do

c   o count the number of elements
      btmp = .true.
      natoms = 0
      do while (btmp)
         read(luz,'(a)') zline
         if (linblnk(zline).eq.0) then
            btmp = .false.
         else
            natoms = natoms + 1
         end if
         if (natoms.gt.mxatms) then
            write(*,*)
            write(*,*) '@FETCHZ: The number of atoms has exceeded the ',
     &                 'maximum allowed of ',mxatms
            write(*,*)
            call errex
         end if
      end do
      if (printi)
     &   write(*,'(a,i3,a)') ' ',natoms,' entries found in Z-matrix '

c     set number of coordinates based on number of elements found in Z-matrix
      NX = 3 * NATOMS

c Create an array that relates TR invariant (squashed) coords to full
c space for use as lookup during compression/decompression.
      ISQUASH(1) = 4
      ISQUASH(2) = 7
      ISQUASH(3) = 8

c Set NXM6 to 3*NATOMS-6 or just 1 if it is a diatomic.
      NXM6 = MAX(NX-6,1)
      DO I = 4,NXM6
         ISQUASH(I) = I+6
      END DO

c ----------------------------------------------------------------------

c Retrieve the Z-matrix:
c     atomic symbols into ZSYM
c     variable names into VARTMP
c     connectivity into NCON
c
c Do this by reading in each line as text and picking it apart using
c the positions of white space determined in PARSEZ.

c   o skip the header (zline=TITLE on end do)
      rewind(luz)
      btmp = .true.
      do while (btmp)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         i = izl(1,1)
         btmp = (i.eq.0).or.(zline(i:i).eq.czPercent)
      end do

c   o save the title
      if (printi) then
         i = linblnk(zline)
         if (i.lt.68) then
            write(LuOut,*)
            write(LuOut,'(2a)') ' Job Title : ', zline(1:i)
            write(LuOut,*)
         else
            write(LuOut,*)
            write(LuOut,'(1a)') ' Job Title : '
            write(LuOut,'(a)') zline(1:i)
            write(LuOut,*)
         end if
      end if
c YAU : old
c      read(zline,'(80a1)') izline
c      call iputrec(1,' ','TITLE',80,izline)
c YAU : new
      call putcrec(1,' ','TITLE',80,zline(1:80))
c YAU : end

c   o first element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,1).eq.0.or.izl(1,2).ne.0) call debug_zmat
      ZSYM(1) = ZLINE(izl(1,1):izl(2,1))
      VARTMP(1) = ' '
      VARTMP(2) = ' '
      VARTMP(3) = ' '
      NCON(1)   = 0
      NCON(2)   = 0
      NCON(3)   = 0
      IF (NATOMS.EQ.1) THEN
         NXM6 = 0
c SB: Fixed output for atomic calculations
         nunique = 0
         nopt = 0
         goto 3441
      END IF

c   o second element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,3).eq.0.or.izl(1,4).ne.0) call debug_zmat
      ZSYM(2)   = ZLINE(izl(1,1):izl(2,1))
      VARTMP(4) = ZLINE(izl(1,3):izl(2,3))
      VARTMP(5) = ' '
      VARTMP(6) = ' '
      NCON(4)   = 1
      NCON(5)   = 0
      NCON(6)   = 0
      IF (NATOMS.EQ.2) GOTO 34

c   o third element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,5).eq.0.or.izl(1,6).ne.0) call debug_zmat
      ZSYM(3)   = ZLINE(izl(1,1):izl(2,1))
      VARTMP(7) = ZLINE(izl(1,3):izl(2,3))
      VARTMP(8) = ZLINE(izl(1,5):izl(2,5))
      VARTMP(9) = ' '
      NCON(7)   = 2
      NCON(8)   = 1
      NCON(9)   = 0

c SET A FLAG IF THIS IS NOT A 2--1--3 Z-MATRIX.
      JUNK   = ATOI( ZLINE(izl(1,2):izl(2,2)) )
      BAD123 = (JUNK.EQ.1)

c Ajith Perera 07/2000
c The extended (to handle MOLCAS integrals) vmol2ja needs to know whether
c the first two atoms have been switched.
      IF (BAD123) CALL IPUTREC(20,'JOBARC','12SWITCH',1,JUNK)

c   o remaining elements
      do i = 4, natoms
         read(luz,'(a)') zline
         if (zline(1:1).eq.czAsterisk) then
            write(*,*)
     &         '@FETCHZ: The Z-matrix was not terminated properly.'
            call errex
         end if
         call parsez(zline,izl)
         if (izl(1,7).eq.0) call debug_zmat
         ZSYM(I)       =       ZLINE(izl(1,1):izl(2,1))
         VARTMP(3*I-2) =       ZLINE(izl(1,3):izl(2,3))
         VARTMP(3*I-1) =       ZLINE(izl(1,5):izl(2,5))
         VARTMP(3*I)   =       ZLINE(izl(1,7):izl(2,7))
         NCON(3*I-2)   = ATOI( ZLINE(izl(1,2):izl(2,2)) )
         NCON(3*I-1)   = ATOI( ZLINE(izl(1,4):izl(2,4)) )
         NCON(3*I)     = ATOI( ZLINE(izl(1,6):izl(2,6)) )
c      o catch basic errors and immediately dump to debug_zmat()
         J = 3*I-2
         IF ( (NCON(J  ).EQ.NCON(J+1)) .OR.
     &        (NCON(J  ).EQ.NCON(J+2)) .OR.
     &        (NCON(J+1).EQ.NCON(J+2))      ) call debug_zmat
         IF ( (NCON(J  ).EQ.0) .OR.
     &        (NCON(J+1).EQ.0) .OR.
     &        (NCON(J+2).EQ.0)      ) call debug_zmat
         IF ( (NCON(J  ).GE.I) .OR.
     &        (NCON(J+1).GE.I) .OR.
     &        (NCON(J+2).GE.I)      ) call debug_zmat
c     end do i = 4, natoms
      end do

c IF CONNECTIVITY OF THE FIRST THREE ATOMS IS 3--1--2. SWITCH
c ATOMS 1 AND 2 AND THEN ALL REFERENCES TO THEM.
   34 CONTINUE
      IF (BAD123) THEN
         CHTEST  = ZSYM(1)
         ZSYM(1) = ZSYM(2)
         ZSYM(2) = CHTEST
         DO J = 9, NX
            ITMP = 0
            IF (NCON(J).EQ.2) ITMP = 1
            IF (NCON(J).EQ.1) ITMP = 2
            IF (ITMP.NE.0)    NCON(J) = ITMP
         END DO
         IF (PRINTI) WRITE(LUOUT,*) '@FETCHZ: The ordering of the ',
     &      'first two atoms in the Z-matrix has been changed.'
      END IF

      IF (PRINTI .AND. IPRNT.GE.2) THEN
         WRITE (LUOUT,*) '@FETCHZ: plain Z-matrix'
         J = 1
         DO I = 1, NAtoms
            WRITE (LUOUT,'(I2,A,1X,A,3(1X,I3,1X,A))')
     &            I,':',ZSYM(I),
     &            NCON(J+0),VARTMP(J+0),
     &            NCON(J+1),VARTMP(J+1),
     &            NCON(J+2),VARTMP(J+2)
            J = J + 3
         END DO
         WRITE (LUOUT,*)
      END IF

c REDUNDANCY CHECKING AND GENERATE VECTORS CONTAINING POSITIONS
c OF COORDINATES TO BE OPTIMIZED AND CORRESPONDING REDUNDANT
c COORDINATES. LISTS USE INTERNAL COORDINATE NUMBERING WHICH
c CORRESPONDS TO THE "SQUASHED" SCHEME (1,2,3,4,... vs 4,7,8 etc)
      CALL IZERO(NEQ,3*MXATMS)
      DO 210 I = 1, NX
         ISQ_I = ISQ(I)
         IF (.NOT.(I.LT.4.OR.I.EQ.5.OR.I.EQ.6.OR.I.EQ.9)) THEN
            IRED = 0
            DO J = 1, I-1
               IF (VARTMP(J).EQ.VARTMP(I)) THEN
                  IRED = 1
                  ISQ_J = ISQ(J)
                  NEQ(ISQ_J) = NEQ(ISQ_J) + 1
                  IEQUIV(JLIST(ISQ_J),NEQ(ISQ_J)) = ISQ_I
               END IF
            END DO
            IF (IRED.LE.0) THEN
               NUNIQUE = NUNIQUE + 1
               IUNIQUE(NUNIQUE) = ISQ_I
               JLIST(ISQ_I) = NUNIQUE
            END IF
C
C CHECKING FOR PARAMETERS TO BE OPTIMIZED
C
            JAX(I) = INDEX(VARTMP(I),czAsterisk)
            VARNAM(I) = VARTMP(I)
            IF (JAX(I).NE.0.OR.iFlags2(h_IFLAGS2_geom_opt).EQ.2) THEN
               IF (JAX(I).NE.0) VARNAM(I) = VARTMP(I)(:JAX(I)-1)
               IF (IRED.EQ.1) GOTO 210
               NOPT = NOPT + 1
               PARNAM(NOPT) = VARNAM(I)
               NOPTI(NOPT) = ISQ_I
            END IF
         END IF
  210 CONTINUE

c   o read the blank line after the Z-matrix
      READ(LUZ,'(A)') ZLINE

c   o load the first structure into R; only when it loads the
c   o first structure, it will check whether the same varible 
c   o name is being used multiple times; Ajith Perera, 12/2012.

      call rd_intcoord(R, .True.)
#ifdef _DEBUG_LVL0
      Write(6,"(a)") " The Current structure "
      Write(6,"(6(1x,F12.6))") (r(i),i=1,nx)
#endif
c   o read additional structures until we hit a namelist
c     (iStruct corresponds to the structure we expect to read)
      iStruct = 1
      bStruct = .true.
      do while (bStruct.and.iStruct.lt.3)
         iStruct = iStruct + 1
         read(luz,'(a)') zline
         If (.Not. ((zline(1:2) .EQ. "Pr") .or. 
     &             (zline(1:2) .EQ. "Re"))) backspace(luz)
C--The additional line is to give a label to the reactants
         read(luz,'(a)') zline
         backspace(luz)
         ISTP = INDEX(zline(1:),'=')
         I    = INDEX(zline(1:),'*')
         bStruct = ((i.eq.0).and.(istp.ne.0))
         if (bStruct) then
            call rd_intcoord(rtmp, .False.)
            if (iStruct.eq.2) then
c            o read the next line and see if this structure was the TS or PR
C--The additional lines (read and backspace) are to give a label to the
C  product structures. 
               read(luz,'(a)') zline
               read(luz,'(a)') zline
               backspace(luz)
               backspace(luz)
               ISTP = INDEX(zline(1:),'=')
               I    = INDEX(zline(1:),'*')
               btmp = ((i.ne.0).or.(istp.eq.0))
            else
               btmp = .true.
            end if
            if (btmp) then

               If ( iStruct.eq.2) Then
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Creating RXSTRUCT jobarc record"
      Write(6,"(6(1x,F12.6))") (rtmp(i),i=1,nx)
#endif      
                  call dputrec(1,'JOBARC','RXSTRUCT',nx,rtmp)
               Else
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Creating PRSTRUCT jobarc record"
      Write(6,"(6(1x,F12.6))") (rtmp(i),i=1,nx)
      Write(6,*) Istruct
#endif
                  call dputrec(1,'JOBARC','PRSTRUCT',nx,rtmp)
               Endif 
            else
c            o move R to RXSTRUCT since we are optimizing the TS structure
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Creating RXSTRUCT jobarc record"
      Write(6,"(6(1x,F12.6))") (rtmp(i),i=1,nx)
#endif
               call dputrec(1,'JOBARC','RXSTRUCT',nx,Rtmp)
C
C R contains the first block of coordinates which is the approx. TS
C structure (better designation must be current structure).
c Commented 12/2012, Ajith Perera
CSSS               call dcopy(nx,rtmp,1,R,1)
            end if
c        end if (bStruct)
         end if
c     end do while (bStruct)
      end do

 3441 continue

      If (IFLAGS2(h_IFLAGS2_opt_control) .EQ. 1) 
     &    Call Gen_curr_coords(Rtmp, Ptmp, R, Nx, .FALSE.)
 

C WRITE OUT RELEVANT INFORMATION
      IF (PRINTI.AND. ncycle.EQ.0) THEN
         WRITE(LUOUT,*)
     &      ' There are ',NUNIQUE,' unique internal coordinates.'
         WRITE(LUOUT,*)
     &      ' Of these, ',NOPT ,' will be optimized.'
      END IF
      IF (IPRNT.GE.2.AND.PRINTI) THEN
         DO I = 1, NOPT
            WRITE(LUOUT,*) ' Parameter #',I,' to be optimized is ',
     &         PARNAM(I)
         END DO
      END IF

C PRINT OUT Z-MATRIX SO THAT USER CAN RECONSTRUCT LATER IF NEED BE.
      IF (IPRNT.GE.0.AND.PRINTI) THEN
         WRITE(LUOUT,1001)
 1001    FORMAT(T3,' User supplied Z-matrix: ',/,80('-'),/
     &          T8,'SYMBOL',T18,'BOND',
     &          T28,'LENGTH',T38,'ANGLE',T48,'ANGLE',T58,'DIHED',T68,
     &              'ANGLE',/,
     &          T18,' TO ',T27,'(ANGST)',T37,' WRT ',T47,'(DEG)',T57,
     &              ' WRT ',
     &          T67,'(DEG)',/,80('-'))
         WRITE(LUOUT,734) ZSYM(1)
c SB fixed output for atomic and diatomic calculations
         if (natoms.gt.1) WRITE(LUOUT,734) ZSYM(2),NCON(4),VARNAM(4)
         if (natoms.gt.2) WRITE(LUOUT,734) ZSYM(3),NCON(7),VARNAM(7),
     &                                     NCON(8),VARNAM(8)
         DO I = 4, NATOMS
            IT3 = 3 * I
                          WRITE(LUOUT,734) ZSYM(I),
     &                       (NCON(IT3-J),VARNAM(IT3-J),J=2,0,-1)
         END DO
  734    FORMAT(T9,A,T19,I2,T30,A,T40,I2,T50,A,T60,I2,T70,A)
         if (nunique.gt.0) then
            WRITE(LUOUT,1000)
 1000       FORMAT(T18,' *Initial values for current coordinates* ',/,
     &             T23,'Name',t40,'Value')
 1002       FORMAT(T18,' *Initial values for reactant coordinates* ',/,
     &             T23,'Name',t40,'Value')
 1003       FORMAT(T18,' *Initial values for product  coordinates* ',/,
     &             T23,'Name',t40,'Value')
            DO I = 1, NUNIQUE
               WRITE(LUOUT,'(T25,A,T38,F11.6)')
     &            VARNAM(ISQUASH(IUNIQUE(I))),R(ISQUASH(IUNIQUE(I)))
            END DO
c         o reactant
            call igetrec(0,'JOBARC','RXSTRUCT',J,rtmp)
            if (j.gt.0) then
               call igetrec(1,'JOBARC','RXSTRUCT',J,rtmp)
               write(luout,1002)
               DO I = 1, NUNIQUE
                  WRITE(LUOUT,'(T25,A,T38,F11.6)')
     &               VARNAM(ISQUASH(IUNIQUE(I))),
     &               RTMP(ISQUASH(IUNIQUE(I)))
               END DO
            end if
c         o product
            call igetrec(0,'JOBARC','PRSTRUCT',J,rtmp)
            if (j.gt.0) then
               call igetrec(1,'JOBARC','PRSTRUCT',J,rtmp)
               write(luout,1003)
               DO I = 1, NUNIQUE
                  WRITE(LUOUT,'(T25,A,T38,F11.6)')
     &               VARNAM(ISQUASH(IUNIQUE(I))),
     &               RTMP(ISQUASH(IUNIQUE(I)))
               END DO
            end if
         END IF
         WRITE(LUOUT,735)
 735  FORMAT(80('-'))
      END IF

c ----------------------------------------------------------------------

cSSS 3431 continue
C
C GET ATOMIC MASSES, ATOMIC NUMBERS FROM PERIODIC TABLE SUBROUTINE
C
      CALL IPUTREC(20, 'JOBARC', 'CONCTVTY', 3*NATOMS, NCON)
      CALL IPUTREC(20, 'JOBARC', 'ICSQUASH', 3*NATOMS, ISQUASH)
      CALL PUTCREC(20, 'JOBARC', 'INTCNAM', 15*NATOMS, VARNAM)

      Call IGETREC(20,  'JOBARC', 'HAVEGEOM', 1, I_havegeom)
      Call IGETREC(0, 'JOBARC', 'PASS1   ', Length, Itmp)
      Write_as_read = (Length .LT. 0)
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Print*, "Write_as_read from FETCHZ:", Write_as_read 
      Print*, "Internal coordinates in FETCHZ"
      Write(6, "(3F10.5)"),  (R(I), I=1, 3*NATOMS)
#endif
      Call Angs2bohr(R, 3*NATOMS)
      If (Write_as_read) CALL DPUTREC(20, 'JOBARC', 'CORD_INT', 
     &                               3*NATOMS, R)
      Call Bohr2Angs(R, 3*NATOMS)  
C
      CALL PERTABLE
C
 3431 continue
C
C FOR FINDIF CALCULATIONS, READ IN NEW CARTESIAN COORDINATES AND
C TRANSFORM THESE BACK INTO MODIFIED INTERNALS
C 
      IONE = 1
      CALL IGETREC(-1,'JOBARC','PASS1   ',IONE,INWFND)
      IF (INWFND.EQ.1) THEN
         XYZIN = .TRUE.
         IFLAGS(68) = 1
         CALL DGETREC(20,'JOBARC','NEXTGEOM',3*NATOMS,Q)
      END IF

C COUNT NUMBER OF REAL ATOMS
C Also add a record that contains the sum of both real and dummy atoms.
C This is needed for external programs that use ACES II JOBARC records
C most of which are based on the total number of atoms, not just the
C number of real atoms. 01/2006, Ajith Perera.
C
      CALL IPUTREC(20,'JOBARC','ZMATATMS',IONE,NATOMS)
      NREAL = 0
      DO IATOM = 1, NATOMS
         IF (ATMASS(IATOM).NE.ZILCH) NREAL = NREAL + 1
      END DO
      CALL IPUTREC(20,'JOBARC','NREALATM',IONE,NREAL)

      RETURN
      END

      SUBROUTINE STPTR(N,NORD1,NORD2,IPTR)
C
C ROUTINE TO CONSTRUCT POINTER LIST FOR FINITE DIFFERENCE CALCULATIONS.
C  IPTR(I)=J MEANS THAT THE SYMMETRY OPERATION MAPS ATOM I INTO ATOM J.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION NORD1(N),NORD2(N),IPTR(N)
      DO 10 I=1,N
       J=NORD1(I)
       K=NORD2(I)
       IPTR(J)=K
10    CONTINUE
      RETURN
      END

C FINDS A LABEL IN A VMOL INTEGRAL FILE AND POSITIONS POINTER
C TO FIRST RECORD AFTER THE LABEL.

      SUBROUTINE LOCATE(IUNIT,LABELS)
      IMPLICIT INTEGER (A-Z)
      CHARACTER*8 LAB,LABELS,LABEL
      LABEL = LABELS
      REWIND(IUNIT)
1     READ(IUNIT,END=100,ERR=110) LAB
      IF (LAB(1:2).NE.'**') GOTO 1
      READ(IUNIT,END=100) LAB
      IF (LAB.EQ.LABEL) RETURN
      GOTO 1
100   WRITE(*,1000) LABEL, IUNIT
      CALL ERREX
      RETURN
1000  FORMAT(T3,'@LOCATE: Label ',A8,' not found on unit ',I3,'.')
110   WRITE(*,1100) IUNIT, LABEL
1100  FORMAT(T3,'@LOCATE: I/O error on unit ',i3,' looking for ',
     &          'label ',A8,'.')
      CALL ERREX
      RETURN
      END

      SUBROUTINE DUMPPERT(VALUE,N,POLAR,DDP,FCM,JFC,JSD,NGEOM,
     &                    ICORE,DOPOL,DODDP,DOFCM,DOJFC,DOJSD,
     &                    ITRANS,IMAP,NUCIND)
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DIRPRD
      DOUBLE PRECISION JFC,JSD
      LOGICAL DOPOL,DODDP,DOFCM,DOJFC,DOJSD,TRAINV
C
      DIMENSION VALUE(N,N),POLAR(3,3),DDP(3,NGEOM),
     &          FCM(NGEOM,NGEOM),JFC(NGEOM,NGEOM),
     &          JSD(NGEOM,NGEOM),ICORE(1),IMAP(1),ITRANS(1) 
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYMINF/NSTART,NIRREP,IRREPA(255,2),DIRPRD(8,8)
      COMMON/PERT1/STERM,NSP
      COMMON/PERT2/NTP,NTPERT(8),NSPERT(8),IPERT(8)
      COMMON/PERT3/IXYZSYM(3) 
      COMMON/INVAR/TRAINV
C
C  LOOP OVER ALL IRREPS
C
      IF(DOFCM) CALL IZERO(FCM,NGEOM*NGEOM*IINTFP)
      IF(DODDP) CALL IZERO(DDP,3*NGEOM*IINTFP)
      IF(DOPOL) CALL IZERO(POLAR,9*IINTFP)
      IF(DOJFC) CALL IZERO(JFC,NGEOM*NGEOM*IINTFP)
      IF(DOJSD) CALL IZERO(JSD,NGEOM*NGEOM*IINTFP)
      IOFFF=0
      IOFFG=0
C
      DO 1000 IRREP=1,NIRREP
C
       NT=NTPERT(IRREP)
       NS=NSPERT(IRREP)
       IOFF=IPERT(IRREP)
C
       IF(DOFCM) THEN
C
        DO 100 IPERT1=1,NS
C
         JPERT1=IPERT1+IOFF
         KPERT1=IMAP(IPERT1+IOFFG)
C
         DO 100 IPERT2=1,NS
C
          JPERT2=IPERT2+IOFF
          KPERT2=IMAP(IPERT2+IOFFG)
C
          FCM(KPERT1,KPERT2)=VALUE(JPERT1,JPERT2)
C
100     CONTINUE
C
       ENDIF
C
       IF(DODDP) THEN
C
        DO 200 IPERT1=1,NS
C
         JPERT1=IPERT1+IOFF
         KPERT1=IMAP(IPERT1+IOFFG)
 
         DO 200 IPERT2=NS+1,NT
C
          JPERT2=IPERT2+IOFF
          KPERT2=IXYZSYM(IPERT2-NS+IOFFF)
C
          DDP(KPERT2,KPERT1)=VALUE(JPERT2,JPERT1)
C
200     CONTINUE
C
       ENDIF
C
       IF(DOPOL) THEN
C
        DO 300 IPERT1=NS+1,NT
C
         JPERT1=IPERT1+IOFF
         KPERT1=IXYZSYM(IPERT1-NS+IOFFF)
C
         DO 300 IPERT2=NS+1,NT
C
          JPERT2=IPERT2+IOFF
          KPERT2=IXYZSYM(IPERT2-NS+IOFFF)
C
          POLAR(KPERT1,KPERT2)=-VALUE(JPERT1,JPERT2)
C
300     CONTINUE
C
       ENDIF
C
       IF(DOJFC) THEN
C
        DO 400 IPERT1=1,NT
C
         JPERT1=IOFF+IPERT1
C
         DO 400 IPERT2=1,NT
C
          JPERT2=IOFF+IPERT2
C
          JFC(JPERT1,JPERT2)=VALUE(JPERT1,JPERT2)
C
400     CONTINUE
C
       ENDIF
C
       IF(DOJSD) THEN
C
        DO 500 IPERT1=1,NT
C
         JPERT1=IOFF+IPERT1
C
         DO 500 IPERT2=1,NT
C
          JPERT2=IOFF+IPERT2
C
          JSD(JPERT1,JPERT2)=VALUE(JPERT1,JPERT2)
C
500     CONTINUE
C
       ENDIF
C
       IOFFG=IOFFG+NS
       IOFFF=IOFFF+NT-NS
C
1000  CONTINUE
C
      IF(DOFCM) THEN
C
C UPDATE FCM FILE
C
       IF(TRAINV) THEN
C
C USE TRANSLATIONAL INVARIANCE TO CREATE FULL FCM CONTRIBUTION
C
        CALL EXPFCM(FCM,NGEOM,ITRANS,NUCIND)
C
        IOFFG=IOFFG+3
C
       ENDIF
C
       ISCR1=1+IOFFG*IOFFG*IINTFP
       ISCR2=ISCR1+IOFFG*IOFFG*IINTFP
       CALL UPFCM(FCM,ICORE,ICORE(ISCR1),ICORE(ISCR2),IOFFG,NIRREP,
     &            .TRUE.)
C
      ENDIF
C
      IF(DODDP) THEN
C
C UPDATE DIPDER FILE
C
       IF(TRAINV) THEN
C
C CREATE FULL DIPDER CONTRIBUTION USING TRANSLATIONAL INVARIANCE
C
        CALL EXPDDP(DDP,NGEOM,ITRANS,NUCIND)
C
       ENDIF
C
       ISCR1=1+IINTFP*3*IOFFG
       CALL UPDDP(DDP,ICORE,ICORE(ISCR1),IOFFG,NIRREP,.TRUE.)
C
      ENDIF 
C
      IF(DOPOL) THEN
C
C UPDATE POLARISABILITY FILE
C
       CALL UPPOL(POLAR,ICORE,.TRUE.)
C
      ENDIF
C
      IF(DOJFC) THEN
C
       IOFFG=NGEOM
       IJFC2=1
       IJFC3=IJFC2+IINTFP*9*IOFFG*IOFFG
       ISCR1=1+9*IOFFG*IOFFG*IINTFP
       ISCR2=ISCR1+9*IOFFG*IOFFG*IINTFP
       CALL UPJFC(JFC,ICORE(IJFC2),ICORE(IJFC3),ICORE(ISCR1),
     &            ICORE(ISCR2),IOFFG,NIRREP,.TRUE.)
C
      ENDIF
C
      IF(DOJSD) THEN
C
       IOFFG=NGEOM
       IJSD2=1
       IJSD3=IJSD2+IINTFP*IOFFG*IOFFG
       ISCR1=1+9*IOFFG*IOFFG*IINTFP
       ISCR2=ISCR1+9*IOFFG*IOFFG*IINTFP
       CALL UPJSD(JSD,ICORE(IJSD2),ICORE(IJSD3),ICORE(ISCR1),
     &            ICORE(ISCR2),IOFFG,NIRREP,.TRUE.)
C
      ENDIF
C
      RETURN
      END

C EXIT HANDLER FOR CRAPS. THIS ROUTINE IS INCLUDED SO THAT ALL
C ERROR EXITS WILL GO THROUGH THE SAME END POINT, WHICH MAY
C BE USEFUL LATER.

      SUBROUTINE ERREX
#ifdef _UNICOS
      CALL TRBK
      CALL ERREXIT
#endif /* _UNICOS */
      CALL EXIT(1)
      RETURN
      END

C THIS ROUTINE COPIES AN NROWFRM BY NCOLFRM BLOCK MATRIX (MATFRM)
C INTO AN NROWTAR BY NCOLTAR TARGET MATRIX (MATTAR) SUCH THAT 
C THE (1,1) ELEMENT IN MATFRM BECOMES THE IROWTAR,ICOLTAR ELEMENT 
C IN MATTAR.

      SUBROUTINE BLKCPY(MATFRM,NROWFRM,NCOLFRM,MATTAR,NROWTAR,NCOLTAR,
     &                  IROWTAR,ICOLTAR)
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION MATTAR(NROWTAR*NCOLTAR),MATFRM(NROWFRM,NCOLFRM)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      if (ncolfrm.lt.0) then
         print *, '@BLKCPY: Assertion failed.'
         print *, '         ncolfrm = ',ncolfrm
         call errex
      end if

      ISTART = IROWTAR + (ICOLTAR-1)*NROWTAR
      DO ICOL = 1, NCOLFRM
         CALL XCOPY(NROWFRM,MATFRM(1,ICOL),1,MATTAR(ISTART),1)
         ISTART = ISTART + NROWTAR
      END DO
      RETURN
      END

c This routine returns the index of the first non-blank character in sz.




       integer function fnblnk(sz)
       implicit none

       character*(*) sz
       character*1 achar, czSpace, czTab
       integer i, length

       length = len(sz)
       if (length.ne.0) then

          czSpace = achar(32)
          czTab   = achar(9)

          do i = 1, length
c          o return at the first non-blank character
             if ((sz(i:i).ne.czSpace).and.
     &           (sz(i:i).ne.czTab  )     ) then
                fnblnk = i
                return
             end if
          end do

       end if

       fnblnk = 0
       return
       end

      Subroutine Qcomp_38D_odd(Qnl, Nlq, Ltot, Talpha)
C              
      Implicit Double Precision(A-H, O-Z)
C
#include "ecp.par"            
#include "ecp.com"            
C
      Dimension Qnl(0:2*Maxang, 0:2*Maxang)
C 
C Using 38D of MD paper (Note the error in MD paper)
C              
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,*) "The Qnl at entry to Qcomp_38D_odd"
      Do i=0, 2*Maxang     
         Write(6,"(4(1x,F10.7))") (Qnl(j,I), j=0, 2*Maxang)
      Enddo    
      Write(6,*)
#endif
         
      If (Nlq .EQ. 1) Then
         
         Lmax = Ltot
         Do NN = 0, Ltot-2, 2
            Lmax = Lmax - 2
            
            Do L = 0, Lmax
                
	    N = L + 2 + NN
                NLM = N + Nlq + L - 1
#ifdef _DEBUG_LVLM1
		Write(6,"(a,3(1x,i3),2(1x,F10.6))") 
     &                "in Qcomp_38D-0", N, L, NLM, Qnl(N-2,L),
     &                 Qnl(N-1,L+1)
#endif
                Qnl(N,L) = ((NLM)*Qnl(N-2,L) + Beta*Qnl(N-1,L+1))/
     &                       Talpha
            
            Enddo
         Enddo

      Else

         NP_Lo = Mod(Nlq-3,2) + 4
         NP_Hi = Nlq + 1
         Ifac  = 2
#ifdef _DEBUG_LVLM1         
        Write(6,"(a,3(1x,i3),2(1x,F10.6))") 
     &       "in Qcomp 38D NP_LO,HI,LTOT", NP_LO, NP_hi, ltot
#endif

         Do NP_D = NP_Lo, NP_hi, 2
            Do LL = 2, Ltot+1
C     
C N = LL (Note that what we are doing here is (Qnl(0+2+2..) where
C Qnl(0+2) is stored in Qnl(0,0)
C
               N = LL - 2
               L = LL - 2 
               NLM = N + L + Ifac

#ifdef _DEBUG_LVLM1
               Write(6,"(a,3(1x,i3),2(1x,F10.6))") 
     &               "In Qcomp_38D-1", N, L, NLM, Qnl(N,L),
     &                Qnl(N+1,L+1)
#endif

               Qnl(N,L) = (NLM*Qnl(N,L) + Beta*Qnl(N+1,L+1))/Talpha

            Enddo

C N = Ltot + 1
               N = Ltot
               L = Ltot
               NLM = Ifac - 1
#ifdef _DEBUG_LVLM1

               Write(6,"(a,3(1x,i3),2(1x,F10.6))") 
     &               "In Qcomp_38D-2", N, L, NLM, Qnl(N,L),
     &                Qnl(N-1,L-1)
#endif
               Qnl(N,L) = (NLM*Qnl(N,L) + Beta*Qnl(N-1,L-1))/Talpha
               Ifac = Ifac + 2
         Enddo

         Lmax = Ltot
         Do NN = 0, Ltot-2, 2
            Lmax = Lmax - 2

            Do L = 0, Lmax

                N = L + 2 + NN
                NLM = N + Nlq + L - 1
#ifdef _DEBUG_LVLM1
                Write(6,"(a,3(1x,i3),2(1x,F10.6))") 
     &                "in Qcomp_38D-3", N, L, NLM, Qnl(N-2,L),
     &                  Qnl(N-1,L+1)
#endif
                Qnl(N,L) = ((NLM)*Qnl(N-2,L) + Beta*Qnl(N-1,L+1))/
     &                       Talpha

            Enddo
         Enddo

C
      Endif

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE REMOVE_360(DQ, TOTNOFBND, TOTNOFANG, TOTREDUNCO)
   
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      INTEGER TOTNOFBND, TOTNOFANG, TOTREDUNCO 
      DIMENSION DQ(TOTREDUNCO)
C
      TWOPI = (ATAN(DFLOAT(1))*DFLOAT(8))
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0
C
#ifdef _DEBUG_LVL0
      Print*, "The Two Phi, TOTNFBND, TOTNOFANG, TOTREDUNCO: ",
     &         TwOPI/DINVPI, TOTNOFBND, TOTNOFANG, TOTREDUNCO
      Write(6,*)
      Write(6,*) "Angles @Entry:"
      Write(6,*)
      Write(6,10) (DQ(I)/DINVPI, I = (TOTNOFBND + 1), TOTREDUNCO)
   10 Format (5(1X,F10.6))
#endif
C
      DO IANG = TOTNOFANG+TOTNOFBND+1, TOTREDUNCO
C
            IF (DQ(IANG) .GE. TWOPI/2.0D0) THEN
                DQ(IANG) = DQ(IANG) - TWOPI
            ELSE IF (DQ(IANG) .LE. (-TWOPI/2.0D0)) THEN
                DQ(IANG) = DQ(IANG) + TWOPI
            ENDIF
C
      ENDDO
C
#ifdef _DEBUG_LVL0
      Print*, "The angles: @Exist"
      Write(6,*)
      Write(6,10) (DQ(I)/DINVPI, I = (TOTNOFBND + 1), TOTREDUNCO)
#endif
C
      RETURN
      END

      SUBROUTINE BUILT_BGMTRX(CARTCOORD, REDUNCO, IREDUNCO,
     &                        TOTREDNCO, TOTNOFBND, TOTNOFANG,
     &                        TOTNOFDIH, NRATMS, 
     &                        BMATRX, GMATRX, EIGVECTORS,
     &                        EPSILON, BTGMIN, DERBMAT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "mxatms.par"
#include "io_units.par"
#include "flags.h" /* for h_IFLAGS_* and h_IFLAGS2_* */
#include "jodaflags.com"
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH
      LOGICAL TS_SEARCH, MN_SEARCH_EXACT_HESS, CMP_DBMAT
C
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C 
C BTMP : used as temp storage of size 9*MXATMS*MXATMS need
C        to be dynamically allocated and discarded.
      DIMENSION CARTCOORD(3*NRATMS), IREDUNCO(4, MAXREDUNCO),
     &          BMATRX(TOTREDNCO, 3*NRATMS), 
     &          BTMP(3*MXATMS, 3*MXATMS), 
     &          GMATRX(TOTREDNCO, 3*NRATMS),
     &          EIGVECTORS(TOTREDNCO, TOTREDNCO),
     &          REDUNCO(TOTREDNCO)
      DIMENSION DERBMAT(3*NRATMS,3*NRATMS*TOTREDNCO),
     &          BTGMIN(3*NRATMS,TOTREDNCO)
         
      DATA MONE /-1.0/
C  
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0
      CALL ZERO(BMATRX, TOTREDNCO*(3*NRATMS))
      CALL ZERO(DERBMAT,9*NRATMS*NRATMS*TOTREDNCO)
C
      CMP_DBMAT = (IFLAGS2(h_IFLAGS2_init_hessian) .GT. 0) .OR.
     &            (IFLAGS2(h_IFLAGS_eval_hess)    .gt. 0)
C
      DO 20 IBNDS = 1, TOTNOFBND
C
         IF (IREDUNCO(2, IBNDS) .NE. 0) THEN  
C
            CALL  BULT_BNDCRD(CARTCOORD, BMATRX, DISTAB,
     &                        IREDUNCO(1, IBNDS), IREDUNCO(2, IBNDS),
     &                        IBNDS, TOTREDNCO, NRATMS)
            IF (CMP_DBMAT) CALL DBND(CARTCOORD, IREDUNCO(1,IBNDS),
     &                               IREDUNCO(2,IBNDS), IBNDS,
     &                               MAXREDUNCO, NRATMS, DERBMAT,
     &                               IREDUNCO, TOTREDNCO)
            REDUNCO(IBNDS) = DISTAB
C
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The bond distance =",DISTAB*0.529177249d0
#endif                        
C
         ENDIF
C
 20   CONTINUE
C
      DO IANGS = (TOTNOFBND + 1), (TOTNOFANG + TOTNOFBND)

         IF (IREDUNCO(4, IANGS) .EQ. MONE) THEN
C
C This is for the linear arrangements. 
C
            CALL  BULT_LANGCRD(CARTCOORD, BMATRX, ANGL,
     &                         IREDUNCO(1, IANGS), IREDUNCO(2, IANGS),
     &                         IREDUNCO(3, IANGS), IREDUNCO(4, IANGS), 
     &                         IANGS, NRATMS, TOTREDNCO, EPSILON)
            REDUNCO(IANGS) = ANGL
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The bond Angle =", ANGL/DINVPI
#endif
C
C The Derivative of B matrix is zero for the angle 0.0 and 180.00
CSSS            IF (CMP_DBMAT) CALL DEANG(CARTCOORD, IREDUNCO(1,IANGS),
CSSS     &                                IREDUNCO(2,IANGS),
CSSS     &                                IREDUNCO(3,IANGS), BMATRX, NRATMS,
CSSS     &                                TOTREDNCO, IREDUNCO, MAXREDUNCO,
CSSS     &                                IANGS, DERBMAT)
C
         ELSE
C
C This is for the non-linear arrangements. 
C
            CALL  BULT_ANGCRD(CARTCOORD, BMATRX, ANGL,
     &                       IREDUNCO(1, IANGS), IREDUNCO(2, IANGS),
     &                       IREDUNCO(3, IANGS), IANGS, TOTREDNCO,
     &                       NRATMS)
            REDUNCO(IANGS) = ANGL
C
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The Bond Angle =", ANGL/DINVPI
#endif
            IF (CMP_DBMAT .AND. ANGL/DINVPI .LE. 175.0D0)
     &                     CALL DEANG(CARTCOORD, IREDUNCO(1,IANGS),     
     &                                IREDUNCO(2,IANGS),
     &                                IREDUNCO(3,IANGS), BMATRX, 
     &                                NRATMS, TOTREDNCO, IREDUNCO, 
     &                                MAXREDUNCO, IANGS, DERBMAT)
         ENDIF
C
      ENDDO
C
 30   CONTINUE
C
#ifdef _DEBUG_LVL0
            WRITE(6,*) "Entering the dihedral angle block"
#endif 
  
      DO 40 IDIHS = (TOTNOFANG + TOTNOFBND + 1),  TOTREDNCO
C
         CALL  BULT_DIHANGCRD(CARTCOORD, BMATRX, DANG,
     &                        IREDUNCO(1, IDIHS), IREDUNCO(2, IDIHS),
     &                        IREDUNCO(3, IDIHS), IREDUNCO(4, IDIHS),
     &                        IDIHS, TOTREDNCO, NRATMS)
         IF (CMP_DBMAT) CALL DDIH(CARTCOORD,
     &                            IREDUNCO(1,IDIHS), IREDUNCO(2,IDIHS),
     &                            IREDUNCO(3,IDIHS), IREDUNCO(4,IDIHS),
     &                            IDIHS, TOTREDNCO, NRATMS, IREDUNCO,
     &                            MAXREDUNCO, DERBMAT)
            REDUNCO(IDIHS) = DANG
C
#ifdef _DEBUG_LVL0
            WRITE(6,"(a,F10.5)") "The Dihedral Angle =", DANG/DINVPI
#endif
C    
 40   CONTINUE
C
C Let's write the DERBMAT to JOBARC
CSSS      PRINT *,'DERBMAT IN BUILT_DERBMAT'
CSSS      CALL OUTPUT(DERBMAT,1,3*NRATMS,1,3*NRATMS*TOTREDNCO,
CSSS     &            3*NRATMS,3*NRATMS*TOTREDNCO,1)
      IF (CMP_DBMAT) THEN
         LENGTH_DERBMAT = 9*NRATMS*NRATMS*TOTREDNCO
         CALL DPUTREC(1,'JOBARC','DERBMAT',LENGTH_DERBMAT,DERBMAT)
      END IF
C
C Let's write the B-matrix to the JOBARC file. 
C
cSSS     CALL DPUTREC(20,'JOBARC', 'BMATRIX ',TOTREDNCO, BMATRX)
C
C Form the G matrix which is required to transfrom the gradient
C from the Cartesian coordinates to redundent internal coordinates.   
C The procedures that are followed here is exactly what is described
C in Pulay et al., 96, 2856, 1992 and Peng et al., 17, 49. 1996.
C Built G = BuB(t) where u is an arbitrary nonsingular matrix, usually
C the unit matrix. The notations are consistent with Pulay et al.
C paper.
C
#ifdef _DEBUG_LVL0
      Write(6,*) "B-Matrix"
      CALL OUTPUT(BMATRX, 1, TOTREDNCO, 1, 3*NRATMS, TOTREDNCO,
     &            3*NRATMS, 1)    
#endif
C
      CALL DCOPY(3*NRATMS*TOTREDNCO, BMATRX, 1, BTMP, 1)
C
      CALL XGEMM('N', 'T', TOTREDNCO, TOTREDNCO, 3*NRATMS, 1.0D0,
     &           BMATRX, TOTREDNCO, BTMP, TOTREDNCO, 0.0D0, GMATRX,
     &           TOTREDNCO)
C
CSSS      Print*, "The G-Matrix:BB^t", MXATMS, MAXREDUNCO
CSSS      CALL OUTPUT(GMATRX, 1, TOTREDNCO, 1, TOTREDNCO, TOTREDNCO,
CSSS     &            TOTREDNCO, 1)
      LENGMAT=TOTREDNCO*TOTREDNCO
      CALL DPUTREC(20,'JOBARC','G-MATRX ',LENGMAT,GMATRX)
C---DEBUG
cSSS      CALL ZERO(BMATRX, 3*NRATMS*TOTREDNCO)
cSSS      CALL DCOPY(TOTREDNCO*TOTREDNCO, GMATRX, 1, BMATRX, 1)
C---DEBUG
C
C The intermediate G matrix created above is linear dependent, hence
C there are eigenvalues that are zero. Invert the non-zero digonal
C elements to built the Lambda(-1) matrix.
C
      CALL EIG(GMATRX, EIGVECTORS, 1, TOTREDNCO , 1)
C 
CSSS      Print*, "The Eigenvalues of G-Matrix"
CSSS      CALL OUTPUT(GMATRX, 1, TOTREDNCO, 1, TOTREDNCO, TOTREDNCO,
CSSS     &            TOTREDNCO, 1)
CSSS      Print*, "The Eigenvectors of G-Matrix"
CSSS      CALL OUTPUT(EIGVECTORS, 1, TOTREDNCO, 1, TOTREDNCO, 
CSSS     &            TOTREDNCO, TOTREDNCO, 1)
C
      NULLEVAL = 0
      DO I = 1, TOTREDNCO
         IF (GMATRX(I, I) .LE. EPSILON) THEN
             NULLEVAL = NULLEVAL + 1
             GMATRX(I, I) = 0.0D0
         ELSE
             GMATRX(I, I) = 1.0D0/GMATRX(I, I)
         ENDIF
      ENDDO
C  
      NONZERO_TOTREDNCO = TOTREDNCO - NULLEVAL
  
      CALL DPUTREC(20,'JOBARC','REDEVECS',NULLEVAL*TOTREDNCO,
     &            EIGVECTORS)
      CALL IPUTREC(20,'JOBARC','NUMREDCO', 1, NULLEVAL)
C
C Built the generalized inverse of G-matrix, what proceeded is generally
C known as singular value decomposition (ineversion of singular matrices)
C G^(-1) = [K L] Lambda^(-1)[K^(t) L^(t)]
C 
      CALL XGEMM('N', 'N', TOTREDNCO, TOTREDNCO, TOTREDNCO, 1.0D0,
     &           EIGVECTORS, TOTREDNCO, GMATRX, TOTREDNCO, 0.0D0,
     &           BTMP, TOTREDNCO)
CSSS      Print*, "The INVERSE OF B-Matrix:1"
CSSS      CALL OUTPUT(BTMP, 1, TOTREDNCO, 1, TOTREDNCO, TOTREDNCO,
CSSS     &            TOTREDNCO, 1)
      CALL XGEMM('N', 'T', TOTREDNCO, TOTREDNCO, TOTREDNCO, 1.0D0,
     &           BTMP, TOTREDNCO, EIGVECTORS, TOTREDNCO, 0.0D0,
     &           GMATRX, TOTREDNCO)
      CALL DPUTREC(20,'JOBARC','GI-MATRX',LENGMAT,GMATRX)
C---DEBULG
CSSS      CALL ZERO(BTMP, TOTREDNCO*TOTREDNCO)
CSSS      CALL XGEMM('N', 'N', TOTREDNCO, TOTREDNCO, TOTREDNCO, 1.0D0,
CSSS     &           GMATRX, TOTREDNCO, BMATRX, TOTREDNCO, 0.0D0,
CSSS     &           BTMP, TOTREDNCO)
CSSS      CALL XGEMM('N', 'N', TOTREDNCO, TOTREDNCO, TOTREDNCO, 1.0D0,
CSSS     &           BTMP, TOTREDNCO, BMATRX, TOTREDNCO, 0.0D0,
CSSS     &           GMATRX, TOTREDNCO)

CSSS      Print*, "The CHECK INVERSE OF B-Matrix"
CSSS      CALL OUTPUT(GMATRX, 1, TOTREDNCO, 1, TOTREDNCO, TOTREDNCO,
CSSS     &            TOTREDNCO, 1)
C---DEBUG
C
C Built the intermediate matrix needed to built G and A matrices. 
C
      CALL XGEMM('N', 'N', TOTREDNCO, 3*NRATMS, TOTREDNCO, 1.0D0,
     &           GMATRX, TOTREDNCO, BMATRX, TOTREDNCO, 0.0D0,
     &           BTMP, TOTREDNCO)

CGAL  Here we build B(t)*G(-)
      CALL XGEMM('T','N',3*NRATMS,TOTREDNCO,TOTREDNCO,1.0D0,
     &            BMATRX,TOTREDNCO,GMATRX,TOTREDNCO,0.0D0,
     &            BTGMIN,3*NRATMS)
CSSS      Write(6,*) "BTGMIN matrix"
CSSS      CALL OUTPUT(BTGMIN,1,3*NRATMS,1,TOTREDNCO
CSSS     &            ,3*NRATMS,TOTREDNCO,1)

      LENBTGMIN=3*NRATMS*TOTREDNCO
      CALL DPUTREC(20,'JOBARC','BTGMIN',LENBTGMIN,BTGMIN)
C  
C Built the the G-MATRIX (G(-1)B)^t; Note the transpose 
C is necessary because the way the transformation is done in 
C CONVQ.f (ACES II). This is the transformation matrix, when
C act on right convert Cartesian gradients to internals, and
C act on left convert internal coordiantes to Cartesian. 
C   
      CALL TRANSP(BTMP, GMATRX, 3*NRATMS, TOTREDNCO)
C
C Make the transpose of the B-Matrix and  pass it out. We 
C need this to transform the Cartesian Hessian matrix to 
C internals.
C
      CALL TRANSP(BMATRX, BTMP, 3*NRATMS, TOTREDNCO)
      CALL DCOPY(3*NRATMS*TOTREDNCO, BTMP, 1, BMATRX, 1)  
C
CSSS
CSSS      CALL OUTPUT(GMATRX, 1, 3*NRATMS, 1, TOTREDNCO, 3*NRATMS,
CSSS     &            TOTREDNCO, 1) 
C
      RETURN
      END

C EMULATOR OF CRAY SCILIB ROUTINE. SCATTERS A VECTOR (B) INTO ANOTHER
C VECTOR (A) ACCORDING TO AN INDEX VECTOR (INDEX).

c The UNICOS man page for scatter is appended to this file.

      subroutine scatter(n,a,index,b)
      integer n,index(n),i
      double precision a(*),b(n)
      do i = 1, n
         a(index(i)) = b(i)
      end do
      return
      end

c NAME
c      SCATTER - Scatters a vector into another vector
c
c SYNOPSIS
c      CALL SCATTER(n,a,index,b)
c
c DESCRIPTION
c      SCATTER is defined as follows:
c
c           a(j(i)) = b(i) where i = 1,...,n
c
c      This routine has the following arguments:
c
c      n      Integer.  (input)
c             Number of elements in arrays index and b (not in a).
c
c      a      Real or integer array of dimension max(index(i): i=1,...,n).
c             (output)
c             Contains the result vector.
c
c      b      Real or integer array of dimension n.  (input)
c             Contains the source vector.
c
c      index  Integer array of dimension n.  (input)
c             Contains the vector of indices.
c
c      The Fortran equivalent of this routine is as follows:
c
c                DO 100 I=1,N
c                   A(INDEX(I))=B(I)
c            100 CONTINUE
c
c CAUTIONS
c      You should not use this routine on systems that have Compress-Index
c      Gather-Scatter (CIGS) hardware, because it will degrade performance.

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE RESOLVE(NDEG,V,TMP,SYMOPS,IPTR,TMP2,BIGX,NX,NATOM,
     &                   NTOTATOM,IORDABEL)
C
C RESOLVES DEGENERATE NORMAL MODE INTO PURE IRREDUCIBLE REPRESENTATIONS
C OF THE ABELIAN SUBGROUP
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL IPRINT,IPRINT2
      DIMENSION V(NX,NDEG),TMP(NX,NDEG),SYMOPS(9*IORDABEL),
     &          IPTR(NATOM*IORDABEL),BIGX(NX,NX),TMP2(NX)
      DIMENSION CHAR2(2,2),CHAR4(4,4),CHAR8(8,8)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/ORIENT/ORIENT(9)
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     &   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     &   XYZTol
      DATA ONE,ONEM,ZILCH/1.0D0,-1.0d0,0.0D0/
      DATA CHAR2/ 1.0D0, 1.0D0,
     &           -1.0D0, 1.0D0/
      DATA CHAR4/ 1.D0, 1.D0, 1.D0, 1.D0,
     &           -1.D0,-1.D0, 1.D0, 1.D0,
     &           -1.D0, 1.D0,-1.D0, 1.D0,
     &            1.D0,-1.D0,-1.D0, 1.D0/
      DATA CHAR8/ 1.D0, 1.D0, 1.D0, 1.D0, 1.D0, 1.D0, 1.D0, 1.D0,
     &            1.D0,-1.D0, 1.D0, 1.D0,-1.D0,-1.D0,-1.D0, 1.D0,
     &            1.D0, 1.D0,-1.D0,-1.D0,-1.D0,-1.D0, 1.D0, 1.D0,
     &           -1.D0, 1.D0,-1.D0, 1.D0, 1.D0,-1.D0,-1.D0, 1.D0,
     &           -1.D0, 1.D0, 1.D0,-1.D0,-1.D0, 1.D0,-1.D0, 1.D0,
     &           -1.D0,-1.D0, 1.D0,-1.D0, 1.D0,-1.D0, 1.D0, 1.D0,
     &           -1.D0,-1.D0,-1.D0, 1.D0,-1.D0, 1.D0, 1.D0, 1.D0,
     &            1.D0,-1.D0,-1.D0,-1.D0, 1.D0, 1.D0,-1.D0, 1.D0/
C
      iprnt=1
      IPRINT2=IPRNT.GT.100
      IPRINT =IPRNT.GT.1
C
C CALCULATE MASS-WEIGHTED HESSIAN IN BASIS OF DEGENERATE EIGENVECTORS
C
      IF(IPRINT)THEN
       rewind(78)
       read(78)bigx
       call xgemm('n','n',nx,ndeg,nx,one,bigx,nx,v,nx,zilch,tmp,nx)
       call xgemm('t','n',ndeg,ndeg,nx,one,v,nx,tmp,nx,zilch,tmp2,ndeg)
       write(6,*)' Mass-weighted Hessian in unresolved coordinates:'
       call output(tmp2,1,ndeg,1,ndeg,ndeg,ndeg,1)
      ENDIF
      IF(IPRINT)THEN
       write(6,*)' Degenerate modes before resolution: '
       do 901 i=1,ndeg
        write(6,'((3f20.14))')(v(j,i),j=1,nx)
        write(6,*)' normalization ',xdnrm2(nx,v(1,i),1)
        write(6,*)
901    continue
      ENDIF
c
      CALL DGETREC(20,'JOBARC','COMPSYOP',9*IORDABEL,SYMOPS)
      CALL MTRAN2(ORIENT,3)
      CALL TRNOPS(SYMOPS,ORIENT,IORDABEL)
      CALL MTRAN2(ORIENT,3)
      CALL IGETREC(20,'JOBARC','COMPPERM',NTOTATOM*IORDABEL,IPTR)
      CALL STRIPDUM(IPTR,TMP,NATOM,NTOTATOM,IORDABEL,BIGX)
C
      CALL XDCOPY(NX*NDEG,V,1,TMP,1)
      DO 5 I=2,NDEG
       CALL XDAXPY(NX,ONE,TMP(1,I),1,TMP,1)
5     CONTINUE
      IF(IPRINT2)THEN
       write(6,*)' reducible representation '
       write(6,'((3f20.14))')(tmp(j,1),j=1,nx)
      ENDIF
C
C LOOP OVER SYMMETRY OPERATIONS AND PROJECT ONTO IRREPS
C
      IDONE=1
      DO 10 IRREP=1,IORDABEL
       IOFFS=1
       IOFFI=1
       CALL ZERO(TMP2,NX)
       DO 11 IOP=1,IORDABEL
        CALL GENREP(BIGX,SYMOPS(IOFFS),IPTR(IOFFI),NATOM)
        IF(IORDABEL.EQ.2.AND.IRREP.EQ.2)THEN
         X=SSUM(9,SYMOPS(1),1)
         FACT=ONE*CHAR2(IOP,IRREP)
         IF(DABS(X-3.0D0).LT.1.D-3)FACT=ONEM*CHAR2(IOP,IRREP)
        ELSEIF(IORDABEL.EQ.2.AND.IRREP.EQ.1)THEN
         FACT=CHAR2(IOP,IRREP)
        ELSEIF(IORDABEL.EQ.4)THEN
         FACT=CHAR4(IOP,IRREP)
        ELSEIF(IORDABEL.EQ.8)THEN
         FACT=CHAR8(IOP,IRREP)
        ENDIF
        CALL XGEMM ('N','N',NX,1,NX,FACT,BIGX,NX,TMP,NX,ONE,TMP2,NX) 
        IOFFS=IOFFS+9
        IOFFI=IOFFI+NTOTATOM
11     CONTINUE
       XLEN=XDNRM2(NX,TMP2,1)
      IF(IPRINT2)THEN
       write(6,*)' after projection onto irrep ',irrep
       write(6,'((3f20.10))')tmp2
       write(6,*)' length of projection for irrep ',irrep,' is ',xlen
      ENDIF
       if(xlen.gt.1.d-2)then
        call xdscal(nx,1.0d0/dfloat(iordabel),tmp2,1)
        call xdcopy(nx,tmp2,1,v(1,idone),1)
        idone=idone+1
       endif
10    CONTINUE
      if(idone.ne.ndeg+1)then
       write(6,*)' Resolution is impossible ! '
       call dgetrec(20,'JOBARC','HOLDDEGQ',NDEG*NX,V)
      endif
      CALL ZERO(TMP,NX)
      IF(IPRINT)WRITE(6,*)' Degenerate modes after resolution and',
     &                    ' renormalization: '
       do 900 i=1,ndeg
        call xdaxpy(nx,one,v(1,i),1,tmp,1)
        IF(IPRINT2)write(6,*)' normalization ',xdnrm2(nx,v(1,i),1)
        call dscal(nx,1.D0/xdnrm2(nx,v(1,i),1),v(1,i),1)
        IF(IPRINT)write(6,'((3f20.14))')(v(j,i),j=1,nx)
        IF(IPRINT2)write(6,*)' renormalized norm ',xdnrm2(nx,v(1,i),1)
        IF(IPRINT)write(6,*)
900    continue
      IF(IPRINT2)write(6,*)' reducible representation on exit '
      IF(IPRINT2)write(6,'((3f20.14))')(tmp(j,1),j=1,nx)
C
C CALCULATE MASS-WEIGHTED HESSIAN IN BASIS OF DEGENERATE EIGENVECTORS
C
      IF(IPRINT)THEN
       rewind(78)
       read(78)bigx
       call xgemm('n','n',nx,ndeg,nx,one,bigx,nx,v,nx,zilch,tmp,nx)
       call xgemm('t','n',ndeg,ndeg,nx,one,v,nx,tmp,nx,zilch,tmp2,ndeg)
       call output(tmp2,1,ndeg,1,ndeg,ndeg,ndeg,1)
       write(6,*)' Mass-weighted Hessian in resolved coordinates:'
       call output(tmp2,1,ndeg,1,ndeg,ndeg,ndeg,1)
      ENDIF
      RETURN
      END

C THIS ROUTINE CONSTRUCTS THE GRADIENT VECTOR FOR
C BLOCK NDIM FROM NUMERICAL DIFFERENTIATION OF THE ENERGY.

c INPUT
c integer NDIM
c double  ENERGY(2,NDIM)
c double  STPSIZ

c OUTPUT
c double GRD(NDIM) : symmetry coordinate gradient

      SUBROUTINE ENER2GRD(NDIM,ENERGY,GRD,STPSIZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION ENERGY(2,NDIM), GRD(NDIM)

      LOGICAL PRINTQ

      COMMON /FLAGS/ IFLAGS(100)

      PRINTQ=(IFLAGS(1).GE.10)

c   o calculate gradient
      DTMP = 0.5d0/STPSIZ
      DO I=1,NDIM
         GRD(I)=(ENERGY(1,I)-ENERGY(2,I))*DTMP
      END DO

      IF (PRINTQ) THEN
         WRITE(6,1000)
1000     FORMAT(T3,'Internal coordinate gradient',/,
     &          T2,'Coord.',T16,'dE/dq')
         DO I=1,NDIM
            WRITE(6,'(2X,I5,5X,F20.10)')I,GRD(I)
         END DO
      END IF

      RETURN
      END

c This routine is a wrapper for looping over sumsym2. (I know, don't ask,
c it's a legacy thing...) It adds a group of arrays DADD to an MOIO family in
c storage. DADD and the MOIO family (up to the number of irreps) must have the
c same number of elements.

c INPUT
c double DADD(*) : the vector of addends
c double DSCR(*) : scratch array to hold at least one column of any MOIO array
c int IDIMSCR : size of the scratch array
c int IFAMILY : the right MOIO index

      subroutine sumsym(dAdd,dScr,iDimScr,iFamily)
      implicit none

c ARGUMENTS
      integer iDimScr, iFamily
      double precision dAdd(*), dScr(iDimScr)

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer iGroup, iNdx, nRows, nCols

c COMMON BLOCKS
c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end

c ----------------------------------------------------------------------

      iNdx = 1
      do iGroup = 1, nirrep
         call sumsym2(dAdd(iNdx),dScr,iDimScr,0,iGroup,iFamily)
         nRows = aces_list_rows(iGroup,iFamily)
         nCols = aces_list_cols(iGroup,iFamily)
         iNdx = iNdx + (nRows*nCols)
      end do

      return
c     end subroutine sumsym
      end

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It copies roots from the coomon block to static array        |
c                in the EOM SIAL code                           |
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|

      subroutine eomcopyroots
     +                 (array_table, 
     *                  narray_table, index_table,
     *                  nindex_table, segment_table, nsegment_table,
     *                  block_map_table, nblock_map_table,
     *                  scalar_table, nscalar_table, 
     *                  address_table, op)

c--------------------------------------------------------------------------
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'daveom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base, daddr
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer sind, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer*8 get_block_index
      integer stack

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif




c----------------------------------------------------------------------------
c   Locate the data for the input matrix which is to be analyses.
c---------------------------------------------------------------------------

      array      = op(c_result_array)

      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      iarray = get_index_from_base(address_table(array), x, 2)

      if (array .eq. 0) then
         print *,'Error: The first argument in return_sval  
     *            must be an array.'  
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index


C----------------------------------------------------------------------------

      call eom_copyroot(x(iarray),1,n1,iter,nroots,DavRoots)

C----------------------------------------------------------------------------

      return 
      end 
C#############################################################################

      subroutine eom_copyroot(Dav_Roots,a1,a2,iter,nroots,DavRoots)
      IMPLICIT NONE

      integer i,j,a1,a2,b1,b2,iter,nroots,IWRK,INFO,LCI,KK,ICK
      double precision DAV_Roots(a1:a2)
      double precision DavRoots(20)
      include 'parallel_info.h'      

      do i=1,nroots
      DAV_Roots(i) = DavRoots(i)
      enddo

      return
      end
c-----------------------------------------------------------------------------

c The following routines allow you to print part of the upper or lower
c diagonal part of a matrix, with or without the diagonal.  The matrix
c is stored as the full square matrix.

      subroutine mat_print_tri(which,diag,mat,nrow,title,collab,rowlab,
     &                         numwid,ndec)
      implicit none
      integer nrow,numwid,ndec
      character*1 which,diag
      double precision mat(nrow,nrow)
      character*(*) title,collab,rowlab
      call mat_print_tri_sub(which,diag,mat,nrow,title,collab,rowlab,
     &                       numwid,ndec,1,nrow,1,nrow)
      return
      end

      program main
      implicit none

      integer iuhf
#include "icore.com"
#include "istart.com"

      call aces_init(icore,i0,icrsiz,iuhf,.true.)
      call symcor(icore(i0),icrsiz)
      call aces_fin

      end

      program main
      implicit none

      integer iuhf


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end



















c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end

      call aces_init(icore,i0,icrsiz,iuhf,.true.)
      call symcor(icore(i0),icrsiz)
      call aces_fin

      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine free_mpi_data()
c---------------------------------------------------------------------------
c   Frees the communicators and groups set up for a previous SIAL execution.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'parallel_info.h'
      include 'company.h'
      integer pst_get_company_comm

      integer comm
      integer group
      integer ierr

      comm = pst_get_company_comm(me)
      call mpi_comm_free(comm, ierr)
     
      return
      end

C---------------------------------------------------------------------
C---------------------------------------------------------------------
C
      Subroutine polyrate_wrte(FlgPOLYGeom,FlgPOLYElec,FlgPOLYGrad,
     &                       FlgPOLYHess,Natom,Nreal,NOcc,AtmMass,
     &                       Coord,Vgrad,Grad,Hess,Freq,Imap,Iord,
     &                       iuhf)
C
C     -----
C     interface ACESII
C
C     -----
C     called by Main
C
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C
      Implicit double precision (a-h,o-z)
C
#include "machsp.com"
#include "mxatms.par"
C
      Logical FlgPOLYGeom,FlgPOLYElec,FlgPOLYGrad,FlgPOLYHess,
     &        FRQARC_EXIST
      Character*5  AtmLabel(Mxatms)
      character*10 Label
      Character*4  PTGRP
      Character*80 FNAME
C
      Dimension NOcc(16),AtmMass(Natom),Coord(3,Natom),VGrad(3,Nreal),
     &          Grad(3,Nreal),Imap(Nreal),Iord(Nreal),
     &          Hess(9*Natom*Natom),Freq(3*Nreal)

C     translation factor from bohr to angstrom
      Parameter (b2ang=1.889725989)
C
      Logical debug, polyrate_exist
      Parameter (debug=.True.)
      If (debug) write(*,*) '\n--- In the ACESII'
C
      IUnitO=30
C
C---------------------------------------------------------------------
C
C     Read number of atoms
C---------------------------------------------------------------------
C
      Call Getcrec(1,'JOBARC','ZSYM',5*Natom,AtmLabel)
*     --- print out ---
      If (debug) then
      Write(*,9000) Nreal
      Write(*,9100) Natom
      Write(*,9200) (AtmLabel(i),i=1,Natom)
      End if
*     -----------------
 9000 Format(4X,'--- ','number of real atoms =',I7)
 9100 Format(4X,'--- ','number of zmat atoms =',I7)
 9200 Format(4X,'--- ','atoms:','\n',8X,10A5,('\n',8X,10A5))
C
C Open the file POLYRATE, if it does exists, then close it and
C reopen it.
C
      CALL GFNAME('POLYRATE',FNAME,ILENGTH)
      Inquire(FILE=FNAME(1:ILENGTH), EXIST=Polyrate_exist)
      If (Polyrate_exist) Then
         Open(UNIT=IUnitO, FILE=FNAME(1:ILENGTH), FORM='FORMATTED')
         Close(IUnito, Status="DELETE")
         Open(UNIT=IUnitO, FILE=FNAME(1:ILENGTH), FORM='FORMATTED',
     &         STATUS='NEW')
      Endif 
C
C---------------------------------------------------------------------
C
C     Read coordinate and translate from bohr to angstrom
C---------------------------------------------------------------------
C
      If (flgPOLYGeom) then
C
         Call Getrec(20,'JOBARC','ATOMMASS',Natom*IINTFP,AtmMass)
         Call Getrec(20,'JOBARC','COORD   ',3*Natom*IINTFP,Coord(1,1))
         Do j=1,3
            Do i=1,Natom
               Coord(j,i)=Coord(j,i)/b2ang
            End do
         End do
         Open(IUnitO,File='Geom.rate',Status='Unknown')
         Do i=1,Natom
            Do j=2,5
               jchar=ichar(AtmLabel(i)(j:j))
               If (jchar .GE. 65 .AND. jchar .LE. 90) then
                  AtmLabel(i)(j:j)=char(jchar+32)
               End if
            End do
            If (AtmLabel(i)(1:5) .NE. 'X    ') then
               Write(IUnitO,7000) AtmLabel(i),(Coord(j,i),j=1,3),
     &                            AtmMass(i)
            End if
         End do
         Close(IUnitO)
C
      End if
 7000 Format(5X,A5,F15.10,2F18.10,F18.10)
C
C---------------------------------------------------------------------
C
C     Read total energy and degeneracy
C---------------------------------------------------------------------
C
      If (flgPOLYElec) then
C
C        Read the number of electrons and estimate degeneracy
C        -------------------------------------------------------------
         Call Getrec(20,'JOBARC','UHFRHF  ',1,iUHF)
         Call Getrec(20,'JOBARC','NIRREP  ',1,NIrRep)
         Call Getrec(20,'JOBARC','OCCUPYA0',NIrRep,NOcc(1)) 
         Nalph=0
         If (iUHF .EQ. 0) then
            Do i=1,NIrRep
               Nalph=Nalph+NOcc(i)
            End do
            Ntotal=Nalph*2
            Mult=1
            Nbeta = Nalph 
            call icopy(8, nocc(1), 1, nocc(9), 1)
         Else if (iUHF .EQ. 1) then
            Call Getrec(20,'JOBARC','OCCUPYB0',NIrRep,NOcc(9))
            Nbeta=0
            Do i=1,NIrRep
               Nalph=Nalph+NOcc(i)
               Nbeta=Nbeta+NOcc(i+8)
            End do
            Ntotal=Nalph+Nbeta
            Mult=(Nalph-Nbeta)+1
         End if
C
C        Calculate degeneracy in the atomic case
C        -------------------------------------------------------------
C
*        --- print out ---
         If (debug) then
         Write(*,6905) iUHF
         Write(*,6910) NIrRep
         Write(*,6920) (NOcc(i),i=1,NIrRep)
         Write(*,6930) (NOcc(i+8),i=1,NIrRep)
         Write(*,6940) Nalph
         Write(*,6950) Nbeta
         Write(*,6960) Ntotal
         Write(*,6970) Mult
         End if
*        -----------------
 6905    Format(4X,'--- ','iUHF  =',I7)
 6910    Format(4X,'--- ','number of irr.  rep. =',I7)
 6920    Format(4X,'--- ','number of alpha orbs :',8I4)
 6930    Format(4X,'--- ','number of beta  orbs :',8I4)
 6940    Format(4X,'--- ','number of alpha elecs=',I7)
 6950    Format(4X,'--- ','number of beta  elecs=',I7)
 6960    Format(4X,'--- ','total number of elecs=',I7)
 6970    Format(4X,'--- ','spin multiplicity    =',I7)

C        Read total energy
C        -------------------------------------------------------------
         CALL Getrec(20,'JOBARC','TOTENERG',IINTFP,Etot)
         Open(IUnitO,File='Elec.rate',Status='Unknown')
         Write(IUnitO,6000) Mult,Etot
         Close(IUnitO)
C
      End if
 6000 Format(I3,F20.10)
C
C---------------------------------------------------------------------
C
C     Read gradient
C---------------------------------------------------------------------
C
      If (flgPOLYGrad) then
C
         Call Getrec(20,'JOBARC','MAP2ZMAT',Nreal,IMAP)
         Do i=1,Nreal
            IORD(i)=i
         End do
         Call iSort2(Nreal,IMAP,IORD,2)
C        --- IORD transforms from VMol order to ZMAT order
C
         Call Getrec(0,'JOBARC','GRADIENT',Length,VGrad(1,1))
   
          If (Length .gt. 0) Call Getrec(20,'JOBARC','GRADIENT',
     &                                   3*Nreal*IINTFP,VGrad(1,1))
         Do i=1,Nreal
            k=IORD(i)
            Do j=1,3
               Grad(j,i)=VGrad(j,k)
            End do
         End do
         Open(IUnitO,File='Grad.rate',Status='Unknown')
         Do i=1,nreal
            Write(IUnitO,5000) (Grad(j,i),j=1,3)
         End do
         Close(IUnitO)
C
      End if
 5000 Format(7X,3F18.10)
C
C---------------------------------------------------------------------
C
C     Read Hessian
C---------------------------------------------------------------------
C
      If (flgPOLYHess) then
C
         Call Getrec(20,'JOBARC','CART_HES',9*Natom*Natom*IINTFP,
     &               Hess)
         Open(IUnitO,File='Hess.rate',Status='Unknown')
         m=0
         Do i=1,Natom
            Do ix=1,3
               m=m+1
               If (AtmLabel(i)(1:5) .NE. 'X    ') then
                  n=0
                  Do j=1,i
                     Do jx=1,3
                        n=n+1
                        If (AtmLabel(j)(1:5) .NE. 'X    ') then
                           k=Natom*3*(n-1)+m
                           If (n .LE. m) Write(IUnitO,4100) Hess(k)
                        End if
                     End do
                  End do
               End if
            End do
         End do
         Close(IUnitO)
C
      End if
 4100 Format(D20.10)
C
C---------------------------------------------------------------------
C
      Call Getrec(20, 'JOBARC', 'LINEAR  ', 1, Iamlinear)
      Print*, Iamlinear, natom
      If (Iamlinear .EQ. 1) Then
         Nvibs = 3*Nreal - 5
      Else
         Nvibs = 3*Nreal - 6
      Endif
C
      INQUIRE(FILE='FRQARC',EXIST=FRQARC_EXIST)
      IF(FRQARC_EXIST)THEN
        OPEN(UNIT=5,FILE='FRQARC',FORM='UNFORMATTED',STATUS='OLD')
        rewind(5)
      else
        write(6,20)
 20     format(T3,'@RDVIB-F, The FRQARC file not present.')
        call errex
      ENDIF
C
      READ(5) LABEL, PTGRP, NRX, NIMAG, ZMAS, ZIX, ZIY, ZIZ,
     &          (Freq(IVIB), IVIB=1, Nvibs)
      
C
C Note that Frequencies written in ascending order. Since all the
C imaginary frequencies have negative sign they are at the begining.
C
      If (NIMAG .GT. 0) Then
         DO Iimag = 1, NIMAG
            Freq(Iimag) =  -Freq(Iimag)
         End Do
      End If
C
      If (debug)  then
         Write(6,*) "The vibrational Frequencies"
         Write(*,"(4(2X,F10.4))") (freq(I), I = 1, Nvibs)
      Endif
      Open(IUnitO,File='Freq.rate',Status='Unknown')
      Write(IUnitO,"(4(2X,F18.8))") (freq(I), I = 1, Nvibs) 
      Close(IUnitO)
C
      If (debug) write(*,'(A)') '--- Out of the a2rate_wrte'
      Return
C
      End

      SUBROUTINE KILLDER
C
C THIS ROUTINE DISPENSES WITH THE DERGAM FILE AND ZEROS OUT ALL OF
C  THE ASSOCIATED LIST POINTERS
C
CEND
      IMPLICIT INTEGER(A-Z)
      LOGICAL YESNO,ISOPEN
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &              MOIODS(10,500),MOIOFL(10,500)
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      INQUIRE(FILE='DERGAM',EXIST=YESNO,OPENED=ISOPEN)
      IF(YESNO) THEN
      IF(.NOT.ISOPEN)OPEN(UNIT=54,FILE='DERGAM',STATUS='OLD')
      CLOSE(UNIT=54,STATUS='DELETE')
      CALL IZERO(MOIO(1,401),1000)
      CALL IZERO(MOIOWD(1,401),1000)
      CALL IZERO(MOIODS(1,401),1000)
      CALL IZERO(MOIOSZ(1,401),1000)
      CALL IZERO(MOIOFL(1,401),1000)
C
      DO 10 I=1,100
C
       IF(CACHFILE(I).EQ.54)THEN
        CACHFILE(I)=0
        CACHDIR (I)=0
       ENDIF
10    CONTINUE   
      ENDIF
      RETURN
      END

C COMPUTES C(I) = a(i) / (1./b(i) + denomshift)
C FOR FIRST N ELEMENTS OF VECTORS A AND B.

      SUBROUTINE BWVECPRD(denomshift,A,B,C,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N),B(N),C(N)
#include "bwcc.com"
#ifdef _ASSERT
      if (n.lt.0) then
         print *, '@BWVECPRD: Assertion failed.'
         print *, '           n = ',n
         call errex
      end if
#endif /* _ASSERT */
cjp b(i) was already 1/(e+e-e-e) and in original routine c was a*b
      DO I = 1, N
c         if (bwgossip) write(*,*) '@BWVECPRD: ',i,b(i),a(i)
         b(i) = 1.0d0 / ( denomshift + (1.0d0/b(i)) )
cjp intruder prevention
         if (abs(b(i)).gt.intruder) then
            c(i) = 0.0d0
         else
            c(i) = a(i)* b(i)
         end if
      END DO
      RETURN
      END

      SUBROUTINE ARGZMAP(TARCOO,IMAP,COORD,NATOMS)
C
C     THIS ROUTINE CHECKS WHICH ATOM'S COORDINATES IN COOR ARE MATCHED
C     BY THE COORDINATES IN TARCOO. THE NUMBER IS RETURNED IN IMAP
C
CEND
C
C PROGRAMED PBY PS SEPT/92
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION COORD(3,NATOMS),TARCOO(3)
      DATA THRES/1.D-10/
C
      DO 10 IATOMS=1,NATOMS
         DO 11 J=1,3
            DIFF=DABS(COORD(J,IATOMS)-TARCOO(J))
            IF(DIFF.GT.THRES) GOTO 10
 11      CONTINUE
         IMAP=IATOMS
         GOTO 20
 10   CONTINUE
      WRITE(6,*) '@ARGZMAP-E Internal error, coordinates not matched'
      CALL ERREX
 20   CONTINUE
      RETURN
      END

      Subroutine Ln_Search(Energy, q, g, dq, nInter, nIter, dqHdq,
     &                     Thr)
      Implicit Double Precision (a-h,o-z)

      DIMENSION Energy(2), A(0:5), Projg(2), q(nInter, 2),
     &          g(nInter, 2), dq(nInter, 2), B(4,0:3), FVal(4)
      Logical RC
      DATA Zero /0.0D0/, One /1.0D0/, Two /2.0D0/, Three /3.0D0/
     &     Four /4.0D0/, Half /0.5D0/
*
      A(0)=Zero
*
      iNew=nIter-1
      iOld=nIter
*
*     1) Quartic search, -0.5 <= Xmin <= 0.5 
*     2) Cubic search, -1.5 <= Xmin <= 1.5
*     3) E(iNew) is the best, no action
*     4) E(iNew) is not the best,
*        XMin=0.0 between iNew and the Best point
*
*---- Quartic line search
*
c      Write(6,*) "The distance array"
c      call output(q, 1, ninter, 1, 2, ninter, 2, 1)
c      Write(6,*) "The gradient array"
c      call output(g, 1, ninter, 1, 2, ninter, 2, 1)
c      Write(6,*) "the energies:", energy(1), energy(2)
      call dscal(nInter*2, -One, g, 1)
      Projg(1)=-DDot(nInter,q(1,iNew),1,g(1,iOld),1)
     &         +DDot(nInter,q(1,iOld),1,g(1,iOld),1)
      Projg(2)=-DDot(nInter,q(1,iNew),1,g(1,iNew),1)
     &         +DDot(nInter,q(1,iOld),1,g(1,iNew),1)
      A(3)=-(Two*(Energy(iNew)-Energy(iOld))
     &    +(Projg(2)+Projg(1)))
      A(1)= (Energy(iNew)-Energy(iOld))
     &    - (One/Four) * A(3)
C       Edif = -(Energy(iNew)-Energy(iOld))
C       Gmid = (Projg(1) + Projg(2))/Two
C       A(4) = -(Three*Edif + gmid)/Two
C       A(2) = Two*(Edif + Gmid)
*     Write (*,*) ' Projg(1),Projg(2),A(3),A(1)=',
*    &              Projg(1),Projg(2),A(3),A(1)
*
*---- Test the gradient difference
*
      Test1=Projg(2)-Projg(1)
*     Write (*,*) ' Test1=',Test1
      If (Test1.lt.Thr) Then
         Write (*,*) '-- Line search failed, negative curvature'
         Return
      End If
*
*---- Now check if data is consistent with the condition that
*     the second derivative is zero at the minimum.
*
      Test2=Test1**2-Three*A(3)**2
C      Test2 = Test1**2 - Three*A(2)**2 
*     Write (*,*) ' Test2=',Test2
      If (Test2.lt.Zero) Then
         Write (*,*) 
     &       '-- Quartic line search failed, nonzero 2nd derivative'
         Go To 100
      End If
*
      A(2)=(Sqrt(Test2)+Test1)/Four
C      A(3) = (DSqrt(Test2) + Test1)/Four
      If (A(2).lt.Thr) Then
         Write (*,*) 
     &       '-- Quartic line search failed, A(3) too small,',
     &       'using cubic minimum'
         Go To 100
      End If
*
      A(4)=Half*(Test1-Test2)
      nOrder=4
      XStart=Zero
      XLow=-Half
      XHi = Half
      Go To 500
*
*---- Cubic line search
*
*     Range: -0.5 - 0.5
*
 100  Continue
      Write (*,*) '-- Cubic line search'
      FVal(1)=Energy(iOld)
      FVal(2)=Energy(iNew)
      FVal(3)=Projg(1)    
      FVal(4)=Projg(2)    
*     B=Zero
      x0=One
      x1=Half
      x2=x1*Half
      x3=x2*Half
      x0g=Zero
      x1g=One
      x2g=Two*x1
      x3g=Three*x2
      Fact=One 
      ii=1
      jj=3
      Do i = 1, 2
         Fact=-One*Fact
         B(ii,0)=x0
         B(ii,1)=Fact*x1
         B(ii,2)=x2
         B(ii,3)=Fact*x3
         B(jj,0)=x0g
         B(jj,1)=x1g
         B(jj,2)=Fact*x2g
         B(jj,3)=x3g
         ii = ii + 1
         jj = jj + 1
      End Do
      nOrder=3
c      Write(6,*) "Before The call to Gauss", (FVAL(I), I=1,4)
      Call Gauss(nOrder+1,nOrder+1,B,A,FVal)
      XStart=Zero
      XLow = -One
      XHi  =  Two+Half
*
 500  Continue
c      Write(6,*) "After The call to Gauss", (A(I), I=0, 5)
c      Write(6,*) "Before the call  to Find_Min"
      Call Find_Min(nOrder,XStart,A,XMin,RC,XLow,XHi,ENew,Thr)
c      Write (*,*) 'ENew and Xmin=',ENew, Xmin
      If (.Not.RC) Then
*        Write (*,*) 'RC=.False.'
         Return
      End If
      If (Test2.lt.Zero) Then
         dqHdq=ENew-Energy(nIter)
      Else
         dqHdq=ENew
      End If
      XMin=XMin+Half
      Write (*,*) 'Minimum found at -->',XMin,'<--'
*                                                                      *
************************************************************************
*                                                                      *
*---- Update vectors in accordance with the result
*
*.... Compute the displacement iOld -> iNew
*
      Call DCopy(nInter,          q(1,iNew  ),1,dq(1,iOld),1)
      Call DaXpY(nInter,-One,     q(1,iOld  ),1,dq(1,iOld),1)
      dqdq=DDot(nInter,          dq(1,iOld),1,dq(1,iOld),1)
      Call DScal(nInter,XMin,    dq(1,iOld),1)
C      dqdq=DDot(nInter,          dq(1,iOld),1,dq(1,iOld),1)
*
*.... Compute the new q
*
      Call DCopy(nInter,          q(1,iOld  ),1, q(1,iNew  ),1)
      Call DaXpY(nInter,One,     dq(1,iOld),1,   q(1,iNew  ),1)
c      Print*, "The updated Geo.",  (q(I,1), I = 1, nInter)
c      Print*, "The line step", (dq(I,2), I = 1, nInter) 
*
*.... Update the gradient
*
      Call DScal(nInter,XMin,     g(1,iNew  ),1)
c      Print*, 'The gradients -1', (g(I, 1), I=1, nInter)
C      Call DaXpY(nInter,One-XMin, g(1,iOld  ),1, g(1,iNew  ),1)
      Call DaXpY(nInter, -XMin, g(1,iOld  ),1, g(1,iNew  ),1)
c      Print*, 'The gradients -2', (g(I, 1), I=1, nInter)
C      gdq=-DDot(nInter,           g(1,iNew  ),1,dq(1,iOld),1)
      gdq=DDot(nInter,           g(1,iNew  ),1,dq(1,iOld),1)

c      Write(6,*) 
c      Write(6,*) "scale factor", gdq/dqdq
      Call DaXpY(nInter,-gdq/dqdq,dq(1,iOld),1, g(1,iNew  ),1)
      Call DScal(nInter, -One, g(1, INew), 1)
c      Print*, 'The gradients', (g(I, 1), I=1, nInter)
*
*.... Update the displacement nIter-1 -> nIter
*
C      Call DCopy(nInter,          q(1,iNew  ),1,dq(1,iOld),1)
C      Call DaXpY(nInter,-One,     q(1,iOld),  1,dq(1,iOld),1)
*                                                                      *
************************************************************************
*                                                                      *
      Return 
      End

      SUBROUTINE ECPDEF(NATOMS,MTYPE,Ecpnam,CNICK)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c
c     NOTE : THE ATOMIC SYMBOL must PRECEED THE ECP NICK NAME
c
c     ---------------------------------------------------------------
c     MEANING OF VARIABLES :
c     ---------------------------------------------------------------
c
c     --------- INPUT -----------------------------------------------
c     MTYPE   : ATOMIC IDENTIFIER (STARTING WITH ELEMENT SYMBOL)
c     NATOMS  : NUMBER OF ATOMS
c     --------- OUTPUT ----------------------------------------------
c     IPSEUX  : PSEUDO POTENTIAL TYPE OF ATOM
c               0  MEANS : NO PSEUDO POTENTIAL OR NOT YET ASSIGNED
c     CNICK   : PSEUDO POTENTIAL NICKNAMES INDEXED BY PSEUDO POTENTIAL
c               TYPES
c
      CHARACTER*16 BLNKBN
      PARAMETER (BLNKBN = '                ')

      CHARACTER ATOSYM*2,MTYPE(NATOMS)*(*)
      CHARACTER*4 DUMPF
      CHARACTER*80 ECPNAM(NATOMS)
      CHARACTER*80 CNICK(NATOMS)
      LOGICAL bDOIT

#include "machsp.com"
#include "ecp.par"
#include "ecp.com"
c
      CALL GETREC(20,'JOBARC','NATOLD',1,NATOLD)
      CALL GETREC(20,'JOBARC','ECPNAM',80*NATOLD,ECPNAM)
c  
c first detect different types of ecp names
C
 
      DO I=1,NATOMS
         IPSEUX(I)=0
      END DO

      DO I=1,NATOMS
         CNICK(I)=BLNKBN
      END DO
C
c ECPNAM is the full list of ECP names per atom including dummy atoms
C
      NOFECP=0

      DO IAT=1, NATOLD

c loop over the atoms and remove all redundant and NONE lines

         IF ((ECPNAM(IAT).NE.BLNKBN).AND.
     &       (INDEX(ECPNAM(IAT),'NONE').EQ.0)) THEN
            bDOIT=.TRUE.
            DO II=1,NOFECP
               IF (ECPNAM(IAT).EQ.CNICK(II)) bDOIT=.FALSE.
            END DO
            IF (bDOIT) THEN
               NOFECP=NOFECP+1
               CNICK(NOFECP)=ECPNAM(IAT)
            END IF
         END IF
      END DO

      ICHECK=0
      DO IPOT=1,NOFECP
         NPOS=INDEX(CNICK(IPOT),':')

         IF (NPOS.EQ.0) THEN
            WRITE(*,*) '@ECPDEF: Error - missing seperator (:) ',
     &                 'between atom symbol and ECP nickname.'
            CALL ERREX
         END IF
c
c extract the full atomic symbol ( C != CL )
c
         DUMPF = '  '
         DUMPF = CNICK(IPOT)(1:NPOS-1)

c loop over the symmetry unique atoms and assign matches to the 
c current CNICK line number

         DO IAT=1,NATOMS

            IF (DUMPF(1:2).EQ.MTYPE(IAT)(1:2)) THEN

c bomb if two orbits have the same atom (CNICK only contains 
C unique ECP definitions)

               if (IPSEUX(IAT).ne.0) then
                  print *, '@ECPDEF: ERROR - Two orbits have the same ',
     &                     'atom and different ECP definitions.'
                  print *, '         The current implementation cannot',
     &                     ' distinguish between the two.'
                  call errex
               end if
               IPSEUX(IAT)=IPOT
               ICHECK=ICHECK+1
            END IF
         END DO
      END DO

      IF (ICHECK.EQ.0) THEN
         IF (NOFECP.EQ.0) THEN
            WRITE(*,*) '@ECPDEF: Error - no ECP nicknames found in ',
     &                 'JOBARC.'
            CALL ERREX
         END IF
         WRITE(*,*) '@ECPDEF: Error - ECP nickname and atom symbols ',
     &              'in ZMAT are incompatible.'
         CALL ERREX
      END IF

      RETURN 
      END

c This subroutine scans a string and returns the first valid integer
c that falls into one of the following two regular expressions:
c         " *[+-]? *[0-9]+"     -->  1,   +1,   -1
c     " *\( *[+-]? *[0-9]+.*\)" --> (1), (+1), (-1)
c If the string is blank, then iVal=UNDEFINED, nChars=0, iErrPos=0.

c INPUT
c char*(*) sz : the string to parse

c OUTPUT
c int iVal    : the valid integer (undefined if iErrPos!=0)
c int nChars  : the number of characters processed (undefined if iErrPos!=0)
c int iErrPos : the position of an invalid character




      subroutine parse_int(sz,iVal,nChars,iErrPos)
      implicit none

c ARGUMENTS
      character*(*) sz
      integer iVal, nChars, iErrPos

c INTERNAL VARIABLES
      integer maxlen, i, j
      logical bParen, bNeg
      character*1 czSpace, czTab

c INTRINSIC FUNCTIONS
      integer   index
      intrinsic index
      character*1 achar
      intrinsic   achar

c ----------------------------------------------------------------------

      iErrPos = 0
      maxlen  = len(sz)
      czSpace = achar(32)
      czTab   = achar(9)

      i = 1
      do while ((sz(i:i).eq.czSpace.or.sz(i:i).eq.czTab).and.
     &          i.le.maxlen)
         i = i + 1
      end do
      if (i.gt.maxlen) then
c      o the string is blank
         nChars = 0
         return
      end if

c   o parenthetical?
      bParen = (sz(i:i).eq.'(')
      if (bParen) then
         j = i + 1
         do while (sz(j:j).ne.')'.and.j.le.maxlen)
            j = j + 1
         end do
c      o no closing parenthesis
         if (j.gt.maxlen) iErrPos = i
         maxlen = j - 1
c      o find the next non-blank character
         i = i + 1
         do while ((sz(i:i).eq.czSpace.or.sz(i:i).eq.czTab).and.
     &             i.le.maxlen)
            i = i + 1
         end do
c      o the string is blank
         if (i.gt.maxlen) iErrPos = i
         if (iErrPos.ne.0) return
      end if

c   o sign?
      j = index('0123456789-+',sz(i:i))
      if (j.eq.0) then
         iErrPos = i
         return
      end if
      bNeg = (j.eq.11)
      if (j.gt.10) then
c      o find the next non-blank character
         j = i + 1
         do while ((sz(j:j).eq.czSpace.or.sz(j:j).eq.czTab).and.
     &             j.le.maxlen)
            j = j + 1
         end do
c      o the string is missing the number
         if (j.gt.maxlen) then
            iErrPos = i
            return
         end if
         i = j
      end if

c   o process all integers from i to maxlen
      iVal = 0
      j = index('0123456789',sz(i:i))
      if (j.eq.0) then
c      o no first number
         iErrPos = i
         return
      end if
      do while (j.ne.0.and.i.le.maxlen)
         iVal = 10*iVal + (j-1)
         i = i + 1
         j = index('0123456789',sz(i:i))
      end do
      if (bNeg) iVal = -iVal

c   o record the number of characters processed
      nChars = i - 1
      if (bParen) nChars = maxlen+1

c ----------------------------------------------------------------------

      return
c     end subroutine parse_int
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK XDSYR2K
      SUBROUTINE XDSYR2K(UPLO, TRANS, N, K, ALPHA, A, LDA, B, LDB, BETA,
     $   C, LDC)
C***BEGIN PROLOGUE  XDSYR2K
C***PURPOSE  Perform one of the symmetric rank 2k operations.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1B6
C***TYPE      DOUBLE PRECISION (SSYR2-S, DSYR2-D, CSYR2-C, XDSYR2K-D)
C***KEYWORDS  LEVEL 3 BLAS, LINEAR ALGEBRA
C***AUTHOR  Dongarra, J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S. (NAG)
C***DESCRIPTION
C
C  XDSYR2K  performs one of the symmetric rank 2k operations
C
C     C := alpha*A*B' + alpha*B*A' + beta*C,
C
C  or
C
C     C := alpha*A'*B + alpha*B'*A + beta*C,
C
C  where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
C  and  A and B  are  n by k  matrices  in the  first  case  and  k by n
C  matrices in the second case.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On  entry,   UPLO  specifies  whether  the  upper  or  lower
C           triangular  part  of the  array  C  is to be  referenced  as
C           follows:
C
C              UPLO = 'U' or 'u'   Only the  upper triangular part of  C
C                                  is to be referenced.
C
C              UPLO = 'L' or 'l'   Only the  lower triangular part of  C
C                                  is to be referenced.
C
C           Unchanged on exit.
C
C  TRANS  - CHARACTER*1.
C           On entry,  TRANS  specifies the operation to be performed as
C           follows:
C
C              TRANS = 'N' or 'n'   C := alpha*A*B' + alpha*B*A' +
C                                        beta*C.
C
C              TRANS = 'T' or 't'   C := alpha*A'*B + alpha*B'*A +
C                                        beta*C.
C
C              TRANS = 'C' or 'c'   C := alpha*A'*B + alpha*B'*A +
C                                        beta*C.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry,  N specifies the order of the matrix C.  N must be
C           at least zero.
C           Unchanged on exit.
C
C  K      - INTEGER.
C           On entry with  TRANS = 'N' or 'n',  K  specifies  the number
C           of  columns  of the  matrices  A and B,  and on  entry  with
C           TRANS = 'T' or 't' or 'C' or 'c',  K  specifies  the  number
C           of rows of the matrices  A and B.  K must be at least  zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
C           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
C           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
C           part of the array  A  must contain the matrix  A,  otherwise
C           the leading  k by n  part of the array  A  must contain  the
C           matrix A.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
C           then  LDA must be at least  max( 1, n ), otherwise  LDA must
C           be at least  max( 1, k ).
C           Unchanged on exit.
C
C  B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
C           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
C           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
C           part of the array  B  must contain the matrix  B,  otherwise
C           the leading  k by n  part of the array  B  must contain  the
C           matrix B.
C           Unchanged on exit.
C
C  LDB    - INTEGER.
C           On entry, LDB specifies the first dimension of B as declared
C           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
C           then  LDB must be at least  max( 1, n ), otherwise  LDB must
C           be at least  max( 1, k ).
C           Unchanged on exit.
C
C  BETA   - DOUBLE PRECISION.
C           On entry, BETA specifies the scalar beta.
C           Unchanged on exit.
C
C  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
C           Before entry  with  UPLO = 'U' or 'u',  the leading  n by n
C           upper triangular part of the array C must contain the upper
C           triangular part  of the  symmetric matrix  and the strictly
C           lower triangular part of C is not referenced.  On exit, the
C           upper triangular part of the array  C is overwritten by the
C           upper triangular part of the updated matrix.
C           Before entry  with  UPLO = 'L' or 'l',  the leading  n by n
C           lower triangular part of the array C must contain the lower
C           triangular part  of the  symmetric matrix  and the strictly
C           upper triangular part of C is not referenced.  On exit, the
C           lower triangular part of the array  C is overwritten by the
C           lower triangular part of the updated matrix.
C
C  LDC    - INTEGER.
C           On entry, LDC specifies the first dimension of C as declared
C           in  the  calling  (sub)  program.   LDC  must  be  at  least
C           max( 1, n ).
C           Unchanged on exit.
C
C***REFERENCES  Dongarra, J., Du Croz, J., Duff, I., and Hammarling, S.
C                 A set of level 3 basic linear algebra subprograms.
C                 ACM TOMS, Vol. 16, No. 1, pp. 1-17, March 1990.
C***ROUTINES CALLED  LSAME, XERBLA
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910605  Modified to meet SLATEC prologue standards.  Only comment
C           lines were modified.  (BKS)
C***END PROLOGUE  XDSYR2K
C     .. Scalar Arguments ..
      CHARACTER*1        UPLO, TRANS
      INTEGER            N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
C
C     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
C     .. External Subroutines ..
      EXTERNAL           XERBLA
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, INFO, J, L, NROWA
      DOUBLE PRECISION   TEMP1, TEMP2
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C***FIRST EXECUTABLE STATEMENT  XDSYR2K
C
C     Test the input parameters.
C
      IF( LSAME( TRANS, 'N' ) )THEN
         NROWA = N
      ELSE
         NROWA = K
      END IF
      UPPER = LSAME( UPLO, 'U' )
C
      INFO = 0
      IF(      ( .NOT.UPPER               ).AND.
     $         ( .NOT.LSAME( UPLO , 'L' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.LSAME( TRANS, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANS, 'T' ) ).AND.
     $         ( .NOT.LSAME( TRANS, 'C' ) )      )THEN
         INFO = 2
      ELSE IF( N  .LT.0               )THEN
         INFO = 3
      ELSE IF( K  .LT.0               )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 7
      ELSE IF( LDB.LT.MAX( 1, NROWA ) )THEN
         INFO = 9
      ELSE IF( LDC.LT.MAX( 1, N     ) )THEN
         INFO = 12
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'XDSYR2K', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
C
C     And when  alpha.eq.zero.
C
      IF( ALPHA.EQ.ZERO )THEN
         IF( UPPER )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 20, J = 1, N
                  DO 10, I = 1, J
                     C( I, J ) = ZERO
   10             CONTINUE
   20          CONTINUE
            ELSE
               DO 40, J = 1, N
                  DO 30, I = 1, J
                     C( I, J ) = BETA*C( I, J )
   30             CONTINUE
   40          CONTINUE
            END IF
         ELSE
            IF( BETA.EQ.ZERO )THEN
               DO 60, J = 1, N
                  DO 50, I = J, N
                     C( I, J ) = ZERO
   50             CONTINUE
   60          CONTINUE
            ELSE
               DO 80, J = 1, N
                  DO 70, I = J, N
                     C( I, J ) = BETA*C( I, J )
   70             CONTINUE
   80          CONTINUE
            END IF
         END IF
         RETURN
      END IF
C
C     Start the operations.
C
      IF( LSAME( TRANS, 'N' ) )THEN
C
C        Form  C := alpha*A*B' + alpha*B*A' + C.
C
         IF( UPPER )THEN
            DO 130, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 90, I = 1, J
                     C( I, J ) = ZERO
   90             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 100, I = 1, J
                     C( I, J ) = BETA*C( I, J )
  100             CONTINUE
               END IF
               DO 120, L = 1, K
                  IF( ( A( J, L ).NE.ZERO ).OR.
     $                ( B( J, L ).NE.ZERO )     )THEN
                     TEMP1 = ALPHA*B( J, L )
                     TEMP2 = ALPHA*A( J, L )
                     DO 110, I = 1, J
                        C( I, J ) = C( I, J ) +
     $                              A( I, L )*TEMP1 + B( I, L )*TEMP2
  110                CONTINUE
                  END IF
  120          CONTINUE
  130       CONTINUE
         ELSE
            DO 180, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 140, I = J, N
                     C( I, J ) = ZERO
  140             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 150, I = J, N
                     C( I, J ) = BETA*C( I, J )
  150             CONTINUE
               END IF
               DO 170, L = 1, K
                  IF( ( A( J, L ).NE.ZERO ).OR.
     $                ( B( J, L ).NE.ZERO )     )THEN
                     TEMP1 = ALPHA*B( J, L )
                     TEMP2 = ALPHA*A( J, L )
                     DO 160, I = J, N
                        C( I, J ) = C( I, J ) +
     $                              A( I, L )*TEMP1 + B( I, L )*TEMP2
  160                CONTINUE
                  END IF
  170          CONTINUE
  180       CONTINUE
         END IF
      ELSE
C
C        Form  C := alpha*A'*B + alpha*B'*A + C.
C
         IF( UPPER )THEN
            DO 210, J = 1, N
               DO 200, I = 1, J
                  TEMP1 = ZERO
                  TEMP2 = ZERO
                  DO 190, L = 1, K
                     TEMP1 = TEMP1 + A( L, I )*B( L, J )
                     TEMP2 = TEMP2 + B( L, I )*A( L, J )
  190             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP1 + ALPHA*TEMP2
                  ELSE
                     C( I, J ) = BETA *C( I, J ) +
     $                           ALPHA*TEMP1 + ALPHA*TEMP2
                  END IF
  200          CONTINUE
  210       CONTINUE
         ELSE
            DO 240, J = 1, N
               DO 230, I = J, N
                  TEMP1 = ZERO
                  TEMP2 = ZERO
                  DO 220, L = 1, K
                     TEMP1 = TEMP1 + A( L, I )*B( L, J )
                     TEMP2 = TEMP2 + B( L, I )*A( L, J )
  220             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP1 + ALPHA*TEMP2
                  ELSE
                     C( I, J ) = BETA *C( I, J ) +
     $                           ALPHA*TEMP1 + ALPHA*TEMP2
                  END IF
  230          CONTINUE
  240       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of XDSYR2K.
C
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__XYZ_E0_PCGTO_BLOCK
     +
     +                    ( NBATCH,NINT1D,
     +                      ATOMIC,
     +                      MIJ,NIJ,NIJBEG,NIJEND,
     +                      NPGTOA,NPGTOB,
     +                      NXYZET,NXYZP,
     +                      SHELLA,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      MOMENTX,MOMENTY,MOMENTZ,
     +                      ALPHAA,ALPHAB,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      XP,YP,ZP,
     +                      PAX,PAY,PAZ,PINVHF,SCALE,
     +                      INT1DX,SCRMTX,XMINUS,
     +                      INT1DY,SCRMTY,YMINUS,
     +                      INT1DZ,SCRMTZ,ZMINUS,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_E0_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__XYZ_1D_INTEGRALS
C                OED__XYZ_INT1D_TO_E0
C  DESCRIPTION : This operation calculates a batch of unnormed moment
C                integrals between primitive cartesian gaussians for
C                the shell range:
C
C                              [E|0]   , E = A to P = A + B
C                                   ij
C
C                and the block of ij exponent pairs. The total number
C                of moment integrals generated here is thus given by
C                the total number of cartesian monomials NXYZET times
C                the total number of exponent pairs MIJ in the present
C                block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyzet)
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    integral batch
C                    NINT1D       =  space needed for each of the 1D
C                                    X,Y,Z integral arrays
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZET       =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    E = A,...,P=A+B
C                    NXYZP        =  # of cartesian monomials for
C                                    the P=A+B shell
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B,P
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current MIJ values of
C                                    scaling factors
C                    INT1Dx       =  will hold all current 1D integrals
C                                    for each cartesian component
C                                    (x = X,Y,Z)
C                    SCRMTx       =  scratch matrix to hold x-1 integrals
C                                    (x = X,Y,Z)
C                    xMINUS       =  scratch matrix that holds the (0|x-2|0)
C                                    integrals
C                    MOMENTx      =  tells which power of X,Y, or Z integrals
C                                    to compute
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian moment moment [E|0] 
C                                    integrals
C
C
C  AUTHOR      : Norbert Flocke
C                  - Wrote original OED package
C
C  MODIFIED    : Thomas Watson Jr.                    p  q  r
C                  - Modified OED package to compute X, Y, Z integrals
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     I,J,M
         INTEGER     IJ
         INTEGER     MIJ
         INTEGER     NBATCH,NINT1D
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NXYZET,NXYZP
         INTEGER     SHELLA,SHELLB,SHELLP
         INTEGER     MOMENTX,MOMENTY,MOMENTZ

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  PINV,PVAL
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,HALF,ONE,ONEP5

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  XP (1:NIJ)
         DOUBLE PRECISION  YP (1:NIJ)
         DOUBLE PRECISION  ZP (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  XMINUS  (1:MIJ)
         DOUBLE PRECISION  YMINUS  (1:MIJ)
         DOUBLE PRECISION  ZMINUS  (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)
         DOUBLE PRECISION  SCALE   (1:MIJ)

         DOUBLE PRECISION  INT1DX  (1:NINT1D)
         DOUBLE PRECISION  INT1DY  (1:NINT1D)
         DOUBLE PRECISION  INT1DZ  (1:NINT1D)

         DOUBLE PRECISION  SCRMTX  (1:NINT1D)
         DOUBLE PRECISION  SCRMTY  (1:NINT1D)
         DOUBLE PRECISION  SCRMTZ  (1:NINT1D)

         PARAMETER  (ZERO  = 0.D0)
         PARAMETER  (HALF  = 0.5D0)
         PARAMETER  (ONE   = 1.D0)
         PARAMETER  (ONEP5 = 1.5D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D overlap integrals.
C
C
         IF (ATOMIC) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                PINV = ONE / (ALPHAA (I) + ALPHAB (J))
                XP (M) = XA
                YP (M) = YA
                ZP (M) = ZA
                PAX (M) = ZERO
                PAY (M) = ZERO
                PAZ (M) = ZERO
                PINVHF (M) = HALF * PINV
                SCALE  (M) = (PINV ** ONEP5) * NORMA (I) * NORMB (J)
  100        CONTINUE
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                PINV = ONE / (EXPA + EXPB)
                XP (M) = PINV * (EXPA * XA  +  EXPB * XB)
                YP (M) = PINV * (EXPA * YA  +  EXPB * YB)
                ZP (M) = PINV * (EXPA * ZA  +  EXPB * ZB)
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PINVHF (M) = HALF * PINV
                SCALE  (M) = (PINV ** ONEP5)
     +                       * NORMA (I) * NORMB (J) * RHOAB (IJ)
  110        CONTINUE
         END IF
C
C
C             ...perform the following steps:
C
C                1) construct all 1D x,y,z moment integrals for
C                   all ij pairs.
C
C                2) assemble the complete [E|0] moment batch for all
C                   ij pairs using the 1D integrals. Arrays PAX and PAY
C                   are passed as scratch arrays.
C
C
                CALL    OED__XYZ_1D_INTEGRALS
     +
     +                    ( SHELLP,0,
     +                      ATOMIC,
     +                      MIJ,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      PAX,PAY,PAZ,
     +                      XP,YP,ZP,
     +                      PINVHF,
     +                      ZERO,ZERO,ZERO,
     +                      MOMENTX,MOMENTY,MOMENTZ,
     +                      XMINUS,YMINUS,ZMINUS,
     +                      SCRMTX,SCRMTY,SCRMTZ,
     +
     +                                INT1DX,
     +                                INT1DY,
     +                                INT1DZ )
     +
             CALL    OED__XYZ_INT1D_TO_E0
     +
     +                    ( SHELLA,SHELLP,
     +                      ATOMIC,
     +                      MIJ,
     +                      NXYZET,NXYZP,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      PAX,PAY,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine molden_rdgeom(natoms,iatchrg,coord,ifuchrg,fucoord,
     &                         iunit)
c------------------------------------------------------------------------------
c read coordinates from jobarc 
c------------------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      parameter (nelement=103)
      parameter (btoang=0.52917724924D0)
      character*2 celemol(nelement)
      dimension iatchrg(natoms),ifuchrg(natoms)
      double precision coord(3,natoms), fucoord(3,natoms)
#include "machsp.com"
      data (celemol(i),i=1,nelement)
     & /' H','He',
     & 'Li','Be',' B',' C',' N',' O',' F','Ne',
     & 'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     & ' K','Ca',
     & 'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     & 'Ga','Ge','As','Se','Br','Kr',
     & 'Rb','Sr',
     & ' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     & 'In','Sn','Sb','Te',' I','Xe',
     & 'Cs','Ba','La',
     & 'Ce','Pr','Nd','Pm','Sm','Eu','Gd',
     & 'Tb','Dy','Ho','Er','Tm','Yb','Lu',
     & 'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     & 'Tl','Pb','Bi','Po','At','Rn',
     & 'Fr','Ra','Ac',
     & 'Th','Pa',' U','Np','Pu','Am','Cm',
     & 'Bk','Cf','Es','Fm','Md','No','Lr'/
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      call izero(iatchrg,natoms)
      call zero(coord,3*natoms)
c
c read in the atomic charges and coordinates
c get rid of dummy atoms
c convert from bohr to angstrom
c
      call getrec(20,'JOBARC','ATOMCHRG',natoms,ifuchrg)
      call getrec(20,'JOBARC','COORD',3*natoms*iintfp,fucoord)
      i=1
      do j = 1, natoms
         if (ifuchrg(j).ne.0) then
c            call scopy(3,fucoord(1,j),1,coord(1,i),1)
            coord(1,i)=fucoord(1,j)
            coord(2,i)=fucoord(2,j)
            coord(3,i)=fucoord(3,j)
            iatchrg(i)=ifuchrg(j) 
            i=i+1
         end if
      end do 

      call getrec(20,'JOBARC','NREALATM',1,nrealatm)
      if(i.ne.nrealatm+1)then
        write(6,*)' Problem reading coordinates from JOBARC file'
        call errex
      endif

      natoms = nrealatm
      do i = 1, natoms
         coord(1,i)=coord(1,i)*btoang
         coord(2,i)=coord(2,i)*btoang
         coord(3,i)=coord(3,i)*btoang
      end do

      do i = 1, natoms
         write(iunit,'(A2,4X,i2,1X,i2,3X,f10.6,3X,f10.6,3X,f10.6)')
     &        celemol(iatchrg(i)),
     &        i,
     &        iatchrg(i),
     &        (coord(j,i),j=1,3)
      end do

      return
      end

      SUBROUTINE REFLECT(A,SCRATCH,NATOM,IPLANE)
C
C REFLECTS POINTS IN PLANE
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(3,NATOM),SCRATCH(3,NATOM)
C
      IX(I,J)=MIN(I,J)/MAX(I,J)
C
      DO 10 I=1,NATOM
         DO 10 J=1,3
 10         SCRATCH(J,I)=A(J,I)*(1.D0-2.D0*IX(IPLANE,J))
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine iputrec(iFlag,szArchive,szRecName,iRecLen,iSrc)
c-----------------------------------------------------------------------------
c   Writes integer data to JOBARC file.
c
c   Note: The data on JOBARC is stored as integer*8 for compatibility with
c         the serial ACES II program's format.  So this subroutine converts
c         the data in iDest to 8-byte integers before calling the actual
c         PUTREC routine to write it to JOBARC.
c
c   iflag == 0 --> A record of iRecLen ints is set to 0 and written to JOBARC.
c         != 0 --> Data in iSrc is converted to 8-byte ints, then written 
c                    to JOBARC.
c-----------------------------------------------------------------------------

      implicit none

      integer iFlag, iRecLen, iSrc(*)
      character*(*) szArchive, szRecName

      integer*8 iSrc8(iRecLen)
      integer i

      if (iFlag .ne. 0) then
         
c-----------------------------------------------------------------------------
c   Convert the data.
c-----------------------------------------------------------------------------

         do i = 1, iRecLen
            iSrc8(i) = iSrc(i)
         enddo 
      endif

c----------------------------------------------------------------------------
c   Write the data.
c----------------------------------------------------------------------------

      call putrec(iFlag,szArchive,szRecName,iRecLen,isrc8)
      return
      end

      SUBROUTINE IDERIV(QCS,TMP,DIDQ,NX)
C
C THIS ROUTINE DETERMINES THE FIRST DERIVATIVES OF THE INERTIA
C TENSOR ELEMENTS WITH RESPECT TO THE NORMAL COORDINATES
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL PRINT
      DIMENSION QCS(NX,NX),DIDQ(3,3,NX)
      DIMENSION TMP(NX),TENSORP(3,3),TENSORM(3,3)
      DIMENSION TENSORR(3,3)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      common /linear/ ilinear
      COMMON/FLAGS/IFLAGS(100),IFLAGS2(500)
C
      PRINT=IFLAGS(1).GT.0
C
      fact=0.001d0
      fact2=fact*fact
      CALL GETREC(20,'JOBARC','NORMCORD',IINTFP*NX*NX,QCS)
C
C LOOP OVER NORMAL COORDINATES TO GET LINEAR AND DIAGONAL
C QUADRATIC COEFFICIENTS
C
      CALL SCOPY(NX,XYZ,1,TMP,1)
      CALL INERTIA(TENSORR)
      CALL PUTREC(20,'JOBARC','I4CDCALC',IINTFP*9,TENSORR)
      DO 100 ICOORD=7-ilinear,NX
       CALL SCOPY(NX,XYZ,1,TMP,1)
       CALL SAXPY(NX,FACT,QCS(1,ICOORD),1,TMP,1)
       CALL INERTIA(TENSORP)
       CALL SAXPY(NX,-2.0D0*FACT,QCS(1,ICOORD),1,TMP,1)
       CALL INERTIA(TENSORM)
       DO 101 I=1,3
       DIDQ(I,I,ICOORD)=0.5D0*(TENSORP(I,I)-TENSORM(I,I))/FACT
101    CONTINUE 

       call saxpy(9,-1.0d0,tensorm,1,tensorp,1)
       call sscal(9,0.5d0/fact,tensorp,1)
       call scopy(9,tensorp,1,didq(1,1,icoord),1)
       if(print)then
        write(6,*)' derivatives of inertia tensor for mode ',icoord
        write(6,'((3f20.10))')((didq(i,j,icoord),j=1,3),i=1,3)
       endif
100   CONTINUE
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine bluegene_assign_companies(hosts, nprocs, 
     *                  nproc_per_node,
     *                  company_id, platoon_id)
      implicit none
      include 'company.h'
   
      integer nprocs, nproc_per_node
      integer hosts(nprocs), company_id(nprocs), platoon_id(nprocs)
      integer nodes, ionodes, nworker, nserver, nserver_per_ionode
      integer node, proc, proc_skip

      integer i, j

      do i = 1, nprocs
         company_id(i) = 0
         platoon_id(i) = 0
      enddo
 
      nodes = nprocs / nproc_per_node
      if (nprocs .ne. nodes * nproc_per_node) nodes = nodes + 1
      ionodes = nodes / 64
      if (nodes .ne. ionodes * 64) ionodes = ionodes + 1

      nworker = c_table(1,c_nwrkr)
      nserver = c_table(2,c_nwrkr)
      nserver_per_ionode = nserver / ionodes
      proc_skip = (64*nproc_per_node) / nserver_per_ionode 
      if (nserver .eq. 0) go to 1000

c---------------------------------------------------------------------------
c   Distribute the IOCOMPANY processes evenly among the I/O nodes.
c   On BLUEGENE, each group of 64 compute nodes is mapped to 1 I/O node.
c---------------------------------------------------------------------------      
      do i = 1, ionodes
         proc = (i-1)*64*nproc_per_node + 2
         do j = 1, nserver_per_ionode
            if (proc .gt. nprocs) then
               print *,'PROC overflow'
               print *,'i, j, proc ',i,j,proc
               print *,'nserver, nprocs, ionodes, nserver_per_ionode ',
     *           nserver, nprocs, ionodes, nserver_per_ionode
               print *,'proc_skip ',proc_skip
               call abort_job()
            endif

            company_id(proc) = 2
            platoon_id(proc) = 1 
            proc = proc + proc_skip
         enddo
      enddo
 
1000  continue
      do i = 1, nprocs
         if (company_id(i) .eq. 0) company_id(i) = 1
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine comp_return_h1_nodiag(z, da1, da2, db1, db2, nsend)
c---------------------------------------------------------------------------
c  Computes the set of OED integrals of types  
c
c   type = 1 --> NAI integrals
c          2 --> KIN integrals
c---------------------------------------------------------------------------
      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nsend
      integer da1, da2, db1, db2
      integer adim, bdim
      double precision z(da1:da2, db1:db2)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif

      integer i, ix, m, n, nfirst, nints, nalpha, ncoeff, iatom, ncsum
      integer component
      integer a, b, a1,a2,b1,b2,lastao, igrad
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc
      integer ind(2)
      integer ierr

      integer flopcount
      logical spherical
      logical*8 l8true, l8spherical

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff),
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers),
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, y

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter, dcoord

      integer ECP, ntot
      double precision ecp_erd
      common /FECP/ntot, ecp_erd(2500,2500)

      common /flags/ iflags
      integer iflags(100)

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif
      spherical = (ispherical .eq. 1)
      l8spherical = spherical
      l8true = .false. ! .true.
      lastao = end_nfps(nshells)

c --------------------------------------------------------------------------- 
c  Set up send data. 
c --------------------------------------------------------------------------- 

      adim = da2-da1+1
      bdim = db2-db1+1

      nsend = adim*bdim
      if (nsend .lt. 0) then
         print *,'ERROR IN COMP_FOCK_DER ',me,' nsend = ',nsend
         print *,'adim,bdim = ',adim,bdim
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      ECP = iflags(71)
      do b = db1,db2
      do a = da1,da2
         Z(a,b) = 0.d0
         IF (ECP .EQ. 1) z(a,b) = ecp_erd(a,b)
      enddo
      enddo

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: comp_fock_der requires ERD ',
     *           'integral package.'
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)

c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       do m = m1, m2
       do n = n1, n2
       if (atom(m) .ne. atom(n)) then

            ncsum = ncfps(m) + ncfps(n)
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)

            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff),
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend),
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

c ------------------------------------------------------------------------ 
c  KIN (type=2) integrals next.   
c ------------------------------------------------------------------------ 

              call oed__gener_kin_batch(intmax, zmax, nalpha, ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))

            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

                call add_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2,1.0d0)
             endif ! (nints .gt. 0) then

c ------------------------------------------------------------------------ 
c NAI (type=1) integrals first.   
c ------------------------------------------------------------------------ 

              call oed__gener_nai_batch(intmax, zmax, nalpha, ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 ncenters, xn,yn,zn, charge, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))

               if (nints .gt. 0) then
                  a2 = end_nfps(m)
                  if (m .eq. 1) then
                     a1 = 1
                  else
                     a1 = end_nfps(m-1)+1
                  endif

                  b2 = end_nfps(n)
                  if (n .eq. 1) then
                     b1 = 1
                  else
                     b1 = end_nfps(n-1)+1
                  endif
                 call add_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2,1.0d0)

               endif ! nints 

         endif   ! atom(m) .ne. atom(n) 
         enddo   ! n shells
         enddo   ! m shells

      return
      end

c This routine prints the sum of elements a(1:n) and their L2 vector norm.
c If two vectors produce the same sum but a different norm, then they
c have the same contributions in different distributions. If element
c order is to be checked, then use checksum2.

      subroutine checksum(sTag,a,n)
      implicit none

      character*(*) sTag
      integer n
      double precision a(n)

      double precision sm, nm
      integer i

      sm=0.d0
      nm=0.d0
      do i=1,n
         sm=sm+a(i)
         nm=nm+a(i)*a(i)
      end do
      write(*,'(2a,1x,2e30.16)') '@CHECKSUM: ',sTag,sm,sqrt(nm)

      return
      end

      Subroutine Read_cart_constrains(Constrains, Num_constrains, 
     &                                Not_found)
C
      Implicit double precision (a-h,o-z)

      Character*80 wrk
      Integer Constrains
      Logical Not_found, ZMAT_PRESENT
C
#include "mxatms.par"

      Dimension Constrains(3*mxatms)
  
      Not_found = .False.

      INQUIRE(FILE='ZMAT',EXIST=ZMAT_PRESENT)
C
      IF (ZMAT_PRESENT)THEN
         OPEN(UNIT=4,FILE='ZMAT',FORM='FORMATTED',STATUS='OLD')
         rewind(4)
      else
         write(6,'(T3,a)')'@Read_constrains, ZMAT file not present.'
         call errex
      ENDIF
c
300   READ(4,'(A)', END=900) WRK
      IF (WRK(1:11) .NE.'*CONSTRAINS') goto 300

      READ(4,'(A)', END=900) WRK
      IF (WRK(1:11) .EQ.'*END') GOTO 999
      BACKSPACE(4)

      READ(4,*,END=900) Num_Constrains
     
          READ(4,*,END=900) (Constrains(Iread), Iread=1, Num_constrains)

      GO TO 99
C
900   WRITE(6,901)
901   FORMAT(3x,'@Read_constrains, *CONSTRAINS namelist not found or',
     &       ' incomplete.')
      GO TO 999
C
 999  CONTINUE

      CLOSE(UNIT=4,STATUS='KEEP')
      Write(6,*)
      Write(6,"(3x,2a)") "Constrained Cartesian ",
     &                   "optimization is requested but no constraints"
      Write(6,"(3x,a)")  "are specified in the inputfile (ZMAT)."
      Write(6,"(3x,2a)") "Calculation proceeds as a unconstrained ",
     &                   "optimization."
C
      Not_found = .True.

  99  CONTINUE
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(a)") "The constrain table"
      Write(6, "(1x,6I3)") (Constrains(i), i=1, Num_constrains)
      Write(6,*) "Not found any constrains?",  Not_found
#endif
      CLOSE(UNIT=4,STATUS='KEEP')

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_my_rank(x, nindex, type, bval,
     *                              eval, bdim, edim)
c---------------------------------------------------------------------------
c   Returns the rank of the current processor in the scalar variable.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      double precision x
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      x = me   ! save the rank in the scalar table.
      return
      end

      Subroutine Post_opt_update
c
      Implicit Double Precision (A-H, O-Z)
c
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)




































































































































































































































































































































































































































































































































c     Maximum string length of basis set
      INTEGER BASLEN
      PARAMETER (BASLEN=80)







c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/






c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


c
      Integer Genby(Mxatms) 
      Double Precision Orient(3, 3)
      Character*(baslen) BasNam(Mxatms)
      Character*4 FPGrp, BPGrp, PGrp 
      Character*5, Zsym(Mxatms)
      Dimension Scratch(Mxatms) 
      Logical Can_do_freq 
c
      Common /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
c
      Call Entry(BasNam, .True., Can_do_freq)
c
      Call Getrec(20, 'JOBARC', 'ZMATATMS', 1, NATOMS)
      Call Getrec(20, 'JOBARC', 'LINEAR  ', 1, ILINEAR)
      If (ILINEAR .EQ. 1) Then
          NX   = 3*NATOMS
          NXM6 = NX - 5
      Else
          NX   = 3*NATOMS
          NXM6 = NX -6
      Endif  
c
      Call Getrec(20, "JOBARC", "COORD   ", NX*IINTFP, Q)
      Call Getrec(20, 'JOBARC', 'CONCTVTY', NX, NCON)
      Call Getrec(-1, 'JOBARC', 'CORD_INT', NX*IINTFP, R)
      Call Bohr2angs(R, NX)
      Call Getrec(20, 'JOBARC', 'ATOMMASS', NATOMS*IINTFP,
     &           ATMASS)
      Call Getrec(20, 'JOBARC', 'ORIENTMT', 9*IINTFP,
     &            ORIENT)
      Call Getrec(20, 'JOBARC', 'ATOMCHRG', NATOMS, IATNUM)
      Call Getrec(20, 'JOBARC', 'ICSQUASH', NX, ISQUASH)
      Call Getcrec(20, 'JOBARC', "PTGP    ", 4, FPGRP)
      Call Getcrec(20, 'JOBARC', "ABL_PTGP", 4, BPGRP)
      Call Getcrec(20, 'JOBARC', "CMP_PTGP", 4, PGRP)
      Call Getcrec(20, 'JOBARC', "ZSYM", 5*NATOMS, ZSYM)
           Print*, "The data read from JOBARC in post_opt_update"
           Print*, "The NATOMS:", NATOMS
           Print*, "Internal coords:",(R(I), I=1, NX)
           Print*, "The Cartesian coords:", (Q(I), I=1, NX) 
           print*, "The connectivities:", (NCON(I), I=1, NX)
           Print*, "The atomic charges:", (IATNUM(I), I=1, NX/3)
           Print*, "The point group", PGRP 
c
c The scratch and Nunique are not used. Genby, istat and Genby
c are internal 

      Call MkVMOL(Q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &            GenBy, Scratch, IStat, BasNam)
      
      Print*, "out from Mkvmol in post_opt_update"
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_E0_DEF_BLOCKS
     +
     +               ( ZMAX,
     +                 NPGTOA,NPGTOB,
     +                 SHELLP,
     +                 NIJ,NRS,NCEN,
     +                 NGQP,NGQSCR,
     +                 NXYZT,
     +                 L1CACHE,NCTROW,
     +                 MEMORY,
     +
     +                     NIJBLK,
     +                     NPSIZE,NCSIZE,NWSIZE,
     +                     NINT1D,
     +                     MXPRIM,MNPRIM,
     +                     ZCBATCH,ZPBATCH,ZWORK,
     +                     ZNORMA,ZNORMB,
     +                     ZRHOAB,
     +                     ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +                     ZRTS,ZWTS,ZGQSCR,ZTVAL,
     +                     ZR1X,ZR1Y,ZR1Z,ZR2,
     +                     ZINT1DX,ZINT1DY,ZINT1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_E0_DEF_BLOCKS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the memory partitions for the
C                generation of the entire contracted (e|0) nuclear
C                attraction batch. It determines the block size
C                partitions (if any) for the ij exponent paris of the
C                whole primitive [e|0] batch and returns pointers to
C                the flp data sections needed by the (e|0) generation.
C
C                The routine is also equipped with the possibility
C                of returning just the minimum / optimum flp memory
C                needed, without evaluating the (e|0) generation flp
C                pointers. This is useful for establishing just the
C                overall memory size needed for the (e|0) generation.
C                The keyword MEMORY has to be set true for this case
C                and obviously the value of ZMAX passed is irrelevant.
C
C
C                  Input:
C
C                    ZMAX         =  maximum flp memory
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x=A,B
C                    SHELLP       =  the shell sum A+B
C                    NIJ          =  total # of ij primitive index
C                                    pairs corresponding to the csh
C                                    pairs A,B
C                    NRS          =  total # of rs contraction index
C                                    pairs corresponding to the csh
C                                    pairs A,B
C                    NCEN         =  # of nuclear attraction centers
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    NXYZT        =  total # of cartesian monomial
C                                    pairs
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    MEMORY       =  if this keyword is true, the
C                                    routine will only determine the
C                                    minimum / optimum flp memory and
C                                    store these values into NPSIZE and
C                                    NCSIZE, respectively (see below)
C
C                  Output:
C
C                    NIJBLK       =  contains the block size for the
C                                    ij primitive indices in order to
C                                    perform efficient contractions.
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays.
C                                    If MEMORY is true, NPSIZE and
C                                    NCSIZE will contain respectively
C                                    the minimum and optimum flp memory
C                    NINT1D       =  space needed for the 1D X,Y,Z
C                                    integral arrays
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = max (i,j)
C                    MNPRIM       =  the minimum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = min (i,j)
C                    Z.....       =  pointers for space partition of
C                                    the flp array (see below)
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                 |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                   Zone 1: final (e|0) batch
C                   Zone 2: block [e|0]
C                   Zone 3 : complete set of A,B norms and complete
C                            set (after screening!) of exponential
C                            prefactors and nuclear attraction center
C                            information (coordinates + nuclear charges)
C                   Zone 4 : i) scratch for block [e|0] generation
C                           ii) scratch for (e|0) generation
C
C
C                Memory allocation offsets for the primitive [e|0]
C                batches generation + contraction to (e|0):
C
C
C                  --- Zone 1 ---
C
C                   ZCBATCH = offset for contracted (e|0) batch
C
C                  --- Zone 2 ---
C
C                   ZPBATCH = offset for (blocked) [e|0] batch
C
C                  --- Zone 3 ---
C
C                   ZNORMA = offset for all A norms
C                   ZNORMB = offset for all B norms
C                   ZRHOAB = offset for all AB exponential prefactors
C
C                  --- Zone 4: for block [e|0] generation only ---
C
C                   ZPX = offset for (blocked) PX values
C                   ZPY = offset for (blocked) PY values
C                   ZPZ = offset for (blocked) PZ values
C                   ZPAX = offset for (blocked) PAX values
C                   ZPAY = offset for (blocked) PAY values
C                   ZPAZ = offset for (blocked) PAZ values
C                   ZPINVHF = offset for (blocked) 1/2P values
C                   ZSCALE = offset for (blocked) scale values
C
C                   ZRTS = offset for (blocked) quadrature roots 
C                   ZWTS = offset for (blocked) quadrature weights
C                   ZGQSCR = offset for (blocked) quadrature scratch
C                   ZTVAL = offset for (blocked) T exponents
C
C                   ZR1X = offset for (blocked) VRR coeff R1X
C                   ZR1Y = offset for (blocked) VRR coeff R1Y
C                   ZR1Z = offset for (blocked) VRR coeff R1Z
C                   ZR2 = offset for (blocked) VRR coeff R2
C
C                   ZINT1DX = offset for (blocked) 1DX integrals
C                   ZINT1DY = offset for (blocked) 1DY integrals
C                   ZINT1DZ = offset for (blocked) 1DZ integrals
C
C                  --- Zone 4: for contraction only ---
C
C                   ZWORK = offset for contraction working array
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     MEMORY

         INTEGER     IJDIV
         INTEGER     L1CACHE,NCTROW
         INTEGER     N
         INTEGER     MIJ,MIJBIG,NCEN,MIJCEN,MGIJCEN
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSTEP
         INTEGER     NGQP,NGQSCR
         INTEGER     NIJ,NIJBLK
         INTEGER     NINT1D
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NRS
         INTEGER     NXYZT
         INTEGER     PFACT
         INTEGER     POW2IJ
         INTEGER     SHELLP
         INTEGER     WCOL
         INTEGER     ZMAX
         INTEGER     ZONE12,ZONE3,ZONE4,ZONE4B,ZONE4C
         INTEGER     ZONEMIN,ZONEOPT
         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,ZRHOAB,
     +               ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +               ZRTS,ZWTS,ZGQSCR,ZTVAL,
     +               ZR1X,ZR1Y,ZR1Z,ZR2,
     +               ZINT1DX,ZINT1DY,ZINT1DZ

         DOUBLE PRECISION   DLOG2

         PARAMETER  (DLOG2  =  0.6931471805599D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine optimum size of [e|0] blocks:
C
C                The next few lines of code are among the most
C                important for performance of the entire overlap
C                integral package. Any badly chosen sizes for the
C                primitive blocks has a severe effect on the integral
C                evaluation timing. Two opposite effects have
C                to be considered:
C
C                1) Reuse level 1 cache data as much as possible,
C                   i.e. choose the primitive blocks in such a
C                   way that most of the heavy computational work
C                   is being done reusing data in each cache line.
C
C                2) Choose the size of the primitive blocks as
C                   large as possible observing point 1), to reduce
C                   subroutine call overheads as much as possible.
C
C                After some experimenting, the following procedure
C                was found to work best:
C
C                  i) The optimum [e|0] block size is assumed to
C                     be directly proportional to the level 1 cache
C                     size.
C
C                 ii) The proportionality factor PFACT has to be
C                     determined by 'experiment', running a real
C                     molecular case with fully contracted basis sets.
C
C
         PFACT = 4

         MIJ = PFACT * L1CACHE / NXYZT
         MIJ = MAX (1,MIJ)
         MIJ = MIN (MIJ,NIJ)
C
C
C             ...the optimum block size MIJ has been determined.
C                We have to see now how it fits with the rest of
C                the needed data into the maximum memory given.
C                If necessary subdivide the optimum block size
C                into convenient subblocks that fit into memory.
C
C                The subdivision of the MIJ block is done in such
C                a way that successive powers of 2 are checked as
C                divisors of MIJ. The maximum # of division steps
C                MXSTEP can thus be calculated beforehand by knowing
C                the fact that the smallest subdivided MIJ block
C                is of size 1. The succesive divisors are checked
C                in the following order:
C
C
C                            step  |  div of MIJ
C                           ----------------------
C                              1   |       1
C                              2   |       2
C                              3   |       4
C                              4   |       8
C                              5   |      16
C                             ...         ...
C
C                The routine stops, if even a MIJ block of minimum
C                size 1 cannot be accomodated into the memory.
C
C
         MXPRIM = MAX (NPGTOA,NPGTOB)
         MNPRIM = MIN (NPGTOA,NPGTOB)

         NCSIZE  = NXYZT * NRS

         ZONE3 = NPGTOA + NPGTOB + NIJ
C
C
C             ...if the MEMORY keyword is activated, the routine
C                will only determine the optimum and minimum flp
C                memory (in that order), place them respectively
C                into the NCSIZE and NPSIZE variables and exit.
C
C
         IF (MEMORY) THEN

             MIJCEN  = MIJ * NCEN
             MGIJCEN = NGQP * MIJCEN
             NINT1D  = MGIJCEN * (SHELLP+1)
             NPSIZE  = NXYZT * MIJ
             WCOL    = MNPRIM
             NWSIZE  = NCTROW * WCOL
             NPSIZE  = MAX (NPSIZE,NWSIZE)
             NWSIZE  = NPSIZE
             ZONE12  = NPSIZE + NCSIZE
             ZONE4B  = NGQSCR + MIJCEN + 7*(MIJ+MGIJCEN) + 3*NINT1D
             ZONE4C  = NWSIZE
             ZONE4   = MAX (ZONE4B,ZONE4C)

             ZONEOPT = ZONE12 + ZONE3 + ZONE4

             MIJ     = 1
             MIJCEN  = MIJ * NCEN
             MGIJCEN = NGQP * MIJCEN
             NINT1D  = MGIJCEN * (SHELLP+1)
             NPSIZE  = NXYZT * MIJ
             WCOL    = MNPRIM
             NWSIZE  = NCTROW * WCOL
             NPSIZE  = MAX (NPSIZE,NWSIZE)
             NWSIZE  = NPSIZE
             ZONE12  = NPSIZE + NCSIZE
             ZONE4B  = NGQSCR + MIJCEN + 7*(MIJ+MGIJCEN) + 3*NINT1D
             ZONE4C  = NWSIZE
             ZONE4   = MAX (ZONE4B,ZONE4C)

             ZONEMIN = ZONE12 + ZONE3 + ZONE4

             NPSIZE  = ZONEMIN
             NCSIZE  = ZONEOPT

             RETURN

         ELSE
C
C
C             ...the actual fitting into the maximum memory given.
C
C
             POW2IJ = DLOG ( DFLOAT (MIJ) ) / DLOG2
             MXSTEP = POW2IJ + 1

             IJDIV = 1
             MIJBIG = MIJ

             DO 100 N = 1,MXSTEP

                MIJ = MAX (1, MIJBIG / IJDIV )

                MIJCEN  = MIJ * NCEN
                MGIJCEN = NGQP * MIJCEN
                NINT1D  = MGIJCEN * (SHELLP+1)
                NPSIZE  = NXYZT * MIJ
                WCOL    = MNPRIM
                NWSIZE  = NCTROW * WCOL
                NPSIZE  = MAX (NPSIZE,NWSIZE)
                NWSIZE  = NPSIZE
                ZONE12  = NPSIZE + NCSIZE
                ZONE4B  = NGQSCR + MIJCEN + 7*(MIJ+MGIJCEN) + 3*NINT1D
                ZONE4C  = NWSIZE
                ZONE4   = MAX (ZONE4B,ZONE4C)

                IF (ZONE12+ZONE3+ZONE4.LE.ZMAX) THEN

                    NIJBLK = MIJ
                    NWSIZE = ZMAX - ZONE12 - ZONE3
C
C
C             ...generate the memory allocation pointers.
C
C
                    ZCBATCH = 1
                    ZPBATCH = NCSIZE + 1

                    ZNORMA = ZPBATCH + NPSIZE
                    ZNORMB = ZNORMA + NPGTOA
                    ZRHOAB = ZNORMB + NPGTOB

                    ZPX = ZRHOAB + NIJ
                    ZPY = ZPX + MIJ
                    ZPZ = ZPY + MIJ
                    ZPAX = ZPZ + MIJ
                    ZPAY = ZPAX + MIJ
                    ZPAZ = ZPAY + MIJ
                    ZPINVHF = ZPAZ + MIJ
                    ZSCALE = ZPINVHF + MIJ

                    ZRTS = ZSCALE + MGIJCEN
                    ZWTS = ZRTS + MGIJCEN
                    ZGQSCR = ZWTS + MGIJCEN
                    ZTVAL = ZGQSCR + NGQSCR

                    ZR1X = ZTVAL + MIJCEN
                    ZR1Y = ZR1X + MGIJCEN
                    ZR1Z = ZR1Y + MGIJCEN
                    ZR2 = ZR1Z + MGIJCEN

                    ZINT1DX = ZR2 + MGIJCEN
                    ZINT1DY = ZINT1DX + NINT1D
                    ZINT1DZ = ZINT1DY + NINT1D

                    ZWORK = ZPX

                    RETURN
                END IF

                IJDIV = IJDIV + IJDIV

  100        CONTINUE

             WRITE (*,*) ' Memory allocation failed for (e|0) ! '
             WRITE (*,*) ' NIJ,MIJ = ',NIJ,MIJ
             WRITE (*,*) ' Increase flp memory! '
             WRITE (*,*) ' (oed__nai_e0_def_blocks) '

             STOP

         END IF
C
C
C             ...ready!
C
C
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine reorder_energy(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Calculates the eigenvalues and eigenvectors of a 2-d square matrix.
c   The matrix is also diagonalized on output.
c
c   The eigenvalues are stored in a common block.  
c   The instruction is executed as follows:
c   
c   execute eig Array1 Array2
c
c   where Array1 is the input matrix that is to be diagonalized.
c         Array2 is the matrix whose columns are the eigenvectors of Array1.
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer i, j, n1, n2
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer ind(mx_array_index)
      integer junk

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix.
c---------------------------------------------------------------------------

      array = op(c_result_array)
      evec_array = op(c_op1_array)
      if (array .eq. 0 .or. evec_array .eq. 0) then
         print *,'Error: EIG routine requires 2 array arguments.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      array_type = array_table(c_array_type, array)
      evec_type  = array_table(c_array_type, evec_array)
      if (array_type .ne. static_array .or. 
     *    evec_type .ne. static_array) then
         print *,'Error: Both arrays in EIG routine must be static.'
         call abort_job()
      endif

#ifdef ALTIX
      dptr = dshptr
#endif

      nindex = array_table(c_nindex, array)
      nindex_evec = array_table(c_nindex, evec_array)
      if (nindex .ne. nindex_evec) then
         print *,'Error: Both arrays in EIG must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex_evec,' indices.'
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      iarray = get_index_from_base(address_table(array), x, 2)
      ievec  = get_index_from_base(address_table(evec_array), x, 2)

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index

      call perform_reorder(x(iarray), x(ievec), n1, n2)

      return
      end

      subroutine perform_reorder (array,order,n1,n2)
      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'parallel_info.h'
      integer n1,n2,i,j,k
      integer proot,icnt,ival
      double precision oldval,newval
      double precision array(n1,n2),order(n1,n2)
      double precision temp(n1,n2)

cVFL      if (me .eq. my_company_rank)then

         IF (n1 .LE. 1) THEN
            ORDER (1,1) = 1.0D0
            RETURN
         END IF

         DO I = 1, n1
         DO J = 1, n2
            ORDER (I,J) = 0.0D0

            if (me .eq. my_company_rank)
     *      WRITE (*,*) ' ARRAY (I,J) ', ARRAY (I,J)
         END DO
         END DO

         DO IVAL = 1, n1
            ICNT = 0
            OLDVAL = array (1,1)
            if (me .eq. my_company_rank)
     *      WRITE (*,*) ' ARRAY (1,1) - ', ARRAY(1,1)
            DO k = 1, n2
               DO i = 2, n1

                  IF (OLDVAL .GT. ARRAY (I,K)) THEN
                     OLDVAL = ARRAY (I,K)
                     if (me .eq. my_company_rank)
     *               WRITE (*,*) '   NEW OLDVAL - ', OLDVAL,I
                     ICNT = I
                  END IF

               END DO

               IF ((IVAL .EQ. 1) .AND. (ICNT .EQ. 0)) THEN
                  ARRAY (1,K) = 9 999.0D0
                  ORDER (1,K) = 1.0D0
               END IF

               IF (ICNT .GT. 0) THEN
                  ARRAY (ICNT,K) = 9 999.0D0
                  ORDER (ICNT,K) = DBLE (IVAL)
               END IF
            END DO
         END DO

         if (me .eq. my_company_rank) then 
         write (*,*) ''
         do j = 1, n2
         do i = 1, n1
            write(*,*) 'Order array - ', order(i,j)
         enddo
         enddo
         endif 

cVFL      endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c The purpose of this routine is to set the number of CACHE_RECS and
c the FILE_RECSIZE based on the MEMORY_SIZE.  The goals are to use 5%
c of ICORE for the I/O cache and to have between 32 and 128
c CACHE_RECS.  We will start with a FILE_RECSIZE of 64 KB and vary it
c to match these goals.

c SG 11/15/97

#define _MAX_CACHE_SLOTS 128 /* from acescore/include/cache.com */

      SUBROUTINE FIGIO(TOTMEM,RECNUM,RECSIZ)
      IMPLICIT NONE

      INTEGER TOTMEM, RECNUM, RECSIZ

c This is the default record size, in bytes. It should be some (large)
c multiple of 512.
cYAU
c   If records will be used will with common indices (e.g., a(i)=b(i)+c(i)),
c then these should NOT be large powers of two like 512, 1024, etc. They
c should certainly be aligned on 128 Byte boundaries, but definitely not
c large powers of two. Search online for 'cache optimization pad'.
      INTEGER DEFSIZ
      PARAMETER (DEFSIZ = 64 * 1024)

      INTEGER MEMUSE
      LOGICAL ADJSIZ, ADJNUM, bTmp1, bTmp2

#include "machsp.com"

c Figure out five percent of MEMORY_SIZE.
      MEMUSE = (TOTMEM / 20)
      ADJSIZ = (RECSIZ .LE. 0)
      ADJNUM = (RECNUM .LE. 0)

      IF ((ADJSIZ .OR. ADJNUM) .AND. (MEMUSE .LT. 32)) THEN
         PRINT *, '@FIGIO: MEMORY_SIZE is too small.'
         CALL ERREX
      END IF

c Calculate the number of records with the default record size
      IF (ADJSIZ) RECSIZ = DEFSIZ / IINTLN

      IF (ADJNUM) THEN

         bTmp1 = .true.
         do while (bTmp1)
            RECNUM = MEMUSE / RECSIZ
            IF (RECNUM .LT. 32) THEN
               IF (ADJSIZ) THEN
c               o Reduce record size
                  RECSIZ = RECSIZ / 2
               ELSE
                  RECNUM = 32
                  bTmp1  = .false.
               END IF
            ELSE
               IF (RECNUM .GT. _MAX_CACHE_SLOTS) THEN
                  IF (ADJSIZ) THEN
c                  o Increase record size
                     RECSIZ = RECSIZ * 2
                  ELSE
                     RECNUM = _MAX_CACHE_SLOTS
                     bTmp1  = .false.
                  END IF
               ELSE
                  bTmp1 = .false.
               END IF
            END IF
c        end do while (.bTmp1)
         end do

      ELSE

         IF (ADJSIZ) THEN
            bTmp2 = .true.
            do while (bTmp2)
               IF ((RECNUM * RECSIZ) .GT. MEMUSE) THEN
c               o Reduce record size
                  RECSIZ = RECSIZ / 2
               ELSE
                  IF ((RECNUM * RECSIZ) .LT. MEMUSE / 2) THEN
c                  o Increase record size
                     RECSIZ = RECSIZ * 2
                  ELSE
c                  o quit
                     bTmp2 = .false.
                  END IF
               END IF
c           end do while (bTmp2)
            end do
c        END IF (ADJSIZ)
         END IF

c     END IF (ADJNUM)
      END IF

c   o override values that are too large
      if (recsiz.gt.262144) then
c      o reduce to 1MB (32-bit) or 2MB (64-bit)
         if (.not.adjsiz) then
            print *, '@FIGIO: reducing records to ',3-iintfp,' MB'
         end if
         if (adjnum) then
            recnum = totmem/5242880
         else
c         o This is a bad convention. The user should be allowed only to
c           specify the size of the cache in units of bytes or as a percentage
c           of MEMSIZE.
            print *, '@FIGIO: increasing number of cache slots'
            recnum = recsiz*recnum/262144
         end if
         recsiz = 262144
         recnum = min(recnum,_MAX_CACHE_SLOTS)
      end if

      RETURN
      END

      SUBROUTINE UPDMOI(LSTDIS,DISSIZ,LSTSPN,LSTNUM,IENTER,IOFF)
C
C UPDATES THE MOIO AND MOIOWD VECTORS WHEN YOU WRITE A NEW LIST.
C
C     LSTDIS= NUMBER OF DISTRIBUTIONS IN THE LIST.
C     DISSIZ= THE SIZE OF THE INDIVIDUAL DISTRIBUTIONS (IN FP WORDS).
C     LSTSPN= "SPIN CASE" FOR LIST [I OF MOIO(I,J)].
C     LSTNUM= NUMBER FOR LIST [J OF MOIO(I,J)].
C     IENTER= 0 UNLESS THE MOINTS FILE IS NEW.  1 IS USED THEN.
C              AT THE END OF EXECUTION OF A LINK, CALL THIS
C              WITH A '2', AND IT WILL WRITE OUT TOTREC TO JOBARC.
C              AT BEGINNING, A '3' WILL INITIALIZE THE VALUE.
C     IOFF  = -1 BEGINS LIST ON A PHYSICAL RECORD BOUNDARY.
C                ANY OTHER VALUE BEGINS AT FIRST AVAILABLE WORD.
C
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*8 NAMES(5)
      CHARACTER*80 FNAME
      LOGICAL YESNO,YESNO1,YESNO2
cjp modified
      DIMENSION ITOPRC(5),JUNK(8192)
      COMMON / / ICORE(1)
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MACHSP2/MASK1,MASK2,ISHFSZ
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /FLAGS/  IFLAGS(100)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFFX(2),LENREC
      COMMON /CACHEINF/ CACHSIZ,CACHSZP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      DATA NAMES /'MOINTS  ','GAMLAM  ','MOABCD  ','DERINT  ',
     &            'DERGAM  '/
cjp      SAVE TOTREC,TOTWRD
      common/io_ptrs/TOTREC(5),TOTWRD(5)
cjp
#include "bwcc.com"
C
      IPACK(I,J)=IOR(J,ISHFT(I-49,ISHFSZ))
      UPACKR(I) =IAND(I,MASK1)
      UPACKF(I) =IAND(ISHFT(I,-ISHFSZ),MASK2)+49
cjp
      if(bwgossip) write(6,*)'UPDMOI: iref',iref,'LSTDIS DISSIZ LSTSPN',
     & ' LSTNUM IENTER IOFF', LSTDIS,DISSIZ,LSTSPN,LSTNUM,IENTER,IOFF
cjp
      CALL IZERO(JUNK,8192)
      DO 1001 I=1,5
       ITOPRC(I)=TOTREC(I)
1001  CONTINUE
      IFIVE=5
cjpNOTE:@@@@ dangerous - totrec, etc stored in JOBARC, which is not replicated
cjp we assume that  files for all irefs will grow to the same size!
cjp during run of the job these must be replicated
cjp this is totally incompatible with symmetry treatment
      IF(IENTER.EQ.2)THEN
cjp
       if(bwgossip) write(6,*)'UPDMOI iref=',iref,' TOTRECMO',TOTREC
       if(bwgossip) write(6,*)'UPDMOI iref=',iref,' TOTWRDMO',TOTWRD
       CALL PUTREC(20,'JOBARC','TOTRECMO',IFIVE,TOTREC)
       CALL PUTREC(20,'JOBARC','TOTWRDMO',IFIVE,TOTWRD)
       RETURN
      ENDIF
      IF(IENTER.EQ.3)THEN
       CALL GETREC(20,'JOBARC','TOTRECMO',IFIVE,TOTREC)
       CALL GETREC(20,'JOBARC','TOTWRDMO',IFIVE,TOTWRD)
       if(bwgossip) write(6,*)'UPDMOI iref=',iref,' TOTRECMO',TOTREC
       if(bwgossip) write(6,*)'UPDMOI iref=',iref,' TOTWRDMO',TOTWRD
       RETURN
      ENDIF
      ITYPE=1+(LSTNUM-1)/100
      IF(IENTER.EQ.1)THEN
       if(bwgossip) write(6,*)'UPDMOI iref=',iref,
     &    ' IENTER=1, TOTRECMO zeroed'
       TOTREC(ITYPE)=1
       TOTWRD(ITYPE)=0
       ITOPRC(ITYPE)=0
      ENDIF
cpn
cjp      print *,'LSTDIS',lstdis,'   DISSIZ',dissiz,'  LSTSPN',lstspn,
cjp     +     '  LSTNUM',lstnum
cpn end
c
c  updmoi should not be used to change size of an exisiting list
c
      IF ( MOIO(LSTSPN,LSTNUM) .NE. 0 ) then
         if ( MOIOSZ(LSTSPN,LSTNUM).eq.DISSIZ .and.
     $        MOIODS(LSTSPN,LSTNUM) .eq. LSTDIS ) then
            if(bwgossip) write(6,*)
     +         ' UPDMOI: list already present, returning!'
            RETURN
         else
            write (6,*) 'tried to change size of exisiting list: ',
     $         lstspn, ',', lstnum
            write (6,*) 'current: distributions -- ',
     $         moiods(lstspn,lstnum), ' size -- ', moiosz(lstspn,lstnum)
            write (6,*) 'requested: distributions -- ',
     $         lstdis, ' size -- ', dissiz
            call errex
         endif
      endif
cjp
C
C ASSIGN MOIO(LSTSPN,LSTNUM) AND MOIOWD(LSTSPN,LSTNUM) AND THE FILE NUMBER
C
      IFILE=ITYPE+49
      CALL GFNAME(NAMES(ITYPE),FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO1,OPENED=YESNO2)
      IF(.NOT.YESNO1.OR..NOT.YESNO2)THEN
       CALL ACES_IO_OPEN(ITYPE)
      ENDIF


      MOIOSZ(LSTSPN,LSTNUM)=DISSIZ
      MOIODS(LSTSPN,LSTNUM)=LSTDIS
      MOIOFL(LSTSPN,LSTNUM)=IFILE

      IF(IOFF.EQ.-1)THEN
C
C LISTS STARTS ON A PHYSICAL RECORD BOUNDARY.
C
       MOIOWD(LSTSPN,LSTNUM)=1
       TOTREC(ITYPE)=TOTREC(ITYPE)+1
       MOIO(LSTSPN,LSTNUM)=TOTREC(ITYPE)
       TOTWRD(ITYPE)=0
      ELSE
       MOIOWD(LSTSPN,LSTNUM)=TOTWRD(ITYPE)+1
       IF(TOTWRD(ITYPE).EQ.IPRCWD)THEN
        MOIOWD(LSTSPN,LSTNUM)=1
        TOTREC(ITYPE)=TOTREC(ITYPE)+1
       ENDIF
       MOIO(LSTSPN,LSTNUM)=TOTREC(ITYPE)
      ENDIF
C
C COMPUTE TOTAL NUMBER OF WORDS IN LIST.
C
      NWORDS=LSTDIS*DISSIZ*IINTFP
C
C COMPUTE THE NUMBER OF FULL RECORDS THIS WILL TAKE UP.  USUALLY THIS
C   WILL BE ZERO.  ALSO COMPUTE HOW MANY WORDS OF A PARTIAL RECORD ARE
C   REQUIRED (OFTEN JUST NWORDS).
C
      NFULL=NWORDS/IPRCWD
      NPART=MOD(NWORDS,IPRCWD)
C
C INCREMENT TOTREC BY THE NUMBER OF FULL RECORDS THAT THIS WILL TAKE UP.
C
      TOTREC(ITYPE)=TOTREC(ITYPE)+NFULL
C
C COMPUTE POSITION OF LAST WORD WRITTEN IN PARTIAL RECORD.  IF THE LOGIC
C  RECORD GOES ACROSS A PHYSICAL RECORD BOUNDARY, INCREMENT TOTREC BY ON
C
      NLEFT=IPRCWD-TOTWRD(ITYPE)
      IF(NLEFT.GE.NPART)THEN
       TOTWRD(ITYPE)=TOTWRD(ITYPE)+NPART
      ELSE
       TOTWRD(ITYPE)=NPART-NLEFT
       TOTREC(ITYPE)=TOTREC(ITYPE)+1
      ENDIF
C
C WRITE AN EMPTY BUFFER TO RECORD RECORD IF IT IS BEYOND EOF.
C
      IF(TOTREC(ITYPE).GT.ITOPRC(ITYPE))THEN
C
C FLUSH CURRENT CONTENTS OF CACHE #1
C
       IF(CACHMOD(1).NE.0)THEN
        IFILE0=CACHFILE(1)
        IREC  =UPACKR(CACHDIR(1))
        CALL ACES_IO_WRITE(IFILE0,IREC,ICORE(CACHPOS(1)),ICHCSZ)
        CACHMOD(1)=0
       ENDIF
       if(bwgossip) write(6,*)' updmoi: enlarging file by zeroes,',
     &    ' iref, ifile,TOTREC(ITYPE)', iref,ifile,TOTREC(ITYPE)
       CALL IZERO(ICORE(CACHPOS(1)),ICHCSZ)
       CALL ACES_IO_WRITE(IFILE,TOTREC(ITYPE),ICORE(CACHPOS(1)),ICHCSZ)
       CACHDIR(1)=0
       CACHFILE(1)=0
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__MOVE_RY
     +
     +                    ( NINTGRL,NINDEX,
     +                      NOTMOVE,MOVE,NRY,
     +                      INDEX,
     +                      TILE,
     +                      X,
     +
     +                             IXOFF,
     +                             Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__MOVE_RY
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__TRANSPOSE_BATCH
C                OED__MAP_IJKL_TO_IKJL
C  DESCRIPTION : This routine moves all ry-components located on the
C                far right in array X to a specific position to the left
C                in array Y:
C
C                     X (1,2,3,...,RY) ---> Y ( 1, 2, 3,...)
C                                   |          |  |  |   |
C                                    --->------^--^--^...^
C
C                The part of X that is not moved (i.e. the # of
C                invariant indices to the left in X) has been calculated
C                beforehand and is transmitted through argument.
C
C
C                  Input:
C
C                       NINTGRL    =  total # of integrals
C                       NINDEX     =  total # of possible target places
C                       NOTMOVE    =  inactive # of indices
C                       MOVE       =  # of indices that will be moved
C                       NRY        =  # of ry-components to be moved
C                       INDEX      =  place 1,2,3,... to which the
c                                     ry-components will be placed in
C                                     array Y (must be within the range
C                                     1 =< INDEX =< NINDEX)
C                       TILE       =  the level 1 cache tile
C                       X          =  initial set of integrals
C                       IXOFF (I)  =  NINDEX-fold array indicating total
C                                     # of elements preceeding place
C                                     I = 1,2,3,... before the move
C                                     (with IXOFF(1)=1)
C
C                  Output:
C
C                       IXOFF (I)  =  updated NINDEX-fold array
C                                     indicating total # of elements
C                                     preceeding place I = 1,2,3,...
C                                     after the move
C                       Y          =  final set of integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I
         INTEGER    INDEX
         INTEGER    MOVE
         INTEGER    NINDEX
         INTEGER    NINTGRL
         INTEGER    NOTMOVE
         INTEGER    NRY
         INTEGER    TILE

         INTEGER    IXOFF (1:NINDEX)

         DOUBLE PRECISION   X (1:NINTGRL)
         DOUBLE PRECISION   Y (1:NINTGRL)
C
C
C------------------------------------------------------------------------
C
C
C             ...check, if the move is simply a transposition
C                or a more general ijkl -> ikjl move.
C
C
         IF (NOTMOVE.EQ.1) THEN

             CALL  OED__TRANSPOSE_BATCH
     +
     +                  ( MOVE,NRY,
     +                    TILE,
     +                    X,
     +
     +                           Y )
     +
     +
         ELSE

             CALL  OED__MAP_IJKL_TO_IKJL
     +
     +                  ( NOTMOVE,MOVE,NRY,1,
     +                    TILE,
     +                    X,
     +
     +                           Y )
     +
     +
         END IF
C
C
C             ...update IXOFF values.
C
C
         DO 10 I = INDEX,NINDEX
            IXOFF (I) = IXOFF (I) * NRY
   10    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
C
C THIS ROUTINE LOADS THE T1AA AND T1BB VECTORS INTO THE VERY TOP OF
C  CORE, AND RETURNS A POINTER ARRAY GIVING THE OFFSETS WHERE EACH
C  IRREP OF THE TWO SPIN CASES BEGINS.  FOR RHF, THE ADDRESSES OF THE
C  AA AND BB T1 VECTORS ARE IDENTICAL AND ONLY ONE IS HELD.
C
C  PARAMETERS:
C              ICORE - THE CORE VECTOR (T1 RETURNED AT TOP)
C             MAXCOR - THE TOTAL CORE SIZE 
C              MXCOR - THE SIZE OF CORE BELOW THE START OF THE T1 VECTORS.
C               IUHF - THE UHF/RHF FLAG
C             IOFFT1 - A TWO DIMENSIONAL ARRAY GIVING THE ADDRESS OF
C                       THE BEGINNING OF EACH IRREP IN THE T1 VECTOR.
C                       FOR EXAMPLE, IOFFT1(3,2) GIVES THE ADDRESS OF
C                       THE FIRST ELEMENT OF THE THIRD IRREP FOR SPIN
C                       CASE 2 (BB).
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2),ITSTART(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,NF1BB,NF2BB
      MXCOR=MAXCOR
C
C COMPUTE OFFSETS FOR BEGINNING OF T1AA AND T1BB (1000 LOOP) AND OFFSETS FOR
C  BEGINNING OF IRREPS (2000 LOOP).
C
      TLIST=90
      DO 1000 ISPIN=2,2-IUHF,-1
       TLIST2=ISPIN
       IF(IUHF.EQ.0)TLIST2=1
       NLIST=22+ISPIN
       IF(IUHF.EQ.0)THEN
        NLIST=23
        TLIST=90
       ENDIF
       T1SIZ=IRPDPD(1,ISYTYP(1,NLIST))
       ITSTART(ISPIN)=MXCOR-T1SIZ*IINTFP+1
       IF(IUHF.EQ.0)ITSTART(1)=ITSTART(2)
       MXCOR=MXCOR-T1SIZ*IINTFP
       IOFF=ITSTART(ISPIN)
       DO 2000 IRREP=1,NIRREP
        IOFFT1(IRREP,ISPIN)=IOFF
        IF(IUHF.EQ.0)IOFFT1(IRREP,1)=IOFF
        IOFF=IOFF+VRT(IRREP,ISPIN)*POP(IRREP,ISPIN)*IINTFP
2000   CONTINUE
       CALL GETLST(ICORE(ITSTART(ISPIN)),1,1,1,TLIST2,TLIST)
1000  CONTINUE
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_list_to_blocks_msg(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_list_to_blocks message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'block_index.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, j, istart, nsearch, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind, imsg
      integer msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile, nxt
      integer status(MPI_STATUS_SIZE)
      integer array, nindex, tag, f_form_msg_tag 
      integer msglen
      integer msg(100)
      integer*8 offset, index_file_loc
      integer fh, fhndx, mode
      integer block_index_entry(lblk_index_entry)
      integer request
      integer ptr, find_server_table_ptr
      integer nind, iblk, nb_total
      integer istat, find_free_diskloc, f_backupram
      logical flag
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      save fh, fhndx

#ifdef ALTIX
      dptr = dshptr
#endif

      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then
         array = server_msg(c_msg_array,node)
         if (array .eq. 0) then

c--------------------------------------------------------------------------
c   We are being signalled to open the BLOCKDATA files.  More messages 
c   with array info are coming later.
c--------------------------------------------------------------------------

            mode = MPI_MODE_RDONLY
            call mpi_file_open(mpi_comm_world, 'BLOCKDATA', mode,
     *                   MPI_INFO_NULL, fh, ierr)
            offset = 0
            call mpi_file_set_view(fh, offset, MPI_DOUBLE_PRECISION,
     *                       MPI_DOUBLE_PRECISION, 'native',
     *                       MPI_INFO_NULL, ierr)

            call mpi_file_open(mpi_comm_world, 'BLOCK_INDEX', mode,
     *                   MPI_INFO_NULL, fhndx, ierr)
            offset = 0
            call mpi_file_set_view(fhndx, offset, MPI_INTEGER,
     *                       MPI_INTEGER, 'native',
     *                       MPI_INFO_NULL, ierr)

            server_msg(c_msg_state,node) = null_state
            return 
         else if (array .eq. list_to_blocks_done) then
        
c----------------------------------------------------------------------------
c   Signal to close the files.
c----------------------------------------------------------------------------

            call mpi_file_close(fh, ierr)
            call mpi_file_close(fhndx, ierr)
 
            server_msg(c_msg_state,node) = null_state
            return
         endif

c---------------------------------------------------------------------------
c   Locate the server_table entries for this array.
c---------------------------------------------------------------------------

         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               istart = served_array_entry(i)
               nsearch = served_numblocks(i)
               go to 50
            endif
         enddo

c---------------------------------------------------------------------------
c   Array not found on this server.   We have nothing to do.
c---------------------------------------------------------------------------

         go to 1000
 
   50    continue
         indblk = get_index_from_base(base_mem_addr, x, 2)
         index_file_loc = blk_to_list_offset(1,node)
         offset         = blk_to_list_offset(2,node)
         nb_total       = blk_to_list_offset(3,node)

c---------------------------------------------------------------------------
c   Calculate the index of the message buffer.
c--------------------------------------------------------------------------

         msgbuffer = server_msg(c_msg_msgbuffer,node)
         imsg = indblk + (msgbuffer-1)* server_mem_blocksize

         do iblock = 1, nb_total

c--------------------------------------------------------------------------
c   Read data for this block from the index file.
c--------------------------------------------------------------------------

            call mpi_file_read_at(fhndx, index_file_loc,
     *                     block_index_entry, lblk_index_entry,
     *                     MPI_INTEGER, status,
     *                     ierr)

            index_file_loc = index_file_loc + lblk_index_entry

c----------------------------------------------------------------------------
c   Create dummy info in the message node for use in the table search routine.
c----------------------------------------------------------------------------

            server_msg(c_msg_type,node) =  
     *                                  server_list_to_blocks_msg
            server_msg(c_msg_array,node) =  array   ! use current array
            server_msg(c_msg_source,node) = 0
            server_msg(c_msg_nind,node)   = 
     *                           block_index_entry(c_blk_index_nind)
            nind = server_msg(c_msg_nind,node)
            server_msg(c_msg_iblk,node)   = 
     *                        block_index_entry(c_blk_index_blkno)
            server_msg(c_msg_size,node)   = 
     *                           block_index_entry(c_blk_index_size)
            server_msg(c_msg_state,node)  = begin_state
            server_msg(c_msg_cause,node)  = null_cause
            server_msg(c_msg_memptr,node) = 0
            server_msg(c_msg_flag,node)   = 0
            do i = 1, mx_array_index
               if (i .gt. nind) then
                  server_msg(c_msg_bsegs+i-1,node) = 0
                  server_msg(c_msg_esegs+i-1,node) = 0
               else
                  server_msg(c_msg_bsegs+i-1,node) = 
     *               block_index_entry(c_blk_index_bsegs+i-1)
                  server_msg(c_msg_esegs+i-1,node) =
     *               block_index_entry(c_blk_index_esegs+i-1)
               endif
            enddo

c----------------------------------------------------------------------------
c   Find a match for this data in the server_table.
c----------------------------------------------------------------------------

            ptr = find_server_table_ptr(node,server_table,
     *                                  nserver_table, .false.)
            size = server_msg(c_msg_size,node)

            if (ptr .gt. 0) then
               server_msg(c_msg_stptr,node) = ptr
               server_table(c_server_iblk,ptr) = 
     *                      server_msg(c_msg_iblk,node)

c-------------------------------------------------------------------------
c   Read block from disk.
c-------------------------------------------------------------------------

               call mpi_file_read_at(fh, offset, x(imsg),
     *                  size, MPI_DOUBLE_PRECISION, status,
     *                  ierr)

c---------------------------------------------------------------------------
c   Write the data to the server's SCR file.
c---------------------------------------------------------------------------

               diskloc = server_table(c_server_diskloc,ptr)
               ifile   = server_table(c_server_file,ptr)
               if (diskloc .eq. 0) then
                  diskloc = find_free_diskloc(ifile, server_table,
     *                                   nserver_table)
                  if (diskloc .lt. 0) then
                     next_server_diskloc(ifile) =
     *                 next_server_diskloc(ifile) + 1
                     diskloc = next_server_diskloc(ifile)
                  endif

                  server_table(c_server_diskloc,ptr) = diskloc
               endif

               istat =  f_backupram(server_unit(ifile), diskloc,
     *                           server_blocksizes(ifile),
     *                           x(imsg), size)
               if (istat .ne. 0)
     *            call server_abort_job(server_table,
     *                                  nserver_table)
            endif   ! ptr > 0

            offset = offset + size
         enddo   ! iblock
 
c--------------------------------------------------------------------------
c   Complete the processing of this message by entering the null state.
c--------------------------------------------------------------------------

1000     continue   
         server_msg(c_msg_state,node) = null_state   ! done
      endif   ! state
      return
      end

      SUBROUTINE T1RB02(ICORE,MAXCOR,IUHF,LAMBDA)
C
C THIS SUBROUTINE COMPUTES TWO T1*W CONTRIBUTIONS TO THE
C  W(mbej) INTERMEDIATE.  
C
C     W(mBEj) =  SUM T(j,f) * <fE|mB> - SUM T(N,B) * <mN|jE>
C     W(MbeJ) =  SUM T(J,F) * <Fe|Mb> - SUM T(n,b) * <Mn|Je> (UHF only)
C
C ALSO COMPUTE ONE OF THE CONTRIBUTIONS TO THE F(ea) INTERMEDIATE:
C
C     F(EA)   = SUM T(m,f) * <fE|mA> 
C     F(EA)   = SUM T(M,F) * <Fe|Ma>  (UHF only)
C
C BY TAKING A GENERALIZED TRACE OVER THE FIRST TERM IN THE FIRST TWO EQUATIONS
C  ABOVE.
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL LAMBDA
      DOUBLE PRECISION ONE,ONEM,ZILCH,ALPHA,BETA,FACTOR
      CHARACTER*4 SSTSPN(2)
      LOGICAL INCORE,RHF
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2),IOFFZL(8,4),SIZEVV(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,
     &             NF1BB,NF2BB
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
      DATA SSTSPN /'ABAB','BABA'/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
C
C FIRST PICK UP T1 VECTOR.
C
      CALL GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
      RHF=.FALSE.
      IF(IUHF.EQ.0)RHF=.TRUE.
      LSTFEA=92
C
C COMPUTE SIZES OF A FULL VV DISTRIBUTION WHICH TRANSFORMS AS THE
C  TOTALLY SYMMETRIC REP.
C
      CALL IZERO(SIZEVV,2)
      DO 3000 ISPIN=1,2
       DO 3001 IRREP=1,NIRREP
        SIZEVV(ISPIN)=SIZEVV(ISPIN)+VRT(IRREP,ISPIN)*VRT(IRREP,ISPIN)
3001   CONTINUE
3000  CONTINUE

C
C SPIN CASES BAAB AND ABBA, RESPECTIVELY.
C
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=57+ISPIN
       IF(LAMBDA)THEN
        LSTOUT=124+ISPIN
        FACTOR=ONEM
       ELSE
        LSTOUT=LSTTAR
        FACTOR=ONE
       ENDIF
C
C LOOP OVER IRREPS - IN THE FIRST BLOCK OF CODE THIS CORRESPONDS TO mB,
C                    WHILE IT IS jE IN THE SECOND BLOCK.
C
C
C
       DO 20 IRREPDO=1,NIRREP

C
C COMPUTE OFFSETS INTO AN i,A DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 1)
C                         I,a DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 2)
C                         b,M DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 3)
C                         B,m DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 4)
C
        IOFF1=0
        IOFF2=0
        IOFF3=0
        IOFF4=0
        DO 1001 IRREPA=1,NIRREP
         IRREPM=IRREPA
         IRREPI=DIRPRD(IRREPA,IRREPDO)
         IRREPB=IRREPI
         IOFFZL(IRREPA,1)=IOFF1
         IOFFZL(IRREPA,2)=IOFF2
         IOFFZL(IRREPM,3)=IOFF3
         IOFFZL(IRREPM,4)=IOFF4
         IOFF1=IOFF1+POP(IRREPI,2)*VRT(IRREPA,1)
         IOFF2=IOFF2+POP(IRREPI,1)  *VRT(IRREPA,2)
         IOFF3=IOFF3+VRT(IRREPB,2)*POP(IRREPM,1)
         IOFF4=IOFF4+VRT(IRREPB,1)  *POP(IRREPM,2)
1001    CONTINUE
C
C COMPUTE DIMENSIONS OF TARGET MATRIX.
C
        DISTAR=aces_list_cols(IRREPDO,LSTTAR)
        DSZTAR=aces_list_rows(IRREPDO,LSTTAR)
        TARSIZ=DISTAR*DSZTAR
C
C FIRST DO  W(mBEj) =   SUM T(j,f) * <Ef|Bm>  
C           W(MbeJ) =   SUM T(J,F) * <Fe|Mb>  (UHF only)
C
C THIS PRODUCT IS INITIALLY PACKED jE-Bm [Je-Mb].
C
        LISTW1=31-ISPIN
        DISW  =aces_list_cols(IRREPDO,LISTW1)
        DSZW  =aces_list_rows(IRREPDO,LISTW1)
C
C I000 HOLDS THE W(jEmB) TARGET FOR GAMMA(mB).
C I010 HOLDS AREA EVENTUALLY USED AS SCRATCH IN SYMTR1a
C I011 AND I012 SCRATCH ARRAYS FOR SYMTR1.
C I020 HOLDS THE <Ef||Bm> INTEGRALS.
C
        I000  =1
        I010  =I000+IINTFP*DISTAR*DSZTAR
        I011  =I010+IINTFP*MAX(DSZTAR,DISTAR,DSZW,SIZEVV(ISPIN))
        I012  =I011+IINTFP*MAX(DSZTAR,DISTAR)  
        I020  =I012+IINTFP*MAX(DSZTAR,DISTAR)
        I030  =I020+IINTFP*DSZW*DISW
        CALL IZERO(ICORE,IINTFP*DISTAR*DSZTAR)
        IF(I030.LE.MXCOR)THEN
         INCORE=.TRUE.
         CALL GETLST(ICORE(I020),1,DISW,2,IRREPDO,LISTW1)
        ELSE
         INCORE=.FALSE.
         I030=I020+IINTFP*DSZW
        ENDIF
        DO 30 INUMBM=1,DISW
         IF(INCORE)THEN
         IOFFW1R=(INUMBM-1)*DSZW*IINTFP+I020
         ELSE
          CALL GETLST(ICORE(I020),INUMBM,1,2,IRREPDO,LISTW1)
          IOFFW1R=I020
         ENDIF
         IOFFW1L=0
         IOFFZR=(INUMBM-1)*DSZTAR*IINTFP+I000
         IF(ISPIN.EQ.1)THEN
         DO 40 IRREPF=1,NIRREP
           IRREPE=DIRPRD(IRREPF,IRREPDO)
           IRREPT=IRREPF
           IOFFT =IOFFT1(IRREPT,2)
           IOFFW1=IOFFW1R+IOFFW1L
           IOFFZ =IOFFZR+IOFFZL(IRREPE,1)*IINTFP
           NROW=POP(IRREPT,2)
           NCOL=VRT(IRREPE,1)
           NSUM=VRT(IRREPT,2)
           ALPHA=ONE*FACTOR
           BETA=ZILCH
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('T','T',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NSUM,
     &                 ICORE(IOFFW1),NCOL,BETA,ICORE(IOFFZ),NROW)
          ENDIF
           IOFFW1L=IOFFW1L+NCOL*NSUM*IINTFP
40        CONTINUE
         ELSE
          DO 41 IRREPE=1,NIRREP
           IRREPF=DIRPRD(IRREPE,IRREPDO)
           IRREPT=IRREPF
           IOFFT =IOFFT1(IRREPT,1)
           IOFFW1=IOFFW1R+IOFFW1L
           IOFFZ =IOFFZR+IOFFZL(IRREPE,2)*IINTFP
           NROW=POP(IRREPT,1)
           NCOL=VRT(IRREPE,2)
           NSUM=VRT(IRREPT,1)
           ALPHA=ONE*FACTOR
           BETA=ZILCH
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('T','N',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NSUM,
     &                 ICORE(IOFFW1),NSUM,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW1L=IOFFW1L+NCOL*NSUM*IINTFP
41        CONTINUE
         ENDIF
30      CONTINUE
C
C COMPUTE CONTRIBUTION TO F(EA) AND F(ea) INTERMEDIATES.
C
        IF(.NOT.LAMBDA) THEN
        IF(ISPIN.EQ.1)THEN
         CALL TRACEOO('OVVO',IRREPDO,POP(1,2),VRT(1,1),DISTAR,
     &                SIZEVV(1),ICORE(I000),ICORE(I010))
         CALL SUMSYM3(ICORE(I010),ICORE(I020),SIZEVV(1),
     &                1,1,LSTFEA)
        ELSE
         CALL TRACEOO('OVOV',IRREPDO,POP(1,1),VRT(1,2),DISTAR,
     &                SIZEVV(2),ICORE(I000),ICORE(I010))
         CALL SUMSYM3(ICORE(I010),ICORE(I020),SIZEVV(2),
     &                1,2,LSTFEA)
        ENDIF
        ENDIF
C
C THE CODE ABOVE PRODUCES mbej INTERMEDIATES IN THE ORDER:
C
C                   jE-Bm (ISPIN=1)
C                   Je-Mb (ISPIN=2)
C
C THE NEXT PIECE WILL BE EVALUATED AS
C
C                   Bm-Ej (ISPIN=1, UHF)
C                   bM-Je (ISPIN=1, RHF)
C                   bM-Je (ISPIN=2)
C
C WE NEED TO REORDER WHAT WE HAVE SO THAT IT WILL MATCH UP AND
C  CAN BE ACCUMULATED BY XGEMM. 
C
        IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
         CALL SYMTR3(IRREPDO,POP(1,2),VRT(1,1),DSZTAR,
     &               DISTAR,ICORE(I000),ICORE(I010),  
     &               ICORE(I011),ICORE(I012))
         CALL MTRAN2(ICORE(I000),DSZTAR)
        ELSEIF(ISPIN.EQ.2)THEN
         CALL SYMTR1(IRREPDO,POP(1,1),VRT(1,2),DSZTAR,
     &              ICORE(I000),ICORE(I010),ICORE(I011),
     &              ICORE(I012))
         CALL MTRAN2(ICORE(I000),DSZTAR)
        ELSEIF(RHF)THEN
         CALL MTRAN2(ICORE(I000),DSZTAR)
        ENDIF
C  
C
C NOW DO    W(mBEj) = W(mBEj) - SUM T(N,B) * <Nm|Ej> (ISPIN=1)
C           W(MbeJ) = W(MbeJ) - SUM T(n,b) * <Mn|Je> (ISPIN=2 OR RHF)
C
C THIS PRODUCT IS INITIALLY PACKED Bm-Ej [bM-Je].
C 
        LISTW2=8+ISPIN
        IF(RHF)LISTW2=10
        DISW  =aces_list_cols(IRREPDO,LISTW2)
        DSZW  =aces_list_rows(IRREPDO,LISTW2)
C
C I020 NOW HOLDS THE <Nm|Ej> [<Mn|Je>] INTEGRALS.
C
        I020  =I010+IINTFP*DSZW
        I030  =I020+IINTFP*DSZW*DISW
        IF(I030.LE.MXCOR)THEN
         INCORE=.TRUE.
         CALL GETLST(ICORE(I020),1,DISW,2,IRREPDO,LISTW2)
        ELSE
         INCORE=.FALSE.
         I030=I020+IINTFP*DSZW
        ENDIF
        DO 50 INUMEJ=1,DISW
         IF(INCORE)THEN
          IOFFW2R=(INUMEJ-1)*DSZW*IINTFP+I020
         ELSE
          CALL GETLST(ICORE(I020),INUMEJ,1,2,IRREPDO,LISTW2)
          IOFFW2R=I020
         ENDIF
         IOFFW2L=0
         IOFFZR=(INUMEJ-1)*DSZTAR*IINTFP+I000
         IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
          DO 60 IRREPM=1,NIRREP
           IRREPN=DIRPRD(IRREPM,IRREPDO)
           IRREPT=IRREPN
           IOFFT=IOFFT1(IRREPT,1)
           IOFFW2=IOFFW2R+IOFFW2L
           IOFFZ=IOFFZR+IOFFZL(IRREPM,4)*IINTFP
           NROW=VRT(IRREPT,1)
           NCOL=POP(IRREPM,2)
           NSUM=POP(IRREPT,1)
           ALPHA=ONEM*FACTOR
           BETA=ONE
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('N','N',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NROW,
     &                 ICORE(IOFFW2),NSUM,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW2L=IOFFW2L+NCOL*NSUM*IINTFP
60        CONTINUE
         ELSEIF(ISPIN.EQ.2.OR.RHF)THEN
          DO 61 IRREPN=1,NIRREP
           IRREPM=DIRPRD(IRREPN,IRREPDO)
           IRREPT=IRREPN 
           IOFFT=IOFFT1(IRREPT,2)
           IOFFW2=IOFFW2R+IOFFW2L
           IOFFZ=IOFFZR+IOFFZL(IRREPM,3)*IINTFP
           NROW=VRT(IRREPT,2)
           NCOL=POP(IRREPM,1)
           NSUM=POP(IRREPT,2)
           ALPHA=ONEM*FACTOR
           BETA=ONE
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('N','T',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NROW,
     &                 ICORE(IOFFW2),NCOL,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW2L=IOFFW2L+NCOL*NSUM*IINTFP
61        CONTINUE
         ENDIF
50      CONTINUE
        IF(ISPIN.EQ.2.OR.RHF)THEN
         CALL SYMTR1(IRREPDO,POP(1,1),VRT(1,2),DSZTAR,
     &              ICORE(I000),ICORE(I010),ICORE(I011),
     &              ICORE(I012))
        ENDIF
C
C NOW WRITE THESE TO DISK FOR EACH IRREP.  THESE ARE ORDERED 
C
C                   Bm-Ej (ISPIN=1, UHF)
C                   bM-eJ (ISPIN=2 OR RHF)
C
        CALL PUTLST(ICORE(I000),1,DISTAR,1,IRREPDO,LSTOUT)
20     CONTINUE
C
C NOW SWITCH ORDERING FROM Bm-Ej TO Bj-Em
C
       ISCSIZ=(NVRTO(1)+NVRTO(2))*(NOCCO(1)+NOCCO(2))
       TARSIZ=ISYMSZ(ISYTYP(1,LSTTAR),ISYTYP(2,LSTTAR))
       I000=1
       I010=I000+TARSIZ*IINTFP
       I020=I010+TARSIZ*IINTFP
       I030=I020+ISCSIZ
       IF(I030.GT.MXCOR)CALL INSMEM('T1RABBA',I030,MXCOR)
       CALL GETALL(ICORE(I010),TARSIZ,1,LSTOUT)
       CALL SSTRNG(ICORE(I010),ICORE(I000),TARSIZ,TARSIZ,ICORE(I020),
     &             SSTSPN(ISPIN))
C
C NOW DO TRANSPOSITION TO GET E,m-B,j ORDERING IRREP BY IRREP.
C
       IOFF=1
       DO 5000 IRREP=1,NIRREP
        DSZTAR=aces_list_rows(IRREP,LSTTAR)
        DISTAR=DSZTAR
        CALL MTRAN2(ICORE(IOFF),DSZTAR)
c        CALL PUTLST(ICORE(IOFF),1,DISTAR,2,IRREP,LSTTAR)
        IOFF=IOFF+IINTFP*DISTAR*DSZTAR
5000   CONTINUE
C
C NOW WRITE THE (PROPERLY ORDERED) PIECE TO THE TARGET LIST.
C
C FOR LAMBDA UPDATE THE TARGET LIST AND COPY ORIGINAL INTERMEDIATES
C  TO LSTOUT
C
       IF(LAMBDA) THEN
        CALL GETALL(ICORE(I010),TARSIZ,1,LSTTAR)
        CALL PUTALL(ICORE(I010),TARSIZ,1,LSTOUT)
        CALL SAXPY(TARSIZ,ONE,ICORE(I010),1,ICORE(I000),1)
       ENDIF
C
       CALL PUTALL(ICORE(I000),TARSIZ,1,LSTTAR)
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine nulltrm(fstr)

c------------------------------------------------------------------------
c   Null terminate a FORTRAN string for use as a string in C language
c   routines.
c
c   Arguments:
c      fstr: The string to be null-terminated.  The string must have enough
c            room for one zero byte at the end.
c-------------------------------------------------------------------------

      character*(*) fstr

c-------------------------------------------------------------------------
c   Find last non-blank character.
c-------------------------------------------------------------------------
      last = 0
      do i = len(fstr), 1, -1
         if (fstr(i:i) .ne. ' ' .and.
     *       ichar(fstr(i:i)) .ne. 0) then
            last = i
            go to 100
         endif
      enddo

  100 continue
      if (last .ne. 0 .and. last .ne. len(fstr)) then
          fstr(last+1:last+1) = char(0)
          fstr(last+2:len(fstr)) = ' '
      endif
      
      return
      end

      Subroutine projec_FC(Coords, Hess, AtmMass, Grad, Work, 
     &                     Hess_project, Threshold, Nreals, 
     &                     Move_CMass, Proj_rots, Proj_grads)
C
      Implicit Double Precision (A-H, O-Z)
C
      Double Precision MO_Inertia(3,3)
      Logical Proj_rots, Proj_grads, Move_CMass
C
      Dimension Coords(3*Nreals), Grad(3*Nreals), AtmMass(Nreals), 
     &          Hess(3*Nreals, 3*Nreals), Hess_Project(3*Nreals, 
     &          3*Nreals), Work(3*Nreals, 3*Nreals), Asym_ten(3,3,3),
     &          Hess_Projects(3*Nreals, 3*Nreals), Center_Mass(3),
     &          CM(3)
 
      Data Asym_ten/ 0.0D+00,  0.0D+00,  0.0D+00,
     &               0.0D+00,  0.0D+00, -1.0D+00,
     &               0.0D+00,  1.0D+00,  0.0D+00,
     &               0.0D+00,  0.0D+00,  1.0D+00,
     &               0.0D+00,  0.0D+00,  0.0D+00,
     &              -1.0D+00,  0.0D+00,  0.0D+00,
     &               0.0D+00, -1.0D+00,  0.0D+00,
     &               1.0D+00,  0.0D+00,  0.0D+00, 
     &               0.0D+00,  0.0D+00,  0.0D+00  /
C
C Normalize the gradinet vector. 
C
      Grad_sqr = Ddot(3*Nreals, Grad, 1, Grad, 1)   
      If (Grad_sqr .GT. Threshold)  Call Normal(Grad, 3*Nreals)
C
C Move to the center of Mass coordinate system.
C
      If (Move_CMass) Then
         Call Dzero(CM, 3)
         TotMass = 0.0D0
         Do Iatoms = 1, Nreals
            Ioff = 3*(Iatoms - 1)
            TotMass = TotMass AtmMass(Iatoms)
            Do Ixyz = 1, 3
               CM(Ioff + Ixyz)   = Coords(Ioff + 1)*AtmMass(Iatoms) 
            Enddo
         Enddo
C
         Do Ixyz = 1, 3
            If (TotMass .GT. Threshold) Then
                Center_Mass(IxYz) = CM(Ixyz)/TotMass
            Else
                Write(6, "(a)") "@-Project_FC Zero total mass"
                Call Errex
            Endif
         Enddo
C         
         Do Iatoms = 1, Nreals
            Ioff  = 3*(Iatoms - 1)
            Do Ixyz = 1, 3
               Coords(Ioff + Ixyz) = Coords(Ioff + Ixyz) - 
     &                               Center_Mass(Ixyz)
            Enddo
         Enddo
      Endif
C
C compute the inverse of inertia matrix.
c 
      Call CalMOI(NReals, Coord, AtmMass, MO_Inertia)
      Call Minv(MO_Inertia, 3, 3, Work, Det, 1.0D-8, 0, 1)
C
C Mass weigh the incomming Cartesians 
C
      Ioff = 1
      TotMass = 0.0D0
      Do Iatoms = 1, Nreals
          Sqrtmass = Dsqrt(AtmMass(Iatoms))
          Ioff = Ioff + 3*(Iatom - 1)
          Do Ixyz = 1, 3
             Coords(Ioff) = Coords(Ioff)*Sqrtmass
             Ioff = Ioff + 1 
          Enddo
      Enddo    
C
C Build the Hessian projector See, Miller, Handy and Adams, JCP, 
C 72, 99, (1980).
C
      Do Iatms = 1, Natoms
         Ioff = 3*(Iatms - 1)

         Do Jatms = 1, Iatms
          Joff = 3*(Jatms - 1)
   
            Do Iz = 1, 3
               L_index = Ioff + Iz
               Jz_end = 3
               If (Iatms .EQ. Jatms)  Jz_end = Iz
C
                 Do Jz = 1, Jz_end
                    R_index = Joff + Jz
                    Sum = 0.0D0
C
                    If (Proj_rots) Then 

                        Do Ix = 1, 3
 
                           Do Iy = 1, 3
C
                              If (Asym_ten(Ix, Iy, Iz) .NE. 0.0D0) 
     &                            Then
                                   
                                   Do Jx = 1, 3

                                      Do Jy = 1, 3
                                         If (Asym_ten(Jx, Iy, Iz) .NE. 
     &                                       0.0D0) Then
                                             Sum = Sum + 
     &                                             Coords(Ioff + IY)*
     &                                             Coords(Joff + Jy)*
     &                                            MO_inertia(Ix, Jx)*
     &                                          Asym_ten(Ix, Iy, Iz)*
     &                                          Asym_ten(Jx, Jy, Jz)
                                         Endif
                                      Enddo
                                   Enddo 
                              Endif
                           Enddo
                        Enddo
                    Endif
C 
                    Hess_project(R_index, L_index) = Sum

                    If (Proj_grads) Hess_project(R_index, L_index) = 
     &                              Hess_project(R_index, L_index) + 
     &                              Grad(R_Index)*Grad(L_index)
C
                    If (Iatms .EQ. Jatms) Then
                        Hess_project(R_index, L_index) =
     &                  Hess_project(R_index, L_index) + 
     &                  Dsqrt(AtmMass(R_index)*AtmMass(R_index))/
     &                  Totmass
                    Endif
C
                 Enddo 
            Enddo 
C
         Enddo
      Enddo
C
C Build the projector (I - P)
C
      Do Jdeg = 1, 3*Nreals
          Do Ideg = 1, 3*Nreals
             If (Ideg .Eq. Jdeg)  Hess_project(Ideg, Jdeg) = 1.0D0 -
     &                            Hess_project(Ideg, Jdeg)   
             If (Ideg .GE. Jdeg .AND. Hess_project(Ideg, Jdeg) .LT. 
     &                            Threshold) Hess_project(Ideg, 
     &                                       Jdeg) = 0.0D0
              Hess_project(Jdeg, Ideg) = Hess_project(Ideg, Jdeg)
          Enddo
      Enddo
C
#ifdef _DEBUG_LVL0
      NX = 3*Nreals
      Call Eig(Hess, Work, 1, NX, 0) 
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the Hessian"
      CALL OUTPUT(Work, 1, NX, 1, Nx, Nx, Nx, 1)
      Write(6,"(a)") "The eigenvalues of the   Hessian"
      Write(6, "(4F10.5)") (Hess(I,I), I=1, NX)
#endif
C
C Project the Hessian (I - P)H(I - P)
C
      Call Xgemm("N", "N", 3*Nreals, 3*Nreals, 3*Nreals, 1.0D0, 
     &            Hess_project, 3*Nreals, Hess, 3*Nreals, 0.0D0, 
     &            Work, 3*Nreals)
C
      Call Xgemm("N", "N", 3*Nreals, 3*Nreals, 3*Nreals, 1.0D0, 
     &            Work, 3*Nreals, Hess_project, 3*Nreals, 0.0D0, 
     &            Hess, 3*Nreals)
C
#ifdef _DEBUG_LVL0
      NX = 3*Nreals
      Call Eig(Hess, Work, 1, NX, 0) 
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the projected Hessian"
      CALL OUTPUT(Work, 1, NX, 1, Nx, Nx, Nx, 1)
      Write(6,"(a)") "The eigenvalues of the  projected Hessian"
      Write(6, "(4F10.5)") (Hess(I,I), I=1, NX)
#endif
      Return
      End
     

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__open_file
     +
     +                    ( file_name,
     +                      file_status,
     +                      file_access,
     +                      file_format,
     +
     +                              unitid )
     +
c------------------------------------------------------------------------
c  operation   : ofh__open_file
c  module      : output files handler
c  module-id   : ofh
c  description : This operation opens a file and returns the unit number.
c                Processing is aborted, if one of the following cases
c                apply:
c
c                     1) file is already open
c                     2) file should have status old, but is
c                        not existing
c                     3) file should have status new, but is
c                        existing
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         character*(*)      file_name
         character*(*)      file_status
         character*(*)      file_access
         character*(*)      file_format

         logical            file_exists
         logical            file_open

         integer            record_length
         integer            unitid
c
c
c------------------------------------------------------------------------
c
c
c             ...check for proper file attributes.
c
c
         if (file_status .ne. 'old'     .or.
     +       file_status .ne. 'new'     .or.
     +       file_status .ne. 'scratch' .or.
     +       file_status .ne. 'unknown'      ) then
             write (*,*) ' Unknown file status! '
             write (*,*) ' File status = ',file_status
             write (*,*) ' Cannot open file! '
             write (*,*) ' ofh__open_file '
             write (1,*) ' Unknown file status! '
             write (1,*) ' File status = ',file_status
             write (1,*) ' Cannot open file! '
             write (1,*) ' ofh__open_file '
             call  ofh__stop
         end if

         if (file_access .ne. 'direct'     .or.
     +       file_access .ne. 'sequential'      ) then
             write (*,*) ' Unknown file access method! '
             write (*,*) ' File access = ',file_access
             write (*,*) ' Cannot open file! '
             write (*,*) ' ofh__open_file '
             write (1,*) ' Unknown file access method! '
             write (1,*) ' File access = ',file_access
             write (1,*) ' Cannot open file! '
             write (1,*) ' ofh__open_file '
             call  ofh__stop
         end if

         if (file_format .ne. 'formatted'   .or.
     +       file_format .ne. 'unformatted'      ) then
             write (*,*) ' Unknown file format! '
             write (*,*) ' File format = ',file_format
             write (*,*) ' Cannot open file! '
             write (*,*) ' ofh__open_file '
             write (1,*) ' Unknown file format! '
             write (1,*) ' File format = ',file_format
             write (1,*) ' Cannot open file! '
             write (1,*) ' ofh__open_file '
             call  ofh__stop
         end if
c
c
c             ...inquire the open and existence status of the file
c                associated with the file name.
c
c
         inquire  (file   = file_name,
     +             opened = file_open,
     +             exist  = file_exists)
c
c
c             ...file already open.
c
c
         if (file_open) then
             write (*,*) ' The file: ',file_name,' is already open! '
             write (*,*) ' ofh__open_file '
             write (1,*) ' The file: ',file_name,' is already open! '
             write (1,*) ' ofh__open_file '
             call  ofh__stop
         end if
c
c
c             ...check file existence if status = old or new.
c
c
         if (.not.file_exists  .and.  file_status.eq.'old') then
             write (*,*) ' The file: ',file_name,' does not exist! '
             write (*,*) ' ofh__open_file '
             write (1,*) ' The file: ',file_name,' does not exist! '
             write (1,*) ' ofh__open_file '
             call  ofh__stop
         end if

         if (file_exists  .and.  file_status.eq.'new') then
             write (*,*) ' The file: ',file_name,' already exists! '
             write (*,*) ' ofh__open_file '
             write (1,*) ' The file: ',file_name,' already exists! '
             write (1,*) ' ofh__open_file '
             call  ofh__stop
         end if
c
c
c             ...if scratch file is wanted set the record length.
c
c
         if (file_access .eq. 'direct') then
             record_length = 4096
         end if
c
c
c             ...get next free unit number.
c
c
         call  ofh__get_free_unit (unitid)
c
c
c             ...open I/O unit.
c
c
         if (file_status .eq. 'scratch') then

             open  (unit   = unitid,
     +              access = file_access,
     +              form   = file_format,
     +              status = 'scratch')

         else

             if (file_access .eq. 'direct') then

                 open  (unit   = unitid,
     +                  access = 'direct',
     +                  file   = file_name,
     +                  form   = file_format,
     +                  recl   = record_length,
     +                  status = file_status)

             else

                 open  (unit   = unitid,
     +                  access = file_access,
     +                  file   = file_name,
     +                  form   = file_format,
     +                  status = file_status)

             end if

         end if
c
c
c             ...ready!
c
c
         return
         end

      real*8 function getheff(array,index)
cjp because in calling routine array is declared as integer!
      real*8 array
      integer index
      dimension array(*)
      getheff = array(index)
      return
      end

      Subroutine a2write_wfn(Wfn, Nangmom, Alpha, Nprim_4shl, 
     &                       Iangmom, IShell_4atm, Itype, Icent, 
     &                       Eigvals, Occnm, Coord, Maxocc, 
     &                       Nshls, Itot_prim, Nbfns,
     &                       Nreal_atoms, Iatmchrg)
      
      Implicit Double Precision (A-H, O-Z)
      Character*2 Atmlab(103)
      Character Title(10)
      Integer Angmom

      Dimension Coord(Nreal_atoms, 3), Iatmchrg(Nreal_atoms),
     &          Wfn(Itot_prim, Nbfns), Nprim_4shl(Nreal_atoms, NShls),
     &          Alpha(Itot_prim), Nangmom(Nreal_atoms), 
     &          Itype(Itot_prim), Iangmom(Nreal_atoms, Nshls), 
     &          IShell_4atm(Nreal_atoms), Icent(Itot_prim),
     &          Eigvals(Nbfns), Occnm(Nbfns)
 
      Data (Atmlab(i),i=1,103)
     & /'H ','HE',
     & 'LI','BE','B ','C ','N ','O ','F ','NE',
     & 'NA','MG','AL','SI','P ','S ','CL','AR',
     & 'K ','CA',
     & 'SC','TI','V ','CR','MN','FE','CO','NI','CU','ZN',
     & 'GA','GE','AS','SE','BR','KR',
     & 'RB','SR',
     & 'Y ','ZR','NB','MO','TC','RU','RH','PD','AG','CD',
     & 'IN','SN','SB','TE','I ','XE',
     & 'CS','BA','LA',
     & 'CE','PR','ND','PM','SM','EU','GD',
     & 'TB','DY','HO','ER','TM','YB','LU',
     & 'HF','TA','W ','RE','OS','IR','PT','AU','HG',
     & 'TL','PB','BI','PO','AT','RN',
     & 'FR','RA','AC',
     & 'TH','PA','U ','NP','PU','AM','CM',
     & 'BK','CF','ES','FM','MD','NO','LR'/
      Data Iunit /10/
      
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(a)") "The number of functions on each atom"
      Write(6, "(4(1x,I3))") (Nangmom(I), I=1, Nreal_atoms)
      Write(6,*)
      Write(6, "(a)") "The number of prim. functions on each atom"
      Do I=1, Nreal_atoms
      Write(6, "(3(1x,I3))") (NPrim_4shl(I,J), J=1, 3)
      Enddo
      Write(6,*) 
      Write(6,*) "The number of shells per atom"
      Write(6, "(4(1x,I3))") (IShell_4atm(I), I=1, Nreal_atoms)
      Write(6,*) 
      Write(6,*) "The shell angular momentum per atom s=1,p=3,d=6,,"
      Do I=1, Nreal_atoms
         Write(6, "(4(1x,I3))") (Iangmom(I, J), J=1, IShell_4atm(I))
      Enddo 
#endif
      Ioff = 0
      Do Iatms = 1, Nreal_atoms
         Do Ishl = 1, IShell_4atm(Iatms)
            Angmom = Iangmom(Iatms, Ishl)
            Nconfs = Nprim_4shl(Iatms, Ishl)
            If (Angmom .Eq. 1)  Then
                Imin = 1
                Imax = 1
            Elseif (Angmom .Eq. 3) Then
                Imin = 2
                Imax = 4
            Elseif (Angmom .Eq. 6) Then
                Imin = 5
                Imax = 10
            Elseif (Angmom .Eq. 10) Then
                Imin = 11 
                Imax = 20
            Elseif (Angmom .Eq. 15) Then
                Imin = 21 
                Imax = 35
            Elseif (Angmom .Eq. 21) Then
                Imin = 36
                Imax = 56
            Elseif (Angmom .Eq. 36) Then
                Imin = 57
                Imax = 84
            Elseif (Angmom .Gt. 36) Then
                Write(6, "(a)") "The WFN file is only available",
     &                          " for up to L angular momentum" 
                Call Errex
            Endif
  
            Do Iang = Imin, Imax
               Do Nfuncs = 1, Nconfs
                  Ioff = Ioff + 1
                  Itype(Ioff) = Iang
                  Icent(Ioff) = Iatms
               Enddo 
            Enddo
         Enddo
      Enddo
           
      Open(unit=Iunit, File="WFNANL", Form="Formatted", 
     &     Status="New")
     
      Write(Iunit, "(a,a)") "Input file for quantum ",
     &             "Topology analysis"
C
      Write(IUnit, 100) Nbfns, Itot_prim, Nreal_atoms
  100 Format('GAUSSIAN',10x,I5,' MOL ORBITALS',1x,I6,' PRIMITIVES',
     &       4x,I5,' NUCLEI')

      Do Iatms = 1, Nreal_atoms
         Write(Iunit, 110)  Atmlab(Iatmchrg(Iatms)), Itams, Iatms, 
     &                      (Coord(Iatms, J), J=1,3), 
     &                      Dble(Iatmchrg(Iatms))
      Enddo
C       
  110 Format(a4,i4,4x,'(CENTRE',i3,')',1x,3f12.8,'  CHARGE =',f5.1)
C
      Write(Iunit, 120) (Icent(I), I = 1, Itot_prim)
      Write(Iunit, 130) (Itype(I), I = 1, Itot_prim)
      Write(Iunit, 140) (Alpha(I), I = 1, Itot_prim)

  120 Format('CENTRE ASSIGNMENTS',2x,20i3)
  130 Format('TYPE ASSIGNMENTS',4x,20i3)
  140 Format('EXPONENTS',1x,1p,5e14.7)
     
      Do Iorb = 1, Maxocc
         Write(Iunit, 150) Iorb, Occnm(Iorb), Eigvals(Iorb)
         Write(Iunit, 160) (Wfn(Iprim, Iorb), Iprim =1, Itot_prim)
      Enddo 

  150 Format('MO',i3,21x,'OCC NO = ',f12.8,' ORB. ENERGY =',f13.8 )
  160 Format(1p,5e16.8)
  
      Write(Iunit, "(a)") "END DATA"
      Close(Iunit)
      Return
      End

C THIS ROUTINE DETERMINES WHICH POINTS WILL BE RUN AND WHAT TYPE
C OF CALCULATION (GRADIENT OR ENERGY ONLY) IS MOST EFFICIENT FOR
C EACH SYMMETRY BLOCK

C-----------------------------------------------------------------------
CJDW  May/June 1996. Note on modifications of dimensioning.
C
C     Memory allocation :
C
C     It is assumed that there will never be more than (3*NATOM)**2
C     energy/gradient calculations. The memory allocation in the main
C     program for SETPTS and UPD_FD is based on this assumption.
C     Note that this bound is highly wasteful for GRADONLY calculations,
C     as the number of gradients will be much less. However, the code
C     currently reads record GRDPOINT even during ENERONLY jobs, hence
C     we need to make appropriate allowances.
C-----------------------------------------------------------------------

c INPUT
c integer NATOM
c integer NIRREP
c char*4  TYPE
c integer NDSCR

c OUTPUT
c integer NENER
c char*8  LABEL(NIRREP)
c integer ISYMIRR(3*NATOM)
c integer IPTTYPE(9*NATOM*NATOM)
c integer INVOP(3*NATOM)
c double  POINTS(27*NATOM*NATOM*NATOM)
c double  DSCR(NDSCR)

c RECORDS
c get 'NFDIRREP'
c get 'FDIRREP '
c get 'COORD   '
c get 'ATOMMASS'
c get TYPE//'SYMQ'
c get TYPE//'SYQT'
c get TYPE//'DEGN'
c get TYPE//'LABL'
c get 'INVPSMAT'
c get 'NUMVIBRT'
c put 'NUMPOINT'
c put 'FDCALCTP'
c put 'FDCOORDS'
c put 'NPTIRREP'
c put 'ENGPOINT'
c put 'GRDPOINT'
c put 'DIPPOINT'
c put 'POLPOINT'

      SUBROUTINE SETPTS(NATOM,NIRREP,TYPE,
     &                  NENER,LABEL,ISYMIRR,IPTTYPE,INVOP,
     &                  POINTS,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      CHARACTER*4 TYPE
      CHARACTER*8 LABEL(NIRREP)
      DIMENSION ISYMIRR(3*NATOM),IPTTYPE(9*NATOM*NATOM),INVOP(3*NATOM)
      DIMENSION POINTS(27*NATOM*NATOM*NATOM)
      DIMENSION DSCR(NDSCR)

      INTEGER SKIPIR
      DIMENSION IJUNK(20),SKIPIR(20),idegen(100),nptirr(100)
      LOGICAL PRINTQ

      COMMON /FLAGS/  IFLAGS(100)
#include "control.com"
#include "machsp.com"
#include "parallel_aces.com"

      DATA TOL /1.D-8/

      PRINTQ=(IFLAGS(1).GE.10)
      NSIZE=3*NATOM

      if (gmtryopt.or.gradonly.or.nprocs.eq.1) then
         iRoot = 0
      else
c      o the root process is doing the reference geometry in a vib freq calc
c        with numerical gradients
         iRoot = 1
      end if

c   o check for restrictions on FD irreps
      CALL GETREC(-1,'JOBARC','NFDIRREP',1,ICOUNT)
      IF (ICOUNT.NE.0) THEN
         CALL GETREC(-1,'JOBARC','FDIRREP ',ICOUNT,IJUNK)
         WRITE(6,501)
501      FORMAT(T3,'@SETPTS: FCM evaluation limited ',
     &             'to the following symmetries :')
         WRITE(6,'((12I5))')(IJUNK(I),I=1,ICOUNT)
         DO I=1,20
            SKIPIR(I)=1
         END DO
         DO I=1,ICOUNT
            SKIPIR(IJUNK(I))=0
         END DO
      ELSE
         CALL IZERO(SKIPIR,20)
      END IF

      STPSIZ=DFLOAT(IFLAGS(57))*10.0D-5
      IF (PRINTQ) THEN
         WRITE(6,500)STPSIZ
500      FORMAT(T3,'Step size will be ',F8.5,' amu**(1/2) * bohr.')
      END IF
#ifdef _DEBUG_LVL0
      Print*, "The step size in symcor:", STPSIZ
#endif 
      lFREE = 1

      lSYMQ = lFREE
      lFREE = lFREE + NSIZE*NSIZE
      lCOOR = lFREE
      lFREE = lFREE + NSIZE
      lMASS = lFREE
      lFREE = lFREE + NATOM
      NDSCRLFT = NDSCR+1-lFREE
      IF (NDSCRLFT.LT.0) THEN
         print *, '@SETPTS: Insufficient memory.'
         print *, '         need ',-ndscrlft*ifltln,' more bytes'
         call aces_exit(1)
      END IF
      CALL GETREC(20,'JOBARC',TYPE//'SYMQ',NSIZE*NSIZE*IINTFP,
     &                                                DSCR(lSYMQ))
      CALL GETREC(20,'JOBARC','COORD   ',NSIZE*IINTFP,DSCR(lCOOR))
#ifdef _DEBUG_LVL0
      Print*, "The Cartesian coordinates read in septs:"
      Write(6,"(f10.4)"), (Dscr(I), I=lCOOR, NSIZE)
#endif      
      CALL GETREC(20,'JOBARC','ATOMMASS',NATOM*IINTFP,DSCR(lMASS))

      CALL GETREC(20,'JOBARC',TYPE//'SYQT',NSIZE,ISYMIRR)
      CALL GETREC(20,'JOBARC',TYPE//'DEGN',NIRREP,IDEGEN)
      CALL GETREC(20,'JOBARC','INVPSMAT',3*NATOM,INVOP)
      IF (PRINTQ) THEN
      CALL GETREC(20,'JOBARC',TYPE//'LABL',NIRREP*IINTFP,LABEL)
      END IF

      CALL GETREC(20,'JOBARC','NUMVIBRT',1,NMODE)
      NLEFT=NMODE

      CALL ZERO(POINTS,27*NATOM*NATOM*NATOM)
      CALL IZERO(NPTIRR,NIRREP)

c   o set up vector of reciprocal square roots of atomic masses
      DO IOFF=0,NATOM-1
         X=SQRT(DSCR(lMASS+IOFF))
         IF (X.LT.TOL) THEN
            DSCR(lMASS+IOFF)=0.d0
         ELSE
            DSCR(lMASS+IOFF)=1.d0/X
         END IF
      END DO

c   o loop over irreducible representations and process first occurances
      NENER=0
      NGRAD=0
      NPTOTX=0
      NENERX=0
      NGRADX=0
      IOFF=0
      IPOS2=1
      IPOS3=1
      DO IRREP=1,NIRREP
         IFIRST=ISRCHEQ(NMODE,ISYMIRR,1,IRREP)
      IF (IFIRST.NE.NMODE+1) THEN

         ILAST=ISRCHNE(NLEFT,ISYMIRR(IFIRST),1,IRREP)
         NVIBSYM=ILAST-1
         NVIBUNQ=NVIBSYM/IDEGEN(IRREP)

         IF (PRINTQ) THEN
            WRITE(6,2000)LABEL(IRREP),IDEGEN(IRREP),NVIBUNQ
2000        FORMAT(T3,' Symmetry : ',A,' Degeneracy : ',I1,
     &             ' Unique symmetry coordinates : ',I3)
         END IF

         IPOS=NSIZE*(IFIRST-1)
#ifdef _DEBUG_LVL0
         Print*, "In setpts, energy only?", ENERONLY 
#endif
         IF (ENERONLY) THEN
            CALL DOENER(NATOM,NVIBUNQ,
     &                  DSCR(lSYMQ+IPOS),DSCR(lCOOR),STPSIZ,DSCR(lMASS),
     &                  POINTS(IPOS2),NPOINT,
     &                  INVOP(IPOS3),PRINTQ,DSCR(lFREE),NDSCRLFT)
            NENER=NENER+NPOINT
            IF (SKIPIR(IRREP).EQ.0) THEN
               do iR = 0, nProcs-1
                  call paces_batch_stat(iR,nProcs,iRoot,nPoint,iO,nE)
                  do iX = 1+iO, nE+iO
                     iPtType(iOff+iX) = 1+iR
                  end do
                  if (iR.eq.iRank) nEnerX=nEnerX+nE
               end do
               iRoot = mod(iRoot+nPoint,nProcs)
               nPTotX=nPTotX+nPoint
            ELSE
               DO IX=1,NPOINT
                  IPTTYPE(IOFF+IX)=0
               END DO
            END IF
         ELSE
#ifdef _DEBUG_LVL0
         Print*, "In setpts, grad only?, T"
#endif  

            CALL DOGRAD(NATOM,NVIBUNQ,
     &                  DSCR(lSYMQ+IPOS),DSCR(lCOOR),STPSIZ,DSCR(lMASS),
     &                  POINTS(IPOS2),NPOINT,
     &                  INVOP(IPOS3),PRINTQ,DSCR(lFREE),NDSCRLFT)
            NGRAD=NGRAD+NPOINT
            IF (SKIPIR(IRREP).EQ.0) THEN
               do iR = 0, nProcs-1
                  call paces_batch_stat(iR,nProcs,iRoot,nPoint,iO,nE)
                  do iX = 1+iO, nE+iO
                     iPtType(iOff+iX) = 1+iR
                  end do
                  if (iR.eq.iRank) nGradX=nGradX+nE
               end do
               iRoot = mod(iRoot+nPoint,nProcs)
               nPTotX=nPTotX+nPoint
            ELSE
               DO IX=1,NPOINT
                  IPTTYPE(IOFF+IX)=0
               END DO
            END IF
         END IF
         NPTIRR(IRREP)=NPTIRR(IRREP)+NPOINT
         IPOS2=IPOS2+NPOINT*NSIZE
         IPOS3=IPOS3+NVIBSYM
         IOFF=IOFF+NPOINT
         NLEFT=NLEFT-NVIBSYM

      END IF
      END DO

      NTOT=NGRAD+NENER
      NTOTX=NGRADX+NENERX
      WRITE(6,1000)NTOTX,NENERX,NGRADX
1000  FORMAT(T3,' Total number of calculations required      : ',I5,/,
     &       T3,' Number of single-point energy calculations : ',I5,/,
     &       T3,' Number of energy gradient     calculations : ',I5)
      IF (NTOT.GT.NSIZE*NSIZE) THEN
         WRITE(6,*) '@SETPTS: Too many points!'
         CALL ERREX
      END IF
      IF (NPTOTX.EQ.0) THEN
         WRITE(6,*) '@SETPTS: There are no vibrational modes!'
         CALL ERREX
      END IF
      IF (NTOTX.EQ.0) THEN
         if (nprocs.eq.1.or.irank.ne.0.or.gmtryopt.or.gradonly) then
            WRITE(6,*) '@SETPTS: There are no points to calculate!'
            CALL ERREX
         else
            CALL PUTREC(20,'JOBARC','LASTGEOM',1,1)
         end if
      END IF
C
C This record was added to do manual finite difference calculations
C with ACES III. The xjoda -procs n -rank m is run before execution
C is transfered to ACESIII. Ajith Perera, 10/2010.

      IF (.NOT. (nprocs.eq. 1 .and. irank.eq.0)) Call PUTREC(20, 
     &                               "JOBARC", "MANULFDS", 1, 1)


c   o write geometries to be used and calculation types to jobarc
      CALL PUTREC(20,'JOBARC','NUMPOINT',1,NTOT)
      CALL PUTREC(20,'JOBARC','FDCALCTP',NTOT,IPTTYPE)
      CALL PUTREC(20,'JOBARC','FDCOORDS',IINTFP*NSIZE*NTOT,POINTS)
      CALL PUTREC(20,'JOBARC','NPTIRREP',NIRREP,NPTIRR)

c   o write out zero vectors for calculation archiving
      CALL ZERO(POINTS,NTOT*max(NSIZE,9))
      CALL PUTREC(20,'JOBARC','ENGPOINT',IINTFP*      NTOT,POINTS)
      CALL PUTREC(20,'JOBARC','GRDPOINT',IINTFP*NSIZE*NTOT,POINTS)
      CALL PUTREC(20,'JOBARC','DIPPOINT',IINTFP*    3*NTOT,POINTS)
      CALL PUTREC(20,'JOBARC','POLPOINT',IINTFP*    9*NTOT,POINTS)
      

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine scf_rhf(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c-----------------------------------------------------------------------------
c   This routine copies the current values of the CA pre-defined array
c   into the CB array, and the FOCKA int FOCKB.  This effectively duplicates 
c   the alpha-spin
c   eigenvectors and eigenvalues as beta-spin.  It is used only in the
c   RHF versions of SCF codes, enabling UHF codes to be used from this
c   point in the processing (i. e. tran, ccsd, lambda, ...).
c-----------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table) 
      integer*8 address_table(narray_table)

      integer*8 get_index_from_base
      integer*8 ixca, ixcb, ixfocka, ixfockb
      integer j, k, n, index, bseg, eseg, val1, val2
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)

      dptr = dshptr
#else
      common x
#endif

c----------------------------------------------------------------------------
c   Find the address of each array. (CA is array 2, CB is array 3, FOCKA is
c   array 9, FOCKB is array 10).
c----------------------------------------------------------------------------

      ixca = get_index_from_base(address_table(2), x, 2)
      ixcb = get_index_from_base(address_table(3), x, 2)
      ixfocka = get_index_from_base(address_table(9), x, 2)
      ixfockb = get_index_from_base(address_table(10), x, 2)

c----------------------------------------------------------------------------
c   Determine size of the arrays.
c----------------------------------------------------------------------------

      n = 1
      do j = 1, array_table(c_nindex,2)
         index = array_table(c_index_array1+j-1,2)
         bseg = index_table(c_bseg, index)
         eseg = index_table(c_eseg, index)
         call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
         array_table(c_index_range1+j-1,2) = val1
         call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
         array_table(c_index_range2+j-1,2) = val2
         k = array_table(c_index_range2+j-1,2) -
     *       array_table(c_index_range1+j-1,2) + 1
         n = n * k
      enddo

c---------------------------------------------------------------------------
c   Copy the data.
c---------------------------------------------------------------------------

      do j = 1, n
         x(ixcb+j-1) = x(ixca+j-1)
      enddo

c----------------------------------------------------------------------------
c   Copy the FOCKA into FOCKB.
c----------------------------------------------------------------------------

      do j = 1, n
         x(ixfockb+j-1) = x(ixfocka+j-1)
      enddo
      return
      end

c A debugging routine that turns dline(izl(1,i):izl(2,i)) to carets (^)
c repeating for j while making the rest spaces.




      subroutine prep_dline_2(dline,izl,i,j)
      implicit none

c     Maximum string length of terminal lines
      INTEGER LINELEN
      PARAMETER (LINELEN=80)

      character*(linelen) dline
      integer izl(2,7), i, j

      integer ndx, k

      character*1 achar, czTmp, czSpace, czCaret

c ----------------------------------------------------------------------

      czCaret = achar(94)
      czSpace = achar(32)

      do ndx = 1, 7
         if (izl(1,ndx).ne.0) then
            if ((ndx.eq.i).or.(ndx.eq.j)) then
               czTmp = czCaret
            else
               czTmp = czSpace
            end if
            do k = izl(1,ndx), izl(2,ndx)
               dline(k:k) = czTmp
            end do
         end if
      end do

      return
      end

      SUBROUTINE SAXLST(ICORE,MAXCOR,LSTINA,LSTINB,LSTOUT,FA,FB)
C
C THIS ROUTINE READS TWO LISTS, A AND B, AND FORMS A THIRD
C (C) WHICH IS EQUAL TO FA * A + FB * B.  LISTS A AND B ARE
C READ FROM LSTINA AND LSTINB AND THE RESULTANT C IS WRITTEN
C TO LSTOUT.  THE SIZES ARE ASSUMED TO BE THE SAME (NSIZE).
C
C A couple of silly bugs corrected by RPM 5/13/94.
C
CEND
      IMPLICIT INTEGER (A-H,O-Z)
      DOUBLE PRECISION ONE,FA,FB
      character *(*)rtnn,rtn
      PARAMETER(ONE=1.0D+00)
      parameter (rtnn='saxlst', rtn='  @'//rtnn)
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
C
C DETERMINE SIZES AND SEE IF THIS WILL GO WITH PUTALL AND GETALL.
C
      LSTTYP=LSTINA
      IF(LSTINA.GT.100)LSTTYP=LSTTYP
      NSIZE=ISYMSZ(ISYTYP(1,LSTTYP),ISYTYP(2,LSTTYP))
C      IF(NSIZE.LT.MAXCOR)THEN !!!!!!  No no no RPM
      IF(2*NSIZE .LT. MAXCOR/IINTFP)THEN
C         write (*,*) rtn,'-I: getall in core'
         I000=1
         I010=I000+IINTFP*NSIZE
         I020=I010+IINTFP*NSIZE
         if ( i020 .gt. maxcor ) then
            write (*,*) rtn,'-F: no room for both lists'
            call insmem(rtnn, i020, maxcor)
         endif
         CALL GETALL(ICORE(I000),NSIZE,1,LSTINA)
         CALL SSCAL(NSIZE,FA,ICORE(I000),1)
         CALL GETALL(ICORE(I010),NSIZE,1,LSTINB)
         CALL SSCAL(NSIZE,FB,ICORE(I010),1)
         CALL SAXPY(NSIZE,ONE,ICORE(I000),1,ICORE(I010),1)
         CALL PUTALL(ICORE(I010),NSIZE,1,LSTOUT)
      ELSE
C         write (*,*) 'out of core'
C         write (*,*)'  pair type of list ', lsttyp,
C     &     ' is (',  isytyp(1,lsttyp),',', isytyp(2,lsttyp),')'
         DO 10 IRREP=1,NIRREP
C            write (*,*)rtn,'-I: irrep ', irrep
            DISSIZ=IRPDPD(IRREP,ISYTYP(1,LSTTYP))
            NUMDIS=IRPDPD(IRREP,ISYTYP(2,LSTTYP))
C
            NSIZE=DISSIZ*NUMDIS
            I000=1
            I010=I000+IINTFP*NSIZE
            I020=I010+IINTFP*NSIZE
            IF(I020.GT.MAXCOR) then
               write (*,*) rtn,'-F: no room for out of core ',
     &           'irrep ', irrep
               CALL  INSMEM('SAXLST',I020,MAXCOR)
            endif
            CALL GETLST(ICORE(I000),1,NUMDIS,1,IRREP,LSTINA)
            CALL SSCAL(NSIZE,FA,ICORE(I000),1)
            CALL GETLST(ICORE(I010),1,NUMDIS,1,IRREP,LSTINB)
            CALL SSCAL(NSIZE,FB,ICORE(I010),1)
            CALL SAXPY(NSIZE,ONE,ICORE(I000),1,ICORE(I010),1)
            CALL PUTLST(ICORE(I010),1,NUMDIS,1,IRREP,LSTOUT)
 10      CONTINUE
      ENDIF
C
      RETURN
      END

#include "flags.h"
      SubrOutine projec_IFC(HESS, PHESS, Tmp, PMAT, GMATRX_N, 
     &                      GMATRX_M, GRD, GRDTMP, NXM6)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      Logical Constrain_opt

C Built the projected Hessian and Gradients for redundent internal
C optimizations (see JCP, 117, 9160, 2002). 
C
#include <machsp.com>
#include <mxatms.par>
#include <jodaflags.com>
C
      Dimension HESS(NXM6, NXM6), PMAT(NXM6, NXM6), PHESS(NXM6, NXM6),
     &          GMATRX_M(NXM6, NXM6), GMATRX_N(NXM6, NXM6),
     &          GRD(NXM6), Scr(Maxredunco), Tmp(NXM6, NXm6),
     &          GRDTM(NXM6)
 
      LENGMAT=NXM6*NXM6
      CALL DGETREC(20,'JOBARC','GI-MATRX',LENGMAT,GMATRX_M)
      CALL DGETREC(20,'JOBARC','G-MATRX ',LENGMAT,GMATRX_N)

      Call XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, GMATRX_M, 
     &            NXM6, GMATRX_N, NXM6, 0.0D0, PMAT, NXM6)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The Hessian projector:P"
      CALL OUTPUT(PMAT, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
C Constrained redundent Internal optimizations; Built the C matrix
C as described in JCC, 17, 49, 1996. This applies to constrained 
C redundent internal optimiztions. Use Phes to store the C matrix,
C 
      Call IGetrec(0, "JOBARC", "CONSTRNS", Ilength, Ijunk)
      Constrain_opt = .FALSE.
C
#ifdef _DEBUG_LVL0
      Write(6,"(a,1x,I4,1x,I4)") "Constrained opt?", Ilength,
     &                            Iflags2(h_IFLAGS2_opt_control)
#endif
C
      If (Ilength .Gt. 0) Then
          Constrain_opt = .TRUE.
          If (Iflags2(h_IFLAGS2_opt_control) .NE. 3) Then
             Write(6,"(3x,2a)") "Inconsitency: There are constrains in", 
     &            " input, but opt_control=constrained is not set."
              Call Errex
           Endif
      Endif
C 
      If (Constrain_opt) Then

         Call Build_cmatrix(NXM6, Phess)
C
C Built the CPC; Not that Gmatrx_N{I} are used as scratch matrices.
C     
         CALL XGEMM("T", "N", NXM6, NXM6, NXM6, 1.0D0, Phess,
     &               NXM6, Pmat, NXM6, 0.0D0, GMATRX_N, NXM6)
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, GMATRX_N,
     &               NXM6, Phess, NXM6, 0.0D0, GMATRX_M, NXM6)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The CPC"
      CALL OUTPUT(GMATRX_M, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
C Invert the CPC 
C
CSSS         Call Dgefa(GMATRX_M, NXM6, NXM6, Ipvt, Info)
C
C#ifdef _NOSKIP
CSSS      CALL MINV(GMATRX_M, NXM6, NXM6, Tmp, Det, 1.0D-8, 0, 1)
      
      CALL EIG(GMATRX_M, Tmp, NXM6, NXM6, 1)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the CPC"
      CALL OUTPUT(Tmp, 1, nxm6, 1, nxM6, nxm6, nxm6, 1)
      Write(6,"(a)") "The eigenvalues of the CPC "
      Write(6, "(4F10.5)") (Gmatrx_M(I,I), I=1, Nxm6)
#endif

      DO I = 1, NXM6
         IF (GMATRX_M(I, I) .LE. 1.0D-10) THEN
             GMATRX_M(I, I) = 0.0D0
         ELSE
             GMATRX_M(I, I) = 1.0D0/GMATRX_M(I, I)
         ENDIF
      ENDDO
C
C Built the generalized inverse of CPC matrix,
C
      CALL XGEMM('N', 'N', NXM6, NXM6, NXM6, 1.0D0, Tmp,
     &            NXM6, GMATRX_M, NXM6, 0.0D0, GMATRX_N, NXM6)
      CALL XGEMM('N', 'T', NXM6, NXM6, NXM6, 1.0D0, GMATRX_N,
     &            NXM6, Tmp, NXM6, 0.0D0, GMATRX_M, NXM6)
C#endif 
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The inverse of CPC"
      CALL OUTPUT(GMATRX_M, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
C Create CP and PC
C
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, Phess,
     &               NXM6, Pmat, NXM6, 0.0D0, GMATRX_N, NXM6)
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, Pmat,
     &               NXM6, Phess, NXM6, 0.0D0, Tmp, NXM6)
C
C Built PC(CPC)^(-1)CP
C 
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, Tmp,
     &               NXM6, GMATRX_M, NXM6, 0.0D0, Phess, NXM6)
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, Phess,
     &               NXM6, GMATRX_N, NXM6, 0.0D0, GMATRX_M, NXM6)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The PC(CPC)^(-1)CP"
      CALL OUTPUT(GMATRX_M, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
      CALL OUTPUT(PMAT, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
C Built P = P - PC(CPC)^(-1)CP

       Call XDaxpy(NXM6*NXM6, -1.0D0, GMATRX_M, 1, Pmat, 1)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The constrained Hessian projector:P"
      CALL OUTPUT(PMAT, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
C Built PHP (projected Hessian)
C
     
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PMAT,
     &            NXM6, HESS, NXM6, 0.0D0, PHESS, NXM6)

         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, PMAT, NXM6, 0.0D0, HESS, NXM6)

C Also project the gradients ie. form PG. Then copy the projected gradient
C to the FI array so that the rest of the code can proceed.
C
      Write(6,"(a)") "The gradients, g"
      Write(6,"(6(1x,F15.7))") (Grd(I), I=1,NXM6)
         CALL XGEMM('N', 'N', NXM6, 1, NXM6, 1.0D0, PMAT,
     &               NXM6, GRD, NXM6, 0.0D0, GRDTMP, NXM6)
         CALL XDCOPY(NXM6, GRDTMP, 1, GRD, 1)
C
#ifdef _NOSKIP
C
C Built Alpha(1-P) where Alpha = 1000.0
      CALL ZERO(TMP,NXM6*NXM6)
      DO I=1, NXM6
         TMP(I,I) = 1.0d0
      END DO
C
C Let's do the PHP + 1000.0(1-P) (note that we have already
C built the PHP and stored in HESS). Make -(1-P)
C
      CALL XDAXPY(NXM6*NXM6,-1.d0,TMP,1,PMAT,1)
      CALL XDSCAL(NXM6*NXM6,1000.0D0,PMAT,1)
      CALL XDAXPY(NXM6*NXM6,-1.d0,PMAT,1,HESS,1)
#endif
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The projected Hessian, (PHP)"
      CALL OUTPUT(HESS, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
      Write(6,"(a)") "The projected gradients, Hg"
      Write(6,"(6(1x,F15.7))") (Grd(I), I=1,NXM6)
#endif
      
      Else 
C
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PMAT,
     &            NXM6, HESS, NXM6, 0.0D0, PHESS, NXM6)
         CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, PMAT, NXM6, 0.0D0, HESS, NXM6)
C
C Also project the gradients. Then copy the projected gradient
C to the FI array so that the rest of the code can proceed.
C
         CALL XGEMM('N', 'N', NXM6, 1, NXM6, 1.0D0, PMAT,
     &               NXM6, GRD, NXM6, 0.0D0, GRDTMP, NXM6)
         CALL XDCOPY(NXM6, GRDTMP, 1, GRD, 1)

#ifdef _NOSKIP
      CALL ZERO(TMP,NXM6*NXM6)
      DO I=1, NXM6
         TMP(I,I) = 1.0d0
      END DO
C
C Let's do the PHP + 1000.0(1-P) (note that we have already
C built the PHP and stored in HESS).
C
      CALL XDAXPY(NXM6,-1.d0,TMP,1,PMAT,1)
      CALL XDSCAL(NXM6*NXM6,1000.0D0,PMAT,1)
      CALL XDAXPY(NXM6*NXM6,-1.d0,PMAT,1,HESS,1)
C
#endif
C
#ifdef _DEBUG_LVL0
          Write(6,"(a)")"The projected hessian (PHP)"
          CALL OUTPUT(HESS, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
          Write(6,*) 
          Write(6,"(a)") "The projected gradients Pg"
          Write(6,"(6(1x,F15.7))") (Grd(I), I=1,NXM6)
#endif
      Endif 
           
C------The lines below are for Debugging only--------------

#ifdef _DEBUG_HESSIAN_PROJC
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The (PHP)(PHP)t matrix"
      CALL OUTPUT(HESS, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
      CALL EIG(HESS, PHESS, NXM6, NXM6, 1)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the PHP"
      CALL OUTPUT(phess, 1, nxm6, 1, nxM6, nxm6, nxm6, 1)
      Write(6,"(a)") "The eigenvalues of the PHP "
      Write(6, "(4F10.5)") (Hess(I,I), I=1, Nxm6)
#endif
      DO I = 1, NXM6
         IF (HESS(I, I) .LE. 1.0D-10) THEN
             HESS(I, I) = 0.0D0
         ELSE
             HESS(I, I) = 1.0D0/HESS(I, I)
         ENDIF
      ENDDO
C
C Built the generalized inverse of H-matrix,
C
      CALL XGEMM('N', 'N', NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, HESS, NXM6, 0.0D0, GMATRX_N, NXM6)
      CALL XGEMM('N', 'T', NXM6, NXM6, NXM6, 1.0D0, GMATRX_N,
     &            NXM6, PHESS, NXM6, 0.0D0, HESS, NXM6)
C
C Built P(PHP)-P 
C
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PMAT,
     &            NXM6, HESS, NXM6, 0.0D0, PHESS, NXM6)
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, PMAT, NXM6, 0.0D0, HESS, NXM6)
C
C---These steps require defining STEP and TMP arrays.
C
      CALL XGEMM("N", "N", NXM6, 1, NXM6, -1.0D0, HESS,
     &            NXM6, GRD, NXM6, 0.0D0, STEP, NXM6)
      CALL IGETREC(20,'JOBARC','NUMREDCO', 1, NULLEVAL)
      CALL DGETREC(20,'JOBARC','REDEVECS',NULLEVAL*NXM6,
     &            GMATRX_N)
      CALL XGEMM('T', 'N', NULLEVAL, 1, NXM6, 1.0D0,
     &               GMATRX_N, NXM6, STEP, 15,
     &               0.0D0, TMP1, 3)
     
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The step and overlap with the red. space"
      Write(6, "(8F10.5)") (Step(I), I=1, Nxm6)
      Write(6, "(8F10.5)") (TMP1(I), I=1, NULLEVAL)
#endif
      STOP
#endif
C------------------------------------------------------
      RETURN
      END
     

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_atomscf(watom, scr,
     *                 maxblk, iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 nc1,nc2, nd1, nd2,
     *                 nai, kin, ovl,  
     *                 fa,fb, 
c
     *                 vmax,omax,norb,maxhist,diis_start)  
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'

      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim  
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, n, m, r, s
      integer a,b,c,d
      integer iatom, n_basis  
      double precision watom 

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer me, ierr
      integer nc1, nc2, nd1, nd2 

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision nai(nc1:nc2,nd1:nd2)
      double precision kin(nc1:nc2,nd1:nd2)
      double precision ovl(nc1:nc2,nd1:nd2)
      double precision H0T(nc1:nc2,nd1:nd2)

      double precision ca(nc1:nc2,nd1:nd2)
      double precision cb(nc1:nc2,nd1:nd2)

      double precision fa(nc1:nc2,nd1:nd2)
      double precision fb(nc1:nc2,nd1:nd2)
      integer map(nc1:nc2) 
      integer umap(nc1:nc2) 
      integer beg_anfps(max_shells)  
      integer end_anfps(max_shells)  
      double precision scr(*)   
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      integer*8 ccbeg_pack64(max_dim_coeff), ccend_pack64(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      integer*8 arg64(25)
      integer n_max 
c
c ---------------------------------------------------------------------- 
c Arrays used in the DIIS procedure 
c ---------------------------------------------------------------------- 

      integer vmax,omax,norb,maxhist,diis_start  
      double precision Fai(vmax,omax,maxhist+1) 
      double precision Fbj(vmax,omax,maxhist+1) 
      double precision Ea(norb,norb,maxhist+1) 
      double precision Eb(norb,norb,maxhist+1) 
      double precision BM(maxhist+1,maxhist+1) 
      double precision TBM(maxhist+1,maxhist+1) 
      double precision CM(maxhist+1) 
c
c ---------------------------------------------------------------------- 

      open(66,file='summary.out') 

c     call mpi_comm_rank(mpi_comm_world, me, ierr)

      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical

      iatom = watom 
c      write(6,*) ' Performing an SCF calculation on atom:', iatom 

      call comp_return_h0(H0T, iatom, nc1, nc2, nd1, nd2) 

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         m1 = 1 
         n1 = 1 
         r1 = 1 
         s1 = 1 

         m2 = (nshells)   
         n2 = (nshells)  
         r2 = (nshells) 
         s2 = (nshells)  

c-----------------------------------------------------------------------
c   Find the number of basis functions and shells in the atom.  
c-----------------------------------------------------------------------

         n_basis = 0 
         do m = m1, m2 
            if(atom(m) .eq. iatom) n_basis = n_basis + 
     *                end_nfps(m) - end_nfps(m-1)   
         enddo 
c         write(6,*) ' The number of basis functions on atom', 
c     *                iatom, '=', n_basis  

c-----------------------------------------------------------------------
c   Find the mapping from atom <--> molecule.  
c-----------------------------------------------------------------------

         do n = nc1, nc2 
            map(n) = 0 
            umap(n) = 0 
         enddo 

         n_basis = 0 
         n_max = 0 
         do m = m1, m2 
            beg_anfps(m) = 0   
            end_anfps(m) = 0   

            if(atom(m) .eq. iatom) then 
               beg_anfps(m) = n_basis + 1  

               if (m .eq. 1) then
                  DO n = 1, end_nfps(m) 
                     n_basis = n_basis + 1 
                     map(n_basis) = n 
                     umap(n) = n_basis  
                     if (n .gt. n_max) n_max = n 
                  enddo 
               else 
                  DO n = end_nfps(m-1) + 1, end_nfps(m) 
                     n_basis = n_basis + 1 
                     map(n_basis) = n 
                     umap(n) = n_basis  
                     if (n .gt. n_max) n_max = n 
                  enddo 
               endif 

               end_anfps(m) = n_basis 

            endif 

         enddo 

         if ((n_max .lt. nc1) .or. (n_max .gt. nc2)) then 
           write(66,*) ' UMapping of atom dens wrong:' 
           write(66,*) ' Correct range :', nc1, nc2, 'Computed range:', 
     *                 '1', n_max  
         endif 

         if ((n_basis .lt. nc1) .or. (n_basis .gt. nc2)) then 
           write(66,*) ' Mapping of atom dens wrong:' 
           write(66,*) ' Correct range :', nc1, nc2, 'Computed range:', 
     *                 '1', nbasis   
         endif 

c        write(66,*) ' Mapping Atom', watom  
c        do n = nc1, nc2 
c           write(66,*) 'n umap(n)', n, umap(n)  
c        enddo 
c        do m = m1, m2 
c           if(atom(m) .eq. iatom) then 
c           write(66,*) ' Mth shell:', m, beg_anfps(m), end_anfps(m) 
c           endif 
c        enddo 
c         write(6,*) ' The number of basis functions on atom', 
c     *                iatom, '=', n_basis  

         call do_atomscf(watom, scr,
     *                 maxblk, iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 nc1,nc2, nd1, nd2,
     *                 H0T, nai, kin, ovl,  
     *                 fa,  fb, 
     *                 n_basis, beg_anfps, end_anfps, map, umap, 
c 
     *                 vmax,omax,norb,maxhist,diis_start) 

      return 
      end 

      subroutine do_atomscf(watom, scr,
     *                 maxblk, iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 nc1,nc2, nd1, nd2,
     *                 H0T, nai, kin, ovl,  
     *                 fina,  finb, 
     *                 n_basis, beg_anfps, end_anfps, map, umap, 
c
     *                 vmax,omax,norb,maxhist,diis_start) 
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2 
      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim  
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, n, m, r, s, l, mn, rs  
      integer a,b,c,d
      integer iatom, n_basis, n_basis_org   
      double precision watom 

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer me, ierr
      integer nc1, nc2, nd1, nd2 

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision nai(nc1:nc2,nd1:nd2)
      double precision kin(nc1:nc2,nd1:nd2)
      double precision ovl(nc1:nc2,nd1:nd2)
      double precision H0T(nc1:nc2,nd1:nd2)

      double precision fina(nc1:nc2,nd1:nd2)
      double precision finb(nc1:nc2,nd1:nd2)

      double precision h0(n_basis,n_basis) 
      double precision aovl(n_basis,n_basis) 
      double precision sos(n_basis,n_basis) 
      double precision Qxx(n_basis,n_basis) 

      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision HFDOLD_A(n_basis,n_basis) 
      double precision HFDOLD_B(n_basis,n_basis) 

      double precision ca(n_basis,n_basis) 
      double precision cb(n_basis,n_basis) 
      double precision cba(n_basis,n_basis) 
      double precision cbb(n_basis,n_basis) 
      double precision FTa(n_basis,n_basis) 
      double precision FTb(n_basis,n_basis) 
      double precision Fa(n_basis,n_basis) 
      double precision Fb(n_basis,n_basis) 
      double precision temp, tempa, tempb   
      double precision charge_keep(max_centers) 
      integer doit, itemp, jtemp, p, p1  

      integer nocc_a, nocc_b, nvirt_a, nvirt_b  
      integer nocc_a_org, nocc_b_org 
      integer iter, max_iter 
c
c ---------------------------------------------------------------------- 
c Arrays used in the DIIS procedure 
c ---------------------------------------------------------------------- 

      integer vmax,omax,norb,nhist,maxhist,diis_start   
      double precision Fai(vmax,omax,maxhist+1) 
      double precision Fbj(vmax,omax,maxhist+1) 
      double precision Ea(norb,norb,maxhist+1) 
      double precision Eb(norb,norb,maxhist+1) 
      double precision BM(maxhist+1,maxhist+1) 
      double precision TBM(maxhist+1,maxhist+1) 
      double precision CM(maxhist+1) 
c ---------------------------------------------------------------------- 

      integer map(nc1:nc2) 
      integer umap(nc1:nc2) 
      integer beg_anfps(max_shells)  
      integer end_anfps(max_shells)  
      double precision scr(*)   
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      integer*8 ccbeg_pack64(max_dim_coeff), ccend_pack64(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      integer*8 arg64(25)

c     call mpi_comm_rank(mpi_comm_world, me, ierr)

      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical

      iatom = watom 

      do m = 1, max_centers 
         if (m .eq. iatom) then 
            nocc_b = charge(m)/2 
            nocc_a = charge(m) - nocc_b 
         endif 
      enddo 
      charge_keep(iatom) = charge(iatom) 
      nvirt_a = n_basis - nocc_a  
      nvirt_b = n_basis - nocc_b  

c TEST !!!! 

c     write(6,*) ' Performing an SCF calculation on atom:', iatom, 
c    * 'in a basis of', n_basis, 'functions with', nocc_a, nocc_b, 
c    * 'alpha and beta occupied electrons and ', nvirt_a, nvirt_b, 
c    * ' alpha and beta virtual electrons'    
      if (nocc_a .eq. 0) return  

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

      m1 = 1 
      n1 = 1 
      r1 = 1 
      s1 = 1 

      m2 = (nshells)   
      n2 = (nshells)  
      r2 = (nshells) 
      s2 = (nshells)  

c-----------------------------------------------------------------------
c Sum nai and kin into small array and copy ovl there too. 
c --> initial guess   
c-----------------------------------------------------------------------

      do n = 1, n_basis  
      do m = 1, n_basis  
         h0(m,n) = 0.0  
      enddo  
      enddo  

      itemp = 0 
      do n = nc1, nc2 
         if (umap(n).ne.0) then 
            itemp = itemp + 1 
            jtemp = 0 
      do m = nc1, nc2 
         if (umap(m).ne.0) then 
            aovl(umap(m),umap(n)) = ovl(m,n) 
            h0(umap(m),umap(n))   = H0T(m,n)   
            jtemp = jtemp + 1 
         endif 
      enddo  
         if (jtemp .ne. n_basis) then 
            write(6,*) ' Jtemp .ne. n_basis ', jtemp, n_basis 
            call abort_job() 
         endif 
         endif 
      enddo  
      if (itemp .ne. n_basis) then 
         write(6,*) ' itemp .ne. n_basis ', itemp, n_basis 
         call abort_job() 
      endif 

      if (itemp*jtemp .ne. n_basis**2) then 
         write(6,*) ' Something possibly wrong with umap ', 
     *                itemp, n_basis 
         call abort_job()
      endif 

c-----------------------------------------------------------------------
c Construct the hcore initial guess  
c-----------------------------------------------------------------------

      do n = 1, n_basis  
      do m = 1, n_basis  
         FA(m,n) = 0.0  
         FB(m,n) = 0.0  
         FTA(m,n) = 0.0  
         FTB(m,n) = 0.0  
         HFD_a(m,n) = 0.0 
         HFD_b(m,n) = 0.0 
      enddo  
      enddo  

      do n = 1, n_basis  
      do m = 1, n_basis  
         FA(m,n) = h0(m,n) 
         FB(m,n) = h0(m,n) 
      enddo  
      enddo  

c-----------------------------------------------------------------------
c Construct U*S**(-1/2)  
c-----------------------------------------------------------------------

      call diag(aovl,sos,m,n_basis,0,1,1) 
      do m = 1, n_basis  
      do n = 1, n_basis  
         temp = 0.0 
         do l = 1, n_basis  
            temp = temp + sos(m,l)*aovl(l,n) 
         enddo 
         Qxx(m,n) = temp 
       enddo  
       enddo  

c-----------------------------------------------------------------------
c Transpose the Fock matrix -> Construct S^(-1/2) F S^(-1/2)  
c-----------------------------------------------------------------------

       call fock_transpose(FA,FB,Qxx,FTa,FTb,n_basis) 

c-----------------------------------------------------------------------
c Diagonalize the transposed Fock matrix  
c-----------------------------------------------------------------------

       call diag(FTa,ca,m,n_basis,0,0,0) 
       call diag(FTb,cb,m,n_basis,0,0,0) 

c-----------------------------------------------------------------------
c Back transform the coefficient array  
c-----------------------------------------------------------------------

       call c_backtran(Qxx,ca,cb,cba,cbb,n_basis) 

c-----------------------------------------------------------------------
c Compute the HF density  
c-----------------------------------------------------------------------

       call hfdensity(ca,cb,HFD_A,HFD_B,n_basis,nocc_a,nocc_b) 

c-----------------------------------------------------------------------
c Compute the HF energy   
c-----------------------------------------------------------------------

       call hfenergy(HFD_A,HFD_B,FA,FB,h0,n_basis) 

c-----------------------------------------------------------------------
c Copy the HF Density into the old Density. 
c-----------------------------------------------------------------------

      call hfdensity_copy(HFD_A,HFD_B,HFDOLD_A,HFDOLD_B,n_basis)  

c     if (nocc_a .ne. nocc_b) go to 100 

c     if (nocc_a .eq. 1) go to 100 

c-----------------------------------------------------------------------
c Start the SCF iterations  
c-----------------------------------------------------------------------

      max_iter = 25  
      DO iter = 1, max_iter 

c-----------------------------------------------------------------------
c       Construct the new Fock matrix  
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
c       One-electron piece  
c-----------------------------------------------------------------------

        do m = 1, n_basis 
        do n = 1, n_basis 
           FA(m,n) = h0(m,n)  
           FB(m,n) = h0(m,n)  
        enddo 
        enddo 

c-----------------------------------------------------------------------
c       Two-electron piece  
c-----------------------------------------------------------------------

         do m = m1, m2
            if(atom(m) .eq. iatom) then  
            aa1 = beg_anfps(m)
            aa2 = end_anfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (m .le. n) then 
            if(atom(n) .eq. iatom) then  
            bb1 = beg_anfps(n)
            bb2 = end_anfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if(atom(r) .eq. iatom) then  
            cc1 = beg_anfps(r)
            cc2 = end_anfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)
         do s = s1, s2
            if (r .le. s) then 
            if(atom(s) .eq. iatom) then  
            dd1 = beg_anfps(s)
            dd2 = end_anfps(s)
c
c-----------------------------------------------------------------------
c   Determine the largest density element.
c-----------------------------------------------------------------------

               x4 = coords(1,s)
               y4 = coords(2,s)
               z4 = coords(3,s)
               call pack_coeffs(alphas, ixalpha, coeffs, ixpcoef, 
     *                          ncfps, npfps, m, n, 
     *                          r, s, alpha_pack, nalpha_pack, 
     *                          pcoeff_pack, npcoeff_pack, 
     *                          ccbeg, ccend, indx_cc,
     *                          ccbeg_pack, ccend_pack) 

c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

c              if (doit .eq. 1) then 

               call ERD__GENER_ERI_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum, 
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n), 
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4, alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints, 
     *                nfirst, scr)    

c               endif 

c---------------------------------------------------------------------------
c   Move the integrals into the output block.  
c---------------------------------------------------------------------------

           if (nints .gt. 0) then

               call form_ss1fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)
               call form_ss2fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

               call form_ss3fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

               call form_ss4fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

               call form_ss5fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

               call form_ss6fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

               call form_ss7fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

               call form_ss8fock(scr(nfirst), n_basis,
     *                        aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,
     *                        HFD_A,HFD_B,FA,FB)

           endif
c 
            endif 
            endif 
         enddo   ! s
            endif 
         enddo   ! r
            endif 
            endif 
         enddo   ! n
            endif 
         enddo   ! m

c-----------------------------------------------------------------------
c       Done computing the Fock matrix   
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
c       Compute the new HF energy  
c-----------------------------------------------------------------------

        call hfenergy(HFD_A,HFD_B,FA,FB,h0,n_basis) 

c-----------------------------------------------------------------------
c       Compute the DIIS coefficients  
c-----------------------------------------------------------------------

        call gen_hist(iter,maxhist,diis_start,n_basis,nvirt_a,
     *                nocc_a,nvirt_b,nocc_b,ca,cb,FA,FB,Fai,Fbj,Ea,Eb)

        if ((iter .lt. maxhist+diis_start-1) .and. 
     *      (iter .gt. diis_start)) then 
           nhist = iter - (diis_start-1)  
           call do_diis(nhist,nvirt_a,nocc_a,nvirt_b,nocc_b,n_basis,
     *                  Fai,Ea, Fbj,Eb, FA, FB) 
        endif 

        if (iter .ge. maxhist+diis_start-1) then 
           nhist = maxhist   
           call do_diis(nhist,nvirt_a,nocc_a,nvirt_b,nocc_b,n_basis,
     *                  Fai,Ea, Fbj,Eb, FA, FB) 
           call move_hist(nhist,diis_start,n_basis,Fa,Fb,Ea,Eb) 
        endif 

c-----------------------------------------------------------------------
c       Transpose the new Fock Matrix   
c-----------------------------------------------------------------------

        call fock_transpose(FA,FB,Qxx,FTa,FTb,n_basis) 

c-----------------------------------------------------------------------
c       Diagonalize the new Transposed Fock Matrix   
c-----------------------------------------------------------------------

        call diag(FTa,ca,m,n_basis,0,0,0) 
        call diag(FTb,cb,m,n_basis,0,0,0) 

c-----------------------------------------------------------------------
c       Back Transform the coefficient array  
c-----------------------------------------------------------------------

        call c_backtran(Qxx,ca,cb,cba,cbb,n_basis) 

c-----------------------------------------------------------------------
c       Check on convergence and replace the old density with the new   
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
c       Compute the new HF density  
c-----------------------------------------------------------------------

        call hfdensity(ca,cb,HFD_A,HFD_B,n_basis,nocc_a,nocc_b) 

c-----------------------------------------------------------------------
c       Check for convergence    
c-----------------------------------------------------------------------

        call check_conv(HFD_A,HFD_B,HFDOLD_A,HFDOLD_B,n_basis,doit)  
        if (doit .eq. 1) go to 100 

c-----------------------------------------------------------------------
c Copy the HF Density into the old Density. 
c-----------------------------------------------------------------------

        call hfdensity_copy(HFD_A,HFD_B,HFDOLD_A,HFDOLD_B,n_basis)  


      ENDDO ! iter = 1, max_iter 
100   continue 

c      write(6,*) ' Alpha Orbital energies ' 
c      write(6,*) ' -----------------------------------------------' 
c      do m = 1, nocc_a 
c         write(6,*) '  ', m, FTA(m,m), FTA(m,m)*27.21138386 
c      enddo  
c      write(6,*) ' -----------------------------------------------' 
c      do m = nocc_a + 1, n_basis  
c         write(6,*) '  ', m, FTA(m,m), FTA(m,m)*27.21138386  
c      enddo  
c      write(6,*) ' -----------------------------------------------' 
c      write(6,*) ' ' 

c      write(6,*) ' Beta Orbital energies ' 
c      write(6,*) ' -----------------------------------------------' 
c      do m = 1, nocc_b 
c         write(6,*) '  ', m, FTB(m,m), FTB(m,m)*27.21138386 
c      enddo  
c      write(6,*) ' -----------------------------------------------' 
c      do m = nocc_b + 1, n_basis  
c         write(6,*) '  ', m, FTB(m,m), FTB(m,m)*27.21138386  
c      enddo  
c      write(6,*) ' -----------------------------------------------' 
c      write(6,*) ' ' 

c         write(6,*) ' Done SCF calculation of ATOM :', iatom 

c-----------------------------------------------------------------------
c     Put the density matrix into the full matrix   
c-----------------------------------------------------------------------

      do n = 1, n_basis
      do m = 1, n_basis
         if ((map(m) .ne. 0) .and. (map(n) .ne. 0)) then  
         Fina(map(m),map(n)) = HFD_a(m,n)  
         Finb(map(m),map(n)) = HFD_b(m,n)   
c        Fina(map(m),map(n)) = FTa(m,n)  
c        Finb(map(m),map(n)) = FTb(m,n)   
         endif 
      enddo 
      enddo 

      charge(iatom) = charge_keep(iatom) 

      return
      end
 

      subroutine form_fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                     dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s 
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      do s = dd1, dd2 
      do r = cc1, cc2 
         temp_rs = HFD_A(r,s) + HFD_B(r,s) 
      do n = bb1, bb2 
      do m = aa1, aa2 
           temp_mn  = int_block(m,n,r,s)*temp_rs 
           F_A(m,n) = F_A(m,n) + temp_mn 
           F_B(m,n) = F_B(m,n) + temp_mn 
      enddo 
      enddo 
      enddo 
      enddo 

      do s = dd1, dd2 
      do r = cc1, cc2 
      do n = bb1, bb2 
         tempa = HFD_A(n,s) 
         tempb = HFD_B(n,s) 
      do m = aa1, aa2 
           F_A(m,r) = F_A(m,r) - int_block(m,n,r,s)*tempa ! HFD_A(n,s)  
           F_B(m,r) = F_B(m,r) - int_block(m,n,r,s)*tempb ! HFD_B(n,s)  
      enddo 
      enddo 
      enddo 
      enddo 

      return 
      end 

      subroutine form_sfock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s 
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

c-----------------------------------------------------------------------
c m=n=r=s  
c-----------------------------------------------------------------------

c     if (m.eq.n .and. r.eq.s .and. n.eq.r) then 

         do s = dd1, dd2 
         do r = cc1, cc2 
            temp_rs = HFD_A(r,s) + HFD_B(r,s) 
         do n = bb1, bb2 
         do m = aa1, aa2 
              temp_mn  = int_block(m,n,r,s)*temp_rs 
              F_A(m,n) = F_A(m,n) + temp_mn 
              F_B(m,n) = F_B(m,n) + temp_mn 
         enddo 
         enddo 
         enddo 
         enddo 

         do s = dd1, dd2 
         do r = cc1, cc2 
            do m = aa1, aa2 
               F1A(m) = 0.0 
               F1B(m) = 0.0 
            enddo 
         do n = bb1, bb2 
            tempa = HFD_A(n,s) 
            tempb = HFD_B(n,s) 
         do m = aa1, aa2 
              F1A(m) = F1A(m) - int_block(m,n,r,s)*tempa ! HFD_A(n,s)  
              F1B(m) = F1B(m) - int_block(m,n,r,s)*tempb ! HFD_B(n,s)  
         enddo 
         enddo 
            do m = aa1, aa2 
               F_A(m,r) = F_A(m,r) + F1A(m)  
               F_B(m,r) = F_A(m,r) + F1B(m)  
            enddo 
         enddo 
         enddo 

c     endif 

c-----------------------------------------------------------------------
c  m.lt.n .and. r.lt.s .and. m.lt.r .and. n.ne.s .and. n.ne.r .and. m.ne.s   
c-----------------------------------------------------------------------

      if(m.lt.n .and. r.lt.s .and. m.lt.r .and. n.ne.s .and. 
     *   n.ne.r .and. m.ne.s) then  

      endif 

      return 
      end 

      subroutine fock_transpose(Fa,FB,Qxx,FTa,FTb,n_basis) 
      implicit none 
      integer n_basis, m, n, l, s  
      double precision Fa(n_basis,n_basis)  
      double precision Fb(n_basis,n_basis)  
      double precision FTa(n_basis,n_basis)  
      double precision FTb(n_basis,n_basis)  
      double precision Qxx(n_basis,n_basis)  
      double precision tempa, tempb 

      do m = 1, n_basis 
      do n = 1, n_basis 
         FTa(m,n) = 0.0  
         FTb(m,n) = 0.0  
      enddo 
      enddo 

      do m = 1, n_basis  
      do s = 1, n_basis  
         tempa = 0.0 
         tempb = 0.0 
         do l = 1, n_basis  
            tempa = tempa + Qxx(l,m)*FA(l,s) 
            tempb = tempb + Qxx(l,m)*FB(l,s) 
         enddo 

         do n = 1, n_basis  
            FTa(m,n) = FTa(m,n) + tempa*Qxx(s,n) 
            FTb(m,n) = FTb(m,n) + tempb*Qxx(s,n) 
         enddo 
      enddo 
      enddo 

      return 
      end 

      subroutine c_backtran(Qxx,ca,cb,cba,cbb,n_basis) 
      implicit none 
      integer n_basis 
      integer m, p, n  
      double precision Qxx(n_basis,n_basis)  
      double precision ca(n_basis,n_basis)  
      double precision cb(n_basis,n_basis)  
      double precision cba(n_basis,n_basis)  
      double precision cbb(n_basis,n_basis) 
      double precision tempa, tempb  

      do p = 1, n_basis  
      do m = 1, n_basis  
         tempa = 0.0  
         tempb = 0.0  
         do n = 1, n_basis  
            tempa = tempa + Qxx(m,n)*ca(n,p) 
            tempb = tempb + Qxx(m,n)*cb(n,p) 
         enddo 
         cba(m,p) = tempa
         cbb(m,p) = tempb
      enddo 
      enddo 

      do p = 1, n_basis  
      do m = 1, n_basis  
         ca(m,p) = cba(m,p) 
         cb(m,p) = cbb(m,p) 
      enddo 
      enddo 

      return 
      end 


      subroutine hfdensity(ca,cb,HFD_A,HFD_B,n_basis,nocc_a,nocc_b) 
      implicit none 
      integer n_basis, nocc_a, nocc_b 
      integer m, n, i, j 
      double precision ca(n_basis,n_basis) 
      double precision cb(n_basis,n_basis) 
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision tempa, tempb  

      do m = 1, n_basis  
      do n = 1, n_basis  
         tempa = 0.0 
         tempb = 0.0 
         do i = 1, nocc_a 
            tempa = tempa + ca(m,i)*ca(n,i) 
         enddo 
         do j = 1, nocc_b 
            tempb = tempb + cb(m,j)*cb(n,j) 
         enddo 
         HFD_A(m,n) = tempa 
         HFD_B(m,n) = tempb 
      enddo 
      enddo 

      return 
      end 

      subroutine hfenergy(HFD_A,HFD_B,FA,FB,h0,n_basis) 
      implicit none 
      integer n_basis 
      integer m, n 
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision FA(n_basis,n_basis) 
      double precision FB(n_basis,n_basis) 
      double precision h0(n_basis,n_basis) 
      double precision ea, eb, etotal 

      ea = 0.0 
      eb = 0.0 
      etotal = 0.0 

      do n = 1, n_basis  
      do m = 1, n_basis  
         ea = ea + (h0(m,n)+FA(m,n))*HFD_A(m,n)   
         eb = eb + (h0(m,n)+FB(m,n))*HFD_B(m,n)   
      enddo  
      enddo  

      etotal = 0.5d0*(ea + eb) 
      write(6,*) ' Total SCF energy(-NN) = ', etotal 

      return 
      end 
   
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss1fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
      double precision t8xx
      double precision t9xx
      double precision t10xx
      double precision t11xx
      double precision t12xx
      double precision t13xx
      double precision t14xx
      double precision t15xx
      double precision t16xx
      double precision t17xx
      double precision t18xx
      double precision t19xx
      double precision t20xx
      double precision t21xx
      double precision t22xx
c
c
c############ CLASS 6  ############
c SS1 
c#  Do four-center part (mu nu |la si)->(mu nu |si la ),(nu mu|la si),(nu mu|si la)
c#                      (la si |mu nu),(si la |mu nu),(la si |nu mu),(si la |nu mu)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if ( l .lt. s) then 
            T1xx = HFD_A(l,s) + HFD_B(l,s)
            T5xx = 0.0 
      do n = bb1, bb2 
         if ( n .ne. s) then 
         if ( n .ne. l) then 
            T11xx = 0.0 
            T13xx = 0.0 
            T19xx = 0.0 
            T21xx = 0.0 
      do m = aa1, aa2 
c
         if ( m .lt. n) then 
         if ( m .lt. l) then 
         if ( m .ne. s) then 

            wint      = int_block(m,n,l,s) 
            T4xx      = HFD_A(m,n) + HFD_B(m,n)
            T2xx      = 2.0*wint*T1xx
            T5xx      = T5xx + 2.0*wint*T4xx
            T7xx      = wint*HFD_A(n,s)
            T9xx      = wint*HFD_A(n,l)
            T11xx     = T11xx + wint*HFD_A(m,s)
            T13xx     = T13xx + wint*HFD_A(m,l)
            T19xx     = T19xx + wint*HFD_B(m,s)
            T21xx     = T21xx + wint*HFD_b(m,l)

            F_a(m,n)  = F_a(m,n) + T2xx
            F_b(m,n)  = F_b(m,n) + T2xx
            F_a(n,m)  = F_a(n,m) + T2xx
            F_b(n,m)  = F_b(n,m) + T2xx

            F_A(m,l) = F_a(m,l) - T7xx
            F_A(l,m) = F_a(l,m) - T7xx

            F_a(m,s) = F_a(m,s) - T9xx
            F_A(s,m) = F_a(s,m) - T9xx

            T15xx    = wint*HFD_B(n,s)
            F_B(m,l) = F_b(m,l) - T15xx
            F_B(l,m) = F_b(l,m) - T15xx

            T17xx    = wint*HFD_B(n,l)
            F_b(m,s) = F_b(m,s) - T17xx
            F_b(s,m) = F_b(s,m) - T17xx

         endif 
         endif 
         endif 

      enddo ! m  
            F_A(n,l) = F_a(n,l) - T11xx
            F_A(l,n) = F_a(l,n) - T11xx
            F_A(n,s) = F_a(n,s) - T13xx
            F_A(s,n) = F_a(s,n) - T13xx
            F_b(n,l) = F_b(n,l) - T19xx
            F_b(l,n) = F_b(l,n) - T19xx
            F_b(n,s) = F_b(n,s) - T21xx
            F_b(s,n) = F_b(s,n) - T21xx
         endif 
         endif 
      enddo ! n  
            F_a(l,s) = F_a(l,s) + T5xx
            F_b(l,s) = F_b(l,s) + T5xx
            F_a(s,l) = F_a(s,l) + T5xx
            F_b(s,l) = F_b(s,l) + T5xx
         endif 
      enddo ! l  
      enddo ! s  
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss2fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
      double precision t8xx
      double precision t9xx
      double precision t10xx
      double precision t11xx
      double precision t12xx
      double precision t13xx
      double precision t14xx
      double precision t15xx
      double precision t16xx
      double precision t17xx
      double precision t18xx
      double precision t19xx
      double precision t20xx
      double precision t21xx
      double precision t22xx
c
c########### CLASS 3  ############
c SS2 
c  Do two-center part (m m |m n)->(m n |m m ),(m m|n m),(n m|m m)
c  Do three-center part (m m |n l)->(m m |l n ),(n l|m m),(l n|m m)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if (l .lt. s) then 
             T1xx = HFD_a(l,s) + HFD_b(l,s)
             T4xx = 0.0  
      do n = bb1, bb2 
      do m = aa1, aa2 
         if (m .eq. n) then 

             wint     = int_block(m,n,l,s) 
             T3xx     = HFD_a(m,n) + HFD_b(m,n)
             T2xx     = 2.0*wint*T1xx
             T4xx     = T4xx + wint*T3xx
             T6xx     = wint*HFD_a(n,s)
             T8xx     = wint*HFD_a(n,l)
             T10xx    = wint*HFD_b(n,s)
             T12xx    = wint*HFD_b(n,l)

             F_a(m,n) = F_a(m,n) + T2xx
             F_b(m,n) = F_b(m,n) + T2xx

             F_a(m,l) = F_a(m,l) - T6xx
             F_a(l,m) = F_a(l,m) - T6xx

             F_a(m,s) = F_a(m,s) - T8xx
             F_a(s,m) = F_a(s,m) - T8xx

             F_b(m,l) = F_b(m,l) - T10xx
             F_b(l,m) = F_b(l,m) - T10xx

             F_b(m,s) = F_b(m,s) - T12xx
             F_b(s,m) = F_b(s,m) - T12xx

         endif 
      enddo 
      enddo 
             F_a(l,s) = F_a(l,s) + T4xx
             F_b(l,s) = F_b(l,s) + T4xx
             F_a(s,l) = F_a(s,l) + T4xx
             F_b(s,l) = F_b(s,l) + T4xx
         endif 
      enddo 
      enddo 

c ---------------------------------------------------------------------------- 
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss3fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
      double precision t8xx
      double precision t9xx
      double precision t10xx
      double precision t11xx
      double precision t12xx
      double precision t13xx
      double precision t14xx
      double precision t15xx
      double precision t16xx
      double precision t17xx
      double precision t18xx
      double precision t19xx
      double precision t20xx
      double precision t21xx
      double precision t22xx
c
c########### CLASS 5  ############
c##################  CLASS A ##############
c SS3 
c  Do three-center part (m n |m la)->(m n |la m ),(n m|m la),(n m|la m)
c                       (m la |m n),(la m |m n ),(m la |n m),(la m |n m)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if ( l .lt. s) then 
            T1xx = HFD_a(l,s) + HFD_b(l,s)
            T5xx = 0.0 
      do n = bb1, bb2 
         if ( n .lt. s) then 
            T19xx = 0.0 
            T21xx = 0.0 
            T11xx = 0.0 
            T13xx = 0.0 
      do m = aa1, aa2 
         if ( m .lt. n) then 
         if ( m .eq. l) then 

                wint     = int_block(m,n,l,s) 
                T4xx     = HFD_a(m,n) + HFD_b(m,n)
                T2xx     = 2.0*wint*T1xx
                T5xx     = T5xx + 2.0*wint*T4xx
                T7xx     = wint*HFD_a(n,s)
                T9xx     = wint*HFD_a(n,l)
                T11xx    = T11xx + wint*HFD_a(m,s)
                T13xx    = T13xx + wint*HFD_a(m,l)
                T15xx    = wint*HFD_b(n,s)
                T17xx    = wint*HFD_b(n,l)
                T19xx    = T19xx + wint*HFD_b(m,s)
                T21xx    = T21xx + wint*HFD_b(m,l)

                F_a(m,n) = F_a(m,n) + T2xx
                F_b(m,n) = F_b(m,n) + T2xx
                F_a(n,m) = F_a(n,m) + T2xx
                F_b(n,m) = F_b(n,m) + T2xx

                F_a(m,l) = F_a(m,l) - T7xx
                F_a(l,m) = F_a(l,m) - T7xx
                F_a(m,s) = F_a(m,s) - T9xx
                F_a(s,m) = F_a(s,m) - T9xx

                F_b(m,l) = F_b(m,l) - T15xx
                F_b(l,m) = F_b(l,m) - T15xx
                F_b(m,s) = F_b(m,s) - T17xx
                F_b(s,m) = F_b(s,m) - T17xx
c
         endif 
         endif 
      enddo ! m  
            F_b(n,l) = F_b(n,l) - T19xx
            F_b(l,n) = F_b(l,n) - T19xx
            F_b(n,s) = F_b(n,s) - T21xx
            F_b(s,n) = F_b(s,n) - T21xx
            F_a(n,l) = F_a(n,l) - T11xx
            F_a(l,n) = F_a(l,n) - T11xx
            F_a(n,s) = F_a(n,s) - T13xx
            F_a(s,n) = F_a(s,n) - T13xx
         endif 
      enddo ! n  
            F_a(l,s) = F_a(l,s) + T5xx
            F_b(l,s) = F_b(l,s) + T5xx
            F_a(s,l) = F_a(s,l) + T5xx
            F_b(s,l) = F_b(s,l) + T5xx
         endif 
      enddo ! l  
      enddo ! s  
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss4fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
      double precision t8xx
      double precision t9xx
      double precision t10xx
      double precision t11xx
      double precision t12xx
      double precision t13xx
      double precision t14xx
      double precision t15xx
      double precision t16xx
      double precision t17xx
      double precision t18xx
      double precision t19xx
      double precision t20xx
      double precision t21xx
      double precision t22xx
c
c##################  CLASS B ##############
c SS4 
c  Do three-center part (m n |m la)->(m n |la m ),(n m|m la),(n m|la m)
c                       (m la |m n),(la m |m n ),(m la |n m),(la m |n m)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if ( l .lt. s) then 
            T1xx = HFD_a(l,s) + HFD_b(l,s)
            T11xx = 0.0 
            T13xx = 0.0 
            T5xx  = 0.0 
      do n = bb1, bb2 
         if ( n .eq. l) then 
            T19xx = 0.0 
            T21xx = 0.0 
      do m = aa1, aa2 
         if ( m .lt.  n) then 
         if ( m .lt. s) then 

             wint     = int_block(m,n,l,s) 
             T4xx     = HFD_a(m,n) + HFD_b(m,n)
             T2xx     = 2.0*wint*T1xx
             T7xx     = wint*HFD_a(n,s)
             T9xx     = wint*HFD_a(n,l)
             T15xx    = wint*HFD_b(n,s)
             T17xx    = wint*HFD_b(n,l)

             T19xx    = T19xx + wint*HFD_b(m,s)
             T21xx    = T21xx + wint*HFD_b(m,l)

             T5xx     = T5xx + 2.0*wint*T4xx
             T11xx    = T11xx + wint*HFD_a(m,s)
             T13xx    = T13xx + wint*HFD_a(m,l)

             F_a(m,n) = F_a(m,n) + T2xx
             F_b(m,n) = F_b(m,n) + T2xx
             F_a(n,m) = F_a(n,m) + T2xx
             F_b(n,m) = F_b(n,m) + T2xx

             F_a(m,l) = F_a(m,l) - T7xx
             F_a(l,m) = F_a(l,m) - T7xx

             F_a(m,s) = F_a(m,s) - T9xx
             F_a(s,m) = F_a(s,m) - T9xx

             F_b(m,l) = F_b(m,l) - T15xx
             F_b(l,m) = F_b(l,m) - T15xx

             F_b(m,s) = F_b(m,s) - T17xx
             F_b(s,m) = F_b(s,m) - T17xx
c
         endif 
         endif 
      enddo ! m  
             F_a(n,l) = F_a(n,l) - T11xx
             F_a(l,n) = F_a(l,n) - T11xx
             F_a(n,s) = F_a(n,s) - T13xx
             F_a(s,n) = F_a(s,n) - T13xx
             F_b(n,l) = F_b(n,l) - T19xx
             F_b(l,n) = F_b(l,n) - T19xx
             F_b(n,s) = F_b(n,s) - T21xx
             F_b(s,n) = F_b(s,n) - T21xx
         endif 
      enddo ! n  
             F_a(l,s) =  F_a(l,s) + T5xx
             F_b(l,s) =  F_b(l,s) + T5xx
             F_a(s,l) =  F_a(s,l) + T5xx
             F_b(s,l) =  F_b(s,l) + T5xx
         endif 
      enddo ! l  
      enddo ! s  
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss5fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
      double precision t8xx
      double precision t9xx
      double precision t10xx
      double precision t11xx
      double precision t12xx
      double precision t13xx
      double precision t14xx
      double precision t15xx
      double precision t16xx
      double precision t17xx
      double precision t18xx
      double precision t19xx
      double precision t20xx
      double precision t21xx
      double precision t22xx
c
c##################  CLASS C ##############
c SS5 
c  Do three-center part (m n |m la)->(m n |la m ),(n m|m la),(n m|la m)
c                       (m la |m n),(la m |m n ),(m la |n m),(la m |n m)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if ( l .lt. s) then 
            T1xx = HFD_a(l,s) + HFD_b(l,s)
            T5xx = 0.0 
      do n = bb1, bb2 
         if ( n .eq. s) then 
            T11xx = 0.0 
            T13xx = 0.0 
            T19xx = 0.0 
            T21xx = 0.0 
      do m = aa1, aa2 
         if ( m .lt. n) then 
         if ( m .lt. l) then 
c 
             wint     = int_block(m,n,l,s) 
             T4xx     = HFD_a(m,n) + HFD_b(m,n)
             T2xx     = 2.0*wint*T1xx
             T7xx     = wint*HFD_a(n,s)
             T9xx     = wint*HFD_a(n,l)
             T15xx    = wint*HFD_b(n,s)
             T17xx    = wint*HFD_b(n,l)

             T11xx    = T11xx + wint*HFD_a(m,s)
             T13xx    = T13xx + wint*HFD_a(m,l)
             T5xx     = T5xx + 2.0*wint*T4xx
             T19xx    = T19xx + wint*HFD_b(m,s)
             T21xx    = T21xx + wint*HFD_b(m,l)

             F_a(m,n) = F_a(m,n) + T2xx
             F_a(n,m) = F_a(n,m) + T2xx
             F_b(m,n) = F_b(m,n) + T2xx
             F_b(n,m) = F_b(n,m) + T2xx

             F_a(m,l) = F_a(m,l) - T7xx
             F_a(l,m) = F_a(l,m) - T7xx

             F_a(m,s) = F_a(m,s) - T9xx
             F_a(s,m) = F_a(s,m) - T9xx

             F_b(m,l) = F_b(m,l) - T15xx
             F_b(l,m) = F_b(l,m) - T15xx

             F_b(m,s) = F_b(m,s) - T17xx
             F_b(s,m) = F_b(s,m) - T17xx
c
         endif 
         endif 
      enddo ! m  
            F_b(n,l) = F_b(n,l) - T19xx
            F_b(l,n) = F_b(l,n) - T19xx
            F_a(n,l) = F_a(n,l) - T11xx
            F_a(l,n) = F_a(l,n) - T11xx
            F_a(n,s) = F_a(n,s) - T13xx
            F_a(s,n) = F_a(s,n) - T13xx
            F_b(n,s) = F_b(n,s) - T21xx
            F_b(s,n) = F_b(s,n) - T21xx
         endif 
      enddo ! n  
            F_a(l,s) = F_a(l,s) + T5xx
            F_b(l,s) = F_b(l,s) + T5xx
            F_a(s,l) = F_a(s,l) + T5xx
            F_b(s,l) = F_b(s,l) + T5xx
         endif 
      enddo ! l  
      enddo ! s  
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss6fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
c
c########### CLASS 1  ############
c SS6 
c  Do one-center part (m m |m m)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
            T1xx = HFD_a(l,s) + HFD_b(l,s)
      do n = bb1, bb2 
      do m = aa1, aa2 
         if ( n .eq. m ) then 
         if ( s .eq. m ) then 
         if ( l .eq. m ) then 
        
            wint     = int_block(m,n,l,s) 
            T2xx     = wint*T1xx
            T3xx     = wint*HFD_a(n,s)
            T4xx     = wint*HFD_b(n,s)

            F_a(m,n) = F_a(m,n) + T2xx
            F_b(m,n) = F_b(m,n) + T2xx
            F_a(m,l) = F_a(m,l) - T3xx
            F_b(m,l) = F_b(m,l) - T4xx
c
         endif 
         endif 
         endif 
      enddo ! m  
      enddo ! n  
      enddo ! l  
      enddo ! s   
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss7fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
c
c########### CLASS 2  ############
c SS7 
c  Do two-center part (m m |n n)->(n n |m m )
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if ( l .eq. s) then 
            T1xx = HFD_a(l,s) + HFD_b(l,s)
            T4xx = 0.0 
      do n = bb1, bb2 
      do m = aa1, aa2 
         if ( m .eq. n) then 
         if ( m .lt. l) then 
 
             wint     = int_block(m,n,l,s) 
             T3xx     = HFD_a(m,n) + HFD_b(m,n)
             T2xx     = wint*T1xx
             T4xx     = T4xx + wint*T3xx
             T5xx     = wint*HFD_a(n,s)
             T7xx     = wint*HFD_b(n,s)

             F_a(m,n) = F_a(m,n) + T2xx
             F_b(m,n) = F_b(m,n) + T2xx

             F_a(m,l) = F_a(m,l) - T5xx
             F_a(l,m) = F_a(l,m) - T5xx

             F_b(m,l) = F_b(m,l) - T7xx
             F_b(l,m) = F_b(l,m) - T7xx
c
         endif 
         endif 
c
      enddo ! m  
      enddo ! n  
            F_a(l,s) = F_a(l,s) + T4xx
            F_b(l,s) = F_b(l,s) + T4xx
         endif 
      enddo ! l  
      enddo ! s  
c
c########### END CLASS 2  ############
c
      return 
      end 
c
c ---------------------------------------------------------------------------- 

      subroutine form_ss8fock(int_block,n_basis,aa1,aa2,bb1,bb2,cc1,cc2,
     *                      dd1,dd2,HFD_A,HFD_B,F_A,F_B)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s, l  
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision F_A(n_basis,n_basis) 
      double precision F_B(n_basis,n_basis) 
      double precision F1A(n_basis) 
      double precision F1B(n_basis) 
      double precision tempa, tempb, temp_rs, temp_mn   

      double precision wint  
      double precision t1xx
      double precision t2xx
      double precision t3xx
      double precision t4xx
      double precision t5xx
      double precision t6xx
      double precision t7xx
      double precision t8xx
      double precision t9xx
      double precision t10xx
      double precision t11xx
c
c########### CLASS 4  ############
c SS8 
c  Do two-center part (m n |m n)->(m n |n m ),(n m|m n),(n m|n m)
c
      do s = dd1, dd2 
      do l = cc1, cc2 
         if ( l .lt. s ) then 
            T1xx = HFD_a(l,s) + HFD_b(l,s)
      do n = bb1, bb2 
         if ( n .eq. s) then 
            T6xx  = 0.0 
            T7xx  = 0.0 
            T10xx = 0.0 
            T11xx = 0.0 
      do m = aa1, aa2 
         if ( m .lt. n) then 
         if ( m .eq. l) then 
 
             wint     = int_block(m,n,l,s) 
             T2xx     = 2.0*wint*T1xx

             T4xx     = wint*HFD_a(n,s)
             T5xx     = wint*HFD_a(n,l)
             T8xx     = wint*HFD_b(n,s)
             T9xx     = wint*HFD_b(n,l)

             T6xx     = T6xx  + wint*HFD_a(m,s)
             T7xx     = T7xx  + wint*HFD_a(m,l)
             T10xx    = T10xx + wint*HFD_b(m,s)
             T11xx    = T11xx + wint*HFD_b(m,l)
 
             F_a(m,n) = F_a(m,n) + T2xx
             F_b(m,n) = F_b(m,n) + T2xx
             F_a(n,m) = F_a(n,m) + T2xx
             F_b(n,m) = F_b(n,m) + T2xx

             F_a(m,l) = F_a(m,l) - T4xx
             F_a(m,s) = F_a(m,s) - T5xx
             F_b(m,l) = F_b(m,l) - T8xx
             F_b(m,s) = F_b(m,s) - T9xx
c
         endif 
         endif 
      enddo ! m  
            F_a(n,l) = F_a(n,l) - T6xx
            F_a(n,s) = F_a(n,s) - T7xx
            F_b(n,l) = F_b(n,l) - T10xx
            F_b(n,s) = F_b(n,s) - T11xx
         endif 
      enddo ! n  
         endif 
      enddo ! l  
      enddo ! s  
c
c ---------------------------------------------------------------------------- 
c
      return 
      end 

      subroutine form_ss(int_block,m,n,r,s,n_basis,aa1,aa2,bb1,bb2,
     *                   cc1,cc2,dd1,dd2)
      implicit none 
      integer aa1, aa2, bb1, bb2, cc1, cc2, dd1, dd2, n_basis 
      integer a, b, c, d 
      integer m, n, r, s   
      double precision int_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  
      double precision temp_block(aa1:aa2,bb1:bb2,cc1:cc2,dd1:dd2)  

      if ((m .lt. n) .and. (r .lt. s)) then 
         do a = aa1, aa2 
         do b = bb1, bb2 
         do c = cc1, cc2 
         do d = dd1, dd2 
            int_block(b,a,c,d) = int_block(a,b,c,d)  
            int_block(a,b,d,c) = int_block(a,b,c,d)  
            int_block(b,a,d,c) = int_block(a,b,c,d)  
         enddo 
         enddo 
         enddo 
         enddo 
      endif 

      if ((m .lt. n) .and. (r .eq. s)) then 
         do a = aa1, aa2 
         do b = bb1, bb2 
         do c = cc1, cc2 
         do d = dd1, dd2 
            int_block(b,a,c,d) = int_block(a,b,c,d)  
            int_block(a,b,d,c) = int_block(a,b,c,d)  
         enddo 
         enddo 
         enddo 
         enddo 
      endif 

      if ((m .eq. n) .and. (r .lt. s)) then 
         do a = aa1, aa2 
         do b = bb1, bb2 
         do c = cc1, cc2 
         do d = dd1, dd2 
            int_block(a,b,d,c) = int_block(a,b,c,d)  
            int_block(b,a,d,c) = int_block(a,b,c,d)  
         enddo 
         enddo 
         enddo 
         enddo 
      endif 

      return 
      end 

      subroutine hfdensity_copy(HFD_A,HFD_B,HFDOLD_A,HFDOLD_B,n_basis)  
      implicit none 

      integer n_basis, a, b 
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision HFDOLD_A(n_basis,n_basis) 
      double precision HFDOLD_B(n_basis,n_basis) 

      do a = 1, n_basis 
      do b = 1, n_basis 
         HFDOLD_A(b,a) = HFD_A(b,a) 
         HFDOLD_B(b,a) = HFD_B(b,a) 
      enddo 
      enddo 

      return 
      end 


      subroutine check_conv(HFD_A,HFD_B,HFDOLD_A,HFDOLD_B,n_basis,flag)  
      implicit none 

      integer n_basis, a, b, flag  
      double precision HFD_A(n_basis,n_basis) 
      double precision HFD_B(n_basis,n_basis) 
      double precision HFDOLD_A(n_basis,n_basis) 
      double precision HFDOLD_B(n_basis,n_basis) 
      double precision max, diffa, diffb, thresh    

      max = 0.0 
      do a = 1, n_basis 
      do b = 1, n_basis 
         diffa = dabs(HFDOLD_A(b,a) - HFD_A(b,a))  
         diffb = dabs(HFDOLD_B(b,a) - HFD_B(b,a))  
         if (diffa .gt. max) max = diffa 
         if (diffb .gt. max) max = diffb 
      enddo 
      enddo 

      thresh = 1.0d-6 
      flag = 0 
      if (max .lt. thresh) flag = 1 
c      write(6,*) '      Max density difference :', max 

c     if (flag .eq. 0) then 
c        do a = 1, n_basis 
c        do b = 1, n_basis 
c           HFDOLD_A(b,a) = HFD_A(b,a) 
c           HFDOLD_B(b,a) = HFD_B(b,a) 
c        enddo 
c        enddo 
c     endif 

      return 
      end 

      subroutine do_diis(nhist_old,navirt,naocc,nbvirt,nbocc,norb,
     *                   Fai,Ea,Fbj,Eb,FA,FB) 

      Implicit none 
      integer nhist, nhist_old, norb, navirt, naocc, nbvirt, nbocc 
      double precision CM(nhist_old+1),BM(nhist_old+1,nhist_old+1) 
      double precision R(nhist_old+1,nhist_old+1) 
      double precision Fai(navirt,naocc,nhist_old+1), 
     *                 Ea(norb,norb,nhist_old+1)  
      double precision Fbj(nbvirt,nbocc,nhist_old+1), 
     *                 Eb(norb,norb,nhist_old+1)  
      double precision FA(norb,norb), FB(norb,norb) 
      double precision itemp, jtemp, atemp, btemp 
      double precision rpack(nhist_old*nhist_old+2*nhist_old+1) 
      integer iP(nhist_old+1) 
      integer m, n, a, i, b, j, k, npack  

c---------------------------------------------------------------------------
c Zero out B and C matrices 
c---------------------------------------------------------------------------

      nhist = nhist_old ! - 1  

      do n = 1, nhist+1  
         CM(n) = 0.0 
         do m = 1, nhist+1  
            BM(m,n)  = 0.0 
         enddo ! m 
      enddo ! n  

c---------------------------------------------------------------------------
c Form the B matrix 
c---------------------------------------------------------------------------

c     alpha-spin 
      do n = 1, nhist 
         do m = 1, nhist   

            btemp = 0.0 

            do i = 1, naocc 
            do a = 1, navirt 

               btemp = btemp + Fai(a,i,m)*Fai(a,i,n)  

            enddo ! a 
            enddo ! i 

            BM(m,n) = btemp 

          enddo ! m 
      enddo ! n 

c     beta-spin 
      do n = 1, nhist 
         do m = 1, nhist   

            btemp = 0.0 

            do j = 1, nbocc 
            do b = 1, nbvirt 

               btemp = btemp + Fbj(b,j,m)*Fbj(b,j,n)  

            enddo ! b 
            enddo ! j 

            BM(m,n) = BM(m,n) + btemp 

          enddo ! m 
       enddo ! n 

c---------------------------------------------------------------------------
c Done forming the B matrix 
c---------------------------------------------------------------------------

      do n = 1, nhist 
      do m = n, nhist   
         R(n,m) = BM(n,m) 
         if (m .ne. n) R(m,n) = BM(n,m) 
      enddo 
      enddo 
    
      do m = 1, nhist 
         R(m,nhist+1) = -1.0 
         R(nhist+1,m) = -1.0 
      enddo 
      R(nhist+1,nhist+1) = 0.0 

c     write(6,*) ' R vector ' 
c     do m = 1, nhist + 1  
c     do n = 1, nhist + 1 
c        write(6,*) '  ', m, n, R(m,n) 
c     enddo 
c     enddo 

      npack = 0 
      do n = 1, nhist+1  
      do m = 1, nhist+1  
         npack = npack + 1 
         Rpack(npack) = R(m,n) 
      enddo 
      enddo 

      do m = 1, nhist  
         CM(m) = 0.0 
      enddo 
      CM(nhist+1) = -1.0 

      call dgesv(nhist+1,1,Rpack,nhist+1,iP,CM,nhist+1,i) 
      if (i .ne. 0) then 
         write(6,*) ' Error in atom DIIS ', i
         call abort_job() 
      endif 

c     write(6,*) ' C vector ', nhist + 1  
c     do m = 1, nhist+1 
c        write(6,*) '  ', m,  CM(M) 
c     enddo 

      CM(nhist+1) = 0.0 

c---------------------------------------------------------------------------
c Form the updated Fock matrix   
c---------------------------------------------------------------------------

      nhist = nhist_old 

c     write(6,*) ' Updating F ' 
      do n = 1, norb  
      do m = 1, norb  
         itemp = 0.0 
         do k = 1, nhist  
             itemp = itemp + Ea(m,n,k)*CM(k)  
         enddo ! k  
         FA(m,n) = itemp 
      enddo ! m 
      enddo ! n 

c     write(6,*) ' Updating F ' 
      do m = 1, norb  
      do n = 1, norb  
         jtemp = 0.0 
         do k = 1, nhist  
             jtemp = jtemp + Eb(m,n,k)*CM(k)  
         enddo ! k  
         FB(m,n) = jtemp 
      enddo ! m 
      enddo ! n 

c     write(6,*) ' Finished DIIS of order', nhist 

      return 
      end 

c       call gen_hist(iter,maxhist,diis_start,n_basis,nvirt_a,
c    *                nocc_a,nvirt_b,nocc_b,ca,cb,FA,FB,Fai,Fbj,Ea,Eb)
      subroutine gen_hist(kiter,maxhist,diis_start,norb,navirt,naocc,
     *                    nbvirt,nbocc,ca,cb,Fpq_a,Fpq_b,Fai,Fbj,Ea,Eb)

      Implicit none 
      integer kiter, maxhist,diis_start,norb,navirt,naocc,nbvirt,nbocc
      integer m, n, a, i, b, j 
      Double precision Fpq_a(norb,norb), Fpq_b(norb,norb) 
      double precision ca(norb,norb), cb(norb,norb) 
      double precision Fai(navirt,naocc,maxhist+1) 
      double precision FTai(navirt,naocc) 
      double precision FTbj(nbvirt,nbocc) 
      double precision Fbj(nbvirt,nbocc,maxhist+1) 
      double precision Ea(norb,norb,maxhist+1) 
      double precision Eb(norb,norb,maxhist+1) 
      double precision Ti(norb,naocc), Tj(norb,nbocc)  
      double precision itemp, jtemp  

c---------------------------------------------------------------------------
c Form Fai and Fbj 
c---------------------------------------------------------------------------

      do m = 1, norb 
      do i = 1, naocc 
         itemp= 0.0 
         do n = 1, norb 
            itemp = itemp + Fpq_a(m,n)*ca(n,i) 
         enddo  
         Ti(m,i) = itemp 
      enddo  
      enddo  

      do a = naocc+1, norb  
      do i = 1, naocc 
         itemp = 0.0 
         do m = 1, norb 
            itemp = itemp + Ti(m,i)*ca(m,a)  
         enddo 
         FTai(a-naocc,i) = itemp 
      enddo 
      enddo 

      do m = 1, norb 
      do j = 1, nbocc 
         jtemp= 0.0 
         do n = 1, norb 
            jtemp = jtemp + Fpq_b(m,n)*cb(n,j) 
         enddo  
         Tj(m,j) = jtemp 
      enddo  
      enddo  

      do b = nbocc+1, norb  
      do j = 1, nbocc 
         jtemp = 0.0 
         do m = 1, norb 
            jtemp = jtemp + Tj(m,j)*cb(m,b)  
         enddo 
         FTbj(b-nbocc,j) = jtemp 
      enddo 
      enddo 

c---------------------------------------------------------------------------
c Done Forming Fai and Fbj 
c---------------------------------------------------------------------------

c---------------------------------------------------------------------------
c Store Fock matrix history  
c---------------------------------------------------------------------------

      if ((kiter .ge. diis_start) .and. 
     *    (kiter .lt. maxhist+diis_start-1)) then 

            do n = 1, norb 
            do m = 1, norb 
               Ea(m,n,kiter-(diis_start-1)) = Fpq_a(m,n) 
               Eb(m,n,kiter-(diis_start-1)) = Fpq_b(m,n) 
            enddo 
            enddo 
           
            do i = 1, naocc 
            do a = 1, navirt   
               Fai(a,i,kiter-(diis_start-1)) = FTai(a,i) 
c              write(6,*) ' XXXXX', a, i, kiter-2, Fai(a,i,kiter-2)
            enddo 
            enddo 
           
            do j = 1, nbocc 
            do b = 1, nbvirt  
               Fbj(b,j,kiter-(diis_start-1)) = FTbj(b,j) 
            enddo 
            enddo 

      endif 

      if (kiter .ge. maxhist+diis_start-1) then 

            do n = 1, norb 
            do m = 1, norb 
               Ea(m,n,maxhist) = Fpq_a(m,n) 
               Eb(m,n,maxhist) = Fpq_b(m,n) 
            enddo 
            enddo 
           
            do i = 1, naocc 
            do a = 1, navirt  
               Fai(a,i,maxhist) = FTai(a,i) 
            enddo 
            enddo 
           
            do j = 1, nbocc 
            do b = 1, nbvirt 
               Fbj(b,j,maxhist) = FTbj(b,j) 
            enddo 
            enddo 

      endif 

      return 
      end 

      subroutine move_hist(nhist,diis_start,norb,Fa,Fb,Ea,Eb) 
      Implicit none 
      integer norb, nhist, diis_start, m, n, k 
      Double precision Ea(norb,norb,nhist), Eb(norb,norb,nhist) 
      Double precision Fa(norb,norb), Fb(norb,norb) 

c Shift histories 

      do k = 2, nhist 
         do n = 1, norb 
         do m = 1, norb 
            Ea(m,n,k-1) = Ea(m,n,k) 
            Eb(m,n,k-1) = Eb(m,n,k) 
         enddo 
         enddo 
      enddo 

c Current Fock 

      do n = 1, norb 
      do m = 1, norb 
         Ea(m,n,nhist) = Fa(m,n) 
         Eb(m,n,nhist) = Fb(m,n) 
      enddo 
      enddo 

      return 
      end 

      function ncindex(str,c,ind)
      implicit none
      integer ncindex
      character*(*) str
      character*1 c
      integer ind,strlen,i,slen
      ncindex=0
      if (ind.lt.0) return
      slen=strlen(str)
      i=ind+1
      do while (.true.)
         if (i.gt.slen) return
         if (str(i:i).eq.c) then
            ncindex=i
            return
         end if
         i=i+1
      end do
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_NLO_ORBITALS
     +
     +                    ( IMAX,ZMAX,
     +                      MEMORY,
     +                      NBAS,NATOM,
     +                      MXSHELL,MXNAL,
     +                      BONDSIZE,RYD2HYB,
     +                      NSHELLS,SHELLS,NBASAL,
     +                      ZATOM,XYZCOOR,
     +                      ALPHA,BETA,
     +                      DENSITY,OVERLAP,
     +                      MJUMP,
     +                      SPHERIC,
     +                      SYMMETRY,
     +                      ONLYNAO,ONLYNHO,ONLYNBO,ONLYNLMO,
     +                      MXCHOOSE,NCHOOSE,CHOOSE,
     +                      ICORE,ZCORE,
     +
     +                              BDSIZE,
     +                              BDATOM,
     +                              COEFFS )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_NLO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : Master routine for finding natural localized orbitals
C                within a molecular environment using the first order
C                density matrix and the overlap matrix.
C
C                The density matrix can be of pure spin alpha or beta
C                in case of UHF functions or of mixed spin in case of
C                RHF functions. To determine the separate alpha and
C                beta natural localized orbitals simply run the routine
C                twice with the corresponding alpha and beta first order
C                density matrix.
C
C
C                  Input:
C
C                    IMAX,ZMAX    =  maximum integer + flp memory
C                    MEMORY       =  if true, the code will determine
C                                    just the maximum amount of memory
C                                    needed. Nothing else will be done.
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    MXSHELL      =  largest l-shell value
C                    MXNAL        =  maximum size of atomic l-shell
C                                    space. The atomic l-shell space
C                                    is the total # of contractions for
C                                    an atomic l-shell.
C                    BONDSIZE     =  maximum # of atomic centers that
C                                    are allowed to form a bond.
C                    RYD2HYB      =  is true, if the Rydberg NAO space
C                                    should be included next to the
C                                    Valence NAO space for natural 
C                                    hybrid orbital (NHO) construction.
C                                    If false, only the Valence NAO
C                                    space will be used.
C                    NSHELLS (A)  =  # of l-shells for atom A.
C                    SHELLS (I,A) =  I-th l-shell type (s=0,p=1,etc...)
C                                    for atom A (in increasing order!).
C                    NBASAL (I,A) =  size of I-th atomic l-shell space
C                                    for atom A.
C                    ZATOM (A)    =  atomic number for atom A.
C                    XYZCOOR      =  x,y,z-coordinates for all the
C                                    atoms in 3 x NATOM matrix format.
C                    ALPHA        =  if true, the input AO density
C                                    matrix contains the alpha spin
C                                    electron density.
C                    BETA         =  if true, the input AO density
C                                    matrix contains the beta spin
C                                    electron density.
C                    DENSITY      =  full NBAS x NBAS matrix containing
C                                    the expansion coeffs of the density
C                                    in terms of products of the AO
C                                    basis functions. Can contain the
C                                    alpha and/or the beta spin electron
C                                    density (example UHF or RHF), which
C                                    is controlled by the keywords
C                                    ALPHA and BETA. Note that when
C                                    both these keywords are passed as
C                                    false, the routine stops with a
C                                    message.
C                    OVERLAP      =  full NBAS x NBAS overlap matrix.
C                    MJUMP        =  is .true., if the m values in the
C                                    m-space are ordered such that the
C                                    same m values are separated. This
C                                    keyword is necessary because some
C                                    AO basis functions are m-ordered
C                                    differently within each l-shell.
C                    SPHERIC      =  is true, if the l-shells are
C                                    spherical, false if they are
C                                    cartesian.
C                    SYMMETRY     =  if true, the code will attempt
C                                    the production of rotationally
C                                    invariant NBOs and NLMOs.
C                    ONLYx        =  is true, if only x=NAO,NHO,NBO or
C                                    NLMO orbitals are wanted. Note,
C                                    that if any of the ONLYx is true,
C                                    then all those ONLYx preceeding
C                                    that particular ONLYx are forced
C                                    to be false.
C                    MXCHOOSE     =  maximum # of bonds selected to
C                                    be chosen. The maximum is build
C                                    from all # of chosen bonds for all
C                                    bondsizes.
C                    NCHOOSE (B)  =  # of bonds to be chosen for bonds
C                                    of size B. Four cases:
C                                    1) = 9999 => skip search for bonds
C                                       of size B.
C                                    2) = 0 => complete search for all
C                                       possible bonds of size B will
C                                       be performed.
C                                    3) = -n => only n bonds of size B
C                                       will be searched between those
C                                       atomic indices as provided by
C                                       the CHOOSE array.
C                                    4) = +n => same as case 3) but
C                                       followed by a complete search
C                                       for all possible remaining
C                                       bonds of size B.
C                                    Priority level: 1) > 3) > 4) > 2).
C                    CHOOSE       =  element CHOOSE (I,N,B) contains
C                                    the I-th atomic index of the N-th
C                                    chosen bond of size B. The order
C                                    of the atomic indices is arbitrary.
C                    ICORE,ZCORE  =  integer/flp scratch space
C
C
C                  Output:
C
C                    BDSIZE (I)   =  Natural localized orbital bond
C                                    sizes. Indicates the # of atoms
C                                    which form the I-th natural
C                                    localized orbital. 
C                    BDATOM (I,J) =  Atomic index map for the natural
C                                    localized orbitals. J-th atomic
C                                    index forming the I-th natural
C                                    localized orbital.
C                    COEFFS (I,J) =  Natural localized orbitals
C                                    coefficient matrix in AO basis.
C                                    I-th AO coefficient in the J-th
C                                    natural localized orbital.
C                                    
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ALPHA,BETA
         LOGICAL     CYCLERYD,CYCLESYM
         LOGICAL     MEMORY
         LOGICAL     MJUMP
         LOGICAL     ONLYNAO,ONLYNHO,ONLYNBO,ONLYNLMO
         LOGICAL     PLATONIC
         LOGICAL     RYD2HYB
         LOGICAL     SETWPRE
         LOGICAL     SPHERIC
         LOGICAL     SYMMETRY

         INTEGER     BONDSIZE,NBOSIZE,ROTSIZE
         INTEGER     GPOINT
         INTEGER     IMAX,ZMAX
         INTEGER     MXCHOOSE
         INTEGER     MXNCBA,MXNVBA,MXNRBA,MXNHBA,MXNBA,MXCOL
         INTEGER     MXSHELL,MXLSIZE,MXNAL,MX2CEN
         INTEGER     NBAS,NATOM,NBOND
         INTEGER     NCA,NVA,NRA,NHA,NLA,NEA,NYA
         INTEGER     NCYCLE
         INTEGER     NOCC
         INTEGER     NMB,NCB,NVB,NRB,NHB,NLB,NBB,NEB,NAB,NYB
         INTEGER     NTETRA,NCUBE,NOCTA,NDODECA,NICOSA
         INTEGER     UNITID,UNITDB

         INTEGER     IAT2CEN,ICOLMAP,INRYDAL,ILSIZE,INAOTYP,ICSHELL,
     +               IVSHELL,IRSHELL,IHSHELL,IATNCB,IATCIDX,IATCOFF,
     +               IATNVB,IATVIDX,IATVOFF,IATNRB,IATRIDX,IATROFF,
     +               IATNLB,IATLIDX,IATLOFF,IATNEB,IATEIDX,IATEOFF,
     +               IATNYB,IATYIDX,IATYOFF,IATNHB,IATHVAL,IATHIDX,
     +               IATHOFF,IATHCEN,IATORD,ILOCMAP,IVALIDX,IRYDIDX,
     +               INHYB,IBDNCEN,IBDCEN,IBDNBAS,IBDBAS,IBDOCC,INBOBD,
     +               INWSTEP,ISYMNBO,IRING,INRING,IRINGSZ,
     +               IPLATO,IBASBEG,IBASEND,ISYMMAP,ISYMCEN,ISLTYPE,
     +               IANGSYM,IWORK1,IWORK2,IWORK3,IWORK4,ITOP

         INTEGER     ZB,ZH,ZQ,ZW,
     +               ZPA,ZPH,
     +               ZCAL,ZSAL,ZWAL,ZSAH,ZHYB,ZROT,
     +               ZWPRE,ZWNAO,ZTSYM,
     +               ZDOMAT,ZSOMAT,ZBOMAT,ZWBOND,ZWSTAR,ZLOCAL,
     +               ZPHSUB,ZPHDEP,
     +               ZPOPCOR,ZPOPVAL,ZPOPRYD,ZPOPSUM,ZDENORM,
     +               ZANGNHO,ZANGNBO,ZWRYDAT,
     +               ZWORK1,ZWORK2,ZWORK3,ZWORK4,ZWORK5,
     +               ZTOP

         INTEGER     BDSIZE  (1:NBAS)
         INTEGER     ICORE   (1:IMAX)
         INTEGER     NCHOOSE (1:BONDSIZE)
         INTEGER     NSHELLS (1:NATOM)
         INTEGER     ZATOM   (1:NATOM)

         INTEGER     BDATOM  (1:NBAS     ,1:BONDSIZE)
         INTEGER     NBASAL  (1:MXSHELL+1,1:NATOM   )
         INTEGER     SHELLS  (1:MXSHELL+1,1:NATOM   )

         INTEGER     CHOOSE  (1:BONDSIZE,1:MXCHOOSE,1:BONDSIZE)

         DOUBLE PRECISION     DSYMACC,LSYMACC,PSYMACC,QSYMACC
         DOUBLE PRECISION     MAXOCC
         DOUBLE PRECISION     NO2CEN
         DOUBLE PRECISION     ONE
         DOUBLE PRECISION     WBDMIN,WSTMAX,WBDCRT,WSTEP
         DOUBLE PRECISION     WPRERYD,WNAOVAL,WNAORYD,WNBOOCC

         DOUBLE PRECISION     ZCORE   (1:ZMAX)

         DOUBLE PRECISION     COEFFS  (1:NBAS,1:NBAS )
         DOUBLE PRECISION     DENSITY (1:NBAS,1:NBAS )
         DOUBLE PRECISION     OVERLAP (1:NBAS,1:NBAS )
         DOUBLE PRECISION     XYZCOOR (1:3   ,1:NATOM)

         PARAMETER  (ONE     = 1.D0)
         PARAMETER  (ROTSIZE = 3   )
C
C
C------------------------------------------------------------------------
C
C
C             ...open general printout file and diagnostic/debug file.
C
C
         IF (ALPHA.AND.BETA) THEN
             IF (.NOT.MEMORY) THEN
                 CALL  NLO__OPEN_FILES
     +
     +                      ( 'NLO-results-printout',
     +                        'NLO-diagnostic-debug',
     +
     +                                   UNITID,
     +                                   UNITDB )
     +
     +
             END IF
         ELSE IF (ALPHA) THEN
             IF (.NOT.MEMORY) THEN
                 CALL  NLO__OPEN_FILES
     +
     +                      ( 'NLO-results-printout-alpha',
     +                        'NLO-diagnostic-debug-alpha',
     +
     +                                   UNITID,
     +                                   UNITDB )
     +
     +
             END IF
         ELSE IF (BETA) THEN
             IF (.NOT.MEMORY) THEN
                 CALL  NLO__OPEN_FILES
     +
     +                      ( 'NLO-results-printout-beta',
     +                        'NLO-diagnostic-debug-beta',
     +
     +                                   UNITID,
     +                                   UNITDB )
     +
     +
             END IF
         ELSE
             WRITE (*,*) ' ALPHA and BETA set to false! '
             WRITE (*,*) ' Unable to proceed! '
             WRITE (*,*) ' nlo__gener_nlo_orbitals '
             STOP
         END IF
C
C
C             ...preliminary steps.
C
C
         IF (ONLYNLMO) THEN
             ONLYNAO = .FALSE.
             ONLYNHO = .FALSE.
             ONLYNBO = .FALSE.
         END IF

         IF (ONLYNBO) THEN
             ONLYNAO = .FALSE.
             ONLYNHO = .FALSE.
         END IF

         IF (ONLYNHO) THEN
             ONLYNAO = .FALSE.
         END IF

         IF (ALPHA.AND.BETA) THEN
             MAXOCC = ONE + ONE
         ELSE
             MAXOCC = ONE
         END IF

         MX2CEN  = NATOM * (NATOM + 1) / 2

         IBASBEG = 1
         IBASEND = IBASBEG + NATOM
         IATORD  = IBASEND + NATOM
         ILSIZE  = IATORD  + NATOM
         INRING  = ILSIZE  + (MXSHELL + 1)
         IRINGSZ = INRING  + NATOM
         IRING   = IRINGSZ + NATOM
         IPLATO  = IRING   + NATOM * NATOM
         ISYMMAP = IPLATO  + NATOM * 5
         IAT2CEN = ISYMMAP + NATOM * NATOM
         IWORK1  = IAT2CEN + 2*MX2CEN
         ITOP    = IWORK1  + MAX (NBAS,NATOM,MX2CEN)

         ZDENORM = 1
         ZDOMAT  = ZDENORM + NBAS
         ZSOMAT  = ZDOMAT  + NATOM * NATOM
         ZBOMAT  = ZSOMAT  + NATOM * NATOM
         ZLOCAL  = ZBOMAT  + NATOM * NATOM
         ZWORK1  = ZLOCAL  + NATOM * NBAS
         ZWORK2  = ZWORK1  + NBAS
         ZTOP    = ZWORK2  + NBAS * NBAS

         IF (MEMORY) THEN
             IMAX = ITOP
             ZMAX = ZTOP
         ELSE
             CALL  NLO__NORMALIZE_OVERLAP_DENSITY
     +
     +                  ( NBAS,
     +                    ZCORE (ZWORK1),
     +                    ICORE (IWORK1),
     +
     +                              ZCORE (ZDENORM),
     +                              DENSITY,OVERLAP )
     +
     +
             CALL  NLO__INITIALIZE_RUN
     +
     +                  ( NBAS,NATOM,
     +                    MXSHELL,
     +                    MAXOCC,BONDSIZE,
     +                    NSHELLS,SHELLS,NBASAL,
     +                    SPHERIC,
     +                    MXCHOOSE,NCHOOSE,CHOOSE,
     +                    ICORE (IWORK1),
     +                    XYZCOOR,ZATOM,
     +                    OVERLAP,
     +                    ZCORE (ZWORK1),
     +                    ZCORE (ZWORK2),
     +
     +                              NO2CEN,
     +                              WPRERYD,WNAOVAL,WNAORYD,WNBOOCC,
     +                              WBDMIN,WSTMAX,WBDCRT,WSTEP,
     +                              DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                              MXNBA,MXLSIZE,
     +                              ICORE (ILSIZE),
     +                              ICORE (IBASBEG),
     +                              ICORE (IBASEND),
     +                              ICORE (ISYMMAP),
     +                              BDATOM,
     +                              GPOINT,
     +                              ZCORE (ZDOMAT),
     +                              ZCORE (ZSOMAT),
     +                              ZCORE (ZBOMAT),
     +                              PLATONIC,
     +                              DENSITY )
     +
     +
             CALL  NLO__PRINT_MOLECULE_INFO
     +
     +                  ( UNITID,
     +                    NATOM,
     +                    XYZCOOR,ZATOM,
     +                    GPOINT,
     +                    ZCORE (ZDOMAT),
     +                    ZCORE (ZSOMAT),
     +                    ZCORE (ZBOMAT) )
     +
     +
             CALL  NLO__ANALYZE_BOND_ORDER_MATRIX
     +
     +                  ( NATOM,
     +                    MX2CEN,
     +                    ICORE (IAT2CEN),
     +                    NO2CEN,
     +                    ICORE (IWORK1),
     +                    ZCORE (ZWORK1),
     +
     +                              ICORE (IATORD),
     +                              ZCORE (ZBOMAT) )
     +
     +
         END IF
C
C
C             ...the NAO generation section follows.
C
C
         IANGSYM = ISYMMAP + NATOM * NATOM
         ICOLMAP = IANGSYM + NBAS
         INRYDAL = ICOLMAP + NBAS
         INAOTYP = INRYDAL + NATOM * (MXSHELL + 1)
         ICSHELL = INAOTYP + NBAS
         IVSHELL = ICSHELL + NBAS
         IRSHELL = IVSHELL + NBAS
         IATNCB  = IRSHELL + NBAS
         IATCIDX = IATNCB  + NATOM
         IATCOFF = IATCIDX + NATOM
         IATNVB  = IATCOFF + NATOM
         IATVIDX = IATNVB  + NATOM
         IATVOFF = IATVIDX + NATOM
         IATNRB  = IATVOFF + NATOM
         IATRIDX = IATNRB  + NATOM
         IATROFF = IATRIDX + NATOM
         IWORK1  = IATROFF + NATOM
         IWORK2  = IWORK1  + NATOM
         IWORK3  = IWORK2  + NATOM
         ITOP    = IWORK3  + NBAS + NBAS

         ZWRYDAT = ZLOCAL  + NATOM * NBAS
         ZWNAO   = ZWRYDAT + NATOM
         ZWPRE   = ZWNAO   + NBAS
         ZSAL    = ZWPRE   + NBAS
         ZCAL    = ZSAL    + MXNAL * MXNAL
         ZWAL    = ZCAL    + MXNAL * MXNAL
         ZTSYM   = ZWAL    + MXNAL
         ZPA     = ZTSYM   + MXLSIZE * MXLSIZE
         ZPOPCOR = ZPA     + MXNBA * MXNBA
         ZPOPVAL = ZPOPCOR + NATOM
         ZPOPRYD = ZPOPVAL + NATOM
         ZPOPSUM = ZPOPRYD + NATOM
         ZWORK1  = ZPOPSUM + NATOM
         ZWORK2  = ZWORK1  + NBAS + NBAS
         ZTOP    = ZWORK2  + NBAS * NBAS

         IF (MEMORY) THEN
             IMAX = MAX (IMAX,ITOP)
             ZMAX = MAX (ZMAX,ZTOP)
         ELSE
             NCYCLE = 0
             SETWPRE = .TRUE.

 1000        NCYCLE = NCYCLE + 1
             WRITE (*,*) ' pre-NAO/NAO cycle # ',NCYCLE

             CALL  NLO__GENER_PRE_NAO_ORBITALS
     +
     +                  ( NBAS,NATOM,
     +                    MXSHELL,MXNAL,
     +                    NSHELLS,SHELLS,NBASAL,
     +                    ICORE (ILSIZE),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    ICORE (ISYMMAP),
     +                    ICORE (IWORK1),
     +                    ICORE (IWORK2),
     +                    DENSITY,OVERLAP,
     +                    ZCORE (ZSAL),
     +                    ZCORE (ZCAL),
     +                    ZCORE (ZWAL),
     +                    SETWPRE,
     +                    WPRERYD,
     +                    ZCORE (ZWRYDAT),
     +                    MJUMP,
     +
     +                             NMB,NRB,
     +                             ICORE (ICOLMAP),
     +                             ICORE (INRYDAL),
     +                             ZCORE (ZWPRE),
     +                             COEFFS )
     +
     +
             CALL  NLO__GENER_NAO_ORBITALS
     +
     +                  ( NBAS,NATOM,
     +                    MXSHELL,MXLSIZE,MXNAL,MXNBA,
     +                    NSHELLS,SHELLS,NBASAL,
     +                    DENSITY,
     +                    ZCORE (ZPA),
     +                    OVERLAP,
     +                    ZCORE (ZSAL),
     +                    ZCORE (ZCAL),
     +                    ZCORE (ZWAL),
     +                    ZCORE (ZTSYM),
     +                    MJUMP,
     +                    NMB,NRB,
     +                    ICORE (ILSIZE),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    PSYMACC,
     +                    ICORE (ISYMMAP),
     +                    ICORE (IWORK1),
     +                    ICORE (IWORK2),
     +                    ICORE (ICOLMAP),
     +                    ICORE (INRYDAL),
     +                    ICORE (IWORK3),
     +                    ZCORE (ZWORK1),
     +                    ZCORE (ZWORK2),
     +                    ZCORE (ZWPRE),
     +
     +                             BDSIZE,
     +                             BDATOM (1,1),
     +                             ICORE (IANGSYM),
     +                             ZCORE (ZWNAO),
     +                             COEFFS )
     +
     +
             CALL  NLO__ANALYZE_NAO_ORBITALS
     +
     +                  ( NBAS,NATOM,
     +                    MXSHELL,MXNAL,
     +                    MAXOCC,
     +                    NSHELLS,SHELLS,NBASAL,
     +                    ZATOM,
     +                    NMB,
     +                    ICORE (ILSIZE),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    PSYMACC,
     +                    WNAOVAL,WNAORYD,
     +                    ZCORE (ZWPRE),
     +                    ZCORE (ZWNAO),
     +                    ZCORE (ZWORK1),
     +
     +                             NCB,NVB,NRB,
     +                             ZCORE (ZWRYDAT),
     +                             ZCORE (ZPOPCOR),
     +                             ZCORE (ZPOPVAL),
     +                             ZCORE (ZPOPRYD),
     +                             ZCORE (ZPOPSUM),
     +                             ICORE (INAOTYP),
     +                             ICORE (ICOLMAP),
     +                             ICORE (ISYMMAP),
     +                             ICORE (ICSHELL),
     +                             ICORE (IVSHELL),
     +                             ICORE (IRSHELL),
     +                             NCA,
     +                             MXNCBA,
     +                             ICORE (IATNCB),
     +                             ICORE (IATCIDX),
     +                             ICORE (IATCOFF),
     +                             NVA,
     +                             MXNVBA,
     +                             ICORE (IATNVB),
     +                             ICORE (IATVIDX),
     +                             ICORE (IATVOFF),
     +                             NRA,
     +                             MXNRBA,
     +                             ICORE (IATNRB),
     +                             ICORE (IATRIDX),
     +                             ICORE (IATROFF),
     +                             CYCLERYD,
     +                             CYCLESYM )
     +
     +
             SETWPRE = CYCLESYM
             IF (CYCLERYD .OR. CYCLESYM) GOTO 1000

         END IF
C
C
C             ...symmetry analysis based on the final NAOs obtained.
C
C
         IWORK1  = IATROFF + NATOM
         IWORK2  = IWORK1  + NATOM
         IWORK3  = IWORK2  + NATOM
         IWORK4  = IWORK3  + NATOM
         ITOP    = IWORK4  + NATOM

         ZWORK1  = ZPOPSUM + NATOM
         ZWORK2  = ZWORK1  + NATOM
         ZWORK3  = ZWORK2  + NATOM
         ZWORK4  = ZWORK3  + NATOM
         ZWORK5  = ZWORK4  + NATOM
         ZTOP    = ZWORK5  + NATOM

         IF (MEMORY) THEN
             IMAX = MAX (IMAX,ITOP)
             ZMAX = MAX (ZMAX,ZTOP)
         ELSE
             CALL  NLO__SYMMETRY_RELATED_CENTERS
     +
     +                  ( NATOM,
     +                    ICORE (IWORK1),
     +                    ICORE (IWORK2),
     +                    ICORE (IWORK3),
     +                    ICORE (ISYMMAP),
     +                    ZCORE (ZDOMAT),
     +                    DSYMACC,
     +                    XYZCOOR,
     +                    ICORE (IWORK4),
     +                    ZCORE (ZWORK1),
     +                    ZCORE (ZWORK2),
     +                    ZCORE (ZWORK3),
     +                    ZCORE (ZWORK4),
     +                    ZCORE (ZWORK5),
     +
     +                             PLATONIC,
     +                             ICORE (IRING),
     +                             ICORE (INRING),
     +                             ICORE (IRINGSZ),
     +                             NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                             ICORE (IPLATO) )
     +
     +
             CALL  NLO__PRINT_SYMMETRY_INFO
     +
     +                  ( UNITID,
     +                    NATOM,
     +                    ZATOM,
     +                    ICORE (ISYMMAP),
     +                    ICORE (IRING),
     +                    ICORE (INRING),
     +                    ICORE (IRINGSZ),
     +                    ICORE (IPLATO) )
     +
     +
         END IF
C
C
C             ...generate the square root of the overlap matrix
C                needed for NAO,NBO and NLMO locality analysis.
C                The overlap matrix is not needed any more and
C                is thus overwritten by its square root.
C
C
         ZWORK1  = ZPOPSUM + NATOM
         ZWORK2  = ZWORK1  + NBAS
         ZTOP    = ZWORK2  + NBAS * NBAS

         IF (MEMORY) THEN
             ZMAX = MAX (ZMAX,ZTOP)
             IF (ONLYNAO) THEN
                 RETURN
             END IF
         ELSE
             CALL  NLO__GENER_SQROOT_OVERLAP
     +
     +                  ( NBAS,
     +                    ZCORE (ZWORK1),
     +                    ZCORE (ZWORK2),
     +
     +                             OVERLAP )
     +
     +
             CALL  NLO__DETERMINE_ORBITAL_LOCALITY
     +
     +                  ( NBAS,NATOM,
     +                    ICORE (IWORK1),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    COEFFS,
     +                    OVERLAP,
     +
     +                             ZCORE (ZLOCAL) )
     +
     +
             CALL  NLO__PRINT_NAO_RESULTS
     +
     +                  ( UNITID,
     +                    NBAS,NATOM,
     +                    MXSHELL,
     +                    NSHELLS,SHELLS,NBASAL,
     +                    ZATOM,
     +                    ICORE (ILSIZE),
     +                    ZCORE (ZPOPCOR),
     +                    ZCORE (ZPOPVAL),
     +                    ZCORE (ZPOPRYD),
     +                    ZCORE (ZPOPSUM),
     +                    ICORE (INAOTYP),
     +                    ICORE (IANGSYM),
     +                    ZCORE (ZLOCAL),
     +                    ZCORE (ZWNAO) )
     +
     +
             IF (ONLYNAO) THEN
                 CALL  NLO__DENORMALIZE_COEFF_MATRIX
     +
     +                      ( NBAS,
     +                        ZCORE (ZDENORM),
     +
     +                                 COEFFS )
     +
     +
                 RETURN
             END IF

         END IF
C
C
C             ...enter the NHO generation.
C
C
         IHSHELL = IATROFF + NATOM
         IATNHB  = IHSHELL + NBAS
         IATHVAL = IATNHB  + NATOM
         IATHIDX = IATHVAL + NATOM
         IATHOFF = IATHIDX + NATOM
         ILOCMAP = IATHOFF + NATOM
         IVALIDX = ILOCMAP + NBAS
         IRYDIDX = IVALIDX + NATOM
         IWORK1  = IRYDIDX + NATOM
         ITOP    = IWORK1  + NBAS

         IF (MEMORY) THEN
             IMAX = MAX (IMAX,ITOP)
         ELSE
             CALL  NLO__CHARACTERIZE_NHO_SPACE
     +
     +                  ( NBAS,NATOM,
     +                    NVB,NVA,
     +                    MXNVBA,
     +                    ICORE (IVSHELL),
     +                    ICORE (IATNVB),
     +                    ICORE (IATVIDX),
     +                    ICORE (IATVOFF),
     +                    RYD2HYB,
     +                    ICORE (ILOCMAP),
     +                    ICORE (IVALIDX),
     +                    ICORE (IRYDIDX),
     +                    ICORE (IWORK1),
     +
     +                             ICORE (IATORD),
     +                             NHB,NCB,NRB,
     +                             ICORE (ICOLMAP),
     +                             ICORE (IHSHELL),
     +                             ICORE (ICSHELL),
     +                             ICORE (IRSHELL),
     +                             NHA,
     +                             MXNHBA,
     +                             ICORE (IATNHB),
     +                             ICORE (IATHVAL),
     +                             ICORE (IATHIDX),
     +                             ICORE (IATHOFF),
     +                             NCA,
     +                             MXNCBA,
     +                             ICORE (IATNCB),
     +                             ICORE (IATCIDX),
     +                             ICORE (IATCOFF),
     +                             NRA,
     +                             MXNRBA,
     +                             ICORE (IATNRB),
     +                             ICORE (IATRIDX),
     +                             ICORE (IATROFF),
     +                             MXNBA,MXCOL )
     +
     +
         END IF

         IF (SYMMETRY) THEN
             NBOSIZE = MAX (BONDSIZE,ROTSIZE)
         ELSE
             NBOSIZE = BONDSIZE
         END IF

         IATHCEN = IATHOFF + NATOM
         INHYB   = IATHCEN + NATOM
         ISLTYPE = INHYB   + NATOM
         IBDNBAS = ISLTYPE + NBAS
         IBDNCEN = IBDNBAS + NBAS
         IBDOCC  = IBDNCEN + NBAS
         IBDCEN  = IBDOCC  + NBAS
         IBDBAS  = IBDCEN  + NBOSIZE * NBAS
         INWSTEP = IBDBAS  + NBOSIZE * NBAS
         IWORK1  = INWSTEP + BONDSIZE
         ITOP    = IWORK1  + 2 * (NBAS + NHB + NHA)

         ZW      = ZWNAO
         ZH      = ZW + NBAS
         ZANGNHO = ZH + MXNBA * NBAS
         ZWBOND  = ZANGNHO + NBAS * (MXSHELL + 1)
         ZWSTAR  = ZWBOND + BONDSIZE
         ZSAH    = ZWSTAR + BONDSIZE
         ZPH     = ZSAH + MXNHBA * MXNHBA
         ZPHSUB  = ZPH + NHB * NHB
         ZPHDEP  = ZPHSUB + NHB * NHB
         ZWORK1  = ZPHDEP + NHB * NHB
         ZWORK2  = ZWORK1 + 3 * NBAS
         ZTOP    = ZWORK2 + NBAS * MXCOL

         IF (MEMORY) THEN
             IMAX = MAX (IMAX,ITOP)
             ZMAX = MAX (ZMAX,ZTOP)
         ELSE
             CALL  NLO__GENER_NHO_ORBITALS
     +
     +                  ( NBAS,NATOM,
     +                    MXNHBA,MXNBA,MXSHELL,MXCOL,
     +                    BONDSIZE,NBOSIZE,
     +                    MAXOCC,
     +                    NHB,NCB,NRB,
     +                    NHA,NCA,NRA,
     +                    ICORE (IATNHB),
     +                    ICORE (IATHVAL),
     +                    ICORE (IATHOFF),
     +                    ICORE (IATNCB),
     +                    ICORE (IATCIDX),
     +                    ICORE (IATCOFF),
     +                    ICORE (IATNRB),
     +                    ICORE (IATRIDX),
     +                    ICORE (IATROFF),
     +                    ICORE (IATORD),
     +                    ICORE (IATHCEN),
     +                    ICORE (IHSHELL),
     +                    ICORE (ICSHELL),
     +                    ICORE (IRSHELL),
     +                    RYD2HYB,
     +                    ICORE (ICOLMAP),
     +                    ICORE (INHYB),
     +                    ICORE (INWSTEP),
     +                    DENSITY,
     +                    ZCORE (ZSAH),
     +                    ZCORE (ZPH),
     +                    ZCORE (ZPHSUB),
     +                    ZCORE (ZPHDEP),
     +                    ZCORE (ZBOMAT),
     +                    WBDMIN,WSTMAX,WBDCRT,WSTEP,
     +                    MXCHOOSE,NCHOOSE,CHOOSE,
     +                    ICORE (IWORK1),
     +                    ZCORE (ZWORK1),
     +                    ZCORE (ZWORK2),
     +
     +                             NBOND,
     +                             ZCORE (ZWBOND),
     +                             ZCORE (ZWSTAR),
     +                             ICORE (IBDNCEN),
     +                             ICORE (IBDCEN),
     +                             ICORE (IBDNBAS),
     +                             ICORE (IBDBAS),
     +                             ICORE (IBDOCC),
     +                             BDATOM (1,1),
     +                             ZCORE (ZANGNHO),
     +                             ZCORE (ZH),
     +                             ZCORE (ZW),
     +                             COEFFS )
     +
     +
             CALL  NLO__PRINT_NHO_RESULTS
     +
     +                  ( UNITID,
     +                    NBAS,NATOM,NBOND,
     +                    NBOSIZE,
     +                    MXNBA,MXSHELL,
     +                    NHB,NCB,NRB,
     +                    NHA,NCA,NRA,
     +                    ZATOM,
     +                    RYD2HYB,
     +                    ICORE (IATNHB),
     +                    ICORE (IATHVAL),
     +                    ICORE (IATHIDX),
     +                    ICORE (IATHOFF),
     +                    ICORE (IATNCB),
     +                    ICORE (IATCIDX),
     +                    ICORE (IATCOFF),
     +                    ICORE (IATNRB),
     +                    ICORE (IATRIDX),
     +                    ICORE (IATROFF),
     +                    ICORE (IHSHELL),
     +                    ICORE (ICSHELL),
     +                    ICORE (IRSHELL),
     +                    ICORE (IBDNCEN),
     +                    ICORE (IBDCEN),
     +                    ICORE (IBDNBAS),
     +                    ICORE (IBDBAS),
     +                    ICORE (IBDOCC),
     +                    ICORE (ICOLMAP),
     +                    ICORE (IWORK1),
     +                    ZCORE (ZANGNHO),
     +                    ZCORE (ZH) )
     +
     +
         END IF

         IF (ONLYNHO) THEN
             RETURN
         END IF
C
C
C             ...enter the NBO generation.
C
C
         INBOBD  = IBDBAS  + NBOSIZE * NBAS
         ISYMNBO = INBOBD  + NBAS
         ISYMCEN = ISYMNBO + NBAS
         IATNLB  = ISYMCEN + NATOM
         IATLIDX = IATNLB  + NATOM
         IATLOFF = IATLIDX + NATOM
         IATNEB  = IATLOFF + NATOM
         IATEIDX = IATNEB  + NATOM
         IATEOFF = IATEIDX + NATOM
         IATNYB  = IATEOFF + NATOM
         IATYIDX = IATNYB  + NATOM
         IATYOFF = IATYIDX + NATOM
         IWORK1  = IATYOFF + NATOM
         ITOP    = IWORK1  + MAX (3*NBAS,NATOM)

         ZQ      = ZWSTAR + BONDSIZE
         ZB      = ZQ + NBAS
         ZANGNBO = ZB + NBOSIZE * NBAS
         ZPH     = ZANGNBO + NBAS * (MXSHELL + 1)
         ZHYB    = ZPH + NHB * NHB
         ZROT    = ZHYB + ROTSIZE * ROTSIZE
         ZWORK1  = ZROT + ROTSIZE * ROTSIZE
         ZWORK2  = ZWORK1 + NBAS + NBAS
         ZTOP    = ZWORK2 + NBAS * NBAS

         IF (MEMORY) THEN
             IMAX = MAX (IMAX,ITOP)
             ZMAX = MAX (ZMAX,ZTOP)
             IF (ONLYNBO) THEN
                 RETURN
             END IF
         ELSE
             CALL  NLO__GENER_NBO_ORBITALS
     +
     +                  ( NBAS,NATOM,NBOND,
     +                    BONDSIZE,NBOSIZE,
     +                    MXNBA,MXSHELL,
     +                    NHB,NCB,NRB,
     +                    NHA,NCA,NRA,
     +                    ICORE (IATNHB),
     +                    ICORE (IATHOFF),
     +                    ICORE (IATNCB),
     +                    ICORE (IATCIDX),
     +                    ICORE (IATCOFF),
     +                    ICORE (IATNRB),
     +                    ICORE (IATRIDX),
     +                    ICORE (IATROFF),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    ICORE (ICOLMAP),
     +                    ZCORE (ZWBOND),
     +                    ZCORE (ZWSTAR),
     +                    WNAORYD,WNBOOCC,
     +                    ICORE (IBDNCEN),
     +                    ICORE (IBDCEN),
     +                    ICORE (IBDNBAS),
     +                    ICORE (IBDBAS),
     +                    ICORE (IBDOCC),
     +                    ZCORE (ZANGNHO),
     +                    DENSITY,
     +                    ZCORE (ZH),
     +                    ZCORE (ZPH),
     +                    ICORE (IWORK1),
     +                    ZCORE (ZWORK1),
     +                    ZCORE (ZWORK2),
     +
     +                             NLA,NEA,NYA,
     +                             NLB,NBB,NEB,NAB,NYB,
     +                             ICORE (IATNLB),
     +                             ICORE (IATLIDX),
     +                             ICORE (IATLOFF),
     +                             ICORE (IATNEB),
     +                             ICORE (IATEIDX),
     +                             ICORE (IATEOFF),
     +                             ICORE (IATNYB),
     +                             ICORE (IATYIDX),
     +                             ICORE (IATYOFF),
     +                             ICORE (INBOBD),
     +                             ZCORE (ZANGNBO),
     +                             BDSIZE,BDATOM,
     +                             ZCORE (ZB),
     +                             ZCORE (ZW),
     +                             ZCORE (ZQ),
     +                             COEFFS )
     +
     +
             IF (SYMMETRY) THEN

                 CALL  NLO__SYMMETRIZE_NBO_ORBITALS
     +
     +                      ( NBAS,NATOM,NBOND,
     +                        NBOSIZE,ROTSIZE,
     +                        MXNBA,MXSHELL,
     +                        NCB,NLB,NBB,NEB,NAB,NYB,NRB,
     +                        NCA,NLA,NEA,NYA,NRA,
     +                        ICORE (IATNCB),
     +                        ICORE (IATCIDX),
     +                        ICORE (IATCOFF),
     +                        ICORE (IATNLB),
     +                        ICORE (IATLIDX),
     +                        ICORE (IATLOFF),
     +                        ICORE (IATNEB),
     +                        ICORE (IATEIDX),
     +                        ICORE (IATEOFF),
     +                        ICORE (IATNYB),
     +                        ICORE (IATYIDX),
     +                        ICORE (IATYOFF),
     +                        ICORE (IATNRB),
     +                        ICORE (IATRIDX),
     +                        ICORE (IATROFF),
     +                        ICORE (IBASBEG),
     +                        ICORE (IBASEND),
     +                        DSYMACC,LSYMACC,
     +                        PSYMACC,QSYMACC,
     +                        ICORE (ISYMMAP),
     +                        ICORE (ISYMNBO),
     +                        ICORE (ISYMCEN),
     +                        PLATONIC,
     +                        ICORE (IRING),
     +                        ICORE (INRING),
     +                        ICORE (IRINGSZ),
     +                        NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                        ICORE (IPLATO),
     +                        ICORE (IBDNCEN),
     +                        ICORE (IBDCEN),
     +                        ZCORE (ZANGNHO),
     +                        ZCORE (ZHYB),
     +                        ZCORE (ZROT),
     +                        DENSITY,
     +                        ZCORE (ZDOMAT),
     +                        OVERLAP,
     +                        ZCORE (ZLOCAL),
     +                        ICORE (ISLTYPE),
     +                        ICORE (IWORK1),
     +                        ZCORE (ZWORK1),
     +                        ZCORE (ZWORK2),
     +
     +                                 ICORE (INBOBD),
     +                                 ICORE (IBDNBAS),
     +                                 ICORE (IBDBAS),
     +                                 ZCORE (ZANGNBO),
     +                                 ZCORE (ZB),
     +                                 ZCORE (ZW),
     +                                 ZCORE (ZQ),
     +                                 COEFFS )
     +
     +
             END IF

             CALL  NLO__DETERMINE_ORBITAL_LOCALITY
     +
     +                  ( NBAS,NATOM,
     +                    ICORE (IWORK1),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    COEFFS,
     +                    OVERLAP,
     +
     +                             ZCORE (ZLOCAL) )
     +
     +
             CALL  NLO__PRINT_NBO_RESULTS
     +
     +                  ( UNITID,
     +                    NBAS,NATOM,
     +                    NBOSIZE,
     +                    MXSHELL,
     +                    NCA,NLA,NEA,NYA,NRA,
     +                    NCB,NLB,NBB,NEB,NAB,NYB,NRB,
     +                    ZATOM,
     +                    ICORE (IATNCB),
     +                    ICORE (IATCIDX),
     +                    ICORE (IATCOFF),
     +                    ICORE (IATNLB),
     +                    ICORE (IATLIDX),
     +                    ICORE (IATLOFF),
     +                    ICORE (IATNEB),
     +                    ICORE (IATEIDX),
     +                    ICORE (IATEOFF),
     +                    ICORE (IATNYB),
     +                    ICORE (IATYIDX),
     +                    ICORE (IATYOFF),
     +                    ICORE (IATNRB),
     +                    ICORE (IATRIDX),
     +                    ICORE (IATROFF),
     +                    ICORE (IBDNCEN),
     +                    ICORE (IBDCEN),
     +                    ICORE (IBDNBAS),
     +                    ICORE (IBDBAS),
     +                    ICORE (INBOBD),
     +                    ZCORE (ZLOCAL),
     +                    ZCORE (ZANGNBO),
     +                    ZCORE (ZW),
     +                    ZCORE (ZQ),
     +                    ZCORE (ZB) )
     +
     +
             IF (ONLYNBO) THEN
                 CALL  NLO__DENORMALIZE_COEFF_MATRIX
     +
     +                      ( NBAS,
     +                        ZCORE (ZDENORM),
     +
     +                                 COEFFS )
     +
     +
                 RETURN
             END IF
         END IF
C
C
C             ...enter the NLMO generation.
C
C
         IWORK1  = IBASEND + NATOM
         ITOP    = IWORK1  + MAX (NBAS,NATOM)

         ZW      = ZDENORM + NBAS
         ZLOCAL  = ZW + NBAS
         ZWORK1  = ZLOCAL + NATOM * NBAS
         ZTOP    = ZWORK1 + NBAS * NBAS

         IF (MEMORY) THEN
             IMAX = MAX (IMAX,ITOP)
             ZMAX = MAX (ZMAX,ZTOP)
         ELSE
             NOCC = NCB + NLB + NBB

             CALL  NLO__GENER_NLMO_ORBITALS
     +
     +                  ( NBAS,NOCC,
     +                    MAXOCC,
     +                    ICORE (IWORK1),
     +                    PSYMACC,QSYMACC,
     +                    DENSITY,
     +                    ZCORE (ZWORK1),
     +
     +                             ZCORE (ZW),
     +                             COEFFS )
     +
     +
             CALL  NLO__DETERMINE_ORBITAL_LOCALITY
     +
     +                  ( NBAS,NATOM,
     +                    ICORE (IWORK1),
     +                    ICORE (IBASBEG),
     +                    ICORE (IBASEND),
     +                    COEFFS,
     +                    OVERLAP,
     +
     +                             ZCORE (ZLOCAL) )
     +
     +
             CALL  NLO__PRINT_NLMO_RESULTS
     +
     +                  ( UNITID,
     +                    NBAS,NATOM,
     +                    ZCORE (ZLOCAL) )
     +
     +
             CALL  NLO__DENORMALIZE_COEFF_MATRIX
     +
     +                  ( NBAS,
     +                    ZCORE (ZDENORM),
     +
     +                             COEFFS )
     +
     +
         END IF
C
C
C             ...close general printout file and diagnostic/debug file.
C
C
         IF (.NOT.MEMORY) THEN
             CALL  NLO__CLOSE_FILES
     +
     +                  ( UNITID,UNITDB )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      Subroutine Ecp_ang_int_typ2(Xahat, Yahat, Zahat, Xbhat, Ybhat, 
     &                            Zbhat, La, Lb, Ltot, Lamalo, Lamahi,
     &                            Lamblo, Lambhi, Lamau, Lambu, Lprj,
     &                            ACS_xyz, BCS_xyz, Ang2_A, Ang2_B,
     &                            Rad2, Cint, Int, Grads)
C
C See the calling routine for meaning of input variables.
C
      Implicit Double Precision (A-H, O-Z)
      Logical Grads

#include "ecp.par"
#include "ecp.com"

      Dimension ACS_xyz(0:2*Maxang,3),BCS_xyz(0:2*Maxang,3),
     &          Ang2_A(0:2*Maxang,-Maxproj:Maxproj,0:2*Maxang),
     &          Ang2_B(0:2*Maxang,-Maxproj:Maxproj,0:2*Maxang),
     &          Rad2(0:2*Maxang,0:2*Maxang, 0:2*Maxang),
     &          Cint(Maxmem_a3)

      If (Grads) Then
         La_lo = Istart_grd(La)
         La_hi = Iend_grd(La)
           Lap = La + 1

         Lb_lo = Istart(Lb)
         Lb_hi = Iend(Lb)
      Else
         La_lo = Istart(La)
         La_hi = Iend(La)
           Lap = La

         Lb_lo = Istart(Lb)
         Lb_hi = Iend(Lb)
      Endif

      Int   = 0

C      La_Lo = 6
C      La_hi = 6
C      Lb_lo = 13
C      Lb_hi = 13

      Do Ia = La_lo, La_hi

         If (Grads) Then
            Nax = Lmnval_grd(1, Ia)
            Nay = Lmnval_grd(2, Ia)
            Naz = Lmnval_grd(3, Ia)
         Else
            Nax = Lmnval(1, Ia) 
            Nay = Lmnval(2, Ia)
            Naz = Lmnval(3, Ia) 
         Endif

#ifdef _DEBUG_LVLM
      write(6,"(a)") "Entering ECP_ang_int2-1: Nax, Nay, Naz"
      Write(6,"(1x,3I)") Nax, Nay, Naz
#endif
         Call Ecp_ang_int2(Xahat, Yahat, Zahat, Lamau, Lap, 
     &                     Nax, Nay, Naz, Lprj, ACS_xyz, Ang2_A)

         Do Ib = Lb_lo, Lb_hi
 
            Nbx = Lmnval(1, Ib) 
            Nby = Lmnval(2, Ib)
            Nbz = Lmnval(3, Ib) 

            Sum = 0.0D0
            Int = Int + 1

#ifdef _DEBUG_LVLM
      write(6,"(a)") "Entering ECP_ang_int2-2"
      Write(6,*)
#endif
             Call Ecp_ang_int2(Xbhat, Ybhat, Zbhat, Lambu, Lb, 
     &                         Nbx, Nby, Nbz, Lprj, BCS_xyz, Ang2_B)

             Do Lama = Lamalo, Lamahi
         
                Na_min = Iabs(Lprj-Lama)
                Na_max  = Lap - Mod(Lap-Na_min,2) 
            
                Do Lamb = Lamblo, Lambhi
            
                   Nb_min = Iabs(Lprj-Lamb)
                   Nb_max = Lb - MOd(Lb-Nb_min,2)
               
                   Nlo = Na_min + Nb_min
                   Nhi = Na_max + Nb_max

                   Do N = Nlo, Nhi, 2
                      
                      Nlmlo = Max(Na_min, N-Nb_Max)
                      Nlmhi = Min(Na_max, N-Nb_Min)
                      
                      Ang = 0.0D0

                      Do M = -Lprj, Lprj
                         
                         Do Nlm = Nlmlo, Nlmhi

                            Ang = Ang + Ang2_A(Nlm, M, Lama)*
     &                                  Ang2_B(N-Nlm, M, Lamb)
                           
#ifdef _DEBUG_LVLM
      Write(6,"(a,5(1x,I3),1x,3(F18.13))")
     &         "Summing Ang1 and Ang2:N,M,L: ",
     &          Nlm, (N-Nlm), M, Lama,Lamb,
     &          ang2_a(nlm,m,lama), ang2_b(n-nlm,m,lamb), Ang
#endif

                         Enddo
                      Enddo

                      Sum = Sum + Ang*Rad2(N, Lamb, Lama)
#ifdef _DEBUG_LVLM
      Write(6,*)
      Write(6,"(a,3(1x,I3),1x,3(F18.13))")
     &         "Summing Rad and Ang:N,M,L: ",
     &          N,  Lama,Lamb,
     &         Rad2(N,Lamb,Lama), Ang, Sum
#endif

                   Enddo
                Enddo
             Enddo 
C
#ifdef _DEBUG_LVLM
         Write(6,*)
         Write(6,"(a,3(1x,i3))") "Ia,Ib,int; ", ia, ib, int
         Write(6,"(a,1x,i3,1x,(F18.13))") "@-ang_typ2,CINT: ", 
     &         int,CINT(int) 
         Write(6,*)
#endif

         Cint(Int) = Cint(Int) + Sum

#ifdef _DEBUG_LVL0
         Write(6,*)
         Write(6,"(a,3(1x,i3))") "Ia,Ib,int; ", ia, ib, int
         Write(6,"(a,1x,i3,1x,(F18.13))") "@-ang_typ2,CINT: ", 
     &         int,CINT(int) 
         Write(6,*)
#endif
C
         Enddo
      Enddo

      Return
      End
            

C DRIVES THE CREATION OF MOIO POINTERS FOR SYMMETRY PACKED LISTS.

      SUBROUTINE INIPCK(IRREPX,SYTYPL,SYTYPR,LIST,IARG1,IARGX2,ISET)
      IMPLICIT INTEGER (A-Z)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)

      if ((SYTYPL.lt.1).or.(22.lt.SYTYPL).or.
     &    (SYTYPR.lt.1).or.(22.lt.SYTYPR)    ) then
         print *, '@INIPCK: Assertion failed.'
         print *, '   SYTYPL = ',SYTYPL
         print *, '   SYTYPR = ',SYTYPR
         print *, '   LIST   = ',LIST
         call errex
      end if

      IARG2 = IARGX2
      DO IRREPR = 1, NIRREP
         IRREPL = DIRPRD(IRREPR,IRREPX)
         CALL UPDMOI(IRPDPD(IRREPR,SYTYPR),IRPDPD(IRREPL,SYTYPL),
     &               IRREPR,LIST,IARG1,IARG2)
         IARG1 = 0
         IARG2 = 0
      END DO
      IF (ISET.EQ.0) RETURN
      LISTX = LIST
      IF (LISTX.EQ.0) LISTX = 100
      ISYTYP(1,LISTX) = SYTYPL
      ISYTYP(2,LISTX) = SYTYPR
      RETURN
      END

      SUBROUTINE T1T2AB2(Z,Z1,W,MAXSIZE,TA,TB,POP1,POP2,VRT1,VRT2,
     &                   DISSYZ,DISSYWA,DISSYWB,NUMSYZ,NUMSYWA,
     &                   NUMSYWB,NTASIZ,NTBSIZ,LISTZ,LISTWA,LISTWB,
     &                   IRREP,IUHF,TMP)
C
C PRIMITIVE CONTRACTION ROUTINE FOR T2<-T1
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSYZ,DISSYWA,DISSYWB,DISMAX,DISLEFT,DISREAD,
     &        DIRPRD,POP1,POP2,VRT1,VRT2
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      DIMENSION Z(DISSYZ,NUMSYZ),W(DISSYWA,1),TA(NTASIZ)
      DIMENSION Z1(DISSYZ,NUMSYZ),TB(NTBSIZ),IPT(8)
      DIMENSION TMP(1),POP1(8),POP2(8),VRT1(8),VRT2(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
C
      DATA AZERO,ONE,ONEM /0.0D0,1.0D0,-1.0D0/
C
C     ZERO FIRST OUTPUT ARRAY (NECCESARY BECAUSE THIS IS NOT NECCESARILY
C     DONE IN THE MATRIX MULTIPLICATION
C
      if (NUMSYZ*DISSYZ.LT.0) call trap_intovf('T1T2AB2',1)
      CALL ZERO(Z,NUMSYZ*DISSYZ)
C
C     IF THERE ARE NO WA INTEGRALS THERE IS NOTHING TO DO
C
      IF(MIN(NUMSYWA,DISSYWA).NE.0) THEN
C
C  DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN CORE
C
      MAXDIS=MAXSIZE/DISSYWA
C
C     DETERMINE ALGORITHM BY CHECKING MAXSIZE
C
      IF(MAXDIS.GE.NUMSYWA) THEN
C
C   WE CAN DO EVERYTHING IN CORE
C
C   GET INTEGRALS <Ab//Ei> FROM LISTWA 
C
       CALL GETLST(W,1,NUMSYWA,2,IRREP,LISTWA)
       CALL SYMTR1(IRREP,VRT1,POP2,DISSYWA,W,TMP,TMP(1+DISSYWA),
     &             TMP(1+2*DISSYWA))
C
C   PERFORM MULTIPLICATION
C
      JOFFW=1
      JOFFZ=1     
      IOFF=1
      DO 90 IRREPJ=1,NIRREP
C
       NOCCJ=POP1(IRREPJ)
       NVRTJ=VRT1(IRREPJ)
C
       IRREPI=DIRPRD(IRREPJ,IRREP)
C
       NOCCI=POP2(IRREPI)
C  
C      NOTHING TO COMPUTE IF ANY OF THE OCCUPATIONS IS ZERO
C
C
        CALL XGEMM('N','N',DISSYWA*NOCCI,NOCCJ,NVRTJ,ONE,W(1,JOFFW), 
     &             DISSYWA*NOCCI,TA(IOFF),NVRTJ,
     &             ONE,Z(1,JOFFZ),DISSYZ*NOCCI)
C
C     UPDATE POINTERS
C
       IOFF=IOFF+NVRTJ*NOCCJ
       JOFFW=JOFFW+NVRTJ*NOCCI
       JOFFZ=JOFFZ+NOCCI*NOCCJ
90    CONTINUE
C
      IF(IUHF.EQ.0) THEN
       CALL SYMTRA(IRREP,POP2,POP1,DISSYZ,Z,Z1)
      ELSE
       CALL SYMTR1(IRREP,POP2,POP1,DISSYZ,Z,TMP,TMP(1+DISSYZ),
     &             TMP(1+2*DISSYZ))
      ENDIF
      ELSE
C
C    WE HAVE TO DO IT OUT OF CORE
C
C    CALCULATE FIRST POINTERS FOR T1
C
       IPT(1)=1
       DO 50 IRREPJ=1,NIRREP-1
        IRREPI=DIRPRD(IRREP,IRREPJ)
        IPT(IRREPJ+1)=IPT(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPJ)
50     CONTINUE
C
C  SET OFFSETS FOR INTEGRAL LIST AND FOR Z ARRAY
C
       IOFFSET=1
       IOFFZ=1
C
C  LOOP OVER IRREPS OF THE LAST INDEX
C
       DO 200 IRREPJ=1,NIRREP
C 
        NOCCJ=POP2(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NOCCI=POP1(IRREPI)
        NVRTI=VRT1(IRREPI)
        IF(MIN(NOCCI,NVRTI,NOCCJ).NE.0) THEN
C
C  GET MAXIMUM NUMBER OF (A,b,E) BLOCKS WHICH CAN BE HELD IN
C  CORE
C
        DISMAX=MAXDIS/NVRTI
        IF(DISMAX.LE.0) STOP 'T1T2AB2'
C
C  DETERMINE NUMBER OF (A,b,E) BLOCKS WHICH MUST BE READ
C
        DISLEFT=NOCCJ
C
10      CONTINUE
C
C  GET NUMBER OF (Ab,E) BLOCKS WHICH ARE READ IN DURING THIS PASS
C
         DISREAD=MIN(DISLEFT,DISMAX)
         DISLEFT=DISLEFT-DISREAD
C
C  GET THE DISTRIBUTIONS FROM DISK
C
         CALL GETLST(W,IOFFSET,DISREAD*NVRTI,2,IRREP,LISTWA)
C
C  UPDATE IOFFSET
C
         IOFFSET=IOFFSET+DISREAD*NVRTI
C
C  LOOP OVER ALL DISTRIBUTIONS AND PERFORM MULTIPLICATION
C
         IOFFW=1
         IOFFT1=IPT(IRREPI)
C
         DO 250 NUM=1,DISREAD
C
          CALL XGEMM('N','N',DISSYWA,NOCCI,NVRTI,ONE,W(1,IOFFW),
     &               DISSYWA,TA(IOFFT1),NVRTI,ONE,Z(1,IOFFZ),DISSYZ)
C
C  UPDATE OFFSETS
C
          IOFFW=IOFFW+NVRTI
          IOFFZ=IOFFZ+NOCCI
C
250      CONTINUE
C
C IF NOT ALL (Ab,E) BLOCKS HAVE BEEN PROCESSED, GO TO 10
C
        IF(DISLEFT.NE.0) GO TO 10
C
       ELSE
C
C  UPDATE OFFSETS IN THE CASE NOTHING HAS BEEN DONE
C
        IOFFZ=IOFFZ+NOCCI*NOCCJ
        IOFFSET=IOFFSET+NOCCJ*NVRTI
       ENDIF
C
200    CONTINUE
c YAU : old
c      IF(IUHF.EQ.0) CALL ICOPY(NUMSYZ*DISSYZ*IINTFP,Z,1,Z1,1)
c YAU : new
       IF(IUHF.EQ.0) CALL DCOPY(NUMSYZ*DISSYZ,Z,1,Z1,1)
c YAU : end
      ENDIF
      ENDIF
C
C
      IF(IUHF.EQ.0) THEN
C
C      RHF CASE :
C
C     WE HAVE NOTHING DONE, SO WE HAVE NOT TO UPDATE Z
C
      IF(MIN(NUMSYWA,DISSYWA).EQ.0) RETURN
C
C   IN RHF THIS IS SIMPLY A TRANSPOSITION
C
       CALL GETLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
       CALL VADD(Z,Z,Z1,NUMSYZ*DISSYZ,ONE)
C
       CALL SYMTR1(IRREP,POP1,POP2,DISSYZ,Z1,TMP,TMP(1+DISSYZ),
     &             TMP(1+2*DISSYZ))
       CALL SYMTR3(IRREP,VRT1,VRT2,DISSYZ,NUMSYZ,Z1,TMP,
     &             TMP(1+NUMSYZ),TMP(1+2*NUMSYZ))
       CALL VADD(Z,Z,Z1,NUMSYZ*DISSYZ,ONE)
       CALL PUTLST(Z,1,NUMSYZ,1,IRREP,LISTZ)
    
      ELSE
C
C      IF THERE ARE NO INTEGRALS SKIP MULTIPLICATION
C
       IF(MIN(NUMSYWB,DISSYWB).NE.0) THEN
C
C  DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN CORE
C
       MAXDIS=MAXSIZE/DISSYWB
C
C    DECIDE ABOUT ALGORITHM
C
       IF(MAXDIS.GE.NUMSYWB) THEN
C
C  IN CORE ALGORITHM
C
C   GET INTEGRALS <Ab//Ie> FROM LISTWB1
C
     
        CALL GETLST(W,1,NUMSYWB,2,IRREP,LISTWB)
C
       JOFFW=1     
       JOFFZ=1
       IOFF=1
       DO 190 IRREPI=1,NIRREP
C
        NOCCI=POP2(IRREPI)
        NVRTI=VRT2(IRREPI)
C
        IRREPJ=DIRPRD(IRREPI,IRREP)
C
        NOCCJ=POP1(IRREPJ)
C
C    PERFORM  MULTIPLICATION
C
        CALL XGEMM('N','N',DISSYWB*NOCCJ,NOCCI,NVRTI,ONE,W(1,JOFFW), 
     &             NOCCJ*DISSYWB,TB(IOFF),NVRTI,
     &             ONE,Z(1,JOFFZ),NOCCJ*DISSYZ)
C
C  UPDATE OFFSETS
C
       IOFF=IOFF+NVRTI*NOCCI
       JOFFW=JOFFW+NVRTI*NOCCJ
       JOFFZ=JOFFZ+NOCCI*NOCCJ
190    CONTINUE
C
      ELSE
C
C  OUT OF CORE ALGORITHM
C
C  OFFSET FOR INTEGRAK LIST, T1 AMPLITUDES AND T2 INCREMENTS
C
       IOFFSET=1
       IOFFT1=1
       IOFFZ=1
C
C   LOOP OVER IRREPS OF THE LAST INDEX
C
       DO 300 IRREPJ=1,NIRREP 
C
        NOCCJ=POP2(IRREPJ)
        NVRTJ=VRT2(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NOCCI=POP1(IRREPI)
        IF(MIN(NOCCI,NOCCJ,NVRTJ).NE.0) THEN
C 
C  DETERMINE THE NUMBER OF (Ab,I) BLOCKS WHICH CAN BE HELD IN
C  CORE
C
        DISMAX=MAXDIS/NOCCI
C
C  NUMBER OF (Ab,I) BLOCKS TO READ
C
        DISLEFT=NVRTJ
C
        IOFF=0
C
20      CONTINUE 
C
C  DETERMINE NUMBER OF (Ab,I) BLOCKS WHICH ARE PROCESSED IN THIS PASS
C
         DISREAD=MIN(DISLEFT,DISMAX)
         DISLEFT=DISLEFT-DISREAD
C
C  GET THE CONTRIBUTIONS FROM DISK
C
         CALL GETLST(W,IOFFSET,DISREAD*NOCCI,2,IRREP,LISTWB)
C
C   UPDATE OFFSET
C 
         IOFFSET=IOFFSET+DISREAD*NOCCI
C
C    PERFORM MULTIPLICATION
C
         CALL XGEMM('N','N',DISSYWB*NOCCI,NOCCJ,DISREAD,ONE,
     &              W,DISSYWB*NOCCI,TB(IOFFT1+IOFF),NVRTJ,
     &              ONE,Z(1,IOFFZ),DISSYZ*NOCCI)
C
         IOFF=IOFF+DISREAD
C
C   IF NOT ALL (Ab,I) BLOCKS HAVE BEEN PROCESSES, GO BACK TO 20
C
        IF(DISLEFT.NE.0) GO TO 20
C
       ELSE
C
C  UPDATE OFFSETS IN THE CASE NOTHING HAS BEEN DONE
C
        IOFFSET=IOFFSET+NVRTJ*NOCCI
       ENDIF
C
C  UPDATE OFFSETS
C
       IOFFT1=IOFFT1+NOCCI*NVRTJ
       IOFFZ=IOFFZ+NOCCJ*NOCCI
300   CONTINUE
      ENDIF
      ENDIF
      CALL GETLST(Z1,1,NUMSYZ,2,IRREP,LISTZ)
      CALL VADD(Z1,Z1,Z,NUMSYZ*DISSYZ,ONE)
      CALL PUTLST(Z1,1,NUMSYZ,2,IRREP,LISTZ)
      ENDIF
      RETURN
      END

      SUBROUTINE FOLOWTANGENT(HESMOD, DIAGHES, QSTLST_TANGENT,
     &                        SCRATCH, NX, NOPT, IMODE)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      DOUBLE PRECISION OVRLP

      PARAMETER (OVRLP_MIN = 8.0D-1)
      DATA ZERO /0.0D0/
      DATA TWO  /2.0D0/

      DIMENSION HESMOD(NOPT, NOPT), DIAGHES(NOPT, NOPT),
     &          SCRATCH(NX*NX),  QSTLST_TANGENT(NOPT)
C
C For climbing steps, Let's get the eigenvector of the Hessian that 
C has the largest overlap with the LST or QST tangent. Since the 
C tangent is approx. eigenfunction (by construction) we are basically
C following the tangent.
C
      ZOVRLP1 = ZERO
      ZOVRLP2 = ZERO

      DO 10 IOPT = 1, NOPT
         OVRLP = XDDOT(NOPT,QSTLST_TANGENT,1,DIAGHES(1,IOPT),1)
         IF (DABS(OVRLP).GT.ZOVRLP1) THEN
            ZOVRLP2 = ZOVRLP1
            ZOVRLP1 = DABS(OVRLP)
            MEFOLOW = IOPT
         ELSE IF (DABS(OVRLP) .GT. ZOVRLP2) THEN
            ZOVRLP2 = DABS(OVRLP)
         END IF
 10   CONTINUE

      IMODE = MEFOLOW

#ifdef _DEBUG_LVL0
      Write(6,"(a,1x,F12.6,1x,F12.6,1x,I3)") "The maximum overlaps = ", 
     &                                        ZOVRLP1,ZOVRLP2, MEFOLOW
      Write(6,*) 
      Write(6,"(a,I3,a,a)")"The LST/QST mode ",Imode," is being used",
     &                     " for climbing."
#endif

      RETURN
      END

c This routine opens the ZMAT file and searches for a namelist.
c If found, it is read into the array namelist for parsing.
c
c If printdef is true, the namelist will default to printing (though it
c can be overridden by the PRINT_NL keyword in the namelist itself).

      subroutine nl_init(title,err,printdef)
      implicit none

      character*(*) title
      integer err
      logical printdef

#include "namelist.com"
#include "callstack.com"

      character*(nllinelen) line, szTitle
      integer zio, linenum, l, strlen
      logical streq, bPrint, bOpen

      callstack_prev = callstack_curr
      callstack_curr = 'NL_INIT'

      szTitle = '*'//title
      err     = 0
      bPrint  = printdef

c Open ZMAT file and search for the namelist.
      zio = 10
      inquire(unit=zio,opened=bOpen)
      do while (bOpen)
         zio = zio+1
         inquire(unit=zio,opened=bOpen)
      end do
      open(unit=zio,file='ZMAT',form='formatted',err=999,iostat=err)

      linenum=0
      nlnumline=0
      l=strlen(szTitle)
   10 continue
         read(zio,'(a)',end=999) line
         linenum=linenum+1
      if (strlen(line).eq.0 .or.
     &    line(1:1).eq.'#' .or.
     &    .not.streq(szTitle,line(1:l),.true.)
     &   ) goto 10

c Once the namelist is found, remove the '*TITLE' from it and if
c anything is left, put it as the first line of the namelist text
      line=line(l+1:strlen(line))
      if (strlen(line).gt.0) then
         call upcase(line)
         nltext(1)=line
         nlnumline=1
      end if

c Read until we are done with the file or find a line starting with '*'
      line=' '
      do while (line(1:1).ne.'*')
         read(zio,'(a)',end=999) line
         linenum=linenum+1
         if (strlen(line).ne.0 .and.
     &       line(1:1).ne.'#' .and.
     &       line(1:1).ne.'*') then
            if (nlnumline.eq.nlmaxline) then
               write(*,'(a)')
     &            '@NL_INIT: maximum length of namelist exceeded'
               call errex
            end if
            nlnumline=nlnumline+1
            call upcase(line)
            nltext(nlnumline)=line
         end if
      end do

  999 continue
      close(zio)
      call nl_log('print_nl',bPrint,prt_nl)
      if (prt_nl) call nl_prttop(title)
      if (nlnumline.eq.0) err=1

      callstack_curr = callstack_prev
      return
c     end subroutine nl_init
      end

c This routine initializes the chemical system in order that the executable
c understands symmetry, orbital, and list information.

      subroutine aces_init_chemsys
      implicit none

c COMMON BLOCKS
c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end

c ----------------------------------------------------------------------

c   o nocco and nvrto
      call aces_com_info

c   o initialize the point group and direct product table
      call aces_com_syminf
      if (nirrep.lt.1) then
         print '(/)'
         print *, '@ACES_INIT_CHEMSYS: Information regarding the ',
     &            'chemical system has not been'
         print *, '                    created. Common blocks relying ',
     &            'on this information will'
         print *, '                    not be initialized.'
         print '(/)'
         return
      end if

c   o irpdpd (needs /syminf/)
      call aces_com_sympop

c   o pop and vrt (needs /syminf/)
      call aces_com_sym

c   o isymoff (needs /syminf/ and /sym/)
      call aces_com_symloc

      return
c     end subroutine aces_init_chemsys
      end

C FLUSHES BUFFERS AND WRITES OUT COMMON BLOCK INFORMATION
C FOR THE NEXT PROGRAM. SHOULD NEVER BE CALLED EXPLICITLY,
C AND IS A DEPENDENT OF CRAPSO.

      SUBROUTINE TERMIO
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION BUFFRC
      LOGICAL YESNO
      COMMON /FLAGS/ IFLAGS(100)
      INTEGER USEC,USECIN,TSTART,WSTART,FILE
      COMMON / / ICORE(1)
      COMMON /INCORE/ ICREC(2),USEC,IXT(2),IMOD(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MACHSP2/MASK1,MASK2,ISHFSZ
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /IOSTAT/ NOPBUF,NOPDSK
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      common/io_ptrs/TOTREC(5),TOTWRD(5)
#include "bwcc.com"

      IPACK(I,J)=IOR(J,ISHFT(I-49,ISHFSZ))
      UPACKR(I) =IAND(I,MASK1)
      UPACKF(I) =IAND(ISHFT(I,-ISHFSZ),MASK2)+49

c ----------------------------------------------------------------------

      MOIOSIZ=5000

c   o DUMP CACHES
cjp replace this with call to aces_cache_flush, which also zeroes out the buffer
cjp and make thus crapso more times callable, which is useful for
cjp multireference case
cjp - old
cjp      DO I=1,CACHNUM
cjp       FILE=CACHFILE(I)
cjp       IF(FILE.NE.0)THEN
cjp        RECORD=UPACKR(CACHDIR(I))
cjp        IPOS  =CACHPOS(I)
cjp        CALL ACES_IO_WRITE(FILE,RECORD,ICORE(IPOS),LENREC)
cjp        CACHMOD(I)=0
cjp       ENDIF
cjp      END DO
cjp - new
      call aces_cache_flush
cjp - end

c   o DUMP INFORMATION TO JOBARC
      CALL PUTREC(20,'JOBARC','MOIOVEC ',MOIOSIZ,MOIO)
      CALL PUTREC(20,'JOBARC','MOIOWRD ',MOIOSIZ,MOIOWD)
      CALL PUTREC(20,'JOBARC','MOIOSIZ ',MOIOSIZ,MOIOSZ)
      CALL PUTREC(20,'JOBARC','MOIODIS ',MOIOSIZ,MOIODS)
      CALL PUTREC(20,'JOBARC','MOIOFIL ',MOIOSIZ,MOIOFL)
      CALL PUTREC(20,'JOBARC','ISYMTYP ',1000,ISYTYP)
c      CALL UPDMOI(0,0,0,0,2,0)
      CALL PUTREC(20,'JOBARC','TOTRECMO',5,TOTREC)
      CALL PUTREC(20,'JOBARC','TOTWRDMO',5,TOTWRD)

c Nevin - changed exist to opened
      DO I = 50, 54
         INQUIRE(UNIT=I,opened=YESNO)
         IF (YESNO) CLOSE(I,STATUS='KEEP')
      END DO

      RETURN
      END

      SUBROUTINE SortC (NAtms, XX, AtNr, Y, NORD, X)
C     X is a scratch array of the same type and dimension as XX and Y
C     AtNr are the atomix numbers of the centers (dummy atom = 0)
C
C     SORTS VECTOR OF NUCLEAR COORDINATES - TO CHECK FOR EQUIVALENCE
C     OF TWO ORIENTATIONS - NEEDS Q VECTOR AND ATOMIC NUMBER VECTOR (AtNr)
C
      Implicit double precision (a-h,o-z)
      DIMENSION X(3*NATMS),XX(3*NATMS),Y(3*NATMS),NORD(NATMS)
      Integer AtNr(natms)
C
      ILINE(J)=1+J/3
C
C     SORT ON THE X - IF TWO X'S ARE EQUIVALENT, SORT ON Y AND SO ON.
C     
      DO 80 I=1,3*NATMS
 80      X(I)=XX(I)
C
C     FIRST GIVE DUMMY ATOMS RIDICULOUS SCRATCH COORDINATES - ENSURES
C     THAT THEY WILL WIND UP AT THE BOTTOM OF THE LIST
C
      DO 81 I=1,3*NATMS-2,3
         IF(AtNr(ILINE(I)) .eq. 0)THEN
            DO 82 J=0,2
 82            X(J+I) = -99995.
         ENDIF
 81   CONTINUE
      JK=1
 429  J=1
      DO 96 I=1,3*NATMS-2,3
C
C     CONTINUE WITH SORTING.
C
         IF(X(I)-X(J).GT.1D-6)J=I
         IF(DABS(X(I)-X(J)).LT.1D-6)THEN
            IF(X(I+1)-X(J+1).GT.1D-6)J=I
            IF(DABS(X(I+1)-X(J+1)).LT.1D-6)THEN
               IF(X(I+2)-X(J+2).GT.1D-6)J=I
            ENDIF
         ENDIF
 96   CONTINUE
      DO 93 I=0,2
C
C     Mass-WEIGHT SORTED VECTOR - WILL ZERO ELEMENTS CORRESPONDING
C     TO DUMMY ATOMS SO THEY DONT MUCK UP THE SYMMETRY CHECKING.
C     
         Y(3*JK-2+I)=X(J+I)*AtNr(ILINE(J))
 93      X(J)=-99999.D0
      NORD(JK)=(J+2)/3
      JK=JK+1
      if(jk.eq.NATMS+1)go to 999
      go to 429
 999  Continue
      Return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine check_work_stack_for_delay(flag, delay_flag,
     *                             server_msg_count)
      implicit none
      include 'server.h'

      integer i
      integer delay_flag, server_msg_count
      logical flag

      if (delay_flag .eq. 0 .or. flag .or. 
     *              barrier_in_progress) return

c--------------------------------------------------------------------------
c   We know delay_flag = 1, flag = .false. (i. e. no more probed messages
c   exist), and we are not in barrier processing mode.  
c
c   If the only messages remaining in our message nodes are requests, 
c   then we must go ahead and clear the delay_flag, otherwise the job 
c   may hang because the worker is blocked waiting for the server to 
c   clear the delay_flag and the server is blocked waiting for the request
c   to complete.
c--------------------------------------------------------------------------

      do i = 1, nmessage_buffers
         if (server_msg(c_msg_state,i) .ne. null_state .and. 
     *       server_msg(c_msg_type,i) .ne. server_request_msgtype)
     *           return
      enddo

c-------------------------------------------------------------------------
c   All active messages are requests.  Clear the flags.
c-------------------------------------------------------------------------

c      print *,'SERVER Clear delay due to requests only...'
      delay_flag = 0
      server_msg_count = 0
      return
      end

      SUBROUTINE T2T1AA1(W,ICORE,MAXCOR,POP,VRT,ISPIN,LAMBDA,LSTOFF)
C
C     THIS SUBROUTINE CALCULATES THE FOLLOWING CONTRIBUTIOBN TO THE
C     T1  INCREMENT (LAMBDA = .FALSE.
C
C      Z(I,A) =  SUM E<F,M T(IM,EF) <AM//EF>
C
C OR   Z(i,a) =  SUM e<f,m T(im,ef) <am//ef)
C
C      OR TO THE L1 INCREMENT (LAMBDA = .TRUE.)
C
C      Z(I,A) =  SUM E<F,M L(IM,EF) <AM//EF>
C
C OR   Z(i,a) =  SUM e<f,m L(im,ef) <am//ef)
C
CEND   
C
C CODED JUNE/90   JG
C 
C  OUT OF CORE ALGORITHM IMPLEMENTED IN SEPT/90
C  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LAMBDA
      INTEGER DIRPRD,POP,VRT,DISSYT,DISSYW,DISMAX,DISLEFT,DISREAD
C
      DIMENSION ICORE(MAXCOR),POP(8),VRT(8),W(1),IPT(8),IPZ(8)
C
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /FLAGS/ IFLAGS(100)
C
      DATA ZERO,ONE,ONEM /0.0D0,1.0D0,-1.0D0/
C
C  DETERMINE LIST NUMBERS
C  LISTT = T2 AMPLITUDES,   LISTW = <EF//AM> INTEGRALS
C
C  The iflags(39) flag, reserved for "standard" or "semicanonical" 
C  orbitals, is used here to determine which list is needed for the
C  ROHF-MBPT code, since this routine is called by two others at
C  different times.  The value of "99" is set before the second call
C  to E3S in ROHFPT.
C
      IF(LAMBDA) THEN
       LISTT=143+ISPIN
      ELSEIF(IFLAGS(11).EQ.2.AND.IFLAGS(39).EQ.99) THEN
       LISTT=93+ISPIN
      ELSE
       LISTT=43+ISPIN
      ENDIF
      LISTW=26+ISPIN+LSTOFF
C
C    LOOP OVER IRREPS
C
      DO 1000 IRREP=1,NIRREP
C
C  GET LENGTHS OF VARIOUS ARRAYS AND
C  ALLOCATE CORE MEMORY
C
       NOCCSQ=0
       DO 1001 IRREPJ=1,NIRREP
        NOCCSQ=NOCCSQ+POP(IRREPJ)*POP(DIRPRD(IRREP,IRREPJ))
1001   CONTINUE
       DISSYW=IRPDPD(IRREP,ISYTYP(1,LISTW))
       DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
       NUMSYW=IRPDPD(IRREP,ISYTYP(2,LISTW))
       NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
       I001=1
       I002=I001+IINTFP*DISSYT*NOCCSQ
       I003=I002+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
       I004=I003+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
       I005=I004+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
       if (I005.LT.0) call trap_intovf('T2T1AA1',1)
       MAXSIZE=(MAXCOR-I005)/IINTFP
       IF(MIN(NUMSYW,NUMSYT,DISSYT).NE.0) THEN
C
C  WE ALWAYS NEED T2 AMPLITUDES. THEY ARE ASSUMED TO FIT INTO THE
C  MEMORY, GET THEM HERE AND EXPAND THE OCC.-OCC. BLOCK
C
       CALL GETLST(ICORE(I001),1,NUMSYT,1,IRREP,LISTT)
       CALL SYMEXP(IRREP,POP,DISSYT,ICORE(I001))
C
C    DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN CORE
C
       MAXDIS=MAXSIZE/DISSYW
C
C  CAN WE DO IT IN CORE ?
C
       IF(MAXDIS.GE.NUMSYW) THEN
C
C  IN CORE ALGORITHM
C
C   GET INTEGRALS <EF//AM> AND TRANSPOSE THE LAST TWO INDICES 
C 
        CALL GETLST(ICORE(I005),1,NUMSYW,2,IRREP,LISTW)
        CALL SYMTR1(IRREP,VRT,POP,DISSYW,ICORE(I005),ICORE(I002),
     &              ICORE(I003),ICORE(I004))
C
C  PERFORM MULTIPLICATION
C
        IOFFT=0
        IOFFW=0 
        IOFFS=1
        DO 100 IRREPJ=1,NIRREP 
         NVRTJ=VRT(IRREPJ)
         NOCCJ=POP(IRREPJ)
         IRREPI=DIRPRD(IRREPJ,IRREP)
         NOCCI=POP(IRREPI)
C 
         IF(MIN(NOCCI,NOCCJ,NVRTJ).NE.0) THEN
          CALL XGEMM('T','N',NVRTJ,NOCCJ,NOCCI*DISSYW,ONEM,
     &               ICORE(I005+IOFFW*IINTFP),DISSYW*NOCCI,
     &               ICORE(I001+IINTFP*IOFFT),DISSYT*NOCCI,ONE,
     &               W(IOFFS),NVRTJ)
         ENDIF
C
C  UPDATE OFFSETS
C
         IOFFT=IOFFT+NOCCI*NOCCJ*DISSYT
         IOFFW=IOFFW+NVRTJ*NOCCI*DISSYW
         IOFFS=IOFFS+NVRTJ*NOCCJ
100     CONTINUE
       ELSE 
C
C  OUT CORE ALGORITHM
C
C    DETERMINE FIRST OFSETS WITHIN THE T1 INCREMENTS
C
       IPT(1)=1
       DO 150 IRREPJ=1,NIRREP-1
        IPT(IRREPJ+1)=IPT(IRREPJ)+POP(IRREPJ)*VRT(IRREPJ)
150    CONTINUE
C
C  OFFSET FOR INTEGRAL LIST  AND FOR T2 AMPLITUDES
C
       IOFFSET=1
       IOFFT2=0
C
C  LOOP OVER THE IRREPS OF THE LAST INDEX
C
       DO 200 IRREPJ=1,NIRREP
C
        NOCCJ=POP(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NOCCI=POP(IRREPI)
        NVRTI=VRT(IRREPI)
        IF(MIN(NOCCI,NVRTI,NOCCJ).NE.0) THEN
C
C  MAXIMUM NUMBER OF (A<B,C) BLOCKS WHICH CAN BE HELD IN CORE
C
        DISMAX=MAXDIS/NVRTI
        IF(DISMAX.LE.0) STOP 'W4AA'
C
C  NUMBER OF (A<B,C) BLOCKS TO READ
C
        DISLEFT=NOCCJ 
C
10      CONTINUE
C
C NUMBER OF (A<B,C) BLOCKS WHICH ARE READ IN THIS PASS
C
         DISREAD=MIN(DISLEFT,DISMAX)
         DISLEFT=DISLEFT-DISREAD
C
C GET THE DISTRIBUTIONS FROM DISK
C
         CALL GETLST(ICORE(I005),IOFFSET,DISREAD*NVRTI,2,IRREP,LISTW)
C
C  UPDATE IOFFSET
C
         IOFFSET=IOFFSET+DISREAD*NVRTI
C
C  LOOP OVER ALL DISTRIBUTIONS AND PERFORM MULTIPLICATION
C
         IOFFW=0
         IOFFT1=IPT(IRREPI)
C
         DO 250 NUM=1,DISREAD
C
          CALL XGEMM('T','N',NVRTI,NOCCI,DISSYW,ONE,
     &               ICORE(I005+IINTFP*IOFFW),DISSYW, 
     &               ICORE(I001+IINTFP*IOFFT2),DISSYT,
     &               ONE,W(IOFFT1),NVRTI)
C
C   UPDATE OFFSETS
C
          IOFFW=IOFFW+DISSYW*NVRTI
          IOFFT2=IOFFT2+DISSYT*NOCCI
C
250      CONTINUE
C
C   IF NOT ALL (A<B,C) BLOCKS HAVE BEEN PROCESSED, GO TO 10
C
        IF(DISLEFT.NE.0) GO TO 10
C
        ELSE
C
C   UPDATE OFFSETS IN THE CASE NOTHING HAS BEEN DONE
C
         IOFFT2=IOFFT2+DISSYT*NOCCI*NOCCJ
         IOFFSET=IOFFSET+NOCCJ*NVRTI
        ENDIF
200    CONTINUE
C
      ENDIF    
      ENDIF
1000  CONTINUE
      RETURN
      END

      function streq(str1,str2,insensitive)
      implicit none
      logical streq
      character*(*) str1,str2
      logical insensitive
      integer l1,l2,i,strlen,ic1,ic2,d
      integer iachar, iBigA, iSmlA, iSmlZ
      character*1 achar
      iBigA=iachar('A')
      iSmlA=iachar('a')
      iSmlZ=iachar('z')
      d = iBigA-iSmlA
      streq=.false.
      l1=strlen(str1)
      l2=strlen(str2)
      if (l1.ne.l2) return
      do i=1,l1
         ic1=iachar(str1(i:i))
         ic2=iachar(str2(i:i))
         if (insensitive) then
            if (iSmlA.le.ic1 .and. ic1.le.iSmlZ) ic1=ic1+d
            if (iSmlA.le.ic2 .and. ic2.le.iSmlZ) ic2=ic2+d
         end if
         if (ic1.ne.ic2) return
      end do
      streq=.true.
      return
      end

c This routine performs tasks that should only be executed the first time joda
c is executed. Examples include initializing records that AMEs are expecting to
c exist and possibly checking for files that should not exist.

      subroutine firstrun
      implicit none

      call putrec(1,'JOBARC','JODADONE',1,0)
      call putrec(1,'JOBARC','FNDFDONE',1,1)

      return
      end

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine Driver(LUInt, NVMol, NAO, NSO, NCen, NOrbits, IOrdGp,
     $   SOAO, CenLbl, AngLbl, NAOOrb, NSOOrb, IAngBF, NAOWrk,
     $   IAOCen, NCenW1, NCenW2, Coord1, Coord2, CenMap, LScr, Scr,
     $   Scr2)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: driver.f,v 1.2 2005/03/09 16:50:21 yau Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     driver -- driver routine for VMol to JOBARC translation
C
C SYNOPSIS
      Integer LUInt, NAO, NSO, NCen, NOrbits, IOrdGp, Map
      Logical NVMol
      Integer LScr
      Double precision Scr(LScr, LScr), Scr2(LScr, LScr)
      Double precision SOAO(NAO, NAO)
      double precision xone,xzero
      Character*4 CenLbl(NSO), AngLbl(NSO)
      Integer NAOOrb(NSO), NSOOrb(NCen), IAngBF(NAO), NAOWrk(NAO)
      Integer IAOCen(NAO)
      Integer NCenW1(NCen), NCenW2(NCen), CenMap(NCen)
      Double precision Coord1(3, NCen), Coord2(3, IOrdGp-1)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Include 'mach.inc'
C $Id: driver.f,v 1.2 2005/03/09 16:50:21 yau Exp $
      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C     Include 'flags.inc'
C $Id: driver.f,v 1.2 2005/03/09 16:50:21 yau Exp $
      Integer IFlags(100), JFlags(16)
      Common /Flags/ IFlags
      Common /Flags3/ JFlags
C LOCAL VARIABLES
C     I       General use
C     L       General use
C     CmpPgp  Computational point group
C     IOrdGp  Order of the computational point group
C     S       Scaling factor for inverting SOAO
C     SEWARD  If it is true SEWARD integrals are being used.
C     ACESIII  If it is true ACESIII is used.
C
      Integer I, L, IACESIII
      LOGICAL SEWARD, ACESIII
      Character*4 CmpPgp
      Double precision S
C
        iErr = 0
      SEWARD = IFLAGS(56).EQ.4
      CALL GETREC(-1, "JOBARC", "AIIIJARC", 1, IACESIII)
      IF (IACESIII .GT. 0) ACESIII = .TRUE.
C
C
C     ***********************************
C     * Get the SO -> AO transformation *
C     ***********************************
C     "New VMol" supports spherical harmonic basis sets.  These generally
c     have rectangular SOAO matrices (because "contaminants" are usually
C     deleted) which cause problems when the time comes to invert them.
c     Fortunately, New VMol happens to write the SOAO entries for the
C     deleted orbitals after the true SOAO matrix (because I made it :-).
C     We need the whole matrix to do this stuff, so if its a New VMol
C     run, we use the dimensions to insure the whole matrix is read.
C
C     "Old VMol" never writes anything other than a NAOxNAO matrix.
C
C     Write both the "full" SOAO matrix out, in case anyone needs it,
C     and the regular rectangular one.  The record AO2SO is a misnomer
C     and should be changed (to SO2AO)!
C
      IF(SEWARD .OR. ACESIII)THEN
       CALL GETREC(20,'JOBARC','FULLSOAO',NAO*NAO*IINTFP,SOAO)
       Call PutRec( 20, 'JOBARC', 'AO2SO   ', NAO*NSO*IIntFP, SOAO)
      ELSE
       If (NVMol) then
          Call RdSOAO(LUInt, 'SYMTRANS', NVMol, NAO, NAO, SOAO, NAO)
          Call PutRec( 20, 'JOBARC', 'AO2SO   ', NAO*NSO*IIntFP, SOAO)
       Else
          Call RdSOAO(LUInt, 'SYMTRANS', NVMol, NAO, NAO, SOAO, NAO)
          Call PutRec( 20, 'JOBARC', 'AO2SO   ', NAO*NAO*IIntFP, SOAO)
       EndIf
       Call PutRec( 20, 'JOBARC', 'FULLSOAO', NAO*NAO*IIntFP, SOAO)
      ENDIF
C
cSSS      write(6,*) ' @DRIVER-I, Matrix SOAO (SYMTRANS) '
cSSS      CALL OUTPUT(SOAO,1,NAO,1,NAO,NAO,NAO,1)
C
C     **********************************
C     * Invert the SOAO transformation *
C     **********************************
C     The full inverse can, of course act to the left or right of SOAO.
C     The submatrix can only act on the LEFT of SOAO!
C
C     The record name of the submatrix, AO2SOINV, has been chosen to
C     complement the (misnamed) AO2SO.  This should be changed (to 
C     AO2SO) when AO2SO is changed!
C
C     Copy the full matrix this time, and invert it.
C
      Call SCopy(NAO*NAO, SOAO, 1, Scr, 1)
c OLD
c      Call MInv(Scr, NAO, NAO, Scr2, S, 1.0d-30, 0, 1)
c NEW
      iErr = 0
      Call DGETRF(NAO,NAO,Scr,NAO,Scr2,iErr)
      if (iErr.ne.0) then
         if (iErr.gt.0) then
            print *, '@DRIVER: factorized a singular matrix'
            if (iflags(62).eq.1) then
            print *, '         Restart with SPHERICAL=OFF.'
            else
            print *, '         Restart with SYMMETRY=OFF.'
            end if
         else
            print *, '@DRIVER: dgetrf argument ',-iErr,' is illegal'
         end if
         call errex
      end if
      Call DGETRI(NAO,Scr,NAO,Scr2,Scr2(1,2),LScr*(LScr-1),iErr)
      if (iErr.ne.0) then
         if (iErr.gt.0) then
            print *, '@DRIVER: inverted a singular matrix'
            if (iflags(62).eq.1) then
            print *, '         Restart with SPHERICAL=OFF.'
            else
            print *, '         Restart with SYMMETRY=OFF.'
            end if
         else
            print *, '@DRIVER: dgetri argument ',-iErr,' is illegal'
         end if
         call errex
      end if
c END
C
C     Write the full inverse and the submatrix without the deleted
C     functions
C
      Call PutRec( 20, 'JOBARC', 'FULLAOSO', NAO*NAO*IIntFP, Scr)
      Call BlkCpy2(Scr, NAO, NAO, Scr2, NSO, NAO, 1, 1)
      Call PutRec( 20, 'JOBARC', 'AO2SOINV', NSO*NAO*IIntFP, Scr2)
C
C     ******************************************************
C     * Create computational <-> cartesian transformations *
C     ******************************************************
C     Only need to do this if the computational basis is _not_
C     the full cartesian basis -- this is the only time the
C     CSYMTRAN record will be written by VMOL.  Otherwise the
C     transformation is the unit matrix, and we don't bother to
C     write it out.
C
      If (IFlags(62) .eq. 1 .OR. NSO .ne. NAO) then
C
C        Get the full cartesian SO -> AO transformation
C
         IF(SEWARD .OR. ACESIII)THEN
          CALL GETREC(20,'JOBARC','CSYMTRAN',NAO*NAO*IINTFP,SOAO)
         ELSE
          Call RdSOAO(LuInt, 'CSYMTRAN', NVMol, NAO, NAO, SOAO, NAO)
         ENDIF
C
cSSS         write(6,*) ' @DRIVER-I, Matrix SOAO (CSYMTRAN) '
cSSS         CALL OUTPUT(SOAO,1,NAO,1,NAO,NAO,NAO,1)
C
C        AO -> computational SO transformation is in Scr from above.
C        Multiply by cartesian SO -> AO on the right to get the
C        cartesian SO (columns) -> computational SO (rows) 
C        transformation.
C
         xone=1.0d0
         xzero=0.0d0
         Call XGEMM('N', 'N', NAO, NAO, NAO, xone, Scr, NAO,
     $      SOAO, NAO, xzero, Scr2, NAO)
C
C        Write the transformation including orbitals dropped in the
C        computational basis (CART3CMP) as well as the submatrix
C        corresponding to the true computational basis (CART2CMP).
C
         Call PutRec( 20, 'JOBARC', 'CART3CMP', NAO*NAO*IIntFP, Scr2)
         Call BlkCpy2(Scr2, NAO, NAO, Scr, NSO, NAO, 1, 1)
         Call PutRec( 20, 'JOBARC', 'CART2CMP', NSO*NAO*IIntFP, Scr)
C
cSSS         Call DGEWRL('N', NAO, NAO, Scr2, NAO, 0, 0, 'junk', 'junk',
cSSS     $      'Num', 'Num', 1, 6, 'Computational to cartesian', 80,
cSSS     $      'F12.6', I)
C
C        Once again, a non-unitary transformation, so we must invert it.
C
C        Then write the full (CMP3CART) and true (CMP2CART)
c        computational basis results.
C
c OLD
c         Call MInv( Scr2, NAO, NAO, Scr, S, 1.0d-30, 0, 1)
c NEW
         Call DGETRF(NAO,NAO,Scr2,NAO,Scr,iErr)
         if (iErr.ne.0) then
            if (iErr.gt.0) then
               print *, '@DRIVER: factorized a singular matrix'
               print *, '         Restart with SPHERICAL=OFF.'
            else
               print *, '@DRIVER: dgetrf argument ',-iErr,' is illegal'
            end if
            call errex
         end if
         Call DGETRI(NAO,Scr2,NAO,Scr,Scr(1,2),LScr*(LScr-1),iErr)
         if (iErr.ne.0) then
            if (iErr.gt.0) then
               print *, '@DRIVER: inverted a singular matrix'
               print *, '         Restart with SPHERICAL=OFF.'
            else
               print *, '@DRIVER: dgetri argument ',-iErr,' is illegal'
            end if
            call errex
         end if
c END
         Call PutRec( 20, 'JOBARC', 'CMP3CART', NAO*NAO*IIntFP, Scr2)
         Call PutRec( 20, 'JOBARC', 'CMP2CART', NAO*NSO*IIntFP, Scr2)
C
cSSS         Call DGEWRL('N', NAO, NAO, Scr2, NAO, 0, 0, 'junk', 'junk',
cSSS     $      'Num', 'Num', 1, 6, 'Inverse computational to cartesian',
cSSS     $      80, 'F12.6', I)
C
C        Restore the computational SO -> AO matrix, needed below
C
         Call GetRec( 20, 'JOBARC', 'FULLSOAO', NAO*NAO*IIntFP, SOAO)
       EndIf
C 
C     **********************************
C     * Read the basis function labels* 
C     ********************************** 
C
      Call RdBLab(LUInt, NVMol, NSO, CenLbl, AngLbl)
C
C     *******************************
C     * Analyze the SO basis labels *
C     *******************************
C     Uses SOAO and the SO basis functions labels to evaluate
C     ANGMOMBF, NBASATOM, and NAOBFORB
C
      Call GetAOSO(NVMol, NAO, NSO, SOAO, CenLbl, AngLbl, NAOOrb, 
     $   IAngBF, NAOWrk, NCen, NOrbits, NSOOrb)
C
      Call PutRec( 20, 'JOBARC', 'ANGMOMBF', NAO, IAngBF)
      Call PutRec( 20, 'JOBARC', 'NBASATOM', NOrbits, NSOOrb)
      Call PutRec( 20, 'JOBARC', 'NAOBFORB', NOrbits, NAOOrb)
C
C     ****************************************************
C     * Determine the mapping from VMol to ZMAT ordering *
C     ****************************************************
C     Uses a bunch of info about the centers to figure out the
C     relation between VMOl's center ordering and the ZMAT input.
C
      L = 1
      Call GetCRec( -1, 'JOBARC', 'COMPPTGP', 4, CMPPGP)
      Call GetRec( -1, 'JOBARC', 'COMPPOPV', NOrbits, NCenW1)
      Call GetRec( -1, 'JOBARC', 'COMPMEMB', NCen, NCenW2)
      L = 3 * NCen * IIntFP
      Call GetRec( -1, 'JOBARC', 'COORD   ', L, Coord1)
C
      Call Remap( CMPPGP, IORDGP, NCen, NOrbits, Coord1, Coord2,
     &               NCenW2, NCenW1, CenMap)
C
      Call PutRec( 20, 'JOBARC', 'MAP2ZMAT', NCen, CenMap)
C
C
C     ************************************************
C     * Imitate VMol for mapping from AOs to centers *
C     ************************************************
C     Requires the population of each orbit in the computational basis
C
      Call VBFCen(NOrbits, NCenW1, NAOOrb, IAOCen)
      Call PutRec(20, 'JOBARC', 'CENTERBF', NAO, IAOCen)
cSSSC
cSSSC     Reorder CENTERBF, already in core.
cSSSC
cSSS      Call ISctr(NAO, IDummy, ICheck, IAngCmp)
cSSS      Call PutRec(20, 'JOBARC', 'CNTERBF0', NAO, IAngCmp)
cSSS      Write (6, 9000) 'CNTERBF0', (i, IAngCmp(i), i = 1, NAO)
cSSSC
cSSSC     Reorder ANGMOMBF
cSSSC
cSSS      Call GetRec( 20, 'JOBARC', 'ANGMOMBF', NAO, IDummy)
cSSS      Call ISctr(NAO, IDummy, ICheck, IAngCmp)
cSSS      Call PutRec(20, 'JOBARC', 'ANMOMBF0', NAO, IAngCmp)
cSSS      Write (6, 9000) 'ANMOMBF0', (i, IAngCmp(i), i = 1, NAO)
cSSSC
cSSSC     Reorder the transformation; written back out by the caller.
cSSSC
cSSS      Do 100 I = 1, NAO
cSSS         Call SCOPY(NBas, Evec(i, 1), NAO, Scr( ICheck(i), 1), NAO)
cSSS 100  Continue
cSSS      Call SCOPY(NAO*NBas, Scr, 1, Evec, 1)
cSSSC
cSSS 9000 Format(1X,'new style ', A,':'/(2I5))
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_NHO_RESULTS
     +
     +                    ( UNITID,
     +                      NBAS,NATOM,NBOND,
     +                      NBOSIZE,
     +                      MXNBA,MXSHELL,
     +                      NHB,NCB,NRB,
     +                      NHA,NCA,NRA,
     +                      ZATOM,
     +                      RYD2HYB,
     +                      ATNHB,ATHVAL,ATHIDX,ATHOFF,
     +                      ATNCB,ATCIDX,ATCOFF,
     +                      ATNRB,ATRIDX,ATROFF,
     +                      HSHELL,CSHELL,RSHELL,
     +                      BDNCEN,BDCEN,BDNBAS,BDBAS,BDOCC,
     +                      COLMAP,NAOIDX,
     +                      ANGNHO,
     +                      H )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_NHO_RESULTS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints details of the final set of
C                natural hybrid orbitals (NHOs) to be used to establish
C                the natural bond orbitals (NBOs) to a file specified
C                by its unit identification number.
C
C                For each atomic center the following is printed:
C
C                   1) Expansion of NHOs in terms of the valence NAOs.
C
C                   2) NHO hybridization pattern.
C
C                  Input:
C
C                    UNITID       =  printout unit identification #
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atoms
C                    NBOND        =  total # of bonds
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    MXSHELL      =  largest l-shell value
C                    NxB          =  total # of Hybrid, Core and
C                                    Rydberg NAOs (x=H,C,R)
C                    NxA          =  total # of hybrid, core and
C                                    Rydberg atoms (x=H,C,R)
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    RYD2HYB      =  is true, if the Rydberg NAO space
C                                    has been included next to the
C                                    Valence NAO space for natural 
C                                    hybrid orbital (NHO) construction.
C                    ATNHB (A)    =  # of Hybrid NAOs on hybrid atom A.
C                    ATHVAL (A)   =  # of Valence NAOs on hybrid atom A.
C                    ATHIDX (A)   =  atomic index for hybrid atom A.
C                    ATHOFF (A)   =  index offset for Hybrid NAOs for
C                                    hybrid atom A. This index is equal
C                                    to the total number of Hybrid
C                                    NAOs on all hybrid atoms preceeding
C                                    hybrid atom A.
C                    ATNCB (A)    =  # of Core NAOs on core atom A.
C                    ATCIDX (A)   =  atomic index for core atom A.
C                    ATCOFF (A)   =  index offset for Core NAOs for
C                                    core atom A. This index is equal
C                                    to the total number of Core NAOs
C                                    on all core atoms preceeding
C                                    core atom A.
C                    ATNRB (A)    =  # of Rydberg NAOs on Rydberg atom A.
C                    ATRIDX (A)   =  atomic index for Rydberg atom A.
C                    ATROFF (A)   =  index offset for Rydberg NAOs
C                                    for Rydberg atom A. This index
C                                    is equal to the total number of
C                                    Rydberg NAOs on all Rydberg atoms
C                                    preceeding Rydberg atom A.
C                    HSHELL (I)   =  l-shell type for I-th Hybrid NAO.
C                    CSHELL (I)   =  l-shell type for I-th Core NAO.
C                    RSHELL (I)   =  l-shell type for I-th Rydberg NAO.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                    BDCEN (I,J)  =  I-th atomic center index for
C                                    J-th bond.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    J-th bond.
C                    BDBAS (I,J)  =  I-th global basis (NHO) index for
C                                    J-th bond.
C                    BDOCC (J)    =  # of occupied levels for J-th bond.
C                    COLMAP (I)   =  column map in the active sense,
C                                    such that COLMAP (I) contains the
C                                    position index of I-th NAO, based
C                                    on atomic order, in the NHB/NCB/NRB
C                                    order. This array is needed for
C                                    relating the printing of the NHOs
C                                    in terms of the original NAO
C                                    indices as they came out of the
C                                    NAO generation routine (i.e. before
C                                    the atomic -> NHB/NCB/NRB ordering.
C                    NAOIDX (I)   =  will contain the inverse of the
C                                    COLMAP array. Hence NAOIDX (I) will
C                                    contain the original NAO index
C                                    in the atomic order of the I-th
C                                    NHB/NCB/NRB reordered NAO.
C                    ANGNHO (J,L) =  NBAS x (MXSHELL+1) matrix
C                                    containing the sum of the square
C                                    of the NAO coefficients per L-type
C                                    angular momentum for the J-th NHO.
C                                    The NHO order is NHB/NCB/NRB.
C                    H (I,J)      =  MXNBA x NBAS matrix containing the
C                                    atomic NHOs. I is the local atomic
C                                    index labeling the atomic hybrid
C                                    NAOs from which the NHOs are
C                                    constructed. J is the global NHO
C                                    index running over all NHB/NCB/NRB
C                                    NHOs in that order, with all NHOs
C                                    belonging to a specific atomic
C                                    center being grouped together.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*2   ATCHAR
         CHARACTER*1   BAR,DASH

         CHARACTER*2   ATSYMB  (1:104)
         CHARACTER*1   HYBRID  (1:50)
         CHARACTER*3   LSYMB   (0:7)
         CHARACTER*7   NAOSYMB (0:2)

         LOGICAL     RYD2HYB

         INTEGER     ATIDX
         INTEGER     ATOM,BOND
         INTEGER     I,J,L
         INTEGER     LENGTH
         INTEGER     LTYPE
         INTEGER     MXNBA,MXSHELL
         INTEGER     NAO,NHO
         INTEGER     NATOM,NBOND
         INTEGER     NBAS
         INTEGER     NBOSIZE
         INTEGER     NOCC,NCEN,NNHO
         INTEGER     NHB,NCB,NRB
         INTEGER     NHA,NCA,NRA
         INTEGER     NHBA,NVBA,NCBA,NRBA
         INTEGER     NSHELL
         INTEGER     OFF
         INTEGER     UNITID
         INTEGER     ZVAL

         INTEGER     ATNHB  (1:NHA  )
         INTEGER     ATNCB  (1:NCA  )
         INTEGER     ATNRB  (1:NRA  )
         INTEGER     ATHIDX (1:NHA  )
         INTEGER     ATCIDX (1:NCA  )
         INTEGER     ATRIDX (1:NRA  )
         INTEGER     ATHOFF (1:NHA  )
         INTEGER     ATCOFF (1:NCA  )
         INTEGER     ATROFF (1:NRA  )
         INTEGER     ATHVAL (1:NHA  )
         INTEGER     BDNBAS (1:NHB  )
         INTEGER     BDNCEN (1:NHB  )
         INTEGER     BDOCC  (1:NHB  )
         INTEGER     COLMAP (1:NBAS )
         INTEGER     NAOIDX (1:NBAS )
         INTEGER     HSHELL (1:NHB  )
         INTEGER     CSHELL (1:NCB  )
         INTEGER     RSHELL (1:NRB  )
         INTEGER     ZATOM  (1:NATOM)

         INTEGER     BDBAS   (1:NBOSIZE,1:NHB)
         INTEGER     BDCEN   (1:NBOSIZE,1:NHB)

         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  W (0:7)

         DOUBLE PRECISION  ANGNHO (1:NBAS,0:MXSHELL)

         DOUBLE PRECISION  H (1:MXNBA,1:NBAS)

         DATA ATSYMB /' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     +                'Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca',
     +                'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     +                'Ga','Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr',
     +                'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     +                'Sb','Te',' I','Xe','Cs','Ba','La','Ce','Pr','Nd',
     +                'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     +                'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     +                'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     +                'Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     +                'Md','No','Lr','xx'/
         DATA  BAR     /'|'/
         DATA  DASH    /'-'/
         DATA  LSYMB   /' s ',' p ',' d ',' f ',' g ',' h ',' i ','> i'/
         DATA  NAOSYMB /'Rydberg','Valence','   Core'/

         PARAMETER  (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...before starting the print we generate the inverse
C                NAOIDX of the COLMAP array. Also we determine the
C                number of shells that will be considered for printing.
C
C
         DO I = 1,NBAS
            NAOIDX (COLMAP (I)) = I
         END DO

         NSHELL = MIN (MXSHELL,7)
C
C
C             ...print out title for valence part.
C
C
         WRITE (UNITID,8100) 'Valence Natural Hybrid Orbital Analysis'
 8100    FORMAT (//,10X,A39,//)
C
C
C             ...print out header line.
C
C
         WRITE (UNITID,9000) 'NHO #',BAR,'Atom',BAR,'Atom #',BAR,
     +                       'NAO #',BAR,'LM-state',BAR,'NAO-type',
     +                        BAR,'NAO coeffs',BAR,'Hybridization'
         WRITE (UNITID,9010) (DASH,I=1,83)
C
C
C             ...print out atomic valence NHO hybrid information.
C
C
         DO 1000 ATOM = 1,NHA
            OFF = ATHOFF (ATOM)
            NHBA = ATNHB (ATOM)
            NVBA = ATHVAL (ATOM)
            ATIDX = ATHIDX (ATOM)

            ZVAL = ZATOM (ATIDX)

            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            DO J = 1,NVBA
               NHO = OFF + J

               DO L = 0,NSHELL
                  W (L) = ANGNHO (NHO,L)
               END DO
               IF (MXSHELL.GT.7) THEN
                   DO L = 8,MXSHELL
                      W (7) = W (7) + ANGNHO (NHO,L)
                   END DO
               END IF

               CALL  NLO__FORM_NHO_HYBRID_PATTERN
     +
     +                    ( NSHELL,
     +                      W,
     +
     +                              LENGTH,
     +                              HYBRID )
     +
     +
               NAO = OFF + 1
               LTYPE = HSHELL (NAO)
               WRITE (UNITID,9020) NHO,BAR,ATCHAR,BAR,ATIDX,BAR,
     +                             NAOIDX (NAO),BAR,LSYMB (LTYPE),
     +                             BAR,NAOSYMB (1),BAR,H (1,NHO),
     +                             BAR,(HYBRID(I),I=1,LENGTH)
               DO I = 2,NVBA
                  NAO = OFF + I
                  LTYPE = HSHELL (NAO)
                  WRITE (UNITID,9030) BAR,BAR,BAR,NAOIDX (NAO),BAR,
     +                                LSYMB (LTYPE),BAR,NAOSYMB (1),
     +                                BAR,H (I,NHO),BAR
               END DO

               DO I = NVBA+1,NHBA
                  NAO = OFF + I
                  LTYPE = HSHELL (NAO)
                  WRITE (UNITID,9030) BAR,BAR,BAR,NAOIDX (NAO),BAR,
     +                                LSYMB (LTYPE),BAR,NAOSYMB (0),
     +                                BAR,H (I,NHO),BAR
               END DO

               WRITE (UNITID,9010) (DASH,I=1,83)

            END DO

 1000    CONTINUE
C
C
C             ...print out title for core part.
C
C
         WRITE (UNITID,8200) 'Core Natural Hybrid Orbital Analysis'
 8200    FORMAT (//,15X,A36,//)
C
C
C             ...print out header line.
C
C
         WRITE (UNITID,9000) 'NHO #',BAR,'Atom',BAR,'Atom #',BAR,
     +                       'NAO #',BAR,'LM-state',BAR,'NAO-type',
     +                        BAR,'NAO coeffs',BAR,'Hybridization'
         WRITE (UNITID,9010) (DASH,I=1,83)
C
C
C             ...print out atomic core NHO hybrid information.
C
C
         DO 2000 ATOM = 1,NCA
            OFF = ATCOFF (ATOM)
            NCBA = ATNCB (ATOM)
            ATIDX = ATCIDX (ATOM)

            ZVAL = ZATOM (ATIDX)

            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            DO J = 1,NCBA
               NHO = NHB + OFF + J

               DO L = 0,NSHELL
                  W (L) = ANGNHO (NHO,L)
               END DO
               IF (MXSHELL.GT.7) THEN
                   DO L = 8,MXSHELL
                      W (7) = W (7) + ANGNHO (NHO,L)
                   END DO
               END IF

               CALL  NLO__FORM_NHO_HYBRID_PATTERN
     +
     +                    ( NSHELL,
     +                      W,
     +
     +                              LENGTH,
     +                              HYBRID )
     +
     +
               NAO = OFF + 1
               LTYPE = CSHELL (NAO)
               WRITE (UNITID,9020) NHO,BAR,ATCHAR,BAR,ATIDX,BAR,
     +                             NAOIDX (NHB+NAO),BAR,LSYMB (LTYPE),
     +                             BAR,NAOSYMB (2),BAR,H (1,NHO),
     +                             BAR,(HYBRID(I),I=1,LENGTH)
               DO I = 2,NCBA
                  NAO = OFF + I
                  LTYPE = CSHELL (NAO)
                  WRITE (UNITID,9030) BAR,BAR,BAR,NAOIDX (NHB+NAO),BAR,
     +                                LSYMB (LTYPE),BAR,NAOSYMB (2),
     +                                BAR,H (I,NHO),BAR
               END DO

               WRITE (UNITID,9010) (DASH,I=1,83)

            END DO

 2000    CONTINUE
C
C
C             ...print out title for Rydberg part.
C
C
         WRITE (UNITID,8300) 'Rydberg Natural Hybrid Orbital Analysis'
 8300    FORMAT (//,10X,A39,//)
C
C
C             ...print out header line.
C
C
         WRITE (UNITID,9000) 'NHO #',BAR,'Atom',BAR,'Atom #',BAR,
     +                       'NAO #',BAR,'LM-state',BAR,'NAO-type',
     +                        BAR,'NAO coeffs',BAR,'Hybridization'
         WRITE (UNITID,9010) (DASH,I=1,83)
C
C
C             ...print out atomic Rydberg NHO hybrid information
C                sitting in the hybrid section (if any).
C
C
         IF (RYD2HYB) THEN

             DO 3000 ATOM = 1,NHA
                OFF = ATHOFF (ATOM)
                NHBA = ATNHB (ATOM)
                NVBA = ATHVAL (ATOM)
                NRBA = NHBA - NVBA
                ATIDX = ATHIDX (ATOM)

                ZVAL = ZATOM (ATIDX)

                IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                    ATCHAR = ATSYMB (104)
                ELSE
                    ATCHAR = ATSYMB (ZVAL)
                END IF

                DO J = 1,NRBA
                   NHO = OFF + NVBA + J

                   DO L = 0,NSHELL
                      W (L) = ANGNHO (NHO,L)
                   END DO
                   IF (MXSHELL.GT.7) THEN
                       DO L = 8,MXSHELL
                          W (7) = W (7) + ANGNHO (NHO,L)
                       END DO
                   END IF

                   CALL  NLO__FORM_NHO_HYBRID_PATTERN
     +
     +                        ( NSHELL,
     +                          W,
     +
     +                                  LENGTH,
     +                                  HYBRID )
     +
     +
                   NAO = OFF + 1
                   LTYPE = HSHELL (NAO)
                   WRITE (UNITID,9020) NHO,BAR,ATCHAR,BAR,ATIDX,BAR,
     +                                 NAOIDX (NAO),BAR,LSYMB (LTYPE),
     +                                 BAR,NAOSYMB (1),BAR,H (1,NHO),
     +                                 BAR,(HYBRID(I),I=1,LENGTH)
                   DO I = 2,NVBA
                      NAO = OFF + I
                      LTYPE = HSHELL (NAO)
                      WRITE (UNITID,9030) BAR,BAR,BAR,NAOIDX (NAO),
     +                                    BAR,LSYMB (LTYPE),BAR,
     +                                    NAOSYMB (1),BAR,H (I,NHO),BAR
                   END DO

                   DO I = NVBA+1,NHBA
                      NAO = OFF + I
                      LTYPE = HSHELL (NAO)
                      WRITE (UNITID,9030) BAR,BAR,BAR,NAOIDX (NAO),BAR,
     +                                    LSYMB (LTYPE),BAR,NAOSYMB (0),
     +                                    BAR,H (I,NHO),BAR
                   END DO

                   WRITE (UNITID,9010) (DASH,I=1,83)

                END DO

 3000        CONTINUE

         END IF
C
C
C             ...print out atomic Rydberg NHO hybrid information.
C
C
         DO 4000 ATOM = 1,NRA
            OFF = ATROFF (ATOM)
            NRBA = ATNRB (ATOM)
            ATIDX = ATRIDX (ATOM)

            ZVAL = ZATOM (ATIDX)

            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            DO J = 1,NRBA
               NHO = NHB + NCB + OFF + J

               DO L = 0,NSHELL
                  W (L) = ANGNHO (NHO,L)
               END DO
               IF (MXSHELL.GT.7) THEN
                   DO L = 8,MXSHELL
                      W (7) = W (7) + ANGNHO (NHO,L)
                   END DO
               END IF

               CALL  NLO__FORM_NHO_HYBRID_PATTERN
     +
     +                    ( NSHELL,
     +                      W,
     +
     +                              LENGTH,
     +                              HYBRID )
     +
     +
               NAO = OFF + 1
               LTYPE = RSHELL (NAO)
               WRITE (UNITID,9020) NHO,BAR,ATCHAR,BAR,ATIDX,BAR,
     +                             NAOIDX (NHB+NCB+NAO),BAR,
     +                             LSYMB (LTYPE),BAR,NAOSYMB (0),
     +                             BAR,H (1,NHO),BAR,
     +                             (HYBRID(I),I=1,LENGTH)
               DO I = 2,NRBA
                  NAO = OFF + I
                  LTYPE = RSHELL (NAO)
                  WRITE (UNITID,9030) BAR,BAR,BAR,NAOIDX (NHB+NCB+NAO),
     +                                BAR,LSYMB (LTYPE),BAR,NAOSYMB (0),
     +                                BAR,H (I,NHO),BAR
               END DO

               WRITE (UNITID,9010) (DASH,I=1,83)

            END DO

 4000    CONTINUE
C
C
C             ...formats for printing the atomic NHO information.
C
C
 9000    FORMAT (1X,A5,1X,  A1, 1X,A4,1X,  A1, 1X,A6,1X, A1,
     +           1X,A5,1X,  A1, 1X,A8,1X,  A1, 1X,A8,1X, A1,
     +           1X,A10,1X, A1, 2X,A13)
 9010    FORMAT (1X,83A1)
 9020    FORMAT (2X,I3,2X,    A1, 2X,A2,2X,  A1, 2X,I3,3X, A1,
     +           1X,I4,2X,    A1, 4X,A3,3X,  A1, 2X,A7,1X, A1,
     +           1X,F10.6,1X, A1, 2X,50(A1))
 9030    FORMAT (2X,3X,2X,    A1, 2X,2X,2X,  A1, 2X,3X,3X, A1,
     +           1X,I4,2X,    A1, 4X,A3,3X,  A1, 2X,A7,1X, A1,
     +           1X,F10.6,1X, A1)
C
C
C             ...print out the NHO angular momentum weight table.
C
C
         WRITE (UNITID,8400) 'NHO Angular Momentum Weight Table'
 8400    FORMAT (//,20X,A33)

         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows = NHOs ; Cols = L-value (1=s,2=p,...) ',
     +                  NBAS,MXSHELL+1,
     +                  NBAS,MXSHELL+1,
     +                  ANGNHO )
     +
     +
C
C
C             ...print out title.
C
C
         WRITE (UNITID,8000) 'Bond formation analysis'
 8000    FORMAT (//,20X,A23,//)
C
C
C             ...print out header line and bond formation
C                information # 1.
C
C
         WRITE (UNITID,9040) 'BOND #',BAR,'Occ #',BAR,
     +                       '# of Centers',BAR,'Atomic Centers  '
         WRITE (UNITID,9050) (DASH,I=1,62)

         DO BOND = 1,NBOND
            NOCC = BDOCC (BOND)
            NCEN = BDNCEN (BOND)
            WRITE (UNITID,9060) BOND,BAR,NOCC,BAR,NCEN,BAR,
     +                          (BDCEN (I,BOND),I=1,NCEN)
         END DO
         WRITE (UNITID,9050) (DASH,I=1,62)
C
C
C             ...print out header line and bond formation
C                information # 2.
C
C
         WRITE (UNITID,9040) 'BOND #',BAR,'Occ #',BAR,
     +                       '  # of NHOs ',BAR,'Bond NHO indices'
         WRITE (UNITID,9050) (DASH,I=1,62)

         DO BOND = 1,NBOND
            NOCC = BDOCC (BOND)
            NNHO = BDNBAS (BOND)
            WRITE (UNITID,9060) BOND,BAR,NOCC,BAR,NNHO,BAR,
     +                          (BDBAS (I,BOND),I=1,NNHO)
         END DO
         WRITE (UNITID,9050) (DASH,I=1,62)
C
C
C             ...formats for printing the bond formation information.
C
C
 9040    FORMAT (1X,A6,1X, A1, 1X,A5,1X,  A1, 1X,A12,1X, A1, 2X,A16)
 9050    FORMAT (1X,62A1)
 9060    FORMAT (2X,I4,2X, A1, 2X,I3,2X,  A1, 5X,I4,5X, A1, 2X,80(I4))
C
C
C             ...ready!
C
C
         RETURN
         END

#include "flags.h"
      SUBROUTINE SUMMARY(SCRATCH, RFAMAT, GRD, SCALE, STPMAG,
     &                   IQFIX, NOPT, NX, NXM6, IBREAK, ICONTL,
     &                   LUOUT, NCYCLE, LUDONE, BMATRIX,
     &                   HES_INTACT, FSCR, VEC, STEP)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
      integer ishell
      external ishell
      CHARACTER*5 a5, a5b
      CHARACTER*1 DISTANCE
      INTEGER TOTREDNCO
      DOUBLE PRECISION OPT_GEOMETRY
      LOGICAL bDonFil, skip, XYZIN, NWFINDIF, I_UNIQUE(MAXREDUNCO),
     &        Hessian_calcs, Geomopt_numrcl 
C
      DIMENSION SCRATCH(NX*NX), RFAMAT(NOPT, NOPT), VEC(NOPT),
     &          GRD(NXM6), BMATRIX(NXM6*NX), 
     &          HES_INTACT(NX*NX), FSCR(NX*NXM6),
     &          IREDUNCO(4, MAXREDUNCO), IQFIX(3*MXATMS, 3*MXATMS),
     &          STEP(NXM6) 
C
      COMMON /INPTYP/ XYZIN,NWFINDIF

C
#include "cbchar.com"
#include "coord.com"
C
      Common /Orient/ Orient(3,3)
c
#include "machsp.com"
C#define MONSTER_FLAGS /* use ioppar */
#include "jodaflags.com"
C
C Do some Printing
C
      WRITE(LUOUT, 88)STPMAG, SCALE
 88   FORMAT(T3,' Summary of Optimization Cycle: ',/,T3,
     &       ' The maximum unscaled ',
     &       'step is: ',F10.5,'.',/,T3,' Scale factor set to: ',
     &        F8.5,'.')
C
      WRITE(LUOUT, 93)
93    FORMAT(T3,' Forces are in hartree/bohr and hartree/radian.',
     &       /,T3,' Parameter values are in Angstroms and degrees.')
C
      WRITE(LUOUT, 81)
      WRITE(LuOut, 881)
      WRITE(LuOut, 81)
881   FORMAT(T3,'Parameter',T17,'dV/dR',T33,'Step',T47,'Rold',
     &       T63,'Rnew')
C
      DO 15 I=1, NOPT
C
         DO 23 J =1, I - 1
            IF (VARNAM(ISQUASH(NOPTI(I))) .EQ.
     &          VARNAM(ISQUASH(NOPTI(J)))) GOTO 15
 23      CONTINUE

         CNF = 180.0D0/DACOS(-1.D0)
         IF (.NOT. XYZIN) THEN
            IF (MOD(ISQUASH(NOPTI(I)),3) .EQ. 1) CNF = 0.529177249D0
         ELSE
            DISTANCE = VARNAM(NOPTI(I))
            IF (DISTANCE .EQ. "R")  CNF = 0.529177249D0
         ENDIF
         ZOP = SCRATCH(I) - SCRATCH(NOPT+I)

C
#ifdef _DEBUG_LVLM1
         WRITE(LUOUT, 84)VARNAM(ISQUASH(NOPTI(I))), GRD(NOPTI(I)),
     &                   SCRATCH(NOPT+I), ZOP,
     &                   SCRATCH(I)
#else
         WRITE(LUOUT, 84)VARNAM(ISQUASH(NOPTI(I))), GRD(NOPTI(I)),
     &                   SCRATCH(NOPT+I)*CNF, ZOP*CNF,
     &                   SCRATCH(I)*CNF
#endif
C
 15   CONTINUE
C
 84   FORMAT(T5,A,T10,4(F15.10,1X))
C
C Generate statistics based on gradients
C
      CALL ZERO(RFAMAT, NOPT*NOPT)
C
      DO 432 I =1, NOPT
         RFAMAT(I, 1) = GRD(NOPTI(I))
 432  CONTINUE
C
      CALL VSTAT(RFAMAT, SCRATCH(2*NOPT + 1), NOPT)
C
      WRITE(LUOUT,82) SCRATCH(2*NOPT + 2),SCRATCH(2*NOPT + 5)
 82   FORMAT(74('-'),/,T3,'Minimum force: ',F12.9,' / RMS force: ',
     &       F12.9)
 81   FORMAT(74('-'))
C
C see if the calcualtion has converged
C
      IF ( (SCRATCH(2*NOPT + 5) .LT. 10.D0**(-1*ICONTL) ) .AND.
     &     (IBREAK .EQ. 0)                                      ) THEN
C
         WRITE(6,1321)
 1321    FORMAT(80('-'))
         WRITE(6,1325)10.D0**(-1*ICONTL)
 1325    FORMAT(T3,' RMS gradient is below ',E10.5,'.')
         WRITE(6,1322)
 1322    FORMAT(T3,' Convergence criterion satisfied.  Optimization ',
     &      'completed.')
         WRITE(6,1321)

         CALL ADM

cmn
c write optimized values of coordinates in table
c for use with vibrational freq. calculation.
c
c The coordinates printed correspond to the geometry that generated the
c last set of energetics, i.e., the geometry whose gradient is below the
c convergence criterion.
C
         IF (Iflags2(h_IFLAGS2_geom_opt) .ge. 3) THEN
C
            write(6,*)
            write(6,*) '  Summary of optimized internal coordinates'
            write(6,*) '  (Angstroms and degrees)'
            write(6,*) (Iflags2(h_IFLAGS2_geom_opt))
            CALL GETREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)
            CALL GETREC(20, 'JOBARC', 'UNIQUEDF', TOTREDNCO, I_UNIQUE)
            CALL GETREC(20, 'JOBARC', 'CONTEVIT', 4*TOTREDNCO,
     &                  IREDUNCO)

            DO I=1,NOPT
            if (I_UNIQUE(NOPTI(I))) then

c            o remove spaces
               a5b=VARNAM(ISQUASH(NOPTI(I)))
               a5='     '
               l=0
               do k=1,5
                  if (a5b(k:k) .ne. ' ') then
                     l = l+1
                     a5(l:l) = a5b(k:k)
                  endif
               enddo

c >R01  :  2  1         =     1.0796431125
c >R03  :  4  1         =     1.3252448582
c >A01  :  2  1  3      =   116.8470115097
c >A02  :  2  1  4      =   121.5764336125
c >D01  :  5  4  1  2   =     0.0000000000
c >D02  :  5  4  1  3   =   180.0000000000

               INDEX = ISQUASH(NOPTI(I))
               DISTANCE = VARNAM(INDEX)
               OPT_GEOMETRY = SCRATCH(I) - SCRATCH(NOPT+I)
               IF (DISTANCE .EQ. "R") THEN
                  CNF = 0.529177249D0
                  WRITE(LUOUT, 9) a5, IREDUNCO(1, INDEX),
     &                            IREDUNCO(2, INDEX),
     &                            OPT_GEOMETRY*CNF
 9                FORMAT(A5,T6,':',2(1X,I2),9X,"=",F17.10)
               ELSE IF (DISTANCE .EQ. "A") THEN
                  CNF=180.D0/DACOS(-1.D0)
                  WRITE(LUOUT, 99) a5, IREDUNCO(1, INDEX),
     &                             IREDUNCO(2, INDEX),
     &                             IREDUNCO(3, INDEX),
     &                             OPT_GEOMETRY*CNF
 99               FORMAT(A5,T6,':',3(1X,I2),6X,'=',F17.10)
               ELSE
                  CNF=180.D0/DACOS(-1.D0)
                  WRITE(LUOUT, 999) a5, IREDUNCO(1, INDEX),
     &                              IREDUNCO(2, INDEX),
     &                              IREDUNCO(3, INDEX),
     &                              IREDUNCO(4, INDEX),
     &                              OPT_GEOMETRY*CNF
 999              FORMAT(A5,T6,':',4(1X,I2),3X,"=",F17.10)
               END IF

c           end if (I_UNIQUE(NOPTI(I)))
            end if
c           END DO I=1,NOPT
            END DO

c         o print out the Cartesian coordinate matrix (broken)
       write(6,*)
       write(6,*) ' Summary of optimized Cartesian coordinates (Ang) '
       write(6,*)
C 
            CALL GETREC(20, 'JOBARC', 'COORD_OP',3*NATOMS*IINTFP, Q)
C
            IOFF=1
            CNF = 0.529177249D0
            DO I=1,NATOMS
 1000          FORMAT(T6,A,T10,F14.8,T25,F14.8,T40,F14.8)
               WRITE(6,1000)ZSYM(I)(1:2),(Q(J)*CNF,J=IOFF,IOFF+2)
               IOFF=IOFF+3
            END DO

c ELSE IF (INTERNAL)

         ELSE IF (Iflags2(h_IFLAGS2_geom_opt) .EQ. 1) THEN
C
            write(6,*)
            write(6,*) '  Summary of optimized internal coordinates'
            write(6,*) '  (Angstroms and degrees)'
            write(6,*) (Iflags2(h_IFLAGS2_geom_opt))

            DO I=1,NOPT
               OPT_GEOMETRY = SCRATCH(I) - SCRATCH(NOPT+I)
               skip = .false.
               do J=1,I-1
                  skip = skip.or.
     &                   (VARNAM(ISQUASH(NOPTI(I))).EQ.
     &                    VARNAM(ISQUASH(NOPTI(J)))    )
               end do
            if (.not.skip) then
c            o remove spaces
               a5b=VARNAM(ISQUASH(NOPTI(I)))
               a5='     '
               l=0
               do k=1,5
                  if (a5b(k:k) .ne. ' ') then
                     l = l+1
                     a5(l:l) = a5b(k:k)
                  endif
               enddo
               IF (MOD(ISQUASH(NOPTI(I)),3).EQ.1) THEN
                  CNF=0.529177249D0
               ELSE
                  CNF=180.D0/DACOS(-1.D0)
               END IF
               WRITE(LuOut,184) A5, OPT_GEOMETRY*CNF
 184           FORMAT(A5,T6,'=',F17.10)
c           end if (.not.skip)
            end if
c           END DO I=1,NOPT
            END DO

c ELES IF (Pure Cartesian)
C
         ELSE IF (Iflags2(h_IFLAGS2_geom_opt) .EQ. 2) THEN
C
c    o print out the Cartesian coordinate matrix (broken)
            write(6,*) 
            write(6,"(a,a)") ' Summary of optimized Cartesian',
     &                          ' coordinates (Angs) '
            write(6,*) 
C      
            CALL GETREC(20, 'JOBARC', 'COORD_OP',3*NATOMS*IINTFP, Q)
C           
            IOFF=1
            CNF = 0.529177249D0
            DO I=1,NATOMS
               WRITE(6,1000)ZSYM(I)(1:2),(Q(J)*CNF,J=IOFF,IOFF+2)
               IOFF=IOFF+3
            END DO
C
C ENDIF (Iflags2(h_IFLAGS2_geom_opt))
C
         ENDIF
         WRITE(LUOUT,*)
cmn end

C      o Let's also update the archive file.
C
C Unpak the scratch array and regenerate the full R vector. Also
C unpak the step vector to avoid any problems with Hessian updates  
C in the next cycle.
C
         DO J = 1, NOPT
C
            INDEX = ISQUASH(NOPTI(J))
            DISTANCE = VARNAM(INDEX)
            IF (DISTANCE .EQ. "R") THEN
               CNF = 0.529177249D0
            ELSE IF (DISTANCE .EQ. "A") THEN
               CNF=180.D0/DACOS(-1.D0)
            ELSE
               CNF=180.D0/DACOS(-1.D0)
            END IF

            R(NOPTI(J))    = (SCRATCH(J) - SCRATCH(NOPT+J))
            STEP(NOPTI(J)) = SCRATCH(J + NOPT)
C
            DO K=1, NEQ(NOPTI(J))
C
               STEP(IQFIX(NOPTI(J), K)) = SCRATCH(J + NOPT)
               R(IQFIX(NOPTI(J), K))    = (SCRATCH(J) - 
     &                                     SCRATCH(NOPT+J))
            ENDDO
         ENDDO
C
C The following calls do anything useful only when the optimizations
C are done numerically, and diretcly followed by frequency calculation
C with analytical or numerical second derivatives.
C What we need is the Cartesian coordinates of the optimized geometry
C in COORD jobarc record. In the case of analytical optimizations the
C previous step correspond to the optimized geometry and this call
C is simply a duplication. However, that is not the case for 
C numerical optimizations (the record contains the coordinates of the
C last dispalced point). Note to Anthony: this will effect the
C tests that use numerical gradients. 
C 
         Call Getrec(20, 'JOBARC', 'IFLAGS  ', 100, Iflags)
         Call Getrec(20, 'JOBARC', 'IFLAGS2 ', 500, Iflags2)
         Hessian_calcs   =  (Iflags(h_IFLAGS_vib) .NE. 0)
         Geomopt_numrcl  =  (Iflags2(h_IFLAGS2_grad_calc) .EQ. 2
     &                      .AND. Iflags2(h_IFLAGS2_geom_opt)
     &                      .NE. 0)
c
#ifdef _DEBUG_LVL0
         Write(6,*), "The internal coord:"
         Write(6,10), (R(I), I=1, NXM6)
         Write(6,*)
         Write(6,*), "The step size:"
         Write(6,*)
         Write(6,10)   (STEP(I), I=1, NXM6)
         Write(6,*)
         Print*, "The optimization cycle:", NCYCLE
         Print*, "Joda flag, grad_calc and geoom_opt",
     &            Iflags2(h_IFLAGS2_grad_calc),
     &            Iflags2(h_IFLAGS2_geom_opt) 
         Print*, "Internal flags; Hessian & geo. optimization:",
     &            Hessian_calcs,  Geomopt_numrcl 
  10     Format(5(1X,F10.6))
#endif
c
         If (Hessian_calcs .OR. Geomopt_numrcl) Then 
            Call GMetry(.TRUE., .FALSE.)
            IStart = 1
            Iscr   = Istart + NX*3
            IQtmp  = Iscr   + NX
            IQnew  = IQtmp  + NX

            Call Symmetry(Scratch(Istart), Scratch(Iscr), 
     &                    Scratch(IQtmp), .FALSE.)
            Call Putrec(20, 'JOBARC', 'COORD   ', NX*IINTFP, Q)
            Call Putrec(20, 'JOBARC', 'CORD_INT', NX*IINTFP, R)
#ifdef _DEBUG_LVL0
         Write(6,*)
         Print*, "The variable from summary" 
         Write(6,20), "The Cartesian coord:", (Q(i), i=1, NX)
   20    Format(A20, 3(1X, F10.6))

#endif
         Endif
c
c         call Putrec(20, 'JOBARC', 'CYCL2CON', 1, NCYCLE)
c         call archive(0.0D0, GRD, HES_INTACT, STEP, 0, VEC)
c
C Marshall's request to provide the frequencies of the updated Hessian
C might be a good idea. The frequencies of the updated Hessian at the
C last step might give a clue about the character of the stationary
C point. If this approx. test passes, then the expensive "exact"
C frequency calculation should be done. Ajith Perera, 05/2005.

         CALL GEN_APPROX_FREQ(SCRATCH, BMATRIX, FSCR, HES_INTACT)

c      o signal the end of the calculation
         call getrec(1,'JOBARC','JODADONE',1,i)
         if (i.ne.0) then
            print *, '@SUMMARY: JODADONE is already true.'
            print *, '          Something is very wrong.'
         end if
         call putrec(1,'JOBARC','JODADONE',1,1)
         call putrec(1,'JOBARC','HAVEGEOM',1,1)

c      o remove the backup directory
         call rm_backup

         CALL ACES_JA_FIN
         STOP

      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE STRIPDUM(IPTR,ATMASS,NATOM,NTOTAL,NSYOP,IHOLD)
C
C STRIP DUMMY ATOMS OUT OF PERMUTATION ARRAY
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION IPTR(NTOTAL,NSYOP),ATMASS(*),IMAPZ2R(150)
      DIMENSION IMAPR2Z(150),IHOLD(NTOTAL,NSYOP)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
      CALL DGETREC(20,'JOBARC','ATOMMASS',NTOTAL,ATMASS)
c      CALL IZERO(IMAPZ2R,NTOTAL*NSYOP)
      do i = 1, NTOTAL*NSYOP
         IMAPZ2R(i) = 0
         IMAPR2Z(i) = 0
      enddo

c      CALL IZERO(IMAPR2Z,NTOTAL*NSYOP)
      CALL ICOPY (NTOTAL*NSYOP, IPTR, 1, IHOLD, 1)

      IREAL=0
      DO 10 IATOM=1,NTOTAL
       IF(ATMASS(IATOM).NE.0.0D0)THEN
        IREAL=IREAL+1
        IMAPR2Z(IREAL)=IATOM
        IMAPZ2R(IATOM)=IREAL
       ENDIF
10    CONTINUE
C
      DO 20 IOP=1,NSYOP
       DO 30 IATOM=1,NATOM
        JATOM=IMAPR2Z(IATOM)
        KATOM=IHOLD(JATOM,IOP)
        IPTR(IATOM,IOP)=IMAPZ2R(KATOM)
30     CONTINUE
20    CONTINUE
C
      RETURN
      END        

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine xcopy(n,dx,incx,dy,incy)
      double precision dx(*),dy(*)
#ifdef ACES64
      integer*8 n, incx, incy
#else
      integer n, incx, incy
#endif
      integer i,ix,iy

         ix = 1
         iy = 1
         if(incx.lt.0)ix = (-n+1)*incx + 1
         if(incy.lt.0)iy = (-n+1)*incy + 1
         do i = 1,n
           dy(iy) = dx(ix)
           ix = ix + incx
           iy = iy + incy
         end do
      return
      end

c This routine converts seconds (in doubles) to hours, minutes, and seconds.

c INPUT
c double SECS : the number of seconds to convert

c OUTPUT
c int HH, MM : the hours and minutes in SECS
c double SS  : the remaining seconds

c#define _DEBUG_DS2HMS

      subroutine ds2hms(secs,hh,mm,ss)
      implicit none

c ARGUMENTS
      double precision secs, ss
      integer hh, mm

c PARAMETERS
      double precision s2h, s2m
      parameter (s2h=(1.d0/3600.d0), s2m=(1.d0/60.d0))

c INTERNAL VARIABLES
      double precision s
      integer h, m

c ----------------------------------------------------------------------

      s = secs
      h = s * s2h
      s = -(3600*h) + s
      m = s * s2m
      s = -(60*m) + s

      hh = h
      mm = m
      ss = s

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine igetrec(iFlag,szArchive,szRecName,iRecLen,iDest)
c-----------------------------------------------------------------------------
c   Reads integer data from JOBARC file.
c
c   Note: The data on JOBARC is stored as integer*8 for compatibility with
c         the serial ACES II program's format.  So this subroutine converts
c         the data read from JOBARC into the internal integer format and
c         returns it in iDest.
c
c   iflag > 0 --> an existing record is retrieved, length stored in iRecLen.
c         = 0 --> record length is returned (or -1 if record doesn't exist).
c         < 0 --> existing record is retrieved or iDest(1:iRecLen) is cleared.
c-----------------------------------------------------------------------------

      implicit none

      integer iFlag, iRecLen, iDest(*)
      character*(*) szArchive, szRecName

#include "jobarc.h"
      integer i

c-----------------------------------------------------------------------------
c   Call getrec to get the raw data.
c-----------------------------------------------------------------------------

      if (iFlag .eq. 0) then
         call getrec(iFlag,szArchive,szRecName,iRecLen,iDest)
      else
         call igetrec_work(iFlag,szArchive,szRecName,iRecLen,iDest) 
      endif

      return
      end
      subroutine igetrec_work(iFlag,szArchive,szRecName,iRecLen,iDest)
c-----------------------------------------------------------------------------
c   Reads integer data from JOBARC file.
c
c   Note: The data on JOBARC is stored as integer*8 for compatibility with
c         the serial ACES II program's format.  So this subroutine converts
c         the data read from JOBARC into the internal integer format and
c         returns it in iDest.
c
c   iflag > 0 --> an existing record is retrieved, length stored in iRecLen.
c         < 0 --> existing record is retrieved or iDest(1:iRecLen) is cleared.
c-----------------------------------------------------------------------------

      implicit none

      integer iFlag, iRecLen, iDest(*)
      character*(*) szArchive, szRecName

#include "jobarc.h"
      integer*8 idest8(iRecLen)
      integer i

c-----------------------------------------------------------------------------
c   Call getrec to get the raw data.
c-----------------------------------------------------------------------------

      call getrec(iFlag,szArchive,szRecName,iRecLen,iDest8)
         
c-----------------------------------------------------------------------------
c   Convert the data.
c-----------------------------------------------------------------------------

      do i = 1, iRecLen
         iDest(i) = iDest8(i)
      enddo 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__DERV_INT2D_TO_0000
     +
     +                    ( NGQP,NEXQ,NGQEXQ,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_INT2D_TO_0000
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of
C                derivative eris [00|00], adding up the contributions
C                from all the derivative 2D 0000 integrals.
C
C                Special routine for the [00|00] eri cases.
C
C
C                  Input:
C
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    INT2Dx      =  all current 2D 0000 derivative
C                                   integrals for each cartesian
C                                   component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1       =  scratch array holding intermediate
C                                   2D 0000 derivative integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive [00|00]
C                                   derivative integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     M,N,R
         INTEGER     NGQP,NEXQ,NGQEXQ

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    DO M = 1,NEXQ
            BATCH (M) = INT2DX (M) * SCALE (M)
         END DO

         IF (DIFFY) THEN
             DO M = 1,NEXQ
                BATCH (M) = BATCH (M) * INT2DY (M)
             END DO
         END IF

         IF (DIFFZ) THEN
             DO M = 1,NEXQ
                BATCH (M) = BATCH (M) * INT2DZ (M)
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
                R = R + 2
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
                R = R + 2
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
                R = R + 2
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
                R = R + 2
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
                R = R + 3
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
                R = R + 3
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
                R = R + 3
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
                R = R + 3
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
     +                      + TEMP1 (R+3)
                R = R + 4
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
                R = R + 4
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
     +                      + TEMP1 (R+3) * INT2DY (R+3)
                R = R + 4
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
                R = R + 4
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
     +                      + TEMP1 (R+3)
     +                      + TEMP1 (R+4)
                R = R + 5
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
                R = R + 5
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
     +                      + TEMP1 (R+3) * INT2DY (R+3)
     +                      + TEMP1 (R+4) * INT2DY (R+4)
                R = R + 5
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
                R = R + 5
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
     +                      + TEMP1 (R+3)
     +                      + TEMP1 (R+4)
     +                      + TEMP1 (R+5)
                R = R + 6
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
                R = R + 6
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
     +                      + TEMP1 (R+3) * INT2DY (R+3)
     +                      + TEMP1 (R+4) * INT2DY (R+4)
     +                      + TEMP1 (R+5) * INT2DY (R+5)
                R = R + 6
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
                R = R + 6
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
     +                      + TEMP1 (R+3)
     +                      + TEMP1 (R+4)
     +                      + TEMP1 (R+5)
     +                      + TEMP1 (R+6)
                R = R + 7
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
     +                      + TEMP1 (R+6) * INT2DZ (R+6)
                R = R + 7
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
     +                      + TEMP1 (R+3) * INT2DY (R+3)
     +                      + TEMP1 (R+4) * INT2DY (R+4)
     +                      + TEMP1 (R+5) * INT2DY (R+5)
     +                      + TEMP1 (R+6) * INT2DY (R+6)
                R = R + 7
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
     +                      + TEMP1 (R+6) * INT2DZ (R+6)
                R = R + 7
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
     +                      + TEMP1 (R+3)
     +                      + TEMP1 (R+4)
     +                      + TEMP1 (R+5)
     +                      + TEMP1 (R+6)
     +                      + TEMP1 (R+7)
                R = R + 8
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
     +                      + TEMP1 (R+6) * INT2DZ (R+6)
     +                      + TEMP1 (R+7) * INT2DZ (R+7)
                R = R + 8
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
     +                      + TEMP1 (R+3) * INT2DY (R+3)
     +                      + TEMP1 (R+4) * INT2DY (R+4)
     +                      + TEMP1 (R+5) * INT2DY (R+5)
     +                      + TEMP1 (R+6) * INT2DY (R+6)
     +                      + TEMP1 (R+7) * INT2DY (R+7)
                R = R + 8
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
     +                      + TEMP1 (R+6) * INT2DZ (R+6)
     +                      + TEMP1 (R+7) * INT2DZ (R+7)
                R = R + 8
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)
     +                      + TEMP1 (R+1)
     +                      + TEMP1 (R+2)
     +                      + TEMP1 (R+3)
     +                      + TEMP1 (R+4)
     +                      + TEMP1 (R+5)
     +                      + TEMP1 (R+6)
     +                      + TEMP1 (R+7)
     +                      + TEMP1 (R+8)
                R = R + 9
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
     +                      + TEMP1 (R+6) * INT2DZ (R+6)
     +                      + TEMP1 (R+7) * INT2DZ (R+7)
     +                      + TEMP1 (R+8) * INT2DZ (R+8)
                R = R + 9
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DY (R)
     +                      + TEMP1 (R+1) * INT2DY (R+1)
     +                      + TEMP1 (R+2) * INT2DY (R+2)
     +                      + TEMP1 (R+3) * INT2DY (R+3)
     +                      + TEMP1 (R+4) * INT2DY (R+4)
     +                      + TEMP1 (R+5) * INT2DY (R+5)
     +                      + TEMP1 (R+6) * INT2DY (R+6)
     +                      + TEMP1 (R+7) * INT2DY (R+7)
     +                      + TEMP1 (R+8) * INT2DY (R+8)
                R = R + 9
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 1
             DO M = 1,NEXQ
                BATCH (M) =   TEMP1 (R)   * INT2DZ (R)
     +                      + TEMP1 (R+1) * INT2DZ (R+1)
     +                      + TEMP1 (R+2) * INT2DZ (R+2)
     +                      + TEMP1 (R+3) * INT2DZ (R+3)
     +                      + TEMP1 (R+4) * INT2DZ (R+4)
     +                      + TEMP1 (R+5) * INT2DZ (R+5)
     +                      + TEMP1 (R+6) * INT2DZ (R+6)
     +                      + TEMP1 (R+7) * INT2DZ (R+7)
     +                      + TEMP1 (R+8) * INT2DZ (R+8)
                R = R + 9
             END DO
         END IF

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C
   10    DO M = 1,NGQEXQ
            TEMP1 (M) = SCALE (M) * INT2DX (M)
         END DO

         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             R = 0
             DO M = 1,NEXQ
                SUM = ZERO
                DO N = 1,NGQP
                   SUM = SUM + TEMP1 (R+N)
                END DO
                R = R + NGQP
                BATCH (M) = SUM
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             R = 0
             DO M = 1,NEXQ
                SUM = ZERO
                DO N = 1,NGQP
                   SUM = SUM + TEMP1 (R+N) * INT2DZ (R+N)
                END DO
                R = R + NGQP
                BATCH (M) = SUM
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             R = 0
             DO M = 1,NEXQ
                SUM = ZERO
                DO N = 1,NGQP
                   SUM = SUM + TEMP1 (R+N) * INT2DY (R+N)
                END DO
                R = R + NGQP
                BATCH (M) = SUM
             END DO
         ELSE
             DO N = 1,NGQEXQ
                TEMP1 (N) = TEMP1 (N) * INT2DY (N)
             END DO
             R = 0
             DO M = 1,NEXQ
                SUM = ZERO
                DO N = 1,NGQP
                   SUM = SUM + TEMP1 (R+N) * INT2DZ (R+N)
                END DO
                R = R + NGQP
                BATCH (M) = SUM
             END DO
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE BULT_BNDCRD(CARTCOORD, BMATRX, DISTAB, ICON1,  
     &                       ICON2, IBNDS, TOTREDNCO, NRATMS)
C         
C Setup the bond stretching B-matrix elements. 
C B(*,i,j)(x,y,z) = (x_i,y_i,z_i - x_j,y_j,z_j)/|Rij|
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      INTEGER TOTREDNCO
      DIMENSION CARTCOORD(3*NRATMS), BMATRX(TOTREDNCO, 3*NRATMS)
C     
      DISTAB = DIST(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2))
C
      DO 10 IXYZ = 1, 3
C
         DIFFAB = CARTCOORD((3*ICON1 - 3) + IXYZ)
     &             - CARTCOORD((3*ICON2 -3) + IXYZ)
         BMATRX(IBNDS, (3*ICON1 - 3) + IXYZ) =  DIFFAB/DISTAB
         BMATRX(IBNDS, (3*ICON2 - 3) + IXYZ) = -DIFFAB/DISTAB
C
 10   CONTINUE

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__CTR_2INDEX_REORDER
     +
     +                    ( NXYZT,NCTR,
     +                      NCGTOR,NCGTOS,
     +                      IXOFFI,IXOFFJ,
     +                      X,
     +
     +                             Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__CTR_2INDEX_REORDER
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine reorders the 2 contraction indices r,s:
C
C                        x (nxyzt,rs) --> y (nxyzt,ij)
C
C                such that the contraction indices correspond to the
C                final ordering of the batch.
C
C
C                  Input:
C
C                      NXYZT      =  total # of cartesian monomial
C                                    quadruplets (invariant indices)
C                      NCTR       =  total # of contraction indices
C                      NCGTOx     =  # of contractions for contraction
C                                    shells x=R,S
C                      IXOFFx     =  index offsets for contraction
C                                    shells x=I,J
C                      X          =  original integral batch with
C                                    contraction shells in RS order
C
C                  Output:
C
C                      Y          =  new integral batch with contraction
C                                    shells in IJ order
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     J,IJ
         INTEGER     IXOFFI,IXOFFJ
         INTEGER     N,R,S
         INTEGER     NCGTOR,NCGTOS
         INTEGER     NCTR
         INTEGER     NXYZT
         INTEGER     RS

         DOUBLE PRECISION  X (1:NXYZT,1:NCTR)
         DOUBLE PRECISION  Y (1:NXYZT,1:NCTR)
C
C
C------------------------------------------------------------------------
C
C
C             ...do the reordering.
C
C
         RS = 0

         J = - IXOFFJ + 1
         DO 100 S = 1,NCGTOS
            J = J + IXOFFJ
            IJ = J - IXOFFI
            DO 200 R = 1,NCGTOR
               IJ = IJ + IXOFFI
               RS = RS + 1

               DO N = 1,NXYZT
                  Y (N,IJ) = X (N,RS)
               END DO

  200       CONTINUE
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__GEN_EIGSYS_REAL_SYMMETRIC
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDROWS,DDCOLS,
     +                      DDVECD,
     +                      N,
     +                      REVERS,
     +
     +                              D,
     +                              S,
     +                              X )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__GEN_EIGSYS_REAL_SYMMETRIC
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : Computation of all eigenvalues and corresponding
C                eigenvectors of a real symmetric generalized
C                eigenvalue problem:
C
C
C                             Ax = cSx
C
C
C                where A is symmetric and S is symmetric and positive
C                definite.
C
C
C                Procedure:
C                ----------
C
C                The matrix S is decomposed into: S = B * B (T), where
C                B is a lower triangular matrix and (T) denotes
C                transposition. Then the above generalized eigenvalue
C                problem can be rewritten as:
C
C
C                   {B(inv) A B(inv,T)} {B(T) x}   =   c {B(T) x}
C
C
C                where (inv) denotes inversion. Hence we obtained
C                an ordinary eigenvalue problem, which can be solved
C                by a conventional technique.
C
C
C                  Input:
C
C                   DDROWz = row dimensions for matrices X and S
C                            (z = X,S)
C                   DDCOLz = column dimensions for matrices X and S
C                            (z = X,S)
C                   DDVECD = dimension for vector D containing the
C                            eigenvalues
C                        N = order of the matrix X to be diagonalized
C                        X = matrix to be diagonalized
C                        S = overlap matrix (must be positive definite)
C                   REVERS = if false, eigenvalues and associated
C                            eigenvectors are in ascending sequence,
C                            otherwise this ordering is reversed.
C
C                  Output:
C
C                        D = computed eigenvalues, in specified order
C                        X = matrix of corresponding eigenvectors,
C                            columnwise.
C
C                Only the lower triangle of X and S need to be
C                supplied. However, both X and S will be destroyed
C                during the diagonalization process!!!
C
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         LOGICAL   REVERS

         INTEGER   DDROWX,DDCOLX,DDROWS,DDCOLS,DDVECD
         INTEGER   I,J,L,N

         DOUBLE PRECISION   DELTA
         DOUBLE PRECISION   ONE
         DOUBLE PRECISION   ROOT
         DOUBLE PRECISION   SII
         DOUBLE PRECISION   SQRARG
         DOUBLE PRECISION   SUM
         DOUBLE PRECISION   ZERO

         DOUBLE PRECISION   D (1:DDVECD)

         DOUBLE PRECISION   S (1:DDROWS,1:DDCOLS)
         DOUBLE PRECISION   X (1:DDROWX,1:DDCOLX)

         DATA   DELTA    /1.D-17/
         DATA   ZERO     /0.D0 /
         DATA   ONE      /1.D0 /
C
C
C------------------------------------------------------------------------
C
C
C             ...check passed dimensions.
C
C
         IF ( N.GT.DDROWX .OR. N.GT.DDCOLX )  THEN
              WRITE (1,*) ' Dimension of matrix X too small: '
              WRITE (1,*) ' mat__gen_eigsys_real_symmetric '
              WRITE (1,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
              WRITE (*,*) ' Dimension of matrix X too small: '
              WRITE (*,*) ' mat__gen_eigsys_real_symmetric '
              WRITE (*,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
              STOP
         END IF

         IF ( N.GT.DDROWS .OR. N.GT.DDCOLS )  THEN
              WRITE (1,*) ' Dimension of overlap matrix S too small: '
              WRITE (1,*) ' mat__gen_eigsys_real_symmetric '
              WRITE (1,*) ' DDROWS,DDCOLS,N = ',DDROWS,DDCOLS,N
              WRITE (*,*) ' Dimension of overlap matrix S too small: '
              WRITE (*,*) ' mat__gen_eigsys_real_symmetric '
              WRITE (*,*) ' DDROWS,DDCOLS,N = ',DDROWS,DDCOLS,N
              STOP
         END IF

         IF ( N.GT.DDVECD )  THEN
              WRITE (1,*) ' Dimension of vector D too small: '
              WRITE (1,*) ' mat__gen_eigsys_real_symmetric '
              WRITE (1,*) ' DDVECD,N = ',DDVECD,N
              WRITE (*,*) ' Dimension of vector D too small: '
              WRITE (*,*) ' mat__gen_eigsys_real_symmetric '
              WRITE (*,*) ' DDVECD,N = ',DDVECD,N
              STOP
         END IF
C
C
C             ...determine B from S via a Cholesky decomposition
C                and place B in upper part of S array.
C
C
          IF ( S (1,1).LE.DELTA ) THEN
               WRITE (*,*) ' S matrix not (enough) +ve definite! '
               WRITE (*,*) ' mat__gen_eigsys_real_symmetric '
               WRITE (*,*) ' Square root argument = ',S (1,1)
               WRITE (1,*) ' S matrix not (enough) +ve definite! '
               WRITE (1,*) ' mat__gen_eigsys_real_symmetric '
               WRITE (1,*) ' Square root argument = ',S (1,1)
               STOP
          END IF

          ROOT  =  DSQRT ( S (1,1) )
          S (1,1)  =  ROOT

          DO  10  I = 2,N
              S (1,I)  =  S (I,1) / ROOT
   10     CONTINUE

          DO  20  J = 2,N

              SQRARG  =  S (J,J)
              DO  30  L = 1,J-1
                  SQRARG  =  SQRARG  -  S (L,J) ** 2
   30         CONTINUE

              IF ( SQRARG.LE.DELTA ) THEN
                   WRITE (*,*) ' S matrix not (enough) +ve definite! '
                   WRITE (*,*) ' mat__gen_eigsys_real_symmetric '
                   WRITE (*,*) ' Square root argument = ',SQRARG
                   WRITE (1,*) ' S matrix not (enough) +ve definite! '
                   WRITE (1,*) ' mat__gen_eigsys_real_symmetric '
                   WRITE (1,*) ' Square root argument = ',SQRARG
                   STOP
              END IF

              ROOT  =  DSQRT (SQRARG)
              S (J,J)  =  ROOT

              DO  40  I = J+1,N
                  SUM  =  S (I,J)
                  DO  50  L = 1,J-1
                      SUM  =  SUM  -  S (L,I) * S (L,J)
   50             CONTINUE
                  S (J,I)  =  SUM / ROOT
   40         CONTINUE

   20     CONTINUE
C
C
C
C             ...calculate next the product:  C = B(inv) A B(inv,T).
C                First observe that, since the result is symmetric,
C                we need to calculate only the upper triangle of C.
C                From this follows, since B(inv) is lower triangular,
C                that one only needs to calculate the lower triangle
C                of the product: B(inv) A. Hence, the following two
C                steps are performed:
C
C                  1) Form lower triangle of:  B(inv) A  and store
C                     the result in the upper part of X
C                
C                  2) Premultiply the result of 1) by B(inv) by
C                     overwriting the upper part of X
C                
C                After 1) and 2) the upper triangle of C calculated
C                sits in the upper triangle of X.
C
C                Note further, that actual calculation of B(inv) is
C                not needed. This matrix is 'calculated' in an
C                implicit way from B, using its nice lower triangular
C                property.
C
C
C
          DO  100  I = 1,N
              SII  =  S (I,I)
              DO  200  J = I,N
                  SUM  =  X (J,I)
                  DO  300  L = 1,I-1
                      SUM  =  SUM  -  S (L,I) * X (L,J)
  300             CONTINUE
                  X (I,J)  =  SUM / SII
  200         CONTINUE
  100     CONTINUE

          DO  400  J = 1,N
          DO  400  I = J,N
              SUM  =  X (J,I)
              DO  500  L = J,I-1
                  SUM  =  SUM  -  X (J,L) * S (L,I)
  500         CONTINUE
              DO  600  L = 1,J-1
                  SUM  =  SUM  -  X (L,J) * S (L,I)
  600         CONTINUE
              X (J,I)  =  SUM / S (I,I)
  400     CONTINUE
C
C
C             ...move upper triangle of X to lower triangle of X
C                to be able to call the standard diagonalization
C                routine.
C
C
          DO  700  I = 1,N
          DO  700  J = I,N
              X (J,I) = X (I,J)
  700     CONTINUE

          CALL    MAT__DIAGONALIZE_REAL_SYMMETRIC
     +
     +                 ( DDROWX,DDCOLX,DDVECD,
     +                   N,
     +                   REVERS,
     +
     +                        D,
     +                        X )
     +
     +
C
C
C             ...transform back the eigenvectors of the standard case
C                to the eigenvectors of the general case by making the
C                product:  B(inv,T) X  and overwriting X.
C
C
          DO  800  J = 1,N
          DO  800  I = N,1,-1
              SUM  =  X (I,J)
              DO  900  L = I+1,N
                  SUM  =  SUM  -  S (I,L) * X (L,J)
  900         CONTINUE
              X (I,J)  =  SUM / S (I,I)
  800     CONTINUE
C
C
C             ...finished!
C
C
          RETURN
          END

      SUBROUTINE MTRANSP(A,AT,NR,NC,NTR,NTC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NR,NC),AT(NC,NR)
      DO I=1,NTR
      DO J=1,NTC
         AT(J,I)=A(I,J)
      END DO
      END DO
      RETURN
      END

       SUBROUTINE SST003(WIN,WOUT,NSIZIN,NSIZOT,ISCR,SPTYPE,RERDTP)
C
C THIS ROUTINE ACCEPTS A SYMMETRY PACKED FOUR-INDEX LIST AND RETURNS
C   THE SAME LIST BUT WITH AN ALTERNATIVE SCHEME FOR SYMMETRY PACKING.
C
C THE LIST (A<B;I<J) IS PRESUMED TO BE PACKED AB-IJ.  THIS ROUTINE RETURNS
C   THE LIST AS (A,I;B,J) PACKED AS AI-BJ OR AJ-BI (THESE POSSIBILITIES
C   DIFFER BY A SIGN).
C
C *** IMPORTANT *** : THE SPACE ALLOCATED FOR BOTH WIN AND WOUT IN THE
C                     CALLING ROUTINE MUST BE EQUAL TO THE SIZE OF
C                     *WOUT*
C
C INPUT: 
C           WIN  - THE SYMMETRY PACKED AB-IJ LIST.
C         NSIZIN - THE TOTAL SIZE OF THE SYM. PACKED INPUT VECTOR.
C         NSIZOT - THE TOTAL SIZE OF THE SYM. PACKED OUTPUT VECTOR.
C         SPTYPE - THE SPIN TYPE FOR THE INPUT LIST
C
C                        'AAAA' FOR (AB-IJ)
C                        'BBBB' FOR (ab-ij)
C         RERDTP - 'AIBJ' FOR AI-BJ POSITIVE, 'AJBI' FOR AJ-BI POSITIVE.
C OUTPUT: 
C          WOUT  - THE SYMMETRY PACKED AI-bj OR bj-AI LIST.
C       
C SCRATCH:
C         ISCR   - SCRATCH AREA TO HOLD THE SYMMETRY VECTORS AND INVERSE
C                   SYMMETRY VECTORS WHICH ARE NEEDED. 
C                   (SIZE: NVRT*(NVRT-1)/2+NOCC*(NOCC-1)/2+NOCC*NVRT)
C         
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*4 REORTP,SPTYPE,RERDTP
      DOUBLE PRECISION WIN(NSIZIN),WOUT(NSIZOT),ISCR(*)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYMINF/NSTART,NIRREP,IRREP0(255,2),DIRPRD(8,8)
      COMMON/SYMPOP/IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
C
      IRREPX=1
C
      IF(SPTYPE.EQ.'AAAA')THEN
       ISPIN=1
      ELSEIF(SPTYPE.EQ.'BBBB')THEN
       ISPIN=2
      ELSE
       WRITE(6,1000)SPTYPE
1000   FORMAT(T3,'@SST003-F, Unknown spin type ',A4,' passed in.')
       CALL ERREX
      ENDIF
C
      IF(RERDTP.EQ.'AIBJ')THEN
       REORTP='1324'
      ELSEIF(RERDTP.EQ.'AJBI')THEN
       REORTP='1423'
      ELSE
       WRITE(6,1001)RERDTP
1001   FORMAT(T3,'@SST003-F, Unknown reorder type ',A4,' passed in.')
       CALL ERREX
      ENDIF
C
C EXPAND LIST FROM A<B,I<J TO AB,IJ
C
      IOFFT=1
      IOFFF=1
      DO 10 IRREPR=1,NIRREP
       IRREPL=DIRPRD(IRREPX,IRREPR)
       DISSZT=IRPDPD(IRREPL,ISPIN)
       NUMDST=IRPDPD(IRREPR,2+ISPIN)
       DISSZF=IRPDPD(IRREPL,18+ISPIN)
       NUMDSF=IRPDPD(IRREPR,20+ISPIN)
       CALL SCOPY(NUMDST*DISSZT,WIN(IOFFT),1,WOUT(IOFFF),1)
       CALL SYMEXP (IRREPR,POP(1,ISPIN),DISSZT,WOUT(IOFFF)) 
       CALL SYMEXP2(IRREPL,VRT(1,ISPIN),DISSZF,DISSZT,NUMDSF,
     &              WOUT(IOFFF),WOUT(IOFFF))
       IOFFF=IOFFF+NUMDSF*DISSZF
       IOFFT=IOFFT+NUMDST*DISSZT
10    CONTINUE
      ITOTSZF=IOFFF-1
      CALL SCOPY(ITOTSZF,WOUT,1,WIN,1)
C
      CALL SSTGEN(WIN,WOUT,ITOTSZF,VRT(1,ISPIN),VRT(1,ISPIN),
     &            POP(1,ISPIN),POP(1,ISPIN),ISCR,IRREPX,REORTP)
C
      RETURN
      END

C
      LOGICAL FUNCTION CHECK_PM_PAIR(IBGN, IMD1, IMD2, IEND, JEND, 
     &                             SAME_PLANE, NATOMS)
      INTEGER NATOMS
      LOGICAL SAME_PLANE(NATOMS), SM_PLANE_BM, SM_PLANE_END
     
CSSS      WRITE(6,*) IBGN, IMD1, IMD2, IEND, JEND

      IF (IEND .EQ. IBGN .OR. IEND .EQ. IMD1 .OR. IEND. EQ. IMD2)
     &    THEN
          CHECK_PM_PAIR = .FALSE. 
          RETURN
      ENDIF
      IF (JEND .EQ. IBGN .OR. JEND .EQ. IMD1 .OR. JEND. EQ. IMD2)
     &    THEN 
          CHECK_PM_PAIR = .FALSE. 
          RETURN
      ENDIF
C
      IF (SAME_PLANE(IBGN) .AND. SAME_PLANE(IMD1) .AND. 
     &    SAME_PLANE(IMD2)) SM_PLANE_BM = .TRUE.
      
      SM_PLANE_END = SAME_PLANE(IEND) .AND.  SAME_PLANE(JEND)
CSSS      WRITE(6,*) SM_PLANE_BM, SM_PLANE_END
     
      IF ((SM_PLANE_BM .AND. SM_PLANE_END) .OR. (.NOT. 
     &     SM_PLANE_BM .AND. .NOT. SM_PLANE_END)) THEN
          CHECK_PM_PAIR = .FALSE.
          RETURN
      ENDIF
      IF ((SM_PLANE_BM .AND. .NOT. SM_PLANE_END) .OR. (.NOT. 
     &    SM_PLANE_BM .AND. SM_PLANE_END)) THEN
          CHECK_PM_PAIR = .TRUE.
          RETURN
      ENDIF
     
      END

      SUBROUTINE PERPOP(T,QREF,SCRATCH,ATMASS,NATOM,NORD,SYMTOL,IFOUND)
C
C THIS ROUTINE CHECKS TO SEE IF THERE IS A C2 AXIS IN THE XY
C PLANE FOR THE COORDINATES GIVEN IN QREF.  
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*1 T
      DIMENSION QREF(3*NATOM),ATMASS(NATOM),NORD(NATOM),SCRATCH(1)
      DIMENSION RM(9)
C
      DATA ONE,ZILCH /1.0D+00,0.0D+00/
C
      IFOUND=0
      I1=3*NATOM+1
C
C FIRST IDENTIFY AN ATOM WHICH HAS A NONZERO PROJECTION IN THE XY PLANE
C
      IPERM=0
      DO 10 I=1,NATOM
       XCOR=QREF((I-1)*3+1)*ATMASS(I)
       YCOR=QREF((I-1)*3+2)*ATMASS(I)
       ZCOR=QREF((I-1)*3+3)*ATMASS(I)
       IF(MAX(ABS(XCOR),ABS(YCOR)).GT.SYMTOL.AND.IPERM.EQ.0)THEN
        IPERM=I
        ZMATCH=ZCOR
        IPOS0=(I-1)*3+1
       ENDIF
10    CONTINUE
C
C NOW LOOP OVER ALL ATOMS HAVING THE SAME ATOMIC NUMBER AND Z
C  COORDINATES WITH OPPOSITE SIGNS AND TEST FOR C2 THROUGH BISECTOR
C
      DO 11 I=1,NATOM
       IF(I.NE.IPERM.AND.ATMASS(I).NE.ZILCH)THEN
        ZCOR=QREF((I-1)*3+3)*ATMASS(I)
        IF(T.EQ.'C')CHECK=ZCOR+ZMATCH
        IF(T.EQ.'P')CHECK=ZCOR-ZMATCH
        IF(ABS(CHECK).LT.SYMTOL)THEN
C
C FIND POSITION OF BISECTING LINE AND ROTATE SYSTEM SO THAT IT LIES
C  ALONG THE X AXIS.  
C
         CALL ALONGX(QREF((I-1)*3+1),QREF(IPOS0),RM,IERR)
         IF(IERR.NE.-1)THEN
          CALL MTRAN2(RM,3)
C
CJDW 1/6/98. Replace MATMULV call by XGEMM call. SCRATCH=(RM)^T * QREF.
C
C         CALL MATMULV(SCRATCH,QREF,RM,NATOM,3,3)
C
          CALL XGEMM('T','N',3,NATOM,3,ONE,RM,3,QREF,3,ZILCH,SCRATCH,3)
C
C NOW CHECK TO SEE IF THIS IS A AXIS OR AN X->-X PLANE
C
          IF(T.EQ.'C')THEN
           CALL DOSYOP('C',2,1,1,NATOM,SCRATCH,SCRATCH(I1),IDUM,0)
          ELSEIF(T.EQ.'P')THEN
           CALL DOSYOP('P',1,1,2,NATOM,SCRATCH,SCRATCH(I1),IDUM,0)
          ELSE
           WRITE(6,1000)T
1000       FORMAT(T3,'@PERPOP-F, Operation type ',A,' unknown.')
           CALL ERREX
          ENDIF
          CALL COMPARE(SCRATCH(I1),SCRATCH,ATMASS,NORD,NATOM,ICOMPX,
     &                  SYMTOL)
          IF(ICOMPX.EQ.0)THEN
           CALL SCOPY(3*NATOM,SCRATCH,1,QREF,1)
           IFOUND=1
          ENDIF
         ENDIF
        ENDIF
       ENDIF
11    CONTINUE
C
      RETURN
      END   

      SUBROUTINE REMOVE(NATOMS,NATMS,NUC,COORD,COORD2,NUC2)
C     
C     This routine removes dummy and ghost atoms from the molecule
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION NUC(NATOMS),COORD(3*NATOMS),
     $     COORD2(3*NATOMS),NUC2(NATOMS)
C     
      ICNT=0
      DO 10 IATM=1,NATOMS
         IF (NUC(IATM).NE.0) THEN
            ICNT=ICNT+1
            NUC2(ICNT)=NUC(IATM)
            DO 20 I=1,3
               COORD2((ICNT-1)*3+I)=COORD((IATM-1)*3+I)
 20         CONTINUE
         END IF
 10   CONTINUE
      NATMS=ICNT
      RETURN
      END
      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_sip_blocksize(blocksize, numblocks)
c-------------------------------------------------------------------------
c   Dummy routine to return blocksize, depending on value of 
c   algorithm_flag.
c-------------------------------------------------------------------------

      implicit none
      include 'int_gen_parms.h'

      integer blocksize, numblocks
      integer get_blkmgr_blocksize
      integer get_blkmgr_numblocks

      blocksize = get_blkmgr_blocksize(0)
      numblocks = get_blkmgr_numblocks(0)
      return
      end
  

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      program test_compare
c-------------------------------------------------------------------------
c   Program to compare test results with that found in a standardized
c   database of results.
c-------------------------------------------------------------------------

      implicit none
      include 'mpif.h'

      integer ios, lenenv, ierr
      integer argc, f_iargc
      integer i, n, nw, ntitle, nkey
      integer str_trimlen 
      integer me, mpierr
      double precision jobarc_vals(1000)
      double precision rvalue, rmserr

      character*256 db_fname, envvar
      character*20 test_name
      character*80 title, line, key

c--------------------------------------------------------------------------
c   Initialize mpi.
c--------------------------------------------------------------------------

      call mpi_init(mpierr)
      call mpi_comm_rank(mpi_comm_world, me, mpierr)
      if (me .ne. 0) go to 500

c--------------------------------------------------------------------------
c   Initialize ACES2 file system, open JOBARC.
c--------------------------------------------------------------------------

      call init_machine_types()
      call aces_init_rte()
      call aces_ja_init()

c--------------------------------------------------------------------------
c   Get ACES_EXE_PATH environment variable.  Test database should be in 
c   this directory.
c--------------------------------------------------------------------------

      call c_getenv('ACES_EXE_PATH'//char(0), envvar, lenenv, ierr)
      if (ierr .ne. 0) then
         print *,'Error: ACES_EXE_PATH env. variable was not found.'
         stop
      endif

      db_fname = envvar(1:lenenv) // '/' // 'test_results'

c--------------------------------------------------------------------------
c   Open database of test results.
c--------------------------------------------------------------------------

      open (unit=20,file=db_fname,status='OLD',err=1000,iostat=ios)

c---------------------------------------------------------------------------
c   Get command-line argument.  This tells us which test we are doing.
c---------------------------------------------------------------------------

      argc = f_iargc()
      call f_getarg(1, test_name)
      n = str_trimlen(test_name)

c----------------------------------------------------------------------------
c   Search the database for this test.
c----------------------------------------------------------------------------

   10 continue
      read (unit=20, fmt=50, end=100 ) line
      if (line(1:n) .ne. test_name(1:n)) go to 10

c----------------------------------------------------------------------------
c   Test was found.  Read the next line. 
c----------------------------------------------------------------------------

      ntitle = str_trimlen(line) 
      title = line (1:ntitle)
      read (unit=20,fmt=50) line
   50 format(a80)

      do i = 1, 80
         if (line(i:i) .eq. ' ') then
            nkey = i-1
            read (line(i+1:80),'(i3)') nw
            go to 70
         else
            key(i:i) = line(i:i)
         endif
      enddo
  70  continue 

      call dgetrec(1,'JOBARC', key(1:nkey), nw, jobarc_vals)

c----------------------------------------------------------------------------
c   Calculate the RMS error between the standardized values and those 
c   found on JOBARC.
c----------------------------------------------------------------------------

      rmserr = 0.d0
      do i = 1, nw
         read (unit=20,fmt=9000) rvalue
         rmserr = rmserr + (rvalue-jobarc_vals(i)) * 
     *                     (rvalue-jobarc_vals(i))  
      enddo 

      rmserr = dsqrt(rmserr) / dble(nw)

c---------------------------------------------------------------------------
c   Print the test result.
c---------------------------------------------------------------------------

      print *,'TEST ',title(1:ntitle),' RMS error ',rmserr       
  100 continue
      call aces_ja_fin() 

  500 continue
      call mpi_barrier(mpi_comm_world, mpierr)
      call mpi_finalize(mpierr)
      stop

 1000 continue
      print *,'Error: Cannot open test database: status = ',ios
      print *,'Test database filename ',db_fname
      stop
 9000 format(g20.12)
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine comp_return_derv_xyz(type,z, da1, da2, db1, db2, nsend)

c---------------------------------------------------------------------------
c  Computes the set of OED derivative moment integrals   
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'dbugcom.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      double precision dsum
      integer type, icount
      integer nsend 
      integer da1, da2, db1, db2
      integer adim, bdim 
      double precision z(da1:da2, db1:db2)

      double precision dbuf(1), temp
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf(1), dbuf(1))
#endif

      integer i, ix, m, n, nfirst, nints, nalpha, ncoeff, iatom, ncsum
      integer nalpha_pack, npcoeff_pack

      integer component
      integer a, b, a1,a2,b1,b2,lastao, igrad
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer xmomder, ymomder, zmomder
      integer ind(2)
      integer ierr 

      integer flopcount
      logical spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, y, fact 

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter, dcoord

      spherical = (ispherical .eq. 1)
      lastao = end_nfps(nshells)

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      if (dbg) 
     *  write(6,*) ' Entering comp_return_derv_xyz jatom jx ', 
     *               jatom,jx,jcenter 

c --------------------------------------------------------------------------- 
c  Set up send data. 
c --------------------------------------------------------------------------- 

      adim = da2-da1+1
      bdim = db2-db1+1 

      nsend = adim*bdim
      if (nsend .lt. 0) then
         print *,'ERROR IN COMP_RETURN_DERV_XYZ ',me,' nsend = ',nsend
         print *,'adim,bdim = ',adim,bdim
         call abort_job()
      endif 

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do b = db1,db2
      do a = da1,da2
         Z(a,b) = 0.D0
      enddo
      enddo

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: comp_return_derv_xyz requires ERD ',
     *           'integral package.'
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)
      
c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       do m = m1, m2
       do n = n1, n2

c         if ((atom(m) .eq. jatom) .and. (atom(n) .eq. jatom)) 
c    *       go to 333  

c         if ((atom(m) .ne. jatom) .and. (atom(n) .ne. jatom)) 
c    *       go to 333  

            ncsum = ncfps(m) + ncfps(n) 
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)
 
            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)


            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff),
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend),
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

             do ix = 1, 2  ! Centers

             der1x = 0
             der1y = 0
             der1z = 0
             der2x = 0
             der2y = 0
             der2z = 0

c            if (atom(m) .eq. jatom) then 
c               if (jx .eq. 1) der1x = 1 
c               if (jx .eq. 2) der1y = 1 
c               if (jx .eq. 3) der1z = 1 
c            endif 

c            if (atom(n) .eq. jatom) then 
c               if (jx .eq. 1) der2x = 1 
c               if (jx .eq. 2) der2y = 1 
c               if (jx .eq. 3) der2z = 1 
c            endif 

             if ((ix .eq. 1) .and. (atom(m) .ne. jatom)) go to 777 
             if ((ix .eq. 2) .and. (atom(n) .ne. jatom)) go to 777 

             if (jx .eq. 1) then
                if (ix .eq. 1) then
                   der1x = 1
C                   if (atom(m) .eq. atom(n)) der2x = 1
                else
                   der2x = 1
C                   if (atom(m) .eq. atom(n)) der1x = 1
                endif
             endif

             if (jx .eq. 2) then
                if (ix .eq. 1) then
                   der1y = 1
C                   if (atom(m) .eq. atom(n)) der2y = 1
                else
                   der2y = 1
C                   if (atom(m) .eq. atom(n)) der1y = 1
                endif
             endif

             if (jx .eq. 3) then
                if (ix .eq. 1) then
                   der1z = 1
C                   if (atom(m) .eq. atom(n)) der2z = 1
                else
                   der2z = 1
C                   if (atom(m) .eq. atom(n)) der1z = 1
                endif
             endif

             xmomder = 0
             ymomder = 0
             zmomder = 0
             if ( type .eq. 1 ) xmomder = 1
             if ( type .eq. 2 ) ymomder = 1
             if ( type .eq. 3 ) zmomder = 1

             call oed__gener_xyz_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z,
     *                 xmomder, ymomder, zmomder,
     *                 alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .false., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))


            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

               fact = 1.0d0 

               call add_integrals2(z, da1,da2,db1,db2,
     *                   dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2,fact)

             endif ! (nints .gt. 0) then

777          continue 

         enddo ! ix

333      continue 
         enddo   ! n shells
         enddo   ! m shells

7000  continue 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK BALANC
      SUBROUTINE BALANC (NM, N, A, LOW, IGH, SCALE)
C***BEGIN PROLOGUE  BALANC
C***PURPOSE  Balance a real general matrix and isolate eigenvalues
C            whenever possible.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1A
C***TYPE      DOUBLE PRECISION (BALANC-S, CBAL-C)
C***KEYWORDS  EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure BALANCE,
C     NUM. MATH. 13, 293-304(1969) by Parlett and Reinsch.
C     HANDBOOK FOR AUTO. COMP., Vol.II-LINEAR ALGEBRA, 315-326(1971).
C
C     This subroutine balances a REAL*8 matrix and isolates
C     eigenvalues whenever possible.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, A, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains the input matrix to be balanced.  A is a
C          two-dimensional REAL*8 array, dimensioned A(NM,N).
C
C     On OUTPUT
C
C        A contains the balanced matrix.
C
C        LOW and IGH are two INTEGER variables such that A(I,J)
C          is equal to zero if
C           (1) I is greater than J and
C           (2) J=1,...,LOW-1 or I=IGH+1,...,N.
C
C        SCALE contains information determining the permutations and
C          scaling factors used.  SCALE is a one-dimensional REAL*8 array,
C          dimensioned SCALE(N).
C
C     Suppose that the principal submatrix in rows LOW through IGH
C     has been balanced, that P(J) denotes the index interchanged
C     with J during the permutation step, and that the elements
C     of the diagonal matrix used are denoted by D(I,J).  Then
C        SCALE(J) = P(J),    for J = 1,...,LOW-1
C                 = D(J,J),      J = LOW,...,IGH
C                 = P(J)         J = IGH+1,...,N.
C     The order in which the interchanges are made is N to IGH+1,
C     then 1 TO LOW-1.
C
C     Note that 1 is returned for IGH if IGH is zero formally.
C
C     The ALGOL procedure EXC contained in BALANCE appears in
C     BALANC  in line.  (Note that the ALGOL roles of identifiers
C     K,L have been reversed.)
C
C     Questions and comments should be directed to B. S. Garbow,
C     Applied Mathematics Division, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  BALANC
C
#ifdef ACES64
      INTEGER*8 I,J,K,L,M,N,JJ,NM,IGH,LOW,IEXC
#else
      INTEGER I,J,K,L,M,N,JJ,NM,IGH,LOW,IEXC
#endif
      DOUBLE PRECISION A(NM,*),SCALE(*)
      DOUBLE PRECISION C,F,G,R,S,B2,RADIX
      double precision tol
      LOGICAL NOCONV
C
C***FIRST EXECUTABLE STATEMENT  BALANC
      RADIX = 16.0D0
      tol = 1.d-08
C
      B2 = RADIX * RADIX
      K = 1
      L = N
      GO TO 100
C     .......... IN-LINE PROCEDURE FOR ROW AND
C                COLUMN EXCHANGE ..........
   20 SCALE(M) = J
      IF (J .EQ. M) GO TO 50
C
      DO 30 I = 1, L
         F = A(I,J)
         A(I,J) = A(I,M)
         A(I,M) = F
   30 CONTINUE
C
      DO 40 I = K, N
         F = A(J,I)
         A(J,I) = A(M,I)
         A(M,I) = F
   40 CONTINUE
C
   50 GO TO (80,130), IEXC
C     .......... SEARCH FOR ROWS ISOLATING AN EIGENVALUE
C                AND PUSH THEM DOWN ..........
   80 IF (L .EQ. 1) GO TO 280
      L = L - 1
C     .......... FOR J=L STEP -1 UNTIL 1 DO -- ..........
  100 DO 120 JJ = 1, L
         J = L + 1 - JJ
C
         DO 110 I = 1, L
            IF (I .EQ. J) GO TO 110
            IF (A(J,I) .NE. 0.0D0) GO TO 120
  110    CONTINUE
C
         M = L
         IEXC = 1
         GO TO 20
  120 CONTINUE
C
      GO TO 140
C     .......... SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE
C                AND PUSH THEM LEFT ..........
  130 K = K + 1
C
  140 DO 170 J = K, L
C
         DO 150 I = K, L
            IF (I .EQ. J) GO TO 150
            IF (A(I,J) .NE. 0.0D0) GO TO 170
  150    CONTINUE
C
         M = K
         IEXC = 2
         GO TO 20
  170 CONTINUE
C     .......... NOW BALANCE THE SUBMATRIX IN ROWS K TO L ..........
      DO 180 I = K, L
  180 SCALE(I) = 1.0D0
C     .......... ITERATIVE LOOP FOR NORM REDUCTION ..........
  190 NOCONV = .FALSE.
C
      DO 270 I = K, L
         C = 0.0D0
         R = 0.0D0
C
         DO 200 J = K, L
            IF (J .EQ. I) GO TO 200
            C = C + ABS(A(J,I))
            R = R + ABS(A(I,J))
  200    CONTINUE
C     .......... GUARD AGAINST ZERO C OR R DUE TO UNDERFLOW ..........
c         IF (C .EQ. 0.0D0 .OR. R .EQ. 0.0D0) GO TO 270
         if (dabs(c) .lt. tol .or. dabs(r) .lt. tol) go to 270
         G = R / RADIX
         F = 1.0D0
         S = C + R
  210    IF (C .GE. G) GO TO 220
         F = F * RADIX
         C = C * B2
         GO TO 210
  220    G = R * RADIX
  230    IF (C .LT. G) GO TO 240
         F = F / RADIX
         C = C / B2
         GO TO 230
C     .......... NOW BALANCE ..........
  240    IF ((C + R) / F .GE. 0.95D0 * S) GO TO 270
         G = 1.0D0 / F
         SCALE(I) = SCALE(I) * F
         NOCONV = .TRUE.
C
         DO 250 J = K, N
  250    A(I,J) = A(I,J) * G
C
         DO 260 J = 1, L
  260    A(J,I) = A(J,I) * F
C
  270 CONTINUE
C
      IF (NOCONV) GO TO 190
C
  280 LOW = K
      IGH = L
      RETURN
      END

      subroutine a2rd_vib(natoms,iatchrg,freq,freqco,dnormmd,Nimag,
     &                    Nvib,iunit,Write_molden_file)
c-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      parameter (nelement=103)
      parameter (angtob=1.88972598772D0)
      character *80 wrk
      character *10 Label
      Character  *4 PTGRP
      character*2 celemol(nelement)
      logical yesno,Write_molden_file
      inTEger iatchrg(natoms)
      DOuble precision freq(nvib),freqco(3,natoms),
     &  dnormmd(nvib,3,natoms)



c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
      data (celemol(i),i=1,nelement)
     & /' H','He',
     & 'Li','Be',' B',' C',' N',' O',' F','Ne',
     & 'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     & ' K','Ca',
     & 'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     & 'Ga','Ge','As','Se','Br','Kr',
     & 'Rb','Sr',
     & ' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     & 'In','Sn','Sb','Te',' I','Xe',
     & 'Cs','Ba','La',
     & 'Ce','Pr','Nd','Pm','Sm','Eu','Gd',
     & 'Tb','Dy','Ho','Er','Tm','Yb','Lu',
     & 'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     & 'Tl','Pb','Bi','Po','At','Rn',
     & 'Fr','Ra','Ac',
     & 'Th','Pa',' U','Np','Pu','Am','Cm',
     & 'Bk','Cf','Es','Fm','Md','No','Lr'/
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C If Writing the MOLDEN files then read the NORMCO file otherwise
C read the FRQARC file.
C
      If (Write_molden_file) Then
C
C Reset the number of frequncies to include rotational and
C vibrational modes since the NORMCO file contains all of
C them.
C
        Nvib  = 3*Natoms
        Nimag = 0
        INQUIRE(FILE='NORMCO',EXIST=YESNO)
        IF(YESNO)THEN
          OPEN(UNIT=4,FILE='NORMCO',FORM='FORMATTED',STATUS='OLD')
          rewind(4)
        else
          write(6,10)
10        format(T3,'@RDVIB-F, NORMCO file not present.')
          call errex
        ENDIF
C
C This is an error, molden visualization does not need mass weigthed 
C coordnates. Ajth Perera, 05/2010
        read(4,*)wrk
        do iatom=1,natoms
CSSS           read(4,*)(freqco(i,iatom),i=1,3)
           read(4,*) tmp
        end do 
      
        do 30 ivib=1,nvib
           read(4,*)wrk      
           read(4,'(a)') wrk(1:21)
           read(unit=wrk(1:20),fmt=*) freqy
           if (wrk(21:21) .eq. 'i') Then
              freqy = -freqy 
              Nimag = Nimag + 1
           endif
           freq(ivib) = freqy      
           read(4,*)wrk
           do 40 iatom=1,natoms
              read(4,*)(dnormmd(ivib,i,iatom),i=1,3)
         
   40      continue
   30   continue
C
        close(unit=4,status='KEEP')    

        do 50 ivib=1,nvib
           if (freq(ivib) .lt. 0.0D0) freq(ivib)= -freq(ivib)
           write(iunit,60)' ',freq(ivib)
60         format(A,f9.4)
50      continue
        write(iunit,70)'[FR-COORD]'
70      format(A)
        do 80 iatom=1,natoms
           write(iunit,90)' ',celemol(iatchrg(iatom)),freqco(1,iatom),
     &     freqco(2,iatom),freqco(3,iatom)
90         format(A,A2,3x,f9.6,3x,f9.6,3x,f9.6)
80      continue
        write(iunit,100)'[FR-NORM-COORD]'
100     format(A)
        do 110 ivib=1,nvib
           write(iunit,115)'vibration    ',ivib
115        format(A,I2)
           do 120 iatom=1,natoms
              write(iunit,130)'   ',dnormmd(ivib,1,iatom),
     &        dnormmd(ivib,2,iatom),dnormmd(ivib,3,iatom)
130           format(A,f9.6,4x,f9.6,4x,f9.6)
120        continue 
110     continue
C
      Else
C
        INQUIRE(FILE='FRQARC',EXIST=YESNO)
        IF(YESNO)THEN
          OPEN(UNIT=5,FILE='FRQARC',FORM='UNFORMATTED',STATUS='OLD')
          rewind(5)
        else
          write(6,20)
20        format(T3,'@RDVIB-F, The FRQARC file not present.')
          call errex
        ENDIF
        READ(5) LABEL, PTGRP, NRX, NIMAG, ZMAS, ZIX, ZIY, ZIZ,
     &          (Freq(IVIB), IVIB=1, Nvib)
        Nimag = 0
        Print*,LABEL, PTGRP, NRX, NIMAG, ZMAS, ZIX, ZIY, ZIZ,
     &         (Freq(IVIB), IVIB=1, Nvib)

C
C Scale coordinates to bohr from angstrom, do not know what
C this is at the moment, Ajith Perera, 04/2011
C
CSSSS        call dscal(3*natoms,angtob,coord,1)
        close(unit=5,status='KEEP')
C
      Endif
C
      Return
      End

       SUBROUTINE GENERATE_12DGRID(WORK, ILEFT, NATOMS, NFCT,
     &                             NBFNS, NAOBFNS, LNP1, IPOPF,
     &                             IUATMS, COORD, ALPHA, PCOEF,
     &                             NUNQSHL, NSHL, NANGMOMSHL,
     &                             NCONFUNSHL, NPRIMFUNSHL,
     &                             NOFFSETATMP, NOFFSETATMC,
     &                             NOFFSETPRM, NOFFSETCON, 
     &                             TMP1, TMP2, TMP3, PRDUCINT,
     &                             CNT_COORD, IREORDER, IANGTYPE, 
     &                             IATMCHRG, IUHF)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      CHARACTER*2 GRID_TYPE, ORIENTATION(3)
      CHARACTER*7 DENSITY_TYPE
      LOGICAL D2_GRID, D3_GRID, D2_EXIST, D3_EXIST, SPIN_D, POST_SCF,
     &        TRIPLET_PERT
      DIMENSION IRREP_PERT(8)
      PARAMETER (MAX_GRID_POINTS = 100)
C
#include "flags.h"
#include "machsp.com"
#include "jodaflags.com"                   
#include "mxatms.par"
C#include "istart.com"                      
#include "baslims.par"
C    
      DIMENSION ALPHA(NFCT), IPOPF(IUATMS), COORD(NATOMS*3), 
     &          NSHL(IUATMS), NANGMOMSHL(IUATMS, NUNQSHL),
     &          NCONFUNSHL(IUATMS, NUNQSHL), 
     &          NPRIMFUNSHL(IUATMS,NUNQSHL), PCOEF(NFCT, NBFNS), 
     &          PRDUCINT(NAOBFNS,NAOBFNS), IREORDER(NAOBFNS),
     &          WORK(ILEFT), NOFFSETPRM(IUATMS,NUNQSHL),
     &          NOFFSETCON(IUATMS,NUNQSHL), NOFFSETATMP(IUATMS), 
     &          NOFFSETATMC(IUATMS), TMP1(LNP1,LNP1),TMP2(LNP1,LNP1),
     &          TMP3(LNP1,LNP1), CNT_COORD(3, NFCT), ORIGIN_2D(3), 
     &          IANGTYPE(NFCT), NCUBE(0:4), ATOM_XYZ(4, MXATMS), 
     &          IATMCHRG(NATOMS), QUANTITY(0:4, MAX_GRID_POINTS), 
     &          STEP_3D(3, 0:3)
 
      DATA D0, D1, D2, D4 /0.0D0, 1.0D0, 2.0D0, 4.0D0/
      DATA LUNIT_2D, LUNIT_3D /10, 20/
      DATA XTANG /0.529177249D0/ 
C
#ifdef _DEBUG_LVL0
       Write(6,"(a,6I4)"), "Input varaibles:", Iuatms, Natoms, 
     &         nunqshl, lnp1, nbfns, nfct
       Write(6,*)
       write(*, '(a)'), "The exponents"
       Write(*, '(4F10.5)') (alpha(i), i=1, NFCT)
       Write(6,*)
       Write(*, '(a)'), "Cartesian Coords."
       Write(*, '(3F10.5)') (Coord(i), i=1, 3*NATOMS)
       Write(6,*)
       Write(*, '(a)'), "The NSHL array"
       Write(*, '(4I5)') (Nshl(i), i=1, iuatms)
       Write(6,*)
       Write(6,*) "The ipopf array"
       Write(*, '(4I5)') (ipopf(i), i=1, iuatms)
       Write(6,*)   
       Write(6, *) "The NOFFSETATMC and NOFFSETATMP arrays"
       Write(*, '(4I5)') (NOFFSETATMC(i), i=1, iuatms) 
       Write(*, '(4I5)') (NOFFSETATMP(i), i=1, iuatms)
       write(6,*)
       Write(6,*) "The number of primitive in a shell"
       Write(6, '(4I5)') ((NPRIMFUNSHL(i,j), J=1, Nshl(i)),  
     &                    i=1,iuatms)
       Write(6,*)
       Write(6,*) "The number of contracted functions in a shell"
       Write(6, '(4I5)') ((NCONFUNSHL(i,j), J=1, Nshl(i)),  
     &                    i=1,iuatms)
       Write(6,*)
       Write(6,*) "The angular momentum of shells"
       Write(6, '(4I5)') ((NANGMOMSHL(i,j), J=1, Nshl(i)), 
     &                    I=1,iuatms)
       Write(6,*)
       Write(6,*) "The offset for primitives"
       Write(6, '(4I5)') ((NOFFSETPRM(i,j), J=1, Nshl(i)), 
     &                    I=1,iuatms)
       Write(6,*)
       Write(6,*) "The offset for contracted functions"
       Write(6, '(4I5)') ((NOFFSETCON(i,j), J=1, Nshl(i)), 
     &                    I=1,iuatms)
       write(6,*)
       Write(*, '(a)') "The Contractions Coef."
       write(*, '(6F10.5)') ((pcoef(i, j), i=1, nfct), 
     &                        j=1,nbfns)
#endif              
             
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "Entering ZMAT READ"
#endif 
          POST_SCF = .FALSE.
      TRIPLET_PERT = .FALSE.
      If (iflags(h_IFLAGS_calc) .GT. 1)    POST_SCF = .TRUE.
      If (iflags(h_IFLAGS_props) .EQ. 9) TRIPLET_PERT = .TRUE.
C

      CALL A2RDZMAT_4GRIDINF(GRID_TYPE, DENSITY_TYPE, SPIN_D, 
     &                       NMBR_OF_PERTS, IPICK_PERT, STEP_SIZE, 
     &                       D2RANGE, D3RANGE, XORIGIN, YORIGIN, 
     &                       ZORIGIN)
C
      
      IF (DENSITY_TYPE .EQ. "1-ORDER" .OR. 
     &    DENSITY_TYPE .EQ. "DEFINED") THEN
         CALL GETREC(0, 'JOBARC', 'NTOTPERT', IRECLEN, NTPERT)
        IF (IRECLEN .GT. 0) THEN
           CALL GETREC(20, 'JOBARC', 'NTOTPERT', 1, NTPERT)
        ELSE 
           NTPERT = 0
           CALL IZERO(IRREP_PERT, 8)
           CALL GETREC (20, 'JOBARC', 'NPERTIRR', 8, IRREP_PERT)
           DO IREPS = 1, 8
              NTPERT = NTPERT + IRREP_PERT(IREPS)
           END DO
        END IF
C    
        IF (NMBR_OF_PERTS .GT. NTPERT .OR. IPICK_PERT .GT. NTPERT) 
     &     THEN
           Write(6,'(t3,6(a))') "Inconsistency in the number of",
     &           " internal and input total perturbations",
     &           " or the selected perturbation is beyond the",
     &           " total number of perturbations: the internal", 
     &           " total number of perturbations and the first", 
     &           " perturbation in the list is choosen."
           NMBR_OF_PERTS = NTPERT
           IPICK_PERT    = 1
        ENDIF
      ENDIF
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,'(1x,a,a,2I3)') "The total number of perturbations ",
     & "and the perturbation of interest", NMBR_OF_PERTS, 
     & IPICK_PERT
      Write(6,*)
      Write(6,*) "The reorder array"
      Write(6,"(6I4)") (IREORDER(I), I=1, NAOBFNS)
#endif
      CALL A2GET_DEN(WORK, ILEFT, IREORDER, DENSITY_TYPE, SPIN_D, 
     &               NMBR_OF_PERTS, NBFNS, NAOBFNS, ISCF_TDEN,
     &               ICOR_TDEN, ISCF_DDEN, ICOR_DDEN, IBEGIN_P_DENS,
     &               IUHF)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "Offsets for 0/1-order density"
      Write(*,'(7(1x,i5))') ISCF_TDEN,ICOR_TDEN,ISCF_DDEN,ICOR_DDEN,
     &                       IBEGIN_P_DENS, NMBR_OF_PERTS, IPICK_PERT
      Write(6,*)
#endif
C
      IF (GRID_TYPE .EQ. "2D") THEN
         D2_GRID = .TRUE.
         ORIENTATION(1) = 'xy'
         ORIENTATION(2) = 'xz'
         ORIENTATION(3) = 'yz'
         INQUIRE(FILE="2DPLOT", EXIST=D2_EXIST)
         IF (D2_EXIST) THEN
            OPEN(UNIT=LUNIT_2D, FILE="2DPLOT", FORM="FORMATTED", 
     &           STATUS='OLD')
         ELSE
            OPEN(UNIT=LUNIT_2D, FILE="2DPLOT", FORM="FORMATTED", 
     &           STATUS='NEW')
         ENDIF
          
      ELSE 
         D3_GRID = .TRUE.
         INQUIRE(FILE="3DPLOT", EXIST=D3_EXIST)
         IF (D3_EXIST) THEN
            OPEN(UNIT=LUNIT_3D, FILE="3DPLOT", FORM="FORMATTED", 
     &           STATUS='OLD')
         ELSE
            OPEN(UNIT=LUNIT_3D, FILE="3DPLOT", FORM="FORMATTED", 
     &           STATUS='NEW')
         ENDIF
C
         IOFF = 1
         DO IATOM =1, NATOMS
            IOFF = IOFF + (IATOM - 1)*3
            DO IXYZ = 1, 3
               ATOM_XYZ(IXYZ, IATOM) = COORD(IOFF)
               IOFF = IOFF + 1
            ENDDO
            IOFF = 1
         END DO
C
         NCUBE(1) = 80
         NCUBE(2) = 80
         NCUBE(3) = 80
C
#ifdef _DEBUG_LVLM2
         NCUBE(1) = 1
         NCUBE(2) = 1
         NCUBE(3) = 1
#endif
C
       ENDIF 

C#ifdef _NOSKIP

      IF(D2_GRID) THEN 

        STEP_2D      = STEP_SIZE
        ADD_2D       = D2RANGE
        ORIGIN_2D(1) = XORIGIN/XTANG
        ORIGIN_2D(2) = YORIGIN/XTANG
        ORIGIN_2D(3) = ZORIGIN/XTANG
        NR_STEPS     = 1 + ADD_2D*D2/STEP_2D

        DO IORIENTATION = 1,3

          NI = NR_STEPS
          NJ = NR_STEPS
          NK = NR_STEPS
C
#ifdef _DEBUG_LVLM2
          NI = 5
          NJ = 5
          NK = 5
#endif
          IF (ORIENTATION(IORIENTATION) .EQ. 'xy') NK = 1
          IF (ORIENTATION(IORIENTATION) .EQ. 'xz') NJ = 1
          IF (ORIENTATION(IORIENTATION) .EQ. 'yz') NI = 1

          WRITE(LUNIT_2D,'(A)')
          WRITE(LUNIT_2D,'(A)')
          WRITE(LUNIT_2D,'(A2)') ORIENTATION(IORIENTATION)
          WRITE(LUNIT_2D,'(A)')

          DO I = 1,NI
            DO J = 1,NJ
              DO K = 1,NK

                XPOINT = ORIGIN_2D(1)
     &                   - ADD_2D + (I-1)*STEP_2D
                YPOINT = ORIGIN_2D(2)
     &                   - ADD_2D + (J-1)*STEP_2D
                ZPOINT = ORIGIN_2D(3)
     &                   - ADD_2D + (K-1)*STEP_2D

                IF(ORIENTATION(IORIENTATION) .EQ. 'xy')
     &                                     ZPOINT = ORIGIN_2D(3)
                IF(ORIENTATION(IORIENTATION) .EQ. 'xz')
     &                                     YPOINT = ORIGIN_2D(2)
                IF(ORIENTATION(IORIENTATION) .EQ. 'yz')
     &                                     XPOINT = ORIGIN_2D(1)

                CALL A2EVAL_INT_MAIN(IUATMS, NATOMS, NUNQSHL, LNP1, 
     &                               IPOPF, NSHL, NFCT, NBFNS, 
     &                               NOFFSETATMP, NOFFSETATMC, 
     &                               NOFFSETPRM, NOFFSETCON,
     &                               NANGMOMSHL, NPRIMFUNSHL, 
     &                               NCONFUNSHL, XPOINT, YPOINT, 
     &                               ZPOINT, ALPHA, PCOEF, COORD, 
     &                               PRDUCINT, TMP1, TMP2, TMP3)
#ifdef _DEBUG_LVLM2
      Print*, "Offsets for 0-order density"
      Write(*,'(7(1x,i5))') ISCF_TDEN,ICOR_TDEN,ISCF_DDEN,ICOR_DDEN,
     &                       IBEGIN_P_DENS, NMBR_OF_PERTS, IPICK_PERT
      Write(6,*)
      Print*, "The product integrals"
      CALL OUTPUT(PRDUCINT, 1, NAOBFNS, 1, NAOBFNS, NAOBFNS,
     &            NAOBFNS, 1)

#endif
                CALL A2BUILD_QUANTITY(WORK, ILEFT, PRDUCINT, 
     &                                QUANTITY, SPIN_D, DENSITY_TYPE, 
     &                                NMBR_OF_PERTS, IPICK_PERT,
     &                                NBFNS, NAOBFNS, ISCF_TDEN, 
     &                                ICOR_TDEN, ISCF_DDEN, 
     &                                ICOR_DDEN, IBEGIN_P_DENS, 
     &                                MAX_GRID_POINTS, POST_SCF, 
     &                                GRID_TYPE, 1, IUHF)
C
               XPOINT        = XPOINT*XTANG
               YPOINT        = YPOINT*XTANG
               ZPOINT        = ZPOINT*XTANG
               QUANTITY(0,1) = QUANTITY(0,1)
               QUANTITY(1,1) = QUANTITY(1,1)
              
C
               IF (DENSITY_TYPE .EQ. "0-ORDER") THEN
C
                   IF (POST_SCF) THEN
                       WRITE(LUNIT_2D,'(5F20.10)') XPOINT, YPOINT, 
     &                                             ZPOINT,
     &                                             QUANTITY(0,1),
     &                                             QUANTITY(1,1)
                   ELSE
                       WRITE(LUNIT_2D,'(4F20.10)') XPOINT, YPOINT,
     &                                             ZPOINT,
     &                                             QUANTITY(0,1)
                   ENDIF
C
               ELSE IF (DENSITY_TYPE .EQ. "1-ORDER") THEN
                        WRITE(LUNIT_2D,'(5F20.10)') XPOINT, YPOINT,
     &                                              ZPOINT,
     &                                              QUANTITY(0,1),
     &                                              QUANTITY(1,1)
C
              ELSE IF (DENSITY_TYPE .EQ. "DEFINED") THEN
C
                       WRITE(LUNIT_2D,'(5F20.10)') XPOINT, YPOINT, 
     &                                             ZPOINT, 
     &                                             QUANTITY(0,1)
               ENDIF
  
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDIF 

      IF(D3_GRID) THEN 

C calculate cube parameters

C NCUBE(0)  number of atoms
C NCUBE(1)  number of points in the "x"-direction
C NCUBE(2)  number of points in the "y"-direction
C NCUBE(3)  number of points in the "z"-direction

C STEP_3D(*,0)  coordinates of initial point
C STEP_3D(*,1)  step vector for the "x"-direction
C STEP_3D(*,2)  step vector for the "y"-direction
C STEP_3D(*,3)  step vector for the "z"-direction

C ATOM_XYZ(1,I)  x-coordinate of atom I
C ATOM_XYZ(2,I)  y-coordinate of atom I
C ATOM_XYZ(3,I)  z-coordinate of atom I
C ATOM_XYZ(4,I)  charge of atom I

        NCUBE(0) = NATOMS
        ADD_3D   = D3RANGE 
        CALL DZERO(STEP_3D, 12)
C
        DO I = 1,3
          STEP_3D(I,0) = ATOM_XYZ(I,I)
          STEP_3D(I,I) = ATOM_XYZ(I,I)
        ENDDO
C
        DO I = 1, NATOMS
           DO M = 1, 3
              STEP_3D(M,0)  = MIN(STEP_3D(M,0),ATOM_XYZ(M,I))
              STEP_3D(M,M)  = MAX(STEP_3D(M,M),ATOM_XYZ(M,I))
           END DO
              ATOM_XYZ(4,I) = DBLE(IATMCHRG(I))
        ENDDO

C add some space, calculate step sizes and convert step vectors to
C angstrom
C
        DO I = 1,3
          STEP_3D(I,0) = STEP_3D(I,0) - ADD_3D
          STEP_3D(I,I) = (STEP_3D(I,I) + (ADD_3D*D2))
          STEP_3D(I,I) = (STEP_3D(I,I) - STEP_3D(I,0))/(NCUBE(I) - 1)
        ENDDO

C Write header

        WRITE(LUNIT_3D,'(A)') 'some'
        WRITE(LUNIT_3D,'(A)') 'text'
        DO I = 0,3
          WRITE(LUNIT_3D,'(I5,4F12.6)') NCUBE(I), (STEP_3D(J,I),J=1,3)
        ENDDO
        DO I = 1,NATOMS
          WRITE(LUNIT_3D,'(I5,4F12.6)')
     &         NINT(ATOM_XYZ(4,I)), ATOM_XYZ(4,I), (ATOM_XYZ(J,I),J=1,3)
        ENDDO
C
        CALL A2GET_ANG_TYPE(IUATMS, NFCT, NUNQSHL, NSHL, NANGMOMSHL, 
     &                      NPRIMFUNSHL, IANGTYPE, COORD, CNT_COORD)
C

        DO ICUBE = 1,NCUBE(1)
          DO JCUBE = 1,NCUBE(2)
            DO KCUBE = 1,NCUBE(3)

              XPOINT = STEP_3D(1,0) + (ICUBE-1)*STEP_3D(1,1)
     &                              + (JCUBE-1)*STEP_3D(1,2)
     &                          + (KCUBE-1)*STEP_3D(1,3)
              YPOINT = STEP_3D(2,0) + (ICUBE-1)*STEP_3D(2,1)
     &                          + (JCUBE-1)*STEP_3D(2,2)
     &                          + (KCUBE-1)*STEP_3D(2,3)
              ZPOINT = STEP_3D(3,0) + (ICUBE-1)*STEP_3D(3,1)
     &                          + (JCUBE-1)*STEP_3D(3,2)
     &                          + (KCUBE-1)*STEP_3D(3,3)
#ifdef _DEBUG_LVLM2
              XPOINT = 1.0D0
              YPOINT = 1.0D0
              ZPOINT = 1.0D0
#endif
C
               CALL A2EVAL_INTS(NFCT, NAOBFNS, IANGTYPE, XPOINT,  
     &                          YPOINT, ZPOINT, ALPHA, PCOEF, 
     &                          PRDUCINT, CNT_COORD, TMP1, TMP2,
     &                          TMP3)
#ifdef _DEBUG_LVL0
      Print*, "Offsets for 0-order density"
      Write(*,'(7(1x,i5))') ISCF_TDEN,ICOR_TDEN,ISCF_DDEN,ICOR_DDEN,
     &                       IBEGIN_P_DENS, NMBR_OF_PERTS, IPICK_PERT
      Write(6,*)
      Print*, "The product integrals"
      CALL OUTPUT(PRDUCINT, 1, NAOBFNS, 1, NAOBFNS, NAOBFNS,
     &            NAOBFNS, 1)
      
#endif
               CALL A2BUILD_QUANTITY(WORK, ILEFT, PRDUCINT,
     &                               QUANTITY, SPIN_D, DENSITY_TYPE,
     &                               NMBR_OF_PERTS, IPICK_PERT,
     &                               NBFNS, NAOBFNS, ISCF_TDEN,
     &                               ICOR_TDEN, ISCF_DDEN,
     &                               ICOR_DDEN, IBEGIN_P_DENS,
     &                               MAX_GRID_POINTS, POST_SCF, 
     &                               GRID_TYPE, KCUBE, IUHF)
C
            ENDDO

C               XPOINT = XPOINT*XTANG
C               YPOINT = YPOINT*XTANG
C               ZPOINT = ZPOINT*XTANG
C
               IF (DENSITY_TYPE .EQ. "0-ORDER") THEN
C
                    IF (TRIPLET_PERT) THEN
                        WRITE(LUNIT_3D,'(6E13.5)')  (QUANTITY(0,M),
     &                                               M = 1, NCUBE(3))
                    ELSE

                        WRITE(LUNIT_3D,'(6E13.5)')  (QUANTITY(0,M),
     &                                               M = 1, NCUBE(3))
                    ENDIF
                   
C
               ELSE IF (DENSITY_TYPE .EQ. "1-ORDER") THEN
C
                    IF (TRIPLET_PERT) THEN
                        WRITE(LUNIT_3D,'(6E13.5)') (QUANTITY(1,M),
     &                                              M = 1, NCUBE(3))
                    ELSE
                        WRITE(LUNIT_3D,'(6E13.5)') (QUANTITY(0,M),
     &                                              M = 1, NCUBE(3))
                    END IF

               ELSE IF (DENSITY_TYPE .EQ. "DEFINED") THEN
C
                       WRITE(LUNIT_3D,'(6E13.5)') (QUANTITY(0,M),
     &                                             M = 1, NCUBE(3))
               ENDIF
C
          ENDDO
        ENDDO
C
      ENDIF 
C
C#endif 
#ifdef _OBSOLETED
       Write(6,*)
       print*, "Entering A2EVAL_PRDCTINT"
       XPOINT=1.0D0
       YPOINT=1.0D0
       ZPOINT=1.0D0
#ifdef _DEBUG_LVL0
       Print*, "Input varaibles:", Iuatms, Natoms, nunqshl, lnp1, nbfns,
     &          nfct 
       Write(6,*)
       write(*, '(a)'), "The exponents"
       Write(*, '(4F10.5)') (alpha(i), i=1, NFCT)
       Write(6,*)
       Write(*, '(a)'), "Cartesian Coords."
       Write(*, '(4F10.5)') (Coord(i), i=1, 3*NATOMS)
       Write(6,*)
       Write(*, '(a)'), "The NSHL array"
       Write(*, '(4I5)') (Nshl(i), i=1, iuatms)
       Write(6,*)
       Write(6,*) "The ipopf array"
       Write(*, '(4I5)') (ipopf(i), i=1, iuatms)
       Write(6,*)
       Write(6, *) "The NOFFSETATMC and NOFFSETATMP arrays"
       Write(*, '(4I5)') (NOFFSETATMC(i), i=1, iuatms)
       Write(*, '(4I5)') (NOFFSETATMP(i), i=1, iuatms)
       write(6,*)
       Write(6,*) "The number of primitive in a shell"
       Write(6, '(4I5)') ((NPRIMFUNSHL(i,j), I=1, iuatms), 
     &                    j=1,NUNQSHL)
       write(6,*)
       Write(*, '(a)') "The Contractions Coef."
       write(*, '(4F10.5)') ((pcoef(i, j), i=1, nfct), 
     &                        j=1,nbfns)
#endif
              CALL A2EVAL_INT_MAIN(IUATMS, NATOMS, NUNQSHL, LNP1, IPOPF,
     &                             NSHL, NFCT, NBFNS, NOFFSETATMP,
     &                             NOFFSETATMC, NOFFSETPRM, NOFFSETCON,
     &                             NANGMOMSHL, NPRIMFUNSHL, NCONFUNSHL,
     &                             XPOINT, YPOINT, ZPOINT, ALPHA, PCOEF,
     &                             COORD, PRDUCINT, TMP1, TMP2, TMP3)
   
              CALL A2BUILD_QUANTITY(WORK, ILEFT, PRDUCINT,
     &                              QUANTITY, SPIN_D, DENSITY_TYPE,
     &                              NMBR_OF_PERTS, IPICK_PERT,
     &                              NBFNS, NAOBFNS, ISCF_TDEN,
     &                              ICOR_TDEN, ISCF_DDEN,    
     &                              ICOR_DDEN, IBEGIN_P_DENS,
     &                              MAX_GRID_POINTS, POST_SCF,
     &                              GRID_TYPE, 1, IUHF)      
C     
#endif

      CLOSE (LUNIT_2D, STATUS="KEEP")
      CLOSE (LUNIT_3D, STATUS="KEEP")
C
      Return
      END
		
		
	

c This function releases memory that was reserved by the setptr function.
c All memory that is released is flushed with a pattern (either 0x00 or 0xFF).

      subroutine relptr(stack,type,ptr)
      implicit none

#include "aces.h"
#include "kscore.com"
#include "ks_mem.com"
#include "callstack.com"

      integer stack,type,ptr

      callstack_prev = callstack_curr
      callstack_curr = 'RELPTR'

      if (type.eq.F_INTEGER) then
         if (ptr.lt.i0 .or. ptr.gt.iptr) then
            write(*,*) '@RELPTR: invalid pointer'
            call errex
            stop
         end if
         if (memknown.ne.0) call izero(kscore(ptr),iptr-ptr)
         iptr=ptr
      else if (type.eq.F_REAL) then
         if (ptr.lt.d0 .or. ptr.gt.dptr) then
            write(*,*) '@RELPTR: invalid pointer'
            call errex
            stop
         end if
         if (memknown.ne.0) call dzero(dcore(ptr),dptr-ptr)
         dptr=ptr
      else
         write(*,*) '@RELPTR: received invalid data type'
         call errex
         stop
      end if

      callstack_curr = callstack_prev
      return
      end

c This function releases memory that was reserved by the setptr function.
c All memory that is released is flushed with a pattern (either 0x00 or 0xFF).

      subroutine relptr(stack,type,ptr)
      implicit none















c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler


























cYAU - ACES3 stuff . . . we hope - #include <aces.par>






c Two different "stacks" of memory will be available in the course of an
c Aces3 calculation.  Integer memory will be stored in icore.  Real memory
c will be stored in dcore.
c
c Memory allocation is done in one of two ways, dynamic or nondynamic.  This
c is controlled by the parameter dynmem.  If dynmem is 1, dynamic memory
c is used.  Otherwise, nondynamic memory is used.
c
c Two additional parameters nondynimem and nondyndmem control how much
c nondynamic memory is allocated initially in the icore and dcore stacks.
c If dynmem is 1, both of these parameters SHOULD be 1.

c Dynamic memory allocation is done in a fairly straighforward way.  The
c program runs through everything twice.  The first time is just to determine
c how much dynamic memory is required.  The second time is use to actually
c allocate the memory and use it.  In some cases, it may be difficult to
c determine how much memory to use in advance in each of the stacks.  To
c aid this, there is also the option of only running through a program a
c single time.  When this happens, both stacks are allocated initially and
c used throughout the program.  If the memory requirement for either stack
c is exceeded, the program crashes.
c
c Two parameters which are used in either case are memknown and maxicore.
c Both MUST be set in the calling program.
c
c   memknown : 0 if a dummy run is being done to determine memory usage
c              1 if the memory usage is known from a previous dummy run
c             -1 if no dummy run is done (only one run through the program)
c   maxicore : the maximum amount of icore to allocate (this MAY be
c              adjusted IF a dummy run detects that more is needed, but in
c              the case of a single run, this will be rigidly applied)
c
c This include file is required whenever calls to any of the memory functions
c (setptr and relptr) are called or when part of the execution depends on
c whether the first or second run is being performed.
c
c ***NOTE***
c It is important that icore be aligned on a floating point boundary.  One
c way which seems to insure this is to have icore the FIRST element in the
c common block.  So, make sure that no integer is ever inserted before icore
c in the common block declaration.

      integer dynmem,nondynimem,nondyndmem
      parameter (dynmem=1)
      parameter (nondynimem=1)
      parameter (nondyndmem=1)

      double precision   dcore(nondyndmem)
      common /dcore_com/ dcore
      save   /dcore_com/

      integer    kscore(nondynimem)
      common /kscore_mem / kscore

      integer            memknown,maxicore
      common /kscore_com/ memknown,maxicore
      save   /kscore_com/





c i0,i1    : The first element in icore that may be used and the first element
c            that may not be used.
c iptr     : The pointer to the current location in icore
c ineeded  : The size of icore needed for the calculation (determined by the
c            initial run).  This is only used when dynamic memory is used.
c
c In a dummy run, i0 starts at 1, iptr is incremented, and ineeded goes from
c 0 to ineeded.  i1 is initially set at maxicore.  These values are used if
c nondynamic memory is used.  Note that if dynamic memory is used, ineeded
c MAY exceed i1.  In this case (provided there dcore has not used all the
c remaining memory), the amount of memory given to icore is increased.  On
c the other hand, if icore does not need all that it was given, it gives
c the remaining to dcore.
c
c When memory is actually allocated, i0 is set to the beginning element,
c i1 is set to i0+ineeded, and iptr ranges from i0 to i1.
c
c d0,dpt,dneeded,d1
c          : Similar for dcore
c
c maxmem   : Maximum memory to allocate (set in ZMAT file)

      integer             i0,iptr,ineeded,i1,d0,dptr,dneeded,d1,maxmem
      common /ks_mem_com/ i0,iptr,ineeded,i1,d0,dptr,dneeded,d1,maxmem
      save   /ks_mem_com/




c This contains the global string for identifying the current subroutine
c or function (provided the programmer set it).  cf. tools/callstack.F
c BE GOOD AND RESET CURR ON EXIT!

      character*64                callstack_curr,callstack_prev
      common /callstack_curr_com/ callstack_curr,callstack_prev
      save   /callstack_curr_com/



      integer stack,type,ptr

      callstack_prev = callstack_curr
      callstack_curr = 'RELPTR'

      if (type.eq.0) then
         if (ptr.lt.i0 .or. ptr.gt.iptr) then
            write(*,*) '@RELPTR: invalid pointer'
            call errex
            stop
         end if
         if (memknown.ne.0) call izero(kscore(ptr),iptr-ptr)
         iptr=ptr
      else if (type.eq.1) then
         if (ptr.lt.d0 .or. ptr.gt.dptr) then
            write(*,*) '@RELPTR: invalid pointer'
            call errex
            stop
         end if
         if (memknown.ne.0) call dzero(dcore(ptr),dptr-ptr)
         dptr=ptr
      else
         write(*,*) '@RELPTR: received invalid data type'
         call errex
         stop
      end if

      callstack_curr = callstack_prev
      return
      end

C FILLS OUT MACHINE-DEPENDENT COMMON BLOCKS

      SUBROUTINE MCHPRM

      LOGICAL MVSCF,MINTPRC,MVDINT1,MVDINT2,MANTI
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MACHSP2/MASK1,MASK2,ISHFSZ
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /MEMSCF/ MVSCF
      COMMON /MINTPC/ MINTPRC
      COMMON /MVDINT/ MVDINT1,MVDINT2
      COMMON /MEMANTI/ MANTI
#include "icdacc.com"

C IINTLN IS THE INTEGER LENGTH IN BYTES.
C IFLTLN IS THE FLOATING POINT LENGTH IN BYTES.
C IINTFP IS THE RATIO IFLTLN/IINTLN

#ifdef F_64BIT
      IINTLN=8
#else
      IINTLN=4
#endif
      IFLTLN=8
      IINTFP=(IFLTLN/IINTLN)
      IALONE=2**(8*IINTLN/4)-1
      IBITWD=8*IINTLN/4

cYAU - Okay, what is this "idacc?" all about...
c
c    First off, the name refers to Direct ACCess. The ultimate problem
c is that the Fortran standard lets RECL take any unit when specifying
c the record length of direct access, unformatted files. It's not
c necessarily compiler, OS, or architecture dependent. In fact, some
c configurations let you specify the units of RECL with an environment
c variable!
c    To aid portability, idaccm was introduced by Nevin as a scaling
c factor for RECL. In essence, idaccm is the number of RECL units
c per integer; therefore, it could take any of the values: 1, 2, 4, or 8.
c    If there is an accompanying Fortran 9x compiler, then a short
c program will tell you whether to define _RECL_IS_WORDS_:
c       program test
c          integer :: i, len
c          inquire(iolength=len) i
c          print *, len
c       end program test
c Whatever number is printed, that should be the value of idaccm. For
c the time being, if RECL is not in bytes, then we will assume 4-byte
c words. It is possible RECL is 8-byte words, but that is very rare.

#ifdef _RECL_IS_WORDS_
#ifdef F_64BIT
      idaccm=2
#else
      idaccm=1
#endif /* F_64BIT */
#else
      idaccm=iintln
#endif /* _RECL_IS_WORDS_ */

#ifdef _DEBUG
c     We will try to print this info just once. Since ACES needs files
c     to get things done, we will check for a characteristic file and
c     print only if it does not exist. Also, since MVSCF gets set a
c     few lines down, we will use it temporarily.
      inquire(file='JOBARC',exist=MVSCF)
      if (.not.MVSCF) then
         write(*,*) '@MCHPRM: Machine/Build-specific parameters:'
         write(*,*) '         bytes per integer: ', iintln
         write(*,*) '         bytes per double:  ', ifltln
         write(*,*) '         recls per integer: ', idaccm
      end if
#endif /* _DEBUG */

      ILNBUF=1800
      LUOUT=6
      MOINTS=50

      IJUNK=4*IBITWD-3
      ISHFSZ=IJUNK
      MASK1=2**IJUNK-1
      MASK2=7

C LOGICAL VARIABLES TO CONTROL MEMORY IN SEVERAL MODULES
C NOTE, ON A RISC IT IS ADVANTAGEOUS TO REDUCE MEMORY
C REQUIREMENTS IN ALL SORT STEPS.

#if (defined _UNICOS) || ( (defined _AIX) && (defined F_64BIT) )
      MVSCF=.FALSE.
      MINTPRC=.FALSE.
      MVDINT1=.TRUE.
      MVDINT2=.FALSE.
      MANTI=.FALSE.
#else
      MVSCF=.FALSE.
      MINTPRC=.TRUE.
      MVDINT1=.TRUE.
      MVDINT2=.TRUE.
      MANTI=.TRUE.
#endif /* _UNICOS || (_AIX && F_64BIT) */

      RETURN
      END

      SUBROUTINE TWIDLE(A,H,F,C,Rref,RPlus,RMinus,Scratch,T)
C
C DOES RECTILINEAR --> CURVILINEAR TRANSFORMATION OF THE HESSIAN
C  MATRIX.  SOMEDAY, A BETTER ALGORITHM MAY COME UP, BUT THIS WILL
C  DO FOR NOW.  TAKES AS INPUT THE RECTILINEAR HESSIAN AND GRADIENT
C  (IN INTERNAL COORDINATES), AND PASSES BACK OUT THE CURVILIINEAR
C  HESSIAN.  THIS WILL ALSO BE USEFUL FOR COMPUTING ROTATIONALLY
C  PROJECTED FREQUENCIES.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


c
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
 
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION RREF(NX),RPLUS(NX),RMINUS(NX),C(NX,NXM6),A(NX,NXM6)
      DIMENSION SCRATCH(NX*NX),H(NXM6,NXM6),F(NXM6),T(NXM6,NXM6)
      PARAMETER(DELX=1.D-3)
      PARAMETER(TWO=2.D0)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
      DEL=DELX
C
C GET REFERENCE INTERNAL COORDINATES
C
      IF(IPRNT.GE.666)WRITE(LUOUT,3123)
      CALL XTOR(RREF,0)
C
C LOOP THROUGH INTERNAL COORDINATES; BUILD A PARTICULAR J,K MEMBER
C                  jk
C                 T
C                  i
C  FOR *ALL* I ON EACH PASS.  I REFERES TO THE INTERNAL COORDINATE.
C  IDIHED GETS TURNED ON IF THE INTERNAL COORDINATE IS A DIHEDRAL
C  ANGLE
C
C
C GET DIAGONAL ELEMENTS FIRST.  NEED THESE FOR OFF DIAGS.
C
      CALL ZERO(SCRATCH,NX*NXM6)
      CALL VADD(SCRATCH,SCRATCH,Q,NX,1.D0)
      DO 10 J=1,NXM6
       CALL ZERO(SCRATCH(NX+1),NX)
       CALL VADD(SCRATCH(NX+1),A(1,J),SCRATCH(NX+1),NX,1.D0)
       CALL xscal(NX,DEL,SCRATCH(NX+1),1)
       CALL VADD(Q,Q,SCRATCH(NX+1),NX,1.D0)
       CALL XTOR(RPLUS,0)
       CALL DCHECK(RREF,RPLUS,NXM6)
       CALL xscal(NX,TWO,SCRATCH(NX+1),1)
       CALL VADD(Q,Q,SCRATCH(NX+1),NX,-1.D0)
       CALL XTOR(RMINUS,0)
       CALL DCHECK(RREF,RMINUS,NXM6)
       CALL ZERO(Q,NX)
       CALL VADD(Q,Q,SCRATCH,NX,1.D0)
C
C NOW CAN GENERATE T(I)(J,J) FOR ALL I.  STORE THESE IN C(I,J)
C
       DO 55 I=1,NXM6
        C(I,J)=(RPLUS(I)+RMINUS(I)-2.D0*RREF(I))/DEL**2
        H(J,J)=H(J,J)-F(I)*C(I,J)
        IF(IPRNT.EQ.666)WRITE(LUOUT,3121)I,J,J,C(I,J)
 55    CONTINUE
 10    CONTINUE
       CALL ZERO(Q,NX)
       CALL VADD(Q,Q,SCRATCH,NX,1.D0)
C
C NOW GET OFF DIAGONALS
C
       CALL ZERO(SCRATCH(NX+1),NX*2)
       DO 30 J=1,NXM6
        DO 30 K=1,J-1
        CALL ZERO(SCRATCH(NX+1),2*NX)
        CALL ZERO(Q,NX)
        CALL VADD(Q,SCRATCH,Q,NX,1.D0)
        CALL VADD(SCRATCH(NX+1),A(1,J),SCRATCH(NX+1),NX,1.D0)
        CALL xscal(NX,DEL,SCRATCH(NX+1),1)
        CALL VADD(SCRATCH(2*NX+1),A(1,K),SCRATCH(2*NX+1),NX,1.D0)
        CALL xscal(NX,DEL,SCRATCH(2*NX+1),1)
        CALL VADD(Q,Q,SCRATCH(NX+1),NX,1.D0)
        CALL VADD(Q,Q,SCRATCH(2*NX+1),NX,1.D0)
        CALL XTOR(RPLUS,0)
        CALL DCHECK(RREF,RPLUS,NXM6)
        CALL xscal(NX*2,TWO,SCRATCH(NX+1),1)
        CALL VADD(Q,Q,SCRATCH(NX+1),NX,-1.D0)
        CALL VADD(Q,Q,SCRATCH(2*NX+1),NX,-1.D0)
        CALL XTOR(RMINUS,0)
        CALL DCHECK(RREF,RMINUS,NXM6)
C
C CONTINUE
C
       DO 56 I=1,NXM6
       P1=RPLUS(I)+RMINUS(I)-2.D0*RREF(I)-C(I,J)*DEL**2-
     &C(I,K)*DEL**2
       T(J,K)=0.5D0*P1/DEL**2
       T(K,J)=T(J,K)
       IF(IPRNT.EQ.666)WRITE(LUOUT,3121)I,J,K,T(J,K)
       H(J,K)=H(J,K)-F(I)*T(J,K)
       H(K,J)=H(J,K)
 56    CONTINUE
 30    CONTINUE
       CALL ZERO(Q,NX)
       CALL VADD(Q,Q,SCRATCH,NX,1.D0)
       ICURVY=1
 3123  FORMAT(T3,' Dump of rectilinear => curvilinear T tensor ',
     &'follows:')
 3121  FORMAT(T3,'[',I3,',',I3,',',I3,']',2X,F20.12)
 
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine load_pre_defined_routines_compile_time()
      implicit none

      integer dummy, load_user_sub
c
      dummy = load_user_sub('sip_barrier' // char(0),
     *                       0)
      dummy = load_user_sub('energy_denominator' // char(0),
     *                       0)
      dummy = load_user_sub('udenominator'//char(0), 0)
      dummy = load_user_sub('energy_product' // char(0),
     *                       0)
      dummy = load_user_sub('energy_reg_denominator' // char(0),
     *                       0)
      dummy = load_user_sub('energy_reg_product' // char(0),
     *                       0)
      dummy = load_user_sub('energy_denominator_reg_deriv' // char(0),
     *                       0)
      dummy = load_user_sub('print_scalar' // char(0),
     *                       0)
      dummy = load_user_sub('trace_on' // char(0),
     *                       0)
      dummy = load_user_sub('trace_off' // char(0),
     *                       0)
      dummy = load_user_sub('dump_block' // char(0),
     *                       0)
      dummy = load_user_sub('load_balance_on' // char(0),
     *                       0)
      dummy = load_user_sub('load_balance_off' // char(0),
     *                       0)
      dummy = load_user_sub('blocks_to_list' // char(0),
     *                       0)
      dummy = load_user_sub('list_to_blocks' // char(0),
     *                       0)
      dummy = load_user_sub('fmult' // char(0),
     *                       0)
      dummy = load_user_sub('der_int_setup' // char(0),
     *                       0)
      dummy = load_user_sub('compute_derivative_integrals'//char(0),
     *                       0)
      dummy = load_user_sub('server_barrier'//char(0),
     *                       0)
      dummy = load_user_sub('scont1'//char(0), 0)
      dummy = load_user_sub('hcont1'//char(0), 0)
      dummy = load_user_sub('dcont2'//char(0), 0)
      dummy = load_user_sub('eig'//char(0), 0)
      dummy = load_user_sub('eig_inv'//char(0), 0)
      dummy = load_user_sub('eig_sr'//char(0), 0)
      dummy = load_user_sub('eig_sr_inv'//char(0), 0)
      dummy = load_user_sub('copy_fock'//char(0), 0)
      dummy = load_user_sub('diis_setup'//char(0), 0)
      dummy = load_user_sub('compute_diis'//char(0), 0)
      dummy = load_user_sub('write_blocks_to_list'//char(0), 
     *             0)
      dummy = load_user_sub('read_list_to_blocks'//char(0), 
     *             0)
      dummy = load_user_sub('remove_diagonal'//char(0), 0)
      dummy = load_user_sub('return_diagonal'//char(0), 0)
      dummy = load_user_sub('fock_denominator'//char(0),
     *            0)
      dummy = load_user_sub('set_flags'//char(0), 0)
      dummy = load_user_sub('set_flags2'//char(0), 0)
      dummy = load_user_sub('der2_comp'//char(0), 0)
      dummy = load_user_sub('fock_der'//char(0), 0)
      dummy = load_user_sub('overlap_der'//char(0), 0)
      dummy = load_user_sub('scontxy'//char(0), 0)
      dummy = load_user_sub('hcontxy'//char(0), 0)
      dummy = load_user_sub('compute_sderivative_integrals'//char(0),
     *                       0)
      dummy = load_user_sub('read_hess'//char(0), 0)
      dummy = load_user_sub('return_h1'//char(0), 0)

      dummy = load_user_sub('smon_on'//char(0), 
     *                       0)
      dummy = load_user_sub('smon_off'//char(0), 
     *                       0)
      dummy = load_user_sub('scf_rhf'//char(0), 0)
      dummy = load_user_sub('array_copy'//char(0), 0)
      dummy = load_user_sub('energy_adenominator'//char(0),
     *                       0) 
      dummy = load_user_sub('energy_bdenominator'//char(0),
     *                       0) 
      dummy = load_user_sub('energy_abdenominator'//char(0),
     *                       0) 
      dummy = load_user_sub('remove_xd'//char(0), 0)
      dummy = load_user_sub('remove_ds'//char(0), 0)
      dummy = load_user_sub('remove_ss'//char(0), 0)
      dummy = load_user_sub('remove_dd'//char(0), 0)
      dummy = load_user_sub('removeoo_dd'//char(0), 0)
      dummy = load_user_sub('removevv_dd'//char(0), 0)
      dummy = load_user_sub('remove_sd'//char(0), 0)
      dummy = load_user_sub('remove_sx'//char(0), 0)
      dummy = load_user_sub('remove_dx'//char(0), 0)
c     dummy = load_user_sub('copy_ab'//char(0), copy_ab)
c     dummy = load_user_sub('copy_ba'//char(0), copy_ba)
      dummy = load_user_sub('copy_ff'//char(0), 0)
c     dummy = load_user_sub('open_amp'//char(0), open_amp)
      dummy = load_user_sub('dump_amp'//char(0), 0)
      dummy = load_user_sub('comp_ovl3c'//char(0), 0)
      dummy = load_user_sub('check_dconf'//char(0), 0)
      dummy = load_user_sub('dropmo_expand_basis'//char(0), 
     *                       0)
      dummy = load_user_sub('square_root'//char(0), 0)
      dummy = load_user_sub('norm_fac'//char(0), 0)
      dummy = load_user_sub('return_sval'//char(0), 0)
      dummy = load_user_sub('return_diagonal4'//char(0),
     *                      0)
      dummy = load_user_sub('symm_force_a'//char(0),
     *                      0)
      dummy = load_user_sub('symm_force_i'//char(0),
     *                      0)
      dummy = load_user_sub('place_sval'//char(0), 0)
      dummy = load_user_sub('place_one'//char(0), 0)
      dummy = load_user_sub('place_one2'//char(0), 0)
      dummy = load_user_sub('place_one3'//char(0), 0)
      dummy = load_user_sub('place_one4'//char(0), 0)
      dummy = load_user_sub('place_one5'//char(0), 0)
      dummy = load_user_sub('place_one6'//char(0), 0)
      dummy = load_user_sub('place_oneb'//char(0), 0)
      dummy = load_user_sub('place_one2b'//char(0), 0)
      dummy = load_user_sub('place_one3b'//char(0), 0)
      dummy = load_user_sub('place_one4b'//char(0), 0)
      dummy = load_user_sub('place_one5b'//char(0), 0)
      dummy = load_user_sub('place_one6b'//char(0), 0)
      dummy = load_user_sub('place_one_dip'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_2'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_3'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_4'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_5'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_6'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_7'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dip_8'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_2'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_3'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_4'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_5'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_6'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_7'//char(0),
     *                                      0)
      dummy = load_user_sub('place_one_dea_8'//char(0),
     *                                      0)
      dummy = load_user_sub('eomroot_print'//char(0), 0)
      dummy = load_user_sub('eomroot_print_new'//char(0), 
     *                       0)
c     dummy = load_user_sub('smooth'//char(0), smooth)
c     dummy = load_user_sub('smooth4'//char(0), smooth4)
      dummy = load_user_sub('eig_nonsymm'//char(0),
     *                       0)
      dummy = load_user_sub('apply_den2'//char(0), 0)
      dummy = load_user_sub('apply_den2_nor'//char(0), 0)
      dummy = load_user_sub('apply_den4'//char(0), 0)
      dummy = load_user_sub('apply_den4_nodiag'//char(0),
     *                       0)
      dummy = load_user_sub('energy_tdenominator'//char(0),
     *                       0)
      
c     dummy = load_user_sub('compute_aaaa_batch'//char(0),
c    *                       compute_aaaa_batch)
c     dummy = load_user_sub('compute_aaab_batch'//char(0),
c    *                       compute_aaab_batch)
      dummy = load_user_sub('compute_aabb_batch'//char(0),
     *                       0)
c     dummy = load_user_sub('compute_aabc_batch'//char(0),
c    *                       compute_aabc_batch)
c     dummy = load_user_sub('compute_abab_batch'//char(0),
c    *                       compute_abab_batch)
c     dummy = load_user_sub('compute_abac_batch'//char(0),
c    *                       compute_abac_batch)
      dummy = load_user_sub('compute_abcd_batch'//char(0),
     *                       0)
      dummy = load_user_sub('compute_no4c_batch'//char(0),
     *                       0)
      dummy = load_user_sub('remove_atom_rud1'//char(0),
     *                       0)
      dummy = load_user_sub('remove_atom_rud2'//char(0),
     *                       0)
      dummy = load_user_sub('der4_comp'//char(0), 0)
      dummy = load_user_sub('set_flags4'//char(0), 0)
      dummy = load_user_sub('timestamp'//char(0), 0)
      dummy = load_user_sub('c1_print'//char(0), 0)
      dummy = load_user_sub('c1b_print'//char(0), 0)
      dummy = load_user_sub('c2aa_print'//char(0), 0)
      dummy = load_user_sub('c2ab_print'//char(0), 0)
      dummy = load_user_sub('c2bb_print'//char(0), 0)
      dummy = load_user_sub('pardo_sects'//char(0), 0)
      dummy = load_user_sub('get_ijk'//char(0), 0)
      dummy = load_user_sub('set_ijk_aaa'//char(0), 0)
      dummy = load_user_sub('set_ijk_aaa_nosymm'//char(0), 0)
      dummy = load_user_sub('stripi'//char(0), 0)
      dummy = load_user_sub('sum_64ss'//char(0), 0)
      dummy = load_user_sub('set_ijk_aab'//char(0), 0)
      dummy = load_user_sub('set_ijk_aab_nosymm'//char(0), 0)
      dummy = load_user_sub('get_my_rank'//char(0), 0)
      dummy = load_user_sub('broadcast_array'//char(0), 0)
      dummy = load_user_sub('checkpoint'//char(0), 0)
      dummy = load_user_sub('get_restart_status'//char(0), 
     *                       0)
      dummy = load_user_sub('commit_checkpoint'//char(0), 
     *                       0)
      dummy = load_user_sub('crash'//char(0), 0)
C
C
C             ...Watson: XYZ moment integrals
C
      dummy = load_user_sub('return_ovl'//char(0), 0)
      dummy = load_user_sub('return_derv_xyz'//char(0), 0)
      dummy = load_user_sub('dipole_moment'//char(0), 0)
      dummy = load_user_sub('second_moment'//char(0), 0)
      dummy = load_user_sub('energy_ty_denominator'//char(0),
     *                       0)
      dummy = load_user_sub('reorder_energy'//char(0), 0)
      dummy = load_user_sub('return_1st_mom'//char(0), 0)
      dummy = load_user_sub('return_2nd_mom'//char(0), 0)

      dummy = load_user_sub('nuc_dipole_moment'//char(0),
     *                       0)
      dummy = load_user_sub('nuc_dipole_derivative'//char(0),
     *                       0)

      dummy = load_user_sub('return_x'//char(0), 0)
      dummy = load_user_sub('return_y'//char(0), 0)
      dummy = load_user_sub('return_z'//char(0), 0)

      dummy = load_user_sub('return_xx'//char(0), 0)
      dummy = load_user_sub('return_yy'//char(0), 0)
      dummy = load_user_sub('return_zz'//char(0), 0)

      dummy = load_user_sub('return_xy'//char(0), 0)
      dummy = load_user_sub('return_xz'//char(0), 0)
      dummy = load_user_sub('return_yz'//char(0), 0)

      dummy = load_user_sub('print_eom_dens_info'//char(0),
     +                       0)
c
c -------------------------------------------------------------------- 
c VFL Instructions needed to perform 'fast' scf calculations 
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('compute_batch1'//char(0), 0)
      dummy = load_user_sub('compute_batch2'//char(0), 0)
      dummy = load_user_sub('compute_batch3'//char(0), 0)
      dummy = load_user_sub('compute_batch4'//char(0), 0)
      dummy = load_user_sub('compute_batch5'//char(0), 0)
      dummy = load_user_sub('compute_batch6'//char(0), 0)
      dummy = load_user_sub('compute_batch7'//char(0), 0)
      dummy = load_user_sub('compute_batch8'//char(0), 0)

      dummy = load_user_sub('compute_ubatch1'//char(0), 0)
      dummy = load_user_sub('compute_ubatch2'//char(0), 0)
      dummy = load_user_sub('compute_ubatch3'//char(0), 0)
      dummy = load_user_sub('compute_ubatch4'//char(0), 0)
      dummy = load_user_sub('compute_ubatch5'//char(0), 0)
      dummy = load_user_sub('compute_ubatch6'//char(0), 0)
      dummy = load_user_sub('compute_ubatch7'//char(0), 0)
      dummy = load_user_sub('compute_ubatch8'//char(0), 0)

      dummy = load_user_sub('form_iad'//char(0), 0)
      dummy = load_user_sub('form_ibd'//char(0), 0)

      dummy = load_user_sub('set_itol'//char(0), 0)
      dummy = load_user_sub('fassign'//char(0), 0)
c
c -------------------------------------------------------------------- 
c VFL Instructions needed to perform 'super' T calculations 
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('set_t3blocks_a'//char(0), 0)
      dummy = load_user_sub('set_t3blocks_i'//char(0), 0)
      dummy = load_user_sub('compt3_a'//char(0), 0)
      dummy = load_user_sub('compt3_i'//char(0), 0)
      dummy = load_user_sub('prefetch_on'//char(0), 0)
      dummy = load_user_sub('prefetch_off'//char(0), 0)
c
c -------------------------------------------------------------------- 
c VFL Instruction needed to perform atomic density guess  
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('scf_atom'//char(0), 0) 
c
c -------------------------------------------------------------------- 
c VFL Instruction needed for printing, FNO, ect.. updated FEB. 29 2012  
c -------------------------------------------------------------------- 
c
      dummy = load_user_sub('print_rel_info'//char(0),
     *                       0)
      dummy = load_user_sub('temp_x'//char(0), 0)
      dummy = load_user_sub('corder'//char(0), 0)
      dummy = load_user_sub('form_fno'//char(0), 0)
      dummy = load_user_sub('form_fnob'//char(0), 0)
      dummy = load_user_sub('maxamp_print'//char(0), 0)
      dummy = load_user_sub('form_fock_rohf'//char(0), 0)
c
c --------------------------------------------------------------------
c VFL Instruction needed for DEA/DIP updated AUG. 14 2012
c --------------------------------------------------------------------
c
      dummy = load_user_sub('write_scfdata'//char(0), 0)
      dummy = load_user_sub('set_np2'//char(0), 0)
      dummy = load_user_sub('sdrop'//char(0), 0)
      dummy = load_user_sub('asymm_force_a'//char(0), 0)
      dummy = load_user_sub('asymm_force_i'//char(0), 0)
      dummy = load_user_sub('symm_force_ij'//char(0), 0)
      dummy = load_user_sub('return_h1_nodiag'//char(0),
     *                       0)
c
c --------------------------------------------------------------------
c Watson instruction needed to write out density
c --------------------------------------------------------------------
c
      dummy = load_user_sub('dens2jobarc'//char(0), 0)
      dummy = load_user_sub('change_occ_dens'//char(0), 0)
      dummy = load_user_sub('change_vrt_dens'//char(0), 0)
      dummy = load_user_sub('add_scal2diag'//char(0), 0)
      dummy = load_user_sub('calc_trace'//char(0), 0)
      dummy = load_user_sub('v_nuc_nuc'//char(0), 0)
c      dummy = load_user_sub('vccs_change_x'//char(0), vccs_change_x)
      dummy = load_user_sub('write_coefficients'//char(0),
     +                       0)
      dummy = load_user_sub('read_coefficients'//char(0),
     +                       0)
      dummy = load_user_sub('scf_atom_coeff'//char(0), 0)
c
c -------------------------------------------------------------------- 
c Instructions needed in the CCSD(T) gradient  
c --------------------------------------------------------------------
C Ajith Perera, miscellaneous developments. 

      dummy = load_user_sub('sum_2d_array'//char(0), 0)

      dummy = load_user_sub('compute_1soi_xbatch'//char(0),0)
      dummy = load_user_sub('compute_1soi_ybatch'//char(0),0)
      dummy = load_user_sub('compute_1soi_zbatch'//char(0),0)

      dummy = load_user_sub('compute_2soi_xbatch'//char(0),0)
      dummy = load_user_sub('compute_2soi_ybatch'//char(0),0)
      dummy = load_user_sub('compute_2soi_zbatch'//char(0),0)

      dummy = load_user_sub('write_vecs2jarc'//char(0),0)

      dummy = load_user_sub('index_match'//char(0), 0)
      dummy = load_user_sub('ecp_dercont'//char(0), 0) 
c--------------------------------------------------------------------
c VFL Instruction needed for restricted pardo  updated JULY 22012
c--------------------------------------------------------------------
      dummy = load_user_sub('init_section'//char(0), 0)
      dummy = load_user_sub('prestrict'//char(0), 0)
      dummy = load_user_sub('doprestrict'//char(0), 0)
c--------------------------------------------------------------------
c Jason Byrd misc. development additions
c--------------------------------------------------------------------
      dummy = load_user_sub('sort_fno'//char(0), 0)
      dummy = load_user_sub('dropcore_fno'//char(0), 0)
c--------------------------------------------------------------------
c Watson, added for general interfaces (ie. read FCIDUMP file for Molpro)
c--------------------------------------------------------------------
c      dummy = load_user_sub('read_interface'//char(0),read_interface)
c      dummy = load_user_sub('get_interface'//char(0),get_interface)
c      call set_upgrade_flag(dummy)
      dummy = load_user_sub('c1_full_print'//char(0),0)
C
C Jason Byrd
c--------Explicitly-correlated part-------------------------------------
      dummy = load_user_sub('f12_integrals'//char(0), 0)
      dummy = load_user_sub('f12_c_coef'//char(0), 0)
      dummy = load_user_sub('mkexch'//char(0), 0)
      dummy = load_user_sub('get_grid_size'//char(0), 0)
      dummy = load_user_sub('grid_point_range'//char(0), 0)
      dummy = load_user_sub('f12_2center_moobj'//char(0), 0)
      dummy = load_user_sub('f12_2center_mxobj'//char(0), 0)
      dummy = load_user_sub('f12_2center_myobj'//char(0), 0)
      dummy = load_user_sub('f12_2center_mzobj'//char(0), 0)
      dummy = load_user_sub('grid_point_weight'//char(0), 0)
      dummy = load_user_sub('int1_setup'//char(0), 0)
      dummy = load_user_sub('f12_1el_gen'//char(0), 0)
      dummy = load_user_sub('energy_numerator'//char(0), 0)
      dummy = load_user_sub('lindep_remove'//char(0), 0)
c---------Equation-of-motion part---------------------------------------
      dummy = load_user_sub('eomiter'//char(0), 0)
      dummy = load_user_sub('eomdiag'//char(0), 0)
      dummy = load_user_sub('eomchunk'//char(0), 0)
      dummy = load_user_sub('eomnewvec'//char(0), 0)
      dummy = load_user_sub('eomovermax'//char(0), 0)
      dummy = load_user_sub('eominitguess_ip'//char(0), 0)
      dummy = load_user_sub('eomcopyroots'//char(0), 0)
      dummy = load_user_sub('apply_den1'//char(0), 0)
      dummy = load_user_sub('apply_den3'//char(0), 0)
      dummy = load_user_sub('addrootindex'//char(0), 0)
      dummy = load_user_sub('eomgetroot'//char(0), 0)
      dummy = load_user_sub('eomprintcorrnorm'//char(0), 0)
      dummy = load_user_sub('setauxvec'//char(0), 0)
      dummy = load_user_sub('eomovertable'//char(0), 0)
      dummy = load_user_sub('make_3body_diag_ip'//char(0), 0)
      dummy = load_user_sub('eomtargetroot'//char(0), 0)
      dummy = load_user_sub('eomiproots'//char(0), 0)
c----------(T) correction for IP-EOMCC----------------------------------
      dummy = load_user_sub('denom_eomip_pt'//char(0), 0)
      dummy = load_user_sub('apply_den5'//char(0), 0)
c-------------frozen-orbital F12 calculation----------------------------
      dummy = load_user_sub('frag_index_range'//char(0), 0)
c-----------f12 info----------------------------------------------------
      dummy = load_user_sub('f12info'//char(0), 0)
c-------------------------------------------------------------------- 
c

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine eigen_nonsymm_calc(x, nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c   Calculates the eigenvalues and eigenvectors of a 2-d square matrix.
c   The matrix does NOT have to be symmetric. 
c   The matrix is also diagonalized on output.
c
c   The eigenvalues are stored in a common block.  
c   The instruction is executed as follows:
c   
c   execute eig Array1 Array2
c
c   where Array1 is the input matrix that is to be diagonalized.
c         Array2 is the matrix whose columns are the eigenvectors of Array1.
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      integer n

      if (nindex .ne. nindex2) then
         print *,'Error: Both arrays in EIG_NONSYMM must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex2,' indices.'
         call abort_job()
      endif

      n = eval(1) - bval(1) + 1

c---------------------------------------------------------------------------
c   Diagonalization.
c---------------------------------------------------------------------------
      call diag_nonsymm(x, x2, n)

c     call print_eig(x(ievec), n)

      return
      end

      subroutine diag_nonsymm(a,b,n)
      implicit none
      include 'machine_types.h'
      include 'parallel_info.h'

      integer n 
      double precision a(n,n),b(n,n)
      double precision wr(n), wi(n), z(n,n),fv1(n),x 
      integer iv1(n)
      integer i, j, ierr 
      integer*8 arg64(3), iarg64(n)
c
c      do i = 1, n 
c      do j = 1, n 
c      write(6,*)'      a(',i,',',j,')=',a(i,j) 
c      enddo 
c      enddo 
c
      do i = 1, n 
      do j = 1, n 
         b(i,j) = 0.0d0 
      enddo 
      enddo 

c ----------------------------------------------------------------------
c   Call the ACESII "eig" routine.
c-----------------------------------------------------------------------
#ifdef ACES64
      arg64(1) = n
      arg64(2) = 1  
      call rg(arg64(1),arg64(1),a,wr,wi,arg64(2),z,iarg64,fv1,arg64(3))   
      ierr = arg64(3) 
#else
      call rg(n,n,a,wr,wi,1,z,iv1,fv1,ierr)   
#endif
c
c Put the eigenvalues on the diagonal of B. 
c ----------------------------------------- 
c
c      write(6,*)'space dimension = ',n
      do i = 1, n 
         a(i,i) = wr(i) 
c      write(6,*) ' Eig of A, real: ',wr(i), 'img: ',wi(i) 
      enddo 
c
c Put the real part of the eigenvectors in A. 
c ------------------------------------------- 
c
c     write(6,*) ' Eigenvectors of diagonalized array', n, n  
      do i = 1, n 
      do j = 1, n 
         b(i,j) = z(i,j) 
      enddo 
      enddo 
c
c Calculate norm of eigenvectors
c ------------------------------------------- 
      do i = 1, n 
      x=0.0d+0
c
      do j = 1, n 
      x = x + (b(j,i) * z(j,i) )
      enddo 
c
c Normalize the eigenvectors
c ------------------------------------------- 
      do j = 1, n 
      b(j,i) = z(j,i) * (1.0d0/(dsqrt( x ))) 
      enddo 
c
      enddo 
c 
      return
      end

C ***************************************************************
C  STANDARD DIAGONALIZATION PROCEDURE FOR NON-HERMITEAN MATRICES
C ***************************************************************
C
      subroutine rg(nm,n,a,wr,wi,matz,z,iv1,fv1,ierr)
      integer i, j 
c
#ifdef ACES64
      integer*8 n,nm,is1,is2,ierr,matz
      integer*8 iv1(n)
#else
      integer n,nm,is1,is2,ierr,matz
      integer iv1(n)
#endif
      double precision a(nm,n),wr(n),wi(n),z(nm,n),fv1(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real general matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.  complex conjugate
c        pairs of eigenvalues appear consecutively with the
c        eigenvalue having the positive imaginary part first.
c
c        z  contains the real and imaginary parts of the eigenvectors
c        if matz is not zero.  if the j-th eigenvalue is real, the
c        j-th column of  z  contains its eigenvector.  if the j-th
c        eigenvalue is complex with positive imaginary part, the
c        j-th and (j+1)-th columns of  z  contain the real and
c        imaginary parts of its eigenvector.  the conjugate of this
c        vector is the eigenvector for the conjugate eigenvalue.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for hqr
c           and hqr2.  the normal completion code is zero.
c
c        iv1  and  fv1  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c      write(6,*)'rg entered'
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  balanc(nm,n,a,is1,is2,fv1)
      call  elmhes(nm,n,is1,is2,a,iv1)
      if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  hqr(nm,n,is1,is2,a,wr,wi,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  eltran(nm,n,is1,is2,a,iv1,z)

      call  hqr2(nm,n,is1,is2,a,wr,wi,z,ierr)

      if (ierr .ne. 0) go to 50
      call  balbak(nm,n,is1,is2,fv1,n,z)

c     write(6,*) ' Z in rg' 
c     do i = 1, n 
c     do j = 1, n 
c        write(6,*) i, j, z(i,j) 
c     enddo 
c     enddo 

   50 return
      end

         SUBROUTINE  ERD__RYS_X_ROOTS_WEIGHTS_YUKAWA
     +
     +                    ( NT,NTGQP,
     +                      NGQP,NMOM,
     +                      TVAL,UVAL,RYSZERO,
     +                      A,B,
     +                      MOM,
     +                      DIA,OFF,
     +                      ROW1,ROW2,
     +
     +                                RTS,
     +                                WTS )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__RYS_X_ROOTS_WEIGHTS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : Master routine to evaluate roots and weights in the
C                interval [0,1] over the Rys weight function:
C
C
C                                       exp(-T*x)+U*(1-1/x)
C                             W   (x) = ----------------
C                              Rys           2*sqrt(x)
C
C
C                using the general Gaussian Quadrature technique
C                consisting of the following basic steps:
C
C
C                  Input:
C
C                    NT           =  # of T-values
C                    NTGQP        =  # of roots times # of T-values
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    TVAL         =  the T-values
c                    UVAL         =  the U-values
C                    RYSZERO      =  the zeroth Rys moments for all
C                                    T-values
C                    A,B          =  will contain the recurrence
C                                    coefficients for the auxillary
C                                    polynomials
C                    MOM          =  will contain the normed auxillary
C                                    polynomial modified moments
C                    DIA,OFF      =  will contain the diagonal and
C                                    offdiagonal elements of the
C                                    tridiagonal symmetric terminal
C                                    matrix
C                    ROW1,ROW2    =  will be used to evaluate the
C                                    tridiagonal elements of the
C                                    symmetric terminal matrix in an
C                                    efficient way using Sack and
C                                    Donovan's method
C
C                  Output:
C
C                    RTS          =  the roots array
C                    WTS          =  the weights array
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INCLUDE    'erd__jacobi.inc'

         INTEGER    I,J,M,N
         INTEGER    IMAX,JMAX
         INTEGER    IP1,JP1
         INTEGER    ITER
         INTEGER    MOMMAX
         INTEGER    MXITER
         INTEGER    NGQP
         INTEGER    NMOM
         INTEGER    NRTS
         INTEGER    NT,NTGQP

         DOUBLE PRECISION   C,D,F,G,P,R,S
         DOUBLE PRECISION   BINC,SINC,STGEXP
         DOUBLE PRECISION   LIM1,LIM2,LIM3
         DOUBLE PRECISION   MOMI,MOMIM1,MOMIP1,MOMZERO
         DOUBLE PRECISION   R1
         DOUBLE PRECISION   ROOT
         DOUBLE PRECISION   SCALE
         DOUBLE PRECISION   SIGMA,THETA
         DOUBLE PRECISION   T,TINV,TINV2,TINVHF,TINVSQ,TEXP,TPOWER
         DOUBLE PRECISION   TEST1,TEST2
         DOUBLE PRECISION   ZMOM,ZINV
         DOUBLE PRECISION   ZERO,EXTREM,VSMALL,SMALL,TENTH,
     +                      HALF,ONE,ONEP5,TWO,THREE,TEN,TLIMIT

         DOUBLE PRECISION   A       (1:NMOM)
         DOUBLE PRECISION   B       (2:NMOM)
         DOUBLE PRECISION   MOM     (1:NMOM)
         DOUBLE PRECISION   DIA     (1:NGQP)
         DOUBLE PRECISION   OFF     (1:NGQP)
         DOUBLE PRECISION   ROW1    (1:NMOM)
         DOUBLE PRECISION   ROW2    (1:NMOM-1)

         DOUBLE PRECISION   RYSZERO (1:NT)
         DOUBLE PRECISION   TVAL(1:NT), UVAL(1:NT)

         DOUBLE PRECISION   RTS     (1:NTGQP)
         DOUBLE PRECISION   WTS     (1:NTGQP)

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (EXTREM  =  1.0D-300)
         PARAMETER  (VSMALL  =  1.0D-16)
         PARAMETER  (SMALL   =  1.0D-6)
         PARAMETER  (TENTH   =  0.1D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0)
         PARAMETER  (ONEP5   =  1.5D0)
         PARAMETER  (TWO     =  2.D0)
         PARAMETER  (THREE   =  3.D0)
         PARAMETER  (TEN     =  10.D0)
         PARAMETER  (TLIMIT  =  15.D0)

         PARAMETER  (MOMMAX  =  30)
         PARAMETER  (MXITER  =  30)
C
C
C------------------------------------------------------------------------|
C   Invocation of Toru Shiozaki's interpolation scheme for Rys roots     |
C       and weights using two-dimentional interpolation procedure        |
c------------------------------------------------------------------------

c         DO J=1,NT
c         UVAL(J)=1.d-7
c         write(6,*) TVAL(J),'===',UVAL(J), J
c         ENDDO

c         call root2(TVAL, UVAL, RTS, WTS, NT)

c           DO I=1,NTGQP          
c           write(6,*) RTS(I),'===',WTS(I), I 
c           ENDDO
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE FSIODRV(ICORE,MAXCOR,IUHF,IDO,IACTIVE,
     &                   NACTIVE,NBAS,I0,TFULL)
C
C DRIVER FOR CONSTRUCTION OF THE GATHER-SCATTER I/O VECTORS 
C NEEDED FOR CALCULATIONS INVOLVING ACTIVE OR INACTIVE INDICES
C
      IMPLICIT INTEGER (A-Z)



c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN

      PARAMETER (MAXBASFN=1000)



c maxbasfn.par : end


      DATA MXBAS /MAXBASFN/
C
C     NOTE: ICore is really MaxCor long, but we can't use anything
C     below I0.
C
      DIMENSION ICORE(I0+MAXCOR),IDO(22),SPIN(2,22),NACTIVE(2)
      CHARACTER*3 TYPE(2,22),LFTTYP,RHTTYP
      CHARACTER*4 PACK(22),TYPEX
      DIMENSION IACTIVE(MAXBASFN,2),IVECTOR(MAXBASFN,3,2),
     &          POPLFT(8),POPRHT(8)
C
      Common /FSORBS/ IVector
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM   / POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
C
      Integer NOccO(2), NVrtO(2)
      Common /Info/ NOccO, NVrtO
C
C COMMON BLOCK WITH POPULATIONS FOR VARIOUS INDEX TYPES:
C
C
      COMMON /FSSYMPOP/ FSDPDAN(8,22),FSDPDNA(8,22),FSDPDAA(8,22),
     &                  FSDPDIN(8,22),FSDPDNI(8,22),FSDPDII(8,22),
     &                  FSDPDAI(8,22),FSDPDIA(8,22)
C
C POSITIONS IN CORE WHERE THE GATHER-SCATTER VECTORS ARE LOCATED.
C
C        LEFT INDEX    - IRREP
C        CENTRAL INDEX - SYMMETRY TYPE
C        RIGHT INDEX   - ORBITAL TYPE (AI, IA, ETC)
C
      COMMON /FSIOLOC/ IFSPOS(8,22,8),ISCRLC, IFSPOSZ(8,22,8)
C
C     Common block to hold labels for the index types
C
      Character*2 FSDsLbl(8)
      Common /FSIOC/ FSDsLbl
C
C&      Include 'tempio.inc'
C
C     For temporary I/O vectors, etc.
C
C     TIOBas  Pointer to space allocated in ICore for temporary I/O
C     TIOSiz  Size of space allocated in ICore for temporary I/O
C     TIOPos  Pointer to gather vector in ICore
C     TIOZPos Position of zero list in ICore
C     TIODPD  Distribution size
C     TIOFull If it is set to 1, the lists are 'right' after 
C             FSPUT and FSPUTT1. Otherwise only the active part
C	      can be used.
C     TIOBufSz FSIO buffer size -- needed by FSMAP to properly
C              handle writing lists of TIOFull=1.
C
C     Dimensions are: 8 irrpes, 22 list types (even though we
C     don't use most of them), up to 5 different types of distributions.
C
C     TIOZPos is only used by UPLE and UPLT packing schemes.  For the
C     others, TIOZPos(*, IType, IDsTyp) must be 0 or FSGET/FSPUT will be
C     very confused.
C
      Integer TMxDsTy
      Parameter (TMxDsTy = 5)
C
      Integer TIOBas, TIOSiz, TIOPos(8, 22, TMxDsTy),
     $   TIOZPos(8, 22, TMxDsTy), TIODPD(8, 22, TMxDsTy), TIOFull,
     $   TIOBufSz
C
C     Text labels for the names of the temp. I/O distributions
C     (slowest dimension of TIO info arrays).
C
      Character*2 TDsLbl(TMxDsTy)
C
      Common /TempIO/ TIOBas, TIOSiz, TIOPos, TIOZPos, TIODPD, TIOFull,
     $   TIOBufSz
      Common /TempIOC/ TDsLbl
C
      DATA TYPE /'VRT','VRT' , 'VRT','VRT' , 'OCC','OCC' ,
     &           'OCC','OCC' , 'VRT','VRT' , 'VRT','VRT' ,
     &           'OCC','OCC' , 'OCC','OCC' , 'VRT','OCC' ,
     &           'VRT','OCC' , 'VRT','OCC' , 'VRT','OCC' ,
     &           'VRT','VRT' , 'OCC','OCC' , 'VRT','VRT' ,
     &           'OCC','VRT' , 'OCC','VRT' , 'OCC','VRT' ,
     &           'VRT','VRT' , 'VRT','VRT' , 'OCC','OCC' ,
     &           'OCC','OCC'/
      DATA SPIN / 1,1 , 2,2 , 1,1 , 2,2 , 1,1 , 2,2 , 1,1 , 2,2 , 
     &            1,1 , 2,2 ,
     &            1,2 , 2,1 , 1,2 , 1,2 , 1,2 , 1,1 , 2,2 , 1,2 ,
     &            1,1 , 2,2 ,
     &            1,1 , 2,2/
      DATA PACK /'UPLT','UPLT','UPLT','UPLT','UPLE',
     &           'UPLE','UPLE','UPLE','FULL','FULL',
     &           'FULL','FULL','FULL','FULL','FULL',
     &           'FULL','FULL','FULL','FULL','FULL',
     &           'FULL','FULL'/
C SG 2/96
C      Data FSDsLbl /'AN', 'NA', 'AA', 'IN', 'NI', 'II', 'AI', 'IA'/
      FSDsLbl(1) = 'AN'
      FSDsLbl(2) = 'NA'
      FSDsLbl(3) = 'AA'
      FSDsLbl(4) = 'IN'
      FSDsLbl(5) = 'NI'
      FSDsLbl(6) = 'II'
      FSDsLbl(7) = 'AI'
      FSDsLbl(8) = 'IA'
C
C     SET TIOFull. If it is set to 1, the lists are 'right' after 
C             FSPUT and FSPUTT1. Otherwise only the active part
C	      can be used.
      TIOFull=TFull
C
C FILL VECTOR OF LENGTH NBAS WITH "1" 
C
      CALL IZERO(IFSPOS,8*22*8)
      CALL IZERO(IFSPOSZ,8*22*8)
      CALL IZERO(IVECTOR,MXBAS*6)
      DO 5 ISPIN=1,2
         DO 10 ITYPE=1,2
            DO 20 IPOS=1,NBAS
               IVECTOR(IPOS,ITYPE,ISPIN)=1
 20         CONTINUE
 10      CONTINUE
 5    CONTINUE
C
C     NOW ZERO OUT POSITIONS WHICH CORRESPOND TO ACTIVE ORBITALS (ITYPE=2)
C     AND POSITIONS WHICH CORRESPOND TO INACTIVE ORBITALS (ITYPE=3)
C
      DO 25 ISPIN=1,2
         DO 28 I=1,NACTIVE(ISPIN)
            IPOS=IACTIVE(I,ISPIN) 
            IVECTOR(IPOS,2,ISPIN)=0
            IVECTOR(IPOS,3,ISPIN)=1
 28      CONTINUE
 25   CONTINUE
C
      CALL FSINIPOP(IVECTOR,MXBAS,IUHF)
C
C     For ISYTYP 1-8, we need room for the "zero vector" accompanying 
C     the gather vector.  This is relatively small, and the space
C     required can be accurately and easily determined in advance:
C
C     AN + IN = NN, NA + NI = NN, AA + AI + IA + II = NN, or 3NN in total.
C
C     ISYTYP  Type    Expanded size
C        1    V <  V      V x V
C        2    v <  v      v x v
C        3    O <  O      O x O
C        4    o <  o      o x o
C        5    V <= V      V x V
C        6    v <= v      v x v
C        7    O <= O      O x O
C        8    o <= o      o x o
C     TOTAL:       2 ( VxV + vxv + OxO + oxo )
C
      IZOff = I0
C
      IZNeed = 3 * 2 * ( NVrtO(1)**2 + NVrtO(2)**2 + NOccO(1)**2 +
     $   NOccO(2)**2 )
      IOFF = I0 + IZNeed
cSSS      Write (6, *) '@FSIODRV-I, Allocated ', IZNeed, ' words for ',
cSSS     $   '''zero vectors''.'
C
C     CALCULATE THE LENGTH OF THE I/O BUFFER. ITS SPACE IS ALLOCATED
C     LATER IN THIS ROUTINE
C     THE ACTUAL SIZE IS GREATER BY ONE IN ORDER TO ALLOCATE SPACE
C     FOR THE 'DIAGONAL' ELEMENTS
C
      DSZMAX=0
      DO 100 I=1,22
       DO 101 J=1,8
        DSZMAX=MAX(DSZMAX,IRPDPD(J,I))
101    CONTINUE
100   CONTINUE
      DSZMAX=DSZMAX+1
C
C NOW GO THROUGH THE DIFFERENT DISTRIBUTION TYPES ONE BY ONE
C
      DO 30 ITYPE=1,22
       IF(IDO(ITYPE).EQ.1)THEN
        LFTTYP=TYPE(1,ITYPE)
        LFTSPN=SPIN(1,ITYPE) 
        RHTTYP=TYPE(2,ITYPE)
        RHTSPN=SPIN(2,ITYPE)
        TYPEX=PACK(ITYPE)
        IF(LFTTYP.EQ.'OCC')CALL ICOPY(8,POP(1,LFTSPN),1,POPLFT,1)
        IF(LFTTYP.EQ.'VRT')CALL ICOPY(8,VRT(1,LFTSPN),1,POPLFT,1)
        IF(RHTTYP.EQ.'OCC')CALL ICOPY(8,POP(1,RHTSPN),1,POPRHT,1)
        IF(RHTTYP.EQ.'VRT')CALL ICOPY(8,VRT(1,RHTSPN),1,POPRHT,1)
C
C LEFT INDEX ACTIVE, RIGHT INDEX FULL
C
cSSS        Write (6, 9999) 1, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,3,LFTSPN),IVECTOR(1,1,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDAN(1,ITYPE),
     &             IFSPOS(1,ITYPE,1),IOFF,
     $     IFSPOSZ(1, ITYPE, 1), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX FULL  , RIGHT INDEX ACTIVE
C
cSSS        Write (6, 9999) 2, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,1,LFTSPN),IVECTOR(1,3,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDNA(1,ITYPE),
     &             IFSPOS(1,ITYPE,2),IOFF,
     $     IFSPOSZ(1, ITYPE, 2), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX ACTIVE  , RIGHT INDEX ACTIVE
C
cSSS        Write (6, 9999) 3, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,3,LFTSPN),IVECTOR(1,3,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDAA(1,ITYPE),
     &             IFSPOS(1,ITYPE,3),IOFF,
     $     IFSPOSZ(1, ITYPE, 3), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX INACTIVE, RIGHT INDEX FULL
C
cSSS        Write (6, 9999) 4, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,2,LFTSPN),IVECTOR(1,1,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDIN(1,ITYPE),
     &             IFSPOS(1,ITYPE,4),IOFF,
     $     IFSPOSZ(1, ITYPE, 4), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX FULL , RIGHT INDEX INACTIVE
C
cSSS        Write (6, 9999) 5, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,1,LFTSPN),IVECTOR(1,2,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDNI(1,ITYPE),
     &             IFSPOS(1,ITYPE,5),IOFF,
     $     IFSPOSZ(1, ITYPE, 5), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX INACTIVE, RIGHT INDEX INACTIVE
C
cSSS        Write (6, 9999) 6, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,2,LFTSPN),IVECTOR(1,2,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDII(1,ITYPE),
     &             IFSPOS(1,ITYPE,6),IOFF,
     $     IFSPOSZ(1, ITYPE, 6), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX ACTIVE, RIGHT INDEX INACTIVE
C
cSSS        Write (6, 9999) 7, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,3,LFTSPN),IVECTOR(1,2,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDAI(1,ITYPE),
     &             IFSPOS(1,ITYPE,7),IOFF,
     $     IFSPOSZ(1, ITYPE, 7), ICore(IZOff), Izoff,Dszmax)
C
C LEFT INDEX INACTIVE, RIGHT INDEX ACTIVE
C
cSSS        Write (6, 9999) 8, IType, LftTyp, LftSpn, RhtTyp, RhtSpn, TypeX
        CALL FSMAP(LFTTYP,RHTTYP,LFTSPN,RHTSPN,TYPEX,POPLFT,POPRHT,
     &             IVECTOR(1,2,LFTSPN),IVECTOR(1,3,RHTSPN),NBAS,
     &             ICORE(IOFF),FSDPDIA(1,ITYPE),
     &             IFSPOS(1,ITYPE,8),IOFF,
     $     IFSPOSZ(1, ITYPE, 8), ICore(IZOff), Izoff,Dszmax)
       ENDIF
30    CONTINUE
 9999 Format(1X, '@FSIODRV-I, distribution type ', I1, ' list type ',
     $   I2, ': ', A, '(', I1, '), ', A, '(', I1, ') ', A)
C
      WRITE(6,1000) '''zero''', IZOFF-I0
      WRITE(6,1000) 'I/O', IOff-IZOFF
1000  FORMAT(T3,'@FSIODRV-I, ', A, ' vectors require ',I8,' words.')
C
C NOW ALLOCATE SPACE FOR THE LARGEST DISTRIBUTION.  THIS IS USED
C AS A SCRATCH AREA IN FSGET. 
C
      IOFF=IOFF+1-iand(IOFF,1)
      ISCRLC=IOFF
      MAXCOR=MAXCOR-(IOFF-I0)-DSZMAX*IINTFP
      I0=IOFF+DSZMAX*IINTFP
      TIOBufSz = DSzMax
C
      Write (6, 1020) DSzMax * IIntFP
 1020 Format(T3, '@FSIODRV-I, I/O buffer requires ', I8, ' words.')
C
C     Find out how much to allocate for "temporary" I/O lists.
C     Putting this in a subroutine reduces clutter here and
C     localizes things that have to change for "temorary" I/O.
C
      Call AllocTIO(MaxCor - I0, TIOSiz)
      Write(6, 1010) TIOSiz
 1010 Format(T3, '@FSIODRV-I, Temporary I/O vectors allocated ', I8,
     $   ' words.')
      TIOBas = I0
      I0 = I0 + TIOSiz
      MAXCOR=MAXCOR-TIOSiz
C
      RETURN
      END

       SUBROUTINE SST02I(WIN,WOUT,NSIZIN,NSIZOT,ISCR,SPTYPE)
C
C THIS ROUTINE ACCEPTS A SYMMETRY PACKED FOUR-INDEX LIST AND RETURNS
C   THE SAME LIST BUT WITH AN ALTERNATIVE SCHEME FOR SYMMETRY PACKING.
C
C THE LIST (A,b;I,j) IS PRESUMED TO BE PACKED AI-bj OR ai-BJ.  
C   THIS ROUTINE RETURNS THE LIST PACKED AS Ab;Ij.  IN A SENSE,
C   THIS ROUTINE FUNCTIONS AS THE INVERSE OF SST002, HENCE ITS NAME.
C
C INPUT: 
C           WIN  - THE SYMMETRY PACKED AB-IJ LIST.
C         NSIZIN - THE TOTAL SIZE OF THE SYM. PACKED INPUT VECTOR.
C         NSIZOT - THE TOTAL SIZE OF THE SYM. PACKED OUTPUT VECTOR.
C         SPTYPE - THE SPIN TYPE FOR THE INPUT LIST
C
C                        'AABB' FOR (AI-bj).
C                        'BBAA' FOR (bj-AI).
C
C OUTPUT: 
C          WOUT  - THE SYMMETRY PACKED Ab-Ij LIST.
C       
C SCRATCH:
C         ISCR   - SCRATCH AREA TO HOLD THE SYMMETRY VECTORS AND INVERSE
C                   SYMMETRY VECTORS WHICH ARE NEEDED. 
C                   (SIZE: NVRTA*NVRTB+NOCCA*NOCCB+NVRTA*NOCCB+
C                          NVRTA*NOCCA+NVRTB*NOCCB)
C         
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*4 REORTP,SPTYPE
      DOUBLE PRECISION WIN(NSIZIN),WOUT(NSIZOT),ISCR(*)
      DIMENSION IOFFTAR(8)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYMINF/NSTART,NIRREP,IRREP0(255,2),DIRPRD(8,8)
      COMMON/SYMPOP/IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
C
      IRREPX=1
C
      IF(SPTYPE.EQ.'BBAA')THEN
C
C CALCULATE SOME OFFSETS
C
       IOFFTAR(1)=1
       DO 5 IRREPR=1,NIRREP-1
        IRREPL=DIRPRD(IRREPX,IRREPR)
        DISSIZ=IRPDPD(IRREPL,10)
        NUMDIS=IRPDPD(IRREPR,9)
        IOFFTAR(IRREPR+1)=IOFFTAR(IRREPR)+DISSIZ*NUMDIS
5      CONTINUE
       IOFF1=1
       DO 10 IRREPR=1,NIRREP
        IRREPL=DIRPRD(IRREPX,IRREPR)
        NUMDIS=IRPDPD(IRREPR,9)
        DISSIZ=IRPDPD(IRREPL,10)
        CALL TRANSP(WIN(IOFF1),WOUT(IOFFTAR(IRREPL)),NUMDIS,DISSIZ)
        IOFF1=IOFF1+NUMDIS*DISSIZ
10     CONTINUE
       TOTSIZ=IOFF1-1
       CALL SCOPY(TOTSIZ,WOUT,1,WIN,1)
      ENDIF
C
      CALL SSTGEN(WIN,WOUT,NSIZIN,VRT(1,1),POP(1,1),VRT(1,2),POP(1,2),
     &            ISCR,IRREPX,'1324')
C
      RETURN
      END

      SUBROUTINE OCCUPY(NIRREP,NBASIR,NBASTOT,EVAL,ISCR,NOCC,ISPIN)
C
C DETERMINES THE OCCUPANCY FOR AN SCF DETERMINANT BASED ON
C  AN EXISTING SET OF EIGENVALUES
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION EVAL(NBASTOT),ISCR(NBASTOT,2),NSPIN(2)
      DIMENSION NBASIR(NIRREP), Nocc(8,2)
C
c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
C
      IONE=1
      CALL GETREC(20,'JOBARC','NMPROTON',IONE,NPROTON)
      ICHARG=IFLAGS(28)
      IMULT=IFLAGS(29)
C
C DETERMINE ALPHA AND BETA OCCUPANCIES
C
      NUMEL=NPROTON-ICHARG
      IALPEX=IMULT-1
      NRHS=NUMEL-IALPEX
      NSPIN(2)=NRHS/2
      NSPIN(1)=NSPIN(2)+IALPEX
C
      IBASIS=0
      DO 10 I=1,NIRREP
       DO 20 J=1,NBASIR(I)
         IBASIS=IBASIS+1
         ISCR(IBASIS,1)=IBASIS
         ISCR(IBASIS,2)=I
20      CONTINUE
10     CONTINUE
C
       CALL IZERO(NOCC(1,ISPIN),8)
       CALL PIKSR2(NBASTOT,EVAL,ISCR)
       DO 40 IOCC=1,NSPIN(ISPIN)
        IPOS=ISCR(IOCC,1)
        IRREP=ISCR(IPOS,2)
        NOCC(IRREP,ISPIN)=NOCC(IRREP,ISPIN)+1
40     CONTINUE
30    CONTINUE
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__XYZ_TO_RY_ABCD
     +
     +                    ( NXYZA,NXYZB,NXYZC,NXYZD,
     +                      NRYA,NRYB,NRYC,NRYD,
     +                      SHELLA,SHELLB,SHELLC,SHELLD,
     +                      ISTART,ZSTART,
     +
     +                            NROWA,NROWB,NROWC,NROWD,
     +                            NROTA,NROTB,NROTC,NROTD,
     +                            Z00A,Z00B,Z00C,Z00D,
     +                            I0A1,I0B1,I0C1,I0D1,
     +                            I0A2,I0B2,I0C2,I0D2,
     +                            IUSED,ZUSED,
     +                            ICORE,ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__XYZ_TO_RY_ABCD
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__XYZ_TO_RY_MATRIX
C  DESCRIPTION : This operation generates all the info needed for
C                cartesian -> spherical transformation of a batch
C                of cartesian integrals (AB|CD). No duplicate info
C                is generated, i.e. the above transmitted pointers
C                of the type Z00x, I0x1 and I0x2 with x=A,B,C,D may
C                coincide if the shell types among the A,B,C,D are
C                equal (see below). The transformation data is placed
C                in two arrays (integer and flp) at the appropriate
C                locations.
C
C                Input:
C
C                    NXYZx = dimension of xyz-monomial basis
C                            corresponding to the shell SHELLx
C                            for x=A,B,C,D.
C
C                     NRYx = dimension of ry-spherical basis
C                            corresponding to the shell SHELLx
C                            for x=A,B,C,D.
C
C                   SHELLx = the shell types for A,B,C,D.
C
C                I(Z)START = Starting location for the integer (flp)
C                            data.
C
C
C                Output:
C
C                    NROWx = maximum # of xyz-monomials contributing
C                            to the ry-components for x=A,B,C,D.
C
C                    NROTx = maximum # of elements in transformation
C                            matrix for x=A,B,C,D. This is equal to
C                            NROWx times NRYx.
C
C                     Z00x = pointer for the transformation matrix
C                            elements for x=A,B,C,D.
C
C                     I0x1 = pointer for the # of row indices leading
C                            to non-zero elements in the transformation
C                            matrix for x=A,B,C,D.
C
C                     I0x2 = pointer for the row index labels of the
C                            non-zero elements in the transformation
C                            matrix for x=A,B,C,D.
C
C                 I(Z)USED = # of integer (flp) words used.
C
C                 I(Z)CORE = The integer (flp) arrays holding the
C                            transformation data.
C
C
C                If any of the A,B,C,D shell labels are equal, their
C                offsets will be set equal in the following sequence,
C                governed by their order of usage:
C
C                    1) If shell C = D, then:
C
C                              Z00C = Z00D
C                              I0C1 = I0D1
C                              I0C2 = I0D2
C
C                    2) If shell B = C or D, then:
C
C                              Z00B = Z00C or Z00D
C                              I0B1 = I0C1 or I0D1
C                              I0B2 = I0C2 or I0D2
C
C                    3) If shell A = B or C or D, then:
C
C                              Z00A = Z00B or Z00C or Z00D
C                              I0A1 = I0B1 or I0C1 or I0D1
C                              I0A2 = I0B2 or I0C2 or I0D2
C
C                Only mutually different transformation matrices +
C                associated data are generated.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         LOGICAL    BDATA,CDATA

         INTEGER    I0A1,I0B1,I0C1,I0D1,I0A2,I0B2,I0C2,I0D2
         INTEGER    ISTART,ZSTART
         INTEGER    IUSED,ZUSED
         INTEGER    NROTA,NROTB,NROTC,NROTD
         INTEGER    NROWA,NROWB,NROWC,NROWD
         INTEGER    NRYA,NRYB,NRYC,NRYD
         INTEGER    NXYZA,NXYZB,NXYZC,NXYZD
         INTEGER    SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER    Z00A,Z00B,Z00C,Z00D,Z0AT,Z0BT,Z0CT,Z0DT

         INTEGER    ICORE (*)

         DOUBLE PRECISION   ZCORE (*)
C
C
C------------------------------------------------------------------------
C
C
C             ...shell D data.
C
C
         IUSED = 0
         ZUSED = 0

         IF (SHELLD.GT.1) THEN
             NROWD = (SHELLD/2+1)*(SHELLD/2+2)/2
             NROTD = NROWD * NRYD
             Z00D = ZSTART
             Z0DT = Z00D + NROTD
             I0D1 = ISTART
             I0D2 = I0D1 + NRYD

             CALL  ERD__XYZ_TO_RY_MATRIX
     +
     +                  ( NXYZD,NRYD,NROWD,
     +                    SHELLD,
     +                    ZCORE (Z0DT),
     +
     +                            ICORE (I0D1),
     +                            ICORE (I0D2),
     +                            ZCORE (Z00D) )
     +
     +
             IUSED = NRYD + NROTD
             ZUSED = NROTD
         ELSE
             NROWD = 0
             NROTD = 0
             Z00D = ZSTART
             I0D2 = ISTART
         END IF
C
C
C             ...shell C data.
C
C
         CDATA = .FALSE.

         IF (SHELLC.GT.1) THEN
             IF (SHELLC.EQ.SHELLD) THEN
                 Z00C = Z00D
                 I0C1 = I0D1
                 I0C2 = I0D2
                 NROWC = NROWD
                 NROTC = NROTD
             ELSE
                 NROWC = (SHELLC/2+1)*(SHELLC/2+2)/2
                 NROTC = NROWC * NRYC
                 Z00C = Z00D + NROTD
                 Z0CT = Z00C + NROTC
                 I0C1 = I0D2 + NROTD
                 I0C2 = I0C1 + NRYC

                 CALL  ERD__XYZ_TO_RY_MATRIX
     +
     +                      ( NXYZC,NRYC,NROWC,
     +                        SHELLC,
     +                        ZCORE (Z0CT),
     +
     +                                ICORE (I0C1),
     +                                ICORE (I0C2),
     +                                ZCORE (Z00C) )
     +
     +
                 IUSED = IUSED + NRYC + NROTC
                 ZUSED = ZUSED + NROTC
                 CDATA = .TRUE.
             END IF
         ELSE
             NROWC = 0
             NROTC = 0
             Z00C = Z00D
             I0C2 = I0D2
         END IF
C
C
C             ...shell B data (being careful, using SHELLD data if
C                SHELLC data is not present!).
C
C
         BDATA = .FALSE.

         IF (SHELLB.GT.1) THEN
             IF (SHELLB.EQ.SHELLC) THEN
                 Z00B = Z00C
                 I0B1 = I0C1
                 I0B2 = I0C2
                 NROWB = NROWC
                 NROTB = NROTC
             ELSE IF (SHELLB.EQ.SHELLD) THEN
                 Z00B = Z00D
                 I0B1 = I0D1
                 I0B2 = I0D2
                 NROWB = NROWD
                 NROTB = NROTD
             ELSE
                 NROWB = (SHELLB/2+1)*(SHELLB/2+2)/2
                 NROTB = NROWB * NRYB
                 IF (CDATA) THEN
                     Z00B = Z00C + NROTC
                     Z0BT = Z00B + NROTB
                     I0B1 = I0C2 + NROTC
                     I0B2 = I0B1 + NRYB
                 ELSE
                     Z00B = Z00D + NROTD
                     Z0BT = Z00B + NROTB
                     I0B1 = I0D2 + NROTD
                     I0B2 = I0B1 + NRYB
                 END IF

                 CALL  ERD__XYZ_TO_RY_MATRIX
     +
     +                      ( NXYZB,NRYB,NROWB,
     +                        SHELLB,
     +                        ZCORE (Z0BT),
     +
     +                                ICORE (I0B1),
     +                                ICORE (I0B2),
     +                                ZCORE (Z00B) )
     +
     +
                 IUSED = IUSED + NRYB + NROTB
                 ZUSED = ZUSED + NROTB
                 BDATA = .TRUE.
             END IF
         ELSE
             NROWB = 0
             NROTB = 0
             Z00B = Z00C
             I0B2 = I0C2
         END IF
C
C
C             ...shell A data (being careful, using SHELLC data if
C                SHELLB data is not present or using SHELLD data if
C                also SHELLC data is not present!).
C
C
         IF (SHELLA.GT.1) THEN
             IF (SHELLA.EQ.SHELLB) THEN
                 Z00A = Z00B
                 I0A1 = I0B1
                 I0A2 = I0B2
                 NROWA = NROWB
                 NROTA = NROTB
             ELSE IF (SHELLA.EQ.SHELLC) THEN
                 Z00A = Z00C
                 I0A1 = I0C1
                 I0A2 = I0C2
                 NROWA = NROWC
                 NROTA = NROTC
             ELSE IF (SHELLA.EQ.SHELLD) THEN
                 Z00A = Z00D
                 I0A1 = I0D1
                 I0A2 = I0D2
                 NROWA = NROWD
                 NROTA = NROTD
             ELSE
                 NROWA = (SHELLA/2+1)*(SHELLA/2+2)/2
                 NROTA = NROWA * NRYA
                 IF (BDATA) THEN
                     Z00A = Z00B + NROTB
                     Z0AT = Z00A + NROTA
                     I0A1 = I0B2 + NROTB
                     I0A2 = I0A1 + NRYA
                 ELSE IF (CDATA) THEN
                     Z00A = Z00C + NROTC
                     Z0AT = Z00A + NROTA
                     I0A1 = I0C2 + NROTC
                     I0A2 = I0A1 + NRYA
                 ELSE
                     Z00A = Z00D + NROTD
                     Z0AT = Z00A + NROTA
                     I0A1 = I0D2 + NROTD
                     I0A2 = I0A1 + NRYA
                 END IF

                 CALL  ERD__XYZ_TO_RY_MATRIX
     +
     +                      ( NXYZA,NRYA,NROWA,
     +                        SHELLA,
     +                        ZCORE (Z0AT),
     +
     +                                ICORE (I0A1),
     +                                ICORE (I0A2),
     +                                ZCORE (Z00A) )
     +
     +
                 IUSED = IUSED + NRYA + NROTA
                 ZUSED = ZUSED + NROTA
             END IF
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      Subroutine MakGen ( NCent, Ref, Perm, GenBy )
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose:
C     Given two permutation lists, produce (update) the GENBY list
C     of which centers are *generated* by symmetry operations on other
C     centers and which are unique.
C
C Usage:
C     Calling this routine with the permutation due to each sym. op.
C     of the group gives a list of the symmetry unique centers 
C     (those with GENBY = 0) or a center (GENBY <> 0) which, under
C     the operations of the group, will generate the center in question.
C
C Arguments:
C     NCent    Length of arrays (number of centers) (input)
C     Ref      Reference permutation list (input)
C              NOTE: Must remain unchanged between successive calls
C     Perm     Permutation due to symmetry operation (input)
C     GenBy    "Generated By" list (modified)
C              For each center, contains 0 if the center is "unique"
C              or the number of another center which generates this
C              one by operations of the group.
C              NOTE: The elements of GENBY refer to the actual
C                    center numbers - it is NOT in the order of the
C                    reference permutation list
C              NOTE: Must be all zeros on *first* call to MakGen
C
C Internal Variables:
C     Cent1    Holds the lesser of Ref(i) and Perm(i)
C     Cent2    Holds the greater of Ref(i) and Perm(i)
C
C Method:
C     Compare Ref and Perm elementwise to see how each center transforms.
C     To avoid ambiguity always take the lesser of the two centers as
C     the "source" and the greater of the two as the "resultant."  
C     [ This has the side effect that in a symmetry equivalent group,
C     the lowest numbered center will be deemed "unique" and the rest
C     will be its "dependents." ]
C
C     For each element, we need update GenBy only if there has been
C     an interchange of centers [Ref(i) <> Perm(i)] and if the resultant
C     is presently unique.  [ If the resultant is *not* unique, then its
C     generator must be somewhere in the list too & it will be dealt
C     with in a way that will also update all of its dependents too
C     (see below). ]
C
C     The source, then, is either unique or a dependent.  If it is unique,
C     we merely mark the resultant as being generated by the source, and
C     proceed to check the rest of the list to see if the present result-
C     ant has any dependents.  If so, they are actually dependents of the
C     source via some combination of symmetry operations, and they are
C     marked as such.
C
C     If the source is already a dependent of another center, then
C     the GenBy list is "switched" so that the original source of this
C     source becomes, instead, a dependent of this source.  Then we
C     proceed to update the rest of the list - any center which was
C     dependent on the *original* source now becomes a dependent of
C     the *present* source (via a combination of operations).
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C $Log: makgen.f,v $
C Revision 1.4  2010/10/07 14:33:58  ponton
C Add symcor changes, fix bugs in optimization code, change numerical lib calls to use proper routines
C
C Revision 1.2  2010/02/10 17:20:48  ponton
C Add GNU GPL info to each source file
C
C Revision 1.1.1.1  2009/07/01 18:54:34  ponton
C Initial import for ACESIII Release 3.0
C
C Revision 1.1.1.1  2003/04/02 19:21:35  aces
C INITIAL 2.4 IMPORT
C
C Revision 4.0  89/03/14  01:15:47  bernhold
C Baseline for Sun & VAX prior to porting everywhere
C 
C Revision 3.0  89/01/29  23:10:26  bernhold
C First working release for VAX
C 
C Revision 1.1  89/01/28  12:09:38  bernhold
C Initial revision
C 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Implicit integer (a-z)
      dimension ref(ncent), perm(ncent), genby(ncent)
C
C     Loop over all centers...
C
      Do 100 i = 1, ncent
C
C        See if it's interesting
         Cent1 = Min( Ref(i), Perm(i) )
         Cent2 = Max( Ref(i), Perm(i) )
         If ( genby( Cent2 ) .eq. 0 .AND.
     $                     Cent1 .ne. Cent2 ) then
            If ( genby( Cent1 ) .eq. 0 ) then
C
C              If the generated center is unique, simply update
               genby( Cent2 ) = Cent1
               tmp = Cent2
            else
C
C              If its not, then fix the original source
               tmp = genby( Cent1 )
               genby(tmp) = Cent1
            endif
C
C           Update other dependents of the generated center
C           or the original source (using TMP, set above)
            Do 200 j = 1, ncent
               If ( genby(j) .eq. tmp ) genby(j) = Cent1
 200        continue
C
         endif
C
 100  continue
C
      return
      end

         SUBROUTINE  A2B__READ_REST
     +
     +                    ( UACES,
     +                      NSHELL,MAXCNTR,MAXPRIM,
     +                      LANGSH,NCNTSH,NPRMSH,
     +                      SCR,
     +
     +                                     EXPNT, COEFS )
     +
     +
C-----------------------------------------------------------------------
C  OPERATION   : A2B__READ_REST
C  MODULE      : ACESII BASIS CONVERTER
C  MODULE-ID   : A2B
C  SUBROUTINES : none
C  DESCRIPTION : This routine will read the exponents and coefficients
C                of a basis set.
C
C                Input:
C
C                     UACES   = The unit number for the ZMAT.BAS
C                     NSHELL  = The number of shells in the ZMAT.BAS
C                     MAXCNTR = The maximum number of contracted
C                               functions in the basis set
C                     MAXPRIM = The maximum number of primitive
C                               functions in the basis set
C                     LANGSH  = An array of angular momentum numbers
C                     NCNTSH  = An array of the number of contracted
C                               functions for a given angular momenta
C                     NPRMSH  = An array of the number of primitive
C                               functions for a given angular momenta
C                     SCR     = A double precision scratch array
C
C                Output:
C
C                     EXPNT   = A matrix of the exponents for a given
C                               angular momenta
C                     COEFS   = A matrix of the coefficients for a 
C                               given angular momenta and contracted
C                               function
C
C
C  AUTHOR      : Thomas Watson Jr.
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I,J,K,L,JUNK
         INTEGER    ISTART,IEND,PART,LOOP
         INTEGER    IPRIM,ICNTR
         INTEGER    UACES,ACESEXP,ACESCNT
         INTEGER    NSHELL,MAXCNTR,MAXPRIM

         DOUBLE PRECISION  ZERO

         INTEGER    LANGSH (1:NSHELL)
         INTEGER    NCNTSH (1:NSHELL)
         INTEGER    NPRMSH (1:NSHELL)

         DOUBLE PRECISION  EXPNT (1:NSHELL,1:MAXPRIM)
         DOUBLE PRECISION  COEFS (1:NSHELL,1:MAXCNTR,1:MAXPRIM)
         DOUBLE PRECISION  SCR   (1:NSHELL,1:MAXPRIM,1:MAXCNTR)

         PARAMETER  ( ZERO    = 0.0D0 )
         PARAMETER  ( ACESEXP = 5     )
         PARAMETER  ( ACESCNT = 7     )
C
C
C------------------------------------------------------------------------
C
C
C             ...Zero out the arrays first!
C
C
         DO I = 1, NSHELL
         DO J = 1, MAXPRIM

            EXPNT (I,J) = ZERO

            DO K = 1, MAXCNTR

               SCR   (I,J,K) = ZERO
               COEFS (I,K,J) = ZERO

            END DO
         END DO
         END DO
C
C
C             ...Read the remainder of the ZMAT.BAS
C
C
         DO I = 1, NSHELL

            IPRIM = NPRMSH (I)
            ICNTR = NCNTSH (I)
C
C
C             ...Read in the exponents for the given shell!
C
C
            IF (IPRIM .GT. ACESEXP) THEN

               PART = MOD (IPRIM,ACESEXP)
               LOOP = (IPRIM - PART) / ACESEXP
               ISTART = 1
               IEND   = ISTART + ACESEXP - 1
               DO J = 1, LOOP
                  READ(UACES,'(5F14.7)') (EXPNT (I,K), K = ISTART, IEND)
                  ISTART = ISTART + ACESEXP
                  IF ((IPRIM - IEND) .GT. ACESEXP) THEN
                     IEND = IEND + ACESEXP
                  ELSE
                     IEND = IPRIM
                  END IF
               END DO
            
               IF (PART .GT. 0) THEN
                  READ(UACES,'(5F14.7)') (EXPNT (I,K), K = ISTART, IEND)
               END IF

            ELSE
               READ(UACES,'(5F14.7)') (EXPNT (I,K), K = 1, IPRIM)
            END IF

            READ (UACES,'(A)') JUNK
C
C
C             ...Read in the contraction coefficients for the given
C                shell and primitive!
C
C
            DO J = 1, IPRIM

               IF (ICNTR .GT. ACESCNT) THEN

                  PART = MOD (ICNTR,ACESCNT)
                  LOOP = (ICNTR - PART) / ACESCNT
                  ISTART = 1
                  IEND   = ISTART + ACESCNT - 1
                  DO L = 1, LOOP

                     READ (UACES,'(7(F10.7,1X))')
     +
     +                    (SCR (I,J,K), K = ISTART, IEND)
     +
                     ISTART = ISTART + ACESCNT
                     IF ((ICNTR - IEND) .GT. ACESCNT) THEN
                        IEND = IEND + ACESCNT
                     ELSE
                        IEND = ICNTR
                     ENDIF
                  END DO

                  IF (PART .GT. 0) THEN

                     READ (UACES,'(7(F10.7,1X))')
     +
     +                    (SCR (I,J,K), K = ISTART, IEND)
     +
                  END IF

               ELSE

                     READ (UACES,'(7(F10.7,1X))')
     +
     +                    (SCR (I,J,K), K = 1, ICNTR)
     +
               END IF

            END DO

            READ (UACES,'(A)') JUNK
C
C
C             ...End the loop over shells!
C
C
         END DO
C
C
C             ...We need to transpose the SCR array so that the
C                coefficient array lines up in a better order!
C
C
         DO I = 1, NSHELL
         DO J = 1, MAXCNTR
         DO K = 1, MAXPRIM

            COEFS (I,J,K) = SCR (I,K,J)

         END DO
         END DO
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine scalef(d,ntot,n)
      implicit double precision(a-h,o-z)
      dimension d(ntot),n(8)
      integer dirprd
      common/syminf/nstart,nirrep,irrepa(255,2),dirprd(8,8)

      ioff = 0
      do irrep = 1, nirrep
         max_n = n(irrep)
         itmp = 1
         do i = 1, max_n
            d(ioff+itmp) = d(ioff+itmp) * 2.0d0
            itmp = itmp + i + 1
         end do
         ioff = ioff + ishft(max_n*(max_n+1),-1)
      end do
      return 
      end

c This subroutine sets the free-space index to INDX.

c INPUT
c int ID   : the stack handle (from LIFO_NEW)
c int INDX : the new free-space index

      subroutine lifo_set(id,indx)
      implicit none

      integer id, indx

#include "lifo.com"

      if (id.lt.1.or.nStacks.lt.id) then
         print *, '@LIFO_SET: Invalid stack id ',id
         print *, '           Must be between 1 and ',nStacks
         call c_exit(1)
      end if
      if (lifo(2,id).eq.-1) then
         print *, '@LIFO_SET: stack ',id,' is invalid'
         call c_exit(1)
      end if
      if (indx.lt.lifo(1,id).or.lifo(2,id).lt.indx) then
         print *, '@LIFO_SET: Invalid index ',indx
         print *, '           Not in [',lifo(1,id),',',lifo(2,id),']'
         call c_exit(1)
      end if

      lifo(2,id) = indx

      return
c     end subroutine lifo_set
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_copy_message(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_copy message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer i, j, ii
      integer node
      integer state
      integer match, nind
      integer source_array, target_array
      integer sentry, tentry
      integer src_bseg(mx_array_index)
      integer src_eseg(mx_array_index)
      integer tgt_bseg(mx_array_index)
      integer tgt_eseg(mx_array_index)

      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then
         source_array = server_msg(c_msg_nind, node)
         target_array = server_msg(c_msg_array, node) 

         do i= 1, nserver_table

c------------------------------------------------------------------------
c   Find the next block of the source_array in the server_table.
c------------------------------------------------------------------------

            if (server_table(c_server_array,i) .eq. 
     *                                   source_array) then

c------------------------------------------------------------------------
c   Save the block's indices.
c------------------------------------------------------------------------

               nind = server_table(c_server_nind,i)
               do j = 1, nind
                  src_bseg(j) = server_table(c_server_bsegs+j-1,i)
                  src_eseg(j) = server_table(c_server_esegs+j-1,i)
               enddo

c------------------------------------------------------------------------
c   Find the corresponding block of the target array.
c------------------------------------------------------------------------

               do ii = 1, nserver_table
                  if (server_table(c_server_array,ii) .eq.
     *                target_array) then
                    
c-------------------------------------------------------------------------
c   Check for a match to the indices of the source block.
c-------------------------------------------------------------------------

                    match = 0
                    do j = 1, nind
                       if (src_bseg(j) .eq. 
     *                    server_table(c_server_bsegs+j-1,ii) .and.
     *                     src_eseg(j) .eq. 
     *                    server_table(c_server_esegs+j-1,ii) )
     *                      match = match + 1   
                    enddo

                    if (match .eq. nind) then

c------------------------------------------------------------------------
c   We have a matching block.  We must swap the array information.
c------------------------------------------------------------------------

                       server_table(c_server_array,i) = -target_array
                       server_table(c_server_array,ii) = -source_array
                       go to 100
                    endif
                  endif 
               enddo

c-------------------------------------------------------------------------
c   We never found a matching block for the source block.  Thus it lives 
c   on another server.  We simply relabel this block as the target.
c-------------------------------------------------------------------------

               server_table(c_server_array,i) = -target_array
            endif

  100    continue
         enddo

c------------------------------------------------------------------------
c   Now change back the flagged array values to the correct array indices.
c------------------------------------------------------------------------

         do i = 1, nserver_table
c-------------------------------------------------------------------------
c   Change any blocks still labeled as target_array to source_array.
c   They are blocks that were never changed because their "mate" lives
c   on another server.
c-------------------------------------------------------------------------

            if (server_table(c_server_array,i) .eq. target_array)
     *          server_table(c_server_array,i) = source_array

c--------------------------------------------------------------------------
c   Reverse the sign on the changed blocks.
c--------------------------------------------------------------------------

            if (server_table(c_server_array,i) .eq. -target_array) 
     *          server_table(c_server_array,i) = target_array
            if (server_table(c_server_array,i) .eq. -source_array)
     *          server_table(c_server_array,i) = source_array

         enddo

c-------------------------------------------------------------------------
c   Swap the entries in the served_array_table.
c-------------------------------------------------------------------------

         sentry = 0
         tentry = 0
         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. source_array) sentry = i
            if (served_array_table(i) .eq. target_array) tentry = i
         enddo

         if (sentry .ne. 0) served_array_table(sentry) = 
     *                                 target_array
         if (tentry .ne. 0) served_array_table(tentry) = 
     *                                 source_array
  
         server_msg(c_msg_state,node) = null_state
      endif

      return
      end

C     FORMS THREE DIMENSIONAL ROTATION MATRIX
C     (IX=0 IF ANG IN RADS,
C      IX=1 IF DEG,
C      ADD 10 TO IX TO GET TRANSPOSE)

      SUBROUTINE ROTM( IAXIS, ANG, IX, RT )
      implicit double precision (a-h,o-z)

      integer iaxis, ix
      dimension rt(3,3)

      integer iaxis1, iaxis2

      CALL ZERO(RT,9)
      IF (mod(IX,10).EQ.1) THEN
         TANG=ANG*DACOS(-1.D0)/180.D0
      ELSE
         TANG=ANG
      END IF

      if (ix/10.gt.0) then
         sign = -1.d0
      else
         sign = 1.0d0
      end if

c     next two axes
c     --  really mod( (iaxis-1)+1, 3 ) + 1 (clock, not mod, arithmetic)
      iaxis1 = mod(iaxis ,3)+1
      iaxis2 = mod(iaxis1,3)+1

      rt(iaxis,iaxis) = 1.0 d0
      RT(iaxis1,iaxis1) = COS(TANG)
      RT(iaxis2,iaxis2) = COS(TANG)

      rt(iaxis1,iaxis2) = sin(tang) * sign
      rt(iaxis2,iaxis1) = -rt(iaxis1,iaxis2)

      RETURN
      END

      Subroutine Make_ztab
 
      Implicit Double Precision (a-h,o-z)

#include "ecp.par"
#include "ecp.com"
C
C form of liner cartesian products. The table is generated
C using the expression provided by Richard J. Mathar. 
C
C -Note that (PRMTESTING block is used only in the early stages of
C development and no longer supported). Ajith Perera.
C
#ifdef _PRMTESTING
C l=0,m=0

      zlm(1) = sqrt(1.0d0/fpi)
c
C l=1,m=+1,0,-1
c
      zlm(2) = sqrt(3.0d0/fpi)
      zlm(3) = zlm(2)
      zlm(4) = zlm(2)
C
C l=2,m=-2,-1....1,2
C
      zlm(5) = sqrt(15.0d0/fpi)/2.0d0
      zlm(6) = -zlm(5)
      zlm(7) = 2.0d0*zlm(5)
      zlm(8) = 3.0d0*sqrt(5.0d0/fpi)/2.0d0
      zlm(9) = -zlm(8)/3.0d0
      zlm(10) = zlm(7)
      zlm(11) = zlm(7)
c l=3
      zlm(12) = sqrt(35.0d0/(8.0d0*fpi))
      zlm(13) = -3.0d0*zlm(12)
      zlm(14) = sqrt(105.0d0/(4.0d0*fpi))
      zlm(15) = -zlm(14)
      zlm(16) = 5.0d0*sqrt(21.0d0/(8.0d0*fpi))
      zlm(17) = -zlm(16)/5.0d0
      zlm(18) = 5.0d0*sqrt(7.0d0/fpi)/2.0d0
      zlm(19) = -3.0d0*zlm(18)/5.0d0
      zlm(20) = zlm(16)
      zlm(21) = zlm(17)
      zlm(22) = 2.0d0*zlm(14)
      zlm(23) = -zlm(13)
      zlm(24) = -zlm(12)
c l=4
      zlm(25) = sqrt(315.0d0/(64.0d0*fpi))
      zlm(26) = -6.0d0*zlm(25)
      Zlm(27) = zlm(25)
      zlm(28) = sqrt(315.0d0/(8.0d0*fpi))
      zlm(29) = -3.0d0*zlm(28)
      temp    = sqrt(45.0d0/fpi)/4.0d0
      zlm(30) = 7.0d0*temp
      zlm(31) = -zlm(30)
      zlm(32) = temp
      zlm(33) = -temp
      temp    = sqrt(45.0d0/(8.0d0*fpi))
      zlm(34) = 7.0d0*temp
      zlm(35) = -3.0d0*temp
      temp    = sqrt(9.0d0/fpi)/8.0d0
      zlm(36) = 35.0d0*temp
      zlm(37) = -30.0d0*temp
      zlm(38) = 3.0d0*temp
      zlm(39) = zlm(34)
      zlm(40) = zlm(35)
      temp    = sqrt(45.0d0/(4.0d0*fpi))
      zlm(41) = 7.0d0*temp
      zlm(42) = -temp
      zlm(43) = -zlm(29)
      zlm(44) = -zlm(28)
      zlm(45) = sqrt(315.0d0/(4.0d0*fpi))
      zlm(46) = -zlm(45)
c l=5
      zlm(47) = sqrt(693.0d0/(128.0d0*fpi))
      zlm(48) = -10.0d0*zlm(47)
      zlm(49) = 5.0d0*zlm(47)
      zlm(50) = sqrt(3465.0d0/(64.0d0*fpi))
      zlm(51) = -6.0d0*zlm(50)
      zlm(52) = zlm(50)
      temp    = sqrt(385.0d0/(128.0d0*fpi))
      zlm(53) = 9.0d0*temp
      zlm(54) = -27.0d0*temp
      zlm(55) = 3.0d0*temp
      zlm(56) = -temp
      temp    = sqrt(1155.0d0/fpi)/4.0d0
      zlm(57) = 3.0d0*temp
      zlm(58) = -zlm(57)
      zlm(59) = -temp
      zlm(60) = +temp
      temp    = sqrt(165.0d0/fpi)/8.0d0
      zlm(61) = 21.0d0*temp
      zlm(62) = -14.0d0*temp
      zlm(63) = temp
      temp    = sqrt(11.0d0/fpi)/8.0d0
      zlm(64) = 63.0d0*temp
      zlm(65) = -70.0d0*temp
      zlm(66) = 15.0d0*temp
      zlm(67) = zlm(61)
      zlm(68) = zlm(62)
      zlm(69) = zlm(63)
      temp    = sqrt(1155.0d0/fpi)/2.0d0
      zlm(70) = 3.0d0*temp
      zlm(71) = -temp
      zlm(72) = -zlm(54)
      zlm(73) = -zlm(55)
      zlm(74) = -zlm(53)
      zlm(75) = -zlm(56)
      zlm(76) = sqrt(3465.0d0/fpi)/2.0d0
      zlm(77) = -zlm(76)
      zlm(78) = zlm(49)
      zlm(79) = zlm(48)
      zlm(80) = zlm(47)
c l=6
      temp    = sqrt(3003.0d0/(512.0d0*fpi))
      zlm(81) = 6.0d0*temp
      zlm(82) = -20.0d0*temp
      zlm(83) = zlm(81)
      zlm(84) = sqrt(9009.0d0/(128.0d0*fpi))
      zlm(85) = -10.0d0*zlm(84)
      zlm(86) = 5.0d0*zlm(84)
      temp    = sqrt(819.0d0/(256.0d0*fpi))
      zlm(87) = 11.0d0*temp
      zlm(88) = -66.0d0*temp
      zlm(89) = zlm(87)
      zlm(90) = -temp
      zlm(91) = 6.0d0*temp
      zlm(92) = -temp
      temp    = sqrt(1365.0d0/(128.0d0*fpi))
      zlm(93) = 11.0d0*temp
      zlm(94) = -33.0d0*temp
      zlm(95) = 9.0d0*temp
      zlm(96) = -3.0d0*temp
      temp    = sqrt(1365.0d0/(512.0d0*fpi))
      zlm(97) = 33.0d0*temp
      zlm(98) = -zlm(97)
      zlm(99) = -18.0d0*temp
      zlm(100) = +18.0d0*temp
      zlm(101) = temp
      zlm(102) = -temp
      temp     = sqrt(273.0d0/fpi)/8.0d0
      zlm(103) = 33.0d0*temp
      zlm(104) = -30.0d0*temp
      zlm(105) = 5.0d0*temp
      temp     = sqrt(13.0d0/fpi)/16.0d0
      zlm(106) = 231.0d0*temp
      zlm(107) = -315.0d0*temp
      zlm(108) = 105.0d0*temp
      zlm(109) = -5.0d0*temp
      zlm(110) = zlm(103)
      zlm(111) = zlm(104)
      zlm(112) = zlm(105)
      temp     = sqrt(1365.0d0/(128.0d0*fpi))
      zlm(113) = 33.0d0*temp
      zlm(114) = -18.0d0*temp
      zlm(115) = temp
      zlm(116) = -zlm(94)
      zlm(117) = -zlm(93)
      zlm(118) = -zlm(95)
      zlm(119) = -zlm(96)
      temp     = sqrt(819.0d0/fpi)/4.0d0
      zlm(120) = 11.0d0*temp
      zlm(121) = -zlm(120)
      zlm(122) = -temp
      zlm(123) = temp
      zlm(124) = zlm(86)
      zlm(125) = zlm(85)
      zlm(126) = zlm(84)
      zlm(127) = sqrt(3003.0d0/(512.0d0*fpi))
      zlm(128) = -15.0d0*zlm(127)
      zlm(129) = -zlm(128)
      zlm(130) = -zlm(127)
      Return
      End
#else
c compute tables by recursion for real spherical harmonics.  they
c are indexed by l, m and sigma.  the sequence number of the
c harmonic with quantum numbers l, m and sigma is given by
c l**2+2*m+1-sigma lmf(index) and lml(index) hold the positions of 
c the first and last terms of the harmonic in the lmx, lmy, lmz, 
c and zlm arrays. The harmonics with angular momentum l are generated 
c from those with angular momenta l-1 and l-2.
c for m = 0,1,2,...,l-1, the recursion relation
c z*Z(l-1,m,s) = sqrt(((l-m)*(l+m))/((2*l-1)*(2*l+1)))*Z(l,m,s)+
c                sqrt(((l+m-1)*(l-m-1))/((2*l-3)*(2*l-1)))*Z(l-2,m,s)
c is used.
c for m = l, the recursion relation
c x*Z(l-1,l-1,s)+(-1)**(1-s)*y*Z(l-1,l-1,1-s) =
c                sqrt((2*l))/((2*l+1)))*Z(l,l,s)
c is used.
c  l=0
      lmf(1) = 1
      lml(1) = 1
      lmx(1) = 0
      lmy(1) = 0
      lmz(1) = 0
      zlm(1) = 1.0D0/Sqrt_fpi
c l=1
      lmf(2) = 2
      lml(2) = 2
      lmx(2) = 0
      lmy(2) = 0
      lmz(2) = 1
      zlm(2) = sqrt(3.0D0)/Sqrt_fpi
      lmf(3) = 3
      lml(3) = 3
      lmx(3) = 0
      lmy(3) = 1
      lmz(3) = 0
      zlm(3) = zlm(2)
      lmf(4) = 4
      lml(4) = 4
      lmx(4) = 1
      lmy(4) = 0
      lmz(4) = 0
      zlm(4) = zlm(2)
      nterm=4

      do 270 lang=2,Maxang
        do 240 mang=0,lang-1
          anum = ((2*lang-1)*(2*lang+1))
          aden = ((lang-mang)*(lang+mang))
          coef1 = sqrt(anum/aden)
          anum = ((lang+mang-1)*(lang-mang-1)*(2*lang+1))
          aden = (2*lang-3)*aden
          coef2 = sqrt(anum/aden)
          nsigma=min(1,mang)
          do 230 isigma=nsigma,0,-1
            indexh=lang**2+2*mang+1-isigma
            lone=lang-1
            ltwo=lang-2
            ione=lone**2+2*mang+1-isigma
            itwo=ltwo**2+2*mang+1-isigma
            lmf(indexh)=lml(indexh-1)+1
            lml(indexh)=lml(indexh-1)
            nxy=(mang-isigma+2)/2
            iu=lmf(ione)+nxy-1
            do i=lmf(ione),iu
              lml(indexh)=lml(indexh)+1
              j=lml(indexh)
              lmx(j)=lmx(i)
              lmy(j)=lmy(i)
              lmz(j)=lmz(i)+1
              zlm(j)=zlm(i)*coef1
              nterm=nterm+1
            enddo
            if(ltwo.ge.mang) then
              il=iu+1
              do i=il,lml(ione)
                lml(indexh)=lml(indexh)+1
                j=lml(indexh)
                k=lmf(itwo)+i-il
                lmx(j)=lmx(k)
                lmy(j)=lmy(k)
                lmz(j)=lmz(k)
                zlm(j)=zlm(i)*coef1-zlm(k)*coef2
                nterm=nterm+1
              enddo
              il=lml(itwo)-nxy+1
              if(mod(lang-mang,2).eq.0) then
                do i=il,lml(itwo)
                  lml(indexh)=lml(indexh)+1
                  j=lml(indexh)
                  lmx(j)=lmx(i)
                  lmy(j)=lmy(i)
                  lmz(j)=lmz(i)
                  zlm(j)=-zlm(i)*coef2
                  nterm=nterm+1
                enddo
              endif
            endif
  230     enddo
  240   enddo

        anum = (2*lang+1)
        aden = (2*lang)
        coef = sqrt(anum/aden)
        mang=lang
        isigma=1
        indexh=lang**2+2*mang+1-isigma
        lmf(indexh)=lml(indexh-1)+1
        lml(indexh)=lml(indexh-1)
c isig:  index of the harmonic (l-1),(m-1),sigma
c isigm: index of the harmonic (l-1),(m-1),(1-sigma)
        isig=(lang-1)**2+2*(mang-1)+1-isigma
        isigm=(lang-1)**2+2*(mang-1)+isigma
        k=lmf(isigm)
        do i=lmf(isig),lml(isig)
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          lmx(j)=lmx(i)+1
          lmy(j)=lmy(i)
          lmz(j)=lmz(i)
          zlm(j)=(zlm(i)+zlm(k))*coef
          k=k+1
          nterm=nterm+1
        enddo
        if(mod(mang,2).eq.1) then
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          lmx(j)=lmx(k)
          lmy(j)=lmy(k)+1
          lmz(j)=lmz(k)
          zlm(j)=zlm(k)*coef
          nterm=nterm+1
        endif
        isigma=0
        indexh=lang**2+2*mang+1-isigma
c isig:  index of the harmonic (l-1),(m-1),sigma
c isigm: index of the harmonuc (l-1),(m-1),(1-sigma)
        isig=(lang-1)**2+2*(mang-1)+1-isigma
        isigm=(lang-1)**2+2*(mang-1)+isigma
        lmf(indexh)=lml(indexh-1)+1
        lml(indexh)=lmf(indexh)
        j=lml(indexh)
        i=lmf(isig)
        lmx(j)=lmx(i)+1
        lmy(j)=lmy(i)
        lmz(j)=lmz(i)
        zlm(j)=zlm(i)*coef
        nterm=nterm+1
        k=lmf(isigm)
        do  i=lmf(isig)+1,lml(isig)
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          lmx(j)=lmx(i)+1
          lmy(j)=lmy(i)
          lmz(j)=lmz(i)
          zlm(j)=(zlm(i)-zlm(k))*coef
          k=k+1
          nterm=nterm+1
        enddo
        if(mod(mang,2).eq.0) then
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          k=lml(isigm)
          lmx(j)=lmx(k)
          lmy(j)=lmy(k)+1
          lmz(j)=lmz(k)
          zlm(j)=-zlm(k)*coef
          nterm=nterm+1
        endif
  270 enddo
C---
CSS      ixy = 0
CSS      iz = 0
CSS      do 300 lang=1,lproju
CSS        do 290 mang=0,lang-1
CSS          nsigma=min(1,mang)
CSS          ndelta=max(0,1-mang)
CSS          anum = ((lang-mang)*(lang+mang+1))
CSS          aden = (2*(2-ndelta))
CSS          coef=sqrt(anum/aden)
CSS          do 280 isigma=nsigma,0,-1
CSS            isign=2*isigma-1
CSS            ixy = ixy+1
CSS            flmtx(1,ixy) = (isign)*coef
CSS            flmtx(2,ixy) = coef
CSS            if(mang.ne.0) then
CSS              iz=iz+1
CSS              flmtx(3,iz) = -(mang*isigma)
CSS            endif
CSS  280     enddo
CSS  290   enddo
CSS        iz=iz+1
CSS        flmtx(3,iz) = -(lang)
CSS  300 enddo
c  column and row indices for angular momentum matrix elements.
CSS      iadd = 1
CSS      do i=1,2*lproju-1
CSS        mc(1,i) = i
CSS        mc(2,i) = i
CSS        mc(3,i) = i+1
CSS        mr(1,i) = i+iadd
CSS        mr(2,i) = i+2
CSS        mr(3,i) = i+2
CSS        iadd = 4-iadd
CSS      enddo
C--
#endif
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine handle_exit(optable, noptable, debug,
     *                       array_table, narray_table,
     *                       index_table, nindex_table, 
     *                       block_map_table,
     *                       start_op, end_op, iop)
c----------------------------------------------------------------------------
c   Runtime code for the "exit" instruction: The instruction exits the 
c   innermost pardo or do loop.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'where_table.h'

      integer noptable, start_op, end_op, iop
      integer optable(loptable_entry,noptable)
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      logical debug

      integer i, istat, opcode
      integer ierr
      integer pop_do, get_block_request
      integer result_array
      integer blkndx, get_block_number
      integer create_flag

      opcode = optable(c_opcode, end_op)
      if (opcode .ne. enddo_op .and.
     *    opcode .ne. endpardo_op) then
         print *,'Error: An exit instruction must be executed from',
     *           ' within a loop.'
         print *,'Line number is ',current_line
         print *,'start_op, end_op = ',start_op,end_op
         print *,'opcode = ',optable(c_opcode, end_op)
         call abort_job()
      endif
      
      call unset_prefetch_context()

c-------------------------------------------------------------------------
c   Reset any temp blocks created in this loop.
c-------------------------------------------------------------------------

      do i = start_op, end_op
         if (optable(c_opblock,i) .ne. 0) then

c-------------------------------------------------------------------------
c   Only clear the block_computed_flag if the array is managed by
c   blkmgr.
c-------------------------------------------------------------------------

            result_array = optable(c_result_array,i)
            if (array_table(c_array_type, result_array) .ne.
     *          static_array) then
               call block_end_of_loop(result_array,
     *               optable(c_opblock,i), optable(c_opblkndx,i),
     *               array_table, narray_table, index_table,
     *               nindex_table, block_map_table)
            endif
            optable(c_opblock,i) = 0
            optable(c_opblkndx,i) = 0
         endif
      enddo

c----------------------------------------------------------------------------
c   Pop a new set of start_op, end_op values from the loop stack.
c----------------------------------------------------------------------------

      optable(c_oploop,start_op) = 0   ! reset loop init flag
      iop = end_op + 1                 ! new iop is 1 beyond end of currentloop

c--------------------------------------------------------------------------
c   Pop a new set of iwhere, nwhere values off the stack, to properly
c   unwind the stack.
c--------------------------------------------------------------------------

            istat = pop_do(iwhere, nwhere)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *          ' Error in handle_exit: stack underflow'
               call abort_job()
            endif

      istat = pop_do(start_op, end_op)
      if (istat .lt. 0) then
         print *,'Task ',me,
     *        ' Error in handle_exit: stack underflow'
         call abort_job()
      endif

      if (start_op .gt. noptable .or.
     *       start_op .lt. 0 .or.
     *       end_op .gt. noptable .or.
     *       end_op .lt. 0) then
         print *,'Task ',me,' handle_exit: start_op, end_op ',
     *       start_op, end_op,' noptable ',noptable
         print *,'New iop = ',iop
         call abort_job()
      endif

      return
      end

c This routine reads a physical record from a direct access file.

c INPUT
c int IUNIT   : the external unit number of the direct access file
c int IREC    : the index of the physical record to read
c int ILENGTH : the integer-length of the record and destination array

c OUTPUT
c int IDEST : the contents of the physical record

      subroutine aces_io_read(iUnit,iRec,iDest,iLength)
      implicit none

c ARGUMENTS
      integer iUnit, iRec, iLength
      integer iDest(iLength)

c INTERNAL VARIABLES
      integer iStat

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iStat = 0
c   o assert iUnit and iRec are natural
      if ((iUnit.lt.1).or.(iRec.lt.1)) then
         print *, '@ACES_IO_READ: Assertion failed.'
         print *, '   iUnit = ',iUnit
         print *, '   iRec  = ',iRec
         iStat = 1
      end if
c   o assert iLength is whole
      if (iLength.lt.0) then
         print *, '@ACES_IO_READ: Assertion failed.'
         print *, '   iLength = ',iLength
         iStat = 1
      end if
      if (iStat.ne.0) call aces_exit(iStat)
#endif /* _AASERT */

c ----------------------------------------------------------------------

      read(unit=iUnit,rec=iRec,err=666,iostat=iStat) iDest
      return

 666  call aces_io_error('ACES_IO_READ',iUnit,iStat)

c     end subroutine aces_io_read
      end

c This routine retrieves physical records from list files.
c It is a primitive of getlst and should not be called directly.

      subroutine getlst_io(ZList,iFile,iRecNum,iWrdNdx,nWords)
      implicit none

c ARGUMENTS
      integer ZList(*), iFile, iRecNum, iWrdNdx, nWords

c EXTERNAL FUNCTIONS
      integer iieq, iiamin, iiamax

c INTERNAL VARIABLES
      integer iFileOut, iRecOut
      integer iTmp, iLoc, iNdx, iVictim
      logical bNotDone

c COMMON BLOCKS
#include "cache.com"
#include "filspc.com" /* for iprcwd */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert cache subsystem is up
      if (.not.bCacheUp) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   bCacheUp = ',bCacheUp
         iTmp = 1
      end if
c   o assert iFile, iRecNum, and iWrdNdx are all natural
      if ((iFile.lt.1).or.(iRecNum.lt.1).or.(iWrdNdx.lt.1)) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   iFile   = ',iFile
         print *, '   iRecNum = ',iRecNum
         print *, '   iWrdNdx = ',iWrdNdx
         iTmp = 1
      end if
c   o assert nWords >= 0
      if (nWords.lt.0) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   nWords = ',nWords
         iTmp = 1
      end if
c   o assert maximum element is in physical record
      if ((iWrdNdx-1+nWords).gt.iprcwd) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   iWrdNdx = ',iWrdNdx
         print *, '   nWords  = ',nWords
         print *, '   iprcwd  = ',iprcwd
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

      if ((iWrdNdx.lt.1).or.(nWords.lt.1)) return

c ----------------------------------------------------------------------

c   o increment the cachetime
      cachetime = cachetime + 1
      if (cachetime.lt.0) then
c      o scale-back the lrustats
         iLoc = iiamin(cachnum,lrustats,1)
         iTmp = lrustats(iLoc)
         do iLoc = 1, cachnum
            lrustats(iLoc) = lrustats(iLoc) - iTmp
         end do
c      o set cachetime to the next integer
         iLoc = iiamax(cachnum,lrustats,1)
         cachetime = lrustats(iLoc) + 1
      end if

c   o check to see if the file/record is in the cache
      bNotDone = .true.
      iLoc = cachnum
      do while (bNotDone.and.(iLoc.ne.0))
         if (cachrec(iLoc).ne.iRecNum) then
            iLoc = iLoc - 1
         else
            if (cachfil(iLoc).eq.iFile) then
               bNotDone = .false.
            else
               iLoc = iLoc - 1
            end if
         end if
      end do

c   o If the correct record is in the cache, then copy it to ZList.
      if (iLoc.ne.0) then
#ifdef _CACHE_HIST
         cacheread = cacheread + 1
#ifdef _CACHE_HIST_VERBOSE
         print *, '@GETLST_IO: cache read (',
     &            iFile,',',iRecNum,') <- ',iLoc
#endif /* _CACHE_HIST_VERBOSE */
#endif /* _CACHE_HIST */
         iNdx = cachndx(iLoc)-1+iWrdNdx
         call icopy(nWords,icache(iNdx),1,ZList,1)
         lrustats(iLoc) = cachetime
      else

#ifdef _CACHE_BYPASS
      if (nWords.eq.iprcwd) then
#ifdef _CACHE_HIST
         cacheskip = cacheskip + 1
#ifdef _CACHE_HIST_VERBOSE
         print *, '@GETLST_IO: cache skip (',iFile,',',iRecNum,')'
#endif /* _CACHE_HIST_VERBOSE */
#endif /* _CACHE_HIST */
         call aces_io_read(iFile,iRecNum,ZList,iprcwd)
      else
#endif /* _CACHE_BYPASS */

c   o the record must be picked up from disk
c     Dump the least recently used record to disk if it has been modified;
c     otherwise, just copy over it.
      iVictim = iiamin(cachnum,lrustats,1)
      iNdx = cachndx(iVictim)
      if (cachmod(iVictim).ne.0) then
         iFileOut = cachfil(iVictim)
         iRecOut  = cachrec(iVictim)
#ifdef _CACHE_HIST
         cachewriteback = cachewriteback + 1
#ifdef _CACHE_HIST_VERBOSE
         print *, '@GETLST_IO: cache write-back ',iVictim,
     &            ' -> (',iFileOut,',',iRecOut,')'
#endif /* _CACHE_HIST_VERBOSE */
#endif /* _CACHE_HIST */
         call aces_io_write(iFileOut,iRecOut,icache(iNdx),iprcwd)
         cachmod(iVictim) = 0
      end if
#ifdef _CACHE_HIST
      cachemiss = cachemiss + 1
#ifdef _CACHE_HIST_VERBOSE
      print *, '@GETLST_IO: cache miss (',
     &         iFile,',',iRecNum,') -> ',iVictim
#endif /* _CACHE_HIST_VERBOSE */
#endif /* _CACHE_HIST */
      call aces_io_read(iFile,iRecNum,icache(iNdx),iprcwd)
      iNdx = iNdx-1+iWrdNdx
      call icopy(nWords,icache(iNdx),1,ZList,1)
      cachfil(iVictim) = iFile
      cachrec(iVictim) = iRecNum
      lrustats(iVictim) = cachetime

#ifdef _CACHE_BYPASS
c     end if (nWords.eq.iprcwd)
      end if
#endif

c     end if (iLoc.ne.0)
      end if

      return
c     end subroutine getlst_io
      end

c This routine retrieves physical records from list files.
c It is a primitive of getlst and should not be called directly.

      subroutine getlst_io(ZList,iFile,iRecNum,iWrdNdx,nWords)
      implicit none

c ARGUMENTS
      integer ZList(*), iFile, iRecNum, iWrdNdx, nWords

c EXTERNAL FUNCTIONS
      integer iieq, iiamin, iiamax

c INTERNAL VARIABLES
      integer iFileOut, iRecOut
      integer iTmp, iLoc, iNdx, iVictim
      logical bNotDone

c COMMON BLOCKS
c cache.com : begin

c These common blocks contain global information about the automatic file cache.
c getlst and putlst REQUIRE a cache, hence the term 'automatic' (compared to the
c auxiliary cache controlled by /auxcache/quikget).

c#define _CACHE_BYPASS /* bypasses cache on reading/writing of full records */
c#define _CACHE_HIST
c#define _CACHE_HIST_VERBOSE

      external aces_bd_cache

c icache     : the anchor used to address each cache slot
c cachnum    : the number of usable cache slots
c cachrec(i) : the index of the physical record cached by the data in slot i
c cachfil(i) : the external file unit number that stores the data in slot i
c cachndx(i) : the icache index of slot i
c cachmod(i) : a modification flag used to trigger a writeback

c cachetime   : a cache-event counter
c lrustats(i) : the last 'time' slot i was accessed

      integer        icache(1), cachnum,
     &               cachrec(128),
     &               cachfil(128),
     &               cachndx(128),
     &               cachmod(128)
      common /cache/ icache, cachnum,
     &               cachrec,
     &               cachfil,
     &               cachndx,
     &               cachmod
      save   /cache/

      integer           cachetime, lrustats(128)
      common /cachelru/ cachetime, lrustats
      save   /cachelru/

c cachemiss      : measures cache misses
c cacheskip      : measures read and write bypasses
c cacheread      : measures read hits
c cachewrite     : measures write hits
c cachewriteback : measures writes-back of dirty slots

      integer             cachemiss, cacheskip,
     &                    cacheread, cachewrite, cachewriteback
      common /cache_hist/ cachemiss, cacheskip,
     &                    cacheread, cachewrite, cachewriteback
      save   /cache_hist/

c bCacheUp : a flag for bombing in get/putlst if there is no I/O cache

      logical              bCacheUp
      common /cache_flags/ bCacheUp
      save   /cache_flags/

c cache.com : end
c filspc.com : begin

c This common block contains the dimensions of the physical records used by the
c MOIO storage files.

c iprcln : the    byte-length of a physical record
c iprcwd : the integer-length of a physical record
c iprcrl : the    recl-length of a physical record

      integer         iprcln, iprcwd, iprcrl
      common /filspc/ iprcln, iprcwd, iprcrl
      save   /filspc/

c filspc.com : end

c ----------------------------------------------------------------------

      iTmp = 0
c   o assert cache subsystem is up
      if (.not.bCacheUp) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   bCacheUp = ',bCacheUp
         iTmp = 1
      end if
c   o assert iFile, iRecNum, and iWrdNdx are all natural
      if ((iFile.lt.1).or.(iRecNum.lt.1).or.(iWrdNdx.lt.1)) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   iFile   = ',iFile
         print *, '   iRecNum = ',iRecNum
         print *, '   iWrdNdx = ',iWrdNdx
         iTmp = 1
      end if
c   o assert nWords >= 0
      if (nWords.lt.0) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   nWords = ',nWords
         iTmp = 1
      end if
c   o assert maximum element is in physical record
      if ((iWrdNdx-1+nWords).gt.iprcwd) then
         print *, '@GETLST_IO: Assertion failed.'
         print *, '   iWrdNdx = ',iWrdNdx
         print *, '   nWords  = ',nWords
         print *, '   iprcwd  = ',iprcwd
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)

      if ((iWrdNdx.lt.1).or.(nWords.lt.1)) return

c ----------------------------------------------------------------------

c   o increment the cachetime
      cachetime = cachetime + 1
      if (cachetime.lt.0) then
c      o scale-back the lrustats
         iLoc = iiamin(cachnum,lrustats,1)
         iTmp = lrustats(iLoc)
         do iLoc = 1, cachnum
            lrustats(iLoc) = lrustats(iLoc) - iTmp
         end do
c      o set cachetime to the next integer
         iLoc = iiamax(cachnum,lrustats,1)
         cachetime = lrustats(iLoc) + 1
      end if

c   o check to see if the file/record is in the cache
      bNotDone = .true.
      iLoc = cachnum
      do while (bNotDone.and.(iLoc.ne.0))
         if (cachrec(iLoc).ne.iRecNum) then
            iLoc = iLoc - 1
         else
            if (cachfil(iLoc).eq.iFile) then
               bNotDone = .false.
            else
               iLoc = iLoc - 1
            end if
         end if
      end do

c   o If the correct record is in the cache, then copy it to ZList.
      if (iLoc.ne.0) then
         iNdx = cachndx(iLoc)-1+iWrdNdx
         call icopy(nWords,icache(iNdx),1,ZList,1)
         lrustats(iLoc) = cachetime
      else


c   o the record must be picked up from disk
c     Dump the least recently used record to disk if it has been modified;
c     otherwise, just copy over it.
      iVictim = iiamin(cachnum,lrustats,1)
      iNdx = cachndx(iVictim)
      if (cachmod(iVictim).ne.0) then
         iFileOut = cachfil(iVictim)
         iRecOut  = cachrec(iVictim)
         call aces_io_write(iFileOut,iRecOut,icache(iNdx),iprcwd)
         cachmod(iVictim) = 0
      end if
      call aces_io_read(iFile,iRecNum,icache(iNdx),iprcwd)
      iNdx = iNdx-1+iWrdNdx
      call icopy(nWords,icache(iNdx),1,ZList,1)
      cachfil(iVictim) = iFile
      cachrec(iVictim) = iRecNum
      lrustats(iVictim) = cachetime


c     end if (iLoc.ne.0)
      end if

      return
c     end subroutine getlst_io
      end

c This routine initializes the symloc common block.

      subroutine aces_com_symloc
      implicit none

c INTERNAL VARIABLES
      integer p(8), q(8), irp_p, irp_q, irp_pq
      integer iSpin, iType, irrep, iLoc
      integer iSpins(2,25)
      data iSpins / 1,1 , 2,2 , 1,1 , 2,2 ,
     &              1,1 , 2,2 , 1,1 , 2,2 ,
     &              1,1 , 2,2 , 1,2 , 2,1 ,
     &              1,2 , 1,2 , 1,2 , 1,1 ,
     &              2,2 , 1,2 , 1,1 , 2,2 ,
     &              1,1 , 2,2 , 2,1 , 2,1 ,
     &              2,1 /
      character*4 szPacks(25)
      data szPacks / 'PACK', 'PACK', 'PACK', 'PACK',
     &               'PCK2', 'PCK2', 'PCK2', 'PCK2',
     &               'FULL', 'FULL', 'FULL', 'FULL',
     &               'FULL', 'FULL', 'FULL', 'FULL',
     &               'FULL', 'FULL', 'FULL', 'FULL',
     &               'FULL', 'FULL', 'FULL', 'FULL',
     &               'FULL' /
      character*1 czTypes(2,25)
      data czTypes / 'V','V' , 'V','V' , 'O','O' , 'O','O' ,
     &               'V','V' , 'V','V' , 'O','O' , 'O','O' ,
     &               'V','O' , 'V','O' , 'V','O' , 'V','O' ,
     &               'V','V' , 'O','O' , 'V','V' , 'O','V' ,
     &               'O','V' , 'O','V' , 'V','V' , 'V','V' ,
     &               'O','O' , 'O','O' , 'V','V' , 'O','O' ,
     &               'O','V' /

c COMMON BLOCKS
#include "symloc.com"
#include "syminf.com" /* for nirrep */
#include "sym.com" /* for pop and vrt */

c INLINE FUNCTIONS
      integer nnm1o2, nnp1o2, i
      nnm1o2(i)=(i*(i-1))/2
      nnp1o2(i)=(i*(i+1))/2

c ----------------------------------------------------------------------

c   o make sure the orbital vectors have been initialized
      i = 0
      do iSpin = 1, 2
      do irrep = 1, nirrep
         i = i + pop(irrep,iSpin) + vrt(irrep,iSpin)
      end do
      end do
      if (i.eq.0) return

c   o loop over pair types
      do iType = 1, 25

c      o load the proper number of orbitals into left (p) and right (q) spaces
         if (czTypes(1,iType).eq.'O') then
            call icopy(nirrep,pop(1,iSpins(1,iType)),1,p,1)
         else
            call icopy(nirrep,vrt(1,iSpins(1,iType)),1,p,1)
         end if
         if (czTypes(2,iType).eq.'O') then
            call icopy(nirrep,pop(1,iSpins(2,iType)),1,q,1)
         else
            call icopy(nirrep,vrt(1,iSpins(2,iType)),1,q,1)
         end if

c      o loop over total symmetry
         do irp_pq = 1, nirrep
            iLoc = 1
            if (szPacks(iType).eq.'FULL') then
               do irp_q = 1, nirrep
                  irp_p = dirprd(irp_q,irp_pq)
                  isymoff(irp_q,irp_pq,iType) = iLoc
                  iLoc = iLoc + p(irp_p)*q(irp_q)
               end do
            else if (szPacks(iType).eq.'PACK') then
               do irp_q = 1, nirrep
                  irp_p = dirprd(irp_q,irp_pq)
                  if (irp_p.lt.irp_q) then
                     isymoff(irp_q,irp_pq,iType) = iLoc
                     iLoc = iLoc + p(irp_p)*q(irp_q)
                  else if (irp_p.eq.irp_q) then
                     isymoff(irp_q,irp_pq,iType) = iLoc
                     iLoc = iLoc + nnm1o2(p(irp_p))
                  end if
               end do
            else if (szPacks(iType).eq.'PCK2') then
               do irp_q = 1, nirrep
                  irp_p = dirprd(irp_q,irp_pq)
                  if (irp_p.lt.irp_q) then
                     isymoff(irp_q,irp_pq,iType) = iLoc
                     iLoc = iLoc + p(irp_p)*q(irp_q)
                  else if (irp_p.eq.irp_q) then
                     isymoff(irp_q,irp_pq,iType) = iLoc
                     iLoc = iLoc + nnp1o2(p(irp_p))
                  end if
               end do
            end if
c        end do irp_pq = 1, nirrep
         end do

c     end do iType = 1, 25
      end do

      return
c     end subroutine aces_com_symloc
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE DUMPCORD(NATOMS,Q,IATNUM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
#include "mxatms.par"
#include "cbchar.com"
      DIMENSION Q(3*NATOMS),IATNUM(NATOMS)
      ATOB = 0.529177249D0
      WRITE(6,100)
      WRITE(6,101)
      WRITE(6,100)
100   FORMAT(T2,64('-'))
101   FORMAT(T2,'Z-matrix',T13,'Atomic',T31,'C o o r d i n a t e s',
     &       /,
     &       T3,'Symbol',T13,'Number',T30,'X',T45,'Y',T60,'Z')
      IOFF=1
      DO 10 I=1,NATOMS
       LAST=linblnk(ZSYM(I))
       WRITE(6,1000)ZSYM(I)(1:LAST),IATNUM(I),(Q(J)*ATOB,
     &              J=IOFF,IOFF+2)
       IOFF=IOFF+3
10    CONTINUE
      WRITE(6,100)
1000  FORMAT(T6,A,T14,I3,T22,F14.8,T37,F14.8,T52,F14.8)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE HUPDATE(V,H,SCRATCH,STEP,TBT,ITYPE)
C
C     ARGUMENTS PASSED ARE NEW GRADIENT, HESSIAN (TO BE READ AND
C     RETURNED UPDATED), SCRATCH ARRAY- OLD GRADIENT READ INTO FIRST
C     NXM6 POSITIONS, UPDATE TYPE
C     TBT IS JUST A SCRATCH ARRAY FOR MATRIX MULTIPLY OPERATIONS
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "io_units.par"
#include "fnamelen.par"
#include "jodaflags.com"
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION V(NXM6),H(NXM6*NXM6),SCRATCH(NX*NX),TBT(3*NXM6*NXM6),
     $   STEP(NXM6)
      LOGICAL POWEL_DONE
      CHARACTER*6 MSPORPSB
      CHARACTER*10 TRASH
      CHARACTER*(fnamelen) FNAME
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
      PARAMETER (TOLRNCE = 1.0D-12)
      DATA ONE /1.00D0/
C
      CALL GFNAME(ARCFIL,FNAME,ILENGTH)
      OPEN(UNIT=LUARC,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
     &     STATUS='OLD')
      DO 10 I=1,NCYCLE
 10   READ(LUARC)TRASH
C
C     Most of the stuff read here is not used - hence the stupid vars.
C The previous cycle's gradients and Hessians are read into scratch and H.
C The incoming variables V, H, and STEP contain the current gradient, Hessian,
C and step size.
C
      READ(LUARC)TRASH,ICRAP,icycle,NJ,NJN,NJNK,NOPT,NJ1,NJ2,NJ3,NJ4,
     $   NJ5,NJ6,NJ7,NJ8,NJ9,NJA,NJB,NJC,NJD,NJE,NJF,NJG,E,
     &   (SCRATCH(I),I=1,NXM6),
     &   (H(I),I=1,NXM6*NXM6),(STEP(J),J=1,NXM6)
      CLOSE(UNIT=LUARC)
      IF(ITYPE.EQ.0)THEN
         WRITE(LuOut,70) icycle
 70      FORMAT(T3,' Hessian from cycle ',i2,' read and not updated.')
      ELSEIF(ITYPE.EQ.1)THEN
C
C        Powell update
C
         WRITE(LuOut,71) icycle
 71      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Powell update using ',
     &      'last two gradients and previous step.')
C
         PHI = ONE
         CALL POWEL(V, H, SCRATCH, STEP, TBT, PHI)
C
      ELSEIF(ITYPE.EQ.2)THEN
C
C        Broyden-Fletcher-Goldfarb-Shanno update
C
         WRITE(LuOut,72) icycle
 72      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' BFGS update using ',
     &      'last two gradients and previous step.')
C
#ifdef _DEBUG_LVLM1
         Print*, "The BFGS update check"
         Write(6,*) (V(I), I =1, NXM6)
         Write(6,*)
         Write(6,*) (SCRATCH(I), I = 1, NXM6)
         Write(6,*)
         Write(6,*) (STEP(I), I= 1, NXM6)
         Write(6,*)
         CALL OUTPUT(H, 1, NXM6, 1, NXM6, NXM6,NXM6, 1 )
         Write(6,*)
#endif
         CALL BFGS(V, H, SCRATCH, STEP, TBT)

C
      ELSEIF(ITYPE.EQ.3)THEN
C
C        Murtagh-Sargent update
C
         WRITE(LuOut,73) icycle
 73      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Murtagh-Sargent update using ',
     &      'last two gradients and previous step.')
C
         POWEL_DONE = .TRUE.
         MSPORPSB   = "MSP   "
         CALL MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                POWEL_DONE, MSPORPSB)
C
      ELSEIF(ITYPE.EQ.4)THEN
C
C        (1-phi)*Powell + (phi)*Murtagh-Sargent update
C
         WRITE(LuOut,74) icycle
 74      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Bofill mixture of Powell and Murtagh-Sargent',
     &      ' update using last two gradients and previous step.')
C
         N2 = NXM6 + 1
         N3 = 2*NXM6+1
         N4 = 3*NXM6+1

         CALL MODMATMUL(SCRATCH(N2),H,STEP,NXM6,NXM6,1,NXM6,NXM6,1)
         CALL DCOPY(NXM6, V, 1, SCRATCH(N3), 1)
         CALL XDAXPY(NXM6, -ONE, SCRATCH(1), 1, SCRATCH(N3), 1)
         CALL VADD(SCRATCH(N4),SCRATCH(N3),SCRATCH(N2),NXM6,-1.D0)

         DDXDX  = XDDOT(NXM6, STEP, 1, STEP, 1)
         DHDXDG = XDDOT(NXM6, SCRATCH(N4), 1, SCRATCH(N4), 1)
         DHDXDX = XDDOT(NXM6, SCRATCH(N4), 1, STEP, 1)

         IF (DABS(DHDXDX).GT.TOLRNCE.AND.
     &       DABS(DHDXDG).GT.TOLRNCE) THEN
            PHI = (DHDXDX**2)/(DDXDX*DHDXDG)
         ELSE
            PHI = ONE
         END IF

         CALL POWEL(V, H, SCRATCH, STEP, TBT, ONE-PHI)
         POWEL_DONE = .TRUE.
         MSPORPSB   = "BOFILL"
         CALL MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                POWEL_DONE, MSPORPSB)

      ELSE IF (ITYPE .EQ. 5) THEN
C
C        Powell-symmetric-Broyden update
C
         WRITE(LuOut,75) icycle
 75      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Powell-Symmetric-Broyden update using ',
     &      'last two gradients and previous step.')
C
         POWEL_DONE = .FALSE.
         MSPORPSB   = "PSB   "
         CALL MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                POWEL_DONE, MSPORPSB)

      ELSE IF (ITYPE .EQ. 6) THEN
C
C  Modified BFGS update

         WRITE(LuOut,76) icycle
 76      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' modified BFGS update using ',
     &      'last two gradients and previous step.')
C
#ifdef _DEBUG_LVL0
         Print*, "The BFGS update check"
         Write(6,*) (V(I), I =1, NXM6)
         Write(6,*) (SCRATCH(I), I = 1, NXM6)
         Write(6,*) (STEP(I), I= 1, NXM6)
         CALL OUTPUT(H, 1, NXM6, 1, NXM6, NXM6,NXM6, 1 )
         Write(6,*)
#endif
CSSS         CALL MODF_BFGS(V, H, SCRATCH, STEP, TBT)
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine c1_print(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)

c--------------------------------------------------------------------------
c
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer sind, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer*8 get_block_index
      integer stack

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix which is to be analyses.
c---------------------------------------------------------------------------

      array      = op(c_result_array)
      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      if (array .eq. 0) then
         print *,'Error: The first argument in c1_print   
     *            must be an array.'  
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      if (nindex .ne. 2) then 
         write(6,*) ' The first array in c1_print must gave have 
     *                2 indices.'   
         write(6,*) ' Number given =', nindex  
         call abort_job() 
      endif 

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

c---------------------------------------------------------------------------
c   Look up its address.
c---------------------------------------------------------------------------

      block  = find_current_block(array, array_table(1,array),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,array) 
      iarray = get_block_index(array, block, stack, blkndx, x, .true.)  

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         type(i)  = index_table(c_index_type, index(i))
         seg      = index_table(c_current_seg,index(i))

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         call get_index_segment(index(i), seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo

c----------------------------------------------------------------------------
c   Locate the scalar.  
c---------------------------------------------------------------------------

      evec_array  = op(c_op1_array)
      evec_type   = array_table(c_array_type, evec_array)
      nindex_evec = array_table(c_nindex, evec_array)

      if (evec_type .ne. scalar_value) return

      if (evec_array .lt. 1 .or. evec_array .gt. narray_table) then
         print *,'Error: Invalid scalar in return_sval, line ',
     *     current_line
         print *,'Array index is ',array,' Allowable values are ',
     *      ' 1 through ',narray_table
         call abort_job()
      endif 

      sind =  array_table(c_scalar_index, evec_array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in return_sval, ',
     *           'line ',current_line
         print *,'Index for array ',evec_array,' is ',ind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

      call doc1_print(x(iarray),scalar_table(sind),
     *             val1(1),val2(1),val1(2),val2(2))

      return 
      end 

      subroutine doc1_print(array1,sval,a1,a2,b1,b2) 

c---------------------------------------------------------------------------
c
c 
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'parallel_info.h'
c
      integer a, a1, a2, b, b1, b2   
      double precision array1(a1:a2,b1:b2), sval, stemp   

10    FORMAT(2x,'Singles amplitudes above 0.005') 
20    FORMAT(2x,60('-'))
30    FORMAT(2x,I8,x,I8,x,F16.8) 
40    FORMAT(2x,'A',10x,'B',10x,'C1A(A,B)') 

       if (me .eq. my_company_rank)then

         write(66,*) ' ' 
         write(66,10)  
         write(66,20)  
         write(66,40)  
c
         do b = b1, b2 
         do a = a1, a2 
         stemp=dabs(array1(a,b))
c
         if(stemp .gt. 0.05d-1)then
c        write(66,*) ' C1A VECTOR FOR I = ',b,',A = ',a,' = ',
c    *                 array1(a,b)
           write(66,30) a, b, array1(a,b) 
         endif

c 999  FORMAT (A20,I5,A5,I5,A3,F14.8)
c
         enddo  
         enddo  
         write(66,20)  
c
       endif
c
      return
      end

c This routine destroys the icore indices in quikget so aces_fin can complete.

c ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING !
c    Given the nature of the auxiliary cache, it is the programmer's
c responsibility to make sure that memory is not lost. I.e., if the memory is
c needed after the reset, then steps should be taken to record where the icore
c range starts.

      subroutine aces_auxcache_reset
      implicit none

c COMMON BLOCKS
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

c   o destroy quikget
      call izero(quikget,_MAX_IO_GRPS*_MAX_IO_FAMS)

      return
c     end subroutine aces_auxcache_reset
      end

c This routine destroys the icore indices in quikget so aces_fin can complete.

c ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING !
c    Given the nature of the auxiliary cache, it is the programmer's
c responsibility to make sure that memory is not lost. I.e., if the memory is
c needed after the reset, then steps should be taken to record where the icore
c range starts.

      subroutine aces_auxcache_reset
      implicit none

c COMMON BLOCKS
c auxcache.com : begin

c The auxiliary cache is a programmer-controlled list cache. The dimensions are
c the same as those of the MOIO arrays. The programmer may load lists into icore
c memory and set quikget(?,?) to their icore addresses. When getlst and putlst
c operate on ANY list, quikget is checked to see if the list lives in icore.
c If so, the operation is performed on the in-core data instead of hitting the
c storage file(s).

c WARNING
c    There is no automatic updating of storage files with data in the auxiliary
c cache. If the memory-resident data is altered and must be stored to disk, then
c the quikget value must be destroyed (zeroed) and the actual location of the
c data must then be passed to putlst. The aces_auxcache_flush routine
c systematically stores the quikget values, calls putlst, and restores the
c quikget values.





      integer           quikget(10,500)
      common /auxcache/ quikget
      save   /auxcache/

c auxcache.com : end

c ----------------------------------------------------------------------

c   o destroy quikget
      call izero(quikget,10*500)

      return
c     end subroutine aces_auxcache_reset
      end

      SUBROUTINE GETFAST(Z,IFIRST,NDIS,ISPIN,ITYPE)
C
C THIS ROUTINE DOES A FAST IN-CORE FETCH OF A LIST HELD IN
C  THE AUXILIARY CACHE
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(1)
      COMMON / / ICORE(1)
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /INCORE/ ICREC(2),USEC,IXT(2),IMOD(2)
      COMMON /IOSTAT/ NOPBUF,NOPDSK
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /AUXCACHE/ QUIKGET(10,500)
C
      DISSIZ=MOIOSZ(ISPIN,ITYPE)
      IPOS=QUIKGET(ISPIN,ITYPE)+(IFIRST-1)*DISSIZ*IINTFP
c YAU : old
c     LENGTH=NDIS*DISSIZ*IINTFP
c     CALL ICOPY(LENGTH,ICORE(IPOS),1,Z,1)
c YAU : new
      CALL DCOPY(NDIS*DISSIZ,ICORE(IPOS),1,Z,1)
c YAU : end
      RETURN
      END

c This routine was the ACES initialization routine, but that function has been
c transferred to aces_init. However, this routine is not merely kept for
c compatibility. It is still needed to initialize some legacy common blocks;
c thus, removing them from the acescore namespace.

c NO NEW MEMBER EXECUTABLES SHOULD CALL THIS!

c To use the automatic memory allocation, IENTRY must be >= 0.

c#define _DEBUG_CRAPSI

      SUBROUTINE CRAPSI(ICORE,IUHF,IENTRY)
      IMPLICIT INTEGER (A-Z)

      INTEGER ICORE(*), IUHF, IENTRY

      LOGICAL BTMP

c COMMON BLOCKS
      COMMON /ISTART/ I0,ICRSIZ
c   o from the old MCHPRM routine
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /BUFLEN/ ILNBUF
      LOGICAL MINTPRC,MVDINT1,MVDINT2,MANTI
      COMMON /MINTPC/ MINTPRC
      COMMON /MVDINT/ MVDINT1,MVDINT2
      COMMON /MEMANTI/ MANTI
c   o from the old GETSTF routine
      LOGICAL LINCC,CICALC
      COMMON /LINEAR/ LINCC,CICALC

c ----------------------------------------------------------------------

c   o initialize the ACES environment
      bTmp = (ientry.gt.-1)
      call aces_init(icore,i0,icrsiz,iuhf,bTmp)

c ----------------------------------------------------------------------

c   o initialize legacy data

c     /BUFLEN/ (only used in intprc)
      ILNBUF = 1536

c     /FILES/
      LUOUT  = 6
      MOINTS = 50

c     /LINEAR/
      LINCC  = .FALSE.
      CICALC = .FALSE.

#if defined(_UNICOS) || ( defined(_AIX) && defined(F_64BIT) )
      MINTPRC = .FALSE.
      MVDINT2 = .FALSE.
      MANTI   = .FALSE.
#else
      MINTPRC = .TRUE.
      MVDINT2 = .TRUE.
      MANTI   = .TRUE.
#endif /* _UNICOS || (_AIX && F_64BIT) */

c ----------------------------------------------------------------------

      RETURN
      END

      SUBROUTINE FRMRIJ2(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,I,J,
     &                   SINGLE,RLETYP)
C
C THIS ROUTINE IS USED TO FORM THE R MATRIX USED IN THE RLE-1 METHOD.
C  PUT THREE T2 VECTORS IN CORE UNTIL WE KNOW WHETHER THIS WORKS OR NOT
C
C THE FORMULA FOR AN R MATRIX ELEMENT IS:
C
C                 (i)   (i-1)      (j)    (j-1)
C      R(I,J) = [T   - T     ] * [T    - T     ]
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(MAXCOR)
      DOUBLE PRECISION R,FACTOR,SDOT,ONEM
      LOGICAL SINGLE,GETT1V
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /RMAT/ R(400)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2)
      COMMON /RLEIO/ IOLDEST
      DATA ONEM /-1.0/
      INDX(I,J)=I+(J-1)*MAXORD
      IGET(I)  =1+MOD(IOLDEST+MAXORD-I,MAXORD+1)
      RSIZE=MIN(RLECYC-1,MAXORD)
C
      IF(I.NE.0.AND.J.EQ.0)THEN
       IROW=I
       NLSTI=1+IROW
       DO 200 ICOL=1,RSIZE
        R(INDX(IROW,ICOL))=0.0
200    CONTINUE
       DO 201 ISPIN=3,1,IUHF-2
        IADD=0
        GETT1V=.FALSE.
        IF(ISPIN.LT.3.AND.IUHF.EQ.0)THEN
         FACTOR=2.0
        ELSE
         FACTOR=1.0
        ENDIF
        IF(SINGLE.AND.ISPIN.LT.3)THEN
         IADD=NT(ISPIN) 
         GETT1V=.TRUE.
        ENDIF
        SIZET2=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
        SIZET=SIZET2+IADD
        IOFFT1=IINTFP*SIZET2
        I000=1
        I010=I000+SIZET*IINTFP
        I020=I010+SIZET*IINTFP
        I030=I020+SIZET*IINTFP
        IF(RLETYP.EQ.3)THEN
         CALL GETLST(ICORE(I000),IGET(NLSTI),1,1,ISPIN+3,70)
        ELSE
         CALL GETLST(ICORE(I000),IGET(NLSTI),1,1,ISPIN,70)
        ENDIF
        CALL GETLST(ICORE(I010),IGET(NLSTI-1),1,1,ISPIN,70)
        CALL SAXPY(SIZET,ONEM,ICORE(I010),1,ICORE(I000),1)
        DO 202 ICOL=1,RSIZE  
         IOFF=INDX(IROW,ICOL)
         NLSTJ=1+ICOL
         NLSTJP1=NLSTJ-1
         IF(RLETYP.EQ.3)THEN
          CALL GETLST(ICORE(I010),IGET(NLSTJ),1,1,ISPIN+3,70)
         ELSE
          CALL GETLST(ICORE(I010),IGET(NLSTJ),1,1,ISPIN,70)
         ENDIF
         CALL GETLST(ICORE(I020),IGET(NLSTJ-1),1,1,ISPIN,70)
         CALL SAXPY(SIZET,ONEM,ICORE(I020),1,ICORE(I010),1)
         R(IOFF)=R(IOFF)+FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
202     CONTINUE
201    CONTINUE
      ELSEIF(I.EQ.0.AND.J.NE.0)THEN
       ICOL=J
       NLSTJ=1+ICOL
       DO 300 IROW=1,RSIZE
        R(INDX(IROW,ICOL))=0.0
300    CONTINUE
       DO 301 ISPIN=3,1,IUHF-2
        IADD=0
        GETT1V=.FALSE.
        IF(ISPIN.LT.3.AND.IUHF.EQ.0)THEN
         FACTOR=2.0
        ELSE
         FACTOR=1.0
        ENDIF
        IF(SINGLE.AND.ISPIN.LT.3)THEN
         IADD=NT(ISPIN) 
         GETT1V=.TRUE.
        ENDIF
        SIZET2=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
        SIZET=SIZET2+IADD
        IOFFT1=IINTFP*SIZET2
        I000=1
        I010=I000+SIZET*IINTFP
        I020=I010+SIZET*IINTFP
        I030=I020+SIZET*IINTFP
        IF(RLETYP.EQ.3)THEN
         CALL GETLST(ICORE(I000),IGET(NLSTJ),1,1,ISPIN+3,70)
        ELSE
         CALL GETLST(ICORE(I000),IGET(NLSTJ),1,1,ISPIN,70)
        ENDIF
        CALL GETLST(ICORE(I010),IGET(NLSTJ-1),1,1,ISPIN,70)
        CALL SAXPY(SIZET,ONEM,ICORE(I010),1,ICORE(I000),1)
        DO 302 IROW=1,RSIZE
         NLSTI=1+IROW
         IOFF=INDX(IROW,ICOL)
         IF(RLETYP.Eq.3)THEN
          CALL GETLST(ICORE(I010),IGET(NLSTI),1,1,ISPIN+3,70)
         ELSE
          CALL GETLST(ICORE(I010),IGET(NLSTI),1,1,ISPIN,70)
         ENDIF
         CALL GETLST(ICORE(I020),IGET(NLSTI-1),1,1,ISPIN,70)
         CALL SAXPY(SIZET,ONEM,ICORE(I020),1,ICORE(I010),1)
         R(IOFF)=R(IOFF)+FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
302     CONTINUE
301    CONTINUE
      ELSE
       RETURN
      ENDIF
      RETURN
      END

      subroutine sb_com_symm2_ks
      implicit none

#include "machsp.com"
#include "iuhf.com"
#include "symm2_ks.com"

      double precision nucrep
      integer length,ijunk,irrep,sqroff,trioff,n,tri,sqr,i,orb,iunit
      character*80 iiiifil
      character*8 title(24)
      logical bExist
      call gfname('IIII',iiiifil,length)
      inquire(file=iiiifil,exist=bExist)
      if (.not.bExist) then
         write(*,*) '@SB_COM_SYMM2_KS: No IIII integral file.'
         call errex
      end if
      iunit = 10
      open(iunit,file=iiiifil,form='unformatted',access='sequential')
      read(iunit) title,nirrep
      rewind(iunit)
      read(iunit) title,nirrep,(numbasir(i),i=1,nirrep),nucrep
      close(iunit,status='keep')
      call getrec(0,'JOBARC','NUCREP  ',length,n)
      if (length.eq.0) call putrec(1,'JOBARC','NUCREP  ',iintfp,nucrep)
      call putrec(1,'JOBARC','NUMBASIR',nirrep,numbasir)
      sqroff=1
      trioff=1
      maxirrsqr=0
      maxirrtri=0
      orb=1
      do irrep=1,nirrep

         n=numbasir(irrep)
         irrorboff(irrep)=orb
         orb=orb+n

         sqr=n*n
         tri=n*(n+1)/2

         irrsqrlen(irrep)=sqr
         irrsqroff(irrep)=sqroff
         sqroff=sqroff+sqr
         maxirrsqr=max(maxirrsqr,sqr)

         irrtrilen(irrep)=tri
         irrtrioff(irrep)=trioff
         trioff=trioff+tri
         maxirrtri=max(maxirrtri,tri)

      end do
      irrorboff(nirrep+1)=orb
      irrsqrtot=sqroff-1
      irrtritot=trioff-1

      call getrec(-1,'JOBARC','OCCUPYA0',nirrep,occup(1,1))
      call getrec(-1,'JOBARC','OCCUPYB0',nirrep,occup(1,2))
      totocc(1)=0
      totocc(2)=0
      do i=1,nirrep
         totocc(1)=totocc(1)+occup(i,1)
         totocc(2)=totocc(2)+occup(i,2)
      end do
      if (iuhf.ne.1) totocc(2)=totocc(1)
      totocca=totocc(1)
      totoccb=totocc(2)
      return
c     end subroutine sb_com_symm2_ks
      end

      subroutine sb_com_symm2_ks
      implicit none



c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end











      integer           iuhf
      common /iuhf_com/ iuhf
      save   /iuhf_com/




      integer maxirrep,num2comb,max2comb
      parameter (maxirrep=8)
      parameter (num2comb=22)
      parameter (max2comb=25)

c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end
      integer        nirrep, numbasir(8),
     &               irpsz1(36),irpsz2(28),irpds1(36),irpds2(56),
     &               old_irpoff(9), irrorboff(9), dirprd(8,8),
     &               old_iwoff1(37), old_iwoff2(29),
     &               inewvc(maxbasfn), idxvec(maxbasfn),
     &               irrtrilen(9), irrtrioff(8),
     &               irrsqrlen(9), irrsqroff(8)
      common /symm2/ nirrep, numbasir,
     &               irpsz1,    irpsz2,    irpds1,    irpds2,
     &               old_irpoff,    irrorboff,    dirprd,
     &               old_iwoff1,     old_iwoff2,
     &               inewvc,           idxvec,
     &               irrtrilen,    irrtrioff,
     &               irrsqrlen,    irrsqroff
      save   /symm2/

      integer             occup(8,2),totocc(2),totocca,totoccb,
     &                    maxirrtri,maxirrsqr,irrtritot,irrsqrtot
      common /sym_ks_com/ occup,     totocc,   totocca,totoccb,
     &                    maxirrtri,maxirrsqr,irrtritot,irrsqrtot
      save   /sym_ks_com/



      double precision nucrep
      integer length,ijunk,irrep,sqroff,trioff,n,tri,sqr,i,orb,iunit
      character*80 iiiifil
      character*8 title(24)
      logical bExist
      call gfname('IIII',iiiifil,length)
      inquire(file=iiiifil,exist=bExist)
      if (.not.bExist) then
         write(*,*) '@SB_COM_SYMM2_KS: No IIII integral file.'
         call errex
      end if
      iunit = 10
      open(iunit,file=iiiifil,form='unformatted',access='sequential')
      read(iunit) title,nirrep
      rewind(iunit)
      read(iunit) title,nirrep,(numbasir(i),i=1,nirrep),nucrep
      close(iunit,status='keep')
      call getrec(0,'JOBARC','NUCREP  ',length,n)
      if (length.eq.0) call putrec(1,'JOBARC','NUCREP  ',iintfp,nucrep)
      call putrec(1,'JOBARC','NUMBASIR',nirrep,numbasir)
      sqroff=1
      trioff=1
      maxirrsqr=0
      maxirrtri=0
      orb=1
      do irrep=1,nirrep

         n=numbasir(irrep)
         irrorboff(irrep)=orb
         orb=orb+n

         sqr=n*n
         tri=n*(n+1)/2

         irrsqrlen(irrep)=sqr
         irrsqroff(irrep)=sqroff
         sqroff=sqroff+sqr
         maxirrsqr=max(maxirrsqr,sqr)

         irrtrilen(irrep)=tri
         irrtrioff(irrep)=trioff
         trioff=trioff+tri
         maxirrtri=max(maxirrtri,tri)

      end do
      irrorboff(nirrep+1)=orb
      irrsqrtot=sqroff-1
      irrtritot=trioff-1

      call getrec(-1,'JOBARC','OCCUPYA0',nirrep,occup(1,1))
      call getrec(-1,'JOBARC','OCCUPYB0',nirrep,occup(1,2))
      totocc(1)=0
      totocc(2)=0
      do i=1,nirrep
         totocc(1)=totocc(1)+occup(i,1)
         totocc(2)=totocc(2)+occup(i,2)
      end do
      if (iuhf.ne.1) totocc(2)=totocc(1)
      totocca=totocc(1)
      totoccb=totocc(2)
      return
c     end subroutine sb_com_symm2_ks
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c---------------------------------------------------------------------------
c   Code to implement a timer subsystem.
c
c   Timers must first be registered by calling subroutine register_timer.
c   This routine accepts a character string describing the timer event, and
c   returns a key to use when referencing the timer.
c
c   As timer data is collected, it is updated by calls to subroutine
c   timer_start, followed by update_timer.  A call to timer_start starts
c   the timer, the corresponding call to update_timer turns it off and 
c   adds the result to the accumulator.
c
c   At the end of the program, the master process accumulates the timer data 
c   and prints a report of each timer that has been registered.
c---------------------------------------------------------------------------

      subroutine init_timers()
c---------------------------------------------------------------------------
c   Initialize the timer data structures.
c---------------------------------------------------------------------------

      implicit none
      include 'timerz.h'
      include 'sip_tables.h'
      include 'dbugcom.h'
      integer i
      integer old_max_timers

      old_max_timers = max_allocated_timers 

c     max_timers = mx_noptable

#if defined VERY_DETAILED_TIMERS
      max_timers = max_timers * 8
#elif defined DETAILED_TIMERS 
      max_timers = max_timers * 5
#else
      max_timers = max_timers * 4
#endif
      max_timers = max_timers + 5
cVFL 8/12/2013 quick hack 
      max_timers = max_allocated_timers  
      if (max_timers .gt. old_max_timers) then
          print *, 'max_timers ', max_timers, ' gt ', old_max_timers
          call abort_job()
      endif

      if (dbg) print *,'max_timers set to ', max_timers
c      print *,'VFL max_timers set to ', max_timers

      do i = 1, max_timers
         tdesc(i) = ' '
         timers(i) = 0.
         tmark(i) = -1.
         timer_type(i) = -1
         timer_times(i) = 0.
         interim_timers(i) = 0.
         interim_start_timers(i) = -1.
      enddo
      return
      end

      subroutine register_timer(desc, type, key)
c---------------------------------------------------------------------------
c   Registers a timer with the timer subsystem.  
c
c   Arguments:
c      desc (char)     	Character description of the timer being measured.
c      type             Type of timer.
c      key		Returned key to use in updating the timer.
c
c   This routine aborts if too many timers are registered.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'timerz.h'
      include 'saved_data.h'
      include 'parallel_info.h'

      character*(*) desc
      integer key, type
      integer i, j, desc_len, str_len
      integer ierr

      if (first_timer) then
         first_timer = .false.
         
         current_last_timer = 1

         do i = 1, max_timers
            tdesc(i) = ' '
            timers(i) = 0.
            tmark(i) = -1.
            timer_type(i) = -1.
            timer_times(i) = 0.
            interim_timers(i) = 0.
            interim_start_timers(i) = -1.
         enddo
      endif

c------------------------------------------------------------------------
c   Validate timer type.
c------------------------------------------------------------------------

      if (type .ne. cpu_timer .and.
     *    type .ne. elapsed_time_timer .and.
     *    type .ne. times_exec_timer .and. 
     *    type .ne. average_unit_timer) then
         print *,'Error: register_timer called with invalid timer type',
     *      ' for ',desc,'.  Type = ',type
         call abort_job()
      endif
c------------------------------------------------------------------------
c   Determine string length as either (1) len(desc) or (2) the
c   null-terminated string length (as in C).
c------------------------------------------------------------------------

      str_len  = max_timer_desc_len
      desc_len = str_len
      do j = 1, str_len
         if (ichar(desc(j:j)) .eq. 0) then
            desc_len = j-1
            go to 50
         endif
      enddo

   50 continue    
      if (desc_len .eq. 0) then
         print *,'Error: register_timer called with desc length 0'
         print *,'desc = ',desc,' type = ',type
         call abort_job()
      endif

c------------------------------------------------------------------------
c   Check to see if timer has already been registered.
c------------------------------------------------------------------------

c      do i = 1, max_timers
c         if (tdesc(i)(1:desc_len) .eq. desc(1:desc_len) .and.
c     *       type .eq. timer_type(i)) then
c            key = i   ! duplicate of a previously registered timer.
cc            print *,'timer with desc ', desc,' was registered again'
c            return
c         endif 
c      enddo

c      do i = 1, max_timers
c         if (tdesc(i)(1:1) .eq. ' ') then
c            tdesc(i)  = desc(1:desc_len)
c            timers(i) = 0.
c            tmark(i)  = -1.
c            timer_type(i) = type
c            timer_times(i) = 0
c            interim_timers(i) = 0.
c            interim_start_timers(i) = -1.
c            if (type .eq. average_unit_timer) timers(i) = -2;
c            key = i 
c            return
c         endif
c      enddo

c------------------------------------------------------------------------
c               Duplicate timers allowed  - Nakul                        
c------------------------------------------------------------------------

      if (current_last_timer .lt. max_timers-1) then
          i = current_last_timer
          tdesc(i)  = desc(1:desc_len)
          timers(i) = 0.
          tmark(i)  = -1.
          timer_type(i) = type
          timer_times(i) = 0
          interim_timers(i) = 0.
          interim_start_timers(i) = -1.
          if (type .eq. average_unit_timer) timers(i) = -2;
          key = i 
          current_last_timer = key + 1
          return
      endif


      call mpi_comm_rank(mpi_comm_world, me, ierr)
      print *,'Error: Too many timers are already in service.'
      print *,'       There is a limit of ',max_timers,' timers.'
      print *,'       Attempted to register ',desc,' on processor ',
     *                   me
      call mpi_abort(mpi_comm_world, 1, ierr)
      return
      end

      subroutine timer_start(key)
c---------------------------------------------------------------------------
c   Starts the timer referenced by "key".
c---------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'timerz.h'
      include 'parallel_info.h'
      include 'trace.h' 
      integer key, ierr
      integer my_type
      integer utime_sec, stime_sec, utime_usec, stime_usec

      if (.not. do_timer) return

      ierr = 0
      if (key .eq. 0) return
      if (key .lt. 1 .or. key .gt. max_timers) then
         print *,'Error: timer_start was called with key ',key,
     *             ' out of range.'
         ierr = 1
      else
         if (tdesc(key) .eq. ' ') then
            print *,'Error: Timer ',key,' is being started without ',
     *              'being registered.'
            ierr = 2
         endif
      endif

      if (ierr .eq. 0 .and.
     *    tmark(key) .ne. -1.) then
         print *,'Task ',me,' Error: Timer ',tdesc(key),
     *             ' is being started ',
     *            'without a corresponding update. key = ',
     *            key
         ierr = 3
      endif

      if (ierr .eq. 0) then
         my_type = timer_type(key)
         if (my_type .eq. elapsed_time_timer) then
            tmark(key) = mpi_wtime()   ! turn on the timer
         else if (my_type .eq. cpu_timer) then
c            call c_rutimes(utime_sec, utime_usec, stime_sec, 
c     *                     stime_usec)
c            tmark(key) = 1.d-6*(utime_usec + stime_usec) + 
c     *                         (utime_sec + stime_sec)
         else if (my_type .eq. times_exec_timer) then
             tmark(key) = 1.
         else if (my_type .eq. average_unit_timer) then
             if (timer_times(key) .eq. 0.) timers(key) = 0.
             tmark(key) = mpi_wtime()
         else 
            print *,'Error: Invalid timer type: key = ',key,
     *             ' type = ',timer_type(key)
            call abort_job()
         endif
      else
         print *,'Task ',me,' Aborting due to timer errors at line ',
     *        current_line
         call mpi_abort(mpi_comm_world, 1, ierr)   ! abort the job.
      endif

      return
      end


      subroutine pause_timer(key)

c----------------------------------------------------------------------------
c   pauses average_unit_timer
c----------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'timerz.h'
      include 'parallel_info.h'
      include 'trace.h'
      integer key, ierr
      
      if (.not. do_timer) return

      if (key .eq. 0) return

      if (key .lt. 1 .or. key .gt. max_timers) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Process ',me,' attempted to update timer ',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      if (timer_type(key) .ne. average_unit_timer) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Worker ',me,' tried to pause non avg timer',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)

      endif
    
      if (interim_start_timers(key) .ne. -1) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Worker ',me,' paused non existant timer',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      interim_start_timers(key) = mpi_wtime()

      end


      subroutine resume_timer(key)

c----------------------------------------------------------------------------
c   resumes average_unit_timer
c----------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'timerz.h'
      include 'parallel_info.h'
      include 'trace.h'
      integer key, ierr
      if (.not. do_timer) return

      if (key .eq. 0) return

      if (key .lt. 1 .or. key .gt. max_timers) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Process ',me,' attempted to update timer ',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      if (timer_type(key) .ne. average_unit_timer) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Worker ',me,' tried to pause non avg timer',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)

      endif
    
      if (interim_timers(key) .eq. -1) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Worker ',me,' resumed non existant timer',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif
    
      interim_timers(key) = interim_timers(key) + mpi_wtime() - 
     *                              interim_start_timers(key) 
      interim_start_timers(key) = -1
    
      end




      subroutine update_timer(key)
c----------------------------------------------------------------------------
c   Accumulates "time_val" into the timer referenced by "key".
c----------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'timerz.h'
      include 'parallel_info.h'
      include 'trace.h'

      double precision time_val
      integer key
      integer ierr
      integer utime_sec, stime_sec, utime_usec, stime_usec

      if (.not. do_timer) return

      if (key .eq. 0) return

      if (key .lt. 1 .or. key .gt. max_timers) then
         call mpi_comm_rank(mpi_comm_world, me, ierr)
         print *,'Error: Process ',me,' attempted to update timer ',
     *           key,'.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      else

c------------------------------------------------------------------------------
c  Valid timer key.  Determine if the timer has been started.
c-----------------------------------------------------------------------------

         if (timer_type(key) .eq. elapsed_time_timer) then
            time_val       = mpi_wtime() - tmark(key)
            timers(key)    = timers(key) + time_val
         else if (timer_type(key) .eq. cpu_timer) then
c             call c_rutimes(utime_sec,utime_usec,stime_sec,
c     *                      stime_usec)
c             time_val = 1.d-6*(utime_usec+stime_usec) + 
c     *                        (utime_sec+stime_sec) - tmark(key)
         else if (timer_type(key) .eq. times_exec_timer) then 
            time_val = 1;
            timers(key)    = timers(key) + time_val
         else if (timer_type(key) .eq. average_unit_timer) then
            time_val = mpi_wtime() - tmark(key) - interim_timers(key)
            timers(key) = timers(key) * timer_times(key) + time_val
            timer_times(key) = timer_times(key) + 1
            timers(key) = timers(key) / timer_times(key)
            interim_timers(key) = 0.
         endif

         tmark(key)  = -1.   ! turn off the timer.
      endif

      return
      end  

      subroutine stop_timers()
c-------------------------------------------------------------------------
c   Stops all timers on a process wihtout updating them.  This allows any
c   leftover timers that are still running to be turned off and reused at
c   a later point.
c-------------------------------------------------------------------------
      implicit none
      include 'timerz.h'

      integer i

      if (.not. do_timer) return

      do i = 1, max_timers
         tmark(i) = -1.
      enddo
      return
      end

      subroutine reset_timer_info()
c----------------------------------------------------------------------------
c   Resets all existing timers to 0.
c----------------------------------------------------------------------------
      implicit none
      include 'timerz.h'

      integer i

      if (.not. do_timer) return
      call stop_timers()    ! make sure they are not running.
      
      do i = 1, max_timers
         timers(i) = 0.
      enddo

      return
      end

      subroutine timer_report(siofile, descs, timer_data, contrib,
     *                        sumsq, nprocs)
c-------------------------------------------------------------------------
c   Called by the master to produce a report of the accumulated timer
c   data collected from each integral worker.
c-------------------------------------------------------------------------

      implicit none
      include 'timerz.h'

      integer ranks_per_line
      parameter (ranks_per_line = 4)

      integer max_calls
      parameter (max_calls = 1000)

      integer i, j, k, l, ndx, lndx, nprocs
      integer nline, nworker
      integer ntimers
      double precision timer_data(max_timers,3)
      double precision contrib(max_timers)
      double precision sumsq(max_timers)
      
      character*(max_timer_desc_len) descs(*)
      character*(*) siofile
      character*32 call_table(max_calls)
      character*256 aces_source_dir
      character*120 srcline, token
      character*256 srcfile, sialfile
      character*40  pardo_desc, blkwait_desc, timerdesc, overhead_desc
      character*60 line_fmt

      integer n
      integer lineno, lenval, ierr
      integer str_trimlen
      integer nprepare, npreparesum, nrequest, nprequest
      integer ndesc, nxtcall, ncalls
      integer call_line(max_calls)
      double precision call_nproc(max_calls)
 
      integer ranks(ranks_per_line)
      double precision data(ranks_per_line)
      double precision sum, avg, sdev
      double precision temp
      double precision calc_sdev
      double precision call_sum(max_calls), call_sumsq(max_calls)
      real pardo_avg, blkwait_avg, efficiency
      real call_tmin(max_calls), call_tmax(max_calls)
      
      logical source_level_analysis 
      logical proc_timer, pardo_timer, line_timer, timer_exist

c---------------------------------------------------------------------------
c   Build a table of all the unique timer descriptions.
c---------------------------------------------------------------------------

      if (.not. do_timer) return   ! nothing to do.

c---------------------------------------------------------------------------
c   Check for the ACES_SOURCE_DIR env. variable.
c---------------------------------------------------------------------------

      aces_source_dir = ' '
      call c_getenv('ACES_SOURCE_DIR'//char(0),
     *            aces_source_dir, lenval, ierr)
      if (ierr .eq. 0) then
         source_level_analysis = .true.
         lenval = str_trimlen(aces_source_dir)
      else
         source_level_analysis = .false.
      endif

      if (source_level_analysis) go to 1000 

c---------------------------------------------------------------------------
c   Print individual worker's statistics.
c---------------------------------------------------------------------------

      print *,'---------- Summary of Timer Statistics ----------'
      print *,' '


c---------------------------------------------------------------------------
c   Print out time for optable_loop processing - Nakul
c---------------------------------------------------------------------------

c      print *,"time spent in processing optable :", timer_optl

c--------------------------------------------------------------------------
c   Calculate and print average and standard dev. of all timers.
c--------------------------------------------------------------------------

       print 400
       print 500
       call c_flush_stdout()
      do i = 1, max_timers
         avg  = timer_data(i,1) 
         sdev = 0.

         if (descs(i)(1:1) .ne. ' ' .and.
     *       descs(i)(1:1) .ne. char(0)) then
            if (contrib(i) .le. 1.) then
               avg = timer_data(i,1)
               sdev = 0.d0
            else  
               avg = timer_data(i,1)/contrib(i)
               sdev = calc_sdev(sumsq(i), timer_data(i,1), contrib(i))
            endif

            if (timer_data(i,3) .eq. 1.d10)    ! remove init value for min
     *          timer_data(i,3) = 0.d0
       
            if (avg .gt. 0.0) 
     *         print 200,descs(i)(1:25), avg, sdev, 
     *             timer_data(i,3), timer_data(i,2) 
         endif
      enddo
      return

 1000 continue
 
c-----------------------------------------------------------------------
c   SOURCE LEVEL ANALYSIS: Find the name of the source file.
c-----------------------------------------------------------------------

      n = str_trimlen(siofile)
      if (siofile(n-3:n) .eq. '.sio') then
         srcfile = siofile(1:n-4) // '.sial'
      else
         print *,'Error: Cannot determine SIAL filename'
         print *,'siofile is ',siofile
         call abort_job() 
      endif

      n = str_trimlen(srcfile)
      print *,'------ Timer statistics for SIAL file ',srcfile(1:n),
     *        '------'



c-------------------------------------------------------------------------
c   Open the source file 
c-------------------------------------------------------------------------

      sialfile = aces_source_dir(1:lenval)// '/' // 
     *           srcfile(1:n) 
      open(unit=95, file=sialfile,
     *     form='formatted', status='OLD',err=1100,iostat=ierr)
     
      lineno  = 1
      nxtcall = 0
      go to 1200

 1100 continue
      print *,'Error opening src file: ',
     *     aces_source_dir(1:lenval)//srcfile(1:n) ,
     *     ' iostat = ',ierr
      call abort_job()

 1200 continue
      read(95,'(a)',end=2000) srcline

c------------------------------------------------------------------------
c   Omit any embedded nulls.
c------------------------------------------------------------------------

      nline = str_trimlen(srcline)
      do i = 1, nline
         if (srcline(i:i) .eq. char(0)) srcline(i:i) = ' '
      enddo

      line_fmt = ' '
      if (nline .ge. 100) then
         write (line_fmt, 9000) nline
      else if (nline .ge. 10 ) then
         write (line_fmt, 9050) nline
      else
         write (line_fmt, 9060) nline
      endif
 
c--------------------------------------------------------------------------
c   Do we have timer data to print for this line?
c--------------------------------------------------------------------------

      pardo_timer = .false.
      proc_timer = .false.

c-------------------------------------------------------------------------
c   Pick up the first token off the source line.
c-------------------------------------------------------------------------
       
      token = ' '
      call f_strtoken(srcline, ' ', token)

      if (token(1:4) .eq. 'call' .or.
     *         token(1:4) .eq. 'CALL') then
         nxtcall = nxtcall + 1
         token = ' '
         call f_strtoken(char(0), ' ', token)  ! get proc name 
         if (token(1:1) .eq. char(0)) then
            print *,'Error: Cannot find proc name for CALL at line ',
     *         lineno
            print *,'srcline = ',srcline
            print *,'token ',token
            call abort_job()
         else
            call_table(nxtcall) = token
            call_line(nxtcall)  = lineno
         endif
      else if (token(1:5) .eq. 'pardo' .or.
     *         token(1:5) .eq. 'PARDO') then
         pardo_timer = .true.

         pardo_desc = ' '
         write (pardo_desc,9300) lineno
         blkwait_desc = ' '
         write (blkwait_desc,9400) lineno

c         overhead_desc = ' '
c         write (overhead_desc,9450) lineno

      else
         timerdesc = ' ' 
         write (timerdesc,9500) lineno
         ndesc = str_trimlen(timerdesc)
      endif 
      
      if (pardo_timer) then

c--------------------------------------------------------------------------
c   Calculate the average of all pardo and block wait timers for this loop.
c---------------------------------------------------------------------------

         pardo_avg = 0.
         blkwait_avg = 0.
         do i = 1, max_timers
            if (descs(i) .eq. pardo_desc) then
               if (contrib(i) .eq. 0.) then
                  pardo_avg = 0.
               else
                  pardo_avg = timer_data(i,1) / contrib(i)
               endif 
               go to 2200
            endif
         enddo

 2200    continue 
         do i = 1, max_timers
            if (descs(i) .eq. blkwait_desc) then
               if (contrib(i) .eq. 0.) then
                  blkwait_avg = 0.
               else
                  blkwait_avg = timer_data(i,1) / contrib(i)
               endif
               go to 2300 
            endif
         enddo

 2300    continue
         if (pardo_avg .gt. 0.) then
            efficiency = 100.0 * (pardo_avg - blkwait_avg) / pardo_avg
         else
            efficiency = 0.
         endif

c---------------------------------------------------------------------------
c   Now get the server-side data pertaining to the loop.
c---------------------------------------------------------------------------

         call get_server_stats(lineno, nprepare, npreparesum, nrequest,
     *                         nprequest ) 

         print 9200,pardo_avg, blkwait_avg, n, efficiency
         print *,'   Num. prepares ',nprepare,' Num. preparesum ',
     *              npreparesum,' Num. requests ', nrequest,
     *              ' Num. prequest ',nprequest
         print line_fmt, lineno,srcline(1:nline)
      else if (proc_timer) then
      else

c----------------------------------------------------------------------------
c   Check for a timer with this line number encoded into it.
c----------------------------------------------------------------------------

         timer_exist = .false.
      
         do i = 1, max_timers
            call f_strtoken(descs(i), ':', token)
            if (token(1:1) .ne. char(0)) then
               if (token(1:ndesc) .eq. timerdesc) then
                  if (contrib(i) .le. 1.) then
                     avg = timer_data(i,1)
                     sdev = 0.d0 
                  else
                     avg = timer_data(i,1) / contrib(i)
                     sdev = calc_sdev(sumsq(i), timer_data(i,1),
     *                                contrib(i))
                  endif
         
                  timer_exist = .true.
                  go to 1500
	       endif
            endif
         enddo

 1500    continue
         if (timer_exist) then
            line_fmt = ' '
            if (nline .ge. 100) then
               write(line_fmt, 9600) nline
            else if (nline .ge. 10) then
               write(line_fmt, 9650) nline
            else
               write(line_fmt, 9660) nline
            endif 

            print line_fmt, real(avg), real(timer_data(i,3)), 
     *             real(timer_data(i,2)), 
     *             real(sdev), lineno, srcline(1:nline) 
         else 
            print line_fmt, lineno, srcline(1:nline) ! no timer for this line
         endif 
      endif

      lineno = lineno + 1

      go to 1200
 
 2000 continue

c---------------------------------------------------------------------------
c   Make a pass through the proc calls to generate the call data.
c---------------------------------------------------------------------------

      ncalls = nxtcall
      do i = 1, ncalls
         timerdesc = ' '
         write (timerdesc, 9700) call_line(i)
         
         do j = 1, max_timers
            if (descs(j) .eq. timerdesc) then
               call_sum(i)   = timer_data(j,1)
               call_sumsq(i) = sumsq(j)
               call_tmin(i)  = timer_data(j,3)
               call_tmax(i)  = timer_data(j,2)
               call_nproc(i) = contrib(j)
               go to 2400
            endif
         enddo
 2400    continue
 
      enddo

c---------------------------------------------------------------------------
c   Print the call data.
c---------------------------------------------------------------------------

      print *,'---------- Table of proc calls -----------------------'
      print 9750

      do i = 1, ncalls
         if (call_nproc(i) .gt. 0) then
            avg = call_sum(i) / call_nproc(i)
            if (call_nproc(i) .le. 1.) then
               sdev = 0.d0
            else
               sdev = calc_sdev(call_sumsq(i), call_sum(i), 
     *                       call_nproc(i))
            endif
            n = str_trimlen(call_table(i)) 
	    print 9800,call_table(i)(1:n),call_line(i), real(avg), 
     *            call_tmin(i), call_tmax(i), real(sdev)
         endif
      enddo

      timerdesc = ' '
      write (timerdesc, 9760)
      do i = 1,max_timers
          if (descs(i) .eq. timerdesc) then
              if (contrib(i) .le. 1) then
                  avg = timer_data(i,1)
                  sdev = 0.d0
              else 
                 avg = timer_data(i,1)/contrib(i)
                 sdev = calc_sdev(sumsq(i), timer_data(i,1), contrib(i))
              endif
            if (timer_data(i,3) .eq. 1.d10)    ! remove init value for min
     *          timer_data(i,3) = 0.d0
       
            if (avg .gt. 0.0) 
     *         print 200,descs(i)(1:25), avg, sdev, 
     *             timer_data(i,3), timer_data(i,2) 
         endif
      enddo

c---------------------------------------------------------------------------
c   Make one last pass to print block wait time.
c---------------------------------------------------------------------------

      n = 0
      sum = 0.
      timerdesc = 'Block wait time'
      ndesc = str_trimlen(timerdesc)
      do i = 1, max_timers
         if (descs(i)(1:ndesc) .eq. timerdesc) then
            if (contrib(i) .le. 1.d0) then 
               avg = timer_data(i,1)
            else
               avg = timer_data(i,1) / contrib(i)
            endif
            go to 2500
         endif
      enddo

 2500 continue

      print *,'Average block wait time: ',avg  
      print *,'------------------------------------------------------'
      return

  100 format(1x,a25,5(1x,f18.6))
  200 format(1x,a25,1x,f18.6,1x,f18.6,7x,f18.6,3x,f18.6)
  300 format(1x,'Rank               ',9(9x,i4))
  400 format(32x,'Average    Standard deviation',
     *       '  Min. time   Max. time')
  500 format(25x,'-------------   ------------------',
     *       '   --------   --------')

      
 9000 format('(48x,''| '',i6,'': '',a',i3,')')
 9050 format('(48x,''| '',i6,'': '',a',i2,')')
 9060 format('(48x,''| '',i6,'': '',a',i1,')')
 9200 format('*** PARDO LOOP: time ',f18.6,' Block wait time ',f18.6,
     *       ' Num. procs ',i5,' Loop efficiency ',f7.3,'% ***')
 9300 format('Pardo at line ',i10)
 9400 format('Blkwait for pardo ',i10)
c 9450 format('Ovrhead for pardo ',i10)
 9500 format('Line',i6)
 9600 format('(4(1x,f11.5),''| '',i6,'': '',a',i3,')')
 9650 format('(4(1x,f11.5),''| '',i6,'': '',a',i2,')')
 9660 format('(4(1x,f11.5),''| '',i6,'': '',a',i1,')')
 9700 format('Proc call at line ',i6) 
 9760 format('Optable time ') 
 9750 format(57x,'Average',6x,'Min. time',5x,'Max. time',4x,
     *         'Std. Dev.')
 9800 format('CALL ',a32,' at line ',i6,': ',4(f18.6,1x))
      end

      subroutine print_timers()
c--------------------------------------------------------------------------
c   Print the contents of all timers for debugging purposes.
c--------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'timerz.h'

      integer i, me, ierr
      
      call mpi_comm_rank(mpi_comm_world, me, ierr)
      print *,'Timer info on process ',me

      do i = 1, max_timers
         if (tdesc(i)(1:1) .ne. ' ') then
            print *,tdesc(i),' ',timers(i)
         endif
      enddo
      return
      end
     
      subroutine print_timer(str, key)
c------------------------------------------------------------------------
c   Prints an individual timer for debugging purposes.
c------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'timerz.h' 
      integer key, me, ierr
      character*(3) str

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      print *,str(1:3), ' Timer ',tdesc(key)(1:20),' on ',me,
     *                  ': ',timers(key)
      return
      end

      double precision function calc_sdev(sumsq, sumdata, contrib)
      double precision sumsq, sumdata, contrib

      double precision temp, dnom

      if (dabs(contrib-1.d0) .le. 0.d-6) then
         calc_sdev = 0.d0
         return
      endif

      temp = sumsq * contrib - sumdata * sumdata
      if (temp .lt. 0.d0) then
         calc_sdev = 0.d0
         return
      endif

      dnom = contrib * (contrib - 1.d0)
      calc_sdev = dsqrt(temp / dnom ) 
      return 
      end

      SUBROUTINE MODFY_HESSIAN(DIAGHES, HESMOD, HES, QSTLST_TANGENT,
     &                         SCRATCH, EIGVALUE, WEIGHT, NOPT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "jodaflags.com"

      DIMENSION HESMOD(NOPT, NOPT), QSTLST_TANGENT(NOPT),
     &          SCRATCH(NOPT), DIAGHES(NOPT, NOPT),
     &          HES(NOPT, NOPT)
      DATA ONE /1.0D0/, TWO /2.0D0/
C
C Note that at the moment SCRATCH array contains the HxT. Let's label
C that product as A vector. As we can see the A vector is an arbitrary
C direction in the space of the eigenvectors of H.
C Impetus for this formula is from Ayala & Schlegel, JCP, 375, 1997.
C Eqn. 7a. 
 
         SCALED_WEIGHT = TWO*EIGVALUE*WEIGHT
        
         CALL XGEMM('T','N', NOPT, NOPT, 1, 1.0D0, QSTLST_TANGENT,
     &               1, SCRATCH, 1, 0.0D0, DIAGHES, NOPT)
         CALL TRANSP(DIAGHES, HESMOD, NOPT, NOPT)
         CALL XDAXPY(NOPT*NOPT, 1.0D0, HESMOD, 1, DIAGHES, 1) 
         CALL XDSCAL(NOPT*NOPT, -WEIGHT, DIAGHES, 1)
         CALL XDAXPY(NOPT*NOPT, 1.0D0, DIAGHES, 1, HES, 1)
         CALL XGEMM('T','N', NOPT, NOPT, 1, SCALED_WEIGHT, 
     &               QSTLST_TANGENT, 1,
     &               QSTLST_TANGENT, 1, 1.0D0, HES, NOPT)

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The modified. Hessian"
      Call output(HES, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
#endif
C
C Diagonalize the modified Hessian and print the eigenvalues and
C vectors. These new vectors and the values dictate the climbing
C phase of the search.
C
         CALL XDCOPY(NOPT*NOPT, HES, 1, HESMOD, 1)
         CALL EIG(HESMOD, DIAGHES, NOPT, NOPT, 1)

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The Eigen vectors of modified. Hessian"
      Call output(DIAGHES, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
      Write(6,"(a)") "The Eigen values of modified Hessian"
      Write(6, "(3(1x,F12.6)))") (hesmod(i,i), i=1,nopt)
#endif
C
C
C This block of code is obsoleted. 
#ifdef _NO_OBSOLETE
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The Eigen vectors of the orig. Hessian"
      Call output(DIAGHES, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
      Write(6,"(a)") "The Eigen values of the orig.  Hessian"
      Write(6, "(6(1x,F12.6))") (hesmod(i,i), i=1,nopt)
#endif
         SCALED_WEIGHT = TWO*EIGVALUE*WEIGHT
         CALL XDCOPY(NOPT, QSTLST_TANGENT, 1, DIAGHES, 1)
         CALL GSCHMIDT(DIAGHES, NOPT, NOPT, SCRATCH, RESID)
C
         CALL XGEMM('T','N', NOPT, NOPT, 1, SCALED_WEIGHT, 
     &               QSTLST_TANGENT, 1,
     &               QSTLST_TANGENT, 1, 1.0D0, HESMOD, NOPT)
      
CSSS      CALL XGEMM('N','N', NOPT, NOPT, NOPT, 1.0D0, DIAGHES, NOPT, 
CSSS     &            HES, NOPT, 0.0D0, SCRATCH, NOPT)
CSSS      CALL XGEMM('N','T', NOPT, NOPT, NOPT, 1.0D0, SCRATCH, NOPT, 
CSSS     &            DIAGHES, NOPT, 0.0D0, HESMOD, NOPT)
      CALL EIG(HESMOD, DIAGHES, NOPT, NOPT, 1)

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The Eigen vectors of modf. Hessian"
      Call output(DIAGHES, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
      Write(6,"(a)") "The Eigen values of modified Hessian"
      Write(6, "(6(1x,F12.6))") (hesmod(i,i), i=1,nopt)
#endif
      Endif
#endif

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function find_free_msg_buffer(req, nreq, itimer, ctimer)
c------------------------------------------------------------------------------
c   This function searches an array of MPI requests until it finds one that
c   is free (i. e. req(i) = MPI_REQUEST_NULL).  If it cannot find a free 
c   request, it waits for one of the requests to complete, and returns the 
c   index of the completed request.  
c-----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'parallel_info.h'
      integer nreq
      integer req(nreq)
      integer itimer, ctimer

      integer i, ireq, ierr
      integer status(MPI_STATUS_SIZE)
   
      do i = 1, nreq
         if (req(i) .eq. MPI_REQUEST_NULL) then
            ireq = i
            go to 100
         endif
      enddo

c--------------------------------------------------------------------------
c   All buffers have outstanding requests.
c   Copy the requests into a scratch area, and test for a completion.
c--------------------------------------------------------------------------

      call update_timer(itimer)
      call timer_start(ctimer)
      call mpi_waitany(nreq, req, ireq, status, ierr)
      call update_timer(ctimer)
      call timer_start(itimer)

  100 continue
      find_free_msg_buffer = ireq
      return
      end

#include "flags.h" 
      SUBROUTINE SYMMETRY_AUTO(SCRATCH, QTMP, NEWQ, IT, IDEGEN, 
     &                         ORIEN2, NOSILENT)
C
C     SUBROUTINE DOES SYMMETRY ANALYSIS AND PUTS MOLECULE IN AN
C     ORIENTATION THAT ACES2 CAN DEAL WITH
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "fnamelen.par"
#include "coord.com"

      DOUBLE PRECISION IT(3,3),CM(3),IV(3,3),NEWQ(NX),dtmp
      DOUBLE PRECISION RM(3,3),QTMP(NX),TATB(3)
      DOUBLE PRECISION SCRATCH(3*NX),MOLWT,ORIEN2(9)
      LOGICAL ALLDONE,ITWOAX, TSSEARCH, NOSILENT 

cSB START
      logical olddone,tetrah
cSB END

      LOGICAL OPTRES
      CHARACTER*3 SYMSTR(6)
      CHARACTER*4 some_string_func, JNKSTR, TMPGRP
      CHARACTER*2 XYZP(3)
      CHARACTER*1 XYZ(3),DOSTR(3),CHRTMP
      CHARACTER*(fnamelen) FNAME
      INTEGER ORDNEW,ORDOLD,IORGRP
      LOGICAL YESNO,SAXIS,SKIP,XYZIN,NWFINDIF
      DIMENSION NORD(3*MXATMS),IORBPOP(MXATMS)
      DIMENSION IORBREF(MXATMS)
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      COMMON /TOLERS/ SYMTOL,DEGTOL
      COMMON/RESTART2/OPTRES
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $     ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $     XYZTol
      COMMON /INPTYP/ XYZIN, NWFINDIF
C
#include "cbchar.com"
C
      CHARACTER*(5*MXATMS) ZSYMUNI
C
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
#include "io_units.par"
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      DATA XYZ /'X','Y','Z'/
      DATA XYZP /'YZ','XZ','XY'/
      DATA ONE   / 1.0D+00/
      DATA ONEM  /-1.0D+00/
      DATA ZILCH / 0.0D+00/
      DATA IONE /1/
      IND(I,J) = 3*(I-1)+J
c
c
      CALL GETCREC(-1, 'JOBARC', "PTGP    ", 4, FPGRP) 
      TMPGRP=FPGRP
      FPGRP='    '
      DTOR=DACOS(ONEM)/180.D0
C
C INITIALIZE MILLIONS OF VARIABLES THAT CFT77 SAYS AREN'T INITIALIZED.
C
      OLDDONE=.FALSE.
      IHIGH=0
      IROT=0
      IREF=0
      IINV=0
      IDGRP=0
      ILINEAR=0
      ICOMP=0
      ICOUNT=0
      IDONE=0
      ISINV=0
      ICOMPQ=0
      IIAX=0
      ORDIS=0
      IERR=0
      ISET=0
      NUMB=0
      ICOMP2=0
      IHIGHX=0
      ISAXIS=0
      JCOMPX=0
      JCOMP=0
      ICOMPX=0
      ISKIP=0
      DOSTR(1)='X'
      DOSTR(2)='Y'
      DOSTR(3)='Z'
      TSSEARCH = (INR .EQ. 4 .OR. INR .EQ. 5 .OR. INR .EQ. 6)
      CALL IZERO(IORBPOP,MXATMS)
      CALL IZERO(IORBREF,MXATMS)

      IF(IDEGEN.EQ.0)THEN
C IDEGEN is zero for Abelian point groups. We can transfer the
C logic to statement 9000 (only symmetry operations
C that we need to deal with is rotation, reflection, and inversion).
C It looks like that this goto 9000 can not be easily avoided.
        GOTO 9000
      ENDIF
C This 777 entry point is used when the degeneracy found by
C inertia matrix was accidental.
  777 CONTINUE
C
C****************************************************************
C
C CODE FOR POINT GROUPS WITH DOUBLY DEGENERATE REPRESENTATIONS.
C
C****************************************************************
      IF(IDEGEN.EQ.1)THEN
C
C     IF DOUBLY DEGENERATE, CHECK TO MAKE SURE THAT THE PRINCIPAL AXES
C     ARE PARALLEL TO X,Y AND Z.  IF NOT, ROTATE ORIENTATION TO THIS
C     POINT.
C
        FPGRP = '    '
        IF(IPRNT .GE. 3 .AND. NOSILENT)WRITE(LUOUT,8002)
        DO 1541 I=1,3
 1541   IF(DABS(IT(I,I)).LT.SYMTOL)ILINEAR=1
        IF(ILINEAR.EQ.1)THEN
          IF(IPRNT .GE. 3 .AND. NOSILENT)WRITE(LUOUT,8004)
C
C Linear molecules can be handled by rotation, reflection,
C and inversion, so transfer the logic to 9000
C
          GOTO 9000
        ENDIF
C
C IDENTIFY HIGHEST ORDER ROTATIONAL AXIS (CHECK THROUGH 24 )
C
        DO 10001 I = 2,24
          ZANG = 360.D0/DFLOAT(I)
          DO 10000 J = 3,3
            CALL DOSYOP('C',I,1,J,NATOMS,NEWQ,SCRATCH,IERR,0)
            CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMP,
     &                   SYMTOL)
            IF(ICOMP.EQ.0)THEN
              IF (XYZIN) CALL PUTREC(20, "JOBARC", "SYMEQUIV", 
     &                               NATOMS, NORD)
              IHIGH  = I
              IHIGHX = J
              IF(IPRNT.GE.4 .AND. NOSILENT)WRITE(LUOUT,3150)XYZ(J),I
 3150         FORMAT(T3,'@SYMMETRY-I, ',A1,' is a C[',I2,'] axis.')
            ENDIF
10000     CONTINUE
10001   continue
C
        IF (XYZIN) CALL PUTREC(20, "JOBARC", "HIGHSTAX", 1, IHIGH) 
C
        IF(IPRNT .GE. 4 .AND. NOSILENT)WRITE(LUOUT,800)IHIGH,
     &                                 XYZ(IHIGHX)
  800   FORMAT(T3,'@SYMMETRY-I, The highest order rotational ',
     &       'axis is C[',i2,'] about ',A1,'.')
        IF(IHIGH.EQ.0)THEN
          IF (IPRNT .GE. 4 .AND. NOSILENT)  WRITE(6,9301)
 9301     FORMAT(T3,'@SYMMETRY-W, An accidental degeneracy is present.',
     &         ' Analysis might be wrong.')
C
          CALL PERPOP2('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,SYMTOL,
     &         IFOUND)
          IF(IFOUND.NE.1)THEN
            CALL PERPOP2('P',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,SYMTOL,
     &           IFOUND)
          ENDIF
          IDEGEN=0
          GOTO 777
        ENDIF
C
C CHECK FOR S(2n) AXIS
C
        CALL DOSYOP ('S',2*IHIGH,1,IHIGHX,NATOMS,NEWQ,SCRATCH,IERR,
     &       IMODE)
        CALL COMPARE(SCRATCH,NEWQ,ATMASS,NORD,NATOMS,ICOMP,SYMTOL)
        SAXIS=(ICOMP.EQ.0)
        IF (SAXIS) CALL PUTREC(20, "JOBARC", "SYMEQUIV", NATOMS, NORD)
        IF(IPRNT.GT.10.AND.SAXIS .AND. NOSILENT)WRITE(6,9503)
 9503   FORMAT(T3,'@SYMMETRY-I, S(2n) axis found.')
C
C NOW CHECK FOR PERPENDICULAR C2 AXES.  THIS SEPARATES D AND C
C GROUPS.  THE LATTER ARE HANDLED FIRST.
C
        CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,SYMTOL,IFOUND)
        IF(IFOUND.EQ.1)THEN
          IF(IPRNT.GT.10 .AND. NOSILENT)WRITE(6,9501)
 9501     FORMAT(T3,'@SYMMETRY-I, Perpendicular C2 axis found.')
C
          FPGRP='DN  '
C
C CHECK FOR HORIZONTAL PLANE NOW
C
          CALL DOSYOP('P',1,1,3,NATOMS,NEWQ,SCRATCH,IERR,IMODE)
          CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMPX,SYMTOL)
C
          IF(ICOMPX.EQ.0)THEN
          IF (XYZIN) CALL PUTREC(20, "JOBARC", "SAMEPLNE", NATOMS,
     &                           NORD)
            FPGRP='DNh '
            IF(IPRNT.GT.10 .AND. NOSILENT)WRITE(6,9502)
 9502       FORMAT(T3,'@SYMMETRY-I, Horizontal plane found.')
          ENDIF
          IF(SAXIS)FPGRP='DNd '
          IF (SAXIS .AND. XYZIN) THEN
             CALL DOSYOP('C', 8, 1, 3, NATOMS, NEWQ, SCRATCH, IERR, 0)
             CALL DCOPY(3*NATOMS, NEWQ, 1, SCRATCH(3*NATOMS+1), 1)
             CALL REFLECT(SCRATCH,NEWQ,NATOMS,1)
             CALL COMPARE(NEWQ, SCRATCH, ATMASS, NORD, NATOMS, ICOMP,
     &                    SYMTOL)
             CALL DCOPY(3*NATOMS, SCRATCH(3*NATOMS+1), 1, NEWQ, 1)
             CALL PUTREC(20, "JOBARC", "SAMEPLNE", NATOMS,
     &                   NORD)
          ENDIF
        ENDIF
C
        IF(FPGRP.EQ.'    ')THEN
C
C THIS IS NOT A D GROUP, SO WE KNOW THAT IT IS EITHER CN, CNv, CNh
C OR MAYBE SN.  PROCEED WITH LOGIC.
C
C FIRST CHECK FOR HORIZONTAL PLANE - THIS ESTABLISHES THE POINT GROUP
C AS CNh
C
          CALL DOSYOP ('P',1,1,3,NATOMS,NEWQ,SCRATCH,IERR,IMODE)
          CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMP,SYMTOL)
          IF(ICOMP.EQ.0)THEN
            FPGRP='CNh '
          IF (XYZIN) CALL PUTREC(20, "JOBARC", "SAMEPLNE", NATOMS,
     &                           NORD)
            IF(IPRNT.GT.10 .AND. NOSILENT)WRITE(6,9502)
            GOTO 9000
          ENDIF
C
C CNv OR CN ?  THIS CAN BE DETERMINED BY PRESENCE OR ABSENCE OF
C PLANES CONTAINING THE SYMMETRY AXIS.  CHECK FOR THESE NOW.
C
          CALL PERPOP('P',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,SYMTOL,IFOUND)
          IF(IFOUND.EQ.1)FPGRP='CNv '
        ENDIF
        IF(FPGRP.EQ.'    ')THEN
          FPGRP='CN  '
          IF(SAXIS)THEN
            FPGRP='SN  '
            IHIGH=2*IHIGH
          ENDIF
        ENDIF
      ENDIF
C****************************************************************
C
C CODE FOR CUBIC POINT GROUPS.  BY FAR THE MOST COMPLICATED PART.
C
C****************************************************************
      IF(IDEGEN.EQ.2)THEN
        ALLDONE=.FALSE.

cSB the following is no longer necessary, it is left only so that
c   the cartesian coordinates are exactly identical to the old
c   version of joda
        itwoax =.false.
        tetrah =.false.
cSB

        IF(IPRNT .GE. 3 .AND. NOSILENT)WRITE(LUOUT,8003)
C
C CHECK FOR INVERSION SYMMETRY.
C
        DO 14002 I = 1,NATOMS*3
14002   SCRATCH(I) = -NEWQ(I)
        CALL COMPARE(SCRATCH,NEWQ,ATMASS,NORD,NATOMS,ISINV,SYMTOL)
C
C NOW PICK A REFERENCE ATOM IN THE MOLECULE **WHICH DOES NOT LIE AT
C THE ORIGIN** AND THEN LOOP OVER ALL OTHER ATOMS HAVING THE SAME
C ATOMIC NUMBER AND COMPARABLE DISTANCE FROM THE COM.  CHECK FOR
C AXES OF ORDER 3, 4 AND 5.
C
        IREF=-1
        IOFF=1
        DO 5000 IATOM=1,NATOMS
          X=SNRM2(3,NEWQ(IOFF),1)*ATMASS(IATOM)
          IF(X.GT.SYMTOL.AND.IREF.EQ.-1)THEN
            IREF=IATOM
            XREF=X
            ZREF=X/ATMASS(IATOM)
            IBOT=1+(IREF-1)*3
          ENDIF
          IOFF=IOFF+3
 5000   CONTINUE
C
C  HANDLE ATOMIC CALCULATION LOGIC
C
        IF(IREF.EQ.-1)THEN
          FPGRP='I h'
          GOTO 9000
        ENDIF
        DO 5001 IATOM=1,NATOMS
          IBOT2=1+(IATOM-1)*3
          X=SNRM2(3,NEWQ(IBOT2),1)*ATMASS(IATOM)
          IF(ABS(X-XREF).LT.SYMTOL)THEN
            IF(IPRNT.GT.100)WRITE(LUOUT,50000)IREF,IATOM
50000       FORMAT(T3,'@SYMMETRY-I, Checking atoms ',I3,' and ',I3,'.')
C
C FIRST ROTATE MOLECULE SO THAT THE INTERATOMIC DISTANCE VECTOR
C   IS PARALLEL TO THE Z-AXIS, WITH BISECTOR ALONG X-AXIS.
C   THIS MEANS THAT THE TWO ATOMS LIE IN THE XZ PLANE.
C   STRUCTURE NOW IN SCRATCH(1).  HERE ONE HAS TO ALLOW FOR THE
C   POSSIBILITY THAT ATOMS I AND J ARE 180 DEGREES APART; IF THIS
C   IS THE CASE, JUST GO TO BOTTOM OF LOOP SINCE THESE DO NOT
C   DEFINE ANY AXIS UNIQUELY.
C
            Write(6,*) "Enetring Vec"
            CALL VEC(NEWQ(IBOT),NEWQ(IBOT2),SCRATCH(1),0)
            Write(6,*) "out of Vec"
            dtmp = xdot(3,SCRATCH(1),1,SCRATCH(1),1)
            DIST = DSQRT(dtmp)
            CALL VADD(SCRATCH(1),NEWQ(IBOT),NEWQ(IBOT2),NX,ONE)
C
C DEAL WITH THE LINEAR PROBLEM RIGHT NOW.
C
            BILEN = xdot(3,SCRATCH(1),1,SCRATCH(1),1)
            IF(BILEN.LT.1.D-12)GOTO 5001
            CALL SIAZ(SCRATCH(1),RM,1)
            CALL ZERO(SCRATCH,NX*3)
C           CALL MATMULV(SCRATCH(NX+1),NEWQ,RM,NATOMS,3,3)
            CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,3,ZILCH,
     &                 SCRATCH(NX+1),3)
C
C NOW YOU HAVE BISECTOR ALONG X.  ROTATE ABOUT X TO BRING THE TWO
C  ATOMS INTO POSITION PARALLEL TO Z!
C
            dtmp = xdot(2,SCRATCH(NX+IBOT+1),1,SCRATCH(NX+IBOT+1),1)
            DIP  = DSQRT(dtmp)
            ARGU=SCRATCH(NX+IBOT+2)/DIP
            ANGLE2=-DACOSX(ARGU,1.D-10)/DTOR
            IF(SCRATCH(NX+IBOT+1).GT.0.D0)ANGLE2=-ANGLE2
            CALL ROTM(1,ANGLE2,1,RM)
C           CALL MATMULV(SCRATCH,SCRATCH(NX+1),RM,NATOMS,3,3)
            CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,SCRATCH(NX+1),3,
     &                 ZILCH,SCRATCH,3)
C
C NOW FIND NEW VECTOR WHICH BISECTS THE TWO ATOMS IN QUESTION -
C   IT HAD BEST BE X!
C
            CALL VADD(TATB,SCRATCH(IBOT),SCRATCH(IBOT2),
     &           3,ONE)
C
C 1. TEST IF THE TWO ATOMS ARE CONNECTED BY SYMMETRY AXES, LOOPING
C     OVER POSSIBILITIES (2,3,4 AND 5).
C
            DO 5002 IAXORD=5,2,-1
              ANGIAX=360.D0/DFLOAT(IAXORD)
              ANGMG=ANGMAG(ZREF,DIST,IAXORD,IERR)
              IF(IERR.EQ.0.AND..NOT.ALLDONE)THEN
                IF(IPRNT.GE.3 .AND. NOSILENT)WRITE(LUOUT,50001)ANGMG
50001           FORMAT(T3,' ANGMAG angle is ',f8.4)
                IF(IPRNT.GE.13 .AND. NOSILENT)WRITE(LUOUT,50002)IERR,IAXORD
50002           FORMAT(T3,' IERR is ',i2,' for ',i1)
                IF(IPRNT.GE.200 .AND. NOSILENT)THEN
                  WRITE(LUOUT,*)' IN ROTATIONAL LOOP, LOOKING FOR ',
     &                 'ORDER ',IAXORD
                  WRITE(LUOUT,50003)IREF,IATOM
50003             FORMAT(' PLAYING WITH ATOMS ',I2,' AND ',I2)
                  WRITE(LUOUT,*)' IBOT AND IBOT2 ARE ',IBOT,IBOT2
                  WRITE(LUOUT,*)' ORBIT DISTANCE IS ',ORDIS
                  WRITE(LUOUT,*)' INTERATOMIC DISTANCE IS ',DIST
                  WRITE(LUOUT,*)' MAGIC ANGLE IS ',ANGMG
                  WRITE(LUOUT,*)' MAGIC VECTOR IS ',(TATB(JJ),JJ=1,3)
                ENDIF
                CALL ROTM(3,ANGMG,1,RM)
                IF(IPRNT.GE.200 .AND. NOSILENT)WRITE(LUOUT,80)
     &            (SCRATCH(JZ),JZ=1,NX)
C               CALL MATMULV(SCRATCH(NX+4),TATB,RM,1,3,3)
                CALL XGEMM('T','N',3,1,3,ONE,RM,3,TATB,3,ZILCH,
     &                     SCRATCH(NX+4),3)
                CALL SIAZ(SCRATCH(NX+4),RM,3)
                CALL ZERO(SCRATCH(NX+1),NATOMS*3*2)
C               CALL MATMULV(SCRATCH(NX+1),SCRATCH,RM,NATOMS,3,3)
                CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,SCRATCH,3,ZILCH,
     &                     SCRATCH(NX+1),3)
                CALL ROTM(3,ANGIAX,1,RM)
C               CALL MATMULV(SCRATCH(2*NX+1),SCRATCH(NX+1),
C    &               RM,NATOMS,3,3)
                CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,SCRATCH(NX+1),
     &                     3,ZILCH,SCRATCH(2*NX+1),3)
                call compare (scratch(nx+1),scratch(2*nx+1),atmass,
     &               nord,natoms,iiax,symtol)
cOLD                WRITE(6,*) "The first one"
cOLD                WRITE(6,*) (NORD(I), I=1, NATOMS) 
                IF(XYZIN) CALL PUTREC(20, "JOBARC", "SYMEQUIV", NATOMS, 
     &                                NORD)
                IF(IIAX.EQ.0)THEN
cSB START
c The following assumes that we will run into an O or I rotation before
c running into at least 1 C2 and 1 C3 rotation.  An example where this
c is not the case is an Oh molecule defined as two superimposed tetrahedrons
c (one the inverse of the other)
cSSS                  IF(IAXORD.EQ.2.AND.TETRAH)THEN
cSSS                    ALLDONE=.TRUE.
cSSS                    FPGRP='T  '
cSSS                    IF(ISINV.EQ.0)FPGRP='T h'
cSSS                    CALL SCOPY (3*NATOMS,SCRATCH(NX+1),1,NEWQ,1)
cSSS                    CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,
cSSS     &                   SYMTOL,IFOUND)
cSSS                    IF(IFOUND.EQ.0)THEN
cSSS                      WRITE(6,50004)FPGRP
cSSS                      CALL ERREX
cSSS                    ENDIF
cSSS                    CALL DOSYOP('S',4,1,3,NATOMS,NEWQ,SCRATCH,IERR,0)
cSSS                    CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMP,
cSSS     &                   SYMTOL)
cSSS                    IF(ICOMP.EQ.0.AND.ISINV.NE.0)THEN
cSSS                      FPGRP='T d'
cSSSC
cSSSC COMMENT OUT TWO LINES BELOW TO GET Td TO RUN AS D2.
cSSSC
cSSS                      CALL DOSYOP('C',8,1,3,NATOMS,NEWQ,SCRATCH,IERR,0)
cSSS                      CALL SCOPY (NX,SCRATCH,1,NEWQ,1)
cSSS                    ENDIF
cSSS                  ELSEIF(IAXORD.EQ.2.AND..NOT.TETRAH)THEN
cSSS                    ITWOAX=.TRUE.
cSSS                    CALL SCOPY(3*NATOMS,SCRATCH(NX+1),1,QTMP,1)
cSSS                  ELSEIF(IAXORD.EQ.3)THEN
cSSS                    TETRAH=.TRUE.
cSSS                    IF(ITWOAX)THEN
cSSS                      ALLDONE=.TRUE.
cSSS                      FPGRP='T  '
cSSS                      IF(ISINV.EQ.0)FPGRP='T h'
cSSS                      CALL SCOPY (NX,QTMP,1,NEWQ,1)
cSSS                      CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,
cSSS     &                     SYMTOL,IFOUND)
cSSS                      IF(IFOUND.EQ.0)THEN
cSSS                        WRITE(6,50004)FPGRP
cSSS                        CALL ERREX
cSSS                      ENDIF
cSSS                      CALL DOSYOP('S',4,1,3,NATOMS,NEWQ,SCRATCH,IERR,0)
cSSS                      CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,
cSSS     &                     ICOMP,SYMTOL)
cSSS                      IF(ICOMP.EQ.0.AND.ISINV.NE.0)FPGRP='T d'
cSSS                    ENDIF
c We replace the above with the following which essentiall ignores all
c C2 and C3 rotations.  If, when we are done, we have not encountered a
c O or I rotation, we know it must be a T type molecule.
c
c All of the logic involving olddone, tetrah, and iaxord is optional.
c It is included only to make sure that the cartesian coordinates are
c exactly identical (as opposed to being off by a symmetry rotation).
                  if (iaxord.eq.2 .and. .not.olddone) then
                    call scopy(3*natoms,scratch(nx+1),1,qtmp,1)
                    if (tetrah) then
                      olddone=.true.
                    else
                      itwoax=.true.
                    endif
                  elseif (iaxord.eq.3 .and. .not.olddone) then
                    tetrah=.true.
                    if (itwoax) olddone=.true.
cSB END

                  ELSEIF(IAXORD.EQ.5)THEN
                    FPGRP='I  '
                    IF(ISINV.EQ.0)FPGRP='I h'
                    CALL SCOPY (3*NATOMS,SCRATCH(NX+1),1,NEWQ,1)
C
C IF WE HAVE FOUND A FIVE-FOLD AXIS, FIRST REORIENT MOLECULE SO
C THAT C2 AXES LIE ALONG X, Y AND Z
C
                    CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,
     &                   SYMTOL,IFOUND)
                    IF(IFOUND.EQ.0)THEN
                      WRITE(6,50004)FPGRP
                      CALL ERREX
                    ENDIF
                    CALL ROTM(2,90.D0,1,RM)
C                   CALL MATMULV(SCRATCH,NEWQ,RM,NATOMS,3,3)
                    CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,
     &                         3,ZILCH,SCRATCH,3)
                    CALL SCOPY (3*NATOMS,SCRATCH,1,NEWQ,1)
                    CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,
     &                   SYMTOL,IFOUND)
                    IF(IFOUND.EQ.0)THEN
                      WRITE(6,50004)FPGRP
                      CALL ERREX
                    ENDIF
                    CALL ROTM(2,90.D0,1,RM)
C                   CALL MATMULV(SCRATCH,NEWQ,RM,NATOMS,3,3)
                    CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,
     &                         3,ZILCH,SCRATCH,3)
                    CALL SCOPY (3*NATOMS,SCRATCH,1,NEWQ,1)
C
C NOW MAKE SURE THAT C5 ORIENTATION IS CORRECT
C
                    SQ5=ONE/DSQRT(5.D0)
                    ARGX=DSQRT(0.5D0*(ONE-SQ5))
                    ANGL=DACOS(ARGX)
                    CALL ROTM(1,ANGL,0,RM)
C                   CALL MATMULV(SCRATCH,NEWQ,RM,NATOMS,3,3)
                    CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,
     &                         3,ZILCH,SCRATCH,3)
                    CALL ROTM(3,72.D0,1,RM)
C                   CALL MATMULV(SCRATCH(NX+1),SCRATCH,RM,NATOMS,3,3)
                    CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,
     &                         3,ZILCH,SCRATCH,3)
                    call compare(scratch(nx+1),scratch,atmass,
     &                   nord,natoms,icomp,symtol)
                    IF(ICOMP.NE.0)THEN
                      CALL ROTM(3,90.D0,1,RM)
C                     CALL MATMULV(SCRATCH,NEWQ,RM,NATOMS,3,3)
                      CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,
     &                         3,ZILCH,SCRATCH,3)
                      CALL SCOPY(NX,SCRATCH,1,NEWQ,1)
                    ENDIF
                    ALLDONE=.TRUE.
                  ELSEIF(IAXORD.EQ.4)THEN
C
C IF WE HAVE FOUND A FOUR-FOLD AXIS, THEN WE ARE DONE.  THE MOLECULE
C BELONGS TO EITHER O OR Oh AND REORIENTATION IS COMPLETELY
C STRAIGHTFORWARD.
C
cSSS                    FPGRP='O  '
cSSS                    IF(ISINV.EQ.0)FPGRP='O h'
                    CALL SCOPY (3*NATOMS,SCRATCH(NX+1),1,NEWQ,1)
                    CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,
     &                   SYMTOL,IFOUND)
                    IF(IFOUND.EQ.0)THEN
                      WRITE(6,50004)FPGRP
50004                 FORMAT(T3,'@SYMMETRY-F, Reorientation failure ',
     &                     'for point group ',A,'.')
                      CALL ERREX
                    ENDIF

cSB START
c At this point, we have either an O, Oh, or Th molecule.  In either
c case, the molecule is oriented in one of two ways (visualized with a
c cube).
c   A.  4 vertices in the XZ plane, 4 in the YZ plane (X and Y axis
c       point to edges of a cube, Z axis points to a face)
c   B.  45 degree rotation from this (all axis point to faces)
c In the B orientation, there is no way (using an X, Y, Z rotation or
c an XY, XZ, YZ reflection) to distinguish between Oh and Th.  In The
c A orientation, an XY, XZ, YZ reflection fails for Th.  Also, in the
c B orientation (but NOT the A orientation), there is a C4 rotation
c along the X axis.
c
c If the molecule is O or Oh, we want to rotate it to the B orientation
c in the end.  If it is a Th molecule, we need to exit without having
c modified the orientation.  In this case, the above SCOPY and PERPOP
c may cause a problem (but it may not).

c Look for the C4(x) rotation (icomp=0 if B orientation))
                    CALL DOSYOP('C',4,1,1,NATOMS,NEWQ,SCRATCH,IERR,0)
                    CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMP,
     &                   SYMTOL)

c The B orientation.
                    if (icomp.eq.0) then

c      In the B orientation, an inversion center means either Oh or Th.
c      Rotate to the A orientation and check for a any reflection plane.
                      if (isinv.eq.0) then
                        call dosyop('C',8,1,3,natoms,newq,scratch,
     &                       ierr,0)
                        call dosyop('P',1,1,3,natoms,scratch,
     &                       scratch(nx+1),ierr,0)
                        call compare(scratch,scratch(nx+1),atmass,
     &                       nord,natoms,icomp,symtol)
cSSS                        WRITE(6,*) "The First one"
cSSS                        WRITE(6,*) (NORD(II), II =1, NATOMS) 
cSSS                        CALL PUTREC(20, "JOBARC", "SYMEQUIV", NATOMS, 
cSSS     &                              NORD)
                        if (icomp.eq.0) then
                          fpgrp='O h'
                          alldone=.true.
                        endif

c      In the B orientation, no inversion center means O.
                      else
                        fpgrp='O  '
                        alldone=.true.
                      endif

c The A orientation.
                    else

c      In the A orientation, an inversion center means either Oh or Th.
c      We need to check for a reflection plane.  If found, rotate to
c      B orientation.
                      if (isinv.eq.0) then
                        call dosyop('P',1,1,3,natoms,newq,scratch(nx+1),
     &                       ierr,0)
                        call compare(newq,scratch(nx+1),atmass,nord,
     &                       natoms,icomp,symtol)
cSSS                        WRITE(6,*) "The Second One"
cSSS                        WRITE(6,*) (NORD(II), II =1, NATOMS) 
cSSS                        CALL PUTREC(20, "JOBARC", "SYMEQUIV", NATOMS, 
cSSS     &                              NORD)
                        if (icomp.eq.0) then
                          call dosyop('C',8,1,3,natoms,newq,scratch,
     &                         ierr,0)
                          call scopy (nx,scratch,1,newq,1)
                          fpgrp='O h'
                          alldone=.true.
                        endif

c      In the A orientation, no inversion center means O.  Rotate it
c      to the B orientation.
                      else
                        call dosyop('C',8,1,3,natoms,newq,scratch,
     &                       ierr,0)
                        call scopy (nx,scratch,1,newq,1)
                        fpgrp='O  '
                        alldone=.true.
                      endif
                    endif

c The old logic was wrong
cSSS              CALL DOSYOP('C',4,1,1,NATOMS,NEWQ,SCRATCH,IERR,0)
cSSS              CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMP,
cSSS     &                     SYMTOL)
cSSS              IF(ICOMP.NE.0)THEN
cSSS               CALL DOSYOP('C',8,1,3,NATOMS,NEWQ,SCRATCH,IERR,0)
cSSS               CALL SCOPY (NX,SCRATCH,1,NEWQ,1)
cSSS               ALLDONE=.TRUE.
cSSS              ENDIF
cSSSCJDW 12/22/94
cSSSC     This lets the Cr(CO)6 job run. CrC6 ends up with ICOMP=6 and so
cSSSC     ALLDONE is set to true. The C coordinates are different in Cr(CO)6
cSSSC     and CrC6. In the former all C atoms lie along Cartesian axes, while
cSSSC     in the latter four of the C atoms bisect axes. This is a somewhat
cSSSC     empirical fix, and a rigorous explanation would be appreciated.
cSSS              ALLDONE = .TRUE.
cSB END

                  ENDIF
                ENDIF
              ENDIF
 5002       CONTINUE
          ENDIF
 5001   CONTINUE
        IF(.NOT.ALLDONE)THEN

cSB START
c It used to be that if we did not get the ALLDONE flag, there was
c an error.  Now it just means that we are in a T-type group.

cSSS          WRITE(6,50005)
cSSS50005     FORMAT(T3,'@SYMMETRY-F, Cubic group not determined.')
cSSS          CALL ERREX

          FPGRP='T  '
          IF(ISINV.EQ.0)FPGRP='T h'
          CALL SCOPY (NX,QTMP,1,NEWQ,1)
          CALL PERPOP('C',NEWQ,SCRATCH,ATMASS,NATOMS,NORD,
     &         SYMTOL,IFOUND)
          IF(IFOUND.EQ.0)THEN
            WRITE(6,50004)FPGRP
            CALL ERREX
          ENDIF
          CALL DOSYOP('S',4,1,3,NATOMS,NEWQ,SCRATCH,IERR,0)
          CALL COMPARE(NEWQ,SCRATCH,ATMASS,NORD,NATOMS,ICOMP,
     &         SYMTOL)
          IF(ICOMP.EQ.0.AND.ISINV.NE.0)THEN
            FPGRP='T d'
            IF (XYZIN) CALL PUTREC(20, "JOBARC", "SYMEQUIV", NATOMS, 
     &                             NORD)
C
C COMMENT OUT TWO LINES BELOW TO GET Td TO RUN AS D2.
C
            CALL DOSYOP('C',8,1,3,NATOMS,NEWQ,SCRATCH,IERR,0)
            CALL SCOPY (NX,SCRATCH,1,NEWQ,1)
          ENDIF
cSB END

        ENDIF
      ENDIF
C
C CUBIC POINT GROUP NOW DETERMINED.  ON WITH THE SHOW.
C
 80   FORMAT((4X,3(2X,F16.12)))
 8001 FORMAT(T3,'@SYMMETRY-I, The molecule belongs to an ',
     &     'Abelian group.')
 8002 FORMAT(T3,'@SYMMETRY-I, The molecule belongs to a point ',
     &     'group with doubly',
     &     ' degenerate representations.')
 8004 FORMAT(T3,'@SYMMETRY-I, The molecule is linear.')
 8003 FORMAT(T3,'@SYMMETRY-I, The molecule belongs to a cubic ',
     &     'point group.')
C
C This is the principal axis or computational orientation of the molecule
C
      IF(OPTRES) THEN
        CALL GETREC(20,'JOBARC','COORD   ',NX*IINTFP,NEWQ)
      ENDIF
C
C This is the entry point for Abelain subgrop. All these 'GO TO 9000"
C could have been easily avoided.
 9000 CONTINUE
      IF(IPRNT.GE.0 .AND. NOSILENT) THEN
        WRITE(LUOUT,8202)
 8202   FORMAT(T3,' Principal axis orientation for molecule:')
        WRITE(LUOUT,80)(NEWQ(I),I=1,NX)
      ENDIF
C
C     CHECK SYMMETRY OPERATIONS BELONGING TO ABELIAN GROUPS
C
C  THE SYMSTR INFORMATION IS USED ONLY TO MAKE VMOL DECKS.  COMMENTED
C   OUT FOR NOW SINCE SYMEQV AND GRPOPS ASSUME "FUDGED" ORIENTATIONS.
C
      ANG = 180.D0
      IREF=0
      IOPS=1
      DO 873 I=1,6
        SYMSTR(I)='   '
  873 CONTINUE
      DO 31 I = 3,1,-1
        CALL REFLECT(NEWQ,SCRATCH,NATOMS,I)
        call compare(newq,scratch,atmass,
     &       nord,natoms,icomp,symtol)
        IF(ICOMP.EQ.0)THEN
C               SYMSTR(IOPS)(2:2)=XYZ(I)
          IF (XYZIN) THEN
              CALl GETREC(0, "JOBARC", "SAMEPLNE", LENGTH, IJUNK)
              IF (LENGTH .LT. 0) CALL PUTREC(20, "JOBARC", "SAMEPLNE",
     &                                   NATOMS, NORD)
          ENDIF
          IOPS=IOPS+1
          IF(IPRNT .GE. 3 .AND. NOSILENT)WRITE(LUOUT,77)I
   77     FORMAT(T3,' Reflection in plane ',i2,' is a valid ',
     $         'symmetry operation.')
          IREF = IREF + 2**I/2
        ENDIF
        CALL ROTM(I,ANG,1,RM)
        IF(IPRNT .GE. 5 .AND. NOSILENT)WRITE(LUOUT,80)
     $       ((RM(IX,JX),JX = 1,3),IX = 1,3)
C       CALL MATMULV(SCRATCH,NEWQ,RM,NATOMS,3,3)
        CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,3,ZILCH,SCRATCH,3)
        call compare(newq,scratch,atmass,
     &       nord,natoms,icomp,symtol)
        IF(ICOMP.EQ.0)THEN
C              SYMSTR(IOPS)(2:3)=XYZP(I)
          IOPS=IOPS+1
          IF(IPRNT .GE. 3 .AND. NOSILENT)WRITE(LUOUT,78)I
   78     FORMAT(T3,' Rotation about ',i2,' is a valid symmetry ',
     $         'operation ')
          IROT = IROT + 2**I/2
        endif
   31 continue
      DO 102 I = 1,NATOMS*3
  102 SCRATCH(I) = -NEWQ(I)
      call compare(newq,scratch,atmass,
     &     nord,natoms,icomp,symtol)
      IF(ICOMP.EQ.0)THEN
C            SYMSTR(IOPS)='XYZ'
        IOPS=IOPS+1
        IF(IPRNT .GE. 3 .AND. NOSILENT)WRITE(LUOUT,81)
   81   FORMAT(T3,' The molecule possesses an inversion center. ')
        IF (XYZIN) CALL PUTREC(20, "JOBARC", "SYMEQUIV",
     &                              NATOMS, NORD)
        IF(ILINEAR.EQ.1)FPGRP = 'DXh '
        IINV=1
      ELSE
        IF(ILINEAR.EQ.1)FPGRP = 'CXv '
cOLD        IF (XYZIN) CALL PUTREC(20, "JOBARC", "SYMEQUIV",
cOLD     &                              NATOMS, NORD)    
        CALL GETREC(0, "JOBARC", "SYMEQUIV", LENGTH, IJUNK)
        IF (XYZIN .AND. LENGTH .LT. 0) CALL PUTREC(20, "JOBARC", 
     &                                 "SYMEQUIV", NATOMS, NORD)    
      ENDIF
C
C     DETERMINE LARGEST ABELIAN SUBGROUP OF MOLECULE
C
      IF(IROT.EQ.0.AND.IREF.EQ.0.AND.IINV.EQ.0)PGRP = 'C1  '
      IF(IROT.EQ.0.AND.IREF.EQ.0.AND.IINV.EQ.1)PGRP = 'C i '
      IF(IROT.EQ.0.AND.IREF.NE.0.AND.IINV.EQ.0)PGRP = 'C s '
      IF(IROT.NE.0.AND.IREF.EQ.0.AND.IINV.EQ.0)PGRP = 'C2  '
      IF(IROT.NE.0.AND.IREF.NE.0.AND.IINV.EQ.0)PGRP = 'C2v '
      IF(IROT.NE.0.AND.IREF.NE.0.AND.IINV.EQ.1)PGRP = 'C2h '
      IF(IROT.EQ.7.AND.IREF.EQ.0.AND.IINV.EQ.0)PGRP = 'D2  '
c         IF(IROT.EQ.7.AND.IREF.EQ.0.AND.IINV.EQ.0)PGRP = 'C2  '
      IF(IROT.EQ.7.AND.IREF.EQ.7.AND.IINV.EQ.1)PGRP = 'D2h '
      IF(IPRNT .GE. 4 .AND. NOSILENT)WRITE(LUOUT,27)IREF,IROT,IINV
   27 FORMAT(T3,'Symmetry bits: ',3(1x,i3))
CJDW 9/16/96. Comment out 3 lines below, as they will not be needed if
C             JFS modifications work (routine SETD2XYZ). Above C2 line
C             is how JFS used to handle D2, i.e. switch to C2 always
C             was done.
CJDW 4/ 1/97. Putting these three lines back in. D2 is causing too much
C             trouble in finite difference calculations at the moment.
c
CNO 5/11/94 Remove D2 from findif calculations and also from 
C Resonance Raman Calculations.
C This restriction should no longer be needed
C (see my comments in vmlgen in vmol2ja and vib1 and geopt in joda)
C Ajith Perera, 01/2006.
CSSS
CSSS         if(pgrp.eq.'D2  ') then
CSSS           if(iflags(54).eq.3.or.iflags(54).eq.2.or.
CSSS     &        iflags2(3) .ne. 0)    pgrp = 'C2  '
CSSS         endif
c
C IFLAGS(85) is non-zero when the subgroup key-word is turned on
C
      IF(IFLAGS(85).NE.0)THEN
        IF(IPRNT .GE. 4 .AND. NOSILENT) WRITE(6,1051)
 1051   FORMAT(T3,'@SYMMETRY-I, Reference coordinates used for ',
     &       'subgroup specification.')
        CALL DUMPCORD(NATOMS,NEWQ,IATNUM)
        IF(FPGRP.EQ.'    ')FPGRP=PGRP
        IF(ISYM .EQ. 1)    PGRP='C1  '
#ifdef _DEBUG_LVL0
        Print*, "PGRP, FPGRP:", FPGRP, PGRP
#endif
        CALL SUBGROUP(IFLAGS(85),PGRP,FPGRP,IROTATE)
C 
        IF(IROTATE.EQ.1)THEN
          CALL ROTM(3,45.0D0,1,RM)
C         CALL MATMULV(SCRATCH,NEWQ,RM,NATOMS,3,3)
          CALL XGEMM('T','N',3,NATOMS,3,ONE,RM,3,NEWQ,3,ZILCH,SCRATCH,3)
          CALL SCOPY(3*NATOMS,SCRATCH,1,NEWQ,1)
        ENDIF
        IF(IFLAGS(86)+1.NE.1)THEN
          CHRTMP=DOSTR(1)
          DOSTR(1)=DOSTR(IFLAGS(86)+1)
          DOSTR(IFLAGS(86)+1)=CHRTMP
        ENDIF
C
C In order to do geo. optimization in a subgroup, Andrew Taube, 06/20
#ifdef _NOSKIP
C As it is this does not work when the point group is not Abelian
C (not even a single point calc). This need to evalauted once
C again, Ajith Perera, 12/2008.
C
            ORDNEW=IORGRP(PGRP)                
            ORDOLD=IORGRP(FPGRP)              
            IF (ORDNEW.LE.ORDOLD) FPGRP=PGRP 
#endif 
      ENDIF
      CALL ZERO(ORIENT,9)
C
C     ROTATE TO DEFAULT SYMMETRY FRAME IF NEEDED - COMPLETELY DONE BY
C     BRUTE FORCE.  NO CUTE ALGORITHM USED HERE.
C
C Reorientation of the molecule depending on the point group.
      BPGRP = PGRP
      CALL ZERO(SCRATCH,NATOMS*3)
      IF(PGRP.EQ.'C1  '.OR.PGRP.EQ.'C i '.OR.
     &     PGRP.EQ.'D2  '.OR.PGRP.EQ.'D2h ')THEN
c            IF(PGRP(1:2).NE.'D2')PGRP = 'C1  '
        CALL VADD(Q,NEWQ,SCRATCH(1),NATOMS*3,ONE)
        GOTO 75
      ENDIF

C
C     C2V
C
      IF(PGRP.EQ.'C2v'.OR.PGRP.EQ.'C2h'.OR.PGRP.EQ.'C2 ')THEN
C
C     IF X IS ROTATION AXIS - SWITCH TO Z - AND PUT LARGEST MOMENT OF
C     INERTIA AROUND X - EIGENVECTORS RETURNED FROM EIG ARE SORTED
C     HIGHEST TO LOWEST FOR D2H, WE TAKE STANDARD ORIENTATION SUCH
C     THAT IX>IY>IZ
C
        CALL SETXYZ(Q,NEWQ,ORIENT,DOSTR(1),IROT,IOK,NATOMS)
        IF(IOK.EQ.0.AND.IFLAGS(86).EQ.0)THEN
          CALL SETXYZ(Q,NEWQ,ORIENT,DOSTR(2),IROT,IOK,NATOMS)
          IF(IOK.EQ.0.AND.IFLAGS(86).EQ.0)THEN
            CALL SETXYZ(Q,NEWQ,ORIENT,DOSTR(3),IROT,IOK,NATOMS)
          ENDIF
        ENDIF
C
      ELSE
C
        CALL SETXYZ(Q,NEWQ,ORIENT,DOSTR(1),IREF,IOK,NATOMS)
        IF(IOK.EQ.0.AND.IFLAGS(86).EQ.0)THEN
          CALL SETXYZ(Q,NEWQ,ORIENT,DOSTR(2),IREF,IOK,NATOMS)
          IF(IOK.EQ.0.AND.IFLAGS(86).EQ.0)THEN
            CALL SETXYZ(Q,NEWQ,ORIENT,DOSTR(3),IREF,IOK,NATOMS)
          ENDIF
        ENDIF
C
      ENDIF
c            IF(Mod(IRot,2).EQ.1)THEN
c               DO 1001 J = 1,NATOMS
c                  Q(3*J) = NEWQ(3*J-2)
c                  Q(3*J-2) = NEWQ(3*J-1)
c 1001             Q(3*J-1) = NEWQ(3*J)
c               ORIENT(1,2)=ONE
c               ORIENT(2,3)=ONE
c               ORIENT(3,1)=ONE
c            ELSEIF(Mod(IRot/2,2).EQ.1)THEN
c               DO 1002 J = 1,NATOMS
c                  Q(3*J) = NEWQ(3*J-1)
c                  Q(3*J-1) = NEWQ(3*J-2)
c 1002             Q(3*J-2) = NEWQ(3*J)
c               ORIENT(3,2)=ONE
c               ORIENT(2,1)=ONE
c               ORIENT(1,3)=ONE
c            ELSEIF(Mod(IRot/4,2).EQ.1)THEN
c               CALL VADD(Q,NEWQ,SCRATCH(1),NATOMS*3,ONE)
c               ORIENT(1,1)=ONE
c               ORIENT(2,2)=ONE
c               ORIENT(3,3)=ONE
c            ENDIF
c         ELSE
c            IF(Mod(IRef,2).EQ.1)THEN
c               DO 2001 J = 1,NATOMS
c                  Q(3*J) = NEWQ(3*J-2)
c                  Q(3*J-2) = NEWQ(3*J-1)
c 2001             Q(3*J-1) = NEWQ(3*J)
c               ORIENT(3,1)=ONE
c               ORIENT(1,2)=ONE
c               ORIENT(2,3)=ONE
c            ELSEIF(Mod(IRef/2,2).EQ.1)THEN
c               DO 2002 J = 1,NATOMS
c                  Q(3*J) = NEWQ(3*J-1)
c                  Q(3*J-1) = NEWQ(3*J-2)
c 2002             Q(3*J-2) = NEWQ(3*J)
c               ORIENT(3,2)=ONE
c               ORIENT(2,1)=ONE
c               ORIENT(1,3)=ONE
c            ELSEIF(MOD(IRef/4,2).EQ.1)THEN
c               CALL VADD(Q,NEWQ,SCRATCH(1),NX,ONE)
c               ORIENT(1,1)=ONE
c               ORIENT(2,2)=ONE
c               ORIENT(3,3)=ONE
c            ENDIF
c         ENDIF
C
C NOW RESET ORIENT TO THE IDENTITY IF THE GROUP IS ABELIAN.
C
C This is important, for abelian groups, the ORIENT is the unit matrix
      IF(IDEGEN.EQ.0)THEN
        CALL ZERO(ORIENT,9)
        ORIENT(1,1)=ONE
        ORIENT(2,2)=ONE
        ORIENT(3,3)=ONE
      ENDIF
C
C FILL SYMSTR STRING AND WRITE OUT IF THIS IS A VMOL-BASED CALCULATION.
C
C
C     IF THIS IS A VMOL-DRIVEN CALCULATION, WRITE SYMMETRY INFORMATION
C      TO VMLSYM. ALSO FOR ARGOS INPUT
C
CJDW 9/20/96. Also for SEWARD.
CADY 5/06/04. Also for GAMESS.
C
   75 IF(INTTYP.EQ.1.OR.INTTYP.EQ.2.OR.INTTYP.EQ.0.OR.INTTYP.EQ.5
     &     .OR.INTTYP.EQ.4)THEN
        IF(PGRP.EQ.'C2v')THEN
          SYMSTR(1)(2:2)='X'
          SYMSTR(2)(2:2)='Y'
          IOPS=3
        ELSEIF(PGRP.EQ.'D2h')THEN
          SYMSTR(1)(2:2)='X'
          SYMSTR(2)(2:2)='Y'
          SYMSTR(3)(3:3)='Z'
          IOPS=4
        ELSEIF(PGRP.EQ.'C2h')THEN
          SYMSTR(1)(2:2)='Z'
          SYMSTR(2)(2:3)='XY'
          IOPS=3
        ELSEIF(PGRP.EQ.'C s')THEN
          SYMSTR(1)(2:2)='Z'
          IOPS=2
        ELSEIF(PGRP.EQ.'C i')THEN
          SYMSTR(1)     ='XYZ'
          IOPS=2
        ELSEIF(PGRP.EQ.'D2 ')THEN
CJDW 9/16/96. Modification from JFS.
          CALL SETD2XYZ(NATOMS,Q,ATMASS,SYMSTR(1),SYMSTR(2),IERROR)
          IOPS=3
          IF(IERROR.EQ.1)THEN
            PGRP='C2 '
            SYMSTR(1)(2:3)='XY'
            IOPS=2
          ENDIF
c           SYMSTR(1)(2:3)='XY'
c           SYMSTR(2)(2:3)='XZ'
c           IOPS=3
        ELSEIF(PGRP.EQ.'C2 ')THEN
          SYMSTR(1)(2:3)='XY'
          IOPS=2
        ELSEIF(PGRP.EQ.'C1 ')THEN
          IOPS=1
        ENDIF
        INQUIRE(FILE='VMLSYM',EXIST=YESNO,NUMBER=JUNK)
        IF(YESNO)THEN
          OPEN(UNIT=78,FILE='VMLSYM',STATUS='OLD',FORM='UNFORMATTED')
          CLOSE(UNIT=78,STATUS='DELETE')
        ENDIF
        OPEN(UNIT=78,FILE='VMLSYM',STATUS='NEW',FORM='UNFORMATTED')
        WRITE(78)MIN(3,IOPS-1),(SYMSTR(I),I=1,3)
        CLOSE(UNIT=78,STATUS='KEEP')
      ENDIF
C
C     DO NUMERIC-ASCII CONVERSION OF IHIGH.
C
      JnkStr=some_string_func(FPGRP,IHIGH)
      FPGrp = JnkStr
      IF(FPGRP.EQ.'    ')FPGRP=BPGRP
C
C FIGURE OUT WHAT THE COMPUTATIONAL POINT GROUP IS FROM OPTCTL PARAMETER
C  ISYM.  IF IT IS SET TO 0, THEN JUST USE PGRP AS IS.  IF =1, THEN USE
C  C1.  IF =3, USE FULL POINT GROUP{SYMM=NONE(0),OFF(1),ON(2),FULL(3)}.
C
      IF(ISYM.EQ.1)PGRP='C1  '
      IF(ISYM.EQ.3)PGRP=FPGRP
C The ncycle=0 refers to the first joda run during geo. optimizations
      IF ( ncycle .EQ. 0 ) THEN
        IF(NOSILENT)WRITE(LUOUT,788)
        IF(IDEGEN.GT.0)THEN
          IF(NOSILENT)WRITE(LUOUT,1881)FPGRP
        ENDIF
        IF(IDEGEN.EQ.0)THEN
          IF(NOSILENT) 
     &       WRITE(LUOUT,1881)some_string_func(BPGRP,IHigh)
          FPGRP=BPGRP
        ENDIF
 1881   FORMAT(T3,' The full molecular point group is ',a,'.')
        IF(NOSILENT) WRITE(LUOUT,177)BPGRP
        IF(NOSILENT) WRITE(LUOUT,712)PGRP
        IF(NOSILENT) WRITE(LUOUT,788)
  788   FORMAT(80('*'))
  712   FORMAT(T3,' The computational point group is ',A,'.')
  177   FORMAT(T3,' The largest Abelian subgroup of the full ',
     $       'molecular point group is ',a,'.')
      ELSE
C
C  MAKE SURE THAT SYMMETRY HAS NOT BEEN REDUCED FROM PREVIOUS STEP.  IF
C    IT HAS, AND THIS IS NOT A TS SEARCH, THEN ABORT.
C
        IF(FPGRP.NE.TMPGRP)THEN
          ORDNEW=IORGRP(FPGRP)
          ORDOLD=IORGRP(TMPGRP)
          WRITE(LUOUT,1883)FPGRP
 1883     FORMAT(T3,'@SYMMETRY-I, Point group has changed to ',A,'.')
C
C Originally test for TS searches were done by INR .NE. 2. That
C was dangerous. Now the TSSEARCH is  a logical variable that 
C is set to TRUE for TS searches (see above, INR=4, 5, and 6). 
C Ajith Perera 08/2001. 
C 
C A bug fix, we must allow only the TS searches to proceed when
C there is a symmetry lowering. It is amazing that it took us
C 15 years to get this right! Ajith Perera 05/2005
C
        IF (ORDNEW.LT.ORDOLD) THEN
          IF (.NOT.TSSEARCH) THEN
            WRITE(LUOUT,1884)
 1884       FORMAT(T3,'@SYMMETRY-F, Descent in symmetry detected.')
            CALL ERREX
          ENDIF
        ELSE
            WRITE(LUOUT,1885)
 1885       FORMAT(T3,'@SYMMETRY-F, Ascent in symmetry detected.')
            CALL ERREX
        ENDIF
        ENDIF
      ENDIF
C
C CHECK TO SEE IF ORIENTATION MATRIX IS EMPTY.  IF IT IS, THEN SET IT EQ
C  TO THE IDENTITY MATRIX.
C
      ZTOTAL=0.D0
      DO 1032 I=1,3
        DO 1033 J=1,3
          ZTOTAL=ZTOTAL+DABS(ORIENT(I,J))
 1033   CONTINUE
 1032 CONTINUE
      IF(ZTOTAL.LT.1.D-8)THEN
        DO 1034 I=1,3
          ORIENT(I,I)=ONE
 1034   CONTINUE
      ENDIF
C
C DEFINE ORIENT TO PUT I AND Ih IN THEIR CANONICAL ORIENTATIONS (C5s
C  ALONG (0,0,1) AND (0,2/SQRT(5),1/SQRT(5)).
C
      IF(FPGRP.EQ.'I h '.OR.FPGRP.EQ.'I   ')THEN
        CALL ZERO(SCRATCH,3*NX)
        SQ5=ONE/DSQRT(5.D0)
        ARGX=DSQRT(0.5D0*(ONE-SQ5))
        ANGL=DACOS(ARGX)
        ANGL2=DACOS(SQ5)
        CALL ROTM(1,ANGL,0,ORIENT)
      ENDIF
C
C DUMP SOME NECESSARIES TO JOBARC
C
      IF(FPGRP(2:2).EQ.'X')ILINEAR=1
#ifdef _DEBUG_LVL0
      Print*, "@-SYM_AUTO The Orientation matrices: ORIEN2 and ORIENT"
      Write(6,*)
      CALL OUTPUT(ORIEN2, 1, 3, 1, 3, 3, 3, 0)
      Write(6,*)
      CALL OUTPUT(ORIENT, 1, 3, 1, 3, 3, 3, 0)
      Write(6,*)
      Write(6,*) "@-SYM_AUTO The variables in /COORD/ common block"
      Write(6, "(3F10.5)"), (Q(I), I=1, 3*NATOMS)
      Write(6,*)
      Write(6,*) "The NEWQ array "
      Write(6, "(F10.5)"), (NEWQ(I), I=1, 3*NATOMS)
      Write(6,*)

#endif
      CALL XGEMM('N','N',3,3,3,ONE,ORIEN2,3,ORIENT,3,ZILCH,
     &     SCRATCH,3)
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "@-SYM_AUTO ORIENT2=ORIEN2xORIENT" 
      CALL OUTPUT(SCRATCH, 1, 3, 1, 3, 3, 3, 0)
#endif

      CALL PUTREC(20,'JOBARC','LINEAR  ',IONE,ILINEAR)
      RETURN
      END

         SUBROUTINE  A2B__FNC_SIZE
     +
     +                    ( UACES,NSHELL,
     +                      MAXCNTR,MAXPRIM,
     +
     +                                 LANGSH,
     +                                 NCNTSH,NPRMSH )
     +
     +
C-----------------------------------------------------------------------
C  OPERATION   : A2B__FNC_SIZE
C  MODULE      : ACESII BASIS CONVERTER
C  MODULE-ID   : A2B
C  SUBROUTINES : none
C  DESCRIPTION : This routine will determine the number of contracted
C                functions and primitive functions that there are.
C
C                Input:
C
C                     UACES   = The unit number for the ZMAT.BAS
C                     NSHELL  = The number of shells in the ZMAT.BAS
C                     MAXCNTR = The maximum number of contracted
C                               functions in the basis set
C                     MAXPRIM = The maximum number of primitive 
C                               functions in the basis set
C
C                Output:
C
C                     LANGSH  = An array of angular momentum numbers
C                     NCNTSH  = An array of the number of contracted
C                               functions for a given angular momenta
C                     NPRMSH  = An array of the number of primitive
C                               functions for a given angular momenta
C
C
C  AUTHOR      : Thomas Watson Jr.
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    JUNK
         INTEGER    I
         INTEGER    UACES
         INTEGER    NSHELL,MAXCNTR,MAXPRIM

         INTEGER    LANGSH (1:NSHELL)
         INTEGER    NCNTSH (1:NSHELL)
         INTEGER    NPRMSH (1:NSHELL)
C
C
C------------------------------------------------------------------------
C
C
C             ...Read the size of functions in the ZMAT.BAS
C
C        
         READ (UACES,'(14I5)') (LANGSH (I), I = 1, NSHELL)
         READ (UACES,'(14I5)') (NCNTSH (I), I = 1, NSHELL)
         READ (UACES,'(14I5)') (NPRMSH (I), I = 1, NSHELL)
         READ (UACES,'(A)') JUNK

         MAXCNTR = MAXVAL (NCNTSH)
         MAXPRIM = MAXVAL (NPRMSH)
C
C
C             ...ready!
C
C
         RETURN
         END

C---------------------------------------------------------------------
C
      SubroutinE a2read_jarc(FlgACESGeom,FlgACESElec,FlgACESGrad,
     &                       FlgACESHess,FlgACESForc,Natom,Nreal,
     &                       Imap, Coord, Etot, AtmMass, AtmLabel, 
     &                       Vgrad, Grad, Vhess, Hess, Vomega, 
     &                       Omega, IUhf,Nirrep, Nvibs, B2ang, 
     &                       Au2Invcm, Wrt_extrnl)
C
      Implicit double precision (a-h,o-z)
C
#include "machsp.com"
#include "mxatms.par"
C
      Logical FlgACESGeom,FlgACESElec,FlgACESGrad,FlgACESHess,
     &        FlgACESForc, Wrt_extrnl
      Character*5  AtmLabel(Mxatms)
      character*10 Label
      Character*4  PTGRP
C
      Dimension NOcc(16),AtmMass(Natom),Coord(3,Natom),
     &          VGrad(3,Natom),Grad(3,Nreal),Imap(Nreal),
     &          Hess(3*Nreal,3*Nreal),Freq(3*Nreal),
     &          Vhess(9*Natom*Natom),VOmega(3*Natom),
     &          Omega(Nvibs)

C
      IUnitO=30
C
C---------------------------------------------------------------------
C
C     Read number of atoms
C---------------------------------------------------------------------
C
#ifdef _DEBUG_LVLM1
      Write(6, *) 
      Write(6,9000) Nreal
      Write(6,9100) Natom
      Write(6,9200) (AtmLabel(i),i=1,Natom)
*     -----------------
 9000 Format(4X,'--- ','number of real atoms =',I7)
 9100 Format(4X,'--- ','number of zmat atoms =',I7)
 9200 Format(4X,'--- ','atoms:',8X,10A5,('\n',8X,10A5))
#endif
C
C---------------------------------------------------------------------
C
C     Read coordinate and translate from bohr to angstrom
C---------------------------------------------------------------------
C
      ierr =  1
      If (flgACESGeom) then
C
         Do j=1,3
            Do i=1,Natom
               Coord(j,i)=Coord(j,i)/b2ang
            End do
         End do
         If (Wrt_extrnl) Then
             Open(IUnitO,File='Geom.rate',Status='Unknown')
             Do i=1,Natom
                Do j=2,5
                   jchar=ichar(AtmLabel(i)(j:j))
                   If (jchar .GE. 65 .AND. jchar .LE. 90) then
                       AtmLabel(i)(j:j)=char(jchar+32)
                   End if
                End do
                If (AtmLabel(i)(1:5) .NE. 'X    ') then
                    ierr = 0
                    Do while (ierr .eq. 0) 
                       Read(IUnitO,7000, iostat=ierr) Temp_buff
                    Enddo
                    Write(IUnitO,7000) AtmLabel(i),(Coord(j,i),j=1,3),
     &                                 AtmMass(i)
                End if
             End do
             Write(IUnitO,"") 
         Endif
         Close(IUnitO)
C
      End if
 7000 Format(5X,A5,F15.10,2F18.10,F18.10)
C
C---------------------------------------------------------------------
C
C     Read total energy and degeneracy
C---------------------------------------------------------------------
C
      If (flgACESElec) then
C
C        Read the number of electrons and estimate degeneracy
C        -------------------------------------------------------------
         Call Getrec(20,'JOBARC','OCCUPYA0',NIrRep,NOcc(1)) 
         Nalph=0
         If (iUHF .EQ. 0) then
            Do i=1,NIrRep
               Nalph=Nalph+NOcc(i)
            End do
            Ntotal=Nalph*2
            Mult=1
            Nbeta = Nalph 
            call icopy(8, nocc(1), 1, nocc(9), 1)
         Else if (iUHF .EQ. 1) then
            Call Getrec(20,'JOBARC','OCCUPYB0',NIrRep,NOcc(9))
            Nbeta=0
            Do i=1,NIrRep
               Nalph=Nalph+NOcc(i)
               Nbeta=Nbeta+NOcc(i+8)
            End do
            Ntotal=Nalph+Nbeta
            Mult=(Nalph-Nbeta)+1
         End if
C
C        Calculate degeneracy in the atomic case
C        -------------------------------------------------------------
C
*        --- print out ---
#ifdef _DEBUG_LVLM1
         Write(6,6905) iUHF
         Write(6,6910) NIrRep
         Write(6,6920) (NOcc(i),i=1,NIrRep)
         Write(6,6930) (NOcc(i+8),i=1,NIrRep)
         Write(6,6940) Nalph
         Write(6,6950) Nbeta
         Write(6,6960) Ntotal
         Write(6,6970) Mult
*        -----------------
 6905    Format(4X,'--- ','iUHF  =',I7)
 6910    Format(4X,'--- ','number of irr.  rep. =',I7)
 6920    Format(4X,'--- ','number of alpha orbs :',8I4)
 6930    Format(4X,'--- ','number of beta  orbs :',8I4)
 6940    Format(4X,'--- ','number of alpha elecs=',I7)
 6950    Format(4X,'--- ','number of beta  elecs=',I7)
 6960    Format(4X,'--- ','total number of elecs=',I7)
 6970    Format(4X,'--- ','spin multiplicity    =',I7)
#endif 
C        Read total energy
C        -------------------------------------------------------------
         CALL Getrec(20,'JOBARC','TOTENERG',IINTFP,Etot)
         If (Wrt_extrnl) Then
            Open(IUnitO,File='Elec.rate',Status='Unknown')
            ierr = 0
            Do while (ierr .eq. 0)
                Read(IUnitO,7000, iostat=ierr) Temp_buff
            Enddo
            Write(IUnitO,6000) Mult,Etot
            Write(IUnitO, "")
            Close(IUnitO)
         Endif
C
      End if
 6000 Format(I3,F20.10)
C
C---------------------------------------------------------------------
C
C     Read gradient
C---------------------------------------------------------------------
C
      If (flgACESGrad) then
C
C   --- IMAP transforms from VMol order to ZMAT order
C
         Call Getrec(20,'JOBARC','GRADIENT',3*Nreal*IINTFP,
     &               VGrad(1,1))
         Do i=1,Nreal
            k=Imap(i)
            Do j=1,3
               Grad(j,k)=VGrad(j,i)
            End do
         End do
         If (Wrt_extrnl) Then
            Open(IUnitO,File='Grad.rate',Status='Unknown')
            ierr = 0
            Do while (ierr .eq. 0)
               Read(IUnitO,7000, iostat=ierr) Temp_buff
            Enddo
            Do i=1,nreal
               Write(IUnitO,5000) (Grad(j,i),j=1,3)
            End do
            Write(IUnitO,"")
            Close(IUnitO)
         Endif
C
      End if
 5000 Format(7X,3F18.10)
C
C---------------------------------------------------------------------
C
C     Read Hessian
C---------------------------------------------------------------------
C
      If (flgACESHess) then
C
         Call Getrec(20,'JOBARC','CART_HES',9*Natom*Natom*IINTFP,
     &               VHess)
         Call output(Vhess,1,3*natom,1,3*natom,3*natom,3*natom,1)

c
c-----Transform to the ZMAT order

         Ioff = 1
         Do Ivmol = 1, Natom
            Iatmzmat = Imap(Ivmol)
            Do Ixyz = 1, 3
               Icol = Ixyz + (Iatmzmat - 1)*3
               Do Jvmol = 1, Natom
                  Jatmzmat = Imap(Jvmol)
                  Irow = 1 + (Jatmzmat - 1)*3
                  Call Blkcpy(Vhess(ioff), 3, 1, Hess, 3*Natom,
     &                        3*Natom, Irow, Icol)
                  Ioff = Ioff + 3
               Enddo
            Enddo
         Enddo
C
C-----Eleminate the entry for dummy atoms
C
         Ix = 0
         Jx = 1
         Do Iatm = 1, 3*Natom
            Do Jatm = 1, 3*Natom
               Ink = 1 + (Iatm - 0.1)*3
               Jnk = 1 + (Jatm - 0.1)*3
               If ((AtmLabel(Ink)(1:5) .NE. 'X    ') .AND.
     &            ( AtmLabel(Jnk)(1:5) .NE. 'X    ')) Then
                   Ix = Ix + 1
                   Hess(Ix, Jx) = Hess(Iatm, Jatm)
                   If (Ix .EQ. 3*Natom) Ix = 0
                   If (Ix .EQ. 0) Jx = Jx + 1
               Endif
           Enddo
         Enddo 
C
         Call output(hess,1,3*natom,1,3*natom,3*natom,3*natom,1)
C
         If (Wrt_extrnl) Then
            Open(IUnitO,File='Hess.rate',Status='Unknown')
C
            ierr = 0
            Do while (ierr .eq. 0)
               Read(IUnitO,7000, iostat=ierr) Temp_buff
            Enddo
C
            Ioff = 0
            Joff = 0
            Do Iatm = 1, Nreal
                  Ioff = Ioff + (Iatm - 1)*3
                  Do Jatm = 1, Iatm
                     Joff = Joff + (Jatm - 1)*3
                     Write(IUnitO,4100) ((Hess(Ioff, Joff), 
     &                                    Ioff = 1, 3), Joff=1,3)
                  Enddo
            Enddo
            Write(IUnitO, "")
            Close(IUnitO)
         Endif
C
      Endif
C
 4100 Format(7X, 3D20.10)
C
      If (FlgACESForc) Call Getrec(20, "JOBARC", 'FORCECON', 
     &                             3*Natom*IINTFP, VOmega)
C
      Ivib = 0
      Do Imode = 1, 3*Natom
C
         If (Vomega(Imode) .lt. 0.0D0) Then
            Vomega(Imode) = - DSQRT(DABS(Vomega(Imode)))*Au2Invcm
         Else
            Vomega(Imode) = DSQRT(Vomega(Imode))*Au2Invcm
         Endif
C
         If (DABS(Vomega(Imode)) .GT. 1.0D0) Then
            Ivib = Ivib + 1
            Omega(Ivib) = Vomega(Imode)
         Endif
C
      Enddo
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The vibrational Frequencies"
      Write(*,"(4(2X,F10.4))") (Omega(I), I = 1, Nvibs)
#endif
C
      Open(IUnitO,File='Freq.rate',Status='Unknown')
      ierr = 0
      Do while (ierr .eq. 0)
         Read(IUnitO,7000, iostat=ierr) Temp_buff
      Enddo
C
      Write(IUnitO,"(4(2X,F18.8))") (Omega(I), I = 1, Nvibs)
      Write(IUnitO, "")
      Close(IUnitO)
C
      Return
      End

      SUBROUTINE SYMEXP3(IRREP,NUM2,NUM1,DIS,NUM,A,B)
C
C  THIS ROUTINE EXPANDS A COMPRESSED ARRAY T(IJ,AB) WITH I.LE.J  
C  TO THE FULL ARRAY USING THE SYMMETRY RELATION
C
C       T(IJ,AB) = T(JI,BA)
C
C  THIS ROUTINE IS USEFUL FOR THE LADDER PART IN THE RHF CASE
C
CEND
C
C  CODED JG JUNE/90
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIS,DIRPRD
      DIMENSION A(DIS,1),B(DIS,1),NUM1(8),NUM2(8)
      DIMENSION IPOLD(8),IPNEW(8)
C
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
C
      IND(J,I)=((J-1)*J)/2+I
C 
      DATA ZERO /0.0D0/
C
      CALL SYMTRA2(IRREP,NUM2,NUM2,DIS,NUM,A,B)
C
C     TAKE HERE CARE, IF WE ARE HANDLING IRREP=1 (TOTAL SYMMETRIC)
C     OR IRREP=1 (OTHERWISE)
C
      IF(IRREP.EQ.1) THEN
C
C     GET FIRST POINTERS FOR OLD AND NEW INDICES
C
       IPOLD(1)=0
       IPNEW(1)=0
       DO 10 IRREPJ=1,(NIRREP-1)
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)+(NUM1(IRREPJ)*(NUM1(IRREPJ)+1))/2
        IPNEW(IRREPJ+1)=IPNEW(IRREPJ)+NUM1(IRREPJ)**2
10     CONTINUE
C
C     NOW LOOP BACKWARDS FROM THE HIGHEST TO THE LOWEST IRREP
C
       DO 1 IRREPJ=NIRREP,1,-1
        NUMJ=NUM1(IRREPJ)
        IPO=IPOLD(IRREPJ)
        IPN=IPNEW(IRREPJ)
C
C     LOOP OVER ORBITALS, BUT ALSO IN BACKWARD ORDER
C
        DO 100 J=NUMJ,1,-1
         DO 100 I=J,1,-1
          IND1=IND(J,I)+IPO
          IND2=(J-1)*NUMJ+I+IPN
          DO 50 IAB=1,DIS
           A(IAB,IND2)=A(IAB,IND1)
50        CONTINUE
100     CONTINUE
C
C     EXPAND NOW THE ARRAY
C
       DO 300 I=2,NUMJ
        DO 300 J=1,I-1
         IND1=IND(I,J)+IPO
         IND2=(J-1)*NUMJ+I+IPN
         DO 250 IAB=1,DIS
          A(IAB,IND2)=B(IAB,IND1)
250      CONTINUE
300    CONTINUE
1      CONTINUE
C
      ELSE
C
C     FILL THE POINTERS OF THE OLD AND NEW ARRAY
C
      IPOLD(1)=0
      IPNEW(1)=0
      DO 1000 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM1(IRREPJ)
       NUMI=NUM1(IRREPI)
       IPNEW(IRREPJ+1)=IPNEW(IRREPJ)+NUMJ*NUMI
       IF(IRREPI.LT.IRREPJ) THEN
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)+NUMJ*NUMI
       ELSE
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)
       ENDIF
1000  CONTINUE
C
C     NOW COPY OLD ARRAYS TO NEW LOCATION
C
      DO 2000 IRREPJ=NIRREP,1,-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM1(IRREPJ)
       NUMI=NUM1(IRREPI)
       IF(IRREPJ.GT.IRREPI) THEN
        IPN=IPNEW(IRREPJ)
        IPO=IPOLD(IRREPJ)
        DO  2100 IJ=NUMJ*NUMI,1,-1
        IPNN=IPN+IJ
        IPOO=IPO+IJ
         DO 2050 IAB=1,DIS
        A(IAB,IPNN)=A(IAB,IPOO)

2050     CONTINUE
2100    CONTINUE
       ELSE
        IPN=IPNEW(IRREPJ)
        IPO=IPOLD(IRREPI)
        DO 2200 J=1,NUMJ
         DO 2200 I=1,NUMI
          IND1=(I-1)*NUMJ+J+IPO
          IND2=(J-1)*NUMI+I+IPN
          DO 2150 IAB=1,DIS
           A(IAB,IND2)=B(IAB,IND1)
2150      CONTINUE
2200    CONTINUE
       ENDIF
2000  CONTINUE
      ENDIF
      RETURN
      END

      subroutine rad_mesh(r_point,r_weight, 
     & radnum,bsrd,atnumber)
           
      implicit none
      
      integer i, j, k, l,radnum,atnumber
      double precision r_point(radnum),bsrd(105)
      double precision r_weight(radnum),kkk
      
      
      
c      write(6,*) 'Atmic number    ',atnumber
c      write(6,*) 'Bregg - Slater parameter ',bsrd(atnumber)   
      
      do i=0,radnum-1
      kkk = dble(i)/dble(radnum)
      r_point(i+1) = bsrd(atnumber)*( kkk**2.d0 )/
     & ( (1.d0-kkk)**2.d0)
      r_weight(i+1) = bsrd(atnumber)*2.d0*kkk/
     & ( (1.d0-kkk)**3.d0)  
      
      enddo
        
      return
      end
c------------------------------------------------------------------     
c                New version of radial mesh                       |
c------------------------------------------------------------------
 
      subroutine rad_mesh_new(r_point,r_weight,radnum,bsrd,atnumber)
      implicit none

      integer I,radnum,atnumber
      double precision r_point(radnum),r_weight(radnum),QQQ,PPP,
     & bsrd(105)
         PPP = dble(radnum+1)
         DO I=1,radnum
         QQQ =  dble(radnum+1-I)
         r_point(I) = bsrd(atnumber)*( (dble(I))**2.d0 )/(QQQ**2.d0)
         r_weight(I) = bsrd(atnumber)**3.d0* 
     &            ( 2.d0*PPP*(dble(I))**5.d0 )/(QQQ**7.d0)
         ENDDO 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ANALYZE_NAO_ORBITALS
     +
     +                    ( NBAS,NATOM,
     +                      MXSHELL,MXNAL,
     +                      MAXOCC,
     +                      NSHELLS,SHELLS,NBASAL,
     +                      ZATOM,
     +                      NMB,
     +                      LSIZE,
     +                      BASBEG,BASEND,
     +                      PSYMACC,
     +                      WNAOVAL,WNAORYD,
     +                      WPRE,W,
     +                      XVEC,
     +
     +                              NCB,NVB,NRB,
     +                              WRYDAT,
     +                              POPCOR,POPVAL,POPRYD,POPSUM,
     +                              NAOTYP,
     +                              COLMAP,SYMMAP,
     +                              CSHELL,VSHELL,RSHELL,
     +                              NCA,
     +                              MXNCBA,
     +                              ATNCB,ATCIDX,ATCOFF,
     +                              NVA,
     +                              MXNVBA,
     +                              ATNVB,ATVIDX,ATVOFF,
     +                              NRA,
     +                              MXNRBA,
     +                              ATNRB,ATRIDX,ATROFF,
     +                              CYCLERYD,CYCLESYM )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ANALYZE_NAO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine analyzes the NAO orbitals obtained by
C                looking at their weights and decomposing the NAO set
C                into Core, Valence and Rydberg NAO orbitals. The
C                criteria for this decomposition is governed by two
C                NAO weight thresholds:
C
C                  WNAOVAL  =<  weight  =<   MAXOCC     Core
C                  WNAORYD  =<  weight   <   WNAOVAL    Valence
C                        0  =<  weight   <   WNAORYD    Rydberg
C
C                Once the decomposition is established, the total
C                # of Rydberg NAO's is compared with the total # of
C                Rydberg NAO's obtained previously. If there is any
C                difference in these two numbers, then we know that
C                the original pre-NAO decomposition into minimal and
C                Rydberg sets was probably based on a wrong Rydberg
C                weight threshold. In this case we exit the present
C                routine with the appropriate pre-NAO Rydberg weight
C                threshold WRYDBG, which is based on the old pre-NAO
C                weights, and set the Rydberg cycle indicator true.
C
C                This routine also determines, if atomic centers are
C                related by symmetry or not, which is based on equal
C                # of shells, shell types and equal weight summations
C                per shell type. Any change in the atomic center
C                symmetry pattern sets the symmetry cycle indicator
C                true. Thus the NAO generation has been successful
C                only if the Rydberg space and the symmetry pattern
C                are both stable.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    MXSHELL      =  largest l-shell value
C                    MXNAL        =  maximum size of atomic l-shell
C                                    space. The atomic l-shell space
C                                    is the total # of contractions for
C                                    an atomic l-shell.
C                    MAXOCC       =  maximum orbital occupancy number
C                                    (can be only 1 or 2).
C                    NSHELLS (A)  =  # of l-shells for atom A.
C                    SHELLS (I,A) =  I-th l-shell type (s=0,p=1,etc...)
C                                    for atom A (in increasing order!).
C                    NBASAL (I,A) =  size of I-th atomic l-shell space
C                                    for atom A.
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    NMB          =  # of minimal NAO's.
C                    LSIZE (I)    =  I-th l-shell size
C                    BASBEG (A)   =  first basis index number for
C                                    atom A.
C                    BASEND (A)   =  last basis index number for
C                                    atom A.
C                    PSYMACC      =  symmetry accuracy for occupation
C                                    matrix values (including weights)
C                    WNAOVAL      =  the Valence NAO weight threshold.
C                    WNAORYD      =  the Rydberg NAO weight threshold.
C                    WPRE         =  pre-NAO weight vector.
C                    W            =  NAO weight vector.
C                    XVEC         =  flp scratch array of vector type.
C                    NRB          =  original # of Rydberg NAO's.
C                    SYMMAP (A,B) =  original symmetry map matrix,
C                                    containing a 1, if atoms A and B
C                                    are symmetry related and a value
C                                    of 0 otherwise, at the present
C                                    stage of calculation. If this
C                                    matrix changes here, we have to
C                                    rerun the pre-NAO/NAO generation
C                                    sequence, hence CYCLE will be set
C                                    true.
C
C
C                  Output:
C
C                    NCB,NVB,NRB  =  # of Core, Valence and Rydberg
C                                    NAOs found.
C                    WRYDAT (A)   =  the new pre-NAO weight threshold
C                                    for atom A (if necessary).
C                    POPxxx (A)   =  # of electrons populating the
C                                    Core, Valence, Rydberg and all
C                                    NAOs on atom A (xxx = COR,VAL,
C                                    RYD and SUM, respectively).
C                    NAOTYP (I)   =  integer 2,1 or 0, identifying
C                                    the type of NAO encountered for
C                                    the I-th NAO (= 2 for Core, = 1
C                                    for Valence and = 0 for Rydberg).
C                    COLMAP (I)   =  column map in the active sense,
C                                    such that COLMAP (I) contains the
C                                    position index of the I-th NAO
C                                    (based on atomic ordering) in an
C                                    NVB/NCB/NRB ordering, in which the
C                                    valence NAOs are bundled together
C                                    for further processing.
C                    SYMMAP (A,B) =  is set equal to 1 if atoms A and
C                                    B are symmetry related as judged
C                                    by comparison of the NAO weight
C                                    sums of the individual shells.
C                                    If no symmetry related the value
C                                    given is 0. Note, that if the
C                                    atomic Z values differ or the
C                                    overall NAO dimension is different
C                                    for both atoms then they cannot be
C                                    symmetry related.
C                    CSHELL (I)   =  l-shell type for the I-th Core NAO.
C                    VSHELL (I)   =  l-shell type for the I-th Valence
C                                    NAO.
C                    RSHELL (I)   =  l-shell type for the I-th Rydberg
C                                    NAO.
C                    NCA          =  # of atoms on which Core NAOs have
C                                    been found.
C                    MXNCBA       =  maximum # of Core NAOs per atom.
C                    ATNCB (A)    =  # of Core NAOs on core atom A.
C                    ATCIDX (A)   =  atomic index for core atom A.
C                    ATCOFF (A)   =  index offset for Core NAOs for
C                                    core atom A. This index is equal
C                                    to the total number of Core NAOs
C                                    on all core atoms preceeding core
C                                    atom A.
C                    NVA          =  # of atoms on which Valence NAOs
C                                    have been found.
C                    MXNVBA       =  maximum # of Valence NAOs per
C                                    atom.
C                    ATNVB (A)    =  # of Valence NAOs on valence
C                                    atom A
C                    ATVIDX (A)   =  atomic index for valence atom A.
C                    ATVOFF (A)   =  index offset for Valence NAOs
C                                    for valence atom A. This index is
C                                    equal to the total number of
C                                    valence NAO's on all valence atoms
C                                    preceeding valence atom A.
C                    NRA          =  # of atoms on which Rydberg NAOs
C                                    have been found.
C                    MXNRBA       =  maximum # of Rydberg NAOs per atom.
C                    ATNRB (A)    =  # of Rydberg NAOs on core atom A.
C                    ATRIDX (A)   =  atomic index for Rydberg atom A.
C                    ATROFF (A)   =  index offset for Rydberg NAOs for
C                                    Rydberg atom A. This index is equal
C                                    to the total number of Rydberg NAOs
C                                    on all Rydberg atoms preceeding
C                                    Rydberg atom A.
C                    CYCLERYD     =  cycle indicator for rerunning the
C                                    pre-NAO/NAO generation sequence
C                                    in case a Rydberg space dimension
C                                    mismatch was found. If true, the
C                                    sequence will be rerun with new
C                                    pre-NAO Rydberg atomic limits.
C                    CYCLESYM     =  cycle indicator for rerunning the
C                                    pre-NAO/NAO generation sequence
C                                    in case higher symmetry was found.
C                                    If true, the sequence will be
C                                    rerun.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     CYCLERYD,CYCLESYM
         LOGICAL     EQUALAB
         LOGICAL     ZVALEQ,NBASEQ,NLTYPEQ,NALEQ,LTYPEQ,LDIMEQ

         INTEGER     A,B,I,L,M,N
         INTEGER     ATOM
         INTEGER     BASOFFA,BASOFFB
         INTEGER     BASNR,BASNRA,BASNRB
         INTEGER     INDEX
         INTEGER     LDIM,LTOT,LTYPE
         INTEGER     MXSHELL,MXNAL,MXNCBA,MXNVBA,MXNRBA
         INTEGER     NBAS,NBAS2,NBASA,NBASB
         INTEGER     NAL
         INTEGER     NATOM
         INTEGER     NLTYPE
         INTEGER     NCA,NVA,NRA
         INTEGER     NCB,NVB,NRB,NMB
         INTEGER     NCBA,NVBA,NRBA
         INTEGER     NCBAOLD,NVBAOLD,NRBAOLD
         INTEGER     NRBPREV
         INTEGER     ZATOMA,ZATOMB

         INTEGER     ATNCB   (1:NATOM)
         INTEGER     ATNVB   (1:NATOM)
         INTEGER     ATNRB   (1:NATOM)
         INTEGER     ATCIDX  (1:NATOM)
         INTEGER     ATVIDX  (1:NATOM)
         INTEGER     ATRIDX  (1:NATOM)
         INTEGER     ATCOFF  (1:NATOM)
         INTEGER     ATVOFF  (1:NATOM)
         INTEGER     ATROFF  (1:NATOM)
         INTEGER     BASBEG  (1:NATOM)
         INTEGER     BASEND  (1:NATOM)
         INTEGER     COLMAP  (1:NBAS)
         INTEGER     CSHELL  (1:NBAS)
         INTEGER     VSHELL  (1:NBAS)
         INTEGER     RSHELL  (1:NBAS)
         INTEGER     LSIZE   (0:MXSHELL)
         INTEGER     NAOTYP  (1:NBAS)
         INTEGER     NSHELLS (1:NATOM)
         INTEGER     ZATOM   (1:NATOM)

         INTEGER     NBASAL  (1:MXSHELL+1,1:NATOM)
         INTEGER     SHELLS  (1:MXSHELL+1,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM    ,1:NATOM)

         DOUBLE PRECISION  MAXOCC
         DOUBLE PRECISION  PSYMACC
         DOUBLE PRECISION  THRESH
         DOUBLE PRECISION  WEIGHT,WNAORYD,WNAOVAL,WSUMA,WSUMB,WDIFF
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  POPCOR  (1:NATOM)
         DOUBLE PRECISION  POPVAL  (1:NATOM)
         DOUBLE PRECISION  POPRYD  (1:NATOM)
         DOUBLE PRECISION  POPSUM  (1:NATOM)
         DOUBLE PRECISION  W       (1:NBAS )
         DOUBLE PRECISION  WPRE    (1:NBAS )
         DOUBLE PRECISION  WRYDAT  (1:NATOM)
         DOUBLE PRECISION  XVEC    (1:NATOM)

         PARAMETER    (ZERO   =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...set initial values. Zero the atomic populations and
C                the temporary array which will hold the new atomic
C                Rydberg pre-NAO weight bounds.
C
C
         CYCLERYD = .FALSE.
         CYCLESYM = .FALSE.

         DO ATOM = 1,NATOM
            POPCOR (ATOM) = ZERO
            POPVAL (ATOM) = ZERO
            POPRYD (ATOM) = ZERO
            POPSUM (ATOM) = ZERO
            XVEC   (ATOM) = ZERO
         END DO
C
C
C             ...analyze the NAO weights and decompose the NAO set
C                into Core, Valence and Rydberg. Find here also
C                the new atomic Rydberg pre-NAO weight bounds, even
C                if they will not be used later, and store them in
C                a temporary array.
C
C
         NBAS2 = NBAS + NBAS
         BASNR = 0
         NRBPREV = NRB

         NCB = 0
         NVB = 0
         NRB = 0
         NCA = 0
         NVA = 0
         NRA = 0
         MXNCBA = 0
         MXNVBA = 0
         MXNRBA = 0

         DO 1000 ATOM = 1,NATOM

            NCBA = 0
            NVBA = 0
            NRBA = 0
            NCBAOLD = NCB
            NVBAOLD = NVB
            NRBAOLD = NRB

            NLTYPE = NSHELLS (ATOM)

            DO 2000 N = 1,NLTYPE

               NAL = NBASAL (N,ATOM)
               LTYPE = SHELLS (N,ATOM)
               LDIM = LSIZE (LTYPE)
               LTOT = NAL * LDIM

               DO L = 1,NAL

                  WEIGHT = ZERO
                  DO M = 1,LDIM
                     WEIGHT = WEIGHT + W (BASNR+M)
                  END DO
                  WEIGHT = WEIGHT / DFLOAT (LDIM)

                  IF (WEIGHT.GT.(MAXOCC+PSYMACC)) THEN
                      WRITE (*,*) ' shell NAO weight > ',MAXOCC+PSYMACC
                      WRITE (*,*) ' WEIGHT = ',WEIGHT
                      WRITE (*,*) ' nlo__analyze_nao_orbitals '
                      WRITE (1,*) ' shell NAO weight > ',MAXOCC+PSYMACC
                      WRITE (1,*) ' WEIGHT = ',WEIGHT
                      WRITE (1,*) ' nlo__analyze_nao_orbitals '
                      STOP
                  ELSE IF (WEIGHT.GE.WNAOVAL) THEN
                      DO M = 1,LDIM
                         NCB = NCB + 1
                         NCBA = NCBA + 1
                         COLMAP (BASNR+M) = NCB + NBAS
                         NAOTYP (BASNR+M) = 2
                         CSHELL (NCB) = LTYPE
                         POPCOR (ATOM) = POPCOR (ATOM) + W (BASNR+M)
                         POPSUM (ATOM) = POPSUM (ATOM) + W (BASNR+M)
                      END DO
                  ELSE IF (WEIGHT.GE.WNAORYD) THEN
                      DO M = 1,LDIM
                         NVB = NVB + 1
                         NVBA = NVBA + 1
                         COLMAP (BASNR+M) = NVB
                         NAOTYP (BASNR+M) = 1
                         VSHELL (NVB) = LTYPE
                         POPVAL (ATOM) = POPVAL (ATOM) + W (BASNR+M)
                         POPSUM (ATOM) = POPSUM (ATOM) + W (BASNR+M)
                      END DO
                  ELSE IF (WEIGHT.GE.ZERO) THEN
                      DO M = 1,LDIM
                         NRB = NRB + 1
                         NRBA = NRBA + 1
                         COLMAP (BASNR+M) = NRB + NBAS2
                         NAOTYP (BASNR+M) = 0
                         RSHELL (NRB) = LTYPE
                         POPRYD (ATOM) = POPRYD (ATOM) + W (BASNR+M)
                         POPSUM (ATOM) = POPSUM (ATOM) + W (BASNR+M)
                      END DO
                      M = BASNR + 1
                      XVEC (ATOM) = MAX (XVEC (ATOM),WPRE (M))
                  ELSE IF (WEIGHT.GE.-PSYMACC) THEN

                      WRITE (*,*) ' WARNING! Negative NAO weight! '
                      WRITE (*,*) -PSYMACC,' < shell NAO weight < 0 '
                      WRITE (*,*) ' WEIGHT = ',WEIGHT
                      WRITE (*,*) ' nlo__analyze_nao_orbitals '
                      WRITE (*,*) ' Proceeding ... '
                      WRITE (1,*) ' WARNING! Negative NAO weight! '
                      WRITE (1,*) -PSYMACC,' < shell NAO weight < 0 '
                      WRITE (1,*) ' WEIGHT = ',WEIGHT
                      WRITE (1,*) ' nlo__analyze_nao_orbitals '
                      WRITE (1,*) ' Proceeding ... '

                      DO M = 1,LDIM
                         NRB = NRB + 1
                         NRBA = NRBA + 1
                         COLMAP (BASNR+M) = NRB + NBAS2
                         NAOTYP (BASNR+M) = 0
                         RSHELL (NRB) = LTYPE
                         POPRYD (ATOM) = POPRYD (ATOM) + W (BASNR+M)
                         POPSUM (ATOM) = POPSUM (ATOM) + W (BASNR+M)
                      END DO
                      M = BASNR + 1
                      XVEC (ATOM) = MAX (XVEC (ATOM),WPRE (M))
                  ELSE
                      WRITE (*,*) ' shell NAO weight < ',-PSYMACC
                      WRITE (*,*) ' WEIGHT = ',WEIGHT
                      WRITE (*,*) ' nlo__analyze_nao_orbitals '
                      WRITE (1,*) ' max shell NAO weight < ',-PSYMACC
                      WRITE (1,*) ' WEIGHT = ',WEIGHT
                      WRITE (1,*) ' nlo__analyze_nao_orbitals '
                      STOP
                  END IF

                  BASNR = BASNR + LDIM

               END DO
 2000       CONTINUE

            IF (NCBA.GT.0) THEN
                NCA = NCA + 1
                ATNCB (NCA) = NCBA
                ATCIDX (NCA) = ATOM
                ATCOFF (NCA) = NCBAOLD
                MXNCBA = MAX0 (NCBA,MXNCBA)
            END IF

            IF (NVBA.GT.0) THEN
                NVA = NVA + 1
                ATNVB (NVA) = NVBA
                ATVIDX (NVA) = ATOM
                ATVOFF (NVA) = NVBAOLD
                MXNVBA = MAX0 (NVBA,MXNVBA)
            END IF

            IF (NRBA.GT.0) THEN
                NRA = NRA + 1
                ATNRB (NRA) = NRBA
                ATRIDX (NRA) = ATOM
                ATROFF (NRA) = NRBAOLD
                MXNRBA = MAX0 (NRBA,MXNRBA)
            END IF

 1000    CONTINUE
C
C
C             ...check, if the # of Rydberg NAO's found conforms
C                with the # of Rydberg pre-NAO's found previously.
C                If not, transfer the new atomic Rydberg pre-NAO
C                weight bounds from the temporary array and exit
C                routine with Rydberg cycle indicator set true.
C
C
         CYCLERYD = NRB .NE. NRBPREV

         IF (CYCLERYD) THEN
             WRITE (*,*) ' Rydberg CYCLE! '
             DO ATOM = 1,NATOM
                WRYDAT (ATOM) = XVEC (ATOM)
             END DO
             RETURN
         END IF
C
C
C             ...check, if the # of Core and Valence NAOs add up ok
C                to the # of minimal pre-NAOs.
C
C
         IF ((NCB+NVB).NE.NMB) THEN
             WRITE (*,*) ' Problems in finding correct # of NAOs! '
             WRITE (*,*) ' NCB,NVB,NMB = ',NCB,NVB,NMB
             WRITE (*,*) ' nlo__analyze_nao_orbitals '
             WRITE (1,*) ' Problems in finding correct # of NAOs! '
             WRITE (1,*) ' NCB,NVB,NMB = ',NCB,NVB,NMB
             WRITE (1,*) ' nlo__analyze_nao_orbitals '
             STOP
         END IF
C
C
C             ...no more NAO determination cycles necessary. Update
C                the NCB and NRB sections of the column map.
C
C
         DO I = 1,NBAS
            INDEX = COLMAP (I)
            IF (INDEX.GT.NBAS2) THEN
                INDEX = INDEX - NBAS2 + NVB + NCB
                COLMAP (I) = INDEX
            ELSE IF (INDEX.GT.NBAS) THEN
                INDEX = INDEX - NBAS + NVB
                COLMAP (I) = INDEX
            END IF
         END DO
C
C
C             ...determine the new symmetry map by looping over all
C                unique atomic pairs and compare with the old symmetry
C                map values. Set the CYCLESYM indicator = .true., if
C                any change occurs.
C
C
         DO A = 1,NATOM
            ZATOMA  = ZATOM (A)
            BASOFFA = BASBEG (A) - 1
            NBASA   = BASEND (A) - BASOFFA
            NLTYPE  = NSHELLS (A)

            DO B = A+1,NATOM
               ZATOMB  = ZATOM (B)
               BASOFFB = BASBEG (B) - 1
               NBASB   = BASEND (B) - BASOFFB

               ZVALEQ  = ZATOMA .EQ. ZATOMB
               NBASEQ  = NBASA  .EQ. NBASB
               NLTYPEQ = NLTYPE .EQ. NSHELLS (B)

               EQUALAB = ZVALEQ.AND.NBASEQ.AND.NLTYPEQ

               IF (EQUALAB) THEN

                   BASNRA = BASOFFA
                   BASNRB = BASOFFB

                   DO N = 1,NLTYPE
                      NAL   = NBASAL (N,A)
                      LTYPE = SHELLS (N,A)
                      LDIM  = LSIZE (LTYPE)

                      NALEQ  = NAL   .EQ. NBASAL (N,B)
                      LTYPEQ = LTYPE .EQ. SHELLS (N,B)
                      LDIMEQ = LDIM  .EQ. LSIZE (SHELLS (N,B))

                      EQUALAB = EQUALAB.AND.NALEQ.AND.LTYPEQ.AND.LDIMEQ

                      IF (EQUALAB) THEN
                          DO L = 1,NAL
                             WSUMA = ZERO
                             WSUMB = ZERO
                             DO M = 1,LDIM
                                WSUMA = WSUMA + W (BASNRA+M)
                                WSUMB = WSUMB + W (BASNRB+M)
                             END DO
                             WDIFF = DABS (WSUMA - WSUMB)
                             THRESH = PSYMACC * DFLOAT (LDIM)
                             EQUALAB = EQUALAB .AND. (WDIFF.LT.THRESH)
                             BASNRA = BASNRA + LDIM
                             BASNRB = BASNRB + LDIM
                          END DO
                      END IF

                   END DO
               END IF

               IF (EQUALAB) THEN
                   CYCLESYM = SYMMAP (A,B) .NE. 1
                   SYMMAP (A,B) = 1
                   SYMMAP (B,A) = 1
               END IF

            END DO
         END DO

         IF (CYCLESYM) THEN
             WRITE (*,*) ' Symmetry CYCLE! '
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE SETUP(HES, GRD, HESMOD, GRDMOD, IQFIX, STPMAX, LUOUT)
C
C Build the Hessian and Gradient vectors symmetry coordintes (
C only those internal that are optimized is taking in to account)
C Also do all other initializations.
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT, INR, IVEC, IDIE, ICURVY, IMXSTP, ISTCRT, 
     &                IVIB, ICONTL, IRECAL, INTTYP, IDISFD, IGRDFD, 
     &                ICNTYP, ISYM, IBASIS, XYZTol

C
      DIMENSION HES(NXM6, NXM6), GRD(NXM6), HESMOD(NOPT, NOPT),
     &          GRDMOD(NOPT), IQFIX(3*MXATMS, 3*MXATMS)
C
C Let's update the number of cycles right away!
C
      Write(6,*) "The number of opt. cycles:", NCYCLE 
C
      NCYCLE = NCYCLE + 1 
C
      DO 311 I=1, NUNIQUE
         DO 312 J=1, NEQ(IUNIQUE(I))
            IQFIX(IUNIQUE(I), J)=IEQUIV(I,J)
 312     CONTINUE
 311  CONTINUE
C  
      DO 19 I=1, NOPT
         DO 20 J=1, NOPT
C
            HESMOD(I,J)=HES(NOPTI(I), NOPTI(J))
C
            DO 29 K=1, NEQ(NOPTI(I))
               HESMOD(I,J)=HESMOD(I,J)+HES(IQFIX(NOPTI(I),K),NOPTI(J))
 29         CONTINUE
C
            DO 39 L=1, NEQ(NOPTI(J))
               HESMOD(I,J)=HESMOD(I,J)+HES(NOPTI(I),IQFIX(NOPTI(J),L))
 39         CONTINUE
C
            DO 49 K=1, NEQ(NOPTI(I))
               DO 50 L=1, NEQ(NOPTI(J))
                  HESMOD(I, J)=HESMOD(I, J) + HES(IQFIX(NOPTI(I), K),
     &                        IQFIX(NOPTI(J), L))
 50            CONTINUE
 49         CONTINUE
C
            ZD=DSQRT(DFLOAT((NEQ(NOPTI(I))+1)*(NEQ(NOPTI(J))+1)))
            HESMOD(I,J)=HESMOD(I,J)/ZD
C
 20      CONTINUE
 19   CONTINUE
C
C     
C Form modified Gradient vector and symmetrize it. 
C
      DO 1177 I=1, NOPT
         GRDMOD(I)=DSQRT(DFLOAT(NEQ(NOPTI(I))+1))*GRD(NOPTI(I))
 1177 CONTINUE
C
C
C The maximum step size can be controlled by the user by setting
C the flag MAX_STEP. The default value for maximum is set 300.
C IMXSTP is first set in mkvmol.F (strange!). We need to move
C these things into a one place that is visible to the developers.
      IF (IMXSTP .EQ. 0) IMXSTP = 300
      STPMAX = DBLE(IMXSTP)/1000.D0
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__OPEN_FILES
     +
     +                    ( NAMEID,NAMEDB,
     +
     +                              UNITID,
     +                              UNITDB )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__OPEN_FILES
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This operation opens the two sequential files:
C
C                         NAMEID : printout file
C                         NAMEDB : diagnostic/debug file
C
C                and returns their unit numbers.
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         CHARACTER*(*)      NAMEID,NAMEDB

         INTEGER            UNITID,UNITDB
C
C
C------------------------------------------------------------------------
C
C
C             ...open the two files.
C
C
         CALL  OFH__OPEN_FILE
     +
     +              ( NAMEID,
     +                'UNKNOWN',
     +                'SEQUENTIAL',
     +                'FORMATTED',
     +
     +                        UNITID )
     +
     +
         CALL  OFH__OPEN_FILE
     +
     +              ( NAMEDB,
     +                'UNKNOWN',
     +                'SEQUENTIAL',
     +                'FORMATTED',
     +
     +                        UNITDB )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork3321(y,na1,na2,nb1,nb2,nc1,nc2,
     *                     a1,a2,b1,b2,c1,c2,inda, indb,
     *                     indc, x1,ne1,ne2,nf1,nf2,ng1,ng2,
     *                     e1,e2,f1,f2,g1,g2,
     *                     indx1, x2,ni1,ni2,nj1,nj2,
     *                     i1,i2,j1,j2,indi, indj,
     *                     cind, flopcount,scr1, scr2)
c-------------------------------------------------------------------------
c   Performs a "3321" contraction:
c      3 index output array
c      3 index operand array
c      2 index operand array
c      1 index contraction.
c
c   I. e., contract one of the the 2 indices of the 2nd operand array out
c   of the first operand array, replacing the index by the 2nd operand's
c   2nd index.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'
      include 'saved_data.h'

      integer na1,na2,nb1,nb2,nc1,nc2
      integer ne1,ne2,nf1,nf2,ng1,ng2
      integer ni1, ni2, nj1, nj2
      integer a1,a2,b1,b2,c1,c2,e1,e2,f1,f2,g1,g2,
     *        i1,i2,j1,j2
      integer inda, indb, indc, indx1(3), indi, indj
      integer cind(2), flopcount

      double precision y(na1:na2,nb1:nb2,nc1:nc2)
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2)
      double precision x2(ni1:ni2,nj1:nj2)

      double precision scr1(*)
      double precision scr2(*)
      integer next

      integer ia, ib, ic, icontract, ix(3), iy
      integer i, j, a, b, c 
      integer indy(3), map(3)
      integer ie, if, ig
      integer e, f, g 
      integer alast, dlast
      integer iprint
      double precision cval

      integer*8 ixx, c_loc64

#ifdef __crayx1
      integer*8 m, n, k, lda, ldb, ldc
#else
      integer m, n, k, lda, ldb, ldc
#endif

      iprint = cwork_iprint
 
c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various y and x2
c   indices.
c---------------------------------------------------------------------------

      ia = 0
      ib = 0
      ic = 0
      do i = 1, 3

         if (indx1(i) .eq. inda) then
            ia = i
         else if (indx1(i) .eq. indb) then
            ib = i
         else if (indx1(i) .eq. indc) then
            ic = i
         else if (indx1(i) .eq. cind(1)) then
            icontract = i
         else
            print *,'Error: Invalid index in cwork3321'
            print *,'X1 index is ',indx1(i),' y indices: ',inda, indb,
     *              indc,  
     *              ' x2 indices: ',indi,indj,' cind(1) = ',cind(1)
            call abort_job()
         endif
      enddo

      indy(1) = ia
      indy(2) = ib
      indy(3) = ic
      do i = 1, 3
         if (indy(i) .eq. 0) indy(i) = icontract
      enddo


c     write(6,*) ' CIND = ', cind(1), 'indi = ', indi, 
c    *           'icontract = ', icontract 
      if (indi .eq. cind(1)) then

c--------------------------------------------------------------------------
c   Contract over the first index in X2.
c--------------------------------------------------------------------------

         flopcount = 2*(i2-i1+1)*(c2-c1+1)*(b2-b1+1)*(a2-a1+1)
         if (indy(1) .eq. 1 .and. indy(2) .eq. 2 .and.
     *       indy(3) .eq. 3) then  

            if (icontract .eq. 1) then

c--------------------------------------------------------------------------
c   Contract over the 1st index of X1.
c
c   Y(a,b,c) = X1(i,b,c)*X2(i,a)
c--------------------------------------------------------------------------

               m = (a2-a1+1)
               n = (b2-b1+1)*(c2-c1+1)
               k = i2-i1+1
               lda = (ni2-ni1+1)
               ldb = ne2-ne1+1
               ldc = (na2-na1+1)
               call dgemm('T', 'N', m,n,k,1.d0, x2(i1,j1), lda,
     *                 x1(i1,b1,c1), ldb,
     *                 0.d0, y(a1,b1,c1), ldc)
               return

            endif

            if (icontract .eq. 2) then
c              write(6,*) ' Entering dgemm --> icontract = 2' 

c--------------------------------------------------------------------------
c   Contract over the 2nd index of X1.
c
c   Y(a,b,c) = X1(a,i,c) * X2(i,b)
c--------------------------------------------------------------------------

               m = (a2-a1+1)
               n = (b2-b1+1)
               k = i2-i1+1
               lda = (ne2-ne1+1)
               ldb = (ni2-ni1+1)
               ldc = (na2-na1+1)
               do c = c1, c2
                  call dgemm('N', 'N', m,n,k,1.d0, x1(a1,i1,c), lda,
     *                        x2(i1,j1), ldb, 0.d0,
     *                        y(a1,b1,c), ldc)
               enddo

               return
            endif

            if (icontract .eq. 3) then

c--------------------------------------------------------------------------
c   Contract over the 3rd index of X1.
c
c   Y(a,b,c) + X1(a,b,i)*X2(i,c)
c--------------------------------------------------------------------------

               m = (a2-a1+1)*(b2-b1+1)
               n = (c2-c1+1)
               k = i2-i1+1
               lda = (ne2-ne1+1)*(nf2-nf1+1)
               ldb = (ni2-ni1+1)
               ldc = (na2-na1+1)*(nb2-nb1+1)
                  call dgemm('N', 'N', m,n,k,1.d0, x1(a1,b1,i1), lda,
     *                        x2(i1,j1), ldb, 0.d0,
     *                        y(a1,b1,c1), ldc)
               return
            endif

         endif 

      endif 

      print *,'Error: Invalid contraction at line ',current_line
      call abort_job()  
      return
      end
       

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine twork2111(y,na1,na2,nb1,nb2,
     *                     a1,a2,b1,b2,indy,
     *                     x1,ne1,ne2,
     *                     e1,e2,indx1,
     *                     x2,ni1,ni2,
     *                     i1,i2,indx2,
     *                     flopcount) 
c-------------------------------------------------------------------------
c   Performs a "4222" tensor contraction: 
c      4 index output array 
c      2 index operand array
c      2 index operand array
c      2 index contraction.
c
c--------------------------------------------------------------------------
      implicit none

      integer na1,na2,nb1,nb2,ne1,ne2,
     *        ni1,ni2 
      integer a1,a2,b1,b2,e1,e2,i1,i2
      integer indy(2), indx1(1), indx2(1)
      integer flopcount

      double precision y(na1:na2,nb1:nb2)
      double precision x1(ne1:ne2)
      double precision x2(ni1:ni2)

      integer i, j, a, b, c, d

      flopcount = (a2-a1+1)*(b2-b1+1)
     
c----------------------------------------------------------------------------
c   ia is the 1st index of x1.
c----------------------------------------------------------------------------

      if (indx1(1) .eq. indy(1)) then 
         do b = b1,b2
         do a = a1,a2
            y(a,b) = x1(a)*x2(b)
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. indy(2)) then 
         do b = b1,b2
         do a = a1,a2
            y(a,b) = x1(b)*x2(a)
         enddo 
         enddo 

         return
      endif

      print *,'twork2111: Your tensor operation does not fit',
     *    ' any valid pattern'
      call abort_job() 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_params(pfile)
c-------------------------------------------------------------------------
c   Reads parameters from a ZMAT file into an internal table.
c   The ZMAT file must be present in the run directory.
c-------------------------------------------------------------------------

      implicit none
      character*(*) pfile

      integer max_table 
      integer ntable
      integer iunit
      parameter (max_table = 1000)

      character*80 table(max_table)
      common /parameter_table/ntable, table

      integer i, ios, n
      integer str_trimlen
      character*80 data

      ntable = 0

c---------------------------------------------------------------------------
c   Open the parameter file.
c---------------------------------------------------------------------------

      iunit = 12
      open (file = pfile, unit = iunit, status = 'OLD',
     *      err=500, iostat = ios)

c---------------------------------------------------------------------------
c   Read each record down to the "*SIP" identifier.
c---------------------------------------------------------------------------

   50 continue
      read (iunit,fmt='(a80)', end = 150, err = 600) data
      if (data(1:4) .ne. '*SIP') go to 50

      go to 200
  150 continue
c      print *,'Error reading ZMAT: No *SIP record was found.'
c      call abort_job()
      go to 300 
  200 continue

c---------------------------------------------------------------------------
c   Read all parameter data until a completely blank line (or a line 
c   beginning with an "*" is found.
c---------------------------------------------------------------------------

      do i = 1, max_table
         read (iunit,'(A80)', end=100) table(i)
         
         n = str_trimlen(table)     ! find length w/o trailing blanks.
         if (n .eq. 0) go to 100    ! n=0 implies a blank line
         if (table(i)(1:1) .eq. '*') go to 100

         ntable = ntable + 1
      enddo

      print *,'ERROR: Maximum number of lines of parameters (',
     *         max_table,') has been exceeded.'
      call abort_job()

  100 continue

      if (table(ntable+1)(1:7) .eq. '*DROPAO') then

c---------------------------------------------------------------------------
c   DROPAO namelist: Read in the lines to the table.
c-------------------------------------------------------------------------

         data = ' '
         do while (data(1:1) .ne. '*')
            read (iunit,fmt='(a80)', end = 300, err = 600) data
            n = str_trimlen(data) 
            if (n .eq. 0) go to 300   ! blank line
            table(ntable) = data
            ntable = ntable + 1
         enddo
      endif

  300 continue
c--------------------------------------------------------------------------
c   Close the parameter file.
c--------------------------------------------------------------------------

      close(iunit)
      return

  500 continue
      print *,'Error: Cannot open parameter file.  I/O status = ',ios
      print *,'       Parameter file name = ',pfile
      call abort_job()

  600 continue
      print *,'I/O error while reading parameter: I/O status ',ios
      print *,'       Parameter file name = ',pfile
      call abort_job()
      return

      end

      subroutine rgetparam(keyword, instance, rvalue)
c------------------------------------------------------------------------
c   Returns the value corresponding to "keyword".  If the keyword is not
c   found, it returns nothing.
c------------------------------------------------------------------------

      implicit none

      integer max_table
      parameter (max_table = 1000)

      integer ntable
      character*80 table(max_table)

      common /parameter_table/ntable, table

      character*(*) keyword
      integer instance, icount
      double precision rvalue
      integer ivalue
      integer i, n
      integer str_trimlen

      character*80 cvalue

      n = str_trimlen(keyword)
      icount = 0
      do i = 1, ntable
         if (keyword(1:n) .eq. table(i)(1:n)) then
            if (table(i)(n+1:n+1) .eq. ' ' .or.
     *          table(i)(n+1:n+1) .eq. '=') then
               icount = icount + 1
               if (icount .eq. instance) then
                  call c_line_parse(table(i) // char(0), '=', 2, ivalue,
     *                        rvalue, cvalue)
                  return
               endif
            endif
         endif 
      enddo
      return
      end

      subroutine igetparam(keyword, instance, ivalue)
c------------------------------------------------------------------------
c   Returns the value corresponding to "keyword".  If the keyword is not
c   found, it returns nothing.
c------------------------------------------------------------------------

      implicit none

      integer max_table
      parameter (max_table = 1000)
      integer ntable
      character*80 table(max_table)

      common /parameter_table/ntable, table

      character*(*) keyword
      integer instance, icount
      double precision rvalue
      integer ivalue
      integer i, n
      integer str_trimlen

      character*80 cvalue

      n = str_trimlen(keyword)
      icount = 0
      do i = 1, ntable
         if (keyword(1:n) .eq. table(i)(1:n)) then
            if (table(i)(n+1:n+1) .eq. ' ' .or.
     *          table(i)(n+1:n+1) .eq. '=') then
               icount = icount + 1
               if (icount .eq. instance) then
                  call c_line_parse(table(i) // char(0), '=', 1, ivalue,
     *                        rvalue, cvalue)
                  return
               endif
            endif
         endif 
      enddo
      return
      end

      subroutine cgetparam(keyword, instance, cvalue)
c------------------------------------------------------------------------
c   Returns the value corresponding to "keyword".  If the keyword is not
c   found, it returns nothing.
c------------------------------------------------------------------------

      implicit none

      integer max_table
      parameter (max_table = 1000)
      integer ntable
      character*80 table(max_table)

      common /parameter_table/ntable, table

      character*(*) keyword
      integer instance, icount
      double precision rvalue
      integer ivalue
      integer i, n, nn, j, indx
      integer str_trimlen

      character*(*) cvalue

      n = str_trimlen(keyword)
      icount = 0
      do i = 1, ntable
         if (keyword(1:n) .eq. table(i)(1:n)) then
            if (table(i)(n+1:n+1) .eq. ' ' .or.
     *          table(i)(n+1:n+1) .eq. '=') then
               icount = icount + 1
               if (icount .eq. instance) then
                  call c_line_parse(table(i) // char(0), '=', 3, ivalue,
     *                        rvalue, cvalue)
                  return
               endif
            endif
         endif 
      enddo
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine stripi(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c--------------------------------------------------------------------------
c  In this routine the index i is stripped from the array1 and the 
c  resulting array is returned as array2.   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index
      integer stack
      integer nsend 

      integer comm

      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(mx_array_index), findex(mx_array_index) 
      integer type(mx_array_index) 
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the first array: c_result_array 
c---------------------------------------------------------------------------

      array = op(c_result_array)
      nindex = array_table(c_nindex, array) 

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         sindex(i) = index 
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, fop1(i), fop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk1 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk1 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the second array: c_op1_array 
c---------------------------------------------------------------------------

      array = op(c_op1_array)
      nindex = array_table(c_nindex, array) 

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         findex(i) = index 
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, sop1(i), sop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk2 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk2 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c     write(6,*) ' ******************** ' 
c     write(6,*) ' OP1 :', (sindex(i), i=1,4) 
c     write(6,*) ' OP2 :', (findex(i), i=1,4) 

200   continue 

      nsend = 1 
      do i = 1, nindex  
         nsend = nsend*(sop2(i)-sop1(i)+1) 
      enddo 
      if (nindex .eq. 4) then 
      call do_istrip4(x(indblk1), sindex, 
     *                  fop1(1), fop2(1), fop1(2), fop2(2), 
     *                  fop1(3), fop2(3), fop1(4), fop2(4),
     *                  x(indblk2), findex,  
     *                  sop1(1), sop2(1), sop1(2), sop2(2), 
     *                  sop1(3), sop2(3), sop1(4), sop2(4), 
     *                  nsend)
      endif 

      if (nindex .eq. 3) then 
      call do_istrip3(x(indblk1), sindex, 
     *                  fop1(1), fop2(1), fop1(2), fop2(2), 
     *                  fop1(3), fop2(3),
     *                  x(indblk2), findex,  
     *                  sop1(1), sop2(1), sop1(2), sop2(2), 
     *                  sop1(3), sop2(3), 
     *                  nsend)
      endif 

      if (nindex .eq. 2) then 
      call do_istrip2(x(indblk1), sindex, 
     *                  fop1(1), fop2(1), fop1(2), fop2(2), 
     *                  x(indblk2), findex,  
     *                  sop1(1), sop2(1), sop1(2), sop2(2), 
     *                  nsend)
      endif 
 
      return
      end

      subroutine do_istrip4(x, sindex, a1, a2, b1, b2, c1, c2, d1, d2,
     *                      y, findex, e1, e2, f1, f2, g1, g2, h1, h2, 
     *                      nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual stripping. Only ONE index can be 
c  stripped and the arrays must be 4-D.   
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index), 
     *        match(4) 

      integer i, j, k, a, b, c, d 
      integer m, n, lda, ldb, ldc 
      integer nsend, strip(4), nstrip   
      integer astart, aend, bstart, bend, cstart, cend, dstart, dend 

      double precision x(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision y(e1:e2,f1:f2,g1:g2,h1:h2)

      nsend = (e2-e1+1)*(f2-f1+1)*(g2-g1+1)*(h2-h1+1) 

c *********************************************************************************** 
c     Find the nonmatching indeces and make sure that array2 has simple indeces 
c     in those locations. 
c *********************************************************************************** 

      nstrip = 0 
      do i = 1, 4 
         strip(i) = 0 
         if (sindex(i) .ne. findex(i)) then 
             if (i .eq. 1) match(i) = e1 
             if (i .eq. 2) match(i) = f1 
             if (i .eq. 3) match(i) = g1 
             if (i .eq. 4) match(i) = h1 
             nstrip = nstrip + 1 
             strip(nstrip) = i 
         else 
             match(i) = 0 
         endif 
      enddo 

      if (match(1) .ne. 0) then 
         if ((e1 .lt. a1) .or. (e1 .gt. a2)) then 
            write(6,*) ' Mismatch trying to strip indices ' 
            call abort_job() 
         endif 
         astart = e1 
         aend   = e1 
      else 
         astart = a1 
         aend   = a2 
      endif 

      if (match(2) .ne. 0) then 
         if ((f1 .lt. b1) .or. (f1 .gt. b2)) then 
            write(6,*) ' Mismatch trying to strip indices ' 
            call abort_job() 
         endif 
         bstart = f1 
         bend   = f1 
      else 
         bstart = b1 
         bend   = b2 
      endif 

      if (match(3) .ne. 0) then 
         if ((g1 .lt. c1) .or. (g1 .gt. c2)) then 
            write(6,*) ' Mismatch trying to strip indices ' 
            call abort_job() 
         endif 
         cstart = g1 
         cend   = g1 
      else 
         cstart = c1 
         cend   = c2 
      endif 

      if (match(4) .ne. 0) then 
         if ((h1 .lt. d1) .or. (h1 .gt. d2)) then 
            write(6,*) ' Mismatch trying to strip indices ' 
            call abort_job() 
         endif 
         dstart = h1 
         dend   = h1 
      else 
         dstart = d1 
         dend   = d2 
      endif 

      do d = dstart, dend  
      do c = cstart, cend  
      do b = bstart, bend  
      do a = astart, aend 

         y(a,b,c,d) = x(a,b,c,d) 

      enddo 
      enddo 
      enddo 
      enddo 
      return 


c *********************************************************************************** 
c Strip one index 
c *********************************************************************************** 
c
      if (nstrip .eq. 1) then 
c *********************************************************************************** 
c     The fourth index stripped 
c *********************************************************************************** 

      if ((strip(1) .eq. 4) .and. (h1 .ge. d1) .and. (h1 .le. d2)) then 

      do c = c1, c2 
      do b = b1, b2 
      do a = a1, a2 
c     do d = d1, d2 

         y(a,b,c,h1) = x(a,b,c,h1) 

c     enddo 
      enddo 
      enddo 
      enddo 

      go to 100 

      endif 

c *********************************************************************************** 
c     The Third index stripped 
c *********************************************************************************** 

      if ((strip(1) .eq. 3) .and. (g1 .ge. c1) .and. (g1 .le. c2)) then 

c     do c = c1, c2 
      do d = d1, d2 
      do b = b1, b2 
      do a = a1, a2 

         y(a,b,g1,d) = x(a,b,g1,d) 

      enddo 
      enddo 
      enddo 
c     enddo 

      go to 100 

      endif 

c *********************************************************************************** 
c     The Second index stripped 
c *********************************************************************************** 

      if ((strip(1) .eq. 2) .and. (f1 .ge. b1) .and. (f1 .le. b2)) then 

      do d = d1, d2 
      do c = c1, c2 
c     do b = b1, b2 
      do a = a1, a2 

         y(a,f1,c,d) = x(a,f1,c,d) 

      enddo 
      enddo 
c     enddo 
      enddo 

      go to 100 

      endif 

c *********************************************************************************** 
c     The First index stripped 
c *********************************************************************************** 

      if ((strip(1) .eq. 1) .and. (e1 .ge. a1) .and. (e1 .le. a2)) then 

      do d = d1, d2 
      do c = c1, c2 
      do b = b1, b2 
c     do a = a1, a2 

         y(e1,b,c,d) = x(e1,b,c,d) 

      enddo 
      enddo 
c     enddo 
      enddo 

      go to 100 

      endif 

      endif ! nstrip = 1 

c *********************************************************************************** 
c Strip two indices  
c *********************************************************************************** 
c
      if (nstrip .eq. 2) then 
c *********************************************************************************** 
c     The index 1 1nd 2 are stripped 
c *********************************************************************************** 

         if ((strip(1) .eq. 1) .and. (strip(2) .eq. 2)) then 
            do c = c1, c2 
            do d = d1, d2 
               y(e1,f1,c,d) = x(e1,f1,c,d) 
            enddo 
            enddo 
            return 
         endif 

      endif 


      write(6,*) ' No indeces were found to strip in strip4 '
      write(6,*) ' Strip = ', (strip(i), i=1, 4)  
      write(6,*) ' Match(i) = ', (match(i), i=1,4)  
      call abort_job() 

100   continue 

      return
      end


      subroutine do_istrip3(x, sindex, a1, a2, b1, b2, c1, c2,
     *                      y, findex, e1, e2, f1, f2, g1, g2,  
     *                      nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual stripping. Only ONE index can be 
c  stripped and the arrays must be 4-D.   
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index), 
     *        match(mx_array_index) 

      integer i, j, k, a, b, c, d 
      integer m, n, lda, ldb, ldc 
      integer nsend, strip  

      double precision x(a1:a2,b1:b2,c1:c2)
      double precision y(e1:e2,f1:f2,g1:g2)

      nsend = (e2-e1+1)*(f2-f1+1)*(g2-g1+1) 

c *********************************************************************************** 
c     Find the nonmatching indeces and make sure that array2 has simple indeces 
c     in those locations. 
c *********************************************************************************** 

      do i = 1, 3 
         if (sindex(i) .ne. findex(i)) then 
             if (i .eq. 1) match(i) = e1 
             if (i .eq. 2) match(i) = f1 
             if (i .eq. 3) match(i) = g1 
             strip = i 
         else 
             match(i) = 0 
         endif 
      enddo 

c *********************************************************************************** 
c     The Third index stripped 
c *********************************************************************************** 

      if ((strip .eq. 3) .and. (g1 .ge. c1) .and. (g1 .le. c2)) then 

c     do c = c1, c2 
      do b = b1, b2 
      do a = a1, a2 

         y(a,b,g1) = x(a,b,g1) 

      enddo 
      enddo 
c     enddo 

      go to 100 

      endif 

c *********************************************************************************** 
c     The Second index stripped 
c *********************************************************************************** 

      if ((strip .eq. 2) .and. (f1 .ge. b1) .and. (f1 .le. b2)) then 

      do c = c1, c2 
c     do b = b1, b2 
      do a = a1, a2 

         y(a,f1,c) = x(a,f1,c) 

      enddo 
      enddo 
c     enddo 

      go to 100 

      endif 

c *********************************************************************************** 
c     The First index stripped 
c *********************************************************************************** 

      if ((strip .eq. 1) .and. (e1 .ge. a1) .and. (e1 .le. a2)) then 

      do c = c1, c2 
      do b = b1, b2 
c     do a = a1, a2 

         y(e1,b,c) = x(e1,b,c) 

      enddo 
      enddo 
c     enddo 

      go to 100 

      endif 

      write(6,*) ' No indeces were found to strip in strip3 '
      write(6,*) ' Strip = ', strip  
      write(6,*) ' Match(i) = ', (match(i), i=1,3)  
      call abort_job() 

100   continue 

      return
      end


      subroutine do_istrip2(x, sindex, a1, a2, b1, b2, 
     *                      y, findex, e1, e2, f1, f2,   
     *                      nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual stripping. Only ONE index can be 
c  stripped and the arrays must be 4-D.   
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2
      integer e1,e2,f1,f2
      integer sindex(mx_array_index), findex(mx_array_index), 
     *        match(mx_array_index) 

      integer i, j, k, a, b, c, d 
      integer m, n, lda, ldb, ldc 
      integer nsend, strip  

      double precision x(a1:a2,b1:b2)
      double precision y(e1:e2,f1:f2)

      nsend = (e2-e1+1)*(f2-f1+1) 

c *********************************************************************************** 
c     Find the nonmatching indeces and make sure that array2 has simple indeces 
c     in those locations. 
c *********************************************************************************** 

      do i = 1, 2 
         if (sindex(i) .ne. findex(i)) then 
             if (i .eq. 1) match(i) = e1 
             if (i .eq. 2) match(i) = f1 
             strip = i 
         else 
             match(i) = 0 
         endif 
      enddo 

c *********************************************************************************** 
c     The Second index stripped 
c *********************************************************************************** 

      if ((strip .eq. 2) .and. (f1 .ge. b1) .and. (f1 .le. b2)) then 

      do a = a1, a2 

         y(a,f1) = x(a,f1) 

      enddo 

      go to 100 

      endif 

c *********************************************************************************** 
c     The first index stripped 
c *********************************************************************************** 

      if ((strip .eq. 1) .and. (e1 .ge. a1) .and. (e1 .le. a2)) then 

      do b = b1, b2 

         y(e1,b) = x(e1,b) 

      enddo 

      go to 100 

      endif 

      write(6,*) ' No indeces were found to strip in strip3 '
      write(6,*) ' Strip = ', strip  
      write(6,*) ' Match(i) = ', (match(i), i=1,3)  
      call abort_job() 

100   continue 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C THIS ROUTINE SETS ALL VALUES IN A VECTOR A TO ZERO IF
C THEY ARE BELOW A SPECIFIED TOLERANCE (TOL).

      SUBROUTINE FILTER(A,LENGTH,TOL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LENGTH)
      if (length.lt.1) return
      DO I = 1, LENGTH
         X = ABS(A(I))
         IF (X.LT.TOL) A(I) = 0.0
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__XYZ_SET_AB
     +
     +                    ( NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      EXP1,EXP2,
     +                      CC1,CC2,
     +                      SPHERIC,
     +
     +                            NCGTOA,NCGTOB,
     +                            NPGTOA,NPGTOB,
     +                            SHELLA,SHELLB,SHELLP,
     +                            MXSHELL,
     +                            XA,YA,ZA,XB,YB,ZB,
     +                            ATOMIC,EQUALAB,
     +                            ABX,ABY,ABZ,NABCOOR,RNABSQ,
     +                            SPNORM,
     +                            NXYZA,NXYZB,NXYZET,NXYZP,
     +                            NRYA,NRYB,
     +                            INDEXA,INDEXB,
     +                            SWAP12,SWAPRS,
     +                            LEXPA,LEXPB,
     +                            LCCA,LCCB,
     +                            LCCSEGA,LCCSEGB,
     +                            NXYZHRR,NCOLHRR,NROTHRR,
     +                            EMPTY )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_SET_AB
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the logistics on how to evaluate
C                the (1|2) overlap integral batch in the most efficient
C                way. It performs the label map:
C
C                                (1|2) --> (A|B)
C
C                according to certain criteria that have to be met for
C                efficiency. The freedom we have in making the internal
C                association 1,2 -> A,B follows from the 2-fold
C                permutational symmetry of the moment integrals in
C                (1|2):
C
C                                 (1|2) = (2|1)
C
C                If the 1 <-> 2 switch has to be applied is simply
C                governed by the demand that the final A and B shell
C                labels have to obey the relation A>=B, since this means
C                the least amount of work (# of steps) for the HRR
C                procedure.
C
C
C                  Input (x = 1 and 2):
C
C                   NCGTOx        =  # of contractions for csh x
C                   NPGTOx        =  # of primitives per contraction
C                                    for csh x
C                   SHELLx        =  the shell type for csh x
C                   Xy,Yy,Zy      =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                   EXPx          =  primitive exponents for csh x
C                   CCx           =  contraction coeffs for csh x
C                   SPHERIC       =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output (x = A and B):
C
C                   NCGTOx        =  # of contractions for csh x
C                   NPGTOx        =  # of primitives per contraction
C                                    for csh x
C                   SHELLx        =  the shell type for csh x
C                   SHELLP        =  the shell sum A+B
C                   MXSHELL       =  the largest (maximum) shell type
C                   Xy,Yy,Zy      =  the x,y,z-coordinates for centers
C                                    y = A and B
C                   ATOMIC        =  indicates, if purely atomic
C                                    integrals will be evaluated
C                   EQUALAB       =  indicates, if csh x and csh y are
C                                    considered to be equal for the
C                                    pair AB
C                   ABX,ABY,ABZ   =  the x,y,z-coordinate differences
C                                    between centers A and B
C                   NABCOOR       =  # of non-zero x,y,z-coordinate
C                                    differences between centers A and B
C                   RNABSQ        =  square of the magnitude of the
C                                    distance between centers A and B
C                   SPNORM        =  normalization factor due to
C                                    presence of s- and p-type shells.
C                                    For each s-type shell there is a
C                                    factor of 1 and for each p-type
C                                    shell a factor of 2
C                   NXYZx         =  # of cartesian monomials for csh x
C                   NXYZET        =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    E = A,...,A+B
C                   NXYZP         =  # of cartesian monomials for
C                                    the largest P = A+B shell
C                   NRYx          =  # of spherical functions for csh x
C                   INDEXx        =  index A,B -> 1,2 map
C                   SWAP12        =  is .true., if a swap 1 <-> 2 has
C                                    been performed
C                   SWAPRS        =  is set .true. if the contraction
C                                    order of the primitives pair AB
C                                    will be performed in reverse order
C                                    BA for efficiency reasons
C                   LEXPx         =  pointers to locate appropriate
C                                    section of the exponent array
C                                    corresponding to csh x
C                   LCCx          =  pointers to locate appropriate
C                                    section of the contraction coeff
C                                    array corresponding to csh x
C                   LCCSEGx       =  pointers to locate appropriate
C                                    section of the lowest and highest
C                                    primitive index array defining
C                                    segmented contraction boundaries
C                                    for csh x
C                   NXYZHRR       =  maximum dimension of cartesian and
C                                    spherical components during the
C                                    entire HRR contraction procedure
C                   NCOLHRR       =  maximum # of HRR rotation matrix
C                                    columns needed to generate the
C                                    final HRR rotation matrix
C                   NROTHRR       =  maximum # of HRR rotation matrix
C                                    elements needed to generate the
C                                    final HRR rotation matrix
C                   EMPTY         =  logical flag, indicating if an
C                                    empty batch of integrals is
C                                    expected.
C
C
C  AUTHOR      : Norbert Flocke
C                  - Wrote original OED package
C
C  MODIFIED    : Thomas Watson Jr.                   p  q  r
C                  - Modified OED package to handle X, Y, Z integrals
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     CASE1,CASE2
         LOGICAL     EMPTY
         LOGICAL     EQUALAB
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAPRS

         INTEGER     I,J,M
         INTEGER     INDEXA,INDEXB
         INTEGER     LCCSEGA,LCCSEGB
         INTEGER     LCCA,LCCB
         INTEGER     LEXPA,LEXPB
         INTEGER     MXSHELL
         INTEGER     NABCOOR
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NCGTOA,NCGTOB
         INTEGER     NGH,NGHO
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NROW,NCOL,NROT
         INTEGER     NRYA,NRYB
         INTEGER     NXYZA,NXYZB,NXYZET,NXYZP
         INTEGER     NXYZG,NXYZH,NXYZI,NXYZGO,NXYZHO
         INTEGER     NXYZHRR,NCOLHRR,NROTHRR
         INTEGER     SHELL1,SHELL2
         INTEGER     SHELLA,SHELLB
         INTEGER     SHELLG,SHELLH
         INTEGER     SHELLP

         INTEGER     ADD (0:2)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  RNABSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  EXP1 (1:NPGTO1)
         DOUBLE PRECISION  EXP2 (1:NPGTO2)

         DOUBLE PRECISION  CC1 (1:NPGTO1,1:NCGTO1)
         DOUBLE PRECISION  CC2 (1:NPGTO2,1:NCGTO2)

         DATA  ADD    /0,0,1/

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (ONE     =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...generate all 1,2 data.
C
C
         EMPTY  = .FALSE.
         ATOMIC = (X1.EQ.X2) .AND. (Y1.EQ.Y2) .AND. (Z1.EQ.Z2)
         SHELLP = SHELL1 + SHELL2

         MXSHELL = MAX (SHELL1,SHELL2)
C
C
C             ...determine csh equality between centers 1 and 2
C                in increasing order of complexity:
C
C                 centers -> shells -> exponents -> ctr coefficients
C
C
         EQUALAB = ATOMIC

         IF (EQUALAB) THEN
             EQUALAB =     (SHELL1 .EQ. SHELL2)
     +               .AND. (NPGTO1 .EQ. NPGTO2)
     +               .AND. (NCGTO1 .EQ. NCGTO2)
             IF (EQUALAB) THEN
               DO I = 1,NPGTO1
                  EQUALAB = EQUALAB .AND. (EXP1(I).EQ.EXP2(I))
               END DO
               IF (EQUALAB) THEN
                 DO J = 1,NCGTO1
                    IF (EQUALAB) THEN
                      DO I = 1,NPGTO1
                         EQUALAB = EQUALAB .AND. (CC1(I,J).EQ.CC2(I,J))
                      END DO
                    END IF
                 END DO
               END IF
             END IF
         END IF
C
C
C             ...decide on the 1 <-> 2 swapping.
C
C
         SWAP12 = SHELL1 .LT. SHELL2
C
C
C             ...according to the previously gathered info, set the
C                new A,B shells, # of primitives + contraction coeffs
C                as well as pointers to the alpha exponents and
C                contraction coefficients. Also set the info for
C                evaluation of the [e|0] overlap batches and for the
C                HRR steps later on.
C
C
         IF (.NOT.SWAP12) THEN
             XA = X1
             YA = Y1
             ZA = Z1
             XB = X2
             YB = Y2
             ZB = Z2
             SHELLA = SHELL1
             SHELLB = SHELL2
             NPGTOA = NPGTO1
             NPGTOB = NPGTO2
             NCGTOA = NCGTO1
             NCGTOB = NCGTO2
             INDEXA = 1
             INDEXB = 2
             LEXPA = 1
             LEXPB = LEXPA + NPGTO1
             LCCA = 1
             LCCB = LCCA + NPGTO1 * NCGTO1
             LCCSEGA = 1
             LCCSEGB = LCCSEGA + NCGTO1
         ELSE
             XA = X2
             YA = Y2
             ZA = Z2
             XB = X1
             YB = Y1
             ZB = Z1
             SHELLA = SHELL2
             SHELLB = SHELL1
             NPGTOA = NPGTO2
             NPGTOB = NPGTO1
             NCGTOA = NCGTO2
             NCGTOB = NCGTO1
             INDEXA = 2
             INDEXB = 1
             LEXPB = 1
             LEXPA = LEXPB + NPGTO1
             LCCB = 1
             LCCA = LCCB + NPGTO1 * NCGTO1
             LCCSEGB = 1
             LCCSEGA = LCCSEGB + NCGTO1
         END IF
C
C
C             ...the new A and B shells are set. Calculate the
C                following info:
C
C                1) control variable to determine contraction order
C                2) cartesian monomial dimensions
C                3) cartesian monomial dimensions for shell sums
C                4) spherical dimensions (= cartesian, if no spherical)
C                5) the overall norm factor due to s- or p-type shells
C                6) the maximum size of the cartesian HRR part
C
C
         SWAPRS = NPGTOA .GT. NPGTOB

         NXYZA  = (SHELLA+1)*(SHELLA+2)/2
         NXYZB  = (SHELLB+1)*(SHELLB+2)/2
         NXYZP  = (SHELLP+1)*(SHELLP+2)/2
         NXYZET =   ((SHELLP+1)*(SHELLP+2)*(SHELLP+3)/6)
     +            - ((SHELLA  )*(SHELLA+1)*(SHELLA+2)/6)

         NRYA = SHELLA + SHELLA + 1
         NRYB = SHELLB + SHELLB + 1

         IF (.NOT.SPHERIC) THEN
             NRYA = NXYZA
             NRYB = NXYZB
         END IF

         SPNORM = ONE
         IF (SHELLA.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELLB.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF

         NXYZHRR = NXYZA * NXYZB
C
C
C             ...calculate the coordinate differences between centers
C                A and B and calculate the square of the magnitude
C                of the distance between A and B. Also determine the
C                number of non-zero coordinate differences for the
C                pair A,B.
C
C
         IF (.NOT.ATOMIC) THEN
             ABX = XA - XB
             ABY = YA - YB
             ABZ = ZA - ZB
             RNABSQ = ABX * ABX + ABY * ABY + ABZ * ABZ
             NABCOOR = 3
             IF (DABS(ABX).EQ.ZERO) NABCOOR = NABCOOR - 1
             IF (DABS(ABY).EQ.ZERO) NABCOOR = NABCOOR - 1
             IF (DABS(ABZ).EQ.ZERO) NABCOOR = NABCOOR - 1
         ELSE
             ABX = ZERO
             ABY = ZERO
             ABZ = ZERO
             RNABSQ = ZERO
             NABCOOR = 0
         END IF
C
C
C             ...if HRR contractions are to be performed, calculate
C                NCOLHRR (maximum # of HRR rotation matrix columns
C                needed to generate the final HRR rotation matrices) and
C                NROTHRR (maximum # of HRR rotation matrix elements).
C
C
         NCOLHRR = 0
         NROTHRR = 0

         IF (SHELLB.NE.0) THEN

             NGH = NXYZET
             NXYZG = NXYZET
             NXYZH = 1
             NXYZGO = NXYZET
             NXYZHO = 1
             NXYZI = NXYZP
             SHELLG = SHELLP
             NROW = 1
             NCOL = NGH
             NROT = NGH

             DO 100 SHELLH = 1,SHELLB
                NXYZGO = NXYZGO - NXYZI
                NXYZHO = NXYZHO + SHELLH + 1
                NGHO = NXYZGO * NXYZHO

                IF (NABCOOR.EQ.3) THEN
                    M = 1 + SHELLH/3
                    NROW = NROW +  M*(M + ADD (MOD(SHELLH,3)))
                ELSE IF (NABCOOR.EQ.2) THEN
                    NROW = NROW + SHELLH/2 + 1
                ELSE IF (NABCOOR.EQ.1) THEN
                    NROW = NROW + 1
                END IF

                NCOL = MAX0 (NGHO,NCOL)
                NROT = MAX0 (NROW*NGHO,NROT)

                NGH = NGHO
                NXYZG = NXYZGO
                NXYZH = NXYZHO
                NXYZI = NXYZI - SHELLG - 1
                SHELLG = SHELLG - 1
  100        CONTINUE

             NCOLHRR = NCOL
             NROTHRR = NROT

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE GEN_NEW_RIC(CARTCOORD, REDUNCO, IATOMICNMBER, 
     &                       NRATMS, TOTNOFBND, NW_TOTREDNCO, 
     &                       TOTNOFANG, TEST_4CHANGE)
C
C Generate the redundent internal coordinates. 
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


C 
      PARAMETER(THRESHOLD = 5.0D00, EPSILON = 1.0D-10)
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH,
     &        FRAGSCR
      LOGICAL TEST_4CHANGE
C
C The following arrays need to be managed dynamically:
C
C BNDLENGTHS: Keep the bond lengths of atom pairs. It is
C             of length MXATMS*MXATMS
C IATOMICNMBER: Keep the atomic numbers of all atoms and
C               it is MAXATMS long.
C SMOFCOVRAD: The sum of covalent radius of pairs of atoms
C             and of MXATMS*MXATMS long.
C NCONPRCNTR: The number of connectivities for an atom. The
C             maximum number is set to 10, so this is a
C             rather small (it is not currently being
C             used, but needs in the future).
C
      DIMENSION CARTCOORD(3*MXATMS), BNDLENTHS(MXATMS, MXATMS), 
     &          IATOMICNMBER(MXATMS), SMOFCOVRADI(MXATMS, MXATMS),
     &          IBNDTO(MXATMS*MXATMS), NCONPRCNTR(MXATMS),
     &          IREDUNCO(4, MAXREDUNCO), 
     &          REDUNCO(MAXREDUNCO), MARK_FRAGMENTS(MXATMS, MXATMS),       
     &          LENGTH_FRAGEMENTS(MXATMS), VECBA(3), VECBC(3), 
     &          VECBAD(3), VECCB(3), VECAB(3), VECCD(3), VECABC(3),
     &          VECBCD(3),
     &          FRAGSCR(MXATMS*MXATMS),BLNGT_IJFRGS(MXATMS)
C      
      DATA  IZERO, MONE, ZERO /0, -1, 0.0D0/
C
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0 
      PI     = (ATAN(DFLOAT(1))*DFLOAT(4))
C
      NW_TOTREDNCO = IZERO
      BHORTOANG    = 0.529177249D0
C
      CALL GETREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)
      CALL GETREC(20, 'JOBARC', 'CONTEVIT', 4*TOTREDNCO,
     &            IREDUNCO)   
      CALL GETREC(20, 'JOBARC', 'TNUMOBND', 1, TOTNOFBND)
      CALL GETREC(20, 'JOBARC', 'TNUMOANG', 1, TOTNOFANG)
      CALL GETREC(20, 'JOBARC', 'TNUMODIH', 1, TOTNOFDIH)
      CALL GETREC(20, 'JOBARC', 'IBONDTO ', NRATMS*NRATMS,
     &            IBNDTO)
C
      Print*, "The redundent internal coordinates assignments"
      Write(6,*)
      Do i = 1, TOTREDNCO
         Write(6,111) (iredunco(j, i), j=1, 4)
      Enddo
C
C Assign bond coordiante
C

      DO IBNDS = 1, TOTNOFBND
         IF (IREDUNCO(2, IBNDS) .NE. 0) THEN
            ICON1  = IREDUNCO(1, IBNDS)
            ICON2  = IREDUNCO(2, IBNDS)
            DISTAB = DIST(CARTCOORD(3*ICON1 - 2), 
     &               CARTCOORD(3*ICON2 - 2))
            REDUNCO(IBNDS) = DISTAB
C     
            WRITE(6,"(a,F10.5)") "The bond distance =",DISTAB*0.529177249d0
         ENDIF
      ENDDO
C
C Assign bond angle Coordinates.
C
      DO IANGS = (TOTNOFBND + 1), (TOTNOFANG + TOTNOFBND)
     
         IF (IREDUNCO(4, IANGS) .EQ. MONE) THEN
C
C This is for linear arrangements (two angle coordinates are
C required). 
C
            REDUNCO(IANGS) = 180.0D0*DINVPI
            WRITE(6,"(a,F10.5)") "The Bond Angle =", ANGL/DINVPI
C
         ELSE
C
C This is for the non-linear arrangements.
C
            ICON1  = IREDUNCO(1, IANGS)
            ICON2  = IREDUNCO(2, IANGS)  
            ICON3  = IREDUNCO(3, IANGS)
            CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2),
     &               VECBC, 1)
            CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON1 - 2),
     &               VECBA, 1)
            ANGL    = ANGLE(VECBC, VECBA, 3)*DINVPI
            REDUNCO(IANGS) = ANGL
            WRITE(6,"(a,F10.5)") "The Bond Angle =", ANGL/DINVPI
         ENDIF
C
      ENDDO
C
C Assign bond dihedral angle Coordinates.
C
      DO IDIHS = (TOTNOFANG + TOTNOFBND + 1),  TOTREDNCO
         ICON1  = IREDUNCO(1, IDIHS)
         ICON2  = IREDUNCO(2, IDIHS)
         ICON3  = IREDUNCO(3, IDIHS)
         ICON4  = IREDUNCO(4, IDIHS)
         CALL VEC(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2),
     &         VECAB, 1)
         CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2),
     &         VECBC, 1)
         CALL VEC(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2),
     &         VECCB, 1)
         CALL VEC(CARTCOORD(3*ICON4 - 2), CARTCOORD(3*ICON3 - 2),
     &         VECCD, 1)
C
         DISTAB = DIST(CARTCOORD(3*ICON1 - 2), 
     &            CARTCOORD(3*ICON2 - 2))
         DISTBC = DIST(CARTCOORD(3*ICON3 - 2), 
     &            CARTCOORD(3*ICON2 - 2))
         DISTCD = DIST(CARTCOORD(3*ICON3 - 2), 
     &            CARTCOORD(3*ICON4 - 2))
C
C First evaluate the dihedral angle. This is calculated as the
C angle between the two unit vectors that are perpendicular to
C the ABC and BCD planes for A-B-C-D pattern.
C
         CALL CROSS(VECAB, VECBC, VECABC, 1)
C
C We need the vector CD, obtain that from vec DC (note the misnomar)
C
         CALL DSCAL(3, -1.0D0, VECCD, 1)
         CALL CROSS(VECBC, VECCD, VECBCD, 1)
C
         DANG = (ANGLE(VECABC, VECBCD, 3))*DINVPI
C
C--- Obtainig the sign of the dihedral angle:
C
         CALL DSCAL(3, -1.0D0, VECCD, 1)
         CALL CROSS(VECCD, VECCB, VECBCD, 0)
C
         SENSE = DDOT(3, VECAB, 1, VECBCD, 1)

         IF (SENSE .GT. 0.0D0) DANG = -DANG
         REDUNCO(IDIHS) = DANG
         
C
C
      ENDDO 
C
      IF (.NOT. TEST_4CHANGE) THEN
          NW_TOTREDNCO = TOTREDNCO
          RETURN
      ENDIF
C
C Assign new set of redundent internal coordiantes to check whether
C the number of redundent internal coordiantes are changing.
C
      CALL ASIGN_CNTVTES(CARTCOORD, BNDLENTHS, IATOMICNMBER,
     &                   SMOFCOVRADI, NCONPRCNTR, IBNDTO, MAXCNTVS,
     &                   NRATMS, MARK_FRAGMENTS, LENGTH_FRAGEMENTS,
     &                   FRAGSCR, BLNGT_IJFRGS)
      Print*, "Entering assign bonds"
      Write(6,*)
      CALL ASSIGN_BONDS(IBNDTO, IREDUNCO, NW_TOTREDNCO, TOTNOFBND,
     &                  NRATMS, MAXREDUNCO)
      Print*, "Entering assign angles"
      Print*, "Total # of bonds:", TOTNOFBND
      CALL ASSIGN_ANGLS(CARTCOORD, IBNDTO, IREDUNCO, NW_TOTREDNCO,
     &                  TOTNOFBND, TOTNOFANG, NRATMS, MAXREDUNCO,
     &                  THRESHOLD)
      Print*, "Entering assign dihedral angles"
      Print*, "Total # of Angles:", TOTNOFANG
      CALL ASSIGN_DIHLS(IBNDTO, IREDUNCO, NW_TOTREDNCO, TOTNOFBND,
     &                  TOTNOFANG, NRATMS, TOTNOFDIH, MAXREDUNCO)

      Write(6,*)
      Print*, "Total # of dihedrals:", TOTNOFDIH
      Print*, "The total redundent internal", TOTREDNCO
      Write(6,*)
      Print*, "The redundent internal coordinates assignments"
      Write(6,*)
      Do i = 1, TOTREDNCO
         Write(6,111) (iredunco(j, i), j=1, 4)
      Enddo
 111  Format(5X, 4(I3, 1X))
      IF (NW_TOTREDNCO .NE. TOTREDNCO) THEN
          Write(6,*) 
          Write(6,"(1x,a,a,a,a)")"The total number of redundent ",
     &                           "internals have changed during ", 
     &                           "the optimization, please start ",
     &                           "from the following coords (Angs.)"
C
          IOFF = 1
          DO I =1, NRATMS
             WRITE(6,100)ZSYM(I)(1:2),(BHORTOANG*CARTCOORD(J),
     &                                 J=IOFF,IOFF+2)
             IOFF=IOFF+3
          END DO


         CALL ERREX
      ENDIF 
 100  FORMAT(T6,A,T10,F14.8,T25,F14.8,T40,F14.8)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE WRITE_WARN_LOG(WARN_STRING)
 
      IMPLICIT NONE
      CHARACTER*80 WARN_STRING
      INTEGER IUNIT

      PARAMETER(IUNIT=10)

      OPEN(UNIT=IUNIT, FILE='WARN.LOG', FORM='FORMATTED')
     
      IF (WARN_STRING .EQ. 'INVALID SUBGROUP') THEN
          WRITE(IUNIT) 'Warning:'
      ENDIF
   
      CLOSE (IUNIT) 
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_integrals_wrapper(bval, eval, nind, x)
c-----------------------------------------------------------------------------
c   Wrapper routine to provide an interface for C and C++ code to 
c   use the "compute_integrals" subroutine.
c-----------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer nind
      integer bval(nind), eval(nind)
      double precision x(*)

      integer i, nsend, maxblk
      integer*8 integral_scr
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif

      if (nind .ne. 4) then
         print *,'Error: compute_integrals_wrapper called with ',
     *       'an incorrect number of indices: ',nind
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      if (intpkg .eq. flocke_package) then
         integral_scr = dpkgscr
         maxblk  = zmax
      endif

      call compute_integrals(bval(1),eval(1), bval(2),eval(2),
     *                       bval(3),eval(3),bval(4),eval(4),
     *                 dbuf(integral_scr),maxblk, ibuf(ipkgscr),
     *                 dbuf(icoord),dbuf(ipcoeff),dbuf(ialpha),
     *                 ibuf(iccbeg), ibuf(iccend),
     *                 x, nsend)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine commit_checkpoint(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'dbugcom.h'
      include 'checkpoint_data.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, ierr
      integer company_comm, pst_get_company_comm
      integer pst_get_company
      integer request(10000)
      integer statuses(MPI_STATUS_SIZE,10000)
      integer niocompany
      integer msg(5)
      logical search

      character*40 ckpt_msg

      if (.not. mpi_io_support) return  

c--------------------------------------------------------------------------
c   Convert the free space candidates to actual free space entries.
c--------------------------------------------------------------------------

      search = .true. 
      do i = 1, nfree_space_candidates

c--------------------------------------------------------------------------
c   Find a free space entry that has been marked for use.
c--------------------------------------------------------------------------

         if (search) then
            do j = 1, nfree_space
               if (free_space(j) .lt. 0) then
                  free_space(j) = free_space_candidates(i)
                  free_space_sizes(j) = candidate_sizes(i)
                  go to 100
               endif
            enddo
         endif
 
c---------------------------------------------------------------------------
c   No free space entry was found.  Add to the free space list.
c---------------------------------------------------------------------------

         nfree_space = nfree_space + 1
         free_space(nfree_space) = free_space_candidates(i)
         free_space_sizes(nfree_space) = candidate_sizes(i) 
         search = .false.
  100    continue
      enddo

      nfree_space_candidates = 0

      if (me .eq. 0) then

c--------------------------------------------------------------------------
c   Send commit signals to each server.
c--------------------------------------------------------------------------

         msg(1) = sip_server_commit_signal
         msg(2) = 0
         msg(3) = 0
         msg(4) = current_line   ! in the "tag" field of the msg.
         niocompany = 0
         do i = 1, nprocs
            if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Send the checkpoint message.
c---------------------------------------------------------------------------

               niocompany = niocompany + 1
               call mpi_isend(msg, 4,
     *            MPI_INTEGER, i-1,
     *            sip_server_message, mpi_comm_world,
     *            request(niocompany), ierr)
            endif
         enddo

c--------------------------------------------------------------------------
c   Write the master restart data to the master checkpoint file.
c--------------------------------------------------------------------------

         call write_master_checkpoint_data(scalar_table,
     *                   nscalar_table, index_table, nindex_table) 

c--------------------------------------------------------------------------
c   Wait on server requests to complete.
c--------------------------------------------------------------------------

         if (niocompany .gt. 0) then
            call mpi_waitall(niocompany, request, statuses, ierr)

c--------------------------------------------------------------------------
c   Post a recv for each server's acknowledgement signal.
c--------------------------------------------------------------------------

            niocompany = 0
            do i = 1, nprocs
               if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Receive the "checkpoint complete" message.
c   Each server will send a 1-word indicator message using the
c   sip_server_checkpoint_signal as the message tag.
c---------------------------------------------------------------------------

                  niocompany = niocompany + 1
                  call mpi_irecv(msg, 1,
     *               MPI_INTEGER, i-1,
     *               sip_server_commit_signal, mpi_comm_world,
     *               request(niocompany), ierr)
               endif
            enddo

c-----------------------------------------------------------------------
c   Wait for all the acknowledgement messages.
c------------------------------------------------------------------------

            call mpi_waitall(niocompany, request, statuses,
     *                    ierr)
         endif   ! niocompany .gt. 0
      endif   ! me .eq. 0

c--------------------------------------------------------------------------
c   Non-master members of the worker company must wait at this barrier
c   until the master arrives.
c--------------------------------------------------------------------------

      company_comm = pst_get_company_comm(me) 
      call mpi_barrier(company_comm, ierr)
      if (dbg) then
         print *,'Task ',me,' Passed checkpoint worker barrier'
         call c_flush_stdout()
      endif

      return
      end

C THIS SUBROUTINE RETURNS THE MATRIX OPERATIONS FOR A GIVEN
C POINT GROUP. THE CANONICAL ORIENTATIONS USED BY JODA ARE
C ASSUMED IN ALL CASES. ALL MATRIX OPERATIONS ARE RETURNED IN
C VECTOR SCR. CURRENTLY CODED FOR ALL GROUPS EXCEPT O, Oh, Th, T, AND I.
C Ih AND Td ARE IN HERE, AND THEY WORK.

      SUBROUTINE CHRTAB(PTGRP,IORDGP,NORDER,OPRTYP,OPRORD,OPRTIM,
     &                  OPRAXS,NUMCLS,NCLASS,CLSTYP,SCR)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      CHARACTER*4 PTGRP
      CHARACTER*1 OPRTYP(IORDGP)
      INTEGER OPRTIM(IORDGP),NUMCLS(IORDGP),OPRORD(IORDGP)
      INTEGER OPRAXS(IORDGP),TOCK,CLSTYP(IORDGP)
      CHARACTER*4 JUNCHR,JUNCHR2,CMPGRP
#include "io_units.par"
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON/PTGP_COM/JUNCHR,JUNCHR2,CMPGRP
 
      DIMENSION SCR(9*IORDGP),SCR1(27),SCR2(9)
      IP(I)=1+9*(I-1)
C
      IL=linblnk(PTGRP)
C
C HANDLE GENERAL GROUP TYPES (CN,DN,CNV,CNH,DNH,DND,SN) FIRST.  THIS
C CAN BE DONE IN A GENERAL WAY.
C
      NORDR2=NORDER/2
      NEQ=(NORDER/2)-1
      IF(MOD(NORDER,2).EQ.1)NEQ=NORDER-1
      JI = 0
      JX=0
      NTIME=0
      IERR=0
C
C        ************ CN  GROUPS **********
C
      IF(NORDER.GT.1.AND.PTGRP(1:1).EQ.'C'
     &.AND.PTGRP(IL:IL).NE.'h'
     &.AND.PTGRP(IL:IL).NE.'v')THEN
       IORD=NORDER
       NCLASS=IORD
       DO 10 I=1,NCLASS
        OPRTYP(I)='C'
        OPRORD(I)=NORDER
        OPRTIM(I)=I
        OPRAXS(I)=3
        NUMCLS(I)=1
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(I)=I
 10    CONTINUE
C
C        ********** DN  GROUPS **********
C
      ELSEIF(PTGRP(1:1).EQ.'D'
     &.AND.PTGRP(IL:IL).NE.'h'
     &.AND.PTGRP(IL:IL).NE.'d')THEN
       IORD=NORDER*2
       NCLASS=NORDR2+3-MOD(NORDER,2)
       DO 11 I=1,NORDR2
        JX=JX+1
        OPRTYP(I)='C'
        OPRORD(I)=NORDER
        OPRTIM(I)=I
        OPRAXS(I)=3
        NUMCLS(I)=2
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &         3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
        IF(I.EQ.NORDR2.AND.MOD(NORDER,2).EQ.0)THEN
         NUMCLS(I)=1
        ELSE
         CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
         CLSTYP(NTIME+1)=JX
         NTIME=NTIME+1
        ENDIF
  11   CONTINUE
C
C PERPENDICULAR C2 S.  THIS IS DIFFERENT FOR NORDER ODD AND EVEN AND
C  IS A REAL PAIN FOR N EVEN.  DO C2' (THE ONE WHICH LIES ALONG X IN
C  THE CANONICAL ORIENTATION) FOR BOTH ODD AND EVEN FIRST.
C
       JX=JX+1
       OPRTYP(JX)='C'
       OPRORD(JX)=2
       OPRTIM(JX)=1
       OPRAXS(JX)=1
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &             3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(NTIME)=JX
C
C GENERATE THE OTHER N-1 C2s IF N ODD AND OTHER (N/2)-1 IF N EVEN.
C
       CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
       IF(MOD(NORDER,2).EQ.0)THEN
C
C DO C2'' (NOT ALONG ANY CARTESIAN AXIS EXCEPT FOR D2) FOR N EVEN.
C  CANONICAL AXIS FOR THIS OPERATION IS C(2N;Z) [X].  GET ONE
C  FROM GENDIH AND THEN CRANK OUT THE OTHERS.
C
        CALL GENDIH(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              NUMCLS(JX),NORDER,NTIME,SCR(IP(NTIME+1)))
        CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
        JX=JX+1
        CLSTYP(NTIME)=JX
       ENDIF
       JX=JX+1
       OPRTYP(JX)='E'
       NUMCLS(JX)=1
       CLSTYP(NTIME)=JX
       CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
C
C      ********** SN GROUPS **********
C
      ELSEIF(PTGRP(1:1).EQ.'S')THEN
       IORD=NORDER
       NCLASS=NORDER
       DO 19 I=1,NORDER/2
        JX=JX+1
        OPRTYP(JX)='S'
        OPRORD(JX)=NORDER
        OPRTIM(JX)=2*I-1
        OPRAXS(JX)=3
        NUMCLS(JX)=1
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
 19    CONTINUE
       DO 190 I=1,NORDER/2
        JX=JX+1
        OPRTYP(JX)='C'
        OPRORD(JX)=NORDER/2
        OPRTIM(JX)=I
        OPRAXS(JX)=3
        NUMCLS(JX)=1
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
 190   CONTINUE
C
C    **********  C(nv) GROUPS **********
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.PTGRP(IL:IL).EQ.'v')THEN
       IORD=NORDER
       NCLASS=NORDR2+3-MOD(NORDER,2)
       DO 12 I=1,NORDR2
        JX=JX+1
        OPRTYP(I)='C'
        OPRORD(I)=NORDER
        OPRTIM(I)=I
        OPRAXS(I)=3
        NUMCLS(I)=2
        IF(I.EQ.NORDR2.AND.MOD(NORDER,2).EQ.0)THEN
         NUMCLS(I)=1
         CALL IDNMAT(SCR1,3,NTIME)
         CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &               3,SCR1,SCR(IP(NTIME)),IERR,1)
         CLSTYP(NTIME)=JX
        ELSE
         NUMCLS(I)=2
         CALL IDNMAT(SCR1,3,NTIME)
         CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &               3,SCR1,SCR(IP(NTIME)),IERR,1)
         CLSTYP(NTIME)=JX
         CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=JX
        ENDIF
  12   CONTINUE
C
C PLANES OF SYMMETRY.  AGAIN, DIFFERENT FOR NORDER ODD AND EVEN CASES.
C   FIRST WITH THE SIGMA(V) PLANES (THE XZ PLANE IS ONE OF THESE IN
C   THE CANONICAL ORIENTATION.
C
       JX=JX+1
       OPRTYP(JX)='P'
       OPRAXS(JX)=2
       NUMCLS(JX)=NORDER
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &             3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(NTIME)=JX
C
C GENERATE THE OTHER N-1 SIGMA(V)s IF N ODD AND OTHER (N/2)-1 IF N EVEN.
C
       CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
C
C IF N IS EVEN, THEN GET THE (N/2) SIGMA(D) PLANES.
C
       IF(MOD(NORDER,2).EQ.0)THEN
        NUMCLS(JX)=NORDR2
        CALL GENDIH(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              NUMCLS(JX),NORDER,NTIME,SCR(IP(NTIME+1)))
        JX=JX+1
        IF(NORDER.EQ.2)OPRAXS(JX)=1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
       ENDIF
       JX=JX+1
       OPRTYP(JX)='E'
       NUMCLS(JX)=1
       CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
       CLSTYP(NTIME)=JX
C
C     ********** THE BLESSED C(nh) GROUPS **********
C
      ELSEIF(PTGRP(1:1).EQ.'C'.AND.PTGRP(IL:IL).EQ.'h')THEN
       IORD=2*NORDER
       NCLASS=2*NORDER
       DO 13 I=1,NORDER
        J=I+NORDER
        OPRTYP(I)='C'
        OPRTYP(J)='S'
        OPRTIM(I)=I
        OPRTIM(J)=I
 13    CONTINUE
       DO 130 I=1,NORDER*2
        OPRORD(I)=NORDER
        OPRAXS(I)=3
        NUMCLS(I)=1
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=I
130    CONTINUE
C
C    ********** THE D(nd) GROUPS **********
C
C *NOTE* - FOR THESE GROUPS, THE PERPENDICULAR AND C2 AXES ARE
C           COINCIDENT WITH THE CARTESIAN ORIENTATION.
C
C        - BY FAR, THESE GROUPS ARE THE TOUGHEST TO DEAL WITH.
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.PTGRP(IL:IL).EQ.'d')THEN
       IORD=4*NORDER
       NCLASS=NORDER+3
C
C PURE ROTATIONS.
C
       DO 14 I=1,NORDR2
        JX=JX+1
        OPRTYP(I)='C'
        OPRORD(I)=NORDER
        OPRTIM(I)=I
        OPRAXS(I)=3
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
        IF(I.EQ.NORDR2.AND.MOD(NORDER,2).EQ.0)THEN
         NUMCLS(I)=1
        ELSE
         NUMCLS(I)=2
         CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=JX
        ENDIF
 14    CONTINUE
C
C IMPROPER ROTATIONS.
C
       DO 140 I=1,NORDER,2
        JX=JX+1
        OPRTYP(JX)='S'
        OPRORD(JX)=NORDER*2
        OPRTIM(JX)=I
        OPRAXS(JX)=3
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
        IF(I.NE.NORDER)THEN
         NUMCLS(JX)=2
         CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=JX
        ELSE
         NUMCLS(JX)=1
        ENDIF
140    CONTINUE
C
C PERPENDICULAR C2 AXES, PLANE AND IDENTITY.  THE AXES AND PLANES
C  ARE A LITTLE TRICKY SINCE A C(2N) (RATHER THAN A C(N)) AXIS)
C  MAPS THEM INTO ONE ANOTHER.
C
       JX=NCLASS-2
       OPRTYP(JX)='C'
       OPRORD(JX)=2
       OPRTIM(JX)=1
       OPRAXS(JX)=1
       NUMCLS(JX)=NORDER
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &             3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(NTIME)=JX
C
C GENERATE REST (NORDER-1) OF THE C2 AXES, WHICH ARE RELATED TO THE
C   CANONICAL ONE BY C2N ROTATIONS, USING DIRTY TRICK.
C
       CALL IDNMAT(SCR1,3,NTIME)
       NTIME=NTIME-1
       CALL DOSYOP('C',2*NORDER,1,3,3,SCR1,
     & SCR(IP(NTIME+NORDER)),IERR,1)
       CALL GENRST(NTIME+NORDER,SCR,NTIME,NORDER-1,IORDGP,JX,CLSTYP)
C
C DIHEDRAL SYMMETRY PLANES.  PRETTY TOUGH, SINCE NONE ARE CARTESIAN IN
C   CANONICAL ORIENTATION.  ONE OF THEM CAN BE GENERATED FROM THE XZ PLA
C   BY A C(4N) ROTATION.
C
       JX=NCLASS-1
       OPRTYP(JX)='P'
       OPRAXS(JX)=2
       NUMCLS(JX)=NORDER
       CALL GENDIH(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &             NUMCLS(JX),2*NORDER,NTIME,SCR(IP(NTIME+1)))
       CLSTYP(NTIME)=JX
C
C GENERATE REST OF THE SIGMA (D) PLANES, WHICH ARE RELATED TO THE
C  CANONICAL ONE BY C2N ROTATIONS.  USE DIRTY TRICK IN PASSING THE
C  APPROPRIATE MATRIX TO GENRST.
C
       CALL IDNMAT(SCR1,3,NTIME)
C
C DECREMENT NTIME HERE SINCE IT IS INCREMENTED IN GENRST.
C
       NTIME=NTIME-1
       CALL DOSYOP('C',2*NORDER,1,3,3,SCR1,
     & SCR(IP(NTIME+NORDER)),IERR,1)
       CALL GENRST(NTIME+NORDER,SCR,NTIME,NORDER-1,IORDGP,JX,CLSTYP)
       OPRTYP(NCLASS)='E'
       NUMCLS(NCLASS)=1
       CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
       CLSTYP(NTIME)=NCLASS
C
C  ********** D(nh) GROUPS **********
C
      ELSEIF(PTGRP(1:1).EQ.'D'.AND.PTGRP(IL:IL).EQ.'h')THEN
       IORD=4*NORDER
       NCLASS=NORDER+6-3*MOD(NORDER,2)
C
C PRINCIPAL ROTATIONS AND IMPROPER ROTATIONS.
C
       DO 15 I=1,NORDR2
        JX=JX+1
        OPRTYP(JX)='C'
        OPRTYP(JX+NORDR2)='S'
        OPRTIM(JX)=I
        OPRTIM(JX+NORDR2)=I
        NUMCLS(JX)=2
        NUMCLS(JX+NORDR2)=2
        IF(JX.EQ.NORDR2.AND.MOD(NORDER,2).EQ.0)THEN
         NUMCLS(JX)=1
         NUMCLS(JX+NORDR2)=1
        ENDIF
 15    CONTINUE
       DO 150 I=1,NORDR2*2
        OPRORD(I)=NORDER
        OPRAXS(I)=3
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(I),OPRORD(I),OPRTIM(I),OPRAXS(I),
     &              3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=I
        IF(NUMCLS(I).EQ.2)THEN
         CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=I
        ENDIF
150    CONTINUE
       JX=NORDR2*2
C
C PERPENDICULAR C2' ROTATIONS.  IN THE CANONICAL ORIENTATION, ONE OF
C   THESE IS THE X AXIS.  HANDLE ODD AND EVEN CASES HERE.
C   VERY MUCH LIKE C2v WITH ITS PLANES.
C
       JX=JX+1
       OPRTYP(JX)='C'
       OPRTIM(JX)=1
       OPRAXS(JX)=1
       OPRORD(JX)=2
       NUMCLS(JX)=NORDR2
       IF(MOD(NORDER,2).EQ.1)NUMCLS(JX)=NORDER
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &             3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(NTIME)=JX
C
C GENERATE THE OTHER N-1 (N ODD) OR (N/2)-1 (N EVEN) GUYS.
C
       CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
C
C IF N IS EVEN, THEN GET ONE OF THE C2'' WITH GENDIH AND GENERATE
C  THE OTHERS.
C
       IF(MOD(NORDER,2).EQ.0)THEN
        CALL GENDIH(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              NUMCLS(JX),NORDER,NTIME,SCR(IP(NTIME+1)))
        JX=JX+1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
       ENDIF
C
C VERTICAL AND DIHEDRAL SYMMETRY PLANES (SIGMA (V) AND (D)).  AGAIN,
C  LIKE C(nv) HERE.  ONE SIGMA (V) IS XZ, THE SIGMA (D)s ARE NONCARTESIA
C
       JX=JX+1
       OPRTYP(JX)='P'
       OPRAXS(JX)=2
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),
     &             OPRAXS(JX),3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(NTIME)=JX
C
C GENERATE THE OTHER N-1 (N ODD) OR (N/2)-1 (N EVEN) GUYS.
C
       CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
C
C IF N IS EVEN, THEN GET ONE OF THE SIGMA(D) WITH GENDIH AND GENERATE
C  THE OTHERS.
C
       IF(MOD(NORDER,2).EQ.0)THEN
        CALL GENDIH(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),OPRAXS(JX),
     &              NUMCLS(JX),NORDER,NTIME,SCR(IP(NTIME+1)))
        JX=JX+1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,NEQ,IORDGP,JX,CLSTYP)
       ENDIF
C
C HORIZONTAL PLANE
C
       JX=JX+1
       OPRAXS(JX)=3
       NUMCLS(JX)=1
       OPRTYP(JX)='P'
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),
     &             OPRAXS(JX),3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(NTIME)=JX
       OPRTYP(NCLASS)='E'
       NUMCLS(NCLASS)=1
       CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
       CLSTYP(NTIME)=NCLASS
C
C CUBIC GROUPS::: Td FIRST
C
      ELSEIF(PTGRP.EQ.'T d'.OR.PTGRP.EQ.'T  ')THEN
       JX=0
       JI=0
C
C FIRST DO S4 - USE ORIENTATION WHERE THESE ARE X, Y AND Z.
C
       IF(PTGRP.NE.'T  ')THEN
        JX=JX+1
        OPRTYP(JX)='S'
        OPRORD(JX)=4
        NUMCLS(JX)=6
        OPRTIM(JX)=1
        JI=0
        DO 4000 I=1,3
         IAXIS=I
         DO 4100 J=1,3,2
          ITIMES=J
          JI=JI+1
          CLSTYP(JI)=1
          CALL IDNMAT(SCR1,3,NTIME)
          CALL DOSYOP(OPRTYP(JX),OPRORD(JX),ITIMES,IAXIS,3,
     &             SCR1,SCR(IP(NTIME)),IERR,1)
4100     CONTINUE
4000    CONTINUE
       ENDIF
C
C NOW C2 OPERATIONS.
C
       JX=JX+1
       OPRTYP(JX)='C'
       OPRORD(JX)=2
       NUMCLS(JX)=3
       OPRTIM(JX)=1
       DO 4001 I=1,3
        JI=JI+1
        CLSTYP(JI)=2
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,I,3,SCR1,SCR(IP(NTIME)),
     &            IERR,1)
4001   CONTINUE
C
C NOW C3 CLASS.  THESE ARE RELATED BY THE S4 OPERATION.
C
      JX=JX+1
      OPRTYP(JX)='C'
      OPRORD(JX)=3
      NUMCLS(JX)=8
      OPRTIM(JX)=1
      CALL IDNMAT(SCR1,3,NTIME)
      CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,3,3,SCR1,SCR(IP(NTIME)),
     &IERR,1)
C
C NOW TRANSFORM THIS REFERENCE OPERATION (A C3 ABOUT Z) TO A C3 ABOUT
C  THE (A,A,A) AXIS.
C
      CALL ZERO(SCR2,9)
      DO 4200 I=1,3
       SCR2(I)=DSQRT(3.D0)
4200  CONTINUE
      CALL SIAZ(SCR2,SCR1,3)
      CALL MTRAN2(SCR1,3)
      CALL UNITRY(SCR1,SCR(IP(NTIME)),SCR(IP(NTIME)),3)
      CLSTYP(NTIME)=JX
C
C NOW GENERATE THE OTHER THREE C3 AXES AND C3(1) OPERATIONS WITH THE S4.
C
C  IF THIS IS THE T POINT GROUP, WE DO NOT HAVE THE S4 HANDY SO PUT IT
C   IN HIGHEST POSITION IN VECTOR (WILL EVENTUALLY BE OVERWRITTEN).
C
      IF(PTGRP.EQ.'T d')THEN
       CALL GENRST(1,SCR,NTIME,3,IORDGP,JX,CLSTYP)
      ELSE
       CALL IDNMAT(SCR1,3,NTIME)
       NTIME=NTIME-1
       CALL DOSYOP('S',4,1,3,3,SCR1,SCR2,IERR,1)
       CALL ZERO(SCR(IP(12)),9)
       CALL VADD(SCR(IP(12)),SCR(IP(12)),SCR2,9,1.D0)
       CALL GENRST(12,SCR,NTIME,3,IORDGP,JX,CLSTYP)
      ENDIF
C
C NOW THE C3(2).
C
      CLSTYP(NTIME)=JX
      CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
      NTIME=NTIME+1
      CLSTYP(NTIME)=JX
      IF(PTGRP.EQ.'T d')THEN
       CALL GENRST(1,SCR,NTIME,3,IORDGP,JX,CLSTYP)
      ELSE
       CALL GENRST(12,SCR,NTIME,3,IORDGP,JX,CLSTYP)
      ENDIF
C
C NOW THE PLANES OF SYMMETRY.
C
      IF(PTGRP.EQ.'T d')THEN
       JX=JX+1
       OPRTYP(JX)='P'
       NUMCLS(JX)=6
       CALL IDNMAT(SCR1,3,NTIME)
       CLSTYP(NTIME)=JX
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),1,
     &             3,SCR1,SCR1(10),IERR,1)
C
C NOW TRANSFORM BY ROTATING 45 DEGREES ABOUT Z.
C
       CALL ROTM(3,45.D0,1,SCR1)
       CALL UNITRY(SCR1,SCR1(10),SCR(IP(NTIME)),3)
C
C GENERATE THE OTHERS WITH ONE OF THE OTHER C3 AXES.
C
       CALL GENRST(10,SCR,NTIME,2,IORDGP,JX,CLSTYP)
C
C NOW GET OTHER REFERENCE PLANE.
C
       CALL ROTM(3,-45.D0,1,SCR1)
       CALL UNITRY(SCR1,SCR1(10),SCR(IP(NTIME+1)),3)
       CLSTYP(NTIME+1)=JX
       NTIME=NTIME+1
       CALL GENRST(10,SCR,NTIME,2,IORDGP,JX,CLSTYP)
      ENDIF
C
C NOW THE IDENTITY AND WE'RE DONE.
C
      JX=JX+1
      OPRTYP(JX)='E'
      NUMCLS(JX)=1
      CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
      CLSTYP(NTIME)=JX
      NCLASS=JX
C
C NOW TRANSFORM THIS TO THE "ACES" CANONICAL ORIENTATION -- WHERE
C  XZ AND YZ ARE SYMMETRY PLANES.  ROTATED 45 DEGREES ABOUT Z FROM
C  THIS PARTICULAR ORIENATION.  THIS MUST BE DONE ONLY IF THE
C  COMPUTATIONAL ABELIAN SUBGROUP IS C2v.  IF IT IS D2, THEN THIS
C  SHOULD BE SKIPPED.
C
       IF(PTGRP.EQ.'T d'.AND.CMPGRP.NE.'D2')THEN
        CALL ROTM(3,45.D0,1,SCR1)
        DO 4500 I=1,NTIME
         CALL UNITRY(SCR1,SCR(IP(I)),SCR(IP(I)),3)
4500    CONTINUE
       ENDIF
       GOTO 383
C
C THE DREADED ICOSAHEDRAL GROUP -- BOTH Ih AND I HANDLED HERE.
C
      ELSEIF(PTGRP.EQ.'I h'.OR.PTGRP.EQ.'I  ')THEN
C
C FIRST DO C5, C5(2), S10 and S10(3) - ONE OF THE AXES IS THE Z-AXIS.
C
c       IORDGP=120
       NCLASS=10
       JX=0
       OMEGA=1.D0/DSQRT(5.D0)
       ANGLE1=DACOS(OMEGA)
       ARG2=DSQRT((1-OMEGA)/2)
       ANGLE2=DACOS(ARG2)
       ARG3=DSQRT(12.D0+24.D0*OMEGA)/6.D0
       ANGLE3=DACOS(ARG3)
       CALL ZERO(SCR2,9)
       SCR2(1)=0.D0
       SCR2(2)=2.D0/DSQRT(5.D0)
       SCR2(3)=1.D0/DSQRT(5.D0)
       CALL SIAZ(SCR2,SCR1(10),3)
       CALL MTRAN2(SCR1(10),3)
       DO 3001 IORD=1,2
        OPRTYP(IORD)='C'
        OPRORD(IORD)=5
        OPRTIM(IORD)=IORD
        OPRTYP(IORD+2)='S'
        OPRORD(IORD+2)=10
        OPRTIM(IORD+2)=1+2*(IORD-1)
        IAXIS=3
C
C C5 OPERATIONS
C
        JX=JX+1
        NUMCLS(JX)=12
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(IORD),OPRORD(IORD),OPRTIM(IORD),IAXIS,3,
     &             SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
        CALL UNITRY(SCR1(10),SCR(IP(NTIME)),SCR(IP(NTIME+1)),3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
C
C S10 OPERATIONS
C
        IF(PTGRP.NE.'I  ')THEN
         JX=JX+1
         NUMCLS(JX)=12
         CALL IDNMAT(SCR1,3,NTIME)
         CALL DOSYOP(OPRTYP(IORD+2),OPRORD(IORD+2),OPRTIM(IORD+2),
     &              IAXIS,3,SCR1,SCR(IP(NTIME)),IERR,1)
         CLSTYP(NTIME)=JX
         CALL UNITRY(SCR1(10),SCR(IP(NTIME)),SCR(IP(NTIME+1)),3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=JX
         CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
        ENDIF
3001   CONTINUE
C
C NOW WE HAVE THE C5(1), C5(2), S10(1) AND S10(3) AXES.  GET ALL OF
C  THE C5(4), C5(3), S10(9) AND S10(7) BY TRANSPOSITION.
C
       NTOP=24
       IF(PTGRP.EQ.'I  ')NTOP=12
       DO 1522 I=1,NTOP
        CALL MTRANSP(SCR(IP(I)),SCR(IP(NTOP+I)),3,3,3,3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=CLSTYP(NTIME-NTOP)
1522   CONTINUE
C
C THIS COMPLETES THE FIVEFOLD AND TENFOLD ROTATIONS.  HAVE 48 OF 120
C   OPERATIONS DONE.
C
C
C NOW GO FOR THE C3 AND S6 AXES.
C
       CALL ROTM(1,ANGLE3,0,SCR1(10))
       ANGLE4=DACOS(-1.D0)-ANGLE1-2.D0*ANGLE3
       CALL ROTM(1,ANGLE4,0,SCR1(19))
 
       JX=JX+1
       OPRTYP(JX)='C'
       OPRTIM(JX)=1
       OPRORD(JX)=3
       NUMCLS(JX)=20
       CALL IDNMAT(SCR1,3,NTIME)
       NREF1=NTIME
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,3,3,SCR1,SCR(IP(NTIME)),
     &IERR,1)
       CLSTYP(NTIME)=JX
       CALL UNITRY(SCR1(10),SCR(IP(NREF1)),SCR(IP(NTIME)),3)
       CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
       CALL UNITRY(SCR1(19),SCR(IP(NREF1)),SCR(IP(NTIME+1)),3)
       NTIME=NTIME+1
       CLSTYP(NTIME)=JX
       CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
       DO 4030 I=0,9
        CALL MTRANSP(SCR(IP(NREF1+I)),SCR(IP(NREF1+10+I)),3,3,3,3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=JX
4030   CONTINUE
 
C S OPS
       IF(PTGRP.NE.'I  ')THEN
        JX=JX+1
        OPRTYP(JX)='S'
        OPRORD(JX)=6
        NUMCLS(JX)=20
        OPRTIM(JX)=1
        CALL IDNMAT(SCR1,3,NTIME)
        NREF2=NTIME
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,3,3,SCR1,SCR(IP(NTIME))
     &,IERR,1)
        CALL UNITRY(SCR1(10),SCR(IP(NREF2)),SCR(IP(NTIME)),3)
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
        CALL UNITRY(SCR1(19),SCR(IP(NREF2)),SCR(IP(NTIME+1)),3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
        DO 4033 I=0,9
         CALL MTRANSP(SCR(IP(NREF2+I)),SCR(IP(NREF2+10+I)),3,3,3,3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=JX
4033    CONTINUE
       ENDIF
C
C NOW DO C2
C
       CALL ROTM(1,ANGLE2,0,SCR1(10))
       CALL ROTM(3,72.D0,1,SCR1(19))
       CALL SIAZ(SCR2,SCR1,3)
       CALL MTRAN2(SCR1,3)
       CALL UNITRY(SCR1,SCR1(19),SCR1(19),3)
 
       JX=JX+1
       OPRTYP(JX)='C'
       OPRORD(JX)=2
       NUMCLS(JX)=15
       OPRTIM(JX)=1
       CALL IDNMAT(SCR1,3,NTIME)
       NREF1=NTIME
       CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,3,3,SCR1,SCR(IP(NTIME)),
     & IERR,1)
       CALL UNITRY(SCR1(10),SCR(IP(NREF1)),SCR(IP(NTIME)),3)
       CLSTYP(NTIME)=JX
       CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
       CALL UNITRY(SCR1(19),SCR(IP(NREF1)),SCR(IP(NTIME+1)),3)
       NTIME=NTIME+1
       CLSTYP(NTIME)=JX
       CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
       CALL MODMATMUL(SCR1(10),SCR1(19),SCR1(19),3,3,3,3,3,3)
       CALL UNITRY(SCR1(10),SCR(IP(NREF1)),SCR(IP(NTIME+1)),3)
       NTIME=NTIME+1
       CLSTYP(NTIME)=JX
       CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
C
C NOW DO SYMMETRY PLANES.  WE'RE ALMOST DONE!  THE FIRST ONE IS XY, SO T
C  MAKES THINGS EASY.
C
       IF(PTGRP.NE.'I  ')THEN
        JX=JX+1
        OPRTYP(JX)='P'
        NUMCLS(JX)=15
        CALL IDNMAT(SCR1,3,NTIME)
        NREF1=NTIME
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),1,
     &            3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
        CALL UNITRY(SCR1(10),SCR(IP(NREF1)),SCR(IP(NTIME+1)),3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
        CALL UNITRY(SCR1(19),SCR(IP(NREF1)),SCR(IP(NTIME+1)),3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=JX
        CALL GENRST(1,SCR,NTIME,4,IORDGP,JX,CLSTYP)
C
C  NOW THE INVERSION AND THE IDENTITY AND WE'RE THROUGH!
C
        JX=JX+1
        OPRTYP(JX)='I'
        NUMCLS(JX)=1
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),0,0,0,3,SCR1,SCR(IP(NTIME)),IERR,
     &   1)
        CLSTYP(NTIME)=JX
       ENDIF
       JX=JX+1
       OPRTYP(JX)='E'
       NUMCLS(JX)=1
       CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
       CLSTYP(NTIME)=JX
       GOTO 383
C
C THE NOT-SO DREADED OCTAHEDRAL GROUP -- BOTH Oh AND O HANDLED HERE.
C
      ELSEIF(PTGRP.EQ.'O h'.OR.PTGRP.EQ.'O  '.OR.PTGRP.EQ.'T h')THEN
C
C FIRST DO C4, S4 - ONE OF THE AXES IS THE Z-AXIS.
C
       JX=0
C
C C4 OPERATIONS
C
       IF(PTGRP(1:1).EQ.'O')THEN
        JX=JX+1
        OPRTYP(JX)='C'
        OPRORD(JX)=4
        OPRTIM(JX)=1
        NUMCLS(JX)=6
        DO 8000 IAXS=1,3
         CALL IDNMAT(SCR1,3,NTIME)
         CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),
     &            IAXS,3,SCR1,SCR(IP(NTIME)),IERR,1)
         CLSTYP(NTIME)=JX
8000    CONTINUE
       ENDIF
C
C S4 OPERATIONS
C
       IF(PTGRP.EQ.'O h')THEN
        JX=JX+1
        OPRTYP(JX)='S'
        OPRORD(JX)=4
        OPRTIM(JX)=1
        NUMCLS(JX)=6
        DO 8001 IAXS=1,3
         CALL IDNMAT(SCR1,3,NTIME)
         CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),
     &               IAXS,3,SCR1,SCR(IP(NTIME)),IERR,1)
         CLSTYP(NTIME)=JX
8001    CONTINUE
       ENDIF
C
C SIGMA H PLANES
C
       IF(PTGRP.NE.'O  ')THEN
        JX=JX+1
        OPRTYP(JX)='P'
        OPRORD(JX)=0
        OPRTIM(JX)=0
        NUMCLS(JX)=3
        DO 8002 IAXS=1,3
         CALL IDNMAT(SCR1,3,NTIME)
         CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),
     &               IAXS,3,SCR1,SCR(IP(NTIME)),IERR,1)
         CLSTYP(NTIME)=JX
8002    CONTINUE
       ENDIF
C
C C4(2) OPERATIONS.
C
       JX=JX+1
       OPRTYP(JX)='C'
       OPRORD(JX)=4
       OPRTIM(JX)=2
       NUMCLS(JX)=3
       DO 8003 IAXS=1,3
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),OPRTIM(JX),
     &              IAXS,3,SCR1,SCR(IP(NTIME)),IERR,1)
        CLSTYP(NTIME)=JX
8003   CONTINUE
C
C NOW WE HAVE THE C4(1), S4(1), C4(2) AND REFLECTION PLANES.  GENERATE
C  ALL OF THE C4(3) AND S4(3) BY TRANSPOSITION.
C
       NTOP=6
       NTOP2=12
       IF(PTGRP.EQ.'O  ')THEN
        NTOP=3
        NTOP2=6
       ENDIF
       IF(PTGRP.NE.'T h')THEN
        DO 7522 I=1,NTOP
         CALL MTRANSP(SCR(IP(I)),SCR(IP(NTOP2+I)),3,3,3,3)
         NTIME=NTIME+1
         CLSTYP(NTIME)=CLSTYP(NTIME-NTOP2)
7522    CONTINUE
C
C THIS COMPLETES ALL OF THE OPERATIONS WHICH ARE HAVE AXES COINCIDENT WI
C  THE NATURAL CARTESIAN FRAME.  NOW GO ON TO DO C2 AND THE SIGMA(D) OPS
C
        DO 7001 K=1,2
         CALL ROTM(3,45.D0,1,SCR1(10))
         IF(K.EQ.1)THEN
          JX=JX+1
          OPRTYP(JX)='C'
          OPRTIM(JX)=1
          OPRORD(JX)=2
          NUMCLS(JX)=6
         ELSE
          IF(PTGRP.EQ.'O  ')GOTO 7001
          JX=JX+1
          OPRTYP(JX)='P'
          OPRTIM(JX)=0
          OPRORD(JX)=0
          NUMCLS(JX)=6
         ENDIF
         CALL IDNMAT(SCR1,3,NTIME)
         NREF1=NTIME
         CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,1,3,SCR1,SCR1(19),IERR,1)
         CALL UNITRY(SCR1(10),SCR1(19),SCR(IP(NTIME)),3)
         CLSTYP(NTIME)=JX
         NTIME=NTIME+1
         CALL MTRAN2(SCR1(10),3)
         CALL UNITRY(SCR1(10),SCR1(19),SCR(IP(NTIME)),3)
         CLSTYP(NTIME)=JX
         NTIME=NTIME+1
         CALL ROTM(2,45.D0,1,SCR1(10))
         NREF1=NTIME
         CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,1,3,SCR1,SCR1(19),IERR,1)
         CALL UNITRY(SCR1(10),SCR1(19),SCR(IP(NTIME)),3)
         CLSTYP(NTIME)=JX
         NTIME=NTIME+1
         CALL MTRAN2(SCR1(10),3)
         CALL UNITRY(SCR1(10),SCR1(19),SCR(IP(NTIME)),3)
         CLSTYP(NTIME)=JX
         NTIME=NTIME+1
         CALL ROTM(1,45.D0,1,SCR1(10))
         NREF1=NTIME
         CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,2,3,SCR1,SCR1(19),IERR,1)
         CALL UNITRY(SCR1(10),SCR1(19),SCR(IP(NTIME)),3)
         CLSTYP(NTIME)=JX
         NTIME=NTIME+1
         CALL MTRAN2(SCR1(10),3)
         CALL UNITRY(SCR1(10),SCR1(19),SCR(IP(NTIME)),3)
         CLSTYP(NTIME)=JX
7001    CONTINUE
       ENDIF
C
C
C NOW DEAL WITH THE C3 AND S6 OPS.  THE ONLY TRICKY BITS.
C
       DO 7003 K=1,2
        IF(K.EQ.1)THEN
         JX=JX+1
         OPRTYP(JX)='C'
         OPRORD(JX)=3
         NUMCLS(JX)=8
         OPRTIM(JX)=1
        ELSE
         IF(PTGRP.EQ.'O  ')GOTO 7003
         JX=JX+1
         OPRTYP(JX)='S'
         OPRORD(JX)=6
         NUMCLS(JX)=8
         OPRTIM(JX)=1
        ENDIF
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),OPRORD(JX),1,3,3,SCR1,
     &             SCR(IP(NTIME)),IERR,1)
C
C NOW TRANSFORM THIS REFERENCE OPERATION (ABOUT Z) TO A C3 OR S6 ABOUT
C  THE (A,A,A) AXIS.
C
        CALL ZERO(SCR2,9)
        DO 7200 I=1,3
         SCR2(I)=DSQRT(3.D0)
7200    CONTINUE
        CALL SIAZ(SCR2,SCR1,3)
        CALL MTRAN2(SCR1,3)
        CALL UNITRY(SCR1,SCR(IP(NTIME)),SCR(IP(NTIME)),3)
        CLSTYP(NTIME)=JX
C
C NOW GENERATE THREE OF THE OTHER C3 AXES WITH A C4.
C
        IF(PTGRP.NE.'T h')THEN
         CALL GENRST(1,SCR,NTIME,3,IORDGP,JX,CLSTYP)
        ELSE
C
C IF GROUP IS Th, WE DON'T HAVE A C4.  NEED TO GENERATE A C4z MATRIX NOW
C
        CALL IDNMAT(SCR1,3,NTIME)
        NTIME=NTIME-1
        CALL DOSYOP('C',4,1,3,3,SCR1,SCR2,IERR,1)
        CALL ZERO(SCR(IP(24)),9)
        CALL VADD(SCR(IP(24)),SCR(IP(24)),SCR2,9,1.D0)
        CALL GENRST(24,SCR,NTIME,3,IORDGP,JX,CLSTYP)
       ENDIF
C
C NOW THE C3(2) OR S6(5) AXES.
C
        CLSTYP(NTIME)=JX
        CALL MTRANSP(SCR(IP(NTIME)),SCR(IP(NTIME+1)),3,3,3,3)
        NTIME=NTIME+1
        CLSTYP(NTIME)=JX
        IF(PTGRP.NE.'T h')THEN
         CALL GENRST(1,SCR,NTIME,3,IORDGP,JX,CLSTYP)
        ELSE
         CALL GENRST(24,SCR,NTIME,3,IORDGP,JX,CLSTYP)
        ENDIF
7003   CONTINUE
C
C NOW THE IDENTITY AND INVERSION AND WE ... ARE ... OUT OF HERE!
C
       IF(PTGRP.NE.'O  ')THEN
        JX=JX+1
        OPRTYP(JX)='I'
        NUMCLS(JX)=1
        CALL IDNMAT(SCR1,3,NTIME)
        CALL DOSYOP(OPRTYP(JX),0,0,0,3,SCR1,SCR(IP(NTIME)),
     &  IERR,1)
        CLSTYP(NTIME)=JX
       ENDIF
       JX=JX+1
       OPRTYP(JX)='E'
       NUMCLS(JX)=1
       CALL IDNMAT(SCR(IP(NTIME+1)),3,NTIME)
       CLSTYP(NTIME)=JX
       NCLASS=JX
       GOTO 383
      ENDIF
C
C NOW DO BORING GROUPS C1, CS, CI.
C
      IF(PTGRP.EQ.'C1 ')THEN
       NCLASS=1
       IORD=1
       OPRTYP(1)='E'
       CALL IDNMAT(SCR(NTIME+1),3,NTIME)
       NUMCLS(1)=1
       CLSTYP(1)=1
      ELSEIF(PTGRP.EQ.'C s')THEN
       NCLASS=2
       IORD=2
       OPRTYP(2)='E'
       OPRTYP(1)='P'
       OPRAXS(1)=3
       NUMCLS(2)=1
       NUMCLS(1)=1
       CALL IDNMAT(SCR(NTIME+1),3,NTIME)
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(1),OPRORD(1),OPRTIM(1),
     &        OPRAXS(1),3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(1)=1
       CLSTYP(2)=2
      ELSEIF(PTGRP.EQ.'C i')THEN
       NCLASS=2
       IORD=2
       OPRTYP(2)='E'
       OPRTYP(1)='I'
       NUMCLS(1)=1
       NUMCLS(2)=1
       CALL IDNMAT(SCR(NTIME+1),3,NTIME)
       CALL IDNMAT(SCR1,3,NTIME)
       CALL DOSYOP(OPRTYP(1),OPRORD(1),OPRTIM(1),
     &        OPRAXS(1),3,SCR1,SCR(IP(NTIME)),IERR,1)
       CLSTYP(1)=1
       CLSTYP(2)=1
      ENDIF

      IF (NTIME.EQ.0) THEN
         WRITE(*,*) '@CHRTAB: Symmetry operations for point group ',
     &          PTGRP,' unavailable.'
         CALL ERREX
      END IF
C
C NOW DO INTELLIGENT RENAMING OF CERTAIN OPERATIONS.  FOR EXAMPLE, A
C  CN(N) OPERATION IS AN IDENTITY, A CN(2) IS A CN/2, ETC.  THIS WILL
C  JUST MAKE THINGS "NICER", AND WILL NOT LEAD TO ANY ACTUAL CHANGES.
C
      DO 20 I=1,NCLASS
       IF(OPRTYP(I).NE.'C'.AND.OPRTYP(I).NE.'S')GOTO 20
       TICK=FLOAT(OPRORD(I))/FLOAT(OPRTIM(I))
       TOCK=OPRORD(I)/OPRTIM(I)
       IREM=MOD(OPRORD(I),OPRTIM(I))
       Z1=DABS(1.D0-TICK)
       IF(OPRTYP(I).EQ.'C'.AND.Z1.LT.1.D-12)THEN
        OPRTYP(I)='E'
        OPRAXS(I)=0
        OPRTIM(I)=0
        OPRORD(I)=0
       ELSEIF(OPRTYP(I).EQ.'S'.AND.Z1.LT.1.D-12)THEN
        OPRTYP(I)='P'
        OPRTIM(I)=0
        OPRORD(I)=0
       ELSEIF(IREM.EQ.0.AND.TOCK.EQ.2.AND.OPRTYP(I).EQ.'S')THEN
        OPRTYP(I)='I'
        OPRTIM(I)=0
        OPRORD(I)=0
        OPRAXS(I)=0
       ELSEIF(IREM.EQ.0)THEN
        OPRTIM(I)=1
        OPRORD(I)=TOCK
       ENDIF
20     CONTINUE
383    IF(IPRNT.GT.5)WRITE(LUOUT,9100)NTIME
9100   FORMAT(T3,'@CHRTAB-I, Generated transformation matrices ',
     &'for ',I3,' symmetry operations.')
       RETURN
       END

      Subroutine Make_Res(Lam, Mu, xph, Yph, Zph, Res)
      
      Implicit Double Precision (A-H, O-Z)
C
#include "ecp.par"
#include "ecp.com"
     
      JD = Lam*(Lam+1) - Mu + 1
     
      Jmn = Lmf(Jd)
      Jmx = Lmf(Jd+1) - 1
C
      Res = 0.0D0
      
#ifdef _DEBUG_LVLM1
      Write(6,"(a,10(1x,I3))") "At entry to make_res, Lam and Mu",
     &                          Lam, Mu
      Write(6,"(a,10(1x,I3))") "At entry to make_res, Jmn and Jmx ",
     &                          Jmn, Jmx
#endif
      Do J = Jmn, Jmx
     
         Jx = Lmx(J)
         Jy = Lmy(J)
         Jz = Lmz(J)  
         Res = Res + Zlm(J)*(Xph**Jx)*(Yph**Jy)*(Zph**Jz)
C
#ifdef _DEBUG_LVLM1
      Write(6,"(a,3(1x,i2),2(1x,F15.8))"), "The real Sph ",jx,jy,jz,
     &          Zlm(J),Res
#endif
      Enddo
     
      Return
      End
            
           

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__SPHERICAL_TRANSFORM
     +
     +                    ( M,
     +                      NROW,NXYZ,NRY,
     +                      LROW,ROW,
     +                      ROT,
     +                      X,
     +
     +                              Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__SPHERICAL_TRANSFORM
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a simple cartesian to spherical
C                transformation step on a batch of contracted cartesian
C                gaussian integrals:
C
C                         y (m,r) = sum  mat (i,r) * x (m,i)
C                                    i
C
C                where i is an element of the cartesian basis, r an
C                element of the spherical basis, mat is the cartesian
C                -> spherical transformation matrix and m are the bra
C                elements not involved. Ordering of the cartesian
C                monomial basis is assumed to be:
C
C                         e f g     a b c
C                        X Y Z  >  X Y Z   , if e > a
C                                            for e=a if f > b
C                                            for e=a and f=b if g > c
C
C
C                  Input:
C
C                    M           =  # of elements not involved in the
C                                   transformation (invariant indices)
C                    NROW        =  maximum # of nonzero rows in the
C                                   transformation matrix
C                    NXYZ        =  # of cartesian monomials xyz for
C                                   the shell to be transformed
C                    NRY         =  # of spherical functions ry for
C                                   the shell to be transformed
C                    LROW (R)    =  # of xyz-monomials contributing
C                                   to the R-th ry-component
C                    ROW (I,R)   =  I-th xyz-monomial row index
C                                   containing nonzero contribution to
C                                   the R-th ry-component
C                    ROT (I,R)   =  I-th nonzero xyz-monomial to R-th
C                                   ry-component transformation matrix
C                                   element
C                    X           =  input batch of cartesian integrals
C
C                  Output:
C
C                    Y           =  output batch of spherical integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,M,N,R
         INTEGER     MROW,NROW
         INTEGER     NBASE,NLEFT,NREST,NSTEP
         INTEGER     NRY
         INTEGER     NXYZ
         INTEGER     XCOL1,XCOL2,XCOL3,XCOL4,XCOL5,XCOL6,XCOL7,XCOL8

         INTEGER     LROW (1:NRY)
         INTEGER     ROW  (1:NROW,1:NRY)

         DOUBLE PRECISION  ROT1,ROT2,ROT3,ROT4,ROT5,ROT6,ROT7,ROT8

         DOUBLE PRECISION  X (1:M,1:NXYZ)
         DOUBLE PRECISION  Y (1:M,1:NRY)

         DOUBLE PRECISION  ROT (1:NROW,1:NRY)
C
C
C------------------------------------------------------------------------
C
C
C             ...perform the cartesian -> spherical transformation.
C                Use basic row grouping of the transformation
C                to improve cache line reusing.
C
C
         DO 100 R = 1,NRY
            MROW = LROW (R)

            GOTO (1,2,3,4,5,6,7,8,9) MIN (MROW,9)
C
C
C             ...# of rows = 1
C
C
    1       XCOL1 = ROW (1,R)
            ROT1  = ROT (1,R)

            DO N = 1,M
               Y (N,R) = ROT1 * X (N,XCOL1)
            END DO

            GOTO 100
C
C
C             ...# of rows = 2
C
C
    2       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
            END DO

            GOTO 100
C
C
C             ...# of rows = 3
C
C
    3       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
            END DO

            GOTO 100
C
C
C             ...# of rows = 4
C
C
    4       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)
            XCOL4 = ROW (4,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)
            ROT4  = ROT (4,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
     +                   + ROT4 * X (N,XCOL4)
            END DO

            GOTO 100
C
C
C             ...# of rows = 5
C
C
    5       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)
            XCOL4 = ROW (4,R)
            XCOL5 = ROW (5,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)
            ROT4  = ROT (4,R)
            ROT5  = ROT (5,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
     +                   + ROT4 * X (N,XCOL4)
     +                   + ROT5 * X (N,XCOL5)
            END DO

            GOTO 100
C
C
C             ...# of rows = 6
C
C
    6       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)
            XCOL4 = ROW (4,R)
            XCOL5 = ROW (5,R)
            XCOL6 = ROW (6,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)
            ROT4  = ROT (4,R)
            ROT5  = ROT (5,R)
            ROT6  = ROT (6,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
     +                   + ROT4 * X (N,XCOL4)
     +                   + ROT5 * X (N,XCOL5)
     +                   + ROT6 * X (N,XCOL6)
            END DO

            GOTO 100
C
C
C             ...# of rows = 7
C
C
    7       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)
            XCOL4 = ROW (4,R)
            XCOL5 = ROW (5,R)
            XCOL6 = ROW (6,R)
            XCOL7 = ROW (7,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)
            ROT4  = ROT (4,R)
            ROT5  = ROT (5,R)
            ROT6  = ROT (6,R)
            ROT7  = ROT (7,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
     +                   + ROT4 * X (N,XCOL4)
     +                   + ROT5 * X (N,XCOL5)
     +                   + ROT6 * X (N,XCOL6)
     +                   + ROT7 * X (N,XCOL7)
            END DO

            GOTO 100
C
C
C             ...# of rows = 8
C
C
    8       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)
            XCOL4 = ROW (4,R)
            XCOL5 = ROW (5,R)
            XCOL6 = ROW (6,R)
            XCOL7 = ROW (7,R)
            XCOL8 = ROW (8,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)
            ROT4  = ROT (4,R)
            ROT5  = ROT (5,R)
            ROT6  = ROT (6,R)
            ROT7  = ROT (7,R)
            ROT8  = ROT (8,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
     +                   + ROT4 * X (N,XCOL4)
     +                   + ROT5 * X (N,XCOL5)
     +                   + ROT6 * X (N,XCOL6)
     +                   + ROT7 * X (N,XCOL7)
     +                   + ROT8 * X (N,XCOL8)
            END DO

            GOTO 100
C
C
C             ...# of rows > 8. Perform transformations in bundles
C                of 8 rows.
C
C
    9       XCOL1 = ROW (1,R)
            XCOL2 = ROW (2,R)
            XCOL3 = ROW (3,R)
            XCOL4 = ROW (4,R)
            XCOL5 = ROW (5,R)
            XCOL6 = ROW (6,R)
            XCOL7 = ROW (7,R)
            XCOL8 = ROW (8,R)

            ROT1  = ROT (1,R)
            ROT2  = ROT (2,R)
            ROT3  = ROT (3,R)
            ROT4  = ROT (4,R)
            ROT5  = ROT (5,R)
            ROT6  = ROT (6,R)
            ROT7  = ROT (7,R)
            ROT8  = ROT (8,R)

            DO N = 1,M
               Y (N,R) =   ROT1 * X (N,XCOL1)
     +                   + ROT2 * X (N,XCOL2)
     +                   + ROT3 * X (N,XCOL3)
     +                   + ROT4 * X (N,XCOL4)
     +                   + ROT5 * X (N,XCOL5)
     +                   + ROT6 * X (N,XCOL6)
     +                   + ROT7 * X (N,XCOL7)
     +                   + ROT8 * X (N,XCOL8)
            END DO

            NBASE = 8
            NLEFT = MROW - 8
            NSTEP = NLEFT / 8
            NREST = MOD (NLEFT,8)

            DO 90 I = 1,NSTEP

               XCOL1 = ROW (NBASE+1,R)
               XCOL2 = ROW (NBASE+2,R)
               XCOL3 = ROW (NBASE+3,R)
               XCOL4 = ROW (NBASE+4,R)
               XCOL5 = ROW (NBASE+5,R)
               XCOL6 = ROW (NBASE+6,R)
               XCOL7 = ROW (NBASE+7,R)
               XCOL8 = ROW (NBASE+8,R)

               ROT1  = ROT (NBASE+1,R)
               ROT2  = ROT (NBASE+2,R)
               ROT3  = ROT (NBASE+3,R)
               ROT4  = ROT (NBASE+4,R)
               ROT5  = ROT (NBASE+5,R)
               ROT6  = ROT (NBASE+6,R)
               ROT7  = ROT (NBASE+7,R)
               ROT8  = ROT (NBASE+8,R)

               DO N = 1,M
                  Y (N,R) = Y (N,R) + ROT1 * X (N,XCOL1)
     +                              + ROT2 * X (N,XCOL2)
     +                              + ROT3 * X (N,XCOL3)
     +                              + ROT4 * X (N,XCOL4)
     +                              + ROT5 * X (N,XCOL5)
     +                              + ROT6 * X (N,XCOL6)
     +                              + ROT7 * X (N,XCOL7)
     +                              + ROT8 * X (N,XCOL8)
               END DO

               NBASE = NBASE + 8

   90       CONTINUE

            DO 92 I = 1,NREST
               XCOL1 = ROW (NBASE+I,R)
               ROT1  = ROT (NBASE+I,R)
               DO N = 1,M
                  Y (N,R) = Y (N,R) + ROT1 * X (N,XCOL1)
               END DO
   92       CONTINUE
C
C
C             ...next spherical index.
C
C
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

         SUBROUTINE  OED__SOI_SET_AB
     +
     +                    ( NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      NUCLEI,
     +                      XN,YN,ZN,
     +                      IXDERC,
     +                      DER1X,DER1Y,DER1Z,
     +                      DER2X,DER2Y,DER2Z,
     +                      DERCX,DERCY,DERCZ,
     +                      EXP1,EXP2,
     +                      CC1,CC2,
     +                      SPHERIC,
     +
     +                                 NCGTOA,NCGTOB,
     +                                 NPGTOA,NPGTOB,
     +                                 SHELLA,SHELLB,SHELLP,
     +                                 MXSHELL, ! need to be careful
     +                                 XA,YA,ZA,XB,YB,ZB,
     +                                 NDERX,NDERY,NDERZ,
     +                                 DERAX,DERAY,DERAZ,
     +                                 DERBX,DERBY,DERBZ,
     +                                 DIFFA,DIFFB,DIFFC,
     +                                 DIFFX,DIFFY,DIFFZ,
     +                                 IXAEQB,IXCEQA,IXCEQB,
     +                                 ATOMIC,EQUALAB,
     +                                 ABX,ABY,ABZ,RNABSQ,
     +                                 SPNORM,
     +                                 NXYZA,NXYZB,NXYZT,
     +                                 NRYA,NRYB,
     +                                 INDEXA,INDEXB,
     +               SWAP12,SWAPRS,   ! need to be careful
     +                                 LEXPA,LEXPB,
     +                                 LCCA,LCCB,
     +                                 LCCSEGA,LCCSEGB,
     +                                 EMPTY )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_SET_DERV_AB
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the logistics on how to evaluate
C                the (1|2) derivative nuclear attraction integral batch
C                in the most efficient way. It performs the label map:
C
C                               (1|2) --> (A|B)
C
C                and returns some additional data of crucial importance
C                for evaluation of the (A|B) derivative nuclear
C                attraction integrals.
C
C                The freedom we have in making the internal association
C                1,2 -> A,B follows from the 2-fold permutational
C                symmetry of the nuclear attraction integrals in (1|2):
C
C                                 (1|2) = (2|1)
C
C                Note, that this permutational symmetry only holds as
C                long as we permute the differential operators with it.
C
C                Application of the 1 <-> 2 switch is pretty irrelevant
C                here, due to the fact the routine which generates the
C                initial 1D integrals has the possibility to either
C                apply the HRR steps on the A or B shell. Still we
C                choose here to have A>=B for convenience and possibly
C                slightly better performance.
C
C
C                  Input (x = 1 and 2):
C
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    NUCLEI       =  the original # of nuclear
C                                    attraction centers
C                    XN,YN,ZN     =  the original x,y,z-coordinates
C                                    of the nuclear attraction centers
C                    IXDERC       =  the index of which of the nuclear
C                                    attraction centers is to be
C                                    differentiated. If that index
C                                    corresponds to one of the centers
C                                    1 and/or 2, it will already be
C                                    differentiated along with these
C                                    centers, hence values transmitted
C                                    for DERCX,DERCY,DERCZ are
C                                    irrelevant in that case.
C                    DERyp        =  the order of differentiation on
C                                    centers y = 1 and 2 with respect
C                                    to the p = x,y,z coordinates
C                    DERCp        =  the order of differentiation for
C                                    the IXDERC-th nuclear attraction
C                                    center with respect to the
C                                    p = x,y,z coordinates
C                    EXPx         =  primitive exponents for csh x
C                    CCx          =  contraction coeffs for csh x
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output (x = A and B):
C
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    SHELLP       =  the shell sum A+B
C                    MXSHELL      =  the largest (maximum) shell type
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = A and B
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERyp        =  the order of differentiation on
C                                    centers y = A and B with respect
C                                    to the p = x,y,z coordinates
C                    DIFFy        =  is true, if differentiation will
C                                    be performed on centers y = A and B
C                                    and at least on one of the nuclear
C                                    attraction centers y = C different
C                                    from A and B and if differentiation
C                                    will be performed at least once
C                                    one on each of the y = x,y,z
C                                    coordinates
C                    IXAEQB       =  is an index = 0 or 1, depending
C                                    on if center A is different or
C                                    equal from center B, respectively
C                    IXCEQy       =  contains index of which of all
C                                    nuclear attraction centers is
C                                    equal to centers y = A,B. If no
C                                    such C is equal the value is 0
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated,
C                                    observing only centers A and B and
C                                    ignoring all nuclear attraction
C                                    centers
C                    EQUALAB      =  indicates, if csh x and csh y are
C                                    considered to be equal for the
C                                    pair AB
C                    ABX,ABY,ABZ  =  the x,y,z-coordinate differences
C                                    between centers A and B
C                    RNABSQ       =  square of the magnitude of the
C                                    distance between centers A and B
C                    SPNORM       =  normalization factor due to
C                                    presence of s- and p-type shells.
C                                    For each s-type shell there is a
C                                    factor of 1 and for each p-type
C                                    shell a factor of 2
C                    NXYZx        =  # of cartesian monomials for csh x
C                    NXYZT        =  total # cartesian monomial
C                                    combinations, that is NXYZA * NXYZB
C                    NRYx         =  # of spherical functions for csh x
C                    INDEXx       =  index A,B -> 1,2 map
C                    SWAP12       =  is .true., if a swap 1 <-> 2 has
C                                    been performed
C                    SWAPRS       =  is set .true. if the contraction
C                                    order of the primitives pair AB
C                                    will be performed in reverse order
C                                    BA for efficiency reasons
C                    LEXPx        =  pointers to locate appropriate
C                                    section of the exponent array
C                                    corresponding to csh x
C                    LCCx         =  pointers to locate appropriate
C                                    section of the contraction coeff
C                                    array corresponding to csh x
C                    LCCSEGx      =  pointers to locate appropriate
C                                    section of the lowest and highest
C                                    primitive index array defining
C                                    segmented contraction boundaries
C                                    for csh x
C                    EMPTY        =  logical flag, indicating if an
C                                    empty batch of integrals is
C                                    expected.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ALERT
         LOGICAL     ATOMIC,ATOMAC,ATOMBC
         LOGICAL     DIFFA,DIFFB,DIFFC
         LOGICAL     DIFFX,DIFFY,DIFFZ
         LOGICAL     EMPTY
         LOGICAL     EQUALAB
         LOGICAL     NODIFF
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAPRS

         INTEGER     DER1X,DER1Y,DER1Z
         INTEGER     DER2X,DER2Y,DER2Z
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DERCX,DERCY,DERCZ
         INTEGER     I,J,N
         INTEGER     INDEXA,INDEXB
         INTEGER     IXAEQB,IXCEQA,IXCEQB
         INTEGER     IXDERC
         INTEGER     LCCSEGA,LCCSEGB
         INTEGER     LCCA,LCCB
         INTEGER     LEXPA,LEXPB
         INTEGER     MXSHELL
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NCGTOA,NCGTOB
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NRYA,NRYB
         INTEGER     NUCLEI
         INTEGER     NXYZA,NXYZB,NXYZT
         INTEGER     SHELL1,SHELL2
         INTEGER     SHELLA,SHELLB
         INTEGER     SHELLP

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  RNABSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  XN (1:NUCLEI)
         DOUBLE PRECISION  YN (1:NUCLEI)
         DOUBLE PRECISION  ZN (1:NUCLEI)

         DOUBLE PRECISION  EXP1 (1:NPGTO1)
         DOUBLE PRECISION  EXP2 (1:NPGTO2)

         DOUBLE PRECISION  CC1 (1:NPGTO1,1:NCGTO1)
         DOUBLE PRECISION  CC2 (1:NPGTO2,1:NCGTO2)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...generate all 1,2 data.
C
C
         EMPTY  = .FALSE.
         ATOMIC = (X1.EQ.X2) .AND. (Y1.EQ.Y2) .AND. (Z1.EQ.Z2)
         SHELLP = SHELL1 + SHELL2

c         write(*,*) 'X1 and X2', X1, X2, (X1.EQ.X2)
c         write(*,*) 'Y1 and Y2', Y1, Y2, (Y1.EQ.Y2)
c         write(*,*) 'Z1 and Z2', Z1, Z2, (Z1.EQ.Z2)

c      write(*,*) 'Shellp= she1 + shel2',SHELLP,shell1, shell2
         MXSHELL = MAX0 (SHELL1,SHELL2)
c      write(*,*) 'MXSHELL=',MXSHELL

cPV I do not think we will need MXSHELL info 

C
C
C             ...determine csh equality between centers 1 and 2
C                in increasing order of complexity:
C
C                 centers -> shells -> exponents -> ctr coefficients
C
C
         EQUALAB = ATOMIC

         IF (EQUALAB) THEN
             EQUALAB =     (SHELL1 .EQ. SHELL2)
     +               .AND. (NPGTO1 .EQ. NPGTO2)
     +               .AND. (NCGTO1 .EQ. NCGTO2)
             IF (EQUALAB) THEN
               DO I = 1,NPGTO1
                  EQUALAB = EQUALAB .AND. (EXP1(I).EQ.EXP2(I))
               END DO
               IF (EQUALAB) THEN
                 DO J = 1,NCGTO1
                    IF (EQUALAB) THEN
                      DO I = 1,NPGTO1
                         EQUALAB = EQUALAB .AND. (CC1(I,J).EQ.CC2(I,J))
                      END DO
                    END IF
                 END DO
               END IF
             END IF
         END IF
CSSS       write(*,*) 'force equlab to be false'
        EQUALAB=.false.
C
C
C             ...decide on the 1 <-> 2 swapping.
C
C
         SWAP12 = SHELL1 .LT. SHELL2
         swap12=.false.
cPV SWAP12 is redundant I can not use SWAP12 logic


C
C
C             ...according to the previously gathered info, set the
C                new A,B shells, # of primitives + contraction coeffs
C                as well as pointers to the alpha exponents and
C                contraction coefficients.
C
C
         IF (.NOT.SWAP12) THEN
             XA = X1
             YA = Y1
             ZA = Z1
             XB = X2
             YB = Y2
             ZB = Z2
             SHELLA = SHELL1
             SHELLB = SHELL2
             NPGTOA = NPGTO1
             NPGTOB = NPGTO2
             NCGTOA = NCGTO1
             NCGTOB = NCGTO2
             DERAX = DER1X
             DERAY = DER1Y
             DERAZ = DER1Z
             DERBX = DER2X
             DERBY = DER2Y
             DERBZ = DER2Z
             INDEXA = 1
             INDEXB = 2
             LEXPA = 1
             LEXPB = LEXPA + NPGTO1
             LCCA = 1
             LCCB = LCCA + NPGTO1 * NCGTO1
             LCCSEGA = 1
             LCCSEGB = LCCSEGA + NCGTO1
         ELSE
cPV I need to ignore this block
             XA = X2
             YA = Y2
             ZA = Z2
             XB = X1
             YB = Y1
             ZB = Z1
             SHELLA = SHELL2
             SHELLB = SHELL1
             NPGTOA = NPGTO2
             NPGTOB = NPGTO1
             NCGTOA = NCGTO2
             NCGTOB = NCGTO1
             DERAX = DER2X
             DERAY = DER2Y
             DERAZ = DER2Z
             DERBX = DER1X
             DERBY = DER1Y
             DERBZ = DER1Z
             INDEXA = 2
             INDEXB = 1
             LEXPB = 1
             LEXPA = LEXPB + NPGTO1
             LCCB = 1
             LCCA = LCCB + NPGTO1 * NCGTO1
             LCCSEGB = 1
             LCCSEGA = LCCSEGB + NCGTO1
cPV end the ignore block
         END IF
C
C
C             ...the new A and B shells are set. Calculate the
C                following info:
C
C                1) control variable to determine contraction order
C                2) cartesian monomial dimensions
C                3) spherical dimensions (= cartesian, if no spherical)
C                4) the overall norm factor due to s- or p-type shells
C
C

cPV SWAPRS logic variable is redunant as well


         SWAPRS = NPGTOA .GT. NPGTOB
        
CSSS         write(*,*) 'SWAPRS=',SWAPRS
cPV end

         NXYZA  = (SHELLA+1)*(SHELLA+2)/2
         NXYZB  = (SHELLB+1)*(SHELLB+2)/2
         NXYZT  = NXYZA * NXYZB

         NRYA = SHELLA + SHELLA + 1
         NRYB = SHELLB + SHELLB + 1

         IF (.NOT.SPHERIC) THEN
             NRYA = NXYZA
             NRYB = NXYZB
         END IF

         SPNORM = ONE
         IF (SHELLA.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELLB.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
C
C
C             ...calculate the coordinate differences between centers
C                A and B and calculate the square of the magnitude
C                of the distance between A and B. Set also the A,B
C                equality index and determine if differentiation is
C                is to be performed on centers A and/or B.
C
C                Check here also, if the specified derivative operator
C                orders for A and B match the center equality patterns
C                for each x,y,z-component. Stop the program if any
C                inconsistency is found.
C
C

CSSS         Write(*,*) 'ATOMIC=',ATOMIC
         IF (.NOT.ATOMIC) THEN

             ABX = XA - XB
             ABY = YA - YB
             ABZ = ZA - ZB
             RNABSQ = ABX * ABX + ABY * ABY + ABZ * ABZ
             IXAEQB = 0

             DIFFA = (DERAX + DERAY + DERAZ) .NE. 0
             DIFFB = (DERBX + DERBY + DERBZ) .NE. 0

             NDERX = DERAX + DERBX
             NDERY = DERAY + DERBY
             NDERZ = DERAZ + DERBZ

         ELSE

             ABX = ZERO
             ABY = ZERO
             ABZ = ZERO
             RNABSQ = ZERO
             IXAEQB = 1

CSSS             ALERT =     DERAX.NE.DERBX
CSSS     +              .OR. DERAY.NE.DERBY
CSSS     +              .OR. DERAZ.NE.DERBZ

c             Write(*,'(a,6(1x,I2))') 'Prakash DERAX,DERBX,
c     +                    DERAYR, DERBY,
c     +                    DERAZ, DERBZ',
c     +                    DERAX,DERBX,
c     +                    DERAY,DERBY,
c     +                    DERAZ,DERBZ
CSSS             IF (ALERT) THEN
CSSS                 WRITE (*,*) ' Center A = B / derv order wrong! '
CSSS                 WRITE (*,*) ' oed__nai_set_derv_ab '
cPV                 STOP
CSSS             END IF

             DIFFA = (DERAX + DERAY + DERAZ) .NE. 0
cPV             DIFFB = DIFFA
             DIFFB=(DERBX + DERBY + DERBZ) .NE. 0

cPV             NDERX = DERAX
cPV             NDERY = DERAY
cPV             NDERZ = DERAZ

             NDERX = DERAX + DERBX
             NDERY = DERAY + DERBY
             NDERZ = DERAZ + DERBZ
        
         END IF

         DIFFX = (DERAX + DERBX) .NE. 0
         DIFFY = (DERAY + DERBY) .NE. 0
         DIFFZ = (DERAZ + DERBZ) .NE. 0
c         Write(*,*)'DIFFX=',DIFFx,diffy,diffz

C
C
C             ...complete next the differentiation info due to the
C                possible differentiation of a nuclear attraction
C                center C:
C
C                   i) x,y,z-component and C center differentiation
C                      indicator
C
C                  ii) the overall differentiation order, observing
C                      possible center equalities. Nuclear attraction
C                      centers C may be equal to centers A and/or B
C                      but they are always mutually different among
C                      each other.
C
C                 iii) index of nuclear attraction center C equal to
C                      A and/or B. If no center C is equal to either
C                      A and/or B then this index is zero. If more
C                      than one nuclear attraction center C is equal to
C                      A and/or B the program stops with a diagnostic.
C
C
         IXCEQA = 0
         IXCEQB = 0

         DO N = 1,NUCLEI

            XC = XN (N)
            YC = YN (N)
            ZC = ZN (N)

            ATOMAC = (XA.EQ.XC) .AND. (YA.EQ.YC) .AND. (ZA.EQ.ZC)
            ATOMBC = (XB.EQ.XC) .AND. (YB.EQ.YC) .AND. (ZB.EQ.ZC)

            IF (ATOMAC) THEN
                IF (IXCEQA.NE.0) THEN
                    WRITE (*,*) ' Nuclear attraction centers equal! '
                    WRITE (*,*) ' oed__nai_set_derv_ab '
                    STOP
                END IF
                IXCEQA = N
            END IF

            IF (ATOMBC) THEN
                IF (IXCEQB.NE.0) THEN
                    WRITE (*,*) ' Nuclear attraction centers equal! '
                    WRITE (*,*) ' oed__nai_set_derv_ab '
                    STOP
                END IF
                IXCEQB = N
            END IF

         END DO

         DIFFC = (DERCX+DERCY+DERCZ) .NE. 0
     +           .AND. (IXDERC.NE.IXCEQA)
     +           .AND. (IXDERC.NE.IXCEQB)
     +           .AND. (IXDERC.GT.0)
     +           .AND. (IXDERC.LE.NUCLEI)

         IF (DIFFC) THEN
             NDERX = NDERX + DERCX
             NDERY = NDERY + DERCY
             NDERZ = NDERZ + DERCZ
             DIFFX = DIFFX .OR. (DERCX.NE.0)
             DIFFY = DIFFY .OR. (DERCY.NE.0)
             DIFFZ = DIFFZ .OR. (DERCZ.NE.0)
         END IF

         NODIFF = (NDERX.EQ.0) .AND. (NDERY.EQ.0) .AND. (NDERZ.EQ.0)

         IF (NODIFF) THEN
             EMPTY = .TRUE.
             RETURN
         END IF
c         write(*,*) 'Diffc=',diffC,diffx,diffy,diffz
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine finalizes the job archive environment (via the JAINDX file)
c in order for getrec and putrec to work properly for other member executables.







      subroutine aces_ja_fin
      implicit none

c INTERNAL VARIABLES
      character*80 szJAINDX
      integer       iJAINDX
      integer i, iStat
      logical bOpened

c COMMON BLOCKS
c jobarc.com : begin

c This data tracks the contents of the JOBARC file. 'physical' records refer
c to direct I/O while 'logical' records refer to the ACES archive elements.


      external aces_bd_jobarc

c marker(i) : the name of logical record i
c rloc(i)   : the integer index in JOBARC that starts logical record i
c rsize(i)  : the integer-length of logical record i
c nrecs  : the number of physical records in the JOBARC file
c irecwd : the integer-length of a physical record
c irecln : the    recl-length of a physical record

      character*8     marker(1000)
      integer         rloc  (1000),
     &                rsize (1000),
     &                nrecs, irecwd, irecln
      common /jobarc/ marker,
     &                rloc,
     &                rsize,
     &                nrecs, irecwd, irecln
      save   /jobarc/

c bJAUp  : a flag for bombing in get/putrec if aces_ja_init has not been called
c bJAMod : a flag for updating JAINDX in aces_ja_fin

      logical           bJAUp, bJAMod
      common /ja_flags/ bJAUp, bJAMod
      save   /ja_flags/

c jobarc.com : end

c ----------------------------------------------------------------------

c   o make sure the job archive subsystem is up
      if (.not.bJAUp) return

c   o mark the job archive as closed
      call putrec(1,'JOBARC','JADIRTY',1,0)

c   o close the JOBARC file
      inquire(unit=75,opened=bOpened,err=666,iostat=iStat)
      if (bOpened) then
         close(unit=75,status='KEEP',err=666,iostat=iStat)
      end if

c   o only update JAINDX if a record has been added
      if (bJAMod) then

c      o update JAINDX (dump the jobarc common block)
         call gfname('JAINDX',szJAINDX,iJAINDX)
         open(unit=75,file=szJAINDX(1:iJAINDX),
     &        form='UNFORMATTED',status='UNKNOWN',err=666,iostat=iStat)
         rewind(75,err=666,iostat=iStat)
         write(75,err=666,iostat=iStat) marker, rloc, rsize, nrecs
         close(unit=75,status='KEEP',err=666,iostat=iStat)

c      o reset the JOBARC modification flag
         bJAMod = .false.

c     end if (bJAMod)
      end if


c   o turn off the job archive subsystem flag
      bJAUp = .false.

      return

c   o I/O error
 666  print *, '@ACES_JA_FIN: I/O error'
      print '(/)'
      call aces_io_error('ACES_JA_FIN',75,iStat)

c     end subroutine aces_ja_fin
      end

c This routine changes how much memory ACESII tries to allocate.













































































































































































































































































































































































































































































































































      subroutine mem(args,nargs)
      implicit none

c ARGUMENT LIST
      integer nargs
      character*80 args(nargs)

c INTERNAL VARIABLES
      double precision dMem
      integer i, iFact
      logical bBytes

c COMMON BLOCKS


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end

c ----------------------------------------------------------------------

      if (nargs.gt.0) then

c   o find the last non-white character
      i = 80
      do while (args(1)(i:i).eq.' ')
         i = i - 1
      end do

c   o get base unit
      if ((iachar(args(1)(i:i)).lt.iachar('0').or.
     &     iachar(args(1)(i:i)).gt.iachar('9')    ).and.
     &    args(1)(i:i).ne.'.') then
         bBytes=(args(1)(i:i).eq.'B'.or.args(1)(i:i).eq.'b')
         i = i - 1
      end if

c   o get order of magnitude
      iFact=1
      if ((iachar(args(1)(i:i)).lt.iachar('0').or.
     &     iachar(args(1)(i:i)).gt.iachar('9')    ).and.
     &    args(1)(i:i).ne.'.') then
         if (args(1)(i:i).eq.'K'.or.args(1)(i:i).eq.'k') iFact=1024
         if (args(1)(i:i).eq.'M'.or.args(1)(i:i).eq.'m') iFact=1024**2
         if (args(1)(i:i).eq.'G'.or.args(1)(i:i).eq.'g') iFact=1024**3
         i = i - 1
      end if

c   o read the amount
      read(args(1)(1:i),*) dMem

      dMem = dMem*iFact
      if (bBytes) dMem = dMem/iIntLn
      iflags(36) = dMem
      call putrec(1,'JOBARC','IFLAGS',36,iflags)

c     end if (nargs.gt.0)
      end if

      print '()'
      print *, '@MEM: The current value of MEM is'
      i = iflags(36)
      print *, '      ',i,' Integer Words'
      i = i*iIntLn
      print *, '      ',i,' Bytes'
      print *, '      ',i*1.0/1024.0/1024.0,' MegaBytes'
      print *, '      ',i*1.0/1024.0/1024.0/1024.0,' GigaBytes'
      print '()'

      return
c     end subroutine mem
      end

      SUBROUTINE TRNLST(IRREP,LISTG,DISSYG,SCR,MAXSIZE)
C
C   THIS ROUTINE TRANSPOSES A SQUARE LIST A(N,N)
C
C       A(I,J) --> A(J,I)
C
C   AND WRITES IT BACK TO DISK IN PLACE.  THIS VERSION HANDLES
C   BOTH IN-CORE AND OUT-OF-CORE TRANSPOSITIONS, AND IS JUST
C   A HACKED-UP SYMMET3.
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSYG,DISLEFT,DISREAD
      DIMENSION SCR(MAXSIZE)
C
      DATA HALF /0.5D0/
C
C  CHECK IF THE LIST FITS INTO THE AVAILABLE CORE MEMORY
C
      IF(MAXSIZE.GE.DISSYG*DISSYG) THEN
C
C   DO IT IN CORE BY USING MTRAN2
C
       CALL GETLST(SCR,1,DISSYG,1,IRREP,LISTG)
       CALL MTRAN2(SCR,DISSYG) 
       CALL PUTLST(SCR,1,DISSYG,1,IRREP,LISTG)
C
      ELSE
C
C  WE HAVE TO DO IT OUT OF CORE
C
C  DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN
C  CORE
C
       MAXDIS=MAXSIZE/DISSYG
C
C  HOWEVER, ONE DISTRIBUTION IS REQUIRED AS BUFFER, SO SUBTRACT ONE
C
       MAXDIS=MAXDIS-1
       IF(MAXDIS.LE.0)THEN
        WRITE(6,1000)2*DISSYG
1000    FORMAT(T3,'@TRNLST-F, Less than ',I10,' words available for ',
     &        'transposition')
        CALL ERREX
       ENDIF
C
C  COMPUTE OFFSET FOR BUFFER
C
       IBUF=1+MAXDIS*DISSYG
C
C  SET THE NUMBER OF DISTRIBUTIONS WHICH MUST BE TREATED
C
       DISREAD=DISSYG
C
C  SET THE NUMBER oF DISTRIBUTIONS LEFT ON DISK
C
       DISLEFT=DISSYG
C
C  SET OFFSET FOR LIST LISTG 
C 
       IOFFSET=1
       IPASS=0
       IREAD=0
C
10     CONTINUE
       IPASS=IPASS+1
       IREAD=IREAD+DISSYG-IOFFSET+1
C
C  DETERMINE THE NUMBER OF DISTRIBUTIONS PROCESSED DURING THIS
C  PATH
C
        DISREAD=MIN(DISLEFT,MAXDIS)
        DISLEFT=DISLEFT-DISREAD
C 
C READ IN THE DISTRIBUTIONS WHICH ARE UPDATED
C
        CALL GETLST(SCR,IOFFSET,DISREAD,1,IRREP,LISTG)
C
C SET IFIRST (FIRST DISTRIBUTION IN CORE)
C
        IFIRST=IOFFSET
C
C UPDATE IOFFSET
C
        IOFFSET=IOFFSET+DISREAD
C
C SET ILAST (LAST DISTRIBUTION IN CORE)
C
        ILAST=IOFFSET-1
C
C  WE HAVE NOW THREE DIFFERENT CATEGORIES OF DISTRIBUTIONS
C
C   1)  THE DISTRIBUTIONS IN MEMORY
C   2)  THE DISTRIBUTIONS ON DISK WHICH ARE ALREADY THE TRANSPOSE OF THE
C       ORIGINAL MATRIX
C   3)  THE DISTRBIBUTIONS ON DISK WHICH ARE STILL NOT THE TRANSPOSE OF
C       THE ORIGINAL MATRIX
C
C
C  DO THE FOLLOWING TWO-STEP PROCEDURE.  FIRST DO AN IN-PLACE TRANSPOSITION 
C   OF THE ELEMENTS FOR WHICH BOTH A(I,J) AND A(J,I) ARE CURRENTLY
C   IN MEMORY.
C
        CALL MTRAN3(SCR(IFIRST),DISSYG,DISREAD)
C
C   NOW LOOP OVER THE REMAINING DISTRIBUTIONS.
C
        DO 100 IDIS=IOFFSET,DISSYG
         CALL GETLST(SCR(IBUF),IDIS,1,1,IRREP,LISTG)
C
C  NOW PUT A(I,J) [I<J] [IN MAIN CORE VECTOR] INTO A(J,I) [IN BUFFER]
C
CDIR$ IVDEP
*VOCL LOOP,NOVREC
         DO 150 IPOS=IFIRST,ILAST
          X=SCR(IBUF+IPOS-1)
          SCR(IBUF+IPOS-1)=SCR(IDIS+(IPOS-IFIRST)*DISSYG)
          SCR(IDIS+(IPOS-IFIRST)*DISSYG)=X
150      CONTINUE
C
C  WRITE THE DISTRIBUTION IN THE BUFFER BACK TO DISK
C
         CALL PUTLST(SCR(IBUF),IDIS,1,1,IRREP,LISTG)
C
100     CONTINUE
C
C SAVE THE TRANSPOSED MAIN CORE AREA ON DISK
C
        CALL PUTLST(SCR,IFIRST,DISREAD,1,IRREP,LISTG)
C
C  IF NOT ALL DISTRIBUTIONS HAVE BEEN PROCESSED, GO BACK TO 10 
C
       IF(DISLEFT.NE.0) GO TO 10
C
C  ALL DONE, RETURN
C
      WRITE(6,2000)IPASS,IREAD
2000  FORMAT(T3,'@TRNLST-I, Transpostion required ',I5,' passes and ',
     &       I10,' reads.')
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine comp_return_xz(z, da1, da2, db1, db2, nsend)
c---------------------------------------------------------------------------
c  Computes the set of XZ integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer me, type
      integer adim, bdim, nsend  
      integer da1, da2, db1, db2
      double precision density(da1:da2, db1:db2)
      double precision z(da1:da2, db1:db2)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif
      double precision sum
      integer icounter, icounter1
      integer i, ix, m, n, nfirst, nints, nalpha, ncoeff, iatom, ncsum
      integer component
      integer a, b, a1,a2,b1,b2,lastao, igrad
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc
      integer ind(2)
      integer flopcount
      logical spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, y

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      spherical = (ispherical .eq. 1)
      lastao    = end_nfps(nshells)

      ind(1) = 1
      ind(2) = 2

c ---------------------------------------------------------------------------
c  Set up send data.
c ---------------------------------------------------------------------------

      adim = da2-da1+1
      bdim = db2-db1+1

      nsend = adim*bdim
      if (nsend .lt. 0) then
         print *,'ERROR IN COMP_FOCK_DER ',me,' nsend = ',nsend
         print *,'adim,bdim = ',adim,bdim
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do b = db1,db2
      do a = da1,da2
         Z(a,b) = 0.d0
      enddo
      enddo

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block of density data.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)
      
c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       icounter = 0
       do m = m1, m2
       do n = n1, n2

            ncsum = ncfps(m) + ncfps(n) 
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)
 
            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend), 
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

c ------------------------------------------------------------------------ 
c  Compute the XZ integrals.
c ------------------------------------------------------------------------ 

              call oed__gener_xyz_batch(intmax, zmax, nalpha, ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .false., ibuf(ipkgscr),1,0,1, nints, 
     *                 nfirst, dbuf(dpkgscr))

            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

                call move_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)

                icounter = icounter + nints
             endif ! (nints .gt. 0) then
              
         enddo   ! n shells
         enddo   ! m shells

      return
      end

      SUBROUTINE HEADER(NATMS,NUC2,COORD2,NPTSX,TVALX,BVALX,
     $     NPTSY,TVALY,BVALY,NPTSZ,TVALZ,BVALZ,
     $     NBASPEFF,IDORO,IAORBD,ICORR,INORBS,IORBVECA,IORBVECB,
     $     NORBOUTA,NORBOUTB,IAORBO,NBASP,IORBOUT,IDENOUT)
C     
C     Print out the headers of the two output files.
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION NUC2(NATMS),COORD2(NATMS*3),IORBVECA(9),
     $     IORBVECB(9)
C     
      STEPX=(TVALX-BVALX)/REAL(NPTSX)
      STEPY=(TVALY-BVALY)/REAL(NPTSY)
      STEPZ=(TVALZ-BVALZ)/REAL(NPTSZ)
      MODVAL=MOD((NBASPEFF+1),10)
      NGRPS=(NBASPEFF+1)/10
C     
C     Density Output:
      IF (IDORO.NE.1) THEN
         WRITE(IDENOUT,*) "ACES II CUBE OUTPUT"
         IF (ICORR.EQ.0) THEN
            IF (IAORBD.EQ.0) WRITE(IDENOUT,*) "SCF Alpha Density"
            IF (IAORBD.EQ.1) WRITE(IDENOUT,*) "SCF Beta Density"
            IF (IAORBD.EQ.2) WRITE(IDENOUT,*) "SCF Total Density"
         ELSE
            IF (IAORBD.EQ.0) WRITE(IDENOUT,*) "Correlated Alpha Density"
            IF (IAORBD.EQ.1) WRITE(IDENOUT,*) "Correlated Beta Density"
            IF (IAORBD.EQ.2) WRITE(IDENOUT,*) "Correlated Total Density"
         END IF
         WRITE(IDENOUT,"(I5,3 F12.6)") NATMS,BVALX,BVALY,BVALZ
         WRITE(IDENOUT,"(I5,3 F12.6)") (NPTSX+1),STEPX,0.0,0.0
         WRITE(IDENOUT,"(I5,3 F12.6)") (NPTSY+1),0.0,STEPY,0.0
         WRITE(IDENOUT,"(I5,3 F12.6)") (NPTSZ+1),0.0,0.0,STEPZ
         DO 20 I=1,NATMS
            WRITE(IDENOUT,"(I5,4 F12.6)") NUC2(I),REAL(NUC2(I)),
     $           (COORD2(3*(I-1)+J),J=1,3)
 20      CONTINUE
      END IF
C
C     Orbital Output
      IF (IDORO.NE.0) THEN
         WRITE(IORBOUT,*) "ACES II CUBE OUTPUT"
         IF (INORBS.EQ.0) THEN
            WRITE(IORBOUT,*) "SCF Molecular Orbitals"
         ELSE
            WRITE(IORBOUT,*) "Correlated Natural Orbitals"
         END IF
         WRITE(IORBOUT,"(I5,3 F12.6)") - NATMS,BVALX,BVALY,BVALZ
         WRITE(IORBOUT,"(I5,3 F12.6)") (NPTSX+1),STEPX,0.0,0.0
         WRITE(IORBOUT,"(I5,3 F12.6)") (NPTSY+1),0.0,STEPY,0.0
         WRITE(IORBOUT,"(I5,3 F12.6)") (NPTSZ+1),0.0,0.0,STEPZ
C     
         DO 30 I=1,NATMS
            WRITE(IORBOUT,"(I5,4 F12.6)") NUC2(I),REAL(NUC2(I)),
     $           (COORD2(3*(I-1)+J),J=1,3)
 30      CONTINUE
C
         IF (IAORBO.EQ.3) THEN
            WRITE(IORBOUT,"(10 I5)") 
     $           NBASPEFF,(IORBVECA(J),J=1,NORBOUTA),
     $           (IORBVECB(J)+NBASP,J=1,NORBOUTB)
         ELSE
C     
            IF (NGRPS.NE.0) THEN
               WRITE(IORBOUT,"(10 I5)") NBASPEFF,(J,J=1,9)
            ELSE
               WRITE(IORBOUT,"(10 I5)") NBASPEFF,(J,J=1,MODVAL-1)
            END IF
C     
            IF (NGRPS.GT.1) THEN
               DO 40 I=1,NGRPS-1
                  WRITE(IORBOUT, "(10 I5)") (9+( (I-1)*10)+J,J=1,10)
 40            CONTINUE
            END IF
C     
            IF ((MODVAL.NE.0).AND.(NGRPS.NE.0)) THEN
               WRITE(IORBOUT,"(10 I5)") (9+((NGRPS-1)*10)+
     $              J,J=1,MODVAL)
            END IF
C     
         END IF
      END IF
C     
      RETURN
      END SUBROUTINE HEADER

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__skip_file_comments
     +
     +                    ( unitid,comsign )
     +
c------------------------------------------------------------------------
c  operation   : ofh__skip_file_comments
c  module      : output files handler
c  module-id   : ofh
c  description : This operation skips those lines of a formatted file
c                labeled by a one character comment sign. If the file
c                as specified by its unit id is not of the type
c                sequential formatted, processing will be aborted.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         logical    is_open

         character*10  access_type
         character*1   char,comsign
         character*11  format_type

         integer    unitid
c
c
c------------------------------------------------------------------------
c
c
c             ...check unit number and print message/stop if necessary.
c
c
         if (unitid.lt.2  .or.  unitid.gt.MAX_OUTPUT_FILES) then
             write (*,*) ' Unit number out of range in routine: '
             write (*,*) ' ofh__skip_file_comments '
             write (1,*) ' Unit number out of range in routine: '
             write (1,*) ' ofh__skip_file_comments '
             call  ofh__stop
         end if
c
c
c             ...inquire the access type, format type and open status
c                of the unit.
c
c
         inquire  (unit   = unitid,
     +             access = access_type,
     +             form   = format_type,
     +             opened = is_open)
c
c
c             ...abort calling program, if file is not of the right
c                type.
c
c
         if ( format_type.ne.'formatted' .or.
     +        access_type.ne.'sequential' ) then
              write (*,*) ' Wrong file type! '
              write (*,*) ' access,form = ',access_type,format_type
              write (*,*) ' ofh__skip_file_comments '
              write (1,*) ' Wrong file type! '
              write (1,*) ' access,form = ',access_type,format_type
              write (1,*) ' ofh__skip_file_comments '
              call  ofh__stop
         end if
c
c
c             ...proceed if unit is open and file is being used.
c
c
         if ( is_open .and. file_handle (unitid).eq.used ) then

 1000         read (unitid,9000) char
 9000         format (a1)
              if ( char.ne.comsign ) then
                   call  ofh__backspace_unit (unitid)
                   return
              end if
              goto 1000

         else
              write (*,*) ' Unit not connected in routine: '
              write (*,*) ' ofh__skip_file_comments '
              write (1,*) ' Unit not connected in routine: '
              write (1,*) ' ofh__skip_file_comments '
              call  ofh__stop
         end if
c
c
c             ...ready!
c
c
         return
         end

      subroutine dgemv_prt(trans,m,n,alpha,a,lda,x,incx,beta,y,incy,
     &                     label,labely,start,step)
      implicit none

      double precision alpha, beta
      integer incx, incy, lda, m, n
      character*1 trans
      double precision a(lda,*), x(*), y(*)
      character*(*) label, labely
      integer start, step

      character*(80) header
      integer i, info
c
      info = 0
      if (.not.((trans.eq."N").or.(trans.eq."n").or.
     &          (trans.eq."T").or.(trans.eq."t").or.
     &          (trans.eq."C").or.(trans.eq."c")    )) then
         info = 1
      else if (m.lt.0) then
         info = 2
      else if (n.lt.0) then
         info = 3
      else if (lda.lt.max(1,m)) then
         info = 6
      else if (incx.eq.0) then
         info = 8
      else if (incy.eq.0) then
         info = 11
      end if
      if (info.ne.0) then
         call xerbla("DGEMV_PRT",info)
         return
      end if

      if ((m.eq.0).or.(n.eq.0).or.
     $    ((alpha.eq.(0.0D0)).and.(beta.eq.(1.0D0)))) return

c This was in the original code. I wonder why?
      if (alpha.eq.(0.0D0)) return

      if ((trans.eq."N").or.(trans.eq."n")) then
         do i = 0,(m-1)
            write(header,'(4A,I3,3A,I3,A,F10.6,A)')
     &         label," ",
     &         labely,"(",start+(i*step),") = ",
     &         labely,"(",start+(i*step),") [* ",beta,"] +"
            call ddot_prt(n,a((1+i),1),lda,x,incx,header,alpha)
         end do
      else
         do i = 0,(n-1)
            write(header,'(4A,I3,3A,I3,A,F10.6,A)')
     &         label," ",
     &         labely,"(",start+(i*step),") = ",
     &         labely,"(",start+(i*step),") [* ",beta,"] +"
            call ddot_prt(m,a(1,(1+(i*lda))),1,x,incx,header,alpha)
         end do
      end if
      return
      end

      SUBROUTINE GETALT(Z,LENGTH,ICACHE,LSTNUM)
C
C THIS ROUTINE RETRIEVES ALL IRREPS OF A SYMMETRY PACKED DISTRIBUTION
C  AND PLACES THEIR *TRANSPOSES* IN VECTOR Z.  LENGTH IS THE TOTAL LENGTH 
C  OF THE LIST, LSTNUM IS THE NUMBER OF THE LIST ON THE MOINTS FILE.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(LENGTH)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),D(18)
C
C  LOOP OVER IRREPS.
C
      IOFF=1
      ILIST=LSTNUM
      IF(ILIST.GT.100)ILIST=LSTNUM
      TOTSIZ=ISYMSZ(ISYTYP(1,ILIST),ISYTYP(2,ILIST))
      ITOP=IOFF+IINTFP*TOTSIZ
      DO 10 IRREP=1,NIRREP
C
C GET NUMBER OF DISTRIBUTIONS AND DISTRIBUTION SIZE.
C
       NUMDIS=IRPDPD(IRREP,ISYTYP(2,ILIST))
       DISSIZ=IRPDPD(IRREP,ISYTYP(1,ILIST))
       ITOP2=ITOP+IINTFP*DISSIZ
C
C STUFF VECTOR INTO Z.
C
       IF(NUMDIS.EQ.0)GOTO 10
       CALL GETTRN(Z(IOFF),Z(ITOP),DISSIZ,NUMDIS,ICACHE,IRREP,LSTNUM)
       IOFF=IOFF+NUMDIS*DISSIZ
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine returns the number of elements and the offset of the first
c element that a numbered process would control in a parallel environment.
c The main purpose of this routine is to localize the load-balancing algorithm.

c INPUT
c int iNode  : the node ID (from 0) whose statistics are to be measured
c int nNodes : the total number of nodes in the workspace
c int iRoot  : the node ID of the virtual root (who gets extra elements)
c int nTotal : the total number of elements to divvy up

c OUTPUT
c int iOff : the offset of the first element in the batch
c int nEls : the number of elements in the batch

      subroutine paces_batch_stat(iNode,nNodes,iRoot,nTotal,iOff,nEls)
      implicit none

c ARGUMENTS
      integer iNode, nNodes, iRoot, nTotal, iOff, nEls

c INTERNAL VARIABLES
      integer iFloor, iLeft
      integer iNode2
      integer iTmp

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert 0 <= (iNode|iRoot) < nNodes
      if ((nNodes.le.iNode).or.(iNode.lt.0).or.
     &    (nNodes.le.iRoot).or.(iRoot.lt.0)    ) then
         print *, '@PACES_BATCH_STAT: Assertion failed.'
         print *, '   nNodes = ',nNodes
         print *, '   iNode  = ',iNode
         print *, '   iRoot  = ',iRoot
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif

c ----------------------------------------------------------------------

      if (nTotal.lt.0) then
         print *, '@PACES_BATCH_STAT: The total number of elements ',
     &            'must be >= 0.'
         print *, '                   nTotal = ',nTotal
         call aces_exit(1)
      end if

      iFloor = nTotal/nNodes
      iLeft  = mod(nTotal,nNodes)

c   o the sexy version
c      iNode2 = mod(iNode+nNodes-iRoot,nNodes)
c      iOff   = iFloor*iNode2 + min(iNode2,iLeft)
c      nEls   = iFloor + min(1,(iLeft/(1+iNode2)))

c   o the naive version is a lot faster w/o the mod and integer divide
      iNode2 = iNode-iRoot
      if (iNode.lt.iRoot) iNode2 = iNode2+nNodes
      nEls = iFloor
      iOff = iFloor*iNode2 + iLeft
      if (iNode2.lt.iLeft) then
         nEls = iFloor+1
         iOff = nEls*iNode2
      end if

      return
c     end subroutine paces_batch_stat
      end

      subroutine compute_return_2SOIY(a1,a2,b1,b2,c1,c2,d1,d2,scr,
     *                 maxblk, iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 SOI_JY, nsend)

c---------------------------------------------------------------------------
c   The block of integrals (a1:a2,b1:b2,c1:c2,d1:d2) is computed for the
c   following 'types' of integrals based on atomic labels.
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2
      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, n, m, r, s
      integer a,b,c,d

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer me, ierr
      integer nc1, nc2, nd1, nd2

      integer imin, zmin, iblk, zblk
 
      INTEGER     DER1X,DER2X,DER3X,DER4X
      INTEGER     DER1Y,DER2Y,DER3Y,DER4Y
      INTEGER     DER1Z,DER2Z,DER3Z,DER4Z

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4
      double precision y

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision SOI_JY(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision scr(*)
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      integer*8 ccbeg_pack64(max_dim_coeff), ccend_pack64(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff),
     *                 pcoeff_pack(max_dim_coeff)
      integer*8 arg64(25)

      common /Imax_com/sz_max(max_shells,max_shells), delta
      double precision sz_max, delta
      double precision itol, bmax, dtemp, emax

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      save me,alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack,
     *     ccbeg_pack64, ccend_pack64

      call mpi_comm_rank(mpi_comm_world, me, ierr)
c      print *,'Task ',me,' computing integrals for ',a1,a2,b1,b2,
c     *     c1,c2,d1,d2
c      call c_flush_stdout()

      adim = a2-a1+1
      bdim = b2-b1+1
      cdim = c2-c1+1
      ddim = d2-d1+1
      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical

c Set the integral tolerance

      call set_itol(delta,itol)

c     write(6,*) ' DELTA = ', delta, itol
c     itol = delta ! 1.0d-9

      nsend = adim*bdim*cdim*ddim
      if (nsend .lt. 0) then
         print *,'ERROR IN INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim,cdim,ddim = ',adim,bdim,cdim,ddim
         call mpi_abort(mpi_comm_world, ierr)
      endif

      do d = d1,d2
      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         SOI_JY(a,b,c,d) = 0.d0
      enddo
      enddo
      enddo
      enddo
c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         call lookup_shell(end_nfps, nshells, a1, m1)
         call lookup_shell(end_nfps, nshells, a2, m2)
         call lookup_shell(end_nfps, nshells, b1, n1)
         call lookup_shell(end_nfps, nshells, b2, n2)
         call lookup_shell(end_nfps, nshells, c1, r1)
         call lookup_shell(end_nfps, nshells, c2, r2)
         call lookup_shell(end_nfps, nshells, d1, s1)
         call lookup_shell(end_nfps, nshells, d2, s2)

CSSS         Write(6,*)
CSSS         Write(6,*) "Loop over shell quads."
CSSS         Write(6,"(4(a,1x,I4,1x,I4,1x))") "m1 and m2: ", m1, m2,
CSSS     &                                    "n1 and N2: ", n1, n2,
CSSS     &                                    "r1 and r2: ", r1, r2,
CSSS     &                                    "s1 and s2: ", s1, s2

C   These are always undifferentiated

CSSS      Write(6,*) "@-entry to OED_batch"
CSSS      Write(6,"((a,2(1x,i4)))") "m, n :", m, n

         DER3X = 0
         DER3Y = 0
         DER3Z = 0
         DER4X = 0
         DER4Y = 0
         DER4Z = 0

c constructing < mu nu | Jz | del gamma >
c more precisely
c Jz = <mu^x nu | del^y gamma> - <mu^y nu | del^x gamma >
c Part A
c <X ..| Y ..>

         do m = m1, m2
            if (m .eq. 1) then
               aa1 = 1
            else
               aa1 = end_nfps(m-1) + 1
            endif
            aa2 = end_nfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (n .eq. 1) then
               bb1 = 1
            else
               bb1 = end_nfps(n-1) + 1
            endif
            bb2 = end_nfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if (r .eq. 1) then
               cc1 = 1
            else
               cc1 = end_nfps(r-1) + 1
            endif
            cc2 = end_nfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)
         do s = s1, s2

               x4 = coords(1,s)
               y4 = coords(2,s)
               z4 = coords(3,s)
               call pack_coeffs(alphas, ixalpha, coeffs, ixpcoef,
     *                          ncfps, npfps, m, n,
     *                          r, s, alpha_pack, nalpha_pack,
     *                          pcoeff_pack, npcoeff_pack,
     *                          ccbeg, ccend, indx_cc,
     *                          ccbeg_pack, ccend_pack)

c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2.
c---------------------------------------------------------------------------
       ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

C
c      Write(6,*) "@-entry to ERD_batch"
c      Write(6,"((a,4(1x,i4)))") "m, n, r, s:", m, n, r, s
c      Write(6,"(a,2(1x,I4))") "The Nalpha_pack and Npcoeff_pack:",
c     &                         nalpha_pack, npcoeff_pack
c      Write(6,"((a,4(1x,i4)))") "Ivanagmom:", Ivangmom(m),
c     &      Ivangmom(n), Ivangmom(r), Ivangmom(s)
c      Write(6,"((a,4(1x,i4)))") "Ncfps:", Ncfps(m),
c     &      Ncfps(n), Ncfps(r), Ncfps(s)
c      Write(6,"((a,4(1x,i4)))") "Npfps:", Npfps(m),
c     &      Npfps(n), Npfps(r), Npfps(s)
c      Write(6,*)
c      Write(6,"(4(1x,F15.7))") (Alpha_pack(i),i=1,Nalpha_pack)
c      Write(6,*)
c      Write(6,"(4(1x,F15.7))")(Pcoeff_pack(i),i=1,npcoeff_pack)
c      Write(6,*)
c      Write(6,"(4(1x,I4))")(CCbeg_pack(i),i=1,Nalpha_pack)
c      Write(6,*)
c      Write(6,"(4(1x,I4))")(CCend_pack(i),i=1,Nalpha_pack)
c      Write(6,*)
c      Write(6,"(a,3(1x,I10))") "The intmax,Zmax,ncsum:",intmax, zmax,
c     &                       ncsum
c      Write(6,*) "The coordiantes"
c      Write(6,*)
c      Write(6,"(3(1x,F10.5))") x1, y1, z1
c      Write(6,"(3(1x,F10.5))") x2, y2, z2
c      Write(6,"(3(1x,F10.5))") x3, y3, z3
c      Write(6,"(3(1x,F10.5))") x4, y4, z4

        DER1X = 0
        DER1Y = 0
        DER1Z = 1
        DER2X = 1
        DER2Y = 0
        DER2Z = 0

       call ERD__SOI_BATCH_XY(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum,
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n),
     *                ivangmom(r), ivangmom(s),
     *                x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &                DER1X,DER1Y,DER1Z,
     +                DER2X,DER2Y,DER2Z,
     +                DER3X,DER3Y,DER3Z,
     +                DER4X,DER4Y,DER4Z,
     *                alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr,
     *                nints,
     *                nfirst, scr)

c---------------------------------------------------------------------------
c   Move the integrals into the output block.
c---------------------------------------------------------------------------

            if (nints .gt. 0) then

c       Write(6,*)"The <munu | lam sig> integral matrix for shell block"
c       Write(6,"(5(1x,F15.10))") (scr(nfirst-1+i),i=1,nints)

               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)

               call add_integrals(soi_Jy, a1,a2,b1,b2,c1,c2,d1,d2,
     *                             scr(nfirst),
     *                            aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,1.0d0)
            endif

c  <Y ...| X..>

        DER1X = 1
        DER1Y = 0
        DER1Z = 0
        DER2X = 0
        DER2Y = 0
        DER2Z = 1

         call ERD__SOI_BATCH_YX(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum,
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n),
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4,
     &                DER1X,DER1Y,DER1Z,
     +                DER2X,DER2Y,DER2Z,
     +                DER3X,DER3Y,DER3Z,
     +                DER4X,DER4Y,DER4Z,
     *                alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr,
     *                nints,
     *                nfirst, scr)

      if (nints .gt. 0) then
               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)

      call add_integrals(soi_Jy, a1,a2,b1,b2,c1,c2,d1,d2,
     *                            scr(nfirst),
     *                            aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,-1.d0)
      endif

         enddo   ! s
         enddo   ! r

         enddo   ! n
         enddo   ! m
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The <munu |SOI_JY| lam sig> integral matrix"
      y=0.0d0
      do a = 1, Nbasis
CSSS      Write(6,*)
      do b = 1, Nbasis
CSSS      Write(6,*)
      do c = 1, Nbasis
      do d = 1, Nbasis
CSSS      if (a .le. b .and. c .le. d) then
CSSS         Write(6, "(5(1x,F15.10))") (SOI_JY(a,b,c,d), a=1, nbasis)
         y = y + SOI_JY(a,b,c,d)*SOI_JY(a,b,c,d)
CSSS      endif
      enddo 
      enddo
      enddo
      enddo
      Write(6,"(a, F20.10)") "L_y check sum=", y
#endif

      return
      end

       SUBROUTINE SSTGEN(WIN,WOUT,NSIZE,POP1,POP2,POP3,
     &                   POP4,IPOS,IRREPX,TYPE)
C
C THIS ROUTINE RESORTS A W(PQ,RS) SYMMETRY-PACKED QUANTITY TO
C W(PS,RQ) [INTERCHANGE OF Q AND S].  
C
C INPUT :
C         WIN - THE W(PQ,RS) QUANTITY [ALL IRREPS]
C       NSIZE - THE SIZE OF THE W QUANTITY
C        POP1 - POPULATION VECTOR FOR P
C        POP2 - POPULATION VECTOR FOR Q
C        POP3 - POPULATION VECTOR FOR R
C        POP4 - POPULATION VECTOR FOR S
C      IRREPX - THE OVERALL SYMMETRY OF THE LIST (USUALLY 1)
C
C SCRATCH:
C        IPOS - A SCRATCH VECTOR OF THE MAXIMUM PS DISTRIBUTION LENGTH
C
C OUTPUT:
C        WOUT - THE RESORTED P(PS,RQ) QUANTITY
C         
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*4 TYPE
      DOUBLE PRECISION WIN(NSIZE),WOUT(NSIZE)
      DIMENSION POP1(8),POP2(8),POP3(8),POP4(8),IPOS(100)
      DIMENSION INUMLFT(8),INUMRHT(8),IABSOFF(9)
      DIMENSION IPOSRHT(8,8),IPOSLFT(8,8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRRVEC(255,2),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
C
      IF(TYPE.EQ.'1432')THEN
C
C            P Q R S -> P S R Q
C
C COMPUTE SIZE OF PS AND RQ DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 100 IRREP=1,NIRREP
        DO 110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP1(IRR2)*POP4(IRR1)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP3(IRR2)*POP2(IRR1)
110     CONTINUE        
100    CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP3(IRREP2R)*POP2(IRREP1)*
     &                            INUMLFT(IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                           POP1(IRREP2L)*POP4(IRREP1)
125     CONTINUE
120    CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 10 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER RS PAIRS
C
        DO 20 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 30 INDEX4=1,POP4(IRREP4)
          DO 35 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> psrq MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C
           ITHRU=1
           DO 40 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP1,IRREP4)
            IRREPR0=DIRPRD(IRREP3,IRREP2)
C OFFSET TO THIS IRREP OF Q WITHIN THIS RQ IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP2,IRREPR0)
            DO 50 INDEX2=1,POP2(IRREP2)
C OFFSET TO THIS Q WITHIN THIS IRREP OF Q WITHIN THIS RQ IRREP
             IOFF =IOFF0+(INDEX2-1)*POP3(IRREP3)*INUMLFT(IRREPL0)
C OFFSET TO THIS R WITHIN ...
             IOFF =IOFF +(INDEX3-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF S WITHIN THIS IRREP OF PS
             IOFF =IOFF+IPOSLFT(IRREP4,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF S WITHIN THIS IRREP OF S 
C WITHIN THIS IRREP OF PS
             IOFF =IOFF+(INDEX4-1)*POP1(IRREP1)-1 
             DO 55 INDEX1=1,POP1(IRREP1)
              IPOS(ITHRU)=IOFF+INDEX1
              ITHRU=ITHRU+1
55           CONTINUE
50          CONTINUE
40         CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
35        CONTINUE
30       CONTINUE
20      CONTINUE
10     CONTINUE 
C
      ELSEIF(TYPE.EQ.'1324')THEN
C
C            P Q R S -> P S R Q
C
C COMPUTE SIZE OF PS AND RQ DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 1100 IRREP=1,NIRREP
        DO 1110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP1(IRR2)*POP3(IRR1)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP2(IRR2)*POP4(IRR1)
1110    CONTINUE        
1100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 1120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 1125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP1(IRREP2L)*POP3(IRREP1)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP2(IRREP2R)*POP4(IRREP1)*
     &                            INUMLFT(IRRLFT)
1125    CONTINUE
1120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 1010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER RS PAIRS
C
        DO 1020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 1030 INDEX4=1,POP4(IRREP4)
          DO 1035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> prqs MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C
           ITHRU=1
           DO 1040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP1,IRREP3)
            IRREPR0=DIRPRD(IRREP2,IRREP4)
C OFFSET TO THIS IRREP OF S WITHIN THIS QS IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP4,IRREPR0)
            DO 1050 INDEX2=1,POP2(IRREP2)
C OFFSET TO THIS S WITHIN THIS IRREP OF S WITHIN THIS QS IRREP
             IOFF =IOFF0+(INDEX4-1)*POP2(IRREP2)*INUMLFT(IRREPL0)
C OFFSET TO THIS Q WITHIN ...
             IOFF =IOFF +(INDEX2-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF R WITHIN THIS IRREP OF PR
             IOFF =IOFF+IPOSLFT(IRREP3,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF R WITHIN THIS IRREP OF R
C WITHIN THIS IRREP OF PR
             IOFF =IOFF+(INDEX3-1)*POP1(IRREP1)-1 
             DO 1055 INDEX1=1,POP1(IRREP1)
              IPOS(ITHRU)=IOFF+INDEX1
              ITHRU=ITHRU+1
1055         CONTINUE
1050        CONTINUE
1040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
1035      CONTINUE
1030     CONTINUE
1020    CONTINUE
1010   CONTINUE 
C
      ELSEIF(TYPE.EQ.'1342')THEN
C
C            P Q R S -> P S Q R
C
C COMPUTE SIZE OF PS AND RQ DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 6100 IRREP=1,NIRREP
        DO 6110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP1(IRR2)*POP3(IRR1)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP4(IRR2)*POP2(IRR1)
6110    CONTINUE        
6100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 6120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 6125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP1(IRREP2L)*POP3(IRREP1)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP4(IRREP2R)*POP2(IRREP1)*
     &                            INUMLFT(IRRLFT)
6125    CONTINUE
6120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 6010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER RS PAIRS
C
        DO 6020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 6030 INDEX4=1,POP4(IRREP4)
          DO 6035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> prsq MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C
           ITHRU=1
           DO 6040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP1,IRREP3)
            IRREPR0=DIRPRD(IRREP2,IRREP4)
C OFFSET TO THIS IRREP OF Q WITHIN THIS SQ IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP2,IRREPR0)
            DO 6050 INDEX2=1,POP2(IRREP2)
C OFFSET TO THIS Q WITHIN THIS IRREP OF Q WITHIN THIS SQ IRREP
             IOFF =IOFF0+(INDEX2-1)*POP4(IRREP4)*INUMLFT(IRREPL0)
C OFFSET TO THIS S WITHIN ...
             IOFF =IOFF +(INDEX4-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF R WITHIN THIS IRREP OF PR
             IOFF =IOFF+IPOSLFT(IRREP3,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF R WITHIN THIS IRREP OF R
C WITHIN THIS IRREP OF PR
             IOFF =IOFF+(INDEX3-1)*POP1(IRREP1)-1 
             DO 6055 INDEX1=1,POP1(IRREP1)
              IPOS(ITHRU)=IOFF+INDEX1
              ITHRU=ITHRU+1
6055         CONTINUE
6050        CONTINUE
6040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
6035      CONTINUE
6030     CONTINUE
6020    CONTINUE
6010   CONTINUE 
C
      ELSEIF(TYPE.EQ.'1423')THEN
C
C            P Q R S -> P S R Q
C
C COMPUTE SIZE OF PS AND QR DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 2100 IRREP=1,NIRREP
        DO 2110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP1(IRR2)*POP4(IRR1)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP2(IRR2)*POP3(IRR1)
2110    CONTINUE        
2100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 2120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 2125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP2(IRREP2R)*POP3(IRREP1)*
     &                            INUMLFT(IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP1(IRREP2L)*POP4(IRREP1)
2125    CONTINUE
2120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 2010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER RS PAIRS
C
        DO 2020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 2030 INDEX4=1,POP4(IRREP4)
          DO 2035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> psrq MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C
           ITHRU=1
           DO 2040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP1,IRREP4)
            IRREPR0=DIRPRD(IRREP3,IRREP2)
C OFFSET TO THIS IRREP OF R WITHIN THIS QR IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP3,IRREPR0)
C OFFSET TO THIS R WITHIN THIS IRREP OF R WITHIN THIS QR IRREP
            IOFF0 =IOFF0+(INDEX3-1)*POP2(IRREP2)*INUMLFT(IRREPL0)
            DO 2050 INDEX2=1,POP2(IRREP2)
C OFFSET TO THIS Q WITHIN ...
             IOFF =IOFF0+(INDEX2-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF S WITHIN THIS IRREP OF PS
             IOFF =IOFF+IPOSLFT(IRREP4,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF S WITHIN THIS IRREP OF S 
C WITHIN THIS IRREP OF PS
             IOFF =IOFF+(INDEX4-1)*POP1(IRREP1)-1 
             DO 2055 INDEX1=1,POP1(IRREP1)
              IPOS(ITHRU)=IOFF+INDEX1
              ITHRU=ITHRU+1
2055         CONTINUE
2050        CONTINUE
2040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
2035      CONTINUE
2030     CONTINUE
2020    CONTINUE
2010   CONTINUE 
C
      ELSEIF(TYPE.EQ.'3214')THEN
C
C            P Q R S -> R Q P S
C
C COMPUTE SIZE OF PS AND QR DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 3100 IRREP=1,NIRREP
        DO 3110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP1(IRR2)*POP4(IRR1)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP3(IRR2)*POP2(IRR1)
3110    CONTINUE        
3100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 3120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 3125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP3(IRREP2L)*POP2(IRREP1)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP1(IRREP2R)*POP4(IRREP1)*
     &                            INUMLFT(IRRLFT)
3125    CONTINUE
3120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 3010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER RS PAIRS
C
        DO 3020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 3030 INDEX4=1,POP4(IRREP4)
          DO 3035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> rqps MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C
           ITHRU=1
           DO 3040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP2,IRREP3)
            IRREPR0=DIRPRD(IRREP1,IRREP4)
C OFFSET TO THIS IRREP OF S WITHIN THIS PS IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP4,IRREPR0)
C OFFSET TO THIS S WITHIN THIS IRREP OF S WITHIN THIS RS IRREP
            IOFF0 =IOFF0+(INDEX4-1)*POP1(IRREP1)*INUMLFT(IRREPL0)
            DO 3050 INDEX2=1,POP2(IRREP2)
             DO 3055 INDEX1=1,POP1(IRREP1)
C OFFSET TO THIS P WITHIN ...
              IOFF =IOFF0+(INDEX1-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF Q WITHIN THIS IRREP OF RQ
              IOFF =IOFF+IPOSLFT(IRREP2,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF Q WITHIN THIS IRREP OF Q 
C WITHIN THIS IRREP OF RQ
              IOFF =IOFF+(INDEX2-1)*POP3(IRREP3)-1 
              IPOS(ITHRU)=IOFF+INDEX3
              ITHRU=ITHRU+1
3055         CONTINUE
3050        CONTINUE
3040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
3035      CONTINUE
3030     CONTINUE
3020    CONTINUE
3010   CONTINUE 
C
      ELSEIF(TYPE.EQ.'2413')THEN
C
C            P Q R S -> Q S P R
C            1 2 3 4    2 4 1 3
C
C COMPUTE SIZE OF QS AND PR DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 4100 IRREP=1,NIRREP
        DO 4110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP1(IRR2)*POP3(IRR1)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP2(IRR2)*POP4(IRR1)
4110    CONTINUE        
4100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 4120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 4125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP2(IRREP2L)*POP4(IRREP1)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP1(IRREP2R)*POP3(IRREP1)*
     &                            INUMLFT(IRRLFT)
4125    CONTINUE
4120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 4010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER PR PAIRS
C            P Q R S -> Q S P R
C            1 2 3 4    2 4 1 3
C
        DO 4020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 4030 INDEX4=1,POP4(IRREP4)
          DO 4035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> qspr MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C 1234->2413
C
           ITHRU=1
           DO 4040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP2,IRREP4)
            IRREPR0=DIRPRD(IRREP1,IRREP3)
C OFFSET TO THIS IRREP OF R WITHIN THIS PR IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP3,IRREPR0)
C OFFSET TO THIS R WITHIN THIS IRREP OF R WITHIN THIS PR IRREP
            IOFF0 =IOFF0+(INDEX3-1)*POP1(IRREP1)*INUMLFT(IRREPL0)
            DO 4050 INDEX2=1,POP2(IRREP2)
             DO 4055 INDEX1=1,POP1(IRREP1)
C OFFSET TO THIS P WITHIN ...
              IOFF =IOFF0+(INDEX1-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF S WITHIN THIS IRREP OF QS
              IOFF =IOFF+IPOSLFT(IRREP4,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF S WITHIN THIS IRREP OF S 
C WITHIN THIS IRREP OF QS
              IOFF =IOFF+(INDEX4-1)*POP2(IRREP2)-1 
              IPOS(ITHRU)=IOFF+INDEX2
              ITHRU=ITHRU+1
4055         CONTINUE
4050        CONTINUE
4040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
4035      CONTINUE
4030     CONTINUE
4020    CONTINUE
4010   CONTINUE 
C
      ELSEIF(TYPE.EQ.'2314')THEN
C
C            P Q R S -> Q R P S
C
C COMPUTE SIZE OF PS AND QR DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 5100 IRREP=1,NIRREP
        DO 5110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP1(IRR2)*POP4(IRR1)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP2(IRR2)*POP3(IRR1)
5110    CONTINUE        
5100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 5120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 5125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
cold         IPOSLFT(IRREP1+1,IRRRHT)=IPOSLFT(IRREP1,IRRRHT)+
cold     &                            POP2(IRREP2R)*POP3(IRREP1)
cold         IPOSRHT(IRREP1+1,IRRLFT)=IPOSRHT(IRREP1,IRRLFT)+
cold     &                            POP1(IRREP2L)*POP4(IRREP1)*
cold     &                            INUMLFT(IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP2(IRREP2L)*POP3(IRREP1)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP1(IRREP2R)*POP4(IRREP1)*
     &                            INUMLFT(IRRLFT)
5125    CONTINUE
5120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 5010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER RS PAIRS
C
        DO 5020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 5030 INDEX4=1,POP4(IRREP4)
          DO 5035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> qrps MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY 1234->2314
C
           ITHRU=1
           DO 5040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP2,IRREP3)
            IRREPR0=DIRPRD(IRREP1,IRREP4)
C OFFSET TO THIS IRREP OF S WITHIN THIS PS IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP4,IRREPR0)
C OFFSET TO THIS S WITHIN THIS IRREP OF S WITHIN THIS RS IRREP
            IOFF0 =IOFF0+(INDEX4-1)*POP1(IRREP1)*INUMLFT(IRREPL0)
            DO 5050 INDEX2=1,POP2(IRREP2)
             DO 5055 INDEX1=1,POP1(IRREP1)
C OFFSET TO THIS P WITHIN ...
              IOFF =IOFF0+(INDEX1-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF R WITHIN THIS IRREP OF QR
              IOFF =IOFF+IPOSLFT(IRREP3,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF R WITHIN THIS IRREP OF R 
C WITHIN THIS IRREP OF QR
              IOFF =IOFF+(INDEX3-1)*POP2(IRREP2)-1 
              IPOS(ITHRU)=IOFF+INDEX2
              ITHRU=ITHRU+1
5055         CONTINUE
5050        CONTINUE
5040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
5035      CONTINUE
5030     CONTINUE
5020    CONTINUE
5010   CONTINUE 
      ELSEIF(TYPE.EQ.'2431')THEN
C
C            P Q R S -> Q S R P
C            1 2 3 4    2 4 3 1
C
C COMPUTE SIZE OF QS AND PR DISTRIBUTIONS FOR EACH IRREP
C
       CALL IZERO(INUMLFT,8)
       CALL IZERO(INUMRHT,8)
       DO 7100 IRREP=1,NIRREP
        DO 7110 IRR1=1,NIRREP
         IRR2=DIRPRD(IRR1,IRREP)
         INUMRHT(IRREP)=INUMRHT(IRREP)+POP3(IRR2)*POP1(IRR1)
         INUMLFT(IRREP)=INUMLFT(IRREP)+POP2(IRR2)*POP4(IRR1)
7110    CONTINUE        
7100   CONTINUE
C
C NOW COMPUTE ABSOLUTE OFFSETS TO BEGINNING OF EACH DPD IRREP
C
       IABSOFF(1)=1
       DO 7120 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX)
        IABSOFF(IRRRHT+1)=IABSOFF(IRRRHT)+
     &                    INUMLFT(IRRLFT)*INUMRHT(IRRRHT) 
        IPOSRHT(1,IRRRHT)=0
        IPOSLFT(1,IRRLFT)=0
        DO 7125 IRREP1=1,NIRREP-1
         IRREP2R=DIRPRD(IRREP1,IRRRHT)
         IRREP2L=DIRPRD(IRREP1,IRRLFT)
         IPOSLFT(IRREP1+1,IRRLFT)=IPOSLFT(IRREP1,IRRLFT)+
     &                            POP2(IRREP2L)*POP4(IRREP1)
         IPOSRHT(IRREP1+1,IRRRHT)=IPOSRHT(IRREP1,IRRRHT)+
     &                            POP3(IRREP2R)*POP1(IRREP1)*
     &                            INUMLFT(IRRLFT)
7125    CONTINUE
7120   CONTINUE
       IOFFW=1
C
C FIRST LOOP OVER RIGHT-HAND SIDE IRREPS 
C
       DO 7010 IRRRHT=1,NIRREP
        IRRLFT=DIRPRD(IRRRHT,IRREPX) 
C
C NOW LOOP OVER PR PAIRS
C            P Q R S -> Q S R P
C            1 2 3 4    2 4 3 1
C
        DO 7020 IRREP4=1,NIRREP
         IRREP3=DIRPRD(IRREP4,IRRRHT)
         DO 7030 INDEX4=1,POP4(IRREP4)
          DO 7035 INDEX3=1,POP3(IRREP3)
C
C NOW COMPUTE ADDRESSES FOR ALL DISTRIBUTION ELEMENTS IN TARGET
C VECTOR (pqrs -> qsrp MAPPING) AND SCATTER DISTRIBUTION INTO
C OUTPUT ARRAY
C 1234->2413
C
           ITHRU=1
           DO 7040 IRREP2=1,NIRREP
            IRREP1=DIRPRD(IRREP2,IRRLFT)
            IRREPL0=DIRPRD(IRREP2,IRREP4)
            IRREPR0=DIRPRD(IRREP1,IRREP3)
C OFFSET TO THIS IRREP OF P WITHIN THIS RP IRREP
            IOFF0 =IABSOFF(IRREPR0)+IPOSRHT(IRREP1,IRREPR0)
            DO 7050 INDEX2=1,POP2(IRREP2)
             DO 7055 INDEX1=1,POP1(IRREP1)
C OFFSET TO THIS P WITHIN THIS IRREP OF P WITHIN THIS RP IRREP
              IOFF =IOFF0+(INDEX1-1)*POP3(IRREP3)*INUMLFT(IRREPL0)
C OFFSET TO THIS R WITHIN ...
              IOFF =IOFF+(INDEX3-1)*INUMLFT(IRREPL0)
C OFFSET TO THIS IRREP OF S WITHIN THIS IRREP OF QS
              IOFF =IOFF+IPOSLFT(IRREP4,IRREPL0)
C OFFSET TO THIS PARTICULAR VALUE OF S WITHIN THIS IRREP OF S 
C WITHIN THIS IRREP OF QS
              IOFF =IOFF+(INDEX4-1)*POP2(IRREP2)-1 
              IPOS(ITHRU)=IOFF+INDEX2
              ITHRU=ITHRU+1
7055         CONTINUE
7050        CONTINUE
7040       CONTINUE
           CALL SCATTER(ITHRU-1,WOUT,IPOS,WIN(IOFFW))
           IOFFW=IOFFW+ITHRU-1
7035      CONTINUE
7030     CONTINUE
7020    CONTINUE
7010   CONTINUE 
C
      ENDIF
      RETURN
      END

       Subroutine Write_Prims(NATOMS, NTOT_PRIMS, NBFNS, NAOBFNS,
     &                        COORD, ALPHA, PCOEF, NUNQSHL, NSHL,
     &                        NANGMOMSHL, NCONFUNSHL, NPRIMFUNSHL,
     &                        CNT_COORD, ANGTYPE, IATMCHRG)
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "flags.h"
#include "machsp.com"
#include "jodaflags.com"                   
#include "mxatms.par"
C#include "istart.com"                      
#include "baslims.par"
C    
      DIMENSION ALPHA(NTOT_PRIMS), IPOPF(NATOMS), COORD(NATOMS*3), 
     &          NSHL(NATOMS), NANGMOMSHL(NATOMS, NUNQSHL),
     &          NCONFUNSHL(NATOMS, NUNQSHL), 
     &          NPRIMFUNSHL(NATOMS,NUNQSHL), PCOEF(NTOT_PRIMS, NBFNS), 
     &          IANGTYPE(NTOT_PRIMS), ATOM_XYZ(4, MXATMS),
     &          CNT_COORD(3,NTOT_PRIMS),CNTMU(3)
      COMMON /HIGHL/ LMNVAL(3,84), ANORM(84)
C
      DATA XTANG /0.529177249D0/ 
C
#ifdef _DEBUG_LVL0
       Write(6,*) 
       Write(6,"(a,5I4)"), "Input varaibles:",  Natoms, 
     &         nunqshl, nbfns, NTOT_PRIMS 
       Write(6,*)
       write(*, '(a)'), "The exponents"
       Write(*, '(4(1x,F10.5))') (alpha(i), i=1, NTOT_PRIMS)
       Write(6,*)
       Write(*, '(a)'), "Cartesian Coords."
       Write(*, '(3F10.5)') (Coord(i), i=1, 3*NATOMS)
       Write(6,*)
       Write(*, '(a)'), "The NSHL array"
       Write(*, '(4I5)') (Nshl(i), i=1, NATOMS)
       Write(6,*)
       Write(6,*) "The number of primitive in a shell"
       Write(6, '(4I5)') ((NPRIMFUNSHL(i,j), J=1, Nshl(i)),  
     &                    i=1,NATOMS)
       Write(6,*)
       Write(6,*) "The number of contracted functions in a shell"
       Write(6, '(4I5)') ((NCONFUNSHL(i,j), J=1, Nshl(i)),  
     &                    i=1,NATOMS)
       Write(6,*)
       Write(6,*) "The angular momentum of shells"
       Write(6, '(4I5)') ((NANGMOMSHL(i,j), J=1, Nshl(i)), 
     &                    I=1,NATOMS)
       write(6,*)
       Write(*, '(a)') "The Contractions Coef."
       write(*, '(6F10.5)') ((pcoef(i, j), i=1, NTOT_PRIMS), 
     &                        j=1,nbfns)
#endif              
      OPEN(UNIT=IUNIT, FILE="BASIS_LOG", FORM="FORMATTED", STATUS="NEW")
C       
      CALL A2GET_ANG_TYPE(NATOMs, NTOT_PRIMS, NUNQSHL, NSHL, NANGMOMSHL, 
     &                    NPRIMFUNSHL, IANGTYPE, COORD, CNT_COORD)
C
      INDEX = 0
      DO LFTPRIM = 1, NTOTPRIM
C
         INDX  = INDX + 1
         ITYPE = IANGTYPE(INDX)
C
         DO IXYZ = 1, 3
            CNTMU(IXYZ) = CNT_COORD(IXYZ, INDX)
         ENDDO
C
         LI = LMNVAL(1, ITYPE)
         MI = LMNVAL(2, ITYPE)
         NI = LMNVAL(3, ITYPE)

      ENDDO 
C

      Return
      END
		
		
	

       Subroutine Write_Prims(NATOMS, NTOT_PRIMS, NBFNS, NAOBFNS,
     &                        COORD, ALPHA, PCOEF, NUNQSHL, NSHL,
     &                        NANGMOMSHL, NCONFUNSHL, NPRIMFUNSHL,
     &                        CNT_COORD, ANGTYPE, IATMCHRG)
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C









































































































































































































































































































































































































































































































































c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end










c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C#include "istart.com"                      

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

C    
      DIMENSION ALPHA(NTOT_PRIMS), IPOPF(NATOMS), COORD(NATOMS*3), 
     &          NSHL(NATOMS), NANGMOMSHL(NATOMS, NUNQSHL),
     &          NCONFUNSHL(NATOMS, NUNQSHL), 
     &          NPRIMFUNSHL(NATOMS,NUNQSHL), PCOEF(NTOT_PRIMS, NBFNS), 
     &          IANGTYPE(NTOT_PRIMS), ATOM_XYZ(4, MXATMS),
     &          CNT_COORD(3,NTOT_PRIMS),CNTMU(3)
      COMMON /HIGHL/ LMNVAL(3,84), ANORM(84)
C
      DATA XTANG /0.529177249D0/ 
C
       Write(6,*) 
       Write(6,"(a,5I4)"), "Input varaibles:",  Natoms, 
     &         nunqshl, nbfns, NTOT_PRIMS 
       Write(6,*)
       write(*, '(a)'), "The exponents"
       Write(*, '(4(1x,F10.5))') (alpha(i), i=1, NTOT_PRIMS)
       Write(6,*)
       Write(*, '(a)'), "Cartesian Coords."
       Write(*, '(3F10.5)') (Coord(i), i=1, 3*NATOMS)
       Write(6,*)
       Write(*, '(a)'), "The NSHL array"
       Write(*, '(4I5)') (Nshl(i), i=1, NATOMS)
       Write(6,*)
       Write(6,*) "The number of primitive in a shell"
       Write(6, '(4I5)') ((NPRIMFUNSHL(i,j), J=1, Nshl(i)),  
     &                    i=1,NATOMS)
       Write(6,*)
       Write(6,*) "The number of contracted functions in a shell"
       Write(6, '(4I5)') ((NCONFUNSHL(i,j), J=1, Nshl(i)),  
     &                    i=1,NATOMS)
       Write(6,*)
       Write(6,*) "The angular momentum of shells"
       Write(6, '(4I5)') ((NANGMOMSHL(i,j), J=1, Nshl(i)), 
     &                    I=1,NATOMS)
       write(6,*)
       Write(*, '(a)') "The Contractions Coef."
       write(*, '(6F10.5)') ((pcoef(i, j), i=1, NTOT_PRIMS), 
     &                        j=1,nbfns)
      OPEN(UNIT=IUNIT, FILE="BASIS_LOG", FORM="FORMATTED", STATUS="NEW")
C       
      CALL A2GET_ANG_TYPE(NATOMs, NTOT_PRIMS, NUNQSHL, NSHL, NANGMOMSHL, 
     &                    NPRIMFUNSHL, IANGTYPE, COORD, CNT_COORD)
C
      INDEX = 0
      DO LFTPRIM = 1, NTOTPRIM
C
         INDX  = INDX + 1
         ITYPE = IANGTYPE(INDX)
C
         DO IXYZ = 1, 3
            CNTMU(IXYZ) = CNT_COORD(IXYZ, INDX)
         ENDDO
C
         LI = LMNVAL(1, ITYPE)
         MI = LMNVAL(2, ITYPE)
         NI = LMNVAL(3, ITYPE)

      ENDDO 
C

      Return
      END
		
		
	

c This routine resets the I/O statistics.

      subroutine aces_io_reset
      implicit none

c INTERNAL VARIABLES
      integer iLenMOIO, i

c COMMON BLOCKS
#include "lists.com"
#include "sympop.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_IO_RESET: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o reset the cache
      call aces_cache_reset

c   o reset the lists common block
      iLenMOIO = _MAX_IO_GRPS * _MAX_IO_FAMS
      call izero(moio,  iLenMOIO)
      call izero(moiods,iLenMOIO)
      call izero(moiosz,iLenMOIO)
      call izero(moiowd,iLenMOIO)
      call izero(moiofl,iLenMOIO)
      call izero(moiomxsz,iLenMOIO)

cYAU - There is so much bad programming related to this array that we cannot
c      destroy it.
cc   o reset the distribution types
c      call izero(isytyp,2*_MAX_IO_FAMS)

c   o reset the free-space pointers
      do i = 1, _MAX_IO_LUNS
         pRec(i)    = 1
         iIntOff(i) = 0
      end do

c   o mark MOIO as modified
      bIOMod = .true.

      return
c     end subroutine aces_io_reset
      end

      SUBROUTINE GET_REFVIB_DATA(Vcoords, Norm_coords, Vomega, Omega,
     &                           AtmMass, AtmLabel, SymLabel, Coords,   
     &                           Btmp, A2grad, Grad, Hess, Vhess,  
     &                           Imap, Vib_Type, Nreals, Natoms, 
     &                           Nvibs, B2ang, Au2Invcm, Trns_state,
     &                           Mass_Weigh_nm, Mass_Weigh_gr,
     &                           Get_hess, Get_Grad)

      Implicit Double Precision (A-H, O-Z)
C
#include <machsp.com> 
C
      Character*4 SymLabel(3*Natoms)
      Character*5 AtmLabel(Natoms)
      Character*11 Vib_Type(3*Natoms)
      Double Precision Norm_coords
C
      Logical Trns_state, Mass_weigh_nm, Get_Hess, Get_Grad, 
     &        Mass_Weigh_gr
C
      Dimension VCoords(3*Natoms), Norm_coords(9*Nreals*Nreals), 
     &          Vomega(3*Nreals), Omega(3*Nreals), AtmMass(Natoms), 
     &          Coords(3*Nreals), Btmp(Natoms), Imap(Natoms),
     &          Hess(3*Natoms,3*Natoms), Vhess(9*Natoms*Natoms),
     &          Grad(3,Natoms), A2grad(3,Natoms)

C       
      Call Getrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP,
     &            Vcoords)
      Call Getrec(20, "JOBARC", "NORMCORD", 3*Nreals*3*Nreals*
     &             IINTFP, Norm_coords)
      Call Getrec(20, "JOBARC", 'FORCECON', 3*Nreals*IINTFP,
     &            VOmega)
      Call Getcrec(20, "JOBARC", 'VIB_TYPE', 3*Nreals*11*IINTFP, 
     &             Vib_Type)
C
      Ivibs = 0
      Do Imode = 1, 3*Nreals
C
         If (Vomega(Imode) .lt. 0.0D0) Then
            Vomega(Imode) = - DSQRT(DABS(Vomega(Imode)))*Au2Invcm
         Else
            Vomega(Imode) = DSQRT(Vomega(Imode))*Au2Invcm
         Endif
C
         If (Vib_Type(Imode) .EQ. ' VIBRATION ') Then
             Ivibs = Ivibs + 1
             Omega(Ivibs) = Vomega(Imode)
         Endif
C
      Enddo
C
      If (Trns_state .AND. Omega(1) .GE. 0.0D0) Then
          Write(6, "(a)") "The IRC search must start from the TS."
CSSS          Call Errex
      Endif
C
      Call Getcrec(20, "JOBARC", "VIB_SYMS", 3*Nreals*4, SymLabel)
C
      Call Dcopy(Natoms, AtmMass, 1, Btmp, 1)
      Ireal = 0
      Icord = 1
      Jcord = 1
      Do Iatom = 1, Natoms
         Icord = Icord + (Iatom - 1)*3
         If (.Not. (Btmp(Iatom) .lt. 0.50D0)) Then
            Ireal = Ireal + 1
            Jcord = Jcord + (Ireal - 1)*3
            AtmMass(Ireal) = Btmp(Iatom)
            Call Dcopy(3, Vcoords(Icord), 1, Coords(Jcord), 1)
         Endif
         Icord = 1
         Jcord = 1
      Enddo
C
      Ivibs = 0
      Do Imode = 1, 3*Nreals
         If (Vib_Type(Imode) .EQ. ' VIBRATION ') Then
            Ivibs = Ivibs + 1
            SymLabel(Ivibs) = SymLabel(Imode)
         Endif
      Enddo
C
      Ivibs = 0
      Do Imodes = 1, 3*Nreals
C
         If (Vib_Type(Imodes) .EQ. ' VIBRATION ') Then 
            Ivibs = Ivibs + 1
            Joff  = 3*Nreals*(Ivibs  - 1) + 1
            Ioff  = 3*Nreals*(Imodes - 1) + 1
            Call Dcopy(3*Nreals, Norm_coords(Ioff), 1,
     &                 Norm_coords(Joff), 1)
         Endif
      Enddo
C
      If (Mass_weigh_nm) Then 
          Ioff = 1
          Do Imodes = 1, Nvibs
             Do Iatoms = 1, Nreals
                Sqrtmass = Dsqrt(AtmMass(Iatoms))
                Do Ixyz = 1, 3
                   Norm_coords(Ioff) = Norm_coords(Ioff)*Sqrtmass
                   Ioff = Ioff + 1
                Enddo
             Enddo
          Enddo
      Endif
C 
      If (Get_Hess) then
C           
CSSS         Call Getrec(20,'JOBARC','CART_HES',9*Natoms*Natoms*IINTFP,
CSSS     &               VHess)
          Call Getrec(20,'JOBARC','HESSIANM',9*Nreals*Nreals*IINTFP,
     &                VHess)

#ifdef _DEBUG_LVL0
         Write(6,*)  
         Write(6,*) "@get_ref_vibdata; Hessian from JARC"
         Call output(Vhess,1,3*nreals,1,3*nreals,3*nreals,3*nreals,1)
#endif
c
c-----Transform to the ZMAT order
C
         Call Zero(Hess, 9*Natoms*Natoms)
         Ioff = 1
         Do Ivmol = 1, Natoms
            Iatmzmat = Imap(Ivmol)
            Do Ixyz = 1, 3
               Icol = Ixyz + (Iatmzmat - 1)*3
               Do Jvmol = 1, Natoms
                  Jatmzmat = Imap(Jvmol)
                  If (Iatmzmat .NE. 0 .AND. Jatmzmat .NE. 0) Then
                      Irow = 1 + (Jatmzmat - 1)*3
                      Call Blkcpy(Vhess(ioff), 3, 1, Hess, 3*Natoms,
     &                            3*Natoms, Irow, Icol)
                      Ioff = Ioff + 3
                  Endif 
               Enddo
            Enddo
         Enddo
#ifdef _DEBUG_LVL0
         Write(6,*)
         Write(6,*) "@get_ref_vibdata; after reorder"
         Call output(hess,1,3*natoms,1,3*natoms,3*natoms,3*natoms,1)
#endif
C
C-----Eleminate the entry for dummy atoms
C
         Ix = 0
         Jx = 1
         Do Jatm = 1, 3*Natoms
            Do Iatm = 1, 3*Natoms
               Ink = 1 + (Iatm - 0.1)/3
               Jnk = 1 + (Jatm - 0.1)/3
               If ((AtmLabel(Ink)(1:5) .NE. 'X    ') .AND.
     &            ( AtmLabel(Jnk)(1:5) .NE. 'X    ')) Then
                   Ix = Ix + 1
                   Hess(Ix, Jx) = Hess(Iatm, Jatm)
                   If (Ix .EQ. 3*Natoms) Ix = 0
                   If (Ix .EQ. 0) Jx = Jx + 1
               Endif
           Enddo
         Enddo
C
      Endif
C     
#ifdef _DEBUG_LVL0
         Write(6,*)  
         Write(6,*) "@get_ref_vibdata; Hessian after removing dummies"
         Call output(hess,1,3*nreals,1,3*nreals,3*nreals,3*nreals,1)
#endif
C
      If (Get_Grad) Then

          Call Getrec(20,'JOBARC','GRADIENT',3*Nreals*IINTFP,
     &                A2Grad(1,1))
C
          Call Dzero(Grad, 3*Natoms)

          Do i=1, Natoms
             k=Imap(i)
             If (k .NE. 0) Then
                Do j=1,3
                   Grad(j,k)  = A2grad(j,i)
                Enddo
             Endif
          Enddo                  
C        
          Call Dcopy(3*Natoms, Grad, 1, A2grad, 1)
C
          Do i=1, Natoms
             If (Imap(i) .NE. 0) Then
                 Call Dcopy(3, A2grad(1,Imap(i)), 1, Grad(1,i), 1)
             Endif
          Enddo
C
          If (Mass_Weigh_gr) Then 
             Do Iatom = 1, Nreals
                Do Ixyz = 1, 3
                   Grad(Ixyz, Iatom) = Grad(Ixyz, Iatom)/
     &                                 Dsqrt(AtmMass(Iatom))
                Enddo
             Enddo
          Endif
C
      Endif
C
      Return
      End

      subroutine bwparend
c finish for BWCC parallelization
      implicit none
#include "bwcc.com"
#ifdef MPI
#include "mpif.h"
       integer ierror
#endif

#ifdef MPI
      write(6,*)' FINAL BARRIER MPI: nproc, myproc ',nproc,myproc
      call MPI_Barrier(MPI_COMM_WORLD,ierror)
      write(6,*)' END MPI: nproc, myproc ',nproc,myproc
      call MPI_Finalize(ierror)
#endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine print_opcounter()
      implicit none
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer ierr

      if (current_op .gt. 0) then
         print *,'Task ',me,' Current instruction counter is ',
     *      current_op,' current line number is ',current_line
      endif 
      return
      end

      Subroutine Ecp_int_typ2(Iecp_cnt, Lamau, Lambu, La, Lb, Exp1,
     &                        Exp2, Exp12, Xahat, Yahat, Zahat, Xbhat,
     &                        Ybhat, Zbhat, Xp, Yp, Zp, Xc, Yc, Zc, 
     &                        Acs_xyz, Bcs_xyz, Ca, Cb, Pc2, Fact_ab,
     &                        CA_Zero, CB_zero, Cint, Rad2_zero, 
     &                        Grads)

      Implicit Double Precision (A-H, O-Z)
      Logical Rad2_zero, CA_zero, CB_zero, Grads

#include "ecp.par"
#include "ecp.com"
   
      Dimension ACS_xyz(0:2*Maxang,3),BCS_xyz(0:2*Maxang,3)
      Dimension Rad2(0:2*Maxang,0:2*Maxang, 0:2*Maxang),
     &          Ang2_A(0:2*Maxang,-Maxproj:Maxproj,0:2*Maxang),
     &          Ang2_B(0:2*Maxang,-Maxproj:Maxproj,0:2*Maxang),
     &          Cint(Maxmem_a3)

      Lmax  = LLMax(Iecp_cnt)
      If (Grads) Then
          Lap = La + 1
         Ltot = La + Lb + 1
      Else
          Lap = La
         Ltot = La + Lb 
      Endif
C     
#ifdef _DEBUG_LVL0
CSS      Lmax = 2
      Write(6,"(a,1x,i2)") "The Lmax value = ",Lmax
      Write(6,*) "CA and CB zero?: ", CA_zero, CB_zero
#endif
C
C This handles U(l)-U(lmax), l = 0,...,lmax-1 
C
      Test = ((exp1*exp2)/exp12)*(Ca-Cb)**2
      If (Test .Gt. Tol) Then
         Rad2_zero = .True.
         Return
      Endif
           
      If (.Not. CA_zero) Then
          Lamau = Lamau + Lmax - 1
      Else
CSSS          Lamau = 1
          Lamau = 0
      Endif
      If (.Not. CB_zero) Then
          Lambu = Lambu + Lmax - 1
      Else
CSSS          Lambu = 1
          Lambu = 0
      Endif

      If (CA_zero .And. CB_zero) then
          Lprjhi = Min(Lmax-1, Lap+1, Lb+1)
          Lprjlo = Mod(Lap, 2)
          Inc    = 2
C
          If (Lprjlo .Ne. Mod(Lb,2) .Or. Lprjlo .Gt. Lprjhi) Then
             Rad2_zero = .True.
             Return
          Endif

      Elseif (CA_zero) Then
          Lprjhi = Min(Lmax-1, Lap+1)
          Lprjlo = Mod(Lap, 2)
          Inc    = 2

          If (Lprjlo .Gt. Lprjhi) Then
             Rad2_zero = .True.
             Return
          Endif
C
      Elseif (CB_zero) Then
          Lprjhi = Min(Lmax-1, Lb+1)
          Lprjlo = Mod(Lb, 2)
          Inc    = 2

          If (Lprjlo .Gt. Lprjhi) Then
             Rad2_zero = .True.
             Return
          Endif
C
      Else     
          Lprjhi = Lmax-1 
          Lprjlo = 0
          Inc    = 1
      Endif
C          
#ifdef _DEBUG_LVL0
      Write(6,*) "Initialize debug values for Lprjlo, Lprjhi"
CS      Lprjlo = 0
CS      Lprjhi = 0
      Write(6, "(a,2(1x,i3))") "Lprjlo, Lprjhi:", Lprjlo, Lprjhi
#endif
C

      Do Lprj = Lprjlo, Lprjhi, Inc

         Lamalo = Max(Lprj-Lap, 0)
         Lamahi = Min(Lprj+Lap, Lamau)
         Lamblo = Max(Lprj-Lb, 0)
         Lambhi = Min(Lprj+Lb, Lambu)

#ifdef _DEBUG_LVL0
      Write(6,"(a,1x,i2)") "Loop over lprj-lprj", lprj
      Write(6,"(a,4(1x,i2))") "Lamalo,Lamahi,Lamblo,Lambhi", 
     &                         Lamalo,Lamahi,Lamblo,Lambhi
#endif
        Call Dzero(Rad2, (2*Maxang+1)**3)
	Kcrl = Kfirst(Lprj+2, Iecp_cnt)
        Kcru = Klast(Lprj+2, Iecp_cnt)

#ifdef _DEBUG_LVL0
CS      Write(6,"(a)") "Set Debug values for Kcr and Kcru"
CS      Kcrl = 1
CS      Kcru = 1
      Write(6, "(a,2(1x,i3))") "Kcrl and Kcru:", Kcrl, Kcru
#endif
         Do Kcr = Kcrl, kcru
        
            Zeta = Zlp(Kcr)
            Np   = Nlp(Kcr)
            Dlj  = Clp(Kcr)

#ifdef _DEBUG_LVL0
CSS      Write(6,*) "Initialize debug values for Zeta, Np and Dlj"
CSS      Zeta = 3.0D0
CSS      NP   = 0
CSS      Dlj  = 1.0D0
      Write(6, "(a,(1x,i2,F10.6,1x,F10.6))") "Np,Zeta,Dlj: ",
     &      Np, Zeta, Dlj
#endif
C
            Call Ecp_rad_int_typ2(Lamalo, Lamahi, Lamblo, Lambhi,
     &                            Lamau, Lambu, Lap, Lb, Ltot, Lprj, 
     &                            Np, Exp1, Exp2, Exp12, Zeta, Dlj, 
     &                            Xahat, Yahat, Zahat, Xbhat, Ybhat, 
     &                            Zbhat, Xp, Yp, Zp, Xc, Yc, Zc, CA,
     &                            CB, Pc2, Fact_ab, Rad2, Rad2_zero)
         Enddo
C
#ifdef _DEBUG_LVLM
      write(6,"(a)") "Entering ECP_ang_int_typ2"
      Write(6,*)
#endif
           If (.Not. Rad2_zero) 
     &     call Ecp_ang_int_typ2(Xahat, Yahat, Zahat, Xbhat, Ybhat, 
     &                           Zbhat, La, Lb, Ltot, Lamalo, Lamahi, 
     &                           Lamblo, Lambhi, Lamau, Lambu, Lprj, 
     &                           Acs_xyz, Bcs_xyz, Ang2_A, Ang2_B,
     &                           Rad2, Cint, Int, Grads)

      Enddo
      
CSSS      Call Dscal(Int, Fpi, Cint, 1) 

#ifdef _DEBUG_LVL0
      If (.Not. Rad2_zero) Then
      Write(6,*)
      Write(6,"(a)") "The Type1+2 integral"
      Write(6,"(4(1x,F20.13))")(Cint(i), i=1,Int)
      Endif
#endif
C 
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_1D_CENDERV_INTEGRALS
     +
     +                    ( MIJ,MGQPIJ,
     +                      NGQP,
     +                      SHELLA,SHELLB,
     +                      EXP2AB,
     +                      P,C,
     +                      ORDER,
     +                      RTS,
     +                      TEMP,
     +                      INT1D,
     +
     +                               OUT1D )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_1D_CENDERV_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single derivation step on
C                a nuclear attraction center C for input 1D nuclear
C                attraction integrals:
C
C            I''(n,a,b,C) =   r * [  a*I'(n,a-1,b,C) + b*I'(n,a,b-1,C) ]
C                         + 2pr * [(P-C)*I'(n,a,b,C) + (1-m)*I(n,a,b,C)]
C
C                and returns the result in a separate array. The
C                explanation of the symbols in the above equation is
C                as follows:
C
C                           m  =  current differentiation order.
C                    I'',I',I  =  m-th,(m-1)-th and (m-2)-th  
C                                 differentiated 1D nuclear
C                                 attraction integral. Note, that
C                                 if m = 1, i.e. when the first order
C                                 differentiated 1D integrals are
C                                 evaluated, the (m-1) term does
C                                 not exist. It only comes into play
C                                 for 2nd and higher derivatives.
C                           r  =  the set of all quadrature roots
C                           p  =  the set of all exponent sums between
C                                 shells A and B
C                         P,C  =  gaussian product center coordinate
C                                 and nuclear attraction center
C                                 coordinate
C                                 
C
C                The derivatives of the 1D integrals are calculated for
C                all roots, all nuclear centers and the present set of
C                exponent pairs.
C
C
C                  Input:
C
C                    MIJ         =  current # of ij primitive index
C                                   pairs corresponding to the
C                                   contracted shell pairs A,B
C                    MGQPIJ      =  # of roots times # of ij primitive
C                                   index pairs
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    SHELLx      =  shell types for centers x = A and B
C                    EXP2AB      =  the MIJ distinct exponent sums
C                                   between both centers x = A and B.
C                    P           =  the MIJ coordinates for the
C                                   gaussian product centers P=A+B
C                    C           =  value of the coordinate for the
C                                   nuclear attraction center
C                    ORDER       =  current order of differentiation
C                    RTS         =  all current MGQPIJ quadrature
C                                   roots
C                    TEMP        =  scratch array that will hold all
C                                   necessary 2pr*(P-C) values, where
C                                   r are all the MGQPIJ roots
C                    INT1D       =  all (ORDER-1)-th order
C                                   differentiated input 1D nuclear
C                                   attraction integrals
C                    OUT1D       =  if ORDER >= 2, this array contains
C                                   initially all (ORDER-2)-th order
C                                   differentiated input 1D nuclear
C                                   attraction integrals
C
C
C                  Output:
C
C                    OUT1D       =  all ORDER-th order differentiated
C                                   1D nuclear attraction integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         INTEGER   A,B,K,M,N
         INTEGER   AM,AP,BM,BP
         INTEGER   IJ,NG
         INTEGER   MIJ,MGQPIJ
         INTEGER   NGQP
         INTEGER   ORDER
         INTEGER   SHELLA,SHELLB

         DOUBLE PRECISION  C,X,Y
         DOUBLE PRECISION  F1,F2
         DOUBLE PRECISION  ONE

         DOUBLE PRECISION  EXP2AB (1:MIJ)
         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  RTS    (1:MGQPIJ)
         DOUBLE PRECISION  TEMP   (1:MGQPIJ)

         DOUBLE PRECISION  INT1D (1:MGQPIJ,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  OUT1D (1:MGQPIJ,0:SHELLA,0:SHELLB)

         PARAMETER  (ONE    =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...proceed.
C
C
         IF (ORDER.LT.2) THEN

             M = 0
             DO IJ = 1,MIJ
                X = (P (IJ) - C) * EXP2AB (IJ)
                DO NG = 1,NGQP
                   TEMP (M+NG) = RTS (M+NG) * X
                END DO
                M = M + NGQP
             END DO

             DO B = 0,SHELLB
             DO A = 0,SHELLA
             DO M = 1,MGQPIJ
                OUT1D (M,A,B) = TEMP (M) * INT1D (M,A,B)
             END DO
             END DO
             END DO

         ELSE

             M = 0
             X = ONE - DFLOAT (ORDER)
             DO IJ = 1,MIJ
                Y = X * EXP2AB (IJ)
                DO NG = 1,NGQP
                   TEMP (M+NG) = RTS (M+NG) * Y
                END DO
                M = M + NGQP
             END DO

             DO B = 0,SHELLB
             DO A = 0,SHELLA
             DO M = 1,MGQPIJ
                OUT1D (M,A,B) = TEMP (M) * OUT1D (M,A,B)
             END DO
             END DO
             END DO

             M = 0
             DO IJ = 1,MIJ
                X = (P (IJ) - C) * EXP2AB (IJ)
                DO NG = 1,NGQP
                   TEMP (M+NG) = RTS (M+NG) * X
                END DO
                M = M + NGQP
             END DO

             DO B = 0,SHELLB
             DO A = 0,SHELLA
             DO M = 1,MGQPIJ
                OUT1D (M,A,B) = OUT1D (M,A,B) + TEMP (M) * INT1D (M,A,B)
             END DO
             END DO
             END DO

         END IF

         IF (SHELLA.GT.0) THEN
             F1 = ONE
             DO A = 1,SHELLA
                AM = A - 1
                DO M = 1,MGQPIJ
                   OUT1D (M,A,0) = OUT1D (M,A,0)
     +                           + F1 * RTS (M) * INT1D (M,AM,0)
                END DO
                F1 = F1 + ONE
             END DO
         END IF

         IF (SHELLB.GT.0) THEN
             F2 = ONE
             DO B = 1,SHELLB
                BM = B - 1
                DO M = 1,MGQPIJ
                   OUT1D (M,0,B) = OUT1D (M,0,B)
     +                           + F2 * RTS (M) * INT1D (M,0,BM)
                END DO

                IF (SHELLA.GT.0) THEN
                    F1 = ONE
                    DO A = 1,SHELLA
                       AM = A - 1
                       DO M = 1,MGQPIJ
                          OUT1D (M,A,B) = OUT1D (M,A,B)
     +                                  + F1 * RTS (M) * INT1D (M,AM,B )
     +                                  + F2 * RTS (M) * INT1D (M,A ,BM)
                       END DO
                       F1 = F1 + ONE
                    END DO
                END IF

                F2 = F2 + ONE
             END DO
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
            subroutine cwork4622_unopt(y, na1,na2,nb1,nb2,
     *                         nc1,nc2,nd1,nd2,
     *                         a1,a2,b1,b2,
     *                         c1, c2, d1, d2,
     *                         inda, indb, indc, indd,
c
     *                      x1,nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2,
     *                         ne1,ne2,nf1,nf2,
     *                          m1, m2, n1, n2, r1, r2, s1, s2,
     *                          e1, e2, f1, f2,
     *                      indx1,
c
     *                      x2,ni1,ni2,nj1,nj2,
     *                          i1, i2, j1, j2,
     *                      indx2,
     *                      cind, flopcount, scr1, scr2, scr3)
c-------------------------------------------------------------------------
c   Performs a "4622" contraction:
c      4 index output array  : y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
c      6 index operand array : x1(nm1:nm2,nn1:nn2,nr1:nr2,ns1:ns2,ne1:ne2,nf1:nf2)
c      2 index operand array : x2(ni1:ni2,nj1:nj2)
c      2 index contraction.
c
c   I. e., contract two of the the 4 indices of the 2nd operand array out
c   of the first operand array, replacing the indices by the 2nd operand's
c   non-contracted indices.
c--------------------------------------------------------------------------


      implicit none
      include 'trace.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *        ne1,ne2,nf1,nf2,
     *        nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2,
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2
      integer a1,a2,b1,b2,c1,c2,d1,d2,
     *        e1,e2,f1,f2,
     *        n1,n2,m1,m2,r1,r2,s1,s2,
     *        i1,i2,j1,j2,k1,k2,l1,l2
      integer inda, indb, indc, indd, inde, indf, indx1(6), indx2(2)
      integer cind(2), flopcount

      double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
      double precision x1(nm1:nm2,nn1:nn2,nr1:nr2,ns1:ns2,
     *                    ne1:ne2,nf1:nf2)
      double precision x2(ni1:ni2,nj1:nj2) 
      double precision scr1(*), scr2(*), scr3(*)
c
      integer ia,ib,ic,id,ie,if, ix_con1, ix_con2,    
     *        ix(6), ix2(2), iy
      integer ia2, ib2, ic2, id2, ie2, if2 
      integer ix2_con1, ix2_con2   
      integer bcon1, bcon2, econ1, econ2
      integer i, j, a, b, c, d, e, f, g, h
      integer lda, ldb, ldc, m, n, k, l
      integer next
      double precision x2val, xval, etemp 
      
      flopcount = 0

      do a = a1, a2
      do b = b1, b2
      do c = c1, c2
      do d = d1, d2
         y(a,b,c,d) = 0.0 
      enddo  
      enddo  
      enddo  
      enddo  
c     return 

c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various y and x2 
c   indices.
c---------------------------------------------------------------------------

      ia = 0
      ib = 0
      ic = 0
      id = 0

      do i = 1, 6
         if (indx1(i)      .eq. inda) then 
            ia = i 
         else if (indx1(i) .eq. indb) then
            ib = i 
         else if (indx1(i) .eq. indc) then
            ic = i 
         else if (indx1(i) .eq. indd) then
            id = i 
         else if (indx1(i) .eq. cind(1)) then
            ix_con1 = i
         else if (indx1(i) .eq. cind(2)) then
            ix_con2 = i
         else
            print *,'Error: Invalid index for x1 in cwork4622'
            print *,'X1 index is ',indx1(i),' y indices: ',inda, indb,
     *               indc, indd,  
     *              ' X1 indices: ',(indx1(j),j=1,6),
     *              ' cind = ',(cind(j), j=1, 2)  
            call abort_job() 
         endif
      enddo

c---------------------------------------------------------------------------
c   Find which indices of the "x2" operand match the various y and x1
c   indices.
c---------------------------------------------------------------------------

      ia2 = 0
      ib2 = 0
      ic2 = 0
      id2 = 0

      do i = 1, 2
         if (indx2(i)      .eq. inda) then 
            ia2 = i 
         else if (indx2(i) .eq. indb) then
            ib2 = i 
         else if (indx2(i) .eq. indc) then
            ic2 = i 
         else if (indx2(i) .eq. indd) then
            id2 = i 
         else if (indx2(i) .eq. cind(1)) then
            ix2_con1 = i
         else if (indx2(i) .eq. cind(2)) then
            ix2_con2 = i
         else
            print *,'Error: Invalid index for x2 in cwork4622'
            print *,'X2 index is ',indx2(i),' y indices: ',inda, indb,
     *               indc, indd, 
     *              ' X2 indices: ',(indx2(j),j=1,2),
     *              ' cind = ',(cind(j), j=1,2) 
            call abort_job() 
         endif
      enddo

c First contracted index 

      if (cind(1)      .eq. indx1(1)) then
         bcon1 = m1
         econ1 = m2
      else if (cind(1) .eq. indx1(2)) then
         bcon1 = n1
         econ1 = n2
      else if (cind(1) .eq. indx1(3)) then
         bcon1 = r1
         econ1 = r2
      else if (cind(1) .eq. indx1(4)) then
         bcon1 = s1
         econ1 = s2
      else if (cind(1) .eq. indx1(5)) then
         bcon1 = e1
         econ1 = e2
      else if (cind(1) .eq. indx1(6)) then
         bcon1 = f1
         econ1 = f2
      endif

c Second contracted index 

      if (cind(2)      .eq. indx1(1)) then
         bcon2 = m1
         econ2 = m2
      else if (cind(2) .eq. indx1(2)) then
         bcon2 = n1
         econ2 = n2
      else if (cind(2) .eq. indx1(3)) then
         bcon2 = r1
         econ2 = r2
      else if (cind(2) .eq. indx1(4)) then
         bcon2 = s1
         econ2 = s2
      else if (cind(2) .eq. indx1(5)) then
         bcon2 = e1
         econ2 = e2
      else if (cind(2) .eq. indx1(6)) then
         bcon2 = f1
         econ2 = f2
      endif

c     print *,'cwork4622: Unoptimized version lineno ',current_line
      do a = a1, a2
         if (ia  .ne. 0) ix(ia)   = a
         if (ia2 .ne. 0) ix2(ia2) = a
      do b = b1, b2
         if (ib  .ne. 0) ix(ib)   = b
         if (ib2 .ne. 0) ix2(ib2) = b
      do c = c1, c2
         if (ic  .ne. 0) ix(ic)   = c
         if (ic2 .ne. 0) ix2(ic2) = c
      do d = d1, d2
         if (id  .ne. 0) ix(id)   = d
         if (id2 .ne. 0) ix2(id2) = d

         y(a,b,c,d) = 0.
         etemp = 0.0 

         do j = bcon2, econ2 
            ix(ix_con2)   = j
            ix2(ix2_con2) = j
         do i = bcon1, econ1 
            ix(ix_con1)   = i
            ix2(ix2_con1) = i
            etemp = etemp + 
     *             x2(ix2(1),ix2(2))*
     *             x1(ix(1),ix(2),ix(3),ix(4),ix(5),ix(6))
         enddo
         enddo

         y(a,b,c,d) = etemp  
         
      enddo
      enddo
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c get 'COMPNSYQ'
c get 'COMPSYMQ'
c put 'COMPSYMQ'

      SUBROUTINE TRAPRJ(NATOM,TPROJ,SCR,SYMQ,ATMASS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SCR(1),SYMQ(1),TPROJ(1),ATMASS(1)

      CHARACTER*8 TRAREC(3)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA ONE /1.0/
      DATA TOL /1.D-10/
      DATA TRAREC /'TRAVECX ','TRAVECY ','TRAVECZ '/

      CALL DGETREC(20,'JOBARC','ATOMMASS',NATOM,ATMASS)

C CONSTRUCT THE TRANSLATIONAL PROJECTOR IN MASS WEIGHTED COORDS
C           1 - SUM |T><T|

      NSIZE=3*NATOM
      CALL ZERO(TPROJ,NSIZE*NSIZE)
      IOFF=1
      DO I=1,NSIZE
         TPROJ(IOFF)=ONE
         IOFF=IOFF+NSIZE+1
      END DO
      DO IXYZ=1,3
         CALL ZERO(SCR,NSIZE)
         ndx = IXYZ
         DO I=1,NATOM
            SCR(ndx)=SQRT(ATMASS(I))
            ndx = ndx + 3
         END DO
         FACT=ONE/DNRM2(NSIZE,SCR,1)
         CALL XDSCAL(NSIZE,FACT,SCR,1)
         CALL DPUTREC(20,'JOBARC',TRAREC(IXYZ),NSIZE,SCR)
         CALL XGEMM('N','N',NSIZE,NSIZE,1,
     &              -1.d0,SCR,  NSIZE,
     &                    SCR,  1,
     &              ONE,  TPROJ,NSIZE)
      END DO

c   o hit symmetry adapted coordinates with projector
      CALL IGETREC(20,'JOBARC','COMPNSYQ',1,NSYMOLD)
      CALL DGETREC(20,'JOBARC','COMPSYMQ',NSYMOLD*NSIZE,SCR)
      CALL XGEMM('N','N',NSIZE,NSYMOLD,NSIZE,ONE,TPROJ,NSIZE,
     &           SCR,NSIZE,0.d0,SYMQ,NSIZE)

c   o renormalize
      IOFF=1
      DO I=1,NSYMOLD
         X=DNRM2(NSIZE,SYMQ(IOFF),1)
         IF (ABS(X).GT.TOL) THEN
            Z=ONE/X
            CALL XDSCAL(NSIZE,Z,SYMQ(IOFF),1)
            IOFF=IOFF+NSIZE
         END IF
      END DO

      CALL DPUTREC(20,'JOBARC','COMPSYMQ',NSYMOLD*NSIZE,SYMQ)

      RETURN
      END

*DECK DSORT
      SUBROUTINE DSORT (DX, DY, N, KFLAG)
C***BEGIN PROLOGUE  DSORT
C***PURPOSE  Sort an array and optionally make the same interchanges in
C            an auxiliary array.  The array may be sorted in increasing
C            or decreasing order.  A slightly modified QUICKSORT
C            algorithm is used.
C***LIBRARY   SLATEC
C***CATEGORY  N6A2B
C***TYPE      DOUBLE PRECISION (SSORT-S, DSORT-D, ISORT-I)
C***KEYWORDS  SINGLETON QUICKSORT, SORT, SORTING
C***AUTHOR  Jones, R. E., (SNLA)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C   DSORT sorts array DX and optionally makes the same interchanges in
C   array DY.  The array DX may be sorted in increasing order or
C   decreasing order.  A slightly modified quicksort algorithm is used.
C
C   Description of Parameters
C      DX - array of values to be sorted   (usually abscissas)
C      DY - array to be (optionally) carried along
C      N  - number of values in array DX to be sorted
C      KFLAG - control parameter
C            =  2  means sort DX in increasing order and carry DY along.
C            =  1  means sort DX in increasing order (ignoring DY)
C            = -1  means sort DX in decreasing order (ignoring DY)
C            = -2  means sort DX in decreasing order and carry DY along.
C
C***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
C                 for sorting with minimal storage, Communications of
C                 the ACM, 12, 3 (1969), pp. 185-187.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   761101  DATE WRITTEN
C   761118  Modified to use the Singleton quicksort algorithm.  (JAW)
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891024  Changed category.  (WRB)
C   891024  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   901012  Declared all variables; changed X,Y to DX,DY; changed
C           code to parallel SSORT. (M. McClain)
C   920501  Reformatted the REFERENCES section.  (DWL, WRB)
C   920519  Clarified error messages.  (DWL)
C   920801  Declarations section rebuilt and code restructured to use
C           IF-THEN-ELSE-ENDIF.  (RWC, WRB)
C***END PROLOGUE  DSORT
C     .. Scalar Arguments ..
      INTEGER KFLAG, N
C     .. Array Arguments ..
      DOUBLE PRECISION DX(*), DY(*)
C     .. Local Scalars ..
      DOUBLE PRECISION R, T, TT, TTY, TY
      INTEGER I, IJ, J, K, KK, L, M, NN
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. External Subroutines ..
      EXTERNAL XERMSG
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C***FIRST EXECUTABLE STATEMENT  DSORT
      NN = N
      IF (NN .LT. 1) THEN
         CALL XERMSG ('SLATEC', 'DSORT',
     +      'The number of values to be sorted is not positive.', 1, 1)
         RETURN
      ENDIF
C
      KK = ABS(KFLAG)
      IF (KK.NE.1 .AND. KK.NE.2) THEN
         CALL XERMSG ('SLATEC', 'DSORT',
     +      'The sort control parameter, K, is not 2, 1, -1, or -2.', 2,
     +      1)
         RETURN
      ENDIF
C
C     Alter array DX to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 10 I=1,NN
            DX(I) = -DX(I)
   10    CONTINUE
      ENDIF
C
      IF (KK .EQ. 2) GO TO 100
C
C     Sort DX only
C
      M = 1
      I = 1
      J = NN
      R = 0.375D0
C
   20 IF (I .EQ. J) GO TO 60
      IF (R .LE. 0.5898437D0) THEN
         R = R+3.90625D-2
      ELSE
         R = R-0.21875D0
      ENDIF
C
   30 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = DX(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (DX(I) .GT. T) THEN
         DX(IJ) = DX(I)
         DX(I) = T
         T = DX(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than than T, interchange with T
C
      IF (DX(J) .LT. T) THEN
         DX(IJ) = DX(J)
         DX(J) = T
         T = DX(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (DX(I) .GT. T) THEN
            DX(IJ) = DX(I)
            DX(I) = T
            T = DX(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
   40 L = L-1
      IF (DX(L) .GT. T) GO TO 40
C
C     Find an element in the first half of the array which is greater
C     than T
C
   50 K = K+1
      IF (DX(K) .LT. T) GO TO 50
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = DX(L)
         DX(L) = DX(K)
         DX(K) = TT
         GO TO 40
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 70
C
C     Begin again on another portion of the unsorted array
C
   60 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
   70 IF (J-I .GE. 1) GO TO 30
      IF (I .EQ. 1) GO TO 20
      I = I-1
C
   80 I = I+1
      IF (I .EQ. J) GO TO 60
      T = DX(I+1)
      IF (DX(I) .LE. T) GO TO 80
      K = I
C
   90 DX(K+1) = DX(K)
      K = K-1
      IF (T .LT. DX(K)) GO TO 90
      DX(K+1) = T
      GO TO 80
C
C     Sort DX and carry DY along
C
  100 M = 1
      I = 1
      J = NN
      R = 0.375D0
C
  110 IF (I .EQ. J) GO TO 150
      IF (R .LE. 0.5898437D0) THEN
         R = R+3.90625D-2
      ELSE
         R = R-0.21875D0
      ENDIF
C
  120 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = DX(IJ)
      TY = DY(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (DX(I) .GT. T) THEN
         DX(IJ) = DX(I)
         DX(I) = T
         T = DX(IJ)
         DY(IJ) = DY(I)
         DY(I) = TY
         TY = DY(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than T, interchange with T
C
      IF (DX(J) .LT. T) THEN
         DX(IJ) = DX(J)
         DX(J) = T
         T = DX(IJ)
         DY(IJ) = DY(J)
         DY(J) = TY
         TY = DY(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (DX(I) .GT. T) THEN
            DX(IJ) = DX(I)
            DX(I) = T
            T = DX(IJ)
            DY(IJ) = DY(I)
            DY(I) = TY
            TY = DY(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
  130 L = L-1
      IF (DX(L) .GT. T) GO TO 130
C
C     Find an element in the first half of the array which is greater
C     than T
C
  140 K = K+1
      IF (DX(K) .LT. T) GO TO 140
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = DX(L)
         DX(L) = DX(K)
         DX(K) = TT
         TTY = DY(L)
         DY(L) = DY(K)
         DY(K) = TTY
         GO TO 130
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 160
C
C     Begin again on another portion of the unsorted array
C
  150 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
  160 IF (J-I .GE. 1) GO TO 120
      IF (I .EQ. 1) GO TO 110
      I = I-1
C
  170 I = I+1
      IF (I .EQ. J) GO TO 150
      T = DX(I+1)
      TY = DY(I+1)
      IF (DX(I) .LE. T) GO TO 170
      K = I
C
  180 DX(K+1) = DX(K)
      DY(K+1) = DY(K)
      K = K-1
      IF (T .LT. DX(K)) GO TO 180
      DX(K+1) = T
      DY(K+1) = TY
      GO TO 170
C
C     Clean up
C
  190 IF (KFLAG .LE. -1) THEN
         DO 200 I=1,NN
            DX(I) = -DX(I)
  200    CONTINUE
      ENDIF
      RETURN
      END

C I don't know who wrote this (or why) but we use it and we'll have to suffer
C the consequences. The old incarnation of this routine crashed the optimizer
C in Sun's compiler(s), but the new one doesn't. This is really a textbook
C example of how to fool optimizers and how not to write code. - ADY

      SUBROUTINE MODMATMUL(A,B,C,NA,NB,NC,NTA,NTB,NTC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION B(NA,NB),C(NB,NC),A(NA,NC)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
      DOUBLE PRECISION SCRATCH(3*MxAtms,3*MxAtms)
      if (nta.gt.3*MxAtms) then
         print *, '@MODMATMUL: Assertion failed.'
         print *, '   scratch dimension = ',3*MxAtms
         print *, '   leading dimension = ',nta
         call aces_exit(1)
      end if
      DO J=1,NTC
         DO I=1,NTA
            SCRATCH(I,J)=0.D0
            DO K=1,NTB
               SCRATCH(I,J)=SCRATCH(I,J)+B(I,K)*C(K,J)
            END DO
         END DO
      END DO
      DO J=1,NTC
         DO I=1,NTA
            A(I,J)=SCRATCH(I,J)
         END DO
      END DO
      RETURN
      END

C       SUBROUTINE MODMATMUL(A,B,C,NA,NB,NC,NTA,NTB,NTC)
C C
C CJDW 1/6/98. This used to be called MATMUL. Name was changed since
C C            apparently MATMUL is a reserved name in Fortran 90. Note
C C            that it is not trivial to replace MATMUL by XGEMM since in
C C            BUILDB MATMUL (MODMATMUL) is called with A and C sharing same
C C            memory location.
C C
C       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C C     Maximum number of atoms currently allowed
C #include "mxatms.par"
C       DIMENSION B(NA,NB),C(NB,NC),A(NA,NC),SCRATCH(3*MxAtms,3*MxAtms)
C       DO 10 I=1,NTA
C       DO 10 J=1,NTC
C       Z=0.D0
C       DO 20 K=1,NTB
C 20    Z=Z+B(I,K)*C(K,J)
C       SCRATCH(I,J)=Z
C 10    CONTINUE
C       DO 15 I=1,NTA
C       DO 15 J=1,NTC
C 15    A(I,J)=SCRATCH(I,J)
C       RETURN
C       END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine check_for_server_array(node, server_table, 
     *                                    nserver_table)
c---------------------------------------------------------------------------
c   This subroutine performs error checking on the array used in the 
c   server message in "node".
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_stat.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      integer node
      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)

      integer msg_type, ierr
      integer i, array, ix, ptr, ptr2

      if (node .lt. 1 .or. node .gt. nmessage_buffers) then
         print *,'Task ',me,' NODE RANGE ERR: node ',node
         call server_abort_job(server_table, nserver_table)
      endif

      msg_type = server_msg(c_msg_type,node)

      if (msg_type .eq. server_request_msgtype) then

c-------------------------------------------------------------------------
c   REQUEST MESSAGE
c-------------------------------------------------------------------------

         array = server_msg(c_msg_array,node)
         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               ix = i
               go to 100 
            endif
         enddo
         print *,'Server ',me,' REQUEST Cannot find array ',array
         call server_abort_job(server_table, nserver_table)

  100 continue
         if (served_array_status(ix) .eq. 0) then
            served_array_status(ix) = readonly_flag
         else if (served_array_status(ix) .ne. readonly_flag) then
            print *,'Server ',me,' Error: Array ',array,' is ',
     *          ' writeonly, but   REQUEST has been received.'
            print *,'ix, served_array_status(ix) = ',
     *           ix, served_array_status(ix)
            print *,'Server ',me,' Processing node ',node
            call server_abort_job(server_table, nserver_table)
         endif

      else  if (msg_type .eq. server_prepare_msgtype) then

c-------------------------------------------------------------------------
c   PREPARE MESSAGE
c--------------------------------------------------------------------------

         array = server_msg(c_msg_array,node)
         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               ix = i
               go to 200 
            endif
         enddo
         print *,'Server ',me,' PREPARE Cannot find array ',array
         call server_abort_job(server_table, nserver_table)

  200 continue
         if (served_array_status(ix) .eq. 0) then
            served_array_status(ix) = writeonly_flag
         else if (served_array_status(ix) .ne. writeonly_flag) then
            print *,'Server ',me,' Error: Array ',array,' is ',
     *          ' readonly, but a PREPARE has been received.'
            print *,'ix, served_array_status(ix) = ',
     *           ix, served_array_status(ix)
            print *,'Server ',me,' Processing node ',node
            call server_abort_job(server_table, nserver_table)
         endif

      else if (msg_type .eq. server_prepare_increment) then

c--------------------------------------------------------------------------
c   PREPARESUM MESSAGE
c--------------------------------------------------------------------------

         array = server_msg(c_msg_array,node)
         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               ix = i
               go to 300 
            endif
         enddo
         print *,'Server ',me,' PREPARESUM Cannot find array ',array
         call server_abort_job(server_table, nserver_table)

  300 continue
         if (served_array_status(ix) .eq. 0) then
            served_array_status(ix) = writeonly_flag
         else if (served_array_status(ix) .ne. writeonly_flag) then
            print *,'Server ',me,' Error: Array ',array,' is ',
     *          ' readonly, but a PREPARESUM has been received.'
            print *,'Server ',me,' Processing node ',node
            call server_abort_job(server_table, nserver_table)
         endif

      else if (msg_type .eq. server_prequest_msg) then

c-------------------------------------------------------------------------
c   PREQUEST MESSAGE
c-------------------------------------------------------------------------

         array = server_msg(c_msg_array,node)
         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               ix = i
               go to 400 
            endif
         enddo
         print *,'Server ',me,' PREQUEST Cannot find array ',array
         call server_abort_job(server_table, nserver_table)

  400 continue
         if (served_array_status(ix) .eq. 0) then
            served_array_status(ix) = readonly_flag
         else if (served_array_status(ix) .ne. readonly_flag) then
            print *,'Server ',me,' Error: Array ',array,' is ',
     *          ' writeonly, but   PREQUEST has been received.'
            print *,'ix, served_array_status(ix) = ',
     *           ix, served_array_status(ix)
            print *,'Server ',me,' Processing node ',node
            call server_abort_job(server_table, nserver_table)
         endif
      endif

      return
      end

c complex division, (cr,ci) = (ar,ai)/(br,bi)

      subroutine cdiv(ar,ai,br,bi,cr,ci)
      double precision ar,ai,br,bi,cr,ci
      double precision s,ars,ais,brs,bis,s_inv
c old
c      s = dabs(br) + dabs(bi)
c      ars = ar/s
c      ais = ai/s
c      brs = br/s
c      bis = bi/s
c      s = brs**2 + bis**2
c      cr = (ars*brs + ais*bis)/s
c      ci = (ais*brs - ars*bis)/s
c new
      s_inv = 1.0d0 / ( dabs(br) + dabs(bi) )
      ars = ar * s_inv
      ais = ai * s_inv
      brs = br * s_inv
      bis = bi * s_inv
      s_inv = 1.0d0 / ( brs*brs + bis*bis )
      cr = (ars*brs + ais*bis) * s_inv
      ci = (ais*brs - ars*bis) * s_inv
c end
      return
      end

c This routine defines the default values for the common blocks in
c cache.com.

      blockdata aces_bd_cache
      implicit none
#define NO_EXTERNAL
#include "cache.com"
      data cachemiss, cacheskip,
     &     cacheread, cachewrite, cachewriteback /5*0/
      data bCacheUp /.false./
      end

C
C     THIS SUBROUTINE CALCULATES THE FOLLOWING CONTRIBUTIOBN TO THE
C     T1 INCREMENT (LAMBDA = .FALSE.)
C
C      Z(I,A) = - SUM M,n,e T(Mn,Ae) <Mn//Ie>
C
C OR   Z(i,a) = - SUM M,n,E T(Mn,Ea) <Mn//Ei)
C
C     OR TO THE L1 INCREMENT (LAMBDA = .TRUE)
C
C      Z(I,A) = - SUM M,n,e L(Mn,Ae) <Mn//Ie>
C
C OR   Z(i,a) = - SUM M,n,E L(Mn,Ea) <Mn//Ei)
C
C  FOR RHF A SPIN ADAPTED CODE HAS BEEN IMPLEMENTED
C
C  CODED JUNE/90  JG
C     
      SUBROUTINE T2T1AB2(W,ICORE,MAXCOR,POP1,POP2,VRT1,VRT2,ISPIN,IUHF,
     &                LAMBDA,LSTOFF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LAMBDA
      INTEGER DIRPRD,DISSYT,DISSYW,POP1,POP2,VRT1,VRT2
      DIMENSION ICORE(MAXCOR),POP1(8),POP2(8),VRT1(8),VRT2(8)
      DIMENSION W(1)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /FLAGS/ IFLAGS(100)
C
      DATA ZERO,ONE,ONEM,TWO /0.0D0,1.0D0,-1.0D0,2.D0/
C
C  The iflags(39) flag, reserved for "standard" or "semicanonical" 
C  orbitals, is used here to determine which list is needed for the
C  ROHF-MBPT code, since this routine is called by two others at
C  different times.  The value of "99" is set before the second call
C  to E3S in ROHFPT.
C
      IF(LAMBDA) THEN
       LISTT=146
      ELSEIF(IFLAGS(11).EQ.2.AND.IFLAGS(39).EQ.99) THEN
       LISTT=96
      ELSE
       LISTT=46
      ENDIF
      LISTW=11-ISPIN+LSTOFF
C
C    LOOP OVER IRREPS
C
      DO 1000 IRREP=1,NIRREP
      DISSYW=IRPDPD(IRREP,ISYTYP(1,LISTW))
      DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
      NUMSYW=IRPDPD(IRREP,ISYTYP(2,LISTW))
      NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
      I001=1
      I002=I001+IINTFP*NUMSYT*DISSYT
      I003=I002+IINTFP*MAX(NUMSYW*DISSYW,NUMSYT*DISSYT)
      I004=I003+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
      I005=I004+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
      I006=I005+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
      IF(I006.LT.MAXCOR) THEN 
       CALL GETLST(ICORE(I002),1,NUMSYT,1,IRREP,LISTT)
C
C  SPIN ADAPTED CODE FOR RHF
C
       IF(IUHF.EQ.0) THEN
        CALL SYMTRA(IRREP,POP1,POP2,DISSYT,ICORE(I002),ICORE(I001))
        CALL SSCAL(NUMSYT*DISSYT,TWO,ICORE(I002),1)
        CALL SAXPY(NUMSYT*DISSYT,ONEM,ICORE(I001),1,ICORE(I002),1)
       ENDIF
C
       CALL TRANSP(ICORE(I002),ICORE(I001),NUMSYT,DISSYT)
       IF(ISPIN.EQ.1) THEN
        CALL SYMTR1(IRREP,VRT1,VRT2,NUMSYT,ICORE(I001),ICORE(I003),
     &              ICORE(I004),ICORE(I005))
       ENDIF
       CALL GETLST(ICORE(I002),1,NUMSYW,2,IRREP,LISTW)
       IF(ISPIN.EQ.1) THEN
        CALL SYMTR1(IRREP,POP1,VRT2,DISSYW,ICORE(I002),ICORE(I003),
     &              ICORE(I004),ICORE(I005))
       ENDIF
       IOFFT=0
       IOFFW=0 
       IOFFS=1
       DO 100 IRREPJ=1,NIRREP 
        NVRTJ=VRT1(IRREPJ)
        NOCCJ=POP1(IRREPJ)
        IRREPI=DIRPRD(IRREPJ,IRREP)
        NVRTI=VRT2(IRREPI)
C
        IF(NVRTI.EQ.0.OR.NOCCJ.EQ.0.OR.NVRTJ.EQ.0) GO TO 90
        CALL XGEMM('T','N',NVRTJ,NOCCJ,NVRTI*DISSYW,ONEM,
     &              ICORE(I001+IOFFT*IINTFP),NUMSYT*NVRTI,
     &              ICORE(I002+IINTFP*IOFFW),DISSYW*NVRTI,ONE,
     &              W(IOFFS),NVRTJ)
90      CONTINUE
        IOFFT=IOFFT+NVRTI*NVRTJ*NUMSYT
        IOFFW=IOFFW+NVRTI*NOCCJ*DISSYW
        IOFFS=IOFFS+NVRTJ*NOCCJ
100    CONTINUE
      ELSE
       STOP 'W5AB'
      ENDIF
1000  CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine remove_xxsd(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)

c--------------------------------------------------------------------------
c
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer*8 get_block_index
      integer stack

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix.
c---------------------------------------------------------------------------

      array      = op(c_result_array)
      evec_array = op(c_op1_array)

      if (array .eq. 0 .or. evec_array .eq. 0) then
         print *,'Error: remove_single routine requires 2 
     *            array arguments.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      array_type = array_table(c_array_type, array)
      evec_type  = array_table(c_array_type, evec_array)

      nindex      = array_table(c_nindex, array)
      nindex_evec = array_table(c_nindex, evec_array)

      if (nindex .ne. nindex_evec) then
         print *,'Error: Both arrays in return_diagonal must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex_evec,' indices.'
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      block  = find_current_block(array, array_table(1,array),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,array) 
      iarray = get_block_index(array, block, stack, blkndx, x, .true.)  

      block  = find_current_block(evec_array, array_table(1,evec_array),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,evec_array) 
      ievec = get_block_index(evec_array, block, stack, blkndx,x,.true.)  

c     iarray = get_index_from_base(address_table(array), x, 2)
c     ievec  = get_index_from_base(address_table(evec_array), x, 2)

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index

      if (nindex .eq. 4) then 
         n3 = index_table(c_index_size, ind(3))  ! pick up length of index
         n4 = index_table(c_index_size, ind(4))  ! pick up length of index
      endif 

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         type(i)  = index_table(c_index_type, index(i))
         seg      = index_table(c_current_seg,index(i))

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         call get_index_segment(index(i), seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
      enddo


      if (nindex .eq. 4) call retnoxxsd(x(iarray),x(ievec),
     *                      val1(1),val2(1),val1(2),val2(2), 
     *                      val1(3),val2(3),val1(4),val2(4),index,type)

      return 
      end 

      subroutine retnoxxsd(array1,array2,a1,a2,b1,b2,c1,c2,d1,d2, 
     *                   index,type) 

c---------------------------------------------------------------------------
c
c 
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'  

      integer i, a, b, c, d, a1, a2, b1, b2, c1, c2, d1, d2  
      double precision array1(a1:a2,b1:b2,c1:c2,d1:d2) 
      double precision array2(a1:a2,b1:b2,c1:c2,d1:d2) 

      integer index(mx_array_index), type(mx_array_index) 
      integer nzero, zero(100), index1, index2, index3, index4 
      integer nszero, ndzero, szero(100), dzero(100) 
      common /SINDEX/index1, index2, index3, index4 

      if (nalpha_occupied .eq. nbeta_occupied) go to 100 

c     Initialize output array to input array. 
c     --------------------------------------- 

      do d = d1, d2 
      do c = c1, c2 
      do b = b1, b2 
      do a = a1, a2 

         array2(a,b,c,d) = array1(a,b,c,d) 

      enddo ! a 
      enddo ! b 
      enddo ! c 
      enddo ! d 
c
c     Determine range of singly occupied indices to be removed. 
c     --------------------------------------------------------- 

      b      = 0 
      nszero = 0 
      if (nalpha_occupied .gt. nbeta_occupied) then 
         nszero = nalpha_occupied - nbeta_occupied 
         do a = nalpha_occupied, nbeta_occupied, -1 
            b = b + 1 
            szero(b) = a 
         enddo 
      endif 
      if (nbeta_occupied .gt. nalpha_occupied) then 
         nszero = nbeta_occupied - nalpha_occupied 
         do a = nbeta_occupied, nalpha_occupied, -1 
            b = b + 1 
            szero(b) = a 
         enddo 
      endif 
c
c     Reduce third index. 
c     ------------------- 

      do i = 1,  nszero 
      do c = c1, c2  
         if (szero(i) .eq. c) then 
         do d = d1, d2 
         do b = b1, b2 
         do a = a1, a2 

            array2(a,b,c,d) = 0.0 

         enddo ! a 
         enddo ! b 
         enddo ! d 
         endif 
      enddo ! c
      enddo ! i 
c
c     Determine range of doubly occupied indices to be removed. 
c     --------------------------------------------------------- 

      b      = 0 
      ndzero = 0 
      if (nalpha_occupied .gt. nbeta_occupied) then 
         ndzero = nbeta_occupied 
         do a = 1, nbeta_occupied  
            b = b + 1 
            dzero(b) = a 
         enddo 
      endif 
      if (nbeta_occupied .gt. nalpha_occupied) then 
         ndzero = nalpha_occupied 
         do a = 1, nalpha_occupied  
            b = b + 1 
            dzero(b) = a 
         enddo 
      endif 
c
c     Reduce fourth index. 
c     ------------------- 

      do i = 1,  ndzero 
      do d = d1, d2  
         if (dzero(i) .eq. d) then 
         do c = c1, c2 
         do b = b1, b2 
         do a = a1, a2 

            array2(a,b,c,d) = 0.0 

         enddo ! a 
         enddo ! b 
         enddo ! c 
         endif 
      enddo ! d   
      enddo ! i 

100   continue 

      return
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_SET_DERV_IJC_TRIPLES
     +
     +                    ( NUCLEI,
     +                      XN,YN,ZN,NCHARGE,
     +                      NPGTOA,NPGTOB,NPGTOAB,
     +                      DIFFC,IXDERC,
     +                      ATOMIC,EQUALAB,
     +                      SWAPRS,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      RNABSQ,
     +                      PREFACT,
     +                      ALPHAA,ALPHAB,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      SCREEN,
     +
     +                               EMPTY,
     +                               NIJ,NCENA,NCENB,NCENC,
     +                               PRIMA,PRIMB,
     +                               IXCEQA,IXCEQB,
     +                               NUCCEN,
     +                               ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_SET_DERV_IJC_TRIPLES
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation determines the ij primitive exponent
C                pairs which will actually be considered for
C                contraction and the nuclear attraction centers that
C                will be processed. It is here where the internal
C                prescreening (if any) of nuclear attraction primitives
C                must be applied.
C
C                Note, that if any of the nuclear attraction centers
C                besides both centers A and B is to be differentiated,
C                then that center is the only surviving nuclear
C                attraction center to be considered. The reason is
C                that the nuclear attraction integrals are defined
C                as a sum of individual nuclear attraction integrals
C                over one specific center and the differentiation
C                operator eliminates any contribution comming from the
C                other centers.
C
C                There are two ways the ij pairs can be ordered:
C                1) i runs fastest or 2) j runs fastest. The ordering
C                to be chosen depends on the order the contraction will
C                be performed. We have the following rule:
C
C                     If # primitives on A > # primitives on B
C                     (i.e. the SWAPRS = .true. case), the contraction
C                     will be performed first on the A primitives
C                     followed by the B primitives in order to save
C                     intermediate storage space for the 1st half
C                     transformation. Hence each B primitive will have
C                     associated a set of A primitives for the 1st
C                     half contraction and thus the order for the
C                     primitive pairs ij must be such that i runs
C                     fastest. If # primitives on A =< # primitives
C                     on B we have to let j run fastest.
C
C                The prescreening will be based on the fact that
C                for normalized cartesian integrals the primitive
C                (s|s) nuclear attraction integrals will be largest
C                in magnitude for all exponent combinations and
C                nuclear attraction centers. The normalized (s|s)
C                nuclear attraction integral value expression is:
C
C                 Sqrt (32/pi) * (-Z) * (ab)**(3/4) * 1/(a+b)
C                              * rho (a,b) * F0 ((a+b)*R(PC)**2)
C
C                where a and b are the individual gaussian exponents,
C                R(PC) is the distance between points P, the location of
C                the gaussian product function and C, the nuclear
C                attraction center, Z is the nuclear charge at center
C                C, and rho (a,b) is the exponential prefactor given
C                by the expression:
C
C                                      - (ab/(a+b)) * R(AB)**2
C                       rho (a,b) = exp
C
C                where R(AB)**2 is the square of the distance between
C                the atomic centers A and B. The exponential prefactor
C                measures to which extent the two gaussians overlap
C                in space and thus is a direct measure of the magnitude
C                of their product. The Boys function F0 argument is
C                a measure of the coulombic interaction between the
C                electronic cloud and the nuclear attraction center
C                and is a measure on how far apart the electronic cloud
C                and the nuclear attraction center are in space. 
C
C                There are two kinds of prescreening applied here:
C
C                    1) Prescreening of ij exponents
C                    2) Prescreening of nuclear attraction centers
C
C                These prescreenings will be applied according to the
C                following scheme:
C
C                    Find exponents a(min) and b(min), giving the
C                    largest electronic cloud distribution in space.
C
C                    Loop over all nuclear attraction centers C
C
C                         Calculate minimum distance d(C,min) between
C                         line segment AB and C
C
C                         Calculate (s|s) NAI integral using a(min),
C                         b(min) and R(PC) = d(C,min)
C
C                         Skip center C, if |(s|s)| < TOL
C
C                    continue
C
C                    From the reduced set of centers C, choose the
C                    one that has given the largest (s|s) integral
C                    previously. From that chosen center use its
C                    R(PC) value for the Boys function argument
C                    calculations and the corresponding nuclear charge
C                    Z.
C
C                    Loop over all ij exponent pairs
C
C                         Calculate (s|s) NAI integral using i-th and
C                         j-th exponent and use R(PC) = d(C(min),min)
C
C                         Skip ij pair, if |(s|s)| < TOL
C
C                    continue
C
C                This prescreening scheme will require as many
C                evaluations of the Boys function as there are nuclear
C                attraction centers plus ij exponent pairs.
C
C                Since evaluation of the exponential prefactors is
C                rather costly, the ones surviving the prescreening
C                are transmitted back to the calling routine for
C                further use.
C
C
C                  Input:
C
C                    NUCLEI       =  the original # of nuclear
C                                    attraction centers
C                    XN,YN,ZN     =  the original x,y,z-coordinates
C                                    of the nuclear attraction centers
C                    NCHARGE      =  the original charges of the
C                                    nuclear attraction centers
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NPGTOAB      =  # of primitive pairs for
C                                    contraction shell pair AB
C                    DIFFC        =  is true, if differentiation will
C                                    be performed on a nuclear
C                                    attraction center C different
C                                    from A and B
C                    IXDERC       =  the index of which of the nuclear
C                                    attraction centers is to be
C                                    differentiated in case DIFFC is
C                                    true
C                    ATOMIC       =  indicates, if atomic integrals
C                                    are evaluated
C                    EQUALAB      =  indicates, if csh A and csh B are
C                                    considered to be equal
C                    SWAPRS       =  is .true. if the contraction order
C                                    of the primitive pairs AB will
C                                    be performed in reverse order
C                                    BA for efficiency reasons
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = A and B
C                    RNABSQ       =  the square distance R(AB)**2
C                                    between centers A and B
C                    PREFACT      =  the value of sqrt (8)
C                    ALPHAx       =  primitive exponents for centers
C                                    x=A,B
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    SCREEN       =  is true, if screening will be
C                                    performed
C
C                  Output:
C
C                    EMPTY        =  is true, if no ij pairs were
C                                    established
C                    NIJ          =  # of ij pairs after screening
C                    NCENx        =  # of nuclear attraction centers
C                                    equal to centers x = A,B and
C                                    C = different from A and B after
C                                    screening. For x = A,B we can
C                                    have only values of 0 or 1. For
C                                    x = C we can have > 1 values.
C                    PRIMx        =  i,j labels of primitives for x=A,B
C                    IXCEQy       =  contains original index of which
C                                    of the screened nuclear attraction
C                                    centers is equal to centers
C                                    y = A,B. If no center is equal
C                                    the value is 0. If no screening
C                                    was performed on the nuclear
C                                    attraction centers the original
C                                    values corresponding to the
C                                    original set of nuclear attraction
C                                    centers are retained
C                    NUCCEN       =  will hold the index labels of
C                                    the nuclear attraction centers C
C                                    different from centers A and B.
C                                    surviving the screening process
C                    ZCORE        =  flp array holding NIJ exponential
C                                    prefactors rho (a,b)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   ATOMIC
         LOGICAL   DIFFC
         LOGICAL   EMPTY
         LOGICAL   EQUALAB
         LOGICAL   SCREEN
         LOGICAL   SWAPRS

         INTEGER   I,J,N
         INTEGER   IXCEQA,IXCEQB
         INTEGER   IXDERC
         INTEGER   MGRID,NGRID
         INTEGER   NCEN,NCENA,NCENB,NCENC
         INTEGER   NIJ
         INTEGER   NPGTOA,NPGTOB,NPGTOAB
         INTEGER   NUCLEI
         INTEGER   TGRID

         INTEGER   NUCCEN (1:NUCLEI)
         INTEGER   PRIMA  (1:NPGTOAB)
         INTEGER   PRIMB  (1:NPGTOAB)

         DOUBLE PRECISION  A,B
         DOUBLE PRECISION  AB,ABMIN
         DOUBLE PRECISION  DELTA
         DOUBLE PRECISION  F0
         DOUBLE PRECISION  OED__DSQMIN_LINE_SEGMENTS
         DOUBLE PRECISION  P,PINV,PMIN
         DOUBLE PRECISION  PREFACT
         DOUBLE PRECISION  RHOAB
         DOUBLE PRECISION  RSQ,RNABSQ,RMINSQ
         DOUBLE PRECISION  SMAXAB
         DOUBLE PRECISION  SSINT,SSMAX
         DOUBLE PRECISION  T,TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         DOUBLE PRECISION  ZATOM,ZFORIJ
         DOUBLE PRECISION  ZERO,SIXTH,FIFTH,FOURTH,THIRD,HALF,
     +                     ZP75,ONE,PI,TOL

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  XN      (1:NUCLEI)
         DOUBLE PRECISION  YN      (1:NUCLEI)
         DOUBLE PRECISION  ZN      (1:NUCLEI)
         DOUBLE PRECISION  NCHARGE (1:NUCLEI)

         DOUBLE PRECISION  ZCORE (*)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (SIXTH   =  0.166666666666667D0)
         PARAMETER  (FIFTH   =  0.2D0)
         PARAMETER  (FOURTH  =  0.25D0)
         PARAMETER  (THIRD   =  0.333333333333333D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ZP75    =  0.75D0)
         PARAMETER  (ONE     =  1.D0)
         PARAMETER  (PI      =  3.141592653589793D0)
         PARAMETER  (TOL     =  1.D-14)
C
C
C------------------------------------------------------------------------
C
C
C             ...the no screening section. Note, that in case there
C                is a differentiation on a nuclear attraction center
C                not equal to centers A and B, then the origial set of
C                nuclear attraction center gets 'screened' in the
C                sense that only the differentiated nuclear attraction
C                center remains.
C
C
         EMPTY = .FALSE.

         IF (.NOT.SCREEN) THEN

             IF (DIFFC) THEN
                 NCENA = 0
                 NCENB = 0
                 NCENC = 1
                 IXCEQA = 0
                 IXCEQB = 0
                 NUCCEN (1) = IXDERC
             ELSE
                 IF (ATOMIC) THEN
                     NCENA = 0
                     NCENB = 0
                 ELSE
                     NCENA = MIN (1,IXCEQA)
                     NCENB = MIN (1,IXCEQB)
                 END IF

                 NCENC = 0
                 DO N = 1,NUCLEI
                    IF (N.NE.IXCEQA .AND. N.NE.IXCEQB) THEN
                        NCENC = NCENC + 1
                        NUCCEN (NCENC) = N
                    END IF
                 END DO

                 IF (ATOMIC .AND. (NCENC.EQ.0)) THEN
                     EMPTY = .TRUE.
                     RETURN
                 END IF
             END IF

             NIJ = 0
             IF (EQUALAB) THEN
                 DO I = 1,NPGTOA
                 DO J = 1,I
                    NIJ = NIJ + 1
                    ZCORE (NIJ) = ONE
                    PRIMA (NIJ) = I
                    PRIMB (NIJ) = J
                 END DO
                 END DO
             ELSE
                 IF (SWAPRS) THEN
                     IF (ATOMIC) THEN
                         DO J = 1,NPGTOB
                         DO I = 1,NPGTOA
                            NIJ = NIJ + 1
                            ZCORE (NIJ) = ONE
                            PRIMA (NIJ) = I
                            PRIMB (NIJ) = J
                         END DO
                         END DO
                     ELSE
                         DO J = 1,NPGTOB
                            B = ALPHAB (J)
                            DO I = 1,NPGTOA
                               A = ALPHAA (I)
                               NIJ = NIJ + 1
                               ZCORE (NIJ) = DEXP (- A*B*RNABSQ / (A+B))
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                            END DO
                         END DO
                     END IF
                 ELSE
                     IF (ATOMIC) THEN
                         DO I = 1,NPGTOA
                         DO J = 1,NPGTOB
                            NIJ = NIJ + 1
                            ZCORE (NIJ) = ONE
                            PRIMA (NIJ) = I
                            PRIMB (NIJ) = J
                         END DO
                         END DO
                     ELSE
                         DO I = 1,NPGTOA
                            A = ALPHAA (I)
                            DO J = 1,NPGTOB
                               B = ALPHAB (J)
                               NIJ = NIJ + 1
                               ZCORE (NIJ) = DEXP (- A*B*RNABSQ / (A+B))
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                            END DO
                         END DO
                     END IF
                 END IF
             END IF

             RETURN

         END IF
C
C
C             ...enter screening. Perform screening on nuclear
C                attraction centers first.
C
C
         IF (DIFFC) THEN

             NCENA = 0
             NCENB = 0
             NCENC = 1
             IXCEQA = 0
             IXCEQB = 0
             NUCCEN (1) = IXDERC

             XC = XN (IXDERC)
             YC = YN (IXDERC)
             ZC = ZN (IXDERC)

             RMINSQ = OED__DSQMIN_LINE_SEGMENTS
     +
     +                     ( XA,YA,ZA,
     +                       XB,YB,ZB,
     +                       XC,YC,ZC,
     +                       XC,YC,ZC )
     +
     +
             ZFORIJ = NCHARGE (IXDERC)

         ELSE

             A = ALPHAA (1)
             DO I = 2,NPGTOA
                A = DMIN1 (A,ALPHAA (I))
             END DO

             B = ALPHAB (1)
             DO I = 2,NPGTOB
                B = DMIN1 (B,ALPHAB (I))
             END DO

             PMIN = A + B
             ABMIN = A * B
             PINV = ONE / PMIN

             SMAXAB = PREFACT * (ABMIN ** ZP75) * PINV
     +                        * DEXP (-ABMIN * RNABSQ * PINV)

             SSMAX = ZERO

             NCENA = 0
             NCENB = 0
             NCENC = 0

             DO N = 1,NUCLEI

                XC = XN (N)
                YC = YN (N)
                ZC = ZN (N)
                ZATOM = NCHARGE (N)

                RSQ = OED__DSQMIN_LINE_SEGMENTS
     +
     +                     ( XA,YA,ZA,
     +                       XB,YB,ZB,
     +                       XC,YC,ZC,
     +                       XC,YC,ZC )
     +
     +
                T = PMIN * RSQ

                IF (T.EQ.ZERO) THEN
                    F0 = ONE
                ELSE IF (T.LE.TMAX) THEN
                    TGRID = INT (T * TVSTEP + HALF)
                    DELTA = TGRID * TSTEP - T

                    F0 = ((((( FTABLE (6,TGRID)  * DELTA * SIXTH
     +                       + FTABLE (5,TGRID)) * DELTA * FIFTH
     +                       + FTABLE (4,TGRID)) * DELTA * FOURTH
     +                       + FTABLE (3,TGRID)) * DELTA * THIRD
     +                       + FTABLE (2,TGRID)) * DELTA * HALF
     +                       + FTABLE (1,TGRID)) * DELTA
     +                       + FTABLE (0,TGRID)
                ELSE
                    F0 = HALF * DSQRT (PI/T)
                END IF

                SSINT = SMAXAB * F0 * ZATOM

                IF (DABS (SSINT).GE.TOL) THEN
                    IF (N.EQ.IXCEQA) THEN
                        IF (.NOT.ATOMIC) THEN
                            NCENA = 1
                        END IF
                    ELSE IF (N.EQ.IXCEQB) THEN
                        IF (.NOT.ATOMIC) THEN
                            NCENB = 1
                        END IF
                    ELSE
                        NCENC = NCENC + 1
                        NUCCEN (NCENC) = N
                    END IF

                    IF (DABS (SSINT).GT.SSMAX) THEN
                        RMINSQ = RSQ
                        ZFORIJ = ZATOM
                        SSMAX = SSINT
                    END IF
                ELSE
                    IF (N.EQ.IXCEQA) IXCEQA = 0
                    IF (N.EQ.IXCEQB) IXCEQB = 0
C                    WRITE (*,*) ' Skip nai center C = ',N
                END IF

             END DO

             NCEN = NCENA + NCENB + NCENC

             IF (NCEN.EQ.0 .OR. (ATOMIC.AND.(NCENC.EQ.0))) THEN
                 EMPTY = .TRUE.
                 RETURN
             END IF

         END IF
C
C
C             ...perform screening on ij exponent pairs.
C
C
         NIJ = 0

         IF (EQUALAB) THEN

             DO I = 1,NPGTOA
                A = ALPHAA (I)
                DO J = 1,I
                   B = ALPHAB (J)
                   P = A + B
                   AB = A * B
                   PINV = ONE / P
                   T = P * RMINSQ

                   IF (T.EQ.ZERO) THEN
                       F0 = ONE
                   ELSE IF (T.LE.TMAX) THEN
                       TGRID = INT (T * TVSTEP + HALF)
                       DELTA = TGRID * TSTEP - T

                       F0 = ((((( FTABLE (6,TGRID)  * DELTA * SIXTH
     +                          + FTABLE (5,TGRID)) * DELTA * FIFTH
     +                          + FTABLE (4,TGRID)) * DELTA * FOURTH
     +                          + FTABLE (3,TGRID)) * DELTA * THIRD
     +                          + FTABLE (2,TGRID)) * DELTA * HALF
     +                          + FTABLE (1,TGRID)) * DELTA
     +                          + FTABLE (0,TGRID)
                   ELSE
                       F0 = HALF * DSQRT (PI/T)
                   END IF

                   SSINT = PREFACT * (AB**ZP75) * PINV * F0 * ZFORIJ

                   IF (DABS (SSINT).GE.TOL) THEN
                       NIJ = NIJ + 1
                       ZCORE (NIJ) = ONE
                       PRIMA (NIJ) = I
                       PRIMB (NIJ) = J
                   ELSE
C                       WRITE (*,*) ' Skip atom nai I J = ',I,J
                   END IF

                END DO
             END DO

         ELSE

             IF (SWAPRS) THEN
                 IF (ATOMIC) THEN
                     DO J = 1,NPGTOB
                        B = ALPHAB (J)
                        DO I = 1,NPGTOA
                           A = ALPHAA (I)
                           P = A + B
                           AB = A * B
                           PINV = ONE / P
                           T = P * RMINSQ

                           IF (T.EQ.ZERO) THEN
                               F0 = ONE
                           ELSE IF (T.LE.TMAX) THEN
                               TGRID = INT (T * TVSTEP + HALF)
                               DELTA = TGRID * TSTEP - T

                               F0 = (((((FTABLE (6,TGRID) *DELTA*SIXTH
     +                                 + FTABLE (5,TGRID))*DELTA*FIFTH
     +                                 + FTABLE (4,TGRID))*DELTA*FOURTH
     +                                 + FTABLE (3,TGRID))*DELTA*THIRD
     +                                 + FTABLE (2,TGRID))*DELTA*HALF
     +                                 + FTABLE (1,TGRID))*DELTA
     +                                 + FTABLE (0,TGRID)
                           ELSE
                               F0 = HALF * DSQRT (PI/T)
                           END IF

                           SSINT = PREFACT * (AB**ZP75) * PINV
     +                                                  * F0 * ZFORIJ
                           IF (DABS (SSINT).GE.TOL) THEN
                               NIJ = NIJ + 1
                               ZCORE (NIJ) = ONE
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip nai I J = ',I,J
                           END IF

                        END DO
                     END DO
                 ELSE
                     DO J = 1,NPGTOB
                        B = ALPHAB (J)
                        DO I = 1,NPGTOA
                           A = ALPHAA (I)
                           P = A + B
                           AB = A * B
                           PINV = ONE / P
                           RHOAB = DEXP (- AB * RNABSQ * PINV)
                           T = P * RMINSQ

                           IF (T.EQ.ZERO) THEN
                               F0 = ONE
                           ELSE IF (T.LE.TMAX) THEN
                               TGRID = INT (T * TVSTEP + HALF)
                               DELTA = TGRID * TSTEP - T

                               F0 = (((((FTABLE (6,TGRID) *DELTA*SIXTH
     +                                 + FTABLE (5,TGRID))*DELTA*FIFTH
     +                                 + FTABLE (4,TGRID))*DELTA*FOURTH
     +                                 + FTABLE (3,TGRID))*DELTA*THIRD
     +                                 + FTABLE (2,TGRID))*DELTA*HALF
     +                                 + FTABLE (1,TGRID))*DELTA
     +                                 + FTABLE (0,TGRID)
                           ELSE
                               F0 = HALF * DSQRT (PI/T)
                           END IF

                           SSINT = PREFACT * (AB**ZP75) * PINV * RHOAB
     +                                                  * F0 * ZFORIJ
                           IF (DABS (SSINT).GE.TOL) THEN
                               NIJ = NIJ + 1
                               ZCORE (NIJ) = RHOAB
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip nai I J = ',I,J
                           END IF

                        END DO
                     END DO
                 END IF
             ELSE
                 IF (ATOMIC) THEN
                     DO I = 1,NPGTOA
                        A = ALPHAA (I)
                        DO J = 1,NPGTOB
                           B = ALPHAB (J)
                           P = A + B
                           AB = A * B
                           PINV = ONE / P
                           T = P * RMINSQ

                           IF (T.EQ.ZERO) THEN
                               F0 = ONE
                           ELSE IF (T.LE.TMAX) THEN
                               TGRID = INT (T * TVSTEP + HALF)
                               DELTA = TGRID * TSTEP - T

                               F0 = (((((FTABLE (6,TGRID) *DELTA*SIXTH
     +                                 + FTABLE (5,TGRID))*DELTA*FIFTH
     +                                 + FTABLE (4,TGRID))*DELTA*FOURTH
     +                                 + FTABLE (3,TGRID))*DELTA*THIRD
     +                                 + FTABLE (2,TGRID))*DELTA*HALF
     +                                 + FTABLE (1,TGRID))*DELTA
     +                                 + FTABLE (0,TGRID)
                           ELSE
                               F0 = HALF * DSQRT (PI/T)
                           END IF

                           SSINT = PREFACT * (AB**ZP75) * PINV
     +                                                  * F0 * ZFORIJ
                           IF (DABS (SSINT).GE.TOL) THEN
                               NIJ = NIJ + 1
                               ZCORE (NIJ) = ONE
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip nai I J = ',I,J
                           END IF

                        END DO
                     END DO
                 ELSE
                     DO I = 1,NPGTOA
                        A = ALPHAA (I)
                        DO J = 1,NPGTOB
                           B = ALPHAB (J)
                           P = A + B
                           AB = A * B
                           PINV = ONE / P
                           RHOAB = DEXP (- AB * RNABSQ * PINV)
                           T = P * RMINSQ

                           IF (T.EQ.ZERO) THEN
                               F0 = ONE
                           ELSE IF (T.LE.TMAX) THEN
                               TGRID = INT (T * TVSTEP + HALF)
                               DELTA = TGRID * TSTEP - T

                               F0 = (((((FTABLE (6,TGRID) *DELTA*SIXTH
     +                                 + FTABLE (5,TGRID))*DELTA*FIFTH
     +                                 + FTABLE (4,TGRID))*DELTA*FOURTH
     +                                 + FTABLE (3,TGRID))*DELTA*THIRD
     +                                 + FTABLE (2,TGRID))*DELTA*HALF
     +                                 + FTABLE (1,TGRID))*DELTA
     +                                 + FTABLE (0,TGRID)
                           ELSE
                               F0 = HALF * DSQRT (PI/T)
                           END IF

                           SSINT = PREFACT * (AB**ZP75) * PINV * RHOAB
     +                                                  * F0 * ZFORIJ
                           IF (DABS (SSINT).GE.TOL) THEN
                               NIJ = NIJ + 1
                               ZCORE (NIJ) = RHOAB
                               PRIMA (NIJ) = I
                               PRIMB (NIJ) = J
                           ELSE
C                               WRITE (*,*) ' Skip nai I J = ',I,J
                           END IF

                        END DO
                     END DO
                 END IF
             END IF

         END IF

         IF (NIJ.EQ.0) THEN
             EMPTY = .TRUE.
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_SET_DERV_SEQUENCE
     +
     +                    ( NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +
     +                               CENSQX,CENSQY,CENSQZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_SET_DERV_SEQUENCE
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine determines the sequence of centers for
C                the x,y,z-coordinate derivations. The info is stored
C                in arrays CENSQp for each coordinate p=X,Y,Z.
C
C                The indices for the centers obey the following
C                indexing scheme: index 1 -> A and index 2 -> B
C
C                Take the x-coordinate for example and let CENSQX have
C                the following elements on exit from this routine:
C
C                            CENSQX (I) = 2,1,1,2,...
C
C                Then the sequence of single derivations is:
C
C                       dx/dBx  dx/dAx  dx/dAx  dx/dBx  (A|B)
C
C                Note, that the indexing of the CENSQp arrays start
C                with 0. The reason is that the NDERp values might
C                be equal to zero.
C
C                The center sequences are determined such that those
C                on center A come first.
C
C
C                  Input:
C
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERxp        =  the order of differentiation on
C                                    centers x = A and B with respect
C                                    to the p = x,y,z coordinates
C
C                  Output:
C
C                    CENSQp       =  center sequence array for the
C                                    p = x,y,z coordinates
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     I
         INTEGER     NDERX,NDERY,NDERZ

         INTEGER     CENSQX (0:NDERX)
         INTEGER     CENSQY (0:NDERY)
         INTEGER     CENSQZ (0:NDERZ)
C
C
C------------------------------------------------------------------------
C
C
C             ...first the center sequences due to centers A.
C
C
         DO I = 1,DERAX
            CENSQX (I) = 1
         END DO

         DO I = 1,DERAY
            CENSQY (I) = 1
         END DO

         DO I = 1,DERAZ
            CENSQZ (I) = 1
         END DO
C
C
C             ...next the center sequences due to centers B.
C
C
         DO I = 1,DERBX
            CENSQX (DERAX+I) = 2
         END DO

         DO I = 1,DERBY
            CENSQY (DERAY+I) = 2
         END DO

         DO I = 1,DERBZ
            CENSQZ (DERAZ+I) = 2
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

cYAU - WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING
c
c    For some reason, which I am not privy to, the original xgeev was not bound
c the same way dgeev is.

      subroutine mn_geev(ndim,  nlow,  amat,
     &                   evalr, evali, evec,
     &                   scr,   nscr,  ierr)
      implicit none

      double precision amat(*), evalr(*), evali(*), evec(*), scr(*)
      integer ndim, nlow, ierr, nscr

      call xgeev('N', 'V', ndim, amat, nlow,
     &           evalr, evali, evec, ndim,
     &           evec, ndim, scr, nscr, ierr)

      return
      end

      SUBROUTINE SYMMET4(A,NDIM,NUM)
C
C   THIS ROUTINE SYMMETRIZES A GIVEN MATRIX A
C
C     A(PQ) = 1/2 ( A(PQ)+A(QP))
C
C   WHERE A IS A SYMMETRY PACKED MATRIX AND
C   NUM THE CORRESPONDING POPULATION VECTOR
C   NDIM IS THE LEADING DIMENSION OF THE MATRIX A
C
C   THE SYMMETRIZATION IS HERE COMPLETELY DONE IN PLACE
C
C   THIS ROUTINE IS REQUIRED IN THE OUT-CORE-SYMMETRIZATION
C   ROUTINE AND CALLED FROM SYMMET3
C
CEND
C
C CODED AUGUST/90 JG
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(NDIM,NUM)
      DATA HALF /0.5D+0/
C
C SYMMETRIZE FISRT HALF OF A
C
       DO 100 I=2,NUM
CDIR$ IVDEP
*VOCL LOOP,NOVREC
       DO 100 J=1,I-1
        A(I,J)=HALF*(A(I,J)+A(J,I))
100    CONTINUE
C
C FILL SECOND HALF OF A
C
       DO 200 I=2,NUM
CDIR$ IVDEP
*VOCL LOOP,NOVREC
       DO 200 J=1,I-1
        A(J,I)=A(I,J)
200    CONTINUE
C
      RETURN
      END

C THIS SUBROUTINE DETERMINES THE INFORMATION ABOUT THE
C LOCATION OF TEH VARIOUS FILES (DEFAULT IS OF COURSE
C THE WORKING DIRECTORY) IN AN ACES2 RUN. THIS OPTION 
C IS PARTICULARLY USEFUL FOR WORKSTATIONS, BUT HAS 
C ALSO SOME BENEFITS ON SUPER COMPUTERS WITH TMPDIR
C DISKS.
C
C IF A FILE IS INTENDED NOT TO BE IN THE WORKING 
C DIRECTORY, THE FULL PATH NAME CAN BE GIVEN IN THE
C FOLLOWING WAY IN THE ZMAT_FILE PRIOR TO THE TITLE
C CARD
C
C  %MOINTS=/work/username/test1/MOINTS
C
C WHICH MEANS THAT MOINTS IS NOW IN THE DIRECTORY
C /work/username/test1. THERE IS ALSO THE POSSIBILITY
C TO RENAME FILES BUT THAT SHOULD BE USED WITH
C COME CAUTION, IN ORDER NOT TO MESS UP THINGS.
C
C JG GOETEBORG SEPT/92

      SUBROUTINE DFILES
      IMPLICIT INTEGER(A-Z)

#include "io_units.par"
#include "linelen.par"

      LOGICAL YESNO,IGNORE
      CHARACTER*(linelen) A
      COMMON/RESTART/IGNORE
C
      IGNORE=.TRUE.
C
C CHECK WHETHER FILE 'FILES EXIST, IF, THEN THERE IS NOTHING TO DO
C
      INQUIRE(FILE='FILES',EXIST=YESNO)
      IF(YESNO) RETURN 
C
      IGNORE=.FALSE.
C
C FIRST OPEN THE ZMAT FILE WHICH IS ALWAYS COPIED
C TO THE WORKING DIRECTORY
C
C  LUZ: UNIT NUMBER FOR ZMAT FILE
C
      OPEN(UNIT=90,FILE='FILES',FORM='FORMATTED',
     &     STATUS='UNKNOWN')
      REWIND(UNIT=90)
C
      INQUIRE(FILE=ZFIL,EXIST=YESNO)
      IF (.NOT.YESNO) THEN
         WRITE(LUOUT,*) '@DFILES: ZMAT file not present.'
         CALL ERREX
      ELSE
         OPEN(UNIT=LUZ,FILE=ZFIL,FORM='FORMATTED',STATUS='OLD')
         REWIND(LUZ)
      END IF
C
C REENTRY POINT FOR NEXT CARD
C
1000  CONTINUE
C
C READ FIRST CARD AS CHARACTER STRING, AT MOST 80 CHARACTERS
C
       READ(4,9001) A
9001   FORMAT(A80)
C
C CHECK IF FIRST CHARACTER IS A % SIGN, INDICATING FILE INFORMATION
C
       IF(A(1:1).EQ.'%') THEN
C
        DO 10 I=2,80
         IF(A(I:I).NE.' ') THEN
          ISTART1=I
          GO TO 11
         ENDIF
10      CONTINUE
11      CONTINUE
        DO 20 I=ISTART1,80
         IF(A(I:I).EQ.'=') THEN
          IEND1=I-1
          GO TO 21
         ENDIF
20      CONTINUE
21      CONTINUE
        ISTART2=IEND1+2
        DO 30 I=ISTART2,80
         IF(A(I:I).EQ.' ') THEN
          IEND2=I-1
          GO TO 31
         ENDIF
30     CONTINUE
31     CONTINUE
C
        WRITE(90,9002) A(ISTART1:IEND1), A(ISTART2:IEND2)
9002    FORMAT(A,1X,A)
        WRITE(6,9003) A(ISTART1:IEND1), A(ISTART2:IEND2)
9003    FORMAT('File ',A,' is ',A,'.')
        GO TO 1000
C
       ENDIF
C
C EVERYTHING DONE, CLOSE ZMAT-FILE
C
       CLOSE(UNIT=LUZ)
       WRITE(90,*)
       CLOSE(UNIT=90)
C
       WRITE(6,*)
C 
       RETURN
       END

         SUBROUTINE  OED__NAI_DERV_PCGTO_BLOCK_F12
     +
     +                    ( NBATCH,
     +                      NINT1DX,NINT1DY,NINT1DZ,
     +                      ATOMIC,
     +                      MIJ,NCEN,MIJCEN,
     +                      NIJ,NIJBEG,NIJEND,
     +                      NGQP,NMOM,NGQSCR,MGIJCEN,
     +                      NPGTOA,NPGTOB,
     +                      NXYZA,NXYZB,
     +                      SHELLA,SHELLB,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      NUCLEI,
     +                      XN,YN,ZN,NCHARGE,
     +                      NUCCEN,
     +                      NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      DIFFA,DIFFB,DIFFC,
     +                      IXAEQB,IXCEQA,IXCEQB,
     +                      ALPHAA,ALPHAB,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      CENSQX,CENSQY,CENSQZ,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      PX,PY,PZ,PAX,PAY,PAZ,PINVHF,SCALE,
     +                      RTS,WTS,GQSCR,TVAL,UVAL,
     +                      R1X,R1Y,R1Z,R2,
     +                      EXP2A,EXP2B,EXP2AB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      INT1DX_2,INT1DY_2,INT1DZ_2,STGEXP,
     +                      RYSGEN,CORETOP,RYSDATA,RYSDATA1,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_DERV_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__RYS_ROOTS_WEIGHTS
C                OED__NAI_1D_COEFFICIENTS
C                OED__NAI_1D_AB_INTEGRALS
C                OED__NAI_1D_DERV_INTEGRALS
C                OED__NAI_DERV_INT1D_TO_00
C                OED__NAI_DERV_INT1D_TO_A0
C                OED__NAI_DERV_INT1D_TO_AB
C  DESCRIPTION : This operation calculates a batch of derivated unnormed
C                nuclear attraction integrals between cartesian
C                gaussians
C
C                                   [A|B]
C                                        ij
C
C                for a block of ij exponent pairs. The total number
C                of nuclear attraction integrals generated here is thus
C                given by the total number of cartesian monomials
C                NXYZA * NXYZB times the total number of exponent pairs
C                MIJ in the present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyza*nxyzb)
C
C
C                  Input:
C
C                    NBATCH       =  size of the array that will hold
C                                    the final primitive cartesian
C                                    derivative integral batch as well
C                                    as intermediate differentiated
C                                    1D integrals
C                    NINT1Dx      =  space needed for each of the 1D
C                                    x = X,Y,Z integral arrays (they
C                                    might be different due to different
C                                    orders of differentiation for
C                                    each cartesian component)
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NCEN         =  # of nuclear attraction centers
C                    MIJCEN       =  # of ij primitive index pairs
C                                    times # of nuclear attraction
C                                    centers
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    MGIJCEN      =  # of roots times # of ij primitive
C                                    index pairs times # of nuclear
C                                    attraction centers
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZx        =  # of cartesian monomials for
C                                    each contraction shell x = A,B
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    NUCLEI       =  # of nuclear attraction centers
C                    XN,YN,ZN     =  the x,y,z-coordinates for all
C                                    nuclear attraction centers
C                    NCHARGE      =  the nuclear charges for all
C                                    nuclear attraction centers
C                    NUCCEN       =  contains those index labels of
C                                    the nuclear attraction centers
C                                    that survived the screening process
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERyp        =  the order of differentiation on
C                                    centers y = A and B with respect
C                                    to the p = x,y,z coordinates
C                    DIFFy        =  is true, if differentiation will
C                                    be performed on centers y = A and B
C                                    and at least on one of the nuclear
C                                    attraction centers y = C different
C                                    from A and B and if differentiation
C                                    will be performed at least once
C                                    one on each of the y = x,y,z
C                                    coordinates
C                    IXAEQB       =  is an index = 0 or 1, depending
C                                    on if center A is different or
C                                    equal from center B, respectively
C                    IXCEQy       =  contains the index of which
C                                    screened nuclear attraction center
C                                    C is equal to centers y = A,B.
C                                    If no C is equal, the value is 0
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    CENSQp       =  derivative center sequence array
C                                    for the p = x,y,z coordinates
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=A+B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current distinct MIJCEN
C                                    (expanded to MGIJCEN) values of
C                                    scaling factors
C                    RTS          =  will hold all current MGIJCEN
C                                    quadrature roots
C                    WTS          =  will hold all current MGIJCEN
C                                    quadrature weights
C                    GQSCR        =  will be used as scratch space
C                                    for determining the quadrature
C                                    roots and weights
C                    TVAL         =  will hold current MIJCEN values
C                                    of T-exponents defining the Rys
C                                    weight functions
C                    R1x          =  will hold the current MGIJCEN
C                                    VRR R1-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    R2           =  will hold the current MGIJCEN
C                                    coordinate independent VRR
C                                    R2-coefficients
C                    EXP2x        =  will hold current double primitive
C                                    exponent values in MIJ order
C                                    (expanded to MGIJCEN) for each
C                                    contracted shell x = A,B
C                    EXP2AB       =  will hold current double primitive
C                                    exponent sum values in MIJ order
C                                    between both contracted shells
C                                    A and B
C                    INT1Dx       =  will hold all current derivated
C                                    1D integrals for each cartesian
C                                    component (x = X,Y,Z) during all
C                                    stages of differentiation
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    derivative cartesian nuclear
C                                    attraction [A|B] integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program OED
C
C    This routine is part of the integral program package OED and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routines of the
C    OED package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     CEQA,CEQB
         LOGICAL     DIFFA,DIFFB,DIFFC
         LOGICAL     DIFFX,DIFFY,DIFFZ

         INTEGER     CENTER
         INTEGER     DERA,DERB
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DEROPA,DEROPB,DEROPC
         INTEGER     G000,G010,G020,G030,G040,G050,G060
         INTEGER     I,J,L,M,N
         INTEGER     IJ
         INTEGER     IXC,IXAEQB,IXCEQA,IXCEQB
         INTEGER     MGRID,NGRID
         INTEGER     MIJ,MGQPIJ,MIJCEN,MGIJCEN
         INTEGER     NBATCH
         INTEGER     NC,NCEN
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NG,NGQP,NGQPCEN,NMOM,NGQSCR
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NINT,NINT1DX,NINT1DY,NINT1DZ
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NUCLEI,RYSGEN,CORETOP
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB,SHELLP

         INTEGER     CENSQX (0:NDERX)
         INTEGER     CENSQY (0:NDERY)
         INTEGER     CENSQZ (0:NDERZ)

         INTEGER     NUCCEN (1:NCEN)

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  CX,CY,CZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  P,PINV,PVAL
         DOUBLE PRECISION  PCX,PCY,PCZ
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL
         DOUBLE PRECISION  RNPCSQ
         DOUBLE PRECISION  SCALEM,SCALEN
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,HALF,ONE

         DOUBLE PRECISION  XN      (1:NUCLEI)
         DOUBLE PRECISION  YN      (1:NUCLEI)
         DOUBLE PRECISION  ZN      (1:NUCLEI)
         DOUBLE PRECISION  NCHARGE (1:NUCLEI)

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  EXP2AB  (1:MIJ)
         DOUBLE PRECISION  PX      (1:MIJ)
         DOUBLE PRECISION  PY      (1:MIJ)
         DOUBLE PRECISION  PZ      (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)

         DOUBLE PRECISION  GQSCR   (1:NGQSCR)
         DOUBLE PRECISION  TVAL    (1:MIJCEN)
         DOUBLE PRECISION  UVAL    (1:MIJCEN)

         DOUBLE PRECISION  R1X     (1:MGIJCEN)
         DOUBLE PRECISION  R1Y     (1:MGIJCEN)
         DOUBLE PRECISION  R1Z     (1:MGIJCEN)
         DOUBLE PRECISION  R2      (1:MGIJCEN)
         DOUBLE PRECISION  EXP2A   (1:MGIJCEN)
         DOUBLE PRECISION  EXP2B   (1:MGIJCEN)
         DOUBLE PRECISION  RTS     (1:MGIJCEN)
         DOUBLE PRECISION  SCALE   (1:MGIJCEN)
         DOUBLE PRECISION  WTS     (1:MGIJCEN)

         DOUBLE PRECISION  INT1DX  (1:NINT1DX)
         DOUBLE PRECISION  INT1DY  (1:NINT1DY)
         DOUBLE PRECISION  INT1DZ  (1:NINT1DZ)

         DOUBLE PRECISION  INT1DX_2  (1:NINT1DX)
         DOUBLE PRECISION  INT1DY_2  (1:NINT1DY)
         DOUBLE PRECISION  INT1DZ_2  (1:NINT1DZ)
         DOUBLE PRECISION  RYSDATA(*),RYSDATA1(*)


         DOUBLE PRECISION  FTABLE  (0:MGRID,0:NGRID),STGEXP

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (HALF = 0.5D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D nuclear attraction integrals.
C
C
         IF (ATOMIC) THEN
             L = 0
             M = 0
             N = 0
             DO IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                P = ALPHAA (I) + ALPHAB (J)
                PX (M) = XA
                PY (M) = YA
                PZ (M) = ZA
                PINV = ONE / P
                PINVHF (M) = HALF * PINV
                SCALEM = PINV * NORMA (I) * NORMB (J)
                DO NC = 1,NCEN
                   N = N + 1
                   IXC = NUCCEN (NC)
                   PCX = XA - XN (IXC)
                   PCY = YA - YN (IXC)
                   PCZ = ZA - ZN (IXC)
                   RNPCSQ = PCX * PCX + PCY * PCY + PCZ * PCZ
                   TVAL (N) = P * RNPCSQ
                   UVAL (N) = (STGEXP*STGEXP)/(4.d0*P)
                   SCALEN = SCALEM * NCHARGE (IXC)
                   DO NG = 1,NGQP
                      L = L + 1
                      SCALE (L) = SCALEN
                   END DO
                END DO
             END DO
         ELSE
             L = 0
             M = 0
             N = 0
             DO IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                P = EXPA + EXPB
                PINV = ONE / P
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PXVAL = PAX (M) + XA
                PYVAL = PAY (M) + YA
                PZVAL = PAZ (M) + ZA
                PX (M) = PXVAL
                PY (M) = PYVAL
                PZ (M) = PZVAL
                PINVHF (M) = HALF * PINV
                SCALEM = PINV * NORMA (I) * NORMB (J) * RHOAB (IJ)
                DO NC = 1,NCEN
                   N = N + 1
                   IXC = NUCCEN (NC)
                   PCX = PXVAL - XN (IXC)
                   PCY = PYVAL - YN (IXC)
                   PCZ = PZVAL - ZN (IXC)
                   RNPCSQ = PCX * PCX + PCY * PCY + PCZ * PCZ
                   TVAL (N) = P * RNPCSQ
                   UVAL (N) = (STGEXP*STGEXP)/(4.d0*P)
                   SCALEN = SCALEM * NCHARGE (IXC)
                   DO NG = 1,NGQP
                      L = L + 1
                      SCALE (L) = SCALEN
                   END DO
                END DO
             END DO
         END IF
C
C
C             ...determine memory allocation offsets for the scratch
C                arrays used to calculate the quadrature roots +
C                weights:
C
C                   G000 = offset for A coefficients (Jacobi/Laguerre)
C                   G010 = offset for B coefficients (Jacobi/Laguerre)
C                   G020 = offset for moments (Jacobi/Laguerre)
C                   G030 = offset for diagonals of symmetric termat
C                   G040 = offset for offdiagonals of symmetric termat
C                   G050 = offset for first row intermediates during
C                          evaluation of symmetric termat
C                   G060 = offset for second row intermediates during
C                          evaluation of symmetric termat
C
C
         G000 = 1
         G010 = G000 + NMOM
         G020 = G010 + NMOM - 1
         G030 = G020 + NMOM
         G040 = G030 + NGQP
         G050 = G040 + NGQP
         G060 = G050 + NMOM
c*****************************************************************************
c   Here we do the most difficult part of the computation of F12             |
c   potential integrals - calculation of the roots and weight of the         |
c  corresponding Rys polynomials. The calculation of the necessary roots and |
c   weight is done by 2D ineterpolation (implemented by Toru Shiozaki)       |
c*****************************************************************************
C
C
C             ...calculate all roots and weights for all ij pairs and
C                nuclear centers. Array R2 is passed as a scratch array.
C
C

     
                    IF(RYSGEN.eq.1) then

         CALL    OED__RYS_ROOTS_WEIGHTS_F12
     +
     +                ( MIJCEN,MGIJCEN,
     +                  NGQP,NMOM,
     +                  TVAL,UVAL,R2,
     +                  FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                  GQSCR(G000),GQSCR(G010),
     +                  GQSCR(G020),
     +                  GQSCR(G030),GQSCR(G040),
     +                  GQSCR(G050),GQSCR(G060),
     +
     +                           RTS,
     +                           WTS )
     +
     +

          DO I=1,MGIJCEN
          RYSDATA(I) = RTS(I)
          RYSDATA1(I) = WTS(I)
          ENDDO

                   ELSE 

          DO I=1,MGIJCEN
          RTS(I) = RYSDATA(I) 
          WTS(I) = RYSDATA1(I)
          ENDDO

                  ENDIF

c--------------------------------------------------------------------------------



C--------------------------------------------------------------------------------
C             ...calculate the derivative 1D integral coefficents               |
C                (if needed). These are the double exponent values              |
C                for differentiation on centers A and/or B and the              |
C                double exponent sum values between centers A and B.            |
C--------------------------------------------------------------------------------
         CEQA = IXCEQA .GT. 0
         CEQB = IXCEQB .GT. 0

         MGQPIJ = NGQP * MIJ
         NGQPCEN = NGQP * NCEN

         IF (DIFFA) THEN
             M = 0
             DO IJ = 1,MIJ
                I = PRIMA (IJ)
                EXPA = ALPHAA (I) + ALPHAA (I)
                DO N = 1,NGQPCEN
                   EXP2A (M+N) = EXPA
                END DO
                M = M + NGQPCEN
             END DO
         END IF

         IF (DIFFB) THEN
             M = 0
             DO IJ = 1,MIJ
                J = PRIMB (IJ)
                EXPB = ALPHAB (J) + ALPHAB (J)
                DO N = 1,NGQPCEN
                   EXP2B (M+N) = EXPB
                END DO
                M = M + NGQPCEN
             END DO
         END IF

         IF (DIFFC .OR. CEQA .OR. CEQB) THEN
             DO IJ = 1,MIJ
                I = PRIMA (IJ)
                J = PRIMB (IJ)
                P = ALPHAA (I) + ALPHAB (J)
                EXP2AB (IJ) = P + P
             END DO
         END IF
C----------------------------------------------------------------|
C                                                                |
C             ...generate all 1D VRR coefficients.               |
C                                                                |
C----------------------------------------------------------------|
         CALL    OED__NAI_1D_COEFFICIENTS
     +
     +                ( NGQP,NCEN,
     +                  MIJ,MGIJCEN,
     +                  ATOMIC,
     +                  NUCLEI,
     +                  XN,YN,ZN,
     +                  NUCCEN,
     +                  PX,PY,PZ,
     +                  PAX,PAY,PAZ,
     +                  PINVHF,
     +                  RTS,
     +
     +                            R1X,R1Y,R1Z,
     +                            R2 )
     +
     +
C-------------------------------------------------------------------------
C                                                                        |
C             ...start assembling the 1D AB nuclear attraction           |
C                integrals and their differentiation. Assemble first     |
C                the 1DX AB integrals and perform differentiation        |
C                sequence, if necessary.                                 |
C                                                                        |
C-------------------------------------------------------------------------
         IF (DIFFX) THEN

            DERA = DERAX
            DERB = DERBX



             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERA+DERB,
     +                      MIN (SHELLA+DERA,SHELLB+DERB),
     +                      SHELLA+DERA,SHELLB+DERB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1X,R2,
     +                      ABX,
     +                      .TRUE.,
     +                      BATCH,
     +
     +                                INT1DX )



             DO N = 1,NDERX

                NINT = MGIJCEN * (SHELLA+DERA+1) * (SHELLB+DERB+1)

                DO M = 1,NINT
                   BATCH (M) = INT1DX (M)
                END DO

                CENTER = CENSQX (N)

                IF (CENTER.EQ.1) THEN

                    DEROPA = 1
                    DEROPB = IXAEQB
                    DEROPC = 0
                    IF (CEQA) THEN
                        DEROPC = 1
                        IXC = IXCEQA
                        CX = XN (NUCCEN (IXCEQA))
                    END IF

                ELSE IF (CENTER.EQ.2) THEN

                    DEROPA = IXAEQB
                    DEROPB = 1
                    DEROPC = 0
                    IF (CEQB) THEN
                        DEROPC = 1
                        IXC = IXCEQB
                        CX = XN (NUCCEN (IXCEQB))
                    END IF

                ELSE

                    DEROPA = 0
                    DEROPB = 0
                    DEROPC = 1
                    IXC = 1
                    CX = XN (NUCCEN (1))

                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB


                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming x-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__nai_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__NAI_1D_DERV_INTEGRALS
     +
     +                       ( MIJ,MGQPIJ,MGIJCEN,
     +                         NGQP,NGQPCEN,
     +                         SHELLA+DERA,SHELLB+DERB,
     +                         DEROPA,DEROPB,DEROPC,
     +                         EXP2A,EXP2B,EXP2AB,
     +                         IXC,PX,CX,
     +                         RTS,
     +                         R1X,
     +                         BATCH,
     +
     +                                  INT1DX )
     +
     +
             END DO
c======================================================================



c------------------------------------------------------------------------------

         ELSE
             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,MIN (SHELLA,SHELLB),
     +                      SHELLA,SHELLB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1X,R2,
     +                      ABX,
     +                      .TRUE.,
     +                      BATCH,
     +
     +                                INT1DX )
     +
     +
         END IF
C--------------------------------------------------------------
C                                                             |
C             ...assemble the 1DY AB integrals and perform    |
C                differentiation sequence, if necessary.      |
C                                                             |
C--------------------------------------------------------------
         IF (DIFFY) THEN

             DERA = DERAY
             DERB = DERBY

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERA+DERB,
     +                      MIN (SHELLA+DERA,SHELLB+DERB),
     +                      SHELLA+DERA,SHELLB+DERB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Y,R2,
     +                      ABY,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DY )
     +
     +

             DO N = 1,NDERY

                NINT = MGIJCEN * (SHELLA+DERA+1) * (SHELLB+DERB+1)

                DO M = 1,NINT
                   BATCH (M) = INT1DY (M)
                END DO

                CENTER = CENSQY (N)

                IF (CENTER.EQ.1) THEN

                    DEROPA = 1
                    DEROPB = IXAEQB
                    DEROPC = 0
                    IF (CEQA) THEN
                        DEROPC = 1
                        IXC = IXCEQA
                        CY = YN (NUCCEN (IXCEQA))
                    END IF

                ELSE IF (CENTER.EQ.2) THEN

                    DEROPA = IXAEQB
                    DEROPB = 1
                    DEROPC = 0
                    IF (CEQB) THEN
                        DEROPC = 1
                        IXC = IXCEQB
                        CY = YN (NUCCEN (IXCEQB))
                    END IF

                ELSE

                    DEROPA = 0
                    DEROPB = 0
                    DEROPC = 1
                    IXC = 1
                    CY = YN (NUCCEN (1))

                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB


                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming y-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__nai_derv_pcgto_block '
                    STOP
                END IF


                CALL    OED__NAI_1D_DERV_INTEGRALS
     +
     +                       ( MIJ,MGQPIJ,MGIJCEN,
     +                         NGQP,NGQPCEN,
     +                         SHELLA+DERA,SHELLB+DERB,
     +                         DEROPA,DEROPB,DEROPC,
     +                         EXP2A,EXP2B,EXP2AB,
     +                         IXC,PY,CY,
     +                         RTS,
     +                         R1Y,
     +                         BATCH,
     +
     +                                  INT1DY )
     +
     +
             END DO

         ELSE
            
             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,MIN (SHELLA,SHELLB),
     +                      SHELLA,SHELLB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Y,R2,
     +                      ABY,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DY )
     +
     +
         END IF
C---------------------------------------------------------------
C                                                              |
C             ...assemble the 1DZ AB integrals and perform     |
C                differentiation sequence, if necessary.       |
C                                                              |
C---------------------------------------------------------------
         IF (DIFFZ) THEN

             DERA = DERAZ
             DERB = DERBZ

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERA+DERB,
     +                      MIN (SHELLA+DERA,SHELLB+DERB),
     +                      SHELLA+DERA,SHELLB+DERB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Z,R2,
     +                      ABZ,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DZ )
     +
     +
             DO N = 1,NDERZ

                NINT = MGIJCEN * (SHELLA+DERA+1) * (SHELLB+DERB+1)

                DO M = 1,NINT
                   BATCH (M) = INT1DZ (M)
                END DO

                CENTER = CENSQZ (N)

                IF (CENTER.EQ.1) THEN

                    DEROPA = 1
                    DEROPB = IXAEQB
                    DEROPC = 0
                    IF (CEQA) THEN
                        DEROPC = 1
                        IXC = IXCEQA
                        CZ = ZN (NUCCEN (IXCEQA))
                    END IF

                ELSE IF (CENTER.EQ.2) THEN

                    DEROPA = IXAEQB
                    DEROPB = 1
                    DEROPC = 0
                    IF (CEQB) THEN
                        DEROPC = 1
                        IXC = IXCEQB
                        CZ = ZN (NUCCEN (IXCEQB))
                    END IF

                ELSE

                    DEROPA = 0
                    DEROPB = 0
                    DEROPC = 1
                    IXC = 1
                    CZ = ZN (NUCCEN (1))

                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB


c--------------------------------
c--------------------------------


                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming z-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__nai_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__NAI_1D_DERV_INTEGRALS
     +
     +                       ( MIJ,MGQPIJ,MGIJCEN,
     +                         NGQP,NGQPCEN,
     +                         SHELLA+DERA,SHELLB+DERB,
     +                         DEROPA,DEROPB,DEROPC,
     +                         EXP2A,EXP2B,EXP2AB,
     +                         IXC,PZ,CZ,
     +                         RTS,
     +                         R1Z,
     +                         BATCH,
     +
     +                                  INT1DZ )
     +
     +
             END DO

         ELSE

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,MIN (SHELLA,SHELLB),
     +                      SHELLA,SHELLB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Z,R2,
     +                      ABZ,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DZ )
     +
     +
         END IF
C---------------------------------------------------------------------
C                                                                    |
C             ...assemble the 1D AB integrals to the [A|B] batch.    |
C                                                                    |
C---------------------------------------------------------------------
         IF (SHELLP.EQ.0) THEN

             CALL    OED__NAI_DERV_INT1D_TO_00_F12
     +
     +                    ( MIJ,NGQPCEN,MGIJCEN,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLB.EQ.0) THEN

             CALL    OED__NAI_DERV_INT1D_TO_A0_F12
     +
     +                    ( SHELLA,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZA,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,R1Y,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLA.EQ.0) THEN

             CALL    OED__NAI_DERV_INT1D_TO_A0_F12
     +
     +                    ( SHELLB,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,R1Y,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
     +
         ELSE

             CALL    OED__NAI_DERV_INT1D_TO_AB_F12
     +
     +                    ( SHELLA,SHELLB,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZA,NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,R1Y,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine find_clean_block(iblock, server_table, nserver_table)
c---------------------------------------------------------------------------
c   Find a block that is in a "clean" state.
c   If no clean blocks are found that are not also busy, return -1.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'parallel_info.h'

      integer iblock, nserver_table
      integer server_table(lserver_table_entry,nserver_table)

      call pop_clean_block(iblock, server_table, nserver_table)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C
C FLUSHES SYMMETRY INFORMATION TO FILE SYMINF.
C
      SUBROUTINE FLUSHS(IORDER,IORBIT,SYMOPS,IPTR,MEMBER,ORBPOP,
     &                  CLSTYP,NATOMS,LABEL,PTGRP,NCLASS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER CLSTYP,ORBPOP
#include "mxatms.par"
      CHARACTER*4 PTGRP
      CHARACTER*4 LABEL
      CHARACTER*8 FULLAB,szJunk,STSYM(MXATMS)
      character*(8*mxatms) szStSymTmp
      DIMENSION SYMOPS(9*IORDER),IPTR(NATOMS,IORDER),MEMBER(NATOMS)
      DIMENSION ORBPOP(IORBIT),CLSTYP(IORBIT)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /LOCAL/ STSYM
C      COMMON /LOCAL/ STSYM
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)

      szJunk(1:4)=PTGRP
      szJunk(5:8)=' '
C
C PUT STUFF OUT ON JOBARC.
C
C
C WRITE OUT POINT GROUP, ORDER AND NUMBER OF CLASSES.
C

csb
      if(label.eq.'FULL' .and. iflags(46).gt.0) then
        write(6,1000)
        write(6,1002) szJunk
        write(6,1004) iorder
        write(6,1008)
        write(6,1009) (orbpop(i),i=1,natoms)
        write(6,1010)
        write(6,1009) (member(i),i=1,natoms)
        write(6,1012)
      endif
 1000 format('*** ORBIT')
 1002 format(' PTGRP: ',a4)
 1004 format(' ORDR : ',i4)
 1008 format(' POPV : ')
 1009 format(15(i5))
 1010 format(' MEMB : ')
 1012 format('*** END')

      ISIZE=1
      FULLAB=LABEL//'PTGP'
CSS      CALL IGETREC(0, 'JOBARC', FULLAB, length, Ijunk)
CSS      Print*, "The length", length, FULLAB, szjunk
      CALL PUTCREC(20,'JOBARC',FULLAB,8,szJunk)
      FULLAB=LABEL//'ORDR'
CSS      CALL IGETREC(0, 'JOBARC', FULLAB, length, Ijunk) 
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,IORDER)
      FULLAB=LABEL//'NIRR'
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,NCLASS)
C
C WRITE OUT THE NUMBER OF ORBITS
C
      FULLAB=LABEL//'NORB'
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,IORBIT)
C
C WRITE OUT SYMMETRY OPERATIONS
C
      FULLAB=LABEL//'SYOP'
      ISIZE=9*IORDER
      CALL DPUTREC(20,'JOBARC',FULLAB,ISIZE,SYMOPS)
C
C WRITE OUT PERMUTATION VECTORS
C
      FULLAB=LABEL//'PERM'
      ISIZE=IORDER*NATOMS
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,IPTR)
C
C WRITE OUT ORBIT CENSUS VECTOR AND ORBIT POPULATION VECTOR.
C
      FULLAB=LABEL//'MEMB'
      ISIZE=NATOMS
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,MEMBER)
      FULLAB=LABEL//'POPV'
c      ISIZE=IORBIT
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,ORBPOP)
C
C WRITE OUT CLASS TYPE VECTOR
C
      FULLAB=LABEL//'CLSS'
      ISIZE=IORDER
      CALL IPUTREC(20,'JOBARC',FULLAB,ISIZE,CLSTYP)
C
C WRITE OUT SITE GROUP VECTOR
C
c   o 'expand' STSYM into a 1-dimensional char array
      FULLAB=LABEL//'STGP'
c      ISIZE=IORBIT
      ISIZE=NATOMS
      iNdx = 1
      do i = 1, iSize
         szStSymTmp(iNdx:iNdx+7) = STSYM(i)(1:8)
         iNdx = iNdx + 8
      end do
      iSize = iSize*8
      CALL PUTCREC(20,'JOBARC',FULLAB,iSize,szStSymTmp(1:iSize))

      CLOSE(UNIT=30,STATUS='KEEP')
      RETURN
      END

C THIS ROUTINE CHECKS THE SYMMETRY OF AN NxN DOUBLE PRECISION 
C MATRIX (A).  FOR ALL ELEMENTS WHICH DIFFER BY MORE THAN 
C TOL WITH THEIR PARTNER [(I,J) AND (J,I)], THE INDICES AND
C VALUES ARE PRINTED OUT [I,J,A(I,J) AND A(J,I)].

      subroutine symchk(a,n,tol)
      implicit double precision (a-h,o-z)
      dimension a(n,n)
      if (n.lt.1) return
      do i = 1, n
         do j = 1, i-1
            if (dabs(a(i,j)-a(j,i)).gt.tol) then
               write(*,'(t3,2I5,2F10.7)') i,j,a(i,j),a(j,i)
            end if
         end do
      end do
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__1111_CSGTO
     +
     +                    ( IMAX,ZMAX,
     +                      NALPHA,NCOEFF,NCSUM,
     +                      NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL2,SHELL3,SHELL4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      ALPHA,CC,CCBEG,CCEND,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      L1CACHE,TILE,NCTROW,
     +                      SCREEN,
     +                      ICORE,
     +
     +                                NBATCH,
     +                                NFIRST,
     +                                ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__1111_CSGTO
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__SET_IJ_KL_PAIRS
C                ERD__1111_DEF_BLOCKS
C                ERD__PREPARE_CTR
C                ERD__SSSS_PCGTO_BLOCK
C                ERD__SSSP_PCGTO_BLOCK
C                ERD__SSPP_PCGTO_BLOCK
C                ERD__SPPP_PCGTO_BLOCK
C                ERD__PPPP_PCGTO_BLOCK
C                ERD__CTR_4INDEX_BLOCK
C                ERD__CTR_RS_EXPAND
C                ERD__CTR_TU_EXPAND
C                ERD__CTR_4INDEX_REORDER
C                ERD__MAP_IJKL_TO_IKJL
C  DESCRIPTION : This operation calculates a batch of contracted
C                electron repulsion integrals on up to four different
C                centers between spherical gaussian type shells.
C
C                Special fast routine for integrals involving s- and
C                p-type shells only!
C
C
C                  Input (x = 1,2,3 and 4):
C
C                    IMAX,ZMAX    =  maximum integer,flp memory
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCSUM        =  total # of contractions
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1,2,3 and 4
C                    ALPHA        =  primitive exponents for csh
C                                    1,2,3,4 in that order
C                    CC           =  full set (including zeros) of
C                                    contraction coefficients for csh
C                                    1,2,3,4 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    CC(BEG)END   =  (lowest)highest nonzero primitive
C                                    index for contractions for csh
C                                    1,2,3,4 in that order. They are
C                                    different from (1)NPGTOx only for
C                                    segmented contractions
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SCREEN       =  is true, if screening will be
C                                    done at primitive integral level
C                    ICORE        =  integer scratch space
C                    ZCORE (part) =  flp scratch space
C
C                  Output:
C
C                    NBATCH       =  # of integrals in batch
C                    NFIRST       =  first address location inside the
C                                    ZCORE array containing the first
C                                    integral
C                    ZCORE        =  full batch of contracted (12|34)
C                                    integrals over spherical gaussians
C                                    starting at ZCORE (NFIRST)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOM12,ATOM34,ATOM23
         LOGICAL     BLOCKED
         LOGICAL     EMPTY
         LOGICAL     EQUAL12,EQUAL34
         LOGICAL     MEMORY
         LOGICAL     REORDER
         LOGICAL     SCREEN
         LOGICAL     SWAPRS,SWAPTU

         INTEGER     CTMOVE,XTMOVE
         INTEGER     I,J,K,L
         INTEGER     IMAX,ZMAX
         INTEGER     IN,OUT
         INTEGER     INDEXR,INDEXS,INDEXT,INDEXU
         INTEGER     IPRIM1,IPRIM2,IPRIM3,IPRIM4
         INTEGER     IPUSED,IPSAVE,IPPAIR
         INTEGER     L1CACHE,TILE,NCTROW
         INTEGER     LCC1,LCC2,LCC3,LCC4
         INTEGER     LCCSEG1,LCCSEG2,LCCSEG3,LCCSEG4
         INTEGER     LEXP1,LEXP2,LEXP3,LEXP4
         INTEGER     MIJ,MKL,MIJKL
         INTEGER     MGRID,NGRID
         INTEGER     MXPRIM,MNPRIM
         INTEGER     NALPHA,NCOEFF,NCSUM
         INTEGER     NBATCH,NFIRST
         INTEGER     NCGTO1,NCGTO2,NCGTO3,NCGTO4,NCGTO12,NCGTO34
         INTEGER     NCGTOR,NCGTOS,NCGTOT,NCGTOU
         INTEGER     NCTR
         INTEGER     NIJ,NKL
         INTEGER     NIJBLK,NKLBLK,NIJBEG,NKLBEG,NIJEND,NKLEND
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4,NPGTO12,NPGTO34
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NXYZ1,NXYZ2,NXYZ3,NXYZ4,NXYZT
         INTEGER     SHELL1,SHELL2,SHELL3,SHELL4,SHELLP,SHELLT
         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORM1,ZNORM2,ZNORM3,ZNORM4,
     +               ZRHO12,ZRHO34,
     +               ZP,ZPX,ZPY,ZPZ,ZSCPK2,
     +               ZQ,ZQX,ZQY,ZQZ,ZSCQK2

         INTEGER     CCBEG (1:NCSUM)
         INTEGER     CCEND (1:NCSUM)
         INTEGER     ICORE (1:IMAX)
         INTEGER     IXOFF (1:4)

         DOUBLE PRECISION    PREFACT
         DOUBLE PRECISION    RN12SQ,RN34SQ
         DOUBLE PRECISION    SPNORM
         DOUBLE PRECISION    TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION    X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4
         DOUBLE PRECISION    X12,Y12,Z12,X34,Y34,Z34
         DOUBLE PRECISION    ZERO,ONE

         DOUBLE PRECISION    ALPHA (1:NALPHA)
         DOUBLE PRECISION    CC    (1:NCOEFF)
         DOUBLE PRECISION    ZCORE (1:ZMAX)

         DOUBLE PRECISION    FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (ZERO    = 0.D0)
         PARAMETER  (ONE     = 1.D0)
         PARAMETER  (PREFACT = 9.027033336764101D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...decide as early as possible if a zero batch of
C                integrals is expected.
C
C
         SHELLP = SHELL1 + SHELL2
         SHELLT = SHELLP + SHELL3 + SHELL4

         ATOM12 = (X1.EQ.X2) .AND. (Y1.EQ.Y2) .AND. (Z1.EQ.Z2)
         ATOM23 = (X2.EQ.X3) .AND. (Y2.EQ.Y3) .AND. (Z2.EQ.Z3)
         ATOM34 = (X3.EQ.X4) .AND. (Y3.EQ.Y4) .AND. (Z3.EQ.Z4)

         ATOMIC = (ATOM12 .AND. ATOM34 .AND. ATOM23)

         IF (ATOMIC .AND. (MOD(SHELLT,2).EQ.1)) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...set the pointers to the alpha exponents, contraction
C                coefficients and segmented contraction boundaries.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LEXP3 = LEXP2 + NPGTO2
         LEXP4 = LEXP3 + NPGTO3

         LCC1 = 1
         LCC2 = LCC1 + NPGTO1 * NCGTO1
         LCC3 = LCC2 + NPGTO2 * NCGTO2
         LCC4 = LCC3 + NPGTO3 * NCGTO3

         LCCSEG1 = 1
         LCCSEG2 = LCCSEG1 + NCGTO1
         LCCSEG3 = LCCSEG2 + NCGTO2
         LCCSEG4 = LCCSEG3 + NCGTO3
C
C
C             ...determine csh equality between center pairs 1,2
C                and 3,4 in increasing order of complexity:
C
C                 centers -> shells -> exponents -> ctr coefficients
C
C
         EQUAL12 = ATOM12

         IF (EQUAL12) THEN
             EQUAL12 =     (SHELL1 .EQ. SHELL2)
     +               .AND. (NPGTO1 .EQ. NPGTO2)
     +               .AND. (NCGTO1 .EQ. NCGTO2)
             IF (EQUAL12) THEN
               K = LEXP1 - 1
               L = LEXP2 - 1
               DO 100 I = 1,NPGTO1
                  EQUAL12 = EQUAL12 .AND. (ALPHA (K+I).EQ.ALPHA (L+I))
  100          CONTINUE
               IF (EQUAL12) THEN
                 K = LCC1 - 1
                 L = LCC2 - 1
                 DO 110 J = 1,NCGTO1
                    IF (EQUAL12) THEN
                      DO 120 I = 1,NPGTO1
                         EQUAL12 = EQUAL12 .AND. (CC (K+I).EQ.CC (L+I))
  120                 CONTINUE
                      K = K + NPGTO1
                      L = L + NPGTO1
                    END IF
  110            CONTINUE
               END IF
             END IF
         END IF

         EQUAL34 = ATOM34

         IF (EQUAL34) THEN
             EQUAL34 =     (SHELL3 .EQ. SHELL4)
     +               .AND. (NPGTO3 .EQ. NPGTO4)
     +               .AND. (NCGTO3 .EQ. NCGTO4)
             IF (EQUAL34) THEN
               K = LEXP3 - 1
               L = LEXP4 - 1
               DO 130 I = 1,NPGTO3
                  EQUAL34 = EQUAL34 .AND. (ALPHA (K+I).EQ.ALPHA (L+I))
  130          CONTINUE
               IF (EQUAL34) THEN
                 K = LCC3 - 1
                 L = LCC4 - 1
                 DO 140 J = 1,NCGTO3
                    IF (EQUAL34) THEN
                      DO 150 I = 1,NPGTO3
                         EQUAL34 = EQUAL34 .AND. (CC (K+I).EQ.CC (L+I))
  150                 CONTINUE
                      K = K + NPGTO3
                      L = L + NPGTO3
                    END IF
  140            CONTINUE
               END IF
             END IF
         END IF
C
C
C             ...calculate relevant data for the [12|34] batch of
C                integrals, such as dimensions, total # of integrals
C                to be expected, relevant ij and kl primitive exponent
C                pairs, etc... The integral prefactor PREFACT has been
C                set as a parameter, its value being = 16 / sqrt(pi).
C                Calculate here also the overall norm factor SPNORM due
C                to presence of s- or p-type shells. The contribution
C                to SPNORM is very simple: each s-type shell -> * 1.0,
C                each p-type shell -> * 2.0.
C
C
         NXYZ1  = SHELL1 + SHELL1 + 1
         NXYZ2  = SHELL2 + SHELL2 + 1
         NXYZ3  = SHELL3 + SHELL3 + 1
         NXYZ4  = SHELL4 + SHELL4 + 1

         NXYZT  = NXYZ1 * NXYZ2 * NXYZ3 * NXYZ4

         IF (.NOT.ATOM12) THEN
             X12 = X1 - X2
             Y12 = Y1 - Y2
             Z12 = Z1 - Z2
             RN12SQ = X12 * X12 + Y12 * Y12 + Z12 * Z12
         ELSE
             X12 = ZERO
             Y12 = ZERO
             Z12 = ZERO
             RN12SQ = ZERO
         END IF

         IF (.NOT.ATOM34) THEN
             X34 = X3 - X4
             Y34 = Y3 - Y4
             Z34 = Z3 - Z4
             RN34SQ = X34 * X34 + Y34 * Y34 + Z34 * Z34
         ELSE
             X34 = ZERO
             Y34 = ZERO
             Z34 = ZERO
             RN34SQ = ZERO
         END IF

         IF (EQUAL12) THEN
             NPGTO12 = (NPGTO1*(NPGTO1+1))/2
             NCGTO12 = (NCGTO1*(NCGTO1+1))/2
         ELSE
             NPGTO12 = NPGTO1 * NPGTO2
             NCGTO12 = NCGTO1 * NCGTO2
         END IF

         IF (EQUAL34) THEN
             NPGTO34 = (NPGTO3*(NPGTO3+1))/2
             NCGTO34 = (NCGTO3*(NCGTO3+1))/2
         ELSE
             NPGTO34 = NPGTO3 * NPGTO4
             NCGTO34 = NCGTO3 * NCGTO4
         END IF

         NCTR = NCGTO12 * NCGTO34

         IPRIM1 = 1
         IPRIM2 = IPRIM1 + NPGTO12
         IPRIM3 = IPRIM2 + NPGTO12
         IPRIM4 = IPRIM3 + NPGTO34

         SWAPRS  = NPGTO1 .GT. NPGTO2
         SWAPTU  = NPGTO3 .GT. NPGTO4

         SPNORM = ONE
         IF (SHELL1.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELL2.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELL3.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELL4.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF

         CALL  ERD__SET_IJ_KL_PAIRS
     +
     +              ( NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                NPGTO12,NPGTO34,
     +                ATOM12,ATOM34,
     +                EQUAL12,EQUAL34,
     +                SWAPRS,SWAPTU,
     +                X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                RN12SQ,RN34SQ,
     +                PREFACT,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                ALPHA (LEXP3),ALPHA (LEXP4),
     +                FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                SCREEN,
     +
     +                         EMPTY,
     +                         NIJ,NKL,
     +                         ICORE (IPRIM1),ICORE (IPRIM2),
     +                         ICORE (IPRIM3),ICORE (IPRIM4),
     +                         ZCORE (1) )
     +
     +
         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...decide on the primitive [12|34] block size and
C                return array sizes and pointers for the primitive
C                [12|34] generation. Perform also some preparation
C                steps for contraction.
C
C
         MEMORY = .FALSE.

         CALL  ERD__1111_DEF_BLOCKS
     +
     +              ( ZMAX,
     +                NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                NIJ,NKL,
     +                NCGTO12,NCGTO34,NCTR,
     +                NXYZT,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                          NIJBLK,NKLBLK,
     +                          NPSIZE,NCSIZE,NWSIZE,
     +                          MXPRIM,MNPRIM,
     +                          ZCBATCH,ZPBATCH,ZWORK,
     +                          ZNORM1,ZNORM2,ZNORM3,ZNORM4,
     +                          ZRHO12,ZRHO34,
     +                          ZP,ZPX,ZPY,ZPZ,ZSCPK2,
     +                          ZQ,ZQX,ZQY,ZQZ,ZSCQK2 )
     +
     +
         BLOCKED = (NIJBLK.LT.NIJ) .OR. (NKLBLK.LT.NKL)

         CALL  ERD__PREPARE_CTR
     +
     +              ( NCSIZE,
     +                NIJ,NKL,
     +                NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                SHELL1,SHELL2,SHELL3,SHELL4,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                ALPHA (LEXP3),ALPHA (LEXP4),
     +                PREFACT,SPNORM,
     +                EQUAL12,EQUAL34,
     +                BLOCKED,
     +                ZCORE (1),
     +
     +                          ZCORE (ZNORM1),ZCORE (ZNORM2),
     +                          ZCORE (ZNORM3),ZCORE (ZNORM4),
     +                          ZCORE (ZRHO12),ZCORE (ZRHO34),
     +                          ZCORE (ZCBATCH) )
     +
     +
         IPUSED = IPRIM4 + NPGTO34
         IPSAVE = IPUSED + MNPRIM
         IPPAIR = IPSAVE + MXPRIM
C
C
C             ...evaluate [12|34] in blocks over ij and kl pairs
C                and add to final contracted (12|34) with full
C                contracted index ranges r,s,t,u. The keyword REORDER
C                indicates, if the primitive [12|34] blocks needs to
C                be transposed before being contracted.
C
C
         REORDER = .FALSE.

         IF (SHELLT.EQ.0) THEN

             DO 1000 NIJBEG = 1,NIJ,NIJBLK
                NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
                MIJ = NIJEND - NIJBEG + 1
                DO 1100 NKLBEG = 1,NKL,NKLBLK
                   NKLEND = MIN0 (NKLBEG+NKLBLK-1,NKL)
                   MKL = NKLEND - NKLBEG + 1
                   MIJKL = MIJ * MKL
                   NPSIZE = NXYZT * MIJKL

                   CALL  ERD__SSSS_PCGTO_BLOCK
     +
     +                        ( NPSIZE,
     +                          ATOMIC,ATOM12,ATOM34,
     +                          MIJ,MKL,
     +                          NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                          X12,Y12,Z12,X34,Y34,Z34,
     +                          ALPHA (LEXP1),ALPHA (LEXP2),
     +                          ALPHA (LEXP3),ALPHA (LEXP4),
     +                          FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          ZCORE (ZNORM1),ZCORE (ZNORM2),
     +                          ZCORE (ZNORM3),ZCORE (ZNORM4),
     +                          ZCORE (ZRHO12),ZCORE (ZRHO34),
     +                          ZCORE (ZP),
     +                          ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                          ZCORE (ZSCPK2),
     +                          ZCORE (ZQ),
     +                          ZCORE (ZQX),ZCORE (ZQY),ZCORE (ZQZ),
     +                          ZCORE (ZSCQK2),
     +
     +                               ZCORE (ZPBATCH) )
     +
     +
                   CALL  ERD__CTR_4INDEX_BLOCK
     +
     +                        ( NPSIZE,NCSIZE,NWSIZE,
     +                          NXYZT,MIJKL,
     +                          MIJ,MKL,NCGTO12,NCGTO34,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                          MXPRIM,MNPRIM,
     +                          CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                          CCBEG (LCCSEG1),CCBEG (LCCSEG2),
     +                          CCBEG (LCCSEG3),CCBEG (LCCSEG4),
     +                          CCEND (LCCSEG1),CCEND (LCCSEG2),
     +                          CCEND (LCCSEG3),CCEND (LCCSEG4),
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          L1CACHE,TILE,NCTROW,
     +                          EQUAL12,EQUAL34,
     +                          SWAPRS,SWAPTU,
     +                          REORDER,
     +                          BLOCKED,
     +                          ICORE (IPUSED),
     +                          ICORE (IPSAVE),
     +                          ICORE (IPPAIR),
     +                          ZCORE (ZPBATCH),
     +                          ZCORE (ZWORK),
     +
     +                                    ZCORE (ZCBATCH) )
     +
     +
 1100           CONTINUE
 1000        CONTINUE

         ELSE IF (SHELLT.EQ.1) THEN

             DO 2000 NIJBEG = 1,NIJ,NIJBLK
                NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
                MIJ = NIJEND - NIJBEG + 1
                DO 2200 NKLBEG = 1,NKL,NKLBLK
                   NKLEND = MIN0 (NKLBEG+NKLBLK-1,NKL)
                   MKL = NKLEND - NKLBEG + 1
                   MIJKL = MIJ * MKL
                   NPSIZE = NXYZT * MIJKL

                   CALL  ERD__SSSP_PCGTO_BLOCK
     +
     +                        ( NPSIZE,
     +                          ATOMIC,ATOM12,ATOM34,
     +                          MIJ,MKL,
     +                          NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          SHELL1,SHELL3,SHELLP,
     +                          X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                          X12,Y12,Z12,X34,Y34,Z34,
     +                          ALPHA (LEXP1),ALPHA (LEXP2),
     +                          ALPHA (LEXP3),ALPHA (LEXP4),
     +                          FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          ZCORE (ZNORM1),ZCORE (ZNORM2),
     +                          ZCORE (ZNORM3),ZCORE (ZNORM4),
     +                          ZCORE (ZRHO12),ZCORE (ZRHO34),
     +                          ZCORE (ZP),
     +                          ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                          ZCORE (ZSCPK2),
     +                          ZCORE (ZQ),
     +                          ZCORE (ZQX),ZCORE (ZQY),ZCORE (ZQZ),
     +                          ZCORE (ZSCQK2),
     +
     +                               ZCORE (ZPBATCH) )
     +
     +
                   CALL  ERD__CTR_4INDEX_BLOCK
     +
     +                        ( NPSIZE,NCSIZE,NWSIZE,
     +                          NXYZT,MIJKL,
     +                          MIJ,MKL,NCGTO12,NCGTO34,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                          MXPRIM,MNPRIM,
     +                          CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                          CCBEG (LCCSEG1),CCBEG (LCCSEG2),
     +                          CCBEG (LCCSEG3),CCBEG (LCCSEG4),
     +                          CCEND (LCCSEG1),CCEND (LCCSEG2),
     +                          CCEND (LCCSEG3),CCEND (LCCSEG4),
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          L1CACHE,TILE,NCTROW,
     +                          EQUAL12,EQUAL34,
     +                          SWAPRS,SWAPTU,
     +                          REORDER,
     +                          BLOCKED,
     +                          ICORE (IPUSED),
     +                          ICORE (IPSAVE),
     +                          ICORE (IPPAIR),
     +                          ZCORE (ZPBATCH),
     +                          ZCORE (ZWORK),
     +
     +                                    ZCORE (ZCBATCH) )
     +
     +
 2200           CONTINUE
 2000        CONTINUE

         ELSE IF (SHELLT.EQ.2) THEN

             DO 3000 NIJBEG = 1,NIJ,NIJBLK
                NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
                MIJ = NIJEND - NIJBEG + 1
                DO 3300 NKLBEG = 1,NKL,NKLBLK
                   NKLEND = MIN0 (NKLBEG+NKLBLK-1,NKL)
                   MKL = NKLEND - NKLBEG + 1
                   MIJKL = MIJ * MKL
                   NPSIZE = NXYZT * MIJKL

                   CALL  ERD__SSPP_PCGTO_BLOCK
     +
     +                        ( NPSIZE,
     +                          ATOMIC,ATOM12,ATOM34,
     +                          MIJ,MKL,
     +                          NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          SHELL1,SHELL3,SHELLP,
     +                          X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                          X12,Y12,Z12,X34,Y34,Z34,
     +                          ALPHA (LEXP1),ALPHA (LEXP2),
     +                          ALPHA (LEXP3),ALPHA (LEXP4),
     +                          FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          ZCORE (ZNORM1),ZCORE (ZNORM2),
     +                          ZCORE (ZNORM3),ZCORE (ZNORM4),
     +                          ZCORE (ZRHO12),ZCORE (ZRHO34),
     +                          ZCORE (ZP),
     +                          ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                          ZCORE (ZSCPK2),
     +                          ZCORE (ZQ),
     +                          ZCORE (ZQX),ZCORE (ZQY),ZCORE (ZQZ),
     +                          ZCORE (ZSCQK2),
     +
     +                               ZCORE (ZPBATCH) )
     +
     +
                   CALL  ERD__CTR_4INDEX_BLOCK
     +
     +                        ( NPSIZE,NCSIZE,NWSIZE,
     +                          NXYZT,MIJKL,
     +                          MIJ,MKL,NCGTO12,NCGTO34,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                          MXPRIM,MNPRIM,
     +                          CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                          CCBEG (LCCSEG1),CCBEG (LCCSEG2),
     +                          CCBEG (LCCSEG3),CCBEG (LCCSEG4),
     +                          CCEND (LCCSEG1),CCEND (LCCSEG2),
     +                          CCEND (LCCSEG3),CCEND (LCCSEG4),
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          L1CACHE,TILE,NCTROW,
     +                          EQUAL12,EQUAL34,
     +                          SWAPRS,SWAPTU,
     +                          REORDER,
     +                          BLOCKED,
     +                          ICORE (IPUSED),
     +                          ICORE (IPSAVE),
     +                          ICORE (IPPAIR),
     +                          ZCORE (ZPBATCH),
     +                          ZCORE (ZWORK),
     +
     +                                    ZCORE (ZCBATCH) )
     +
     +
 3300           CONTINUE
 3000        CONTINUE

         ELSE IF (SHELLT.EQ.3) THEN

             DO 4000 NIJBEG = 1,NIJ,NIJBLK
                NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
                MIJ = NIJEND - NIJBEG + 1
                DO 4400 NKLBEG = 1,NKL,NKLBLK
                   NKLEND = MIN0 (NKLBEG+NKLBLK-1,NKL)
                   MKL = NKLEND - NKLBEG + 1
                   MIJKL = MIJ * MKL
                   NPSIZE = NXYZT * MIJKL

                   CALL  ERD__SPPP_PCGTO_BLOCK
     +
     +                        ( NPSIZE,
     +                          ATOMIC,ATOM12,ATOM34,
     +                          MIJ,MKL,
     +                          NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          SHELL1,SHELL3,SHELLP,
     +                          X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                          X12,Y12,Z12,X34,Y34,Z34,
     +                          ALPHA (LEXP1),ALPHA (LEXP2),
     +                          ALPHA (LEXP3),ALPHA (LEXP4),
     +                          FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          ZCORE (ZNORM1),ZCORE (ZNORM2),
     +                          ZCORE (ZNORM3),ZCORE (ZNORM4),
     +                          ZCORE (ZRHO12),ZCORE (ZRHO34),
     +                          ZCORE (ZP),
     +                          ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                          ZCORE (ZSCPK2),
     +                          ZCORE (ZQ),
     +                          ZCORE (ZQX),ZCORE (ZQY),ZCORE (ZQZ),
     +                          ZCORE (ZSCQK2),
     +
     +                               ZCORE (ZPBATCH) )
     +
     +
                   CALL  ERD__CTR_4INDEX_BLOCK
     +
     +                        ( NPSIZE,NCSIZE,NWSIZE,
     +                          NXYZT,MIJKL,
     +                          MIJ,MKL,NCGTO12,NCGTO34,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                          MXPRIM,MNPRIM,
     +                          CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                          CCBEG (LCCSEG1),CCBEG (LCCSEG2),
     +                          CCBEG (LCCSEG3),CCBEG (LCCSEG4),
     +                          CCEND (LCCSEG1),CCEND (LCCSEG2),
     +                          CCEND (LCCSEG3),CCEND (LCCSEG4),
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          L1CACHE,TILE,NCTROW,
     +                          EQUAL12,EQUAL34,
     +                          SWAPRS,SWAPTU,
     +                          REORDER,
     +                          BLOCKED,
     +                          ICORE (IPUSED),
     +                          ICORE (IPSAVE),
     +                          ICORE (IPPAIR),
     +                          ZCORE (ZPBATCH),
     +                          ZCORE (ZWORK),
     +
     +                                    ZCORE (ZCBATCH) )
     +
     +
 4400           CONTINUE
 4000        CONTINUE

         ELSE

             DO 5000 NIJBEG = 1,NIJ,NIJBLK
                NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
                MIJ = NIJEND - NIJBEG + 1
                DO 5500 NKLBEG = 1,NKL,NKLBLK
                   NKLEND = MIN0 (NKLBEG+NKLBLK-1,NKL)
                   MKL = NKLEND - NKLBEG + 1
                   MIJKL = MIJ * MKL
                   NPSIZE = NXYZT * MIJKL

                   CALL  ERD__PPPP_PCGTO_BLOCK
     +
     +                        ( NPSIZE,
     +                          ATOMIC,ATOM12,ATOM34,
     +                          MIJ,MKL,
     +                          NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                          X12,Y12,Z12,X34,Y34,Z34,
     +                          ALPHA (LEXP1),ALPHA (LEXP2),
     +                          ALPHA (LEXP3),ALPHA (LEXP4),
     +                          FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          ZCORE (ZNORM1),ZCORE (ZNORM2),
     +                          ZCORE (ZNORM3),ZCORE (ZNORM4),
     +                          ZCORE (ZRHO12),ZCORE (ZRHO34),
     +                          ZCORE (ZP),
     +                          ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                          ZCORE (ZSCPK2),
     +                          ZCORE (ZQ),
     +                          ZCORE (ZQX),ZCORE (ZQY),ZCORE (ZQZ),
     +                          ZCORE (ZSCQK2),
     +
     +                               ZCORE (ZPBATCH) )
     +
     +
                   CALL  ERD__CTR_4INDEX_BLOCK
     +
     +                        ( NPSIZE,NCSIZE,NWSIZE,
     +                          NXYZT,MIJKL,
     +                          MIJ,MKL,NCGTO12,NCGTO34,
     +                          NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                          NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                          MXPRIM,MNPRIM,
     +                          CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                          CCBEG (LCCSEG1),CCBEG (LCCSEG2),
     +                          CCBEG (LCCSEG3),CCBEG (LCCSEG4),
     +                          CCEND (LCCSEG1),CCEND (LCCSEG2),
     +                          CCEND (LCCSEG3),CCEND (LCCSEG4),
     +                          ICORE (IPRIM1+NIJBEG-1),
     +                          ICORE (IPRIM2+NIJBEG-1),
     +                          ICORE (IPRIM3+NKLBEG-1),
     +                          ICORE (IPRIM4+NKLBEG-1),
     +                          L1CACHE,TILE,NCTROW,
     +                          EQUAL12,EQUAL34,
     +                          SWAPRS,SWAPTU,
     +                          REORDER,
     +                          BLOCKED,
     +                          ICORE (IPUSED),
     +                          ICORE (IPSAVE),
     +                          ICORE (IPPAIR),
     +                          ZCORE (ZPBATCH),
     +                          ZCORE (ZWORK),
     +
     +                                    ZCORE (ZCBATCH) )
     +
     +
 5500           CONTINUE
 5000        CONTINUE

         END IF
C
C
C             ...expand the contraction indices (if necessary):
C
C                   batch (nxyzt,r>=s,t>=u) --> batch (nxyzt,r,s,t,u)
C
C                and reorder the contraction indices (if necessary):
C
C                   batch (nxyzt,r,s,t,u) --> batch (nxyzt,i,j,k,l)
C
C                such that they are in final correspondence:
C
C                                    i --> 1
C                                    j --> 2
C                                    k --> 3
C                                    l --> 4
C
         NCTR = NCGTO1 * NCGTO2 * NCGTO3 * NCGTO4
         NBATCH = NXYZT * NCTR

         IN = ZCBATCH
         OUT = ZCBATCH + NBATCH

         IF (EQUAL12 .AND. NCGTO12.GT.1) THEN
             CALL  ERD__CTR_RS_EXPAND
     +
     +                  ( NXYZT,NCGTO12,NCGTO34,
     +                    NCGTO1,NCGTO2,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished ctr rs expansion '

             I = IN
             IN = OUT
             OUT = I
         END IF

         NCGTO12 = NCGTO1 * NCGTO2

         IF (EQUAL34 .AND. NCGTO34.GT.1) THEN
             CALL  ERD__CTR_TU_EXPAND
     +
     +                  ( NXYZT*NCGTO12,NCGTO34,
     +                    NCGTO3,NCGTO4,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished ctr tu expansion '

             I = IN
             IN = OUT
             OUT = I
         END IF

         NCGTO34 = NCGTO3 * NCGTO4

         IF ((SWAPRS.OR.SWAPTU) .AND. NCTR.GT.1) THEN

              IXOFF (1) = 1
              IXOFF (2) = NCGTO1
              IXOFF (3) = NCGTO1 * NCGTO2
              IXOFF (4) = NCGTO1 * NCGTO2 * NCGTO3

              IF (SWAPRS) THEN
                  INDEXR = 2
                  INDEXS = 1
                  NCGTOR = NCGTO2
                  NCGTOS = NCGTO1
              ELSE
                  INDEXR = 1
                  INDEXS = 2
                  NCGTOR = NCGTO1
                  NCGTOS = NCGTO2
              END IF

              IF (SWAPTU) THEN
                  INDEXT = 4
                  INDEXU = 3
                  NCGTOT = NCGTO4
                  NCGTOU = NCGTO3
              ELSE
                  INDEXT = 3
                  INDEXU = 4
                  NCGTOT = NCGTO3
                  NCGTOU = NCGTO4
              END IF

              CALL  ERD__CTR_4INDEX_REORDER
     +
     +                   ( NXYZT,NCTR,
     +                     NCGTOR,NCGTOS,NCGTOT,NCGTOU,
     +                     IXOFF (INDEXR),IXOFF (INDEXS),
     +                     IXOFF (INDEXT),IXOFF (INDEXU),
     +                     ZCORE (IN),
     +
     +                             ZCORE (OUT) )
     +
     +
C              WRITE (*,*) ' Finished ctr reorder '

              I = IN
              IN = OUT
              OUT = I
         END IF
C
C
C             ...reorder contracted (12|34) batch:
C
C                      batch (nxyz1,nxyz2,nxyz3,nxyz4,rstu) -->
C                               batch (nxyz1,r,nxyz2,s,nxyz3,t,nxyz4,u)
C
C                Do this in three steps (if necessary):
C
C                   i) batch (nxyz1,nxyz2,nxyz3,nxyz4,rstu) -->
C                               batch (nxyz1,nxyz2,nxyz3,rst,nxyz4,u)
C
C                  ii) batch (nxyz1,nxyz2,nxyz3,rst,nxyz4,u) -->
C                               batch (nxyz1,nxyz2,rs,nxyz3,t,nxyz4,u)
C
C                 iii) batch (nxyz1,nxyz2,rs,nxyz3,t,nxyz4,u) -->
C                               batch (nxyz1,r,nxyz2,s,nxyz3,t,nxyz4,u)
C
C
         XTMOVE = NXYZ2 * NXYZ3 * NXYZ4
         CTMOVE = NCGTO12 * NCGTO3

         IF (XTMOVE.GT.1 .OR. CTMOVE.GT.1) THEN

             IF (NXYZ4.GT.1) THEN
                 CALL  ERD__MAP_IJKL_TO_IKJL
     +
     +                      ( NXYZ1*NXYZ2*NXYZ3,
     +                        NXYZ4,
     +                        CTMOVE,
     +                        NCGTO4,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                 ZCORE (OUT) )
     +
     +
                 I = IN
                 IN = OUT
                 OUT = I
             END IF

             IF (NXYZ3.GT.1 .AND. NCGTO12.GT.1) THEN
                 CALL  ERD__MAP_IJKL_TO_IKJL
     +
     +                      ( NXYZ1*NXYZ2,
     +                        NXYZ3,
     +                        NCGTO12,
     +                        NXYZ4*NCGTO34,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                 ZCORE (OUT) )
     +
     +
                 I = IN
                 IN = OUT
                 OUT = I
             END IF

             IF (NXYZ2.GT.1 .AND. NCGTO1.GT.1) THEN
                 CALL  ERD__MAP_IJKL_TO_IKJL
     +
     +                      ( NXYZ1,
     +                        NXYZ2,
     +                        NCGTO1,
     +                        NXYZ3*NXYZ4*NCGTO2*NCGTO34,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                 ZCORE (OUT) )
     +
     +
                 I = IN
                 IN = OUT
                 OUT = I
             END IF

         END IF
C
C
C             ...set final pointer to integrals in ZCORE array.
C
C
         NFIRST = IN
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE A2GET_DEN(COEF, DENS, SCFDEN, RELDEN, SPH2CART, 
     &                     TMP, NBAS, NBASP, NOCC, NSOIRP, IFLG)
     
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL SPHERICAL
      CHARACTER*8 LABELPSCF, LABELDSCF, LABELDENS, LABELSDEN
      CHARACTER*1 SPIN(2)
C
      DIMENSION COEF(NBASP*NBASP), DENS(NBASP*NBASP),SCFDEN(NBAS*NBAS),
     &          NOCC(16), RELDEN(NBAS*NBAS), FOCKMAT(NBASP, NBASP),
     &          SPH2CART(NBAS*NBASP), TMP(NBAS*NBAS), NSOIRP(8)
C
#include "machsp.com"
#include "syminf.com"
#include "jodaflags.com"
C
      DATA SPIN /'A', 'B'/
C
      SPHERICAL = (IFLAGS(62) .EQ. 1)
      NBAS2=NBASP*NBASP
C
      LABELPSCF='HFDENSTY'
      LABELDSCF='HDDENSTY'
      LABELDENS='TDENSITY'
      LABELSDEN='DDENSITY'
C
      CALL ZERO(DENS,   NBASP*NBASP)
      CALL ZERO(SCFDEN, NBAS*NBAS)
      CALL ZERO(RELDEN, NBAS*NBAS)
C
      IF (IFLG.EQ.1) THEN
C
         CALL GETREC(20,'JOBARC','SCFEVCA0',IINTFP*NBAS2,COEF)
         ISOFF=0
      ELSE
         CALL GETREC(20,'JOBARC','SCFEVCB0',IINTFP*NBAS2,COEF)
         ISOFF=8
      ENDIF
C
      IOFF  = 0
      IOFF2 = 0
      DO 10 ISYM=1,NIRREP
         NOCCT=NOCC(ISOFF+ISYM)
         DO 20 IOCC=1,NOCCT
            DO 30 I=1,NSOIRP(ISYM)
               DO 40 J=1,NSOIRP(ISYM)
                  DENS((IOFF+I-1)*NBASP+IOFF+J)=DENS((IOFF+I-1)*
     &                                          NBASP+IOFF+J)+
     &                                          COEF((IOFF+IOCC-1)*
     &                                          NBASP+IOFF+I)*
     &                                          COEF((IOFF+IOCC-1)*
     &                                          NBASP+IOFF+J)
C
   40          CONTINUE
   30       CONTINUE
   20    CONTINUE
C
         IOFF  = IOFF+NSOIRP(ISYM)
         IOFF2 = IOFF2+NOCCT*NBAS2
C
   10 CONTINUE
  
     IF (ZEROTH_ORDER_DENS) THEN
C
C Get the SCF and correlated (relaxed) density matirices in AO basis. For 
C open shell calculations, we also read the density diferences. Note that
C the "relaxed" density read here only contain the correlated contributions.
C
      CALL GETREC(-20, 'JOBARC', LABELPSCF, NBAS2*IINTFP, SCFDEN)
      CALL GETREC(-20, 'JOBARC', LABELDENS, NBAS2*IINTFP, RELDEN)
C      
      IF (IFLG .EQ. 2) THEN
         CALL GETREC(-20, 'JOBARC', LABELDSCF, NBAS2*IINTFP, SCFDEN)
         CALL GETREC(-20, 'JOBARC', LABELSDEN, NBAS2*IINTFP, RELDEN)
      ENDIF
C      
#ifdef _DEBUG_LVL0
      Write(6,*) "The Density matrix in AO basis"
      CALL OUTPUT(RELDEN, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
#endif
      ELSE IF (FIRST_ORDER_DENS) THEN
          
           DO IPERT = 1, NATOMS
C
              WRITE(RECNAMEA, "(A,I2)") "PTDENA", IPERT
              CALL GETREC(20, "JOBARC", RECNAMEA, NBAS2*IINTFP,
C
              WRITE(RECNAMEB, "(A,I2)") "PTDENB", IPERT
              CALL GETREC(20, "JOBARC", RECNAMEB, NBAS2*IINTFP,
     &                    )
              CALL SAXPY(NBAS2, 


C
C At this point we need to transform the density matrices to Cartesian
C basis in order to directly contract with the Cartesian AO integrals.
C 
C$$$      IF (SPHERICAL) THEN
C$$$         CALL GETREC(20, 'JOBARC','CMP2CART', NBAS*NBASP*IINTFP, 
C$$$     &               SPH2CART)

C$$$      Write(6,*) "The spherical to Cartesian transformation matrix"
C$$$      CALL OUTPUT(SPH2CART, 1, NBAS, 1, NBASP, NBAS, NBASP, 1)
C
C$$$         CALL TRANS_SPH2CART(SCFDEN, SPH2CART, TMP, NBAS, NBASP)
C$$$         CALL TRANS_SPH2CART(RELDEN, SPH2CART, TMP, NBAS, NBASP)
C$$$      ENDIF
C
C
      RETURN
      END

C
cjp
cjp in bwcc it computes diagonal elements of the effective hamiltonian,
cjp not the energy, which is obtained from diagonalization of that Heff
cjp after also the offdiagonal elements are computed
cjp
C  DRIVER FOR THE  CALCULATION OF THE CORRELATION ENERGY FOR A GIVEN SET
C  OF AMPLITUDES
C
C  ARGUMENTS :  ICORE ..... ICORE ARRAY
C               MAXCOR .... DIMENSION OF ICORE
C               NLIST2 .... OFFSET OF T2 LIST ON MOINTS (WITH RESPECT TO
C                            TYPE)
C               NLIST1 .... OFFSET OF T1 LISTS ON MOINTS (WITH RESPECT TO
C                            SPIN TYPE)
C               ECORR ..... RETURNS THE CORRELATION ENERGY FOR ALL SPIN CASES
C               ETOT .....  RETURNS TOTAL CORRELATION ENERGY
C               ETOTT2 ...  RETURNS LINEAR CONTRIBUTION TO
C                            THE CORRELATION ENERGY
C               IUHF .....  IUHF FLAG
C               IPRINT ...  PRINT FLAG
C
      SUBROUTINE CMPENG(ICORE,MAXCOR,NLIST2,NLIST1,ECORR,ETOT,ETOTT2,
     &                  IUHF,IPRINT)
      IMPLICIT INTEGER (A-Z)
      LOGICAL TAU,NONHF
      LOGICAL MBPT3,MBPT4,CC,TRPEND,SNGEND,GRAD,MBPTT,SING1
      CHARACTER*2 SPCASE(3)
      DOUBLE PRECISION E,ETOT,FACTOR,ECORR(3),ESPIN,ET2,ETOTT2,
     &                 ESING,SDOT
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SWITCH/ MBPT3,MBPT4,CC,TRPEND,SNGEND,GRAD,MBPTT,SING1,
     &                QCISD
      COMMON /NHFREF/NONHF
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
C
      DIMENSION I0T(2),I0F(2)
C
      EQUIVALENCE (IFLAGS(2),METHOD)
C
      DATA SPCASE /'AA','BB','AB'/
cjp
#include "bwcc.com"
C
c Nevin insured that mxcor is even for alignment
c      MXCOR=MAXCOR
      MXCOR=MAXCOR - MOD(MAXCOR,2)

cYAU: The one-particle entities were moved from the end of icore to the front.
      IFREE=1

      TAU=.FALSE.
      IF((METHOD.GT.9.AND.SING1.AND.METHOD.NE.21.AND.METHOD.NE.23)
     &    .OR.NONHF.AND.SING1)THEN
C
C   ALLOCATE MEMORY FOR T1 AMPLITUDES
C
cYAU       I0T(1)=MXCOR+1-NT(1)*IINTFP
cYAU       MXCOR=MXCOR-NT(1)*IINTFP
       I0T(1)=IFREE
       IFREE=IFREE+NT(1)*IINTFP
       CALL GETLST(ICORE(I0T(1)),1,1,1,1+NLIST1,90)
       IF(IUHF.EQ.0) THEN
        I0T(2)=I0T(1)
       ELSE
cYAU        I0T(2)=I0T(1)-NT(2)*IINTFP
cYAU        MXCOR=MXCOR-NT(2)*IINTFP
        I0T(2)=IFREE
        IFREE=IFREE+NT(2)*IINTFP
        CALL GETLST(ICORE(I0T(2)),1,1,1,2+NLIST1,90)
       ENDIF
       TAU=.TRUE.
C
C   FOR NON HF REFERENCES ALLOCATE MEMORY FOR f(a,I)
C
       IF(NONHF) THEN
cYAU        I0F(1)=I0T(2)-NT(1)*IINTFP
cYAU        MXCOR=MXCOR-NT(1)*IINTFP
        I0F(1)=IFREE
        IFREE=IFREE+NT(1)*IINTFP
        CALL GETLST(ICORE(I0F(1)),1,1,1,3,93)
        IF(IUHF.EQ.0) THEN
         I0F(2)=I0F(1)
        ELSE
cYAU         I0F(2)=I0F(1)-NT(2)*IINTFP
cYAU         MXCOR=MXCOR-NT(2)*IINTFP
         I0F(2)=IFREE
         IFREE=IFREE+NT(2)*IINTFP
         CALL GETLST(ICORE(I0F(2)),1,1,1,4,93)
        ENDIF
       ENDIF
      ENDIF
C
      ETOT=0.D0
      ETOTT2=0.D0
      FACTOR=1.D0
      IF(IUHF.EQ.0)FACTOR=2.D0
      DO 10 ISPIN=1,IUHF+1
       LISTT=43+ISPIN
       ESPIN=0.D0
C
C  FOR NON HF REFERENCE FUNCTION ADD HERE THE T(I,A) f(I,A) CONTRIBUTION
C  THERE ARE AA AND BB CONTRIBUTIONS
C
       IF(NONHF.AND.SING1) THEN
        ESING=SDOT(NT(ISPIN),ICORE(I0T(ISPIN)),1,ICORE(I0F(ISPIN)),1)
        ESPIN=ESPIN+ESING
        ETOT=ETOT+FACTOR*ESING
        ETOTT2=ETOTT2+FACTOR*ESING
       ENDIF
C
C  THE TAU(IJ,AB) <IJ//AB> CONTRIBUTION TO THE ENERGY (AA AND BB SPIN
C  CASES
C
       DO 100 IRREP=1,NIRREP
        DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
        NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
        IF(MIN(NUMSYT,DISSYT).NE.0) THEN
cYAU        I001=1
        I001=IFREE
        I002=I001+IINTFP*NUMSYT*DISSYT
        I003=I002+IINTFP*NUMSYT*DISSYT
        I004=I003+NUMSYT
        IF(I004.LT.MXCOR) THEN
         CALL TENER(NLIST2,ET2,E,NUMSYT,DISSYT,ICORE(I001),
     &             ICORE(I002),ICORE(I0T(ISPIN)),ICORE(I0T(ISPIN)),
     &             ISPIN,TAU,IRREP,POP(1,ISPIN),POP(1,ISPIN),
     &             VRT(1,ISPIN),VRT(1,ISPIN),ICORE(I003))
        ELSE
         CALL INSMEM('CMPENG',I004,MXCOR)
        ENDIF
        ETOTT2=ETOTT2+FACTOR*ET2
        ETOT=ETOT+FACTOR*E
        ESPIN=ESPIN+E
        ENDIF
100    CONTINUE
        ECORR(ISPIN)=ESPIN
       IF(IPRINT.NE.0)WRITE(*,80)SPCASE(ISPIN),ESPIN
80     FORMAT(T3,' The ',A2,' contribution to the correlation ',
     &        'energy is: ',F12.7,' a.u.')
10    CONTINUE
C
C  THE TAU(Ij,Ab) <Ij//Ab> CONTRIBUTION TO THE ENERGY (SPIN CASE AB)
C
      ESPIN=0.D0
      DO 200 IRREP=1,NIRREP
       DISSYT=IRPDPD(IRREP,ISYTYP(1,46))
       NUMSYT=IRPDPD(IRREP,ISYTYP(2,46))
       IF(MIN(NUMSYT,DISSYT).NE.0) THEN
cYAU        I001=1
        I001=IFREE
        I002=I001+IINTFP*NUMSYT*DISSYT
        I003=I002+IINTFP*NUMSYT*DISSYT
        I004=I003+NUMSYT
        IF(I004.LT.MXCOR) THEN
         CALL TENER(NLIST2,ET2,E,NUMSYT,DISSYT,ICORE(I001),
     &              ICORE(I002),ICORE(I0T(1)),ICORE(I0T(2)),3,TAU,
     &              IRREP,POP(1,1),POP(1,2),VRT(1,1),VRT(1,2),
     &              ICORE(I003))
        ELSE
         CALL INSMEM('CMPENG',I004,MXCOR)
        ENDIF
        ETOTT2=ETOTT2+ET2
        ETOT=ETOT+E
        ESPIN=ESPIN+E
       ENDIF
200   CONTINUE
      ECORR(3)=ESPIN
      IF(IPRINT.NE.0)WRITE(*,80)SPCASE(3),ESPIN
      IF(IPRINT.NE.0)WRITE(*,81)ETOT
81    FORMAT(T3,' The total correlation energy is ',F15.12,' a.u.')
cjp
cjp add vacuum energy of (iref) and store the result in diagonal element
cjp of the effective hamiltonian
cjp
      if (isbwcc) heff(iref,iref)=etot+hdiagcontr(iref)
      RETURN
      END

C
cjp
cjp in bwcc it computes diagonal elements of the effective hamiltonian,
cjp not the energy, which is obtained from diagonalization of that Heff
cjp after also the offdiagonal elements are computed
cjp
C  DRIVER FOR THE  CALCULATION OF THE CORRELATION ENERGY FOR A GIVEN SET
C  OF AMPLITUDES
C
C  ARGUMENTS :  ICORE ..... ICORE ARRAY
C               MAXCOR .... DIMENSION OF ICORE
C               NLIST2 .... OFFSET OF T2 LIST ON MOINTS (WITH RESPECT TO
C                            TYPE)
C               NLIST1 .... OFFSET OF T1 LISTS ON MOINTS (WITH RESPECT TO
C                            SPIN TYPE)
C               ECORR ..... RETURNS THE CORRELATION ENERGY FOR ALL SPIN CASES
C               ETOT .....  RETURNS TOTAL CORRELATION ENERGY
C               ETOTT2 ...  RETURNS LINEAR CONTRIBUTION TO
C                            THE CORRELATION ENERGY
C               IUHF .....  IUHF FLAG
C               IPRINT ...  PRINT FLAG
C
      SUBROUTINE CMPENG(ICORE,MAXCOR,NLIST2,NLIST1,ECORR,ETOT,ETOTT2,
     &                  IUHF,IPRINT)
      IMPLICIT INTEGER (A-Z)
      LOGICAL TAU,NONHF
      LOGICAL MBPT3,MBPT4,CC,TRPEND,SNGEND,GRAD,MBPTT,SING1
      CHARACTER*2 SPCASE(3)
      DOUBLE PRECISION E,ETOT,FACTOR,ECORR(3),ESPIN,ET2,ETOTT2,
     &                 ESING,SDOT
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SWITCH/ MBPT3,MBPT4,CC,TRPEND,SNGEND,GRAD,MBPTT,SING1,
     &                QCISD
      COMMON /NHFREF/NONHF
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
C
      DIMENSION I0T(2),I0F(2)
C
      EQUIVALENCE (IFLAGS(2),METHOD)
C
      DATA SPCASE /'AA','BB','AB'/
cjp





cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)



C
c Nevin insured that mxcor is even for alignment
c      MXCOR=MAXCOR
      MXCOR=MAXCOR - MOD(MAXCOR,2)

cYAU: The one-particle entities were moved from the end of icore to the front.
      IFREE=1

      TAU=.FALSE.
      IF((METHOD.GT.9.AND.SING1.AND.METHOD.NE.21.AND.METHOD.NE.23)
     &    .OR.NONHF.AND.SING1)THEN
C
C   ALLOCATE MEMORY FOR T1 AMPLITUDES
C
cYAU       I0T(1)=MXCOR+1-NT(1)*IINTFP
cYAU       MXCOR=MXCOR-NT(1)*IINTFP
       I0T(1)=IFREE
       IFREE=IFREE+NT(1)*IINTFP
       CALL GETLST(ICORE(I0T(1)),1,1,1,1+NLIST1,90)
       IF(IUHF.EQ.0) THEN
        I0T(2)=I0T(1)
       ELSE
cYAU        I0T(2)=I0T(1)-NT(2)*IINTFP
cYAU        MXCOR=MXCOR-NT(2)*IINTFP
        I0T(2)=IFREE
        IFREE=IFREE+NT(2)*IINTFP
        CALL GETLST(ICORE(I0T(2)),1,1,1,2+NLIST1,90)
       ENDIF
       TAU=.TRUE.
C
C   FOR NON HF REFERENCES ALLOCATE MEMORY FOR f(a,I)
C
       IF(NONHF) THEN
cYAU        I0F(1)=I0T(2)-NT(1)*IINTFP
cYAU        MXCOR=MXCOR-NT(1)*IINTFP
        I0F(1)=IFREE
        IFREE=IFREE+NT(1)*IINTFP
        CALL GETLST(ICORE(I0F(1)),1,1,1,3,93)
        IF(IUHF.EQ.0) THEN
         I0F(2)=I0F(1)
        ELSE
cYAU         I0F(2)=I0F(1)-NT(2)*IINTFP
cYAU         MXCOR=MXCOR-NT(2)*IINTFP
         I0F(2)=IFREE
         IFREE=IFREE+NT(2)*IINTFP
         CALL GETLST(ICORE(I0F(2)),1,1,1,4,93)
        ENDIF
       ENDIF
      ENDIF
C
      ETOT=0.D0
      ETOTT2=0.D0
      FACTOR=1.D0
      IF(IUHF.EQ.0)FACTOR=2.D0
      DO 10 ISPIN=1,IUHF+1
       LISTT=43+ISPIN
       ESPIN=0.D0
C
C  FOR NON HF REFERENCE FUNCTION ADD HERE THE T(I,A) f(I,A) CONTRIBUTION
C  THERE ARE AA AND BB CONTRIBUTIONS
C
       IF(NONHF.AND.SING1) THEN
        ESING=SDOT(NT(ISPIN),ICORE(I0T(ISPIN)),1,ICORE(I0F(ISPIN)),1)
        ESPIN=ESPIN+ESING
        ETOT=ETOT+FACTOR*ESING
        ETOTT2=ETOTT2+FACTOR*ESING
       ENDIF
C
C  THE TAU(IJ,AB) <IJ//AB> CONTRIBUTION TO THE ENERGY (AA AND BB SPIN
C  CASES
C
       DO 100 IRREP=1,NIRREP
        DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
        NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
        IF(MIN(NUMSYT,DISSYT).NE.0) THEN
cYAU        I001=1
        I001=IFREE
        I002=I001+IINTFP*NUMSYT*DISSYT
        I003=I002+IINTFP*NUMSYT*DISSYT
        I004=I003+NUMSYT
        IF(I004.LT.MXCOR) THEN
         CALL TENER(NLIST2,ET2,E,NUMSYT,DISSYT,ICORE(I001),
     &             ICORE(I002),ICORE(I0T(ISPIN)),ICORE(I0T(ISPIN)),
     &             ISPIN,TAU,IRREP,POP(1,ISPIN),POP(1,ISPIN),
     &             VRT(1,ISPIN),VRT(1,ISPIN),ICORE(I003))
        ELSE
         CALL INSMEM('CMPENG',I004,MXCOR)
        ENDIF
        ETOTT2=ETOTT2+FACTOR*ET2
        ETOT=ETOT+FACTOR*E
        ESPIN=ESPIN+E
        ENDIF
100    CONTINUE
        ECORR(ISPIN)=ESPIN
       IF(IPRINT.NE.0)WRITE(*,80)SPCASE(ISPIN),ESPIN
80     FORMAT(T3,' The ',A2,' contribution to the correlation ',
     &        'energy is: ',F12.7,' a.u.')
10    CONTINUE
C
C  THE TAU(Ij,Ab) <Ij//Ab> CONTRIBUTION TO THE ENERGY (SPIN CASE AB)
C
      ESPIN=0.D0
      DO 200 IRREP=1,NIRREP
       DISSYT=IRPDPD(IRREP,ISYTYP(1,46))
       NUMSYT=IRPDPD(IRREP,ISYTYP(2,46))
       IF(MIN(NUMSYT,DISSYT).NE.0) THEN
cYAU        I001=1
        I001=IFREE
        I002=I001+IINTFP*NUMSYT*DISSYT
        I003=I002+IINTFP*NUMSYT*DISSYT
        I004=I003+NUMSYT
        IF(I004.LT.MXCOR) THEN
         CALL TENER(NLIST2,ET2,E,NUMSYT,DISSYT,ICORE(I001),
     &              ICORE(I002),ICORE(I0T(1)),ICORE(I0T(2)),3,TAU,
     &              IRREP,POP(1,1),POP(1,2),VRT(1,1),VRT(1,2),
     &              ICORE(I003))
        ELSE
         CALL INSMEM('CMPENG',I004,MXCOR)
        ENDIF
        ETOTT2=ETOTT2+ET2
        ETOT=ETOT+E
        ESPIN=ESPIN+E
       ENDIF
200   CONTINUE
      ECORR(3)=ESPIN
      IF(IPRINT.NE.0)WRITE(*,80)SPCASE(3),ESPIN
      IF(IPRINT.NE.0)WRITE(*,81)ETOT
81    FORMAT(T3,' The total correlation energy is ',F15.12,' a.u.')
cjp
cjp add vacuum energy of (iref) and store the result in diagonal element
cjp of the effective hamiltonian
cjp
      if (isbwcc) heff(iref,iref)=etot+hdiagcontr(iref)
      RETURN
      END

      SUBROUTINE HUPDATE(V,H,SCRATCH,STEP,TBT,ITYPE)
C
C     ARGUMENTS PASSED ARE NEW GRADIENT, HESSIAN (TO BE READ AND
C     RETURNED UPDATED), SCRATCH ARRAY- OLD GRADIENT READ INTO FIRST
C     NXM6 POSITIONS, UPDATE TYPE
C     TBT IS JUST A SCRATCH ARRAY FOR MATRIX MULTIPLY OPERATIONS
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)










































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION V(NXM6),H(NXM6*NXM6),SCRATCH(NX*NX),TBT(3*NXM6*NXM6),
     $   STEP(NXM6)
      LOGICAL POWEL_DONE
      CHARACTER*6 MSPORPSB
      CHARACTER*10 TRASH
      CHARACTER*(fnamelen) FNAME
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
      PARAMETER (TOLRNCE = 1.0D-12)
      DATA ONE /1.00D0/
C
      CALL GFNAME(ARCFIL,FNAME,ILENGTH)
      OPEN(UNIT=LUARC,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
     &     STATUS='OLD')
      DO 10 I=1,NCYCLE
 10   READ(LUARC)TRASH
C
C     Most of the stuff read here is not used - hence the stupid vars.
C The previous cycle's gradients and Hessians are read into scratch and H.
C The incoming variables V, H, and STEP contain the current gradient, Hessian,
C and step size.
C
      READ(LUARC)TRASH,ICRAP,icycle,NJ,NJN,NJNK,NOPT,NJ1,NJ2,NJ3,NJ4,
     $   NJ5,NJ6,NJ7,NJ8,NJ9,NJA,NJB,NJC,NJD,NJE,NJF,NJG,E,
     &   (SCRATCH(I),I=1,NXM6),
     &   (H(I),I=1,NXM6*NXM6),(STEP(J),J=1,NXM6)
      CLOSE(UNIT=LUARC)
      IF(ITYPE.EQ.0)THEN
         WRITE(LuOut,70) icycle
 70      FORMAT(T3,' Hessian from cycle ',i2,' read and not updated.')
      ELSEIF(ITYPE.EQ.1)THEN
C
C        Powell update
C
         WRITE(LuOut,71) icycle
 71      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Powell update using ',
     &      'last two gradients and previous step.')
C
         PHI = ONE
         CALL POWEL(V, H, SCRATCH, STEP, TBT, PHI)
C
      ELSEIF(ITYPE.EQ.2)THEN
C
C        Broyden-Fletcher-Goldfarb-Shanno update
C
         WRITE(LuOut,72) icycle
 72      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' BFGS update using ',
     &      'last two gradients and previous step.')
C
         CALL BFGS(V, H, SCRATCH, STEP, TBT)

C
      ELSEIF(ITYPE.EQ.3)THEN
C
C        Murtagh-Sargent update
C
         WRITE(LuOut,73) icycle
 73      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Murtagh-Sargent update using ',
     &      'last two gradients and previous step.')
C
         POWEL_DONE = .TRUE.
         MSPORPSB   = "MSP   "
         CALL MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                POWEL_DONE, MSPORPSB)
C
      ELSEIF(ITYPE.EQ.4)THEN
C
C        (1-phi)*Powell + (phi)*Murtagh-Sargent update
C
         WRITE(LuOut,74) icycle
 74      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Bofill mixture of Powell and Murtagh-Sargent',
     &      ' update using last two gradients and previous step.')
C
         N2 = NXM6 + 1
         N3 = 2*NXM6+1
         N4 = 3*NXM6+1

         CALL MODMATMUL(SCRATCH(N2),H,STEP,NXM6,NXM6,1,NXM6,NXM6,1)
         CALL DCOPY(NXM6, V, 1, SCRATCH(N3), 1)
         CALL DAXPY(NXM6, -ONE, SCRATCH(1), 1, SCRATCH(N3), 1)
         CALL VADD(SCRATCH(N4),SCRATCH(N3),SCRATCH(N2),NXM6,-1.D0)

         DDXDX  = DDOT(NXM6, STEP, 1, STEP, 1)
         DHDXDG = DDOT(NXM6, SCRATCH(N4), 1, SCRATCH(N4), 1)
         DHDXDX = DDOT(NXM6, SCRATCH(N4), 1, STEP, 1)

         IF (DABS(DHDXDX).GT.TOLRNCE.AND.
     &       DABS(DHDXDG).GT.TOLRNCE) THEN
            PHI = (DHDXDX**2)/(DDXDX*DHDXDG)
         ELSE
            PHI = ONE
         END IF

         CALL POWEL(V, H, SCRATCH, STEP, TBT, ONE-PHI)
         POWEL_DONE = .TRUE.
         MSPORPSB   = "BOFILL"
         CALL MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                POWEL_DONE, MSPORPSB)

      ELSE IF (ITYPE .EQ. 5) THEN
C
C        Powell-symmetric-Broyden update
C
         WRITE(LuOut,75) icycle
 75      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' Powell-Symmetric-Broyden update using ',
     &      'last two gradients and previous step.')
C
         POWEL_DONE = .FALSE.
         MSPORPSB   = "PSB   "
         CALL MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                POWEL_DONE, MSPORPSB)

      ELSE IF (ITYPE .EQ. 6) THEN
C
C  Modified BFGS update

         WRITE(LuOut,76) icycle
 76      FORMAT(T3,' Hessian from cycle ',i2,' read.',/,t3,
     $      ' modified BFGS update using ',
     &      'last two gradients and previous step.')
C
         Print*, "The BFGS update check"
         Write(6,*) (V(I), I =1, NXM6)
         Write(6,*) (SCRATCH(I), I = 1, NXM6)
         Write(6,*) (STEP(I), I= 1, NXM6)
         CALL OUTPUT(H, 1, NXM6, 1, NXM6, NXM6,NXM6, 1 )
         Write(6,*)
CSSS         CALL MODF_BFGS(V, H, SCRATCH, STEP, TBT)
      ENDIF
C
      RETURN
      END

      SUBROUTINE SUMARY(SCRATCH, RFAMAT, GRD, SCALE, STPMAG, VARNAM, 
     &                  ISQUASH, NOPT, NX, NXM6, MXATMS, IBREAK, 
     &                  ICONTL, LUOUT, NOPTI, LUDONE, DONFIL)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      CHARACTER*5 VARNAM
      CHARACTER*(*) DONFIL
      LOGICAL bDonFil
C
      DIMENSION SCRATCH(NX*NX), RFAMAT(NOPT, NOPT), VARNAM(3*MXATMS), 
     &          ISQUASH(3*MXATMS), GRD(NXM6), NOPTI(3*MXATMS)
C
C Do some Printing
C
      WRITE(LUOUT, 88)STPMAG, SCALE
 88   FORMAT(T3,' Summary of Optimization Cycle: ',/,T3,
     &       ' The maximum unscaled ',
     &       'step is: ',F10.5,'.',/,T3,' Scale factor set to: ',
     &        F8.5,'.')
C
      WRITE(LUOUT, 93)
93    FORMAT(T3,' Forces are in hartree/bohr and hartree/radian.',
     &       /,T3,' Parameter values are in Angstroms and degrees.')
C
      WRITE(LUOUT, 81)
      WRITE(LuOut, 881)
      WRITE(LuOut, 81)
881   FORMAT(T3,'Parameter',T17,'dV/dR',T33,'Step',T47,'Rold',
     &       T63,'Rnew')
C
      DO 15 I=1,NOPT
C
         DO 23 J =1, I - 1
            IF (VARNAM(ISQUASH(NOPTI(I))) .EQ. 
     &          VARNAM(ISQUASH(NOPTI(J)))) GOTO 15
 23      CONTINUE

         CNF = 180.0D0/DACOS(-1.D0)
         IF (MOD(ISQUASH(NOPTI(I)),3) .EQ. 1) CNF = 0.529177249D0
         ZOP = SCRATCH(I) - SCRATCH(NOPT+I)
C
         WRITE(LUOUT, 84)VARNAM(ISQUASH(NOPTI(I))), GRD(NOPTI(I)),
     &                   SCRATCH(NOPT+I)*CNF, ZOP*CNF,
     &                   SCRATCH(I)*CNF
C
 15   CONTINUE
C
 84   FORMAT(T5,A,T10,4(F15.10,1X))
C
C Generate statistics based on gradients
C
      CALL ZERO(RFAMAT, NOPT*NOPT)
C
      DO 432 I =1, NOPT
         RFAMAT(I, 1) = GRD(NOPTI(I))
 432  CONTINUE
C
      CALL VSTAT(RFAMAT, SCRATCH(2*NOPT + 1), NOPT)
C
      WRITE(LUOUT,82) SCRATCH(2*NOPT + 2),SCRATCH(2*NOPT + 5)
 82   FORMAT(74('-'),/,T3,'Minimum force: ',F12.9,' / RMS force: ',
     &       F12.9)
 81   FORMAT(74('-'))
C
C see if the calcualtion has converged
C
      IF ( (SCRATCH(2*NOPT + 5) .LT. 10.D0**(-1*ICONTL) ) .AND.
     &     (IBREAK .EQ. 0)                                      ) THEN
C
         WRITE(6,1321)
 1321    FORMAT(80('-'))
         WRITE(6,1325)10.D0**(-1*ICONTL)
 1325    FORMAT(T3,' RMS gradient is below ',E10.5,'.')
         WRITE(6,1322)
 1322    FORMAT(T3,' Convergence criterion satisfied.  Optimization ',
     &      'completed.')
         WRITE(6,1321)

         CALL ADM

C Put file DonFil out on disk so that ACES II can terminate.
C First check to see there is any.
         INQUIRE(FILE=DonFil,EXIST=bDonFil)
         IF (bDonFil) THEN
            WRITE(*,*) '@SUMMARY: File ',DonFil,' already on disk.'
            WRITE(*,*) '          Something is very wrong.'
            INQUIRE(FILE=DonFil,OPENED=bDonFil,NUMBER=LUOLD)
            IF (bDonFil) THEN
               CLOSE(UNIT=LUOLD,STATUS='DELETE')
            ELSE
               OPEN(UNIT=LUDONE,FILE=DonFil,FORM='UNFORMATTED',
     &              STATUS='NEW')
               CLOSE(UNIT=LUDONE,STATUS='DELETE')
            END IF
         END IF

cYAU         WRITE(*,*) '@SUMMARY: Writing out completion flag to disk.'
         OPEN(UNIT=LUDONE, FILE=DonFil, FORM='UNFORMATTED',  
     &        STATUS='NEW')
         CLOSE(UNIT=LUDONE, STATUS='KEEP')

         CALL ACES_JA_FIN
         STOP

      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sum_blocks(x1handle, x1_block, x1_ndx, 
     *                      x2handle, x2_block, x2_ndx,
     *                      yhandle, y_block, y_ndx, opcode,
     *                      array_table, narray_table, 
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table, 
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
c--------------------------------------------------------------------------
c   Forms the sum of blocks x1 and x2, resulting in block y.
c   x1, x2, and y are the array_table entries for their respective arrays.
c   x1_block, x2_block, and y_block are the actual block indices of the
c   blocks to be summed.
c
c   If the opcode is a subtract_op, this routine forms the difference
c   of x1-x2, storing the result in y.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer nsegment_table 
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer x1handle, x2handle, yhandle
      integer x1_block, x2_block, y_block 
      integer x1_ndx, x2_ndx, y_ndx
      integer opcode, flopcount

      integer n1, n2, ny
      integer nw, iseg
      integer*8 indy, indx1, indx2, daddr
      integer*8 get_block_data_index
      integer stack
      integer*8 get_index_from_base
      integer i, j, k
      integer ind(mx_array_index,3)
      integer range1(mx_array_index), range2(mx_array_index)
      integer dim1(mx_array_index,3), dim2(mx_array_index,3)
      integer blkmgr_blocksize
      integer x1type, x2type, ytype

      double precision y(1), x1(1), x2(2)
#ifdef ALTIX
      pointer (ptry, y)
      pointer (ptrx1, x1)
      pointer (ptrx2, x2)
#else
      common y, x1, x2
#endif

      x1type = array_table(c_array_type, x1handle)
      x2type = array_table(c_array_type, x2handle)
      ytype = array_table(c_array_type, yhandle)
      
#ifdef ALTIX
      ptry = dshptr
      ptrx1 = dshptr
      ptrx2 = dshptr
#endif

c--------------------------------------------------------------------------
c   Verify no operands are scalars.
c--------------------------------------------------------------------------

      if (x1type .eq. scalar_value .or.
     *    x2type .eq. scalar_value .or.
     *    ytype .eq. scalar_value) then
         print *,'Error in sum_blocks: One or more scalar operands.'
         print *,'Operands are ',x1handle,x2handle,yhandle
      endif
 
      n1 = array_table(c_nindex, x1handle)
      n2 = array_table(c_nindex, x2handle)
      ny = array_table(c_nindex, yhandle)

      flopcount = 0

      do j = 1, 3
      do i = 1, mx_array_index
        ind(i,j) = 0
      enddo
      enddo
     
c-----------------------------------------------------------------------
c   Match the operand indices with that of the result.
c-----------------------------------------------------------------------

      do i = 1, ny
         ind(i,1) = array_table(c_index_array1+i-1,yhandle)
         
         do j = 1, n1
            if (ind(i,1) .eq. array_table(c_index_array1+j-1,x1handle)) 
     *            ind(i,2) = array_table(c_index_array1+j-1,x1handle)
         enddo

         do j = 1, n2
            if (ind(i,1) .eq. array_table(c_index_array1+j-1,x2handle))
     *            ind(i,3) = array_table(c_index_array1+j-1,x2handle)
         enddo
      enddo

c--------------------------------------------------------------------------
c   All indices must match for a summation operation.
c--------------------------------------------------------------------------

      do i = 1, ny
         if (ind(i,1) .ne. ind(i,2) .or.
     *       ind(i,1) .ne. ind(i,3)) then
            print *,'Error: Summation of blocks, non-matching indices.'
            print *,'Indices:'
            do j = 1, ny
               print *,'   ',ind(j,1),ind(j,2),ind(j,3)
            enddo
            call abort_job()
         endif
      enddo

c---------------------------------------------------------------------------
c   Compute the size of the block.
c---------------------------------------------------------------------------

      nw = 1
      do i = 1, ny
         iseg = index_table(c_current_seg,ind(i,1))
         call get_index_segment(ind(i,1), iseg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, range1(i), range2(i))
         nw = nw * (range2(i)-range1(i)+1)
      enddo

      if (ytype .eq. static_array) then
         daddr = address_table(yhandle)
         indy  = get_index_from_base(daddr, y, 2)
         do i = 1, ny
            dim1(i,1) = array_table(c_index_range1+i-1,yhandle)
            dim2(i,1) = array_table(c_index_range2+i-1,yhandle)
         enddo
      else
         stack = array_table(c_array_stack,yhandle)
         indy  = get_block_data_index(yhandle, y_block, stack,
     *                                y_ndx, y) 
         do i = 1, ny
            dim1(i,1) = range1(i)
            dim2(i,1) = range2(i)
         enddo
      endif

      if (x1type .eq. static_array) then
         daddr = address_table(x1handle)
         indx1 = get_index_from_base(daddr, x1, 2)
         do i = 1, n1
            dim1(i,2) = array_table(c_index_range1+i-1,x1handle)
            dim2(i,2) = array_table(c_index_range2+i-1,x1handle)
         enddo
      else
         stack = array_table(c_array_stack,x1handle)
         indx1 = get_block_data_index(x1handle, x1_block, stack, x1_ndx,
     *                                      x1) 
         do i = 1, n1
            dim1(i,2) = range1(i)
            dim2(i,2) = range2(i)
         enddo
      endif

      if (x2type .eq. static_array) then
         daddr = address_table(x2handle)
         indx2 = get_index_from_base(daddr, x2, 2)
         do i = 1, n2
            dim1(i,3) = array_table(c_index_range1+i-1,x2handle)
            dim2(i,3) = array_table(c_index_range2+i-1,x2handle)
         enddo
      else
         stack = array_table(c_array_stack,x2handle)
         indx2 = get_block_data_index(x2handle, x2_block, stack,
     *                                x2_ndx, x2) 
         do i = 1, n2
            dim1(i,3) = range1(i)
            dim2(i,3) = range2(i)
         enddo
      endif

c      if (ytype .ne. static_array .and. 
c     *    x1type .ne. static_array .and.
c     *    x2type .ne. static_array) then

c---------------------------------------------------------------------------
c   Sum the blocks.
c---------------------------------------------------------------------------

c         call add_sub_blocks(y(indy), x1(indx1), x2(indx2), nw,
c     *                          opcode)
c      else

c----------------------------------------------------------------------------
c   Special code to handle static array dimensions.
c----------------------------------------------------------------------------

         if (ny .eq. 4) then
            call sum_static_blocks4(y(indy),range1(1),range2(1),
     *             range1(2),range2(2),range1(3),range2(3),
     *             range1(4),range2(4),dim1(1,1),dim2(1,1),
     *             dim1(2,1),dim2(2,1),dim1(3,1),dim2(3,1),
     *             dim1(4,1),dim2(4,1), x1(indx1), 
     *             dim1(1,2),dim2(1,2),dim1(2,2),dim2(2,2),
     *             dim1(3,2),dim2(3,2),dim1(4,2),dim2(4,2),
     *             x2(indx2),
     *             dim1(1,3),dim2(1,3),dim1(2,3),dim2(2,3),
     *             dim1(3,3),dim2(3,3),dim1(4,3),dim2(4,3),
     *             opcode)
         else if (ny .eq. 2) then
            call sum_static_blocks2(y(indy),range1(1),range2(1),
     *             range1(2),range2(2),
     *             dim1(1,1),dim2(1,1),dim1(2,1),dim2(2,1),
     *             x1(indx1),
     *             dim1(1,2),dim2(1,2),dim1(2,2),dim2(2,2),
     *             x2(indx2),
     *             dim1(1,3),dim2(1,3),dim1(2,3),dim2(2,3),
     *             opcode)
         else if (ny .eq. 6) then
            call sum_static_blocks6(y(indy),range1(1),range2(1),
     *             range1(2),range2(2),range1(3),range2(3),
     *             range1(4),range2(4),range1(5),range2(5),
     *             range1(6),range2(6),
     *             dim1(1,1),dim2(1,1),
     *             dim1(2,1),dim2(2,1),dim1(3,1),dim2(3,1),
     *             dim1(4,1),dim2(4,1), 
     *             dim1(5,1),dim2(5,1), dim1(6,1),dim2(6,1), 
     *             x1(indx1),
     *             dim1(1,2),dim2(1,2),dim1(2,2),dim2(2,2),
     *             dim1(3,2),dim2(3,2),dim1(4,2),dim2(4,2),
     *             dim1(5,2),dim2(5,2),dim1(6,2),dim2(6,2),
     *             x2(indx2),
     *             dim1(1,3),dim2(1,3),dim1(2,3),dim2(2,3),
     *             dim1(3,3),dim2(3,3),dim1(4,3),dim2(4,3),
     *             dim1(5,3),dim2(5,3),dim1(6,3),dim2(6,3),
     *             opcode)
         else if (ny .eq. 5) then
            call sum_static_blocks5(y(indy),range1(1),range2(1),
     *             range1(2),range2(2),range1(3),range2(3),
     *             range1(4),range2(4),range1(5),range2(5),
     *             dim1(1,1),dim2(1,1),
     *             dim1(2,1),dim2(2,1),dim1(3,1),dim2(3,1),
     *             dim1(4,1),dim2(4,1),
     *             dim1(5,1),dim2(5,1),
     *             x1(indx1),
     *             dim1(1,2),dim2(1,2),dim1(2,2),dim2(2,2),
     *             dim1(3,2),dim2(3,2),dim1(4,2),dim2(4,2),
     *             dim1(5,2),dim2(5,2),
     *             x2(indx2),
     *             dim1(1,3),dim2(1,3),dim1(2,3),dim2(2,3),
     *             dim1(3,3),dim2(3,3),dim1(4,3),dim2(4,3),
     *             dim1(5,3),dim2(5,3),
     *             opcode)
         else if (ny .eq. 3) then 
            call sum_static_blocks3(y(indy),range1(1),range2(1),
     *             range1(2),range2(2),range1(3),range2(3),
     *             dim1(1,1),dim2(1,1),
     *             dim1(2,1),dim2(2,1),dim1(3,1),dim2(3,1),
     *             x1(indx1),
     *             dim1(1,2),dim2(1,2),dim1(2,2),dim2(2,2),
     *             dim1(3,2),dim2(3,2),
     *             x2(indx2),
     *             dim1(1,3),dim2(1,3),dim1(2,3),dim2(2,3),
     *             dim1(3,3),dim2(3,3),
     *             opcode)
         else if (ny .eq. 1) then
            call sum_static_blocks1(y(indy),range1(1),range2(1),
     *             dim1(1,1),dim2(1,1),
     *             x1(indx1),
     *             x2(indx2),
     *             opcode)
         else
            print *,'Error: Cannot handle static arrays of dimension',
     *           ' other than 2,3, 4, or 6.'
            print *,'Arrays have dimension of ',ny
            call abort_job()
         endif
c      endif

      flopcount = nw

      return
      end

      subroutine sum_static_blocks6(y, a1,a2,b1,b2,c1,c2,d1,d2,
     *                              e1,e2,f1,f2,
     *                              na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                              ny51,ny52,ny61,ny62,
     *                              x1,ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,
     *                              nx1_51,nx1_52,nx1_61,nx1_62,
     *                              x2,ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                              nx2_51,nx2_52,nx2_61,nx2_62,
     *                              opcode)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2
      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ny51,ny52,ny61,ny62
      integer ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,nx1_51,nx1_52,nx1_61,
     *        nx1_62
      integer ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,nx2_51,nx2_52,nx2_61,
     *        nx2_62
      double precision 
     *    y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2,ny51:ny52,ny61:ny62)
      double precision 
     *  x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2,nx1_51:nx1_52,nx1_61:nx1_62)
      double precision 
     *  x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2,nx2_51:nx2_52,nx2_61:nx2_62)
      integer opcode, a,b,c,d,e,f

      if (opcode .eq. subtract_op) then
         do f = f1,f2
         do e = e1,e2
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d,e,f) = x1(a,b,c,d,e,f) - x2(a,b,c,d,e,f)
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
      else if (opcode .eq. sum_op) then
         do f = f1,f2
         do e = e1,e2
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d,e,f) = x1(a,b,c,d,e,f) + x2(a,b,c,d,e,f) 
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
      else
         print *,'Error: Invalid opcode in sum_static_blocks6: ',
     *      opcode
         call abort_job()
      endif

      return
      end

      subroutine sum_static_blocks4(y, a1,a2,b1,b2,c1,c2,d1,d2,
     *                              na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                              x1,ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,
     *                              x2,ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                              opcode)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2
      integer ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2
      integer ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2
      double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2) 
      integer opcode, a,b,c,d

      if (opcode .eq. subtract_op) then
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d) = x1(a,b,c,d) - x2(a,b,c,d)
         enddo
         enddo
         enddo
         enddo
      else if (opcode .eq. sum_op) then
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d) = x1(a,b,c,d) + x2(a,b,c,d)
         enddo
         enddo
         enddo
         enddo
      else
         print *,'Error: Invalid opcode in sum_static_blocks4: ',
     *      opcode
         call abort_job()
      endif

      return
      end

c---------------------------------------------------------------------------|

      subroutine sum_static_blocks5(y, a1,a2,b1,b2,c1,c2,d1,d2,
     *                              e1,e2,
     *                              na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                              ny51,ny52,
     *                              x1,ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,
     *                              nx1_51,nx1_52,
     *                              x2,ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                              nx2_51,nx2_52,
     *                              opcode)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2
      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ny51,ny52,ny61,ny62
      integer ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,nx1_51,nx1_52,nx1_61,
     *        nx1_62
      integer ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,nx2_51,nx2_52,nx2_61,
     *        nx2_62
      double precision
     *    y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2,ny51:ny52)
      double precision
     *  x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2,nx1_51:nx1_52)
      double precision
     *  x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2,nx2_51:nx2_52)
      integer opcode, a,b,c,d,e,f

      if (opcode .eq. subtract_op) then

         do e = e1,e2
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d,e) = x1(a,b,c,d,e) - x2(a,b,c,d,e)
         enddo
         enddo
         enddo
         enddo
         enddo

      else if (opcode .eq. sum_op) then

         do e = e1,e2
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d,e) = x1(a,b,c,d,e) + x2(a,b,c,d,e)
         enddo
         enddo
         enddo
         enddo
         enddo

      else
         print *,'Error: Invalid opcode in sum_static_blocks6: ',
     *      opcode
         call abort_job()
      endif
      return
      end

c
c

      subroutine sum_static_blocks3(y, a1,a2,b1,b2,c1,c2,
     *                              na1,na2,nb1,nb2,nc1,nc2,
     *                              x1,ne1,ne2,nf1,nf2,ng1,ng2,
     *                              x2,ni1,ni2,nj1,nj2,nk1,nk2,
     *                              opcode)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2
      integer na1,na2,nb1,nb2,nc1,nc2
      integer ne1,ne2,nf1,nf2,ng1,ng2
      integer ni1,ni2,nj1,nj2,nk1,nk2
      double precision y(na1:na2,nb1:nb2,nc1:nc2)
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2) 
      integer opcode, a,b,c,d

      if (opcode .eq. subtract_op) then
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c) = x1(a,b,c) - x2(a,b,c)
         enddo
         enddo
         enddo
      else if (opcode .eq. sum_op) then
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c) = x1(a,b,c) + x2(a,b,c)
         enddo
         enddo
         enddo
      else
         print *,'Error: Invalid opcode in sum_static_blocks3: ',
     *      opcode
         call abort_job()
      endif

      return
      end

      subroutine sum_static_blocks2(y, a1,a2,b1,b2,
     *                              na1,na2,nb1,nb2,
     *                              x1,ne1,ne2,nf1,nf2,
     *                              x2,ni1,ni2,nj1,nj2,
     *                              opcode)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2
      integer na1,na2,nb1,nb2
      integer ne1,ne2,nf1,nf2
      integer ni1,ni2,nj1,nj2
      double precision y(na1:na2,nb1:nb2)
      double precision x1(ne1:ne2,nf1:nf2)
      double precision x2(ni1:ni2,nj1:nj2)
      integer opcode, a,b

      if (opcode .eq. subtract_op) then
         do b = b1,b2
         do a = a1,a2
            y(a,b) = x1(a,b) - x2(a,b)
         enddo
         enddo
      else if (opcode .eq. sum_op) then
         do b = b1,b2
         do a = a1,a2
            y(a,b) = x1(a,b) + x2(a,b)
         enddo
         enddo
      else
         print *,'Error: Invalid opcode in sum_static_blocks2: ',
     *      opcode
         call abort_job()
      endif

      return
      end

      subroutine sum_static_blocks1(y, a1,a2, na1, na2, x1, x2,  opcode)
      implicit none
      include 'interpreter.h'

      integer a1,a2
      integer na1,na2
      double precision y(na1:na2)
      double precision x1(na1:na2)
      double precision x2(na1:na2)
      integer opcode, a

      if (opcode .eq. subtract_op) then
         do a = a1,a2
            y(a) = x1(a) - x2(a)
         enddo
      else if (opcode .eq. sum_op) then
         do a = a1,a2
            y(a) = x1(a) + x2(a)
         enddo
      else
         print *,'Error: Invalid opcode in sum_static_blocks2: ',
     *      opcode
         call abort_job()
      endif

      return
      end

      subroutine add_sub_blocks(y, x1, x2, n, opcode)
      implicit none
      include 'interpreter.h'

      integer n, opcode
      double precision y(n), x1(n), x2(n)

      integer i

      if (opcode .eq. sum_op) then
         do i = 1, n
            y(i) = x1(i) + x2(i)
         enddo    
      else if (opcode .eq. subtract_op) then
         do i = 1, n
            y(i) = x1(i) - x2(i)
         enddo    
      else
         print *,'Error in sum_blocks: Invalid opcode ',opcode
         call abort_job()
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine convert_chars(string, char_to_replace, replacement)
c---------------------------------------------------------------------------
c   Converts all occurrences of a character in a string to a 
c   replacement char.
c---------------------------------------------------------------------------
      implicit none
      character*(*) string
      character char_to_replace, replacement

      integer i, n
      integer str_trimlen

      n = str_trimlen(string)
      do i = 1, n
         if (string(i:i) .eq. char_to_replace) 
     *        string(i:i) = replacement
      enddo

      return
      end

C ROUTINE TO CONSTRUCT POINTER LIST FOR FINITE DIFFERENCE CALCULATIONS.
C  IPTR(I)=J MEANS THAT THE SYMMETRY OPERATION MAPS ATOM I INTO ATOM J.

      SUBROUTINE STPTR(N,NORD1,NORD2,IPTR)
      IMPLICIT INTEGER (A-Z)
      DIMENSION NORD1(N),NORD2(N),IPTR(N)
      DO I=1,N
         J=NORD1(I)
         K=NORD2(I)
         IPTR(J)=K
      END DO
      RETURN
      END

      SUBROUTINE SUMRNG(T2AIBJ,T2AJBI,ISCR,NSZ1,NSZ2,ISCRSZ)
C
C FORMS THE AB T2 RING INCREMENT IN THE ORDER AI-bj.
C
C DURING THE CALCULATION, LIST 42 HOLDS ONE CONTRIBUTION TO 
C  THE INCREMENT WHICH IS ORDERED AI-bj, WHILE LIST 43 HOLDS
C  ANOTHER CONTRIBUTION WHICH IS ORDERED Aj-bI.  THIS ROUTINE
C  RESORTS THE LATTER AND OVERWRITES LIST 42 WITH THE SUM OF 
C  THE TWO LISTS.
C
C    INPUT:  
C
C         NSZ1   - THE TOTAL SIZE OF AN AI-bj SYMMETRY PACKED LIST.
C         NSZ2   - THE TOTAL SIZE OF AN Aj-bI SYMMETRY PACKED LIST.
C         T2AIBJ - THIS ARRAY HOLDS THE LIST 43 INCREMENT AFTER
C                  IT HAS BEEN REORDERED TO AI-bj.  
C                  (SIZE: NSZ1).
C         T2AJBI - THIS ARRAY IS USED TWICE, FOR TWO DIFFERENT PURPOSES.
C                  FIRST, IT HOLDS THE Aj-bI INCREMENTS FROM LIST 43 
C                  AND IS LATER USED TO HOLD THE AI-bj INCREMENTS FROM
C                  LIST 42.  CONSEQUENTLY, THE SPACE ALLOCATED TO THIS
C                  ARRAY IN THE CALLING ROUTINE MUST BE MAX(NSZ1,NSZ2).
C         ISCR   - SCRATCH ROUTINE USED TO HOLD SYMMETRY VECTORS IN
C                  SSTRNG.  THE SIZE ALLOCATED MUST BE 
C                  (NVRTA+NVRTB)*(NOCCA+NOCCB).
C         ISCRSZ - (NVRTA+NVRTB)*(NOCCA+NOCCB).
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION T2AIBJ(NSZ1),T2AJBI(NSZ2),ONE
      DIMENSION ISCR(ISCRSZ)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),D(18)
      DATA ONE /1.0/
      CALL GETALL(T2AJBI,NSZ2,1,43)
      CALL SSTRNG(T2AJBI,T2AIBJ,NSZ2,NSZ1,ISCR,'ABBA')
      CALL GETALL(T2AJBI,NSZ1,1,42)
      CALL SAXPY(NSZ1,ONE,T2AJBI,1,T2AIBJ,1)
      CALL VMINUS(T2AIBJ,NSZ1)
      CALL PUTALL(T2AIBJ,NSZ1,1,42)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      subroutine det_segsizes(auto_seg_switch, nproc)
      implicit none
      integer auto_seg_switch, nproc
      integer oa_segsize, ob_segsize, va_segsize, vb_segsize

#include "int_gen_parms.h"

      integer iatom, nelec, naocc, nbocc, iShell, ierr

#ifdef ACES64
      integer*8 arg_1, arg_2, arg_3, iFlags(100), ivCharge(100)
#else
      integer   arg_1, arg_2, arg_3, iFlags(100), ivCharge(100)
#endif

      integer nCarts, nSphrs, l
      nCarts(l) = (l+1)*(l+2)/2
      nSphrs(l) = 2*l+1

c   o count the number of AOs per shell
      if (iSpherical.ne.0) then
         do iShell = 1, nShells
            nFpS(iShell) = nSphrs(ivAngMom(iShell))*nCFpS(iShell)
         end do
      else
         do iShell = 1, nShells
            nFpS(iShell) = nCarts(ivAngMom(iShell))*nCFpS(iShell)
         end do
      end if

      naocc = nalpha_occupied 
      nbocc = nbeta_occupied 

      if (auto_seg_switch .eq. 1) then
         call det_segsizes_kern(naocc,nbocc,sip_mx_occ_segsize,
     &                       nalpha_virtual, nbeta_virtual,
     &                       sip_mx_virt_segsize,
     &                       nFpS,nShells,sip_mx_ao_segsize
     &                       )
      else if (auto_seg_switch .eq. 2) then
         call find_seg(naocc, nalpha_virtual, naocc+nalpha_virtual, 
     *                 nproc, oa_segsize, va_segsize,
     *                 sip_mx_ao_segsize)
         call find_seg(nbocc, nbeta_virtual, naocc+nalpha_virtual, 
     *                 nproc, ob_segsize, vb_segsize,
     *                 sip_mx_ao_segsize)
         sip_mx_occ_segsize = max(oa_segsize, ob_segsize)
         sip_mx_virt_segsize = max(va_segsize, vb_segsize)
      else 
         print *,'Error: Invalid value for auto_seg_switch ',
     *      'in det_segsizes: ',auto_seg_switch
         call abort_job()
      endif

      return
      end

c ----------------------------------------------------------------------
c ----------------------------------------------------------------------

      subroutine det_segsizes_kern(nocca,noccb,seg_occ,
     &                             nvrta,nvrtb,seg_vrt,
     &                             nFpS,nShells,seg_ao
     &                             )
      implicit none

c ARGUMENTS
      integer nocca, noccb, nvrta, nvrtb, nShells
      integer nFpS(nShells), seg_occ, seg_vrt, seg_ao

c PARAMETERS
      integer mn_seg, mx_seg
      parameter (mn_seg=4)  ! 2kB block
c      parameter (mx_seg=16) ! 0.5MB block
c      parameter (mx_seg=19) ! 1MB block
c      parameter (mx_seg=22) ! 2MB block
c      parameter (mx_seg=26) ! 4MB block
      parameter (mx_seg=32) ! 8MB block
c      parameter (mx_seg=35) ! 12MB block
c      parameter (mx_seg=38) ! 16MB block
c      parameter (mx_seg=40) ! 20MB block
c      parameter (mx_seg=42) ! 24MB block
c      parameter (mx_seg=43) ! 28MB block
c      parameter (mx_seg=45) ! 32MB block
c      parameter (mx_seg=50) ! 48MB block
c      parameter (mx_seg=53) ! 64MB block

c INTERNAL VARIABLES
      double precision d1, d2, d3, d4, dCost
      integer mx_occ, mx_vrt, mx_shl, nBasis
      integer iFacts(100), nFacts, iScan
      integer iNeed, iHave, iDiff
      integer i, j, k, nSegs, nOccSegs, nVrtSegs, nAOSegs
      integer iSpin1, iSpin2, pop(2,3)
      character*5 szSpin(2)
      data szSpin/'alpha','beta '/
      character*2 czu(6)
      data czu/'B ','kB','MB','GB','TB','PB'/

      print *, '******************** SEGMENT SIZE ********************'

c ----------------------------------------------------------------------

      mx_occ = max(nocca,noccb)
      mx_vrt = max(nvrta,nvrtb)
      mx_shl = nFpS(1)
      nBasis = nFpS(1)
      do i = 2, nShells
         mx_shl = max(mx_shl,nFpS(i))
         nBasis = nBasis + nFpS(i)
      end do
      print *, 'constraints: ',mx_occ,' occ; ',
     &                         mx_vrt,' vrt; ',
     &                    '<=',mx_shl,' aos/shl (',nBasis,' AOs)'
      if (mx_occ.eq.0.or.mx_vrt.eq.0.or.nBasis.eq.0) then
         print *, '@DET_SEGSIZES: ERROR: 0 dimension encountered'
         call abort_job()
      end if

      pop(1,1) = nocca
      pop(2,1) = noccb
      pop(1,2) = nvrta
      pop(2,2) = nvrtb
      pop(1,3) = nBasis
      pop(2,3) = nBasis

c ----------------------------------------------------------------------

c   o start at mx_vrt and keep going up until a factor is found
      dCost = 1.d100
      iScan = max(mx_vrt,mx_shl)
      if (seg_vrt.eq.0.and.seg_ao.ne.0) seg_vrt=seg_ao
      do while (seg_vrt.eq.0)
         call fact_dim(iScan,iFacts,nFacts)
         print *, 'vrt spectrum: ', !'(pad=',iScan-mx_vrt,')',
     &            (iFacts(i),i=1,nFacts)
         do i = nFacts, 1, -1 ! prefer larger segments to smaller ones
            if (mx_shl.le.iFacts(i).and.iFacts(i).le.mx_seg) then
c            o vrt waste
               nSegs = (mx_vrt+iFacts(i)-1)/iFacts(i)
               iHave = nSegs*iFacts(i)
               d3 = 1.d0*iHave
               d3 = 8.d0*d3**4
               d4 = 1.d0*mx_vrt
               d4 = 8.d0*d4**4
               d1 = d3-d4
               j = 1
               do while (d1.gt.1000.d0)
                  j = j+1
                  d1 = d1/1024.d0
               end do
c            o AO waste
               call binpack_cost(nFpS,nShells,iFacts(i),nAOSegs,d2)
               if (d2.lt.0.99*dCost) then
                  seg_vrt = iFacts(i)
                  dCost = d2
               end if
               k = 1
               do while (d2.gt.1000.d0)
                  k = k+1
                  d2 = d2/1024.d0
               end do
               print '(4x,i2,a,f5.1,x,a,a,f4.1,a,f5.1,x,a,a,i2,a)',
     &                  iFacts(i),': ',d1,czu(j),' wasted (',
     &                  100.d0*(d3-d4)/d3,'%), AO cost = ',d2,czu(k),
     &                  ' (',nAOSegs,' segs)'
            end if
         end do
         iScan = iScan + 1
      end do
      nVrtSegs = (mx_vrt+seg_vrt-1)/seg_vrt

      if (seg_ao.eq.0) seg_ao=seg_vrt
      call binpack_cost(nFpS,nShells,seg_ao,nAOSegs,dCost)

      iNeed = (mx_occ+nVrtSegs-1)/nVrtSegs
      iDiff = mx_occ+1
      iScan = mx_occ
      if (seg_occ.eq.0.and.mx_occ.le.mn_seg) seg_occ = mx_occ
      do while (seg_occ.eq.0.and.iScan.le.mx_occ+3)
         call fact_dim(iScan,iFacts,nFacts)
c         print *, 'occ spectrum: ',(iFacts(i),i=1,nFacts)
         print *, 'occ spectrum: ', !'(pad=',iScan-mx_occ,')',
     &            (iFacts(i),i=1,nFacts)
         do i = 1, nFacts
            if (mn_seg.le.iFacts(i).and.iFacts(i).le.mx_seg) then
               j = abs(iFacts(i)-iNeed)
               if (j.lt.iDiff) then
                  seg_occ = iFacts(i)
                  iDiff = j
               end if
            end if
         end do
         iScan = iScan + 1
      end do
      nOccSegs = (mx_occ+seg_occ-1)/seg_occ

      if (seg_occ.lt.1.or.seg_vrt.lt.1.or.seg_ao.lt.1) then
         print *, 'Error determining segment sizes: (O,V,N) ',
     &            seg_occ, seg_vrt, seg_ao
         call abort_job()
      end if

      print *, 'Summary (leng,numb): (',
     &         seg_occ,',',nOccSegs,') occ, (',
     &         seg_vrt,',',nVrtSegs,') vrt, (',
     &         seg_ao, ',',nAOSegs,') ao'
      print *, '******************************************************'

      return
      end

c ----------------------------------------------------------------------
c ----------------------------------------------------------------------

      subroutine fact_dim(iMult, iList, nFact)
      implicit none

      integer iMult, i, j, k, nFact, iFact1, iFact2, iList(*)
      logical sqr

      i = sqrt(1.*(iMult+0.1))
      sqr = (i*i.eq.iMult)
      nFact = 0
      do iFact1 = i, 1, -1
         iFact2 = iMult/iFact1
         if (iFact1*iFact2.eq.iMult) then
            iList(nFact+1) = iFact1
            iList(nFact+2) = iFact2
            nFact = nFact + 2
            if (iFact1.eq.iFact2) nFact = nFact - 1
         end if
      end do
      k = 3
      if (sqr) k = 2
      do while (k.lt.nFact)
         iFact1 = iList(k)
         do j = k-1, 1, -1
            iList(j+1) = iList(j)
         end do
         iList(1) = iFact1
         k = k + 2
      end do

      return
      end

c ----------------------------------------------------------------------
c ----------------------------------------------------------------------

c This program implements a worst fit bin packing algorithm.

      subroutine binpack_cost(mass,nShells,iSegSize,nSegs,dCost)
      implicit none

      double precision dCost
      integer nShells, mass(*), iSegSize, nSegs

      integer TotMass, lrg, sml

      integer nGrps, pGrp0, SmlGrp

      integer m(2000), GrpMass(2000)
      integer FinGrps

      double precision dTmp, d1, d2
      logical bValid
      logical bAccept

      integer i, j

c ----------------------------------------------------------------------

      if (nShells.lt.1.or.2000.lt.nShells) then
         print *, 'Error in binpack_cost: nshells = ',nshells
         call abort_job()
      end if

      TotMass = 0
      lrg = 0
      sml = 2**30
      do i = 1, nShells
         TotMass = TotMass + mass(i)
         lrg = max(lrg,mass(i))
         sml = min(sml,mass(i))
         m(i) = mass(i)
      end do

      if (iSegSize .lt. lrg) iSegSize = lrg + 1 

      if (sml.lt.1) then
         print *,'Error in binpack_cost: Shells must have a mass > 0,'
         print *,'and the group limit (',iSegSize,
     *           ') must be >= the largest shell size (',lrg,').'
         print *, ' VFL WHAT??' 
         call abort_job()
      end if

c     if (sml.lt.1.or.iSegSize.lt.lrg) then
c        print *,'Error in binpack_cost: Shells must have a mass > 0,'
c        print *,'and the group limit (',iSegSize,
c    *           ') must be >= the largest shell size (',lrg,').'
c        call abort_job()
c     end if

c   o sort the masses in descending order
      call isort(m,0,nShells,-1)

      nGrps = (TotMass+iSegSize-1)/iSegSize
      FinGrps = 0
      do while (FinGrps.eq.0.and.nGrps.le.nShells)

c      o fill in the largest shells
c        (pGrp0 points to the first group to scan from)
         pGrp0 = 1
         do i = 1, nGrps
            GrpMass(i) = m(i)
            if (m(i).gt.iSegSize-sml) pGrp0 = pGrp0 + 1
         end do
         bValid=(pGrp0.le.nGrps.or.nGrps.eq.nShells)

c      o assign the remaining shells
         do i = nGrps+1, nShells
c         o find the smallest group
            SmlGrp = pGrp0
            do j = pGrp0+1, nGrps
               if (GrpMass(j).lt.GrpMass(SmlGrp)) SmlGrp = j
            end do
            GrpMass(SmlGrp) = GrpMass(SmlGrp) + m(i)
            if (GrpMass(SmlGrp).gt.iSegSize) bValid = .false.
         end do

         if (bValid) FinGrps = nGrps
         nGrps = nGrps + 1
      end do

      nSegs = FinGrps

      dCost = 0.d0
      if (TotMass.ne.FinGrps*iSegSize) then
         d1 = 1.d0*TotMass
         d2 = 1.d0*FinGrps*iSegSize
         d1 = 8.d0*d1**4
         d2 = 8.d0*d2**4
         dCost = (d2-d1) !/1024/1024/1024
      end if

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE GSCHMIDT(VEC,VORTH,NSIZE,NDIM,TMP,RESID,TOL)
C
C THIS PROJECTS OUT ALL PARTS OF AN INPUT VECTOR (VEC)
C WHICH LIE IN THE SPACE SPANNED BY THE ORTHOGONAL BASIS
C VORTH.
C
C   |v'> = |v> - SUM <i|v> |i>
C                 i
C
C WHERE THE |i> ARE NORMALIZED BASIS VECTORS FOR THE SPACE VORTH
C
C INPUT:
C       VEC : THE VECTOR WHICH IS TO BE ORTHOGONALIZED TO
C             THE EXISTING BASIS.  *IT IS ASSUMED THAT VEC
C             IS NORMALIZED ON INPUT)
C     VORTH : THE BASIS VECTORS FOR THE EXISTING ORTHOGONAL
C             BASIS
C     NSIZE : THE LENGTH OF THE BASIS VECTORS
C      NDIM : THE DIMENSION OF THE ORTHOGONAL SPACE
C       TMP : A SCRATCH VECTOR OF LENGTH NSIZE
C     RESID : THE NORM OF VEC, AFTER ORTHONALIZATION AND
C             BEFORE NORMALIZATION
C       TOL : TOLERANCE FOR RENORMALIZATION
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(NSIZE),VORTH(NSIZE,NDIM),TMP(NSIZE)
C
      DATA ONE /1.0/
C
      IF(NDIM.EQ.0)THEN
       RESID=XDNRM2(NSIZE,VEC,1)
       RETURN
      ENDIF
C
      CALL XDCOPY(NSIZE,VEC,1,TMP,1)
      DO 10 I=1,NDIM
       FACT=XDDOT(NSIZE,VORTH(1,I),1,VEC,1)
       CALL XDAXPY(NSIZE,-FACT,VORTH(1,I),1,TMP,1)
10    CONTINUE
      CALL XDCOPY(NSIZE,TMP,1,VEC,1)
C
C RENORMALIZE THE RESIDUAL
C
      RESID=XDNRM2(NSIZE,VEC,1)
      IF(RESID.GT.TOL)THEN
       X=ONE/RESID
       CALL XDSCAL(NSIZE,X,VEC,1)
      ENDIF 
      RETURN
      END

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      SUBROUTINE AOSize(LUN, NewVM, NSO, NrAO)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: aosize.f,v 1.5 2008/11/19 15:48:33 perera Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     aosize -- determine size of the AO basis for VMol
C
C SYNOPSIS
      Integer LUN, NSO, NrAO
      Logical NewVM
C
C ARGUMENTS
C     LUN     Unit number of integral file (input)
C     NSO     Nr fo symmetry-adapted basis functions (input)
C     NewVM   New VMol or old VMol (input)
C     NrAO    Largest AO index referenced in AO->SO xform. (output)
C
C ROUTINES REQUIRED
C     IAMAX   Largest absolute element of a vector
C     Locate  Find a Molecule-style record label 
C
      External IAMAX, Locate
      Integer IAMAX
C
C DESCRIPTION
C     Determines the size of the AO basis by finding the largest function
C     index referenced by the AO->SO transformation.  Anything higher
C     than that can't possibly be relevant... we hope!
C
C BUGS
C     Limited to 80 AOs contributing to each SO.
C     Molecule record label is fixed as SYMTRANS.
C     Variable IIntFP in common block MACHSP must be 1 or 2.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Include 'mach.inc'
C $Id: aosize.f,v 1.5 2008/11/19 15:48:33 perera Exp $
      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C LOCAL VARIABLES
C     i       General counter
C     ii      General counter
C     j       General counter
C     JTran   Number of AOs in SO (valid elements in ITran/CTran)
C     ITran   AO components of an SO
C     Junk    To skip over center and ang. mom. labels neatly.
C     SOAO    Scratch array to read coefficients into
C             
      Character*4 Junk
      Integer I, ii, j, JTran, ITran(80)
      Double Precision SOAO
C
C     Find the symmetry transformation section
      Call Locate( LUN, 'SYMTRANS')
C
C     Record format is slightly different for New_Mol & VMol
C        New_Mol starts with a record holding the number of basis fns
C           and is otherwise like VMol.
C        VMol writes each orbital as a record
C
C     NOTE:  The number of 4 char. pieces making up the two labels
C     should be 4 if IIntFP=1 and 2 if IIntFP=2.
C
C
      NrAO = 0
      If (.NOT. NewVM) then
         Do 100 I = 1, NSO
            Read (LUN) J, (Junk, ii = 1, 2*(3-IIntFP)),  JTran,
     $         (ITran(ii), SOAO, ii = 1, JTran)
               NrAO = Max( NrAO, IAMax(JTran, ITran, 1) )
 100     Continue
      Else
         Read (LUN)
         Do 200 I = 1, NSO
            Read (LUN) JTran, (ITran(ii), SOAO,
     $         ii = 1, JTran)
               NrAO = Max( NrAO, IAMax(JTran, ITran, 1) )
 200     Continue
      EndIf
C
      Return
      End

      subroutine molden_rdvib(natoms,iatchrg,freq,freqco,dnormmd,nvib,
     &                        iunit)
c-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      parameter (nelement=103)
      character *80 wrk
      character*2 celemol(nelement)
      logical yesno
      integer iatchrg(natoms)
      double precision freq(nvib),freqco(3,natoms),
     &  dnormmd(nvib,3,natoms)

#include "machsp.com"
#include "flags.com"
      data (celemol(i),i=1,nelement)
     & /' H','He',
     & 'Li','Be',' B',' C',' N',' O',' F','Ne',
     & 'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     & ' K','Ca',
     & 'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     & 'Ga','Ge','As','Se','Br','Kr',
     & 'Rb','Sr',
     & ' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     & 'In','Sn','Sb','Te',' I','Xe',
     & 'Cs','Ba','La',
     & 'Ce','Pr','Nd','Pm','Sm','Eu','Gd',
     & 'Tb','Dy','Ho','Er','Tm','Yb','Lu',
     & 'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     & 'Tl','Pb','Bi','Po','At','Rn',
     & 'Fr','Ra','Ac',
     & 'Th','Pa',' U','Np','Pu','Am','Cm',
     & 'Bk','Cf','Es','Fm','Md','No','Lr'/
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INQUIRE(FILE='NORMCO',EXIST=YESNO)
      IF(YESNO)THEN
        OPEN(UNIT=4,FILE='NORMCO',FORM='FORMATTED',STATUS='OLD')
        rewind(4)
      else
        write(6,10)
10      format(T3,'@RDVIB-F, NORMCO file not present.')
        call errex
      ENDIF
      read(4,*)wrk
      do 20 iatom=1,natoms
        read(4,*)(freqco(i,iatom),i=1,3)
20    continue

      do 30 ivib=1,nvib
        read(4,*)wrk
        read(4,*)freq(ivib)
        read(4,*)wrk
        do 40 iatom=1,natoms
          read(4,*)(dnormmd(ivib,i,iatom),i=1,3)
40      continue
30    continue
      close(unit=4,status='KEEP')
c\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
      do 50 ivib=1,nvib
        write(iunit,60)' ',freq(ivib)
60      format(A,f9.4)
50    continue
      write(iunit,70)'[FR-COORD]'
70    format(A)
      do 80 iatom=1,natoms
        write(iunit,90)' ',celemol(iatchrg(iatom)),freqco(1,iatom),
     &    freqco(2,iatom),freqco(3,iatom)
90      format(A,A2,3x,f9.6,3x,f9.6,3x,f9.6)
80    continue
      write(iunit,100)'[FR-NORM-COORD]'
100   format(A)
      do 110 ivib=1,nvib
        write(iunit,115)'vibration    ',ivib
115     format(A,I2)
        do 120 iatom=1,natoms
          write(iunit,130)'   ',dnormmd(ivib,1,iatom),
     &      dnormmd(ivib,2,iatom),dnormmd(ivib,3,iatom)
130       format(A,f9.6,4x,f9.6,4x,f9.6)
120     continue 
110   continue
c/////////////////////////////////////////////////////////////////////////////
      return
      end

#include "flags.h"
      subroutine vib_rot_coupl
C
      implicit double precision (a-h,o-z)
C
#include "icore.com"
#include "machsp.com"
#include "flags.com"
#include "flags2.com"
#include "istart.com"
C-----------------------------------------------------------------------
      if (iflags(h_IFLAGS_ref).eq.0) iuhf = 0
      maxcor=icrsiz
C
      Call Getrec(20,'JOBARC','NREALATM',1,Nreals)
      Call Getrec(20,'JOBARC','ZMATATMS',1,Natoms)
      Call Getrec(20, 'JOBARC', 'LINEAR', 1, Iamlinear)
C
      If (Iamlinear .EQ. 1) Then
         Nxm6 = 3*Nreals - 5
      Else
         Nxm6 = 3*Nreals - 6
      Endif
      Nx  = 3*Nreals
C
      iatmMass = i0
      icoord   = iatmMass + 3*Natoms*iintfp 
      iBmat    = icoord   + 3*NAtoms*iintfp
      iGmat    = iBmat    + Nx*NXm6*iintfp
      ihess    = iGmat    + Nxm6*Nxm6*iintfp
      ieig_vec = ihess    + Nx*Nx*iintfp
      ivib_vec = ieig_vec + Nx*Nx*iintfp
      ibtmp    = ivib_vec + Nx*Nxm6*iintfp
      itmp1    = ibtmp    + Nx*Nxm6*iintfp 
      itmp2    = itmp1    + Nx*Nx*iintfp 
      immatx   = Itmp2    + Nx*Nx*iintfp
      immaty   = Immatx   + Nx*Nx*iintfp
      immatz   = Immaty   + Nx*Nx*iintfp
      imap     = Immatz   + Nx*Nx*iintfp
      inext    = Imap     + Natoms
C
      if(inext-i0.gt.maxcor)call insmem('vib_rot_coupl',inext-i0,
     &                      maxcor)

      call coriolis_cc(natoms,nreals,Nx,Nxm6,icore(iatmMass),
     &                 icore(icoord),icore(ibmat),icore(igmat),
     &                 icore(ihess),icore(ieig_vec),icore(ivib_vec),
     &                 icore(ibtmp),icore(itmp1),icore(itmp2),
     &                 icore(immatx),icore(immaty),icore(immatz),
     &                 icore(imap),iuhf)
c ----------------------------------------------------------------------

      return
      end

      subroutine vib_rot_coupl
C
      implicit double precision (a-h,o-z)
C


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end







c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c flags2.com : begin
      integer         iflags2(500)
      common /flags2/ iflags2
c flags2.com : end
c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end
C-----------------------------------------------------------------------
      if (iflags(11).eq.0) iuhf = 0
      maxcor=icrsiz
C
      Call Getrec(20,'JOBARC','NREALATM',1,Nreals)
      Call Getrec(20,'JOBARC','ZMATATMS',1,Natoms)
      Call Getrec(20, 'JOBARC', 'LINEAR', 1, Iamlinear)
C
      If (Iamlinear .EQ. 1) Then
         Nxm6 = 3*Nreals - 5
      Else
         Nxm6 = 3*Nreals - 6
      Endif
      Nx  = 3*Nreals
C
      iatmMass = i0
      icoord   = iatmMass + 3*Natoms*iintfp 
      iBmat    = icoord   + 3*NAtoms*iintfp
      iGmat    = iBmat    + Nx*NXm6*iintfp
      ihess    = iGmat    + Nxm6*Nxm6*iintfp
      ieig_vec = ihess    + Nx*Nx*iintfp
      ivib_vec = ieig_vec + Nx*Nx*iintfp
      ibtmp    = ivib_vec + Nx*Nxm6*iintfp
      itmp1    = ibtmp    + Nx*Nxm6*iintfp 
      itmp2    = itmp1    + Nx*Nx*iintfp 
      immatx   = Itmp2    + Nx*Nx*iintfp
      immaty   = Immatx   + Nx*Nx*iintfp
      immatz   = Immaty   + Nx*Nx*iintfp
      imap     = Immatz   + Nx*Nx*iintfp
      inext    = Imap     + Natoms
C
      if(inext-i0.gt.maxcor)call insmem('vib_rot_coupl',inext-i0,
     &                      maxcor)

      call coriolis_cc(natoms,nreals,Nx,Nxm6,icore(iatmMass),
     &                 icore(icoord),icore(ibmat),icore(igmat),
     &                 icore(ihess),icore(ieig_vec),icore(ivib_vec),
     &                 icore(ibtmp),icore(itmp1),icore(itmp2),
     &                 icore(immatx),icore(immaty),icore(immatz),
     &                 icore(imap),iuhf)
c ----------------------------------------------------------------------

      return
      end

      subroutine delspc(instr,outstr)
      implicit none
      character*(*) instr,outstr
      integer j,islen,oslen,strlen,i
      character*1 achar,spc,tab
      spc=achar(32)
      tab=achar(9)
      j=1
      islen=strlen(instr)
      oslen=strlen(outstr)
      do i=1,islen
         if (instr(i:i).ne.spc .and. instr(i:i).ne.tab) then
            outstr(j:j)=instr(i:i)
            j=j+1
         end if
      end do
      if (j.gt.oslen+1) then
         print *, '@DELSPC: wrote out of bounds'
         call c_exit(1)
      end if
cYAU: this loop used to run to oslen+1, which makes no sense
      do i=j,oslen
         outstr(i:i)=spc
      end do
      return
      end

      subroutine fixrhs(w,d,den,e,ntsiz,pop,vrt,nocc,nvrt,ispin,iuhf)
C
cjp used to prepare from T1 RHS the <j,b|HexpT|0> term for 4.28
cjp NOTE: this routine can be called only with ispin=1,2
cjp
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LINCC,CICALC
      INTEGER DIRPRD,POP,VRT
cjp
      integer itrue,iatrue
      DIMENSION W(NTSIZ),E(NOCC+NVRT),
     &          D(NTSIZ),DEN(NTSIZ),POP(8),VRT(8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /LINEAR/ LINCC,CICALC
      COMMON /CORENG/ ELAST
C
      EQUIVALENCE(IFLAGS(2),METHOD)
C
cjp
#include "bwcc.com"
C
C     GET ORBITAL ENERGIES FROM DISK
C
      if(ispin.eq.1.or.iuhf.eq.0)then
       CALL GETREC(20,'JOBARC','SCFEVALA',IINTFP*(NOCC + NVRT),
     &             E)
      ELSE
       CALL GETREC(20,'JOBARC','SCFEVALB',IINTFP*(NOCC + NVRT),
     &             E)
      ENDIF
cjp fix diagonal fock elements
      if(isbwcc) then
        do i=1,nocc+nvrt
          e(i)=e(i)+fockcd(i,iref,ispin)
        enddo
      endif
C
C     LOOP OVER IRREPS
C
      IND=0
      INDI=0
      INDA0=0
C
      DO 100 IRREP=1,NIRREP
C
      NOCCI=POP(IRREP)
      NVRTI=VRT(IRREP)
C
cjp
cjp HERE DO NOT identify the internal amplitudes
cjp the following is also completely wrong if symmetry is on
      DO  10 I=1,NOCCI
      INDI=INDI+1
      INDA=INDA0
      DO  10 IA=1,NVRTI
      INDA=INDA+1
      IND=IND+1
           itrue=invhnum(indi,iref,ispin)
           iatrue=invpnum(inda,iref,ispin)
           den(ind)=e(itrue)-e(iatrue)
cjp correction 2: put just LHS of BWCC T1, for internal one keep just the RHS as is
           if(correctiontype.eq.2.and.
     & .not.(isactive(itrue,ispin).and.isactive(iatrue,ispin))) then
           w(ind)=ecorrbw0*d(ind)
           endif
           if(bwgossip.and.correctiontype.eq.2)
     &   write(6,*)'fixrhs:c=2 : ind, ispin, iref,w(ind)'
     &              ,ind, ispin, iref,w(ind)
   10 CONTINUE
      INDA0=INDA0+NVRTI
100   CONTINUE
C
C    compute addition to the rhs of RSCC to get the <...> elements for 4.28
C
cjp use old, internal-zeroed, amplitudes
cjp this is the correct version
#ifndef BAD_ALTERNATIVE
c
       if(correctiontype.le.1) then
cjp
cjp correction type =1 ... build full <> term from current amplitudes and denominators
cjp at convergence scaled to RSCC, this gives zeros except internal excitations
cjp when it is Heff element
cjp
      DO  I=1,NTSIZ
      w(i)=w(i)-d(i)*den(i)
      enddo
c
      endif
cjp correctiontype.eq.2 has been done above already

#else
cjp OBSOLETE
cjp use new, not internal-zeroed, amplitudes
      DO  I=1,NTSIZ
      w(i)=w(i)-w(i)*den(i)/(den(i)+ecorrbw)
        enddo
#endif
C
      RETURN
      END

      subroutine fixrhs(w,d,den,e,ntsiz,pop,vrt,nocc,nvrt,ispin,iuhf)
C
cjp used to prepare from T1 RHS the <j,b|HexpT|0> term for 4.28
cjp NOTE: this routine can be called only with ispin=1,2
cjp
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LINCC,CICALC
      INTEGER DIRPRD,POP,VRT
cjp
      integer itrue,iatrue
      DIMENSION W(NTSIZ),E(NOCC+NVRT),
     &          D(NTSIZ),DEN(NTSIZ),POP(8),VRT(8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /LINEAR/ LINCC,CICALC
      COMMON /CORENG/ ELAST
C
      EQUIVALENCE(IFLAGS(2),METHOD)
C
cjp


cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)


C
C     GET ORBITAL ENERGIES FROM DISK
C
      if(ispin.eq.1.or.iuhf.eq.0)then
       CALL GETREC(20,'JOBARC','SCFEVALA',IINTFP*(NOCC + NVRT),
     &             E)
      ELSE
       CALL GETREC(20,'JOBARC','SCFEVALB',IINTFP*(NOCC + NVRT),
     &             E)
      ENDIF
cjp fix diagonal fock elements
      if(isbwcc) then
        do i=1,nocc+nvrt
          e(i)=e(i)+fockcd(i,iref,ispin)
        enddo
      endif
C
C     LOOP OVER IRREPS
C
      IND=0
      INDI=0
      INDA0=0
C
      DO 100 IRREP=1,NIRREP
C
      NOCCI=POP(IRREP)
      NVRTI=VRT(IRREP)
C
cjp
cjp HERE DO NOT identify the internal amplitudes
cjp the following is also completely wrong if symmetry is on
      DO  10 I=1,NOCCI
      INDI=INDI+1
      INDA=INDA0
      DO  10 IA=1,NVRTI
      INDA=INDA+1
      IND=IND+1
           itrue=invhnum(indi,iref,ispin)
           iatrue=invpnum(inda,iref,ispin)
           den(ind)=e(itrue)-e(iatrue)
cjp correction 2: put just LHS of BWCC T1, for internal one keep just the RHS as is
           if(correctiontype.eq.2.and.
     & .not.(isactive(itrue,ispin).and.isactive(iatrue,ispin))) then
           w(ind)=ecorrbw0*d(ind)
           endif
           if(bwgossip.and.correctiontype.eq.2)
     &   write(6,*)'fixrhs:c=2 : ind, ispin, iref,w(ind)'
     &              ,ind, ispin, iref,w(ind)
   10 CONTINUE
      INDA0=INDA0+NVRTI
100   CONTINUE
C
C    compute addition to the rhs of RSCC to get the <...> elements for 4.28
C
cjp use old, internal-zeroed, amplitudes
cjp this is the correct version
c
       if(correctiontype.le.1) then
cjp
cjp correction type =1 ... build full <> term from current amplitudes and denominators
cjp at convergence scaled to RSCC, this gives zeros except internal excitations
cjp when it is Heff element
cjp
      DO  I=1,NTSIZ
      w(i)=w(i)-d(i)*den(i)
      enddo
c
      endif
cjp correctiontype.eq.2 has been done above already

C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE NORMAL(X,N)
C
C NORMALIZES VECTOR X
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
      Q=0.D0
      DO 10 I=1,N
10    Q=Q+X(I)**2
      P=DSQRT(Q)
      IF(P.LT.1D-14)THEN
      WRITE(6,*)' null vector returned from NORMAL'
      RETURN
      ENDIF
      DO 11 I=1,N
11    X(I)=X(I)/P    
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__DGEMM_CT_EQ_ATXB_FLOAT
     +
     +                    ( DDROWA,DDCOLA,
     +                      DDROWB,DDCOLB,
     +                      DDROWC,DDCOLC,
     +                      ROW,SUM,COL,
     +                      A,B,
     +
     +                              C )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__DGEMM_CT_EQ_ATXB_FLOAT
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : Highly optimized matrix multiplication routine
C                performing the matrix multiplication:
C
C                                C (T) = A (T) * B
C
C                The result will be stored in transposed form into C.
C                Matrices A and B need not be distinct, but matrix C
C                must be distinct from A and B and all matrices must
C                be of floating point type.
C
C                Code derived from the 'dgemm' Level 3 Blas routine.
C
C                To tune this routine for maximum performance, pass
C                ROWB,SUMB and COLB in argument and test for several
C                sizes of these variables.
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    DDROWA,DDCOLA
         INTEGER    DDROWB,DDCOLB
         INTEGER    DDROWC,DDCOLC
         INTEGER    I,J,K
         INTEGER    I1,I2,J1,K1,II1,II2,JJ1,KK1
         INTEGER    IDEPTH,JDEPTH
         INTEGER    II,JJ,KK
         INTEGER    IIEND1,IIEND2,JJEND1,JJEND2,KKEND
         INTEGER    ILEN,JLEN
         INTEGER    ISPAN,JSPAN,KSPAN
         INTEGER    ROW,SUM,COL
         INTEGER    ROWB,SUMB,COLB

C Original value for the parameter (supposed to be for the IBM RS/6000)
C         PARAMETER  (ROWB=64,COLB=64,SUMB=64)
C Parameter for the 256kB cache on the IBM RS/6000 models 590 and 990
         PARAMETER  (ROWB=96,COLB=96,SUMB=96)
C Parameter for the 16kB cache on the Sparc
C         PARAMETER   (ROWB=24,COLB=24,SUMB=24)
C Parameter for the 4MB L2 cache on the SGI POWER CHALLANGE
C         PARAMETER  (ROWB=384,COLB=384,SUMB=384)
C Parameter for the 8kB cache on the DEC Alpha
C         PARAMETER  (ROWB=16,COLB=16,SUMB=16)
C Optimized Parameter for QTP crunch
C         PARAMETER   (ROWB=46,COLB=46,SUMB=46)

         DOUBLE PRECISION   E,F,G,H
         DOUBLE PRECISION   T11,T12,T21,T22
         DOUBLE PRECISION   ZERO

         DOUBLE PRECISION   A (1:DDROWA,DDCOLA)
         DOUBLE PRECISION   B (1:DDROWB,DDCOLB)
         DOUBLE PRECISION   C (1:DDROWC,DDCOLC)

         DOUBLE PRECISION   ASUB (1:SUMB,1:ROWB)

         PARAMETER   (ZERO = 0.D0)
C
C
C-----------------------------------------------------------------------
C
C
C             ...proceed.
C
C
         DO I = 1,ROW
         DO J = 1,COL
            C (J,I) = ZERO
         END DO
         END DO

         DO 1000 I = 1,ROW,ROWB
            I1 = I - 1
            I2 = I - 2
            IDEPTH = 2
            ISPAN = MIN0 (ROWB,ROW-I1)
            IIEND2 = I1 + ISPAN
            ILEN = IDEPTH * (ISPAN/IDEPTH)
            IIEND1 = I1 + ILEN

            DO 2000 K = 1,SUM,SUMB
               K1 = K - 1
               KSPAN = MIN0 (SUMB,SUM-K1)
               KKEND = K1 + KSPAN
               DO II = I,IIEND2
                  II1 = II - I1
                  DO KK = K,KKEND
                     ASUB (KK-K1,II1) = A (KK,II)
                  END DO
               END DO

               DO 3000 J = 1,COL,COLB
                  J1 = J - 1
                  JDEPTH = 2
                  JSPAN = MIN0 (COLB,COL-J1)
                  JJEND2 = J1 + JSPAN
                  JLEN = JDEPTH * (JSPAN/JDEPTH)
                  JJEND1 = J1 + JLEN

                  DO II = I,IIEND1,IDEPTH
                     II1 = II - I1
                     II2 = II - I2
                     DO JJ = J,JJEND1,JDEPTH
                        JJ1 = JJ + 1
                        T11 = ZERO
                        T21 = ZERO
                        T12 = ZERO
                        T22 = ZERO
                        DO KK = K,KKEND
                           KK1 = KK - K1
                           E = ASUB (KK1,II1)
                           F = ASUB (KK1,II2)
                           G = B (KK,JJ)
                           H = B (KK,JJ1)
                           T11 = T11 + E * G
                           T21 = T21 + F * G
                           T12 = T12 + E * H
                           T22 = T22 + F * H
                        END DO
                        C(JJ,II) = C(JJ,II) + T11
                        C(JJ,II+1) = C(JJ,II+1) + T21
                        C(JJ1,II) = C(JJ1,II) + T12
                        C(JJ1,II+1) = C(JJ1,II+1) + T22
                     END DO
                     IF (JLEN.LT.JSPAN) THEN
                         DO JJ = JJEND1+1,JJEND2
                            T11 = ZERO
                            T21 = ZERO
                            DO KK = K,KKEND
                               KK1 = KK - K1
                               G = B (KK,JJ)
                               T11 = T11 + ASUB (KK1,II1) * G
                               T21 = T21 + ASUB (KK1,II2) * G
                            END DO
                            C(JJ,II) = C(JJ,II) + T11
                            C(JJ,II+1) = C(JJ,II+1) + T21
                         END DO
                     END IF
                  END DO

                  IF (ILEN.LT.ISPAN) THEN
                      DO II = IIEND1+1,IIEND2
                         II1 = II - I1
                         DO JJ = J,JJEND1,JDEPTH
                            JJ1 = JJ + 1
                            T11 = ZERO
                            T12 = ZERO
                            DO KK = K,KKEND
                               E = ASUB (KK-K1,II1)
                               T11 = T11 + E * B (KK,JJ)
                               T12 = T12 + E * B (KK,JJ1)
                            END DO
                            C(JJ,II) = C(JJ,II) + T11
                            C(JJ1,II) = C(JJ1,II) + T12
                         END DO
                         IF (JLEN.LT.JSPAN) THEN
                             DO JJ = JJEND1+1,JJEND2
                                T11 = ZERO
                                DO KK = K,KKEND
                                   T11 = T11 + ASUB(KK-K1,II1)*B(KK,JJ)
                                END DO
                                C(JJ,II) = C(JJ,II) + T11
                             END DO
                         END IF
                      END DO
                  END IF

 3000          CONTINUE
 2000       CONTINUE
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It does create overlap table of new eom roots and roots from |
c             previous iteration                                |
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|

      subroutine eomovertable
     +                 (array_table,
     *                  narray_table, index_table,
     *                  nindex_table, segment_table, nsegment_table,
     *                  block_map_table, nblock_map_table,
     *                  scalar_table, nscalar_table,
     *                  address_table, op)

c--------------------------------------------------------------------------
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'epsilon.h'
      include 'daveom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index,iarray,daddr
      integer stack
      integer nsend
      integer array_type, evec_type
      integer comm
      integer sind, ind(mx_array_index)
      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(mx_array_index), findex(mx_array_index)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2,n1,n2
      integer*8 addr, get_index_from_base
      double precision x(1)


      double precision overmax_index

#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------|
c   Locate the data for the input matrix which is to be analyses.           |
c   First array: set of overlaps for current root                           |
c---------------------------------------------------------------------------|

      array      = op(c_result_array)

      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      daddr = address_table(array)
      iarray  = get_index_from_base(daddr, x, 2)


      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index
c---------------------------------------------------------------------------|
c               Selection of maximal root                                   |
c---------------------------------------------------------------------------|

        call max_overlap2( x(iarray), n1, n2 )

c---------------------------------------------------------------------------|
c---------------------------------------------------------------------------|



      return
      end
c===========================================================================|
c===========================================================================|
      subroutine max_overlap2(overlap,i1,i2)
      implicit none
      include 'parallel_info.h'
      include 'daveom.h'
      integer i1,i2,i,j,kk,overmax,izz,iyy
      double precision overlap(i1,i2),overmax_index,qq,qq1,
     & root_tmp(400)
c-----------------------------------------------------------|
c This subroutine does search of maximal overlap            |
c-----------------------------------------------------------|

            izz = nroots*iter+nroots  

            DO i=1,nroots              

            overmax = 1
            DO kk=1,izz
            qq = overlap(overmax,i)
            qq1 = overlap(kk,i)

c            IF(RL.eq.0) then                   
c            if(me.eq.0) write(6,*) dabs(qq1),'****',i,'****',kk
c            endif                 

                  IF( dabs(qq1) .gt. dabs(qq) ) then
                  overmax = kk
                  ENDIF

            ENDDO

                 IF(RL.eq.1) then
                 DavOverRmax(i) = overmax
                 if(me.eq.0) write(6,*) DavOverRmax(i),'***===***',i
                 ENDIF

                 IF(RL.eq.0) then
                 DavOverLmax(i) = overmax 
                 if(me.eq.0) write(6,*) DavOverLmax(i),'***$$$***',i 
                 ENDIF  

            ENDDO 

c--------Reordering of the eigenvalues according to maximal overlap----
              IF(RL.eq.1) then
            DO i=1,izz  
            root_tmp(i) = DavRoots(i)
            ENDDO


            DO i=1,izz 
            overmax = DavOverRmax(i)
            DavRoots(i) = root_tmp(overmax)
            ENDDO
              ENDIF 
c----------------------------------------------------------------------
                 
           


c            if(me.eq.0) write(6,*) overmax,'#####',overlap(overmax)

              

      return
      end 
C---------------------------------------------------------------------------|

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                    ( NBAS,
     +                      P,
     +                      XVEC,
     +                      XMAT,
     +
     +                            C1,S1,
     +                            C2,S2,
     +                            X1,X2 )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ROTATE_PAIR_DEGENERATE_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine rotates a pair of two-fold weight
C                degenerate atomic NBOs, such that their lobes match
C                and form rectangular angles between them:
C
C
C
C                                                  x
C                       x  *                       *
C                        x *    x                  x
C                         x* x                     *
C                    ******x******   ---->   x**x**x**x**x
C                        x *x                      *
C                     x    * x                     x
C                          *  x                    *
C                                                  x
C
C
C
C                We look for a rotation matrix R of the form:
C
C
C
C                                    -----------------
C                                   | C1  S1 |        |
C                                   |        |    0   |
C                                   |-S1  C1 |        |
C                          R  =      -----------------
C                                   |        | C2  S2 |
C                                   |   0    |        |
C                                   |        |-S2  C2 |
C                                    -----------------
C
C
C
C                which brings the original occupation matrix P
C                corresponding to the pair (w is the weight of the
C                two-fold weight degenerate atomic NBOs):
C
C
C
C                                        ------
C                                       | w  0 |
C                                       |      |
C                                       | 0  w |
C                              P  =      -------------
C                                       | p1 p2| w  0 |
C                                       |      |      |
C                                       | p3 p4| 0  w |
C                                        -------------
C
C
C                to the form, i.e:
C
C
C
C                                        ------
C                                       | w  0 |
C                                       |      |
C                                       | 0  w |
C                   R(T) * P * R  =      -------------
C                                       | a  0 | w  0 |
C                                       |      |      |
C                                       | 0  b | 0  w |
C                                        -------------
C
C
C                in which the offdiagonal block shows now two zeros.
C                Inserting the form of R into the last equation we
C                obtain the matrix equation:
C
C
C                    | a  0 |     |C2 -S2|   | p1 p2|   |C1  S1|
C                    |      |  =  |      | * |      | * |      |
C                    | 0  b |     |S2  C2|   | p3 p4|   |-S1 C1|
C
C
C                from which we obtain two equations in the two unknowns
C                t1 = S1/C1 and t2 = S2/C2:
C
C
C                        t2*p1 - t1*t2*p2 + p3 - t1*p4 = 0
C
C                        t1*p1 - t1*t2*p3 + p2 - t2*p4 = 0
C
C
C                leading to a quadratic equation for both t1 and t2
C                cases:
C
C                              t*t + R*t - 1 = 0
C
C                where:
C
C
C                              p2*p2 + p4*p4 - p1*p1 - p3*p3
C                 R for t1  =  -----------------------------
C                                      p1*p2 + p3*p4
C
C
C                              p3*p3 + p4*p4 - p1*p1 - p2*p2
C                 R for t2  =  -----------------------------
C                                      p1*p3 + p2*p4
C
C
C                Solutions are then given by:
C
C
C                               - R +- sqrt (R*R + 4)
C                          t =  ---------------------
C                                         2
C
C
C                and from the relations t = s/c and s*s + c*c = 1
C                we obtain for the cosines:
C
C
C                       c = sqrt ( 2 / (R*R + 4 -+ R*sqrt (R*R+4) ) )
C
C
C                and, after trying out the solutions, for the sines:
C
C
C                       s = +- sqrt (1 - c*c)
C
C
C                Note in particular the -+ and +- possibilities for
C                the cosines and sines, respectively. Hence a total
C                of 4 sign combinations are possible:
C
C                         For C1,S1   =>   -,+ and +,-
C                         For C2,S2   =>   -,+ and +,-
C
C                corresponding to the 4 different ways the two lobes
C                of the pair (a,b) of two-fold weight degenerate atomic
C                NBOs can be superimposed in space (leave lobes of a
C                fixed and rotate lobes of b by successive 90 degrees):
C
C
C
C
C                                     +(a)+(b)
C
C                                         *
C                                         *
C                           +(a)+(b) *********** -(a)-(b)
C                                         *
C                                         *
C
C                                     -(a)-(b)
C
C
C                 ..................................................
C
C
C                                     +(a)+(b)
C
C                                         *
C                                         *
C                           +(a)-(b) *********** -(a)+(b)
C                                         *
C                                         *
C
C                                     -(a)-(b)
C
C
C                 ..................................................
C
C
C                                     +(a)-(b)
C
C                                         *
C                                         *
C                           +(a)-(b) *********** -(a)+(b)
C                                         *
C                                         *
C
C                                     -(a)+(b)
C
C
C                 ..................................................
C
C
C                                     +(a)-(b)
C
C                                         *
C                                         *
C                           +(a)+(b) *********** -(a)-(b)
C                                         *
C                                         *
C
C                                     -(a)+(b)
C
C
C
C
C                These 4 different cases will lead to the 4 possible
C                (not in correspondence with the above sequence of
C                overlapping lobes pictures) offdiagonal blocks of the
C                occupation matrix P:
C
C
C                    | a  0 |   | b  0 |   | 0  b |   | 0  a |
C                    |      | , |      | , |      | , |      |
C                    | 0  b |   | 0  a |   | a  0 |   | b  0 |
C
C
C                For the sake of uniqueness, we will decide on the
C                lobe overlapping solution that leads to the following
C                offdiagonal block:
C
C
C                            | a  0 |
C                            |      |  and condition  |a| >= |b|
C                            | 0  b |
C
C
C                which has to be found by placing all possible four
C                solutions for C1,S1 and C2,S2 into the equation:
C
C
C                    | a  0 |     |C2 -S2|   | p1 p2|   |C1  S1|
C                    |      |  =  |      | * |      | * |      |
C                    | 0  b |     |S2  C2|   | p3 p4|   |-S1 C1|
C
C
C                and picking the one we are after.
C
C                Relations among the p1,p2,p3,p4 values indicate, if
C                there is the unique set of 4 possible rotations or
C                if there is in fact an infinite possibility of
C                rotations. We have the following two cases:
C
C                  Case i) p2 = -p3 , p1 = p4 or p2 = p3 , p1 = -p4
C                  ------------------------------------------------
C                       This is the case if there is no tilt
C                       angle between the lobe pairs. An infinite
C                       number of rotations is possible here.
C                       Both R values for the t1 and t2 solutions
C                       are given by the indetermined values 0/0.
C                       We proceed here by fixing the first lobe
C                       pairs (i.e. t1 = 0, no angle of rotation)
C                       and rotate the second lobe pair (i.e.
C                       finding the solution for t2 under the
C                       constraint t1 = 0) to match the first lobe
C                       pair.
C
C                  Case ii) p1,p2,p3,p4 not obeing case i)
C                  ---------------------------------------
C                       This is the case if there exists a tilt
C                       angle between the lobe pairs. Proper
C                       solutions exist for both t1 and t2 and
C                       only 4 rotations are possible.
C
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    P            =  full NBAS x NBAS occupation matrix.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    X1,X2        =  NBAS x 2 sections of the NAO
C                                    coefficient matrix in AO basis
C                                    corresponding to the two-fold
C                                    weight degenerate atomic NBOs
C                                    before rotation.
C
C
C                  Output:
C
C                    C1,S1        =  cosine and sine rotation values
C                                    for the first two-fold weight
C                                    degenerate atomic NBO.
C                    C2,S2        =  cosine and sine rotation values
C                                    for the second two-fold weight
C                                    degenerate atomic NBO.
C                    X1,X2        =  NBAS x 2 rotated sections of the
C                                    NAO coefficient matrix in AO basis
C                                    corresponding to the two-fold
C                                    weight degenerate atomic NBOs.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     CASEI
C         LOGICAL     P14ZERO,P23ZERO
         LOGICAL     SAVEC,SAVEP

         INTEGER     N
         INTEGER     NBAS

         DOUBLE PRECISION  A1,A2,A3,A4
         DOUBLE PRECISION  AMAX,BMAX
         DOUBLE PRECISION  C1,C2
         DOUBLE PRECISION  COSA,COSB,COSC,COSD
         DOUBLE PRECISION  ERROR
         DOUBLE PRECISION  F2,F3,F4,F5,F6,F7,F8,F9,F10,F11
         DOUBLE PRECISION  LARGE,VSMALL,EPSILON,EXTREM
         DOUBLE PRECISION  S1,S2
         DOUBLE PRECISION  SINA,SINB,SINC,SIND
         DOUBLE PRECISION  O1,O2,O3,O4
         DOUBLE PRECISION  P1,P2,P3,P4
         DOUBLE PRECISION  R,RNOM,RDENOM
         DOUBLE PRECISION  T2
         DOUBLE PRECISION  Z1,Z2,Z3,Z4,Z5,Z6,Z7,Z8,Z9,Z10,Z11
         DOUBLE PRECISION  ZERO,ONE,TWO,FOUR

         DOUBLE PRECISION  XVEC   (1:NBAS)

         DOUBLE PRECISION  X1     (1:NBAS,1:2   )
         DOUBLE PRECISION  X2     (1:NBAS,1:2   )
         DOUBLE PRECISION  P      (1:NBAS,1:NBAS)
         DOUBLE PRECISION  XMAT   (1:NBAS,1:2   )

         PARAMETER   (ZERO    = 0.D0 )
         PARAMETER   (ONE     = 1.D0 )
         PARAMETER   (TWO     = 2.D0 )
         PARAMETER   (FOUR    = 4.D0 )
         PARAMETER   (LARGE   = 1.D+2)
         PARAMETER   (VSMALL  = 1.D-12)
         PARAMETER   (EPSILON = 1.D-12)
         PARAMETER   (EXTREM  = 1.D+12)

         PARAMETER   (F2  =     1.D0 / 2.D0  )
         PARAMETER   (F3  =     3.D0 / 2.D0  )
         PARAMETER   (F4  =    11.D0 / 8.D0  )
         PARAMETER   (F5  =    31.D0 / 8.D0  )
         PARAMETER   (F6  =    69.D0 / 16.D0 )
         PARAMETER   (F7  =   187.D0 / 16.D0 )
         PARAMETER   (F8  =  1843.D0 / 128.D0)
         PARAMETER   (F9  =  4859.D0 / 128.D0)
         PARAMETER   (F10 = 12767.D0 / 256.D0)
         PARAMETER   (F11 = 32965.D0 / 256.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate initial offdiagonal occupation matrix block
C                corresponding to both two-fold weight degenerate
C                atomic NBOs.
C
C
         SAVEC = .TRUE.
         SAVEP = .TRUE.

         CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +              ( NBAS,2,
     +                NBAS,NBAS,
     +                NBAS,2,
     +                NBAS,2,
     +                NBAS,
     +                2,NBAS,2,
     +                0,0,
     +                SAVEC,SAVEP,SAVEC,
     +                X2,P,X1,
     +                XVEC,
     +
     +                           XMAT )
     +
     +
         CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +              ( 6,
     +                ' P sections before ',
     +                NBAS,2,
     +                2,2,
     +                XMAT )
     +
     +
         P1 = XMAT (1,1)
         P2 = XMAT (1,2)
         P3 = XMAT (2,1)
         P4 = XMAT (2,2)
C
C
C             ...check for case i) orientation (lobes only relatively
C                reoriented to each other).
C
C
         CASEI =    (ABS (P2+P3).LT.VSMALL).AND.(ABS (P1-P4).LT.VSMALL)
     +          .OR.(ABS (P2-P3).LT.VSMALL).AND.(ABS (P1+P4).LT.VSMALL)

         IF (CASEI) THEN

             C1 = ONE
             S1 = ZERO

             IF (P4.EQ.ZERO) THEN
                 COSA = ZERO
                 SINA = ONE
             ELSE
                 T2 = P2 / P4
                 COSA = DSQRT (ONE / (ONE + T2*T2))
                 SINA = DSQRT (ONE - COSA * COSA)
             END IF

             COSB = COSA
             COSC = - COSA
             COSD = - COSA
             SINB = - SINA
             SINC = SINA
             SIND = - SINA
C
C
C             ...find largest solution for a in offdiagonal occupation
C                matrix block:
C
C
C                    | a  0 |     |C2 -S2|   | p1 p2|   | 1  0 |
C                    |      |  =  |      | * |      | * |      |
C                    | 0  b |     |S2  C2|   | p3 p4|   | 0  1 |
C
C
C                by forming the 4 possible a1,a2,a3,a4 values using
C                the sines and cosines evaluated above:
C
C
C                               |    C2     S2
C                         -----------------------
C                           A1  |   COSA   SINA
C                           A2  |   COSB   SINB
C                           A3  |   COSC   SINC
C                           A4  |   COSD   SIND
C
C
C                From these 4 possible solutions we exclude those
C                which lead to nonzero offdiagonal elements. The
C                remaining solutions with a positive can either have
C                b = a or b = -a. The latter case is unacceptable
C                and thus an inversion on the second lobe is performed
C                by multiplying the the rotation matrix forming:
C
C
C                        |C2  S2|     | 1  0 |   |C2 -S2|
C                        |      |  =  |      | * |      |
C                        |S2 -C2|     | 0 -1 |   |S2  C2|
C
C
             A1 = COSA * P1 - SINA * P3
             A2 = COSB * P1 - SINB * P3
             A3 = COSC * P1 - SINC * P3
             A4 = COSD * P1 - SIND * P3
             O1 = COSA * P2 - SINA * P4
             O2 = COSB * P2 - SINB * P4
             O3 = COSC * P2 - SINC * P4
             O4 = COSD * P2 - SIND * P4

             IF (ABS (O1).GT.VSMALL) A1 = ZERO
             IF (ABS (O2).GT.VSMALL) A2 = ZERO
             IF (ABS (O3).GT.VSMALL) A3 = ZERO
             IF (ABS (O4).GT.VSMALL) A4 = ZERO

             AMAX = MAX (A1,A2,A3,A4)

             IF (A1.EQ.AMAX) THEN
                 C2 = COSA
                 S2 = SINA
             ELSE IF (A2.EQ.AMAX) THEN
                 C2 = COSB
                 S2 = SINB
             ELSE IF (A3.EQ.AMAX) THEN
                 C2 = COSC
                 S2 = SINC
             ELSE
                 C2 = COSD
                 S2 = SIND
             END IF

             BMAX = S2 * P2 + C2 * P4
C
C
C             ...rotate (possibly with second lobe inversion) second
C                set of degenerate NBOs relative to first set.
C
C
             IF (BMAX.GT.ZERO) THEN

                 IF (ABS (AMAX - BMAX).GT.VSMALL) THEN
                     WRITE (*,*) ' Problems rotating opposite pairs! '
                     WRITE (*,*) ' AMAX,BMAX = ',AMAX,BMAX
                     WRITE (*,*) ' nlo__rotate_pair_degenerate_nbo '
                     WRITE (1,*) ' Problems rotating opposite pairs! '
                     WRITE (1,*) ' AMAX,BMAX = ',AMAX,BMAX
                     WRITE (1,*) ' nlo__rotate_pair_degenerate_nbo '
                     STOP
                 END IF

                 DO N = 1,NBAS
                    R        = C2 * X2 (N,1) - S2 * X2 (N,2)
                    X2 (N,2) = C2 * X2 (N,2) + S2 * X2 (N,1)
                    X2 (N,1) = R
                 END DO

             ELSE

                 IF (ABS (AMAX + BMAX).GT.VSMALL) THEN
                     WRITE (*,*) ' Problems rotating opposite pairs! '
                     WRITE (*,*) ' AMAX,BMAX = ',AMAX,BMAX
                     WRITE (*,*) ' nlo__rotate_pair_degenerate_nbo '
                     WRITE (1,*) ' Problems rotating opposite pairs! '
                     WRITE (1,*) ' AMAX,BMAX = ',AMAX,BMAX
                     WRITE (1,*) ' nlo__rotate_pair_degenerate_nbo '
                     STOP
                 END IF

                 DO N = 1,NBAS
                    R        =   C2 * X2 (N,1) - S2 * X2 (N,2)
                    X2 (N,2) = - C2 * X2 (N,2) - S2 * X2 (N,1)
                    X2 (N,1) = R
                 END DO

             END IF
C
C
C             ...check the newly rotated NBOs.
C
C
             CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                  ( NBAS,2,
     +                    NBAS,NBAS,
     +                    NBAS,2,
     +                    NBAS,2,
     +                    NBAS,
     +                    2,NBAS,2,
     +                    0,0,
     +                    SAVEC,SAVEP,SAVEC,
     +                    X2,P,X1,
     +                    XVEC,
     +
     +                               XMAT )
     +
     +
            CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                 ( 6,
     +                   ' P sections after relative reorientation ',
     +                   NBAS,2,
     +                   2,2,
     +                   XMAT )
     +
     +
            RETURN

         END IF
C
C
C             ...the absolute reorientation case ii).
C                Find the two sine and cosine solutions for rotation
C                of first degenerate NBOs. If either pair P1,P4 or
C                P2,P3 values are below the calculation accuracy of
C                VSMALL, we apply no rotation. This catch is necessary
C                as the other values might be very small as well,
C                leading to a false conclusion of necessity of small
C                rotations.
C
C
C         P14ZERO = ABS (P1).LT.VSMALL .AND. ABS (P4).LT.VSMALL
C         P23ZERO = ABS (P2).LT.VSMALL .AND. ABS (P3).LT.VSMALL
C
C         IF (P14ZERO) THEN
C             R = EXTREM * DSIGN (ONE,P2-P3)
C         ELSE IF (P23ZERO) THEN
C             R = EXTREM * DSIGN (ONE,P4-P1)
C         ELSE
C             R = (P2*P2 + P4*P4 - P1*P1 - P3*P3) / (P1*P2 + P3*P4)
C         END IF

         ERROR  = (ABS (P1) + ABS (P2) + ABS (P3) + ABS (P4)) * EPSILON
         RNOM   = P2*P2 + P4*P4 - P1*P1 - P3*P3
         RDENOM = P1*P2 + P3*P4

         IF (ABS (RDENOM).LT.ERROR) THEN
             R = EXTREM * DSIGN (ONE,RNOM)
         ELSE
             R = RNOM / RDENOM
         END IF

         WRITE (*,*) ' R for A,B = ',R

         IF (ABS (R).GE.EXTREM) THEN

             IF (R.LT.ZERO) THEN
                 COSA = ONE
                 SINB = ONE
                 SINA = ZERO
                 COSB = ZERO
             ELSE
                 COSB = ONE
                 SINA = - ONE
                 SINB = ZERO
                 COSA = ZERO
             END IF

         ELSE IF (ABS (R).GT.LARGE) THEN

             Z1  = ONE / ABS (R)
             Z2  = Z1  * Z1
             Z3  = Z2  * Z1
             Z4  = Z3  * Z1
             Z5  = Z4  * Z1
             Z6  = Z5  * Z1
             Z7  = Z6  * Z1
             Z8  = Z7  * Z1
             Z9  = Z8  * Z1
             Z10 = Z9  * Z1
             Z11 = Z10 * Z1

             IF (R.LT.ZERO) THEN
                 COSA = ONE - F2*Z2 + F4*Z4 - F6*Z6 + F8*Z8 - F10*Z10
                 COSB =  Z1 - F3*Z3 + F5*Z5 - F7*Z7 + F9*Z9 - F11*Z11
                 SINA = - COSB
                 SINB = COSA
             ELSE
                 COSB = ONE - F2*Z2 + F4*Z4 - F6*Z6 + F8*Z8 - F10*Z10
                 SINB =  Z1 - F3*Z3 + F5*Z5 - F7*Z7 + F9*Z9 - F11*Z11
                 SINA = - COSB
                 COSA = SINB
             END IF

         ELSE

             Z1 = R * R + FOUR
             Z2 = R * DSQRT (Z1)
             Z3 = TWO / (Z1 + Z2)
             Z4 = TWO / (Z1 - Z2)
             COSA = DSQRT (Z3)
             COSB = DSQRT (Z4)
             SINA = - DSQRT (ONE - Z3)
             SINB =   DSQRT (ONE - Z4)

         END IF
C
C
C             ...find the two sine and cosine solutions for rotation
C                of second degenerate NBOs.
C
C
C         IF (P14ZERO) THEN
C             R = EXTREM * DSIGN (ONE,P3-P2)
C         ELSE IF (P23ZERO) THEN
C             R = EXTREM * DSIGN (ONE,P4-P1)
C         ELSE
C             R = (P3*P3 + P4*P4 - P1*P1 - P2*P2) / (P1*P3 + P2*P4)
C         END IF

         ERROR  = (ABS (P1) + ABS (P2) + ABS (P3) + ABS (P4)) * EPSILON
         RNOM   = P3*P3 + P4*P4 - P1*P1 - P2*P2
         RDENOM = P1*P3 + P2*P4

         IF (ABS (RDENOM).LT.ERROR) THEN
             R = EXTREM * DSIGN (ONE,RNOM)
         ELSE
             R = RNOM / RDENOM
         END IF

         WRITE (*,*) ' R for C,D = ',R

         IF (ABS (R).GE.EXTREM) THEN

             IF (R.LT.ZERO) THEN
                 COSC = ONE
                 COSD = ZERO
                 SINC = ZERO
                 SIND = ONE
             ELSE
                 COSD = ONE
                 SIND = ZERO
                 SINC = - ONE
                 COSC = ZERO
             END IF

         ELSE IF (ABS (R).GT.LARGE) THEN

             Z1  = ONE / ABS (R)
             Z2  = Z1  * Z1
             Z3  = Z2  * Z1
             Z4  = Z3  * Z1
             Z5  = Z4  * Z1
             Z6  = Z5  * Z1
             Z7  = Z6  * Z1
             Z8  = Z7  * Z1
             Z9  = Z8  * Z1
             Z10 = Z9  * Z1
             Z11 = Z10 * Z1

             IF (R.LT.ZERO) THEN
                 COSC = ONE - F2*Z2 + F4*Z4 - F6*Z6 + F8*Z8 - F10*Z10
                 COSD =  Z1 - F3*Z3 + F5*Z5 - F7*Z7 + F9*Z9 - F11*Z11
                 SINC = - COSD
                 SIND = COSC
             ELSE
                 COSD = ONE - F2*Z2 + F4*Z4 - F6*Z6 + F8*Z8 - F10*Z10
                 SIND =  Z1 - F3*Z3 + F5*Z5 - F7*Z7 + F9*Z9 - F11*Z11
                 SINC = - COSD
                 COSC = SIND
             END IF

         ELSE

             Z1 = R * R + FOUR
             Z2 = R * DSQRT (Z1)
             Z3 = TWO / (Z1 + Z2)
             Z4 = TWO / (Z1 - Z2)
             COSC = DSQRT (Z3)
             COSD = DSQRT (Z4)
             SINC = - DSQRT (ONE - Z3)
             SIND =   DSQRT (ONE - Z4)

         END IF

         WRITE (*,*) ' COSA = ',COSA
         WRITE (*,*) ' SINA = ',SINA
         WRITE (*,*) ' COSB = ',COSB
         WRITE (*,*) ' SINB = ',SINB
         WRITE (*,*) ' COSC = ',COSC
         WRITE (*,*) ' SINC = ',SINC
         WRITE (*,*) ' COSD = ',COSD
         WRITE (*,*) ' SIND = ',SIND

         WRITE (*,*) ' A ident = ',COSA*COSA + SINA*SINA
         WRITE (*,*) ' B ident = ',COSB*COSB + SINB*SINB
         WRITE (*,*) ' C ident = ',COSC*COSC + SINC*SINC
         WRITE (*,*) ' D ident = ',COSD*COSD + SIND*SIND
C
C
C             ...find largest solution for |a| in offdiagonal occupation
C                matrix block:
C
C
C                    | a  0 |     |C2 -S2|   | p1 p2|   |C1  S1|
C                    |      |  =  |      | * |      | * |      |
C                    | 0  b |     |S2  C2|   | p3 p4|   |-S1 C1|
C
C
C                by forming the 4 possible a1,a2,a3,a4 values using
C                the sines and cosines evaluated above:
C
C
C                         |    C1     S1     C2     S2
C                         --------------------------------
C                     A1  |   COSA   SINA   COSC   SINC
C                     A2  |   COSA   SINA   COSD   SIND
C                     A3  |   COSB   SINB   COSC   SINC
C                     A4  |   COSB   SINB   COSD   SIND
C
C
         A1 = COSA*COSC*P1 - SINA*COSC*P2 - COSA*SINC*P3 + SINA*SINC*P4
         A2 = COSA*COSD*P1 - SINA*COSD*P2 - COSA*SIND*P3 + SINA*SIND*P4
         A3 = COSB*COSC*P1 - SINB*COSC*P2 - COSB*SINC*P3 + SINB*SINC*P4
         A4 = COSB*COSD*P1 - SINB*COSD*P2 - COSB*SIND*P3 + SINB*SIND*P4

         A1 = DABS (A1)
         A2 = DABS (A2)
         A3 = DABS (A3)
         A4 = DABS (A4)

         AMAX = MAX (A1,A2,A3,A4)

         IF (A1.EQ.AMAX) THEN
             C1 = COSA
             C2 = COSC
             S1 = SINA
             S2 = SINC
             WRITE (*,*) ' Took A,C ! '
         ELSE IF (A2.EQ.AMAX) THEN
             C1 = COSA
             C2 = COSD
             S1 = SINA
             S2 = SIND
             WRITE (*,*) ' Took A,D ! '
         ELSE IF (A3.EQ.AMAX) THEN
             C1 = COSB
             C2 = COSC
             S1 = SINB
             S2 = SINC
             WRITE (*,*) ' Took B,C ! '
         ELSE
             C1 = COSB
             C2 = COSD
             S1 = SINB
             S2 = SIND
             WRITE (*,*) ' Took B,D ! '
         END IF

         AMAX = C2 * (C1*P1 - S1*P2) - S2 * (C1*P3 - S1*P4)
         BMAX = S2 * (S1*P1 + C1*P2) + C2 * (S1*P3 + C1*P4)
C
C
C             ...rotate both sets of degenerate NBOs.
C
C
         IF (AMAX.GT.ZERO) THEN
             DO N = 1,NBAS
                R        = C1 * X1 (N,1) - S1 * X1 (N,2)
                X1 (N,2) = C1 * X1 (N,2) + S1 * X1 (N,1)
                X1 (N,1) = R
             END DO
         ELSE
             DO N = 1,NBAS
                R        = - C1 * X1 (N,1) + S1 * X1 (N,2)
                X1 (N,2) =   C1 * X1 (N,2) + S1 * X1 (N,1)
                X1 (N,1) = R
             END DO
         END IF

         IF (BMAX.GT.ZERO) THEN
             DO N = 1,NBAS
                R        = C2 * X2 (N,1) - S2 * X2 (N,2)
                X2 (N,2) = C2 * X2 (N,2) + S2 * X2 (N,1)
                X2 (N,1) = R
             END DO
         ELSE
             DO N = 1,NBAS
                R        =   C2 * X2 (N,1) - S2 * X2 (N,2)
                X2 (N,2) = - C2 * X2 (N,2) - S2 * X2 (N,1)
                X2 (N,1) = R
             END DO
         END IF
C
C
C             ...check the newly rotated NBOs.
C
C
         CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +              ( NBAS,2,
     +                NBAS,NBAS,
     +                NBAS,2,
     +                NBAS,2,
     +                NBAS,
     +                2,NBAS,2,
     +                0,0,
     +                SAVEC,SAVEP,SAVEC,
     +                X2,P,X1,
     +                XVEC,
     +
     +                           XMAT )
     +
     +
         CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +              ( 6,
     +                ' P sections after ',
     +                NBAS,2,
     +                2,2,
     +                XMAT )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine xgemm(transa,transb,
     &                 m,n,k,alpha,a,lda,
     &                             b,ldb,
     &                       beta, c,ldc)

c----------------------------------------------------------------------------
c  This code overrides the normal ACESII serial version of xgemm in the 
c  "tools" library.  Its purpose is to provide a version of xgemm that works 
c  has the proper interface to the calling sequence required in the joda
c  routines, while calling the actual system-level dgemm routine with the
c  properly typed arguments.
c
c  This version of xgemm gets linked in ahead of the tools/xgemm.o.  Then
c  the joda code within the xaces3 executable calls this version of xgemm,
c  which calls the proper system-level dgemm routine.  
c----------------------------------------------------------------------------
 
c ARGUMENT LIST
      character*1 transa, transb
#ifdef ACES64
      integer*8 m, n, k, lda, ldb, ldc
#else
      integer m, n, k, lda, ldb, ldc
#endif
      double precision alpha, beta
c      double precision a(lda,*), b(ldb,*), c(ldc,*)
      double precision a, b, c

#ifdef __crayx1
      integer*8   int_m, int_n, int_k, int_lda, int_ldb, int_ldc
#else
      integer   int_m, int_n, int_k, int_lda, int_ldb, int_ldc
#endif

c ----------------------------------------------------------------------

c This quick return code was taken straight from blas/dgemm. We need it
c for cases when m=lda=0 (e.g., the number of occupied orbitals is zero
c but we didn't check for it). Rather than have dgemm crash, we just
c want to return having done nothing. This also saves us from filtering
c lda, ldb, and ldc through max(1,ld?).

c BEWARE!!! xgemm will, therefore, not crash when the other arguments
c are ill-conditioned.

      if ((m.eq.0).or.
     &    (n.eq.0).or.
     &    (((alpha.eq.(0.0d0)).or.(k.eq.0)).and.(beta.eq.(1.0d0)))
     &   ) return

c ----------------------------------------------------------------------

c   o recast the arguments
      int_m   = m
      int_n   = n
      int_k   = k
      int_lda = lda
      int_ldb = ldb
      int_ldc = ldc

#ifdef USE_SP_BLAS
      call sgemm(transa,transb,int_m,int_n,int_k,
     &           alpha,a,int_lda,
     &                 b,int_ldb,
     &           beta, c,int_ldc)
#else
      call dgemm(transa,transb,int_m,int_n,int_k,
     &           alpha,a,int_lda,
     &                 b,int_ldb,
     &           beta, c,int_ldc)
#endif

      return
      end

      SUBROUTINE CHKECK(NRX,HBUF,ECKART)
C
C SUBROUTINE CHECKS NORMAL MODES AGAINST ECKART CONDITIONS.  PUTS
C   VALUES OF ROTATIONAL AND TRANSLATIONAL PSEUDOMOMENTA INTO A VECTOR
C   AND PASSES THIS BACK TO THE CALLING PROGRAM.  PRINTING IS AN OPTION.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
 
      Common /Orient/ Orient(3,3)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
      DIMENSION ECKART(2*NRX),HBUF(NRX,NRX),ZAT(3),ZA(3)
C
C CHECK EIGENVECTORS AGAINST ECKART CONDITIONS - CAN DETERMINE IF
C  IT IS A TRANSLATION, ROTATION OR VIBRATION.  USE TOLERANCES FOR
C  LINEAR AND ANGULAR MOMENTUM.  PUT VALUE INTO ECKART VECTOR
C  (TOP HALF USED FOR ROTATIONS, BOTTOM FOR TRANSLATIONS).
C
C
C FIRST, MAKE EIGENVECTOR DIMENSION = MASS * DISPLACEMENT SO THAT ROTATI
C  ECKART CONDITION CAN BE TESTED LATER.
C
 3456 DO 32 I=1,NRX
      DO 33 J=1,NRX
      HBuf(J,I)=HBuf(J,I)*DSQRT(ATMASS(1+(J-1)/3))
   33 CONTINUE
      CALL NORMAL(HBUF(1,I),NRX)
   32 CONTINUE
C
C TEST ECKART CONDITIONS.
C
      CALL ZERO(ECKART,2*NRX)
      DO 35 I=1,NRX
      CALL ZERO(ZAT,3)
C
C 1. CHECK ANGULAR MOMENTUM CRITERIA
C
       DO 36 J=1,NRX-2,3
        CALL CROSS(HBUF(J,I),Q(J),ZA,0)
        CALL VADD(ZAT,ZAT,ZA,3,1.D0)
   36  CONTINUE
       CALL ZERO(ZA,3)
       ECKART(I)=DIST(ZAT,ZA)
C
C 2. CHECK LINEAR MOMENTUM CRITERIA
C
C
        CALL ZERO(ZAT,3)
        DO 39 J=1,NRX-2,3
        CALL VADD(ZAT,ZAT,HBUF(J,I),3,1.D0)
   39  CONTINUE
       ECKART(NRX+I)=DIST(ZAT,ZA)
   38  CONTINUE
   35  CONTINUE
C
C DUMP ROTATIONAL AND VIBRATIONAL VALUES IF CALLED FOR.
C
      IF(IPRNT.GE.8)THEN
       WRITE(LUOUT,5700)
 5700  FORMAT(T3,' Linear and Angular "momenta" corresponding ',
     &'to Hessian Eigenvectors ',/,T10,'Mode',T30,'P',T50,'L')
       WRITE(LUOUT,5701)(I,ECKART(NRX+I),ECKART(I),I=1,NRX)
 5701  FORMAT(T10,I3,T23,F16.12,T43,F16.12)
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_prequest_message(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a prequest message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind1, ind2
      integer ptr, ptr2, msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile
      integer status(MPI_STATUS_SIZE)
      logical flag, restore_data_flag
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      double precision xmin, xmax

#ifdef ALTIX
      dptr = dshptr
#endif
      state = server_msg(c_msg_state,node)
c      print *,'PREQ MSG: line ',server_msg(c_msg_current_line,node),
c     *     ' node ',node,' state ',state,' cause ',
c     *     server_msg(c_msg_cause,node), 
c     *     ' clean ptr ',
c     *     clean_block_ptr,' nclean ',nclean_blocks
      if (state .eq. begin_state .or. 
     *    state .eq. wait_for_block_state) then

c---------------------------------------------------------------------------
c   Force the data into memory.  
c---------------------------------------------------------------------------
 
         call claim_memory_block(node, server_table, nserver_table,
     *                            .true.)

         if (server_msg(c_msg_state, node) .eq. null_state) then
            server_msg(c_msg_state, node) = prequest_intermediate_state
         else
c            print *,'CLAIM FAILED: cause ',server_msg(c_msg_cause,node)
            return   ! claim did not work, retry later.
         endif
      endif
          
      if (server_msg(c_msg_state,node) .eq. 
     *                 prequest_intermediate_state) then

c--------------------------------------------------------------------------
c   Lookup the addresses of the data block and the msgbuffer data block.
c--------------------------------------------------------------------------

         ptr       = server_msg(c_msg_stptr,node)
         memloc    = server_table(c_server_memloc,ptr)
         msgbuffer = server_msg(c_msg_msgbuffer,node)

         indblk    = get_index_from_base(base_mem_addr, x, 2)
         ind1      = indblk + (memloc-1)*server_mem_blocksize
         ind2      = indblk +(msgbuffer-1)*server_mem_blocksize

c---------------------------------------------------------------------------
c   Copy the slice of data from the data block (ind1) into the msgbuffer 
c   (ind2).
c---------------------------------------------------------------------------

         call prequest_copy_slice(node, x(ind1), x(ind2),
     *                   server_table, nserver_table)

c---------------------------------------------------------------------------
c   Post a mpi_isend using the msgbuffer as the data address.
c---------------------------------------------------------------------------

         size = server_msg(c_msg_size,node)
         call mpi_isend(x(ind2), size, mpi_double_precision,
     *               server_msg(c_msg_source,node),
     *               server_msg(c_msg_tag,node),mpi_comm_world,
     *               server_msg(c_msg_request,node), ierr)

c--------------------------------------------------------------------------
c   Release the data block by turning off the server_table flags.  This 
c   allows the block to be reused in other messages at this point.
c---------------------------------------------------------------------------

          server_table(c_server_flags,ptr) = xor(server_busy_flag,
     *              server_table(c_server_flags,ptr))
          server_table(c_server_busy_node,ptr) = 0
          call push_clean_block(memloc,server_table, nserver_table)

c---------------------------------------------------------------------------
c   Enter the "wait_for_send" state.
c---------------------------------------------------------------------------

         server_msg(c_msg_state,node) = wait_for_send_state
      endif

      if (server_msg(c_msg_state,node) .eq.
     *                         wait_for_send_state) then

c-------------------------------------------------------------------------
c   Test for completion of the send.
c-------------------------------------------------------------------------

         if (server_msg(c_msg_request,node) .eq. 
     *                               MPI_REQUEST_NULL) then
            flag = .true.
         else
            call mpi_test(server_msg(c_msg_request,node), flag,
     *                 status, ierr)
         endif

         if (flag) then
c            print *,'PREQ line ',server_msg(c_msg_current_line,node),
c     *            ' for node ',node,' completed!!!'
            server_msg(c_msg_state,node) = null_state   ! done
         endif
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine accumulate_block(array, array_block, iblk2,
     *                 tarray, tarray_block, iblk, tproc, array_table,
     *                 narray_table, index_table, nindex_table,
     *                 segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table,
     *                 scalar_table, nscalar_table, address_table,
     *                 send_count, send_time, comm, my_comm_rank,
     *                 opcode, comm_timer, instruction_timer)
c--------------------------------------------------------------------------
c   Sends a block of a distributed array to its destination in rsponse to 
c   an accumulate command.  
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blkmgr.h'

      integer array, array_block
      integer tarray, tarray_block
      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer*8 address_table(narray_table)
      integer send_count, flopcount
      integer comm
      integer my_comm_rank
      integer opcode

      integer result_type, result_block, tproc, flag
      integer array_type
      integer find_block_destination
      integer iblk, iblk2, get_block_number
      integer nwblock, request
      integer get_block_request
      integer comm_timer, instruction_timer
      integer tblkndx

      double precision send_time
      integer nscalar_table
      double precision scalar_table(nscalar_table)

      result_type = array_table(c_array_type,tarray)
      array_type = array_table(c_array_type, array)
      if (result_type .ne. distributed_array) then
         print *,'Error: accumulate_block called, ',
     *             ' but the array is not a distributed array.'
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Set the "put" flag, indicating that the barrier should destroy
c   all local copies of the array's blocks.
c--------------------------------------------------------------------------

      array_table(c_put_flag,tarray) = 1

      call mutex_block(iblk2)   ! lock the "send" block

c---------------------------------------------------------------------------
c   Check for a previous communication request.  It must be satisfied before
c   a new one can be started.
c---------------------------------------------------------------------------

      request = get_block_request(array, array_block, iblk2)
      if (request .ne. mpi_request_null) 
     *   call wait_on_block(array, array_block, iblk2, 
     *             array_type, request,
     *             instruction_timer, comm_timer)

      if (tproc .eq. my_comm_rank) then
         call mutex_block(iblk)

         if (opcode .eq. put_op) then

c--------------------------------------------------------------------------
c   Sum the block locally.
c--------------------------------------------------------------------------

            call sum_blocks(tarray, tarray_block, iblk, 
     *                      array, array_block, iblk2,
     *                      tarray, tarray_block, iblk, sum_op,
     *                      array_table, narray_table,
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
         else if (opcode .eq. put_replace_op) then

c----------------------------------------------------------------------------
c   Copy the block locally.
c----------------------------------------------------------------------------

            call assign_block(array, array_block, iblk2,
     *                      tarray, tarray_block, iblk,
     *                      array_table, narray_table,
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
         else
            print *,'Error: accumulate_block must be called with ',
     *              'put_op or put_replace_op.'
            print *,'Invalid opcode was ',opcode
            call abort_job()
         endif

         call release_mutex_block(iblk)
      else

c--------------------------------------------------------------------------
c   Send the data to a remote process.
c--------------------------------------------------------------------------

         call get_actual_blocksize(array, array_block, iblk2,
     *                  array_table, narray_table, 
     *                  index_table, nindex_table, 
     *                  segment_table, nsegment_table, nwblock)

         tblkndx = -1

         call send_block(array, array_block, iblk2, tproc, tarray, 
     *                tarray_block, tblkndx, nwblock, comm, opcode,
     *                request)

         call set_block_request(array, array_block, iblk2, request)
         if (request .ne. mpi_request_null) 
     *      call blkmgr_insert_block_in_list(comm_list_head, 
     *                     comm_list_tail, iblk2,
     *                     c_comm_list_ptr, .true.)
       endif

      call release_mutex_block(iblk2)  
      return
      end

c This routine adds a vector DADD to the first column of an MOIO array in
c storage. DADD must have the same number of elements as one column of the
c MOIO array.

c INPUT
c double DADD(*) : the vector of addends
c double DSCR(*) : scratch array to hold at least one column of the MOIO array
c int IDIMSCR : size of the scratch array
c int IJUNK   : (obsolete integer)
c int ILEFT   : the left  MOIO index
c int IRIGHT  : the right MOIO index

      subroutine sumsym3(dAdd,dScr,iDimScr,iJunk,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iDimScr, iJunk, iLeft, iRight
      double precision dAdd(*), dScr(iDimScr)

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer nRows, nCols, i

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert iDimScr is > 0
      if (iDimScr.lt.1) then
         print *, '@SUMSYM3: Assertion failed.'
         print *, '   iDimScr = ',iDimScr
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif

c ----------------------------------------------------------------------

      nRows = aces_list_rows(iLeft,iRight)
      nCols = aces_list_cols(iLeft,iRight)
      if ((nRows.lt.1).or.(nCols.lt.1)) return

      if (iDimScr.lt.nRows) then
         print *, '@SUMSYM3: ERROR - There is not enough scratch space',
     &            ' for one column.'
         print *, '          MOIO list = ',iLeft,iRight
         print *, '          iDimScr   = ',iDimScr
         print *, '          nRows     = ',nRows
         call aces_exit(1)
      end if

      call getlst(dScr,1,1,0,iLeft,iRight)
      do i = 1, nRows
         dScr(i) = dScr(i) + dAdd(i)
      end do
      call putlst(dScr,1,1,0,iLeft,iRight)

      return
c     end subroutine sumsym3
      end

      Subroutine Ln_search(Energy, Cur_geo, Prv_geo_stp, Cur_grad, 
     &                     Prv_grad, Prv_geo_stpn, Nxm6, EPS)


      Implicit Double Precision (A-H, O-Z)

      Dimension Energy(2), Cur_geo(Nxm6), Prv_geo_stp(Nxm6), 
     &          Cur_grad(Nxm6), Prv_grad(Nxm6), Prv_geo_stpn(Nxm6)
 
      Data Dnull, Done, Ione, Five, Two, Three, Four, Pt1, Pt5, Pt9, 
     &            Pt15 /0.0D0, 1.0D0, 1, 5.0D0, 2.0D0, 3.0D0, 4.0D0, 
     &                 0.1D0, 0.5D0, 0.9D0, 0.15D0 /
C
      Step_Norm = Dsqrt(Ddot(Nxm6, Prv_geo_stp, 1, Prv_geo_stp, 1))

      Do Imode = 1, Nxm6
         Prv_geo_stpn(Imode) = - Prv_geo_stp(Imode)/Step_Norm
      Enddo
     
      Prv_grad_on_stp = Ddot(Nxm6, Prv_geo_stpn, 1, Prv_grad, 1)
      Cur_grad_on_stp = Ddot(Nxm6, Prv_geo_stpn, 1, Cur_grad, 1)

      Thrs = Eps*100

      If (Dabs(Prv_grad_on_stp) .lt. Thrs .or. Dabs(Cur_grad_on_stp)
     &    .lt. Thrs) Then
         Write(6, "(a,a)") "Too close to the minimum, line search",
     &          " skipped."
         Return
      Endif 
C
c The energy and gradient from the current and last point are fitted
C to a quadratic polynomial.

      Ca = Dabs(Five*Prv_grad_on_stp -Two*Cur_grad_on_stp + Three*
     &     Energy(1) - Three*Energy(2))
      Cb = Cur_grad_on_stp + Prv_grad_on_stp + Two*Energy(1) - Two*
     &     Energy(2) - Two*Ca
      Cc = Energy(2) - Energy(1) - Prv_grad_on_stp - Ca - Cb
      Cd = Prv_grad_on_stp
      Ce = Energy(1)


      Write(6,*) "@-Ln_search, Starting parameters"
      Write(6,*) "The normalized step increment"
      Write(6,"(3F10.5)") (Prv_geo_stpn(I), I=1,Nxm6)
      Write(6,*) "Prv. and Cur. gradient nomrs"
      Write(6,"(2F10.5)") Prv_grad_on_stp, Cur_grad_on_stp
      Write(6,*) "Ca-e coefs"
      Write(6,"(5F10.5)") Ca, Cb, Cc, Cd, Ce


      If ((Prv_grad_on_stp .lt. Dnull) .and. (Cur_grad_on_stp .gt. 
     &      Dnull)) Then
c
         Crda  = Dnull
         Crdb  = DOne
         Grda  = Prv_grad_on_stp
         Grdb  = Cur_grad_on_stp
         Iycle = Ione
C
         Crdc  = Crda + (Crdb - Crda)*Max(Pt1, Min(Pt9,Dabs(Grda/
     &             Grdb)*pt5))
         Grdc  = ((four*Ca*Crdc + Three*Cb)*Crdc +Two*Cc)*Crdc + Cd
         Gcut  = 1.0D-5*Min(Dabs(Prv_grad_on_stp), Dabs(
     &               Cur_grad_on_stp))
C







         Do While (Dabs(Grdc) .lt. Gcut) 

            Icycle = Icycle + 1
C
            If (Grdc .Gt. Dnul) Then
                Crdb = Crdc
                Grdb = Grdc
            Else
               Crda = Crdc
               Grda = Grdc
            Endif
C
            Crdc = Crda + (Crdb - Crda)*Max(Pt1, Min(Pt9,Dabs(Grda/
     &             Grdb)*pt5))
            Grdc = ((four*Ca*Crdc + Three*Cb)*Crdc +Two*Cc)*Crdc + Cd
C

      Write(6,*) "@-Ln_search, parameters during the ln search"
      Write(6,"(1x,a,2F10.5)") "Crdb, Grdb: ", Crdb, Grdb 
      Write(6,"(1x,a,2F10.5)") "Crda, Grda: ", Crda, Grda 
      Write(6,"(1x,a,2F10.5)") "Crdc, Grdc: ", Crdc, Grdc

C
            If (Icycle .gt. 200) Then
               Write(6,*)
               Write(6, "(a)") "Line search failed and it is ignored!"
               Return
            Endif
C
         Enddo 
C
C If the line serch yields almost the same point as the previous point,
C do not use it.
C       
         If (Crdc .lt. pt15) Then
             Write(6, "(a)") "The line serach is skipped!"
             Return
         Else
             Do Imode = 1, Nxm6
                Cur_geo(Imode)  = Cur_geo(Imode) + 
     &                            Prv_geo_stp(Imode)*(Done - Crdc)
                Cur_grad(Imode) = Prv_grad(Imode) + (Cur_grad(imode)  
     &                            - Prv_grad(Imoded))*Crdc
             Enddo
         Endif
C 
         Energ_intpl = (((Ca*Crdc + Cb)*Crdc + Cc)*Crdc + Cd)*Crdc
     &                            + Ce

C

      Write(6,*) "@-Ln_search, interpolated, geo., grad. and energy"
      Write(6,*) "The geometry"
      Write(6,"(3F10.5)") (Cur_geo(i), i=1, Nxm6)
      Write(6,*) "The gradients"
      Write(6,"(3F10.5)") (Cur_grad(i), i=1, Nxm6)
      Write(6,"(a,F10.5)") "The energy", Energ_intpl

      Else
C 
         Write(6,*)
         Write(6, "(1x,a)") "Line search is skiped!"
         Write(6,*)
C
      Endif 
C
      Return
      End
 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine write_zmat_auto(jobflow)
c-------------------------------------------------------------------------
c   Uses information from the ZMAT file and ACES II flags to generate
c   automatic ACES III parameters which are written to the file ZMAT.AUTO.
c
c   If a *SIP section already exists in the ZMAT file, no automatic
c   parameters are generated.
c-------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
      include 'frag_def.h'
      include 'dropmo.h'

#ifdef ACES64
      integer*8 ishell, ierr
      common /flags/ iflags
      integer*8 iflags(100)
      integer*8 iflags2(500)
#else
      integer ishell, ierr
      common /flags/ iflags
      integer iflags(100)
      integer iflags2(500)
#endif

      integer calc, vib, geom_opt, ref, dropmo, excite, instab, props
      integer grad_calc, dip_calc, dea_calc, density
      integer nerr
      integer ios
      integer str_trimlen
      integer i, j, n, nw, ns

      integer nauto_params
      parameter (nauto_params = 4)

      character*80 line, sip_line
      character*80 keyword
      character*80 auto_keyword(nauto_params)
      character*80 jobflow  
      logical set_keyword(nauto_params)
      logical sip_written

      auto_keyword(1) = 'MAXMEM'
      auto_keyword(2) = 'COMPANY'
      auto_keyword(3) = 'IOCOMPANY'
      auto_keyword(4) = 'SIAL_PROGRAM'

      nerr = 0

c---------------------------------------------------------------------------
c   Get IFLAGS and IFLAGS2 off of JOBARC.
c---------------------------------------------------------------------------

      call igetrec(1,'JOBARC','IFLAGS',100,iflags)
      call igetrec(1,'JOBARC','IFLAGS2',500,iflags2)

c---------------------------------------------------------------------------
c   Determine type of calculation.
c---------------------------------------------------------------------------

      calc     = iflags(2)
      if (calc .ne. 0 .and. calc .ne. 1 .and. calc .ne. 10 .and.
     *    calc .ne. 22 .and. calc .ne. 6) then
         nerr = nerr + 1
         print *,'ACES III only supports CALC values of SCF, MBPT(2),',
     *           ' LCCSD, CCSD, and CCSD(T).'
      endif

      vib      = iflags(54)
      geom_opt = iflags2(5)
      props    = iflags(18)   ! Watson: get props.
      grad_calc = iflags2(138)

      if ((geom_opt .gt. 0) .and. (calc .eq. 22)) then
        print *,'ACES III does not support CALC=CCSD(T) with geometry ',
     *          'optimization'
        nerr = nerr + 1
      endif

c---------------------------------------------------------------------------
c   Get the REF value.
c---------------------------------------------------------------------------

      ref = iflags(11)
      if (ref .ne. 0 .and. ref .ne. 1) then
         nerr = nerr + 1
         print *,'ACES III only supports REF values of UHF, ',
     *           'RHF for auto parameterization.'
      endif

c---------------------------------------------------------------------------
c   Get the DROPMO flag.
c---------------------------------------------------------------------------

      dropmo = iflags(27)

      if (dropmo .gt. 0) then
         if (geom_opt .gt. 0) then
            if (calc .eq. 1) then
               print *,'ACES III does not support CALC=MBPT(2) with ',
     *                 'DROPMO and geometry optimization'
               nerr = nerr + 1
            endif
         endif
      endif

c---------------------------------------------------------------------------
c   Get the EXCITE flag.
c---------------------------------------------------------------------------

      excite = iflags(87)

      if (excite .gt. 0) then
         if (calc .ne. 10) then
            print *,'ACES III using EXCITE=EOMEE must use ',
     *                 'CALC=CCSD.'
            nerr = nerr + 1
         endif
      endif

c---------------------------------------------------------------------------
c   Get the flag for relaxed or respnse denstiy
c---------------------------------------------------------------------------

      density = iflags(19)
c
c---------------------------------------------------------------------------
c Get the flags for DIP/DEA calculations.
C Note that currently singlet states only DIP/DEA calculations
C require UHF refrence and it is not necessary and need to be
C changed (require new SIAL codes). Ajith Perera, 07/2013.

      dip_calc = iflags2(128)
      dea_calc = iflags2(230)

      If (dip_calc .gt. 0 .OR. dea_calc .gt. 0) then
          if (ref .eq. 0) then
              Write(6,"(a,a)") "DIP/DEA calcuation with RHF reference",
     &                         " is not currently supported."
              nerr = nerr + 1
          Endif
      Endif
c---------------------------------------------------------------------------
c   Get the HFSTABILITY flag.
c---------------------------------------------------------------------------

      instab = iflags(74)

c--------------------------------------------------------------------------
c   Abort job if it did not pass the error checking.
c--------------------------------------------------------------------------

      if (nerr .gt. 0) then
         print *,'Aborting job in write_zmat_auto due to ',nerr,
     *           ' errors'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Open the files.
c---------------------------------------------------------------------------

      open (unit=22, file='ZMAT.AUTO', ACTION='WRITE',
     *      err = 100, iostat = ios)

  100 continue
      if (ios .ne. 0) then
         print *,'Error: Cannot open ZMAT.AUTO file.'
         call abort_job()
      endif

      open (unit=23, file='ZMAT', status='OLD',
     *      err = 200, iostat = ios)

  200 continue
      if (ios .ne. 0) then
         print *,'Error: Cannot open ZMAT file.'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Copy everything before a *SIP section to the ZMAT file.
c---------------------------------------------------------------------------

      sip_written = .false.
  300 continue
      line = ' '
      read (23,9000, end = 400) line
      if (line(1:4) .eq. '*SIP') then
         write (22,9000) line   ! copy the '*SIP'
         sip_written = .true.
         go to 400
      endif
      write (22,9000) line   ! copy to ZMAT.AUTO
      go to 300

  400 continue

c--------------------------------------------------------------------------
c   Process the '*SIP' section?
c--------------------------------------------------------------------------

      do i = 1, nauto_params
         set_keyword(i) = .false.
      enddo

      if (sip_written) then
  500    continue
         line = ' '
         read (23,9000,end=600) line
         if (line(1:1) .eq. '*') go to 600   ! new namelist.
         if (line .eq. ' ') go to 600        ! skip blank line

c---------------------------------------------------------------------------
c   Scan the line for '='.
c---------------------------------------------------------------------------

         do i = 1, len(line)
            if (line(i:i) .eq. '=') then
               n = str_trimlen(line(1:i-1))
               keyword = line(1:n)

c----------------------------------------------------------------------------
c   See if 'keyword' is in the list of automatic params.
c----------------------------------------------------------------------------

               do j = 1,nauto_params
                  if (keyword .eq. auto_keyword(j))
     *                set_keyword(j) = .true.
               enddo
               exit
            endif
         enddo

c----------------------------------------------------------------------------
c   Now copy the line to ZMAT.AUTO.
c----------------------------------------------------------------------------

         write(22,9000) line
         go to 500
      endif

  600 continue

c--------------------------------------------------------------------------
c   If the '*SIP' record has not been written, do it now.
c--------------------------------------------------------------------------

      if (.not. sip_written) then
         sip_line = '*SIP'
         write(22,9000) sip_line
      endif

c--------------------------------------------------------------------------
c   Write out lines for any automatic parameters that have not been set in
c   the '*SIP' section.
c-------------------------------------------------------------------------

      if (.not. set_keyword(1)) then
         sip_line = 'MAXMEM=900'
         write (22,9000) sip_line
      endif

      if (.not. set_keyword(2)) then
         nw = (nprocs * 3) / 4
         nw = max(nw, 1)      ! must have at least 1 worker
         sip_line = ' '
         write (sip_line, 9100) nw   ! COMPANY parameter
         write (22,9000) sip_line
      endif

      if (.not. set_keyword(3)) then
         nw = (nprocs * 3) / 4
         nw = max(nw, 1)
         ns = nprocs - nw
         sip_line = ' '
         write (sip_line, 9200) ns   ! IOCOMPANY parameter
         write (22,9000) sip_line
      endif

c   Check if this is a fragmented calculation.  
c---------------------------------------------------------------------------

  700 continue
      line = ' '
      read (23,9000, end = 800) line
      if (line(1:9) .eq. '*FRAGLIST') then
         frag_calc = .true. 
         write (22,9000) line   ! copy the '*SIP'
      endif
      if (frag_calc) then 
         fdrop_flag = .false. 
         read(23,*) nfrags 
c
c Check for dropmo calc NOT frag calc 
         if (nfrags .le. 1) then 
            nfrags = 2 
            fdrop_flag = .true. 
         endif 

         read(23,*) (natoms_frag(i), i=1, nfrags) 
         do i = 1, nfrags 
            read(23,*) (watom_frag(i,j), j=1, natoms_frag(i)) 
         enddo 
c     endif 
c 800 continue

c     if (frag_calc) then 
         write(6,*) ' You are performing a fragment calculation' 
         write(6,*) ' Number of fragments :', nfrags 
         do i = 1, nfrags 
            write(6,*) ' Atoms in fragment ', i, 
     *         (watom_frag(i,j), j=1, natoms_frag(i)) 
         enddo 
      endif
  800 continue
 
c---------------------------------------------------------------------------

      if (.not. set_keyword(4)) then
         call write_default_sial_programs(calc,dropmo,ref,geom_opt,
     *                                    vib, excite, instab, props,
     *                                    grad_calc,density,dip_calc,
     *                                    dea_calc,jobflow)
      else 
         call find_jobflow(calc,dropmo,ref,geom_opt,
     *                                    vib, excite, instab, props,
     *                                    grad_calc,density,dip_calc,
     *                                    dea_calc,jobflow)
      endif

c---------------------------------------------------------------------------
c   Copy all additional lines to ZMAT.AUTO.
c---------------------------------------------------------------------------

      line = ' '
      read (23,9000,end=9900) line
      write (22,9000) line

 9900 continue
      close(22)
      close(23)

 9000 format(a80)
 9100 format('COMPANY   = 1 1 ',i5,' 0')
 9200 format('IOCOMPANY = 2 1 ',i5,' 0')
      return
      end

c This routine retrieves the transpose of an upper-left rectangular submatrix
c of an MOIO array. For a stored matrix dList(1:nRows,1:nCols) and given
c boundaries iRow and iCol, the output would be dDest(1:iCol,1:iRow).

c INPUT
c double DSCR(*) : scratch array to hold at least one column of the MOIO array
c int IROW   : number of rows    in the submatrix (columns in the transpose)
c int ICOL   : number of columns in the submatrix (rows    in the transpose)
c int IJUNK  : (obsolete integer)
c int ILEFT  : the left  MOIO index
c int IRIGHT : the right MOIO index

c OUTPUT
c double DDEST(*) : the destination array for the transpose

      subroutine gettrn(dDest,dScr,iRow,iCol,iJunk,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iRow, iCol, iJunk, iLeft, iRight
      double precision dDest(iCol,iRow), dScr(*)

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer i

c ----------------------------------------------------------------------


      i = 0
c   o assert dimensions are properly bound (zero rows or cols returns)
      if ((iRow.lt.0).or.(iRow.gt.aces_list_rows(iLeft,iRight)).or.
     &    (iCol.lt.0).or.(iCol.gt.aces_list_cols(iLeft,iRight))
     &   ) then
         print *, '@GETTRN: Assertion failed.'
         print *, '   MOIO list = ',iLeft,iRight
         print *, '   MOIO rows = ',aces_list_rows(iLeft,iRight)
         print *, '   MOIO cols = ',aces_list_cols(iLeft,iRight)
         print *, '   iRow = ',iRow
         print *, '   iCol = ',iCol
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)


c ----------------------------------------------------------------------

      if ((iRow.lt.1).or.(iCol.lt.1)) return

      do i = 1, iCol
         call getlst(dScr,i,1,0,iLeft,iRight)
         call dcopy(iRow,dScr,1,dDest(i,1),iCol)
      end do

      return
c     end subroutine gettrn
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      Subroutine SAVORI ( PtGrp, NAtms, Q, AtNr, At1, At2, XYOri, Err )
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: savori.F,v 1.3.18.1 2011/10/10 04:00:29 bhoj Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose:
C     Save information about the xy-orientation of the molecule.
C
C Arguments:
C     PtGrp    Point group to be used (Schoenflies symbol) (input)
C     NAtms    Number of atoms in molecule (input)
C     Q        Cartesian coordinates of centers (input)
C     AtNr     Atomic numbers of centers (input)
C     At1      First atom of "marker pair" (output)
C     At2      Second atom of "marker pair" (output)
C     XYOri    Direction of vector joining At1 to At2 (output)
C     Err      Error return code (output)
C
C Internal Variables:
C     ScrQ     Coordinates while they're being worked on. Length
C              2*(3*NAtms) because we need the workspace
C     RefOrd   Hold reference permutation list
C     NewOrd   Hold permutation list from sort
C     *** The GrpOp data structure ***
C     NrOps    Number of operations in the group.
C     PrinAx   Specify the principal axes for the molecule
C     OpTyp    Holds the type of symmetry operations from GrpOp
C     OpOrd    Holds the order of the axis for OpTyp = rotations
C     OpAxis   Holds the axis/plane to use for the sym. op.
C
C Dependents:
C     linblnk   Returns the index of the last non-blank character
C     GrpOps    Returns the operations of the given point group
C     MakGen   Updates the GenBy list
C     SortC    Sorts & mass weights coordinate vector.  We use it
C              to get the permutation list from the operations.
C     DoSyOp   The "symmetry operation interpreter" - does whatever
C              transformation its told.
C
C Diagnostic Messages:
C     "Unknown point group"  The given point group is unknown to
C     GrpOps. The C1 point group is used instead & is returned to
C     the caller in PtGrp.
C
C     "Unknown symmetry operation"  The sym. op. interpreter cannot
C     handle the indicated operation.  It is ignored.
C
C     "Unidentified error during..." The sym. op. interpreter returns
C     an error which SymEqv doesn't understand.  The operation is
C     ignored.  If this occurs, it probably means that the sym. op.
C     interpreter has been changed & SymEqv hasn't been updated to
C     match any new error codes.
C
C Limitations:
C     Parameter MxOps limits  the number of symmetry operations we
C     can handle from GrpOps.  It is presently set to 150, which should
C     be sufficient for anything but the I groups.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     Maximum number of atoms currently allowed
#include "mxatms.par"
      Character*(*) PtGrp
      Dimension Q(3*NAtms)
      Integer AtNr(NAtms), At1, At2, XYOri, Err
C
      integer luout
      parameter (luout = 6 )
c
      Dimension OriVec(3)
C
C     To handle the coordinate transformations
      Dimension ScrQ(2*3*MxAtms)
      Integer RefOrd(MxAtms), NewOrd(MxAtms), GenBy(MxAtms)
C
C     For the operations of the point group.  MxOps=50 should handle
C     just about everything except I groups!
      Integer GrpOps
      Integer NrOps, MxOps, PrinAx(3)
      Parameter (MxOps = 150)
      Character*1 OpTyp(MxOps)
      Integer OpOrd(MxOps), OpAxis(MxOps)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     First, clear out the GenBy list, At1, At2, and XYOri.
C
      Do 100 i = 1, NAtms
         GenBy(i) = 0
 100  Continue
      At1 = 0
      At2 = 0
      XYOri = 0
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Now, get the operations of the group
C
      PrinAx(1) = 3
      PrinAx(2) = 1
      PrinAx(3) = 2
      NrOps = GrpOps (PtGrp, PrinAx, MxOps, OpTyp, OpOrd, OpAxis)
C
C     If GrpOps doesn't know this group, write an error message,
C     set the group to be C1, and return with everything marked
C     as unique in GenBy.
C
      If (NrOps .eq. -1) then
C         PtGrp = 'C1'
         Return
      EndIf
 9600 Format (' @SAVORI-W, Unknown point group ',A,'. Using C1')
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     If there are no non-trivial operations in the group, the
C     "right thing" is for GenBy to have everything as unique,
C     which it is, so we can return, printing the "final" GenBy
C     if required.
C
      If (NrOps .eq. 0) Return
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Generate the reference permutation list to compare with later.
C     Put resulting coordinates in ScrQ because we don't need them -
C     only the permutation list.
C
      Call SortC (NAtms, Q, AtNr, ScrQ, RefOrd, ScrQ(3*NAtms+1))
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Look for a xz- or yz-plane which maps one center into another.
C
      Do 1000 Iop = 1, NrOps
         If (OpTyp(Iop) .eq. 'P' .AND. OpAxis(Iop) .ne. 3) then
            Call DoSyOp ( OpTyp(Iop), OpOrd(Iop), J, OpAxis(Iop),
     $         NAtms, Q, ScrQ, Err, 0)
C
C           Handle any errors in DoSyOp
C
            If (Err .eq. 1) then
               Write (Luout, 9610) OpTyp(Iop), OpOrd(Iop), OpAxis(Iop)
               Goto 1000
            ElseIf (Err .ne. 0) then
               Write (Luout, 9620) OpTyp(Iop), OpOrd(Iop), OpAxis(Iop)
               Goto 1000
            EndIf
 9610       Format (' @SAVORI-W, Unknown symmetry operation ',
     $         A,'(',I3,') about ',I3,': Operation ignored.')
 9620       Format (' @SAVORI-W, Unidentified error during, ',
     $         'operation ',A,'(',I3,') about ',I3,': Op. ignored.')
C
C           Generate the new permutation list & update GenBy.
C
            Call SortC (NAtms, ScrQ, AtNr, ScrQ, NewOrd,
     $         ScrQ(3*NAtms+1))
C
            Call MakGen ( NAtms, RefOrd, NewOrd, GenBy)
C
C     See if this operation maps one center onto another. If so, get
C     the centers, and the normalized vector between them.  This vector
C     should be in either the x or y direction.
C
            Do 1100 i = 1, NAtms
               If (GenBy(i) .ne. 0) then
                  At1 = i
                  At2 = GenBy(i)
                  Call VAdd(OriVec, Q(3*(At2-1)+1), Q(3*(At1-1)+1),3,
     $                            -1.D0)
                  Call Normal(OriVec,3)
                  XYOri = NInt(OriVec(1)) + 2*NInt(OriVec(2))
     $               + 3*NInt(OriVec(3))
cYAU                  Write (6,*) 'OriVec is ',OriVec, XYOri
                  Return
               Endif
 1100       Continue
         EndIf
 1000 Continue
C
C     If we leave this way, there are no equivalences we can use.
C     This is possible only for cases in which we don't need to worry
C     about x <--> y switching anyway, so its okay.
C
      Return
      End

      program getcrec
      implicit none

c ARGUMENTS
      integer iLength
      character*(11) szDest

c INTERNAL VARIABLES
      integer i, iNdx, nLeft, iBuf(3), iRecLen

c ----------------------------------------------------------------------

c     This should read 'Hello World '
      iLength = 11
      iBuf(1) = 1819043144
      iBuf(2) = 1867980911
      iBuf(3) =  543452274

c   o iNdx is the moving szDest index
      iNdx = 1

c   o iRecLen is the number of whole integers that contain szDest(1:iLength)
c     (residual handled later)
      iRecLen = iLength/4

c   o the format definition for reading whole integers into szDest
 10   format(a4)

c   o read from iBuf into szDest by whole integers
      if (iRecLen.gt.0) then
         do i = 1, iRecLen
            write(szDest(iNdx:iNdx+4-1),10) iBuf(i)
            iNdx = iNdx + 4
         end do
      end if

c   o pick up the slack
      nLeft = iand(iLength,4-1)
      if (nLeft.ne.0) then
         iRecLen = iRecLen + 1
         do i = 1, nLeft
            write(szDest(iNdx:iNdx),'(a1)') iBuf(iRecLen)
            iBuf(iRecLen) = rshift(iBuf(iRecLen),8)
            iNdx = iNdx + 1
         end do
      end if

      print *, '->',szDest(1:iLength),'<-'

c     end subroutine getcrec
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ROTATE_AXIAL_NBO
     +
     +                    ( NBAS,NATOM,
     +                      NBOSIZE,ROTSIZE,
     +                      NXA,NXBA,
     +                      OFFX,
     +                      OFFLP,OFFBD,OFFEP,
     +                      OFFAB,OFFRY,OFFRR,
     +                      ATXIDX,ATXOFF,
     +                      IDXSYM,
     +                      RING,NRING,RINGSZ,
     +                      SYMCEN,
     +                      LSYMACC,QSYMACC,
     +                      NPAIR,
     +                      IDXDEG,
     +                      NBOBD,
     +                      BDNCEN,BDCEN,
     +                      HYB,
     +                      ROT,ROTIDX,
     +                      SYMCRIT,
     +                      P,
     +                      LOCAL,
     +                      W,Q,
     +                      XVEC,
     +                      XMAT,
     +
     +                              SYMNBO,
     +                              SLTYPE,
     +                              BDNBAS,
     +                              BDBAS,
     +                              B,
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ROTATE_AXIAL_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine rotates an axial set (two) of two-fold
C                interaction order degenerate atomic NBOs, such that
C                they become equivalent under all axial operations.
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    ROTSIZE      =  maximum # of NHOs that will be
C                                    allowed to form NBO hybrids for
C                                    rotationally invariant atomic NBO
C                                    construction.
C                    NXA          =  total # of atomic x-type NBO atoms.
C                    NXBA         =  # of atomic x-type NBOs on one of
C                                    the axially related atoms.
C                    OFFX         =  absolute offset index for present
C                                    x-type NBOs. This index indicates
C                                    the totallity of NBOs before the
C                                    x-type NBO set.
C                    OFFxy        =  absolute offset indices for x-type
C                                    NBOs. These indices indicate the
C                                    totallity of x-type NBOs before the
C                                    x-type NBO set (xy:LP=Lone-pair,
C                                    BD=Bond, EP=Empty-pair, AB=Anti-
C                                    bond, RY,RR=Rydberg types)
C                    ATXIDX (A)   =  atomic index for x-type NBO atom A.
C                    ATXOFF (A)   =  index offset for atomic NBOs for
C                                    x-type NBO atom A. This index is
C                                    equal to the total number of atomic
C                                    x-type NBOs on all x-type NBO atoms
C                                    preceeding x-type NBO atom A.
C                    IDXSYM (1,2) =  both x-type NBO atomic indices
C                                    which are axially symmetry related.
C                                    Note: this is a local index within
C                                    the x-type NBO atomic set, not the
C                                    overall atomic index of the entire
C                                    molecule.
C                    RING (A,B)   =  contains all atomic indices A of
C                                    those symmetry related sets that
C                                    have equal distance from center
C                                    B and are of maximum size.
C                    NRING (B)    =  contains the # of sets of maximum
C                                    size related to center B.
C                    RINGSZ (B)   =  contains the maximum size of the
C                                    above found sets related to
C                                    center B.
C                    SYMCEN       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    NPAIR        =  local atomic index of the two-fold
C                                    weight degenerate atomic NBOs.
C                                    For each atom the local atomic
C                                    indices for the degenerate pair
C                                    are NPAIR and NPAIR+1.
C                    IDXDEG       =  array that will be used to store
C                                    the NBO indices that will be
C                                    rotated (for example, if sp2
C                                    hybrids will be constructed, this
C                                    array will indicate all the NBO
C                                    indices for the s and the two p
C                                    NBOs).
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th atomic x-type NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/
C                                    NRB. Note that the # of NHB-bonds
C                                    might be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for J-th
C                                    bond. The bond order is NHB-bonds/
C                                    NCB/NRB. Note that the # of
C                                    NHB-bonds might be < NHB size.
C                    HYB          =  will contain the NBO hybridization
C                                    matrix.
C                    ROT          =  will contain the NBO rotation
C                                    matrix.
C                    ROTIDX       =  will contain the NBO rotation
C                                    indices.
C                    SYMCRIT      =  symmetry interaction criterion.
C                                    Any absolute occupation matrix
C                                    interaction element between
C                                    symmetrized NBOs and a degenerate
C                                    set of NBOs is assumed to be zero
C                                    if it falls below this value.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs.
C                    W            =  complete NBO weight vector at
C                                    present stage of symmetrization.
C                    Q            =  complete NBO interaction order
C                                    vector at present stage of
C                                    symmetrization.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    SYMNBO       =  initial integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  initial integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  initial # of basis functions (NHOs)
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  initial NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    before symmetrization.
C
C
C                  Output:
C
C                    SYMNBO       =  updated integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  updated integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  modified # of basis functions
C                                    (NHOs) for J-th bond. The bond
C                                    order is NHB-bonds/NCB/NRB. Note
C                                    that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDBAS (I,J)  =  modified I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  modified NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    after symmetrization.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     HYBRID
         LOGICAL     MAXIMZE
         LOGICAL     SAVEC,SAVEP
         LOGICAL     ZEROSYM

         INTEGER     AXIAL
         INTEGER     B1ST,BOND
         INTEGER     CENTER
         INTEGER     D,I,J,N,S
         INTEGER     LOBE
         INTEGER     MROT,NROT
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NBOSIZE,ROTSIZE
         INTEGER     NHO
         INTEGER     NLO__ANGULAR_MOMENTUM_NBO
         INTEGER     NPAIR
         INTEGER     NSYM
         INTEGER     NXA,NXBA
         INTEGER     OFFA,OFFX
         INTEGER     OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR
         INTEGER     POS
         INTEGER     SYMSIZE,SYMSETS
         INTEGER     TOTSYM

         INTEGER     ATXIDX  (1:NXA  )
         INTEGER     ATXOFF  (1:NXA  )
         INTEGER     BDNBAS  (1:NBAS )
         INTEGER     BDNCEN  (1:NBAS )
         INTEGER     IDXDEG  (1:NXBA )
         INTEGER     IDXSYM  (1:2    )
         INTEGER     NBOBD   (1:NBAS )
         INTEGER     NRING   (1:NATOM)
         INTEGER     RINGSZ  (1:NATOM)
         INTEGER     ROTIDX  (1:NBAS )
         INTEGER     SLTYPE  (1:NBAS )
         INTEGER     SYMCEN  (1:NATOM)
         INTEGER     SYMNBO  (1:NBAS )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS )
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS )
         INTEGER     RING    (1:NATOM  ,1:NATOM)

         DOUBLE PRECISION  HIJ
         DOUBLE PRECISION  LSYMACC,QSYMACC
         DOUBLE PRECISION  R11,R12,R21,R22
         DOUBLE PRECISION  SYMCRIT
         DOUBLE PRECISION  X,Y
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  LOCAL (1:NBAS)
         DOUBLE PRECISION  Q     (1:NBAS)
         DOUBLE PRECISION  W     (1:NBAS)
         DOUBLE PRECISION  XVEC  (1:NBAS+NBAS)

         DOUBLE PRECISION  B     (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  C     (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  HYB   (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  P     (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  ROT   (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  XMAT  (1:NBAS   ,1:ROTSIZE)

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...set some data.
C
C
         SAVEC = .TRUE.
         SAVEP = .TRUE.
C
C
C             ...loop over both axial centers.
C
C
         DO AXIAL = 1,2

            CENTER = ATXIDX (IDXSYM (AXIAL))
            OFFA   = ATXOFF (IDXSYM (AXIAL))

            SYMSIZE = RINGSZ (CENTER)

            IF (SYMSIZE.LT.3) THEN
                WRITE (*,*) ' Symmetry conflict in axial case! '
                WRITE (*,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
                WRITE (*,*) ' nlo__rotate_axial_nbo '
                WRITE (1,*) ' Symmetry conflict in axial case! '
                WRITE (1,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
                WRITE (1,*) ' nlo__rotate_axial_nbo '
                STOP
            END IF

            SYMSETS = NRING (CENTER)
            NSYM = SYMSIZE * SYMSETS

            DO N = 1,NSYM
               SYMCEN (N) = RING (N,CENTER)
            END DO
C
C
C             ...rotate the degenerate pair first.
C
C
            D = OFFX + OFFA + NPAIR

            CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                 ( NBAS,NBAS,
     +                   NBAS,NBAS,
     +                   NBAS,2,
     +                   NBAS,2,
     +                   NBAS,
     +                   NBAS,NBAS,2,
     +                   0,0,
     +                   SAVEC,SAVEP,SAVEC,
     +                   C,P,C (1,D),
     +                   XVEC,
     +
     +                            XMAT )
     +
     +
            CALL  NLO__FIND_ROTATION_NBO_INDICES
     +
     +                 ( NBAS,NATOM,2,
     +                   NBOSIZE,
     +                   OFFLP,OFFBD,OFFEP,
     +                   OFFAB,OFFRY,OFFRR,
     +                   CENTER,
     +                   SYMSIZE,SYMSETS,SYMCEN,
     +                   SYMNBO,
     +                   QSYMACC,LSYMACC,
     +                   BDNCEN,BDCEN,
     +                   NBOBD,
     +                   SYMCRIT,
     +                   XMAT,
     +                   LOCAL,
     +                   Q,
     +
     +                            ZEROSYM,
     +                            NROT,
     +                            ROTIDX )
     +
     +
            IF (ZEROSYM) THEN
                WRITE (*,*) ' NO SYMMETRY INTERACTION! '
                WRITE (*,*) ' Rotation failed! '
                RETURN
            END IF

            IF (NROT.EQ.0) THEN
                WRITE (*,*) ' Cannot establish NBO rotation set! '
                WRITE (*,*) ' CENTER = ',CENTER
                WRITE (*,*) ' nlo__rotate_axial_nbo '
                WRITE (1,*) ' Cannot establish NBO rotation set! '
                WRITE (1,*) ' CENTER = ',CENTER
                WRITE (1,*) ' nlo__rotate_axial_nbo '
                STOP
            END IF

            LOBE = ROTIDX (1)
            X    = XMAT (LOBE,1)
            Y    = XMAT (LOBE,2)

            MAXIMZE = .TRUE.

            CALL  NLO__FIND_2DEG_AXIAL_ROTMAT
     +
     +                 ( X,Y,
     +                   MAXIMZE,
     +
     +                           R11,R12,
     +                           R21,R22 )
     +
     +
            DO N = 1,NBAS
               X = R11 * C (N,D) + R21 * C (N,D+1)
               Y = R12 * C (N,D) + R22 * C (N,D+1)
               C (N,D  ) = X
               C (N,D+1) = Y
            END DO

            ROT (1,1) = R11
            ROT (2,1) = R21
            ROT (1,2) = R12
            ROT (2,2) = R22

            HYB (1,1) = ONE
            HYB (2,1) = ZERO
            HYB (1,2) = ZERO
            HYB (2,2) = ONE

            MROT = 2

            IDXDEG (1) = D
            IDXDEG (2) = D + 1
C
C
C             ...form the necessary hybrids, if possible and
C                necessary. Hybrids for 3-fold symmetry.
C
C
            IF (SYMSIZE.EQ.3) THEN

                IF (AXIAL.EQ.1) THEN

                    TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                            ( NXBA,
     +                              SLTYPE (OFFX+OFFA+1),
     +                              NPAIR,NPAIR+1,
     +                              0,
     +                              1,
     +                              QSYMACC,LSYMACC,
     +                              W (OFFX+OFFA+1),
     +                              Q (OFFX+OFFA+1),
     +                              LOCAL (OFFX+OFFA+1) )
     +
     +
                    HYBRID = TOTSYM .NE. 0

                    IF (HYBRID .AND. ROTSIZE.LT.3) THEN
                        WRITE (*,*) ' Cannot form sp2 hybrids! '
                        WRITE (*,*) ' ROTSIZE = ',ROTSIZE
                        WRITE (*,*) ' nlo__rotate_axial_nbo '
                        WRITE (1,*) ' Cannot form sp2 hybrids! '
                        WRITE (1,*) ' ROTSIZE = ',ROTSIZE
                        WRITE (1,*) ' nlo__rotate_axial_nbo '
                        STOP
                    END IF
                END IF

                IF (HYBRID) THEN

                    S = OFFX + OFFA + TOTSYM

                    CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +                         ( ROTSIZE,ROTSIZE,
     +                           3,3,
     +
     +                                    ROT )
     +
     +

                    ROT (2,2) = R11
                    ROT (3,2) = R21
                    ROT (2,3) = R12
                    ROT (3,3) = R22

                    CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                         ( NBAS,NBAS,
     +                           NBAS,NBAS,
     +                           NBAS,1,
     +                           NBAS,1,
     +                           NBAS,
     +                           NBAS,NBAS,1,
     +                           0,0,
     +                           SAVEC,SAVEP,SAVEC,
     +                           C,P,C (1,S),
     +                           XVEC,
     +
     +                                    XMAT )
     +
     +
                    X = XMAT (LOBE,1)

                    IF (X.LT.ZERO) THEN
                        DO N = 1,NBAS
                           C (N,S) =  - C (N,S)
                        END DO
                        ROT (1,1) = - ONE
                    ELSE
                        ROT (1,1) = ONE
                    END IF

                    CALL  NLO__FORM_SP2_NBO
     +
     +                         ( NBAS,
     +
     +                                  HYB (1,1),HYB (1,2),HYB (1,3),
     +                                  HYB (2,1),HYB (2,2),HYB (2,3),
     +                                  HYB (3,1),HYB (3,2),HYB (3,3),
     +                                  C (1,S),
     +                                  C (1,D) )
     +
     +
                    MROT = 3

                    IDXDEG (1) = S
                    IDXDEG (2) = D
                    IDXDEG (3) = D + 1

                    SLTYPE (S  ) = -1
                    SLTYPE (D  ) = -1
                    SLTYPE (D+1) = -1

                ELSE

                    WRITE (*,*) ' No s function for sp2 hybrid! '
                    WRITE (*,*) ' Occuring at CENTER = ',CENTER
                    WRITE (*,*) ' Symmetry reduction C3v -> C2v! '
                    WRITE (1,*) ' No s function for sp2 hybrid! '
                    WRITE (1,*) ' Occuring at CENTER = ',CENTER
                    WRITE (1,*) ' Symmetry reduction C3v -> C2v! '

                END IF
C
C
C             ...No hybrids for 4-fold symmetry!.
C
C
            ELSE IF (SYMSIZE.GT.4) THEN

                WRITE (*,*) ' Cannot deal with SYMSIZE > 4! '
                WRITE (*,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
                WRITE (*,*) ' nlo__rotate_axial_nbo '
                WRITE (1,*) ' Cannot deal with SYMSIZE > 4! '
                WRITE (1,*) ' CENTER,SYMSIZE = ',CENTER,SYMSIZE
                WRITE (1,*) ' nlo__rotate_axial_nbo '
                STOP

            END IF
C
C
C             ...form the NBO coefficient matrix in NHO basis.
C
C
            DO J = 1,MROT
               POS = IDXDEG (J)
               DO N = 1,MROT
                  B (N,POS) = ZERO
               END DO
            END DO

            DO J = 1,MROT
               POS = IDXDEG (J)
               DO I = 1,MROT
                  HIJ = HYB (I,J)
                  DO N = 1,MROT
                     B (N,POS) = B (N,POS) + HIJ * ROT (N,I)
                  END DO
               END DO
            END DO
C
C
C             ...the matrices containing details about the new NBOs.
C
C
            POS = IDXDEG (1)
            B1ST = NBOBD (POS)
            BDNBAS (B1ST) = MROT

            DO I = 1,MROT
               POS = IDXDEG (I)
               BOND = NBOBD (POS)
               NHO = BDBAS (1,BOND)
               BDBAS (I,B1ST) = NHO
            END DO

            DO J = 2,MROT
               POS = IDXDEG (J)
               BOND = NBOBD (POS)
               BDNBAS (BOND) = MROT
               DO I = 1,MROT
                  BDBAS (I,BOND) = BDBAS (I,B1ST)
               END DO
            END DO
C
C
C             ...mark new NBOs as symmetry adapted.
C
C
            DO I = 1,MROT
               POS = IDXDEG (I)
               SYMNBO (POS) = 2
            END DO
C
C
C             ...next axial center.
C
C
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

c initialization routine for BWCC parallelization

      subroutine bwparinit
      implicit none
#include "bwcc.com"
#ifdef MPI
#include "mpif.h"
       integer ierror
#endif

#ifdef MPI
cjp@@@ HANDLING OF STDOUT NOT TO GET MIXED?!!!@@@@@@@
      call mpi_init(ierror)
      call mpi_comm_rank(MPI_COMM_WORLD,myproc,ierror)
      myproc = myproc + 1
      call mpi_comm_size(MPI_COMM_WORLD,nproc,ierror)
cYAU      write(*,*) '@BWPARINIT: nproc, myproc ',nproc,myproc
cjp change working directory appropriatelly
cjp first assuming common working directory for all processes
      if (nproc.gt.1) call bwchdir(myproc)
#else
      nproc  = 1
      myproc = 1
#endif

      return
      end

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Integer Function IAMAX( N, IX, IncX)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: iamax.f,v 1.1.1.1 2003/04/02 19:21:47 aces Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     iamax -- maximum absolute value of an integer vector
C
C SYNOPSIS
      Integer N, IX(1), IncX
C
C ARGUMENTS
C     N       Number of elements to check (input)
C     IX      Integer vector (input)
C     IncX    Skip distance between elements of IX (input)
C
C DESCRIPTION
C     Returns the maximum absolute value of the vector.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
C     IPtr    Pointer to current element of IX
C     j       Counter over number of "actIXe" elements
C
      Integer IPtr, j
C
C     Initialize the max
C
      IAMax = 0
C
C     Get out if there is no work
C
      If (N .le. 0) Return
C
C     Handle increment = 1 differently
C
      If (IncX .eq. 1) then
         Do 100 IPtr = 1, N
            IAMax = Max(IAMax, Abs(IX(IPtr)))
 100     Continue
      Else
         IPtr = 1
         If (IncX .lt. 0) IPtr = (-N+1) * IncX + 1
         Do 200 j = 1, N
            IAMax = Max(IAMax, Abs(IX(IPtr)))
            IPtr = IPtr + IncX
 200     Continue
      EndIf
C
      Return
      End

#include "f_types.h"
c#define _ABORT_ON_OVERLAP

      subroutine xcopy(n,dx,incx,dy,incy)
      double precision dx(*),dy(*)
      integer i,incx,incy,ix,iy,n
      F_ADR c_adr, z
      external c_adr
      if(n.le.0)return
      if ((incx.eq.1).and.(incy.eq.1)) then
         if (c_adr(dy).eq.c_adr(dx)) return
#ifdef _DEBUG
c      o complain about overlapping data
#ifdef _PTRS_ARE_WORDS
c        This might be a defect. I am assuming c_adr returns 64-bit words.
c        I could divide by iintfp, but that would require including /MACHSP/,
c        which means xcopy would have to be moved out of the tools library.
         z = abs(c_adr(dx)-c_adr(dy))
#else
         z = abs(c_adr(dx)-c_adr(dy))/8
#endif
         if (z.lt.n) then
            print '(/)'
            print *, '@XCOPY: WARNING - the source and destination ',
     &               'data overlap'
            print *, '        src address: ',c_adr(dx)
            print *, '        dst address: ',c_adr(dy)
            print *, '        difference:  ',z,' doubles'
            print *, '        data length: ',n,' doubles'
            print '(/)'
#ifdef _ABORT_ON_OVERLAP
            call c_abort
#endif
         end if
#endif
         call c_memmove(dy,dx,n*8)
      else
         ix = 1
         iy = 1
         if(incx.lt.0)ix = (-n+1)*incx + 1
         if(incy.lt.0)iy = (-n+1)*incy + 1
         do i = 1,n
           dy(iy) = dx(ix)
           ix = ix + incx
           iy = iy + incy
         end do
      end if
      return
      end

c#define _ABORT_ON_OVERLAP

      subroutine xcopy(n,dx,incx,dy,incy)
      double precision dx(*),dy(*)
      integer i,incx,incy,ix,iy,n
      INTEGER c_adr, z
      external c_adr
      if(n.le.0)return
      if ((incx.eq.1).and.(incy.eq.1)) then
         if (c_adr(dy).eq.c_adr(dx)) return
         call c_memmove(dy,dx,n*8)
      else
         ix = 1
         iy = 1
         if(incx.lt.0)ix = (-n+1)*incx + 1
         if(incy.lt.0)iy = (-n+1)*incy + 1
         do i = 1,n
           dy(iy) = dx(ix)
           ix = ix + incx
           iy = iy + incy
         end do
      end if
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ROTATE_ATOM_OGROUP_NBO
     +
     +                    ( NBAS,NATOM,NDEG,
     +                      NBOSIZE,ROTSIZE,
     +                      NXBA,
     +                      OFFX,OFFA,
     +                      OFFLP,OFFBD,OFFEP,
     +                      OFFAB,OFFRY,OFFRR,
     +                      CENTER,
     +                      NCUBE,NOCTA,
     +                      PLATO,
     +                      SYMCEN,
     +                      LSYMACC,QSYMACC,
     +                      FIRST,
     +                      IDXDEG,
     +                      NBOBD,
     +                      BDNCEN,BDCEN,
     +                      HYB,
     +                      ROT,ROTIDX,
     +                      SYMCRIT,
     +                      P,
     +                      LOCAL,
     +                      W,Q,
     +                      XVEC,
     +                      XMAT,
     +
     +                              SYMNBO,
     +                              SLTYPE,
     +                              BDNBAS,
     +                              BDBAS,
     +                              B,
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ROTATE_ATOM_OGROUP_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine rotates a degenerate set of NBOs sitting
C                at the center of octahedral symmetry. The possible
C                background atomic sets used for performing this
C                rotation can be either chosen from the octahedrally or
C                cubically related centers, where the former posses
C                C4v and the latter C3v site symmetry. The following
C                Oh -> C4v and C3v irrep decomposition table shows what
C                will be expected:
C
C
C                         Oh   |    C4v   |    C3v
C                      ------------------------------
C                         A1g  |     A1   |    A1
C                         A2g  |     B1   |    A2
C                          Eg  |  A1 + B1 |     E
C                         T1g  |  A2 + E  |  A2 + E
C                         T2g  |  B2 + E  |  A1 + E
C                         A1u  |     A2   |    A2
C                         A2u  |     B2   |    A1
C                          Eu  |  A2 + B2 |     E
C                         T1u  |  A1 + E  |  A1 + E
C                         T2u  |  B1 + E  |  A2 + E
C
C
C                From this table we can construct two tables, showing
C                which octahedral degenerate NBO sets can have (+)
C                or cannot have (-) interactions with the octahedral
C                (C4v site symmetry) and cubical (C3v site symmetry)
C                background:
C
C
C
C                    C4v background | Oh-irrep: Eg T1g T2g Eu T1u T2u
C                  ----------------------------------------------------
C                    A1 (s,pz)      |           +   -   -  -   +   -
C                    A2 (g,h,i,...) |           -   +   -  +   -   -
C                    B1 (dx^2-y^2)  |           +   -   -  -   -   +
C                    B2 (dxy)       |           -   -   +  +   -   -
C                     E (px,py)     |           -   +   +  -   +   +
C
C
C
C                    C3v background | Oh-irrep: Eg T1g T2g Eu T1u T2u
C                  ----------------------------------------------------
C                    A1 (s,pz)      |           -   -   +  -   +   -
C                    A2 (f,g,h,...) |           -   +   -  -   -   +
C                  A1+E (sp2-hybrid)|           +   +   +  +   +   +
C
C
C
C                Both tables also show what type of C4v and C3v irreps
C                will occur for specific atomic functions used on those
C                sites. For example, when s,p,d,f functions are used
C                on one C4v site we expect all C4v irreps to occur,
C                except the A2 irrep, which will only occur if g- or
C                higher-angular functions are used. Similarly A2 irreps
C                of C3v will only occur when including f- or higher
C                atomic functions.
C
C                Another table is also useful, showing decomposition
C                of atomic angular momentum levels into Oh irreps:
C
C
C                        atomic level  |          Oh irreps
C                      -----------------------------------------------
C                             s        |             A1g
C                             p        |             T1u
C                             d        |           Eg + T2g
C                             f        |        A2u + T1u + T2u
C                             g        |     A1g + Eg + T1g + T2g
C                             h        |        Eu + 2T1u + T2u
C                             i        |  A1g + A2g + Eg + T1g + 2T2g
C
C
C                We have next to distinguish two cases:
C
C                  i) 2-fold degenerate NBOs
C
C                     These can be only of Eg and Eu type and can
C                     occur if the basis set on the center atom has
C                     at least respectively d-type and h-type functions.
C                     In the majority of the cases we will thus deal
C                     with Eg type degenerate NBOs. Eu type NBOs can
C                     be checked by the odd smallest angular momentum
C                     component presence in these NBOs.
C
C                     Procedure for the Eg type NBOs:
C
C                       a) Rotate the Eg pair to one of the background
C                          sites, such that the first Eg NBO interaction
C                          with this site is either minimized (C4v
C                          octahedral A1 or B1 site symmetry) or
C                          maximized (C3v cubical A1+E sp2 hybrid site
C                          symmetry).
C
C                       b) Once appropriately rotated, form sd2
C                          hybrids to achieve octahedral symmetry.
C                           
C
C                 ii) 3-fold degenerate NBOs
C
C                     These can be of T1g,T2g,T1u and T2u type. Both
C                     background types C4v and C3v are checked for
C                     rotation, with the octahedral C4v preferred over
C                     the cubical C3v (less background points for the
C                     former!). The 1-norm of the interaction occupation
C                     matrix between the background and the 3-fold
C                     degenerate NBOs is then:
C
C                          1-norm minimized -> for C4v background
C                          1-norm maximized -> for C3v background
C                     
C
C
C
C                  Input:
C 
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    NDEG         =  # of degenerate NBOs. Can only
C                                    be equal to 2,3,4 or 5.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    ROTSIZE      =  maximum # of NHOs that will be
C                                    allowed to form NBO hybrids for
C                                    rotationally invariant atomic NBO
C                                    construction.
C                    NXBA         =  # of atomic x-type NBOs on the
C                                    central atom treated here.
C                    OFFX         =  absolute offset index for present
C                                    x-type NBOs. This index indicates
C                                    the totallity of NBOs before the
C                                    x-type NBO set.
C                    OFFA         =  local atomic offset index for
C                                    present atomic x-type NBOs. This
C                                    index is equal to the total number
C                                    of atomic x-type NBOs on all
C                                    x-type NBO atoms preceeding x-type
C                                    NBO atom A.
C                    OFFxy        =  absolute offset indices for x-type
C                                    NBOs. These indices indicate the
C                                    totallity of x-type NBOs before the
C                                    x-type NBO set (xy:LP=Lone-pair,
C                                    BD=Bond, EP=Empty-pair, AB=Anti-
C                                    bond, RY,RR=Rydberg types)
C                    CENTER       =  atomic index of the center on which
C                                    NBO rotation will be performed
C                    NCUBE        =  contains the # of cubically related
C                                    center sets (size 8)
C                    NOCTA        =  contains the # of octahedrally
C                                    related center sets (size 6)
C                    PLATO (A,P)  =  contains all atomic indices A for
C                                    all cubically arranged centers
C                                    in groups of 8 (P = 1) and all
C                                    octahedrally arranged centers in
C                                    groups of 6 (P = 2).
C                    SYMCEN       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    FIRST        =  index of 1st degenerate NBO inside
C                                    the atomic NXBA-dimensional NBO set.
C                    IDXDEG       =  array that will be used to store
C                                    the NBO indices that will be
C                                    rotated (for example, if sd2
C                                    hybrids will be constructed, this
C                                    array will indicate all the NBO
C                                    indices for the s and the two d
C                                    NBOs).
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th atomic x-type NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/
C                                    NRB. Note that the # of NHB-bonds
C                                    might be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for J-th
C                                    bond. The bond order is NHB-bonds/
C                                    NCB/NRB. Note that the # of
C                                    NHB-bonds might be < NHB size.
C                    HYB          =  will contain the NBO hybridization
C                                    matrix.
C                    ROT          =  will contain the NBO rotation
C                                    matrix.
C                    ROTIDX       =  will contain the NBO rotation
C                                    indices.
C                    SYMCRIT      =  symmetry interaction criterion.
C                                    Any absolute occupation matrix
C                                    interaction element between
C                                    symmetrized NBOs and a degenerate
C                                    set of NBOs is assumed to be zero
C                                    if it falls below this value.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs.
C                    W            =  complete NBO weight vector at
C                                    present stage of symmetrization.
C                    Q            =  complete NBO interaction order
C                                    vector at present stage of
C                                    symmetrization.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    SYMNBO       =  initial integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  initial integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  initial # of basis functions (NHOs)
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  initial NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    before symmetrization.
C
C
C                  Output:
C
C                    SYMNBO       =  updated integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  updated integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  modified # of basis functions
C                                    (NHOs) for J-th bond. The bond
C                                    order is NHB-bonds/NCB/NRB. Note
C                                    that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDBAS (I,J)  =  modified I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  modified NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    after symmetrization.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     CUBICAL
         LOGICAL     HYBRID
         LOGICAL     MAXIMZE
         LOGICAL     NORMLZE
         LOGICAL     ROT2DEG,ROT3DEG
         LOGICAL     SAVEC,SAVEP
         LOGICAL     ZEROSYM

         INTEGER     BOND1,BOND2,BOND3
         INTEGER     CENTER
         INTEGER     D,N,S
         INTEGER     D1,D2
         INTEGER     FIRST
         INTEGER     H1,H2,H3
         INTEGER     IDX
         INTEGER     LOBE
         INTEGER     NROT
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NBOSIZE,ROTSIZE
         INTEGER     NCUBE,NOCTA
         INTEGER     NHO1,NHO2,NHO3
         INTEGER     NDEG
         INTEGER     NITER
         INTEGER     NLO__ANGULAR_MOMENTUM_NBO
         INTEGER     NSYM
         INTEGER     NXBA
         INTEGER     OFFA,OFFX
         INTEGER     OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR
         INTEGER     SYMSIZE,SYMSETS
         INTEGER     T1,T2,T3
         INTEGER     TOTSYM

         INTEGER     BDNBAS  (1:NBAS )
         INTEGER     BDNCEN  (1:NBAS )
         INTEGER     IDXDEG  (1:NXBA )
         INTEGER     NBOBD   (1:NBAS )
         INTEGER     ROTIDX  (1:NBAS )
         INTEGER     SLTYPE  (1:NBAS )
         INTEGER     SYMCEN  (1:NATOM)
         INTEGER     SYMNBO  (1:NBAS )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS )
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS )
         INTEGER     PLATO   (1:NATOM  ,1:2    )

         DOUBLE PRECISION  LSYMACC,QSYMACC
         DOUBLE PRECISION  R11,R12,R21,R22
         DOUBLE PRECISION  SYMCRIT
         DOUBLE PRECISION  X,Y,Z
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  LOCAL (1:NBAS)
         DOUBLE PRECISION  Q     (1:NBAS)
         DOUBLE PRECISION  W     (1:NBAS)
         DOUBLE PRECISION  XVEC  (1:NBAS+NBAS)

         DOUBLE PRECISION  B     (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  C     (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  HYB   (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  P     (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  ROT   (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  XMAT  (1:NBAS   ,1:ROTSIZE)

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check symmetry consistency. Since this routine deals
C                with the octahedral NBOs, we know that deg = 2 or 3
C                always. Otherwise stop with message.
C
C
         IF (NDEG.NE.2 .AND. NDEG.NE.3) THEN
             WRITE (*,*) ' Degeneracy conflict for atomic ogroup case! '
             WRITE (*,*) ' NDEG = ',NDEG
             WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
             WRITE (1,*) ' Degeneracy conflict for atomic ogroup case! '
             WRITE (1,*) ' NDEG = ',NDEG
             WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
             STOP
         END IF
C
C
C             ...check dimensions.
C
C
         IF (NDEG.GT.ROTSIZE) THEN
             WRITE (*,*) ' Degeneracy size too large! '
             WRITE (*,*) ' NDEG,ROTSIZE = ',NDEG,ROTSIZE
             WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
             WRITE (1,*) ' Degeneracy size too large! '
             WRITE (1,*) ' NDEG,ROTSIZE = ',NDEG,ROTSIZE
             WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
             STOP
         END IF
C
C
C             ...set some data.
C
C
         SAVEC = .TRUE.
         SAVEP = .TRUE.
C
C
C             ...handle 2-fold degeneracy, if any. Try to use first
C                the octahedrally arranged centers, if any, followed
C                by the cubically arranged ones.
C
C
         IF (NDEG.EQ.2) THEN

             D = OFFX + OFFA + FIRST

             CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                  ( NBAS,NBAS,
     +                    NBAS,NBAS,
     +                    NBAS,2,
     +                    NBAS,2,
     +                    NBAS,
     +                    NBAS,NBAS,2,
     +                    0,0,
     +                    SAVEC,SAVEP,SAVEC,
     +                    C,P,C (1,D),
     +                    XVEC,
     +
     +                             XMAT )
     +
     +
             ROT2DEG = .FALSE.

C             GOTO 1234

             IF (NOCTA.NE.0) THEN

                 SYMSIZE = 6
                 SYMSETS = NOCTA

                 NSYM = SYMSIZE * SYMSETS

                 DO N = 1,NSYM
                    SYMCEN (N) = PLATO (N,2)
                 END DO

                 CALL  NLO__FIND_ROTATION_NBO_INDICES
     +
     +                      ( NBAS,NATOM,2,
     +                        NBOSIZE,
     +                        OFFLP,OFFBD,OFFEP,
     +                        OFFAB,OFFRY,OFFRR,
     +                        CENTER,
     +                        SYMSIZE,SYMSETS,SYMCEN,
     +                        SYMNBO,
     +                        QSYMACC,LSYMACC,
     +                        BDNCEN,BDCEN,
     +                        NBOBD,
     +                        SYMCRIT,
     +                        XMAT,
     +                        LOCAL,
     +                        Q,
     +
     +                                 ZEROSYM,
     +                                 NROT,
     +                                 ROTIDX )
     +
     +
                 ROT2DEG = .NOT.ZEROSYM

                 IF (ROT2DEG) THEN
                     WRITE (*,*) ' Using 2-deg octahedral background! '
                     IF (NROT.EQ.0) THEN
                         WRITE (*,*) ' No 2-deg ogroup NBO rot set! '
                         WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                         WRITE (1,*) ' No 2-deg ogroup NBO rot set! '
                         WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                         STOP
                     END IF
                 END IF
             END IF

C             GOTO 12345

 1234        IF (.NOT.ROT2DEG .AND. (NCUBE.NE.0)) THEN

                 SYMSIZE = 8
                 SYMSETS = NCUBE

                 NSYM = SYMSIZE * SYMSETS

                 DO N = 1,NSYM
                    SYMCEN (N) = PLATO (N,1)
                 END DO

                 CALL  NLO__FIND_ROTATION_NBO_INDICES
     +
     +                      ( NBAS,NATOM,2,
     +                        NBOSIZE,
     +                        OFFLP,OFFBD,OFFEP,
     +                        OFFAB,OFFRY,OFFRR,
     +                        CENTER,
     +                        SYMSIZE,SYMSETS,SYMCEN,
     +                        SYMNBO,
     +                        QSYMACC,LSYMACC,
     +                        BDNCEN,BDCEN,
     +                        NBOBD,
     +                        SYMCRIT,
     +                        XMAT,
     +                        LOCAL,
     +                        Q,
     +
     +                                 ZEROSYM,
     +                                 NROT,
     +                                 ROTIDX )
     +
     +
                 ROT2DEG = .NOT.ZEROSYM

                 IF (ROT2DEG) THEN
                     WRITE (*,*) ' Using 2-deg cubical background! '
                     IF (NROT.EQ.0) THEN
                         WRITE (*,*) ' No 2-deg ogroup NBO rot set! '
                         WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                         WRITE (1,*) ' No 2-deg ogroup NBO rot set! '
                         WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                         STOP
                     END IF
                 END IF
             END IF

12345        IF (.NOT.ROT2DEG) THEN
                 WRITE (*,*) ' Could not rotate 2-deg ogroup NBOs! '
                 WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                 WRITE (1,*) ' Could not rotate 2-deg ogroup NBOs! '
                 WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                 RETURN
             END IF

C
C
C             ...up to now, the 2-fold basis forming the E-irreps
C                is mixed. For example, the 2z*z-x*x-y*y and x*x-y*y
C                d-functions are randomly mixed, thus each of the
C                d-functions possesses variable amounts of the z*z
C                component. In order to form clean sd2 hybrids, we
C                have to unmix the d-functions such that the first
C                one is identified as the one depleted of any z*z
C                component. This is achieved by rotating both
C                d-functions such that the first has no interaction
C                with the first background point. This first d-function
C                is then taken as the pure x*x-y*y type function
C                and passed to the sd2 hybrid formation routine.
C                The same logic applies to the Eu-irreps, which
C                appear for the first time with h-functions and are
C                of the same form as those for the d-functions but
C                multiplied both be a x*y*z factor.
C
C
             LOBE = ROTIDX (1)
             X    = XMAT (LOBE,1)
             Y    = XMAT (LOBE,2)

             MAXIMZE = .FALSE.

             CALL  NLO__FIND_2DEG_AXIAL_ROTMAT
     +
     +                  ( X,Y,
     +                    MAXIMZE,
     +
     +                         R11,R12,
     +                         R21,R22 )
     +
     +
             DO N = 1,NBAS
                X = R11 * C (N,D) + R21 * C (N,D+1)
                Y = R12 * C (N,D) + R22 * C (N,D+1)
                C (N,D  ) = X
                C (N,D+1) = Y
             END DO
C
C
C             ...if possible, form the symmetric octahedral sd2
C                hybrids.
C
C
             HYBRID = .FALSE.

             TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                     ( NXBA,
     +                       SLTYPE (OFFX+OFFA+1),
     +                       FIRST,FIRST+1,
     +                       0,
     +                       1,
     +                       QSYMACC,LSYMACC,
     +                       W (OFFX+OFFA+1),
     +                       Q (OFFX+OFFA+1),
     +                       LOCAL (OFFX+OFFA+1) )
     +
     +
             HYBRID = TOTSYM .NE. 0

             IF (HYBRID) THEN

                 IF (ROTSIZE.LT.3) THEN
                     WRITE (*,*) ' Cannot form sd2 hybrids! '
                     WRITE (*,*) ' ROTSIZE = ',ROTSIZE
                     WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                     WRITE (1,*) ' Cannot form sd2 hybrids! '
                     WRITE (1,*) ' ROTSIZE = ',ROTSIZE
                     WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                     STOP
                 END IF

                 S = OFFX + OFFA + TOTSYM

                 ROT (1,1) = ZERO
                 ROT (2,1) = ZERO
                 ROT (3,1) = ZERO
                 ROT (1,2) = ZERO
                 ROT (2,2) = R11
                 ROT (3,2) = R21
                 ROT (1,3) = ZERO
                 ROT (2,3) = R12
                 ROT (3,3) = R22

                 CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                      ( NBAS,NBAS,
     +                        NBAS,NBAS,
     +                        NBAS,1,
     +                        NBAS,1,
     +                        NBAS,
     +                        NBAS,NBAS,1,
     +                        0,0,
     +                        SAVEC,SAVEP,SAVEC,
     +                        C,P,C (1,S),
     +                        XVEC,
     +
     +                                 XMAT )
     +
     +
                 X = XMAT (LOBE,1)

                 IF (X.LT.ZERO) THEN
                     DO N = 1,NBAS
                        C (N,S) =  - C (N,S)
                     END DO
                     ROT (1,1) = - ONE
                 ELSE
                     ROT (1,1) = ONE
                 END IF

                 CALL  NLO__FORM_SD2_NBO
     +
     +                      ( NBAS,
     +
     +                               HYB (1,1),HYB (1,2),HYB (1,3),
     +                               HYB (2,1),HYB (2,2),HYB (2,3),
     +                               HYB (3,1),HYB (3,2),HYB (3,3),
     +                               C (1,S),
     +                               C (1,D) )
     +
     +
                 H1 = S
                 H2 = D
                 H3 = D + 1

                 CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                      ( NBAS,NBAS,
     +                        NBAS,NBAS,
     +                        NBAS,1,
     +                        NBAS,1,
     +                        NBAS,
     +                        NBAS,NBAS,1,
     +                        0,0,
     +                        SAVEC,SAVEP,SAVEC,
     +                        C,P,C (1,S),
     +                        XVEC,
     +
     +                                 XMAT (1,1) )
     +
     +
                 CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                      ( NBAS,NBAS,
     +                        NBAS,NBAS,
     +                        NBAS,2,
     +                        NBAS,2,
     +                        NBAS,
     +                        NBAS,NBAS,2,
     +                        0,0,
     +                        SAVEC,SAVEP,SAVEC,
     +                        C,P,C (1,D),
     +                        XVEC,
     +
     +                                 XMAT (1,2) )
     +
     +
                 DO N = 1,NROT
                    IDX = ROTIDX (N)
                    XMAT (N,1) = XMAT (IDX,1)
                    XMAT (N,2) = XMAT (IDX,2)
                    XMAT (N,3) = XMAT (IDX,3)
                 END DO

                 CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                      ( 6,
     +                        ' P for sd2 orientation (atom,ogroup) ',
     +                        NBAS,3,
     +                        NROT,3,
     +                        XMAT )
     +
     +
C
C
C             ...form the hybrid NBO coefficient matrix in NHO basis and
C                the matrices containing details about the new NBOs.
C                Mark the new hybrid NBOs as symmetry adapted.
C
C
                 B (1,H1) =   ROT (1,1) * HYB (1,1)
     +                      + ROT (1,2) * HYB (2,1)
     +                      + ROT (1,3) * HYB (3,1)
                 B (2,H1) =   ROT (2,1) * HYB (1,1)
     +                      + ROT (2,2) * HYB (2,1)
     +                      + ROT (2,3) * HYB (3,1)
                 B (3,H1) =   ROT (3,1) * HYB (1,1)
     +                      + ROT (3,2) * HYB (2,1)
     +                      + ROT (3,3) * HYB (3,1)
                 B (1,H2) =   ROT (1,1) * HYB (1,2)
     +                      + ROT (1,2) * HYB (2,2)
     +                      + ROT (1,3) * HYB (3,2)
                 B (2,H2) =   ROT (2,1) * HYB (1,2)
     +                      + ROT (2,2) * HYB (2,2)
     +                      + ROT (2,3) * HYB (3,2)
                 B (3,H2) =   ROT (3,1) * HYB (1,2)
     +                      + ROT (3,2) * HYB (2,2)
     +                      + ROT (3,3) * HYB (3,2)
                 B (1,H3) =   ROT (1,1) * HYB (1,3)
     +                      + ROT (1,2) * HYB (2,3)
     +                      + ROT (1,3) * HYB (3,3)
                 B (2,H3) =   ROT (2,1) * HYB (1,3)
     +                      + ROT (2,2) * HYB (2,3)
     +                      + ROT (2,3) * HYB (3,3)
                 B (3,H3) =   ROT (3,1) * HYB (1,3)
     +                      + ROT (3,2) * HYB (2,3)
     +                      + ROT (3,3) * HYB (3,3)

                 BOND1 = NBOBD (H1)
                 BOND2 = NBOBD (H2)
                 BOND3 = NBOBD (H3)

                 NHO1 = BDBAS (1,BOND1)
                 NHO2 = BDBAS (1,BOND2)
                 NHO3 = BDBAS (1,BOND3)

                 BDNBAS (BOND1) = 3
                 BDNBAS (BOND2) = 3
                 BDNBAS (BOND3) = 3

                 BDBAS (1,BOND1) = NHO1
                 BDBAS (2,BOND1) = NHO2
                 BDBAS (3,BOND1) = NHO3
                 BDBAS (1,BOND2) = NHO1
                 BDBAS (2,BOND2) = NHO2
                 BDBAS (3,BOND2) = NHO3
                 BDBAS (1,BOND3) = NHO1
                 BDBAS (2,BOND3) = NHO2
                 BDBAS (3,BOND3) = NHO3

                 SYMNBO (H1) = 2
                 SYMNBO (H2) = 2
                 SYMNBO (H3) = 2

                 SLTYPE (H1) = -1
                 SLTYPE (H2) = -1
                 SLTYPE (H3) = -1

             ELSE

                 WRITE (*,*) ' No s function for sd2 hybrid! '
                 WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                 WRITE (*,*) ' O-group symmetry reduction will occur! '
                 WRITE (1,*) ' No s function for sd2 hybrid! '
                 WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                 WRITE (1,*) ' O-group symmetry reduction will occur! '

                 D1 = D
                 D2 = D + 1
C
C
C             ...form the 2-deg NBO coefficient matrix in NHO basis and
C                the matrices containing details about the new NBOs.
C                However, do not mark the 2-deg NBOs as symmetry adapted.
C
C
                 B (1,D1) = R11
                 B (2,D1) = R21
                 B (1,D2) = R12
                 B (2,D2) = R22

                 BOND1 = NBOBD (D1)
                 BOND2 = NBOBD (D2)

                 NHO1 = BDBAS (1,BOND1)
                 NHO2 = BDBAS (1,BOND2)

                 BDNBAS (BOND1) = 2
                 BDNBAS (BOND2) = 2

                 BDBAS (1,BOND1) = NHO1
                 BDBAS (2,BOND1) = NHO2
                 BDBAS (1,BOND2) = NHO1
                 BDBAS (2,BOND2) = NHO2

             END IF

         END IF
C
C
C             ...handle 3-fold degeneracy, if any. Try to use first
C                the octahedrally arranged centers, if any, followed
C                by the cubically arranged ones.
C
C
         IF (NDEG.EQ.3) THEN

             T1 = OFFX + OFFA + FIRST
             T2 = T1 + 1
             T3 = T2 + 1

             CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +                  ( NBAS,NBAS,
     +                    NBAS,NBAS,
     +                    NBAS,NDEG,
     +                    NBAS,NDEG,
     +                    NBAS,
     +                    NBAS,NBAS,3,
     +                    0,0,
     +                    SAVEC,SAVEP,SAVEC,
     +                    C,P,C (1,T1),
     +                    XVEC,
     +
     +                              XMAT )
     +
     +
             CUBICAL = .FALSE.
             ROT3DEG = .FALSE.

C             GOTO 2345

             IF (NOCTA.NE.0) THEN

                 SYMSIZE = 6
                 SYMSETS = NOCTA

                 NSYM = SYMSIZE * SYMSETS

                 DO N = 1,NSYM
                    SYMCEN (N) = PLATO (N,2)
                 END DO

                 CALL  NLO__FIND_ROTATION_NBO_INDICES
     +
     +                      ( NBAS,NATOM,3,
     +                        NBOSIZE,
     +                        OFFLP,OFFBD,OFFEP,
     +                        OFFAB,OFFRY,OFFRR,
     +                        CENTER,
     +                        SYMSIZE,SYMSETS,SYMCEN,
     +                        SYMNBO,
     +                        QSYMACC,LSYMACC,
     +                        BDNCEN,BDCEN,
     +                        NBOBD,
     +                        SYMCRIT,
     +                        XMAT,
     +                        LOCAL,
     +                        Q,
     +
     +                                 ZEROSYM,
     +                                 NROT,
     +                                 ROTIDX )
     +
     +
                 ROT3DEG = .NOT.ZEROSYM

                 IF (ROT3DEG) THEN
                     WRITE (*,*) ' Using 3-deg octahedral background! '
                     IF (NROT.EQ.0) THEN
                         WRITE (*,*) ' No 3-deg ogroup NBO rot set! '
                         WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                         WRITE (1,*) ' No 3-deg ogroup NBO rot set! '
                         WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                         STOP
                     END IF
                 END IF
             END IF

C             GOTO 23456

 2345        IF (.NOT.ROT3DEG .AND. (NCUBE.NE.0)) THEN

                 SYMSIZE = 8
                 SYMSETS = NCUBE

                 NSYM = SYMSIZE * SYMSETS

                 DO N = 1,NSYM
                    SYMCEN (N) = PLATO (N,1)
                 END DO

                 CALL  NLO__FIND_ROTATION_NBO_INDICES
     +
     +                      ( NBAS,NATOM,3,
     +                        NBOSIZE,
     +                        OFFLP,OFFBD,OFFEP,
     +                        OFFAB,OFFRY,OFFRR,
     +                        CENTER,
     +                        SYMSIZE,SYMSETS,SYMCEN,
     +                        SYMNBO,
     +                        QSYMACC,LSYMACC,
     +                        BDNCEN,BDCEN,
     +                        NBOBD,
     +                        SYMCRIT,
     +                        XMAT,
     +                        LOCAL,
     +                        Q,
     +
     +                                 ZEROSYM,
     +                                 NROT,
     +                                 ROTIDX )
     +
     +
                 ROT3DEG = .NOT.ZEROSYM

                 IF (ROT3DEG) THEN
                     WRITE (*,*) ' Using 3-deg cubical background! '

                     CUBICAL = .TRUE.

                     IF (NROT.EQ.0) THEN
                         WRITE (*,*) ' No 3-deg ogroup NBO rot set! '
                         WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                         WRITE (1,*) ' No 3-deg ogroup NBO rot set! '
                         WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                         STOP
                     END IF
                 END IF
             END IF

23456        IF (.NOT.ROT3DEG) THEN
                 WRITE (*,*) ' Could not rotate 3-deg ogroup NBOs! '
                 WRITE (*,*) ' nlo__rotate_atom_ogroup_nbo '
                 WRITE (1,*) ' Could not rotate 3-deg ogroup NBOs! '
                 WRITE (1,*) ' nlo__rotate_atom_ogroup_nbo '
                 RETURN
             END IF

             DO N = 1,NROT
                IDX = ROTIDX (N)
                XMAT (N,1) = XMAT (IDX,1)
                XMAT (N,2) = XMAT (IDX,2)
                XMAT (N,3) = XMAT (IDX,3)
             END DO

             CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                  ( 6,
     +                    ' P rotation matrix (atom,ogroup) ',
     +                    NBAS,3,
     +                    NROT,3,
     +                    XMAT )
     +
     +
C
C
C             ...find the ogroup rotation matrix.
C
C
             NORMLZE = .TRUE.
             MAXIMZE = CUBICAL

             CALL  MAT__ORTHOTRAN_MINIMAX_1_NORM
     +
     +                  ( NBAS,3,
     +                    ROTSIZE,ROTSIZE,
     +                    NBAS,NBAS,
     +                    NROT,3,
     +                    NORMLZE,
     +                    MAXIMZE,
     +                    XMAT,
     +                    XVEC (1),
     +                    XVEC (NBAS+1),
     +
     +                             NITER,
     +                             ROT )
     +
     +
             CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                  ( 6,
     +                    ' ROT matrix (atom,ogroup) ',
     +                    ROTSIZE,ROTSIZE,
     +                    3,3,
     +                    ROT )
     +
     +
C
C
C             ...form the new rotated ogroup NBO coefficients in
C                AO basis, the NBO coefficient matrix in NHO basis
C                and the matrices containing details about the new
C                NBOs. Mark the new NBOs as symmetry adapted.
C
C
             DO N = 1,NBAS
                X =   C (N,T1) * ROT (1,1)
     +              + C (N,T2) * ROT (2,1)
     +              + C (N,T3) * ROT (3,1)
                Y =   C (N,T1) * ROT (1,2)
     +              + C (N,T2) * ROT (2,2)
     +              + C (N,T3) * ROT (3,2)
                Z =   C (N,T1) * ROT (1,3)
     +              + C (N,T2) * ROT (2,3)
     +              + C (N,T3) * ROT (3,3)
                C (N,T1) = X
                C (N,T2) = Y
                C (N,T3) = Z
             END DO

             B (1,T1) = ROT (1,1)
             B (2,T1) = ROT (2,1)
             B (3,T1) = ROT (3,1)
             B (1,T2) = ROT (1,2)
             B (2,T2) = ROT (2,2)
             B (3,T2) = ROT (3,2)
             B (1,T3) = ROT (1,3)
             B (2,T3) = ROT (2,3)
             B (3,T3) = ROT (3,3)

             BOND1 = NBOBD (T1)
             BOND2 = NBOBD (T2)
             BOND3 = NBOBD (T3)

             NHO1 = BDBAS (1,BOND1)
             NHO2 = BDBAS (1,BOND2)
             NHO3 = BDBAS (1,BOND3)

             BDNBAS (BOND1) = 3
             BDNBAS (BOND2) = 3
             BDNBAS (BOND3) = 3

             BDBAS (1,BOND1) = NHO1
             BDBAS (2,BOND1) = NHO2
             BDBAS (3,BOND1) = NHO3
             BDBAS (1,BOND2) = NHO1
             BDBAS (2,BOND2) = NHO2
             BDBAS (3,BOND2) = NHO3
             BDBAS (1,BOND3) = NHO1
             BDBAS (2,BOND3) = NHO2
             BDBAS (3,BOND3) = NHO3

             SYMNBO (T1) = 2
             SYMNBO (T2) = 2
             SYMNBO (T3) = 2

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

         SUBROUTINE  OED__NAI_SET_DERV_SEQUENCE
     +
     +                    ( NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DERCX,DERCY,DERCZ,
     +                      DIFFA,DIFFB,DIFFC,
     +                      ATOMIC,
     +
     +                               CENSQX,CENSQY,CENSQZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_SET_DERV_SEQUENCE
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine determines the sequence of centers for
C                the x,y,z-coordinate derivations. The info is stored
C                in arrays CENSQp for each coordinate p=X,Y,Z.
C
C                The indices for the centers obey the following
C                indexing scheme:
C
C                               centers: A  B  C
C                          center index: 1  2  3
C
C                where C denotes the extra nuclear attraction center
C                different from A and B that is to be differentiated.
C
C                Take the x-coordinate for example and let CENSQX have
C                the following elements on exit from this routine:
C
C                            CENSQX (I) = 2,3,3,1,1
C
C                Then the sequence of single derivations is:
C
C                   dx/dAx  dx/dAx  dx/dCx  dx/dCx  dx/dBx  (A|B)
C
C                Note, that the indexing of the CENSQp arrays start
C                with 0. The reason is that the NDERp values might
C                be equal to zero.
C
C                The strategy to determine the center sequences is
C                to perform differentiation on the centers A and/or B
C                first, since they reduce the angular momentum by -1
C                for the 1D integrals involved. On the other hand,
C                differentiation on any of the nuclear attraction
C                centers not equal to A and B does not change the
C                1D angular momentum parts on centers A and B.
C
C
C                  Input:
C
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERxp        =  the order of differentiation on
C                                    centers x = A and B with respect
C                                    to the p = x,y,z coordinates
C                    DERCp        =  the order of differentiation for
C                                    the IXDERC-th nuclear attraction
C                                    center with respect to the
C                                    p = x,y,z coordinates
C                    DIFFy        =  is true, if differentiation will
C                                    be performed on centers y = A and B
C                                    and at least on one of the nuclear
C                                    attraction centers y = C different
C                                    from A and B
C                    ATOMIC       =  indicates, if centers A and B are
C                                    equal
C
C                  Output:
C
C                    CENSQp       =  center sequence array for the
C                                    p = x,y,z coordinates
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     DIFFA,DIFFB,DIFFC

         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DERCX,DERCY,DERCZ
         INTEGER     I
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NX,NY,NZ

         INTEGER     CENSQX (0:NDERX)
         INTEGER     CENSQY (0:NDERY)
         INTEGER     CENSQZ (0:NDERZ)
C
C
C------------------------------------------------------------------------
C
C
C             ...first the center sequences due to centers A.
C
C
         NX = 0
         NY = 0
         NZ = 0

         IF (DIFFA) THEN

             DO I = 1,DERAX
                CENSQX (NX+I) = 1
             END DO
             NX = NX + DERAX

             DO I = 1,DERAY
                CENSQY (NY+I) = 1
             END DO
             NY = NY + DERAY

             DO I = 1,DERAZ
                CENSQZ (NZ+I) = 1
             END DO
             NZ = NZ + DERAZ

         END IF
C
C
C             ...add the center sequences due to centers B (if needed).
C
C
         IF (DIFFB .AND. .NOT.ATOMIC) THEN

             DO I = 1,DERBX
                CENSQX (NX+I) = 2
             END DO
             NX = NX + DERBX

             DO I = 1,DERBY
                CENSQY (NY+I) = 2
             END DO
             NY = NY + DERBY

             DO I = 1,DERBZ
                CENSQZ (NZ+I) = 2
             END DO
             NZ = NZ + DERBZ

         END IF
C
C
C             ...center sequences due to a possible differentiation
C                on a nuclear attraction center different from centers
C                A and B.
C
C
         IF (DIFFC) THEN

             DO I = 1,DERCX
                CENSQX (NX+I) = 3
             END DO
             NX = NX + DERCX

             DO I = 1,DERCY
                CENSQY (NY+I) = 3
             END DO
             NY = NY + DERCY

             DO I = 1,DERCZ
                CENSQZ (NZ+I) = 3
             END DO
             NZ = NZ + DERCZ

         END IF
C
C
C             ...safety check.
C
C
         IF (NX.NE.NDERX .OR. NY.NE.NDERY . OR. NZ.NE.NDERZ) THEN
             WRITE (*,*) ' Total derivative order mismatch! '
             WRITE (*,*) ' NX,NY,NZ,NDERX,NDERY,NDERZ = ',
     +                     NX,NY,NZ,NDERX,NDERY,NDERZ
             WRITE (*,*) ' oed__nai_set_derv_sequence '
             STOP
         END IF

C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE SCFINP(TITLE,ITAPE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*(*) TITLE
      DIMENSION NI(8),NOCC1(8),NOCC2(8),IOCC(150)
      LOGICAL IOPEN,OPN
c     Maximum string length of terminal lines
      INTEGER LINELEN
      PARAMETER (LINELEN=80)
      CHARACTER*(linelen) FMTA
      COMMON /FLAGS/IFLAGS(100),IFLAGS2(500)
C
      DATA ZERO,ONE,IONE/0.D0,1.D0,1/
C
C   SET DEFAULTS
C
      IPRCT=-5
      ISCF=IFLAGS(5)
      I2CON=0
      INFLG=-1
      IVECT=-1 
      IF(IFLAGS(1).GT.0) IVECT=0
      IPUNCH=8
      IPRINT=0
      IDEBUG=0 
      ISAVE=0
      ITMAX=IFLAGS(16)
      ISTO=20
      MICMX=0
      IAUTO=0
      IDFIX=1
      ITPREP=0
      ITCON=0
      IALL=1
      IVO=0
      IGRAD=0
      IDMAT=0
      DAMP=ZERO
      DAMP1=ONE
      FMTA='(3F25.15)'

C  GET NUMBER OF IRREPS AND OCCUPATIONS FROM JOBARC
      CALL GETREC(20,'JOBARC','COMPORDR',IONE,LAU)
      CALL GETREC(20,'JOBARC','OCCUPYA ',LAU,NOCC1)
      IF (IFLAGS(11).NE.0) THEN
         CALL GETREC(20,'JOBARC','OCCUPYB ',LAU,NOCC2)
      ELSE
         DO LA = 1, LAU
            NOCC2(LA) = NOCC1(LA)
         END DO
      END IF
      DO 11 LA=1,LAU
         NI(LA)=MAX(NOCC1(LA),NOCC2(LA))
 11   CONTINUE

C  OPEN FILE
      INQUIRE (FILE='SCFINPT', OPENED=OPN)
      IF (.NOT.OPN) THEN
         OPEN (ITAPE, FILE='SCFINPT', FORM='FORMATTED',
     $     STATUS='UNKNOWN')
      ELSE
         WRITE(6,*) ' FILE ',ITAPE,' IS OPEN, CAN NOT WRITE IT'
      ENDIF
C
C  WRITE SCF INPUT FILE
C
      REWIND ITAPE
      WRITE(ITAPE,501) TITLE
  501 FORMAT(A)
      WRITE(ITAPE,502) IPRCT,ISCF,I2CON,INFLG,IVECT,IPUNCH,IPRINT,
     1                 IDEBUG,ISAVE,ITMAX,ISTO,MICMX,IAUTO,IDFIX,
     2                 ITPREP,ITCON,IALL,IVO,IGRAD,IDMAT
  502 FORMAT(24I4)
C
      WRITE(ITAPE,503) (NI(LA),LA=1,LAU)
  503 FORMAT(20I4)
C
      IOPEN=.FALSE.
      DO 1 LA=1,LAU
         IF(NOCC1(LA).NE.0.OR.NOCC2(LA).NE.0) THEN
            IF(NOCC1(LA).NE.NOCC2(LA)) IOPEN=.TRUE.
            DO 2 I=1,NOCC1(LA)
               IOCC(I)=1
 2          CONTINUE 
            DO 3 I=1,NOCC2(LA)
               IOCC(I)=IOCC(I)+1
 3          CONTINUE
            WRITE(ITAPE,503) (IOCC(I),I=1,NI(LA))
         ENDIF
 1    CONTINUE
C
      IF(IOPEN) THEN
         WRITE(ITAPE,*) 'HERE YOU HAVE TO INSERT THE OPEN-SHELL ENERGY',
     $      'COEFFICENTS'    
      ENDIF
C
      WRITE(ITAPE,504) DAMP,DAMP1
 504  FORMAT(2F20.0)
C
      WRITE(ITAPE,505) FMTA
 505  FORMAT(A80)
C
      WRITE(ITAPE,503) IONE
C
      CLOSE(ITAPE)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__SSPP_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      ATOMIC,ATOM12,ATOM34,
     +                      MIJ,MKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL3,SHELLP,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      X12,Y12,Z12,X34,Y34,Z34,
     +                      ALPHA1,ALPHA2,ALPHA3,ALPHA4,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIM1,PRIM2,PRIM3,PRIM4,
     +                      NORM1,NORM2,NORM3,NORM4,
     +                      RHO12,RHO34,
     +                      P,PX,PY,PZ,SCALEP,
     +                      Q,QX,QY,QZ,SCALEQ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__SSPP_PCGTO_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation is designed to provide ultrafast block
C                evaluation of a batch of normalized electron repulsion
C                integrals between s-shell and p-shell primitive
C                spherical gaussian type orbitals.
C
C                A batch is defined here as containing all possible
C                integrals, that is its dimension is determined by
C                the total number of primitive functions (here = 9)
C                times the total number of ij and kl exponent pair
C                combinations.
C
C                The integrals are ordered in the batch the following
C                way (first index varying fastest):
C
C                    batch (nxyz1,nxyz2,nxyz3,nxyz4,kl,ij)
C
C                where ij and kl indicates alpha exponent pairs
C                defining the present block.
C
C                The present routine evaluates batches of the type:
C
C                      sspp , spsp , pssp , spps , psps , ppss
C
C                The cartesian primitive integrals are evaluated using
C                the auxillary functions technique, described by
C                V.R. Saunders, "An Introduction to Molecular Integral
C                Evaluation" in "Computational Techniques in Quantum
C                Chemistry and Molecular Physics" edited by
C                GHF Diercksen, BT Sutcliff and A Veillard, D. Reidel
C                Publ. Comp. Dordrecht (1975), p. 347.
C
C                The cartesian primitive integrals are each evaluated
C                explicitely using common multipliers if possible and
C                avoiding array addresses.
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    sspp/spsp/pssp/spps/psps/ppss
C                                    integral batch
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    ATOM12(34)   =  indicates, if centers 1 and 2
C                                    (3 and 4) coincide
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the contracted shell pairs 1,2
C                                    (3,4)
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair 1,2
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NKL          =  total # of kl primitive index
C                                    pairs for the contracted shell
C                                    pair 3,4
C                    NKLBEG(END)  =  first(last) kl primitive index
C                                    defining the kl block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = 1,2,3,4
C                    SHELLx       =  the shell type for contraction
C                                    shells x = 1,3,P=1+2
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = 1,2,3,4
C                    Xxx,Yxx,Zxx  =  the x,y,z-coordinate differences
C                                    between centers xx = 12 and 34
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = 1,2,3,4
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j,k,l labels of primitives for
C                                    the respective contraction shells
C                                    x = 1,2,3,4
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = 1,2,3,4
C                    RHO12(34)    =  the complete set of NIJ (NKL)
C                                    exponential prefactors between
C                                    contraction shells 1 and 2
C                                    (3 and 4)
C                    P            =  will hold current MIJ exponent
C                                    sums for contraction shells 1
C                                    and 2
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=1+2
C                    SCALEP       =  will hold current MIJ values of
C                                    scaling factors related to point P
C                    Q            =  will hold current MKL exponent
C                                    sums for contraction shells 3
C                                    and 4
C                    Qx           =  will hold current MKL coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers Q=3+4
C                    SCALEQ       =  will hold current MKL values of
C                                    scaling factors related to point Q
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian sspp/spsp/pssp/spps/
C                                    psps/ppss integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOM12,ATOM34

         INTEGER     CASE
         INTEGER     I,J,K,L,M
         INTEGER     IJ,KL
         INTEGER     MGRID,NGRID,TGRID
         INTEGER     MIJ,MKL
         INTEGER     NBATCH
         INTEGER     NIJ,NKL
         INTEGER     NIJBEG,NIJEND,NKLBEG,NKLEND
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4
         INTEGER     SHELL1,SHELL3,SHELLP

         INTEGER     PRIM1 (1:MIJ)
         INTEGER     PRIM2 (1:MIJ)
         INTEGER     PRIM3 (1:MKL)
         INTEGER     PRIM4 (1:MKL)

         DOUBLE PRECISION  A,B,C,D,E,F,G
         DOUBLE PRECISION  DELTA1,DELTA2,DELTA3,DELTA4,DELTA5,DELTA6
         DOUBLE PRECISION  EXP1,EXP2,EXP3,EXP4
         DOUBLE PRECISION  F0,F1,F2
         DOUBLE PRECISION  PVAL,QVAL
         DOUBLE PRECISION  PQPLUS,PQMULT,PQPINV
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE
         DOUBLE PRECISION  PXSUB,PYSUB,PZSUB,QXSUB,QYSUB,QZSUB
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL,QXVAL,QYVAL,QZVAL
         DOUBLE PRECISION  RNPQSQ
         DOUBLE PRECISION  SCALE
         DOUBLE PRECISION  T,TINV,T2INV,TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  U0,U1
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4
         DOUBLE PRECISION  X12,Y12,Z12,X34,Y34,Z34
         DOUBLE PRECISION  XSP1,XPS1,XSP2,XPS2,
     +                     YSP1,YPS1,YSP2,YPS2,
     +                     ZSP1,ZPS1,ZSP2,ZPS2
         DOUBLE PRECISION  ZERO,SIXTH,FIFTH,THIRD,HALF,ONE,THREE,PI

         DOUBLE PRECISION  ALPHA1 (1:NPGTO1)
         DOUBLE PRECISION  ALPHA2 (1:NPGTO2)
         DOUBLE PRECISION  ALPHA3 (1:NPGTO3)
         DOUBLE PRECISION  ALPHA4 (1:NPGTO4)

         DOUBLE PRECISION  NORM1  (1:NPGTO1)
         DOUBLE PRECISION  NORM2  (1:NPGTO2)
         DOUBLE PRECISION  NORM3  (1:NPGTO3)
         DOUBLE PRECISION  NORM4  (1:NPGTO4)

         DOUBLE PRECISION  RHO12  (1:NIJ)
         DOUBLE PRECISION  RHO34  (1:NKL)

         DOUBLE PRECISION  BATCH  (1:NBATCH)

         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  PX     (1:MIJ)
         DOUBLE PRECISION  PY     (1:MIJ)
         DOUBLE PRECISION  PZ     (1:MIJ)
         DOUBLE PRECISION  SCALEP (1:MIJ)

         DOUBLE PRECISION  Q      (1:MKL)
         DOUBLE PRECISION  QX     (1:MKL)
         DOUBLE PRECISION  QY     (1:MKL)
         DOUBLE PRECISION  QZ     (1:MKL)
         DOUBLE PRECISION  SCALEQ (1:MKL)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (ZERO    =  0.D0 )
         PARAMETER  (SIXTH   =  0.166666666666667D0)
         PARAMETER  (FIFTH   =  0.2D0)
         PARAMETER  (THIRD   =  0.333333333333333D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0 )
         PARAMETER  (THREE   =  3.D0 )
         PARAMETER  (PI      =  3.141592653589793D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...predetermine in 'K2' loops the quantities associated
C                with the 1,2-part and 3,4-part.
C
C
         CASE = 5

         IF (ATOMIC.OR.ATOM12) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                P (M) = ALPHA1 (I) + ALPHA2 (J)
                SCALEP (M) = NORM1 (I) * NORM2 (J)
  100        CONTINUE
             CASE = CASE - 1
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                EXP1 = ALPHA1 (I)
                EXP2 = ALPHA2 (J)
                PVAL = EXP1 + EXP2
                P (M) = PVAL
                PVAL = EXP1 / PVAL
                PX (M) = PVAL * X12 + X2
                PY (M) = PVAL * Y12 + Y2
                PZ (M) = PVAL * Z12 + Z2
                SCALEP (M) = NORM1 (I) * NORM2 (J) * RHO12 (IJ)
  110        CONTINUE
         END IF

         IF (ATOMIC.OR.ATOM34) THEN
             M = 0
             DO 200 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                Q (M) = ALPHA3 (K) + ALPHA4 (L)
                SCALEQ (M) = NORM3 (K) * NORM4 (L)
  200        CONTINUE
             CASE = CASE - 2
         ELSE
             M = 0
             DO 220 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                EXP3 = ALPHA3 (K)
                EXP4 = ALPHA4 (L)
                QVAL = EXP3 + EXP4
                Q (M) = QVAL
                QVAL = EXP3 / QVAL
                QX (M) = QVAL * X34 + X4
                QY (M) = QVAL * Y34 + Y4
                QZ (M) = QVAL * Z34 + Z4
                SCALEQ (M) = NORM3 (K) * NORM4 (L) * RHO34 (KL)
  220        CONTINUE
         END IF

         IF (ATOMIC) THEN
             CASE = CASE - 1
         END IF
C
C
C             ...jump according to where the s-type functions are
C                located and the type of 'K4' loop:
C
C                SHELLP CASE  |        Integral center type
C               --------------|------------------------------------
C                   0     1   |  (AA|AA)  atomic     sspp
C                   0     2   |  (AA|CC)  2-center   sspp
C                   0     3   |  (AB|CC)  3-center   sspp
C                   0     4   |  (AA|CD)  3-center   sspp
C                   0     5   |  (AB|CD)  4-center   sspp
C
C                   1     1   |  (AA|AA)  atomic     spsp,spps,pssp,psps
C                   1     2   |  (AA|CC)  2-center   spsp,spps,pssp,psps
C                   1     3   |  (AB|CC)  3-center   spsp,spps,pssp,psps
C                   1     4   |  (AA|CD)  3-center   spsp,spps,pssp,psps
C                   1     5   |  (AB|CD)  4-center   spsp,spps,pssp,psps
C
C                   2     1   |  (AA|AA)  atomic     ppss
C                   2     2   |  (AA|CC)  2-center   ppss
C                   2     3   |  (AB|CC)  3-center   ppss
C                   2     4   |  (AA|CD)  3-center   ppss
C                   2     5   |  (AB|CD)  4-center   ppss
C
C
         GOTO (11,12,13,14,15,
     +         21,22,23,24,25,
     +         31,32,33,34,35) 5*SHELLP + CASE
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic sspp (AA|AA)
C                type integrals.
C
C
   11    M = 0
         DO 1100 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1110 KL = 1,MKL
               QVAL = Q (KL)
               PQPLUS = PVAL + QVAL
               F0 = PSCALE * SCALEQ (KL) / (PVAL*QVAL*DSQRT (PQPLUS))
               U1 = (F0 - (PVAL / PQPLUS) * F0 * THIRD) / (QVAL + QVAL)
               BATCH (M+1) = U1
               BATCH (M+2) = ZERO
               BATCH (M+3) = ZERO
               BATCH (M+4) = ZERO
               BATCH (M+5) = U1
               BATCH (M+6) = ZERO
               BATCH (M+7) = ZERO
               BATCH (M+8) = ZERO
               BATCH (M+9) = U1
               M = M + 9
 1110       CONTINUE
 1100    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center sspp (AA|CC)
C                type integrals.
C
C
   12    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

         M = 0
         DO 1200 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1220 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = (F0 - U0 * F1) / (QVAL + QVAL)
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = YSP2 * F2
               B = ZSP2 * F2
               BATCH (M+1) = XSP2 * XSP2 * F2 + U1
               BATCH (M+2) = XSP2 * A
               BATCH (M+3) = XSP2 * B
               BATCH (M+4) = BATCH (M+2)
               BATCH (M+5) = YSP2 * A + U1
               BATCH (M+6) = YSP2 * B
               BATCH (M+7) = BATCH (M+3)
               BATCH (M+8) = BATCH (M+6)
               BATCH (M+9) = ZSP2 * B + U1
               M = M + 9
 1220       CONTINUE
 1200    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center sspp (AB|CC)
C                type integrals.
C
C
   13    M = 0
         DO 1300 IJ = 1,MIJ
            PVAL = P (IJ)
            PQX = PX (IJ) - X3
            PQY = PY (IJ) - Y3
            PQZ = PZ (IJ) - Z3
            RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
            PSCALE = SCALEP (IJ)
            DO 1330 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = (F0 - U0 * F1) / (QVAL + QVAL)
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = YSP2 * F2
               B = ZSP2 * F2
               BATCH (M+1) = XSP2 * XSP2 * F2 + U1
               BATCH (M+2) = XSP2 * A
               BATCH (M+3) = XSP2 * B
               BATCH (M+4) = BATCH (M+2)
               BATCH (M+5) = YSP2 * A + U1
               BATCH (M+6) = YSP2 * B
               BATCH (M+7) = BATCH (M+3)
               BATCH (M+8) = BATCH (M+6)
               BATCH (M+9) = ZSP2 * B + U1
               M = M + 9
 1330       CONTINUE
 1300    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center sspp (AA|CD)
C                type integrals.
C
C
   14    M = 0
         DO 1400 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1440 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = X1 - QXVAL
               PQY = Y1 - QYVAL
               PQZ = Z1 - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = (F0 - U0 * F1) / (QVAL + QVAL)
               XPS1 = QXVAL - X3
               YPS1 = QYVAL - Y3
               ZPS1 = QZVAL - Z3
               XSP1 = QXVAL - X4
               YSP1 = QYVAL - Y4
               ZSP1 = QZVAL - Z4
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = XPS1 * F0 +  XSP2 * F1
               B = XPS1 * F1 +  XSP2 * F2
               C = YPS1 * F0 +  YSP2 * F1
               D = YPS1 * F1 +  YSP2 * F2
               E = ZPS1 * F0 +  ZSP2 * F1
               F = ZPS1 * F1 +  ZSP2 * F2
               BATCH (M+1) = XSP1 * A + XSP2 * B + U1
               BATCH (M+2) = XSP1 * C + XSP2 * D
               BATCH (M+3) = XSP1 * E + XSP2 * F
               BATCH (M+4) = YSP1 * A + YSP2 * B
               BATCH (M+5) = YSP1 * C + YSP2 * D + U1
               BATCH (M+6) = YSP1 * E + YSP2 * F
               BATCH (M+7) = ZSP1 * A + ZSP2 * B
               BATCH (M+8) = ZSP1 * C + ZSP2 * D
               BATCH (M+9) = ZSP1 * E + ZSP2 * F + U1
               M = M + 9
 1440       CONTINUE
 1400    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center sspp (AB|CD)
C                type integrals.
C
C
   15    M = 0
         DO 1500 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            DO 1550 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = PXVAL - QXVAL
               PQY = PYVAL - QYVAL
               PQZ = PZVAL - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = (F0 - U0 * F1) / (QVAL + QVAL)
               XPS1 = QXVAL - X3
               YPS1 = QYVAL - Y3
               ZPS1 = QZVAL - Z3
               XSP1 = QXVAL - X4
               YSP1 = QYVAL - Y4
               ZSP1 = QZVAL - Z4
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = XPS1 * F0 +  XSP2 * F1
               B = XPS1 * F1 +  XSP2 * F2
               C = YPS1 * F0 +  YSP2 * F1
               D = YPS1 * F1 +  YSP2 * F2
               E = ZPS1 * F0 +  ZSP2 * F1
               F = ZPS1 * F1 +  ZSP2 * F2
               BATCH (M+1) = XSP1 * A + XSP2 * B + U1
               BATCH (M+2) = XSP1 * C + XSP2 * D
               BATCH (M+3) = XSP1 * E + XSP2 * F
               BATCH (M+4) = YSP1 * A + YSP2 * B
               BATCH (M+5) = YSP1 * C + YSP2 * D + U1
               BATCH (M+6) = YSP1 * E + YSP2 * F
               BATCH (M+7) = ZSP1 * A + ZSP2 * B
               BATCH (M+8) = ZSP1 * C + ZSP2 * D
               BATCH (M+9) = ZSP1 * E + ZSP2 * F + U1
               M = M + 9
 1550       CONTINUE
 1500    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic spsp,spps,
C                pssp and psps (AA|AA) type integrals.
C
C
   21    M = 0
         DO 2100 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 2110 KL = 1,MKL
               QVAL = Q (KL)
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               F0 = PSCALE * SCALEQ (KL) / (PVAL*QVAL*DSQRT (PQPLUS))
               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               D = SIXTH * F0 * PQPINV
               BATCH (M+1) = D
               BATCH (M+2) = ZERO
               BATCH (M+3) = ZERO
               BATCH (M+4) = ZERO
               BATCH (M+5) = D
               BATCH (M+6) = ZERO
               BATCH (M+7) = ZERO
               BATCH (M+8) = ZERO
               BATCH (M+9) = D
               M = M + 9
 2110       CONTINUE
 2100    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center spsp,spps,
C                pssp and psps (AA|CC) type integrals.
C
C
   22    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

         M = 0
         DO 2200 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 2220 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               XPS2 = PQX * U1
               YPS2 = PQY * U1
               ZPS2 = PQZ * U1
               A = XPS2 * F2
               B = YPS2 * F2
               C = ZPS2 * F2
               D = HALF * F1 * PQPINV
               BATCH (M+1) = XSP2 * A + D
               BATCH (M+2) = XSP2 * B
               BATCH (M+3) = XSP2 * C
               BATCH (M+4) = YSP2 * A
               BATCH (M+5) = YSP2 * B + D
               BATCH (M+6) = YSP2 * C
               BATCH (M+7) = ZSP2 * A
               BATCH (M+8) = ZSP2 * B
               BATCH (M+9) = ZSP2 * C + D
               M = M + 9
 2220       CONTINUE
 2200    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center spsp,spps,
C                pssp and psps (AB|CC) type integrals.
C
C
   23    IF (SHELL1.EQ.1) THEN
             PXSUB = X1
             PYSUB = Y1
             PZSUB = Z1
         ELSE
             PXSUB = X2
             PYSUB = Y2
             PZSUB = Z2
         END IF

         M = 0
         DO 2300 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PQX = PXVAL - X3
            PQY = PYVAL - Y3
            PQZ = PZVAL - Z3
            RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
            PSCALE = SCALEP (IJ)
            XPS1 = PXVAL - PXSUB
            YPS1 = PYVAL - PYSUB
            ZPS1 = PZVAL - PZSUB
            DO 2330 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               XPS2 = PQX * U1
               YPS2 = PQY * U1
               ZPS2 = PQZ * U1
               A = XPS1 * F1 + XPS2 * F2
               B = YPS1 * F1 + YPS2 * F2
               C = ZPS1 * F1 + ZPS2 * F2
               D = HALF * F1 * PQPINV
               BATCH (M+1) = XSP2 * A + D
               BATCH (M+2) = XSP2 * B
               BATCH (M+3) = XSP2 * C
               BATCH (M+4) = YSP2 * A
               BATCH (M+5) = YSP2 * B + D
               BATCH (M+6) = YSP2 * C
               BATCH (M+7) = ZSP2 * A
               BATCH (M+8) = ZSP2 * B
               BATCH (M+9) = ZSP2 * C + D
               M = M + 9
 2330       CONTINUE
 2300    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center spsp,spps,
C                pssp and psps (AA|CD) type integrals.
C
C
   24    IF (SHELL3.EQ.1) THEN
             QXSUB = X3
             QYSUB = Y3
             QZSUB = Z3
         ELSE
             QXSUB = X4
             QYSUB = Y4
             QZSUB = Z4
         END IF

         M = 0
         DO 2400 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 2440 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = X1 - QXVAL
               PQY = Y1 - QYVAL
               PQZ = Z1 - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F1 = T2INV * SCALE * HALF * DSQRT (PI*TINV)
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               XSP1 = QXVAL - QXSUB
               YSP1 = QYVAL - QYSUB
               ZSP1 = QZVAL - QZSUB
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               XPS2 = PQX * U1
               YPS2 = PQY * U1
               ZPS2 = PQZ * U1
               A = XSP1 * F1 + XSP2 * F2
               B = YSP1 * F1 + YSP2 * F2
               C = ZSP1 * F1 + ZSP2 * F2
               D = HALF * F1 * PQPINV
               BATCH (M+1) = XPS2 * A + D
               BATCH (M+2) = YPS2 * A
               BATCH (M+3) = ZPS2 * A
               BATCH (M+4) = XPS2 * B
               BATCH (M+5) = YPS2 * B + D
               BATCH (M+6) = ZPS2 * B
               BATCH (M+7) = XPS2 * C
               BATCH (M+8) = YPS2 * C
               BATCH (M+9) = ZPS2 * C + D
               M = M + 9
 2440       CONTINUE
 2400    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center spsp,spps,
C                pssp and psps (AB|CD) type integrals.
C
C
   25    IF (SHELL1.EQ.1) THEN
             PXSUB = X1
             PYSUB = Y1
             PZSUB = Z1
         ELSE
             PXSUB = X2
             PYSUB = Y2
             PZSUB = Z2
         END IF

         IF (SHELL3.EQ.1) THEN
             QXSUB = X3
             QYSUB = Y3
             QZSUB = Z3
         ELSE
             QXSUB = X4
             QYSUB = Y4
             QZSUB = Z4
         END IF

         M = 0
         DO 2500 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            XPS1 = PXVAL - PXSUB
            YPS1 = PYVAL - PYSUB
            ZPS1 = PZVAL - PZSUB
            DO 2550 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = PXVAL - QXVAL
               PQY = PYVAL - QYVAL
               PQZ = PZVAL - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = PVAL * PQPINV
               U1 = - QVAL * PQPINV
               XSP1 = QXVAL - QXSUB
               YSP1 = QYVAL - QYSUB
               ZSP1 = QZVAL - QZSUB
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               XPS2 = PQX * U1
               YPS2 = PQY * U1
               ZPS2 = PQZ * U1
               A = XPS1 * F0 + XPS2 * F1
               B = XPS1 * F1 + XPS2 * F2
               C = YPS1 * F0 + YPS2 * F1
               D = YPS1 * F1 + YPS2 * F2
               E = ZPS1 * F0 + ZPS2 * F1
               F = ZPS1 * F1 + ZPS2 * F2
               G = HALF * F1 * PQPINV
               BATCH (M+1) = XSP1 * A + XSP2 * B + G
               BATCH (M+2) = XSP1 * C + XSP2 * D
               BATCH (M+3) = XSP1 * E + XSP2 * F
               BATCH (M+4) = YSP1 * A + YSP2 * B
               BATCH (M+5) = YSP1 * C + YSP2 * D + G
               BATCH (M+6) = YSP1 * E + YSP2 * F
               BATCH (M+7) = ZSP1 * A + ZSP2 * B
               BATCH (M+8) = ZSP1 * C + ZSP2 * D
               BATCH (M+9) = ZSP1 * E + ZSP2 * F + G
               M = M + 9
 2550       CONTINUE
 2500    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic ppss (AA|AA)
C                type integrals.
C
C
   31    M = 0
         DO 3100 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            U1 = ONE / (PVAL + PVAL)
            DO 3110 KL = 1,MKL
               QVAL = Q (KL)
               PQPLUS = PVAL + QVAL
               F0 = PSCALE * SCALEQ (KL) / (PVAL*QVAL*DSQRT (PQPLUS))
               C = U1 * (F0 - (QVAL / PQPLUS) * F0 * THIRD)
               BATCH (M+1) = C
               BATCH (M+2) = ZERO
               BATCH (M+3) = ZERO
               BATCH (M+4) = ZERO
               BATCH (M+5) = C
               BATCH (M+6) = ZERO
               BATCH (M+7) = ZERO
               BATCH (M+8) = ZERO
               BATCH (M+9) = C
               M = M + 9
 3110       CONTINUE
 3100    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center ppss (AA|CC)
C                type integrals.
C
C
   32    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

         M = 0
         DO 3200 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            U1 = ONE / (PVAL + PVAL)
            DO 3220 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = - QVAL * PQPINV
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = YSP2 * F2
               B = ZSP2 * F2
               C = U1 * (F0 + U0 * F1)
               BATCH (M+1) = XSP2 * XSP2 * F2 + C
               BATCH (M+2) = XSP2 * A
               BATCH (M+3) = XSP2 * B
               BATCH (M+4) = BATCH (M+2)
               BATCH (M+5) = YSP2 * A + C
               BATCH (M+6) = YSP2 * B
               BATCH (M+7) = BATCH (M+3)
               BATCH (M+8) = BATCH (M+6)
               BATCH (M+9) = ZSP2 * B + C
               M = M + 9
 3220       CONTINUE
 3200    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center ppss (AB|CC)
C                type integrals.
C
C
   33    M = 0
         DO 3300 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PQX = PXVAL - X3
            PQY = PYVAL - Y3
            PQZ = PZVAL - Z3
            RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
            PSCALE = SCALEP (IJ)
            XPS1 = PXVAL - X1
            YPS1 = PYVAL - Y1
            ZPS1 = PZVAL - Z1
            XSP1 = PXVAL - X2
            YSP1 = PYVAL - Y2
            ZSP1 = PZVAL - Z2
            U1 = ONE / (PVAL + PVAL)
            DO 3330 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               T = RNPQSQ * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = - QVAL * PQPINV
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = XPS1 * F0 +  XSP2 * F1
               B = XPS1 * F1 +  XSP2 * F2
               C = YPS1 * F0 +  YSP2 * F1
               D = YPS1 * F1 +  YSP2 * F2
               E = ZPS1 * F0 +  ZSP2 * F1
               F = ZPS1 * F1 +  ZSP2 * F2
               G = U1 * (F0 + U0 * F1)
               BATCH (M+1) = XSP1 * A + XSP2 * B + G
               BATCH (M+2) = XSP1 * C + XSP2 * D
               BATCH (M+3) = XSP1 * E + XSP2 * F
               BATCH (M+4) = YSP1 * A + YSP2 * B
               BATCH (M+5) = YSP1 * C + YSP2 * D + G
               BATCH (M+6) = YSP1 * E + YSP2 * F
               BATCH (M+7) = ZSP1 * A + ZSP2 * B
               BATCH (M+8) = ZSP1 * C + ZSP2 * D
               BATCH (M+9) = ZSP1 * E + ZSP2 * F + G
               M = M + 9
 3330       CONTINUE
 3300    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center ppss (AA|CD)
C                type integrals.
C
C
   34    M = 0
         DO 3400 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            U1 = ONE / (PVAL + PVAL)
            DO 3440 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = X1 - QXVAL
               PQY = Y1 - QYVAL
               PQZ = Z1 - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = - QVAL * PQPINV
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = YSP2 * F2
               B = ZSP2 * F2
               C = U1 * (F0 + U0 * F1)
               BATCH (M+1) = XSP2 * XSP2 * F2 + C
               BATCH (M+2) = XSP2 * A
               BATCH (M+3) = XSP2 * B
               BATCH (M+4) = BATCH (M+2)
               BATCH (M+5) = YSP2 * A + C
               BATCH (M+6) = YSP2 * B
               BATCH (M+7) = BATCH (M+3)
               BATCH (M+8) = BATCH (M+6)
               BATCH (M+9) = ZSP2 * B + C
               M = M + 9
 3440       CONTINUE
 3400    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center ppss (AB|CD)
C                type integrals.
C
C
   35    M = 0
         DO 3500 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            XPS1 = PXVAL - X1
            YPS1 = PYVAL - Y1
            ZPS1 = PZVAL - Z1
            XSP1 = PXVAL - X2
            YSP1 = PYVAL - Y2
            ZSP1 = PZVAL - Z2
            U1 = ONE / (PVAL + PVAL)
            DO 3550 KL = 1,MKL
               QVAL = Q (KL)
               QXVAL = QX (KL)
               QYVAL = QY (KL)
               QZVAL = QZ (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQPINV = ONE / PQPLUS
               PQX = PXVAL - QXVAL
               PQY = PYVAL - QYVAL
               PQZ = PZVAL - QZVAL
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT * PQPINV
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA1 = TGRID * TSTEP - T
                   DELTA2 = DELTA1 * HALF
                   DELTA3 = DELTA1 * THIRD
                   DELTA4 = DELTA2 * HALF
                   DELTA5 = DELTA1 * FIFTH
                   DELTA6 = DELTA3 * HALF

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA6
     +                      + FTABLE (5,TGRID)) * DELTA5
     +                      + FTABLE (4,TGRID)) * DELTA4
     +                      + FTABLE (3,TGRID)) * DELTA3
     +                      + FTABLE (2,TGRID)) * DELTA2
     +                      + FTABLE (1,TGRID)) * DELTA1
     +                      + FTABLE (0,TGRID)

                   F1 = ((((( FTABLE (7,TGRID)  * DELTA6
     +                      + FTABLE (6,TGRID)) * DELTA5
     +                      + FTABLE (5,TGRID)) * DELTA4
     +                      + FTABLE (4,TGRID)) * DELTA3
     +                      + FTABLE (3,TGRID)) * DELTA2
     +                      + FTABLE (2,TGRID)) * DELTA1
     +                      + FTABLE (1,TGRID)

                   F2 = ((((( FTABLE (8,TGRID)  * DELTA6
     +                      + FTABLE (7,TGRID)) * DELTA5
     +                      + FTABLE (6,TGRID)) * DELTA4
     +                      + FTABLE (5,TGRID)) * DELTA3
     +                      + FTABLE (4,TGRID)) * DELTA2
     +                      + FTABLE (3,TGRID)) * DELTA1
     +                      + FTABLE (2,TGRID)

                   F0 = SCALE * F0
                   F1 = SCALE * F1
                   F2 = SCALE * F2

               ELSE

                   TINV = ONE / T
                   T2INV = HALF * TINV
                   F0 = SCALE * HALF * DSQRT (PI*TINV)
                   F1 = T2INV * F0
                   F2 = THREE * T2INV * F1

               END IF

               U0 = - QVAL * PQPINV
               XSP2 = PQX * U0
               YSP2 = PQY * U0
               ZSP2 = PQZ * U0
               A = XPS1 * F0 +  XSP2 * F1
               B = XPS1 * F1 +  XSP2 * F2
               C = YPS1 * F0 +  YSP2 * F1
               D = YPS1 * F1 +  YSP2 * F2
               E = ZPS1 * F0 +  ZSP2 * F1
               F = ZPS1 * F1 +  ZSP2 * F2
               G = U1 * (F0 + U0 * F1)
               BATCH (M+1) = XSP1 * A + XSP2 * B + G
               BATCH (M+2) = XSP1 * C + XSP2 * D
               BATCH (M+3) = XSP1 * E + XSP2 * F
               BATCH (M+4) = YSP1 * A + YSP2 * B
               BATCH (M+5) = YSP1 * C + YSP2 * D + G
               BATCH (M+6) = YSP1 * E + YSP2 * F
               BATCH (M+7) = ZSP1 * A + ZSP2 * B
               BATCH (M+8) = ZSP1 * C + ZSP2 * D
               BATCH (M+9) = ZSP1 * E + ZSP2 * F + G
               M = M + 9
 3550       CONTINUE
 3500    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine lindep_remove(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Calculates the eigenvalues and eigenvectors of a 2-d square matrix.
c   The matrix is also diagonalized on output. The square root and inverse
c   operators are also applied.
c
c   The eigenvalues are stored in a common block.  
c   The instruction is executed as follows:
c   
c   execute eig Array1 Array2
c
c   where Array1 is the input matrix that is to be diagonalized.
c         Array2 is the matrix whose columns are the eigenvectors of Array1.
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'epsilon.h'
      include 'parallel_info.h'
      include 'scflindep.h'
      include 'mpif.h'
      include 'int_gen_parms.h'
 
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table),scfevec
       
      integer inda(2), indb(2)

      integer*8 iarray, ievec, array,get_index_from_base
      integer i, j, n
      integer array1, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer ind(mx_array_index)
      integer junk,n_orb

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix.
c---------------------------------------------------------------------------

#ifdef ALTIX
      dptr = dshptr
#endif
      array = op(c_result_array)
      evec_array = op(c_op1_array)
      if (array .eq. 0 .or. evec_array .eq. 0) then
         print *,'Error: EIG routine requires 2 array arguments.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      array_type = array_table(c_array_type, array)
      evec_type  = array_table(c_array_type, evec_array)
      if (array_type .ne. static_array .or. 
     *    evec_type .ne. static_array) then
         print *,'Error: Both arrays in EIG routine must be static.'
         call abort_job()
      endif

      nindex = array_table(c_nindex, array)
      nindex_evec = array_table(c_nindex, evec_array)
      if (nindex .ne. nindex_evec) then
         print *,'Error: Both arrays in EIG must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex_evec,' indices.'
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      iarray = get_index_from_base(address_table(array), x, 2)
      ievec  = get_index_from_base(address_table(evec_array), x, 2)

      n = index_table(c_index_size, ind(1))  ! pick up length of index

c----------------SCF eigenvectors-------------------------------------------

      array1 = 2 ! SCF vectors alpha   
      array_type = array_table(c_array_type, array1)

      if (array_type .ne. static_array) then
         print *,'Error: SCF vectors arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array1)

      if (nindex .ne. 2) then
         print *,'Error: SCF vectors array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, na)  ! pick up length
      enddo

      scfevec = get_index_from_base(address_table(array1), x, 2)
      n_orb = indb(1)



c---------------------------------------------------------------------------

      call resort(x(iarray), x(ievec), x(scfevec),n )

      return
      end

c---------------------------------------------------------------------------
c---------------------------------------------------------------------------
      subroutine resort(temparr,fockmatr,scfevec,n )
      implicit none
     
      integer i,j,k,l,n,indexarr(n),NZERO,cnt     
      double precision temparr(n,n), fockmatr(n,n),scfevec(n,n),
     & auxvec(n),auxval(n),VECNORM,dnrm2 
      double precision norm(n),ctol 

c----------Tolerance for the MO vector norm---------------------------------
      ctol = 1d-6

c----------Calculate norm of vectors----------------------------------------
          do i=1,n
                do j=1,n
                auxvec(j) = 0.d0
                auxvec(j) = scfevec(j,i)         
                enddo

                VECNORM =  dnrm2(n,auxvec,1)
                IF(dabs(VECNORM).ge.ctol) then
                indexarr(i) = 1
                ELSE
                indexarr(i) = 0 
                ENDIF
          enddo
c----------Move vectors with non-zero norm into auxiliary array------------
          NZERO = 0 
          cnt = 0
          do i=1,n
             IF(indexarr(i).eq.1) then
             cnt = cnt + 1
             do j=1,n
             temparr(j,cnt) = scfevec(j,i)     
             enddo
             auxval(cnt) = fockmatr(cnt,cnt) 
             ELSE    
             NZERO = NZERO + 1
             ENDIF
           enddo
c----------Move back reordered vectors to scfevec array--------------------
           do i=1,n
                fockmatr(i,i) = 1000000
                IF(i.le.cnt) fockmatr(i,i) = auxval(i)
                do j=1,n
                scfevec(j,i) = 0.d0 
                IF(i.le.cnt) then
                scfevec(j,i) = temparr(j,i)
                ENDIF                                 
                enddo
           enddo 

           write(6,*) 'Totally',NZERO,'vectors have zero norm'  
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork0222(y,
     *                     x1,ne1,ne2,nf1,nf2,
     *                     e1,e2,f1,f2, indx1,
     *                     x2,ni1,ni2,nj1,nj2,
     *                     i1,i2,j1,j2,indi, indj,
     *                     flopcount) 
c-------------------------------------------------------------------------
c   Performs a "0222" contraction: 
c      0 index output array (i. e. scalar)
c      2 index operand array
c      2 index operand array
c      2 index contraction.
c
c   I. e., contract the 2 indices of the 2nd operand array out of the 
c   first operand array, forming a scalar result.
c--------------------------------------------------------------------------
      implicit none

      integer ne1,ne2,nf1,nf2,
     *        ni1,ni2,nj1,nj2
      integer e1,e2,f1,f2,i1,i2,j1,j2
      integer indx1(2), indi, indj
      integer flopcount

      double precision y
      double precision x1(ne1:ne2,nf1:nf2)
      double precision x2(ni1:ni2,nj1:nj2)

      integer ii, ij, ix(2)
      integer i, j, k, n

c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various x2 
c   indices.
c---------------------------------------------------------------------------

      do i = 1,2 
         if (indx1(i) .eq. indi) then
            ii = i
         else if (indx1(i) .eq. indj) then
            ij = i
         else
            print *,'Error: Invalid index in cwork2422'
            print *,'X1 index is ',indx1(i),
     *              ' x2 indices: ',indi,indj
            call abort_job() 
         endif
      enddo

      flopcount = 2 * (i2-i1+1)*(j2-j1+1)
     
      if (ii .ne. 1) then        

c-------------------------------------------------------------------------
c   Indices do not match up, use indirect addressing to perform contraction.
c---------------------------------------------------------------------------

         y = 0.
         do j = j1, j2
            ix(ij) = j
         do i = i1, i2 
            ix(ii) = i
            y = y + x2(i,j)*x1(ix(1),ix(2))
         enddo
         enddo
      else

c--------------------------------------------------------------------------
c   Indices match.  Use optimized contraction loop.
c--------------------------------------------------------------------------

         n = (i2-i1+1)*(j2-j1+1)

         y = 0.
         do j = j1, j2
         do i = i1, i2
            y = y + x1(i,j)*x2(i,j)
         enddo
         enddo
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_DERV_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      NEXP,NGQPCEN,NGEXCEN,
     +                      NXYZA,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_DERV_INT1D_TO_A0
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative nuclear attraction integrals [A|0] or [0|A],
C                adding up the contributions from all the 1D A0 or 0A
C                integrals for all nuclear centers.
C
C                Simplified version of the general AB routine to reduce
C                loop overheads for those cases where there is at least
C                one s-shell. For comments and details see the general
C                AB routine.
C
C
C                  Input:
C
C                    SHELLA      =  shell types for contraction shell A
C                    NEXP        =  current # of exponent pairs
C                    NGQPCEN     =  product of # of gaussian quadrature
C                                   points (roots) times # of nuclear
C                                   attraction centers
C                    NGEXCEN     =  product of # of gaussian quadrature
C                                   points times # of exponent pairs
C                                   times # of nuclear attraction
C                                   centers
C                    NXYZA       =  # of cartesian monomials for shell A
C                    INT1Dx      =  all current 1D A0/0A derivative
C                                   nuclear attraction integrals for
C                                   each cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1D A0/0A derivative integral
C                                   products
C                    SCALE       =  the NGEXCEN scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [A|0] or [0|A] derivative nuclear
C                                   attraction integrals corresponding
C                                   to all current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,K,M,N
         INTEGER     NEXP,NGQPCEN,NGEXCEN
         INTEGER     NXYZA
         INTEGER     SHELLA
         INTEGER     XA,YA,ZA
         INTEGER     YAMAX

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NGEXCEN)
         DOUBLE PRECISION  TEMP1 (1:NGEXCEN)
         DOUBLE PRECISION  TEMP2 (1:NGEXCEN)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZA)

         DOUBLE PRECISION  INT1DX (1:NGEXCEN,0:SHELLA)
         DOUBLE PRECISION  INT1DY (1:NGEXCEN,0:SHELLA)
         DOUBLE PRECISION  INT1DZ (1:NGEXCEN,0:SHELLA)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...outer loop over x-contribution. No skipping of
C                x-contribution of 0-type can be done here,
C                since the 1DX integrals carry the Rys weight!
C
C
         I = 0
         DO 100 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            DO N = 1,NGEXCEN
               TEMP1 (N) = SCALE (N) * INT1DX (N,XA)
            END DO
C
C
C             ...inner loop over y-contribution. Skip the multiplication
C                of y-contributions, if no y-coordinate derivative
C                was formed and we have a 0-contribution, as then the
C                1DY integrals are equal to 1.
C
C
            DO 110 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NGEXCEN
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGEXCEN
                      TEMP2 (N) = TEMP1 (N) * INT1DY (N,YA)
                   END DO
               END IF
C
C
C             ...skip multiplication of z-contributions, if we
C                have a 0-type and no derivations were performed
C                on the z-coordinate, as then the 1DZ integrals
C                are equal to 1. All info concerning all three
C                x,y and z contributions have been collected for all
C                exponent pairs, nuclear centers and quadrature points
C                at once. Sum up the 1D X,Y,Z integral products over
C                the nuclear centers and the quadrature points to
C                the appropriate place of the [A|0] or [0|A] batch.
C
C
               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   K = 0
                   DO M = 1,NEXP
                      SUM = ZERO
                      DO N = 1,NGQPCEN
                         SUM = SUM + TEMP2 (K+N)
                      END DO
                      K = K + NGQPCEN
                      BATCH (M,I) = SUM
                   END DO
               ELSE
                   K = 0
                   DO M = 1,NEXP
                      SUM = ZERO
                      DO N = 1,NGQPCEN
                         SUM = SUM + TEMP2 (K+N) * INT1DZ (K+N,ZA)
                      END DO
                      K = K + NGQPCEN
                      BATCH (M,I) = SUM
                   END DO
               END IF
C
C
C             ...next z- and y-contributions.
C
C
  110       CONTINUE
C
C
C             ...next x-contribution.
C
C
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE CMP_ANGLE(ILFTEND, IMIDLE, IRHTEND, CARTCOORD,
     &                     VLUANGLE, NRATMS) 
C
C This is a simple routine to calculate the angle between two vectors,
C ILFTEND and IRHTEND and the center is IMIDLE. The angle is retrun
C in VLUANGLE.
C      
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION CARTCOORD(3*NRATMS), VEC1(3), VEC2(3)


      CALL VEC(CARTCOORD(IMIDLE*3 - 2), CARTCOORD(ILFTEND*3 - 2), 
     &         VEC1, 1)
C
      CALL VEC(CARTCOORD(IMIDLE*3 - 2), CARTCOORD(IRHTEND*3 - 2), 
     &         VEC2, 1)

      VLUANGLE = ANGLE(VEC1, VEC2, 3)
C
      RETURN
      END

c This routine grabs a record from JOBARC and compares it to data in test files.
c Recognized datatypes: i/nt/eger, d/ouble, f/loat, r/eal (technically,
c anything not an integer is processed as a double)




      subroutine test(args,numfiles)
      implicit none

c ARGUMENT LIST
      integer numfiles
      character*80 args(numfiles)

c INTERNAL VARIABLES
      integer iFile, iStat
      integer iFirst, iLast
      logical bWarn, bCont
      character*80 sz
      character*80 szRecName
      character*80 szDataType
      character*1 czSpace, czTab

c EXTERNAL FUNCTIONS
      logical leq
      integer fnblnk, linblnk
      external leq, fnblnk, linblnk

c COMMON BLOCKS
      integer            iErrExit
      common /exit_stat/ iErrExit
      save   /exit_stat/


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end





c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end





c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end

c ----------------------------------------------------------------------

      if (numfiles.lt.1) then
         print *, '@TEST: The test module requires at least 1 argument'
         print '()'
         print *, '  xa2proc test <file> [ <file> [ <file> [ ... ]]]'
         call aces_exit(1)
      end if

      iErrExit = 0

c   o constants
      czSpace = achar(32)
      czTab   = achar(9)

c   o loop over the file arguments
      do iFile = 1, numfiles
         iLast = linblnk(args(iFile))
c         print *, '@TEST: processing file "',args(iFile)(1:iLast),'"'

c      o open the file
         open(unit=10,file=args(iFile)(1:iLast),
     &        form='FORMATTED',status='OLD',err=9999,iostat=iStat)
         rewind(10)
         bWarn = .true.

c      o loop over records and data until EOF or bCont=F
         read(10,'(a)',end=100,err=9999) sz
         bCont = .true.
         do while (bCont)
         if (0.eq.fnblnk(sz)) then
            read(10,'(a)',end=100,err=9999) sz
         else
            bWarn = .false.

c         o read the data type
            iFirst = 1
            do while ((sz(iFirst:iFirst).eq.czSpace.or.
     &                 sz(iFirst:iFirst).eq.czTab).and.
     &                iFirst.le.80)
               iFirst = iFirst + 1
            end do
            iLast = iFirst
            do while ((sz(iLast:iLast).ne.czSpace.and.
     &                 sz(iLast:iLast).ne.czTab).and.
     &                iLast.lt.80)
               iLast = iLast + 1
            end do
            if (iFirst.ne.81) then
               if (sz(iLast:iLast).eq.czSpace.or.
     &             sz(iLast:iLast).eq.czTab) iLast = iLast - 1
               szDataType = sz(iFirst:iLast)
            end if

c         o read the record name
            iFirst = iLast + 1
            do while ((sz(iFirst:iFirst).eq.czSpace.or.
     &                 sz(iFirst:iFirst).eq.czTab).and.
     &                iFirst.le.80)
               iFirst = iFirst + 1
            end do
            iLast = iFirst
            do while ((sz(iLast:iLast).ne.czSpace.and.
     &                 sz(iLast:iLast).ne.czTab).and.
     &                iLast.lt.80)
               iLast = iLast + 1
            end do
            if (iLast.gt.80) then
               print *, '@TEST: string overflow while reading rec name'
               call aces_exit(1)
            end if
            if (sz(iLast:iLast).eq.czSpace.or.
     &          sz(iLast:iLast).eq.czTab) iLast = iLast - 1
            szRecName = sz(iFirst:iLast)

c            print *, 'DEBUG: ',szDataType(1:1),' "',szRecName(1:8),'"'
            if (szDataType(1:1).eq.'i'.or.szDataType(1:1).eq.'I') then
c            o integers
               call test_int(10,sz,bCont,
     &                       szRecName(1:8),icore(i0),icrsiz)
            else
c            o doubles
               call test_dbl(10,sz,bCont,
     &                       szRecName(1:8),icore(i0),icrsiz/iintfp)
            end if

c        end if (sz.ne.' ')
         end if
c        end do while (bCont)
         end do

c      o close the file
 100     close(10,status='KEEP')
         if (bWarn) then
            print *, '@TEST: WARNING: Test file "',args(iFile)(1:iLast),
     &               '" has no test data.'
         end if
      end do

      if (iErrExit.ne.0) call aces_exit(iErrExit)
      print *, '@TEST: All test records pass.'

      return

 9999 call aces_io_error('TEST',10,iStat)

c     end subroutine test
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine deallocate_instruction(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, op, 
     *                      comm_timer, instruction_timer)
c---------------------------------------------------------------------------
c   Runtime implementation code for the DEALLOCATE instruction.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blkmgr.h'
      include 'checkpoint_data.h'

      integer narray_table, nindex_table, nsegment_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer block_map_table(lblock_map_entry,*)
      integer op(loptable_entry)
      integer comm_timer, instruction_timer

      integer array, type, next, flag, flagtest
      integer stack, i, j, array_data, blk, blkndx, request
      integer get_block_request
      integer*8 ixx
      integer*8 get_index_from_base
      integer bhdr(1) 

      array = op(c_result_array)
      type  = array_table(c_array_type,array)
      if (type .ne. local_array) then
         print *,'Error: Deallocate instruction requires a local_array'
         print *,'Array, type = ',array,type
         call abort_job()
      endif

      flagtest = or(block_busy_flag,block_persistence_flag)
      ixx      = get_index_from_base(addr_blk_header, bhdr, 1)
      stack    = array_table(c_array_stack, array)

c-----------------------------------------------------------------------------
c   Scan the linked list of blocks in the array, releasing the blocks as
c   we go.
c-----------------------------------------------------------------------------

      next = array_table(c_block_list, array)
 2000 continue
      if (next .ne. 0) then
         i = next
         array_data =
     *            bhdr(ixx+(c_array_handle-1)*blkmgr_blocks+i-1)
c         call get_blk_header(array_data, i, c_array_handle)

         if (array_data .eq. array) then

c--------------------------------------------------------------------------
c   The block matches the array.  We can get rid of it now.
c--------------------------------------------------------------------------

            call get_block_id(stack, i, array, blk)
            blkndx = i
            array_table(c_current_blkndx, array) = i  ! Update array table entry

            call clear_block_created_flag(array, blk, blkndx)

c--------------------------------------------------------------------------
c   Must not free this block if it is engaged in communication.
c--------------------------------------------------------------------------

            request = get_block_request(array, blk, blkndx)
            if (request .ne. MPI_REQUEST_NULL)
     *         call wait_on_block(array, blk, blkndx, type, request,
     *             instruction_timer, comm_timer)

c-------------------------------------------------------------------------
c   Find the next block in the linked list.
c-------------------------------------------------------------------------

            call get_blk_header(next, i,c_block_list_ptr)
            if (next .eq. i) then
               print *,'Error: Recursion in block list'
               print *,'array = ',array,' head = ',
     *             array_table(c_block_list,array)
               call abort_job()
            endif

            call_marker = 30303
            call free_block(array, blk, blkndx, array_table,
     *                      narray_table, index_table, nindex_table,
     *                      block_map_table)
         endif

         go to 2000
      endif

c---------------------------------------------------------------------------
c   We have traversed the list.  We have deallocated all the blocks of the 
c   array.
c
c   Now, remove the last allocate for this array from the checkpoint data.
c---------------------------------------------------------------------------

      do i = nactive_allocate_table, 1, -1
         if (active_allocate_table(i) .eq. array) then 
            
c--------------------------------------------------------------------------
c   Shift remaining table data over this entry. 
c--------------------------------------------------------------------------

            do j = i+1, nactive_allocate_table
               active_allocate_table(j-1) = active_allocate_table(j)
               active_allocate_op(j-1)    = active_allocate_op(j)
            enddo

            nactive_allocate_table = nactive_allocate_table - 1
            return
         endif
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_blocks_to_list_msg(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_blocks_to_list message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'block_index.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, j, k, istart, nsearch, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind, imsg
      integer msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile, nxt
      integer request, status(MPI_STATUS_SIZE)
      integer array, nindex, tag, f_form_msg_tag 
      integer msglen
      integer msg(100)
      integer*8 offset, index_file_loc
      integer fh, fhndx, mode
      integer block_index_entry(lblk_index_entry)
      logical flag
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      save fh, fhndx

#ifdef ALTIX
      dptr = dshptr
#endif

      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then
         array = server_msg(c_msg_array,node)
         if (array .eq. 0) then

c--------------------------------------------------------------------------
c   We are being signalled to open the BLOCKDATA files.  More messages 
c   with array info are coming later.
c--------------------------------------------------------------------------

            mode = MPI_MODE_CREATE + MPI_MODE_WRONLY
            call mpi_file_open(mpi_comm_world, 'BLOCKDATA2', mode,
     *                   MPI_INFO_NULL, fh, ierr)
            offset = 0
            call mpi_file_set_view(fh, offset, MPI_DOUBLE_PRECISION,
     *                       MPI_DOUBLE_PRECISION, 'native',
     *                       MPI_INFO_NULL, ierr)

            call mpi_file_open(mpi_comm_world, 'BLOCK_INDEX2', mode,

     *                   MPI_INFO_NULL, fhndx, ierr)
            offset = 0
            call mpi_file_set_view(fhndx, offset, MPI_INTEGER,
     *                       MPI_INTEGER, 'native',
     *                       MPI_INFO_NULL, ierr)

            server_msg(c_msg_state,node) = null_state
            return 
         else if (array .eq. blocks_list_done) then
        
c----------------------------------------------------------------------------
c   Signal to close the files.
c----------------------------------------------------------------------------

            call mpi_file_sync(fh, ierr)
            call mpi_file_close(fh, ierr)
            call mpi_file_sync(fhndx, ierr)
            call mpi_file_close(fhndx, ierr)
 
            server_msg(c_msg_state,node) = null_state
            return
         endif

c---------------------------------------------------------------------------
c   Locate the server_table entries for this array.
c---------------------------------------------------------------------------

         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               istart = served_array_entry(i)
               nsearch = served_numblocks(i)
               go to 50
            endif
         enddo

c---------------------------------------------------------------------------
c   Array not found on this server.   We have nothing to do.
c---------------------------------------------------------------------------

         go to 1000
 
   50    continue
         indblk = get_index_from_base(base_mem_addr, x, 2)
         index_file_loc = blk_to_list_offset(1,node) 
         offset         = blk_to_list_offset(2,node)

c---------------------------------------------------------------------------
c   Calculate the index of the message buffer.
c--------------------------------------------------------------------------

         msgbuffer = server_msg(c_msg_msgbuffer,node)
         imsg = indblk + (msgbuffer-1)* server_mem_blocksize

c---------------------------------------------------------------------------
c   Process each block of the array found in the server_table.
c---------------------------------------------------------------------------

         do iblock = istart, istart+nsearch-1
            if (server_table(c_server_array,iblock) .eq. array) then
               if (server_table(c_server_iblk,iblock) .eq. 
     *                               99999999) then
                  print *,'No message for iblock ',iblock
                  print *,(server_table(i,iblock),
     *                     i=1,lserver_table_entry)
                  call server_abort_job(server_table, nserver_table)
               endif

               size = server_table(c_server_size,iblock)
               if (server_table(c_server_memloc,iblock) .ne. 0) then
                  
c---------------------------------------------------------------------------
c   Data is found in memory.
c---------------------------------------------------------------------------
   
                  j = server_table(c_server_memloc,iblock)
                  ind = indblk + (j-1) * server_mem_blocksize
               else if (server_table(c_server_diskloc,iblock) .gt. 
     *                      0) then 

c---------------------------------------------------------------------------
c   Read the data from disk into the node's message buffer.
c---------------------------------------------------------------------------

                  diskloc = server_table(c_server_diskloc,iblock)
                  ifile   = server_table(c_server_file, iblock)
                  call f_restoreram(server_unit(ifile), diskloc,
     *                           server_blocksizes(ifile),
     *                           x(imsg), size)
                  ind = imsg
               else
                  print *,'Server ',me,': Error in write_blocks_to_list'
                  print *,'   Array ',array,
     *                    ' erroneous server_table entry'
                  print *,(server_table(i,iblock),i=1,
     *                      lserver_table_entry)
                  call server_abort_job(server_table, nserver_table)
               endif

c-------------------------------------------------------------------------
c   Write block to disk.
c-------------------------------------------------------------------------

               call mpi_file_write_at(fh, offset, x(ind),
     *                     size, MPI_DOUBLE_PRECISION, status,
     *                     ierr)
c               print *,'B2L: offset, size ',offset,size,' xxx ',
c     *                block_energy(x(ind), size)

c--------------------------------------------------------------------------
c   Write the index file data to disk.
c--------------------------------------------------------------------------

               block_index_entry(c_blk_index_array) = array
               block_index_entry(c_blk_index_blkno) = 
     *                      server_table(c_server_iblk,iblock)
               block_index_entry(c_blk_index_size)  = size
               nindex = server_table(c_server_nind,iblock)
               block_index_entry(c_blk_index_nind)  = nindex
               do k = 1, nindex
                  block_index_entry(c_blk_index_bsegs+k-1) = 
     *              server_table(c_server_bsegs+k-1,iblock)
                  block_index_entry(c_blk_index_esegs+k-1) = 
     *              server_table(c_server_esegs+k-1,iblock)
               enddo
 
               call mpi_file_write_at(fhndx, index_file_loc,
     *                     block_index_entry, lblk_index_entry,
     *                     MPI_INTEGER, status,
     *                     ierr)
               index_file_loc = index_file_loc + lblk_index_entry
               offset = offset + size
            endif
         enddo

c--------------------------------------------------------------------------
c   Complete the processing of this message by entering the null state.
c--------------------------------------------------------------------------

1000     continue   
         server_msg(c_msg_state,node) = null_state   ! done
      endif   ! state
      return
      end

cjp closes moints and moabcd and reopens them with new iref

      subroutine reopenmo
      implicit integer (a-z)
#include "bwcc.com"

      if (nref.gt.1) call loadmoio

      close(50)
      close(52)
      call aces_io_open(1)
      call aces_io_open(3)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__E0F0_PCGTO_BLOCK
     +
     +                    ( NBATCH,NINT2D,
     +                      ATOMIC,ATOMAB,ATOMCD,
     +                      MIJ,MKL,MIJKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NGQP,NMOM,NGQSCR,MGQIJKL,
     +                      NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                      NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                      SHELLA,SHELLP,SHELLC,SHELLQ,
     +                      XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD,
     +                      ABX,ABY,ABZ,CDX,CDY,CDZ,
     +                      ALPHAA,ALPHAB,ALPHAC,ALPHAD,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIMA,PRIMB,PRIMC,PRIMD,
     +                      NORMA,NORMB,NORMC,NORMD,
     +                      RHOAB,RHOCD,
     +                      P,PX,PY,PZ,PAX,PAY,PAZ,PINVHF,SCALEP,
     +                      Q,QX,QY,QZ,QCX,QCY,QCZ,QINVHF,SCALEQ,
     +                      RTS,WTS,GQSCR,TVAL,PQPINV,SCALEPQ,
     +                      B00,B01,B10,C00X,C00Y,C00Z,D00X,D00Y,D00Z,
     +                      INT2DX,INT2DY,INT2DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__E0F0_PCGTO_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__RYS_ROOTS_WEIGHTS
C                ERD__2D_COEFFICIENTS
C                ERD__2D_PQ_INTEGRALS
C                ERD__INT2D_TO_E000
C                ERD__INT2D_TO_E0F0
C                ERD__2D_ATOM_COEFFICIENTS
C                ERD__2D_ATOM_PQ_INTEGRALS
C                ERD__ATOM_INT2D_TO_E000
C                ERD__ATOM_INT2D_TO_E0F0
C  DESCRIPTION : This operation calculates a batch of unnormed electron
C                repulsion integrals between primitive cartesian
C                gaussians for the shell quadruplet range:
C
C                    [E0|F0]     , E = A to P, F = C to Q
C                           ijkl
C
C                and the block of ij and kl exponent pairs. The total
C                number of eris generated here is thus given by the
C                total number of cartesian monomials NXYZET*NXYZFT
C                times the total number of exponent pairs MIJKL in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (kl,ij,nxyzt)
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    integral batch
C                    NINT2D       =  space needed for each of the 2D
C                                    X,Y,Z integral arrays
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    ATOMAB(CD)   =  indicates, if centers A and B
C                                    (C and D) coincide
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the contracted shell pairs A,B
C                                    (C,D)
C                    MIJKL        =  current # of ijkl primitive
C                                    index quadruplets (= MIJ*MKL)
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NKL          =  total # of kl primitive index
C                                    pairs for the contracted shell
C                                    pair C,D
C                    NKLBEG(END)  =  first(last) kl primitive index
C                                    defining the kl block
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    MGQIJKL      =  # of roots times # of ijkl
C                                    quadruplets (= NGQP*MIJKL)
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B,C,D
C                    NXYZE(F)T    =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    E = A,...,P=A+B and in the range
C                                    F = C,...,Q=C+D
C                    NXYZP(Q)     =  # of cartesian monomials for
C                                    the P=A+B and Q=C+D shells
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,P=A+B,C,Q=C+D
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B,C,D
C                    ABm(CDm)     =  the m=x,y,z-coordinate differences
C                                    between centers A and B (C and D)
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B,C,D
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j,k,l labels of primitives for
C                                    the respective contraction shells
C                                    x = A,B,C,D
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B,C,D
C                    RHOAB(CD)    =  the complete set of NIJ (NKL)
C                                    exponential prefactors between
C                                    contraction shells A and B
C                                    (C and D)
C                    P            =  will hold current MIJ exponent
C                                    sums for contraction shells A
C                                    and B
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=A+B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALEP       =  will hold current MIJ values of
C                                    scaling factors related to point P
C                    Q            =  will hold current MKL exponent
C                                    sums for contraction shells C
C                                    and D
C                    Qx           =  will hold current MKL coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers Q=C+D
C                    QCx          =  will hold current MKL coordinate
C                                    x=X,Y,Z differences Q-C between
C                                    centers Q and C
C                    QINVHF       =  will hold current MKL values of
C                                    1/(2*Q), where Q are the exponent
C                                    sums for contraction shells C
C                                    and D
C                    SCALEQ       =  will hold current MKL values of
C                                    scaling factors related to point Q
C                    RTS          =  will hold all current MGQIJKL
C                                    quadrature roots
C                    WTS          =  will hold all current MGQIJKL
C                                    quadrature weights
C                    GQSCR        =  will be used as scratch space
C                                    for determining the quadrature
C                                    roots and weights
C                    TVAL         =  will hold current MIJKL values
C                                    of T-exponents defining the Rys
C                                    weight functions
C                    PQPINV       =  will hold current MIJKL values
C                                    of 1/(P+Q), i.e. the inverses
C                                    of all total exponent sums
C                    SCALEPQ      =  will hold current distinct MIJKL
C                                    (expanded to MGQIJKL) values of
C                                    the overal scaling factors for
C                                    the integrals
C                    Bxx          =  will hold the current MGQIJKL
C                                    coordinate independent VRR
C                                    B-coefficients (xx=00,01,10)
C                    C00x         =  will hold the current MGQIJKL
C                                    VRR C-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    D00x         =  will hold the current MGQIJKL
C                                    VRR D-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center Q
C                    INT2Dx       =  will hold all current 2D integrals
C                                    for each cartesian component
C                                    (x = X,Y,Z)
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian [E0|F0] integrals
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOMAB,ATOMCD

         INTEGER     CASE2D,CASEAT
         INTEGER     G000,G010,G020,G030,G040,G050,G060
         INTEGER     I,J,K,L,M,N
         INTEGER     IJ,KL
         INTEGER     MGRID,NGRID
         INTEGER     MIJ,MKL,MIJKL,MGQIJKL
         INTEGER     NBATCH,NINT2D
         INTEGER     NGQP,NMOM,NGQSCR
         INTEGER     NIJ,NKL
         INTEGER     NIJBEG,NIJEND,NKLBEG,NKLEND
         INTEGER     NPGTOA,NPGTOB,NPGTOC,NPGTOD
         INTEGER     NXYZET,NXYZFT,NXYZP,NXYZQ
         INTEGER     SHELLA,SHELLP,SHELLC,SHELLQ

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)
         INTEGER     PRIMC (1:MKL)
         INTEGER     PRIMD (1:MKL)

         DOUBLE PRECISION  ABX,ABY,ABZ,CDX,CDY,CDZ
         DOUBLE PRECISION  EXPA,EXPB,EXPC,EXPD
         DOUBLE PRECISION  INVERS
         DOUBLE PRECISION  PINV,QINV,PVAL,QVAL
         DOUBLE PRECISION  PQPLUS,PQMULT
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL
         DOUBLE PRECISION  RNPQSQ
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD
         DOUBLE PRECISION  ZERO,HALF,ONE

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)
         DOUBLE PRECISION  ALPHAC  (1:NPGTOC)
         DOUBLE PRECISION  ALPHAD  (1:NPGTOD)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)
         DOUBLE PRECISION  NORMC   (1:NPGTOC)
         DOUBLE PRECISION  NORMD   (1:NPGTOD)

         DOUBLE PRECISION  RHOAB   (1:NIJ)
         DOUBLE PRECISION  RHOCD   (1:NKL)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  P       (1:MIJ)
         DOUBLE PRECISION  PX      (1:MIJ)
         DOUBLE PRECISION  PY      (1:MIJ)
         DOUBLE PRECISION  PZ      (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)
         DOUBLE PRECISION  SCALEP  (1:MIJ)

         DOUBLE PRECISION  Q       (1:MKL)
         DOUBLE PRECISION  QX      (1:MKL)
         DOUBLE PRECISION  QY      (1:MKL)
         DOUBLE PRECISION  QZ      (1:MKL)
         DOUBLE PRECISION  QCX     (1:MKL)
         DOUBLE PRECISION  QCY     (1:MKL)
         DOUBLE PRECISION  QCZ     (1:MKL)
         DOUBLE PRECISION  QINVHF  (1:MKL)
         DOUBLE PRECISION  SCALEQ  (1:MKL)

         DOUBLE PRECISION  B00     (1:MGQIJKL)
         DOUBLE PRECISION  B01     (1:MGQIJKL)
         DOUBLE PRECISION  B10     (1:MGQIJKL)
         DOUBLE PRECISION  C00X    (1:MGQIJKL)
         DOUBLE PRECISION  C00Y    (1:MGQIJKL)
         DOUBLE PRECISION  C00Z    (1:MGQIJKL)
         DOUBLE PRECISION  D00X    (1:MGQIJKL)
         DOUBLE PRECISION  D00Y    (1:MGQIJKL)
         DOUBLE PRECISION  D00Z    (1:MGQIJKL)
         DOUBLE PRECISION  RTS     (1:MGQIJKL)
         DOUBLE PRECISION  SCALEPQ (1:MGQIJKL)
         DOUBLE PRECISION  WTS     (1:MGQIJKL)
         DOUBLE PRECISION  GQSCR   (1:NGQSCR)
         DOUBLE PRECISION  TVAL    (1:MIJKL)
         DOUBLE PRECISION  PQPINV  (1:MIJKL)

         DOUBLE PRECISION  INT2DX  (1:NINT2D)
         DOUBLE PRECISION  INT2DY  (1:NINT2D)
         DOUBLE PRECISION  INT2DZ  (1:NINT2D)

         DOUBLE PRECISION  FTABLE  (0:MGRID,0:NGRID)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (HALF  =  0.5D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...predetermine 2D integral case. This is done in
C                order to distinguish the P- and Q-shell combinations
C                for efficient evaluation of the 2D integrals and
C                their VRR coefficients. The cases distinguished
C                are summarized in the following table, indicating
C                the value of CASE2D:
C
C                                Q-shell
C                              s    p   >p
C                            ---------------
C                           |
C                         s |  1    4    7
C                           |
C                P-shell  p |  2    5    8
C                           |
C                        >p |  3    6    9
C                           |
C
C
C
         CASE2D = 3 * MIN0 (2,SHELLQ) + MIN0 (2,SHELLP) + 1
C
C
C             ...predetermine in 'K2' loops the quantities associated
C                with the A,B-part and C,D-part. Set the atom equality
C                case CASEAT here to exploit simplifications due to
C                center equalities later on:
C
C                     CASEAT = 1  -->    atomic (AA|AA) integrals
C                            = 2  -->  2-center (AA|CC) integrals
C                            = 3  -->  3-center (AB|CC) integrals
C                            = 4  -->  3-center (AA|CD) integrals
C                            = 5  -->  4-center (AB|CD) integrals
C
C
         CASEAT = 5

         IF (ATOMAB) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                PVAL = ALPHAA (I) + ALPHAB (J)
                P (M) = PVAL
                PX (M) = XA
                PY (M) = YA
                PZ (M) = ZA
                PINVHF (M) = HALF / PVAL
                SCALEP (M) = NORMA (I) * NORMB (J)
  100        CONTINUE
             CASEAT = CASEAT - 1
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                PVAL = EXPA + EXPB
                PINV = ONE / PVAL
                P (M) = PVAL
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PX (M) = PAX (M) + XA
                PY (M) = PAY (M) + YA
                PZ (M) = PAZ (M) + ZA
                PINVHF (M) = HALF * PINV
                SCALEP (M) = NORMA (I) * NORMB (J) * RHOAB (IJ)
  110        CONTINUE
         END IF

         IF (ATOMCD) THEN
             M = 0
             DO 200 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIMC (M)
                L = PRIMD (M)
                QVAL = ALPHAC (K) + ALPHAD (L)
                Q (M) = QVAL
                QX (M) = XC
                QY (M) = YC
                QZ (M) = ZC
                QINVHF (M) = HALF / QVAL
                SCALEQ (M) = NORMC (K) * NORMD (L)
  200        CONTINUE
             CASEAT = CASEAT - 2
         ELSE
             M = 0
             DO 220 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIMC (M)
                L = PRIMD (M)
                EXPC = ALPHAC (K)
                EXPD = ALPHAD (L)
                QVAL = EXPC + EXPD
                QINV = ONE / QVAL
                Q (M) = QVAL
                QVAL = - EXPD * QINV
                QCX (M) = QVAL * CDX
                QCY (M) = QVAL * CDY
                QCZ (M) = QVAL * CDZ
                QX (M) = QCX (M) + XC
                QY (M) = QCY (M) + YC
                QZ (M) = QCZ (M) + ZC
                QINVHF (M) = HALF * QINV
                SCALEQ (M) = NORMC (K) * NORMD (L) * RHOCD (KL)
  220        CONTINUE
         END IF

         IF (ATOMIC) THEN
             CASEAT = CASEAT - 1
         END IF
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block to calculate all T's
C                and scaling factors for the cases:
C
C                     CASEAT = 1  -->    atomic (AA|AA) integrals
C                            = 2  -->  2-center (AA|CC) integrals
C                            = 3  -->  3-center (AB|CC) integrals
C                            = 4  -->  3-center (AA|CD) integrals
C                            = 5  -->  4-center (AB|CD) integrals
C
C                4-center (AB|CD) integrals are checked first
C                (most common occurence in large systems).
C
C
         IF (CASEAT.EQ.5) THEN

             M = 1
             DO 5000 IJ = 1,MIJ
                PVAL = P (IJ)
                PXVAL = PX (IJ)
                PYVAL = PY (IJ)
                PZVAL = PZ (IJ)
                PSCALE = SCALEP (IJ)
                DO 5500 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS
                   PQX = PXVAL - QX (KL)
                   PQY = PYVAL - QY (KL)
                   PQZ = PZVAL - QZ (KL)

                   TVAL (M) = (PQX * PQX + PQY * PQY + PQZ * PQZ)
     +                                  * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 5500           CONTINUE
 5000        CONTINUE

         ELSE IF (CASEAT.EQ.4) THEN

             M = 1
             DO 4000 IJ = 1,MIJ
                PVAL = P (IJ)
                PSCALE = SCALEP (IJ)
                DO 4400 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS
                   PQX = XA - QX (KL)
                   PQY = YA - QY (KL)
                   PQZ = ZA - QZ (KL)

                   TVAL (M) = (PQX * PQX + PQY * PQY + PQZ * PQZ)
     +                                  * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 4400           CONTINUE
 4000        CONTINUE

         ELSE IF (CASEAT.EQ.3) THEN

             M = 1
             DO 3000 IJ = 1,MIJ
                PVAL = P (IJ)
                PXVAL = PX (IJ)
                PYVAL = PY (IJ)
                PZVAL = PZ (IJ)
                PQX = PXVAL - XC
                PQY = PYVAL - YC
                PQZ = PZVAL - ZC
                RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
                PSCALE = SCALEP (IJ)
                DO 3300 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS

                   TVAL (M) = RNPQSQ * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 3300           CONTINUE
 3000        CONTINUE

         ELSE IF (CASEAT.EQ.2) THEN

             PQX = XA - XC
             PQY = YA - YC
             PQZ = ZA - ZC
             RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

             M = 1
             DO 2000 IJ = 1,MIJ
                PVAL = P (IJ)
                PSCALE = SCALEP (IJ)
                DO 2200 KL = 1,MKL
                   QVAL = Q (KL)
                   PQMULT = PVAL * QVAL
                   PQPLUS = PVAL + QVAL
                   INVERS = ONE / PQPLUS

                   TVAL (M) = RNPQSQ * PQMULT * INVERS
                   PQPINV (M) = INVERS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                                  / (PQMULT * DSQRT (PQPLUS))
                   M = M + 1
 2200           CONTINUE
 2000        CONTINUE

         ELSE

             M = 1
             DO 1000 IJ = 1,MIJ
                PVAL = P (IJ)
                PSCALE = SCALEP (IJ)
                DO 1100 KL = 1,MKL
                   QVAL = Q (KL)
                   PQPLUS = PVAL + QVAL
                   TVAL (M) = ZERO
                   PQPINV (M) = ONE / PQPLUS
                   SCALEPQ (M) = PSCALE * SCALEQ (KL)
     +                           / (PVAL * QVAL * DSQRT (PVAL + QVAL))
                   M = M + 1
 1100           CONTINUE
 1000        CONTINUE

         END IF
C
C
C             ...if necessary, expand the scaling array size from
C                MIJKL to MGQIJKL starting from the last elements.
C
C
         IF (NGQP.GT.1) THEN
             N = MGQIJKL + 1
             DO 10 M = MIJKL,1,-1
                DO 20 I = 1,NGQP
                   SCALEPQ (N-I) = SCALEPQ (M)
   20           CONTINUE
                N = N - NGQP
   10        CONTINUE
         END IF
C
C
C             ...determine memory allocation offsets for the scratch
C                arrays used to calculate the quadrature roots +
C                weights:
C
C                   G000 = offset for A coefficients (Jacobi/Laguerre)
C                   G010 = offset for B coefficients (Jacobi/Laguerre)
C                   G020 = offset for moments (Jacobi/Laguerre)
C                   G030 = offset for diagonals of symmetric termat
C                   G040 = offset for offdiagonals of symmetric termat
C                   G050 = offset for first row intermediates during
C                          evaluation of symmetric termat
C                   G060 = offset for second row intermediates during
C                          evaluation of symmetric termat
C
C
         G000 = 1
         G010 = G000 + NMOM
         G020 = G010 + NMOM - 1
         G030 = G020 + NMOM
         G040 = G030 + NGQP
         G050 = G040 + NGQP
         G060 = G050 + NMOM
C
C
C             ...calculate all roots and weights. Array B00 is passed
C                as a scratch array.
C
C
         CALL    ERD__RYS_ROOTS_WEIGHTS
     +
     +                ( MIJKL,MGQIJKL,
     +                  NGQP,NMOM,
     +                  TVAL,B00,
     +                  FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                  GQSCR(G000),GQSCR(G010),
     +                  GQSCR(G020),
     +                  GQSCR(G030),GQSCR(G040),
     +                  GQSCR(G050),GQSCR(G060),
     +
     +                           RTS,
     +                           WTS )
     +
     +
C
C
C             ...perform the following steps:
C
C                1) generate all VRR coefficients.
C
C                2) construct all 2D PQ x,y,z integrals using all the
C                   weights and all the generated VRR coefficients for
C                   all exponent quadruples.
C
C                3) assemble the complete [E0|F0] batch for all ij and
C                   kl pairs using the 2D integrals. Arrays B00 and B01
C                   are passed as scratch arrays.
C
C                The last step 3) is the most compute intensive and
C                separate routines are provided depending on presence
C                of s-shells. The gainings are in the innermost loops
C                of these routines, which are considerably simplified
C                for the special s-shell cases. Note, that the case
C                in which both P- and Q-shells are s-shells cannot
C                arise, as this case is dealt with in separate routines.
C
C
         IF (.NOT.ATOMIC) THEN

             CALL    ERD__2D_COEFFICIENTS
     +
     +                    ( MIJ,MKL,MIJKL,
     +                      NGQP,MGQIJKL,
     +                      ATOMAB,ATOMCD,
     +                      P,Q,
     +                      PX,PY,PZ,QX,QY,QZ,
     +                      PAX,PAY,PAZ,QCX,QCY,QCZ,
     +                      PINVHF,QINVHF,PQPINV,
     +                      RTS,
     +                      CASE2D,
     +
     +                                B00,B01,B10,
     +                                C00X,C00Y,C00Z,
     +                                D00X,D00Y,D00Z )
     +
     +
             CALL    ERD__2D_PQ_INTEGRALS
     +
     +                    ( SHELLP,SHELLQ,
     +                      MGQIJKL,
     +                      WTS,
     +                      B00,B01,B10,
     +                      C00X,C00Y,C00Z,
     +                      D00X,D00Y,D00Z,
     +                      CASE2D,
     +
     +                                INT2DX,
     +                                INT2DY,
     +                                INT2DZ )
     +
     +
             IF (SHELLQ.EQ.0) THEN

                 CALL    ERD__INT2D_TO_E000
     +
     +                        ( SHELLA,SHELLP,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZP,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                    BATCH )
     +
     +
             ELSE IF (SHELLP.EQ.0) THEN

                 CALL    ERD__INT2D_TO_E000
     +
     +                        ( SHELLC,SHELLQ,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZFT,NXYZQ,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                    BATCH )
     +
     +
             ELSE

                 CALL    ERD__INT2D_TO_E0F0
     +
     +                        ( SHELLA,SHELLP,SHELLC,SHELLQ,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                    BATCH )
     +
     +
             END IF

         ELSE

             CALL    ERD__2D_ATOM_COEFFICIENTS
     +
     +                    ( MIJ,MKL,MIJKL,
     +                      NGQP,MGQIJKL,
     +                      P,
     +                      PINVHF,QINVHF,PQPINV,
     +                      RTS,
     +                      CASE2D,
     +
     +                                B00,B01,B10 )
     +
     +
             CALL    ERD__2D_ATOM_PQ_INTEGRALS
     +
     +                    ( SHELLP,SHELLQ,
     +                      MGQIJKL,
     +                      WTS,
     +                      B00,B01,B10,
     +                      CASE2D,
     +
     +                                INT2DX,
     +                                INT2DY,
     +                                INT2DZ )
     +
     +
             IF (SHELLQ.EQ.0) THEN

                 CALL    ERD__ATOM_INT2D_TO_E000
     +
     +                        ( SHELLA,SHELLP,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZP,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE IF (SHELLP.EQ.0) THEN

                 CALL    ERD__ATOM_INT2D_TO_E000
     +
     +                        ( SHELLC,SHELLQ,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZFT,NXYZQ,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             ELSE

                 CALL    ERD__ATOM_INT2D_TO_E0F0
     +
     +                        ( SHELLA,SHELLP,SHELLC,SHELLQ,
     +                          NGQP,MIJKL,MGQIJKL,
     +                          NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                          INT2DX,INT2DY,INT2DZ,
     +                          B00,B01,
     +                          SCALEPQ,
     +
     +                                     BATCH )
     +
     +
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE PRINTDVEC(DVECNAM,LEN)
C
C Designed to print out an integer vector
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION DVECNAM(LEN)
C     
      WRITE(*,*) "len=",LEN
      DO 20 I=1,LEN
         WRITE(*,*) DVECNAM(I)
 20   CONTINUE
C     
      END SUBROUTINE PRINTDVEC
      
      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_prefetch_context()
c----------------------------------------------------------------------------
c   Initializes the prefetch context data structures.
c----------------------------------------------------------------------------
      implicit none
      include 'prefetch.h'
      integer i

      do i = 1, mx_prefetch_context
         ptr_context(i) = 0
      enddo

      nptr_context = 0

      return
      end

      subroutine set_prefetch_context(ind, nind)
c----------------------------------------------------------------------------
c   Saves the array of indices as the "prefetch index context" for the 
c   current loop.
c----------------------------------------------------------------------------
      implicit none
      include 'prefetch.h'
      include 'parallel_info.h'
      include 'trace.h'
      integer nind
      integer ind(nind)
      integer i

      nptr_context = nptr_context + 1
      if (nptr_context .gt. mx_prefetch_context) then
         print *,'Task ',me,' Error: Prefetch context is exhausted.'
         call abort_job() 
      endif

      do i = 1, nind
         context(i,nptr_context) = ind(i)
      enddo

      do i = nind+1,mx_array_index
         context(i,nptr_context) = 0
      enddo

      prefetch_flag = .true.
      return
      end

      logical function is_prefetch_index(ind)
c----------------------------------------------------------------------------
c   Determines whether a given index is in the current prefetch context.
c----------------------------------------------------------------------------
      implicit none
      include 'prefetch.h'
      integer ind
      integer i
  
      is_prefetch_index = .false.
     
      if (nptr_context .eq. 0) return
 
      do i = 1, mx_array_index
         if (ind .eq. context(i,nptr_context)) then
            is_prefetch_index = .true.
            return
         endif 
      enddo
      return
      end

      subroutine unset_prefetch_context()
c----------------------------------------------------------------------------
c   Removes the current prefetch index context, replaces it with the last 
c   previous context.
c----------------------------------------------------------------------------
      implicit none
      include 'prefetch.h'
      include 'parallel_info.h' 
      include 'trace.h'

      nptr_context = nptr_context - 1
      if (nptr_context .lt. 0) then
         print *,'Task ',me,' Error: Prefetch context underflow'
         call abort_job()
      endif

      return
      end

 
      SUBROUTINE FMREVC(IRERDR,OCCORB,IRRORB,NBAS,NIRREP,ISPIN,IUHF,
     &                  CALLER)
C
C FORMS THE REORDERING VECTOR FROM A LIST OF EIGENVALUES AND
C  OCCUPANCIES.
C
C  IRERDR  = REORDERING VECTOR (CONSTRUCTED AND DUMPED)
C  NOCCORB = ORBITAL OCCUPANCY VECTOR (PASSED IN)
C  IRRPOP  = IRREP. POPULATION VECTOR (CONSTRUCTED AND DUMPED)
C  IRRORB  = IRREPS OF INDIVIDUAL ORBITALS (PASSED IN, MODIFIED AND DUMP
C  NBAS    = NUMBER OF BASIS FUNCTIONS (PASSED IN)
C
      IMPLICIT INTEGER (A-Z)
      CHARACTER*3 LABEL(2)
      CHARACTER*1 LABL2(2)
      CHARACTER*5 CALLER
      DIMENSION OCCORB(NIRREP),IRRPOP(8),IRRORB(NBAS),IRERDR(NBAS)
      DATA LABEL /'ALP','BET'/
      DATA LABL2 /'A','B'/
C
C FIGURE OUT HOW MANY BASIS FUNCTIONS THERE ARE IN EACH IRREP.
C
      CALL IZERO(IRRPOP,8)
      DO 5 I=1,NBAS
       IX=IRRORB(I)
       IRRPOP(IX)=IRRPOP(IX)+1
5     CONTINUE
C
C CONSTRUCT REORDERING VECTOR.  START WITH THE OCCUPIED ORBITALS,
C  SINCE THESE GET MAPPED TO THE BOTTOM OF THE UMBPT ORDERING.
C
      IOFF=0
      IX=0
      DO 10 I=1,NIRREP
       DO 20 J=1,OCCORB(I)
        IX=IX+1
        IRERDR(J+IOFF)=IX
20     CONTINUE
       IOFF=IOFF+IRRPOP(I)
10    CONTINUE
C
C NOW DO VIRTUALS WHICH GO AT THE TOP OF THE HEAP.
C
      IOFF=0
      DO 30 I=1,NIRREP
       DO 40 J=1,IRRPOP(I)-OCCORB(I)
        IX=IX+1
        IRERDR(J+OCCORB(I)+IOFF)=IX
40     CONTINUE
       IOFF=IOFF+IRRPOP(I)
30    CONTINUE
C
C NOW RECONSTRUCT THE IRRORB VECTOR TO CORRESPOND TO THE
C  UMBPT ORDERING.
C
      IX=0
      DO 50 I=1,NIRREP
       DO 60 J=1,OCCORB(I)
        IX=IX+1
        IRRORB(IX)=I
60     CONTINUE
50    CONTINUE
      DO 70 I=1,NIRREP
       DO 80 J=1,IRRPOP(I)-OCCORB(I)
        IX=IX+1
        IRRORB(IX)=I
80     CONTINUE
70    CONTINUE
C
C DUMP IRREP POPULATION VECTOR, REORDERING VECTOR AND IRRORB VECTOR.
C
      IF (CALLER .EQ. "VTRAN") THEN
          CALL PUTREC(20,'JOBARC','IRREPPOP',NIRREP,IRRPOP)
          CALL PUTREC(20,'JOBARC','REORDER'//LABL2(ISPIN),NBAS,
     &                IRERDR)
          CALL PUTREC(20,'JOBARC','IRREP'//LABEL(ISPIN),NBAS,
     &                IRRORB)
          IF(IUHF.EQ.0)THEN
             CALL PUTREC(20,'JOBARC','IRREPBET',NBAS,IRRORB)
          ENDIF

      ELSE IF (CALLER .EQ. "VSCF ") THEN

          CALL PUTREC(20,'JOBARC','REORDER'//LABL2(ISPIN),NBAS,
     &                IRERDR)
      ENDIF

   
C
      RETURN
      END

      INTEGER FUNCTION INTGRP(PGRP)
C
C   GET THE INTERNAL NUMBER OF THE IRREP
C  
      CHARACTER*3 IGROUP,PGRP
      DIMENSION IGROUP(8)
      DATA IGROUP /'C1 ','C s','C2 ','C i','D2 ','C2v','C2h','D2h'/
C
      DO 1 I=1,8
         IF(IGROUP(I).EQ.PGRP) GOTO 2
 1    CONTINUE
      WRITE(6,3) 
 3    FORMAT(T3,'@INTGRP-F Symbol of point group do not match')
      CALL ERREX
 2    INTGRP=I
      RETURN
      END

      SUBROUTINE SORTXYZ0(XX,Y,NORD)
C
C *** NOTE !!!  THIS IS THE OLD VERSION OF SORTXYZ (WRITTEN IN
C       1987) WHICH HAS NOW BEEN REPLACED WITH A MORE EFFICIENT
C       VERSION.  HOWEVER, IF PROBLEMS ARISE IN USING THE NEW
C       ROUTINE, THIS ONE SHOULD BE USED INSTEAD ***
C
C     SORTS VECTOR OF NUCLEAR COORDINATES - TO CHECK FOR EQUIVALENCE
C     OF TWO ORIENTATIONS - NEEDS Q VECTOR AND ATOMIC MASS VECTOR (ATMAS
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


      COMMON /TOLERS/ SYMTOL,DEGTOL
      DIMENSION X(3*MXATMS),XX(3*NATOMS),Y(3*NATOMS),NORD(MXATMS*2)
C
      ILINE(J)=1+J/3
C
C
C     SORT ON THE X - IF TWO X'S ARE EQUIVALENT, SORT ON Y AND SO ON.
C
      DO 80 I=1,3*NATOMS
 80      X(I)=XX(I)
C
C     FIRST GIVE DUMMY ATOMS RIDICULOUS SCRATCH COORDINATES - ENSURES
C     THAT THEY WILL WIND UP AT THE BOTTOM OF THE LIST
C
      DO 81 I=1,3*NATOMS-2,3
         IF(DABS(ATMASS(ILINE(I))).LT.1D-3)THEN
            DO 82 J=0,2
 82            X(J+I) = -99995.
         ENDIF
 81   CONTINUE
      JK=1
 429  J=1
      DO 96 I=1,3*NATOMS-2,3
C
C     CONTINUE WITH SORTING.
C
         XDIF=X(I)-X(J)
         YDIF=X(I+1)-X(J+1)
         ZDIF=X(I+2)-X(J+2) 
         AXDIF=ABS(XDIF)
         AYDIF=ABS(YDIF)
         AZDIF=ABS(ZDIF)
         IF(XDIF.GT.SYMTOL)THEN
          J=I
         ELSEIF(AXDIF.LT.SYMTOL)THEN
          IF(YDIF.GT.SYMTOL)THEN
           J=I
          ELSEIF(AYDIF.LT.SYMTOL)THEN
           IF(ZDIF.GT.SYMTOL)J=I
          ENDIF
         ENDIF
 96   CONTINUE
      DO 93 I=0,2
C
C     MASS-WEIGHT SORTED VECTOR - WILL ZERO ELEMENTS CORRESPONDING
C     TO DUMMY ATOMS SO THEY DONT MUCK UP THE SYMMETRY CHECKING.
C
         Y(3*JK-2+I)=X(J+I)*NINT(ATMASS(ILINE(J)))
 93      X(J)=-99999.D0
      NORD(JK)=(J+2)/3
      JK=JK+1
      if(jk.eq.NATOMS+1)go to 999
      go to 429
 999  Continue
      Return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__MEMORY_HRR_CORRECTION(
     *                     angmom, nshells, spheric,
     *                     imax_hrr, zmax_hrr)
c---------------------------------------------------------------------------
c   Uses shell angular momentum information to provide an estimate of 
c   the maximum possible memory necessary for the HRR transformation.
c   This values for integer memory and double precision memory needed 
c   are returned in the variables imax_hrr, zmax_hrr respectively.
c---------------------------------------------------------------------------
      implicit none
      integer nshells  
      integer angmom(nshells)
      integer imax_hrr, zmax_hrr
      logical spheric

      integer iunique(nshells)
      integer i, j, nunique
      integer m, n, r, s
      integer ncolhrr, nrothrr
      integer shell1, shell2, shell3, shell4
      integer shella, shellb, shellc, shelld
      integer shellp, shellq
      integer shellg, shellh
      integer ngh, ngho
      integer ncol, nrot, nrow
      integer nxyze, nxyzf
      integer nxyzhrr
      integer nxyz1, nxyz2, nxyz3, nxyz4
      integer nry1, nry2, nry3, nry4
      integer nhrr1st, nhrr2nd
      integer nxyzet, nxyzft
      integer nxyzg, nxyzh, nxyzi, nxyzp, nxyzq
      integer nxyzgo, nxyzho

      integer add(0:2)

      logical tr1234, swap12, swap34

      data add /0,0,1/

c---------------------------------------------------------------------------
c   Form an array of unique angular momenta from the shell angular momenta.
c---------------------------------------------------------------------------

      iunique(1) = angmom(1)
      nunique = 1
      do 10 i = 2, nshells
         n = nunique

c--------------------------------------------------------------------------
c   Search the current unique list to see if angmom(i) matches any.
c--------------------------------------------------------------------------

         do j = 1, n
            if (angmom(i) .eq. iunique(j)) go to 10
         enddo 

c--------------------------------------------------------------------------
c   Add this value to the unique list.
c--------------------------------------------------------------------------

         nunique = nunique + 1
         iunique(nunique) = angmom(i)
   10 continue
 
c--------------------------------------------------------------------------
c   Loop over all quadruples of unique angular momenta, calculating the
c   max. value of NCOLHRR and NROTHRR as we go.
c--------------------------------------------------------------------------

      ncolhrr = 0
      nrothrr = 0 

      do m = 1, nunique
      do n = 1, nunique
      do r = 1, nunique
      do s = 1, nunique
         shell1 = iunique(m)
         shell2 = iunique(n)
         shell3 = iunique(r)
         shell4 = iunique(s)
C
C
C             ...decide on the 1 <-> 2 and/or 3 <-> 4 swapping.
C
C
         SWAP12 = SHELL1.LT.SHELL2
         SWAP34 = SHELL3.LT.SHELL4

         SHELLP = SHELL1 + SHELL2
         SHELLQ = SHELL3 + SHELL4

         NXYZ1  = (SHELL1+1)*(SHELL1+2)/2
         NXYZ2  = (SHELL2+1)*(SHELL2+2)/2
         NXYZ3  = (SHELL3+1)*(SHELL3+2)/2
         NXYZ4  = (SHELL4+1)*(SHELL4+2)/2

         NRY1 = SHELL1 + SHELL1 + 1
         NRY2 = SHELL2 + SHELL2 + 1
         NRY3 = SHELL3 + SHELL3 + 1
         NRY4 = SHELL4 + SHELL4 + 1

         IF (.NOT.SPHERIC) THEN
             NRY1 = NXYZ1
             NRY2 = NXYZ2
             NRY3 = NXYZ3
             NRY4 = NXYZ4
         END IF

c---------------------------------------------------------------------------
c   Convert shell1, shell2, ... into shella, shellb, etc.
c---------------------------------------------------------------------------

         SHELLA = MAX0 (SHELL1,SHELL2)
         SHELLB = MIN0 (SHELL1,SHELL2)
         SHELLC = MAX0 (SHELL3,SHELL4)
         SHELLD = MIN0 (SHELL3,SHELL4)

         NXYZE  =   ((SHELLP+1)*(SHELLP+2)*(SHELLP+3)/6)
     +            - ((SHELLA  )*(SHELLA+1)*(SHELLA+2)/6)
         NXYZF  =   ((SHELLQ+1)*(SHELLQ+2)*(SHELLQ+3)/6)
     +            - ((SHELLC  )*(SHELLC+1)*(SHELLC+2)/6)

         IF (SHELLB.EQ.0 .AND. SHELLD.EQ.0) THEN
             NXYZHRR = NXYZE * NXYZF
             TR1234 = .FALSE.
         ELSE
             NHRR1ST = MAX0 (NXYZE*NXYZ3*NXYZ4,NXYZ1*NXYZ2*NRY3*NRY4)
             NHRR2ND = MAX0 (NXYZF*NXYZ1*NXYZ2,NXYZ3*NXYZ4*NRY1*NRY2)
             NXYZHRR = MIN0 (NHRR1ST,NHRR2ND)
             TR1234  = NHRR1ST .GT. NHRR2ND
         END IF

         IF (.NOT.TR1234) THEN

             NXYZET = NXYZE
             NXYZFT = NXYZF
             IF (SWAP12) THEN
                 SHELLA = SHELL2
                 SHELLB = SHELL1
             ELSE
                 SHELLA = SHELL1
                 SHELLB = SHELL2
             ENDIF 

             IF (.NOT.SWAP34) THEN
                 SHELLC = SHELL3
                 SHELLD = SHELL4
             ELSE
                 SHELLC = SHELL4
                 SHELLD = SHELL3
             ENDIF
         ELSE

             NXYZET = NXYZF
             NXYZFT = NXYZE
             IF (.NOT.SWAP12) THEN
                 SHELLC = SHELL1
                 SHELLD = SHELL2
             ELSE
                 SHELLC = SHELL2
                 SHELLD = SHELL1
             ENDIF 

             IF (.NOT.SWAP34) THEN
                 SHELLA = SHELL3
                 SHELLB = SHELL4
             ELSE
                 SHELLA = SHELL4
                 SHELLB = SHELL3
             ENDIF
         ENDIF

         SHELLP = SHELLA + SHELLB
         SHELLQ = SHELLC + SHELLD

         NXYZP  = (SHELLP+1)*(SHELLP+2)/2
         NXYZQ  = (SHELLQ+1)*(SHELLQ+2)/2

C
C             ...if HRR contractions are to be performed, calculate
C                NCOLHRR (maximum # of HRR rotation matrix columns
C                needed to generate the final HRR rotation matrices) and
C                NROTHRR (maximum # of HRR rotation matrix elements).
C
C                First find maximum values for the HRR on the AB-part.
C
C
         IF (SHELLB.NE.0) THEN

             NGH = NXYZET
             NXYZG = NXYZET
             NXYZH = 1
             NXYZGO = NXYZET
             NXYZHO = 1
             NXYZI = NXYZP
             SHELLG = SHELLP
             NROW = 1
             NCOL = NGH
             NROT = NGH

             DO 100 SHELLH = 1,SHELLB
                NXYZGO = NXYZGO - NXYZI
                NXYZHO = NXYZHO + SHELLH + 1
                NGHO = NXYZGO * NXYZHO

c---------------------------------------------------------------------------
c   Use max. possible value for NROW, since we do not know atomic 
c   coordinates of each shell.
c---------------------------------------------------------------------------

                    J = 1 + SHELLH/3
                    NROW = NROW +  J*(J + ADD (MOD(SHELLH,3)))

                NCOL = MAX0 (NGHO,NCOL)
                NROT = MAX0 (NROW*NGHO,NROT)

                NGH = NGHO
                NXYZG = NXYZGO
                NXYZH = NXYZHO
                NXYZI = NXYZI - SHELLG - 1
                SHELLG = SHELLG - 1
  100        CONTINUE

             NCOLHRR = MAX0(NCOL, NCOLHRR)
             NROTHRR = MAX0(NROT, NROTHRR)
             
         END IF
C
C
C             ...next find maximum values for the HRR on the CD-part
C                and set overall maximum values.
C
C
         IF (SHELLD.NE.0) THEN

             NGH = NXYZFT
             NXYZG = NXYZFT
             NXYZH = 1
             NXYZGO = NXYZFT
             NXYZHO = 1
             NXYZI = NXYZQ
             SHELLG = SHELLQ
             NROW = 1
             NCOL = NGH
             NROT = NGH

             DO 200 SHELLH = 1,SHELLD
                NXYZGO = NXYZGO - NXYZI
                NXYZHO = NXYZHO + SHELLH + 1
                NGHO = NXYZGO * NXYZHO

                    J = 1 + SHELLH/3
                    NROW = NROW +  J*(J + ADD (MOD(SHELLH,3)))

                NCOL = MAX0 (NGHO,NCOL)
                NROT = MAX0 (NROW*NGHO,NROT)

                NGH = NGHO
                NXYZG = NXYZGO
                NXYZH = NXYZHO
                NXYZI = NXYZI - SHELLG - 1
                SHELLG = SHELLG - 1
  200        CONTINUE

             NCOLHRR = MAX0 (NCOL,NCOLHRR)
             NROTHRR = MAX0 (NROT,NROTHRR)

         END IF

      enddo
      enddo
      enddo
      enddo

c----------------------------------------------------------------------------
c   The amount of memory for the T array in ERD__HRR_MATRIX is 2*NROTHRR.
c   The amount for the ROW array is also 2*NROTHRR.
c----------------------------------------------------------------------------

      imax_hrr = 2*nrothrr
      zmax_hrr = 2*nrothrr

      RETURN
      END

      SUBROUTINE T2T1AB1(W,ICORE,MAXCOR,POP1,POP2,VRT1,VRT2,ISPIN,IUHF,
     &                LAMBDA,LSTOFF)
C
C     THIS SUBROUTINE CALCULATES THE FOLLOWING CONTRIBUTIOBN TO THE
C     T1 INCREMENT (LAMBDA = .FALSE.)
C
C      Z(I,A) =  SUM E,f,m T(Im,Ef) <Am//Ef>
C
C OR   Z(i,a) =  SUM E,f,M T(Mi,Ef) <Ma//Ef)
C
C     OR THE L1 INCREMENT (LAMBDA = .TRUE>)
C
C      Z(I,A) =  SUM E,f,m L(Im,Ef) <Am//Ef>
C
C OR   Z(i,a) =  SUM E,f,M L(Mi,Ef) <Ma//Ef)
C
CEND
C 
C CODED JUNE/90  JG
C     
C SPIN ADAPTED CODE IMPLEMENTED FOR RHF IN AUGUST 90
C
C OUT OF CORE ALGORITHM IMPLEMENTED IN SEPT/90
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LAMBDA
      INTEGER DIRPRD,DISSYT,DISSYW,DISLEFT,DISREAD,DISMAX,
     &                   POP1,POP2,VRT1,VRT2
C
      DIMENSION ICORE(MAXCOR),POP1(8),POP2(8),VRT1(8),VRT2(8)
      DIMENSION W(1),IPT(8)
C 
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /FLAGS/ IFLAGS(100)
C
      DATA AZERO,ONE,ONEM,TWO /0.0D0,1.0D0,-1.0D0,2.0D0/
C
C  DETEMINE LIST NUMBERS
C  LISTT = T2 AMPLITUDES,   LISTW = <EF//AM> INTEGRALS 
C
C  The iflags(39) flag, reserved for "standard" or "semicanonical" 
C  orbitals, is used here to determine which list is needed for the
C  ROHF-MBPT code, since this routine is called by two others at
C  different times.  The value of "99" is set before the second call
C  to E3S in ROHFPT.
C
      IF(LAMBDA) THEN
       LISTT=146
      ELSEIF(IFLAGS(11).EQ.2.AND.IFLAGS(39).EQ.99) THEN
       LISTT=96
      ELSE
       LISTT=46
      ENDIF 
      LISTW=31-ISPIN+LSTOFF
C
C    LOOP OVER IRREPS
C
      DO 1000 IRREP=1,NIRREP
C
C  GET LENGTHS OF VARIOUS ARRAYS AND ALLOCATE CORE
C
      DISSYW=IRPDPD(IRREP,ISYTYP(1,LISTW))
      DISSYT=IRPDPD(IRREP,ISYTYP(1,LISTT))
      NUMSYW=IRPDPD(IRREP,ISYTYP(2,LISTW))
      NUMSYT=IRPDPD(IRREP,ISYTYP(2,LISTT))
      if (NUMSYT*DISSYT.LT.0) call trap_intovf('T2T1AB1',1)
      I001=1
      I002=I001+IINTFP*NUMSYT*DISSYT
      I003=I002+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
      I004=I003+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
      I005=I004+IINTFP*MAX(NUMSYT,NUMSYW,DISSYT,DISSYW)
      if (I005.LT.0) call trap_intovf('T2T1AB1',2)
      MAXSIZE=(MAXCOR-I005)/IINTFP
      IF(MIN(NUMSYT,NUMSYW,DISSYT).NE.0) THEN
C
C  WE ALWAYS NEED THE T2 AMPLITUDES. THEY ARE ASSUMED TO
C  FIT INTO THE AVAILABLE CORE MEMORY. GET THEM HERE.
C
       CALL GETLST(ICORE(I001),1,NUMSYT,1,IRREP,LISTT)
C
C SPIN ADAPTED CODE FOR RHF
C
       IF(IUHF.EQ.0) THEN
        IF(MAXSIZE.LT.DISSYT*NUMSYT) STOP 'W4AB'
        CALL SYMTRA(IRREP,POP1,POP2,DISSYT,ICORE(I001),ICORE(I005))
        CALL SSCAL(NUMSYT*DISSYT,TWO,ICORE(I001),1)
        CALL SAXPY(NUMSYT*DISSYT,ONEM,ICORE(I005),1,ICORE(I001),1)
       ENDIF
C
C   DETERMINE MAXIMUM NUMBER OF DISTRIBUTIONS WHICH CAN BE HELD IN CORE
C
       MAXDIS=MAXSIZE/DISSYW
C
C  CAN WE DO IT IN CORE ?
C
       IF(MAXDIS.GE.NUMSYW) THEN
C
C  IN CORE
C
C      FOR SPIN CASE 1 TRANPOSE THE LAST TWO INDICES
C
       IF(ISPIN.EQ.1) THEN
        CALL SYMTR1(IRREP,POP1,POP2,DISSYT,ICORE(I001),ICORE(I002),
     &             ICORE(I003),ICORE(I004))
       ENDIF
C
C      GET INTEGRALS FROM DISK
C
       CALL GETLST(ICORE(I005),1,NUMSYW,2,IRREP,LISTW)
C
C      FOR SPIN CASE 1 TRANSPOSE THE LAST TWO INDICES
C
       IF(ISPIN.EQ.1) THEN
        CALL SYMTR1(IRREP,VRT1,POP2,DISSYW,ICORE(I005),ICORE(I002),
     &              ICORE(I003),ICORE(I004))
       ENDIF
C
C   PERFORM MULTIPLICATION
C
       IOFFT=0
       IOFFW=0 
       IOFFS=1
       DO 100 IRREPJ=1,NIRREP 
        NVRTJ=VRT1(IRREPJ)
        NOCCJ=POP1(IRREPJ)
        IRREPI=DIRPRD(IRREPJ,IRREP)
        NOCCI=POP2(IRREPI)
C
        IF(MIN(NVRTJ,NOCCJ,NOCCI).NE.0) THEN
C
         CALL XGEMM('T','N',NVRTJ,NOCCJ,NOCCI*DISSYW,ONE,
     &               ICORE(I005+IOFFW*IINTFP),DISSYW*NOCCI,
     &               ICORE(I001+IINTFP*IOFFT),DISSYT*NOCCI,ONE,
     &               W(IOFFS),NVRTJ)
C
        ENDIF
C
C  UPDATE OFFSETS
C 
        IOFFT=IOFFT+NOCCI*NOCCJ*DISSYT
        IOFFW=IOFFW+NVRTJ*NOCCI*DISSYW
        IOFFS=IOFFS+NVRTJ*NOCCJ
C
100    CONTINUE
C
      ELSE
C
C  OUT CORE ALGORITHM
C
C   DIFFER HERE BETWEEN THE TWO SPIN CASES
C
       IF(ISPIN.EQ.1) THEN
C
C   HERE <Ef//Am> T(Ef,Im)  WITH E,f ; I,m AND E,f ; A,m ORDERING
C
C   DETERMINE FIRST OFFSETS WITHIN THE T1 INCREMENTS
C
        IPT(1)=1
        DO 150 IRREPJ=1,NIRREP-1
         IPT(IRREPJ+1)=IPT(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPJ)
150     CONTINUE
C
C   OFFSETS FOR INTEGRAL LIST AND FOR T2 AMPLITUDES
C
        IOFFSET=1
        IOFFT2=0
C
C   LOOP OVER THE IRREPS OF THE LAST INDEX
C
        DO 200 IRREPJ=1,NIRREP
C
         NOCCJ=POP2(IRREPJ)
         IRREPI=DIRPRD(IRREP,IRREPJ)  
         NOCCI=POP1(IRREPI)
         NVRTI=VRT1(IRREPI)
         IF(MIN(NOCCI,NVRTI,NOCCJ).NE.0) THEN
C
C  MAXIMUM NUMBER OF  (E,F,A) BLOCKS WHICH CAN BE HELD IN CORE
C
         DISMAX=MAXDIS/NVRTI
         IF(DISMAX.LE.0) STOP 'W4AB'
C
C   NUMBER OF (E,f,A) BLOCKS TO READ
C
         DISLEFT=NOCCJ
C
10       CONTINUE
C
C  NUMBER OF (E,f,A) BLOCKS WHICH ARE READ IN THIS PASS
C
         DISREAD=MIN(DISLEFT,DISMAX)
         DISLEFT=DISLEFT-DISREAD
C
C    GET THE DISTRIBUTIONS FROM DISK
C
         CALL GETLST(ICORE(I005),IOFFSET,DISREAD*NVRTI,2,IRREP,LISTW)
C
C    UPDATE IOFFSET
C 
         IOFFSET=IOFFSET+DISREAD*NVRTI
C
C  LOOP OVER ALL DISTRIBUTIONS AND PERFORM MULTIPLICATION 
C
         IOFFW=0
         IOFFT1=IPT(IRREPI)
C
         DO 250 NUM=1,DISREAD
C
          CALL XGEMM('T','N',NVRTI,NOCCI,DISSYW,ONE,
     &               ICORE(I005+IINTFP*IOFFW),DISSYW,
     &               ICORE(I001+IINTFP*IOFFT2),DISSYT,
     &               ONE,W(IOFFT1),NVRTI)
C
C    UPDATE OFFSETS
C
          IOFFW=IOFFW+DISSYW*NVRTI
          IOFFT2=IOFFT2+DISSYT*NOCCI
C
250      CONTINUE
C
C    IF NOT ALL (Ef,A) BLOCKS HAVE BEEN PROCESSED, GO BACK TO 10
C
        IF(DISLEFT.NE.0) GO TO 10
C
       ELSE
C
C   UPDATE OFFSETS IN THE CASE NOTHING HAS BEEN DONE
C
        IOFFT2=IOFFT2+DISSYT*NOCCI*NOCCJ
        IOFFSET=IOFFSET+NOCCJ*NVRTI
       ENDIF
200   CONTINUE
C
      ELSE IF(ISPIN.EQ.2) THEN
C
C    HERE <Ef//Ma> T(Ef,Mi) IS COMPUTED, THE ORDERING IS E,f ; M,i AND 
C    E,f ; M,a
C
C   OFFSET FOR INTEGRAL LIST AND FOR T2 AMPLITUDES
C
       IOFFSET=1
       IOFFT2=0
       IOFFT1=1
C
C    LOOP OVER IRREPS OF THE LAST INDEX
C
       DO 300 IRREPJ=1,NIRREP
C
        NOCCJ=POP1(IRREPJ)
        NVRTJ=VRT1(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NOCCI=POP2(IRREPI)
        IF(MIN(NOCCI,NVRTI,NOCCJ).NE.0) THEN
C
C   MAXIMUM NUMBER OF (Ef,I) BLOCKS WHICH CAN BE HELD IN CORE
C
        DISMAX=MAXDIS/NOCCI
C
C   NUMBER OF(Ef,I) BLOCKS TO READ
C
        DISLEFT=NVRTJ
C
        IOFF=0
C
20      CONTINUE
C
C   NUMBER OF(Ef,I) BLOCKS WHICH ARE READ IN THIS PASS
C
         DISREAD=MIN(DISLEFT,DISMAX)
         DISLEFT=DISLEFT-DISREAD
C
C  GET THE DISTRIBUTIONS FROM DISK
C
         CALL GETLST(ICORE(I005),IOFFSET,DISREAD*NOCCI,2,IRREP,LISTW)
C
C  UPDATE IOFFSET
C
         IOFFSET=IOFFSET+DISREAD*NOCCI
C
C        PERFORM MULTIPLICATION
C
         CALL XGEMM('T','N',DISREAD,NOCCJ,DISSYW*NOCCI,ONE,
     &              ICORE(I005),DISSYW*NOCCI,ICORE(I001+
     &              IINTFP*IOFFT2),DISSYT*NOCCI,ONE,W(IOFFT1+IOFF),
     &              NVRTJ)
C
         IOFF=IOFF+DISREAD
C
C   IF NOT ALL (Ef,I) BLOCKS HAVE BEEN PROCESSED, GO BACK TO 20
C
         IF(DISLEFT.NE.0) GO TO 20
C
        ELSE
C
C  UPDATE OFFSETS IN THE CASE NOTHING HAS BEEN DONE
C
         IOFFSET=IOFFSET+NVRTJ*NOCCI
        ENDIF
C
C  UPDATE OFFSETS
C
        IOFFT1=IOFFT1+NOCCJ*NVRTJ
        IOFFT2=IOFFT2+NOCCJ*NOCCI*DISSYT
300    CONTINUE
C
       ENDIF
      ENDIF
      ENDIF
1000  CONTINUE
      RETURN
      END

C
C A fairly simple routine to identify symmetry unique values in the
C array RIN and put the symmetry unique elements to the begining
C of the RIN array followed by locating the elements in the RIN
C array that are being optimized and putting them in ROUT array
C in the proper (to ACES II) order.  Ajith Perera, 01/2005.
C
      SUBROUTINE SYMUNQONLY(RIN, ROUT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
#include "coord.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT

      DIMENSION RIN(NX), ROUT(NX)

      DO I = 1, NUNIQUE
         IP = IUNIQUE(I)
         Z  = RIN(IP)
         DO J = 1, NEQ(IP)
            Z = Z + RIN(IEQUIV(I,J))
         END DO
         FIAVE  = Z/(NEQ(IP)+1)
         RIN(I) = FIAVE
      END DO
      DO IUNQ = 1, NUNIQUE
         ROUT(IUNQ) = RIN(NOPTI(IUNQ))
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sip_integral_init()
c--------------------------------------------------------------------
c
c   sip_integral_init: Handles initialization of worker tasks for
c                         the direct integral computation used by 
c                         the sip implementation.
c 
c---------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'proto_defines.h'
      include 'proto_events.h'
      include 'mem.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'dbugcom.h'
      include 'erd_dbug.h'
      include 'F12.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer me, ierr, my_company, company_comm, company_size
      integer iBytes, i0int
      integer i, j, ncomp
      integer master
      integer itemp, ztemp
      integer nalpha
      integer ihrr, zhrr 
      integer ECP 

      integer nw
      integer*8 nw8
      integer*8 c_loc64
      integer*8 get_index_from_base
      integer*8 addr
      integer status(MPI_STATUS_SIZE)

      integer pst_get_role
      integer pst_get_my_company
      integer pst_get_company
      integer pst_get_mem_scratch
      integer pst_get_master
      integer pst_get_company_comm

      logical configure
      logical spherical
      
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (iptr, ibuf)
#else
      equivalence (ibuf, dbuf)  
      common dbuf    ! blank common for scratch.
#endif

      common /flags/ iflags
      integer iflags(100)

      logical do_erd_scratch_calc
      save do_erd_scratch_calc

      data do_erd_scratch_calc/.true./

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      my_company = pst_get_my_company()
      company_comm = pst_get_company_comm(me) 
      call mpi_comm_size(company_comm, company_size, ierr)
      master = pst_get_master()
         
#ifdef ALTIX
      dptr = dshptr     ! set dbuf pointer to shared mem.
      iptr = ishptr     ! set ibuf pointer to shared mem.
#endif

c------------------------------------------------------------------------
c   Initialization code for integral company.
c------------------------------------------------------------------------

      configure = .true.
      if (intpkg .eq. flocke_package) then
         if (master .eq. me .and. 
     *       .not. master_is_worker) then
            configure = .false.
         else
            nw = nalloc_pkg
            if (nw/2*2 .ne. nw) nw = nw + 1   
            call mem_alloc(dbuf, nw, bytes_per_double, icoord, .true.,
     *                     ierr)
            if (ierr .ne. 0) then
               print *,'Task ',me,' mem_alloc error: basis functions ',
     *                 nw
               call abort_job()
            endif

            nw = nbasis
            if (nw/2*2 .ne. nw) nw = nw + 1   
            call mem_alloc(dbuf, nw, bytes_per_double, iscale_fac, 
     *                     .true., ierr)
            if (ierr .ne. 0) then
               print *,'Task ',me,' mem_alloc error: scale factor',
     *                 nw
               call abort_job()
            endif

            call mem_alloc(ibuf, nw, intsize, ierdind, 
     *                     .true., ierr)
            if (ierr .ne. 0) then
               print *,'Task ',me,' mem_alloc error: ierdind',
     *                 nw
               call abort_job()
            endif

c-------------------------------------------------------------------------
c   Determine max. memory for "ccbeg", "ccend" arrays used in ERD package.
c-------------------------------------------------------------------------

            nw = 0
            do i = 1, nshells
               nw = nw + ncfps(i)
            enddo
            if (nw/2*2 .ne. nw) then
               nw = nw + 1
            else
               nw = nw + 2
            endif
 
            call mem_alloc(ibuf, nw, intsize, iccbeg,
     *                     .true., ierr)
            if (ierr .ne. 0) then
               print *,'Task ',me,' mem_alloc error: iccbeg',
     *                 nw
               call abort_job()
            endif

            call mem_alloc(ibuf, nw, intsize, iccend,
     *                     .true., ierr)
            if (ierr .ne. 0) then
               print *,'Task ',me,' mem_alloc error: iccend',
     *                 nw
               call abort_job()
            endif
         endif
      endif

      if (intpkg .eq. flocke_package) then

c-------------------------------------------------------------------------
c   Recv the obtain the basis functions from the master.
c-------------------------------------------------------------------------

         master = pst_get_master()
         if (master .ne. me) then
            call mpi_recv(dbuf(icoord), nalloc_pkg, 
     *                  mpi_double_precision, master,
     *                  basis_function_request_event, 
     *                  company_comm, status, ierr)  
         else
            icoord = master_icoord
         endif

         call mpi_barrier(company_comm, ierr)

         nalpha = 0
         do i = 1, nshells
            nalpha = nalpha + npfps(i)
         enddo

         ialpha  = icoord + 3*nshells
         ipcoeff = ialpha + nalpha

         if (configure) then

c For ECP must renormalize/reorder 
            ECP = iflags(71) 

            IF (ECP .eq. 1) then 
               call ecp_to_erd(nfps, ivangmom, nshells, ispherical,
     *                         ibuf(ierdind), dbuf(iscale_fac))
               call ecp_renorm(nbasis, ibuf(ierdind), 
     *                         dbuf(iscale_fac)) 
            Else
               call aces_to_erd(nfps, ivangmom, nshells, ispherical,

     *                          ibuf(ierdind), dbuf(iscale_fac))

C The mapping from ERD <-> VMOL (ACES II) is written to JOBARC
C for post ACES II processing. Within ACES III a ERD normalization
C and order is maintained. Ajith Perera, 07/2013.
 
               If (master .EQ. me) then
                   call iputrec(20, "JOBARC", "ERDORDER", nbasis,
     *                          ibuf(ierdind))
                   call dputrec(20, "JOBARC", "ERD2A2CS", nbasis,
     *                          dbuf(iscale_fac))
               Endif
            Endif

            call setup_ccbeg(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, nshells, 
     *                       ibuf(iccbeg), ibuf(iccend), indx_cc)
         endif

         spherical = (ispherical .eq. 1) 

         if (do_erd_scratch_calc) then
            do_erd_scratch_calc = .false.   ! only 1 time EVER!

            if (fast_erd_memcalc) then
               call fast_erd_scratch_mem_calc(nshells, ivangmom, 
     *                          ncfps, npfps,
     *                          atom, dbuf(icoord), dbuf(ialpha),
     *                          dbuf(ipcoeff), ixalpha, ixpcoef,
     *                          ibuf(iccbeg), ibuf(iccend), indx_cc,
     *                          spherical, ncenters, intmax, zmax)
            else
               call erd_scratch_mem_calc(nshells, ivangmom, 
     *                          ncfps, npfps,
     *                          atom, dbuf(icoord), dbuf(ialpha),
     *                          dbuf(ipcoeff), ixalpha, ixpcoef,
     *                          ibuf(iccbeg), ibuf(iccend), indx_cc, 
     *                          spherical, ncenters, 
     *                          calc_2der_integrals,
     *                          intmax, zmax, me, company_size)
            endif


         if(STGF12) then
             zmax = zmax*5
             intmax = intmax*5
         endif

c-------------------------------------------------------------------------
c   Add correction for memory needed in the HRR transformation.
c-------------------------------------------------------------------------

            call erd__memory_hrr_correction(ivAngMom, nshells, 
     *                  spherical, ihrr, zhrr)
            intmax = intmax + ihrr
            zmax   = zmax + zhrr  
         endif

         itemp = intmax
         ztemp = zmax
         call mpi_barrier(company_comm, ierr)
         call mpi_reduce(itemp, intmax, 1,
     *          mpi_integer, mpi_max, 0,
     *          company_comm, ierr)
         call mpi_bcast(intmax, 1, MPI_INTEGER, 0,
     *               company_comm, ierr)

         call mpi_reduce(ztemp, zmax, 1,
     *                mpi_integer, mpi_max, 0,
     *                company_comm, ierr)
         call mpi_bcast(zmax, 1, MPI_INTEGER, 0,
     *               company_comm, ierr)

         if (me .eq. 0 .and. dbg) 
     *       print *,'Integral memory: intmax ',
     *        intmax, ' zmax ',zmax  

c---------------------------------------------------------------------------
c   Add the integral scratch buffers to the memory configuration, and
c   place it in context.
c---------------------------------------------------------------------------

         nw        = zmax
         call mem_alloc(dbuf, nw, bytes_per_double, dpkgscr,
     *                     .true., ierr)
         if (ierr .ne. 0) then
            print *,'Task ',me,' mem_alloc error: dpkgscr',
     *                 nw
            call abort_job()
         endif

         nw        = intmax
         call mem_alloc(ibuf, nw, intsize, ipkgscr,
     *                     .true., ierr)
         if (ierr .ne. 0) then
            print *,'Task ',me,' mem_alloc error: ipkgscr',
     *                 nw
            call abort_job()
         endif
      endif

         max_int_erd = intmax
         max_dp_erd  = zmax
         erd_base_int_addr = c_loc64(ibuf, ipkgscr, intsize)
         erd_base_dp_addr  = c_loc64(dbuf, dpkgscr, bytes_per_double)
         nw8 = zmax
         erd_dp_bounds = c_loc64(dbuf(dpkgscr), nw8, bytes_per_double)
         nw8 = intmax  
         erd_int_bounds = c_loc64(ibuf(ipkgscr), nw8, intsize)
         if (erd_dp_bounds .gt. erd_base_int_addr) then
            print *,'Task ',me,' INTEGRAL MEM ALLOC PROBLEM'
            print *,'Task ',me,' Base of dp mem: ',erd_base_dp_addr
            print *,'Task ',me,' End of dp mem = ',erd_dp_bounds
            print *,'Task ',me,' max_dp_erd    = ',max_dp_erd
            print *,'Task ',me,' Base of int mem = ',erd_base_int_addr
            print *,'Task ',me,' End of int mem = ',erd_int_bounds
            print *,'Task ',me,' max_int_erd    = ',max_int_erd
            call abort_job()
         endif  

c--------------------------------------------------------------------------
c   Initialize flag for computation of 1-electron integrals.
c--------------------------------------------------------------------------

      compute_1e_integrals = .true.

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
       subroutine cwork4622(y, na1,na2,nb1,nb2,
     *                         nc1,nc2,nd1,nd2,
     *                         a1,a2,b1,b2,
     *                         c1, c2, d1, d2,
     *                         inda, indb, indc, indd,
c
     *                      x1,nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2,
     *                         ne1,ne2,nf1,nf2,
     *                          m1, m2, n1, n2, r1, r2, s1, s2,
     *                          e1, e2, f1, f2,
     *                      indx1,
c
     *                      x2,ni1,ni2,nj1,nj2,
     *                          i1, i2, j1, j2,
     *                      indx2,
     *                      cind, flopcount, scr1, scr2, scr3)
c-------------------------------------------------------------------------
c   Performs a "4622" contraction: 
c      4 index output array  : y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
c      6 index operand array : x1(nm1:nm2,nn1:nn2,nr1:nr2,ns1:ns2,ne1:ne2,nf1:nf2)
c      2 index operand array : x2(ni1:ni2,nj1:nj2)
c      2 index contraction.
c
c   I. e., contract two of the the 4 indices of the 2nd operand array out 
c   of the first operand array, replacing the indices by the 2nd operand's 
c   non-contracted indices.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'
      include 'saved_data.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *        ne1,ne2,nf1,nf2,
     *        nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2, 
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2
      integer a1,a2,b1,b2,c1,c2,d1,d2,
     *        e1,e2,f1,f2,
     *        n1,n2,m1,m2,r1,r2,s1,s2,
     *        i1,i2,j1,j2,k1,k2,l1,l2
      integer inda, indb, indc, indd, inde, indf, indx1(6), indx2(2)
      integer cind(2), flopcount

      double precision y(*)
      double precision x1(nm1:nm2,nn1:nn2,nr1:nr2,ns1:ns2,
     *                    ne1:ne2,nf1:nf2)
      double precision x2(ni1:ni2,nj1:nj2)
      double precision scr1(*), scr2(*), scr3(*)
      double precision etemp  
c
c Temporary arrays used in array permutations 
c 
c END Temporary arrays used in array permutations 

c     integer p1, p2, q1, q2
      integer na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, np, nq
      integer p0(4), q1(6), q2(4) 

      integer i1a, i1b, i1c, i1d, i1p, i1q
      integer i2a, i2b, i2c, i2d, i2p, i2q
      integer a, b, c, d, e, f, g, h, i, j, l, p, q
      integer r, s 

#ifdef __crayx1
      integer*8 lda, ldb, ldc, m, nn, k
#else
      integer lda, ldb, ldc, m, nn, k
#endif
      integer n
      character*1 op_a, op_b
      logical b2pq
      logical debug

      debug = cwork_debug
      flopcount = 0

      if (.false.) then

c   o assert x1 is contiguous
      if (m1.ne.nm1.or.n1.ne.nn1.or.r1.ne.nr1.or.s1.ne.ns1.or.
     &    m2.ne.nm2.or.n2.ne.nn2.or.r2.ne.nr2.or.s2.ne.ns2.or.   
     &    e1.ne.ne1.or.e2.ne.ne2.or.f1.ne.nf1.or.f2.ne.nf2    ) then
         print *, '@CWORK4622: Assertion failed.'
         print *, '            The x1 tensor is not contiguous.'
         call abort_job()
      end if

c   o assert x2 is contiguous
      if (i1.ne.ni1.or.j1.ne.nj1.or.k1.ne.nk1.or.l1.ne.nl1.or.
     &    i2.ne.ni2.or.j2.ne.nj2.or.k2.ne.nk2.or.l2.ne.nl2 ) then 
         print *, '@CWORK4622: Assertion failed.'
         print *, '            The x2 tensor is not contiguous.'
         call abort_job()
      end if

c   o assert y is contiguous
      if (a1.ne.na1.or.b1.ne.nb1.or.c1.ne.nc1.or.d1.ne.nd1) then 
         print *, '@CWORK4622: Assertion failed.'
         print *, '            The product tensor is not contiguous.'
         call abort_job()
      end if

c     end if (.false.)
      end if

c-----------------------------------------------------------------------
c   Perform the contraction in unoptimized mode.
c-----------------------------------------------------------------------
            call cwork4622_unopt(y, na1,na2,nb1,nb2, 
     *                         nc1,nc2,nd1,nd2, 
     *                         a1,a2,b1,b2,  
     *                         c1, c2, d1, d2,  
     *                         inda, indb, indc, indd,  
c 
     *                      x1,nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2,
     *                         ne1,ne2,nf1,nf2, 
     *                          m1, m2, n1, n2, r1, r2, s1, s2, 
     *                          e1, e2, f1, f2, 
     *                      indx1,
c 
     *                      x2,ni1,ni2,nj1,nj2,
     *                          i1, i2, j1, j2,
     *                      indx2,
     *                      cind, flopcount, scr1, scr2, scr3) 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE READ_CNTVTES(IBNDTO, IUNIT, NATOMS)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL FLAG
C
#include "mxatms.par"
C
      DIMENSION IBNDTO(NATOMS, NATOMS), NCONPRCNTR(MXATMS),
     &          NCON(MAXCNTVS)

      DATA IONE, IJZERO /1, 0/
   
C Read the connectivites from the file CONNECT if present and
C bypass the automatic genration done in assign_cntvtes.F. 
C This is usefull when dealing with fused rings consists 
C of many atoms.
C
      CALL IZERO(NCON, MAXCNTVS)
      DO IATOMS = 1, NATOMS
         READ(IUNIT, 99) NCONPRCNTR(IATOMS), (NCON(J), J=1, 
     &                   NCONPRCNTR(IATOMS))
         NO_CNTS_PER_CENTER = NCONPRCNTR(IATOMS)
C
         IF (NO_CNTS_PER_CENTER .GE. MAXCNTVS) THEN
            WRITE(6,1000)
            CALL ERREX
         ENDIF
#ifdef _DEBUG_LVL0
         Write(6, "(a,I2)") "The # of connectivites: ",
     &                       NCONPRCNTR(IATOMS)
         Write(6,*)
         Write(6,"(a,10I3)") "The NCON array: ",
     &                     (NCON(J), J=1, NCONPRCNTR(IATOMS))
#endif
      ENDDO
   99 FORMAT (I2, 10(1X,I2))
C
C Create the IBNDTO array. This dicatate everything else that
C proceeds.
C
      DO IATMS = 1, NATOMS
         DO IBNDS = 1, NCONPRCNTR(IATMS)
            IF (NCON(IBNDS) .NE. IJZERO) 
     &          IBNDTO(NCON(IBNDS), IATMS) = IONE
         ENDDO
      ENDDO
C
C Some internal checks. Caution: needs to verify them.
C
      DO IATMS = 1, NATOMS
         DO IBNDS = 1, NCONPRCNTR(IATMS)
            KBNDS = IBNDTO(IBNDS, IATMS)
            DO JBNDS = 1,  NCONPRCNTR(KBNDS)
C
               IF (IBNDTO(JBNDS, KBNDS) .EQ. IATMS) THEN
                   FLAG = .TRUE.
                   WRITE(6, 2000)
                   CALL ERREX
               ENDIF
C
           ENDDO
        ENDDO
      ENDDO
C
CSSS        IF (.NOT. FLAG) THEN
CSSS            NCONPRCNTR(KBNDS) = NCONPRCNTR(KBNDS) + 1
CSSS            IBNDTO(NCONPRCNTR(KBNDS), KBNDS) = IATMS
CSSS        ENDIF
C
 1000 FORMAT("@-Rd_cntvtes - Exceeds the maximum number of
     &        bonds allowed for a center")

 2000 FORMAT("@-Rd_cntvtes - Duplicate connectivity", " I=",I5,
     &      " IB=",I3," J=",I5," JB=",I3,'.')

       RETURN 
       END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine scf_atom_coeff(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block 

      integer array_type, nindex, inda(2), indb(2)    

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, carray, indblk, get_block_index
      integer*8 ibarray, cbarray 
      integer*8 nai_array, kin_array, ovl_array 
      integer*8 integral_scr
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack
      integer sind  

      double precision x(1)
      double precision dbuf(1), temp 
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

      array       = op(c_result_array)
      direct_flag = .false. 
      array_type  = array_table(c_array_type, array)
      nindex      = array_table(c_nindex, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The only argument in scf_atom  
     *            must be a scalar.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in scf_atom, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Set up the integral pointer 
c----------------------------------------------------------------------------

      integral_scr = dpkgscr
      maxblk  = zmax

c----------------------------------------------------------------------------
c   Get the Nuclear attraction integrals.
c----------------------------------------------------------------------------

      array = 11 
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Nuclear attraction integrals calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: NAI array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      nai_array = get_index_from_base(address_table(array), x, 2)

c----------------------------------------------------------------------------
c   Get the Kinetic energy integrals.
c----------------------------------------------------------------------------

      array = 12 
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Kinetic energy integrals calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: KIN array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      kin_array = get_index_from_base(address_table(array), x, 2)

c----------------------------------------------------------------------------
c   Get the Overlap integrals.
c----------------------------------------------------------------------------

      array = 13 
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: overlap integrals calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: ovl array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      ovl_array = get_index_from_base(address_table(array), x, 2)

c----------------------------------------------------------------------------
c   Get the alpha coefficient array.
c----------------------------------------------------------------------------

      array = 2 ! coefficient array for VCCS algorithm
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Coefficient arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: Coefficient array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      carray = get_index_from_base(address_table(array), x, 2)

c----------------------------------------------------------------------------
c   Get the beta Coefficient array.
c----------------------------------------------------------------------------

      array = 3 ! coefficient array for VCCS algorithm
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Coefficient arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: Coefficients array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      cbarray = get_index_from_base(address_table(array), x, 2)

c---------------------------------------------------------------------------
c---------------------------------------------------------------------------

c     write(6,*) '  x(nai_array), x(kin_array), x(ovl_array),
c    *                 x(farray), x(fbarray)) ', 
c    *                 nai_array, kin_array, ovl_array,
c    *                 farray, fbarray 

      if (.not. dryrun) then
         call compute_atomscf_coeff(scalar_table(sind), 
     *                 dbuf(integral_scr),maxblk, ibuf(ipkgscr),
     *                 dbuf(icoord),dbuf(ipcoeff),dbuf(ialpha), 
     *                 ibuf(iccbeg), ibuf(iccend), 
     *                 1, inda(1), 1,inda(2), 
     *                 x(nai_array), x(kin_array), x(ovl_array),
     *                 x(carray), x(cbarray))
      endif

C      WRITE (*,*) ' IN SCF_ATOM_COEFF: COEFFICIENTS '
C      call ttt (x(carray),  1, inda(1), 1, inda(2), 1)
C      call ttt (x(cbarray), 1, inda(1), 1, inda(2), 2)

      return
      end
C
C
C Watson, testing
C
C
      subroutine ttt (array,nc1,nc2,nd1,nd2,spin)
      implicit   none
      integer    nc1, nc2, nd1, nd2
      integer    p, q, m
      integer    spin
      double precision  array (nc1:nc2,nd1:nd2)

      if (spin .eq. 1) then
         do q = nc1, nc2
            do m = nd1, nd2
               WRITE (*,88) ' CA(',m,',',q,') = ',array (m,q)
            enddo
            write (*,*) ''
         enddo
      elseif (spin .eq. 2) then
         do q = nc1, nc2
            do m = nd1, nd2
               WRITE (*,88) ' CB(',m,',',q,') = ',array (m,q)
            enddo
            write (*,*) ''
         enddo
      endif
   88 FORMAT (A4,I2,A1,I2,A4,F12.6)


c    *   call compute_atommp2(scalar_table(sind), 
c    *                 dbuf(integral_scr),maxblk, ibuf(ipkgscr),
c    *                 dbuf(icoord),dbuf(ipcoeff),dbuf(ialpha), 
c    *                 ibuf(iccbeg), ibuf(iccend), 
c    *                 1, inda(1), 1,inda(2), 
c    *                 x(nai_array), x(kin_array), x(ovl_array),
c    *                 x(farray), x(fbarray))


      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_c(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table, 
     *                      address_table, op)
      implicit none
      include 'interpreter.h'
      include 'proto_events.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer*8 address_table(narray_table)

      integer*8 addr, ixc, get_index_from_base
      integer*8 c_loc64
      integer c, master, ierr
      integer i, n
      integer pst_get_master
      integer status(mpi_status_size)
      logical msg_present
      double precision xxx(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, xxx)
#else
      common xxx
      equivalence (ibuf, xxx)
#endif

      include 'int_gen_parms.h'

      integer company_comm, pst_get_company_comm

c-------------------------------------------------------------------------
c   Locate array address in array_table.
c-------------------------------------------------------------------------

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      c    = op(c_result_array)
      addr = address_table(c)
      ixc  = get_index_from_base(addr, xxx, 2)
      n    = index_table(c_index_size, 
     *                   array_table(c_index_array1, c))
      master = pst_get_master()

      if (c .eq. 1 .or. c .eq. 2) then
         if (me .eq. master) then
            do i = 1, nscfa
               xxx(ixc+i-1) = xxx(iscfa+i-1) 
            enddo
         endif
      else if (c .eq. 3) then
         if (me .eq. master) then
            do i = 1, nscfb
               xxx(ixc+i-1) = xxx(iscfb+i-1)
            enddo
         endif
      else
         print *,'init_c called with invalid array: ',c
         call abort_job()  
      endif

      company_comm = pst_get_company_comm(me)
      call mpi_bcast(xxx(ixc), nscfa, mpi_double_precision, master,
     *               company_comm, ierr)

c--------------------------------------------------------------------------
c   Reorder the coefficients in each column to correspond to ERD order.
c--------------------------------------------------------------------------

      go to 10 
      if (intpkg .eq. flocke_package) 
     *    call apply_erd_order(xxx(ixc), n, ibuf(ierdind), 
     *                        xxx(iscale_fac))
       
      return
10    continue 
      end

      subroutine apply_erd_order(c, n, erd_ind, scale)
c---------------------------------------------------------------------------
c   Reorders the C array column by column into an order compatible with
c   integrals produced by the ERD integral package.
c---------------------------------------------------------------------------
      implicit none
      integer n, erd_ind(n)
      double precision c(n,n)
      double precision scale(n)
      double precision temp(n)

      integer i, j
 
      do j = 1, n
         do i = 1, n
            temp(i) = c(i,j)
         enddo

         do i = 1, n
            c(i,j) = temp(erd_ind(i)) * scale(erd_ind(i))
         enddo

      enddo

      return
      end

      SUBROUTINE GETSTF(EVAL,IUHF,IENTRY)
C
C THIS ROUTINE IS A DEPENDENT OF CRAPSI AND INITIALIZES MANY
C  OF THE COMMON BLOCKS USED BY THE PROGRAM SYSTEM.  CALLING
C  THIS ROUTINE EXPLICITLY IS NOT A WISE THING TO DO.
C
CEND
C
CJDW 3/21/94
C Addition of IFLAGS2.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL YESNO,LINCC,CICALC
      CHARACTER*3 CALTYP
      CHARACTER*8 TYPEO
      CHARACTER*6 FILE1
      CHARACTER*80 FNAME
      INTEGER DIRPRD,QUIKGET
      DIMENSION EVAL(1)
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      COMMON /SYMLOC/ ISYMOFF(8,8,25)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /CONTROL/ IPRNT,IXXX,IXXX2
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /FLAGS2/ IFLAGS2(500)
      COMMON /LINEAR/ LINCC,CICALC
      COMMON /AUXCACHE/ QUIKGET(10,500)
      MOIOSIZ=5000
      IONE=1
      ITWO=2
      ISIXTN=16
      ISIXFR=64
      NPARAM=100
      NPARAM2=500
      IUHF=0
      LINCC=.FALSE.
      CICALC=.FALSE.
      CALL IZERO(QUIKGET,5000)
      CALL GETREC(-1,'JOBARC','IFLAGS  ',NPARAM,IFLAGS)
      CALL GETREC(-1,'JOBARC','IFLAGS2 ',NPARAM2,IFLAGS2)
      CALL GETREC(-1,'JOBARC','NOCCORB ',ITWO,NOCCO)
      CALL GETREC(-1,'JOBARC','NVRTORB ',ITWO,NVRTO)
      CALL GETREC(-1,'JOBARC','COMPNIRR',IONE,NIRREP)
      CALL GETDPT
      IF(IFLAGS(11).GE.1)IUHF=1
      NORBS=NOCCO(1)+NVRTO(1)
      CALTYP='RHF'
      IF(IUHF.EQ.1)CALTYP='UHF'
      CALL FILPOP
      CALL INITPOP
c      CALL GETREC(-1,'JOBARC','IRREPALP',NORBS,IRREPA)
c      CALL GETREC(-1,'JOBARC','IRREPBET',NORBS,IRREPB)
      CALL GETREC(-1,'JOBARC','MOIOVEC ',MOIOSIZ,MOIO)
      CALL GETREC(-1,'JOBARC','MOIOWRD ',MOIOSIZ,MOIOWD)
      CALL GETREC(-1,'JOBARC','MOIOSIZ ',MOIOSIZ,MOIOSZ)
      CALL GETREC(-1,'JOBARC','MOIODIS ',MOIOSIZ,MOIODS)
      CALL GETREC(-1,'JOBARC','MOIOFIL ',MOIOSIZ,MOIOFL)
      CALL GETREC(-1,'JOBARC','ISYMTYP ',1000,ISYTYP)
      CALL GFNAME('MOINTS  ',FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO)
      IF(YESNO.AND.IENTRY.NE.-1)THEN
       CALL UPDMOI(0,0,0,0,3,0)
       IJUNK = 0
       CALL INITIO(IJUNK,I0) 
      ENDIF
      CALL GNSYOF
      RETURN
      END

      SUBROUTINE FSMAP(XTYP,YTYP,XSPIN,YSPIN,TYPE,POPX,POPY,IDROPX,
     &                 IDROPY,NBAS,IMAP,DPDVEC,IFSPOS,
     &                 IOFF, IZPos, ZList, IZOff,DSZMAX)
C
C THIS ROUTINE CONSTRUCTS A GATHER-SCATTER VECTOR WHICH RELATES
C POSITIONS IN A SYMMETRY PACKED PQ DISTRIBUTION TO THOSE IN THE
C SAME DISTRIBUTION WHERE CERTAIN ELEMENTS OF P OR Q ARE EXCLUDED.
C
C THIS VECTORS PRODUCED BY THIS ROUTINE ARE USEFUL FOR READING QUANTITIES
C INVOLVING ONLY ACTIVE OR INACTIVE INDICES FROM THE STANDARD LISTS.
C
C The last three arguments are used only for TYPE = 'UPLT' or 'UPLE'
C (unpack from X < Y  or X <= Y storage) 
C
C     IZPos   Analog to IFSPos for ZList. 
C     ZList   Integer multiplier for each element of IMap.
C     IZOff   Analog to IOff for tracking the position of the ZList
C     DSZMAX  LENGTH OF THE FSIO BUFFER
C
C NOTE: DPDVEC applies equally well to IMap and ZList.
C
CEND
      IMPLICIT INTEGER (A-Z)
C
      CHARACTER*4 TYPE
      CHARACTER*3 XTYP,YTYP
      DIMENSION POPX(8),POPY(8),IDROPX(NBAS),IDROPY(NBAS),IMAP(1)
      DIMENSION IOFFX(8),IOFFY(8),DPDVEC(8),IFSPOS(8)
      Integer IZPos(8), ZList(*), IZOff
C
C     Local Variables
C
      Integer Ptrs(8,2), Count, I
C
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /INFO  / NOCCO(2),NVRTO(2)
C
      IPART=0
C
C CALCULATE OFFSETS FOR STARTS OF IRREPS
C
      IF(XTYP.EQ.'VRT')THEN
       IOFFX(1)=NOCCO(XSPIN)
      ELSE
       IOFFX(1)=0
      ENDIF
      IF(YTYP.EQ.'VRT')THEN
       IOFFY(1)=NOCCO(YSPIN)
      ELSE
       IOFFY(1)=0
      ENDIF
      DO 5 IRREP=2,NIRREP
       IOFFX(IRREP)=IOFFX(IRREP-1)+POPX(IRREP-1)
       IOFFY(IRREP)=IOFFY(IRREP-1)+POPY(IRREP-1) 
5     CONTINUE
      IABSX=0
      IABSY=0
C
      IF(TYPE.EQ.'FULL')THEN
C
C X,Y (FULL) DISTRIBUTION.  
C
       DO 10 IRREPXY=1,NIRREP 
        INUMIRR=0
        IFULL0=0
        DO 20 IRREPY=1,NIRREP
         IRREPX=DIRPRD(IRREPY,IRREPXY)
         NUMX=POPX(IRREPX)
         NUMY=POPY(IRREPY)
         DO 30 INDEXY=1,NUMY
          DO 40 INDEXX=1,NUMX
           IABSX=IOFFX(IRREPX)+INDEXX
           IABSY=IOFFY(IRREPY)+INDEXY
           IFULL0=IFULL0+1
           IF(IDROPX(IABSX)*IDROPY(IABSY).NE.0)THEN
            IPART=IPART+1
            INUMIRR=INUMIRR+1
            IMAP(IPART)=IFULL0
           ENDIF
40        CONTINUE
30       CONTINUE 
20      CONTINUE
        DPDVEC(IRREPXY)=INUMIRR
        IFSPOS(IRREPXY)=IOFF
        IOFF=IOFF+INUMIRR
10     CONTINUE
C
      ELSEIF(TYPE.EQ.'PACK'.OR.TYPE.EQ.'PCK2')THEN
C
C X<Y OR X<=Y (PACKED) DISTRIBUTION 
C
       IF(TYPE.EQ.'PACK')THEN
        IOFFR=1
       ELSE
        IOFFR=0
       ENDIF
       DO 110 IRREPXY=1,NIRREP
        INUMIRR=0
        IFULL0 =0
        DO 120 IRREPY=1,NIRREP
         IRREPX=DIRPRD(IRREPY,IRREPXY)
C
         IF(IRREPX.EQ.IRREPY)THEN
C
          NUMX=POPX(IRREPX)
          NUMY=POPY(IRREPY)
          DO 130 INDEXY=1,NUMX
           DO 140 INDEXX=1,INDEXY-IOFFR
            IABSX=IOFFX(IRREPX)+INDEXX
            IABSY=IOFFY(IRREPY)+INDEXY
            IFULL0=IFULL0+1
            IF(IDROPX(IABSX)*IDROPY(IABSY).NE.0)THEN
             IPART=IPART+1
             INUMIRR=INUMIRR+1
             IMAP(IPART)=IFULL0
            ENDIF
140        CONTINUE
130       CONTINUE
C
         ELSEIF(IRREPX.LT.IRREPY)THEN
C          
          NUMX=POPX(IRREPX)
          NUMY=POPY(IRREPY)
          DO 135 INDEXY=1,NUMY
           DO 145 INDEXX=1,NUMX
            IABSX=IOFFX(IRREPX)+INDEXX
            IABSY=IOFFY(IRREPY)+INDEXY
            IFULL0=IFULL0+1
            IF(IDROPX(IABSX)*IDROPY(IABSY).NE.0)THEN
             IPART=IPART+1
             INUMIRR=INUMIRR+1
             IMAP(IPART)=IFULL0
            ENDIF
145        CONTINUE
135       CONTINUE 
C
         ENDIF
C
120     CONTINUE
        DPDVEC(IRREPXY)=INUMIRR
        IFSPOS(IRREPXY)=IOFF
        IOFF=IOFF+INUMIRR
110    CONTINUE
C
      ELSEIF(TYPE.EQ.'UPLE'.OR.TYPE.EQ.'UPLT')THEN
C
C        X<=Y OR X<Y (PACKED) DISTRIBUTION which is to be expanded
C        into a rectangle.  The difference between this and 'PACK' &
C        'PCK2' above is that we have to cover the entire array,
C        to insure that things expand properly, but the origin
C        position in IMap must be within the X<Y or X<=Y framework.
C
C        Things to be very careful of in comparison with regular
C        PACK or PCK2 situations:
C
C        o For X<=Y lists, diagonals (X=Y) are not stored.  They are
C          of course required in the unpacked list.
C        o Integrals, amplitudes, etc. are antisymmetric, so unpacking
C          requires a sign change on some of elements compared to
C          what they were in the packed list.
C
C        These points are solved by creating a companion array to IMap
C        which contains an integer multipliers for each element in
C        in the unpacked list.  Elements may be 1, 0, -1 for UPLT or
C        1, -1 for UPLE.  All offsets for the IMap array apply equally
C        to the Zlist array.
C
C        o The IrrepX .gt. IrrepY blocks of the unpacked list are
C          the transpose of the corresponding IrrepX <--> IrrepY
C          block of the packed list.  They must be given IMap entries
C          before the IFull0 value of the beginning of the actual
C          block in the packed list is known because each element of
C          IMap corresponds directly to an element in the unpacked
C          result, so proper ordering must be maintained.
C
C        This is solved by filling the IrrepX .gt. IrrepY blocks with
C        the position relative to the beginning of the actual block
C        and saving the position and length of this block in the
C        IrrepX element of the Ptrs array.
C
C        When we process a block which is in the packed list (IrrepX
C        .lt. IrrepY), we lookup the IrrepY value in the Ptrs array
C        to find out where the transpose block is which requires
C        the value of IFull0 to be added.
C
         IF(TYPE.EQ.'UPLT')THEN
            IOFFR=1
         ELSE
            IOFFR=0
         ENDIF
         DO 210 IRREPXY=1,NIRREP
            INUMIRR=0
            NZero = 0
            IFULL0 =0
C
C           The pointer array is reused for each IRREPXY
C
            Call IZero(Ptrs, 8*2)
C
            DO 220 IRREPY=1,NIRREP
               IRREPX=DIRPRD(IRREPY,IRREPXY)
C
               IF(IRREPX.EQ.IRREPY)THEN
C
                  NUMX=POPX(IRREPX)
                  NUMY=POPY(IRREPY)
                  DO 230 INDEXY=1,NUMY
                     DO 240 INDEXX=1,INDEXY - IOffR
                        IABSX=IOFFX(IRREPX)+INDEXX
                        IABSY=IOFFY(IRREPY)+INDEXY
                        IFULL0=IFULL0+1
                        IF(IDROPX(IABSX)*IDROPY(IABSY).NE.0)THEN
                           IPART=IPART+1
                           INUMIRR=INUMIRR+1
                           IMAP(IPART)=IFULL0
                           Zlist(IPart) = 1
                        ENDIF
 240                 CONTINUE
C
                     IABSX=IOFFX(IRREPX)+INDEXX+1
                     IABSY=IOFFY(IRREPY)+INDEXY
                     If (Type .eq. 'UPLT' .AND. 
     $                  (IDropX(IAbsY)*IDropY(IAbsY) .ne. 0) ) then
                        IPart = IPart + 1
                        INumIrr = INumIrr + 1
c&C
c&C                       In case this is the (1,1) element, make sure
c&C                       it is at least 1
c&C
c&                        IMap(IPart) = Max(1, IFull0)
                        IMap(IPart) = DSZMAX
C
C                       This one will have to be explicitly zeroed in
c                       the final gathered array.  DO NOT increment
c                       IFull0 here!
C
                        ZList(IPart) = 0
                     EndIf
C
C                    These are the transpose of the upper triangle
C                    so a sign change is required.
C
C                    Increment to IFull1 depends on whether list is
C                    UPLE or UPLT.
C
                     IFull1 = IFull0 + IndexY
                     DO 250 INDEXX=INDEXY+1, NUMX
                        IABSX=IOFFX(IRREPX)+INDEXX
                        IABSY=IOFFY(IRREPY)+INDEXY
cSSS                        IFULL1=IFULL0 + IndexX - 1
                        IF(IDROPX(IABSX)*IDROPY(IABSY).NE.0)THEN
                           IPART=IPART+1
                           INUMIRR=INUMIRR+1
                           IMAP(IPART)=IFULL1
                           ZList(IPart) = -1
                        ENDIF
                        IFull1 = IFull1 + IndexX - IOffR
 250                 CONTINUE
 230              CONTINUE
C                 
               ElseIf (IrrepX .gt. IrrepY) then
C              
C                 This block is the transpose of the IrrepY,IrrepX block
C                 which will satisfy the conditional below.  At the
C                 moment, we don't know where the original block will
C                 begin, so just put offsets into IMap now and setup
C                 Ptrs so that when we hit the original block, we can
C                 add the appropriate offset to these values.
C
                  Count = 0
                  Ptrs(IrrepX, 1) = IPart + 1
C
                  NumX = PopX(IrrepX)
                  NumY = PopY(IrrepY)
                  Do 232 IndexY = 1, NumY
                     Do 242 IndexX = 1, NumX
                        IAbsX = IOffX(IrrepX) + IndexX
                        IAbsY = IOffY(IrrepY) + IndexY
C
C                       Remember: original position is in the
C                       _transpose_ of this block w.r.t. the
C                       current NumX, NumY.  The formula may
C                       look funny, but its correct -- try it!
C
                        If (IDropX(IAbsX) * IDropY(IAbsY) .ne. 0) then
                           Count = Count + 1
                           IMap(IPart + Count) =
     $                        (IndexX-1) * NumY + IndexY
                           ZList(IPart + Count) = -1
                        EndIf
C
 242                  Continue
 232               Continue
C
                   Ptrs(IrrepX, 2) = Count
                   IPart = IPart + Count
                   INumIrr = INumIrr + Count
C                 
               ELSEIF(IRREPX.LT.IRREPY)THEN
C          
C                 Check for a block in the lower half of the matrix
C                 which needs to know the origin of this block in
C                 the original triangle.
C
                  If (Ptrs(IrrepY, 2) .ne. 0) then
                     Do 234 I = 0, Ptrs(IrrepY, 2) - 1
                        J = Ptrs(IrrepY, 1) + I
                        IMap(J) = IMap(J) + IFull0
 234                 Continue
                  EndIf
C
C                 Now continue with this block
C
                  NUMX=POPX(IRREPX)
                  NUMY=POPY(IRREPY)
                  DO 235 INDEXY=1,NUMY
                     DO 245 INDEXX=1,NUMX
                        IABSX=IOFFX(IRREPX)+INDEXX
                        IABSY=IOFFY(IRREPY)+INDEXY
                        IFULL0=IFULL0+1
                        IF(IDROPX(IABSX)*IDROPY(IABSY).NE.0)THEN
                           IPART=IPART+1
                           INUMIRR=INUMIRR+1
                           IMAP(IPART)=IFULL0
                           ZList(IPart) = 1
                        ENDIF
 245                 CONTINUE
 235              CONTINUE 
C                 
               ENDIF
C
 220        CONTINUE
C
            DPDVEC(IRREPXY)=INUMIRR
            IFSPOS(IRREPXY)=IOFF
            IOFF=IOFF+INUMIRR
C           
            If (Type .eq. 'UPLT' .OR. Type .eq. 'UPLE') then
               IZPos(IrrepXY) = IZOff
               IZOff = IZOff + INumIrr
            EndIf
 210     CONTINUE
C
      ENDIF
C
cSSS      If (Type .eq. 'UPLT' .OR. Type .eq. 'UPLE') then
cSSS         Write (6, 9005) (i, IFSPOS(i), IZPos(i), DPDVEC(i),
cSSS     $      i = 1, NIrrep)
cSSS      Else
cSSS         Write (6, 9006) (i, IFSPOS(i), DPDVEC(i), i = 1, NIrrep)
cSSS      EndIf
cSSS      If (Type .eq. 'UPLT' .OR. Type .eq. 'UPLE') then
cSSS         Write (6, 9011) (i, Zlist(i), IMap(I), ZList(i+1), IMap(i+1),
cSSS     $      ZList(I+2), IMap(I+2), ZList(I+3), IMap(I+3),
cSSS     $      ZList(I+4), IMap(i+4), I = 1, IPart, 5)
cSSS      Else
cSSS         Write (6, 9010) (i, IMap(I), IMap(i+1), IMap(I+2), IMap(I+3),
cSSS     $   IMap(i+4), I = 1, IPart, 5)
cSSS      EndIf
cSSS 9005 Format(10X, 'IFSPOS', 2X, 'IZPOS ', 2X, 'DPDVEC', /
cSSS     $   (5X, I3, 2X, I6, 2I8))
cSSS 9006 Format(10X, 'IFSPOS', 2X, 'DPDVEC', /
cSSS     $   (5X, I3, 2X, I6, I8))
cSSS 9010 Format(/ (5X, I3, ':', 2X, 5I6) )
cSSS 9011 Format(/ (5X, I3, ':', 2X, 5(I2, '*', I4, 4X) ) ) 
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__EXTRACT_ATOMIC_CONTENT
     +
     +                    ( NBAS,NATOM,
     +                      NCEN,
     +                      ATIDX,
     +                      BASBEG,BASEND,
     +                      TOTAL,
     +                      C,
     +                      SHALF,
     +
     +                              X )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__EXTRACT_ATOMIC_CONTENT
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine extracts from a given MO coefficient
C                vector C in AO basis its atomic center content
C                in terms of the symmetrized AO basis corresponding
C                to NCEN atoms. The content X is simply the number
C                which results in the multiplication:
C
C                                X = C'(T) * C'
C
C                with C' being the MO coefficent expansion in terms
C                of the symmetrized AO basis:
C
C                             C' = S**(1/2) * C
C
C                and restricting the summation to only those rows
C                of S**(1/2) belonging to the NCEN atoms.
C
C                The routine allows for two options:
C
C                    1) the total atomic content is evaluated with
C                       summation over all NCEN atoms and adding up
C                       the individual atomic contents. The result
C                       is placed in X (1).
C
C                    2) the individual atomic contents are evaluated
C                       and the results placed into the NCEN first
C                       places of array X.
C
C                Which option is performed is controlled by the
C                keyword TOTAL, which is true, if the first option
C                is wanted and false for option 2).
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis.
C                    NATOM        =  total # of atoms.
C                    NCEN         =  # of atomic centers for content
C                                    evaluation.
C                    ATIDX (A)    =  atomic index for atom A for
C                                    content evaluation.
C                    BASBEG (A)   =  first basis index number for
C                                    atom A.
C                    BASEND (A)   =  last basis index number for
C                                    atom A.
C                    TOTAL        =  is true, if the total atomic
C                                    content is wanted, and false, if
C                                    the individual ones are wanted.
C                    C            =  MO coefficient vector in AO basis.
C                    SHALF        =  full NBAS x NBAS square root of
C                                    the overlap matrix in AO basis.
C
C
C                  Output:
C
C                    X            =  atomic content of MO in C.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     TOTAL

         INTEGER     ATOM
         INTEGER     I,J,N
         INTEGER     JBEG,JEND
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NCEN

         INTEGER     ATIDX  (1:NCEN )
         INTEGER     BASBEG (1:NATOM)
         INTEGER     BASEND (1:NATOM)

         DOUBLE PRECISION  CS
         DOUBLE PRECISION  XATOM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  C (1:NBAS)
         DOUBLE PRECISION  X (1:NCEN)

         DOUBLE PRECISION  SHALF (1:NBAS,1:NBAS)

         DATA  ZERO  /0.D0/
C
C
C------------------------------------------------------------------------
C
C
C             ...form X = C'(T)*C using only atoms in ATIDX.
C
C
         X (1) = ZERO

         DO N = 1,NCEN
            ATOM = ATIDX (N)
            JBEG = BASBEG (ATOM)
            JEND = BASEND (ATOM)

            XATOM = ZERO
            DO J = JBEG,JEND
               CS = ZERO
               DO I = 1,NBAS
                  CS = CS + C (I) * SHALF (I,J)
               END DO
               XATOM = XATOM + CS * CS
            END DO

            IF (TOTAL) THEN
                X (1) = X (1) + XATOM
            ELSE
                X (N) = XATOM
            END IF

         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE S2PROJ(ICORE,MAXCOR,IUHF,SINGLE)
C
C THIS ROUTINE CALCULATES THE PROJECTED VALUE OF THE
C  NORMAL ORDERED S**2 OPERATOR, WHICH REPRESENTS THE
C  CORRELATION CORRECTION TO THE S**2.  THE FORMULA USED
C  IS:
C
C  <0|S**2 exp(T)|0> = SUM T(A,I) * P(A,I) - SUM T(a,i) * P(a,i)
C
C                     - T(Ab,Ij) * DELTA(b,I) * DELTA(A,j)
C
C WHERE:
C
C                 P(A,I) = SUM DELTA(J,e) * DELTA(e,A)
C                           e
C
C                 P(a,i) = SUM DELTA(a,J) * DELTA(J,i)
C      
C AND DELTA(p,Q) ARE ELEMENTS OF THE VIRTUAL-OCCUPIED ALPHA-BETA
C  MO OVERLAP MATRIX.
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL SINGLE
      DOUBLE PRECISION S2PRJ,S2T2,S2T12,S1A,S1B,S2SCF,SDOT,ONE,ZILCH
      DOUBLE PRECISION S2P,Z
      DIMENSION ICORE(MAXCOR),NSIZOO(8),NSIZVO(8),NSIZOV(8),NSIZVV(8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM/-1.0/
      IF(IUHF.EQ.0)RETURN
C
C LOAD OVERLAP MATRICES INTO BOTTOM OF CORE
C
      NSZOOT=0
      NSZVOT=0
      NSZOVT=0
      NSZVVT=0
      DO 10 IRREP=1,NIRREP
       ITMPOO=POP(IRREP,1)*POP(IRREP,2)
       ITMPVO=VRT(IRREP,1)*POP(IRREP,2)
       ITMPOV=POP(IRREP,1)*VRT(IRREP,2)
       ITMPVV=VRT(IRREP,1)*VRT(IRREP,2)
       NSIZOO(IRREP)=NSZOOT
       NSIZVO(IRREP)=NSZVOT
       NSIZOV(IRREP)=NSZOVT
       NSIZVV(IRREP)=NSZVVT
       NSZOOT=NSZOOT+ITMPOO
       NSZVOT=NSZVOT+ITMPVO
       NSZOVT=NSZOVT+ITMPOV
       NSZVVT=NSZVVT+ITMPVV
10    CONTINUE
      I000=1
      I010=I000+IINTFP*NSZOOT
      I020=I010+IINTFP*NSZVOT
      I030=I020+IINTFP*NSZOVT
      I040=I030+IINTFP*NSZVVT
      CALL GETLST(ICORE(I000),1,1,1,5,90)
      CALL GETLST(ICORE(I010),1,1,1,6,90)
      CALL GETLST(ICORE(I020),1,1,1,7,90)
      CALL GETLST(ICORE(I030),1,1,1,8,90)
      IF(SINGLE)THEN
       I050=I040+IINTFP*NT(1)
       I060=I050+IINTFP*NT(2)
       CALL GETLST(ICORE(I040),1,1,1,1,90)
       CALL GETLST(ICORE(I050),1,1,1,2,90)
      ELSE
       I060=I040
      ENDIF
C
C DO T2 + T1**2 CONTRIBUTION TO S**2
C
      LISTT=46
      I070=I060+IINTFP*NSZVOT
      CALL IZERO(ICORE(I060),NSZVOT*IINTFP)
      DO 100 IRREPDO=1,NIRREP
       NT2DSZ=IRPDPD(IRREPDO,ISYTYP(1,LISTT))
       NT2DIS=IRPDPD(IRREPDO,ISYTYP(2,LISTT))
       I080=I070+IINTFP*NT2DIS*NT2DSZ
       I090=I080+IINTFP*NT2DSZ
       CALL GETLST(ICORE(I070),1,NT2DIS,1,IRREPDO,LISTT)
       IF(SINGLE)THEN
        CALL FTAU(ICORE(I070),ICORE(I040),ICORE(I050),NT2DSZ,
     &            NT2DIS,POP(1,1),POP(1,2),VRT(1,1),VRT(1,2),
     &            IRREPDO,3,ONE)
       ENDIF
       I100=I090+IINTFP*NSZOVT
       CALL SYMTRA(1,POP(1,1),VRT(1,2),1,ICORE(I020),ICORE(I090))
       CALL DOT24(IRREPDO,ICORE(I060),ICORE(I090),ICORE(I070),
     &            ICORE(I080),NT2DSZ,VRT(1,1),POP(1,2),
     &            VRT(1,1),VRT(1,2),POP(1,1),POP(1,2),'TSST')
100   CONTINUE
      S2T2=-SDOT(NSZVOT,ICORE(I010),1,ICORE(I060),1)
      S2T12=0.0
C
C GET EASY PART FOR CCSD, QCISD, ETC.
C
      IF(SINGLE)THEN
       I070=I060+IINTFP*NT(1)
       I080=I070+IINTFP*NT(2)
       IOFF1=0
       IOFF2=0
       IOFFD1=I030
       IOFFD2=I020
       IOFFD3=I020
       IOFFD4=I000
       DO 300 IRREP=1,NIRREP
        POPI=POP(IRREP,1)
        VRTE=VRT(IRREP,2)
        VRTA=VRT(IRREP,1)
C
C  P(A,I) = SUM DELTA(A,e) * DELTA(I,e)
C
        CALL XGEMM('N','T',VRTA,POPI,VRTE,ONE,ICORE(IOFFD1),VRTA,
     &             ICORE(IOFFD2),POPI,ZILCH,ICORE(I060+IOFF1),VRTA)
        IOFF1=IOFF1+VRTA*POPI*IINTFP
        IOFFD1=IOFFD1+VRTA*VRTE*IINTFP
        IOFFD2=IOFFD2+POPI*VRTE*IINTFP
        POPJ=POP(IRREP,1)
        VRTA=VRT(IRREP,2)
        POPI=POP(IRREP,2)
C
C  P(a,i) = SUM DELTA(J,a) * DELTA(J,i)
C
        CALL XGEMM('T','N',VRTA,POPI,POPJ,ONE,ICORE(IOFFD3),POPJ,
     &             ICORE(IOFFD4),POPJ,ZILCH,ICORE(I070+IOFF2),VRTA)
        IOFF2=IOFF2+VRTA*POPI*IINTFP
        IOFFD3=IOFFD3+POPJ*VRTA*IINTFP
        IOFFD4=IOFFD4+POPJ*POPI*IINTFP
300    CONTINUE
       S1A=SDOT(NT(1),ICORE(I060),1,ICORE(I040),1)
       S1B=SDOT(NT(2),ICORE(I070),1,ICORE(I050),1)
       S2T12=S1A-S1B
      ENDIF
      S2P=S2T2+S2T12
      CALL GETREC(20,'JOBARC','S2SCF   ',IINTFP,S2SCF)
      WRITE(6,698)
      WRITE(6,697)
      WRITE(6,698)
      WRITE(6,699)S2SCF
      IF(.NOT.SINGLE)THEN
       WRITE(6,700)S2T2
      ELSE
       WRITE(6,701)S2T2
       WRITE(6,702)S2T12
      ENDIF
      WRITE(6,703)S2P+S2SCF
      Z=0.5*(-1.0+SQRT(1.0+4.0*(S2P+S2SCF)))
      WRITE(6,704)2.0*Z+1.0
      WRITE(6,698)
697   FORMAT(T20,'  Projected spin multiplicities: ')
698   FORMAT(T13,46('-'))
699   FORMAT(T13,' <0|S^2|0> ',T40,' = ',F15.10,'.')
700   FORMAT(T13,' <0|S^2 T2|0> ',T40,' = ',F15.10,'.')
701   FORMAT(T13,' <0|S^2 (T2+T1**2) |0> ',T40,' = ',F15.10,'.')
702   FORMAT(T13,' <0|S^2 T1|0> ',T40,' = ',F15.10,'.')
703   FORMAT(T13,' Projected <0|S^2 exp(T)|0>',T40,' = ',F15.10,'.')
704   FORMAT(T13,' Approximate spin mult.',T40,' = ',F15.10,'.')
      RETURN
      END

      SUBROUTINE SYMMET5(A,B,NUM)
C
C   THIS ROUTINE SYMMETRIZES A GIVEN MATRIX A
C
C     A(PQ) = 1/2 ( A(PQ)+A(QP))
C
C   WHERE A IS A SYMMETRY PACKED MATRIX AND
C   NUM THE CORRESPONDING POPULATION VECTOR
C
C   THE SYMMETRIZED ARRAY IS RETURNED IN A, B IS ONLY USED
C   AS A SCRATCH ARRAY. IT IS POSSIBLE TO SET UP A ROUTINE WHICH
C   DOES NOT USE A SCRATCH ARRAY, BUT VECTORIZATION SHOULD HERE 
C   SLIGHTLY BETTER
C
CEND
C
C CODED JULY/90  JG
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DIRPRD
      DIMENSION A(1),B(1),NUM(8)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255,2),DIRPRD(8,8)
      DATA HALF /0.5D+0/
C
      IOFF=0
      DO 1000 IRREP=1,NIRREP
C
       NUMI=NUM(IRREP)
C
       DO 100 I=1,NUMI
       DO 100 J=1,NUMI
        B(IOFF+(I-1)*NUMI+J)=HALF*(A(IOFF+(I-1)*NUMI+J)
     &                        +A(IOFF+(J-1)*NUMI+I))
100    CONTINUE
C
       IOFF=IOFF+NUMI*NUMI
1000  CONTINUE
C
C  COPY B BACK TO A
C
      DO 2000 I=1,IOFF 
       A(I)=B(I)
2000  CONTINUE
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pre_request_block(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table,nblock_map_table,
     *                      op, instruction_timer, comm_timer, 
     *                      direct_flag)
c---------------------------------------------------------------------------
c   This routine iterates the indices used in the current array request.
c   Then if the indices are well-formed, it sets up a block for the data
c   that is being requested and issues a request to the server.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_barrier_data.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry,
     *                           nblock_map_table)
      integer instruction_timer, comm_timer
      logical direct_flag

      integer i, j, k
      integer nind
      integer ierr, handle, status(MPI_STATUS_SIZE)
      integer response_req, request, get_block_request
      integer blk, blkndx, mgr
      integer blocksize
      integer*8 indblk, get_block_index
      integer stack
      integer find_block_destination, block_map_lookup
      integer find_current_block, find_current_block_map
      integer allocate_block_light
      integer ind(mx_array_index), seg(mx_array_index)
      integer next_segs(mx_array_index)
      integer dummy

      integer msg(len_sip_server_message, mx_msg)
      integer imsg, find_free_msg_buffer
      integer mx_msg_used

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      integer nxt
      integer f_form_msg_tag2, tag
      integer flag
      integer save_op(2)
      integer nwblock
      logical return_flag
      logical is_prefetch_index

      save msg

      mx_msg_used = mx_msg
#ifdef ALTIX
      dptr = dshptr
c      mx_msg_used = min(mx_msg, 100)
#endif
      handle = op(c_result_array)
      if (array_table(c_array_type, handle) .ne. served_array) then
         print *,'Task ',me,' Error: Request instruction uses ',
     *           'an array that is not type "served".'
         print *,'Array ',handle,' type ',
     *            array_table(c_array_type, handle)
         call abort_job()
      endif

c------------------------------------------------------------------------
c   Pick up the current indices and segments of the array.
c------------------------------------------------------------------------

      nind = array_table(c_nindex, handle)
      return_flag = .false.
      do i = 1, nind
         ind(i) = array_table(c_index_array1+i-1,handle)
         seg(i) = index_table(c_current_seg,ind(i))
         if (is_prefetch_index(ind(i)) ) then
            next_segs(i) = index_table(c_next_seg,ind(i))
	    if (next_segs(i) .eq. 0) return_flag = .true.  ! no prefetch is possible.
            index_table(c_current_seg,ind(i)) = next_segs(i)
         else
            next_segs(i) = seg(i)   ! index is not prefetch, use current seg
         endif
      enddo

      if (return_flag) go to 1000

c------------------------------------------------------------------------
c   create_current_block will store the block info in the opblock and 
c   opblkndx fields of the instruction.  We don't want the prefetched 
c   block data stored, because this data has already been set by the 
c   REQUEST instruction.  So we save this data and restore it later.
c------------------------------------------------------------------------

       save_op(1) = op(c_opblock)
       save_op(2) = op(c_opblkndx)    

c------------------------------------------------------------------------
c   Make sure the requested block exists.  create_current_block will
c   create the block if it does not exist, and simply return if the 
c   block is already present.
c------------------------------------------------------------------------

      blk = find_current_block(handle, array_table(1,handle),
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           block_map_table, blkndx)

      if (blk .le. 0) then

c----------------------------------------------------------------------------
c   Block is not present.  Allocate a new block and set it up for this
c   operation.
c
c   Determine the size of the data to be allocated.
c---------------------------------------------------------------------------

         call determine_current_block_size(ind, nind,
     *        index_table, nindex_table,
     *        segment_table, nsegment_table, nwblock)

c--------------------------------------------------------------------------
c   Block is not present.  Allocate it and compute it.
c--------------------------------------------------------------------------

         blk = find_current_block_map(handle, array_table(1,handle),
     *                   index_table, nindex_table,
     *                   block_map_table, nblock_map_table)

         ierr = allocate_block_light(handle, blk, nwblock, array_table,
     *                      narray_table, index_table, nindex_table,
     *                      block_map_table)
         blkndx = ierr 
         if (ierr .le. 0) then

c--------------------------------------------------------------------------
c   No blocks available right now.  We will simply not do this pre_request.
c--------------------------------------------------------------------------

            go to 1000
         endif

c--------------------------------------------------------------------------
c   Finish setting up the block.
c--------------------------------------------------------------------------

         call blkmgr_insert_block_in_list(
     *              array_table(c_block_list,handle),
     *              dummy, blkndx, c_block_list_ptr, .false.)

c--------------------------------------------------------------------------
c   Store the block indices  and segments in the block header.
c--------------------------------------------------------------------------

         call set_block_indices(handle, blk, blkndx, 
     *                          array_table(1,handle))
         call set_block_segments(handle, blk, blkndx, index_table,
     *                           nindex_table)
         stack = array_table(c_array_stack,handle)
      endif

      mgr = find_block_destination(handle, array_table,
     *               narray_table, index_table, nindex_table,
     *               block_map_table, nblock_map_table)

c--------------------------------------------------------------------------
c   Check the block_request_outstanding_flag.
c   If a previous request instruction on this block has not been satisfied,
c   there is no need to process the current request.
c--------------------------------------------------------------------------

      call get_block_request_outstanding_flag(handle,blk, blkndx,
     *                                       flag)
      if (flag .ne. 0) then

c---------------------------------------------------------------------------
c   Check block_computed_flag: If it is not set, this was probably a block
c   requested from an earlier loop.  Therefore we must set the 
c   block_computed_flag here.
c---------------------------------------------------------------------------

         call get_block_computed_flag(handle, blk, blkndx, flag)
         if (flag .eq. 0) then
            call set_block_computed_flag(handle, blk, blkndx, 1)

c---------------------------------------------------------------------------
c   If the block_scrub_flag is set, this has been scrubbed from usage in
c   an earlier loop.  We must turn this flag off in order to prevent the
c   block from possibly being reused.
c---------------------------------------------------------------------------

            call set_block_scrub_flag(handle, blk, blkndx, 0)
         endif
      
         go to 1000
      endif

c---------------------------------------------------------------------------
c   Check the block_persistence_flag.  If it is already turned on, the
c   block is available from a previous access, and there is no need to
c   request it again.
c---------------------------------------------------------------------------

      call get_block_persistence_flag(handle, blk, blkndx, flag)
      if (flag .ne. 0) then
         call set_block_computed_flag(handle, blk, blkndx, 1)

c---------------------------------------------------------------------------
c   If the block_scrub_flag is set, this has been scrubbed from usage in
c   an earlier loop.  We must turn this flag off in order to prevent the 
c   block from possibly being reused.
c---------------------------------------------------------------------------

         call set_block_scrub_flag(handle, blk, blkndx, 0)
         go to 1000
      endif
      
c--------------------------------------------------------------------------
c   Build and send the request message to the mgr.
c--------------------------------------------------------------------------

      imsg = find_free_msg_buffer(server_requests, mx_msg_used, 
     *                 instruction_timer, comm_timer)
      msg(1,imsg) = sip_server_request
      msg(2,imsg) = handle
      msg(3,imsg) = nind
      tag    = f_form_msg_tag2()
      msg(4,imsg) = tag
      msg(5,imsg) = current_line
      msg(6,imsg) = op(c_server_stat_key)
      nxt = 7 
      do i = 1, mx_array_index
         if (i .le. nind) then
            msg(nxt,imsg) = ind(i)
         else
            msg(nxt,imsg) = 0
         endif
         nxt = nxt + 1
      enddo

      do i = 1, nind
         call get_index_segment(ind(i), next_segs(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, msg(nxt,imsg), 
     *                             msg(nxt+1,imsg))
         nxt = nxt + 2
      enddo

      do i = nind+1, mx_array_index
         msg(nxt,imsg)   = 0
         msg(nxt+1,imsg) = 0
         nxt = nxt + 2
      enddo

      msg(7, imsg) = block_map_lookup(next_segs, nind, handle,
     *                         array_table(1,handle),
     *                         index_table, nindex_table)

      call mpi_isend(msg(1,imsg), len_sip_server_message, mpi_integer,
     *               mgr, sip_server_message,
     *                 mpi_comm_world, server_requests(imsg), ierr)

c-------------------------------------------------------------------------
c   Post a recv for the block of data.
c   Check if the block is engaged in ongoing communication first.
c-------------------------------------------------------------------------

      call get_actual_blocksize(handle, blk, blkndx,
     *                  array_table, narray_table,
     *                  index_table, nindex_table, 
     *                  segment_table, nsegment_table, blocksize)
      stack  = array_table(c_array_stack,handle)
      indblk = get_block_index(handle, blk, stack, blkndx, x, .true.)

      request = get_block_request(handle, blk, blkndx)
      if (request .ne. MPI_REQUEST_NULL) then
         call wait_on_block(handle, blk, blkndx, served_array, request,
     *             instruction_timer, comm_timer)
      endif
 
      call mpi_irecv(x(indblk), blocksize, mpi_double_precision,
     *               mgr, tag, mpi_comm_world,
     *               request, ierr)
      call set_block_request(handle, blk, blkndx, request)
      if (request .ne. MPI_REQUEST_NULL) then
         call set_block_request_outstanding_flag(handle, blk, blkndx)
         call blkmgr_insert_block_in_list(comm_list_head, 
     *             comm_list_tail, blkndx, c_comm_list_ptr,
     *             .true.)
      endif

c----------------------------------------------------------------------------
c   Set the block_computed_flag.
c----------------------------------------------------------------------------

      call get_block_computed_flag(handle, blk, blkndx, flag)
      if (flag .eq. 0) then
         call get_block_created_flag(handle, blk, blkndx, flag)
         if (flag .eq. 0) then

c--------------------------------------------------------------------------
c   Set the block_persistence_flag.  This guarantees that the block will
c   remain available as long as possible before having to do an actual
c   new request from it's "home" server.
c
c   Setting the flag also updates its age, which is used in the allocation
c   scheme.
c--------------------------------------------------------------------------

            call set_block_persistence_flag(handle, blk, blkndx, 1)
            call blkmgr_insert_block_in_list(persistent_list_head,
     *          persistent_list_tail, blkndx, c_persistent_ptr,
     *          .true.)

c--------------------------------------------------------------------------
c   Set the block request flag for possible monitoring.
c--------------------------------------------------------------------------

            call set_block_request_flag(handle, blk, blkndx, 1)
         endif
      endif

 1000 continue

c---------------------------------------------------------------------------
c   Restore indices to original state.
c---------------------------------------------------------------------------

      do i = 1, nind
         index_table(c_current_seg,ind(i)) = seg(i)
      enddo

      return
      end

      SUBROUTINE SETUPS(ICORE,ICRSIZ,I010,I020,I030,I040,I050,LISTW1,
     &                  LISTW2,LISTT1,LISTT2,NWDIS,NWDSZ,NT2DIS,
     &                  NT2DSZ)
C
C THIS ROUTINE RETURNS THE SYMMETRY INFORMATION ABOUT THE LISTS
C   ON MOIO(LISTT1,LISTT2) AND MOIO(LISTW1,LISTW2), ALONG WITH
C   OFFSETS INTO THE CORE ARRAY WHERE THESE LISTS BEGIN.
C
C       ICORE - CORE VECTOR (PASSED IN)
C       ICRSIZ- SIZE OF WORKING AREA.
C       I010  - OFFSET TO BEGINNING OF THE POPULATION COUNT VECTOR FOR
C                THE MOIO(LISTW1,LISTW2) LIST.
C       I020  - OFFSET TO BEGINNING OF THE SYMMETRY VECTOR FOR
C                THE MOIO(LISTW1,LISTW2) LIST.
C       I030  - OFFSET TO BEGINNING OF THE POPULATION COUNT VECTOR FOR
C                THE MOIO(LISTT1,LISTT2) LIST.
C       I040  - OFFSET TO BEGINNING OF THE SYMMETRY VECTOR FOR
C                THE MOIO(LISTT1,LISTT2) LIST.
C       I050  - TOTAL CORE REQUIRED FOR SYMMETRY INFORMATION.
C       LISTT1- "SPIN CASE" FOR THE T LIST.
C       LISTT2- LIST TYPE FOR T LIST.
C       LISTW1- "SPIN CASE" FOR THE W LIST.
C       LISTW2- LIST TYPE FOR THE W LIST.
C       NWDIS - TOTAL NUMBER OF W DISTRIBUTIONS (IN C1).
C       NWDSZ - SIZE OF W DISTRIBUTIONS (IN C1).
C       NT2DIS- TOTAL NUMBER OF T DISTRIBUTIONS (IN C1).
C       NT2DSZ- SIZE OF T DISTRIBUTIONS (IN C1).
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION DISTYP(18,8),ICORE(ICRSIZ)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      DATA DISTYP /3,3,4,4,14,14,0,0,0,0,0,0,0,0,0,0,0,0,
     &            3,16,4,17,14,11,14,18,0,0,0,0,0,0,0,0,0,0,
     &            1,3,2,4,13,14,10,9,9,10,9,9,10,10,11,12,0,0,
     &            9,9,10,10,11,11,12,12,0,0,0,0,0,0,0,0,0,0,
     &            1,9,2,10,13,18,13,11,0,0,0,0,0,0,0,0,0,0,
     &            1,1,2,2,13,13,0,0,0,0,0,0,0,0,0,0,0,0,
     &            1,3,2,4,13,14,9,9,10,10,10,9,9,10,12,11,11,12,
     &            1,3,2,4,13,14,9,9,10,10,10,9,9,10,12,11,11,12/
      IPOS(I)=2*(I-1)+1
      WDSTPL=DISTYP(IPOS(LISTW1),LISTW2)
      WDSTPR=DISTYP(IPOS(LISTW1)+1,LISTW2)
      TDSTPL=DISTYP(IPOS(LISTT1),LISTT2)
      TDSTPR=DISTYP(IPOS(LISTT1)+1,LISTT2)
      I010=1
      I020=I010+2*NIRREP
      I030=I020+NWDIS+NWDSZ
      I040=I030+2*NIRREP
      I050=I040+NT2DIS+NT2DSZ
      IF(MOD(I050,2).EQ.0)I050=I050+1
C
C INTEGRAL POINTERS.
C
      CALL GETGSV(WDSTPL,NWDSZ,WDSTPR,NWDIS,NIRREP,
     &             ICORE(I010),ICORE(I020))
C
C T2 AMPLITUDE POINTERS.
C
      CALL GETGSV(TDSTPL,NT2DSZ,TDSTPR,NT2DIS,NIRREP,
     &             ICORE(I030),ICORE(I040))
      RETURN
      END

      SUBROUTINE UPDDP(DDP,DDP2,SCR1,NCOORD,NIRREP,UPDATE)
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL UPDATE
C
      DIMENSION DDP(3,NCOORD),DDP2(3,NCOORD),SCR1(1)
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
      DATA AZERO,ONE/0.D0,1.D0/
C
      IF(NIRREP.NE.1) THEN
C
       CALL ZERO(DDP2,NCOORD*3)
       CALL TRADIP(DDP,DDP2,SCR1,NCOORD)
c YAU : old
c      CALL ICOPY(IINTFP*3*NCOORD,DDP2,1,DDP,1)
c YAU : new
       CALL DCOPY(3*NCOORD,DDP2,1,DDP,1)
c YAU : end
C
      ENDIF
C
      IF(UPDATE) THEN
       OPEN(UNIT=82,FILE='DIPDER',STATUS='OLD',FORM='FORMATTED')
       DO 2000 IFIELD=1,3
        READ(82,3000) IJUNK
        DO 2000 IATOM=1,NCOORD/3
         READ(82,3001) AZERO,DDP2(IFIELD,3*IATOM-2),
     &                 DDP2(IFIELD,3*IATOM-1),DDP2(IFIELD,3*IATOM)
2000   CONTINUE
C
3000   FORMAT(I5)
3001   FORMAT(4F20.10)
C
       CALL SAXPY(NCOORD*3,ONE,DDP2,1,DDP,1)
C
      ELSE
C
       OPEN(UNIT=82,FILE='DIPDER',STATUS='UNKNOWN',FORM='FORMATTED')
C
      ENDIF
C
      REWIND(82)
C
      DO 2100 IFIELD=1,3
       WRITE(82,3000) IFIELD
       DO 2100 IATOM=1,NCOORD/3
        WRITE(82,3001) SCR1(IATOM),DDP(IFIELD,3*IATOM-2),
     &                 DDP(IFIELD,3*IATOM-1),DDP(IFIELD,3*IATOM)
2100  CONTINUE
C
      CLOSE(UNIT=82,STATUS='KEEP')
C
      RETURN
      END

module rank1
  double precision x(32400)
  double precision w(32400)
end

module rank2
  double precision x(64800)
  double precision w(64800)
end

module rank3
  double precision x(97200)
  double precision w(97200)
end

module rank4
  double precision x(78400)
  double precision w(78400)
end

module rank5
  double precision x(98000)
  double precision w(98000)
end

module rank6
  double precision x(117600)
  double precision w(117600)
end

module rank7
  double precision x(137200)
  double precision w(137200)
end

module rank8
  double precision x(259200)
  double precision w(259200)
end

module rank9
  double precision x(291600)
  double precision w(291600)
end

module rank10
  double precision x(196000)
  double precision w(196000)
end

module rank11
  double precision x(215600)
  double precision w(215600)
end

module rank12
  double precision x(235200)
  double precision w(235200)
end

module rank13
  double precision x(254800)
  double precision w(254800)
end

      SUBROUTINE A2BULT_PRDUCT(INDX, JNDX, ITYPE, JTYPE, MAXPRM,  
     &                         EXP1, EXP2, CENTER, CNTMU, CNTNU, 
     &                         TMP2)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION TMP2(MAXPRM, MAXPRM), CENTER(3), CNTMU(3), CNTNU(3)
C
      COMMON /HIGHL/ LMNVAL(3,84), ANORM(84)
C

      LI = LMNVAL(1, ITYPE) 
      MI = LMNVAL(2, ITYPE) 
      NI = LMNVAL(3, ITYPE) 
C
      LJ = LMNVAL(1, JTYPE) 
      MJ = LMNVAL(2, JTYPE) 
      NJ = LMNVAL(3, JTYPE) 
C
      DISTNCEI = ((CENTER(1)-CNTMU(1))**2 + (CENTER(2)-CNTMU(2))**2 +
     &           (CENTER(3)-CNTMU(3))**2)
      DISTNCEJ = ((CENTER(1)-CNTNU(1))**2 + (CENTER(2)-CNTNU(2))**2 +
     &           (CENTER(3)-CNTNU(3))**2)
      
      PREFCTI = ((CENTER(1)-CNTMU(1))**LI)*((CENTER(2)-CNTMU(2))**MI)*
     &          ((CENTER(3)-CNTMU(3))**NI)
      PREFCTJ = ((CENTER(1)-CNTNU(1))**LJ)*((CENTER(2)-CNTNU(2))**MJ)*
     &          ((CENTER(3)-CNTNU(3))**NJ)

      EXPFCTI = DEXP(-1.0D0*EXP1*DISTNCEI)
      EXPFCTJ = DEXP(-1.0D0*EXP2*DISTNCEJ)

      TMP2(INDX, JNDX) = PREFCTI*EXPFCTI*PREFCTJ*EXPFCTJ







C
      RETURN
      END

      SUBROUTINE EVEC_SHIFT(EIGEN, VEC, SCR, NOPT)
 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      DIMENSION EIGEN(NOPT, NOPT), VEC(NOPT, NOPT), SCR(NOPT, NOPT)
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Unsorted Eigen values and vectors"
      call output(eigen, 1, nopt, 1, nopt, nopt, nopt, 1)
      call output(vec, 1, nopt, 1, nopt, nopt, nopt, 1)
#endif

      NTR=0
      DO I=NOPT,1,-1
         IF(ABS(EIGEN(I,I)).LT.1.0D-09) NTR=NTR+1
         IF(ABS(EIGEN(I,I)).LT.1.0D-09) ISHIFT=I
      ENDDO
C 
      JSHIFT=ISHIFT-1
      DO J=1,NTR
         JSHIFT=JSHIFT+1
          SCR(8,J)=EIGEN(JSHIFT,JSHIFT)
          DO I=1,NOPT
             SCR(J,I)=VEC(I,JSHIFT)
          ENDDO
      ENDDO
C
      DO J=ISHIFT,NOPT-NTR
        EIGEN(J,J)=EIGEN(J+NTR,J+NTR)
        DO I=1,NOPT
           VEC(I,J)=VEC(I,J+NTR)
        ENDDO
      ENDDO
C
      JTMP=0
      DO J=NOPT-NTR+1,NOPT
         JTMP=JTMP+1
         EIGEN(J,J)=SCR(8,JTMP)
         DO I=1,NOPT
            VEC(I,J)=SCR(JTMP,I)
         ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "Sorted Eigen values and vectors"
      call output(eigen, 1, nopt, 1, nopt, nopt, nopt, 1)
      call output(vec, 1, nopt, 1, nopt, nopt, nopt, 1)
#endif
      
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK HQR2
      SUBROUTINE HQR2 (NM, N, LOW, IGH, H, WR, WI, Z, IERR)
C***BEGIN PROLOGUE  HQR2
C***PURPOSE  Compute the eigenvalues and eigenvectors of a real upper
C            Hessenberg matrix using QR method.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C2B
C***TYPE      DOUBLE PRECISION (HQR2-S, COMQR2-C)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure HQR2,
C     NUM. MATH. 16, 181-204(1970) by Peters and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 372-395(1971).
C
C     This subroutine finds the eigenvalues and eigenvectors
C     of a REAL*8 UPPER Hessenberg matrix by the QR method.  The
C     eigenvectors of a REAL*8 GENERAL matrix can also be found
C     if  ELMHES  and  ELTRAN  or  ORTHES  and  ORTRAN  have
C     been used to reduce this general matrix to Hessenberg form
C     and to accumulate the similarity transformations.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, H and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix H.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix, N.
C
C        H contains the upper Hessenberg matrix.  H is a two-dimensional
C          REAL*8 array, dimensioned H(NM,N).
C
C        Z contains the transformation matrix produced by  ELTRAN
C          after the reduction by  ELMHES, or by  ORTRAN  after the
C          reduction by  ORTHES, if performed.  If the eigenvectors
C          of the Hessenberg matrix are desired, Z must contain the
C          identity matrix.  Z is a two-dimensional REAL*8 array,
C          dimensioned Z(NM,M).
C
C     On OUTPUT
C
C        H has been destroyed.
C
C        WR and WI contain the real and imaginary parts, respectively,
C          of the eigenvalues.  The eigenvalues are unordered except
C          that complex conjugate pairs of values appear consecutively
C          with the eigenvalue having the positive imaginary part first.
C          If an error exit is made, the eigenvalues should be correct
C          for indices IERR+1, IERR+2, ..., N.  WR and WI are one-
C          dimensional REAL*8 arrays, dimensioned WR(N) and WI(N).
C
C        Z contains the real and imaginary parts of the eigenvectors.
C          If the J-th eigenvalue is real, the J-th column of Z
C          contains its eigenvector.  If the J-th eigenvalue is complex
C          with positive imaginary part, the J-th and (J+1)-th
C          columns of Z contain the real and imaginary parts of its
C          eigenvector.  The eigenvectors are unnormalized.  If an
C          error exit is made, none of the eigenvectors has been found.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after a total of 30*N iterations.
C                     The eigenvalues should be correct for indices
C                     IERR+1, IERR+2, ..., N, but no eigenvectors are
C                     computed.
C
C     Calls CDIV for complex division.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  CDIV
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  HQR2
C
#ifdef ACES64
      INTEGER*8 I,J,K,L,M,N,EN,II,JJ,LL,MM,NA,NM,NN
      INTEGER*8 IGH,ITN,ITS,LOW,MP2,ENM2,IERR
#else
      INTEGER I,J,K,L,M,N,EN,II,JJ,LL,MM,NA,NM,NN
      INTEGER IGH,ITN,ITS,LOW,MP2,ENM2,IERR
#endif
      DOUBLE PRECISION H(NM,*),WR(*),WI(*),Z(NM,*)
      DOUBLE PRECISION P,Q,R,S,T,W,X,Y,RA,SA,VI,VR,ZZ,NORM,S1,S2
      LOGICAL NOTLAS,OVFLSW
      DATA OVFLSW /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  HQR2
      IERR = 0
      NORM = 0.0D0
      K = 1
C     .......... STORE ROOTS ISOLATED BY BALANC
C                AND COMPUTE MATRIX NORM ..........
      DO 50 I = 1, N
C
         DO 40 J = K, N
   40    NORM = NORM + ABS(H(I,J))
C
         K = I
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 50
         WR(I) = H(I,I)
         WI(I) = 0.0D0
   50 CONTINUE
C
      EN = IGH
      T = 0.0D0
      ITN = 30*N
C     .......... SEARCH FOR NEXT EIGENVALUES ..........
   60 IF (EN .LT. LOW) GO TO 340
      ITS = 0
      NA = EN - 1
      ENM2 = NA - 1
C     .......... LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT
C                FOR L=EN STEP -1 UNTIL LOW DO -- ..........
   70 DO 80 LL = LOW, EN
         L = EN + LOW - LL
         IF (L .EQ. LOW) GO TO 100
         S = ABS(H(L-1,L-1)) + ABS(H(L,L))
         IF (S .EQ. 0.0D0) S = NORM
         S2 = S + ABS(H(L,L-1))
         IF (S2 .EQ. S) GO TO 100
   80 CONTINUE
C     .......... FORM SHIFT ..........
  100 X = H(EN,EN)
      IF (L .EQ. EN) GO TO 270
      Y = H(NA,NA)
      W = H(EN,NA) * H(NA,EN)
      IF (L .EQ. NA) GO TO 280
      IF (ITN .EQ. 0) GO TO 1000
      IF (ITS .NE. 10 .AND. ITS .NE. 20) GO TO 130
C     .......... FORM EXCEPTIONAL SHIFT ..........
      T = T + X
C
      DO 120 I = LOW, EN
  120 H(I,I) = H(I,I) - X
C
      S = ABS(H(EN,NA)) + ABS(H(NA,ENM2))
      X = 0.75D0 * S
      Y = X
      W = -0.4375D0 * S * S
  130 ITS = ITS + 1
      ITN = ITN - 1
C     .......... LOOK FOR TWO CONSECUTIVE SMALL
C                SUB-DIAGONAL ELEMENTS.
C                FOR M=EN-2 STEP -1 UNTIL L DO -- ..........
      DO 140 MM = L, ENM2
         M = ENM2 + L - MM
         ZZ = H(M,M)
         R = X - ZZ
         S = Y - ZZ
         P = (R * S - W) / H(M+1,M) + H(M,M+1)
         Q = H(M+1,M+1) - ZZ - R - S
         R = H(M+2,M+1)
         S = ABS(P) + ABS(Q) + ABS(R)
         P = P / S
         Q = Q / S
         R = R / S
         IF (M .EQ. L) GO TO 150
         S1 = ABS(P) * (ABS(H(M-1,M-1)) + ABS(ZZ) + ABS(H(M+1,M+1)))
         S2 = S1 + ABS(H(M,M-1)) * (ABS(Q) + ABS(R))
         IF (S2 .EQ. S1) GO TO 150
  140 CONTINUE
C
  150 MP2 = M + 2
C
      DO 160 I = MP2, EN
         H(I,I-2) = 0.0D0
         IF (I .EQ. MP2) GO TO 160
         H(I,I-3) = 0.0D0
  160 CONTINUE
C     .......... DOUBLE QR STEP INVOLVING ROWS L TO EN AND
C                COLUMNS M TO EN ..........
      DO 260 K = M, NA
         NOTLAS = K .NE. NA
         IF (K .EQ. M) GO TO 170
         P = H(K,K-1)
         Q = H(K+1,K-1)
         R = 0.0D0
         IF (NOTLAS) R = H(K+2,K-1)
         X = ABS(P) + ABS(Q) + ABS(R)
         IF (X .EQ. 0.0D0) GO TO 260
         P = P / X
         Q = Q / X
         R = R / X
  170    S = SIGN(SQRT(P*P+Q*Q+R*R),P)
         IF (K .EQ. M) GO TO 180
         H(K,K-1) = -S * X
         GO TO 190
  180    IF (L .NE. M) H(K,K-1) = -H(K,K-1)
  190    P = P + S
         X = P / S
         Y = Q / S
         ZZ = R / S
         Q = Q / P
         R = R / P
cYAU: The following loops are inverted so the conditional is evaluated once.
cYAU|C     .......... ROW MODIFICATION ..........
cYAU|         DO 210 J = K, N
cYAU|            P = H(K,J) + Q * H(K+1,J)
cYAU|            IF (.NOT. NOTLAS) GO TO 200
cYAU|            P = P + R * H(K+2,J)
cYAU|            H(K+2,J) = H(K+2,J) - P * ZZ
cYAU|  200       H(K+1,J) = H(K+1,J) - P * Y
cYAU|            H(K,J) = H(K,J) - P * X
cYAU|  210    CONTINUE
cYAU|         J = MIN(EN,K+3)
cYAU|C     .......... COLUMN MODIFICATION ..........
cYAU|         DO 230 I = 1, J
cYAU|            P = X * H(I,K) + Y * H(I,K+1)
cYAU|            IF (.NOT. NOTLAS) GO TO 220
cYAU|            P = P + ZZ * H(I,K+2)
cYAU|            H(I,K+2) = H(I,K+2) - P * R
cYAU|  220       H(I,K+1) = H(I,K+1) - P * Q
cYAU|            H(I,K) = H(I,K) - P
cYAU|  230    CONTINUE
cYAU|C     .......... ACCUMULATE TRANSFORMATIONS ..........
cYAU|         DO 250 I = LOW, IGH
cYAU|            P = X * Z(I,K) + Y * Z(I,K+1)
cYAU|            IF (.NOT. NOTLAS) GO TO 240
cYAU|            P = P + ZZ * Z(I,K+2)
cYAU|            Z(I,K+2) = Z(I,K+2) - P * R
cYAU|  240       Z(I,K+1) = Z(I,K+1) - P * Q
cYAU|            Z(I,K) = Z(I,K) - P
cYAU|  250    CONTINUE
cYAU: begin new code
         IF (NOTLAS) THEN
            DO J = K, N
               P = H(K,J) + Q * H(K+1,J) + R * H(K+2,J)
               H(K,J) = H(K,J) - P * X
               H(K+1,J) = H(K+1,J) - P * Y
               H(K+2,J) = H(K+2,J) - P * ZZ
            END DO
            J = MIN(EN,K+3)
            DO I = 1, J
               P = X * H(I,K) + Y * H(I,K+1) + ZZ * H(I,K+2)
               H(I,K) = H(I,K) - P
               H(I,K+1) = H(I,K+1) - P * Q
               H(I,K+2) = H(I,K+2) - P * R
            END DO
            DO I = LOW, IGH
               P = X * Z(I,K) + Y * Z(I,K+1) + ZZ * Z(I,K+2)
               Z(I,K) = Z(I,K) - P
               Z(I,K+1) = Z(I,K+1) - P * Q
               Z(I,K+2) = Z(I,K+2) - P * R
            END DO
         ELSE
            DO J = K, N
               P = H(K,J) + Q * H(K+1,J)
               H(K,J) = H(K,J) - P * X
               H(K+1,J) = H(K+1,J) - P * Y
            END DO
            J = MIN(EN,K+3)
            DO I = 1, J
               P = X * H(I,K) + Y * H(I,K+1)
               H(I,K) = H(I,K) - P
               H(I,K+1) = H(I,K+1) - P * Q
            END DO
            DO I = LOW, IGH
               P = X * Z(I,K) + Y * Z(I,K+1)
               Z(I,K) = Z(I,K) - P
               Z(I,K+1) = Z(I,K+1) - P * Q
            END DO
         END IF
cYAU: end new code
C
  260 CONTINUE
C
      GO TO 70
C     .......... ONE ROOT FOUND ..........
  270 H(EN,EN) = X + T
      WR(EN) = H(EN,EN)
      WI(EN) = 0.0D0
      EN = NA
      GO TO 60
C     .......... TWO ROOTS FOUND ..........
  280 P = (Y - X) / 2.0D0
      Q = P * P + W
      ZZ = SQRT(ABS(Q))
      H(EN,EN) = X + T
      X = H(EN,EN)
      H(NA,NA) = Y + T
      IF (Q .LT. 0.0D0) GO TO 320
C     .......... REAL PAIR ..........
      ZZ = P + SIGN(ZZ,P)
      WR(NA) = X + ZZ
      WR(EN) = WR(NA)
      IF (ZZ .NE. 0.0D0) WR(EN) = X - W / ZZ
      WI(NA) = 0.0D0
      WI(EN) = 0.0D0
      X = H(EN,NA)
      S = ABS(X) + ABS(ZZ)
      P = X / S
      Q = ZZ / S
      R = SQRT(P*P+Q*Q)
      P = P / R
      Q = Q / R
C     .......... ROW MODIFICATION ..........
      DO 290 J = NA, N
         ZZ = H(NA,J)
         H(NA,J) = Q * ZZ + P * H(EN,J)
         H(EN,J) = Q * H(EN,J) - P * ZZ
  290 CONTINUE
C     .......... COLUMN MODIFICATION ..........
      DO 300 I = 1, EN
         ZZ = H(I,NA)
         H(I,NA) = Q * ZZ + P * H(I,EN)
         H(I,EN) = Q * H(I,EN) - P * ZZ
  300 CONTINUE
C     .......... ACCUMULATE TRANSFORMATIONS ..........
      DO 310 I = LOW, IGH
         ZZ = Z(I,NA)
         Z(I,NA) = Q * ZZ + P * Z(I,EN)
         Z(I,EN) = Q * Z(I,EN) - P * ZZ
  310 CONTINUE
C
      GO TO 330
C     .......... COMPLEX PAIR ..........
  320 WR(NA) = X + P
      WR(EN) = X + P
      WI(NA) = ZZ
      WI(EN) = -ZZ
  330 EN = ENM2
      GO TO 60
C     .......... ALL ROOTS FOUND.  BACKSUBSTITUTE TO FIND
C                VECTORS OF UPPER TRIANGULAR FORM ..........
  340 IF (NORM .EQ. 0.0D0) GO TO 1001
C     .......... FOR EN=N STEP -1 UNTIL 1 DO -- ..........
      DO 800 NN = 1, N
         EN = N + 1 - NN
         P = WR(EN)
         Q = WI(EN)
         NA = EN - 1
         IF (Q) 710, 600, 800
C     .......... REAL VECTOR ..........
  600    M = EN
         H(EN,EN) = 1.0D0
         IF (NA .EQ. 0) GO TO 800
C     .......... FOR I=EN-1 STEP -1 UNTIL 1 DO -- ..........
         DO 700 II = 1, NA
            I = EN - II
            W = H(I,I) - P
            R = H(I,EN)
            IF (M .GT. NA) GO TO 620
C
            DO 610 J = M, NA
  610       R = R + H(I,J) * H(J,EN)
C
  620       IF (WI(I) .GE. 0.0D0) GO TO 630
            ZZ = W
            S = R
            GO TO 700
  630       M = I
            IF (WI(I) .NE. 0.0D0) GO TO 640
            T = W
            IF (T .NE. 0.0D0) GO TO 635
            T = NORM
  632       T = 0.5D0*T
            IF (NORM + T .GT. NORM) GO TO 632
            T = 2.0D0*T
  635       H(I,EN) = -R / T
            GO TO 680
C     .......... SOLVE REAL EQUATIONS ..........
  640       X = H(I,I+1)
            Y = H(I+1,I)
            Q = (WR(I) - P) * (WR(I) - P) + WI(I) * WI(I)
            T = (X * S - ZZ * R) / Q
            H(I,EN) = T
            IF (ABS(X) .LE. ABS(ZZ)) GO TO 650
            H(I+1,EN) = (-R - W * T) / X
            GO TO 680
  650       H(I+1,EN) = (-S - Y * T) / ZZ
cYAU: The following code was incorporated from a later version.
c     .......... overflow control ..........
  680       IF (OVFLSW) THEN
               S1 = ABS(H(I,EN))
               IF (S1 .NE. 0.0d0) THEN
                  S2 = S1 + 1.0d0/S1
                  IF (S2 .LE. S1) THEN
                     DO J = I, EN
                        H(J,EN) = H(J,EN)/S1
                     END DO
                  END IF
               END IF
            END IF
cYAU: end added code
  700    CONTINUE
C     .......... END REAL VECTOR ..........
         GO TO 800
C     .......... COMPLEX VECTOR ..........
  710    M = NA
C     .......... LAST VECTOR COMPONENT CHOSEN IMAGINARY SO THAT
C                EIGENVECTOR MATRIX IS TRIANGULAR ..........
         IF (ABS(H(EN,NA)) .LE. ABS(H(NA,EN))) GO TO 720
         H(NA,NA) = Q / H(EN,NA)
         H(NA,EN) = -(H(EN,EN) - P) / H(EN,NA)
         GO TO 730
  720    CALL CDIV(0.0D0,-H(NA,EN),H(NA,NA)-P,Q,H(NA,NA),H(NA,EN))
  730    H(EN,NA) = 0.0D0
         H(EN,EN) = 1.0D0
         ENM2 = NA - 1
         IF (ENM2 .EQ. 0) GO TO 800
C     .......... FOR I=EN-2 STEP -1 UNTIL 1 DO -- ..........
         DO 795 II = 1, ENM2
            I = NA - II
            W = H(I,I) - P
            RA = 0.0D0
            SA = H(I,EN)
C
            DO 760 J = M, NA
               RA = RA + H(I,J) * H(J,NA)
               SA = SA + H(I,J) * H(J,EN)
  760       CONTINUE
C
            IF (WI(I) .GE. 0.0D0) GO TO 770
            ZZ = W
            R = RA
            S = SA
            GO TO 795
  770       M = I
            IF (WI(I) .NE. 0.0D0) GO TO 780
            CALL CDIV(-RA,-SA,W,Q,H(I,NA),H(I,EN))
            GO TO 790
C     .......... SOLVE COMPLEX EQUATIONS ..........
  780       X = H(I,I+1)
            Y = H(I+1,I)
            VR = (WR(I) - P) * (WR(I) - P) + WI(I) * WI(I) - Q * Q
            VI = (WR(I) - P) * 2.0D0 * Q
            IF (VR .NE. 0.0D0 .OR. VI .NE. 0.0D0) GO TO 783
            S1 = NORM * (ABS(W)+ABS(Q)+ABS(X)+ABS(Y)+ABS(ZZ))
            VR = S1
  782       VR = 0.5D0*VR
            IF (S1 + VR .GT. S1) GO TO 782
            VR = 2.0D0*VR
  783       CALL CDIV(X*R-ZZ*RA+Q*SA,X*S-ZZ*SA-Q*RA,VR,VI,
     x                H(I,NA),H(I,EN))
            IF (ABS(X) .LE. ABS(ZZ) + ABS(Q)) GO TO 785
            H(I+1,NA) = (-RA - W * H(I,NA) + Q * H(I,EN)) / X
            H(I+1,EN) = (-SA - W * H(I,EN) - Q * H(I,NA)) / X
            GO TO 790
  785       CALL CDIV(-R-Y*H(I,NA),-S-Y*H(I,EN),ZZ,Q,
     x                H(I+1,NA),H(I+1,EN))
cYAU: The following code was incorporated from a later version.
c     .......... overflow control ..........
  790       IF (OVFLSW) THEN
               S1 = MAX(ABS(H(I,NA)), ABS(H(I,EN)))
               IF (S1 .NE. 0.0D0) THEN
                  S2 = S1 + 1.0D0/S1
                  IF (S2 .LE. S1) THEN
                     DO J = I, EN
                        H(J,NA) = H(J,NA)/S1
                        H(J,EN) = H(J,EN)/S1
                     END DO
                  END IF
               END IF
            END IF
cYAU: end added code
  795    CONTINUE
C     .......... END COMPLEX VECTOR ..........
  800 CONTINUE
C     .......... END BACK SUBSTITUTION.
C                VECTORS OF ISOLATED ROOTS ..........
      DO 840 I = 1, N
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 840
C
         DO 820 J = I, N
  820    Z(I,J) = H(I,J)
C
  840 CONTINUE
C     .......... MULTIPLY BY TRANSFORMATION MATRIX TO GIVE
C                VECTORS OF ORIGINAL FULL MATRIX.
C                FOR J=N STEP -1 UNTIL LOW DO -- ..........
      DO 880 JJ = LOW, N
         J = N + LOW - JJ
         M = MIN(J,IGH)
C
         DO 880 I = LOW, IGH
            ZZ = 0.0D0
C
            DO 860 K = LOW, M
  860       ZZ = ZZ + Z(I,K) * H(K,J)
C
            Z(I,J) = ZZ
  880 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30*N ITERATIONS ..........
 1000 IERR = EN
 1001 RETURN
      END

      SUBROUTINE MO2AO2(ZMO,ZAO,EVEC,SCR,NBAS,ISPIN)
C
C TRANSFORMS A TWO-INDEX QUANTITY (I.E. DENSITY) FROM THE MO TO
C  THE AO BASIS.
C
C INPUT:
C       ZMO  - TWO-INDEX QUANTITY IN MO BASIS (LENGTH: NBAS*NBAS)
C       NBAS - NUMBER OF BASIS FUNCTIONS
C       ISPIN- 1 FOR ALPHA, 2 FOR BETA
C
C OUTPUT:
C       ZAO  - TWO-INDEX QUANTITY IN AO BASIS (LENGTH: NBAS*NBAS)
C       
C SCRATCH:
C       EVEC - HOLDS EIGENVECTOR MATRIX (LENGTH: NBAS*NBAS)
C       SCR  - HOLDS INTERMEDIATE QUANTITY (LENGTH: NBAS*NBAS) 
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*8 LABEL
      DIMENSION EVEC(NBAS,NBAS),ZMO(NBAS,NBAS),ZAO(NBAS,NBAS)
      DIMENSION SCR(NBAS,NBAS)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      IF(ISPIN.EQ.1)LABEL='SCFEVCA0'
      IF(ISPIN.EQ.2)LABEL='SCFEVCB0'
      CALL GETREC(20,'JOBARC',LABEL,IINTFP*NBAS*NBAS,EVEC)
      CALL MTRAN2(EVEC,NBAS)
      CALL MXM(ZMO,NBAS,EVEC,NBAS,SCR,NBAS)
      CALL MTRAN2(EVEC,NBAS)
      CALL MXM(EVEC,NBAS,SCR,NBAS,ZAO,NBAS)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine flowqsdmin(scratch, grad, ehess, eigvh, dmr1, dmr2,
     &                      stp, eps, nx, ndim, ncycle)
c
c This subroutine implements the quadratic gradient descent
c algorithm of J.-Q. Sun and K.Ruedenberg in JCP 99, 5257 (1993).
c
      implicit double precision(a-h, o-z)
#include "fnamelen.par"
      character*(fnamelen) fname
      logical yesno, update, nwtonrpson, negeval, genstpsz
c
      dimension scratch(nx*nx), grad(ndim), ehess(ndim, ndim), 
     &          eigvh(ndim, ndim), dmr1(ndim, ndim), dmr2(ndim,ndim)
c
c find the eigenvalues and eigenvectors of the hessian to build the
c solution to eqn. 11 in Sun & Ruedenberg.
c
      call eig(ehess, eigvh, ndim, ndim, 1)
c
c Find the tangential vector, the scalar curvature, and define some
c ad hoc factors from Sun & Ruedenburg.
c
      update     = .false.
      nwtonrpson = .false.
      negeval    = .false.
      genstpsz    = .true.
      unew    = 0.0d0
      u_upper = 0.0d0
      u_lower = 0.0d0
      hvalue  = 0.0d0
      anu     = 5.0d0/6.0d0
c
      call qsdline(scratch, ehess, eigvh, dmr1, dmr2, unew, u_upper,
     &             u_lower, hvalue, curvtre, ndim, nx, update,
     &             nwtonrpson, negeval, genstpsz)
c
c construct the curvature dependent step size (eqn. 20b)
c
      crvdstsz = 0.25d0 + (0.75d0)/(1.d0 + 3.0d0*curvtre**anu)
      Write(6, *) "The value of curv =", curvtre
      eh = 0.3d0*crvdstsz
      Write(6, *) "The value of stpsize = ", eh
c      
c
c       if (ncycle .eq. 1) then
c
c P_0=Q_0=R_0 at the initial point. Calculate P* and Q_1 and 
c Save P*
c
c           call xdcopy(ndim, scratch(1), 1, scratch(1 + 2*ndim), 1)
           
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                  (eh/2)**2, eps, nx, ndim)
c
c          open(unit = 99, file = "QSDPINTS", form = "formatted")
c          write(99, 999) eh
c          write(99, 9999) (scratch(i + 2*ndim), i = 1, ndim)
c
c Get the Q_1 based on P*
c
          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
     &                   (eh/2.0d0), eps, nx, ndim)

c          call vadd(scratch(1 + 2*ndim), scratch(1 + 2*ndim), 
c     &              scratch(1), ndim, -1.0d0)
c
c          call xdcopy(ndim, scratch(1 + 2*ndim), 1, scratch(1 + ndim),
c     &               1)
c
c       else if (ncycle .eq. 2) then
c
c Calculate R_1 based on P*
c             
c          call gfname('QSDPINTS', fname, ilength)
c          inquire(file=fname(1:ilength), exist=yesno)
c          if (yesno) open(unit = 99, file = "QSDPINTS", 
c     &                    form = "formatted", status ="old")
c
c          read(99, 999) ehp
c          read(99, 9999) (scratch(i + 2*ndim), i = 1, ndim)
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                   (ehp/4.0d0)**2, eps, nx, ndim)
c
c Calculate P_1 based on Q_1
c
c          call xdcopy(ndim, scratch(1), 1, scratch(1 + 2*ndim), 1)
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                  (ehp/2.0d0)**2, eps, nx, ndim)
c          rewind(99)
c          write(99, 999) eh
c          write(99, 9999) (scratch(i + 2*ndim), i = 1, ndim)
c
c Calculate Q_2 based on P_1
c
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                  (eh/2.0d0)**2, eps, nx, ndim)
c
c          call vadd(scratch(1 + 2*ndim), scratch(1 + 2*ndim), 
c     &             scratch(1), ndim, -1.0d0)
c
c          call xdcopy(ndim, scratch(1 + 2*ndim), 1, scratch(1 + ndim),
c     &               1)
c
c       else
c
c Calculate R_n based on P_n-1
c
c          call gfname('QSDPINTS', fname, ilength)
c          inquire(file=fname(1:ilength), exist=yesno)
c          if (yesno) open(unit = 99, file = "QSDPINTS", 
c     &                    form = "formatted", status="old")
c
c          read(99, 999) ehp
c          read(99, 9999) (scratch(i + 2*ndim), i = 1, ndim)
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                  (ehp/2.0d0)**2, eps, nx, ndim)
c
c Calculate P_n based on Q_n
c
c          call xdcopy(ndim, scratch(1), 1, scratch(1 + 2*ndim), 1)
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                  (eh/2.0d0)**2, eps, nx, ndim)
c          rewind(99)
c          write(99, 999) eh
c          write(99, 9999) (scratch(i + 2*ndim), i = 1, ndim)
c
c Calculate Q_n+1 based on P_n
c
c          call getptspqr(scratch, ehess, eigvh, dmr1, dmr2, 
c     &                  (eh/2.0d0)**2, eps, nx, ndim)
c
c           call vadd(scratch(1 + 2*ndim), scratch(1 + 2*ndim), 
c     &             scratch(1), ndim, -1.0d0)
c
c           call xdcopy(ndim, scratch(1 + 2*ndim), 1, 
c     &                scratch(1 + ndim), 1)
c
c
c      endif
c       
 999    format(1x, f15.8)
 9999   format(1x, 3(f15.8, 1x))
c        
       return
       end

      SUBROUTINE sortint(n,arr)
      INTEGER n,M,NSTACK
      integer arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      integer a,temp
      if(n.le.1) return
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          a=arr(j)
          do 11 i=j-1,1,-1
            if(arr(i).le.a)goto 2
            arr(i+1)=arr(i)
11        continue
          i=0
2         arr(i+1)=a
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l+1).gt.arr(l))then
          temp=arr(l+1)
          arr(l+1)=arr(l)
          arr(l)=temp
        endif
        i=l+1
        j=ir
        a=arr(l)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 3
5       arr(l)=arr(j)
        arr(j)=a
        jstack=jstack+2
        if(jstack.gt.NSTACK) stop 'NSTACK too small in sort2'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END

      SUBROUTINE EXPT1(T1PACK,T1FULL,NOCC,NVRT,
     &                 NOCC_EXPND,NVRT_EXPND,NOCCO_EXPND,NVRTO_EXPND,
     &                 NDROPMO,ISPIN)
C
C THIS EXPANDS THE T1 VECTOR FROM A SYMMETRY PACKED ORDER TO A FULL
C NVRT x NOCC VECTOR
C
C Modifications to accomodate dropmo functionality. Ajith Perera, 07/2005.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER POP,VRT,DIRPRD
      DIMENSION T1PACK(1),T1FULL(NVRT,NOCC)
      DIMENSION NOCC_EXPND(8,2),NVRT_EXPND(8,2),
     &          NOCCO_EXPND(2),NVRTO_EXPND(2)
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF(4)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SYMINF/NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      CALL ZERO(T1FULL,NVRT*NOCC)
      LENGTH=NOCCO(ISPIN)*NVRTO(ISPIN)
      IF (NDROPMO.GT.0) LENGTH=NOCCO_EXPND(ISPIN)*NVRTO_EXPND(ISPIN)
      IOFFO=1
      IOFFV=1
      IOFF0=1
      DO 10 IRREP=1,NIRREP
       NOCIRR=POP(IRREP,ISPIN)
       NVRIRR=VRT(IRREP,ISPIN)
       IF (NDROPMO.GT.0) THEN
          NOCIRR=NOCC_EXPND(IRREP,ISPIN)
          NVRIRR=NVRT_EXPND(IRREP,ISPIN)
       END IF
       DO 20 IOCC=1,NOCIRR
        CALL SCOPY(NVRIRR,T1PACK(IOFF0),1,T1FULL(IOFFV,IOFFO),1)
        IOFFO=IOFFO+1
        IOFF0=IOFF0+NVRIRR
20     CONTINUE
       IOFFV=IOFFV+NVRIRR
10    CONTINUE
      CALL SCOPY(LENGTH,T1FULL,1,T1PACK,1)
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_NLMO_RESULTS
     +
     +                    ( UNITID,
     +                      NBAS,NATOM,
     +                      LOCAL )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_NLMO_RESULTS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints info about the set of obtained
C                natural localized molecular orbitals (NLMOs) to a file
C                specified by its unit identification number. The
C                order of the NLMOs corresponds to the parent NBO
C                ordering.
C
C                At the moment only the atomic localization map of
C                the NLMOs is printed, which, when compared to the
C                one obtained for the NBOs, gives an indication on
C                how much locality was lost due to the NBO -> NLMO
C                transformation.
C
C
C                  Input:
C
C                    UNITID       =  printout unit identification #
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atoms
C                    LOCAL (A,I)  =  NLMO atom locality map for each
C                                    atom A and with NLMOs in NCB/NLB/
C                                    NBB/NEB/NAB/NYB/NRB order (i.e.
C                                    corresponding to their parent NBO
C                                    ordering).
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     UNITID

         DOUBLE PRECISION  LOCAL (1:NATOM,1:NBAS)
C
C
C------------------------------------------------------------------------
C
C
C             ...print out the NLMO atomic localization map.
C
C
         WRITE (UNITID,9000) 'NLMO Atomic Localization Map'
 9000    FORMAT (//,20X,A28)

         CALL    MAT__PRINT_A_FLOAT_3_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows = Atoms ; Columns = NLMOs ',
     +                  NATOM,NBAS,
     +                  NATOM,NBAS,
     +                  LOCAL )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE GMETRY(We_havegeom, NOSILENT)
C
C     ROUTINE TO CALCULATE CARTESIAN COORDINATES FROM INTERNAL
C     COORDINATE REPRESENTATION.  SOME OF THIS HAS BEEN LIFTED FROM
C     PRDDO, ALTHOUGH SOME IMPROVEMENTS HAVE BEEN MADE.  UP TO 50
C     ATOMS ALLOWED.  CONNECTIVITY OF FIRST THREE MUST BE 1-2-3 IN
C     INTERNAL COORDINATE REP.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "coord.com"
      LOGICAL OPTRES
      INTEGER NA(MXATMS),NB(MXATMS),NC(MXATMS)
      DIMENSION A(3,MXATMS),Q0(3*MXATMS)
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
C
      COMMON/RESTART2/OPTRES
C
      LOGICAL NOT_IN_BOUND, We_havegeom, NOSILENT
#include "io_units.par"
C
      IONE=1
      CALL GETREC(-1,'JOBARC','PASS1   ',IONE,IX)
CSSS      CALL GETREC(-1,'JOBARC', 'VIB_POPT',IONE, ipost_vib)
      If (IPrnt .ge. 20 .AND. NOSILENT) then
         Write (LuOut, *) 'GMETRY starting with R'
         Write (LuOut,'((I3,1X,f12.6))') (i,R(i),i=1,NX)
      EndIf
C
#ifdef _DEBUG_LVL0
      Print*, "In Gmetry; ncycle, ix, and ipost_vib"
      Print*, ncycle, is, ipost_vib
#endif
      IF (ncycle .NE. 0. or. ix.ne.0) THEN
C
C DECOMPRESS R
C
         If (IPrnt .ge. 20 .AND. NOSILENT) Write (LuOut, '(a)')
     $      '@GMETRY-I, Decompressing R.'
         CALL USQUSH(R,NXM6)
         IF(.NOT.OPTRES .AND. NOSILENT)  WRITE(LuOut,78)
 78      FORMAT(' Updating structure...')
      ELSE
         ATOR=DACOS(-1.D0)/180.D0
         ATOB=0.529177249D0
         If (IPrnt .ge. 20 .AND. NOSILENT) Write (LuOut,*)
     $      'GMETRY: Converting to radians & bohr.',ator,atob
         DO 19 IX=8,NX-1,3
            IF(IX.NE.8)R(IX+1)=R(IX+1)*ATOR
 19         R(IX)=R(IX)*ATOR
         IF(IFLAGS(78).EQ.0)THEN
          DO 18 IX=4,NX-2,3
 18          R(IX)=R(IX)/ATOB
         ENDIF
      ENDIF
C
      If (IPrnt .ge. 20 .AND. NOSILENT) then
         Write (LuOut, *) 'GMETRY using R vector'
         Write (LuOut,'((I3,1X,f12.6))') (i,R(i),i=1,NX)
      EndIf

      CALL GEN_CART_COORD(Q0, NOSILENT)
C
C DEAL WITH CASE WHERE ANGLES OR DIHEDRALS NOT WITHIN BOUNDS HERE.
C
      CALL ZERO(Q0,3*MXATMS)
      CALL VADD(Q0,R,Q0,NX,1.D0)
      CALL XTOR(R,0)
      CALL USQUSH(R,NXM6)
      NOT_IN_BOUND = .FALSE.
      DO 107 I=1,NX
       IF(DABS(DABS(R(I))-DABS(Q0(I))).GT.1.D-4)THEN
        IF(NOSILENT) WRITE(6,8331)I,Q0(I),R(I)
 8331   FORMAT('@GMETRY-W, Internal coordinate #',i3,
     &' not within bounds:',
     &/,t3,' Value was: ',f10.5,' and has been changed to ',f10.5,'.')
        NOT_IN_BOUND = .TRUE.
       ENDIF
 107  CONTINUE
C
C Since their inception, the previous 12 lines, which were meant to
C correct poorly constructed internal coordinates, were doing more harm
C than good for geometry optimizations. I assume that this was left
C unnoticed for so many years simply because every one wrote decent
C Z-matrices. Then come ZMAT files generated automatically by MOPAC (or
C HyperChem?). Those matrices go through the 12 lines and trigger the
C "not within bound" flag, which causes joda to use its own internally-
C chosen values. The problem is that the Cartesian coordinates still
C correspond to the "bad" internal coordinates. For single point
C calculations, this is irrelevant since the internal coordinates have
C no role beyond generating the Cartesian coordinates (so why do we even
C bother for SP calcs?). However, during an optimization, we go back
C and forth between Cartesians and internals. As a result, when the
C condition that ((DABS(DABS(R(I))-DABS(Q0(I))).GT.1.D-4) is satisfied,
C the gradients are calculated for Cartesians that do NOT correspond to
C the internals that are supposed to be updated. This is a serious error
C and might partially explain why some TS searches were "meandering". To
C fix this, I created a new subroutine called GEN_CART_COORD which takes
C internal coordinates and connectivities (from ACES II common blocks)
C and generates ACES II Cartesians (nothing else). Ajith Perera, 04/2005
C
C Only one out-of-bound is all it takes to regenerate Cartesians.
      IF (NOT_IN_BOUND) CALL GEN_CART_COORD(Q0, NOSILENT)
C
#ifdef _DEBUG_LVL0
      Call geomout
#endif
      RETURN
      END

      SUBROUTINE GNSYOF
C
C THIS ROUTINE CREATES SYMMETRY OFFSET VECTORS
C
C THE NUMBERING SCHEME IS AS FOLLOWS :
C
C  a<b    (alpha) [1]
C  a<b    (beta)  [2]
C  i<j    (alpha) [3]
C  i<j    (beta)  [4]
C  a<=b   (alpha) [5]
C  a<=b   (beta)  [6]
C  i<=j   (alpha) [7]
C  i<=j   (beta)  [8]
C  a,i    (alpha) [9]
C  a,i    (beta)  [10]
C  a,i    (AB)    [11]
C  a,i    (BA)    [12]
C  a,b    (AB)    [13]
C  i,j    (AB)    [14]
C  a,b    (AB)    [15]
C  i,a    (alpha) [16]
C  i,a    (beta)  [17]
C  i,a    (AB)    [18]
C  a,b    (alpha) [19]
C  a,b    (beta)  [20]
C  i,j    (alpha) [21]
C  i,j    (beta)  [22]
C  a,b    (BA)    [23]
C  i,j    (BA)    [24]
C  i,a    (BA)    [25]
C 
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*3 TYPE(2,25)
      CHARACTER*4 PACK(25)
      DIMENSION ISYM(8,8),SPIN(2,25),POPL(8),POPR(8)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYMINF/NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON/SYMLOC/ISYMOFF(8,8,25)
C
      DATA TYPE /'VRT','VRT' , 'VRT','VRT' , 'OCC','OCC' ,
     &           'OCC','OCC' , 'VRT','VRT' , 'VRT','VRT' ,
     &           'OCC','OCC' , 'OCC','OCC' , 'VRT','OCC' ,
     &           'VRT','OCC' , 'VRT','OCC' , 'VRT','OCC' ,
     &           'VRT','VRT' , 'OCC','OCC' , 'VRT','VRT' ,
     &           'OCC','VRT' , 'OCC','VRT' , 'OCC','VRT' ,
     &           'VRT','VRT' , 'VRT','VRT' , 'OCC','OCC' ,
     &           'OCC','OCC' , 'VRT','VRT' , 'OCC','OCC' ,
     &           'OCC','VRT' /
      DATA SPIN / 1,1 , 2,2 , 1,1 , 2,2 , 1,1 , 2,2 , 1,1 , 2,2 ,
     &            1,1 , 2,2 ,
     &            1,2 , 2,1 , 1,2 , 1,2 , 1,2 , 1,1 , 2,2 , 1,2 ,
     &            1,1 , 2,2 ,
     &            1,1 , 2,2 , 2,1 , 2,1 , 2,1 / 
      DATA PACK /'PACK','PACK','PACK','PACK','PCK2',
     &           'PCK2','PCK2','PCK2','FULL','FULL',
     &           'FULL','FULL','FULL','FULL','FULL',
     &           'FULL','FULL','FULL','FULL','FULL',
     &           'FULL','FULL','FULL','FULL','FULL'/
C
      NNM1O2(I)=(I*(I-1))/2
      NNP1O2(I)=(I*(I+1))/2
C
C CHECK TO MAKE SURE POPULATION COUNTERS HAVE BEEN INITIALIZED
C
      NTOT=0
      DO 1 ISPIN=1,2
       DO 2 IRREP=1,8
        NTOT=NTOT+POP(IRREP,ISPIN)
2      CONTINUE
1     CONTINUE 
C
      IF(NTOT.EQ.0)RETURN
C
      DO 5 ITYPE=1,25
       IF(TYPE(1,ITYPE).EQ.'VRT'.AND.SPIN(1,ITYPE).EQ.1)THEN
        CALL ICOPY(8,VRT(1,1),1,POPL,1)
       ELSEIF(TYPE(1,ITYPE).EQ.'VRT'.AND.SPIN(1,ITYPE).EQ.2)THEN
        CALL ICOPY(8,VRT(1,2),1,POPL,1)
       ELSEIF(TYPE(1,ITYPE).EQ.'OCC'.AND.SPIN(1,ITYPE).EQ.1)THEN
        CALL ICOPY(8,POP(1,1),1,POPL,1)
       ELSEIF(TYPE(1,ITYPE).EQ.'OCC'.AND.SPIN(1,ITYPE).EQ.2)THEN
        CALL ICOPY(8,POP(1,2),1,POPL,1)
       ENDIF
       IF(TYPE(2,ITYPE).EQ.'VRT'.AND.SPIN(2,ITYPE).EQ.1)THEN
        CALL ICOPY(8,VRT(1,1),1,POPR,1)
       ELSEIF(TYPE(2,ITYPE).EQ.'VRT'.AND.SPIN(2,ITYPE).EQ.2)THEN
        CALL ICOPY(8,VRT(1,2),1,POPR,1)
       ELSEIF(TYPE(2,ITYPE).EQ.'OCC'.AND.SPIN(2,ITYPE).EQ.1)THEN
        CALL ICOPY(8,POP(1,1),1,POPR,1)
       ELSEIF(TYPE(2,ITYPE).EQ.'OCC'.AND.SPIN(2,ITYPE).EQ.2)THEN
        CALL ICOPY(8,POP(1,2),1,POPR,1)
       ENDIF
C        
       DO 10 IRRDPD=1,NIRREP
        ILOC=1
C
C FULL STORAGE MODE
C
        IF(PACK(ITYPE).EQ.'FULL')THEN
         DO 20 IRREPR=1,NIRREP
          IRREPL=DIRPRD(IRREPR,IRRDPD)
          ISYMOFF(IRREPR,IRRDPD,ITYPE)=ILOC
          ILOC=ILOC+POPL(IRREPL)*POPR(IRREPR)
20       CONTINUE
        ELSEIF(PACK(ITYPE).EQ.'PACK')THEN
         DO 30 IRREPR=1,NIRREP
          IRREPL=DIRPRD(IRREPR,IRRDPD)
          IF(IRREPL.LT.IRREPR)THEN
           ISYMOFF(IRREPR,IRRDPD,ITYPE)=ILOC
           ILOC=ILOC+POPL(IRREPL)*POPR(IRREPR)
          ELSEIF(IRREPL.EQ.IRREPR)THEN
           ISYMOFF(IRREPR,IRRDPD,ITYPE)=ILOC
           ILOC=ILOC+NNM1O2(POPL(IRREPL))
          ENDIF
30       CONTINUE
        ELSEIF(PACK(ITYPE).EQ.'PCK2')THEN
         DO 40 IRREPR=1,NIRREP
          IRREPL=DIRPRD(IRREPR,IRRDPD)
          IF(IRREPL.LT.IRREPR)THEN
           ISYMOFF(IRREPR,IRRDPD,ITYPE)=ILOC
           ILOC=ILOC+POPL(IRREPL)*POPR(IRREPR)
          ELSEIF(IRREPL.EQ.IRREPR)THEN
           ISYMOFF(IRREPR,IRRDPD,ITYPE)=ILOC
           ILOC=ILOC+NNP1O2(POPL(IRREPL))
          ENDIF
40       CONTINUE
        ENDIF
C
10     CONTINUE
5     CONTINUE
C
      RETURN
      END

      SUBROUTINE RDBAS(TITLE,IENTRY,ICONTX,LUVMOL,INTTYP,NULLST,
     &                 IATNUM,NORD,seward,cpbasis,icpun)
C
C ROUTINE READS NEW BASINF ENTRIES AND WRITES THE INFORMATION TO THE
C VMOL INPUT FILE
C
C It will scan unit 12 for the basis set and copy the definition to
C unit icpun if cpbasis=.true.
C
C THE FORMAT FOR THE ENTRIES IS AS FOLLOWS :
C
C 1. NAME OF BASIS SET.  FOLLOWS OLD BASINF CONVENTIONS, NAMELY IT
C    MUST BEGIN WITH XX:, WHERE XX IS THE ATOMIC SYMBOL.  THE NAME
C    OF THE BASIS SET BEGINS AFTER THE :.
C
C 2. THE TOTAL NUMBER OF SHELLS MAKING UP THE BASIS (NSHELL).
C
C 3. A VECTOR OF LENGTH NSHELL CONTAINING THE ANGULAR MOMENTA OF
C    THE SHELLS (LANGSH).
C
C 4. A VECTOR OF LENGTH NSHELL CONTAINING THE NUMBER OF CONTRACTED
C    FUNCTIONS IN THE SHELL (ICNTSH).
C
C 5. A VECTOR OF LENGTH NSHELL CONTAINING THE NUMBER OF PRIMITIVE
C    FUNCTIONS IN THE SHELL (IFNCSH).
C
C LOOPING OVER SHELLS
C
C1a. A VECTOR OF LENGTH IFNCSH(ISHELL) CONTAINING THE PRIMITIVE FUNCTION
C    EXPONENTS (IPRIM).
C
C1b. A MATRIX OF DIMENSION IFNCSH(ISHELL) x ICNTSH(ISHELL) CONTAINING THE
C    CONTRACTION COEFFICIENTS FOR THE SHELL.  EACH CONTRACTED FUNCTION
C    CORRESPONDS TO AN INDIVIDUAL COLUMN IN THIS MATRIX.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CJDW 9/8/97 3 lines (From Thomas Steinke).
      DOUBLE PRECISION PRT_THRESH
      CHARACTER*32 CFORMAT
      PARAMETER (PRT_THRESH = 1.0D+07 - 1.0D+00)
C      PARAMETER (MAXSHL = 20)
C      PARAMETER (NPRIMAX = 1000)
C      PARAMETER (NCNTMAX = 10)
#include "mxatms.par"
#include "baslen.par"
#include "linelen.par"
#include "baslims.par"
#include "molstrct.com"
C
      PARAMETER (NDI10 = MXATMS)
      PARAMETER (NDI9  = 250)
      parameter (lusew = 15)
      CHARACTER*(linelen) TEST
C Ajith 07/04/96
      CHARACTER*6 NULLST
      CHARACTER*(*) TITLE
      CHARACTER*(baslen) TITEL(ndi10)

      LOGICAL YESNO,seward,cpbasis
CSSS      INTEGER SHELLANG,SHELLLOC,SHELLSIZ,SHELLPRM
      DIMENSION EEXP(MXPRIM)
      DIMENSION LANGSH(MXSHEL),NINSHL(MXSHEL)
      DIMENSION IFNCSH(MXSHEL),ICNTSH(MXSHEL),COEFMT(MXPRIM*MXCORB)
C
CSSS      COMMON /MOLSTR1/ SHELLANG(100),SHELLLOC(100),SHELLSIZ(100),
CSSS     &                 SHELLPRM(100),BASISEXP(10000),BASISCNT(10000)
CSSS      COMMON /MOLSTR2/ NTOTPRIM,NTOTSHEL,IOFFPRIM,IOFFSHEL,IATOM
      COMMON /TMPINF/ NSHLAT(NDI10),IATLOC(NDI10),TITEL,
     &                IOFSHL(NDI10),IOFPRM(NDI9)
      COMMON /TURBO / ITURBO,MATOM,IOFFSH
C
      INDXF(I,J,N)=I+(J-1)*N
      REWIND(12)
C
C LOCATE BASIS SET
C
1     READ(12,'(A)',END=990)TEST
      IF(INDEX(TEST,':').EQ.0)GOTO 1
      IF(TEST(1:linblnk(TEST)).NE.(TITLE(1:linblnk(TITLE))))GOTO 1
      if (cpbasis) write(icpun,'(a)') test(1:linblnk(test))
C
      READ(12,'(A)') TEST
      READ(12,*)
      READ(12,'(I3)')NSHELL
      READ(12,'((14I5))')(LANGSH(I),I=1,NSHELL)
      READ(12,'((14I5))')(ICNTSH(I),I=1,NSHELL)
      READ(12,'((14I5))')(IFNCSH(I),I=1,NSHELL)
      if (cpbasis) then
         write(icpun,'(a)') test(1:linblnk(test))
         write(icpun,*)
         write(icpun,'(I3)')NSHELL
         write(icpun,'((14I5))')(LANGSH(I),I=1,NSHELL)
         write(icpun,'((14I5))')(ICNTSH(I),I=1,NSHELL)
         write(icpun,'((14I5))')(IFNCSH(I),I=1,NSHELL)
      end if
      IDUMP=NSHELL
      IOFF=0
C
      IF(ICONTX.NE.0)THEN
C
C CHANGE CONTRACTION LEVEL IF GENBAS_X KEYWORD IS ACTIVE.  COMPLICATED
C  STUFF.
C
       ITPSHL=0
C
C DETERMINE ITPSHL (THE HIGHEST ANGULAR MOMENTUM FUNCTION IN THE BASIS)
C
       DO 10 I=1,NSHELL
        IANG=LANGSH(I)+1
        IF(ICONTX/10**(IANG-1).NE.0)ITPSHL=IANG
10     CONTINUE
C
C CALCULATE THE NUMBER OF SHELLS OF EACH ANGULAR MOMENTUM AND THE
C  NUMBER OF CONTRACTED FUNCTIONS IN EACH OF THESE SHELLS
C
       IDUMMY=ICONTX
       CALL IZERO(NINSHL,NSHELL)
       DO 11 IANGUL=1,ITPSHL
C
C NALLOW IS THE NUMBER OF CONTRACTED FUNCTIONS WHICH WILL BE USED
C FOR THIS ANGULAR MOMENTUM
C
        NALLOW=IDUMMY/10**(ITPSHL-IANGUL)
        NTOT=0
C
        DO 12 ISHELL=1,NSHELL
         IF(LANGSH(ISHELL).EQ.IANGUL-1)THEN
          NINSHL(IANGUL)=NINSHL(IANGUL)+1
          NTOT=NTOT+ICNTSH(ISHELL)
          IF(NTOT.GT.NALLOW)THEN
           NEXCESS=NTOT-NALLOW
           ICNTSH(ISHELL)=MAX(ICNTSH(ISHELL)-NEXCESS,0)
           IF(ICNTSH(ISHELL).EQ.0)THEN
            IDUMP=IDUMP-1
            NINSHL(IANGUL)=NINSHL(IANGUL)-1
           ENDIF
          ENDIF
         ENDIF
12      CONTINUE
C
        IDUMMY=IDUMMY-MIN(NTOT,NALLOW)*10**(ITPSHL-IANGUL)
C
11     CONTINUE
C

c Nevin fixed for GENBAS_X stuff, cannot use split shells and GENBAS_X
c at the same time
       NSHELL=ITPSHL

      ELSE
C
C DETERMINE ITPSHL
C
      ITPSHL=0
      DO 13 I=1,NSHELL
       ITPSHL=MAX(ITPSHL,LANGSH(I)+1)
13    CONTINUE
C
      CALL IZERO(NINSHL,ITPSHL)
      DO 14 I=1,ITPSHL
       DO 14 ISHELL=1,NSHELL
        IF(LANGSH(ISHELL).EQ.I-1) NINSHL(I)=NINSHL(I)+1
14    CONTINUE
C
      ENDIF
C
C COSMETIC STUFF.  IF HIGHEST ANGULAR MOMENTUM HAS NO SHELLS,
C DECREMENT ITPSHL BY 1.
C
      IDUMMY=0
      IOK=0
      DO 21 I=ITPSHL,1,-1
       IF(IOK.EQ.0.AND.NINSHL(I).EQ.0)THEN
        IDUMMY=IDUMMY+1
       ELSE
        IOK=1
       ENDIF
21    CONTINUE
      ITPSHL=ITPSHL-IDUMMY
C
      IF(IENTRY.EQ.0)THEN
       CALL ICOPY(NSHELL,LANGSH,1,SHELLANG(IOFFSHEL),1)
       CALL ICOPY(NSHELL,ICNTSH,1,SHELLSIZ(IOFFSHEL),1)
       CALL ICOPY(NSHELL,IFNCSH,1,SHELLPRM(IOFFSHEL),1)
       DO 313 I=1,NSHELL
        SHELLLOC(IOFFSHEL+I-1)=IATOM
313    CONTINUE
C
C STORE SHELL INFORMATION FOR THE TURBOMOLE INTERFACE
C
       IF ((ITURBO.EQ.1).AND.(INDEX(TITLE,':').NE.0)) THEN
        MATOM=MATOM+1
        IATLOC(MATOM)=MATOM
        DO 7895 I=1,MATOM
          IF (TITLE.EQ.TITEL(I)) GOTO 7896
          TITEL(MATOM)=TITLE
 7895   CONTINUE
 7896   CONTINUE
        NSHLAT(MATOM)=NSHELL
        IOFSHL(MATOM)=IOFFSHEL-1
       ENDIF

       IOFFSHEL=IOFFSHEL+NSHELL
C
        Z=FLOAT(IATNUM)
        IF(Z.GT.109.0)Z=0.0
cYAU        WRITE(LUVMOL,'(A6,F14.8,I5,(10I5))')NULLST,Z,NORD,
        WRITE(LUVMOL,'(A6,F14.8,I5,(10I5))')'      ',Z,NORD,
     &  ITPSHL,(NINSHL(I),I=1,ITPSHL)
CJDW 9/20/96. Allow for Seward.
       if(inttyp.eq.4)then
        write(lusew,'(A)')'Basis set'
        if(title(2:2).eq.':')then
          isew=1
        else
          isew=2
        endif
        write(lusew,*)title(1:isew),'..... / inline'
        Z=FLOAT(IATNUM)
        IF(Z.GT.109.0)Z=0.0
        write(lusew,'(7x,f6.1,14x,i2)')z,itpshl-1        
       ELSE IF(INTTYP.EQ.2) THEN
        WRITE(LUVMOL,'(F10.5,I5,(10I5))')Z,NORD,
     &  ITPSHL,(NINSHL(I),I=1,ITPSHL)
       ENDIF
       RETURN
      ENDIF
C
      DO 100 ISHELL=1,NSHELL
       NPRIM=IFNCSH(ISHELL)
       NCONT=ICNTSH(ISHELL)
       NJUNK=NINSHL(LANGSH(ISHELL)+1)
       READ(12,*)
       READ(12,'((5F14.6))')(EEXP(I),I=1,NPRIM)
       READ(12,*)
       if (cpbasis) then
          write(icpun,*)
          write(icpun,'((5F14.6))')(EEXP(I),I=1,NPRIM)
          write(icpun,*)
       end if
       IF(MIN(NPRIM,NCONT,NJUNK).NE.0)THEN
          WRITE(LUVMOL,'(2I5)')IFNCSH(ISHELL),ICNTSH(ISHELL)
        if(seward) then
          write(lusew,'(2i5)')nprim,ncont
        endif
       ENDIF
       IOFF0=IOFFPRIM
       DO 101 IPRIM=1,NPRIM
        LENG=MAX(1,NCONT)
        READ(12,'((7(F10.7,1X)))')(COEFMT(J),J=1,LENG)
        if (cpbasis) write(icpun,'((7(F10.7,1X)))')(COEFMT(J),J=1,LENG)
        CALL SCOPY(NCONT,COEFMT,1,BASISCNT(IOFF0),NPRIM)
        IOFF0=IOFF0+1
C
CJDW 9/8/97 5 lines (from Thomas Steinke).
        IF( EEXP(IPRIM) .GT. PRT_THRESH )THEN
          CFORMAT = '(G18.12E2,3F18.9,/,(4F18.9))'
        ELSE
          CFORMAT = '((4F18.9))'
        ENDIF
C
        IF(MIN(NJUNK,NCONT).NE.0)THEN
CJDW 9/8/97 2 lines (from Thomas Steinke).
C        WRITE(LUVMOL,'((4F18.10))')EEXP(IPRIM),(COEFMT(J),J=1,NCONT)
           WRITE(LUVMOL,CFORMAT)EEXP(IPRIM),(COEFMT(J),J=1,NCONT)
         if(seward) then
           if(iprim.eq.1)then
             do 111 isewprim=1,nprim
               write(lusew,'(f18.10)') eexp(isewprim)
 111         continue
             write(lusew,'(4f18.9)') (COEFMT(J),J=1,NCONT) 
           else
             write(lusew,'(4f18.9)') (COEFMT(J),J=1,NCONT) 
           endif
         endif
        ENDIF
101    CONTINUE
C
C STORE PRIMITIVE INFORMATION FOR THE TURBOMOLE INTERFACE
C
       IF ((ITURBO.EQ.1).AND.(INDEX(TITLE,':').NE.0)) THEN
        IOFPRM(IOFFSH+ISHELL)=IOFFPRIM-1
       ENDIF
       DO 105 IX=1,NCONT
        CALL SCOPY(NPRIM,EEXP,1,BASISEXP(IOFFPRIM),1)
        IOFFPRIM=IOFFPRIM+NPRIM
105    CONTINUE
100   CONTINUE
      IF ((ITURBO.EQ.1).AND.(INDEX(TITLE,':').NE.0))
     &   IOFFSH=IOFFSH+NSHELL
C
      if (cpbasis) write(icpun,*)
      RETURN
990   WRITE(6,5000)TITLE(1:linblnk(TITLE))
5000  FORMAT(T3,'@RDBAS-F, Basis set ',A,' not found on GENBAS.')
      CALL ERREX
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE SORTXYZ(XX,Y,NORD,NATOMS)
C
C     SORTS VECTOR OF NUCLEAR COORDINATES - TO CHECK FOR EQUIVALENCE
C     OF TWO ORIENTATIONS - NEEDS Q VECTOR AND ATOMIC MASS VECTOR 
C     FOR MASS WEIGHTING.  THE SORT IS FIRST DONE ON THE X COORDINATE,
C     BUT IF IDENTICAL X VALUES ARE ENCOUNTERED, THE Y COORDINATE
C     IS THEN SORTED AS WELL, AND ALSO THE Z IF NECESSARY.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     Maximum number of atoms currently allowed
#include "mxatms.par"
#include "coord_4sortxyz.com"
C
      COMMON /TOLERS/ SYMTOL,DEGTOL
C
C The purpose of the above coord common block was to get the value of the
C number of atoms, mass, and charge. However, it was a serious mistake
C to obtain the number of atoms from this common block.
C NATOMS in the COORD common block corresponds to the total number
C of atoms including the dummy atoms. There were calls to this
C routine from IRREPS() and COMVEC() with the assumption
C that NATOMS corresponds to the number of real atoms. This
C caused memory errors for sufficiently large systems (>20 atoms), but
C was hidden for smaller systems. The correct thing
C to do is to let the caller pass in the correct value as an
C argument and ignore the last entry of the COORD common block.
C 01/2006, Ajith Perera.
C
      DIMENSION X(3*MXATMS),XX(3*NATOMS),Y(3*NATOMS),NORD(MXATMS*2)
      DIMENSION SCR(3*MXATMS)
C
      CALL ZERO(X,3*MXATMS)
C
C SORT THE X COORDINATES AND MASS WEIGHT THEM
C
      CALL XDCOPY(3*NATOMS,XX,1,SCR,1)
      IOFF=1
      DO 10 I=1,NATOMS
       NORD(I+MXATMS)=I
       IOFF=IOFF+3
10    CONTINUE
    
      CALL XDCOPY(NATOMS,SCR,3,X,1)
C
C GIVE DUMMY ATOMS RIDICULOUS X COORDINATES
C
      DO 5 I=1,NATOMS
       IF(ATMASS(I).LT.1.D-8)X(I)=-99999.
5     CONTINUE
      CALL PIKSR3(NATOMS,X,NORD(MXATMS+1))
      DO 11 ITARGET=1,NATOMS
       ISOURCE=NORD(ITARGET+MXATMS)
       IOFFSRC=3*(ISOURCE-1)+1
       IOFFTAR=3*(ITARGET-1)+1
       CALL XDCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
11    CONTINUE
C
C NOW WE MUST SEARCH FOR CLUSTERS OF VALUES IN THE X VECTOR
C
      IFINDX=1
1     NLEFT=NATOMS-IFINDX+1
      ILOC=IFINDNE(NLEFT,X(IFINDX),1,X(IFINDX),SYMTOL)+IFINDX-1
      ICLSIZX=ILOC-IFINDX
      IF(ILOC.NE.IFINDX+1)THEN
C
C CLUSTER HAS BEEN LOCATED.  SORT THE ASSOCIATED Y VALUES.
C
       CALL XDCOPY(ICLSIZX,Y(2+3*(IFINDX-1)),3,X,1)
       CALL PIKSR3(ICLSIZX,X,NORD(MXATMS+IFINDX))
       DO 13 ITARGET0=1,ICLSIZX
        ISOURCE=NORD(ITARGET0+MXATMS+IFINDX-1)
        ITARGET=ITARGET0+IFINDX-1
        IOFFSRC=3*(ISOURCE-1)+1
        IOFFTAR=3*(ITARGET-1)+1
        CALL XDCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
13     CONTINUE
C
C NOW WE MUST SEARCH FOR CLUSTERS OF VALUES IN THE Y VECTOR WITHIN
C  THIS X VECTOR CLUSTER
C
       IFINDY=1
2      NLEFTY=ICLSIZX-IFINDY+1
       ILOC=IFINDNE(NLEFTY,X(IFINDY),1,X(IFINDY),SYMTOL)+IFINDY-1
       ICLSIZY=ILOC-IFINDY
       IF(ICLSIZY.NE.1)THEN
C
C CLUSTER HAS BEEN LOCATED.  SORT THE Z VALUES.
C
        IPOS=IFINDX+IFINDY-1
        CALL XDCOPY(ICLSIZY,Y(3+3*(IPOS-1)),3,X,1)
        CALL PIKSR3(ICLSIZY,X,NORD(MXATMS+IPOS))
        DO 14 ITARGET0=1,ICLSIZY
         ISOURCE=NORD(ITARGET0+MXATMS+IPOS-1)
         ITARGET=ITARGET0+IPOS-1
         IOFFSRC=3*(ISOURCE-1)+1
         IOFFTAR=3*(ITARGET-1)+1
         CALL XDCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
14      CONTINUE
       ENDIF
       IFINDY=IFINDY+ICLSIZY
       IF(IFINDY.LT.ICLSIZX)GOTO 2
      ENDIF
      IFINDX=IFINDX+ICLSIZX
      IF(IFINDX.LT.NATOMS)GOTO 1
C
      IOFF=1
      DO 100 I=1,NATOMS
       Z=FLOAT(IATNUM(NORD(MXATMS+I)))
       CALL DSCAL(3,Z,Y(IOFF),1)
       IOFF=IOFF+3
100   CONTINUE
      CALL ICOPY(MXATMS,NORD(MXATMS+1),1,NORD,1)
      RETURN
      END

      subroutine A3_Ecp_int_driver(Ecpint, Natoms, Ntotatoms,
     &                             IGenby, Coord, Grads, Spherical)
c----------------------------------------------------------------------
c     Ecp_int_driver drives the calculation of 1e-matrices in the basis of
c     cartesian atomic orbitals using subroutine ecp_int.
c----------------------------------------------------------------------
c     tol    = integral cutoff (ints to be neglected, if value expected
c              to be < exp(-tol)(i)
c     Cint   = 1e-integral array ('batch') of dimension nfij
c       
c----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
C-----------------------------------------------------------------------
#include "ecp.par"
#include "ecp.com"

C Ecpints need to be (2*Maxang+1)**2 times the square of the 
C maximum number of contracted functions per shell (currently
C set at 20 for ECP integrals). The current Max_cbf is 1000. 
C
C Modification to compute ECP integrals in a suitable form 
C for ACES III parallel implementation. Since ACES III disregard
C symmetry, all the logic relating to symmtery is removed (the
C reason that symmetry logic there in the first place is that 
C this code is written to use both in ACES II and III. 08/2013,
C Ajith Perera. 
C
      Logical Grads, Zero_int, Spherical

      dimension Cint(Maxmem_a3), Ecpint_4Shell(Maxints_4shell),
     &          IGenby(Ntotatoms),
     &          Coord(3,Ntotatoms),Ecpint(*)

c-----------------------------------------------------------------------
#ifdef _DEBUG_LVL0
CSS      Nshell = 2
      Write(6,"(a,I3)") "The Debug value for Nshell: ", Nshell
CSS      nprims(2) = 1
#endif

      Iloc   = 0
      Isoc   = 0

CSSS      Do Icent = 1, Ntotatoms

      Do ishell = 1, Nshell

CSSS      do ishell = 1, 1

        iatom  = katom(ishell)

CSSS        If (IGenby(Icent) .EQ. Iatom) Then

        xa = Coord(1,iatom)
        ya = Coord(2,iatom)
        za = Coord(3,iatom)
        la = ktype(ishell) - 1

        kprimi=kprim(ishell)-1
        numcoi=numcon(ishell)

C begin loop jshell 

        Jloc = 0
        Jsoc = 0

CSSS        Do Jcent = 1, Icent

        do jshell=1, Nshell

CSSS        do jshell=1, 1

          jatom=katom(jshell)
          lb = ktype(jshell) - 1
C
#ifdef _DEBUG_LVL0       
      Write(6,"(a)") "Iatom, Jatom, Ishell, Jshell, Jloc: " 
      write(6,"(6(1x,i4))") Iatom, Jatom, Ishell, Jshell, Jloc
      Write(6,*)
#endif
CSSS          If (IGenby(Jcent) .EQ. Jatom) Then
CSSS          If (.NOT. (ICent .EQ. Jcent .AND. JShell .GT. IShell)) Then

          If (.NOT. (Iatom .EQ. Jatom .AND. JShell .GT. IShell)) Then
C
          xb=Coord(1,jatom)
          yb=Coord(2,jatom)
          zb=Coord(3,jatom)

          kprimj=kprim(jshell)-1
          numcoj=numcon(jshell)

          Call Dzero(Ecpint_4shell, Maxints_4shell)
C
          Do iprim = 1, nprims(ishell)
CSSS                  Do iprim = 3, 3

              exp1 = expnt(kprim(ishell)+iprim-1)
              Indnpri = Kprimi + Iprim
                     
              Do jprim = 1, nprims(jshell)
CSSS                     Do jprim = 3, 3
                 exp2 = expnt(kprim(jshell)+jprim-1)
                 Indnprj = Kprimj + Jprim
                 Call Dzero(Cint, Maxmem_a3)
C
#ifdef _DEBUG_LVL0
      Write(6, "(a, 4(1x,I2))") "The Ishell, Jshell, La, Lb: ", 
     &                           Ishell, Jshell, La, Lb
      Write(6, "(a, 4(1x,I2))") "The prim. pair; Iprim, Jprim",
     &                           Iprim, Jprim
#endif
#ifdef _DEBUG_LVL0
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of A : ", Xa, ya, Za
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of B : ", Xb, yb, Zb
      Write(6, "(a, 2(1x,F10.6))") "The Primtive pair: ", Exp1, Exp2
      Write(6,*)
      Write(6,*) "Initilize debug data"
#endif 
#ifdef _DEBUG_LVLM
      Write(6,"(a)") "Initilize debug xyz of A and B"
      xa = 1.0
      ya = 1.0
      za = 1.0
      xb = -1.0
      yb = -1.0
      zb = -1.0
      exp1 = 1.5
      exp2 = 1.5 
      La = 2
      Lb = 2
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of A : ", Xa, ya, Za
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of B : ", Xb, yb, Zb
      Write(6, "(a, 2(1x,F10.6))") "The Primtive pair: ", Exp1, Exp2
      Write(6,*)
#endif
                 Call Ecp_int_4prim(Xa, Ya, Za, Xb, Yb, Zb, 
     &                              La, Lb, Coord, Exp1, Exp2,
     &                              Natoms, Ntotatoms, IGenby,
     &                              Cint, Int, Zero_int, 
     &                              Grads)

                 If (.NOT. Zero_int)
     &              Call ecp_int_4shell(Cint, Ecpint_4shell, 
     &                                  La, Lb, Numcoi, Numcoj, 
     &                                  Indnpri, Indnprj, Iprim,
     &                                  Jprim, Jnt)
             Enddo
          Enddo        
C 
#ifdef _DEBUG_LVL0
      Write(6,*)
      Idegen = (la+1)*(la+2)/2
      Jdegen = (lb+1)*(lb+2)/2
      Write(6,"(a,4(1x,I2))")
     &"The Contracted integral for shell pair", Ishell, JShell, Idegen,
     & Jdegen

      If (Ishell .NE. Jshell) Then
          Do I = 1, Idegen
             Write(6,"(4(1x,F20.13))")(Ecpint_4shell((I-1)*Jdegen+J),
     &                                 J=1,Jdegen)
          Enddo
      Else
          Do I = 1, Idegen
             Write(6,"(4(1x,F20.13))")(Ecpint_4shell((I-1)*Jdegen+J),
     &                                 J=1,I)
          Enddo
      Endif
#endif  
                  Call Ecp_int(Ecpint, Ecpint_4shell, 
     &                         La, Lb, Iloc, Jloc, Isoc, Jsoc, 
     &                         Numcoi, Numcoj, Ishell, Jshell,
     &                         Spherical)
C
          Jloc = Jloc + (Lb+1)*(Lb+2)*Numcoj/2
          Jsoc = Jsoc + (2*Lb+1)*NUmcoj
C
        Endif
cSSS        Endif
C
        Enddo
CSSS        Enddo

        Iloc = Iloc + (La+1)*(La+2)*Numcoi/2
        Isoc = Isoc + (2*La+1)*Numcoi
C
CSSS      Endif 
      Enddo 
CSSS      Enddo
C     
      Ndim = Iloc
      If (Spherical) Ndim = Isoc 
#ifdef _DEBUG_LVL0
      w=0.0d0
      Write(6,"(a)") "@-Ecpint_Driver, The ECP integrals"
      Write(6,"(a,1x,i3)") "The dimension of ints: ", Ndim
      Write(6, "(6(1x,F10.7))") (Ecpint(I), I=1, Ndim*(Ndim+1)/2)
      do i =1, Ndim*(Ndim+1)/2
      W = w+ecpint(i)*ecpint(i)
      enddo
      Write(6, "(a,(1x,F20.13))") "The ecpint. check sum = ", w
#endif
C
      Open(unit=61, file='ecpint.dat', form='unformatted')
      Rewind 61
      write(61) Ndim
      Write(61) (Ecpint(i), i = 1, Ndim*(Ndim+1)/2)
      Close (61)
      Call Putrec(20, "JOBARC", "ECP1INTS", Ndim*(Ndim+1)/2, Ecpint)
C
      return
      end

      SUBROUTINE A2EVAL_INT_MAIN(MAXATMS, NATOMS, MAXSHELL, MAXPRM,
     &                           IREDUN, NSHL, NTOTPRIM, NTOTCRF, 
     &                           NOFFSETATMP, NOFFSETATMC, 
     &                           NOFFSETPRM, NOFFSETCON,NANGMOMSHL, 
     &                           NPRIMFUNSHL, NCONFUNSHL, XPOINT,
     &                           YPOINT, ZPOINT, ALPHA, PCOEF, 
     &                           COORD, PRDUTINT, TMP1, TMP2, 
     &                           TMP3)
C
C Evaluate integral of the form <Mu(r_1)Nu(r_1)> where r1 is 
C maintained as constant. Ajith Perera 01/2000 
C     
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DIMENSION IP(20), FAC(9,9), IOFFST(15), COORDI(3), COORDJ(3),
     &          COORD(NATOMS*3), ALPHA(NTOTPRIM), IREDUN(MAXATMS),
     &          PCOEF(NTOTPRIM*NTOTCRF), NANGMOMSHL(MAXATMS,MAXSHELL),
     &          NPRIMFUNSHL(MAXATMS,MAXSHELL),
     &          NCONFUNSHL(MAXATMS,MAXSHELL),
     &          PRDUTINT(NTOTCRF,NTOTCRF), CENTER(3),
     &          TMP1(MAXPRM, MAXPRM), TMP2(MAXPRM, MAXPRM),
     &          TMP3(MAXPRM, MAXPRM), NSHL(MAXATMS),
     &          NOFFSETATMP(MAXATMS), NOFFSETATMC(MAXATMS), 
     &          NOFFSETPRM(MAXATMS,MAXSHELL),
     &          NOFFSETCON(MAXATMS,MAXSHELL)
C      
      CALL SETRHF(FAC, IOFFST, IP)
       
C
      IREDCNT = 0
      JREDCNT = 0
      IPRMCOUNT = 0
      JPRMCOUNT = 0
      ICFNCOUNT = 0
      JCFNCOUNT = 0
      CENTER(1) = XPOINT 
      CENTER(2) = YPOINT
      CENTER(3) = ZPOINT
C
C Loop over the symmetry unique atoms 
C      
      DO IATMS = 1, MAXATMS
C                  
         IPRMSTART =  NOFFSETATMP(IATMS)
         ICFNSTART =  NOFFSETATMC(IATMS)
         IREDATMS  =  IREDUN(IATMS)
C
C Loop over the redundent atoms 
C
         DO IRATMS = 1, IREDATMS         
C
C Loop over shells on symmetry unique atoms
C
            DO ISHL = 1, NSHL(IATMS)
C
               IREDCNT = IREDCNT + 1 
C
               DO JATMS = 1, MAXATMS
C                  
                  JPRMSTART =  NOFFSETATMP(JATMS)
                  JCFNSTART =  NOFFSETATMC(JATMS)
                  JREDATMS  =  IREDUN(JATMS)
C
                  DO JRATMS = 1, JREDATMS                 
C
                     DO JSHL = 1, NSHL(JATMS)
#ifdef _DEBUG_LVLM2
      Write(6,"(a,4I4)") "in Driver IATMS, JATMS, ISHL, JSHL",
     &                     IATMS, JATMS, ISHL, JSHL
#endif
C
                        JREDCNT = JREDCNT + 1 
C                        
                        IANGMOM = NANGMOMSHL(IATMS, ISHL)
                        JANGMOM = NANGMOMSHL(JATMS, JSHL)
                        IPRIM   = NPRIMFUNSHL(IATMS, ISHL)
                        JPRIM   = NPRIMFUNSHL(JATMS, JSHL)
                        INCRF   = NCONFUNSHL(IATMS, ISHL)
                        JNCRF   = NCONFUNSHL(JATMS, JSHL)
                        IINTTYP = IOFFST(IANGMOM)
                        JINTTYP = IOFFST(JANGMOM)
#ifdef _DEBUG_LVLM2
      Write(6,"(a,4I4)") "in Driver IANG, JANG, ITYP, JTYP",
     &                     IANGMOM, JANGMOM, IINTTYP, JINTTYP
#endif
C                        
                        ICOORD = (IATMS - 1)*3 
                        JCOORD = (JATMS - 1)*3 
C     
                        DO INDX = 1, 3
                           COORDI(INDX)  = COORD(ICOORD + INDX)
                           COORDJ(INDX)  = COORD(JCOORD + INDX)
                        ENDDO
C
C Loop over angular momentum components of each shell
C
                        IF (.NOT. ((IANGMOM*JANGMOM) .EQ. 0)) THEN
C
                           IPRMINTCNT = NOFFSETPRM(IATMS, ISHL) +
     &                                  IPRMSTART       
                           JPRMINTCNT = NOFFSETPRM(JATMS, JSHL) +
     &                                  JPRMSTART                           
                           ICFNINTCNT = NOFFSETCON(IATMS, ISHL) +
     &                                  ICFNSTART 
                           JCFNINTCNT = NOFFSETCON(JATMS, JSHL) +
     &                                  JCFNSTART 
C
                           IPRMCOUNT = IPRMINTCNT
                           ICFNCOUNT = ICFNINTCNT
                           ITYPE     = IINTTYP
C
                           DO IMOMN = 1, IANGMOM
                              ITYPE = ITYPE + 1 
                              JPRMCOUNT = JPRMINTCNT
                              JCFNCOUNT = JCFNINTCNT
                              JTYPE     = JINTTYP
C
                              DO JMOMN = 1, JANGMOM
                                 JTYPE = JTYPE + 1 
C
C Do the actual evaluation of the repulsion integral(A-Term in Eqn). Also bulit 
C the product function (B-Term in Eqn). 
C
#ifdef _DEBUG_LVLM2
      Write(6,"(a,4I4)") "in Driver INCR, JNCR, IPRM, JPRM",
     &                     INCRF, JNCRF, IPRMCOUNT, JPRMCOUNT
#endif

C
                                 CALL A2EVAL_PRDCINT(IPRIM, JPRIM, 
     &                                               INCRF, JNCRF, 
     &                                               ITYPE, JTYPE, 
     &                                               IPRMCOUNT, 
     &                                               JPRMCOUNT,
     &                                               ICFNCOUNT, 
     &                                               JCFNCOUNT,
     &                                               NTOTPRIM, 
     &                                               NTOTCRF,
     &                                               MAXPRM, COORDI,
     &                                               COORDJ, ALPHA, 
     &                                               PCOEF, CENTER,
     &                                               PRDUTINT, TMP1,
     &                                               TMP2, TMP3)
C
C Angular momentum loop end here!
C     
                                 JPRMCOUNT = JPRMCOUNT + JPRIM
                                 JCFNCOUNT = JCFNCOUNT + JNCRF
                              ENDDO
                              IPRMCOUNT = IPRMCOUNT + IPRIM
                              ICFNCOUNT = ICFNCOUNT + INCRF
                           ENDDO
C     
                        ENDIF
C
C Shell loop end here!
C

                     ENDDO
                  ENDDO
               ENDDO
               JREDCNT = 0
C
            ENDDO
         ENDDO
      ENDDO
C
C$$$      V_INT = 0.0D0
CSSS      Write(6,*) "The repulsion and product integral"
C$$$      DO I =1, NTOTCRF
C$$$         DO J= 1, I
C$$$            V_INT = V_INT + REPLINT(I,J)*REPLINT(I,J)
C$$$         ENDDO
C$$$      ENDDO
CSSS      Write(6,*) "The checksum of REPLINT =", V_INT
CSSS      CALL OUTPUT(PRDUTINT, 1, NTOTCRF, 1, NTOTCRF, NTOTCRF, NTOTCRF, 1)
       
      RETURN
      END
 

      SUBROUTINE ASSIGN_ANGLS(CARTCOORD, IBNDTO, IREDUNCO, TOTREDNCO,
     &                        TOTNOFBND, TOTNOFANG, NRATMS, MAXREDUNCO, 
     &                        THRESHOLD)
C
C This routine setup the connectivity array to define bond angles. This
C array is dimensioned to (4, MAXREDUNCO).
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     DOUBLE PRECISION DFLOAT
      LOGICAL USE1, USE2, MULAOK, LOOK4_ANCHOR
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG
      DIMENSION IREDUNCO(4, MAXREDUNCO), IBNDTO(NRATMS,NRATMS),
     &          CARTCOORD(3*NRATMS)

      DATA IZERO /0/, MTWO /-2/, MONE /-1/
C     
      PI        = 180.0D0
      TOTNOFBND = TOTREDNCO
      TOTNOFANG = IZERO
      MULAOK    = .FALSE. 
      LOOK4_ANCHOR = .FALSE.
C
      DO 10 IBNDS = 2, TOTNOFBND
         IBND1 = IREDUNCO(1, IBNDS)
         IBND2 = IREDUNCO(2, IBNDS)
C         
cSSS         IF (IBND2 .GT. IZERO) THEN
cSSS            USE1 = .TRUE.
cSSS            USE2 = .TRUE.
cSSS         END IF 
C           
         DO 20 JBNDS = 1, IBNDS - 1
C
            IF (IBND2 .GT. IZERO) THEN
               USE1 = .TRUE. 
               USE2 = .TRUE.
            END IF
C
            JBND1 = IREDUNCO(1, JBNDS)
            JBND2 = IREDUNCO(2, JBNDS)
            
C I'll have to check connections from ICON1,2,3...
               
            IF (JBND2 .GT. IZERO) THEN
               IF (IBND1 .EQ. JBND1 .AND. USE1) THEN
                  ICON1 = IBND2
                  ICON2 = IBND1
                  ICON3 = JBND2
                  USE1  = MULAOK
               ELSE IF (IBND1 .EQ. JBND2 .AND. USE1) THEN
                  ICON1 = JBND1
                  ICON2 = IBND1
                  ICON3 = IBND2
                  USE1  = MULAOK
               ELSE IF (IBND2 .EQ. JBND1 .AND. USE2) THEN
                  ICON1 = IBND1
                  ICON2 = IBND2
                  ICON3 = JBND2
                  USE2  = MULAOK
               ELSE IF (IBND2 .EQ. JBND2 .AND. USE2) THEN
                  ICON1 = JBND1
                  ICON2 = IBND2
                  ICON3 = IBND1
                  USE2  = MULAOK 
               ELSE
                  GO TO 20
C
C I wish I could avoid this GoTo Statement!
C
               ENDIF
            ENDIF
C     
C For linear bonds, we need to generate two redundant coordinates for 
C for the same centers (ICON1, ICON2 and ICON3). The VLUANGLE is 
C returned in degrees from CMP_ANGLE. 
C     
            CALL CMP_ANGLE(ICON1, ICON2, ICON3, CARTCOORD, 
     &                     VLUANGLE, NRATMS)
C     
C eleminate connectivity between the edge atoms 
C
            IF (ABS(VLUANGLE - PI) .LE. THRESHOLD) THEN
                IBNDTO(ICON3, ICON1) = -99 
C
                DO 30 LBNDS = 1, NRATMS
                   IF (LBNDS .NE. ICON1 .AND. LBNDS .NE. ICON2
     &                 .AND. LBNDS .NE. ICON3) THEN

                      IF (IBNDTO(LBNDS, ICON3) .NE. IZERO) THEN
                         CALL CMP_ANGLE(ICON1, ICON3, LBNDS,
     &                                  CARTCOORD, VLUANGLE, 
     &                                  NRATMS)
                         IF (ABS(VLUANGLE - PI) .LE. THRESHOLD)
     &                   THEN
                            IBNDTO(LBNDS, ICON1) = -99
                            IBNDTO(LBNDS, ICON2) = -99
                         ENDIF
C
                      ELSE IF (IBNDTO(LBNDS, ICON1) .NE. IZERO) THEN
                         CALL CMP_ANGLE(LBNDS, ICON1, ICON3,
     &                                  CARTCOORD, VLUANGLE,
     &                                  NRATMS) 
                         IF (ABS(VLUANGLE - PI) .LE. THRESHOLD)
     &                   THEN
                            IBNDTO(ICON2, LBNDS) = -99
                            IBNDTO(ICON3, LBNDS) = -99
   
                            IF (ICON2 .GT. LBNDS)
     &                      IBNDTO(LBNDS, ICON2) = -99
                            IF (ICON3 .GT. LBNDS) 
     &                      IBNDTO(LBNDS, ICON3) = -99
                         ENDIF
C
                      ENDIF
                   ENDIF
C
 30             CONTINUE
C
C Skip assigning angles if there are connections to the middle atom.
C
                DO 40 LBNDS = 1, NRATMS
                   IF (LBNDS .NE. ICON1 .AND. LBNDS .NE. ICON2
     &                .AND. LBNDS .NE. ICON3 .AND.
     &                (IBNDTO(LBNDS, ICON2) .GT. IZERO)) GO TO 20

C Once again I would have prefered to avoid this GoTo statement!
C
 40             CONTINUE
                
                TOTNOFANG = TOTNOFANG + 1
                IREDUNCO(1, TOTNOFANG + TOTREDNCO) =
     &                   MIN0(ICON1, ICON3)
                IREDUNCO(2, TOTNOFANG + TOTREDNCO) = ICON2
                IREDUNCO(3, TOTNOFANG + TOTREDNCO) =
     &                   MAX0(ICON1, ICON3)
                IREDUNCO(4, TOTNOFANG + TOTREDNCO) = MONE
C                
C For nearly linear angles serch for another atom that is
C connected to the edge atoms. This alternative scheme was
C added with help from Peter Szalay and have the advantage
C of better handling the angles that go pass 180 during the
C optimization, Ajith Perera, 03/2011.
C
                IF (LOOK4_ANCHOR) THEN
                   DO IANCHOR = 1, NRATMS
#ifdef _DEBUG_LVL0
      Write(6, "(a,4I3)") "Check for anchor atom: ICON1", 
     &      IBNDTO(MIN(ICON1,IANCHOR), MAX(ICON1,IANCHOR)),
     &      IANCHOR, ICON1
#endif
                       IF (IBNDTO(MIN(ICON1,IANCHOR),
     &                      MAX(ICON1,IANCHOR)) .GT. 0) THEN
                            IREDUNCO(4, TOTNOFANG + TOTREDNCO)
     &                      = -IANCHOR
                            GO TO 999
                       ENDIF
#ifdef _DEBUG_LVL0
      Write(6, "(a,4I3)") "Check for anchor atom: ICON2", 
     &      IBNDTO(MIN(ICON3,IANCHOR), MAX(ICON3,IANCHOR)),
     &      IANCHOR, ICON3
#endif
                       IF (IBNDTO(MIN(ICON3,IANCHOR),
     &                     MAX(ICON3,IANCHOR)) .GT. 0) THEN
                           IREDUNCO(4, TOTNOFANG + TOTREDNCO) 
     &                     = -IANCHOR
                           GO TO 999
                       ENDIF
                   ENDDO
                ENDIF
C     
             ELSE
                ICON4 = MTWO
             ENDIF
C
 999         CONTINUE
C
             TOTNOFANG = TOTNOFANG + 1
             IREDUNCO(1, TOTNOFANG + TOTREDNCO) =
     &                MIN0(ICON1, ICON3)
             IREDUNCO(2, TOTNOFANG + TOTREDNCO) = ICON2
             IREDUNCO(3, TOTNOFANG + TOTREDNCO) = 
     &                MAX0(ICON1, ICON3)
             IREDUNCO(4, TOTNOFANG + TOTREDNCO) = MTWO
             
 20       CONTINUE
 10    CONTINUE
C
      TOTREDNCO = TOTREDNCO + TOTNOFANG
C
      IF (TOTREDNCO .GE. MAXREDUNCO) THEN
        WRITE(6, 99) TOTREDNCO, MAXREDUNCO 
 99     FORMAT(T3,'Maximum No. of redundant coordinates allowed',
     &         '/', ' exceeded','/' 
     &         T3,' Required:',I3,' Current Maximum:',I3)
        CALL ERREX
      ENDIF
C
      RETURN
      END

c ---------------------------------------------------------------------
c --- SCALE THE (OFF) DIAGONAL ELEMENTS OF A PACKED SYMMETRIC ARRAY ---
c ---------------------------------------------------------------------

c CALL DDIAGSCAL_SP(UPLO,DORO,M,ALPHA,DX)
c
c UPLO  = { "U", "u", "L", "l" }
c         the condition of the packed array
c
c DORO  = { "D", "d", "O", "o" }
c         controls whether the diagonal or off-diagonal elements are
c         to be scaled
c
c M     = { integer }
c         the order of the symmetric array
c
c ALPHA = { double precision }
c         the scaling factor
c
c DX    = { double precision array with dimension M*(M+1)/2 }
c         the packed array to be scaled

      subroutine ddiagscal_sp(uplo,doro,m,alpha,dx)
      implicit none

c ARGUMENT LIST
      character*1 uplo, doro
      integer m
      double precision alpha, dx(m*(m+1)/2)

c INTERNAL VARIABLES
      logical diag
      integer offset, i, from, to, step
      double precision factor

c DISCARD THE CHAFF AND THE SIMPLE CASES
      if (m.lt.0) then
         print *, "@DDIAGSCAL_SP: The array to be scaled cannot",
     &            " have a dimension"
         print *, "               less than zero."
         call c_exit(1)
      end if
      if (m.eq.0) return
      if (alpha.eq.(1.0D0)) return
      if ((doro.eq."D").or.(doro.eq."d")) then
         diag=.TRUE.
      else if ((doro.eq."O").or.(doro.eq."o")) then
         diag=.FALSE.
      else
         print *, "@DDIAGSCAL_SP: An invalid character has been",
     &            " received for DorO."
         print *, "               The string ",doro," should be",
     &            " D, d, O, or o."
         call c_exit(1)
      end if
      if (m.eq.1) then
         if (diag) dx(1)=dx(1)*alpha
         return
      end if
      if (m.eq.2) then
         if (diag) then
            dx(1)=dx(1)*alpha
            dx(3)=dx(3)*alpha
         else
            dx(2)=dx(2)*alpha
         end if
         return
      end if

c SET INCREMENT PARAMETERS
c   o For the case where m is 3, we can hard-code the results and save
c     some time. I know it is not a lot of time, but it is my call and
c     I made it.
      if ((uplo.eq."U").or.(uplo.eq."u")) then
         if (m.eq.3) then
            if (diag) then
               dx(1)=dx(1)*alpha
               dx(3)=dx(3)*alpha
               dx(6)=dx(6)*alpha
            else
               dx(2)=dx(2)*alpha
               dx(4)=dx(4)*alpha
               dx(5)=dx(5)*alpha
            end if
            return
         end if
         from =  2
         to   =  m+1
         step =  1
      else if ((uplo.eq."L").or.(uplo.eq."l")) then
         if (m.eq.3) then
            if (diag) then
               dx(1)=dx(1)*alpha
               dx(4)=dx(4)*alpha
               dx(6)=dx(6)*alpha
            else
               dx(2)=dx(2)*alpha
               dx(3)=dx(3)*alpha
               dx(5)=dx(5)*alpha
            end if
            return
         end if
         from =  m
         to   =  1
         step = -1
      else
         print *, "@DDIAGSCAL_SP: An invalid character has been",
     &            " received for UpLo."
         print *, "               The string ",uplo," should be",
     &            " U, u, L, or l."
         call c_exit(1)
      end if

c INVERT THE PROBLEM WHEN .NOT.DIAG (WATCH OUT WHEN ALPHA=0.0D0)
c   o Note: I am still looking for a fast way to zero-out a float.
c           If these were integers, we could IAND(number,0) but I
c           cannot find any such intrinsic function for floats.
c     Also, I examined the time cost of filtering low-order matrices
c     out (instead of calling dscal), but the startup cost of even
c     entering this subroutine is much higher than anything you
c     may gain by tweaking the cut-off parameter. KEEP IT SIMPLE!
      if (.not.diag) then
c         if ((alpha.eq.(0.0D0)).or.(m.lt.10)) then
         if (alpha.eq.(0.0D0)) then
            if ((uplo.eq."L").or.(uplo.eq."l")) then
               offset = 1
               do step = m,2,-1
                  do i = 1,(step-1)
                     dx(offset+i)=dx(offset+i)*alpha
                  end do
                  offset=offset+step
               end do
            else
               offset = 1
               do step = 1,(m-1)
                  do i = 1,step
                     dx(offset+i)=dx(offset+i)*alpha
                  end do
                  offset=offset+step+1
               end do
            end if
            return
         end if
         call xscal(ishft((m*(m+1)),-1),alpha,dx,1)
         factor=1/alpha
      else
         factor=alpha
      end if

c GET TO WORK
      offset=1
      do i = from,to,step
         dx(offset)=dx(offset)*factor
         offset=offset+i
      end do

      return
      end

      subroutine rdebbs(scr,n,kint,kreal,kchar,isucc,iwert,rwert,cwert)
C
      implicit double precision (a-h,o-z)
c
c     --- this routine reads one integer/real/character variable
c         as specified by the mask kint/kreal/kchar (two values of
c         which have to be zero) from the input string <scr>
c         it is assumed that integer/real numbers do not need
c         more than 32 characters of space (if wanted, pump that up)
c         if the mask value is positive, the input characters
c         will be cleaned after reading if the mask value is
c         positive
c
c         NOTE : abs(kchar) = length of the output string <cwert>
c
      integer kint,kreal,kchar
      integer isucc,iwert
      double precision rwert
      character*(*) cwert,scr
      character*32 readit
      logical prtout
c
      prtout=n.lt.0
c
      if(prtout) write(6,601) scr
  601 format(/,' input string = ',/,a,/)
c
c     --- if read succeeds, isucc contains the length of the string
c
c     --- check input parameters
      if((kint.ne.0.and.kreal.ne.0).or.
     1   (kint.ne.0.and.kchar.ne.0).or.
     2   (kreal.ne.0.and.kchar.ne.0)) stop ' abuse of rdebbs '
c
      iwert=0
      rwert=0.d0
      cwert=' '
c
      isucc=iblank(scr)-1
c
      if(isucc.eq.0) return
c
      if((kint.ne.0.or.kreal.ne.0).and.isucc.gt.32) then
        write(6,901)
  901   format(/,' integer/real number with more than 32 digits ',/)
        goto 800
      elseif(kchar.ne.0.and.abs(kchar).lt.isucc) then
        write(6,902) iabs(kchar)
  902       format(/,' i/o-error : input string is longer than ',i3,
     1             ' characters ',/)
        goto 800
      endif
c
      nbl=32-isucc
      if(kint.ne.0) then
        iact=kint
        if(nbl.gt.0) readit(1:nbl)=' '
        readit(nbl+1:32)=scr(1:isucc)
        read(readit,'(i32)',err=701) iwert
      elseif(kreal.ne.0) then
        iact=kreal
        if(nbl.gt.0) readit(1:nbl)=' '
        readit(nbl+1:32)=scr(1:isucc)
        read(readit,'(g32.0)',err=702) rwert
      elseif(kchar.ne.0) then
        iact=kchar
        cwert=scr(1:isucc) 
      endif
c     --- delete the string if iact>0 (iact<0 allows second read)
      if(iact.gt.0) scr(1:isucc)=' '
c
      return
c
  701 write(6,751)
  751 format(/,' i/o-error : input variable is not integer ',/)
      goto 800
  702 write(6,752)
  752 format(/,' i/o-error : input variable is not real ',/)
c
  800 write(6,991) scr
  991 format(/,
     1 ' WARNING : <rdebbs> could not read properly from string ',/,a,/)
      isucc=-1
c
      return
      end

      SUBROUTINE ASSIGN_XYZ_LABELS (TOTNO_XYZ, XYZ_LABEL)
C 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      Integer TOTNO_XYZ
C
C Assign a label for xyz coordiantes of each atom
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C
      CHARACTER*4 XYZ_LABEL(TOTNO_XYZ)
      CHARACTER*3 LABEL(3*MXATMS)
C
      do i = 1, min(9,3*MXATMS)
         write(label(i),'(2i1)') 0, i
      end do
      do i = 10, min(99,MXATMS)
         write(label(i),'(i2)') i
      end do
      do i = 100, 3*MXATMS
         write(label(i),'(i3)') i
      end do
C
      DO I=1,TOTNO_XYZ
         XYZ_LABEL(I)='R'//LABEL(I)
      END DO
C            
      RETURN
      END
   

c dx(i) *= da

      subroutine xscal(n,da,dx,incx)
      implicit none
      double precision da,dx(*)
      integer i,incx,p,n,nincx

      if (n.le.0 .or. incx.le.0 .or. da.eq.1.d0) return

      if (incx.eq.1) then

#ifdef _UNICOS
         do i = 1, n
            dx(i) = da*dx(i)
         end do
#else
         p = iand(n,3)
         do i = 1, p
            dx(i) = da*dx(i)
         end do
         do i = 1+p, n, 4
            dx(i)   = da*dx(i)
            dx(i+1) = da*dx(i+1)
            dx(i+2) = da*dx(i+2)
            dx(i+3) = da*dx(i+3)
         end do
#endif

      else

         nincx = n*incx
         do i = 1, nincx, incx
            dx(i) = da*dx(i)
         end do

      end if

      return
c     end subroutine xscal
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine block_on_server_delay(proc)
      implicit none
      include 'mpif.h'
      include 'server_delay.h'
      include 'server_barrier_data.h'

      integer proc
#ifdef ALTIX
      integer lenshmem

      integer i, ierr
      integer status(MPI_STATUS_SIZE)
      logical done
#endif

c-------------------------------------------------------------------------
c   This subroutine is used on the Altix to block until the server delay_flag
c   on server "proc" is cleared.  This is done to allow the server time
c   to catch up with its messge processing, so it is not flooded with 
c   messages that it has no time to process.
c-------------------------------------------------------------------------

#ifdef ALTIX
      RETURN
  100 continue

c-------------------------------------------------------------------------
c   Fetch the server delay flag from server "proc".
c-------------------------------------------------------------------------

      lenshmem = 1
      call shmem_get4(delay_flag, delay_flag, lenshmem, proc)

      if (delay_flag .eq. 1) then

c-------------------------------------------------------------------------
c   Attempt to clear any leftover server_barrier requests.
c-------------------------------------------------------------------------

         do i = 1, mx_msg
            if (server_requests(i) .ne. MPI_REQUEST_NULL) then
               call mpi_test(server_requests(i), done, status, ierr)
            endif
         enddo

         call f_usleep(10000)
         go to 100
      endif 
#endif

      return
      end

      

      SUBROUTINE DTAU(IRREPAB,IRREPIJ,IRREPX,IRREPY,Z,XA,XB,
     &                YA,YB,ISPIN,FACT)
C
C THIS ROUTINE FORMS THE MODIFIED DOUBLES AMPLITUDE:
C
C  Z(ab,ij) = Z(ab,ij) + FACT * [X(ai)*Y(bj)+X(bj)*Y(ai)]
C
C SPIN CASES:
C
C  Z(Ab,Ij) = Z(Ab,Ij) + FACT * [X(AI)*Y(bj)+X(bj)*Y(AI)]
C
C  Z(AB,IJ) = Z(AB,IJ) + FACT * [X(AI)*Y(BJ)+X(BJ)*Y(AI)]
C                      - FACT * [X(BI)*Y(AJ)+X(AJ)*Y(BI)]
C
C WHERE THE OVERALL SYMMETRIES OF X, Y AND Z NEED NOT BE
C TOTALLY SYMMETRIC.  THIS ROUTINE WORKS ON ONE SYMMETRY
C BLOCK OF IJ AT A TIME.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION XA,XB,YA,YB,Z,FACT
      DIMENSION XA(*),YA(*),XB(*),YB(*),Z(*)
      COMMON/SYMLOC/ISYMOFF(8,8,25)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYM/POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON/SYMINF/NSTART,NIRREP,IRREPYY(255,2),DIRPRD(8,8)
      COMMON/SYMPOP/IRPDPD(8,22),ISYTYP(2,500),ID(18)
C
      INDX(I,J,N)=I+(J-1)*N
C
      IF(ISPIN.LE.2)THEN
       ISP1=ISPIN
       ISP2=ISPIN
       IOFFZ0=1
       DO 10 IRREPJ=1,NIRREP
        IRREPI=DIRPRD(IRREPJ,IRREPIJ)
        IF(IRREPI.GT.IRREPJ)GOTO 10
        NUMJ=POP(IRREPJ,ISP2)
        NUMI=POP(IRREPI,ISP1)
        DO 11 J=1,NUMJ
         ITOP=NUMI
         IF(IRREPI.EQ.IRREPJ)ITOP=J-1
         DO 12 I=1,ITOP
          DO 13 IRREPB=1,NIRREP
           IRREPA=DIRPRD(IRREPB,IRREPAB)
           IF(IRREPA.GT.IRREPB)GOTO 13
           NUMB=VRT(IRREPB,ISP2)
           NUMA=VRT(IRREPA,ISP1)
           IF(IRREPA.NE.IRREPB)THEN
            NUMAB=NUMA*NUMB
           ELSE
            NUMAB=(NUMA*(NUMA-1))/2
           ENDIF
           IRREPAI=DIRPRD(IRREPA,IRREPI)
           IRREPBJ=DIRPRD(IRREPB,IRREPJ)
           IRREPAJ=DIRPRD(IRREPA,IRREPJ)
           IRREPBI=DIRPRD(IRREPB,IRREPI)
           IF(IRREPAI.EQ.IRREPX)THEN
            IOFFZ=IOFFZ0
            DO 21 B=1,NUMB
             ATOP=NUMA
             IF(IRREPA.EQ.IRREPB)ATOP=B-1
             DO 22 A=1,ATOP
              IOFFX=ISYMOFF(IRREPI,IRREPX,8+ISP1)+INDX(A,I,NUMA)-1
              IOFFY=ISYMOFF(IRREPJ,IRREPY,8+ISP1)+INDX(B,J,NUMB)-1
              Z(IOFFZ)=Z(IOFFZ)+FACT*XA(IOFFX)*YA(IOFFY)
              IOFFZ=IOFFZ+1
22           CONTINUE
21          CONTINUE
           ENDIF
           IF(IRREPBJ.EQ.IRREPX)THEN
            IOFFZ=IOFFZ0
            DO 23 B=1,NUMB
             ATOP=NUMA
             IF(IRREPA.EQ.IRREPB)ATOP=B-1
             DO 24 A=1,ATOP
              IOFFX=ISYMOFF(IRREPJ,IRREPX,8+ISP1)+INDX(B,J,NUMB)-1
              IOFFY=ISYMOFF(IRREPI,IRREPY,8+ISP1)+INDX(A,I,NUMA)-1
              Z(IOFFZ)=Z(IOFFZ)+FACT*XA(IOFFX)*YA(IOFFY)
              IOFFZ=IOFFZ+1
24           CONTINUE
23          CONTINUE
           ENDIF
           IF(IRREPBI.EQ.IRREPX)THEN
            IOFFZ=IOFFZ0
            DO 25 B=1,NUMB
             ATOP=NUMA
             IF(IRREPA.EQ.IRREPB)ATOP=B-1
             DO 26 A=1,ATOP
              IOFFX=ISYMOFF(IRREPI,IRREPX,8+ISP1)+INDX(B,I,NUMB)-1
              IOFFY=ISYMOFF(IRREPJ,IRREPY,8+ISP1)+INDX(A,J,NUMA)-1
              Z(IOFFZ)=Z(IOFFZ)-FACT*XA(IOFFX)*YA(IOFFY)
              IOFFZ=IOFFZ+1
26           CONTINUE
25          CONTINUE
           ENDIF
           IF(IRREPAJ.EQ.IRREPX)THEN
            IOFFZ=IOFFZ0
            DO 27 B=1,NUMB
             ATOP=NUMA
             IF(IRREPA.EQ.IRREPB)ATOP=B-1
             DO 28 A=1,ATOP
              IOFFX=ISYMOFF(IRREPJ,IRREPX,8+ISP1)+INDX(A,J,NUMA)-1
              IOFFY=ISYMOFF(IRREPI,IRREPY,8+ISP1)+INDX(B,I,NUMB)-1
              Z(IOFFZ)=Z(IOFFZ)-FACT*XA(IOFFX)*YA(IOFFY)
              IOFFZ=IOFFZ+1
28           CONTINUE
27          CONTINUE
           ENDIF
           IOFFZ0=IOFFZ0+NUMAB
13        CONTINUE
12       CONTINUE
11      CONTINUE
10     CONTINUE
      ELSEIF(ISPIN.EQ.3)THEN
       ISP1=1
       ISP2=2
       IOFFZ0=1
       DO 30 IRREPJ=1,NIRREP
        IRREPI=DIRPRD(IRREPJ,IRREPIJ)
        NUMJ=POP(IRREPJ,ISP2)
        NUMI=POP(IRREPI,ISP1)
        DO 31 J=1,NUMJ
         DO 32 I=1,NUMI
          DO 33 IRREPB=1,NIRREP
           IRREPA=DIRPRD(IRREPB,IRREPAB)
           NUMB=VRT(IRREPB,ISP2)
           NUMA=VRT(IRREPA,ISP1)
           IRREPAI=DIRPRD(IRREPA,IRREPI)
           IRREPBJ=DIRPRD(IRREPB,IRREPJ)
           IF(IRREPAI.EQ.IRREPX)THEN
            IOFFZ=IOFFZ0
            DO 41 B=1,NUMB
             DO 42 A=1,NUMA
              IOFFX=ISYMOFF(IRREPI,IRREPX,8+ISP1)+INDX(A,I,NUMA)-1
              IOFFY=ISYMOFF(IRREPJ,IRREPY,8+ISP2)+INDX(B,J,NUMB)-1
              Z(IOFFZ)=Z(IOFFZ)+FACT*XA(IOFFX)*YB(IOFFY)
              IOFFZ=IOFFZ+1
42           CONTINUE
41          CONTINUE
           ENDIF
           IF(IRREPBJ.EQ.IRREPX)THEN
            IOFFZ=IOFFZ0
            DO 43 B=1,NUMB
             DO 44 A=1,NUMA
              IOFFX=ISYMOFF(IRREPJ,IRREPX,8+ISP2)+INDX(B,J,NUMB)-1
              IOFFY=ISYMOFF(IRREPI,IRREPY,8+ISP1)+INDX(A,I,NUMA)-1
              Z(IOFFZ)=Z(IOFFZ)+FACT*XB(IOFFX)*YA(IOFFY)
              IOFFZ=IOFFZ+1
44           CONTINUE
43          CONTINUE
           ENDIF
           IOFFZ0=IOFFZ0+NUMA*NUMB
33        CONTINUE
32       CONTINUE
31      CONTINUE
30     CONTINUE
C
      ENDIF 
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      LOGICAL FUNCTION QSAME(Q1,Q2)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: qsame.f,v 1.3 2010-06-30 15:58:20 ponton Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     qsame -- determine the equivalence of two cartesian coordinates
C
C SYNOPSIS
      DOUBLE PRECISION Q1(3),Q2(3)
C
C DESCRIPTION
C     True if the absolute difference in any component of the cartesian
c     coordinates is less than or equal to 1.0e-6.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Integer I
      Double precision Z
      QSAME=.TRUE.
      DO 10 I=1,3
       Z=ABS(Q1(I)-Q2(I))
       IF(Z.GT.1.D-6)QSAME=.FALSE.
10    CONTINUE
      RETURN
      END

      subroutine qpasy(npi,l,lit,ljt,ltot1,lmalo,lmahi,lmblo,lmbhi,
     1   alp,xka1,xkb1,prd,dum,qsum)
c     ----- partially asymptotic form for q(n,la1,lb1) -----
c     ----- scaled by exp(-xkb*xkb/(4*alpha)) to prevent overflows
      implicit double precision (a-h,o-z)
c*    common/qstore/dum1(49),alpha,xk,t
      common/qstore/dum1(81),alpha,xk,t
      common /dfac/ dfac(29)
c*    common /dfac/ dfac(23)
c*    dimension qsum(7,7,2)
c*    dimension fctr(7), sum(7), term(7)
      dimension qsum(9,9,9)
      dimension fctr(9), sum(9), term(9)
      data a0,accrcy,a1s4,a1s2,a1 /0.0d0,1.0d-13,0.25d0,0.5d0,1.0d0/
c     ----- first set up xkb as larger -----
      save
      if(xka1.gt.xkb1) go to 10
      xka=xka1
      xkb=xkb1
      go to 12
   10 xka=xkb1
      xkb=xka1
c     ----- set up parameters for qcomp using xkb -----
   12 alpha=a1
      sqalp=dsqrt(alp)
      xk=xkb/sqalp
      t=a1s4*xk*xk
      prd=prd*dexp(-(dum-t))
      tk=xka*xka/(alp+alp)
      do 90 lama=lmalo,lmahi
      ldifa1=iabs(l-lama)+1
      if(xka1.gt.xkb1) go to 14
      la=lama-1
      go to 16
   14 lb=lama-1
   16 do 90 lamb=lmblo,lmbhi
      ldifb=iabs(l-lamb)
      nlo=ldifa1+ldifb
      nhi=(ltot1-mod(lit-ldifa1,2))-mod((ljt-1)-ldifb,2)
      if(xka1.gt.xkb1) go to 18
      lb=lamb-1
      go to 20
   18 la=lamb-1
c     ----- run power series using xka, obtaining initial    -----
c     ----- q(n,l) values from qcomp, then recurring upwards -----
c     ----- j=0 term in sum -----
   20 qold2=qcomp(npi+nlo-1+la,lb)/dfac(la+la+3)
      fctr(nlo)=a1
      sum(nlo)=qold2
      if(nlo.eq.nhi.and.tk.eq.a0) go to 60
c     ----- j=1 term in sum -----
      nprime=npi+nlo+la+1
      qold1=qcomp(nprime,lb)/dfac(la+la+3)
      if(nlo.ne.nhi) fctr(nlo+2)=fctr(nlo)
      f1=(la+la+3)
      fctr(nlo)=tk/f1
      term(nlo)=fctr(nlo)*qold1
      sum(nlo)=sum(nlo)+term(nlo)
      if(nlo.ne.nhi) go to 22
      qold2=fctr(nlo)*qold2
      qold1=term(nlo)
      go to 24
   22 nlo2=nlo+2
      sum(nlo2)=qold1
      if(nlo2.eq.nhi.and.tk.eq.a0) go to 60
   24 j=1
c     ----- increment j for next term -----
   30 j=j+1
      nprime=nprime+2
      f1=(nprime+nprime-5)
      f2=((lb-nprime+4)*(lb+nprime-3))
      qnew=(t+a1s2*f1)*qold1+a1s4*f2*qold2
      nlojj=nlo+j+j
      if(nlo.eq.nhi) go to 40
      nhitmp=min0(nlojj,nhi)
      do 38 n=nlo2,nhitmp,2
      nrev=nhitmp+nlo2-n
   38 fctr(nrev)=fctr(nrev-2)
   40 f1=(j*(la+la+j+j+1))
      fctr(nlo)=tk/f1
      if(nlojj.gt.nhi) go to 44
      nhitmp=nlojj-2
      term(nlojj)=qnew
      sum(nlojj)=term(nlojj)
      do 42 n=nlo,nhitmp,2
      nrev=nhitmp+nlo-n
      term(nrev)=fctr(nrev)*term(nrev+2)
   42 sum(nrev)=sum(nrev)+term(nrev)
      if(nlojj.eq.nhi.and.tk.eq.a0) go to 60
      qold2=qold1
      qold1=qnew
      go to 30
   44 qold2=fctr(nhi)*qold1
      qold1=fctr(nhi)*qnew
      term(nhi)=qold1
      sum(nhi)=sum(nhi)+term(nhi)
      if(nlo.eq.nhi) go to 47
      nhitmp=nhi-2
      do 46 n=nlo,nhitmp,2
      nrev=nhitmp+nlo-n
      term(nrev)=fctr(nrev)*term(nrev+2)
   46 sum(nrev)=sum(nrev)+term(nrev)
   47 do 48 n=nlo,nhi,2
   48 if(term(n).gt.accrcy*sum(n)) go to 30
   60 if(la.ne.0) go to 62
      prefac=prd/sqalp**(npi+nlo+la)
      go to 64
   62 prefac=prd*xka**la/sqalp**(npi+nlo+la)
   64 do 66 n=nlo,nhi,2
      qsum(n,lamb,lama)=qsum(n,lamb,lama)+prefac*sum(n)
   66 prefac=prefac/alp
   90 continue
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine optable_loop_sim(optable, noptable, array_table, 
     *                   narray_table,
     *                   index_table, nindex_table, 
     *                   segment_table, nsegment_table, block_map_table,
     *                   nblock_map_table, 
     *                   scalar_table, nscalar_table, proctab,
     *                   stack_blksizes, block_count, nstacks)
c--------------------------------------------------------------------------
c   Simulates the execution of the optable, accumulating a count of 
c   the number of blocks needed on each stack for each instruction.
c--------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_barrier_data.h'
      include 'scratchpad.h'

      common /load_balance/load_balance
      logical load_balance

      integer noptable, narray_table, nindex_table, nsegment_table
      integer nblock_map_table, nscalar_table
      integer optable(loptable_entry,noptable)
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer proctab(2,*)
      double precision scalar_table(nscalar_table)
      integer nstacks
      integer stack_blksizes(nstacks)
      integer block_count(nstacks,noptable)
 
      integer ierr
      integer iop, iopsave, iblk
      integer index, result_array, result_type
      integer opcode
      integer i, j, k, n
      integer running_count(nstacks)

      integer level, type, lop, lopbegin, lopend
      integer max_level
      parameter (max_level = 100)
      integer current(nstacks, max_level)
      integer instr(max_level)
      integer matchind(mx_array_index)
      integer save_ind(mx_array_index,narray_table)

      integer ind(mx_array_index), seg(mx_array_index)
      integer stack, which_stack
      integer array, nind, numblks, iblock_map, proc
      integer val1, val2
      integer allocate_table(narray_table)
      integer instruction

      integer jseg, iseg(mx_array_index)
      integer iblock, nseg(mx_array_index), bseg(mx_array_index),
     *        eseg(mx_array_index), iwild(mx_array_index),
     *        maxrange(mx_array_index), maxrange_seg(mx_array_index)
      integer nblock, nwild
      integer start_op, end_op
      integer lookup, block_map_lookup
      logical debug
      logical countit
      logical partial_create

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      call mpi_comm_rank(mpi_comm_world, me, ierr)

      trace = .false.
      load_balance = .false.
      debug = .false.
      simulator = .true.

      do i = 1, narray_table
         allocate_table(i) = 0
      enddo

      do i = 1, nstacks
         running_count(i) = 0
      enddo
c      running_count(nstacks) = 3   ! scratch arrays for contraction routines.

c--------------------------------------------------------------------------
c   Clear the scratchpad areas.
c--------------------------------------------------------------------------

      do i = 1, mx_scratchpad
         scratchpad(i) = 0
      enddo

      do i = 1, mx_fscratchpad
         fscratchpad(i) = 0.
      enddo

c--------------------------------------------------------------------------
c   Save original array table indices.
c--------------------------------------------------------------------------

      do i = 1, narray_table
         do j = 1, mx_array_index
            save_ind(j,i) = array_table(c_index_array1+j-1,i)
         enddo
      enddo

c--------------------------------------------------------------------------
c   Main processing loop.
c--------------------------------------------------------------------------

         start_op = 0
         end_op   = noptable
         iop = 1 
 1000    continue
            opcode = optable(c_opcode, iop)
            iopsave = iop
            current_op = iop  ! save operation pointer for debugging  purposes.
            current_line = optable(c_lineno,iop)

            if (opcode .eq. call_op) then
               call handle_call(optable, noptable, proctab, debug,
     *                start_op, end_op, iop)
            else if (opcode .eq. return_op) then
               call handle_return(optable, noptable, debug,
     *                start_op, end_op, iop)
            else if (opcode .eq. go_to_op) then 
               call handle_goto(optable, noptable, debug,
     *                start_op, end_op, iop)
            else if (opcode .eq. do_op .or.
     *               opcode .eq. enddo_op) then
c               call doloop(optable, noptable, iop, index_table, 
c     *                  nindex_table, array_table, narray_table,
c     *                  block_map_table, segment_table,
c     *                  nsegment_table, 
c     *                  debug, .false.,
c     *                  start_op, end_op)
            else if (opcode .eq. pardo_op .or.
     *               opcode .eq. endpardo_op) then
c               if (load_balance) then
c                  call pardo_loadb(optable, noptable, iop, index_table,
c     *                  nindex_table, array_table, narray_table,
c     *                  block_map_table,
c     *                  comm, debug, .false.,
c     *                  start_op, end_op)
c               else
c                  call pardo_loop(optable, noptable, iop, index_table,
c     *                  nindex_table, array_table, narray_table,
c     *                  block_map_table,
c     *                  comm, debug, .false.,
c     *                  start_op, end_op)
c               endif
            else if (opcode .eq. exit_op) then
c               call handle_exit(optable, noptable, debug,
c     *                array_table, narray_table,
c     *                index_table, nindex_table, 
c     *                block_map_table,    
c     *                start_op, end_op, iop)
            else if (opcode .eq. cycle_op) then
c               call handle_cycle(optable, noptable, debug,
c     *                start_op, end_op, iop)
            endif

            if (iop .gt. noptable) go to 2000
            if (iopsave .ne. iop) then
               go to 1000
            endif

            if (iop .lt. start_op .or.
     *          iop .gt. end_op) go to 900 

            current_op = iop  ! save operation pointer for debugging  purposes.
            current_line = optable(c_lineno,iop)

            do i = 1, nstacks
               block_count(i,iop) = running_count(i)
            enddo

c---------------------------------------------------------------------------
c   Check for the following instructions: CREATE, DELETE, ALLOCATE,
c   or DEALLOCATE.
c---------------------------------------------------------------------------

            partial_create = .false.   

            if (optable(c_opcode,iop) .eq. create_op .or.
     *          optable(c_opcode,iop) .eq. delete_op) then

c---------------------------------------------------------------------------
c   Determine the number of blocks for this array on the current processor.
c---------------------------------------------------------------------------

               array = optable(c_result_array,iop)
               iblock_map = array_table(c_block_map,array)
               numblks    = array_table(c_numblks,array)
               nind       = array_table(c_nindex,array)

               do i = 1, nind
                  ind(i) = array_table(c_index_array1+i-1,array)
               enddo

c---------------------------------------------------------------------------
c   Is this a partial create/delete?
c---------------------------------------------------------------------------

               partial_create = .false.
               do k = 1, nind
                  if (optable(c_ind1+k-1,iop) .eq. 
     *                             wildcard_indicator) then
                     partial_create = .true.
                  endif    
               enddo

               if (partial_create) go to 500
                  
c---------------------------------------------------------------------------
c   Loop over the number of blocks.
c---------------------------------------------------------------------------

               do i = 1, numblks
                  proc = block_map_table(c_processor,iblock_map+i-1)
                  if (proc .eq. my_company_rank) then
               
c----------------------------------------------------------------------------
c   Determine blocksize.
c----------------------------------------------------------------------------

                     n = 1
                     do j = 1, nind
                        seg(j) =  block_map_table(c_block_map_seg+j-1,
     *                                          iblock_map+i-1)
                        index_table(c_current_seg,ind(j)) = seg(j)
                        call get_index_segment(ind(j), seg(j), 
     *                             segment_table, nsegment_table, 
     *                             index_table, nindex_table, 
     *                             val1, val2)
                        if (val1 .le. 0 .or. val2 .le. 0) go to 900
                        n = n * (val2 - val1 + 1)
                     enddo

c----------------------------------------------------------------------------
c   Determine the proper stack.
c----------------------------------------------------------------------------

                     stack = which_stack(stack_blksizes, nstacks, n) 

c---------------------------------------------------------------------------
c   Increment (or decrement) the running block count.
c---------------------------------------------------------------------------

                     if (optable(c_opcode,iop) .eq. create_op) then
                        block_count(stack,iop) = 
     *                            block_count(stack,iop)+1
                     else
                        block_count(stack,iop) =
     *                            block_count(stack,iop) - 1
                     endif
                  endif
               enddo 
            endif   ! create_op/delete_op
  500       continue
 
            if (optable(c_opcode,iop) .eq. allocate_op .or.
     *          (optable(c_opcode,iop) .eq. create_op .and. 
     *          partial_create)) then 

c----------------------------------------------------------------------------
c   Since we don't know the actual distribution of the non-wildcard indices
c   until runtime, we cannot directly calculate the size of each block.
c   Instead, we calculate the number of wildcard blocks, and use the maximum
c   size of each non-wildcard index to estimate an upper limit of the
c   size of each block.
c----------------------------------------------------------------------------

               array = optable(c_result_array,iop)
               allocate_table(array) = iop   ! save the instruction for dealloc

               nblock = 1
               nwild  = 0
               nind   = 0
               do i = 1, mx_array_index
                  if (array_table(c_index_array1+i-1,array) .gt. 0) then
                     nind = nind + 1
                     ind(i) = array_table(c_index_array1+i-1,array)
                     nseg(i) = index_table(c_nsegments, ind(i))
                     bseg(i) = index_table(c_bseg, ind(i))
                     eseg(i) = index_table(c_eseg, ind(i))

                     if (optable(c_ind1+i-1,iop) .eq. 
     *                       wildcard_indicator) then
                        nblock = nblock*nseg(i)
                        nwild = nwild + 1
                        iwild(nwild) = i
                        iseg(iwild(nwild)) = bseg(iwild(nwild)) 
                     endif
                  endif
               enddo

               do j = 1, nind
                  maxrange(j) = 0
                  maxrange_seg(j) = 0
                  do jseg = bseg(j), eseg(j)
                     call get_index_segment(ind(j),jseg,
     *                             segment_table, nsegment_table,
     *                             index_table, nindex_table,
     *                             val1, val2)
                     if (val1 .le. 0 .and. val2 .le. 0) go to 900
                     n = val2 - val1 + 1
                     if (n .gt. maxrange(j)) then 
                        maxrange(j) = n
                        maxrange_seg(j) = jseg
                     endif 
                  enddo
               enddo

               do iblock = 1, nblock
         
c--------------------------------------------------------------------------
c   Determine the blocksize.  First loop over the non-wildcard indices, 
c   using the maxrange for the size of each of their segments.
c--------------------------------------------------------------------------

                  n = 1
                  do i = 1, nind
                     if (optable(c_ind1+i-1,iop) .ne. 
     *                          wildcard_indicator) then
                        n = n * maxrange(i)
                        seg(i) = maxrange_seg(i)
                     endif
                  enddo

c---------------------------------------------------------------------------
c   Next, loop over the wildcard indices, determining the actual segment
c   size for the next block.
c---------------------------------------------------------------------------

                  do i = 1, nwild
                     call get_index_segment(ind(iwild(i)),
     *                                      iseg(iwild(i)),
     *                             segment_table, nsegment_table,
     *                             index_table, nindex_table,
     *                             val1, val2)
                     n = n * (val2 - val1 + 1) 
                     seg(i) = iseg(iwild(i))
                  enddo

c--------------------------------------------------------------------------
c   Determine the stack on which to place the block.
c--------------------------------------------------------------------------

                  stack = which_stack(stack_blksizes, nstacks, n)

c---------------------------------------------------------------------------
c   Adjust the block count for the stack.
c---------------------------------------------------------------------------

                  if (partial_create) then

c---------------------------------------------------------------------------
c   Only count it if the block_map_table indicates the block resides on
c   this processor.
c---------------------------------------------------------------------------

                     lookup =  block_map_lookup(seg, nind, array,
     *                       array_table(1,array),
     *                       index_table, nindex_table) 
                     proc = block_map_table(c_processor,lookup)
                     if (proc .eq. my_company_rank) 
     *                   block_count(stack,iop) =
     *                        block_count(stack,iop) + 1  
                  else
                     block_count(stack,iop) = 
     *                        block_count(stack,iop) + 1
                  endif

c--------------------------------------------------------------------------
c   Increment the "wildcard" segments.
c--------------------------------------------------------------------------

                  if (nwild .gt. 0)
     *               iseg(iwild(1)) = iseg(iwild(1)) + 1
                  do i = 2, nwild
                     if (iseg(iwild(i-1)) .le. 
     *                           eseg(iwild(i-1))) go to 100
                     iseg(iwild(i-1)) = bseg(iwild(i-1))
                     iseg(iwild(i))   = iseg(iwild(i)) + 1
                  enddo
  100             continue
               enddo
            else if (optable(c_opcode,iop) .eq. deallocate_op .or.
     *               (optable(c_opcode,iop) .eq. delete_op .and. 
     *                   partial_create) ) then

c---------------------------------------------------------------------------
c   Deallocate instruction: Wildcard indices are not encoded into the 
c   deallocate instruction, they must be decoded from the instruction that
c   last allocated the array.
c---------------------------------------------------------------------------

               array = optable(c_result_array,iop)
               instruction = allocate_table(array)
               allocate_table(array) = 0
               nblock = 1
               nwild  = 0
               nind   = 0
               do i = 1, mx_array_index
                  if (array_table(c_index_array1+i-1,array) .gt. 0) then
                     nind = nind + 1
                     ind(i) = array_table(c_index_array1+i-1,array)
                     nseg(i) = index_table(c_nsegments, ind(i))
                     bseg(i) = index_table(c_bseg, ind(i))
                     eseg(i) = index_table(c_eseg, ind(i))

                     if (optable(c_ind1+i-1,instruction) .eq. 
     *                                 wildcard_indicator) then
                        nblock = nblock*nseg(i)
                        nwild = nwild + 1
                        iwild(nwild) = i
                        iseg(iwild(nwild)) = bseg(iwild(nwild)) 
                     endif
                  endif
               enddo

               do j = 1, nind
                  maxrange(j) = 0
                  maxrange_seg(j) = 0
                  do jseg = bseg(j), eseg(j)
                     call get_index_segment(ind(j),jseg,
     *                             segment_table, nsegment_table,
     *                             index_table, nindex_table,
     *                             val1, val2)
                     if (val1 .le. 0 .and. val2 .le. 0) go to 900
                     n = val2 - val1 + 1  
                     if (n .gt. maxrange(j)) then
                        maxrange(j) = n
                        maxrange_seg(j) = jseg
                     endif
                  enddo
               enddo
               
               do iblock = 1, nblock
         
c--------------------------------------------------------------------------
c   Determine the blocksize.  First loop over the non-wildcard indices, 
c   using the maxrange for the size of each of their segments.
c--------------------------------------------------------------------------

                  n = 1
                  do i = 1, nind
                     if (optable(c_ind1+i-1,instruction) .ne. 
     *                            wildcard_indicator) then
                        n = n * maxrange(i)
                        seg(i) = maxrange_seg(i)
                     endif
                  enddo

c---------------------------------------------------------------------------
c   Next, loop over the wildcard indices, determining the actual segment
c   size for the next block.
c---------------------------------------------------------------------------

                  do i = 1, nwild
                     call get_index_segment(ind(iwild(i)),
     *                                      iseg(iwild(i)),
     *                             segment_table, nsegment_table,
     *                             index_table, nindex_table,
     *                             val1, val2)
                     n = n * (val2 - val1 + 1) 
                     seg(i) = iseg(iwild(i))
                  enddo

c--------------------------------------------------------------------------
c   Determine the stack on which to place the block.
c--------------------------------------------------------------------------

                  stack = which_stack(stack_blksizes, nstacks, n)

c---------------------------------------------------------------------------
c   Adjust the block count for the stack.
c---------------------------------------------------------------------------

                  if (partial_create) then

c---------------------------------------------------------------------------
c   Only delete it if the block_map_table indicates the block resides on
c   this processor.
c---------------------------------------------------------------------------

                     lookup =  block_map_lookup(seg, nind, array,
     *                       array_table(1,array),
     *                       index_table, nindex_table)
                     proc = block_map_table(c_processor,lookup)
                     if (proc .eq. my_company_rank) 
     *                   block_count(stack,iop) =
     *                        block_count(stack,iop) - 1
                  else
                     block_count(stack,iop) = 
     *                     block_count(stack,iop) - 1
                  endif

c--------------------------------------------------------------------------
c   Increment the "wildcard" segments.
c--------------------------------------------------------------------------

                  if (nwild .gt. 0)
     *               iseg(iwild(1)) = iseg(iwild(1)) + 1
                  do i = 2, nwild
                     if (iseg(iwild(i-1)) .le. 
     *                           eseg(iwild(i-1))) go to 200
                     iseg(iwild(i-1)) = bseg(iwild(i-1))
                     iseg(iwild(i))   = iseg(iwild(i)) + 1
                  enddo
  200             continue
               enddo
            endif

            do i = 1, nstacks
               running_count(i) = block_count(i,iop)
            enddo

  900    continue
         iop = iop + 1 
c            print *,'AT 900: iop, start_op, end_op = ',
c     *         iop, start_op, end_op
         if (start_op .ne. 0 .or. iop .le. noptable) then
            if (iop .gt. end_op)  iop = start_op
c            print *,'   BRANCH TO iop = ',iop
            if (iop .le. 0 .or. iop .gt. noptable) then
               print *,'ERROR: iop out of range: iop = ',iop
               call abort_job()
            endif
            go to 1000
         endif
         
 2000 continue

c---------------------------------------------------------------------------
c   Refine our block estimate by analyzing each loop, attempting to 
c   add blocks that are brought into and out of scope during loop execution.
c---------------------------------------------------------------------------

      do i = 1, max_level
         instr(i) = 0

         do j = 1, nstacks
            current(j,i) = 0
            running_count(j) = 0
         enddo
      enddo

      level = 1
      do iop = 1, noptable
         opcode = optable(c_opcode,iop)
         current_op = iop
         current_line = optable(c_lineno, iop)

         if (opcode .eq. pardo_op .or. 
     *       opcode .eq. do_op) then

c---------------------------------------------------------------------------
c   Increase the loop level and define the current number of blocks.
c---------------------------------------------------------------------------

            level = level + 1
            if (level .gt. max_level) then
               print *,'Error: Loop nesting is > ',max_level,
     *                 ' levels.'
               call abort_job()
            endif

            do j = 1, nstacks
               current(j,level) = 0
            enddo

            instr(level) = iop   ! save beginning instruction number

c--------------------------------------------------------------------------
c   The running count for the new loop is the sum of the newly
c   created blocks from all previous levels.
c--------------------------------------------------------------------------

            do j = 1, nstacks
               running_count(j) = 0
               do i = 1, level - 1
                  running_count(j) = 
     *                      running_count(j) + current(j,i)
               enddo
            enddo
         else if (opcode .eq. enddo_op .or. 
     *       opcode .eq. endpardo_op) then

c---------------------------------------------------------------------------
c   Move back one loop level.
c---------------------------------------------------------------------------

            level = level - 1
            if (level .lt. 1) then
               print *,'Error: Loop nesting level < 1 detected.'
               call abort_job()
            endif

c---------------------------------------------------------------------------
c   Compute a new running count.  
c---------------------------------------------------------------------------

            do j = 1, nstacks
               running_count(j) = 0
               do i = 1, level
                  running_count(j) = running_count(j) + current(j,i)
               enddo
            enddo
         else

c---------------------------------------------------------------------------
c   Bypass checking logic for logical instructions.
c---------------------------------------------------------------------------

            if (opcode .eq. jz_op .or.
     *          opcode .eq. go_to_op .or.
     *          opcode .eq. call_op .or.
     *          opcode .eq. destroy_op) go to 2300

            if (opcode .ge. sp_add_op .and.
     *          opcode .le. sp_ldindex_op) go to 2300

            if (opcode .ge. fl_add_op .and.
     *          opcode .le. fl_load_value_op) go to 2300

            if (opcode .eq. sp_ldi_sym_op) go to 2300
C bypass for automatically generated case
            if (opcode .eq. where_op) go to 2300

c---------------------------------------------------------------------------
c   Does this instruction create a temp result block?
c---------------------------------------------------------------------------

            array = optable(c_result_array,iop) 
            if (array .gt. narray_table) then
               print *,'ARRAY OUT OF BOUNDS: ',array,' iop ',
     *          iop,' op ',(optable(j,iop),j=1,loptable_entry)
               call abort_job()
            endif

            type  = array_table(c_array_type,array)

            if (opcode .eq. reindex_op) then
               do i = 1, mx_array_index
                  ind(i) = optable(c_ind1+i-1,iop)
               enddo

               call set_effective_indices(array_table(1,array),
     *                     ind)
            endif

            if (opcode .ne. reindex_op .and. array .ne. 0 ) then
               if (type .eq. temp_array .or.
     *             type .eq. served_array) then

c---------------------------------------------------------------------------
c   The current instruction results in creation of a result block.
c   Determine the maximum possible size of the block, and increment the
c   corresponding stack count.
c---------------------------------------------------------------------------

                  nind   = 0
                  do i = 1, mx_array_index
                     if (array_table(c_index_array1+i-1,array) .gt. 
     *                                             0) then
                        nind = nind + 1
                        ind(i) = array_table(c_index_array1+i-1,array)

                        if (ind(i) .gt. nindex_table) then
                           print *,'Task ',me,' INDEX OUT OF RANGE ',
     *                       ind(i),' iop ',iop,
     *                       ' op ',(optable(j,iop),j=1,loptable_entry)
                           print *,'Array ',array,' type ',type
                           call abort_job()
                        endif

                        nseg(i) = index_table(c_nsegments, ind(i))
                        bseg(i) = index_table(c_bseg, ind(i))
                        eseg(i) = index_table(c_eseg, ind(i))
                     endif
                  enddo

c---------------------------------------------------------------------------
c   Check all previous instructions at the current "level" to see if this
c   array and set of indices has already been used as a result.  If so, we 
c   need not count it.
c----------------------------------------------------------------------------

                  countit = .true.

                  do j = 1, nind
                     matchind(j) = 0
                  enddo

                  lopbegin = instr(level)
                  if (level .gt. 1) then
                     lopbegin = instr(2)  ! go through all nested loops.
                  endif

                  lopend = iop-1
                  if (optable(c_opcode,lopend) .eq. reindex_op .and.
     *                optable(c_result_array,lopend) .eq. array) 
     *               lopend = lopend - 1

                  do 2100 lop = lopbegin, lopend
                     if (optable(c_result_array,lop) .eq. array) then
                        if (optable(c_opcode,lop) .eq. reindex_op) then
                         
c--------------------------------------------------------------------------
c   Save indices from the "reindex" instruction.
c--------------------------------------------------------------------------

                           do j = 1, nind
                              matchind(j) = optable(c_ind1+j-1,lop)
                           enddo

                           go to 2100
                        endif

                        do j = 1, nind
                           if (matchind(j) .ne. ind(j)) then
                               go to 2100  ! try next instruction
                           endif
                        enddo 

                        countit = .false.   ! got a match, so do not count it
                        go to 2200
                     endif
 2100             continue
 2200             continue

                  if (countit) then

c----------------------------------------------------------------------------
c   Find the largest possible block with these indices.
c----------------------------------------------------------------------------

                     n = 1
                     do j = 1, nind
                        maxrange(j) = 0
                        do jseg = bseg(j), eseg(j)
                           call get_index_segment(ind(j),jseg,
     *                             segment_table, nsegment_table,
     *                             index_table, nindex_table,
     *                             val1, val2)
                           maxrange(j) = max(maxrange(j),(val2-val1+1))
                        enddo

                        n = n * maxrange(j)
                     enddo
               
c--------------------------------------------------------------------------
c   Determine the stack on which to place the block.
c--------------------------------------------------------------------------

                     stack = which_stack(stack_blksizes, nstacks, n)

c---------------------------------------------------------------------------
c   Adjust the block count for the stack.
c---------------------------------------------------------------------------

                     current(stack,level) = current(stack,level) + 1
                     running_count(stack) = running_count(stack) + 1      

c----------------------------------------------------------------------------
c   Add an additional block to account for prefetching the REQUEST instruction.
c------------------------------------------------------------------------------

                     if (opcode .eq. request_op) then
                        current(stack,level) = current(stack,level) + 1
                        running_count(stack) = running_count(stack) + 1
                     endif

                     block_count(stack,iop) =
     *                     block_count(stack,iop) + 
     *                        running_count(stack)
                  endif
               endif
            endif
 2300       continue
         endif
      enddo

c-------------------------------------------------------------------------
c   Restore array_table indices.
c-------------------------------------------------------------------------

      do i = 1, narray_table
         do j = 1, mx_array_index
            array_table(c_index_array1+j-1,i) = save_ind(j,i)
         enddo
      enddo

      call reset_timer_info()
      simulator = .false.
      return
      end

      integer function which_stack(stack_blksizes, nstacks, blocksize)
c------------------------------------------------------------------------
c   Determines the appropriate stack for a particular blocksize.
c   The stack_blksizes array is assumed to be ordered in increasing order.
c------------------------------------------------------------------------
      implicit none
      integer nstacks
      integer stack_blksizes(nstacks)
      integer blocksize
      integer i

      do i = 1, nstacks
         if (stack_blksizes(i) .ge. blocksize) then
            which_stack = i
            return
         endif
      enddo

      which_stack = nstacks   ! use largest blocksize.
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_SYMMETRY_INFO
     +
     +                    ( UNITID,
     +                      NATOM,
     +                      ZATOM,
     +                      SYMMAP,
     +                      RING,NRING,RINGSZ,
     +                      PLATO )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_SYMMETRY_INFO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints the symmetry info, which consists
C                of the symmetry map, the symmetry rings and its sizes
C                and the atoms related by platonic symmetry, to the
C                output file specified by its unit identification
C                number.
C
C
C                  Input:
C
C                    UNITID       =  printout unit identification #
C                    NATOM        =  total # of atoms
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    SYMMAP (A,B) =  has been set equal to 1 if atoms
C                                    A and B were found to be symmetry
C                                    related. A value of 0 indicates
C                                    no symmetry relation.
C                    RING (A,B)   =  integer array containing all atomic
C                                    indices A of those symmetry related
C                                    sets that have equal distance from
C                                    center B and are of maximum size
C                    NRING (B)    =  integer vector containing the # of
C                                    sets of maximum size related to
C                                    center B.
C                    RINGSZ (B)   =  integer vector containing the
C                                    maximum size of the above found
C                                    sets related to center B.
C                    PLATO (A,P)  =  integer array containing all atomic
C                                    indices A for specific platonic
C                                    symmetry types as characterized by
C                                    the index P: P = 1 (four atoms
C                                    tetrahedrally arranged), P = 2
C                                    (eight atoms arranged in a cube),
C                                    P = 3 (six octahedral atoms), P = 4
C                                    (twenty atoms in a dodecahedron),
C                                    P = 5 (twelve icosahedral atoms)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*2   ATCHAR,ATTYPE
         CHARACTER*1   BAR,DASH
         CHARACTER*12  SYMTYP

         CHARACTER*2   ATSYMB  (1:104)

         INTEGER     ATOM
         INTEGER     ATRING
         INTEGER     I,M,N
         INTEGER     NATOM
         INTEGER     NSET
         INTEGER     NSTEP
         INTEGER     OFFR
         INTEGER     REST
         INTEGER     RINGS
         INTEGER     SIZE
         INTEGER     STEP
         INTEGER     SYM
         INTEGER     UNITID
         INTEGER     ZVAL

         INTEGER     NRING   (1:NATOM)
         INTEGER     RINGSZ  (1:NATOM)
         INTEGER     ZATOM   (1:NATOM)

         INTEGER     PLATO   (1:NATOM,1:5    )
         INTEGER     RING    (1:NATOM,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM,1:NATOM)

         DATA ATSYMB /' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     +                'Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca',
     +                'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     +                'Ga','Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr',
     +                'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     +                'Sb','Te',' I','Xe','Cs','Ba','La','Ce','Pr','Nd',
     +                'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     +                'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     +                'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     +                'Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     +                'Md','No','Lr','xx'/
         DATA  BAR     /'|'/
         DATA  DASH    /'-'/
C
C
C------------------------------------------------------------------------
C
C
C             ...print out the atomic symmetry map.
C
C
         WRITE (UNITID,9000) 'Atomic Symmetry Map'
 9000    FORMAT (///,20X,A19)

         CALL    MAT__PRINT_A_INTEGER_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows,Columns = Atoms ; 1 = Symmetry related ',
     +                  NATOM,NATOM,
     +                  NATOM,NATOM,
     +                  SYMMAP )
     +
     +
C
C
C             ...print out the atomic symmetry rings info.
C
C
         WRITE (UNITID,9010) 'Ring Symmetry Info'
 9010    FORMAT (///,20X,A18,///)
C
C
C             ...print out header of atomic symmetry rings.
C
C
         WRITE (UNITID,9020) 'Atom',BAR,'Atom #',BAR,
     +                       'Ring size',BAR,'Ring #',BAR,
     +                       'Ring atom type',BAR,'Ring atomic indices'
         WRITE (UNITID,9030) (DASH,I=1,94)
C
C
C             ...print out atomic symmetry rings.
C
C
         NSTEP = 10

         DO ATOM = 1,NATOM
            ZVAL = ZATOM (ATOM)
            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            RINGS = NRING (ATOM)
            IF (RINGS.GT.0) THEN
                SIZE = RINGSZ (ATOM)
                STEP = (SIZE / NSTEP) - 1
                REST = MOD (SIZE,NSTEP)
                OFFR = 0

                DO N = 1,RINGS
                   ATRING = RING (OFFR+1,ATOM)
                   ZVAL = ZATOM (ATRING)
                   IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                       ATTYPE = ATSYMB (104)
                   ELSE
                       ATTYPE = ATSYMB (ZVAL)
                   END IF

                   M = MIN (SIZE,NSTEP)
                   IF (N.EQ.1) THEN
                       WRITE (UNITID,9040) ATCHAR,BAR,ATOM,BAR,
     +                                     SIZE,BAR,N,BAR,ATTYPE,BAR,
     +                                     (RING (OFFR+I,ATOM),I=1,M)
                   ELSE
                       WRITE (UNITID,9050) BAR,BAR,BAR,N,BAR,ATTYPE,BAR,
     +                                     (RING (OFFR+I,ATOM),I=1,M)
                   END IF
                   OFFR = OFFR + M
                   IF (SIZE.GT.NSTEP) THEN
                       DO M = 1,STEP
                          WRITE (UNITID,9060) BAR,BAR,BAR,BAR,BAR,
     +                                    (RING (OFFR+I,ATOM),I=1,NSTEP)
                          OFFR = OFFR + NSTEP
                       END DO
                       WRITE (UNITID,9060) BAR,BAR,BAR,BAR,BAR,
     +                                    (RING (OFFR+I,ATOM),I=1,REST)
                       OFFR = OFFR + REST
                   END IF
                END DO
            END IF
         END DO
C
C
C             ...formats for printing atomic symmetry rings.
C
C
 9020    FORMAT (1X,A4,1X,     A1, 1X,A6,1X,     A1,
     +           1X,A9,1X,     A1, 1X,A6,1X,     A1,
     +           1X,A14,1X,    A1, 10X,A19)
 9030    FORMAT (1X,94A1)
 9040    FORMAT (2X,A2,2X,     A1, 2X,I3,3X,     A1,
     +           3X,I3,5X,     A1, 2X,I3,3X,     A1,
     +           7X,A2,7X,     A1, 10(I4))
 9050    FORMAT (2X,2X,2X,     A1, 2X,3X,3X,     A1,
     +           3X,3X,5X,     A1, 2X,I3,3X,     A1,
     +           7X,A2,7X,     A1, 10(I4))
 9060    FORMAT (2X,2X,2X,     A1, 2X,3X,3X,     A1,
     +           3X,3X,5X,     A1, 2X,3X,3X,     A1,
     +           7X,2X,7X,     A1, 10(I4))
C
C
C             ...print out the platonic symmetry info.
C
C
         WRITE (UNITID,9070) 'Platonic Symmetry Info'
 9070    FORMAT (///,20X,A22,///)
C
C
C             ...print out header of platonic symmetry.
C
C
         WRITE (UNITID,9080) 'Symmetry',BAR,'Set #',BAR,
     +                       'Atom type',BAR,'Atomic indices'
         WRITE (UNITID,9090) (DASH,I=1,50)
C
C
C             ...print out platonic symmetry.
C
C
         DO 1000 SYM = 1,5
            IF (SYM.EQ.1) THEN
                SIZE = 4
                SYMTYP = ' Tetrahedral'
            ELSE IF (SYM.EQ.2) THEN
                SIZE = 8
                SYMTYP = '   Cubical  '
            ELSE IF (SYM.EQ.3) THEN
                SIZE = 6
                SYMTYP = ' Octahedral '
            ELSE IF (SYM.EQ.4) THEN
                SIZE = 12
                SYMTYP = 'Dodecahedral'
            ELSE
                SIZE = 20
                SYMTYP = ' Icosahedral'
            END IF

            NSET = 0

            DO N = 1,NATOM,SIZE
               ATOM = PLATO (N,SYM)
               IF (ATOM.EQ.0) THEN
                   IF (NSET.EQ.0) THEN
                       WRITE (UNITID,9100) SYMTYP,BAR,DASH,BAR,
     +                                     DASH,BAR,DASH
                   END IF
                   GOTO 1000
               ELSE
                   ZVAL = ZATOM (ATOM)
                   IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                       ATCHAR = ATSYMB (104)
                   ELSE
                       ATCHAR = ATSYMB (ZVAL)
                   END IF

                   NSET = NSET + 1
                   IF (NSET.EQ.1) THEN
                       WRITE (UNITID,9110) SYMTYP,BAR,NSET,BAR,
     +                                     ATCHAR,BAR,
     +                                     (PLATO (N+I-1,SYM),I=1,SIZE)
                   ELSE
                       WRITE (UNITID,9120) BAR,NSET,BAR,ATCHAR,BAR,
     +                                     (PLATO (N+I-1,SYM),I=1,SIZE)
                   END IF
               END IF
            END DO

 1000    CONTINUE
C
C
C             ...formats for printing platonic symmetry.
C
C
 9080    FORMAT (3X,A8,3X,     A1, 1X,A5,1X,     A1,
     +           1X,A9,1X,     A1, 1X,A14)
 9090    FORMAT (1X,50A1)
 9100    FORMAT (1X,A12,1X,    A1, 3X,A1,3X,     A1,
     +           5X,A1,5X,     A1, 7X,A1)
 9110    FORMAT (1X,A12,1X,    A1, 2X,I2,3X,     A1,
     +           4X,A2,5X,     A1, 20(I4))
 9120    FORMAT (1X,12X,1X,    A1, 2X,I2,3X,     A1,
     +           4X,A2,5X,     A1, 20(I4))
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__REORDER_VECTOR_FLOAT
     +
     +                    ( DDVEC,
     +                      DDORDER,
     +                      DDWORK,
     +                      VEC,
     +                      ORDER,
     +                      WORK,
     +                      W )
     +
C------------------------------------------------------------------------
C  OPERATION   : MAT__REORDER_VECTOR_FLOAT
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This routine reorders the elements of input vector W
C                of floating type according to a new ordering defined
C                in array ORDER. Definition of the ordering array is in
C                the active sense:
C
C                        ORDER (old element) = new element
C
C                Example:
C
C                Let W be:
C
C                          1  2  3  4  5  6  7  8
C
C                then, if ORDER is equal to:
C
C                              ORDER (1) = 5
C                              ORDER (2) = 2
C                              ORDER (3) = 1
C                              ORDER (4) = 6
C                              ORDER (5) = 8
C                              ORDER (6) = 3
C                              ORDER (7) = 7
C                              ORDER (8) = 4
C
C                the vector W on exit looks like:
C
C                          3  2  6  8  1  4  7  5
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     DDORDER
         INTEGER     DDVEC
         INTEGER     DDWORK
         INTEGER     I
         INTEGER     VEC

         INTEGER     ORDER (1:DDORDER)

         DOUBLE PRECISION  W    (1:DDVEC )
         DOUBLE PRECISION  WORK (1:DDWORK)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF  (VEC.GT.DDVEC) THEN
              WRITE (*,*) ' Dimensions of vector W too small! '
              WRITE (*,*) ' nlo__reorder_vector_float '
              WRITE (*,*) ' DDVEC,VEC = ',DDVEC,VEC
              WRITE (1,*) ' Dimensions of vector W too small! '
              WRITE (1,*) ' nlo__reorder_vector_float '
              WRITE (1,*) ' DDVEC,VEC = ',DDVEC,VEC
              STOP
         END IF

         IF  (VEC.GT.DDWORK) THEN
              WRITE (*,*) ' Dimensions of array WORK too small! '
              WRITE (*,*) ' nlo__reorder_vector_float '
              WRITE (*,*) ' DDWORK,VEC = ',DDWORK,VEC
              WRITE (1,*) ' Dimensions of array WORK too small! '
              WRITE (1,*) ' nlo__reorder_vector_float '
              WRITE (1,*) ' DDWORK,VEC = ',DDWORK,VEC
              STOP
         END IF

         IF  (VEC.GT.DDORDER) THEN
              WRITE (*,*) ' Dimensions of array ORDER too small! '
              WRITE (*,*) ' nlo__reorder_vector_float '
              WRITE (*,*) ' DDORDER,VEC = ',DDORDER,VEC
              WRITE (1,*) ' Dimensions of array ORDER too small! '
              WRITE (1,*) ' nlo__reorder_vector_float '
              WRITE (1,*) ' DDORDER,VEC = ',DDORDER,VEC
              STOP
         END IF
C
C
C             ...check the reordering array passed. It might have
C                element indices out of range, that is numbers > VEC.
C
C
         DO I = 1,VEC
            IF (ORDER (I).GT.VEC) THEN
                WRITE (*,*) ' Element index out of meaningful range! '
                WRITE (*,*) ' nlo__reorder_vector_float '
                WRITE (*,*) ' I,Element idx I,VEC = ',I,ORDER (I),VEC
                WRITE (1,*) ' Element index out of meaningful range! '
                WRITE (1,*) ' nlo__reorder_vector_float '
                WRITE (1,*) ' I,Element idx I,VEC = ',I,ORDER (I),VEC
                STOP
            END IF
         END DO
C
C
C             ...reorder the vector elements in straightforward way.
C
C
         DO I = 1,VEC
            WORK (I) = W (I)
         END DO

         DO I = 1,VEC
            W (ORDER (I)) = WORK (I)
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

C THIS ROUTINE ACCEPTS VECTORS RV AND IV AND PERFORMS THE
C FOLLOWING OPERATION: IT LEAVES ENTRIES 1-ISKIP UNCHANGED,
C AND OVERWRITES RV(J) AND IV(J) WITH RV(J-1) AND IV(J-1)
C RESPECTIVELY FOR ALL J-1 .GE. ISKIP.  THE VECTORS BOTH HAVE
C LENGTH NUMEL.  RV IS DOUBLE PRECISION AND IV IS INTEGER.
C THIS ROUTINE IS A DEPENDENT OF SCANVC.

      SUBROUTINE SHIFTV(RV,IV,ISKIP,NUMEL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RV(NUMEL),IV(NUMEL)

      if (iskip.lt.1) then
         print *, '@SHIFTV: Assertion failed.'
         print *, '         iskip = ',iskip
         call errex
      end if
      if (iskip.gt.numel) then
         print *, '@SHIFTV: Assertion failed.'
         print *, '         numel = ',numel
         print *, '         iskip = ',iskip
         call errex
      end if

      if ((numel.gt.1).and.(iskip.lt.numel)) then
         DO I = NUMEL-1, ISKIP, -1
            RV(I+1) = RV(I)
            IV(I+1) = IV(I)
         END DO
      end if
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sip_fmain_init(ierr_return, ncompany_workers_min)
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'int_gen_parms.h'
      include 'symbolic_constants.h'
      include 'sip_tables.h'
      include 'machine_types.h'
      include 'timerz.h'
      include 'proto_events.h' 
      include 'parallel_info.h'
      include 'dropmo.h'
      include 'sial_config_params.h' 
      include 'dbugcom.h'
      include 'trace.h'
      include 'hess.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

#ifdef HP
      integer*8 lenshmem
#else
      integer lenshmem
#endif
      integer mx_ao_seg_size, mx_occ_seg_size, mx_virt_seg_size
      integer nocc_orbitals, nvirt_orbitals 
      integer naocc_orbitals, nbocc_orbitals
      integer ierr_return

      integer i, ii, j, n, flag, ierr, istat
      integer mpierr
      integer blocksize
      integer*8 get_index_from_base
      integer*8 c_loc64, ixx
      integer*8 i8temp, nxthess
      integer str_trimlen
      integer status(mpi_status_size)
      integer*8 i8size
      integer size
      integer igrad

      integer*8 iopt, iindex, iarray, iscalar
      integer*8 iaddr_table
      integer*8 isegbase, isegtable, ibmap_table
      integer*8 iexp_index_table
      integer*8 iblkmgr, malloced_previously
      integer*8 iblk_header, iblkmgr_data, ifree_stack, iblk_addr
      integer*8 iblk_in_use
      integer*8 addr, addr_comm_buffer
      integer noptable, nindex_table, narray_table, nscalar_table
      integer nsegment_table
      integer nblk_overhead, nblocks_total

      integer optable(1), array_table(1), index_table(1)
      integer exp_index_table(1)
      integer segment_table(1)
      integer*8 address_table(2)
      integer proctab(200)
      double precision scalar_table(1)
      integer block_map_table(1)
      integer nblkmgr, nblkmgr_ints
      double precision blkmgr_scr(1)
      integer iblkmgr_scr(1)
      integer niocompany
      integer range, maxseg, nwork, nwork2
      integer*8 nw_total
      integer*8 irange1, irange2
      integer itotenerg, comm_timer, master, nsial_lines
      integer iscfeneg, istabvalue
      character*40 timerdesc 
      character*10 array_labels   

      integer company_comm
      integer pst_get_company_comm, pst_get_company_rank
      integer pst_get_company, pst_get_master

      integer nstacks
      integer stack_blocksizes(max_stacks)
      integer stack_blocks(max_stacks)

      integer npre_defined
      parameter (npre_defined = 19)
      logical need_predef(npre_defined)

      double precision x(2)
      integer double_ratio
      integer nblock_map_table
      integer nw
      integer ncompany_workers, ncompany_workers_min
      integer*8 ixca, ixcb, ixfa, ixfb
#ifdef ALTIX
      pointer (dptr, x)
      pointer (ptr_optable, optable)
      pointer (ptr_index_table, index_table)
      pointer (ptr_array_table, array_table)
      pointer (ptr_scalar_table, scalar_table)
      pointer (ptr_block_map, block_map_table)
      pointer (ptr_segment_table, segment_table)
      pointer (ptr_address_table, address_table)
      pointer (ptr_blkmgr_scr, blkmgr_scr)
#else
      common x
#endif
      double precision mygrad(3*ncenters) 

      logical debug, validate
      logical atom_based
      save

      call mpi_comm_rank(mpi_comm_world, me, mpierr)
      call mpi_comm_size(mpi_comm_world, nprocs, mpierr)
      company_comm    = pst_get_company_comm(me)
      my_company_rank = pst_get_company_rank(me)
      call mpi_comm_size(company_comm, ncompany_workers, mpierr)

      ierr_return = 0

#ifdef ALTIX
      dptr = dshptr
      ptr_optable      = ishptr
      ptr_index_table  = ishptr
      ptr_array_table  = ishptr
      ptr_scalar_table = dshptr
      ptr_block_map    = ishptr
      ptr_segment_table=ishptr
      ptr_address_table =i8shptr
      ptr_blkmgr_scr   = dshptr
#endif

c--------------------------------------------------------------------------
c   Set up the server for this processor.
c   First, count the number of processes in the IOCOMPANY.
c   Second, determine the server for this process based on the rank of 
c      the process within its company, and the number of prcesses in
c      the IOCOMPANY.
c--------------------------------------------------------------------------

      niocompany = 0
      if (io_company_id .gt. 0) then
         do i = 1, nprocs
            if (pst_get_company(i-1) .eq. io_company_id) 
     *          niocompany = niocompany + 1
         enddo
      endif

      iopt   = get_index_from_base(optable_base, optable, 1)
      iindex = get_index_from_base(index_table_base,
     *     index_table, 1)
      iarray = get_index_from_base(array_table_base, array_table, 1)

      iscalar = get_index_from_base(scalar_table_base, scalar_table, 2)

      noptable = noptable_sip
      nindex_table = nindex_table_sip
      narray_table = narray_table_sip
      nscalar_table = nscalar_table_sip

c---------------------------------------------------------------------
c   Set up the segment table.
c---------------------------------------------------------------------

      if (vvvi_stack) then
         nstacks = 9
      else
         nstacks = 7
      endif

c---------------------------------------------------------------------
c   experimental stack setup  
c---------------------------------------------------------------------
      nstacks = 10  

      nocc_orbitals = noccupied
      naocc_orbitals = nalpha_occupied
      if (nbeta_occupied .ne. 0) then
         nbocc_orbitals = nbeta_occupied
      else
         nbocc_orbitals = nocc_orbitals
      endif

       mx_ao_seg_size = sip_mx_ao_segsize
       mx_occ_seg_size = sip_mx_occ_segsize
       mx_virt_seg_size = sip_mx_virt_segsize

c--------------------------------------------------------------------------
c   If dropmo is used, create a copy of the index_table, for later use
c   in expanding the basis.
c--------------------------------------------------------------------------

       if (.not. ignore_dropmo) then
          call mem_alloc(exp_index_table, 
     *            nindex_table*lindex_table_entry, intsize,
     *            iexp_index_table, .true., ierr)

          eindex_table_base = c_loc64(exp_index_table, 
     *                             iexp_index_table, intsize)

          do i = 1, nindex_table*lindex_table_entry
             exp_index_table(iexp_index_table+i-1) = 
     *             index_table(iindex+i-1)
          enddo   
       endif

c---------------------------------------------------------------------------
c   Determine whether we use atom_based AO segmentation or the normal
c   algorithm.
c---------------------------------------------------------------------------

       atom_based = .false.
       if (aat_database .ne. ' ') atom_based = .true.

c---------------------------------------------------------------------------
c   Build the segment table.
c---------------------------------------------------------------------------

       call build_segment_table(index_table(iindex), nindex_table,
     *                        end_nfps, nshells, mx_ao_seg_size,
     *                        mx_occ_seg_size, mx_virt_seg_size,
     *                        sip_sub_segsize, sip_sub_occ_segsize,
     *                        sip_sub_virt_segsize, sip_sub_ao_segsize,
     *                        nocc_orbitals, naocc_orbitals,
     *                        nbocc_orbitals, 
     *                        nvirt_orbitals, nalpha_virtual,
     *                        nbeta_virtual, 
     *                        isegbase,nsegment_table,
     *                        stack_blocksizes, nstacks,
     *                        array_table(iarray), narray_table,
     *                        atom_based, atom)

       nsegment_table_sip = nsegment_table  ! store in common

c----------------------------------------------------------------------------
c   Add additional symbolic constants from parameter data.
c----------------------------------------------------------------------------

       symbolic_constant_table(38) = cc_iter
       symbolic_constant_table(39) = cc_hist
       symbolic_constant_table(40) = cc_beg
       symbolic_constant_table(41) = scf_iter
       symbolic_constant_table(42) = scf_hist
       symbolic_constant_table(43) = scf_beg
       symbolic_constant_table(44) = ncenters
       symbolic_constant_table(45) = itrips
       symbolic_constant_table(46) = itripe
       symbolic_constant_table(47) = ihess1
       symbolic_constant_table(48) = ihess2
       symbolic_constant_table(49) = jhess1
       symbolic_constant_table(50) = jhess2
       symbolic_constant_table(51) = subb
       symbolic_constant_table(52) = sube
       symbolic_constant_table(53) = sip_sub_segsize
       symbolic_constant_table(54) = sip_sub_occ_segsize
       symbolic_constant_table(55) = sip_sub_virt_segsize
       symbolic_constant_table(56) = sip_sub_ao_segsize

       isegtable = get_index_from_base(isegbase, segment_table, 1)
       segment_table_base = isegbase
            
c------------------------------------------------------------------------
c   Allocate enough memory for the address_table.
c------------------------------------------------------------------------

      size = loc(address_table(2)) - loc(address_table(1))

      call mem_alloc(address_table, narray_table, size, iaddr_table,
     *               .true., ierr)
      ixx = 1
      address_table_base = c_loc64(address_table(iaddr_table), ixx, 8)
      proctab_base       = c_loc64(proctab, ixx, intsize)

c--------------------------------------------------------------------------
c   Determine the amount of memory needed for the block_map_table.
c--------------------------------------------------------------------------

      call block_map_table_setup(array_table(iarray), narray_table,
     *                     index_table(iindex), nindex_table,
     *                     segment_table(isegbase), nsegment_table,
     *                     nblock_map_table)

c----------------------------------------------------------------------------
c   Allocate the memory for the block_map_table.
c----------------------------------------------------------------------------

      nw = nblock_map_table * lblock_map_entry
      call mem_alloc(block_map_table, nw, intsize, 
     *               ibmap_table,
     *               .true., ierr)

      ixx = 1
      bmap_table_base = c_loc64(block_map_table, ibmap_table, 
     *                       intsize)

c------------------------------------------------------------------------
c   Initialize all the tables.
c------------------------------------------------------------------------

       if (me .eq. 0) call print_symbolic_constants()  
      

       call vtdemo_init(optable(iopt), noptable, 
     *                    array_table(iarray), narray_table,
     *                    index_table(iindex), nindex_table, 
     *                    segment_table(isegtable), nsegment_table,
     *                    scalar_table(iscalar), nscalar_table, 
     *                    block_map_table(ibmap_table),
     *                    nblock_map_table, proctab, 
     *                    address_table(iaddr_table), blocksize,
     *                    end_nfps, nshells, scf_energy, totenerg,
     *                    damp_init, cc_conv, scf_conv, stabvalue,
     *
     *                    excite, eom_tol, eom_roots, ! Watson Added
     *
     *                    io_company_id, niocompany, need_predef,
     *                    npre_defined, dryrun)
 
c------------------------------------------------------------------------
c   Determine block size for the thread buffer(s).
c------------------------------------------------------------------------

      blocksize = 0
      do i = 1, nstacks
         blocksize = max(stack_blocksizes(i), blocksize)
      enddo
      
c--------------------------------------------------------------------------
c   Allocate the remaining memory for use as data blocks.
c--------------------------------------------------------------------------

      i8temp = maxmem * 1024
      i8size = i8temp * 1024
      call mem_alloc_query(malloced_previously)
      i8size    = i8size - malloced_previously
      i8size    = i8size / bytes_per_double
      nblkmgr = (0.95*i8size) 
      call mem_alloc(blkmgr_scr, nblkmgr, bytes_per_double, 
     *                  iblkmgr, .true., ierr)
      if (ierr .ne. 0) then
         print *,'Task ',me,' mem_alloc error in sip_fmain_init ',
     *        nblkmgr
         write(6,11) nblkmgr  
         call abort_job()
      endif
11    FORMAT('Task ',I4,' mem_alloc error in sip_fmain_init ',
     *        I8) 

      i8size = nblkmgr
      i8size = i8size * bytes_per_double
      if (me .eq. 0) print *,'Allocated ',i8size,
     *        ' bytes for blkmgr.'

c---------------------------------------------------------------------------
c   Set up the addresses of communication buffers.
c---------------------------------------------------------------------------

      addr_comm_buffer = c_loc64(blkmgr_scr,iblkmgr,
     *                                    bytes_per_double)

      ithread = get_index_from_base(addr_comm_buffer, x, 2)
      if (nprocs .gt. 1) then
         nwork   = nworkthread * blocksize 
      else
         nwork = 0    ! thread server will not be active.
      endif

c-------------------------------------------------------------------------
c   Do a dryrun to determine the proper distribution of the stack blocks.
c-------------------------------------------------------------------------

       nblk_overhead = lblk_header + 2 + 8/intsize  ! overhead per block

       call stack_distribution(optable(iopt), noptable, 
     *                    array_table(iarray), narray_table,
     *                    index_table(iindex), nindex_table, 
     *                    segment_table(isegtable), nsegment_table,
     *                    scalar_table(iscalar), nscalar_table, 
     *                    block_map_table(ibmap_table),
     *                    nblock_map_table, proctab, 
     *                    blkmgr_scr(iblkmgr+nwork), nblkmgr-nwork,
     *                    nblk_overhead,
     *                    stack_blocksizes, nstacks, stack_blocks,
     *                    stack_algorithm_type, ncompany_workers,
     *                    niocompany, ierr, .true.)
      if (ierr .ne. 0) then
         
c--------------------------------------------------------------------------
c   Attempt to determine the number of processors on which this job 
c   will fit.
c--------------------------------------------------------------------------

  100    continue
         ncompany_workers = ncompany_workers + 1
         call refill_block_map_table(ncompany_workers, 
     *                    block_map_table(ibmap_table),
     *                    nblock_map_table, 
     *                    array_table(iarray), narray_table,
     *                    index_table(iindex), nindex_table)
         call stack_distribution(optable(iopt), noptable,
     *                    array_table(iarray), narray_table,
     *                    index_table(iindex), nindex_table,
     *                    segment_table(isegtable), nsegment_table,
     *                    scalar_table(iscalar), nscalar_table,
     *                    block_map_table(ibmap_table),
     *                    nblock_map_table, proctab,
     *                    blkmgr_scr(iblkmgr+nwork), nblkmgr-nwork,
     *                    nblk_overhead,
     *                    stack_blocksizes, nstacks, stack_blocks,
     *                    stack_algorithm_type, ncompany_workers,
     *                    niocompany, istat, .false.)
         if (istat .ne. 0 .and. 
     *       ncompany_workers .lt. max_procsx) go to 100
      endif

      call mpi_barrier(company_comm, mpierr)
      call mpi_reduce(ncompany_workers, ncompany_workers_min, 1,
     *                mpi_integer, mpi_max, 0,
     *                company_comm, mpierr)

      ierr_return = ierr

      if (my_company_rank .eq. 0 .and. ierr .ne. 0) then

         print *,'DRYRUN ERROR: Step will abort, ',
     *       'cannot fit in memory'
         print *,'This step requires a minimum of ',
     *      ncompany_workers_min,
     *      ' workers along with ',niocompany,' servers to run.'

         write(66,*) 'DRYRUN ERROR: Step will abort, ',
     *       'cannot fit in memory'
         write(66,*) 'This step requires a minimum of ',
     *      ncompany_workers_min,
     *      ' workers along with ',niocompany,' servers to run.'

         return
      endif

c-------------------------------------------------------------------------
c   Create the server table and send a copy to each server.
c-------------------------------------------------------------------------

      if (my_company_rank .eq. 0 .and. .not. dryrun) then
         i8size = nblkmgr
         i8size = i8size * bytes_per_double
         nblkmgr_ints = i8size / intsize

         i8size = niocompany * nstacks
         i8size = i8size * intsize
         i8size = (i8size + bytes_per_double -1)/ bytes_per_double
         nwork2 = i8size 

         nblkmgr_ints = nblkmgr_ints - 
     *                  (nwork2*bytes_per_double) / intsize
         
         call distribute_server_info(array_table(iarray), narray_table,
     *                     index_table(iindex), nindex_table,
     *                     segment_table(isegtable), nsegment_table,
     *                     block_map_table(ibmap_table),
     *                     nblock_map_table, io_company_id,
     *                     niocompany, blkmgr_scr(iblkmgr+nwork2), 
     *                     nblkmgr_ints, stack_blocksizes, nstacks,
     *                     blkmgr_scr(iblkmgr))
      endif

c------------------------------------------------------------------------
c   Set up the following dynamically allocated arrays:
c      blk_header - For data required by blkmgr to manage each block.
c      free_stack - Array containing the free blocks for each stack.
c      blk_addr   - Array continuing the address of each data block.
c   These arrays will be initialized by blkmgr_init, but we must 
c   allocate them here.
c------------------------------------------------------------------------

      nblocks_total = 0
      nw_total      = 0
      do i = 1, nstacks
         nblocks_total = nblocks_total + stack_blocks(i)
         nw_total = nw_total + stack_blocks(i)*(stack_blocksizes(i) +
     *                2) 
      enddo

      iblkmgr_data = iblkmgr + nwork
      nblkmgr      = nblkmgr - nwork

      nblkmgr = nblkmgr - (nblk_overhead * nblocks_total *
     *                      intsize) / bytes_per_double

      ixx = iblkmgr_data + nblkmgr   ! point to end of block area.
      addr = c_loc64(blkmgr_scr, ixx, bytes_per_double)
      iblk_header = get_index_from_base(addr, iblkmgr_scr, 1)
      ifree_stack = iblk_header + lblk_header * nblocks_total
      iblk_in_use = ifree_stack + nblocks_total
      iblk_addr   = iblk_in_use + nblocks_total 

c-------------------------------------------------------------------------
c   Force the blk_addr table to come out on a 8-byte boundary.
c-------------------------------------------------------------------------

      addr = c_loc64(iblkmgr_scr, iblk_addr, intsize)
      if (addr/8 * 8 .ne. addr) then
         addr = (addr + 7)/8 * 8
         iblk_addr = get_index_from_base(addr, iblkmgr_scr, 1)
      endif
 
c------------------------------------------------------------------------
c   Initialize the block manager.
c------------------------------------------------------------------------

       call blkmgr_init(blkmgr_scr(iblkmgr_data), nblkmgr, 
     *                  nblocks_total,
     *                  iblkmgr_scr(iblk_header), 
     *                  iblkmgr_scr(ifree_stack),
     *                  iblkmgr_scr(iblk_addr),
     *                  iblkmgr_scr(iblk_in_use),
     *                  stack_blocksizes, stack_blocks, 
     *                  nstacks, company_comm)

      if (me .eq. 0) then
         call mem_alloc_query(malloced_previously)
         i8size = malloced_previously
         i8size = i8size / 1024
         i8size = i8size / 1024
         print *,'Total memory usage ',i8size,' MBytes.'
         print *,'Max. possible usage ',maxmem,' MBytes' 
         print *,'Total blocks used = ',nblocks_total
      endif 
      return

      entry sip_fmain()
      call mpi_comm_rank(mpi_comm_world, me, ierr)
      company_comm    = pst_get_company_comm(me)
      my_company_rank = pst_get_company_rank(me)

#ifdef ALTIX
      dptr = dshptr
      ptr_optable      = ishptr
      ptr_index_table  = ishptr
      ptr_array_table  = ishptr
      ptr_scalar_table = dshptr
      ptr_block_map    = ishptr
      ptr_segment_table=ishptr 
      ptr_address_table = i8shptr
      ptr_blkmgr_scr   = dshptr
#endif

c----------------------------------------------------------------------------
c   Set up table addresses.
c----------------------------------------------------------------------------

      ixx = 1
      iopt   = get_index_from_base(optable_base, optable, 1)
      iindex = get_index_from_base(index_table_base,
     *     index_table, 1)
      iarray = get_index_from_base(array_table_base, array_table, 1)

      iscalar = get_index_from_base(scalar_table_base, scalar_table, 2)
      iaddr_table = get_index_from_base(address_table_base, 
     *                                  address_table, 3)
      ibmap_table = get_index_from_base(bmap_table_base,
     *                                 block_map_table, 1)
      isegtable = get_index_from_base(segment_table_base, segment_table,
     *                                1)

      noptable = noptable_sip
      nindex_table = nindex_table_sip
      narray_table = narray_table_sip
      nscalar_table = nscalar_table_sip

      timerdesc = 'Block wait time'
      call register_timer(timerdesc, elapsed_time_timer, comm_timer)

      debug = .false.
      validate = .false.
      
      call set_sumz_tables(array_table(iarray), 
     *                     block_map_table(ibmap_table))

      call optable_loop(optable(iopt), noptable, array_table(iarray),
     *                narray_table,
     *                array_labels, index_table(iindex), nindex_table,
     *                segment_table(isegtable), nsegment_table,
     *                block_map_table(ibmap_table), nblock_map_table,
     *                scalar_table(iscalar), nscalar_table,
     *                proctab, address_table(iaddr_table), 
     *                debug, validate,
     *                company_comm, comm_timer)

      if (my_company_rank .eq. 0) then
         print *, '---------- Finished! ---------------'

         if (dbg) then
            print *,'Final state of scalar table:'
            do i = 1, nscalar_table
              print *,'scalar entry ',i,': ',
     *              scalar_table(iscalar+i-1)
            enddo
         endif

c-------------------------------------------------------------------------
c   Save TOTENERG value for later update of JOBARC file.
c-------------------------------------------------------------------------

         itotenerg = 
     *          array_table(iarray+4*larray_table_entry+
     *                       c_scalar_index-1)
         print *,'Total energy: ',
     *          scalar_table(iscalar+itotenerg-1)
         totenerg = scalar_table(iscalar+itotenerg-1)

c-------------------------------------------------------------------------
c   Save SCFENEG value for later update of JOBARC file.
c-------------------------------------------------------------------------

         iscfeneg =
     *          array_table(iarray+3*larray_table_entry+
     *                      c_scalar_index-1)
         print *,'SCF energy: ',
     *          scalar_table(iscalar+iscfeneg-1)
         scf_energy = scalar_table(iscalar+iscfeneg-1)

c-------------------------------------------------------------------------
c   Save STABVALUE value for later update of JOBARC file.
c-------------------------------------------------------------------------

         istabvalue =
     *          array_table(iarray+18*larray_table_entry+
     *                      c_scalar_index-1)
         print *,'HF Instability Value: ',
     *          scalar_table(iscalar+istabvalue-1)
         stabvalue = scalar_table(iscalar+istabvalue-1)
      endif

c-------------------------------------------------------------------------
c   Sum up the distributed contributions to the gradient.
c-------------------------------------------------------------------------

      call mpi_barrier(company_comm, ierr)
      call mpi_comm_size(company_comm, ncompany_workers, ierr)
      if (ncompany_workers .gt. 1) then
         do i = 1, 3*ncenters
            mygrad(i) = gradient_data(i)
         enddo

         call mpi_reduce(mygrad, gradient_data, 3*ncenters,
     *                mpi_double_precision, mpi_sum, 0, 
     *                company_comm, ierr)

c----------------------------------------------------------------------------
c   Final summation of the Hessian is performed in batches to save memory.
c   The mygrad array is used as a temporary buffer so the send and receive 
c   buffers of the mpi_reduce call do not overlap.
c----------------------------------------------------------------------------

         nxthess = ix_hess
         do j = 1, 3*ncenters
            do i = 1, 3*ncenters
               mygrad(i) = x(nxthess+i-1)
            enddo

            call mpi_reduce(mygrad, x(nxthess), 3*ncenters,
     *                mpi_double_precision, mpi_sum, 0,
     *                company_comm, ierr)
            nxthess = nxthess + 3*ncenters
         enddo
      endif

      if (my_company_rank .eq. 0) then
         print *,'Gradient data:'
         do i = 1, ncenters
            igrad = (i-1)*3 + 1
            print *,'Atom #',i,': ',gradient_data(igrad),
     *               gradient_data(igrad+1), gradient_data(igrad+2)
         enddo
     
c---------------------------------------------------------------------------
c   Get addresses of CA, CB, FOCK_A, and FOCK_B arrays. 
c   ONLY if the scf has just been performed. 
c---------------------------------------------------------------------------

         if (if_scf .or. init_scf .or. if_fno) then
            ixca = 1
            ixcb = 1
            ixfa = 1
            ixfb = 1
            if (address_table(iaddr_table+1) .ne. 0) 
     *         ixca = get_index_from_base(address_table(iaddr_table+1),
     *                                     x,2) 
            if (address_table(iaddr_table+2) .ne. 0)
     *         ixcb = get_index_from_base(address_table(iaddr_table+2),
     *                                    x,2) 
            if (address_table(iaddr_table+8) .ne. 0)
     *         ixfa = get_index_from_base(address_table(iaddr_table+8),
     *                                    x,2)
            if (address_table(iaddr_table+9) .ne. 0) 
     *         ixfb = get_index_from_base(address_table(iaddr_table+9),
     *                                    x,2) 

             call write_eig_data(x(ixca), x(ixcb), x(ixfa), x(ixfb), 
     *                           nbasis, need_predef)
         endif 

      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine find_matching_indices(x, y, array_table, narray_table,
     *                                 matches, nmatches)
c---------------------------------------------------------------------------
c   Returns matching indices of arrays x and y in array "matches".
c---------------------------------------------------------------------------
 
      implicit none
      include 'interpreter.h'
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer x, y, matches(4)
      integer i, j, nmatches, nx, ny, xval

      nx = array_table(c_nindex,x)    ! number of indices.
      ny = array_table(c_nindex,y)

      nmatches = 0
      do i = 1, nx
         xval = array_table(c_index_array1+i-1,x)
         do j = 1, ny
            if (xval .eq. array_table(c_index_array1+j-1,y)) then
               nmatches = nmatches + 1
               matches(nmatches) = xval
            endif
         enddo 
      enddo
      
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C EMULATOR OF CRAY SCILIB ROUTINE. GATHERS A VECTOR (B) INTO ANOTHER
C VECTOR (A) ACCORDING TO AN INDEX VECTOR (INDEX).

c The UNICOS man page for gather is appended to this file.

      subroutine gather(n,a,b,index)
      integer n,index(n),i
      double precision a(n),b(*)
      do i = 1, n
         a(i) = b(index(i))
      end do
      return
      end

c NAME
c      GATHER - Gathers a vector from a source vector
c
c SYNOPSIS
c      CALL GATHER(n,a,b,index)
c
c DESCRIPTION
c      GATHER is defined as follows:
c
c           a(i) = b(j(i)) where i = 1,...,n
c
c      This routine has the following arguments:
c
c      n      Integer.  (input)
c             Number of elements in arrays a and index (not in b).
c
c      a      Real or integer array of dimension n.  (output)
c             Contains the result vector.
c
c      b      Real or integer array of dimension max(index(i): i=1,...,n).
c             (input)
c             Contains the source vector.
c
c      index  Integer array of dimension n.  (input)
c             Contains the vector of indices.
c
c      The Fortran equivalent of this routine is as follows:
c
c                DO 100 I=1,N
c                   A(I)=B(INDEX(I))
c            100 CONTINUE
c
c CAUTIONS
c      You should not use this routine on systems that have Compress-Index
c      Gather-Scatter (CIGS) hardware, because it will degrade performance.

C ROUTINE PRINTS FIRST LENGTH ELEMENTS OF INTEGER VECTOR IVEC,
C ALONG WITH THE CORRESPONDING INDICES IN I5,I6 FORMAT.

      SUBROUTINE PRVECI(IVEC,LENGTH)
      IMPLICIT INTEGER (A-Z)
      DIMENSION IVEC(LENGTH)
      if (length.lt.1) return
      WRITE(*,100) (I,IVEC(I),I=1,LENGTH)
100   FORMAT(5(1X,:'[',I5,']',I6))
      RETURN
      END

      SUBROUTINE NODUMMY(NATMS, NTANGM, NUC, COORD, NANGMOM,
     &                   NMOMFCT,NUCTR)
C
C This routine removes dummy and ghost atoms from the molecule
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION NUC(NATMS),COORD(3*NATMS),NANGMOM(NATMS),
     &          NMOMFCT(NATMS*NTANGM),NUCTR(NATMS)
C
      ICNT=0
      DO 10 IATM=1,NATMS
         IF(NUC(IATM).NE.0)THEN
            ICNT=ICNT+1
            NUC(ICNT)=NUC(IATM)
            NUCTR(IATM)=ICNT
            NANGMOM(ICNT)=NANGMOM(IATM)
            DO 20 I=1,3
              COORD((ICNT-1)*3+I)=COORD((IATM-1)*3+I)
   20       CONTINUE
            DO 30 I=1,NTANGM
               NMOMFCT((ICNT-1)*NTANGM+I)=NMOMFCT((IATM-1)*NTANGM+I)
   30       CONTINUE
         ENDIF
   10 CONTINUE
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__CSGTO
     +
     +                    ( IMAX,ZMAX,
     +                      NALPHA,NCOEFF,NCSUM,
     +                      NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL2,SHELL3,SHELL4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      ALPHA,CC,CCBEG,CCEND,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      L1CACHE,TILE,NCTROW,
     +                      SPHERIC,SCREEN,
     +                      ICORE,
     +
     +                                NBATCH,
     +                                NFIRST,
     +                                ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__CSGTO
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__SET_ABCD
C                ERD__SET_IJ_KL_PAIRS
C                ERD__E0F0_DEF_BLOCKS
C                ERD__PREPARE_CTR
C                ERD__E0F0_PCGTO_BLOCK
C                ERD__CTR_4INDEX_BLOCK
C                ERD__CTR_RS_EXPAND
C                ERD__CTR_TU_EXPAND
C                ERD__CTR_4INDEX_REORDER
C                ERD__TRANSPOSE_BATCH
C                ERD__XYZ_TO_RY_ABCD
C                ERD__CARTESIAN_NORMS
C                ERD__HRR_MATRIX
C                ERD__HRR_TRANSFORM
C                ERD__SPHERICAL_TRANSFORM
C                ERD__NORMALIZE_CARTESIAN
C                ERD__MOVE_RY
C  DESCRIPTION : This operation calculates a batch of contracted
C                electron repulsion integrals on up to four different
C                centers between spherical or cartesian gaussian type
C                shells.
C
C
C                  Input (x = 1,2,3 and 4):
C
C                    IMAX,ZMAX    =  maximum integer,flp memory
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCSUM        =  total # of contractions
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1,2,3 and 4
C                    ALPHA        =  primitive exponents for csh
C                                    1,2,3,4 in that order
C                    CC           =  full set (including zeros) of
C                                    contraction coefficients for csh
C                                    1,2,3,4 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction
C                    CC(BEG)END   =  (lowest)highest nonzero primitive
C                                    index for contractions for csh
C                                    1,2,3,4 in that order. They are
C                                    different from (1)NPGTOx only for
C                                    segmented contractions
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C                    SCREEN       =  is true, if screening will be
C                                    done at primitive integral level
C                    ICORE        =  integer scratch space
C                    ZCORE (part) =  flp scratch space
C
C                  Output:
C
C                    NBATCH       =  # of integrals in batch
C                    NFIRST       =  first address location inside the
C                                    ZCORE array containing the first
C                                    integral
C                    ZCORE        =  full batch of contracted (12|34)
C                                    integrals over cartesian or
C                                    spherical gaussians starting at
C                                    ZCORE (NFIRST)
C
C
C
C              --- NOTES ABOUT THE OVERALL INTEGRAL PREFACTOR ---
C
C                The overal integral prefactor is defined here as
C                follows. Consider the normalization factors for a
C                primitive cartesian GTO and for a spherical GTO
C                belonging to the angular momentum L = l+m+n:
C
C
C                    lmn                        l m n           2
C                 GTO  (x,y,z) = N (l,m,n,a) * x y z  * exp (-ar )
C                    a
C
C
C                    LM                     L    LM                2
C                 GTO  (r,t,p) = N (L,a) * r  * Y  (t,p) * exp (-ar )
C                    a
C
C
C                where a = alpha exponent, t = theta and p = phi and
C                N (l,m,n,a) and N (L,a) denote the respective
C                cartesian and spherical normalization factors such
C                that:
C
C
C                              lmn            lmn
C                 integral {GTO  (x,y,z) * GTO   (x,y,z) dx dy dz} = 1
C                              a              a
C
C
C                              LM             LM
C                 integral {GTO  (r,t,p) * GTO  (r,t,p) dr dt dp} = 1
C                              a              a
C
C
C                The normalization constants have then the following
C                values, assuming the spherical harmonics are
C                normalized:
C
C                              _____________________________________
C                             /      2^(2L+1+1/2) * a^((2L+3)/2)
C            N (l,m,n,a) =   / ----------------------------------------
C                          \/ (2l-1)!!(2m-1)!!(2n-1)!! * pi * sqrt (pi)
C
C
C                                   ____________________________
C                                  / 2^(2L+3+1/2) * a^((2L+3)/2)
C                     N (L,a) =   / -----------------------------
C                               \/     (2L+1)!! * sqrt (pi)
C
C
C                Note, that the extra pi under the square root in
C                N (l,m,n,a) belongs to the normalization of the
C                spherical harmonic functions and therefore does not
C                appear in the expression for N (L,a). The common
C                L-,l-,m-,n- and a-independent part of the cartesian
C                norm is a scalar quantity needed for all integrals
C                no matter what L-,l-,m-,n- and a-values they have:
C
C                                       _____________
C                                      /  2^(1+1/2)
C                     N (0,0,0,0) =   / --------------
C                                   \/  pi * sqrt (pi)
C
C
C                Also every ERI integral has a factor of 2*pi**(5/2)
C                associated with it, hence the overall common factor
C                for all integrals will be N(0,0,0,0)**4 times
C                2*pi**(5/2), which is equal to:
C
C
C                            PREFACT = 16 / sqrt(pi)
C
C
C                and is set as a parameter inside the present routine.
C                The alpha exponent dependent part of the norms:
C
C                                   ______________
C                                 \/ a^((2L+3)/2)
C
C                will be calculated separately (see below) and their
C                inclusion in evaluating the primitive cartesian
C                [E0|F0] integrals will be essential for numerical
C                stability during contraction.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOMAB,ATOMCD
         LOGICAL     BLOCKED
         LOGICAL     EMPTY
         LOGICAL     EQUALAB,EQUALCD
         LOGICAL     MEMORY
         LOGICAL     REORDER
         LOGICAL     SCREEN
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAP34,SWAPRS,SWAPTU
         LOGICAL     TR1234

         INTEGER     IHNROW,IHROW,IHSCR
         INTEGER     IMAX,ZMAX
         INTEGER     IN,OUT
         INTEGER     INDEXA,INDEXB,INDEXC,INDEXD
         INTEGER     INDEXR,INDEXS,INDEXT,INDEXU
         INTEGER     IPRIMA,IPRIMB,IPRIMC,IPRIMD
         INTEGER     IPUSED,IPSAVE,IPPAIR
         INTEGER     ISNROWA,ISNROWB,ISNROWC,ISNROWD
         INTEGER     ISROWA,ISROWB,ISROWC,ISROWD
         INTEGER     IUSED,ZUSED
         INTEGER     L1CACHE,TILE,NCTROW
         INTEGER     LCC1,LCC2,LCC3,LCC4
         INTEGER     LCCA,LCCB,LCCC,LCCD
         INTEGER     LCCSEGA,LCCSEGB,LCCSEGC,LCCSEGD
         INTEGER     LEXP1,LEXP2,LEXP3,LEXP4
         INTEGER     LEXPA,LEXPB,LEXPC,LEXPD
         INTEGER     MIJ,MKL,MIJKL,MGQIJKL
         INTEGER     MGRID,NGRID
         INTEGER     MOVE,NOTMOVE
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSHELL,MXSIZE
         INTEGER     NABCOOR,NCDCOOR
         INTEGER     NALPHA,NCOEFF,NCSUM
         INTEGER     NBATCH,NFIRST
         INTEGER     NCGTO1,NCGTO2,NCGTO3,NCGTO4
         INTEGER     NCGTOA,NCGTOB,NCGTOC,NCGTOD,NCGTOAB,NCGTOCD
         INTEGER     NCGTOR,NCGTOS,NCGTOT,NCGTOU
         INTEGER     NCOLHRR,NROWHRR,NROTHRR,NXYZHRR
         INTEGER     NCTR
         INTEGER     NGQP,NMOM,NGQSCR
         INTEGER     NIJ,NKL
         INTEGER     NIJBLK,NKLBLK,NIJBEG,NKLBEG,NIJEND,NKLEND
         INTEGER     NINT2D
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4
         INTEGER     NPGTOA,NPGTOB,NPGTOC,NPGTOD,NPGTOAB,NPGTOCD
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NROTA,NROTB,NROTC,NROTD
         INTEGER     NROWA,NROWB,NROWC,NROWD
         INTEGER     NRYA,NRYB,NRYC,NRYD
         INTEGER     NXYZA,NXYZB,NXYZC,NXYZD
         INTEGER     NXYZP,NXYZQ,NXYZT,NXYZET,NXYZFT
         INTEGER     POS1,POS2
         INTEGER     SHELL1,SHELL2,SHELL3,SHELL4
         INTEGER     SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER     SHELLP,SHELLQ,SHELLT
         INTEGER     TEMP

         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,ZNORMC,ZNORMD,
     +               ZBASE,ZCNORM,
     +               ZRHOAB,ZRHOCD,
     +               ZP,ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCPK2,
     +               ZQ,ZQX,ZQY,ZQZ,ZQCX,ZQCY,ZQCZ,ZQINVHF,ZSCQK2,
     +               ZRTS,ZWTS,ZGQSCR,ZTVAL,ZPQPINV,ZSCPQK4,
     +               ZB00,ZB01,ZB10,
     +               ZC00X,ZC00Y,ZC00Z,ZD00X,ZD00Y,ZD00Z,
     +               ZINT2DX,ZINT2DY,ZINT2DZ,
     +               ZSROTA,ZSROTB,ZSROTC,ZSROTD,
     +               ZHROT

         INTEGER     CCBEG (1:NCSUM)
         INTEGER     CCEND (1:NCSUM)
         INTEGER     ICORE (1:IMAX)
         INTEGER     IXOFF (1:4)

         DOUBLE PRECISION  ABX,ABY,ABZ,CDX,CDY,CDZ
         DOUBLE PRECISION  PREFACT
         DOUBLE PRECISION  RNABSQ,RNCDSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
         DOUBLE PRECISION  ZCORE (1:ZMAX)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (PREFACT = 9.027033336764101D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...fix the A,B,C,D labels from the 1,2,3,4 ones.
C                Calculate the relevant data for the A,B,C,D batch of
C                integrals.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LEXP3 = LEXP2 + NPGTO2
         LEXP4 = LEXP3 + NPGTO3

         LCC1 = 1
         LCC2 = LCC1 + NPGTO1 * NCGTO1
         LCC3 = LCC2 + NPGTO2 * NCGTO2
         LCC4 = LCC3 + NPGTO3 * NCGTO3

         CALL  ERD__SET_ABCD
     +
     +              ( NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                SHELL1,SHELL2,SHELL3,SHELL4,
     +                X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                ALPHA (LEXP3),ALPHA (LEXP4),
     +                CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                SPHERIC,
     +
     +                            NCGTOA,NCGTOB,NCGTOC,NCGTOD,
     +                            NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                            SHELLA,SHELLB,SHELLC,SHELLD,
     +                            SHELLP,SHELLQ,SHELLT,
     +                            MXSHELL,
     +                            XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD,
     +                            ATOMIC,ATOMAB,ATOMCD,
     +                            EQUALAB,EQUALCD,
     +                            ABX,ABY,ABZ,CDX,CDY,CDZ,
     +                            NABCOOR,NCDCOOR,
     +                            RNABSQ,RNCDSQ,
     +                            SPNORM,
     +                            NXYZA,NXYZB,NXYZC,NXYZD,
     +                            NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                            NRYA,NRYB,NRYC,NRYD,
     +                            INDEXA,INDEXB,INDEXC,INDEXD,
     +                            SWAP12,SWAP34,SWAPRS,SWAPTU,TR1234,
     +                            LEXPA,LEXPB,LEXPC,LEXPD,
     +                            LCCA,LCCB,LCCC,LCCD,
     +                            LCCSEGA,LCCSEGB,LCCSEGC,LCCSEGD,
     +                            NXYZHRR,NCOLHRR,NROTHRR,
     +                            EMPTY )
     +
     +
C         WRITE (*,*) ' Finished set abcd '
C         WRITE (*,*) ' Index A,B,C,D = ',INDEXA,INDEXB,INDEXC,INDEXD
C         WRITE (*,*) ' EQUALAB = ',EQUALAB
C         WRITE (*,*) ' EQUALCD = ',EQUALCD

         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...enter the cartesian contracted (e0|f0) batch
C                generation. Set the ij and kl primitive exponent
C                pairs and the corresponding exponential prefactors.
C
C
         IF (EQUALAB) THEN
             NPGTOAB = (NPGTOA*(NPGTOA+1))/2
             NCGTOAB = (NCGTOA*(NCGTOA+1))/2
         ELSE
             NPGTOAB = NPGTOA * NPGTOB
             NCGTOAB = NCGTOA * NCGTOB
         END IF

         IF (EQUALCD) THEN
             NPGTOCD = (NPGTOC*(NPGTOC+1))/2
             NCGTOCD = (NCGTOC*(NCGTOC+1))/2
         ELSE
             NPGTOCD = NPGTOC * NPGTOD
             NCGTOCD = NCGTOC * NCGTOD
         END IF

         NCTR = NCGTOAB * NCGTOCD
         NXYZT = NXYZET * NXYZFT

         IPRIMA = 1
         IPRIMB = IPRIMA + NPGTOAB
         IPRIMC = IPRIMB + NPGTOAB
         IPRIMD = IPRIMC + NPGTOCD

         CALL  ERD__SET_IJ_KL_PAIRS
     +
     +              ( NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                NPGTOAB,NPGTOCD,
     +                ATOMAB,ATOMCD,
     +                EQUALAB,EQUALCD,
     +                SWAPRS,SWAPTU,
     +                XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD,
     +                RNABSQ,RNCDSQ,
     +                PREFACT,
     +                ALPHA (LEXPA),ALPHA (LEXPB),
     +                ALPHA (LEXPC),ALPHA (LEXPD),
     +                FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                SCREEN,
     +
     +                         EMPTY,
     +                         NIJ,NKL,
     +                         ICORE (IPRIMA),ICORE (IPRIMB),
     +                         ICORE (IPRIMC),ICORE (IPRIMD),
     +                         ZCORE (1) )
     +
     +
         IF (EMPTY) THEN
             NBATCH = 0
             RETURN
         END IF
C
C
C             ...decide on the primitive [e0|f0] block size and
C                return array sizes and pointers for the primitive
C                [e0|f0] generation. Perform also some preparation
C                steps for contraction.
C
C
         NGQP = 1 + SHELLT / 2
         NMOM = 2 * NGQP - 1
         NGQSCR = 5 * NMOM + 2 * NGQP - 2

         MEMORY = .FALSE.

         CALL  ERD__E0F0_DEF_BLOCKS
     +
     +              ( ZMAX,
     +                NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                SHELLP,SHELLQ,
     +                NIJ,NKL,
     +                NCGTOAB,NCGTOCD,NCTR,
     +                NGQP,NGQSCR,
     +                NXYZT,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                     NIJBLK,NKLBLK,
     +                     NPSIZE,NCSIZE,NWSIZE,
     +                     NINT2D,
     +                     MXPRIM,MNPRIM,
     +                     ZCBATCH,ZPBATCH,ZWORK,
     +                     ZNORMA,ZNORMB,ZNORMC,ZNORMD,
     +                     ZRHOAB,ZRHOCD,
     +                     ZP,ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCPK2,
     +                     ZQ,ZQX,ZQY,ZQZ,ZQCX,ZQCY,ZQCZ,ZQINVHF,ZSCQK2,
     +                     ZRTS,ZWTS,ZGQSCR,ZTVAL,ZPQPINV,ZSCPQK4,
     +                     ZB00,ZB01,ZB10,
     +                     ZC00X,ZC00Y,ZC00Z,ZD00X,ZD00Y,ZD00Z,
     +                     ZINT2DX,ZINT2DY,ZINT2DZ )
     +
     +
         BLOCKED = (NIJBLK.LT.NIJ) .OR. (NKLBLK.LT.NKL)

         CALL  ERD__PREPARE_CTR
     +
     +              ( NCSIZE,
     +                NIJ,NKL,
     +                NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                SHELLA,SHELLB,SHELLC,SHELLD,
     +                ALPHA (LEXPA),ALPHA (LEXPB),
     +                ALPHA (LEXPC),ALPHA (LEXPD),
     +                PREFACT,SPNORM,
     +                EQUALAB,EQUALCD,
     +                BLOCKED,
     +                ZCORE (1),
     +
     +                          ZCORE (ZNORMA),ZCORE (ZNORMB),
     +                          ZCORE (ZNORMC),ZCORE (ZNORMD),
     +                          ZCORE (ZRHOAB),ZCORE (ZRHOCD),
     +                          ZCORE (ZCBATCH) )
     +
     +
         IPUSED = IPRIMD + NPGTOCD
         IPSAVE = IPUSED + MNPRIM
         IPPAIR = IPSAVE + MXPRIM
C
C
C             ...evaluate unnormalized rescaled [e0|f0] in blocks
C                over ij and kl pairs and add to final contracted
C                (e0|f0). The keyword REORDER indicates, if the
C                primitive [e0|f0] blocks need to be transposed
C                before being contracted.
C
C
         REORDER = .TRUE.

         DO 1000 NIJBEG = 1,NIJ,NIJBLK
            NIJEND = MIN0 (NIJBEG+NIJBLK-1,NIJ)
            MIJ = NIJEND - NIJBEG + 1
            DO 1100 NKLBEG = 1,NKL,NKLBLK
               NKLEND = MIN0 (NKLBEG+NKLBLK-1,NKL)
               MKL = NKLEND - NKLBEG + 1

               MIJKL = MIJ * MKL
               MGQIJKL = NGQP * MIJKL

               CALL  ERD__E0F0_PCGTO_BLOCK
     +
     +                    ( NPSIZE,NINT2D,
     +                      ATOMIC,ATOMAB,ATOMCD,
     +                      MIJ,MKL,MIJKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NGQP,NMOM,NGQSCR,MGQIJKL,
     +                      NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                      NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                      SHELLA,SHELLP,SHELLC,SHELLQ,
     +                      XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD,
     +                      ABX,ABY,ABZ,CDX,CDY,CDZ,
     +                      ALPHA (LEXPA),ALPHA (LEXPB),
     +                      ALPHA (LEXPC),ALPHA (LEXPD),
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      ICORE (IPRIMA+NIJBEG-1),
     +                      ICORE (IPRIMB+NIJBEG-1),
     +                      ICORE (IPRIMC+NKLBEG-1),
     +                      ICORE (IPRIMD+NKLBEG-1),
     +                      ZCORE (ZNORMA),ZCORE (ZNORMB),
     +                      ZCORE (ZNORMC),ZCORE (ZNORMD),
     +                      ZCORE (ZRHOAB),ZCORE (ZRHOCD),
     +                      ZCORE (ZP),
     +                      ZCORE (ZPX),ZCORE (ZPY),ZCORE (ZPZ),
     +                      ZCORE (ZPAX),ZCORE (ZPAY),ZCORE (ZPAZ),
     +                      ZCORE (ZPINVHF),ZCORE (ZSCPK2),
     +                      ZCORE (ZQ),
     +                      ZCORE (ZQX),ZCORE (ZQY),ZCORE (ZQZ),
     +                      ZCORE (ZQCX),ZCORE (ZQCY),ZCORE (ZQCZ),
     +                      ZCORE (ZQINVHF),ZCORE (ZSCQK2),
     +                      ZCORE (ZRTS),ZCORE (ZWTS),ZCORE (ZGQSCR),
     +                      ZCORE (ZTVAL),ZCORE (ZPQPINV),
     +                      ZCORE (ZSCPQK4),
     +                      ZCORE (ZB00),ZCORE (ZB01),ZCORE (ZB10),
     +                      ZCORE (ZC00X),ZCORE (ZC00Y),ZCORE (ZC00Z),
     +                      ZCORE (ZD00X),ZCORE (ZD00Y),ZCORE (ZD00Z),
     +                      ZCORE (ZINT2DX),
     +                      ZCORE (ZINT2DY),
     +                      ZCORE (ZINT2DZ),
     +
     +                                ZCORE (ZPBATCH) )
     +
     +
C               WRITE (*,*) ' Finished e0f0 pcgto block '

               CALL  ERD__CTR_4INDEX_BLOCK
     +
     +                    ( NPSIZE,NCSIZE,NWSIZE,
     +                      NXYZT,MIJKL,
     +                      MIJ,MKL,NCGTOAB,NCGTOCD,
     +                      NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                      NCGTOA,NCGTOB,NCGTOC,NCGTOD,
     +                      MXPRIM,MNPRIM,
     +                      CC (LCCA),CC (LCCB),CC (LCCC),CC (LCCD),
     +                      CCBEG (LCCSEGA),CCBEG (LCCSEGB),
     +                      CCBEG (LCCSEGC),CCBEG (LCCSEGD),
     +                      CCEND (LCCSEGA),CCEND (LCCSEGB),
     +                      CCEND (LCCSEGC),CCEND (LCCSEGD),
     +                      ICORE (IPRIMA+NIJBEG-1),
     +                      ICORE (IPRIMB+NIJBEG-1),
     +                      ICORE (IPRIMC+NKLBEG-1),
     +                      ICORE (IPRIMD+NKLBEG-1),
     +                      L1CACHE,TILE,NCTROW,
     +                      EQUALAB,EQUALCD,
     +                      SWAPRS,SWAPTU,
     +                      REORDER,
     +                      BLOCKED,
     +                      ICORE (IPUSED),
     +                      ICORE (IPSAVE),
     +                      ICORE (IPPAIR),
     +                      ZCORE (ZPBATCH),
     +                      ZCORE (ZWORK),
     +
     +                                ZCORE (ZCBATCH) )
     +
     +
C               WRITE (*,*) ' Finished 4 index ctr block '

 1100       CONTINUE
 1000    CONTINUE
C
C
C             ...the unnormalized cartesian (e0|f0) contracted batch is
C                ready. Expand the contraction indices (if necessary):
C
C                   batch (nxyzt,r>=s,t>=u) --> batch (nxyzt,r,s,t,u)
C
C                and reorder the contraction index part (if necessary):
C
C                   batch (nxyzt,r,s,t,u) --> batch (nxyzt,1,2,3,4)
C
C                The array IXOFF (x) indicates the total # of indices
C                to the left of x without including the nxyzt-part.
C                For the left most IXOFF value it is convenient to
C                set it equal to 1 instead of 0. Note, that the IXOFF
C                array indicates the true # of indices to the left
C                after! the batch has been transposed (see below) and
C                can be used as initial values when moving the
C                ry-components later on during the HRR and cartesian ->
C                spherical transformation procedure.
C                
C                For efficient application of the HRR contraction
C                scheme we need the batch elements ordered as:
C
C                          batch (1,2,3,4,nxyzt)
C
C                hence we transpose the batch after the reordering.
C                The space partitioning of the flp array for all of
C                these steps will be as follows:
C
C
C                          |  Zone 1  |  Zone 2  |
C
C                in which Zone 1 and 2 are 2 batches of HRR maximum
C                size. This can be done because we have always the
C                following dimension inequality:
C
C                              NXYZT =< NXYZHRR
C
C
         IXOFF (1) = 1
         IXOFF (2) = NCGTO1
         IXOFF (3) = NCGTO1 * NCGTO2
         IXOFF (4) = IXOFF (3) * NCGTO3

         NCTR = IXOFF (4) * NCGTO4
         MXSIZE = NCTR * NXYZHRR

         IN = ZCBATCH
         OUT = IN + MXSIZE

         IF (EQUALAB .AND. NCGTOAB.GT.1) THEN
             CALL  ERD__CTR_RS_EXPAND
     +
     +                  ( NXYZT,NCGTOAB,NCGTOCD,
     +                    NCGTOA,NCGTOB,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished ctr rs expansion '

             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

         IF (EQUALCD .AND. NCGTOCD.GT.1) THEN
             CALL  ERD__CTR_TU_EXPAND
     +
     +                  ( NXYZT*NCGTOA*NCGTOB,NCGTOCD,
     +                    NCGTOC,NCGTOD,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished ctr tu expansion '

             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

         REORDER = TR1234 .OR. (SWAP12.NEQV.SWAPRS)
     +                    .OR. (SWAP34.NEQV.SWAPTU)

         IF (REORDER .AND. NCTR.GT.1) THEN

             IF (SWAPRS) THEN
                 INDEXR = INDEXB
                 INDEXS = INDEXA
                 NCGTOR = NCGTOB
                 NCGTOS = NCGTOA
             ELSE
                 INDEXR = INDEXA
                 INDEXS = INDEXB
                 NCGTOR = NCGTOA
                 NCGTOS = NCGTOB
             END IF

             IF (SWAPTU) THEN
                 INDEXT = INDEXD
                 INDEXU = INDEXC
                 NCGTOT = NCGTOD
                 NCGTOU = NCGTOC
             ELSE
                 INDEXT = INDEXC
                 INDEXU = INDEXD
                 NCGTOT = NCGTOC
                 NCGTOU = NCGTOD
             END IF

             CALL  ERD__CTR_4INDEX_REORDER
     +
     +                  ( NXYZT,NCTR,
     +                    NCGTOR,NCGTOS,NCGTOT,NCGTOU,
     +                    IXOFF (INDEXR),IXOFF (INDEXS),
     +                    IXOFF (INDEXT),IXOFF (INDEXU),
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished ctr reorder '

             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

         IF (NXYZT.GT.1 .AND. NCTR.GT.1) THEN

             CALL  ERD__TRANSPOSE_BATCH
     +
     +                  ( NXYZT,NCTR,
     +                    TILE,
     +                    ZCORE (IN),
     +
     +                            ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished transpose batch '

             TEMP = IN
             IN = OUT
             OUT = TEMP
         END IF

C         CALL  ERD__PRINT_BATCH
C     +
C     +              ( NCTR,NXYZT,1,1,  ZCORE (IN) )
C     +
C         STOP
C
C
C             ...enter the HRR contraction and cartesian -> spherical
C                transformation / cartesian normalization section.
C                The sequence of events is to apply the HRR followed
C                by cartesian -> spherical transformations or cartesian
C                normalizations and immediate final positioning of
C                the finished parts to correspond with the contraction
C                indices i,j,k,l. First we do the f0-part followed
C                by the e0-part, which hence gives rise to the sequence
C                (where ' means spherical or cartesian normalization
C                and [] means the indices are in correspondence):
C
C                   batch (ijkl,e0,f0) --> batch (ijkl,e0,cd)
C                   batch (ijkl,e0,c,d) --> batch (ijkl,e0,c,d')
C                   batch (ijkl,e0,c,d') --> batch (ijkl[d'],e0,c)
C                   batch (ijkl[d'],e0,c) --> batch (ijkl[d'],e0,c')
C                   batch (ijkl[d'],e0,c') --> batch (ijkl[c'd'],e0)
C
C                   batch (ijkl[c'd'],e0) --> batch (ijkl[c'd'],ab)
C                   batch (ijkl[c'd'],a,b) --> batch (ijkl[c'd'],a,b')
C                   batch (ijkl[c'd'],a,b') --> batch (ijkl[b'c'd'],a)
C                   batch (ijkl[b'c'd'],a) --> batch (ijkl[b'c'd'],a')
C                   batch (ijkl[b'c'd'],a') --> batch (ijkl[a'b'c'd'])
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                  |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                 Zone 1 and 2:  2 batches of MXSIZE maximum size
C                                (set previously)
C
C                       Zone 3:  cart -> spher transformation data
C                                             or
C                                cartesian normalization factors
C
C                       Zone 4:  HRR contraction data
C
C
C                Determine memory allocation offsets for the entire HRR
C                procedure + cartesian -> spherical transformations or
C                cartesian normalizations and generate the transformation
C                matrices + associated data for those shells > p-shell.
C                The offsets are as follows (x=A,B,C,D):
C
C                    IN = offset for input HRR batch
C                   OUT = offset for output HRR batch
C
C                ZSROTx = offset for x-part transformation matrix
C               ISNROWx = offset for # of non-zero XYZ contribution row
C                         labels for x-part transformation matrix
C                ISROWx = offset for non-zero XYZ contribution row
C                         labels for x-part transformation matrix
C
C                 ZHROT = offset for HRR transformation matrix
C                IHNROW = offset for # of nonzero row labels for
C                         each HRR matrix column
C                 IHROW = offset for nonzero row labels for the HRR
C                         matrix
C                 IHSCR = integer scratch space for HRR matrix
C                         assembly
C
C                In case of s- or p-shells no transformation matrix is
C                generated, hence if we have s- and/or p-shells, then
c                no call to the cartesian -> spherical transformation
C                or cartesian normalization routines needs to be done.
C                All integrals have already been multiplied by a factor
C                SPNORM, which has the following value for each s- and
C                p-shell:
C
C                       For s-type shell  =  1
C
C                       For p-type shell  =  2 * norm for s-type
C
C                This factor was introduced together with the overall
C                prefactor during evaluation of the primitive integrals
C                in order to save multiplications.
C
C
         ZBASE = MAX0 (IN,OUT) + MXSIZE

         IF (SPHERIC) THEN
             IF (MXSHELL.GT.1) THEN
                 CALL  ERD__XYZ_TO_RY_ABCD
     +
     +                      ( NXYZA,NXYZB,NXYZC,NXYZD,
     +                        NRYA,NRYB,NRYC,NRYD,
     +                        SHELLA,SHELLB,SHELLC,SHELLD,
     +                        1,ZBASE,
     +
     +                                 NROWA,NROWB,NROWC,NROWD,
     +                                 NROTA,NROTB,NROTC,NROTD,
     +                                 ZSROTA,ZSROTB,ZSROTC,ZSROTD,
     +                                 ISNROWA,ISNROWB,ISNROWC,ISNROWD,
     +                                 ISROWA,ISROWB,ISROWC,ISROWD,
     +                                 IUSED,ZUSED,
     +                                 ICORE,ZCORE )
     +
     +
C                 WRITE (*,*) ' Finished xyz to ry abcd '
             ELSE
                 IUSED = 0
                 ZUSED = 0
             END IF
         ELSE
             IF (MXSHELL.GT.1) THEN
                 ZCNORM = ZBASE
                 CALL  ERD__CARTESIAN_NORMS
     +
     +                      ( MXSHELL,
     +
     +                                 ZCORE (ZCNORM))
     +
     +
C                 WRITE (*,*) ' Finished cartesian partial norms '
                 IUSED = 0
                 ZUSED = MXSHELL + 1
             ELSE
                 IUSED = 0
                 ZUSED = 0
             END IF
         END IF

         IHNROW = 1 + IUSED
         IHROW  = IHNROW + NCOLHRR + NCOLHRR
         IHSCR  = IHROW + NROTHRR + NROTHRR
         ZHROT  = ZBASE + ZUSED
C
C
C             ...do the first stage of processing the integrals:
C
C                   batch (ijkl,e0,f0) --> batch (ijkl,e0,cd)
C                   batch (ijkl,e0,c,d) --> batch (ijkl,e0,c,d')
C                   batch (ijkl,e0,c,d') --> batch (ijkl[d'],e0,c)
C                   batch (ijkl[d'],e0,c) --> batch (ijkl[d'],e0,c')
C                   batch (ijkl[d'],e0,c') --> batch (ijkl[c'd'],e0)
C
C
         IF (SHELLD.NE.0) THEN

             CALL  ERD__HRR_MATRIX
     +
     +                  ( NROTHRR,NCOLHRR,
     +                    NXYZFT,NXYZC,NXYZQ,
     +                    SHELLC,SHELLD,SHELLQ,
     +                    NCDCOOR,
     +                    CDX,CDY,CDZ,
     +                    ICORE (IHSCR),
     +
     +                             POS1,POS2,
     +                             NROWHRR,
     +                             ICORE (IHNROW),
     +                             ICORE (IHROW),
     +                             ZCORE (ZHROT) )
     +
     +
C             WRITE (*,*) ' Finished HRR f0 matrix '

             CALL  ERD__HRR_TRANSFORM
     +
     +                  ( NCTR*NXYZET,
     +                    NROWHRR,NXYZFT,NXYZC*NXYZD,
     +                    NXYZC,NXYZD,
     +                    ICORE (IHNROW+POS1-1),
     +                    ICORE (IHROW+POS2-1),
     +                    ZCORE (ZHROT+POS2-1),
     +                    ZCORE (IN),
     +
     +                             ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished HRR f0 '

             TEMP = IN
             IN = OUT
             OUT = TEMP

             IF (SHELLD.GT.1) THEN
                 IF (SPHERIC) THEN
                     CALL  ERD__SPHERICAL_TRANSFORM
     +
     +                          ( NCTR*NXYZET*NXYZC,
     +                            NROWD,NXYZD,NRYD,
     +                            ICORE (ISNROWD),
     +                            ICORE (ISROWD),
     +                            ZCORE (ZSROTD),
     +                            ZCORE (IN),
     +
     +                                    ZCORE (OUT) )
     +
     +
C                     WRITE (*,*) ' Finished sph quart d '
                     TEMP = IN
                     IN = OUT
                     OUT = TEMP
                 ELSE
                     CALL  ERD__NORMALIZE_CARTESIAN
     +
     +                          ( NCTR*NXYZET*NXYZC,
     +                            NXYZD,
     +                            SHELLD,
     +                            ZCORE (ZCNORM),
     +
     +                                    ZCORE (IN) )
     +
     +
C                     WRITE (*,*) ' Finished normalize cart d '
                 END IF
             END IF
         END IF

         IF (NRYD.GT.1) THEN
             NBATCH = NCTR * NXYZET * NXYZC * NRYD
             NOTMOVE = IXOFF (INDEXD)
             MOVE = NBATCH / (NOTMOVE * NRYD)
             IF (MOVE.GT.1) THEN

                 CALL  ERD__MOVE_RY
     +
     +                      ( NBATCH,4,
     +                        NOTMOVE,MOVE,NRYD,
     +                        INDEXD,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry d '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF

         IF (SHELLC.GT.1) THEN
             IF (SPHERIC) THEN
                 CALL  ERD__SPHERICAL_TRANSFORM
     +
     +                      ( NCTR*NXYZET*NRYD,
     +                        NROWC,NXYZC,NRYC,
     +                        ICORE (ISNROWC),
     +                        ICORE (ISROWC),
     +                        ZCORE (ZSROTC),
     +                        ZCORE (IN),
     +
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished sph quart c '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             ELSE
                 CALL  ERD__NORMALIZE_CARTESIAN
     +
     +                      ( NCTR*NXYZET*NRYD,
     +                        NXYZC,
     +                        SHELLC,
     +                        ZCORE (ZCNORM),
     +
     +                                ZCORE (IN) )
     +
     +
C                 WRITE (*,*) ' Finished normalize cart c '
             END IF
         END IF

         IF (NRYC.GT.1) THEN
             NBATCH = NCTR * NRYD * NXYZET * NRYC
             NOTMOVE = IXOFF (INDEXC)
             MOVE = NBATCH / (NOTMOVE * NRYC)
             IF (MOVE.GT.1) THEN

                 CALL  ERD__MOVE_RY
     +
     +                      ( NBATCH,4,
     +                        NOTMOVE,MOVE,NRYC,
     +                        INDEXC,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry c '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF
C
C
C             ...do the second stage of processing the integrals:
C
C                   batch (ijkl[c'd'],e0) --> batch (ijkl[c'd'],ab)
C                   batch (ijkl[c'd'],a,b) --> batch (ijkl[c'd'],a,b')
C                   batch (ijkl[c'd'],a,b') --> batch (ijkl[b'c'd'],a)
C                   batch (ijkl[b'c'd'],a) --> batch (ijkl[b'c'd'],a')
C                   batch (ijkl[b'c'd'],a') --> batch (ijkl[a'b'c'd'])
C
C
         IF (SHELLB.NE.0) THEN

             CALL  ERD__HRR_MATRIX
     +
     +                  ( NROTHRR,NCOLHRR,
     +                    NXYZET,NXYZA,NXYZP,
     +                    SHELLA,SHELLB,SHELLP,
     +                    NABCOOR,
     +                    ABX,ABY,ABZ,
     +                    ICORE (IHSCR),
     +
     +                             POS1,POS2,
     +                             NROWHRR,
     +                             ICORE (IHNROW),
     +                             ICORE (IHROW),
     +                             ZCORE (ZHROT) )
     +
     +
C             WRITE (*,*) ' Finished HRR e0 matrix '

             CALL  ERD__HRR_TRANSFORM
     +
     +                  ( NCTR*NRYC*NRYD,
     +                    NROWHRR,NXYZET,NXYZA*NXYZB,
     +                    NXYZA,NXYZB,
     +                    ICORE (IHNROW+POS1-1),
     +                    ICORE (IHROW+POS2-1),
     +                    ZCORE (ZHROT+POS2-1),
     +                    ZCORE (IN),
     +
     +                             ZCORE (OUT) )
     +
     +
C             WRITE (*,*) ' Finished HRR e0 '
             TEMP = IN
             IN = OUT
             OUT = TEMP

             IF (SHELLB.GT.1) THEN
                 IF (SPHERIC) THEN
                     CALL  ERD__SPHERICAL_TRANSFORM
     +
     +                          ( NCTR*NRYC*NRYD*NXYZA,
     +                            NROWB,NXYZB,NRYB,
     +                            ICORE (ISNROWB),
     +                            ICORE (ISROWB),
     +                            ZCORE (ZSROTB),
     +                            ZCORE (IN),
     +
     +                                    ZCORE (OUT) )
     +
     +
C                     WRITE (*,*) ' Finished sph quart b '
                     TEMP = IN
                     IN = OUT
                     OUT = TEMP
                 ELSE
                     CALL  ERD__NORMALIZE_CARTESIAN
     +
     +                          ( NCTR*NRYC*NRYD*NXYZA,
     +                            NXYZB,
     +                            SHELLB,
     +                            ZCORE (ZCNORM),
     +
     +                                    ZCORE (IN) )
     +
     +
C                     WRITE (*,*) ' Finished normalized cart b '
                 END IF
             END IF
         END IF

         IF (NRYB.GT.1) THEN
             NBATCH = NCTR * NRYC * NRYD * NXYZA * NRYB
             NOTMOVE = IXOFF (INDEXB)
             MOVE = NBATCH / (NOTMOVE * NRYB)
             IF (MOVE.GT.1) THEN

                 CALL  ERD__MOVE_RY
     +
     +                      ( NBATCH,4,
     +                        NOTMOVE,MOVE,NRYB,
     +                        INDEXB,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry b '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF

         IF (SHELLA.GT.1) THEN
             IF (SPHERIC) THEN
                 CALL  ERD__SPHERICAL_TRANSFORM
     +
     +                      ( NCTR*NRYB*NRYC*NRYD,
     +                        NROWA,NXYZA,NRYA,
     +                        ICORE (ISNROWA),
     +                        ICORE (ISROWA),
     +                        ZCORE (ZSROTA),
     +                        ZCORE (IN),
     +
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished sph quart a '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             ELSE
                 CALL  ERD__NORMALIZE_CARTESIAN
     +
     +                      ( NCTR*NRYB*NRYC*NRYD,
     +                        NXYZA,
     +                        SHELLA,
     +                        ZCORE (ZCNORM),
     +
     +                                ZCORE (IN) )
     +
     +
C                 WRITE (*,*) ' Finished normalized cart a '
             END IF
         END IF

         NBATCH = NCTR * NRYB * NRYC * NRYD * NRYA

         IF (NRYA.GT.1) THEN
             NOTMOVE = IXOFF (INDEXA)
             MOVE = NBATCH / (NOTMOVE * NRYA)
             IF (MOVE.GT.1) THEN

                 CALL  ERD__MOVE_RY
     +
     +                      ( NBATCH,4,
     +                        NOTMOVE,MOVE,NRYA,
     +                        INDEXA,
     +                        TILE,
     +                        ZCORE (IN),
     +
     +                                IXOFF,
     +                                ZCORE (OUT) )
     +
     +
C                 WRITE (*,*) ' Finished move ry a '
                 TEMP = IN
                 IN = OUT
                 OUT = TEMP
             END IF
         END IF
C
C
C             ...set final pointer to integrals in ZCORE array.
C
C
         NFIRST = IN
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine writes a character string to the job archive.

c WARNING!
c    The "record length" that gets associated with the logical record is the
c number of whole integers that contain the string. Therefore, calling getrec
c with the query flag may not return the actual length of the string.

c INPUT
c int      XFLAG     : (same as putrec)
c char*(*) SZARCHIVE : (same as putrec)
c char*(*) SZRECNAME : (same as putrec)
c int      ILENGTH   : the substring-length of the record to store
c char*(*) SZSRC     : (same as putrec)

#define _MAXLEN 256 /* 1024 or 2048 characters */

#ifdef F_64BIT
#  define _IINTLN 8
#else
#  define _IINTLN 4
#endif

      subroutine putcrec(xFlag,szArchive,szRecName,iLength,szSrc)
      implicit none

c ARGUMENTS
      integer xFlag, iLength
      character*(*) szArchive, szRecName, szSrc

c INTERNAL VARIABLES
      integer i, iNdx, nLeft, iBuf(_MAXLEN), iRecLen

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert substring fits in iBuf
      if (iLength.gt.(_MAXLEN*_IINTLN)) then
         print *, '@PUTCREC: Assertion failed.'
         print *, '   iLength = ',iLength
         print *, '   maximum = ',_MAXLEN*_IINTLN
         i = 1
      endif
c   o assert substring is within szSrc
      if (len(szSrc).lt.iLength) then
         print *, '@PUTCREC: Assertion failed.'
         print *, '   iLength = ',iLength
         print *, '   len(sz) = ',len(szSrc)
         i = 1
      endif
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o iNdx is the moving szSrc index
      iNdx = 1

c   o iRecLen is the number of whole integers that contain szSrc(1:iLength)
c     (residual handled later)
      iRecLen = iLength/_IINTLN

c   o the format definition for reading whole integers from szSrc
 10   format(a _IINTLN)

c   o read from szSrc into iBuf by whole integers
      if (iRecLen.gt.0) then
         do i = 1, iRecLen
            read(szSrc(iNdx:iNdx+_IINTLN-1),10) iBuf(i)
            iNdx = iNdx + _IINTLN
         end do
      end if

c   o pick up the slack (while flushing the integer with spaces)
      nLeft = iand(iLength,_IINTLN-1)
      if (nLeft.ne.0) then
         iRecLen = iRecLen + 1
         read(szSrc(iNdx:iNdx+nLeft-1),10) iBuf(iRecLen)
      end if

c   o write to the job archive
      call putrec(xFlag,szArchive,szRecName,iRecLen,iBuf)

      return
c     end subroutine putcrec
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C CALCULATES THE VECTOR V BETWEEN CARTESIAN POINTS A AND B

      SUBROUTINE VEC(A,B,V,IX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(3),B(3),V(3)
      V(1)=B(1)-A(1)
      V(2)=B(2)-A(2)
      V(3)=B(3)-A(3)
C
C This block is added to avoid calling NORMAL when
C the vector is null, Ajith Perera, 10/2010
C
      D2 = 0.0D0
      Do I = 1, 3
         D2 = D2 + V(i)**2
      Enddo
      D2sqrt = Dsqrt(D2)
      If (D2sqrt .LT. 1.0D-14) Then
         Write(6,"(a)") "@-VEC: The null vector is returned"
         Call Errex
      Endif
C
      IF(IX.EQ.1)CALL NORMAL(V,3)
      RETURN
      END 

c This routine returns the first index in sz of any single char appearing in
c charset. WARNING: Since Fortran pads the end of all strings with spaces,
c be sure to pass only the relevant substring.

#define SZ_BUF      256
#define CHARSET_BUF 32

      integer function fortran_strpbrk(sz,charset)
      implicit none

      character*(*) sz, charset

      character*(SZ_BUF)      sz2
      character*(CHARSET_BUF) charset2

      character*1 achar
      integer fortran_strpbrk_core

      if (len(sz).ge.SZ_BUF) then
         print *, '@FORTRAN_STRPBRK: The sz buffer is too small ',
     &            'to contain the input string.'
         print *, '                  Recompile with at least ',
     &            len(sz)+1, ' characters in the buffer.'
         print *, '                  (Currently ',SZ_BUF,' characters.)'
         call exit(1)
      end if
      if (len(charset).ge.CHARSET_BUF) then
         print *, '@FORTRAN_STRPBRK: The charset buffer is too small ',
     &            'to contain the input string.'
         print *, '                  Recompile with at least ',
     &            len(charset)+1, ' characters in the buffer.'
         print *, '                  (Currently ',CHARSET_BUF,
     &                                                   ' characters.)'
         call exit(1)
      end if

      sz2      = sz//achar(0)
      charset2 = charset//achar(0)

c      print *, 'sz is ',len(sz),' chars long'
c      print *, 'charset is ',len(charset),' chars long'

      fortran_strpbrk = fortran_strpbrk_core(sz2,charset2)

      return
      end

c This routine returns the DACOS of VALUE. If VALUE is within THRESH of 1.d0 or
c -1.d0, then VALUE is set to (-)1.d0 and the DACOS is evaluated and returned.

      double precision function dacosx(dValue,dThresh)
      implicit none
      double precision dValue, dThresh
      if (dabs(dabs(dValue)-1.d0).lt.dThresh) dValue=sign(1.d0,dValue)
      dacosx=dacos(dValue)
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK DTRMV
      SUBROUTINE DTRMV (UPLO, TRANS, DIAG, N, A, LDA, X, INCX)
C***BEGIN PROLOGUE  DTRMV
C***PURPOSE  Perform one of the matrix-vector operations.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1B4
C***TYPE      DOUBLE PRECISION (STRMV-S, DTRMV-D, CTRMV-C)
C***KEYWORDS  LEVEL 2 BLAS, LINEAR ALGEBRA
C***AUTHOR  Dongarra, J. J., (ANL)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  DTRMV  performs one of the matrix-vector operations
C
C     x := A*x,   or   x := A'*x,
C
C  where x is an n element vector and  A is an n by n unit, or non-unit,
C  upper or lower triangular matrix.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the matrix is an upper or
C           lower triangular matrix as follows:
C
C              UPLO = 'U' or 'u'   A is an upper triangular matrix.
C
C              UPLO = 'L' or 'l'   A is a lower triangular matrix.
C
C           Unchanged on exit.
C
C  TRANS  - CHARACTER*1.
C           On entry, TRANS specifies the operation to be performed as
C           follows:
C
C              TRANS = 'N' or 'n'   x := A*x.
C
C              TRANS = 'T' or 't'   x := A'*x.
C
C              TRANS = 'C' or 'c'   x := A'*x.
C
C           Unchanged on exit.
C
C  DIAG   - CHARACTER*1.
C           On entry, DIAG specifies whether or not A is unit
C           triangular as follows:
C
C              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
C
C              DIAG = 'N' or 'n'   A is not assumed to be unit
C                                  triangular.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular matrix and the strictly lower triangular part of
C           A is not referenced.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular matrix and the strictly upper triangular part of
C           A is not referenced.
C           Note that when  DIAG = 'U' or 'u', the diagonal elements of
C           A are not referenced either, but are assumed to be unity.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the n
C           element vector x. On exit, X is overwritten with the
C           transformed vector x.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C***REFERENCES  Dongarra, J. J., Du Croz, J., Hammarling, S., and
C                 Hanson, R. J.  An extended set of Fortran basic linear
C                 algebra subprograms.  ACM TOMS, Vol. 14, No. 1,
C                 pp. 1-17, March 1988.
C***ROUTINES CALLED  LSAME, XERBLA
C***REVISION HISTORY  (YYMMDD)
C   861022  DATE WRITTEN
C   910605  Modified to meet SLATEC prologue standards.  Only comment
C           lines were modified.  (BKS)
C***END PROLOGUE  DTRMV
C     .. Scalar Arguments ..
      INTEGER            INCX, LDA, N
      CHARACTER*1        DIAG, TRANS, UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * )
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JX, KX
      LOGICAL            NOUNIT
C     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
C     .. External Subroutines ..
      EXTERNAL           XERBLA
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C***FIRST EXECUTABLE STATEMENT  DTRMV
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.LSAME( UPLO , 'U' ).AND.
     $         .NOT.LSAME( UPLO , 'L' )      )THEN
         INFO = 1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ).AND.
     $         .NOT.LSAME( TRANS, 'T' ).AND.
     $         .NOT.LSAME( TRANS, 'C' )      )THEN
         INFO = 2
      ELSE IF( .NOT.LSAME( DIAG , 'U' ).AND.
     $         .NOT.LSAME( DIAG , 'N' )      )THEN
         INFO = 3
      ELSE IF( N.LT.0 )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DTRMV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( N.EQ.0 )
     $   RETURN
C
      NOUNIT = LSAME( DIAG, 'N' )
C
C     Set up the start point in X if the increment is not unity. This
C     will be  ( N - 1 )*INCX  too small for descending loops.
C
      IF( INCX.LE.0 )THEN
         KX = 1 - ( N - 1 )*INCX
      ELSE IF( INCX.NE.1 )THEN
         KX = 1
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through A.
C
      IF( LSAME( TRANS, 'N' ) )THEN
C
C        Form  x := A*x.
C
         IF( LSAME( UPLO, 'U' ) )THEN
            IF( INCX.EQ.1 )THEN
               DO 20, J = 1, N
                  IF( X( J ).NE.ZERO )THEN
                     TEMP = X( J )
                     DO 10, I = 1, J - 1
                        X( I ) = X( I ) + TEMP*A( I, J )
   10                CONTINUE
                     IF( NOUNIT )
     $                  X( J ) = X( J )*A( J, J )
                  END IF
   20          CONTINUE
            ELSE
               JX = KX
               DO 40, J = 1, N
                  IF( X( JX ).NE.ZERO )THEN
                     TEMP = X( JX )
                     IX   = KX
                     DO 30, I = 1, J - 1
                        X( IX ) = X( IX ) + TEMP*A( I, J )
                        IX      = IX      + INCX
   30                CONTINUE
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )*A( J, J )
                  END IF
                  JX = JX + INCX
   40          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 60, J = N, 1, -1
                  IF( X( J ).NE.ZERO )THEN
                     TEMP = X( J )
                     DO 50, I = N, J + 1, -1
                        X( I ) = X( I ) + TEMP*A( I, J )
   50                CONTINUE
                     IF( NOUNIT )
     $                  X( J ) = X( J )*A( J, J )
                  END IF
   60          CONTINUE
            ELSE
               KX = KX + ( N - 1 )*INCX
               JX = KX
               DO 80, J = N, 1, -1
                  IF( X( JX ).NE.ZERO )THEN
                     TEMP = X( JX )
                     IX   = KX
                     DO 70, I = N, J + 1, -1
                        X( IX ) = X( IX ) + TEMP*A( I, J )
                        IX      = IX      - INCX
   70                CONTINUE
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )*A( J, J )
                  END IF
                  JX = JX - INCX
   80          CONTINUE
            END IF
         END IF
      ELSE
C
C        Form  x := A'*x.
C
         IF( LSAME( UPLO, 'U' ) )THEN
            IF( INCX.EQ.1 )THEN
               DO 100, J = N, 1, -1
                  TEMP = X( J )
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 90, I = J - 1, 1, -1
                     TEMP = TEMP + A( I, J )*X( I )
   90             CONTINUE
                  X( J ) = TEMP
  100          CONTINUE
            ELSE
               JX = KX + ( N - 1 )*INCX
               DO 120, J = N, 1, -1
                  TEMP = X( JX )
                  IX   = JX
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 110, I = J - 1, 1, -1
                     IX   = IX   - INCX
                     TEMP = TEMP + A( I, J )*X( IX )
  110             CONTINUE
                  X( JX ) = TEMP
                  JX      = JX   - INCX
  120          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 140, J = 1, N
                  TEMP = X( J )
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 130, I = J + 1, N
                     TEMP = TEMP + A( I, J )*X( I )
  130             CONTINUE
                  X( J ) = TEMP
  140          CONTINUE
            ELSE
               JX = KX
               DO 160, J = 1, N
                  TEMP = X( JX )
                  IX   = JX
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 150, I = J + 1, N
                     IX   = IX   + INCX
                     TEMP = TEMP + A( I, J )*X( IX )
  150             CONTINUE
                  X( JX ) = TEMP
                  JX      = JX   + INCX
  160          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of DTRMV .
C
      END

C Read Cartesian coordinates from Z-matrix

      SUBROUTINE GETXYZ
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

#include "mxatms.par"
#include "io_units.par"
#include "linelen.par"
      DOUBLE PRECISION BTOA
      PARAMETER (BTOA=0.529177249d0)

C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
#include "coord_dup.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
#include "machsp.com"

C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol

      double precision xyz(3,mxatms)
      integer izl(2,7), iStruct
      CHARACTER*(linelen) ZLINE
      logical btmp, bStruct, bAtom

c ----------------------------------------------------------------------

c   o scaling factor for Angstoms to Bohr
      FACTOR = 1.d0 / BTOA

c   o open up the main input file
      open(LuZ,FILE=ZFil,FORM='FORMATTED',STATUS='OLD')
      rewind LuZ

c   o skip the header (zline=TITLE on end do)
      btmp = .true.
      do while (btmp)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         i = izl(1,1)
         btmp = (i.eq.0).or.(zline(i:i).eq.'%')
      end do
      call putcrec(1,' ','TITLE',80,zline(1:80))

c   o load the first structure (reactant) into Q and ZSYM
      ndx = 0
      bAtom = .true.
      do while (bAtom)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         if (izl(1,1).ne.0) then
c         o increment atom counter
            ndx = ndx + 1
            if (ndx.gt.mxatms) then
               print *, '@GETXYZ: Primary structure exceeds the ',
     &                  'maximum number of atoms (',mxatms,')'
               call errex
            end if
c         o load the symbol
            if (izl(2,1).gt.izl(1,1)+1) then
               print *, '@GETXYZ: Symbol token is invalid'
               print *, '         atom ',ndx,' = "',
     &                  zline(izl(1,1):izl(2,1)),'"'
               call errex
            end if
            zsym(ndx)=zline(izl(1,1):izl(2,1))
c         o load the coordinates
            if (izl(1,2).eq.0.or.izl(1,3).eq.0.or.
     &          izl(1,4).eq.0.or.izl(1,5).ne.0    ) then
               print *, '@GETXYZ: Error in XYZ coordinates'
               print *, '         atom ',ndx,': ',zline
               call errex
            end if
            read(zline(izl(1,2):izl(2,4)),*) (q(i,ndx),i=1,3)
         else
            bAtom = .false.
         end if
c     end do while (bAtom)
      end do

c   o process the reactant as the main structure
      if (ndx.eq.0) then
         print *, '@GETXYZ: Missing XYZ coordinates'
         call errex
      end if
      natoms = ndx
      nx = 3*natoms
      if (iflags(78).eq.0) call xscal(nx,factor,q,1)
      call pertable

c   o flush remaining atom slots
      if (natoms.lt.mxatms) then
         i = 3*(mxatms-natoms)
         call zero(q(1,natoms+1),i)
         do i = natoms+1, mxatms
            zsym(i) = ' '
         end do
      end if

c   o read additional structures into xyz until we hit a namelist
c     (iStruct corresponds to the structure we expect to read)
      iStruct = 1
      bStruct = .true.
      do while (bStruct.and.iStruct.lt.3)
         iStruct = iStruct + 1
         ndx = 0
         bAtom = .true.
         do while (bAtom)
c         o only read the first line of the secondary structure
            if (ndx.ne.0.or.iStruct.eq.2) then
               read(luz,'(a)') zline
               call parsez(zline,izl)
            end if
            i = izl(1,1)
            if (i.ne.0.and.(ndx.ne.0.or.zline(i:i).ne.'*')) then
c            o increment atom counter
               ndx = ndx + 1
               if (ndx.gt.natoms) then
                  print *, '@GETXYZ: Structure ',iStruct,' has more ',
     &                     'atoms than the primary structure.'
                  print *, '         atom ',ndx,': ',zline
                  call errex
               end if
c            o make sure the symbol is the same
               if (zsym(ndx).ne.zline(izl(1,1):izl(2,1))) then
                  print *, '@GETXYZ: Atoms do not match'
                  print *, '         ',zsym(ndx),' != "',
     &                     zline(izl(1,1):izl(2,1)),'"'
                  call errex
               end if
c            o load the coordinates
               if (izl(1,2).eq.0.or.izl(1,3).eq.0.or.
     &             izl(1,4).eq.0.or.izl(1,5).ne.0    ) then
                  print *, '@GETXYZ: Error in XYZ coordinates'
                  print *, '         structure ',iStruct
                  print *, '         atom ',ndx,': ',zline
                  call errex
               end if
               read(zline(izl(1,2):izl(2,4)),*) (xyz(i,ndx),i=1,3)
            else
               bAtom = .false.
               if (ndx.eq.0) then
c               o we hit a namelist or another blank line
                  bStruct = .false.
               else
c               o compare this structure to the primary structure
                  if (ndx.ne.natoms) then
                     print *, '@GETXYZ: Structure ',iStruct,' has ',
     &                        'fewer atoms than structure 1'
                     call errex
                  end if
               end if
            end if
c        end do while (bAtom)
         end do
         if (bStruct) then
            if (iStruct.eq.2) then
c            o read the next line and see if this structure was the TS or PR
               read(luz,'(a)') zline
               call parsez(zline,izl)
               i = izl(1,1)
               btmp = (i.eq.0.or.zline(i:i).eq.'*')
            else
               btmp = .true.
            end if
            if (iprnt.gt.1
#ifdef _DEBUG
     &          .or..true.
#endif
     &         ) then
               if (btmp) then
                  print *, 'Product structure:'
               else
                  print *, 'Transition-state structure:'
               end if
               do ndx = 1, natoms
                  print *, zsym(ndx),(xyz(i,ndx),i=1,3)
               end do
c           end if (print structures)
            end if
            if (iflags(78).eq.0) call xscal(nx,factor,xyz,1)
            if (btmp) then
               call putrec(1,'JOBARC','PRSTRUCT',nx*iintfp,xyz)
            else
c            o move Q to RXSTRUCT since we are optimizing the TS structure
               call putrec(1,'JOBARC','RXSTRUCT',nx*iintfp,q)
               call dcopy(nx,xyz,1,q,1)
            end if
c        end if (bStruct)
         end if
c     end do while (bStruct)
      end do

      RETURN
      END

      Subroutine projec_IFC(HESS, PHESS, PMAT, GMATRX_N, GMATRX_M,
     &                      GRD, NXM6)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include <machsp.com>
C
      Dimension HESS(NXM6, NXM6), PMAT(NXM6, NXM6), PHESS(NXM6, NXM6),
     &          GMATRX_M(NXM6, NXM6), GMATRX_N(NXM6, NXM6),
     &          GRD(NXM6)
 
      LENGMAT=NXM6*NXM6
      CALL GETREC(20,'JOBARC','GI-MATRX',LENGMAT*IINTFP,GMATRX_M)
      CALL GETREC(20,'JOBARC','G-MATRX ',LENGMAT*IINTFP,GMATRX_N)

      Call XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, GMATRX_M, 
     &            NXM6, GMATRX_N, NXM6, 0.0D0, PMAT, NXM6)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a)") "The Hessian projector:P"
      CALL OUTPUT(PMAT, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)

#endif
C
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PMAT,
     &            NXM6, HESS, NXM6, 0.0D0, PHESS, NXM6)
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, PMAT, NXM6, 0.0D0, HESS, NXM6)

#ifdef _DEBUG_HESSIAN_PROJC
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The (PHP)(PHP)t matrix"
      CALL OUTPUT(HESS, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
C
      CALL EIG(HESS, PHESS, NXM6, NXM6, 1)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a)") "The eigen vectors of the PHP"
      CALL OUTPUT(phess, 1, nxm6, 1, nxM6, nxm6, nxm6, 1)
      Write(6,"(a)") "The eigenvalues of the PHP "
      Write(6, "(4F10.5)") (Hess(I,I), I=1, Nxm6)
#endif
      DO I = 1, NXM6
         IF (HESS(I, I) .LE. 1.0D-10) THEN
             HESS(I, I) = 0.0D0
         ELSE
             HESS(I, I) = 1.0D0/HESS(I, I)
         ENDIF
      ENDDO
C
C Built the generalized inverse of H-matrix,
C
      CALL XGEMM('N', 'N', NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, HESS, NXM6, 0.0D0, GMATRX_N, NXM6)
      CALL XGEMM('N', 'T', NXM6, NXM6, NXM6, 1.0D0, GMATRX_N,
     &            NXM6, PHESS, NXM6, 0.0D0, HESS, NXM6)
C
C Built P(PHP)-P 
C
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PMAT,
     &            NXM6, HESS, NXM6, 0.0D0, PHESS, NXM6)
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, PMAT, NXM6, 0.0D0, HESS, NXM6)
C
C---These steps require defining STEP and TMP arrays.
C
      CALL XGEMM("N", "N", NXM6, 1, NXM6, -1.0D0, HESS,
     &            NXM6, GRD, NXM6, 0.0D0, STEP, NXM6)
      NULLEVAL=8
      CALL GETREC(20,'JOBARC','REDEVECS',NULLEVAL*TOTREDNCO*IINTFP,
     &            GMATRX_N)
      CALL XGEMM('T', 'N', 8, 1, TOTREDNCO, 1.0D0,
     &               GMATRX_N, TOTREDNCO, R, TOTREDNCO,
     &               0.0D0, TMP, 8)
     
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The step and overlap with the red. space"
      Write(6, "(8F10.5)") (Step(I), I=1, Nxm6)
      Write(6, "(8F10.5)") (TMP(I), I=1, 8)
#endif
      STOP
#endif
      RETURN
      END
     

      Subroutine projec_IFC(HESS, PHESS, PMAT, GMATRX_N, GMATRX_M,
     &                      GRD, NXM6)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end









C
      Dimension HESS(NXM6, NXM6), PMAT(NXM6, NXM6), PHESS(NXM6, NXM6),
     &          GMATRX_M(NXM6, NXM6), GMATRX_N(NXM6, NXM6),
     &          GRD(NXM6)
 
      LENGMAT=NXM6*NXM6
      CALL GETREC(20,'JOBARC','GI-MATRX',LENGMAT*IINTFP,GMATRX_M)
      CALL GETREC(20,'JOBARC','G-MATRX ',LENGMAT*IINTFP,GMATRX_N)

      Call XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, GMATRX_M, 
     &            NXM6, GMATRX_N, NXM6, 0.0D0, PMAT, NXM6)
C
C
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PMAT,
     &            NXM6, HESS, NXM6, 0.0D0, PHESS, NXM6)
      CALL XGEMM("N", "N", NXM6, NXM6, NXM6, 1.0D0, PHESS,
     &            NXM6, PMAT, NXM6, 0.0D0, HESS, NXM6)

      RETURN
      END
     

c This routine prints the elapsed time.

c INPUT
c    integer i : behavior flag
c              = 0 ; record the wall clock for future use
c             != 0 ; print the elapsed time since zclock(0) was called

#define PRINT_ZCLOCK_INFO
c#define _DEBUG_ZCLOCK

      subroutine zclock(i)
      implicit none

#include "aces.h"
#include "timeinfo.com"

      integer i

      double precision sc,                 percent
      integer          hc, mc, hw, mw, sw, wall
      integer itmp

      integer days(12), day0, day
      data days /0,31,59,90,120,151,181,212,243,273,304,334/

      logical set_up
      data set_up /.false./

      integer             y0,mo0,d0,h0,mi0,s0
      double precision                        cpu0
      common /zclock_com/ y0,mo0,d0,h0,mi0,s0,cpu0
      save   /zclock_com/

      integer y, mo, d, h, mi, s
      double precision cpu

c ----------------------------------------------------------------------

      if (i.eq.0) then
         call wallclock(y0,mo0,d0,h0,mi0,s0)
         call timer(1)
         cpu0 = timenow
         set_up = .true.
         return
      end if

      if (.not.set_up) then
         write(*,*) '@ZCLOCK: zclock called before proper set up'
         return
      end if

      call wallclock(y,mo,d,h,mi,s)
      call timer(1)

#ifdef _DEBUG_ZCLOCK
      write(*,*) '@ZCLOCK: cpu0 = ',cpu0,' and timenow = ',timenow
      write(*,*) '         wall0 = ',y0,mo0,d0,h0,mi0,s0
      write(*,*) '         wall1 = ',y, mo, d, h, mi, s
#endif

c   o SYSTEM TIME
      cpu  = timenow - cpu0
      hc   = cpu / 3600.0
      itmp = -3600 * hc
      mc   = ( cpu + itmp ) / 60.0
      sc   = cpu + itmp + ( -60 * mc )

c   o USER TIME
      if ((mo0.gt.2).and.(mod(y0,4).eq.0)) then
         day0 = days(mo0) + d0 + 1
      else
         day0 = days(mo0) + d0
      end if
      if ((mo .gt.2).and.(mod(y ,4).eq.0)) then
         day = days(mo ) + d  + 1
      else
         day = days(mo ) + d
      end if
c     Calculations longer than one year are improbable and not supported.
      if (y0.ne.y) day = day + 365

      wall =   (day - day0 )*86400
     &       + (h   - h0   )*3600
     &       + (mi  - mi0  )*60
     &       + (s   - s0   )
      hw   = wall / 3600
      itmp = -3600 * hw
      mw   = ( wall + itmp ) / 60
      sw   = wall + itmp + ( -60 * mw )

      if (wall.gt.0) then
         percent = ( cpu / wall ) * 100.0
      else
         percent = 100.0
      endif

#ifdef PRINT_ZCLOCK_INFO
c      print 9000,hc,mc,sc,hw,mw,sw,percent
c 9000    format('  cpu time:', I4,' h ',I2,' min ',F5.2,' sec;  ',
c     &   'real time:', I4,' h ',I2,' min ',I2,' sec  (',F5.1,'%)'/)
c        CPU TIME: 999 H 23 MIN 65.32 SEC   REAL TIME: 999 H 23 MIN 76
c        SEC  (100.0%)

      itmp = cpu
      write(*,9000) '  AME TIMING:  ',
     &   'cpu ', hc,':',mc,':',sc,' (',itmp,') ;  ',
     &   'real ',hw,':',mw,':',sw,' (',wall,')'
 9000 format(a,
     &       1(a,i4,a,i2,a,f5.2,a,i8,a),
     &       1(a,i4,a,i2,a,i2  ,a,i8,a)
     &      )

#endif /* PRINT_ZCLOCK_INFO */

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ASSIGN_ANGLS(CARTCOORD, IBNDTO, IREDUNCO, TOTREDNCO,
     &                        TOTNOFBND, TOTNOFANG, NRATMS, MAXREDUNCO, 
     &                        THRESHOLD)
C
C This routine setup the connectivity array to define bond angles. This
C array is dimensioned to (4, MAXREDUNCO).
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     DOUBLE PRECISION DFLOAT
      LOGICAL USE1, USE2, MULAOK
C
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG
      DIMENSION IREDUNCO(4, MAXREDUNCO), IBNDTO(NRATMS,NRATMS),
     &          CARTCOORD(3*NRATMS)

      DATA IZERO /0/, MTWO /-2/, MONE /-1/
C     
      PI        = 180.0D0
      TOTNOFBND = TOTREDNCO
      TOTNOFANG = IZERO
      MULAOK    = .FALSE. 
C
      DO 10 IBNDS = 2, TOTNOFBND
         IBND1 = IREDUNCO(1, IBNDS)
         IBND2 = IREDUNCO(2, IBNDS)
C         
cSSS         IF (IBND2 .GT. IZERO) THEN
cSSS            USE1 = .TRUE.
cSSS            USE2 = .TRUE.
cSSS         END IF 
C           
         DO 20 JBNDS = 1, IBNDS - 1
C
            IF (IBND2 .GT. IZERO) THEN
               USE1 = .TRUE. 
               USE2 = .TRUE.
            END IF
C
            JBND1 = IREDUNCO(1, JBNDS)
            JBND2 = IREDUNCO(2, JBNDS)
            
C I'll have to check connections from ICON1,2,3...
               
            IF (JBND2 .GT. IZERO) THEN
               IF (IBND1 .EQ. JBND1 .AND. USE1) THEN
                  ICON1 = IBND2
                  ICON2 = IBND1
                  ICON3 = JBND2
                  USE1  = MULAOK
               ELSE IF (IBND1 .EQ. JBND2 .AND. USE1) THEN
                  ICON1 = JBND1
                  ICON2 = IBND1
                  ICON3 = IBND2
                  USE1  = MULAOK
               ELSE IF (IBND2 .EQ. JBND1 .AND. USE2) THEN
                  ICON1 = IBND1
                  ICON2 = IBND2
                  ICON3 = JBND2
                  USE2  = MULAOK
               ELSE IF (IBND2 .EQ. JBND2 .AND. USE2) THEN
                  ICON1 = JBND1
                  ICON2 = IBND2
                  ICON3 = IBND1
                  USE2  = MULAOK 
               ELSE
                  GO TO 20
C
C I wish I could avoid this GoTo Statement!
C
               ENDIF
            ENDIF
C     
C For linear bonds, we need to generate two redundant coordinates for 
C for the same centers (ICON1, ICON2 and ICON3). The VLUANGLE is 
C returned in degrees from CMP_ANGLE. 
C     
            CALL CMP_ANGLE(ICON1, ICON2, ICON3, CARTCOORD, 
     &                     VLUANGLE, NRATMS)
C     
            IF (ABS(VLUANGLE - PI) .LE. THRESHOLD) THEN
                IBNDTO(ICON3, ICON1) = -99 
C
                DO 30 LBNDS = 1, NRATMS
                   IF (LBNDS .NE. ICON1 .AND. LBNDS .NE. ICON2
     &                 .AND. LBNDS .NE. ICON3) THEN

                      IF (IBNDTO(LBNDS, ICON3) .NE. IZERO) THEN
                         CALL CMP_ANGLE(ICON1, ICON3, LBNDS,
     &                                  CARTCOORD, VLUANGLE, 
     &                                  NRATMS)
                         IF (ABS(VLUANGLE - PI) .LE. THRESHOLD)
     &                   THEN
                            IBNDTO(LBNDS, ICON1) = -99
                            IBNDTO(LBNDS, ICON2) = -99
                         ENDIF
C
                      ELSE IF (IBNDTO(LBNDS, ICON1) .NE. IZERO) THEN
                         CALL CMP_ANGLE(LBNDS, ICON1, ICON3,
     &                                  CARTCOORD, VLUANGLE,
     &                                  NRATMS) 
                         IF (ABS(VLUANGLE - PI) .LE. THRESHOLD)
     &                   THEN
                            IBNDTO(ICON2, LBNDS) = -99
                            IBNDTO(ICON3, LBNDS) = -99
   
                            IF (ICON2 .GT. LBNDS)
     &                      IBNDTO(LBNDS, ICON2) = -99
                            IF (ICON3 .GT. LBNDS) 
     &                      IBNDTO(LBNDS, ICON3) = -99
                         ENDIF
C
                      ENDIF
                   ENDIF
C
 30             CONTINUE
C
                DO 40 LBNDS = 1, NRATMS
                   IF (LBNDS .NE. ICON1 .AND. LBNDS .NE. ICON2
     &                .AND. LBNDS .NE. ICON3 .AND.
     &                (IBNDTO(LBNDS, ICON2) .GT. IZERO)) GO TO 20
C
C Once again I would have prefered to avoid this GoTo statement!
C
 40             CONTINUE
                
                TOTNOFANG = TOTNOFANG + 1
                IREDUNCO(1, TOTNOFANG + TOTREDNCO) =
     &                   MIN0(ICON1, ICON3)
                IREDUNCO(2, TOTNOFANG + TOTREDNCO) = ICON2
                IREDUNCO(3, TOTNOFANG + TOTREDNCO) =
     &                   MAX0(ICON1, ICON3)
                IREDUNCO(4, TOTNOFANG + TOTREDNCO) = MONE
C     
             ELSE
                ICON4 = MTWO
             ENDIF
C
             TOTNOFANG = TOTNOFANG + 1
             IREDUNCO(1, TOTNOFANG + TOTREDNCO) =
     &                MIN0(ICON1, ICON3)
             IREDUNCO(2, TOTNOFANG + TOTREDNCO) = ICON2
             IREDUNCO(3, TOTNOFANG + TOTREDNCO) = 
     &                MAX0(ICON1, ICON3)
             IREDUNCO(4, TOTNOFANG + TOTREDNCO) = MTWO
             
 20       CONTINUE
 10    CONTINUE
C
      TOTREDNCO = TOTREDNCO + TOTNOFANG
C
      IF (TOTREDNCO .GE. MAXREDUNCO) THEN
        WRITE(6, 99)
 99     FORMAT(T3,'assign_angles: Maximum No. of redundant ',
     &         'coordinates allowed',
     &         '/', 'exceeded')
        print *,' Required:',TOTREDNCO,' Current Maximum:',MAXREDUNCO
        CALL ERREX
      ENDIF
C
      RETURN
      END

      SUBROUTINE USQUSH(V,ISIZE)
C
C "UNSQUASHES" A VECTOR OF LENGTH ISIZE.
C
      DOUBLE PRECISION V(ISIZE+6)
      DO 10 I=ISIZE,4,-1
      V(I+6)=V(I)
 10   CONTINUE
      V(8)=V(3)
      V(7)=V(2)
      V(4)=V(1)
      V(9)=0.D0
      V(6)=0.D0
      V(5)=0.D0
      DO 20 I=1,3
      V(I)=0.D0
 20   CONTINUE
      RETURN
      END

c This routine reads the bwdata file. If this file does not exist, then the
c usual CC is performed.

      subroutine bwread(invcc,iuhf)
      logical invcc
      logical bIAmOne
      character*512 line
      character*80 fname
      real*8 s
      integer ilength,nbas
      character*1 z


cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)



      bIAmOne = .true.

c initialize warnings
      do i = 1, maxbwwarnings
         bwwarning(i) = .false.
      end do

      intruder = 1.d300
      open(unit=1,file='intruder',
     &     form='formatted',status='old',err=991)
      read(1,*) intruder
      close(1)
      intruder = abs(intruder)
991   continue
      if (intruder.lt.1.d300.and.bIAmOne) then
         write(6,*)'Intruder limit set to',intruder
      end if

      correctiontype = 0
      open(unit=1,file='correctiontype',
     &     form='formatted',status='old',err=992)
      read(1,*) correctiontype
      close(1)
992   continue

      ihubaccorr = 1
      open(unit=1,file='nohubaccorr',status='old',err=994)
      ihubaccorr = 0
      close(1)
994   continue

      ihomotop = 0
      open(unit=1,file='homotop',
     &     form='formatted',access='sequential',status='old',err=993)
      read(1,*) ihomotop
      read(1,*) lambdahomotop
      read(1,*) diishonset
      hfaktmax = 1.d-6
      read(1,*,end=9931,err=9931) hfaktmax
9931  continue
      close(1)
993   continue
      if (ihomotop.gt.0) then
         ihubaccorr = 0
         if (invcc.and.bIAmOne) then
            write(6,*)
            write(6,*) 'homotopic solution attempted, parameters ',
     &                 ihomotop,lambdahomotop,diishonset,hfaktmax
            write(6,*) 'correction type: ',correctiontype
            write(6,*)
         end if
      end if

      bwgossip = .false.
      open(unit=1,file='bwgossip',status='old',err=995)
      bwgossip = .true.
      close(1)
995   continue
      if (bIAmOne) write(6,*)
      if (bIAmOne) write(6,*)

      isbwcc = .true.
      open(unit=1,file='masik',
     &     form='formatted',access='sequential',status='old',err=998)
      if (bIAmOne) then
         write(6,*) 'performing integral processing for masik program'
      end if
      masik = .true.
      close(1)
      goto 111
998   masik = .false.
111   continue

      open(unit=1,file='bwdata',
     &     form='formatted',access='sequential',status='old',err=999)
      if (invcc) then
         if (bIAmOne) write(6,*) 'running mr-bwcc program'
      else
         if (bIAmOne) then
            write(6,*) 'performing integral processing for mr-bwcc pgm'
         end if
      end if

c we need IUHF before crapsi is called
c vscf will create this file
      open(unit=2,file='IUHF',
     &     form='unformatted',access='sequential',status='old')
      read(2) iuhf
      close(2)

      do j = 1, maxref
      do i = 1, maxorb
         iocc(i,j,1) = 0
         iocc(i,j,2) = 0
      end do
      end do
      do i = 1, maxorb
         iocc0(i,1) = 0
         iocc0(i,2) = 0
      end do
      scfrefread = .false.

c here we read the data
      nref = 0
1     read(1,10,end=2) line
10    format(a512)
      if (bIAmOne) write(6,*) 'input reference: ',line
      if (line(1:3).eq.'SCF' .or. line(1:3).eq.'scf') then
c what we have read in previous was just the SCF configuration
c not a reference configuration
         scfrefread = .true.
         do i = 1, maxorb
            iocc0(i,1)     = iocc(i,nref,1)
            iocc0(i,2)     = iocc(i,nref,2)
            iocc(i,nref,1) = 0
            iocc(i,nref,2) = 0
         end do
      else
         nref = nref+1
      end if
      if (nref.gt.maxref) then
         write(*,*) 'too many references, increase MAXREF'
         call aces_exit(1)
      end if

c process the string into array
      do i = 1, maxorb
         z = line(i:i)
         if (z.eq.'2') then
            iocc(i,nref,1) = 1
            iocc(i,nref,2) = 1
         else
            if (z.eq.'a' .or. z.eq.'b') then
               if (iuhf.eq.0) then
                  write(*,*) 'open shell references not allowed for ',
     &                       'RHF based calculation'
                  call aces_exit(1)
               else
                  if (z.eq.'a') then
                     iocc(i,nref,1) = 1
                  else
                     iocc(i,nref,2) = 1
                  end if
               end if
            else
               if (z.ne.'0'.and.z.ne.' ') then
                  if (bIAmOne) then
                     write(6,*) 'unexpected character "',z,'" in ref.'
                     write(6,*) line
                  end if
                  write(*,*) 'illegal character in configuration ',
     &                       'specification'
                  call aces_exit(1)
               end if
            end if
         end if
      end do
      goto 1
2     close(1)
      if (bIAmOne) then
         write(6,*)
         write(6,*) 'number of bw references: ',nref
         write(6,*)
      end if
      goto 100
999   isbwcc = .false.
      if (invcc) then
         if (bIAmOne) write(6,*) ' running standard cc program'
      else
         if (bIAmOne) then
            write(6,*) 'performing integral processing for standard CC'
         end if
      end if
      close(1)
      nref = 1
c in cc program read and store vacuum energies and diagonal fock corrections
c in intprc this does not exist yet, of course
100   continue

      if (.not.isbwcc) goto 200
      if (invcc) then
c this loop has to be parallelized since FOCKCD was generated only for
c appropriate irefs by xintprc
         do iref = 1, nref
            if (mod(iref-1,1).ne.1-1) goto 1234
            call gfname('FOCKCD  ',fname,ilength)
            open(unit=99,file=fname(1:ilength),
     &           form='unformatted',status='old')
            read(99) nbas
            do is = 1, 1+iuhf
               do i = 1, nbas
                  read(99) fockcd(i,iref,is)
               end do
            end do
            read(99) hdiagcontr(iref)
c read also indices for assignment of offdiagonal heff elements
            if (iuhf.eq.0) then
               ibot = 3
            else
               ibot = 1
            end if
            do is = ibot, 3
               read(99) internnum(iref,is)
               read(99) (internfrom(j,iref,is),
     &                   j=1,(maxref*(maxref-1)/2))
               read(99) (internto(j,iref,is),
     &                   j=1,(maxref*(maxref-1)/2))
               read(99) (internindex(j,iref,is),
     &                   j=1,(maxref*(maxref-1)/2))
            end do
            if (iuhf.ne.0) then
               do is = 1, 2
                  read(99) internnum1(iref,is)
                  read(99) (internfrom1(j,iref,is),
     &                      j=1,(maxref*(maxref-1)/2))
                  read(99) (internto1(j,iref,is),
     &                      j=1,(maxref*(maxref-1)/2))
                  read(99) (internindex1(j,iref,is),
     &                      j=1,(maxref*(maxref-1)/2))
               end do
            end if
            close(99)
1234     end do
      else
c initialize indices for assignment of offdiagonal heff elements
         if (iuhf.eq.0) then
            ibot = 3
         else
            ibot = 1
         end if
         do is = ibot, 3
            do iref = 1, nref
               internnum(iref,is) = 0
               do j = 1, maxref*(maxref-1)/2
                  internindex(j,iref,is) = 0
                  internfrom(j,iref,is)  = 0
                  internto(j,iref,is)    = 0
               end do
            end do
         end do
         if (iuhf.ne.0) then
            do is = 1, 2
               do iref = 1, nref
                  internnum1(iref,is) = 0
                  do j = 1, maxref*(maxref-1)/2
                     internindex1(j,iref,is) = 0
                     internfrom1(j,iref,is)  = 0
                     internto1(j,iref,is)    = 0
                  end do
               end do
            end do
         end if
      end if
c the following in fact not necessary
200   continue

c read info which roots we want
      nbwstates   = 1
      ibwstate(1) = 1
      cbwstate(1) = 1.0
      if (isbwcc) then
         open(unit=1,file='bwroot',
     &        form='formatted',access='sequential',status='old',err=997)
333      read(1,'(i3,f10.7)',end=3) ibwstate(nbwstates),
     &                              cbwstate(nbwstates)
         if (ibwstate(nbwstates).le.0 .or.
     &       ibwstate(nbwstates).gt.nref) then
            write(6,*) 'illegal state number requested'
            call aces_exit(1)
         end if
         nbwstates = nbwstates+1
         goto 333
3        close(1)
         nbwstates = nbwstates-1
         if (nbwstates.gt.nref) then
            write(6,*) 'too many states to average'
            call aces_exit(1)
         end if
         s = 0.0
         do i = 1, nbwstates
            s = s + cbwstate(i)*cbwstate(i)
         end do
         if (s.eq.0.0) then
            do i = 1, nbwstates
               cbwstate(i) = 1d0/nbwstates
            end do
         end if
997      continue

         if (invcc.and.bIAmOne) then
            write(6,*) 'BW roots requested: ',nbwstates
            do i = 1, nbwstates
               write(6,*) 'BW root ',ibwstate(i), cbwstate(i)
            end do
            write(6,*)
            write(6,*)
         end if

      end if

      iref = 1

      if (.not.isbwcc) ihubaccorr=0
      if (ihubaccorr.gt.0.and.bIAmOne) then
         write(6,*) 'A posteriori correction will be calculated'
         write(6,*) 'Correction type: ',correctiontype
         write(6,*)
      end if

c check if parallelization makes sense
      if (.not.isbwcc.and.1.gt.1) then
         write(6,*)' PARALLELIZATION IMPLEMENTED ONLY FOR MR-BWCC '
         call aces_exit(1)
      end if
      if (mod(nref,1).ne.0.and.bIAmOne) then
         write(6,*) ' PARALLELIZATION EFFICIENCY WILL NOT BE OPTIMAL'
         write(6,*) ' NUMBER OF PROCESSORS SHOULD BE DIVISOR OF NREF'
      end if
      if (1.gt.nref) then
c it has no sense and broadcast would not work either:
         if (bIAmOne) then
            write(6,*)' IT HAS NO SENSE TO RUN ON MORE PROCESSORS THEN'
            write(6,*)' NUMBER OF REFERENCES. AND IT DOES NOT WORK'
         end if
         call aces_exit(1)
      end if

      return
      end

cYAU - WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING ! WARNING
c
c    The original xgemm filtered lda, ldb, and ldc through max(1,ld?).
c This subtly changes the behavior of dgemm depending on the other arguments.
c I refused to continue that tradition. There is quite a bit of debugging
c info in this routine which should help in finding the places where the
c leading dimensions are not properly checked.

      subroutine xgemm(transa,transb,
     &                 m,n,k,alpha,a,lda,
     &                             b,ldb,
     &                       beta, c,ldc)

c ARGUMENT LIST
      character*1 transa, transb
      integer m, n, k, lda, ldb, ldc
      double precision alpha, beta
c      double precision a(lda,*), b(ldb,*), c(ldc,*)
      double precision a, b, c

c EXTERNAL FUNCTIONS

c INTERNAL VARIABLES
c Be careful here. If you build your own generic gemm, then make sure
c you use the same integer type. Otherwise, if you link against
c system-BLAS, make sure you cast the arguments correctly.




      integer   int_m, int_n, int_k, int_lda, int_ldb, int_ldc


c ----------------------------------------------------------------------

c This quick return code was taken straight from blas/dgemm. We need it
c for cases when m=lda=0 (e.g., the number of occupied orbitals is zero
c but we didn't check for it). Rather than have dgemm crash, we just
c want to return having done nothing. This also saves us from filtering
c lda, ldb, and ldc through max(1,ld?).

c BEWARE!!! xgemm will, therefore, not crash when the other arguments
c are ill-conditioned.

      if ((m.eq.0).or.
     &    (n.eq.0).or.
     &    (((alpha.eq.(0.0d0)).or.(k.eq.0)).and.(beta.eq.(1.0d0)))
     &   ) return

c ----------------------------------------------------------------------


c ----------------------------------------------------------------------

c   o recast the arguments
      int_m   = m
      int_n   = n
      int_k   = k
      int_lda = lda
      int_ldb = ldb
      int_ldc = ldc

      call dgemm(transa,transb,int_m,int_n,int_k,
     &           alpha,a,int_lda,
     &                 b,int_ldb,
     &           beta, c,int_ldc)

      return
      end

C PRIMITIVE ROUTINE USED BY THE FANCY I/O ROUTINES.  REST ASSURED THAT
C YOU WILL NEVER WANT TO KNOW WHAT THIS ROUTINE DOES.

      SUBROUTINE FILIRP(IVEC,IRREP)
      IMPLICIT INTEGER (A-Z)
      DIMENSION IVEC(4)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPX(255,2),DIRPRD(8,8)
      IVEC(1) = DIRPRD(IVEC(2),IRREP)
      IF (IVEC(3).EQ.0) IVEC(3) = DIRPRD(IVEC(4),IRREP)
      IF (IVEC(4).EQ.0) IVEC(4) = DIRPRD(IVEC(3),IRREP)
      RETURN
      END

c This routine returns the index of the first element in an integer array
c that matches the target integer.

c INPUT
c int N     : the total number of integers to test in IA
c int IA(*) : an array of integers
c int INC   : the increment (leading dimension) of IA
c int IT    : the target integer to match

      integer function iieq(n,ia,inc,it)
      implicit none

c ARGUMENTS
      integer n, ia(*), inc, it

c INTERNAL VARIABLES
      integer i, ndx

c ----------------------------------------------------------------------

      iieq = 0
      if ((n.lt.1).or.(inc.lt.1)) return

      if (inc.eq.1) then
         do i = 1, n
            if (ia(i).eq.it) then
               iieq = i
               return
            end if
         end do
      else
         ndx = 1
         do i = 1, n
            if (ia(ndx).eq.it) then
               iieq = i
               return
            end if
            ndx = ndx + inc
         end do
c     end if (inc.eq.1)
      end if

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__CTR_4INDEX_BLOCK
     +
     +                    ( NPSIZE,NCSIZE,NWSIZE,
     +                      NXYZT,MIJKL,
     +                      MIJ,MKL,NRS,NTU,
     +                      NPR,NPS,NPT,NPU,
     +                      NCR,NCS,NCT,NCU,
     +                      MXPRIM,MNPRIM,
     +                      CCR,CCS,CCT,CCU,
     +                      CCBEGR,CCBEGS,CCBEGT,CCBEGU,
     +                      CCENDR,CCENDS,CCENDT,CCENDU,
     +                      PRIMR,PRIMS,PRIMT,PRIMU,
     +                      L1CACHE,TILE,NCTROW,
     +                      EQUALRS,EQUALTU,
     +                      SWAPRS,SWAPTU,
     +                      PTRANS,
     +                      BLOCKED,
     +                      PUSED,PSAVE,PPAIR,
     +                      PBATCH,
     +                      WORK,
     +
     +                                CBATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__CTR_4INDEX_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__TRANSPOSE_BATCH
C                ERD__CTR_1ST_HALF
C                ERD__MAP_IJKL_TO_IKJL
C                ERD__CTR_2ND_HALF_NEW
C                ERD__CTR_2ND_HALF_UPDATE
C  DESCRIPTION : This operation performs a four-indexed contraction
C                on a block of primitive integrals and updates all
C                contracted integrals:
C
C
C                  sum  [ab|cd]      -->  (ab|cd)
C                 ijkl         ijkl              rstu
C
C                                             r = 1,NCR
C                                             s = 1,NCS
C                                             t = 1,NCT
C                                             u = 1,NCU
C
C                For optimum performance of the contraction procedure,
C                the contraction routine is written to operate on the
C                block of primitive integrals ordered in the following
C                form (i.e. primitive indices to the far right):
C
C                              pbatch (nxyzt,kl,ij)
C
C                where ij and kl are the partial primitive index pairs
C                being treated here. If on entry to this routine the
C                primitive integrals are ordered in the form:
C
C                              pbatch (kl,ij,nxyzt)
C
C                a transposition has to preceed the actual contraction
C                procedure. This is triggered by the keyword PTRANS,
C                which has to be set true, if such a transposition is
C                needed. The complete set of cartesian monomial
C                quadruplets is kept together for efficiency through
C                the entire contraction sequence.
C
C                STRATEGY:
C
C                Perform overall contraction in 2 half contraction
C                steps, using an intermediate reordering if necessary:
C
C
C                1) Contract over ij primitives:
C
C                  (nxyzt,kl,rs) = ccr (r,i) * ccs (s,j) * (nxyzt,kl,ij)
C
C                2) Reorder kl <-> rs (if needed):
C
C                  (nxyzt,kl,rs) --> (nxyzt,rs,kl)
C
C                3) Contract over kl primitives and add result to the
C                   final contraction vector:
C
C                  (nxyzt,rs,tu) = (nxyzt,rs,tu)
C                                + cct (t,k) * ccu (u,l) * (nxyzt,rs,kl)
C
C
C
C                  Input:
C
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays
C                    NXYZT        =  total # of cartesian monomial
C                                    quadruplets
C                    MIJKL        =  total # of partial primitive
C                                    index quadruplets
C                    MIJ(KL)      =  # of partial ij(kl) primitive
C                                    pairs to be transformed
C                    NRS(TU)      =  # of rs(tu) contraction pairs
C                    NPx          =  # of respective i,j,k,l primitives
C                                    for contractions x=R,S,T,U
C                    NCx          =  # of contractions for x=R,S,T,U
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i,j,k,l primitives,
C                                    i.e. = max (i,j,k,l)
C                    MNPRIM       =  the minimum # of primitives
C                                    between i and j primitives and
C                                    k and l primitives and form the
C                                    maximum between these two values,
C                                    i.e. = max (min(i,j),min(k,l))
C                    CCx          =  full set (including zeros) of
C                                    contraction coefficients for
C                                    x=R,S,T,U contractions
C                    CCBEGx       =  lowest nonzero primitive i,j,k,l
C                                    index for x=R,S,T,U contractions
C                    CCENDx       =  highest nonzero primitive i,j,k,l
C                                    index for x=R,S,T,U contractions
C                    PRIMx        =  primitive i,j,k,l indices for
C                                    the x=R,S,T,U contractions
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    EQUALRS(TU)  =  is true, if only the lower
C                                    triangle of ij(kl) primitive
C                                    indices is present and consequently
C                                    only the lower triangle of rs(tu)
C                                    contractions needs to be evaluated
C                    SWAPRS(TU)   =  if this is true, the 1st quarter
C                                    transformation will be over R(T)
C                                    followed by the 2nd over S(U).
C                                    If false, the order will be
C                                    reversed: 1st over S(U) then 2nd
C                                    over R(T)
C                    PTRANS       =  if true, a necessary primitive
C                                    integral transposition needs to
C                                    be done in order to bring the
C                                    ijkl primitive indices to the
C                                    far right position
C                    BLOCKED      =  if false, only one call will be
C                                    made to the present contraction
C                                    routine. The contraction batch
C                                    has not! been initialized to zero
C                                    and there is no need to perform
C                                    an update of the contracted batch.
C                    Pxxxx        =  intermediate storage arrays for
C                                    primitive labels to bundle
C                                    contraction steps in do loops
C                                    (xxxx = USED,SAVE,PAIR)
C                    PBATCH       =  the batch of primitive integrals
C                                    to be contracted
C                    WORK         =  the working array for intermediate
C                                    storage
C                    CBATCH       =  the batch of contracted integrals
C                                    before contraction update
C
C                  Output:
C
C                    CBATCH       =  the update batch of contracted
C                                    integrals after contraction
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     BLOCKED
         LOGICAL     EQUALRS,EQUALTU
         LOGICAL     INWORK
         LOGICAL     PTRANS
         LOGICAL     SWAPRS,SWAPTU

         INTEGER     L1CACHE,L1FREE,L1USED
         INTEGER     MIJ,MKL,NRS,NTU
         INTEGER     MIJKL
         INTEGER     MXPRIM,MNPRIM
         INTEGER     N
         INTEGER     NBLOCK
         INTEGER     NCOL,NROW
         INTEGER     NCR,NCS,NCT,NCU
         INTEGER     NCTROW
         INTEGER     NPMAX,NPMIN
         INTEGER     NPR,NPS,NPT,NPU
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NXYZT
         INTEGER     TILE
         INTEGER     WROW,WUSED

         INTEGER     CCBEGR (1:NCR)
         INTEGER     CCBEGS (1:NCS)
         INTEGER     CCBEGT (1:NCT)
         INTEGER     CCBEGU (1:NCU)

         INTEGER     CCENDR (1:NCR)
         INTEGER     CCENDS (1:NCS)
         INTEGER     CCENDT (1:NCT)
         INTEGER     CCENDU (1:NCU)

         INTEGER     PRIMR  (1:MIJ)
         INTEGER     PRIMS  (1:MIJ)
         INTEGER     PRIMT  (1:MKL)
         INTEGER     PRIMU  (1:MKL)

         INTEGER     PPAIR  (1:MXPRIM)
         INTEGER     PSAVE  (1:MXPRIM)
         INTEGER     PUSED  (1:MNPRIM)

         DOUBLE PRECISION    CCR (1:NPR,1:NCR)
         DOUBLE PRECISION    CCS (1:NPS,1:NCS)
         DOUBLE PRECISION    CCT (1:NPT,1:NCT)
         DOUBLE PRECISION    CCU (1:NPU,1:NCU)

         DOUBLE PRECISION    CBATCH (1:NCSIZE)
         DOUBLE PRECISION    PBATCH (1:NPSIZE)
         DOUBLE PRECISION    WORK   (1:NWSIZE)
C
C
C------------------------------------------------------------------------
C
C
C             ...check, if a primitive batch transposition is needed:
C
C                        (kl,ij,nxyzt) --> (nxyzt,kl,ij)
C
C
         IF (PTRANS .AND. (MIJKL.GT.1) .AND. (NXYZT.GT.1)) THEN

             CALL  ERD__TRANSPOSE_BATCH
     +
     +                  ( MIJKL,NXYZT,
     +                    TILE,
     +                    PBATCH,
     +
     +                            WORK )
     +
     +
             INWORK = .TRUE.
         ELSE
             INWORK = .FALSE.
         END IF
C
C
C             ...prepare for contraction over ij. Logical variable
C                INWORK controls where the actual significant data
C                (i.e. the integrals to be contracted) is residing.
C                If INWORK is true, then array WORK contains the
C                integrals, if false, they are in array PBATCH.
C                One of the key variables to be determined here
C                is the blocking size of the invariant indices N
C                such that the cache is used efficiently. The
C                blocking size has to be adapted also to the size
C                of the working space available. L1USED contains
C                the amount of data that will occupy the cache
C                besides the three main big arrays containing the
C                initial, quarter transformed and halftransformed
C                integrals. This extra data is the contraction
C                coefficients, their segmentation limits and the
C                primitive indices. L1FREE indicates the size of
C                the level 1 cache that is finally available for
C                the three big integral arrays.
C
C
         NPMAX = MAX (NPR,NPS)
         NPMIN = MIN (NPR,NPS)

         L1USED = MIJ + NCR + NCS + NPR + NPS + NPR*NCR + NPS*NCS
         L1FREE = (3*L1CACHE/4) - L1USED

         NCOL = NPMIN + NRS + MIJ
         NROW = L1FREE / NCOL
C
C
C             ...do contraction over ij.
C
C
         N = NXYZT * MKL

         IF (INWORK) THEN

             WUSED = N * MIJ
             WROW = (NWSIZE - WUSED) / NPMIN
             NBLOCK = MIN (N,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             CALL  ERD__CTR_1ST_HALF
     +
     +                  ( N,
     +                    NPMAX,NPMIN,
     +                    MIJ,NRS,
     +                    NBLOCK,
     +                    NCR,NCS,
     +                    NPR,NPS,
     +                    CCR,CCS,
     +                    CCBEGR,CCBEGS,
     +                    CCENDR,CCENDS,
     +                    PRIMR,PRIMS,
     +                    EQUALRS,
     +                    SWAPRS,
     +                    PUSED,PSAVE,PPAIR,
     +                    WORK (1),WORK (WUSED+1),
     +
     +                            PBATCH )
     +
     +
             INWORK = .FALSE.

         ELSE

             WUSED = N * NRS
             WROW = (NWSIZE - WUSED) / NPMIN
             NBLOCK = MIN (N,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             CALL  ERD__CTR_1ST_HALF
     +
     +                  ( N,
     +                    NPMAX,NPMIN,
     +                    MIJ,NRS,
     +                    NBLOCK,
     +                    NCR,NCS,
     +                    NPR,NPS,
     +                    CCR,CCS,
     +                    CCBEGR,CCBEGS,
     +                    CCENDR,CCENDS,
     +                    PRIMR,PRIMS,
     +                    EQUALRS,
     +                    SWAPRS,
     +                    PUSED,PSAVE,PPAIR,
     +                    PBATCH,WORK (WUSED+1),
     +
     +                            WORK (1) )
     +
     +
             INWORK = .TRUE.

         END IF
C
C
C             ...reorder rs <-> kl , if needed.
C
C
         IF (MKL.GT.1 .AND. NRS.GT.1) THEN

             IF (INWORK) THEN

                 CALL  ERD__MAP_IJKL_TO_IKJL
     +
     +                  ( NXYZT,MKL,NRS,1,
     +                    TILE,
     +                    WORK,
     +
     +                            PBATCH )
     +
     +
                 INWORK = .FALSE.

             ELSE

                 CALL  ERD__MAP_IJKL_TO_IKJL
     +
     +                  ( NXYZT,MKL,NRS,1,
     +                    TILE,
     +                    PBATCH,
     +
     +                            WORK )
     +
     +
                 INWORK = .TRUE.

             END IF
         END IF
C
C
C             ...prepare for contraction over kl. Same procedure
C                as for ij (see comments above). The contracted
C                result will be added (updated) directly to the
C                final contracted CBATCH array. Do not perform a
C                contracted batch update, if no contraction blocking
C                is necessary.
C
C
         NPMAX = MAX (NPT,NPU)
         NPMIN = MIN (NPT,NPU)

         L1USED = MKL + NCT + NCU + NPT + NPU + NPT*NCT + NPU*NCU
         L1FREE = (3*L1CACHE/4) - L1USED

         NCOL = NPMIN + NTU + MKL
         NROW = L1FREE / NCOL
C
C
C             ...do contraction over kl.
C
C
         N = NXYZT * NRS

         IF (INWORK) THEN

             WUSED = N * MKL
             WROW = (NWSIZE - WUSED) / NPMIN
             NBLOCK = MIN (N,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             IF (BLOCKED) THEN
                 CALL  ERD__CTR_2ND_HALF_UPDATE
     +
     +                      ( N,
     +                        NPMAX,NPMIN,
     +                        MKL,NTU,
     +                        NBLOCK,
     +                        NCT,NCU,
     +                        NPT,NPU,
     +                        CCT,CCU,
     +                        CCBEGT,CCBEGU,
     +                        CCENDT,CCENDU,
     +                        PRIMT,PRIMU,
     +                        EQUALTU,
     +                        SWAPTU,
     +                        PUSED,PSAVE,PPAIR,
     +                        WORK (1),WORK (WUSED+1),
     +
     +                                 CBATCH )
     +
     +
             ELSE
                 CALL  ERD__CTR_2ND_HALF_NEW
     +
     +                      ( N,
     +                        NPMAX,NPMIN,
     +                        MKL,NTU,
     +                        NBLOCK,
     +                        NCT,NCU,
     +                        NPT,NPU,
     +                        CCT,CCU,
     +                        CCBEGT,CCBEGU,
     +                        CCENDT,CCENDU,
     +                        PRIMT,PRIMU,
     +                        EQUALTU,
     +                        SWAPTU,
     +                        PUSED,PSAVE,PPAIR,
     +                        WORK (1),WORK (WUSED+1),
     +
     +                                 CBATCH )
     +
     +
             END IF

         ELSE

             WUSED = 0
             WROW = (NWSIZE - WUSED) / NPMIN
             NBLOCK = MIN (N,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             IF (BLOCKED) THEN
                 CALL  ERD__CTR_2ND_HALF_UPDATE
     +
     +                      ( N,
     +                        NPMAX,NPMIN,
     +                        MKL,NTU,
     +                        NBLOCK,
     +                        NCT,NCU,
     +                        NPT,NPU,
     +                        CCT,CCU,
     +                        CCBEGT,CCBEGU,
     +                        CCENDT,CCENDU,
     +                        PRIMT,PRIMU,
     +                        EQUALTU,
     +                        SWAPTU,
     +                        PUSED,PSAVE,PPAIR,
     +                        PBATCH,WORK (1),
     +
     +                               CBATCH )
     +
     +
             ELSE
                 CALL  ERD__CTR_2ND_HALF_NEW
     +
     +                      ( N,
     +                        NPMAX,NPMIN,
     +                        MKL,NTU,
     +                        NBLOCK,
     +                        NCT,NCU,
     +                        NPT,NPU,
     +                        CCT,CCU,
     +                        CCBEGT,CCBEGU,
     +                        CCENDT,CCENDU,
     +                        PRIMT,PRIMU,
     +                        EQUALTU,
     +                        SWAPTU,
     +                        PUSED,PSAVE,PPAIR,
     +                        PBATCH,WORK (1),
     +
     +                               CBATCH )
     +
     +
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function find_current_block_map(x, array_table_entry,
     *                                  index_table, nindex_table,
     *                                  block_map_table, 
     *                                  nblock_map_table)
c-----------------------------------------------------------------------------
c   Looks up the current segments of each index of an array, then uses
c   those segments to find the block with those segments in the 
c   block_map_table.  
c-----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'

      integer x, nindex_table, nblock_map_table
      integer array_table_entry(larray_table_entry)
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)

      integer nindex, i, j, nb, iblock_map, nmatch, maxblk
      integer index(mx_array_index), seg(mx_array_index)
      integer lookup, block_map_lookup

      iblock_map = array_table_entry(c_block_map)
      if (iblock_map .eq. 0) then   ! array is not mapped

c----------------------------------------------------------------------------
c   Get a dummy block number. 
c----------------------------------------------------------------------------

         blkmgr_next_block = blkmgr_next_block + 1
         find_current_block_map = blkmgr_next_block
         return
      endif

      nindex = array_table_entry(c_nindex)
      do i = 1, nindex
         index(i) = array_table_entry(c_index_array1+i-1)
         seg(i)   = index_table(c_current_seg,index(i))
      enddo

      lookup = block_map_lookup(seg, nindex, x,
     *                         array_table_entry,
     *                         index_table, nindex_table)

      find_current_block_map = lookup - iblock_map + 1
     
      return
      end

      Subroutine MkCadp (PtGrp, NAtms, NUnique, ZSym, AtNr, QX,
     &GenBy, IStat)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Purpose: Produce a CADPAC input file based on the ZMAT file
C
C Arguments:
C     PtGrp   Symbol for the point group symmetry to use in (input)
C             making the INP file.
C     NAtms   Number of atoms (input)
C     AtNr    Atomic numbers for each center (input)
C     NUnique Number of unique internal coordinates (input)
C     Q       Cartesian coordinates (input)
C     GenBy   To hold the Genby list (internal)
C     IStat   Error codes (output)
C             = 0  Successful
C             = 1  Fatal error from dependent
C             = 3  I/O Error on CadFil
C             = 5  I/O Error on ZFil
C             = 7  No non-dummy centers!
C             = 8  ZFil ends after Z-matrix
C             = 10 ZFil ends after JODA control info
C
C Common blocks used:
C     LUnits  Sets unit names & numbers
C
C Internal Variables:
C     BasNam  Holds the basis set name given in the ZMAT file
C     JobTtl  Holds the job title given in the ZMAT file
C     Wrk     Scratch string to copy lines form ZMAT to ABI
C     PitSym  Holds the point group label in Pitzer's form
C     PitOrd  Order of the axis - for Pitzer
C     IOS     Gets the status code from all I/O statements
C     ISect   Counts sections in ZMAT and ABI files to help
C             locate errors.
C
C Dependents
C     PitPtG  Translates a schoenflies symbol into Pitzer's form
C     WrPBas  Lookup & write basis set in Pitzer style
C
C Files used:
C     ZFil   Holds the basis specification & the "rest" of INP
C     CadFil Gets written out here (kills previous one)
C     BasFil The basis set library
C
C Limitations:
C     Only looks up bases for the geometrically unique atoms.
C
C     Extra blank lines at the end of a "truncated" ZFil will cause
C     it to act like it encountered a real error on reading the file.
C
C Diagnostics
C     Printed for most I/O errors and end-of-file conditions.  The
C     IOSTAT result code is reported where appropriate, along with
C     the section of the file in which the error occurred.  The
C     IOSTAT code is system dependent and probably requires manuals
C     for the machine.
C
C     ZFIL file sections:
C     1) Title and Z-matrix
C     2) Optimization control input
C     3) Basis sets
C     4) Point group input
C     5) Remainder of file
C
C     CadFil file sections:
C     1) Title
C     2) Point group
C     3) Atom label & coordinates
C     4) Basis
C     5) Remainder of file
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
      Character*(*) PtGrp, ZSym(NAtms)
      Integer AtNr(NAtms), GenBy(NAtms), IStat, IOS, ISect
      Integer AtoI
      Character*80 JobTtl, Wrk
      Character*5 PitSym
      Integer PitOrd

csb 1/97 Hold long basis set names
      integer baslen
      parameter (baslen=80)
      character*(baslen) BasNam(MxAtms),BlnkBN,ScrBas,BasName

      Logical Opn,bad123
      Integer OldLu
      Dimension QX(3*NAtms)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
#include "io_units.par"
 
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      Common /SymInf/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      COMMON /COORD/ Q(3*MXATMS), R(3*MXATMS), NCON(3*MXATMS),
     1     NR(MXATMS),ISQUASH(3*MXATMS),IATNUM(MXATMS),ATMASS(MXATMS),
     2     IUNIQUE(3*MXATMS),NEQ(3*MXATMS),IEQUIV(3*MXATMS,3*MXATMS),
     3     NOPTI(3*MXATMS), NATOMS
C
C     Length of BasNam is fixed by the basis library
C
C
C     This length is fixed by ABINITIO's input section
C
c$$$      DATA BASIS /'PBS     ','STO-3G  ','DZ      ',
c$$$     &            'VDZ     ','3-21G   ','6-31G   ',
c$$$     &            '4-31G   ','TZ      ','VTZ     ',
c$$$     &            '6-311G  ','DZP     ','VDZP    ',
c$$$     &            'TZP     ','VTZP    ','TZ2P    ',
c$$$     &            'WMR     ','6-31G*  ','6-31G** ',
c$$$     &            '6-311G* ','6-311G**','PV5Z    '/
C
C     Cautiously open the ZMAT file
C
      PitOrd = 0
      Opn = .False.
      OldLu = 0
      Inquire (FILE=ZFil, OPENED=Opn, NUMBER=OldLu)
      If (Opn) Close (OldLu)
C
      Open (LuZ, FILE=ZFil, STATUS='OLD')
      Rewind LuZ
C
C     Read ZMAT: Get title, skip Z-matrix, skip parameters
C     NOTE: blank line after Z-matrix, and parameters required.
C
      bad123 = .false.
      ISect = 1
      Read (LuZ, '(A)', ERR=8500, END=8510, IOSTAT=IOS) JobTtl
      Do 200 i = 1, NAtms
         Read (LuZ,'(A)', ERR=8500, END=8510, IOSTAT = IOS) Wrk
C
C     ADDITION (JFS, 4/1990): Check third atom in Z-matrix in
C     order to detect 2--1--3 connectivity.
C
         If(I.Eq.3)then
          iblank=index(wrk,' ')
          istrt2=fnblnk(wrk(iblank+1:))+iblank
          iendd2=index(wrk(istrt2+1:),' ')+istrt2-1
          izz=AtoI(wrk(istrt2:iendd2))
          if(izz.eq.1.and.zsym(1)(1:1).ne.'X'.and.zsym(2)(1:1).ne.'X')
     &       bad123=.true.
         endif
C     END OF ADDITION
 200  Continue
      Read (LuZ,'(A)', ERR=8500, END=8510, IOSTAT=IOS) Wrk
      Do 205 i = 1, NUnique
         Read (LuZ, '(A)', ERR=8500, END=8510, IOSTAT=IOS) Wrk
 205  Continue
      Read (LuZ, '(A)', ERR=8500, END=8800, IOSTAT=IOS) Wrk
C
C     Get the optimizer settings & another blank line after
C
      ISect = 2
      Call GtFlgs(0,IERR,IPRNT,INR,ICONTL,IVEC,IDIE,ICURVY,ISTCRT,
     &IMXSTP,IVIB,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     &IDFGHI,BasName)
      IF(IERR.EQ.1)GOTO 8500
      IF(IERR.EQ.2)GOTO 8800
C      Read (LuZ, '(10I3)', ERR=8500, END=8800) IPrnt, INR, IContl,
C     $ IVec, IDie, ICurvy, IStCrt, IMxStp, IVib, IRecal
      If(IContl.eq.0)IContl = 4
      IF(IPrnt.ge.100)then
      Write (LuOut, '(1X,A,I3)') 'Print Level: ', IPrnt
      Write (LuOut, '(1X,A,I3)') 'Step-taking: ', INR
      Write (LuOut, '(1X,A,I3)') 'E-Vec to follow: ',IVec
      Write (LuOut, '(1X,A,I3)') 'Die: ',IDie
      Write (LuOut, '(1X,A,I3)') 'Use curvilinear xform: ',ICurvy
      Write (LuOut, '(1X,A,I3)') 'Max Step: ',IMxStp
      Write (LuOut, '(1X,A,I3)') 'Step Contol: ', IStCrt
      Write (LuOut, '(1X,A,I3)') 'Vibrational Analysis: ', IVib
      Write (LuOut, '(1X,A,I3)') 'Recalculation of Hessian: ',
     &IRecal
      Write (LuOut, '(1X,A,I3)') 'Convergence cutoff: ',IContl
      Endif
      Read (LuZ, '(A)', ERR=8500, END=8810, IOSTAT=IOS) Wrk
C
C     Now read the basis sets - each line corresponds to a (non-dummy)
C     center in the Z-matrix, in the order of appearance.  We put this
C     into an array length NAtms, with blanks for dummies.  This makes
C     it easier to match the basis with the right coordinates later.
C     NOTE: blank line after basis names.
C
      ISect = 3
      Do 250 i = 1, NAtms
         BasNam(i) = BlnkBN
         If (AtNr(i) .ne. 0 .and. IBasis .eq. 0) then
            Read (LuZ, '(A)', ERR=8500, END=8510, IOSTAT=IOS) BasNam(i)
         ElseIf(AtNr(i) .ne. 0 .and. IBasis .ne. 0)then
            BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
     &          BasName(1:linblnk(BasName))
c$$$            izz=index(Basis(IBasis),'*')
c$$$            ixx=index(Basis(IBasis),'**')
c$$$            ipop=0
c$$$            if(ixx.ne.0.and.atmass(i).gt.4.5)ipop=1
c$$$            if(izz.ne.ixx.and.atmass(i).lt.4.5)ipop=1
c$$$            BasNam(i)=ZSym(i)(1:linblnk(ZSym(i)))//':'//
c$$$     &                Basis(IBasis)(1:linblnk(Basis(IBasis))-ipop)
         EndIf
 250  Continue
      If(IBasis.eq.0)
     &Read (LuZ, '(A)', ERR=8500, END=8510, IOSTAT=IOS) Wrk
C ADDITION (JFS,4/90)
C Now take care of situation which occurs when 2--1--3 Z-matrix
C  specification and nonstandard basis set input is used.  In this case,
C  the basis sets for atoms #1 and #2 must be switched.
C
      If(Bad123.and.IBasis.eq.0)then
       ScrBas=BasNam(1)
       BasNam(1)=BasNam(2)
       BasNam(2)=ScrBas
      EndIf
C END OF ADDITION
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Let's find out which centers are equivalent.  This call is
C     skipped in finite difference calculations.
C
      If(IVib.ne.2)
     &Call SymEqv ( NAtms, GenBy)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Now we've got (pretty much) all the information we need, so
C     we can start writing out the INP file.
C     Begin with a very cautious opening of the file.
C
      Inquire (FILE=CadFil, OPENED=Opn, NUMBER=OldLu)
      If (Opn) Close (OldLu)
C
      Open (LuCad, FILE=CadFil, FORM='FORMATTED', STATUS='UNKNOWN')
      Rewind LuCad
C
C     This we got from the beginning of the ZMAT file
C
      ISect = 1
      Write (LuCad, '(A)', ERR=8300, IOSTAT=IOS) 'TITLE'
      Write (LuCad, '(A)', ERR=8300, IOSTAT=IOS)
     $   JobTtl(:linblnk(JobTtl))
C
C     Now for the point group symbol
C
      Call PitPtG (PtGrp, PitSym, PitOrd)
      ISect = 2
      Write (LuCad, 9010, ERR=8300, IOSTAT=IOs) PitSym, PitOrd
 9010 Format ('SYMMETRY'/A5,I5/'END')
C
C     Now to write out the geometry/basis information
C
      Write (LuCad, *, ERR=8300, IOSTAT=IOS)
      Write (LuCad, '(A)', ERR=8300, IOSTAT=IOS) 'ATOMS'
      IPit = 0
      Do 100 i = 1, NAtms
         If (AtNr(i) .ne. 0 .AND. GenBy(i) .eq. 0) then
            IPit = IPit + 1
            ISect = 3
            Write (LuCad, 9000, ERR=8300, IOSTAT=IOS) ZSym(i),
     $         Float(AtNr(i)), (QX(3*(i-1)+j),j=1,3)
 9000       Format (A5, 3X, 2X, F5.0, 3F20.12)
C
            ISect = 4
            Call WrPBas (LuBasL,BasFil,BasNam(i),LuCad,1,2,IStat)
            Write (LuCad, '(A)', ERR=8300, IOSTAT=IOS) 'END'
C
C           Handle errors in WrPBas
C
            If (Mod(IStat,2) .eq. 1) then
               IStat = 1
               Write (LuErr, 9910)
               Close (LuZ)
               Close (LuCad)
               Return
            ElseIf (IStat .eq. 8) then
               IStat = 3
               Write (LuErr, 9935) CadFil, LuCad
               Close (LuZ)
               Close (LuCad)
               Return
            EndIf
         EndIf
 100  Continue
 9910 Format (' @MKCADP-F, Dependent terminated with FATAL error.')
 9935 Format (' @MKCADP-F, Dependent reports error accessing file ',
     $   A,' on unit ',I3,'.')
C
C     This really better not happen...
C
      If (Ipit .eq. 0) then
         IStat = 7
         Write (LuErr, 9970)
         Close (LuZ)
         Close (LuCad)
         Return
 9970    Format (' @MKCADP-F, No non-dummy centers in Z-matrix.')
      EndIf
C
C     Finish off the "atoms" section
C
      Write (LuCad, '(A)', ERR=8300, IOSTAT=IOS) 'END'
C
C     The rest of this just copied from ZMAT
C
      Write (LuCad, * , ERR=8300, IOSTAT=IOS)
 300  Continue
      ISect = 5
      Read (LuZ, '(A)', END=500, IOSTAT=IOS) Wrk
      Write (LuCad, '(A)', ERR=8300, IOSTAT=IOS) Wrk(:linblnk(Wrk))
      Goto 300
 500  Continue
C
C     Make sure every body gets closed & stuff
C
 8000 Close (LuCad)
      Close (LuZ)
      Return
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Get here via an I/O error on LuCad
C
 8300 IStat = 3
      Write (LuErr, 9930) IOS, CadFil, ISect
      Close (LuCad)
      Close (LuZ)
      Return
 9930 Format (' @MKCADP-F, I/O error ',I5,' on file ',A,' in section ',
     $   I2,'.')
C
C     Get here via an I/O error on LuZ
C
 8500 IStat = 5
      Write (LuErr, 9950) IOS, ZFil, ISect
      Close (LuCad)
      Close (LuZ)
      Return
 8510 IStat = 5
      Write (LuErr, 9955) ZFil, ISect
      Close (LuCad)
      Close (LuZ)
      Return
C
C     If the ZFil ends after the Z-matrix or the optimization control
C     info, it probably means that JODA is being used "stand-alone"
C     and we want to allow for that possibility.
C
 8800 IStat = 8
      Write (LuOut, 9800) ZFil, CadFil
      Close (LuCad)
      Close (LuZ)
      Return
 8810 IStat = 10
      Write (LuOut, 9810) ZFil, CadFil
      Close (LuCad)
      Close (LuZ)
      Return
 9950 Format (' @MKCADP-F, I/O error ',I5,' on file ',A,' in section ',
     $   I2,'.')
 9955 Format (' @MKCADP-F, Premature end-of-file on ',A,' in section ',
     $   I2,'.')
 9800 Format (/1X,A,' ends after Z-matrix - cannot ',
     $   'finish making ',A,'.')
 9810 Format (/1X,A,' ends after JODA control info - cannot ',
     $   'finish making ',A,'.')
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         INTEGER FUNCTION  NLO__ANGULAR_MOMENTUM_NBO
     +
     +                          ( NANG,
     +                            ANGMOM,
     +                            FIRST,LAST,
     +                            L,
     +                            NDEG,
     +                            QSYMACC,LSYMACC,
     +                            W,Q,
     +                            LOCAL )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ANGULAR_MOMENTUM_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This function returns the first index position of
C                an NBO set inside the ANGMOM array, all of which
C                posses lowest angular momentum component L. If
C                there is any negative value in ANGMOM, the NBO will
C                not participate in the search, i.e. will not be
C                recognized. Three criteria must be met by the set
C                of NBOs chosen:
C
C                     1) the lowest angular momentum must
C                        have a value of L
C
C                     2) there must be NDEG NBOs having the
C                        same lowest angular momentum value L,
C                        where the degeneracy criterion is based
C                        on equal interaction order and locality
C                        content within a threshold limit.
C
C                     3) off all possible sets found obeying 1)
C                        and 2) we pick the one that has the closest
C                        weight to the target weight corresponding
C                        to the weight average of the excluded
C                        NBOs between the ranges FIRST and LAST.
C
C                If no NBO set is found, a value of 0 is returned.
C                Since the weights of all NBOs transmitted here are
C                already ordered, the search will be performed starting
C                from both ends -> and <- and move inwards to the
C                positions FIRST and LAST inside the ANGMOM array:
C
C
C                      * * * * * * * * * * * * * * * * * * * * *
C                      ->        |       |                    <-
C                              FIRST    LAST
C
C                This procedure will ensure close proximity to the
C                target weight in FIRST and LAST.
C
C
C
C                  Input:
C
C                    NANG         =  # of lowest angular momenta
C                                    present in array ANGMOM over which
C                                    the search will be performed
C                    ANGMOM (I)   =  lowest angular momentum component
C                                    of I-th NBO.
C                    FIRST,LAST   =  the range of excluded NBOs from
C                                    the search.
C                    L            =  lowest angular momentum component
C                                    of NBO wanted.
C                    NDEG         =  # of consecutive NBOs wanted with
C                                    the same weight and locality
C                                    content within accuracy limits.
C                    QSYMACC      =  threshold value for NBO interaction
C                                    order equalities.
C                    LSYMACC      =  threshold value for NBO locality
C                                    equalities.
C                    W            =  the NANG NBO weights.
C                    Q            =  the NANG NBO interaction orders.
C                    LOCAL        =  the NANG NBO atomic localization
C                                    content.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ACCEPT

         INTEGER     K,L,M,N
         INTEGER     FIRST,LAST
         INTEGER     NANG
         INTEGER     NDEG
         INTEGER     NFIRST,NLAST
         INTEGER     NSTEPS

         INTEGER     ANGMOM  (1:NANG)

         DOUBLE PRECISION  QDIFF,LDIFF
         DOUBLE PRECISION  QSYMACC,LSYMACC
         DOUBLE PRECISION  QVAL,LVAL
         DOUBLE PRECISION  WLAST,WFIRST
         DOUBLE PRECISION  WTARGET
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  LOCAL (1:NANG)
         DOUBLE PRECISION  Q     (1:NANG)
         DOUBLE PRECISION  W     (1:NANG)

         DATA  ZERO  /0.D0/
C
C
C------------------------------------------------------------------------
C
C
C             ...form target (average) weight.
C
C
         WTARGET = ZERO
         DO N = FIRST,LAST
            WTARGET = WTARGET + W (N)
         END DO
         WTARGET = WTARGET / DFLOAT (N)
C
C
C             ...determine closest NBO set first index positions
C                NLAST and NFIRST from both respective LAST and
C                FIRST ends.
C
C
         NLAST = 0
         NFIRST = 0

         NSTEPS = MAX (FIRST-1,NANG-LAST)

         DO N = NSTEPS,1,-1
            M = LAST + N
            IF (M.LE.NANG) THEN
                IF (ANGMOM (M).EQ.L) THEN
                    QVAL = Q (M)
                    LVAL = LOCAL (M)
                    ACCEPT = .TRUE.
                    DO K = M-NDEG+1,M-1
                       QDIFF  = ABS (QVAL - Q (K))
                       LDIFF  = ABS (LVAL - LOCAL (K))
                       ACCEPT = ACCEPT .AND. (K.GT.LAST)
                       ACCEPT = ACCEPT .AND. (ANGMOM (K).EQ.L)
                       ACCEPT = ACCEPT .AND. (QDIFF.LT.QSYMACC)
                       ACCEPT = ACCEPT .AND. (LDIFF.LT.LSYMACC)
                    END DO
                    IF (ACCEPT) THEN
                        NLAST = M-NDEG+1
                    END IF
                END IF
            END IF
            M = FIRST - N
            IF (M.GE.1) THEN
                IF (ANGMOM (M).EQ.L) THEN
                    QVAL = Q (M)
                    LVAL = LOCAL (M)
                    ACCEPT = .TRUE.
                    DO K = M+1,M+NDEG-1
                       QDIFF  = ABS (QVAL - Q (K))
                       LDIFF  = ABS (LVAL - LOCAL (K))
                       ACCEPT = ACCEPT .AND. (K.LT.FIRST)
                       ACCEPT = ACCEPT .AND. (ANGMOM (K).EQ.L)
                       ACCEPT = ACCEPT .AND. (QDIFF.LT.QSYMACC)
                       ACCEPT = ACCEPT .AND. (LDIFF.LT.LSYMACC)
                    END DO
                    IF (ACCEPT) THEN
                        NFIRST = M
                    END IF
                END IF
            END IF
         END DO
C
C
C             ...decide which to take by comparing with target
C                weight.
C
C
         IF (NLAST.NE.0 .AND. NFIRST.NE.0) THEN

             WLAST  = ABS (WTARGET - W (NLAST))
             WFIRST = ABS (WTARGET - W (NFIRST))

             IF (WLAST.LT.WFIRST) THEN
                 NLO__ANGULAR_MOMENTUM_NBO = NLAST
             ELSE
                 NLO__ANGULAR_MOMENTUM_NBO = NFIRST
             END IF

         ELSE IF (NLAST.NE.0) THEN

             NLO__ANGULAR_MOMENTUM_NBO = NLAST

         ELSE IF (NFIRST.NE.0) THEN

             NLO__ANGULAR_MOMENTUM_NBO = NFIRST

         ELSE

             NLO__ANGULAR_MOMENTUM_NBO = 0

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE UPJFC(JFC,JFC2,JFC3,SCR1,SCR2,NCOORD,NIRREP,UPDATE)
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION JFC,JFC2,JFC3,MPROTON,NINE
      LOGICAL UPDATE 
C
      DIMENSION JFC(NCOORD,NCOORD),JFC2(3*NCOORD,3*NCOORD),
     &          JFC3(3*NCOORD,3*NCOORD),SCR1(1),SCR2(1)
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALOBE,IBITWD
C
      DATA IONE/1/
      DATA ONE,TWO,FOUR,NINE/1.D0,2.D0,4.D0,9.D0/
C
C C: VELOCITY OF LINGHT IN A.U.
C
      DATA C /137.035987D0/
C
C MPROTON: MASS OF PROTON IN A.U.
C
      DATA MPROTON /1836.152736D0/
C
C CONVERT: CONVERSION FROM A.U. TO SEC  (FOR TIME UNITS)
C
      DATA  CONVERT /2.4188843D-17/
C
      DATA PI /3.141592654D0/
C
C CONVERSION OF CALCULATED COUPLING TENSOR TO THE USUAL UNITS (HZ)
C
      FACT=FOUR/((MPROTON**2)*(C**4)*CONVERT*TWO*NINE)*PI
C
      CALL SSCAL(NCOORD*NCOORD,FACT,JFC,1)
C
      IF(NIRREP.NE.1) THEN
C 
       CALL ZERO(JFC2,NCOORD*NCOORD)
       CALL TRAHES(JFC,JFC2,SCR1,SCR2,NCOORD)
c YAU : old
c      CALL ICOPY(NCOORD*NCOORD*IINTFP,JFC2,1,JFC,1)
c YAU : new
       CALL DCOPY(NCOORD*NCOORD,JFC2,1,JFC,1)
c YAU : end
C
      ENDIF
C
      CALL EXPJFC(JFC,JFC2,NCOORD)
C
      CALL GETREC(20,'JOBARC','NINDATOM',IONE,NUCIND)
      CALL GETREC(20,'JOBARC','MULTATOM',NUCIND,SCR1)
      CALL GETREC(20,'JOBARC','NAMCOORD',IINTFP*3*NUCIND,
     &            SCR1(1+NUCIND))
C
      CALL JPRI(JFC2,3*NCOORD,NUCIND,SCR1,SCR1(1+NUCIND),SCR2,.TRUE.)
C
      IF(UPDATE) THEN
 
       OPEN(UNIT=81,FILE='JFC',STATUS='OLD',FORM='FORMATTED')
       DO 2000 ICOORD=1,3*NCOORD
        READ(81,3001) (JFC3(ICOORD,J),J=1,3*NCOORD)
2000   CONTINUE
3000   FORMAT(2I5)
3001   FORMAT(3F20.10)
       CALL SAXPY(9*NCOORD*NCOORD,ONE,JFC3,1,JFC2,1)
      ELSE
       OPEN(UNIT=81,FILE='JFC',STATUS='UNKNOWN',FORM='FORMATTED')
      ENDIF
C
      REWIND(81)
      DO 2100 ICOORD=1,3*NCOORD
       WRITE(81,3001) (JFC2(ICOORD,J),J=1,3*NCOORD)
2100  CONTINUE
      CLOSE(UNIT=81,STATUS='KEEP')
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine send_block(array, array_block, blkndx, dest, tarray,
     *                      tblock, tblkndx, nwblock, comm, opcode, 
     *                      request)
c---------------------------------------------------------------------------
c   Send block "array_block" of "array" to a given destination processor's
c   tarray, tblock.
c   Destination processor rank is relative to communicator "comm".
c---------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer array, array_block, blkndx, dest
      integer tarray, tblock, tblkndx
      integer nwblock
      integer comm
      integer opcode
      integer request

      integer ierr

      request = MPI_REQUEST_NULL
      if (my_company_rank .ne. dest) then
            if (opcode .eq. put_op) then
               call fsumdata(array, array_block, blkndx, dest, 
     *                    tarray, tblock, nwblock, comm, request) 
            else if (opcode .eq. put_replace_op) then
               call fcopydata(array, array_block, blkndx, dest, 
     *                    tarray, tblock, nwblock, comm, request) 
            endif
      endif

      return
      end

c This routine loads a block of lists into icore-addressable memory.

      subroutine aces_auxcache_ldblk(i0,iCrSiz,
     &                               iLeft0, iLeft1, iLeftInc,
     &                               iRight0,iRight1,iRightInc)
      implicit none

c ARGUMENTS
      integer i0, iCrSiz
      integer iLeft0, iLeft1, iLeftInc, iRight0, iRight1, iRightInc

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer iFam, iGrp, nRows, nCols, nInts, i

c COMMON BLOCKS
#include "icore.com" /* for icore */
#include "machsp.com" /* for iintfp */
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert icore info is sane
      if (i0.eq.0.or.iCrSiz.lt.0) then
         print *, '@ACES_AUXCACHE_LDBLK: Assertion failed.'
         print *, '   i0     = ',i0
         print *, '   iCrSiz = ',iCrSiz
         i = 1
      end if
c   o assert iLeft and iRight are properly bound
      if ((iLeft0 .lt.1).or.(_MAX_IO_GRPS.lt.iLeft0 ).or.
     &    (iLeft1 .lt.1).or.(_MAX_IO_GRPS.lt.iLeft1 ).or.
     &    (iRight0.lt.1).or.(_MAX_IO_FAMS.lt.iRight0).or.
     &    (iRight1.lt.1).or.(_MAX_IO_FAMS.lt.iRight1).or.
     &    (iLeftInc.eq.0).or.(iRightInc.eq.0)            ) then
         print *, '@ACES_AUXCACHE_LDBLK: Assertion failed.'
         print *, '   do iFam = ',iRight0,',',iRight1,',',iRightInc
         print *, '   do iGrp = ',iLeft0 ,',',iLeft1 ,',',iLeftInc
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o load lists
      do iFam = iRight0, iRight1, iRightInc
      do iGrp = iLeft0,  iLeft1,  iLeftInc
         if (quikget(iGrp,iFam).eq.0) then
            nCols = aces_list_cols(iGrp,iFam)
            nRows = aces_list_rows(iGrp,iFam)
            nInts = iintfp*nRows*nCols
            if (0.lt.nInts.and.nInts.lt.iCrSiz) then
c               print *, '@ACES_AUXCACHE_LDBLK: Loading ',iGrp,iFam
               call getlst(icore(i0),1,nCols,1,iGrp,iFam)
               quikget(iGrp,iFam) = i0
               i0     = i0     + nInts
               iCrSiz = iCrSiz - nInts
            end if
         end if
      end do
      end do

      return
c     end subroutine aces_auxcache_ldblk
      end

c This routine loads a block of lists into icore-addressable memory.

      subroutine aces_auxcache_ldblk(i0,iCrSiz,
     &                               iLeft0, iLeft1, iLeftInc,
     &                               iRight0,iRight1,iRightInc)
      implicit none

c ARGUMENTS
      integer i0, iCrSiz
      integer iLeft0, iLeft1, iLeftInc, iRight0, iRight1, iRightInc

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer iFam, iGrp, nRows, nCols, nInts, i

c COMMON BLOCKS


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end







c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c auxcache.com : begin

c The auxiliary cache is a programmer-controlled list cache. The dimensions are
c the same as those of the MOIO arrays. The programmer may load lists into icore
c memory and set quikget(?,?) to their icore addresses. When getlst and putlst
c operate on ANY list, quikget is checked to see if the list lives in icore.
c If so, the operation is performed on the in-core data instead of hitting the
c storage file(s).

c WARNING
c    There is no automatic updating of storage files with data in the auxiliary
c cache. If the memory-resident data is altered and must be stored to disk, then
c the quikget value must be destroyed (zeroed) and the actual location of the
c data must then be passed to putlst. The aces_auxcache_flush routine
c systematically stores the quikget values, calls putlst, and restores the
c quikget values.





      integer           quikget(10,500)
      common /auxcache/ quikget
      save   /auxcache/

c auxcache.com : end

c ----------------------------------------------------------------------

      i = 0
c   o assert icore info is sane
      if (i0.eq.0.or.iCrSiz.lt.0) then
         print *, '@ACES_AUXCACHE_LDBLK: Assertion failed.'
         print *, '   i0     = ',i0
         print *, '   iCrSiz = ',iCrSiz
         i = 1
      end if
c   o assert iLeft and iRight are properly bound
      if ((iLeft0 .lt.1).or.(10.lt.iLeft0 ).or.
     &    (iLeft1 .lt.1).or.(10.lt.iLeft1 ).or.
     &    (iRight0.lt.1).or.(500.lt.iRight0).or.
     &    (iRight1.lt.1).or.(500.lt.iRight1).or.
     &    (iLeftInc.eq.0).or.(iRightInc.eq.0)            ) then
         print *, '@ACES_AUXCACHE_LDBLK: Assertion failed.'
         print *, '   do iFam = ',iRight0,',',iRight1,',',iRightInc
         print *, '   do iGrp = ',iLeft0 ,',',iLeft1 ,',',iLeftInc
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)

c ----------------------------------------------------------------------

c   o load lists
      do iFam = iRight0, iRight1, iRightInc
      do iGrp = iLeft0,  iLeft1,  iLeftInc
         if (quikget(iGrp,iFam).eq.0) then
            nCols = aces_list_cols(iGrp,iFam)
            nRows = aces_list_rows(iGrp,iFam)
            nInts = iintfp*nRows*nCols
            if (0.lt.nInts.and.nInts.lt.iCrSiz) then
c               print *, '@ACES_AUXCACHE_LDBLK: Loading ',iGrp,iFam
               call getlst(icore(i0),1,nCols,1,iGrp,iFam)
               quikget(iGrp,iFam) = i0
               i0     = i0     + nInts
               iCrSiz = iCrSiz - nInts
            end if
         end if
      end do
      end do

      return
c     end subroutine aces_auxcache_ldblk
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function block_map_lookup(seg, nindex, array, 
     *                         array_table_entry,
     *                         index_table, nindex_table)
c-------------------------------------------------------------------------
c   Returns a lookup index into the block_map table for the block of a
c   given array that contains data for the segments (seg(i), i = 1, nindex).
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      integer nindex, array
      integer seg(nindex)
      integer array_table_entry(larray_table_entry)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
     
      integer i, n, index, eseg
      integer offset
      integer nseg(mx_array_index), bseg(mx_array_index)

c-------------------------------------------------------------------------
c   Look up the number of segments in each index.
c-------------------------------------------------------------------------

      do i = 1, nindex
         index = array_table_entry(c_index_original+i-1)
         bseg(i) = index_table(c_bseg, index)
         eseg    = index_table(c_eseg, index) 
         nseg(i) = eseg - bseg(i) + 1
      enddo

      offset = array_table_entry(c_block_map) + seg(1)-bseg(1)
      n = 1
      do i = 2, nindex
         n = n * nseg(i-1) 
         offset = offset + n * (seg(i) - bseg(i))
      enddo 

      block_map_lookup = offset
      return
      end

      SUBROUTINE AMPSUM(ICORE,MAXCOR,IUHF,NLIST,SING1,TYPE)
C
C THIS ROUTINE DRIVES A NUMBER OF ROUTINES WHICH DETERMINE AND PRINT
C  OUT THE LARGEST T2 AMPLITUDES.  ALL THREE SPIN CASES DONE FOR UHF,
C  AB ONLY FOR RHF.
C
c  NLIST -- list from which to read amplitudes
c           0 -- T amplitudes, 100 -- lambda
c  SING1 -- .TRUE. if singles included in calculation
c  TYPE  -- character*1 label for printouts ( usually 'T' or 'L')
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL SING1
      CHARACTER*1 TYPE
      DIMENSION ICORE(MAXCOR)
      COMMON /FLAGS/ IFLAGS(100)
      IF(IUHF.NE.0)THEN
       DO 10 I=1,2
        IF(SING1)CALL SORTT1(ICORE,MAXCOR,I,90+NLIST,IFLAGS(14),TYPE)
        CALL SORTT2(ICORE,MAXCOR,I,43+I+NLIST,IFLAGS(14),TYPE)
10     CONTINUE
       I=3
       CALL SORTT2(ICORE,MAXCOR,I,43+I+NLIST,IFLAGS(14),TYPE)
      ELSE
       IF(SING1)CALL SORTT1(ICORE,MAXCOR,1,90+NLIST,IFLAGS(14),TYPE)
       CALL SORTT2(ICORE,MAXCOR,1,44+NLIST,IFLAGS(14),TYPE)
       CALL SORTT2(ICORE,MAXCOR,3,46+NLIST,IFLAGS(14),TYPE)
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE COMPKMAT(DERBMAT,NRATMS,TOTREDNCO,FI,HC,
     &                    DIFTEMP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INTEGER TOTREDNCO
      DOUBLE PRECISION KMAT

#include "mxatms.par"

C KMAT is used as temporary storge while building DIFTEMP and it is of
C size 9*MXATMS*MXATMS (so it needs to be managed dynamically).

      DIMENSION DERBMAT(3*NRATMS,3*NRATMS*TOTREDNCO),
     &          FI(TOTREDNCO),HC(3*NRATMS,3*NRATMS),
     &          KMAT(3*NRATMS,3*NRATMS),
     &          DIFTEMP(3*NRATMS,3*NRATMS)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      CALL ZERO(KMAT,9*NRATMS*NRATMS)

      LENDBMAT = 9*NRATMS*NRATMS*TOTREDNCO
      CALL DGETREC(20,'JOBARC','DERBMAT',LENDBMAT,DERBMAT)

      DO I=1, TOTREDNCO
         IND=3*NRATMS*(I-1)+1
C
#ifdef _DEBUG_LVL0
         Write(6, "(a,4F10.5)") 'The gradients Compkmat: ',
     &        (FI(J), J=1, TOTREDNCO)
#endif
         CALL DSCAL(9*NRATMS*NRATMS,FI(I),DERBMAT(1,IND),1)
      END DO

      DO I=1,3*NRATMS
         DO J=1,3*NRATMS
            DO K=1,TOTREDNCO
               JTMP = (K-1)*3*NRATMS+J
               KMAT(I,J) = KMAT(I,J)+ DERBMAT(I,JTMP)
            END DO
         END DO
      END DO
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") 'The  Cartesian Hess'
      CALL OUTPUT(HC,1,3*NRATMS,1,3*NRATMS,3*NRATMS,
     &            3*NRATMS,1)
#endif
C
      DO I=1,3*NRATMS
         DO J=1,3*NRATMS
            DIFTEMP(I,J)=HC(I,J)-KMAT(I,J)
         END DO
      END DO
C
#ifdef _DEBUG_LVL0
      Write(6,*) 'In COMPKMAT: The (HC-K) Matrix'
      CALL OUTPUT(DIFTEMP,1,3*NRATMS,1,3*NRATMS,3*NRATMS,
     &            3*NRATMS,1)
#endif

      RETURN
      END

      SUBROUTINE NEWEVC(EVEC,SCR,NBAS,ISPIN)
C
C THIS ROUTINE REORDERS AN EIGENVECTOR MATRIX FROM THE MO ORDERING
C  TO SCF ORDERING FOR A SPECIFIC SPIN CASE
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIRPRD,POP,VRT
      DIMENSION EVEC(NBAS,NBAS),SCR(NBAS,NBAS)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF(2),NF2(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
C
      ITHRU=1
C
C COPY OCCUPIED MO VECTORS INTO SCR
C
      IOFF0=1
      DO 10 IRREP=1,NIRREP
       IOFF=IOFF0
       NOCC=POP(IRREP,ISPIN)
       DO 20 I=1,NOCC
        CALL SCOPY(NBAS,EVEC(1,ITHRU),1,SCR(1,IOFF),1)
        write(6,*)' copied ',ioff,' to ',ithru
        IOFF=IOFF+1
        ITHRU=ITHRU+1
20     CONTINUE
       IOFF0=IOFF0+POP(IRREP,ISPIN)+VRT(IRREP,ISPIN)
10    CONTINUE
C
C COPY VIRTUAL MO VECTORS INTO SCR
C
      IOFF0=POP(1,ISPIN)+1
      DO 110 IRREP=1,NIRREP
       IOFF=IOFF0
       NVRT=VRT(IRREP,ISPIN)
       DO 120 I=1,NVRT
        CALL SCOPY(NBAS,EVEC(1,ITHRU),1,SCR(1,IOFF),1)
        write(6,*)' copied ',ioff,' to ',ithru
        IOFF=IOFF+1
        ITHRU=ITHRU+1
120    CONTINUE
       IF(IRREP.NE.NIRREP)IOFF0=IOFF0+NVRT+POP(IRREP+1,ISPIN)
110   CONTINUE
C
C NOW OVERWRITE ORIGINAL EIGENVECTORS WITH REORDERED ONES
C
      CALL SCOPY (NBAS*NBAS,SCR,1,EVEC,1)
C
      RETURN
      END  

C THIS ROUTINE CONSTRUCTS THE FORCE CONSTANT MATRIX FOR SYMMETRY
C BLOCK NDIM FROM NUMERICAL DIFFERENTIATION OF INTERNAL COORDINATE
C (SYMMETRY ADAPTED AND MASS WEIGHTED) GRADIENTS

C 07/98, Extensions for Raman Intensities, Ajith and John

c INPUT
c integer NATOM     :
c integer NDIM      :
c double  GRDPNT(*) :
c double  DIPPNT(*) :
c double  POLPNT(*) :
c integer INVOP(*)  :
c double  SYOP(*)   :
c double  STPSIZ    :
c integer NDSCR     :

c OUTPUT
c double FCM(*)      :
c double DIPDER(*)   :
c double POLDER(*)   :
c double DSCR(NDSCR) :

      SUBROUTINE GRAD2FCM(NATOM,NDIM,
     &                    GRDPNT,FCM,
     &                    DIPPNT,DIPDER,
     &                    POLPNT,POLDER,
     &                    INVOP,SYOP,STPSIZ,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION GRDPNT(*),FCM(NDIM,NDIM)
      DIMENSION DIPPNT(*),DIPDER(3,NDIM)
      DIMENSION POLPNT(*),POLDER(9,NDIM)
      DIMENSION INVOP(NDIM),SYOP(*)
      double precision dscr(ndscr)

      DIMENSION DA3(3),DA3x3(3,3),WORK3x3(3,3)
      LOGICAL PRINTQ

      COMMON /FLAGS/ IFLAGS(100)
#include "control.com" /* for RAMAN */

      DATA ZILCH /0.0/
      DATA FACT /5.14048D03/

      IF (NDSCR.LT.NDIM*(1+2*NDIM)) THEN
         print *, '@GRAD2FCM: Insufficient memory.'
         print *, '           have ',NDSCR,' doubles'
         print *, '           need ',NDIM*(1+2*NDIM),' doubles'
         call aces_exit(1)
      END IF

      PRINTQ=(IFLAGS(1).GE.1)

      NSIZE=3*NATOM

C IF THE REPRESENTATION IS TOTALLY SYMMETRIC, THEN WE HAVE DONE ONLY
C ONE DISPLACEMENT FOR EACH DEGREE OF FREEDOM.
C NOW BUILD THE FCM ROW BY ROW.  EASY STUFF.

      IF (INVOP(1).LE.0) THEN

c      o cases with positive and negative displacements
         IOFF1=0
         IOFF2=NSIZE
         IOFF1D=0
         IOFF2D=3
         IOFF1P=0
         IOFF2P=9
         DO IDIM=1,NDIM
            DO I = 1, NDIM
               FCM(I,IDIM) = GRDPNT(IOFF1+I)-GRDPNT(IOFF2+I)
            END DO
            IOFF1=IOFF1+2*NSIZE
            IOFF2=IOFF2+2*NSIZE
            DIPDER(1,IDIM) = DIPPNT(IOFF1D+1)-DIPPNT(IOFF2D+1)
            DIPDER(2,IDIM) = DIPPNT(IOFF1D+2)-DIPPNT(IOFF2D+2)
            DIPDER(3,IDIM) = DIPPNT(IOFF1D+3)-DIPPNT(IOFF2D+3)
            IOFF1D=IOFF1D+6
            IOFF2D=IOFF2D+6
            DO I = 1, 9
               POLDER(I,IDIM) = POLPNT(IOFF1P+I)-POLPNT(IOFF2P+I)
            END DO
            IOFF1P=IOFF1P+18
            IOFF2P=IOFF2P+18
         END DO
         FFACT=0.5d0/STPSIZ
         CALL DSCAL(NDIM*NDIM,FFACT,FCM,   1)
         CALL DSCAL(   3*NDIM,FFACT,DIPDER,1)
         CALL DSCAL(   9*NDIM,FFACT,POLDER,1)

      ELSE

c      o cases with only one displacement
         IOFF1=1
         IOFF1D=1
         IOFF1P=1
         DO IDIM=1,NDIM
            IOP=INVOP(IDIM)
            IPOS=1+(IOP-1)*9
            CALL DCOPY(NDIM,GRDPNT(IOFF1),1,FCM(1,IDIM),1)
            IOFF1=IOFF1+NSIZE
c         o generate image dipole
            CALL XGEMM('N','N',3,1,3,
     &                 1.d0,SYOP(IPOS),    3,
     &                      DIPPNT(IOFF1D),3,
     &                 0.d0,DIPDER(1,IDIM),3)
            CALL DAXPY(3,-1.d0,DIPPNT(IOFF1D),1,DIPDER(1,IDIM),1)
            IOFF1D=IOFF1D+3
C 07/98 Ajith and John, generate polarizabilty image.
            CALL XGEMM('N','N',3,3,3,
     &                 1.d0,SYOP(IPOS),    3,
     &                      POLPNT(IOFF1P),3,
     &                 0.d0,DA3x3,         3)
            CALL XGEMM('N','T',3,3,3,
     &                 1.d0,DA3x3,         3,
     &                      SYOP(IPOS),    3,
     &                 0.d0,POLDER(1,IDIM),3)
            CALL DAXPY(9,-1.d0,POLPNT(IOFF1P),1,POLDER(1,IDIM),1)
            IOFF1P=IOFF1P+9
         END DO
         FFACT=0.5d0/STPSIZ
         CALL DSCAL(NDIM*NDIM,2.d0*FFACT,FCM,   1)
         CALL DSCAL(   3*NDIM,     FFACT,DIPDER,1)
         CALL DSCAL(   9*NDIM,     FFACT,POLDER,1)

      END IF

      IF (PRINTQ) THEN
         WRITE(6,1010)
1010     FORMAT(T3,'Force constant matrix : ')
         WRITE(6,1011)((I,J,FCM(I,J),J=1,NDIM),I=1,NDIM)
1011     FORMAT(3('[',I3,',',I3,']',1X,F9.6,1X),'[',I3,',',I3,']',1X,
     &          F9.6)
      END IF

c   o initialize DSCR pointers for FCM e.vectors and dipder in norm coords
      NFCEV = 1+NDIM
      NDDNC = NFCEV + NDIM*NDIM

c   o diagonalize force constant matrix
      CALL SYMMET2(FCM,NDIM)
      CALL DCOPY(NDIM*NDIM,FCM,1,DSCR(NFCEV),1)
      L = NDSCR - NDIM*(1+NDIM)
      CALL DSYEV('V','U',NDIM,DSCR(NFCEV),NDIM,DSCR(1),DSCR(NDDNC),L,I)
      if (i.ne.0) then
         print *, '@GRAD2FCM: Eigensolver failed.'
         print *, '           dsyev returned error ',i
         call aces_exit(i)
      end if

c   o transform dipole derivatives to normal coordinate representation
      CALL XGEMM('N','N',3,NDIM,NDIM,
     &           1.d0,DIPDER,     3,
     &                DSCR(NFCEV),NDIM,
     &           0.d0,DSCR(NDDNC),3)

      IF (RAMAN) THEN
         Write(6, *) "Raman Intensities and depolarization ratios"
         NDX = NFCEV
         DO IMODE=1,NDIM
c         o transform polarizability derivatives to normal coordinates
            CALL XGEMM('N','N',9,1,NDIM,
     &                 1.d0,POLDER,   9,
     &                      DSCR(NDX),NDIM,
     &                 0.d0,DA3x3,    9)
            NDX = NDX+NDIM
c         o convert the tensor into its principal axis orientation
            CALL DSYEV('N','U',3,DA3x3,3,DA3,WORK3x3,9,I)
            ALPHA = ( DA3(1)
     &               +DA3(2)
     &               +DA3(3))/3.0D0
            BETAS = ( (DA3(1)-DA3(2))**2
     &               +(DA3(2)-DA3(3))**2
     &               +(DA3(3)-DA3(1))**2)*0.5D0
            IF (ALPHA .NE. 0.0D0) THEN
               DTMP = 45.0D0*ALPHA*ALPHA + 4.0D0*BETAS
               RMNIN = 0.0784159D0*(DTMP + 3.0D0*BETAS)
               DEPOL = 3.0D0*BETAS/DTMP
            ELSE
               RMNIN = 0.0784159D0*7.0D0*BETAS
               DEPOL = 0.75D0
            END IF
            Write(6,*) IMODE,RMNIN,DEPOL
         END DO
      END IF

c   o write out frequencies and intensities
      WRITE(6,1000)
1000  FORMAT(T3,'Vibrational frequencies  (cm-1) :')
      NDX = NDDNC
      DO IMODE=1,NDIM
         W=DNRM2(3,DSCR(NDX),1)
         ZINT=W*W*974.868
         NDX=NDX+3
         X=DSCR(IMODE)
         IF (X.LT.ZILCH) THEN
            Z=SQRT(-X)*FACT
            WRITE(6,1001)IMODE,Z,ZINT
1001        FORMAT(T3,I5,1X,F10.5,'i ',F10.5)
         ELSE
            Z=SQRT(X)*FACT
            WRITE(6,1002)IMODE,Z,ZINT
1002        FORMAT(T3,I5,1X,F10.5,2X,F10.5)
         END IF
      END DO

      RETURN
      END

      subroutine mat_print_tri_sub(which,diag,mat,nrow,title,collab,
     &                             rowlab,numwid,ndec,
     &                             r0_in,r1_in,c0_in,c1_in)
      implicit none

      integer nrow,numwid,ndec,r0_in,r1_in,c0_in,c1_in
      character*1 which,diag
      double precision mat(nrow,nrow)
      character*(*) title,collab,rowlab

      integer pagewid
      parameter (pagewid=80)

      character*80 f,fn,fb,frh,frb,fch,fc,fr
      character*10 tmpn,tmpm,tmpl,tmpw,tmpd,tmp
      integer rownumlen,numcol,col0,col1,n,irow,icol,cols(pagewid),off,
     &        nblank,c,r0,r1,c0,c1,cc,r,rr
      integer  strlen
      external strlen
      logical top

      c0=c0_in
      c1=c1_in
      r0=r0_in
      r1=r1_in

c Check some error conditions...
      if (nrow.lt.1 .or. ndec.lt.0 .or. numwid.lt.1 .or.
     &    numwid.gt.pagewid/2 .or. ndec.gt.numwid-2 .or.
     &    r0.lt.1 .or. r0.gt.nrow .or. c0.lt.1 .or. c0.gt.nrow .or.
     &    r0.gt.r1 .or. c0.gt.c1 .or. (which.ne.'u' .and. which.ne.'U'
     &    .and. which.ne.'l' .and. which.ne.'L') .or. (diag.ne.'d' .and.
     &    diag.ne.'D' .and. diag.ne.'n' .and. diag.ne.'N')) then
         write(*,*) '@MAT_PRINT_TRI_SUB: invalid parameter'
         stop
      end if

      top=(which.eq.'u' .or. which.eq.'U')
      off=1
      if (diag.eq.'d' .or. diag.eq.'D') off=0

c Some columns/rows end up totally blank.  Remove them.
      if (top) then
         if (c0.lt.r0+off) c0=r0+off
         if (r1.gt.c0-off) r1=c1-off
      else
         if (c1.gt.r1-off) c1=r1-off
         if (r0.lt.c0+off) r0=c0+off
      end if

c Some combinations don't include anything to print
      if ((top .and. r0.gt.c0+off) .or. (.not.top .and. r1.lt.c1-off))
     &   return

c The number of digits in the row
      rownumlen=1+(log10(nrow*1.d0))
c The maximum number of columns to print
      numcol=(pagewid-(strlen(rowlab)+1+rownumlen))/(numwid+1)

c Formats are:
c   fn = '(x,fW.D)'            : a single number
c   fb = '(W+1x)'              : a blank number field
c   frh= '(aN,x,iM,'           : a row header
c   frb= '(N+M+1x,'            : a blank row header
c   f  = '(aN,x,iM,L(x,fW.D))' : a left justified set of numbers
c   fch= '(aN+M+1,L(x,iW))'    : a column header
c   fc = '(N+M+1x,L(x,W('-')))': the 2nd line of the column header
c where
c   N : strlen(rowlab)
c   M : rownumlen
c   L : numcol
c   W : numwid
c   D : ndec

      write(tmpw,'(i10)') numwid
      write(tmpd,'(i10)') ndec
      call delspc(tmpw,tmpw)
      call delspc(tmpd,tmpd)
      fn='(x,f'//tmpw(1:strlen(tmpw))//'.'//tmpd(1:strlen(tmpd))//')'
      write(tmp,'(i10)') numwid+1
      call delspc(tmp,tmp)
      fb='('//tmp(1:strlen(tmp))//'x)'

      write(tmpn,'(i10)') strlen(rowlab)
      write(tmpm,'(i10)') rownumlen
      call delspc(tmpn,tmpn)
      call delspc(tmpm,tmpm)
      frh='(a'//tmpn(1:strlen(tmpn))//',x,i'//tmpm(1:strlen(tmpm))//','
      write(tmp,'(i10)') strlen(rowlab)+rownumlen+1
      call delspc(tmp,tmp)
      frb='('//tmp(1:strlen(tmp))//'x,'

      write(tmpl,'(i10)') numcol
      call delspc(tmpl,tmpl)
      f=frh(1:strlen(frh))//tmpl(1:strlen(tmpl))//fn(1:strlen(fn))//')'

      fch='(a'//tmp(1:strlen(tmp))//','//tmpl(1:strlen(tmpl))//'(x,i'
     &    //tmpw(1:strlen(tmpw))//'))'

      col0=c0
      col1=c0+numcol-1
      if (col1.gt.c1) col1=c1
      write(*,*) title
      write(*,*)

   10 continue

c The actual number of columns to print
      n=col1-col0+1
      write(tmpn,'(i10)') n
      call delspc(tmpn,tmpn)
      fc=frb(1:strlen(frb))//tmpn(1:strlen(tmpn))//'(x,'//
     &   tmpw(1:strlen(tmpw))//'(''-'')))'

      do icol=col0,col1
         cols(icol-col0+1)=icol
      end do
      write(*,fch) collab,(cols(icol-col0+1),icol=col0,col1)
      write(*,fc)

      r=r0
      rr=r1
      if (top .and. rr.gt.col1-off) rr=col1-off
      if (.not.top .and. r.lt.col0+off) r=col0+off

      do irow=r,rr
         c=col0
         cc=col1
         nblank=0
         if (top .and. col0.lt.irow+off) then
            nblank=irow+off-col0
            c=irow+off
         endif
         if (.not.top .and. col1.gt.irow-off) cc=irow-off
         if (nblank.eq.0) then
            write(*,f) rowlab,irow,(mat(irow,icol),icol=c,cc)
         else
            write(tmp,'(i10)') nblank
            call delspc(tmp,tmp)
            fr=frh(1:strlen(frh))//tmp(1:strlen(tmp))//fb(1:strlen(fb))
     &         //','//tmpl(1:strlen(tmpl))//fn(1:strlen(fn))//')'
            write(*,fr) rowlab,irow,(mat(irow,icol),icol=c,cc)
         end if
      end do
      write(*,*)

      if (col1.lt.c1) then
         col0=col0+numcol
         col1=col1+numcol
         if (col1.gt.c1) col1=c1
         goto 10
      end if

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine contract_oed_2derv_integrals(type, density, z,
     *                       da1, da2, db1, db2, hess)
c---------------------------------------------------------------------------
c  Computes the set of OED second derivative integrals matching "type" and 
c  contracts them with density block (da1:da2, db1:db2). Note that the 
c  density block may be the density(for type = 1,2) or an intermediate
c  array(for type = 3).
c
c   type = 1 --> NAI integrals
c          2 --> KIN integrals
c          3 --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      include 'parallel_info.h'
      include 'trace.h'

      integer type
      integer da1, da2, db1, db2
      double precision density(da1:da2, db1:db2)
      double precision z(da1:da2, db1:db2)
      double precision hess(3*ncenters, 3*ncenters)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif

      integer i, j, m, n, nfirst, nints, nalpha, ncoeff, iatom, jatom 
      integer icomponent, jcomponent, ix, jx, ncsum  
      integer a, b, a1,a2,b1,b2,lastao, ihess, jhess 
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc, jxderc 
      integer ind(2)
      integer flopcount
      logical spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, x, y, tess, fact

      if (type .lt. 1 .or. type .gt. 3) then
         print *,'Error: Invalid type in contract_oed_2derv_integrals'
         print *,'type = ',type
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif
      spherical = (ispherical .eq. 1)
      lastao    = end_nfps(nshells)

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: contract_oed_2derv_integrals requires ERD ',
     *           'integral package.'
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block of density data.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)
      
c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       do m = m1, m2
       do n = n1, n2

            ncsum = ncfps(m) + ncfps(n) 
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)
 
            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend), 
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff )

       if (type .eq. 2 .or. type .eq. 3) then 

c loop over derivatives on centers

         do icomponent = 1, 3   ! i component is x, y, or z term of hessian  
         do jcomponent = 1, 3   ! j component is x, y, or z term of hessian  
         do ix = 1, 2          ! index of desired center of i component 
         do jx = 1, 2          ! index of desired center of j component 

c-------------------------------------------------------------------------
c   Clear the integral block.
c-------------------------------------------------------------------------

          do b = db1, db2
          do a = da1, da2
             z(a,b) = 0.
          enddo
          enddo

             der1x = 0
             der1y = 0
             der1z = 0
             der2x = 0
             der2y = 0
             der2z = 0
c
c Check if 'derivatives' equal 
c
             if((icomponent .eq. jcomponent) .and. (ix .eq. jx)) then 
c 
             if (icomponent .eq. 1) then
                if (ix .eq. 1) then
                   der1x = 2
                   if (atom(m) .eq. atom(n)) der2x = 2
                   iatom = atom(m)
                   jatom = atom(m)
                else
                   der2x = 2
                   if (atom(m) .eq. atom(n)) der1x = 2
                   iatom = atom(n)
                   jatom = atom(n)
                endif
             endif

             if (icomponent .eq. 2) then
                if (ix .eq. 1) then
                   der1y = 2
                   if (atom(m) .eq. atom(n)) der2y = 2
                   iatom = atom(m)
                   jatom = atom(m)
                else
                   der2y = 2
                   if (atom(m) .eq. atom(n)) der1y = 2
                   iatom = atom(n)
                   jatom = atom(n)
                endif
             endif

             if (icomponent .eq. 3) then
                if (ix .eq. 1) then
                   der1z = 2
                   if (atom(m) .eq. atom(n)) der2z = 2
                   iatom = atom(m)
                   jatom = atom(m)
                else
                   der2z = 2
                   if (atom(m) .eq. atom(n)) der1z = 2
                   iatom = atom(n)
                   jatom = atom(n)
                endif
             endif 
             go to 999 
             endif 
c
c set first derivative index 
c 
             if (icomponent .eq. 1) then
                if (ix .eq. 1) then
                   der1x = 1
                   if (atom(m) .eq. atom(n)) der2x = 1
                   iatom = atom(m)
                else
                   der2x = 1
                   if (atom(m) .eq. atom(n)) der1x = 1
                   iatom = atom(n)
                endif
             endif

             if (icomponent .eq. 2) then
                if (ix .eq. 1) then
                   der1y = 1
                   if (atom(m) .eq. atom(n)) der2y = 1
                   iatom = atom(m)
                else
                   der2y = 1
                   if (atom(m) .eq. atom(n)) der1y = 1
                   iatom = atom(n)
                endif
             endif

             if (icomponent .eq. 3) then
                if (ix .eq. 1) then
                   der1z = 1
                   if (atom(m) .eq. atom(n)) der2z = 1
                   iatom = atom(m)
                else
                   der2z = 1
                   if (atom(m) .eq. atom(n)) der1z = 1
                   iatom = atom(n)
                endif
             endif
c
c set second derivative index 
c 
             if (jcomponent .eq. 1) then
                if (jx .eq. 1) then
                   der1x = der1x + 1
                   if (atom(m) .eq. atom(n)) der2x = der1x !1
                   jatom = atom(m)
                else
                   der2x = der2x + 1
                   if (atom(m) .eq. atom(n)) der1x = der2x !1
                   jatom = atom(n)
                endif
             endif

             if (jcomponent .eq. 2) then
                if (jx .eq. 1) then
                   der1y = der1y + 1
                   if (atom(m) .eq. atom(n)) der2y = der1y !1
                   jatom = atom(m)
                else
                   der2y = der2y + 1
                   if (atom(m) .eq. atom(n)) der1y = der2y !1
                   jatom = atom(n)
                endif
             endif

             if (jcomponent .eq. 3) then
                if (jx .eq. 1) then
                   der1z = der1z + 1
                   if (atom(m) .eq. atom(n)) der2z = der1z !1
                   jatom = atom(m)
                else
                   der2z = der2z + 1
                   if (atom(m) .eq. atom(n)) der1z = der2z !1
                   jatom = atom(n)
                endif
             endif

999         continue 
               if (type .eq. 2) then
                  call oed__gener_kin_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               else if (type .eq. 3) then
                  call oed__gener_ovl_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,spherical,
     *                 .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               endif

            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

                call move_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)

c--------------------------------------------------------------------------
c   Contract the density block with the block of integrals.
c--------------------------------------------------------------------------

               call cwork0222(y,
     *                        density,da1,da2,db1,db2,
     *                        da1,da2,db1,db2, ind,
     *                        z,da1,da2,db1,db2,
     *                        da1,da2,db1,db2,ind(1), ind(2),
     *                        flopcount)

c---------------------------------------------------------------------------
c   Sum into the hessian.
c---------------------------------------------------------------------------

              ihess = (iatom-1)*3 + icomponent 
              jhess = (jatom-1)*3 + jcomponent 

              hess(jhess,ihess) = hess(jhess,ihess) + y 

             endif

         enddo ! jx
         enddo ! ix
         enddo ! jcomponent
         enddo ! icomponent

         endif ! ktype = 2,3

         enddo   ! n shells
         enddo   ! m shells

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine mark_block_clean(iblock, server_table,nserver_table)
c----------------------------------------------------------------------------
c   Marks a block as "clean".
c----------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'parallel_info.h'
      integer iblock, nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer ptr, flagval

      ptr = server_table_ptr(iblock)
      flagval = and(server_table(c_server_flags,ptr),
     *              server_dirty_flag)
      server_table(c_server_flags,ptr) = xor(flagval,
     *       server_table(c_server_flags,ptr))
      call push_clean_block(iblock, server_table, nserver_table)

c-----------------------------------------------------------------------------
c   Remove block from dirty list.
c-----------------------------------------------------------------------------

      if (dirty_list_head .eq. 0)  return
      if (dirty_list_head .eq. iblock) then
         dirty_list_head = dirty_list_ptr(iblock)
         if (iblock .eq. dirty_list_tail) dirty_list_tail = 0
         ndirty = ndirty - 1
         return
      endif 

      ptr = dirty_list_head
  100 continue
      if (ptr .eq. 0) then
         print *,'Error: Cannot find block ',iblock,
     *      ' in list of dirty blocks'
         call server_abort_job(server_table, nserver_table)
      endif

      if (dirty_list_ptr(ptr) .eq. iblock) then
         dirty_list_ptr(ptr) = dirty_list_ptr(iblock)
         dirty_list_ptr(iblock) = 0 
         if (iblock .eq. dirty_list_tail) dirty_list_tail = ptr
         ndirty = ndirty - 1
         return
      endif

      ptr = dirty_list_ptr(ptr)

      go to 100
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine jobarc_query(up, mod)
c----------------------------------------------------------------------------
c   Query the JOBARC subsystem.
c----------------------------------------------------------------------------
#include "jobarc.com"
     
      logical up, mod
  
      up  = bJAup
      mod = bJAmod
      return
      end 

#include "flags.h"
C
      Subroutine A3_ECP_set4_grdint(Iecp,Nmax,namat,iqmstr,jcostr,
     &                              nucstr, nrcstr, Jstrt, Jrs, 
     &                              Expa, Nalpha, Cont, Npcoef, 
     &                              Coord, Charge)
C      
      Implicit Double Precision(A-H, O-Z)

#include "ecp.par"
#include "ecp.com"
#include "flags.com"
#include "flags2.com"
C
      Character*2 mtype(Max_centers)
      Character*80 Cnick(Max_centers)
      Character*80 Ecpnam(Max_centers)
      Character*4 namat(max_centers)
      Logical Nharm, Grads
C
      Dimension iqmstr(Max_centers),jcostr(Max_centers,maxjco),
     &          nucstr(Max_centers,Maxang,Maxjco),
     &          nrcstr(Max_centers,Maxang,Maxjco),
     &          Jstrt(Max_shells),Jrs(Max_shells),Expa(Nalpha),
     &          Cont(Npcoef),Coord(3,Max_centers),
     &          IGenby(Max_centers), Charge(Max_centers)
C
C ECP deriavtive integrals. Except for simplifications, I have kept the 
C original  form of all the input/output ECP processing routines. This was 
C originaly written by Christien Huber, Ajith Perera, 12/2001.
C
C - Natoms is the number of symmetry unique atoms
C - Ipseux is 0 when no ECP definitions; > 0 otherwise.
C - Cnick is the name of then ECP 
C - iqmstr highest ang. mom. qun. num.(AMQN) for each atom.
C - jcostr has the AQMN for each shell (each atom). Normally the # of shells
C   is the same as the Max AMQN but some cases there may be mutiple shells
C   with the same AQMN, so jcostr tells you how many.
C - nucstr is the number of primitives per each shell (per atom,per AQMN).
C - nrcstr is the number of contracted functions per each shell
C   (per atom,per AQMN)
C - nhram is logical that tells you whether this is sperical or 
C   cartesian basis calculation (key-word driven)
C - I must add that the names choosen for those 4 variables are dumb!!
C   
      nharm = (Iflags(h_IFLAGS_spherical) .EQ. 1)
      Itol  = Iflags(h_IFLAGS2_intgrl_tol)
      Thres = Dble(10.0D+00*(-Itol))
 
      if (iecp.ne.0) then
c-----------------------------------------------------------------------
c get atomsymbols and put them to mtype-array
c-----------------------------------------------------------------------
         ierr=0
         call chrges(CHARGE,mtype,natoms,ierr)
c-----------------------------------------------------------------------
c read ecp data and prepare data for evulation of the c integrals
c-----------------------------------------------------------------------

         if (ierr.eq.0) then
             ipr=0
             call ecpdef(natoms,mtype,Ecpnam,cnick)

             if (ierr.eq.0) then
                ipr=0
                call ecppar(ipr,cnick,CHARGE,natoms,.FALSE.,0)
C
c-----------------------------------------------------------------------
c prepare data for ecp integral evaluation
c-----------------------------------------------------------------------
                Call ecp_init
                Call A3_ecp_basis_init_4grd(Natoms, Namat,
     &                                      Iqmstr, Jcostr, Nucstr, 
     &                                      Nrcstr, Jstrt, Jrs, Expa,
     &                                      Nalpha, Cont, Npcoef, 
     &                                      Nharm)
          
c-----------------------------------------------------------------------
             else
                write(6,"(a)") 'ERROR while reading ECP data!'
                write(6,"(a)") 'Please check yourECPDATA file.'
                Call Errex
             endif

         else
             write(6,"(a)") 'E R R O R in subroutine chrges!'
             Call Errex
         endif
c-----------------------------------------------------------------------

      Endif

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine setup_ccbeg(alpha, ixalpha, pcoeff, ixpcoeff, 
     *                       ncfps, npfps, nshells, ccbeg, ccend,
     *                       indx_cc)
c---------------------------------------------------------------------------
c   Computes the beginning and ending non-zero contraction coefficients,
c   used to gain efficiency in the ERD integral package.
c---------------------------------------------------------------------------
      implicit none
      
      integer nshells
      integer ncfps(*), npfps(*), ixalpha(*), ixpcoeff(*)
      integer nalpha, npcoeff
      double precision alpha(*), pcoeff(*)
      integer ccbeg(*), ccend(*), indx_cc(nshells)
      integer i, j, ishell
      integer k, l, icc

      icc = 1
      do ishell = 1, nshells
         indx_cc(ishell) = icc
         do k = 1, ncfps(ishell)
           l = (k-1)*npfps(ishell) + 1
           do i = 1, npfps(ishell)
              if (pcoeff(ixpcoeff(ishell)+l-1) .ne. 0.d0) then
                 ccbeg(icc) = i
                 go to 10
              endif
              l = l + 1
           enddo
   10      continue

           l = k*npfps(ishell)
           do i = npfps(ishell), 1, -1
              if (pcoeff(ixpcoeff(ishell)+l-1) .ne. 0.d0) then
                 ccend(icc) = i
                 go to 20
              endif
              l = l - 1
           enddo
   20      continue 

           icc = icc + 1
         enddo   ! k
      enddo      ! ishell

      return
      end  

C THIS ROUTINE DETERMINES WHICH ENERGIES ARE CALCULATED TO
C EVALUATE THE FORCE CONSTANT MATRIX
C AND GENERATES THE APPROPRIATE *CARTESIAN* GEOMETRIES

c INPUT
c integer NATOM              : NUMBER OF ATOMS IN THE MOLECULE (WITH DUMMIES)
c integer NDIM               : NUMBER OF COORDINATES IN THIS IRREP
c double  SYMQ(3*NATOM,NDIM) : SYMMETRY ADAPTED COORDINATES FOR THIS IRREP
c double  COORD(3*NATOM)     : CARTESIAN COORDINATES OF THE REFERENCE STRUCTURE
c double  STPSIZ             : STEP SIZE FOR DISPLACEMENTS IN MASS-WEIGHTED
c                              CARTESIAN COORDINATES
c double  VMASS(NATOM)       : INVERSE SQUARE ROOTS OF THE ATOMIC MASSES
c integer INVOP(NDIM)
c logical PRINTQ             : VERBOSE PRINTING FLAG
c integer NDSCR              : AMOUNT OF DOUBLE SCRATCH AT DSCR

c OUTPUT
c double  POINTS(3*NATOM,*) : COORDINATES USED IN FD ENERGY CALCULATIONS
c integer NPOINT            : NUMBER OF ENERGY CALCS REQ'D FOR THIS IRREP
c double  DSCR(NDSCR)       : (scr) double scratch

#include "flags.h"

      SUBROUTINE DOENER(NATOM,NDIM,SYMQ,COORD,STPSIZ,VMASS,
     &                  POINTS,NPOINT,
     &                  INVOP,PRINTQ,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SYMQ(3*NATOM,NDIM),COORD(3*NATOM),VMASS(NATOM)
      DIMENSION POINTS(*),INVOP(NDIM),DSCR(NDSCR)
      LOGICAL PRINTQ

      LOGICAL ONEGRD
      CHARACTER*5 PHASE(2)

#include "control.com" /* for GMTRYOPT */

      DATA PHASE /'plus ','minus'/

      NSIZE=3*NATOM
      PRINTQ = .TRUE. 

      if (ndscr.lt.nsize*2) then
         print *, '@DOENER: Insufficient memory.'
         print *, '         have ',ndscr,' doubles'
         print *, '         need ',nsize*2,' doubles'
         call aces_exit(1)
      end if

C LOOP OVER DIMENSIONALITY OF SUBSPACE.  FOR ENERGIES, WE NEED
C PURE AND MIXED DISPLACEMENTS FOR ALL POSSIBLE MODES.  THERE
C WILL BE [NDIM*(NDIM+1)]/2 OF THESE.

      IOFFP=1
      NPOINT=0
      DO IDIM1=1,NDIM

C SCALE SYMMETRY COORDINATE VECTOR FOR DIMENSION IDIM1 AND TRANSFORM
C TO PURE CARTESIAN COORDINATES

         CALL DCOPY(NSIZE,SYMQ(1,IDIM1),1,DSCR,1)
         CALL DSCAL(NSIZE,STPSIZ,DSCR,1)
         NDX = 1
         DO IATOM=1,NATOM
            DSCR(NDX+0) = DSCR(NDX+0)*VMASS(IATOM)
            DSCR(NDX+1) = DSCR(NDX+1)*VMASS(IATOM)
            DSCR(NDX+2) = DSCR(NDX+2)*VMASS(IATOM)
            NDX = NDX+3
         END DO

C LOOP OVER SECOND DISPLACEMENT AND DO THE SAME STUFF

         DO IDIM2=1,IDIM1
            ONEGRD=(INVOP(IDIM1).GT.0).AND.(INVOP(IDIM2).GT.0)
         if (.not.gmtryopt.or.idim1.eq.idim2) then
            CALL DCOPY(NSIZE,SYMQ(1,IDIM2),1,DSCR(NSIZE+1),1)
            CALL DSCAL(NSIZE,STPSIZ,DSCR(NSIZE+1),1)
            NDX = 1+NSIZE
            DO IATOM=1,NATOM
               DSCR(NDX+0) = DSCR(NDX+0)*VMASS(IATOM)
               DSCR(NDX+1) = DSCR(NDX+1)*VMASS(IATOM)
               DSCR(NDX+2) = DSCR(NDX+2)*VMASS(IATOM)
               NDX = NDX+3
            END DO

            IF (IDIM1.EQ.IDIM2) THEN

c            o generate positive displacement
               CALL VADD(POINTS(IOFFP),COORD,DSCR,NSIZE,1.d0)
               IOFFP=IOFFP+NSIZE
               NPOINT=NPOINT+1

c            o generate negative displacement (totally symmetric irrep only)
               IF (.NOT.ONEGRD) THEN
                  CALL VADD(POINTS(IOFFP),COORD,DSCR,NSIZE,-1.d0)
                  IOFFP=IOFFP+NSIZE
                  NPOINT=NPOINT+1
               END IF

            ELSE

c            o generate +/+ displacements
               CALL VADD(POINTS(IOFFP),COORD,DSCR,NSIZE,1.d0)
               CALL DAXPY(NSIZE,1.d0,DSCR(NSIZE+1),1,POINTS(IOFFP),1)
               IOFFP=IOFFP+NSIZE
               NPOINT=NPOINT+1

c            o generate -/- displacements
               IF (.NOT.ONEGRD) THEN
                  CALL VADD(POINTS(IOFFP),COORD,DSCR,NSIZE,-1.d0)
                  CALL DAXPY(NSIZE,-1.d0,DSCR(NSIZE+1),1,
     &                                   POINTS(IOFFP),1)
                  IOFFP=IOFFP+NSIZE
                  NPOINT=NPOINT+1
               END IF

            END IF

         end if
         END DO

      END DO

      IF (PRINTQ) THEN
         WRITE(6,1000)
1000     FORMAT(T3,'Geometries used for energy calculations : ')
         IOFF=1
         IF (ONEGRD) THEN
            ITOP=1
         ELSE
            ITOP=2
         END IF
         DO IDIM1=1,NDIM
            DO IDIM2=1,IDIM1
            if (.not.gmtryopt.or.idim1.eq.idim2) then
               DO IPHASE=1,ITOP
                  IF (IDIM1.EQ.IDIM2) THEN
                     WRITE(6,1001)IDIM1,PHASE(IPHASE)
1001                 FORMAT(T3,'Symmetry coordinate : ',i3,' Phase : ',
     &                      a,' Type : Energy')
                  ELSE
                     WRITE(6,1002)IDIM1,IDIM2,PHASE(IPHASE)
1002                 FORMAT(T3,'Symmetry coordinates (mixed) : ',i3,i3,
     &                      ' Phase : ',a,' Type : Energy')
                  END IF
                  DO IATOM=1,NATOM
                     WRITE(6,1003)IATOM,(POINTS(IPOS),IPOS=IOFF,IOFF+2)
1003                 FORMAT(T3,I5,3F20.10)
                     IOFF=IOFF+3
                  END DO
               END DO
            end if
            END DO
         END DO
      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine dropmo_expand_basis(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Dumps all blocks of an array to a list.
c   Uses new format (i. e. written with MPI_IO) BLOCK_INDEX/BLOCKDATA files.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'dbugcom.h'
      include 'blkmgr.h'
      include 'dropmo.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'sip_tables.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
      pointer (iptr, esegtable)
      pointer (iptr2, eindex_table)
      pointer (dptr2, scr_dropmo)
#else
      common x, scr_dropmo, esegtable, eindex_table
#endif
    
      integer proc, company_comm
      integer pst_get_company_comm, pst_get_company_rank
      integer*8 get_index_from_base
      integer*8 nmem_bytes
      integer   nmem_words
      integer*8 iblkmgr, idropmo
      integer*8 isegbase_exp, iexp_segtable, iexp_index_table
      integer   ensegment_table, ierr, ndropmo_blksize
      integer esegtable(1), eindex_table(1)
      double precision scr_dropmo(1)

      integer nestacks
      parameter (nestacks = max_stacks)
      integer estack_blocksizes(nestacks)

#ifdef ALTIX
      dptr = dshptr
      dptr2 = dshptr
      iptr = ishptr
      iptr2 = ishptr
#endif

      if (ndropmo_a .eq. 0 .and. ndropmo_b .eq. 0) return

      company_comm    = pst_get_company_comm(me)
      proc  = pst_get_company_rank(me)
      if (proc .eq. 0) then

c VFL Stupid temporary skip 12/13/2012 
c        call mem_alloc_free(first_blk_addr, ierr)  ! release blkmgr memory.

c        if (ierr .ne. 0) then
c           print *,'Task ',me,' Error in mem_alloc_free'
c           call abort_job()
c        endif
 
         ndropmo_blksize = stack_blocksize(nblkmgr_stacks) ! save largest blksize
         call mem_alloc(scr_dropmo, ndropmo_blksize, bytes_per_double,
     *                  idropmo, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Task ',me,' mem_alloc error in dropmo_expand_basis'
            print *,'Attempted to malloc ',ndropmo_blksize,' doubles.'
            call abort_job()
         endif  

         iexp_index_table = get_index_from_base(eindex_table_base, 
     *                       eindex_table, 1)

c---------------------------------------------------------------------------
c   Determine the proper segmentation that will be set up for the data
c   in the expanded basis set.
c---------------------------------------------------------------------------

         call get_expanded_basis_segsizes(enalpha_occupied,
     *           enalpha_virtual, enbeta_occupied, enbeta_virtual)

c---------------------------------------------------------------------------
c   Build a new segment table based on the expanded basis.
c---------------------------------------------------------------------------

         call build_segment_table(eindex_table(iexp_index_table), 
     *             nindex_table,
     *             end_nfps, nshells, sip_mx_ao_segsize,
     *             sip_mx_occ_segsize, sip_mx_virt_segsize,
     *             sip_sub_segsize, sip_sub_occ_segsize,
     *             sip_sub_virt_segsize, sip_sub_ao_segsize,
     *             enbeta_occupied, enalpha_occupied, enbeta_occupied,
     *             enalpha_virtual, enalpha_virtual, enbeta_virtual,
     *             isegbase_exp,ensegment_table, estack_blocksizes,
     *             nestacks, array_table, narray_table, .false.,
     *             atom)

          iexp_segtable = get_index_from_base(isegbase_exp, 
     *                                esegtable, 1)

          if (mpi_io_support) then
             call dropmo_expand_process_data_mpi_io(array_table, 
     *            narray_table,
     *            index_table, nindex_table,segment_table,
     *            nsegment_table, block_map_table, nblock_map_table,
     *            eindex_table(iexp_index_table), 
     *            esegtable(iexp_segtable), ensegment_table,
     *            scr_dropmo(idropmo), ndropmo_blksize)
          else
             call dropmo_expand_process_data_no_mpi_io(array_table,
     *            narray_table,
     *            index_table, nindex_table,segment_table,
     *            nsegment_table, block_map_table, nblock_map_table,
     *            eindex_table(iexp_index_table),
     *            esegtable(iexp_segtable), ensegment_table,
     *            scr_dropmo(idropmo), ndropmo_blksize)
          endif
      endif

      return
      end

      subroutine dropmo_expand_process_data_mpi_io(array_table, 
     *            narray_table,
     *            index_table, nindex_table,segment_table,
     *            nsegment_table, block_map_table, nblock_map_table,
     *            eindex_table, esegtable, ensegment_table,
     *            scr_dropmo, ndropmo_blksize)
c--------------------------------------------------------------------------
c   Performs the actual processing of the dropmo expansion for each 
c   array in the blockdata_list array.
c   Uses new format (i. e. MPI_IO-written) BLOCK_INDEX/BLOCKDATA files.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'block_index.h'
      include 'dbugcom.h'
      include 'blkmgr.h'
      include 'dropmo.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, ensegment_table
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer eindex_table(lindex_table_entry, nindex_table)
      integer esegtable(lsegment_table_entry, ensegment_table)

      integer ndropmo_blksize
      double precision scr_dropmo(ndropmo_blksize)

      integer list_unit, list_unit2, data_unit, data_unit2
      integer*8 data_ptr, data_ptr2, next_diskaddr
      integer ios
      logical is_file_open
 
      integer i, j, n, n_eblocks, max_eblocks, max_eblksize
      integer nindex, array, darray, iarray, ierr, map
      integer memloc
      integer dnindex, dblock
      integer index(mx_array_index), seg(mx_array_index)
      integer index_type(mx_array_index)
      integer dval1(mx_array_index), dval2(mx_array_index)  
      integer bseg(mx_array_index), eseg(mx_array_index), 
     *        nseg(mx_array_index)
      integer e_bseg(mx_array_index), e_eseg(mx_array_index), 
     *        e_nseg(mx_array_index)
      integer val1(mx_array_index), val2(mx_array_index), iblk,
     *        ieblk, nxeblocks
      integer*8 ixeblocks, i8size, malloced_previously
      integer*8 ieb, idiskloc, ixx
      integer*8 index_file_loc, index_file_loc2
      integer block_index_entry(lblk_index_entry)

      integer eblock_table(1)
      integer*8 diskloc_table(1)
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
      pointer (iptr, eblock_table)
      pointer (i8ptr, diskloc_table)
#else
      common x, diskloc_table, eblock_table
#endif
      logical restart

#ifdef ALTIX
      dptr = dshptr
      iptr = ishptr
      i8ptr = i8shptr
#endif

c---------------------------------------------------------------------------
c   Open files.
c---------------------------------------------------------------------------

      call f_openfile('BLOCK_INDEX'//char(0), list_unit)
      call f_openfile('BLOCKDATA' // char(0), data_unit)
      data_ptr = 0
      call f_creatfile('BLOCK_INDEX2'//char(0), list_unit2)
      call f_creatfile('BLOCKDATA2' // char(0), data_unit2)
      data_ptr2 = 0

c-------------------------------------------------------------------------
c   Determine max. number of expanded blocks, max. expanded blocksize.
c-------------------------------------------------------------------------

      max_eblocks = 0
      max_eblksize = 0
      do iarray = 1, narray_list
         array = array_list(iarray)
         nb = array_table(c_numblks, array)

         nindex = array_table(c_nindex, array)
         
         n_eblocks = 1
         do i = 1, nindex
            index(i) = array_table(c_index_array1+i-1,array)
            bseg(i)  = index_table(c_bseg, index(i))
            eseg(i)  = index_table(c_eseg, index(i)) 
            nseg(i)  = index_table(c_nsegments, index(i))

            e_bseg(i) = eindex_table(c_bseg, index(i)) 
            e_eseg(i) = eindex_table(c_eseg, index(i)) 
            e_nseg(i) = eindex_table(c_nsegments, index(i)) 

            n_eblocks = n_eblocks * e_nseg(i)
         enddo

c         print *,'DROPMO_EXPAND_BASIS: array ',array
c         print *,'number of blocks before expansion ',nb
c         print *,'number of blocks after expansion ',n_eblocks
         max_eblocks = max(max_eblocks, n_eblocks) 

c-------------------------------------------------------------------------
c   Loop over all blocks to determine max blocksize.
c-------------------------------------------------------------------------

         do i = 1, nindex
            seg(i) = e_bseg(i)
         enddo
         
         do iblk = 1, n_eblocks
            n = 1
            do i = 1, nindex
               call get_index_segment(index(i), seg(i), esegtable,
     *                             ensegment_table, eindex_table,
     *                             nindex_table, val1, val2)

               n = n * (val2(1) - val1(1) + 1) 
            enddo
      
            max_eblksize = max(max_eblksize, n)

c--------------------------------------------------------------------------
c   Increment segment indices for next block.
c--------------------------------------------------------------------------

            if (i .lt. n_eblocks) then 
               i = 1
  100          continue
               seg(i) = seg(i) + 1 
               if (seg(i) .gt. e_nseg(i)) then
                  seg(i)= e_bseg(i)
                  i = i + 1
                  go to 100
               endif
            endif
         enddo
 
      enddo    ! iarray

c      print *,'max blocks for all arrays ',max_eblocks
c      print *,'max blksize for all eblocks ',max_eblksize

c-------------------------------------------------------------------------
c   Allocate memory.
c-------------------------------------------------------------------------

      call mem_alloc(eblock_table, max_eblocks * leblock_entry, 
     *               intsize, ieb, .true., ierr)

      call mem_alloc(diskloc_table, max_eblocks, 8, idiskloc, 
     *               .true., ierr)
      
      call mem_alloc_query(malloced_previously)
      i8size = maxmem * 1024
      i8size = i8size * 1024
      n = (i8size - malloced_previously) / bytes_per_double
      call mem_alloc(x, n, bytes_per_double, ixeblocks, .true., ierr)
      nxeblocks = n / max_eblksize
 
c-------------------------------------------------------------------------
c   Main processing loop.
c-------------------------------------------------------------------------

      next_diskaddr = 0
      index_file_loc = 0
      index_file_loc2 = 0
      do iarray = 1, narray_list
         array  = array_list(iarray)
         nb     = array_table(c_numblks, array)
         nindex = array_table(c_nindex, array)
         map    = array_table(c_block_map, array)
c         print *,'Processing array ',iarray,' nb ',nb,' nindex ',
c     *         nindex,' indices = ',
c     *   (array_table(c_index_array1+i-1,array),i=1,nindex)

         n_eblocks = 1
         do i = 1, nindex
            index(i) = array_table(c_index_array1+i-1,array)
            index_type(i) = index_table(c_index_type, index(i))
            bseg(i)  = index_table(c_bseg, index(i))
            eseg(i)  = index_table(c_eseg, index(i))
            nseg(i)  = index_table(c_nsegments, index(i))

            e_bseg(i) = eindex_table(c_bseg, index(i))
            e_eseg(i) = eindex_table(c_eseg, index(i))
            e_nseg(i) = eindex_table(c_nsegments, index(i))

            n_eblocks = n_eblocks * e_nseg(i)
         enddo

c         print *,'e_bseg ',(e_bseg(i),i=1,nindex)
c         print *,'e_eseg ',(e_eseg(i),i=1,nindex)
c         print *,'e_nseg ',(e_nseg(i),i=1,nindex)

c-------------------------------------------------------------------------
c   Build the eblock tables.
c-------------------------------------------------------------------------

c         print *,'next_diskaddr for array ',array ,' is ',
c     *       next_diskaddr
         call build_eblock_table(eblock_table(ieb), max_eblocks,
     *         n_eblocks, e_bseg, e_eseg, e_nseg, nindex, 
     *         diskloc_table(idiskloc), index, esegtable, 
     *         ensegment_table, eindex_table, nindex_table,
     *         next_diskaddr)
       
c         print *,'Processing array ',array,' n_eblocks = ',n_eblocks

         restart = .true.
         do iblk = 1, nb

c-------------------------------------------------------------------------
c   Read a descriptor record from the BLOCK_INDEX file.
c-------------------------------------------------------------------------

            call f_read_disk_ints(list_unit, index_file_loc,
     *              block_index_entry, lblk_index_entry)
            index_file_loc = index_file_loc + lblk_index_entry

            darray =  block_index_entry(c_blk_index_array)
            dblock = block_index_entry(c_blk_index_blkno)
            dnindex = block_index_entry(c_blk_index_nind)
            n = block_index_entry(c_blk_index_size)
            do i = 1, nindex
               dval1(i) = block_index_entry(c_blk_index_bsegs+i-1)
               dval2(i) = block_index_entry(c_blk_index_esegs+i-1)
            enddo

c--------------------------------------------------------------------------
c   Read the data block from disk.
c--------------------------------------------------------------------------

            call f_read_disk(data_unit, data_ptr, scr_dropmo, n)
            data_ptr = data_ptr + n

c---------------------------------------------------------------------------
c   Form the contribution of this (dropmo) block into all eblocks to which
c   it contributes.
c---------------------------------------------------------------------------

            call contribute_eblocks(scr_dropmo, dval1, dval2, nindex,
     *                eblock_table(ieb), n_eblocks, 
     *                diskloc_table(idiskloc), data_unit2, 
     *                x(ixeblocks), nxeblocks, max_eblksize, 
     *                index_type, restart)
            restart = .false.
         enddo   ! iblk

c-------------------------------------------------------------------------
c   Write BLOCK_INDEX2 data for the array and flush out any unwritten
c   eblocks to BLOCKDATA2.
c-------------------------------------------------------------------------

         do ieblk = 1, n_eblocks

c--------------------------------------------------------------------------
c   Write out the BLOCK_INDEX2 data for the eblock.
c--------------------------------------------------------------------------

            ixx = ieb + (ieblk-1) * leblock_entry

            nindex = array_table(c_nindex, array)
            n      = eblock_table(ixx+c_eblock_blksize-1)

            do i = 1, nindex
               dval1(i) = eblock_table(ixx+c_eblock_range1+i-2)
               dval2(i) = eblock_table(ixx+c_eblock_range2+i-2)
            enddo
 
            block_index_entry(c_blk_index_array) = array
            block_index_entry(c_blk_index_blkno) = ieblk
            block_index_entry(c_blk_index_size)  = n
            block_index_entry(c_blk_index_nind)  = nindex
            do i = 1, nindex
               block_index_entry(c_blk_index_bsegs+i-1) = dval1(i)
               block_index_entry(c_blk_index_esegs+i-1) = dval2(i)
            enddo

            call f_write_disk_ints(list_unit2, index_file_loc2,
     *                  block_index_entry, lblk_index_entry)
            index_file_loc2 = index_file_loc2 + lblk_index_entry 
         enddo

         call flush_eblocks(eblock_table(ieb), n_eblocks,
     *              diskloc_table(idiskloc),
     *              data_unit2, x(ixeblocks), nxeblocks)

c         print *,'Processing of array ',array,' is complete.'
      enddo      ! iarray

c-------------------------------------------------------------------------
c   Close files.
c-------------------------------------------------------------------------

      call f_close_file(list_unit)
      call f_close_file(list_unit2)
      call f_close_file(data_unit)
      call f_close_file(data_unit2)

c--------------------------------------------------------------------------
c   Rename the files.
c--------------------------------------------------------------------------

      call f_renamefile('BLOCK_INDEX2'//char(0),'BLOCK_INDEX'//char(0))
      call f_renamefile('BLOCKDATA2'//char(0),'BLOCKDATA'//char(0))
      return
      end

      subroutine dropmo_expand_process_data_no_mpi_io(array_table, 
     *            narray_table,
     *            index_table, nindex_table,segment_table,
     *            nsegment_table, block_map_table, nblock_map_table,
     *            eindex_table, esegtable, ensegment_table,
     *            scr_dropmo, ndropmo_blksize)
c--------------------------------------------------------------------------
c   Performs the actual processing of the dropmo expansion for each 
c   array in the blockdata_list array.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'dbugcom.h'
      include 'blkmgr.h'
      include 'dropmo.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, ensegment_table
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer eindex_table(lindex_table_entry, nindex_table)
      integer esegtable(lsegment_table_entry, ensegment_table)

      integer ndropmo_blksize
      double precision scr_dropmo(ndropmo_blksize)

      integer list_unit, list_unit2, data_unit, data_unit2
      integer*8 data_ptr, data_ptr2, next_diskaddr
      integer ios
      logical is_file_open
 
      integer i, j, n, n_eblocks, max_eblocks, max_eblksize
      integer nindex, array, darray, iarray, ierr, map
      integer memloc
      integer dnindex, dblock
      integer index(mx_array_index), seg(mx_array_index)
      integer dseg(mx_array_index)
      integer index_type(mx_array_index), dindex_type(mx_array_index)
      integer dval1(mx_array_index), dval2(mx_array_index)  
      integer bseg(mx_array_index), eseg(mx_array_index), 
     *        nseg(mx_array_index)
      integer e_bseg(mx_array_index), e_eseg(mx_array_index), 
     *        e_nseg(mx_array_index)
      integer val1(mx_array_index), val2(mx_array_index), iblk,
     *        ieblk, nxeblocks
      integer*8 ixeblocks, i8size, malloced_previously
      integer*8 ieb, idiskloc, ixx

      integer eblock_table(1)
      integer*8 diskloc_table(1)
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
      pointer (iptr, eblock_table)
      pointer (i8ptr, diskloc_table)
#else
      common x, diskloc_table, eblock_table
#endif
      logical restart

#ifdef ALTIX
      dptr = dshptr
      iptr = ishptr
      i8ptr = i8shptr
#endif

c---------------------------------------------------------------------------
c   Open files.
c---------------------------------------------------------------------------

      list_unit = 29
      inquire (unit = list_unit, opened=is_file_open)
      if (is_file_open) then
         rewind list_unit
      else
         open (unit = list_unit, file='BLOCK_INDEX',err = 1000,
     *      iostat=ios, access='SEQUENTIAL', form='UNFORMATTED',
     *      status='OLD')
      endif

      call f_openfile('BLOCKDATA' // char(0), data_unit)
      data_ptr = 0

      list_unit2 = 30
      inquire (unit = list_unit2, opened=is_file_open)
      if (is_file_open) then
         rewind list_unit2
      else
         open (unit = list_unit2, file='BLOCK_INDEX2',err = 1000,
     *      iostat=ios, access='SEQUENTIAL', form='UNFORMATTED',
     *      status='NEW')
      endif

      call f_creatfile('BLOCKDATA2' // char(0), data_unit2)
      data_ptr2 = 0

c-------------------------------------------------------------------------
c   Determine max. number of expanded blocks, max. expanded blocksize.
c-------------------------------------------------------------------------

      max_eblocks = 0
      max_eblksize = 0
      do iarray = 1, narray_list
         array = array_list(iarray)
         nb = array_table(c_numblks, array)

         nindex = array_table(c_nindex, array)
         
         n_eblocks = 1
         do i = 1, nindex
            index(i) = array_table(c_index_array1+i-1,array)
            bseg(i)  = index_table(c_bseg, index(i))
            eseg(i)  = index_table(c_eseg, index(i)) 
            nseg(i)  = index_table(c_nsegments, index(i))

            e_bseg(i) = eindex_table(c_bseg, index(i)) 
            e_eseg(i) = eindex_table(c_eseg, index(i)) 
            e_nseg(i) = eindex_table(c_nsegments, index(i)) 

            n_eblocks = n_eblocks * e_nseg(i)
         enddo

c         print *,'DROPMO_EXPAND_BASIS: array ',array
c         print *,'number of blocks before expansion ',nb
c         print *,'number of blocks after expansion ',n_eblocks
         max_eblocks = max(max_eblocks, n_eblocks) 

c-------------------------------------------------------------------------
c   Loop over all blocks to determine max blocksize.
c-------------------------------------------------------------------------

         do i = 1, nindex
            seg(i) = e_bseg(i)
         enddo
         
         do iblk = 1, n_eblocks
            n = 1
            do i = 1, nindex
               call get_index_segment(index(i), seg(i), esegtable,
     *                             ensegment_table, eindex_table,
     *                             nindex_table, val1, val2)

               n = n * (val2(1) - val1(1) + 1) 
            enddo
      
            max_eblksize = max(max_eblksize, n)

c--------------------------------------------------------------------------
c   Increment segment indices for next block.
c--------------------------------------------------------------------------

            if (i .lt. n_eblocks) then 
               i = 1
  100          continue
               seg(i) = seg(i) + 1 
               if (seg(i) .gt. e_nseg(i)) then
                  seg(i)= e_bseg(i)
                  i = i + 1
                  go to 100
               endif
            endif
         enddo
 
      enddo    ! iarray

c      print *,'max blocks for all arrays ',max_eblocks
c      print *,'max blksize for all eblocks ',max_eblksize

c-------------------------------------------------------------------------
c   Allocate memory.
c-------------------------------------------------------------------------

      call mem_alloc(eblock_table, max_eblocks * leblock_entry, 
     *               intsize, ieb, .true., ierr)

      call mem_alloc(diskloc_table, max_eblocks, 8, idiskloc, 
     *               .true., ierr)
      
      call mem_alloc_query(malloced_previously)
      i8size = maxmem * 1024
      i8size = i8size * 1024
      n = (i8size - malloced_previously) / bytes_per_double
      call mem_alloc(x, n, bytes_per_double, ixeblocks, .true., ierr)
      nxeblocks = n / max_eblksize
 
c-------------------------------------------------------------------------
c   Main processing loop.
c-------------------------------------------------------------------------

      next_diskaddr = 0
      do iarray = 1, narray_list
         array  = array_list(iarray)
         nb     = array_table(c_numblks, array)
         nindex = array_table(c_nindex, array)
         map    = array_table(c_block_map, array)
c         print *,'Processing array ',iarray,' nb ',nb,' nindex ',
c     *         nindex,' indices = ',
c     *   (array_table(c_index_array1+i-1,array),i=1,nindex)

         n_eblocks = 1
         do i = 1, nindex
            index(i) = array_table(c_index_array1+i-1,array)
            index_type(i) = index_table(c_index_type, index(i))
            bseg(i)  = index_table(c_bseg, index(i))
            eseg(i)  = index_table(c_eseg, index(i))
            nseg(i)  = index_table(c_nsegments, index(i))

            e_bseg(i) = eindex_table(c_bseg, index(i))
            e_eseg(i) = eindex_table(c_eseg, index(i))
            e_nseg(i) = eindex_table(c_nsegments, index(i))

            n_eblocks = n_eblocks * e_nseg(i)
         enddo

c         print *,'e_bseg ',(e_bseg(i),i=1,nindex)
c         print *,'e_eseg ',(e_eseg(i),i=1,nindex)
c         print *,'e_nseg ',(e_nseg(i),i=1,nindex)

c-------------------------------------------------------------------------
c   Build the eblock tables.
c-------------------------------------------------------------------------

c         print *,'next_diskaddr for array ',array ,' is ',
c     *       next_diskaddr
         call build_eblock_table(eblock_table(ieb), max_eblocks,
     *         n_eblocks, e_bseg, e_eseg, e_nseg, nindex, 
     *         diskloc_table(idiskloc), index, esegtable, 
     *         ensegment_table, eindex_table, nindex_table,
     *         next_diskaddr)
       
c         print *,'Processing array ',array,' n_eblocks = ',n_eblocks

         restart = .true.
         do iblk = 1, nb

c-------------------------------------------------------------------------
c   Read a descriptor record from the BLOCK_INDEX file.
c-------------------------------------------------------------------------

c            print *,'   Read block ',iblk,' from BLOCKDATA'
            read (list_unit) darray, dblock, dnindex, n,
     *                       (dindex_type(i),i=1,nindex),
     *                       (dseg(i),i=1,nindex),
     *                       (dval1(i),i=1,nindex),
     *                       (dval2(i),i=1,nindex)

c--------------------------------------------------------------------------
c   Make sure the indices match with respect to number and type.
c--------------------------------------------------------------------------

            ierr = 0
            if (dnindex .ne. nindex) ierr = 1
            do i = 1, nindex
               if (dindex_type(i) .ne. index_type(i)) ierr = 1
            enddo

c---------------------------------------------------------------------------
c   Make sure the (dropmo) segment values match the segment values on disk.
c---------------------------------------------------------------------------

            n = 1
            do i = 1, nindex
               seg(i) = block_map_table(c_block_map_seg+i-1,
     *                                  map+dblock-1)
               if (seg(i) .ne. dseg(i)) ierr = 1

               call get_index_segment(index(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
               if (dval1(i) .ne. val1(i)) ierr = 1
               if (dval2(i) .ne. val2(i)) ierr = 1
               n = n * (val2(i) - val1(i) + 1)
            enddo

            if (ierr .eq. 1) then
               print *,'Error in LIST_TO_BLOCKS: ',
     *               'Index data does not match data ',
     *              'for current job.'
               print *,'nindex ',nindex,' dnindex ',dnindex
               print *,'index_type: ',(index_type(i),i=1,nindex),
     *               ' dindex_type: ',(dindex_type(i),i=1,nindex)
               print *,'seg: ',(seg(i),i=1,nindex),' dseg ',
     *              (dseg(i),i=1,nindex)
               print *,'val1: ',(val1(i),i=1,nindex),' dval1: ',
     *                (dval1(i),i=1,nindex)
               print *,'val2: ',(val2(i),i=1,nindex),' dval2: ',
     *                (dval2(i),i=1,nindex)
               call abort_job()
            endif

c--------------------------------------------------------------------------
c   Read the data block from disk.
c--------------------------------------------------------------------------

            call f_read_disk(data_unit, data_ptr, scr_dropmo, n)
            data_ptr = data_ptr + n

c---------------------------------------------------------------------------
c   Form the contribution of this (dropmo) block into all eblocks to which
c   it contributes.
c---------------------------------------------------------------------------

            call contribute_eblocks(scr_dropmo, val1, val2, nindex,
     *                eblock_table(ieb), n_eblocks, 
     *                diskloc_table(idiskloc), data_unit2, 
     *                x(ixeblocks), nxeblocks, max_eblksize, 
     *                index_type, restart)
            restart = .false.
         enddo   ! iblk

c-------------------------------------------------------------------------
c   Write BLOCK_INDEX2 data for the array and flush out any unwritten
c   eblocks to BLOCKDATA2.
c-------------------------------------------------------------------------

         do ieblk = 1, n_eblocks

c--------------------------------------------------------------------------
c   Write out the BLOCK_INDEX2 data for the eblock.
c--------------------------------------------------------------------------

            ixx = ieb + (ieblk-1) * leblock_entry

            nindex = array_table(c_nindex, array)
            n      = eblock_table(ixx+c_eblock_blksize-1)

            do i = 1, nindex
               dseg(i) = eblock_table(ixx+c_eblock_segs+i-2)
               dval1(i) = eblock_table(ixx+c_eblock_range1+i-2)
               dval2(i) = eblock_table(ixx+c_eblock_range2+i-2)

               index(i) = array_table(c_index_array1+i-1,array) 
               dindex_type(i) = index_table(c_index_type, index(i))
            enddo
 
            write (list_unit2) array, ieblk, nindex, n,
     *                       (dindex_type(i),i=1,nindex),
     *                       (dseg(i),i=1,nindex),
     *                       (dval1(i),i=1,nindex),
     *                       (dval2(i),i=1,nindex)
         enddo

         call flush_eblocks(eblock_table(ieb), n_eblocks,
     *              diskloc_table(idiskloc),
     *              data_unit2, x(ixeblocks), nxeblocks)

c         print *,'Processing of array ',array,' is complete.'
      enddo      ! iarray

c-------------------------------------------------------------------------
c   Close files.
c-------------------------------------------------------------------------

      close (list_unit)
      close (list_unit2)
      call f_close_file(data_unit)
      call f_close_file(data_unit2)

c--------------------------------------------------------------------------
c   Rename the files.
c--------------------------------------------------------------------------

      call f_renamefile('BLOCK_INDEX2'//char(0),'BLOCK_INDEX'//char(0))
      call f_renamefile('BLOCKDATA2'//char(0),'BLOCKDATA'//char(0))
      return

 1000 continue
      print *,'Cannot open BLOCK_INDEX or BLOCKDATA files.'
      print *,'I/O status = ',ios
      call abort_job()
      end

      subroutine build_eblock_table(eblock_table, max_eblocks,
     *         n_eblocks, e_bseg, e_eseg, e_nseg, nindex, 
     *         diskloc_table, index, esegtable, ensegment_table,
     *         eindex_table, nindex_table, diskaddr)
c-------------------------------------------------------------------------
c   Initializes the table entries for the eblock control table.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'

      integer max_eblocks
      integer eblock_table(leblock_entry, max_eblocks)
      integer n_eblocks, nindex
      integer e_bseg(nindex), e_eseg(nindex), e_nseg(nindex)
      integer*8 diskloc_table(max_eblocks)
      integer index(nindex)
      integer ensegment_table
      integer esegtable(lsegment_table_entry,ensegment_table)
      integer nindex_table
      integer eindex_table(lindex_table_entry,nindex_table)

      integer i, j, k, n, seg(nindex)
      integer val1, val2
      integer*8 diskaddr

      do i = 1, nindex
         seg(i) = e_bseg(i)
      enddo

      do i = 1, n_eblocks
         eblock_table(c_eblock_memloc,i) = -1  ! uninitialized
         n = 1
         do j = 1, nindex
            eblock_table(c_eblock_segs+j-1,i) = seg(j)

c-------------------------------------------------------------------------
c   Look up the segment ranges and store them.
c-------------------------------------------------------------------------

            call get_index_segment(index(j), seg(j), esegtable,
     *                       ensegment_table, eindex_table,
     *                       nindex_table, val1, val2)
            eblock_table(c_eblock_range1+j-1,i) = val1
            eblock_table(c_eblock_range2+j-1,i) = val2  
            n = n * (val2 - val1 + 1)
         enddo

         eblock_table(c_eblock_blksize,i) = n
         diskloc_table(i) = diskaddr
c         print *,'   BUILD_EBLOCK: eblock ',i,' size ',n,' diskloc ',
c     *      diskloc_table(i)
         diskaddr = diskaddr + n

c--------------------------------------------------------------------------
c   Increment segment indices for next block.
c--------------------------------------------------------------------------

         if (i .lt. n_eblocks) then   ! no need for last eblock.
            j = 1
  100       continue
            seg(j) = seg(j) + 1
            if (seg(j) .gt. e_eseg(j)) then
               seg(j)= e_bseg(j)
               j = j + 1
               if (j .gt. nindex) then
                  print *,'ERROR: seg range err in build_eblock_table'
                  print *,'j, nindex ',j,nindex
                  print *,'seg ',(seg(k),k=1,nindex)
                  print *,'e_bseg ',(e_bseg(k),k=1,nindex)
                  print *,'e_eseg ',(e_eseg(k),k=1,nindex)
                  call abort_job()
               endif
 
               go to 100
            endif
         endif
      enddo
 
      return
      end

      subroutine contribute_eblocks(data, val1, val2, nindex,
     *                eblock_table, n_eblocks, diskloc_table,
     *                data_unit2, scr, nscr_blks, max_blksize,
     *                index_type, restart)
c--------------------------------------------------------------------------
c   Stores the contribution of one dropmo block into all eblocks to 
c   which it contributes.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'machine_types.h'
      include 'dropmo.h'

      double precision data(*)
      integer nindex
      integer val1(nindex), val2(nindex)
      integer n_eblocks
      integer eblock_table(leblock_entry, n_eblocks)
      integer*8 diskloc_table(n_eblocks)
      integer data_unit2
      integer nscr_blks, max_blksize
      double precision scr(*)
      integer index_type(nindex)
      
      integer i, j, k, l, noverlap, memloc
      integer eval1(nindex), eval2(nindex)
      integer oval1(nindex), oval2(nindex)
      integer ival1(nindex), ival2(nindex)

      integer iblkuse, next_block
      integer ncontrib_blocks
      logical restart
      save next_block

      if (restart) next_block = 1

c-------------------------------------------------------------------------
c   Remap the mo-typeindices into the expanded basis.  Non-mo-indices 
c   are passed through unchanged.
c-------------------------------------------------------------------------

      do i = 1, nindex
         if (index_type(i) .eq. moindex .or. 
     *       index_type(i) .eq. moaindex) then
            ival1(i) = moamap(val1(i))
            ival2(i) = moamap(val2(i))
         else if (index_type(i) .eq. mobindex) then
            ival1(i) = mobmap(val1(i))
            ival2(i) = mobmap(val2(i))
         else
            ival1(i) = val1(i)
            ival2(i) = val1(i)
         endif
      enddo
 
c      print *,'      ival = ',(ival1(j),ival2(j),j=1,nindex)

      ncontrib_blocks = 0
      do i = 1, n_eblocks
         
c-------------------------------------------------------------------------
c   Determine overlap between the current block and the ith eblock.
c-------------------------------------------------------------------------

         noverlap = 0
         do j = 1, nindex
            eval1(j) = eblock_table(c_eblock_range1+j-1,i)
            eval2(j) = eblock_table(c_eblock_range2+j-1,i)
            if (ival1(j) .le. eval2(j) .and. 
     *          ival2(j) .ge. eval1(j)) then
               noverlap = noverlap + 1
               oval1(j) = max(ival1(j), eval1(j))
               oval2(j) = min(ival2(j), eval2(j))
            else
               oval1(j) = 0
               oval2(j) = 0 
            endif
         enddo

         if (noverlap .eq. nindex) then
            ncontrib_blocks = ncontrib_blocks + 1

c-------------------------------------------------------------------------
c   The data block contributes to this eblock. Find the data.
c-------------------------------------------------------------------------

            memloc = eblock_table(c_eblock_memloc,i)
            iblkuse = 0
c            print *,'Block contributes to e_block ',i,' memloc ',
c     *          memloc
            if (memloc .le. 0) then

c--------------------------------------------------------------------------
c   Is there a block that has never been used?
c--------------------------------------------------------------------------
           
c               print *,'next_block, nscr_blks ',next_block,nscr_blks
               if (next_block .le. nscr_blks) then
                  iblkuse = next_block
                  next_block = next_block + 1  
                  go to 100
               endif

c--------------------------------------------------------------------------
c   The eblocks have been exhausted. Flush them to disk. 
c--------------------------------------------------------------------------

               call flush_eblocks(eblock_table, n_eblocks, 
     *              diskloc_table,
     *              data_unit2, scr, nscr_blks)
               iblkuse = 1

  100          continue
               if (iblkuse .eq. 0) then
                  print *,'Error: blocks are full in ',
     *               ' dropmo_expand_basis' 
                  print *,'e_block_table:'
                  do k = 1, n_eblocks
                     print *,'Entry ',k,' : ',(eblock_table(l,k),
     *                 l = 1,leblock_entry)
                  enddo
                  call abort_job()  
               endif
                
c-----------------------------------------------------------------------
c   Set the table values.
c-----------------------------------------------------------------------
 
               memloc = (iblkuse-1)*max_blksize + 1
c               print *,'Move data to memloc ',memloc,' iblkuse ',
c     *            iblkuse 
               if (eblock_table(c_eblock_memloc,i) .lt. 0) then
c                  print *,'Initialize iblkuse ',iblkuse,' to 0.'
c                  print *,'blksize = ',
c     *                  eblock_table(c_eblock_blksize,i)

c---------------------------------------------------------------------------
c   This is a totally new block.  Initialize it to 0's.
c---------------------------------------------------------------------------
 
                  do j = 1, eblock_table(c_eblock_blksize,i)
                     scr(memloc+j-1) = 0
                  enddo 
               else

c--------------------------------------------------------------------------
c   Read the previous contributions in from disk.
c--------------------------------------------------------------------------

c                  print *,'Read iblkuse ',iblkuse,' from disk loc ',
c     *                  diskloc_table(i),' blksize = ',
c     *                  eblock_table(c_eblock_blksize,i)
                  call f_read_disk(data_unit2, diskloc_table(i), 
     *              scr(memloc), eblock_table(c_eblock_blksize,i)) 
               endif
            endif

            eblock_table(c_eblock_memloc,i) = memloc

c--------------------------------------------------------------------------
c   Store into the eblock.
c--------------------------------------------------------------------------

            do j = 1, nindex
               eval1(j) = eblock_table(c_eblock_range1+j-1,i) 
               eval2(j) = eblock_table(c_eblock_range2+j-1,i) 
            enddo

            if (nindex .eq. 2) then
               call eblock2_contribution(
     *            data, val1(1), val2(1), val1(2), val2(2),
     *            scr(memloc),eval1(1),eval2(1),eval1(2),eval2(2),
     *            index_type)
            else if (nindex .eq. 4) then
               call eblock4_contribution(
     *              data, val1(1), val2(1), val1(2), val2(2),
     *                    val1(3), val2(3), val1(4), val2(4),
     *              scr(memloc), eval1(1),eval2(1), eval1(2), eval2(2),
     *                     eval1(3),eval2(3), eval1(4), eval2(4),
     *                     index_type)
            else if (nindex .eq. 6) then
               call eblock6_contribution(
     *              data, val1(1), val2(1), val1(2), val2(2),
     *                    val1(3), val2(3), val1(4), val2(4),
     *                    val1(5), val2(5), val1(6), val2(6),
     *              scr(memloc), eval1(1),eval2(1), eval1(2), eval2(2),
     *                     eval1(3),eval2(3), eval1(4), eval2(4),
     *                     eval1(5),eval2(5), eval1(6), eval2(6),
     *                     index_type)
            else
               print *,'Error: Invalid number of indices in ',
     *            'dropmo_expand_basis.  nindex = ',nindex,
     *            ' should be 2, 4, or 6.'
               call abort_job()
            endif
         endif
      enddo

c      print *,'Data block contributed to ',ncontrib_blocks,' e_blocks.'
      if (ncontrib_blocks .eq. 0) then
         print *,'Non-contributing data block.'
         print *,'data block segment ranges: ',(ival1(j),ival2(j),
     *             j = 1, nindex)
         print *,'eblock_table:'
         do i = 1, n_eblocks
            print *,'Entry ',i,':',(eblock_table(j,i),j=1,
     *            leblock_entry)
         enddo
         call abort_job()
      endif

      return
      end

      subroutine eblock2_contribution(data, a1, a2, b1, b2,
     *                 x, ax1, ax2, bx1, bx2, index_type)
      implicit none
      include 'interpreter.h'
      include 'dropmo.h'

      integer a1, a2, b1, b2, ax1, ax2, bx1, bx2
      double precision data(a1:a2,b1:b2)
      double precision x(ax1:ax2,bx1:bx2)
      integer index_type(*)
 
      integer a, b
      integer aa, bb
 
      do b = b1, b2
         if (index_type(2) .eq. moindex .or.
     *       index_type(2) .eq. moaindex) then
            bb = moamap(b)
         else if (index_type(2) .eq. mobindex) then
            bb = mobmap(b)
         else
            bb = b
         endif
 
      do a = a1, a2
         if (index_type(1) .eq. moindex .or.
     *       index_type(1) .eq. moaindex) then
            aa = moamap(a)
         else if (index_type(1) .eq. mobindex) then
            aa = moamap(a)
         else
            aa = a
         endif

         if (aa .ge. ax1 .and. aa .le. ax2 .and.
     *       bb .ge. bx1 .and. bb .le. bx2)
     *       x(aa,bb) = data(a,b)
      enddo
      enddo

      return
      end

      subroutine eblock4_contribution(data, a1, a2, b1, b2,
     *                    c1, c2, d1, d2,
     *                 x, ax1, ax2, bx1, bx2, 
     *                    cx1, cx2, dx1, dx2,
     *                    index_type)
      implicit none
      include 'interpreter.h'
      include 'dropmo.h'

      integer a1, a2, b1, b2, ax1, ax2, bx1, bx2
      integer c1, c2, d1, d2, cx1, cx2, dx1, dx2
      double precision data(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision x(ax1:ax2,bx1:bx2,cx1:cx2,dx1:dx2)
      integer index_type(*)
 
      integer a, b, c, d
      integer aa, bb, cc, dd
 
      do d = d1, d2
         if (index_type(4) .eq. moindex .or.
     *       index_type(4) .eq. moaindex) then
            dd = moamap(d)
         else if (index_type(4) .eq. mobindex) then
            dd = mobmap(d)
         else
            dd = d
         endif

      do c = c1, c2
         if (index_type(3) .eq. moindex .or.
     *       index_type(3) .eq. moaindex) then
            cc = moamap(c)
         else if (index_type(3) .eq. mobindex) then
            cc = mobmap(c)
         else
            cc = c
         endif
 
      do b = b1, b2
         if (index_type(2) .eq. moindex .or.
     *       index_type(2) .eq. moaindex) then
            bb = moamap(b)
         else if (index_type(2) .eq. mobindex) then
            bb = mobmap(b)
         else
            bb = b
         endif
 
      do a = a1, a2
         if (index_type(1) .eq. moindex .or.
     *       index_type(1) .eq. moaindex) then
            aa = moamap(a)
         else if (index_type(1) .eq. mobindex) then
            aa = moamap(a)
         else
            aa = a
         endif

         if (aa .ge. ax1 .and. aa .le. ax2 .and.
     *       bb .ge. bx1 .and. bb .le. bx2 .and.
     *       cc .ge. cx1 .and. cc .le. cx2 .and.
     *       dd .ge. dx1 .and. dd .le. dx2) 
     *       x(aa,bb,cc,dd) = data(a,b,c,d)
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine eblock6_contribution(data, a1, a2, b1, b2,
     *                    c1, c2, d1, d2, e1, e2, f1, f2,
     *                 x, ax1, ax2, bx1, bx2, 
     *                    cx1, cx2, dx1, dx2, ex1, ex2, fx1, fx2,
     *                    index_type)
      implicit none
      include 'interpreter.h'
      include 'dropmo.h'

      integer a1, a2, b1, b2, ax1, ax2, bx1, bx2
      integer c1, c2, d1, d2, cx1, cx2, dx1, dx2
      integer e1, e2, f1, f2, ex1, ex2, fx1, fx2
      double precision data(a1:a2,b1:b2,c1:c2,d1:d2,e1:e2,f1:f2)
      double precision x(ax1:ax2,bx1:bx2,cx1:cx2,dx1:dx2,
     *                    ex1:ex2,fx1:fx2)
      integer index_type(*)
 
      integer a, b, c, d, e, f
      integer aa, bb, cc, dd, ee, ff
 
      do f = f1, f2
         if (index_type(6) .eq. moindex .or.
     *       index_type(6) .eq. moaindex) then
            ff = moamap(f)
         else if (index_type(6) .eq. mobindex) then
            ff = mobmap(f)
         else
            ff = f
         endif

      do e = e1, e2
         if (index_type(5) .eq. moindex .or.
     *       index_type(5) .eq. moaindex) then
            ee = moamap(e)
         else if (index_type(5) .eq. mobindex) then
            ee = mobmap(e)
         else
            ee = e
         endif
 
      do d = d1, d2
         if (index_type(4) .eq. moindex .or.
     *       index_type(4) .eq. moaindex) then
            dd = moamap(d)
         else if (index_type(4) .eq. mobindex) then
            dd = mobmap(d)
         else
            dd = d
         endif

      do c = c1, c2
         if (index_type(3) .eq. moindex .or.
     *       index_type(3) .eq. moaindex) then
            cc = moamap(c)
         else if (index_type(3) .eq. mobindex) then
            cc = mobmap(c)
         else
            cc = c
         endif
 
      do b = b1, b2
         if (index_type(2) .eq. moindex .or.
     *       index_type(2) .eq. moaindex) then
            bb = moamap(b)
         else if (index_type(2) .eq. mobindex) then
            bb = mobmap(b)
         else
            bb = b
         endif
 
      do a = a1, a2
         if (index_type(1) .eq. moindex .or.
     *       index_type(1) .eq. moaindex) then
            aa = moamap(a)
         else if (index_type(1) .eq. mobindex) then
            aa = moamap(a)
         else
            aa = a
         endif

         if (aa .ge. ax1 .and. aa .le. ax2 .and.
     *       bb .ge. bx1 .and. bb .le. bx2 .and.
     *       cc .ge. cx1 .and. cc .le. cx2 .and.
     *       dd .ge. dx1 .and. dd .le. dx2 .and.
     *       ee .ge. ex1 .and. ee .le. ex2 .and.
     *       ff .ge. fx1 .and. ff .le. fx2)
     *       x(aa,bb,cc,dd,ee,ff) = data(a,b,c,d,e,f)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine flush_eblocks(eblock_table, n_eblocks, diskloc_table,
     *                         data_unit2, scr, nscr_blocks)
c---------------------------------------------------------------------------
c   Writes all eblocks to disk that currently have data in memory.
c--------------------------------------------------------------------------- 
      implicit none
      include 'interpreter.h'
      integer n_eblocks, data_unit2, nscr_blocks
      integer eblock_table(leblock_entry, n_eblocks)
      integer*8 diskloc_table(n_eblocks)
      double precision scr(*)
      double precision sum

      integer ieblk, memloc, i, n
      integer*8 data_ptr2

      do ieblk = 1, n_eblocks
         memloc = eblock_table(c_eblock_memloc,ieblk)
         if (memloc .gt. 0) then
            n = eblock_table(c_eblock_blksize,ieblk)
            data_ptr2 = diskloc_table(ieblk)

c            sum = 0.0
c            do i = 1, n
c               sum = sum + scr(memloc+i-1)*scr(memloc+i-1)
c            enddo

c            print *,'Writing eblock ',ieblk,' to disk: disk loc ',
c     *              data_ptr2,' n ',n, ' sum ',sum 
            call f_write_disk(data_unit2, data_ptr2,
     *                        scr(memloc),n)
 
            eblock_table(c_eblock_memloc,ieblk) = 0
         endif
      enddo
      return
      end

      subroutine get_expanded_basis_segsizes(enalpha_occupied, 
     *     enalpha_virtual, enbeta_occupied, enbeta_virtual)
c----------------------------------------------------------------------------
c   This routine determines the segment sizes in the expanded basis set.
c   It queries the ZMAT parameters.  If the parameters were coded by the
c   user, we do nothing.  If the segment size parameters were not coded
c   in the ZMAT, we determine the correct algorithm to use, and call the 
c   det_segsizes routine to calculate the new values.
c----------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      integer enalpha_occupied, enalpha_virtual
      integer enbeta_occupied, enbeta_virtual
      
      integer ao_segsize, occ_segsize, virt_segsize
      integer nao, nav, nbo, nbv
      integer auto_seg_switch
      character*80 auto_seg_algorithm

      ao_segsize   = 0
      occ_segsize  = 0
      virt_segsize = 0

      call igetparam('SIP_MX_SEGSIZE', 1, ao_segsize)
      call igetparam('SIP_MX_OCC_SEGSIZE', 1, occ_segsize)
      call igetparam('SIP_MX_VIRT_SEGSIZE', 1, virt_segsize)
      if (occ_segsize.lt.1.or.
     &    virt_segsize.lt.1.or.
     &    ao_segsize.lt.1) then
         auto_seg_algorithm = 'SEGMENT_OPTIMIZED'
         call cgetparam('AUTO_SEG_ALGORITHM', 1, auto_seg_algorithm)

         if (auto_seg_algorithm(1:16) .eq. 'MEMORY_OPTIMIZED') then
           auto_seg_switch = 1
         else if (auto_seg_algorithm(1:17) .eq.
     *                                     'SEGMENT_OPTIMIZED') then
           auto_seg_switch = 2
         else
           print *,'====>> Invalid value for AUTO_SEG_ALGORITHM'
           print *,'Value is ',auto_seg_algorithm
           call abort_job()
         endif

c---------------------------------------------------------------------------
c   Save current values of nalpha_occupied, etc., set common block to 
c   desired values.
c---------------------------------------------------------------------------

         nao = nalpha_occupied
         nbo = nbeta_occupied
         nav = nalpha_virtual
         nbv = nbeta_virtual

         nalpha_occupied = enalpha_occupied
         nbeta_occupied  = enbeta_occupied
         nalpha_virtual  = enalpha_virtual
         nbeta_virtual   = enbeta_virtual

c---------------------------------------------------------------------------
c   The new (expanded basis) segment sizes will be stored in int_gen_parms.h
c   by det_segsizes.
c---------------------------------------------------------------------------

         call det_segsizes(auto_seg_switch, my_company_size)

c---------------------------------------------------------------------------
c   Restore the previous values to common.
c---------------------------------------------------------------------------

         nalpha_occupied = nao
         nbeta_occupied  = nbo
         nalpha_virtual  = nav
         nbeta_virtual   = nbv 
      end if

      return
      end

      CHARACTER*4 FUNCTION some_string_func(NAME,Iord)
      CHARACTER*4 NAME, ItoA
      If (Name(2:2) .eq. 'N') then
         some_string_func(1:1) = Name(1:1)
         some_string_func(2: ) = ItoA(Iord, 0)
         some_string_func(linblnk(some_string_func)+1:) = Name(3:3)
      Else
         some_string_func = Name
      EndIf
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_NBO_ORBITALS
     +
     +                    ( NBAS,NATOM,NBOND,
     +                      BONDSIZE,NBOSIZE,
     +                      MXNBA,MXSHELL,
     +                      NHB,NCB,NRB,
     +                      NHA,NCA,NRA,
     +                      ATNHB,ATHOFF,
     +                      ATNCB,ATCIDX,ATCOFF,
     +                      ATNRB,ATRIDX,ATROFF,
     +                      BASBEG,BASEND,
     +                      COLMAP,
     +                      WBOND,WSTAR,
     +                      WRYD,WOCC,
     +                      BDNCEN,BDCEN,
     +                      BDNBAS,BDBAS,
     +                      BDOCC,
     +                      ANGNHO,
     +                      P,H,
     +                      PH,
     +                      IVEC,
     +                      XVEC,XMAT,
     +
     +                              NLA,NEA,NYA,
     +                              NLB,NBB,NEB,NAB,NYB,
     +                              ATNLB,ATLIDX,ATLOFF,
     +                              ATNEB,ATEIDX,ATEOFF,
     +                              ATNYB,ATYIDX,ATYOFF,
     +                              NBOBD,
     +                              ANGNBO,
     +                              BDSIZE,BDATOM,
     +                              B,W,Q,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_NBO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine generates the sets of natural bond
C                orbitals (NBOs) by combining the final set of NHOs
C                in the appropriate way.
C
C
C                  Input:
C
C                    NBAS         =  total # of AOs in AO basis
C                    NATOM        =  total # of atomic centers
C                    NBOND        =  total # of bonds found in the NHB
C                                    part.
C                    BONDSIZE     =  maximum # of atomic centers that
C                                    are allowed to form a bond.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    MXSHELL      =  largest l-shell value
C                    NxB          =  total # of Hybrid, Core and
C                                    Rydberg NAOs (x=H,C,R)
C                    NxA          =  total # of hybrid, core and
C                                    Rydberg atoms (x=H,C,R)
C                    ATNHB (A)    =  # of Hybrid NAOs on hybrid atom A.
C                    ATHOFF (A)   =  index offset for Hybrid NAOs for
C                                    hybrid atom A. This index is equal
C                                    to the total number of Hybrid
C                                    NAOs on all hybrid atoms preceeding
C                                    hybrid atom A.
C                    ATNCB (A)    =  # of Core NAOs on core atom A.
C                    ATCIDX (A)   =  atomic index for core atom A.
C                    ATCOFF (A)   =  index offset for Core NAOs for
C                                    core atom A. This index is equal
C                                    to the total number of Core NAOs
C                                    on all core atoms preceeding
C                                    core atom A.
C                    ATNRB (A)    =  # of Rydberg NAOs on Rydberg
C                                    atom A.
C                    ATRIDX (A)   =  atomic index for Rydberg atom A.
C                    ATROFF (A)   =  index offset for Rydberg NAOs for
C                                    Rydberg atom A. This index is
C                                    equal to the total number of
C                                    Rydberg NAOs on all Rydberg atoms
C                                    preceeding Rydberg atom A.
C                    BASBEG (A)   =  first basis index number for atom A
C                    BASEND (A)   =  last basis index number for atom A
C                    COLMAP (I)   =  will contain the column map in the
C                                    active sense for the pure NBO
C                                    ordering NHB -> NLB/NBB/NEB/NAB/NYB
C                                    and the subsequent mixed NBO/NAO
C                                    ordering NHB/NCB -> NCB/NHB to bring
C                                    the Core NAOs up front. COLMAP (I)
C                                    contains the position index of the
C                                    I-th NBO in the final respective
C                                    order.
C                    WBOND (x)    =  lowest weight criterion for each
C                                    x-center bond.
C                    WSTAR (x)    =  highest weight criterion for each
C                                    x-center antibond.
C                    WRYD         =  highest weight below which a one-
C                                    center bond is classified as an
C                                    atomic Rydberg NBO.
C                    WOCC         =  the weight limit to decide when
C                                    a NBO is considered occupied or
C                                    virtual.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/NRB.
C                                    Note that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  I-th global basis (NHO) index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDOCC (J)    =  # of occupied levels for J-th bond.
C                                    The bond order is NHB-bonds/NCB/NRB.
C                                    Note that the # of NHB-bonds might
C                                    be < NHB size.
C                    ANGNHO (J,L) =  NBAS x (MXSHELL+1) matrix
C                                    containing the sum of the square
C                                    of the NAO coefficients per L-type
C                                    angular momentum for the J-th NHO.
C                                    The NHO order is NHB/NCB/NRB.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    H (I,J)      =  MXNBA x NBAS matrix containing the
C                                    atomic NHOs. I is the local atomic
C                                    index labeling the atomic Hybrid
C                                    NAOs from which the NHOs are
C                                    constructed. J is the global NHO
C                                    index running over all NHOs in
C                                    NHB/NCB/NRB order, with all NHOs
C                                    in each section belonging to a
C                                    specific atomic center being
C                                    grouped together.
C                    PH           =  will contain the NHB x NHB valence
C                                    occupation matrix in NAO basis.
C                    IVEC         =  int scratch array of vector type.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    BDSIZE       =  full NAO bond sizes (all = 1).
C                    BDATOM       =  full NAO atomic index map with
C                                    1st column in NHB/NCB/NRB order.
C                    W            =  weight vector in NHB/NCB/NRB order.
C                                    The NCB and NRB parts contain the
C                                    original Core and Rydberg NAO
C                                    weights. The NHB part was used
C                                    during NHO generation and will
C                                    be replaced by the NBO Lone-pair,
C                                    Bond, Empty-pair, Antibond and
C                                    Rydberg weights.
C                    C            =  full NAO coefficient matrix in AO
C                                    basis with columns in NHB/NCB/NRB
C                                    order.
C
C
C                  Output:
C
C                    NxA          =  total # of Lone-pair, Empty-pair
C                                    and Rydberg atoms found (x=L,E,Y).
C                    NxB          =  total # of Lone-pair, Bond,
C                                    Empty-pair, Antibond and Rydberg
C                                    NBOs found (x=L,B,E,A,Y).
C                    ATNLB (A)    =  # of Lone-pair NBOs on Lone-pair
C                                    atom A.
C                    ATLIDX (A)   =  atomic index for Lone-pair atom A.
C                    ATLOFF (A)   =  index offset for Lone-pair NBOs for
C                                    Lone-pair atom A. This index is
C                                    equal to the total number of
C                                    Lone-pair NBOs on all Lone-pair
C                                    atoms preceeding Lone-pair atom A.
C                    ATNEB (A)    =  # of Empty-pair NBOs on Empty-pair
C                                    atom A.
C                    ATEIDX (A)   =  atomic index for Empty-pair atom A.
C                    ATEOFF (A)   =  index offset for Empty-pair NBOs for
C                                    Empty-pair atom A. This index is
C                                    equal to the total number of
C                                    Empty-pair NBOs on all Empty-pair
C                                    atoms preceeding Empty-pair atom A.
C                    ATNYB (A)    =  # of Rydberg NBOs on Rydberg atom A.
C                    ATYIDX (A)   =  atomic index for Rydberg atom A.
C                    ATYOFF (A)   =  index offset for Rydberg NBOs for
C                                    Rydberg atom A. This index is
C                                    equal to the total number of
C                                    Rydberg NBOs on all Rydberg atoms
C                                    preceeding Rydberg atom A.
C                    NBOBD (I)    =  contains the bond index number for
C                                    the I-th NBO. This array is the
C                                    handle for accessing and modifying
C                                    info of the bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC. The NBOBD elements are in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C                    ANGNBO (J,L) =  NBAS x (MXSHELL+1) matrix containing
C                                    the sum of the square of the NAO
C                                    coefficients per L-type angular
C                                    momentum for the J-th NBO. The NBO
C                                    order is NCB/NLB/NBB/NEB/NAB/NYB/
C                                    NRB.
C                    BDSIZE       =  full NBO bond sizes in NBO order
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB.
C                    BDATOM       =  full NBO atomic index map in NBO
C                                    order NCB/NLB/NBB/NEB/NAB/NYB/NRB.
C                    B (I,J)      =  NBOSIZE x NBAS matrix containing
C                                    the J-th NBO expansion coefficients
C                                    in terms of the I-th atomic NHOs
C                                    forming the J-th NBO. The NBO
C                                    column index is in NCB/NLB/NBB/NEB/
C                                    NAB/NYB/NRB order.
C                    W            =  NBO weight vector with elements in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C                    Q            =  NBO occupation interaction order
C                                    vector with elements in NCB/NLB/
C                                    NBB/NEB/NAB/NYB/NRB order. These
C                                    interaction orders are given by
C                                    the square root of the sum of the
C                                    square offdiagonal occupation
C                                    matrix elements:
C
C                                      Q (I) = sqrt ( sum   P (I,K)**2 )
C                                                    K.ne.I
C
C                                    They will be used here to determine
C                                    degenerate NBOs during the NBO
C                                    symmetrization procedure.
C                    C            =  full NBO coefficient matrix
C                                    in AO basis with columns in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     LTRG,UTRG
         LOGICAL     SAVEP

         INTEGER     ATOM
         INTEGER     ATNEW,ATOLD
         INTEGER     BOND
         INTEGER     BONDSIZE,NBOSIZE
         INTEGER     I,J
         INTEGER     INDEX
         INTEGER     LTYPE
         INTEGER     MXNBA,MXSHELL
         INTEGER     NBAS,NATOM
         INTEGER     NBO,NBOOLD
         INTEGER     NBOND
         INTEGER     NHB,NHA,NCB,NCA,NRB,NRA
         INTEGER     NHCEN
         INTEGER     NHO,NNHO
         INTEGER     NLB,NLA,NBB,NEB,NEA,NAB,NYB,NYA
         INTEGER     NLBA,NEBA,NYBA
         INTEGER     NLBSUM,NEBSUM,NYBSUM
         INTEGER     NMOVE
         INTEGER     NOCC
         INTEGER     OFFLP,OFFBD,OFFEP,OFFAB,OFFRY

         INTEGER     ATNCB   (1:NCA      )
         INTEGER     ATNHB   (1:NHA      )
         INTEGER     ATNRB   (1:NRA      )
         INTEGER     ATNLB   (1:NATOM    )
         INTEGER     ATNEB   (1:NATOM    )
         INTEGER     ATNYB   (1:NATOM    )
         INTEGER     ATCIDX  (1:NCA      )
         INTEGER     ATRIDX  (1:NRA      )
         INTEGER     ATLIDX  (1:NATOM    )
         INTEGER     ATEIDX  (1:NATOM    )
         INTEGER     ATYIDX  (1:NATOM    )
         INTEGER     ATCOFF  (1:NCA      )
         INTEGER     ATHOFF  (1:NHA      )
         INTEGER     ATROFF  (1:NRA      )
         INTEGER     ATLOFF  (1:NATOM    )
         INTEGER     ATEOFF  (1:NATOM    )
         INTEGER     ATYOFF  (1:NATOM    )
         INTEGER     BASBEG  (1:NATOM    )
         INTEGER     BASEND  (1:NATOM    )
         INTEGER     BDNBAS  (1:NBAS     )
         INTEGER     BDNCEN  (1:NBAS     )
         INTEGER     BDOCC   (1:NBAS     )
         INTEGER     BDSIZE  (1:NBAS     )
         INTEGER     COLMAP  (1:NCB+NHB  )
         INTEGER     IVEC    (1:NBAS     )
         INTEGER     NBOBD   (1:NBAS     )

         INTEGER     BDATOM  (1:NBAS   ,1:BONDSIZE)
         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS    )
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS    )

         DOUBLE PRECISION  ANGVAL
         DOUBLE PRECISION  CSQR
         DOUBLE PRECISION  WRYD,WOCC
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  Q     (1:NBAS     )
         DOUBLE PRECISION  W     (1:NBAS     )
         DOUBLE PRECISION  WBOND (1:BONDSIZE )
         DOUBLE PRECISION  WSTAR (1:BONDSIZE )
         DOUBLE PRECISION  XVEC  (1:NBAS+NBAS)

         DOUBLE PRECISION  ANGNBO (1:NBAS   ,0:MXSHELL)
         DOUBLE PRECISION  ANGNHO (1:NBAS   ,0:MXSHELL)
         DOUBLE PRECISION  B      (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  C      (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  P      (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  H      (1:MXNBA  ,1:NBAS   )
         DOUBLE PRECISION  PH     (1:NHB    ,1:NHB    )
         DOUBLE PRECISION  XMAT   (1:NBAS   ,1:NBAS   )

         PARAMETER  (ZERO  = 0.D0 )
         PARAMETER  (ONE   = 1.D0 )
C
C
C------------------------------------------------------------------------
C
C
C             ...form the full NHB x NHB occupation matrix PH.
C
C
         LTRG  = .TRUE.
         UTRG  = .TRUE.
         SAVEP = .TRUE.

         CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +              ( NBAS,NHB,
     +                NBAS,NBAS,
     +                NBAS,NHB,
     +                NHB,
     +                NHB,NBAS,
     +                0,
     +                SAVEP,LTRG,UTRG,
     +                C,
     +                P,
     +                XVEC,
     +
     +                        XMAT )
     +
     +
         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NBAS,NHB,
     +                NHB,NHB,
     +                NHB,NHB,
     +                XMAT,
     +
     +                        PH )
     +
     +
C
C
C             ...loop over all NHO bonds found and accumulate the NBO
C                weights, the coefficient matrix, the NBO bond sizes,
C                the NBO atomic index map, the NHO bond index
C                numbers and the local column NBO ordering map
C                NHB -> NLB/NBB/NEB/NAB/NYB with added offsets for
C                temporary protection. The difference between the
C                offsets is set to NHB, since this ensures no overlap
C                of indices between different types of NBOs.
C
C
         CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +              ( NBOSIZE,NBAS,
     +                NBOSIZE,NBAS,
     +
     +                        B )
     +
     +
         NBO = 0
         NLB = 0
         NBB = 0
         NEB = 0
         NAB = 0
         NYB = 0
         NBOOLD = 0

         OFFLP = 0
         OFFBD = OFFLP + NHB
         OFFEP = OFFBD + NHB
         OFFAB = OFFEP + NHB
         OFFRY = OFFAB + NHB

         DO BOND = 1,NBOND

            NOCC = BDOCC (BOND)
            NHCEN = BDNCEN (BOND)

            CALL  NLO__FORM_NBO_X_CENTERS
     +
     +              ( NBAS,NHCEN,NOCC,
     +                BONDSIZE,NBOSIZE,
     +                MXNBA,
     +                ATNHB,ATHOFF,
     +                NHB,NHA,
     +                OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,
     +                BDCEN (1,BOND),
     +                BDBAS (1,BOND),
     +                WBOND (NHCEN),
     +                WSTAR (NHCEN),
     +                WRYD,WOCC,
     +                C,
     +                PH,
     +                H,
     +                IVEC,
     +
     +                        NBO,
     +                        NLB,NBB,NEB,NAB,NYB,
     +                        COLMAP,
     +                        B (1,NBOOLD+1),
     +                        W (NBOOLD+1),
     +                        BDSIZE,BDATOM,
     +                        XMAT (1,NBO+1) )
     +
     +
            DO I = NBOOLD+1,NBO
               NBOBD (I) = BOND
            END DO

            NBOOLD = NBO
         END DO
C
C
C             ...check, if the # of Lone-pairs, Bonds, Empty-pairs,
C                Antibonds and Rydbergs add up ok.
C
C
         IF ((NLB+NBB+NEB+NAB+NYB).NE.NHB) THEN
             WRITE (*,*) ' Problems in finding correct # of NBOs! '
             WRITE (*,*) ' NLB,NBB,NEB,NAB,NYB,NHB = ',
     +                     NLB,NBB,NEB,NAB,NYB,NHB
             WRITE (*,*) ' nlo__gener_nbo_orbitals '
             WRITE (1,*) ' Problems in finding correct # of NBOs! '
             WRITE (1,*) ' NLB,NBB,NEB,NAB,NYB,NHB = ',
     +                     NLB,NBB,NEB,NAB,NYB,NHB
             WRITE (1,*) ' nlo__gener_nbo_orbitals '
             STOP
         END IF
C
C
C             ...complete the NHO bond index number array by adding
C                the Core and Rydberg NHO bonds. This is just a one
C                to one index mapping. Complete also the NBO expansion
C                coefficient matrix, which simply contains a +1 in its
C                first row for the Core and Rydberg NBOs, as these
C                consist of just one NHO at this stage.
C
C
         DO I = NHB+1,NBAS
            NBOBD (I) = I
            B (1,I) = ONE
         END DO
C
C
C             ...copy the NHB section of the NBO coefficient
C                accumulation matrix to the final NBO coefficient
C                matrix.
C
C
         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NBAS,NHB,
     +                NBAS,NBAS,
     +                NBAS,NHB,
     +                XMAT,
     +
     +                        C )
     +
     +
C
C
C             ...remove the protective offsets on the local column
C                NBO ordering NHB -> NLB/NBB/NEB/NAB/NYB and reorder
C                all the NHB related data:
C
C                    i) the NBO weights
C                   ii) the NBO coefficients in AO basis
C                  iii) the NBO -> NHO expansion coefficient matrix
C                   iv) the vector containing the NHO bond index numbers
C                    v) the NBO bond size vector
C                   vi) the NBO atomic index array
C
C                Use the obsolete PH matrix for scratch.
C
C
         DO I = 1,NHB
            INDEX = COLMAP (I)
            IF (INDEX.GT.OFFRY) THEN
                INDEX = INDEX - OFFRY + NLB + NBB + NEB + NAB
            ELSE IF (INDEX.GT.OFFAB) THEN
                INDEX = INDEX - OFFAB + NLB + NBB + NEB
            ELSE IF (INDEX.GT.OFFEP) THEN
                INDEX = INDEX - OFFEP + NLB + NBB
            ELSE IF (INDEX.GT.OFFBD) THEN
                INDEX = INDEX - OFFBD + NLB
            ELSE IF (INDEX.GT.OFFLP) THEN
                INDEX = INDEX - OFFLP
            END IF
            COLMAP (I) = INDEX
         END DO

         CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +              ( NHB,
     +                NHB,
     +                NHB,
     +                NHB,
     +                COLMAP,
     +                XVEC,
     +
     +                        W )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBAS,NHB,
     +                NHB,
     +                NHB,
     +                NBAS,
     +                NBAS,NHB,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        C )
     +
     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NHB,
     +                NHB,
     +                NHB,
     +                NHB,
     +                COLMAP,
     +                IVEC,
     +
     +                        NBOBD )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBOSIZE,NHB,
     +                NHB,
     +                NHB,
     +                NBOSIZE,
     +                NBOSIZE,NHB,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        B )
     +
     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NHB,
     +                NHB,
     +                NHB,
     +                NHB,
     +                COLMAP,
     +                IVEC,
     +
     +                        BDSIZE )
     +
     +
         DO I = 1,BONDSIZE

            CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +                 ( NHB,
     +                   NHB,
     +                   NHB,
     +                   NHB,
     +                   COLMAP,
     +                   IVEC,
     +
     +                           BDATOM (1,I) )
     +
     +
         END DO
C
C
C             ...at this stage all NLB lone pairs are conglomerated,
C                however, due to their finding process, they are
C                not ordered according to the atomic index. Lone
C                pairs corresponding to the same atom are scattered
C                through the set of NLB lone pairs. We thus generate
C                first the COLMAP array to bring the lone pairs into
C                atomic order and then reorder them together with
C                all the associated data. After that we analyze the
C                lone pair space and get some info from it to be used
C                for symmetrization.
C
C
         DO I = 1,NATOM
            IVEC (I) = 0
         END DO
         DO I = 1,NLB
            ATOM = BDATOM (I,1)
            OFFLP = ATOM * NLB
            IVEC (ATOM) = IVEC (ATOM) + 1
            COLMAP (I) = IVEC (ATOM) + OFFLP
         END DO
         DO I = NATOM,1,-1
            IVEC (I) = 0
            DO J = 1,I-1
               IVEC (I) = IVEC (I) + IVEC (J)
            END DO
         END DO
         DO I = 1,NLB
            INDEX = COLMAP (I)
            ATOM = INDEX / NLB
            OFFLP = ATOM * NLB
            COLMAP (I) = INDEX - OFFLP + IVEC (ATOM)
         END DO

         CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +              ( NLB,
     +                NLB,
     +                NLB,
     +                NLB,
     +                COLMAP,
     +                XVEC,
     +
     +                        W )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBAS,NLB,
     +                NLB,
     +                NLB,
     +                NBAS,
     +                NBAS,NLB,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        C )
     +
     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NLB,
     +                NLB,
     +                NLB,
     +                NLB,
     +                COLMAP,
     +                IVEC,
     +
     +                        NBOBD )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBOSIZE,NLB,
     +                NLB,
     +                NLB,
     +                NBOSIZE,
     +                NBOSIZE,NLB,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        B )
     +
     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NLB,
     +                NLB,
     +                NLB,
     +                NLB,
     +                COLMAP,
     +                IVEC,
     +
     +                        BDSIZE )
     +
     +
         DO I = 1,BONDSIZE

            CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +                 ( NLB,
     +                   NLB,
     +                   NLB,
     +                   NLB,
     +                   COLMAP,
     +                   IVEC,
     +
     +                           BDATOM (1,I) )
     +
     +
         END DO
C
C
C             ...all data related to the NHB section is now locally
C                ordered in the form NHB -> NLB/NBB/NEB/NAB/NYB.
C                Determine global mixed column NBO/NAO ordering NHB/NCB
C                -> NCB/NHB. Reorder the NBO coefficient matrix from
C                NHB/NCB order to NCB/NHB order, such that the Core
C                NBOs come first. Reorder also the NHB/NCB part of the
C                weight vector and the NHB/NCB parts of the NBO bond
C                size vector and the NBO atomic index array.
C
C
         DO I = 1,NHB
            COLMAP (I) = I + NCB
         END DO

         DO I = 1,NCB
            COLMAP (NHB+I) = I
         END DO

         NMOVE = NCB + NHB

         CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +              ( NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                COLMAP,
     +                XVEC,
     +
     +                        W )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBAS,NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                NBAS,
     +                NBAS,NMOVE,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        C )
     +
     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                COLMAP,
     +                IVEC,
     +
     +                        NBOBD )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBOSIZE,NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                NBOSIZE,
     +                NBOSIZE,NMOVE,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        B )
     +
     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                NMOVE,
     +                COLMAP,
     +                IVEC,
     +
     +                        BDSIZE )
     +
     +
         DO I = 1,BONDSIZE

            CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +                 ( NMOVE,
     +                   NMOVE,
     +                   NMOVE,
     +                   NMOVE,
     +                   COLMAP,
     +                   IVEC,
     +
     +                           BDATOM (1,I) )
     +
     +
         END DO
C
C
C             ...form now the Core and remaining Rydberg NBO orbitals.
C                The array H containing the atomic NHOs will be used
C                for temporary space and the atomic NHO in it will be
C                destroyed.
C
C
         CALL  NLO__FORM_ATOMIC_NONVALENCE_NBO
     +
     +              ( NBAS,MXNBA,
     +                NCB,NCA,
     +                ATNCB,ATCOFF,
     +                P,
     +                H (1,NHB+1),
     +                XMAT,
     +
     +                        W (1),
     +                        C (1,1))
     +
     +
         CALL  NLO__FORM_ATOMIC_NONVALENCE_NBO
     +
     +              ( NBAS,MXNBA,
     +                NRB,NRA,
     +                ATNRB,ATROFF,
     +                P,
     +                H (1,NHB+NCB+1),
     +                XMAT,
     +
     +                        W (NHB+NCB+1),
     +                        C (1,NHB+NCB+1))
     +
     +
C
C
C             ...generate NBO info for Lone-pairs, Empty-pairs and
C                Rydberg NBOs. 
C
C
         OFFLP = NCB
         OFFEP = OFFLP + NLB + NBB
         OFFRY = OFFEP + NEB + NAB

         NLA = 0

         IF (NLB.GT.0) THEN
             NLBA = 1
             NLBSUM = 0
             ATOLD = BDATOM (OFFLP+1,1)

             DO I = 2,NLB
                ATNEW = BDATOM (OFFLP+I,1)
                IF (ATNEW.EQ.ATOLD) THEN
                    NLBA = NLBA + 1
                ELSE
                    NLA = NLA + 1
                    ATNLB (NLA) = NLBA
                    ATLIDX (NLA) = ATOLD
                    ATLOFF (NLA) = NLBSUM
                    NLBSUM = NLBSUM + NLBA
                    NLBA = 1
                    ATOLD = ATNEW
                END IF
             END DO

             NLA = NLA + 1
             ATNLB (NLA) = NLBA
             ATLIDX (NLA) = ATOLD
             ATLOFF (NLA) = NLBSUM
         END IF

         NEA = 0

         IF (NEB.GT.0) THEN
             NEBA = 1
             NEBSUM = 0
             ATOLD = BDATOM (OFFEP+1,1)

             DO I = 2,NEB
                ATNEW = BDATOM (OFFEP+I,1)
                IF (ATNEW.EQ.ATOLD) THEN
                    NEBA = NEBA + 1
                ELSE
                    NEA = NEA + 1
                    ATNEB (NEA) = NEBA
                    ATEIDX (NEA) = ATOLD
                    ATEOFF (NEA) = NEBSUM
                    NEBSUM = NEBSUM + NEBA
                    NEBA = 1
                    ATOLD = ATNEW
                END IF
             END DO

             NEA = NEA + 1
             ATNEB (NEA) = NEBA
             ATEIDX (NEA) = ATOLD
             ATEOFF (NEA) = NEBSUM
         END IF

         NYA = 0

         IF (NYB.GT.0) THEN
             NYBA = 1
             NYBSUM = 0
             ATOLD = BDATOM (OFFRY+1,1)

             DO I = 2,NYB
                ATNEW = BDATOM (OFFRY+I,1)
                IF (ATNEW.EQ.ATOLD) THEN
                    NYBA = NYBA + 1
                ELSE
                    NYA = NYA + 1
                    ATNYB (NYA) = NYBA
                    ATYIDX (NYA) = ATOLD
                    ATYOFF (NYA) = NYBSUM
                    NYBSUM = NYBSUM + NYBA
                    NYBA = 1
                    ATOLD = ATNEW
                END IF
             END DO

             NYA = NYA + 1
             ATNYB (NYA) = NYBA
             ATYIDX (NYA) = ATOLD
             ATYOFF (NYA) = NYBSUM
         END IF
C
C
C             ...calculate the NBO occupation interaction orders. 
C
C
         DO NBO = 1,NBAS

            CALL  NLO__CALC_INTERACTION_ORDER
     +
     +                 ( NBAS,NBAS,
     +                   NBAS,NBAS,
     +                   NBAS,
     +                   NBAS,NBAS,
     +                   NBAS,
     +                   NBO,
     +                   C,P,C (1,NBO),
     +                   XVEC (1),
     +                   XVEC (NBAS+1),
     +
     +                           Q (NBO) )
     +
     +
         END DO

         CALL    MAT__PRINT_A_FLOAT_18_NOZEROS
     +
     +                ( 6,
     +                  ' NBO Interaction order vector (not sym)',
     +                  NBAS,1,
     +                  NBAS,1,
     +                  Q )
     +
     +
C
C
C             ...evaluate the NBO angular momentum table.
C
C
         DO LTYPE = 0,MXSHELL

            DO NBO = 1,NBAS
               BOND = NBOBD (NBO)
               NNHO = BDNBAS (BOND)
               ANGVAL = ZERO

               DO I = 1,NNHO
                  NHO = BDBAS (I,BOND)
                  CSQR = B (I,NBO) ** 2
                  ANGVAL = ANGVAL + CSQR * ANGNHO (NHO,LTYPE)
               END DO

               ANGNBO (NBO,LTYPE) = ANGVAL

            END DO
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine prints the unique factors of a number.

      subroutine factor(args,dimargs)
      implicit none

c ARGUMENT LIST
      integer dimargs
      character*80 args(dimargs)

c INTERNAL VARIABLES
      double precision d
      integer iArg
      integer iMult, iFact1, iFact2, iList(100), nFact, i

c EXTERNAL FUNCTIONS
      integer atoi
      external atoi

c ----------------------------------------------------------------------

      if (dimargs.eq.0) return

      do iArg = 1, dimargs

         iMult = atoi(args(iArg))
         i = sqrt(1.*(iMult+0.1))
         nFact = 0
         do iFact1 = i, 1, -1
            iFact2 = iMult/iFact1
            if (iFact1*iFact2.eq.iMult) then
               iList(nFact+1) = iFact1
               iList(nFact+2) = iFact2
               nFact = nFact + 2
               if (iFact1.eq.iFact2) nFact = nFact - 1
            end if
         end do
         call isort(iList,0,nFact,1)
         print *, iMult,' -> ',(iList(i),i=1,nFact)

      end do

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__INT2D_TO_E0F0
     +
     +                    ( SHELLA,SHELLP,SHELLC,SHELLQ,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__INT2D_TO_E0F0
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                eris [E0|F0] , E = A to P, F = C to Q, adding up all
C                the contributions from all the 2D PQ integrals.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                2DX and 2DY integrals, which can be achieved by having
C                the outer loops run over all possible x and y monomial
C                parts and the inner loops over all allowed E and F
C                shell combinations. The price to pay for such loop
C                ordering is the scattered addressing of locations
C                within the batch array, which has its rows and columns
C                ordered such that the E and F shells are increasing
C                and within each E and F shell the monomials are
C                ordered such that x>y>z in exponents.
C
C                An example follows:
C                -------------------
C
C                Let E = 0,2 and F = 0,1. Then we have the left and
C                right hand of the batch array ordered as follows:
C
C                          left xyz        right xyz
C
C                             000             000
C                             ---             ---
C                             100             100
C                             010             010
C                             001             001
C                             ---
C                             200 -> -5
C                             110
C                             101 -> -3
C                             020
C                             011
C                             002 -> 0
C                        
C                The batch would thus have dimensions 10 x 4. For
C                the left side (and analogous for the right side) the
C                reduced multiplication scheme would have its outer
C                most loop run over x=0,2, followed by the next loop
C                y=0,2-x. The innermost loop would then run over the
C                allowed shells E=E(max),max(E(min),x+y). In this
C                case all x,y-pairs can be reused for all appropriate
C                shell combinations.
C
C                To find the address of a specific x,y,z,E combination
C                inside the batch array, we first note that the z-part
C                is dependent on the x,y-parts and is hence not needed.
C                Lets look at the E-part first. The E-part is evaluated
C                from its dimension formula (E+1)*(E+2)/2. Organizing
C                the inner E-loop to run from E(max) always, the
C                dimension for E(max) is passed as the argument NXYZP
C                and all lower E dimensions are calculated by the
C                formula relating dimensions between E and E+1:
C
C                           dim(E+1) = dim(E) + E + 2
C
C                In this way multiplications in the E-part can be
C                entirely avoided. The x,y-part is defined as the
C                part which has to be subtracted from dim(E) to
C                reach the xyz monomial position inside the E shell.
C                It can be divided into an x-part and a y-part. The
C                x-part is given by the fomula:
C
C                          x-part = - x*E + x(x-3)/2
C
C                and for the example above has been given for E=2
C                and marked with arrows ->. The last term of the x-part
C                involves 1 multiplication and division, however it
C                can be changed to:
C
C                                               x-1
C                          x-part = - x*E - x + sum i
C                                               i=0
C
C                and clever additions inside the x-loop avoid the use
C                of multiplications and divisions. The y-part is trivial
C                and is simply equal to -y. The overall conclusion is
C                thus that the location of a specific x,y,z,E quadruple
C                inside the batch comes at the cost of one x*E(max)
C                multiplication in the outermost x-loops, since the
C                other x*E ones can again be reached via stepwise
C                subtraction of x from x*E(max).
C
C                Due to the very computational intensive steps inside
C                the x,y,z,E loops, special sections of identical
C                x,y,z,E loop structers have been given for each
C                # of roots =< 9, thus saving considerable computing
C                time over the general case.
C
C                For comments on how the x,y,z,E loop structures are
C                coded please refer to the general root case.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A,C and csh sums P=A+B,Q=C+D
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZE(F)T   =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B and in the range
C                                   F = C,...,Q=C+D
C                    NXYZy       =  # of cartesian monomials for
C                                   y = P,Q shells
C                    INT2Dx      =  all current 2D PQ integrals for
C                                   each cartesian component
C                                   (x = X,Y,Z)
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D PQ integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [E0|F0] integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,J,K,M,N
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZE,NXYZF,NXYZET,NXYZFT,NXYZP,NXYZQ
         INTEGER     SE,SF
         INTEGER     SEEND,SFEND
         INTEGER     SHELLA,SHELLP,SHELLC,SHELLQ
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX,XFMAX
         INTEGER     XEP,XFP,XYEP,XYFP
         INTEGER     XF,YF,ZF
         INTEGER     XYE,XYF
         INTEGER     YEEND,YFEND

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ,1:NXYZET,1:NXYZFT)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP,0:SHELLQ)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XFP = NXYZFT + 3
         DO 100 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 102 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 110 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 112 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M)
                         END DO
                     ELSE
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M) * INT2DY (M,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 120 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 122 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) = TEMP2 (M)
                               END DO
                           ELSE
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (M)
     +                                            * INT2DZ (M,ZE,ZF)
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  122                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  120                CONTINUE
  112             CONTINUE
  110          CONTINUE
  102       CONTINUE
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XFP = NXYZFT + 3
         DO 200 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 202 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 210 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 212 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 220 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 222 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
                                  K = K + 2
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
                                  K = K + 2
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  222                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  220                CONTINUE
  212             CONTINUE
  210          CONTINUE
  202       CONTINUE
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XFP = NXYZFT + 3
         DO 300 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 302 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 310 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 312 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 320 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 322 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
                                  K = K + 3
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
                                  K = K + 3
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  322                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  320                CONTINUE
  312             CONTINUE
  310          CONTINUE
  302       CONTINUE
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XFP = NXYZFT + 3
         DO 400 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 402 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 410 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 412 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 420 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 422 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
     +                                            + TEMP2 (K+3)
                                  K = K + 4
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
                                  K = K + 4
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  422                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  420                CONTINUE
  412             CONTINUE
  410          CONTINUE
  402       CONTINUE
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XFP = NXYZFT + 3
         DO 500 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 502 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 510 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 512 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 520 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 522 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
     +                                            + TEMP2 (K+3)
     +                                            + TEMP2 (K+4)
                                  K = K + 5
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
                                  K = K + 5
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  522                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  520                CONTINUE
  512             CONTINUE
  510          CONTINUE
  502       CONTINUE
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XFP = NXYZFT + 3
         DO 600 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 602 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 610 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 612 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 620 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 622 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
     +                                            + TEMP2 (K+3)
     +                                            + TEMP2 (K+4)
     +                                            + TEMP2 (K+5)
                                  K = K + 6
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
                                  K = K + 6
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  622                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  620                CONTINUE
  612             CONTINUE
  610          CONTINUE
  602       CONTINUE
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XFP = NXYZFT + 3
         DO 700 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 702 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 710 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 712 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 720 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 722 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
     +                                            + TEMP2 (K+3)
     +                                            + TEMP2 (K+4)
     +                                            + TEMP2 (K+5)
     +                                            + TEMP2 (K+6)
                                  K = K + 7
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                            + TEMP2 (K+6)
     +                                            * INT2DZ (K+6,ZE,ZF)
                                  K = K + 7
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  722                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  720                CONTINUE
  712             CONTINUE
  710          CONTINUE
  702       CONTINUE
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XFP = NXYZFT + 3
         DO 800 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 802 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 810 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 812 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 820 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 822 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
     +                                            + TEMP2 (K+3)
     +                                            + TEMP2 (K+4)
     +                                            + TEMP2 (K+5)
     +                                            + TEMP2 (K+6)
     +                                            + TEMP2 (K+7)
                                  K = K + 8
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                            + TEMP2 (K+6)
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                            + TEMP2 (K+7)
     +                                            * INT2DZ (K+7,ZE,ZF)
                                  K = K + 8
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  822                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  820                CONTINUE
  812             CONTINUE
  810          CONTINUE
  802       CONTINUE
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XFP = NXYZFT + 3
         DO 900 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 902 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 910 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 912 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 920 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 922 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE

                           IF (ZE+ZF.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            + TEMP2 (K+1)
     +                                            + TEMP2 (K+2)
     +                                            + TEMP2 (K+3)
     +                                            + TEMP2 (K+4)
     +                                            + TEMP2 (K+5)
     +                                            + TEMP2 (K+6)
     +                                            + TEMP2 (K+7)
     +                                            + TEMP2 (K+8)
                                  K = K + 9
                               END DO
                           ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                            + TEMP2 (K+6)
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                            + TEMP2 (K+7)
     +                                            * INT2DZ (K+7,ZE,ZF)
     +                                            + TEMP2 (K+8)
     +                                            * INT2DZ (K+8,ZE,ZF)
                                  K = K + 9
                               END DO
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  922                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  920                CONTINUE
  912             CONTINUE
  910          CONTINUE
  902       CONTINUE
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x-pairs. No skipping of the
C                x,x-contribution of 0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XFP = NXYZFT + 3
         DO 1000 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 1002 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO
C
C
C             ...middle loops over y,y-pairs. Skip multiplication
C                of y,y-contributions, if we have a 0,0-pair, as
C                then the 2DY integral is equal to 1.
C
C
               XYFP = XFP - XFMAX
               DO 1010 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 1012 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     IF (YE+YF.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF
C
C
C             ...inner loops over E,F-pairs. Skip multiplication
C                of z,z-contributions, if we have a 0,0-pair, as
C                then the 2DZ integral is equal to 1.
C
C
                     J = XYFP
                     NXYZF = NXYZQ
                     DO 1020 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 1022 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
C
C
C             ...all info concerning all three x,x-, y,y- and z,z-pairs
C                have been collected for all exponent quadruplets at
C                once. Sum up the 2D X,Y,Z integral products to the
C                appropriate place of the [E0|F0] batch.
C
C
                           IF (ZE+ZF.EQ.0) THEN
                               K = 0
                               DO M = 1,NEXQ
                                  SUM = ZERO
                                  DO N = 1,NGQP
                                     SUM = SUM + TEMP2 (K+N)
                                  END DO
                                  K = K + NGQP
                                  BATCH (M,I,J) = SUM
                               END DO
                           ELSE
                               K = 0
                               DO M = 1,NEXQ
                                  SUM = ZERO
                                  DO N = 1,NGQP
                                     SUM = SUM + TEMP2 (K+N)
     +                                         * INT2DZ (K+N,ZE,ZF)
                                  END DO
                                  K = K + NGQP
                                  BATCH (M,I,J) = SUM
                               END DO
                           END IF
C
C
C             ...next z,z-pair.
C
C
                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
 1022                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
 1020                CONTINUE
C
C
C             ...next y,y-pair and next x,x-pair.
C
C
 1012             CONTINUE
 1010          CONTINUE
 1002       CONTINUE
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine xscal(n,da,dx,incx)
      implicit none
      double precision da,dx(*)
#ifdef ACES64
      integer*8 n, incx
#else
      integer n, incx
#endif

      integer i,p,nincx

      if (n.le.0 .or. incx.le.0 .or. da.eq.1.d0) return

         do i = 1, n
            dx(i) = da*dx(i)
         end do

      return
c     end subroutine xscal
      end

      subroutine dscal(n,da,dx,incx)
      implicit none
      double precision da,dx(*)
#ifdef ACES64
      integer*8 n, incx
#else
      integer n, incx
#endif

      integer i,p,nincx

      if (n.le.0 .or. incx.le.0 .or. da.eq.1.d0) return

         do i = 1, n
            dx(i) = da*dx(i)
         end do

      return
c     end subroutine dscal
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine contract_oed_2derv_type1b(type, density, z,
     *                       da1, da2, db1, db2, hess)
c---------------------------------------------------------------------------
c  Computes the set of OED second derivative integrals matching "type" and 
c  contracts them with density block (da1:da2, db1:db2). Note that the 
c  density block may be the density(for type = 1,2) or an intermediate
c  array(for type = 3).
c
c   type = 1 --> NAI integrals
c          2 --> KIN integrals
c          3 --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'hess.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer type, ipertx
      integer da1, da2, db1, db2
      double precision density(da1:da2, db1:db2)
      double precision z(da1:da2, db1:db2)
      double precision hess(3*ncenters,3*ncenters)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif

      integer i, j, m, n, nfirst, nints, nalpha, ncoeff, iatom, jatom 
      integer component, icomponent, jcomponent, ix, jx, ncsum  
      integer a, b, a1,a2,b1,b2,lastao, ihess, jhess, newatoms, 
     *        map(max_centers)  
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc, jxderc 
      integer ind(2)
      integer flopcount
      logical spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers), newcharge(max_centers)
      double precision xold(max_centers), yold(max_centers), 
     *                 zold(max_centers)
      double precision x1,y1,z1,x2,y2,z2, x, y, tess, fact 
      double precision x1p,y1p,z1p,x2p,y2p,z2p, eps

      if (type .ne. 1) then
         print *,'Error: Invalid type in contract_oed_2derv_type'
         print *,'type = ',type
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif
      spherical = (ispherical .eq. 1)
      lastao = end_nfps(nshells)

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: contract_oed_2derv_type1 requires ERD ',
     *           'integral package.'
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block of density data.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)
      
c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xold(iatom) = dbuf(icoord+3*(m-1))
         yold(iatom) = dbuf(icoord+3*(m-1)+1)
         zold(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       do m = m1, m2
       do n = n1, n2

            ncsum = ncfps(m) + ncfps(n) 
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)
 
            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend), 
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

c-------------------------------------------------------------------------
c /Sum_C d/dx (A_x|C|B) type derivative integrals. 
c-------------------------------------------------------------------------

c loop over derivatives on centers

         do ixderc = 1, ncenters

            iatom         = ixderc
            do icomponent = 1, 3   ! component is x, y, or z term of gradient

c loop over perturbations in the x-direction 

            do jatom      = 1, ncenters  
            do jcomponent = 1, 3  

c-------------------------------------------------------------------------
c   Clear the integral block.
c-------------------------------------------------------------------------

               do b = db1, db2
               do a = da1, da2
                  z(a,b) = 0.
               enddo
               enddo

c-------------------------------------------------------------------------
c   Initialize the derivative array.
c-------------------------------------------------------------------------

               der1x = 0
               der1y = 0
               der1z = 0
               der2x = 0
               der2y = 0
               der2z = 0

               dercx  = 0
               dercy  = 0
               dercz  = 0

c-------------------------------------------------------------------------
c   Set the derivative array.
c-------------------------------------------------------------------------

               if (icomponent .eq. 1) dercx = 1
               if (icomponent .eq. 2) dercy = 1
               if (icomponent .eq. 3) dercz = 1

               if (ixderc .eq. atom(m)) then
                  if (icomponent .eq. 1) der1x = 1
                  if (icomponent .eq. 2) der1y = 1
                  if (icomponent .eq. 3) der1z = 1
               endif

               if (ixderc .eq. atom(n)) then
                  if (icomponent .eq. 1) der2x = 1
                  if (icomponent .eq. 2) der2y = 1
                  if (icomponent .eq. 3) der2z = 1
               endif

c-------------------------------------------------------------------------
c   Initialize the geometry.
c-------------------------------------------------------------------------

               newatoms = 0 
               do jx = 1, ncenters  
                  newatoms = newatoms + 1 
                  xn(jx) = xold(jx)  
                  yn(jx) = yold(jx)  
                  zn(jx) = zold(jx)  
                  newcharge(jx) = charge(jx)  
               enddo

               eps   = 0.0000001d0 
c
c-------------------------------------------------------------------------
c
c XX integrals first. 
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 1) then 

                x1p = x1  
                y1p = y1  
                z1p = z1  

                x2p = x2  
                y2p = y2  
                z2p = z2  

                xn(jatom) = xold(jatom) + eps 

                if (atom(m) .eq. jatom) then 

                   x1p = x1 + eps 

                endif 

                if (atom(n) .eq. jatom) then  

                   x2p = x2 + eps 

                endif 

                go to 111 

             endif 
c
c-------------------------------------------------------------------------
c
c YY integrals first. 
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 2) then 

                x1p = x1  
                y1p = y1  
                z1p = z1  

                x2p = x2  
                y2p = y2  
                z2p = z2  

                yn(jatom) = yold(jatom) + eps 

                if (atom(m) .eq. jatom) then 

                   y1p = y1 + eps 

                endif 

                if (atom(n) .eq. jatom) then  

                   y2p = y2 + eps 

                endif 

                go to 111 

             endif 
c
c-------------------------------------------------------------------------
c
c ZZ integrals next. 
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 3) then 

                x1p = x1  
                y1p = y1  
                z1p = z1  

                x2p = x2  
                y2p = y2  
                z2p = z2  

                zn(jatom) = zold(jatom) + eps 

                if (atom(m) .eq. jatom) then 

                   z1p = z1 + eps 

                endif 

                if (atom(n) .eq. jatom) then  

                   z2p = z2 + eps 

                endif 

                go to 111 

             endif 
c
c-------------------------------------------------------------------------
c
111          continue 

c-------------------------------------------------------------------------
c   Clear the integral block.
c-------------------------------------------------------------------------

               do b = db1, db2
               do a = da1, da2
                  z(a,b) = 0.
               enddo
               enddo
c
                if (atom(m) .eq. atom(n)) then 

                   if (der1x .ne. 0) der2x = der1x  
                   if (der1y .ne. 0) der2y = der1y  
                   if (der1z .ne. 0) der2z = der1z  

                   if (der2x .ne. 0) der1x = der2x  
                   if (der2y .ne. 0) der1y = der2y  
                   if (der2z .ne. 0) der1z = der2z  

               endif 
c
c Stationary integrals: 
c --------------------- 
c
                  call oed__gener_nai_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 ncenters, xold,yold,zold, charge, ixderc,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, 
     *                 dercx, dercy, dercz, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst, 
     *                 dbuf(dpkgscr))     

               if (nints .gt. 0) then
                  a2 = end_nfps(m)
                  if (m .eq. 1) then
                     a1 = 1
                  else
                     a1 = end_nfps(m-1)+1
                  endif

                  b2 = end_nfps(n)
                  if (n .eq. 1) then
                     b1 = 1
                  else
                     b1 = end_nfps(n-1)+1
                  endif

                 call move_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)

               endif ! nints 
c
c Perturbed integrals 
c ------------------- 
c
                  call oed__gener_nai_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), 
     *                 x1p,y1p,z1p,x2p,y2p,z2p,
     *                 ncenters, xn, yn, zn, charge, ixderc,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, 
     *                 dercx, dercy, dercz, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst, 
     *                 dbuf(dpkgscr))     

               if (nints .gt. 0) then
                  a2 = end_nfps(m)
                  if (m .eq. 1) then
                     a1 = 1
                  else
                     a1 = end_nfps(m-1)+1
                  endif

                  b2 = end_nfps(n)
                  if (n .eq. 1) then
                     b1 = 1
                  else
                     b1 = end_nfps(n-1)+1
                  endif

                 fact = -1.0d0 
                 call add_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2,fact)

c--------------------------------------------------------------------------
c   Contract the density block with the block of integrals.
c--------------------------------------------------------------------------

                 y = 0.0d0
                 call cwork0222(y,
     *                          density,da1,da2,db1,db2,
     *                          da1,da2,db1,db2, ind,
     *                          z,da1,da2,db1,db2,
     *                          da1,da2,db1,db2,ind(1), ind(2),
     *                          flopcount)

c---------------------------------------------------------------------------
c   Sum into the hessian.
c---------------------------------------------------------------------------

                 ihess = (iatom-1)*3 + icomponent 
                 jhess = (jatom-1)*3 + jcomponent 

c                if (atom(m) .ne. atom(n)) y = y*2.0d0  

c                 if (dbg .and. icomponent .eq. 3 .and. 
c     *             jcomponent .eq. 3
c     *           .and. iatom .eq. 1 .and. jatom .eq. 1)
c     *           write(6,*) ' M N :', m, n, y/eps 
                 hess(jhess,ihess) = hess(jhess,ihess) + y/eps  

               endif ! nints 
1000           continue 

            enddo ! jcomponent
            enddo ! jatom   
            enddo ! icomponent
            enddo ! ixderc 

c           endif 

c-------------------------------------------------------------------------
c /Sum_C (A_x|C|A_x), A .eg. B  type derivative integrals. 
c-------------------------------------------------------------------------

c-------------------------------------------------------------------------
c /Sum_C (A_xx|C|A) type derivative integrals. 
c-------------------------------------------------------------------------


c-------------------------------------------------------------------------
c  Integral derivatives of type (A|C_xx|B) --> C .ne. A,B.
c-------------------------------------------------------------------------


c-------------------------------------------------------------------------
c  Integral derivatives of type (A_x|C_x|A) --> C .ne. A.
c-------------------------------------------------------------------------


       enddo ! n = n1, n2
       enddo ! m = m1, m2

      return
      end

      Subroutine Factorial
C 
C Compute factorial of n! (n(n-1)...21), and 0! = 1
c
      Implicit Double Precision(A-H, O-Z)

#include "ecp.par"
#include "ecp.com"
      
      fact(0)  = 1.0D0
      Fact(1)  = 1.0D0
      Fact(2)  = 2.0D0

      FI = 2.0D0

      Do I = 2, 2*Maxang-1
         FI = FI + 1.0D0
         Fact(I+1) =  FI*Fact(I)
      EndDo

      Do I = 1, 2*Maxang
         Do J = 1, I
            Fprod(J, I) = Fact(I+(J-1)-1)/(Fact(J-1)*Fact(I -(J-1)-1))
         Enddo
      Enddo

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_np2  
     +                     (array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)

c--------------------------------------------------------------------------
c Scalar value    ARRAY  
c            1    CA  
c            2    CB  
c            3    FOCK_A   
c            4    FOCK_B   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'int_gen_parms.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base, daddr
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer sind, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer*8 get_block_index
      integer stack

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the scalar. --> what do we want to calculate??   
c---------------------------------------------------------------------------

      evec_array  = op(c_result_array)
      evec_type   = array_table(c_array_type, evec_array)
      nindex_evec = array_table(c_nindex, evec_array)

      if (evec_type .ne. scalar_value) return

      if (evec_array .lt. 1 .or. evec_array .gt. narray_table) then
         print *,'Error: Invalid scalar in set_psect, line ',
     *     current_line
         print *,'Array index is ',array,' Allowable values are ',
     *      ' 1 through ',narray_table
         call abort_job()
      endif 

      sind =  array_table(c_scalar_index, evec_array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in set_psect, ',
     *           'line ',current_line
         print *,'Index for array ',evec_array,' is ',ind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix which is to be analyses.
c---------------------------------------------------------------------------

      array      = op(c_op1_array)

      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      daddr = address_table(array)
      iarray  = get_index_from_base(daddr, x, 2)

      if (array .eq. 0) then
         print *,'Error: The first argument in return_sval  
     *            must be an array.'  
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index

          call set_ca(x(iarray),scalar_table(sind),
     *             1,n1,1,n2,nindex_table, nsegment_table)

      return 
      end 

      subroutine set_ca(psect,sval,a1,a2,b1,b2, 
     *                       nindex_table, nsegment_table) 

c---------------------------------------------------------------------------
c
c 
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'symbolic_constants.h'
c
      integer ival, i, j, k, l, a, a1, a2, b, b1, b2   
      double precision psect(a1:a2,b1:b2)
      double precision sval, stemp   
      double precision efinal, conv   
      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 

      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer ierr, array, array_type, ind, nind
      integer nseg, bseg, eseg, start(100), end(100), maxi

      integer nao_seg, nocc_seg, occ_size_avg, ao_size_avg, b_size  
      integer NW, NS          

       ival = sval 

c      if (me .eq. 0) then 
         if (ival .eq. 1) then 
            open (33,file='ca_data',status='old') 
            do i = 1, a2 
            do j = 1, b2 
               read(33,*) k, l, psect(i,j) 
            enddo 
            enddo 
          endif 
         if (ival .eq. 2) then 
            open (34,file='cb_data',status='old') 
            do i = 1, a2 
            do j = 1, b2 
               read(34,*) k, l, psect(i,j) 
            enddo 
            enddo 
          endif 
         if (ival .eq. 3) then 
            open (35,file='focka_data',status='old') 
            do i = 1, a2 
            do j = 1, b2 
               read(35,*) k, l, psect(i,j) 
            enddo 
            enddo 
          endif 
         if (ival .eq. 4) then 
            open (36,file='fockb_data',status='old') 
            do i = 1, a2 
            do j = 1, b2 
               read(36,*) k, l, psect(i,j) 
            enddo 
            enddo 
          endif 
c      endif 
c 
c------------------------------------------------------------------------


      return
      end

c This routine reads a logical value.  If the keyword has a value,
c the value must be one of the (case-insensitive) following:
c   yes, true,   1,  on,  y,  t
c   no,  false,  0,  off  n,  f
c If it does not have a value, it is set to .true.
c
c Variables which have default values may safely be passed in both
c as the default value and as the value read in.

      subroutine nl_log(key,def,var)
      implicit none

      character*(*) key
      logical var,def

#include "namelist.com"
#include "callstack.com"

      character*5 val,defval
      logical nl_key,present,streq
      integer strlen

      callstack_prev=callstack_curr
      callstack_curr='NL_LOG'

      var=def

      val=' '
      present=nl_key(key,val)
      if (present) then
         var=.true.
         if (strlen(val).gt.0) then
            if (streq(val,'yes',.true.) .or.
     &          streq(val,'true',.true.) .or.
     &          streq(val,'y',.true.) .or.
     &          streq(val,'t',.true.) .or.
     &          streq(val,'1',.true.) .or.
     &          streq(val,'on',.true.)) then
               var=.true.
            else if (streq(val,'no',.true.) .or.
     &               streq(val,'false',.true.) .or.
     &               streq(val,'n',.true.) .or.
     &               streq(val,'f',.true.) .or.
     &               streq(val,'0',.true.) .or.
     &               streq(val,'off',.true.)) then
               var=.false.
            else
               write(*,*) '@NL_LOG: invalid value for ',key
               call errex
            end if
         end if
      end if

      if (prt_nl .and. .not.streq(key,'print_nl',.true.)) then
         val='false'
         if (var) val=' true'
         defval='false'
         if (def) defval=' true'
         if (val.eq.defval) then
            write(*,900) key,'logical',val
  900       format(a20,2x,a10,2x,a20)
         else
            write(*,910) key,'logical',val,defval
  910       format(a20,2x,a10,2x,a20,2x,a20)
         end if
      end if

      callstack_curr=callstack_prev
      return
c     end subroutine nl_log
      end

      subroutine beckegrid(RADNUM,ANGNUM,r_point,r_weight,bsrd,
     & x_lebed,y_lebed,z_lebed,lebed_weight)
      implicit none
c----------------------------------------------------------------------------
c The purpose of this subroutine is to set up grid for the integration of   |
c      multicenter objects using Becke's method of fuzzy cells              |
c                                                                           |
c----------------------------------------------------------------------------
c----------------------------------------------------------------------------
      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'dbugcom.h'
      include 'trace.h'
      include 'dropmo.h'
      include 'sial_config_params.h'
      include 'F12_gr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
c-----------------------------------------------------------------------------


c-----------Input parameters--------------------------------------------------
      integer RADNUM,atnumber,ANGNUM,N
c----------------------------------------------------------------------------- 
      
      double precision bsrd(105),r_point(RADNUM),r_weight(RADNUM),
     & x_lebed(ANGNUM),y_lebed(ANGNUM),z_lebed(ANGNUM),
     & lebed_weight(ANGNUM),dref,GRIDX,GRIDY,GRIDZ,GRIDW,AtCoordX,
     & AtCoordY,AtCoordZ,CUTLIM,ATWT

      integer coretop,i000,natm,natmx,comppopv,compmemb,atmchr,atmcrd,
     & atmmas,I,J,K,iref,compnorb,iGRDPTX,iGRDPTY,iGRDPTZ,iGRDPTWT,
     & BLSIZE,ind,funit,ind1,ind2,AIJ,VxIJ,VyIJ,VzIJ,iRIJ,iRp,iWWT,NITR

  
      integer*8 itop,itop1,itop2,itop3
      integer NEED,NEED1,ierr,iq(3)

      parameter (BLSIZE = 500)
      parameter (funit = 34 )
      parameter (NITR = 4)

C------------------------------------------------------------------------
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (iptr, ibuf)
#else
      equivalence (ibuf, dbuf)
      common dbuf    ! blank common for scratch.
#endif

#ifdef ALTIX
      dptr = dshptr     ! set dbuf pointer to shared mem.
      iptr = ishptr     ! set ibuf pointer to shared mem.
#endif


c----------------------------------------------------------------------------
c-----------Open file to store grid points and weights-----------------------

c      open(unit=funit,file='GRIDDATA',FORM='UNFORMATTED',
c     &     STATUS='UNKNOWN',ACCESS='SEQUENTIAL')
      
c-----------Reading information about atomic centers----------------------------------
      call getrec (20, 'JOBARC', 'NATOMS  ', 1, natmx)
      call getrec (20, 'JOBARC', 'NREALATM', 1, natm)
      call getrec (20, 'JOBARC', 'COMPNORB', 1, compnorb)

c------Memory allocation and partitioning---------------------------------------------
      comppopv = 1
      compmemb = comppopv + natmx
      atmchr   = compmemb + natmx
      NEED1 = atmchr + natmx
       
    
      call mem_alloc(ibuf, NEED1, intsize, itop1, .true., ierr)
      if(ierr.ne.0) then
      write(6,*) 'Not enough memory!!!!'
      return
      endif 

C-------------------------------------------------------------------------------------

      call igetrec (20, 'JOBARC', 'COMPPOPV', 
     &                            natmx, ibuf (itop1+comppopv-1))
      call igetrec (20, 'JOBARC', 'COMPMEMB', 
     &                            natmx, ibuf (itop1+compmemb-1))
      call igetrec (20, 'JOBARC', 'ATOMCHRG', 
     &                              natmx, ibuf(itop1+atmchr-1)  )


c--------------------------------------------------------------------------------------
      atmcrd  = 1
      atmmas   = atmcrd + natmx * 3
      NEED = atmmas + natmx

      call mem_alloc(dbuf, NEED, bytes_per_double, itop, .true., ierr)
      if(ierr.ne.0) then
      write(6,*) 'Not enough memory!!!!'
      return
      endif


      call getrec (20, 'JOBARC','COORD   ',natmx*3,
     &                                    dbuf(itop+atmcrd-1) )
      call getrec (20, 'JOBARC','ATOMMASS',natmx,  
     &                                    dbuf(itop+atmmas-1) )
c

      call rmdummy (
     &     natmx, natm, compnorb, ibuf (itop1+comppopv-1),
     &     ibuf(itop1+compmemb-1),ibuf (itop1+atmchr-1), 
     &     dbuf(itop+atmmas-1), dbuf(itop+atmcrd-1) )
c---------------------------------------------------------------------------------------


        call recharge(natmx, ibuf (itop1+atmchr-1) )

           
c--Step 1 - set up Slater- Bragg radii for atoms and construction of AIJ paramters-------
c----and interatomic pair vectors for the construction of cutoff functions---------------

       AIJ = 1
       VxIJ = AIJ + natmx*natmx
       VyIJ = VxIJ + natmx*natmx
       VzIJ = VyIJ + natmx*natmx
       iRIJ = VzIJ + natmx*natmx
       iRp = iRIJ + natmx*natmx
       iWWT = iRp + natmx 
       NEED = iWWT + natmx

      call mem_alloc(dbuf, NEED, bytes_per_double, itop2, .true., ierr)
      if(ierr.ne.0) then
      write(6,*) 'Not enough memory!!!!'
      return
      endif


      call bsr(bsrd)
      
      call make_aij(dbuf(itop2+AIJ-1),dbuf(itop2+VxIJ-1),
     & dbuf(itop2+VyIJ-1),dbuf(itop2+VzIJ-1),dbuf(itop2+iRIJ-1),
     & ibuf (itop1+atmchr-1),dbuf(itop+atmcrd-1),bsrd,natmx) 
       
       
c-------Step 2 - set up angular Lebedev grid-------------------------
 
      if(ANGNUM.eq.194) then
       call LD0194( x_lebed,y_lebed,z_lebed,lebed_weight,N )
      endif 


c---------------------------------------------------------------------

       ind = 0
       ind1 = 0  
       CUTLIM = 1.d-14 
                  DO K=1,natmx          

                  atnumber = iref (K, ibuf (itop1+atmchr-1))
                  AtCoordX = dref (1+3*(K-1), dbuf(itop+atmcrd-1) )
                  AtCoordY = dref (2+3*(K-1), dbuf(itop+atmcrd-1) )
                  AtCoordZ = dref (3+3*(K-1), dbuf(itop+atmcrd-1) )

c-------Step 3 - set up radilal mesh for each atom--------------------
       call zero(r_point, RADNUM)
       call zero(r_weight,RADNUM)       

       call rad_mesh_new(r_point,r_weight,RADNUM,bsrd,atnumber)

c-------Construction of the grid for each atom------------------------

          DO I=1,RADNUM
           DO J=1,N
           

           GRIDX = r_point(I)*x_lebed(J)      
           GRIDY = r_point(I)*y_lebed(J) 
           GRIDZ = r_point(I)*z_lebed(J) 

c---Here we create weights for each poit using Becke fuzzy cell method-


c---------------------------------------------------------------------- 
         call atomweights(K,natmx,dbuf(itop2+AIJ-1),dbuf(itop2+VxIJ-1),
     & dbuf(itop2+VyIJ-1),dbuf(itop2+VzIJ-1),dbuf(itop2+iRIJ-1),GRIDX,
     & GRIDY,GRIDZ,dbuf(itop2+iRp-1),dbuf(itop2+iWWT-1),ATWT,NITR)

           GRIDX = r_point(I)*x_lebed(J) + AtCoordX
           GRIDY = r_point(I)*y_lebed(J) + AtCoordY
           GRIDZ = r_point(I)*z_lebed(J) + AtCoordZ


           GRIDW = (4.d0*3.1415926535898d0)*
     &        r_weight(I)*lebed_weight(J)

c           write(6,*) r_weight(I),I,'<<----'

           GRIDW = GRIDW*ATWT


c---------------Processing of the grid---------------------------------
           call procgrid(GRIDX,GRIDY,GRIDZ,GRIDW,BLSIZE,ind,ind1,ind2,
     &     funit,CUTLIM)
c---------------------------------------------------------------------
           
           ENDDO
          ENDDO


                  ENDDO

c------------Write on disk remaining point and weights ---------------
c           if(ind2.eq.1) then
c           CALL Gwrite(funit,dbuf(itop3+iGRDPTX-1),BLSIZE  )
c           CALL Gwrite(funit,dbuf(itop3+iGRDPTY-1),BLSIZE  )
c           CALL Gwrite(funit,dbuf(itop3+iGRDPTZ-1),BLSIZE  )
c           CALL Gwrite(funit,dbuf(itop3+iGRDPTWT-1),BLSIZE )
c           endif


        write(6,*) 'Number of points on Lebedev grid ... ',N
        write(6,*) 'Number of points on radial grid ... ',RADNUM
        write(6,*) 'Number of grid points per atom ...',N*RADNUM
        write(6,*) 'Total number of grid points ...',ind1
        NPT = ind1
c      close(funit,status='keep')       
 
      return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine atomweights(K,natmx,AIJ,VxIJ,VyIJ,VzIJ,RIJ,GRIDX,GRIDY,
     & GRIDZ,Rp,WWT,ATWT,NITR)
      implicit none
c-----------------------------------------------------------------------
c This subroutine compute atomic weights for each grid point           |
c  using Becke fuzzy cells approach                                    |
c-----------------------------------------------------------------------
      integer natmx,J,L,NITR,N,K
      double precision GRIDX,GRIDY,GRIDZ,ATWT,AIJ(natmx,natmx),
     & VxIJ(natmx,natmx),VyIJ(natmx,natmx),VzIJ(natmx,natmx),Xp,Yp,Zp,
     & RIJ(natmx,natmx),QQQ,Rp(natmx),WWT(natmx),cutoffIJ,cutoffJI,muij,
     & nuij,Wattot

c---------Step 1 - definition of the position of grid point ------------
c    with rescpect to atomic center J   --------------------------------

          DO J=1,natmx
             Xp = VxIJ(K,J) + GRIDX
             Yp = VyIJ(K,J) + GRIDY
             Zp = VzIJ(K,J) + GRIDZ
             QQQ = Xp**2.d0 + Yp**2.d0 + Zp**2.d0
             Rp(J) = DSQRT(QQQ)
             WWT(J) = 1.d0
          enddo

c----------Step 2 - definition of cut-off function-----------------------
          DO J=1,natmx

c   -------Check if atom is real------- 
          IF(DABS(AIJ(J,1)+1.d0).lt.1d-5) then
          WWT(J) = 0.d0 
          goto 1234
          endif 
c   ------------------------------------
             DO L=1,J-1
              if(ABS(AIJ(K,J)-1.d0).lt.1d-5) then
              cutoffIJ = 1.d0
              goto 1233
              endif
                muij = ( Rp(J) - Rp(L) ) / RIJ(J,L)
                nuij = muij + AIJ(J,L)*(1.d0 - muij**2.d0)

c---------Here nuij - is a generaralized border function for pair ij----------
c----Generation of cutoff function for ij pair with fuzzy polynomial of Becke |
c------------------------------------------------------------------------------

               QQQ = nuij
                DO N=1,NITR
                 QQQ = QQQ*(1.5d0 - 0.5d0*QQQ*QQQ)                 
                ENDDO
                cutoffIJ = 0.5d0*(1.d0-QQQ)
                cutoffJI = 0.5d0*(1.d0+QQQ)
                WWT(J) = cutoffIJ*WWT(J)
                WWT(L) = cutoffJI*WWT(L) 

1233         continue
             ENDDO
1234      continue
          enddo

             Wattot = 0.d0
             DO J=1,natmx
             Wattot = Wattot + WWT(J) 
             enddo

             ATWT = WWT(K)/Wattot
c             write(6,*) 'ATWT =',ATWT,'nnnnnn'
      return
      end 
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine make_aij(AIJ,VxIJ,VyIJ,VzIJ,RIJ,atchar,atcoord,bsrd,
     & natmx)
      implicit none
c-----------------------------------------------------------------------
c     This subroutine construct a_ij array, which is necessary         |
c     for construction of Becke fuzzy cells and interatomic            | 
c            pair vectors  V_ij                                        |
c-----------------------------------------------------------------------
      integer natmx,I,J,atchar(natmx),a1,a2
      double precision AIJ(natmx,natmx),bsrd(105),chi,uij,
     & VxIJ(natmx,natmx),VyIJ(natmx,natmx),VzIJ(natmx,natmx),
     & atcoord(3,natmx),RIJ(natmx,natmx),QQQ

        DO I=1,natmx
         a1 = atchar(I)
         AIJ(I,I) = 0.d0
          IF(a1.eq.0) then
          AIJ(I,1) = -1.d0
          goto 4800
          endif 
         
          DO J=1,natmx
          IF(I.EQ.J) goto 4700
           a2 = atchar(J)
           IF(a2.eq.0) THEN
           AIJ(I,J) = 1.d0
           goto 4700 
           ENDIF

           chi = bsrd(a1)/bsrd(a2)
           uij = (chi - 1.d0)/(chi + 1.d0 )
           AIJ(I,J) = uij/(uij*uij-1.d0)

           if(AIJ(I,J).gt.0.5d0) AIJ(I,J)=0.5d0
           if(AIJ(I,J).lt.-0.5d0) AIJ(I,J)=-0.5d0 

4700      continue
          ENDDO
4800      continue
        ENDDO

c-------Interatomic pair vectors----------------------------------------
        DO I=1,natmx
        VxIJ(I,I) = 0.d0
        VyIJ(I,I) = 0.d0
        VzIJ(I,I) = 0.d0        
        RIJ(I,I) = 0.d0
          DO J=1,I-1
          VxIJ(I,J) = atcoord(1,I) - atcoord(1,J) 
          VyIJ(I,J) = atcoord(2,I) - atcoord(2,J)
          VzIJ(I,J) = atcoord(3,I) - atcoord(3,J)
          VxIJ(J,I) = - VxIJ(I,J)
          VyIJ(J,I) = - VyIJ(I,J)
          VzIJ(J,I) = - VzIJ(I,J)
          QQQ = VxIJ(I,J)**2.d0 + VyIJ(I,J)**2.d0 + VzIJ(I,J)**2.d0
          RIJ(I,J) = DSQRT(QQQ)
          RIJ(J,I) = RIJ(I,J)  
          ENDDO 
        ENDDO
      return
      end 
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine procgrid(GRIDX,GRIDY,GRIDZ,GRIDW,
     & BLSIZE,ind,ind1,ind2,funit,CUTLIM)

      implicit none

      include 'F12_gr.h'
c-----------------------------------------------------------------------
c       This subroutine copy points and weights to auxiliary array     |
c         and dump it to disk                                          |
c-----------------------------------------------------------------------
      integer BLSIZE,ind,funit,K,ind1,ind2
      double precision GRIDX,GRIDY,GRIDZ,GRIDW,CUTLIM 
     
        ind2 = 0        

        IF(GRIDW.ge.CUTLIM) then
        ind = ind + 1
        ind1 = ind1 + 1 
      PTX(ind1) = GRIDX
      PTY(ind1) = GRIDY
      PTZ(ind1) = GRIDZ
      PTW(ind1) = GRIDW       
c        write(6,*) PTX(ind1), PTY(ind1), PTZ(ind1), '<++==',ind1 
        endif       

c           IF(ind.eq.BLSIZE) then
c           CALL Gwrite(funit,PTX,BLSIZE)
c           CALL Gwrite(funit,PTY,BLSIZE)
c           CALL Gwrite(funit,PTZ,BLSIZE)
c           CALL Gwrite(funit,PTW,BLSIZE) 


c           ind = 0
c           ELSE
c           ind2 = 1
c           ENDIF 

      
      return
      end 

c----------------------------------------------------------------------

c----------------------------------------------------------------------
c-------------------Auxiliary functions--------------------------------

      subroutine Gread(N,ARR,LEN)
      integer N,LEN
      double precision ARR(LEN)
c--------read array ARR of size LEN from the file of unit N ------------
            READ(N) ARR
      return
      end

c------------------------------------------------------------------------
c------------------------------------------------------------------------

      subroutine Gwrite(N,ARR,LEN)
      integer N,LEN
      double precision ARR(LEN)
c--------read array ARR of size LEN from the file of unit N ------------
            WRITE(N) ARR
      return
      end


c------------------------------------------------------------------------


 
c--------some auxiliary functions-------------------------------------

      function dref (n, a)
      integer n
      double precision a (*), dref
      dref = a (n)
      return
      end
c---------------------------------------------------------------------
c---------------------------------------------------------------------
      function iref (n, i)
      integer n, i (*), iref
      iref = i (n)
      return
      end
c---------------------------------------------------------------------

c------------------------------------------------------------------------
       subroutine recharge(natmx,atchar)
       implicit none   
       integer I,natmx,atchar(natmx)

          do I=1,natmx
           IF(atchar(I).eq.110) atchar(I)=1
          enddo
       return
       end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer*8 function get_index_from_base(base, anchor, type)
      implicit none
      include 'machine_types.h'

      double precision x(2)
      integer ix(2)
      integer size

      integer anchor(*)
      integer*8 base
      integer*8 c_loc64
      integer*8 anchor_addr
      integer*8 ixx
      integer type
      integer*8 unmask_addr
      integer*8 ubase, uanchor

      if (type .eq. 1) then
         size = intsize
      else if (type .eq. 2) then
         size = bytes_per_double
      else if (type .eq. 3) then
         size = 8   ! 64 bit integer
      else
         print *,'Invalid size in get_index_from_base: size ',size
      endif

      ixx = 1
      anchor_addr = c_loc64(anchor, ixx, 1)
      ubase = unmask_addr(base)
      uanchor = unmask_addr(anchor_addr)
c      print *,'Task ',my_pe(),' GET_INDEX: base ',ubase,
c     *     ' anchor_addr ',uanchor,
c     *     ' size ', size,' return index ',
c     *          (ubase-uanchor)/size+1
     
      get_index_from_base = (ubase - uanchor)/size+1
      return
      end
      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine block_map_table_setup(array_table, narray_table,
     *                                 index_table, nindex_table, 
     *                                 segment_table, nsegment_table,
     *                                 nblock_map_table)
c---------------------------------------------------------------------------
c   Scans the array table to determine the number of entries necessary 
c   for the block_map_table.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'

      integer narray_table,nindex_table,nsegment_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer nblock_map_table
     
      integer i, nind, k, nblks
      integer bseg, eseg, nseg, ind

      nblock_map_table = 0
      do i = 11, narray_table   ! 1st 10 arrays are pre-defined.
         if (array_table(c_array_type,i) .eq. distributed_array .or.
     *       array_table(c_array_type,i) .eq. served_array ) then

c-------------------------------------------------------------------------
c   Define the block_map_entry table for the array.
c-------------------------------------------------------------------------

            nind = array_table(c_nindex,i)
            nblks = 1
            do k = 1, nind
               ind = array_table(c_index_array1+k-1,i)
               bseg = index_table(c_bseg, ind)
               eseg = index_table(c_eseg, ind)
               nseg = eseg - bseg + 1
               nblks = nblks * nseg
            enddo

            nblock_map_table = nblock_map_table + nblks
         endif 
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK DGESL
      SUBROUTINE DGESL (A, LDA_ARG, N_ARG, IPVT, B, JOB_ARG)
C***BEGIN PROLOGUE  DGESL
C***PURPOSE  Solve the real system A*X=B or TRANS(A)*X=B using the
C            factors computed by DGECO or DGEFA.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A1
C***TYPE      DOUBLE PRECISION (SGESL-S, DGESL-D, CGESL-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, MATRIX, SOLVE
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     DGESL solves the double precision system
C     A * X = B  or  TRANS(A) * X = B
C     using the factors computed by DGECO or DGEFA.
C
C     On Entry
C
C        A       DOUBLE PRECISION(LDA, N)
C                the output from DGECO or DGEFA.
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C        IPVT    INTEGER(N)
C                the pivot vector from DGECO or DGEFA.
C
C        B       DOUBLE PRECISION(N)
C                the right hand side vector.
C
C        JOB     INTEGER
C                = 0         to solve  A*X = B ,
C                = nonzero   to solve  TRANS(A)*X = B  where
C                            TRANS(A)  is the transpose.
C
C     On Return
C
C        B       the solution vector  X .
C
C     Error Condition
C
C        A division by zero will occur if the input factor contains a
C        zero on the diagonal.  Technically this indicates singularity
C        but it is often caused by improper arguments or improper
C        setting of LDA .  It will not occur if the subroutines are
C        called correctly and if DGECO has set RCOND .GT. 0.0
C        or DGEFA has set INFO .EQ. 0 .
C
C     To compute  INVERSE(A) * C  where  C  is a matrix
C     with  P  columns
C           CALL DGECO(A,LDA,N,IPVT,RCOND,Z)
C           IF (RCOND is too small) GO TO ...
C           DO 10 J = 1, P
C              CALL DGESL(A,LDA,N,IPVT,C(1,J),0)
C        10 CONTINUE
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  XDAXPY, XDDOT
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DGESL
#ifdef ACES64
      INTEGER*8 LDA_ARG,N_ARG,IPVT(*),JOB_ARG
#else
      INTEGER LDA_ARG,N_ARG,IPVT(*),JOB_ARG
#endif
      integer n, lda, job
      DOUBLE PRECISION A(LDA_ARG,*),B(*)
C
      DOUBLE PRECISION XDDOT,T
      INTEGER K,KB,L,NM1
C***FIRST EXECUTABLE STATEMENT  DGESL
      n = n_arg
      lda = lda_arg
      job = job_arg

      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE  L*Y = B
C
         IF (NM1 .LT. 1) GO TO 30
         DO 20 K = 1, NM1
            L = IPVT(K)
            T = B(L)
            IF (L .EQ. K) GO TO 10
               B(L) = B(K)
               B(K) = T
   10       CONTINUE
            CALL XDAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20    CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/A(K,K)
            T = -B(K)
            CALL XDAXPY(K-1,T,A(1,K),1,B(1),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            T = XDDOT(K-1,A(1,K),1,B(1),1)
            B(K) = (B(K) - T)/A(K,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (NM1 .LT. 1) GO TO 90
         DO 80 KB = 1, NM1
            K = N - KB
            B(K) = B(K) + XDDOT(N-K,A(K+1,K),1,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
               T = B(L)
               B(L) = B(K)
               B(K) = T
   70       CONTINUE
   80    CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END

c This routine returns the index of the last non-blank character in sz.

#include "iachar.h"

       integer function linblnk(sz)
       implicit none

       character*(*) sz
       character*1 achar, czSpace, czTab, czNULL
       integer i, length

       length = len(sz)
       if (length.ne.0) then

          czSpace = achar(_IACHAR_SPACE)
          czTab   = achar(_IACHAR_TAB)
          czNULL  = achar(0)

          do i = length, 1, -1
c          o return at the first non-blank character
             if ((sz(i:i).ne.czSpace).and.
     &           (sz(i:i).ne.czTab  ).and.
     &           (sz(i:i).ne.czNULL )     ) then
                linblnk = i
                return
             end if
          end do

       end if

       linblnk = 0
       return
       end

C OPENS THE WORD ADDRESSABLE DIRECT ACCESS FILES USED BY CRAPS

      SUBROUTINE OPNFIL(IUNIT)
      CHARACTER*8 NAME(5)
      CHARACTER*80 FNAME
      LOGICAL EXISTS
      COMMON /FILSPC/ IBUFLN,IPRCLN,IPRCWD
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
 
#include "icdacc.com"

      DATA NAME /'MOINTS  ','GAMLAM  ','MOABCD  ','DERINT  ','DERGAM  '/

      CALL GFNAME(NAME(IUNIT),FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=EXISTS)

c YAU - old
c      IF(EXISTS)THEN
c       OPEN(UNIT=IUNIT+49,FILE=FNAME(1:ILENGTH),
c     &      FORM='UNFORMATTED',ACCESS=
c     &      'DIRECT',RECL=idaccr,STATUS= 'OLD')
c      ELSE
c       OPEN(UNIT=IUNIT+49,FILE=FNAME(1:ILENGTH),
c     &      FORM='UNFORMATTED',ACCESS=
c     &      'DIRECT',RECL=idaccr,STATUS='NEW')
c      ENDIF
c YAU - new
      IF (EXISTS) THEN
         OPEN(UNIT=IUNIT+49,FILE=FNAME(1:ILENGTH),
     &        FORM='UNFORMATTED',ACCESS='DIRECT',
     &        RECL=IPRCWD*idaccm,STATUS='OLD')
      ELSE
         OPEN(UNIT=IUNIT+49,FILE=FNAME(1:ILENGTH),
     &        FORM='UNFORMATTED',ACCESS='DIRECT',
     &        RECL=IPRCWD*idaccm,STATUS='NEW')
      END IF
c YAU - end

      RETURN
      END

      function nindex(str,substr,ind)
      implicit none
      integer nindex
      character*(*) str,substr
      integer ind,strlen,slen,sublen,indmax,i,ncindex
      slen=strlen(str)
      sublen=strlen(substr)
      indmax=slen-sublen+1
      if (sublen.gt.slen .or. ind.ge.indmax .or. ind.lt.0) then
         nindex=0
         return
      end if
      i=ind
 10   continue
      nindex=ncindex(str,substr(1:1),i)
      if (nindex.eq.0) return
      if (nindex.gt.indmax) then
         nindex=0
         return
      end if
      if (str(nindex:nindex+sublen-1).eq.substr(1:sublen)) return
      i=nindex
      goto 10
      end

      SUBROUTINE A2BUILD_QUANTITY(WORK, MAXCOR, PRDUTINT, QUANTITY, 
     &                            SPIN_D, DENSITY_TYPE, 
     &                            NMBR_OF_PERTS, IPICK_PERT, NBFNS,
     &                            NAOBFNS, ISCF_TDEN, ICOR_TDEN,  
     &                            ISCF_DDEN, ICOR_DDEN, 
     &                            IBEGIN_P_DENS, MAX_GRID_POINTS, 
     &                            POST_SCF, GRID_TYPE, KCUBE, IUHF)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL SPIN_D, POST_SCF
C
      CHARACTER*7 DENSITY_TYPE
      CHARACTER*2 GRID_TYPE
C
      DIMENSION WORK(MAXCOR), PRDUTINT(NAOBFNS, NAOBFNS),
     &          QUANTITY(0:4, MAX_GRID_POINTS)
      DATA TWO /2.0D0/
C
      IF (DENSITY_TYPE .EQ. "0-ORDER") THEN
         SCF_TOT_DENSITY = DDOT(NAOBFNS*NAOBFNS, PRDUTINT, 1,
     &                          WORK(ISCF_TDEN), 1)
         COR_TOT_DENSITY = DDOT(NAOBFNS*NAOBFNS, PRDUTINT, 1,
     &                         WORK(ICOR_TDEN), 1)
C
         IF (.NOT. SPIN_D) THEN
C
CSSS            DO IND_CUBE = 1, KCUBE
               QUANTITY(0, KCUBE) = SCF_TOT_DENSITY
               IF (POST_SCF)  QUANTITY(1, KCUBE) = 
     &                                COR_TOT_DENSITY
CSSS            END DO
         ENDIF
C
         IF (IUHF .NE. 0 .AND. SPIN_D) THEN
            SCF_DIF_DENSITY = DDOT(NAOBFNS*NAOBFNS, PRDUTINT,
     &                             1, WORK(ISCF_DDEN), 1)
            COR_DIF_DENSITY = DDOT(NAOBFNS*NAOBFNS, PRDUTINT,
     &                             1, WORK(ICOR_DDEN), 1)
C
CSSS            DO IND_CUBE = 1, KCUBE
               QUANTITY(0, KCUBE) = SCF_DIF_DENSITY
               IF (POST_SCF)  QUANTITY(1, KCUBE) = 
     &                                 COR_DIFF_DENSITY
CSSS            END DO
         ENDIF
C
      ELSE IF (DENSITY_TYPE .EQ. "1-ORDER") THEN

          DO IPERT = 1, NMBR_OF_PERTS
             IF (IPERT .EQ. IPICK_PERT) THEN
            
                I_TOT_PDEN_N = IBEGIN_P_DENS + 2*(IPERT-1)*
     &                         NAOBFNS*NAOBFNS
                I_DIF_PDEN_N =  I_TOT_PDEN_N + NAOBFNS*NAOBFNS

                TOT_PDEN_N = DDOT(NAOBFNS*NAOBFNS, PRDUTINT, 1,
     &                            WORK(I_TOT_PDEN_N), 1)
                DIF_PDEN_N = DDOT(NAOBFNS*NAOBFNS, PRDUTINT, 1,
     &                            WORK(I_DIF_PDEN_N), 1)
C
CSSS                DO IND_CUBE = 1, KCUBE
                   QUANTITY(0, KCUBE) = TOT_PDEN_N*TWO
                   QUANTITY(1, KCUBE) = DIF_PDEN_N*TWO
CSSS                END DO
C
             END IF
          END DO
c
      ELSE IF (DENSITY_TYPE .EQ. "DEFINED") THEN

         OPEN (UNIT=30, FILE='VPOUT', FORM='UNFORMATTED', 
     &         STATUS='OLD')
         IRWND = 0
         IERR  = 0
         IOFF  = 1
C
         DO IPERT = 1, NMBR_OF_PERTS

            CALL SEEKLB ('   DEN  ', IERR, IRWND, 30)
            IF (IERR .NE. 0) CALL ERREX
C
            CALL LOAD_DEFINED(WORK(IOFF), NAOBFNS*NAOBFNS, NAOBFNS)
C
C#ifdef _DEBUG_LVLM2
            CALL HEADER ('Matrix elements of the defined operator', 1
     &                   , 6)
            CALL OUTPUT(WORK(IOFF), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &                  NAOBFNS, 1)
C#endif 
            IRWND = 1
            IOFF  = IOFF + NAOBFNS*NAOBFNS
            
         END DO
C
         DO IPERT = 1, NMBR_OF_PERTS
             IF (IPERT .EQ. IPICK_PERT) THEN

                I_TOT_PDEN_N = IBEGIN_P_DENS + (IPERT-1)*
     &                         NAOBFNS*NAOBFNS

                TOT_PDEN_N = DDOT(NAOBFNS*NAOBFNS, PRDUTINT, 1,
     &                            WORK(I_TOT_PDEN_N), 1)
C
CSSS                DO IND_CUBE = 1, KCUBE
                   QUANTITY(0, KCUBE) = TOT_PDEN_N*TWO
CSSS                END DO
C
             END IF
          END DO
c
      Print*, "Quantity of interest (perturbed total and/or spin",
     &        " density)"
      Write(6,*), KCUBE
CSS      Do IND_CUBE =1, KCUBE
      Write(*,'((1x,2F10.6))') QUANTITY(0,KCUBE),
     &                         QUANTITY(1,KCUBE)
CSSS      Enddo
      ENDIF
C
      RETURN
      END 
C  

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__CALC_INTERACTION_ORDER
     +
     +                    ( DDROWC,DDCOLC,
     +                      DDROWP,DDCOLP,
     +                      DDVECD,
     +                      DDVECX,DDVECY,
     +                      N,
     +                      I,
     +                      C,P,D,
     +                      X,Y,
     +
     +                              ORDER )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__CALC_INTERACTION_ORDER
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine calculates the occupation interaction
C                order of the I-th natural orbital D. The occupation
C                interaction order is defined as follows:
C
C                The N x N occupation matrix P is idempotent:
C
C                                 P = P * P
C
C                For any diagonal element in P we have thus:
C
C                                                N
C                    P (I,I) - P (I,I)**2  =    sum   P (I,K)**2
C                                             i neq k
C
C                The square root of the right sum constitutes the
C                occupation interaction order of the I-th natural
C                orbital. If the individual P (I,K) are accurate
C                to +- E, where E is the accuracy threshold, then
C                we have:
C
C
C                     ---------------------------
C                    /   N
C                   /   sum   [P (I,K) +- E ]**2
C                 \/  i neq k
C
C
C                              -------------------
C                             /   N
C                      =     /   sum   P (I,K)**2
C                          \/  i neq k
C
C
C                                       N
C                                      sum   P (I,K)
C                                    i neq k                         2
C                      +- E   ------------------------------  + O [E]
C                                   -------------------
C                                  /   N
C                                 /   sum   P (I,K)**2
C                               \/  i neq k
C
C
C                showing that the occupation interaction order is
C                also roughly accurate to within +- E.
C
C
C
C                  Input:
C
C                    DDROWC,DDCOLC  =  declared dimensions of natural
C                                      orbital coefficient matrix C
C                    DDROWP,DDCOLP  =  declared dimensions of occupation
C                                      matrix P
C                    DDVECD         =  declared dimensions of natural
C                                      orbital D coefficient vector
C                    DDVECX,DDVECY  =  declared dimensions of scratch
C                                      vectors X and Y
C                    N              =  order of occupation matrix P
C                    I              =  index label of natural orbital D
C                                      (this is necessary to remove the
C                                      I-th contribution to the sum)
C                    C              =  N x N natural orbital coefficient
C                                      matrix in AO basis
C                    P              =  N x N occupation matrix in AO
C                                      basis
C                    D              =  natural orbital coefficient
C                                      vector in AO basis
C                    X,Y            =  flp scratch vectors
C
C
C                  Output:
C
C                    ORDER          =  occupation interaction order
C                                      for I-th natural orbital D
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     SAVEC,SAVED,SAVEP

         INTEGER     DDROWC,DDCOLC
         INTEGER     DDROWP,DDCOLP
         INTEGER     DDVECD,DDVECX,DDVECY
         INTEGER     I,J,N

         DOUBLE PRECISION  ORDER
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  D     (1:DDVECD)
         DOUBLE PRECISION  X     (1:DDVECX)
         DOUBLE PRECISION  Y     (1:DDVECY)

         DOUBLE PRECISION  C     (1:DDROWC,1:DDCOLC)
         DOUBLE PRECISION  P     (1:DDROWP,1:DDCOLP)

         PARAMETER   (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF (N.GT.DDROWC .OR. N.GT.DDCOLC) THEN
             WRITE (*,*) ' Dimensions of matrix C too small! '
             WRITE (*,*) ' nlo__calc_interaction_order '
             WRITE (*,*) ' DDROWC,DDCOLC,N = ',DDROWC,DDCOLC,N
             WRITE (1,*) ' Dimensions of matrix C too small! '
             WRITE (1,*) ' nlo__calc_interaction_order '
             WRITE (1,*) ' DDROWC,DDCOLC,N = ',DDROWC,DDCOLC,N
             STOP
         END IF

         IF (N.GT.DDROWP .OR. N.GT.DDCOLP) THEN
             WRITE (*,*) ' Dimensions of matrix P too small! '
             WRITE (*,*) ' nlo__calc_interaction_order '
             WRITE (*,*) ' DDROWP,DDCOLP,N = ',DDROWP,DDCOLP,N
             WRITE (1,*) ' Dimensions of matrix P too small! '
             WRITE (1,*) ' nlo__calc_interaction_order '
             WRITE (1,*) ' DDROWP,DDCOLP,N = ',DDROWP,DDCOLP,N
             STOP
         END IF

         IF (N.GT.DDVECD) THEN
             WRITE (*,*) ' Dimension of vector D too small! '
             WRITE (*,*) ' nlo__calc_interaction_order '
             WRITE (*,*) ' DDVECD,N = ',DDVECD,N
             WRITE (1,*) ' Dimension of vector D too small! '
             WRITE (1,*) ' nlo__calc_interaction_order '
             WRITE (1,*) ' DDVECD,N = ',DDVECD,N
             STOP
         END IF

         IF (N.GT.DDVECX .OR. N.GT.DDVECY) THEN
             WRITE (*,*) ' Dimensions of vectors X,Y too small! '
             WRITE (*,*) ' nlo__calc_interaction_order '
             WRITE (*,*) ' DDVECX,DDVECY,N = ',DDVECX,DDVECY,N
             WRITE (1,*) ' Dimensions of vectors X,Y too small! '
             WRITE (1,*) ' nlo__calc_interaction_order '
             WRITE (1,*) ' DDVECX,DDVECY,N = ',DDVECX,DDVECY,N
             STOP
         END IF
C
C
C             ...form the I-th column of the occupation matrix
C                corresponding to the natural orbital D.
C
C
         SAVEC = .TRUE.
         SAVEP = .TRUE.
         SAVED = .TRUE.

         CALL  MAT__C_EQ_ORTHOTRAN_OFFDIAG
     +
     +              ( DDROWC,DDCOLC,
     +                DDROWP,DDCOLP,
     +                DDVECD,1,
     +                DDVECY,1,
     +                DDVECX,
     +                N,N,1,
     +                0,0,
     +                SAVEC,SAVEP,SAVED,
     +                C,P,D,
     +                X,
     +
     +                         Y )
     +
     +
C
C
C             ...calculate the interaction order.
C
C
         Y (I) = ZERO

         ORDER = ZERO
         DO J = 1,N
            ORDER = ORDER + Y (J) ** 2
         END DO

         ORDER = DSQRT (ORDER)
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_1D_INTEGRALS
     +
     +                    ( SHELLP,SHELLB,
     +                      ATOMIC,
     +                      NEXP,
     +                      PAX,PAY,PAZ,
     +                      PINVHF,
     +                      ABX,ABY,ABZ,
     +
     +                               INT1DX,
     +                               INT1DY,
     +                               INT1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_1D_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 1-dimensional
C                overlap integrals of x,y and z type using the Rys
C                vertical recurrence scheme RI explained below.
C
C                The vertical recurrence scheme RI is due to Rys, Dupuis
C                and King, J. Comp. Chem. 4, p.154-157 (1983).
C
C
C                   INT1D (0,0) = 1.D0
C                   INT1D (1,0) = PA
C
C                   For I = 1,...,SHELLP-1
C                       INT1D (I+1,0) = I * (1/2P) * INT1D (I-1,0)
C                                             + PA * INT1D (I,0)
C
C
C                If SHELLB is > 0, then the horizontal transfer scheme
C                HI is also applied:
C
C                   For J = 1,...,SHELLB
C                   For I = 0,...,SHELLP-J
C                       INT1D (I,J) =       INT1D (I+1,J-1)
C                                    + AB * INT1D (I,J-1)
C
C                If the HI is not needed, the values in ABX,ABY and ABZ
C                have no meaning and can be set as wished.
C
C                The 1D integrals are calculated for all exponent pairs
C                simultaneously and placed into a 3-dimensional array
C                with the exponent pair index varying fastest.
C
C                              !!!IMPORTANT!!!
C
C                In case the 1D integrals are needed for an atom, all
C                even-odd and odd-even shell combinations lead to 1D
C                integrals whose value is zero. However, the routine
C                does not place explicit zeros in the corresponding
C                1D integral array places, as these will never be
C                addressed by subsequent routines.
C
C
C                  Input:
C
C                    SHELLx       =  the shell types for shells
C                                    x=P=A+B and x=B
C                    ATOMIC       =  indicates, if purely atomic 1D
C                                    integrals will be evaluated
C                    NEXP         =  # of exponent pairs
C                    PAx          =  current NEXP coordinate x=X,Y,Z
C                                    differences P-A between centers
C                                    P and A
C                    PINVHF       =  current NEXP values of 1/(2*P),
C                                    where P are the exponent sums
C                                    for contraction shells A and B
C                    ABx          =  coordinate x=X,Y,Z differences
C                                    A-B between centers A and B
C
C                  Output:
C
C                    INT1Dx       =  all 1D overlap integrals for each
C                                    cartesian component x = X,Y,Z
C                                    for the current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         LOGICAL    ATOMIC

         INTEGER    I,J,N
         INTEGER    I1,I2,J1
         INTEGER    IEND,JEND
         INTEGER    NEXP
         INTEGER    SHELLP,SHELLB

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  F
         DOUBLE PRECISION  ONE,TWO
         DOUBLE PRECISION  P1

         DOUBLE PRECISION  PAX    (1:NEXP)
         DOUBLE PRECISION  PAY    (1:NEXP)
         DOUBLE PRECISION  PAZ    (1:NEXP)
         DOUBLE PRECISION  PINVHF (1:NEXP)

         DOUBLE PRECISION  INT1DX (1:NEXP,0:SHELLP,0:SHELLB)
         DOUBLE PRECISION  INT1DY (1:NEXP,0:SHELLP,0:SHELLB)
         DOUBLE PRECISION  INT1DZ (1:NEXP,0:SHELLP,0:SHELLB)

         PARAMETER  (ONE   =  1.D0)
         PARAMETER  (TWO   =  2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...initialize 1D overlap integrals.
C
C
         DO 100 N = 1,NEXP
            INT1DX (N,0,0) = ONE
            INT1DY (N,0,0) = ONE
            INT1DZ (N,0,0) = ONE
  100    CONTINUE

         IF (SHELLP.EQ.0) RETURN
C
C
C             ...proceed, if total shell is > s-shell.
C                The atomic case first. Note, that only even-even
C                and odd-odd shell combinations contribute to the
C                1D integrals, the even-odd and odd-even ones being
C                equal to 0.
C
C
         IF (ATOMIC) THEN

             IF (SHELLP.GT.1) THEN
                 F = ONE
                 DO 200 I = 2,SHELLP,2
                    I2 = I - 2
                    DO 210 N = 1,NEXP
                       P1 = F * PINVHF (N)
                       INT1DX (N,I,0) = P1 * INT1DX (N,I2,0)
                       INT1DY (N,I,0) = P1 * INT1DY (N,I2,0)
                       INT1DZ (N,I,0) = P1 * INT1DZ (N,I2,0)
  210               CONTINUE
                    F = F + TWO
  200            CONTINUE
             END IF

             IF (SHELLB.GT.0) THEN

                 JEND = SHELLB - 1
                 DO 220 J = 1,JEND,2
                    J1 = J - 1
                    IEND = SHELLP - J
                    DO 230 I = 1,IEND,2
                       I1 = I + 1
                       DO 240 N = 1,NEXP
                          INT1DX (N,I,J) = INT1DX (N,I1,J1)
                          INT1DY (N,I,J) = INT1DY (N,I1,J1)
                          INT1DZ (N,I,J) = INT1DZ (N,I1,J1)
  240                  CONTINUE
  230               CONTINUE
                    J1 = J + 1
                    DO 250 I = 0,IEND,2
                       I1 = I + 1
                       DO 260 N = 1,NEXP
                          INT1DX (N,I,J1) = INT1DX (N,I1,J)
                          INT1DY (N,I,J1) = INT1DY (N,I1,J)
                          INT1DZ (N,I,J1) = INT1DZ (N,I1,J)
  260                  CONTINUE
  250               CONTINUE
  220            CONTINUE

                 IF (MOD (SHELLB,2).NE.0) THEN
                     J = SHELLB
                     J1 = J - 1
                     IEND = SHELLP - J
                     DO 270 I = 1,IEND,2
                        I1 = I + 1
                        DO 280 N = 1,NEXP
                           INT1DX (N,I,J) = INT1DX (N,I1,J1)
                           INT1DY (N,I,J) = INT1DY (N,I1,J1)
                           INT1DZ (N,I,J) = INT1DZ (N,I1,J1)
  280                   CONTINUE
  270                CONTINUE
                 END IF

             END IF

         ELSE
C
C
C             ...the general non-atomic case.
C
C
             DO 300 N = 1,NEXP
                INT1DX (N,1,0) = PAX (N)
                INT1DY (N,1,0) = PAY (N)
                INT1DZ (N,1,0) = PAZ (N)
  300        CONTINUE

             F = ONE
             DO 310 I = 2,SHELLP
                I1 = I - 1
                I2 = I - 2
                DO 320 N = 1,NEXP
                   P1 = F * PINVHF (N)
                   INT1DX (N,I,0) =        P1 * INT1DX (N,I2,0)
     +                              + PAX (N) * INT1DX (N,I1,0)
                   INT1DY (N,I,0) =        P1 * INT1DY (N,I2,0)
     +                              + PAY (N) * INT1DY (N,I1,0)
                   INT1DZ (N,I,0) =        P1 * INT1DZ (N,I2,0)
     +                              + PAZ (N) * INT1DZ (N,I1,0)
  320           CONTINUE
                F = F + ONE
  310        CONTINUE

             IF (SHELLB.GT.0) THEN

                 DO 330 J = 1,SHELLB
                    J1 = J - 1
                    IEND = SHELLP-J
                    DO 340 I = 0,IEND
                       I1 = I + 1
                       DO 350 N = 1,NEXP
                          INT1DX (N,I,J) =  ABX * INT1DX (N,I,J1)
     +                                          + INT1DX (N,I1,J1)
                          INT1DY (N,I,J) =  ABY * INT1DY (N,I,J1)
     +                                          + INT1DY (N,I1,J1)
                          INT1DZ (N,I,J) =  ABZ * INT1DZ (N,I,J1)
     +                                          + INT1DZ (N,I1,J1)
  350                  CONTINUE
  340               CONTINUE
  330            CONTINUE

             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      function strlen(str)
      implicit none
      integer strlen
      character*(*) str
      character*1 spc,tab,zero
      integer i
      i=len(str)
      spc=achar(32)
      tab=achar(9)
      zero=achar(0)
      do while (i.gt.0 .and.
     &          (str(i:i).eq.spc .or.
     &           str(i:i).eq.tab .or.
     &           str(i:i).eq.zero)
     &         )
         i=i-1
      end do
      strlen=i
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE COMVEC(NDEG,TYPE,ORDER,COUNT,AXIS,NATMS,Q,SCRATCH,
     &NORD,V,CHAR)
C
C SUBROUTINE PERFORMS A GIVEN SYMMETRY OPERATION ON COORDINATES AND
C  AN INPUT VECTOR (V), SHUFFLES THE TRANSFORMED VECTOR AND RETURNS 
C  OVERLAP OF TRANSFORMED V WITH ORIGINAL V.  USED TO COMPUTE CHARACTERS
C  OF SYMMETRY OPERATIONS.  FOR N-FOLD DEGENERACIES, V WILL BE N TIMES
C  AS LONG AS Q.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
#include "mxatms.par"
      DIMENSION V(NDEG*3*NATMS),SCRATCH(9*NATMS)
      DIMENSION NORD(2*MXATMS),Q(3*NATMS)
      CHARACTER*1 TYPE
      INTEGER ORDER,COUNT,AXIS,ERR
      IX1=3*NATMS+1
      IX2=3*NATMS+IX1
      IJ1=NATMS+1
      IJ2=IJ1+NATMS
      CHAR=0.D0
C
C ZERO OUT SCRATCH VECTOR
C

      CALL ZERO(SCRATCH,9*NATMS)
C
C PERFORM PARTICULAR SYMMETRY OPERATION ON COORINATES AND GENERATE
C   "STANDARD" LIST OF CENTERS WITH SORTXYZ.
C
      CALL DOSYOP(TYPE,ORDER,COUNT,AXIS,NATMS,Q,SCRATCH,ERR,0)
      CALL SORTXYZ(SCRATCH(1),SCRATCH(IX1),NORD(IJ1),NATMS)
C
C NOW DO SAME OPERATION TO V INPUT VECTOR AND THEN SWAP ATOM
C  ORDERING TO COMPARE WITH OLD (UNTRANSFORMED) V.
C    
C LOOP OVER LEVEL OF DEGENERACY AND COMPUTE CHARACTER.
C
      DO 10 I=0,NDEG-1
      IBOT=1+3*I*NATMS
      CALL DOSYOP(TYPE,ORDER,COUNT,AXIS,NATMS,V(IBOT),
     &SCRATCH(IX2),ERR,0)
      CALL SWPORD(NORD(1),NORD(IJ1),SCRATCH(IX2),SCRATCH(IX1),NATMS)
      CHAR=xdot(3*NATMS,SCRATCH(IX1),1,V(IBOT),1)+CHAR
 10   CONTINUE
      RETURN
      END

         SUBROUTINE  FRAG__INIT
     +
     +                   (NATOMS,
     +                    CONNECT,
     +                    IPRINT,IERR,
     +                    INITFRAG,
     +
     +                                 NFRAG,
     +                                 FRAGLEN,
     +                                 FRAGMAT  )
     +
     +             
C------------------------------------------------------------------------
C  OPERATION   : FRAG__INIT
C  MODULE      : FRAGMENT DETERMINE
C  MODULE-ID   : FRAG
C  SUBROUTINES : FRAG__WORK
C                                    
C  DESCRIPTION : Main program that drives the fragmentation pattern.
C
C                  Input:
C
C                    IPRINT       =  level of printing variable
C                    IERR         =  sets the return error
C                    NATOMS       =  total number of atoms
C                    CONNECT      =  connectivity array
C                                    fragmentation pattern
C                    INITFRAG     =  scratch space for routine
C
C                  Output:
C
C                    NFRAG        =  total number of fragments
C                    FRAGLEN      =  contains the length of the
C                                    fragments in FRAGMAT
C                    FRAGMAT      =  contains the fragments
C
C  
C  AUTHOR      : Thomas Watson Jr.
C------------------------------------------------------------------------
C
C
C             ...Declare variables and include files!
C
C
         IMPLICIT    NONE

         INTEGER    I,J,ZERO
         INTEGER    IPRINT,IERR
         INTEGER    NATOMS,NFRAG

         INTEGER    FRAGLEN  (1:NATOMS)

         INTEGER    CONNECT  (1:NATOMS,1:NATOMS)
         INTEGER    FRAGMAT  (1:NATOMS,1:NATOMS)
         INTEGER    INITFRAG (1:NATOMS,1:NATOMS)

         PARAMETER  (ZERO = 0)
C
C
C------------------------------------------------------------------------
C
C
C             ...Return if 1 atom, analyze otherwise!
C
C
         IF (NATOMS .LE. 1) THEN
            NFRAG   = 1
            FRAGLEN ( 1 ) = 1
            FRAGMAT (1,1) = 1
            RETURN
         ENDIF
C
C
C          ...Zero out the necessary arrays!
C
C
         DO I = 1, NATOMS
            FRAGLEN (I) = ZERO
            DO J = 1, NATOMS
               INITFRAG (I,J) = ZERO
               FRAGMAT  (I,J) = ZERO
            ENDDO
         ENDDO
C
C
C          ...Figure out the fragmentation pattern!
C
C
         CALL  FRAG__WORK
     +
     +              (NATOMS,
     +               CONNECT,
     +               IPRINT,IERR,
     +               INITFRAG,
     +
     +                          NFRAG,
     +                          FRAGLEN,
     +                          FRAGMAT  )
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c----------------------------------------------------------------------
c
c   pst_get_master: Retrieve the master task from the pst.
c
c----------------------------------------------------------------------

      integer function pst_get_master()

      implicit none

      include 'mpif.h'
      include 'pst.h'
      include 'proto_defines.h'
      integer i, j, nprocs, me, ierr

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      do i = 1, nprocs
         if (pst(i, r_role) .eq. master_status .or.
     *       pst(i, r_role) .eq. master_worker_status) then
            pst_get_master = i - 1
            return
         endif
      enddo

      print *,'ERROR: pst_get_master cannot find the master.'
      call mpi_comm_rank(mpi_comm_world, me, ierr)
      print *,'Dump of pst on process ',me,':'
      do i = 1, nprocs
         print *,'Row ',i,' on proc ',me,' ',(pst(i,j),j=1,r_last)
      enddo 
      call mpi_abort(mpi_comm_world, 1, ierr)
      pst_get_master = -1   ! avoids HP compiler warning
      return
      end

c----------------------------------------------------------------------
c
c   pst_get_role: Retrieve the role of task "me" from the pst.
c
c----------------------------------------------------------------------

      integer function pst_get_role(me)

      implicit none
 
      include 'mpif.h'
      include 'pst.h'
      integer me, nprocs, ierr

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      if (me .ge. nprocs) then
         print *,'pst_get_role: Invalid task id: ',me
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif
      
      pst_get_role = pst(me+1, r_role)
      return
      end

c---------------------------------------------------------------------------
c   pst_get_company: Returns the company id associated with a specified
c                task.
c---------------------------------------------------------------------------

      integer function pst_get_company(iproc)
      implicit none
      include 'pst.h'
      include 'mpif.h'
      integer iproc, nprocs, ierr

      call mpi_comm_size(mpi_comm_world, nprocs, ierr) 
      if (iproc .ge. 0 .and. iproc .lt. nprocs) then
         pst_get_company = pst(iproc+1, r_company_id)
      else
         print *,'pst_get_company: Invalid processor rank = ',iproc
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif
      return
      end

c---------------------------------------------------------------------------
c   pst_get_my_company: Returns the company id associated with the running 
c                process.
c---------------------------------------------------------------------------

      integer function pst_get_my_company()
      implicit none
      include 'pst.h'
      include 'mpif.h'
      integer me, ierr

      call mpi_comm_rank(mpi_comm_world, me, ierr) 
      pst_get_my_company = pst(me+1, r_company_id)
      return
      end

c---------------------------------------------------------------------------
c   pst_get_company_comm: Returns the communicator associated with a 
c                given task's company.
c---------------------------------------------------------------------------

      integer function pst_get_company_comm(iproc)
      implicit none
      include 'pst.h'
      include 'mpif.h'
      integer iproc, nprocs, ierr

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      if (iproc .ge. 0 .and. iproc .lt. nprocs) then
         pst_get_company_comm = pst(iproc+1, r_company_comm)
      else
         print *,'pst_get_company_comm: Invalid processor rank = ',
     *            iproc
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif
      return
      end

c---------------------------------------------------------------------------
c   pst_get_company_rank: Returns the rank relative to the task's company
c                         communicator.
c---------------------------------------------------------------------------

      integer function pst_get_company_rank(iproc)
      implicit none
      include 'pst.h'
      include 'mpif.h'
      integer iproc, nprocs, ierr

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      if (iproc .ge. 0 .and. iproc .lt. nprocs) then
         pst_get_company_rank = pst(iproc+1, r_company_rank)
      else
         print *,'pst_get_company_rank: Invalid processor rank = ',
     *            iproc
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      Subroutine Angs2bohr(R, NX)
C 
      Implicit Double Precision (A-H, O-Z)
      Dimension R(NX)
C
      ATOR = DACOS(-1.0D0)/180.0D0
      ATOB = 0.529177249D0
c
      Do IDeg = 8, NX-1, 3
         If (Ideg .NE. 8) R(Ideg + 1) = R(Ideg + 1)*ATOR
                          R(ideg) = R(Ideg)*ATOR
      Enddo

      Do IDeg = 4, NX-2, 3
         R(Ideg) =  R(Ideg)/ATOB
      Enddo

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
        SUBROUTINE PIKSR3(N,ARR,NLIST)
C
C SIMPLE SORTER FROM NUMERICAL RECIPES.
C
CEND
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION ARR(N),NLIST(N)
        DO 12 J=2,N
        A=ARR(J)
        NLST=NLIST(J)
        DO 11 I=J-1,1,-1
         IF(ARR(I).GE.A)GOTO 10
         ARR(I+1)=ARR(I)
         NLIST(I+1)=NLIST(I)
   11   CONTINUE
        I=0
   10   ARR(I+1)=A
        NLIST(I+1)=NLST
   12   CONTINUE
        RETURN
        END

      SUBROUTINE TRANS_SPH2CART(DMAT_IN_OUT, TRANSFRM, TMP, NBAS, NBASP)
C
C This little subroutine makes a in-place transforamtion of a 
C matrix in spherical harmonic basis to a Cartesian basis. 
C
C   DMAT_IN_OUT : Matrix that need to be transformed. Note that the 
C                transformed matrix is also returned in MAT_IN_OUT
C   
C   TRANSFRM    : The transformation matrix is passed in as a input
C                argument
C
C   TMP         : A scratch array to keep the intermediates
C
C  NBASP, NBAS  : Spherical and Cartesian dimensions NBAS > NBASP
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      
      DIMENSION DMAT_IN_OUT(NBASP*NBASP), TRANSFRM(NBAS*NBASP),
     &          TMP(NBAS*NBAS)
      
      DATA ONE, ZLICH /1.0D00, 0.0D00/
C 
      CALL XGEMM('N', 'N', NBAS, NBASP, NBASP, ONE, TRANSFRM, NBAS, 
     &            DMAT_IN_OUT, NBASP, ZLICH, TMP, NBAS)
      
      CALL XGEMM('N', 'T', NBAS, NBAS, NBASP, ONE, TMP, NBAS,
     &           TRANSFRM, NBAS, ZLICH, DMAT_IN_OUT, NBAS)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine qsdline(scratch, ehess, eigvh, dmr1, dmr2, unew,
     &                   u_upper, u_lower, hvalue, curvtre, ndim, nx,
     &                   update, nwtonrpson, negeval, genstpsz)
c
c this routine calculate quadaratic steepest descent line (eqn. 11
c sun & rudernberg jcp, 99, 5258, 1993.
c
      implicit double precision (a-h, o-z)
      logical update, nwtonrpson, negeval, genstpsz
c
      dimension scratch(nx*nx), eigvh(ndim, ndim), dmr1(ndim, ndim),
     &          dmr2(ndim, ndim), ehess(ndim, ndim)
c
      call xgemm('t','n', ndim, 1, ndim, 1.0d0, eigvh, ndim,
     &            scratch(1 + ndim), ndim, 0.0d0,
     &            scratch(1 + 2*ndim), ndim)
c
      if (genstpsz) then
         call curve(scratch, ehess, curvtre, ndim, nx)
         return
      endif

      if (negeval) then
         u_lower =  dexp(-dlog(1.0d0 + 2.0d0*hvalue/
     &              dabs(scratch(1 + 2*ndim)))/dabs(ehess(1, 1)))
         unew = u_lower
      endif
c
      do 10 i = 1, ndim
         dmr1(i, i) = unew**ehess(i, i)
 10   continue
c
      do 80 i = 1, ndim
         scratch(i + 3*ndim) = dmr1(i, i)*scratch(i + 2*ndim)
  80   continue
c
       if (negeval) then
          call xdcopy(ndim,scratch(1 + 3*ndim),1,scratch(1 + 4*ndim),
     &               1)
          return
       endif
c
c Let's first check the search can be reduced to the Newton-Rapshon search
c
      dtmp = xdot(ndim,scratch(1 + 2*ndim),1,scratch(1 + 2*ndim),1)
      threshld = dsqrt(dtmp)

      If (threshld .lt. hvalue) then
         write(6, *) "  QSD search reduce to Newton-Raphson update"
         call vminus(scratch(1+ ndim), ndim)
         nwtonrpson = .true.
         return
      endif

      if (.not. update) then
c
         call vadd(scratch(1 + 3*ndim), scratch(1 + 3*ndim),
     &             scratch(1 + 2*ndim), ndim, -1.0d0)

         dtmp = xdot(ndim,scratch(1 + 3*ndim),1,scratch(1 + 3*ndim),1)
         xupqr = dsqrt(dtmp)
c
         if (xupqr .gt. hvalue) then
            u_lower = unew
            call xdcopy(ndim,scratch(1 + 3*ndim),1,scratch(1 + 4*ndim),
     &                 1)
         else
            u_upper = unew
            call xdcopy(ndim,scratch(1 + 3*ndim),1,scratch(1 + 5*ndim),
     &                 1)
         endif
c
      else
c
         call xgemm('n','n', ndim, 1, ndim, 1.0d0, eigvh, ndim,
     &               scratch(1 + 3*ndim), ndim, 0.d0,
     &               scratch(1 + 2*ndim), ndim)
c
         call vadd(scratch(1 + 3*ndim), scratch(1 + 2*ndim),
     &             scratch(1 + ndim), ndim, -1.0d0)

         call xdcopy(ndim, scratch(1 + 3*ndim), 1, scratch(1 + ndim), 1)

      endif
c
      return
      end

      SUBROUTINE TENER(NLIST,ET2,EAA,NUMSYT,DISSYT,T2,W,T1A,
     &                 T1B,ISPIN,TAU,IRREP,POP1,POP2,VRT1,
     &                 VRT2,TMP)
C
C THIS ROUTINE CALCULATES THE CORRELATION ENERGY FOR A GIVEN
C SET OF AMPLITUDES (ALWAYS CALLED FOM CMPENG) FOR ONE
C SPECIFIC SPIN CASE
C
C    NLIST ..... OFFSET OF THE T2 LIST    
C    ET2 ....... CORRELATION ENERGY CALCULATED FROM T2 ONLY
C    EAA ....... CORRELATION ENERGY CALCULATED FROM TAU
C    NUMSYT .... NUMBER OF DISTRUBUTION IN T2 LIST
C    DISSYT .... DISTRIBUTION SIZE OF T2 LIST
C    T2 ........ HOLDS T2 AMPLITUDES
C    W ......... HOLDS INTEGRALS <AB//IJ>
C    T1A ....... HOLDS T1 AMPLITUDES (ALPHA)
C    T1B ....... HOLDS T1 AMPLITUDES (BETA)
C       FOR ISPIN=1,2 BOTH T1 ARRAYS ARE IDENTICAL
C    ISPIN ..... SPIN CASE
C    TAU ....... LOGICAl FLAG WHICH TELLS IF TAU AMPLITUDES ARE REQUIRED 
C    IRREP ..... IRREP OF T2 LIST
C    POP1 ...... POPULATION VECTOR OF I (OCCUPIED ORBITALS)
C    POP2 ...... POPULATIOn VECTOR OF J (OCCUPIED ORBITALS)
C    VRT1 ...... POPULATION VECTOR OF A (VIRTUAL ORBITALS)
C    TMP ....... SCRATCH ARRAY
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL TAU
      INTEGER DISSYT,POP1,POP2,VRT1,VRT2,DIRPRD
      DIMENSION T1A(1),T1B(1),POP1(8),POP2(8),VRT1(8),VRT2(8)
      DIMENSION T2(DISSYT,NUMSYT),W(DISSYT,NUMSYT),TMP(1),
     &          NUMIRT(1),IBUFT(1)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      DATA AZERO,ONE /0.0D0,1.0D0/
      CALL GETLST(W, 1,NUMSYT,2,IRREP,13+ISPIN)
      CALL GETLST(T2,1,NUMSYT,1,IRREP,ISPIN+NLIST)
      ET2=DDOT(NUMSYT*DISSYT,T2,1,W,1)
      IF(TAU) THEN
       CALL FTAU(T2,T1A,T1B,DISSYT,NUMSYT,POP1,POP2,VRT1,VRT2,
     &           IRREP,ISPIN,ONE)
      ENDIF
      EAA=DDOT(NUMSYT*DISSYT,T2,1,W,1)
      RETURN
      END

      Subroutine Radint_recur(Nlq, Ltot, Qnl)
  
      Implicit Double Precision (A-H, O-Z)
C
#include "ecp.par" 
#include "ecp.com" 
C
      Dimension Qnl(0:2*Maxang, 0:2*Maxang)
      Logical Eve, Odd
      Data A0, Ahalf, A1, A2, A3 /0.0d0, 0.5d0, 1.0d0, 2.0d0, 3.0d0/

#ifdef _DEBUG_LVL0 
      write(6,*) "@-Radint_recur the Qstore common block values"
      Write(6,"(a,3(1x,F18.13),2(1x,i2))")"Alpha,Beta,Xval,Nlq,Ltot: ", 
     &                      Alpha,Beta,Xval, Nlq, Ltot
      Write(6,*) 
#endif
C
      Odd = ((Mod(Nlq,2)+1) .EQ. 2)
      Eve = ((Mod(Nlq,2)+1) .EQ. 1)

C
      Talpha = 2.0D0*Alpha
C
C Compute the radial integral, Int {0,inf} exp(-alpha r^n) M_l(beta r)
C employing recursion relations given in Mcmurchie and Davidson,
c Journal of Computational Physics, 44, 289 (1981).
C
      If (Beta .Eq. 0.0D0) then

C Using standard integral for Bessel functions, Page 302, Text book
C of Mathematical functions (Abramowitz and Stegun, Eds. 1964, US
C BUreau of Standards).

         If (Odd) Then

            If (Ltot .LE. 1) Then

                If (Nlq .EQ. 1) Then

                    Qnl(0,0) = Ahalf*(A1/Alpha)

                Else

                    Qnl(0,0) =  Ahalf*(A1/Alpha)
                       Term1 = (A1/Alpha)
                    
                    Do NN = 2, Nlq, 2
                        
                        Qnl(0,0) = Qnl(0,0)*Term1
                           Term1 = Term1 + (A1/Alpha)
                    
                    Enddo
                
                Endif
            
            Else
                
                Do L = 0, Ltot, 2
                   
                   NN = (Nlq + L)/2
                   Qnl(L,0) = Fact(NN)/(A2*(Alpha**(NN+1)))
                
                Enddo
            
            Endif
         
         Else
             
             If (Ltot .LE. 1) Then
                    
                 If (Nlq .EQ.0) Then
                    
                    Qnl(0,0) =  Ahalf*Dsqrt(Pi/Alpha)
                 
                 Else
                     
                     Qnl(0,0) =  Ahalf*Dsqrt(Pi/Alpha)
                        Term1 = Ahalf*(A1/Alpha)

                     Do NN = 2, Nlq, 2

                        Qnl(0,0) = Qnl(0,0)*Term1
                           Term1 = Term1 + (A1/Alpha)

                     Enddo

                 Endif

             Else

                 Do L = 0, Ltot, 2

                    NN = (Nlq + L)/2
                    Qnl(L,0) = Faco(NN)/((A2**(NN+1))*(Alpha**NN))*
     &                        (Dsqrt(Pi/Alpha)) 

                 Enddo

             Endif

         Endif

      Else

         If (Ltot .LE. 1) Then
            Do L = 0, Ltot
               Do N = 0, L
C
C Only (N-L) positive and even is needed.
C
                   If ((N-L) .GE. 0) Qnl(N,L) = Qcomp(N+Nlq, L)

               Enddo
            Enddo
         Endif

         If (Ltot .LE. 1) Return
C
         If (Nlq .GT. 0) Then

            If (Eve) Then

C Npl > 0 and even
C
C N = 0+2
               Qnl(0,0) = Qcomp(2, 0)

               Do LL = 0, Ltot-1
C N = LL+3-2
                  N = LL+1
                  L = LL+1
                  Qnl(N,L) = Beta*(Qnl(N-1,L-1))/Talpha

               Enddo

               If ((Nlq-2) .EQ. 0) Then
C
C Use recursion 38D of Davidson paper.
C
                   Lmax = Ltot
                   Do NN = 0, Ltot-2, 2

                      Lmax = Lmax - 2
                      Do L= 0, Lmax

C NLM = N+2-1; N=0+2, 0+4,...

                         N = L + 2 + NN
                         NLM = N + L + 1
#ifdef _DEBUG_LVLM1
                         Write(6,*) "N and L", N, L , NLM, Qnl(N-2,L),
     &                               Qnl(N-1,L+1)
#endif
                         Qnl(N,L) = ((NLM)*Qnl(N-2,L) +
     &                                Beta*Qnl(N-1,L+1))/Talpha

                      Enddo
                   Enddo

               Else
C
C Use recursion 38D in MD paper (multiple times).
C
                  Call Qcomp_38D(Qnl, Nlq, Ltot, Talpha)

               Endif

            Else

               If (Xval .GT. 3.0D0) Then
C
C Npl > 0, and odd  Xval > 3.0
C N = 0+1, 1+1...
                   Qnl(0,0) = Qcomp(1,0)
                   Qnl(1,1) = Qcomp(2,1)
C
C Use recursion 38E in MD paper.
C
                   Do LL = 3, Ltot+1

                      L = LL - 1
                      N = LL - 1
#ifdef _DEBUG_LVLM1
                      Write(6,"(a,2(1x,i3),2(1x,F10.6))") 
     &                "X>3;odd", N, L, Qnl(N-2,L-2),
     &                                 Qnl(N-1,L-1),N+L-2
#endif
                      Qnl(N,L) =  ((N+L-2)*Qnl(N-2,L-2) +
     &                             (Beta-(2*L-1)*(Talpha/Beta))*
     &                              Qnl(N-1,L-1))/Talpha
                   Enddo
C
C Use recursion 38D in MD paper (multiple times).
C
                   Call Qcomp_38D_odd(Qnl, Nlq, Ltot, Talpha)

               Else
C
C Npl > 0, and odd  Xval < 3.0
C N = Ltot+1, Ltot+1+....

                  Qnl(Ltot-1,Ltot-1)   = Qcomp(Ltot, Ltot-1)
                  Qnl(Ltot,Ltot) = Qcomp(Ltot+1, Ltot)
C
C Using 38F from MD paper.
C
                  Do LL = (Ltot-1), 1, -1
                     L = LL - 1
                     N = LL - 1
#ifdef _DEBUG_LVLM1
                     Write(6,"(a,2(1x,i3),2(1x,F10.6))") 
     &                    "X<3;odd", N, L, Qnl(N+2,L+2),
     &                     Qnl(N+1,L+1),N+L+2
#endif

                     Qnl(N,L) = (Talpha*Qnl(N+2,L+2) - (Beta-(2*L+3)*
     &                           (Talpha/Beta))*Qnl(N+1,L+1))/(N+L+2)
                  Enddo
C
C Use recursion 38D in MD paper (multiple times).
C
                  Call Qcomp_38D_Odd(Qnl, Nlq, Ltot, Talpha)

               Endif

            Endif

         Else
C
C Nlq=0, Ltot >=2 bblock
C
            If (Ltot .EQ. 2) Then
C
C Using prescription A in Fig. 1 of MD paper
c
               Qnl(2,0) = Qcomp(2,0)

               If (Xval .Gt. 3.0D0) Then

                  Qnl(0,0) = Qcomp(0,0)
C
C Using 38B of MD paper
C
                  Qnl(1,1) = (Talpha*Qnl(2,0) - Qnl(0,0))/Beta
C
C Combining 38A and 38B of MD paper,note the cancellation of constants.
C
CSSSS Qnl(3,1) = Beta*Q(2,0)/Talpha
C
                  Qnl(2,2) = Qnl(2,0) - 3.0D0*Qnl(1,1)/Beta

               Else
C
C Using prescription C in Fig. 1 and combining with 38C and 38A.
c
                  Qnl(2,2) = Qcomp(2,2)

CSSS Qnl(1,1) = Beta*Qnl(2,0)/Talpha
CSSS Qnl(3,1) = Beta*Qnl(2,0)/Talpha

                  Qnl(1,1) = Beta*(Qnl(2,0) - Qnl(2,2))/3.0D0
                  Qnl(0,0) = (Talpha*Qnl(2,0) - Beta*Qnl(1,1))

               Endif

            Else
C
C Nlq=0, Ltot>2 block
C Using recursion 38A of MD paper.
C
               Qnl(2,0) = Qcomp(2,0)

               Do L = 0, Ltot - 3

                  Qnl(3+L,L+1) = Beta*(Qnl(L+2,L))/Talpha

               Enddo

               If (Xval .Gt. 3.0D0) Then

                   Qnl(0,0) = Qcomp(0,0)

                   Do L = 1, Ltot - 1
C
C Using 38B of MD paper.
C
                      Qnl(L,L) = (Talpha*Qnl(L+1,L-1) - (2*L-1)*
     &                            Qnl(L-1,L-1))/Beta
                   Enddo
C
C Combining 38A and 38B of MD paper,note the cancellation of constants.
C
                   Qnl(Ltot,Ltot) = Qnl(Ltot,Ltot-2) - (2*Ltot-1)*
     &                              Qnl(Ltot-1, Ltot-1)/Beta

C Using 38D of MD paper (Note the error in MD paper)
C
                   Lmax = Ltot - 2
                   Do NN = 0, Ltot-4, 2
                      Lmax = Lmax - 2
                      Do L= 0, Lmax

                         N = L + 4 + NN
#ifdef _DEBUG_LVLM1
                         Write(6,"(a,2(1x,i3),2(1x,F10.6))") 
     &                        "N and L", N, L , Qnl(N-2,L),
     &                         Qnl(N-1,L+1)
#endif
                         Qnl(N,L) = ((N+L-1)*Qnl(N-2,L) +
     &                                Beta*Qnl(N-1,L+1))/Talpha

                      Enddo
                   Enddo

               Else
C
C Using prescription C in Fig. 1 and combining with 38C and 38A.
c
                  Qnl(2,2) = Qcomp(2,2)

CSSS         Qnl(1,1) = Beta*Qnl(2,0)/Talpha
CSSS         Qnl(3,1) = Beta*Qnl(2,0)/Talpha

                  Qnl(1,1) = Beta*(Qnl(2,0) - Qnl(2,2))/3.0D0

                  Do L = Ltot-3, 0, -1

                     Qnl(L,L) = (Talpha*Qnl(L+2,L) - Beta*Qnl(L+1,L+1)/
     &                          (2*L+1))
                  Enddo
C
C Using 38D of MD paper (Note the error in MD paper),
C
                   Lmax = Ltot - 2
                   Do NN = 0, Ltot-4, 2
                      Lmax = Lmax - 2
                      Do L= 0, Lmax

                         N = L + 4 + NN
#ifdef _DEBUG_LVLM1
                         Write(6,"(a,2(1x,i3),2(1x,F10.6))") 
     &                            "N and L", N, L , Qnl(N-2,L),
     &                             Qnl(N-1,L+1)
#endif
                         Qnl(N,L) = ((N+L-1)*Qnl(N-2,L) +
     &                                Beta*Qnl(N-1,L+1))/Talpha

                      Enddo
                   Enddo

C
               Endif

            Endif
C
         Endif
C
      Endif


      Return
      End


                              

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine reset_internal_system_data()
c---------------------------------------------------------------------------
c   Resets internal data used by subroutines back to their original state.
c---------------------------------------------------------------------------
      implicit none
      include 'saved_data.h'

      first_master_send_work        = .true.
      first_sip_get_next_work       = .true.
      terminated_worker_termination = .false.
      printwarn_worker_work         = .true.
      flag_internal_event           = .false.
      master_error_processing       = .false.
      master_called                 = .false.
      managers_notified             = .false.
      first_timer                   = .true.
      first_aces_to_erd             = .true.
      first_contract_blocks         = .true.
      first_dcont2                  = .true.
      first_der_int_setup           = .true.
      first_operation_desc          = .true.
      first_blk_event_log           = .true.
      cwork_debug                   = .false.
      first_diis_setup              = .true.
      first_blocks_to_list          = .true.
      first_list_to_blocks          = .true.
      n_saved_requests              = 0
      cwork_iprint                  = 0
      i_been_called_list_to_blocks  = 0
      i_been_called_shmem_list      = 0

c-------------------------------------------------------------------------
c   Remove entries from user_sub table.
c-------------------------------------------------------------------------

      call clear_user_sub()

      return
      end

c This function returns the uppercase atomic symbol of the atomic number N.
C It returns '  ' if the atomic number is not recognized.

      character*2 function AtomSymb(n)
      implicit none

      integer n

      character*2 SymbTable(111)
      data SymbTable /
     & 'H ','HE',
     & 'LI','BE',
     & 'B ','C ','N ','O ','F ','NE',
     & 'NA','MG',
     & 'AL','SI','P ','S ','CL','AR',
     & 'K ','CA',
     & 'SC','TI','V ','CR','MN','FE','CO','NI','CU','ZN',
     & 'GA','GE','AS','SE','BR','KR',
     & 'RB','SR',
     & 'Y ','ZR','NB','MO','TC','RU','RH','PD','AG','CD',
     & 'IN','SN','SB','TE','I ','XE',
     & 'CS','BA',
     & 'LA','CE','PR','ND','PM','SM','EU',
     &                               'GD','TB','DY','HO','ER','TM','YB',
     & 'LU','HF','TA','W ','RE','OS','IR','PT','AU','HG',
     & 'TL','PB','BI','PO','AT','RN',
     & 'FR','RA',
     & 'AC','TH','PA','U ','NP','PU','AM',
     &                               'CM','BK','CF','ES','FM','MD','NO',
     & 'LR','RF','DB','SG','BH','HS','MT','DS','RG'
     &               /

      AtomSymb = SymbTable(n)
      if (n.lt.1.or.111.lt.n) AtomSymb = '  '

      return
c     end function AtomSymb
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL3C_SET_ABC
     +
     +                    ( NCGTO1,NCGTO2,NCGTO3,
     +                      NPGTO1,NPGTO2,NPGTO3,
     +                      SHELL1,SHELL2,SHELL3,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                      EXP1,EXP2,EXP3,
     +                      CC1,CC2,CC3,
     +                      SPHERIC,
     +
     +                            NCGTOA,NCGTOB,NCGTOC,
     +                            NPGTOA,NPGTOB,NPGTOC,
     +                            SHELLA,SHELLB,SHELLC,SHELLP,SHELLQ,
     +                            MXSHELL,
     +                            XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,
     +                            ATOMIC,EQUALAB,EQUALBC,EQUALAC,
     +                            ABX,ABY,ABZ,ACX,ACY,ACZ,
     +                            NABCOOR,NACCOOR,
     +                            RNABSQ,RNACSQ,RNBCSQ,
     +                            SPNORM,
     +                            NXYZA,NXYZB,NXYZC,
     +                            NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                            NRYA,NRYB,NRYC,
     +                            INDEXA,INDEXB,INDEXC,
     +                            SWAP12,SWAP23,SWAP13,
     +                            LEXPA,LEXPB,LEXPC,
     +                            LCCA,LCCB,LCCC,
     +                            LCCSEGA,LCCSEGB,LCCSEGC,
     +                            NXYZHRR,NCOLHRR,NROTHRR,
     +                            EMPTY )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL3C_SET_ABC
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the logistics on how to evaluate
C                the 3-center (123) overlap integral batch in the most
C                efficient way. It performs the label map:
C
C                                 (123) --> (ABC)
C
C                according to certain criteria that have to be met for
C                efficiency. The freedom we have in making the internal
C                association 1,2,3 -> A,B,C follows from the 6-fold
C                permutational symmetry of the 3-center overlap
C                integrals:
C
C                  (123) = (132) = (213) = (231) = (312) = (321)
C
C                Which kind of these permutations have to be applied
C                is governed by the least amount of work (# of steps)
C                for the combined two HRR procedures:
C
C                     (A+B+C,0,0) -> (A+B,C,0) -> (A,B,C)
C
C                The final A and B shell labels have thus to obey the
C                relation A>=B>=C.
C
C
C                  Input (x = 1,2 and 3):
C
C                   NCGTOx        =  # of contractions for csh x
C                   NPGTOx        =  # of primitives per contraction
C                                    for csh x
C                   SHELLx        =  the shell type for csh x
C                   Xy,Yy,Zy      =  the x,y,z-coordinates for centers
C                                    y = 1,2 and 3
C                   EXPx          =  primitive exponents for csh x
C                   CCx           =  contraction coeffs for csh x
C                   SPHERIC       =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output (x = A,B and C):
C
C                   NCGTOx        =  # of contractions for csh x
C                   NPGTOx        =  # of primitives per contraction
C                                    for csh x
C                   SHELLx        =  the shell type for csh x
C                   SHELLy        =  the shell sums y = P = A+B and
C                                    y = Q = A+B+C
C                   MXSHELL       =  the largest (maximum) shell type
C                   Xy,Yy,Zy      =  the x,y,z-coordinates for centers
C                                    y = A,B and C
C                   ATOMIC        =  indicates, if purely atomic
C                                    integrals will be evaluated
C                   EQUALxy       =  indicates, if csh x and csh y are
C                                    considered to be equal for the
C                                    pairs AB,BC and AC
C                   xyX,xyY,xyZ   =  the x,y,z-coordinate differences
C                                    between centers xy = AB and xy = AC
C                   NxyCOOR       =  # of non-zero x,y,z-coordinate
C                                    differences between centers xy = AB
C                                    and xy = AC
C                   RNxySQ        =  square of the magnitude of the
C                                    distance between centers xy = AB,AC
C                                    and BC
C                   SPNORM        =  normalization factor due to
C                                    presence of s- and p-type shells.
C                                    For each s-type shell there is a
C                                    factor of 1 and for each p-type
C                                    shell a factor of 2
C                   NXYZx         =  # of cartesian monomials for csh x
C                   NXYZET        =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    E = A,...,A+B
C                   NXYZFT        =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    F = A,...,A+B+C
C                   NXYZy         =  # of cartesian monomials for
C                                    the y = P = A+B and y = Q = A+B+C
C                                    shells
C                   NRYx          =  # of spherical functions for csh x
C                   INDEXx        =  index A,B,C -> 1,2,3 map
C                   SWAPxy        =  is .true., if a swap x <-> y has
C                                    been performed for xy = 12,23,13
C                   LEXPx         =  pointers to locate appropriate
C                                    section of the exponent array
C                                    corresponding to csh x
C                   LCCx          =  pointers to locate appropriate
C                                    section of the contraction coeff
C                                    array corresponding to csh x
C                   LCCSEGx       =  pointers to locate appropriate
C                                    section of the lowest and highest
C                                    primitive index array defining
C                                    segmented contraction boundaries
C                                    for csh x
C                   NXYZHRR       =  maximum dimension of cartesian and
C                                    spherical components during the
C                                    entire HRR contraction procedure
C                   NCOLHRR       =  maximum # of HRR rotation matrix
C                                    columns needed to generate the
C                                    final HRR rotation matrix
C                   NROTHRR       =  maximum # of HRR rotation matrix
C                                    elements needed to generate the
C                                    final HRR rotation matrix
C                   EMPTY         =  logical flag, indicating if an
C                                    empty batch of integrals is
C                                    expected.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     ATOM12,ATOM13,ATOM23
         LOGICAL     CASE1,CASE2
         LOGICAL     EMPTY
         LOGICAL     EQUAL12,EQUAL13,EQUAL23
         LOGICAL     EQUALAB,EQUALAC,EQUALBC
         LOGICAL     SPHERIC
         LOGICAL     SWAP12,SWAP23,SWAP13

         INTEGER     I,J,M
         INTEGER     INDEXA,INDEXB,INDEXC
         INTEGER     LCCSEGA,LCCSEGB,LCCSEGC
         INTEGER     LCCA,LCCB,LCCC
         INTEGER     LEXPA,LEXPB,LEXPC
         INTEGER     MXSHELL
         INTEGER     NABCOOR,NACCOOR
         INTEGER     NCGTO1,NCGTO2,NCGTO3
         INTEGER     NCGTOA,NCGTOB,NCGTOC
         INTEGER     NGH,NGHO
         INTEGER     NPGTO1,NPGTO2,NPGTO3
         INTEGER     NPGTOA,NPGTOB,NPGTOC
         INTEGER     NROW,NCOL,NROT
         INTEGER     NRYA,NRYB,NRYC
         INTEGER     NXYZA,NXYZB,NXYZC
         INTEGER     NXYZET,NXYZFT,NXYZP,NXYZQ
         INTEGER     NXYZG,NXYZH,NXYZI,NXYZGO,NXYZHO
         INTEGER     NXYZHRR,NCOLHRR,NROTHRR
         INTEGER     SHELL1,SHELL2,SHELL3
         INTEGER     SHELLA,SHELLB,SHELLC
         INTEGER     SHELLG,SHELLH
         INTEGER     SHELLP,SHELLQ

         INTEGER     ADD (0:2)

         DOUBLE PRECISION  ABX,ABY,ABZ,ACX,ACY,ACZ,BCX,BCY,BCZ
         DOUBLE PRECISION  RNABSQ,RNACSQ,RNBCSQ
         DOUBLE PRECISION  SPNORM
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  EXP1 (1:NPGTO1)
         DOUBLE PRECISION  EXP2 (1:NPGTO2)
         DOUBLE PRECISION  EXP3 (1:NPGTO3)

         DOUBLE PRECISION  CC1 (1:NPGTO1,1:NCGTO1)
         DOUBLE PRECISION  CC2 (1:NPGTO2,1:NCGTO2)
         DOUBLE PRECISION  CC3 (1:NPGTO3,1:NCGTO3)

         DATA  ADD    /0,0,1/

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (ONE     =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...generate all 1,2,3 data. Decide as early as possible,
C                if a zero batch of overlap integrals is expected.
C
C
         EMPTY  = .FALSE.

         ATOM12 = (X1.EQ.X2) .AND. (Y1.EQ.Y2) .AND. (Z1.EQ.Z2)
         ATOM13 = (X1.EQ.X3) .AND. (Y1.EQ.Y3) .AND. (Z1.EQ.Z3)
         ATOM23 = (X2.EQ.X3) .AND. (Y2.EQ.Y3) .AND. (Z2.EQ.Z3)
         ATOMIC = ATOM12 .AND. ATOM13
         SHELLQ = SHELL1 + SHELL2 + SHELL3

         MXSHELL = MAX0 (SHELL1,SHELL2,SHELL3)

         CASE1 = MOD (SHELLQ,2) .EQ. 1
         CASE2 = SPHERIC. AND. (MXSHELL.GT.(SHELLQ-MXSHELL))

         IF (ATOMIC .AND. (CASE1.OR.CASE2)) THEN
             EMPTY = .TRUE.
             RETURN
         END IF
C
C
C             ...determine csh equality between center pairs 1,2 ,
C                1,3 and 2,3 in increasing order of complexity:
C
C                 centers -> shells -> exponents -> ctr coefficients
C
C
         EQUAL12 = ATOM12

         IF (EQUAL12) THEN
             EQUAL12 =     (SHELL1 .EQ. SHELL2)
     +               .AND. (NPGTO1 .EQ. NPGTO2)
     +               .AND. (NCGTO1 .EQ. NCGTO2)
             IF (EQUAL12) THEN
               DO I = 1,NPGTO1
                  EQUAL12 = EQUAL12 .AND. (EXP1(I).EQ.EXP2(I))
               END DO
               IF (EQUAL12) THEN
                 DO J = 1,NCGTO1
                    IF (EQUAL12) THEN
                      DO I = 1,NPGTO1
                         EQUAL12 = EQUAL12 .AND. (CC1(I,J).EQ.CC2(I,J))
                      END DO
                    END IF
                 END DO
               END IF
             END IF
         END IF

         EQUAL13 = ATOM13

         IF (EQUAL13) THEN
             EQUAL13 =     (SHELL1 .EQ. SHELL3)
     +               .AND. (NPGTO1 .EQ. NPGTO3)
     +               .AND. (NCGTO1 .EQ. NCGTO3)
             IF (EQUAL13) THEN
               DO I = 1,NPGTO1
                  EQUAL13 = EQUAL13 .AND. (EXP1(I).EQ.EXP3(I))
               END DO
               IF (EQUAL13) THEN
                 DO J = 1,NCGTO1
                    IF (EQUAL13) THEN
                      DO I = 1,NPGTO1
                         EQUAL13 = EQUAL13 .AND. (CC1(I,J).EQ.CC3(I,J))
                      END DO
                    END IF
                 END DO
               END IF
             END IF
         END IF

         EQUAL23 = EQUAL12 .AND. EQUAL13

         IF (.NOT.EQUAL12 .AND. .NOT.EQUAL13) THEN
           EQUAL23 = ATOM23
           IF (EQUAL23) THEN
             EQUAL23 =     (SHELL2 .EQ. SHELL3)
     +               .AND. (NPGTO2 .EQ. NPGTO3)
     +               .AND. (NCGTO2 .EQ. NCGTO3)
             IF (EQUAL23) THEN
               DO I = 1,NPGTO2
                  EQUAL23 = EQUAL23 .AND. (EXP2(I).EQ.EXP3(I))
               END DO
               IF (EQUAL23) THEN
                 DO J = 1,NCGTO2
                    IF (EQUAL23) THEN
                      DO I = 1,NPGTO2
                         EQUAL23 = EQUAL23 .AND. (CC2(I,J).EQ.CC3(I,J))
                      END DO
                    END IF
                 END DO
               END IF
             END IF
           END IF
         END IF
C
C
C             ...decide on the 1 <-> 2 , 1 <-> 3 and 2 <-> 3 swapping.
C
C
         SWAP12 = SHELL1 .LT. SHELL2
         SWAP13 = SHELL1 .LT. SHELL3
         SWAP23 = SHELL2 .LT. SHELL3
C
C
C             ...according to the previously gathered info, set the
C                new A,B,C shells, # of primitives + contraction coeffs
C                as well as pointers to the alpha exponents and
C                contraction coefficients. Also set the info for
C                evaluation of the [f00] overlap batches and for the
C                HRR steps later on.
C
C
         IF (SWAP12) THEN
             IF (SWAP23) THEN
                 XA = X3
                 YA = Y3
                 ZA = Z3
                 XB = X2
                 YB = Y2
                 ZB = Z2
                 XC = X1
                 YC = Y1
                 ZC = Z1
                 EQUALAB = EQUAL23
                 EQUALBC = EQUAL12
                 EQUALAC = EQUAL13
                 SHELLA = SHELL3
                 SHELLB = SHELL2
                 SHELLC = SHELL1
                 NPGTOA = NPGTO3
                 NPGTOB = NPGTO2
                 NPGTOC = NPGTO1
                 NCGTOA = NCGTO3
                 NCGTOB = NCGTO2
                 NCGTOC = NCGTO1
                 INDEXA = 3
                 INDEXB = 2
                 INDEXC = 1
                 LEXPC = 1
                 LEXPB = LEXPC + NPGTO1
                 LEXPA = LEXPB + NPGTO2
                 LCCC = 1
                 LCCB = LCCC + NPGTO1 * NCGTO1
                 LCCA = LCCB + NPGTO2 * NCGTO2
                 LCCSEGC = 1
                 LCCSEGB = LCCSEGC + NCGTO1
                 LCCSEGA = LCCSEGB + NCGTO2
             ELSE
                 IF (SWAP13) THEN
                     XA = X2
                     YA = Y2
                     ZA = Z2
                     XB = X3
                     YB = Y3
                     ZB = Z3
                     XC = X1
                     YC = Y1
                     ZC = Z1
                     EQUALAB = EQUAL23
                     EQUALBC = EQUAL13
                     EQUALAC = EQUAL12
                     SHELLA = SHELL2
                     SHELLB = SHELL3
                     SHELLC = SHELL1
                     NPGTOA = NPGTO2
                     NPGTOB = NPGTO3
                     NPGTOC = NPGTO1
                     NCGTOA = NCGTO2
                     NCGTOB = NCGTO3
                     NCGTOC = NCGTO1
                     INDEXA = 2
                     INDEXB = 3
                     INDEXC = 1
                     LEXPC = 1
                     LEXPA = LEXPC + NPGTO1
                     LEXPB = LEXPA + NPGTO2
                     LCCC = 1
                     LCCA = LCCC + NPGTO1 * NCGTO1
                     LCCB = LCCA + NPGTO2 * NCGTO2
                     LCCSEGC = 1
                     LCCSEGA = LCCSEGC + NCGTO1
                     LCCSEGB = LCCSEGA + NCGTO2
                 ELSE
                     XA = X2
                     YA = Y2
                     ZA = Z2
                     XB = X1
                     YB = Y1
                     ZB = Z1
                     XC = X3
                     YC = Y3
                     ZC = Z3
                     EQUALAB = EQUAL12
                     EQUALBC = EQUAL13
                     EQUALAC = EQUAL23
                     SHELLA = SHELL2
                     SHELLB = SHELL1
                     SHELLC = SHELL3
                     NPGTOA = NPGTO2
                     NPGTOB = NPGTO1
                     NPGTOC = NPGTO3
                     NCGTOA = NCGTO2
                     NCGTOB = NCGTO1
                     NCGTOC = NCGTO3
                     INDEXA = 2
                     INDEXB = 1
                     INDEXC = 3
                     LEXPB = 1
                     LEXPA = LEXPB + NPGTO1
                     LEXPC = LEXPA + NPGTO2
                     LCCB = 1
                     LCCA = LCCB + NPGTO1 * NCGTO1
                     LCCC = LCCA + NPGTO2 * NCGTO2
                     LCCSEGB = 1
                     LCCSEGA = LCCSEGB + NCGTO1
                     LCCSEGC = LCCSEGA + NCGTO2
                 END IF
             END IF
         ELSE
             IF (SWAP23) THEN
                 IF (SWAP13) THEN
                     XA = X3
                     YA = Y3
                     ZA = Z3
                     XB = X1
                     YB = Y1
                     ZB = Z1
                     XC = X2
                     YC = Y2
                     ZC = Z2
                     EQUALAB = EQUAL13
                     EQUALBC = EQUAL12
                     EQUALAC = EQUAL23
                     SHELLA = SHELL3
                     SHELLB = SHELL1
                     SHELLC = SHELL2
                     NPGTOA = NPGTO3
                     NPGTOB = NPGTO1
                     NPGTOC = NPGTO2
                     NCGTOA = NCGTO3
                     NCGTOB = NCGTO1
                     NCGTOC = NCGTO2
                     INDEXA = 3
                     INDEXB = 1
                     INDEXC = 2
                     LEXPB = 1
                     LEXPC = LEXPB + NPGTO1
                     LEXPA = LEXPC + NPGTO2
                     LCCB = 1
                     LCCC = LCCB + NPGTO1 * NCGTO1
                     LCCA = LCCC + NPGTO2 * NCGTO2
                     LCCSEGB = 1
                     LCCSEGC = LCCSEGB + NCGTO1
                     LCCSEGA = LCCSEGC + NCGTO2
                 ELSE
                     XA = X1
                     YA = Y1
                     ZA = Z1
                     XB = X3
                     YB = Y3
                     ZB = Z3
                     XC = X2
                     YC = Y2
                     ZC = Z2
                     EQUALAB = EQUAL13
                     EQUALBC = EQUAL23
                     EQUALAC = EQUAL12
                     SHELLA = SHELL1
                     SHELLB = SHELL3
                     SHELLC = SHELL2
                     NPGTOA = NPGTO1
                     NPGTOB = NPGTO3
                     NPGTOC = NPGTO2
                     NCGTOA = NCGTO1
                     NCGTOB = NCGTO3
                     NCGTOC = NCGTO2
                     INDEXA = 1
                     INDEXB = 3
                     INDEXC = 2
                     LEXPA = 1
                     LEXPC = LEXPA + NPGTO1
                     LEXPB = LEXPC + NPGTO2
                     LCCA = 1
                     LCCC = LCCA + NPGTO1 * NCGTO1
                     LCCB = LCCC + NPGTO2 * NCGTO2
                     LCCSEGA = 1
                     LCCSEGC = LCCSEGA + NCGTO1
                     LCCSEGB = LCCSEGC + NCGTO2
                 END IF
             ELSE
                 XA = X1
                 YA = Y1
                 ZA = Z1
                 XB = X2
                 YB = Y2
                 ZB = Z2
                 XC = X3
                 YC = Y3
                 ZC = Z3
                 EQUALAB = EQUAL12
                 EQUALBC = EQUAL23
                 EQUALAC = EQUAL13
                 SHELLA = SHELL1
                 SHELLB = SHELL2
                 SHELLC = SHELL3
                 NPGTOA = NPGTO1
                 NPGTOB = NPGTO2
                 NPGTOC = NPGTO3
                 NCGTOA = NCGTO1
                 NCGTOB = NCGTO2
                 NCGTOC = NCGTO3
                 INDEXA = 1
                 INDEXB = 2
                 INDEXC = 3
                 LEXPA = 1
                 LEXPB = LEXPA + NPGTO1
                 LEXPC = LEXPB + NPGTO2
                 LCCA = 1
                 LCCB = LCCA + NPGTO1 * NCGTO1
                 LCCC = LCCB + NPGTO2 * NCGTO2
                 LCCSEGA = 1
                 LCCSEGB = LCCSEGA + NCGTO1
                 LCCSEGC = LCCSEGB + NCGTO2
             END IF
         END IF
C
C
C             ...the new A,B and C shells are set. Calculate the
C                following info:
C
C                1) total shell sum A + B
C                2) cartesian monomial dimensions
C                3) cartesian monomial dimensions for shell sums
C                4) spherical dimensions (= cartesian, if no spherical)
C                5) the overall norm factor due to s- or p-type shells
C                6) the maximum size of the cartesian HRR part
C                   There will be two HRR steps involved:
C
C                           [f00] -> [e0c]      HRR I
C                           [e0c] -> [abc]      HRR II
C
C
         SHELLP = SHELLA + SHELLB

         NXYZA  = (SHELLA+1)*(SHELLA+2)/2
         NXYZB  = (SHELLB+1)*(SHELLB+2)/2
         NXYZC  = (SHELLC+1)*(SHELLC+2)/2
         NXYZP  = (SHELLP+1)*(SHELLP+2)/2
         NXYZQ  = (SHELLQ+1)*(SHELLQ+2)/2
         NXYZET =   ((SHELLP+1)*(SHELLP+2)*(SHELLP+3)/6)
     +            - ((SHELLA  )*(SHELLA+1)*(SHELLA+2)/6)
         NXYZFT =   ((SHELLQ+1)*(SHELLQ+2)*(SHELLQ+3)/6)
     +            - ((SHELLA  )*(SHELLA+1)*(SHELLA+2)/6)

         NRYA = SHELLA + SHELLA + 1
         NRYB = SHELLB + SHELLB + 1
         NRYC = SHELLC + SHELLC + 1

         IF (.NOT.SPHERIC) THEN
             NRYA = NXYZA
             NRYB = NXYZB
             NRYC = NXYZC
         END IF

         SPNORM = ONE
         IF (SHELLA.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELLB.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF
         IF (SHELLC.EQ.1) THEN
             SPNORM = SPNORM + SPNORM
         END IF

         NXYZHRR = MAX (NXYZET * NXYZC , NRYC * NXYZA * NXYZB)
C
C
C             ...calculate the coordinate differences between centers
C                A and B and calculate the square of the magnitude
C                of the distance between A and B. Also determine the
C                number of non-zero coordinate differences for the
C                pair A,B. Same for centers A and C. For centers
C                B and C we only need the square of the magnitude
C                of the distance between B and C.
C
C
         IF (.NOT.EQUALAB) THEN
             ABX = XA - XB
             ABY = YA - YB
             ABZ = ZA - ZB
             RNABSQ = ABX * ABX + ABY * ABY + ABZ * ABZ
             NABCOOR = 3
             IF (DABS(ABX).EQ.ZERO) NABCOOR = NABCOOR - 1
             IF (DABS(ABY).EQ.ZERO) NABCOOR = NABCOOR - 1
             IF (DABS(ABZ).EQ.ZERO) NABCOOR = NABCOOR - 1
         ELSE
             ABX = ZERO
             ABY = ZERO
             ABZ = ZERO
             RNABSQ = ZERO
             NABCOOR = 0
         END IF

         IF (.NOT.EQUALAC) THEN
             ACX = XA - XC
             ACY = YA - YC
             ACZ = ZA - ZC
             RNACSQ = ACX * ACX + ACY * ACY + ACZ * ACZ
             NACCOOR = 3
             IF (DABS(ACX).EQ.ZERO) NACCOOR = NACCOOR - 1
             IF (DABS(ACY).EQ.ZERO) NACCOOR = NACCOOR - 1
             IF (DABS(ACZ).EQ.ZERO) NACCOOR = NACCOOR - 1
         ELSE
             ACX = ZERO
             ACY = ZERO
             ACZ = ZERO
             RNACSQ = ZERO
             NACCOOR = 0
         END IF

         IF (.NOT.EQUALBC) THEN
             BCX = XB - XC
             BCY = YB - YC
             BCZ = ZB - ZC
             RNBCSQ = BCX * BCX + BCY * BCY + BCZ * BCZ
         ELSE
             RNBCSQ = ZERO
         END IF
C
C
C             ...if HRR I and/or II contractions are to be performed,
C                calculate NCOLHRR (maximum # of HRR rotation matrix
C                columns needed to generate the final HRR rotation
C                matrices) and NROTHRR (maximum # of HRR rotation
C                matrix elements).
C
C                First find maximum values for the HRR I part.
C
C
         NCOLHRR = 0
         NROTHRR = 0

         IF (SHELLC.NE.0) THEN

             NGH = NXYZFT
             NXYZG = NXYZFT
             NXYZH = 1
             NXYZGO = NXYZFT
             NXYZHO = 1
             NXYZI = NXYZQ
             SHELLG = SHELLQ
             NROW = 1
             NCOL = NGH
             NROT = NGH

             DO 100 SHELLH = 1,SHELLC
                NXYZGO = NXYZGO - NXYZI
                NXYZHO = NXYZHO + SHELLH + 1
                NGHO = NXYZGO * NXYZHO

                IF (NACCOOR.EQ.3) THEN
                    M = 1 + SHELLH/3
                    NROW = NROW +  M*(M + ADD (MOD(SHELLH,3)))
                ELSE IF (NACCOOR.EQ.2) THEN
                    NROW = NROW + SHELLH/2 + 1
                ELSE IF (NACCOOR.EQ.1) THEN
                    NROW = NROW + 1
                END IF

                NCOL = MAX0 (NGHO,NCOL)
                NROT = MAX0 (NROW*NGHO,NROT)

                NGH = NGHO
                NXYZG = NXYZGO
                NXYZH = NXYZHO
                NXYZI = NXYZI - SHELLG - 1
                SHELLG = SHELLG - 1
  100        CONTINUE

             NCOLHRR = NCOL
             NROTHRR = NROT

         END IF
C
C
C             ...next find maximum values for the HRR II part
C                and set overall maximum values.
C
C
         IF (SHELLB.NE.0) THEN

             NGH = NXYZET
             NXYZG = NXYZET
             NXYZH = 1
             NXYZGO = NXYZET
             NXYZHO = 1
             NXYZI = NXYZP
             SHELLG = SHELLP
             NROW = 1
             NCOL = NGH
             NROT = NGH

             DO 200 SHELLH = 1,SHELLB
                NXYZGO = NXYZGO - NXYZI
                NXYZHO = NXYZHO + SHELLH + 1
                NGHO = NXYZGO * NXYZHO

                IF (NABCOOR.EQ.3) THEN
                    M = 1 + SHELLH/3
                    NROW = NROW +  M*(M + ADD (MOD(SHELLH,3)))
                ELSE IF (NABCOOR.EQ.2) THEN
                    NROW = NROW + SHELLH/2 + 1
                ELSE IF (NABCOOR.EQ.1) THEN
                    NROW = NROW + 1
                END IF

                NCOL = MAX0 (NGHO,NCOL)
                NROT = MAX0 (NROW*NGHO,NROT)

                NGH = NGHO
                NXYZG = NXYZGO
                NXYZH = NXYZHO
                NXYZI = NXYZI - SHELLG - 1
                SHELLG = SHELLG - 1
  200        CONTINUE

             NCOLHRR = MAX (NCOL,NCOLHRR)
             NROTHRR = MAX (NROT,NROTHRR)

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

cjp for management of multiple moio information for multiple references

      subroutine loadmoio
      IMPLICIT INTEGER (A-Z)

c lists.com : begin

c These common blocks contain global information about the arrays in storage.
c Elements prepended with "bw" are for storing the file metadata while working
c on multiple references.






cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)



      external aces_bd_lists

c moio  (iGrp,iFam) : the physical record that contains the first element
c                     of the array (iGrp,iFam)
c moiowd(iGrp,iFam) : the integer-word index of the first element
c moiods(iGrp,iFam) : the number of columns in the array
c moiosz(iGrp,iFam) : the number of rows    in the array
c moiofl(iGrp,iFam) : the external file unit that contains the array

      integer          moio  (10,500),
     &                 moiowd(10,500),
     &                 moiosz(10,500),
     &                 moiods(10,500),
     &                 moiofl(10,500),
     &               bwmoio  (10,500,maxref),
     &               bwmoiowd(10,500,maxref),
     &               bwmoiosz(10,500,maxref),
     &               bwmoiods(10,500,maxref),
     &               bwmoiofl(10,500,maxref)
      common /lists/   moio,   moiowd,   moiosz,   moiods,   moiofl,
     &               bwmoio, bwmoiowd, bwmoiosz, bwmoiods, bwmoiofl
      save   /lists/

c moiomxsz(iGrp,iFam) : the original length of a one-dimensional array
c                       (This is shameful. Arrays should not be re-dimensioned
c                        at will during a job.)

      integer               moiomxsz(10,500),
     &                    bwmoiomxsz(10,500,maxref)
      common /lists_mxsz/   moiomxsz,
     &                    bwmoiomxsz
      save   /lists_mxsz/

c pRec(i)    : the index of the physical record in file i containing free space
c              (i is the internal unit number of the storage file.)
c iIntOff(i) : the integer offset from the beginning of the physical record
c              needed to address the free space

      integer            pRec   (5),
     &                   iIntOff(5),
     &                 bwpRec   (5,maxref),
     &                 bwiIntOff(5,maxref)
      common /io_ptrs/   pRec,   iIntOff,
     &                 bwpRec, bwiIntOff
      save   /io_ptrs/

c bIOUp  : a flag for bombing in get/putlst if aces_io_init has not been called
c bIOMod : a flag for updating the records in aces_io_fin

      logical           bIOUp, bIOMod
      common /io_flags/ bIOUp, bIOMod
      save   /io_flags/

c lists.com : end

      iLenMOIO = 10 * 500
      call icopy(iLenMOIO, bwmoio  (1,1,iref), 1, moio  (1,1), 1)
      call icopy(iLenMOIO, bwmoiowd(1,1,iref), 1, moiowd(1,1), 1)
      call icopy(iLenMOIO, bwmoiosz(1,1,iref), 1, moiosz(1,1), 1)
      call icopy(iLenMOIO, bwmoiods(1,1,iref), 1, moiods(1,1), 1)
      call icopy(iLenMOIO, bwmoiofl(1,1,iref), 1, moiofl(1,1), 1)
      call icopy(iLenMOIO, bwmoiomxsz(1,1,iref), 1, moiomxsz(1,1), 1)
      do i = 1, 5
         pRec(i) = bwpRec(i,iref)
         iIntOff(i) = bwiIntOff(i,iref)
      end do

      return
      end

C THIS PROJECTS THE TRANSLATIONAL MODES FROM THE SYMMETRY
C ADAPTED COORDINATES IN THE ABELIAN SUBGROUP

c INPUT
c integer NATOM

c OUTPUT
c double TPROJ(*)
c double SCR(*)
c double SYMQ(*)
c double ATMASS(*)

c RECORDS
c get 'ATOMMASS'
c put TRAREC(IXYZ)
c get 'COMPNSYQ'
c get 'COMPSYMQ'
c put 'COMPSYMQ'

      SUBROUTINE TRAPRJ(NATOM,TPROJ,SCR,SYMQ,ATMASS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SCR(1),SYMQ(1),TPROJ(1),ATMASS(1)

      CHARACTER*8 TRAREC(3)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA ONE /1.0/
      DATA TOL /1.D-10/
      DATA TRAREC /'TRAVECX ','TRAVECY ','TRAVECZ '/

      CALL GETREC(20,'JOBARC','ATOMMASS',IINTFP*NATOM,ATMASS)

C CONSTRUCT THE TRANSLATIONAL PROJECTOR IN MASS WEIGHTED COORDS
C           1 - SUM |T><T|

      NSIZE=3*NATOM
      CALL ZERO(TPROJ,NSIZE*NSIZE)
      IOFF=1
      DO I=1,NSIZE
         TPROJ(IOFF)=ONE
         IOFF=IOFF+NSIZE+1
      END DO
      DO IXYZ=1,3
         CALL ZERO(SCR,NSIZE)
         ndx = IXYZ
         DO I=1,NATOM
            SCR(ndx)=SQRT(ATMASS(I))
            ndx = ndx + 3
         END DO
         FACT=ONE/DNRM2(NSIZE,SCR,1)
         CALL DSCAL(NSIZE,FACT,SCR,1)
         CALL PUTREC(20,'JOBARC',TRAREC(IXYZ),NSIZE*IINTFP,SCR)
         CALL XGEMM('N','N',NSIZE,NSIZE,1,
     &              -1.d0,SCR,  NSIZE,
     &                    SCR,  1,
     &              ONE,  TPROJ,NSIZE)
      END DO

c   o hit symmetry adapted coordinates with projector
      CALL GETREC(20,'JOBARC','COMPNSYQ',1,NSYMOLD)
      CALL GETREC(20,'JOBARC','COMPSYMQ',NSYMOLD*NSIZE*IINTFP,SCR)
      CALL XGEMM('N','N',NSIZE,NSYMOLD,NSIZE,ONE,TPROJ,NSIZE,
     &           SCR,NSIZE,0.d0,SYMQ,NSIZE)

c   o renormalize
      IOFF=1
      DO I=1,NSYMOLD
         X=DNRM2(NSIZE,SYMQ(IOFF),1)
         IF (ABS(X).GT.TOL) THEN
            Z=ONE/X
            CALL DSCAL(NSIZE,Z,SYMQ(IOFF),1)
            IOFF=IOFF+NSIZE
         END IF
      END DO

      CALL PUTREC(20,'JOBARC','COMPSYMQ',NSYMOLD*NSIZE*IINTFP,SYMQ)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      Integer Function GrpOps ( PtGrp, PrimAx, Length, Type, Order,
     $   Axis )
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose:
C     Given a point group, generate a list of operations of the group.
C
C Limitations:
C     Knows the abelian groups: C1, Cs, Ci, C2, D2, C2v, C2h, D2h
C     Knows all Cn, Cnh, Sn groups
C     Doesn't know any group with C2's or sigma's *not* along the
C     cartesian axes due to problems defining such operations with
C     the present data structure.
C
C Returns:
C     GrpOps   Returns the number of operations in the group.
C              In case of error, returns error codes a follows:
C              = -1  Group unknown to GrpOps (presently only abelian
C                    groups and selected others are known.)
C              NOTE: The operation count given here is *not* the same
C                    as the usual group theory usage.  For example,
C                    a C6 axis is given as a single operation by GrpOps
C                    and the code *using* this list is expected to
C                    iterate through all 6 of the C6's.
C
C Variables:
C     PtGrp    String containing the Schoenflies symbol for the
C              group of interest. (input)
C              The first character must be in [CDS].  The order
C              must begin with the second character of PtGrp.  The
C              last non-blank character is taken to be the "modifier"
C              in the group symbol. It may be in upper- or lowercase.
C              A group of infinite order is denoted with an 'X' for the
C              order.
C     PrimAx   Array indicating the primary, secondary, (input)
C              and tertiary axes.
C     Length   Length of Type/Order/Axis arrays (input)
C     Type     Type of symmetry operation. (output)
C              = 'C'   Rotation
C              = 'S'   Improper rotation
C              = 'P'   Reflection plane
C              = 'I'   Inversion center
C     Order    Order of rotation axis. (output)
C     Axis     Axis of rotation or plane of reflection. (output)
C              = 1     x-axis or yz-plane
C              = 2     y-axis or xz-plane
C              = 3     z-axis or xy-plane
C
C Bugs:
C     Doesn't check point group symbols carefully.
C     Requires that perpendicular C2s and reflection planes
C     coincide with the cartesian axes.
C
C Dependents:
C     AtoI     Converts string to integer
C     linblnk   Returns the index of the last non-blank character
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C $Log: grpops.f,v $
C Revision 1.4  2010/10/07 14:33:58  ponton
C Add symcor changes, fix bugs in optimization code, change numerical lib calls to use proper routines
C
C Revision 1.2  2010/02/10 17:20:48  ponton
C Add GNU GPL info to each source file
C
C Revision 1.1.1.1  2009/07/01 18:54:34  ponton
C Initial import for ACESIII Release 3.0
C
C Revision 1.1.1.1  2003/04/02 19:21:35  aces
C INITIAL 2.4 IMPORT
C
C Revision 4.0  89/03/14  01:15:38  bernhold
C Baseline for Sun & VAX prior to porting everywhere
C 
C Revision 3.0  89/01/29  23:10:12  bernhold
C First working release for VAX
C 
C Revision 1.1  89/01/28  12:08:51  bernhold
C Initial revision
C 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Implicit Integer (a-z)
      Character*(*) PtGrp
      Integer PrimAx(3)
      Character*1 Type(length)
      Dimension Order(length), Axis(length)
C
      Character*1 PGMod
      Integer AtoI, linblnk
C
C     GrpOps serves as a counter for Type, Order, and Axis
C     PGMod is the "modifier" lifted from the name
C     OrdGrp is the order of the group (-1 if infinite order)
C
      GrpOps = 0
C
      i = linblnk(PtGrp)
      PGMod = PtGrp(i:i)
C
      If (PtGrp(2:2) .eq. 'X') then
         OrdGrp = -1
      Else
         OrdGrp = AtoI( PtGrp(2:) )
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     First check for the special cases: C1, Cs, Ci
C
      If (PtGrp(1:1) .eq. 'C' .AND. OrdGrp .eq. 1) then
C        C1 has *no* operations other than E
         GrpOps = 0
         Return
      ElseIf (PtGrp(1:2) .eq. 'Cs' .OR. PtGrp(1:2) .eq. 'CS'
     &   .OR. PtGrp .eq. 'C s') then
C        Cs has only Sigma-h (xy-plane)
         GrpOps        =  1
         Type(GrpOps)  = 'P'
         Order(GrpOps) =  0
         Axis(GrpOps)  =  PrimAx(1)
         Return
      ElseIf (PtGrp(1:2) .eq. 'Ci' .OR. PtGrp(1:2) .eq. 'CI'
     &      .OR. PtGrp .eq. 'C i') then
C        Ci has only i (inversion center)
         GrpOps        =  1
         Type(GrpOps)  = 'I'
         Order(GrpOps) =  0
         Axis(GrpOps)  =  0
         Return
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Handle the linear groups: Don't worry about C-infinity!
C     If we know its linear already, then only the non-axial
C     operations will help!
C
      If (PtGrp(1:3) .eq. 'CXv' .OR. PtGrp(1:3) .eq. 'CXV') then
C        CXv has no non-axial operations
         GrpOps = 0
         Return
      EndIf
      If (PtGrp(1:3) .eq. 'DXh' .OR. PtGrp(1:3) .eq. 'DXH') then
C        DXh has a sigma-h plane
         GrpOps        =  1
         Type(GrpOps)  = 'P'
         Order(GrpOps) =  0
         Axis(GrpOps)  =  PrimAx(1)
         Return
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     If we got this far, and its order is not at least 2, then
C     it must be T, O, I (which we can't handle) or a screw-up
C     with the point group symbol, so get out!
C
      If (OrdGrp .le. 1) then
         GrpOps = -1
         Return
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Sn groups are special: n must be even
C
      If (PtGrp(1:1) .eq. 'S') then
         If (mod(OrdGrp, 2) .eq. 0) then
            GrpOps        =  1
            Type(GrpOps)  = 'S'
            Order(GrpOps) =  OrdGrp
            Axis(GrpOps)  =  PrimAx(1)
            Return
         Else
            GrpOps = -1
            Return
         EndIf
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     All other groups (C & D) have a C(OrdGrp) about the z-axis
C
      If (PtGrp(1:1) .eq. 'C' .OR. PtGrp(1:1) .eq. 'D') then
         GrpOps        =  GrpOps + 1
         Type(GrpOps)  = 'C'
         Order(GrpOps) =  OrdGrp
         Axis(GrpOps)  =  PrimAx(1)
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     If its a 'D' group, add the perpendicular C2's
C
      If (PtGrp(1:1) .eq. 'D') then
         If (OrdGrp .eq. 2) then
C           Can handle D2, D2h
            Do 100 i = 2, 3
               GrpOps        = GrpOps + 1
               Type(GrpOps)  = 'C'
               Order(GrpOps) =  OrdGrp
               Axis(GrpOps)  =  PrimAx(i)
 100        Continue
         Else
C           Can't handle orders > 2 - they have C2's which
C           aren't on the cartesian axes.
            GrpOps = -1
            Return
         EndIf
      EndIf
C
C IF IT IS D2H, ADD ALL OF THE REMAINING OPS.
C
      IF(PTGRP.EQ.'D2h'.OR.PTGRP.EQ.'D2H')THEN
       DO 133 I=2,3
        GRPOPS=GRPOPS+1
        TYPE(GRPOPS)='P'
        ORDER(GRPOPS)=0
        AXIS(GRPOPS)=PRIMAX(I)
133    CONTINUE
       GRPOPS=GRPOPS+1
       TYPE(GRPOPS)='I'
       ORDER(GRPOPS)=0
       AXIS(GRPOPS)=0
      ENDIF
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Add the horizontal plane for 'h' groups
C
      If (PGMod .eq. 'h' .OR. PGMod .eq. 'H') then
         GrpOps        =  GrpOps + 1
         Type(GrpOps)  = 'P'
         Order(GrpOps) =  0
         Axis(GrpOps)  =  PrimAx(1)
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     Add the vertical planes for 'v' groups
C
      If (PGMod .eq. 'v' .OR. PGMod .eq. 'V') then
         If (OrdGrp .eq. 2) then
C           Can handle C2v
            Do 200 i = 2, 3
               GrpOps        = GrpOps + 1
               Type(GrpOps)  = 'P'
               Order(GrpOps) =  0
               Axis(GrpOps)  =  PrimAx(i)
 200        Continue
         Else
C           Can't handle orders > 2 - they have C2's which
C           aren't on the cartesian axes.
            GrpOps = -1
            Return
         EndIf
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     The only other thing left is a 'd' group, which we can't
C     handle either
C
      If (PGMod .eq. 'd' .OR. PGMod .eq. 'D') then
         GrpOps = -1
         Return
      EndIf
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     If we get here and haven't got any operations, something's wrong!
C
      If (GrpOps .eq. 0) GrpOps = -1
C
      Return
      End

      SUBROUTINE T2INS2(TAU,OVRLP,Z,IOVOFF,NROWT,NCOLT,IRREPDO)
C
C  FORM Z(A,j) = SUM TAU(bA,Ij) * DELTA(I,b)
C                b,I
C
CEND

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIRPRD,POP,VRT,POPI,POPJ,VRTA,VRTB,A,B
      DIMENSION TAU(NROWT,NCOLT),OVRLP(1),Z(1),IOVOFF(NIRREP)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
C
C LOOP OVER IRREPS OF A AND J
C
       INDAJ=0
       INDOV=1
       IOFTL0=1
       IOFTR0=0
       DO 200 IRREPAJ=1,NIRREP
        IRREPBI=DIRPRD(IRREPAJ,IRREPDO)
        INDOV=IOVOFF(IRREPBI)
        VRTB=VRT(IRREPBI,2)
        POPI=POP(IRREPBI,1)
        VRTA=VRT(IRREPAJ,1)
        POPJ=POP(IRREPAJ,2)
        IBI=1
        DO 210 J=1,POPJ
         IOFTRX=IOFTR0+(J-1)*POPI
         DO 220 A=1,VRTA
          INDAJ=INDAJ+1
          IOFTL=IOFTL0+(A-1)*VRTB
          DO 230 I=1,POPI
           IOFTR=IOFTRX+I
           Z(INDAJ)=Z(INDAJ)+SDOT(VRTB,TAU(IOFTL,IOFTR),1,
     &              OVRLP(INDOV+I),POPI)
230       CONTINUE
220      CONTINUE
210     CONTINUE
        IOFTR0=IOFTR0+POPI*POPJ
        IOFTL0=IOFTL0+VRTA*VRTB
200    CONTINUE
       RETURN
       END

      SUBROUTINE FSPUT(Z,ISTART,NUMPUT,IDUMMY,IRREP,LIST,IOTYPE)
C
C THIS ROUTINE WRITES A "STANDARD" INTEGRAL OR AMPLITUDE LIST IN A
C NONSTANDARD WAY.  IT ALLOWS ONE TO READ LISTS OF THE TYPE:
C
C           W(PQ,R1)  WITH IOTYPE = 'NNNA'
C
C WHERE 1 IS A SPECIAL TYPE OF ORBITAL (ACTIVE OR INACTIVE).  ANY
C INDEX CAN REFER TO A "SPECIAL" ORBITAL
C
C  'N' - NORMAL CASE.  READ ALL ORBITALS OF THIS TYPE
C  'A' - ACTIVE ORBITALS ONLY.
C  'I' - INACTIVE ORBITALS ONLY.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(*)
      CHARACTER*4 IOTYPE
      COMMON // ICORE(1)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FSIOLOC/ IFSPOS(8,22,8),ISCRLC, IFSPOSZ(8,22,8)
      COMMON /SYMPOP  / IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /FSSYMPOP/ FSDPDAN(8,22),FSDPDNA(8,22),FSDPDAA(8,22),
     &                  FSDPDIN(8,22),FSDPDNI(8,22),FSDPDII(8,22),
     &                  FSDPDAI(8,22),FSDPDIA(8,22)
C
C     It is convenient to consider all of the FSDPD__ arrays as a
C     single large array.
C
      Integer FSDPD(8,22,8)
      Equivalence (FSDPDAN(1,1), FSDPD(1, 1, 1) )
C
C     Common block to hold labels for the index types
C
      Character*2 FSDsLbl(8)
      Common /FSIOC/ FSDsLbl
C
C&      Include 'tempio.inc'
C
C     For temporary I/O vectors, etc.
C
C     TIOBas  Pointer to space allocated in ICore for temporary I/O
C     TIOSiz  Size of space allocated in ICore for temporary I/O
C     TIOPos  Pointer to gather vector in ICore
C     TIOZPos Position of zero list in ICore
C     TIODPD  Distribution size
C     TIOFull If it is set to 1, the lists are 'right' after 
C             FSPUT and FSPUTT1. Otherwise only the active part
C	      can be used.
C     TIOBufSz FSIO buffer size -- needed by FSMAP to properly
C              handle writing lists of TIOFull=1.
C
C     Dimensions are: 8 irrpes, 22 list types (even though we
C     don't use most of them), up to 5 different types of distributions.
C
C     TIOZPos is only used by UPLE and UPLT packing schemes.  For the
C     others, TIOZPos(*, IType, IDsTyp) must be 0 or FSGET/FSPUT will be
C     very confused.
C
      Integer TMxDsTy
      Parameter (TMxDsTy = 5)
C
      Integer TIOBas, TIOSiz, TIOPos(8, 22, TMxDsTy),
     $   TIOZPos(8, 22, TMxDsTy), TIODPD(8, 22, TMxDsTy), TIOFull,
     $   TIOBufSz
C
C     Text labels for the names of the temp. I/O distributions
C     (slowest dimension of TIO info arrays).
C
      Character*2 TDsLbl(TMxDsTy)
C
      Common /TempIO/ TIOBas, TIOSiz, TIOPos, TIOZPos, TIODPD, TIOFull,
     $   TIOBufSz
      Common /TempIOC/ TDsLbl
C
C LOCAL VARIABLES
C
C     LType   Index type of left-hand index pair.  0 is reserved for
C             'NN', which means no gather is done; otherwise, a positive
C             integer corresponding to one of the standard index types
C             or one of the temporary IO types (no distinction is
C             required once IPosLeft, NSize, and IZPosL are set).
C     RType   Same as LType for the right-hand index pair.
C     IPosLeft Pointer to gather vector for LHS indices.
C     IPosRght Pointer to gather vector for RHS indices.
C     IZPosL   Pointer to "zero list" vector for LHS indices. 0 if
C              no extra processing is required.
C     IZPosR   Same as IZPosL for RHS.
C     I        Loop index
C     IFactor  A particular factor from the "zero list" for the ket
c              indices.
C
      Integer LType, RType, IPosLeft, IPosRght, IZPosL, IZPosR, I,
     $   IFactor
C
      IOFF=1
      IPosLeft = 0
      IPosRght = 0
      IZPosL = 0
      IZPosR = 0
C
      SYTYPL=ISYTYP(1,LIST)
      SYTYPR=ISYTYP(2,LIST)
C
C DISTINGUISH LEFT AND RIGHT TYPES.  SET UP POINTER ADDRESSES.
C
      If (IOType(1:2) .eq. 'NN') then
         LType = 0
      Else
         LType = iszeq(8, FSDsLbl, 1, IOType(1:2))
         If (LType .ne. 0) then
            IPosLeft = IFSPos(  Irrep, SyTypL, LType)
            IZPosL   = IFSPosZ( Irrep, SyTypL, LType)
            NSize    = FSDPD(   Irrep, SyTypL, LType)
         Else
            LType = iszeq(TMxDsTy, TDsLbl, 1, IOType(1:2))
            If (LType .ne. 0) then
               IPosLeft = TIOPos (Irrep, SyTypL, LType)
               IZPosL   = TIOZPos(Irrep, SyTypL, LType)
               NSize    = TIODPD (Irrep, SyTypL, LType)
cSSS               Write (6, 8000) Irrep, List, 'Left', LType, SyTypL,
cSSS     $            IPosLeft, IZPosL
            Else
               Write (6, 9000) IOType(1:2), 'left'
               Call ErrEx
            EndIf
         EndIf
      EndIf
C
      If (IOType(3:4) .eq. 'NN') then
         RType = 0
      Else
         RType = iszeq(8, FSDsLbl, 1, IOType(3:4))
         If (RType .ne. 0) then
            IPosRght = IFSPos(  Irrep, SyTypR, RType)
            IZPosR   = IFSPosZ( Irrep, SyTypR, RType)
         Else
            RType = iszeq(TMxDsTy, TDsLbl, 1, IOType(3:4))
            If (RType .ne. 0) then
               IPosRght = TIOPos (Irrep, SyTypR, RType)
               IZPosR   = TIOZPos(Irrep, SyTypR, RType)
cSSS               Write (6, 8000) Irrep, List, 'Right', RType, SyTypR,
cSSS     $            IPosRght, IZPosR
            Else
               Write (6, 9000) IOType(3:4), 'right'
               Call ErrEx
            EndIf
         EndIf
      EndIf
C
 8000 Format(1X, '@FSPUT-I, List [', I3, ',', I3, '] ', A5,
     $   ' indices are dist., ', I2, ' sym. type ', I2,/11X,
     $   'Gather vector at ', I6, ' zero vector at ', I6, '.')
 9000 Format(T3,'@FSPUT-F, Unknown index type ', A, ' requested ',
     $   'for ', A, ' index pair.')
C
C     Sanity check for gather vector pointers
C
      If (LType .ne. 0 .AND. IPosLeft .eq. 0) then
         Write (6, 9100) Irrep, List, IOType, 'left'
         Call ErrEx
      EndIf
      If (RType .ne. 0 .AND. IPosRght .eq. 0) then
         Write (6, 9100) Irrep, List, IOType, 'right'
         Call ErrEx
      EndIf
 9100 Format(1X, '@FSPUT-F, Bad gather vector pointer for list [', I3,
     $   ',', I3, '] ', A, 1X, A, ' indices.')
C
C CASE I.  ONLY BRA INDICES ARE NONSTANDARD
C
      IF( RType .eq. 0 )THEN
       DO 10 IPUT=ISTART,NUMPUT
C
C       Apply factors from "zero list" if necessary
C
        If (IZPosL .ne. 0) then
           Do 15 I = 0, NSize - 1
              Z(IOff + I) = ICore(IZPosL + I ) * Z(IOff + I)
 15        Continue
        EndIf
C
        IF(TIOFULL.EQ.1) CALL GETLST(ICORE(ISCRLC),IPUT,1,1,IRREP,LIST)
        CALL SCATTER(NSIZE,ICORE(ISCRLC),ICORE(IPOSLEFT),Z(IOFF))
        CALL PUTLST(ICORE(ISCRLC),IPUT,1,1,IRREP,LIST)
C
        IOFF=IOFF+NSIZE
10     CONTINUE
C
C CASE II. ONLY KET INDICES ARE NONSTANDARD
C
      ELSEIF( LType .eq. 0 )THEN
       NSIZE=IRPDPD(IRREP,SYTYPL)
       DO 20 IPUT=ISTART,NUMPUT
        IREALPUT=ICORE(IPOSRGHT+IPUT-1)
C
C       Do we have a factor from the "zero list" to account for?
C
        If (IZPosR .ne. 0) then
           IFactor = ICore(IZPosR + IPut - 1)
        Else
           IFactor = 1
        EndIf
C
C       Might have to scale everything
C
        If (IFactor .ne. 1 .AND. IFactor .ne. 0) then
           Do 25 I = 0, NSize - 1
              Z(IOff + I) =  Z(IOff + I) * IFactor 
 25        Continue
        EndIf
C
C       If factor is 0, don't even try to write it
C
        If (IFactor .ne. 0) then
           CALL PUTLST(Z(IOFF),IREALPUT,1,1,IRREP,LIST)
        EndIf
C
        IOFF=IOFF+NSIZE
20     CONTINUE
C
C CASE III. BOTH NONSTANDARD
C
      ELSE
       DO 30 IPUT=ISTART,NUMPUT
        IREALPUT=ICORE(IPOSRGHT+IPUT-1)
        If (IZPosR .ne. 0) then
           IFactor = ICore(IZPosR + IPut - 1)
        Else
           IFactor = 1
        EndIf
C
C       If factor is 0, don't even try to read/write it
C
        If (IFactor .ne. 0) then
C
C       Apply factors from "zero list" if necessary
C
        If (IZPosL .ne. 0) then
           Do 35 I = 0, NSize - 1
              Z(IOff + I) = Z(IOff + I) * (IFactor * ICore(IZPosL + I ))
 35        Continue
        EndIf
           IF(TIOFULL.EQ.1) 
     $        CALL GETLST(ICORE(ISCRLC),IREALPUT,1,1,IRREP,LIST)
           CALL SCATTER(NSIZE,ICORE(ISCRLC),ICORE(IPOSLEFT),Z(IOFF))
           CALL PUTLST(ICORE(ISCRLC),IREALPUT,1,1,IRREP,LIST)
        EndIf
C
        IOFF=IOFF+NSIZE
30     CONTINUE
C
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pardo_loadb(optable, noptable, iop, index_table, 
     *                  nindex_table, array_table, narray_table,
     *                  block_map_table, segment_table, nsegment_table,
     *                  comm, debug, prt_flag,
     *                  start_op, end_op)
c---------------------------------------------------------------------------
c   PARDO loop with load balancing.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      INCLUDE 'timerz.h'
      include 'where_table.h'
      include 'batch_table.h'

      integer noptable, iop, start_op, end_op
      integer optable(loptable_entry,noptable)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer block_map_table(lblock_map_entry,*)
      integer nsegment_table 
      integer segment_table(lsegment_table_entry,nsegment_table) 
      integer comm

      integer i, j, opcode, istat
      integer result_array
      integer indx(mx_array_index)
      integer ind(mx_array_index), seg(mx_array_index)
      integer bseg(mx_array_index), eseg(mx_array_index)
      integer next_seg(mx_array_index)
      integer nind 
      integer my_lock
      integer pardo_master, get_pardo_master
      integer cluster_start, cluster_end
      logical debug, prt_flag
      logical prefetch

      integer push_do, pop_do

      integer next_batch, last_batch, max_batch

      save ind, nind, next_batch
      save bseg, eseg, seg



      if (iop .gt. noptable) then
	print *,'PARDO_LOOP: Called with iop = ',iop,' noptable = ',
     *           noptable
        call abort_job()
      endif

      if (iop .lt. start_op .or. iop .gt. end_op) return
      opcode = optable(c_opcode, iop)

      if (opcode .eq. pardo_op) then
         pardo_master = get_pardo_master()

c--------------------------------------------------------------------------
c   PARDO operation
c   Save the loop indices, line number.
c--------------------------------------------------------------------------

         do i = 1, mx_array_index
            indx(i) = optable(c_ind1+i-1,iop)
         enddo

         call set_prefetch_context(indx, mx_array_index)
 
c---------------------------------------------------------------------------
c   First pass through the loop?
c---------------------------------------------------------------------------

         my_lock = optable(c_pardo_lock_index,iop)
         if (my_company_rank .eq. pardo_master) 
     *          call f_acquire_pardo_lock(my_lock)
         if (optable(c_oploop, iop) .eq. 0) then
c            print *,'TASK ',me,' PARDO INIT CODE line ',current_line
c            call c_flush_stdout()

c----------------------------------------------------------------------------
c   Push the start_op and end_op indices on the instruction stack.
c----------------------------------------------------------------------------

            istat = push_do(start_op, end_op)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *           ' Error in pardo_loadb: stack overflow'
               call abort_job()
            endif

c---------------------------------------------------------------------------
c   Push the data for the WHERE conditionals.
c---------------------------------------------------------------------------

            istat = push_do(iwhere, nwhere)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *           ' Error in pardo_loadb: stack overflow while ',
     *           'pushing wheres'
               call abort_job()
            endif

c---------------------------------------------------------------------------
c   Set the new values of start_op, end_op
c---------------------------------------------------------------------------

            start_op = iop
            do j = iop+1,noptable
               if (optable(c_opcode,j) .eq. endpardo_op) then
                  end_op = j
                  go to 100
               endif
            enddo
  100       continue

            optable(c_oploop, iop)     = 1   ! loop is initialized

c--------------------------------------------------------------------------
c   Get the current pardo timer keys out of the optable.
c--------------------------------------------------------------------------

            call unpack_pardo_timer(optable(c_instr_timer,iop),
     *                      pardo_timer, pardo_block_wait_timer)

c            print *, "pardo_timer =", pardo_timer, 
c     *               "pardo_block_wait_timer =", pardo_block_wait_timer

            call timer_start(pardo_timer)
            

c----------------------------------------------------------------------------
c   Get the WHERE conditionals for the current loop.
c----------------------------------------------------------------------------

            call get_where_conditionals(optable, start_op, end_op)

c----------------------------------------------------------------------------
c   Set up loop segment/index mapping.
c----------------------------------------------------------------------------

            max_batch = -1  
            call  lb_set_loop_incr_mapping(indx, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      ind, bseg, eseg, nind,
     *                      max_batch)
            last_batch_processed = optable(c_pardo_max_batch,iop) + 1
         endif   

c--------------------------------------------------------------------------
c   Determine the next loop batch.
c--------------------------------------------------------------------------

         next_batch = optable(c_pardo_batch,iop) + 1
         last_batch = optable(c_pardo_batch_end,iop)

         if (optable(c_pardo_batch,iop) .ge. 0) 
     *      optable(c_pardo_batch,iop) = optable(c_pardo_batch,iop)+1  
#ifdef DETAILED_TIMERS
         call timer_start (pardo_ovrhead_timer)
#endif         

         if (next_batch .gt. last_batch .or.
     *       next_batch .eq. 0) then
            if (my_company_rank .eq. pardo_master) then
               call pardo_loadb_update_batch(iop, optable, index_table, 
     *                segment_table, nsegment_table,
     *                next_batch, last_batch)
#ifdef VERY_DETAILED_TIMERS
               call timer_start (pardo_tserver_timer)
#endif               
               call exec_thread_server(0) 
#ifdef VERY_DETAILED_TIMERS               
               call update_timer (pardo_tserver_timer)
#endif               
               if (next_batch .le. 0) optable(c_oploop,iop) = 0
            else
               call f_acquire_pardo_lock(my_lock)
               call pardo_loadb_get_next_batch(comm, iop, index_table,
     *                 next_batch, last_batch)

               optable(c_pardo_batch, iop) = next_batch
               optable(c_pardo_batch_end,iop) = last_batch

               if (next_batch .le. 0) optable(c_oploop,iop) = 0
               call f_release_pardo_lock(my_lock)
            endif   
         endif
#ifdef DETAILED_TIMERS
         call update_timer (pardo_ovrhead_timer)
#endif         

         if (my_company_rank .eq. pardo_master) 
     *           call f_release_pardo_lock(my_lock)

c---------------------------------------------------------------------------
c   We now have a batch.  Check for end of loop.
c---------------------------------------------------------------------------

         if (next_batch .le. 0) then
            last_batch_processed = next_batch
            iop = end_op                ! point instruction counter to endpardo

            return                      ! Next instruction will be the endpardo
         endif

         call lb_get_next_loop_set(next_batch, ind, nind,
     *                             index_table, nindex_table,
     *                             bseg, eseg, seg)

c--------------------------------------------------------------------------
c   Save batch info in the batch table.
c--------------------------------------------------------------------------
 
         last_batch_processed = next_batch
         do i = 1, nind
            save_batch(i) = seg(i)
         enddo

         call lb_get_next_loop_set(next_batch+1, ind, nind,
     *                             index_table, nindex_table,
     *                             bseg, eseg, next_seg)

c---------------------------------------------------------------------------
c   Store the set of index segments in the "current_seg" field of the 
c   index table.
c---------------------------------------------------------------------------

         prefetch = .true.
         do i = 1, nind
            index_table(c_current_seg,ind(i)) = seg(i)
            index_table(c_next_seg, ind(i))   = next_seg(i)
            if (next_seg(i) .eq. 0) prefetch = .false.
         enddo

c----------------------------------------------------------------------------
c   If we cannot prefetch, zero out all the "next_seg" entries.
c----------------------------------------------------------------------------

         if (.not. prefetch) then
            do i = 1, nind
               index_table(c_next_seg, ind(i)) = 0
            enddo
         endif 
         
         iop = start_op + 1   ! point to next instruction
         return
      endif   ! pardo_op

      if (opcode .eq. endpardo_op) then

c         print *,'Task ',me,' Endpardo at line ',current_line
c         call c_flush_stdout()
         call unset_prefetch_context()

c-------------------------------------------------------------------------
c   Reset any temp blocks created in this loop.
c-------------------------------------------------------------------------

         do i = start_op, end_op

c-------------------------------------------------------------------------
c   If a PUT was executed, set the flag in the array_table.
c-------------------------------------------------------------------------
                                                                                
            if (optable(c_opcode,i) .eq. put_op .or.
     *          optable(c_opcode,i) .eq. put_replace_op) then
               result_array = optable(c_result_array,i)
               array_table(c_put_flag,result_array) = 1
            endif

c-------------------------------------------------------------------------
c   If a PREPARE was executed, set the flag in the array_table.
c-------------------------------------------------------------------------
                                                                                
            if (optable(c_opcode,i) .eq. prepare_op .or.
     *          optable(c_opcode,i) .eq. prepare_increment_op) then
               result_array = optable(c_result_array,i)
               array_table(c_prepare_flag,result_array) = 1
            endif

            if (optable(c_opblock,i) .ne. 0) then

c-------------------------------------------------------------------------
c   Only clear the block_computed_flag if the array is managed by
c   blkmgr.
c-------------------------------------------------------------------------

               result_array = optable(c_result_array,i)
               if (array_table(c_array_type, result_array) .ne.
     *             static_array) then
                  call block_end_of_loop(result_array,
     *              optable(c_opblock,i),optable(c_opblkndx,i),
     *              array_table, narray_table, index_table,
     *              nindex_table, block_map_table)
               endif
               optable(c_opblock,i) = 0
               optable(c_opblkndx,i) = 0
            endif
         enddo


c-------------------------------------------------------------------------
c   ENDPARDO operation.
c   Check for loop termination.
c-------------------------------------------------------------------------

         if (next_batch .lt. 0) then 
            optable(c_pardo_batch,iop) = -1

            call update_timer(pardo_timer)

c            print *,'Task ',me,' ENDPARDO loop termination'

c--------------------------------------------------------------------------
c   Reset the loop indices to "undefined".
c--------------------------------------------------------------------------

            do i = 1, mx_array_index
               ind(i) = optable(c_ind1+i-1,iop)
               if (ind(i) .ge. 1 .and. ind(i) .le. nindex_table) then
                  index_table(c_current_seg,ind(i)) = undefined_segment
                  index_table(c_next_seg, ind(i))   = 0
               endif  
            enddo

c--------------------------------------------------------------------------
c   Final pass of the loop.  Pop a new set of iwhere, nwhere values off the
c   stack.
c--------------------------------------------------------------------------

            istat = pop_do(iwhere, nwhere)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *          ' Error in pardo_loadb: stack underflow'
               call abort_job()
            endif

c--------------------------------------------------------------------------
c   Final pass of the loop.  Pop a new set of start, end values off the
c   stack.
c--------------------------------------------------------------------------

            istat = pop_do(start_op, end_op)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *          ' Error in pardo_loadb: stack underflow'
               call abort_job()
            endif

            if (start_op .gt. noptable .or. 
     *          start_op .lt. 0 .or.
     *          end_op .gt. noptable .or.
     *          end_op .lt. 0) call abort_job()
         endif 

      endif   ! endpardo_op


      return
      end

      subroutine set_pardo_workload(max_batch, start_batch, end_batch)
c--------------------------------------------------------------------------
c   Defines the pardo workload for the current pardo cluster. 
c--------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
      include 'trace.h'
      integer max_batch, start_batch, end_batch
      integer get_pardo_master, pardo_master
      integer cluster_size, get_pardo_cluster_size
      integer nbatch, ndiff, nclusters, my_cluster

      cluster_size = get_pardo_cluster_size()
      pardo_master = get_pardo_master()
      nclusters     = my_company_size / cluster_size
      if (nclusters * cluster_size .lt. my_company_size)
     *   nclusters = nclusters + 1
      nbatch       = max_batch / nclusters
      ndiff        = max_batch - nbatch * nclusters
      my_cluster   = pardo_master / cluster_size 
      start_batch  = my_cluster * nbatch + 1
      if (ndiff .gt. 0) then
         if (my_cluster .lt. ndiff) then
            nbatch = nbatch + 1
            start_batch = start_batch + my_cluster  
         else
            start_batch = start_batch + ndiff
         endif
      endif

      end_batch = start_batch + nbatch - 1 
      return
      end

      subroutine lb_set_loop_incr_mapping(raw_indx, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      ind, bseg, eseg, nind,
     *                      max_batch)
c--------------------------------------------------------------------------
c   Defines a new parallel mapping of the loop indices in array "ind", 
c   based on the index_table.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'where_table.h'
      include 'batch_table.h'
      include 'parallel_info.h'
      include 'trace.h'

      integer raw_indx(mx_array_index)
      integer indx(mx_array_index)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer nsegment_table
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer i, j, nind, bseg(mx_array_index),eseg(mx_array_index)
      integer ind(mx_array_index)
      integer max_batch
      integer superseg, superindex

      integer seg(mx_array_index)
      integer count, ncomb
      logical check_where_conditions
      logical subrange_flag(mx_array_index)

c--------------------------------------------------------------------------
c   Count the number of indices, determine number of segments.
c--------------------------------------------------------------------------

      nind = 0
      do i = 1, mx_array_index
         if (raw_indx(i) .ne. 0) then
            call get_loop_index(raw_indx(i), indx(i), subrange_flag(i))

            nind = nind + 1
            ind(nind) = indx(i)

            if (subrange_flag(i)) then

c---------------------------------------------------------------------------
c   Find the superindex and its current segment (superseg).
c---------------------------------------------------------------------------

               superindex = index_table(c_subindex_ptr,ind(nind))
               superseg   = index_table(c_current_seg,superindex)
               if (superseg .eq. undefined_segment) then
                  print *,'Error: Pardo at line ',current_line,
     *              ' superindex ',superindex,' is not in scope.' 
                  call abort_job()
               endif
  
c--------------------------------------------------------------------------
c   Find the segment_table entry for superseg.
c--------------------------------------------------------------------------

               do j = 1, nsegment_table
                  if (segment_table(c_index,j) .eq. superindex .and.
     *                segment_table(c_segment,j) .eq. superseg) then
                     bseg(nind) = segment_table(c_subseg1,j)
                     eseg(nind) = segment_table(c_subseg2,j)
                     go to 50
                  endif 
               enddo
   50          continue
            else
               eseg(nind) = index_table(c_eseg, indx(i))
               bseg(nind) = index_table(c_bseg, indx(i))
            endif
         endif
      enddo

      if (max_batch .eq. -1) return

c--------------------------------------------------------------------------
c   Determine the max. number of batches to process.
c--------------------------------------------------------------------------

      ncomb = 1
      do i = 1, nind
         ncomb = ncomb * (eseg(i)-bseg(i)+1)
      enddo

      if (nwhere .eq. 0) then

c---------------------------------------------------------------------------
c   No WHERE conditions are applied, simply multiply the ranges of all the 
c   indices together.
c---------------------------------------------------------------------------

         max_batch = ncomb
      else

c---------------------------------------------------------------------------
c   When we have WHERE conditions, we must count the number of valid 
c   combinations of indices.
c---------------------------------------------------------------------------

         do i = 2, nind
            seg(i) = bseg(i)
         enddo
         seg(1) = bseg(1) - 1

         max_batch = 0
         do count = 1, ncomb
            do i = 1, nind
               seg(i) = seg(i) + 1
               if (seg(i) .le. eseg(i)) then
                  go to 100
               else
                  seg(i) = bseg(i)
               endif
            enddo

  100       continue

c---------------------------------------------------------------------------
c   Check the combination for valid WHERE conditions.
c---------------------------------------------------------------------------

            if (check_where_conditions(ind, seg, nind, 
     *                                 index_table, nindex_table)) 
     *            max_batch = max_batch + 1
         enddo
      endif

c---------------------------------------------------------------------------
c   Initialize the batch_table.
c---------------------------------------------------------------------------

      last_batch_processed = max_batch + 1   ! force start at 1.
      return
      end

      subroutine lb_get_next_loop_set(next_batch, ind, nind,
     *                                index_table, nindex_table,
     *                                bseg, eseg, seg)
      implicit none
      include 'maxdim.h'
      include 'where_table.h'
      include 'batch_table.h'
 
      integer next_batch, nind
      integer nindex_table
      integer index_table(*)
      integer ind(nind), bseg(nind), eseg(nind)
      integer seg(nind)

      integer i
      integer count
      integer istart
      
      logical check_where_conditions

c--------------------------------------------------------------------------
c   Convert the batch index into segment indices.
c--------------------------------------------------------------------------

      if (last_batch_processed .gt. next_batch .or.
     *    last_batch_processed .le. 0) then

c--------------------------------------------------------------------------
c   Start at batch number 1.
c--------------------------------------------------------------------------

         istart = 1
         do i = 2, nind
            seg(i) = bseg(i)
         enddo
         seg(1) = bseg(1) - 1
      else

c---------------------------------------------------------------------------
c   Start at batch number 'last_batch'
c---------------------------------------------------------------------------

         istart = last_batch_processed+1
         do i = 1, nind
            seg(i) = save_batch(i)
         enddo  
      endif

      do count = istart, next_batch
   50    continue      
         do i = 1, nind
            seg(i) = seg(i) + 1 
            if (seg(i) .le. eseg(i)) then
               go to 100
            else
               seg(i) = bseg(i) 
            endif
         enddo

  100    continue

c--------------------------------------------------------------------------
c   If there are any "where" conditions, make sure they are satisfied.
c--------------------------------------------------------------------------

         if (nwhere .gt. 0) then
            if (.not. check_where_conditions(ind, seg, nind,
     *                                 index_table, nindex_table))
     *            go to 50
         endif

      enddo 

      return
      end

      SUBROUTINE DUMPCORD(NATOMS,Q,IATNUM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C cbchar.com : begin
C
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(MAXREDUNCO),
     &                PARNAM(MAXREDUNCO)

C cbchar.com : end


      DIMENSION Q(3*NATOMS),IATNUM(NATOMS)
      ATOB = 0.529177249D0
      WRITE(6,100)
      WRITE(6,101)
      WRITE(6,100)
100   FORMAT(T2,64('-'))
101   FORMAT(T2,'Z-matrix',T13,'Atomic',T31,'C o o r d i n a t e s',
     &       /,
     &       T3,'Symbol',T13,'Number',T30,'X',T45,'Y',T60,'Z')
      IOFF=1
      DO 10 I=1,NATOMS
       LAST=linblnk(ZSYM(I))
       WRITE(6,1000)ZSYM(I)(1:LAST),IATNUM(I),(Q(J)*ATOB,
     &              J=IOFF,IOFF+2)
       IOFF=IOFF+3
10    CONTINUE
      WRITE(6,100)
1000  FORMAT(T6,A,T14,I3,T22,F14.8,T37,F14.8,T52,F14.8)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*
************************************************************************
*
      DOUBLE PRECISION FUNCTION DLAMC3( A, B )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   A, B
*     ..
*
*  Purpose
*  =======
*
*  DLAMC3  is intended to force  A  and  B  to be stored prior to doing
*  the addition of  A  and  B ,  for use in situations where optimizers
*  might hold one of these in a register.
*
*  Arguments
*  =========
*
*  A, B    (input) DOUBLE PRECISION
*          The values A and B.
*
* =====================================================================
*
*     .. Executable Statements ..
*
      DLAMC3 = A + B
*
      RETURN
*
*     End of DLAMC3
*
      END

      subroutine rdbasis(
     &     lumol, natm, compnorb, comppopv, compmemb,
     &     nprm, maxshl, nangatm, nshlatm, nshlatm1)
c
c This routine reads VMOL's MOL file to get the following information
c about the atomic basis: NPRM - total number of primitives; MAXSHL -
c the largest number of shells per atom; NSHLATM (NATM)- the number of
c shells for each atom.
c
c These parameters are necessary to allocate memory for the primitive
c exponents and coefficients. After memory is allocated, the loop over
c the MOL file will be repeated to actually read the exponents and
c coefficients.
c
c This routine is a slightly modified copy of LIBRA3/A3BASIS, which in
c turn is a copy of Nevin Oliphant's HFDFT/BASIS routine.
c
c Igor Schweigert, Aug 2003
c $Id: rdbasis.F,v 1.1 2004/12/21 17:41:15 igor Exp $
c
      implicit none
c
c     Arguments.
c     
      integer
     &     lumol, natm, compnorb, compmemb (compnorb), comppopv (natm),
     &  nprm, maxshl, nangatm (natm), nshlatm (natm),nshlatm1 (natm),
     &  ii
c
c     Local variables.
c     
      integer
     &     memb, iorb, ishl, iang, nang, isub, nsub (99),
     &     iprm, iaos, i, nline, ishl1
c     
      character*80 line

c
c     Initialize accumulative quantities to zeros.
c     
      nprm = 0
      maxshl = 0
c
c     Rewind the MOL file and skip the first 5 lines
c     
      rewind(lumol)
      read(lumol,'(a)') line
      read(lumol,'(a)') line
      read(lumol,'(a)') line
      read(lumol,'(a)') line
      read(lumol,'(a)') line
c
c     Loop over symmetry unique atoms. For each unique atom:
c      1/ read number of different angular momenta, and the number of lines
c         describing each angular momentum;
c      2/ loop over angular momentum, and over all lines describing it in order
c         to accumulate the number of shells per atom, and the total number of 
c         primitives (note that the latter is multiplied by the number of
c         symmetry identical atoms corresponding to current symm. unique atom)
c      3/ update the largest number of shells per atom
c      4/ copy the number of shells to to all symmetry identical atoms corresponding
c         to the current symmetry unique atom and shift MEMB by number of symm.
c         identical atoms, COMPPOPV
c
c     Note that in the begging of the loop over symmetry unique atoms
c     (orbits), MEMB points at the first atoms in the block of symmetry
c     identical atoms in COMPMEMB. After the info is copied to all
c     symm. ident. atoms, MEMB is iterated by the current COMPPOPV.
c     
      memb = 1
      do iorb=1, compnorb
c     
         read(lumol, '(a25,12i5)')
     &        line, nang, (nsub(iang), iang=1, nang)
         read(lumol, '(a)') line
c     
         ishl = 0
         ishl1 = 0
         do iang = 1, nang
            ishl = ishl + iang*(iang+1)/2
            ishl1 = ishl1+1
c     
            do isub=1, nsub(iang)
c     
               read(lumol,'(2i5)') iprm, iaos
               nprm = nprm + iprm*iang*(iang+1)/2*comppopv (iorb)
c     
               nline = (iaos-3)/4
               if ((iaos-3).gt.(nline*4)) nline = nline + 1
               nline = (nline+1) * iprm
               do i=1, nline
                  read(lumol,'(a)') line
               end do
c
            end do
         end do
c     
         if (ishl .gt. maxshl) maxshl = ishl
c     
         do i = 1, comppopv (iorb)
            nangatm (compmemb (memb+i-1)) = nang
            nshlatm (compmemb (memb+i-1)) = ishl
            nshlatm1 (compmemb (memb+i-1)) = ishl1
         end do
         memb = memb + comppopv (iorb)
c     
      end do
c 
c      do ii=1,natm
c      write(6,*) nshlatm1 (ii), ii
c      enddo
c      write(6,*) '-----------------------'


    
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
#include "flags.h" /* for h_IFLAGS_* and h_IFLAGS2_* */
      SUBROUTINE RETRIEVE(E, V1,V2,STEP,VEC)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "fnamelen.par"
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
      LOGICAL XYZIN, NWFINDIF
      CHARACTER*(fnamelen) FNAME
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $        ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $        XYZTol
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      Common /Orient/ Orient(3,3)
      CHARACTER*10 CRAP,CRAP2
      DIMENSION V1(NXM6),V2(NXM6*NXM6),STEP(NXM6),VEC(NOPT)
      INTEGER    LuArc
      PARAMETER (LuArc  = 77)
      CHARACTER*(*) ArcFil
      PARAMETER    (ArcFil = 'OPTARC ')
#include "io_units.par"
      DATA CRAP /'***CYCLE  '/
C
      IF( ncycle .NE. 0 )WRITE(6,933)
933   FORMAT(T3,' Retrieving information from last optimization cycle.')
      CALL GFNAME(ARCFIL,FNAME,ILENGTH)
      OPEN(UNIT=LuArc,FILE=fname(1:ilength),STATUS='OLD',
     &     FORM='UNFORMATTED')
C
C NUMBER OF RECORDS IN .OPT IS ONE GREATER THAN THE NUMBER OF
C  OPTIMIZATION CYCLES.
C
      DO 101 K=1,nCYCLE
         READ(LuArc)CRAP2
         IF(CRAP2.NE.CRAP)then
            Write (LuErr,*) ' *Problem with optimization archive file.'
            Call ErrEx
         EndIf
 101  Continue
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "Start Reading Archive file NXM6: ", NXM6
#endif
C
      READ(LuArc)CRAP2,iarchx,ICYCLE,NATOMS,NX,NUNIQUE,NOPT,IPRNT,INR,
     $     IVEC,
     $ IDIE,IMXSTP,ISTCRT,IVIB,ICURVY,ICONTL,IRECAL,INTTYP,IDISFD,
     $ IGRDFD,ICNTYP,ISYM,IBASIS,E,
     $   (V1(I),I=1,NXM6),
     $   (V2(I),I=1,NXM6*NXM6),(STEP(J),J=1,NXM6),(R(J),J=1,NXM6),
     $   (Q(J),J=1,NX),(NCON(I),I=1,NX),(ZSYM(I),I=1,NATOMS),
     &   (VARNAM(I),I=1,NX),(PARNAM(I),I=1,NX),(ISQUASH(J),J=1,NXM6),
     &   (IATNUM(I),I=1,NATOMS),(ATMASS(I),I=1,NATOMS),
     $   (IUNIQUE(J),J=1,NUNIQUE),(NEQ(J),J=1,NXM6),
     $   ((IEQUIV(I,J),J=1,NEQ(IUNIQUE(I))),I=1,NUNIQUE),
     &   (NOPTI(J),J=1,NOPT), (VEC(J),J=1,NOPT),FPGRP,BPGRP,PGRP,
     $   ((ORIENT(I,J),J=1,3),I=1,3)
         IF(CRAP2.NE.CRAP)then
            Write (LuErr,*) ' *Problem with optimization archive file.'
            Call ErrEx
         EndIf
C
#ifdef _DEBUG_LVL0
      Print*, "The COORD COMMON BLOCK AT RETRIEVE BEFORE DECOMPRESS"
      Write(6, "(3F10.5)") (Q (I), I= 1, 3*NATOMS)
      Write(6,*)
      Write(6, "(3F10.5)") (R(I), I= 1, NXM6)
#endif

C
C DECOMPRESS INTERNAL COORINATE VECTOR
C
      XYZIN = IFLAGS(h_IFLAGS_coordinates) .GT. 0
C
      IF (.NOT. XYZIN) THEN 
         DO J=NX,10,-1
            R(J)=R(J-6)
         ENDDO 
         R(8)=R(3)
         R(7)=R(2)
         R(4)=R(1)
         R(1)=0.D0
         R(2)=0.D0
         R(3)=0.D0
         R(5)=0.D0
         R(6)=0.D0
         R(9)=0.D0
       ENDIF
C
#ifdef _DEBUG_LVL0
      Print*, "The COORD COMMON BLOCK AT RETRIEVE"
      Write(6, "(3F10.5)") (Q (I), I= 1, 3*NATOMS)
      Write(6,*)
      Write(6, "(3F10.5)") (R(I), I= 1, NXM6)
#endif

C
      CLOSE(77,STATUS='KEEP')
      RETURN
      END

#include "flags.h"
      Subroutine a2write_wfn(Wfn, Nangmom, Alpha, Nprim_4shl, 
     &                       Iangmom, IShell_4atm, Itype, Icent, 
     &                       Eigvals, Occnm, Iorder, Scr, Coord,
     &                       Maxocc, Nshls, Itot_prim, Nbfns,
     &                       Nreal_atoms, Iatmchrg, Iunit, Iuhf,
     &                       Iwrite_H, Iwrite_T, Ekin)
      
      Implicit Double Precision (A-H, O-Z)
C
#include "machsp.com"
#include "jodaflags.com"
C
      Character*2 Atmlab(103)
      Character*11 Method(45)
      Character*4 Ref 
      Logical Iwrite_H, Iwrite_T
      
      Character Title(10)
      Integer Angmom

      Dimension Coord(3*Nreal_atoms), Iatmchrg(Nreal_atoms),
     &          Wfn(Itot_prim, Nbfns), Nprim_4shl(Nreal_atoms*NShls),
     &          Alpha(Itot_prim), Nangmom(Nreal_atoms), 
     &          Itype(Itot_prim), Iangmom(Nreal_atoms*Nshls), 
     &          IShell_4atm(Nreal_atoms), Icent(Itot_prim),
     &          Eigvals(Nbfns), Occnm(Nbfns), Iorder(Itot_prim),
     &          Scr(Itot_prim)
C 
      Data (Atmlab(i),i=1,103)
     & /'H ','HE',
     & 'LI','BE','B ','C ','N ','O ','F ','NE',
     & 'NA','MG','AL','SI','P ','S ','CL','AR',
     & 'K ','CA',
     & 'SC','TI','V ','CR','MN','FE','CO','NI','CU','ZN',
     & 'GA','GE','AS','SE','BR','KR',
     & 'RB','SR',
     & 'Y ','ZR','NB','MO','TC','RU','RH','PD','AG','CD',
     & 'IN','SN','SB','TE','I ','XE',
     & 'CS','BA','LA',
     & 'CE','PR','ND','PM','SM','EU','GD',
     & 'TB','DY','HO','ER','TM','YB','LU',
     & 'HF','TA','W ','RE','OS','IR','PT','AU','HG',
     & 'TL','PB','BI','PO','AT','RN',
     & 'FR','RA','AC',
     & 'TH','PA','U ','NP','PU','AM','CM',
     & 'BK','CF','ES','FM','MD','NO','LR'/
C
      Data (Method(I), i=1, 45)/
     &  "SCF",          "MBPT(2)",      "MBPT(3)",      "SDQ-MBPT(4)",
     &  "MBPT(4)",      "LCCD",         "LCCSD",        "UCCSD(4)",
     &  "CCD",          "UCC(4)",       "CCSD",         "CCSD[T]",
     &  "CCSD+TQ*",     "CCSDT-1",      "CCSDT-1b",     "CCSDT-2",
     &  "CCSDT-3",      "CCSDT-4",      "CCSDT",        "LCCSDT",
     &  "CCD+ST(CCD)",  "QCISD(T)",     "CCSD(T)",      "QCISD",
     &  "CID",          "CISD",         "QCISD(TQ)",    "CCSD(TQ)",
     &  "CCSD+TQ",      "CCSDT+Q*",     "CCSDT+Q",      "CC5SD(T)",
     &  "CCSD-T",       "CC3",          "CCSDT-T1T2",   "CCSDTQ-1",
     &  "CCSDTQF-1",    "CCSDTQ-2",     "CCSDTQ-3",     "CCSDTQ",
     &  "ACCSD",        "HFDFT",        "ACCSD(T)",     "CCSD(TQf)",
     &  "CCSDT(Qf)" /
C    
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6, "(a)") "The number of functions on each atom"
      Write(6, "(4(1x,I3))") (Nangmom(I), I=1, Nreal_atoms)
      Write(6,*)
      Write(6, "(a)") "The number of prim. functions on each atom"
      Do I =1, Nreal_atoms
      Write(6, "(4(1x,I3))") (NPrim_4shl(ioff+J),J=1,IShell_4atm(I))
      ioff = ioff + IShell_4atm(I)
      Enddo 
      Write(6,*) 
      Write(6,*) "The number of shells per atom"
      Write(6, "(4(1x,I3))") (IShell_4atm(I), I=1, Nreal_atoms)
      Write(6,*) 
      Write(6,*) "The shell angular momentum per atom s=1,p=3,d=6,,"
      Ioff = 0 
      Do I= 1, Nreal_atoms
      Write(6, "(4(1x,I3))") (Iangmom(ioff + J), J=1,IShell_4atm(I))
      ioff = ioff + IShell_4atm(I)
      Enddo
      Write(6,*)
      Write(6, "(3F10.5)"), (coord(i), i=1,3*Nreal_atoms)
      Write(*,*)
#endif
#ifdef _OLD_G
      Call Built_Reord_Vec(Nreal_atoms, Nprim_4shl, Iangmom,
     &                     IShell_4atm, Itot_prim, Nshls, Iorder)

      Call reord_vecs(Alpha, Scr, Iorder, Itot_prim, .True.)
      Call reord_vecs(Eigvals, Scr, Iorder, Itot_prim, .True.)
C
      Do Iorbs = 1, Nbfns
         Call reord_vecs(Wfn(1,Iorbs), Scr, Iorder, Itot_prim, .True.)
      Enddo
#endif

      Ioff = 0
      Ifun = 0
      Do Iatms = 1, Nreal_atoms
         Do Ishl = 1, IShell_4atm(Iatms)
            Angmom = Iangmom(Ifun+Ishl)
            Nconfs = Nprim_4shl(Ifun+Ishl)
            If (Angmom .Eq. 1)  Then
                Imin = 1
                Imax = 1
            Elseif (Angmom .Eq. 3) Then
                Imin = 2
                Imax = 4
            Elseif (Angmom .Eq. 6) Then
                Imin = 5
                Imax = 10
            Elseif (Angmom .Eq. 10) Then
                Imin = 11 
                Imax = 20
            Elseif (Angmom .Eq. 15) Then
                Imin = 21 
                Imax = 35
            Elseif (Angmom .Eq. 21) Then
                Imin = 36
                Imax = 56
            Elseif (Angmom .Eq. 36) Then
                Imin = 57
                Imax = 84
            Elseif (Angmom .Gt. 36) Then
                Write(6, "(a)") "The WFN file is only available",
     &                          " for up to L angular momentum" 
                Call Errex
            Endif
  
            Do Iang = Imin, Imax
               Do Nfuncs = 1, Nconfs
                  Ioff = Ioff + 1
                  Itype(Ioff) = Iang
                  Icent(Ioff) = Iatms
               Enddo 
            Enddo
         Enddo
         Ifun = Ifun + IShell_4atm(Iatms)
      Enddo
C           
      If (Iwrite_H) Then
         Write(Iunit, "(a,a)") "----Input file for quantum ",
     &                         "topology analysis----"
C
         Write(IUnit, 100) Maxocc, Itot_prim, Nreal_atoms
  100    Format('GAUSSIAN',10x,I5,' MOL ORBITALS',1x,I6,
     &          ' PRIMITIVES', 4x,I5,' NUCLEI')

         Ioff = 0
         Do Iatms = 1, Nreal_atoms
             Write(Iunit, 110)  Atmlab(Iatmchrg(Iatms)), Iatms, 
     &                          Iatms, (Coord(J+ioff), J=1,3), 
     &                          Dble(Iatmchrg(Iatms))
             Ioff = Ioff + 3
         Enddo
C       
  110    Format(a4,i4,4x,'(CENTRE',i3,')',1x,3f12.8, 
     &          '  CHARGE =',f5.1)
C
         Write(Iunit, 120) (Icent(I), I = 1, Itot_prim)
         Write(Iunit, 130) (Itype(I), I = 1, Itot_prim)
         Write(Iunit, 140) (Alpha(I), I = 1, Itot_prim)

  120    Format('CENTRE ASSIGNMENTS',2x,20i3)
  130    Format('TYPE ASSIGNMENTS',4x,20i3)
  140    Format('EXPONENTS',1x,1p,5e14.7)
      Endif
     
      Do Iorb = 1, Maxocc
         Write(Iunit, 150) Iorb, Occnm(Iorb), Eigvals(Iorb)
         Write(Iunit, 160) (Wfn(Iprim, Iorb), Iprim =1, Itot_prim)
      Enddo 

  150 Format('MO  ',i3,19x,'OCC NO =',f13.7,'  ORB. ENERGY = ',f12.7 )
  160 Format(1p,5e16.8)
  
      If (Iwrite_T) Then
         Write(Iunit, "(a)") "END DATA"
C
         Call Getrec(20, "JOBARC", 'SCFENEG ', Iintfp, Escf)
         Call Getrec(20, "JOBARC", 'TOTENERG', Iintfp, Etot)
         Vir     = 0.0D0
C
         Imethod = Iflags(h_IFLAGS_calc) + 1
         Iref    = Iflags(h_IFLAGS_ref)
         If (Iref .Eq. 0) Then
            Ref = "RHF"
         Elseif (Iref .Eq. 1) Then
            Ref = "UHF"
         Elseif (Iref .Eq. 2) Then
            Ref = "ROHF"
         Endif 
         Epot = Etot - Ekin 
         If (Ekin .Ne. 0.0D0) Vir = Dabs(Epot/Ekin)
CSSS         Write(Iunit, 170) Ref, Method(Imethod), Etot, Vir
CSSS  170    Format(a4,1x,a11,' ENERGY =',f15.10,' VIRIAL(-V/T)  =',f13.8)
         Write(Iunit, 170) Ref, Method(1), Escf, Vir
  170 Format(a4,1x,a3,' ENERGY =',f20.12,' THE VIRIAL(-V/T)=',f13.8)
C
         Write(Iunit, "(a,a)") "----End of input file for quantum ",
     &                         "topology analysis----"
      Endif
C
      Return
      End

      SUBROUTINE PROCESTEP_XYZ(SCRATCH, AMATRX, TOTREDNCO)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL CONVERGED, CHANGED, NO_ITER
      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG
      DOUBLE PRECISION ORIENT(3,3)
      PARAMETER (MAXITER = 100)
C
#include "mxatms.par"
#include "machsp.com"
#include "flags.h"
#include "flags.com"
#include "flags2.com"
#include "coord.com"
C
      PARAMETER (EPSILON = 1.0D-5)
      CHARACTER*80 HOLDQ
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION SCRATCH(9*NATOMS*NATOMS), IQFIX(3*MXATMS, 3*MXATMS),
     &          AMATRX(3*NATOMS*TOTREDNCO), STATS(6), 
     &          REDUNCO(MAXREDUNCO), SCRATCH_LCL(4*MAXREDUNCO+6*
     &          MXATMS+15*MXATMS),
     &          TMP1(MAXREDUNCO*MAXREDUNCO),TMP2(MAXREDUNCO)
C
      DATA BTOA /0.529177249D0/

      DO I = 1, NUNIQUE
         DO J = 1, NEQ(IUNIQUE(I))
            IQFIX(IUNIQUE(I), J) = IEQUIV(I,J)
         ENDDO
      ENDDO
C
      DO J = 1, NOPT
C
         SCRATCH_LCL(NOPTI(J)) = SCRATCH(J + NOPT)
         SCRATCH_LCL(NOPT + NOPTI(J)) = SCRATCH(J + NOPT)
C
         DO K = 1, NEQ(NOPTI(J))
            SCRATCH_LCL(IQFIX(NOPTI(J), K)) = SCRATCH(J + NOPT)
           SCRATCH_LCL(NOPT + IQFIX(NOPTI(J), K)) = SCRATCH(J + NOPT)  
         ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      WRITE(6,*) "The optimization parameters:nx, nopt, totrednco nxm6",
     &            nx, totrednco, nopt, nxm6
      Write(6,*)
      WRITE(6,*) "The delta q0"
      Write(6,*)
      WRITE(6,10) (SCRATCH_LCL(I), I = 1, TOTREDNCO)
      Write(6,*) "The The rnew (q1)"
      WRITE(6,10) (R(I), I = 1, TOTREDNCO)
   10 Format (5(1X,F10.6))
      Write(6,*)
#endif
C
      IOFF4q0  = 3*NATOMS + 3*TOTREDNCO
      IOFF4X0  = IOFF4q0  + TOTREDNCO
C
      ISCRATCH = 4*TOTREDNCO + 6*NATOMS 
      ITMPQ    = ISCRATCH    + 9*NATOMS
      INEWQ    = ITMPQ       + 3*NATOMS
      ILAST    = INEWQ       + 3*NATOMS
C
      CALL DAXPY(TOTREDNCO, -1.0D0, SCRATCH_LCL, 1, R, 1)
      CALL DCOPY(TOTREDNCO, R, 1, SCRATCH_LCL(2*TOTREDNCO + 1), 1)
      CALL DCOPY(TOTREDNCO, SCRATCH_LCL, 1, SCRATCH_LCL(IOFF4q0 + 1),
     &           1)
      CALL DCOPY(3*NATOMS, Q, 1, SCRATCH_LCL(IOFF4X0 + 1), 1)

C#ifdef _TEST_RED
C This requires defining TMP1 and TMP2 arrays.
      CALL GETREC(20,'JOBARC','NUMREDCO', 1, NULLEVAL)
      CALL GETREC(20,'JOBARC','REDEVECS',NULLEVAL*TOTREDNCO*IINTFP,
     &            TMP1)
      CALL XGEMM('T', 'N', NULLEVAL, 1, TOTREDNCO, 1.0D0,
     &               TMP1, TOTREDNCO, SCRATCH_LCL, TOTREDNCO,
     &               0.0D0, TMP2, NULLEVAL)
      Write(6,*) "Check for the redundencies in deltaq0"
      Write(6,"(6F13.7)") (tmp2(i), i=1, NULLEVAL)
C#endif
C
#ifdef _DEBUG_LVLM1
      WRITE(6,*) "The starting Cartesian coords. x0"
      Write(6,*)
      CALL OUTPUT(Q, 1, 3, 1, Natoms, 3, Natoms, 1)
      Write(6,*) 
      Write(6,*) "The starting RICs  (q0)"
      Write(6,*) 
      WRITE(6,10) (SCRATCH_LCL(2*TOTREDNCO + I), I=1, TOTREDNCO)
      Write(6,*)
#endif
C     
      CONVERGED = .FALSE. 
        CHANGED = .FALSE.
        NO_ITER = .FALSE.
          NITER = 0 
C
      DO WHILE (.NOT. CONVERGED .AND. NITER .LE. MAXITER .AND.
     &          .NOT. CHANGED .AND. .NOT. NO_ITER) 
C
         CALL DCOPY(3*NATOMS, Q, 1, SCRATCH_LCL(3*TOTREDNCO + 1), 1)
#ifdef _DEBUG_LVL0
         Write(6,*)
CSSS         Write(6,*) "The A matrix"
CSSS         CALL OUTPUT(AMATRX, 1, 3*NATOMS, 1, TOTREDNCO, 3*NATOMS,
CSSS     &               TOTREDNCO, 1) 
         WRITE(6,*) "The starting Cartesian during iteration; x_K"
         CALL OUTPUT(Q, 1, 3, 1, Natoms,3, Natoms, 1)
         Write(6,*)
         Write(6,*) "The starting internal increments:delta q_k"
         Write(6,*) 
         WRITE(6,10) (SCRATCH_LCL(I), I=1, TOTREDNCO)
         Write(6,*)
#endif
         CALL XGEMM('N', 'N', 3*NATOMS, 1, TOTREDNCO, 1.0D0,
     &               AMATRX, 3*NATOMS, SCRATCH_LCL, TOTREDNCO,
     &               1.0D0, Q, 3*NATOMS)
C
CSSS         CALL GETREC(20,'JOBARC','ORIENT2 ',9*IINTFP,ORIENT)
CSSS         CALL XGEMM('T', 'N', 3, NATOMS, 3, 1.0D0, ORIENT, 3, Q,
CSSS     &               3, 0.0D0, SCRATCH_LCL(INEWQ), 3)
CSSS         CALL  DCOPY(3*NATOMS, SCRATCH_LCL(INEWQ), 1, Q, 1)
C
#ifdef _DEBUG_LVL0
         Print*, "The Cartesian after the update: x_k+1"
         CALL OUTPUT(Q, 1, 3, 1, Natoms,3, Natoms, 1)
#endif
         CALL GEN_NEW_RIC(Q, REDUNCO, IATNUM, NATOMS, TOTNOFBND,
     &                    NW_TOTREDNCO, TOTNOFANG, .FALSE.)
C
         IF (IFLAGS(h_IFLAGS_symmetry).EQ. 2) THEN
            CALL GETREC(20,'JOBARC','PLSMINSP',NW_TOTREDNCO,NCON)  
            DO ICOORD = 1, NW_TOTREDNCO
               IF (NCON(ICOORD).EQ.1) REDUNCO(ICOORD) = -REDUNCO(ICOORD)
            END DO
         END IF
C
C In rare cases, it is possible that the # of RIC coordinates
C can change. If that happens leave the iterative procedure and
C and use the linear update.
C
         IF (NW_TOTREDNCO .GT. TOTREDNCO) CHANGED = .TRUE.
         CALL CHECK4_180(SCRATCH_LCL(2*TOTREDNCO + 1), SCRATCH_LCL,
     &                   TOTNOFBND, TOTNOFANG, TOTREDNCO, NO_ITER)
C        
#ifdef _DEBUG_LVLM1
      Write(6,*)
      WRITE(6,*) "The new q: q_k+1"
      Write(6,*)
      WRITE(6,10) (REDUNCO(I), I = 1, TOTREDNCO)
      Write(6,*) 
      WRITE(6,*) "The strating q: q0 (should not change)"
      Write(6,*)
      WRITE(6,10) (SCRATCH_LCL(2*TOTREDNCO+I), I = 1, TOTREDNCO)
      Write(6,*)
#endif
C
         CALL DCOPY(TOTREDNCO, REDUNCO, 1, R, 1)
         CALL DAXPY(TOTREDNCO, -1.0D0, SCRATCH_LCL(2*TOTREDNCO + 1),
     &              1, R, 1)
#ifdef _DEBUG_LVLM1 
      WRITE(6,*) "The (q_k - q0)"
      Write(6,*)
      WRITE(6,10) (R(I), I = 1, TOTREDNCO)
      Write(6,*)
      Write(6,*) "The delta q0 (should not change)" 
      Write(6,*)
      write(6,10) (SCRATCH_LCL(IOFF4q0 + I), I=1, TOTREDNCO)
      Write(6,*)
#endif
         CALL DCOPY(TOTREDNCO, SCRATCH_LCL(IOFF4q0 + 1), 1, 
     &              SCRATCH_LCL, 1)
         CALL DAXPY(TOTREDNCO, -1.0D0, R, 1, SCRATCH_LCL, 1)
C
#ifdef _DEBUG_LVL0
      WRITE(6,*) "The delta delta q_k" 
      Write(6,*)
      WRITE(6,10) (SCRATCH_LCL(I), I=1, TOTREDNCO)
      Write(6,*)
#endif
         CALL REMOVE_360(SCRATCH_LCL, TOTNOFBND, TOTNOFANG, 
     &                   TOTREDNCO)
C
         DO IREDUNCO = 1, TOTREDNCO
            IF (DABS(SCRATCH_LCL(IREDUNCO)) .LT. 1.0D-10) SCRATCH_LCL
     &          (IREDUNCO) = 0.0D0
         ENDDo
   
         IF (NITER .GE. 0) CALL VSTAT(SCRATCH_LCL, STATS, TOTREDNCO)
         IF (NITER .EQ. 0) THEN
             RMSOF_DDQ1 = STATS(5)
         ELSE
C
#ifdef _DEBUG_LVLM1
      Write(6,"(a,2F13.9)"), "RMS RIC changes DDQ1,DDDQk:", 
     &     RMSOF_DDQ1, STATS(5)
#endif
CSSS             IF (STATS(5) .GE. RMSOF_DDQ1) NO_ITER = .TRUE.
             IF (STATS(5) .GE. RMSOF_DDQ1) NO_ITER = .FALSE.
         ENDIF
C
C#ifdef _TEST_RED
C This requires defining TMP1 and TMP2 arrays.
      CALL XGEMM('T', 'N', NULLEVAL, 1, TOTREDNCO, 1.0D0,
     &               TMP1, TOTREDNCO, SCRATCH_LCL, TOTREDNCO,
     &               0.0D0, TMP2, NULLEVAL)
      Write(6,*)
      Write(6,*) "Check for the redundencies in delta delta q_K"
      Write(6,"(6F13.7)") (tmp2(i), i=1, NULLEVAL)
C#endif
C
         CALL DAXPY(3*NATOMS, -1.0D0, Q, 1, SCRATCH_LCL
     &             (3*TOTREDNCO + 1), 1)
         CALL VSTAT(SCRATCH_LCL(3*TOTREDNCO+1), STATS, 3*NATOMS)
C
#ifdef _DEBUG_LVLM1
         Write(6,*)
         Write(6,*) "Change in Cartesians x_k+1 - x_k"
         CALL OUTPUT(SCRATCH_LCL(3*TOTREDNCO+1), 1, 3, 1, NATOMS,
     &               3, NATOMS, 1)
         Write(6,*) 
         Print*, "The root mean sq change of x:", STATS(5)
#endif
         IF (STATS(5)  .LE. EPSILON) CONVERGED = .TRUE.
         NITER = NITER + 1 

      ENDDO 
      IF (CONVERGED) Write(6, "(a,a,I2,a)") "Iterative update ",
     &                         "converged in ", NITER, " iterations."
C
C If the iterative procedure fail to converge in maximum iterations
C alowed, then do a simple linear update.
C
C#endif
C
      IF (.NOT. CONVERGED) THEN
         Write(6, "(a,a)") "Iterative update did not converged.",
     &                     " linear update is used. "
         CALL DCOPY(3*NATOMS, SCRATCH_LCL(IOFF4X0 +1), 1, Q, 1)
         CALL XGEMM('N', 'N', 3*NATOMS, 1, TOTREDNCO, 1.0D0,
     &              AMATRX, 3*NATOMS, SCRATCH_LCL(IOFF4q0 + 1), 
     &              TOTREDNCO, 1.0D0, Q, 3*NATOMS)
      ENDIF
C
C Lets screen the Cartesian coordiantes and filter out changes
C beyond 7th decimal.
C 
      DO IATOM = 1, 3*NATOMS
         WRITE(HOLDQ, "(F12.7)") Q(IATOM)
         READ(HOLDQ,  "(F12.7)") Q(IATOM)
      ENDDO 

#ifdef _DEBUG_LVL0
      Write(6,*)
      WRITE(6,*) "The new Cartesian Coord., x+delta x0"
      WRITE(6,"(3F13.9)") (Q(I), I = 1, 3*NATOMS)
#endif
C
      CALL GEN_NEW_RIC(Q, REDUNCO, IATNUM, NATOMS, TOTNOFBND,
     &                 NW_TOTREDNCO, TOTNOFANG, .TRUE.)

C
C Store the Cartesian coordinates with a different record label
C from COORD since finite difference calculations use COORD
C for the grid points, not the current point.
C

      CALL PUTREC(1,'JOBARC','COORD_OP',IINTFP*3*NATOMS,Q)
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine verify_aces2_params()
c----------------------------------------------------------------------------
c   Checks for valid combinations of parameters in the *ACES2 section.
c   If an invalid combination (i. e. not supported by ACESIII) is found,
c   an error message is printed and the job is aborted.
c----------------------------------------------------------------------------

      implicit none

      common /flags/ iflags
      common /flags2/ iflags2
      integer iflags(100)
      integer iflags2(500)

      integer vib, geom_opt, calc, opt_method, coords, init_hessian,
     *        hess_update, dropmo, ecp
      integer grad_calc

      call igetrec(1,'JOBARC','IFLAGS',100,iflags)
      call igetrec(1,'JOBARC','IFLAGS2',500,iflags2)

      vib      = iflags(54)
      geom_opt = iflags2(5)
      calc     = iflags(2)
      opt_method   = iflags(47)
      coords       = iflags(68)
      init_hessian = iflags2(8)
      hess_update  = iflags2(7)
      dropmo       = iflags(27)
      ecp          = iflags(71)
      grad_calc    = iflags2(138)

      if (vib .eq. 1 .and. geom_opt .gt. 0) then
         print *,'ERROR: ACESIII does not support VIB=FINDIF ',
     *           'with geometry optimization.'
         print *,'Either remove the geometry optimization ',
     *           'parameters or remove VIB_FINDIF'
         call abort_job()   
      endif

      if (vib .eq. 1 .and. dropmo .gt. 0) then
         print *,'ERROR: ACESIII does not support Hessian ',
     *           'calculations using DROPMO.'
         call abort_job()
      endif

      if (ecp .gt. 0) then
         print *,'Experimental ACESIII ECP calculations.'
c        print *,'ERROR: ACESIII does not support ECP calculations.'
c        call abort_job()
      endif

      if (grad_calc .eq. 2 .and. vib .eq. 1) then
         print *,'Error: GRAD_CALC = NUMERICAL and VIB = FINDIF'
         print *,'       Parameter inconsistency'
         call abort_job()
      endif
      return
      end    

      SUBROUTINE GRIDVAL(PCOORD,NPTS,PVAL,ITFCT,NBASP,
     $     ACOORD,NATOM,ALPHA,PCOEFFN,MOMFCT,MAXANG,
     $     NTANGM,NBAS,DENSN,DENSNCUB,ISFLAG,
     $     TMONCUB,PVAL2,IPCNT,APDX,APDY,
     $     APDZ,APDR,DENSNMAT,
     $     PCOEFSO,FINMO,FINSALC,IBIGLOOP,JBIGLOOP,IDORO,
     $     NORBOUTN)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION PCOORD((NPTS+1)*3)
      DIMENSION DENSNCUB(NPTS+1)
      DIMENSION PVAL(ITFCT*NBASP),PCOEFFN(ITFCT*NBASP)
      DIMENSION PVAL2(ITFCT*NBASP)
      DIMENSION ACOORD(3*NATOM)
      DIMENSION ALPHA(ITFCT)
      DIMENSION MOMFCT(NATOM*NTANGM)
      DIMENSION DENSN(NBASP*NBASP)
      DIMENSION DENSNMAT(NBASP,NBASP)
      DIMENSION TMONCUB((NPTS+1)*NBASP)
      DIMENSION IPCNT(NBAS)
      DIMENSION APDX(NATOM),APDY(NATOM),APDZ(NATOM),
     &   APDR(NATOM)
      DIMENSION PCOEFSO(ITFCT*NBASP)
      DIMENSION FINMO(NBASP),FINSALC(NBASP)
C     
      CALL ONED2TWOD(DENSN,DENSNMAT,NBASP,NBASP)
C Scroll over each point
      DO 10 KK=0,NPTS
C
C Evaluate the coefficient of each mo and sale at
C that point in the ao basis
         CALL ATPT(PCOORD,NPTS,KK+1,ACOORD,NATOM,ALPHA,
     $        PCOEFFN,MOMFCT,MAXANG,NTANGM,ITFCT,NBASP,PVAL,
     $        NBAS,PVAL2,IPCNT,APDX,APDY,
     $        APDZ,APDR,PCOEFSO,FINMO,FINSALC,IDORO,NORBOUTN)
C WRITE(*,*)
C
C IF (KK+l.EQ.1) THEN
C WRITE(*,*) "in gridval"
C DO 6 ILIST1=l,NORBOUTN
C WRITE(*,*) "FINMO(",ILIST1,")=",FINMO(ILIST1)
C 6 CONTINUE
C DO 7 ILIST2=1,NBASP
C WRITE(*,*) "FINSALC(~,ILIST2, n ) = ~ ~ FINSALC(ILIST2)
C 7 CONTINUE
C END IF
C
         IF (IDORO.NE.1) THEN
C Evaluate the density at this point
C
            DENSNCUB(KK+1)=0.0
            DO 40 IR=1,NBASP
               DO 50 IS=1,NBASP
                  DENSNCUB(KK+1)=DENSNCUB(KK+1)+(FINSALC(IR)*
     $                 FINSALC(IS)*DENSNMAT(IR,IS))
 50            CONTINUE
 40         CONTINUE
C
C IF (KK+l.EQ.1) THEN
C IF (ISFLAG.EQ.) THEN
C WRITE(*,*) "alpha density at point ",KK+1," = ",
C $ DENSNCUB(KK+1)
C WRITE(*,*)
C ELSE
C WRITE(*,*) "beta density at point ~,KK+1,~ = .,
C $ DENSNCUB(KK+1)
C WRITE(*,*)
C END IF
C END IF
         END IF
C
         IF (IDORO.NE.0) THEN
C Evaluate each MO Coeff. at this point
            DO 60 IMO=1,NORBOUTN
               TMONCUB(KK*NORBOUTN+IMO)=FINMO(IMO)
C
C IF (KK+l.EQ.l) THEN
C IF (ISFLAG.EQ.) THEN
C WRITE(*,*) "alpha #",IMO," at point ",KK+1," = ",
C $ TMONCUB(KK*NORBOUTN+IMO)
C WRITE(*,*)
C ELSE
C WRITE(*,*) ~beta #",IMO,~ at point ",KK+1," = ",
C $ TMONCUB(KK*NORBOUTN+IMO)
C WRITE(*,*)
C END IF
C END IF
 60         CONTINUE
         END IF
C
 10   CONTINUE
C
      RETURN
      END SUBROUTINE GRIDVAL

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine addrootindex(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c--------------------------------------------------------------------------
c  In this routine the first array is copied into the second.  
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex,nindex2, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index
      integer stack
      integer nsend 

      integer comm

      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(mx_array_index), findex(mx_array_index) 
      integer type(mx_array_index) 
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the first array: c_result_array 
c---------------------------------------------------------------------------

      array = op(c_result_array)
      nindex = array_table(c_nindex, array) 

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         sindex(i) = index 
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, fop1(i), fop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk1 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk1 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the second array: c_op1_array 
c---------------------------------------------------------------------------

      array = op(c_op1_array)
      nindex2 = array_table(c_nindex, array) 

      do i = 1, nindex2
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         findex(i) = index 
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, sop1(i), sop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk2 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk2 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c     write(6,*) ' ******************** ' 
c     write(6,*) ' OP1 :', (sindex(i), i=1,4) 
c     write(6,*) ' OP2 :', (findex(i), i=1,4) 

200   continue 

      nsend = 1 
      do i = 1, nindex  
         nsend = nsend*(sop2(i)-sop1(i)+1) 
      enddo 

c-----------One-index case----------------------------------
      if (nindex.eq.1) then
 
          if (nindex2.eq.2) then
      call do_addrootindex1(x(indblk1),sindex,fop1(1), fop2(1),
     &  x(indblk2),findex,sop1(1), sop2(1), sop1(2), sop2(2),nsend)
          endif 

          if (nindex2.eq.3) then  
      call do_addrootindex1_3(x(indblk1),sindex,fop1(1), fop2(1),
     &  x(indblk2),findex,sop1(1), sop2(1), sop1(2), sop2(2),
     &  sop1(3),sop2(3),nsend)
          endif 
           
      endif 
c----------Three-index case----------------------------------
      if (nindex.eq.3) then

          if (nindex2.eq.4) then 
      call do_addrootindex3(x(indblk1),sindex,fop1(1), fop2(1),
     &  fop1(2),fop2(2),fop1(3),fop2(3),
     &  x(indblk2),findex,sop1(1),sop2(1),sop1(2),sop2(2),
     &  sop1(3),sop2(3),sop1(4),sop2(4),nsend)
          endif

          if (nindex2.eq.5) then
      call do_addrootindex3_5(x(indblk1),sindex,fop1(1), fop2(1),
     &  fop1(2),fop2(2),fop1(3),fop2(3),
     &  x(indblk2),findex,sop1(1),sop2(1),sop1(2),sop2(2),
     &  sop1(3),sop2(3),sop1(4),sop2(4),sop1(5),sop2(5),nsend)
          endif     

      endif   

c----------Six-index case-------------------------------------
 
      if(nindex.eq.5) then

       if (nindex2.eq.6) then
       call do_addrootindex5_6(x(indblk1),sindex,fop1(1), fop2(1),
     &  fop1(2),fop2(2),fop1(3),fop2(3),fop1(4),fop2(4),fop1(5),fop2(5),
     &  x(indblk2),findex,sop1(1),sop2(1),sop1(2),sop2(2),
     &  sop1(3),sop2(3),sop1(4),sop2(4),sop1(5),sop2(5),
     &  sop1(6),sop2(6),nsend)
       endif 

      endif 
c----------------------------------------------------------

c      if (nindex .eq. 4) then 
c      call do_addrootindex4(x(indblk1), sindex, 
c     *                  fop1(1), fop2(1), fop1(2), fop2(2), 
c     *                  fop1(3), fop2(3), fop1(4), fop2(4),
c     *                  x(indblk2), findex,  
c     *                  sop1(1), sop2(1), sop1(2), sop2(2), 
c     *                  sop1(3), sop2(3), sop1(4), sop2(4), 
c     *                  nsend)
c      endif 

      return
      end

      subroutine do_addrootindex4(x, sindex, a1, a2, b1, b2, c1, 
     *                      c2, d1, d2,
     *                      y, findex, e1, e2, f1, f2, g1, g2, h1, h2, 
     *                      nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual copying. 
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index), 
     *        match(4) 

      integer i, j, k, a, b, c, d 
      integer m, n, lda, ldb, ldc 
      integer nsend, strip  

      double precision x(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision y(e1:e2,f1:f2,g1:g2,h1:h2)

      nsend = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1) 

      do d = d1, d2 
      do c = c1, c2 
      do b = b1, b2 
      do a = a1, a2 
         x(a,b,c,d) = y(a,b,c,d) 
      enddo 
      enddo 
      enddo 
      enddo 

c *********************************************************************************** 
c *********************************************************************************** 

      return
      end
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      subroutine do_addrootindex1(x, sindex, a1, a2, y, findex, e1, e2, 
     & f1, f2, nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual copying. 
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index),
     *        match(4)

      integer i, j, k, a, b, c, d
      integer m, n, lda, ldb, ldc
      integer nsend, strip

      double precision x(a1:a2)
      double precision y(a1:a2,f1:f2)

      nsend = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1)

c------------------------
           do b=f1,f2 
            do a=a1,a2
           y(a,b) = x(a)
           enddo  
          enddo
c------------------------

      return
      end    
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      subroutine do_addrootindex3(x, sindex, a1, a2, b1, b2, c1, c2, 
     *                      y, findex, e1, e2, f1, f2, g1, g2, h1, h2,
     *                      nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual copying. 
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index),
     *        match(4)

      integer i, j, k, a, b, c, d
      integer m, n, lda, ldb, ldc
      integer nsend, strip

      double precision x(a1:a2,b1:b2,c1:c2)
      double precision y(a1:a2,b1:b2,c1:c2,h1:h2)

c------------------------------------
      do d = h1, h2
      do c = c1, c2
      do b = b1, b2
      do a = a1, a2
      y(a,b,c,d) = x(a,b,c)
      enddo
      enddo
      enddo
      enddo
c------------------------------------

      return
      end
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      subroutine do_addrootindex1_3(x, sindex, a1, a2, y, findex, 
     & e1, e2, f1, f2, g1, g2, nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual copying. 
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index),
     *        match(4)

      integer i, j, k, a, b, c, d, g
      integer m, n, lda, ldb, ldc
      integer nsend, strip

      double precision x(a1:a2)
      double precision y(a1:a2,f1:f2,g1:g2)

      nsend = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1)

c------------------------
         do g=g1,g2
          do b=f1,f2
           do a=a1,a2
             y(a,b,g) = x(a)
           enddo
          enddo
         enddo 
c------------------------
      return
      end

c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

      subroutine do_addrootindex3_5(x, sindex, a1, a2, b1, b2, c1,
     *                      c2, y, findex, e1, e2, f1, f2, d1, d2, 
     *                      g1, g2, h1, h2,
     *                      nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual copying. 
c--------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer e1,e2,f1,f2,g1,g2,h1,h2
      integer sindex(mx_array_index), findex(mx_array_index),
     *        match(4)

      integer i, j, k, a, b, c, d, g, h
      integer m, n, lda, ldb, ldc
      integer nsend, strip

      double precision x(a1:a2,b1:b2,c1:c2)
      double precision y(a1:a2,b1:b2,c1:c2,g1:g2,h1:h2)

      nsend = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1)


c--------------------------------------------
          do h=h1,h2
          do g=g1,g2
           do c=c1,c2
           do b=b1,b2
           do a=a1,a2
           y(a,b,c,g,h) = x(a,b,c)  
           enddo
           enddo
           enddo
          enddo
          enddo

c--------------------------------------------
      return
      end
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

      subroutine do_addrootindex5_6(x, sindex, a1, a2, b1, b2, c1,
     *                      c2, cc1,cc2, dd1,dd2, y, findex, 
     *                      e1, e2, f1, f2, d1, d2, g1, g2, h1, h2, hh1,
     *                      hh2, nsend)
c--------------------------------------------------------------------------
c  Routine which performs the actual copying. 
c--------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer a1,a2,b1,b2,c1,c2,d1,d2,cc1,cc2
      integer e1,e2,f1,f2,g1,g2,h1,h2,dd1,dd2,hh1,hh2
      integer sindex(mx_array_index), findex(mx_array_index),
     *        match(4)

      integer i, j, k, a, b, c, d, e, f, g, h
      integer m, n, lda, ldb, ldc
      integer nsend, strip

      double precision x(a1:a2,b1:b2,c1:c2,cc1:cc2,dd1:dd2)
      double precision y(a1:a2,b1:b2,c1:c2,cc1:cc2,dd1:dd2,hh1:hh2)

      nsend = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1)




c--------------------------------------------
          do e=hh1,hh2
          do h=dd1,dd2
          do g=cc1,cc2
           do c=c1,c2
           do b=b1,b2
           do a=a1,a2
           y(a,b,c,g,h,e) = x(a,b,c,g,h)
           enddo
           enddo
           enddo
          enddo
          enddo
          enddo
c--------------------------------------------
      return
      end


c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

         SUBROUTINE  ERD__ATOM_INT2D_TO_E0F0_YUKAWA
     +
     +                    ( SHELLA,SHELLP,SHELLC,SHELLQ,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZET,NXYZFT,NXYZP,NXYZQ,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__ATOM_INT2D_TO_E0F0
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of atomic batches of
C                cartesian eris [E0|F0] , E = A to P, F = C to Q,
C                adding up all the contributions from all the atomic
C                2D PQ integrals.
C
C                The routine is a special routine derived from the
C                corresponding nonatomic one. Its structure is the
C                same except for the fact that for an atom individual
C                x,x-,y,y- and z,z-pair contributions are zero if
C                their monomial exponent sum is odd (vanishing integral
C                due to atomic D2h symmetry!). Hence checks of such
C                cases are placed inside the x,y,z loops.
C                
C                For comments on how the x,y,z,E loop structures are
C                coded please refer to the nonatomic routine.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A,C and csh sums P=A+B,Q=C+D
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZE(F)T   =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B and in the range
C                                   F = C,...,Q=C+D
C                    NXYZy       =  # of cartesian monomials for
C                                   y = P,Q shells
C                    INT2Dx      =  all current atomic 2D PQ integrals
C                                   for each cartesian component
C                                   (x = X,Y,Z)
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   atomic 2D PQ integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of atomic primitive cartesian
C                                   [E0|F0] integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,J,K,M,N
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZE,NXYZF,NXYZET,NXYZFT,NXYZP,NXYZQ
         INTEGER     SE,SF
         INTEGER     SEEND,SFEND
         INTEGER     SHELLA,SHELLP,SHELLC,SHELLQ
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX,XFMAX
         INTEGER     XEP,XFP,XYEP,XYFP
         INTEGER     XF,YF,ZF
         INTEGER     XYE,XYF
         INTEGER     YEEND,YFEND
         INTEGER     YTOT,ZTOT

         DOUBLE PRECISION  SUM,QQQ
         DOUBLE PRECISION  ZERO,RTS(1:NGQEXQ)

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ,1:NXYZET,1:NXYZFT)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP,0:SHELLQ)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...set first all [E0|F0] batch elements equal to zero.
C                This is necessary, since not all elements of the
C                batch will be addressed inside the x,y,z loops.
C
C
         DO J = 1,NXYZFT
         DO I = 1,NXYZET
         DO M = 1,NEXQ
            BATCH (M,I,J) = ZERO
         END DO
         END DO
         END DO
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XFP = NXYZFT + 3
         DO 100 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 102 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 102

               DO M = 1,NEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 110 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 112 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 112

                     IF (YTOT.EQ.0) THEN
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M)
                         END DO
                     ELSE
                         DO M = 1,NEXQ
                            TEMP2 (M) = TEMP1 (M) * INT2DY (M,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 120 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 122 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                               IF (ZTOT.EQ.0) THEN
                                   DO M = 1,NEXQ
                                      BATCH (M,I,J) = TEMP2 (M)*RTS(M)
                                   END DO
                               ELSE
                                   DO M = 1,NEXQ
                                      BATCH (M,I,J) = TEMP2 (M)*RTS(M)
     +                                                * INT2DZ (M,ZE,ZF)
                                   END DO
                               END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  122                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  120                CONTINUE
  112             CONTINUE
  110          CONTINUE
  102       CONTINUE
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XFP = NXYZFT + 3
         DO 200 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 202 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 202

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 210 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 212 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 212

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 220 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 222 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
                                  K = K + 2
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
                                  K = K + 2
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  222                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  220                CONTINUE
  212             CONTINUE
  210          CONTINUE
  202       CONTINUE
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XFP = NXYZFT + 3
         DO 300 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 302 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 302

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 310 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 312 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 312

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 320 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 322 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
                                  K = K + 3
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
                                  K = K + 3
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  322                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  320                CONTINUE
  312             CONTINUE
  310          CONTINUE
  302       CONTINUE
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XFP = NXYZFT + 3
         DO 400 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 402 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 402

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 410 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 412 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 412

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 420 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 422 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            + TEMP2 (K+3)*RTS(K+3)
                                  K = K + 4
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
                                  K = K + 4
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  422                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  420                CONTINUE
  412             CONTINUE
  410          CONTINUE
  402       CONTINUE
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XFP = NXYZFT + 3
         DO 500 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 502 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 502

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 510 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 512 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 512

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 520 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 522 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            + TEMP2 (K+4)*RTS(K+4)
                                  K = K + 5
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
                                  K = K + 5
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  522                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  520                CONTINUE
  512             CONTINUE
  510          CONTINUE
  502       CONTINUE
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XFP = NXYZFT + 3
         DO 600 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 602 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 602

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 610 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 612 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 612

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 620 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 622 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            + TEMP2 (K+5)*RTS(K+5)
                                  K = K + 6
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
                                  K = K + 6
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  622                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  620                CONTINUE
  612             CONTINUE
  610          CONTINUE
  602       CONTINUE
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XFP = NXYZFT + 3
         DO 700 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 702 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 702

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 710 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 712 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 712

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 720 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 722 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            + TEMP2 (K+6)*RTS(K+6)
                                  K = K + 7
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                            + TEMP2 (K+6)*RTS(K+6)
     +                                            * INT2DZ (K+6,ZE,ZF)
                                  K = K + 7
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  722                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  720                CONTINUE
  712             CONTINUE
  710          CONTINUE
  702       CONTINUE
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XFP = NXYZFT + 3
         DO 800 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 802 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 802

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 810 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 812 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 812

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 820 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 822 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            + TEMP2 (K+6)*RTS(K+6)
     +                                            + TEMP2 (K+7)*RTS(K+7)
                                  K = K + 8
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                            + TEMP2 (K+6)*RTS(K+6)
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                            + TEMP2 (K+7)*RTS(K+7)
     +                                            * INT2DZ (K+7,ZE,ZF)
                                  K = K + 8
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  822                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  820                CONTINUE
  812             CONTINUE
  810          CONTINUE
  802       CONTINUE
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XFP = NXYZFT + 3
         DO 900 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 902 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 902

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO

               XYFP = XFP - XFMAX
               DO 910 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 912 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 912

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF

                     J = XYFP
                     NXYZF = NXYZQ
                     DO 920 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 922 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF

                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            + TEMP2 (K+6)*RTS(K+6)
     +                                            + TEMP2 (K+7)*RTS(K+7)
     +                                            + TEMP2 (K+8)*RTS(K+8)
                                  K = K + 9
                               END DO
                            ELSE
                               K = 1
                               DO M = 1,NEXQ
                                  BATCH (M,I,J) =   TEMP2 (K)*RTS(K)
     +                                            * INT2DZ (K,ZE,ZF)
     +                                            + TEMP2 (K+1)*RTS(K+1)
     +                                            * INT2DZ (K+1,ZE,ZF)
     +                                            + TEMP2 (K+2)*RTS(K+2)
     +                                            * INT2DZ (K+2,ZE,ZF)
     +                                            + TEMP2 (K+3)*RTS(K+3)
     +                                            * INT2DZ (K+3,ZE,ZF)
     +                                            + TEMP2 (K+4)*RTS(K+4)
     +                                            * INT2DZ (K+4,ZE,ZF)
     +                                            + TEMP2 (K+5)*RTS(K+5)
     +                                            * INT2DZ (K+5,ZE,ZF)
     +                                            + TEMP2 (K+6)*RTS(K+6)
     +                                            * INT2DZ (K+6,ZE,ZF)
     +                                            + TEMP2 (K+7)*RTS(K+7)
     +                                            * INT2DZ (K+7,ZE,ZF)
     +                                            + TEMP2 (K+8)*RTS(K+8)
     +                                            * INT2DZ (K+8,ZE,ZF)
                                  K = K + 9
                               END DO
                            END IF
                           END IF

                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
  922                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
  920                CONTINUE
  912             CONTINUE
  910          CONTINUE
  902       CONTINUE
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x-pairs. No skipping of the
C                x,x-contribution of 0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XFP = NXYZFT + 3
         DO 1000 XF = 0,SHELLQ
            XFP = XFP + XF - 2
            XFMAX = XF * SHELLQ
            YFEND = SHELLQ - XF
            XEP = NXYZET + 3
            DO 1002 XE = 0,SHELLP
               XEP = XEP + XE - 2
               XEMAX = XE * SHELLP
               YEEND = SHELLP - XE

               IF (MOD (XE+XF,2).EQ.1) GOTO 1002

               DO M = 1,NGQEXQ
                  TEMP1 (M) = SCALE (M) * INT2DX (M,XE,XF)
               END DO
C
C
C             ...middle loops over y,y-pairs. Skip multiplication
C                of y,y-contributions, if we have a 0,0-pair, as
C                then the 2DY integral is equal to 1.
C
C
               XYFP = XFP - XFMAX
               DO 1010 YF = 0,YFEND
                  XYF = XF + YF
                  XYFP = XYFP - 1
                  SFEND = MAX (SHELLC,XYF)
                  XYEP = XEP - XEMAX
                  DO 1012 YE = 0,YEEND
                     XYE = XE + YE
                     XYEP = XYEP - 1
                     SEEND = MAX (SHELLA,XYE)

                     YTOT = YE + YF
                     IF (MOD (YTOT,2).EQ.1) GOTO 1012

                     IF (YTOT.EQ.0) THEN
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N)
                         END DO
                     ELSE
                         DO N = 1,NGQEXQ
                            TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE,YF)
                         END DO
                     END IF
C
C
C             ...inner loops over E,F-pairs. Skip multiplication
C                of z,z-contributions, if we have a 0,0-pair, as
C                then the 2DZ integral is equal to 1.
C
C
                     J = XYFP
                     NXYZF = NXYZQ
                     DO 1020 SF = SHELLQ,SFEND,-1
                        ZF = SF - XYF
                        I = XYEP
                        NXYZE = NXYZP
                        DO 1022 SE = SHELLP,SEEND,-1
                           ZE = SE - XYE
                           ZTOT = ZE + ZF
C
C
C             ...all info concerning all three x,x-, y,y- and z,z-pairs
C                have been collected for all exponent quadruplets at
C                once. Sum up the 2D X,Y,Z integral products to the
C                appropriate place of the [E0|F0] batch.
C
C
                           IF (MOD (ZTOT,2).EQ.0) THEN
                            IF (ZTOT.EQ.0) THEN
                               K = 0
                               DO M = 1,NEXQ
                                  SUM = ZERO
                                  DO N = 1,NGQP
                                     QQQ = TEMP2 (K+N)*RTS(K+N) 
                                     SUM = SUM + QQQ
                                  END DO
                                  K = K + NGQP
                                  BATCH (M,I,J) = SUM
                               END DO
                            ELSE
                               K = 0
                               DO M = 1,NEXQ
                                  SUM = ZERO
                                  DO N = 1,NGQP
                        QQQ = TEMP2 (K+N)*RTS(K+N)*INT2DZ (K+N,ZE,ZF) 
                                     SUM = SUM + QQQ
                                  END DO
                                  K = K + NGQP
                                  BATCH (M,I,J) = SUM
                               END DO
                            END IF
                           END IF
C
C
C             ...next z,z-pair.
C
C
                           I = I - NXYZE + XE
                           NXYZE = NXYZE - SE - 1
 1022                   CONTINUE
                        J = J - NXYZF + XF
                        NXYZF = NXYZF - SF - 1
 1020                CONTINUE
C
C
C             ...next y,y-pair and next x,x-pair.
C
C
 1012             CONTINUE
 1010          CONTINUE
 1002       CONTINUE
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE EXPAND_T1(T1_EXPND, T1_DROP, NIRREP, NOCC_EXPND,
     &                     NVRT_EXPND, NOCC, NVRT, NOCCO_EXPND,
     &                     NVRTO_EXPND, SYMP_OVFUL)
C
C This will expand the symmetry-packed T1 space from the drop-mo to full-mo by
C adding zeros to the excitations that involve dropped mos: t(i,a)=0
C for all inactive i and a. Ajith Perera, 07/2005.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER SYMP_OVFUL
      DIMENSION T1_EXPND(NVRTO_EXPND*NOCCO_EXPND), T1_DROP(NVRT*NOCC),
     &          NOCC_EXPND(8), NVRT_EXPND(8)
      COMMON /SYMDROP/ NDRPOP(8),NDRVRT(8)

      IOFF_FULL = 0
      IOFF_ACT  = 0

      CALL ZERO(T1_EXPND, NVRTO_EXPND*NOCCO_EXPND)
      CALL GETREC(20,'JOBARC','NDROPPOP',NIRREP,NDRPOP)
      CALL GETREC(20,'JOBARC','NDROPVRT',NIRREP,NDRVRT)

      DO IRREP = 1, NIRREP
             NVRT = NVRT_EXPND(IRREP)
             NOCC = NOCC_EXPND(IRREP)
         NVRT_DRP = NDRVRT(IRREP)
         NOCC_DRP = NDRPOP(IRREP)
         NVRT_ACT = NVRT - NVRT_DRP
         NOCC_ACT = NOCC - NOCC_DRP

         IOFF_FULL = IOFF_FULL + NVRT*NOCC
         IOFF_ACT  = IOFF_ACT  + NVRT_ACT*NOCC_ACT
      END DO
      SYMP_OVFUL = IOFF_FULL
      IOFF_FULL  = IOFF_FULL + 1
      IOFF_ACT   = IOFF_ACT  + 1

      DO IRREP = NIRREP, 1, -1
             NVRT = NVRT_EXPND(IRREP)
             NOCC = NOCC_EXPND(IRREP)
         NVRT_DRP = NDRVRT(IRREP)
         NOCC_DRP = NDRPOP(IRREP)
         NVRT_ACT = NVRT - NVRT_DRP
         NOCC_ACT = NOCC - NOCC_DRP

         IOFF_FULL = IOFF_FULL - NVRT*NOCC
         IOFF_ACT  = IOFF_ACT  - NVRT_ACT*NOCC_ACT

         CALL FULL_T1(T1_EXPND(IOFF_FULL), T1_DROP(IOFF_ACT),
     &                NVRT_ACT, NOCC_ACT, NVRT, NOCC,
     &                NVRT_DRP, NOCC_DRP)

      END DO

      RETURN
      END

      SUBROUTINE FTAU(T2,T1A,T1B,DISSYT,NUMSYT,POP1,POP2,
     &               VRT1,VRT2,IRREP,ISPIN,FACT)
C
C THIS SUBROUTINE FORMS THE SYMMETRY PACKED TAU(AB,IJ) 
C AMPLITUDES FOR CCSD GIVEN THE SYMMETRY PACKED T2(AB,IJ)
C AND T1(A,I) AMPLITUDES. TAU(AB,IJ) IS DEFINED AS
C
C  TAU(AB,IJ) = T2(AB,IJ) + T1(A,I)*T1(B,J)*FACT
C                         - T1(A,J)*T1(B,I)*FACT
C
C FOR ISPIN =1 (AAAA CASE) AND ISPIN =2 (BBBB CASE)
C THE EQUATION GIVEN APLIES DIRECTLY. FOR ISPIN=3
C (ABAB CASE) IT REDUCES TO
C
C TAU(Ab,Ij) = T2(Ab,Ij) + T1(A,I)*T1(b,j)*FACT
C
C NOTE THAT SYMMETRY PACKING IS USED AND THAT THE
C SYMMETRY INFORMATION IS ALSO USED IN ORDER TO
C DECIDE IF THERE ARE ANY SINGLE CONTRIBUTION OR NOT.
C FOR THE ABAB SPIN CASE, THERE ARE ONLY CONTRIBUTIONS
C WHEN THE IRREP OF A IS EQUAL TO THE IRREP OF I (AND
C IRREPB EQUAL TO IRREPJ, WHICH IS FORCED BY THE REQUIREMENT
C THAT THE T2 AMPLITUDES ARE TOTAL SYMMETRIC) IN THE AAAA
C AND BBBB SPIN CASES, THERE ARE CONTRIBUTIONS IF EITHERE
C IRREPA EQUALS IRREPI (FIRST TERM) OR IRREPA EQUALS IRREPJ 
C (SECOND TERM)
C
CEND 
C
C CODED JULY/90 JG
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL LINCC,CICALC
      INTEGER POP1,POP2,VRT1,VRT2,DIRPRD,DISSYT
      DIMENSION T2(DISSYT,NUMSYT),T1A(1),T1B(1)
      DIMENSION POP1(8),POP2(8),VRT1(8),VRT2(8)
      DIMENSION IOFFT2O(8),IOFFT2V(8),IOFFT1A(8),
     &          IOFFT1B(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /LINEAR/ LINCC,CICALC
C
      NNM1O2(I)=((I-1)*I)/2
C
      IF(LINCC)RETURN
C
      IF(ISPIN.LT.3) THEN
C
C AAAA OR BBBB SPIN CASE
C
C DETERMINE FIRST OFFSETS FOR T2 AND T1
C
       IOFFT2O(1)=0
       IOFFT2V(1)=0
       IOFFT1A(1)=0
       DO 1 IRREPJ=1,NIRREP-1
        IOFFT1A(IRREPJ+1)=IOFFT1A(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPJ)
1      CONTINUE
       IF(IRREP.EQ.1) THEN
        DO 2 IRREPJ=1,NIRREP-1
         IOFFT2O(IRREPJ+1)=IOFFT2O(IRREPJ)+NNM1O2(POP1(IRREPJ))
         IOFFT2V(IRREPJ+1)=IOFFT2V(IRREPJ)+NNM1O2(VRT1(IRREPJ))
2       CONTINUE
       ELSE
        DO 3 IRREPJ=1,NIRREP-1
         IRREPI=DIRPRD(IRREP,IRREPJ)
         IF(IRREPI.LT.IRREPJ) THEN
          IOFFT2O(IRREPJ+1)=IOFFT2O(IRREPJ)+POP1(IRREPI)*POP1(IRREPJ)
          IOFFT2V(IRREPJ+1)=IOFFT2V(IRREPJ)+VRT1(IRREPI)*VRT1(IRREPJ)
         ELSE
          IOFFT2O(IRREPJ+1)=IOFFT2O(IRREPJ)
          IOFFT2V(IRREPJ+1)=IOFFT2V(IRREPJ)
         ENDIF
3       CONTINUE
       ENDIF
C
       DO 100 IRREPJ=1,NIRREP
C
        NUMJ=POP1(IRREPJ)
        INDIJ=IOFFT2O(IRREPJ)
        INDJ0=IOFFT1A(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        IF(IRREPI.EQ.IRREPJ) THEN
C
         IF(NNM1O2(NUMJ).EQ.0) GO TO 100
C
          NUMB=VRT1(IRREPJ)
C
          INDAB0=IOFFT2V(IRREPJ)
C
         DO 10 J=2,NUMJ
         INDJ=INDJ0+(J-1)*NUMB
         DO 10 I=1,J-1
          INDI=INDJ0+(I-1)*NUMB
C
          INDIJ=INDIJ+1
C 
          INDAB=INDAB0
C
          DO 20 IB=2,NUMB
          INDBI=INDI+IB
          INDBJ=INDJ+IB
          DO 20 IA=1,IB-1
           INDAI=INDI+IA
           INDAJ=INDJ+IA
           INDAB=INDAB+1
C
           T2(INDAB,INDIJ)=T2(INDAB,INDIJ)+FACT*T1A(INDAI)*T1A(INDBJ)
     &                                    -FACT*T1A(INDAJ)*T1A(INDBI)
20        CONTINUE
10       CONTINUE
C
        ELSE IF(IRREPI.LT.IRREPJ) THEN
C
         NUMI=POP1(IRREPI)
C
         INDIJ=IOFFT2O(IRREPJ)
C
C
         NUMB=VRT1(IRREPJ)
         NUMA=VRT1(IRREPI)
         INDAB0=IOFFT2V(IRREPJ)
C
         DO 30 J=1,NUMJ
         INDJ=IOFFT1A(IRREPJ)+(J-1)*NUMB
         DO 30 I=1,NUMI
C
          INDIJ=INDIJ+1         
C
          INDI=IOFFT1A(IRREPI)+(I-1)*NUMA
C
          INDAB=INDAB0
C
C
          DO 50 IB=1,NUMB
           INDBJ=INDJ+IB
           DO 60 IA=1,NUMA
            INDAI=INDI+IA
            INDAB=INDAB+1
            T2(INDAB,INDIJ)=T2(INDAB,INDIJ)+FACT*T1A(INDAI)*T1A(INDBJ)
60         CONTINUE
50        CONTINUE
30       CONTINUE
        ENDIF
100    CONTINUE
      ELSE
C
C  ABAB SPIN CASE
C
C  GET FIRST OFFSETS OF T1 AND T2
C
       IOFFT2O(1)=0
       IOFFT2V(1)=0
       IOFFT1A(1)=0
       IOFFT1B(1)=0
       DO 101 IRREPJ=1,NIRREP-1
        IRREPI=DIRPRD(IRREPJ,IRREP)
        IOFFT2O(IRREPJ+1)=IOFFT2O(IRREPJ)+POP2(IRREPJ)*POP1(IRREPI)
        IOFFT2V(IRREPJ+1)=IOFFT2V(IRREPJ)+VRT2(IRREPJ)*VRT1(IRREPI)
        IOFFT1A(IRREPJ+1)=IOFFT1A(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPJ)
        IOFFT1B(IRREPJ+1)=IOFFT1B(IRREPJ)+POP2(IRREPJ)*VRT2(IRREPJ)
101    CONTINUE
C
       DO 200 IRREPJ=1,NIRREP

        NUMJ=POP2(IRREPJ)
        INDIJ=IOFFT2O(IRREPJ)
        INDAB0=IOFFT2V(IRREPJ)
        NUMB=VRT2(IRREPJ)
C
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NUMI=POP1(IRREPI)
        NUMA=VRT1(IRREPI)
C
        DO 210 J=1,NUMJ
        INDJ=IOFFT1B(IRREPJ)+(J-1)*NUMB
        DO 210 I=1,NUMI
         INDI=IOFFT1A(IRREPI)+(I-1)*NUMA
         INDIJ=INDIJ+1
         INDAB=INDAB0
         DO 220 IB=1,NUMB
         INDBJ=INDJ+IB
         DO 220 IA=1,NUMA
          INDAB=INDAB+1
          INDAI=INDI+IA
          T2(INDAB,INDIJ)=T2(INDAB,INDIJ)+FACT*T1A(INDAI)*T1B(INDBJ)
220      CONTINUE
210     CONTINUE
200    CONTINUE
      ENDIF
      RETURN
      END

c This routine prints the chemical system (minus dummy atoms) in the form:
c   A1 X1 Y1 Z1
c   A2 X2 Y2 Z2

      subroutine xyz
      implicit none

      integer maxatm
      parameter(maxatm=100)

      double precision coord(3,maxatm)
      integer nAtoms, i, indx
      character*(5*maxatm) zsymuni

#include "machsp.com"

c ----------------------------------------------------------------------

      call getrec(1,'JOBARC','NATOMS',1,nAtoms)
      if (nAtoms.gt.maxatm) then
         print *, '@XYZ: Assertion failed.'
         print *, '      maxatm = ',maxatm
         print *, '      nAtoms = ',nAtoms
         call aces_exit(1)
      end if

c   o get the Cartesian coordinates (with dummy atoms)
      call getrec(1,'JOBARC','COORD',iintfp*3*nAtoms,coord)

c   o get the atomic symbols
      call getcrec(1,'JOBARC','ZSYM',5*nAtoms,zsymuni)

c   o print the matrix without dummies
      indx = 1
      do i = 1, nAtoms
         if (zsymuni(indx:indx).ne.'X') print '(a2,3(x,f12.8))',
     &      zsymuni(indx:indx+1), coord(1,i), coord(2,i), coord(3,i)
         indx = indx + 5
      end do

      return
c     end subroutine xyz
      end

      INTEGER FUNCTION IFINDNE(N,A,ISKIP,TARGET,TOLER)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(1)
      IOFF=1
      IPASS=1
c1     DIFF=ABS(A(IOFF)-a(max(1,ioff-1)))
1     DIFF=ABS(A(IOFF)-TARGET)
      IF(DIFF.GT.TOLER.OR.IPASS.EQ.N+1)THEN
       IFINDNE=IPASS
      ELSE
       IPASS=IPASS+1
       IOFF=IOFF+ISKIP
       GOTO 1
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FIND_AXIAL_ROTATION_MATRIX
     +
     +                    ( DDROW,DDCOL,
     +                      NHYB,
     +                      P,
     +
     +                              ROT )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FIND_AXIAL_ROTATION_MATRIX
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine calculates the rotation matrix of
C                NHYB identical hybrids which are arranged such that
C                they are equally spaced in a plane in space.
C                The rotation is against a background interaction
C                of NHYB interaction points P on one of the hybrids.
C                The goal is to maximize the interaction of the first
C                interaction point P(1).
C
C                Example:
C                
C                Consider the three sp2 hybrids. Let the absolute values
C                of the 3 interaction points on one of the sp2 hybrids
C                (denoted by o's below) be P1,P2,P3:
C
C
C                                      o
C                                      o    .P3
C                                      o   .
C                                      o  .
C                                      o .
C                                      o.    <---- rotate (o) by theta
C                                     * *
C                           P2      *     *
C                                 *         *
C                               *             *
C                             *           P1    *
C
C
C
C                          to get (P1,P2,P3 stay fixed)
C
C
C
C                                      *
C                                      P3
C                                      *
C                                      *
C                                      *
C                                      *
C                                     * o
C                                   *     o
C                                 *         o
C                               P2            P1
C                             *                 o
C
C
C
C                Let us first find the general form of such rotation
C                matrix. The three sp2 hybrids are formed by one s and
C                the two px and py functions. A general rotation T of
C                these functions (in basis order s,px,py) in the xy
C                plane is given by (c,s = cos,sin theta):
C
C
C                                     1   0   0
C
C                              T  =   0   c   s
C
C                                     0  -s   c
C
C                since the s function does not change upon rotation.
C                Also we have the defining matrix U of the three sp2
C                hybrids:
C
C
C                                      e   e   e
C
C                              U  =   2f  -f  -f
C
C                                      0   g  -g
C
C                where e = 1/sqrt(3), f = 1/sqrt(6) and c = 1/sqrt(2).
C                The general rotation matrix R of the sp2 hybrids is
C                then:
C
C                                     -1
C                                R = U   * T * U
C
C
C                which after inserting the above values becomes:
C
C
C                     1  1  1           2 -1 -1                 0  1 -1
C               1/3   1  1  1  +  c/3  -1  2 -1  +  s/sqrt(3)  -1  0  1
C                     1  1  1          -1 -1  2                 1 -1  0
C
C
C                Forming the product R*P for the new rotated P1'
C                element (the one we intend to maximize):
C
C
C                                               P1
C
C                                               P2
C
C                                               P3
C
C                              R11  R12  R13    P1'
C
C                              R11  R12  R13    ...
C
C                              R11  R12  R13    ...
C
C                we get
C
C
C            P1' = 1/3 (P1+P2+P3) + c/3 (2P1-P2-P3) + s/sqrt(3) (P2-P3)
C
C
C                which, when maximizing with respect to c under the
C                constrain c*c+s*s=1, gives for c:
C
C
C
C                                 /      (2P1 - P2 - P3)**2
C                 c(max) = +- \  / -----------------------------------
C                              \/ 3(P2 - P3)**2  +  (2P1 - P2 - P3)**2
C
C
C                 s(max) = +- sqrt (1 - c(max)*c(max)
C
C
C                The signs to be chosen are the following:
C
C                   For c(max) : +ve  if 2P1 >= P2 + P3
C                                -ve  otherwise
C
C                   For s(max) : +ve  if P2 >= P3
C                                -ve  otherwise
C
C
C                  Input:
C
C                    DDROW        =  declared row dimension of rotation
C                                    matrix
C                    DDCOL        =  declared column dimension of
C                                    rotation matrix
C                    NHYB         =  # of degenerate hybrids.
C                    P            =  the NHYB interaction points.
C
C
C                  Output:
C
C                    ROT          =  the NHYB x NHYB rotation matrix.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     DDROW,DDCOL
         INTEGER     NHYB

         DOUBLE PRECISION  C,S
         DOUBLE PRECISION  COSINE,SINE
         DOUBLE PRECISION  P1,P2,P3
         DOUBLE PRECISION  P1MAX,P1VAL
         DOUBLE PRECISION  X,Y,Z
         DOUBLE PRECISION  ZERO,THIRD,SQR3TH,ONE

         DOUBLE PRECISION  P (1:NHYB)

         DOUBLE PRECISION  ROT (1:DDROW,1:DDCOL)

         PARAMETER  (ZERO    = 0.D0                                   )
         PARAMETER  (THIRD   = 1.D0 / 3.D0                            )
         PARAMETER  (SQR3TH  = 0.57735026918962576450914878050195750D0)
         PARAMETER  (ONE     = 1.D0                                   )
C
C
C------------------------------------------------------------------------
C
C
C             ...proceed.
C
C
         IF (NHYB.EQ.3) THEN

             P1MAX = ZERO

             P1 = P (1)
             P2 = P (2)
             P3 = P (3)

             X = P1 + P1 - P2 - P3
             Y = P2 - P3
             X = X * X
             Y = Y * Y

             C = DSQRT (X / (Y+Y+Y+X))
             S = DSQRT (ONE - C*C)
             
             X = THIRD * (ONE + C + C)
             Y = THIRD * (ONE - C) + SQR3TH * S
             Z = THIRD * (ONE - C) - SQR3TH * S

             P1VAL = ABS (P1 * X + P2 * Z + P3 * Y)

             IF (P1VAL.GT.P1MAX) THEN
                 COSINE = C
                 SINE = S
                 P1MAX = P1VAL
             END IF

             C = - C

             X = THIRD * (ONE + C + C)
             Y = THIRD * (ONE - C) + SQR3TH * S
             Z = THIRD * (ONE - C) - SQR3TH * S

             P1VAL = ABS (P1 * X + P2 * Z + P3 * Y)

             IF (P1VAL.GT.P1MAX) THEN
                 COSINE = C
                 SINE = S
                 P1MAX = P1VAL
             END IF

             C = - C
             S = - S

             X = THIRD * (ONE + C + C)
             Y = THIRD * (ONE - C) + SQR3TH * S
             Z = THIRD * (ONE - C) - SQR3TH * S

             P1VAL = ABS (P1 * X + P2 * Z + P3 * Y)

             IF (P1VAL.GT.P1MAX) THEN
                 COSINE = C
                 SINE = S
                 P1MAX = P1VAL
             END IF

             C = - C

             X = THIRD * (ONE + C + C)
             Y = THIRD * (ONE - C) + SQR3TH * S
             Z = THIRD * (ONE - C) - SQR3TH * S

             P1VAL = ABS (P1 * X + P2 * Z + P3 * Y)

             IF (P1VAL.GT.P1MAX) THEN
                 COSINE = C
                 SINE = S
                 P1MAX = P1VAL
             END IF

             X = THIRD * (ONE + COSINE + COSINE)
             Y = THIRD * (ONE - COSINE) + SQR3TH * SINE
             Z = THIRD * (ONE - COSINE) - SQR3TH * SINE

             ROT (1,1) = X
             ROT (2,1) = Z
             ROT (3,1) = Y
             ROT (1,2) = Y
             ROT (2,2) = X
             ROT (3,2) = Z
             ROT (1,3) = Z
             ROT (2,3) = Y
             ROT (3,3) = X

         ELSE

             WRITE (*,*) ' Cannot rotate > 3 axial hybrids! '
             WRITE (*,*) ' NHYB = ',NHYB
             WRITE (*,*) ' nlo__find_axial_rotation_matrix '
             WRITE (1,*) ' Cannot rotate > 3 axial hybrids! '
             WRITE (1,*) ' NHYB = ',NHYB
             WRITE (1,*) ' nlo__find_axial_rotation_matrix '
             STOP

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      function iattop(igrep,n,ind)
      implicit double precision (a-h,o-z)
c
c --- determine the first of n atoms with ind(iattop)=igrep
c
      dimension ind(n)
c
      iattop=0
      k=0
   10 k=k+1
      if(k.gt.n) return
      if(ind(k).eq.-igrep) return
      if(ind(k).ne.igrep) goto 10
      iattop=k
c
      return
      end

      subroutine molden_rdorb(ener,iocc,orb,orb_r,iang,scr,nao,nmo,
     &                        maxcor,iuhf,iexx,iunit)
c-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      double precision ener(nmo),orb(nao,nmo),scr(maxcor),
     &                 orb_r(nao)
      character*8 cscfener(2)
      character*8 cscforb(2)
      character*8 cexxcoef(2)
      character*8 cnumdrop(2)
      character*5 sptype(2)
      integer iocc(nmo), iang(nao)
      integer  idrppop(8),idrpvrt(8)

#include "machsp.com"
#include "info.com"
#include "flags.com"
#include "syminf.com"
#include "sym.com"
      parameter (one=1.0D0)
      parameter (zilch=0.0D0)
      data cscfener /'SCFEVLA0','SCFEVLB0'/
      data cscforb  /'SCFEVCA0','SCFEVCB0'/
      data cexxcoef /'EXXCOEFA','EXXCOEFB'/
      data cnumdrop /'NUMDROPA','NUMDROPB'/  
      data sptype   /'Alpha','Beta '/
      call aces_com_info
      call aces_com_syminf
      call aces_com_sym
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c the mo ordering is important for getting the occupations right
c
c depending on the place in the program (if the user is not using xaces2)
c it may be either scf or correlated
c
c    so            mo                        mo
c ao CMP2ZMAT   so cscforb(ispin)    =    ao AOBASMOS
c
c the so ordering is zmat
c the mo ordering is correlated if calc is greater than scf 
c or if this is a vibrational calculation
c
      i000=1
      i010=i000+nao*nmo
      i020=i010+nmo**2

      if(i020.gt.maxcor/iintfp)
     &  call insmem('RDORB-F',i020*iintfp,maxcor)

      call getrec(-1,'JOBARC','CMP2ZMAT',nao*nmo*iintfp,scr(i000))
c      if(iexx.eq.1) then
c          write(*,*)" number of AOs: ",nao
c          write(*,*)" number of MOs: ",nmo
c         write(*,*)" cmp2zmat matrix is: "
c         do i=1,nao*nmo
c           write(*,*)scr(i000+i-1)
c         enddo
c      endif
      do 10 ispin=1,iuhf+1
        if(iexx.eq.1)then
           call getrec(-1,'JOBARC',cexxcoef(ispin),nao*iintfp,
     $          scr(i010))
c           write(*,*)" the exx potential coefficents are: "
c           do i=1,nao
c             write(*,*) scr(i010+i-1)
c           enddo
c           do i=2,nmo
c              call dcopy(nao,scr(i010),1,scr(i010+(i-1)*nao),1)
c           enddo
        else
           call getrec(20,'JOBARC',cscforb(ispin),
     $          nmo**2*iintfp,scr(i010))

#ifdef _IMPORT_CORR_ORBS
C This is a highly experiemental work and what this do is
C to read the IP/EA or correlated natuarl orbitals and put
C in MOLDEN format in order to visualize them (see vscf.F).
C Note that IP/EA orbitals are limited to RHF reference and
C in general they are non-symmetric. 11/2009, Ajith Perera. 
C
            call getrec(-1,'JOBARC',"IPEAORBR", nmo**2*iintfp,
     &                  scr(i010))
#endif
        endif

        call xgemm('n','n',nao,nmo,nmo,one,scr(i000),nao,scr(i010),
     &    nmo,zilch,orb,nao)

        call getrec(-1,'JOBARC',cscfener,nmo*iintfp,ener)
c
c fill occupation numbers
c
cYAU - iflags(52) corresponds to geometry search step size controls...
        if((iflags(2).gt.0).or.(iflags(52).gt.0))then
c
c correlated ordering
c if dropmo change to full dimension
c
          call getrec(20,'JOBARC',cnumdrop(ispin),1,idrop)
          if(idrop.gt.0) then
            call getrec(-1,'JOBARC','NDROPPOP',nirrep,idrppop)
            call getrec(-1,'JOBARC','NDROPVRT',nirrep,idrpvrt)
            do 20 irrep=1,nirrep
              pop(irrep,ispin)=pop(irrep,ispin)+idrppop(irrep)
              nocco(ispin)=nocco(ispin)+idrppop(irrep)              
              vrt(irrep,ispin)=vrt(irrep,ispin)+idrpvrt(irrep)
              nvrto(ispin)=nvrto(ispin)+idrpvrt(irrep)
20          continue
          endif
          if(iuhf.eq.0)then
            do 30 imo=1,nocco(ispin)
              iocc(imo)=2
30          continue
          else
            do 35 imo=1,nocco(ispin)
              iocc(imo)=1
35          continue
          endif
          do 40 imo=nocco(ispin)+1,nmo
            iocc(imo)=0
40        continue 
        else
c
c scf ordering dropmo 
c since vtran hasn't run dropmo should be irrelevant here
c
          ioff=1
          if(iuhf.eq.0)then
            do 50 irrep=1,nirrep
              do 51 imo=ioff,ioff+pop(irrep,ispin)-1
                iocc(imo)=2
51            continue
              ioff=ioff+pop(irrep,ispin)
              do 52 imo=ioff,ioff+vrt(irrep,ispin)-1
                iocc(imo)=0
52            continue
              ioff=ioff+vrt(irrep,ispin)
50          continue
          else
            do 60 irrep=1,nirrep
              do 61 imo=ioff,ioff+pop(irrep,ispin)-1
                iocc(imo)=1
61            continue
              ioff=ioff+pop(irrep,ispin)
              do 62 imo=ioff,ioff+vrt(irrep,ispin)-1
                iocc(imo)=0
62            continue
              ioff=ioff+vrt(irrep,ispin)
60          continue
          endif
        endif
C
        do 80 imo=1,nmo
          write(iunit,90)' Ene=   ',ener(imo)
90        format(A,F8.4)
          write(iunit,100)' Spin= ' // sptype(ispin)
100       format(A)
          write(iunit,110)'  Occup=   ',iocc(imo),'.000000'
110       format(A,I1,A)
C
C Reorder the F functions (perhaps g too ..), Peter Szalay identified
C the problem and proivided the reorder routines. 
C Ajith Perera, 06/2011.
C
          call getrec(-1, 'JOBARC', 'ANMOMBF0', nao, iang)
          call reorder(orb(1, imo), orb_r, iang, nao)
          do 120 iao=1,nao
CSSS             write(iunit,130)iao,'  ',orb(iao,imo)
            write(iunit,130)iao,'  ',orb_r(iao)
130         format(I4,A,F12.6)
120       continue
80      continue 
10    continue
      return
      end

C THIS ROUTINE RETURNS THE TOTAL SIZE OF A SYMMETRY PACKED
C DISTRIBUTION (FOR ALL IRREPS).  ITYPL IS THE SYMMETRY TYPE
C OF THE DISTRIBUTION MEMBERS, ITYPR IS THE SYMMETRY TYPE OF
C THE DISTRIBUTIONS.  NOTE THAT CHANGING THE MEANING OF THESE
C VARIABLES MAKES NO DIFFERENCE.

      INTEGER FUNCTION IDSYMSZ(IRREPX,ITYPL,ITYPR)
      IMPLICIT INTEGER (A-Z)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                 DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)

      if ((IRREPX.lt.1).or.(NIRREP.lt.IRREPX)) then
         print *, '@IDSYMSZ: Assertion failed.'
         print *, '   IRREPX = ',IRREPX
         print *, '   NIRREP = ',NIRREP
         call errex
      end if
      if ((ITYPL.lt.1).or.(22.lt.ITYPL).or.
     &    (ITYPR.lt.1).or.(22.lt.ITYPR)    ) then
         print *, '@IDSYMSZ: Assertion failed.'
         print *, '   ITYPL = ',ITYPL
         print *, '   ITYPR = ',ITYPR
         call errex
      end if

      IDSYMSZ = 0
      DO IRREPR = 1, NIRREP 
         IRREPL = DIRPRD(IRREPR,IRREPX)
         IDSYMSZ =   IDSYMSZ
     &             + ( IRPDPD(IRREPL,ITYPL)*IRPDPD(IRREPR,ITYPR) )
      END DO
      RETURN
      END

C ROBUST EQUIVALENCE CHECK - DO WELL DEFINED SORT ON COORDINATE
C MATRIX AND COMPARE ELEMENT BY ELEMENT. SHOULD BE FOOLPROOF.

      SUBROUTINE COMPARE2(VEC,VECR,NORD,ICOMP,TOL)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

C VEC      coordinate vector to be checked (modified)
C VECR     sorted reference coordinate vector (input only)
C NORD     ???
C ICOMP    number of coordinates outside of TOL (output only)
C TOL      tolerance for comparison of coords (input only)

#include "mxatms.par"
#include "coord.com"
      DIMENSION VEC(3*NATOMS),VECR(3*NATOMS)
      DIMENSION NORD(2*MXATMS),SCR(3*MXATMS)

 80   FORMAT(3(1X,F10.5))
C
#ifdef _DEBUG_LVL0
      WRITE(6,*)'--------------B'
      WRITE(6,80)(VEC(JAP),JAP=1,3*NATOMS)
#endif

      CALL SORTXYZ(VEC,scr,NORD(NATOMS+1),NATOMS)
C
#ifdef _DEBUG_LVLM1
      WRITE(6,*)'--------------I'
      WRITE(6,80)(VECR(JAP),JAP=1,3*NATOMS)
      WRITE(6,*)'--------------O'
      WRITE(6,80)(VEC(JAP),JAP=1,3*NATOMS)
#endif

      ICOMP = 0
      DO I = 1, NATOMS*3
         Z = DABS( VECR(I)-scr(I) )

C As a temporary fix to a problem Gennady is having 
C following changes have been made. We hope to find the exact
C reason for the failure. AP 03/14/97.

         IF ((Z .GT. TOL) .AND. (Z .GT. 10*TOL)) ICOMP = ICOMP + 1
         IF ((Z .GT. TOL) .AND. (Z .LT. 10*TOL)) THEN
            WRITE(*,*) 'Warning - Less tighter tolerance is used.'
         END IF

      END DO

      RETURN
      END

C ROBUST EQUIVALENCE CHECK - DO WELL DEFINED SORT ON COORDINATE
C MATRIX AND COMPARE ELEMENT BY ELEMENT. SHOULD BE FOOLPROOF.

      SUBROUTINE COMPARE2(VEC,VECR,NORD,ICOMP,TOL)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

C VEC      coordinate vector to be checked (modified)
C VECR     sorted reference coordinate vector (input only)
C NORD     ???
C ICOMP    number of coordinates outside of TOL (output only)
C TOL      tolerance for comparison of coords (input only)

C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


      DIMENSION VEC(3*NATOMS),VECR(3*NATOMS)
      DIMENSION NORD(2*MXATMS),SCR(3*MXATMS)

 80   FORMAT(3(1X,F10.5))
C
      WRITE(6,*)'--------------B'
      WRITE(6,80)(VEC(JAP),JAP=1,3*NATOMS)

      CALL SORTXYZ(VEC,scr,NORD(NATOMS+1),NATOMS)
C

      ICOMP = 0
      DO I = 1, NATOMS*3
         Z = DABS( VECR(I)-scr(I) )

C As a temporary fix to a problem Gennady is having 
C following changes have been made. We hope to find the exact
C reason for the failure. AP 03/14/97.

         IF ((Z .GT. TOL) .AND. (Z .GT. 10*TOL)) ICOMP = ICOMP + 1
         IF ((Z .GT. TOL) .AND. (Z .LT. 10*TOL)) THEN
            WRITE(*,*) 'Warning - Less tighter tolerance is used.'
         END IF

      END DO

      RETURN
      END

      DOUBLE PRECISION FUNCTION TRACE(A,N)
      IMPLICIT NONE
      INTEGER N, INC, I, ADD
      DOUBLE PRECISION A(N*N)
      TRACE = A(1)
      INC = N + 1
      ADD = 1
      DO I = 1, N-1
         ADD = ADD + INC
         TRACE = TRACE + A(ADD)
      END DO
      RETURN
      END 

	SUBROUTINE PRINTIVEC(IVECNAM,LEN)
C       
C       Designed to print out an integer vector
c
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C       
	DIMENSION IVECNAM(LEN)
C       
	WRITE(*,*) "len=", LEN
	DO 20 I=1,LEN
	   WRITE(*,*) IVECNAM(I)
   20 CONTINUE
C       
	END SUBROUTINE PRINTIVEC
	

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__MEMORY_OVL_DERV_BATCH
     +
     +                    ( NALPHA,NCOEFF,
     +                      NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      DER1X,DER1Y,DER1Z,
     +                      DER2X,DER2Y,DER2Z,
     +                      ALPHA,CC,
     +                      SPHERIC,
     +
     +                                IMIN,IOPT,
     +                                ZMIN,ZOPT )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__MEMORY_OVL_DERV_BATCH
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__MEMORY_OVL_DERV_CSGTO
C  DESCRIPTION : Main operation that calculates the minimum and optimum
C                integer/flp memory needed for evaluating a batch
C                of contracted electron overlap derivative integrals.
C
C
C                  Input (x = 1 and 2):
C
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    DERyp        =  the order of differentiation on
C                                    centers y = 1 and 2 with respect
C                                    to the p = x,y,z coordinates
C                    ALPHA        =  primitive exponents for csh
C                                    1 and 2 in that order
C                    CC           =  contraction coefficient for csh
C                                    1 and 2 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C
C                  Output:
C
C                    IMIN,IOPT    =  minimum/optimum integer memory
C                    ZMIN,ZOPT    =  minimum/optimum flp memory
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INCLUDE     'oed__tuning.inc'

         LOGICAL     SPHERIC

         INTEGER     DER1X,DER1Y,DER1Z
         INTEGER     DER2X,DER2Y,DER2Z
         INTEGER     IMIN,IOPT
         INTEGER     NALPHA,NCOEFF
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NPGTO1,NPGTO2
         INTEGER     SHELL1,SHELL2
         INTEGER     ZMIN,ZOPT

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
C
C
C------------------------------------------------------------------------
C
C
C             ...call memory routine.
C
C
         CALL  OED__MEMORY_OVL_DERV_CSGTO
     +
     +              ( NALPHA,NCOEFF,
     +                NCGTO1,NCGTO2,
     +                NPGTO1,NPGTO2,
     +                SHELL1,SHELL2,
     +                X1,Y1,Z1,X2,Y2,Z2,
     +                DER1X,DER1Y,DER1Z,
     +                DER2X,DER2Y,DER2Z,
     +                ALPHA,CC,
     +                L1CACHE,NCTROW,
     +                SPHERIC,
     +
     +                         IMIN,IOPT,
     +                         ZMIN,ZOPT )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE RLEVEC(ICORE,MAXCOR,IUHF,TAU,IORDER,SINGLE,E,
     &                  RLETYP,MAXORD)
C
C THIS ROUTINE FORMS AN EXTRAPOLATED T VECTOR ACCORDING TO THE
C  RLE TAU VECTOR.
C
C   T2(new) = [1 - SUM TAU(k)] T(1) + SUM TAU(k) * T(k)
C                   k                  k
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z,COEFF,TAU,E,SDOT,Z0
      LOGICAL SINGLE,NONHF
      DIMENSION ICORE(MAXCOR),TAU(IORDER)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /RLEIO/ IOLDEST
C
      IGET(I)=1+MOD(IOLDEST+MAXORD-I,MAXORD+1)
C
      NONHF=.FALSE.
      IF(IFLAGS(32).NE.0.OR.IFLAGS(33).NE.0.OR.IFLAGS(38).NE.0)THEN
       NONHF=.TRUE.
      ENDIF
C
C FORM  Z= 1 - SUM TAU(k)
C                k
C
      Z=1.0
      DO 10 I=1,IORDER
       Z=Z-TAU(I)
10    CONTINUE
      IF(RLETYP.EQ.2)E=0.0
      DO 100 ISPIN=3,1,IUHF-2
       SIZET=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
       IF(SINGLE.AND.ISPIN.LT.3)SIZET=SIZET+NT(ISPIN)
       I000=1
       I010=I000+IINTFP*SIZET
       I020=I010+IINTFP*SIZET
       NLIST=60+ISPIN
       CALL IZERO(ICORE(I000),SIZET*IINTFP)
       IF(MOD(RLETYP,2).EQ.0)THEN
C
C FORM  Z*T(1)
C 
        CALL GETLST(ICORE(I000),1,1,1,ISPIN,89)
        CALL SSCAL(SIZET,Z,ICORE(I000),1)
C
C NOW PICK UP ALL OTHER T VECTORS, WEIGHT THEM WITH TAU AND
C  ACCUMULATE INTO BOTTOM OF CORE.
C
       ENDIF
       DO 20 I=1,IORDER
        COEFF=TAU(I)
        CALL GETLST(ICORE(I010),IGET(I),1,1,ISPIN,70)
        CALL SAXPY(SIZET,COEFF,ICORE(I010),1,ICORE(I000),1)
20     CONTINUE
       IF(RLETYP.NE.2.AND.RLETYP.NE.3)THEN
        CALL PUTLST(ICORE(I000),IGET(1),1,1,ISPIN,70)
       ELSE
        CALL PUTLST(ICORE(I000),IGET(1),1,1,ISPIN+3,70)
       ENDIF
C
C NOW OVERWRITE LISTS 61-63 WITH THE UPDATED T2 VECTOR, AND THE
C   T1 LISTS IF THE MODEL IS NOT CCD OR LCCD.
C
       IOFF=1
       DO 30 IRREP=1,NIRREP
        DISSIZ=IRPDPD(IRREP,ISYTYP(1,NLIST))
        NUMDIS=IRPDPD(IRREP,ISYTYP(2,NLIST))
        CALL PUTLST(ICORE(IOFF),1,NUMDIS,1,IRREP,NLIST)
        IOFF=IOFF+NUMDIS*DISSIZ*IINTFP
30     CONTINUE
       IF(SINGLE.AND.ISPIN.LT.3)THEN
        CALL PUTLST(ICORE(IOFF),1,1,1,2+ISPIN,90)
       ENDIF
C
C COMPUTE T1+T2 ENERGY FOR RLE/NOJACOBI METHOD
C
       IF(RLETYP.EQ.2)THEN
        LENT2=(IOFF-1)/IINTFP
        LENT1=SIZET-LENT2
        CALL GETALL(ICORE(I010),LENT2,1,13+ISPIN)
        Z0=SDOT(LENT2,ICORE(I000),1,ICORE(I010),1)
        IF(IUHF.EQ.0.AND.ISPIN.EQ.1)Z0=2.0*Z0
        E=E+Z0
        IF(NONHF.AND.SINGLE.AND.ISPIN.LT.3)THEN
         CALL GETLST(ICORE(I010),1,1,1,2+ISPIN,93)
         Z0=SDOT(LENT1,ICORE(IOFF),1,ICORE(I010),1)
         IF(IUHF.EQ.0.AND.ISPIN.EQ.1)Z0=2.0*Z0
         E=E+Z0
        ENDIF
       ENDIF
100   CONTINUE
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine twork4222(y,na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                     a1,a2,b1,b2,c1,c2,d1,d2,indy,
     *                     x1,ne1,ne2,nf1,nf2,
     *                     e1,e2,f1,f2, indx1,
     *                     x2,ni1,ni2,nj1,nj2,
     *                     i1,i2,j1,j2,indx2,
     *                     flopcount) 
c-------------------------------------------------------------------------
c   Performs a "4222" tensor contraction: 
c      4 index output array 
c      2 index operand array
c      2 index operand array
c      2 index contraction.
c
c--------------------------------------------------------------------------
      implicit none

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ne1,ne2,nf1,nf2,
     *        ni1,ni2,nj1,nj2
      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2,i1,i2,j1,j2
      integer indy(4), indx1(2), indx2(2)
      integer flopcount

      double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
      double precision x1(ne1:ne2,nf1:nf2)
      double precision x2(ni1:ni2,nj1:nj2)

      integer ia, ib, ic, id, ia2, ib2, ic2, id2
      integer ix(0:2), ix2(0:2)
      integer i, j, a, b, c, d

c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various y
c   indices.
c---------------------------------------------------------------------------

      do i = 0,2 
         ix(i) = 0
         ix2(i) = 0
      enddo

      ia = 0
      ib = 0
      ic = 0
      id = 0
      do j = 1, 2
      do i = 1, 4
         if (indx1(j) .eq. indy(i)) then
            if (i .eq. 1) then
               ia = indy(1)
            else if (i .eq. 2) then
               ib = indy(2)
            else if (i .eq. 3) then
               ic = indy(3)
            else 
               id = indy(4)
            endif
         endif 
      enddo
      enddo

      ia2 = 0
      ib2 = 0
      ic2 = 0
      id2 = 0
      do j = 1, 2
      do i = 1, 4
         if (indx2(j) .eq. indy(i)) then
            if (i .eq. 1) then
               ia2 = indy(1)
            else if (i .eq. 2) then
               ib2 = indy(2)
            else if (i .eq. 3) then
               ic2 = indy(3)
            else 
               id2 = indy(4)
            endif
         endif 
      enddo
      enddo

      flopcount = (a2-a1+1)*(b2-b1+1)*(c2-c1+1)*(d2-d1+1)
     
c----------------------------------------------------------------------------
c   ia is the 1st index of x1.
c----------------------------------------------------------------------------

      if (indx1(1) .eq. ia .and. indx1(2) .eq. ib .and.
     *    indx2(1) .eq. ic2 .and. indx2(2) .eq. id2) then
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d) = x1(a,b)*x2(c,d)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ia .and. indx1(2) .eq. ib .and.
     *    indx2(1) .eq. id2 .and. indx2(2) .eq. ic2) then
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
            y(a,b,c,d) = x1(a,b)*x2(d,c)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. ia .and. indx1(2) .eq. ic .and.
     *    indx2(1) .eq. ib2 .and. indx2(2) .eq. id2) then
         do d = d1,d2
         do b = b1,b2
         do c = c1,c2
         do a = a1,a2
            y(a,b,c,d) = x1(a,c)*x2(b,d)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ia .and. indx1(2) .eq. ic .and.
     *    indx2(1) .eq. id2 .and. indx2(2) .eq. ib2) then
         do d = d1,d2
         do b = b1,b2
         do c = c1,c2
         do a = a1,a2
            y(a,b,c,d) = x1(a,c)*x2(d,b)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. ia .and. indx1(2) .eq. id .and.
     *    indx2(1) .eq. ib2 .and. indx2(2) .eq. ic2) then
         do c = c1,c2
         do b = b1,b2
         do d = d1,d2
         do a = a1,a2
            y(a,b,c,d) = x1(a,d)*x2(b,c)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ia .and. indx1(2) .eq. id .and.
     *    indx2(1) .eq. ic2 .and. indx2(2) .eq. ib2) then
         do c = c1,c2
         do b = b1,b2
         do d = d1,d2
         do a = a1,a2
            y(a,b,c,d) = x1(a,d)*x2(c,b)
         enddo
         enddo
         enddo
         enddo

         return
      endif

c-------------------------------------------------------------------------
c   ib is 1st index in x1.
c-------------------------------------------------------------------------

      if (indx1(1) .eq. ib .and. indx1(2) .eq. ia .and.
     *    indx2(1) .eq. ic2 .and. indx2(2) .eq. id2) then
         do d = d1,d2
         do c = c1,c2
         do a = a1,a2
         do b = b1,b2
            y(a,b,c,d) = x1(b,a)*x2(c,d)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ib .and. indx1(2) .eq. ia .and.
     *    indx2(1) .eq. id2 .and. indx2(2) .eq. ic2) then
         do d = d1,d2
         do c = c1,c2
         do a = a1,a2
         do b = b1,b2
            y(a,b,c,d) = x1(b,a)*x2(d,c)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. ib .and. indx1(2) .eq. ic .and.
     *    indx2(1) .eq. ia2 .and. indx2(2) .eq. id2) then
         do d = d1,d2
         do a = a1,a2
         do c = c1,c2
         do b = b1,b2
            y(a,b,c,d) = x1(b,c)*x2(a,d)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ib .and. indx1(2) .eq. ic .and.
     *    indx2(1) .eq. id2 .and. indx2(2) .eq. ia2) then
         do a = a1,a2
         do d = d1,d2
         do c = c1,c2
         do b = b1,b2
            y(a,b,c,d) = x1(b,c)*x2(d,a)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. ib .and. indx1(2) .eq. id .and.
     *    indx2(1) .eq. ia2 .and. indx2(2) .eq. ic2) then
         do c = c1,c2
         do a = a1,a2
         do d = d1,d2
         do b = b1,b2
            y(a,b,c,d) = x1(b,d)*x2(a,c)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ib .and. indx1(2) .eq. id .and.
     *    indx2(1) .eq. ic2 .and. indx2(2) .eq. ia2) then
         do a = a1,a2
         do c = c1,c2
         do d = d1,d2
         do b = b1,b2
            y(a,b,c,d) = x1(b,d)*x2(c,a)
         enddo
         enddo
         enddo
         enddo

         return
      endif

c----------------------------------------------------------------------------
c   ic is the 1st index of x1.
c----------------------------------------------------------------------------

      if (indx1(1) .eq. ic .and. indx1(2) .eq. ib .and.
     *    indx2(1) .eq. ia2 .and. indx2(2) .eq. id2) then
         do d = d1,d2
         do a = a1,a2
         do b = b1,b2
         do c = c1,c2
            y(a,b,c,d) = x1(c,b)*x2(a,d)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ic .and. indx1(2) .eq. ib .and.
     *    indx2(1) .eq. id2 .and. indx2(2) .eq. ia2) then
         do a = a1,a2
         do d = d1,d2
         do b = b1,b2
         do c = c1,c2
            y(a,b,c,d) = x1(c,b)*x2(d,a)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. ic .and. indx1(2) .eq. ia .and.
     *    indx2(1) .eq. ib2 .and. indx2(2) .eq. id2) then
         do d = d1,d2
         do b = b1,b2
         do a = a1,a2
         do c = c1,c2
            y(a,b,c,d) = x1(c,a)*x2(b,d)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ic .and. indx1(2) .eq. ia .and.
     *    indx2(1) .eq. id2 .and. indx2(2) .eq. ib2) then
         do d = d1,d2
         do b = b1,b2
         do a = a1,a2
         do c = c1,c2
            y(a,b,c,d) = x1(c,a)*x2(d,b)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. ic .and. indx1(2) .eq. id .and.
     *    indx2(1) .eq. ib2 .and. indx2(2) .eq. ia2) then
         do a = a1,a2
         do b = b1,b2
         do d = d1,d2
         do c = c1,c2
            y(a,b,c,d) = x1(c,d)*x2(b,a)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. ic .and. indx1(2) .eq. id .and.
     *    indx2(1) .eq. ia2 .and. indx2(2) .eq. ib2) then
         do b = b1,b2
         do a = a1,a2
         do d = d1,d2
         do c = c1,c2
            y(a,b,c,d) = x1(c,d)*x2(a,b)
         enddo
         enddo
         enddo
         enddo

         return
      endif

c----------------------------------------------------------------------------
c   id is the 1st index of x1.
c----------------------------------------------------------------------------

      if (indx1(1) .eq. id .and. indx1(2) .eq. ib .and.
     *    indx2(1) .eq. ic2 .and. indx2(2) .eq. ia2) then
         do a = a1,a2
         do c = c1,c2
         do b = b1,b2
         do d = d1,d2
            y(a,b,c,d) = x1(d,b)*x2(c,a)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. id .and. indx1(2) .eq. ib .and.
     *    indx2(1) .eq. ia2 .and. indx2(2) .eq. ic2) then
         do c = c1,c2
         do a = a1,a2
         do b = b1,b2
         do d = d1,d2
            y(a,b,c,d) = x1(d,b)*x2(a,c)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. id .and. indx1(2) .eq. ic .and.
     *    indx2(1) .eq. ib2 .and. indx2(2) .eq. ia2) then
         do a = a1,a2
         do b = b1,b2
         do c = c1,c2
         do d = d1,d2
            y(a,b,c,d) = x1(d,c)*x2(b,a)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. id .and. indx1(2) .eq. ic .and.
     *    indx2(1) .eq. ia2 .and. indx2(2) .eq. ib2) then
         do b = b1,b2
         do a = a1,a2
         do c = c1,c2
         do d = d1,d2
            y(a,b,c,d) = x1(d,c)*x2(a,b)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      if (indx1(1) .eq. id .and. indx1(2) .eq. ia .and.
     *    indx2(1) .eq. ib2 .and. indx2(2) .eq. ic2) then
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
         do d = d1,d2
            y(a,b,c,d) = x1(d,a)*x2(b,c)
         enddo 
         enddo 
         enddo 
         enddo 

         return
      endif

      if (indx1(1) .eq. id .and. indx1(2) .eq. ia .and.
     *    indx2(1) .eq. ic2 .and. indx2(2) .eq. ib2) then
         do c = c1,c2
         do b = b1,b2
         do a = a1,a2
         do d = d1,d2
            y(a,b,c,d) = x1(d,a)*x2(c,b)
         enddo
         enddo
         enddo
         enddo

         return
      endif

      print *,'twork4222: Your tensor operation does not fit',
     *    ' any valid pattern'
      call abort_job() 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine write_blocks_to_list(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c---------------------------------------------------------------------------
c   Wrapper routine for write_blcoks_to_list instruction.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      if (mpi_io_support) then
         call write_blocks_to_list_mpi_io(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      else
         call write_blocks_to_list_no_mpi_io(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      endif

      return
      end

      subroutine write_blocks_to_list_mpi_io(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Dumps all blocks of an array to a list.
c--------------------------------------------------------------------------

      implicit none
      include 'aces3_version.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'block_index.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 index_file_loc, data_file_loc, offset
      integer*8 size
      integer i, company, niocompany, nbarray
      integer array, type, iarray
      integer fh, fhndx, mode, ierr
      integer*8 bdata_table(2,narray_list)
      integer comm, company_comm, pst_get_company_comm, pst_get_company
      integer msg(len_sip_server_message)
      integer*8 msg8(len_sip_server_message/2)
      equivalence (msg, msg8)

      integer*8 indblk, get_block_index
      integer blkndx, val1, val2, stack, iblock_map, iblock, seg, ind, k
      integer nindex, nreq
      integer bseg(mx_array_index)
      integer eseg(mx_array_index)

      integer mx_mpi_req
      parameter (mx_mpi_req = 150000)
      integer request(mx_mpi_req)
      integer statuses(MPI_STATUS_SIZE, mx_mpi_req)
      integer status(MPI_STATUS_SIZE)

      integer block_index_entry(lblk_index_entry)

      logical served_data

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (aces3_version .eq. '3.0.3') then
    
c--------------------------------------------------------------------------
c   Write BLOCK_INDEX_FORMAT file, used to check for proper format on
c   restart.
c--------------------------------------------------------------------------

         open (unit=29, file='BLOCK_INDEX_FORMAT')
         write (29,*) aces3_version
         close(29)
      endif

c---------------------------------------------------------------------------
c   Pre-calculate each array's position in the BLOCKDATA file.
c---------------------------------------------------------------------------

#ifdef ALTIX
      dptr = dshptr
#endif
      data_file_loc  = 0
      index_file_loc = 0
      served_data = .false.
      company_comm = pst_get_company_comm(me)

      do iarray = 1, narray_list
         array = array_list(iarray)
         type  = array_table(c_array_type,array)
         if (type .ne. distributed_array .and.
     *       type .ne. served_array) then
            print *,'Error: BLOCKS_TO_LIST array must be either ',
     *        'a distributed or served array.'
            print *,'Array ',array,' has type = ',type
            call abort_job()
         endif

         if (type .eq. served_array) served_data = .true.
         nbarray = array_table(c_numblks,array) 
         call determine_array_size(array, array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      size)

         bdata_table(1, iarray) = index_file_loc
         bdata_table(2, iarray) = data_file_loc
         index_file_loc  = index_file_loc + nbarray * lblk_index_entry
         data_file_loc  = data_file_loc + size
      enddo

c-----------------------------------------------------------------------------
c   Open the files.
c-----------------------------------------------------------------------------

      if (served_data) then
         comm = mpi_comm_world

c--------------------------------------------------------------------------
c   Send a blocks_to_list "open" message (i. e. array = 0) to each server.
c--------------------------------------------------------------------------

         if (me .eq. 0) then
            msg(1) = sip_server_blocks_to_list
            msg(2) = 0         ! signal to open the files.
            msg(3) = 0         ! nindex
            niocompany = 0
            do i = 1, nprocs
               company = pst_get_company(i-1)
               if (company .eq. io_company_id) then
                  niocompany = niocompany + 1
                  call mpi_isend(msg, len_sip_server_message,
     *                     mpi_integer,
     *                     i-1, sip_server_message,
     *                     mpi_comm_world,
     *                     request(niocompany), ierr)
               endif
            enddo
         endif   ! me .eq. 0
      else
         comm = pst_get_company_comm(me)
      endif

      mode = MPI_MODE_CREATE + MPI_MODE_WRONLY
      call mpi_file_open(comm, 'BLOCKDATA2', mode,
     *                   MPI_INFO_NULL, fh, ierr)
      offset = 0
      call mpi_file_set_view(fh, offset, MPI_DOUBLE_PRECISION,
     *                       MPI_DOUBLE_PRECISION, 'native',
     *                       MPI_INFO_NULL, ierr)

      call mpi_file_open(comm, 'BLOCK_INDEX2', mode,
     *                   MPI_INFO_NULL, fhndx, ierr)
      offset = 0
      call mpi_file_set_view(fhndx, offset, MPI_INTEGER,
     *                       MPI_INTEGER, 'native',
     *                       MPI_INFO_NULL, ierr)

c-----------------------------------------------------------------------------
c   Wait for completion of the server messages.
c-----------------------------------------------------------------------------

      if (me .eq. 0 .and. served_data) then
         call mpi_waitall(niocompany, request, statuses, ierr)
      endif

c---------------------------------------------------------------------------
c   Process each array.
c---------------------------------------------------------------------------

      do iarray = 1, narray_list
         array          = array_list(iarray)
         type           = array_table(c_array_type,array)
         nindex         = array_table(c_nindex,array)
         iblock_map     = array_table(c_block_map, array)
         index_file_loc = bdata_table(1,iarray)
         data_file_loc  = bdata_table(2,iarray)
 
         if (type .eq. served_array) then
            
c---------------------------------------------------------------------------
c   Send a blocks_to_list message to each server.
c---------------------------------------------------------------------------

            msg(1) = sip_server_blocks_to_list
            msg(2) = array
            msg(3) = 0         ! nindex
            niocompany = 0
            do i = 1, nprocs
               company = pst_get_company(i-1)
               if (company .eq. io_company_id) then

                  msg8(2) = index_file_loc
                  msg8(3) = data_file_loc

                  call determine_server_contribution(array, i-1,
     *                      array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      nbarray, size)

                  if (me .eq. 0) then 
                     niocompany = niocompany + 1
                     call mpi_isend(msg, len_sip_server_message, 
     *                  mpi_integer,
     *                  i-1, sip_server_message,
     *                  mpi_comm_world,
     *                  request(niocompany), ierr)
                  endif

                  data_file_loc  = data_file_loc + size
                  index_file_loc = index_file_loc + 
     *                             nbarray * lblk_index_entry
               endif
            enddo

            if (me .eq. 0) then

c--------------------------------------------------------------------------
c   Wait for completion of server messages.
c--------------------------------------------------------------------------

               call mpi_waitall(niocompany, request, 
     *                          statuses, ierr)
            endif   ! me .eq. 0 
         else

c---------------------------------------------------------------------------
c   Process the blocks of a distributed array.
c---------------------------------------------------------------------------

            nreq = 0
            offset = data_file_loc
            nbarray = array_table(c_numblks, array)
            do iblock = 1, nbarray

c--------------------------------------------------------------------------
c   Determine block size in words.
c--------------------------------------------------------------------------

               blksize = 1
               do k = 1, nindex
                  ind = array_table(c_index_array1+k-1,array)
                  seg = block_map_table(c_block_map_seg+k-1,
     *                       iblock_map+iblock-1)
                  call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
                  bseg(k) = val1
                  eseg(k) = val2
                  blksize = blksize * (val2-val1+1)
               enddo

               blkndx = block_map_table(c_bmap_blkndx,
     *                                  iblock_map+iblock-1)
               if (block_map_table(c_processor,iblock_map+iblock-1) 
     *                .eq. my_company_rank) then

c----------------------------------------------------------------------------
c   The block resides on this processor.   Write it to disk.
c----------------------------------------------------------------------------

                  stack  = array_table(c_array_stack,array)
                  indblk = get_block_index(array, iblock, stack, 
     *                               blkndx, x, .true.)

                  if (nreq .eq. mx_mpi_req) then
                     call mpi_waitall(nreq, request, statuses, ierr)
                     nreq = 0
                  endif

                  nreq = nreq + 1
                  call mpi_file_iwrite_at(fh, offset, x(indblk),
     *                     blksize, MPI_DOUBLE_PRECISION, request(nreq),
     *                     ierr)

c---------------------------------------------------------------------------
c   Create the BLOCK_INDEX entry for this block.
c---------------------------------------------------------------------------
    
                  block_index_entry(c_blk_index_array) = array
                  block_index_entry(c_blk_index_blkno) = iblock
                  block_index_entry(c_blk_index_size)  = blksize
                  block_index_entry(c_blk_index_nind)  = nindex
                  do k = 1, nindex
                     block_index_entry(c_blk_index_bsegs+k-1) = bseg(k)
                     block_index_entry(c_blk_index_esegs+k-1) = eseg(k)
                  enddo
 
c---------------------------------------------------------------------------
c   Write the BLOCK_INDEX entry.
c---------------------------------------------------------------------------

                  call mpi_file_write_at(fhndx, index_file_loc, 
     *                  block_index_entry, lblk_index_entry,
     *                  MPI_INTEGER, status,
     *                  ierr)
               endif

               offset = offset + blksize
               index_file_loc = index_file_loc + lblk_index_entry
            enddo    ! iblock

c--------------------------------------------------------------------------
c   Wait for completion of any dist. data blocks.
c---------------------------------------------------------------------------

            if (nreq .gt. 0) call mpi_waitall(nreq, request, 
     *                                        statuses, ierr)
         endif
      enddo

c---------------------------------------------------------------------------
c   Send servers the signal to close their files.
c---------------------------------------------------------------------------

      if (me .eq. 0 .and. served_data) then
         msg(1) = sip_server_blocks_to_list
         msg(2) = blocks_list_done

         niocompany = 0
         do i = 1, nprocs
            company = pst_get_company(i-1)
            if (company .eq. io_company_id) then
               niocompany = niocompany + 1
               call mpi_isend(msg, len_sip_server_message, 
     *                  mpi_integer,
     *                  i-1, sip_server_message,
     *                  mpi_comm_world,
     *                  request(niocompany), ierr)

            endif
         enddo

c--------------------------------------------------------------------------
c   Wait for completion of server messages.
c--------------------------------------------------------------------------

         call mpi_waitall(niocompany, request, statuses, ierr)
      endif

c--------------------------------------------------------------------------
c   Sync the data and close the files.
c   Wait until all in the worker's company have finished processing.
c--------------------------------------------------------------------------

      call mpi_barrier(company_comm, ierr)
      call mpi_file_sync(fh, ierr)
      call mpi_file_close(fh, ierr)
      call mpi_file_sync(fhndx, ierr)
      call mpi_file_close(fhndx, ierr)

c--------------------------------------------------------------------------
c   Rename the files to their actual values.
c--------------------------------------------------------------------------

      if (me .eq. 0) then
         call f_renamefile('BLOCKDATA2'//char(0), 'BLOCKDATA'//char(0))
         call f_renamefile('BLOCK_INDEX2'//char(0), 
     *                      'BLOCK_INDEX'//char(0))
         
      endif
      return
      end

      subroutine determine_server_contribution(array, proc,
     *                      array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      nb, size)
c---------------------------------------------------------------------------
c   Calculates the number of blocks and number of words contained in all
c   the blocks of an array residing on server "proc".
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'

      integer array, proc
      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nb
      integer*8 size

      integer nindex, nblk, iblock_map, iblock, i,k, blksize
      integer ind, seg, val1, val2
      nb = 0
      size = 0

      nindex     = array_table(c_nindex,array)
      nblk       = array_table(c_numblks, array)
      iblock_map = array_table(c_block_map, array)

      do iblock = 1, nblk
         if (block_map_table(c_processor,iblock_map+iblock-1) 
     *                                    .eq. proc) then
            nb = nb + 1

            blksize = 1
            do k = 1, nindex
               ind = array_table(c_index_array1+k-1,array)
               seg = block_map_table(c_block_map_seg+k-1,
     *                       iblock_map+iblock-1)
               call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
               blksize = blksize * (val2-val1+1)
            enddo

            size = size + blksize
         endif
      enddo

      return
      end

      double precision function block_energy(x, n)
      integer n
      double precision x(1)

      integer i
      double precision sum

      sum = 0.
      do i = 1, n
         sum = sum + x(i) * x(i)
      enddo

      block_energy = sum
      return
      end

c     finds the index of element having min. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     anthony yau, modified directly from idamin

      integer function iiamin(n,iarray,incx)
      integer n,iarray(*),incx
      integer i,ix,imin,itmp

      if (n.lt.2) then
         if (n.eq.1) then
            iiamin=1
         else
            iiamin=0
         end if
         return
      end if

      itmp=1
      imin=abs(iarray(1))
      if (incx.eq.1) then
         do i=2,n
            if (abs(iarray(i)).lt.imin) then
               if (iarray(i).ne.0) then
                  itmp=i
                  imin=abs(iarray(i))
               else
                  iiamin=i
                  return
               end if
            end if
         end do
      else
         ix=1
         do i=2,n
            ix=ix+incx
            if (abs(iarray(ix)).lt.imin) then
               if (iarray(ix).ne.0) then
                  itmp=i
                  imin=abs(iarray(ix))
               else
                  iiamin=i
                  return
               end if
            end if
         end do
      end if
      iiamin=itmp

      return
      end

      SUBROUTINE SYMRHF(IRREP,NUML,NUMR,DISSIZE,A,SCR,ISCRL,ISCRR)
C
C  THIS ROUTINE FORMS THE TERM 
C
C   A(I,J,K,L) --> A(I,J,K,L) + A(J,I,L,K)  
C
C  WHICH IS REQUIRED IN RHF CCSD CALCULATIONS
C
C  INPUT :  IRREP  ...   IRREP OF   G(K)*G(L) = G(I)*G(J)
C           NUMR   ....  POPULATION VECTOR FOR K,L
C           NUML   ....  POPULATION VECTOR FOR I,J
C           DISSIZE ...  DISTRIBUTION SIZE OF A
C           A      ....  HOLDS THE MATRIX A         
C           SCR,ISCRL,ISCRR ... THREE SCRATCH ARRAYS OF SIZE DISSIZE
C
C  OUTPUT :  A     ....  THE RHF SYMMETRIZED MATRIX
C
CEND
C
C  WRITTEN IN SEPTEMBER/90   JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DISSIZE,DIRPRD
      DIMENSION A(DISSIZE,1),SCR(1),ISCRL(1),ISCRR(2),NUMR(8),NUML(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      DIMENSION IPL(8),IPR(8)
C
      IPR(1)=0
      IPL(1)=0          
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IPR(IRREPJ+1)=IPR(IRREPJ)+NUMR(IRREPJ)*NUMR(IRREPI)
       IPL(IRREPJ+1)=IPL(IRREPJ)+NUML(IRREPJ)*NUML(IRREPI)
10    CONTINUE
       
C
C  GET FIRST THE NEW ADDRESSES AND STORE THEM IN ISCR
C
C ADDRESSES FOR THE RIGHT SIDE
C
      NTOTAL=0
      DO 20  IRREPJ=1,NIRREP
       NUMJ=NUMR(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUMR(IRREPI)
       NTOTAL=NTOTAL+NUMI*NUMJ
       DO 15 J=1,NUMJ
       DO 15 I=1,NUMI
        IND1=IPR(IRREPJ)+(J-1)*NUMI+I
        IND2=IPR(IRREPI)+(I-1)*NUMJ+J
        ISCRR(IND1)=IND2
15     CONTINUE
20    CONTINUE
C
C  ADDRESSES FOR THE LEFT SIDE
C
      DO 120  IRREPJ=1,NIRREP
       NUMJ=NUML(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUML(IRREPI)
        DO 115 J=1,NUMJ
        DO 115 I=1,NUMI
         IND1=IPL(IRREPJ)+(J-1)*NUMI+I
         IND2=IPL(IRREPI)+(I-1)*NUMJ+J
         ISCRL(IND1)=IND2
115     CONTINUE
120    CONTINUE
C
C  NOW FORM A(IJ,KL) + A(JI,LK)
C
      DO 100 IJ=1,NTOTAL
       IF(ISCRR(IJ).NE.0) THEN
        IJTR=ISCRR(IJ) 
        ISCRR(IJTR)=0
        DO 3 L=1,DISSIZE
         SCR(L)=A(L,IJ)+A(ISCRL(L),IJTR)
3       CONTINUE
        DO 4 L=1,DISSIZE
         A(L,IJ)=SCR(L)
4       CONTINUE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
        DO 5 L=1,DISSIZE
         A(ISCRL(L),IJTR)=SCR(L)
5       CONTINUE
       ENDIF
100   CONTINUE
      RETURN
      END

      SUBROUTINE T1RC02(ICORE,MAXCOR,IUHF,LAMBDA)
C
C THIS SUBROUTINE COMPUTES TWO T1*W CONTRIBUTIONS TO THE
C  W(mbej) INTERMEDIATE.  
C
C     W(mBeJ) =   SUM T(J,F) * <Fe|Bm> - T(N,B) * <Nm|Je>
C     W(MbEj) =   SUM T(j,f) * <fE|bM> - T(n,b) * <nM|jE>
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL LAMBDA,CHANGE
      DOUBLE PRECISION ONE,ONEM,ZILCH,ALPHA,BETA,FACTOR
      CHARACTER*4 SSTSPN
      LOGICAL INCORE,RHF
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2),IOFFZL(8,4)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,
     &             NF1BB,NF2BB
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
      CHANGE=.TRUE.
      RHF=.FALSE.
      IF(IUHF.EQ.0)RHF=.TRUE.
C
C FIRST PICK UP T1 VECTOR.
C
      CALL GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
C
C SPIN CASES ABAB AND BABA, RESPECTIVELY.
C
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=55+ISPIN
       IF(LAMBDA)THEN
        LSTOUT=119-ISPIN
        FACTOR=ONEM
       ELSE
        LSTOUT=LSTTAR
        FACTOR=ONE
       ENDIF
 
C
C RESET THE TARGET LIST PARAMETERS BECAUSE IT MUST FIRST BE USED AS A
C  SCRATCH LIST FOR A LIST WHICH IS PACKED DIFFERENTLY.
C
       IF(IUHF.NE.0)THEN
        LSTSCR=37+ISPIN
        CALL NEWTYP(LSTOUT,ISYTYP(1,LSTSCR),ISYTYP(2,LSTSCR),CHANGE)
       ENDIF
C
C LOOP OVER IRREPS - IN THE FIRST BLOCK OF CODE THIS CORRESPONDS TO mB,
C                    WHILE IT IS jE IN THE SECOND BLOCK.
C
C     W(MbEj) =   SUM T(j,f) * <fE|bM> - T(n,b) * <nM|jE>
C     W(mBeJ) =   SUM T(J,F) * <Fe|Bm> - T(N,B) * <Nm|Je>
C
       DO 20 IRREPDO=1,NIRREP
C
C COMPUTE OFFSETS INTO AN i,A DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 1)
C                         I,a DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 2)
C                         b,M DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 3)
C                         B,m DISTRIBUTION FOR THIS IRREP (RIGHT INDEX - 4)
C
        IOFF1=0
        IOFF2=0
        IOFF3=0
        IOFF4=0
        DO 1001 IRREPA=1,NIRREP
         IRREPM=IRREPA
         IRREPI=DIRPRD(IRREPA,IRREPDO)
         IRREPB=IRREPI
         IOFFZL(IRREPA,1)=IOFF1
         IOFFZL(IRREPA,2)=IOFF2
         IOFFZL(IRREPM,3)=IOFF3
         IOFFZL(IRREPM,4)=IOFF4
         IOFF1=IOFF1+POP(IRREPI,2)*VRT(IRREPA,1)
         IOFF2=IOFF2+POP(IRREPI,1)  *VRT(IRREPA,2)
         IOFF3=IOFF3+VRT(IRREPB,2)*POP(IRREPM,1)
         IOFF4=IOFF4+VRT(IRREPB,1)  *POP(IRREPM,2)
1001    CONTINUE
C
C COMPUTE DIMENSIONS OF TARGET MATRIX.
C
        DSZTAR=IRPDPD(IRREPDO,ISYTYP(1,LSTOUT))
        DISTAR=IRPDPD(IRREPDO,ISYTYP(2,LSTOUT))
        DSZTMP=IRPDPD(IRREPDO,10+ISPIN)
        DISTMP=IRPDPD(IRREPDO,13-ISPIN)
C
C FIRST DO       W(MbEj) =   SUM T(j,f) * <Ef|Mb> (ISPIN=1)
C                W(mBeJ) =   SUM T(J,F) * <Fe|Bm> (ISPIN=2 OR RHF).
C
C THIS PRODUCT IS INITIALLY PACKED j,E-M,b [J,e;B,m].
C
        LISTW1=28+ISPIN
        IF(RHF)LISTW1=30
        DISW  =aces_list_cols(IRREPDO,LISTW1)
        DSZW  =aces_list_rows(IRREPDO,LISTW1)
C
C I000 HOLDS THE W(jEMb) [W(JemB)] TARGET FOR GAMMA(Mb [Bm]).
C I010 HOLDS AREA EVENTUALLY USED AS SCRATCH IN SYMTR.
C I020 HOLDS THE <Ef|Mb> [<Fe|Bm>] INTEGRALS.
C
        I000  =1
        I010  =I000+IINTFP*DISTMP*DSZTMP
        CALL IZERO(ICORE,IINTFP*DSZTMP*DISTMP)
        I011  =I010+IINTFP*MAX(DISTMP,DSZTMP)
        I012  =I011+IINTFP*MAX(DSZTMP,DISTMP)
        I020  =I012+IINTFP*MAX(DSZTMP,DISTMP)
        I030  =I020+IINTFP*DSZW*DISW
        IF(I030.LE.MXCOR)THEN
         INCORE=.TRUE.
         CALL GETLST(ICORE(I020),1,DISW,2,IRREPDO,LISTW1)
        ELSE
         INCORE=.FALSE.
         I030=I020+IINTFP*DSZW
        ENDIF
        DO 30 INUMBM=1,DISW
         IF(INCORE)THEN
          IOFFW1R=(INUMBM-1)*DSZW*IINTFP+I020
         ELSE
          CALL GETLST(ICORE(I020),INUMBM,1,2,IRREPDO,LISTW1)
          IOFFW1R=I020
         ENDIF
         IOFFW1L=0
         IOFFZR=(INUMBM-1)*DSZTMP*IINTFP+I000
C
C FIRST DO       W(MbEj) =   SUM T(j,f) * <Ef|Mb> (ISPIN=1)
C                W(mBeJ) =   SUM T(J,F) * <Fe|Bm> (ISPIN=2 OR RHF).
C
         IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
          DO 40 IRREPF=1,NIRREP
           IRREPT=IRREPF
           IRREPE=DIRPRD(IRREPF,IRREPDO) 
           IOFFT=IOFFT1(IRREPT,2)
           IOFFW1=IOFFW1R+IOFFW1L
           IOFFZ=IOFFZR+IOFFZL(IRREPE,1)*IINTFP
           NROW=POP(IRREPT,2)
           NCOL=VRT(IRREPE,1)
           NSUM=VRT(IRREPT,2)
           ALPHA=ONE*FACTOR
           BETA=ZILCH
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN 
            CALL XGEMM('T','T',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NSUM,
     &                 ICORE(IOFFW1),NCOL,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW1L=IOFFW1L+NCOL*NSUM*IINTFP
40        CONTINUE
         ELSEIF(ISPIN.EQ.2.OR.RHF)THEN
          DO 41 IRREPE=1,NIRREP
           IRREPT=DIRPRD(IRREPE,IRREPDO)
           IRREPF=IRREPT
           IOFFT=IOFFT1(IRREPT,1)
           IOFFW1=IOFFW1R+IOFFW1L
           IOFFZ=IOFFZR+IOFFZL(IRREPE,2)*IINTFP
           NROW=POP(IRREPT,1)
           NCOL=VRT(IRREPE,2)
           NSUM=VRT(IRREPF,1)
           ALPHA=ONE*FACTOR
           BETA=ZILCH
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('T','N',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NSUM,
     &                 ICORE(IOFFW1),NSUM,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW1L=IOFFW1L+NCOL*NSUM*IINTFP
41        CONTINUE
         ENDIF
30      CONTINUE
C
C NOW WE HAVE A jE-Mb (ISPIN=1) OR Je-Bm (ISPIN=2 OR RHF) ORDERED
C  QUANTITY.  THE NEXT PIECE WILL BE ORDERED bM-Ej (ISPIN=1) OR
C  Bm-Je (ISPIN=2 OR RHF), SO WE NEED TO REORDER WHAT WE HAVE TO MATCH
C  THIS, THEREBY ALLOWING ACCUMULATION IN MATRIX MULTIPLY OPERATIONS.
C
        IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
         CALL SYMTR1(IRREPDO,POP(1,1),VRT(1,2),DSZTMP,ICORE(I000),
     &              ICORE(I010),ICORE(I011),ICORE(I012))
         CALL SYMTR3(IRREPDO,POP(1,2),VRT(1,1),DSZTMP,DISTMP,
     &               ICORE(I000),ICORE(I010),ICORE(I011),
     &               ICORE(I012))
        ENDIF
        CALL TRANSP(ICORE(I000),ICORE(I010),DISTMP,DSZTMP)
c YAU : old
c       CALL ICOPY(DISTMP*DSZTMP*IINTFP,ICORE(I010),1,ICORE(I000),1)
c YAU : new
        CALL DCOPY(DISTMP*DSZTMP,ICORE(I010),1,ICORE(I000),1)
c YAU : end
C
C NOW DO    W(MbEj) =   - T(n,b) * <Mn|Ej>   (ISPIN=1)
C           W(mBeJ) =   - T(N,B) * <Nm|Je>   (ISPIN=2 OR RHF)
C
        LISTW2=8+ISPIN
        IF(RHF)LISTW2=10
        DSZTMP=IRPDPD(IRREPDO,13-ISPIN)
        DISTMP=IRPDPD(IRREPDO,10+ISPIN)
        DISW  =aces_list_cols(IRREPDO,LISTW2)
        DSZW  =aces_list_rows(IRREPDO,LISTW2)
C
C I020 NOW HOLDS THE <Mn|Ej> [<Nm|jE>] INTEGRALS.
C
        I020  =I010+IINTFP*DSZW
        I030  =I020+IINTFP*DSZW*DISW
        IF(I030.LE.MXCOR)THEN
         INCORE=.TRUE.
         CALL GETLST(ICORE(I020),1,DISW,2,IRREPDO,LISTW2)
        ELSE
         INCORE=.FALSE.
         I030=I020+IINTFP*DSZW
        ENDIF
        DO 50 INUMEJ=1,DISW
         IF(INCORE)THEN
          IOFFW2R=(INUMEJ-1)*DSZW*IINTFP+I020
         ELSE
          CALL GETLST(ICORE(I020),INUMEJ,1,2,IRREPDO,LISTW2)
          IOFFW2R=I020
         ENDIF
         IOFFW2L=0
         IOFFZR=(INUMEJ-1)*DSZTMP*IINTFP+I000
C
C NOW DO    W(MbEj) =   - T(n,b) * <Mn|Ej>   (ISPIN=1)
C           W(mBeJ) =   - T(N,B) * <Nm|Je>   (ISPIN=2 OR RHF)
C
         IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
          DO 60 IRREPN=1,NIRREP
           IRREPM=DIRPRD(IRREPN,IRREPDO)
           IRREPT=IRREPN
           IOFFT=IOFFT1(IRREPT,2)
           IOFFW2=IOFFW2R+IOFFW2L
           IOFFZ=IOFFZR+IOFFZL(IRREPM,3)*IINTFP
           NROW=VRT(IRREPT,2)
           NCOL=POP(IRREPM,1)
           NSUM=POP(IRREPN,2)
           ALPHA=ONEM*FACTOR
           BETA=ONE
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('N','T',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NROW,
     &                 ICORE(IOFFW2),NCOL,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW2L=IOFFW2L+NCOL*NSUM*IINTFP
60        CONTINUE
         ELSEIF(ISPIN.EQ.2.OR.RHF)THEN
          DO 61 IRREPM=1,NIRREP
           IRREPN=DIRPRD(IRREPM,IRREPDO)
           IRREPT=IRREPN
           IOFFT=IOFFT1(IRREPT,1)
           IOFFW2=IOFFW2R+IOFFW2L
           IOFFZ=IOFFZR+IOFFZL(IRREPM,4)*IINTFP
           NROW=VRT(IRREPT,1)
           NCOL=POP(IRREPM,2)
           NSUM=POP(IRREPN,1)
           ALPHA=ONEM*FACTOR
           BETA=ONE
           IF(MIN(NROW,NCOL,NSUM).GT.0)THEN
            CALL XGEMM('N','N',NROW,NCOL,NSUM,ALPHA,ICORE(IOFFT),NROW,
     &                 ICORE(IOFFW2),NSUM,BETA,ICORE(IOFFZ),NROW)
           ENDIF
           IOFFW2L=IOFFW2L+NCOL*NSUM*IINTFP
61        CONTINUE
         ENDIF
50      CONTINUE
C
C REORDER TO 
C           bM-Ej ->  bM-Ej (ISPIN=1)
C           Bm-Je ->  Bm-eJ (ISPIN=2 OR RHF)
C     
        IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
         CONTINUE
         SSTSPN='BAAB'
        ELSE
         CALL SYMTR1(IRREPDO,POP(1,1),VRT(1,2),DSZTMP,
     &               ICORE(I000),ICORE(I010),ICORE(I011),
     &               ICORE(I012))
         SSTSPN='ABBA'
        ENDIF
C
C NOW WRITE THESE TO DISK FOR EACH IRREP.  
C
        CALL PUTLST(ICORE(I000),1,DISTMP,1,IRREPDO,LSTOUT)
20     CONTINUE
C
C NOW SWITCH ORDERING 
C
C                   bM-Ej -> bj-EM (ISPIN=1)
C                   Bm-eJ -> BJ-em (ISPIN=2 OR RHF)
C
       ISCSIZ=(NVRTO(1)+NVRTO(2))*(NOCCO(1)+NOCCO(2))
       TARSIZ=ISYMSZ(ISYTYP(1,LSTTAR),ISYTYP(2,LSTTAR))
       I000=1
       I010=I000+TARSIZ*IINTFP
       I020=I010+TARSIZ*IINTFP
       I030=I020+ISCSIZ
       IF(I030.GT.MXCOR)CALL INSMEM('T1RABBA',I030,MXCOR)
       CALL GETALL(ICORE(I010),TARSIZ,1,LSTOUT)
       CALL SSTRNG(ICORE(I010),ICORE(I000),TARSIZ,TARSIZ,ICORE(I020),
     &             SSTSPN)
C
C NOW TRANSPOSE AND WRITE TO DISK IRREP BY IRREP.
C
       IOFF=1
       IF(IUHF.NE.0)CALL NEWTYP(LSTOUT,8+ISPIN,11-ISPIN,CHANGE)
       DO 5000 IRREP=1,NIRREP
        DSZTAR=aces_list_rows(IRREP,LSTTAR)
        DISTAR=aces_list_cols(IRREP,LSTTAR)
        CALL TRANSP(ICORE(IOFF),ICORE(I010),DSZTAR,DISTAR)
C
C  FOR LAMBDA UPDATE TARGET LIST AND COPY ORIGINAL LIST TO LSTOUT
C
        IF(LAMBDA) THEN
         CALL GETLST(ICORE(IOFF),1,DISTAR,2,IRREP,LSTTAR)
         CALL PUTLST(ICORE(IOFF),1,DISTAR,2,IRREP,LSTOUT)
         CALL SAXPY(DSZTAR*DISTAR,ONE,ICORE(IOFF),1,ICORE(I010),1)
        ENDIF
C
        CALL PUTLST(ICORE(I010),1,DISTAR,2,IRREP,LSTTAR)
        IOFF=IOFF+IINTFP*DISTAR*DSZTAR
5000   CONTINUE 
10    CONTINUE
      RETURN
      END

c This routine reads a character string from the job archive.

c WARNING!
c    The "record length" that is associated with the logical record is the
c number of whole integers that contain the string. Therefore, calling getrec
c with IFLAG=0 may not return the actual length of the string.

c INPUT
c int      IFLAG     : (same as getrec)
c char*(*) SZARCHIVE : (same as getrec)
c char*(*) SZRECNAME : (same as getrec)

c INPUT/OUTPUT
c int ILENGTH : on input, this is the substring-length of the record to get
c               on output, if IFLAG=0, the string-length of the logical record
c                  is returned

c OUTPUT
c char*(*) SZDEST : (same as getrec)

#define _MAXLEN 256 /* 1024 or 2048 characters */

#ifdef F_64BIT
#  define _IINTLN 8
#else
#  define _IINTLN 4
#endif

      subroutine getcrec(iFlag,szArchive,szRecName,iLength,szDest)
      implicit none

c ARGUMENTS
      integer iFlag, iLength
      character*(*) szArchive, szRecName, szDest

c INTERNAL VARIABLES
      integer i, iNdx, nLeft, iBuf(_MAXLEN), iRecLen

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert substring fits in iBuf
      if (iLength.gt.(_MAXLEN*_IINTLN)) then
         print *, '@GETCREC: Assertion failed.'
         print *, '   iLength = ',iLength
         print *, '   maximum = ',_MAXLEN*_IINTLN
         i = 1
      endif
c   o assert substring is within szDest
      if (len(szDest).lt.iLength) then
         print *, '@GETCREC: Assertion failed.'
         print *, '   iLength = ',iLength
         print *, '   len(sz) = ',len(szDest)
         i = 1
      endif
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o assume the length of the record from iLength
      iRecLen = (iLength+_IINTLN-1)/_IINTLN

c   o read from the job archive
      call getrec(iFlag,szArchive,szRecName,iRecLen,iBuf)

c   o comply with getrec queries
      if (iFlag.eq.0) then
         iLength = iRecLen*_IINTLN
         return
      end if

c   o iNdx is the moving szDest index
      iNdx = 1

c   o iRecLen is the number of whole integers that contain szDest(1:iLength)
c     (residual handled later)
      iRecLen = iLength/_IINTLN

c   o the format definition for reading whole integers into szDest
 10   format(a _IINTLN)

c   o read from iBuf into szDest by whole integers
      if (iRecLen.gt.0) then
         do i = 1, iRecLen
            write(szDest(iNdx:iNdx+_IINTLN-1),10) iBuf(i)
            iNdx = iNdx + _IINTLN
         end do
      end if

c   o pick up the slack
      nLeft = iand(iLength,_IINTLN-1)
      if (nLeft.ne.0) then
         iRecLen = iRecLen + 1
         do i = 1, nLeft
            write(szDest(iNdx:iNdx),'(a1)') iBuf(iRecLen)
            iBuf(iRecLen) = rshift(iBuf(iRecLen),8)
            iNdx = iNdx + 1
         end do
      end if

      return
c     end subroutine getcrec
      end

      SUBROUTINE GETCOVLRADI(IATOMICNMBER, SMOFCOVRADI, NRATMS)
C
C Compute sum of covalent radii for each unquie pair of atoms. The
C covalent radii are look up from the table, and was provided by 
C Stefan Fau (1999/2000). 
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      PARAMETER (MAXPERTABLE =86, SCALE = 1.30D00)
      DIMENSION COVLNTRADI(MAXPERTABLE), IATOMICNMBER(NRATMS), 
     &          SMOFCOVRADI(NRATMS, NRATMS)
C
      DATA COVLNTRADI /0.32, 0.93, 1.23, 0.90, 0.80, 0.77, 0.74, 0.73, 
     &                  0.72, 0.71, 1.54, 1.36, 1.18, 1.11, 1.06, 1.02,
     &                  0.99, 0.98, 2.03, 1.74, 1.44, 1.32, 1.22, 1.18,
     &                  1.17, 1.17, 1.16, 1.15, 1.17, 1.25, 1.26, 1.22,
     &                  1.20, 1.16, 1.14, 1.12, 2.16, 1.91, 1.62, 1.45,
     &                  1.34, 1.30, 1.27, 1.25, 1.25, 1.28, 1.34, 1.48,    
     &                  1.44, 1.41, 1.40, 1.36, 1.33, 1.31, 2.35, 1.98,
     &                  1.69, 1.65, 1.65, 1.64, 1.64, 1.68, 1.85, 1.61,
     &                  1.59, 1.59, 1.57, 1.57, 1.56, 1.70, 1.56, 1.44,
     &                  1.34, 1.30, 1.28, 1.26, 1.27, 1.30, 1.34, 1.49,      
     &                  1.48, 1.47, 1.46, 1.46, 1.45, 2.14/

      DATA AMTOBOHR /1.8897265/
C
      CALL ZERO(SMOFCOVRADI, NRATMS*NRATMS)
C
C Compute the Scaled covalents radii, The Scaling Factor of 1.3 is provided
C by Stefan Fau.
C
      DO 10 IBNDS = 2, NRATMS
C         DO 20 JBNDS = JBNDS, NRATMS
          DO 20 JBNDS = 1, (IBNDS - 1)
            IF (IBNDS .NE. JBNDS) THEN
               SMOFCOVRADI(JBNDS, IBNDS) = 
     &                                (COVLNTRADI(IATOMICNMBER(IBNDS))
     &                              + COVLNTRADI(IATOMICNMBER(JBNDS)))
     &                              * SCALE * AMTOBOHR
#ifdef _DEBUG_LVL_M1
            Print*, "The covalent radii assignments"
            Print*,  IBNDS, JBNDS, IATOMICNMBER(IBNDS),
     &               IATOMICNMBER(JBNDS)
            Print*,  SMOFCOVRADI(JBNDS, IBNDS)*0.529177249d0

#endif
            ENDIF
 20      CONTINUE
 10   CONTINUE
C
      RETURN
      END

C
C DRIVES THE CREATION OF MOIO POINTERS FOR SYMMETRY PACKED LISTS.
C
      SUBROUTINE INIPCK3(SYTYPL,SYTYPR,LIST,IARG1,IARGX2)
      IMPLICIT INTEGER (A-Z)
      CHARACTER*6 SYMLST(22)
      DIMENSION POPLFT(8),POPRHT(8)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      DATA SYMLST /'SVAVA0','SVBVB0','SOAOA0','SOBOB0',
     &             'SVAVA1','SVBVB1','SOAOA1','SOBOB1',
     &             'SVAOA2','SVBOB2','SOBVA2','SVBOA2',
     &             'SVAVB2','SOAOB2','SVAVB2','SOAVA2',
     &             'SOBVB2','SOAVB2','SVAVA2','SVBVB2',
     &             'SOAOA2','SOBOB2'/

      if ((SYTYPL.lt.1).or.(22.lt.SYTYPL).or.
     &    (SYTYPR.lt.1).or.(22.lt.SYTYPR)    ) then
         print *, '@INIPCK3: Assertion failed.'
         print *, '   SYTYPL = ',SYTYPL
         print *, '   SYTYPR = ',SYTYPR
         print *, '   LIST   = ',LIST
         call errex
      end if

      IARG2=IARGX2
      CALL GETREC(20,'JOBARC',SYMLST(SYTYPL)//'X ',NIRREP,POPLFT)
      CALL GETREC(20,'JOBARC',SYMLST(SYTYPR)//'X ',NIRREP,POPRHT)
      DO 10 IRREP=1,NIRREP
       CALL UPDMOI(POPRHT(IRREP),POPLFT(IRREP),IRREP,LIST,IARG1,IARG2)
       IARG1=0
       IARG2=0
C
C      This is not a good thing to do now that ISYTYP handles up to
C      500 lists!     db 920531
C      IF(LIST.GT.100) GO TO 10
C
       listx=list
       if(listx.eq.0)listx=100
       ISYTYP(1,LISTx)=SYTYPL
       ISYTYP(2,LISTx)=SYTYPR
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine handle_sss_op(op, array_table, narray_table, 
     *                         scalar_table, nscalar_table)
c-------------------------------------------------------------------------
c   Performs all calculations of the form 
c      scalar op scalar --> scalar.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'

      integer op(loptable_entry)
      integer narray_table, nscalar_table
      integer array_table(larray_table_entry,narray_table)
      double precision scalar_table(nscalar_table)

      integer op1, op2, result
      integer iop1, iop2, iresult
      integer i, opcode, ierr
      double precision val1, val2

      op1 = op(c_op1_array)
      op2 = op(c_op2_array)
      result = op(c_result_array)
      opcode = op(c_opcode)

c--------------------------------------------------------------------------
c   Make sure all operands are scalars.
c--------------------------------------------------------------------------

      ierr = 0
      if (op2 .eq. 0) then
         if (opcode .ne. assignment_op .or.
     *       array_table(c_array_type,op1) .ne. scalar_value .or.
     *       array_table(c_array_type,result) .ne. scalar_value) 
     *      ierr = 1
      else
         if (array_table(c_array_type,op1) .ne. scalar_value .or.
     *    array_table(c_array_type,op2) .ne. scalar_value .or.
     *    array_table(c_array_type,result) .ne. scalar_value) 
     *       ierr = 1
      endif

      if (ierr .eq. 1) then
         print *,'Error in handle_sss_op: Invalid operation.'
         print *,'op = ',(op(i),i=1,loptable_entry)
         print *,'op1 type = ',array_table(c_array_type,op1)
         if (op2 .ne. 0) print *,'op2 type = ',
     *             array_table(c_array_type,op2)
         print *,'result type = ',array_table(c_array_type,result)
         call abort_job()
      endif
   
c--------------------------------------------------------------------------
c   Get operand addresses.
c--------------------------------------------------------------------------

      iop1 = array_table(c_scalar_index,op1)
      if (op2 .ne. 0) iop2 = array_table(c_scalar_index,op2)
      iresult = array_table(c_scalar_index,result)

c--------------------------------------------------------------------------
c   Perform the arithmetic.
c--------------------------------------------------------------------------

      val1 = scalar_table(iop1)
      if (op2 .ne. 0) val2 = scalar_table(iop2)

      if (opcode .eq. contraction_op) then
         scalar_table(iresult) = val1 * val2
      else if (opcode .eq. sum_op) then
         scalar_table(iresult) = val1 + val2
      else if (opcode .eq. subtract_op) then
         scalar_table(iresult) = val1 - val2
      else if (opcode .eq. assignment_op) then
         scalar_table(iresult) = val1
      else if (opcode .eq. divide_op) then
         if (val2 .eq. 0.0) then
            print *,'Error: Scalar divide by zero'
            print *,'Operation: ',(op(i),i=1,loptable_entry)
            print *,'Values = ',val1, val2
            call abort_job()
         endif

         scalar_table(iresult) = val1 / val2
      else
         print *,'Invalid scalar operation: opcode = ',opcode
         call abort_job()
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_effective_indices(array_table_entry, indices)
c--------------------------------------------------------------------------
c   Sets the index fields of a local array to specified quantities.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      integer array_table_entry(larray_table_entry)
      integer indices(*)
      integer i

      do i = 1, mx_array_index
         if (indices(i) .ne. 0) 
     *           array_table_entry(c_index_array1+i-1) = indices(i)
      enddo
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE SETXYZ(Q,NEWQ,ORIENT,szCOORD,IVAL,IOK,NATOMS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DOUBLE PRECISION NEWQ
      CHARACTER*1 szCOORD
      DIMENSION Q(*),NEWQ(*),ORIENT(3,3)
      PARAMETER (ONE=1.0D0)

      IOK=0
      IF (szCOORD.EQ.'X') THEN
         IF (Mod(IVAL,2).EQ.1) THEN
            DO J = 1,NATOMS
               Q(3*J) = NEWQ(3*J-2)
               Q(3*J-2) = NEWQ(3*J-1)
               Q(3*J-1) = NEWQ(3*J)
               ORIENT(1,2)=ONE
               ORIENT(2,3)=ONE
               ORIENT(3,1)=ONE
               IOK=1
            END DO
         END IF
      ELSE
         IF (szCOORD.EQ.'Y') THEN
            IF (Mod(IVAL/2,2).EQ.1) THEN
               DO J = 1,NATOMS
                  Q(3*J) = NEWQ(3*J-1)
                  Q(3*J-1) = NEWQ(3*J-2)
                  Q(3*J-2) = NEWQ(3*J)
                  ORIENT(3,2)=ONE
                  ORIENT(2,1)=ONE
                  ORIENT(1,3)=ONE
                  IOK=1
               END DO
            END IF
         ELSE
            IF (szCOORD.EQ.'Z') THEN
               IF (Mod(IVAL/4,2).EQ.1) THEN
                  CALL XCOPY(3*NATOMS,NEWQ,1,Q,1)
                  ORIENT(1,1)=ONE
                  ORIENT(2,2)=ONE
                  ORIENT(3,3)=ONE
                  IOK=1
               END IF
            END IF
         END IF
      END IF

      RETURN
      END

C OPENS THE MOINTS FILE WITH THE RECORD LENGTH SPECIFIED IN ROUTINE
C ACES_INIT_RTE.

      SUBROUTINE OPENMO(IUNIT,NAME)
      CHARACTER*6 NAME
      LOGICAL EXISTS
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
 
#include "icdacc.com"

      INQUIRE(FILE=NAME,EXIST=EXISTS)

c YAU - old
c      IF (EXISTS) THEN
c         OPEN(UNIT=IUNIT,FILE=NAME,FORM='UNFORMATTED',ACCESS='DIRECT',
c     &        RECL=idaccr,STATUS='OLD')
c      ELSE
c         OPEN(UNIT=IUNIT,FILE=NAME,FORM='UNFORMATTED',ACCESS='DIRECT',
c     &        RECL=idaccr,STATUS='NEW')
c      END IF
c YAU - new
      IF (EXISTS) THEN
         OPEN(UNIT=IUNIT,FILE=NAME,FORM='UNFORMATTED',ACCESS='DIRECT',
     &        RECL=IPRCWD*idaccm,STATUS='OLD')
      ELSE
         OPEN(UNIT=IUNIT,FILE=NAME,FORM='UNFORMATTED',ACCESS='DIRECT',
     &        RECL=IPRCWD*idaccm,STATUS='NEW')
      END IF
c YAU - end

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__SSSS_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      ATOMIC,ATOM12,ATOM34,
     +                      MIJ,MKL,
     +                      NIJ,NIJBEG,NIJEND,NKL,NKLBEG,NKLEND,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      X12,Y12,Z12,X34,Y34,Z34,
     +                      ALPHA1,ALPHA2,ALPHA3,ALPHA4,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIM1,PRIM2,PRIM3,PRIM4,
     +                      NORM1,NORM2,NORM3,NORM4,
     +                      RHO12,RHO34,
     +                      P,PX,PY,PZ,SCALEP,
     +                      Q,QX,QY,QZ,SCALEQ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__SSSS_PCGTO_BLOCK
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation is designed to provide ultrafast block
C                evaluation of a batch of normalized electron repulsion
C                integrals between s-shell primitive gaussian type
C                orbitals.
C
C                A batch is defined here as containing all possible
C                integrals, that is its dimension is determined by
C                the total number of primitive functions (here = 1)
C                times the total number of ij and kl exponent pair
C                combinations.
C
C                The integrals are ordered in the batch the following
C                way (first index varying fastest):
C
C                    batch (nxyz1,nxyz2,nxyz3,nxyz4,kl,ij)
C
C                where ij and kl indicates alpha exponent pairs
C                defining the present block.
C
C                The present routine evaluates batches of the type:
C
C                                     ssss
C
C                The cartesian primitive integrals are evaluated using
C                the auxillary functions technique, described by
C                V.R. Saunders, "An Introduction to Molecular Integral
C                Evaluation" in "Computational Techniques in Quantum
C                Chemistry and Molecular Physics" edited by
C                GHF Diercksen, BT Sutcliff and A Veillard, D. Reidel
C                Publ. Comp. Dordrecht (1975), p. 347.
C
C                The cartesian primitive integrals are each evaluated
C                explicitely using common multipliers if possible and
C                avoiding array addresses.
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    ssss integral batch
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    ATOM12(34)   =  indicates, if centers 1 and 2
C                                    (3 and 4) coincide
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the contracted shell pairs 1,2
C                                    (3,4)
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair 1,2
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NKL          =  total # of kl primitive index
C                                    pairs for the contracted shell
C                                    pair 3,4
C                    NKLBEG(END)  =  first(last) kl primitive index
C                                    defining the kl block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = 1,2,3,4
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = 1,2,3,4
C                    Xxx,Yxx,Zxx  =  the x,y,z-coordinate differences
C                                    between centers xx = 12 and 34
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = 1,2,3,4
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j,k,l labels of primitives for
C                                    the respective contraction shells
C                                    x = 1,2,3,4
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = 1,2,3,4
C                    RHO12(34)    =  the complete set of NIJ (NKL)
C                                    exponential prefactors between
C                                    contraction shells 1 and 2
C                                    (3 and 4)
C                    P            =  will hold current MIJ exponent
C                                    sums for contraction shells 1
C                                    and 2
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=1+2
C                    SCALEP       =  will hold current MIJ values of
C                                    scaling factors related to point P
C                    Q            =  will hold current MKL exponent
C                                    sums for contraction shells 3
C                                    and 4
C                    Qx           =  will hold current MKL coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers Q=3+4
C                    SCALEQ       =  will hold current MKL values of
C                                    scaling factors related to point Q
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian ssss integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOM12,ATOM34

         INTEGER     CASE
         INTEGER     I,J,K,L,M
         INTEGER     IJ,KL
         INTEGER     MGRID,NGRID,TGRID
         INTEGER     MIJ,MKL
         INTEGER     NBATCH
         INTEGER     NIJ,NKL
         INTEGER     NIJBEG,NIJEND,NKLBEG,NKLEND
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4

         INTEGER     PRIM1 (1:MIJ)
         INTEGER     PRIM2 (1:MIJ)
         INTEGER     PRIM3 (1:MKL)
         INTEGER     PRIM4 (1:MKL)

         DOUBLE PRECISION  DELTA
         DOUBLE PRECISION  EXP1,EXP2,EXP3,EXP4
         DOUBLE PRECISION  F0
         DOUBLE PRECISION  PVAL,QVAL
         DOUBLE PRECISION  PQPLUS,PQMULT
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL
         DOUBLE PRECISION  RNPQSQ
         DOUBLE PRECISION  SCALE
         DOUBLE PRECISION  T,TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4
         DOUBLE PRECISION  X12,Y12,Z12,X34,Y34,Z34
         DOUBLE PRECISION  SIXTH,FIFTH,FOURTH,THIRD,HALF,ONE,PI

         DOUBLE PRECISION  ALPHA1 (1:NPGTO1)
         DOUBLE PRECISION  ALPHA2 (1:NPGTO2)
         DOUBLE PRECISION  ALPHA3 (1:NPGTO3)
         DOUBLE PRECISION  ALPHA4 (1:NPGTO4)

         DOUBLE PRECISION  NORM1  (1:NPGTO1)
         DOUBLE PRECISION  NORM2  (1:NPGTO2)
         DOUBLE PRECISION  NORM3  (1:NPGTO3)
         DOUBLE PRECISION  NORM4  (1:NPGTO4)

         DOUBLE PRECISION  RHO12  (1:NIJ)
         DOUBLE PRECISION  RHO34  (1:NKL)

         DOUBLE PRECISION  BATCH  (1:NBATCH)

         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  PX     (1:MIJ)
         DOUBLE PRECISION  PY     (1:MIJ)
         DOUBLE PRECISION  PZ     (1:MIJ)
         DOUBLE PRECISION  SCALEP (1:MIJ)

         DOUBLE PRECISION  Q      (1:MKL)
         DOUBLE PRECISION  QX     (1:MKL)
         DOUBLE PRECISION  QY     (1:MKL)
         DOUBLE PRECISION  QZ     (1:MKL)
         DOUBLE PRECISION  SCALEQ (1:MKL)

         DOUBLE PRECISION  FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (SIXTH   =  0.166666666666667D0)
         PARAMETER  (FIFTH   =  0.2D0)
         PARAMETER  (FOURTH  =  0.25D0)
         PARAMETER  (THIRD   =  0.333333333333333D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0 )
         PARAMETER  (PI      =  3.141592653589793D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...predetermine in 'K2' loops the quantities associated
C                with the 1,2-part and 3,4-part.
C
C
         CASE = 5

         IF (ATOMIC.OR.ATOM12) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                P (M) = ALPHA1 (I) + ALPHA2 (J)
                SCALEP (M) = NORM1 (I) * NORM2 (J)
  100        CONTINUE
             CASE = CASE - 1
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIM1 (M)
                J = PRIM2 (M)
                EXP1 = ALPHA1 (I)
                EXP2 = ALPHA2 (J)
                PVAL = EXP1 + EXP2
                P (M) = PVAL
                PVAL = EXP1 / PVAL
                PX (M) = PVAL * X12 + X2
                PY (M) = PVAL * Y12 + Y2
                PZ (M) = PVAL * Z12 + Z2
                SCALEP (M) = NORM1 (I) * NORM2 (J) * RHO12 (IJ)
  110        CONTINUE
         END IF

         IF (ATOMIC.OR.ATOM34) THEN
             M = 0
             DO 200 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                Q (M) = ALPHA3 (K) + ALPHA4 (L)
                SCALEQ (M) = NORM3 (K) * NORM4 (L)
  200        CONTINUE
             CASE = CASE - 2
         ELSE
             M = 0
             DO 220 KL = NKLBEG,NKLEND
                M = M + 1
                K = PRIM3 (M)
                L = PRIM4 (M)
                EXP3 = ALPHA3 (K)
                EXP4 = ALPHA4 (L)
                QVAL = EXP3 + EXP4
                Q (M) = QVAL
                QVAL = EXP3 / QVAL
                QX (M) = QVAL * X34 + X4
                QY (M) = QVAL * Y34 + Y4
                QZ (M) = QVAL * Z34 + Z4
                SCALEQ (M) = NORM3 (K) * NORM4 (L) * RHO34 (KL)
  220        CONTINUE
         END IF

         IF (ATOMIC) THEN
             CASE = CASE - 1
         END IF
C
C
C             ...jump according to type of 'K4' loop:
C
C                       CASE  |  Integral center type
C                     --------|-----------------------
C                         1   |     (AA|AA)  atomic
C                         2   |     (AA|CC)  2-center
C                         3   |     (AB|CC)  3-center
C                         4   |     (AA|CD)  3-center
C                         5   |     (AB|CD)  4-center
C
C
         GOTO (10,20,30,40,50) CASE
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for atomic (AA|AA)
C                type integrals.
C
C
   10    M = 0
         DO 1000 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 1100 KL = 1,MKL
               QVAL = Q (KL)
               M = M + 1
               BATCH (M) = PSCALE * SCALEQ (KL)
     +                            / (PVAL * QVAL * DSQRT (PVAL+QVAL))
 1100       CONTINUE
 1000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 2-center (AA|CC)
C                type integrals.
C
C
   20    PQX = X1 - X3
         PQY = Y1 - Y3
         PQZ = Z1 - Z3
         RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ

         M = 0
         DO 2000 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 2200 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               T = RNPQSQ * PQMULT / PQPLUS
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA = TGRID * TSTEP - T

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA * SIXTH
     +                      + FTABLE (5,TGRID)) * DELTA * FIFTH
     +                      + FTABLE (4,TGRID)) * DELTA * FOURTH
     +                      + FTABLE (3,TGRID)) * DELTA * THIRD
     +                      + FTABLE (2,TGRID)) * DELTA * HALF
     +                      + FTABLE (1,TGRID)) * DELTA
     +                      + FTABLE (0,TGRID)
               ELSE
                   F0 = HALF * DSQRT (PI/T)
               END IF

               M = M + 1
               BATCH (M) = SCALE * F0
 2200       CONTINUE
 2000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center (AB|CC)
C                type integrals.
C
C
   30    M = 0
         DO 3000 IJ = 1,MIJ
            PVAL = P (IJ)
            PQX = PX (IJ) - X3
            PQY = PY (IJ) - Y3
            PQZ = PZ (IJ) - Z3
            RNPQSQ = PQX * PQX + PQY * PQY + PQZ * PQZ
            PSCALE = SCALEP (IJ)
            DO 3300 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               T = RNPQSQ * PQMULT / PQPLUS
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA = TGRID * TSTEP - T

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA * SIXTH
     +                      + FTABLE (5,TGRID)) * DELTA * FIFTH
     +                      + FTABLE (4,TGRID)) * DELTA * FOURTH
     +                      + FTABLE (3,TGRID)) * DELTA * THIRD
     +                      + FTABLE (2,TGRID)) * DELTA * HALF
     +                      + FTABLE (1,TGRID)) * DELTA
     +                      + FTABLE (0,TGRID)
               ELSE
                   F0 = HALF * DSQRT (PI/T)
               END IF

               M = M + 1
               BATCH (M) = SCALE * F0
 3300       CONTINUE
 3000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 3-center (AA|CD)
C                type integrals.
C
C
   40    M = 0
         DO 4000 IJ = 1,MIJ
            PVAL = P (IJ)
            PSCALE = SCALEP (IJ)
            DO 4400 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQX = X1 - QX (KL)
               PQY = Y1 - QY (KL)
               PQZ = Z1 - QZ (KL)
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT / PQPLUS
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA = TGRID * TSTEP - T

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA * SIXTH
     +                      + FTABLE (5,TGRID)) * DELTA * FIFTH
     +                      + FTABLE (4,TGRID)) * DELTA * FOURTH
     +                      + FTABLE (3,TGRID)) * DELTA * THIRD
     +                      + FTABLE (2,TGRID)) * DELTA * HALF
     +                      + FTABLE (1,TGRID)) * DELTA
     +                      + FTABLE (0,TGRID)
               ELSE
                   F0 = HALF * DSQRT (PI/T)
               END IF

               M = M + 1
               BATCH (M) = SCALE * F0
 4400       CONTINUE
 4000    CONTINUE

         RETURN
C
C
C             ...the 'K4' loop over all ij- and kl-exponent pairs
C                in present ij and kl block for 4-center (AB|CD)
C                type integrals.
C
C
   50    M = 0
         DO 5000 IJ = 1,MIJ
            PVAL = P (IJ)
            PXVAL = PX (IJ)
            PYVAL = PY (IJ)
            PZVAL = PZ (IJ)
            PSCALE = SCALEP (IJ)
            DO 5500 KL = 1,MKL
               QVAL = Q (KL)
               PQMULT = PVAL * QVAL
               PQPLUS = PVAL + QVAL
               PQX = PXVAL - QX (KL)
               PQY = PYVAL - QY (KL)
               PQZ = PZVAL - QZ (KL)
               T = (PQX*PQX + PQY*PQY + PQZ*PQZ) * PQMULT / PQPLUS
               SCALE = PSCALE * SCALEQ (KL) / (PQMULT * DSQRT (PQPLUS))

               IF (T.LE.TMAX) THEN
                   TGRID = INT (T * TVSTEP + HALF)
                   DELTA = TGRID * TSTEP - T

                   F0 = ((((( FTABLE (6,TGRID)  * DELTA * SIXTH
     +                      + FTABLE (5,TGRID)) * DELTA * FIFTH
     +                      + FTABLE (4,TGRID)) * DELTA * FOURTH
     +                      + FTABLE (3,TGRID)) * DELTA * THIRD
     +                      + FTABLE (2,TGRID)) * DELTA * HALF
     +                      + FTABLE (1,TGRID)) * DELTA
     +                      + FTABLE (0,TGRID)
               ELSE
                   F0 = HALF * DSQRT (PI/T)
               END IF

               M = M + 1
               BATCH (M) = SCALE * F0
 5500       CONTINUE
 5000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_COEFFICIENTS
     +
     +                    ( MIJ,MKL,MIJKL,
     +                      NGQP,MGQIJKL,
     +                      ATOMAB,ATOMCD,
     +                      P,Q,
     +                      PX,PY,PZ,QX,QY,QZ,
     +                      PAX,PAY,PAZ,QCX,QCY,QCZ,
     +                      PINVHF,QINVHF,PQPINV,
     +                      RTS,
     +                      CASE2D,
     +
     +                               B00,B01,B10,
     +                               C00X,C00Y,C00Z,
     +                               D00X,D00Y,D00Z )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_COEFFICIENTS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation evaluates the VRR coefficients for
C                the 2D integrals for the present set of NGQP roots
C                corresponding to all i,j,k,l exponent quadruplets.
C
C                Not all coefficients are needed in case there are
C                s- or p-shells present on either P or Q side. Also
C                observe that the cartesian distance components PAX,
C                PAY and PAZ are all equal to zero in case the two
C                atomic centers A and B coincide, in which case they
C                need not to be addressed inside the algorithm.
C                Likewise for QCX,QCY and QCZ, if centers C and D
C                coincide.
C
C
C                  Input:
C
C                    MIJ(KL)      =  current # of ij (kl) primitive
C                                    index pairs corresponding to
C                                    the csh pairs A,B (C,D)
C                    MIJKL        =  current # of ijkl primitive
C                                    index quadruplets (= MIJ*MKL)
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    MGQIJKL      =  # of roots times # of ijkl
C                                    quadruplets (= NGQP*MIJKL)
C                    ATOMAB(CD)   =  is true, if centers A and B
C                                    (C and D) coincide
C                    P(Q)         =  current MIJ (MKL) exponent sums
C                                    for csh A and B (C and D)
C                    Px(Qx)       =  current MIJ (MKL) coordinates
C                                    x=X,Y,Z for gaussian product
C                                    centers P=A+B (Q=C+D)
C                    PAx(QCx)     =  current MIJ (MKL) coordinate
C                                    x=X,Y,Z differences P-A (Q-C)
C                                    between centers P and A (Q and C)
C                    P(Q)INVHF    =  current MIJ (MKL) values of
C                                    1/(2*P(Q)), where P and Q are
C                                    the corresponding exponent sums
C                                    for csh A and B (C and D)
C                    PQPINV       =  current MIJKL values of 1/(P+Q)
C                    RTS          =  current MGQIJKL values of all
C                                    quadrature roots
C                    CASE2D       =  integer value within the range
C                                    from 1 to 9, indicating which
C                                    2D coefficient evaluation case
C                                    is present to trigger specific
C                                    simplified sections of the code
C
C                  Output:
C
C                    Bxx          =  the coordinate independent
C                                    B-coefficients (xx=00,01,10)
C                    C00x         =  the C-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    D00x         =  the D-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center Q
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   ATOMAB,ATOMCD

         INTEGER   CASE2D
         INTEGER   IJ,KL
         INTEGER   M,N
         INTEGER   MIJ,MKL,MIJKL
         INTEGER   NG,NGQP,MGQIJKL

         DOUBLE PRECISION  PIJ,PXIJ,PYIJ,PZIJ,PAXIJ,PAYIJ,PAZIJ
         DOUBLE PRECISION  PQX,PQY,PQZ
         DOUBLE PRECISION  PSCALE,QSCALE
         DOUBLE PRECISION  QCXKL,QCYKL,QCZKL
         DOUBLE PRECISION  ROOT,PROOT,QROOT
         DOUBLE PRECISION  TWOP,TWOQ,TWOPQ
         DOUBLE PRECISION  HALF,ONE

         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  PX     (1:MIJ)
         DOUBLE PRECISION  PY     (1:MIJ)
         DOUBLE PRECISION  PZ     (1:MIJ)
         DOUBLE PRECISION  PAX    (1:MIJ)
         DOUBLE PRECISION  PAY    (1:MIJ)
         DOUBLE PRECISION  PAZ    (1:MIJ)
         DOUBLE PRECISION  PINVHF (1:MIJ)

         DOUBLE PRECISION  Q      (1:MKL)
         DOUBLE PRECISION  QX     (1:MKL)
         DOUBLE PRECISION  QY     (1:MKL)
         DOUBLE PRECISION  QZ     (1:MKL)
         DOUBLE PRECISION  QCX    (1:MKL)
         DOUBLE PRECISION  QCY    (1:MKL)
         DOUBLE PRECISION  QCZ    (1:MKL)
         DOUBLE PRECISION  QINVHF (1:MKL)

         DOUBLE PRECISION  PQPINV (1:MIJKL)

         DOUBLE PRECISION  B00    (1:MGQIJKL)
         DOUBLE PRECISION  B01    (1:MGQIJKL)
         DOUBLE PRECISION  B10    (1:MGQIJKL)
         DOUBLE PRECISION  C00X   (1:MGQIJKL)
         DOUBLE PRECISION  C00Y   (1:MGQIJKL)
         DOUBLE PRECISION  C00Z   (1:MGQIJKL)
         DOUBLE PRECISION  D00X   (1:MGQIJKL)
         DOUBLE PRECISION  D00Y   (1:MGQIJKL)
         DOUBLE PRECISION  D00Z   (1:MGQIJKL)
         DOUBLE PRECISION  RTS    (1:MGQIJKL)

         PARAMETER  (HALF  =  0.5D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 9 different cases that can arise:
C
C                  P-shell = s- ,p- or higher angular momentum
C                  Q-shell = s- ,p- or higher angular momentum
C
C                each leading to simplifications in the VRR formulas.
C                The case present has been evaluated outside this
C                routine and is transmitted via argument.
C
C
         GOTO (1,2,5,3,4,7,6,8,9) CASE2D
C
C
C             ...the case P = s-shell and Q = s-shell.
C                (no coefficients here)
C
C
    1    RETURN
C
C
C             ...the case P = p-shell and Q = s-shell.
C                (no B00,B01,B10,D00)
C
C
    2    IF (ATOMAB) THEN
             M = 0
             N = 0
             DO 200 IJ = 1,MIJ
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 210 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   QSCALE = - Q (KL) * PQPINV (M)

                   DO 215 NG = 1,NGQP
                      N = N + 1
                      QROOT = QSCALE * RTS (N)
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
  215              CONTINUE

  210           CONTINUE
  200        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 220 IJ = 1,MIJ
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                DO 230 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   QSCALE = Q (KL) * PQPINV (M)

                   DO 235 NG = 1,NGQP
                      N = N + 1
                      QROOT = QSCALE * RTS (N)
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
  235              CONTINUE

  230           CONTINUE
  220        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P = s-shell and Q = p-shell.
C                (no B00,B01,B10,C00)
C
C
    3    IF (ATOMCD) THEN
             M = 0
             N = 0
             DO 300 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 310 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   PSCALE = PIJ * PQPINV (M)

                   DO 315 NG = 1,NGQP
                      N = N + 1
                      PROOT  = PSCALE * RTS (N)
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  315              CONTINUE

  310           CONTINUE
  300        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 320 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 330 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   PSCALE = PIJ * PQPINV (M)

                   DO 335 NG = 1,NGQP
                      N = N + 1
                      PROOT  = PSCALE * RTS (N)
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  335              CONTINUE

  330           CONTINUE
  320        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P = p-shell and Q = p-shell.
C                (no B01,B10)
C
C
    4    IF (ATOMAB.AND.ATOMCD) THEN

             M = 0
             N = 0
             DO 400 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 410 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 415 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  415              CONTINUE

  410           CONTINUE
  400        CONTINUE

         ELSE IF (ATOMAB) THEN

             M = 0
             N = 0
             DO 420 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 430 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 435 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  435              CONTINUE

  430           CONTINUE
  420        CONTINUE

         ELSE IF (ATOMCD) THEN

             M = 0
             N = 0
             DO 440 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                DO 450 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 455 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  455              CONTINUE

  450           CONTINUE
  440        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 460 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                DO 470 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 475 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  475              CONTINUE

  470           CONTINUE
  460        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P > p-shell and Q = s-shell.
C                (no B00,B01,D00)
C
C
    5    IF (ATOMAB) THEN
             M = 0
             N = 0
             DO 500 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                TWOP = PINVHF (IJ)
                DO 510 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   QSCALE = ONE - PIJ * PQPINV (M)

                   DO 515 NG = 1,NGQP
                      N = N + 1
                      QROOT  = - QSCALE * RTS (N)
                      B10  (N)= (ONE + QROOT) * TWOP
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
  515              CONTINUE

  510           CONTINUE
  500        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 520 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                TWOP = PINVHF (IJ)
                DO 530 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   QSCALE = ONE - PIJ * PQPINV (M)

                   DO 535 NG = 1,NGQP
                      N = N + 1
                      QROOT  = QSCALE * RTS (N)
                      B10  (N)= (ONE - QROOT) * TWOP
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
  535              CONTINUE

  530           CONTINUE
  520        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P = s-shell and Q > p-shell.
C                (no B00,B10,C00)
C
C
    6    IF (ATOMCD) THEN
             M = 0
             N = 0
             DO 600 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 610 KL = 1,MKL
                   TWOQ = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   PSCALE = PIJ * PQPINV (M)

                   DO 615 NG = 1,NGQP
                      N = N + 1
                      PROOT  = PSCALE * RTS (N)
                      B01  (N) = (ONE - PROOT) * TWOQ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  615              CONTINUE

  610           CONTINUE
  600        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 620 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 630 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   TWOQ = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   PSCALE = PIJ * PQPINV (M)

                   DO 635 NG = 1,NGQP
                      N = N + 1
                      PROOT  = PSCALE * RTS (N)
                      B01  (N) = (ONE - PROOT) * TWOQ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  635              CONTINUE

  630           CONTINUE
  620        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P > p-shell and Q = p-shell.
C                (no B01)
C
C
    7    IF (ATOMAB.AND.ATOMCD) THEN

             M = 0
             N = 0
             DO 700 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                TWOP = PINVHF (IJ)
                DO 710 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 715 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B10  (N) = (ONE + QROOT) * TWOP
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  715              CONTINUE

  710           CONTINUE
  700        CONTINUE

         ELSE IF (ATOMAB) THEN

             M = 0
             N = 0
             DO 720 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                TWOP = PINVHF (IJ)
                DO 730 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 735 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B10  (N) = (ONE + QROOT) * TWOP
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  735              CONTINUE

  730           CONTINUE
  720        CONTINUE

         ELSE IF (ATOMCD) THEN

             M = 0
             N = 0
             DO 740 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                TWOP = PINVHF (IJ)
                DO 750 KL = 1,MKL
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 755 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B10  (N) = (ONE - QROOT) * TWOP
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  755              CONTINUE

  750           CONTINUE
  740        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 760 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                TWOP = PINVHF (IJ)
                DO 770 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 775 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B10  (N) = (ONE - QROOT) * TWOP
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  775              CONTINUE

  770           CONTINUE
  760        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P = p-shell and Q > p-shell.
C                (no B10)
C
C
    8    IF (ATOMAB.AND.ATOMCD) THEN

             M = 0
             N = 0
             DO 800 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 810 KL = 1,MKL
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 815 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  815              CONTINUE

  810           CONTINUE
  800        CONTINUE

         ELSE IF (ATOMAB) THEN

             M = 0
             N = 0
             DO 820 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                DO 830 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 835 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  835              CONTINUE

  830           CONTINUE
  820        CONTINUE

         ELSE IF (ATOMCD) THEN

             M = 0
             N = 0
             DO 840 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                DO 850 KL = 1,MKL
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 855 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  855              CONTINUE

  850           CONTINUE
  840        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 860 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                DO 870 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 875 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  875              CONTINUE

  870           CONTINUE
  860        CONTINUE
         END IF

         RETURN
C
C
C             ...the case P > p-shell and Q > p-shell.
C
C
    9    IF (ATOMAB.AND.ATOMCD) THEN

             M = 0
             N = 0
             DO 900 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                TWOP = PINVHF (IJ)
                DO 910 KL = 1,MKL
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 915 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      B10  (N) = (ONE + QROOT) * TWOP
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  915              CONTINUE

  910           CONTINUE
  900        CONTINUE

         ELSE IF (ATOMAB) THEN

             M = 0
             N = 0
             DO 920 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                TWOP = PINVHF (IJ)
                DO 930 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 935 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = - QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      B10  (N) = (ONE + QROOT) * TWOP
                      C00X (N) = QROOT * PQX
                      C00Y (N) = QROOT * PQY
                      C00Z (N) = QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  935              CONTINUE

  930           CONTINUE
  920        CONTINUE

         ELSE IF (ATOMCD) THEN

             M = 0
             N = 0
             DO 940 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                TWOP = PINVHF (IJ)
                DO 950 KL = 1,MKL
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 955 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      B10  (N) = (ONE - QROOT) * TWOP
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = PROOT * PQX
                      D00Y (N) = PROOT * PQY
                      D00Z (N) = PROOT * PQZ
  955              CONTINUE

  950           CONTINUE
  940        CONTINUE
         ELSE
             M = 0
             N = 0
             DO 960 IJ = 1,MIJ
                PIJ = P (IJ)
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                TWOP = PINVHF (IJ)
                DO 970 KL = 1,MKL
                   QCXKL = QCX (KL)
                   QCYKL = QCY (KL)
                   QCZKL = QCZ (KL)
                   TWOQ  = QINVHF (KL)
                   PQX = PXIJ - QX (KL)
                   PQY = PYIJ - QY (KL)
                   PQZ = PZIJ - QZ (KL)

                   M = M + 1
                   TWOPQ = HALF * PQPINV (M)
                   PSCALE = PIJ * PQPINV (M)
                   QSCALE = ONE - PSCALE

                   DO 975 NG = 1,NGQP
                      N = N + 1
                      ROOT = RTS (N)
                      PROOT = PSCALE * ROOT
                      QROOT = QSCALE * ROOT
                      B00  (N) = ROOT * TWOPQ
                      B01  (N) = (ONE - PROOT) * TWOQ
                      B10  (N) = (ONE - QROOT) * TWOP
                      C00X (N) = PAXIJ - QROOT * PQX
                      C00Y (N) = PAYIJ - QROOT * PQY
                      C00Z (N) = PAZIJ - QROOT * PQZ
                      D00X (N) = QCXKL + PROOT * PQX
                      D00Y (N) = QCYKL + PROOT * PQY
                      D00Z (N) = QCZKL + PROOT * PQZ
  975              CONTINUE

  970           CONTINUE
  960        CONTINUE
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         DOUBLE PRECISION FUNCTION  ERD__DSQMIN_LINE_SEGMENTS
     +
     +                     ( XP0,YP0,ZP0,
     +                       XP1,YP1,ZP1,
     +                       XQ0,YQ0,ZQ0,
     +                       XQ1,YQ1,ZQ1 )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DSQMIN_LINE_SEGMENTS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This function returns the square of the minimum 3D
C                distance that exists between two line segments P and Q
C                in space.
C
C                The line segment P is located between points P0 and
C                P1 and likewise for line segment Q between points
C                Q0 and Q1. The routine also handles the situations
C                when the line segments P and/or Q have zero lenghts,
C                i.e. they are points in space.
C
C
C
C                        \
C                         \
C                          P0
C                           \ <-- segment P, dir vector U = P1 - P0
C                            \
C                             P1
C                              \
C                               \          /
C                                \        / <-- line L2
C                                 P(sc)  /
C                                 |\    /
C                                 | \  /
C             W = P0 - Q0         |  \/
C      C(sc,tc) = P(sc) - Q(tc)   |  /\
C                                 | /  \
C                                 |/    \
C                                 Q(tc)  \
C                                /        \
C                               /          \ <-- line L1
C                              /            \
C                             Q1             \
C                            /
C                           / <-- segment Q, dir vector V = Q1 - Q0
C                          Q0
C                         /
C
C
C
C                The two lines L1 and L2 are the extension lines on
C                which the two segments P and Q sit and are in given
C                in parametric form using the direction vectors U
C                and V as:
C
C                                 L1 = P0 + sU
C                                 L2 = Q0 + tV
C
C                with s and t parameters. C(sc,tc) is the vector
C                representing the closest approach between these two
C                lines occuring at s = sc and t = tc and is uniquely
C                perpendicular to the line direction vectors U and V:
C
C                                 U dot C(sc,tc) = 0
C                                 V dot C(sc,tc) = 0
C
C                Using C(sc,tc) = P(sc) - Q(tc) = P0 + sc*U - Q0 - tc*V
C                = W + sc*U - tc*V for these two conditions we obtain
C                two simultaneous linear equations in sc and tc:
C
C
C                     (U dot U)*sc - (U dot V)*tc = - (U dot W)
C                     (V dot U)*sc - (V dot V)*tc = - (V dot W)
C
C
C                from which we obtain:
C
C                          sc = (b*e - c*d) / (a*c - b*b)
C                          tc = (a*e - b*d) / (a*c - b*b)
C
C                where:
C
C                                 a = U dot U
C                                 b = U dot V
C                                 c = V dot V
C                                 d = U dot W
C                                 e = V dot W
C
C                If the denominator (a*c - b*b) is equal to zero, then
C                the lines L1 and L2 are parallel and the distance
C                between them is constant. We can solve for this
C                parallel distance of separation by fixing the value of
C                one parameter and using either equation to solve for
C                the other. If we select sc = 0, then we get tc = d/b
C                = e/c. The situation when one or both of the line
C                segments shrink to points is identified as a and/or c
C                being equal to zero.
C
C                The closest distance between segments may not be the
C                same as the closest distance between their extended
C                lines. The closest points on the extended infinite line
C                may be outside the range of the segments. Using the
C                parametrized line form for L1 = P0 + sU, we see that
C                the segment P is represented by all points on L1 for
C                which 0 =< s =< 1. Likewise for the segment Q with
C                0 =< t =< 1.
C
C                Minimizing the distance between the two line segments
C                P and Q means to minimize the scalar product:
C
C                  C dot C = (W0 + s*U - t*V) dot (W0 + s*U - t*V)
C
C                as a function of s and t over the restricted values
C                0 =< s =< 1 and 0 =< t =< 1 defining the segments.
C
C
C                  Input:
C
C                     XP0,YP0,ZP0 =  x,y,z coordinates of first point
C                                    defining line segment P
C                     XP1,YP1,ZP1 =  x,y,z coordinates of second point
C                                    defining line segment P
C                     XQ0,YQ0,ZQ0 =  x,y,z coordinates of first point
C                                    defining line segment Q
C                     XQ1,YQ1,ZQ1 =  x,y,z coordinates of second point
C                                    defining line segment Q
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         DOUBLE PRECISION    DENOM
         DOUBLE PRECISION    LINE
         DOUBLE PRECISION    PARLLEL
         DOUBLE PRECISION    SD,SN,SC,TD,TN,TC
         DOUBLE PRECISION    UDOTU,VDOTV,UDOTV,UDOTW,VDOTW
         DOUBLE PRECISION    XC,YC,ZC
         DOUBLE PRECISION    XP0,YP0,ZP0,XP1,YP1,ZP1
         DOUBLE PRECISION    XQ0,YQ0,ZQ0,XQ1,YQ1,ZQ1
         DOUBLE PRECISION    XU,YU,ZU
         DOUBLE PRECISION    XV,YV,ZV
         DOUBLE PRECISION    XW,YW,ZW
         DOUBLE PRECISION    ZERO,ONE

         PARAMETER  (PARLLEL =  1.D-12)
         PARAMETER  (LINE    =  1.D-12)
         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (ONE     =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...set direction vectors U and V and reference vector W.
C
C
         XU = XP1 - XP0
         YU = YP1 - YP0
         ZU = ZP1 - ZP0
         XV = XQ1 - XQ0
         YV = YQ1 - YQ0
         ZV = ZQ1 - ZQ0
         XW = XP0 - XQ0
         YW = YP0 - YQ0
         ZW = ZP0 - ZQ0

         UDOTU = XU * XU + YU * YU + ZU * ZU
         VDOTV = XV * XV + YV * YV + ZV * ZV

         IF (UDOTU.LT.LINE .AND. VDOTV.LT.LINE) THEN
C
C
C             ...both line segments are points.
C
C
             ERD__DSQMIN_LINE_SEGMENTS = XW * XW + YW * YW + ZW * ZW
             RETURN

         ELSE IF (UDOTU.LT.LINE) THEN
C
C
C             ...only P line segment is a point.
C
C
             VDOTW = XV * XW + YV * YW + ZV * ZW

             IF (VDOTW.LT.ZERO) THEN
                 ERD__DSQMIN_LINE_SEGMENTS = XW * XW + YW * YW + ZW * ZW
                 RETURN
             ELSE IF (VDOTW.GT.VDOTV) THEN
                 XC = XW - XV
                 YC = YW - YV
                 ZC = ZW - ZV
             ELSE
                 TC = VDOTW / VDOTV
                 XC = XW - TC * XV
                 YC = YW - TC * YV
                 ZC = ZW - TC * ZV
             END IF

         ELSE IF (VDOTV.LT.LINE) THEN
C
C
C             ...only Q line segment is a point.
C
C
             UDOTW = - (XU * XW + YU * YW + ZU * ZW)

             IF (UDOTW.LT.ZERO) THEN
                 ERD__DSQMIN_LINE_SEGMENTS = XW * XW + YW * YW + ZW * ZW
                 RETURN
             ELSE IF (UDOTW.GT.UDOTU) THEN
                 XC = XW + XU
                 YC = YW + YU
                 ZC = ZW + ZU
             ELSE
                 SC = UDOTW / UDOTU
                 XC = XW + SC * XU
                 YC = YW + SC * YU
                 ZC = ZW + SC * ZU
             END IF

         ELSE
C
C
C           ...both P and Q are line segments.
C
C
             UDOTV = XU * XV + YU * YV + ZU * ZV
             UDOTW = XU * XW + YU * YW + ZU * ZW
             VDOTW = XV * XW + YV * YW + ZV * ZW

             DENOM = UDOTU * VDOTV - UDOTV * UDOTV

             IF (DENOM.LT.PARLLEL) THEN
                 SN = ZERO
                 SD = ONE
                 TN = VDOTW
                 TD = VDOTV
             ELSE
                 SN = UDOTV * VDOTW - VDOTV * UDOTW
                 SD = DENOM
                 IF (SN.LT.ZERO) THEN
                     SN = ZERO
                     TN = VDOTW
                     TD = DENOM
                 ELSE IF (SN.GT.DENOM) THEN
                     SN = DENOM
                     SD = DENOM
                     TN = VDOTW + UDOTV
                     TD = VDOTV
                 ELSE
                     TN = UDOTU * VDOTW - UDOTV * UDOTW
                     TD = DENOM
                 END IF
             END IF

             IF (TN.LT.ZERO) THEN
                 TN = ZERO
                 SN = - UDOTW
                 IF (SN.LT.ZERO) THEN
                     SN = ZERO
                 ELSE IF (SN.GT.UDOTU) THEN
                     SN = SD
                 ELSE
                     SN = - UDOTW
                     SD = UDOTU
                 END IF
             ELSE IF (TN.GT.TD) THEN
                 TN = TD
                 SN = UDOTV - UDOTW
                 IF (SN.LT.ZERO) THEN
                     SN = ZERO
                 ELSE IF (SN.GT.UDOTU) THEN
                     SN = SD
                 ELSE
                     SD = UDOTU
                 END IF
             END IF

             SC = SN / SD
             TC = TN / TD

             XC = XW + SC * XU - TC * XV
             YC = YW + SC * YU - TC * YV
             ZC = ZW + SC * ZU - TC * ZV

         END IF

         ERD__DSQMIN_LINE_SEGMENTS = XC * XC + YC * YC + ZC * ZC
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine c2bb_print(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Each element of the array source(i,j,k,l) is divided by the 
c   corresponding element of the array target(i,j,k,l).  
c   Dividing is not performed when i = k or j = l or if the absolute 
c   value of the target element is below 1.0d-8
c
c   Format of command is :
c
c   execute apply_den4_nodiag source target
c
c   There is no resriction on the type of array of source or target. 
c
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer*8 indblk, get_block_index
      integer block, blkndx, seg
      integer find_current_block

      integer i, j, ii, source, company, comm, ierr
      integer source_type
      integer*8 isource
      integer nindex_source, stack  
      integer n(mx_array_index),ind(mx_array_index) 
      integer sval1(mx_array_index),sval2(mx_array_index)  
      integer tval1(mx_array_index),tval2(mx_array_index)  
      integer msg(len_sip_server_message)
      integer status(MPI_STATUS_SIZE) 

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif


c--------------------------------------------------------------------------
c   Locate the data for both arrays.  
c--------------------------------------------------------------------------

      source = op(c_result_array)

c---------------------------------------------------------------------------
c   Look up source's address.
c---------------------------------------------------------------------------

      block  = find_current_block(source, array_table(1,source),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,source)
      isource = get_block_index(source, block, stack, blkndx, x, .true.) 

c--------------------------------------------------------------------------
c   Check the dimensions of both arrays both arrays.  
c--------------------------------------------------------------------------
      
      source_type = array_table(c_array_type, source)

      nindex_source = array_table(c_nindex, source)

      if (nindex_source .ne. 4) then 
         print *,'Arrays in apply_den4 must have 4 indices' 
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Get segment ranges of the array source.
c-------------------------------------------------------------------------

      do i = 1, nindex_source 
         ind(i) = array_table(c_index_array1+i-1,source)
         n(i)   = index_table(c_index_size, ind(i))  ! pick up length of index 
         seg    = index_table(c_current_seg,ind(i)) 

         call get_index_segment(ind(i), seg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, sval1(i), sval2(i))

      enddo


      call doc2bb_print(x(isource),
     *                      sval1(1),sval2(1),sval1(2),sval2(2),
     *                      sval1(3),sval2(3),sval1(4),sval2(4)) 

      return
      end

      subroutine doc2bb_print(x,
     *                      i1,i2,j1,j2,k1,k2,l1,l2)
      implicit none 
      include 'interpreter.h'
      include 'parallel_info.h'

      integer i1,i2,j1,j2,k1,k2,l1,l2
      double precision x(i1:i2,j1:j2,k1:k2,l1:l2)

      integer a,b,c,d 
      double precision stemp
c
c
       if (me .eq. my_company_rank)then
c
      do b = j1, j2
      do d = l1, l2
      do a = i1, i2
      do c = k1, k2
c
c     if(a .lt. c .and. b .lt. d)then
c
      stemp=dabs(x(a,b,c,d))
c
      if(stemp .gt. 0.5d-1)then

c      write(6,*) ' C2AA VECTOR FOR I,J = ',b,d,',A,B = ',a,c,' = ',
c     *x(a,b,c,d)
c      write(66,1000) ' C2AA VECTOR FOR I,J = ',b,d,',A,B = ',a,c,' = ',
c    * x(a,b,c,d)

        write(66,1000) a, b, c, d, x(a,b,c,d)
      endif
c     endif
c
      enddo
      enddo
      enddo
      enddo

 1000 FORMAT (8x,I6,x,I6,x,I6,x,I6,x,D20.10)
c
c
       endif

c
      return 
      end 

#include "disttype.h"
      SUBROUTINE T1RING(ICORE,MAXCOR,IUHF,LAMBDA)
C
C DRIVER FOR W(MBEJ) <- T1 CONTRIBUTIONS.  SELECTS BETWEEN INCORE
C AND OUT OF CORE ALGORITHMS AND CALLS THE APPROPRIATE ROUTINES
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION ONE,ONEM,ZILCH
      LOGICAL LAMBDA,AOBASIS,AOLOG
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NFEA(2),NFMI(2)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /AOLOG/ AOLOG
      DATA ONE  /1.0/   
      DATA ONEM /-1.0/
      DATA ZILCH /0.0/
      integer disttype_vo(2)
      data disttype_vo /h_DistType_Ai,h_DistType_aI/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
C
      AOBASIS=IFLAGS(93).EQ.2.AND.(.NOT.LAMBDA)
C
C IF CALCULATION IN AOBASIS FIRST READ THE F(e;a)
C
      AOLOG=.FALSE.
      IF (AOBASIS) THEN
       AOLOG=.TRUE.
       I000=1
       DO 1111 ISPIN=1,1+IUHF
        CALL UPDMOI(1,NFMI(ISPIN),6+ISPIN,92,0,0)
        CALL GETLST(ICORE(I000),1,1,1,ISPIN,92)
        CALL PUTLST(ICORE(I000),1,1,1,6+ISPIN,92)
1111   CONTINUE
      ENDIF
C
C SPIN CASES AAAA AND BBBB
C
      INEED=-1
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=53+ISPIN
       LSTINT1=6+ISPIN
       LSTINT2=26+ISPIN
       FULTYP1=18+ISPIN
       FULTYP2=20+ISPIN
       T1SIZE=NT(1)+IUHF*NT(2)
       ABFULL=IRPDPD(1,FULTYP1)
       MNFULL=IRPDPD(1,FULTYP2)
       DO 20 IRREP=1,NIRREP
        TARDSZ=aces_list_rows(IRREP,LSTTAR)
        TARDIS=aces_list_cols(IRREP,LSTTAR)
        TARSIZ=TARDSZ*TARDIS
        if (TARSIZ.LT.0) call trap_intovf('T1RING:TARSIZ',1)
        FULDSZ1=IRPDPD(IRREP,FULTYP1)
        FULDSZ2=IRPDPD(IRREP,FULTYP2)
        INTDSZ1=aces_list_rows(IRREP,LSTINT1)
        INTDIS1=aces_list_cols(IRREP,LSTINT1)
        INTDSZ2=aces_list_rows(IRREP,LSTINT2)
        INTDIS2=aces_list_cols(IRREP,LSTINT2)
        I1=TARDIS*TARSIZ+T1SIZE
        if (I1.LT.0) call trap_intovf('T1RING:I1',1)
        I2=3*TARDSZ
C
        I3A=FULDSZ1*INTDIS1+INTDSZ1
        I3B=FULDSZ2*INTDIS2+INTDSZ2
        if (I3A.LT.0) call trap_intovf('T1RING:I3A',1)
        if (I3B.LT.0) call trap_intovf('T1RING:I3B',1)
C
        I4A=2*ABFULL
        I4B=2*MNFULL
C
        INEEDA=I1+MAX(I2,I3A,I4A)
        INEEDB=I1+MAX(I2,I3B,I4B)
        INEED =MAX(INEED,INEEDA,INEEDB)
20     CONTINUE
10    CONTINUE
      IF(INEED.LT.MAXCOR/IINTFP)THEN
       CALL T1RA01(ICORE,MAXCOR,IUHF,LAMBDA)
      ELSE
       CALL T1RA02(ICORE,MAXCOR,IUHF,LAMBDA)
      ENDIF
C
C SPIN CASES ABBA AND BAAB
C
      INEED=-1
      DO 110 ISPIN=1,1+IUHF
       LSTTAR=57-ISPIN
       LSTINT1=31-ISPIN
       LSTINT2=8+ISPIN+(1-IUHF)
       T1SIZE=NT(1)+IUHF*NT(2)
       FULTYP1=18+ISPIN
       FULTYP2=20+ISPIN
       ABFULL=IRPDPD(1,FULTYP1)
       DO 120 IRREP=1,NIRREP
        TARDSZ=aces_list_rows(IRREP,LSTTAR)
        TARDIS=aces_list_cols(IRREP,LSTTAR)
        TARSIZ=TARDSZ*TARDIS
        if (TARSIZ.LT.0) call trap_intovf('T1RING:TARSIZ',2)
        INTDSZ1=aces_list_rows(IRREP,LSTINT1)
        INTDIS1=aces_list_cols(IRREP,LSTINT1)
        INTDSZ2=aces_list_rows(IRREP,LSTINT2)
        INTDIS2=aces_list_cols(IRREP,LSTINT2)
        I1=TARDIS*TARSIZ+T1SIZE
        if (I1.LT.0) call trap_intovf('T1RING:I1',2)
        I2=3*TARDSZ
C
        I3A=INTDSZ1*INTDIS1+3*MAX(INTDSZ1,INTDIS1)
        I3B=INTDSZ2*INTDIS2+3*MAX(INTDSZ2,INTDIS2)
        if (I3A.LT.0) call trap_intovf('T1RING:I3A',2)
        if (I3B.LT.0) call trap_intovf('T1RING:I3B',2)
C
        I4=2*ABFULL
C
        I5=TARDIS*TARDSZ+3*TARDSZ
        if (I5.LT.0) call trap_intovf('T1RING:I5',2)

        INEEDA=I1+MAX(I2,I3A,I4,I5)
        INEEDB=I1+MAX(I2,I3B,I4,I5)
        INEED =MAX(INEED,INEEDA,INEEDB)
120    CONTINUE
110   CONTINUE
      IF(INEED.LT.MAXCOR/IINTFP)THEN
       CALL T1RB01(ICORE,MAXCOR,IUHF,LAMBDA)
      ELSE
       CALL T1RB02(ICORE,MAXCOR,IUHF,LAMBDA)
      ENDIF
C
C STORE THE VALUES OF SUM(m,f) t(m;f) <ma||fe> IF AOBASIS IS TRUE
C DO THIS BY SUBTRACTING THE ACTUAL F(e;a)'s 
C BY THE F(e;a)'s READ IN BEFORE
C
      IF (AOBASIS) THEN
       I000=1
       DO 2222 ISPIN=1,1+IUHF
        I010=I000+NFMI(ISPIN)*IINTFP
        CALL GETLST(ICORE(I000),1,1,1,ISPIN,92)
        CALL GETLST(ICORE(I010),1,1,1,6+ISPIN,92)
        CALL SAXPY(NFMI(ISPIN),ONEM,ICORE(I010),1,ICORE(I000),1)
        CALL PUTLST(ICORE(I000),1,1,1,6+ISPIN,92)
 2222  CONTINUE
      ENDIF
C
C SPIN CASES ABAB AND BABA (FOR UHF ONLY)
C
c      IF(IUHF.EQ.0 )RETURN
      INEED=-1
      DO 210 ISPIN=1,1+IUHF
       LSTTAR=55+ISPIN
       LSTTMP1=37+ISPIN
       LSTTMP2=40-ISPIN
       LSTINT1=28+ISPIN
       LSTINT2=8+ISPIN
       T1SIZE=NT(1)+IUHF*NT(2)
       DO 220 IRREP=1,NIRREP
        TARDSZ=aces_list_rows(IRREP,LSTTAR)
        TARDIS=aces_list_cols(IRREP,LSTTAR)
        TARSIZ=TARDSZ*TARDIS
        if (TARSIZ.LT.0) call trap_intovf('T1RING:TARSIZ',3)
        TMPDSZ1=IRPDPD(IRREP,disttype_vo(3-ISPIN))
        TMPDIS1=IRPDPD(IRREP,disttype_vo(ISPIN))
        TMPDSZ2=IRPDPD(IRREP,disttype_vo(ISPIN))
        TMPDIS2=IRPDPD(IRREP,disttype_vo(3-ISPIN))
        INTDSZ1=IRPDPD(IRREP,h_DistType_Ab)
        INTDIS1=IRPDPD(IRREP,disttype_vo(3-ISPIN))
        INTDSZ2=IRPDPD(IRREP,h_DistType_Ij)
        INTDIS2=IRPDPD(IRREP,disttype_vo(ISPIN))
        I1=TARDIS*TARSIZ+T1SIZE
        if (I1.LT.0) call trap_intovf('T1RING:I1',3)
        I2=3*TARDSZ
C
        I3A=INTDSZ1*INTDIS1+3*MAX(INTDSZ1,INTDIS1)
        I3B=INTDSZ2*INTDIS2+3*MAX(INTDSZ2,INTDIS2)
        if (I3A.LT.0) call trap_intovf('T1RING:I3A',3)
        if (I3B.LT.0) call trap_intovf('T1RING:I3B',3)
C
        I4=TARDIS*TARDSZ+3*TARDSZ
        if (I4.LT.0) call trap_intovf('T1RING:I4',3)
C
        I5A=3*MAX(TMPDSZ1,TMPDIS1)
        I5B=3*MAX(TMPDSZ2,TMPDIS2)

        INEEDA=I1+MAX(I2,I3A,I4,I5A)
        INEEDB=I1+MAX(I2,I3B,I4,I5B)
        INEED =MAX(INEED,INEEDA,INEEDB)
220    CONTINUE
210   CONTINUE
      IF(INEED.LT.MAXCOR/IINTFP)THEN
       CALL T1RC01(ICORE,MAXCOR,IUHF,LAMBDA)
      ELSE
       CALL T1RC02(ICORE,MAXCOR,IUHF,LAMBDA)
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C Read the Z-matrix and find errors.

#include "iachar.h"

      subroutine debug_zmat
      implicit none

c "parameters"
#include "mxatms.par"
#include "io_units.par"
#include "linelen.par"

      character*(linelen) zline, dline
      integer izl(2,7), ref(3)
      logical not_done

      integer atoi, linblnk, i, j, k, iatom

      character*1 achar, czTab, czSpace, czPercent, czComment

c ----------------------------------------------------------------------

      czTab     = achar(_IACHAR_TAB)
      czSpace   = achar(_IACHAR_SPACE)
      czComment = achar(_IACHAR_POUND)
      czPercent = achar(_IACHAR_PERCENT)

      inquire(file=zfil,opened=not_done)
      if (.not.not_done)
     &   open(unit=luz,file=zfil,form='formatted',status='old')
      rewind luz

c   o skip the header (zline=TITLE on end do)
      not_done = .true.
      do while (not_done)
         read(luz,'(a)') zline
         call parsez(zline,izl)
         i = izl(1,1)
         not_done = (i.eq.0).or.(zline(i:i).eq.czPercent)
      end do

c   o first element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,1).eq.0) then
         write(*,*)
     &      '@DEBUG_ZMAT: There are no elements in the Z-matrix.'
         call errex
      end if
      if (izl(1,2).ne.0) then
         write(*,*)
     &      '@DEBUG_ZMAT: There are extra tokens on the first line.'
         write(*,*)
     &      '             (Perhaps the title line is missing.)'
         write(*,*) ' 1 : ',zline(izl(1,1):izl(2,2)),' ...'
         write (*,*) ' izl(1,2) = ',izl(1,2)
         call errex
      end if

c   o second element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,3).eq.0) then
         write(*,*)
     &      '@DEBUG_ZMAT: Line 2 must have three values.'
         i = max( izl(2,2) , izl(2,1) )
         write(*,*) ' 2 : ',zline(izl(1,1):i)
         call errex
      end if
      if (izl(1,4).ne.0) then
         write(*,*)
     &      '@DEBUG_ZMAT: There are extra tokens on the second line.'
         write(*,*) ' 2 : ',zline(izl(1,1):izl(2,4)),' ...'
         call errex
      end if

c   o third element
      read(luz,'(a)') zline
      call parsez(zline,izl)
      if (izl(1,5).eq.0) then
         write(*,*)
     &      '@DEBUG_ZMAT: Line 3 must have five values.'
         i = max( izl(2,4) , izl(2,3) , izl(2,2) , izl(2,1) )
         write(*,*) ' 3 : ',zline(izl(1,1):i)
         call errex
      end if
      if (izl(1,6).ne.0) then
         write(*,*)
     &      '@DEBUG_ZMAT: There are extra tokens on the third line.'
         write(*,*) ' 3 : ',zline(izl(1,1):izl(2,6)),' ...'
         call errex
      end if

c   o remaining elements
      iatom = 4
      read(luz,'(a)') zline
      call parsez(zline,izl)
      not_done = .true.
      do while (not_done)

         if (izl(1,7).eq.0) then
            write(*,*)
     &         '@DEBUG_ZMAT: Line ',iatom,' must have seven values.'
            i = max( izl(2,6) , izl(2,5) , izl(2,4) ,
     &               izl(2,3) , izl(2,2) , izl(2,1) )
            write(*,*) iatom,' : ',zline(izl(1,1):i)
            call errex
         end if

         ref(1) = atoi( zline(izl(1,2):izl(2,2)) )
         ref(2) = atoi( zline(izl(1,4):izl(2,4)) )
         ref(3) = atoi( zline(izl(1,6):izl(2,6)) )

c        REUSED REFS

         if (ref(1).eq.ref(2)) then
            dline = zline
            call prep_dline_2(dline,izl,2,4)
            write(*,*) '@DEBUG_ZMAT: References cannot be reused.'
            write(*,*) iatom,' : ',zline(izl(1,1):izl(2,7))
            write(*,*) iatom,' : ',dline(izl(1,1):izl(2,7))
            write(*,*)
         end if

         if (ref(1).eq.ref(3)) then
            dline = zline
            call prep_dline_2(dline,izl,2,6)
            write(*,*) '@DEBUG_ZMAT: References cannot be reused.'
            write(*,*) iatom,' : ',zline(izl(1,1):izl(2,7))
            write(*,*) iatom,' : ',dline(izl(1,1):izl(2,7))
            write(*,*)
         end if

         if (ref(2).eq.ref(3)) then
            dline = zline
            call prep_dline_2(dline,izl,4,6)
            write(*,*) '@DEBUG_ZMAT: References cannot be reused.'
            write(*,*) iatom,' : ',zline(izl(1,1):izl(2,7))
            write(*,*) iatom,' : ',dline(izl(1,1):izl(2,7))
            write(*,*)
         end if

c        ZERO REFS

         do j = 1, 3
            if (ref(j).eq.0) then
               dline = zline
               i = ishft(j,1)
               call prep_dline_2(dline,izl,i,i)
               write(*,*) '@DEBUG_ZMAT: Reference ',j,' for element ',
     &                    iatom,' does not exist.'
               write(*,*) iatom,' : ',zline(izl(1,1):izl(2,7))
               write(*,*) iatom,' : ',dline(izl(1,1):izl(2,7))
               write(*,*)
            end if
         end do

c        UNDEFINED REFS

         do j = 1, 3
            if (ref(j).gt.iatom) then
               dline = zline
               i = ishft(j,1)
               call prep_dline_2(dline,izl,i,i)
               write(*,*) '@DEBUG_ZMAT: Reference ',j,' for element ',
     &                    iatom,' has not yet been defined.'
               write(*,*) iatom,' : ',zline(izl(1,1):izl(2,7))
               write(*,*) iatom,' : ',dline(izl(1,1):izl(2,7))
               write(*,*)
            end if
         end do

c        SELF-REF

         do j = 1, 3
            if (ref(j).eq.iatom) then
               dline = zline
               i = ishft(j,1)
               call prep_dline_2(dline,izl,i,i)
               write(*,*) '@DEBUG_ZMAT: Element ',iatom,
     &                    ' references itself.'
               write(*,*) iatom,' : ',zline(izl(1,1):izl(2,7))
               write(*,*) iatom,' : ',dline(izl(1,1):izl(2,7))
               write(*,*)
            end if
         end do

         iatom = iatom + 1
         read(luz,'(a)') zline
         call parsez(zline,izl)
         not_done = (linblnk(zline(1:80)).ne.0)

c     end do while (not_done)
      end do

      call errex
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine worker_work()
c---------------------------------------------------------------------------
c   "Work" routine for the worker task.
c---------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'proto_events.h'
      include 'int_gen_parms.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'saved_data.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer pst_get_my_company
      integer pst_get_master
      integer my_company
      integer ierr, master
      integer dummy
      integer dryrun_flag
      integer dbgval

      double precision t1
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      integer msg1, msg2
      save msg1, msg2

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      my_company = pst_get_my_company()
c#ifdef HP
      call clear_saved_requests()
c#endif

      if (dryrun) return

#ifdef ALTIX
      dptr = dshptr
#endif

c-------------------------------------------------------------------------
c   Call worker subroutines for the particular company.
c-------------------------------------------------------------------------

      if (my_company .eq. io_company_id) then
         call sip_server_work()   ! enter server processing
      else if (my_company .ne. MPI_UNDEFINED) then

         dryrun_flag = 0

         if (dbg) then
            dbgval = 1
         else
            dbgval = 0
         endif

         call sumz_work(dryrun_flag, nworkthread, dbgval, x(ithread))
         if (dbg) print *,'Task ',me,' Exiting sumz_work...'
      endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C PRINTS LOWER DIAGONAL ATOMIC DISTANCE MATRIX FOR ACES2 PROGRAM SYSTEM.

      SUBROUTINE ADM
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
      PARAMETER (BA = 0.529177249d0)
      PARAMETER (NCOL = 6)
c      PARAMETER (TOL = 0.5)
      PARAMETER (TOL = 0.2)

C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
      DIMENSION V1(3),V2(3)

cJDW 1/6/98
c   Scratch array for holding up to five distances. Introduced
c   because previous code did not work on Suns with f90.
      DIMENSION SCR(5)
      INTEGER ITMP

C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT

      IQ(I)=3*I-2

c ----------------------------------------------------------------------

c      write(6,*) '  @ADM-I, Coordinates : '
c      write(6,'(3F15.10)') Q(1),Q(2),Q(3)
c      write(6,'(3F15.10)') Q(4),Q(5),Q(6)
c      write(6,'(3F15.10)') Q(7),Q(8),Q(9)

      iexit = 0

      WRITE(6,'(t3,a)') ' Interatomic distance matrix (Angstroms) '

      JBOT = 1
      NTIMES = 1 + (NATOMS-1)/5
      DO ICOUNT = 1, NTIMES
         WRITE(6,*)
         WRITE(6,142) (ZSYM(ICN),ICN=JBOT,MIN(NATOMS,JBOT+4))
 142     FORMAT(17X,A,4(9X,A))
         WRITE(6,144) (ICN,ICN=JBOT,MIN(NATOMS,JBOT+4))
 144     FORMAT(16X,:'[',I2,']',4(8X,:'[',I2,']'))
         DO I = JBOT, NATOMS
c      write(6,*) jbot,i,natoms,iq(1),iq(2),iq(3)
c      write(6,*) ' jbot,i,min(i,jbot+4) ',jbot,i,min(i,jbot+4)
c      write(6,*) '  @ADM-I, Coordinates : '
c      write(6,'(3F15.10)') Q(1),Q(2),Q(3)
c      write(6,'(3F15.10)') Q(4),Q(5),Q(6)
c      write(6,'(3F15.10)') Q(7),Q(8),Q(9)
            ITMP = MIN(I,JBOT+4)-JBOT+1
            IF (ITMP.GT.5) THEN
               WRITE(6,*) '@ADM: Loop limit exceeded. ',I,JBOT,ITMP
            END IF
            DO J = 1, ITMP
               SCR(J) = BA * DIST(Q(IQ(I)),Q(IQ(J+JBOT-1)))
            END DO
cJDW - old
c   This led to problems with f90 on Suns. The old code did not
c   work, but the new code seems to. Essential difference is we
c   calculate the MIN(I,JBOT+4)-JBOT+1 distances before the
c   write statement.
c            WRITE(6,143) ZSYM(I),I,(BA*DIST(Q(IQ(I)),Q(IQ(J))),J=JBOT,
c     &      MIN(I,JBOT+4))
cJDW - new
            WRITE(6,143) ZSYM(I),I,(SCR(J),J=1,ITMP)
cJDW - end
 143        FORMAT(T3,A,'[',I2,']',5(2X,F10.5))
         END DO
         JBOT = JBOT + 5
      END DO

c CHECK DISTANCES TO SEE IF ANY ARE TOO SHORT. CALL EXIT IF BELOW
c A CERTAIN TOLERANCE.

       dismax = 0.0
       DO 12 I = 1, NATOMS
       DO 12 J = I+1, NATOMS
       DIS=DIST(Q(IQ(I)),Q(IQ(J)))*BA
c-pr
c  get the longest distance, for a cavity radius in RFSCF calculations
       dismax = max(dis,dismax)
c-pr
       IF (DIS.LT.TOL) THEN
c         IF ONE IS A DUMMY (or a ghost), GO ON.
          IF(ATMASS(I).LT.1.D-3.OR.ATMASS(J).LT.1.D-3)GOTO 12
          IF(ATMASS(I).ge.100d0.OR.ATMASS(J).ge.100d0)GOTO 12
          WRITE(6,231)I,J,DIS,TOL
231       FORMAT(T3,' Atoms ',i2,' and ',i2,' are too close.',
     &/,T3,' Distance of ',f6.4,' Angstroms is below threshold of '
     &,f6.4,'.')
          IEXIT = 1
       END IF
c-pr
       dismax = 0.5 + 0.5*dismax
       call dputrec(20,'JOBARC','CAVITY',1,dismax)
c-pr
12     CONTINUE
C
C CRANK OUT ANGLES IF IPRNT IS SET TO A SUFFICIENTLY HIGH VALUE.
C
       IF (IPRNT.GE.600) THEN
       WRITE(6,702)
 702   FORMAT(/,T3,' Interatomic angles (degrees) ',/)
C
C LOOP OVER ALL ATOMS, PUTTING EACH AT THE ORIGIN OF A X-Y-Z ANGLE
C   PAIR.  INCLUDE THE DUMMY ATOMS TO MAKE CERTAIN USERS HAPPY.
C
       ANGTOL = 3.D0/BA
       ICNT = 0
       DO 15 I = 1, NATOMS
        DO 205 J = 1, NATOMS
         IF (J.EQ.I) GOTO 205
         DO K = 1, J-1
          IF (K.NE.I.AND.K.NE.J) THEN
C
C CHECK TO MAKE SURE THAT D(I,J) AND D(I,K) ARE BOTH LESS THAN 3 ANGSTROMS
C IF EITHER J OR K IS TOO FAR AWAY, GO ON.
C
          IF (DIST(Q(IQ(I)),Q(IQ(J))).LE.ANGTOL.AND.
     &        DIST(Q(IQ(I)),Q(IQ(K))).LE.ANGTOL) THEN
          CALL VEC(Q(IQ(I)),Q(IQ(J)),V1,1)
          CALL VEC(Q(IQ(I)),Q(IQ(K)),V2,1)
          Z=ANGLE(V1,V2,3)
          ICNT=ICNT+1
          IF(MOD(ICNT,2).EQ.1)THEN
           WRITE(6,400)ZSYM(K),K,ZSYM(I),I,ZSYM(J),J,Z
          ELSE
           WRITE(6,401)ZSYM(K),K,ZSYM(I),I,ZSYM(J),J,Z
          ENDIF
 400      FORMAT(/,T3,A2,'[',I2,']-',A2,'[',I2,']-',A2,'[',I2,']',
     &           2X,F9.5)
 401      FORMAT(T3,A2,'[',I2,']-',A2,'[',I2,']-',A2,'[',I2,']',
     &           2X,F9.5)
          END IF
          END IF
          END DO
 205     CONTINUE
 15    CONTINUE

       IF (MOD(ICNT,2).EQ.1) THEN
          WRITE(6,402)ICNT
 402   FORMAT(/ ,T3,I5,' interatomic angles printed.')
       ELSE
          WRITE(6,403)ICNT
 403   FORMAT(//,T3,I5,' interatomic angles printed.')
       END IF

       END IF

       if (iexit.eq.1) then
          write (6,*) '@ADM: Inspect distance matrix and correct input.'
          call errex
       end if

       RETURN
       END

C COMPUTES C(I)=A(I)/B(I) FOR FIRST N ELEMENTS OF VECTORS A AND B.

      SUBROUTINE VECDIV(A,B,C,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N),B(N),C(N)
      if (n.lt.1) return
      DO I = 1, N
         C(I) = A(I) / B(I)
      END DO
      RETURN
      END

      SUBROUTINE T1RC01(ICORE,MAXCOR,IUHF,LAMBDA)
C
C THIS SUBROUTINE COMPUTES TWO T1*W CONTRIBUTIONS TO THE
C  W(mbej) INTERMEDIATE.  
C
C     W(mBeJ) =   SUM T(J,F) * <Fe|Bm> - T(N,B) * <Nm|Je>
C     W(MbEj) =   SUM T(j,f) * <fE|bM> - T(n,b) * <nM|jE>
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL LAMBDA,CHANGE
      DOUBLE PRECISION ONE,ONEM,ZILCH,ALPHA,BETA,FACTOR
      CHARACTER*4 SSTSPN
      LOGICAL RHF
      DIMENSION ICORE(MAXCOR),IOFFT1(8,2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),
     &                DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF2AA,
     &             NF1BB,NF2BB
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols
      CHANGE=.TRUE.
      RHF=.FALSE.
      IF(IUHF.EQ.0)RHF=.TRUE.
C
C FIRST PICK UP T1 VECTOR.
C
      CALL GETT1(ICORE,MAXCOR,MXCOR,IUHF,IOFFT1)
C
C SPIN CASES ABAB AND BABA, RESPECTIVELY.
C
      DO 10 ISPIN=1,1+IUHF
       LSTTAR=55+ISPIN
       IF(LAMBDA)THEN
        LSTOUT=119-ISPIN
        FACTOR=ONEM
       ELSE
        LSTOUT=LSTTAR
        FACTOR=ONE
       ENDIF
C
C RESET THE TARGET LIST PARAMETERS BECAUSE IT MUST FIRST BE USED AS A
C  SCRATCH LIST FOR A LIST WHICH IS PACKED DIFFERENTLY.
C
       IF(IUHF.NE.0)THEN
        LSTSCR=40-ISPIN
        CALL NEWTYP(LSTOUT,ISYTYP(1,LSTSCR),ISYTYP(2,LSTSCR),CHANGE)
       ENDIF
C
C LOOP OVER IRREPS - IN THE FIRST BLOCK OF CODE THIS CORRESPONDS TO mB,
C                    WHILE IT IS jE IN THE SECOND BLOCK.
C
C     W(MbEj) =   SUM T(j,f) * <fE|bM> - T(n,b) * <nM|jE>
C     W(mBeJ) =   SUM T(J,F) * <Fe|Bm> - T(N,B) * <Nm|Je>
C
       DO 20 IRREPDO=1,NIRREP
C
C COMPUTE DIMENSIONS OF TARGET MATRIX.
C
        DSZTAR=IRPDPD(IRREPDO,ISYTYP(1,LSTOUT))
        DISTAR=IRPDPD(IRREPDO,ISYTYP(2,LSTOUT))
        DSZTMP=IRPDPD(IRREPDO,13-ISPIN)
        DISTMP=IRPDPD(IRREPDO,10+ISPIN)
C
C FIRST DO       W(MbEj) =   SUM T(j,f) * <Ef|Mb> (ISPIN=1)
C                W(mBeJ) =   SUM T(J,F) * <Fe|Bm> (ISPIN=2 OR RHF).
C
C THIS PRODUCT IS INITIALLY PACKED Mb,Ej [Bm,eJ].
C
       CALL IZERO(ICORE,IINTFP*DSZTMP*DISTMP)
        ALPHA=ONE*FACTOR
        BETA=ONE
        LISTW1=28+ISPIN
        IF(RHF)LISTW1=30
        DISW  =aces_list_cols(IRREPDO,LISTW1)
        DSZW  =aces_list_rows(IRREPDO,LISTW1)
        I000  =1
        I010  =I000+IINTFP*DISTMP*DSZTMP
        I020  =I010+IINTFP*DSZW*DISW
        I030  =I020+IINTFP*DSZW
C
C READ INTEGRALS INTO AN I(Mb,Ef) [I(Bm,Fe)] MATRIX
C
        CALL GETTRN(ICORE(I010),ICORE(I020),DSZW,DISW,2,IRREPDO,
     &              LISTW1)
        ITMP=DISW
        DISW=DSZW
        DSZW=ITMP
C
C TRANSPOSE KET INDICES IF ISPIN=2
C
        IF(ISPIN.EQ.2.OR.RHF)THEN
         I030=I020+IINTFP*DSZW
         I040=I030+IINTFP*DSZW
         I050=I040+DSZW
         CALL SYMTR1(IRREPDO,VRT(1,1),VRT(1,2),DSZW,ICORE(I010),
     &               ICORE(I020),ICORE(I030),ICORE(I040))
        ENDIF
C
C WE NOW HAVE
C
C                   I(Mb,Ef)    [ISPIN=1]
C                   I(Bm,eF)    [ISPIN=2 OR RHF]
C
C SETUP AND PERFORM THE MATRIX MULTIPLY
C
C                 I(MbE,f) * T(f,j) [ISPIN=1]
C                 I(Bme,F) * T(F,J) [ISPIN=2 OR RHF]
C             
C
         IOFFI=I010
         IOFFZ=I000
         DO 100 IRREPF=1,NIRREP
          IRREPE=DIRPRD(IRREPF,IRREPDO)
          IRREPJ=IRREPF
          NROWI=DSZW*VRT(IRREPE,ISPIN)
          NCOLI=VRT(IRREPF,3-ISPIN)
          NROWT=VRT(IRREPF,3-ISPIN)
          NCOLT=POP(IRREPJ,3-ISPIN)
          NROWZ=NROWI
          NCOLZ=NCOLT
          IOFFT=IOFFT1(IRREPF,3-ISPIN)
          IF(MIN(NROWZ,NCOLZ,NCOLI).GT.0)THEN
           CALL XGEMM('N','N',NROWZ,NCOLZ,NCOLI,ALPHA,ICORE(IOFFI),
     &                NROWI,ICORE(IOFFT),NROWT,BETA,ICORE(IOFFZ),NROWZ)
          ENDIF
          IOFFI=IOFFI+IINTFP*NROWI*NCOLI
          IOFFZ=IOFFZ+IINTFP*NROWZ*NCOLZ
100      CONTINUE
C
C NOW WE HAVE A Mb-Ej (ISPIN=1) OR Bm-eJ (ISPIN=2 OR RHF) ORDERED
C  QUANTITY.  THE NEXT PIECE WILL BE ORDERED Ej-Mb (ISPIN=1) OR
C  Je-mB (ISPIN=2 OR RHF), SO WE NEED TO REORDER WHAT WE HAVE TO MATCH
C  THIS, THEREBY ALLOWING ACCUMULATION IN MATRIX MULTIPLY OPERATIONS.
C
        IF(ISPIN.EQ.2.OR.RHF)THEN
         I020=I010+IINTFP*MAX(DSZTMP,DISTMP)
         I030=I020+IINTFP*MAX(DSZTMP,DISTMP)
         I040=I030+IINTFP*MAX(DSZTMP,DISTMP)
         CALL SYMTR1(IRREPDO,VRT(1,2),POP(1,1),DSZTMP,ICORE(I000),
     &               ICORE(I010),ICORE(I020),ICORE(I030))
         CALL SYMTR3(IRREPDO,VRT(1,1),POP(1,2),DSZTMP,DISTMP,
     &               ICORE(I000),ICORE(I010),ICORE(I020),ICORE(I030))
        ENDIF
        I020=I010+IINTFP*DSZTMP*DISTMP
        CALL TRANSP(ICORE(I000),ICORE(I010),DISTMP,DSZTMP)
c YAU : old
c       CALL ICOPY(IINTFP*DISTMP*DSZTMP,ICORE(I010),1,ICORE(I000),1)
c YAU : new
        CALL DCOPY(DISTMP*DSZTMP,ICORE(I010),1,ICORE(I000),1)
c YAU : end
C
C NOW DO    W(MbEj) =   - T(n,b) * <Mn|Ej>   (ISPIN=1)
C           W(mBeJ) =   - T(N,B) * <Nm|Je>   (ISPIN=2 OR RHF)
C
        ALPHA=ONEM*FACTOR
        BETA=ONE
        LISTW2=8+ISPIN
        IF(RHF)LISTW2=10
        DSZTMP=IRPDPD(IRREPDO,10+ISPIN)
        DISTMP=IRPDPD(IRREPDO,13-ISPIN)
        DISW  =aces_list_cols(IRREPDO,LISTW2)
        DSZW  =aces_list_rows(IRREPDO,LISTW2)
        I020  =I010+IINTFP*DSZW*DISW
        I030  =I020+IINTFP*DSZW
        CALL GETTRN(ICORE(I010),ICORE(I020),DSZW,DISW,2,IRREPDO,LISTW2)
        ITMP=DISW
        DISW=DSZW
        DSZW=ITMP
C
C WE NOW HAVE 
C                I(Ej,Mn) [ISPIN=1]
C                I(Je,Nm) [ISPIN=2 OR RHF]
C
C WE NEED TO HAVE N AS THE SLOWEST INDEX, SO TRANSPOSE KET INDICES FOR ISPIN=2.
C
        IF(ISPIN.EQ.2.OR.RHF)THEN
         I030=I020+IINTFP*DSZW 
         I040=I030+IINTFP*DSZW 
         I050=I040+IINTFP*DSZW 
         CALL SYMTR1(IRREPDO,POP(1,1),POP(1,2),DSZW,ICORE(I010),
     &               ICORE(I020),ICORE(I030),ICORE(I040))
        ENDIF
C
C WE NOW HAVE
C                I(Ej,Mn) [ISPIN=1]
C                I(Je,mN) [ISPIN=2 OR RHF]
C
C
C AND WE CAN DO THE MATRIX MULTIPLY
C                                 t
C                I(Ej,Mn) * T(b,n)  [ISPIN=1]
C                                 t
C                I(Je,mN) * T(B,N)  [ISPIN=2 OR RHF]
C
        IOFFI=I010
        IOFFZ=I000
        DO 200 IRREPN=1,NIRREP
         IRREPM=DIRPRD(IRREPN,IRREPDO)
         IRREPB=IRREPN
         NROWI=DSZW*POP(IRREPM,ISPIN)
         NCOLI=POP(IRREPN,3-ISPIN)
         NROWT=VRT(IRREPB,3-ISPIN)
         NCOLT=POP(IRREPN,3-ISPIN)
         NROWZ=NROWI
         NCOLZ=NROWT
         IOFFT=IOFFT1(IRREPB,3-ISPIN)
         IF(MIN(NROWZ,NCOLZ,NCOLI).GT.0)THEN
          CALL XGEMM('N','T',NROWZ,NCOLZ,NCOLI,ALPHA,ICORE(IOFFI),
     &               NROWI,ICORE(IOFFT),NROWT,BETA,ICORE(IOFFZ),
     &               NROWZ)
         ENDIF
         IOFFI=IOFFI+IINTFP*NROWI*NCOLI
         IOFFZ=IOFFZ+IINTFP*NROWZ*NCOLZ
200     CONTINUE
C
C REORDER TO 
C           Ej-Mb ->  Ej-bM [ISPIN=1]
C           Je-mB ->  eJ-Bm [ISPIN=2 OR RHF]
C     
        I020=I010+IINTFP*DSZTMP
        I030=I020+IINTFP*DSZTMP
        I040=I030+IINTFP*DSZTMP
        CALL SYMTR1(IRREPDO,POP(1,ISPIN),VRT(1,3-ISPIN),DSZTMP,
     &              ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030))
        IF(ISPIN.EQ.2.OR.RHF)THEN
         I020=I010+IINTFP*MAX(DSZTMP,DISTMP)
         I030=I020+IINTFP*MAX(DSZTMP,DISTMP)
         I040=I030+IINTFP*MAX(DSZTMP,DISTMP)
         CALL SYMTR3(IRREPDO,POP(1,1),VRT(1,2),DSZTMP,DISTMP,
     &               ICORE(I000),ICORE(I010),ICORE(I020),
     &               ICORE(I030))
        ENDIF
        IF(ISPIN.EQ.1.AND..NOT.RHF)THEN
         SSTSPN='ABBA'
        ELSE
         SSTSPN='BAAB'
        ENDIF 
C
C NOW WRITE THESE TO DISK FOR EACH IRREP.  
C
        CALL PUTLST(ICORE(I000),1,DISTMP,1,IRREPDO,LSTOUT)
20     CONTINUE
C
C NOW SWITCH ORDERING  
C
C           Ej-bM ->  EM-bj [ISPIN=1]
C           eJ-Bm ->  em-BJ [ISPIN=2 OR RHF]
C
       ISCSIZ=(NVRTO(1)+NVRTO(2))*(NOCCO(1)+NOCCO(2))
       TARSIZ=ISYMSZ(ISYTYP(1,LSTTAR),ISYTYP(2,LSTTAR))
       I000=1
       I010=I000+TARSIZ*IINTFP
       I020=I010+TARSIZ*IINTFP
       I030=I020+ISCSIZ
       IF(I030.GT.MXCOR)CALL INSMEM('T1RABBA',I030,MXCOR)
       CALL GETALL(ICORE(I010),TARSIZ,1,LSTOUT)
       CALL SSTRNG(ICORE(I010),ICORE(I000),TARSIZ,TARSIZ,ICORE(I020),
     &             SSTSPN)
       IF(IUHF.NE.0)CALL NEWTYP(LSTOUT,8+ISPIN,11-ISPIN,CHANGE)
C
C  FOR LAMBDA UPDATE LSTTAR AND COPY ORIGINAL INTERMEDIATES TO LSTOUT
C
       IF(LAMBDA) THEN
        CALL GETALL(ICORE(I010),TARSIZ,1,LSTTAR)
        CALL PUTALL(ICORE(I010),TARSIZ,1,LSTOUT)
        CALL SAXPY(TARSIZ,ONE,ICORE(I010),1,ICORE(I000),1)
       ENDIF
C
       CALL PUTALL(ICORE(I000),TARSIZ,1,LSTTAR)
10    CONTINUE
      RETURN
      END

      function lstr(str,l)
c
c     find rightmost non-blank in string str of length l
c     and return its position
c
      implicit double precision (a-h,o-z)
      character*(*) str

      lstr=0
      i=min(len(str),l)+1
   10 i=i-1
      if(i.eq.0) return
      if(str(i:i).eq.' ') go to 10
      lstr=i

      return 
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork0666(y, x1,
     *                     ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,
     *                     nm1,nm2,nn1,nn2, 
     *                     e1,e2,f1,f2,g1,g2,h1,h2,
     *                     m1,m2,n1,n2, 
     *                     indx1, x2,
     *                     ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                     no1,no2,np1,np2, 
     *                     i1,i2,j1,j2,k1,k2,l1,l2,i5,j5,i6,j6,
     *                     indx2, flopcount)
c-------------------------------------------------------------------------
c   Performs a "0666" contraction: 
c      0 index output array
c      6 index operand array
c      6 index operand array
c      6 index contraction.
c
c   I. e., contract all 4 indices of the 2nd operand array with the
c   first operand array, storing the result in a scalar. 
c--------------------------------------------------------------------------
      implicit none

      integer ne1,ne2,nf1,nf2,
     *        ng1,ng2,nh1,nh2,
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2, 
     *        nm1,nm2,nn1,nn2,
     *        no1,no2,np1,np2 
      integer e1,e2,f1,f2,g1,g2,h1,h2,
     *        i1,i2,j1,j2,k1,k2,l1,l2, 
     *        m1,m2,n1,n2,i5,j5,i6,j6  
      integer indx1(4), indx2(4), indi, indj
      integer flopcount

      double precision xddot
      double precision y
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2,
     *                    nm1:nm2,nn1:nn2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2,
     *                    no1:no2,np1:np2)

      integer ii,ij,ik,il
      integer i, j, k, l, m, n, ix(4)
      integer one 

      flopcount = 0
      y = 0.0d0 

c--------------------------------------------------------------------------
c   Indices of x1, x2 line up exactly.  Use optimized contraction loop.
c--------------------------------------------------------------------------

         n = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(l2-l1+1)
     *      *(j5-i5+1)*(j6-i6+1)
         one = 1
         y = xddot(n, x1(i1,j1,k1,l1,i5,i6), one, 
     *                x2(i1,j1,k1,l1,i5,i6), one)
c     y = 0.0d0 
c     do i = i1, i2 
c     do j = j1, j2 
c     do k = k1, k2 
c     do l = l1, l2 
c     do m = i5, j5  
c     do n = i6, j6  
c        y = y + x1(i,j,k,l,m,n)*x2(i,j,k,l,m,n) 
c     enddo 
c     enddo 
c     enddo 
c     enddo 
c     enddo 
c     enddo 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine descramble_coefficients(ca, na, epsa, nfps, 
     *                ixshells, nshells)
c--------------------------------------------------------------------------
c   Unscrambles the transformation coefficients and eigenvalues 
c   prior to writing them out.  After the descramble procedure, the
c   data is back into VMOL order, and is usable by other ACES member
c   executables.
c--------------------------------------------------------------------------

      implicit none
      integer na, nshells
      integer nfps(nshells)
      integer ixshells(nshells)
      double precision ca(na,na)
      double precision epsa(na)
      double precision xa(na)
      integer ixa(na)
      integer nfps_orig(nshells)

      integer i, j, istart, ishell, n

      if (na .gt. 0) then

c-------------------------------------------------------------------------
c   Descramble the number of functions per shell.
c-------------------------------------------------------------------------

         do i = 1, nshells
            nfps_orig(ixshells(i)) = nfps(i)
         enddo

c--------------------------------------------------------------------------
c   Build a basis function index array from the shell index array.
c--------------------------------------------------------------------------

         istart = 1
         do i = 1, nshells
            ishell = ixshells(i)

c---------------------------------------------------------------------------
c   Calculate the starting basis function.
c---------------------------------------------------------------------------

            n = 0
            do j = 1, ishell-1
               n = n + nfps_orig(j)
            enddo

c----------------------------------------------------------------------------
c   Store the next "nfps_orig(ishell)" indices in the index array.
c----------------------------------------------------------------------------

            do j = 1, nfps_orig(ishell)
               ixa(istart) = n + j
               istart = istart + 1
            enddo
         enddo

         do j = 1, na

c--------------------------------------------------------------------------
c   Save column "j".
c--------------------------------------------------------------------------

            do i = 1, na
               xa(i) = ca(i,j)
            enddo

            do i = 1, na
               ca(ixa(i),j) = xa(i)
            enddo

         enddo

c         do i = 1, na
c            xa(i) = epsa(i)
c         enddo

c         do i = 1, na
c            epsa(ixa(i)) = xa(i)
c         enddo
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine proto_assign_status(master, ihosts, nprocs, 
     *                               task_status,
     *                               master_is_worker,
     *                               managers_are_workers)

c------------------------------------------------------------------------
c   Determines task assignments based on host IDs and user parameters.
c   
c   Arguments:
c       master  	Global index of the master task.
c	ihosts		Array of processor host IDs.
c	nprocs		Number of processors.
c	task_status	Return array for the status of each task.
c
c   The task status takes on one of the following values:
c	worker_status		the task is a worker.
c	manager_status		the task is a manager.
c	both_status		the task is both worker and manager.
c       master_status           the task is the master.
c       master_worker_status    the task is both master and worker.
c
c-------------------------------------------------------------------------

      implicit none
      include 'proto_defines.h'

      integer master, nprocs
      integer ihosts(nprocs), task_status(nprocs)
      logical master_is_worker, managers_are_workers

      integer i, k
      logical manager_was_assigned

c------------------------------------------------------------------------
c   Initialize status array.
c------------------------------------------------------------------------

      do i = 1, nprocs
         task_status(i) = unassigned_status
      enddo

c-------------------------------------------------------------------------
c   Determine a node index for each task.
c-------------------------------------------------------------------------

      do i = 1, nprocs
         if (task_status(i) .ne. unassigned_status) go to 100

         if (i .eq. master+1) then

c-------------------------------------------------------------------------
c   Assign the master task.
c-------------------------------------------------------------------------

            manager_was_assigned = .false.
            if (master_is_worker) then
               task_status(i) = master_worker_status
            else
               task_status(i) = master_status
            endif
         else

c-------------------------------------------------------------------------
c   Assign this task as manager for its node.
c-------------------------------------------------------------------------

            manager_was_assigned = .true.
            if (managers_are_workers) then
               task_status(i) = both_status
            else
               task_status(i) = manager_status
            endif
         endif

c-------------------------------------------------------------------------
c   Assign all remaining tasks for this host.
c-------------------------------------------------------------------------

         do k = i+1, nprocs
            if (ihosts(k) .eq. ihosts(i)) then

c-------------------------------------------------------------------------
c   If the node's manager was not assigned prior to the loop, it must be 
c   done now.  Otherwise, we just have a worker.
c-------------------------------------------------------------------------
 
               if (.not. manager_was_assigned) then
                  manager_was_assigned = .true.
                  if (managers_are_workers) then
                     task_status(k) = both_status
                  else
                     task_status(k) = manager_status
                  endif
               else 
                  task_status(k) = worker_status 
               endif
            endif
         enddo
   
c---------------------------------------------------------------------------
c   IMPORTANT: If we get here and still haven't assigned a manager, we 
c              must do so now, even if the user has forbidden the use
c              of manager tasks as workers.  The only exception is if
c              the current task is the master, which can never be a 
c              manager.
c---------------------------------------------------------------------------

         if (.not. manager_was_assigned .and.
     *       i .ne. master+1) then
            task_status(i) = both_status       ! must do double duty.
         endif

  100 continue
      enddo

      return
      end

      SUBROUTINE FRMRIJ3(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,I,J,
     &                  SINGLE)
C
C THIS ROUTINE IS USED TO FORM THE R MATRIX USED IN THE RLE SOLUTION
C  OF THE CC EQUATIONS.  RLECYC IS THE NUMBER OF CYCLES WHICH HAVE BEEN
C  COMPLETED, I IS THE ROW NUMBER OF THE MATRIX ELEMENT WHICH IS TO BE 
C  COMPUTED AND J IS THE COLUMN NUMBER.  IF I IS NONZERO AND J IS ZERO,
C  THE THE ENTIRE Ith ROW WILL BE CONSTRUCTED.  SIMILARLY, IF I IS ZERO AND
C  J IS NONZERO, THE Jth COLUMN WILL BE FORMED.
C
C THE FORMULA FOR AN R MATRIX ELEMENT IS:
C
C                [i]     [j]   [i]     (j+1)      (i)
C      R(I,J) = T   D   T   - T   D   T       -  Q
C
C WHERE Q IS THE T2 CONTRIBUTION TO THE ENERGY FOR HF CASES AND
C  E<-T2 + E<-T1 FOR NON-HF CASES.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(MAXCOR)
      DOUBLE PRECISION R,FACTOR,SDOT,ECORR,ONEM
      LOGICAL SINGLE,GETT1V
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /RMAT/ R(400)
cAP - 500 is the maximum number of CC iterations (not basis functions)
      COMMON /ENERGY/ ECORR(500,2),IXTRLE(500)
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF1(2),NF2(2)
      COMMON /RLEIO/ IOLDEST
      DATA ONEM /-1.0/
      INDX(I,J)=I+(J-1)*MAXORD
      IGET(I)  =1+MOD(IOLDEST+MAXORD-I,MAXORD+1)
      RSIZE=MIN(RLECYC-1,MAXORD)
C
C CASE ONE.  ONLY ONE ELEMENT WILL BE FORMED.
C
      IF(I.NE.0.AND.J.NE.0)THEN
       IROW=I
       ICOL=J
       IOFF=INDX(IROW,ICOL)
       R(IOFF)=0.0
       NLSTI=1+IROW
       NLSTJ=1+ICOL
       NLSTJP1=NLSTJ-1
       DO 100 ISPIN=3,1,IUHF-2
        IADD=0
        GETT1V=.FALSE.
        IF(ISPIN.LT.3.AND.IUHF.EQ.0)THEN
         FACTOR=2.0
        ELSE
         FACTOR=1.0
        ENDIF
        IF(SINGLE.AND.ISPIN.LT.3)THEN
         IADD=NT(ISPIN) 
         GETT1V=.TRUE.
        ENDIF
        SIZET2=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
        SIZET=SIZET2+IADD
        IOFFT1=IINTFP*SIZET2
        I000=1
        I010=I000+SIZET*IINTFP
        I020=I010+SIZET*IINTFP
        CALL GETLST(ICORE(I000),IGET(NLSTI),1,1,ISPIN+3,70)
        CALL GETALL(ICORE(I010),SIZET,1,63+ISPIN)
        IF(GETT1V)CALL GETLST(ICORE(I010+IOFFT1),1,1,2,9,63+ISPIN)
        CALL VECPRD(ICORE(I000),ICORE(I010),ICORE(I000),SIZET)
        CALL GETLST(ICORE(I010),IGET(NLSTJ),1,1,ISPIN+3,70)
        R(IOFF)=R(IOFF)+FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
        CALL GETLST(ICORE(I010),IGET(NLSTJP1),1,1,ISPIN,70)
        R(IOFF)=R(IOFF)-FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
100    CONTINUE
       R(IOFF)=R(IOFF)+ECORR(RLECYC-IROW,2)
      ELSEIF(I.NE.0.AND.J.EQ.0)THEN
       IROW=I
       NLSTI=1+IROW
       DO 200 ICOL=1,RSIZE
        R(INDX(IROW,ICOL))=0.0
200    CONTINUE
       DO 201 ISPIN=3,1,IUHF-2
        IADD=0
        GETT1V=.FALSE.
        IF(ISPIN.LT.3.AND.IUHF.EQ.0)THEN
         FACTOR=2.0
        ELSE
         FACTOR=1.0
        ENDIF
        IF(SINGLE.AND.ISPIN.LT.3)THEN
         IADD=NT(ISPIN) 
         GETT1V=.TRUE.
        ENDIF
        SIZET2=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
        SIZET=SIZET2+IADD
        IOFFT1=IINTFP*SIZET2
        I000=1
        I010=I000+SIZET*IINTFP
        I020=I010+SIZET*IINTFP
        CALL GETLST(ICORE(I000),IGET(NLSTI),1,1,ISPIN+3,70)
        CALL GETALL(ICORE(I010),SIZET,1,63+ISPIN)
        IF(GETT1V)CALL GETLST(ICORE(I010+IOFFT1),1,1,2,9,63+ISPIN)
        CALL VECPRD(ICORE(I000),ICORE(I010),ICORE(I000),SIZET)
        DO 202 ICOL=1,RSIZE  
         IOFF=INDX(IROW,ICOL)
         NLSTJ=1+ICOL
         NLSTJP1=NLSTJ-1
         CALL GETLST(ICORE(I010),IGET(NLSTJ),1,1,ISPIN+3,70)
         R(IOFF)=R(IOFF)+FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
         CALL GETLST(ICORE(I010),IGET(NLSTJP1),1,1,ISPIN,70)
         R(IOFF)=R(IOFF)-FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
202     CONTINUE
201    CONTINUE
       DO 203 ICOL=1,RSIZE
        IOFF=INDX(IROW,ICOL)
        R(IOFF)=R(IOFF)+ECORR(RLECYC-IROW,2)
203    CONTINUE
      ELSEIF(I.EQ.0.AND.J.NE.0)THEN
       ICOL=J
       NLSTJ=1+ICOL
       DO 300 IROW=1,RSIZE
        R(INDX(IROW,ICOL))=0.0
300    CONTINUE
       DO 301 ISPIN=3,1,IUHF-2
        IADD=0
        GETT1V=.FALSE.
        IF(ISPIN.LT.3.AND.IUHF.EQ.0)THEN
         FACTOR=2.0
        ELSE
         FACTOR=1.0
        ENDIF
        IF(SINGLE.AND.ISPIN.LT.3)THEN
         IADD=NT(ISPIN) 
         GETT1V=.TRUE.
        ENDIF
        SIZET2=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
        SIZET=SIZET2+IADD
        IOFFT1=IINTFP*SIZET2
        I000=1
        I010=I000+SIZET*IINTFP
        I020=I010+SIZET*IINTFP
        CALL GETLST(ICORE(I010),IGET(NLSTJ),1,1,ISPIN+3,70)
        CALL GETLST(ICORE(I000),IGET(NLSTJ-1),1,1,ISPIN,70)
        CALL SAXPY(SIZET,ONEM,ICORE(I000),1,ICORE(I010),1)
        CALL GETALL(ICORE(I000),SIZET,1,63+ISPIN)
        IF(GETT1V)CALL GETLST(ICORE(I000+IOFFT1),1,1,2,9,63+ISPIN)
        CALL VECPRD(ICORE(I010),ICORE(I000),ICORE(I010),SIZET)
        DO 302 IROW=1,RSIZE
         NLSTI=1+IROW
         CALL GETLST(ICORE(I000),IGET(NLSTI),1,1,ISPIN+3,70)
         IOFF=INDX(IROW,ICOL)
         R(IOFF)=R(IOFF)+FACTOR*SDOT(SIZET,ICORE(I000),1,ICORE(I010),1)
302     CONTINUE
301    CONTINUE
       DO 303 IROW=1,RSIZE
        IOFF=INDX(IROW,ICOL)
cYAU - inlining the offset crashes the Sun Forte 6 optimizer
        IOFF2=RLECYC-IROW
        R(IOFF)=R(IOFF)+ECORR(IOFF2,2)
303    CONTINUE
      ELSE
       RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE SYMTRA(IRREP,NUM1,NUM2,DISSIZE,A,B)
C
C  THIS ROUTINE TRANSPOSES THE LAST TWO INDICES OF A GIVEN MATRIX A
C
C    A(I,J,K,L) --> B(I,J,L,K)
C
C  NOTE THAT THIS IS NOT CARRIED OUT IN PLACE ( SEE THEREFORE SYMTR1)
C
C     INPUT : IRREP ....... IRREP OF THE GIVEN PART OF A
C             NUM1 ........ POPULATION VECTOR OF K
C             NUM2 ........ POPULATION VECTOR OF L
C             DISSIZE ..... DISTRIBUTION SIZE OF A
C             A       ..... INPUT MATRIX
C
C     OUTPUT : B .......... TRANSPOSED INPUT MATRIX A
C
CEND
C
C CODED JULY/90   JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DISSIZE,DIRPRD
      DIMENSION A(DISSIZE,1),B(DISSIZE,1),NUM1(8),NUM2(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      DIMENSION IPI(8),IPJ(8)
C
      IPI(1)=0
      IPJ(1)=0          
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IPJ(IRREPJ+1)=IPJ(IRREPJ)+NUM2(IRREPJ)*NUM1(IRREPI)
       IPI(IRREPJ+1)=IPI(IRREPJ)+NUM1(IRREPJ)*NUM2(IRREPI)
10    CONTINUE
       
C
      DO 20  IRREPJ=1,NIRREP
       NUMJ=NUM2(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUM1(IRREPI)
        DO 15 J=1,NUMJ
        DO 15 I=1,NUMI
         IND1=IPJ(IRREPJ)+(J-1)*NUMI+I
         IND2=IPI(IRREPI)+(I-1)*NUMJ+J
         DO 11 L=1,DISSIZE
          B(L,IND2)=A(L,IND1)
11       CONTINUE
15      CONTINUE
20     CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c
c      program main
c      implicit none
c      integer iErr
c      open(unit=13,file='CHSSI.MOL',form='formatted',status='unknown')
c      close(13,status='delete')
c      call segment_mol('MOL','CHSSI.MOL',12,13,iErr)
c      if (iErr.ne.0) stop 'Failed to segment MOL file.'
c      print '(a)', 'Successfully created CHSSI.MOL'
c      end

c ----------------------------------------------------------------------

c This routine reads a MOL file and segments the basis into (mostly)
c disjoint subshells.

c INPUT:
c char*(*) szOldMOL : file name in MOL format to convert
c char*(*) szNewMOL : file name in MOL format to create
c int      iUOld    : unit number to use for old file
c int      iUNew    : unit number to use for new file
c int      iErr     : return code (success==0, failure!=0)

      subroutine segment_mol(szOldMOL,szNewMOL,iUOld,iUNew,iErr)
      implicit none

c   o ARGUMENTS
      character*(*) szOldMOL, szNewMOL
      integer iUOld, iUNew, iErr

c   o PARAMETERS
      integer maxLines, maxAngMom
      parameter (maxLines=10000, maxAngMom=8)
      integer maxPpB, maxCpB
      parameter (maxPpB=500, maxCpB=500)

c   o VARIABLES
      double precision dTmp, dCharge
      double precision dPrim(maxPpB), dCoef(maxPpB,maxCpB)
      integer iAtom, iLine, iOldLine, iNewLine
      integer iAngMom, nAMShells
      integer nOldBpAM(1+maxAngMom), iOldBlock, nOldBlocks, nBlocksLeft
      integer nNewBpAM(1+maxAngMom), iNewBlock, nNewBlocks
      integer iPrim, nOldPrims, nNewPrims
      integer iCont, nOldConts, nNewConts
      integer iStart(maxCpB), iEnd(maxCpB), iStartPrv, iEndPrv
      integer nSubShells, SubShellPtr(maxCpB)
      integer i, j, iOff, iReg0, iReg1, iReg2, iReg3
      character*80 szOldBuf(maxLines), szNewBuf(maxLines)
      character*80 szError, szLine
      logical bExist

c ----------------------------------------------------------------------

c   o open the files or return
      iErr = 0
c      inquire(file=szNewMOL,exist=bExist)
c      if (bExist) return
      szError = '@SEGMENT_MOL: Error opening '//szOldMOL
      open(unit=iUOld,file=szOldMOL,form='formatted',status='old',
     &     err=666,iostat=iErr)
      szError = '@SEGMENT_MOL: Error opening '//szNewMOL
      open(unit=iUNew,file=szNewMOL,form='formatted',
     &     err=666,iostat=iErr)

c ----------------------------------------------------------------------

c   o create the 5-line header
      szError = '@SEGMENT_MOL: Error copying header'
      do i = 1, 5
         read( iUOld,'(a)',err=666,iostat=iErr) szLine
         write(iUNew,'(a)',err=666,iostat=iErr) szLine
      end do

c   o loop over (symmetry unique) atoms
      szError = '@SEGMENT_MOL: Error reading new atom data'
      read(iUOld,'(a)',err=666,iostat=iErr) szOldBuf(1)
      iAtom = 0
      do while (szOldBuf(1)(1:6).ne.'FINISH')
         iAtom = iAtom + 1

c      o flush the file buffers
         iNewLine = 0
         szNewBuf(1) = ' '
         do iLine = 2, maxLines
            szOldBuf(iLine) = ' '
            szNewBuf(iLine) = ' '
         end do

c ----------------------------------------------------------------------

c   o read the block statistics from line 1
      read(szOldBuf(1),'(6x,f14.8,i5,10i5)')
     &    dCharge, iReg0, nAMShells
      if (nAMShells.gt.1+maxAngMom) then
         szError = '@SEGMENT_MOL: Angular momentum limit exceeded.'
         iErr = 1
         goto 666
      end if
      read(szOldBuf(1),'(6x,f14.8,i5,10i5)')
     &    dTmp, iReg0, iReg1, (nOldBpAM(i),i=1,nAMShells)

c   o count the old blocks and reset the new blocks
      nOldBlocks = 0
      do i = 1, nAMShells
         nOldBlocks  = nOldBlocks + nOldBpAM(i)
         nNewBpAM(i) = 0
      end do

c   o read the symbol, orbit index, and XYZ coordinates
      szError = '@SEGMENT_MOL: Error reading XYZ coordinates'
      read(iUOld,'(a)',err=666,iostat=iErr) szOldBuf(2)

c   o read in all of the shell blocks
      iOldBlock = 0
      iOldLine  = 2
      do while (iOldBlock.lt.nOldBlocks)
         iOldBlock = iOldBlock + 1

c      o read the number of primitives and contractions
         szError = '@SEGMENT_MOL: Error reading block header'
         iOldLine = iOldLine + 1
         read(iUOld,'(a)',err=666,iostat=iErr) szOldBuf(iOldLine)

c----------------------------------------------------------------------------
c   Change any null chars to blanks.
c----------------------------------------------------------------------------

         do i = 1, len(szOldBuf(iOldLine))
            if (szOldBuf(iOldLine)(i:i) .eq. char(0)) 
     *           szOldBuf(iOldLine)(i:i) = ' '
         enddo

         read(szOldBuf(iOldLine),'(2i5)') nOldPrims, nOldConts
         if (nOldPrims.gt.maxPpB.or.nOldConts.gt.maxCpB) then
            szError = '@SEGMENT_MOL: number of functions exceeded'
            iErr = 1
            goto 666
         end if

c      o load this block
         szError = '@SEGMENT_MOL: Error reading block data'
         do iPrim = 1, nOldPrims
            iOldLine = iOldLine + 1
            read(iUOld,'(a)',err=666,iostat=iErr) szOldBuf(iOldLine)
            do iCont = 4, nOldConts, 4
               iOldLine = iOldLine + 1
               read(iUOld,'(a)',err=666,iostat=iErr) szOldBuf(iOldLine)
            end do
         end do

c     end do (read old blocks)
      end do

c ----------------------------------------------------------------------

c   o write new block data into szNewBuf
      iAngMom = 0
      nBlocksLeft = nOldBpAM(1)
      iOldBlock = 0
      iOldLine  = 2
      do while (iOldBlock.lt.nOldBlocks)
         iOldBlock = iOldBlock + 1

c      o reset the primitive start and end indices for each contraction
         do i = 1, nOldConts
            iStart(i) = 0
            iEnd(i)   = 0
         end do

         iOldLine = iOldLine + 1
         read(szOldBuf(iOldLine),'(2i5)') nOldPrims, nOldConts
         do iPrim = 1, nOldPrims

c         o read the vector of exponents and array of coefficients
            iOldLine = iOldLine + 1
            read(szOldBuf(iOldLine),'(4f18.9)')
     &          dPrim(iPrim),(dCoef(iPrim,i),i=1,min(3,nOldConts))
            iCont = 4
            do while (iCont.le.nOldConts)
               iOldLine = iOldLine + 1
               read(szOldBuf(iOldLine),'(4f18.9)')
     &             (dCoef(iPrim,i),i=iCont,min(iCont+3,nOldConts))
               iCont = iCont + 4
            end do

c         o scan the coefficients and mark the primitives that each uses
            do iCont = 1, nOldConts
               if (dCoef(iPrim,iCont).ne.0.d0) then
                  if (iStart(iCont).eq.0) iStart(iCont) = iPrim
                  iEnd(iCont) = iPrim
               end if
            end do

         end do

c      o determine the number of new blocks coming from this old block
         nNewBlocks = 0
         iStartPrv  = 0
         iEndPrv    = 0
         do iCont = 1, nOldConts
            if (iStart(iCont).ne.iStartPrv.and.
     &          iEnd(iCont).ne.iEndPrv) then
               nNewBlocks = nNewBlocks + 1
               SubShellPtr(nNewBlocks) = iCont
               iStartPrv = iStart(iCont)
               iEndPrv   = iEnd(iCont)
            end if
         end do

c      o write the set of new blocks to the new file buffer
         do iNewBlock = 1, nNewBlocks
            nNewPrims = 1 + iEnd(SubShellPtr(iNewBlock))
     &                    - iStart(SubShellPtr(iNewBlock))
            if (iNewBlock.lt.nNewBlocks) then
               nNewConts =   SubShellPtr(iNewBlock+1)
     &                     - SubShellPtr(iNewBlock)
            else
               nNewConts = 1+nOldConts-SubShellPtr(iNewBlock)
            end if
c         o block header
            iNewLine = iNewLine + 1
            write(szNewBuf(iNewLine),'(2i5)') nNewPrims, nNewConts
            do iPrim = iStart(SubShellPtr(iNewBlock)),
     &                 iEnd(SubShellPtr(iNewBlock))
c            o exponent line
               iNewLine = iNewLine + 1
               write(szNewBuf(iNewLine),'(4f18.9)')
     &              dPrim(iPrim),
     &              (dCoef(iPrim,SubShellPtr(iNewBlock)+i),
     &               i=0,min(2,nNewConts-1))
c            o additional coefficient lines
               iOff = 3
               do while (iOff.lt.nNewConts)
                  iNewLine = iNewLine + 1
                  write(szNewBuf(iNewLine),'(4f18.9)')
     &                 (dCoef(iPrim,SubShellPtr(iNewBlock)+iOff+i),
     &                  i=0,min(3,nNewConts-1-iOff))
                  iOff = iOff + 4
               end do
            end do
c        end do iNewBlock = 1, nNewBlocks
         end do

c      o increment the angular momentum
         nNewBpAM(1+iAngMom) = nNewBpAM(1+iAngMom) + nNewBlocks
         nBlocksLeft = nBlocksLeft - 1
         if (nBlocksLeft.eq.0.and.iAngMom.lt.nAMShells) then
            iAngMom = iAngMom + 1
            nBlocksLeft = nOldBpAM(1+iAngMom)
         end if

c     end do (process old blocks)
      end do
c ----------------------------------------------------------------------

c      o write the new file buffer to the new file
         read(szOldBuf(1),'(6x,f14.8,i5,10i5)') dCharge, iReg0, iReg1
         szError = '@SEGMENT_MOL: Error writing new atom data'
         write(iUNew,'(6x,f14.8,i5,10i5)',err=666,iostat=iErr)
     &        dCharge, iReg0, iReg1, (nNewBpAM(i),i=1,nAMShells)
         write(iUNew,'(a)',err=666,iostat=iErr) szOldBuf(2)
         szError = '@SEGMENT_MOL: Error writing new basis set data'
         do iLine = 1, iNewLine
            write(iUNew,'(a)',err=666,iostat=iErr) szNewBuf(iLine)
         end do

c      o read the next basis set statistics line from the old file
         szError = '@SEGMENT_MOL: Error reading next atom data'
         read(iUOld,'(a)',err=666,iostat=iErr) szOldBuf(1)
c     end do while (szOldBuf(1)(1:6).ne.'FINISH')
      end do

c   o mark the end of the file
      szError = '@SEGMENT_MOL: Error finalizing new MOL file'
      write(iUNew,'(a)',err=666,iostat=iErr) 'FINISH'

      close(iUOld)
      close(iUNew)
      return
 666  print '(a)', szError
      return
c     end subroutine segment_mol
      end

c this procedure checks consistency of bw input and prepares
c renumbering vectors between MO numbers and separate numbering of
c particle and hole orbitals

      subroutine bwprep(nocc,nvrt,iuhf)
      integer iflags,n0,norb,nocc,nvrt,n,iocc1,i,j,k,ir,jr
      dimension nocc(2),nvrt(2),norb(2)
      common /syminf/ nstart,nirrep,irrepy(255,2),dirprd(8,8)
      common /flags/ IFLAGS(100)
      logical bIAmOne
#include "bwcc.com"

      bIAmOne = .true.

c called after crapsi in order to check bwcc input

      norb(1) = nocc(1)+nvrt(1)
      norb(2) = nocc(2)+nvrt(2)

c check if we are in C1 symmetry
      if (nirrep.gt.1) then
         write(6,*) 'MR-BWCC implemented only for C1 symmetry'
         call aces_exit(1)
      end if

c check array dimension
      if (norb(1).gt.maxorb.or.norb(2).gt.maxorb) then
         write(6,*) 'Too many orbitals, increase MAXORB parameter'
         call aces_exit(1)
      end if

c generate occupation of scf reference if necessary
      if (.not.scfrefread) then
         do iu = 1, 2
            do i = 1, norb(iu)
               iocc0(i,iu) = 0
            end do
         end do
         do iu = 1, 2
            do i = 1, nocc(iu)
               iocc0(i,iu) = 1
            end do
         end do
      end if

c check number of alpha and beta electrons
c here do both spins even for RHF
      do iu = 1, 2
         do j = 1, nref
            n  = 0
            n0 = 0
            do i = 1, norb(iu)
               n  = n  + iocc(i,j,iu)
               n0 = n0 + iocc0(i,iu)
            end do
            if (n.ne.nocc(iu) .or. n0.ne.nocc(iu)) then
               write(6,*)
     &            'inconsistent number of electrons in bwcc input'
               call aces_exit(1)
            end if
         end do
      end do

      do iu = 1, 1+iuhf
c prepare boolean switch isactive
c orbital is active, if there exists at least one pair of reference
c configurations having different occupation of that orbital
         do i = 1, norb(iu)
            isactive(i,iu) = .false.
            iocc1 = iocc(i,1,iu)
            do j = 2, nref
               if (iocc(i,j,iu).ne.iocc1) then
                  isactive(i,iu) = .true.
                  goto 10
               end if
            end do
10          continue
c ISACTIVE MUST be defined for beta orbitals even in the RHF case
c in order to use common rhf/uhf code
            if (iuhf.eq.0) isactive(i,2) = isactive(i,1)
         end do
c prepare nactive, numactive - count and indices of active orbitals
         nactive(iu) = 0
         do i = 1, norb(iu)
            if (isactive(i,iu)) then
               nactive(iu) = nactive(iu)+1
               numactive(nactive(iu),iu) = i
            end if
         end do
      end do

c for RHF copy the beta spin  values
      if (iuhf.eq.0) then
         nactive(2) = nactive(1)
         do i = 1, nactive(1)
            numactive(i,2) = numactive(i,1)
         end do
      end if

c prepare renumbering vectors for later use
      do iu = 1, 1+iuhf
         do j = 1, nref
            ip = 0
            ih = 0
            do i = 1, norb(iu)
               if (iocc(i,j,iu).gt.0) then
                  ih = ih+1
                  iphnum(i,j,iu) = ih
                  invhnum(ih,j,iu) = i
               else
                  ip = ip+1
                  iphnum(i,j,iu) = ip
                  invpnum(ip,j,iu) = i
               end if
               if (iuhf.eq.0) then
                  iphnum(i,j,2)   = iphnum(i,j,1)
                  invhnum(ih,j,2) = invhnum(ih,j,1)
                  invpnum(ip,j,2) = invpnum(ip,j,1)
               end if
            end do
         end do
      end do

c compute mutual excitation level of reference configurations
c and the indices of corresponding internal amplitudes
c zero out effective hamiltonian, so that in the unset elements
c no garbage remains
      do ir = 1, nref
         do jr = 1, nref
            heff(jr,ir) = 0.0
            call calcexcit(ihefferank(jr,ir),iheffefrom(1,jr,ir),
     &                     iheffeto(1,jr,ir),iheffespin(1,jr,ir),
     &                     jr,ir,norb)
c check for identical references!
            if (ir.ne.jr .and. ihefferank(jr,ir).eq.0 ) then
               if (bIAmOne) then
                  write(6,*) '@BWPREP: references no.',ir,jr,
     &                       'are identical!'
               end if
               write(*,*) 'identical references found!'
               call aces_exit(1)
            end if
         end do
      end do

c print out and make a warning if some Heff element will be neglected
      if (bIAmOne) then
         write(6,*)
         write(6,*) 'Excitations between reference configurations'
         write(6,*)
         do ir = 1, nref
            write(6,'(32i2)') (ihefferank(ir,jr),jr=1,nref)
         end do
         write(6,*)
         if (iflags(1).ge.10. or. bwgossip) then
c write out detailed summary
            do ir = 1, nref
            do jr = 1, nref
               write(6,*) 'Heff (',ir,',',jr,'): erank: ',
     &                    ihefferank(ir,jr)
               do i = 1, ihefferank(ir,jr)
                  write(6,*) 'spin ',iheffespin(i,ir,jr),' from ',
     &                       invhnum(iheffefrom(i,ir,jr),jr,
     &                               iheffespin(i,ir,jr)),' to ',
     &                       invpnum(iheffeto(i,ir,jr),jr,
     &                               iheffespin(i,ir,jr))
               end do
               write(6,*)
            end do
            end do
            write(6,*)
            write(6,*)
         end if
      end if

c make check and warning
      do ir = 1, nref
      do jr = 1, nref
         if (ihefferank(jr,ir).gt.2) then
            bwwarning(1) = .true.
cYAU          bwwarntext(1)='@BWPREP-W: There are references mutually more'
cYAU     &       //' than biexcited, some Heff elements will be neglected!'
cYAU          if(bIAmOne)write(6,*) bwwarntext(1)
            if (bIAmOne) then
               write(6,*) '@BWPREP: There are references mutually more',
     &                    ' than biexcited,'
               write(6,*) '           some Heff elements will be',
     &                    ' neglected!'
               write(6,*)
            end if
            goto 123
         end if
      end do
      end do
123   continue

c useeq429=.true. - version to be identically compared to masik's' program
c default should be false ... general implem. of eq.4.28 from Hubac's review
c this is obsolete, this whole switching may be deleted from future version
      useeq429 = .false.

      return
      end

      SUBROUTINE SYMEXP2(IRREP,NUM,DSZ1,DSZ,DIS,A1,A)
C
C     THIS ROUTINE EXPANDS THE A COMPRESSED ARRAY A(AB,IJ) WITH
C     A < B TO AN ARRAY A(AB,IJ) WITH A,B. NOTE THAT THIS ROUTINE
C     EXPECTS THAT THE ARRAY A IS SYMMETRY PACKED
C
C  USAGE :
C
C          IRREP ....... IRREDUCIBLE REPRESENTATION OF THE BLOCKS
C          NUM ......... POPULATION IN EACH IRREP FOR THE ORBITALS
C                        (EITHER VIRTUAL OR OCCUPIED IN DEPENDENCE
C                        IF A VIRTUAL-VIRTULA OR OCCUPIED-OCCUPIED      
C                        BLOCK MUST BE EXTENDED
C          DSZ1 ........ DISTRIBUTION SIZE OF EXPANDED ARRAY
C          DSZ ......... DISTRIBUTION SIZE OF OLD ARRAY
C          DIS ......... NUMBER OF DISTRIBUTIONS IN A AND A1
C          A1 .......... EXPANDED ARRAY (OUTPUT)
C          A ........... OLD ARRAY (INPUT)
C
C NOTE THAT THIS IS A IN PLACE EXPANSION, HOWEVER THE SAME ADDRESS
C HAS TO BE PASSED TWO TIMES TO THIS ROUTINE ( AS A1 AND A) IN ORDER
C TO DEAL WITH THE DIFFREENT DIMENSIONS OF THE INPUT AND OUTPUT ARRAY
C
CEND
C
C  CODED JG JUNE/90
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIS,DIRPRD,DSZ1,DSZ
      DIMENSION A(DSZ,DIS),A1(DSZ1,DIS),NUM(8)
      DIMENSION IPOLD(8),IPNEW(8)
C
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
C
      IND(J,I)=((J-1)*(J-2))/2+I
C 
      DATA ZERO /0.0D0/
C
C    COPY FIRST A TO A1
C
      DO 1000 L=DIS,1,-1
      DO 1000 I=DSZ,1,-1
       A1(I,L) = A(I,L) 
1000  CONTINUE
C
C     TAKE HERE CARE, IF WE ARE HANDLING IRREP=1 (TOTAL SYMMETRIC)
C     OR IRREP=1 (OTHERWISE)
C
      IF(IRREP.EQ.1) THEN
C
C     GET FIRST POINTERS FOR OLD AND NEW INDICES
C
       IPOLD(1)=0
       IPNEW(1)=0
       DO 10 IRREPJ=1,(NIRREP-1)
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)+(NUM(IRREPJ)*(NUM(IRREPJ)-1))/2
        IPNEW(IRREPJ+1)=IPNEW(IRREPJ)+NUM(IRREPJ)**2
10     CONTINUE
C
C     NOW LOOP BACKWARDS FROM THE HIGHEST TO THE LOWEST IRREP
C
       DO 1 IRREPJ=NIRREP,1,-1
        NUMJ=NUM(IRREPJ)
        IPO=IPOLD(IRREPJ)
        IPN=IPNEW(IRREPJ)
C
C     LOOP OVER ORBITALS, BUT ALSO IN BACKWARD ORDER
C
        DO 100 J=NUMJ,2,-1
         DO 100 I=J-1,1,-1
          IND1=IND(J,I)+IPO
          IND2=(J-1)*NUMJ+I+IPN
          DO 101 L=1,DIS
          A1(IND2,L)=A1(IND1,L)
101       CONTINUE
100     CONTINUE
C
C    FILL NOW DIAGONAL ELEMENTS WITH ZERO
C
       DO 200 I=1,NUMJ
        IND1=(I-1)*NUMJ+I+IPN
        DO 201 L=1,DIS
        A1(IND1,L)=ZERO
201     CONTINUE
200    CONTINUE
C
C     EXPAND NOW THE ARRAY
C
       DO 300 J=2,NUMJ
CDIR$ NOVECTOR
*VOCL LOOP,SCALAR
        DO 300 I=1,J-1
         IND1=(J-1)*NUMJ+I+IPN
         IND2=(I-1)*NUMJ+J+IPN
C
CDIR$ VECTOR
*VOCL LOOP,VECTOR
         DO 301 L=1,DIS
         A1(IND2,L)=-A1(IND1,L)
301      CONTINUE
300    CONTINUE
1      CONTINUE
C
      ELSE
C
C     FILL THE POINTERS OF THE OLD AND NEW ARRAY
C
      IPOLD(1)=0
      IPNEW(1)=0
      DO 1001 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM(IRREPJ)
       NUMI=NUM(IRREPI)
       IPNEW(IRREPJ+1)=IPNEW(IRREPJ)+NUMJ*NUMI
       IF(IRREPI.LT.IRREPJ) THEN
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)+NUMJ*NUMI
       ELSE
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)
       ENDIF
1001  CONTINUE
C
C     NOW COPY OLD ARRAYS TO NEW LOCATION
C
      DO 2000 IRREPJ=NIRREP,1,-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM(IRREPJ)
       NUMI=NUM(IRREPI)
       IF(IRREPJ.GT.IRREPI) THEN
        IPN=IPNEW(IRREPJ)
        IPO=IPOLD(IRREPJ)
        DO  2100 IJ=NUMJ*NUMI,1,-1
         DO 2101 L=1,DIS
         A1(IPN+IJ,L)=A1(IPO+IJ,L)
2101     CONTINUE
2100    CONTINUE
       ELSE
        IPN=IPNEW(IRREPJ)
        IPO=IPNEW(IRREPI)
        DO 2200 J=1,NUMJ
CDIR$ NOVECTOR
*VOCL LOOP,SCALAR
         DO 2200 I=1,NUMI
          IND1=(I-1)*NUMJ+J+IPO
          IND2=(J-1)*NUMI+I+IPN
C
CDIR$ VECTOR
*VOCL LOOP,VECTOR
          DO 2201 L=1,DIS
          A1(IND2,L)=-A1(IND1,L)
2201      CONTINUE
2200    CONTINUE
       ENDIF
2000  CONTINUE
      ENDIF
      RETURN
      END

c This routine reads the command-line arguments and initializes the
c a2proc environment (and any other dependents).

      subroutine a2proc_init(module,args,dimargs)
      implicit none

c ARGUMENT LIST
      integer dimargs
      character*80 module
      character*80 args(*)

c INTERNAL VARIABLES
      logical bExist
      integer i, f_iargc, num_args
      integer iJOBARC
      character*80 szJOBARC

c ----------------------------------------------------------------------

#ifdef _TRACE_A2PROC
      write(*,*) '@A2PROC: Entered file ', __FILE__
#endif

c ----------------------------------------------------------------------

      num_args = f_iargc()
      if (1.gt.num_args) then
         write(*,*) '@INIT_A2PROC: This program requires an argument.\n'
         call aces_exit(1)
      end if

c   o get the module name
      module = ' '
      call f_getarg(1,module)

c   o get additional arguments
      do i = 1, min(dimargs,num_args-1)
         call f_getarg(1+i,args(i))
      end do
      if (num_args-1.gt.dimargs) then
         print *, '@A2PROC_INIT: a2proc can only handle the first ',
     &            dimargs,' arguments'
         print *, '              after the module name'
      else
         dimargs = num_args - 1
      end if

c ----------------------------------------------------------------------

c VERIFY CONSISTENCY

c for most modules, JOBARC must exist
      if (module.eq.'help'.or.module.eq.'-h') return
      if (module.eq.'factor') return
      if (module.eq.'PES_scan') return
      call gfname('JOBARC',szJOBARC,iJOBARC)
      inquire(file=szJOBARC(1:iJOBARC),exist=bExist)
      if (.not.bExist) then
         write(*,*) '@INIT_A2PROC: There is no JOBARC file, which ',
     &              'probably means'
         write(*,*) '              ACES2 has not been run.\n'
         call c_exit(1)
      end if

c ----------------------------------------------------------------------

#ifdef _TRACE_A2PROC
      write(*,*) '@A2PROC: Leaving file ', __FILE__
#endif

      return
      end

      SUBROUTINE AO2MO2(ZAO,ZMO,EVEC,SCR,NBAS,NBAST,ISPIN)
C
C TRANSFORMS A TWO-INDEX QUANTITY (I.E. FOCK MATRIX) FROM THE AO
C  TO THE MO BASIS
C
C INPUT:
C       ZAO  - TWO-INDEX QUANTITY IN AO BASIS (LENGTH: NBAST*NBAST)
C       NBAST- NUMBER OF BASIS FUNCTIONS 
C       NBAS - NUMBER OF BASIS FUNCTIONS AFTER TRANSFORMATION
C       ISPIN- 1 FOR ALPHA, 2 FOR BETA
C
C OUTPUT:
C       ZMO  - TWO-INDEX QUANTITY IN MO BASIS (LENGTH: NBAS*NBAS)
C       
C SCRATCH:
C       EVEC - HOLDS EIGENVECTOR MATRIX (LENGTH: NBAS*NBAST)
C       SCR  - HOLDS INTERMEDIATE QUANTITIES (LENGTH: 2*NBAST*NBAST) 
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*8 LABEL
      DIMENSION EVEC(NBAS*NBAST),ZMO(NBAS*NBAS),ZAO(NBAST*NBAST)
      DIMENSION SCR(2*NBAST*NBAST)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      IF(ISPIN.EQ.1)LABEL='SCFEVECA'
      IF(ISPIN.EQ.2)LABEL='SCFEVECB'
      CALL GETREC(20,'JOBARC',LABEL,IINTFP*NBAS*NBAST,EVEC)
      CALL MXM(ZAO,NBAST,EVEC,NBAST,SCR,NBAS)
      CALL TRANSP(EVEC,SCR(NBAST*NBAST+1),NBAS,NBAST)
      CALL MXM(SCR(NBAST*NBAST+1),NBAS,SCR,NBAST,ZMO,NBAS)
      RETURN
      END

c This routine retrieves a record from the JOBARC file.

c INPUT
c int IFLAG : a behavior flag
c             > 0; extant record is retrieved or process is killed
c             = 0; IRECLEN is modified as output
c                  >=  0; extant record integer-length
c                   = -1; record does not exist
c             < 0; extant record is retrieved or IDEST(1:IRECLEN) is zeroed out
c char*(*) SZARCHIVE : the internal filename of the record archive
c                      NOTE: Currently this is unused because all the archive
c                            statistics relate to JOBARC alone; however, we
c                            could expand the functionality to name any
c                            arbitrary archive.
c char*(*) SZRECNAME : the name of the record to retrieve

c INPUT/OUTPUT
c int IRECLEN : on input,  this is the integer-length of the record to retrieve
c               on output, if IFLAG=0, the int-length of the record is returned

c OUTPUT
c int IDEST : the destination array
c             NOTE: The record length is in units of integers regardless of
c                   the type of data actually stored in the record.

#include "jobarc.h" /* for _JA_RECWD */

      subroutine getrec(iFlag,szArchive,szRecName,iRecLen,iDest)
      implicit none

c ARGUMENTS
      integer iFlag, iRecLen, iDest(*)
      character*(*) szArchive, szRecName

c EXTERNAL FUNCTIONS
      integer iszeq

c INTERNAL VARIABLES
      character*80 szJOBARC
      integer       iJOBARC
      integer iRecNdx
      integer iRec, iBufNdx, iTmp
      integer nLeft, nGet, iOff
      integer iStat, iBuf(_JA_RECWD), i

c COMMON BLOCKS
#include "jobarc.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert job archive subsystem is up
      if (.not.bJAUp) then
         print *, '@GETREC: Assertion failed.'
         print *, '   bJAUp = ',bJAUp
         iTmp = 1
      end if
c   o assert record length is >= 0 if it's supposed to exist
      if ((iFlag.ne.0).and.(iRecLen.lt.0)) then
         print *, '@GETREC: Assertion failed.'
         print *, '   iRecLen = ',iRecLen
         iTmp = 1
      end if
c   o the record name must be between 1 and 8 characters
      if ((len(szRecName).lt.1).or.(len(szRecName).gt.8)) then
         print *, '@GETREC: Assertion failed.'
         print *, '   szRecName = ',szRecName
         iTmp = 1
      end if
c   o the record cannot be named 'OPENSLOT'
      if (len(szRecName).eq.8) then
      if (szRecName.eq.'OPENSLOT') then
         print *, '@GETREC: Assertion failed.'
         print *, '   szRecName = ',szRecName
         iTmp = 1
      end if
      end if
      if (iTmp.ne.0) then
         print *, '   record name = "',szRecName,'"'
         call aces_exit(iTmp)
      end if
#endif /* _ASSERT */

      if ((iFlag.ne.0).and.(iRecLen.lt.0)) return

c ----------------------------------------------------------------------

c   o get the index of the requested record
cYAU - This confused me at first (because I am stupid). Apparently,
c      iszeq declares marker as char*(*) and knows it is an array of
c      strings. Therefore, it steps through marker in 8-Byte increments,
c      which is the string length of one marker element.
      iRecNdx = iszeq(_MAX_JA_RECS,marker,1,szRecName)

c   o the record is not found
      if (iRecNdx.eq.0) then
         if (iFlag.lt.0) then
c         o return zeroes in iDest
            call izero(iDest,iRecLen)
         else
c         o the record has no length
            if (iFlag.ne.0) then
c            o complain and die
               print *, '@GETREC: The record "',szRecName,
     &                  '" is not found.'
               call aces_exit(1)
            end if
            iRecLen = -1
         end if
         return
      end if

c   o the record is found, but the caller doesn't care
      if (iFlag.eq.0) then
         iRecLen = rsize(iRecNdx)
         return
      end if

c   o the record is found, but the caller doesn't know the actual length
      if (iRecLen.ne.rsize(iRecNdx)) then
c      o only bomb for invalid data
         if (iRecLen.gt.rsize(iRecNdx)) then
            print *, '@GETREC: "',szRecName,'" record length mismatch'
            print *, '         requested length = ',iRecLen
            print *, '         stored    length = ',rsize(iRecNdx)
            call aces_exit(1)
         end if
      end if
      if (iRecLen.eq.0) return

c   o find the first physical record and integer index that point to
c     the first element
      iBufNdx = rloc(iRecNdx)
      iTmp    = (iBufNdx-1)/irecwd
      iRec    = 1       + iTmp
      iBufNdx = iBufNdx - iTmp*irecwd

#ifdef OPEN_JOBARC_AS_NEEDED
c   o open the JOBARC file
      call gfname('JOBARC',szJOBARC,iJOBARC)
      open(unit=_JA_UNIT,file=szJOBARC(1:iJOBARC),
     &     form='UNFORMATTED',access='DIRECT',
     &     status='OLD',recl=irecln,err=666,iostat=iStat)
#endif

c   o read/copy the record
      read(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
      if (iRecLen.eq.1) then
         iDest(1) = iBuf(iBufNdx)
      else
         nLeft = iRecLen
         nGet  = min(nLeft,irecwd+1-iBufNdx)
         call icopy(nGet,iBuf(iBufNdx),1,iDest,1)
         iOff  = 1     + nGet
         nLeft = nLeft - nGet
         do while (nLeft.ne.0)
            nGet = min(nLeft,irecwd)
            iRec = iRec + 1
            read(unit=_JA_UNIT,rec=iRec,err=666,iostat=iStat) iBuf
            call icopy(nGet,iBuf,1,iDest(iOff),1)
            iOff  = iOff  + nGet
            nLeft = nLeft - nGet
         end do
      end if

#ifdef OPEN_JOBARC_AS_NEEDED
c   o close the JOBARC file
      close(unit=_JA_UNIT,status='KEEP',err=666,iostat=iStat)
#endif

      return

c   o JOBARC read error
 666  print *, '@GETREC: read error on JOBARC'
      print *, '         record name = "',szRecName,'"'
      print '(/)'
      call aces_io_error('GETREC',_JA_UNIT,iStat)

c     end subroutine getrec
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine blkmgr_init(x, nx, nblocks_total,
     *                       blk_header,
     *                       free_stack,
     *                       blk_addr,
     *                       blk_in_use,
     *                       blksize, stack_blocks,
     *                       nstacks, comm)
c------------------------------------------------------------------------
c   Initialization of block manager subsystem.
c   x         = array to use for block management.
c   nx        = total number of double precision words in x
c   blksize   = array of blocksizes to use in each stack of blocks.
c   stack_blocks = array of blocks used for each stack.
c   nstacks   = number of stacks
c   comm      = company communicator.
c-------------------------------------------------------------------------  

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
      include 'machine_types.h'
      include 'dbugcom.h'
 
      integer nblocks_total
      integer blk_header(nblocks_total,lblk_header)
      integer free_stack(nblocks_total) 
      integer blk_in_use(nblocks_total) 
      integer*8 blk_addr(nblocks_total)

      integer nstacks
      integer i, j, nx, blksize(nstacks), stack_blocks(nstacks)
      double precision x(*)
      integer comm
      integer*8  count_word, nword_stack
      integer*8 c_loc64, ixx
      integer count_block
      integer size, ierr
      integer wsum
      integer*8 indblk
      integer stk_weights(10)
      integer*8 addr
      integer k
      integer iii

      blkmgr_comm   = comm
      blkmgr_next_block = 0
      call mpi_comm_rank(comm, blkmgr_comm_rank, ierr)

      ixx = 1
      addr_blk_header = c_loc64(blk_header, ixx, intsize) 
      addr_free_stack = c_loc64(free_stack, ixx, intsize)
      addr_blk_addr   = c_loc64(blk_addr,   ixx, 8)
      addr_blk_in_use = c_loc64(blk_in_use, ixx, intsize)

c---------------------------------------------------------------------------
c   Set up the stack blocks.
c---------------------------------------------------------------------------

      count_block = 0
      count_word  = 0
      do i = 1, nstacks
         stack_size(i) = stack_blocks(i)
         nblocks_stack(i) = stack_blocks(i)
         count_block = count_block + stack_size(i)
         count_word = count_word + stack_size(i) * 
     *                  (blksize(i) + lblock_id_data)
      enddo
      
c--------------------------------------------------------------------------
c   Inform the user about the actual stack sizes.
c--------------------------------------------------------------------------

      if (dbg) then
         do i = 1, nstacks
            print *,'Task ',blkmgr_comm_rank,' Stack ',i,' contains ',
     *        stack_size(i),' blocks of ',blksize(i)+lblock_id_data,
     *        ' words per block.'
         enddo
      endif

      blkmgr_blocks = count_block
      if (blkmgr_blocks .gt. nblocks_total) then
         print *,'Error: Total number of blocks (',blkmgr_blocks,
     *     ') exceeds the blkmgr limit of ',nblocks_total
         call abort_job()
      endif

      if (count_word .gt. nx) then
         print *,'Error: Total number of words (',count_word,
     *       ') exceeds amount allowed for blkmgr data (',
     *       nx,')'
         call abort_job()
      endif

      do j = 1, lblk_header
      do i = 1, blkmgr_blocks
        call put_blk_header(0, i, j)
      enddo
      enddo

c-----------------------------------------------------------------------
c   Set up the block stacks.
c-----------------------------------------------------------------------

      nblkmgr_stacks = nstacks
      count_block = 1
      count_word  = 1
      
      do i = 1, nblkmgr_stacks
         stack_start(i)     = count_block
         free_stack_ptr(i)  = stack_start(i) - 1
         stack_base_addr(i) = c_loc64(x, count_word, bytes_per_double)
         stack_blocksize(i) = blksize(i) + lblock_id_data
         stack_datasize(i)  = blksize(i)
         
c--------------------------------------------------------------------------
c   Each block is pushed onto a free stack.
c   Also, calculate the block address.
c--------------------------------------------------------------------------

         do j = 1, stack_size(i)
            call push_free_stack(i, count_block) 
            call put_blk_header(i, count_block,c_block_stack)
            addr = c_loc64(x, count_word, bytes_per_double)
            call put_blk_addr(addr, count_block)
            count_block = count_block + 1
            count_word  = count_word + stack_blocksize(i)
         enddo
      enddo

      last_blk_addr = blk_addr(count_block-1)
      first_blk_addr = blk_addr(1)

c--------------------------------------------------------------------------
c   Adjust block and word counters.
c--------------------------------------------------------------------------

      count_block = count_block - 1
      count_word  = count_word - 1
      
      nblk_in_use = 0
      do i = 1, blkmgr_blocks
         blk_in_use(i) = 0
      enddo

      do i = 1, blkmgr_blocks
         call put_blk_header(mpi_request_null, i, c_block_request)
      enddo
 
      comm_list_head = 0
      comm_list_tail = 0
      persistent_list_head = 0
      persistent_list_tail = 0

      blkmgr_init_flag = .true.
C      dbg = .true. 
      if (dbg) then
         print *,'Task ',blkmgr_comm_rank,
     *        ' BLKMGR has been initialized with ',
     *        count_word,' double precision ',
     *        'words, or ',count_block,' blocks.'
         print *,'Task ',blkmgr_comm_rank,
     *     ' stack base_addr: ',(stack_base_addr(i),i=1,nblkmgr_stacks)
      endif
C      dbg = .false. 
      return
      end

      subroutine put_blk_in_use(blkndx)
c----------------------------------------------------------------------------
c   Adds a block to the "blk_in_use" table.
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer blkndx

      integer*8 get_index_from_base, ixx
      integer blk_in_use(1)
#ifdef ALTIX
      pointer (iptr, blk_in_use)
#else
      common blk_in_use
#endif

#ifdef ALTIX 
      iptr = ishptr
#endif

      ixx = get_index_from_base(addr_blk_in_use, blk_in_use, 1)
      if (nblk_in_use .ge. blkmgr_blocks) then
         print *,'Error: Attempting to set too many blocks in use.'
         call abort_job()
      endif

      nblk_in_use = nblk_in_use + 1
      blk_in_use(ixx + nblk_in_use - 1) = blkndx
      return
      end

      subroutine remove_block_from_use(blkndx)
c----------------------------------------------------------------------------
c   Removes an entry from the "blk_in_use" table. 
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer blkndx

      integer i
      integer*8 get_index_from_base, ixx
      integer blk_in_use(1)
#ifdef ALTIX
      pointer (iptr, blk_in_use)
#else 
      common blk_in_use
#endif
      
#ifdef ALTIX
      iptr = ishptr
#endif
      ixx = get_index_from_base(addr_blk_in_use, blk_in_use, 1)
      do i = 1, nblk_in_use
         if (blk_in_use(ixx+i-1) .eq. blkndx) then
            
c--------------------------------------------------------------------------
c   Remove entry by swapping entry "nblk_in_use" over it.
c--------------------------------------------------------------------------

            blk_in_use(ixx+i-1) = blk_in_use(ixx+nblk_in_use-1)
            nblk_in_use = nblk_in_use - 1
            return
         endif
      enddo

      print *,'Error: Attempted to remove ',blkndx,' from use, ',
     *          'but it was not registered as in use already.'
      call abort_job()
      return
      end

      subroutine put_blk_header(data, blkndx, col)
c----------------------------------------------------------------------------
c   Stores a word in the blk_header table at row "blkndx", cloumn "col".
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer data, blkndx, col

      integer*8 get_index_from_base, ixx
      integer blk_header(1)
#ifdef ALTIX
      pointer (iptr, blk_header)
#else
      common blk_header
#endif

#ifdef ALTIX
      iptr = ishptr  
#endif
      ixx = get_index_from_base(addr_blk_header, blk_header, 1)
      blk_header(ixx + (col-1)* blkmgr_blocks + blkndx - 1) = data 
      return
      end

      subroutine get_blk_header(data, blkndx, col)
c----------------------------------------------------------------------------
c   Retrieves a word in the blk_header table from row "blkndx", column "col".
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer data, blkndx, col

      integer*8 get_index_from_base, ixx
      integer blk_header(1)
#ifdef ALTIX
      pointer (iptr, blk_header) 
#else
      common blk_header
#endif

#ifdef ALTIX
      iptr = ishptr
#endif

      ixx = get_index_from_base(addr_blk_header, blk_header, 1)
      data = blk_header(ixx + (col-1)* blkmgr_blocks + blkndx - 1)
      return
      end

      subroutine put_free_stack(data, blkndx)
c----------------------------------------------------------------------------
c   Stores a word in the free_stack table at row "blkndx".
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer data, blkndx

      integer*8 get_index_from_base, ixx
      integer free_stack(1)
#ifdef ALTIX
      pointer (iptr, free_stack)
#else
      common free_stack
#endif
 
#ifdef ALTIX
      iptr = ishptr
#endif
      if (data .eq. 0) print *,'Task ',me,' put_free_stack: put data ',
     *     data,' into blkndx ',blkndx
      ixx = get_index_from_base(addr_free_stack, free_stack, 1)
      free_stack(ixx + blkndx - 1) = data 

      return
      end

      subroutine get_free_stack(data, blkndx)
c----------------------------------------------------------------------------
c   Retrieves a word from the free_stack table from row "blkndx".
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer data, blkndx

      integer*8 get_index_from_base, ixx
      integer free_stack(1)
#ifdef ALTIX
      pointer (iptr, free_stack)
#else
      common free_stack
#endif

#ifdef ALTIX
      iptr = ishptr
#endif  
      ixx = get_index_from_base(addr_free_stack, free_stack, 1)
      data = free_stack(ixx + blkndx - 1)
      return
      end

      subroutine put_blk_addr(data, blkndx)
c----------------------------------------------------------------------------
c   Stores a word in the blk_addr table at row "blkndx".
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer*8 data
      integer blkndx
 
      integer*8 get_index_from_base, ixx
      integer*8 blk_addr(1)
#ifdef ALTIX
      pointer (i8ptr, blk_addr) 
#else
      common blk_addr
#endif
 
#ifdef ALTIX
      i8ptr = i8shptr
#endif
      ixx = get_index_from_base(addr_blk_addr, blk_addr, 3)
      blk_addr(ixx + blkndx - 1) = data 
      return
      end

      subroutine get_blk_addr(data, blkndx)
c----------------------------------------------------------------------------
c   Retrieves a word from the blk_addr table from row "blkndx".
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer*8 data
      integer blkndx

      integer i, j
      integer*8 get_index_from_base, ixx
      integer*8 blk_addr(1)
#ifdef ALTIX
      pointer (i8ptr, blk_addr)
#else
      common blk_addr
#endif

#ifdef ALTIX
      i8ptr = i8shptr
#endif
      ixx = get_index_from_base(addr_blk_addr, blk_addr, 3)
      data = blk_addr(ixx + blkndx - 1)

c      if (data .lt. first_blk_addr .or.
c     *    data .gt. last_blk_addr) then
c          print *,'Task ',me,' GET_BLK_ADDR: invalid address'
c          print *,'addr for block ',blkndx,' is ',data
c          print *,'first_blk_addr ',first_blk_addr,
c     *            ' last_blk_addr ',last_blk_addr
c          do i = 1, blkmgr_blocks
c             print *,'address for block ',i,' is ',blk_addr(ixx+i-1)
c          enddo
c          call abort_job()
c      endif   

      return
      end

      block data blkmgr_data
c--------------------------------------------------------------------------
c   Block data subprogram to initialize the "blkmgr_init_flag" variable.
c--------------------------------------------------------------------------
      include 'maxdim.h'
      include 'blkmgr.h'
      data blkmgr_init_flag/.false./
      end

      subroutine set_block_id(array, array_block, stack, block)
c-------------------------------------------------------------------------
c   Encodes the array descriptor and array_block identifier into the
c   block_id_data portion of a block in stack "stack".
c-------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'machine_types.h'
       include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer array, array_block, stack, block
 
      integer ix(2)
#ifdef ALTIX
      pointer (iptr, ix)
#else
      common ix
#endif

      integer*8 ixblk, c_loc64, ixx
      integer*8 get_index_from_base
      integer*8 addr

#ifdef ALTIX
      iptr = ishptr
#endif

c--------------------------------------------------------------------------
c   Find the integer index of ix relative to x(indblk).
c   This enables us to reference the data as integer.
c--------------------------------------------------------------------------

      call get_blk_addr(addr, block)
      ixblk = get_index_from_base(addr, ix, 1)

c---------------------------------------------------------------------------
c   Encode the integer data into the block.
c---------------------------------------------------------------------------

      ix(ixblk) = array
      ix(ixblk+1) = array_block

      return
      end

      integer function get_block_array_handle(blkndx)
c-------------------------------------------------------------------------
c   Returns the array handle corresponding to blk number "blkndx".
c-------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
 
      integer blkndx
      integer data

      call get_blk_header(data, blkndx,c_array_handle)
      get_block_array_handle = data
      return
      end

      subroutine get_block_id(stack, block, array, array_block)
c-------------------------------------------------------------------------
c   Returns the array descriptor and array_block identifier from the
c   block_id_data portion of a block in stack "stack".
c-------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
      integer array, array_block, stack, block
 
      integer ix(2)
#ifdef ALTIX
      pointer (iptr, ix)
#else
      common ix
#endif
      integer i   
      integer*8 ixblk
      integer*8 c_loc64, ixx
      integer*8 get_index_from_base
      integer*8 addr
      integer size

#ifdef ALTIX
      iptr = ishptr
#endif

       call get_blk_addr(addr, block)
       ixblk = get_index_from_base(addr, ix, 1)

c---------------------------------------------------------------------------
c   Return the integer data of the block.
c---------------------------------------------------------------------------

      array = ix(ixblk)
      array_block = ix(ixblk+1)
      return
      end

      subroutine validate_block(data, array, block, flag)
c--------------------------------------------------------------------------
c   Checks the block_id_data portion of the block against the expected 
c   array and block info.  If it matches, the subroutine returns, else  
c   the job is terminated (if the abort flag is set).
c--------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'machine_types.h'

      integer data(*)
      integer array, block
      integer*8 ixx, c_loc64
      logical flag
 
      if (data(1) .ne. array .or.
     *    data(2) .ne. block) then
         print *,'Task ',me,' ERROR: Invalid data in block, line ',
     *                   current_line
         print *,'       Expected array ',array,' block ',block
         print *,'       Data had array id ',data(1),' block id ',
     *                   data(2)
         ixx = 1
         print *,'       Data address of block ',
     *        c_loc64(data, ixx, intsize)
         if (flag) then
            call dump_block_ids()
            call abort_job()
         endif
      endif
      return
      end

      subroutine free_block(array_handle, array_block, blkndx,
     *                 array_table, narray_table, 
     *                 index_table, nindex_table, block_map_table)
c---------------------------------------------------------------------------
c   Marks the block associated with array "array_handle", block "array_block"
c   as free.  
c----------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'

      integer i, flag
      integer array_handle, array_block, stack, blkndx
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer block_map_table(lblock_map_entry, *)
      integer dummy
      integer iseg(mx_array_index)
      integer nind, lookup, block_map_lookup

      call blkmgr_remove_block_from_list(
     *             array_table(c_block_list,array_handle), 
     *              dummy, blkndx, c_block_list_ptr)

      call get_blk_header(flag, blkndx,c_block_flags)
      if (and(flag, block_persistence_flag) .ne. 0) then
         call blkmgr_remove_block_from_list(persistent_list_head,
     *      persistent_list_tail, blkndx, c_persistent_ptr)
      endif

c---------------------------------------------------------------------------
c   If this is a distributed array, its entry must be removed from the
c   block_map_table.
c---------------------------------------------------------------------------

      if (array_table(c_array_type,array_handle) .eq. 
     *                                 distributed_array) then
                                          
         nind = array_table(c_nindex,array_handle)
         do i = 1, nind
            call get_blk_header(iseg(i), blkndx,c_block_segments+i-1)
         enddo
                                                                                
         lookup = block_map_lookup(iseg, nind, array_handle,
     *                          array_table(1,array_handle),
     *                          index_table, nindex_table)
                                                                                
         if (block_map_table(c_bmap_blkndx, lookup) .ne. blkndx) then
            print *,'Error: blkndx lookup value is ',
     *         block_map_table(c_bmap_blkndx, lookup),
     *         ' which does not ',
     *         'match blkndx ',blkndx,' for array ',array_handle,
     *         ' block ',array_block,'. Lookup index is ',
     *          lookup
            call array_block_summary(array_table, narray_table)
            call dump_block_ids()
            call abort_job()
         endif

         block_map_table(c_bmap_blkndx, lookup) = 0
      endif

c---------------------------------------------------------------------------
c   Put this block back on its proper free stack.
c--------------------------------------------------------------------------

       call get_blk_header(stack, blkndx,c_block_stack)
       call push_free_stack(stack, blkndx)
       call remove_block_from_use(blkndx)

c---------------------------------------------------------------------------
c   Destroy the block data info.
c---------------------------------------------------------------------------

       do i = 1, lblk_header
          call put_blk_header(0, blkndx,i)
       enddo

       call put_blk_header(MPI_REQUEST_NULL, blkndx,c_block_request)
       call put_blk_header(stack, blkndx,c_block_stack)

      return
      end

      integer*8 function get_block_index(array, block, stack, blkndx,
     *                                   x, data_flag)
c--------------------------------------------------------------------------
c   Returns the index (in double words) of the block id info for block 
c   "block" of
c   array "array".  The index is relative to the argument "x".
c   If the "data_flag" argument is .true., the index of the actual data in 
c   the block is returned, otherwise, the index of the block_id area is 
c   returned.
c
c   If the block is not in the blkmgr table, a negative value is returned.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'machine_types.h'

      integer array, block, stack, blkndx
      logical data_flag

      double precision x(*)
      integer i, j, k, size
      integer*8 block_index, c_loc64, ixx
      integer*8 get_index_from_base
      integer*8 addr
      integer blk_in_use(1)
      integer handle, myblock

      if (blkndx .le. 0) then
         ixx = get_index_from_base(addr_blk_in_use, blk_in_use, 1)

c--------------------------------------------------------------------------
c   Scan all blocks that are registered as "in use".
c--------------------------------------------------------------------------

         do k = 1, nblk_in_use
            j = blk_in_use(ixx+k-1)

            call get_blk_header(handle, j,c_array_handle)
            call get_blk_header(myblock, j,c_array_block)
            if (handle .eq. array .and.
     *          myblock .eq. block) then
               i = j
               go to 100
            endif
         enddo
 
         get_block_index = -1
         return
      else
         i = blkndx
      endif

100   continue
      call get_blk_addr(addr, i)
      block_index = get_index_from_base(addr, x, 2)

      if (data_flag) then
         get_block_index = block_index +lblock_id_data
      else
         get_block_index = block_index
      endif
      
      return
      end 

      integer*8 function get_block_data_index(array, block, stack,
     *                                        blkndx, x)
c--------------------------------------------------------------------------
c   Returns the index (in double words) of the data for block "block" of
c   array "array".  The index is relative to the argument "x".
c
c   If the block is not in the blkmgr table, a negative value is returned.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'

      integer array, block, stack, blkndx
      integer*8 block_index
      double precision x(*)

      integer*8 get_block_index

      block_index = get_block_index(array, block, stack, blkndx, 
     *                              x, .true.)
      if (block_index .ne. -1) then
         get_block_data_index = block_index 
      else
         get_block_data_index = -1
      endif
      return
      end 

      subroutine clear_block(array_handle, array_block, xstack, 
     *                       blkndx, size)
c--------------------------------------------------------------------------
c   Sets the content of a block to 0.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      integer array_handle, array_block, xstack, blkndx, size
      integer j
      integer*8 indblk, get_block_index
      integer stack

#ifdef ALTIX
      dptr = dshptr
#endif
      indblk = get_block_index(array_handle, array_block, stack, blkndx,
     *                         x, .false.)
      if (indblk .eq. -1) then
         print *,'Error: Block not found: array, block = ',
     *        array_handle, array_block
         call abort_job()
      endif

      call validate_block(x(indblk), array_handle, array_block, 
     *                       .true.)
      indblk = indblk + lblock_id_data

      call get_blk_header(stack, blkndx,c_block_stack)
      if (size .gt. stack_blocksize(stack)) then
         print *,'Error: Block size > stack blocksize'
         print *,'array_handle ',array_handle,' blkndx ',blkndx
         print *,'size, stack, stack_blocksize(stack) ',
     *       size, stack, stack_blocksize(stack)
         call dump_block_ids()
         call abort_job()
      endif

      do j = 1, size
         x(indblk+j-1) = 0.
      enddo

      return
      end

      subroutine fill_block(array_handle, array_block, stack,
     *                      blkndx, value)
c--------------------------------------------------------------------------
c   Sets the content of a block to a given value.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      double precision value

      integer array_handle, array_block, stack, blkndx
      integer j, n
      integer*8 indblk, get_block_index
#ifdef ALTIX
      dptr = dshptr
#endif

      indblk = get_block_index(array_handle, array_block, stack, blkndx,
     *                         x, .true.)
      if (indblk .eq. -1) then
         print *,'Error: Block not found: array, block = ',
     *        array_handle, array_block
         call abort_job()
      endif

      call get_blk_header(n, blkndx,c_block_size)
      do j = 1, n
         x(indblk+j-1) = value
      enddo

      return
      end

      subroutine multiply_block(array_handle, array_block, stack,
     *                          blkndx, value,
     *                          result_array, result_block,
     *                          result_stack, result_blkndx, 
     *                          blocksize)
c--------------------------------------------------------------------------
c   Sets the content of a block to 0.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      double precision value

      integer array_handle, array_block, stack, blkndx
      integer result_array, result_block, result_stack, result_blkndx
      integer j
      integer*8 indblk, iresult, get_block_index
      integer blocksize

#ifdef ALTIX
      dptr = dshptr
#endif

      indblk = get_block_index(array_handle, array_block, stack, blkndx, 
     *                         x, .true.)
      if (indblk .eq. -1) then
         print *,'Error: Block not found: array, block = ',
     *        array_handle, array_block
         call abort_job()
      endif

      iresult = get_block_index(result_array, result_block, 
     *                          result_stack, result_blkndx, 
     *                          x, .true.)
      if (indblk .eq. -1) then
         print *,'Error: Block not found: array, block = ',
     *        result_array, result_block
         call abort_job()
      endif

      do j = 1, blocksize
         x(iresult+j-1) = x(indblk+j-1) * value
      enddo

      return
      end

      subroutine dump_block_ids()
c--------------------------------------------------------------------------
c   Dump the current state of the blocks.                       
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer i, j, k, n, ierr
      integer seg(mx_array_index)
      integer*8 indblk, get_block_index
      integer*8 data_addr, block_addr
      integer size
      integer flag, flagval, persistent
      integer data_block, data_array
      integer blkndx, stack
      integer nused(nblkmgr_stacks)
      integer array_data, blk_data, nind, request_data
      double precision x(2)
#ifdef ALTIX
      pointer (dptr, x)

      dptr = dshptr
#endif
 
      print *,'Dump of busy blocks on processor ',me,
     *     ' max_blkmgr_blocks = ',max_blkmgr_blocks

      size = bytes_per_double
      i = 1
      do stack = 1, nblkmgr_stacks
      n = stack_size(stack)
      nused(stack)  = 0 
      do j = 1, n 
         call get_blk_header(flag, i,c_block_flags)
         flagval = and(flag, block_busy_flag)
         persistent = and(flag, block_persistence_flag)
         if (flagval .ne. 0 .or.
     *       persistent .ne. 0) then
            call get_blk_addr(block_addr,i)
            data_addr  = block_addr + lblock_id_data * size
            nused(stack) = nused(stack) + 1
 
            call get_block_id(stack, i,data_array, data_block)

            call get_blk_header(array_data, i,c_array_handle)
            call get_blk_header(blk_data, i,c_array_block)
            call get_block_segments(i, seg)
            call get_blk_header(nind, i, c_block_nindex)
            print *,'Block ',i,' ARRAY ID: ',array_data,
     *             ' BLOCK ID ',blk_data,
     *             ' FLAGS ',flag,
     *             ' SEGS ',(seg(k),k=1,nind),
     *               ' ADDR ',
     *               block_addr,' DADDR ',data_addr,
     *               'DATA ARRAY ',data_array,' DATA BLOCK ',
     *               data_block


            indblk = get_block_index(array_data, blk_data,
     *                               stack, i, x, .false.)
            call validate_block(x(indblk), array_data, blk_data,
     *                          .false.)
         endif

         i = i + 1
      enddo
      enddo

      print *,'Task ',me,' Stack block usage: ',
     *   (nused(i),i=1,nblkmgr_stacks)

      i = 1
      do stack = 1, nblkmgr_stacks
      n = stack_size(stack)
      do j = 1, n
        call get_blk_header(array_data, i,c_array_handle)
        call get_blk_header(blk_data, i,c_array_block) 
        call get_blk_header(flag, i,c_block_flags) 
        call get_blk_header(request_data, i, c_block_request)
        call get_blk_header(size, i,c_block_size)
        call get_blk_header(stack, i,c_block_stack)
        print *,' blkndx ',i,' array,block,flags ',
     *     array_data, blk_data, flag, 
     *     ' request ',request_data,
     *     ' size ', size, 
     *     ' stack ',stack

         i = i + 1
      enddo
      enddo
      return
      end

      subroutine validate_all_blocks()
c--------------------------------------------------------------------------
c   Validates the current state of the blocks.                       
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer i, j, k, n, ierr
      integer*8 indblk, get_block_index
      integer*8 data_addr, block_addr
      integer flag, array_data, blk_data, size
      integer flagval, persistent
      integer data_block, data_array
      integer blkndx, stack
      double precision x(2)
#ifdef ALTIX
      pointer (dptr, x)

      dptr = dshptr
#endif
 
      size = bytes_per_double
      i = 1
      do stack = 1, nblkmgr_stacks
      n = stack_size(stack)
      do j = 1, n 
         call get_blk_header(flag, i,c_block_flags)
         flagval = and(flag,  block_busy_flag)
         persistent = and(flag,
     *                    block_persistence_flag)
         if (flagval .ne. 0 .or.
     *       persistent .ne. 0) then
 
            blkndx = 0
            call get_blk_header(array_data, i,c_array_handle)
            call get_blk_header(blk_data, i,c_array_handle)
            indblk = get_block_index(array_data, blk_data,
     *                               stack, blkndx, x, .false.)
            call validate_block(x(indblk), array_data, blk_data,
     *                          .true.)
         endif

         i = i + 1
      enddo
      enddo

      return
      end

      subroutine dump_block_data(array, block)
c--------------------------------------------------------------------------
c   Dump the current state of the blocks.                       
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer i, j, ierr
      integer*8 indblk, get_block_index
      integer blkndx 
      integer*8 data_addr, block_addr
      integer size
      integer flagval
      integer data_block, data_array
      integer array, block
      integer array_data, blk_data, flag, nind
      integer seg(mx_array_index)
      integer get_block_number
      integer stack
      double precision x(2)
#ifdef ALTIX
      pointer (dptr, x)

      dptr = dshptr
#endif
 
      i = get_block_number(array, block)
      print *,'Task ',me,' DUMP_BLOCK_DATA: array, block, i = ',
     *   array, block, i
      if (i .lt. 0) return

      do j = 1, nblkmgr_stacks
         if (i .ge. stack_start(j) .and.
     *       i .le. stack_start(j)+stack_size(j) - 1) then
            stack = j
            go to 100
         endif
      enddo

      size = bytes_per_double
  100 continue
      call get_blk_addr(block_addr, i)
      data_addr  = block_addr + lblock_id_data * size
 
      call get_block_id(stack, i,data_array, data_block)

      call get_blk_header(array_data, i,c_array_handle)
      call get_blk_header(blk_data, i,c_array_block)
      call get_blk_header(flag, i,c_block_flags)
      call get_block_segments(i, seg)
      call get_blk_header(nind, i,c_block_nindex) 

      print *,'Task ',me,' Block ',i,' ARRAY ID: ',array_data,
     *             ' BLOCK ID ',blk_data,
     *             ' FLAGS ',flag,
     *             ' SEGS ',(seg(j),j=1,nind),
     *             ' ADDR ',  block_addr,' DADDR ',data_addr,
     *               'DATA ARRAY ',data_array,' DATA BLOCK ',
     *               data_block

      blkndx = 0
      indblk = get_block_index(array_data, blk_data,
     *                         stack, blkndx, x, .false.)

      call validate_block(x(indblk), array_data, blk_data,
     *                    .false.)
      return
      end

      integer function find_current_block(x, array_table,
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)
c--------------------------------------------------------------------------
c   Determines whether the block with the current ranges of indices is 
c   present in the set of blocks being managed.  If the block is found,
c   the block index is returned as a negative index.  If the block is 
c   in the array mapping AND also in the table of managed blocks, the 
c   block index is returned.
c
c   x = array handle 
c   array_table = table of arrays entry for array x.
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer x, array_table(larray_table_entry)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer nsegment_table
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer i, j, nindex
      integer index(mx_array_index), seg(mx_array_index)
      integer block_map_table(lblock_map_entry,*)
      integer array, array_block, blkndx
      integer array_data, data
      integer flag, flagval, flagtest
      integer type
      integer next
      integer lookup, block_map_lookup
      integer stack
      integer seg_blk
      integer ierr
      integer orig_index
      logical match
      integer*8 ixx, get_index_from_base
      integer bhdr(1) 

c---------------------------------------------------------------------------
c   Get the current segment of each index.
c---------------------------------------------------------------------------

      find_current_block = -1
      blkndx = 0

      type = array_table(c_array_type)
      if (type .eq. scalar_value .or.
     *    type .eq. static_array) then
         return
      endif

      nindex = array_table(c_nindex)
      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1)
         if (index(i) .gt. nindex_table) then
            return
         endif

         seg(i)   = index_table(c_current_seg,index(i))

c---------------------------------------------------------------------------
c   If this is a subindex, do we look up the block defined by the subindex
c   itself, or the block defined by its superindex?
c---------------------------------------------------------------------------

         if (index_table(c_index_type, index(i)) .eq. subindex) then
            orig_index = array_table(c_index_original+i-1)
            if (orig_index .gt. 0) then
               if (index_table(c_index_type,orig_index) .ne. 
     *                                             subindex) then
         
c---------------------------------------------------------------------------
c   Find the segment of the superindex corresponding to the current block
c   of the subindex.
c---------------------------------------------------------------------------

                  call subindex_seg_match(index(i), index_table,
     *                                    nindex_table, segment_table,
     *                                    nsegment_table, seg(i))
                  index(i) = orig_index 
               endif
            endif
         endif

         if (seg(i) .eq. undefined_segment) then
            return
         endif
      enddo

      stack = array_table(c_array_stack)

      if (type .eq. distributed_array) then

c---------------------------------------------------------------------------
c   Perform a direct lookup in the block_map_table.
c---------------------------------------------------------------------------

         lookup = block_map_lookup(seg, nindex, x, array_table,
     *                         index_table, nindex_table)
         blkndx = block_map_table(c_bmap_blkndx, lookup)
         if (blkndx .eq. 0) then
            find_current_block = -1
         else
            call get_block_id(stack, blkndx, array, array_block)

            find_current_block = array_block
         endif

         return
      endif

c-------------------------------------------------------------------------
c   Search for a matching block in the most recent blkndx.
c-------------------------------------------------------------------------

       blkndx = array_table(c_current_blkndx)
       if (blkndx .ne. 0) then

c---------------------------------------------------------------------------
c   If the array handle stored in the block itself doesn't match the 
c   expected array number, the blkndx has become invalid and we must
c   search the entire block cache.
c----------------------------------------------------------------------------

         call get_block_id(stack, blkndx, array, array_block)
         if (array .ne. x) go to 1000

c---------------------------------------------------------------------------
c   Either the block must be "busy" or the "persistent" bit must be set. 
c   Otherwise, we must search the entire block cache.
c---------------------------------------------------------------------------

         call get_blk_header(flag, blkndx,c_block_flags)
         if (and(flag, block_busy_flag) .eq. 0) then
            if (and(flag, block_persistence_flag) .eq. 0) then
               array_table(c_current_blkndx) = 0
               go to 1000
            endif
         endif

         do j = 1, nindex
            call get_blk_header(seg_blk, blkndx,c_block_segments+j-1)
            if (seg(j) .ne. seg_blk) then
               array_table(c_current_blkndx) = 0
               blkndx = 0
               go to 1000
            endif
         enddo

         find_current_block = array_block
         return
       endif

c-------------------------------------------------------------------------
c   Search for a matching block in the blk_header table.
c-------------------------------------------------------------------------

 1000 continue

c-------------------------------------------------------------------------
c   Search the linked list for the blocks of this array.
c-------------------------------------------------------------------------

      next = array_table(c_block_list)
      flagtest = or(block_busy_flag,block_persistence_flag)
      ixx = get_index_from_base(addr_blk_header, bhdr, 1)

      if (next .ne. 0) then
 2000 continue
            i = next
            array_data = 
     *            bhdr(ixx+(c_array_handle-1)*blkmgr_blocks+i-1)
c            call get_blk_header(array_data, i, c_array_handle)
            if (array_data .eq. x) then 

c-------------------------------------------------------------------------
c   Make certain that this block has been busied.
c-------------------------------------------------------------------------

               flag = 
     *            bhdr(ixx+(c_block_flags-1)*blkmgr_blocks+i-1) 
c               call get_blk_header(flag, i,c_block_flags)
               if (and(flag, flagtest) .eq. 0) then
                   if (and(flag, block_scrub_flag) .ne. 0) then

c--------------------------------------------------------------------------
c   This block is neither busy nor persistent.  It is marked for scrubbing.
c   Attempt to scrub the block now.
c--------------------------------------------------------------------------
 
                      call scrub_this_block(i,
     *                        index_table, nindex_table,
     *                        block_map_table, ierr)
                    endif
                   go to 1500
               endif

               do j = 1, nindex
c                  call get_blk_header(data, i,c_block_segments+j-1)
                  data = 
     *               bhdr(ixx+(c_block_segments+j-2)*blkmgr_blocks+i-1)
                  if (seg(j) .ne. data)  go to 1500
               enddo

               call get_block_id(stack, i, array, array_block)

               find_current_block = array_block
               blkndx = i
               array_table(c_current_blkndx) = i   ! Update array table entry
               return
            endif

 1500       continue
            call get_blk_header(next, i,c_block_list_ptr)
            if (next .eq. i) then
               print *,'Error: Recursion in block list'
               print *,'x = ',x,' head = ',array_table(c_block_list)
               call abort_job()
            endif

            if (next .ne. 0) go to 2000
      endif     ! next .ne. 0

      find_current_block = -1
      blkndx = 0
      array_table(c_current_blkndx) = 0
      return
      end

      integer function get_blkmgr_blocksize(stack)
c--------------------------------------------------------------------------
c   Returns the size of the blocksize used for the data area of each blkmgr
c   block, in double precision words.
c   If stack = 0, the function returns the maximum blocksize of all stacks.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer stack
      integer i, mxblk
 
      if (stack .eq. 0) then
         mxblk = 0
         do i = 1, nblkmgr_stacks
            mxblk = max(mxblk, stack_datasize(i))
         enddo
         get_blkmgr_blocksize = mxblk
      else
         get_blkmgr_blocksize = stack_datasize(stack)
      endif
      return
      end

      integer function get_blkmgr_numblocks(stack)
c--------------------------------------------------------------------------
c   Returns the number of blocks managed by the blkmgr routines.
c   If stack = 0, we return the total number of blocks over all the stacks.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer stack
      integer i, total_blocks
 
      if (stack .eq. 0) then
         total_blocks = 0
         do i = 1, nblkmgr_stacks
            total_blocks = total_blocks + stack_size(i)
         enddo 
         get_blkmgr_numblocks = total_blocks
      else
         get_blkmgr_numblocks = stack_size(stack)
      endif
      return
      end

      subroutine set_block_indices(array, block, blkndx, 
     *                             array_table_entry)
c-----------------------------------------------------------------------------
c   Sets the block indices in the block header for a given array and block.
c-----------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'

      integer array, block, blkndx
      integer array_table_entry(larray_table_entry)
      integer i, j, n

      i = blkndx
      n = array_table_entry(c_nindex)
      call put_blk_header(n, i,c_block_nindex)
      do j = 1, n
         call put_blk_header(array_table_entry(c_index_array1+j-1),
     *             i,c_block_indices+j-1)
      enddo

      return
      end

      subroutine set_block_segments(array, block, blkndx, 
     *                              index_table, nindex_table)
c--------------------------------------------------------------------------
c   Sets the block segments to the current values of the segment for each 
c   index in the index_table.
c--------------------------------------------------------------------------
      
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'

      integer array, block, blkndx
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer i, j, n, indx

      i = blkndx
      call get_blk_header(n, i,c_block_nindex)

      do j = 1, n
         call get_blk_header(indx, i,c_block_indices+j-1)
         if (index_table(c_current_seg,indx) .le. 0) then
            print *,'Error: current segment of index ',indx,
     *                    ' is ',index_table(c_current_seg,indx)
            print *,'set_block_segments was setting array ',
     *                  array,' block ',block,' at time of error.'
            call abort_job()
         endif

         call put_blk_header(index_table(c_current_seg,indx), 
     *               i,c_block_segments+j-1)

      enddo

      return

      print *,'Error: block ',block,' of array ',array,
     *        ' was not found in set_block_segments.'
      call dump_block_ids()
      call abort_job()
      return
      end

      subroutine set_block_busy_flag(array, array_block, blkndx,
     *                               value)
c-------------------------------------------------------------------------
c   Sets or clears the block_busy_flag for a given array, block 
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx

      if (array_block .lt. 1) return

      if (value .eq. 1) then
         call set_block_flag(array, array_block, blkndx, 
     *                       block_busy_flag)
      else if (value .eq. 0) then
         call clear_block_flag(array, array_block, blkndx,
     *                         block_busy_flag) 
      endif
      return
      end

      subroutine set_block_persistence_flag(array, array_block,
     *                               blkndx, value)
c-------------------------------------------------------------------------
c   Sets or clears the block_persistence_flag for a given array, block 
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx

      if (array_block .lt. 1) return

      if (value .eq. 1) then
         call set_block_flag(array, array_block, blkndx, 
     *                       block_persistence_flag)
      else if (value .eq. 0) then
         call clear_block_persistence_flag(array, array_block, 
     *                         blkndx) 
      endif
      return
      end

      subroutine set_block_scrub_flag(array, array_block, blkndx,
     *                                value)
c-------------------------------------------------------------------------
c   Sets or clears the block_scrub_flag for a given array, block 
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx

      if (array_block .lt. 1) return

      if (value .eq. 1) then
         call set_block_flag(array, array_block, blkndx,
     *                       block_scrub_flag)
      else if (value .eq. 0) then
         call clear_block_flag(array, array_block, blkndx,
     *                          block_scrub_flag) 
      endif
      return
      end

      subroutine set_block_computed_flag(array, array_block, blkndx,
     *                                   value)
c-------------------------------------------------------------------------
c   Sets or clears the block_computed_flag for a given array, block 
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx

      if (array_block .lt. 1) return

      if (value .eq. 1) then
         call set_block_flag(array, array_block, blkndx,
     *                       block_computed_flag)
      else if (value .eq. 0) then
         call clear_block_flag(array, array_block, blkndx,
     *                         block_computed_flag) 
      endif
      return
      end

      subroutine set_block_created_flag(array, array_block, blkndx,
     *                                  value)
c-------------------------------------------------------------------------
c   Sets or clears the block_created_flag for a given array, block 
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx

      if (array_block .lt. 1) return

      if (value .eq. 1) then
         call set_block_flag(array, array_block, blkndx,
     *                       block_created_flag)
      else if (value .eq. 0) then
         call clear_block_flag(array, array_block, blkndx,
     *                         block_created_flag) 
      endif
      return
      end

      subroutine set_block_request_outstanding_flag(array, 
     *                                    array_block, blkndx)
c-------------------------------------------------------------------------
c   Sets the block_request_outstanding_flag for a given array, block 
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, blkndx

      if (array_block .lt. 1) return

      call set_block_flag(array, array_block, blkndx,
     *                    block_request_outstanding_flag)
      return
      end

      subroutine set_block_request_flag(array, array_block,
     *                               blkndx, value)
c-------------------------------------------------------------------------
c   Sets or clears the block_request_flag for a given array, block
c   combination.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      integer array, array_block, value, blkndx

      if (array_block .lt. 1) return

      if (value .eq. 1) then
         call set_block_flag(array, array_block, blkndx,
     *                       block_request_flag)
      else if (value .eq. 0) then
         call clear_block_request_flag(array, array_block,
     *                         blkndx)
      endif
      return
      end

      subroutine get_block_computed_flag(array, array_block, blkndx,
     *                                   value)
c--------------------------------------------------------------------------
c   The value of the block_computed_flag for a given array, block setting
c   is returned in the "value" argument.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx
      integer iblk, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id #1'
         call dump_block_ids()
         call abort_job()
      endif

      call get_blk_header(flagval, iblk,c_block_flags)
      value = and(flagval, block_computed_flag)

      return
      end

      subroutine get_block_scrub_flag(array, array_block, blkndx,
     *                                value)
c--------------------------------------------------------------------------
c   The value of the block_scrub_flag for a given array, block setting
c   is returned in the "value" argument.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx
      integer iblk, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id #2'
         call dump_block_ids()
         call abort_job()
      endif

      call get_blk_header(flagval, iblk,c_block_flags)
      value = and(flagval, block_scrub_flag)

      return
      end

      subroutine get_block_created_flag(array, array_block, blkndx,
     *                                  value)
c--------------------------------------------------------------------------
c   The value of the block_created_flag for a given array, block setting
c   is returned in the "value" argument.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx
      integer iblk, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 3'
         call dump_block_ids()
         call abort_job()
      endif

      call get_blk_header(flagval, iblk,c_block_flags)
      value = and(flagval, block_created_flag)

      return
      end

      subroutine get_block_persistence_flag(array, array_block,
     *                                blkndx, value)
c--------------------------------------------------------------------------
c   The value of the block_persistence_flag for a given array, block setting
c   is returned in the "value" argument. 
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      include 'trace.h'
      integer array, array_block, value, blkndx
      integer iblk, flagval
      integer array_data, blk_data

      iblk = blkndx
      call get_blk_header(array_data, iblk,c_array_handle)
      call get_blk_header(blk_data, iblk,c_array_block)
      if (array_data .ne. array .or.
     *    blk_data .ne. array_block) then
         print *,'Error: Inconsistent data: array, block, blkndx ',
     *             array, array_block, blkndx 
         print *,'Task ',me,' line ',current_line,' actual block was ',
     *      array_data, blk_data
         call dump_block_ids()
         call abort_job()
      endif

      call get_blk_header(flagval, iblk,c_block_flags)
      value = and(flagval, block_persistence_flag)

      return
      end

      subroutine check_block_consistency(array, array_block,
     *                                blkndx)
c--------------------------------------------------------------------------
c   Check to make sure the argument values match the values stored in the
c   data block.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      include 'trace.h'
      integer array, array_block, value, blkndx
      integer iblk, flagval
      integer array_data, blk_data

      iblk = blkndx
      call get_blk_header(array_data, iblk,c_array_handle)
      call get_blk_header(blk_data, iblk,c_array_block)
      if (array_data .ne. array .or.
     *    blk_data .ne. array_block) then
         print *,'Error: Inconsistent data: array, block, blkndx ',
     *             array, array_block, blkndx 
         print *,'Task ',me,' line ',current_line,' actual block was ',
     *      array_data, blk_data
         call dump_block_ids()
         call abort_job()
      endif

      return
      end

      subroutine get_block_request_outstanding_flag(array, 
     *                               array_block, blkndx, value)
c--------------------------------------------------------------------------
c   The value of the block_request_outstanding_flag for a given array, 
c   block setting is returned in the "value" argument.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, value, blkndx
      integer iblk, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 5'
         call dump_block_ids() 
         call abort_job()
      endif

      call get_blk_header(flagval, iblk,c_block_flags)
      value = and(flagval, 
     *             block_request_outstanding_flag)

      return
      end

      subroutine clear_block_computed_flag(array, array_block, 
     *                                     blkndx)
c--------------------------------------------------------------------------
c   Clears all the block_computed_flag values in the table of blocks.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'

      integer i,j,flag, flagval
      integer array, array_block, blkndx

      i = blkndx
      if (i .lt. 1) then
         print *,'Error: clear_block_computed_flag cannot find',
     *     ' array, block ',array, array_block
         call dump_block_ids()
         call abort_job()
      endif

      call get_blk_header(flagval, i,c_block_flags)
      flag = and(flagval, block_computed_flag)
      if (flag .ne. 0) 
     *   call put_blk_header(xor(block_computed_flag,flagval),
     *                       i,c_block_flags)    

      return
      end

      subroutine clear_block_created_flag(array, array_block, blkndx)
c--------------------------------------------------------------------------
c   Clears all the block_created_flag values in the table of blocks.
c--------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'

      integer i,flag, flagval
      integer array, array_block, blkndx

      i = blkndx
      if (i .lt. 1) then
         print *,'Error: clear_block_created_flag cannot find',
     *     ' array, block ',array, array_block
         call abort_job()
      endif

      call get_blk_header(flagval, i,c_block_flags)
      flag = and(flagval, block_created_flag)
      if (flag .ne. 0) 
     *   call put_blk_header(xor(block_created_flag,flagval),
     *                       i,c_block_flags)

      return
      end

      subroutine set_block_flag(array, array_block, blkndx, 
     *                           block_flag)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, block_flag, blkndx
      integer iblk, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 6'
         call abort_job()
      endif

      call get_blk_header(flagval, iblk,c_block_flags)
      flagval = or(flagval, block_flag)
      call put_blk_header(flagval, iblk,c_block_flags)
      return
      end

      subroutine clear_block_flag(array, array_block, blkndx,
     *                            block_flag)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, block_flag, blkndx
      integer iblk, flag, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 7'
         call abort_job()
      endif

      call get_blk_header(flag, iblk,c_block_flags)  
      flagval = and(flag, block_flag)
      call put_blk_header(xor(flagval, flag), iblk,c_block_flags) 
      return
      end

      subroutine clear_block_persistence_flag(array, array_block, 
     *                                        blkndx)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, blkndx
      integer iblk, flag, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 8'
         call abort_job()
      endif

      call get_blk_header(flag, iblk,c_block_flags)
      flagval = and(flag, 
     *                  block_persistence_flag)
      call put_blk_header(xor(flagval, flag), iblk,c_block_flags)

      return
      end

      subroutine clear_block_request_flag(array, array_block, 
     *                                        blkndx)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, blkndx
      integer iblk, flag, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 8'
         call abort_job()
      endif

      call get_blk_header(flag, iblk,c_block_flags)
      flagval = and(flag, 
     *                  block_request_flag)
      call put_blk_header(xor(flagval, flag), iblk,c_block_flags)

      return
      end

      subroutine clear_block_request_outstanding_flag(array, 
     *                                     array_block, blkndx)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      integer array, array_block, blkndx 
      integer iblk, flag, flagval

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: Block not found by blkmgr: array ',array,
     *           ' array_block = ',array_block,' id # 9'
         call abort_job()
      endif

      call get_blk_header(flag, iblk,c_block_flags)
      flagval = and(flag, 
     *              block_request_outstanding_flag)
      if (flagval .ne. 0)
     *   call put_blk_header(xor(flagval, flag), iblk,c_block_flags)
      return
      end

      subroutine set_block_size(array, array_block, blkndx, size)
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer array, array_block, size, blkndx
      integer iblk

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: set_block_size is unable to find array ',
     *           array,' block ',array_block
         call abort_job()
      endif

      call put_blk_header(size, iblk,c_block_size)
      return
      end 

      integer function get_block_size(array, array_block, blkndx)
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer array, array_block, blkndx
      integer iblk, n

      iblk = blkndx
      if (iblk .le. 0) then
         print *,'Error: get_block_size is unable to find array ',
     *           array,' block ',array_block
         call abort_job()
      endif

      call get_blk_header(n, iblk,c_block_size)
      get_block_size = n
      return
      end

      integer function get_block_number(array, array_block)
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'machine_types.h'

      integer i, j, array, array_block
      integer flag, array_data, blk_data
      integer blk_in_use(1)
      integer*8 addr, get_index_from_base
      integer*8 ixx

      ixx = get_index_from_base(addr_blk_in_use, blk_in_use, 1)
      
c--------------------------------------------------------------------------
c   Scan all blocks that are registered as "in use".
c--------------------------------------------------------------------------

      do  j = 1, nblk_in_use
         i = blk_in_use(ixx+j-1)
 
         call get_blk_header(flag, i,c_block_flags)
         if (and(flag, block_busy_flag) 
     *              .ne. 0 .or.
     *       and(flag,
     *                 block_persistence_flag) .ne. 0) then
            call get_blk_header(array_data, i,c_array_handle)
            call get_blk_header(blk_data, i,c_array_block)
            if (array_data .eq. array .and.
     *             blk_data .eq. array_block) then
               get_block_number = i
               return
            endif
         endif
      enddo

      get_block_number = -1 
      return
      end

      integer function get_block_number_distributed(array, array_block,
     *                     array_table, block_map_table)
c----------------------------------------------------------------------------
c   Fast lookup of a block number of a distributed array.
c   No checking is done to insure correctness, and the array is assumed
c   to have been created previously.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'machine_types.h'
      include 'mpif.h'
      integer me, ierr

      integer i, j, array, array_block
      integer array_table(larray_table_entry,*)
      integer block_map_table(lblock_map_entry,*)
 
      integer flag, array_data, blk_data
      
      j = array_table(c_block_map,array)   ! block_map entry of 1st block.
      get_block_number_distributed = 
     *    block_map_table(c_bmap_blkndx, j+array_block-1)
      
      return
      end

      subroutine set_block_request(array, block, blkndx, request)
c-------------------------------------------------------------------------
c   Stores the mpi request handle in the blkmgr data for the array, block.
c-------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'mpif.h'
      integer array, block, blkndx, request
      integer j
      integer request_data

      if (array .le. 0 .or. block .le. 0) then
         print *,'Error: set_block_request was called with ',
     *      ' array ',array,' block ',block
         call abort_job()
      endif

      j = blkndx
      if (j .gt. 0) then
         call get_blk_header(request_data, j,c_block_request)
         if (request_data .ne. mpi_request_null .and.
     *      request .ne. mpi_request_null) then
            print *,'Error in set_block_request: Previous request',
     *          ' has not been cleared. array, block = ',
     *          array,block
            print *,'Previous request = ',request_data,
     *               ' mpi_request_null = ',mpi_request_null
            call abort_job()
         endif

         call put_blk_header(request, j,c_block_request)
      else
         print *,'Error: set_block_request cannot find array ',
     *     array,' block ',block
         call dump_block_ids()
         call abort_job()
      endif 

      return
      end

      integer function get_block_request(array, block, blkndx)
c-------------------------------------------------------------------------
c   Returns the value of the request stored in the blkmgr's data for the
c   array, block.
c-------------------------------------------------------------------------

      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer array, block, blkndx
      integer j, request

      j = blkndx
      if (j .gt. 0) then
         call get_blk_header(request, j,c_block_request)
         get_block_request = request
      else
         print *,'Error: get_block_request cannot find array ',
     *     array,' block ',block
         call dump_block_ids()
         call abort_job()
      endif 

      return
      end

      subroutine scrub_blocks(size, must_wait, array_table,
     *                        narray_table, index_table, nindex_table, 
     *                        block_map_table, ierr)
c----------------------------------------------------------------------------
c   Attempt to scrub a block larger than a given size.
c   Searches all blocks marked as "scrubbable".
c   If a block has been marked to be scrubbed, and if the block is on a stack
c   with a large enough stack size, the communication request
c   is checked.  If the request has been completed, the block_busy_flag
c   is cleared, indicating that the block may be reclaimed for later use.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'

      logical must_wait
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer ierr, mpi_ierr
      integer size

      integer array, block, stack
      integer flag, comp_flag
      integer flagval
      integer request
      integer next, ptr
      integer status(MPI_STATUS_SIZE)
      logical complete

      ierr = 1
      ptr = comm_list_head
      if (ptr .eq. 0) return

  100 continue
      call get_blk_header(flagval, ptr,c_block_flags)
      flag = and(flagval, block_scrub_flag)
      call get_blk_header(next, ptr,c_comm_list_ptr)

      if (flag .ne. 0) then

c---------------------------------------------------------------------------
c   Check the size requirement.
c---------------------------------------------------------------------------

         call get_blk_header(stack, ptr,c_block_stack)
         if (size .le. stack_datasize(stack)) then
            call get_blk_header(request, ptr,c_block_request)
            call mpi_test(request, complete,
     *                    status, mpi_ierr)
            if (complete) then
               call put_blk_header(MPI_REQUEST_NULL,ptr,c_block_request)
               call get_blk_header(array, ptr, c_array_handle)
               call get_blk_header(block, ptr, c_array_block)
               call blkmgr_remove_block_from_list(comm_list_head,
     *             comm_list_tail, ptr, c_comm_list_ptr)

               if (server_monitor_on) 
     *            call server_monitor_write_log(ptr, 'r', 
     *                            status(mpi_source))

               call free_block(array, block, ptr, array_table,
     *                narray_table, index_table, nindex_table,
     *                block_map_table)
               ierr = 0
               return
            endif      ! complete
	 endif      ! size
      endif      ! flag

      if (next .ne. 0) then
         ptr = next
         go to 100
      endif 

c      print *,'Task ',me,'   SCRUB: Returning ierr ',ierr
      return
      end

      subroutine scrub_this_block(blkndx, 
     *                        index_table, nindex_table, 
     *                        block_map_table, ierr)
c----------------------------------------------------------------------------
c   Attempt to scrub a particular block.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'
      include 'sip_tables.h'

      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer ierr, mpi_ierr
      integer blkndx

      integer*8 ixarray_table, get_index_from_base
      integer array_table(1)
      integer narray_table

      integer array, block, stack
      integer request
      integer status(MPI_STATUS_SIZE)
      logical complete

      ierr = 1

      call get_blk_header(request, blkndx,c_block_request)
      call mpi_test(request, complete,
     *                    status, mpi_ierr)
      if (complete) then
         call put_blk_header(MPI_REQUEST_NULL,blkndx,c_block_request)
         call get_blk_header(array, blkndx, c_array_handle)
         call get_blk_header(block, blkndx, c_array_block)
         call blkmgr_remove_block_from_list(comm_list_head,
     *             comm_list_tail, blkndx, c_comm_list_ptr)

         if (server_monitor_on) 
     *      call server_monitor_write_log(blkndx, 'r', 
     *                      status(mpi_source))

         ixarray_table = get_index_from_base(array_table_base,
     *                       array_table, 1)
         call free_block(array, block, blkndx, 
     *          array_table(ixarray_table),
     *          narray_table_sip, index_table, nindex_table,
     *          block_map_table)
         ierr = 0
      endif

      return
      end

      subroutine scrub_from_stack(scrub_stack, array_table,
     *                        narray_table, index_table, nindex_table, 
     *                        block_map_table, ierr)
c----------------------------------------------------------------------------
c   Attempt to scrub a block from a given stack.
c   Searches all blocks marked as "scrubbable".
c   If a block has been marked to be scrubbed, and if the block is on the 
c   specified stack, the communication request
c   is checked.  If the request has been completed, the block_busy_flag
c   is cleared, indicating that the block may be reclaimed for later use.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'

      integer scrub_stack
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer ierr, mpi_ierr

      integer array, block, stack
      integer flag, comp_flag
      integer flagval
      integer request
      integer next, ptr
      integer status(MPI_STATUS_SIZE)
      logical complete

      ierr = 1
      ptr = comm_list_head
      if (ptr .eq. 0) return

  100 continue
      call get_blk_header(flagval, ptr,c_block_flags)
      flag = and(flagval,  block_scrub_flag)
      call get_blk_header(next, ptr,c_comm_list_ptr)

      if (flag .ne. 0) then

c---------------------------------------------------------------------------
c   Check the size requirement.
c---------------------------------------------------------------------------

         call get_blk_header(stack, ptr,c_block_stack)
         if (stack .eq. scrub_stack) then
            call get_blk_header(request, ptr,c_block_request) 
            call mpi_test(request, complete,
     *                    status, mpi_ierr)
            if (complete) then
               call put_blk_header(MPI_REQUEST_NULL, 
     *                            ptr,c_block_request)
               call get_blk_header(array, ptr, c_array_handle)
               call get_blk_header(block, ptr, c_array_block) 
               call blkmgr_remove_block_from_list(comm_list_head,
     *             comm_list_tail, ptr, c_comm_list_ptr)

               if (server_monitor_on)
     *            call server_monitor_write_log(ptr, 'r', 
     *                               status(mpi_source))

               call free_block(array, block, ptr, array_table,
     *                narray_table, index_table, nindex_table,
     *                block_map_table)
               ierr = 0
               return
            endif
         endif
      endif

      if (next .ne. 0) then
         ptr = next
         go to 100
      endif 

c      print *,'Task ',me,'   SCRUB: Returning ierr ',ierr
      return
      end

      subroutine reclaim_persistent_block(size, array_table,
     *                     narray_table, index_table, nindex_table,
     *                     block_map_table, ierr)
c---------------------------------------------------------------------------
c   Find a block marked as "persistent" exceeding a given "size", and 
c   frees the block.  This makes the block available for further use.
c
c   If no block is available to be reclaimed, the ierr argument is set to
c   -1.  Otherwise, ierr = 0 is returned.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'

      integer narray_table, ierr, mpi_ierr
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer size, request
      integer i, old_array, block, stack, ptr, next
      integer flagval
      integer status(MPI_STATUS_SIZE)
      logical flag
 
c-------------------------------------------------------------------------
c   Find a persistent block that is not busy.
c-------------------------------------------------------------------------

      ierr = -1
      if (persistent_list_head .eq. 0) return
      
      next = persistent_list_head
  100 continue
      ptr = next
      i   = next 
      call get_blk_header(next, ptr, c_persistent_ptr)
      call get_blk_header(stack, i,c_block_stack)
      if (size .le. stack_datasize(stack)) then

c--------------------------------------------------------------------------
c   We must check the block_busy_flag and block_computed_flag.  If either 
c   one is non-zero, we cannot reclaim the block.
c--------------------------------------------------------------------------

      call get_blk_header(flagval, i,c_block_flags)
      if (and(flagval, block_busy_flag) .eq. 0 .and.
     *    and(flagval, block_computed_flag) .eq. 0) then 

c--------------------------------------------------------------------------
c   This is the oldest such block in the list, since the list is a FIFO.
c   Make sure the block is not still engaged in communication.
c--------------------------------------------------------------------------

         call get_blk_header(request, i,c_block_request)
         if (request .ne. 
     *                                mpi_request_null) then

c--------------------------------------------------------------------------
c   Test the block to see if it has finished its communication.
c   If it has finished, remove it from the comm_list.
c--------------------------------------------------------------------------

            call mpi_test(request,
     *                         flag, status, mpi_ierr)

            if (flag) then 
               call put_blk_header(MPI_REQUEST_NULL, i,c_block_request)
               call blkmgr_remove_block_from_list(comm_list_head,
     *                 comm_list_tail, i, c_comm_list_ptr)
               if (server_monitor_on)
     *            call server_monitor_write_log(ptr, 'r',
     *                                  status(mpi_source))
            endif
         else

c--------------------------------------------------------------------------
c   The block is not found to be engaged in communication.
c   Thus it may be safely reclaimed.
c--------------------------------------------------------------------------

            flag = .true.
         endif

c-------------------------------------------------------------------------
c   Free the block. The free_block subroutine will also remove the 
c   block from the persistent_block list.
c-------------------------------------------------------------------------

         if (flag) then
            call get_blk_header(old_array, i,c_array_handle)
            call get_blk_header(block,i,c_array_block)
            call free_block(old_array, block,
     *                i, array_table, narray_table,
     *                index_table, nindex_table, block_map_table)
            ierr = 0
            return
         endif
      endif    ! flag
      endif    ! size <= stack_size(stack)

c---------------------------------------------------------------------------
c   Point to the next block in the list and check for a block to reclaim.
c---------------------------------------------------------------------------

      if (next .ne. 0) go to 100

      return
      end

      subroutine reclaim_persistent_block_from_stack(mystack, 
     *           array_table,narray_table, index_table, nindex_table,
     *           block_map_table, ierr)
c---------------------------------------------------------------------------
c   Finds a block marked as "persistent" on a given stack, and 
c   frees the block.  This makes the block available for further use.
c
c   If no block is available to be reclaimed, the ierr argument is set to
c   -1.  Otherwise, ierr = 0 is returned.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'

      integer narray_table, ierr, mpi_ierr
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer mystack, flagval, request
      integer i, old_array, block, stack, ptr, next
      integer status(MPI_STATUS_SIZE)
      logical flag
      
c-------------------------------------------------------------------------
c   Find a persistent block that is not busy.
c-------------------------------------------------------------------------

      ierr = -1
      if (persistent_list_head .eq. 0) return
      
      next = persistent_list_head
  100 continue
      ptr = next
      i   = next 
      call get_blk_header(next, ptr, c_persistent_ptr)
      call get_blk_header(stack, i,c_block_stack)
      if (stack .ne. mystack) then
         if (next .gt. 0) go to 100   ! check next entry
         return   ! end of list
      endif

c--------------------------------------------------------------------------
c   We must check the block_busy_flag and block_computed_flag.  If either 
c   one is non-zero, we cannot reclaim the block.
c--------------------------------------------------------------------------

      call get_blk_header(flagval, i,c_block_flags) 
      if (and(flagval, block_busy_flag) 
     *                                     .eq. 0 .and.
     *    and(flagval, block_computed_flag) 
     *                                     .eq. 0) then 

c--------------------------------------------------------------------------
c   This is the oldest such block in the list, since the list is a FIFO.
c   Make sure the block is not still engaged in communication.
c--------------------------------------------------------------------------

         call get_blk_header(request, i,c_block_request)
         if (request .ne. mpi_request_null) then

c--------------------------------------------------------------------------
c   Test the block to see if it has finished its communication.
c   If it has finished, remove it from the comm_list.
c--------------------------------------------------------------------------

            call mpi_test(request,
     *                         flag, status, mpi_ierr)
            if (flag) then
               call put_blk_header(MPI_REQUEST_NULL, i,c_block_request)
               call blkmgr_remove_block_from_list(comm_list_head,
     *                 comm_list_tail, i, c_comm_list_ptr)
               if (server_monitor_on)
     *            call server_monitor_write_log(ptr, 'r',
     *                                status(mpi_source))
            endif
         else

c--------------------------------------------------------------------------
c   The block is not found to be engaged in communication.
c   Thus it may be safely reclaimed.
c--------------------------------------------------------------------------

            flag = .true.
         endif

c-------------------------------------------------------------------------
c   Free the block. The free_block subroutine will also remove the 
c   block from the persistent_block list.
c-------------------------------------------------------------------------

         if (flag) then
            call get_blk_header(old_array, i,c_array_handle)
            call get_blk_header(block, i,c_array_block)  
            call free_block(old_array, block,
     *                i, array_table, narray_table,
     *                index_table, nindex_table, block_map_table)
            ierr = 0
            return
         endif
      endif

c---------------------------------------------------------------------------
c   Point to the next block in the list and check for a block to reclaim.
c---------------------------------------------------------------------------

      if (next .ne. 0) go to 100

      return
      end

      subroutine free_persistent_blocks(array, array_table, 
     *                    narray_table, index_table, nindex_table,
     *                    block_map_table)
c---------------------------------------------------------------------------
c   Releases all persistent blocks of an array.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'timerz.h'

      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer array, flagval, request, blk_data
      integer ptr, i, ierr
      integer status(MPI_STATUS_SIZE)

      logical flag 

      ptr = array_table(c_block_list,array)
      if (ptr .eq. 0) return    ! no blocks

  100 continue
      i = ptr 

c------------------------------------------------------------------------
c   Check the persistence flag.
c------------------------------------------------------------------------

      call get_blk_header(flagval, i,c_block_flags)
      if (and(flagval, block_persistence_flag)
     *                       .ne. 0) then

c-------------------------------------------------------------------------
c   The block may still be communicating.  In that case, we must wait.
c--------------------------------------------------------------------------

         call get_blk_header(request, i,c_block_request)
         if (request .ne. MPI_REQUEST_NULL) then
  200        continue
             call mpi_test(request, flag,
     *                       status, ierr)
             if (flag) then
                call put_blk_header(MPI_REQUEST_NULL, 
     *                      i,c_block_request)
             else 

               call update_timer(current_instr_timer)  
               call pause_timer(current_instr_unit_timer)
               if (pardo_block_wait_timer .ne. 0)
     *           call update_timer(pardo_act_timer)
#ifdef VERY_DETAILED_TIMERS               
               if (pardo_block_wait_timer .ne. 0)
     *           call timer_start(pardo_tserver_timer)
               call timer_start(current_instr_mpi_timer)
               call timer_start (current_instr_mpino_timer)
#endif               
               call exec_thread_server(0)
#ifdef VERY_DETAILED_TIMERS               
               call update_timer (current_instr_mpino_timer)
               call update_timer(current_instr_mpi_timer)
               if (pardo_block_wait_timer .ne. 0)
     *            call update_timer(pardo_tserver_timer)
#endif                
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_act_timer)
               call resume_timer(current_instr_unit_timer)
               call timer_start(current_instr_timer)
                go to 200
             endif

             call blkmgr_remove_block_from_list(comm_list_head,
     *                    comm_list_tail, i, c_comm_list_ptr)
         endif

c-------------------------------------------------------------------------
c   Free the block and remove it from the list.
c   The free_block subroutine also removes this block from the 
c   persistent block linked list.
c-----------------------------------------------------------------------

            call get_blk_header(ptr, i,c_block_list_ptr)
            call get_blk_header(blk_data, i,c_array_block)
            call free_block(array, blk_data, i,
     *                   array_table, narray_table, 
     *                   index_table, nindex_table,
     *                   block_map_table)
      else

c--------------------------------------------------------------------------
c   Find the next block in the list.
c--------------------------------------------------------------------------
      
         call get_blk_header(ptr, i,c_block_list_ptr)
      endif
      if (ptr .ne. 0) go to 100

      return
      end

      subroutine blkmgr_insert_block_in_list(head, tail, blkndx, 
     *                                       list, fifo)
c-------------------------------------------------------------------------
c   Enters a newly-allocated block in a linked list.
c   The "fifo" argument adds the block to the end of the list, otherwise 
c   it is inserted at the head.
c-------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer head, tail, list
      integer blkndx
      integer existing_head
      logical fifo

      if (fifo) then

         if (tail .eq. 0) then

c-------------------------------------------------------------------------
c   List is currently empty.  Create a new head.
c-------------------------------------------------------------------------

            head = blkndx
            tail = blkndx
            call put_blk_header(0, blkndx,list)
         else

c--------------------------------------------------------------------------
c   Add to end of existing list.
c--------------------------------------------------------------------------

            call put_blk_header(blkndx, tail, list)
            tail = blkndx                      ! update tail 
            call put_blk_header(0, blkndx,list)
         endif
      else
         existing_head = head
         head          = blkndx
         call put_blk_header(existing_head, blkndx,list)
      endif

      return
      end

      subroutine blkmgr_remove_block_from_list(head, tail, 
     *                                         blkndx, list)
c--------------------------------------------------------------------------
c   Removes a block from the linked list of blocks.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer head, tail, blkndx, list
      integer ptr, data
      integer array

      call get_blk_header(array, blkndx,c_array_handle)
      if (head .eq. blkndx) then

c---------------------------------------------------------------------------
c   Removing the head.
c---------------------------------------------------------------------------

         call get_blk_header(ptr, blkndx,list)
         head = ptr
         call put_blk_header(0, blkndx,list) 
         if (blkndx .eq. tail) tail = 0  
      else

c--------------------------------------------------------------------------
c   Find the block whose pointer points to blkndx.
c--------------------------------------------------------------------------

         ptr = head
  100    continue
         if (ptr .eq. 0) then
            print *,'Error: Cannot find block ',blkndx,
     *                   ' to remove from block list.'
            call print_list(head, list)
            call dump_block_ids()
            call abort_job()
         else
            call get_blk_header(data, ptr,list)
            if (data .eq. blkndx) then

c--------------------------------------------------------------------------
c   This block points to the block we wish to remove.  Change its pointer
c   and return.
c--------------------------------------------------------------------------

               call get_blk_header(data, blkndx,list)
               call put_blk_header(data, ptr,list)
               call put_blk_header(0, blkndx,list)

c--------------------------------------------------------------------------
c  If we just removed the tail, this block becomes the new tail.
c--------------------------------------------------------------------------

               if (blkndx .eq. tail) tail = ptr
               return
            endif
         endif

c--------------------------------------------------------------------------
c   Point to the next block in the list, try again.
c--------------------------------------------------------------------------

         call get_blk_header(data, ptr,list)
         ptr = data
         go to 100
      endif
      
      return
      end

      subroutine print_list(head, list)
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer head, list
      integer ptr, next
      integer array_data, blk_data, flagval
   
      if (head .eq. 0) then
         print *,'Task ',me,' line ',current_line,
     *     ' List ',list,' has no blocks in list.'
      else
         print *,'Task ',me,' line ',current_line, 
     *     ' head ',head,' list ',list
         ptr = head

  100    continue
         call get_blk_header(next, ptr,list)
         call get_blk_header(array_data, ptr,c_array_handle)
         call get_blk_header(blk_data, ptr,c_array_block)
         call get_blk_header(flagval, ptr,c_block_flags)
         
         print *,'Task ',me,' line ',current_line,'   ptr ',ptr,
     *      '-->',next,' array ',array_data,
     *    ' block ',blk_data,
     *     ' block flags ',flagval
         if (ptr .eq. next) then
            print *,'Error: recursion in list detected.'
            call abort_job()
         endif

         ptr = next
         if (ptr .eq. 0) then
            print *,'Task ',me,' line ',current_line,' End of list'
            return
         endif

         go to 100
      endif

      return
      end 

      subroutine pop_free_stack(stack, blkndx)
c---------------------------------------------------------------------------
c   Pops a block from the "stack" free stack.
c   The block index number (blkndx) is returned.
c   If there is a stack underflow, a -1 is returned.
c---------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      integer stack
      integer blkndx

      if (free_stack_ptr(stack) .lt. stack_start(stack)) then
         blkndx = -1
      else

c---------------------------------------------------------------------------
c   Capture the value of the stack.
c---------------------------------------------------------------------------

         call get_free_stack(blkndx, free_stack_ptr(stack))
         free_stack_ptr(stack) = free_stack_ptr(stack) - 1
         if (blkndx .lt. stack_start(stack) .or. 
     *       blkndx .gt. stack_start(stack)+stack_size(stack)-1) then
            print *,'Error: Invalid data on free stack: ',
     *           ' stack = ',stack,' blkndx ',blkndx,
     *           ' stack data should be between ',
     *          stack_start(stack),' and ',
     *          stack_start(stack)+stack_size(stack)-1
            print *,'stack pointer ',free_stack_ptr(stack)
            call abort_job()
         endif
      endif

      return
      end

      subroutine find_free_stack(stack, blkndx)
c---------------------------------------------------------------------------
c   Pops a block from the "stack" free stack.
c   The block index number (blkndx) is returned.
c   If there is a stack underflow, a -1 is returned.
c---------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      integer stack
      integer blkndx

      if (free_stack_ptr(stack) .lt. stack_start(stack)) then
         blkndx = -1
      else

c---------------------------------------------------------------------------
c   Capture the value of the stack.
c---------------------------------------------------------------------------

         call get_free_stack(blkndx, free_stack_ptr(stack))
         if (blkndx .lt. stack_start(stack) .or. 
     *       blkndx .gt. stack_start(stack)+stack_size(stack)-1) then
            print *,'Error: Invalid data on free stack: ',
     *           ' stack = ',stack,' blkndx ',blkndx,
     *           ' stack data should be between ',
     *          stack_start(stack),' and ',
     *          stack_start(stack)+stack_size(stack)-1
            print *,'stack pointer ',free_stack_ptr(stack)
            call abort_job()
         endif
      endif

      return
      end


      subroutine push_free_stack(stack, blkndx)
c---------------------------------------------------------------------------
c   Pushes a block onto the free stack.
c   The block index number (blkndx) is stored on the stack.
c   If there is a stack overflow, the job is aborted.
c---------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'
      integer stack, blkndx

      if (free_stack_ptr(stack) .ge. stack_start(stack) +
     *                                  stack_size(stack)-1) then
         print *,'Task ',me,' line ',current_line,
     *      ' free stack overflow: stack ',stack
         call abort_job()
      else

      if (blkndx .lt. stack_start(stack) .or. 
     *    blkndx .gt. stack_start(stack)+stack_size(stack)-1) then
          print *,'Error: Invalid data submitted to free stack:',
     *     ' stack ',stack,' blkndx ',blkndx
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Increment the stack pointer, store the value.
c---------------------------------------------------------------------------

         free_stack_ptr(stack) = free_stack_ptr(stack) + 1
         call put_free_stack(blkndx, free_stack_ptr(stack))
      endif
      return
      end

      integer function allocate_block(array, array_block, size,
     *                       array_table, narray_table,
     *                       index_table, nindex_table, 
     *                       block_map_table)
c-------------------------------------------------------------------------
c     Finds a free block, allocates it to block "array_block" of "array".
c     The block index is returned in the return code if 
c     successful, otherwise a negative value is returned.
c-------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'timerz.h'

      integer array, array_block, size, ierr
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer i
      integer k, max_iterations, kscrub, scrub_iterations
      integer blkndx
      integer stack, istack

#ifdef DETAILED_TIMERS
      call timer_start(current_instr_allocate_timer)
#endif      
      call update_timer(current_instr_timer)
      call pause_timer(current_instr_unit_timer)

      allocate_block = -1
      max_iterations = 600000   
      scrub_iterations = 100

      if (array_block .lt. 1) then
         print *,'Error in allocate_block: Invalid block number ',
     *           array_block,
     *           ' for array ',array
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Find the smallest stack on which this block will fit.
c--------------------------------------------------------------------------

      do i = 1, nblkmgr_stacks
         if (size .le. stack_datasize(i)) then
            istack = i
            go to 100
         endif
      enddo

      print *,'Error: array, block ',array,array_block,
     *   ' will not fit on any stack.  Size = ',size
      call array_block_summary(array_table, narray_table)
      call dump_block_ids()
      call abort_job()
  100 continue

      do k = 1, max_iterations

c--------------------------------------------------------------------------
c   Pop a block off one of the free stacks.  We use the smallest stack
c   on which we can find a suitable block.
c--------------------------------------------------------------------------

         do i = istack, nblkmgr_stacks
            stack = i
            call pop_free_stack(stack, blkndx)
            if (blkndx .gt. 0) go to 200 

c---------------------------------------------------------------------------
c   Try to scrub a block from the current stack.
c---------------------------------------------------------------------------

            do kscrub = 1, scrub_iterations

               if (pardo_block_wait_timer .ne. 0)
     *            call update_timer(pardo_act_timer)
#ifdef VERY_DETAILED_TIMERS               
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_tserver_timer)
               call timer_start(current_instr_mpi_timer)
               call timer_start (current_instr_mpino_timer)
#endif               
               call exec_thread_server(0)
#ifdef VERY_DETAILED_TIMERS
               call update_timer (current_instr_mpino_timer)
               call update_timer(current_instr_mpi_timer)
               if (pardo_block_wait_timer .ne. 0)
     *             call update_timer(pardo_tserver_timer)
#endif                
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_act_timer)

               call scrub_from_stack(stack, array_table,
     *                     narray_table, index_table, nindex_table,
     *                     block_map_table, ierr)

               if (ierr .ne. 0) then

c-------------------------------------------------------------------------
c   We failed to scrub a block.  Try to reclaim a persistent block that
c   lives on this stack.
c-------------------------------------------------------------------------

                  call reclaim_persistent_block_from_stack(stack,
     *              array_table,narray_table, index_table, nindex_table,
     *              block_map_table, ierr)
               endif
            
               if (ierr .eq. 0) then
                  call pop_free_stack(stack,blkndx)
                  if (blkndx .gt. 0) go to 200
               endif
            enddo      ! kscrub_iterations

         enddo         ! istack
  200    continue

         if (blkndx .gt. 0) then
            i = blkndx

c--------------------------------------------------------------------------
c   Set up the newly allocated block.
c--------------------------------------------------------------------------

            call put_blk_header(array, i,c_array_handle)
            call put_blk_header(array_block,i,c_array_block) 
            call put_blk_header(mpi_request_null,i,c_block_request)
            call put_blk_header(block_busy_flag,i,c_block_flags)
            call put_blk_header(size,i,c_block_size)   
            call put_blk_header(0,i,c_block_list_ptr)
            allocate_block = i 

            call set_block_id(array, array_block, stack, i)
            call put_blk_in_use(i)
#ifdef DETAILED_TIMERS            
            call update_timer(current_instr_allocate_timer)
#endif            
            call timer_start(current_instr_timer)
            call resume_timer(current_instr_unit_timer)
            return 
         else
            if (comm_list_head .ne. 0) then
               
               if (pardo_block_wait_timer .ne. 0)
     *            call update_timer(pardo_act_timer)
#ifdef VERY_DETAILED_TIMERS               
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_tserver_timer)
               call timer_start(current_instr_mpi_timer)
               call timer_start (current_instr_mpino_timer)
#endif               
               call exec_thread_server(0)
#ifdef VERY_DETAILED_TIMERS
               call update_timer (current_instr_mpino_timer)
               call update_timer(current_instr_mpi_timer)
               if (pardo_block_wait_timer .ne. 0)
     *            call update_timer(pardo_tserver_timer)
#endif                
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_act_timer)

               call scrub_blocks(size, .false., array_table,
     *                   narray_table, index_table, nindex_table,
     *                   block_map_table, ierr)  
c               print *,'Task ',me,' ALLOC SCRUB array,block ',
c     *              array,array_block,' k, ierr ',k, ierr
            else
               ierr = 1
            endif

            if (ierr .ne. 0) then     ! could not scrub any.
                call reclaim_persistent_block(size, array_table, 
     *               narray_table, index_table, nindex_table,
     *               block_map_table, ierr)
c                 print *,'Task ',me,' ALLOC RECLAIM array,block ',
c     *             array,array_block,' k, ierr ',k, ierr
            endif

            if (ierr .ne. 0) then

               if (pardo_block_wait_timer .ne. 0)
     *            call update_timer(pardo_act_timer)
#ifdef VERY_DETAILED_TIMERS               
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_tserver_timer)
               call timer_start(current_instr_mpi_timer)
               call timer_start (current_instr_mpino_timer)
#endif               
               call exec_thread_server(0)
#ifdef VERY_DETAILED_TIMERS               
               call update_timer (current_instr_mpino_timer)
               call update_timer(current_instr_mpi_timer)
               if (pardo_block_wait_timer .ne. 0)
     *            call update_timer(pardo_tserver_timer)
#endif
               if (pardo_block_wait_timer .ne. 0)
     *            call timer_start(pardo_act_timer)

            endif
         endif
      enddo
 
      print *,'Task ',me,' line ',current_line,
     *  ' Cannot allocate block for array ',array,' stack ',
     *   stack
      call array_block_summary(array_table, narray_table)
      call dump_block_ids()
      call abort_job()
#ifdef DETAILED_TIMERS
      call update_timer(current_instr_allocate_timer)
#endif      
      call timer_start(current_instr_timer)
      call resume_timer(current_instr_unit_timer)
      return
      end

      integer function allocate_block_light(array, array_block, size,
     *                       array_table, narray_table,
     *                       index_table, nindex_table, 
     *                       block_map_table)
c-------------------------------------------------------------------------
c     Finds a free block, allocates it to block "array_block" of "array".
c     The block index is returned in the return code if 
c     successful, otherwise a negative value is returned.
c
c     This routine does not go through the entire allocation algorithm,
c     it may be used when an instruction does not requre the block to 
c     be allocated to run.
c-------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'timerz.h'

      integer array, array_block, size, ierr
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer i
      integer k, max_iterations, kscrub, scrub_iterations
      integer blkndx
      integer stack, istack
#ifdef DETAILED_TIMERS
      call timer_start(current_instr_allocate_timer)
#endif      
      call update_timer(current_instr_timer)
       call pause_timer(current_instr_unit_timer)
      
      allocate_block_light = -1

      if (array_block .lt. 1) then
         print *,'Error in allocate_block: Invalid block number ',
     *           array_block,
     *           ' for array ',array
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Find the smallest stack on which this block will fit.
c--------------------------------------------------------------------------

      do i = 1, nblkmgr_stacks
         if (size .le. stack_datasize(i)) then
            istack = i
            go to 100
         endif
      enddo

      print *,'Error: array, block ',array,array_block,
     *   ' will not fit on any stack.  Size = ',size
      call array_block_summary(array_table, narray_table)
      call dump_block_ids()
      call abort_job()
  100 continue

c--------------------------------------------------------------------------
c   Pop a block off one of the free stacks.  We use the smallest stack
c   on which we can find a suitable block.
c--------------------------------------------------------------------------

       do stack = istack, nblkmgr_stacks     
          call pop_free_stack(stack, blkndx)
c          print *,'TASK ',me,' ALLOC: stack , blkndx ',stack,blkndx
          if (blkndx .gt. 0) go to 200 

c---------------------------------------------------------------------------
c   Try to scrub a block from the current stack.
c---------------------------------------------------------------------------


               if (pardo_block_wait_timer .ne. 0)
     *           call update_timer(pardo_act_timer)
#ifdef VERY_DETAILED_TIMERS               
               if (pardo_block_wait_timer .ne. 0)
     *           call timer_start(pardo_tserver_timer)
             call timer_start(current_instr_mpi_timer)
             call timer_start (current_instr_mpino_timer)
#endif               
             call exec_thread_server(0)
#ifdef VERY_DETAILED_TIMERS               
             call update_timer (current_instr_mpino_timer)
             call update_timer(current_instr_mpi_timer)
               if (pardo_block_wait_timer .ne. 0)
     *           call update_timer(pardo_tserver_timer)
#endif          
               if (pardo_block_wait_timer .ne. 0)
     *           call timer_start(pardo_act_timer)

          call scrub_from_stack(stack, array_table,
     *                     narray_table, index_table, nindex_table,
     *                     block_map_table, ierr)
c          print *,'TASK ',me,' ALLOC AFTER SCRUB ierr ',ierr
          if (ierr .eq. 0) then
             blkndx = ierr 
             call pop_free_stack(stack,blkndx)
c             print *,'TASK ',me,' ALLOC AFTER POP: stack, blkndx ',
c     *          stack,blkndx 
             go to 200
          endif
      enddo    ! stack

c---------------------------------------------------------------------------
c   Couldn't get a block off any of the free stacks.  Return without 
c   allocating the block.
c---------------------------------------------------------------------------

      allocate_block_light = -1
c      print *,'TASK ',me,' ALLOC_LIGHT RETURN -1'
#ifdef DETAILED_TIMERS
      call update_timer(current_instr_allocate_timer)
#endif      
      call timer_start(current_instr_timer)
      call resume_timer(current_instr_unit_timer)
      return
            
  200 continue 

c---------------------------------------------------------------------------
c   We got a block.  Set it up for use.
c---------------------------------------------------------------------------

      i = blkndx

c--------------------------------------------------------------------------
c   Set up the newly allocated block.
c--------------------------------------------------------------------------

      call put_blk_header(array, i,c_array_handle)
      call put_blk_header(array_block,i,c_array_block) 
      call put_blk_header(mpi_request_null,i,c_block_request)
      call put_blk_header(block_busy_flag,i,c_block_flags)
      call put_blk_header(size,i,c_block_size)   
      call put_blk_header(0,i,c_block_list_ptr)
      allocate_block_light = i 

      call set_block_id(array, array_block, stack, i)
      call put_blk_in_use(i)
c      print *,'TASK ',me,' ALLOC LIGHT SUCCEEDED: RETURN ',i  
#ifdef DETAILED_TIMERS
      call update_timer(current_instr_allocate_timer)
#endif
      call timer_start(current_instr_timer)
      call resume_timer(current_instr_unit_timer)
      return 
      end

      integer function allocate_scratch_block(base, index, handle,
     *                         array_table, narray_table, 
     *                         index_table, nindex_table, 
     *                         block_map_table)
c-------------------------------------------------------------------------
c     Finds a free block, allocates it as a scratch block.
c     The index of the scratch area relative to "base" is returned along 
c     with a zero return code if 
c     successful, otherwise a non-zero value is returned.
c-------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'machine_types.h'

      integer narray_table
      integer nindex_table
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer block_map_table(*)
      integer handle
      integer i, j, k, flagval
      integer size
      integer*8 index, block_addr
      integer*8 get_index_from_base
      integer*8 c_loc64, ixx
      integer maxblocksize 
      integer stack, data
      integer kscrub, ierr
      integer scrub_iterations
      parameter (scrub_iterations = 100)

      double precision base(1)

      allocate_scratch_block = 1

      if (.not. blkmgr_init_flag) then
         print *,'Error: blkmgr has not been initialized.'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Find the next available block.
c   Scratch blocks are always allocated off the largest (blocksize) stack.
c---------------------------------------------------------------------------

      maxblocksize = stack_blocksize(1)
      stack = 1
      do i = 2, nblkmgr_stacks
         if (stack_blocksize(i) .gt. maxblocksize) then
            maxblocksize = stack_blocksize(i)
            stack = i
         endif
      enddo

      call pop_free_stack(stack, handle)  
      if (handle .le. 0) then
         do kscrub = 1, scrub_iterations
            call scrub_from_stack(stack, array_table,
     *                  narray_table, index_table, nindex_table,
     *                  block_map_table, ierr)
            if (ierr .ne. 0) then

c-------------------------------------------------------------------------
c   We failed to scrub a block.  Try to reclaim a persistent block that
c   lives on this stack.
c-------------------------------------------------------------------------

               call reclaim_persistent_block_from_stack(stack,
     *           array_table,narray_table, index_table, nindex_table,
     *           block_map_table, ierr)
            endif

            if (ierr .eq. 0) then
               call pop_free_stack(stack,handle)
               if (handle .gt. 0) go to 200
            endif
         enddo      ! kscrub_iterations

         print *,'Error: Unable to allocate a scratch block, line ',
     *       current_line,' stack, handle ',stack, handle
         call abort_job()
      endif

  200 continue

c---------------------------------------------------------------------------
c   Turn on the block_scratch_flag
c---------------------------------------------------------------------------

      i = handle
      call put_blk_header(mpi_request_null,i,c_block_request)
      call get_blk_header(data, i,c_block_flags)
      flagval = or(data, block_scratch_flag)
      call put_blk_header(flagval,i,c_block_flags)

c---------------------------------------------------------------------------
c   Determine the index to return.
c---------------------------------------------------------------------------
      
      call get_blk_addr(block_addr, i)
      index = get_index_from_base(block_addr, base, 2) 
 
      allocate_scratch_block = 0
      return
      end

      subroutine free_scratch_block(handle)
c-------------------------------------------------------------------------
c   Releases the scratch block whose handle is "handle".
c-------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer i, stack, handle, flagval
      integer flag

c--------------------------------------------------------------------------
c   Determine the stack for this block.
c--------------------------------------------------------------------------

      stack = nblkmgr_stacks
      do i = 1, nblkmgr_stacks-1
         if (handle .ge. stack_start(i) .and. 
     *       handle .lt. stack_start(i+1)) stack = i
      enddo

c---------------------------------------------------------------------------
c   Make sure this is actually a scratch block.
c---------------------------------------------------------------------------

      call get_blk_header(flag, handle,c_block_flags)
      flagval =  and(flag, block_scratch_flag)
      if (flagval .eq. 0) then
         print *,'Error: Attempt to release scratch block ',handle
         print *,'The block is not a scratch block. flags = ',
     *        flag
         call abort_job()
      endif

      call put_blk_header(xor(flag,block_scratch_flag),
     *                    handle,c_block_flags)
      
      call push_free_stack(stack, handle)
      return
      end

      integer function get_stack_index(blkndx)
c---------------------------------------------------------------------------
c   Determines the stack index of a given block.
c---------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer blkndx

      integer i, stack

      stack = nblkmgr_stacks
      do i = 1, nblkmgr_stacks-1
         if (blkndx .ge. stack_start(i)) stack = i
      enddo

      get_stack_index = stack
      return
      end

      subroutine server_monitor_write_log(blkndx, optype, server)
c--------------------------------------------------------------------------
c   Write a record to the server monitor logfile.
c   These files are saved for later analysis.
c--------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'server_monitor.h' 
      include 'parallel_info.h'
      include 'trace.h'

      integer blkndx, server
      character*(*) optype
      integer nw, ierr
      integer flagval
      integer array, block
      
      character*24 timestamp, get_timestamp

      if (.not. server_monitor_on) return

c--------------------------------------------------------------------------
c   For "request" types, make sure the block was actually used in a request.
c--------------------------------------------------------------------------

      if (optype .eq. 'r') then
         call get_blk_header(flagval, blkndx, c_block_flags)
         if (and(flagval, block_request_flag) .eq. 0)
     *       return

c---------------------------------------------------------------------------
c   Turn off the request flag saved by blkmgr.
c---------------------------------------------------------------------------

         call get_blk_header(array,blkndx,c_array_handle)
         call get_blk_header(block, blkndx,c_array_block)
         call set_block_request_flag(array, block,
     *                               blkndx, 0)
      endif

      timestamp = get_timestamp()
      call get_blk_header(nw, blkndx, c_block_size)
      write (server_logunit,*) timestamp,me,server,nw,optype,
     *                         current_line
      return
      end

      subroutine get_block_indices(blkndx, ind)
c--------------------------------------------------------------------------
c   Returns the indices for block "blkndx" in the "ind" array.
c--------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer blkndx
      integer ind(*)

      integer i, nind

      call get_blk_header(nind, blkndx, c_block_nindex)
      do i = 1, nind
         call get_blk_header(ind(i), blkndx, c_block_indices+i-1)
      enddo

      return
      end

      subroutine get_block_segments(blkndx, seg)
c--------------------------------------------------------------------------
c   Returns the segments for block "blkndx" in the "seg" array.
c--------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      integer blkndx
      integer seg(*)
      integer i, nind

      call get_blk_header(nind, blkndx, c_block_nindex)
      do i = 1, nind
         call get_blk_header(seg(i),blkndx, c_block_segments+i-1)
      enddo

      return
      end

      subroutine free_all_blocks()
c----------------------------------------------------------------------------
c  Clears all remaining MPI requests from the blkmgr data blocks.
c----------------------------------------------------------------------------
      implicit none
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'parallel_info.h'
      include 'mpif.h'
      integer i, ierr, request, array
      integer status(MPI_STATUS_SIZE)
      logical flag

#ifndef ALTIX
      return
#endif

      do i = 1, blkmgr_blocks
         call get_blk_header(request, i, c_block_request)
         if (request .ne. MPI_REQUEST_NULL) then
            call mpi_request_free(request, ierr)
         endif
      enddo

      return
      end

      subroutine subindex_seg_match(index, index_table,
     *                  nindex_table, segment_table,
     *                  nsegment_table, seg)
c--------------------------------------------------------------------------
c   Determines the superindex segment that contains the current segment 
c   of the subindex.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      integer index
      integer nindex_table, nsegment_table, seg
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)

      integer superindex, r1, r2, r1sub, r2sub
      integer i, current_seg
 
c--------------------------------------------------------------------------
c   Look up the superindex and beginning and ending ranges of the subindex 
c   segment.
c--------------------------------------------------------------------------

      superindex = index_table(c_subindex_ptr, index)
      current_seg = index_table(c_current_seg, index)
      call get_index_segment(index, current_seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, r1sub, r2sub) 

c--------------------------------------------------------------------------
c   Find the superindex segment containing r1sub, r2sub.
c--------------------------------------------------------------------------

      do i = 1, nsegment_table
         if (segment_table(c_index,i) .eq. superindex) then
            r1 = segment_table(c_range1,i)
            r2 = segment_table(c_range2,i)
            if (r1 .le. r1sub .and. r2 .ge. r2sub) then
               seg = segment_table(c_segment,i)
               return
            endif 
         endif
      enddo

      print *,'Error: subindex_seg_match cannot find matching segment'
      print *,'index, superindex, r1sub, r2sub ',
     *      index, superindex, r1sub, r2sub
      call abort_job() 
      return
      end 

      subroutine count_scrubbable(scrub_stack, array_table,
     *                        narray_table, index_table, nindex_table, 
     *                        block_map_table)
c----------------------------------------------------------------------------
c   Attempts to scrub ALL blocks from a given stack.
c   Searches all blocks marked as "scrubbable".
c   If a block has been marked to be scrubbed, and if the block is on the 
c   specified stack, the communication request
c   is checked.  If the request has been completed, the block_busy_flag
c   is cleared, indicating that the block may be reclaimed for later use.
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'

      integer scrub_stack
      integer narray_table
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer ierr, mpi_ierr

      integer array, block, stack
      integer flag, comp_flag
      integer flagval
      integer request
      integer next, ptr
      integer status(MPI_STATUS_SIZE)
      logical complete
      integer i, n_tot, n_scrubbable 

      n_scrubbable = 0 
      n_tot = 0 

      ierr = 1
      ptr = stack_start(scrub_stack-1)  
      if (ptr .eq. 0) return

  100 continue
         n_tot = n_tot + 1 

         call get_blk_header(flagval, ptr,c_block_flags)
         flag = and(flagval,  block_scrub_flag)
         call get_blk_header(next, ptr,c_comm_list_ptr)

         if (flag .ne. 0) then

c---------------------------------------------------------------------------
c   Check the size requirement.
c---------------------------------------------------------------------------

            call get_blk_header(stack, ptr,c_block_stack)
            if (stack .eq. scrub_stack) then
               call put_blk_header(MPI_REQUEST_NULL,ptr,c_block_request)
               call get_blk_header(array, ptr, c_array_handle)
               call get_blk_header(block, ptr, c_array_block)
               call blkmgr_remove_block_from_list(comm_list_head,
     *             comm_list_tail, ptr, c_comm_list_ptr)

               if (server_monitor_on) 
     *            call server_monitor_write_log(ptr, 'r', 
     *                            status(mpi_source))

               call free_block(array, block, ptr, array_table,
     *                narray_table, index_table, nindex_table,
     *                block_map_table)
               n_scrubbable = n_scrubbable + 1 
           endif
         endif

      if (n_tot .lt. stack_size(scrub_stack)) then
         ptr = ptr - 1  
         go to 100
      endif 

      if (n_scrubbable .gt. 0) 
     *write(6,*) ' STACK NSCRUBBABLE :', scrub_stack, n_scrubbable 

c      print *,'Task ',me,'   SCRUB: Returning ierr ',ierr
      return
      end


      subroutine reclaim_persistent_blocks_from_stack(mystack, 
     *           array_table,narray_table, index_table, nindex_table,
     *           block_map_table)
c---------------------------------------------------------------------------
c   Finds all blocks marked as "persistent" on a given stack, and 
c   frees all block.  This makes all blocks available for further use.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_monitor.h'

      integer narray_table, ierr, mpi_ierr
      integer array_table(larray_table_entry, narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry, nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer mystack, flagval, request
      integer i, old_array, block, stack, ptr, next
      integer n_persistent, n_removed, n_tot  
      integer status(MPI_STATUS_SIZE)
      logical persistent, flag
      
c-------------------------------------------------------------------------
c   Find a persistent block that is not busy.
c-------------------------------------------------------------------------
      n_persistent = 0 
      n_removed    = 0 
      n_tot = 0 

      ierr = -1
      if (persistent_list_head .eq. 0) return
      
      next = stack_start(mystack-1)  
  100 continue
      n_tot = n_tot + 1 
      ptr = next
      i   = next 
      call get_blk_header(next, ptr, c_persistent_ptr)
      call get_blk_header(stack, i,c_block_stack)

      call get_blk_header(flag, i,c_block_flags)
      persistent = and(flag, block_persistence_flag)
      if (persistent .eq. 0) then 
         if (n_tot .lt. stack_size(mystack)) then
            ptr = ptr - 1  
            go to 100
         else 
            go to 200 
         endif 
      endif 

      n_persistent = n_persistent + 1 

      if (stack .ne. mystack) then
         return 
         return   ! end of list
      endif

c--------------------------------------------------------------------------
c   We must check the block_busy_flag and block_computed_flag.  If either 
c   one is non-zero, we cannot reclaim the block.
c--------------------------------------------------------------------------

      call get_blk_header(flagval, i,c_block_flags) 
      if (and(flagval, block_busy_flag) 
     *                                     .eq. 0 .and.
     *    and(flagval, block_computed_flag) 
     *                                     .eq. 0) then 

c--------------------------------------------------------------------------
c   This is the oldest such block in the list, since the list is a FIFO.
c   Make sure the block is not still engaged in communication.
c--------------------------------------------------------------------------

         call get_blk_header(request, i,c_block_request)
         if (request .ne. mpi_request_null) then

c--------------------------------------------------------------------------
c   Test the block to see if it has finished its communication.
c   If it has finished, remove it from the comm_list.
c--------------------------------------------------------------------------

            call mpi_test(request,
     *                         flag, status, mpi_ierr)
            if (flag) then
               call put_blk_header(MPI_REQUEST_NULL, i,c_block_request)
               call blkmgr_remove_block_from_list(comm_list_head,
     *                 comm_list_tail, i, c_comm_list_ptr)
               if (server_monitor_on)
     *            call server_monitor_write_log(ptr, 'r',
     *                                status(mpi_source))
            endif
         else

c--------------------------------------------------------------------------
c   The block is not found to be engaged in communication.
c   Thus it may be safely reclaimed.
c--------------------------------------------------------------------------

            flag = .true.
         endif

c-------------------------------------------------------------------------
c   Free the block. The free_block subroutine will also remove the 
c   block from the persistent_block list.
c-------------------------------------------------------------------------

         if (flag) then
            call get_blk_header(old_array, i,c_array_handle)
            call get_blk_header(block, i,c_array_block)  
            call free_block(old_array, block,
     *                i, array_table, narray_table,
     *                index_table, nindex_table, block_map_table)
            n_removed = n_removed + 1  
         endif
      endif

c---------------------------------------------------------------------------
c   Point to the next block in the list and check for a block to reclaim.
c---------------------------------------------------------------------------

      if (n_tot .lt. stack_size(mystack)) then
         ptr = ptr - 1  
         go to 100
      endif 

200   continue 
      if (n_persistent .gt. 0) 
     *write(6,*) ' There were ', n_persistent, ' persistent blocks and'
     *            , n_removed,
     *           'have been removed from
     *             stack ', mystack   

      return
      end

      SUBROUTINE FILL_DROP_MOS(NIRREP, IUHF, NOCC_EXPND, NVRT_EXPND,
     &                         NBAS_FULL, NOCCO_EXPND, NVRTO_EXPND)
C
C Recreate the new population vectors that correspond to the full space
C for dropmo calculations. Ajith Perera, 07/2005.
C
      IMPLICIT INTEGER (A-Z)
      INTEGER POP, VRT
      DIMENSION NDRPOP(8), NDRVRT(8), NOCC_EXPND(8,2),
     &          NVRT_EXPND(8,2), NOCCO_EXPND(2), NVRTO_EXPND(2)

      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF(4)

      CALL GETREC(20, 'JOBARC', 'NDROPPOP', NIRREP, NDRPOP)
      CALL GETREC(20, 'JOBARC', 'NDROPVRT', NIRREP, NDRVRT)

           NBAS_FULL = 0
      NOCCO_EXPND(1) = 0
      NVRTO_EXPND(1) = 0
      NOCCO_EXPND(2) = 0
      NVRTO_EXPND(2) = 0
      DO IRREP = 1, NIRREP
         NOCC_EXPND(IRREP,1) = POP(IRREP,1) + NDRPOP(IRREP)
         NVRT_EXPND(IRREP,1) = VRT(IRREP,1) + NDRVRT(IRREP)
     &
         NBAS_FULL = NBAS_FULL + NOCC_EXPND(IRREP,1)
     &                         + NVRT_EXPND(IRREP,1)
         NOCCO_EXPND(1) = NOCCO_EXPND(1) + NOCC_EXPND(IRREP,1)
         NVRTO_EXPND(1) = NVRTO_EXPND(1) + NVRT_EXPND(IRREP,1)
         IF (IUHF.GT.0) THEN
            NOCC_EXPND(IRREP,2) = POP(IRREP,2) + NDRPOP(IRREP)
            NVRT_EXPND(IRREP,2) = VRT(IRREP,2) + NDRVRT(IRREP)
         ELSE
            NOCC_EXPND(IRREP,2) = NOCC_EXPND(IRREP,1)
            NVRT_EXPND(IRREP,2) = NVRT_EXPND(IRREP,1)
         END IF
      END DO

C At this point we assume that number of both alpha and beta MOs
C are the same. This is assumed throughout the code, but Ken (Andrew's)
C frozen natural orbitals can break this assumption.

      NOCCO_EXPND(2) = NOCCO_EXPND(1)
      NVRTO_EXPND(2) = NVRTO_EXPND(1)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine decode_fmo_params()
      implicit none
      include 'fmo.h'
      integer max_table, ntable
      parameter (max_table = 1000)

      character*80 table(max_table)
      common /parameter_table/ntable, table

      integer i, j, k, ii, ifmo, n, nvals, str_trimlen

c----------------------------------------------------------------------------
c   Search parameter table for the FMO keyword.
c----------------------------------------------------------------------------
  
      ifmo = 1
      nfmo = 0

      do i = 1, ntable
         if (table(i)(1:3) .eq. 'FMO') then

c----------------------------------------------------------------------------
c   Beginning of FMO array.
c----------------------------------------------------------------------------

            k = i
            n = str_trimlen(table(i))
            
c---------------------------------------------------------------------------
c   Find the '='.
c---------------------------------------------------------------------------

            do j = 1, len(table(i))
               if (table(i)(j:j) .eq. '=') then

c---------------------------------------------------------------------------
c   Decode the 1st FMO line.
c---------------------------------------------------------------------------

                  call c_decode_csv_integer(table(i)(j+1:n) // char(0),
     *                       fmo(ifmo), nvals)
                  go to 100
               endif
            enddo  

            print *,'Missing "=" on FMO parameter.'
            call abort_job()

  100       continue 
            if (nvals .gt. 0) then
               ifmo = ifmo + nvals
               nfmo = nfmo + nvals

c----------------------------------------------------------------------------
c   Decode remaining lines until a blank line is encountered (or end 
c   of table).    
c----------------------------------------------------------------------------

               do ii = k+1,ntable
                  n = str_trimlen(table(ii))
                  if (n .gt. 0) then
                     call c_decode_csv_integer(table(ii)(1:n)//char(0),
     *                       fmo(ifmo), nvals)
                     if (nvals .gt. 0) then
                        ifmo = ifmo + nvals
                        nfmo = nfmo + nvals
                     else
                        go to 200
                     endif 
                  else
                     go to 200
                  endif    ! n .gt. 0
               enddo    ! do ii
            endif    ! nvals .gt. 0   

         endif
      enddo
 
  200 continue
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine contract_oed_2derv_numint(type, density, z,
     *                       da1, da2, db1, db2, hess)
c---------------------------------------------------------------------------
c  Computes the set of OED derivative integrals matching "type" and 
c  and contracts them with density block (da1:da2, db1:db2).
c
c   type = 
c          2 --> KIN integrals
c          3 --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'hess.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer type
      integer da1, da2, db1, db2
      double precision density(da1:da2, db1:db2)
      double precision z(da1:da2, db1:db2)
      double precision hess(3*ncenters,3*ncenters)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif

      integer i, ix, m, n, nfirst, nints, nalpha, ncoeff, iatom,jatom
      integer component,icomponent,jcomponent,ihess,jhess,newatoms  
      integer a, b, a1,a2,b1,b2,lastao,ncsum,igrad
      integer m1, m2, n1, n2
      integer der1x, der1y, der1z
      integer der2x, der2y, der2z
      integer dercx, dercy, dercz
      integer ixderc
      integer ind(2)
      integer flopcount
      logical spherical
      logical*8 l8true, l8spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *       pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2, x, y, fact
      double precision x1p,y1p,z1p,x2p,y2p,z2p, eps 

      if (type .lt. 2 .or. type .gt. 3) then
         print *,'Error: Invalid type in contract_oed_numint'
         print *,'type = ',type
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      spherical = (ispherical .eq. 1)
      l8spherical = spherical
      l8true = .true.
      lastao    = end_nfps(nshells)

      ind(1) = 1
      ind(2) = 2

      if (intpkg .ne. flocke_package) then
         print *,'Error: contract_oed_derv_integrals requires ERD ',
     *           'integral package.'
         call abort_job()
      endif

c-------------------------------------------------------------------------
c   Find the shells we need to loop over for this block of density data.
c--------------------------------------------------------------------------

      call lookup_shell(end_nfps, nshells, da1, m1)
      call lookup_shell(end_nfps, nshells, da2, m2)
      call lookup_shell(end_nfps, nshells, db1, n1)
      call lookup_shell(end_nfps, nshells, db2, n2)
      
c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c-------------------------------------------------------------------------
c   Calculate the integrals over the necessary shell blocks.
c-------------------------------------------------------------------------

       do m = m1, m2
       do n = n1, n2

            ncsum = ncfps(m) + ncfps(n) 
            x1 = dbuf(icoord+3*(m-1))
            y1 = dbuf(icoord+3*(m-1)+1)
            z1 = dbuf(icoord+3*(m-1)+2)
 
            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend), 
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

c loop over derivatives on centers

         do icomponent = 1, 3  ! component is x, y, or z term of gradient
         do ix = 1, 2          ! index of desired center

c loop over perturbations 

         do jatom = 1, ncenters 
         do jcomponent = 1, 3 

c-------------------------------------------------------------------------
c   Clear the integral block.
c-------------------------------------------------------------------------

          do b = db1, db2
          do a = da1, da2
             z(a,b) = 0.
          enddo
          enddo

             der1x = 0
             der1y = 0
             der1z = 0
             der2x = 0
             der2y = 0
             der2z = 0

             ixderc = 0
             dercx  = 0
             dercy  = 0
             dercz  = 0

             if (icomponent .eq. 1) then
                if (ix .eq. 1) then
                   der1x = 1
                   if (atom(m) .eq. atom(n)) der2x = 1
                   iatom = atom(m)
                else
                   der2x = 1
                   if (atom(m) .eq. atom(n)) der1x = 1
                   iatom = atom(n)
                endif
             endif

             if (icomponent .eq. 2) then
                if (ix .eq. 1) then
                   der1y = 1
                   if (atom(m) .eq. atom(n)) der2y = 1
                   iatom = atom(m)
                else
                   der2y = 1
                   if (atom(m) .eq. atom(n)) der1y = 1
                   iatom = atom(n)
                endif
             endif

             if (icomponent .eq. 3) then
                if (ix .eq. 1) then
                   der1z = 1
                   if (atom(m) .eq. atom(n)) der2z = 1
                   iatom = atom(m)
                else
                   der2z = 1
                   if (atom(m) .eq. atom(n)) der1z = 1
                   iatom = atom(n)
                endif
             endif

               eps   = 0.0000001d0
c
c-------------------------------------------------------------------------
c
c XX integrals first.
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 1) then

                x1p = x1
                y1p = y1
                z1p = z1

                x2p = x2
                y2p = y2
                z2p = z2

                if (atom(m) .eq. jatom) then

                   x1p = x1 + eps

                endif

                if (atom(n) .eq. jatom) then

                   x2p = x2 + eps

                endif

                go to 111

             endif
c
c-------------------------------------------------------------------------
c
c YY integrals first.
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 2) then

                x1p = x1
                y1p = y1
                z1p = z1

                x2p = x2
                y2p = y2
                z2p = z2

                if (atom(m) .eq. jatom) then

                   y1p = y1 + eps

                endif

                if (atom(n) .eq. jatom) then

                   y2p = y2 + eps

                endif

                go to 111

             endif
c
c-------------------------------------------------------------------------
c
c ZZ integrals next.
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 3) then

                x1p = x1
                y1p = y1
                z1p = z1

                x2p = x2
                y2p = y2
                z2p = z2

                if (atom(m) .eq. jatom) then

                   z1p = z1 + eps

                endif

                if (atom(n) .eq. jatom) then

                   z2p = z2 + eps

                endif

                go to 111

             endif
c
c-------------------------------------------------------------------------
c
111          continue
c
c Stationary integrals.
c --------------------- 
c
               if (type .eq. 2) then
                  call oed__gener_kin_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               else if (type .eq. 3) then
                  call oed__gener_ovl_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,spherical,
     *                 .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               endif

            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

                call move_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)

             endif
c
c Perturbed integrals
c -------------------
c
               if (type .eq. 2) then
                  call oed__gener_kin_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m),ivangmom(n),x1p,y1p,z1p,x2p,y2p,z2p,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               else if (type .eq. 3) then
                  call oed__gener_ovl_derv_batch(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m),ivangmom(n),x1p,y1p,z1p,x2p,y2p,z2p,
     *                 der1x, der1y, der1z,
     *                 der2x, der2y, der2z, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,spherical,
     *                 .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
               endif

            if (nints .gt. 0) then
               a2 = end_nfps(m)
               if (m .eq. 1) then
                  a1 = 1
               else
                  a1 = end_nfps(m-1)+1
               endif

               b2 = end_nfps(n)
               if (n .eq. 1) then
                  b1 = 1
               else
                  b1 = end_nfps(n-1)+1
               endif

               fact = -1.0d0 
               call add_integrals2(z, da1,da2,db1,db2,
     *                 dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2,fact)

c--------------------------------------------------------------------------
c   Contract the density block with the block of integrals.
c--------------------------------------------------------------------------

               call cwork0222(y,
     *                        density,da1,da2,db1,db2,
     *                        da1,da2,db1,db2, ind,
     *                        z,da1,da2,db1,db2,
     *                        da1,da2,db1,db2,ind(1), ind(2),
     *                        flopcount)

c---------------------------------------------------------------------------
c   Sum into the gradient.
c---------------------------------------------------------------------------

                 ihess = (iatom-1)*3 + icomponent
                 jhess = (jatom-1)*3 + jcomponent

                 hess(jhess,ihess) = hess(jhess,ihess) + y/eps

             endif
c
         enddo ! jx
         enddo ! jcomponent
         enddo ! ix
         enddo ! icomponent

         enddo   ! n shells
         enddo   ! m shells

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine decode_cond_code(cond_str, cond_code)
c---------------------------------------------------------------------------
c   Converts from the SIAL compiler's internal string used for conditionals 
c   to the SIP runtime code for the corresponding conditional operator.
c---------------------------------------------------------------------------

      implicit none
      integer i, ncond_table, cond_code
      parameter (ncond_table = 6)

      character*2 cond_str_table(ncond_table)
      character*2 my_cond_str
      character*(*) cond_str

      cond_str_table(1) = '=='
      cond_str_table(2) = '>='
      cond_str_table(3) = '<='
      cond_str_table(4) = '> '
      cond_str_table(5) = '< '
      cond_str_table(6) = '!='
      
      my_cond_str(1:1) = cond_str(1:1)
      if (cond_str(2:2) .eq. char(0)) then
         my_cond_str(2:2) = ' '
      else
         my_cond_str(2:2) = cond_str(2:2)
      endif 

      do i = 1, ncond_table
         if (my_cond_str .eq. cond_str_table(i)) then
            cond_code = i
            return
         endif
      enddo

      print *,'No decoded value'
      return
      end
      
      
      

      SUBROUTINE NUCREP(ZNREP,IERR)
C
C DETERMINES THE INTERNUCLEAR REPULSION ENERGY.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     Maximum number of atoms currently allowed
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end


C
      IQ(I)=3*I-2
      Z=0.D0
      DO 10 I=1,NATOMS
      DO 10 J=I+1,NATOMS
       BOT=DIST(Q(IQ(I)),Q(IQ(J)))
       IF(BOT.LT.1.D-5)THEN
        IERR=1
        GOTO 10
       ELSE
        IF(IATNUM(I).NE.110.AND.IATNUM(J).NE.110)THEN
c        IGNORE GHOST ATOMS
         TOP=FLOAT(IATNUM(I)*IATNUM(J))
         Z=Z+(TOP/BOT)
        ENDIF
      ENDIF
10    CONTINUE
      ZNREP=Z
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         LOGICAL FUNCTION  NLO__ACCEPT_ATOMS_BOND_SEARCH
     +
     +                    ( NATOM,
     +                      BONDSIZE,
     +                      NHCEN,NHA,
     +                      ATHIDX,ATHVAL,
     +                      NHYB,
     +                      BOMAT,
     +                      CHOOSED,
     +                      MXCHOOSE,NCHOOSE,CHOOSE,
     +                      IVEC )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ACCEPT_ATOMS_BOND_SEARCH
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine checks, if a set of atomic indices will
C                be accepted for further bond formation search. There
C                are three resons why the present set of atomic indices
C                might be rejected:
C
C                     1) At least one of the atoms has already a
C                        complete pre-NHO set.
C
C                     2) The set contains isolated (not bonded) atoms,
C                        as judged by the simplified bond order matrix.
C
C                     3) The present particular set of atoms has
C                        already been searched for bond formation
C                        through the bond choosing.
C
C                  Input:
C
C                    NATOM        =  total # of atomic centers
C                    NHCEN        =  current # of atomic hybrid centers
C                                    to be checked for NHCEN centered
C                                    bond construction.
C                    NHA          =  total # of hybrid atoms.
C                    ATHIDX       =  contains the NHCEN atomic indices
C                                    to be tested for bond formation.
C                    ATHVAL (A)   =  # of Valence NAOs on hybrid atom A.
C                    NHYB (A)     =  current total # of pre-NHO's on
C                                    each hybrid atom A.
C                    BOMAT (A,B)  =  simplified bond order matrix
C                                    containing info if atoms A and B
C                                    are considered to be bonded or not.
C                    CHOOSED      =  is true, if at least one NHCEN
C                                    atomic indicex combination has
C                                    been chosen for bond search
C                    MXCHOOSE     =  maximum # of bonds selected to
C                                    be chosen. The maximum is build
C                                    from all # of chosen bonds for all
C                                    bondsizes.
C                    NCHOOSE      =  # of bonds to be chosen for bonds
C                                    of size NHCEN. Four cases:
C                                    1) = 9999 => skip search for bonds
C                                       of size NHCEN.
C                                    2) = 0 => complete search for all
C                                       possible bonds of size NHCEN
C                                       will be performed.
C                                    3) = -n => only n bonds of size
C                                       NHCEN will be searched between
C                                       those atomic indices as
C                                       provided by the CHOOSE array.
C                                    4) = +n => same as case 3) but
C                                       followed by a complete search
C                                       for all possible remaining
C                                       bonds of size NHCEN.
C                                    Priority level: 1) > 3) > 4) > 2).
C                    CHOOSE (I,N) =  contains the I-th atomic index of
C                                    the N-th chosen bond of size NHCEN.
C                                    The order of the atomic indices
C                                    is arbitrary.
C                    IVEC         =  int scratch array of vector type
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ABSOLUT
         LOGICAL     ACCEPT
         LOGICAL     BONDED
         LOGICAL     CHOOSED
         LOGICAL     EQUAL
         LOGICAL     INCRESE

         INTEGER     ATOMI,ATOMJ
         INTEGER     BONDSIZE
         INTEGER     I,J,N
         INTEGER     MXCHOOSE
         INTEGER     NATOM
         INTEGER     NCHOOSE
         INTEGER     NHCEN
         INTEGER     NHA

         INTEGER     ATHIDX  (1:NHCEN)
         INTEGER     ATHVAL  (1:NHA  )
         INTEGER     IVEC    (1:2*NHCEN)
         INTEGER     NHYB    (1:NHA  )

         INTEGER     CHOOSE  (1:BONDSIZE,1:MXCHOOSE)

         DOUBLE PRECISION  ONE

         DOUBLE PRECISION  BOMAT (1:NATOM,1:NATOM)

         DATA  ONE  /1.D0/
C
C
C------------------------------------------------------------------------
C
C
C             ...check for complete pre-NHO sets on all atoms
C                involved.
C
C
         ACCEPT = .TRUE.

         DO I = 1,NHCEN
            ATOMI = ATHIDX (I)
            IF (NHYB (ATOMI) .EQ. ATHVAL (ATOMI)) THEN
                ACCEPT = .FALSE.
            END IF
         END DO
C
C
C             ...check for isolated nonbonded atoms.
C
C
         IF (ACCEPT) THEN
             DO J = 1,NHCEN
                ATOMJ = ATHIDX (J)
                BONDED = .FALSE.
                DO I = 1,NHCEN
                   ATOMI = ATHIDX (I)
                   IF (BOMAT (ATOMI,ATOMJ) .EQ. ONE) THEN
                       BONDED = .TRUE.
                   END IF
                END DO
                IF (.NOT.BONDED) THEN
                    ACCEPT = .FALSE.
                END IF
             END DO
         END IF
C
C
C             ...check for already choosen atom combinations.
C
C
         IF (ACCEPT) THEN
             IF (CHOOSED) THEN

                 ABSOLUT = .FALSE.
                 INCRESE = .TRUE.

                 CALL  NLO__SORT_INT_VECTOR_ELEMENTS
     +
     +                      ( NHCEN,NHCEN,
     +                        1,NHCEN,
     +                        ABSOLUT,INCRESE,
     +                        0,
     +                        ATHIDX,
     +
     +                                 IVEC )
     +
     +
                 N = IABS (NCHOOSE)

                 DO I = 1,N

                    CALL  NLO__SORT_INT_VECTOR_ELEMENTS
     +
     +                         ( NHCEN,NHCEN,
     +                           1,NHCEN,
     +                           ABSOLUT,INCRESE,
     +                           0,
     +                           CHOOSE (1,I),
     +
     +                                    IVEC (NHCEN+1))
     +
     +
                    EQUAL = .TRUE.
                    DO J = 1,NHCEN
                       ATOMI = ATHIDX(IVEC (J))
                       ATOMJ = CHOOSE(IVEC (NHCEN+J),I)
                       IF (ATOMI.NE.ATOMJ) THEN
                           EQUAL = .FALSE.
                       END IF
                    END DO

                    IF (EQUAL) THEN
                        NLO__ACCEPT_ATOMS_BOND_SEARCH = .FALSE.
                        RETURN
                    END IF

                 END DO

             END IF
         END IF

         NLO__ACCEPT_ATOMS_BOND_SEARCH = ACCEPT
C
C
C             ...ready!
C
C
         RETURN
         END

c This reads a string value.  If it isn't in the namelist,
c it defaults to the value passed in.
c
c Variables which have default values may safely be passed in both
c as the default value and as the value read in.

      subroutine nl_str(key,def,var)
      implicit none

      character*(*) key,def,var

#include "namelist.com"
#include "callstack.com"

      character*(nllinelen) str1,str2
      logical nl_key,present
      integer strlen

      callstack_prev=callstack_curr
      callstack_curr='NL_STR'

      present=nl_key(key,var)
      if (.not.present) var=def

      if (prt_nl) then
         if (strlen(var).le.20) then
            str1=var
         else
            str1=var(1:18)//' $'
         end if
         if (strlen(def).le.20) then
            str2=def
         else
            str2=def(1:18)//' $'
         end if
         if (var(1:strlen(var)).eq.def(1:strlen(def))) then
            write(*,900) key,'string',str1
  900       format(a20,2x,a10,2x,a20)
         else
            write(*,910) key,'string',str1,str2
  910       format(a20,2x,a10,2x,a20,2x,a20)
         end if
      end if

      callstack_curr=callstack_prev
      return
c     end subroutine nl_str
      end

c This reads a string value.  If it isn't in the namelist,
c it defaults to the value passed in.
c
c Variables which have default values may safely be passed in both
c as the default value and as the value read in.

      subroutine nl_str(key,def,var)
      implicit none

      character*(*) key,def,var



c This common block contains information about a namelist which is being
c parsed.

c   nlmaxline   : the maximum number of lines which can be in the namelist
c   nllinelen   : the maximum length of each line

c   nlnumline   : the number of lines in the namelist (blank lines are
c                 removed)
c   nltext      : the text in the namelist
c   prt_nl      : a logical which is read in from the namelist to see
c                 if the values read in are printed or not
c
      integer nlmaxline, nllinelen
      parameter(nlmaxline=64)
      parameter(nllinelen=132)

      character*(nllinelen) nltext(nlmaxline)
      integer nlnumline
      logical prt_nl

      common /namelistc/ nltext
      common /namelist/  nlnumline
      common /namelistl/ prt_nl
      save /namelist/
      save /namelistc/
      save /namelistl/




c This contains the global string for identifying the current subroutine
c or function (provided the programmer set it).  cf. tools/callstack.F
c BE GOOD AND RESET CURR ON EXIT!

      character*64                callstack_curr,callstack_prev
      common /callstack_curr_com/ callstack_curr,callstack_prev
      save   /callstack_curr_com/



      character*(nllinelen) str1,str2
      logical nl_key,present
      integer strlen

      callstack_prev=callstack_curr
      callstack_curr='NL_STR'

      present=nl_key(key,var)
      if (.not.present) var=def

      if (prt_nl) then
         if (strlen(var).le.20) then
            str1=var
         else
            str1=var(1:18)//' $'
         end if
         if (strlen(def).le.20) then
            str2=def
         else
            str2=def(1:18)//' $'
         end if
         if (var(1:strlen(var)).eq.def(1:strlen(def))) then
            write(*,900) key,'string',str1
  900       format(a20,2x,a10,2x,a20)
         else
            write(*,910) key,'string',str1,str2
  910       format(a20,2x,a10,2x,a20,2x,a20)
         end if
      end if

      callstack_curr=callstack_prev
      return
c     end subroutine nl_str
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine apply_den1(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Each element of the array source(i,j) is divided by the 
c   corresponding element of the array target(i,j).  
c   Format of command is :
c
c   execute apply_den2 source target
c
c   There is no resriction on the type of array of source or target. 
c
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer*8 indblk, get_block_index
      integer block, blkndx, seg
      integer find_current_block

      integer i, j, ii, source, target, company, comm, ierr
      integer source_type, target_type
      integer nindex_source, nindex_target, stack
      integer*8 isource, itarget 
      integer n(mx_array_index),ind(mx_array_index) 
      integer sval1(mx_array_index),sval2(mx_array_index)  
      integer tval1(mx_array_index),tval2(mx_array_index)  
      integer msg(len_sip_server_message)
      integer status(MPI_STATUS_SIZE) 

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif


c--------------------------------------------------------------------------
c   Locate the data for both arrays.  
c--------------------------------------------------------------------------

      target = op(c_op1_array)
      source = op(c_result_array)

c---------------------------------------------------------------------------
c   Look up source's address.
c---------------------------------------------------------------------------

      block  = find_current_block(source, array_table(1,source),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,source)
      isource = get_block_index(source, block, stack, blkndx, x, .true.) 

c---------------------------------------------------------------------------
c   Look up target's address.
c---------------------------------------------------------------------------

      block  = find_current_block(target, array_table(1,target),
     *                            index_table, nindex_table,
     *                            segment_table, nsegment_table,
     *                            block_map_table, blkndx)
      stack = array_table(c_array_stack,target)
      itarget = get_block_index(target, block, stack, blkndx, x, .true.) 

c--------------------------------------------------------------------------
c   Check the dimensions of both arrays both arrays.  
c--------------------------------------------------------------------------
      
      source_type = array_table(c_array_type, source)
      target_type = array_table(c_array_type, target)

      nindex_source = array_table(c_nindex, source)
      nindex_target = array_table(c_nindex, target)

      if (nindex_source .ne. nindex_target) then
         print *,'Error: Both arrays in apply_den2 must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex_source,' indices.'
         print *,'Second array has ',nindex_target,' indices.'
         call abort_job()
      endif

c      if (nindex_source .ne. 2) then 
c         print *,'Arrays in apply_den2 must have 2 indices' 
c         call abort_job()
c      endif

c-------------------------------------------------------------------------
c   Get segment ranges of the array source.
c-------------------------------------------------------------------------

      do i = 1, nindex_source 
         ind(i) = array_table(c_index_array1+i-1,source)
         n(i)   = index_table(c_index_size, ind(i))  ! pick up length of index 
         seg    = index_table(c_current_seg,ind(i)) 

         call get_index_segment(ind(i), seg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, sval1(i), sval2(i))

      enddo

c-------------------------------------------------------------------------
c   Get segment ranges of the array target.
c-------------------------------------------------------------------------

      do i = 1, nindex_target 
         ind(i) = array_table(c_index_array1+i-1,target)
         n(i)   = index_table(c_index_size, ind(i))  ! pick up length of index 
         seg    = index_table(c_current_seg,ind(i)) 

         call get_index_segment(ind(i), seg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, tval1(i), tval2(i))

      enddo

      call do_div1(x(isource),x(itarget),sval1(1),sval2(1),tval1(1),
     & tval2(1) )

      return
      end

      subroutine do_div1(x,y,
     *                   a1,a2,i1,i2)
      implicit none 
      include 'interpreter.h'

      integer a1,a2,b1,b2
      integer i1,i2,j1,j2
      double precision x(a1:a2)
      double precision y(i1:i2)

      integer i,j,k,l 
      double precision val, div

      do i = i1, i2 
         div = y(i) 
c        if (dabs(div) .gt. 1.0d-5) then 
            val = x(i)/div   
            x(i) = val 
c        endif 
      enddo 

      return 
      end 

      SUBROUTINE A2RD_BASIS_4INTGRT(IUATMS,NATOMS,ITFCT,LNP1,LNPO,
     &                              NTANGM,IMEMB,NUC,NFCT,NUFCT,
     &                              NANGMOM,NUMOM,ATMNAM,COORD,NPOP,
     &                              NAOATM,NAOUATM,NANGMOMSHL,
     &                              NCONFUNSHL,NPRIMFUNSHL,IPRINT,
     &                              ISHL,NMBERSHL,NANGMOMTSHL,
     &                              NCONFUNTSHL,NOFFSETPRM,
     &                              NOFFSETCON,NOFFSETSHL,ISHLOFF,
     &                              MAXSHELL,NUNQSHL,NTOTSHL,
     &                              IATMCHRG)
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      CHARACTER*4 ATMNAM
      CHARACTER*80 XLINE
C     
      DIMENSION NUC(IUATMS),NUFCT(IUATMS),NUMOM(IUATMS),NFCT(NATOMS),
     &   NANGMOM(NATOMS),NPOP(IUATMS),NAOATM(NATOMS),NAOUATM(IUATMS),
     &   ATMNAM(IUATMS),COORD(3*NATOMS),IMEMB(NATOMS),ISHL(6), 
     &   NANGMOMSHL(IUATMS,MAXSHELL),NCONFUNSHL(IUATMS,MAXSHELL),
     &   NPRIMFUNSHL(IUATMS,MAXSHELL),NMBERSHL(NATOMS),
     &   NCONFUNTSHL(NATOMS*MAXSHELL),NANGMOMTSHL(NATOMS*MAXSHELL),
     &   NOFFSETPRM(IUATMS,MAXSHELL),NOFFSETCON(IUATMS,MAXSHELL),
     &   NOFFSETSHL(NATOMS*MAXSHELL),IATMCHRG(NATOMS),
     &   ISHLOFF(NATOMS)
C     
      COMMON /IPAR/ LUOUT
C     
C     Determine the number of functions for each atom, NFCT(IATM), the 
C     largest number of primitives in a single shell, LNP1, the largest
C     number of primitive orbitals, (number of primitive functions 
C     times the number of atomic orbitals), in a single shell, LNPO, 
C     and the total number of primitive functions, ITFCT, for the 
C     molecule.  The number of AOs for each atom NAOATM
C     
C     Open MOL for basis set information.
      OPEN(UNIT=10,FILE='MOL',FORM='FORMATTED',STATUS='OLD')
      REWIND(10)
C     

C     Read the first five lines.
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
C     
      LNP1   = 0
      LNPO   = 0
      LTNP1  = 0
      LTNPO  = 0
      NTANGM = 0
      NDUM   = 0
      IATM   = 0
      LUOUT  = 6
C
      DO IATOMS = 1, NATOMS
         IF (IATMCHRG(IATOMS) .EQ. 0) THEN
             NDUM = NDUM + 1
         Else
             IATM = IATM + 1
             IMEMB(IATM) =  IMEMB(IATM) - NDUM
         ENDIF
      ENDDO

C
      DO 10 IATM=1,IUATMS
         READ(10,1110) ZNUC,IJUNK,NSHL,(ISHL(I),I=1,NSHL)
 1110    FORMAT(F20.1,8I5)
         READ(10,1115) ATMNAM(IATM),COORDX,COORDY,COORDZ
 1115    FORMAT(A4,3F20.12)
         NUFCT(IATM)=0
         NTANGMI=0
         NUNQSHL = 0
C     
         NAOTMP=0
         DO 20 I=1,NSHL
            NPT=0
            NAOT=0
            DO 21 I1=1,ISHL(I)
               READ(10,1120) NP1,NAO
C
               NPT=NPT+NP1
               NAOT=NAOT+NAO
C
CSSS               IF(I.EQ.1) NP2=1
CSSS               IF(I.EQ.2) NP2=3
CSSS               IF(I.EQ.3) NP2=6
CSSS               IF(I.EQ.4) NP2=10
CSSS               IF(I.EQ.5) NP2=15
C
               NP2 = I*(I + 1)/2
C
               NAOTMP=NAOTMP+NP2*NAO
               NUFCT(IATM)=NUFCT(IATM)+NP2*NP1
C
C This commented if statement is wrong from the start. Ajith 01/2000
C Now this code will work for when their are multiple shells for 
C given angular momentum.
C$$$               IF(I1.EQ.ISHL(I)) NTANGMI=NTANGMI+NP2
C
                  NTANGMI=NTANGMI+NP2
                  NUNQSHL = NUNQSHL + 1 
                  NANGMOMSHL(IATM, NUNQSHL)  = NP2
                  NPRIMFUNSHL(IATM, NUNQSHL) = NP1*NP2
                  NCONFUNSHL(IATM, NUNQSHL)  = NAO*NP2
C
               NLN=(NAO-3)/4
               IF((NAO-3).GT.(NLN*4))NLN=NLN+1
               NLN=(NLN+1)*NP1
               DO 30 J=1,NLN
                  READ(10,'(A)') XLINE
 30            CONTINUE
               IF(NPT.GT.LNP1)THEN
                  IF(NPT.GT.LTNP1) LTNP1=NPT
               ENDIF
               ITMP=NPT*NAOT
               IF(ITMP.GT.LNPO)THEN
                  IF(ITMP.GT.LTNPO) LTNPO=ITMP
               ENDIF
 21         CONTINUE
 20      CONTINUE
         IF(LTNP1.GT.LNP1) LNP1=LTNP1
         IF(LTNPO.GT.LNPO) LNPO=LTNPO
         NUMOM(IATM)=NTANGMI
         IF(NTANGMI.GT.NTANGM) NTANGM=NTANGMI
         NAOUATM(IATM)=NAOTMP
         NMBERSHL(IATM) = NUNQSHL
 10   CONTINUE
C     
      ITFCT=0
      DO 110 IATM=1,IUATMS
         DO 120 IEQATM=1,NPOP(IATM)
            ITFCT=ITFCT+NUFCT(IATM)
 120     CONTINUE
 110  CONTINUE
C     
C Fill out NFCT, NAOATM and NMOMFCT for all atoms.

      ICNT=0
      DO 1011 II=1,IUATMS
C
         DO 1020 IJ = 1,NPOP(II)
C
            ICNT=ICNT+1
            NFCT(IMEMB(ICNT))=NUFCT(II)
            NANGMOM(IMEMB(ICNT))=NUMOM(II)
            NAOATM(IMEMB(ICNT))=NAOUATM(II)
            NMBERSHL(IMEMB(ICNT)) = NMBERSHL(II)
C
 1020    CONTINUE
 1011 CONTINUE
         
#ifdef _DEBUG_LVL0
      Write(6,*) "The NANGMOM array"
      Write(6, "(8i4)") (NANGMOM(I), i=1, Natoms)
      Write(6,*) "The NFCT array"
      Write(6, "(8i4)") (NFCT(I), i=1, Natoms)
      Write(6,*) "The NAOATM array"
      Write(6, "(8i4)") (NAOATM(I), i=1, Natoms)
      Write(6,*) "The NPOP array"
      Write(6, "(8i4)") (NPOP(I), i=1, Natoms)
      Write(6,*) "The NMBERSHL array"
      Write(6, "(8i4)") (NMBERSHL(I), i=1, Natoms)
#endif
C     
C Built the NCONFUNSHL, NANGMOMSHL arrays for all atoms. Also 
C get the total number of shells for all the atoms. This data
C comes handy when we try to retrive the two particle density.
C Ajith Perera 01/2001.
C

      ISHLOFF(1) = 1
      DO IATMS = 2, NATOMS
         ISHLOFF(IATMS) =  ISHLOFF(IATMS-1) + NMBERSHL(IATMS-1)
      ENDDO
#ifdef _DEBUG_LVL0      
      Write(6,*) "The offset array"
      Write(6, "(8i4)") (ISHLOFF(I), i=1, Natoms)
#endif
      NTOTSHL = 0
      ITOTATM = 0
C
      DO IATMS = 1, IUATMS
c
         DO IREDATMS = 1, NPOP(IATMS)
            ITOTATM = ITOTATM + 1
            IATMOFF = ISHLOFF(ITOTATM)

            DO IISHL = 1, NMBERSHL(IATMS)
               
               NTOTSHL = NTOTSHL + 1 

               NCONFUNTSHL(NTOTSHL) = NCONFUNSHL(IATMS, IISHL)
               NANGMOMTSHL(NTOTSHL) = NANGMOMSHL(IATMS, IISHL)
            ENDDO
         ENDDO
      ENDDO
C
      ICOUNT = 0
      DO IATMS = 1, IUATMS
C
         DO IREDATMS = 1, NPOP(IATMS)
C
            ICOUNT = ICOUNT + 1
            NMBERSHL(ICOUNT) = NMBERSHL(IATMS)
         ENDDO
      ENDDO
C
C Also bulit the offsets for primitives and contracted functions 
C on each symmetry unique atoms.
C
C$$$      CALL ICOPY(NUFCT, NUC, IUATMS)
      CALL ICOPY(IUATMS, NUFCT, 1, NUC, 1)
      NUFCT(1) = 0
      DO IATMS = 1, (IUATMS - 1)
         NUFCT(IATMS + 1) = NUC(IATMS) + NUFCT(IATMS)
      ENDDO
C
C$$$      CALL ICOPY(NAOUATM, NUC, IUATMS)
      CALL ICOPY(IUATMS, NAOUATM, 1, NUC, 1)  
      NAOUATM(1) = 0 
      DO IATMS = 1, (IUATMS - 1)
         NAOUATM(IATMS + 1) = NUC(IATMS) + NAOUATM(IATMS)
      ENDDO
C
      NOFFSETSHL(1) = 0
      DO KSHL = 1, NTOTSHL
         NOFFSETSHL(KSHL + 1) = NOFFSETSHL(KSHL) + NCONFUNTSHL(KSHL)
      ENDDO
C
C Read the atom charges back into the NUC array.
C
      CALL GETREC(20,'JOBARC','ATOMCHRG',NATOMS, NUC)
C     
      DO IATM = 1, IUATMS

         DO KSHL =1, NUNQSHL
C
            IF (IATM.EQ.1.AND.KSHL.EQ.1) THEN
C
               NOFFSETPRM(IATM,KSHL) = 0
               NOFFSETCON(IATM,KSHL) = 0
C
            ELSE IF (IATM .EQ. 1 .AND. KSHL .EQ. 2) THEN
C
               NOFFSETPRM(1, 2) = NPRIMFUNSHL(1, 1)
               NOFFSETCON(1, 2) = NCONFUNSHL(1, 1)
C
            ELSE IF (IATM .EQ. 2 .AND. KSHL .EQ. 1) THEN
C
               NOFFSETPRM(2, 1) = 0
               NOFFSETCON(2, 1) = 0 
C
            ELSE
C
               IF (KSHL .EQ. 1) THEN
                   NOFFSETPRM(IATM, KSHL) = 0
                   NOFFSETCON(IATM, KSHL) = 0
               ELSE

                   NOFFSETPRM(IATM,KSHL) = NOFFSETPRM(IATM, KSHL-1)
     &                                   + NPRIMFUNSHL(IATM, KSHL-1) 
 
                   NOFFSETCON(IATM,KSHL)= NOFFSETCON(IATM, KSHL-1)
     &                                  + NCONFUNSHL(IATM, KSHL-1) 
               ENDIF 
C
            ENDIF
         ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
C
         WRITE(LUOUT, *) "The debug info for two particle density"
         WRITE(LUOUT, *)  "Total No, shells, Angular momentum components,
     &   No. of contracted functions per shell"
C
         DO 130 IATM=1,IUATMS
            WRITE(LUOUT,1170) IATM,ATMNAM(IATM),NFCT(IATM),
     &         (COORD((IATM-1)*3+J),J=1,3)
         IMANY_SHEL =  NMBERSHL(IATM)
         WRITE(LUOUT, *) (NANGMOMSHL(IATM,I), I= 1, IMANY_SHEL)
         WRITE(LUOUT, *) (NCONFUNSHL(IATM,I), I= 1, IMANY_SHEL)
 130     CONTINUE
         WRITE(LUOUT,1130) NTANGM
         WRITE(LUOUT,1140) ITFCT
         WRITE(LUOUT,1150) LNP1
         WRITE(LUOUT,1160) LNPO
#endif
 1120 FORMAT(2I5)
 1130 FORMAT(/'THE LARGEST NUMBER OF SHELLS FOR ANY ATOM IS',I3)
 1140 FORMAT('THE MOLECULE HAS',I4,' TOTAL PRIMITIVE FUNCTIONS')
 1150 FORMAT('THE LARGEST NUMBER OF PRIMITIVES IN A SINGLE SHELL IS',I3)
 1160 FORMAT('THE LARGEST NUMBER OF PRIMITIVE ORBITALS IN A SINGLE
     &   SHELL IS',I3)
 1170 FORMAT(/'ATOM',I3,' IS ',A2,' WITH',I4,' PRIMITIVE FUNCTIONS'/
     &   '     ITS COORDINATES ARE ',3F15.5)
C     
      RETURN
      END

         SUBROUTINE  OED__GENER_NAI_BATCH_F12
     +
     +                    ( IMAX,ZMAX,
     +                      NALPHA,NCOEFF,NCSUM,
     +                      NCGTO1,NCGTO2,
     +                      NPGTO1,NPGTO2,
     +                      SHELL1,SHELL2,
     +                      X1,Y1,Z1,X2,Y2,Z2,
     +                      NUCLEI,
     +                      XN,YN,ZN,NCHARGE,
     +                      ALPHA,CC,CCBEG,CCEND,
     +                      SPHERIC,
     +                      SCREEN,
     +                ICORE,STGEXP,RYSGEN,CORETOP,RYSDATA,RYSDATA1,
     +
     +                                NBATCH,
     +                                NFIRST,
     +                                ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__GENER_NAI_BATCH
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__NAI_CSGTO
C  DESCRIPTION : Main operation that drives the calculation of a batch
C                of contracted electron nuclear attraction integrals.
C
C
C                  Input (x = 1 and 2):
C
C                    IMAX,ZMAX    =  maximum integer + flp memory
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCSUM        =  total # of contractions
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1 and 2
C                    NUCLEI       =  # of nuclear attraction centers
C                    XN,YN,ZN     =  the x,y,z-coordinates for all
C                                    nuclear attraction centers
C                    NCHARGE      =  the nuclear charges for all
C                                    nuclear attraction centers
C                    ALPHA        =  primitive exponents for csh
C                                    1 and 2 in that order
C                    CC           =  contraction coefficient for csh
C                                    1 and 2 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    CC(BEG)END   =  (lowest)highest nonzero primitive
C                                    index for contractions for csh
C                                    1 and 2 in that order. They are
C                                    different from (1)NPGTOx only for
C                                    segmented contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C                    SCREEN       =  is true, if screening will be
C                                    done at primitive integral level
C                    ICORE        =  integer scratch space
C                    ZCORE (part) =  flp scratch space
C
C
C                  Output:
C
C                    NBATCH       =  # of integrals in batch
C                    NFIRST       =  first address location inside the
C                                    ZCORE array containing the first
C                                    integral
C                    ZCORE        =  full batch of contracted (1|2)
C                                    nuclear attraction integrals over
C                                    cartesian or spherical gaussians
C                                    starting at ZCORE (NFIRST)
C
C
C
C                            !!! IMPORTANT !!!
C
C                For performance tuning, please see the include file
C                'oed__tuning.inc'.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program OED
C
C    The program package OED is copyrighted 2004 by N. Flocke.
C    All rights are reserved, except as noted herein. OED was produced
C    in part under the auspices of the U. S. Department of Defense.
C    The U. S. Government retains a nonexclusive, royalty-free license
C    to publish or reproduce any published form of OED, or to allow
C    others to do so, for U. S. Government purposes. This copy of OED
C    may not be redistributed nor reproduced, in whole, in part, or as
C    part of another code package without the prior, explicit, written
C    permission from the author. This copy of OED may be used for
C    scientific research provided that any and all published papers
C    and/or presentations of results generated using OED shall
C    acknowledge that fact and the authorship of the code specifically
C    and accurately.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INCLUDE     'oed__ftable.inc'
         INCLUDE     'oed__tuning.inc'

         LOGICAL     SCREEN
         LOGICAL     SPHERIC

         INTEGER     IMAX,ZMAX
         INTEGER     NALPHA,NCOEFF,NCSUM
         INTEGER     NBATCH,NFIRST
         INTEGER     NCGTO1,NCGTO2
         INTEGER     NPGTO1,NPGTO2
         INTEGER     NUCLEI,RYSGEN,CORETOP
         INTEGER     SHELL1,SHELL2

         INTEGER     CCBEG (1:NCSUM)
         INTEGER     CCEND (1:NCSUM)
         INTEGER     ICORE (1:IMAX)

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,STGEXP

         DOUBLE PRECISION  XN      (1:NUCLEI)
         DOUBLE PRECISION  YN      (1:NUCLEI)
         DOUBLE PRECISION  ZN      (1:NUCLEI)
         DOUBLE PRECISION  NCHARGE (1:NUCLEI)

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
         DOUBLE PRECISION  ZCORE (1:ZMAX),RYSDATA(*),RYSDATA1(*)
C
C
C------------------------------------------------------------------------
C
C
C             ...call csgto routine.
C
C
         CALL  OED__NAI_CSGTO_F12
     +
     +              ( IMAX,ZMAX,
     +                NALPHA,NCOEFF,NCSUM,
     +                NCGTO1,NCGTO2,
     +                NPGTO1,NPGTO2,
     +                SHELL1,SHELL2,
     +                X1,Y1,Z1,X2,Y2,Z2,
     +                NUCLEI,
     +                XN,YN,ZN,NCHARGE,
     +                ALPHA,CC,CCBEG,CCEND,
     +                FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                L1CACHE,TILE,NCTROW,
     +                SPHERIC,SCREEN,
     +                ICORE,STGEXP,RYSGEN,CORETOP,RYSDATA,RYSDATA1,
     +
     +                          NBATCH,
     +                          NFIRST,
     +                          ZCORE )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE MO2AO3(ZMO,ZAO,EVEC,SCR,NAO,NMO,ISPIN,ITYPE)
C
C TRANSFORMS A TWO-INDEX QUANTITY (I.E. DENSITY) FROM THE MO TO
C  THE AO BASIS.
C
C INPUT:
C       ZMO  - TWO-INDEX QUANTITY IN MO BASIS (LENGTH: NBAS*NBAS)
C       NMO  - NUMBER OF MOLECULAR ORBITALS
C       NAO  - NUMBER OF ATOMIC ORBITALS
C       
C       ISPIN- 1 FOR ALPHA, 2 FOR BETA
C
C OUTPUT:
C       ZAO  - TWO-INDEX QUANTITY IN AO BASIS (LENGTH: NAO*NAO)
C       
C SCRATCH:
C       EVEC - HOLDS EIGENVECTOR MATRIX (LENGTH: NAO*NMO)
C       SCR  - HOLDS INTERMEDIATE QUANTITY (LENGTH: NBAS*NBAS) 
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*8 LABEL
      DIMENSION EVEC(NAO,NMO),ZMO(NMO,NMO),ZAO(NAO,NAO)
      DIMENSION SCR(NAO*NAO)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100)
      DATA ONE,ZILCH /1.0D0,0.0D0/
      IF(ITYPE.EQ.1) THEN
      IF(ISPIN.EQ.1)LABEL='SCFEVECA'
      IF(ISPIN.EQ.2)LABEL='SCFEVECB'
      ELSE
      IF(ISPIN.EQ.1)LABEL='SCFEVCA0'
      IF(ISPIN.EQ.2)LABEL='SCFEVCB0'
      ENDIF
C
CJDW 3/18/96. See comments in main program.
C
      CALL GETREC(20,'JOBARC','NUMDROPA',1,NDROP)
      IF(NDROP.GT.0.AND.IFLAGS(2).GT.0)THEN
        IF(ISPIN.EQ.1)LABEL='SCFEVCA0'
        IF(ISPIN.EQ.2)LABEL='SCFEVCB0'
      ENDIF
C
      CALL GETREC(20,'JOBARC',LABEL,IINTFP*NAO*NMO,EVEC)
      CALL XGEMM('N','T',NMO,NAO,NMO,ONE,ZMO,NMO,EVEC,NAO,
     &           ZILCH,SCR,NMO)
      CALL XGEMM('N','N',NAO,NAO,NMO,ONE,EVEC,NAO,SCR,NMO,
     &           ZILCH,ZAO,NAO)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
C GEOPT:  A Z-matrix input and geometry optimization module for
C         the ACES2 program system.
C
C By: J.F. Stanton, 7/88
C Modifications for portability by: D.E. Bernholdt 12/88
C Modifications for [name it] by: The ACES Development Team

#include "flags.h"

      SUBROUTINE GEOPT(Z, MEMREQ)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "mxatms.par"
#include "fnamelen.par"
      LOGICAL IGNORE,OPTRES,YESNO, OPTARC_presnt, FCM_EXIST,
     &        IMPORT_CART_HESS
cYAU : 3/11/03 : VIBRES is only used in this file and for nothing
c      LOGICAL VIBRES
      CHARACTER*(fnamelen) FNAME
C     Allocate more than enough core for the present needs
C     Estimated  by NX-6 => NX, and assume the worst!
C      PARAMETER (MEMREQ = 14*9*MXATMS*MXATMS + 16*3*MXATMS +
C     &           5*9*3*MXATMS + 2*3*MXATMS)
C Audit was carried out and recounted the memory requirements. Also,
C change to MXATMS to MAXREDUNCO so tha both user defined internal
C and redundent intnterals can work (note that No. of REDUNCO 
C = 3*MXATMS, so this is safe for both options), 05/2006, Ajith Perera.
C
c      PARAMETER (MEMREQ = 15*MAXREDUNCO*MAXREDUNCO + 
c     &           34*MAXREDUNCO) 
      INTEGER MEMREQ
      DIMENSION Z(MEMREQ)
C
CJDW  Arrays for the POLYPRT routine.
CJDW  10/23/95. Should not now be needed as we are using POLYPRT0.
C      dimension xyzcor(3*mxatms),grad(3*mxatms),hess(9*mxatms*mxatms)
C      dimension iordco(  mxatms)
C
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
      CHARACTER*7 EXPRT_INT_HESS

cYAU passed down to entry for mkvmol
#include "baslen.par"
      character*(baslen) BasNam
      INTEGER TOTREDNCO
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /TOLERS/ SYMTOL,DEGTOL
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $     ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $     XYZTol

C     Symmetry Information
C     FPGrp   Full point group
C     BPGrp   Largest Abelian subgroup
C     PGrp    "Computational" point group
      Character*4 FPGrp, BPGrp, PGrp
      LOGICAL XYZIN,PS1EXIST,We_havegeom,Can_do_freq,Anlytic_hessian
     &       ,Geomtry_opt
      Common /PtGp_com/ FPGrp, BPGrp, PGrp
      COMMON /INPTYP/ XYZIN,PS1EXIST
      COMMON/RESTART_COM/IGNORE
      COMMON/RESTART2/OPTRES
cYAU      COMMON/RESTART3/VIBRES
      Common /Orient/ Orient(3,3)
#include "io_units.par"
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
C     Use to fix orientation for C2v and D2h from one step to the next
      Integer At1, At2, XYOri
C
      integer genby(mxatms)

c ----------------------------------------------------------------------

      IONE   = 1
      IJUNK  = 1
      XYZTol = 1.0d-6
      SYMTOL = 1.D-6
      DEGTOL = 1.D-10
      ISTAT  = 0
      E      = 0.D0
      IPrnt  = 0
      TOTREDNCO = 0

C IF .OPT FILE NOT THERE, READ Z-MATRIX AND GET THINGS SET UP
      call igetrec(-1,'JOBARC', 'HAVEGEOM', 1, i_havegeom)
#ifdef _DEBUG_LVL0
      Print*, "The value of HAVEGEOM record:", i_havegeom 
#endif
      We_havegeom = .false.
      Can_do_freq = .false.
      If (i_havegeom .EQ. 1) We_havegeom = .true.
      CALL ENTRY(BasNam, We_havegeom, Can_do_freq)

c      inquire(file='ALLDONE',exist=yesno)
c      if( (iflags2(h_IFLAGS2_grad_calc).eq.2) .and. .not. yesno)iarch=0
C
      call igetrec(1,'JOBARC','FNDFDONE',1,iTmp)
      if ((iflags2(h_IFLAGS2_grad_calc).eq.2).and.(iTmp.eq.0)) iarch=0
      Anlytic_hessian =  (Iflags(h_IFLAGS_vib) .EQ. 1)
      Geomtry_opt        =  (Iflags2(h_IFLAGS2_geom_opt) .NE. 0)
C
#ifdef  _DEBUG_LVL0 
      Print*, "-----After call to Entry-----"
      Print*, "The FNDDONE in Geopt:", iTmp 
      Print*, "The gradient calcs:", iflags2(h_IFLAGS2_grad_calc)
      Print*, "Hessian calc.,Geo. opt. and iarch:", Anlytic_hessian,
     &         Geomtry_opt, iarch
#endif
C
C The logical argument to FETCHZ, controls whether it is the
C the very first call to the FETCHZ. In the case of user
C defined internal coordinates geometry optimizations, FETCHZ
C is called only once and this argument has no use, but in the
C case of redundent internal coordinate (RIC) optimizations, the FETCHZ
C is called repeatedly during a optimization with this argument
C set to .FALSE. During the first call it will generate RICs,
C B-matrix and A-matirx. During the next calls it will generate
C B-matrix and A-matrix that corresponds to new coordiantes using the
C RIC's generated in the first call. Ajith Perera, 08/2002
C
      If (We_havegeom .AND. (Anlytic_hessian .OR. iTmp .EQ. 1)) Then
#ifdef _DEBUG_LVL0
      Print*, "Reading previous step from JOBARC file"
#endif
           Call igetrec(20, 'JOBARC', 'ZMATATMS', 1, NATOMS)
           Call igetrec(20, 'JOBARC', 'LINEAR  ', 1, ILINEAR)
           If (ILINEAR .EQ. 1) Then
               NX   = 3*NATOMS
               NXM6 = NX - 5
           Else
               NX   = 3*NATOMS
               NXM6 = NX -6
           Endif
           IF (iflags(h_IFLAGS_coord) .EQ. 1) XYZIN = .TRUE. 
           Call dgetrec(20, "JOBARC", "COORD   ", NX, Q)
           Call igetrec(-1, 'JOBARC', 'CONCTVTY', NX, NCON)
           Call dgetrec(-1, 'JOBARC', 'CORD_INT', NX, R)
CSSS           If (Anlytic_hessian) Call Bohr2angs(R, NX)
           Call Bohr2angs(R, NX) 
           Call dgetrec(20, 'JOBARC', 'ATOMMASS', NATOMS,
     &                 ATMASS)
           Call dgetrec(20, 'JOBARC', 'ORIENTMT', 9,
     &                 ORIENT)
           Call igetrec(20, 'JOBARC', 'ATOMCHRG', NATOMS, IATNUM)
           Call igetrec(-1, 'JOBARC', 'ICSQUASH', NX, ISQUASH)
           Call Getcrec(20, 'JOBARC', "PTGP    ", 4, FPGRP)
           Call Getcrec(20, 'JOBARC', "ABL_PTGP", 4, BPGRP)
           Call Getcrec(20, 'JOBARC', "CMP_PTGP", 4, PGRP)
           Call Getcrec(20, 'JOBARC', "ZSYM", 5*NATOMS, ZSYM)
           Call Getcrec(-1, 'JOBARC', "INTCNAM", 5*NX, VARNAM)
           IF (.not. Geomtry_opt .And. Iarch .Ne. 1) CALL
     &         FETCHZ(.TRUE., Z, MAXMEM)
           CALL ZERO(Z, MEMREQ)
#ifdef _DEBUG_LVL0
           Print*, "The data read from JOBARC"
           Print*, "The NATOMS:", NATOMS
           Write(6,*)
           IF (.not. xyzin) Write(6,*) "Internal coords:"
           IF (.not. xyzin) Write(6,"(3F10.5)") (R(I), I=1, NX)  
           Write(6,*)
           Write(6,*) "The Cartesian coords:"
           Write(6, "(3F10.5)") (Q(I), I=1, NX)
           Write(6,*)
           if (.not. xyzin) Write(6,*) "The connectivities:" 
           if (.not. xyzin) Write(6, "(5I2)")(NCON(I), I=1, NX) 
#endif
      Else
c
#ifdef _DEBUG_LVL0
          Print*, "Entering Fetchz IARCH .NE. 1", IARCH
#endif
          IF (iarch .NE.1) CALL FETCHZ(.TRUE., Z, MAXMEM)
      Endif
C
c Marcel Nooijen 2001
c print warning if atoms are connected 3 to 1 and vibrations.
c Abort if resraman calculation
c
      if (iarch .ne. 1) then
c
         ijunk = 0
         call igetrec(-1, 'JOBARC', '12SWITCH', ione, ijunk)
         if (ijunk .eq. 1 .and. (iflags2(h_IFLAGS2_resraman) .eq. 1
     $        .and. ivib .ge. 1)) then
c
            write(6,*) ' *** Warning *** '
            write(6,*)
            WRITE(6,*)' Please reconstruct ZMAT file '
            WRITE(6,*)' Third atom should connect to second atom '
            WRITE(6,*)' Interchange atoms 1 and 2 in ZMAT '
            WRITE(6,*)' Replace all 1->2 and 2->1 '
            WRITE(6,*)' in third through last lines of ZMAT '
            WRITE(6,*)' Our apologies for the inconvenience'
            write(6,*)
            write(6,*)' Necessary for RESRAMAN calculations!!'
            write(6,*)' Erroneous representation of'
            write(6,*)' Normal Coordinates in internal representation'
            write(6,*)
            if (iflags2(h_IFLAGS2_resraman) .eq. 1) call errex
         endif
      endif
C
C The JOBARC record PASS1 is created in symcor ME and can have
C any of the following values: 0 to indicate a first call to
C symcor in a frequency or finite difference geometry optimizations,
C 1 to indicate geometry optimization with numerical gradients
C or frequency calculations with numerical or analytical gradients
C is in the middle of generating required Hessian or gradients.
C Also, 0 is used to indicate that gradients or Hessians 
C generation is complete. When the gradients or Hessian generation
C is complete, the joda Handle the Frequency generation or 
C taking the next geometry step by transfering the execution 
C to the appropriate block (note the comments in the section marked
C as  BRANCHING below). Also, please read comments in SYMCOR ME.
C The second GETREC call returns the length of the record if that
C exists. If the PASS1 record present it is a finite difference 
C calculation. Ajith Perera 03/2003. 
C 
      CALL IGETREC(-1,'JOBARC','PASS1   ',IONE,IPASS1)
C 
C The following logic is for restarting numerical gradient
C generation. If there is PASS1 record in JOBARC, that means
C symcor has been run at least once. 
C
      CALL IGETREC(0,'JOBARC','PASS1',iTmp,IX)
      PS1EXIST=(iTmp.GT.0)
      IF (PS1EXIST.AND.(.NOT.IGNORE)) THEN
cYAU        VIBRES=.true.
         CALL IPUTREC(1,'JOBARC','VIBRES',1,1)
      ELSE
cYAU        VIBRES=.false.
      ENDIF
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "@GEOPT, PASS1,  PS1EXIST=:", IPASS1, PS1EXIST
#endif
C
C Allocate memory, Note that in the case of pure Cartesian Optimizations
C the number of internal coordinates is always correspond to
C NX where NX=3*NATOMS. In the case of Redundent internal optimizations
C NX = TOTREDNCO and the fetchz.F dependency, gen_rednintrnls.F
C create the "REDNCORD" record. In the case of user defined internals 
C it is NX-6. Ajith Perera, 09/2002,2008.
C
      CALL IGETREC(0, 'JOBARC','REDNCORD', Length, TOTREDNCO)
      IF (iFlags2(h_IFLAGS2_geom_opt).eq.2) Then 
          NXM6 = NX
      ELSE IF (length .gt.0) THEN
C
C This is equivalent to iFlags2(h_IFLAGS2_geom_opt).ge.3, but
C the optimizer (ifort on SGI Altix) would not allow me to use 
C it, so the above is the alternative. 
C
          CALL IGETREC(-1, 'JOBARC','REDNCORD', 1, TOTREDNCO)
          NXM6 = TOTREDNCO
      ENDIF
C
C The following applies for the user defined internal optimizations.
C Somewhat overaloaded because PS1EXIST control numerical finite
C differencing. Ajith Perera, 08/2008.
C A bug fix for Numerical finte difference redundent internal
C and Cartesian only optimizations, Ajith Perera, 04/2012.
C (.OR. PS1EXIST is removed).
C
      IF (iFlags(h_IFLAGS_coord).eq.0 .OR. 
     &    iFlags2(h_IFLAGS2_geom_opt) .eq. 0) NXM6 = MAX(NX-6,1)
C
C FOR DUMMY B-MATRIX (AND CARTESIAN HESSIAN AFTER BUILDB)
C
      N1 = (NX * NX) + 1
C
C FOR B MATRIX (OCCUPIED BY A(TRSPSE) AFTER BUILDB. (++9*MXATMS^2)
C
      N2 = (NX * NX) + N1
C
C FOR G MATRIX (AND INTERNAL COORD HESSIAN AFT(++9*MXATMS^2)
C
      N3 = (NX * NX) + N2
C
C FOR A MATRIX (++9*MXATMS^2)
C
      N4 = (NX * NXM6) + N3
C
C FOR B TRANSPOSE
C Increase the space at N4 so that it can be used to store the Cartesian
C Hessian in get_mopac_hess.F. The N4 location is used as scratch space
C in several other places and the increased space should not have any
C effect on those. Ajith Perera, 06/2005. (++3*MXATMS*(3*MXATMS-6))
C N5 = (NX * NXM6) + N4
C
      N5 = (NX * NX) + N4
C
C FOR SCRATCH ARRAY IN BUILDB (++9*MXATMS^2)
C
      N6 = (NXM6 * 2) + N5
C
C CARTESIAN GRADIENT VECTOR (++2*(3*MXATMS-6))
C
      N7 = NX + N6
C
C INTERNAL COORDINATE GRADIENT VECTOR (++3*MXATMS)
C
      N8 = NXM6 + N7
C
C INTERNAL COORDINATE HESSIAN FOR ARCHIVING (++(3*MXATMS-6))
C
      N9 = (NXM6 * NXM6) + N8
C
C FOR STEP IN UPDATE (++(3*MXATMS-6)^2)
C
      N10 = NXM6 + N9
C
C FOR SCRATCH ARRAYS IN UPDATE (++(3*MXATMS-6))
C
      N11 = ((NXM6 * NXM6) * 3) + N10
C
C FOR SCRATCH ARRAYS IN SYMMETRY (++3*(3*MXATMS-6)^2)
C
      N12 = (3 * NX) + N11
C
      N13 = NX + N12
C
      N14 = NX + N13
C
C FOR CONSTRAINED HESSIAN IN NEWRAP (++5*(3*MXATMS-6))
C
      N15 = (NOPT * NOPT) + N14
C
C FOR CONSTRAINED GRADIENT VECTOR IN NEWRAP (++9*MXATMS^2)
C
      N16 = NOPT + N15
C
C CONSTRAINED ORTHOG. BASIS GRADIENT & HESSIAN IN EFOL (++3*MXATMS)
C
      N17 = NOPT + N16
C
      N18 = NOPT*NOPT + N17
C
C Eigenvector followed on previous iter. (EFOL) (++(9*MXATMS^2+3*MXATMS))
C
      N19 = NOPT + N18
C
C Scratch matrices for EFOL - Used for augmented Hessian in RFA
C and TS searches.  Dimension must be NOPT+1 for RFA.(++3*MXATMS)
C
      N20 = (NOPT+1)*(NOPT+1) + N19
      N21 = (NOPT+1)*(NOPT+1) + N20
      N22 = NX + N21
      N23 = NX + N22
      N24 = NX + N23
      N25 = NX*NX + N24
C
C A Bug fix (Only occured when extended to do Raman intensiies)
C Ajith 08/98, Note the generous allocation. (++(3*9*MXATMS^2 + 3*MXATMS))
C
      N26 = NX*NX + N25
C
C Marcel Need a bigger scracth space. (++9*MXATMS^2)
cSSS N27 = NXM6*NXM6 + N26
C
      N27 = NX*NX + N26
C
C Allocate room for polarizabiliity derivatives Ajith & John, 08/98 (++9*MXATMS^2)
C
      N28 = 9*NX + N27
      N29 = 9*NX + N28
      N30 =   NX + N29
      N31 =   NX + N30
C
C Allocate memory for a scratch array in line search, Ajith, 03/10.

      N32 = 6*NX + N31
C
C Allocate memory for the projector required in redundent internal
C optimizations, Ajith, 02/2012 (++20*MXATMS)

      N33 = NX*NX + N32
C
C The memory for this block (++9*MXATMS^2)
C
      MEMTOP = N33
C
C The total memory required  (9*16*MXATMS^2 +  3*34*MXATMS ) assuming 
C (3*MXATMS-6)=3*MXATMS for user defined internals and 15*MAXREDUNCO^2
C 34*MAXREDUNCO) for redundent internals
C
      IF (MEMTOP .GT. MEMREQ) THEN
        WRITE(LUOUT,5010)MEMTOP,MEMREQ
 5010   FORMAT(T3,'@GEOPT-F, Not enough core.',/,
     &       T3,'Words required:',I9,' Words available:',I9)
        CALL ERREX
        Write(6,*)
      ENDIF
C
#ifdef _DEBUG_LVLM1
C
      WRITE (LUOUT, 9100)  MEMTOP,MEMREQ
 9100 FORMAT (T3,'@GEOPT-I, Words Needed: ',I9,
     &        ' Words Allocated ',I9,'.')
      Write(6,*)
      WRITE(LUOUT,9101)N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,
     &      N11,N12,N13,N14,N15,N16,N17,N18,N19,N20,N21,N22,
     &      N23,N24,N25,N26,N27,N28,N29,N30,N31
 9101 FORMAT(T3,'@GEOPT-I, Offsets into core vector: ',
     &      (/,9(1X,I9)))
#endif
C
C Gets information from OPTARC file for subsequent steps (after
C the first call)
C
      IF (iarch .EQ.1) Then
C
C IF archive file (OPTARC) present then immediately branch out to
C the geometry optimization section. OPTARC is made during the very first
C call to joda for optimizations. For analytical gradients optimizations
C iarch is set 1 (after the first joda) while for numerical derivatives 
C it set to 0 until the full set of gardients available when it is 1.
C (Note that this changes from 0 --> 1 during numerical opt. cycles)
C 03/2003, Ajith Perera. 
C
        If (We_havegeom) Then
           NATOMS = NX/3 
           Call igetrec(10, 'JOBARC', 'IFLAGS  ', 100, IFlags)
           IF (iflags(h_IFLAGS_coord) .EQ. 1) XYZIN = .TRUE. 
           Call dgetrec(20, "JOBARC", "COORD   ", NX, Q)
           Call igetrec(-1, 'JOBARC', 'CONCTVTY', NX, NCON)
           Call dgetrec(-1, 'JOBARC', 'CORD_INT', NX, R)
CSSS           Call Angs2bohr(R, NX)
           Call dgetrec(20, 'JOBARC', 'ATOMMASS', NATOMS, 
     &                 ATMASS)
           Call dgetrec(20, 'JOBARC', 'ORIENTMT', 9, 
     &                 ORIENT)
           Call igetrec(-1, 'JOBARC', 'ICSQUASH', NX, ISQUASH)
           Call Getcrec(20, 'JOBARC', "PTGP    ", 4, FPGRP)
           Call Getcrec(20, 'JOBARC', "ABL_PTGP", 4, BPGRP)
           Call Getcrec(20, 'JOBARC', "CMP_PTGP", 4, PGRP)
           Call Getcrec(-1, 'JOBARC', "INTCNAM", 5*NX, VARNAM)
           CALL ZERO(Z, N11)
#ifdef _DEBUG_LVL0
           Print*, "The Retrive-2"
           Print*, "Coordiantes:",iflags(h_IFLAGS_coord)
           Print*, "The data read from JOBARC"
           Print*, "The NATOMS:", NATOMS
           Print*, "Untested change (undoB2A) on 07/09/06"
           IF (.not. xyzin) Write(6,*) "Internal coords:"
           IF (.not. xyzin) Write(6,"(3F10.5)") (R(I), I=1, NX)
           Write(6,*)
           Write(6,*) "The Cartesian coords:"
           Write(6, "(3F10.5)") (Q(I), I=1, NX)
           Write(6,*)
           If (.not. xyzin) Write(6,*) "The connectivities:"
           If (.not. xyzin) Write(6, "(5I2)")(NCON(I), I=1, NX)
#endif
        Else
            CALL RETRIEVE( E, Z(N4), Z(N8), Z(1), Z(N18))
            CALL ZERO(Z, N11)
C
#ifdef _DEBUG_LVL0
      Write(6,*) 'Data read from OPTARC file'
      Write(6,*) 
      Print*, 'The COORD COMMON BLOCK/AFTER RETRIVE'
      Write(6,'(3F10.5)') (Q (I), I= 1, NX)
      Write(6,*)
      Write(6, '(3F10.5)') (R(I), I= 1, NXM6)
      Write(6,*)
#endif
        Endif 
C 
      ELSE
C
C CALL SYMMETRY PACKAGE AND NEW FINDIF SYMMETRY ROUTINES.
C
#ifdef _DEBUG_LVL0
            Print*, "Before the call to GMETRY, XYZIN", XYZIN
#endif
C 
        IF (.NOT. XYZIN) CALL GMETRY(We_havegeom, .TRUE.)
        IF (XYZIN .AND. Iflags(h_IFLAGS_vib) .GT. 1 .AND.
     &      IPASS1 .EQ. 0) CALL GETXYZ
C
C Internal coordinate geo. optimizations, Cartesian Coordinate 
C frequency calcualtions requires following call to SYMMETRY.  
C This call should be avoided for RIC optimizations 
C 03/2003 Ajith Perera. 
C 
        IF (iFlags2(h_IFLAGS2_geom_opt).lt.3) THEN
           CALL SYMMETRY(Z(N11), Z(N12), Z(N13), .TRUE.)
        ELSE
C
C Allow higher tolerance for Cartesian inputs (perhaps generated from a
C GUI). The parameter DEGTOL is used to determine the degeneracy of the
C inertia tensor which is related to the degeneracy of the point group.
           DEGTOL = 1000*DEGTOL
        END IF
C
CJDW 4/1/97. Write COMPSYOP with maximum possible length at beginning
C of finite difference calculation.
C Also COMPPERM, COMPCLSS. When SYMMETRY=NONE, these two records
C are initialized in symmetry.F.
C
        IF(.NOT.PS1EXIST)THEN
         If (iFlags(h_IFLAGS_sym).GT.0) THEN
            CALL ZERO(Z,8*9)
            CALL DPUTREC(20,'JOBARC','COMPSYOP',8*9,Z)
            CALL ZERO(Z,8*NATOMS)
            CALL DPUTREC(20,'JOBARC','COMPPERM',8*NATOMS,Z)
         Endif
C
            CALL ZERO(Z,8)
            CALL DPUTREC(20,'JOBARC','COMPCLSS',8,Z)
         IF (Iflags2(h_IFLAGS2_geom_opt) .eq. 2 .or. 
     &       Iflags2(h_IFLAGS2_geom_opt) .ge. 3) THEN
             CALL DPUTREC(0,'JOBARC','COORD_OP',3*NATOMS,Z)
         ENDIF
        ENDIF
C
        
        IOFF=1+120*9+NATOMS*9
        MLTINT=IINTFP*(MEMREQ-120)
C
        If (iFlags(h_IFLAGS_sym).GT.0) CALL SYMDRV(Z(IOFF),Z,
     &                                 MLTINT,IOFF,FPGRP,'FULL')
        ITMP=IPRNT
        IF(PGRP.EQ.FPGRP)IPRNT=0
        If (iFlags(h_IFLAGS_sym).GT.0) CALL SYMDRV(Z(IOFF),Z,
     &                                 MLTINT,IOFF,PGRP,'COMP')
        IPRNT=ITMP
CSSS        CALL DGETREC(20,'JOBARC','NOREOCOR',3*NATOMS,
CSSS     &              Q)

        CALL ZERO(Z,MEMREQ)
C
c SB : The if(.not.PS1EXIST) block used to be inside the if(natoms.gt.1)
c block.  I moved it outside so that the call to geomout is made
c even in the case of an atom.
C
        If (NAtoms .gt. 1) THEN
C
C Call the Z-matrix analyzer - requires A matrix from BUILDB.
C XYZIN is true when IFLAGS(h_IFLAGS_coord)=1 occur at the same time. So,
C in that sens the following test is a overkill. 03/2003, 
C Ajith Perera.
C 
          IF (.NOT. XYZIN .AND. IFLAGS(h_IFLAGS_coord).NE.1) THEN
C
             CALL BUILDB(Z(1),Z(N1),Z(N2),Z(N3),Z(N4),Z(N5),Z(N10))
C
C Analyse only should be called for Geo. optimizations
C
             IF(.NOT.PS1EXIST)Call Analyze (Z(N10), Z(N3))
C
C As of 08/2008 we can also useiFlags2(h_IFLAGS2_geom_opt).ge.3)
C to test for RIC opts.
C
          ELSE IF (iFlags2(h_IFLAGS2_geom_opt).ge.3) THEN
C
C Note, this  part is executed only in the first call to joda, and
C no need to re-run since it had alredy been run with the argument set
C to .TRUE, and the following records for the starting  geometry is in
C the JOBARC. Ajith Perera 08/2002.
C
             CALL IGETREC(-1, 'JOBARC','REDNCORD', 1, TOTREDNCO)
             LENGTH_GMAT=3*NATOMS*TOTREDNCO
             CALL DGETREC(-1, 'JOBARC', 'GMATRIX ',LENGTH_GMAT,
     &                   Z(N3))
             CALL ANALYZE(Z(N10), Z(N3)) 
C
          ELSE IF (iFlags2(h_IFLAGS2_geom_opt).eq.2 .AND.XYZIN) THEN
C
C This block is for pure Cartesian full optimizations. In this case 
C all the B and G matrices are unit matrices.
C
             CALL SET_2UNIT_MATRIX(Z(N3), 3*NATOMS)
             CALL ANALYZE(Z(N10), Z(N3))     
C
          ENDIF
        endif
C
C Print out the coordinates and distance matrix
C
        IF(.NOT.PS1EXIST)THEN
          Call GeomOut
          if (natoms.gt.1) Call ADM
        EndIf
C
C IF THIS IS A FINITE DIFFERENCE CALCULATION AND ALL POINTS HAVE
C BEEN RUN, THEN CALL VIBRATIONAL ANALYSIS CODE
C Make the appropriate input deck
C
        IF (INTTYP .EQ. 0) THEN
cYAU          Call MkAbIn (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
cYAU     &         GenBy, Z(N11), IStat)
           write(*,*) '@GEOPT: MkAbin was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
CJDW 9/20/96. Allow for Seward (currently must make MOL file).
CADY 5/06/04. Allow for GAMESS (currently must make MOL file).
        ElseIf (IntTyp .eq. 1 .or. IntTyp .eq. 2
     &                        .or. IntTyp .eq. 5
     &                        .or. IntTyp .eq. 4) then
          Call MkVMOL (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &         GenBy, Z(N11), IStat, BasNam)
           if (iflags(h_IFLAGS_guess).eq.2) then
              call mknddo(q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &                    GenBy, Z(N11), IStat, BasNam)
           end if
        ElseIf (IntTyp .eq. 3) then
cYAU          Call MkCadp (PGrp, NAtoms, NUnique, ZSym, IAtNum, Q,
cYAU     &         GenBy, IStat)
           write(*,*) '@GEOPT: MkCadp was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
        ENDIF
        If (Mod(IStat,2) .eq. 1) then
           Call ErrEx
        ElseIf (IStat .eq. 8 .OR. IStat .eq. 10) then
          IStat = 0
c            Write (LuErr, 9810)
C           Eventually we will want to do more things here...
C           Probably want to change to program to chain to
C           Probably want to write out a CON file or similar
        EndIF
C
C NOW WRITE COORDINATE INFORMATION TO INPUT FOR INTS.  THIS IS CRUDE,
C BUT THINGS HAVE TO BE DONE THIS WAY FOR NOW. (OBSOLETE LONG AGO).
C
        CALL ZERO(Z, N13)
        itmp                   = iflags(h_IFLAGS_props)
        iflags(h_IFLAGS_props) = mod(itmp,100)
C
C ****************** BRANCHING Begins **************************
C
C Test to see whether the current calcultion is a single point
C energy, vibrational frequency or geometry optimiztion. Unfortunatley
C some NMR spin-spin coupling stuff (work of Stanton and Gauss not
C Perera's) cramped here (The iflags(h_IFLAGS_props) carry those flags.
C In principle these should have been moved out of joda). If not a single
C point or atomic, create archive file OPTARC, else print a message and
C move on to next ME.
C 
        IF (NOpt .ne. 0 .AND. NAtoms .gt. 1 .or. IVib .eq. 1 .or.
     &       IVIB.EQ.2
     &       .OR. IFLAGS(h_IFLAGS_props).EQ.3
     &       .OR. IFLAGS(h_IFLAGS_props).EQ.4
     &       .OR. IFLAGS(h_IFLAGS_props).EQ.5
     &       .OR. IFLAGS(h_IFLAGS_props).EQ.8
     &       .OR. IFLAGS(h_IFLAGS_props).EQ.9
     &       .OR. IFLAGS(h_IFLAGS_props).EQ.10
     &       .OR. IFLAGS2(h_IFLAGS2_resraman).NE.0
     &       ) then
          CALL ARCHIVE(E, Z(N7), Z(N8), Z(NXM6 + 1), 1,
     &                 Z(N18))
        ElseIf (NOpt .eq. 0) then
          Write (LuOut, 9820) 'single-point'
        ElseIf (NAtoms .eq. 1) then
          Write (LuOut, 9820) 'atomic'
        Endif
c
c inquire(file='ALLDONE',exist=yesno)
c if(.not.yesno)then, if(.not. PS1EXIST .or. PS1EXIST .and. IPASS1 .eq. 1)
C These lines were obsoleted on 03/2003 Ajith Perera
C
C The logic here is important. The variable IPASS1 can be 0 and 1
C (see the comments under PASS1 JOBARC record above). 
C Geometry Optimizations with analytical gradients reach this far
C only in the first call to joda and the condition is true. In 
C subsequent steps, it will see the presence of OPTARC file and
C branch out to the geometry optimization section (below). It can
C exit via SUMMARY.F when the convergence is achieved. 
C 
C For geometry optimizations with numerical gradients the conditional
C is true until the full set of gradients are created (IPASS1 is 
C 1 until the full set of gradients are created then it is set to 0
C in symcor ME). When the full set of gradients are there, iarch get
C set to 1 (OPTARC is present), and the execution get pass over to 
C the geometry optimization logic. It can exit via SUMMARY.F. 
C
C For frequency calculations, untill the full Hessian is available the
C the conditional is true (IPASS1 is 1 PS1EXIST is true). When the 
C conditional is false, execution is transfered to VIB1.F. The 
C program exit is from the main program GEOPT.F. Ajith Perera 03/2003. 
C 
C Note that during the first run IPASS1 is 0 and PS1EXIST is false. 
C 
        iflags(h_IFLAGS_props)=itmp
        if(IPASS1 .eq. 1 .or. .not. PS1EXIST)then
          IF(IPRNT.EQ.999)WRITE(LUOUT,8888)(I,Z(I),I=1,N27)
          CALL IPUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
          return
        endif
      END IF
 9820 Format (' @GEOPT-W, Archive file not created for ',A,
     $     ' calculation.')
C 
C ************************ BRANCHING ENDS *********************************
C
C CALL ROUTINE TO BUILD B MATRIX, Only for geometry optimizations
C vibrational Frequency calculations. Also, here, XYZIN and 
C IFLAGS(h_IFLAGS_coord) convey the same information. 03/2003, Ajith Perera
C
      IF(.NOT. XYZIN .AND. IFLAGS(h_IFLAGS_coord).NE.1) THEN
C
        CALL BUILDB(Z(1), Z(N1), Z(N2), Z(N3), Z(N4), Z(N5), Z(N10)) 
C
      ELSE IF (TOTREDNCO.NE.0) THEN
C
C This block is executed for each iteration during a optimiation and
C requires a call to FETCHZ with argument set to .FALSE. to create
C B and A matrices for the new coordinates using the IRC's genereated
C in the first call to FETCHZ. Ajith Perera 08/2002
C
        CALL FETCHZ(.FALSE., Z, MAXMEM)
        CALL IGETREC(-1, 'JOBARC','REDNCORD', 1, TOTREDNCO)
        LENGTH_GMAT = 3*NATOMS*TOTREDNCO
        CALL DGETREC(-1, 'JOBARC', 'GMATRIX ',LENGTH_GMAT,
     &              Z(N3))
        CALL DGETREC(-1, 'JOBARC', 'BMATRIXT', LENGTH_GMAT,
     &              Z(N4))
C
       ELSE IF (iFlags2(h_IFLAGS2_geom_opt).eq.2 .AND.XYZIN) THEN
C
C This block is for pure Cartesian full optimizations. In this case
C all the B and G matrices are unit matrices.
C
             CALL SET_2UNIT_MATRIX(Z(N4), 3*NATOMS)
             CALL DPUTREC(20,'JOBARC','BMATRIX ',9*NATOMS*NATOMS,
     &                   Z(N4))
             CALL SET_2UNIT_MATRIX(Z(N3), 3*NATOMS)
             CALL DPUTREC(20, 'JOBARC', 'AMATRIX', 9*NATOMS*NATOMS,
     &                   Z(N3))

      ENDIF
C
C************************* Frequency/Rate Cons/NMR starts **********
C 
C This start the vibrational Frequency,  Stanton Gauss NMR stuff
C and Rozeann Steckler's rate constant stuff. 
C
      itmp                   = iflags(h_IFLAGS_props)
      iflags(h_IFLAGS_props) = mod(itmp,100)
C
      IF (Can_do_freq .OR.IFLAGS2(h_IFLAGS2_resraman).NE.0)THEN
C
CJDW 1/ 5/95 Write polyrate data for Rozeanne Steckler. This almost
C certainly will not work if there are dummy atoms present.
C In addition, it should only be called when we do analytical
C hessians, as in the finite difference case it will not get
C the coordinates, energy, and gradient for the reference
C geometry. Also, POLYRATE must be ON.
C
CJDW 10/23/95 Change from POLYPRT to POLYPRT0 in standard code.
C
        IF(IFLAGS(h_IFLAGS_vib).EQ.1.AND.
     &     IFLAGS2(h_IFLAGS2_polyrate).EQ.1)THEN
          CALL POLYPRT0(NATOMS,IINTFP,IFLAGS(h_IFLAGS_print),
     &                  .TRUE.,.TRUE.,.TRUE.,.TRUE.)
        ENDIF
C
        IHES = 0
        IF(IVIB.EQ.3.OR.IFLAGS2(h_IFLAGS2_resraman).NE.0) IHES = 1
C
        Call READGH (0,IHES,NATOMS,Z(N6),Z(1),Z(N1),Z(N2),IAVGRD,
     &       IAVHES)

#ifdef _DEBUG_LVL0
       Print*, "The exact Hessian after reading in READGH."
       CALL OUTPUT(Z(1), 1, 3*NATOMS, 1, 3*NATOMS, 3*NATOMS,
     &             3*NATOMS, 1) 
#endif
C
C
        IF(ISTAT.NE.0)THEN
          WRITE(LUOUT,3432)
 3432     FORMAT(T3,'@GEOPT-F, Problem with FCM or GRD file.')
          CALL ERREX
        ENDIF
C
C PROJECT FORCE CONSTANT MATRIX AND DIPOLE DERIVATIVE MATRIX ONTO
C TOTALLY SYMMETRIC SUBSPACE FOR VIB=FINDIF CALCULATIONS
C
        IF(IVIB.EQ.3)THEN
          CALL IGETREC(20,'JOBARC','FULLORDR',IONE,IORDER)
          CALL IGETREC(20,'JOBARC','FULLNIRR',IONE,NIRREP)
          I000=N4
          I00A=I000+9*NATOMS*NATOMS
          I010=I00A+9*NATOMS*NATOMS
          I020=I010+9*NATOMS*NATOMS
          I030=I020+IORDER*9
          I040=I030+NATOMS*IORDER
          I050=I040+NATOMS
          I060=I050+NATOMS
          CALL XDCOPY(9*NATOMS*NATOMS,Z(1),1,Z(I00A),1)
          CALL PROJFCM(NATOMS,NIRREP,IORDER,Z(I00A),
     &         Z(I010),Z(I020),Z(I030),Z(I040),Z(I050),
     &         Z(I060))
          CALL XDCOPY(9*NATOMS*NATOMS,Z(I00A),1,Z(1),1)
          CALL PROJDPD(NATOMS,NIRREP,IORDER,ATMASS,Z(I00A),
     &         Z(I010),Z(I020),Z(I030),Z(I040),Z(I050),
     &         Z(I060))
          I000=N4
          I010=I000+27*NATOMS
          I020=I010+27*NATOMS
          I030=I020+IORDER*9
          I040=I030+NATOMS*IORDER
          I050=I040+NATOMS
          I060=I050+NATOMS
          I070=I060+84*NATOMS
          IF(I070.GT.MEMREQ)THEN
             WRITE(LUOUT,5020)IINTFP*I070,IINTFP*MEMREQ
 5020        FORMAT(T3,'@GEOPT-F, Not enough core.',/,
     &            T3,'Words required:',I9,' Words available:',I9)
             CALL ERREX
          ENDIF
          CALL PROJPLD(NATOMS,NIRREP,IORDER,ATMASS,Z(I000),
     &                 Z(I010),Z(I020),Z(I030),Z(I040),Z(I050),
     &                 Z(I060))
        ENDIF
C
C CONVERT TO IC AND DUMP TO DISK NOW. This block is executed
C for VIB=EXACT, FINDIF. 
C When the last argument is set to -1, the CONVHESS routine writes out the
C FCMINT file (note that any other value for this argument will not work).
C The character of the FCMINT (which coordinates it is on) depends on
C the input coordinate sytem. Note that:
C
C  1. The redundant internal coordinates (RIC) input - The incoming Hessian
C     is in Cartesian and the outgoing Hessian is in RIC
C     (not implemented yet). So, the outgoing Hessian is in Cartesians.
C
C  2. The user defined internals (ZMAT) input - The incoming Hessian is
C     in Cartesian and the outgoing Hessian is in user defined
C     internals.
C
C  3. Cartesian input - The incoming Hessian is in Cartesian
C     and the outgoing Hessian is in Cartesian.
C
C A cautionary note about the transformation of Cartesian Hessian
C to internal Hessian. Inside CONVHESS it is assumed that the
C curvature of the transformation of internal-cartesian or vice versa
C is zero. Notice the call to TWIDLE below when this Hessian
C is used as an initial guess for a transition state searches where this
C condition is no longer valid. In TWIDLE the terms that arise from
C the curvature of the transformation is evaluated and added to the
C internal Hessian. Ajith Perera, 06/2004.
C
        CALL CONVHESS(Z(N3),Z(N4),Z(1),Z(N2),Z(N1),-1)
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N6))
        CALL VIB1(Z(1),Z(N24),Z(N21),Z(N25),Z(N12),Z(N25),Z(N1),Z(N6),
     &            Z(N27), Z(N28), Z(N29), Z(N30),NRX,IStat,Z(N26))
        CALL IPUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
c YAU: leave the Hessian so we can re-run xjoda with ISOMASS files
c (A lot of single-point stuff will break, but those calcs made no
c sense without reference info anyway.)
c        CALL ACES_JA_TRUNCATE('NEXTGEOM',1)
        call rm_backup
        return
C
C Vibrational Frequency Calculations Ends!!!
C
      ELSEIF(IFLAGS(h_IFLAGS_props).EQ.3
     &       .OR.IFLAGS(h_IFLAGS_props).EQ.4
     &       .OR.IFLAGS(h_IFLAGS_props).EQ.5)THEN
C
C NMR CALCULATION, Note that the last argument is just a
C dummy argument. This is to aviod having two subroutines that
C basically do same things except for one thing. Note the
C above call to PREVIB this arguement has the gradient
C vector. In the following calls Z(N26) does not contain
C any useful info. Ajith Perera 12/2001.
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL NMR1(Z(1),Z(9*NRX+1),Z(10*NRX+1),Z(11*NRX+1),NRX)
        CALL GFNAME('JSO     ',FNAME,ILENGTH)
        INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO)
        IF(YESNO) CALL JSO1(Z(1),Z(NRX*9+1),NRX)
        CALL IPUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)
        return
      ELSEIF(IFLAGS(h_IFLAGS_props).EQ.8) THEN
C
C NMR COUPLING CONSTANT (SO CONTRIBUTION) CALCULATION
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL JSO1(Z(1),Z(NRX*9+1),NRX)
        CALL IPUTREC(20,'JOBARC','JODAOUT',IONE,IJUNK)
        return

      ELSEIF(IFLAGS(h_IFLAGS_props).EQ.9) THEN
C
C NMR COUPLING CONSTANT (FC CONTRIBUTION) CALCULATION
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL JFC1(Z(1),Z(NRX*9+1),NRX)
        CALL IPUTREC(20,'JOBARC','JODAOUT',IONE,IJUNK)
        return
      ELSEIF(IFLAGS(h_IFLAGS_props).EQ.10) THEN
C
C NMR COUPLING CONSTANT (SD CONTRIBUTION) CALCULATION
C
        CALL PREVIB(NRX,Z(1),Z(N11),Z(N26))
        NRX=NRX/3
        CALL JSD1(Z(1),Z(NRX*9+1),NRX)
        CALL IPUTREC(20,'JOBARC','JODAOUT',IONE,IJUNK)
        return
C
C At the moment we don't need anything here. All we did 
C was to create a numerical energy gradient. What you
C want to do with is up to the person who wants it. 
C
      ELSEIF((iflags2(h_IFLAGS2_grad_calc).eq.2) .AND.
     &       (iFlags2(h_IFLAGS2_geom_opt) .eq.0)) THEN 
      
           RETURN
      ENDIF
C
C*************** Frequency/Rate Cons/NMR Ends ************************
C*************** Non-vibrational calculations really begin here ******
C
C Save some information about the xy orientation of the molecule
C before taking the step.  Used later to give new geometry same
C orientation.
C
      Err        = 0
      iflags(h_IFLAGS_props) = itmp
      IF(OPTRES) CALL DGETREC(20,'JOBARC','COORD   ',NX,Q)
      Call SavOri (FPGrp, NAtoms, Q, IAtNum, At1, At2, XYOri, Err)
      IF(OPTRES) GO TO 9876
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Get gradient and Hessian from disk
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C IRecal controls how often we should look for an analytic
C Hessian.  For a "full-x" optimization, IRecal should be 1.
C IRecal get initilized in mkvmol.F (??). 
C
C NOTE: IRecal is not used elsewhere.  Eventually it should be
C used to generate input decks that insure the Hessian will be
C recalculated every IRecal steps.
C
C With the introduction of the INIT_HESSIAN keyword, we are now
C able to control the make up of the initial guess Hessian.
C Follow the notes below to see how this new key token is integrated
C to the structure that existed before without breaking it.
C Naturally, that introduces redundancies and since they
C are harmless, I will leave them as they are. Ajith Perera, 02/2005.
C
      INT_HESS = IFLAGS2(h_IFLAGS2_init_hessian)
      IF      (INT_HESS.EQ.0 .AND. IRECAL .LT. 0) THEN
                                   EXPRT_INT_HESS = "SPECIAL"
      ELSE IF (INT_HESS.EQ.1) THEN
                                   EXPRT_INT_HESS = "FCMINT "
      ELSE IF (INT_HESS.EQ.2) THEN
                                   EXPRT_INT_HESS = "MOPAC  "
      ELSE IF (INT_HESS.EQ.3) THEN
                                   EXPRT_INT_HESS = "EXACT  "
      END IF
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The COORD COMMON BLOCK/at opt. start:"
C      Write(6,*)
C      Write(6,"(3F10.5)"), (Q(I), I= 1, 3*NATOMS)
      Write(6,*)
      Write(6,"(3F10.5)") (R(I), I= 1, NXM6)
      Write(6,*)
#endif
C
C This is for those who don't want to give explicit instructions. 
C By specifying IRECAL=EVAL_HESS=n, they are telling the program
C to recalculate the SCF Hessian every n cycles, but failed to 
C specify INIT_HESSIAN=EXACT, lets do it for them here. 
C When n=0 SCF hessian generated only once at the begining 
C Ajith Perera, 07/2006. 
C
      IF (IRECAL .GE. 0 .AND. INT_HESS .EQ. 0) 
     &    EXPRT_INT_HESS = "EXACT  "  
C       
C Some assertions; Anthony is going to love this.
C
      If (EXPRT_INT_HESS .EQ. "FCMINT ") THEN
          CALL GFNAME('FCMINT  ',FNAME,ILENGTH)
          INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=FCM_EXIST)
          IF (.NOT. FCM_EXIST) THEN
             Write(6, 01)
  01         Format('INIT_HESS=FCMINT requiers a startating Hessian:',
     &              'starting Hessian matrix (FCMINT) does not exist')
             CALL ERREX
           ENDIF
      ENDIF
C
      IF (EXPRT_INT_HESS .EQ. "SPECIAL" .AND.  IRECAL .GT. 0) THEN
         Write(6, 02)
  02     Format("Inconsistent input parameters: INIT_HESS=SPECIAL ", 
     &          "and EVAL_HESS>0 is not allowed!")
         CALL ERREX
      ENDIF
C
      IHes = -1
      If (IRecal .gt. 0) then
        If (Mod(ncycle, IRecal) .eq. 0 ) IHes = 0
      Else If (IRecal .eq. 0) then
        If (ncycle .eq. 0) Then 
            IHes = 0
          IICFCM = 0
        Endif
      
      EndIf
C
C If this is the first cycle, and an internal coordinate Hessian
C is available, then snatch it. This comment is false. If there
C is an exact Cartesian Hessian then take it. 08/2008.
C
      IGRD = 0
      IF(IFLAGS2(h_IFLAGS2_geom_opt).EQ.0 .OR.
     &   IFLAGS2(h_IFLAGS2_grad_calc).EQ.2)IGRD=1
C
      Call READGH (IGRD,IHES,NATOMS,Z(N6),Z(1),Z(N1),Z(N2),IAVGRD,
     &     IAVHES)

#ifdef _DEBUG_LVL0
      Print*, "The Cart. Hessian in after reading from READGH"   
      Print*, "IAVHES flags: Cartesian exact Hess. read", IAVHES
      CALL OUTPUT(Z(1), 1, 3*NATOMS, 1, 3*NATOMS, 3*NATOMS,
     &            3*NATOMS, 1)
#endif
C
C The following comments deal with what is going on in GETICFCM.
C
C During the first cycle (ncycle=0, ihes=0), read the Internal
C coordinate Hessian from FCMINT file, if FCMINT is avilable,
C then set the IICFCM variable to 1. With the introduction of
C the INIT_HESSIAN keyword, we now know beforehand whether we are
C reading the Hessian from FCMINT file. The function IICFCM becomes
C redundant with EXPRT_INT_HESS = "FCMINT", but I will keep it intact
C since that redundancy does no harm.
C The FCMINT is generated from a prior vibrational calculation.
C Note that the Hessian read in GETICFCM is in Internal coordinates.
C
C IAVHES is 1 if there was an analytic Hessian and zero otherwise.
C This is equivalent to EXPRT_INT_HESS = "EXACT" and once again
C by keeping both does no harm. If there is an analytic Hessian then
C that Hessian is in Cartesian.
C
C Note that the logic here forces us to read FCMINT file regardless
C of whether analytic Hessian has already been read (to allow the
C user to have control over the starting Hessian).
C Ajith Perera, 07/2003.
C
C Let's assume that we have the exact Hessian and
C it is already read by READGH.F, but for some unknown
C reason, a user wanted his/her own Hessian instead. As long
C as the user put the FCMINT file in the workdir, he/she
c can accomplish that goal. The EXPRT_INT_HESS "EXACT" and
C the "FCMINT" are the redundancies.
C
C This is a messy code, in order to have a Cartesian Hessian if
C XYZIN is on, which we are writing to FCMINT (which is also
C used for internal (ZMAT) Hessian) during a vibrational
C frequency calculation with Cartesian input, is read.
C If the input is in cartesian, the Hessian written is in cartesian
C and the variables are set up to accomodate that.
C Luis Galiano, 07/2003. (I have a hard time understanding this
C comment, but I will leave it. Ajith Perera, 02/2005.)

      IICFCM=0
C
C.and. ihes .eq. 0 .and. is removed. 06/08.
C
      If (ncycle .eq.0 .and. (EXPRT_INT_HESS .eq. "FCMINT ")) THEN
C
         IF (.NOT.XYZIN) THEN
C Read internal Hessian from FCMINT file!
            CALL GETICFCM(Z(N2),NXM6,IICFCM)
            IF(IICFCM.EQ.1)IHES=-1
         ELSE
            If (iFlags2(h_IFLAGS2_geom_opt).eq.2) Then
                CALL GETICFCM(Z(N2),3*NATOMS,IICFCM)
            Else
               CALL GETICFCM(Z(1),3*NATOMS,IICFCM)
            Endif
            IF(IICFCM.EQ.1)IHES=-1
         END IF
      EndIf
#ifdef _DEBUG_LVL0
      Print*, "The Cartesian Hessian after reading fron GETICFCM"
      if (ncycle .eq.0 .and. (EXPRT_INT_HESS .eq. "FCMINT ")) then
      if (iFlags2(h_IFLAGS2_geom_opt).eq.2) Then
      CALL output(Z(N2), 1, 3*NATOMS, 1, 3*NATOMS,  3*NATOMS,
     &            3*NATOMS, 1)
      else
      CALL output(Z(1), 1, 3*NATOMS, 1, 3*NATOMS,  3*NATOMS,
     &            3*NATOMS, 1)
      endif
      endif 
#endif
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The COORD COMMON BLOCK/at opt. start:"
C      Write(6,*)
C      Write(6,"(3F10.5)") (Q(I), I= 1, 3*NATOMS)
      Write(6,*)
      Write(6,"(3F10.5)") (R(I), I= 1, NXM6)
      Write(6,*)
#endif
C
C 
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Convert gradient to internal coordinates & print it out
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C
      IF (iFlags2(h_IFLAGS2_geom_opt).eq.2) Then
          CALL XDCOPY(NOPT, Z(N6), 1, Z(N7), 1)
      ELSE
          CALL CONVQ(Z(N3), Z(N6), Z(N7), 0, 0)
      ENDIF
      CALL FORCEOUT(Z(N7))
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C If it is the first cycle and there is no Hessian read so far (IAVHES
C is equal to zero, nothing was retrieved from the call to READGH)
C and if a Hessian is needed (IHES=0), then create an approximate
C internal coordinate Hessian (1.0 in the diagonal and 0.0 in
C the off-diagonal). Once again the control is in the final argument
C which takes up the value 1 (1-IAVHESS see below). This is the
C situation when EXPRT_INT_HESS="SPECIAL". The special guess is made
C inside CONVHESS.F.
C
C If analytic Cartesian Hessian was read in READGH (IAVHESS=1), convert
C that to internal coordinates. The conditional based on IICFCM is
C very important. IICFCM is zero if no FCMINT file was present and
C so the Hessian is not read from the FCMINT file. If it is read from
C the FCMINT, it is in Internal Coordinates and the first stage of the
C transformation to Cartesian is not required and hence the call to
C CONVHESS should be avoided.
C  Ajith Perera 07/2003.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      If ( ncycle .eq. 0 .OR. IHES.EQ.0) THEN
        IF(IICFCM.EQ.0)THEN

C IAVHES = 1 (the value of the final argument to CONVHESS is Zero).
C If the Hessian is analytic (EXPRT_INT_HESS = "EXACT"), then it is in
C Cartesian. CONVHESS does the first stage of the transformation to
C internals, i.e. the part that does not involve the gradient of the B matrix.
C
C For EXPRT_INT_HESS = "MOPAC", the NDDO Hessian is read from the
C HINP file and transformed to internal coordinates.
C
C If no Hessian is read (IAVHES=0 or EXPRT_INT_HESS = "SPECIAL")
C and the final argument in CONVHESS is 1. Then CONVHESS generates
C a very crude starting Hessian (this is when no Hessian is read
C either from FCMINT or through READGH and the "MOPAC" Hessian is
C not available). Then a call to TWIDLE is made if the calculation is a
C transition state search. I can identify what goes in TWIDLE
C as the second part of the transformation of Cartesian Hessian
C to internal Hessian (the one that involves the derivative of B-matrix).
C But then, should it not be called for the EXPRT_INT_HESS = "EXACT",
C EXPRT_INT_HESS = "MOPAC", and EXPRT_INT_HESS = "FCMINT"? (All these
C are Cartesian Hessian to start with and CONVHESS only does the
C first stage of the transformation and I thought TWIDLE is
C the one that does the second stage - that is wrong). Whatever
C happens in TWIDLE only effects the Internal Hessian generated
C by an educated guess. In my view, in all three other options (EXACT, MOPAC,
C and FCMINT), the transformation to internals assumes that the
C gradient at that point is zero. This might be fair, since a harmonic
C frequency normally assumes that anyway. Ajith Perera, 02/2005.
C
C If the FCMINT file is generated via a vibrational frequency calculation,
C there is no reason to be here (EXPRT_INT_HESS = "FCMINT" since during
C the frequency calculation, transformation to internals is carried
C out by controlling the final argument to CONVHESS (-1). See above
C vibrational frequency block for further explanation. The overloading
C CONVHESS (generating approximate Hessian in internals, first stage of
C the transformation to internal, and writing the FCMINT file to disk)
C has caused enormous amounts of pain when tried to change or
C understand what is going on there. OVERLOADING should be avoided at
C ALL COST. Ajith Perera 05/2004.

           IF (EXPRT_INT_HESS.EQ."MOPAC  ".AND.IAVHES.EQ.0) THEN
C
C MOPAC Hessian in Cartesians Z(1) or internals Z(N2) if no exact Hessian
C is read!
C 
              CALL IGETREC(1,'JOBARC','NREALATM',IONE,NREAL)
              CALL IGETREC(1,'JOBARC','LINEAR  ',IONE,ILINEAR)
              NREAL3   = 3*NREAL
              NREAL3M6 = 3*NREAL - 6 + ILINEAR
              CALL GET_MOPAC_HESS(Z(N3), Z(N4), Z(N5), Z(1), Z(N2),
     &                            Z(N1), NATOMS, NX, NXM6, NREAL,
     &                            NREAL3, NREAL3M6)
#ifdef _DEBUG_LVL0
       Write(6,*)
       Print*, "The Cart. Hessian generated by MOPAC"
       CALL OUTPUT(Z(1), 1, 3*NATOMS, 1, 3*NATOMS, 3*NATOMS,
     &             3*NATOMS, 1)
#endif
C
           ELSE IF (EXPRT_INT_HESS.EQ."SPECIAL".AND.IAVHES.EQ.0) THEN
C 
C Educated guess Hessian in internal or redundent internals Z(N2)!
C
#ifdef _DEBUG_LVL0
       Write(6,*)
       Print*, "Entering convhess:form an educated guess4hess"
       Write(6,*)
#endif        
              CALL CONVHESS(Z(N3),Z(N4),Z(1),Z(N2),Z(N1),1-IAVHES)
C
           ELSE IF (.NOT. XYZIN .AND. IAVHES.EQ.1) THEN
C
C Cartesian exact Hessian is read Z(1), do part of the transformation 
C that does not depends on the derivative of the B matrix!
C
#ifdef _DEBUG_LVL0
       Print*, "Entering convhess:piece of cart2int transformation"
       Print*, "IAVHES: ", IAVHES
#endif 
            CALL CONVHESS(Z(N3),Z(N4),Z(1),Z(N2),Z(N1),-IAVHES)

           END IF

C       ENDIF(IICFCM.EQ.0)
        ENDIF
C
C If redundant internals are used and Cartesian Hessian exists, then
C convert it into redundant internals. This is only needed for
C transition state searches. Let's document the conditional to call
C CHESS:
C
C   TS_SEARCH - simple, applies only for transition state searches.
C   XYZIN .AND. IAVHES.EQ.1   -- RIC (XYZIN=TRUE) and analytic Cartesian
C                                Hessian is available (EXACT).
C   XYZIN .AND. IICFCM .EQ. 1 -- Hessian is read from FCMINT. Note
C                                that the approx. Hessian is generated
C                                from a frequency calculation and it
C                                is in Cartesian.
C   IICFCM .EQ.0              -- An educated guess at the initial Hessian
C                                in internals is made in CONVHESS.F
C
C What is happening in TWIDLE should have been done somewhere else.
C It is actually the part that involves gradient and derivative of B
C matrix in the transformation of Cartesian Hessian to Internal
C Hessians. This comment may be wrong. The TWIDLE is not called
C for when the initial Hessian is EXACT, MOPAC, or read from the
C FCMINT file. If the comment is correct, that should have been
C the case. The call to TWIDLE is made for educated guess Hessian
C (SPECIAL) which is in internal to begin with. Ajith Perera, 02/2005.
C
C In the case of RIC TS searches, this part of the transformation
C (Cartesian to internal) is taken care of in CART2INT_HESS).
C
        IMPORT_CART_HESS = (EXPRT_INT_HESS .EQ. "FCMINT " .OR.
     &                      EXPRT_INT_HESS .EQ. "MOPAC  " .OR. 
     &                      EXPRT_INT_HESS .EQ. "EXACT  " ) 
C
        IF (IMPORT_CART_HESS .AND. XYZIN .AND.
     &      iFlags2(h_IFLAGS2_geom_opt).ge.3) THEN
#ifdef _DEBUG_LVL0
       Print*, "The RIC: Importing Cartesian Hessian",
     &          IMPORT_CART_HESS
       Print*, "The Cart. Hessian in geopt-before CART2INT"
       CALL OUTPUT(Z(1), 1, 3*NATOMS, 1, 3*NATOMS, 3*NATOMS,
     &             3*NATOMS, 1)
#endif
C
           CALL CART2INT_HESS(Z(N7),Z(1),TOTREDNCO,NATOMS,Z(N2))
        END IF
C
C FORCE CURVILINEAR <-- RECTILINEAR TRANSFORMATION IF TS SEARCH
C AND TRANSFORMATION HAS NOT BEEN TURNED OFF BY EXTERNAL
C REQUEST (ICURVY>1).
C
CSSS        IF (.NOT.XYZIN) THEN
C
           IF (iFlags2(h_IFLAGS2_geom_opt).eq.1) Then
           IF (IMPORT_CART_HESS .AND. ICURVY.EQ.0) ICURVY = 1 
           IF (IMPORT_CART_HESS .AND. ICURVY.EQ.0 .AND. 
     &         ICURVY .GT. 1) WRITE(6,9920)
 9920      FORMAT(T3,' Transformation to curvilinear coordinates ',
     &               'has been turned off.')
C
#ifdef _DEBUG_LVL0
       Print*, "Importing Cartesian Hessian",IMPORT_CART_HESS,
     &          ICURVY
       Print*, "The Partialy trans. Cart. Hessian in geopt-before" 
       Print*, "TWIDLE"
       CALL OUTPUT(Z(N2), 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
#endif
           IF (ICURVY .EQ. 1) THEN
              CALL TWIDLE(Z(N3),Z(N2),Z(N7),Z(N25),Z(N21),
     &                    Z(N22),Z(N23),Z(N24),Z(N26))
           END IF
        END IF
C
C DO NOT WRITE OUT WHOLE HESSIAN UNLESS IT HAS BEEN SPECIFICALLY
C REQUESTED.  THIS CAN EVENTUALLY BE MADE INTO AN ADJUSTABLE
C PARAMETER, BUT WILL BE IN CODE FOR NOW.
C
CSSS        IF(IPRNT.GE.10) THEN
CSSS          CALL HESSOUT(Z(N2),NXM6,NXM6,0)
CSS        ENDIF
C
C The logic for cycles other than the first cycle begins here.
C Also, note that regeneration of a new Hessian rather than an
C update is requested by the user once every N cycles. During
C the regeneration cycles, it follows the same path as the first
C cycle.
C
      ELSE
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C otherwise update the Hessian, flags(18)=itmpIUPD=2 GIVES BFGS; 
C IUPD=1 GIVES POWELL.
C The Hessian update routine was modified to
C improve the readability and to add new methods. The new additions
C include Murtagh-Sargent update and the mixture, Phi*Powel + (1 - Phi)
C Murtagh-Sargent  (JCC vol 15 pg 1 1994). For minima searches, the
C default is set to BFGS update, and for transition state searches, the
C mixture of Powel and Murtagh-Sargent using Bofill's weighted update
C (see above formula). Ajith Perera, 11, 2004.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
        IUPD = IFLAGS2(h_IFLAGS2_hess_update)
        CALL HUPDATE(Z(N7), Z(N2), Z(1), Z(N9), Z(N10), IUPD)
      END IF
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Compute the step (in internal coordinates
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C SAVE HESSIAN FOR ARCHIVING BEFORE IT IS DESTROYED IN STEP TAKING
C EMPTY Z(N11) FIRST
C
      CALL ZERO(Z(N10), NXM6 * NXM6)
      CALL ZERO(Z(N1), NXM6)
      CALL ZERO(Z(N8), NXM6*NXM6)
      CALL VADD(Z(N8), Z(N2), Z(N10), NXM6 * NXM6, 1.D0)
C
C SET FLAG WHICH DETERMINES DIMENSION OF AUGMENTED HESSIAN, WHICH IS
C USED IN RFA AND TS SEARCHES.  NEED TO BE CAREFUL ABOUT NR AND MANR
C OPTIONS, HOWEVER, SINCE THESE MAY BE SWITCHED TO RFA IF HESSIAN HAS
C NEGATIVE EIGENVALUES.  FORCE DIMENSION TO BE (NOPT+1) FOR EVERYTHING
C BUT TS, WHERE IS MUST BE NOPT.
C
      IAUGHS = 1
CSSS      IF(INR .EQ. 4 .OR. INR .EQ. 5) IAUGHS=0
C
C Copy the updated Hessian for approximate frequencies in the final
C iteration. We need to keep a copy of the Hessian because tkstep will
C symmetrize it. Ajith Perera. 05/2005.
C
      CALL DCOPY(NXM6*NXM6, Z(N2), 1, Z(N25), 1)
      CALL TKSTEP(Z(N7), Z(N2), Z(1), Z(N14), Z(N15), Z(N1), Z(N16),
     &            Z(N17), Z(N18), Z(N19), Z(N20), Z(N3), Z(N25),
     &            Z(N4), Z(N31), Z(N32), IAUGHS)
CSSS     &            Z(N4), IAUGHS)

c   TKSTEP calls SUMMARY, which may or may not signal the completion of the 
c   calculation.  So we must check for completion (JODADONE=1), and unwind
c   the calling stack to the main program if JODAODNE == 1.

      call igetrec(1,'JOBARC', 'JODADONE', 1, jodadone)
      if (jodadone .eq. 1) return
C
C Save the energy of the current step for the trust
C radius step size control algorithm. 11/04, Ajith Perera.
      ione = 1
      call dgetrec(1,'JOBARC','TOTENERG',ione,TotEng)
      call dputrec(1,'JOBARC','OLDENERG',1,TotENg)

C Save the gradient of current step and the geometry for the
C line search algorithm. 12/04, Ajith Perera
c      call xdscal(nopt, -1.0D0, Z(nopt+1), 1)
c      call xdaxpy(nopt, 1.0D0, Z(1),  1, Z(nopt+1), 1)
      call dputrec(1,'JOBARC','OLDGRADS',NXM6,Z(N7))
c      call dputrec(1,'JOBARC','OLDGEOMT',NOPT,Z(NOPT+1))

      IF ( ncycle .GE. iflags(h_IFLAGS_opt_maxcyc)) then
        Write (LuErr,*) '*Maximum number of optimization steps ',
     $       'exceeded.'

        jodadone = 1
        call iputrec(1,'JOBARC', 'JODADONE', 1, jodadone) 
        return
      EndIf
 9876 CONTINUE
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Generate new cartesian coordinates from internals and determine
C the point group.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      IF (XYZIN .AND. (iFlags2(h_IFLAGS2_geom_opt).ge.3)) THEN
         CALL PROCESTEP_XYZ(Z(1), Z(N3), TOTREDNCO)
C
C Here I force, NX=3*NATOMS so that symmetry.F would not complain
C when it tries to retrieve the Cartesian coordinates (the record
C length is 3*NATOMS regardles of the number of internal coordinates).
C Note that NX is set back again to MAX(TOREDUNCO, 3*NATOMS) just
C before archiving. Ajith Perera, 10/2002
C
         NX = 3*NATOMS
C
      ELSE IF ((iFlags2(h_IFLAGS2_geom_opt).eq.2)) THEN
C
         CALL DCOPY(NX, R, 1, Q, 1) 
         CALL DPUTREC(20, 'JOBARC', 'COORD_OP', NX, Q)
C
#ifdef _DEBUG_LVL0
           Write(6,*)
           Write(6,"(a,a)") "Updating the new 3*natoms geometries",
     &     " for Cartesian optimizations"
           Write(6, "(a)") "The Cartesian coords:"
           Write(6, "(3F10.5)") (Q(I), I=1, NX)
#endif
C
      ELSE 
         CALL GMETRY(We_havegeom, .TRUE.)
      ENDIF
      CALL SYMMETRY(Z(N11), Z(N12), Z(N13), .TRUE.)
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Do some fudging with the orientations
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Eventually, symmetry will always leave the molecule in Cotton's
C orientation and orientation "fudging" to accomodate specific
C integral packages will be done here.
C
C It is possible (in a few points groups like C2v & maybe D2h)
C for the relative orders of the moments of inertia to switch
C from one step to the next.  This effectively interchanges
C the x and y axes, and thus some of the irreps -- wreaking havoc
C on occupations specified by symmetry irrep.  The solution is
C to base everything on the orientation of the zeroeth step.
C
c      IF(INR.NE.6)Call FixOri (NAtoms, Q, At1, At2, XYOri)
C
      Call FixOri (NAtoms, Q, At1, At2, XYOri)
      ITMP=IPRNT
      IF(PGRP.EQ.FPGRP)IPRNT=0
      IOFF=N19+1+120*9+NATOMS*9
      MLTINT=IINTFP*(MEMREQ-N19)
      If (iFlags(h_IFLAGS_sym).GT.0) CALL SYMDRV(Z(IOFF),Z(N19),
     &                               MLTINT,IOFF,PGRP,'COMP')
      If (iFlags(h_IFLAGS_sym).GT.0) CALL SYMDRV(Z(IOFF),Z(N19),
     &                               MLTINT,IOFF,FPGRP,'FULL')
      IPRNT=ITMP
C
C print out coordintes and distance matrix
C Note that all orientation fudging has already been done. These
C coordinates should match the integral program's except for
C permutations of equivalent atoms.
C
      Call GeomOut
      Call ADM

C  make input decks for the integral program using new coordinates
C
      If (IntTyp.Eq.0) Then
cYAU         Call MkAbIn (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
cYAU     &                GenBy, Z(N11), IStat)
           write(*,*) '@GEOPT: MkAbin was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
CJDW 9/20/96. Allow for Seward (currently must make MOL file).
CADY 5/06/04. Allow for GAMESS (currently must make MOL file).
      Else If (IntTyp .eq. 1 .or.
     &         IntTyp .eq. 2 .or.
     &         IntTyp .eq. 5 .or.
     &         IntTyp .eq. 4) Then
         Call MkVMol (q, PGrp, NAtoms, NUnique, ZSym, IAtNum,
     &                GenBy, Z(N11), IStat, BasNam)
         if (iflags(h_IFLAGS_guess).eq.2) then
            call mknddo(q, PGrp, NAtoms, NUnique, ZSym, IAtNum, GenBy,
     &                  Z(N11), IStat, BasNam)
         end if
      Else If (IntTyp .eq. 3) Then
cYAU         Call MkCadp (PGrp, NAtoms, NUnique, ZSym, IAtNum, Q,
cYAU     &                GenBy, IStat)
           write(*,*) '@GEOPT: MkCadp was temporarily removed.'
           write(*,*) '        This calculation cannot complete.'
           call errex
      End If
C
C************************ For the Future additions *****************
C
      If (Mod(IStat,2) .eq. 1) then
         Call ErrEx
      Else If (IStat .eq. 8 .OR. IStat .eq. 10) then
         IStat = 0
         Write (LuErr, 9810)
C        Eventually we will want to do more things here...
C        Probably want to change to program to chain to
C        Probably want to write out a CON file or similar
      End IF

c o save the information about this step to disk
c THE GRADIENT IS IN Z(N7)
c THE HESSIAN  IS IN Z(N8)
C
      NX = MAX(TOTREDNCO, 3*NATOMS)
      IF (.NOT.OPTRES) CALL ARCHIVE(E,Z(N7),Z(N8),Z(N1),1,Z(N18))
      IF (IPRNT.EQ.999) WRITE(LUOUT,8888) (I,Z(I),I=1,N27)
      CALL IPUTREC(20,'JOBARC','JODAOUT ',IONE,IJUNK)

      IF (NCYCLE.GE.IFLAGS(h_IFLAGS_opt_maxcyc)) THEN
         WRITE(LUOUT,*)
     &      '@GEOPT: Maximum number of optimization cycles exceeded.'
         WRITE(LUOUT,*)
     &      '        Geometry optimization failed.'
         CALL ERREX
      END IF

c     FORMAT STATEMENTS USED MORE THAN ONCE
 8888 FORMAT(T3,'@GEOPT: Dump of core vector:',/,
     &       T5,'Element',T40,'Value',/,(T5,I6,T36,E15.10))
 9810 FORMAT(T3,'@GEOPT: Standard ACES2 routing impossible. ',/,
     &       T3,'        User must supply gradient and Hessian.')

      return
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__DERV_DEF_BLOCKS
     +
     +               ( ZMAX,
     +                 NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                 SHELLA,SHELLB,SHELLC,SHELLD,
     +                 SHELLP,SHELLQ,
     +                 NIJ,NKL,
     +                 NRS,NTU,NRSTU,
     +                 NGQP,NGQSCR,
     +                 NXYZT,
     +                 DERAX,DERAY,DERAZ,
     +                 DERBX,DERBY,DERBZ,
     +                 DERCX,DERCY,DERCZ,
     +                 DERDX,DERDY,DERDZ,
     +                 DERPX,DERPY,DERPZ,
     +                 DERQX,DERQY,DERQZ,
     +                 PRIMTYP,
     +                 L1CACHE,NCTROW,
     +                 MEMORY,
     +
     +                     NIJBLK,NKLBLK,
     +                     NBATCH,
     +                     NPSIZE,NCSIZE,NWSIZE,
     +                     NINT2DX,NINT2DY,NINT2DZ,
     +                     MXPRIM,MNPRIM,
     +                     ZCBATCH,ZPBATCH,ZWORK,
     +                     ZNORMA,ZNORMB,ZNORMC,ZNORMD,
     +                     ZRHOAB,ZRHOCD,
     +                     ZP,ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCPK2,
     +                     ZQ,ZQX,ZQY,ZQZ,ZQCX,ZQCY,ZQCZ,ZQINVHF,ZSCQK2,
     +                     ZRTS,ZWTS,ZGQSCR,ZTVAL,ZPQPINV,ZSCPQK4,
     +                     ZB00,ZB01,ZB10,
     +                     ZC00X,ZC00Y,ZC00Z,ZD00X,ZD00Y,ZD00Z,
     +                     ZEXP2A,ZEXP2B,ZEXP2C,ZEXP2D,
     +                     ZINT2DX,ZINT2DY,ZINT2DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_DEF_BLOCKS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the memory partitions for the
C                generation of the entire contracted derivated (e0|cd)
C                or (ab|cd) batch. It determines the block size
C                partitions (if any) for the ij and kl exponent paris
C                of the whole primitive derivated [e0|cd] or [ab|cd]
C                batch and returns pointers to the flp data sections
C                needed by the (e0|cd) or (ab|cd) generation.
C
C                The routine is also equipped with the possibility
C                of returning just the minimum / optimum flp memory
C                needed, without evaluating the (e0|cd) or (ab|cd)
C                generation flp pointers. This is useful for
C                establishing just the overall memory size needed for
C                the (e0|cd) or (ab|cd) generation. The keyword MEMORY
C                has to be set true for this case and obviously the
C                value of ZMAX passed is irrelevant.
C
C
C                  Input:
C
C                    ZMAX         =  maximum flp memory
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x=A,B,C,D
C                    SHELLx       =  the shell type for csh x=A,B,C,D
C                    SHELLP(Q)    =  the shell sums for csh: A+B (C+D)
C                    NIJ(KL)      =  total # of ij(kl) primitive
C                                    index pairs corresponding to
C                                    the csh pairs A,B(C,D)
C                    NRS(TU)      =  total # of rs(tu) contraction
C                                    index pairs corresponding to
C                                    the csh pairs A,B(C,D)
C                    NRSTU        =  total # of rstu contraction
C                                    index quadruplets (= NRS*NTU)
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    NXYZT        =  total # of cartesian monomial
C                                    quadruplets
C                    DERyp        =  the order of differentiation on
C                                    centers y = A,B,C,D with respect
C                                    to the p = x,y,z coordinates
C                                    and their sums y=P,Q=A+B,C+D
C                    PRIMTYP      =  character variable, indicating
C                                    which type of primitives will
C                                    be generated and contracted. Can
C                                    be only 'E0CD' or 'ABCD'
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    MEMORY       =  if this keyword is true, the
C                                    routine will only determine the
C                                    minimum / optimum flp memory and
C                                    store these values into NIJBLK and
C                                    NKLBLK, respectively (see below)
C
C                  Output:
C
C                    NIJ(KL)BLK   =  block sizes for the ij(kl)
C                                    primitive indices in order to
C                                    perform efficient contractions.
C                    NBATCH       =  size of the integral batch array
C                                    during primitive integral block
C                                    generation. This array is also
C                                    needed for 2D integral derivative
C                                    evaluation, hence its size might
C                                    be larger than the final primitive
C                                    integral block
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays
C                    NINT2Dx      =  space needed for the 2D x=X,Y,Z
C                                    integral arrays. They are usually
C                                    not equal due to derivations
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i,j,k,l primitives,
C                                    i.e. = max (i,j,k,l)
C                    MNPRIM       =  the minimum # of primitives
C                                    between i and j primitives and
C                                    k and l primitives and form the
C                                    maximum between these two values,
C                                    i.e. = max (min(i,j),min(k,l))
C                    Z.....       =  pointers for space partition of
C                                    the flp array (see below)
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                    |  Zone 1  |  Zone 2  |  Zone 3  |
C
C
C                   Zone 1: final contracted (e0|cd) or (ab|cd) batch
C                   Zone 2: complete set of A,B,C,D norms and
C                           complete set (after screening!) of
C                           exponential prefactors 
C                   Zone 3: will be used at two different stages:
C                            i) during derivated primitive [e0|cd]
C                               or [ab|cd] block generation
C                           ii) during the contraction stage
C
C
C                While the first two Zones are straightforward in
C                their definition, Zone 3 requires some more detailed
C                explanation:
C
C                 Stage i) : During this stage the primitive blocks
C                            have to be assembled from the derivated
C                            2D integrals, which in turn are generated
C                            in single derivative steps. The derivation
C                            of the 2D integrals needs an extra work
C                            space for accumulation, which will be
C                            provided at the same memory location where
C                            the final primitive block will be. This
C                            can be done, because the primitive block
C                            can only be assembled after! all the
C                            derivated 2D integrals are ready.
C
C                Stage ii) : This stage needs the primitive blocks
C                            plus some workspace for performing the
C                            two partial contraction steps.
C
C
C                Memory allocation offsets for the primitive [e0|cd]/
C                [ab|cd] batches generation + contraction to (e0|cd)/
C                (ab|cd):
C
C
C                  --- Zone 1 ---
C
C                   ZCBATCH = offset for contracted (e0|cd) or (ab|cd)
C                             batch
C
C                  --- Zone 2 ---
C
C                   ZNORMA = offset for all A norms
C                   ZNORMB = offset for all B norms
C                   ZNORMC = offset for all C norms
C                   ZNORMD = offset for all D norms
C
C                   ZRHOAB = offset for all AB exponential prefactors
C                   ZRHOCD = offset for all CD exponential prefactors
C
C                  --- Zone 3: for Stage i) only ---
C
C                   ZPBATCH = offset for derivated 2D integrals
C                             accumulation work space and for
C                             (blocked) derivated [e0|cd] or [ab|cd]
C                             batch (K4)
C
C                   ZP = offset for (blocked) P values (K2)
C                   ZPX = offset for (blocked) PX values (K2)
C                   ZPY = offset for (blocked) PY values (K2)
C                   ZPZ = offset for (blocked) PZ values (K2)
C                   ZPAX = offset for (blocked) PAX values (K2)
C                   ZPAY = offset for (blocked) PAY values (K2
C                   ZPAZ = offset for (blocked) PAZ values (K2)
C                   ZPINVHF = offset for (blocked) 1/2P values (K2)
C                   ZSCPK2 = offset for (blocked) P scale values (K2)
C
C                   ZQ = offset for (blocked) Q values (K2)
C                   ZQX = offset for (blocked) QX values (K2)
C                   ZQY = offset for (blocked) QY values (K2)
C                   ZQZ = offset for (blocked) QZ values (K2)
C                   ZQCX = offset for (blocked) QCX values (K2)
C                   ZQCY = offset for (blocked) QCY values (K2
C                   ZQCZ = offset for (blocked) QCZ values (K2)
C                   ZQINVHF = offset for (blocked) 1/2Q values (K2)
C                   ZSCQK2 = offset for (blocked) Q scale values (K2)
C
C                   ZRTS = offset for (blocked) quad roots (K4)
C                   ZWTS = offset for (blocked) quad weights (K4)
C                   ZGQSCR = offset for (blocked) quad scratch (K4)
C                   ZTVAL = offset for (blocked) T exponents (K4)
C                   ZPQPINV = offset for (blocked) 1/(P+Q) values (K4)
C                   ZSCPQK4 = offset for (blocked) PQ scale values (K4)
C
C                   ZB00 = offset for (blocked) VRR coeff B00 (K4)
C                   ZB01 = offset for (blocked) VRR coeff B01 (K4)
C                   ZB10 = offset for (blocked) VRR coeff B10 (K4)
C                   ZC00X = offset for (blocked) VRR coeff C00X (K4)
C                   ZC00Y = offset for (blocked) VRR coeff C00Y (K4)
C                   ZC00Z = offset for (blocked) VRR coeff C00Z (K4)
C                   ZD00X = offset for (blocked) VRR coeff D00X (K4)
C                   ZD00Y = offset for (blocked) VRR coeff D00Y (K4)
C                   ZD00Z = offset for (blocked) VRR coeff D00Z (K4)
C
C                   ZEXP2A = offset for 2 x A-exponent values (K4)
C                   ZEXP2B = offset for 2 x B-exponent values (K4)
C                   ZEXP2C = offset for 2 x C-exponent values (K4)
C                   ZEXP2D = offset for 2 x D-exponent values (K4)
C
C                   ZINT2DX = offset for (blocked) derivative 2DX
C                             integrals accumulation (K4)
C                   ZINT2DY = offset for (blocked) derivative 2DY
C                             integrals accumulation (K4)
C                   ZINT2DZ = offset for (blocked) derivative 2DZ
C                             integrals accumulation (K4)
C
C                  --- Zone 3: for Stage ii) only ---
C
C                   ZPBATCH = offset for (blocked) derivated [e0|cd]
C                             or [ab|cd] batch (K4)
C
C                   ZWORK = offset for contraction working array
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     MEMORY

         CHARACTER*4   PRIMTYP

         INTEGER     DERAX,DERBX,DERCX,DERDX
         INTEGER     DERAY,DERBY,DERCY,DERDY
         INTEGER     DERAZ,DERBZ,DERCZ,DERDZ
         INTEGER     DERPX,DERPY,DERPZ
         INTEGER     DERQX,DERQY,DERQZ
         INTEGER     IJDIV,KLDIV
         INTEGER     ISHELLX,ISHELLY,ISHELLZ
         INTEGER     L1CACHE,NCTROW
         INTEGER     M,N
         INTEGER     MIJ,MKL,MIJKL,MRSKL
         INTEGER     MIJBIG,MKLBIG
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSTEP
         INTEGER     NBATCH
         INTEGER     NIJ,NKL
         INTEGER     NIJBLK,NKLBLK
         INTEGER     NINT2DX,NINT2DY,NINT2DZ
         INTEGER     NGQP,NGQSCR,MGQIJKL
         INTEGER     NPGTOA,NPGTOB,NPGTOC,NPGTOD
         INTEGER     NPMINRS,NPMINTU
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NRS,NTU,NRSTU
         INTEGER     NXYZT
         INTEGER     PFACT
         INTEGER     POW2IJ,POW2KL
         INTEGER     PSHELL
         INTEGER     SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER     SHELLP,SHELLQ
         INTEGER     SHELLX,SHELLY,SHELLZ
         INTEGER     WCOL
         INTEGER     ZONE1,ZONE2,ZONE3,ZONE3B,ZONE3C
         INTEGER     ZMAX
         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,ZNORMC,ZNORMD,
     +               ZRHOAB,ZRHOCD,
     +               ZP,ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCPK2,
     +               ZQ,ZQX,ZQY,ZQZ,ZQCX,ZQCY,ZQCZ,ZQINVHF,ZSCQK2,
     +               ZRTS,ZWTS,ZGQSCR,ZTVAL,ZPQPINV,ZSCPQK4,
     +               ZB00,ZB01,ZB10,ZC00X,ZC00Y,ZC00Z,ZD00X,ZD00Y,ZD00Z,
     +               ZEXP2A,ZEXP2B,ZEXP2C,ZEXP2D,
     +               ZINT2DX,ZINT2DY,ZINT2DZ

         DOUBLE PRECISION   DLOG2

         PARAMETER  (DLOG2  =  0.6931471805599D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine optimum size of [e0|cd] or [ab|cd] blocks:
C
C                The next few lines of code are among the most
C                important for performance of the entire integral
C                derivative package. Any badly chosen sizes for the
C                primitive blocks has a severe effect on the integral
C                derivative evaluation timing. Two opposite effects
C                have to be considered:
C
C                1) Reuse level 1 cache data as much as possible,
C                   i.e. choose the primitive blocks in such a
C                   way that most of the heavy computational work
C                   is being done reusing data in each cache line.
C
C                2) Choose the size of the primitive blocks as
C                   large as possible observing point 1), to reduce
C                   subroutine call overheads as much as possible.
C
C                After some experimenting, the following procedure
C                was found to work best:
C
C                  i) The optimum [e0|cd]/[ab|cd] block size is
C                     assumed to be directly proportional to the
C                     level 1 cache size.
C
C                 ii) The proportionality factor PFACT has to be
C                     determined by 'experiment', running a real
C                     molecular case with fully contracted basis sets.
C
C                iii) After having found the optimum # of exponent
C                     quadruplets per [e0|cd]/[ab|cd] block, it is best
C                     to choose the IJ-part as large as possible,
C                     keeping the KL-part size to a minimum. The
C                     reason behind this is that a KL-part size
C                     of 1 does not trigger an intermediate IJ <-> KL
C                     transposition during the contraction procedure.
C
C                Note, that the difference between the [e0|cd] or
C                [ab|cd] block case is in the size of the # of
C                monomials quadruplets, which is given by the variable
C                NXYZT.
C
C
         PFACT = 4

         MIJKL = PFACT * L1CACHE / NXYZT
         MIJKL = MAX (1,MIJKL)

         MIJ = MIN (MIJKL,    NIJ)
         MKL = MIN (MIJKL/MIJ,NKL)
C
C
C
C             ...the optimum block sizes MIJ x MKL have been found.
C                We have to see now how it fits with the rest of
C                the needed data into the maximum memory given.
C                If necessary subdivide the optimum MIJ x MKL block
C                size into convenient subblocks that fit into memory.
C                Note, that the primitive array must also hold the
C                intermediate halftransformed contracted integrals.
C
C                The subdivision of the MIJ x MKL block is done in
C                such a way that successive powers of 2 are checked
C                as divisors of MIJ and MKL. Only one of the divisors
C                is incremented in each trial step. The maximum #
C                of steps MXSTEP can thus be calculated beforehand
C                by knowing the fact that the smallest subdivided
C                MIJ x MKL block is of size 1 x 1. The succesive
C                divisors are checked in the following order:
C
C
C                        step  |  div of MIJ  |  div of MKL
C                       ------------------------------------
C                          1   |       1      |      1
C                          2   |       1      |      2
C                          3   |       2      |      2
C                          4   |       2      |      4
C                          5   |       4      |      4
C                          6   |       4      |      8
C                          7   |       8      |      8
C                         ...         ...           ...
C
C                The routine stops, if even a MIJ x MKL block of
C                minimum size 1 x 1 cannot be accomodated into the
C                memory.
C
C
C
         IF (PRIMTYP.EQ.'E0CD') THEN

             SHELLX =   (SHELLP + 1)
     +                * (SHELLQ + DERQX + 1)
     +                * MIN ((SHELLC + DERCX + 1),(SHELLD + DERDX + 1))
             SHELLY =   (SHELLP + 1)
     +                * (SHELLQ + DERQY + 1)
     +                * MIN ((SHELLC + DERCY + 1),(SHELLD + DERDY + 1))
             SHELLZ =   (SHELLP + 1)
     +                * (SHELLQ + DERQZ + 1)
     +                * MIN ((SHELLC + DERCZ + 1),(SHELLD + DERDZ + 1))

             PSHELL = MAX (SHELLX,SHELLY,SHELLZ)

             ISHELLX =   (SHELLP + 1)
     +                 * (SHELLC + DERCX + 1)
     +                 * (SHELLD + DERDX + 1)
             ISHELLY =   (SHELLP + 1)
     +                 * (SHELLC + DERCY + 1)
     +                 * (SHELLD + DERDY + 1)
             ISHELLZ =   (SHELLP + 1)
     +                 * (SHELLC + DERCZ + 1)
     +                 * (SHELLD + DERDZ + 1)
         ELSE
             SHELLX =   (SHELLP + DERPX + 1)
     +                * (SHELLQ + DERQX + 1)
     +                * MIN ((SHELLA + DERAX + 1),(SHELLB + DERBX + 1))
     +                * MIN ((SHELLC + DERCX + 1),(SHELLD + DERDX + 1))
             SHELLY =   (SHELLP + DERPY + 1)
     +                * (SHELLQ + DERQY + 1)
     +                * MIN ((SHELLA + DERAY + 1),(SHELLB + DERBY + 1))
     +                * MIN ((SHELLC + DERCY + 1),(SHELLD + DERDY + 1))
             SHELLZ =   (SHELLP + DERPZ + 1)
     +                * (SHELLQ + DERQZ + 1)
     +                * MIN ((SHELLA + DERAZ + 1),(SHELLB + DERBZ + 1))
     +                * MIN ((SHELLC + DERCZ + 1),(SHELLD + DERDZ + 1))

             PSHELL = MAX (SHELLX,SHELLY,SHELLZ)

             ISHELLX =   (SHELLA + DERAX + 1)
     +                 * (SHELLB + DERBX + 1)
     +                 * (SHELLC + DERCX + 1)
     +                 * (SHELLD + DERDX + 1)
             ISHELLY =   (SHELLA + DERAY + 1)
     +                 * (SHELLB + DERBY + 1)
     +                 * (SHELLC + DERCY + 1)
     +                 * (SHELLD + DERDY + 1)
             ISHELLZ =   (SHELLA + DERAZ + 1)
     +                 * (SHELLB + DERBZ + 1)
     +                 * (SHELLC + DERCZ + 1)
     +                 * (SHELLD + DERDZ + 1)
         END IF

         NPMINRS = MIN (NPGTOA,NPGTOB)
         NPMINTU = MIN (NPGTOC,NPGTOD)

         NCSIZE  = NXYZT * NRSTU

         MXPRIM = MAX (NPGTOA,NPGTOB,NPGTOC,NPGTOD)
         MNPRIM = MAX (NPMINRS,NPMINTU)

         ZONE2 = NPGTOA + NPGTOB + NPGTOC + NPGTOD + NIJ + NKL
C
C
C             ...if the MEMORY keyword is activated, the routine
C                will only determine the optimum and minimum flp
C                memory (in that order), place them respectively
C                into the NKLBLK and NIJBLK variables and exit.
C
C
         IF (MEMORY) THEN

             MIJKL   = MIJ * MKL
             MGQIJKL = NGQP * MIJKL
             NINT2DX = MGQIJKL * ISHELLX
             NINT2DY = MGQIJKL * ISHELLY
             NINT2DZ = MGQIJKL * ISHELLZ
             MRSKL   = NRS * MKL
             NBATCH  = MAX (MGQIJKL*PSHELL,NXYZT*MIJKL)
             NPSIZE  = NXYZT * MAX (MIJKL,MRSKL)
             WCOL    = MNPRIM
             NWSIZE  = NPSIZE + NCTROW * WCOL
             ZONE1   = NCSIZE
             ZONE3B  = NBATCH + NINT2DX + NINT2DY + NINT2DZ
     +                 + NGQSCR + 2*MIJKL + 9*(MIJ+MKL) + 16*MGQIJKL
             ZONE3C  = NPSIZE + NWSIZE
             ZONE3   = MAX (ZONE3B,ZONE3C)

             NKLBLK  = ZONE1 + ZONE2 + ZONE3

             MIJ     = 1
             MKL     = 1
             MIJKL   = MIJ * MKL
             MGQIJKL = NGQP * MIJKL
             NINT2DX = MGQIJKL * ISHELLX
             NINT2DY = MGQIJKL * ISHELLY
             NINT2DZ = MGQIJKL * ISHELLZ
             MRSKL   = NRS * MKL
             NBATCH  = MAX (MGQIJKL*PSHELL,NXYZT*MIJKL)
             NPSIZE  = NXYZT * MAX (MIJKL,MRSKL)
             WCOL    = MNPRIM
             NWSIZE  = NPSIZE + NCTROW * WCOL
             ZONE1   = NCSIZE
             ZONE3B  = NBATCH + NINT2DX + NINT2DY + NINT2DZ
     +                 + NGQSCR + 2*MIJKL + 9*(MIJ+MKL) + 16*MGQIJKL
             ZONE3C  = NPSIZE + NWSIZE
             ZONE3   = MAX (ZONE3B,ZONE3C)

             NIJBLK  = ZONE1 + ZONE2 + ZONE3

             RETURN

         ELSE
C
C
C             ...the actual fitting into the maximum memory given.
C
C

             POW2IJ = DLOG ( DFLOAT (MIJ) ) / DLOG2
             POW2KL = DLOG ( DFLOAT (MKL) ) / DLOG2

             MXSTEP = 2*MIN (POW2IJ,POW2KL) + ABS (POW2IJ - POW2KL) + 1

             MIJBIG = MIJ
             MKLBIG = MKL

             IJDIV = 1
             KLDIV = 1

             DO 100 N = 1,MXSTEP

                MIJ = MAX (1, MIJBIG / IJDIV )
                MKL = MAX (1, MKLBIG / KLDIV )

                MIJKL   = MIJ * MKL
                MGQIJKL = NGQP * MIJKL
                NINT2DX = MGQIJKL * ISHELLX
                NINT2DY = MGQIJKL * ISHELLY
                NINT2DZ = MGQIJKL * ISHELLZ
                MRSKL   = NRS * MKL
                NBATCH  = MAX (MGQIJKL*PSHELL,NXYZT*MIJKL)
                NPSIZE  = NXYZT * MAX (MIJKL,MRSKL)
                WCOL    = MNPRIM
                NWSIZE  = NPSIZE + NCTROW * WCOL
                ZONE1   = NCSIZE
                ZONE3B  = NBATCH + NINT2DX + NINT2DY + NINT2DZ
     +                    + NGQSCR + 2*MIJKL + 9*(MIJ+MKL) + 16*MGQIJKL
                ZONE3C  = NPSIZE + NWSIZE
                ZONE3   = MAX (ZONE3B,ZONE3C)

                IF (ZONE1+ZONE2+ZONE3.LE.ZMAX) THEN

                    NIJBLK = MIJ
                    NKLBLK = MKL
                    NWSIZE = ZMAX - ZONE1 - ZONE2 - NPSIZE
C
C
C             ...generate the memory allocation pointers.
C
C
                    ZCBATCH = 1

                    ZNORMA = ZCBATCH + NCSIZE
                    ZNORMB = ZNORMA + NPGTOA
                    ZNORMC = ZNORMB + NPGTOB
                    ZNORMD = ZNORMC + NPGTOC

                    ZRHOAB = ZNORMD + NPGTOD
                    ZRHOCD = ZRHOAB + NIJ

                    ZPBATCH = ZRHOCD + NKL

                    ZP = ZPBATCH + NBATCH
                    ZPX = ZP + MIJ
                    ZPY = ZPX + MIJ
                    ZPZ = ZPY + MIJ
                    ZPAX = ZPZ + MIJ
                    ZPAY = ZPAX + MIJ
                    ZPAZ = ZPAY + MIJ
                    ZPINVHF = ZPAZ + MIJ
                    ZSCPK2 = ZPINVHF + MIJ

                    ZQ = ZSCPK2 + MIJ
                    ZQX = ZQ + MKL
                    ZQY = ZQX + MKL
                    ZQZ = ZQY + MKL
                    ZQCX = ZQZ + MKL
                    ZQCY = ZQCX + MKL
                    ZQCZ = ZQCY + MKL
                    ZQINVHF = ZQCZ + MKL
                    ZSCQK2 = ZQINVHF + MKL

                    ZRTS = ZSCQK2 + MKL
                    ZWTS = ZRTS + MGQIJKL
                    ZGQSCR = ZWTS + MGQIJKL
                    ZTVAL = ZGQSCR + NGQSCR
                    ZPQPINV = ZTVAL + MIJKL
                    ZSCPQK4 = ZPQPINV + MIJKL

                    ZB00 = ZSCPQK4 + MGQIJKL
                    ZB01 = ZB00 + MGQIJKL
                    ZB10 = ZB01 + MGQIJKL
                    ZC00X = ZB10 + MGQIJKL
                    ZC00Y = ZC00X + MGQIJKL
                    ZC00Z = ZC00Y + MGQIJKL
                    ZD00X = ZC00Z + MGQIJKL
                    ZD00Y = ZD00X + MGQIJKL
                    ZD00Z = ZD00Y + MGQIJKL

                    ZEXP2A = ZD00Z + MGQIJKL
                    ZEXP2B = ZEXP2A + MGQIJKL
                    ZEXP2C = ZEXP2B + MGQIJKL
                    ZEXP2D = ZEXP2C + MGQIJKL

                    ZINT2DX = ZEXP2D + MGQIJKL
                    ZINT2DY = ZINT2DX + NINT2DX
                    ZINT2DZ = ZINT2DY + NINT2DY

                    ZWORK = ZPBATCH + NPSIZE

                    RETURN
                END IF

                IF (MIJ.EQ.1) THEN
                    KLDIV = KLDIV * 2
                ELSE IF (MKL.EQ.1) THEN
                    IJDIV = IJDIV * 2
                ELSE
                    M = MOD (N+1,2)
                    IJDIV = IJDIV * (M+1)
                    KLDIV = KLDIV * (2-M)
                END IF

  100        CONTINUE

             WRITE (*,*) ' Memory allocation failed for derv blocks ! '
             WRITE (*,*) ' NIJ,NKL,MIJ,MKL = ',NIJ,NKL,MIJ,MKL
             WRITE (*,*) ' Increase flp memory! '
             WRITE (*,*) ' (erd__derv_def_blocks) '

             STOP

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ASSIGN_LABELS (IREDUNCO, TOTREDNCO, TOTNOFBND,
     &                          TOTNOFANG, TOTNOFDIH,INTLABEL)
C 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C Labels all the redundant coordinates according to whether they
C are bonds,angles or dihedrals
C
#include "mxatms.par"
C
      INTEGER TOTREDNCO,TOTNOFBND,TOTNOFANG,TOTNOFDIH
      DIMENSION IREDUNCO(4,TOTREDNCO)
      CHARACTER*4 INTLABEL(TOTREDNCO)
      CHARACTER*3 LABEL(MAXREDUNCO)
C
      DATA MONE/-1/, MTWO/-2/
      do i = 1, min(9,MAXREDUNCO)
         write(label(i),'(2i1)') 0, i
      end do
      do i = 10, min(99,MAXREDUNCO)
         write(label(i),'(i2)') i
      end do
      do i = 100, MAXREDUNCO
         write(label(i),'(i3)') i
      end do
C
      DO 10 I=1,TOTNOFBND
            IF (IREDUNCO(4,I).EQ.0) THEN
                 INTLABEL(I)='R'//LABEL(I)
            END IF
 10   CONTINUE
            
      DO 20 I=TOTNOFBND+1, (TOTREDNCO-TOTNOFDIH)
            IF (IREDUNCO(4,I).LE.MONE) THEN
                 INTLABEL(I)='A'//LABEL(I-TOTNOFBND)
            END IF
 20   CONTINUE
 
      DO 30 I=TOTNOFBND+TOTNOFANG+1,TOTREDNCO
            IF (IREDUNCO(4,I).GT.0) THEN
                INTLABEL(I)='D'//LABEL(I-TOTNOFBND-TOTNOFANG)
            END IF
 30   CONTINUE
  
C      We may avoid scanning 3 times the whole totrednco simply by getting
C      TOTNOFBND,TOTNOFANG,TOTNOFDIH (1-->TOTNOFBND,TOTNOFBND+1 -->...

      RETURN
      END
   

c This routine switches off the timing statistics that are printed by
c aces_fin.

      subroutine aces_time_hush
      implicit none
#include "aces_time.com"
      ame_timed = .false.
      return
      end

      SUBROUTINE SPINAD1(IRREP,NUM1,DIS,A,SCR,ISCR)
C
C THIS ROUTINE SPIN ADAPTS A MATRIX A BY
C
C  A(I,J,K,L) ----> 2*A(I,J,K,L)-A(I,J,L,K) 
C
C NOTE THAT THE SPIN ADAPTION IS CARRIED OUT HERE IN PLACE AND
C ONLY TWO ADDITIONAL ARRAYS OF SIZE NUM ARE REQUIRED
C
C INPUT : IRREP .......... IRREP OF THE GIVEN PAR OF A
C         NUM1 ........... POPULATION VECTOR OF I AND J
C         DIS ............ DISTRIBUTION SIZE OF A
C         A .............. INPUT MATRIX A
C         SCR,ISCR ....... TWO SCRATCH ARRAYS OF DIMENSION DIS
C
C  OUTPUT : A ............ SPIN ADAPTED MATRIX A
C 
CEND
C
C CODED SEPTEMBER/90  JG
C
C The SCR array is no longer needed, but the reference is kept for
C   compatibility.
C SG 6/95
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIS,DIRPRD
      DIMENSION A(DIS,1),SCR(1),ISCR(2),NUM1(8),IP(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
C
      DATA TWO /2.0D+00/
C
      IP(1)=0
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IP(IRREPJ+1)=IP(IRREPJ)+NUM1(IRREPJ)*NUM1(IRREPI)
10    CONTINUE
       
C
C  GET FIRST THE NEW ADDRESSES AND STORE THEM IN ISCR
C
      NTOTAL=0
      DO 20  IRREPJ=1,NIRREP
       NUMJ=NUM1(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUM1(IRREPI)
       NTOTAL=NTOTAL+NUMI*NUMJ
       DO 15 J=1,NUMJ
       DO 15 I=1,NUMI
        IND1=IP(IRREPJ)+(J-1)*NUMI+I
        IND2=IP(IRREPI)+(I-1)*NUMJ+J
        ISCR(IND1)=IND2
15     CONTINUE
20    CONTINUE
C
C  NOW SPIN ADAPT A
C
      DO 100 IJ=1,NTOTAL
C
C  IF THIS ELEMENT HAS BEEN ALREADY TREATED SKIP
C
       IF(ISCR(IJ).NE.0) THEN
C
C  GET ADDRESS OF TRANPOSED ELEMENT AND SET IT TO ZERO
C
        IJTR=ISCR(IJ)  
        ISCR(IJTR)=0
        IF(IJ.NE.IJTR) THEN
C
C  SPIN ADAPT A(IJ,L) and A(IJTR,L)
C
CDIR$ IVDEP
*VOCL LOOP,NOVREC
         DO 5 L=1,DIS
          TEMP = A(L,IJ)
          A(L,IJ) = TWO*A(L,IJ) - A(L,IJTR)
          A(L,IJTR) = TWO*A(L,IJTR) - TEMP
5        CONTINUE
C
        ENDIF
       ENDIF
C
C ALL DONE FOR IJ AND IJTR
C
100   CONTINUE 
C
      RETURN
      END

      SUBROUTINE FILPOP
C
C FILLS THE SYMMETRY POPULATION VECTOR COMMON BLOCK.
C
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*6 SYMLST(22)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),NTOT(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      DATA SYMLST /'SVAVA0','SVBVB0','SOAOA0','SOBOB0',
     &             'SVAVA1','SVBVB1','SOAOA1','SOBOB1',
     &             'SVAOA2','SVBOB2','SOBVA2','SVBOA2',
     &             'SVAVB2','SOAOB2','SVAVB2','SOAVA2',
     &             'SOBVB2','SOAVB2','SVAVA2','SVBVB2',
     &             'SOAOA2','SOBOB2'/
      CALL IZERO(IRPDPD,144)
      DO 10 ITYPE=1,22
       CALL GETREC(-1,'JOBARC',SYMLST(ITYPE)//'X ',NIRREP,
     &             IRPDPD(1,ITYPE))
10    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_NAO_RESULTS
     +
     +                    ( UNITID,
     +                      NBAS,NATOM,
     +                      MXSHELL,
     +                      NSHELLS,SHELLS,NBASAL,
     +                      ZATOM,
     +                      LSIZE,
     +                      POPCOR,POPVAL,POPRYD,POPSUM,
     +                      NAOTYP,
     +                      ANGSYM,
     +                      LOCAL,
     +                      W )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_NAO_RESULTS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints the final results of the natural
C                atomic population analysis to the output file specified
C                by its unit identification number.
C
C                The following is printed:
C
C                   1) The occupation numbers (weights) of the
C                      final NAO's and their characterization as
C                      Core, Valence and Rydberg type orbitals.
C
C                   2) A population chart indicating the natural
C                      atomic populations broken down in Core,
C                      Valence and Rydberg populations, together
C                      with the overall natural atomic charges
C                      for each atomic center.
C
C                   3) The NAO atomic localization map.
C
C
C                  Input:
C
C                    UNITID       =  printout unit identification #
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atoms
C                    MXSHELL      =  largest l-shell value
C                    NSHELLS (A)  =  # of l-shells for atom A.
C                    SHELLS (I,A) =  I-th l-shell type (s=0,p=1,etc...)
C                                    for atom A (in increasing order!).
C                    NBASAL (I,A) =  size of I-th atomic l-shell space
C                                    for atom A.
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    LSIZE (I)    =  I-th l-shell size
C                    POPxxx (A)   =  # of electrons populating the
C                                    Core, Valence, Rydberg and all
C                                    NAOs on atom A (xxx = COR,VAL,
C                                    RYD and SUM, respectively).
C                    NAOTYP (I)   =  integer 2,1 or 0, identifying
C                                    the type of NAO encountered for
C                                    the I-th NAO (= 2 for Core, = 1
C                                    for Valence and = 0 for Rydberg).
C                    ANGSYM (I)   =  angular symmetry of I-th NAO.
C                                    This is equal to the lowest l-shell
C                                    value that can mix with the I-th
C                                    NAO and is dependent on the site
C                                    symmetry of the atom to which the
C                                    I-th NAO belongs.
C                    LOCAL (A,I)  =  NAO atom locality map for each
C                                    atom A and I-th NAO.
C                    W            =  NAO weight vector.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     FIRST

         CHARACTER*2   ATCHAR
         CHARACTER*1   BAR,DASH
         CHARACTER*3   LSTATE,LSYM
         CHARACTER*7   NAOCHAR

         CHARACTER*2   ATSYMB  (1:104)
         CHARACTER*3   LSYMB   (0:7)
         CHARACTER*7   NAOSYMB (0:2)

         INTEGER     ATOM
         INTEGER     BASNR
         INTEGER     I,L,N
         INTEGER     LDIM,LTOT,LTYPE
         INTEGER     MXSHELL
         INTEGER     NBAS,NATOM
         INTEGER     NAL
         INTEGER     NLTYPE
         INTEGER     UNITID
         INTEGER     ZVAL

         INTEGER     ANGSYM  (1:NBAS)
         INTEGER     LSIZE   (0:MXSHELL)
         INTEGER     NAOTYP  (1:NBAS)
         INTEGER     NSHELLS (1:NATOM)
         INTEGER     ZATOM   (1:NATOM)

         INTEGER     NBASAL  (1:MXSHELL+1,1:NATOM)
         INTEGER     SHELLS  (1:MXSHELL+1,1:NATOM)

         DOUBLE PRECISION  CHARGE,WEIGHT
         DOUBLE PRECISION  TOTCHG,TOTCOR,TOTVAL,TOTRYD,TOTSUM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  POPCOR  (1:NATOM)
         DOUBLE PRECISION  POPVAL  (1:NATOM)
         DOUBLE PRECISION  POPRYD  (1:NATOM)
         DOUBLE PRECISION  POPSUM  (1:NATOM)
         DOUBLE PRECISION  W       (1:NBAS)

         DOUBLE PRECISION  LOCAL (1:NATOM,1:NBAS)

         DATA ATSYMB /' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     +                'Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca',
     +                'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     +                'Ga','Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr',
     +                'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     +                'Sb','Te',' I','Xe','Cs','Ba','La','Ce','Pr','Nd',
     +                'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     +                'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     +                'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     +                'Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     +                'Md','No','Lr','xx'/
         DATA  BAR     /'|'/
         DATA  DASH    /'-'/
         DATA  LSYMB   /' s ',' p ',' d ',' f ',' g ',' h ',' i ','> i'/
         DATA  NAOSYMB /'Rydberg','Valence','   Core'/

         PARAMETER  (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...print out header.
C
C
         WRITE (UNITID,8000) 'Natural atomic orbital analysis'
 8000    FORMAT (//,20X,A31,//)
C
C
C             ...print out header of occupation analysis.
C
C
         WRITE (UNITID,9000) 'NAO #',BAR,'Atom',BAR,'Atom #',BAR,
     +                       'L-state',BAR,'L-sym',BAR,'NAO-type',BAR,
     +                       'Occupancy'
         WRITE (UNITID,9010) (DASH,I=1,72)
C
C
C             ...print out occupation analysis.
C
C
         BASNR = 0
         DO 1000 ATOM = 1,NATOM
            ZVAL = ZATOM (ATOM)

            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            FIRST = .TRUE.
            NLTYPE = NSHELLS (ATOM)
            DO 2000 N = 1,NLTYPE

               NAL = NBASAL (N,ATOM)
               LTYPE = SHELLS (N,ATOM)
               LDIM = LSIZE (LTYPE)
               LTOT = NAL * LDIM

               IF (LTYPE.GT.6) THEN
                   LSTATE = LSYMB (7)
               ELSE
                   LSTATE = LSYMB (LTYPE)
               END IF

               LTYPE = ANGSYM (BASNR+1)

               IF (LTYPE.GT.6) THEN
                   LSYM = LSYMB (7)
               ELSE
                   LSYM = LSYMB (LTYPE)
               END IF

               NAOCHAR = NAOSYMB (NAOTYP (BASNR+1))
               WEIGHT = W (BASNR+1)

               IF (FIRST) THEN
                   WRITE (UNITID,9020) BASNR+1,BAR,ATCHAR,BAR,ATOM,BAR,
     +                                 LSTATE,BAR,LSYM,BAR,NAOCHAR,BAR,
     +                                 WEIGHT
                   FIRST = .FALSE.
               ELSE
                   WRITE (UNITID,9030) BASNR+1,BAR,BAR,BAR,
     +                                 LSTATE,BAR,LSYM,BAR,NAOCHAR,BAR,
     +                                 WEIGHT
               END IF

               DO 100 L = 2,LTOT
                  LTYPE = ANGSYM (BASNR+L)
                  IF (LTYPE.GT.6) THEN
                      LSYM = LSYMB (7)
                  ELSE
                      LSYM = LSYMB (LTYPE)
                  END IF

                  NAOCHAR = NAOSYMB (NAOTYP (BASNR+L))
                  WEIGHT = W (BASNR+L)

                  WRITE (UNITID,9030) BASNR+L,BAR,BAR,BAR,
     +                                LSTATE,BAR,LSYM,BAR,NAOCHAR,BAR,
     +                                WEIGHT
  100          CONTINUE

               BASNR = BASNR + LTOT

 2000       CONTINUE
            WRITE (UNITID,9010) (DASH,I=1,72)
 1000    CONTINUE
C
C
C             ...formats for printing occupation analysis.
C
C
 9000    FORMAT (1X,A5,1X, A1, 1X,A4,1X, A1, 1X,A6,1X, A1,
     +           1X,A7,1X, A1, 1X,A5,1X, A1, 1X,A8,1X, A1,
     +           5X,A9,5X)
 9010    FORMAT (1X,90A1)
 9020    FORMAT (2X,I3,2X, A1, 2X,A2,2X, A1, 2X,I3,3X, A1,
     +           3X,A3,3X, A1, 2X,A3,2X, A1, 2X,A7,1X, A1,
     +           1X,F16.14)
 9030    FORMAT (2X,I3,2X, A1, 2X,2X,2X, A1, 2X,3X,3X, A1,
     +           3X,A3,3X, A1, 2X,A3,2X, A1, 2X,A7,1X, A1,
     +           1X,F16.14)
C
C
C             ...print out header for the population analysis.
C
C
         WRITE (UNITID,9040) 'Population Analysis'
 9040    FORMAT (//,20X,A19,//)

         WRITE (UNITID,9050) 'Atom',BAR,'Atom #',BAR,'Charge',BAR,
     +                       'Core',BAR,'Valence',BAR,
     +                       'Rydberg',BAR,'Sum (C+V+R)'
         WRITE (UNITID,9060) (DASH,I=1,90)
C
C
C             ...print out the population analysis.
C
C
         TOTCHG = ZERO
         TOTCOR = ZERO
         TOTVAL = ZERO
         TOTRYD = ZERO
         TOTSUM = ZERO

         DO 3000 ATOM = 1,NATOM
            ZVAL = ZATOM (ATOM)

            IF (ZVAL.LT.1 .OR. ZVAL.GT.103) THEN
                ATCHAR = ATSYMB (104)
            ELSE
                ATCHAR = ATSYMB (ZVAL)
            END IF

            CHARGE = DFLOAT (ZVAL) - POPSUM (ATOM)

            TOTCHG = TOTCHG + CHARGE
            TOTCOR = TOTCOR + POPCOR (ATOM)
            TOTVAL = TOTVAL + POPVAL (ATOM)
            TOTRYD = TOTRYD + POPRYD (ATOM)
            TOTSUM = TOTSUM + POPSUM (ATOM)

            WRITE (UNITID,9070) ATCHAR,BAR,ATOM,BAR,CHARGE,BAR,
     +                          POPCOR (ATOM),BAR,POPVAL (ATOM),BAR,
     +                          POPRYD (ATOM),BAR,POPSUM (ATOM)
 3000    CONTINUE
         WRITE (UNITID,9060) (DASH,I=1,90)
         WRITE (UNITID,9080) 'Total',BAR,TOTCHG,BAR,TOTCOR,BAR,
     +                       TOTVAL,BAR,TOTRYD,BAR,TOTSUM

 9050    FORMAT (1X,A4,1X,     A1, 1X,A6,1X,     A1, 4X,A6,4X,     A1,
     +           5X,A4,5X,     A1, 4X,A7,3X,     A1,
     +           4X,A7,3X,     A1, 2X,A11)
 9060    FORMAT (1X,90A1)
 9070    FORMAT (2X,A2,2X,     A1, 2X,I3,3X,     A1, 1X,F12.8,1X,  A1,
     +           1X,F12.8,1X,  A1, 1X,F12.8,1X,  A1,
     +           1X,F12.8,1X,  A1, 1X,F12.8)
 9080    FORMAT (           5X,A5,5X,            A1, 1X,F12.8,1X,  A1,
     +           1X,F12.8,1X,  A1, 1X,F12.8,1X,  A1,
     +           1X,F12.8,1X,  A1, 1X,F12.8)
C
C
C             ...print out the NAO atomic localization map.
C
C
         WRITE (UNITID,9090) 'NAO Atomic Localization Map'
 9090    FORMAT (//,20X,A27)

         CALL    MAT__PRINT_A_FLOAT_3_NOZEROS
     +
     +                ( UNITID,
     +                  ' Rows = Atoms ; Columns = NAOs ',
     +                  NATOM,NBAS,
     +                  NATOM,NBAS,
     +                  LOCAL )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__REORDER_MATRIX_COLUMNS
     +
     +                    ( DDROW,DDCOL,
     +                      DDORDER,
     +                      DDUSED,
     +                      DDWORK,
     +                      ROW,COL,
     +                      ORDER,
     +                      USED,
     +                      WORK,
     +                      C )
     +
C------------------------------------------------------------------------
C  OPERATION   : MAT__REORDER_MATRIX_COLUMNS
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This routine reorders columns of input matrix C
C                according to a new ordering defined in array ORDER.
C                The ordering is done in place, hence C is overwritten
C                by the reordered matrix. Definition of the ordering
C                array is in the active sense:
C
C                      ORDER (old column #) = new column #
C
C                Example:
C
C                Let C be:
C
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C                          1  2  3  4  5  6  7  8
C
C                then, if ORDER is equal to:
C
C                              ORDER (1) = 5
C                              ORDER (2) = 2
C                              ORDER (3) = 1
C                              ORDER (4) = 6
C                              ORDER (5) = 8
C                              ORDER (6) = 3
C                              ORDER (7) = 7
C                              ORDER (8) = 4
C
C                the matrix C on exit looks like:
C
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C                          3  2  6  8  1  4  7  5
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     DDORDER
         INTEGER     DDROW,DDCOL
         INTEGER     DDUSED
         INTEGER     DDWORK
         INTEGER     I,J,N
         INTEGER     NEWCOL
         INTEGER     ROW,COL

         INTEGER     ORDER (1:DDORDER)
         INTEGER     USED  (1:DDUSED)

         DOUBLE PRECISION  CVAL

         DOUBLE PRECISION  WORK (1:DDWORK)

         DOUBLE PRECISION  C (1:DDROW,1:DDCOL)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF  (ROW.GT.DDROW .OR. COL.GT.DDCOL) THEN
              WRITE (*,*) ' Dimensions of matrix C too small! '
              WRITE (*,*) ' mat__reorder_matrix_columns '
              WRITE (*,*) ' DDROW,DDCOL,ROW,COL = ',DDROW,DDCOL,ROW,COL
              WRITE (1,*) ' Dimensions of matrix C too small! '
              WRITE (1,*) ' mat__reorder_matrix_columns '
              WRITE (1,*) ' DDROW,DDCOL,ROW,COL = ',DDROW,DDCOL,ROW,COL
              STOP
         END IF

         IF  (ROW.GT.DDWORK) THEN
              WRITE (*,*) ' Dimensions of array WORK too small! '
              WRITE (*,*) ' mat__reorder_matrix_columns '
              WRITE (*,*) ' DDWORK,ROW = ',DDWORK,ROW
              WRITE (1,*) ' Dimensions of array WORK too small! '
              WRITE (1,*) ' mat__reorder_matrix_columns '
              WRITE (1,*) ' DDWORK,ROW = ',DDWORK,ROW
              STOP
         END IF

         IF  (COL.GT.DDORDER) THEN
              WRITE (*,*) ' Dimensions of array ORDER too small! '
              WRITE (*,*) ' mat__reorder_matrix_columns '
              WRITE (*,*) ' DDORDER,COL = ',DDORDER,COL
              WRITE (1,*) ' Dimensions of array ORDER too small! '
              WRITE (1,*) ' mat__reorder_matrix_columns '
              WRITE (1,*) ' DDORDER,COL = ',DDORDER,COL
              STOP
         END IF

         IF  (COL.GT.DDUSED) THEN
              WRITE (*,*) ' Dimensions of array USED too small! '
              WRITE (*,*) ' mat__reorder_matrix_columns '
              WRITE (*,*) ' DDUSED,COL = ',DDUSED,COL
              WRITE (1,*) ' Dimensions of array USED too small! '
              WRITE (1,*) ' mat__reorder_matrix_columns '
              WRITE (1,*) ' DDUSED,COL = ',DDUSED,COL
              STOP
         END IF
C
C
C             ...check the reordering array passed. It might have
C                column indices out of range, that is numbers > COL.
C
C
         DO J = 1,COL
            NEWCOL = ORDER (J)
            IF (NEWCOL.GT.COL) THEN
                WRITE (*,*) ' Column # out of meaningful range! '
                WRITE (*,*) ' mat__reorder_matrix_columns '
                WRITE (*,*) ' NEWCOL,J,COL = ',NEWCOL,J,COL
                WRITE (1,*) ' Column # out of meaningful range! '
                WRITE (1,*) ' mat__reorder_matrix_columns '
                WRITE (1,*) ' NEWCOL,J,COL = ',NEWCOL,J,COL
                STOP
            END IF
         END DO
C
C
C             ...initialize used column array and start loop over
C                all cycles.
C
C
         DO J = 1,COL
            USED (J) = 0
         END DO

         DO 1000 J = 1,COL
            IF (USED (J).EQ.0) THEN
                NEWCOL = ORDER (J)
C
C
C             ...handle current cycle, if not of length 1.
C                Inner loop over dummy index N runs over all
C                # of columns to ensure that end of cycle is
C                reached.
C
C
                IF (NEWCOL.NE.J) THEN

                    USED (NEWCOL) = 1
                    DO I = 1,ROW
                       WORK (I) = C (I,NEWCOL)
                       C (I,NEWCOL) = C (I,J)
                    END DO

                    DO N = 1,COL
                       NEWCOL = ORDER (NEWCOL)
                       USED (NEWCOL) = 1
                       DO I = 1,ROW
                          CVAL = C (I,NEWCOL)
                          C (I,NEWCOL) = WORK (I)
                          WORK (I) = CVAL
                       END DO
                       IF (NEWCOL.EQ.J) GOTO 1000
                    END DO

                END IF

            END IF
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine write_default_sial_programs(calc,dropmo,ref,geom_opt,
     *                                       vib, excite, instab, props,
     *                                       grad_calc, density,
     *                                       dip_calc, dea_calc,
     *                                       jobflow)
c-------------------------------------------------------------------------
c   Writes the SIAL_PROGRAM parameters for a default set of SIAL programs
c   determined by the parameters calc, dropmo, ref, geom_opt, and vib.
c   The SIAL_PROGRAM parameters are written to ZMAT.AUTO.
c-------------------------------------------------------------------------
      implicit none
      integer calc,dropmo,ref,geom_opt, vib, excite, instab, props
      integer grad_calc, density, dea_calc, dip_calc, dip_singlet_root,
     &        dip_triplet_root, dea_singlet_root, dea_triplet_root
      character*80 jobflow
      integer ierr
      integer n, str_trimlen

c---------------------------------------------------------------------------
c   Determine the jobflow required for the combination of parameters.
c---------------------------------------------------------------------------

c      print *,'ref, calc, dropmo, geom_opt, vib ',
c     *   ref, calc, dropmo, geom_opt, vib, excite
      jobflow = 'UNDEFINED'

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'SCF_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'SCF_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'SCF_RHF_GRADIENT'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'SCF_UHF_GRADIENT'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'SCF_RHF_HESSIAN'     ! analytical hessian calc
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 0 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 3) then
         if (grad_calc .eq. 2) then
            jobflow = 'SCF_RHF_ENERGY'    ! numerical gradient calc
         else
            jobflow = 'SCF_RHF_GRADIENT'    ! numerical hessian calc
         endif 
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'SCF_UHF_HESSIAN'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'SCF_UHF_ENERGY'
         else
            jobflow = 'SCF_UHF_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'MP2_RHF_HESSIAN'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'MP2_RHF_ENERGY'
         else
            jobflow = 'MP2_RHF_GRADIENT'
         endif
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 1)) then
         jobflow = 'MP2_UHF_HESSIAN'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'MP2_UHF_ENERGY'
         else
            jobflow = 'MP2_UHF_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'MP2_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .eq. 0 .and. vib .eq. 0) then
         jobflow = 'MP2_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'MP2_RHF_GRADIENT'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 1 .and.
     *    geom_opt .gt. 0) then
         jobflow = 'MP2_UHF_GRADIENT'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_RHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'LCCSD_UHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'LCCSD_RHF_ENERGY'
         else
            jobflow = 'LCCSD_RHF_GRADIENT'
         endif
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'LCCSD_UHF_ENERGY'
         else 
            jobflow = 'LCCSD_UHF_GRADIENT'
         endif  
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         jobflow = 'LCCSD_RHF_DROPMO_GRADIENT'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 6 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         jobflow = 'LCCSD_UHF_DROPMO_GRADIENT'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_DROPMO_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_RHF_ENERGY'
         else
            jobflow = 'CCSD_RHF_GRADIENT'
         endif
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_UHF_ENERGY'
         else
            jobflow = 'CCSD_UHF_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_RHF_DROPMO_ENERGY'
         else
            jobflow = 'CCSD_RHF_DROPMO_GRADIENT'
         endif 
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 10 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .gt. 0 .or. vib .eq. 3)) then
         if (grad_calc .eq. 2) then
            jobflow = 'CCSD_UHF_DROPMO_GRADIENT'
         else
            jobflow = 'CCSD_UHF_DROPMO_GRADIENT'
         endif
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 22 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_TRIPLES_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 22 .and.
     *    dropmo .eq. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_TRIPLES_ENERGY'
      endif

      if (ref .eq. 0 .and.
     *    calc .eq. 22 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_RHF_DROPMO_TRIPLES_ENERGY'
      endif

      if (ref .eq. 1 .and.
     *    calc .eq. 22 .and.
     *    dropmo .ne. 0 .and.
     *    (geom_opt .eq. 0 .and. vib .eq. 0)) then
         jobflow = 'CCSD_UHF_DROPMO_TRIPLES_ENERGY'
      endif

      n = str_trimlen(jobflow)
      if (instab .gt. 0) jobflow((n+1):(n+7)) = '_INSTAB'

      if (excite .eq. 3) then
         if (ref .eq. 0 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0) then
            jobflow = 'EOM_RHF_CCSD_ENERGY'
         endif

         if (ref .eq. 0 .and.
     *       calc .eq. 10 .and.
     *       dropmo .ne. 0) then
            jobflow = 'EOM_RHF_CCSD_DROPMO_ENERGY'
         endif

         if (ref .eq. 1 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0) then
            jobflow = 'EOM_UHF_CCSD_ENERGY'
         endif

         if (ref .eq. 1 .and.
     *       calc .eq. 10 .and.
     *       dropmo .ne. 0) then
            jobflow = 'EOM_UHF_CCSD_DROPMO_ENERGY'
         endif
C
C   Watson
C
         if (ref .eq. 0 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0  .and.
     *       props  .eq. 1)   then
            jobflow = 'EOM_RHF_CCSD_DENS_ENERGY'
         endif

         if (ref .eq. 1 .and.
     *       calc .eq. 10 .and.
     *       dropmo .eq. 0  .and.
     *       props   .eq. 1)  then
            jobflow = 'EOM_UHF_CCSD_DENS_ENERGY'
         endif
C
C   Watson
C
      endif
C
C Ajith Perera, 07/2013. The isotropic Hyperfine coupling
c Constants.
C

      if (ref .eq. 1 .and. Calc .eq. 0 .and. props .eq. 1)
     &   jobflow = 'HF_AISO'

      if (ref .eq. 1 .and. Calc .eq. 1 .and. props .eq. 1)
     &   jobflow = 'MBPT2_AISO'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. props .eq. 1 .and.
     &   density .eq. 0) jobflow = 'CCSD_RELAX_DENS_AISO'

      if (ref .eq. 1 .and. Calc .eq. 22 .and. props .eq. 1 .and.
     &   density .eq. 0) jobflow = 'CCSDT_RELAX_DENS_AISO'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. props .eq. 1 .and.
     &   density .eq. 1) jobflow = 'CCSD_RESPONSE_DENS_AISO'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. props .eq. 1 .and.
     &   density .eq. 0 .and. dropmo .ne. 0)
     &   jobflow = 'CCSD_RELAX_DENS_DROPMO_AISO'

C
C EOM-DIP and DEA (singlets and triplets)
C
C
C EOM-DIP and DEA (singlets and triplets)
C
      call Igetrec(-1,'JOBARC','DIPSYMA ',1, dip_singlet_root)
      call Igetrec(-1,'JOBARC','DIPSYMB ',1, dip_triplet_root)

      call Igetrec(-1,'JOBARC','DEASYMA ',1, dea_singlet_root)
      call Igetrec(-1,'JOBARC','DEASYMB ',1, dea_triplet_root)

      if (ref .eq. 0 .and. Calc .eq. 10 .and.dip_calc .eq. 2 .and.
     &    dip_singlet_root .gt. 0) jobflow = 'EOMDIP_CCSD_SINGLET'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. dip_calc .eq. 2 .and.
     &    dip_triplet_root .gt. 0) jobflow = 'EOMDIP_CCSD_TRIPLET'

      if (ref .eq. 0 .and. Calc .eq. 10 .and. dea_calc .eq. 2 .and.
     &    dea_singlet_root .gt. 0) jobflow = 'EOMDEA_CCSD_SINGLET'

      if (ref .eq. 1 .and. Calc .eq. 10 .and. dea_calc .eq. 2 .and.
     &    dea_triplet_root) jobflow = 'EOMDEA_CCSD_TRIPLET'

      n = str_trimlen(jobflow)
      print *,'Using Default jobflow = ',jobflow(1:n)
      call find_default_jobflow(jobflow(1:n), ierr)
      if (ierr .eq. 0) then
         call write_default_jobflow(22, jobflow(1:n))
      else
         print *,'Error: Cannot find jobflow ',jobflow(1:n),
     *           ' in default_jobflows file.'
         call abort_job()
      endif

      return
      end

      subroutine find_default_jobflow(jobflow, ierr)
c---------------------------------------------------------------------------
c   Position default_jobfiles file to desired jobflow.  ierr > 0 indicates
c   the jobflow was not found.
c---------------------------------------------------------------------------
      implicit none
      character*(*) jobflow
      integer ierr

      character*256 fn, envvar
      character*80 line

      integer iunit, ios, lenenv, n, str_trimlen

c--------------------------------------------------------------------------
c   Check for existence of $ACES_EXE_PATH/sial_config
c--------------------------------------------------------------------------

      iunit = 12

      call c_getenv('ACES_EXE_PATH'//char(0), envvar, lenenv, ierr)
      if (ierr .eq. 0) then
         fn = envvar(1:lenenv) // '/sio/default_jobflows'
         open (unit=iunit, file = fn, status = 'OLD',
     *      err=600, iostat = ios)
      endif

  100 continue

c---------------------------------------------------------------------------
c   Read each line, checking for JOBFLOW statements.
c---------------------------------------------------------------------------

      read (iunit, '(A80)', end = 200) line
      if (line(1:7) .eq. 'JOBFLOW') then
         n = str_trimlen(line)
         if (line(9:n) .eq. jobflow) then

c---------------------------------------------------------------------------
c   The jobflow name matches, we have found it.
c---------------------------------------------------------------------------

            ierr = 0
            return
         endif
      endif

      go to 100

  200 continue
      ierr = 1
      return

  600 continue
      ierr = 2
      print *,'Error: Could not open file: ',fn
      return
      end

      subroutine write_default_jobflow(iunit, jobflow)
c---------------------------------------------------------------------------
c   Reads data until an "ENDJOBFLOW" is reached.  Writes the filenames to
c   the ZMAT.AUTO file.
c---------------------------------------------------------------------------

      implicit none
      integer iunit, n, str_trimlen
      character*(*) jobflow
      character*80 line , pline

  100 continue
      read (12, '(A80)', end=200) line
      n = str_trimlen(line)
      if (line(1:10) .eq. 'ENDJOBFLOW') then
         close(12)
         return
      endif

      pline = 'SIAL_PROGRAM=' // line(1:n)
      write(iunit, 9000) pline
      go to 100

  200 continue
      print *,'Error: Missing ENDJOBFLOW statement for jobflow ',
     *   jobflow
      call abort_job()

 9000 format(a80)
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c double DSCR(NDSCR)        :

c INPUT/OUTPUT
c double DIPDER(3,3*NATOM) :
c double POLDER(9,3*NATOM) :

c RECORDS
c get TYPE//'SYMQ'
c get 'ATOMMASS'

      SUBROUTINE TRNDIP(NMODE,NATOM,NIRREP,
     &                  DIPDER,DIPDFUL,POLDER,POLDFUL,
     &                  ISYMIRR,IDEGEN,TYPE,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION DIPDER(3,3*NATOM),DIPDFUL(3,3*NATOM)
      DIMENSION POLDER(9,3*NATOM),POLDFUL(9,3*NATOM)
      DIMENSION ISYMIRR(*),IDEGEN(*)
      CHARACTER*4 TYPE
      double precision dscr(ndscr)

      LOGICAL bExist

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
#include "control.com" /* for RAMAN */

      DATA ZILCH /0.0/

      if (eneronly) then
c      o there are no derivatives
         CALL DGETREC(20,'JOBARC','ATOMMASS',NATOM,DSCR)
         OPEN(UNIT=40,FILE='DIPDER',STATUS='UNKNOWN',FORM='FORMATTED')
         DO IXYZ=1,3
            WRITE(40,'(I5)')IXYZ
            DO IATOM=1,NATOM
               IF (DSCR(IATOM).NE.ZILCH) THEN
                  WRITE(40,'((4F20.10))')0.d0,0.d0,0.d0,0.d0,0.d0
               END IF
            END DO
         END DO
         CLOSE(UNIT=40,STATUS='KEEP')
         return
      end if

      NATOM3=3*NATOM
      NATOM9=9*NATOM

      IF (NDSCR.LT.(NATOM3+9)*NATOM3) THEN
         print *, '@TRNDIP: Insufficient memory.'
         print *, '         have ',NDSCR,' doubles'
         print *, '         need ',(NATOM3+9)*NATOM3,' doubles'
         call aces_exit(1)
      END IF

      CALL ZERO(DIPDFUL,3*NATOM3)
      CALL ZERO(POLDFUL,9*NATOM3)

      ICOUNT=1
      IOFF1 =1
      NLEFT =NMODE
      DO IRREP=1,NIRREP

c      o find first occurance of this irrep
         ILOC=ISRCHEQ(NMODE,ISYMIRR,1,IRREP)
         IF (ILOC.NE.NMODE+1) THEN
            ILAST=ISRCHNE(NLEFT,ISYMIRR(ILOC),1,IRREP)
            NVIBSYM=ILAST-1
            IDEG=IDEGEN(IRREP)
            NDIM=NVIBSYM/IDEG
c         o expand dipder and polder matrix into full matrices
            CALL XDSCAL(3*NDIM,DFLOAT(IDEG),DIPDER(1,ioff1),1)
            CALL XDCOPY(3*NDIM,DIPDER(1,IOFF1),1,DIPDFUL(1,ICOUNT),1)
            CALL XDSCAL(9*NDIM,DFLOAT(IDEG),POLDER(1,ioff1),1)
            CALL XDCOPY(9*NDIM,POLDER(1,IOFF1),1,POLDFUL(1,ICOUNT),1)
            ICOUNT=ICOUNT+NVIBSYM
            IOFF1 =IOFF1 +NDIM
            NLEFT =NLEFT -NVIBSYM
         END IF

      END DO

c   o transform to mass-weighted cartesian coordinates
      I = 1+3*NATOM9
      CALL DGETREC(20,'JOBARC',TYPE//'SYMQ',NATOM3*NATOM3,DSCR(I))
      CALL XGEMM('N','T',3,NATOM3,NATOM3,
     &           1.d0,DIPDFUL,3,
     &                DSCR(I),NATOM3,
     &           0.d0,DSCR,   3)
      CALL XDCOPY(NATOM9,DSCR,1,DIPDFUL,1)
      CALL XGEMM('N','T',9,NATOM3,NATOM3,
     &           1.d0,POLDFUL,9,
     &                DSCR(I),NATOM3,
     &           0.d0,DSCR,   9)
      CALL XDCOPY(3*NATOM9,DSCR,1,POLDFUL,1)

c   o remove mass weighting
      CALL DGETREC(20,'JOBARC','ATOMMASS',NATOM,DSCR)
      IOFF1=1
      DO IATOM=1,NATOM
         X=SQRT(DSCR(IATOM))
         DO IXYZ=1,3
            DIPDFUL(1,IOFF1)=X*DIPDFUL(1,IOFF1)
            DIPDFUL(2,IOFF1)=X*DIPDFUL(2,IOFF1)
            DIPDFUL(3,IOFF1)=X*DIPDFUL(3,IOFF1)
            DO I = 1, 9
               POLDFUL(I,IOFF1)=X*POLDFUL(I,IOFF1)
            END DO
            IOFF1=IOFF1+1
         END DO
      END DO

      OPEN(UNIT=40,FILE='DIPDER',STATUS='UNKNOWN',FORM='FORMATTED')
      DO IXYZ=1,3
         WRITE(40,'(I5)')IXYZ
         IOFF=1
         DO IATOM=1,NATOM
            IF (DSCR(IATOM).NE.ZILCH) THEN
               WRITE(40,'((4F20.10))')0.d0,
     &                                (DIPDFUL(IXYZ,I),I=IOFF,IOFF+2)
            END IF
            IOFF=IOFF+3
         END DO
      END DO
      CLOSE(UNIT=40,STATUS='KEEP')

      INQUIRE(FILE='POLDER', EXIST=bExist)
      IF (.NOT.bExist.AND.RAMAN) THEN
         OPEN(UNIT=60,FILE='POLDER',STATUS='UNKNOWN',FORM='FORMATTED')
         DO IXYZ=1,9
            WRITE(60,'(I5)')IXYZ
            IOFF=1
            DO IATOM=1,NATOM
               IF (DSCR(IATOM).NE.ZILCH) THEN
                  WRITE(60,'((4F20.10))')0.d0,
     &                                   (POLDFUL(IXYZ,I),I=IOFF,IOFF+2)
               END IF
               IOFF=IOFF+3
            END DO
         END DO
         CLOSE(UNIT=60,STATUS='KEEP')
      END IF

      RETURN
      END

c This routine initializes the ACES runtime environment. It or aces_init
c should be called before any other ACES routine.

      subroutine aces_init_rte
      implicit none

c INTERNAL VARIABLES
      character*80 szJOBARC
      integer       iJOBARC
      logical bTmp

c COMMON BLOCKS
#include "machsp.com"
#include "icdacc.com"

c ----------------------------------------------------------------------

c   o initialize the machsp common block
      call aces_com_machsp
#ifdef _ASSERT
      if ((iintln.ne.4).and.(iintln.ne.8)) then
         print *, '@ACES_INIT_RTE: Assertion failed.'
         print *, '                iintln = ',iintln
         print *, '                ifltln = ',ifltln
         call aces_exit(1)
      end if
#endif /* _ASSERT */

c   o initialize the icdacc common block

cYAU - Okay, what is this "idacc?" all about...
c
c    First off, the name refers to (D)irect (ACC)ess. The ultimate problem
c is that the Fortran standard lets RECL take any unit when specifying
c the record length of direct access, unformatted files. It's not
c necessarily compiler, OS, or architecture dependent. In fact, some
c configurations let you specify the units of RECL with an environment
c variable!
c    To aid portability, idaccm was introduced by Nevin as a scaling
c factor for RECL. In essence, idaccm is the number of RECL units
c per integer; therefore, it could take any of the values: 1, 2, 4, or 8.
c    If there is an accompanying Fortran 9x compiler, then a short
c program will tell you whether to define _RECL_IS_WORDS_:
c       program test
c          integer :: i=0, len
c          inquire(iolength=len) i
c          print *, len
c       end program test
c Whatever number is printed, that should be the value of idaccm. For
c the time being, if RECL is not in bytes, then we will assume 4-byte
c words. It is possible RECL is 8-byte words, but that is very rare.

#ifdef _RECL_IS_WORDS_
#ifdef F_64BIT
      idaccm = 2
#else
      idaccm = 1
#endif /* F_64BIT */
#else
      idaccm = iintln
#endif /* _RECL_IS_WORDS_ */

#ifdef _DEBUG
c   o try to print this info just once
c     (should we bother trapping this with err/iostat?)
      call gfname('JOBARC',szJOBARC,iJOBARC)
      inquire(file=szJOBARC(1:iJOBARC),exist=bTmp)
      if (.not.bTmp) then
         print *, '@ACES_INIT_RTE: Build-specific parameters:'
         print *, '                bytes per integer = ',iintln
         print *, '                bytes per double  = ',ifltln
         print *, '                recls per integer = ',idaccm
      end if
#endif

      return
c     end subroutine aces_init_rte
      end

c This routine initializes the ACES runtime environment. It or aces_init
c should be called before any other ACES routine.

      subroutine aces_init_rte
      implicit none

c INTERNAL VARIABLES
      character*80 szJOBARC
      integer       iJOBARC
      logical bTmp

c COMMON BLOCKS


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c icdacc.com : begin
c Nevin 8-30-95 added record length common to facilitate change from
c Bytes to Words for SGI and DecAlpha
      integer         idaccm
      common /icdacc/ idaccm
c icdacc.com : end

c ----------------------------------------------------------------------

c   o initialize the machsp common block
      call aces_com_machsp
      if ((iintln.ne.4).and.(iintln.ne.8)) then
         print *, '@ACES_INIT_RTE: Assertion failed.'
         print *, '                iintln = ',iintln
         print *, '                ifltln = ',ifltln
         call aces_exit(1)
      end if

c   o initialize the icdacc common block

cYAU - Okay, what is this "idacc?" all about...
c
c    First off, the name refers to (D)irect (ACC)ess. The ultimate problem
c is that the Fortran standard lets RECL take any unit when specifying
c the record length of direct access, unformatted files. It's not
c necessarily compiler, OS, or architecture dependent. In fact, some
c configurations let you specify the units of RECL with an environment
c variable!
c    To aid portability, idaccm was introduced by Nevin as a scaling
c factor for RECL. In essence, idaccm is the number of RECL units
c per integer; therefore, it could take any of the values: 1, 2, 4, or 8.
c    If there is an accompanying Fortran 9x compiler, then a short
c program will tell you whether to define 1:
c       program test
c          integer :: i=0, len
c          inquire(iolength=len) i
c          print *, len
c       end program test
c Whatever number is printed, that should be the value of idaccm. For
c the time being, if RECL is not in bytes, then we will assume 4-byte
c words. It is possible RECL is 8-byte words, but that is very rare.

      idaccm = 2


      return
c     end subroutine aces_init_rte
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_INT1D_TO_AB
     +
     +                    ( SHELLA,SHELLB,SHELLP,
     +                      ATOMIC,
     +                      NEXP,
     +                      NXYZA,NXYZB,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_INT1D_TO_AB
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                kinetic integrals [A|B], adding up all contributions
C                from all the kinetic and overlap 1D integrals:
C
C                      X = KIN (XA,XB) * OVL (YA,YB) * OVL (ZA,ZB)
C                      Y = OVL (XA,XB) * KIN (YA,YB) * OVL (ZA,ZB)
C                      Z = OVL (XA,XB) * OVL (YA,YB) * KIN (ZA,ZB)
C
C                        [A|B] = [XA,YA,ZA|XB,YB,ZB] = X + Y + Z
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between the
C                kinetic and overlap 1DX integrals with the scaling
C                factors.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A,B and csh sum P=A+B
C                    ATOMIC      =  indicates, if purely atomic [A|B]
C                                   integrals will be evaluated
C                    NEXP        =  current # of exponent pairs
C                    NXYZx       =  # of cartesian monomials for the
C                                   shells x=A,B
C                    KIN1Dx      =  all current kinetic 1D integrals
C                                   for each cartesian component
C                                   x = X,Y,Z
C                    OVL1Dx      =  all current overlap 1D integrals
C                                   for each cartesian component
C                                   x = X,Y,Z
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1DX kinetic and overlap integral
C                                   times scaling factor products
C                    SCALE       =  the NEXP scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian [A|B]
C                                   kinetic integrals corresponding
C                                   to all current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     I,J,N
         INTEGER     NEXP
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB,SHELLP
         INTEGER     XA,YA,ZA,XB,YB,ZB
         INTEGER     XAP,XBP
         INTEGER     YAMAX,YBMAX

         DOUBLE PRECISION  X,Y,Z
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NEXP)
         DOUBLE PRECISION  TEMP1 (1:NEXP)
         DOUBLE PRECISION  TEMP2 (1:NEXP)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZA,1:NXYZB)

         DOUBLE PRECISION  KIN1DX (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  KIN1DY (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  KIN1DZ (1:NEXP,0:SHELLA  ,0:SHELLB  )
         DOUBLE PRECISION  OVL1DX (1:NEXP,0:SHELLP+2,0:SHELLB+1)
         DOUBLE PRECISION  OVL1DY (1:NEXP,0:SHELLP+2,0:SHELLB+1)
         DOUBLE PRECISION  OVL1DZ (1:NEXP,0:SHELLP+2,0:SHELLB+1)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...the atomic case. Outer loop is over x contributions,
C                inner loop over y,z contributions. Skip any even-odd
C                and odd-even x,x , y,y and z,z pairs.
C
C
         IF (ATOMIC) THEN

             DO J = 1,NXYZB
             DO I = 1,NXYZA
             DO N = 1,NEXP
                BATCH (N,I,J) = ZERO
             END DO
             END DO
             END DO

             XBP = 0
             DO 100 XB = SHELLB,0,-1
                YBMAX = SHELLB - XB
                XAP = 0
                DO 110 XA = SHELLA,0,-1
                   YAMAX = SHELLA - XA

                   IF (MOD (XA+XB,2).NE.0) THEN
                       J = XBP + YBMAX + 1
                       XAP = XAP + YAMAX + 1
                   ELSE
                       IF (XA+XB.GT.0) THEN
                           DO N = 1,NEXP
                              TEMP1 (N) = SCALE (N) * KIN1DX (N,XA,XB)
                              TEMP2 (N) = SCALE (N) * OVL1DX (N,XA,XB)
                           END DO
                       ELSE
                           DO N = 1,NEXP
                              TEMP1 (N) = SCALE (N) * KIN1DX (N,XA,XB)
                              TEMP2 (N) = SCALE (N)
                           END DO
                       END IF

                       J = XBP
                       DO 120 YB = YBMAX,0,-1
                          J = J + 1
                          ZB = YBMAX - YB
                          I = XAP
                          DO 130 YA = YAMAX,0,-1
                             I = I + 1
                             ZA = YAMAX - YA

                             IF (MOD (YA+YB,2).EQ.0 .AND.
     +                           MOD (ZA+ZB,2).EQ.0) THEN

                                 IF (YA+YB.GT.0 .AND. ZA+ZB.GT.0) THEN

                                     DO N = 1,NEXP
                                        X = TEMP1 (N) * OVL1DY (N,YA,YB)
     +                                                * OVL1DZ (N,ZA,ZB)
                                        Y = TEMP2 (N) * KIN1DY (N,YA,YB)
     +                                                * OVL1DZ (N,ZA,ZB)
                                        Z = TEMP2 (N) * OVL1DY (N,YA,YB)
     +                                                * KIN1DZ (N,ZA,ZB)
                                        BATCH (N,I,J) = X + Y + Z
                                     END DO

                                 ELSE IF (YA+YB.GT.0) THEN

                                     DO N = 1,NEXP
                                        X = TEMP1 (N) * OVL1DY (N,YA,YB)
                                        Y = TEMP2 (N) * KIN1DY (N,YA,YB)
                                        Z = TEMP2 (N) * OVL1DY (N,YA,YB)
     +                                                * KIN1DZ (N,ZA,ZB)
                                        BATCH (N,I,J) = X + Y + Z
                                     END DO

                                 ELSE IF (ZA+ZB.GT.0) THEN

                                     DO N = 1,NEXP
                                        X = TEMP1 (N) * OVL1DZ (N,ZA,ZB)
                                        Y = TEMP2 (N) * KIN1DY (N,YA,YB)
     +                                                * OVL1DZ (N,ZA,ZB)
                                        Z = TEMP2 (N) * KIN1DZ (N,ZA,ZB)
                                        BATCH (N,I,J) = X + Y + Z
                                     END DO

                                 ELSE

                                     DO N = 1,NEXP
                                        X = TEMP1 (N)
                                        Y = TEMP2 (N) * KIN1DY (N,YA,YB)
                                        Z = TEMP2 (N) * KIN1DZ (N,ZA,ZB)
                                        BATCH (N,I,J) = X + Y + Z
                                     END DO

                                 END IF

                             END IF

  130                     CONTINUE
  120                  CONTINUE
                       XAP = I
                   END IF

  110           CONTINUE
                XBP = J
  100        CONTINUE

         ELSE
C
C
C             ...the nonatomic case. Outer loop is over x contributions,
C                inner loop over y,z contributions.
C
C
             XBP = 0
             DO 200 XB = SHELLB,0,-1
                YBMAX = SHELLB - XB
                XAP = 0
                DO 210 XA = SHELLA,0,-1
                   YAMAX = SHELLA - XA

                   IF (XA+XB.GT.0) THEN
                       DO N = 1,NEXP
                          TEMP1 (N) = SCALE (N) * KIN1DX (N,XA,XB)
                          TEMP2 (N) = SCALE (N) * OVL1DX (N,XA,XB)
                       END DO
                   ELSE
                       DO N = 1,NEXP
                          TEMP1 (N) = SCALE (N) * KIN1DX (N,XA,XB)
                          TEMP2 (N) = SCALE (N)
                       END DO
                   END IF

                   J = XBP
                   DO 220 YB = YBMAX,0,-1
                      J = J + 1
                      ZB = YBMAX - YB
                      I = XAP
                      DO 230 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (YA+YB.GT.0 .AND. ZA+ZB.GT.0) THEN

                             DO N = 1,NEXP
                                X = TEMP1 (N) * OVL1DY (N,YA,YB)
     +                                        * OVL1DZ (N,ZA,ZB)
                                Y = TEMP2 (N) * KIN1DY (N,YA,YB)
     +                                        * OVL1DZ (N,ZA,ZB)
                                Z = TEMP2 (N) * OVL1DY (N,YA,YB)
     +                                        * KIN1DZ (N,ZA,ZB)
                                BATCH (N,I,J) = X + Y + Z
                             END DO

                         ELSE IF (YA+YB.GT.0) THEN

                             DO N = 1,NEXP
                                X = TEMP1 (N) * OVL1DY (N,YA,YB)
                                Y = TEMP2 (N) * KIN1DY (N,YA,YB)
                                Z = TEMP2 (N) * OVL1DY (N,YA,YB)
     +                                        * KIN1DZ (N,ZA,ZB)
                                BATCH (N,I,J) = X + Y + Z
                             END DO

                         ELSE IF (ZA+ZB.GT.0) THEN

                             DO N = 1,NEXP
                                X = TEMP1 (N) * OVL1DZ (N,ZA,ZB)
                                Y = TEMP2 (N) * KIN1DY (N,YA,YB)
     +                                        * OVL1DZ (N,ZA,ZB)
                                Z = TEMP2 (N) * KIN1DZ (N,ZA,ZB)
                                BATCH (N,I,J) = X + Y + Z
                             END DO

                         ELSE

                             DO N = 1,NEXP
                                X = TEMP1 (N)
                                Y = TEMP2 (N) * KIN1DY (N,YA,YB)
                                Z = TEMP2 (N) * KIN1DZ (N,ZA,ZB)
                                BATCH (N,I,J) = X + Y + Z
                             END DO

                         END IF

  230                 CONTINUE
  220              CONTINUE

                   XAP = I
  210           CONTINUE
                XBP = J
  200        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C ZERO OUT THE FIRST LEN ELEMENTS OF DOUBLE PRECISION VECTOR A.

      SUBROUTINE ZERO(A,LEN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LEN)
      if (len.lt.1) return
      DO I = 1, LEN
         A(I) = 0.D0
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__SYMMETRY_RELATED_CENTERS
     +
     +                    ( NATOM,
     +                      ATDONE,
     +                      IDXSYM,
     +                      DMAP,
     +                      SYMMAP,
     +                      DOMAT,
     +                      DSYMACC,
     +                      XYZ,
     +                      R,X,Y,Z,
     +                      DIST,
     +                      XVEC,
     +
     +                              PLATONIC,
     +                              RING,NRING,RINGSZ,
     +                              NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                              PLATO )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__SYMMETRY_RELATED_CENTERS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine consists of two parts: part 1) and 2).
C
C                  Part 1): For each atomic center C in the collection
C                           of all atomic centers there exist sets
C                           of symmetry related centers which are
C                           equally distant from center C. Of all these
C                           sets, we pick out only those that have the
C                           minimum size, excluding sizes 1 and 2.
C                           Their indices will be placed into array
C                           RING in the column appropriate for center C.
C                           The # of such rings and their minimum size
C                           will be placed into the respective arrays
C                           NRING and RINGSZ at the position
C                           corresponding to C.
C
C
C                  Part 2): Determine, if the collection of all atomic
C                           centers have certain symmetry related
C                           subsets belonging to the following possible
C                           5 platonic solid symmetries:
C
C                               1) Centers arranged tetrahedrally
C                               2) Centers arranged cubically
C                               3) Centers arranged octahedrally
C                               4) Centers arranged dodecahedrally
C                               5) Centers arranged icosahedrally
C
C                           The way to do this is to analyze the
C                           'distance' info in the distance order
c                           matrix for all groups of symmetry related
C                           atomic centers.
C
C                           Procedure:
C
C                           As an example consider the centers arranged
C                           on the vertices of a cube:
C
C
C
C                                          1---------2
C                                         /|        /|
C                                        / |       / |
C                                       /  |      /  |
C                                      5---------6   |
C                                      |   |     |   |
C                                      |   3-----|---4
C                                      |  /      |  /
C                                      | /       | /
C                                      |/        |/
C                                      7---------8
C
C
C                
C                           Lets pick vertex 1 with a 'distance' value
C                           of D0. Then vertices 2,5,3 are all
C                           equidistant from vertex 1, say a distance
C                           D1. Likewise for vertices 4,6,7 by distance
C                           D2. Vertex 8 is the most distant with
C                           distance D3. Since this distance map must
C                           be obeyed by all other vertices as well,
C                           we can identify a set of 8 atomic centers
C                           belonging to the cubic symmetry if:
C
C                               i) they are all symmetry related
C                              ii) one of the centers obeys the cubic
C                                  distance map
C
C                           The above mentioned symmetry cases have
C                           then the following distance maps (D0 > D1
C                           > D2 > D3 > ...):
C
C                               1) Tetrahedron:   D0 (x1)
C                                                 D1 (x3)
C
C                               2) Cube:          D0 (x1)
C                                                 D1 (x3)
C                                                 D2 (x3)
C                                                 D3 (x1)
C
C                               3) Octahedron:    D0 (x1)
C                                                 D1 (x4)
C                                                 D2 (x1)
C
C                               4) Dodecahedron:  D0 (x1)
C                                                 D1 (x3)
C                                                 D2 (x6)
C                                                 D3 (x6)
C                                                 D4 (x3)
C                                                 D5 (x1)
C
C                               5) Icosahedron:   D0 (x1)
C                                                 D1 (x5)
C                                                 D2 (x5)
C                                                 D3 (x1)
C
C
C                Besides the distance maps, we can also specify the
C                exact values for the distance order ratios:
C
C                       [D0 - D(n+1)] / [D0 - D1]  ,  n = 0,1,2,...
C
C                The a,b distance order matrix element between two
C                atoms is defined as:
C
C                      DOMAT (a,b) = (dmax - d(ab)) / dmax
C
C                where dmax is the maximum distance in the complete
C                atomic set and d(ab) is the ordinary distance between
C                atoms a and b. From this we imediately see that all D0
C                are = 1. For the above ratio we obtain with this
C                definition, using the fact that D(n+1) denotes the
C                distance order between vertex n+1 and 0:
C
C                   [D0 - D(n+1)] / [D0 - D1]  =  d(n+1,0) / d(1,0)
C
C                a ratio involving only internal polyhedra distances.
C                These are always expressible as a linear function
C                of the polyhedra side length and hence the ratio
C                becomes independent of size and is specific for each
C                platonic solid. The following is a list of the ratios
C                expected:
C
C                    1) Tetrahedron:  (D0 - D1) / (D0 - D1) = 1
C
C                    2) Cube:         (D0 - D1) / (D0 - D1) = 1
C                                     (D0 - D2) / (D0 - D1) = sqrt (2)
C                                     (D0 - D3) / (D0 - D1) = sqrt (3)
C
C                    3) Octahedron:   (D0 - D1) / (D0 - D1) = 1
C                                     (D0 - D2) / (D0 - D1) = sqrt (2)
C
C                    4) Dodecahedron: (D0 - D1) / (D0 - D1) = 1
C                                     (D0 - D2) / (D0 - D1) = ?
C                                     (D0 - D3) / (D0 - D1) = ? 
C                                     (D0 - D4) / (D0 - D1) = ?
C                                     (D0 - D5) / (D0 - D1) = ?
C
C                    5) Icosahedron:  (D0 - D1) / (D0 - D1) = 1
C                                     (D0 - D2) / (D0 - D1) = ?
C                                     (D0 - D3) / (D0 - D1) = ?
C
C
C
C
C                  Input:
C
C                    NATOM        =  total # of atomic centers
C                    ATDONE (A)   =  will be used as an indicator if
C                                    atom A has been symmetry checked
C                                    or not.
C                    IDXSYM       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    DMAP         =  array that will be used to store
C                                    distance maps, i.e. the frequency
C                                    of identical 'distances'
C                    SYMMAP (A,B) =  has been set equal to 1 if atoms
C                                    A and B were found to be symmetry
C                                    related. A value of 0 indicates
C                                    no symmetry relation.
C                    DOMAT (A,B)  =  distance order matrix containing
C                                    'distance' info between atoms A
C                                    and B.
C                    DSYMACC      =  symmetry accuracy for distance
C                                    order matrix values
C                    XYZ          =  x,y,z-coordinates for all the
C                                    atoms in 3 x NATOM matrix format.
C                    R            =  will hold atomic indices
C                    X,Y,Z        =  will hold atomic x,y,z-coordinates
C                    DIST         =  array that will be used to store
C                                    distance orders
C                    XVEC         =  flp scratch vector
C                    PLATONIC     =  is true, if the current state of
C                                    the calculation thinks the density
C                                    of the molecule possesses platonic
C                                    symmetry.
C
C
C                  Output:
C
C                    PLATONIC     =  is still true, if platonic symmetry
C                                    is assumed, false otherwise.
C                    RING (A,B)   =  integer array containing all atomic
C                                    indices A of those symmetry related
C                                    sets that have equal distance from
C                                    center B and are of maximum size
C                    NRING (B)    =  integer vector containing the # of
C                                    sets of maximum size related to
C                                    center B.
C                    RINGSZ (B)   =  integer vector containing the
C                                    maximum size of the above found
C                                    sets related to center B.
C                    NTETRA       =  contains the # of tetrahedrally
C                                    related atomic center sets (size 4)
C                    NCUBE        =  contains the # of cubically
C                                    related atomic center sets (size 8)
C                    NOCTA        =  contains the # of octahedrally
C                                    related atomic center sets (size 6)
C                    NDODECA      =  contains the # of dodecahedrally
C                                    related atomic center sets
C                                    (size 20)
C                    NICOSA       =  contains the # of icosahedrally
C                                    related atomic center sets
C                                    (size 12)
C                    PLATO (A,P)  =  integer array containing all atomic
C                                    indices A for specific platonic
C                                    symmetry types as characterized by
C                                    the index P: P = 1 (four atoms
C                                    tetrahedrally arranged), P = 2
C                                    (eight atoms arranged in a cube),
C                                    P = 3 (six octahedral atoms), P = 4
C                                    (twenty atoms in a dodecahedron),
C                                    P = 5 (twelve icosahedral atoms)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ALERT
         LOGICAL     CHECK
         LOGICAL     NSYM1,NSYM4,NSYM6,NSYM8,NSYM12,
     +               NSYM20,NSYM24,NSYM30,NSYM60
         LOGICAL     NSYMOK
         LOGICAL     PLANAR
         LOGICAL     PLATONIC
         LOGICAL     PROCEED
         LOGICAL     TETRA,CUBE,OCTA,DODECA,ICOSA
         LOGICAL     SYM4,SYM8,SYM6,SYM20,SYM12
         LOGICAL     SYMBAD1,SYMBAD2,SYMBAD3,SYMBAD4

         INTEGER     ATOM,ATOMA,ATOMB
         INTEGER     BADSIZE
         INTEGER     CENTER
         INTEGER     I,M,N
         INTEGER     MINRING,MINSIZE
         INTEGER     NATOM
         INTEGER     NBASE
         INTEGER     NDIFF
         INTEGER     NLAST
         INTEGER     NRINGS
         INTEGER     NSIZE
         INTEGER     NSYM
         INTEGER     NTETRA,NCUBE,NOCTA,NDODECA,NICOSA

         INTEGER     ATDONE  (1:NATOM)
         INTEGER     DMAP    (1:NATOM)
         INTEGER     IDXSYM  (1:NATOM)
         INTEGER     NRING   (1:NATOM)
         INTEGER     R       (1:NATOM)
         INTEGER     RINGSZ  (1:NATOM)

         INTEGER     PLATO   (1:NATOM,1:5    )
         INTEGER     RING    (1:NATOM,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM,1:NATOM)

         DOUBLE PRECISION  DIFF
         DOUBLE PRECISION  DSYMACC

         DOUBLE PRECISION  DIST (1:NATOM)
         DOUBLE PRECISION  X    (1:NATOM)
         DOUBLE PRECISION  Y    (1:NATOM)
         DOUBLE PRECISION  Z    (1:NATOM)
         DOUBLE PRECISION  XVEC (1:NATOM)

         DOUBLE PRECISION  DOMAT  (1:NATOM,1:NATOM)
         DOUBLE PRECISION  XYZ    (1:3    ,1:NATOM)
C
C
C------------------------------------------------------------------------
C
C
C             ...initialize the data.
C
C
         BADSIZE = NATOM + 1

         DO ATOMA = 1,NATOM
            ATDONE (ATOMA) = 0
            RINGSZ (ATOMA) = BADSIZE
            NRING  (ATOMA) = 0
         END DO

         CALL  MAT__C_EQ_ZERO_INTEGER
     +
     +              ( NATOM,NATOM,
     +                NATOM,NATOM,
     +
     +                         RING )
     +
     +
         TETRA  = .FALSE.
         CUBE   = .FALSE.
         OCTA   = .FALSE.
         DODECA = .FALSE.
         ICOSA  = .FALSE.

         NTETRA  = 0
         NCUBE   = 0
         NOCTA   = 0
         NDODECA = 0
         NICOSA  = 0

         CALL  MAT__C_EQ_ZERO_INTEGER
     +
     +              ( NATOM,5,
     +                NATOM,5,
     +
     +                         PLATO )
     +
     +
C
C
C             ...outer loop over all atomic centers.
C
C
         DO ATOMA = 1,NATOM

            CHECK = ATDONE (ATOMA) .EQ. 0
C
C
C             ...find total # of symmetry related atoms corresponding
C                to current checked atom.
C
C
            IF (CHECK) THEN

                NSYM = 0
                DO ATOMB = 1,NATOM
                   IF (SYMMAP (ATOMB,ATOMA) .EQ. 1) THEN
                       NSYM = NSYM + 1
                       IDXSYM (NSYM) = ATOMB
                       ATDONE (ATOMB) = 1
                   END IF
                END DO
C
C
C             ...the higher symmetry (platonic solids) cases first.
C                Pick first vertex, determine its distance order
C                vector and from it its distance order map.
C
C
                IF (PLATONIC) THEN

                    ATOMB = IDXSYM (1)

                    DO N = 1,NSYM
                       XVEC (N) = DOMAT (IDXSYM (N),ATOMB)
                    END DO

                    CALL  NLO__SORT_FLP_VECTOR_ELEMENTS
     +
     +                         ( NSYM,NSYM,
     +                           1,NSYM,
     +                           .FALSE.,.FALSE.,
     +                           0,
     +                           XVEC,
     +
     +                                   DMAP )
     +
     +
                    DO N = 1,NSYM
                       DIST (N) = XVEC (DMAP (N))
                       DMAP (N) = 0
                    END DO

                    NLAST = 1
                    NDIFF = 1

                    DO N = 2,NSYM
                       DIFF = ABS (DIST (N-1) - DIST (N))
                       IF (DIFF.GT.DSYMACC) THEN
                           NSIZE = N - NLAST
                           DMAP (NDIFF) = NSIZE
                           NDIFF = NDIFF + 1
                           NLAST = N
                       END IF
                    END DO
                    NSIZE = NSYM + 1 - NLAST
                    DMAP (NDIFF) = NSIZE
C
C
C             ...check, which platonic cases apply.
C
C
                    SYM4 =        NSYM.EQ.4
     +                      .AND. NDIFF.EQ.2
     +                      .AND. DMAP (1).EQ.1
     +                      .AND. DMAP (2).EQ.3

                    SYM8 =        NSYM.EQ.8
     +                      .AND. NDIFF.EQ.4
     +                      .AND. DMAP (1).EQ.1
     +                      .AND. DMAP (2).EQ.3
     +                      .AND. DMAP (3).EQ.3
     +                      .AND. DMAP (4).EQ.1

                    SYM6 =        NSYM.EQ.6
     +                      .AND. NDIFF.EQ.3
     +                      .AND. DMAP (1).EQ.1
     +                      .AND. DMAP (2).EQ.4
     +                      .AND. DMAP (3).EQ.1

                    SYM20 =       NSYM.EQ.20
     +                      .AND. NDIFF.EQ.6
     +                      .AND. DMAP (1).EQ.1
     +                      .AND. DMAP (2).EQ.3
     +                      .AND. DMAP (3).EQ.6
     +                      .AND. DMAP (4).EQ.6
     +                      .AND. DMAP (5).EQ.3
     +                      .AND. DMAP (6).EQ.1

                    SYM12 =       NSYM.EQ.12
     +                      .AND. NDIFF.EQ.4
     +                      .AND. DMAP (1).EQ.1
     +                      .AND. DMAP (2).EQ.5
     +                      .AND. DMAP (3).EQ.5
     +                      .AND. DMAP (4).EQ.1
C
C
C             ...add the current set of symmetry related atomic
C                centers to the corresponding column positions in
C                the PLATO array.
C
C
                    IF (SYM4) THEN

                        DO N = 1,4
                           NTETRA = NTETRA + 1
                           PLATO (NTETRA,1) = IDXSYM (N)
                        END DO

                    ELSE IF (SYM8) THEN

                        DO N = 1,8
                           NCUBE = NCUBE + 1
                           PLATO (NCUBE,2) = IDXSYM (N)
                        END DO

                    ELSE IF (SYM6) THEN

                        DO N = 1,6
                           NOCTA = NOCTA + 1
                           PLATO (NOCTA,3) = IDXSYM (N)
                        END DO

                    ELSE IF (SYM20) THEN

                        DO N = 1,20
                           NDODECA = NDODECA + 1
                           PLATO (NDODECA,4) = IDXSYM (N)
                        END DO

                    ELSE IF (SYM12) THEN

                        DO N = 1,12
                           NICOSA = NICOSA + 1
                           PLATO (NICOSA,5) = IDXSYM (N)
                        END DO

                    END IF

                    TETRA  = TETRA  .OR. SYM4
                    CUBE   = CUBE   .OR. SYM8
                    OCTA   = OCTA   .OR. SYM6
                    DODECA = DODECA .OR. SYM20
                    ICOSA  = ICOSA  .OR. SYM12

                END IF
C
C
C             ...determine the rings resulting from the current set
C                of symmetry related centers. Loop over all atomic
C                centers and determine the rings of minimum size > 2.
C
C
                DO ATOMB = 1,NATOM

                   DO N = 1,NSYM
                      XVEC (N) = DOMAT (IDXSYM (N),ATOMB)
                   END DO

                   CALL  NLO__SORT_FLP_VECTOR_ELEMENTS
     +
     +                        ( NSYM,NSYM,
     +                          1,NSYM,
     +                          .FALSE.,.FALSE.,
     +                          0,
     +                          XVEC,
     +
     +                                  DMAP )
     +
     +
                   DO N = 1,NSYM
                      DIST (N) = XVEC (DMAP (N))
                   END DO

                   NBASE = 0
                   NLAST = 1
                   MINSIZE = BADSIZE

                   DO N = 2,NSYM
                      DIFF = ABS (DIST (N-1) - DIST (N))
                      IF (DIFF.GT.DSYMACC) THEN
                          NSIZE = N - NLAST

                          IF (NSIZE.GE.3) THEN
                              IF (NSIZE.LT.MINSIZE) THEN
                                  NBASE = 0
                              END IF
                              DO M = 1,NSIZE
                                 NBASE = NBASE + 1
                                 ATOM = IDXSYM (DMAP (NLAST+M-1))
                                 R (NBASE) = ATOM
                                 X (NBASE) = XYZ (1,ATOM)
                                 Y (NBASE) = XYZ (2,ATOM)
                                 Z (NBASE) = XYZ (3,ATOM)
                              END DO
                              MINSIZE = MIN (MINSIZE,NSIZE)
                          END IF

                          NLAST = N
                      END IF
                   END DO

                   NSIZE = NSYM + 1 - NLAST

                   IF (NSIZE.GE.3) THEN
                       IF (NSIZE.LT.MINSIZE) THEN
                           NBASE = 0
                       END IF
                       DO M = 1,NSIZE
                          NBASE = NBASE + 1
                          ATOM = IDXSYM (DMAP (NLAST+M-1))
                          R (NBASE) = ATOM
                          X (NBASE) = XYZ (1,ATOM)
                          Y (NBASE) = XYZ (2,ATOM)
                          Z (NBASE) = XYZ (3,ATOM)
                       END DO
                       MINSIZE = MIN (MINSIZE,NSIZE)
                   END IF

                   NRINGS = NBASE / MINSIZE
C
C
C             ...check for proper subrings.
C
C
                   IF (NRINGS.GT.0) THEN

                       NBASE = 0

                       DO N = 1,NRINGS
                          CALL  NLO__ANALYZE_RINGS
     +
     +                               ( MINSIZE,
     +                                 R (NBASE+1),
     +                                 X (NBASE+1),
     +                                 Y (NBASE+1),
     +                                 Z (NBASE+1),
     +                                 DSYMACC,
     +                                 DMAP,
     +
     +                                       PLANAR )
     +
     +
                   WRITE (*,*) ' Ring # ',N
                   WRITE (*,*) ' Ring size ',MINSIZE
                   WRITE (*,*) ' At idx = ',(R(NBASE+I),I=1,MINSIZE)
                   WRITE (*,*) ' PLANAR = ',PLANAR

                          NBASE = NBASE + MINSIZE
                       END DO
                   END IF
C
C
C             ...minimum size of rings corresponding to current
C                atomic center within current set of symmetry
C                related centers has been found. Check, if it is
C                worth including into existing rings of current
C                atomic center.
C
C
                   MINRING = RINGSZ (ATOMB)
                   PROCEED = (NRINGS.GT.0) .AND. (MINSIZE.LE.MINRING)

                   IF (PROCEED) THEN
                       IF (MINSIZE.EQ.MINRING) THEN
                           NBASE = NRING (ATOMB)
                       ELSE
                           NBASE = 0
                           RINGSZ (ATOMB) = MINSIZE
                       END IF

                       NSIZE = NRINGS * MINSIZE

                       DO N = 1,NSIZE
                          RING (NBASE+N,ATOMB) = R (N)
                       END DO
                       NRING (ATOMB) = NBASE + NSIZE
                   END IF
C
C
C             ...next atomic center for ring check.
C
C
                END DO
C
C
C             ...next atomic center for symmetry check.
C
C
            END IF
         END DO
C
C
C             ...if everything went allright, some platonic solids
C                cannot be simultaneously present. The tetrahedron
C                can coexist with the octahedron only (this is seen
C                easily by placing a center on the middle of each
C                tetrahedron edge, of which there are six). Both
C                cube and octahedron symmetries can coexist because
C                of their dual nature. Same with the dodecahedron
C                and icosahedron pair. Below we analyze the situation
C                for incompatible coexistence of symmetries.
C                Also we analyze the dimensions of the symmetry
C                related centers. Observe that in case of platonic
C                symmetry we can only have at most one NSYM = 1
C                case and only the following NSYM dimensions:
C
C
C                         1) Tetrahedron:  NSYM = 4,4,6,12
C                         2) Cube:         NSYM = 8,6,12,24
C                         3) Octahedron:   NSYM = 6,8,12,24
C                         4) Dodecahedron: NSYM = 20,12,30,60
C                         5) Icosahedron:  NSYM = 12,20,30,60
C
C
C                The first three NSYM numbers arise (in that order) by
C                placing centers on the vertices, center of faces and
C                edge-midpoints, while the last numbers are obtained by
C                placing them anywhere on the face surfaces excluding
C                the center.
C
C                Note, that we cannot exactly pinpoint down which of
C                the 5 platonic solids we have, as the vertex numbers
C                NSYM = 4,6,8,12,20 occur multiple times. The only
C                exception is the tetrahedra, which we know for sure
C                is present if at least one NSYM is equal to 4.
C
C
C
         IF (PLATONIC) THEN

             ALERT =      (TETRA  .AND. CUBE)
     +               .OR. (TETRA  .AND. DODECA)
     +               .OR. (TETRA  .AND. ICOSA)
     +               .OR. (CUBE   .AND. DODECA)
     +               .OR. (CUBE   .AND. ICOSA)
     +               .OR. (OCTA   .AND. DODECA)
     +               .OR. (OCTA   .AND. ICOSA)

             IF (ALERT) THEN
                 WRITE (*,*) ' Symmetry inconsistency! '
                 WRITE (*,*) ' TETRA,CUBE,OCTA,DODECA,ICOSA = ',
     +                         TETRA,CUBE,OCTA,DODECA,ICOSA
                 WRITE (*,*) ' nlo__symmetry_related_centers '
                 WRITE (1,*) ' Symmetry inconsistency! '
                 WRITE (1,*) ' TETRA,CUBE,OCTA,DODECA,ICOSA = ',
     +                         TETRA,CUBE,OCTA,DODECA,ICOSA
                 WRITE (1,*) ' nlo__symmetry_related_centers '
                 STOP
             END IF

             DO ATOMA = 1,NATOM
                ATDONE (ATOMA) = 0
             END DO

             CENTER = 0

             DO ATOMA = 1,NATOM
                CHECK = ATDONE (ATOMA) .EQ. 0
                IF (CHECK) THEN
                    NSYM = 0
                    DO ATOMB = 1,NATOM
                       IF (SYMMAP (ATOMB,ATOMA) .EQ. 1) THEN
                           NSYM = NSYM + 1
                           ATDONE (ATOMB) = 1
                       END IF
                    END DO

                    IF (NSYM.EQ.1) THEN
                        CENTER = CENTER + 1
                    END IF

                    NSYM1  = NSYM .EQ. 1
                    NSYM4  = NSYM .EQ. 4
                    NSYM6  = NSYM .EQ. 6
                    NSYM8  = NSYM .EQ. 8
                    NSYM12 = NSYM .EQ. 12
                    NSYM20 = NSYM .EQ. 20
                    NSYM24 = NSYM .EQ. 24
                    NSYM30 = NSYM .EQ. 30
                    NSYM60 = NSYM .EQ. 60

                    NSYMOK =     NSYM1 .OR.NSYM4 .OR.NSYM6 .OR.NSYM8
     +                       .OR.NSYM12.OR.NSYM20.OR.NSYM24.OR.NSYM30
     +                       .OR.NSYM60

                    SYMBAD1 =  .NOT. NSYMOK
                    SYMBAD2 =  CENTER .GT. 1
                    SYMBAD3 =       (NSYM4.OR.NSYM6.OR.NSYM8)
     +                        .AND. (DODECA.OR.ICOSA)
                    SYMBAD4 =       (NSYM20.OR.NSYM30.OR.NSYM60)
     +                        .AND. (TETRA.OR.CUBE.OR.OCTA)

                    ALERT =      SYMBAD1
     +                      .OR. SYMBAD2
     +                      .OR. SYMBAD3
     +                      .OR. SYMBAD4

                    IF (ALERT) THEN
                        WRITE (*,*) ' Symmetry inconsistency! '
                        WRITE (*,*) ' SYMBAD1 = ',SYMBAD1
                        WRITE (*,*) ' SYMBAD2 = ',SYMBAD2
                        WRITE (*,*) ' SYMBAD3 = ',SYMBAD3
                        WRITE (*,*) ' SYMBAD4 = ',SYMBAD4
                        WRITE (*,*) ' nlo__symmetry_related_centers '
                        WRITE (1,*) ' Symmetry inconsistency! '
                        WRITE (1,*) ' SYMBAD1 = ',SYMBAD1
                        WRITE (1,*) ' SYMBAD2 = ',SYMBAD2
                        WRITE (1,*) ' SYMBAD3 = ',SYMBAD3
                        WRITE (1,*) ' SYMBAD4 = ',SYMBAD4
                        WRITE (1,*) ' nlo__symmetry_related_centers '
                        STOP
                    END IF

                END IF
             END DO
         END IF
C
C
C             ...everything is ok. Reset the atomic index counters
C                from individual to set counting.
C
C
         NTETRA  = NTETRA  / 4
         NCUBE   = NCUBE   / 8
         NOCTA   = NOCTA   / 6
         NDODECA = NDODECA / 20
         NICOSA  = NICOSA  / 12

         DO N = 1,NATOM
            NSIZE = RINGSZ (N)
            IF (NSIZE.EQ.BADSIZE) THEN
                RINGSZ (N) = 0
            ELSE
                NRING (N) = NRING (N) / NSIZE
            END IF
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE REORD_MOS(IFLG,NATOMS,NBAS,NBASP,NTANGM,ICNTR,
     &                     COEFF,COEFFN,NANGMOM,NMOMAO,NAOATM,WFN)
C 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      Logical WFN
C     
      DIMENSION COEFF(NBAS*NBASP),COEFFN(NBAS*NBASP),ICNTR(NBAS),
     $     NANGMOM(NATOMS),NMOMAO(NATOMS*NTANGM),NAOATM(NATOMS)
C     
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C     
      NBAS2=NBAS*NBASP
C
      IF (WFN .AND. IFLG.EQ.0) THEN
         CALL GETREC(20,'JOBARC','CNTERBF0',NBAS,ICNTR)
      ELSE
         IF (IFLG.EQ.0) THEN
            CALL GETREC(20,'JOBARC','CNTERBF0',NBAS,ICNTR)
            CALL GETREC(20,'JOBARC','EVECAO_A',IINTFP*NBAS2,COEFF)
         ELSE
            CALL GETREC(20,'JOBARC','EVECAO_B',IINTFP*NBAS2,COEFF)
         ENDIF
      ENDIF
#ifdef _DEBUG_LVL0
      Write(6,*)
      Print*, "The eigenvectors in Reord_MOs", NATOMS
      Call output(COEFF, 1, NBAS, 1, NBASP, NBAS, NBASP, 1)
      Write(6,*) 
      Write(6,"(a,I5)") "The value of NTANGM :", NTANGM
      Write(6,*)
      Write(6,"(a)") "The NANGMOM array"
      Write(6,"(4(1x,I3))") (NANGMOM(I), I=1, NATOMS)
      Write(6,*)
      Write(6,"(a)") "The NMOMAO array"
      Write(6,"(4(1x,I3))") (NMOMAO(I), I=1, NATOMS*NTANGM)
      Write(6,*)
#endif
C  Put higher angular momentum vectors in correct order
C
      ICNT=1
      IATMOFF=0
      DO 110 IATM=1,NATOMS
         DO 120 IANGMOM=1,NANGMOM(IATM)
            NCNT=1
            DO 125 IMOMAO=1,NMOMAO((IATM-1)*NTANGM+IANGMOM)
               IF(IANGMOM.EQ.1)THEN
                  DO 130 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=COEFF((IMO-1)*NBAS+ICNT)
 130              CONTINUE
               ENDIF
               IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)
               IF(IANGMOM.EQ.2)THEN
                  DO 141 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*3+IOFF+1)
 141              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.3)THEN
                  DO 142 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*3+IOFF+2)
 142              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.4)THEN
                  DO 143 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*3+IOFF+3)
 143              CONTINUE
               ENDIF
               IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)+
     $              3*NMOMAO((IATM-1)*NTANGM+2)
               IF(IANGMOM.EQ.5)THEN
                  DO 151 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+1)
 151              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.6)THEN
                  DO 152 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+2)
 152              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.7)THEN
                  DO 153 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+3)
 153              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.8)THEN
                  DO 154 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+4)
 154              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.9)THEN
                  DO 155 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+5)
 155              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.10)THEN
                  DO 156 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+6)
 156              CONTINUE
               ENDIF
               IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)+
     $              3*NMOMAO((IATM-1)*NTANGM+2)+
     $              6*NMOMAO((IATM-1)*NTANGM+5)
               IF(IANGMOM.EQ.11)THEN
                  DO 160 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+1)
 160              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.12)THEN
                  DO 161 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+2)
 161              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.13)THEN
                  DO 162 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+3)
 162              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.14)THEN
                  DO 163 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+4)
 163              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.15)THEN
                  DO 164 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+5)
 164              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.16)THEN
                  DO 165 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+6)
 165              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.17)THEN
                  DO 166 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+7)
 166              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.18)THEN
                  DO 167 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+8)
 167              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.19)THEN
                  DO 168 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+9)
 168              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.20)THEN
                  DO 169 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+10)
 169              CONTINUE
               ENDIF
               ICNT=ICNT+1
               NCNT=NCNT+1
 125        CONTINUE
 120     CONTINUE
         IATMOFF=IATMOFF+NAOATM(IATM)
 110  CONTINUE

#ifdef _DEBUG_LVL0
      Write(6,*)  
      Print*, "The eigenvectors after reordering in Reord_MOs"
      Call output(COEFFN, 1, NBAS, 1, NBASP, NBAS, NBASP, 1)
      Write(6,*)  
#endif
C     
      RETURN
      END
      
      

      SUBROUTINE INITPOP
C
C INITIALIZES COMMON BLOCK /SYM/.
C
C  DESCRIPTION OF /SYM/
C
C         POP1   ...... NUMBER OF OCCUPIED ALPHA ORBITALS WITHIN EACH IRREP
C         POP2   ...... NUMBER OF OCCUPIED BETA ORBITALS WITIN EACH IRREP
C         VRT1   ...... NUMBER OF VIRTUAL ALPHA ORBITALS WITHIN EACH IRREP
C         VRT2   ...... NUMBER OF VIRTUAL BETA ORBITALS WITHIN EACH IRREP
C         NTAA   ...... LENGTH OF T1(A,I) ALPHA
C         NTBB   ...... LENGTH OF T1(A,I) BETA
C         NF1AA  ...... LENGTH OF F(M,I) ALPHA ( NOTE ALL Fs ARE NOT SYMMETRIC)
C         NF1BB  ...... LENGTH OF F(M,I) BETA
C         NF2AA  ...... LENGTH OF F(A,E) ALPHA
C         NF2BB  ...... LENGTH OF F(A,E) BETA
C
CEND
      IMPLICIT INTEGER (A-Z)
      COMMON/SYM/POP1(8),POP2(8),VRT1(8),VRT2(8),
     &           NTAA,NTBB,NF1AA,NF1BB,NF2AA,NF2BB
      COMMON/SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
C
      CALL GETREC(-1,'JOBARC','SYMPOPOA',NIRREP,POP1)
      CALL GETREC(-1,'JOBARC','SYMPOPOB',NIRREP,POP2)
      CALL GETREC(-1,'JOBARC','SYMPOPVA',NIRREP,VRT1)
      CALL GETREC(-1,'JOBARC','SYMPOPVB',NIRREP,VRT2)
C
      NTAA=0
      NTBB=0
      NF1AA=0
      NF1BB=0
      NF2AA=0
      NF2BB=0
      DO 100 IRREP=1,NIRREP
       POPA=POP1(IRREP)
       POPB=POP2(IRREP)
       VRTA=VRT1(IRREP)
       VRTB=VRT2(IRREP)
       NTAA=NTAA+POPA*VRTA
       NTBB=NTBB+POPB*VRTB
       NF1AA=NF1AA+POPA*POPA
       NF1BB=NF1BB+POPB*POPB
       NF2AA=NF2AA+VRTA*VRTA
       NF2BB=NF2BB+VRTB*VRTB
100   CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine print_symbolic_constants()
      
      implicit none
      include 'symbolic_constants.h'

      print *, 'norb = ', symbolic_constant_table(1)
      print *, 'nocc = ', symbolic_constant_table(2)
      print *, 'nvirt = ', symbolic_constant_table(3)
      print *, 'bocc = ', symbolic_constant_table(4)
      print *, 'eocc = ', symbolic_constant_table(5)
      print *, 'bvirt = ', symbolic_constant_table(6)
      print *, 'evirt = ', symbolic_constant_table(7)
      print *, 'naocc = ', symbolic_constant_table(8)
      print *, 'nbocc = ', symbolic_constant_table(9)
      print *, 'navirt = ', symbolic_constant_table(10)
      print *, 'nbvirt = ', symbolic_constant_table(11)
      print *, 'baocc = ', symbolic_constant_table(12)
      print *, 'bbocc = ', symbolic_constant_table(13)
      print *, 'eaocc = ', symbolic_constant_table(14)
      print *, 'ebocc = ', symbolic_constant_table(15)
      print *, 'bavirt = ', symbolic_constant_table(16)
      print *, 'bbvirt = ', symbolic_constant_table(17)
      print *, 'eavirt = ', symbolic_constant_table(18)
      print *, 'ebvirt = ', symbolic_constant_table(19)
      print *, 'noccorb = ', symbolic_constant_table(20)
      print *, 'nvirtorb = ', symbolic_constant_table(21)
      print *, 'boccorb = ', symbolic_constant_table(22)
      print *, 'eoccorb = ', symbolic_constant_table(23)
      print *, 'bvirtorb = ', symbolic_constant_table(24)
      print *, 'evirtorb = ', symbolic_constant_table(25)
      print *, 'naoccorb = ', symbolic_constant_table(26)
      print *, 'nboccorb = ', symbolic_constant_table(27)
      print *, 'navirtorb = ', symbolic_constant_table(28)
      print *, 'nbvirtorb = ', symbolic_constant_table(29)
      print *, 'baoccorb = ', symbolic_constant_table(30)
      print *, 'bboccorb = ', symbolic_constant_table(31)
      print *, 'eaoccorb = ', symbolic_constant_table(32)
      print *, 'eboccorb = ', symbolic_constant_table(33)
      print *, 'bavirtorb = ', symbolic_constant_table(34)
      print *, 'bbvirtorb = ', symbolic_constant_table(35)
      print *, 'eavirtorb = ', symbolic_constant_table(36)
      print *, 'ebvirtorb = ', symbolic_constant_table(37)
      print *, 'cc_iter = ', symbolic_constant_table(38)
      print *, 'cc_hist = ', symbolic_constant_table(39)
      print *, 'cc_beg = ',  symbolic_constant_table(40)
      print *, 'scf_iter = ',   symbolic_constant_table(41)
      print *, 'scf_hist = ',  symbolic_constant_table(42)
      print *, 'scf_beg = ',  symbolic_constant_table(43)
      print *, 'ncenters = ', symbolic_constant_table(44)
      print *, 'itrips = ',  symbolic_constant_table(45)
      print *, 'itripe = ',  symbolic_constant_table(46)
      print *, 'ihess1 = ',  symbolic_constant_table(47)
      print *, 'ihess2 = ', symbolic_constant_table(48)
      print *, 'jhess1 = ',  symbolic_constant_table(49)
      print *, 'jhess2 = ',  symbolic_constant_table(50)
      print *, 'subb = ', symbolic_constant_table(51)
      print *, 'sube = ', symbolic_constant_table(52)
      print *, 'sip_sub_segsize = ', symbolic_constant_table(53)
      print *, 'sip_sub_occ_segsize = ',  symbolic_constant_table(54)
      print *, 'sip_sub_virt_segsize ', symbolic_constant_table(55)
      print *, 'sip_sub_ao_segsize = ', symbolic_constant_table(56)

      return 
      end

C     SORTS VECTOR OF NUCLEAR COORDINATES - TO CHECK FOR EQUIVALENCE
C     OF TWO ORIENTATIONS - NEEDS Q VECTOR AND ATOMIC MASS VECTOR
C     FOR MASS WEIGHTING.  THE SORT IS FIRST DONE ON THE X COORDINATE,
C     BUT IF IDENTICAL X VALUES ARE ENCOUNTERED, THE Y COORDINATE
C     IS THEN SORTED AS WELL, AND ALSO THE Z IF NECESSARY.

      SUBROUTINE SORT2(XX,Y,NORD,IORDER)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

      DIMENSION XX(3*IORDER),Y(3*IORDER),NORD(IORDER*2)

      DIMENSION X(3*MXATMS),SCR(3*MXATMS)

      TOL=1.d-5

      CALL ZERO(X,3*MXATMS)

c   o sort the X coordinates and mass weight them
      NATOMS=IORDER
      CALL DCOPY(3*IORDER,XX,1,SCR,1)
      IOFF=1
      DO I=1,NATOMS
         NORD(I+NATOMS)=I
         IOFF=IOFF+3
      END DO
      CALL DCOPY(NATOMS,SCR,3,X,1)

      CALL PIKSR3(NATOMS,X,NORD(NATOMS+1))
      DO ITARGET=1,NATOMS
         ISOURCE=NORD(ITARGET+NATOMS)
         IOFFSRC=3*(ISOURCE-1)+1
         IOFFTAR=3*(ITARGET-1)+1
         CALL DCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
      END DO

c   o search for clusters of values in the X vector
      IFINDX=1
1     CONTINUE
         NLEFT=NATOMS-IFINDX+1
         ILOC=IFINDNE(NLEFT,X(IFINDX),1,X(IFINDX),TOL)+IFINDX-1
         ICLSIZX=ILOC-IFINDX
         IF (ILOC.NE.IFINDX+1) THEN
c         o located cluster --> sort the Y values
            CALL DCOPY(ICLSIZX,Y(2+3*(IFINDX-1)),3,X,1)
            CALL PIKSR3(ICLSIZX,X,NORD(NATOMS+IFINDX))
            DO ITARGET0=1,ICLSIZX
               ISOURCE=NORD(ITARGET0+NATOMS+IFINDX-1)
               ITARGET=ITARGET0+IFINDX-1
               IOFFSRC=3*(ISOURCE-1)+1
               IOFFTAR=3*(ITARGET-1)+1
               CALL DCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
            END DO
c         o search for clusters of values in the Y vector within this X cluster
            IFINDY=1
2           CONTINUE
               NLEFTY=ICLSIZX-IFINDY+1
               ILOC=IFINDNE(NLEFTY,X(IFINDY),1,X(IFINDY),TOL)+IFINDY-1
               ICLSIZY=ILOC-IFINDY
               IF (ICLSIZY.NE.1) THEN
c               o located cluster --> sort the Z values
                  IPOS=IFINDX+IFINDY-1
                  CALL DCOPY(ICLSIZY,Y(3+3*(IPOS-1)),3,X,1)
                  CALL PIKSR3(ICLSIZY,X,NORD(NATOMS+IPOS))
                  DO ITARGET0=1,ICLSIZY
                     ISOURCE=NORD(ITARGET0+NATOMS+IPOS-1)
                     ITARGET=ITARGET0+IPOS-1
                     IOFFSRC=3*(ISOURCE-1)+1
                     IOFFTAR=3*(ITARGET-1)+1
                     CALL DCOPY(3,SCR(IOFFSRC),1,Y(IOFFTAR),1)
                  END DO
               END IF
               IFINDY=IFINDY+ICLSIZY
            IF (IFINDY.LT.ICLSIZX) GOTO 2
         END IF
         IFINDX=IFINDX+ICLSIZX
      IF (IFINDX.LT.NATOMS) GOTO 1

c YAU - why is this here?
      IOFF=1
      DO I=1,NATOMS
         Z=1.0
         CALL DSCAL(3,Z,Y(IOFF),1)
         IOFF=IOFF+3
      END DO

      CALL ICOPY(NATOMS,NORD(NATOMS+1),1,NORD,1)

      RETURN
      END

c This program writes a molden format file containing the coordinates,
c basis functions for each center, molecular orbitals, frequencies,
c frequency coordinates, and normal mode vectors.
c
c Basis functions are limited to gaussian which is a constraint from aces2.
c
c the following files need to be present:
c	JOBARC
c	JAINDX
c	ZMAT
c	GENBAS
c       for frequencies NORMCO
c 
c Ken Wilson March 1998































































































































































































































































































































































































































































































































      subroutine molden_main (args,dimargs)

      implicit double precision (a-h,o-z)
C
C Watson added
C 
c ARGUMENT LIST
      integer dimargs
      character*80 args(dimargs)
      
      logical LNAT_ORBS, dens_diff
      character*8 DLABEL
      character*2 iroot

      parameter (mxangmom=7)
      parameter (mxcoef=30)


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end







c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c flags2.com : begin
      integer         iflags2(500)
      common /flags2/ iflags2
c flags2.com : end
c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end
      character*32 szFile
      logical bExist
      dimension iangmom(mxangmom)
c
      iuhf = 1
      if (iflags(11).eq.0) iuhf = 0
      maxcor=icrsiz
      iunit =10
      if (iunit.ne.6) then
         szFile = 'MOLDEN.INPUT'
         inquire(file=szFile,exist=bExist)
         if (bExist) call f_remove(szFile)
         open(unit=iunit,file=szFile,form='formatted',err=2)
 1       goto 3
 2       print *, '@MOLDEN_MAIN: could not create/open ',szFile
         call errex
 3       continue
      end if
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      iexx=0
c      iexx=1
c      call nl_init('tomolden',ierr,.true.)
c      if(ierr.eq.1)then
c         write(*,*)' *tomolden namelist not found in ZMAT file'
c         call errex
c      end if
c      call nl_str('EXX',0,iexx)
c      call nl_term
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c geometry
c
      write(iunit,'(a)')'[Molden Format]'
      write(iunit,'(a)')'[Atoms] Angs'

      call getrec(20,'JOBARC','NATOMS',1,natoms)

      iatchrg=i0
      icoord=iatchrg+natoms+mod(natoms,2)
      ifuchrg=icoord+3*natoms*iintfp
      ifucoord=ifuchrg+natoms+mod(natoms,2)
      inext=ifucoord+3*natoms*iintfp

      if(inext-i0.gt.maxcor)call insmem('rdgeom-f',inext-i0,maxcor)

      call A2rd_geom(natoms,icore(iatchrg),icore(icoord),
     &               icore(ifuchrg),icore(ifucoord),iunit,.true.)
c--------------------------------------------------------------------------
c basis set
c
      call getrec(0,'JOBARC','SCFENEG ',Ilength,Ijunk)
      If (Ilength .LE. 0) Then
         if (iunit.ne.6) then
             write(iunit,*)
             close(iunit)
             print *, '@MOLDEN_MAIN: successfully created ',szFile
         end if
         Return
      Endif

      write(iunit,'(a)')'[GTO]'

      iexp=inext 
      icoef=iexp+mxangmom*mxcoef*iintfp 
      inext=icoef+mxangmom*mxcoef**2*iintfp 

      if(inext-i0.gt.maxcor)call insmem('rdbasis-f',inext-i0,maxcor)

      call A2rd_basis(natoms,icore(iatchrg),icore(iexp),
     &                icore(icoef),nshells,iangmom,iunit,.true.)
c--------------------------------------------------------------------------
c orbitals from exact calculations
c
      if((iflags(54).ne.3).and.
     &   (iflags2(138).ne.3)) then
   
        call getrec(0,'JOBARC','SCFENEG ',Ilength,Dtmp)
        if (ilength .gt. 0) then
           write(iunit,*)
           write(iunit,'(a)')'[MO]'
        else
           if (iunit.ne.6) then
              close(iunit)
              print *, '@MOLDEN_MAIN: successfully created ',szFile
           end if
            Return
        Endif
C
        call getrec(-1,'JOBARC','NAOBASFN',1,nao)
        call getrec(-1,'JOBARC','NBASTOT',1,nmo)
C
C Watson, added
C
        iroot = "00"
        dens_diff=.FALSE.
        LNAT_ORBS = .FALSE.
        iLst = linblnk(args(1))
        IF (args(1)(1:iLst) .EQ. "nlo") LNAT_ORBS = .TRUE.

        iLst = linblnk(args(2))
        IF (iLst .NE. 0) THEN
          DLABEL = args(2)(1:iLst)
          IF (DLABEL(1:iLst) .EQ. "ediff") THEN
            iLst = linblnk(args(3))
            dens_diff=.TRUE.
            IF (iLst .EQ. 0) THEN
               WRITE (*,*) ' Density difference requested',
     +                     ' but no root number specified!'
               call errex
            ELSE IF (iLst .NE. 2) THEN
               WRITE (*,*) ' Incorrect root number specified',
     +                     ' for density difference!'
               WRITE (*,*) ' Must be in form XX (i.e. 01, 02, etc)!'
               call errex
            ELSE
               DLABEL="TDENSITY"
               iroot = args(3)(1:iLst)
            ENDIF
          ENDIF
        ELSE
          DLABEL = 'TDENSITY'
        ENDIF

CSSS        WRITE (*,*) 'DLABEL - ', DLABEL, LNAT_ORBS
        IF ( .NOT. LNAT_ORBS) THEN
           iener=inext
           iocc=iener+nmo*iintfp
           iorb=iocc+nmo+mod(nmo,2)
           iorbr=iorb+nao*nmo*iintfp
           imom =iorbr+nao*iintfp
           inext=imom+nao
           
           if(inext-i0.gt.maxcor)call insmem('rdorb-f',inext-i0,maxcor)

           call molden_rdorb(icore(iener),icore(iocc),icore(iorb),
     &          icore(iorbr),icore(imom),icore(inext),nao,nmo,
     &          maxcor-(inext-i0),iuhf,iexx,iunit)

        ELSE
           iener=inext
           iocc=iener+nmo*iintfp
           iorb=iocc+nmo+mod(nmo,2)
           igden=iorb+nao*nmo*iintfp
           ivec=igden+nmo*nmo*iintfp
           ieden=ivec+nmo*nmo*iintfp
           inext=ieden+nmo*nmo*iintfp

           if(inext-i0.gt.maxcor)call insmem('nlorb ',inext-i0,maxcor)

           call molden_nlorb (icore(iener),icore(iocc),icore(iorb),
     &       icore(igden),icore(ivec),icore(ieden),
     &       icore(inext),nao,nmo,maxcor-(inext-i0),iuhf,iexx,iunit,
     &       DLABEL,iroot,dens_diff)
        ENDIF
      endif
c-------------------------------------------------------------------------
c vibrational frequencies
c
      if(iflags(54).ne.0) then
        write(iunit,*)  
        write(iunit,'(a)')'[FREQ]'

        call getrec(-1,'JOBARC','NREALATM',1,nreal_atoms)
        nvib=3*nreal_atoms
 
        ifreq=inext
        ifreqco=ifreq+nvib*iintfp
        inormmd=ifreqco+3*nreal_atoms*iintfp
        inext=inormmd+nvib*3*nreal_atoms*iintfp

        if(inext-i0.gt.maxcor)call insmem('rdvib-f',inext-i0,maxcor)
        call A2rd_vib(nreal_atoms,icore(iatchrg),icore(ifreq),
     &    icore(icoord),icore(inormmd),Nimag,nvib,iunit,.true.)

      endif

c ----------------------------------------------------------------------

      if (iunit.ne.6) then
         close(iunit)
         print *, '@MOLDEN_MAIN: successfully created ',szFile
      end if

      return
      end

      Subroutine Read_ric_constrains(Constrains, 
     &                               Num_bond_Constrains, 
     &                               Num_angle_constrains,
     &                               Num_dihs_angle_constrains,
     &                               Not_found)
      Implicit double precision (a-h,o-z)
      Logical ZMAT_PRESENT
      Character*80 wrk
      Integer Constrains 
      Logical Not_found
C
#include "mxatms.par"

      Dimension Constrains(4, Maxredunco)
  
      Not_found = .False.

      INQUIRE(FILE='ZMAT',EXIST=ZMAT_PRESENT)
C
      IF (ZMAT_PRESENT)THEN
         OPEN(UNIT=4,FILE='ZMAT',FORM='FORMATTED',STATUS='OLD')
         rewind(4)
      else
         write(6,'(T3,a)')'@Read_constrains, ZMAT file not present.'
         call errex
      ENDIF
c
300   READ(4,'(A)', END=900) WRK
      IF (WRK(1:11) .NE.'*CONSTRAINS') goto 300

      READ(4,'(A)', END=900) WRK
      IF (WRK(1:11) .EQ.'*END') GOTO 999
      BACKSPACE(4)

      READ(4,*,END=900) Num_bond_Constrains
      Do Iread = 1, Num_bond_constrains
          READ(4,*,END=900) Constrains(1,Iread), Constrains(2,Iread)
      Enddo 
C
      Ibegin = Num_bond_constrains + 1
   
      READ(4,'(A)', END=900) WRK
      IF (WRK(1:11) .EQ.'*END') THEN
         Num_angle_constrains      = 0 
         Num_dihs_angle_constrains = 0
         GOTO 99
      ENDIF
      BACKSPACE(4)

      READ(4,*,END=900) Num_angle_constrains
      Do Iread = Ibegin, Ibegin+Num_angle_constrains-1
          READ(4,*,END=900) Constrains(1,Iread), Constrains(2,Iread),
     &                      Constrains(3,Iread)
      Enddo 

      Ibegin = Num_bond_constrains + Num_angle_constrains + 1

      READ(4,'(A)', END=900) WRK
      IF (WRK(1:11) .EQ.'*END') THEN
         Num_dihs_angle_constrains = 0
         GOTO 99
      ENDIF
      BACKSPACE(4)

      READ(4,*,END=900) Num_dihs_angle_constrains 
      Do Iread = Ibegin, Ibegin+Num_dihs_angle_constrains-1
          READ(4,*,END=900) Constrains(1,Iread), Constrains(2,Iread),
     &                      Constrains(3,Iread), Constrains(4,Iread)
      Enddo 

      GO TO 99
C
900   WRITE(6,901)
901   FORMAT(3x,'@Read_constrains, *CONSTRAINS namelist not found or',
     &       ' incomplete.')
      GO TO 999
C
 999  CONTINUE
      CLOSE(UNIT=4,STATUS='KEEP')
      Write(6,*)
      Write(6,"(3x,2a)") "Constrained redundent internal ",
     &                   "optimization is requested but no constraints"
      Write(6,"(3x,a)")  "are specified in the inputfile (ZMAT)."
      Write(6,"(3x,2a)") "Calculation proceeds as a unconstrained ",
     &                   "optimization."
C 
      Not_found = .True.
      Num_bond_constrains       = 0
      Num_angle_constrains      = 0
      Num_dihs_angle_constrains = 0
C
  99  CONTINUE
      CLOSE(UNIT=4,STATUS='KEEP')

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine read_list_to_blocks(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table,  op)
c---------------------------------------------------------------------------
c   Wrapper routine for read_blocks_to_list instruction.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      if (mpi_io_support) then
         call read_list_to_blocks_mpi_io(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table,  op)
      else
         call read_list_to_blocks_no_mpi_io(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table,  op)
      endif
     
      return
      end

      subroutine read_list_to_blocks_mpi_io(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table,  op)
c--------------------------------------------------------------------------
c   Reads block data from a list file and distributes them to their owners.
c--------------------------------------------------------------------------

      implicit none
      include 'aces3_version.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h' 
      include 'block_index.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, k, ierr 
      integer iarray, array, type, ind, seg, iblock, iblock_map
      integer company, comm, company_comm
      integer niocompany , nbarray
      integer pst_get_company, pst_get_company_comm
      integer msg(len_sip_server_message)
      integer*8 msg8(len_sip_server_message/2)
      equivalence (msg, msg8)
      integer mx_mpi_req
      parameter (mx_mpi_req = 150000)
      integer request(mx_mpi_req)
      integer statuses(MPI_STATUS_SIZE, mx_mpi_req)
      integer mode, fh, fhndx
      integer*8 offset, size, data_file_loc, index_file_loc
      integer*8 bdata_table(2,narray_list)
      integer*8 indblk, get_block_index
      integer stack, blkndx, val1, val2, nindex
      integer status(MPI_STATUS_SIZE)

      logical served_data, file_exist
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

      if (aces3_version .eq. '3.0.3') then

c---------------------------------------------------------------------------
c   Check for presence of BLOCK_INDEX_FORMAT file.  If it exists, then
c   the BLOCK_INDEX and BLOCKDATA files were created by the new algorithm
c   for write_blocks_to_list that uses MPI_IO, and we must read the files
c   using the new algorithm as well.  If the file does not exist, then the
c   BLOCK_INDEX and BLOCKDATA were created with the previous version, and
c   during this switchover, we will revert back to the non-MPI_IO version.
c---------------------------------------------------------------------------

         inquire (file='BLOCK_INDEX_FORMAT', exist=file_exist)
         if (.not. file_exist) then
            if (me .eq. 0) print *,'*** Restarting using non-parallel',
     *            'I/O algorithm (old format BLOCKDATA file.'
            call read_list_to_blocks_no_mpi_io(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table,  op)
            return
         endif
      endif
 
      data_file_loc  = 0
      index_file_loc = 0
      served_data = .false.
      do iarray = 1, narray_list
         array = array_list(iarray)
         type  = array_table(c_array_type, array)
         if (type .ne. served_array .and.
     *       type .ne. distributed_array) then
            print *,'Error: READ_LIST_TO_BLOCKS array ',
     *          array,' should be either served or distributed.'
            call abort_job()
         endif  

         if (type .eq. served_array) served_data = .true. 

         call determine_array_size(array, array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      size)
         nbarray = array_table(c_numblks, array)

         bdata_table(1,iarray) = index_file_loc
         bdata_table(2,iarray) = data_file_loc
         data_file_loc  = data_file_loc + size
         index_file_loc = index_file_loc + nbarray * lblk_index_entry
      enddo

      company_comm = pst_get_company_comm(me)
      if (served_data) then

c-------------------------------------------------------------------------
c   Send a message to each server indicating that the BLOCKDATA file should
c   be opened.
c--------------------------------------------------------------------------

         comm = mpi_comm_world

c--------------------------------------------------------------------------
c   Send a blocks_to_list "open" message (i. e. array = 0) to each server.
c--------------------------------------------------------------------------

         if (me .eq. 0) then
            msg(1) = sip_server_list_to_blocks
            msg(2) = 0         ! signal to open the files.
            msg(3) = 0         ! nindex
            niocompany = 0
            do i = 1, nprocs
               company = pst_get_company(i-1)
               if (company .eq. io_company_id) then
                  niocompany = niocompany + 1
                  call mpi_isend(msg, len_sip_server_message,
     *                     mpi_integer,
     *                     i-1, sip_server_message,
     *                     mpi_comm_world,
     *                     request(niocompany), ierr)
               endif
            enddo
         endif   ! me .eq. 0
      else
         comm = company_comm
      endif

      mode = MPI_MODE_RDONLY
      call mpi_file_open(comm, 'BLOCKDATA', mode,
     *                   MPI_INFO_NULL, fh, ierr)
      offset = 0
      call mpi_file_set_view(fh, offset, MPI_DOUBLE_PRECISION,
     *                       MPI_DOUBLE_PRECISION, 'native',
     *                       MPI_INFO_NULL, ierr)

      call mpi_file_open(comm, 'BLOCK_INDEX', mode,
     *                   MPI_INFO_NULL, fhndx, ierr)
      offset = 0
      call mpi_file_set_view(fhndx, offset, MPI_INTEGER,
     *                       MPI_INTEGER, 'native',
     *                       MPI_INFO_NULL, ierr)

c-----------------------------------------------------------------------------
c   Wait for completion of the server messages.
c-----------------------------------------------------------------------------

      if (me .eq. 0 .and. served_data) then
         call mpi_waitall(niocompany, request, statuses, ierr)
      endif

c---------------------------------------------------------------------------
c   Process each array.
c---------------------------------------------------------------------------

      do iarray = 1, narray_list
         array      = array_list(iarray)
         type       = array_table(c_array_type,array)
         nindex     = array_table(c_nindex, array)
         iblock_map = array_table(c_block_map, array)
         index_file_loc = bdata_table(1,iarray)
         data_file_loc  = bdata_table(2,iarray)
         if (type .eq. served_array) then

c---------------------------------------------------------------------------
c   Send a list_to_blocks message to each server.
c---------------------------------------------------------------------------

            msg(1) = sip_server_list_to_blocks
            msg(2) = array
            msg(3) = 0         ! nindex
            msg8(2) = index_file_loc
            msg8(3) = data_file_loc
            msg8(4) = array_table(c_numblks,array)
            niocompany = 0
            do i = 1, nprocs
               company = pst_get_company(i-1)
               if (company .eq. io_company_id) then
                  if (me .eq. 0) then
                     niocompany = niocompany + 1
                     call mpi_isend(msg, len_sip_server_message,
     *                  mpi_integer,
     *                  i-1, sip_server_message,
     *                  mpi_comm_world,
     *                  request(niocompany), ierr)
                  endif
               endif
            enddo

            if (me .eq. 0) then

c--------------------------------------------------------------------------
c   Wait for completion of server messages.
c--------------------------------------------------------------------------

               call mpi_waitall(niocompany, request,
     *                          statuses, ierr)
            endif   ! me .eq. 0 
         else

c---------------------------------------------------------------------------
c   Process the blocks of a distributed array.
c---------------------------------------------------------------------------

            offset = data_file_loc
            nbarray = array_table(c_numblks, array)
            do iblock = 1, nbarray

c--------------------------------------------------------------------------
c   Determine block size in words.
c--------------------------------------------------------------------------

               blksize = 1
               do k = 1, nindex
                  ind = array_table(c_index_array1+k-1,array)
                  seg = block_map_table(c_block_map_seg+k-1,
     *                       iblock_map+iblock-1)
                  call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
                  blksize = blksize * (val2-val1+1)
               enddo

               blkndx = block_map_table(c_bmap_blkndx,
     *                                  iblock_map+iblock-1)
               if (block_map_table(c_processor,iblock_map+iblock-1)
     *                .eq. my_company_rank) then

c----------------------------------------------------------------------------
c   The block resides on this processor.   Read it from disk.
c----------------------------------------------------------------------------

                  stack  = array_table(c_array_stack,array)
                  indblk = get_block_index(array, iblock, stack,
     *                               blkndx, x, .true.)

                  call mpi_file_read_at(fh, offset, x(indblk),
     *                     blksize, MPI_DOUBLE_PRECISION, status,
     *                     ierr)
               endif

               offset = offset + blksize
            enddo    ! iblock
         endif   
      enddo   ! iarray

c-------------------------------------------------------------------------
c   Send servers the signal to close their files.
c-------------------------------------------------------------------------

      if (me .eq. 0 .and. served_data) then
         msg(1) = sip_server_list_to_blocks 
         msg(2) = list_to_blocks_done

         niocompany = 0
         do i = 1, nprocs
            company = pst_get_company(i-1)
            if (company .eq. io_company_id) then
               niocompany = niocompany + 1
               call mpi_isend(msg, len_sip_server_message,
     *                  mpi_integer,
     *                  i-1, sip_server_message,
     *                  mpi_comm_world,
     *                  request(niocompany), ierr)
            endif
         enddo

c--------------------------------------------------------------------------
c   Wait for completion of server messages.
c--------------------------------------------------------------------------

         call mpi_waitall(niocompany, request, statuses, ierr)
      endif   

c-------------------------------------------------------------------------
c   Close the BLOCKDATA file.
c-------------------------------------------------------------------------

      call mpi_file_close(fh, ierr)
      call mpi_file_close(fhndx, ierr)
      call mpi_barrier(company_comm, ierr)

      return
      end

      SUBROUTINE MATEXP(IRREP,NUM,A,B)
C
C     THIS ROUTINE EXPANDS THE A COMPRESSED MATRIX A(P,Q)
C     P >= Q TO AN ARRAY A(PQ) WITH P,Q. NOTE THIS ROUTINE 
C     EXPECTS THAT THE ARRAY A IS SYMMETRY PACKED
C
C     INPUT : IRREP  ...  THE IRREP OF THE CORRESPONDING PART OF A
C             NUM ......  POPULATION VECTOR FOR I AND J
C             DISSIZE ..  DISTRIBUTION SIZE OF A
C             A     ....  THE MATRIX A
C
C     OUTPUT : B .......  THE EXPANDED MATRIX A
C
CEND
C
C  CODED JG JAN/91
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIRPRD
      DIMENSION A(1),B(1),NUM(8)
      DIMENSION IPOLD(8),IPNEW(8)
C
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
C
      IND(J,I)=(J*(J-1))/2+I
C 
      DATA ZERO /0.0D0/
C
C     TAKE HERE CARE, IF WE ARE HANDLING IRREP=1 (TOTAL SYMMETRIC)
C     OR IRREP=1 (OTHERWISE)
C
      IF(IRREP.EQ.1) THEN
C
C     GET FIRST POINTERS FOR OLD AND NEW INDICES
C
       IPOLD(1)=0
       IPNEW(1)=0
       DO 10 IRREPJ=1,(NIRREP-1)
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)+(NUM(IRREPJ)*(NUM(IRREPJ)+1))/2
        IPNEW(IRREPJ+1)=IPNEW(IRREPJ)+NUM(IRREPJ)**2
10     CONTINUE
C
C     NOW LOOP OVER ALL IRREPS
C
       DO 1 IRREPJ=1,NIRREP
        NUMJ=NUM(IRREPJ)
        IPO=IPOLD(IRREPJ)
        IPN=IPNEW(IRREPJ)
C
C     LOOP OVER ORBITALS, BUT ALSO IN BACKWARD ORDER
C
        DO 100 J=1,NUMJ
         DO 100 I=1,J
          IND1=IND(J,I)+IPO
          IND2=(J-1)*NUMJ+I+IPN
          IND3=(I-1)*NUMJ+J+IPN
          B(IND2)=A(IND1)
          B(IND3)=A(IND1)
100     CONTINUE
C
1      CONTINUE
      ELSE
C
C     FILL THE POINTERS OF THE OLD AND NEW ARRAY
C
      IPOLD(1)=0
      IPNEW(1)=0
      DO 1000 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM(IRREPJ)
       NUMI=NUM(IRREPI)
       IPNEW(IRREPJ+1)=IPNEW(IRREPJ)+NUMJ*NUMI
       IF(IRREPI.LT.IRREPJ) THEN
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)+NUMJ*NUMI
       ELSE
        IPOLD(IRREPJ+1)=IPOLD(IRREPJ)
       ENDIF
1000  CONTINUE
C
C     NOW COPY OLD ARRAYS TO NEW LOCATION
C
      DO 2000 IRREPJ=1,NIRREP
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM(IRREPJ)
       NUMI=NUM(IRREPI)
       IF(IRREPJ.GT.IRREPI) THEN
        IPN=IPNEW(IRREPJ)
        IPO=IPOLD(IRREPJ)
        DO 2100 IJ=1,NUMJ*NUMI
        IPNN=IPN+IJ
        IPOO=IPO+IJ
         B(IPNN)=A(IPOO)
2100    CONTINUE
       ELSE
        IPN=IPNEW(IRREPJ)
        IPO=IPOLD(IRREPI)
        DO 2200 J=1,NUMJ
         DO 2200 I=1,NUMI
          IND1=(I-1)*NUMJ+J+IPO
          IND2=(J-1)*NUMI+I+IPN
          B(IND2)=A(IND1)
2200    CONTINUE
       ENDIF
2000  CONTINUE
      ENDIF
      RETURN
      END

C
C ITERATIVE SOLUTION OF EIGENVALUES USING THE DAVIDSON METHOD.
C THIS VERSION IS FOR CASES WHERE THE MATRIX TO BE DIAGONALIZED
C EASILY FITS INTO CORE.
C
C INPUT:
C
C  ALARGE - THE MATRIX TO BE DIAGONALIZED [DOUBLE PRECISION]
C  NDIMA  - THE DIMENSION OF ALARGE [INTEGER]
C  MAXIT  - THE MAXIMUM NUMBER OF ITERATIONS ALLOWED [INTEGER]
C  NROOT  - THE NUMBER OF ROOTS OBTAINED [INTEGER]
C  TOL    - TOLERANCE FOR CONVERGENCE [NORM OR RESIDUAL] [DOUBLE PREC]
C  NSCAN  - THE NUMBER OF DIAGONAL ELEMENTS OF ALARGE WHICH SHOULD
C           BE INSPECTED FOR INITIAL GUESSES.  THIS IS ALMOST ALWAYS
C           EQUAL TO NDIMA.
C
C OUTPUT:
C
C  ROOT   - THE EIGENVALUES [DOUBLE PRECISION]
C  IROOT  - THE NUMBER OF GOOD ROOTS OBTAINED
C  EVEC   - A VECTOR OF DIMENSION (NDIMA,NROOT) HOLDING THE
C           EIGENVECTORS  [DOUBLE PRECISION]
C  IERR   - RETURNS THE NUMBER OF BAD EIGENVALUES (UNSUCCESSFUL
C           ROOT SEARCHES)
C
C SCRATCH VECTORS:
C
C  ASMALL - LENGTH MAXIT*MAXIT
C  VSPACE - LENGTH NDIMA*(MAXIT+NROOT)
C  TMP1   - LENGTH NDIMA
C  TMP2   - LENGTH NDIMA
C  TMP3   - LENGTH MAXIT*MAX(MAXIT,NDIMA)
C  TMP4   - LENGTH NDIMA
C
      SUBROUTINE DAVID1(ALARGE,ASMALL,ROOT,EVEC,VSPACE,TMP,
     &                  TMP2,TMP3,TMP4,MAXIT,NROOT,IROOT,
     &                  NDIMA,NSCAN,TOL,IERR)
      IMPLICIT INTEGER (A-Z)
      LOGICAL DOMORE,PRINT
      DOUBLE PRECISION ALARGE,ASMALL,TMP,TMP2,TMP3,TMP4,ROOT
      DOUBLE PRECISION EVEC,VSPACE,RESID,TOL,ONE,ZILCH,X,THRESH
      DOUBLE PRECISION SNRM2,SDOT,XMAX,EVAL,LARGE
      PARAMETER (LARGE=1.D+30)
      DIMENSION ALARGE(NDIMA,NDIMA),ASMALL(*),VSPACE(NDIMA,MAXIT+NROOT)
      DIMENSION TMP(NDIMA),TMP2(NDIMA),TMP3(*)
      DIMENSION TMP4(NDIMA)
      DIMENSION ROOT(NROOT),EVEC(NDIMA,NROOT)
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/FLAGS/IFLAGS(100)
C
      DATA ONE,ZILCH /1.0D0,0.0D0/
      DATA THRESH /1.D-10/
C
      INDXF(I,J,N)=I+(J-1)*N
C
      PRINT=IFLAGS(1).GE.2
      IERR=0
C
      IF(PRINT)THEN
       WRITE(6,1000)NROOT
1000   FORMAT(T3,'@DAVID1-I, Beginning search for lowest ',I5,
     &           ' solutions.')
      ENDIF
C
C COLLECT DIAGONAL ELEMENTS OF ALARGE INTO TMP VECTOR
C
      CALL DCOPY(NDIMA,ALARGE,NDIMA+1,TMP,1)
C
C COUNTER FOR SUCCESSFUL ROOT SEARCHES
C
      IROOT=0
C
C LOOP OVER NUMBER OF DESIRED ROOTS
C
      DO 5 NPASS=1,NROOT
C
C GENERATE INITIAL GUESS BASED ON DIAGONAL ELEMENTS OF ALARGE
C
       NSPACE=1
       IF(PRINT)WRITE(6,1003)NPASS
       IF(PRINT)WRITE(6,1001)
       ILOC=IMINPOS(NSCAN,TMP,1)
       TMP(ILOC)=LARGE
       ICOL=MAXIT
       CALL ZERO(VSPACE(1,ICOL),NDIMA)
       VSPACE(ILOC,ICOL)=ONE
       CALL DCOPY(NDIMA,VSPACE(1,ICOL),1,TMP2,1)
C
C ORTHOGONALIZE GUESS TO ALL PRECEDING SOLUTION VECTORS
C
       IF(IROOT.GT.0)THEN
        CALL GSCHMIDT(VSPACE(1,ICOL),VSPACE(1,MAXIT+1),NDIMA,IROOT,
     &                TMP2,RESID,THRESH)
       ENDIF
C
C FORM ASMALL
C
1      CONTINUE
       CALL XGEMM('N','N',NDIMA,NSPACE,NDIMA,ONE,ALARGE,NDIMA,
     &            VSPACE(1,ICOL),NDIMA,ZILCH,TMP3,NDIMA)
       CALL XGEMM('T','N',NSPACE,NSPACE,NDIMA,ONE,VSPACE(1,ICOL),
     &            NDIMA,TMP3,NDIMA,ZILCH,ASMALL,NSPACE)
C
C DIAGONALIZE ASMALL
C
       CALL EIG(ASMALL,TMP3,NSPACE,NSPACE,0)
C
C OBTAIN NEW EIGENVECTORS AND FIND ONE HAVING BEST OVERLAP 
C WITH PRECEDING APPROXIMATION
C
       XMAX=ZILCH
       IPOS=1
       DO 12 I=1,NSPACE
        CALL XGEMM('N','N',NDIMA,1,NSPACE,ONE,VSPACE(1,ICOL),
     &             NDIMA,TMP3(INDXF(1,I,NSPACE)),NSPACE,ZILCH,
     &             TMP4,NDIMA)
        X=ABS(SDOT(NDIMA,TMP4,1,TMP2,1))
        IF(X.GT.XMAX)THEN
         XMAX=X
         IPOS=I
         CALL DCOPY(NDIMA,TMP4,1,EVEC(1,IROOT+1),1)
        ENDIF
12     CONTINUE
       EVAL=ASMALL(IPOS+(IPOS-1)*NSPACE)
       CALL DCOPY(NDIMA,EVEC(1,IROOT+1),1,TMP2,1)
C
C CALCULATE RESIDUAL [W-E(n)]C AND APPLY DAVIDSON CORRECTION 
C
       CALL XGEMM('N','N',NDIMA,1,NDIMA,ONE,ALARGE,
     &            NDIMA,EVEC(1,IROOT+1),NDIMA,ZILCH,TMP4,NDIMA)
       CALL SAXPY(NDIMA,-EVAL,EVEC(1,IROOT+1),1,TMP4,1)
       IF(NSPACE.NE.1)THEN
        DO 11 I=1,NDIMA
         X=EVAL-ALARGE(I,I)
         TMP4(I)=TMP4(I)/X
11      CONTINUE
       ENDIF
C
C ORTHOGONALIZE RESIDUAL TO EXISTING SPACE
C
       CALL GSCHMIDT(TMP4,VSPACE(1,ICOL),NDIMA,NSPACE+IROOT,
     &               TMP2,RESID,THRESH)
       IF(PRINT)WRITE(6,1002)NSPACE,EVAL,XMAX,RESID
       IF(RESID.GT.TOL)THEN
        NSPACE=NSPACE+1
        ICOL=ICOL-1
        CALL DCOPY(NDIMA,TMP4,1,VSPACE(1,ICOL),1)
        CALL DCOPY(NDIMA,EVEC(1,IROOT+1),1,TMP2,1)
        IF(NSPACE+1.EQ.MAXIT)THEN
         IERR=IERR+1
         WRITE(6,1005)MAXIT
         DOMORE=.FALSE.
        ELSE
         DOMORE=.TRUE.
        ENDIF
       ELSE
        DOMORE=.FALSE.
        IROOT=IROOT+1
        ROOT(IROOT)=EVAL
        IF(PRINT)WRITE(6,1004)NSPACE
        CALL DCOPY(NDIMA,EVEC(1,IROOT),1,VSPACE(1,MAXIT+IROOT),1)
       ENDIF 
C
       IF(DOMORE)GOTO 1
C
5     CONTINUE
      RETURN
1001  FORMAT(T5,'Iteration',T23,'Eigenvalue',T40,'Overlap',
     &       T58,'Residual')
1002  FORMAT(T7,I4,T18,F15.8,T39,F8.6,T52,E15.10)
1003  FORMAT(T3,'Beginning root search ',I5,'.')
1004  FORMAT(T3,'Convergence achieved in ',I5,' iterations.')
1005  FORMAT(T3,'Convergence fails after ',I5,' iterations.')
      END

      SUBROUTINE CONVHESS(A,SCRATCH,HC,HI,AT,ID)
C
C     CONVERTS CARTESIAN HESSIAN TO INTERNAL COORDINATE HESSIAN
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "io_units.par"
#include "fnamelen.par"
#include "flags.h"
#include "jodaflags.com"
C
      CHARACTER*(fnamelen) FNAME
      LOGICAL XYZIN, NWFINDIF
      INTEGER TOTNOFBND, TOTNOFANG, TOTNOFDIH
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
      COMMON /INPTYP/ XYZIN,NWFINDIF
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      DOUBLE PRECISION A(NX,NXM6),HC(NX,NX),HI(NXM6,NXM6)
      DOUBLE PRECISION AT(NXM6,NX),SCRATCH(NX,NXM6)
C
      IF (ID .GT. 0) THEN
         CALL ZERO(HI, NXM6*NXM6)
         IF (XYZIN) THEN
            IF (iFlags2(h_IFLAGS2_geom_opt) .ge. 3) THEN
               CALL GETREC(20, 'JOBARC', 'TNUMOBND', 1, TOTNOFBND)
               CALL GETREC(20, 'JOBARC', 'TNUMOANG', 1, TOTNOFANG)
               CALL GETREC(20, 'JOBARC', 'TNUMODIH', 1, TOTNOFDIH)
               DO IBONDS = 1, TOTNOFBND
                  HI(IBONDS, IBONDS) = 1.0D0
                END DO
                DO IANGS = TOTNOFBND + 1, TOTNOFANG + TOTNOFBND
                   HI(IANGS, IANGS) = 0.25D0
                END DO
                DO IDIHS = TOTNOFBND + TOTNOFANG + 1, TOTNOFANG 
     &                     + TOTNOFBND + TOTNOFDIH
                   HI(IDIHS, IDIHS) = 0.10D0
                END DO
                RETURN
         ELSE IF (iFlags2(h_IFLAGS2_geom_opt) .eq. 2) THEN
                CALL SET_2UNIT_MATRIX(HI, NX)
                RETURN
         ENDIF

        ELSE
            HI(1,1)=1.D0
            HI(2,2)=1.D0
            HI(3,3)=0.25D0
            IF(NXM6.GT.3)THEN
              DO 10 I=4,NXM6-2,3
                 HI(I,I)    =1.D0
                 HI(I+1,I+1)=0.25D0
                 HI(I+2,I+2)=0.1D0
10            CONTINUE
             ENDIF
            RETURN 
        ENDIF
      ENDIF
C
C
C The following block of code is executed only in vibrational
C frequency calculations. The purpose is to bulid a Hessian in
C internal cordinates and write it to the FCMINT file. Note the
C assumption in the transformation: the gradient is zero, hence
C no derivative of B matrix is required. This Hessian can be
C used as a starting Hessian for Transition State searches.
C In the case of frequency calculations with Cartesians let's not do
C any transformations and leave the Hessian in Cartesian
C Coordinates.  Ajith Perera 07/2003.
C
      IF (.NOT.XYZIN) THEN
         CALL MODMATMUL(SCRATCH,HC,A,NX,NX,NXM6,NX,NX,NXM6)
         CALL MTRANSP(A,AT,NX,NXM6,NX,NXM6)
         CALL MODMATMUL(HI,AT,SCRATCH,NXM6,NX,NXM6,NXM6,NX,NXM6)
      END IF
C
C Note that the Cartesian Hessian is already in the JOBARC record
C HESSINAM written by vdint for analytical Hessians and symcor for
C numerical Hessian calculations. Since there can be ordering
C issues (vmol vs ZMAT order) let's write another record. We know
C that this is in ZMAT order. 01/2006, Ajith Perera.
C
      CALL PUTREC(20,'JOBARC','CART_HES',NX*NX*IINTFP,HC)
C
#ifdef _DEBUG_LVL0
      Print*, "Writing Internal or Cartesian Hessian"
      Print*, "XYZIN, NX, NXM6:", XYZIN, NX, NXM6 
      CALL OUTPUT(HC, 1, NX, 1, NX, NX, NX, 1)
#endif     
      IF(ID.EQ.-1)THEN
         CALL GFNAME('FCMINT  ',FNAME,ILENGTH)
         OPEN(UNIT=50,FILE=FNAME(1:ILENGTH),FORM='FORMATTED',
     &        STATUS='UNKNOWN')
         IF (.NOT.XYZIN) THEN
            WRITE(LUOUT,112)
112         FORMAT(T3,'@CONVHESS: the FCMINT is in internals')
            WRITE(50,'((3(E18.12,1X)))')((HI(I,J),J=1,NXM6),I=1,NXM6)
C
C Write the internal Hessian to JOBARC even though
C we have it in the FCMINT file.
C
            CALL PUTREC(20,'JOBARC','INTR_HES',NXM6*NXM6*IINTFP,HI)
         ELSE
            WRITE(LUOUT,113)
113         FORMAT(T3,'@CONVHESS: Write Cartesians FCMINT file')
            WRITE(50,'((3(E18.12,1X)))')((HC(I,J),J=1,NX),I=1,NX)
         ENDIF
          CLOSE(UNIT=50,STATUS='KEEP')
      ENDIF
C
      IF(IPRNT.GE.500)THEN
       WRITE(LUOUT,110)
 110   FORMAT(T3,' @CONVHESS-I, Full Cartesian Hessian: ')
       WRITE(LuOut,90)((I,J,HC(I,J),J=1,I),I=1,NX)
       WRITE(LUOUT,111)
 111   FORMAT(T3,' @CONVHESS-I, Full internal coordinate Hessian: ')
       WRITE(LuOut,90)((I,J,HI(I,J),J=1,I),I=1,NXM6)
 90    FORMAT(3('[',I3,',',I3,']',1X,F9.6,1X),'[',I3,',',I3,']',1X,
     & F9.6)
      ENDIF
C
      RETURN
      END

C SUMS LIST (ISPIN,LIST1) AND (ISPIN,LIST2) AND THEN OVERWRITES
C (ISPIN,LIST2) WITH THE SUM.

      SUBROUTINE SUMLST(ISPIN,LIST1,LIST2,Z,T2,NDSSIZ,NDIS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T2(NDSSIZ),Z(NDSSIZ,NDIS)
      PARAMETER (ONE=1.0D0)

      if (ndis.lt.0) then
         print *, '@SUMLST: Assertion failed.'
         print *, '         ndis = ',ndis
         call errex
      end if

      CALL GETLST(Z,1,NDIS,1,ISPIN,LIST1)
      DO I = 1, NDIS
         CALL GETLST(T2,I,1,1,ISPIN,LIST2)
         CALL SAXPY(NDSSIZ,ONE,Z(1,I),1,T2,1)
         CALL PUTLST(T2,I,1,1,ISPIN,LIST2)
      END DO
      RETURN
      END

      subroutine A2RDZMAT_4GRIDINF(GRID_TYPE, DENSITY_TYPE, SPIN_D,
     &                             NMBR_OF_PERTS, IPICK_PERT, 
     &                             STEP_SIZE, D2RANGE, D3RANGE, 
     &                             XORIGIN, YORIGIN, ZORIGIN)
C
      implicit double precision (a-h,o-z)
      logical ZMAT_PRESENT, SPIN_D
      character*80 wrk
      CHARACTER*2 GRID_TYPE
      CHARACTER*7 DENSITY_TYPE
      
      INQUIRE(FILE='ZMAT',EXIST=ZMAT_PRESENT)
C
      IF (ZMAT_PRESENT)THEN
         OPEN(UNIT=4,FILE='ZMAT',FORM='FORMATTED',STATUS='OLD')
         rewind(4)
      else
         write(6,'(T3,a)')'@RDZMAT_4GRID.f, ZMAT file not present.'
         call errex
      ENDIF
c
300   READ(4,'(A)', END=900) WRK
      IF (WRK(1:9) .NE.'*GRID_INF') goto 300
C
C The density type can be zeroth order, first-order ...Specify
C the density type as 0-ORDER, 1-ORDER. 
 
      READ(4,'(A)', END=900) WRK
      DENSITY_TYPE = WRK(1:7)
      SPIN_D = .FALSE.
      IF (WRK(9:21) .EQ. "SPIN-DENSITY") SPIN_D = .TRUE.
C
C The number of perturbations. 0 for 1-ORDER and 1-ORDER depends
C on the type of pertubation. For example, 3 for dipole moments.

      READ(4,*,END=900) NMBR_OF_PERTS, IPICK_PERT
C
C The gridtype can be two or three dimensional. Specify the 
C grid type as GRID_TYPE={2D, 3D}

      READ(4,'(A)', END=900) WRK
      GRID_TYPE = WRK(1:2)
C
C The step size for the grid and the range (if range is 
C specifies as x, the grid would be generated -x:x).
C       
      READ(4,*,END=900) STEP_SIZE, D2RANGE, D3RANGE
C
C The orgin of the grid
C       
      READ(4,*,END=900) XORIGIN, YORIGIN, ZORIGIN
C
C
      GO TO 99
900   WRITE(6,901)
901   FORMAT(T3,'@RDZMAT_4GRID.f, *GRID_INF namelist not found or', 
     &       ' incomplete.')
      GO TO 999 
 999  CONTINUE
      CLOSE(UNIT=4,STATUS='KEEP')
      CALL ERREX
C
  99  CONTINUE
      CLOSE(UNIT=4,STATUS='KEEP')
      
      RETURN
      END

      SUBROUTINE TOPT1S(ISPIN,ILIST,NTOP,NT1SIZ,NOCC,
     &                  NVRT,NSMSZ,T,TOPT1,
     &                  SYVEC,ITOPT1,I,A,TYPE)
C
C THIS ROUTINE PICKS UP A T1 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT1 AND THEIR ASSOCIATED INDICES
C  IN THE I AND A VECTORS.
C
C INPUT:
C       ISPIN - THE LIST SUBTYPE
C       ILIST - THE LIST NUMBER
C       NTOP  - THE NUMBER OF LARGEST AMPLITUDES (BY ABSOLUTE VALUE)
C               WHICH ARE TO BE FOUND
C       NT1SIZ- THE TOTAL SIZE OF THE T1 VECTOR
C       NOCC  - THE NUMBER OF OCCUPIED ORBITALS OF THIS SPIN TYPE
C       NVRT  - THE NUMBER OF VIRTUAL ORBITALS OF THIS SPIN TYPE
C       NSMSZ - THE TOTAL SIZE OF THE SYMMETRY VECTOR (NOCC*NVRT)
C       SYVEC - THE SYMMETRY VECTOR FOR THE A,I OR a,i LIST
C       TYPE  - ???????????
C
C OUTPUT:
C       TOPT1 - THE NTOP LARGEST ELEMENTS IN THE T1 VECTOR
C               SORTED BY ABSOLUTE VALUE
C       I     - THE I INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       A     - THE A INDICES CORRESPONDING TO THE VALUES IN TOPT1
C
C SCRATCH:
C
C       T     - USED TO HOLD THE SYMMETRY-PACKED T VECTOR
C       ITOPT1- USED TO HOLD THE OFFSETS CORRESPONDING TO THE
C               ELEMENTS IN TOPT1
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A(NTOP),SYVEC(NSMSZ)
      CHARACTER*2 SPCASE(3)
      CHARACTER*1 TYPE
      DIMENSION T(NT1SIZ),TOPT1(NTOP),ITOPT1(NTOP),I(NTOP)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
cjp
#include "bwcc.com"
      DATA SPCASE /'AA','BB','AB'/
C
C THIS ROUTINE PICKS UP A T1 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT1 AND THEIR ASSOCIATED INDICES
C  IN THE I AND A VECTORS.
C
C
C STATEMENT FUNCTIONS
C
      IGETI(IX,NUMA)=1+(IX-1)/NUMA
      IGETA(IX,NUMA)=IX-(IGETI(IX,NUMA)-1)*NUMA
      NNM1O2(IX)=(IX*(IX-1))/2
C
      IF(NT1SIZ.EQ.0)RETURN
C
      CALL GETLST(T,1,1,1,ISPIN,ILIST)
C
C COMPUTE NORM OF T1 VECTOR
C
      X=SNRM2(NT1SIZ,T,1)
      T1NORM=X
C
C PUT NTOP LARGEST ELEMENTS INTO TOPT1 AND THEIR ASSOCIATED INDICES INTO
C   ITOPT1.
C
      CALL SCANVC(T,TOPT1,ITOPT1,NTOP,NT1SIZ)
      DO 10 IRANK=1,NTOP
       IUNPK=SYVEC(ITOPT1(IRANK))
       A(IRANK)=IGETA(IUNPK,NVRT)+NOCCO(ISPIN)
       I(IRANK)=IGETI(IUNPK,NVRT)
10    CONTINUE
cjp
      if(isbwcc) then
        write(*,201)type,SPCASE(ISPIN),iref
        else
      WRITE(*,200)TYPE,SPCASE(ISPIN)
        endif
200   FORMAT(T3,' Largest ',A1,'1 amplitudes for spin case ',A2,':')
201   format(T3,' Largest ',A1,'1 amplitudes for spin case ',A2,
     +   ' of reference no.: ',i3)
      IF(ISPIN.EQ.3)WRITE(*,299)
      WRITE(*,300)
299   FORMAT(3X,3(' ',3X,'_',3X,' ',3X,'_',13X))
300   FORMAT(3X,3('i',3X,' ',3X,'a',3X,' ',13X))
      WRITE(*,400)
400   FORMAT(77('-'))
      if(isbwcc) then
      if(bwgossip) then
        write(*,501) (irank,i(irank),a(irank),
     &         invhnum(i(irank),iref,ispin),
     &        invpnum(a(irank)-nocco(ispin),iref,ispin),
     &         topt1(irank),irank=1,ntop)
        else
         write(*,500)(invhnum(i(irank),iref,ispin),
     &      invpnum(a(irank)-nocco(ispin),iref,ispin),
     &              topt1(irank),irank=1,ntop)
        endif
      else
      WRITE(*,500)(I(IRANK),A(IRANK),
     &                 TOPT1(IRANK),IRANK=1,NTOP)
      endif
      WRITE(*,400)
      WRITE(*,600)TYPE,SPCASE(ISPIN),NT1SIZ,T1NORM
      WRITE(*,400)
600   FORMAT(T3,' Norm of ',A1,'1',A2,' vector (',I9,
     &        ' symmetry allowed elements):',F14.10,'.')
500   FORMAT((2('[',I3,1X,3X,1X,I3,1X,3X,']',F8.5,1X),'[',I3,1X,
     &3X,1X,I3,1X,3X,']',F8.5))
cjp
501    format(i4,':',i4,1x,i4,':true indices:',i4,1x,i4,' : ',f12.8)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine return_diagonal4(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c The diagonal elements of a four index array are extracted. 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      if (nindex .eq. 4) then
         call ret_diag4(x, bval(1),eval(1),type(1),
     *                   bval(2),eval(2),type(2),
     *                   bval(3),eval(3),type(3),
     *                   bval(4),eval(4),type(4), 
     *                   epsilon,epsilonb)
      elseif (nindex .eq. 2) then
         call lret_diag2(x, bval(1),eval(1),type(1),
     *                   bval(2),eval(2),type(2),
     *                   epsilon,epsilonb)
      else
         print *,'Error in return_diagonal_4: Result array ',
     *      'must have 2 or 4 indices.'
         print *,'array has ',nindex,' indices.'
         call abort_job()
      endif
      
      return
      end

      subroutine ret_diag4(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision val

      do j = j1,j2
      do b = b1,b2
         do i = i1, i2
         do a = a1,a2
            val = 0.0d0 
            if ((atype .eq. itype) .and. (i .eq. a) .and. 
     *          (btype .eq. jtype) .and. (j .eq. b)) then  
               val =  x(a,i,b,j)
            else 
               val = 0.0d0 
            endif 
            x(a,i,b,j) = val 
         enddo
         enddo
      enddo
      enddo

      return
      end

      subroutine lret_diag2(x, a1,a2,atype,i1,i2,itype,
     *                      epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision val

      do i = i1, i2
      do a = a1 ,a2
         val = 0.0d0 
         if ((atype .eq. itype) .and. (i .eq. a)) then 
            val =  x(a,i)
         else 
            val = 0.0d0 
         endif 
         x(a,i) = val 
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_SQROOT_OVERLAP
     +
     +                    ( NBAS,
     +                      XVEC,XMAT,
     +
     +                              S )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_SQROOT_OVERLAP
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine generates the S**(1/2) matrix and
C                overwrites the original overlap matrix S.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    S            =  full NBAS x NBAS overlap matrix.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C
C
C                  Output:
C
C                    S            =  full NBAS x NBAS S**(1/2) matrix.
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     REVERS

         INTEGER     I,J,N
         INTEGER     NBAS

         DOUBLE PRECISION  LDEPEND
         DOUBLE PRECISION  X,Y

         DOUBLE PRECISION  XVEC (1:NBAS)

         DOUBLE PRECISION  S    (1:NBAS,1:NBAS)
         DOUBLE PRECISION  XMAT (1:NBAS,1:NBAS)

         DATA  REVERS   /.TRUE./
         DATA  LDEPEND  /1.D-12/
C
C
C------------------------------------------------------------------------
C
C
C             ...generate the S**(1/2) matrix and overwrite original
C                matrix S.
C
C
         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                S,
     +
     +                        XMAT )
     +
     +
         CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
     +
     +              ( NBAS,NBAS,NBAS,
     +                NBAS,
     +                REVERS,
     +
     +                        XVEC,
     +                        XMAT )
     +
     +
         CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +
     +                        S )
     +
     +
         DO 100 N = 1,NBAS

            X = XVEC (N)
            IF (X.LT.LDEPEND) THEN
                WRITE (*,*) ' Overlap matrix is linear dependent! '
                WRITE (*,*) ' nlo__gener_sqroot_overlap '
                WRITE (*,*) ' X,LDEPEND = ',X,LDEPEND
                WRITE (1,*) ' Overlap matrix is linear dependent! '
                WRITE (1,*) ' nlo__gener_sqroot_overlap '
                WRITE (1,*) ' X,LDEPEND = ',X,LDEPEND
                STOP
            END IF

            X = DSQRT (X)
            DO 110 J = 1,NBAS
               Y = X * XMAT (J,N)
               DO 120 I = 1,NBAS
                  S (I,J) = S (I,J) + Y * XMAT (I,N)
  120          CONTINUE
  110       CONTINUE

  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      Subroutine Ln_interpol(Coord_K1P, Coord_K1CM, Coord_K1C, 
     &                       Coord_PV, Grad_on_K1P, Grad_on_K1C, 
     &                       Vec_K1P, Vec_K1C, Grad_K1PM, 
     &                       Grad_K1CM, Grad_K1C, Vec_K1C_K1P, 
     &                       Vec_K1Int, Grad_K1Int, AtmMass, 
     &                       Nreals, Ln_Intrp_Tol)

      Implicit Double Precision (A-H, O-Z)
C    
      Double Precision Ln_intrp_Tol, K1P_K1C_Norm, Pang_K1C_K1P
C
      Dimension Coord_K1P(3*Nreals), Coord_K1CM(3*Nreals), 
     &          Grad_on_K1P(3*Nreals), Grad_on_K1C(3*Nreals),
     &          Vec_K1P(3*Nreals), Vec_K1C(3*Nreals),
     &          Vec_K1C_K1P(3*Nreals), Vec_K1Int(3*Nreals),
     &          Grad_K1Int(3*Nreals), Coord_PV(3*Nreals),
     &          Grad_K1CM(3*Nreals), Grad_K1C(3*Nreals),
     &          Grad_K1PM(3*Nreals), Coord_K1C(3*Nreals), 
     &          AtmMass(Nreals)
C

      Write(6,*)
      Write(6,"(a,a)") "@-Ln_interpol M.W. prev., ",
     &                  "current point, N.M.W. current point"
      Write(6,"(a)")  "The prv. point"
      Write(6, "(3F17.13)") (Coord_K1P(i),i=1,3*Nreals)
      Write(6,"(a)")  "The curr. point"
      Write(6, "(3F17.13)") (Coord_K1CM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The curr. point (no. mass weight)"
      Write(6, "(3F17.13)") (Coord_K1C(i),i=1,3*Nreals)
      Write(6,"(a)")  "The M.W. pivot point"
      Write(6, "(3F17.13)") (Coord_PV(i),i=1,3*Nreals)
      Write(6,*) 
      Write(6, "(a,a)") "@-Ln_interpol M.W. grad and vec on, ",
     &                  "K1 vector"
      Write(6,"(a)")  "The Grad_on_K1P"
      Write(6, "(3F17.13)") (Grad_on_K1P(i),i=1,3*Nreals)
      Write(6,"(a)")  "Grad_on_K1C"
      Write(6, "(3F17.13)") (Grad_on_K1C(i),i=1,3*Nreals)
      Write(6,*) 
      Write(6, "(a,a)") "@-Ln_interpol M.W. prv. and curr. grad "
      Write(6,"(a)")  "The M.W previous gradient"
      Write(6, "(3F17.13)") (Grad_K1PM(i),i=1,3*Nreals)
      Write(6,"(a)")  "The M.W current gradient"
      Write(6, "(3F17.13)") (Grad_K1CM(i),i=1,3*Nreals)

C
      Do Iatom = 1, Nreals
         Ioff = 1 + 3*(Iatom - 1)
         Call Vec(Coord_PV(Ioff), Coord_K1CM(Ioff), Vec_K1C(Ioff), 0)
         Call Vec(Coord_PV(Ioff), Coord_K1P(Ioff), Vec_K1P(Ioff), 0)
      Enddo
C
      Vec_K1C_Norm  = Ddot(3*Nreals, Vec_K1C, 1, Vec_K1C, 1)
      Vec_K1P_Norm  = Ddot(3*Nreals, Vec_K1P, 1, Vec_K1P, 1)
      K1P_K1C_Norm  = Ddot(3*Nreals, Vec_K1P, 1, Vec_K1C, 1)
C
      Pang_K1C_K1P = (K1P_K1C_Norm/(Dsqrt(Vec_K1C_Norm)*
     &                              Dsqrt(Vec_K1P_Norm)))
      If (Abs(Pang_K1C_K1P) .Gt. 1.0D0) Pang_K1C_K1P = Pang_K1C_K1P/
     &                                             Abs(Pang_K1C_K1P)
      PAng_K1C_K1P = DAcos(Pang_K1C_K1P)
      Theta_prime  = PAng_K1C_K1P

C

      Write(6,*)
      Write(6,"(a)") "The norms of the vectors for theta prime"
      write(6,"(3F17.13)") dsqrt(Vec_K1P_Norm), (K1P_K1C_Norm),
     &                    dsqrt(Vec_K1C_Norm )
      Write(6,*)
      Write(6,"(a,F17.13)") "The Theta_prime", Theta_prime

C
      Do Iatom = 1, Nreals
         Ioff = 1 + 3*(Iatom - 1)
         Call Vec(Vec_K1P(Ioff),  Vec_K1C(Ioff),  Vec_K1C_K1P(Ioff),
     &            0)
      Enddo

      G1_prime = Ddot(3*Nreals, Vec_K1C_K1P, 1, Grad_on_K1C, 1)
      G2_Prime = Ddot(3*Nreals, Vec_K1C_K1P, 1, Grad_on_K1P, 1)


      Write(6,*)
      Write(6,"(a)") "The norms of the vectors for theta "
      write(6,"(2F17.13)") G1_prime, G2_Prime

C
      Theta = Theta_prime*G2_prime/(G2_Prime - G1_Prime)

      Write(6,*)
      Write(6,"(a, F17.13)") "The theta", theta

C
      If (Theta .LT. 0.0D0 .AND. Theta_prime .LT. Ln_Intrp_Tol) Then
         Write(6, "(a)") "@-Ln_interpol, Interpolation is invlaid"
         Return
      Endif

      If (DAbs(Theta) .GT. Ln_Intrp_Tol .AND. DAbs(Theta_Prime 
     &    - Theta) .GT. Ln_Intrp_Tol) Then
         Write(6, "(a)") "@-Ln_interpol, Interpolation is invlaid"
         Return
      Endif
C
      Ratio_1 = Theta/Theta_prime
      Ratio_2 = Sin(Theta)/Sin(Theta_prime)
      Ratio_3 = Cos(Theta) - Sin(Theta)*Cos(Theta_prime)/
     &                                  Sin(Theta_prime)
C
      Do Ideg = 1, Nreals
         Ioff = 3*(Ideg - 1) 
         Do Ixyz = 1, 3 
            Ioff = Ioff + 1 
            Vec_K1Int(Ioff)  = Ratio_2*Vec_K1C(Ioff) + Ratio_3*
     &                         Vec_K1P(Ioff)
            Grad_K1Int(Ioff) = Ratio_1*Grad_K1CM(Ioff) + (1.0D0 - 
     &                         Ratio_1)*Grad_K1PM(Ioff)
         Enddo
      Enddo 

      Write(6,*)
      Write(6,"(a)") "@-ln_interpol, geo. and gradient updates"
      Write(6,"(a)")  "The M.W. geo. update"
      Write(6, "(3F17.13)") (Vec_K1int(i),i=1,3*Nreals)
      Write(6,"(a)")  "The M.W. gradient update" 
      Write(6, "(3F17.13)") (Grad_K1int(i),i=1,3*Nreals)
      Write(6,*) 

C
      Call Daxpy(3*Nreals, 1.0D0, Coord_PV, 1, Vec_K1Int, 1)
      Call Dcopy(3*Nreals, Vec_K1Int, 1, Coord_K1CM, 1)
      Call Dcopy(3*Nreals, Grad_K1Int, 1, Grad_K1CM, 1)
C
      Ioff = 0
      Do Iatom = 1, Nreals
         Do Ixyz = 1, 3
           Ioff = Ioff + 1
            Grad_K1Int(Ioff) = Grad_K1Int(Ioff)*
     &                         Dsqrt(AtmMass(Iatom))
            Vec_K1Int(Ioff)  = Vec_K1Int(Ioff)/
     &                         Dsqrt(AtmMass(Iatom))
         Enddo
      Enddo
C
      Call Dcopy(3*Nreals, Vec_K1Int, 1, Coord_K1C, 1)
      Call Dcopy(3*Nreals, Grad_K1Int, 1, Grad_K1C, 1)
      
      Return
      End
       

C SUBROUTINE COMPUTES OUTER PRODUCT OF VECTOR V WITH ITSELF.  IF
C ICOMP IS SET TO ONE, 1-|V><V| IS RETURNED; OTHERWISE IT IS JUST
C |V><V|.

      SUBROUTINE OUTERP(VV,V,NR,NC,ICOMP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION V(NR,NC),VV(NR,NR)
      DO I = 1, NR
         DO J = 1, NR
            T = 0.D0
            DO K = 1, NC
               T = T + V(I,K) * V(J,K)
            END DO
            VV(I,J) = T
         END DO
      END DO
      IF (ICOMP.EQ.0) RETURN
      Z = -1.D0
      CALL xscal(NR*NR,Z,VV,1)
      DO I = 1, NR
         VV(I,I) = 1.D0 + VV(I,I)
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__PRINT_NHO_SEARCH_INFO
     +
     +                    ( STAGE,
     +                      BONDSIZE,
     +                      MAXOCC,
     +                      NHCEN,
     +                      NWSTEP,
     +                      WMAX,WMIN,WSTEP,
     +                      WBOND,WSTAR )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__PRINT_NHO_SEARCH_INFO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine prints information related to the NHO
C                generation process, depending on the generation stage.
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*1    DASH
         CHARACTER*(*)  STAGE

         INTEGER     BONDSIZE
         INTEGER     NHCEN
         INTEGER     NSTEP
         INTEGER     SIZE

         INTEGER     NWSTEP (1:BONDSIZE)

         DOUBLE PRECISION  MAXOCC
         DOUBLE PRECISION  WBMAX,WBMIN,WSMAX,WSMIN
         DOUBLE PRECISION  WMAX,WMIN
         DOUBLE PRECISION  WSTEP
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  WBOND (1:BONDSIZE)
         DOUBLE PRECISION  WSTAR (1:BONDSIZE)

         DATA  DASH  /'-'/
         DATA  ZERO  /0.D0/
C
C
C------------------------------------------------------------------------
C
C
C             ...print out info according to stage.
C
C
         IF (STAGE.EQ.'start') THEN

             WRITE (*,9100) ' --- Starting NHO search --- '
             WRITE (1,9100) ' --- Starting NHO search --- '

             WRITE (*,9110) '# cen','wbond range','wstar range'
             WRITE (1,9110) '# cen','wbond range','wstar range'

             DO 10 SIZE = 1,BONDSIZE
                NSTEP = NWSTEP (SIZE)
                WBMAX = MAXOCC
                WBMIN = WMAX - (NSTEP-1)*WSTEP
                WSMAX = WMIN + (NSTEP-1)*WSTEP
                WSMIN = ZERO
                WRITE (*,9120) SIZE,WBMIN,DASH,WBMAX,WSMAX,DASH,WSMIN
                WRITE (1,9120) SIZE,WBMIN,DASH,WBMAX,WSMAX,DASH,WSMIN
   10        CONTINUE

         ELSE IF (STAGE.EQ.'failure') THEN

             WRITE (*,9200) ' Failure at bondsize = ',NHCEN
             WRITE (1,9200) ' Failure at bondsize = ',NHCEN

         ELSE IF (STAGE.EQ.'complete') THEN

             WRITE (*,9300) ' Trying to complete NHO space ... '
             WRITE (1,9300) ' Trying to complete NHO space ... '

         ELSE IF (STAGE.EQ.'failure complete') THEN

             WRITE (*,9400) ' Failure completing NHO space! '
             WRITE (1,9400) ' Failure completing NHO space! '

         ELSE IF (STAGE.EQ.'more') THEN

             WRITE (*,9500) ' Searching for remaining NHOs ... '
             WRITE (1,9500) ' Searching for remaining NHOs ... '

             WRITE (*,9510) '# cen','wbond range','wstar range'
             WRITE (1,9510) '# cen','wbond range','wstar range'

             DO 50 SIZE = 1,BONDSIZE
                WBMAX = WBOND (SIZE)
                WBMIN = WBOND (SIZE) - WSTEP
                WSMAX = WSTAR (SIZE) + WSTEP
                WSMIN = WSTAR (SIZE)
                WRITE (*,9520) SIZE,WBMIN,DASH,WBMAX,WSMAX,DASH,WSMIN
                WRITE (1,9520) SIZE,WBMIN,DASH,WBMAX,WSMAX,DASH,WSMIN
   50        CONTINUE

         ELSE IF (STAGE.EQ.'success') THEN

             WRITE (*,9600) ' NHO space generation successful ! '
             WRITE (1,9600) ' NHO space generation successful ! '
             WRITE (*,9610) ' ----- Final weight limits ----- '
             WRITE (1,9610) ' ----- Final weight limits ----- '

             WRITE (*,9620) '# cen','wbond range','wstar range'
             WRITE (1,9620) '# cen','wbond range','wstar range'

             DO 60 SIZE = 1,BONDSIZE
                WBMAX = MAXOCC
                WBMIN = WBOND (SIZE)
                WSMAX = WSTAR (SIZE)
                WSMIN = ZERO
                WRITE (*,9630) SIZE,WBMIN,DASH,WBMAX,WSMAX,DASH,WSMIN
                WRITE (1,9630) SIZE,WBMIN,DASH,WBMAX,WSMAX,DASH,WSMIN
   60        CONTINUE

         END IF
C
C
C             ...formats used.
C
C
 9100    FORMAT (A29)
 9110    FORMAT (1X,A5,1X, 2(1X,A11,1X))
 9120    FORMAT (2X,I2,3X, 2(1X,F4.2,1X,A1,1X,F4.2,1X))

 9200    FORMAT (A23,I3)
 9300    FORMAT (A34)
 9400    FORMAT (A31)

 9500    FORMAT (A34)
 9510    FORMAT (1X,A5,1X, 2(1X,A11,1X))
 9520    FORMAT (2X,I2,3X, 2(1X,F4.2,1X,A1,1X,F4.2,1X))

 9600    FORMAT (A35)
 9610    FORMAT (A33)
 9620    FORMAT (1X,A5,1X, 2(1X,A11,1X))
 9630    FORMAT (2X,I2,3X, 2(1X,F4.2,1X,A1,1X,F4.2,1X))
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine ecp_dercont(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Performs the contraction of derivative 1-electron integrals in the AO
c   domain with an intermediate term derived from the back-transformed
c   gamma matrix. The contraction is performed on an atom-by-atom basis
c   and summed into the appropriate component of the gradient array.
c
c   hcont1 must be executed with the following syntax:
c   execute hcont1 i(mu,nu)
c
c   The block i(mu,nu) is the intermediate term which is 
c   to be contracted with the "S" derivative integrals for its 
c   block of (mu,nu) across all the atoms in the molecule.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      integer array, nind, ind(mx_array_index), seg(mx_array_index)
      integer a1, a2, b1, b2
      integer i, j, m, n
      integer shandle, iatom
      integer*8 iscr, indblk
      integer find_current_block
      integer*8 get_block_data_index
      integer*8 iarray, get_index_from_base 
      integer block, blkndx, stack
      integer igrad, component
      integer allocate_scratch_block, ierr
      integer array_type, nindex 

      double precision dummy, y
      integer flopcount
      integer*8 arg64(10)
      logical*8 l8false

      common /flags/ iflags
      integer iflags(100)

#ifdef ALTIX
      dptr = dshptr
#endif


      if (compute_1e_integrals) then
         compute_1e_integrals = .false.

         if (me .eq. 0) then

c--------------------------------------------------------------------------
c   Sum the nuclear-nuclear repulsion term into the gradient.
c--------------------------------------------------------------------------

            iatom = 0
            j     = 0
            do i = 1, 3*ncenters
               j = j + 1
               if (j .gt. 3) j = 1
               if (j .eq. 1) iatom = iatom + 1
               gradient_data(i) = gradient_data(i) + 
     *                            NNgrad(j,iatom)
            enddo

            if (dbg) then
               print *,'ecp_dercont on Task 0: Summed NNgrad into 
     *                  Gradient'
               do i = 1, 3*ncenters
                  print *,'Gradient i: ',i,gradient_data(i)
               enddo
            endif
         endif
      endif

      if (iflags(71) .ne. 1) return 

c--------------------------------------------------------------------------
c   Find the ranges of the AO indices of the input block.
c--------------------------------------------------------------------------

      array = op(c_result_array)

      array_type = array_table(c_array_type, array)
      if (array_type .ne. static_array) then 
         print *,'Error: array in ecp_dercont routine must be static.'
         call abort_job()
      endif

      nindex = array_table(c_nindex, array) 
   
      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo 

      iarray = get_index_from_base(address_table(array), x, 2)
      n = index_table(c_index_size, ind(1))  ! pick up length of index 

c---------------------------------------------------------------------------
c   Perform contraction of the data block with the integrals.
c---------------------------------------------------------------------------

      call contract_ecp_derv_integrals(x(iarray), 
     *               1, n, 1, n)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_PRE_NAO_ORBITALS
     +
     +                    ( NBAS,NATOM,
     +                      MXSHELL,MXNAL,
     +                      NSHELLS,SHELLS,NBASAL,
     +                      LSIZE,
     +                      BASBEG,BASEND,
     +                      SYMMAP,
     +                      ATDONE,IDXSYM,
     +                      P,S,
     +                      SAL,CAL,WAL,
     +                      SETWRYD,
     +                      WPRERYD,WRYDAT,
     +                      MJUMP,
     +
     +                              NMB,NRB,
     +                              COLMAP,
     +                              NRYDAL,
     +                              W,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_PRE_NAO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine forms all the pre-NAO's by diagonalizing
C                the systems of equations P(AL)C(AL) = S(AL)C(AL)W(AL)
C                for all (AL) spaces. Analyze the symmetry average
C                weights W(AL) and decompose the pre-NAO space into
C                the minimal and Rydberg pre-NAO spaces. All atoms
C                related by symmetry are treated at the same time, thus
C                ensuring the same C(AL) coefficients.
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    MXSHELL      =  largest l-shell value
C                    MXNAL        =  maximum size of atomic l-shell
C                                    space. The atomic l-shell space
C                                    is the total # of contractions for
C                                    an atomic l-shell.
C                    NSHELLS (A)  =  # of l-shells for atom A.
C                    SHELLS (I,A) =  I-th l-shell type (s=0,p=1,etc...)
C                                    for atom A (in increasing order!).
C                    NBASAL (I,A) =  size of I-th atomic l-shell space
C                                    for atom A.
C                    LSIZE (I)    =  I-th l-shell size
C                    BASBEG (A)   =  first basis index number for atom A
C                    BASEND (A)   =  last basis index number for atom A
C                    SYMMAP (A,B) =  has been set equal to 1 if atoms
C                                    A and B were found to be symmetry
C                                    related at the present stage of
C                                    calculation. A value of 0 indicates
C                                    no symmetry relation up to now.
C                    ATDONE (A)   =  will be used as an indicator if
C                                    atom A has been checked for
C                                    symmetry or not.
C                    IDXSYM       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    S            =  full NBAS x NBAS overlap matrix.
C                    SAL,CAL,WAL  =  submatrices S(AL) and C(AL) for
C                                    overlap and density/pre-NAO coeffs
C                                    and subvector W(AL) for weights.
C                    SETWRYD      =  is true, if the Rydberg pre-NAO
C                                    weight threshold has to be set to
C                                    the initial value of WPRERYD.
C                    WPRERYD      =  the initial Rydberg pre-NAO weight
C                                    threshold. This is the initial
C                                    Rydberg weight criterion for
C                                    pre-NAO construction.
C                    WRYDAT (A)   =  the pre-NAO weight threshold below
C                                    which a pre-NAO will be considered
C                                    of Rydberg type for atom A. If
C                                    SETWRYD is true, then we reset
C                                    these values to the initial value
C                                    WPRERYD for all atoms. If SETWRYD
C                                    is false at this stage, we will
C                                    take the current values as have
C                                    been transmitted in argument.
C                    MJUMP        =  is .true., if the m values in the
C                                    m-space are ordered such that the
C                                    same m values are separated. This
C                                    keyword is necessary because some
C                                    AO basis functions are m-ordered
C                                    differently within each l-shell.
C                                    It invokes different types of
C                                    m-averaging algorithms.
C
C
C                  Output:
C
C                    NMB,NRB      =  # of minimal and Rydberg pre-NAO's
C                                    found.
C                    COLMAP (I)   =  column map in the active sense,
C                                    such that COLMAP (I) contains the
C                                    position index of I-th pre-NAO,
C                                    based on atomic clustering, in the
C                                    final NMB and NRB bundled pre-NAO
C                                    coefficient array C.
C                    NRYDAL (I,A) =  # of Rydberg pre-NAO's found for
C                                    the I-th atomic l-shell for atom A.
C                                    Needed later on for updating the
C                                    Rydberg pre-NAO's when generating
C                                    the final NAO's.
C                    W            =  pre-NAO weight vector.
C                    C            =  pre-NAO coefficient matrix in AO
C                                    basis.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ADD
         LOGICAL     LTRG
         LOGICAL     MJUMP
         LOGICAL     NEW
         LOGICAL     REVERS
         LOGICAL     SETWRYD
         LOGICAL     ZEROC

         INTEGER     A,B
         INTEGER     ATOM
         INTEGER     BASB,BASL,BASNR
         INTEGER     INDEX
         INTEGER     I,J,L,N
         INTEGER     LDIM,LTOT,LTYPE
         INTEGER     MXSHELL,MXNAL
         INTEGER     NBAS,NATOM
         INTEGER     NAL
         INTEGER     NLTYPE
         INTEGER     NMB,NRB,NRBOLD
         INTEGER     NSYM

         INTEGER     ATDONE  (1:NATOM  )
         INTEGER     BASBEG  (1:NATOM  )
         INTEGER     BASEND  (1:NATOM  )
         INTEGER     COLMAP  (1:NBAS   )
         INTEGER     IDXSYM  (1:NATOM  )
         INTEGER     LSIZE   (0:MXSHELL)
         INTEGER     NSHELLS (1:NATOM  )

         INTEGER     NBASAL  (1:MXSHELL+1,1:NATOM)
         INTEGER     NRYDAL  (1:MXSHELL+1,1:NATOM)
         INTEGER     SHELLS  (1:MXSHELL+1,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM    ,1:NATOM)

         DOUBLE PRECISION  WEIGHT,WTHRSH
         DOUBLE PRECISION  WPRERYD
         DOUBLE PRECISION  X
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  W      (1:NBAS )
         DOUBLE PRECISION  WAL    (1:MXNAL)
         DOUBLE PRECISION  WRYDAT (1:NATOM)

         DOUBLE PRECISION  C   (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  S   (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  P   (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  CAL (1:MXNAL,1:MXNAL)
         DOUBLE PRECISION  SAL (1:MXNAL,1:MXNAL)

         PARAMETER    (ZERO    =  0.D0 )
         PARAMETER    (ONE     =  1.D0 )
         PARAMETER    (REVERS  = .TRUE.)
C
C
C------------------------------------------------------------------------
C
C
C             ...set initial data.
C
C
         LTRG  = .TRUE.
         ZEROC = .FALSE.

         DO A = 1,NATOM
            ATDONE (A) = 0
         END DO

         IF (SETWRYD) THEN
             DO A = 1,NATOM
                WRYDAT (A) = WPRERYD
             END DO
         END IF
C
C
C             ...outer loop over all atoms. For each atom, find its
C                group of symmetry equivalent atoms and process these
C                at the same time.
C
C
         DO A = 1,NATOM
            NEW = ATDONE (A) .EQ. 0
            IF (NEW) THEN

                NSYM = 0
                DO B = 1,NATOM
                   IF (SYMMAP (B,A) .EQ. 1) THEN
                       NSYM = NSYM + 1
                       IDXSYM (NSYM) = B
                       ATDONE (B) = 1
                   END IF
                END DO

                BASL = 0
                ATOM = IDXSYM (1)
                NLTYPE = NSHELLS (ATOM)
C
C
C
C             ...inner loop over all l-shell types for one of the
C                symmetry equivalent atoms (they must posses the same
C                angular momentum basis, otherwise they are not per
C                definition symmetry equivalent). The following steps
C                are performed for all atoms in the symmetry equivalent
C                group:
C
C                      i) for each atom calculate the m-symmetry
C                         averaged P(AL) and S(AL) matrices.
C
C                     ii) sum all P(AL) and S(AL) matrices up and
C                         form the group symmetry averaged matrices.
C
C                    iii) solve the generalized eigenvalue problem for
C                         the resulting m-symmetry and group-symmetry
C                         averaged P(AL) and S(AL) matrices.
C
C
C
                DO N = 1,NLTYPE
                   NAL = NBASAL (N,ATOM)
                   LTYPE = SHELLS (N,ATOM)
                   LDIM = LSIZE (LTYPE)
                   LTOT = NAL * LDIM

                   DO I = 1,NSYM
                      B = IDXSYM (I)
                      BASB = BASBEG (B) - 1
                      BASNR = BASB + BASL
                      ADD = I.GT.1

                      CALL  NLO__FORM_M_AVERAGED_MATRIX
     +
     +                           ( NBAS,LTOT,
     +                             MXNAL,MXNAL,
     +                             LTOT,LDIM,
     +                             BASNR,
     +                             MJUMP,LTRG,ADD,
     +                             P (1,BASNR+1),
     +
     +                                     CAL )
     +
     +
                      CALL  NLO__FORM_M_AVERAGED_MATRIX
     +
     +                           ( NBAS,LTOT,
     +                             MXNAL,MXNAL,
     +                             LTOT,LDIM,
     +                             BASNR,
     +                             MJUMP,LTRG,ADD,
     +                             S (1,BASNR+1),
     +
     +                                     SAL )
     +
     +
                   END DO

                   IF (NSYM.GT.1) THEN
                       X = ONE / DFLOAT (NSYM)
                       DO J = 1,NAL
                       DO I = J,NAL
                          CAL (I,J) = X * CAL (I,J)
                          SAL (I,J) = X * SAL (I,J)
                       END DO
                       END DO
                   END IF

                   CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                        ( 6,
     +                          ' (averaged) CAL matrix (pre-NAO) ',
     +                          MXNAL,MXNAL,
     +                          NAL,0,
     +                          CAL )
     +
     +
                   CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                        ( 6,
     +                          ' (averaged) SAL matrix (pre-NAO) ',
     +                          MXNAL,MXNAL,
     +                          NAL,0,
     +                          SAL )
     +
     +
                   CALL  MAT__GEN_EIGSYS_REAL_SYMMETRIC
     +
     +                        ( MXNAL,MXNAL,
     +                          MXNAL,MXNAL,
     +                          MXNAL,
     +                          NAL,
     +                          REVERS,
     +
     +                                  WAL,
     +                                  SAL,
     +                                  CAL )
     +
     +
                   CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                        ( 6,
     +                          ' CAL eigenvalues (pre-NAO) ',
     +                          MXNAL,1,
     +                          NAL,1,
     +                          WAL )
     +
     +
                   CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                        ( 6,
     +                          ' CAL eigenvectors (pre-NAO) ',
     +                          MXNAL,MXNAL,
     +                          NAL,NAL,
     +                          CAL )
     +
     +
C
C
C             ...for the present group of symmetry equivalent atoms
C                generate the pre-NAO coefficients in the AO basis
C                together with the corresponding average weights.
C
C
                   DO I = 1,NSYM
                      B = IDXSYM (I)
                      BASB = BASBEG (B) - 1
                      BASNR = BASB + BASL

                      CALL  MAT__W_EQ_ZERO_FLOAT
     +
     +                           ( LTOT*NBAS,
     +                             LTOT*NBAS,
     +
     +                                     C (1,BASNR+1) )
     +
     +
                      CALL  NLO__FORM_M_EXPANDED_MATRIX
     +
     +                           ( MXNAL,MXNAL,
     +                             NBAS,LTOT,
     +                             NAL,LTOT,
     +                             BASNR,
     +                             MJUMP,.FALSE.,ZEROC,
     +                             CAL,
     +
     +                                     C (1,BASNR+1) )
     +
     +
                      CALL  NLO__FORM_M_EXPANDED_WEIGHTS
     +
     +                           ( MXNAL,
     +                             LTOT,
     +                             LTOT,NAL,
     +                             MJUMP,
     +                             WAL,
     +
     +                                     W (BASNR+1) )
     +
     +
                   END DO
C
C
C             ...next shell type for present symmetry equivalent
C                group of atoms.
C
C
                   BASL = BASL + LTOT

                END DO
            END IF
C
C
C             ...next symmetry equivalent group of atoms.
C
C
         END DO
C
C
C
C             ...the complete pre-NAO coefficient matrix and weight
C                vector are ready in atomic order. For all atoms
C                determine now the decomposition into minimal and
C                Rydberg spaces.
C
C                The decomposition into minimal and Rydberg spaces
C                for each atom A is governed by the critical value
C                WRYDAT (A), which has the following meaning:
C
C                          weight  >  WRYDAT (A)    minimal
C                          weight =<  WRYDAT (A)    Rydberg
C
C                As we move along, determining each atomic section of
C                the pre-NAO coefficients, we also need to keep track
C                of which column indices will belong to the NMB and
C                NRB spaces. A column map COLMAP is established, which
C                will contain the mapping of the columns from the
C                original atomic structure to the new NMB and NRB
C                clustered structure in the active sense. Pictorially,
C                this means a columnwise restructuring of the pre-NAO
C                coefficient matrix:
C
C
C                 at 1    at 2   ...             NMB          NRB
C               --------------------         ------------------------
C              |   |   |   |   | ...        |   |   |... |   |   |...
C              |   |   |   |   | ...        |   |   |... |   |   |...
C              | N | N | N | N | ...        | a | a |... | a | a |...
C              | M | R | M | R | ...    ->  | t | t |... | t | t |...
C              | B | B | B | B | ...        | 1 | 2 |... | 1 | 2 |...
C              |   |   |   |   | ...        |   |   |... |   |   |...
C              |   |   |   |   | ...        |   |   |... |   |   |...
C
C
C
C                The active column map has the following info:
C
C                  COLMAP (atomic based index) = NMB/NRB based index
C
C                Note, that while it is easy to determine the NMB
C                index, the NRB index has to be determined after the
C                we know the size of the NMB space. Hence the initial
C                COLMAP values for the NRB space must be protected
C                from identification at a later stage, which is easy
C                to do by adding the constant NBAS, since the maximum
C                value that NMB can take is NBAS.
C
C                The whole idea behind creating the column map is the
C                fact that the NMB and NRB spaces will be manipulated
C                separately, hence for efficiency reasons in handling
C                matrix operations on these spaces we will temporarily
C                bundle each kind together in later routines.
C
C
C
         NMB = 0
         NRB = 0
         BASNR = 0

         DO ATOM = 1,NATOM
            NLTYPE = NSHELLS (ATOM)
            WTHRSH = WRYDAT (ATOM)

            DO N = 1,NLTYPE
               NAL = NBASAL (N,ATOM)
               LTYPE = SHELLS (N,ATOM)
               LDIM = LSIZE (LTYPE)
               LTOT = NAL * LDIM

               NRBOLD = NRB

               DO L = 1,LTOT
                  BASNR = BASNR + 1
                  WEIGHT = W (BASNR)
                  IF (WEIGHT.GT.WTHRSH) THEN
                      NMB = NMB + 1
                      COLMAP (BASNR) = NMB
                  ELSE
                      NRB = NRB + 1
                      COLMAP (BASNR) = NRB + NBAS
                  END IF
               END DO

               NRYDAL (N,ATOM) = NRB - NRBOLD

            END DO
         END DO

C         CALL  MAT__PRINT_A_INTEGER_NOZEROS
C     +
C     +              ( 6,
C     +                ' NRYDAL matrix ',
C     +                MXSHELL+1,NATOM,
C     +                MXSHELL+1,NATOM,
C     +                NRYDAL )
C     +
C
C
C             ...remove protection value and update the NRB section of
C                the column map.
C
C
         DO I = 1,NBAS
            INDEX = COLMAP (I)
            IF (INDEX.GT.NBAS) THEN
                INDEX = INDEX - NBAS + NMB
                COLMAP (I) = INDEX
            END IF
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It copies eigenvectors of small Davidson matrix vectors      |
c  from block to static arrays DAV_R_AUX and DAV_L_AUX          | 
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|
      subroutine setauxvec (array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)


c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'pst_functions.h'
      include 'F12.h'
      include 'F12_gr.h'
      include 'daveom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

c---------------Variables--------------------------------------------

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array
      integer op(loptable_entry),sind
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block

      integer array_type, nindex, inda(2), indb(2)

      logical direct_flag

      integer i, j, k,qq,qq1,is_it_worker(max_procsx)
      integer nind, nsend,ind1,w_worker(max_procsx)
      integer ierr, handle,our_workers
      integer blk, blkndx, maxblk
      integer*8 iarray, farray, indblk, get_block_index
      integer*8 integral_scr,daddr,daddr1,iarray1
      integer seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag,ind(mx_array_index)
      integer stack,g,n1,n2,m1,m2

      double precision x(1),int_type_d,dind1
      double precision dbuf(1), temp
      integer ibuf(1)
      integer int_type
c----------------------------------------------------------------------
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      array = op(c_result_array)

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c-------------------DAV_R_aux array---------------------------------

      array      = op(c_result_array)

      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      daddr = address_table(array)
      iarray  = get_index_from_base(daddr, x, 2)


      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

      n1 = index_table(c_index_size, ind(1))  ! pick up length of index
      n2 = index_table(c_index_size, ind(2))  ! pick up length of index
c-------------------DAV_L_aux array---------------------------------
      array = op(c_op1_array)

      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      daddr1 = address_table(array)
      iarray1  = get_index_from_base(daddr1, x, 2)

      do i = 1, nindex
         ind(i) = array_table(c_index_array1+i-1,array)
      enddo

      m1 = index_table(c_index_size, ind(1))  ! pick up length of index
      m2 = index_table(c_index_size, ind(2))  ! pick up length of index
c---------------------------------------------------------------------
      call setauxvectors(x(iarray),n1,n2,x(iarray1),m1,m2 ) 
c---------------------------------------------------------------------


      return
      end


c#####################################################################
c#####################################################################
      subroutine setauxvectors(DAV_R_aux,n1,n2,DAV_L_aux,m1,m2) 
      IMPLICIT NONE
      include 'parallel_info.h'
      include 'daveom.h'

      integer i,j,n1,n2,m1,m2,izz,k
      double precision  ppp,
     & DAV_R_aux(n2,n2),DAV_L_aux(m2,m2) 

      izz = nroots*iter + nroots   

      do i=1,izz 
       do j=1,izz
       DAV_R_aux(i,j) = DavRvec(i,j)            
       DAV_L_aux(i,j) = DavLvec(i,j)
       enddo
      enddo

c--------Test-----------------------------

c      do i=1,izz  
c      do j=1,izz 
c         ppp = 0.d0
c         do k=1,izz
c         ppp = ppp+DavLvec(k,i)*DavRvec(k,j)  
c         enddo 
c         if(me.eq.0) write(6,*) ppp,'<--',i,j  
c      enddo    
c      enddo
c-----------------------------------------
      return
      end   

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine write_blocks_to_list_no_mpi_io(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Dumps all blocks of an array to a list.  This version is used when 
c   a system does not support MPI_IO.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k, n
      integer array, index(mx_array_index), nindex, ierr
      integer block, seg(mx_array_index)
      integer saveseg(mx_array_index)
      integer find_current_block
      integer blkndx
      integer*8 indblk, get_block_data_index
      integer stack
      integer f_form_msg_tag
      integer type, next, nreq
      
      integer mx_blk
      parameter (mx_blk = 25000)

      integer request(mx_blk)
      integer msg(2,mx_blk)
      integer statuses(MPI_STATUS_SIZE,mx_blk)

      integer my_comm_rank, comm
      integer home, iblk
      integer val1(mx_array_index), val2(mx_array_index)
      double precision x(1)
    
      integer nb, proc, map, company_comm
      integer tag
      integer pst_get_company_comm, pst_get_company_rank
      integer iarray

      company_comm    = pst_get_company_comm(me)
      proc  = pst_get_company_rank(me)
      if (proc .eq. 0) then
         call master_blocks_to_list(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, op)
         return
      endif

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      do iarray = 1, narray_list
      array = array_list(iarray)
      type  = array_table(c_array_type,array)
      if (type .eq. served_array) go to 900 ! master handles all served arrays
      if (type .ne. distributed_array) then
         print *,'Error: BLOCKS_TO_LIST array must be either ',
     *     'a distributed or served array.'
         print *,'Array ',array,' has type = ',type
         call abort_job()
      endif

      nb = array_table(c_numblks, array)
      map = array_table(c_block_map, array)

      nindex = array_table(c_nindex, array)

c---------------------------------------------------------------------------
c   Pick up the array's indices, and save the current segments of each.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         saveseg(i) = index_table(c_current_seg,index(i))
      enddo

c-------------------------------------------------------------------------
c   Loop over all blocks in the block_map_table, processing only the
c   blocks with this processor as "home".
c-------------------------------------------------------------------------

      nreq = 0
      next = 0
      do iblk = 1, nb
         home = block_map_table(c_processor, map+iblk-1)
         if (home .eq. proc) then 

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

            n = 1
            do i = 1, nindex
               seg(i) = block_map_table(c_block_map_seg+i-1,map+iblk-1)
               call get_index_segment(index(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))

c--------------------------------------------------------------------------
c   Set the current_segment of the appropriate index to this segment.
c--------------------------------------------------------------------------

                index_table(c_current_seg,index(i)) = seg(i)
                n = n * (val2(i)-val1(i)+1)
            enddo

c---------------------------------------------------------------------------
c   Get array data address.
c---------------------------------------------------------------------------

            block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)
            if (block .lt. 0) then
               print *,'Error in BLOCKS_TO_LIST: Array ',array,
     *            ' Block ',block,' not found.'
               call abort_job()
            endif

            stack  = array_table(c_array_stack,array)
            indblk = get_block_data_index(array, block, stack,
     *                                    blkndx, x)

c--------------------------------------------------------------------------
c   Send a descriptor message to the master.
c--------------------------------------------------------------------------
   
            tag = f_form_msg_tag() 
            next = next + 1
            if (nreq .gt. mx_blk) then
               call mpi_waitall(nreq, request, statuses, ierr)
               next = 1
            endif

            msg(1,next) = iblk
            msg(2,next) = tag
            nreq = nreq + 1
            call mpi_isend(msg(1,next), 2, MPI_INTEGER, 0, 
     *                  block_list_descriptor_tag,
     *                  company_comm, request(nreq), ierr)

c---------------------------------------------------------------------------
c   Send the data to the master process.
c---------------------------------------------------------------------------

            nreq = nreq + 1
            call mpi_isend(x(indblk), n, MPI_DOUBLE_PRECISION, 0,
     *                  tag, company_comm, request(nreq), ierr)
         endif 
      enddo

c---------------------------------------------------------------------------
c   Restore the current segments to their saved values.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index_table(c_current_seg,index(i)) = saveseg(i)
      enddo

c----------------------------------------------------------------------------
c   Wait for all messages to complete.
c----------------------------------------------------------------------------

      call mpi_waitall(nreq, request, statuses, ierr)
  900 continue
      enddo   ! iarray

      narray_list = 0
      return
      end

      subroutine master_blocks_to_list(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, op)
c--------------------------------------------------------------------------
c   Dumps all blocks of an array to a list.
c   This routine handles the master's role.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h'
      include 'machine_types.h'
      include 'dbugcom.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)

      integer i, j, k, n
      integer array, index(mx_array_index), nindex, ierr
      integer seg(mx_array_index)
      integer*8 iscr
      integer*8 indblk
      integer*8 get_block_data_index
      integer allocate_scratch_block
      integer type
      
      integer my_comm_rank, comm
      integer home, iblk
      integer val1(mx_array_index), val2(mx_array_index)
      integer index_type(mx_array_index)
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
    
      integer nblk, proc, map, company_comm
      integer pst_get_company_comm, pst_get_company_rank
      integer list_unit, data_unit, ios
      logical file_open
      integer irecv, nrecv
      integer datatag, nind, handle

      integer mx_blk
      parameter (mx_blk = 25000)
      integer request(mx_blk)
      integer tag(mx_blk)
      integer desc_msg(2,mx_blk)
      integer stack, blkndx
      integer status(MPI_STATUS_SIZE)
      integer iarray
      integer*8 data_ptr

      logical served_flag
      double precision esum, block_energy

#ifdef ALTIX
      dptr = dshptr
#endif

      company_comm    = pst_get_company_comm(me)
      proc  = pst_get_company_rank(me)
      if (proc .ne. 0) then
         print *,'ERROR: master_block_to_list called on non-master'
         call abort_job()
         return
      endif

c---------------------------------------------------------------------------
c   Verify array type info.
c---------------------------------------------------------------------------

      do iarray = 1, narray_list
         array = array_list(iarray)
         type  = array_table(c_array_type,array)
         if (type .ne. distributed_array .and.
     *       type .ne. served_array) then
            print *,'Error: BLOCKS_TO_LIST array must be ',
     *              'either a distributed or served array.'
            print *,'Array ',array,' has type = ',type
            call abort_job()
         endif
      enddo

c---------------------------------------------------------------------------
c   Allocate a scratch block.
c---------------------------------------------------------------------------
   
      ierr = allocate_scratch_block(x, iscr, handle, array_table,
     *                              narray_table, index_table, 
     *                              nindex_table, block_map_table)
      if (ierr .ne. 0) then
         print *,'Error: Cannot allocate a scratch block'
         call array_block_summary(array_table, narray_table)
         call dump_block_ids()
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Open the files.
c--------------------------------------------------------------------------

      list_unit = 29
      inquire (unit=list_unit, opened=file_open)
      if (.not. file_open) then
         open (unit = list_unit, file='BLOCK_INDEX2',err = 1000,
     *      iostat=ios, access='SEQUENTIAL', form='UNFORMATTED')
      endif

      data_unit = -1
      inquire (file='BLOCKDATA2', exist = file_open)
      if (file_open) call f_deletefile('BLOCKDATA2'//char(0), 
     *                                 data_unit)
      call f_creatfile('BLOCKDATA2' // char(0), data_unit)
      data_ptr = 0
 
c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      served_flag = .false.

      do iarray = 1, narray_list
      esum = 0.

      array = array_list(iarray)
      type  = array_table(c_array_type,array)

      if (type .eq. served_array) then
         call master_blocks_to_list_served(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, op, x(iscr),
     *                      list_unit, data_unit, array, data_ptr,
     *                      esum)
         go to 900    ! process next array
      endif

      nblk = array_table(c_numblks, array)
      map = array_table(c_block_map, array)
      nindex = array_table(c_nindex, array)

      if (dbg) print *,'Task ',me,' BLOCKS_TO_LIST: array ',
     *     array,' type ',
     *     type,' nb ',nblk
      call prt_time('Worker time')
      if (nblk .gt. mx_blk) then
         print *,'Error: Array ',array,' contains ',nblk,' blocks'
         print *,'Current max. for lists is ',mx_blk
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Pick up the array's indices, and save the current segments of each.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         index_type(i) = index_table(c_index_type, index(i))
      enddo

c-------------------------------------------------------------------------
c   Loop over all blocks in the block_map_table, processing only the
c   blocks with this processor as "home".
c-------------------------------------------------------------------------

      nrecv = 0
      do iblk = 1, nblk
         home = block_map_table(c_processor, map+iblk-1)

c--------------------------------------------------------------------------
c   Post a descriptor message recv from the block's owner.
c--------------------------------------------------------------------------

         if (home .ne. proc) then
            nrecv = nrecv + 1
            call mpi_irecv(desc_msg(1,nrecv), 2, mpi_integer, home,
     *                     block_list_descriptor_tag,
     *                     company_comm, request(nrecv), ierr)
         endif
      enddo

c---------------------------------------------------------------------------
c   Process the data messages.
c---------------------------------------------------------------------------

      do irecv = 1, nrecv
         call mpi_wait(request(irecv), status, ierr)

         iblk    = desc_msg(1,irecv)
         datatag = desc_msg(2,irecv)
         home    = block_map_table(c_processor, map+iblk-1)

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

         n = 1
         do i = 1, nindex
            seg(i) = block_map_table(c_block_map_seg+i-1,map+iblk-1)
            call get_index_segment(index(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
            n = n * (val2(i)-val1(i)+1)
         enddo

c---------------------------------------------------------------------------
c   Write an index record for this block.
c---------------------------------------------------------------------------

         write (list_unit) array, iblk, nindex, n,
     *                       (index_type(i),i=1,nindex),
     *                       (seg(i),i=1,nindex),
     *                       (val1(i),i=1,nindex), 
     *                       (val2(i),i=1,nindex)

c----------------------------------------------------------------------------
c   Receive the data into the scratch block.
c----------------------------------------------------------------------------

         call mpi_recv(x(iscr), n, mpi_double_precision, home,
     *                     datatag,
     *                     company_comm, status, ierr)

c----------------------------------------------------------------------------
c   Write the data record for this block.
c----------------------------------------------------------------------------

c         write (data_unit) (x(iscr+i-1),i=1,n)
c          call encode_orbital_ind(x(iscr), index_type, val1, val2, 
c     *                            nindex)
          call f_write_disk(data_unit, data_ptr, x(iscr), n)
          data_ptr = data_ptr + n
          if (dbg) esum = esum + block_energy(x(iscr), n)
      enddo

c--------------------------------------------------------------------------
c   Write all the master's blocks.
c--------------------------------------------------------------------------

      do iblk = 1, nblk
         home = block_map_table(c_processor, map+iblk-1)
         if (home .eq. proc) then

c-------------------------------------------------------------------------
c   Get segment ranges.
c-------------------------------------------------------------------------

            n = 1
            do i = 1, nindex
               seg(i) = block_map_table(c_block_map_seg+i-1,map+iblk-1)
               call get_index_segment(index(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
               n = n * (val2(i)-val1(i)+1)
            enddo

c---------------------------------------------------------------------------
c   Write an index record to the index file for this block.
c---------------------------------------------------------------------------

            write (list_unit) array, iblk, nindex, n,
     *                       (index_type(i),i=1,nindex),
     *                       (seg(i),i=1,nindex),
     *                       (val1(i),i=1,nindex), 
     *                       (val2(i),i=1,nindex)

c--------------------------------------------------------------------------
c   Write the data block.
c--------------------------------------------------------------------------

            stack = array_table(c_array_stack,array)
            blkndx = block_map_table(c_bmap_blkndx,map+iblk-1)
            indblk = get_block_data_index(array, iblk, 
     *                                    stack, blkndx, x)
c            write (data_unit) (x(indblk+i-1),i=1,n)
c            call encode_orbital_ind(x(indblk), index_type, val1,  
c     *                              val2, nindex)
            call f_write_disk(data_unit, data_ptr, x(indblk), n) 
            data_ptr = data_ptr + n
            if (dbg) esum = esum + block_energy(x(indblk), n)
         endif
      enddo

  900 continue
         if (dbg) then
            print *,'BLOCKS_TO_LIST: array ',array,' at line ',
     *          current_line,' esum = ',esum
         endif
      enddo   ! iarray

c---------------------------------------------------------------------------
c   Release the scratch block.
c---------------------------------------------------------------------------

      call free_scratch_block(handle) 
      narray_list = 0

c---------------------------------------------------------------------------
c   Close the files.
c---------------------------------------------------------------------------

      close(list_unit)
      call f_close_file(data_unit)

c---------------------------------------------------------------------------
c   Rename BLOCK_INDEX2 --> BLOCK_INDEX, BLOCKDATA2 --> BLOCKDATA.
c---------------------------------------------------------------------------

      call f_renamefile('BLOCK_INDEX2'//char(0),'BLOCK_INDEX'//char(0))
      call f_renamefile('BLOCKDATA2'//char(0),'BLOCKDATA'//char(0))
      call prt_time('END OF BLOCKS_TO_LIST')
      return

 1000 continue
      print *,'Cannot open BLOCK_INDEX or BLOCKDATA files.'
      print *,'I/O status = ',ios
      call abort_job()
      end

      subroutine master_blocks_to_list_served(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, op, scr,
     *                      list_unit, data_unit, array, data_ptr,
     *                      esum)
c--------------------------------------------------------------------------
c   Dumps all blocks of an array to a list.
c   This routine handles the master's role.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'machine_types.h' 
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      double precision scr(*)

      integer i, j, k, n
      integer array, index(mx_array_index), nindex, ierr
      integer msg_array, msg_nindex
      integer msg_tag
      integer seg(mx_array_index)
      integer type
      
      integer my_comm_rank
      integer msg_iblk
      integer val1(mx_array_index), val2(mx_array_index)
      integer msg_val1(mx_array_index), msg_val2(mx_array_index)
      integer index_type(mx_array_index)
    
      integer proc, map
      integer list_unit, data_unit
      integer request(nprocs)
      integer server_request(nprocs)
      integer server_id(nprocs)
      integer nxt, match
      integer msg(len_sip_server_message),
     *        desc_msg(len_sip_server_message,nprocs)
      integer f_form_msg_tag
      integer status(MPI_STATUS_SIZE)
      integer company, pst_get_company

      integer*8 data_ptr
      integer nblocks, nwpblk, niocompany
      integer nb_processed, irecv, source
      double precision esum, block_energy
      integer statuses(MPI_STATUS_SIZE, nprocs)
      logical invalid_data

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      type  = array_table(c_array_type,array)
      if (type .ne. served_array) then
         print *,'Error: MASTER_BLOCKS_TO_LIST_SERVED must be ',
     *           'called with a served array.'
         print *,'Array ',array,' has type = ',type
         call abort_job()
      endif

      nb = array_table(c_numblks, array)
      map = array_table(c_block_map, array)
      nindex = array_table(c_nindex, array)
      if (dbg) then
        print *,'BLOCKS_TO_LIST array ',array,' type ',
     *     type,' nb ',
     *     nb
         call prt_time('Worker time')
      endif

c---------------------------------------------------------------------------
c   Send a "sip_server_blocks_to_list" message to each server, requesting
c   that the servers transfer the blocks of the array.
c---------------------------------------------------------------------------

      msg(1) = sip_server_blocks_to_list
      msg(2) = array 
      msg(3) = 0         ! nindex
      niocompany = 0
      do i = 1, nprocs
         company = pst_get_company(i-1) 
         if (company .eq. io_company_id) then
            niocompany = niocompany + 1
            call mpi_isend(msg, len_sip_server_message, mpi_integer,
     *                  i-1, sip_server_message,
     *                  mpi_comm_world, 
     *                  server_request(niocompany), ierr) 
            server_id(niocompany) = i-1
         endif 
      enddo

      call mpi_waitall(niocompany, server_request, statuses, ierr)

c---------------------------------------------------------------------------
c   Post an initial recv for each server.
c---------------------------------------------------------------------------

      do i = 1, niocompany
         call mpi_irecv(desc_msg(1,i), len_sip_server_message, 
     *                     mpi_integer, server_id(i),
     *                     sip_server_blocks_to_list,
     *                     mpi_comm_world, request(i), ierr)
      enddo 
      
c---------------------------------------------------------------------------
c   Pick up the array's indices and index_type's.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         index_type(i) = index_table(c_index_type, index(i))
      enddo

c----------------------------------------------------------------------------
c   Process the blocks of this array.
c----------------------------------------------------------------------------

      nb_processed = 0
  100 continue
      
c----------------------------------------------------------------------------
c   Wait for a recv of the desc_msg.
c----------------------------------------------------------------------------

      call mpi_waitany(niocompany, request, irecv, status, ierr)

c----------------------------------------------------------------------------
c   Decode the descriptor message and write the data to BLOCK_INDEX.
c----------------------------------------------------------------------------

         msg_array = desc_msg(2,irecv)
         msg_nindex = desc_msg(3,irecv) 
         msg_tag    = desc_msg(4,irecv)
         msg_iblk   = desc_msg(7,irecv) 

         nxt = 7 + mx_array_index

         n = 1
         do i = 1, mx_array_index
            if (i .le. msg_nindex) then
               msg_val1(i) = desc_msg(nxt,irecv)
               msg_val2(i) = desc_msg(nxt+1,irecv)
               n = n * (msg_val2(i) - msg_val1(i) + 1)
            endif
            nxt = nxt + 2
         enddo

c---------------------------------------------------------------------------
c   Validate the data in the message.
c---------------------------------------------------------------------------

         invalid_data = .false. 
         if (array .ne. msg_array .or. nindex .ne. msg_nindex) then
            print *,'Error in write_blocks_to_list: Invalid data in msg'
            print *,'array ',array,' msg_array ',msg_array
            print *,'nindex ',nindex,' msg_nindex ',msg_nindex
            do i = 1, nindex
               print *,'val1, val2 ',val1(i),val2(i),
     *                 ' msg_val1, msg_val2 ',msg_val1(i),msg_val2(i)
            enddo
            call abort_job()
         endif
     
         do j = 1, nindex
            seg(j) = 
     *         block_map_table(c_block_map_seg+j-1,msg_iblk)
            call get_index_segment(index(j), seg(j), segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, val1(j), val2(j))
         enddo

         do j = 1, nindex
            if (val1(j) .ne. msg_val1(j) .or. 
     *          val2(j) .ne. msg_val2(j)) then
               print *,'Error: seg values do not match.'
               print *,'index ',(index(i),i=1,nindex) 
               print *,'seg ',(seg(i),i=1,nindex) 
               print *,'val1 ',(val1(i),i=1,nindex) 
               print *,'msg_val1 ',(msg_val1(i),i=1,nindex) 
               print *,'val2 ',(val2(i),i=1,nindex) 
               print *,'msg_val2 ',(msg_val2(i),i=1,nindex) 
            endif
         enddo

c--------------------------------------------------------------------------
c   Look up the block in the blk_map_table, verify the blocksize.
c--------------------------------------------------------------------------

         source = block_map_table(c_processor, msg_iblk)
         if (source .ne. server_id(irecv)) then
            print *,'Error: write_blocks_to_list'
            print *,'Block ',msg_iblk,' recvd from wrong source.'
            print *,'Msg source ',server_id(irecv),' should be ',
     *                source
            call abort_job()
         endif
 
c---------------------------------------------------------------------------
c   Write an index record to the index file for this block.
c---------------------------------------------------------------------------

         write (list_unit) array, msg_iblk-map+1, nindex, n,
     *                       (index_type(i),i=1,nindex),
     *                       (seg(i),i=1,nindex),
     *                       (val1(i),i=1,nindex),
     *                       (val2(i),i=1,nindex)

c--------------------------------------------------------------------------
c   Now recv the data block, write it to disk.
c--------------------------------------------------------------------------

      call mpi_recv(scr, n, mpi_double_precision,
     *               server_id(irecv), msg_tag, mpi_comm_world,
     *               status, ierr)

      call f_write_disk(data_unit, data_ptr, scr, n)
      data_ptr = data_ptr + n
      if (dbg) esum = esum + block_energy(scr, n)

c---------------------------------------------------------------------------
c   Post a new recv for this server.
c---------------------------------------------------------------------------

      call mpi_irecv(desc_msg(1,irecv), len_sip_server_message,
     *                     mpi_integer, server_id(irecv),
     *                     sip_server_blocks_to_list,
     *                     mpi_comm_world, request(irecv), ierr)
      nb_processed = nb_processed + 1
      if (nb_processed .lt. nb) go to 100

c--------------------------------------------------------------------------
c   Free up the posted recvs of the desc_msg's.
c--------------------------------------------------------------------------

      do i = 1, niocompany
         if ( request(i) .ne. MPI_REQUEST_NULL) then
            call mpi_cancel(request(i), ierr)
            call mpi_wait(request(i), status, ierr)
         endif
      enddo

      return
      end

      subroutine encode_orbital_ind(x, index_type, val1, val2, nindex)
      implicit none
      include 'interpreter.h'
      include 'dropmo.h'

      integer nindex
      integer index_type(nindex), val1(nindex), val2(nindex)
      integer*8 x(*)

      integer i, j, k
      integer*8 orb(4), neworb(4), next
      integer*8 packit, shift1, shift2, shift3

      if (nindex .ne. 4) return
      do i = 1, 4
         orb(i) = val1(i)
      enddo

      shift1 = 2**16
      shift2 = shift1 * shift1
      shift3 = shift2 * shift1

      next = 0
  100 continue
      do i = 1, 4
         neworb(i) = orb(i)
         if (index_type(i) .eq. moaindex .or.
     *       index_type(i) .eq. moindex) then
            neworb(i) = moamap(orb(i))
         else if (index_type(i) .eq. mobindex) then
            neworb(i) = mobmap(orb(i))
         endif
      enddo

      packit = neworb(1)
      packit = packit + neworb(2) * shift1
      packit = packit + neworb(3) * shift2 
      packit = packit + neworb(4) * shift3
      next = next + 1
      x(next) = packit
c      print 101,(orb(i),i=1,4),x(next),packit 
c  101 format(' orb ',4(i4,1x),' x(next) ',z16,' packit ',z16)

      j = 1
  200 continue
      orb(j) = orb(j) + 1
      if (orb(j) .gt. val2(j)) then
         orb(j) = val1(j)
         j = j + 1
         if (j .gt. nindex) return
         go to 200
      else
        go to 100
      endif

      return
      end

C THIS ROUTINE TRANSFORMS THE SYMMETRY COORDINATE HESSIAN MATRIX
C TO THE CARTESIAN REPRESENTATION.

c INPUT
c integer NMODE      :
c integer NATOM      :
c integer NIRREP     :
c integer ISYMIRR(*) :
c integer IDEGEN(*)  :
c char*4  TYPE       :
c integer NDSCR      :

c INPUT/OUTPUT
c double FCM(9*NATOM*NATOM) :

c OUTPUT
c double FCMFUL(9*NATOM*NATOM) :
c double DSCR(NDSCR)           :

c RECORDS
c get TYPE//'SYMQ'
c get 'ATOMMASS'

      SUBROUTINE TRNFCM(NMODE,NATOM,NIRREP,FCM,FCMFUL,
     &                  ISYMIRR,IDEGEN,TYPE,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION FCM(9*NATOM*NATOM),FCMFUL(9*NATOM*NATOM)
      DIMENSION ISYMIRR(*),IDEGEN(*)
      CHARACTER*4 TYPE
      double precision dscr(ndscr)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      NSIZE=3*NATOM

      IF (NDSCR.LT.2*NSIZE*NSIZE) THEN
         print *, '@TRNFCM: Insufficient memory.'
         print *, '         have ',NDSCR,' doubles'
         print *, '         need ',2*NSIZE*NSIZE,' doubles'
         call aces_exit(1)
      END IF

      CALL ZERO(FCMFUL,NSIZE*NSIZE)

      ICOUNT=1
      IOFF1 =1
      NLEFT =NMODE
      DO IRREP=1,NIRREP

c      o find first occurance of this irrep
         ILOC=ISRCHEQ(NMODE,ISYMIRR,1,IRREP)
         IF (ILOC.NE.NMODE+1) THEN
            ILAST=ISRCHNE(NLEFT,ISYMIRR(ILOC),1,IRREP)
            NVIBSYM=ILAST-1
            IDEG=IDEGEN(IRREP)
            NDIM=NVIBSYM/IDEG
c         o expand fcm matrix into full matrix
            call dscal(ndim*ndim,dfloat(ideg),fcm(ioff1),1)
            CALL BLKCPY(FCM(IOFF1),NDIM,NDIM,FCMFUL,NSIZE,NSIZE,
     &                  ICOUNT,ICOUNT)
            ICOUNT=ICOUNT+NVIBSYM
            IOFF1 = IOFF1+NDIM*NDIM
            NLEFT = NLEFT-NVIBSYM
         END IF

      END DO

c   o transform to mass-weighted cartesian coordinates
      CALL GETREC(20,'JOBARC',TYPE//'SYMQ',NSIZE*NSIZE*IINTFP,DSCR)
      I = 1+NSIZE*NSIZE
      CALL XGEMM('N','N',NSIZE,NSIZE,NSIZE,
     &           1.d0,DSCR,   NSIZE,
     &                FCMFUL, NSIZE,
     &           0.d0,DSCR(I),NSIZE)
      CALL XGEMM('N','T',NSIZE,NSIZE,NSIZE,
     &           1.d0,DSCR(I),NSIZE,
     &                DSCR,   NSIZE,
     &           0.d0,FCMFUL, NSIZE)

c   o remove mass weighting
      CALL GETREC(20,'JOBARC','ATOMMASS',NATOM*IINTFP,DSCR)
      IOFF1=1
      IOFF2=1
      DO IATOM=1,NATOM
         X=SQRT(DSCR(IATOM))
         DO IXYZ=1,3
            CALL DSCAL(NSIZE,X,FCMFUL(IOFF1),1)
            CALL DSCAL(NSIZE,X,FCMFUL(IOFF2),NSIZE)
            IOFF1=IOFF1+NSIZE
            IOFF2=IOFF2+1
         END DO
      END DO

c   o create the FCM file
      OPEN(UNIT=40,FILE='FCM',STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE(40,'(2I5)')NSIZE,NSIZE
      WRITE(40,'((3F20.10))')(FCMFUL(I),I=1,NSIZE*NSIZE)
      CLOSE(UNIT=40,STATUS='KEEP')

      RETURN
      END

C THIS ROUTINE COMPUTES AND WRITES OUT THE NORM OF a, WHICH IS AN
C VECTOR OF LENGTH n.

      subroutine znorm(a,n)
      implicit double precision (a-h,o-z)
      dimension a(n)
      z = 0.0d0
      if (n.gt.0) then
         do i = 1, n
            z = z + ( a(i) * a(i) )
         end do
      end if
      write(*,'(F20.10)') z
      return
      end

      Subroutine PitPtG (RealPG, PitS, PitOrd)
C
C     Take a real Schoenflies symbol & convert it into something Pitzer
C     can understand.  Pretty inelegant for now.  I hope we won't need
C     to use Pitzer much longer.
C
      Character*(*) RealPG, PitS
      Integer PitOrd
      Integer AtoI
C
      Do 100 i = 1, Len(PitS)
         PitS(i:i) = ' '
 100  Continue
      If (RealPG(1:linblnk(RealPG)) .eq. 'C1') then
         PitS = 'C1'
         PitOrd = 0
         Return
      EndIf
      If (RealPG(1:linblnk(RealPG)) .eq. 'CS' .OR.
     $   RealPG(1:linblnk(RealPG)) .eq. 'Cs' .OR.
     $   RealPG(1:linblnk(RealPG)) .eq. 'C S' .OR.
     $   RealPG(1:linblnk(RealPG)) .eq. 'C s') then
         PitS = 'CS'
         PitOrd = 0
         Return
      EndIf
      If (RealPG(1:1) .eq. 'C' .OR. RealPG(1:1) .eq. 'D') then
         PitS(1:1) = RealPG(1:1)
         PitS(2:2) = 'N'
         PitOrd = AtoI(RealPG(2:))
         i = linblnk(RealPG)
         If (RealPG(i:i) .eq. 'v' .OR. RealPG(i:i) .eq. 'V') then
            PitS(3:3) = 'V'
         ElseIf (RealPG(i:i) .eq. 'h' .OR. RealPG(i:i) .eq. 'H') then
            PitS(3:3) = 'H'
         EndIf
      Else
         PitS = 'XXX'
      EndIf
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__HRR_TRANSFORM
     +
     +                    ( M,
     +                      NROW,NXYZET,NXYZAB,
     +                      NXYZA,NXYZB,
     +                      LROW,ROW,
     +                      ROT,
     +                      X,
     +
     +                              Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__HRR_TRANSFORM
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a HRR transformation on a
C                batch of contracted cartesian gaussian integrals:
C
C                                      nxyzet
C                     y (m,nxyzab)  =   sum   x (m,i) * rot (i,nxyzab)
C                                       i=1
C
C                where rot is the HRR transformation matrix. Due to
C                the very sparse nature of this matrix, only those
C                i indices in the summation are addressed which
C                correspond to nonzero HRR transformation matrix
C                elements.
C
C
C                  Input:
C
C                     M          =  # of elements not involved in the
C                                   transformation (invariant indices)
C                     NROW       =  maximum # of nonzero row elements
C                                   per column in transformation matrix
C                     NXYZET     =  dimension of the cartesian e0-part
C                     NXYZAB     =  dimension of the resulting cartesian
C                                   ab-part
C                     NXYZA      =  dimension of the cartesian part due
C                                   to the a-shell
C                     NXYZB      =  dimension of the cartesian part due
C                                   to the b-shell
C                     LROW (N)   =  # of nonzero entries in column N of
C                                   ROT and ROW matrix. N ranges from
C                                   1 to NXYZB
C                     ROW (I,N)  =  I-th nonzero row label of column N
C                                   in ROT matrix. N ranges from 1 to
C                                   NXYZAB
C                     ROT (I,N)  =  I-th nonzero HRR transformation
C                                   matrix element of column N. N ranges
C                                   from 1 to NXYZB
C                     X          =  batch of untransformed integrals
C                                   (m,e0)
C
C                  Output:
C
C                     Y          =  batch of HRR transformed integrals
C                                   (m,ab)
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     A,B,I,J,M,N
         INTEGER     MROW,NROW
         INTEGER     NLEFT,NSTEP
         INTEGER     NXYZET,NXYZAB
         INTEGER     NXYZA,NXYZB
         INTEGER     XCOL1,XCOL2,XCOL3,XCOL4,XCOL5,XCOL6,XCOL7,XCOL8

         INTEGER     LROW (1:NXYZB)
         INTEGER     ROW  (1:NROW,1:NXYZAB)

         DOUBLE PRECISION  ROT1,ROT2,ROT3,ROT4,ROT5,ROT6,ROT7,ROT8

         DOUBLE PRECISION  X (1:M,1:NXYZET)
         DOUBLE PRECISION  Y (1:M,1:NXYZAB)

         DOUBLE PRECISION  ROT (1:NROW,1:NXYZB)
C
C
C------------------------------------------------------------------------
C
C
C             ...perform the HRR transformation. One of the main
C                properties of this transformation is that the
C                last nonzero element of the HRR transformation
C                matrix is always equal to 1. Hence we can skip
C                the multiplication with that element.
C
C                Use basic row grouping of the transformation
C                to improve cache line reusing.
C
C
         N = 1

         DO 100 B = 1,NXYZB
            MROW = LROW (B)

            GOTO (1,2,3,4,5,6,7,8,9) MIN (MROW,9)
C
C
C             ...# of rows = 1
C
C
    1       DO 10 A = 1,NXYZA
               XCOL1 = ROW (1,N)
               DO J = 1,M
                  Y (J,N) = X (J,XCOL1)
               END DO
               N = N + 1
   10       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 2
C
C
    2       DO 20 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               ROT1  = ROT (1,B)

               DO J = 1,M
                  Y (J,N) = ROT1 * X (J,XCOL1)
     +                           + X (J,XCOL2)
               END DO

               N = N + 1
   20       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 3
C
C
    3       DO 30 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               XCOL3 = ROW (3,N)

               ROT1  = ROT (1,B)
               ROT2  = ROT (2,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      +        X (J,XCOL3)
               END DO

               N = N + 1
   30       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 4
C
C
    4       DO 40 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               XCOL3 = ROW (3,N)
               XCOL4 = ROW (4,N)

               ROT1  = ROT (1,B)
               ROT2  = ROT (2,B)
               ROT3  = ROT (3,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      + ROT3 * X (J,XCOL3)
     +                      +        X (J,XCOL4)
               END DO

               N = N + 1
   40       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 5
C
C
    5       DO 50 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               XCOL3 = ROW (3,N)
               XCOL4 = ROW (4,N)
               XCOL5 = ROW (5,N)

               ROT1  = ROT (1,B)
               ROT2  = ROT (2,B)
               ROT3  = ROT (3,B)
               ROT4  = ROT (4,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      + ROT3 * X (J,XCOL3)
     +                      + ROT4 * X (J,XCOL4)
     +                      +        X (J,XCOL5)
               END DO

               N = N + 1
   50       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 6
C
C
    6       DO 60 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               XCOL3 = ROW (3,N)
               XCOL4 = ROW (4,N)
               XCOL5 = ROW (5,N)
               XCOL6 = ROW (6,N)

               ROT1  = ROT (1,B)
               ROT2  = ROT (2,B)
               ROT3  = ROT (3,B)
               ROT4  = ROT (4,B)
               ROT5  = ROT (5,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      + ROT3 * X (J,XCOL3)
     +                      + ROT4 * X (J,XCOL4)
     +                      + ROT5 * X (J,XCOL5)
     +                      +        X (J,XCOL6)
               END DO

               N = N + 1
   60       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 7
C
C
    7       DO 70 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               XCOL3 = ROW (3,N)
               XCOL4 = ROW (4,N)
               XCOL5 = ROW (5,N)
               XCOL6 = ROW (6,N)
               XCOL7 = ROW (7,N)

               ROT1  = ROT (1,B)
               ROT2  = ROT (2,B)
               ROT3  = ROT (3,B)
               ROT4  = ROT (4,B)
               ROT5  = ROT (5,B)
               ROT6  = ROT (6,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      + ROT3 * X (J,XCOL3)
     +                      + ROT4 * X (J,XCOL4)
     +                      + ROT5 * X (J,XCOL5)
     +                      + ROT6 * X (J,XCOL6)
     +                      +        X (J,XCOL7)
               END DO

               N = N + 1
   70       CONTINUE

            GOTO 100
C
C
C             ...# of rows = 8
C
C
    8       DO 80 A = 1,NXYZA

               XCOL1 = ROW (1,N)
               XCOL2 = ROW (2,N)
               XCOL3 = ROW (3,N)
               XCOL4 = ROW (4,N)
               XCOL5 = ROW (5,N)
               XCOL6 = ROW (6,N)
               XCOL7 = ROW (7,N)
               XCOL8 = ROW (8,N)

               ROT1  = ROT (1,B)
               ROT2  = ROT (2,B)
               ROT3  = ROT (3,B)
               ROT4  = ROT (4,B)
               ROT5  = ROT (5,B)
               ROT6  = ROT (6,B)
               ROT7  = ROT (7,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      + ROT3 * X (J,XCOL3)
     +                      + ROT4 * X (J,XCOL4)
     +                      + ROT5 * X (J,XCOL5)
     +                      + ROT6 * X (J,XCOL6)
     +                      + ROT7 * X (J,XCOL7)
     +                      +        X (J,XCOL8)
               END DO

               N = N + 1
   80       CONTINUE

            GOTO 100
C
C
C             ...# of rows > 8. Perform transformations in bundles
C                of 8 rows.
C
C
    9       DO 90 A = 1,NXYZA

               XCOL1 = ROW (MROW-7,N)
               XCOL2 = ROW (MROW-6,N)
               XCOL3 = ROW (MROW-5,N)
               XCOL4 = ROW (MROW-4,N)
               XCOL5 = ROW (MROW-3,N)
               XCOL6 = ROW (MROW-2,N)
               XCOL7 = ROW (MROW-1,N)
               XCOL8 = ROW (MROW  ,N)

               ROT1  = ROT (MROW-7,B)
               ROT2  = ROT (MROW-6,B)
               ROT3  = ROT (MROW-5,B)
               ROT4  = ROT (MROW-4,B)
               ROT5  = ROT (MROW-3,B)
               ROT6  = ROT (MROW-2,B)
               ROT7  = ROT (MROW-1,B)

               DO J = 1,M
                  Y (J,N) =   ROT1 * X (J,XCOL1)
     +                      + ROT2 * X (J,XCOL2)
     +                      + ROT3 * X (J,XCOL3)
     +                      + ROT4 * X (J,XCOL4)
     +                      + ROT5 * X (J,XCOL5)
     +                      + ROT6 * X (J,XCOL6)
     +                      + ROT7 * X (J,XCOL7)
     +                      +        X (J,XCOL8)
               END DO

               NLEFT = MROW - 8
               NSTEP = NLEFT / 8

               DO 92 I = 1,NSTEP

                  XCOL1 = ROW (NLEFT-7,N)
                  XCOL2 = ROW (NLEFT-6,N)
                  XCOL3 = ROW (NLEFT-5,N)
                  XCOL4 = ROW (NLEFT-4,N)
                  XCOL5 = ROW (NLEFT-3,N)
                  XCOL6 = ROW (NLEFT-2,N)
                  XCOL7 = ROW (NLEFT-1,N)
                  XCOL8 = ROW (NLEFT  ,N)

                  ROT1  = ROT (NLEFT-7,B)
                  ROT2  = ROT (NLEFT-6,B)
                  ROT3  = ROT (NLEFT-5,B)
                  ROT4  = ROT (NLEFT-4,B)
                  ROT5  = ROT (NLEFT-3,B)
                  ROT6  = ROT (NLEFT-2,B)
                  ROT7  = ROT (NLEFT-1,B)
                  ROT8  = ROT (NLEFT  ,B)

                  DO J = 1,M
                     Y (J,N) = Y (J,N) + ROT1 * X (J,XCOL1)
     +                                 + ROT2 * X (J,XCOL2)
     +                                 + ROT3 * X (J,XCOL3)
     +                                 + ROT4 * X (J,XCOL4)
     +                                 + ROT5 * X (J,XCOL5)
     +                                 + ROT6 * X (J,XCOL6)
     +                                 + ROT7 * X (J,XCOL7)
     +                                 + ROT8 * X (J,XCOL8)
                  END DO
                  NLEFT = NLEFT - 8
   92          CONTINUE

               DO 94 I = NLEFT,1,-1
                  XCOL1 = ROW (I,N)
                  ROT1  = ROT (I,B)
                  DO J = 1,M
                     Y (J,N) = Y (J,N) + ROT1 * X (J,XCOL1)
                  END DO
   94          CONTINUE

               N = N + 1
   90       CONTINUE
C
C
C             ...next b-shell monomial.
C
C
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine joda_main()
      implicit none

      integer pass1, i, istat
      logical fd, geomopt, num_grad

      integer iprt, ierr
      character*80 BasNam

#include "jodaflags.com"
#include "flags.h"
#include "mxatms.par"
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(3*MXATMS),
     1     PARNAM(3*MXATMS)

#include "coord.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      INTEGER  NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT

      integer genby(mxatms), scratch(mxatms)
 
c   o initialize the runtime environment
      call aces_init_rte

c   o initialize the job archive subsystem
c      call aces_ja_init

c      o this is the first joda run
c         call iputrec(1,'JOBARC','FIRSTRUN',1,1)
c         call iputrec(1,'JOBARC','DIRTYFLG',1,0)
c         call iputrec(1,'JOBARC','JODADONE',1,0)
c         call iputrec(1,'JOBARC','FNDFDONE',1,1)

c         iprt = 1 
c         call gtflgs(iprt, ierr, BasNam)   ! decipher flags from ZMAT
c         if (iflags(h_IOPPAR_coordinates) .eq. 1) then 
c            call getxyz()   ! read ZMAT Cartesian geometry into common 
c         else
c            call read_zmat_internal_coords()  ! read ICs from ZMAT.
c         endif
c
c         call mkvmol(q, ' ', natoms, nunique, zsym, iatnum, 
c     *               GenBy, scratch, istat, BasNam)
c         if (istat .ne. 0) then
c            print *,'@JODA_MAIN: MKVMOL returned istat = ',istat
c            call abort_job()
c         endif

c      geomopt=(iflags2(h_IFLAGS2_geom_opt).ne.0)
c      num_grad=(iflags2(h_IFLAGS2_grad_calc).eq.1)
c      fd = (iflags(h_IFLAGS_vib).eq.3.or.(geomopt.and.num_grad))

      call aces2_joda_main()

c   o finalize the job archive subsystem
c      call aces_ja_fin

      return
      end

c This routine prints a summary of all the records in the JOBARC file up to
c the next open slot.

      subroutine aces_ja_summary
      implicit none

c INTERNAL VARIABLES
      integer i
      logical bNotDone

c COMMON BLOCKS
#include "jobarc.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert job archive subsystem is up
      if (.not.bJAUp) then
         print *, '@ACES_JA_SUMMARY: Assertion failed.'
         print *, '   bJAUp = ',bJAUp
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

      print '(/)'
      print '(8x,64a)', ('-',i=1,64)
      print '(8x,21x,a22)', 'SUMMARY OF JOB ARCHIVE'
      print '(8x,64a)', ('-',i=1,64)
      print '(8x,a5,8x,3x,a4,3x,8x,a13,8x,a12)',
     &          'INDEX', 'NAME', 'ADDRESS (INT)', 'LENGTH (INT)'
      print '(8x,64a)', ('-',i=1,64)
      i = 1
      bNotDone = .true.
      do while (bNotDone)
      print '(8x,i5,8x,a1,a8,a1,8x,i13,8x,i12)',
     &           i, '"',marker(i),'"', rloc(i), rsize(i)
      if (iand(i,3).eq.0) print '(/)'
      bNotDone = ((marker(i).ne.'OPENSLOT').and.(i.le._MAX_JA_RECS))
      i = i+1
      end do
      print '(8x,64a)', ('-',i=1,64)
      print '(/)'

      return
c     end subroutine aces_ja_summary
      end

      SUBROUTINE EIG2(A,B,L,N,N1)
C
C Shell to drive Householder algorithm.  Slightly different from 
C EIG routine in that less memory is used.
C
C B - MATRIX TO BE DIAGONALIZED (EIGENVECTORS RETURNED)
C A - N by 2 SCRATCH VECTOR.  A(I,1) CONTAINS Ith EIGENVALUE ON RETURN
C L - not used
C N - SIZE OF MATRIX
C N1 - EIGENVECTORS AND EIGENVALUES ARE REORDERED, with eigenvalues:
c      1     -- unordered (currently ascending because eispack does it)
c      0     -- ascending
c      other -- descending
C 
CEND
c 91/10/1 DCC use eispack routines instead of numerical recipes
C
      integer l, n, n1
      double precision A(N,2),B(N,N)
c
      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
c
      integer i, j, mu, ierr
      double precision w1, w2
C
      IF(N.EQ.1)THEN
         A(1,1)=B(1,1)
         B(1,1)=1.0
         RETURN
      ENDIF
c
      CALL TRED2(N,N,B,A(1,1),A(1,2), b)
      CALL TQL2(N,N,A(1,1),A(1,2),B, ierr )
      if ( ierr .ne. 0 ) then
         write (6,*) 'eig:  eigenvalue not found -- ', ierr
         call errex
      endif
c
      IF(N1.EQ.1 .or. n1.eq.0 ) RETURN
c
      DO 20 I=1, n-1
      DO 20 J=I+1,N
         IF ( A(I,1) .lt. A(J,1) ) then
            W1=A(I,1)
            A(I,1)=A(J,1)
            A(J,1)=W1
            DO 10 MU=1,N
               W2=B(MU,I)
               B(MU,I)=B(MU,J)
               B(MU,J)=W2
 10         continue
         endif
 20   CONTINUE
c
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine make_free_block(node, server_table, nserver_table)
c-----------------------------------------------------------------------------
c   Produces a free block, doing a backup of a dirty block to disk if 
c   necessary.  If successful, the node's "c_msg_state" field is set to
c   "null_state", and the "c_msg_memptr" field points to the block.
c-----------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_stat.h'
      include 'dbugcom.h'

      integer nserver_table, node
      integer server_table(lserver_table_entry,nserver_table)
      integer iblock

c---------------------------------------------------------------------------
c   First, see if a clean block is already available.
c---------------------------------------------------------------------------

      call find_clean_block(iblock, server_table, nserver_table)
      if (iblock .le. 0) then

c----------------------------------------------------------------------------
c   All clean blocks are busy.  We must find a dirty block and back it up 
c   to disk.
c---------------------------------------------------------------------------

         call do_backup(iblock, server_table, nserver_table)
      endif

      if (iblock .gt. 0) then
         server_msg(c_msg_state,node)  = null_state
         server_msg(c_msg_memptr,node) = iblock
      endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine determine_timeslice(timeslice, timer_count)
c--------------------------------------------------------------------------
c   Returns system-dependent vallues for timeslice and timer_count 
c   arguments.
c--------------------------------------------------------------------------
      implicit none
      double precision timeslice
      integer timer_count
      integer itimeslice

#ifdef __crayx1
      itimeslice = 1000   ! 1000 microseconds
#else
      itimeslice = 500
#endif

#ifdef ALTIX
      timer_count = 1
#else
      timer_count = 10
#endif
      timeslice = itimeslice * 1.e-6   ! convert microseconds to seconds.
      return
      end

      Subroutine Get_flags(FlgACESElec, FlgACESGrad, FlgACESHess,
     &                     FlgACESForc)

      Implicit Double Precision(A-H, O-Z)
C  
      Logical FlgACESElec, FlgACESGrad, FlgACESHess, FlgACESForc
C
      Call Getrec(0,'JOBARC', 'TOTENERG', JLength, A2Ener)
      If (JLength .GT. 0) FlgACESElec = .TRUE.
      Call Getrec(0,'JOBARC', 'GRADIENT', JLength, VGrad)
      If (JLength .GT. 0) FlgACESGrad = .TRUE.
      Call Getrec(0,'JOBARC', 'CART_HES', JLength, VHess)
      If (JLength .GT. 0) FlgACESHess = .TRUE.
      Call Getrec(0, "JOBARC", 'FORCECON', JLength, Omega)
      If (JLength .GT. 0) FlgACESForc = .TRUE.

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c The Broyden-Fletcher-Goldfarb-Shanno update.

      SUBROUTINE BFGS(V,H,SCRATCH,STEP,TBT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "io_units.par"
#include "fnamelen.par"
#include "jodaflags.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION V(NXM6),H(NXM6*NXM6),SCRATCH(NX*NX),TBT(3*NXM6*NXM6),
     $          STEP(NXM6)

      N2=1+NXM6
      N3=1+2*NXM6
      N4=1+3*NXM6
      NX2=1+NXM6*NXM6
C
C SCRATCH(N2) = DG
C
      CALL VADD(SCRATCH(N2),V,SCRATCH(1),NXM6,-1.D0)
C
C TBT(1) =  [1/DG{dot}DX][DGxDG]
C
      CALL MODMATMUL(TBT(1),SCRATCH(N2),SCRATCH(N2),NXM6,1,NXM6,
     $               NXM6,1,NXM6)
      X0=1.D0/xdot(NXM6,SCRATCH(N2),1,STEP,1)
      CALL xscal(NXM6*NXM6,X0,TBT(1),1)
C
C SCRATCH(N3) = HDX, SCRATCH(N4) = DXH, TBT(NX2)= HDX{x}DXH
C
      CALL MODMATMUL(SCRATCH(N3),H,STEP,NXM6,NXM6,1,NXM6,NXM6,1)
      CALL MODMATMUL(SCRATCH(N4),STEP,H,1,NXM6,NXM6,1,NXM6,NXM6)
      CALL MODMATMUL(TBT(NX2),SCRATCH(N3),SCRATCH(N4),NXM6,1,NXM6,
     $               NXM6,1,NXM6)
C
C Z0 = 1/DXHDX, TBT(NX2) = [1/DXHDX][HDX{x}DXH]
C
      Z0=1.D0/xdot(NXM6,STEP,1,SCRATCH(N3),1)
      CALL xscal(NXM6*NXM6,Z0,TBT(NX2),1)
C
C H(updated) = H(old) + [1/DG{dot}DX][DGxDG] - [1/DXHDX][HDX{x}DXH]
C
      CALL VADD(TBT(1),TBT(1),TBT(NX2),NXM6*NXM6,-1.D0)
      CALL VADD(H,H,TBT(1),NXM6*NXM6,1.D0)
C
C DON'T WRITE ENTIRE HESSIAN UNLESS SPECIFICALLY REQUESTED.
C FOR NOW, JUST USE AN IN-CODE PARAMETER.
C
#ifdef _DEBUG_LVLM1
         Print*, "-----The BFGS updated Hessian-----"
         CALL HESSOUT(H,NXM6,NXM6,0)
#endif
      RETURN
      END

      SUBROUTINE MATMUL(A,B,C,NA,NB,NC,NTA,NTB,NTC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     Maximum number of atoms currently allowed
      PARAMETER (MXATMS = 100)
      DIMENSION B(NA,NB),C(NB,NC),A(NA,NC),SCRATCH(3*MxAtms,3*MxAtms)
      DO 10 I=1,NTA
      DO 10 J=1,NTC
      Z=0.D0
      DO 20 K=1,NTB
20    Z=Z+B(I,K)*C(K,J)
      SCRATCH(I,J)=Z
10    CONTINUE
      DO 15 I=1,NTA
      DO 15 J=1,NTC
15    A(I,J)=SCRATCH(I,J)
      RETURN
      END

      subroutine getstr(iunit,irewnd,ifound,zeile,stropt)
      implicit double precision (a-h,o-z)

c     --- scan through file connected to unit=iunit looking for 
c         a line containing string <stropt> 
c         note : comment lines (starting with '#') will be skipped !
c         irewnd>0  : rewind iunit
c         irewnd=0  : no rewind
c         irewnd<0  : search up to next buck (i.e. '$') including
c                     input string zeile !
c         ifound>0  : string has been found (index=ifound)
c         ifound=0  : string has not been found 
c         ifound=-1 : string has not been found since file is empty

      character*80 zeile
      character*(*) stropt
      integer iunit,ifound

      ifound=-1
      iread=0
      if(irewnd.gt.0) rewind iunit
      if(irewnd.lt.0) goto 101
  100 read(iunit,'(a)',end=900) zeile
      iread=iread+1
      if (zeile(1:4).eq.'$end') return
  101 call wisch(zeile,80)
      if(zeile(1:1).eq.' '.or.zeile(1:1).eq.'#') goto 100
      if(irewnd.lt.0.and.iread.gt.0.and.zeile(1:1).eq.'$') return
      ifound=index(zeile,stropt)
      if(ifound.eq.0) goto 100
      return

  900 continue
      return

      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_PREPARE_CTR
     +
     +                    ( NCSIZE,
     +                      NIJ,
     +                      NPGTOA,NPGTOB,
     +                      SHELLA,SHELLB,
     +                      ALPHAA,ALPHAB,
     +                      PREFACT,SPNORM,
     +                      EQUALAB,
     +                      BLOCKED,
     +                      RHO,
     +
     +                              NORMA,NORMB,
     +                              RHOAB,
     +                              CBATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_PREPARE_CTR
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine prepares for contracting the nuclear
C                attraction primitive batches. Everything that needs
C                still to be done at the stage when calling this
C                routine should be placed here. At the moment, we have
C                the following:
C
C                       i) copy the exponential prefactors
C                      ii) generate all the A and B norms
C                     iii) add the contribution due to the
C                          overall integral prefactor and the
C                          s-/p-shell type norm into one of
C                          the A or B norms, depending on
C                          which has the least elements
C                      iv) initialize the nuclear attraction
C                          contraction batch
C
C
C                  Input:
C
C                    NCSIZE       =  size of the contraction batch
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NCEN         =  # of ij nuclear attraction centers
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    SHELLx       =  the shell types for contraction
C                                    shells x = A,B
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    PREFACT      =  overall prefactor for all integrals
C                    SPNORM       =  normalization factor due to
C                                    presence of s- and p-type shells.
C                                    For each s-type shell there is a
C                                    factor of 1 and for each p-type
C                                    shell a factor of 2
C                    EQUALAB      =  indicates, if csh A and csh A are
C                                    considered to be equal
C                    BLOCKED      =  if false, there will be no need
C                                    to block the contraction step over
C                                    the set of primitives and thus as
C                                    a consequence there is no need to
C                                    initialize the contraction batch
C                    RHO          =  NIJ exponential prefactors rho(a,b)
C
C                  Output:
C
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    CBATCH       =  contraction batch initialized
C                                    to zero (if needed)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         LOGICAL    BLOCKED
         LOGICAL    EQUALAB

         INTEGER    N
         INTEGER    NCSIZE
         INTEGER    NIJ
         INTEGER    NPGTOA,NPGTOB
         INTEGER    SHELLA,SHELLB

         DOUBLE PRECISION   FACTOR
         DOUBLE PRECISION   POWER
         DOUBLE PRECISION   PREFACT,SPNORM
         DOUBLE PRECISION   ZERO,HALF,ZP75

         DOUBLE PRECISION   CBATCH (1:NCSIZE)
         DOUBLE PRECISION   ALPHAA (1:NPGTOA)
         DOUBLE PRECISION   ALPHAB (1:NPGTOB)
         DOUBLE PRECISION   NORMA  (1:NPGTOA)
         DOUBLE PRECISION   NORMB  (1:NPGTOB)
         DOUBLE PRECISION   RHO    (1:NIJ)
         DOUBLE PRECISION   RHOAB  (1:NIJ)
         double precision   rho_temp(1:nij)

         PARAMETER   (ZERO = 0.D0)
         PARAMETER   (HALF = 0.5D0)
         PARAMETER   (ZP75 = 0.75D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...copy the exponential prefactors. This has to be
C                done with care, as the memory location for the
C                final RHOAB array might overlap with the input RHO
C                array. The following diagram shows how such overlap
C                might happen:
C
C                       RHO  ->  |  NIJ  |
C                                 \       \
C                                  \       \
C                                   | RHOAB |
C
C                We are always safe, if we start copying from the
C                last element of RHO downwards.
C
C
c         DO N = NIJ,1,-1
c            RHOAB (N) = RHO (N)
c         END DO

          do n = 1, nij
             rho_temp(n) = rho(n)
          enddo
#ifndef ERDFIX
          do n = 1, nij
             rhoab(n) = rho_temp(n)
          enddo
#endif

C
C
C             ...calculate the A and B norms.
C
C
         POWER = DFLOAT (SHELLA) * HALF + ZP75
         IF (EQUALAB) THEN
             DO N = 1,NPGTOA
                NORMA (N) = ALPHAA (N) ** POWER
                NORMB (N) = NORMA (N)
             END DO
         ELSE
             DO N = 1,NPGTOA
                NORMA (N) = ALPHAA (N) ** POWER
             END DO
             POWER = DFLOAT (SHELLB) * HALF + ZP75
             DO N = 1,NPGTOB
                NORMB (N) = ALPHAB (N) ** POWER
             END DO
         END IF
C
C
C             ...rescale one of the A or B norms, which has the
C                least number of elements.
C
C
         FACTOR = PREFACT * SPNORM

         IF (NPGTOA.LE.NPGTOB) THEN
             DO N = 1,NPGTOA
                NORMA (N) = FACTOR * NORMA (N)
             END DO
         ELSE
             DO N = 1,NPGTOB
                NORMB (N) = FACTOR * NORMB (N)
             END DO
         END IF
C
C
C             ...initialize contraction batch (if necessary).
C
C
         IF (BLOCKED) THEN
             DO N = 1,NCSIZE
                CBATCH (N) = ZERO
             END DO
         END IF
C
C
C             ...ready!
C
C
#ifdef ERDFIX
          do n = 1, nij
             rhoab(n) = rho_temp(n)
          enddo
#endif
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__OPTIMUM_ATOM_INDEX_ORDER
     +
     +                    ( NATOM,N2CEN,
     +                      INDEX,
     +                      AT2CEN,
     +
     +                             ATORD )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__OPTIMUM_ATOM_INDEX_ORDER
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : Given a set of ordered atomic pair (2 center) indices,
C                this routine extracts an optimum atomic index sequence
C                via the following algorithm:
C
C                    1) Take first index pair I,J and start the
C                       atomic index sequence with I.
C
C                    2) Go through the index pair list from the
C                       beginning to the end, adding all atomic
C                       indices {K} in that order, that contain
C                       atom I in all index pairs {I,K}.
C
C                    3) Take second element I of already established
C                       partial atomic index sequence and repeat
C                       step 2). Then take third element I, etc...
C
C                Observe, that isolated sequences of atoms (i.e. not
C                bonded) might occur in cases the program deals
C                with a molecule composed of well separated fragments.
C                Also if the set of all index pairs does not contain
C                all atom indices, the atomic index sequence will be
C                completed by those missing.
C
C                A special case arises, if no index pairs were found
C                from the bond order matrix. This indicates a isolated
C                atom or a set of well separated atoms. In both these
C                cases we have N2CEN = 0 and no info is sitting in
C                array AT2CEN. Thus the case N2CEN = 0 has to be dealt
C                with separately.
C
C                  Input:
C
C                    NATOM        =  total # of atoms
C                    N2CEN        =  # of ordered atomic index pairs
C                                    that will be considered for
C                                    optimum atomic index sequence
C                                    construction.
C                    INDEX        =  will hold info about used atoms
C                    AT2CEN (1,N) =  1st atomic index of N-th ordered
C                                    pair.
C                    AT2CEN (2,N) =  2nd atomic index of N-th ordered
C                                    pair.
C
C
C                  Output:
C
C                    ATORD (I)    =  I-th atomic index in sequence.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     CASE1,CASE2
         LOGICAL     CHECK
         LOGICAL     IGNORE

         INTEGER     AT1,AT2
         INTEGER     ATNEW
         INTEGER     ATOM
         INTEGER     I,J,M
         INTEGER     IDX
         INTEGER     N2CEN
         INTEGER     NATOM
         INTEGER     USED,NOTUSED

         INTEGER     ATORD (1:NATOM)
         INTEGER     INDEX (1:NATOM)

         INTEGER     AT2CEN (1:2,1:N2CEN)
C
C
C------------------------------------------------------------------------
C
C
C             ...handle special case of isolated atom(s) only.
C                This requires straightforward consecutive indexing.
C
C
         IF (N2CEN.EQ.0) THEN
             DO ATOM = 1,NATOM
                ATORD (ATOM) = ATOM
             END DO
             RETURN
         END IF
C
C
C             ...initialize used atoms index array.
C
C
         USED = 1
         NOTUSED = 0

         DO ATOM = 1,NATOM
            INDEX (ATOM) = NOTUSED
         END DO
C
C
C             ...initialize atom index list.
C
C
         M = 1
         IDX = 1
         ATOM = AT2CEN (1,1)
         ATORD (1) = ATOM
         INDEX (ATOM) = USED
C
C
C             ...check presence of atom ATOM in the set of ordered
C                index pairs and add the new atoms to the atom index
C                list.
C
C
 1000    DO I = 1,N2CEN
            AT1 = AT2CEN (1,I)
            AT2 = AT2CEN (2,I)
            CASE1 = AT1 .EQ. ATOM
            CASE2 = AT2 .EQ. ATOM
            CHECK = CASE1 .OR. CASE2

            IF (CHECK) THEN
                IF (CASE1) THEN
                    ATNEW = AT2
                ELSE
                    ATNEW = AT1
                END IF

                IGNORE = .FALSE.
                DO J = 1,M
                   IGNORE = IGNORE .OR. (ATORD (J).EQ.ATNEW)
                END DO

                IF (.NOT.IGNORE) THEN
                    M = M + 1
                    ATORD (M) = ATNEW
                    INDEX (ATNEW) = USED
                END IF
            END IF
         END DO

         IDX = IDX + 1
         IF (IDX.LE.M) THEN
C
C
C             ...more atoms are present in current atom index list
C                ready for checking. Pick the next in line and go
C                back.
C
C
             ATOM = ATORD (IDX)
             GOTO 1000
         ELSE
C
C
C             ...all atoms in current atom index list have been
C                checked. Check next, if still atoms need to be
C                added to this list corresponding to untreated
C                index pairs. If so, take next available atom and
C                go back to the checking procedure.
C
C
             DO I = 1,N2CEN
                AT1 = AT2CEN (1,I)
                AT2 = AT2CEN (2,I)
                CASE1 = INDEX (AT1) .EQ. NOTUSED
                CASE2 = INDEX (AT2) .EQ. NOTUSED
                CHECK = CASE1 .OR. CASE2

                IF (CHECK) THEN
                    IF (CASE1) THEN
                        ATOM = AT1
                    ELSE
                        ATOM = AT2
                    END IF
                    M = IDX
                    ATORD (IDX) = ATOM
                    INDEX (ATOM) = USED
                    GOTO 1000
                END IF
             END DO
C
C
C             ...we get here if all atoms of all index pairs
C                have been ordered. There might be still atoms
C                which are not bonded to any of the rest and
C                which still must be added to the atom index list
C                in order to complete it.
C
C
             DO ATOM = 1,NATOM
                IF (INDEX (ATOM).EQ.NOTUSED) THEN
                    M = M + 1
                    ATORD (M) = ATOM
                END IF
             END DO
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE GTAO(IFLG,IFLG2,NATOMS,NBAS,NBASP,NTANGM,ICNTR,
     $     COEFF,COEFFN,NANGMOM,NMOMAO,NAOATM,IPRINT,XNOCOEFF,INORBS,
     $     COEFFTEMP)
c     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION COEFF(NBAS*NBASP),COEFFN(NBAS*NBASP),ICNTR(NBAS),
     $     NANGMOM(NATOMS),NMOMAO(NATOMS*NTANGM),
     $     NAOATM(NATOMS)
      DIMENSION XNOCOEFF(NBASP*NBASP)
      DIMENSION COEFFTEMP(NBAS*NBASP)
C     
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /IPAR/ LUOUT
C     
      NBAS2=NBAS*NBASP
C     
      IF (INORBS.EQ.0) THEN
C     
         IF (IFLG.EQ.0) THEN
C Get list of centers to which atomic orbitals belong
C     
            CALL GETREC(20,'JOBARC','CNTERBF0',NBAS,ICNTR)
C     
C     Get the matrix of alpha MO's in terms of AO's.
            CALL GETREC(20,'JOBARC','EVECAO_A',IINTFP*NBAS2,COEFF)
C
         ELSE
C     Get the matrix of beta MO's in terms of AO's.
            CALL GETREC(20,'JOBARC','EVECAO_B',IINTFP*NBAS2,COEFF)
C     
         ENDIF
C     
      ELSE
C     
         IF(IFLG.EQ.0) THEN
C     Get list of centers to which atomic orbitals belong
C
            CALL GETREC(20,'JOBARC','CNTERBF0',NBAS,ICNTR)
C     
C     Get the matrix of alpha MO's in terms of AO's. and save temporarily
            CALL GETREC(20,'JOBARC','EVECAO_A',IINTFP*NBAS2,COEFFTEMP)
C     
         ELSE
C Get the matrix of beta MO's in terms of AO's. and save temporarily
            CALL GETREC(20,'JOBARC','EVECAO_B',IINTFP*NBAS2,COEFFTEMP)
C     
         ENDIF
C     Now transform the NOs from the MO to the AO basis
         CALL XGEMM('N','N',NBAS,NBASP,NBASP,1.0D+00,COEFFTEMP,NBAS,
     $        XNOCOEFF,NBASP,0.0D+00,COEFF,NBAS)
      END IF
C
C     Put higher angular momentum vectors in correct order
      ICNT=1
      IATMOFF=0
      DO 110 IATM=1,NATOMS
         DO 120 IANGMOM=1,NANGMOM(IATM)
            NCNT=1
            DO 125 IMOMAO=1,NMOMAO((IATM-1)*NTANGM+IANGMOM)
               IF(IANGMOM.EQ.1)THEN
                  DO 130 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=COEFF((IMO-1)*NBAS+ICNT)
 130              CONTINUE
               ENDIF
               IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)
               IF(IANGMOM.EQ.2)THEN
                  DO 141 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*3+IOFF+1)
 141              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.3)THEN
                  DO 142 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*3+IOFF+2)
 142              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.4)THEN
                  DO 143 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*3+IOFF+3)
 143              CONTINUE
               ENDIF
               IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)+
     $              3*NMOMAO((IATM-1)*NTANGM+2)
               IF(IANGMOM.EQ.5)THEN
                  DO 151 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+1)
 151              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.6)THEN
                  DO 152 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+2)
 152              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.7)THEN
                  DO 153 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+3)
 153              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.8)THEN
                  DO 154 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+4)
 154              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.9)THEN
                  DO 155 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+5)
 155              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.1)THEN
                  DO 156 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*6+IOFF+6)
 156              CONTINUE
               ENDIF
               IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)+
     $              3*NMOMAO((IATM-1)*NTANGM+2)+
     $              6*NMOMAO((IATM-1)*NTANGM+5)
               IF(IANGMOM.EQ.11)THEN
                  DO 160 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+1)
 160              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.12)THEN
                  DO 161 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+2)
 161              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.13)THEN
                  DO 162 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+3)
 162              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.14)THEN
                  DO 163 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+4)
 163              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.15)THEN
                  DO 164 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+5)
 164              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.16)THEN
                  DO 165 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+6)
 165              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.17)THEN
                  DO 166 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+7)
 166              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.18)THEN
                  DO 167 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+8)
 167              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.19)THEN
                  DO 168 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+9)
 168              CONTINUE
               ENDIF
               IF(IANGMOM.EQ.2)THEN
                  DO 169 IMO=1,NBASP
                     COEFFN((IMO-1)*NBAS+ICNT)=
     $                    COEFF((IMO-1)*NBAS+(NCNT-1)*10+IOFF+10)
 169              CONTINUE
               ENDIF
C     Offset for g functions
C     IOFF=IATMOFF+NMOMAO((IATM-1)*NTANGM+1)+
C     & 3*NMOMAO((IATM-1)*NTANGM+2)+
C     6*NMOMAO((IATM-1)*NTANGM+5)+
C     1*NMOMAO((IATM-1)*NTANGM+11)
C     
               ICNT=ICNT+1
               NCNT=NCNT+1
 125        CONTINUE
 120     CONTINUE
         IATMOFF=IATMOFF+NAOATM(IATM)
 110  CONTINUE
C     
C     Write the MO's to output in groups of four.
      IF (IPRINT.EQ.1) THEN
C     
         WRITE(LUOUT,1010)
 1010    FORMAT(/' OCCUPIED MOLECULAR ORBITALS')
C     
         IF(IFLG2.EQ.0)THEN
            WRITE(LUOUT,1020)
 1020       FORMAT(/'                  ******* ALPHA BLOCK *******')
         ELSE
            WRITE(LUOUT,1025)
 1025       FORMAT(/'                  ******** BETA BLOCK *******')
         ENDIF
C     
         INBASP=NBASP/4
         DO 30 ICNT=1,INBASP
            IB=4*(ICNT-1)
            IE=4*(ICNT-1)+3
            WRITE(LUOUT,1030) (K,K=IB+1,IE+1)
            DO 30 J=1,NBAS
               WRITE(LUOUT,1040) ICNTR(J),(COEFFN(I*NBAS+J),I=IB,IE)
 30      CONTINUE
         IF(INBASP*4.NE.NBASP)THEN
            KNBASP=INBASP*4
            JNBASP=NBASP-KNBASP
            IF(JNBASP.EQ.1) WRITE(LUOUT,1031) (K,K=KNBASP+1,NBASP)
            IF(JNBASP.EQ.2) WRITE(LUOUT,1032) (K,K=KNBASP+1,NBASP)
            IF(JNBASP.EQ.3) WRITE(LUOUT,1033) (K,K=KNBASP+1,NBASP)
            DO 40 J=1,NBAS
               WRITE(LUOUT,1040) ICNTR(J),(COEFFN(I*NBAS+J),I=KNBASP,
     $              NBASP-1)
 40         CONTINUE
         ENDIF
C     
      ENDIF
C     
 1030 FORMAT(/'CENTER',6X,'MO',I4,8X,'MO',I4,8X,'MO',I4,8X,'MO',I4)
 1031 FORMAT(/'CENTER',6X,'MO',I4)
 1032 FORMAT(/'CENTER',6X,'MO',I4,8X,'MO',I4)
 1033 FORMAT(/'CENTER',6X,'MO',I4,8X,'MO',I4,8X,'MO',I4)
 1040 FORMAT(I4,4F14.5)
C     
C     DO 50 IIIII=1,20
C     WRITE(*,*) COEFFN(IIIII)
C     50 END DO
C     
      RETURN
      END
      
      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork1211(y,na1,na2,a1,a2,inda,
     *                     x1,nd1,nd2,ne1,ne2,
     *                     d1,d2,e1,e2, indx1,
     *                     x2,ni1,ni2,
     *                     i1,i2,indi, 
     *                     scr1, scr2,flopcount) 
c-------------------------------------------------------------------------
c   Performs a "1211" contraction: 
c      1 index output array  --> y 
c      2 index operand array --> x1 
c      1 index operand array --> x2 
c      1 index contraction.
c
c   I. e., contract the 2 indices of the 2nd operand array out of the 
c   first operand array into the 2-index output array.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'

      character*1 char(5)  
      character*2 char2a, char2b   
      character*5 char5 

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,ne1,ne2,nf1,nf2,
     *        ni1,ni2,nj1,nj2
      integer a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2,i1,i2,j1,j2
      integer inda, indb, indc, indx1(2), indi, indj, h(3), perm(5) 
      integer flopcount

      double precision y(na1:na2)
      double precision x1(nd1:nd2,ne1:ne2)
      double precision x2(ni1:ni2)
      double precision scr1(*), scr2(*), x  

      integer ia, ib, ii, ij, ix(2)
      integer i, j, a, b, c, d, e, f 
#ifdef __crayx1
      integer*8 ncount, m, n, k, lda, ldb, ldc 
#else
      integer ncount, m, n, k, lda, ldb, ldc 
#endif

      logical check
      check = .false.

c      write(6,*) ' Entering cwork1211 ', inda, indx1(1), indx1(2)  

        do d=nd1,nd2
        y(d) = 0.d0
        enddo 


      if (indx1(1) .eq. inda) then 
         do e = ne1, ne2  
         do d = nd1, nd2  
            y(d) = y(d) + x1(d,e)*x2(e) 
         enddo 
         enddo 
      endif 

      if (indx1(2) .eq. inda) then 
         do d = nd1, nd2  
         do e = ne1, ne2  
            y(d) = y(d) + x1(e,d)*x2(e) 
         enddo 
         enddo 
      endif 

      return
      end

c This routine resets the automatic cache data. It DOES NOT write-back
c any modified slots.

      subroutine aces_cache_reset
      implicit none

c INTERNAL VARIABLES
      integer i

c COMMON BLOCKS
#include "cache.com"

c ----------------------------------------------------------------------

c   o make sure the cache subsystem is up
      if (.not.bCacheUp) return

c   o zero the cached addresses
      do i = 1, cachnum
         cachrec(i) = 0
      end do

c   o zero the LUNs
      do i = 1, cachnum
         cachfil(i) = 0
      end do

c   o reset the modification flags
      do i = 1, cachnum
         cachmod(i) = 0
      end do

c   o reset the cache event counter
      cachetime = 0

c   o zero the LRU statistics
      do i = 1, cachnum
         lrustats(i) = 0
      end do

      return
c     end subroutine aces_cache_reset
      end

c This routine resets the automatic cache data. It DOES NOT write-back
c any modified slots.

      subroutine aces_cache_reset
      implicit none

c INTERNAL VARIABLES
      integer i

c COMMON BLOCKS
c cache.com : begin

c These common blocks contain global information about the automatic file cache.
c getlst and putlst REQUIRE a cache, hence the term 'automatic' (compared to the
c auxiliary cache controlled by /auxcache/quikget).

c#define _CACHE_BYPASS /* bypasses cache on reading/writing of full records */
c#define _CACHE_HIST
c#define _CACHE_HIST_VERBOSE

      external aces_bd_cache

c icache     : the anchor used to address each cache slot
c cachnum    : the number of usable cache slots
c cachrec(i) : the index of the physical record cached by the data in slot i
c cachfil(i) : the external file unit number that stores the data in slot i
c cachndx(i) : the icache index of slot i
c cachmod(i) : a modification flag used to trigger a writeback

c cachetime   : a cache-event counter
c lrustats(i) : the last 'time' slot i was accessed

      integer        icache(1), cachnum,
     &               cachrec(128),
     &               cachfil(128),
     &               cachndx(128),
     &               cachmod(128)
      common /cache/ icache, cachnum,
     &               cachrec,
     &               cachfil,
     &               cachndx,
     &               cachmod
      save   /cache/

      integer           cachetime, lrustats(128)
      common /cachelru/ cachetime, lrustats
      save   /cachelru/

c cachemiss      : measures cache misses
c cacheskip      : measures read and write bypasses
c cacheread      : measures read hits
c cachewrite     : measures write hits
c cachewriteback : measures writes-back of dirty slots

      integer             cachemiss, cacheskip,
     &                    cacheread, cachewrite, cachewriteback
      common /cache_hist/ cachemiss, cacheskip,
     &                    cacheread, cachewrite, cachewriteback
      save   /cache_hist/

c bCacheUp : a flag for bombing in get/putlst if there is no I/O cache

      logical              bCacheUp
      common /cache_flags/ bCacheUp
      save   /cache_flags/

c cache.com : end

c ----------------------------------------------------------------------

c   o make sure the cache subsystem is up
      if (.not.bCacheUp) return

c   o zero the cached addresses
      do i = 1, cachnum
         cachrec(i) = 0
      end do

c   o zero the LUNs
      do i = 1, cachnum
         cachfil(i) = 0
      end do

c   o reset the modification flags
      do i = 1, cachnum
         cachmod(i) = 0
      end do

c   o reset the cache event counter
      cachetime = 0

c   o zero the LRU statistics
      do i = 1, cachnum
         lrustats(i) = 0
      end do

      return
c     end subroutine aces_cache_reset
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sial_compile_and_send_tables()
c----------------------------------------------------------------------------
c   This subroutine does the following:
c   Master:   
c      1. Compiles the SIAL programs used for each company.
c      2. Sends the descriptions of the compiled tables to each processor 
c         in the company.
c      3. Sends the relevant tables to each processor in the company.
c
c   Worker:
c      1. Receives the table description from the master.
c      2. Creates the tables.
c      3. Receives the table data from the master.
c----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'company.h'
      include 'int_gen_parms.h'
      include 'proto_defines.h'
      include 'sip_tables.h'
      include 'interpreter.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer create_index_table
      integer create_array_table
      integer create_optable

      integer master
      integer me, nprocs, ierr

      integer company_comm, target_company
      integer company_rank, rank
      integer i, j, n
      integer interpretface, str_trimlen
      integer pst_get_company
      integer pst_get_company_comm
      integer pst_get_company_rank
      integer msg(4)
      integer*8 ind, get_index_from_base
      integer ix(1)
      double precision x(1) 
#ifdef ALTIX
      pointer (iptr, ix)
      pointer (dptr, x)
#endif

      character*80 sial_file

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      company_comm = pst_get_company_comm(me)
      company_rank = pst_get_company_rank(me)
      target_company = pst_get_company(me)
      if (target_company .eq. io_company_id) return  ! this is a  server

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

c--------------------------------------------------------------------------
c   Find the master of this company (company_rank = 0).
c--------------------------------------------------------------------------

      do i = 1, nprocs
         if (pst_get_company(i-1) .eq. target_company) then
            rank = pst_get_company_rank(i-1)
            if (rank .eq. 0) then
               master = i-1
               go to 50
            endif
         endif
      enddo
   50 continue

      call load_pre_defined_routines()

      if (master .eq. me) then

c---------------------------------------------------------------------------
c   Compile the SIAL code (or read an object file) for this company.
c---------------------------------------------------------------------------

        sial_file = company_sial_prog(i)
        if (sial_file(1:1) .eq. ' ') go to 100 ! no program

        n = str_trimlen(sial_file)
        if (sial_file(n-3:n) .eq. '.sio') then
           call read_tables(sial_file(1:n) // char(0))
        else if (sial_file(n-4:n) .eq. '.sial') then
            print *,'Error: Cannot use .sial files.'
            call abort_job()
c           ierr = interpretface(sial_file(1:n) // char(0) )
c           if (ierr .ne. 0) then
c              print *,'Error: SIAL compile errors.'
c              call abort_job()
c           endif
        else
           print *,'Error: Invalid file format for SIAL program.'
           print *,'File extension must be .sial or .sio'
           print *,'SIAL_FILE = ',sial_file(1:n)
           call abort_job()
        endif

         msg(1) = nindex_table_sip
         msg(2) = narray_table_sip
         msg(3) = noptable_sip
         msg(4) = nscalar_table_sip
         call mpi_bcast(msg, 4, MPI_INTEGER, 0,
     *               company_comm, ierr)
      else
         call mpi_bcast(msg, 4, MPI_INTEGER, 0,
     *               company_comm, ierr)

c------------------------------------------------------------------------------
c   Allocate memory in which to recv the tables.
c-----------------------------------------------------------------------------

         ierr = create_index_table(msg(1))
         if (ierr .ne. 0) then
            print *,'Task ',me,' Error: Cannot create index_table, ',
     *           'nindex_table = ',msg(1)
            call c_exit(1)
         endif

         ierr = create_array_table(msg(2))
         if (ierr .ne. 0) then
            print *,'Task ',me,' Error: Cannot create array_table, ',
     *           'narray_table = ',msg(2)
            call c_exit(1)
         endif

         ierr = create_optable(msg(3))
         if (ierr .ne. 0) then
            print *,'Task ',me,' Error: Cannot create optable, ',
     *           'narray_table = ',msg(3)
            call c_exit(1)
         endif

         nindex_table_sip = msg(1)
         narray_table_sip = msg(2)
         noptable_sip     = msg(3)
         nscalar_table_sip = msg(4)  
      endif      ! master .eq. me

c-----------------------------------------------------------------------------
c   Broadcast the 4 tables.
c   Index table:
c----------------------------------------------------------------------------

      n = nindex_table_sip*lindex_table_entry
      ind = get_index_from_base(index_table_base, ix, 1)
      call mpi_bcast(ix(ind), n, MPI_INTEGER, 0, company_comm, ierr)

c---------------------------------------------------------------------------
c   Array table
c---------------------------------------------------------------------------

      n = narray_table_sip*larray_table_entry
      ind = get_index_from_base(array_table_base, ix, 1)
      call mpi_bcast(ix(ind), n, MPI_INTEGER, 0, company_comm, ierr)
      
c---------------------------------------------------------------------------
c   Operation table
c---------------------------------------------------------------------------

      n = noptable_sip*loptable_entry
      ind = get_index_from_base(optable_base, ix, 1)
      call mpi_bcast(ix(ind), n, MPI_INTEGER, 0, company_comm, ierr)
      
c---------------------------------------------------------------------------
c   Scalar table
c---------------------------------------------------------------------------

      n = nscalar_table_sip
      ind = get_index_from_base(scalar_table_base, x, 2)
      call mpi_bcast(x(ind), n, MPI_DOUBLE_PRECISION, 0, 
     *                company_comm, ierr)
      

  100 continue   

      return
      end

      SUBROUTINE GENNBO_GENFILE(NATOMS,NBAS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end











      DIMENSION COORD(3,Mxatms),NUCCHG(Mxatms),OVLAP(MAXBASFN*MAXBASFN)
      CHARACTER*80 FNAME
      CHARACTER*4 ATMLBL(MAXBASFN),LABEL(10),ANGLBL(MAXBASFN)
      INTEGER CENTERBF(MAXBASFN)

      DATA LABEL/'S','X','Y','Z','XX','YY','ZZ','XY','XZ','YZ'/

      OPEN(UNIT=47,FILE='FILE47')

      WRITE(47,*)'$GENNBO'
      WRITE(47,'(T2,A,I3)')'NATOMS=',NATOMS
      WRITE(47,'(T2,A,I3)')'NBAS=',NBAS
      WRITE(47,*)'BODM'
      WRITE(47,*)'BOHR'
      WRITE(47,*)'$END'
      WRITE(47,*)
      WRITE(47,*)'$NBO'
      WRITE(47,*)'PRINT=4'
      WRITE(47,*)'NLMO'
      WRITE(47,*)'$END'
      WRITE(47,*)


      WRITE(47,*)'$COORD'
      WRITE(47,*)'NATURAL ORBITAL ANALYSIS USING ACES2 INFORMATION'
      CALL GETREC(-1,'JOBARC','COORD',3*NATOMS,COORD)
      CALL GETREC(-1,'JOBARC','ATOMCHRG',NATOMS,NUCCHG)

      DO I = 1, NATOMS
         WRITE(47,*)NUCCHG(I),NUCCHG(I),COORD(1,I),COORD(2,I),COORD(3,I)
      END DO
      WRITE(47,*)'$END'


      CALL GETREC(-1,'JOBARC','CENTERBF',NBAS,CENTERBF)
      WRITE(47,*)
      WRITE(47,*)'$BASIS'
      WRITE(47,*)'CENTER ='

      DO I = 1, NBAS
         WRITE(47,*)CENTERBF(I)
      END DO

      CALL GFNAME('IIII',FNAME,ILENGTH)
      OPEN(UNIT=10,FILE='IIII',FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      CALL LOCATE(10,'LABBASIS')

      DO I = 1, NBAS
         READ(10)J,ATMLBL(I),ANGLBL(I),IJUNK
      END DO

      WRITE(47,*)
      WRITE(47,*)'LABEL ='
      IDTYPE=0

      DO I = 1, NBAS
         IF(ANGLBL(I).EQ.LABEL(1))THEN
            WRITE(47,*)'1'
         ELSE IF(ANGLBL(I).EQ.LABEL(2))THEN
            WRITE(47,*)'101'
         ELSE IF(ANGLBL(I).EQ.LABEL(3))THEN
            WRITE(47,*)'102'
         ELSE IF(ANGLBL(I).EQ.LABEL(4))THEN
            WRITE(47,*)'103'
         ELSE IF(ANGLBL(I).EQ.LABEL(5))THEN
            WRITE(47,*)'201'
            IDTYPE=IDTYPE+1
         ELSE IF(ANGLBL(I).EQ.LABEL(6))THEN
            WRITE(47,*)'204'
            IDTYPE=IDTYPE+1
         ELSE IF(ANGLBL(I).EQ.LABEL(7))THEN
            WRITE(47,*)'206'
            IDTYPE=IDTYPE+1
         ELSE IF(ANGLBL(I).EQ.LABEL(8))THEN
            WRITE(47,*)'202'
         ELSE IF(ANGLBL(I).EQ.LABEL(9))THEN
            WRITE(47,*)'203'
         ELSE IF(ANGLBL(I).EQ.LABEL(10))THEN
            WRITE(47,*)'205'
         END IF
      END DO
      WRITE(47,*)'$END'
      WRITE(*,*)'there are',IDTYPE,'D ORBITALS'
      WRITE(47,*)


c     The contract datalist is not necessary since it is used only for plotting data.



      CALL GETREC(-1,'JOBARC','AOOVRLAP',NBAS*NBAS,OVLAP)
      WRITE(47,*)'$OVERLAP'
      WRITE(47,*)OVLAP
      WRITE(47,*)'$END'


      CALL GETREC(-1,'JOBARC','SCFDENSA',NBAS*NBAS,OVLAP)
      WRITE(47,*)
      WRITE(47,*)'$DENSITY'
      WRITE(47,*)OVLAP
      WRITE(47,*)'$END'

      CALL GETREC(-1,'JOBARC','FOCKA',NBAS*NBAS,OVLAP)
      WRITE(47,*)
      WRITE(47,*)'$FOCK'
      WRITE(47,*)OVLAP
      WRITE(47,*)'$END'

      CALL GETREC(-1,'JOBARC','SCFEVCA0',NBAS*NBAS,OVLAP)
      WRITE(47,*)
      WRITE(47,*)'$LCAOMO'
      WRITE(47,*)OVLAP
      WRITE(47,*)'$END'


      CLOSE(47)

      RETURN
      END

      SUBROUTINE DOMORSEXYZ_RIC(SCRATCH, NOPT, NX, LUOUT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      INTEGER TOTREDNCO, TOTNOFBND
      LOGICAL BONDED
C     Maximum number of atoms currently allowed
#include "mxatms.par"
C
      DIMENSION IBNDTO(MXATMS*MXATMS), IREDUNCO(4, MAXREDUNCO) 
      DIMENSION SCRATCH(NX*NX)
      LOGICAL I_UNIQUE(MAXREDUNCO)
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C 
      CALL GETREC(20, 'JOBARC', 'IBONDTO ', NATOMS*NATOMS, IBNDTO)
      CALL GETREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)
      CALL GETREC(20, 'JOBARC', 'UNIQUEDF', TOTREDNCO, I_UNIQUE)
      CALL GETREC(20, 'JOBARC', 'CONTEVIT', 4*TOTREDNCO, IREDUNCO)
C
      DO IOPT = 1,  NOPT
C
         IATM = IREDUNCO(1, IOPT)
         JATM = IREDUNCO(2, IOPT)
         KATM = IREDUNCO(3, IOPT)
C
         IF (I_UNIQUE(IOPT) .AND. KATM .EQ. 0) THEN
C
            NA = IATNUM(IATM)
            NB = IATNUM(JATM)
C
            CALL MORSEA(NA, NB, A)
C     
            IF(A.EQ.0.D0)THEN
               WRITE(LUOUT,1474)ZSYM(IATM),ZSYM(IATM)
 1474          FORMAT(T3,'@EFOL-I, No Morse constant available',
     &                'for ',A5, '-',A5,'.  Default used.')
            ENDIF
C
C Scale factor calculated from internal coordinates (not
C symmetry coordinate increment)
C
            Z = SCRATCH(NOPT + IOPT)/
     &          DSQRT(DFLOAT(NEQ(NOPTI(IOPT)) + 1))
C
            IF (DABS(Z) .GT. 0.75D0) THEN
               WRITE(LUOUT, 7208) VARNAM(IOPT)
 7208          FORMAT(T3,' NR step for ',A5,' too large.  MANR ',
     &                'scaling not done.')
            ELSE
               CORR = 1.D0 + 1.5D0*A*Z+2.3333333D0*(A*Z)**2
               WRITE(LUOUT, 7201)CORR,VARNAM(IOPT)
 7201          FORMAT(T3,' MANR scale factor for NR step is ',
     &                F5.3,' for ', A5,'.')
               SCRATCH(NOPT + IOPT) = SCRATCH(NOPT + IOPT)*CORR
            ENDIF
C     
         ENDIF
C
      ENDDO 
C
      RETURN
      END

      SUBROUTINE PRIM(NATOMS,IUATMS,ITFCT,NBAS,LNP1,LNPO,NTANGM,
     &   NPOP,NFCT,NANGMOM,NMOMFCT,NMOMAO,IMEMB,NANGMOMSHL, 
     &   NPRIMFUNSHL,NCONFUNSHL,NCONFUNTSHL,NMBERSHL,ISHL2CNTR_MAP,
     &   NPRMFUNTSHL,ALPHA,PCOEFF,NAOATM,SALPHA,SPCOEF,MAXSHELL,
     &   ISHL,MAXANG)
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      CHARACTER*80 XLINE
      CHARACTER*4 ATMNAM
C     
      DIMENSION NPOP(IUATMS),IMEMB(NATOMS),NFCT(NATOMS),
     &   NANGMOM(NATOMS),NMOMFCT(NATOMS*NTANGM),NAOATM(NATOMS),
     &   NMOMAO(NATOMS*NTANGM),ISHL(6),NANGMOMSHL(IUATMS,MAXSHELL),
     &   NPRIMFUNSHL(IUATMS,MAXSHELL),NCONFUNSHL(IUATMS,MAXSHELL),
     &   NCONFUNTSHL(NATOMS*MAXSHELL),NMBERSHL(IUATMS), 
     &   ISHL2CNTR_MAP(NATOMS*MAXSHELL),NPRMFUNTSHL(IUATMS*MAXSHELL)
C     
      DIMENSION PCOEFF(ITFCT*NBAS),ALPHA(ITFCT),SALPHA(LNP1),
     &   SPCOEF(LNPO)
C     
      COMMON /PAR/ PI,PIX4
      COMMON /IPAR/ LUOUT
C     
      PICNST=(0.5D+00/PI)**0.75D+00
C     
C     Read alpha and primitive coefficients from MOL file, 
C     fill in the C1 symmetry vector
      REWIND(10)
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
C     Initialize population 
      INI=1
C     
      MAXANG=0
      DO 10 IATM=1,IUATMS
         READ(10,1000) ZNUC,IJUNK,NSHL,(ISHL(I),I=1,NSHL)
 1000    FORMAT(F20.1,8I5)
         READ(10,1010) ATMNAM,COORDX,COORDY,COORDZ
 1010    FORMAT(A4,3F20.12)
C     
         IDGOFF=0
         IOFF=0
         JOFF=0
         NUNQSHL=0
         DO 28 LL=1,NSHL
            NPT=0
            NAOT=0
            DO 30 II1=1,ISHL(LL)
               READ(10,1120) NP1,NAO
               NPT=NPT+NP1
               NAOT=NAOT+NAO
               IF(LL.EQ.1) NP2=1
               IF(LL.EQ.2) NP2=3
               IF(LL.EQ.3) NP2=6
               IF(LL.EQ.4) NP2=10
               IF(LL.EQ.5) NP2=15
C
C Reinitilize the array NANGMOMSHL, NPRIMFUNSHL, NCONFUNSHL
C arrays. Ajith Perera 2001
C     
               NUNQSHL = NUNQSHL + 1 
               NANGMOMSHL(IATM, NUNQSHL)  = NP2
               NPRIMFUNSHL(IATM, NUNQSHL) = NP1
               NCONFUNSHL(IATM, NUNQSHL)  = NAO
C
               DO 31 IJ=INI,INI+NPOP(IATM)-1
                  DO 1031 IDG=1,NP2
                     NMOMFCT((IMEMB(IJ)-1)*NTANGM+IDG+IDGOFF)=NPT
                     NMOMAO((IMEMB(IJ)-1)*NTANGM+IDG+IDGOFF)=NAOT
 1031             CONTINUE
 31            CONTINUE
               IF(II1.EQ.ISHL(LL)) IDGOFF=IDGOFF+NP2
               DO 2230 I=1,LNPO
                  SPCOEF(I)=0.D+00
 2230          CONTINUE
               DO 32 I=1,NP1
                  READ(10,1060) SALPHA(I),(SPCOEF((J-1)*NP1+I),J=1,NAO)
 32            CONTINUE
C     
C     Renormalize the atomic orbitals.
C     Multiply the renormalized coefficients by the appropriate 
C     normalization constants.
C     
               DO 34 INAO=1,NAO
                  SUM=0.D+00
                  DO 36 I=1,NP1
                     DO 37 J=1,I
                        AI=SALPHA(I)
                        AJ=SALPHA(J)
                        TMP=SPCOEF((INAO-1)*NP1+I)*SPCOEF((INAO-1)*
     $                     NP1+J)*(2.0D+00*DSQRT(AI*AJ)/
     $                     (AI+AJ))**(REAL(LL)+0.5D+00)
                        SUM=SUM+TMP
                        IF(I.NE.J) SUM=SUM+TMP
 37                  CONTINUE
 36               CONTINUE
                  XNORM=1.D+00/DSQRT(SUM)
                  DO 38 I=1,NP1
                     SPCOEF((INAO-1)*NP1+I)=SPCOEF((INAO-1)*NP1+I)*
     $                  XNORM*PICNST*
     &                  (4.D+00*SALPHA(I))**(0.5D+00*REAL(LL)+0.25D+00)
 38               CONTINUE
 34            CONTINUE
C     
C     Place the alpha's and coefficients in their appropriate place in 
C     their respective matrices, ALPHA and PCOEFF.
               DO 40 IPOP=INI,INI+NPOP(IATM)-1
                  IATMOFF=0
                  JATMOFF=0
                  DO 43 ITMP=1,IMEMB(IPOP)-1
                     IATMOFF=IATMOFF+NFCT(ITMP)
                     JATMOFF=JATMOFF+NAOATM(ITMP)*ITFCT
 43               CONTINUE
                  DO 45 I=1,NP1
                     JSHOFF=0
                     DO 46 I1=1,NP2
                        ALPHA(I+IOFF+IATMOFF+(I1-1)*NP1)=SALPHA(I)
                        DO 57 J=1,NAO
                           PCOEFF(JATMOFF+(JOFF+JSHOFF)*ITFCT+I+IOFF+
     $                        IATMOFF+(I1-1)*NP1)=SPCOEF((J-1)*NP1+I)
                           JSHOFF=JSHOFF+1
 57                     CONTINUE
 46                  CONTINUE
 45               CONTINUE
 40            CONTINUE
               IOFF=IOFF+NP1*NP2
               JOFF=JOFF+NP2*NAO
 30         CONTINUE
 28      CONTINUE
         INI=INI+NPOP(IATM)
         IF(NSHL.GT.MAXANG)MAXANG=NSHL
 10   CONTINUE
C
C Reinitilize the NCONFUNTSHL array, Ajith Perer 01/2001
C
      NTOTSHL = 0
C
      DO IATMS = 1, IUATMS
C
         DO IREDATMS = 1, NPOP(IATMS)

            DO IISHL = 1, NMBERSHL(IATMS)
C            
               NTOTSHL = NTOTSHL + 1 
               NCONFUNTSHL(NTOTSHL)   = NCONFUNSHL(IATMS, IISHL)
               NPRMFUNTSHL(NTOTSHL)   = NPRIMFUNSHL(IATMS, IISHL)
               ISHL2CNTR_MAP(NTOTSHL) = IATMS
            ENDDO
         ENDDO
      ENDDO
C
 1120 FORMAT(2I5)
 1060 FORMAT(4F18.10)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine fallocate_it(sheap_flag, nw, ierr)
c--------------------------------------------------------------------------
c   Allocates memory from the shared heap, and sets up pointers to access
c   it.  The "ishptr" (ishared_heap array) is used to refer to the memory
c   as integers, and "dshptr" (dshared_heap array) is used to refer to
c   the shared heap as a double precision array.
c-------------------------------------------------------------------------

      implicit none
      integer nw
      integer ierr
      integer sheap_flag
#ifdef ALTIX
      include 'parallel_info.h'
      include 'machine_types.h'
      include 'sheap.h'
      common /addrchk/last_sheap_addr
      integer*8 last_sheap_addr
      
      ishptr = malloc(nw*intsize)
      if (ishptr .eq. 0) then
         ierr = -1
      else
         ierr = 0
      endif

      dshptr = ishptr
      i8shptr = ishptr
#else
      print *,'fallocate_it call is illegal on this system!'
      call abort_job()
#endif
      return
      end

      SUBROUTINE TRUST_UPDATE(SCRATCH, GRADINT, HESIAN, TRUST_RAD,
     &                        PRD_ENRG_CHNG, DXDX, EPS, NX, NXM6, NOPT,
     &                        NCYCLE, TS)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      DOUBLE PRECISION MIN_RMIN,  MIN_RMAX, MIN_ENRG_CHNG
      LOGICAL TS



c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end





      DIMENSION SCRATCH(NX*NX), GRADINT(NOPT), HESIAN(NOPT, NOPT)

      DATA HALF /0.50D0/, TS_RMIN /0.70D0/, TS_RMAX /0.85D0/,
     &     MIN_RMIN /0.25D0/, MIN_RMAX /0.75d0/, TWO /2.0D0/,
     &     SCALE_FCTR /2.0D0/, ZERO /0.0D0/, ONE /1.0D0/,
     &     MIN_ENRG_CHNG /1.0D-6/, STP_MIN /0.05D0/,
     &     STP_MAX /0.60D0/, THREE /3.0D0/

      CALL GETREC(1,'JOBARC','TOTENERG',IINTFP,CURR_ENRG)
      CALL GETREC(1,'JOBARC','OLDENERG',IINTFP,PREV_ENRG)

      IF (NCYCLE .GE. 2) THEN
         CALL GETREC(1,'JOBARC','T_RADIUS',IINTFP,TAU)
         TRUST_RAD = TAU
      END IF

CSSS      WRITE(6,*) "The energy change", CURR_ENRG, PREV_ENRG,
CSSS     &            PRD_ENRG_CHNG, STP_MAX , TRUST_RAD
C
C The actual energy change
C
      ACT_ENRG_CHNG = CURR_ENRG - PREV_ENRG
C
CSSS      WRITE(6,*) "The current energy change", ACT_ENRG_CHNG,
CSSS     &            PRD_ENRG_CHNG
C
      IF (DABS(PRD_ENRG_CHNG).GT.EPS) THEN
         CURR_TRUST_RAD = ACT_ENRG_CHNG/PRD_ENRG_CHNG
         IF (TS) THEN
            IF (CURR_TRUST_RAD .LE. TS_RMIN .OR. CURR_TRUST_RAD .GE.
     &         (TWO - TS_RMIN)) TRUST_RAD = TRUST_RAD/SCALE_FCTR
            IF (CURR_TRUST_RAD .GE. TS_RMAX .OR. CURR_TRUST_RAD .LE.
     &         (TWO - TS_RMAX)) TRUST_RAD = TRUST_RAD*
     &                                      DSQRT(SCALE_FCTR)
         ELSE
CSSS            Write(6,*) "Updating trust radius", SCALE_FCTR, MIN_RMIN,
CSSS     &        CURR_TRUST_RAD, TRUST_RAD
            IF (CURR_TRUST_RAD .LE. MIN_RMIN .OR.
     &          CURR_TRUST_RAD .GT. THREE) THEN
               TRUST_RAD = TRUST_RAD/SCALE_FCTR
            ELSE IF (CURR_TRUST_RAD.GE.MIN_RMAX.AND.
     &               (DABS(ACT_ENRG_CHNG).GE.MIN_ENRG_CHNG.OR.
     &                DABS(PRD_ENRG_CHNG).GE.MIN_ENRG_CHNG)) THEN
               TMP_TRUST_RAD = TRUST_RAD*DSQRT(SCALE_FCTR)
               TMP_TRUST_RAD = MIN(TMP_TRUST_RAD,THREE*DXDX)
               TRUST_RAD = MAX(TRUST_RAD,TMP_TRUST_RAD)
            END IF
         END IF

C###         TRUST_RAD = MAX(TRUST_RAD, STP_MIN)
C###         TRUST_RAD = MIN(TRUST_RAD, STP_MAX)

       ELSE
C
C Make sure that unrealisticaly large or small steps are not taken
C
          TRUST_RAD = MAX(TRUST_RAD, STP_MIN)
          TRUST_RAD = MIN(TRUST_RAD, STP_MAX)
       END IF
C
C Calculate the "new" predicted energy change (Grad DeltaX + 1/2 DelatX H DeltaX)
C
CSSS      CALL XGEMM('N', 'N', NOPT, 1, NOPT, ONE, HESIAN, NOPT,
CSSS     &           SCRATCH(NOPT + 1), NOPT, ZERO, SCRATCH(2*NOPT +1),
CSSS     &           NOPT)
C
C The "new" predicted energy change.
C
CSSS      PRD_ENRG_CHNG = DDOT(NOPT, GRADINT, 1, SCRATCH(NOPT + 1), 1) +
CSSS     &                HALF*DDOT(NOPT, SCRATCH(2*NOPT + 1), 1,
CSSS     &                SCRATCH(NOPT + 1), 1)
C
CSSS       Write(6,*) "Leaving TRUST_RAD and Energy", TRUST_RAD,
CSSS     &             PRD_ENRG_CHNG
C
CSSS       TAU = DSQRT(DABS(DDOT(NXM6, SCRATCH(NOPT + 1), 1, SCRATCH(NOPT
CSSS     &             + 1), 1)))
C
C What we should save for the next cycle is something not clear to me.
C Nor It is clear in the papers. At this point what I have it consistent
C with MOPAC. Gamess uses the TAU of the current iteration.

       CALL PUTREC(1,'JOBARC','T_RADIUS',IINTFP,TRUST_RAD)

       RETURN
       END

#ifdef __fortran9x

! This routine is used to allocate memory.

! iwords : the number of *integer* words requested
! ioff   : the offset (in integer words) relative to icore(1)
!          OR -1 if the allocation failed

SUBROUTINE aces_malloc(iwords,ioff)
   IMPLICIT NONE

   INTEGER, ALLOCATABLE, SAVE :: heap(:)
   INTEGER, INTENT(IN)    :: iwords
   INTEGER, INTENT(INOUT) :: ioff

#include "icore.com"
#include "machsp.com"

   ALLOCATE(heap(iwords),STAT=ioff)
   IF (ioff /= 0) THEN
      ioff = -1 ! leave error handling to the caller
      RETURN
   END IF
   ioff = LOC(heap) - LOC(icore) ! the byte offset
   ioff = 1 + (ioff/iintln)      ! scale the offset to integers
#ifdef _DEBUG
   write(*,*) '@ACES_MALLOC: Allocated ~',iwords*BIT_SIZE(ioff)/8388608,' MB'
#endif

 ! ADY 20000203: The rest is supposedly for Crays, but I can't confirm
 ! this since switching to FORTRAN 95.
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 ! CALL timef(telap) !declare telap as double precision
 ! CALL hpalloc(index,iwords,ierr1,0)
 ! CALL timef(telap)
 ! WRITE(*,*) '@ACES_MALLOC: Allocation of ',iwords,' words of core required ',&
 !  & TELAP/1000.0,' sec.'
 ! IF (IERR1 < 0) THEN
 !    ioff=-1
 !    RETURN
 ! END IF
 ! ioff=1+(index-LOC(icore))
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   RETURN
END

#else /* defined(__fortran77) */

c This routine is used to allocate memory.

c iwords : the number of *integer* words requested
c ioff   : the offset (in integer words) relative to icore(1)
c          OR -1 if the allocation failed

      SUBROUTINE aces_malloc(iwords,ioff)
      IMPLICIT NONE

      INTEGER iwords, ioff, ibytes

#include "icore.com"
#include "machsp.com"

#ifdef _UNICOS
      INTEGER index, ierr1
      CALL hpalloc(index,iwords,ierr1,0)
      IF (ierr1.LT.0) THEN
         ioff = -1
         RETURN
      END IF
      ioff = 1 + (index-LOC(icore))
#else
#   ifdef _DEC
C Ajith 05/20/96 for DecAlpha machines. Having to do with the
C different integer representations C and Fortan on DecAlpha.
      INTEGER*8 index, ioff, MALLOC, loc
      ibytes = iwords * iintln
      index = MALLOC(ibytes)
#   else
      INTEGER index, c_malloc
      ibytes = iwords * iintln
      index = c_malloc(ibytes)
#   endif
      IF (index.EQ.0) THEN
         ioff = -1
         RETURN
      END IF
      ioff = index - loc(icore)
      ioff = 1 + (ioff/iintln)
#ifdef _DEBUG
      write(*,*) '@ACES_MALLOC: Allocated ~',rshift(ibytes,20),' MB'
#endif
#endif

      RETURN
      END

#endif /* __fortran9x */

      SUBROUTINE TRNCHR(LIST1,LIST2)
C
C THIS ROUTINE CHANGES THE CHARACTERISTICS OF A LIST, ALLOWING
C  ITS TRANSPOSE TO BE WRITTEN IN THE SAME AREA.  USED IN THE
C  FULL GAMMA BACK-TRANSFORMATION.
C  
C INPUT: LIST1  - THE SECONDARY LIST NUMBER.
C        LIST2  - THE PRIMARY LIST NUMBER.
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL CHANGE
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &              MOIODS(10,500),MOIOFL(10,500)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      ITMP=MOIODS(LIST1,LIST2)
      MOIODS(LIST1,LIST2)=MOIOSZ(LIST1,LIST2)
      MOIOSZ(LIST1,LIST2)=ITMP
      RETURN
      END

      SUBROUTINE PIVOT(AB,N,ND,OUTER,SCRATCH,EPS)
C
C     This subroutine switches two columns of a matrix to get
C         a nonzero entry in the diagonal.
C     Martin J. McBride.  12/04/85.
C     General Electric CRD, Information System Operation.
C
CEND
      INTEGER N,ND,COL,OUTER,I
      DOUBLE PRECISION AB(ND,1),SCRATCH(1),TEMP,EPS

C  Get first column with non-zero element in row OUTER.
      COL = OUTER + 1
   10 IF (COL .GT. N) GO TO 90
      IF (ABS(AB(OUTER,COL)) .GT. EPS) GO TO 20
         COL = COL + 1
         GO TO 10

C  Switch column OUTER with column COL, which has non-zero element in
C  row OUTER.
   20 DO 30 I = 1,N
         TEMP = AB(I,OUTER)
         AB(I,OUTER) = AB(I,COL)
         AB(I,COL) = TEMP
   30 CONTINUE
      TEMP = SCRATCH(N+OUTER)
      SCRATCH(N+OUTER) = SCRATCH(N+COL)
      SCRATCH(N+COL) = TEMP

   90 CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      subroutine set_ecp_charges(max_centers,natoms,icrcor)
      implicit none

#include "mxatms.par"

      integer natoms  
      integer max_centers 
      integer charge(max_centers) 
      integer icrcor(mxatms) 
      integer nlines, ios, i  
      character*80 line
      character*2 name(max_centers) 

c Open the ZMAT file 

      open (unit=23, file='ZMAT', status='OLD',
     *      err = 200, iostat = ios)

  200 continue 
      if (ios .ne. 0) then
         print *,'Error: Cannot open ZMAT file.'
         call abort_job()
      endif


c Read atom data from the ZMAT 

      natoms = 0 
      nlines = 0 
  300 continue
      line = ' '
      read (23,9000, end = 400) line
      nlines = nlines + 1 
      if (nlines .gt. 1) then 
         if (line .eq. '  ') go to 400 
         natoms = natoms + 1 
111   continue 
      endif 

      go to 300

  400 continue 

      close(23) 

#ifdef _DEBUG_LVL0
      write(6,*) '@set_ecp_charges: Number of ECP ATOMS = ', natoms
#endif

9000  FORMAT(a80) 
      return
      end

c ----------------------------------------------------------------------
c ----------------------------------------------------------------------

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_machine_types()
      implicit none
      include 'machine_types.h'
      include 'parallel_info.h'

      integer iii(2)
      double precision x(2)

      intsize = loc(iii(2)) - loc(iii(1))
      bytes_per_double = loc(x(2)) - loc(x(1))
#ifdef ACES64
      aces64 = .true.
      aces_ints_per_double = bytes_per_double/8
#else
      aces64 = .false.
      aces_ints_per_double = bytes_per_double/intsize
#endif

#ifdef __crayx1
      mpi_int_ratio = 1
#else
      mpi_int_ratio = intsize / 4
#endif

#ifdef NO_MPI_IO
      mpi_io_support = .false.
#else
      mpi_io_support = .true.
#endif

c     TURM MPIIO OFF 3/6/2012 VFL 
      mpi_io_support = .false.
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      integer function find_free_diskloc(ifile, server_table, 
     *                                   nserver_table)
c--------------------------------------------------------------------------
c   Finds a free disk location for the correct file.  If no free blocks are
c   available already, this function returns -1.
c--------------------------------------------------------------------------
      implicit none
      include 'server.h'

      integer ifile, nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer i

      find_free_diskloc = -1

      do i = 1, nserver_table
         if (server_table(c_server_file,i) .eq. ifile) then
            if (server_table(c_server_diskloc,i) .lt. 0) then
               find_free_diskloc = -server_table(c_server_diskloc,i)
               server_table(c_server_diskloc,i) = 0
               return
            endif
         endif
      enddo

      return
      end

      subroutine reopenmo
cjp closes moints and moabcd
cjp abd reopens them with new iref
cjp
      implicit integer (a-z)
      LOGICAL YESNO,GAMLAM
      CHARACTER*8 NAMES(5)
      CHARACTER*80 FNAME
      INTEGER USEC,USECIN,TSTART,WSTART
      COMMON / / ICORE(1)
      COMMON /INCORE/ ICREC(2),USEC,IXT(2),IMOD(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIODS(10,500),
     &               MOIOSZ(10,500),MOIOFL(10,500)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /FILSPC/ IBUFLN,IPRCLN,IPRCWD
      COMMON /CACHEINF/ CACHSIZ,CACHSZP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      DATA NAMES /'MOINTS  ','GAMLAM  ','MOABCD  ','DERINT  ',
     &            'DERGAM  '/
#include "bwcc.com"
c
      if(nref.gt.1) call loadmoio
      do i= 50,52,2
      close(i)
      call gfname(names(i-49),fname,ilength)
      call aces_io_open(i-49)
      enddo
      return
      end

         SUBROUTINE  OED__NAI_1D_DERV_F12_INTEGRALS
     +
     +                    ( MIJ,MGQPIJ,MGIJCEN,
     +                      NGQP,NGQPCEN,
     +                      SHELLA,SHELLB,
     +                      DERA,DERB,DERC,
     +                      EXP2A,EXP2B,EXP2AB,
     +                      INT1D,
     +
     +                               OUT1D,OUT1D_2 )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_1D_DERV_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single derivation step on
C                the input 1D nuclear attraction integrals:
C
C            I'(n,a,b) = delta (DERA,1) *
C                              [-a*I(n,a-1,b) + 2*expa(n)*I(n,a+1,b)]
C                      + delta (DERB,1) *
C                              [-b*I(n,a,b-1) + 2*expb(n)*I(n,a,b+1)]
C                      + delta (DERC,1) * r
C                              [2p(P-C)I(n,a,b) + a*I(n,a-1,b)
C                                               + b*I(n,a,b-1)]
C
C                and returns the result in a separate array.
C
C                The derivatives of the 1D integrals are calculated for
C                all roots, all nuclear centers and the present set of
C                exponent pairs. The values of DERA,DERB and DERC can
C                be only 1 or 0. A set of 1's among these variables
C                indicates that these centers were identified as equal.
C
C
C                  Input:
C
C                    MIJ         =  current # of ij primitive index
C                                   pairs corresponding to the
C                                   contracted shell pairs A,B
C                    MGQPIJ      =  # of roots times # of ij primitive
C                                   index pairs
C                    MGIJCEN     =  # of roots times # of ij primitive
C                                   index pairs times # of nuclear
C                                   attraction centers
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NGQPCEN     =  # of roots times # of nuclear
C                                   attraction centers
C                    SHELLx      =  maximum shell type for centers
C                                   x = A and B after differentiation
C                    DERx        =  indicator, if differentiation is
C                                   to be performed with respect to
C                                   centers x = A,B,C. Two possible
C                                   values: 0 = no differentiation,
C                                   1 = differentiate, i.e. d/dx
C                    EXP2x       =  the totality of all MGIJCEN
C                                   exponents x 2 for both centers
C                                   x = A and B in the appropriate
C                                   order
C                    EXP2AB      =  the MIJ distinct exponent sums
C                                   between both centers x = A and B.
C                    IXC         =  contains the index value of the
C                                   nuclear attraction center C to be
C                                   derivated. This index is necessary
C                                   for locating the appropriate
C                                   sections of the 1D integrals for
C                                   differentiation
C                    P           =  the MIJ coordinates for the
C                                   gaussian product centers P=A+B
C                    C           =  value of the coordinate for the
C                                   IXC-th nuclear attraction center
C                    RTS         =  all current MGIJCEN quadrature
C                                   roots
C                    TEMP        =  scratch array that will hold all
C                                   necessary 2pr*(P-C) values, where
C                                   r are all those MGQPIJ roots
C                                   corresponding to the IXC-th nuclear
C                                   attraction center
C                    INT1D       =  all input 1D nuclear attraction
C                                   integrals before differentiation.
C
C
C                  Output:
C
C                    OUT1D       =  all differentiated 1D nuclear
C                                   attraction integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program OED
C
C    This routine is part of the integral program package OED and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routines of the
C    OED package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   FIRST

         INTEGER   A,B,M,N
         INTEGER   AM,AP,BM,BP
         INTEGER   DERA,DERB,DERC
         INTEGER   IJ,NG
         INTEGER   IXC
         INTEGER   MIJ,MGQPIJ,MGIJCEN
         INTEGER   NGQP,NGQPCEN
         INTEGER   OFF
         INTEGER   SHELLA,SHELLB

         DOUBLE PRECISION  C,X
         DOUBLE PRECISION  F,F1,F2
         DOUBLE PRECISION  ZERO,ONE,TWO

         DOUBLE PRECISION  EXP2A  (1:MGIJCEN)
         DOUBLE PRECISION  EXP2B  (1:MGIJCEN)
         DOUBLE PRECISION  EXP2AB (1:MIJ)
         DOUBLE PRECISION  P      (1:MIJ)
         DOUBLE PRECISION  RTS    (1:MGIJCEN)
         DOUBLE PRECISION  TEMP   (1:MGQPIJ)

         DOUBLE PRECISION  INT1D (1:MGIJCEN,0:SHELLA+DERA,
     +                                      0:SHELLB+DERB)
         DOUBLE PRECISION  OUT1D (1:MGIJCEN,0:SHELLA,
     +                                      0:SHELLB)

         DOUBLE PRECISION  OUT1D_2 (1:MGIJCEN,0:SHELLA,
     +                                      0:SHELLB)

         PARAMETER  (ZERO   =  0.D0)
         PARAMETER  (ONE    =  1.D0)
         PARAMETER  (TWO    =  2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...derivative on center A (if any).
C
c         goto 5555
C
         FIRST = .TRUE.

         IF (DERA.EQ.1) THEN

             IF (SHELLA.EQ.0) THEN

                 DO B = 0,SHELLB
                 DO N = 1,MGIJCEN
                    OUT1D_2 (N,0,B) = EXP2A (N) * INT1D (N,1,B)
                 END DO
                 END DO

             ELSE IF (SHELLA.EQ.1) THEN

                 DO B = 0,SHELLB
                 DO N = 1,MGIJCEN
                    OUT1D_2 (N,0,B) = EXP2A (N) * INT1D (N,1,B)
                    OUT1D_2 (N,1,B) = EXP2A (N) * INT1D (N,2,B)
     +                                        - INT1D (N,0,B)
                 END DO
                 END DO

             ELSE

                 DO B = 0,SHELLB
                    DO N = 1,MGIJCEN
                       OUT1D_2 (N,0,B) = EXP2A (N) * INT1D (N,1,B)
                       OUT1D_2 (N,1,B) = EXP2A (N) * INT1D (N,2,B)
     +                                           - INT1D (N,0,B)
                    END DO
                    F = TWO
                    DO A = 2,SHELLA
                       AM = A - 1
                       AP = A + 1
                       DO N = 1,MGIJCEN
                          OUT1D_2 (N,A,B) = EXP2A (N) * INT1D (N,AP,B)
     +                                          - F * INT1D (N,AM,B)
                       END DO
                       F = F + ONE
                    END DO
                 END DO

             END IF

             FIRST = .FALSE.

         END IF
C
C
C             ...derivative on center B (if any).
C
C
             
         IF (DERB.EQ.1) THEN

             IF (FIRST) THEN

                 DO A = 0,SHELLA
                 DO N = 1,MGIJCEN
                    OUT1D_2 (N,A,0) = EXP2B (N) * INT1D (N,A,1)
                 END DO
                 END DO

                 IF (SHELLB.GT.0) THEN
                     DO A = 0,SHELLA
                     DO N = 1,MGIJCEN
                        OUT1D_2 (N,A,1) = EXP2B (N) * INT1D (N,A,2)
     +                                            - INT1D (N,A,0)
                     END DO
                     END DO
                 END IF

                 IF (SHELLB.GT.1) THEN
                     F = TWO
                     DO B = 2,SHELLB
                        BM = B - 1
                        BP = B + 1
                        DO A = 0,SHELLA
                        DO N = 1,MGIJCEN
                           OUT1D_2 (N,A,B) = EXP2B (N) * INT1D (N,A,BP)
     +                                           - F * INT1D (N,A,BM)
                        END DO
                        END DO
                        F = F + ONE
                     END DO
                 END IF

                 FIRST = .FALSE.

             ELSE
 
                 DO A = 0,SHELLA
                 DO N = 1,MGIJCEN
                    OUT1D_2 (N,A,0) = OUT1D_2 (N,A,0) +
     +                              EXP2B (N) * INT1D (N,A,1)
                 END DO
                 END DO

                 IF (SHELLB.GT.0) THEN
                     DO A = 0,SHELLA
                     DO N = 1,MGIJCEN
                        OUT1D_2 (N,A,1) = OUT1D_2 (N,A,1) +
     +                                  EXP2B (N) * INT1D (N,A,2)
     +                                            - INT1D (N,A,0)
                     END DO
                     END DO
                 END IF

                 IF (SHELLB.GT.1) THEN
                     F = TWO
                     DO B = 2,SHELLB
                        BM = B - 1
                        BP = B + 1
                        DO A = 0,SHELLA
                        DO N = 1,MGIJCEN
                           OUT1D_2 (N,A,B) = OUT1D_2 (N,A,B) +
     +                                     EXP2B (N) * INT1D (N,A,BP)
     +                                           - F * INT1D (N,A,BM)
                        END DO
                        END DO
                        F = F + ONE
                     END DO
                 END IF

             END IF

         END IF
C
C
C
C
C
C
C             ...ready!
C
C

5555     continue

           IF(DERB.eq.1) THEN
            DO N = 1,MGIJCEN
             DO A=0,SHELLA
              DO B=0,SHELLB
c               IF( ( OUT1D_2 (N,A,B)-OUT1D_2 (N,B,A) ).ne.0.d0  ) 
c     &  write(6,*) OUT1D_2 (N,A,B), N,A,B

               OUT1D (N,A,B) =  OUT1D_2 (N,A,B)
              ENDDO
             ENDDO
            ENDDO
           endif
 

         RETURN
         END

C
      Subroutine simple_sort(a, b, n)
C      
C This is a very simple routine that can sort eigenvalues and
C eigenvectors (or any other such combination) in ascending order. 
C The sorted eigenvalues and vectors are returned in the respective
C incomming arrays a and b. 11/09, Ajith Perera. 
C

      Implicit None
      Integer i, j, k, n
      Double Precision a(n), b(n,n), dtmp
C
      do i = 1, n-1
            do j = i+1, n
               if ( a(i) .gt. a(j) ) then
                  dtmp = a(i)
                  a(i) = a(j)
                  a(j) = dtmp
                  do k = 1, n
                     dtmp   = b(k,i)
                     b(k,i) = b(k,j)
                     b(k,j) = dtmp
                  end do
               end if 
            end do 
         end do 
C
      Return
      End

      SUBROUTINE A2EVAL_INTS(NTOTPRIM, NTOTCRF, IANGTYPE, 
     &                       XPOINT, YPOINT, ZPOINT, EXPS, PCOEF, 
     &                       PRDTINT, CNT_COORD, TMP1, TMP2, TMP3)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DIMENSION CNTMU(3), CNTNU(3), EXPS(NTOTPRIM), 
     &          PRDTINT(NTOTCRF, NTOTCRF), PCOEF(NTOTPRIM, NTOTCRF),
     &          CENTER(3),TMP1(NTOTPRIM*NTOTPRIM),
     &          TMP2(NTOTPRIM*NTOTPRIM),TMP3(NTOTPRIM*NTOTPRIM),
     &          IANGTYPE(NTOTPRIM), CNT_COORD(3, NTOTPRIM)
C
      COMMON /HIGHL/ LMNVAL(3, 84), ANORM(84)
      DATA   DZERO /0.0D+00/, ONE /1.00D0/
C
C Loop over number of primitive functions
C
      INDX = 0
C
      CENTER(1) = XPOINT
      CENTER(2) = YPOINT
      CENTER(3) = ZPOINT
C
      DO LFTPRIM = 1, NTOTPRIM
C
         INDX  = INDX + 1 
         ITYPE = IANGTYPE(INDX)
         DO IXYZ = 1, 3
            CNTMU(IXYZ) = CNT_COORD(IXYZ, INDX)
         ENDDO 
C                     
         JNDX = 0
         DO RGTPRIM = 1, NTOTPRIM
C                  
            JNDX  = JNDX + 1 
            JTYPE = IANGTYPE(JNDX)
            DO IXYZ = 1, 3
               CNTNU(IXYZ) = CNT_COORD(IXYZ, JNDX)
            ENDDO 
C
C We can built the product here!
C
                  CALL A2BULT_PRDUCT(INDX, JNDX, ITYPE, JTYPE, 
     &                               NTOTPRIM, EXPS(INDX), 
     &                               EXPS(JNDX), CENTER,
     &                               CNTMU, CNTNU, TMP2)
C
C Loop over primitives end here!
C
         ENDDO
      ENDDO
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "The product integral in primitive basis"
      CALL OUTPUT(TMP2, 1, NTOTPRIM, 1, NTOTPRIM, NTOTPRIM, 
     &            NTOTPRIM, 1)
#endif
C
#ifdef _DEBUG_LVLM2
       Write(6,*)
       Write(6,*) "@-a2eval_ints CONTRACTION COEFICIENTS"
       CALL OUTPUT(PCOEF, 1, NTOTPRIM, 1, NTOTCRF, NTOTPRIM,
     &                  NTOTCRF, 1)
#endif
C 
C Built the contracted product functions for this shell.
C
      CALL XGEMM('N', 'N', NTOTPRIM, NTOTCRF, NTOTPRIM, ONE, TMP2,
     &            NTOTPRIM, PCOEF, NTOTPRIM, DZERO, TMP3, NTOTPRIM)
C
      CALL XGEMM('T', 'N', NTOTCRF, NTOTCRF, NTOTPRIM, ONE, PCOEF, 
     &            NTOTPRIM, TMP3, NTOTPRIM, DZERO, PRDTINT, NTOTCRF)
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The product integral in contracted basis"
      CALL OUTPUT(PRDTINT, 1, NTOTCRF, 1, NTOTCRF, NTOTCRF, NTOTCRF, 1)
#endif
C
      RETURN 
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c
      subroutine form_R(b_array,
     *                   c1,c2,c3,c4,c5, c6,c7,c8,c9,c10)  
c
      double precision R(11,11), rpack(121), v(11) 
      double precision b_array(10,10)
      double precision c1,c2,c3,c4,c5,c6,c7,c8,c9,c10
      double precision temp
      integer i, ndim 
#ifdef __crayx1
      integer*8 arg64(5), iP(11)
#else
      integer iP(11)
#endif

      integer maxdim
      parameter (maxdim = 10)

c--------------------------------------------------------------------------
c   Symmetrize the b_array into the R array
c--------------------------------------------------------------------------

      do i = 1, maxdim
      do j = i, maxdim
         R(i,j) = b_array(i,j)
         if (i .ne. j) R(j,i) = b_array(i,j) 
      enddo
      enddo

      ndim = maxdim
      do i = 1, maxdim
         nzero = maxdim
         do j = 1, maxdim
            if (dabs(r(i,j)) .gt. 0.d0) then
               nzero = nzero - 1
            endif
         enddo
         if (nzero .eq. maxdim) ndim = ndim - 1
      enddo

      do i = 1, ndim
         R(i,ndim+1) = -1.0d0 
         R(ndim+1,i) = -1.0d0 
      enddo ! i 
      R(ndim+1,ndim+1) =  0.0d0 

      n = 0
      do j = 1, ndim+1
      do i = 1, ndim+1
         n = n + 1
         rpack(n) = r(i,j)
      enddo
      enddo

c
c Form the v-vector. 
c ------------------ 
c
      do i = 1, ndim
         v(i) = 0.
      enddo
      v(ndim+1) = -1.d0

c
c Solve the eigenvalue problem R * C = v for the vector C.
c -------------------------------------------------------- 
c
#ifdef __crayx1
      arg64(1) = ndim+1
      arg64(2) = 1
      arg64(3) = ndim+1
      arg64(4) = ndim+1
      arg64(5) = i
      call dgesv(arg64(1), arg64(2), rpack, arg64(3), iP, v,
     *           arg64(4), arg64(5))
      i = arg64(5)  
#else
      call dgesv(ndim+1,1,rpack,ndim+1,iP,v,ndim+1,i)  
#endif

      if (i .ne. 0) then
         print *,'Error in dgesv: info = ',i
         call abort_job()
      endif

c
c Put solutions into c for use in the SIAL program. 
c ------------------------------------------------------------------------ 
c
      do i = ndim+1, maxdim+1
         v(i) = 0.
      enddo

      c1 = v(1) 
      c2 = v(2) 
      c3 = v(3) 
      c4 = v(4) 
      c5 = v(5) 
      c6 = v(6)
      c7 = v(7)
      c8 = v(8)
      c9 = v(9)
      c10 = v(10)
 
c
      end 
c 

      
      
      SUBROUTINE HEADER(HEAD, IN, LUPRI)
C
C Printing of Headers in a neat format.
C
C Arguments:
C  
C  Head  : String to be printed
C  IN    : Controls the indentation
C          When it is greater than zero, indentations is the 
C          the value of the variable IN plus 1. Otherwise
C          it will center the string in the output page.
C
C  LUPRI : The out-put unit number
C
      CHARACTER HEAD*(*)
C
      LENGTH = LEN(HEAD)
C
      IF (IN .GE. 0) THEN
         INDENT = IN + 1
      ELSE
         INDENT = (72 - LENGTH)/2 + 1
      END IF
C
      WRITE (LUPRI, '(/,80A)') (' ',I=1,INDENT), HEAD
      WRITE (LUPRI, '(80A)') (' ',I=1,INDENT), ('-',I=1,LENGTH)
      WRITE (LUPRI, '()')
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__DENORMALIZE_COEFF_MATRIX
     +
     +                    ( NBAS,
     +                      DENORM,
     +
     +                              COEFFS )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__DENORMALIZE_COEFF_MATRIX
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine denormalizes the coefficient matrix such
C                that the natural orbitals are expressed in the original
C                AO basis set. This is necessary sometimes when the
C                overlap and density matrices in the original AO basis
C                set have both been normalized and the natural orbital
C                coefficients are based on the normalized AO's.
C
C                The denormalized coefficient matrix is simply obtained
C                by multiplying each row with the appropriate
C                denormalization factor (which is equal to the square
C                root of the diagonal unnormalized overlap matrix).
C
C
C                Input:
C
C                     NBAS = size of AO basis.
C                   DENORM = denormalization coefficients.
C                   COEFFS = original coefficient matrix.
C
C                Output:
C
C                   COEFFS = denormalized coefficient matrix.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I,J
         INTEGER    NBAS

         DOUBLE PRECISION  ONE
         DOUBLE PRECISION  X

         DOUBLE PRECISION  DENORM (1:NBAS)

         DOUBLE PRECISION  COEFFS (1:NBAS,1:NBAS)

         PARAMETER    (ONE  =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...perform denormalization. Skip multiplication of
C                rows if denormalization factor is equal to 1.
C
C
         DO 10 I = 1,NBAS
            X = DENORM (I)
            IF (X.NE.ONE) THEN
                DO 20 J = 1,NBAS
                   COEFFS (I,J) = (ONE/X) * COEFFS (I,J)
   20           CONTINUE
            END IF
   10    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine writes a character string to the job archive.

c WARNING!
c    The "record length" that gets associated with the logical record is the
c number of whole integers that contain the string. Therefore, calling getrec
c with the query flag may not return the actual length of the string.

c INPUT
c int      XFLAG     : (same as putrec)
c char*(*) SZARCHIVE : (same as putrec)
c char*(*) SZRECNAME : (same as putrec)
c int      ILENGTH   : the substring-length of the record to store
c char*(*) SZSRC     : (same as putrec)

#define _MAXLEN 1024 /* 4096 or 8192 characters */

#ifdef F_64BIT
#  define _IINTLN 8
#else
#  define _IINTLN 4
#endif

      subroutine putcrec(xFlag,szArchive,szRecName,iLength,szSrc)
      implicit none

c ARGUMENTS
      integer xFlag, iLength
      character*(*) szArchive, szRecName, szSrc(*)

c EXTERNAL FUNCTIONS
      integer iachar

c INTERNAL VARIABLES
      integer i, iNdx, nLeft, iBuf(_MAXLEN), iRecLen

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert substring fits in iBuf
      if (iLength.gt.(_MAXLEN*_IINTLN)) then
         print *, '@PUTCREC: Assertion failed.'
         print *, '   iLength = ',iLength
         print *, '   maximum = ',_MAXLEN*_IINTLN
         i = 1
      end if
cYAU: Since szSrc is now an array pointer, we have no idea if iLength is good.
cc   o assert substring is within szSrc
c      if (len(szSrc).lt.iLength) then
c         print *, '@PUTCREC: Assertion failed.'
c         print *, '   iLength = ',iLength
c         print *, '   len(sz) = ',len(szSrc)
c         i = 1
c      end if
c   o assert ichar and iachar are the same
      if (ichar(' ').ne.iachar(' ')) then
         print *, '@PUTCREC: Assertion failed.'
         print *, '   iachar(szSpace) = ',iachar(' ')
         print *, '    ichar(szSpace) = ',ichar(' ')
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o iRecLen is the number of whole integers that contain szSrc(1:iLength)
      iRecLen = (iLength+_IINTLN-1)/_IINTLN

c   o flush the last integer with spaces
      if (iand(iLength,_IINTLN-1).ne.0) then
         i = ichar(' ')
         call c_memset(iBuf(iRecLen),i,_IINTLN)
      end if

c   o copy the string to the integer buffer
      call c_memmove(iBuf,szSrc,iLength)

c   o write to the job archive
      call putrec(xFlag,szArchive,szRecName,iRecLen,iBuf)

      return
c     end subroutine putcrec
      end

#include "flags.h"
      SUBROUTINE GEN_APPROX_FREQ(SCRATCH, BMATRIX, TMP, HES_INTACT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "io_units.par"
#include "fnamelen.par"
#include "machsp.com"
#include "mxatms.par"
#include "coord.com"
#include "jodaflags.com"
C
      LOGICAL XYZIN, NWFINDIF
      CHARACTER*1 FLAG(3*MXATMS)
      INTEGER TOTREDNCO
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
      DOUBLE PRECISION BMATRIX(NXM6*3*NATOMS), TMP(NXM6*3*NATOMS),
     &                 SCRATCH(9*NATOMS*NATOMS),
     &                 HES_INTACT(3*NATOMS, 3*NATOMS)

C Transform the internal coordinate Hessian to the Cartesian Hessian in
C order to carry out mass weighing (it is nearly impossible to mass
C weigh internal Hessians). Notice the assumption made in the
C transformation: the gradient is zero, hence no derivative of the B
C matrix is required. Since this is done only at the stationary points,
C the assumption (or the condition) is satisfied and the transformation
C is valid. Ajith Perera 05/2005.

CSSS      CALL OUTPUT(HES_INTACT, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
C
      IF (Iflags2(h_IFLAGS2_geom_opt) .ge. 3) THEN
C
C It is more than safer to always use 3*NATOMS explicitly when
C redundent internal optimizations are performed. Ajith perera,
C 01/2007.

         CALL GETREC(20, 'JOBARC','REDNCORD', 1, TOTREDNCO)
         LENGTH_BMAT = 3*NATOMS*TOTREDNCO
         CALL GETREC(-1, 'JOBARC', 'BMATRIXT', LENGTH_BMAT*IINTFP,
     &              TMP)
         CALL ZERO(SCRATCH, 9*NATOMS*NATOMS)
         CALL XGEMM("N", "N", 3*NATOMS, TOTREDNCO, TOTREDNCO, 1.0D0,
     &              TMP, 3*NATOMS, HES_INTACT, TOTREDNCO, 0.0D0,
     &              SCRATCH, 3*NATOMS)
         CALL TRANSP(TMP, BMATRIX, TOTREDNCO, 3*NATOMS)
         CALL ZERO(HES_INTACT, 9*NATOMS*NATOMS)
         CALL XGEMM("N", "N", 3*NATOMS, 3*NATOMS, TOTREDNCO, 1.0D0, 
     &               SCRATCH, 3*NATOMS, BMATRIX, TOTREDNCO, 0.0D0, 
     &               HES_INTACT, 3*NATOMS)
C
      ELSE
C
         CALL GETREC(20, 'JOBARC', 'BMATRIX ', IINTFP*NXM6*NX,
     &               BMATRIX)
CSSS         CALL OUTPUT(BMATRIX, 1, NXM6, 1, NX, NXM6, NX, 1)
C
         CALL TRANSP(BMATRIX, TMP, NX, NXM6)
         CALL ZERO(SCRATCH, NX*NX)
         CALL XGEMM("N", "N", NX, NXM6, NXM6, 1.0D0, TMP, NX,
     &               HES_INTACT, NXM6, 0.0D0, SCRATCH, NX)
         CALL ZERO(HES_INTACT, NX*NX)
         CALL XGEMM("N", "N", NX, NX, NXM6, 1.0D0, SCRATCH, NX,
     &               BMATRIX, NXM6, 0.0D0, HES_INTACT, NX)
C
CSSS         CALL OUTPUT(HES_INTACT, 1, NX, 1, NX, NX, NX, 1)
      ENDIF
C
C Mass weight the Cartesian Hessian
C
      DO I = 1, 3*NATOMS
         DO J = 1, 3*NATOMS
            FACT = DSQRT(ATMASS(1+(I-1)/3)*ATMASS(1+(J-1)/3))
            IF (FACT .LT. 1.0D-3)THEN
                HES_INTACT(I,J) = 0.D0
            ELSE
                HES_INTACT(I,J) = HES_INTACT(I,J)/FACT
            ENDIF
         ENDDO
      ENDDO
C
C Diagonalize the mass-weighted Hessian and tag the negative
C eigenvalues with "i" to indicate an imaginary frequency and
C convert them to the correspnding frequencies in cm-1 units.
C
      CALL EIG(HES_INTACT, SCRATCH, 3*NATOMS, 3*NATOMS, 0)
C
      DO I = 1, 3*NATOMS
         FLAG(I) = " "
         IF (HES_INTACT(I,I) .LT. 0.0D0) FLAG(I) = "i"
         HES_INTACT(I,I) = DSQRT(DABS(HES_INTACT(I,I)))*5.14048D03
         SCRATCH(I) = HES_INTACT(I,I)
      END DO
C
C Print the frequencies along with a warning message.
C
      WRITE(LUOUT,10)
   10 FORMAT(3X, "Frequencies of the updated Hessian at convergence:")
      WRITE(LUOUT,*)
C
      WRITE(LUOUT,'(11(F6.0,A))')
     &     (SCRATCH(IMODE), FLAG(IMODE), IMODE=1,3*NATOMS)
      WRITE(LUOUT,*)
      WRITE(LUOUT,20)
   20 FORMAT(3X, "Warning: Frequencies based on the updated Hessian",
     &" are not very accurate.",/,12X, "A separate frequency",
     &" calculation is required to get correct values.")
      WRITE(LUOUT,*)
C
      RETURN
      END

      SUBROUTINE GEN_APPROX_FREQ(SCRATCH, BMATRIX, TMP, HES_INTACT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end









c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C
      LOGICAL XYZIN, NWFINDIF
      CHARACTER*1 FLAG(3*MXATMS)
      INTEGER TOTREDNCO
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
      DOUBLE PRECISION BMATRIX(NXM6*3*NATOMS), TMP(NXM6*3*NATOMS),
     &                 SCRATCH(9*NATOMS*NATOMS),
     &                 HES_INTACT(3*NATOMS, 3*NATOMS)

C Transform the internal coordinate Hessian to the Cartesian Hessian in
C order to carry out mass weighing (it is nearly impossible to mass
C weigh internal Hessians). Notice the assumption made in the
C transformation: the gradient is zero, hence no derivative of the B
C matrix is required. Since this is done only at the stationary points,
C the assumption (or the condition) is satisfied and the transformation
C is valid. Ajith Perera 05/2005.

CSSS      CALL OUTPUT(HES_INTACT, 1, NXM6, 1, NXM6, NXM6, NXM6, 1)
C
      IF (Iflags2(5) .ge. 3) THEN
C
C It is more than safer to always use 3*NATOMS explicitly when
C redundent internal optimizations are performed. Ajith perera,
C 01/2007.

         CALL GETREC(20, 'JOBARC','REDNCORD', 1, TOTREDNCO)
         LENGTH_BMAT = 3*NATOMS*TOTREDNCO
         CALL GETREC(-1, 'JOBARC', 'BMATRIXT', LENGTH_BMAT*IINTFP,
     &              TMP)
         CALL ZERO(SCRATCH, 9*NATOMS*NATOMS)
         CALL XGEMM("N", "N", 3*NATOMS, TOTREDNCO, TOTREDNCO, 1.0D0,
     &              TMP, 3*NATOMS, HES_INTACT, TOTREDNCO, 0.0D0,
     &              SCRATCH, 3*NATOMS)
         CALL TRANSP(TMP, BMATRIX, TOTREDNCO, 3*NATOMS)
         CALL ZERO(HES_INTACT, 9*NATOMS*NATOMS)
         CALL XGEMM("N", "N", 3*NATOMS, 3*NATOMS, TOTREDNCO, 1.0D0, 
     &               SCRATCH, 3*NATOMS, BMATRIX, TOTREDNCO, 0.0D0, 
     &               HES_INTACT, 3*NATOMS)
C
      ELSE
C
         CALL GETREC(20, 'JOBARC', 'BMATRIX ', IINTFP*NXM6*NX,
     &               BMATRIX)
CSSS         CALL OUTPUT(BMATRIX, 1, NXM6, 1, NX, NXM6, NX, 1)
C
         CALL TRANSP(BMATRIX, TMP, NX, NXM6)
         CALL ZERO(SCRATCH, NX*NX)
         CALL XGEMM("N", "N", NX, NXM6, NXM6, 1.0D0, TMP, NX,
     &               HES_INTACT, NXM6, 0.0D0, SCRATCH, NX)
         CALL ZERO(HES_INTACT, NX*NX)
         CALL XGEMM("N", "N", NX, NX, NXM6, 1.0D0, SCRATCH, NX,
     &               BMATRIX, NXM6, 0.0D0, HES_INTACT, NX)
C
CSSS         CALL OUTPUT(HES_INTACT, 1, NX, 1, NX, NX, NX, 1)
      ENDIF
C
C Mass weight the Cartesian Hessian
C
      DO I = 1, 3*NATOMS
         DO J = 1, 3*NATOMS
            FACT = DSQRT(ATMASS(1+(I-1)/3)*ATMASS(1+(J-1)/3))
            IF (FACT .LT. 1.0D-3)THEN
                HES_INTACT(I,J) = 0.D0
            ELSE
                HES_INTACT(I,J) = HES_INTACT(I,J)/FACT
            ENDIF
         ENDDO
      ENDDO
C
C Diagonalize the mass-weighted Hessian and tag the negative
C eigenvalues with "i" to indicate an imaginary frequency and
C convert them to the correspnding frequencies in cm-1 units.
C
      CALL EIG(HES_INTACT, SCRATCH, 3*NATOMS, 3*NATOMS, 0)
C
      DO I = 1, 3*NATOMS
         FLAG(I) = " "
         IF (HES_INTACT(I,I) .LT. 0.0D0) FLAG(I) = "i"
         HES_INTACT(I,I) = DSQRT(DABS(HES_INTACT(I,I)))*5.14048D03
         SCRATCH(I) = HES_INTACT(I,I)
      END DO
C
C Print the frequencies along with a warning message.
C
      WRITE(LUOUT,10)
   10 FORMAT(3X, "Frequencies of the updated Hessian at convergence:")
      WRITE(LUOUT,*)
C
      WRITE(LUOUT,'(11(F6.0,A))')
     &     (SCRATCH(IMODE), FLAG(IMODE), IMODE=1,3*NATOMS)
      WRITE(LUOUT,*)
      WRITE(LUOUT,20)
   20 FORMAT(3X, "Warning: Frequencies based on the updated Hessian",
     &" are not very accurate.",/,12X, "A separate frequency",
     &" calculation is required to get correct values.")
      WRITE(LUOUT,*)
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_ijk(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c---------------------------------------------------------------------------
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'

      common /d2int_com/jatom, jx, jcenter
      common /Occ_ijk/NT, Xijk(10000,7) 
      integer jatom, jx, jcenter
      double precision flags_value

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table, sind, xind, Xijk 
      double precision scalar_table(nscalar_table), tind 
      integer*8 address_table(narray_table)
      integer*8 iarray, ievec, get_index_from_base 

      integer ierr, array, array_type, ind, nind
      integer i, nseg, bseg, eseg, start(100), end(100), maxi   
      integer Nt, wind  
      integer nindex 

      double precision x(1) 

c-----------------------------------------------------------------------
c Determine the array which will hold the 7 parameters definining
c the occupied combination.  
c------------------------------------------------------------------------
 
      array      = op(c_result_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. scalar_value) then 
         print *,'Error: First array in get_ijk must be a scalar.'
         call abort_job()
      endif

      xind =  array_table(c_scalar_index, array) 
      if (xind .lt. 1 .or. xind .gt. nscalar_table) then
         print *,'Scalar table index out of range in get_ijk, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',xind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif


c-----------------------------------------------------------------------
c Determine which combination you want   
c-----------------------------------------------------------------------

      array = op(c_op1_array)
      array_type = array_table(c_array_type, array) 

      if (array_type .ne. scalar_value) then
         print *,'Error: The Second argument in get_ijk  
     *            must be a scalar.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif
 
      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in get_ijk, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif

      tind = scalar_table(xind) 
      wind = scalar_table(sind)  
c     write(6,*) ' TIND XIND SIND WIND:', tind,xind, sind, wind  

      if (tind .eq. 1.0) scalar_table(xind) = Xijk(wind,1)   
      if (tind .eq. 2.0) scalar_table(xind) = Xijk(wind,2)   
      if (tind .eq. 3.0) scalar_table(xind) = Xijk(wind,3)   
      if (tind .eq. 4.0) scalar_table(xind) = Xijk(wind,4)   
      if (tind .eq. 5.0) scalar_table(xind) = Xijk(wind,5)   
      if (tind .eq. 6.0) scalar_table(xind) = Xijk(wind,6)   
      if (tind .eq. 7.0) scalar_table(xind) = Xijk(wind,7)   
c     write(6,*) ' SCALAR = ', scalar_table(xind) 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_SP2_NBO
     +
     +                    ( NBAS,
     +
     +                            H11,H12,H13,
     +                            H21,H22,H23,
     +                            H31,H32,H33,
     +                            S,P )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_SP2_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine forms trigonal sp2 hybrids from one
C                totally symmetric s-type NBO and two p-type NBOs.
C                The sp2 hybrids are formed as follows:
C
C
C                         h1  =  m * s + 2n * p1
C                         h2  =  m * s -  n * p1 + q * p2
C                         h3  =  m * s -  n * p1 - q * p2
C
C                where:
C                                 m = 1 / sqrt (3)
C                                 n = 1 / sqrt (6)
C                                 q = 1 / sqrt (2)
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NHYB         =  total # of AO's in AO basis
C                    S            =  s-type NBO coefficient vector in
C                                    AO basis.
C                    P            =  NBAS x 2 p1- and p2-type NBO
C                                    coefficient matrix in AO basis.
C
C
C                  Output:
C
C                    Hij          =  3 x 3 matrix ij components,
C                                    containing the sp2 hybridization
C                                    coefficients: elements H11,H21,H31
C                                    define h1, elements H12,H22,H32
C                                    define h2, elements H13,H23,H33
C                                    define h3 in basis (rows): s,p1,p2
C                    S            =  h1 hybrid NBO coefficient vector
C                                    in AO basis.
C                    P            =  h2 and h3 hybrid NBO coefficient
C                                    vectors in AO basis.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     N
         INTEGER     NBAS

         DOUBLE PRECISION  A,B,C
         DOUBLE PRECISION  H11,H12,H13,H21,H22,H23,H31,H32,H33
         DOUBLE PRECISION  SQR3TH,SQR6TH,SQR2TH
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  S  (1:NBAS)
         DOUBLE PRECISION  P  (1:NBAS,1:2)

         PARAMETER   (ZERO   = 0.D0)
         PARAMETER   (SQR3TH = 0.57735026918962576450914878050195750D0)
         PARAMETER   (SQR6TH = 0.40824829046386301636621401245098191D0)
         PARAMETER   (SQR2TH = 0.70710678118654752440084436210484909D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...form the sp2 hybridization matrix elements.
C
C
         H11 = SQR3TH
         H21 = SQR6TH + SQR6TH
         H31 = ZERO
         H12 = SQR3TH
         H22 = - SQR6TH
         H32 = SQR2TH
         H13 = SQR3TH
         H23 = - SQR6TH
         H33 = - SQR2TH
C
C
C             ...form the sp2 hybrid functions.
C
C
         DO N = 1,NBAS
            A = SQR3TH * S (N)
            B = SQR6TH * P (N,1)
            C = SQR2TH * P (N,2)
            S (N)   = A + B + B
            P (N,1) = A - B + C
            P (N,2) = A - B - C
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__PRINT_A_FLOAT_3_NOZEROS
     +
     +                    ( UNITID,
     +                      TITLE,
     +                      DDROW,DDCOL,
     +                      ROW,COL,
     +                      A )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__PRINT_A_FLOAT_3_NOZEROS
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation prints a two-dimensional matrix A to
C                the unit specified by UNITID in floating point format
C                F7.3 .Values below 5.0D-4 are not printed.
C
C                The following print options are possible:
C
C                    ROW equals zero   =   upper triangle of matrix
C                    COL equals zero   =   lower triangle of matrix
C                    ROW,COL not zero  =   full matrix
C
C
C                The matrix is printed by the following algorithm:
C
C                    a) divide number of columns into blocks of 10.
C                    b) loop over all blocks.
C                            loop over all rows in matrix.
C                                 loop over all 10 columns in block.
C                    c) determine number of columns left.
C                            loop over all rows in matrix.
C                                 loop over all resting columns. 
C                    
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         INTEGER    B
         INTEGER    BLOCKS
         INTEGER    DDROW,DDCOL
         INTEGER    I,J,K,L
         INTEGER    JSTART,JEND
         INTEGER    ROW,COL
         INTEGER    UNITID
         INTEGER    WIDTH

         CHARACTER*(*)      TITLE

         CHARACTER*7       S (1:10)

         DOUBLE PRECISION   LIMIT

         DOUBLE PRECISION   A (1:DDROW,1:DDCOL)

         DATA  LIMIT  /5.0D-4/
         DATA  WIDTH  /10/
C
C
C------------------------------------------------------------------------
C
C
C             ...printout title.
C
C
         WRITE (UNITID,5000)
         WRITE (UNITID, *  ) TITLE
C
C
C             ...immediate return if both lenghts are zero.
C
C
         IF  ( ROW.EQ.0  .AND.  COL.EQ.0 )  RETURN
C
C
C             ...check dimensions.
C
C
         IF  ( ROW .GT. DDROW   .OR.
     +         COL .GT. DDCOL         )  THEN

               WRITE (1,*) ' Dimensions of matrix A too small: '
               WRITE (1,*) ' mat__print_a_float_3_nozeros '
               WRITE (1,*) ' DDROW,DDCOL,ROW,COL = ',
     +                       DDROW,DDCOL,ROW,COL

               WRITE (*,*) ' Dimensions of matrix A too small: '
               WRITE (*,*) ' mat__print_a_float_3_nozeros '
               WRITE (*,*) ' DDROW,DDCOL,ROW,COL = ',
     +                       DDROW,DDCOL,ROW,COL

               STOP

         END IF

         IF  ( ROW.EQ.0 )  THEN
C
C
C             ...upper triangle of square matrix COL*COL is printed.
C
C
               BLOCKS = COL / WIDTH
               JEND   = 0

               DO  100  B = 1,BLOCKS

                   JSTART = JEND + 1
                   JEND   = JEND + WIDTH

                   WRITE (UNITID,6000) (J,J=JSTART,JEND)
                   WRITE (UNITID,7000)

                   DO  200  I = 1,JEND
                       K = 0
                       DO  300  J = JSTART,JEND
                           K = K + 1

                           IF  ( I.GT.J )  THEN
                                S(K) = ' '
                           ELSE IF ( ABS (A(I,J)) .LT. LIMIT )  THEN
                                S(K) = ' '
                           ELSE 
                                WRITE (S(K),8000) A(I,J)
                           END IF

  300                  CONTINUE
                       WRITE (UNITID,9000) I,(S(L),L=1,WIDTH)
  200              CONTINUE

  100          CONTINUE

               JSTART = JEND + 1

               IF  ( JSTART .GT. COL )  RETURN

               WRITE (UNITID,6000) (J,J=JSTART,COL)
               WRITE (UNITID,7000)

               DO  250  I = 1,COL
                   K = 0
                   DO  350  J = JSTART,COL
                       K = K + 1

                       IF  ( I.GT.J )  THEN
                             S(K) = ' '
                       ELSE IF  ( ABS (A(I,J)) .LT. LIMIT )  THEN
                             S(K) = ' '
                       ELSE 
                             WRITE (S(K),8000) A(I,J)
                       END IF

  350              CONTINUE
                   WRITE (UNITID,9000) I,(S(L),L=1,K)
  250          CONTINUE

               RETURN

         END IF

         IF  ( COL.EQ.0 )  THEN
C
C
C             ...lower triangle of square matrix ROW*ROW is printed.
C
C
               BLOCKS = ROW / WIDTH
               JEND   = 0

               DO  400  B = 1,BLOCKS

                   JSTART = JEND + 1
                   JEND   = JEND + WIDTH

                   WRITE (UNITID,6000) (J,J=JSTART,JEND)
                   WRITE (UNITID,7000)

                   DO  500  I = JSTART,ROW
                       K = 0
                       DO  600  J = JSTART,JEND
                           K = K + 1

                           IF  ( I.LT.J )  THEN
                                S(K) = ' '
                           ELSE IF ( ABS (A(I,J)) .LT. LIMIT )  THEN
                                S(K) = ' '
                           ELSE 
                                WRITE (S(K),8000) A(I,J)
                           END IF

  600                  CONTINUE
                       WRITE (UNITID,9000) I,(S(L),L=1,WIDTH)
  500              CONTINUE

  400          CONTINUE

               JSTART = JEND + 1

               WRITE (UNITID,6000) (J,J=JSTART,ROW)
               WRITE (UNITID,7000)

               DO  550  I = JSTART,ROW
                   K = 0
                   DO  650  J = JSTART,ROW
                       K = K + 1

                       IF  ( I.LT.J )  THEN
                             S(K) = ' '
                       ELSE IF  ( ABS (A(I,J)) .LT. LIMIT )  THEN
                             S(K) = ' '
                       ELSE 
                             WRITE (S(K),8000) A(I,J)
                       END IF

  650              CONTINUE
                   WRITE (UNITID,9000) I,(S(L),L=1,K)
  550          CONTINUE

               RETURN

         END IF
C
C
C             ...full matrix ROW*COL is printed.
C
C
         BLOCKS = COL / WIDTH
         JEND   = 0

         DO  700  B = 1,BLOCKS

             JSTART = JEND + 1
             JEND   = JEND + WIDTH

             WRITE (UNITID,6000) (J,J=JSTART,JEND)
             WRITE (UNITID,7000)

             DO  800  I = 1,ROW
                 K = 0
                 DO  900  J = JSTART,JEND
                     K = K + 1

                     IF  ( ABS (A(I,J)) .LT. LIMIT )  THEN
                           S(K) = ' '
                     ELSE 
                           WRITE (S(K),8000) A(I,J)
                     END IF

  900            CONTINUE
                 WRITE (UNITID,9000) I,(S(L),L=1,WIDTH)
  800        CONTINUE

  700    CONTINUE

         JSTART = JEND + 1

         IF  ( JSTART .GT. COL )  RETURN

         WRITE (UNITID,6000) (J,J=JSTART,COL)
         WRITE (UNITID,7000)

         DO  850  I = 1,ROW
             K = 0
             DO  950  J = JSTART,COL
                 K = K + 1

                 IF  ( ABS (A(I,J)) .LT. LIMIT )  THEN
                       S(K) = ' '
                 ELSE 
                       WRITE (S(K),8000) A(I,J)
                 END IF

  950        CONTINUE
             WRITE (UNITID,9000) I,(S(L),L=1,K)
  850    CONTINUE
C
C
C             ...formats of printing.
C
C
 5000    FORMAT  (/)
 6000    FORMAT  (/,3X,10I7)
 7000    FORMAT  ()
 8000    FORMAT  (F7.3)
 9000    FORMAT  (1X,I3,1X,10A7)
C
C
C             ...ready!
C
C
         RETURN
         END

#ifdef __fortran77

C This subroutine should return the current time information
C in its parameters. Add another IFDEF group for your
C architecture/OS and enjoy!

      subroutine wallclock(year,month,day,hour,minute,second)

c#include <aces.h>

      integer year,month,day,hour,minute,second

#ifdef _AIX      
c     Please note the underscores!
      integer*4 currtime,time_
      integer*4 tarray(9)
      currtime=time_()
      call ltime_(currtime, tarray)
      second=tarray(1)
      minute=tarray(2)
      hour=tarray(3)
      day=tarray(4)
      month=tarray(5)
      year=tarray(6)+1900
c      day of week: tarray(7)
c      day of year: tarray(8)
c      daylight savings time: tarray(9)
#endif /* _AIX */

#ifdef _SUNOS
      integer*4 iarray (3)
      call idate(iarray)
      day=iarray(1)
      month=iarray(2)
      year=iarray(3)
      call itime(iarray)
      hour=iarray(1)
      minute=iarray(2)
      second=iarray(3)
#endif /* _SUNOS */

#ifdef _UNICOS
      character*8 cdate, ctime
      integer conv_char_int
      call date(cdate)
      month = 10*conv_char_int(cdate(1:1))
     &    + conv_char_int(cdate(2:2))
      day = 10*conv_char_int(cdate(4:4))
     &    + conv_char_int(cdate(5:5))
      year = 10*conv_char_int(cdate(7:7))
     &    + conv_char_int(cdate(8:8))
      call clock(ctime)
      hour = 10*conv_char_int(ctime(1:1))
     &    + conv_char_int(ctime(2:2))
      minute = 10*conv_char_int(ctime(4:4))
     &    + conv_char_int(ctime(5:5))
      second = 10*conv_char_int(ctime(7:7))
     &    + conv_char_int(ctime(8:8))
#endif /* _UNICOS */

#ifdef _IRIX
      integer*4 currtime,time_
      integer*4 tarray(9)
      currtime=time_()
      call ltime_(currtime, tarray)
      second=tarray(1)
      minute=tarray(2)
      hour=tarray(3)
      day=tarray(4)
      month=tarray(5)
      year=tarray(6)+1900
#endif /* _IRIX */

#ifdef _DEC
#   ifdef F_64BIT
      integer*4 iarray (3)
      external idate
      external itime
      call idate(iarray)
      day=iarray(1)
      month=iarray(2)
      year=iarray(3)
#   else
      integer iarray (3)
      call idate(month,day,year)
      year=year+1900
#   endif /* F_64BIT */
      call itime(iarray)
      hour=iarray(1)
      minute=iarray(2)
      second=iarray(3)
#endif /* _DEC */

c#ifdef M_IP22
c      integer iarray (3)
c      call idate (month, day, year)
c      call itime (iarray)
c      hour=iarray(1)
c      minute=iarray(2)
c      second=iarray(3)
c#endif

CC#ifdef M_HPUX
C      integer iarray (3)
C      call idate(month,day,year)
C      year=year+1900
C      call itime(iarray)
C      hour=iarray(1)
C      minute=iarray(2)
C      second=iarray(3)
CC..#ELSE
C      This subroutine needs FPP processing.
C#ENDIF

      return
      end

#elif defined(__ansi_c)

#include <time.h>

void
#ifdef C_SUFFIX
wallclock_
#else
wallclock
#endif /* C_SUFFIX */
( long * year, long * mon, long * mday, long * hour, long * min, long * sec )
{
    /*
     * Relevant members of the tm struct:
     * int tm_sec
     * int tm_min
     * int tm_hour
     * int tm_mday
     * int tm_mon
     * int tm_year
     */

    time_t    now_clock;
    struct tm now;

    time(&now_clock);
    now = *localtime(&now_clock);

 /* MUWAHAHAHAHA! ACES is not fully Y2K compliant! */
    *year = now.tm_year +1900;
    *mon  = now.tm_mon  +1;
    *mday = now.tm_mday;
    *hour = now.tm_hour;
    *min  = now.tm_min;
    *sec  = now.tm_sec;

    return;
}

#else
CRASH HARD!
#endif /* __fortran77 */
 

c This routine stores NCOLS columns starting at column IFIRST
c of an in-core double precision 2-dimensional array.

c INPUT
c double ISRC : the source array
c               NOTE: Internally, this is treated as an integer array
c                     since a counter runs across both ISRC and ICORE.
c int IFIRST : the index of the first column to store
c int NCOLS  : the number of columns to store
c int XCACHE : the cache buffer for the I/O operation (unused)
c              = 1; T amplitudes
c              = 2; integrals
c int ILEFT  : the left  (row) address index of the array [MOIO(ILEFT,IRIGHT)]
c int IRIGHT : the right (col) address index of the array [MOIO(ILEFT,IRIGHT)]

c#define _DEBUG_PUTLST

      subroutine putlst(iSrc,iFirst,nCols,xCache,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iSrc(*), iFirst, nCols, xCache, iLeft, iRight

c EXTERNAL FUNCTIONS
      double precision dnrm2

c INTERNAL VARIABLES
      integer iFileNum, iStat
      integer nRows
      integer iRec, iRecNdx, iTmp
      integer nLeft, nPut, iOff
      integer iPos
#ifdef OPEN_LISTS_AS_NEEDED
#include "szfiles.dat"
      integer ihFile
      character*80 szFile
      integer      iLength
      logical bExist
#endif

c COMMON BLOCKS
#include "icore.com" /* for icore */
#include "lists.com" /* for moio info */
#include "machsp.com" /* for iintfp */
#include "filspc.com" /* for iprcwd */
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@PUTLST: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iTmp = 1
      end if
c   o assert iFirst > 0 and nCols >= 0
      if ((iFirst.lt.1).or.(nCols.lt.0)) then
         print *, '@PUTLST: Assertion failed.'
         print *, '   iFirst = ',iFirst
         print *, '   nCols  = ',nCols
         iTmp = 1
      end if
c   o assert iLeft and iRight are properly bound
      if ((iLeft .lt.1).or.(_MAX_IO_GRPS.lt.iLeft ).or.
     &    (iRight.lt.1).or.(_MAX_IO_FAMS.lt.iRight)    ) then
         print *, '@PUTLST: Assertion failed.'
         print *, '   iRight = ',iRight
         print *, '   iLeft  = ',iLeft
         iTmp = 1
      end if
c   o assert the list was touched
      if (moio(iLeft,iRight).lt.1) then
         print *, '@PUTLST: Assertion failed.'
         print *, '   List (',iLeft,',',iRight,') does not exist.'
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o look up the length of one column
      nRows = moiosz(iLeft,iRight)

      if ((nRows.lt.1).or.(nCols.lt.1)) return

c   o make sure the column range requested is properly bound
      iTmp = moiods(iLeft,iRight)
      if ((iFirst.lt.1).or.(iTmp.lt.iFirst).or.
     &    (iTmp.lt.(iFirst-1+nCols))           ) then
         print *, '@PUTLST: Error reading list (',iLeft,',',iRight,')'
         print *, '         cols available = ',iTmp
         print *, '         cols addressed = ',nCols
         print *, '         range start    = ',iFirst
         call aces_exit(1)
      end if

c   o do a fast in-core dump to the auxiliary cache
      if (quikget(iLeft,iRight).ne.0) then
         iPos = quikget(iLeft,iRight) + nRows*(iFirst-1)*iintfp
         call xcopy(nRows*nCols,iSrc,1,icore(iPos),1)
         return
      end if

c   o determine which file this array lives in
      iFileNum = moiofl(iLeft,iRight)

#ifdef OPEN_LISTS_AS_NEEDED
c   o open the file that contains this array
      ihFile = 1+iFileNum-_FIRST_IO_LUN
      call gfname(szFiles(ihFile),szFile,iLength)
      inquire(file=szFile(1:iLength),exist=bExist,err=666,iostat=iStat)
      if (bExist) then
         call aces_io_open(ihFile)
      else
         print *, '@PUTLST: "',szFile(1:iLength),'" - file not found'
         call aces_exit(1)
      end if
#endif

c   o find the first record and integer index that point to the first element
      iRecNdx = moiowd(iLeft,iRight) + nRows*(iFirst-1)*iintfp
      iTmp    = (iRecNdx-1)/iprcwd
      iRec    = moio(iLeft,iRight) + iTmp
      iRecNdx = iRecNdx            - iTmp*iprcwd

#ifdef _DEBUG_PUTLST
      print *, '@PUTLST: writing cols',iFirst,' -',iFirst+nCols-1,
     &         ' of list',iLeft,',',iRight
      print *, '         file',iFileNum,', rec',iRec,', index',iRecNdx
#endif

c   o do the first partial record and then loop over whole records
c     which contain the remaining data
      nLeft = nRows*nCols*iintfp
      nPut  = min(nLeft,iprcwd+1-iRecNdx)
      call putlst_io(iSrc,iFileNum,iRec,iRecNdx,nPut)
      iOff  = 1     + nPut
      nLeft = nLeft - nPut
      do while (nLeft.ne.0)
         nPut = min(nLeft,iprcwd)
         iRec = iRec + 1
         call putlst_io(iSrc(iOff),iFileNum,iRec,1,nPut)
         iOff  = iOff  + nPut
         nLeft = nLeft - nPut
      end do

#ifdef OPEN_LISTS_AS_NEEDED
c   o close the file
      close(unit=iFileNum,status='KEEP',err=666,iostat=iStat)
#endif

      return

c   o I/O error
 666  print *, '@PUTLST: I/O error'
      print *, '         list = [',iLeft,',',iRight,']'
      print '(/)'
      call aces_io_error('PUTLST',iFileNum,iStat)

c     end subroutine putlst
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL3C_SET_IJK
     +
     +                    ( NCGTOA,NCGTOB,NCGTOC,
     +                      NPGTOA,NPGTOB,NPGTOC,
     +                      SHELLA,SHELLB,SHELLC,
     +                      EQUALAB,EQUALAC,EQUALBC,
     +                      XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,
     +                      RNABSQ,RNACSQ,RNBCSQ,
     +                      INDEXA,INDEXB,INDEXC,
     +                      LEXPA,LEXPB,LEXPC,
     +                      LCCA,LCCB,LCCC,
     +                      LCCSEGA,LCCSEGB,LCCSEGC,
     +
     +                             NCGTOI,NCGTOJ,NCGTOK,NCGTOIJ,
     +                             NPGTOI,NPGTOJ,NPGTOK,NPGTOIJ,
     +                             SHELLI,SHELLJ,SHELLK,
     +                             EQUALIJ,EQUALIK,EQUALJK,
     +                             XI,YI,ZI,XJ,YJ,ZJ,XK,YK,ZK,
     +                             RNIJSQ,RNIKSQ,RNJKSQ,
     +                             SWAPAC,SWAPBC,SWAPRS,
     +                             INDEXI,INDEXJ,INDEXK,
     +                             LEXPI,LEXPJ,LEXPK,
     +                             LCCI,LCCJ,LCCK,
     +                             LCCSEGI,LCCSEGJ,LCCSEGK )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL3C_SET_IJK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation defines the abc -> ijk map for optimum
C                performance of the contraction steps.
C
C                The contraction step from primitive to contracted
C                [F00] 3-center overlap integrals will be performed
C                in two steps in the following order:
C
C                        1) contract over a single index k
C                        2) contract over index pairs ij.
C
C                Only the last contraction step over the index pairs
C                can accomodate any restriction i>=j due to shell
C                equalities. Since shell equalities can arise between
C                all possible shell pairs ab,ac and bc, a remapping
C                has to be performed: a,b,c -> i,j,k to adjust for
C                the contraction steps. Two criteria are used for
C                the mapping:
C
C                  If any two shells xy are equal then:
C
C                              xy
C                              ab,c -> ij,k    (no swap)
C                              ac,b -> ij,k    (swap b <-> c)
C                              cb,a -> ij,k    (swap a <-> c)
C                  else
C                     if # of 'a' prim >= b,c:  a -> k   (swap a <-> c)
C                     if # of 'b' prim >= a,c:  b -> k   (swap b <-> c)
C                     if # of 'c' prim >= a,b:  c -> k   (no swap)
C                  endif
C
C                Note, that this scheme does not consider the purely
C                atomic case where all shells are equal, which could
C                in principle use the index restrictions i>=j>=k.
C                The reason lies in the way the contraction step is
C                splitted into the two parts mentioned above. However
C                these cases present only a minute fraction during
C                an electronic structure calculation, hence efficieny
C                of the package will not be affected.
C
C                In case any two shells are equal, the corresponding
C                i>=j index restriction is transmitted via setting
C                EQUALIJ = .TRUE.
C
C
C                  Input (x = A,B and C):
C
C                   NCGTOx        =  # of contractions for csh x
C                   NPGTOx        =  # of primitives per contraction
C                                    for csh x
C                   SHELLx        =  the shell type for csh x
C                   EQUALxy       =  indicates, if csh x and csh y are
C                                    considered to be equal for the
C                                    pairs AB,AC and BC
C                   Xy,Yy,Zy      =  the x,y,z-coordinates for centers
C                                    y = A,B and C
C                   RNxySQ        =  square of the magnitude of the
C                                    distance between centers xy = AB,AC
C                                    and BC
C                   INDEXx        =  index A,B,C -> 1,2,3 map
C                   LEXPx         =  pointers to locate appropriate
C                                    section of the exponent array
C                                    corresponding to csh x
C                   LCCx          =  pointers to locate appropriate
C                                    section of the contraction coeff
C                                    array corresponding to csh x
C                   LCCSEGx       =  pointers to locate appropriate
C                                    section of the lowest and highest
C                                    primitive index array defining
C                                    segmented contraction boundaries
C                                    for csh x
C
C                  Output (x = I,J and K):
C
C                   NCGTOx        =  # of contractions for csh x
C                   NCGTOIJ       =  # of contractions to handle for
C                                    the csh pair I,J
C                   NPGTOx        =  # of primitives per contraction
C                                    for csh x
C                   NPGTOIJ       =  # of primitive pairs to handle for
C                                    contraction csh pair I,J
C                   SHELLx        =  the shell type for csh x
C                   EQUALxy       =  indicates, if csh x and csh y are
C                                    considered to be equal for the
C                                    pairs IJ,IK and JK
C                   Xy,Yy,Zy      =  the x,y,z-coordinates for centers
C                                    y = I,J and K
C                   RNxySQ        =  square of the magnitude of the
C                                    distance between centers xy = IJ,IK
C                                    and JK
C                   SWAPxy        =  is .true., if a swap x <-> y has
C                                    been performed for xy = AC and BC
C                   SWAPRS        =  is set .true. if the contraction
C                                    order of the primitives pair IJ
C                                    will be performed in reverse order
C                                    JI for efficiency reasons
C                   INDEXx        =  index I,J,K -> 1,2,3 map
C                   LEXPx         =  pointers to locate appropriate
C                                    section of the exponent array
C                                    corresponding to csh x
C                   LCCx          =  pointers to locate appropriate
C                                    section of the contraction coeff
C                                    array corresponding to csh x
C                   LCCSEGx       =  pointers to locate appropriate
C                                    section of the lowest and highest
C                                    primitive index array defining
C                                    segmented contraction boundaries
C                                    for csh x
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   EQUALAB,EQUALAC,EQUALBC
         LOGICAL   EQUALIJ,EQUALIK,EQUALJK
         LOGICAL   NPAMAX,NPBMAX
         LOGICAL   SWAPAC,SWAPBC,SWAPRS

         INTEGER   INDEXA,INDEXB,INDEXC
         INTEGER   INDEXI,INDEXJ,INDEXK
         INTEGER   LCCA,LCCB,LCCC
         INTEGER   LCCI,LCCJ,LCCK
         INTEGER   LCCSEGA,LCCSEGB,LCCSEGC
         INTEGER   LCCSEGI,LCCSEGJ,LCCSEGK
         INTEGER   LEXPA,LEXPB,LEXPC
         INTEGER   LEXPI,LEXPJ,LEXPK
         INTEGER   NCGTOA,NCGTOB,NCGTOC
         INTEGER   NCGTOI,NCGTOJ,NCGTOK,NCGTOIJ
         INTEGER   NPGTOA,NPGTOB,NPGTOC
         INTEGER   NPGTOI,NPGTOJ,NPGTOK,NPGTOIJ
         INTEGER   SHELLA,SHELLB,SHELLC
         INTEGER   SHELLI,SHELLJ,SHELLK

         DOUBLE PRECISION  RNABSQ,RNACSQ,RNBCSQ
         DOUBLE PRECISION  RNIJSQ,RNIKSQ,RNJKSQ
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         DOUBLE PRECISION  XI,YI,ZI,XJ,YJ,ZJ,XK,YK,ZK
C
C
C------------------------------------------------------------------------
C
C
C             ...determine primitives index restrictions and their
C                index order. Remap associated data: a,b,c -> i,j,k.
C
C
         NPAMAX = (NPGTOA.GE.NPGTOB) .AND. (NPGTOA.GE.NPGTOC)
         NPBMAX = (NPGTOB.GE.NPGTOA) .AND. (NPGTOB.GE.NPGTOC)

         IF (EQUALAB) THEN
             SWAPAC = .FALSE.
             SWAPBC = .FALSE.
             NPGTOIJ = NPGTOA * (NPGTOA + 1) / 2
             NCGTOIJ = NCGTOA * (NCGTOA + 1) / 2
         ELSE IF (EQUALAC) THEN
             SWAPAC = .FALSE.
             SWAPBC = .TRUE.
             NPGTOIJ = NPGTOA * (NPGTOA + 1) / 2
             NCGTOIJ = NCGTOA * (NCGTOA + 1) / 2
         ELSE IF (EQUALBC) THEN
             SWAPAC = .TRUE.
             SWAPBC = .FALSE.
             NPGTOIJ = NPGTOB * (NPGTOB + 1) / 2
             NCGTOIJ = NCGTOB * (NCGTOB + 1) / 2
         ELSE
             IF (NPAMAX) THEN
                 SWAPAC = .TRUE.
                 SWAPBC = .FALSE.
                 NPGTOIJ = NPGTOB * NPGTOC
                 NCGTOIJ = NCGTOB * NCGTOC
             ELSE IF (NPBMAX) THEN
                 SWAPAC = .FALSE.
                 SWAPBC = .TRUE.
                 NPGTOIJ = NPGTOA * NPGTOC
                 NCGTOIJ = NCGTOA * NCGTOC
             ELSE
                 SWAPAC = .FALSE.
                 SWAPBC = .FALSE.
                 NPGTOIJ = NPGTOA * NPGTOB
                 NCGTOIJ = NCGTOA * NCGTOB
             END IF
         END IF

         IF (SWAPAC) THEN
             XI = XC
             XJ = XB
             XK = XA
             YI = YC
             YJ = YB
             YK = YA
             ZI = ZC
             ZJ = ZB
             ZK = ZA
             EQUALIJ = EQUALBC
             EQUALIK = EQUALAC
             EQUALJK = EQUALAB
             LCCI = LCCC
             LCCJ = LCCB
             LCCK = LCCA
             LCCSEGI = LCCSEGC
             LCCSEGJ = LCCSEGB
             LCCSEGK = LCCSEGA
             LEXPI = LEXPC
             LEXPJ = LEXPB
             LEXPK = LEXPA
             INDEXI = INDEXC
             INDEXJ = INDEXB
             INDEXK = INDEXA
             NCGTOI = NCGTOC
             NCGTOJ = NCGTOB
             NCGTOK = NCGTOA
             NPGTOI = NPGTOC
             NPGTOJ = NPGTOB
             NPGTOK = NPGTOA
             SHELLI = SHELLC
             SHELLJ = SHELLB
             SHELLK = SHELLA
             RNIJSQ = RNBCSQ
             RNIKSQ = RNACSQ
             RNJKSQ = RNABSQ
         ELSE IF (SWAPBC) THEN
             XI = XA
             XJ = XC
             XK = XB
             YI = YA
             YJ = YC
             YK = YB
             ZI = ZA
             ZJ = ZC
             ZK = ZB
             EQUALIJ = EQUALAC
             EQUALIK = EQUALAB
             EQUALJK = EQUALBC
             LCCI = LCCA
             LCCJ = LCCC
             LCCK = LCCB
             LCCSEGI = LCCSEGA
             LCCSEGJ = LCCSEGC
             LCCSEGK = LCCSEGB
             LEXPI = LEXPA
             LEXPJ = LEXPC
             LEXPK = LEXPB
             INDEXI = INDEXA
             INDEXJ = INDEXC
             INDEXK = INDEXB
             NCGTOI = NCGTOA
             NCGTOJ = NCGTOC
             NCGTOK = NCGTOB
             NPGTOI = NPGTOA
             NPGTOJ = NPGTOC
             NPGTOK = NPGTOB
             SHELLI = SHELLA
             SHELLJ = SHELLC
             SHELLK = SHELLB
             RNIJSQ = RNACSQ
             RNIKSQ = RNABSQ
             RNJKSQ = RNBCSQ
         ELSE
             XI = XA
             XJ = XB
             XK = XC
             YI = YA
             YJ = YB
             YK = YC
             ZI = ZA
             ZJ = ZB
             ZK = ZC
             EQUALIJ = EQUALAB
             EQUALIK = EQUALAC
             EQUALJK = EQUALBC
             LCCI = LCCA
             LCCJ = LCCB
             LCCK = LCCC
             LCCSEGI = LCCSEGA
             LCCSEGJ = LCCSEGB
             LCCSEGK = LCCSEGC
             LEXPI = LEXPA
             LEXPJ = LEXPB
             LEXPK = LEXPC
             INDEXI = INDEXA
             INDEXJ = INDEXB
             INDEXK = INDEXC
             NCGTOI = NCGTOA
             NCGTOJ = NCGTOB
             NCGTOK = NCGTOC
             NPGTOI = NPGTOA
             NPGTOJ = NPGTOB
             NPGTOK = NPGTOC
             SHELLI = SHELLA
             SHELLJ = SHELLB
             SHELLK = SHELLC
             RNIJSQ = RNABSQ
             RNIKSQ = RNACSQ
             RNJKSQ = RNBCSQ
         END IF
C
C
C             ...set the control variable to determine contraction
C                order between csh I and J
C
C
         SWAPRS = NPGTOI .GT. NPGTOJ
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE DUMP(ZLIST,FILE,RECNUM,IWRDOFF,NWORDS)
C
C THIS ROUTINE IS A DEPENDENT OF PUTLST AND PERFORMS THE
C  REQUIRED LOGIC TO WRITE A DIRECT ACCESS RECORD.  IT IS
C  EITHER WRITTEN TO THE CACHE AREA OR TO DISK.
C
CEND
C
C SG 6/5/96 If a full record is being written, do not copy it to the cache.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION ZLIST(1)
      COMMON // ICORE(1)
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MACHSP2/ MASK1,MASK2,ISHFSZ
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
cjp
cjp just for info for printout
#include "bwcc.com"
C
      IPACK(I,J)=IOR(J,ISHFT(I-49,ISHFSZ))
      UPACKR(I) =IAND(I,MASK1)
      UPACKF(I) =IAND(ISHFT(I,-ISHFSZ),MASK2)+49
C
C CHECK TO SEE IF THE RECORD IS IN THE CACHE.  IF IT IS, IIEQ WILL
C  RETURN A VALUE IN THE RANGE 1-CACHNUM.
C
      ITEST=IPACK(FILE,RECNUM)
      ILOC=IIEQ(CACHNUM,CACHDIR,1,ITEST)

C IF THE CORRECT RECORD (FILE MUST MATCH AS WELL) IS IN THE CACHE,
C  THE JUST COPY ZLIST TO IT AND LEAVE, BUT SET THE MODIFICATION
C  FLAG FIRST.
C
      IF(ILOC.NE.0)THEN
       IADR=CACHPOS(ILOC)
       IPOS=IADR+IWRDOFF-1
cjp debug
       if(bwgossip) write(6,*) 'DUMP: cache hit!'
       CALL ICOPY(NWORDS,ZLIST,1,ICORE(IPOS),1)
       CACHMOD(ILOC)=1
      ELSEIF (NWORDS .EQ. LENREC) THEN
        CALL ACES_IO_WRITE(FILE,RECNUM,ZLIST,LENREC)
      ELSE
C
C THE RECORD MUST BE PICKED UP FROM DISK.  DUMP OLDEST SURVIVING RECORD
C  TO DISK IF IT HAS BEEN MODIFIED.  OTHERWISE, COPY OVER IT AND THEN
C  PUT INFORMATION OVER IT.
C
       IF(CACHMOD(OLDEST).NE.0)THEN
        IADR=CACHPOS(OLDEST)
        FILEOUT=UPACKF(CACHDIR(OLDEST))
        RECWRT=UPACKR(CACHDIR(OLDEST))
        CALL ACES_IO_WRITE(FILEOUT,RECWRT,ICORE(CACHPOS(OLDEST)),LENREC)
       ENDIF
       CALL ACES_IO_READ(FILE,RECNUM,ICORE(CACHPOS(OLDEST)),LENREC)
       CACHFILE(OLDEST)=FILE
       CACHDIR (OLDEST)=IPACK(FILE,RECNUM)
       IPOS=CACHPOS(OLDEST)+IWRDOFF-1
       CALL ICOPY(NWORDS,ZLIST,1,ICORE(IPOS),1)
       CACHMOD(OLDEST)=1
       OLDEST=OLDEST+1
       IF(OLDEST.GT.CACHNUM)OLDEST=1
      ENDIF
C
cjp
cjp for debug purposes in order to identify exactly, when some
cjp modifications of files occured, switch off caching mechanism
cjp by flushing caches immediatelly

cjp  call aces_cache_flush

      RETURN
      END

      Subroutine FIXORI (NAtms, Q, At1, At2, OldOri)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      Integer NAtms, At1, At2, OldOri
      Dimension Q(3*NAtms),ORIENT(3,3),ORIENT2(3,3)
C
      Integer NewOri
      Double Precision NewVec(3), Tmp
C     Define the "Standard I/O" units to use throughout the code
      Parameter (LuIn  = 5)
      Parameter (LuOut = 6)
      Parameter (LuErr = 6)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
C     Its quite possible that there won't be anything to check...
C
      If (At1 .eq. 0 .AND. At2 .eq. 0 .AND. OldOri .eq. 0) Return
C
C     Get the vector from At1 to At2 and find out how it is directed
C
      Call VAdd(NewVec, Q(3*(At2-1)+1), Q(3*(At1-1)+1),3,-1.D0)
      Call Normal(NewVec,3)
      NewOri = NInt(NewVec(1)) + 2*NInt(NewVec(2))
     $   + 3*NInt(NewVec(3))
C
C     Check to see if this orientation is the same as last time.  If
C     not, interchange x and y axes, keeping the coordinate frame
C     right-handed.
C
C     Note:  Handedness of frame may change eariler, so atoms may now
C     be connected by the *opposite* vector.  This is okay.
C
      If (Abs(NewOri) .ne. Abs(OldOri)) then
         ININE=9
         CALL GETREC(20,'JOBARC','ORIENT2 ',ININE*IINTFP,ORIENT2)
         CALL GETREC(20,'JOBARC','ORIENTMT',ININE*IINTFP,ORIENT)
         Write (LuOut, 9000)
 9000    Format ('@FIXORI-I, Rotating about z-axis to ',
     $      'match previous orientation.')
         Do 100 i = 1, NAtms
            Tmp = Q(3*(i-1)+1)
            Q(3*(i-1)+1) = Q(3*(i-1)+2)
            Q(3*(i-1)+2) = -Tmp
 100     Continue
         TMP=ORIENT(1,1)
         ORIENT(1,1)=ORIENT(2,2)
         ORIENT(2,2)=TMP
         TMP=ORIENT(1,2)
         ORIENT(1,2)=ORIENT(2,1)
         ORIENT(2,1)=TMP
         TMP=ORIENT2(1,1)
         ORIENT2(1,1)=ORIENT2(2,2)
         ORIENT2(2,2)=TMP
         TMP=ORIENT2(1,2)
         ORIENT2(1,2)=ORIENT2(2,1)
         ORIENT2(2,1)=TMP
         CALL PUTREC(20,'JOBARC','ORIENT2 ',ININE*IINTFP,ORIENT2)
         CALL PUTREC(20,'JOBARC','ORIENTMT',ININE*IINTFP,ORIENT)
         CALL PUTREC(20,'JOBARC','COORD   ',NATMS*3*IINTFP,Q)
      EndIf
      Return
      End

c This routine initializes the syminf common block.
c The code for the direct product table was taken straight from VMOL.

      subroutine aces_com_syminf
      implicit none

c INTERNAL VARIABLES
      integer i, j, k
      integer zMin, zMax
      logical bTmp

c COMMON BLOCKS
#include "syminf.com"

c INLINE FUNCTIONS
      integer ka
      ka(i,k) = (i-1)/(2**(k-1)) - 2*((i-1)/(2**k))

c ----------------------------------------------------------------------

c   o nirrep
      call getrec(-1,'JOBARC','COMPNIRR',1,nirrep)

c   o irrep a/b
c???      norbs=nocco(1)+nvrto(1)
c???      call getrec(-1,'JOBARC','IRREPALP',norbs,irrepa)
c???      call getrec(-1,'JOBARC','IRREPBET',norbs,irrepb)

c   o dirprd
      do i = 1, 8
      do j = 1, 8
         zMin = 1
         zMax = 1
         do k = 1, 3
            zMin = zMin + ( min(ka(i,k),ka(j,k)) * 2**(k-1) )
            zMax = zMax + ( max(ka(i,k),ka(j,k)) * 2**(k-1) )
         end do
         dirprd(i,j) = 1 + zMax - zMin
      end do
      end do

#ifdef _DEBUG
c   o try to print this info just once
c     (should we bother trapping this with err/iostat?)
      inquire(file='JAINDX',exist=bTmp)
      if (.not.bTmp) then
         if (nirrep.gt.0) then
            print *, '@ACES_COM_SYMINF: direct product table ='
            do i = 1, nirrep
               print '(8i3)', (dirprd(i,j),j=1,nirrep)
            end do
         end if
      end if
#endif

      return
c     end subroutine aces_com_syminf
      end

c This routine initializes the syminf common block.
c The code for the direct product table was taken straight from VMOL.

      subroutine aces_com_syminf
      implicit none

c INTERNAL VARIABLES
      integer i, j, k
      integer zMin, zMax
      logical bTmp

c COMMON BLOCKS
c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end

c INLINE FUNCTIONS
      integer ka
      ka(i,k) = (i-1)/(2**(k-1)) - 2*((i-1)/(2**k))

c ----------------------------------------------------------------------

c   o nirrep
      call getrec(-1,'JOBARC','COMPNIRR',1,nirrep)

c   o irrep a/b
c???      norbs=nocco(1)+nvrto(1)
c???      call getrec(-1,'JOBARC','IRREPALP',norbs,irrepa)
c???      call getrec(-1,'JOBARC','IRREPBET',norbs,irrepb)

c   o dirprd
      do i = 1, 8
      do j = 1, 8
         zMin = 1
         zMax = 1
         do k = 1, 3
            zMin = zMin + ( min(ka(i,k),ka(j,k)) * 2**(k-1) )
            zMax = zMax + ( max(ka(i,k),ka(j,k)) * 2**(k-1) )
         end do
         dirprd(i,j) = 1 + zMax - zMin
      end do
      end do


      return
c     end subroutine aces_com_syminf
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_eps(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table, 
     *                      op)
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'proto_events.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)

      integer eps, i, n, ind
      integer ierr
      integer master, pst_get_master
      integer status(mpi_status_size)
      logical msg_present

      include 'int_gen_parms.h'
      include 'epsilon.h'

      integer company_comm, pst_get_company_comm

      double precision xxx(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, xxx)
#else
      common xxx
      equivalence (ibuf, xxx)
#endif

c-------------------------------------------------------------------------
c   Locate array address in array_table.
c-------------------------------------------------------------------------

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      eps    = op(c_result_array)

c--------------------------------------------------------------------------
c   Determine size of epsilon array.
c--------------------------------------------------------------------------

      ind = array_table(c_index_array1,eps)
      n   = index_table(c_index_size,ind)
      master = pst_get_master()
      if (me .eq. master) then
         do i = 1, nepsa
            epsilon(i) = xxx(iepsa+i-1)
         enddo

         do i = 1, nepsb
            epsilonb(i) = xxx(iepsb+i-1)
         enddo 
      endif

      company_comm = pst_get_company_comm(me)
      call mpi_bcast(epsilon, nepsa, mpi_double_precision, master,
     *               company_comm, ierr)
      if (nepsb .gt. 0) 
     *   call mpi_bcast(epsilonb, nepsb, mpi_double_precision, master,
     *               company_comm, ierr)
      return
      end

      PROGRAM TOGOPENMOL
c     
C     This program generates a cube file from an ACESII
C     calculation.
C     
C     Written by Tommy Miller, Quantum Theory Project,
C     University of Florida, 1998
C     
C     A portion of the source code and a number
C     of the subroutines were extracted from the HFDFT code
C     written by Nevin Oliphant, Quantum Theory Project,
C     University of Florida, 1993. Also, I would like to
C     thank Ken Wilson and Drs. John Watts and Ajith Perera for their
C     valuable time and assistance.
c     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)     
C     Characters for determining symmetry elements
      CHARACTER*1 SYMEL(3,3)
      CHARACTER*8 PGRP
      CHARACTER*12 STRIAORBO
      CHARACTER*12 STRIAORBD
      CHARACTER*12 STRICORR
      CHARACTER*12 STRIDORO
      CHARACTER*12 STRINORBS
      CHARACTER*12 STRINUMCUBE
      integer err
C     
      LOGICAL::YESNO
C     
      DIMENSION NOCC(16),ISHL(6),IORBVEC(9)
C     
      COMMON//ICORE(1)
      COMMON /ISTART/ I0
      COMMON /IOPOS/ ICRSIZ,ICHSZ,IOFF(2),LENREC
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(10)
      COMMON /FLAGS2/ IFLAGS2(50)
      COMMON /ISYMINF/ NIRREP,NSOIRP(8)
      COMMON /CNST/ALPHA,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12,X13,X14,X15
      COMMON /PAR/ PI,PIX4
      COMMON /IPAR/ LUOUT
C     
CXXXXXXXXXXXXXXXXXXXXX
C     READ IN THE OPTIONS FROM THE ZMAT FILE
CXXXXXXXXXXXXXXXXXXXXX
C     
C     Open the ZMAT file and search for the cube_gen namelist
      CALL NL_INIT('cube_gen',err,.true.)
      if(err.eq.1)then
         write(*,*)' *cube_gen namelist not found in ZMAT file'
         call errex
      end if
C     
C     Determine the number of cube files to be created.
      CALL NL_STR('NUM_CUBE','ONE',STRINUMCUBE)
C     
C     Interpret STRINUMCUBE:
      IF (STRINUMCUBE.EQ.'ONE') THEN
         NUMCUBE=1
         IDDIFF=0
      ELSE IF (STRINUMCUBE.EQ.'TWO') THEN
         NUMCUBE=2
         IDDIFF=0
      ELSE IF (STRINUMCUBE.EQ.'DEN_DIFF') THEN
         NUMCUBE=2
         IDDIFF=1
      END IF
C     
C     Loop over the cube files.
C     
      DO 911 ICUBE=1,NUMCUBE
C     
         IF (ICUBE.EQ.2) CALL NL_INIT('cube2_gen',err,.true.)
C     
C     Read in the upper and lower boundaries of the cube
         CALL NL_REAL('TVALX', 3.0D+00,TVALX)
         CALL NL_REAL('BVALX',-3.0D+00,BVALX)
         CALL NL_REAL('TVALY', 3.0D+00,TVALY)
         CALL NL_REAL('BVALY',-3.0D+00,BVALY)
         CALL NL_REAL('TVALZ', 3.0D+00,TVALZ)
         CALL NL_REAL('BVALZ',-3.0D+00,BVALZ)
C     
C     Read in the number of interval along each axis
         CALL NL_INT('NPTSX',27,NPTSX)
         CALL NL_INT('NPTSY',27,NPTSY)
         CALL NL_INT('NPTSZ',27,NPTSZ)
     
C     Determine if this is a OFT calculation 
c     (this keyword is not for the masses yet)
         CALL NL_INT('DFT',0,NDFT)
C     Read in the various options regarding what is to be calculated
         CALL NL_STR('CUBE',      'DENSITY',STRIDORO)
         CALL NL_STR('DEN_METHOD','SCF',    STRICORR)
         CALL NL_STR('DENSITY',   'TOTAL',  STRIAORBD)
         CALL NL_STR('ORBITAL',  'ALPHA',  STRIAORBO)
         CALL NL_STR('ORB_METHOD','SCF',    STRINORBS)
C     
C     Translate string options
C     
C     If IDORO=0, just density is displayed
C             =1, just orbitals are displayed
C             =2, both are displayed
         IF (STRIDORO.EQ.'DENSITY') IDORO=0
         IF (STRIDORO.EQ.'ORBITALS') IDORO=1
         IF (STRIDORO.EQ.'BOTH') IDORO=2
C     
C     If ICORR=0, just SCF density is displayed
C             =1, SCF+relaxation density is displayed (only for
C     correlated methods)
         IF (STRICORR.EQ.'SCF') ICORR=0
         IF (STRICORR.EQ.'CORRELATED') ICORR=1
C     
C     If INORBS=0, SCF orbitals will be displayed
C              =1, Correlated Natural Orbitals will be displayed
         IF (STRINORBS.EQ.'SCF') INORBS=0
         IF (STRINORBS.EQ.'CORRELATED') INORBS=1
C     
C     IF IAORBD=0, just alpha density is displayed
C              =1, just beta density is displayed
C              =2, total density is displayed
         IF (STRIAORBD.EQ.'ALPHA') IAORBD=0
         IF (STRIAORBD.EQ.'BETA')  IAORBD=1
         IF (STRIAORBD.EQ.'TOTAL') IAORBD=2
C     
C     IF IAORBO=0, just alpha orbitals are displayed
C              =1, just beta orbitals are displayed
C              =2, both are displayed
C              =3, certain selected orbitals are displayed
         IF (STRIAORBO.EQ.'ALPHA') IAORBO=0
        IF (STRIAORBO.EQ.'BETA')  IAORBO=1
        IF (STRIAORBO.EQ.'BOTH')  IAORBO=2
        IF (STRIAORBO.EQ.'SELECT')  THEN
           IAORBO=3
           CALL NL_INT('ORBITAL1',0,IORBVEC(1))
           CALL NL_INT('ORBITAL2',0,IORBVEC(2))
           CALL NL_INT('ORBITAL3',0,IORBVEC(3))
           CALL NL_INT('ORBITAL4',0,IORBVEC(4))
           CALL NL_INT('ORBITAL5',0,IORBVEC(5))
           CALL NL_INT('ORBITAL6',0,IORBVEC(6))
           CALL NL_INT('ORBITAL7',0,IORBVEC(7))
           CALL NL_INT('ORBITAL8',0,IORBVEC(8))
           CALL NL_INT('ORBITAL9',0,IORBVEC(9))
        END IF
        call nl_term
C     
C     When Natural Orbitals are requested, the correlated is exclusively calculated
        IF (INORBS.EQ.1) THEN
           ICORR=1
           WRITE(*,*) "The correlated density is"
           WRITE(*,*) "exclusively calculated with NOs."
        END IF
C     
C     WRITE(*,*) "IDORO=",IDORO
C     WRITE(*,*) "ICORR=",ICORR
C     WRITE(*,*) "IAORBD=",IAORBD
C     WRITE(*,*) "IAORBO=",IAORBO
C     WRITE(*,*) "INORBS=",INORBS
C     
CXXXXXXXXXXXXXXXXXXX
C     
        PI=DATAN(1.0D+00)*4.D+00
        PIX4=DATAN(1.0D+0)*16.D+00
        LUOUT=6
C     
C     INITIALIZE THE PROGRAM BY CALLING CRAPSI, GET IUHF FLAG
C     
        IF (ICUBE.EQ.1) THEN
C     
           CALL CRAPSI(ICORE(1),IUHF,0)
C     
C     MAXIMUM CORE AVAILABLE FOR THIS CALCULATION
C     
           CALL GETREC(20,'JOBARC','IFLAGS  ',100,IFLAGS)
           MAXCOR=ICRSIZ
C     
C     Output control
           IPRINT=IFLAGS(1)
C     Print only results
           IF(IPRINT.EQ.1) IPRINT=0
C     Print intermediate information
           IF(IPRINT.GT.1) IPRINT=1
C     
           IF (IPRINT.EQ.1) THEN
              IF (IUHF.EQ.1) THEN
                 WRITE(LUOUT,1010)
              ELSE
                 WRITE(LUOUT,1020)
              ENDIF
           ENDIF
 1010      FORMAT(/' THE CALCULATION IS UHF')
 1020      FORMAT(/' THE CALCULATION IS RHF')
C     
C     
C     Get the total number of centers
           CALL GETREC(20,'JOBARC','NATOMS  ',1,NATOMS)
C     
C     
C     Get the number of unique atoms, (orbits), in the full point group
           CALL GETREC(20,'JOBARC','FULLNORB',1,IUATMS) 
C     
C Get the number of unique atoms, (orbits), in the computational
C     point group
           CALL GETREC(20,'JOBARC','COMPNORB',1,IUCATMS)
        END IF
C     
C     The atomic number of each center
        INUC=I0
C     The coordinates of each center
        ICOORD=INUC+NATOMS + mod(natoms,2)
C     The number of atoms in each orbit in the computational point group
        IPOPC=ICOORD+3*NATOMS*IINTFP
C     The atoms sorted by computational point group orbits
        IMEMBC=IPOPC+IUCATMS + mod(IUCATMS,2)
C     
C     Starting point of remaining memory
        ISTART=IMEMBC+NATOMS + mod(natoms,2)
C     
C     Get the number of atoms in a computational point group orbit
        CALL GETREC(20,'JOBARC','COMPPOPV',IUCATMS,ICORE(IPOPC))
C     Get the sorted list of atoms for the computational point group
        CALL GETREC(20,'JOBARC','COMPMEMB',NATOMS,ICORE(IMEMBC))
C     
C     Get the atomic numbers and coordinates
        CALL GETREC(20,'JOBARC','ATOMCHRG',NATOMS,ICORE(INUC))
        CALL GETREC(20,'JOBARC','COORD',3*IINTFP*NATOMS,ICORE(ICOORD))
C     
C     Get the full point group
        CALL GETREC(20,'JOBARC','FULLPTGP',IINTFP,PGRP)
C     
        WRITE(LUOUT,3010) PGRP
 3010   FORMAT(/'The Full Point Group is ',A4)
C     
C     Get the computational point group
        CALL GETREC(20,'JOBARC','COMPPTGP',IINTFP,PGRP)
C     
        WRITE(LUOUT,3020) PGRP
 3020   FORMAT(/' The Computational Point Group is ',A4)
C     
        IF (IPRINT.EQ.1) THEN
           WRITE(LUOUT,1102) IUCATMS
        ENDIF
 1102   FORMAT(' THERE ARE',I4,
     $       ' UNIQUE ATOMS IN THE COMPUTATIONAL POINT GROUP')
C     
C     Get number of basis functions
        CALL GETREC(20,'JOBARC','NAOBASFN',1,NBAS)
C     
        IF (IPRINT.EQ.1)THEN
           WRITE(LUOUT,1030) NBAS
        ENDIF
 1030   FORMAT(/' THE NUMBER OF ATOMIC BASIS FUNCTIONS IS',I5)
C     
C     
C     Get number of irreducible representations.
        CALL GETREC(20,'JOBARC','COMPNIRR',1,NIRREP)
C     Get number of symmetry orbitals in each irrep
        CALL GETREC(20,'JOBARC','NUMBASIR',NIRREP,NSOIRP)
C     
C     Get alpha and beta occupation
        CALL GETREC(20,'JOBARC','OCCUPYA',NIRREP,NOCC(1))
        NOCCA=0
        DO 10 I=1,NIRREP
           NOCCA=NOCCA+NOCC(I)
 10     CONTINUE
        IF (IUHF.EQ.1) THEN
           CALL GETREC(20,'JOBARC','OCCUPYB',NIRREP,NOCC(9))
           NOCCB=0
           DO 20 I=9,NIRREP+8
              NOCCB=NOCCB+NOCC(I)
 20        CONTINUE
        ELSE
           NOCCB=NOCCA
        ENDIF
C     
        IF (IPRINT.EQ.1)THEN
           WRITE(LUOUT,1040) NOCCA
           WRITE(LUOUT,1050) NOCCB
        ENDIF
 1040   FORMAT(/' THE ALPHA OCCUPATION IS',I4)
 1050   FORMAT(' THE BETA OCCUPATION IS',I4)
C     
C     First get the atomic numbers of the atoms, the number of
C     primitive functions for each unique atom, the coordinates for
C     each unique atom, the total number of primitive functions for
C     the molecule, the total number of primitive coefficients for the
C     molecule, the number of different angular momenta for each unique
C     atom (NUMOM(IUCATMS), the largest number of angular momenta for a
C     single atom (NTANGM).
C     
C     The number of primitive functions for each unique atom
        NUFCT=ISTART
C     The number of angular momentum shells for each unique atom
        NUMOM=NUFCT+IUCATMS + mod(IUCATMS,2)
C     The number of primitive functions for each atom
        NFCT=NUMOM+IUCATMS + mod(IUCATMS,2)
C     The number of angular momentum shells for each atom
        NANGMOM=NFCT+NATOMS + mod(NATOMS,2)
C     Array of atomic names
        IATMNAM=NANGMOM+NATOMS + mod(NATOMS,2)
C     Number of AOs for each unique atom
        NAOUATM=IATMNAM+IUCATMS*IINTFP
C     Number of AOs for each atom
        NAOATM=NAOUATM+IUCATMS + mod(IUCATMS,2) 
C     
      ISTART=NAOATM+NATOMS + mod(NATOMS,2)
C     
      IF(ISTART.GE.MAXCOR) CALL INSMEM('HYBRD1',ISTART,MAXCOR)
C     
      CALL BASIS(IUCATMS,NATOMS,ITFCT,LNP1,LNPO,NTANGM,ICORE(IMEMBC),
     $     ICORE(INUC),ICORE(NFCT),ICORE(NUFCT),ICORE(NANGMOM),
     $     ICORE(NUMOM),ICORE(IATMNAM),ICORE(ICOORD),ICORE(IPOPC),
     $     ICORE(NAOATM),ICORE(NAOUATM),IPRINT,ISHL)
C     
      write(*,*)" number of primitives for each atom"
      call printivec(icore(nfct),natoms)
      write(*,*)" largest number of primitives in a single shell: "
     $     ,lnp1
      write(*,*)" largest number of primitive orbitals in a ",
     $     "single shell: ",lnpo 
      write(*,*)" total number of primitive functions: ",itfct
      write(*,*)" number of AOs for each atoms:"
      call printivec(icore(naoatm),natoms)
c
C     Now fill the ao to primitive transformation, alpha and angular
C     momentum matrices.
C     
C     Get number of symmetry adapted basis functions
C     is different from nbas if spherical=on
      IF (IFLAGS(2).NE.0) THEN
         CALL GETREC(20,'JOBARC','NUMDROPA',1,NDROP)
         WRITE(*,*) "Ndrops=",NDROP
         IF (NDROP.NE.0) THEN
            WRITE(*,*) "NO FROZEN CORE!!!!!!."
         END IF
      END IF
      CALL GETREC(20,'JOBARC','NBASTOT ',1,NBASP)
      WRITE(*,*) "# orbitals =",NBASP
C     
      NVRTA=NBASP-NOCCA
      NVRTB=NBASP-NOCCB
C     
C     Note that if IAORBO=3, nbaspeff will redefined later.
      IF (IAORBO.EQ.2) THEN
         NBASPEFF=NBASP*2
      ELSE
         NBASPEFF=NBASP
      END IF
C     
C     The number of primitive functions for each angular momentum
C     shell in each atom
      NMOMFCT=ISTART
C     The number of atomic orbitals for each angular momentum
C     shell in each atom
      NMOMAO=NMOMFCT+NATOMS*NTANGM + mod(NATOMS*NTANGM,2)
C     The alpha matrix, (exponential factor).
         IALPHA=NMOMAO+NATOMS*NTANGM + mod(NATOMS*NTANGM,2)
C     
C     C1 MO coefficients
         ICOEFFA=IALPHA+ITFCT*IINTFP
         ICOEFFB=ICOEFFA+NBASP*NBAS*IINTFP
C     Natural Orbitals in the MO basis
         IANOCOEFF=ICOEFFB+NBASP*NBAS*IINTFP
         IBNOCOEFF=IANOCOEFF+NBASP*NBASP*IINTFP
C     C1 density matrices
         IDENSA=IBNOCOEFF+NBASP*NBASP*IINTFP
         IDENSB=IDENSA+NBASP*NBASP*IINTFP
C     Primitive coefficient matrix
         IPCOEFFA=IDENSB+NBASP*NBASP*IINTFP
         IPCOEFFB=IPCOEFFA+NBASP*ITFCT*IINTFP
C     AO-basis to primitive
         IPCOEFF=IPCOEFFB+NBASP*ITFCT*IINTFP
         IPCOEFF2=IPCOEFF+ITFCT*IINTFP*NBAS
C     Coordinates of the Array of points in cube
         IPCOORD=IPCOEFF2+ITFCT*IINTFP*NBAS
C     C1 primitive density matrices
         IAODENSA=IPCOORD+(NPTSZ+1)*3*IINTFP
         IAODENSB=IAODENSA+NBAS*NBAS*IINTFP
C     Total value of a,b,and tot density at each point
         IDENSACUB=IAODENSB+NBAS*NBAS*IINTFP
         IDENSBCUB=IDENSACUB+(NPTSZ+1)*IINTFP
         IDENSTCUB=IDENSBCUB+(NPTSZ+1)*IINTFP
C     Total value of each mo at each point
         IMOACUB=IDENSTCUB+(NPTSZ+1)*IINTFP
         IMOBCUB=IMOACUB+(NPTSZ+1)*IINTFP*NBASP
         IMOOUT=IMOBCUB+(NPTSZ+1)*IINTFP*NBASP
C     SALC to primitive tranformation matrix
         IPCOEFSO=IMOOUT+(NPTSZ+1)*IINTFP*NBASPEFF
C     Scratch space for reading MOL file and renormalization
         ISCR1=IPCOEFSO+ITFCT*IINTFP*NBASP
         ISCR2=ISCR1+LNP1*IINTFP
         ISTOP=ISCR2+LNPO*IINTFP
         ISTART=ISCR1
C     
         IF(ISTOP.GE.MAXCOR) CALL INSMEM('HYBRD2',ISTOP,MAXCOR)
C     
         CALL PRIM(NATOMS,IUCATMS,ITFCT,NBAS,LNP1,LNPO,NTANGM,
     $        ICORE(IPOPC),ICORE(NFCT),
     $        ICORE(NANGMOM),ICORE(NMOMFCT),ICORE(NMOMAO),ICORE(IMEMBC),
     $        ICORE(IALPHA),ICORE(IPCOEFF),ICORE(NAOATM),ICORE(ISCR1),
     $        ICORE(ISCR2),ISHL,MAXANG)
C
         write(*,*)" gaussian exponents"
         call printdvec(icore(iscr1),lnp1)
         write(*,*)" contraction coefficents"
         call printdvec(icore(iscr2),lnpo)
c
         IF ((IDORO.NE.1).OR.(INORBS.EQ.1)) THEN
            ICOEF=ISTART
            IDENRELA=ICOEF+NBASP*NBASP*IINTFP
            IDENRELB=IDENRELA+NBASP*NBASP*IINTFP
            IDENSCF=IDENRELB+NBASP*NBASP*IINTFP
            ICOEF2=IDENSCF+NBASP*NBASP*IINTFP
            ITEMPMAT=ICOEF2+NBASP*NBASP*IINTFP
            IREORD=ITEMPMAT+NBASP*NBASP*IINTFP
            INOCOEFFTEMP=IREORD+NBASP+MOD(NBASP,2)
            INOOCC=INOCOEFFTEMP+NBASP*NBASP*IINTFP
            IWORK=INOOCC+NBASP*NBASP*IINTFP
            IUMAT=IWORK+(3*NBASP-1)*IINTFP
            ISTOP=IUMAT+NBAS*NBASP*IINTFP
C     
            IF(ISTOP.GE.MAXCOR) CALL INSMEM('HYBRD3',ISTART,MAXCOR)
C     
C     Get scf density matrix
            IFLG=0
            CALL MKDEN(ICORE(ICOEF),ICORE(IDENSA),NBASP,NOCC,IFLG,ICORR,
     $           ICORE(IDENRELA),ICORE(IDENSCF),ICORE(ICOEF2),
     $           ICORE(ITEMPMAT),IUHF,NDFT)
            IF (IUHF.EQ.1)THEN
               IFLG=1
               CALL MKDEN(ICORE(ICOEF),ICORE(IDENSB),NBASP,NOCC,IFLG,
     $              ICORR,
     $              ICORE(IDENRELB),ICORE(IDENSCF),ICORE(ICOEF2),
     $              ICORE(ITEMPMAT),IUHF,NDFT)
            ELSE
               IFLG=1
               CALL MKDEN(ICORE(ICOEF),ICORE(IDENSB),NBASP,NOCC,IFLG,
     $              ICORR,
     $              ICORE(IDENRELB),ICORE(IDENSCF),ICORE(ICOEF2),
     $              ICORE(ITEMPMAT),IUHF,NDFT)
            ENDIF
C     
            IF (IDORO.NE.1) THEN
C     Form the SALC to primitive transformation matrix
C     
C     Get the SALC to AO transformation matrix
               CALL GETREC(20,'JOBARC','CMP2ZMAT',NBAS*NBASP*IINTFP,
     $              ICORE(IUMAT))
C     Left multiply by the prim to AO matrix to get the sale to prim. mat.
               CALL XGEMM('N','N',ITFCT,NBASP,NBAS,1.0D+00,
     $              ICORE(IPCOEFF2),
     $              ITFCT,ICORE(IUMAT),NBAS,0.0D+00,ICORE(IPCOEFSO),
     $              ITFCT)
C     
               WRITE(*,*)" AO to prim #1"
               CALL PRINTMAT(ICORE(IPCOEFF),ITFCT,NBAS)
               WRITE(*,*)" AO to prim #2"
               CALL PRINTMAT(ICORE(IPCOEFF2),ITFCT,NBAS)
               WRITE(*,*)" salc to ao"
               CALL PRINTMAT(ICORE(IUMAT),NBAS,NBASP)
               WRITE(*,*)" Rsalc to prim transformation"
               CALL PRINTMAT(ICORE(IPCOEFSO),ITFCT,NBASP)
            END IF
C     
            IF (INORBS.EQ.1) THEN
               CALL GETREC(20,'JOBARC','REORDERA',NBASP,ICORE(IREORD))
               WRITE(*,*) "Reorder vector"
               CALL PRINTIVEC(ICORE(IREORD),NBASP)
C     
C     Diagonalize the alpha and beta correlated density
C     to obtain the NOs in an MO basis
C     Important Output: IANOCOEFF and IBNOCOEFF
C     
               CALL NORBMAKE(ICORE(IDENRELA),ICORE(IDENRELB),
     $              ICORE(INOCOEFFTEMP),ICORE(IANOCOEFF),
     $              ICORE(IBNOCOEFF),
     $              ICORE(IREORD),NBASP,ICORE(INOOCC),
     $              ICORE(IWORK))
            END IF
         END IF
C     
C     Alpha
         IFLG=0
         IFLG2=0
C     Scratch arrays for sorting MO vectors
         ICNTR=ISTART
         ICOEFF=ICNTR+NBAS + mod(nbas,2)
         ICOEFFTEMP=ICOEFF+NBASP*NBAS*IINTFP
         ISTOP=ICOEFFTEMP+NBASP*NBAS*IINTFP
         ISTART=ICNTR+NBAS + mod(nbas,2)
C     
         IF(ISTOP.GE.MAXCOR) CALL INSMEM('HYBRD5',ISTOP,MAXCOR)
C     
         IF (IDORO.NE.0) THEN
C Get MO vectors in correct order in C1 symmetry
C     
            CALL GTAO(IFLG,IFLG2,NATOMS,NBAS,NBASP,NTANGM,ICORE(ICNTR),
     $           ICORE(ICOEFF),ICORE(ICOEFFA),ICORE(NANGMOM),
     $           ICORE(NMOMAO),ICORE(NAOATM),IPRINT,ICORE(IANOCOEFF),
     $           INORBS,ICORE(ICOEFFTEMP))
C     
C     Form the C1 primitive coefficient vector
            CALL XGEMM('N','N',ITFCT,NBASP,NBAS,1.0D+00,
     $           ICORE(IPCOEFF),
     $           ITFCT,ICORE(ICOEFFA),NBAS,0.0D+00,
     $           ICORE(IPCOEFFA),ITFCT)
C     
         END IF
C     
C     Scratch arrays for primitive values at a point in the cube
         IPVAL=ISTART
         IPVAL2=IPVAL+ITFCT*NBASP*IINTFP
         IPCRDX=IPVAL2+ITFCT*NBASP*IINTFP
         IPCRDY=IPCRDX+(NPTSX+1)*IINTFP
         IPCRDZ=IPCRDY+(NPTSY+1)*IINTFP
         IIPCNT=IPCRDZ+(NPTSZ+1)*IINTFP
         IAPDX=IIPCNT+NBAS+MOD(NBAS,2)
         IAPDY=IAPDX+NATOMS*IINTFP
         IAPDZ=IAPDY+NATOMS*IINTFP
         IAPDR=IAPDZ+NATOMS*IINTFP
         IDENSNMAT=IAPDR+NATOMS*IINTFP
         IFINMO=IDENSNMAT+NBASP*NBASP*IINTFP
         IFINSALC=IFINMO+NBASP*IINTFP
         INUC2=IFINSALC+NBASP*IINTFP
         ICOORD2=INUC2+NATOMS+mod(NATOMS,2)
         IIORBVECA=ICOORD2+3*NATOMS*IINTFP
         IIORBVECB=IIORBVECA+10
         IORDERMATA=IIORBVECB+10
         IORDERMATB=IORDERMATA+9*IINTFP*ITFCT
         ISTOP=IORDERMATB+9*IINTFP*ITFCT
C     
         IF(ISTOP.GE.MAXCOR) CALL INSMEM('HYBRD6',ISTOP,MAXCOR)
C     
C     
C     If needed, reduce the primitive coeff. matrices to only contain
C     the desired orbitals.
         IF (IAORBO.EQ.3) THEN
            CALL ORBOUT(NBASP,NORBOUTA,NORBOUTB,ICORE(IPCOEFFA),
     $           ICORE(IPCOEFFB),ICORE(IIORBVECA),ICORE(IIORBVECB),
     $           ICORE(IORDERMATA),ICORE(IORDERMATB),ITFCT,NORBOUT,
     $           IORBVEC)
            NBASPEFF=NORBOUT
         ELSE
            NORBOUT=NBASPEFF
            NORBOUTA=NBASP
            NOBROUTB=NBASP
         END IF
C
C     WRITE(*,*) "# of ang. mom. shells for each atom"
C     CALL PRINTIVEC(ICORE(NANGMOM),NATOMS)
C     WRITE(*,*) "# of prim. funcs. for each ang.
C     $ mom. shell in each atom"
C     CALL PRINTIVEC(ICORE(NMOMFCT),(NATOMS*NTANGM))
C     WRITE(*,*) "# of AOs for each atom"
C     CALL PRINTIVEC(ICORE(NAOATM),NATOMS)
C     WRITE(*,*) "Alpha coeffs."
C     CALL PRINTDVEC(ICORE(IALPHA),ITFCT)
C     WRITE(*,*) "gaussian coeffs."
C     CALL PRINTMAT(ICORE(IPCOEFFA),ITFCT,NORBOUTA)
C     
C     WRITE(*,*) "atoms"
C     CALL PRINTMAT(ICORE(ICOORD),3,NATOMS)
C     
C     Heading for output
C     
         NATMS=NATOMS
         CALL REMOVE(NATOMS,NATMS,ICORE(INUC),ICORE(ICOORD),
     $        ICORE(ICOORD2),ICORE(INUC2))
C     
         IF (ICUBE.EQ.1) THEN
            IF (IDORO.NE.1) OPEN(UNIT=98,FILE='den.cube')
            IF (IDORO.NE.0) OPEN(UNIT=99,FILE='orb.cube')
            IDENOUT=98
            IORBOUT=99
         ELSE
            IF (IDORO.NE.1) OPEN(UNIT=96,FILE='den2.cube')
            IF (IDORO.NE.0) OPEN(UNIT=97,FILE='orb2.cube')
            IDENOUT=96
            IORBOUT=97
         END IF
C     
         CALL HEADER(NATMS,ICORE(INUC2),ICORE(ICOORD2),NPTSX,
     $        TVALX,BVALX,NPTSY,TVALY,BVALY,NPTSZ,TVALZ,BVALZ,
     $        NBASPEFF,IDORO,IAORBD,ICORR,INORBS,ICORE(IIORBVECA),
     $        ICORE(IIORBVECB),NORBOUTA,NORBOUTB,IAORBO,NBASP,
     $        IORBOUT,IDENOUT)
C     
         DO 100 IBIGLOOP=1,(NPTSX+1)
            DO 101 JBIGLOOP=1,(NPTSY+1)
C     Determine the grid points
               CALL GRID(NPTSX,TVALX,BVALX,NPTSY,TVALY,BVALY,NPTSZ,
     $              TVALZ,BVALZ,ICORE(IPCOORD),ICORE(IPCRDX),
     $              ICORE(IPCRDY),ICORE(IPCRDZ),IBIGLOOP,JBIGLOOP)
C     WRITE(*,*) "points in row ",((IBIGLOOP-l)*(NPTSY+l)+JBIGLOOP)
C     CALL PRINTMAT(ICORE(IPCooRD),3,(NPTSZ+l))
C     
C     Determine the desired quantities at the grid points for alpha
               CALL GRIDVAL(ICORE(IPCOORD),NPTSZ,ICORE(IPVAL),ITFCT,
     $              NBASP,
     $              ICORE(ICOORD),NATOMS,ICORE(IALPHA),
     $              ICORE(IPCOEFFA),
     $              ICORE(NMOMFCT),MAXANG,NTANGM,NBAS,
     $              ICORE(IDENSA),ICORE(IDENSACUB),0,ICORE(IMOACUB),
     $              ICORE(IPVAL2),ICORE(IIPCNT),ICORE(IAPDX),
     $              ICORE(IAPDY),ICORE(IAPDZ),ICORE(IAPDR),
     $              ICORE(IDENSNMAT),
     $              ICORE(IPCOEFSO),ICORE(IFINMO),ICORE(IFINSALC),
     $              IBIGLOOP,
     $              JBIGLOOP,IDORO,NORBOUTA)
C     Determine the desired quantities at the grid points for beta
               CALL GRIDVAL(ICORE(IPCOORD),NPTSZ,ICORE(IPVAL),ITFCT,
     $              NBASP,
     $              ICORE(ICOORD),NATOMS,ICORE(IALPHA),
     $              ICORE(IPCOEFFB),
     $              ICORE(NMOMFCT),MAXANG,NTANGM,NBAS,
     $              ICORE(IDENSB),ICORE(IDENSBCUB),1,ICORE(IMOBCUB),
     $              ICORE(IPVAL2),ICORE(IIPCNT),ICORE(IAPDX),
     $              ICORE(IAPDY),ICORE(IAPDZ),ICORE(IAPDR),
     $              ICORE(IDENSNMAT),
     $              ICORE(IPCOEFSO),ICORE(IFINMO),ICORE(IFINSALC),
     $              IBIGLOOP,
     $              JBIGLOOP,IDORO,NORBOUTB)
C     
C     Print final results
               CALL CUBEFORM (ICORE(IDENSACUB),ICORE(IDENSBCUB),NPTSZ,
     $              ICORE(IDENSTCUB),ICORE(IMOACUB),ICORE(IMOBCUB),
     $              NBASP,IDORO,IAORBD,IAORBO,ICORE(IMOOUT),NBASPEFF,
     $              NORBOUTA,NORBOUTB,IORBOUT,IDENOUT)
C     
 101        CONTINUE
 100     CONTINUE
 911  CONTINUE
C     
C     If requested, calculate the density difference cube file.
      IF (IDDIFF.EQ.1) THEN
         CALL DIF ()
      END IF
C     
      CALL CRAPSO
C     
      STOP
      END

      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__SYMMETRIZE_ATOMIC_NBO
     +
     +                    ( NBAS,NATOM,
     +                      NBOSIZE,ROTSIZE,
     +                      MXNBA,
     +                      NXB,NXA,
     +                      OFFX,
     +                      OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR,
     +                      ATNXB,ATXIDX,ATXOFF,ATDONE,
     +                      BASBEG,BASEND,
     +                      COLMAP,SYMMAP,
     +                      IDXSYM,
     +                      INITSYM,ATOMSYM,AXISSYM,HIGHSYM,
     +                      DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                      PLATONIC,
     +                      RING,NRING,RINGSZ,
     +                      NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                      PLATO,
     +                      SYMCEN,
     +                      BDNCEN,BDCEN,
     +                      HYB,
     +                      ROT,ROTIDX,
     +                      SYMCRIT,
     +                      P,
     +                      DOMAT,
     +                      SHALF,
     +                      XVEC,
     +                      XMAT,
     +
     +                              SYMNBO,
     +                              SLTYPE,
     +                              NBOBD,
     +                              BDNBAS,
     +                              BDBAS,
     +                              LOCAL,
     +                              B,W,Q,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__SYMMETRIZE_ATOMIC_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine symmetrizes the NBOs.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    ROTSIZE      =  maximum # of NHOs that will be
C                                    allowed to form NBO hybrids for
C                                    rotationally invariant atomic NBO
C                                    construction.
C                    MXNBA        =  maximum # of NHOs per atom.
C                    NXB          =  total # of atomic x-type NBOs
C                                    (x = Core,Rydberg,Lone-pair,
C                                    Empty-pair).
C                    NXA          =  total # of atomic x-type NBO atoms.
C                    OFFX         =  absolute offset index for present
C                                    x-type NBOs. This index indicates
C                                    the totallity of NBOs before the
C                                    x-type NBO set.
C                    OFFxy        =  absolute offset indices for x-type
C                                    NBOs. These indices indicate the
C                                    totallity of x-type NBOs before the
C                                    x-type NBO set (xy:LP=Lone-pair,
C                                    BD=Bond, EP=Empty-pair, AB=Anti-
C                                    bond, RY,RR=Rydberg types)
C                    ATNXB (A)    =  # of atomic x-type NBOs on x-type
C                                    NBO atom A.
C                    ATXIDX (A)   =  atomic index for x-type NBO atom A.
C                    ATXOFF (A)   =  index offset for atomic NBOs for
C                                    x-type NBO atom A. This index is
C                                    equal to the total number of atomic
C                                    x-type NBOs on all x-type NBO atoms
C                                    preceeding x-type NBO atom A.
C                    ATDONE (A)   =  will be used as an indicator if
C                                    x-type NBO atom A has been checked
C                                    for symmetry or not.
C                    BASBEG (A)   =  first basis index number for atom A
C                    BASEND (A)   =  last basis index number for atom A
C                    COLMAP (I)   =  will contain the column map in the
C                                    active sense for reordering the
C                                    symmetrized atomic NBOs by weight
C                                    in decreasing order. COLMAP (I)
C                                    contains the position index of the
C                                    I-th symmetrized atomic NBO in the
C                                    final respective order. This array
C                                    will also be used for other
C                                    purposes as well, when rotating
C                                    NBOs on axially or atomic symmetry
C                                    related centers.
C                    SYMMAP (A,B) =  has been set equal to 1 if atoms
C                                    A and B were found to be symmetry
C                                    related. A value of 0 indicates
C                                    no symmetry relation.
C                    IDXSYM       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    INITSYM      =  is true, if the routine has to
C                                    perform the initial steps, which
C                                    consists in setting the initial
C                                    values for SYMNBO (see below).
C                    ATOMSYM      =  is true, if the routine has to deal
C                                    with a single symmetry center.
C                    AXISSYM      =  is true, if the routine has to deal
C                                    with two symmetry related centers.
C                    HIGHSYM      =  is true, if the routine has to deal
C                                    with three or more symmetry related
C                                    centers.
C                    DSYMACC      =  symmetry accuracy for distance
C                                    order matrix values
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    PSYMACC      =  symmetry accuracy for occupation
C                                    matrix values (including weights)
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    PLATONIC     =  is true, if the complete set of
C                                    atomic centers possess one of the
C                                    possible 5 platonic symmetries.
C                    RING (A,B)   =  integer array containing all atomic
C                                    indices A of those symmetry related
C                                    sets that have equal distance from
C                                    center B and are of maximum size
C                    NRING (B)    =  integer vector containing the # of
C                                    sets of maximum size related to
C                                    center B.
C                    RINGSZ (B)   =  integer vector containing the
C                                    maximum size of the above found
C                                    sets related to center B.
C                    NTETRA       =  contains the # of tetrahedrally
C                                    related atomic center sets (size 4)
C                    NCUBE        =  contains the # of cubically
C                                    related atomic center sets (size 8)
C                    NOCTA        =  contains the # of octahedrally
C                                    related atomic center sets (size 6)
C                    NDODECA      =  contains the # of dodecahedrally
C                                    related atomic center sets
C                                    (size 20)
C                    NICOSA       =  contains the # of icosahedrally
C                                    related atomic center sets
C                                    (size 12)
C                    PLATO (A,P)  =  integer array containing all atomic
C                                    indices A for specific platonic
C                                    symmetry types as characterized by
C                                    the index P: P = 1 (four atoms
C                                    tetrahedrally arranged), P = 2
C                                    (eight atoms arranged in a cube),
C                                    P = 3 (six octahedral atoms), P = 4
C                                    (twenty atoms in a dodecahedron),
C                                    P = 5 (twelve icosahedral atoms)
C                    SYMCEN       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/
C                                    NRB. Note that the # of NHB-bonds
C                                    might be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for J-th
C                                    bond. The bond order is NHB-bonds/
C                                    NCB/NRB. Note that the # of
C                                    NHB-bonds might be < NHB size.
C                    HYB          =  will contain the NBO hybridization
C                                    matrix.
C                    ROT          =  will contain the NBO rotation
C                                    matrix.
C                    ROTIDX       =  will contain the NBO rotation
C                                    indices.
C                    SYMCRIT      =  symmetry interaction criterion.
C                                    Any absolute occupation matrix
C                                    interaction element between
C                                    symmetrized NBOs and a degenerate
C                                    set of NBOs is assumed to be zero
C                                    if it falls below this value.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    DOMAT (A,B)  =  distance order matrix containing
C                                    'distance' info between atoms A
C                                    and B. Will be used when attempting
C                                    NBO symmetrization in case of
C                                    octahedral and icosahedral groups.
C                    SHALF        =  full NBAS x NBAS square root of
C                                    the overlap matrix in AO basis.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    SYMNBO       =  initial integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE (I)   =  initial integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the I-th NBO.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    NBOBD (I)    =  initial array that contains the
C                                    NHO bond index number for the I-th
C                                    NBO. This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the arrays
C                                    BDNCEN,BDCEN,BDBAS and BDOCC.
C                    BDNBAS (J)   =  initial # of basis functions (NHOs)
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs before symmetrization.
C                    B (I,J)      =  initial NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    W            =  complete NBO weight vector before
C                                    symmetrization.
C                    Q            =  complete NBO occupation interaction
C                                    order vector before symmetrization.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    before symmetrization.
C
C
C                  Output:
C
C                    SYMNBO       =  updated integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE (I)   =  updated integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the I-th NBO.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  modified # of basis functions
C                                    (NHOs) for J-th bond. The bond
C                                    order is NHB-bonds/NCB/NRB. Note
C                                    that the # of NHB-bonds might
C                                    be < NHB size.
C                    NBOBD (I)    =  modified array that contains the
C                                    NHO bond index number for the I-th
C                                    NBO. This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the arrays
C                                    BDNCEN,BDCEN,BDBAS and BDOCC.
C                    BDBAS (I,J)  =  modified I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs after symmetrization of
C                                    the x-type NBOs treated here.
C                    B (I,J)      =  modified NBOSIZE x NBAS matrix
C                                    containing the newly J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    W            =  complete NBO weight vector after
C                                    symmetrization of the x-type NBOs
C                                    treated here.
C                    Q            =  complete NBO occupation interaction
C                                    order vector after symmetrization
C                                    of the x-type NBOs treated here.
C                    C            =  complete NBAS x NBAS NBO
C                                    coefficient matrix in AO basis
C                                    after symmetrization.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     INITSYM,ATOMSYM,AXISSYM,HIGHSYM
         LOGICAL     C3AXIS,C4AXIS
         LOGICAL     CHECK
         LOGICAL     DEG2,DEG3,DEG4,DEG5,DEGX
         LOGICAL     LSYM,QSYM
         LOGICAL     LTRG,UTRG
         LOGICAL     PLATONIC
         LOGICAL     PROCEED
         LOGICAL     SAVEP
         LOGICAL     TGROUP,OGROUP,IGROUP
         LOGICAL     TOTAL
         LOGICAL     QUSE

         INTEGER     ATOMA,ATOMB
         INTEGER     CENTER
         INTEGER     FIRST
         INTEGER     I
         INTEGER     IDXA,IDXB
         INTEGER     MDEG
         INTEGER     MXNBA
         INTEGER     NBAS,NATOM
         INTEGER     NBO
         INTEGER     NBOSIZE,ROTSIZE
         INTEGER     NDEG
         INTEGER     NSYM
         INTEGER     NTETRA,NCUBE,NOCTA,NDODECA,NICOSA
         INTEGER     NXB,NXA
         INTEGER     NXBA
         INTEGER     OFFA,OFFX,OFFT
         INTEGER     OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR

         INTEGER     ATDONE  (1:NXA  )
         INTEGER     ATNXB   (1:NXA  )
         INTEGER     ATXIDX  (1:NXA  )
         INTEGER     ATXOFF  (1:NXA  )
         INTEGER     BASBEG  (1:NATOM)
         INTEGER     BASEND  (1:NATOM)
         INTEGER     BDNBAS  (1:NBAS )
         INTEGER     BDNCEN  (1:NBAS )
         INTEGER     COLMAP  (1:MXNBA)
         INTEGER     IDXSYM  (1:NATOM)
         INTEGER     NBOBD   (1:NBAS )
         INTEGER     NRING   (1:NATOM)
         INTEGER     RINGSZ  (1:NATOM)
         INTEGER     ROTIDX  (1:NBAS )
         INTEGER     SLTYPE  (1:NBAS )
         INTEGER     SYMCEN  (1:NATOM)
         INTEGER     SYMNBO  (1:NBAS )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS )
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS )
         INTEGER     PLATO   (1:NATOM  ,1:5    )
         INTEGER     RING    (1:NATOM  ,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM  ,1:NATOM)

         DOUBLE PRECISION  DSYMACC,LSYMACC,PSYMACC,QSYMACC
         DOUBLE PRECISION  LOLD,LNEW
         DOUBLE PRECISION  QOLD,QNEW
         DOUBLE PRECISION  SYMCRIT
         DOUBLE PRECISION  ZERO,ONE,TWO,FOUR

         DOUBLE PRECISION  LOCAL  (1:NBAS     )
         DOUBLE PRECISION  Q      (1:NBAS     )
         DOUBLE PRECISION  W      (1:NBAS     )
         DOUBLE PRECISION  XVEC   (1:NBAS+NBAS)

         DOUBLE PRECISION  B      (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  C      (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  HYB    (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  P      (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  ROT    (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  SHALF  (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  DOMAT  (1:NATOM  ,1:NATOM  )
         DOUBLE PRECISION  XMAT   (1:NBAS   ,1:NBAS   )

C         SAVE  TGROUP
C         SAVE  OGROUP
C         SAVE  IGROUP

         PARAMETER   (ZERO   =  0.D0 )
         PARAMETER   (ONE    =  1.D0 )
         PARAMETER   (TWO    =  2.D0 )
         PARAMETER   (FOUR   =  4.D0 )
C
C
C------------------------------------------------------------------------
C
C
C             ...perform initial step, if requested. This consists
C                of one major step:
C
C                    1) identify those x-type atomic NBOs which are
C                       non-degenerate and are thus known to be of
C                       proper symmetry already. These NBOs can be
C                       marked as usable for the symmetry reorientation
C                       procedure.
C
C
         IF (INITSYM) THEN

             DO ATOMA = 1,NXA

                IDXA = ATXIDX (ATOMA)
                OFFA = ATXOFF (ATOMA)
                NXBA = ATNXB  (ATOMA)

                OFFT = OFFX + OFFA

                NDEG = 0
                QOLD = Q     (OFFT+1)
                LOLD = LOCAL (OFFT+1)

                DO I = 1,NXBA
                   QNEW = Q     (OFFT+I)
                   LNEW = LOCAL (OFFT+I)

                   QUSE = QNEW .GT. QSYMACC
                   QSYM = DABS (QOLD - QNEW) .LT. QSYMACC
                   LSYM = DABS (LOLD - LNEW) .LT. LSYMACC

                   IF (QSYM .AND. LSYM) THEN
                       IF (QUSE) THEN
                           NDEG = NDEG + 1
                       END IF
                   ELSE
                       IF (NDEG.EQ.1) THEN
                           SYMNBO (OFFT+I-1) = 2
                       END IF
                       IF (QUSE) THEN
                           NDEG = 1
                           QOLD = QNEW
                           LOLD = LNEW
                       ELSE
                           NDEG = 0
                       END IF
                   END IF

                   IF (I.EQ.NXBA .AND. NDEG.EQ.1) THEN
                       SYMNBO (OFFT+I) = 2
                   END IF

                END DO
             END DO

             RETURN

         END IF
C
C
C             ...outer loop over all atomic centers.
C
C
         DO ATOMA = 1,NXA
            ATDONE (ATOMA) = 0
         END DO

         DO ATOMA = 1,NXA

            CHECK = ATDONE (ATOMA) .EQ. 0
C
C
C             ...find total # of symmetry related atoms corresponding
C                to current checked atom.
C
C
            IF (CHECK) THEN

                IDXA = ATXIDX (ATOMA)
                OFFA = ATXOFF (ATOMA)
                NXBA = ATNXB  (ATOMA)

                OFFT = OFFX + OFFA

                NSYM = 0
                DO ATOMB = 1,NXA
                   IDXB = ATXIDX (ATOMB)
                   IF (SYMMAP (IDXB,IDXA) .EQ. 1) THEN
                       NSYM = NSYM + 1
                       IDXSYM (NSYM) = ATOMB
                       ATDONE (ATOMB) = 1
                   END IF
                END DO
C
C
C             ...proceed with the high symmetry case, which deals
C                with the NSYM > 2 cases. 2-fold degenerate levels
C                will be identified by both identical interaction
C                orders and atomic localization content.
C
C
                IF (HIGHSYM .AND. NSYM.GT.2) THEN

                    NDEG = 0
                    QOLD = Q     (OFFT+1)
                    LOLD = LOCAL (OFFT+1)

                    DO I = 1,NXBA
                       QNEW = Q     (OFFT+I)
                       LNEW = LOCAL (OFFT+I)

                       QUSE = QNEW .GT. QSYMACC
                       QSYM = DABS (QOLD - QNEW) .LT. QSYMACC
                       LSYM = DABS (LOLD - LNEW) .LT. LSYMACC

                       IF (QSYM .AND. LSYM) THEN
                           IF (QUSE) THEN
                               NDEG = NDEG + 1
                           END IF
                       ELSE
                           IF (QUSE) THEN
                               NDEG = 1
                               QOLD = QNEW
                               LOLD = LNEW
                           ELSE
                               NDEG = 0
                           END IF
                       END IF

                       IF (NDEG.GT.2) THEN
                           WRITE (*,*) ' Degeneracy > 2-fold! '
                           WRITE (*,*) ' Atom index = ',IDXA
                           WRITE (*,*) ' Order,Locality = ',QOLD,LOLD
                           WRITE (*,*) ' nlo__symmetrize_atomic_nbo '
                           WRITE (1,*) ' Degeneracy > 2-fold! '
                           WRITE (1,*) ' Atom index = ',IDXA
                           WRITE (1,*) ' Order,Locality = ',QOLD,LOLD
                           WRITE (1,*) ' nlo__symmetrize_atomic_nbo '
                           STOP
                       END IF

                       IF (NDEG.EQ.2) THEN

                           FIRST = I - 1

                           WRITE (*,*) ' HIGH SYMMETRY case! '
                           WRITE (*,*) ' Weight = ',W (OFFT+FIRST)
                           WRITE (*,*) ' Order = ',QOLD
                           WRITE (*,*) ' Loc = ',LOLD
                           WRITE (*,*) ' 1st function = ',FIRST
                           WRITE (*,*) ' High NSYM = ',NSYM

                           IF (NSYM.EQ.4) THEN

                               CALL  NLO__ROTATE_TGROUP_NBO
     +
     +                                    ( NBAS,
     +                                      NBOSIZE,
     +                                      NXB,NXA,NXBA,
     +                                      ATXOFF,
     +                                      LSYMACC,QSYMACC,
     +                                      FIRST,
     +                                      IDXSYM,
     +                                      NBOBD (OFFX+1),
     +                                      P,
     +                                      LOCAL (OFFT+1),
     +                                      W (OFFT+1),
     +                                      Q (OFFT+1),
     +                                      XVEC,
     +                                      XMAT,
     +
     +                                             SYMNBO (OFFX+1),
     +                                             SLTYPE (OFFX+1),
     +                                             BDNBAS,
     +                                             BDBAS,
     +                                             B (1,OFFX+1),
     +                                             C (1,OFFX+1) )
     +
     +
                               TGROUP = .TRUE.

                           ELSE IF (NSYM.EQ.6 .OR. NSYM.EQ.8) THEN

                               C3AXIS = NSYM.EQ.8
                               C4AXIS = NSYM.EQ.6

                               CALL  NLO__ROTATE_OGROUP_NBO
     +
     +                                    ( NBAS,NATOM,NSYM,
     +                                      NBOSIZE,
     +                                      NXB,NXA,NXBA,
     +                                      ATXIDX,ATXOFF,
     +                                      DSYMACC,LSYMACC,QSYMACC,
     +                                      FIRST,
     +                                      IDXSYM,
     +                                      C3AXIS,C4AXIS,
     +                                      NBOBD (OFFX+1),
     +                                      P,
     +                                      LOCAL (OFFT+1),
     +                                      W (OFFT+1),
     +                                      Q (OFFT+1),
     +                                      DOMAT,
     +                                      XVEC,
     +                                      XMAT,
     +
     +                                             SYMNBO (OFFX+1),
     +                                             SLTYPE (OFFX+1),
     +                                             BDNBAS,
     +                                             BDBAS,
     +                                             B (1,OFFX+1),
     +                                             C (1,OFFX+1) )
     +
     +
                               OGROUP = .TRUE.

                           ELSE IF (NSYM.EQ.12) THEN

                               WRITE (*,*) ' I,Ih-group present! '
                               WRITE (*,*) ' Not implemented yet! '
                               WRITE (*,*) ' Symmetrization skipped... '
                               WRITE (1,*) ' I,Ih-group present! '
                               WRITE (1,*) ' Not implemented yet! '
                               WRITE (1,*) ' Symmetrization skipped... '

                               IGROUP = .TRUE.

                           ELSE IF (NSYM.EQ.20) THEN

                               WRITE (*,*) ' I,Ih-group present! '
                               WRITE (*,*) ' Not implemented yet! '
                               WRITE (*,*) ' Symmetrization skipped... '
                               WRITE (1,*) ' I,Ih-group present! '
                               WRITE (1,*) ' Not implemented yet! '
                               WRITE (1,*) ' Symmetrization skipped... '

                               IGROUP = .TRUE.

                           ELSE

                               WRITE (*,*) ' # of symcen ne 4,6,8,12,20'
                               WRITE (*,*) ' Accidental degeneracy ? '
                               WRITE (*,*) ' nlo__symmetrize_atomic_nbo'
                               WRITE (1,*) ' # of symcen ne 4,6,8,12,20'
                               WRITE (1,*) ' Accidental degeneracy ? '
                               WRITE (1,*) ' nlo__symmetrize_atomic_nbo'
                               STOP

                           END IF

                       END IF
                    END DO

                END IF
C
C
C             ...proceed with the axial symmetry case, which deals
C                with the NSYM = 2 cases. The following point groups
C                are possible here:
C
C                        Ci,Cs,C2,C2v,Cnh,Dn,Dnh,Dnd,Sn
C
C                Of these, only the following will lead to 2-fold
C                degenerate levels (i.e. only those groups will allow
C                for site-groups of Cn,Cnv,n>=3):
C
C                            Cnh,Dn,Dnh,Dnd  n>=3  and Sn  n>=6
C
C                2-fold degenerate levels will be identified by both
C                identical interaction orders and atomic localization
C                content. Note also that we cannot have the axial
C                symmetry case, if a high symmetry group was detected
C                before.
C
C
                IF (AXISSYM .AND. NSYM.EQ.2) THEN

                    IF (PLATONIC) THEN
                        WRITE (*,*) ' Axial symmetry conflict! '
                        WRITE (*,*) ' PLATONIC = ',PLATONIC
                        WRITE (*,*) ' nlo__symmetrize_atomic_nbo'
                        WRITE (1,*) ' Axial symmetry conflict! '
                        WRITE (1,*) ' PLATONIC = ',PLATONIC
                        WRITE (1,*) ' nlo__symmetrize_atomic_nbo'
                        STOP
                    END IF

                    NDEG = 0
                    QOLD = Q     (OFFT+1)
                    LOLD = LOCAL (OFFT+1)

                    DO I = 1,NXBA
                       QNEW = Q     (OFFT+I)
                       LNEW = LOCAL (OFFT+I)

                       QUSE = QNEW .GT. QSYMACC
                       QSYM = DABS (QOLD - QNEW) .LT. QSYMACC
                       LSYM = DABS (LOLD - LNEW) .LT. LSYMACC

                       IF (QSYM .AND. LSYM) THEN
                           IF (QUSE) THEN
                               NDEG = NDEG + 1
                           END IF
                       ELSE
                           IF (QUSE) THEN
                               NDEG = 1
                               QOLD = QNEW
                               LOLD = LNEW
                           ELSE
                               NDEG = 0
                           END IF
                       END IF

                       IF (NDEG.GT.2) THEN
                           WRITE (*,*) ' Degeneracy > 2-fold! '
                           WRITE (*,*) ' Atom index = ',IDXA
                           WRITE (*,*) ' Order,Locality = ',QOLD,LOLD
                           WRITE (*,*) ' nlo__symmetrize_atomic_nbo '
                           WRITE (1,*) ' Degeneracy > 2-fold! '
                           WRITE (1,*) ' Atom index = ',IDXA
                           WRITE (1,*) ' Order,Locality = ',QOLD,LOLD
                           WRITE (1,*) ' nlo__symmetrize_atomic_nbo '
                           STOP
                       END IF

                       IF (NDEG.EQ.2) THEN

                           FIRST = I - 1
                           PROCEED = SYMNBO (OFFT+FIRST) .NE. 2

                           IF (PROCEED) THEN
                               WRITE (*,*) ' AXIAL case! '
                               WRITE (*,*) ' Weight = ',W (OFFT+FIRST)
                               WRITE (*,*) ' Order = ',Q (OFFT+FIRST)
                               WRITE (*,*) ' Loc = ',LOCAL (OFFT+FIRST)
                               WRITE (*,*) ' Degeneracy = ',NDEG
                               WRITE (*,*) ' 1st function = ',FIRST
                               WRITE (*,*) ' Center # 1 = ',IDXSYM (1)
                               WRITE (*,*) ' Center # 2 = ',IDXSYM (2)

                               CALL  NLO__ROTATE_AXIAL_NBO
     +
     +                                    ( NBAS,NATOM,
     +                                      NBOSIZE,ROTSIZE,
     +                                      NXA,NXBA,
     +                                      OFFX,
     +                                      OFFLP,OFFBD,OFFEP,
     +                                      OFFAB,OFFRY,OFFRR,
     +                                      ATXIDX,ATXOFF,
     +                                      IDXSYM,
     +                                      RING,NRING,RINGSZ,
     +                                      SYMCEN,
     +                                      LSYMACC,QSYMACC,
     +                                      FIRST,
     +                                      COLMAP,
     +                                      NBOBD,
     +                                      BDNCEN,BDCEN,
     +                                      HYB,
     +                                      ROT,ROTIDX,
     +                                      SYMCRIT,
     +                                      P,
     +                                      LOCAL,
     +                                      W,Q,
     +                                      XVEC,
     +                                      XMAT,
     +
     +                                              SYMNBO,
     +                                              SLTYPE,
     +                                              BDNBAS,
     +                                              BDBAS,
     +                                              B,
     +                                              C )
     +
     +
                           END IF
                       END IF
                    END DO

                END IF
C
C
C             ...proceed with the atomic symmetry case, which deals
C                with the NSYM = 1 cases. 2- or higher-fold degenerate
C                levels will be identified by both identical interaction
C                orders and atomic localization content. If 2- or
C                higher-fold degenerate levels are found, this means
C                that either the atomic center is located at the center
C                point of the point group or it is located on a C axis
C                of order =< 3. Note that if at least one 3- or higher-
C                fold degenerate level is found, then the atomic center
C                must be located at the center point of the point group
C                and the group can only be of T-,O- or I-type.
C
C
                IF (ATOMSYM .AND. NSYM.EQ.1) THEN

                    CENTER = ATXIDX (IDXSYM (1))

                    DEG2 = .FALSE.
                    DEG3 = .FALSE.
                    DEG4 = .FALSE.
                    DEG5 = .FALSE.
                    DEGX = .FALSE.
                    NDEG = 0
                    QOLD = Q     (OFFT+1)
                    LOLD = LOCAL (OFFT+1)

                    DO I = 1,NXBA
                       QNEW = Q     (OFFT+I)
                       LNEW = LOCAL (OFFT+I)

                       QUSE = QNEW .GT. QSYMACC
                       QSYM = DABS (QOLD - QNEW) .LT. QSYMACC
                       LSYM = DABS (LOLD - LNEW) .LT. LSYMACC

                       IF (QSYM .AND. LSYM) THEN
                           IF (QUSE) THEN
                               NDEG = NDEG + 1
                               IF (I.EQ.NXBA) THEN
                                   DEG2 = NDEG.EQ.2
                                   DEG3 = NDEG.EQ.3
                                   DEG4 = NDEG.EQ.4
                                   DEG5 = NDEG.EQ.5
                                   DEGX = NDEG.GT.5
                                   MDEG = NDEG
                                   FIRST = I - MDEG + 1
                               END IF
                           END IF
                       ELSE
                           DEG2 = NDEG.EQ.2
                           DEG3 = NDEG.EQ.3
                           DEG4 = NDEG.EQ.4
                           DEG5 = NDEG.EQ.5
                           DEGX = NDEG.GT.5
                           MDEG = NDEG
                           FIRST = I - MDEG
                           IF (QUSE) THEN
                               NDEG = 1
                               QOLD = QNEW
                               LOLD = LNEW
                           ELSE
                               NDEG = 0
                           END IF
                       END IF

                       PROCEED =  (DEG2 .OR. DEG3 .OR. DEG4 .OR. DEG5)
     +                                           .AND.
     +                               (SYMNBO (OFFT+FIRST) .NE. 2)

                       IF (PROCEED) THEN
                           WRITE (*,*) ' ATOMIC case! '
                           WRITE (*,*) ' Weight = ',W (OFFT+FIRST)
                           WRITE (*,*) ' Order = ',Q (OFFT+FIRST)
                           WRITE (*,*) ' Loc = ',LOCAL (OFFT+FIRST)
                           WRITE (*,*) ' Degeneracy = ',MDEG
                           WRITE (*,*) ' 1st function = ',FIRST

                           IF (NTETRA.GT.0) THEN

                               CALL  NLO__ROTATE_ATOM_TGROUP_NBO
     +
     +                                    ( NBAS,NATOM,MDEG,
     +                                      NBOSIZE,ROTSIZE,
     +                                      NXBA,
     +                                      OFFX,OFFA,
     +                                      OFFLP,OFFBD,OFFEP,
     +                                      OFFAB,OFFRY,OFFRR,
     +                                      CENTER,
     +                                      NTETRA,
     +                                      PLATO (1,1),
     +                                      SYMCEN,
     +                                      LSYMACC,QSYMACC,
     +                                      FIRST,
     +                                      COLMAP,
     +                                      NBOBD,
     +                                      BDNCEN,BDCEN,
     +                                      HYB,
     +                                      ROT,ROTIDX,
     +                                      SYMCRIT,
     +                                      P,
     +                                      LOCAL,
     +                                      W,Q,
     +                                      XVEC,
     +                                      XMAT,
     +
     +                                               SYMNBO,
     +                                               SLTYPE,
     +                                               BDNBAS,
     +                                               BDBAS,
     +                                               B,
     +                                               C )
     +
     +
                           ELSE IF ((NCUBE.GT.0).OR.(NOCTA.GT.0)) THEN

                               CALL  NLO__ROTATE_ATOM_OGROUP_NBO
     +
     +                                    ( NBAS,NATOM,MDEG,
     +                                      NBOSIZE,ROTSIZE,
     +                                      NXBA,
     +                                      OFFX,OFFA,
     +                                      OFFLP,OFFBD,OFFEP,
     +                                      OFFAB,OFFRY,OFFRR,
     +                                      CENTER,
     +                                      NCUBE,NOCTA,
     +                                      PLATO (1,2),
     +                                      SYMCEN,
     +                                      LSYMACC,QSYMACC,
     +                                      FIRST,
     +                                      COLMAP,
     +                                      NBOBD,
     +                                      BDNCEN,BDCEN,
     +                                      HYB,
     +                                      ROT,ROTIDX,
     +                                      SYMCRIT,
     +                                      P,
     +                                      LOCAL,
     +                                      W,Q,
     +                                      XVEC,
     +                                      XMAT,
     +
     +                                               SYMNBO,
     +                                               SLTYPE,
     +                                               BDNBAS,
     +                                               BDBAS,
     +                                               B,
     +                                               C )
     +
     +
                           ELSE IF (NDODECA.GT.0.OR.NICOSA.GT.0) THEN

                               WRITE (*,*) ' I,Ih-group present! '
                               WRITE (*,*) ' Not implemented yet! '
                               WRITE (*,*) ' Symmetrization skipped... '
                               WRITE (1,*) ' I,Ih-group present! '
                               WRITE (1,*) ' Not implemented yet! '
                               WRITE (1,*) ' Symmetrization skipped... '

                           ELSE IF (PLATONIC) THEN

                               WRITE (*,*) ' Platonic sym present! '
                               WRITE (*,*) ' But no surroundings! '
                               WRITE (*,*) ' Symmetrization skipped... '
                               WRITE (1,*) ' Platonic sym present! '
                               WRITE (1,*) ' But no surroundings! '
                               WRITE (1,*) ' Symmetrization skipped... '

                           ELSE

                               CALL  NLO__ROTATE_ATOM_NBO
     +
     +                                    ( NBAS,NATOM,MDEG,
     +                                      NBOSIZE,ROTSIZE,
     +                                      NXBA,
     +                                      OFFX,OFFA,
     +                                      OFFLP,OFFBD,OFFEP,
     +                                      OFFAB,OFFRY,OFFRR,
     +                                      CENTER,
     +                                      RING,NRING,RINGSZ,
     +                                      SYMCEN,
     +                                      LSYMACC,QSYMACC,
     +                                      FIRST,
     +                                      COLMAP,
     +                                      NBOBD,
     +                                      BDNCEN,BDCEN,
     +                                      HYB,
     +                                      ROT,ROTIDX,
     +                                      SYMCRIT,
     +                                      P,
     +                                      LOCAL,
     +                                      W,Q,
     +                                      XVEC,
     +                                      XMAT,
     +
     +                                              SYMNBO,
     +                                              SLTYPE,
     +                                              BDNBAS,
     +                                              BDBAS,
     +                                              B,
     +                                              C )
     +
     +
                           END IF

                           DEG2 = .FALSE.
                           DEG3 = .FALSE.
                           DEG4 = .FALSE.
                           DEG5 = .FALSE.

                       END IF

                    END DO

                END IF
C
C
C             ...check next atom.
C
C
            END IF
         END DO
C
C
C             ...establish the final atomic NBO weights, localization
C                contents and interaction orders, and reorder the atomic
C                NBOs according to decreasing weight.
C
C
         LTRG = .FALSE.
         UTRG = .FALSE.
         SAVEP = .TRUE.
         TOTAL = .TRUE.

         DO ATOMA = 1,NXA

            IDXA = ATXIDX (ATOMA)
            OFFA = ATXOFF (ATOMA)
            NXBA = ATNXB  (ATOMA)

            OFFT = OFFX + OFFA

            CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                 ( NBAS,NXBA,
     +                   NBAS,NBAS,
     +                   NBAS,NXBA,
     +                   NXBA,
     +                   NXBA,NBAS,
     +                   0,
     +                   SAVEP,LTRG,UTRG,
     +                   C (1,OFFT+1),
     +                   P,
     +
     +                           W (OFFT+1),
     +
     +                   XMAT )
     +
     +
            DO NBO = OFFT+1,OFFT+NXBA

               CALL  NLO__EXTRACT_ATOMIC_CONTENT
     +
     +                    ( NBAS,NATOM,
     +                      1,
     +                      IDXA,
     +                      BASBEG,BASEND,
     +                      TOTAL,
     +                      C (1,NBO),
     +                      SHALF,
     +
     +                               LOCAL (NBO) )
     +
     +
               CALL  NLO__CALC_INTERACTION_ORDER
     +
     +                    ( NBAS,NBAS,
     +                      NBAS,NBAS,
     +                      NBAS,
     +                      NBAS,NBAS,
     +                      NBAS,
     +                      NBO,
     +                      C,P,C (1,NBO),
     +                      XVEC (1),XVEC (NBAS+1),
     +
     +                               Q (NBO) )
     +
     +
            END DO
C
C
C             ...reorder curent atomic NBOs according to decreasing
C                weight. Reorder also all the data associated with
C                these NBOs. Obsolete array ROTIDX will be used
C                as an integer scratch vector.
C
C
            CALL  NLO__SORT_FLP_VECTOR_ELEMENTS
     +
     +                 ( NXBA,NXBA,
     +                   1,NXBA,
     +                   .FALSE.,.FALSE.,
     +                   0,
     +                   W (OFFT+1),
     +
     +                           ROTIDX )
     +
     +
            DO I = 1,NXBA
               COLMAP (ROTIDX (I)) = I
            END DO

            CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +                 ( NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   COLMAP,
     +                   XVEC,
     +
     +                           LOCAL (OFFT+1) )
     +
     +
            CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +                 ( NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   COLMAP,
     +                   XVEC,
     +
     +                           Q (OFFT+1) )
     +
     +
            CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +                 ( NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   COLMAP,
     +                   XVEC,
     +
     +                           W (OFFT+1) )
     +
     +
            CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +                 ( NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   COLMAP,
     +                   ROTIDX,
     +
     +                           NBOBD (OFFT+1) )
     +
     +
            CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +                 ( NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   COLMAP,
     +                   ROTIDX,
     +
     +                           SYMNBO (OFFT+1) )
     +
     +
            CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +                 ( NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   COLMAP,
     +                   ROTIDX,
     +
     +                           SLTYPE (OFFT+1) )
     +
     +
            CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +                 ( NBOSIZE,NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NBOSIZE,
     +                   NBOSIZE,NXBA,
     +                   COLMAP,
     +                   ROTIDX,
     +                   XVEC,
     +
     +                           B (1,OFFT+1) )
     +
     +
            CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +                 ( NBAS,NXBA,
     +                   NXBA,
     +                   NXBA,
     +                   NBAS,
     +                   NBAS,NXBA,
     +                   COLMAP,
     +                   ROTIDX,
     +                   XVEC,
     +
     +                           C (1,OFFT+1) )
     +
     +
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine worker_termination
c------------------------------------------------------------------------
c   worker_termination: Hook to give a worker a chance to finish up.
c------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'proto_events.h'
      include 'int_gen_parms.h'
      include 'timerz.h'
      include 'machine_types.h'
      include 'parallel_info.h'
      include 'saved_data.h'
      include 'dbugcom.h'
      include 'trace.h'

      integer master, i, dummy, ierr
      integer pst_get_my_company
      integer my_company
      integer pst_get_master
      integer nints
      integer treq1, treq2
      integer status(mpi_status_size)

      save
 
      if (.not. terminated_worker_termination) then
         terminated_worker_termination = .true.

         my_company = pst_get_my_company()
         master = pst_get_master()
         if (my_company .eq. io_company_id) then
            call prt_time('SIP server has terminated')
         else
            call prt_time('SIAL worker has terminated...')
         endif

c--------------------------------------------------------------------------
c   Send the timer data to the master.
c--------------------------------------------------------------------------

         if (me .ne. master .and. .not. dryrun .and. do_timer) then 
            call mpi_isend(timers, max_timers, mpi_double_precision,
     *              master, timer_data_request_tag, mpi_comm_world, 
     *              treq1, ierr)

            nints = (max_timers*max_timer_desc_len + intsize-1) / 
     *                intsize
            call mpi_isend(tdesc, nints, mpi_integer,
     *              master, timer_desc_request_tag, mpi_comm_world, 
     *              treq2, ierr)

            call prt_time('Waiting on timer data requests...')
            call mpi_wait(treq1, status, ierr)
            call mpi_wait(treq2, status, ierr)
            call prt_time('Completed timer data requests')
         endif
      endif

      return
      end

      SUBROUTINE EVLOUT(EVAL, IRERDR, IVMLSYM, IREPS, NBAS, NIRREP,
     &                  NOCC, ISPIN)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
#include "maxbasfn.par"
#include "machsp.com"
#include "flags.com"

      INTEGER NBAS
      CHARACTER*8 IRRSYM1(MAXBASFN),IRRSYM2(MAXBASFN)
      CHARACTER*4 IRPCHAR
      CHARACTER*5 SPIN(2)
      LOGICAL FANDUP, SYMINFO_EXIST
      DIMENSION EVAL(NBAS),IRERDR(NBAS)
      DIMENSION IVMLSYM(NBAS),IREPS(9)
      DIMENSION IRPCHAR(8), NOCC(8,2)
C
      DATA FACTOR /27.2113957D0/
      DATA SPIN /'ALPHA',' BETA'/
C
C  Now go get the eigenvalues.
C
      CALL GETREC(20,'JOBARC','SCFEVLA0',NBAS*IINTFP,EVAL(1))
C
      If (ispin.eq.1) then
          CALL GETREC(20,'JOBARC','EVCSYMAF',NBAS*IINTFP,IRRSYM1)
          CALL GETREC(20,'JOBARC','EVCSYMAC',NBAS*IINTFP,IRRSYM2)
      Else
          CALL GETREC(20,'JOBARC','EVCSYMBF',NBAS*IINTFP,IRRSYM1)
          CALL GETREC(20,'JOBARC','EVCSYMBC',NBAS*IINTFP,IRRSYM2)
      Endif
C
      DO 101 I=1,NBAS
         IRERDR(I)=I
  101 CONTINUE
C
C  Check to see if we have MOs which are constitued solely from f
C  or higher functions.  Write out a message stating this fact so
C  the user doesn't get worried.
C
      LUOUT  = 6
      IF(ISPIN.EQ.1) THEN
        FANDUP=.FALSE.
        DO 102 I=1,NBAS
           IF(IRRSYM1(I).EQ.'----') FANDUP=.TRUE.
  102   CONTINUE
C
          IF(FANDUP) THEN
            WRITE(LUOUT,5500)
 5500       FORMAT(T3,'@EVLOUT-I, There are MOs which are solely made ',
     &                'up of f and/or higher',/,
     &             T14,'angular momentum AOs.  Analysis for these ',
     &                 'cases is not yet',/,
     &             T14,'implemented.  These orbitals will have "----"',
     &                 ' as the symmetry.',/)
          ENDIF
        ENDIF
C
        DO 110 J=1,NBAS
          EMIN=EVAL((ISPIN-1)*NBAS+J)
          IMIN=J
          DO 115 K=J,NBAS
            IF(EVAL((ISPIN-1)*NBAS+K).LT.EMIN) THEN
              EMIN=EVAL((ISPIN-1)*NBAS+K)
              IMIN=K
            ENDIF
  115     CONTINUE
          SJUNK=EVAL((ISPIN-1)*NBAS+J)
          EVAL((ISPIN-1)*NBAS+J)=EVAL((ISPIN-1)*NBAS+IMIN)
          EVAL((ISPIN-1)*NBAS+IMIN)=SJUNK
          IJUNK=IRERDR(J)
          IRERDR(J)=IRERDR(IMIN)
          IRERDR(IMIN)=IJUNK
  110   CONTINUE
C
        DO 200 I=1,NBAS
          DO 201 J=1,NIRREP
            IF(IRERDR(I).GE.IREPS(J).AND.IRERDR(I).LT.IREPS(J+1)) 
     &        IVMLSYM(I)=J
  201     CONTINUE
  200   CONTINUE
C
        ITOTOCC=0
        DO 210 I=1,NIRREP
           ITOTOCC=ITOTOCC+NOCC(I,ISPIN)
  210   CONTINUE
C
        IF(IFLAGS(77).NE.0)THEN
          WRITE(LUOUT,5000)SPIN(ISPIN)
 5000     FORMAT(T3,'DIAGONAL FOCK MATRIX ELEMENTS (',A5,')',
     &              '  (1H = 27.2113957 eV)',/)
        ELSE
          WRITE(LUOUT,5002)SPIN(ISPIN)
 5002     FORMAT(T3,'ORBITAL EIGENVALUES (',A5,')',
     &              '  (1H = 27.2113957 eV)',/)
        ENDIF
        WRITE(LUOUT,5009)
 5009   FORMAT(T3,77("-"))
        WRITE(LUOUT,5010)
 5010   FORMAT(T8,'MO #',8X,'E(hartree)',15X,'E(eV)',11X,'FULLSYM',4X,
     &            'COMPSYM')
        WRITE(LUOUT,5015)
 5015   FORMAT(T8,'----',3X,'--------------------',3X,
     &            '--------------------',3X,'-------',3X,'---------')
        DO 125 J=1,NBAS
          WRITE(LUOUT,5020)J,IRERDR(J),EVAL((ISPIN-1)*NBAS+J),
     &                     EVAL((ISPIN-1)*NBAS+J)*FACTOR,
     &                     IRRSYM1(J)(1:4),IRRSYM2(J)(1:4),
     &                     IVMLSYM(J)
 5020     FORMAT(T3,I3,3X,I3,3X,F20.10,3X,F20.10,4X,A4,6X,A4,
     &           1X,'(',I1,')')
          IF(J.EQ.ITOTOCC) WRITE(LUOUT,5021)
 5021     FORMAT(T3,77('+'))
C
  125   CONTINUE
c
        WRITE(LUOUT,5022)
 5022   FORMAT(T3,77("-"))
cmn
c Determine mapping between comp symmetry labels and internal number of irrep.
c
        do j=1,8
           irpchar(j)='XXXX'
        enddo
        do j= 1, nbas
           k = ivmlsym(j)
           if (irpchar(k) .eq. 'XXXX') then
              do i = 1, 4
                 irpchar(k)(i:i) = IRRSYM2(J)(i:i)
              enddo
           endif
        enddo
c
c write this info to file SYMINFO
c
        inquire(file='SYMINFO', exist=syminfo_exist)
        if (.not. syminfo_exist) then
        open(unit=10, FILE='SYMINFO',STATUS='NEW')
        do i = 1, 8
           write(10,599) i,  (irpchar(i)(k:k),k=1,4)
        enddo
 599    format(i4,2x,4a1)
 589    format(i4,a4)
        close(unit=10, status='KEEP')
        endif
cmn end
        WRITE(LUOUT,5025)
 5025   FORMAT(/)
  100 CONTINUE        
C      MO #        E(hartree)               E(eV)           FULLSYM    COMPSYM
C      ----   --------------------   --------------------   -------   ---------
C XXX   XXX   000000000.0000000000   000000000.0000000000     XXX       XXX (X)
C
      RETURN
      END

C DETERMINES TOTAL EXECUTION TIME FOR PROGRAM

      SUBROUTINE CHECKOUT
      IMPLICIT INTEGER (A-Z)

#include "bwcc.com"
#include "timeinfo.com"

cjp - only after we are finished with the last reference in MR
      if ((.not.isbwcc).or.(iref+nproc.gt.nref)) call zclock(1)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__TRANSPOSE_BATCH
     +
     +                    ( NROW,NCOL,
     +                      TILE,
     +                      BATCH,
     +
     +                              OBATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__TRANSPOSE_BATCH
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine transposes a batch of NROW x NCOL
C                integrals to an output batch of NCOL x NROW integrals.
C                The routine uses tiling for better use of cache.
C
C
C                  Input:
C
C                    NROW,NCOL    =  # of rows and columns in input
C                                    integral batch
C                    TILE         =  tile size
C                    BATCH        =  input integral batch
C
C                  Output:
C
C                    OBATCH       =  output integral batch
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,J
         INTEGER     IEND,JEND
         INTEGER     II,JJ
         INTEGER     NROW,NCOL
         INTEGER     TILE

         DOUBLE PRECISION  BATCH   (1:NROW,1:NCOL)
         DOUBLE PRECISION  OBATCH  (1:NCOL,1:NROW)
C
C
C------------------------------------------------------------------------
C
C
C             ...proceed.
C
C
         DO 100 JJ = 1,NROW,TILE
            JEND = MIN (NROW,JJ+TILE-1)
            DO 110 II = 1,NCOL,TILE
               IEND = MIN (NCOL,II+TILE-1)

               DO 120 J = JJ,JEND
               DO 120 I = II,IEND
                  OBATCH (I,J) = BATCH (J,I)
  120          CONTINUE

  110       CONTINUE
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine return_h1_nodiag(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c--------------------------------------------------------------------------
c
c   return_h1 must be executed with the following syntax:
c   execute return_h1 h1(mu,nu)
c
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 indblk, get_block_index
      integer*8 integral_scr
      integer val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      integer array, ind(mx_array_index), seg(mx_array_index)
      integer a1, a2, b1, b2
      integer m, n, nl2
      integer iatom
      integer*8 iscr
      integer find_current_block
      integer*8 get_block_data_index
      integer block
      integer igrad, component, intermediate

      double precision dummy, y
      integer flopcount
      integer*8 arg64(10)
      logical*8 l8false

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter, dcoord

      nl2 = (nbasis * nbasis + nbasis)/2
      handle = op(c_result_array)
      direct_flag = .false.

#ifdef ALTIX
      dptr = dshptr
#endif

c------------------------------------------------------------------------
c   Make sure the requested block exists.  create_current_block will
c   create the block if it does not exist, and simply return if the
c   block is already present.
c------------------------------------------------------------------------

      call create_current_block(handle,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., direct_flag, blk, ierr)
      blkndx = ierr
      call get_block_computed_flag(handle, blk, blkndx, flag)
      if (flag .eq. 0) then
         call set_opblock(handle, blk, blkndx, op)
         call set_block_computed_flag(handle, blk, blkndx, 1)
      endif

      stack = array_table(c_array_stack,handle)
      indblk = get_block_index(handle, blk, stack,
     *                         blkndx, x, .true.)

c--------------------------------------------------------------------------
c   Find the ranges of the AO indices of the input block.
c--------------------------------------------------------------------------

         array = op(c_result_array)

         nind  = array_table(c_nindex,array)
         if (nind .ne. 2) then
            print *,'Error: Fock_der requires a 2-index argument array.'
            print *,'Array ',array,' is defined with ',nind,' indices.'
            call abort_job()
         endif

         do i = 1, nind
            ind(i) = array_table(c_index_array1+i-1,array)
            seg(i) = index_table(c_current_seg,ind(i))
         enddo

         call get_index_segment(ind(1), seg(1), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, a1, a2)
         call get_index_segment(ind(2), seg(2), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, b1, b2)

c--------------------------------------------------------------------------
c   Form the address of the current data block.
c--------------------------------------------------------------------------

         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack = array_table(c_array_stack, array)
         indblk = get_block_data_index(array, block, stack,
     *                                        blkndx, x)

c---------------------------------------------------------------------------
c   Compute data block of integrals.
c---------------------------------------------------------------------------

      if (intpkg .eq.flocke_package) then
         call comp_return_h1_nodiag(x(indblk), a1, a2, b1, b2,nsend)
      else
        write(6,*) ' MUST USE ERD IN FOCK_DER!!! '
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__open_logfile
c------------------------------------------------------------------------
c  operation   : ofh__open_logfile
c  module      : output files handler
c  module-id   : ofh
c  description : This operation opens the logfile for sequential access
c                and formatted output and connects it to unit 1. If the
c                logfile is already open, the routine aborts the
c                program.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         logical    file_open
c
c
c------------------------------------------------------------------------
c
c
c             ...inquire the open status of the logfile.
c
c
         inquire  (unit   = 1,
     +             opened = file_open )
c
c
c             ...logfile already open.
c
c
         if (file_open) then
             write (*,*) ' Cannot connect Logfile to unit 1 ! '
             write (*,*) ' Program will abort! '
             write (*,*) ' ofh__open_logfile '
             call  ofh__stop
         end if
c
c
c             ...open logfile unit and write header.
c
c
         open  (unit   = 1,
     +          access = 'sequential',
     +          file   = logfile_name,
     +          form   = 'formatted',
     +          status = 'unknown')

         write (1,9000) ' ACES3 LOGFILE '
 9000    format (///,a15,///)

         logfile_exists = .true.
c
c
c             ...ready!
c
c
         return
         end

c This routine takes a matrix or a block of a matrix and transforms it from
c one form to another.  This is for a matrix of the same general form as the
c fock matrix (i.e. a block diagonal matrix where each block is symmetric,
c there is one block for each irrep, and the size of each block is kept in
c the variables in the sym.com include file).
c
c Matrices may be stored in one of three forms:
c   triangular  : the matrix is stored in blocks of upper triangular matrices
c   square      : each block of the matrix is stored fully (but none of the
c                 zero's outside each block)
c   full        : the full matrix (including zero's) is stored

      subroutine mat_trans(intype,outtype,in,out,irr)

#include <aces.h>
      implicit none
#include <symm2_ks.com>
#include <callstack.com>
#include <mol.com>

      integer irr,intype,outtype
      M_REAL in(1),out(1)

      integer irrep
      if (intype.eq.outtype) return

      callstack_prev=callstack_curr
      callstack_curr='MAT_TRANS'

      irrep=irr

c Full matrix transformations

      if (intype.eq.MAT_SQR) then
        if (outtype.eq.MAT_TRI) then
          do irrep=1,nirrep
            call mat_trans_sqr_tri(in(irrsqroff(irrep)),
     &          out(irrtrioff(irrep)),numbasir(irrep),
     &          irrtrilen(irrep),1)
          end do
        else if (outtype.eq.MAT_FULL) then
          call dzero(out,nbastot*nbastot)
          do irrep=1,nirrep
            call mat_trans_sqr_sqr(in(irrsqroff(irrep)),out,
     &          numbasir(irrep),nbastot,1,irrorboff(irrep))
          end do
        else
          goto 900
        endif

      else if (intype.eq.MAT_TRI) then
        if (outtype.eq.MAT_SQR) then
          do irrep=1,nirrep
            call mat_trans_tri_sqr(in(irrtrioff(irrep)),
     &          out(irrsqroff(irrep)),irrtrilen(irrep),
     &          numbasir(irrep),1)
          end do
        else if (outtype.eq.MAT_FULL) then
          call dzero(out,nbastot*nbastot)
          do irrep=1,nirrep
            call mat_trans_tri_sqr(in(irrtrioff(irrep)),out,
     &          irrtrilen(irrep),nbastot,irrorboff(irrep))
          end do
        else
          goto 900
        endif

      else if (intype.eq.MAT_FULL) then
        if (outtype.eq.MAT_SQR) then
          do irrep=1,nirrep
            call mat_trans_sqr_sqr(in,out(irrsqroff(irrep)),
     &          nbastot,numbasir(irrep),irrorboff(irrep),1)
          end do
        else if (outtype.eq.MAT_TRI) then
          do irrep=1,nirrep
            call mat_trans_sqr_tri(in,out(irrtrioff(irrep)),nbastot,
     &          irrtrilen(irrep),irrorboff(irrep))
          end do
        else
          goto 900
        endif

c Block transformations

      else if (intype.eq.MAT_FULLSEG) then
        if (outtype.eq.MAT_TRISEG) then
          call mat_trans_sqr_tri(in,out(irrtrioff(irrep)),nbastot,
     &        irrtrilen(irrep),irrorboff(irrep))
        else if (outtype.eq.MAT_TRIBLK) then
          call dzero(out,maxirrtri)
          call mat_trans_sqr_tri(in,out,nbastot,irrtrilen(irrep),
     &        irrorboff(irrep))
        else if (outtype.eq.MAT_SQRSEG) then
          call mat_trans_sqr_sqr(in,out(irrsqroff(irrep)),
     &        nbastot,numbasir(irrep),irrorboff(irrep),1)
        else if (outtype.eq.MAT_SQRBLK) then
          call dzero(out,maxirrsqr)
          call mat_trans_sqr_sqr(in,out,nbastot,numbasir(irrep),
     &        irrorboff(irrep),1)
        else
          goto 900
        endif

      else if (intype.eq.MAT_TRISEG) then
        if (outtype.eq.MAT_FULLSEG) then
          call mat_trans_tri_sqr(in(irrtrioff(irrep)),out,
     &        irrtrilen(irrep),nbastot,irrorboff(irrep))
        else if (outtype.eq.MAT_TRIBLK) then
          call dzero(out,maxirrtri)
          call B_COPY(irrtrilen(irrep),in(irrtrioff(irrep)),1,out,1)
        else if (outtype.eq.MAT_SQRSEG) then
          call mat_trans_tri_sqr(in(irrtrioff(irrep)),
     &        out(irrsqroff(irrep)),irrtrilen(irrep),
     &        numbasir(irrep),1)
        else if (outtype.eq.MAT_SQRBLK) then
          call dzero(out,maxirrsqr)
          call mat_trans_tri_sqr(in(irrtrioff(irrep)),out,
     &        irrtrilen(irrep),numbasir(irrep),1)
        else
          goto 900
        endif

      else if (intype.eq.MAT_TRIBLK) then
        if (outtype.eq.MAT_FULLSEG) then
          call mat_trans_tri_sqr(in,out,irrtrilen(irrep),nbastot,
     &        irrorboff(irrep))
        else if (outtype.eq.MAT_TRISEG) then
          call B_COPY(irrtrilen(irrep),in,1,out(irrtrioff(irrep)),1)
        else if (outtype.eq.MAT_SQRSEG) then
          call mat_trans_tri_sqr(in,out(irrsqroff(irrep)),
     &        irrtrilen(irrep),numbasir(irrep),1)
        else if (outtype.eq.MAT_SQRBLK) then
          call dzero(out,maxirrsqr)
          call mat_trans_tri_sqr(in,out,irrtrilen(irrep),
     &        numbasir(irrep),1)
        else
          goto 900
        endif

      else if (intype.eq.MAT_SQRSEG) then
        if (outtype.eq.MAT_FULLSEG) then
          call mat_trans_sqr_sqr(in(irrsqroff(irrep)),out,
     &        numbasir(irrep),nbastot,1,irrorboff(irrep))
        else if (outtype.eq.MAT_TRISEG) then
          call mat_trans_sqr_tri(in(irrsqroff(irrep)),
     &        out(irrtrioff(irrep)),numbasir(irrep),
     &        irrtrilen(irrep),1)
        else if (outtype.eq.MAT_TRIBLK) then
          call dzero(out,maxirrtri)
          call mat_trans_sqr_tri(in(irrsqroff(irrep)),out,
     &        numbasir(irrep),irrtrilen(irrep),1)
        else if (outtype.eq.MAT_SQRBLK) then
          call dzero(out,maxirrsqr)
          call B_COPY(irrsqrlen(irrep),in(irrsqroff(irrep)),1,out,1)
        else
          goto 900
        endif

      else if (intype.eq.MAT_SQRBLK) then
        if (outtype.eq.MAT_FULLSEG) then
          call mat_trans_sqr_sqr(in,out,numbasir(irrep),nbastot,
     &        1,irrorboff(irrep))
        else if (outtype.eq.MAT_TRISEG) then
          call mat_trans_sqr_tri(in,out(irrtrioff(irrep)),
     &        numbasir(irrep),irrtrilen(irrep),1)
        else if (outtype.eq.MAT_TRIBLK) then
          call dzero(out,maxirrtri)
          call mat_trans_sqr_tri(in,out,numbasir(irrep),
     &        irrtrilen(irrep),1)
        else if (outtype.eq.MAT_SQRSEG) then
          call B_COPY(irrsqrlen(irrep),in,1,out(irrsqroff(irrep)),1)
        else
          goto 900
        endif

      else
        goto 900
      endif

      callstack_curr=callstack_prev
      return

  900 continue
      write(*,9000)
 9000 format('@MAT_TRANS-F: illegal transformation')
      stop
      end

c This routine takes a matrix or a block of a matrix and transforms it from
c one form to another.  This is for a matrix of the same general form as the
c fock matrix (i.e. a block diagonal matrix where each block is symmetric,
c there is one block for each irrep, and the size of each block is kept in
c the variables in the sym.com include file).
c
c Matrices may be stored in one of three forms:
c   triangular  : the matrix is stored in blocks of upper triangular matrices
c   square      : each block of the matrix is stored fully (but none of the
c                 zero's outside each block)
c   full        : the full matrix (including zero's) is stored

      subroutine mat_trans(intype,outtype,in,out,irr)








c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler

























cYAU - ACES3 stuff . . . we hope - #include <aces.par>




      implicit none


      integer maxirrep,num2comb,max2comb
      parameter (maxirrep=8)
      parameter (num2comb=22)
      parameter (max2comb=25)

c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end
      integer        nirrep, numbasir(8),
     &               irpsz1(36),irpsz2(28),irpds1(36),irpds2(56),
     &               old_irpoff(9), irrorboff(9), dirprd(8,8),
     &               old_iwoff1(37), old_iwoff2(29),
     &               inewvc(maxbasfn), idxvec(maxbasfn),
     &               irrtrilen(9), irrtrioff(8),
     &               irrsqrlen(9), irrsqroff(8)
      common /symm2/ nirrep, numbasir,
     &               irpsz1,    irpsz2,    irpds1,    irpds2,
     &               old_irpoff,    irrorboff,    dirprd,
     &               old_iwoff1,     old_iwoff2,
     &               inewvc,           idxvec,
     &               irrtrilen,    irrtrioff,
     &               irrsqrlen,    irrsqroff
      save   /symm2/

      integer             occup(8,2),totocc(2),totocca,totoccb,
     &                    maxirrtri,maxirrsqr,irrtritot,irrsqrtot
      common /sym_ks_com/ occup,     totocc,   totocca,totoccb,
     &                    maxirrtri,maxirrsqr,irrtritot,irrsqrtot
      save   /sym_ks_com/




c This contains the global string for identifying the current subroutine
c or function (provided the programmer set it).  cf. tools/callstack.F
c BE GOOD AND RESET CURR ON EXIT!

      character*64                callstack_curr,callstack_prev
      common /callstack_curr_com/ callstack_curr,callstack_prev
      save   /callstack_curr_com/




c This common block contains the molecule and basis set information
c read in from the JOBARC file.  Since much of this information is
c used in a large number of modules, and since most of the information
c is relatively small compared to the other things held in memory,
c a large percentage of the data stored in the JOBARC file is stored
c here, even though some modules will not use all of it.

c   maxangshell - The maximum number of angular momentum shells.  Since this
c                 is used VERY infrequently, set it high enough to never
c                 cause a problem.
c   spinc(2)    - The characters 'A' and 'B' (useful for alpha/beta labels)
c   natoms      - The number of atoms in the Z-matrix (including X/GH).  After
c                 remove is called, natoms becomes equivalent to nrealatm.
c   natomsx     - The number of atoms in the Z-matrix (including X/GH).  This
c                 does not change.
c   nrealatm    - The number of atoms in the Z-matrix (including GH).
c   naobasfn    - The number of AOs in the basis
c   nbastot     - The number of symmetry adapted orbitals in the basis (the AO
c                 basis may be larger than the SO basis if spherical orbitals
c                 are used since harmonic contaminants are deleted)
c   linear      - 1 if the molecule is linear
c   orientmt    - 3x3 matrix which relates the computational and canonical
c                 orientations
c   nucrep      - Nuclear repulsion energy in a.u.
c   nmproton    - Number of protons in the molecule.
c
c   compptgp    - Point group
c   fullptgp    -
c   compordr    - Order of the point group
c   fullordr    -
c   compnirr    - Number of irreps in the point group
c   fullnirr    -
c   compnorb    - Number of unique atoms (orbits) in the point group
c   fullnorb    -
c   c1symmet    - 1 if the molecule is C1 symmetry
c   nirrep      - The same as compnirr (since nirrep is used so commonly,
c                 this is included for conveniance)
c                 ***NOTE*** nirrep is read in twice and is stored in /sym/
c                            so it is not actually included here
c   totprim     - Total number of primitive functions in the molecule
c   maxshlprim  - Largest number of primitives in a single shell
c   maxshlao    - Largest number of AOs in a single shell
c   maxshlorb   - Largest number of primitive orbitals (primitive functions
c                 times the number of AOs) in a single shell
c   maxangmom   - Largest angular momentum for any atom
c   maxshell    - Larges number of angular momentum shells for any atom
c   noccorb(2)  - The number of alpha and beta occupied orbitals
c   nvrtorb(2)  - The number of alpha and beta virtual orbitals

c The parameter maxorbit is needed because of how dynamic memory is used.
c Two runs of the program are needed.  The first to calculate memory usage,
c the second to use it.  In order to calculate totprim, we have to know the
c orbit population vector (the number of each type of atom).  BUT, this is
c stored in dynamic memory since we do not know how long this vector is.
c In the future, joda or vmol will write this information to JOBARC, and
c this problem will disappear.  In the meantime, we have to introduce a
c genuine limit on the size of the molecule.  It may have no more than
c maxorbit sets of unique atoms.  This limit is ONLY used in the subroutine
c basis, so it probably will disappear when the information in the MOL file
c is put in JOBARC.
c    maxorbit   - the number of symmetry unique atoms

c The following are pointers to real arrays
c
c   zatommass(natoms)  - Atomic mass of all atoms (X=0.0, GH=100.0)
c   zcoord(3,natoms)   - Coordinates of all atoms (computational orientation)
c   zalpha(totprim)    - The alpha for each primitive function
c   zprimcoef(totprim,naobasfn)
c                      - The primitive to AO coefficients
c
c The following are pointers to integer arrays
c
c   patomchrg(natoms)  - Atomic number of all atoms (X=0, GH=110)
c   pfullclss(fullordr)- Class type vector
c   pcompclss(compordr)-
c   pfullpopv(natoms)  - Number of atoms in each orbit
c   pcomppopv(natoms)  -
c   pfullmemb(natoms)  - Atoms sorted by point group orbits
c   pcompmemb(natoms)  -
c   pnprimatom(natoms) - Number of primitive functions for each atom
c   pnshellatom(natoms)- Number of different angular momentum shells for each
c                        atom (takes on values of 1,4,9,16, etc.)
c   pnangatom(natoms)  - The number of different angular momentum for each
c                        atom (takes on values of 1,2,3,4, etc.)
c   pnaoatom(natoms)   - Number of AOs for each atom
c   pnshellprim(maxshell,natoms)
c                      - The number of primitive functions in each shell
c                        of each atom
c   pnshellao(maxshell,natoms)
c                      - The number of AOs in each shell of each atom
c   pprimoff(maxshell,natoms)
c   paooff(maxshell,natoms)
c                      - The primcoef matrix is a block diagonal matrix.
c                        Each shell of each atom has a block.  If you have
c                        a list of all primitive functions, pprimoff(ishell,
c                        iatom) tells the location of the first primitive
c                        function in the block (ishell,iatom) and paooff
c                        contains similar information for the AOs.
c
c ***NOTE***  Because joda stores pfullpopv/pcomppopv as size natoms, we
c             do to, but they should be of size fullnorb/compnorb.  The
c             first ones have real values.  The remaining ones are 0.

      double precision orientmt(3,3),nucrep
      integer natoms,nrealatm,naobasfn,nbastot,linear,compnirr,
     &    fullnirr,compnorb,fullnorb,compordr,fullordr,nmproton,
     &    c1symmet,totprim,maxshlprim,maxshlorb,maxshell,noccorb(2),
     &    nvrtorb(2),maxshlao,maxangmom,natomsx
      integer patomchrg,zatommass,zcoord,pfullclss,pcompclss,
     &    pfullpopv,pcomppopv,pfullmemb,pcompmemb,pnprimatom,
     &    pnshellatom,pnaoatom,pnshellprim,pnshellao,
     &    zalpha,zprimcoef,pprimoff,paooff,pnangatom

      common /mol_com/ orientmt,nucrep,
     &    natoms,nrealatm,naobasfn,nbastot,linear,compnirr,
     &    fullnirr,compnorb,fullnorb,compordr,fullordr,nmproton,
     &    c1symmet,totprim,maxshlprim,maxshlorb,maxshell,noccorb,
     &    nvrtorb,maxshlao,maxangmom,natomsx,
     &    patomchrg,zatommass,zcoord,pfullclss,pcompclss,
     &    pfullpopv,pcomppopv,pfullmemb,pcompmemb,pnprimatom,
     &    pnshellatom,pnaoatom,pnshellprim,pnshellao,zalpha,
     &    zprimcoef,pprimoff,paooff,pnangatom
      save   /mol_com/

      character*4 compptgp,fullptgp
      character*1 spinc(2)
      common /molc_com/ compptgp,fullptgp,spinc
      save   /molc_com/



      integer irr,intype,outtype
      double precision in(1),out(1)

      integer irrep
      if (intype.eq.outtype) return

      callstack_prev=callstack_curr
      callstack_curr='MAT_TRANS'

      irrep=irr

c Full matrix transformations

      if (intype.eq.1) then
        if (outtype.eq.2) then
          do irrep=1,nirrep
            call mat_trans_sqr_tri(in(irrsqroff(irrep)),
     &          out(irrtrioff(irrep)),numbasir(irrep),
     &          irrtrilen(irrep),1)
          end do
        else if (outtype.eq.0) then
          call dzero(out,nbastot*nbastot)
          do irrep=1,nirrep
            call mat_trans_sqr_sqr(in(irrsqroff(irrep)),out,
     &          numbasir(irrep),nbastot,1,irrorboff(irrep))
          end do
        else
          goto 900
        endif

      else if (intype.eq.2) then
        if (outtype.eq.1) then
          do irrep=1,nirrep
            call mat_trans_tri_sqr(in(irrtrioff(irrep)),
     &          out(irrsqroff(irrep)),irrtrilen(irrep),
     &          numbasir(irrep),1)
          end do
        else if (outtype.eq.0) then
          call dzero(out,nbastot*nbastot)
          do irrep=1,nirrep
            call mat_trans_tri_sqr(in(irrtrioff(irrep)),out,
     &          irrtrilen(irrep),nbastot,irrorboff(irrep))
          end do
        else
          goto 900
        endif

      else if (intype.eq.0) then
        if (outtype.eq.1) then
          do irrep=1,nirrep
            call mat_trans_sqr_sqr(in,out(irrsqroff(irrep)),
     &          nbastot,numbasir(irrep),irrorboff(irrep),1)
          end do
        else if (outtype.eq.2) then
          do irrep=1,nirrep
            call mat_trans_sqr_tri(in,out(irrtrioff(irrep)),nbastot,
     &          irrtrilen(irrep),irrorboff(irrep))
          end do
        else
          goto 900
        endif

c Block transformations

      else if (intype.eq.10) then
        if (outtype.eq.31) then
          call mat_trans_sqr_tri(in,out(irrtrioff(irrep)),nbastot,
     &        irrtrilen(irrep),irrorboff(irrep))
        else if (outtype.eq.30) then
          call dzero(out,maxirrtri)
          call mat_trans_sqr_tri(in,out,nbastot,irrtrilen(irrep),
     &        irrorboff(irrep))
        else if (outtype.eq.21) then
          call mat_trans_sqr_sqr(in,out(irrsqroff(irrep)),
     &        nbastot,numbasir(irrep),irrorboff(irrep),1)
        else if (outtype.eq.20) then
          call dzero(out,maxirrsqr)
          call mat_trans_sqr_sqr(in,out,nbastot,numbasir(irrep),
     &        irrorboff(irrep),1)
        else
          goto 900
        endif

      else if (intype.eq.31) then
        if (outtype.eq.10) then
          call mat_trans_tri_sqr(in(irrtrioff(irrep)),out,
     &        irrtrilen(irrep),nbastot,irrorboff(irrep))
        else if (outtype.eq.30) then
          call dzero(out,maxirrtri)
          call dcopy(irrtrilen(irrep),in(irrtrioff(irrep)),1,out,1)
        else if (outtype.eq.21) then
          call mat_trans_tri_sqr(in(irrtrioff(irrep)),
     &        out(irrsqroff(irrep)),irrtrilen(irrep),
     &        numbasir(irrep),1)
        else if (outtype.eq.20) then
          call dzero(out,maxirrsqr)
          call mat_trans_tri_sqr(in(irrtrioff(irrep)),out,
     &        irrtrilen(irrep),numbasir(irrep),1)
        else
          goto 900
        endif

      else if (intype.eq.30) then
        if (outtype.eq.10) then
          call mat_trans_tri_sqr(in,out,irrtrilen(irrep),nbastot,
     &        irrorboff(irrep))
        else if (outtype.eq.31) then
          call dcopy(irrtrilen(irrep),in,1,out(irrtrioff(irrep)),1)
        else if (outtype.eq.21) then
          call mat_trans_tri_sqr(in,out(irrsqroff(irrep)),
     &        irrtrilen(irrep),numbasir(irrep),1)
        else if (outtype.eq.20) then
          call dzero(out,maxirrsqr)
          call mat_trans_tri_sqr(in,out,irrtrilen(irrep),
     &        numbasir(irrep),1)
        else
          goto 900
        endif

      else if (intype.eq.21) then
        if (outtype.eq.10) then
          call mat_trans_sqr_sqr(in(irrsqroff(irrep)),out,
     &        numbasir(irrep),nbastot,1,irrorboff(irrep))
        else if (outtype.eq.31) then
          call mat_trans_sqr_tri(in(irrsqroff(irrep)),
     &        out(irrtrioff(irrep)),numbasir(irrep),
     &        irrtrilen(irrep),1)
        else if (outtype.eq.30) then
          call dzero(out,maxirrtri)
          call mat_trans_sqr_tri(in(irrsqroff(irrep)),out,
     &        numbasir(irrep),irrtrilen(irrep),1)
        else if (outtype.eq.20) then
          call dzero(out,maxirrsqr)
          call dcopy(irrsqrlen(irrep),in(irrsqroff(irrep)),1,out,1)
        else
          goto 900
        endif

      else if (intype.eq.20) then
        if (outtype.eq.10) then
          call mat_trans_sqr_sqr(in,out,numbasir(irrep),nbastot,
     &        1,irrorboff(irrep))
        else if (outtype.eq.31) then
          call mat_trans_sqr_tri(in,out(irrtrioff(irrep)),
     &        numbasir(irrep),irrtrilen(irrep),1)
        else if (outtype.eq.30) then
          call dzero(out,maxirrtri)
          call mat_trans_sqr_tri(in,out,numbasir(irrep),
     &        irrtrilen(irrep),1)
        else if (outtype.eq.21) then
          call dcopy(irrsqrlen(irrep),in,1,out(irrsqroff(irrep)),1)
        else
          goto 900
        endif

      else
        goto 900
      endif

      callstack_curr=callstack_prev
      return

  900 continue
      write(*,9000)
 9000 format('@MAT_TRANS-F: illegal transformation')
      stop
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
       subroutine cwork6441(y, na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                         ne1,ne2,nf1,nf2,
     *                      a1, a2, b1, b2, c1, c2, d1, d2,
     *                      e1, e2, f1, f2,
     *                      inda, indb, indc, indd, inde, indf,
c
     *                      x1,nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2,
     *                          m1, m2, n1, n2, r1, r2, s1, s2,
     *                      indx1,
c
     *                      x2,ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                          i1, i2, j1, j2, k1, k2, l1, l2,
     *                      indx2,
     *                      cind, flopcount, scr1, scr2, scr3)
c      6 index output array  : y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2,ne1:ne2,nf1:nf2)
c      4 index operand array : x1(nm1:nm2,nn1:nn2,nr1:nr2,ns1:ns2)
c      4 index operand array : x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2)
c      1 index contraction.
c
c   I. e., contract two of the the 4 indices of the 2nd operand array out 
c   of the first operand array, replacing the indices by the 2nd operand's 
c   non-contracted indices.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'
      include 'saved_data.h'

      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *        ne1,ne2,nf1,nf2,
     *        nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2, 
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2
      integer a1,a2,b1,b2,c1,c2,d1,d2,
     *        e1,e2,f1,f2,
     *        n1,n2,m1,m2,r1,r2,s1,s2,
     *        i1,i2,j1,j2,k1,k2,l1,l2
      integer inda, indb, indc, indd, inde, indf, indx1(4), indx2(4)
      integer cind(1), flopcount

c     double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2,
c    *                   ne1:ne2,nf1:nf2)
      double precision y(*)
      double precision x1(nm1:nm2,nn1:nn2,nr1:nr2,ns1:ns2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2)
      double precision scr1(*), scr2(*), scr3(*)
      double precision etemp, thresh, max1, max2   
c
c Temporary arrays used in array permutations 
c 
c
c END Temporary arrays used in array permutations 

c     integer p1, p2, q1, q2
      integer na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, np, nq
      integer p0(6), q1(4), q2(4) 

      integer i1a, i1b, i1c, i1d, i1p, i1q
      integer i2a, i2b, i2c, i2d, i2p, i2q
      integer a, b, c, d, e, f, g, h, i, j, l, p, q
      integer aa, bb, cc, dd, ee, ff, ii, jj, ll  
      integer yy, xx, y1, y2, y3, y4, yTOT, nTOT, inc, xinc    
      integer ystart, yend 

#ifdef __crayx1
      integer*8 lda, ldb, ldc, m, nn, k
#else
      integer lda, ldb, ldc, m, nn, k
#endif
      integer n
      character*1 op_a, op_b
      logical b2pq
      logical debug

      debug = cwork_debug
      flopcount = 0

      if (.false.) then

c   o assert x1 is contiguous
      if (m1.ne.nm1.or.n1.ne.nn1.or.r1.ne.nr1.or.s1.ne.ns1.or.
     &    m2.ne.nm2.or.n2.ne.nn2.or.r2.ne.nr2.or.s2.ne.ns2    ) then
         print *, '@CWORK6441: Assertion failed.'
         print *, '            The x1 tensor is not contiguous.'
         call abort_job()
      end if

c   o assert x2 is contiguous
      if (i1.ne.ni1.or.j1.ne.nj1.or.k1.ne.nk1.or.l1.ne.nl1.or.
     &    i2.ne.ni2.or.j2.ne.nj2.or.k2.ne.nk2.or.l2.ne.nl2    ) then
         print *, '@CWORK6441: Assertion failed.'
         print *, '            The x2 tensor is not contiguous.'
         call abort_job()
      end if

c   o assert y is contiguous
      if (a1.ne.na1.or.b1.ne.nb1.or.c1.ne.nc1.or.d1.ne.nd1.or.
     &    a2.ne.na2.or.b2.ne.nb2.or.c2.ne.nc2.or.d2.ne.nd2.or. 
     &    e1.ne.ne1.or.f1.ne.nf1.or.e2.ne.ne2.or.f2.ne.nf2    ) then
         print *, '@CWORK6441: Assertion failed.'
         print *, '            The product tensor is not contiguous.'
         call abort_job()
      end if

c     end if (.false.)
      end if

c     go to 99 
c Try optimized version !!! VFL 

      inc = 5 

      do i = 1, 6 
         p0(i) = i 
      enddo 
      do i = 1, 4 
         q1(i) = 0 
         q2(i) = 0 
      enddo 

      do i = 1, 4 
         if (indx1(i) .eq. inda) q1(i) = p0(1) 
         if (indx1(i) .eq. indb) q1(i) = p0(2) 
         if (indx1(i) .eq. indc) q1(i) = p0(3) 
         if (indx1(i) .eq. indd) q1(i) = p0(4) 
         if (indx1(i) .eq. inde) q1(i) = p0(5) 
         if (indx1(i) .eq. indf) q1(i) = p0(6) 

         if (indx2(i) .eq. inda) q2(i) = p0(1) 
         if (indx2(i) .eq. indb) q2(i) = p0(2) 
         if (indx2(i) .eq. indc) q2(i) = p0(3) 
         if (indx2(i) .eq. indd) q2(i) = p0(4) 
         if (indx2(i) .eq. inde) q2(i) = p0(5) 
         if (indx2(i) .eq. indf) q2(i) = p0(6) 
      enddo 

      do i = 1, 4 
      do j = 1, 4 
         if (indx1(i) .eq. indx2(j)) then 
            q1(i) = 7 ! indx1(i) 
            q2(j) = 7 ! indx1(i) 
         endif 
      enddo 
      enddo 

      nTOT = (f2-f1+1) 
     *     * (e2-e1+1) 
     *     * (d2-d1+1) 
     *     * (c2-c1+1) 
     *     * (b2-b1+1) 
     *     * (a2-a1+1) 

      thresh = 100.0 ! 1.0d-10 

      do a  = 1, nTOT   
         y(a) = 0.0 
      enddo 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.7).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.7).and.(q2(3).eq.5).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
            y2 = 0 
            do c = c1, c2 
            do j = j1, j2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,j,e,f) 
            enddo 
            enddo 

         do d = d1, d2
            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do j = j1, j2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,j,d) 
            enddo 
            enddo 
            enddo 
            y4 = 0   
         do c = c1, c2  
            y4 = y4 + 1 
            xx = (j2-j1+1)*(y4-1) 
            y1 = 0 

         do b = b1, b2, inc 
            do bb = b, min(b2,b+inc-1) 
         do a = a1, a2, inc 
            do aa = a, min(a2,a+inc-1) 

               etemp = 0.0 
               yy    = yy + 1 

               y2 = xx  
               do j = j1, j2     
                  y1 = y1 + 1 
                  y2 = y2 + 1   
                  etemp = etemp + scr1(y1)*scr2(y2)
               enddo

               y(yy) = etemp 
         
            enddo 
         enddo
            enddo 
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.6).and.(q1(3).eq.7).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.7).and.(q2(3).eq.5).and.
     *    (q2(4).eq.2)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do a = a1, a2  
            do j = j1, j2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,f,j,d) 
            enddo 
            enddo 
         do c = c1, c2  
         do b = b1, b2  
            y1 = 0 
            y2 = 0 
            do j = j1, j2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,j,e,b) 
            enddo 
         do a = a1, a2  

            etemp = 0.0 

            y2 = 0 
            do j = j1, j2 
               y1 = y1 + 1 
               y2 = y2 + 1 
c              etemp = etemp + x1(a,f,j,d)*x2(c,j,e,b)
               etemp = etemp + scr1(y1)*scr2(y2)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.5).and.(q1(2).eq.2).and.(q1(3).eq.7).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.7).and.(q2(3).eq.1).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0.0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2

            y2 = 0 
            do a = a1, a2
            do j = j1, j2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,j,a,f) 
            enddo 
            enddo 

         do b = b1, b2

            y2 = 0 
            y1 = 0 
            do j = j1, j2 
               y1 = y1 + 1 
               scr1(y1) = x1(e,b,j,d) 
            enddo 

         do a = a1, a2

            etemp = 0.0 

            y1 = 0 
            do j = j1, j2 
c              etemp = etemp + x1(e,b,j,d)*x2(c,j,a,f)
               y2 = y2 + 1 
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(y2)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.7).and.(q1(3).eq.5).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
            y1 = 0  
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,k,e,f) 
            enddo 
            enddo 
         do d = d1, d2
         do c = c1, c2
         do b = b1, b2
            y1 = 0 
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,b,k,d) 
            enddo 
         do a = a1, a2, inc 
            do aa = a, min(a2,a+inc-1) 

               etemp = 0.0 

               y2 = 0 
               do k = k1, k2 
                  y1 = y1 + 1 
                  y2 = y2 + 1 
c                 etemp = etemp + x1(a,k,e,f)*x2(c,b,k,d)
                  etemp = etemp + scr1(y1)*scr2(y2)
               enddo

               yy = yy + 1 
               y(yy) = etemp  
         
         enddo
            enddo 
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.7).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.7).and.(q2(3).eq.5).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2

            y1 = 0 
            do b = b1, b2 
            do a = a1, a2 
            do j = j1, j2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,j,f) 
            enddo 
            enddo 
            enddo 

         do e = e1, e2
         do d = d1, d2
         do c = c1, c2

            y2 = 0 
            do j = j1, j2 
               y2 = y2 + 1  
               scr2(y2) = x2(c,j,e,d) 
            enddo 

            y1 = 0 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 
 
            do j = j1, j2 
c              etemp = etemp + x1(a,b,j,f)*x2(c,j,e,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(j-j1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.7).and.(q1(3).eq.5).and.
     *    (q1(4).eq.2).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.6).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2

            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,k,e,b) 
            enddo 
            enddo 
            enddo 

         do d = d1, d2
         do c = c1, c2
            y1 = 0 

            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,f,k,d) 
            enddo 

         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,k,e,b)*x2(c,f,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.4).and.(q1(3).eq.5).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2

            y1 = 0  
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,d,e,k) 
            enddo 
            enddo 

         do c = c1, c2
         do b = b1, b2
            y1 = 0 

            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,b,k,f) 
            enddo 

         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,d,e,k)*x2(c,b,k,f)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.4).and.(q1(3).eq.3).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.7).and.(q2(2).eq.2).and.(q2(3).eq.5).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2

            y2 = 0 
            do b = b1, b2
            do i = i1, i2 
               y2 = y2 + 1 
               scr2(y2) = x2(i,b,e,f) 
            enddo 
            enddo 

         do d = d1, d2
         do c = c1, c2

            y1 = 0 
            do a = a1, a2
            do i = i1, i2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,d,c,i) 
            enddo 
            enddo 

            y4 = 0 
         do b = b1, b2
            y4 = y4 + 1 
            xx = (i2-i1+1)*(y4-1) 
            y1 = 0 
         do a = a1, a2

               etemp = 0.0 
               y2 = xx  
            do i = i1, i2 
c              etemp = etemp + x1(a,d,c,i)*x2(i,b,e,f)
               y1 = y1 + 1 
               y2 = y2 + 1 
               etemp = etemp + scr1(y1)*scr2(y2)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.7).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.4).and.(q2(3).eq.5).and.
     *    (q2(4).eq.7)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2

            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do l = l1, l2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,l,f) 
            enddo 
            enddo 
            enddo 

         do e = e1, e2
         do d = d1, d2
         do c = c1, c2

            y2 = 0 
            do l = l1, l2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,d,e,l) 
            enddo 

            y1 = 0 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do l = l1, l2 
c              etemp = etemp + x1(a,b,l,f)*x2(c,d,e,l)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(l-l1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.5).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.4).and.(q2(3).eq.7).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0
         do f = f1, f2
         do e = e1, e2

            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,e,k) 
            enddo 
            enddo 
            enddo 

         do d = d1, d2
         do c = c1, c2

            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,d,k,f) 
            enddo 

         y1 = 0 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,b,e,k)*x2(c,d,k,f)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.3).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.7).and.(q2(2).eq.2).and.(q2(3).eq.5).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
            y2 = 0 
            do b = b1, b2 
            do i = i1, i2 
               y2 = y2 + 1 
               scr2(y2) = x2(i,b,e,f) 
            enddo 
            enddo 

         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            do a = a1, a2 
            do i = i1, i2 
               y1 = y1 + 1 
               scr1(y1) = x1(c,i,a,d) 
            enddo 
            enddo 

         do b = b1, b2
            y1 = 0 
         do a = a1, a2

            etemp = 0.0 

            y3 = 0 
            do i = i1, i2 
               y1 = y1 + 1 
               y3 = y3 + 1 
               y2 = y3 + (b-b1)*(i2-i1+1)  
c              etemp = etemp + x1(c,i,a,d)*x2(i,b,e,f)
               etemp = etemp + scr1(y1)*scr2(y2)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo ! a 
         enddo ! b 
         enddo ! c 
         enddo ! d 
         enddo ! e 
         enddo ! f 

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.3).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.2).and.  
     *    (q2(1).eq.7).and.(q2(2).eq.4).and.(q2(3).eq.5).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2
         do i = i1, i2 
            y1       = y1 + 1 
            scr1(y1) = x1(c,i,a,b) 
         enddo 
         enddo 
         enddo 
         enddo 

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y2 = 0 
            do i = i1, i2 
               y2       = y2 + 1 
               scr2(y2) = x2(i,d,e,f) 
            enddo 
            y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            y2 = 0 
            do i = i1, i2 
               y2 = y2 + 1 
               y1 = y1 + 1 
c              etemp = etemp + x1(c,i,a,b)*x2(i,d,e,f)
               etemp = etemp + scr1(y1)*scr2(y2)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.5).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(e,k,a,d) 
            enddo 
            enddo 

         do c = c1, c2
         do b = b1, b2
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,b,k,f) 
            enddo 
            y1 = 0 
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
               y1 = y1 + 1 
c              etemp = etemp + x1(e,k,a,d)*x2(c,b,k,f)
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1  
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.5).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.2).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.4).and.(q2(3).eq.7).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
            y2 = 0 
            do d = d1, d2
            do c = c1, c2
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,d,k,f) 
            enddo 
            enddo 
            enddo 
         do e = e1, e2
            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do k = k1, k2 
               y1       = y1 + 1 
               scr1(y1) = x1(e,k,a,b) 
            enddo 
            enddo 
            enddo 
         y4 = 0 
         do d = d1, d2
         do c = c1, c2
            y4 = y4 + 1 
            y3 = (y4-1) *(k2-k1+1)  
            y1 = 0 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            y2 = 0 
            do k = k1, k2 
               y1 = y1 + 1 
               y2 = y2 + 1 
c              etemp = etemp + x1(e,k,a,b)*x2(c,d,k,f)
               etemp = etemp + scr1(y1)*scr2(y2+y3)
            enddo

            yy = yy + 1  
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.4).and.(q1(3).eq.7).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.7).and.(q2(3).eq.3).and.
     *    (q2(4).eq.2)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2  
         do e = e1, e2, inc 
            do ee = e, min(e2,e+inc-1) 
         do d = d1, d2  
         do c = c1, c2  
         do b = b1, b2  
            y2 = 0 
            do j = j1, j2 
               y2 = y2 + 1 
               scr2(y2) = x2(ee,j,c,b) 
            enddo 
         do a = a1, a2,inc 
            do aa = a, min(a2,a+inc-1) 

               etemp = 0.0 

               do j = j1, j2   
c                 etemp = etemp + x1(aa,d,j,f)*x2(ee,j,c,b)
                  etemp = etemp + x1(aa,d,j,f)*scr2(j-j1+1)
               enddo

               yy = yy + 1 
               y(yy) = etemp  
         
            enddo 
         enddo
         enddo
         enddo
         enddo
            enddo 
         enddo
         enddo

         return 
c        go to 99 

      endif 

c VFL 
      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.7).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.7).and.(q2(3).eq.3).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         y3 = 0 
         do f = f1, f2
            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do j = j1, j2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,j,f) 
            enddo 
            enddo 
            enddo 
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2
            y2 = 0 
            do j = j1, j2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,j,c,d) 
            enddo 
         y1 = 0 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            y2 = 0 
            do j = j1, j2 
               y1 = y1 + 1 
               y2 = y2 + 1 
c              etemp = etemp + x1(a,b,j,f)*x2(e,j,c,d)
               etemp = etemp + scr1(y1)*scr2(y2)  
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.4).and.(q1(3).eq.7).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.2).and.(q2(3).eq.5).and.
     *    (q2(4).eq.7)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do a = a1, a2
            do l = l1, l2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,d,l,f) 
            enddo 
            enddo 

         do c = c1, c2
         do b = b1, b2
            y1 = 0 

            y2 = 0 
            do l = l1, l2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,b,e,l) 
            enddo 

         do a = a1, a2

            etemp = 0.0 

            do l = l1, l2 
c              etemp = etemp + x1(a,d,l,f)*x2(c,b,e,l)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(l-l1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.3).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.7).and.(q2(2).eq.4).and.(q2(3).eq.5).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2
         do i = i1, i2 
            y1 = y1 + 1 
            scr1(y1) = x1(a,b,c,i) 
         enddo 
         enddo 
         enddo 
         enddo 

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y2 = 0 
            do i = i1, i2 
               y2 = y2 + 1 
               scr2(y2) = x2(i,d,e,f) 
            enddo 
            y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do i = i1, i2 
c              etemp = etemp + x1(a,b,c,i)*x2(i,d,e,f)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(i-i1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.6).and.(q1(3).eq.5).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2

            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,f,e,k) 
            enddo 
            enddo 

         do d = d1, d2
         do c = c1, c2
         do b = b1, b2
            y1 = 0 

            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,b,k,d) 
            enddo 

         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,f,e,k)*x2(c,b,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 
 

      if ((q1(1).eq.1).and.(q1(2).eq.4).and.(q1(3).eq.5).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.6).and.(q2(3).eq.7).and.
     *    (q2(4).eq.2)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,d,e,k) 
            enddo 
            enddo 
         do c = c1, c2
         do b = b1, b2
            y1 = 0 
            y2 = 0  
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,f,k,b) 
            enddo 
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
               etemp = etemp + x1(a,d,e,k)*x2(c,f,k,b)
               y1 = y1 + 1 
c              etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.7).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.6).and.(q2(3).eq.3).and.
     *    (q2(4).eq.7)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do l = l1, l2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,l,d) 
            enddo 
            enddo 
            enddo 
           
         do c = c1, c2
            y1 = 0 
            y2 = 0 
            do l = l1, l2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,f,c,l) 
            enddo 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do l = l1, l2 
c              etemp = etemp + x1(a,b,l,d)*x2(e,f,c,l)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(l-l1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.6).and.(q1(3).eq.7).and.
     *    (q1(4).eq.2).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.4).and.(q2(3).eq.3).and.
     *    (q2(4).eq.7)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do l = l1, l2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,f,l,b) 
            enddo  
            enddo  
            enddo  
            
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            y2 = 0 
            do l = l1, l2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,d,c,l) 
            enddo 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do l = l1, l2 
c              etemp = etemp + x1(a,f,l,b)*x2(e,d,c,l)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(l-l1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.6).and.(q1(3).eq.3).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,f,c,k) 
            enddo 
            enddo 

         do b = b1, b2
            y1 = 0 
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,b,k,d) 
            enddo 
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,f,c,k)*x2(e,b,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.4).and.(q1(3).eq.3).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.6).and.(q2(3).eq.7).and.
     *    (q2(4).eq.2)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,d,c,k) 
            enddo 
            enddo 

         do b = b1, b2
            y1 = 0 
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,f,k,b) 
            enddo 
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,d,c,k)*x2(e,f,k,b)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.5).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.6).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
            y1 = 0 
            do b = b1, b2
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,b,e,k) 
            enddo 
            enddo 
            enddo 
         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,f,k,d) 
            enddo 
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,b,e,k)*x2(c,f,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.2).and.(q1(3).eq.3).and.
     *    (q1(4).eq.7).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.6).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2
         do k = k1, k2 
            y1 = y1 + 1 
            scr1(y1) = x1(a,b,c,k) 
         enddo 
         enddo 
         enddo 
         enddo 

         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,f,k,d) 
            enddo 
            y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,b,c,k)*x2(e,f,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.6).and.(q1(3).eq.7).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.2).and.(q2(3).eq.3).and.
     *    (q2(4).eq.7)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do a = a1, a2 
            do l = l1, l2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,f,l,d) 
            enddo 
            enddo 
         do c = c1, c2
         do b = b1, b2
            y2 = 0 
            do l = l1, l2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,b,c,l) 
            enddo 
            y1 = 0 
         do a = a1, a2

            etemp = 0.0 

            do l = l1, l2 
c              etemp = etemp + x1(a,f,l,d)*x2(e,b,c,l)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(l-l1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.3).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(c,k,a,d) 
            enddo 
            enddo 
      
         do b = b1, b2
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,b,k,f) 
            enddo 
            y1 = 0 
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(c,k,a,d)*x2(e,b,k,f)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.3).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.2).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.6).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2
         do k = k1, k2 
            y1 = y1 + 1 
            scr1(y1) = x1(c,k,a,b) 
         enddo 
         enddo 
         enddo 
         enddo 

         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,f,k,d) 
            enddo 
            y1 = 0 
         do c = c1, c2
         do b = b1, b2
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(c,k,a,b)*x2(e,f,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.1).and.(q1(2).eq.7).and.(q1(3).eq.5).and.
     *    (q1(4).eq.4).and.  
     *    (q2(1).eq.3).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.6)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(a,k,e,d) 
            enddo 
            enddo 

         do c = c1, c2
         do b = b1, b2
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(c,b,k,f) 
            enddo 
            
            y1 = 0 
         do a = a1, a2

            etemp = 0.0 

            do k = k1, k2 
c              etemp = etemp + x1(a,k,e,d)*x2(c,b,k,f)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

      if ((q1(1).eq.3).and.(q1(2).eq.7).and.(q1(3).eq.1).and.
     *    (q1(4).eq.6).and.  
     *    (q2(1).eq.5).and.(q2(2).eq.2).and.(q2(3).eq.7).and.
     *    (q2(4).eq.4)) then   
c        print *,'cwork6441: Optimized version lineno ',current_line

         yy = 0 
         do f = f1, f2
         do e = e1, e2
         do d = d1, d2
         do c = c1, c2
            y1 = 0 
            do a = a1, a2
            do k = k1, k2 
               y1 = y1 + 1 
               scr1(y1) = x1(c,k,a,f) 
            enddo 
            enddo 
         do b = b1, b2
            y2 = 0 
            do k = k1, k2 
               y2 = y2 + 1 
               scr2(y2) = x2(e,b,k,d) 
            enddo 
            y1 = 0 
         do a = a1, a2

            etemp = 0.0 ! VFL  

            do k = k1, k2 
c              etemp = etemp + x1(c,k,a,f)*x2(e,b,k,d)
               y1 = y1 + 1 
               etemp = etemp + scr1(y1)*scr2(k-k1+1)
            enddo

            yy = yy + 1 
            y(yy) = etemp  
         
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return 
c        go to 99 

      endif 

99    continue 
c-----------------------------------------------------------------------
c   Perform the contraction again in unoptimized mode.
c-----------------------------------------------------------------------

      write(6,*) 'Using unoptimized cwork6441 at line number ', 
     *            current_line 
            call cwork6441_unopt(y, na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     &                              ne1,ne2,nf1,nf2, 
     &                               a1, a2, b1, b2, c1, c2, d1, d2,
     &                               e1,e2,f1,f2, 
     &                           inda, indb, indc, indd, inde, indf,
     &                           x1,nm1,nm2,nn1,nn2,nr1,nr2,ns1,ns2,
     &                               m1, m2, n1, n2, r1, r2, s1, s2,
     &                           indx1,
     &                           x2,ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     &                               i1, i2, j1, j2, k1, k2, l1, l2,
     &                           indx2,
     &                           cind, flopcount, scr1, scr2)

      return
      end

      SUBROUTINE SYTRA(A,DISSIZE,NUM1,NUM2,SCR)
C
C   THIS ROUTINE COMPUTES THE TRANSPOSE OF A GIVEN MATRIX
C
C    A(DISSIZE,IJ) ----> A(DISSIZE,JI)
C
C    WHERE     NUM1 AND NUM2 GIVE THE NUMBER OF DIFFERENT
C              I AND J INDICES RESPECTIVELY
C
C    SCR IS AN SCRATCH ARRAY OF LENGTH NUM1*NUM2
C
C    NOTE THIS ROUTINE IS USED IN OUT-CORE ALGORITHMN WHERE
C    ONLY ONE SUB BLOCK OF THE A-MATRIX WITHIN ONE GIVEN
C    SYMMETRY IS AVAILABLE
C
CEND
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DISSIZE
      DIMENSION A(DISSIZE,1),SCR(1)
C
      DO 100 L=1,DISSIZE
      DO 10 J=1,NUM2
      DO 10 I=1,NUM1
      IND1=(J-1)*NUM1+I
      IND2=(I-1)*NUM2+J
      SCR(IND2)=A(L,IND1)
10    CONTINUE
      DO 20 IJ=1,NUM1*NUM2
      A(L,IJ)=SCR(IJ)
20    CONTINUE
100   CONTINUE
      RETURN
      END  

      SUBROUTINE SQUEZ4(VFULL,VPACK,LENGTH,IDIM)
C
C THIS ROUTINE EXPANDS A "PACKED" MATRIX TO FULL FORMAT, WHERE
C   THE PACKED ORDER IS :  V(1,1),V(2,1),...,V(N,1),V(2,2),...
C
C THIS IS USEFUL FOR EXPANDING THE D FUNCTION REPRESENTATIONS TO
C   A FULL 3x3 MATRIX
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VPACK(1),VFULL(LENGTH*LENGTH)
      INTEGER DLOC(6),FLOC(10),GLOC(15),DPAK,FPAK,GPAK,DSIZ,FSIZ,GSIZ
      DIMENSION DFAC(6),FFAC(10),GFAC(15)
C
      PARAMETER (TWO   = 2.0D0)
      PARAMETER (ONE   = 1.0D0)
      PARAMETER (THREE = 3.0D0)
      PARAMETER (SIX   = 6.0D0)
      PARAMETER (FOUR  =4.00D0)
      PARAMETER (TWELVE=12.D0)
C   
      DATA DPAK /6/
      DATA FPAK /10/
      DATA GPAK /15/
      DATA DSIZ /9/
      DATA FSIZ /27/
      DATA GSIZ /81/
      DATA DLOC /1,2,3,5,6,9/
      DATA FLOC /1,2,3,5,6,9,14,15,18,27/
      DATA GLOC /1,2,3,5,6,9,14,15,18,27,41,42,45,54,81/
      DATA DFAC /ONE,TWO,TWO,ONE,TWO,ONE/
      DATA FFAC /ONE,THREE,THREE,THREE,SIX,THREE,ONE,THREE,
     &           THREE,ONE/
      DATA GFAC /ONE,FOUR,FOUR,SIX,TWELVE,
     &           SIX,FOUR,TWELVE,TWELVE,FOUR,
     &           ONE,FOUR,SIX,FOUR,ONE/
C
      INDX2(I,J)=I+3*(J-1)
      INDX3(I,J,K)=I+3*(J-1)+9*(K-1)
      INDX4(I,J,K,L)=I+3*(J-1)+9*(K-1)+27*(L-1) 
C
C CODE FOR TWO DIMENSIONAL MATRICES (SUCH AS d FUNCTIONS)
C
      IF(IDIM.EQ.2)THEN
       CALL GATHER(DPAK,VPACK,VFULL,DLOC)
       CALL VECPRD(DFAC,VPACK,VPACK,DPAK)
C
C CODE FOR THREE DIMENSIONAL MATRICES (SUCH AS f FUNCTIONS)
C
      ELSEIF(IDIM.EQ.3)THEN
       CALL GATHER (FPAK,VPACK,VFULL,FLOC)
       CALL VECPRD (FFAC,VPACK,VPACK,FPAK)
C
C CODE FOR FOUR DIMENSIONAL MATRICES (g FUNCTIONS)
C
      ELSEIF(IDIM.EQ.4)THEN
       CALL GATHER (GPAK,VPACK,VFULL,GLOC)
       CALL VECPRD (GFAC,VPACK,VPACK,GPAK)
C
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__CTR_PAIR_UPDATE
     +
     +                    ( N,
     +                      NPMAX,NPMIN,
     +                      MIJ,NRS,
     +                      NBLOCK,
     +                      NCR,NCS,
     +                      NPR,NPS,
     +                      CCR,CCS,
     +                      CCBEGR,CCBEGS,
     +                      CCENDR,CCENDS,
     +                      PRIMR,PRIMS,
     +                      EQUALRS,
     +                      SWAPRS,
     +                      PUSED,PSAVE,PPAIR,
     +                      X,W,
     +
     +                             Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__CTR_PAIR_UPDATE
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a pair contraction step on
C                the incomming integrals over primitives in blocked
C                form over invariant indices n and updates old
C                transformed integrals:
C
C                   y (n,rs) = y (n,rs)
C                              + sum  ccr (r,i) * ccs (s,j) * x (n,ij)
C                                 ij
C
C                where ccr and ccs are the arrays containing the
C                contraction coefficients. The sum is over the i and
C                j primitives which are transmitted in arrays PRIMR
C                and PRIMS, respectively, and may constitute only
C                a subset of the full range of primitives.
C
C                The contraction is split into two quarter steps,
C                the order of which is determined by the # of i and
C                j primitives:
C
C                   a) w (n,j/i) = sum ccr/s (r/s,i/j) * x (n,ij)
C                                  i/j
C
C                   b) y (n,rs)  = y (n,rs)
C                                  + sum ccs/r (s/r,j/i) * w (n,j/i)
C                                    j/i
C
C                Size of the intermediate w (n,i) or w (n,j) array
C                has to be kept to a minimum and blocking over the
C                invariant indices n has to be performed such that
C                the intermediate w array does not get kicked out
C                from the cache lines after the first quarter
C                transformation.
C
C                In case of csh equality (EQUALRS = .true), we only
C                have to consider the lower triangle of the primitive
C                integrals, which, with the exception of the diagonals,
C                have to be used twice.
C
C                        --- SEGMENTED CONTRACTIONS ---
C
C                Segmented contractions are those defined to be
C                within a certain consecutive i- and j-range of
C                primitives. The segmented limits for each contraction
C                are sitting respectively in CCBEGR and CCBEGS (lowest
C                limit) and CCENDR and CCENDS (highest limit) and they
C                determine which of the actual i's and j's from the
C                PRIMR and PRIMS lists have to be considered for each
C                contraction index.
C
C                The code also allows efficient contractions in case
C                there is only one contraction coefficient present
C                in a certain contraction and its value is equal to 1.
C                In such cases we can save lots of multiplications by
C                1 and since these cases are quite common for certain
C                types of basis functions it is worth including some
C                IF's inside the contraction loops to gain speed.
C
C
C                  Input:
C
C                    N            =  # of invariant indices
C                    NPMAX(MIN)   =  the maximum (minimum) # of
C                                    primitives between both primitive
C                                    sets i,j
C                    MIJ          =  # of ij primitive products to
C                                    be transformed
C                    NRS          =  # of rs contractions to be done
C                    NBLOCK       =  blocking size for invariant
C                                    indices n
C                    NCR(S)       =  # of contractions for the i -> R
C                                    (j -> S) primitives
C                    NPR(S)       =  # of i(j) primitives
C                    CCR(S)       =  full set (including zeros) of
C                                    contraction coefficients for
C                                    R(S) contractions
C                    CCBEGR(S)    =  lowest nonzero primitive i(j)
C                                    index for R(S) contractions
C                    CCENDR(S)    =  highest nonzero primitive i(j)
C                                    index for R(S) contractions
C                    PRIMR(S)     =  primitive i(j) indices
C                    EQUALRS      =  is true, if only the lower
C                                    triangle of ij primitive indices
C                                    is present and consequently
C                                    only the lower triangle of rs
C                                    contractions needs to be evaluated
C                    SWAPRS       =  if this is true, the 1st quarter
C                                    transformation is over R followed
C                                    by the 2nd over S. If false, the
C                                    order is reversed: 1st over S then
C                                    2nd over R
C                    Pxxxx        =  intermediate storage arrays for
C                                    primitive labels to bundle
C                                    contraction steps in do loops
C                                    (xxxx = USED,SAVE,PAIR)
C                    X            =  input array containing the
C                                    primitive integrals
C                    W            =  intermediate storage array
C                                    containing 1st half transformed
C                                    primitive integrals
C
C                  Output:
C
C                    Y            =  contains the updated transformed
C                                    integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     CNTRCT
         LOGICAL     EQUALRS
         LOGICAL     IRANGE,JRANGE
         LOGICAL     SWAPRS

         INTEGER     I,J,K,L,M,N,R,S
         INTEGER     I1,I2,I3,I4,I5,I6,I7,I8
         INTEGER     IJ,RS
         INTEGER     IJ1,IJ2,IJ3,IJ4,IJ5,IJ6,IJ7,IJ8
         INTEGER     INEXT,JNEXT
         INTEGER     J1,J2,J3,J4,J5,J6,J7,J8
         INTEGER     MIJ,NRS
         INTEGER     NBLOCK,NSUB
         INTEGER     NCR,NCS
         INTEGER     NI,NJ
         INTEGER     NIBASE,NJBASE
         INTEGER     NILEFT,NJLEFT
         INTEGER     NIREST,NJREST
         INTEGER     NISTEP,NJSTEP
         INTEGER     NPMAX,NPMIN
         INTEGER     NPR,NPS
         INTEGER     PMIN,PMAX

         INTEGER     CCBEGR (1:NCR)
         INTEGER     CCBEGS (1:NCS)
         INTEGER     CCENDR (1:NCR)
         INTEGER     CCENDS (1:NCS)

         INTEGER     PRIMR  (1:MIJ)
         INTEGER     PRIMS  (1:MIJ)

         INTEGER     PPAIR  (1:NPMAX)
         INTEGER     PSAVE  (1:NPMAX)
         INTEGER     PUSED  (1:NPMIN)

         DOUBLE PRECISION    C1,C2,C3,C4,C5,C6,C7,C8
         DOUBLE PRECISION    ZERO,ONE

         DOUBLE PRECISION    CCR  (1:NPR,1:NCR)
         DOUBLE PRECISION    CCS  (1:NPS,1:NCS)

         DOUBLE PRECISION    W (1:NBLOCK,1:NPMIN)

         DOUBLE PRECISION    Y (1:N,1:NRS)
         DOUBLE PRECISION    X (1:N,1:MIJ)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check case R >= S or full RS range.
C
C
         IF (EQUALRS) THEN
C
C
C             ...the R >= S case. Here we always have equal # of
C                primitives I and J for both R and S. The primitives
C                I >= J are ordered such that J varies fastest.
C                Outer contraction is over S, inner over R.
C
C
           DO 1000 K = 0,N-1,NBLOCK
              NSUB = MIN0 (NBLOCK,N-K)

              RS = 0
              DO 100 S = 1,NCS
                 PMIN = CCBEGS (S)
                 PMAX = CCENDS (S)

                 DO 110 I = 1,NPR
                    PUSED (I) = 0
  110            CONTINUE

                 IF (PMIN.EQ.PMAX .AND. CCS (PMIN,S).EQ.ONE) THEN
C
C
C             ...we reach this point, if only one S contraction
C                coefficient equal to 1.0 is present.
C
C
                     DO 120 IJ = 1,MIJ
                        J = PRIMS (IJ)
                        IF (J.EQ.PMIN) THEN
                            I = PRIMR (IJ)
                            DO L = 1,NSUB
                               W (L,I) = X (K+L,IJ)
                            END DO
                            PUSED (I) = 1
                        END IF
  120                CONTINUE
                 ELSE
C
C
C             ...the general S contraction case with many coefficients.
C                For each I determine all allowed J's and perform the
C                present S contraction for each I over all J's
C                simultaneously.
C
C
                     NJ = 0
                     DO 130 IJ = 1,MIJ
                        I = PRIMR (IJ)
                        J = PRIMS (IJ)
                        JRANGE = J.GE.PMIN .AND. J.LE.PMAX

                        IF (JRANGE) THEN
                            NJ = NJ + 1
                            PSAVE (NJ) = J
                            PPAIR (NJ) = IJ
                        END IF

                        IF (IJ.EQ.MIJ) THEN
                            INEXT = 0
                        ELSE
                            INEXT = PRIMR (IJ+1)
                        END IF

                        CNTRCT = (INEXT.NE.I) .AND. (NJ.GT.0)

                        IF (CNTRCT) THEN
                            IF (NJ.EQ.1) THEN
                                IJ1 = PPAIR (1)
                                C1 = CCS (PSAVE (1),S)
                                DO L = 1,NSUB
                                   W (L,I) = C1 * X (K+L,IJ1)
                                END DO
                            ELSE IF (NJ.EQ.2) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
                                END DO
                            ELSE IF (NJ.EQ.3) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
                                END DO
                            ELSE IF (NJ.EQ.4) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                IJ4 = PPAIR (4)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                C4 = CCS (PSAVE (4),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
     +                                       + C4 * X (K+L,IJ4)
                                END DO
                            ELSE IF (NJ.EQ.5) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                IJ4 = PPAIR (4)
                                IJ5 = PPAIR (5)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                C4 = CCS (PSAVE (4),S)
                                C5 = CCS (PSAVE (5),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
     +                                       + C4 * X (K+L,IJ4)
     +                                       + C5 * X (K+L,IJ5)
                                END DO
                            ELSE IF (NJ.EQ.6) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                IJ4 = PPAIR (4)
                                IJ5 = PPAIR (5)
                                IJ6 = PPAIR (6)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                C4 = CCS (PSAVE (4),S)
                                C5 = CCS (PSAVE (5),S)
                                C6 = CCS (PSAVE (6),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
     +                                       + C4 * X (K+L,IJ4)
     +                                       + C5 * X (K+L,IJ5)
     +                                       + C6 * X (K+L,IJ6)
                                END DO
                            ELSE IF (NJ.EQ.7) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                IJ4 = PPAIR (4)
                                IJ5 = PPAIR (5)
                                IJ6 = PPAIR (6)
                                IJ7 = PPAIR (7)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                C4 = CCS (PSAVE (4),S)
                                C5 = CCS (PSAVE (5),S)
                                C6 = CCS (PSAVE (6),S)
                                C7 = CCS (PSAVE (7),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
     +                                       + C4 * X (K+L,IJ4)
     +                                       + C5 * X (K+L,IJ5)
     +                                       + C6 * X (K+L,IJ6)
     +                                       + C7 * X (K+L,IJ7)
                                END DO
                            ELSE IF (NJ.EQ.8) THEN
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                IJ4 = PPAIR (4)
                                IJ5 = PPAIR (5)
                                IJ6 = PPAIR (6)
                                IJ7 = PPAIR (7)
                                IJ8 = PPAIR (8)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                C4 = CCS (PSAVE (4),S)
                                C5 = CCS (PSAVE (5),S)
                                C6 = CCS (PSAVE (6),S)
                                C7 = CCS (PSAVE (7),S)
                                C8 = CCS (PSAVE (8),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
     +                                       + C4 * X (K+L,IJ4)
     +                                       + C5 * X (K+L,IJ5)
     +                                       + C6 * X (K+L,IJ6)
     +                                       + C7 * X (K+L,IJ7)
     +                                       + C8 * X (K+L,IJ8)
                                END DO
                            ELSE
                                IJ1 = PPAIR (1)
                                IJ2 = PPAIR (2)
                                IJ3 = PPAIR (3)
                                IJ4 = PPAIR (4)
                                IJ5 = PPAIR (5)
                                IJ6 = PPAIR (6)
                                IJ7 = PPAIR (7)
                                IJ8 = PPAIR (8)
                                C1 = CCS (PSAVE (1),S)
                                C2 = CCS (PSAVE (2),S)
                                C3 = CCS (PSAVE (3),S)
                                C4 = CCS (PSAVE (4),S)
                                C5 = CCS (PSAVE (5),S)
                                C6 = CCS (PSAVE (6),S)
                                C7 = CCS (PSAVE (7),S)
                                C8 = CCS (PSAVE (8),S)
                                DO L = 1,NSUB
                                   W (L,I) =   C1 * X (K+L,IJ1)
     +                                       + C2 * X (K+L,IJ2)
     +                                       + C3 * X (K+L,IJ3)
     +                                       + C4 * X (K+L,IJ4)
     +                                       + C5 * X (K+L,IJ5)
     +                                       + C6 * X (K+L,IJ6)
     +                                       + C7 * X (K+L,IJ7)
     +                                       + C8 * X (K+L,IJ8)
                                END DO

                                NJBASE = 8
                                NJLEFT = NJ - 8
                                NJSTEP = NJLEFT / 8
                                NJREST = MOD (NJLEFT,8)

                                DO M = 1,NJSTEP
                                   IJ1 = PPAIR (NJBASE+1)
                                   IJ2 = PPAIR (NJBASE+2)
                                   IJ3 = PPAIR (NJBASE+3)
                                   IJ4 = PPAIR (NJBASE+4)
                                   IJ5 = PPAIR (NJBASE+5)
                                   IJ6 = PPAIR (NJBASE+6)
                                   IJ7 = PPAIR (NJBASE+7)
                                   IJ8 = PPAIR (NJBASE+8)
                                   C1 = CCS (PSAVE (NJBASE+1),S)
                                   C2 = CCS (PSAVE (NJBASE+2),S)
                                   C3 = CCS (PSAVE (NJBASE+3),S)
                                   C4 = CCS (PSAVE (NJBASE+4),S)
                                   C5 = CCS (PSAVE (NJBASE+5),S)
                                   C6 = CCS (PSAVE (NJBASE+6),S)
                                   C7 = CCS (PSAVE (NJBASE+7),S)
                                   C8 = CCS (PSAVE (NJBASE+8),S)
                                   DO L = 1,NSUB
                                      W (L,I) = W (L,I)
     +                                             + C1 * X (K+L,IJ1)
     +                                             + C2 * X (K+L,IJ2)
     +                                             + C3 * X (K+L,IJ3)
     +                                             + C4 * X (K+L,IJ4)
     +                                             + C5 * X (K+L,IJ5)
     +                                             + C6 * X (K+L,IJ6)
     +                                             + C7 * X (K+L,IJ7)
     +                                             + C8 * X (K+L,IJ8)
                                   END DO
                                   NJBASE = NJBASE + 8
                                END DO

                                DO M = 1,NJREST
                                   IJ1 = PPAIR (NJBASE+M)
                                   C1 = CCS (PSAVE (NJBASE+M),S)
                                   DO L = 1,NSUB
                                      W (L,I) = W (L,I)
     +                                             + C1 * X (K+L,IJ1)
                                   END DO
                                END DO

                            END IF
                            PUSED (I) = 1
C
C
C             ...don't forget to add into W the contributions due
C                to the J indices due to triangularization. Observe
C                that there is no possibility of grouping the J's
C                together, unless we resort the I and J such that
C                I varies fastest. Also observe that only J's
C                will be addressed that are =< I, hence we do
C                not run into the danger of addressing W columns
C                prematurely which have J > I, which saves us
C                from checking addressing of W columns during the
C                above simultaneous J contractions for each I. 
C
C
                            IF (I.GE.PMIN .AND. I.LE.PMAX) THEN
                                C1 = CCS (I,S)
                                DO 135 M = 1,NJ
                                   J = PSAVE (M)
                                   IF (J.NE.I) THEN
                                       IJ1 = PPAIR (M)
                                       IF (PUSED (J).EQ.1) THEN
                                           DO L = 1,NSUB
                                              W (L,J) = W (L,J)
     +                                                + C1 * X (K+L,IJ1)
                                           END DO
                                       ELSE
                                           DO L = 1,NSUB
                                              W (L,J) = C1 * X (K+L,IJ1)
                                           END DO
                                           PUSED (J) = 1
                                       END IF
                                   END IF
  135                           CONTINUE
                            END IF

                            NJ = 0
                        END IF
  130                CONTINUE
                 END IF
C
C
C             ...inner contraction over all R >= S.
C
C
                 DO 140 R = S,NCR
                    RS = RS + 1
                    PMIN = CCBEGR (R)
                    PMAX = CCENDR (R)

                    IF (PMIN.EQ.PMAX .AND. CCR (PMIN,R).EQ.ONE
     +                               .AND. PUSED (PMIN).EQ.1  ) THEN
C
C
C             ...we reach this point, if only one R contraction
C                coefficient equal to 1.0 is present.
C
C
                        DO L = 1,NSUB
                           Y (K+L,RS) = Y (K+L,RS) + W (L,PMIN)
                        END DO
                    ELSE
C
C
C             ...the general R contraction case with many coefficients.
C                Group all relevant I's together and perform the
C                present R contraction over all I's simultaneously.
C
C
                        NI = 0
                        DO I = PMIN,PMAX
                           IF (PUSED (I).EQ.1) THEN
                               NI = NI + 1
                               PSAVE (NI) = I
                           END IF
                        END DO

                        IF (NI.EQ.1) THEN
                            I1 = PSAVE (1)
                            C1 = CCR (I1,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
                            END DO
                        ELSE IF (NI.EQ.2) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
                            END DO
                        ELSE IF (NI.EQ.3) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
                            END DO
                        ELSE IF (NI.EQ.4) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            I4 = PSAVE (4)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            C4 = CCR (I4,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
     +                                                 + C4 * W (L,I4)
                            END DO
                        ELSE IF (NI.EQ.5) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            I4 = PSAVE (4)
                            I5 = PSAVE (5)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            C4 = CCR (I4,R)
                            C5 = CCR (I5,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
     +                                                 + C4 * W (L,I4)
     +                                                 + C5 * W (L,I5)
                            END DO
                        ELSE IF (NI.EQ.6) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            I4 = PSAVE (4)
                            I5 = PSAVE (5)
                            I6 = PSAVE (6)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            C4 = CCR (I4,R)
                            C5 = CCR (I5,R)
                            C6 = CCR (I6,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
     +                                                 + C4 * W (L,I4)
     +                                                 + C5 * W (L,I5)
     +                                                 + C6 * W (L,I6)
                            END DO
                        ELSE IF (NI.EQ.7) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            I4 = PSAVE (4)
                            I5 = PSAVE (5)
                            I6 = PSAVE (6)
                            I7 = PSAVE (7)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            C4 = CCR (I4,R)
                            C5 = CCR (I5,R)
                            C6 = CCR (I6,R)
                            C7 = CCR (I7,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
     +                                                 + C4 * W (L,I4)
     +                                                 + C5 * W (L,I5)
     +                                                 + C6 * W (L,I6)
     +                                                 + C7 * W (L,I7)
                            END DO
                        ELSE IF (NI.EQ.8) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            I4 = PSAVE (4)
                            I5 = PSAVE (5)
                            I6 = PSAVE (6)
                            I7 = PSAVE (7)
                            I8 = PSAVE (8)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            C4 = CCR (I4,R)
                            C5 = CCR (I5,R)
                            C6 = CCR (I6,R)
                            C7 = CCR (I7,R)
                            C8 = CCR (I8,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
     +                                                 + C4 * W (L,I4)
     +                                                 + C5 * W (L,I5)
     +                                                 + C6 * W (L,I6)
     +                                                 + C7 * W (L,I7)
     +                                                 + C8 * W (L,I8)
                            END DO
                        ELSE IF (NI.GT.8) THEN
                            I1 = PSAVE (1)
                            I2 = PSAVE (2)
                            I3 = PSAVE (3)
                            I4 = PSAVE (4)
                            I5 = PSAVE (5)
                            I6 = PSAVE (6)
                            I7 = PSAVE (7)
                            I8 = PSAVE (8)
                            C1 = CCR (I1,R)
                            C2 = CCR (I2,R)
                            C3 = CCR (I3,R)
                            C4 = CCR (I4,R)
                            C5 = CCR (I5,R)
                            C6 = CCR (I6,R)
                            C7 = CCR (I7,R)
                            C8 = CCR (I8,R)
                            DO L = 1,NSUB
                               Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                 + C2 * W (L,I2)
     +                                                 + C3 * W (L,I3)
     +                                                 + C4 * W (L,I4)
     +                                                 + C5 * W (L,I5)
     +                                                 + C6 * W (L,I6)
     +                                                 + C7 * W (L,I7)
     +                                                 + C8 * W (L,I8)
                            END DO

                            NIBASE = 8
                            NILEFT = NI - 8
                            NISTEP = NILEFT / 8
                            NIREST = MOD (NILEFT,8)

                            DO M = 1,NISTEP
                               I1 = PSAVE (NIBASE+1)
                               I2 = PSAVE (NIBASE+2)
                               I3 = PSAVE (NIBASE+3)
                               I4 = PSAVE (NIBASE+4)
                               I5 = PSAVE (NIBASE+5)
                               I6 = PSAVE (NIBASE+6)
                               I7 = PSAVE (NIBASE+7)
                               I8 = PSAVE (NIBASE+8)
                               C1 = CCR (I1,R)
                               C2 = CCR (I2,R)
                               C3 = CCR (I3,R)
                               C4 = CCR (I4,R)
                               C5 = CCR (I5,R)
                               C6 = CCR (I6,R)
                               C7 = CCR (I7,R)
                               C8 = CCR (I8,R)
                               DO L = 1,NSUB
                                  Y (K+L,RS) = Y (K+L,RS)
     +                                         + C1 * W (L,I1)
     +                                         + C2 * W (L,I2)
     +                                         + C3 * W (L,I3)
     +                                         + C4 * W (L,I4)
     +                                         + C5 * W (L,I5)
     +                                         + C6 * W (L,I6)
     +                                         + C7 * W (L,I7)
     +                                         + C8 * W (L,I8)
                               END DO
                               NIBASE = NIBASE + 8
                            END DO

                            DO M = 1,NIREST
                               I1 = PSAVE (NIBASE+M)
                               C1 = CCR (I1,R)
                               DO L = 1,NSUB
                                  Y (K+L,RS) = Y (K+L,RS)
     +                                         + C1 * W (L,I1)
                               END DO
                            END DO

                        END IF
                    END IF
  140            CONTINUE
C
C
C             ...next outer S contraction for present block.
C
C
  100         CONTINUE
C
C
C             ...next block (if any).
C
C
 1000      CONTINUE

         ELSE
C
C
C             ...the full RS case. Check the order of the two quarter
C                transformations and proceed accordingly.
C
C                The case: # of I primitives R > # of J primitives S
C                The primitives I and J are ordered such that I varies
C                fastest. Outer contraction is over R, inner over S.
C
C
           IF (SWAPRS) THEN

            DO 2000 K = 0,N-1,NBLOCK
               NSUB = MIN0 (NBLOCK,N-K)

               RS = 0
               DO 200 R = 1,NCR
                  PMIN = CCBEGR (R)
                  PMAX = CCENDR (R)

                  DO 210 J = 1,NPS
                     PUSED (J) = 0
  210             CONTINUE

                  IF (PMIN.EQ.PMAX .AND. CCR (PMIN,R).EQ.ONE) THEN
C
C
C             ...we reach this point, if only one R contraction
C                coefficient equal to 1.0 is present.
C
C
                      DO 220 IJ = 1,MIJ
                         I = PRIMR (IJ)
                         IF (I.EQ.PMIN) THEN
                             J = PRIMS (IJ)
                             DO L = 1,NSUB
                                W (L,J) = X (K+L,IJ)
                             END DO
                             PUSED (J) = 1
                         END IF
  220                 CONTINUE
                  ELSE
C
C
C             ...the general R contraction case with many coefficients.
C                For each J determine all allowed I's and perform the
C                present R contraction for each J over all I's
C                simultaneously.
C
C
                      NI = 0
                      DO 230 IJ = 1,MIJ
                         I = PRIMR (IJ)
                         J = PRIMS (IJ)
                         IRANGE = I.GE.PMIN .AND. I.LE.PMAX

                         IF (IRANGE) THEN
                             NI = NI + 1
                             PSAVE (NI) = I
                             PPAIR (NI) = IJ
                         END IF

                         IF (IJ.EQ.MIJ) THEN
                             JNEXT = 0
                         ELSE
                             JNEXT = PRIMS (IJ+1)
                         END IF

                         CNTRCT = (JNEXT.NE.J) .AND. (NI.GT.0)

                         IF (CNTRCT) THEN
                             IF (NI.EQ.1) THEN
                                 IJ1 = PPAIR (1)
                                 C1 = CCR (PSAVE (1),R)
                                 DO L = 1,NSUB
                                    W (L,J) = C1 * X (K+L,IJ1)
                                 END DO
                             ELSE IF (NI.EQ.2) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
                                 END DO
                             ELSE IF (NI.EQ.3) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
                                 END DO
                             ELSE IF (NI.EQ.4) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 C4 = CCR (PSAVE (4),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
                                 END DO
                             ELSE IF (NI.EQ.5) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 C4 = CCR (PSAVE (4),R)
                                 C5 = CCR (PSAVE (5),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
                                 END DO
                             ELSE IF (NI.EQ.6) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 C4 = CCR (PSAVE (4),R)
                                 C5 = CCR (PSAVE (5),R)
                                 C6 = CCR (PSAVE (6),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
                                 END DO
                             ELSE IF (NI.EQ.7) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 IJ7 = PPAIR (7)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 C4 = CCR (PSAVE (4),R)
                                 C5 = CCR (PSAVE (5),R)
                                 C6 = CCR (PSAVE (6),R)
                                 C7 = CCR (PSAVE (7),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
     +                                        + C7 * X (K+L,IJ7)
                                 END DO
                             ELSE IF (NI.EQ.8) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 IJ7 = PPAIR (7)
                                 IJ8 = PPAIR (8)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 C4 = CCR (PSAVE (4),R)
                                 C5 = CCR (PSAVE (5),R)
                                 C6 = CCR (PSAVE (6),R)
                                 C7 = CCR (PSAVE (7),R)
                                 C8 = CCR (PSAVE (8),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
     +                                        + C7 * X (K+L,IJ7)
     +                                        + C8 * X (K+L,IJ8)
                                 END DO
                             ELSE
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 IJ7 = PPAIR (7)
                                 IJ8 = PPAIR (8)
                                 C1 = CCR (PSAVE (1),R)
                                 C2 = CCR (PSAVE (2),R)
                                 C3 = CCR (PSAVE (3),R)
                                 C4 = CCR (PSAVE (4),R)
                                 C5 = CCR (PSAVE (5),R)
                                 C6 = CCR (PSAVE (6),R)
                                 C7 = CCR (PSAVE (7),R)
                                 C8 = CCR (PSAVE (8),R)
                                 DO L = 1,NSUB
                                    W (L,J) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
     +                                        + C7 * X (K+L,IJ7)
     +                                        + C8 * X (K+L,IJ8)
                                 END DO

                                 NIBASE = 8
                                 NILEFT = NI - 8
                                 NISTEP = NILEFT / 8
                                 NIREST = MOD (NILEFT,8)

                                 DO M = 1,NISTEP
                                    IJ1 = PPAIR (NIBASE+1)
                                    IJ2 = PPAIR (NIBASE+2)
                                    IJ3 = PPAIR (NIBASE+3)
                                    IJ4 = PPAIR (NIBASE+4)
                                    IJ5 = PPAIR (NIBASE+5)
                                    IJ6 = PPAIR (NIBASE+6)
                                    IJ7 = PPAIR (NIBASE+7)
                                    IJ8 = PPAIR (NIBASE+8)
                                    C1 = CCR (PSAVE (NIBASE+1),R)
                                    C2 = CCR (PSAVE (NIBASE+2),R)
                                    C3 = CCR (PSAVE (NIBASE+3),R)
                                    C4 = CCR (PSAVE (NIBASE+4),R)
                                    C5 = CCR (PSAVE (NIBASE+5),R)
                                    C6 = CCR (PSAVE (NIBASE+6),R)
                                    C7 = CCR (PSAVE (NIBASE+7),R)
                                    C8 = CCR (PSAVE (NIBASE+8),R)
                                    DO L = 1,NSUB
                                       W (L,J) = W (L,J)
     +                                              + C1 * X (K+L,IJ1)
     +                                              + C2 * X (K+L,IJ2)
     +                                              + C3 * X (K+L,IJ3)
     +                                              + C4 * X (K+L,IJ4)
     +                                              + C5 * X (K+L,IJ5)
     +                                              + C6 * X (K+L,IJ6)
     +                                              + C7 * X (K+L,IJ7)
     +                                              + C8 * X (K+L,IJ8)
                                    END DO
                                    NIBASE = NIBASE + 8
                                 END DO

                                 DO M = 1,NIREST
                                    IJ1 = PPAIR (NIBASE+M)
                                    C1 = CCR (PSAVE (NIBASE+M),R)
                                    DO L = 1,NSUB
                                       W (L,J) = W (L,J)
     +                                              + C1 * X (K+L,IJ1)
                                    END DO
                                 END DO

                             END IF
                             PUSED (J) = 1
                             NI = 0
                         END IF

  230                 CONTINUE
                  END IF
C
C
C             ...inner contraction over all S.
C
C
                  DO 240 S = 1,NCS
                     RS = RS + 1
                     PMIN = CCBEGS (S)
                     PMAX = CCENDS (S)

                     IF (PMIN.EQ.PMAX .AND. CCS (PMIN,S).EQ.ONE
     +                                .AND. PUSED (PMIN).EQ.1  ) THEN
C
C
C             ...we reach this point, if only one S contraction
C                coefficient equal to 1.0 is present.
C
C
                         DO L = 1,NSUB
                            Y (K+L,RS) = Y (K+L,RS) + W (L,PMIN)
                         END DO
                     ELSE
C
C
C             ...the general S contraction case with many coefficients.
C                Group all relevant J's together and perform the
C                present S contraction over all J's simultaneously.
C
C
                         NJ = 0
                         DO J = PMIN,PMAX
                            IF (PUSED (J).EQ.1) THEN
                                NJ = NJ + 1
                                PSAVE (NJ) = J
                            END IF
                         END DO

                         IF (NJ.EQ.1) THEN
                             J1 = PSAVE (1)
                             C1 = CCS (J1,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
                             END DO
                         ELSE IF (NJ.EQ.2) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
                             END DO
                         ELSE IF (NJ.EQ.3) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
                             END DO
                         ELSE IF (NJ.EQ.4) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             J4 = PSAVE (4)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             C4 = CCS (J4,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
     +                                                  + C4 * W (L,J4)
                             END DO
                         ELSE IF (NJ.EQ.5) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             J4 = PSAVE (4)
                             J5 = PSAVE (5)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             C4 = CCS (J4,S)
                             C5 = CCS (J5,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
     +                                                  + C4 * W (L,J4)
     +                                                  + C5 * W (L,J5)
                             END DO
                         ELSE IF (NJ.EQ.6) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             J4 = PSAVE (4)
                             J5 = PSAVE (5)
                             J6 = PSAVE (6)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             C4 = CCS (J4,S)
                             C5 = CCS (J5,S)
                             C6 = CCS (J6,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
     +                                                  + C4 * W (L,J4)
     +                                                  + C5 * W (L,J5)
     +                                                  + C6 * W (L,J6)
                             END DO
                         ELSE IF (NJ.EQ.7) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             J4 = PSAVE (4)
                             J5 = PSAVE (5)
                             J6 = PSAVE (6)
                             J7 = PSAVE (7)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             C4 = CCS (J4,S)
                             C5 = CCS (J5,S)
                             C6 = CCS (J6,S)
                             C7 = CCS (J7,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
     +                                                  + C4 * W (L,J4)
     +                                                  + C5 * W (L,J5)
     +                                                  + C6 * W (L,J6)
     +                                                  + C7 * W (L,J7)
                             END DO
                         ELSE IF (NJ.EQ.8) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             J4 = PSAVE (4)
                             J5 = PSAVE (5)
                             J6 = PSAVE (6)
                             J7 = PSAVE (7)
                             J8 = PSAVE (8)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             C4 = CCS (J4,S)
                             C5 = CCS (J5,S)
                             C6 = CCS (J6,S)
                             C7 = CCS (J7,S)
                             C8 = CCS (J8,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
     +                                                  + C4 * W (L,J4)
     +                                                  + C5 * W (L,J5)
     +                                                  + C6 * W (L,J6)
     +                                                  + C7 * W (L,J7)
     +                                                  + C8 * W (L,J8)
                             END DO
                         ELSE IF (NJ.GT.8) THEN
                             J1 = PSAVE (1)
                             J2 = PSAVE (2)
                             J3 = PSAVE (3)
                             J4 = PSAVE (4)
                             J5 = PSAVE (5)
                             J6 = PSAVE (6)
                             J7 = PSAVE (7)
                             J8 = PSAVE (8)
                             C1 = CCS (J1,S)
                             C2 = CCS (J2,S)
                             C3 = CCS (J3,S)
                             C4 = CCS (J4,S)
                             C5 = CCS (J5,S)
                             C6 = CCS (J6,S)
                             C7 = CCS (J7,S)
                             C8 = CCS (J8,S)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,J1)
     +                                                  + C2 * W (L,J2)
     +                                                  + C3 * W (L,J3)
     +                                                  + C4 * W (L,J4)
     +                                                  + C5 * W (L,J5)
     +                                                  + C6 * W (L,J6)
     +                                                  + C7 * W (L,J7)
     +                                                  + C8 * W (L,J8)
                             END DO

                             NJBASE = 8
                             NJLEFT = NJ - 8
                             NJSTEP = NJLEFT / 8
                             NJREST = MOD (NJLEFT,8)

                             DO M = 1,NJSTEP
                                J1 = PSAVE (NJBASE+1)
                                J2 = PSAVE (NJBASE+2)
                                J3 = PSAVE (NJBASE+3)
                                J4 = PSAVE (NJBASE+4)
                                J5 = PSAVE (NJBASE+5)
                                J6 = PSAVE (NJBASE+6)
                                J7 = PSAVE (NJBASE+7)
                                J8 = PSAVE (NJBASE+8)
                                C1 = CCS (J1,S)
                                C2 = CCS (J2,S)
                                C3 = CCS (J3,S)
                                C4 = CCS (J4,S)
                                C5 = CCS (J5,S)
                                C6 = CCS (J6,S)
                                C7 = CCS (J7,S)
                                C8 = CCS (J8,S)
                                DO L = 1,NSUB
                                   Y (K+L,RS) = Y (K+L,RS)
     +                                          + C1 * W (L,J1)
     +                                          + C2 * W (L,J2)
     +                                          + C3 * W (L,J3)
     +                                          + C4 * W (L,J4)
     +                                          + C5 * W (L,J5)
     +                                          + C6 * W (L,J6)
     +                                          + C7 * W (L,J7)
     +                                          + C8 * W (L,J8)
                                END DO
                                NJBASE = NJBASE + 8
                             END DO

                             DO M = 1,NJREST
                                J1 = PSAVE (NJBASE+M)
                                C1 = CCS (J1,S)
                                DO L = 1,NSUB
                                   Y (K+L,RS) = Y (K+L,RS)
     +                                          + C1 * W (L,J1)
                                END DO
                             END DO

                         END IF
                     END IF
  240             CONTINUE
C
C
C             ...next outer R contraction for present block.
C
C
  200          CONTINUE
C
C
C             ...next block (if any).
C
C
 2000       CONTINUE

           ELSE
C
C
C             ...the case: # of I primitives R =< # of J primitives S.
C                The primitives I and J are ordered such that J varies
C                fastest. Outer contraction is over S, inner over R.
C
C
            DO 3000 K = 0,N-1,NBLOCK
               NSUB = MIN0 (NBLOCK,N-K)

               RS = 0
               DO 300 S = 1,NCS
                  PMIN = CCBEGS (S)
                  PMAX = CCENDS (S)

                  DO 310 I = 1,NPR
                     PUSED (I) = 0
  310             CONTINUE

                  IF (PMIN.EQ.PMAX .AND. CCS (PMIN,S).EQ.ONE) THEN
C
C
C             ...we reach this point, if only one S contraction
C                coefficient equal to 1.0 is present.
C
C
                      DO 320 IJ = 1,MIJ
                         J = PRIMS (IJ)
                         IF (J.EQ.PMIN) THEN
                             I = PRIMR (IJ)
                             DO L = 1,NSUB
                                W (L,I) = X (K+L,IJ)
                             END DO
                             PUSED (I) = 1
                         END IF
  320                 CONTINUE
                  ELSE
C
C
C             ...the general S contraction case with many coefficients.
C                For each I determine all allowed J's and perform the
C                present S contraction for each I over all J's
C                simultaneously.
C
C
                      NJ = 0
                      DO 330 IJ = 1,MIJ
                         I = PRIMR (IJ)
                         J = PRIMS (IJ)
                         JRANGE = J.GE.PMIN .AND. J.LE.PMAX

                         IF (JRANGE) THEN
                             NJ = NJ + 1
                             PSAVE (NJ) = J
                             PPAIR (NJ) = IJ
                         END IF

                         IF (IJ.EQ.MIJ) THEN
                             INEXT = 0
                         ELSE
                             INEXT = PRIMR (IJ+1)
                         END IF

                         CNTRCT = (INEXT.NE.I) .AND. (NJ.GT.0)

                         IF (CNTRCT) THEN
                             IF (NJ.EQ.1) THEN
                                 IJ1 = PPAIR (1)
                                 C1 = CCS (PSAVE (1),S)
                                 DO L = 1,NSUB
                                    W (L,I) = C1 * X (K+L,IJ1)
                                 END DO
                             ELSE IF (NJ.EQ.2) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
                                 END DO
                             ELSE IF (NJ.EQ.3) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
                                 END DO
                             ELSE IF (NJ.EQ.4) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 C4 = CCS (PSAVE (4),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
                                 END DO
                             ELSE IF (NJ.EQ.5) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 C4 = CCS (PSAVE (4),S)
                                 C5 = CCS (PSAVE (5),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
                                 END DO
                             ELSE IF (NJ.EQ.6) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 C4 = CCS (PSAVE (4),S)
                                 C5 = CCS (PSAVE (5),S)
                                 C6 = CCS (PSAVE (6),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
                                 END DO
                             ELSE IF (NJ.EQ.7) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 IJ7 = PPAIR (7)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 C4 = CCS (PSAVE (4),S)
                                 C5 = CCS (PSAVE (5),S)
                                 C6 = CCS (PSAVE (6),S)
                                 C7 = CCS (PSAVE (7),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
     +                                        + C7 * X (K+L,IJ7)
                                 END DO
                             ELSE IF (NJ.EQ.8) THEN
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 IJ7 = PPAIR (7)
                                 IJ8 = PPAIR (8)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 C4 = CCS (PSAVE (4),S)
                                 C5 = CCS (PSAVE (5),S)
                                 C6 = CCS (PSAVE (6),S)
                                 C7 = CCS (PSAVE (7),S)
                                 C8 = CCS (PSAVE (8),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
     +                                        + C7 * X (K+L,IJ7)
     +                                        + C8 * X (K+L,IJ8)
                                 END DO
                             ELSE
                                 IJ1 = PPAIR (1)
                                 IJ2 = PPAIR (2)
                                 IJ3 = PPAIR (3)
                                 IJ4 = PPAIR (4)
                                 IJ5 = PPAIR (5)
                                 IJ6 = PPAIR (6)
                                 IJ7 = PPAIR (7)
                                 IJ8 = PPAIR (8)
                                 C1 = CCS (PSAVE (1),S)
                                 C2 = CCS (PSAVE (2),S)
                                 C3 = CCS (PSAVE (3),S)
                                 C4 = CCS (PSAVE (4),S)
                                 C5 = CCS (PSAVE (5),S)
                                 C6 = CCS (PSAVE (6),S)
                                 C7 = CCS (PSAVE (7),S)
                                 C8 = CCS (PSAVE (8),S)
                                 DO L = 1,NSUB
                                    W (L,I) =   C1 * X (K+L,IJ1)
     +                                        + C2 * X (K+L,IJ2)
     +                                        + C3 * X (K+L,IJ3)
     +                                        + C4 * X (K+L,IJ4)
     +                                        + C5 * X (K+L,IJ5)
     +                                        + C6 * X (K+L,IJ6)
     +                                        + C7 * X (K+L,IJ7)
     +                                        + C8 * X (K+L,IJ8)
                                 END DO

                                 NJBASE = 8
                                 NJLEFT = NJ - 8
                                 NJSTEP = NJLEFT / 8
                                 NJREST = MOD (NJLEFT,8)

                                 DO M = 1,NJSTEP
                                    IJ1 = PPAIR (NJBASE+1)
                                    IJ2 = PPAIR (NJBASE+2)
                                    IJ3 = PPAIR (NJBASE+3)
                                    IJ4 = PPAIR (NJBASE+4)
                                    IJ5 = PPAIR (NJBASE+5)
                                    IJ6 = PPAIR (NJBASE+6)
                                    IJ7 = PPAIR (NJBASE+7)
                                    IJ8 = PPAIR (NJBASE+8)
                                    C1 = CCS (PSAVE (NJBASE+1),S)
                                    C2 = CCS (PSAVE (NJBASE+2),S)
                                    C3 = CCS (PSAVE (NJBASE+3),S)
                                    C4 = CCS (PSAVE (NJBASE+4),S)
                                    C5 = CCS (PSAVE (NJBASE+5),S)
                                    C6 = CCS (PSAVE (NJBASE+6),S)
                                    C7 = CCS (PSAVE (NJBASE+7),S)
                                    C8 = CCS (PSAVE (NJBASE+8),S)
                                    DO L = 1,NSUB
                                       W (L,I) = W (L,I)
     +                                              + C1 * X (K+L,IJ1)
     +                                              + C2 * X (K+L,IJ2)
     +                                              + C3 * X (K+L,IJ3)
     +                                              + C4 * X (K+L,IJ4)
     +                                              + C5 * X (K+L,IJ5)
     +                                              + C6 * X (K+L,IJ6)
     +                                              + C7 * X (K+L,IJ7)
     +                                              + C8 * X (K+L,IJ8)
                                    END DO
                                    NJBASE = NJBASE + 8
                                 END DO

                                 DO M = 1,NJREST
                                    IJ1 = PPAIR (NJBASE+M)
                                    C1 = CCS (PSAVE (NJBASE+M),S)
                                    DO L = 1,NSUB
                                       W (L,I) = W (L,I)
     +                                              + C1 * X (K+L,IJ1)
                                    END DO
                                 END DO

                             END IF
                             PUSED (I) = 1
                             NJ = 0
                         END IF

  330                 CONTINUE
                  END IF
C
C
C             ...inner contraction over all R.
C
C
                  DO 340 R = 1,NCR
                     RS = RS + 1
                     PMIN = CCBEGR (R)
                     PMAX = CCENDR (R)

                     IF (PMIN.EQ.PMAX .AND. CCR (PMIN,R).EQ.ONE
     +                                .AND. PUSED (PMIN).EQ.1  ) THEN
C
C
C             ...we reach this point, if only one R contraction
C                coefficient equal to 1.0 is present.
C
C
                         DO L = 1,NSUB
                            Y (K+L,RS) = Y (K+L,RS) + W (L,PMIN)
                         END DO
                     ELSE
C
C
C             ...the general R contraction case with many coefficients.
C                Group all relevant I's together and perform the
C                present R contraction over all I's simultaneously.
C
C
                         NI = 0
                         DO I = PMIN,PMAX
                            IF (PUSED (I).EQ.1) THEN
                                NI = NI + 1
                                PSAVE (NI) = I
                            END IF
                         END DO

                         IF (NI.EQ.1) THEN
                             I1 = PSAVE (1)
                             C1 = CCR (I1,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
                             END DO
                         ELSE IF (NI.EQ.2) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
                             END DO
                         ELSE IF (NI.EQ.3) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
                             END DO
                         ELSE IF (NI.EQ.4) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             I4 = PSAVE (4)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             C4 = CCR (I4,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
     +                                                  + C4 * W (L,I4)
                             END DO
                         ELSE IF (NI.EQ.5) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             I4 = PSAVE (4)
                             I5 = PSAVE (5)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             C4 = CCR (I4,R)
                             C5 = CCR (I5,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
     +                                                  + C4 * W (L,I4)
     +                                                  + C5 * W (L,I5)
                             END DO
                         ELSE IF (NI.EQ.6) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             I4 = PSAVE (4)
                             I5 = PSAVE (5)
                             I6 = PSAVE (6)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             C4 = CCR (I4,R)
                             C5 = CCR (I5,R)
                             C6 = CCR (I6,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
     +                                                  + C4 * W (L,I4)
     +                                                  + C5 * W (L,I5)
     +                                                  + C6 * W (L,I6)
                             END DO
                         ELSE IF (NI.EQ.7) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             I4 = PSAVE (4)
                             I5 = PSAVE (5)
                             I6 = PSAVE (6)
                             I7 = PSAVE (7)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             C4 = CCR (I4,R)
                             C5 = CCR (I5,R)
                             C6 = CCR (I6,R)
                             C7 = CCR (I7,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
     +                                                  + C4 * W (L,I4)
     +                                                  + C5 * W (L,I5)
     +                                                  + C6 * W (L,I6)
     +                                                  + C7 * W (L,I7)
                             END DO
                         ELSE IF (NI.EQ.8) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             I4 = PSAVE (4)
                             I5 = PSAVE (5)
                             I6 = PSAVE (6)
                             I7 = PSAVE (7)
                             I8 = PSAVE (8)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             C4 = CCR (I4,R)
                             C5 = CCR (I5,R)
                             C6 = CCR (I6,R)
                             C7 = CCR (I7,R)
                             C8 = CCR (I8,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
     +                                                  + C4 * W (L,I4)
     +                                                  + C5 * W (L,I5)
     +                                                  + C6 * W (L,I6)
     +                                                  + C7 * W (L,I7)
     +                                                  + C8 * W (L,I8)
                             END DO
                         ELSE IF (NI.GT.8) THEN
                             I1 = PSAVE (1)
                             I2 = PSAVE (2)
                             I3 = PSAVE (3)
                             I4 = PSAVE (4)
                             I5 = PSAVE (5)
                             I6 = PSAVE (6)
                             I7 = PSAVE (7)
                             I8 = PSAVE (8)
                             C1 = CCR (I1,R)
                             C2 = CCR (I2,R)
                             C3 = CCR (I3,R)
                             C4 = CCR (I4,R)
                             C5 = CCR (I5,R)
                             C6 = CCR (I6,R)
                             C7 = CCR (I7,R)
                             C8 = CCR (I8,R)
                             DO L = 1,NSUB
                                Y (K+L,RS) = Y (K+L,RS) + C1 * W (L,I1)
     +                                                  + C2 * W (L,I2)
     +                                                  + C3 * W (L,I3)
     +                                                  + C4 * W (L,I4)
     +                                                  + C5 * W (L,I5)
     +                                                  + C6 * W (L,I6)
     +                                                  + C7 * W (L,I7)
     +                                                  + C8 * W (L,I8)
                             END DO

                             NIBASE = 8
                             NILEFT = NI - 8
                             NISTEP = NILEFT / 8
                             NIREST = MOD (NILEFT,8)

                             DO M = 1,NISTEP
                                I1 = PSAVE (NIBASE+1)
                                I2 = PSAVE (NIBASE+2)
                                I3 = PSAVE (NIBASE+3)
                                I4 = PSAVE (NIBASE+4)
                                I5 = PSAVE (NIBASE+5)
                                I6 = PSAVE (NIBASE+6)
                                I7 = PSAVE (NIBASE+7)
                                I8 = PSAVE (NIBASE+8)
                                C1 = CCR (I1,R)
                                C2 = CCR (I2,R)
                                C3 = CCR (I3,R)
                                C4 = CCR (I4,R)
                                C5 = CCR (I5,R)
                                C6 = CCR (I6,R)
                                C7 = CCR (I7,R)
                                C8 = CCR (I8,R)
                                DO L = 1,NSUB
                                   Y (K+L,RS) = Y (K+L,RS)
     +                                          + C1 * W (L,I1)
     +                                          + C2 * W (L,I2)
     +                                          + C3 * W (L,I3)
     +                                          + C4 * W (L,I4)
     +                                          + C5 * W (L,I5)
     +                                          + C6 * W (L,I6)
     +                                          + C7 * W (L,I7)
     +                                          + C8 * W (L,I8)
                                END DO
                                NIBASE = NIBASE + 8
                             END DO

                             DO M = 1,NIREST
                                I1 = PSAVE (NIBASE+M)
                                C1 = CCR (I1,R)
                                DO L = 1,NSUB
                                   Y (K+L,RS) = Y (K+L,RS)
     +                                          + C1 * W (L,I1)
                                END DO
                             END DO

                         END IF
                     END IF
  340             CONTINUE
C
C
C             ...next outer S contraction for present block.
C
C
  300          CONTINUE
C
C
C             ...next block (if any).
C
C
 3000       CONTINUE

           END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE A2_PREP4_MOL_READ(ICORE, MAXCOR, NATOMS, NBASP, 
     &                             NBAS, IUCATMS, IUATMS, COORD, 
     &                             IATMCHRG, Norbits_fullG, 
     &                             Norbits_compG,MAXSHELL, MAXANG,
     &                             ITFCT, NUNQSHL, NTOTSHL, NTANGM, 
     &                             LNP1, INext)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      DIMENSION COORD(3*NATOMS), Norbits_fullG(IUATMS), 
     &          Norbits_compG(IUCATMS), ICORE(MAXCOR), 
     &          IATMCHRG(NATOMS),ISHL(6)
C     




































































































































































































































































































































































































































































































































c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end










c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end

      COMMON /OFF_4INTGRT/IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                    IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                    ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                    IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                    IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                    IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                    ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                    IPCOEFFB, IPCOEFF,ISCR1,ISCR2,IREORD 




    
      DATA IONE /1/
      IMEMBC       = IONE 
      INUC         = IMEMBC       + NATOMS
      NUFCT        = INUC         + NATOMS
      NUMOM        = NUFCT        + IUCATMS 
      NFCT         = NUMOM        + IUCATMS 
      NANGMOM      = NFCT         + NATOMS
      IATMNAM      = NANGMOM      + NATOMS
      NAOUATM      = IATMNAM      + IUCATMS*IINTFP
      NAOATM       = NAOUATM      + IUCATMS 
      IANGMOMSHL   = NAOATM       + NATOMS
      ICONFUNSHL   = IANGMOMSHL   + MAXSHELL*IUCATMS
      IPRMFUNSHL   = ICONFUNSHL   + MAXSHELL*IUCATMS
      INPRIMSHL    = IPRMFUNSHL   + MAXSHELL*IUCATMS
      IANGMOMTSHL  = INPRIMSHL    + NATOMS 
      ICONFUNTSHL  = IANGMOMTSHL  + NATOMS*MAXSHELL
      IOFFSETPRM   = ICONFUNTSHL  + NATOMS*MAXSHELL
      IOFFSETCON   = IOFFSETPRM   + IUCATMS*MAXSHELL
      IOFFSETSHL   = IOFFSETCON   + IUCATMS*MAXSHELL
      IMAP_SHL2CNT = IOFFSETSHL   + NATOMS*MAXSHELL
      IPRMFUNTSHL  = IMAP_SHL2CNT + NATOMS*MAXSHELL 
      ISHLOFF_TMP  = IPRMFUNTSHL  + NATOMS*MAXSHELL  
      ISHLOFF      = ISHLOFF_TMP  + NATOMS
      IREORD       = ISHLOFF      + NATOMS
      IEND1        = IREORD       + NBAS
C    
      IF (IEND1 .GE. MAXCOR) CALL INSMEM('P4_DEN_PLOTS', IEND1,
     &                                    MAXCOR)
C
      CALL GETREC(20,'JOBARC', 'COMPMEMB', NATOMS, ICORE(IMEMBC))
      IPRINT = iflags(1)
C     
      print*, "Entering A2RD_BASIS_4INTGRT: Orbits and Cart. Coord."
      Write(6,"(4I4)"), (Norbits_compG(i), i=1, iucatms)
      Write(*,*)
      Write(6, "(3F10.5)"), (coord(i), i=1,3*natoms)
      Write(*,*)
      CALL A2RD_BASIS_4INTGRT(IUCATMS,NATOMS,ITFCT,LNP1,LNPO,NTANGM,
     &                        ICORE(IMEMBC),ICORE(INUC),ICORE(NFCT),
     &                        ICORE(NUFCT),ICORE(NANGMOM), 
     &                        ICORE(NUMOM),ICORE(IATMNAM),
     &                        COORD,Norbits_compG,
     &                        ICORE(NAOATM),ICORE(NAOUATM),
     &                        ICORE(IANGMOMSHL),ICORE(ICONFUNSHL),
     &                        ICORE(IPRMFUNSHL),IPRINT,ISHL, 
     &                        ICORE(INPRIMSHL),ICORE(IANGMOMTSHL),
     &                        ICORE(ICONFUNTSHL),ICORE(IOFFSETPRM),
     &                        ICORE(IOFFSETCON),ICORE(IOFFSETSHL),
     &                        ICORE(ISHLOFF_TMP),ICORE(ISHLOFF),
     &                        ICORE(IREORD),MAXSHELL,NUNQSHL,
     &                        NTOTSHL,IATMCHRG,NBAS)
C
      NMOMFCT  = IEND1 
      NMOMAO   = NMOMFCT  + NATOMS*NTANGM 
      IALPHA   = NMOMAO   + NATOMS*NTANGM 
      ICOEFFA  = IALPHA   + ITFCT*IINTFP
      ICOEFFB  = ICOEFFA  + NBASP*NBAS*IINTFP
      IDENSA   = ICOEFFB  + NBASP*NBAS*IINTFP
      IDENSB   = IDENSA   + NBAS*NBAS*IINTFP
      IPCOEFFA = IDENSB   + NBAS*NBAS*IINTFP
      IPCOEFFB = IPCOEFFA + NBASP*ITFCT*IINTFP
      IPCOEFF  = IPCOEFFB + NBASP*ITFCT*IINTFP
      ISCR1    = IPCOEFF  + ITFCT*IINTFP*NBAS
      ISCR2    = ISCR1    + LNP1*IINTFP
      ISTOP    = ISCR2    + LNPO*IINTFP
      INEXT    = ISCR1
C     
      IF(ISTOP.GE.MAXCOR) CALL INSMEM('P4_DEN_PLOTS',ISTOP,MAXCOR)
      Write(*,*)
      print*, "Entering A2RD_BASIS_PRIMINF", ITFCT, NTANGM, IALPHA,
     &          LNP1,NUNQSHL

C
      CALL A2RD_BASIS_PRIMINF(NATOMS,IUCATMS,ITFCT,NBAS,LNP1,LNPO,
     &                        NTANGM,Norbits_compG,ICORE(NFCT),
     &                        ICORE(NANGMOM),ICORE(NMOMFCT),
     &                        ICORE(NMOMAO),ICORE(IMEMBC),
     &                        ICORE(IANGMOMSHL),ICORE(IPRMFUNSHL),
     &                        ICORE(ICONFUNSHL),ICORE(ICONFUNTSHL), 
     &                        ICORE(INPRIMSHL),ICORE(IMAP_SHL2CNT),
     &                        ICORE(IPRMFUNTSHL),ICORE(IALPHA),
     &                        ICORE(IPCOEFF),ICORE(NAOATM),
     &                        ICORE(ISCR1),ICORE(ISCR2),
     &                        ICORE(ISHLOFF),MAXSHELL,ISHL,MAXANG)
      Write(6,*)
      Write(6,*) "The number of contracted function per shell"
      Write(6,"(4I4)") (ICORE(ICONFUNTSHL - 1 + I), I=1, NTOTSHL)
      Write(6,*) "The shell angular momentum"
      Write(6,"(4I5)") (ICORE(IANGMOMTSHL - 1 + I), I=1, NTOTSHL)
      Write(6,*) "The number of primitive functions per shell"
      Write(6,"(4I5)") (ICORE(IPRMFUNTSHL - 1 + I), I=1, NTOTSHL)
      Print*, "Offsets for various arrays initilized in Pre4_Den_plo."
      Write(*, '(31I9)'), IMEMBC,INUC,NUFCT,NUMOM,NFCT,NANGMOM,
     &                   IATMNAM,NAOUATM,NAOATM,IANGMOMSHL,
     &                   ICONFUNSHL,IPRMFUNSHL,INPRIMSHL,
     &                   IANGMOMTSHL,ICONFUNTSHL,IOFFSETPRM,
     &                   IOFFSETCON,IOFFSETSHL,IMAP_SHL2CNT,
     &                   IPRMFUNTSHL,NMOMAO,IALPHA,ICOEFFA,
     &                   ICOEFFB,IDENSA,IDENSB,IPCOEFFA,
     &                   IPCOEFFB, IPCOEFF,ISCR1,ISCR2
      Print*, "The exponents"
      Call output(icore(ialpha), 1, nfct, 1, 1, 1, nfct, 1, 1, 1)
      Call output(icore(ipcoeff), 1, nfct, 1, nbasp, nfct, nbasp, 1)
      Write(*,*)
      print*, "Exit Prep4_density_plots"
      Write(*,*)
C     
      RETURN
      END

c This takes an NROWxNCOL matrix and reorders the rows and/or columns.
c   op=0    reorder the columns
c   op=1    reorder the rows
c   op=2    reorder both the rows and columns
c If sorting both rows and columns, the matrix must be square.
c
c scr      is a vector of the appropriate length to hold 1 column or 1 row
c          (whichever is being sorted)
c order    is an integer array telling what order to put the columns or rows in
c scrorder is a similar length integer vector used for scratch space
c
c If we are sorting the columns of a Nx4 matrix [ C1 C2 C3 C4 ], and order
c is [ 2 3 4 1 ] and reverse is 0, then the matrix is reordered to be
c [ C4 C1 C2 C3 ].  In other words, column 1 is put in the 2nd columns
c position, column 2 is moved to column 3, etc.  If reverse is 1, the
c reverse reorder is done, so that if order is [ 2 3 4 1 ] and the matrix
c [ C4 C1 C2 C3 ] is passed in, it unreorders it and returns [ C1 C2 C3 C4].

      subroutine mat_reorder(op,reverse,nrow,ncol,matrix,scr,scrorder,
     &                       order)
      implicit none

      integer op,reverse,nrow,ncol,order(*),scrorder(*)
      double precision matrix(nrow,ncol),scr(*)

      integer ito,ifrom,irow,icol

      if (op.eq.2 .and. nrow.ne.ncol) then
         write(*,*) '@MAT_REORDER: fatal error, nrows ne ncols.'
         stop
      end if

c Sort columns
      if (op.eq.0 .or. op.eq.2) then
         do icol=1,ncol
            scrorder(icol)=order(icol)
         end do
         do 30 icol=1,ncol
         if (scrorder(icol).eq.0) goto 30

c           Normal (slow) reorder
            if (reverse.eq.0) then
               do while (scrorder(icol).ne.0)
                  ito=scrorder(icol)
                  call dcopy(nrow,matrix(1,icol),1,scr,1)
                  call dcopy(nrow,matrix(1,ito),1,matrix(1,icol),1)
                  call dcopy(nrow,scr,1,matrix(1,ito),1)
                  scrorder(icol)=scrorder(ito)
                  scrorder(ito)=0
               end do

c           Reverse (quick) reorder
            else
               call dcopy(nrow,matrix(1,icol),1,scr,1)
               ito=icol
   20          continue
               ifrom=scrorder(ito)
               if (ifrom.eq.icol) then
                  call dcopy(nrow,scr,1,matrix(1,ito),1)
                  scrorder(ito)=0
               else
                  call dcopy(nrow,matrix(1,ifrom),1,matrix(1,ito),1)
                  scrorder(ito)=0
                  ito=ifrom
                  goto 20
               end if
            end if

   30    continue
      end if

c Sort rows (very slow)
      if (op.eq.1 .or. op.eq.2) then
         do irow=1,nrow
            scrorder(irow)=order(irow)
         end do
         do 60 irow=1,nrow
         if (scrorder(irow).eq.0) goto 60

c           Normal (slow) reorder
            if (reverse.eq.0) then
               do while (scrorder(irow).ne.0)
                  ito=scrorder(irow)
                  do icol=1,ncol
                     scr(icol)=matrix(irow,icol)
                     matrix(irow,icol)=matrix(ito,icol)
                     matrix(ito,icol)=scr(icol)
                  end do
                  scrorder(irow)=scrorder(ito)
                  scrorder(ito)=0
               end do

c           Reverse (quick) reorder
            else
               do icol=1,ncol
                  scr(icol)=matrix(irow,icol)
               end do
               ito=irow
   50          continue
               ifrom=scrorder(ito)
               if (ifrom.eq.irow) then
                  do icol=1,ncol
                     matrix(ito,icol)=scr(icol)
                  end do
                  scrorder(ito)=0
               else
                  do icol=1,ncol
                     matrix(ito,icol)=matrix(ifrom,icol)
                  end do
                  scrorder(ito)=0
                  ito=ifrom
                  goto 50
               end if
            end if

   60    continue
      end if

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__W_EQ_U_FLOAT
     +
     +                    ( DDVECU,
     +                      DDVECW,
     +                      VEC,
     +                      U,
     +
     +                              W )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__W_EQ_U_FLOAT
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation copies a vector U of floating point
C                type to vector W.
C
C                The dimensions of both vectors need not be the same.
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         INTEGER    DDVECU
         INTEGER    DDVECW
         INTEGER    I
         INTEGER    VEC

         DOUBLE PRECISION   U (1:DDVECU)
         DOUBLE PRECISION   W (1:DDVECW)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF  ( VEC .GT. DDVECU )  THEN

               WRITE (1,*) ' Dimension of vector U too small: '
               WRITE (1,*) ' mat__w_eq_u_float '
               WRITE (1,*) ' DDVECU,VEC = ',
     +                       DDVECU,VEC

               WRITE (*,*) ' Dimension of vector U too small: '
               WRITE (*,*) ' mat__w_eq_u_float '
               WRITE (*,*) ' DDVECU,VEC = ',
     +                       DDVECU,VEC

               STOP

         END IF

         IF  ( VEC .GT. DDVECW )  THEN

               WRITE (1,*) ' Dimension of vector W too small: '
               WRITE (1,*) ' mat__w_eq_u_float '
               WRITE (1,*) ' DDVECW,VEC = ',
     +                       DDVECW,VEC

               WRITE (*,*) ' Dimension of vector W too small: '
               WRITE (*,*) ' mat__w_eq_u_float '
               WRITE (*,*) ' DDVECW,VEC = ',
     +                       DDVECW,VEC

               STOP

         END IF
C
C
C             ...loop over all vector elements.
C
C
         DO  10  I = 1,VEC  
             W (I) = U (I)
   10    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine compute_return_1SOIX(SOI_LP1,da1,da2,db1,db2,nsend)

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'dbugcom.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

c--------------------------------------------------------------------------
      integer nsend
      integer da1, da2, db1, db2
      integer adim, bdim
      double precision SOI_LP1(da1:da2, db1:db2)
c.........................................................................
      double precision dbuf(1), temp
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf(1), dbuf(1))
#endif

      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2

cPV we need this for NAI Lo, L-1, L+1
      double precision xn(max_centers), yn(max_centers),
     *                 zn(max_centers)
      integer iatom
      integer DERCX,DERCY,DERCZ
      integer DER1X, DER1Y,DER1Z,IXDERC,DER2X,DER2Y,DER2Z
      integer a,b,m,n,m1,m2,n1,n2
      integer Ea1,Ea2,Eb1,Eb2
c end PV
      integer nalpha,ncoeff,nints,nfirst
      integer ncsum
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)

      spherical = (ispherical .eq. 1)
  
      adim = da2-da1+1
      bdim = db2-db1+1

      nsend = adim*bdim
      if (nsend .lt. 0) then
         print *,'ERROR IN INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim = ',adim,bdim
         call Errex
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do b = db1, db2
      do a = da1, da2
         SOI_LP1(a,b) = 0.d0
      end do
      end do
C
c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

       call lookup_shell(end_nfps, nshells, da1, m1)
       call lookup_shell(end_nfps, nshells, da2, m2)
       call lookup_shell(end_nfps, nshells, db1, n1)
       call lookup_shell(end_nfps, nshells, db2, n2)

       do m=1,nshells
         iatom=Atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
       end do

      IXDERC = 0
      DERCX  = 0
      DERCY  = 0
      DERCZ  = 0

      do m = m1, m2

         x1 = dbuf(icoord+3*(m-1))
         y1 = dbuf(icoord+3*(m-1)+1)
         z1 = dbuf(icoord+3*(m-1)+2)

         do n = n1, n2

            x2 = dbuf(icoord+3*(n-1))
            y2 = dbuf(icoord+3*(n-1)+1)
            z2 = dbuf(icoord+3*(n-1)+2)

            ncsum = ncfps(m) + ncfps(n) 

            call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff),
     *                          ixpcoef,ncfps, npfps,
     *                          m, n,
     *                          alpha_pack, nalpha,
     *                          pcoeff_pack, ncoeff,
     *                          ibuf(iccbeg),ibuf(iccend), indx_cc,
     *                          ccbeg_pack, ccend_pack,max_dim_coeff)

CSSS      Write(6,*) "@-entry to OED_batch"
CSSS      Write(6,"((a,2(1x,i4)))") "m, n :", m, n

      DER1X = 0
      DER1Y = 1
      DER1Z = 0
      DER2X = 0
      DER2Y = 0
      DER2Z = 1
  
      call oed__soi_batchYZ(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m),ivangmom(n),x1,y1,z1,x2,y2,z2,
     *                 ncenters, xn, yn,zn, charge, ixderc, 
     *                 der1x,der1y,der1z,        
     *                 der2x,der2y,der2z,
     *                 dercx,dercy,dercz, alpha_pack, 
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr),
     +                 nints, 
     +                 nfirst,
     +                 dbuf(dpkgscr))

      if(nints .gt. 0) then
         Ea2 = end_nfps(m)
         if(m .eq. 1) then
            Ea1=1
         else
            Ea1 = end_nfps(m-1)+1
         end if
         Eb2 = end_nfps(n)
         if(n .eq. 1) then
           Eb1 = 1
         else
           Eb1 = end_nfps(n-1)+1
         end if

      call add_integrals2(SOI_LP1,da1,da2,db1,db2,
     *                   dbuf(dpkgscr+nfirst-1),Ea1,Ea2,Eb1,Eb2,1.0d0)
      endif 

      DER1X = 0
      DER1Y = 0
      DER1Z = 1
      DER2X = 0
      DER2Y = 1
      DER2Z = 0

      call oed__SOI_batchZY(intmax,zmax,
     *                 nalpha,ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m),ivangmom(n),x1,y1,z1,x2,y2,z2,
     *                 ncenters, xn, yn,zn, charge, ixderc, 
     *                 der1x,der1y,der1z,
     *                 der2x,der2y,der2z,
     *                 dercx,dercy,dercz, alpha_pack, 
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr),
     +                 nints, 
     +                 nfirst,
     +                 dbuf(dpkgscr)) 

      if(nints .gt. 0) then
         Ea2 = end_nfps(m)
         if(m .eq. 1) then
            Ea1=1
         else
            Ea1 = end_nfps(m-1)+1
         end if
         Eb2 = end_nfps(n)
         if(n .eq. 1) then
           Eb1 = 1
         else
           Eb1 = end_nfps(n-1)+1
         end if

      call add_integrals2(SOI_LP1,da1,da2,db1,db2,
     *                   dbuf(dpkgscr+nfirst-1),Ea1,Ea2,Eb1,Eb2,-1.0d0)
       endif ! nints

       end do !n
       end do !m

       if (dbg) write(6,*) " Finished spin-orbit L0 integral comp."

#ifdef _DEBUG_LVL0
      Write(6,*) "The <mu| L_x |nu > integral matrix"
      do b = 1, Nbasis
      Write(6,*)
         Write(6, "(5(1x,F15.10))") (SOI_LP1(a,b), a=1, nbasis)
      enddo
#endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine maps an internal file name (limited to 8 characters)
c like 'JOBARC' to a user-defined (external) filename like '../JOBARC.old'.

cjp - For MR-BWCC, various files are affixed with ".##", in which the hashes
c     represent the 2-digit process id.
cYAU - Our parallel file processing has not been fully designed. Once it is, I
c      imagine this 'feature' will be refined or replaced.

c INPUT
c char*(*) SZINT : the internal file name

c OUTPUT
c char*80 SZEXT   : the external file name for use with OPEN or INQUIRE
c int     ILENGTH : the character length of SZEXT

c#define _DEBUG_GFNAME
#define _FILES_UNIT 92 /* the file unit number for FILES (temporary) */

      subroutine gfname(szInt,szExt,iLength)
      implicit none

c ARGUMENTS
      character*(*) szInt, szExt
      integer iLength

c EXTERNAL FUNCTIONS
      integer fnblnk
      character*1 achar

c PARAMETERS
      character*1 czSpace
      parameter (czSpace=' ')

c INTERNAL VARIABLES
      character*80 szTmp
      integer iEnd, iEnd1, iTmp, iStat
      logical bExist, bDone

c COMMON BLOCKS
c#include "bwcc.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert szInt is not empty
      if (fnblnk(szInt).eq.0) then
         print *, '@GFNAME: Assertion failed.'
         print *, '   szInt = "',szInt,'"'
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o determine the shortest string length of szInt
      iTmp = min(8,len(szInt))
      iEnd = 0
      do while ((szInt(iEnd+1:iEnd+1).ne.czSpace).and.(iEnd.lt.iTmp))
         iEnd = iEnd + 1
      end do

c   o initialize szExt
      if (iEnd.gt.0) then
         szExt(1:iEnd) = szInt(1:iEnd)
         iLength = iEnd
      else
         iLength = 0
         return
      end if

c   o attempt to map the filename to a user-defined file
      inquire(file='FILES',exist=bExist,err=666,iostat=iStat)
      if (bExist) then
         open(unit=_FILES_UNIT,file='FILES',
     &        status='OLD',form='FORMATTED',
     &        err=666,iostat=iStat)
         rewind(_FILES_UNIT,err=666,iostat=iStat)
         bDone = .false.
         do while (.not.bDone)
            read(unit=_FILES_UNIT,fmt='(a)',
     &           end=200,err=666,iostat=iStat) szTmp
            if ((szTmp(1:iEnd).eq.szInt(1:iEnd)) .and.
     &          (szTmp(iEnd+1:iEnd+1).eq.czSpace)     ) then
               iEnd1 = iEnd+1
               do while ((szTmp(iEnd1+1:iEnd1+1).ne.czSpace).and.
     &                   (iEnd1.lt.80))
                  iEnd1 = iEnd1 + 1
               end do
               iLength = iEnd1-(iEnd+1)
               szExt(1:iLength) = szTmp(iEnd+2:iEnd1)
               bDone = .true.
            end if
         end do
 200     continue
         close(_FILES_UNIT,status='KEEP',err=666,iostat=iStat)
c     end if (bExist)
      end if

c   o add the process id to the end of various files
c      if (.not.masik.and.isbwcc) then
c         if (szInt(1:iEnd).eq.'MOINTS'.or.
c     &       szInt(1:iEnd).eq.'MOABCD'.or.
c     &       szInt(1:iEnd).eq.'FOCKCD'    ) then
c            szExt(iLength+1:iLength+1) = '.'
c            szExt(iLength+2:iLength+2) = achar(48+iref/10)
c            szExt(iLength+3:iLength+3) = achar(48+iref-10*(iref/10))
c            iLength = iLength+3
c         end if
c      end if

#ifdef _DEBUG_GFNAME
      print *, '@GFNAME: (debug) "',szInt,'" -> "',szExt(1:iLength),'"'
#endif

      return

c   o FILES I/O error
 666  print *, '@GFNAME: I/O error on FILES'
      print *, '         internal file name = "',szInt,'"'
      print '(/)'
c      call aces_io_error('GFNAME',_FILES_UNIT,iStat)
      call abort_job() 

c     end subroutine gfname
      end

      SUBROUTINE ORBSUM(SCR,ISCR,NORBS,IUHF)
C
C THIS ROUTINE WRITES OUT A SUMMARY OF THE MOLECULAR ORBITALS
C USED IN THE CORRELATED PART OF THE CALCULATION.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER POP,VRT,DIRPRD
      CHARACTER*5 SPCASE(2)
      CHARACTER*1 SP(2)
      DIMENSION SCR(NORBS),ISCR(NORBS)
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/SYM/ POP(8,2),VRT(8,2),NT(2),NFMI(2),NFEA(2)
      COMMON/SYMINF/NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
C
      DATA SPCASE/'alpha','beta '/
      DATA SP    /'A','B'/      
C
      CALL ACES_COM_SYM
C
      NCOL=NORBS/2 + MOD(NORBS,2)
C
      WRITE(6,600)
C
C LOOP OVER SPIN CASES
C
      DO 10 ISPIN=1,1+IUHF
       IOFF=1
       DO 11 IRREP=1,NIRREP
        N=POP(IRREP,ISPIN)
        DO 12 I=1,N
         ISCR(IOFF)=IRREP
         IOFF=IOFF+1
12      CONTINUE
11     CONTINUE
       DO 21 IRREP=1,NIRREP
        N=VRT(IRREP,ISPIN)
        DO 22 I=1,N
         ISCR(IOFF)=IRREP
         IOFF=IOFF+1
22      CONTINUE
21     CONTINUE
C       
       WRITE(6,1000)
       IF(IUHF.NE.0)WRITE(6,500)SPCASE(ISPIN)(1:linblnk(SPCASE(ISPIN)))
       WRITE(6,*)
       WRITE(6,2000)
       WRITE(6,1000)
       CALL GETREC(20,'JOBARC','SCFEVAL'//SP(ISPIN),NORBS*IINTFP,SCR)
C
       IFIRST=1
       DO 20 IFIRST=1,NCOL
        IOTHER=IFIRST+NCOL
        IF(IOTHER.LE.NORBS)THEN
         WRITE(6,3000)IFIRST,SCR(IFIRST),ISCR(IFIRST),
     &                IOTHER,SCR(IOTHER),ISCR(IOTHER)
        ELSE
         WRITE(6,3001)IFIRST,SCR(IFIRST),ISCR(IFIRST)
        ENDIF
20     CONTINUE
       WRITE(6,1000)
10    CONTINUE
C
3000  FORMAT(T3,I4,T10,F15.7,T32,I2,T40,I4,T47,F15.7,T69,I2)
3001  FORMAT(T3,I4,T10,F15.7,T32,I2)
1000  FORMAT(72('-'))
500   FORMAT(T26,'* Spin case ',A,' *')
600   FORMAT(T3,'@ORBSUM-I, Summary of active molecular orbitals: ')
2000  FORMAT(T3,'Index',T14,'Eigenvalue',T28,'Symmetry',
     &       T40,'Index',T51,'Eigenvalue',T65,'Symmetry')
C
      RETURN
      END

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine DiagCk(M, N, Tol, A, LDA, Info)
      Integer M, N, LDA, Info
      Double precision A(LDA, N), Tol
      Integer I, J
      Info = 0
      Do 1000 J = 1, N
         Do 1010 I = 1, M
            If (Abs( A(i,j) ) .gt. Tol .AND. i .ne. j) Info = Info + 1
 1010    Continue
 1000 Continue
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE REMAPX(CMPPGP,IORDGP,NATOMS,NORBCMP,COORD,
     &                 SCR,IMEMCMP,IPOPCMP,IMAP,itype)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: remap.F,v 1.3 2010/06/30 15:58:42 ponton Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     remap -- determine the VMol -> ZMAT reordering vector
C
C SYNOPSIS
      CHARACTER*4 CMPPGP
      Integer IOrdGp, NAtoms, NOrbCmp
      Double precision COORD(3,NATOMS), SCR(3*(IOrdGp-1))
      Integer IMEMCMP(NATOMS),IPOPCMP(NORBCMP), IMAP(NATOMS)
C
C DESCRIPTION
C     THIS ROUTINE FORMS A POINTER VECTOR RELATING THE ATOMIC ORDERING
C     USED IMPLICITY BY VMOL TO THAT SPECIFIED IN THE Z-MATRIX.  THIS
C     IS RATHER EASILY CALCULATED FROM INFORMATION RESIDENT IN THE JOBARC
C     FILE.  UPON RETURN, THE INTEGER VECTOR IMAP CONTAINS THE 
C     Z-MATRIX POSITION OF THE ATOMS, AS INDEXED BY THE VMOL ORDERING.
C     FOR EXAMPLE, IF IMAP(3)=11, THIS MEANS THAT THE 3RD ATOM USED BY
C     VMOL IS ACTUALLY THE ELEVENTH ATOM IN THE Z-MATRIX.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Integer IOff, INumAtm, IAtom, IOrbit, IRefAtm, NGen, ICent,
     $   ILoc, IOff1, I, IPos
      Integer itype
      LOGICAL QSAME

      do i = 1, natoms
         imap(i) = 0
      enddo

C LOOP OVER ORBITS IN COMPUTATIONAL POINT GROUP
C
      IOFF=1
      IATOM=1
      DO 10 IORBIT=1,NORBCMP
C
C DETERMINE THE REFERENCE ATOM FOR THE ORBIT (THE ONE USED BY VMOL
C   TO GENERATE THE REDUNDANT CENTERS)
C 
       INUMATM=IPOPCMP(IORBIT)
       IREFATM=IMEMCMP(IOFF)
       IMAP(IATOM)=IREFATM
       IATOM=IATOM+1
C
C NOW USE THE ALGORITHM OF VMOL TO GENERATE THE REDUNDANT CENTERS
C   IN THE COMPUTATIONAL POINT GROUP.  THE VALUE OF NGEN IS THE
C   NUMBER OF DISTINCT REDUNDANT CENTERS RETURNED
C
       CALL VMLGENX(CMPPGP,IORDGP,COORD(1,IREFATM),SCR,NGEN, itype)
C
C NOW LOOP OVER DISTINCT REDUNDANT CENTERS AND FIND THEIR 
C  POSITION IN THE Z-MATRIX ORDER
C
       DO 11 ICENT=1,NGEN
        ILOC=-1
        IOFF1=IOFF+1
        DO 20 I=1,INUMATM-1
         IPOS=IMEMCMP(IOFF1)
         IF(QSAME(SCR(1+(ICENT-1)*3),COORD(1,IPOS)))ILOC=IPOS
         IOFF1=IOFF1+1
20      CONTINUE
        IMAP(IATOM)=ILOC
        IATOM=IATOM+1
11     CONTINUE
       IOFF=IOFF+INUMATM
10    CONTINUE
      RETURN
      END

c This routine converts seconds (in integers) to hours, minutes, and seconds.

c INPUT
c int SECS : the number of seconds to convert

c OUTPUT
c int HH, MM, SS : the hours, minutes, and seconds equal to SECS

c#define _DEBUG_IS2HMS

      subroutine is2hms(secs,hh,mm,ss)
      implicit none

c ARGUMENTS
      integer secs, hh, mm, ss

c PARAMETERS
      double precision s2h, s2m
      parameter (s2h=(1.d0/3600.d0), s2m=(1.d0/60.d0))

c INTERNAL VARIABLES
      integer h, m, s

c ----------------------------------------------------------------------

      s = secs
      h = s * s2h
      s = -(3600*h) + s
      m = s * s2m
      s = -(60*m) + s

      hh = h
      mm = m
      ss = s

      return
      end

      SUBROUTINE IRREPGET(PTGRPX,IORDGP,Z,V,LENTOT,LENGTH,LENMAX,
     &                    NDEG,IPTR,NBFATM,ILCATM,SYOP,SCRATCH,
     &                    NATOMS,IRREP,NBAS,NBASX,IANG)
C
C THIS SUBROUTINE FUNCTIONS TO DETERMINE THE IRREDUCIBLE REPRESENTATION
C  TO WHICH THE VECTOR V BELONGS.  V CAN BE EXPRESSED IN A NUMBER OF 
C  REPRESENTATIONS.  
C
C INPUT:
C    PTGRPX (CHARACTER*4) - THE POINT GROUP OF THE MOLECULE
C    IORDGP               - THE ORDER OF THE POINT GROUP
C    Z                    - A SCRATCH VECTOR OF LENGTH IORDGP WHICH
C                           IS USED TO HOLD THE CHARACTERS
C    V (DOUBLE PRECISION) - THE VECTOR WHICH IS GOING TO BE ASSIGNED
C                           TO A PARTICULAR IRREP OF THE GROUP.  IF
C                           THE VECTOR IS ASSOCIATED WITH A DEGENERATE
C                           EIGENVALUE, THEN V HOLDS ALL EIGENVECTORS
C                           OF THE EIGENVALUE 
C    LENTOT               - THE TOTAL LENGTH OF V (SEE ABOVE)
C    LENGTH               - A VECTOR (OF LENGTH 5) GIVING THE LOGICAL
C                           LENGTH OF EACH EIGENVECTOR IN V.  (THEY
C                           ARE ALMOST ALWAYS EQUAL) [SEE NBAS BELOW]
C    LENMAX               - NDEG*MAXIMUM VALUE IN LENGTH ARRAY [NBAS]
C    NDEG                 - THE LEVEL OF DEGENERACY ASSOCIATED WITH V
C    IPTR                 - THE SYMMETRY POINTER VECTOR RELATING ATOMIC
C                           POSITIONS WITH THEIR IMAGE UNDER THE SYMOPS.
C    NBFATM               - AN INTEGER VECTOR RELATING THE CENTER NUMBER
C                           TO THE NUMBER OF ELEMENTS IN EACH EIGENVECTOR
C                           WHICH ARE ASSOCIATED WITH IT
C    ILCATM               - A VECTOR WHICH GIVES THE STARTING POSITION OF
C                           EACH CENTER IN AN EIGENVECTOR
C    SYOP                 - THE SET OF 3x3 CARTESIAN SYMMETRY OPERATIONS
C    NATOMS               - THE NUMBER OF CENTERS IN EACH EIGENVECTOR
C    NBAS                 - THE MAXIMUM LENGTH OF AN EIGENVECTOR IN V
C                           ***NOTE THAT THIS VALUE IS USED AS A LEADING
C                              DIMENSION IN THE V ARRAY***
C    IANG                 - A NUMBER GIVING THE REPRESENTATION IN WHICH
C                           V IS EXPRESSED.  
C                              0=POSITION REPRESENTATION (LIKE S FUNCS)
C                              1=DIRPRD(POSITION,XYZ) (LIKE P FUNCS)
C                              2=DIRPRD(DIRPRD(POSITION,XYZ),XYZ) (LIKE D)
C    SCRATCH              - A WORKING SCRATCH AREA OF MINIMUM LENGTH
C                           MAX(3^{IANG},NATOMS*3)
C
C RETURNED:
C
C    IRREP                - THE IRREDUCIBLE REPRESENTATION OF V
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER ATOI
      CHARACTER*4 PTGRP,PTGRPX
      CHARACTER*4 IRREP
      DIMENSION V(LENGTH,5),SCRATCH(1),NBFATM(NATOMS)
      DIMENSION IPTR(1),ILCATM(NATOMS),SYOP(1),Z(IORDGP)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SYMCHAR/ CHAR
C     
C     If the length of the vector is zero, return immediately
C     to avoid division by zero.
C     
      If (Length .eq. 0) Return
C
C APPLY ALL SYMMETRY OPERATIONS OF THE GROUP TO THE VECTOR AND
C CALCULATE THE CHARACTERS.
C
      CALL ZERO(Z,IORDGP)
      DO 100 I=1,IORDGP
       CALL IMAGE(NATOMS,LENGTH,NDEG,I,IPTR,NBFATM,
     &            ILCATM,V,SCRATCH,SCRATCH(NDEG*LENGTH+1),
     &            IANG,NBASX,SYOP,0)
       Z(I)=CHAR
100   CONTINUE
C
C OLD CODE BELOW.  CHAR IS NOW PASSED VIA COMMON DIRECTLY FROM
C IMAGE.  CHANGE NECESSARY BECAUSE PROPER NORMALIZATION OF D,F, ETC
C FUNCTIONS IS TRICKY AND MORE EASILY HANDLED IN IMAGE.  
C
c       IOFF=1
c       DO 110 J=1,NDEG
c        Z0=1.D0/SNRM2(LENGTH,V(1,J),1)
c        z1=1.D0/snrm2(length,scratch(ioff),1)
c        write(6,*)' z0 and z1 are ',z0,z1
c        Z(I)=Z(I)+SDOT(LENGTH,V(1,J),1,SCRATCH(IOFF),1)*Z0*Z1
c        IOFF=IOFF+LENGTH
c110    CONTINUE
c100   CONTINUE
C
C PRINT CHARACTERS IF PRINT IS TURNED WAY UP
C
      IF(IFLAGS(1).GT.100)THEN
       WRITE(6,1000)PTGRPX
1000   FORMAT(T3,'@IRREPGET-I, Characters under operations of ',A,':')
       IPASS=1+(IORDGP-1)/10
       IBOT=1
       DO 1100 I=1,IPASS
        ITOP=MIN(IBOT+9,IORDGP)
        WRITE(6,'((10I7))')(IJ,IJ=IBOT,ITOP)
        WRITE(6,'((10F7.4))')(Z(IJ),IJ=IBOT,ITOP)
        IBOT=IBOT+10
1100   CONTINUE
      ENDIF
C
C DETERMINE THE IRREP OF THIS REPRESENTATION
C
      CALL ASSIRR(PTGRPX,Z,NDEG,IRREP)
      RETURN
      END

C THIS ROUTINE CALCULATES SYMMETRY ADAPTED SETS OF CARTESIAN
C COORDINATES.  THERE ARE ESSENTIALLY TWO MODES OF OPERATION:
C
C  1. ABELIAN SUBGROUP.  BASIS VECTORS FOR CHARACTER PROJECTIONS
C     ARE SIMPLE CARTESIAN VECTORS.
C
C  2. FULL POINT GROUP.  BASIS VECTORS FOR CHARACTER PROJECTIONS
C     ARE THE SYMMETRY ADAPTED DISPLACEMENTS IN THE ABELIAN
C     SUBGROUP.

c INPUT
c integer NATOM
c integer NIRREP
c integer IORDER
c integer NORBIT
c char*4  TYPE
c integer NPASS

c OUTPUT
c double  VGEN(NATOM*3)
c double  VREF(NATOM*3)
c double  VIMAGE(NATOM*3)
c double  CHAR(IORDER,NIRREP)
c double  SYOP(9*IORDER)
c char*8  LABEL(NIRREP)
c integer ICENSUS(NATOM)
c integer IPTR(NATOM,IORDER)
c integer NBFATM(NATOM)
c integer ILCATM(NATOM)
c double  SCR(*)
c double  SYMQ(*)
c integer ISYMTYP(*)
c integer INVOP(3*NATOM)

c RECORDS
c get TYPE//'MEMB'
c get TYPE//'CHAR'
c get TYPE//'SYOP'
c get TYPE//'PERM'
c get TYPE//'POPV'
c get TYPE//'LABL'
c get 'ORIENTMT'
c get 'NUMVIBRT'
c get 'COMPSYMQ'
c get 'COMPSYQT'
c put 'SBGRPSYM'
c put 'ORDERREF'
c put 'OPERSREF'
c put 'NVIBSYMF'
c put TYPE//'NSYQ'
c put TYPE//'SYQT'
c put TYPE//'SYMQ'

      SUBROUTINE SYMADQ(NATOM,NIRREP,IORDER,NORBIT,VGEN,VREF,
     &                  VIMAGE,CHAR,SYOP,LABEL,ICENSUS,IPTR,
     &                  NBFATM,ILCATM,SCR,SYMQ,ISYMTYP,
     &                  INVOP,TYPE,NPASS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION VGEN(NATOM*3),VREF(NATOM*3),VIMAGE(NATOM*3)
      DIMENSION CHAR(IORDER,NIRREP),SYOP(9*IORDER)
      CHARACTER*8 LABEL(NIRREP)
      DIMENSION ICENSUS(NATOM),IPTR(NATOM,IORDER),NBFATM(NATOM)
      DIMENSION ILCATM(NATOM),SCR(*),SYMQ(*),ISYMTYP(*)
      DIMENSION INVOP(3*NATOM)
      CHARACTER*4 TYPE

      DIMENSION IPOP(255),buf(1000),NVIBSYM(100)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100)

      DATA TOL /1.D-5/
      DATA ONE /1.0/

      IPOS=1
      NSYMOLD=0
      NSIZE=3*NATOM

      CALL ZERO(VREF,NSIZE)
      CALL ZERO(SYMQ,NSIZE*NSIZE)
      CALL IZERO(INVOP,NSIZE)

      CALL GETREC(20,'JOBARC',TYPE//'MEMB',NATOM,ICENSUS)
      CALL GETREC(20,'JOBARC',TYPE//'CHAR',NIRREP*IORDER*IINTFP,CHAR)
      CALL GETREC(20,'JOBARC',TYPE//'SYOP',9*IORDER*IINTFP,SYOP)
      CALL GETREC(20,'JOBARC',TYPE//'PERM',NATOM*IORDER,IPTR)
      CALL GETREC(20,'JOBARC',TYPE//'POPV',NORBIT,IPOP)
      CALL GETREC(20,'JOBARC',TYPE//'LABL',NIRREP*IINTFP,LABEL)
      CALL GETREC(20,'JOBARC','ORIENTMT',9*IINTFP,SCR)

c   o fill basis vector skipping dummy atoms
      IF (NPASS.EQ.2) THEN
         IF (TYPE.EQ.'FULL') CALL TRNOPS(SYOP,SCR,IORDER)
         CALL GETREC(20,'JOBARC','NUMVIBRT',1,NMODE)
         CALL GETREC(20,'JOBARC','COMPSYMQ',NSIZE*NSIZE*IINTFP,SCR)
         CALL GETREC(20,'JOBARC','COMPSYQT',NSIZE,ISYMTYP(NSIZE+1))
         NTOP=NMODE
      ELSE
         IOFF=1
         CALL ZERO(SCR,NSIZE*NSIZE)
         IOFFS=0
         DO IORBIT=1,NORBIT
            NPOP=IPOP(IORBIT)
            DO I=1,NPOP
               J=ICENSUS(IOFF)
               IOFF=IOFF+1
               DO IXYZ=1,3
                  SCR(IOFFS+IXYZ+(J-1)*3)=ONE
                  IOFFS=IOFFS+NSIZE
               END DO
            END DO
         END DO
         NTOP=NSIZE
      END IF

c   o fill out length and offset vectors for image()
      I = 1
      DO IATOM=1,NATOM
         NBFATM(IATOM)=3
         ILCATM(IATOM)=I
         I = I+3
      END DO

      ZNORM=ONE/DFLOAT(IORDER)

c   o loop over the symmetry blocks
      DO IRREP=1,NIRREP

c      o loop over basis functions
         IOFF=1
         NVIBSYM(IRREP)=0
         DO IBAS=1,NTOP
            CALL DCOPY(NSIZE,SCR(IOFF),1,VREF,1)
            CALL ZERO(VGEN,3*NATOM)

C NOW LOOP OVER ALL SYMMETRY OPERATIONS AND COMPUTE IMAGE OF
C REFERENCE DIRECTION AND MULTIPLY RESULT BY CHARACTER OF OPERATION

            DO IOP=1,IORDER
               CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &                    VREF,VIMAGE,SCR(NSIZE*NSIZE+1),1,3*NATOM,
     &                    SYOP,1)
               CALL DSCAL(3*NATOM,CHAR(IOP,IRREP),VIMAGE,1)
               CALL DAXPY(3*NATOM,ONE,VIMAGE,1,VGEN,1)
            END DO
            ZLEN=DNRM2(3*NATOM,VGEN,1)
            IF (ZLEN.GT.TOL) THEN

c            o normalize coordinates
               XX=ONE/ZLEN
               CALL DSCAL(3*NATOM,xx,VGEN,1)

c            o schmidt orthogonalize to all previous vectors
               CALL GSCHMIDT(VGEN,SYMQ,3*NATOM,NSYMOLD,BUF,ZJUNK,1.D-8)

               ZLEN2=DNRM2(3*NATOM,VGEN,1)
               IF (ZLEN2.GT.TOL) THEN
                  NSYMOLD=NSYMOLD+1
                  ISYMTYP(NSYMOLD)=IRREP
                  ZNORM=1.D0/ZLEN
                  CALL DCOPY(3*NATOM,VGEN,1,SYMQ(IPOS),1)
                  IPOS=IPOS+3*NATOM
                  NVIBSYM(IRREP)=NVIBSYM(IRREP)+1

C FOR FULL POINT GROUP, WE NEED TO KNOW THE SYMMETRY OF THE GENERATOR
C IN THE ABELIAN SUBGROUP.  WE ALSO WANT TO KNOW WHICH OPERATION IN THE
C FULL POINT GROUP MAPS THIS COORDINATE INTO ITS NEGATIVE (NONSYMMETRIC
C DISPLACEMENTS ONLY)

                  IF (NPASS.EQ.2) THEN
                     ISYMTYP(2*NSIZE+NSYMOLD)=ISYMTYP(NSIZE+IBAS)
                  END IF
                  IF (IFLAGS(1).GT.100) THEN
                     write(6,*)'  species ',label(irrep)(1:4)
                     ioffx=0
                     do i=1,natom
                        write(6,'(i5,3f20.10)')i,(vgen(ioffx+ix),ix=1,3)
                        ioffx=ioffx+3
                     end do
                  END IF

               END IF
            END IF
            IOFF=IOFF+NSIZE
         END DO
      END DO

      IF (NPASS.EQ.2) THEN
         CALL DCOPY(NTOP*NSIZE,SYMQ,1,SCR,1)
         CALL DCOPY(NSIZE*NSIZE,SCR,1,SYMQ,1)
         CALL PUTREC(20,'JOBARC','SBGRPSYM',NSIZE,ISYMTYP(2*NSIZE+1))
         CALL PUTREC(20,'JOBARC','ORDERREF',1,IORDER)
         CALL PUTREC(20,'JOBARC','OPERSREF',IORDER*9*IINTFP,SYOP)
         CALL PUTREC(20,'JOBARC','NVIBSYMF',NIRREP,NVIBSYM)
      END IF
      CALL PUTREC(20,'JOBARC',TYPE//'NSYQ',1,NSYMOLD)
      CALL PUTREC(20,'JOBARC',TYPE//'SYQT',NSIZE,ISYMTYP)
      CALL PUTREC(20,'JOBARC',TYPE//'SYMQ',NSIZE*NSIZE*IINTFP,SYMQ)

      RETURN
      END

c NOTE: This routine was blatantly ripped from the SLATEC library.
c       It sorts the primary integer array and carries along the
c       operations on an auxiliary double precision array.
c       I, Anthony Yau, only modified the DSORT source making X an
c       integer array and removing options 1 and -1 from the KFLAG list
c       of possibilities. For the complete header of comments
c       pertaining to this subroutine, consult
c       http://www.netlib.org/slatec/src/dsort.f

      SUBROUTINE IDSORT (IX, DY, N, KFLAG)
C***PURPOSE  Sort an integer array and make the same interchanges in
C            an auxiliary double precision array. The array may be
c            sorted in increasing or decreasing order.
C            algorithm is used.
C***AUTHOR  Jones, R. E., (SNLA)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION OF PARAMETERS
C
C      IX - array of values to be sorted (usually destinations)
C      DY - array to be carried along
C      N  - number of values in array IX to be sorted
C      KFLAG - control parameter
C            =  2  means sort IX in increasing order and carry DY along.
C            = -2  means sort IX in decreasing order and carry DY along.
C
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   000729  DATE MODIFIED FROM DSORT
C
      IMPLICIT NONE
C
C     .. Scalar Arguments ..
      INTEGER KFLAG, N
C     .. Array Arguments ..
      INTEGER IX(*)
      DOUBLE PRECISION DY(*)
C     .. Local Scalars ..
      INTEGER T, TT
      DOUBLE PRECISION R, TY, TTY
      INTEGER I, IJ, J, K, KK, L, M, NN
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. External Subroutines ..
      EXTERNAL XERMSG
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C
C***FIRST EXECUTABLE STATEMENT IDSORT
      NN = N
      IF (NN.LT.1) THEN
         CALL XERMSG ('SLATEC', 'IDSORT',
     +      'The number of values to be sorted is not positive.', 1, 1)
         RETURN
      ENDIF
C
      KK = ABS(KFLAG)
      IF (KK.NE.2) THEN
         CALL XERMSG ('SLATEC', 'IDSORT',
     +      'The sort control parameter, K, is not 2 or -2.', 2, 1)
         RETURN
      ENDIF
C
C     Alter array IX to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 10 I=1,NN
            IX(I) = -IX(I)
   10    CONTINUE
      ENDIF
C
C     Sort IX and carry DY along
C
  100 M = 1
      I = 1
      J = NN
      R = 0.375D0
C
  110 IF (I .EQ. J) GO TO 150
      IF (R .LE. 0.5898437D0) THEN
         R = R+3.90625D-2
      ELSE
         R = R-0.21875D0
      ENDIF
C
  120 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = IX(IJ)
      TY = DY(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (IX(I) .GT. T) THEN
         IX(IJ) = IX(I)
         IX(I) = T
         T = IX(IJ)
         DY(IJ) = DY(I)
         DY(I) = TY
         TY = DY(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than T, interchange with T
C
      IF (IX(J) .LT. T) THEN
         IX(IJ) = IX(J)
         IX(J) = T
         T = IX(IJ)
         DY(IJ) = DY(J)
         DY(J) = TY
         TY = DY(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (IX(I) .GT. T) THEN
            IX(IJ) = IX(I)
            IX(I) = T
            T = IX(IJ)
            DY(IJ) = DY(I)
            DY(I) = TY
            TY = DY(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
  130 L = L-1
      IF (IX(L) .GT. T) GO TO 130
C
C     Find an element in the first half of the array which is greater
C     than T
C
  140 K = K+1
      IF (IX(K) .LT. T) GO TO 140
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = IX(L)
         IX(L) = IX(K)
         IX(K) = TT
         TTY = DY(L)
         DY(L) = DY(K)
         DY(K) = TTY
         GO TO 130
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 160
C
C     Begin again on another portion of the unsorted array
C
  150 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
  160 IF (J-I .GE. 1) GO TO 120
      IF (I .EQ. 1) GO TO 110
      I = I-1
C
  170 I = I+1
      IF (I .EQ. J) GO TO 150
      T = IX(I+1)
      TY = DY(I+1)
      IF (IX(I) .LE. T) GO TO 170
      K = I
C
  180 IX(K+1) = IX(K)
      DY(K+1) = DY(K)
      K = K-1
      IF (T .LT. IX(K)) GO TO 180
      IX(K+1) = T
      DY(K+1) = TY
      GO TO 170
C
C     Clean up
C
  190 IF (KFLAG .LE. -1) THEN
         DO 200 I=1,NN
            IX(I) = -IX(I)
  200    CONTINUE
      ENDIF
      RETURN
      END

      subroutine A2get_gridnmlist(GRID_FILE, NMBROF_GRIDPTS)
C
      implicit double precision (a-h,o-z)
      character*80 wrk
      Character*12 GRID_FILE
      
      OPEN(UNIT=4,FILE='ZMAT',FORM='FORMATTED',STATUS='OLD')
      REWIND(4)
C
300   READ(4,'(A)', END=900) WRK
      IF (WRK(1:9) .NE.'*PES_GRID') goto 300
C
C Obtain the number grid points
C
      READ(4,*,END=900) NMBROF_GRIDPTS
C
C The name of the file that the GRID is stored (maximum of 10 
C charaters.

      READ(4,'(A)', END=900) WRK
      GRID_FILE = WRK(1:12)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Print*, "The user given grid info"
      Write(6, "(t3,a,1x,i5)"), 
     &           GRID_FILE, NMBROF_GRIDPTS
      Write(6,*)
#endif
C
      GO TO 99
900   WRITE(6,901)
c
901   FORMAT(T3,'@A2get_gridnmlist, *PES_GRID namelist not found or', 
     &       ' incomplete.')
      GO TO 999 
 999  CONTINUE
C
      CLOSE(UNIT=4,STATUS='KEEP')
      CALL ERREX
C
  99  CONTINUE
      CLOSE(UNIT=4,STATUS='KEEP')
      
      RETURN
      END

      SUBROUTINE HESSOUT(X,IR,IC,NSYM)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
#include "coord.com"
#include "flags.h"
#include "jodaflags.com"
C
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
#include "io_units.par"
      DIMENSION X(IR,IC)
C
      JX=1
 1    ITOP=MIN(JX+4,IR)
      
      IF(NSYM.EQ.1)
     $  WRITE(LuOut,90)(VARNAM(ISQUASH(NOPTI(IX))),IX=JX,ITOP)
      IF(NSYM.EQ.0)WRITE(LuOut,90)(VARNAM(ISQUASH(IX)),IX=JX,ITOP)
 90   FORMAT(T17,A5,T27,A5,T37,A5,T47,A5,T57,A5)

      DO 10 I=1,IR
         IF (NSYM .EQ. 1) WRITE (LuOut,44) VARNAM(ISQUASH(NOPTI(I))),
     $      (X(I,J),J=JX,MIN(IC,ITOP))
         IF (NSYM .EQ. 0) WRITE (LuOut,44) VARNAM(ISQUASH(I)),
     $      (X(I,J),J=JX,MIN(IC,ITOP))
 10   CONTINUE
      JX=JX+5
      IF (JX .GT. IR) RETURN
      WRITE(LuOut,*)
      GOTO 1
 44   FORMAT(T3,A5,T13,F9.6,T23,F9.6,T33,F9.6,T43,
     &       F9.6,T53,F9.6)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_1D_COEFFICIENTS
     +
     +                    ( NGQP,NCEN,
     +                      MIJ,MGIJCEN,
     +                      ATOMIC,
     +                      NUCLEI,
     +                      XN,YN,ZN,
     +                      NUCCEN,
     +                      PX,PY,PZ,
     +                      PAX,PAY,PAZ,
     +                      PINVHF,
     +                      RTS,
     +
     +                               R1X,R1Y,R1Z,
     +                               R2 )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_1D_COEFFICIENTS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation evaluates the VRR coefficients for
C                the 1D nuclear attraction integrals for the present
C                set of NGQP roots corresponding to all i,j exponent
C                pairs.
C
C
C                  Input:
C
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NCEN         =  # of nuclear attraction centers
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    MGIJCEN      =  # of roots times # of ij primitive
C                                    index pairs times # of nuclear
C                                    attraction centers
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    NUCLEI       =  # of nuclear attraction centers
C                    XN,YN,ZN     =  the x,y,z-coordinates for all
C                                    nuclear attraction centers
C                    NUCCEN       =  contains those index labels of
C                                    the nuclear attraction centers
C                                    that survived the screening process
C                    Px           =  current MIJ coordinates x=X,Y,Z
C                                    for the gaussian product centers
C                                    P=A+B
C                    PAx          =  current MIJ coordinate x=X,Y,Z
C                                    differences P-A between centers
C                                    P and A
C                    PINVHF       =  current MIJ values of 1/(2*P),
C                                    where P are the exponent sums for
C                                    contraction shells A and B
C                    RTS          =  all current MGIJCEN quadrature
C                                    roots
C
C                  Output:
C
C                    R1x          =  the VRR R1-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    R2           =  the coordinate independent VRR
C                                    R2-coefficients
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   ATOMIC

         INTEGER   IJ,N
         INTEGER   IXC
         INTEGER   MIJ,MGIJCEN
         INTEGER   NC,NCEN
         INTEGER   NG,NGQP
         INTEGER   NUCLEI

         INTEGER   NUCCEN (1:NCEN)

         DOUBLE PRECISION  PXIJ,PYIJ,PZIJ
         DOUBLE PRECISION  PAXIJ,PAYIJ,PAZIJ
         DOUBLE PRECISION  ROOT
         DOUBLE PRECISION  TWOP
         DOUBLE PRECISION  XC,YC,ZC

         DOUBLE PRECISION  XN     (1:NUCLEI)
         DOUBLE PRECISION  YN     (1:NUCLEI)
         DOUBLE PRECISION  ZN     (1:NUCLEI)

         DOUBLE PRECISION  PX     (1:MIJ)
         DOUBLE PRECISION  PY     (1:MIJ)
         DOUBLE PRECISION  PZ     (1:MIJ)
         DOUBLE PRECISION  PAX    (1:MIJ)
         DOUBLE PRECISION  PAY    (1:MIJ)
         DOUBLE PRECISION  PAZ    (1:MIJ)
         DOUBLE PRECISION  PINVHF (1:MIJ)

         DOUBLE PRECISION  R1X    (1:MGIJCEN)
         DOUBLE PRECISION  R1Y    (1:MGIJCEN)
         DOUBLE PRECISION  R1Z    (1:MGIJCEN)
         DOUBLE PRECISION  R2     (1:MGIJCEN)
         DOUBLE PRECISION  RTS    (1:MGIJCEN)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the 1D coefficients.
C
C
         IF (ATOMIC) THEN
             N = 0
             DO IJ = 1,MIJ
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                TWOP = PINVHF (IJ)

                DO NC = 1,NCEN
                   IXC = NUCCEN (NC)
                   XC = XN (IXC)
                   YC = YN (IXC)
                   ZC = ZN (IXC)
                   DO NG = 1,NGQP
                      N = N + 1
                      ROOT  = RTS (N)
                      R1X (N) = ROOT * (XC - PXIJ)
                      R1Y (N) = ROOT * (YC - PYIJ)
                      R1Z (N) = ROOT * (ZC - PZIJ)
                      R2  (N) = TWOP - (TWOP * ROOT)
                   END DO
                END DO
             END DO
         ELSE
             N = 0
             DO IJ = 1,MIJ
                PXIJ = PX (IJ)
                PYIJ = PY (IJ)
                PZIJ = PZ (IJ)
                PAXIJ = PAX (IJ)
                PAYIJ = PAY (IJ)
                PAZIJ = PAZ (IJ)
                TWOP = PINVHF (IJ)

                DO NC = 1,NCEN
                   IXC = NUCCEN (NC)
                   XC = XN (IXC)
                   YC = YN (IXC)
                   ZC = ZN (IXC)
                   DO NG = 1,NGQP
                      N = N + 1
                      ROOT  = RTS (N)
                      R1X (N) = PAXIJ + ROOT * (XC - PXIJ)
                      R1Y (N) = PAYIJ + ROOT * (YC - PYIJ)
                      R1Z (N) = PAZIJ + ROOT * (ZC - PZIJ)
                      R2  (N) = TWOP - (TWOP * ROOT)
                   END DO
                END DO
             END DO
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE ZEROLIST(ICORE,MAXCOR,DOLIST)
C
C THIS ROUTINE ZEROS OUT A DPD LIST
C
CEND
C SG 9/6/1996
C Modified to take care of cases when the list is not totally symmetric
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMINF/ NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
C
      MXNMDS = 0
      MXDSSZ = 0
      DO 10 IRREP = 1,NIRREP
        NUMDIS = IRPDPD(IRREP,ISYTYP(2,DOLIST))
        MXNMDS = MAX(NUMDIS,MXNMDS)
        DISSIZ = IRPDPD(IRREP,ISYTYP(1,DOLIST))
        MXDSSZ = MAX(DISSIZ,MXDSSZ)
 10   CONTINUE
      ISIZE = MXNMDS*MXDSSZ*IINTFP
      IF (ISIZE .LE. MAXCOR) THEN
        CALL IZERO(ICORE,ISIZE)
        DO 20 IRREP = 1,NIRREP
          NUMDIS = IRPDPD(IRREP,ISYTYP(2,DOLIST))
          CALL PUTLST(ICORE,1,NUMDIS,1,IRREP,DOLIST)
 20     CONTINUE
      ELSE
        CALL IZERO(ICORE,MXDSSZ*IINTFP)
        DO 30 IRREP = 1,NIRREP
          NUMDIS = IRPDPD(IRREP,ISYTYP(2,DOLIST))
          DO 40 IDIS = 1,NUMDIS
            CALL PUTLST(ICORE,IDIS,1,1,IRREP,DOLIST)
 40       CONTINUE
 30     CONTINUE
      ENDIF
C
      RETURN
      END

      SUBROUTINE IDNMAT(A,N,NTIME)
C
C SUBROUTINE RETURNS THE N X N IDENTITY MATRIX.  NTIME UTILITY IS
C  USED IN SYMUNQ.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      double precision a(*)
      if (n.eq.3) then
         a(1) = 1.d0
         a(2) = 0.d0
         a(3) = 0.d0
         a(4) = 0.d0
         a(5) = 1.d0
         a(6) = 0.d0
         a(7) = 0.d0
         a(8) = 0.d0
         a(9) = 1.d0
      else
         do i = 1, n*n
            a(i) = 0.d0
         end do
         ndx = 1
         do i = 1, n
            a(ndx) = 1.d0
            ndx = ndx + n + 1
         end do
      end if
      NTIME=NTIME+1
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK BALBAK
      SUBROUTINE BALBAK (NM, N, LOW, IGH, SCALE, M, Z)
C***BEGIN PROLOGUE  BALBAK
C***PURPOSE  Form the eigenvectors of a real general matrix from the
C            eigenvectors of matrix output from BALANC.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      DOUBLE PRECISION (BALBAK-S, CBABK2-C)
C***KEYWORDS  EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure BALBAK,
C     NUM. MATH. 13, 293-304(1969) by Parlett and Reinsch.
C     HANDBOOK FOR AUTO. COMP., Vol.II-LINEAR ALGEBRA, 315-326(1971).
C
C     This subroutine forms the eigenvectors of a REAL*8 GENERAL
C     matrix by back transforming those of the corresponding
C     balanced matrix determined by  BALANC.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the number of components of the vectors in matrix Z.
C          N is an INTEGER variable.  N must be less than or equal
C          to NM.
C
C        LOW and IGH are INTEGER variables determined by  BALANC.
C
C        SCALE contains information determining the permutations and
C          scaling factors used by  BALANC.  SCALE is a one-dimensional
C          REAL*8 array, dimensioned SCALE(N).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the real and imaginary parts of the eigen-
C          vectors to be back transformed in its first M columns.
C          Z is a two-dimensional REAL*8 array, dimensioned Z(NM,M).
C
C     On OUTPUT
C
C        Z contains the real and imaginary parts of the
C          transformed eigenvectors in its first M columns.
C
C     Questions and comments should be directed to B. S. Garbow,
C     Applied Mathematics Division, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  BALBAK
C
#ifdef ACES64
      INTEGER*8 I,J,K,M,N,II,NM,IGH,LOW
#else
      INTEGER I,J,K,M,N,II,NM,IGH,LOW
#endif
      DOUBLE PRECISION SCALE(*),Z(NM,*)
      DOUBLE PRECISION S
C
C***FIRST EXECUTABLE STATEMENT  BALBAK
      IF (M .EQ. 0) GO TO 200
      IF (IGH .EQ. LOW) GO TO 120
C
      DO 110 I = LOW, IGH
         S = SCALE(I)
C     .......... LEFT HAND EIGENVECTORS ARE BACK TRANSFORMED
C                IF THE FOREGOING STATEMENT IS REPLACED BY
C                S=1.0D0/SCALE(I). ..........
         DO 100 J = 1, M
  100    Z(I,J) = Z(I,J) * S
C
  110 CONTINUE
C     ......... FOR I=LOW-1 STEP -1 UNTIL 1,
C               IGH+1 STEP 1 UNTIL N DO -- ..........
  120 DO 140 II = 1, N
         I = II
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 140
         IF (I .LT. LOW) I = LOW - II
         K = SCALE(I)
         IF (K .EQ. I) GO TO 140
C
         DO 130 J = 1, M
            S = Z(I,J)
            Z(I,J) = Z(K,J)
            Z(K,J) = S
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END

      SUBROUTINE GETICFCM(A,NIC,IICFCM)
C
C ROUTINE FETCHES INTERNAL OR CARTESIAN COORDINATE HESSIAN FROM FCMINT.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL YESNO
c     Maximum string length of absolute file names
      INTEGER FNAMELEN
      PARAMETER (FNAMELEN=80)
      CHARACTER*(fnamelen) FNAME
      DIMENSION A(NIC,NIC)
      IICFCM=0
      CALL GFNAME('FCMINT  ',FNAME,ILENGTH)
      INQUIRE(FILE=FNAME(1:ILENGTH),EXIST=YESNO)
      IF(.NOT.YESNO)RETURN
c      OPEN(UNIT=50,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
      OPEN(UNIT=50,FILE=FNAME(1:ILENGTH),FORM='FORMATTED',
     &     STATUS='OLD')
c      REWIND(50)
      READ(50,*)((A(I,J),J=1,NIC),I=1,NIC)
      CLOSE(UNIT=50,STATUS='KEEP')
      WRITE(6,100)
100   FORMAT(T3,'@GETICFCM-I, Hessian read from FCMINT file.')
      IICFCM=1
      RETURN
      END

      SUBROUTINE FLOWEVFMIN(SCRATCH, GRDHES, HESMOD, DIAGHES, LMBDAN,
     &                      MORSE, NX, NOPT)
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C
      DOUBLE PRECISION LMBDAN
      LOGICAL MORSE
C
#include "flags.h"
#include "jodaflags.com"
C
      DIMENSION SCRATCH(NX*NX), GRDHES(NOPT), HESMOD(NOPT, NOPT),
     &          DIAGHES(NOPT, NOPT)
C
#ifdef _DEBUG_LVLM1
        Write(6,*) "The scratch array before RFO step", NOPT
        Write(6, "(3F10.5)") (SCRATCH(J+NOPT), J=1, NOPT)
#endif
      DO 10 I = 1, NOPT
         DO 20 J = 1, NOPT

            IF (LAMBDN .EQ. 0.0D0 .AND.
     &          DABS(HESMOD(I,I)) .LT. 1.0D0-8)  THEN
C
                 SCRATCH(J+NOPT) = SCRATCH(J+NOPT) - 0.0D0
C
            ELSE
C
               IF (DABS((HESMOD(I,I) - LMBDAN)) .LT. 1.0D0-8) THEN

                  SCRATCH(J+NOPT) = SCRATCH(J+NOPT) - 0.0D0
C
               ELSE
                  SCRATCH(J+NOPT) = SCRATCH(J+NOPT)-
     &                             GRDHES(I)*DIAGHES(J,I)/
     &                             (HESMOD(I,I) - LMBDAN)
C
#ifdef _DEBUG_LVLM1
            Write(6,"(6F10.5)"), GRDHES(I), HESMOD(i,i),
     &                    DIAGHES(J,I), LMBDAN, GRDHES(I)/
     &                    (HESMOD(I,I) - LMBDAN), SCRATCH(J+NOPT)
#endif
              ENDIF
            ENDIF

 20      CONTINUE
 10   CONTINUE 
#ifdef _DEBUG_LVLM1
        Write(6,*) "The unscaled RFO step"
        Write(6, "(3F10.5)") (SCRATCH(J+NOPT), J=1, NOPT)
#endif
C
C Notice that there is no Morse adjustments can be made for
C pure Cartesian OLPtimization (no connections), Also, no
C Morse scaling can be done for redundent internals.
C Ajith Perera,08/2008, 2011.

      IF (MORSE) THEN
         IF (iFlags2(h_IFLAGS2_geom_opt) .ge. 3) THEN
CSSS           CALL DOMORSEXYZ_RIC(SCRATCH, NOPT, NX, LUOUT)
         ELSE IF (iFlags2(h_IFLAGS2_geom_opt) .eq. 1) THEN
           CALL DOMORSEZMT(SCRATCH, NOPT, NX, LUOUT)
         ENDIF
      ENDIF
C
      RETURN
      END

c This routine was the common exit handler for all AMEs, but that function has
c been transferred to aces_exit(). This routine is now kept for compatibility.

      subroutine errex
      call aces_exit(1)
      end

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine RdSOAO (LUN, RecNam, NewVM, NAO, NSO, SOAO, LD)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: rdsoao.f,v 1.4 2008/11/19 15:48:33 perera Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     rdsoao -- read SO --> AO transformation from MOLECULE file
C
C SYNOPSIS
      Integer LUN, NSO, NAO, LD
      Character*(*) RecNam
      Double precision SOAO(LD, NSO)
      Logical NewVM
C
C ARGUMENTS
C     LUN     Unit for integral file (input)
C     RecNam  Record name for transformaiton (input)
C     NewVM   New VMol or old VMol (input)
C     NAO     Row dimension SOAO (nr of AOs) (input)
C     NSO     Column dimension of SOAO (nr of SOs) (input)
C     SOAO    The SO -> AO transformation (output)
C     LD      Leading dimension of SOAO (input)
C
C ROUTINES REQUIRED
C     Zero    Zero out a vector
C     Locate  Find a give record label in a Molecule-style int. file
C
C DESCRIPTION
C     Reads SO -> AO transform. matrix from a MOLECULE integral file.
C     In the output matrix, SOs label the columns and AOs the rows.
C     
C     The usual record to read is labeled SYMTRANS.
C
C     The matrix is not in general normalized, so the inverse
C     transformation requires some playing with factors.  Moreover, 
C     the matrix may not be square if spherical harmonic SOs are
C     used.  In this case the matrix may still be considered square
C     with "phantom" columns representing the SOs which have been
C     dropped in the cartesian->spherical transformation.  This
C     expanded matrix would then have to act on a matrix with the SO
C     space augemented by rows of zeros corresponding to the dropped
C     functions.  Good luck!
C
C BUGS
C     Limited to 80 AOs contributing to each SO.
C     Variable IIntFP in common block MACHSP must be 1 or 2.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     Include 'mach.inc'
C $Id: rdsoao.f,v 1.4 2008/11/19 15:48:33 perera Exp $
      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C LOCAL VARIABLES
C     i       General counter
C     ii      General counter
C     j       General counter
C     JTran   Number of AOs in SO (valid elements in ITran/CTran)
C     ITran   AO components of an SO
C     Junk    To skip over center and ang. mom. labels neatly.
C             
      Character*4 Junk
      Integer I, ii, j, JTran, ITran(224)
C
      Call Zero( SOAO, LD*NSO)
C
C     ***************************
C     * SO -> AO transformation *
C     ***************************
C
C     Find the symmetry transformation section
      Call Locate( LUN, RecNam)
C
C     Record format is slightly different for New_Mol & VMol
C        New_Mol starts with a record holding the number of basis fns
C           and is otherwise like VMol.
C        VMol writes each orbital as a record
C
C     NOTE:  The number of 4 char. pieces making up the two labels
C     should be 4 if IIntFP=1 and 2 if IIntFP=2.
C
C
      If (.NOT. NewVM) then
         Do 100 I = 1, NSO
            Read (LUN) J, (Junk, ii = 1, 2*(3-IIntFP)),  JTran,
     $         (ITran(ii), SOAO(ITran(ii), j), ii = 1, JTran)
 100     Continue
      Else
         Read (LUN)
         Do 200 I = 1, NSO
            Read (LUN) JTran, (ITran(ii), SOAO(ITran(ii), i),
     $         ii = 1, JTran)
 200     Continue
      EndIf
C
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE CNVRT2RAD(R,NX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
      DIMENSION R(NX)
      ATOR=DACOS(-1.D0)/180.D0
      ATOB=0.529177249D0
      DO IX = 8, NX-1, 3
         IF (IX.NE.8) R(IX+1) = R(IX+1)*ATOR
         R(IX) = R(IX)*ATOR
      END DO
      IF (IFLAGS(78).EQ.0) THEN
         DO IX = 4, NX-2, 3
            R(IX) = R(IX)/ATOB
         END DO
      END IF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine remove_diagonal(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c
c   The diagonal elements of an array(Array1) are removed and the array 
c   without the diagonal elements is put into another array(Array2). 
c
c   The instruction is executed as follows:
c   
c   execute remove_diagonal Array1 Array2
c
c   where Array1 is the full input matrix, usually the fock matrix.  
c         Array2 is the matrix with zero diagonal elements.  
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'trace.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      integer n

      if (dryrun) return

      n = edim(1) - bdim(1) + 1 
      if (nindex .eq. 2) call rdiag2(x,x2,n) 

      return 
      end 

      subroutine rdiag2(array1,array2,n) 

c---------------------------------------------------------------------------
c
c The diagonal elements of the array1 are removed and the output put into 
c array2. The diagonal elements of the Fock matrix are also put into
c the epsilon array.  
c 
c---------------------------------------------------------------------------

      implicit none
      include 'epsilon.h'
      integer n 
      double precision array1(n,n)
      double precision array2(n,n)
      integer a, b

      do b = 1, n
      do a = 1, n
         if (a .ne. b) array2(a,b) = array1(a,b)
         if (a .eq. b) array2(a,b) = 0.0  
c        write(6,*) a, b, array1(a,b), array2(a,b) 
      enddo
      enddo

      return
      end

      subroutine Ecp_Grdint_4prim(Xa, Ya, Za, Xb, Yb, Zb, La, Lb, 
     &                            Coord, Exp1, Exp2, Natoms, Ntotatoms, 
     &                            Cint, Int, Zero_int, Icnt, Iecp_cnt, 
     &                            Grads)

C (XA,YA,ZA) and (XB,YB.ZB) are the coordintes of center A and B.
C LA and LB are the angular momentums of gaussians on A and B (0,...n)
C Cont1 and Cont1 are the contractions coefficients for gaussian A and B.
C Exp1 and Exp1 are the exponents of gaussian A and B
C
      Implicit Double Precision (A-H, O-Z)

#include "ecp.par"
#include "ecp.com"

      Dimension Coord(3,Ntotatoms), ACS_xyz(0:2*Maxang,3),
     &          BCS_xyz(0:2*Maxang,3), Cint(Maxmem_a3)
      Logical CA_zero, CB_zero, PC_zero, Zero_int, Rad1_zero,
     &        Rad2_zero, Grads, Zero_int_cnt(Ntotatoms)
C
#ifdef _DEBUG_LVL0
      Write(6,*) "ECP Paramters: Kfirst and Klast"
      Write(6,"(6(1x,I2))") ((Kfirst(i,j),i=1,Maxang),
     &                                    J=1,Natoms)
      Write(6,"(6(1x,I2))") ((Klast(i,j),i=1,Maxang),
     &                                    J=1,Natoms)
#endif
C 
C Loop over all the ECP centers and compute the integral 
C for each pair of  primitives

      Ltot = La + Lb + 1
      Lap = La + 1

#ifdef _DEBUG_LVL0
C      Natoms = 1
      Write(6,"(a,I3)") "The Debug value for No. atoms: ", Natoms
      Write(6,"(a,2I3)") "The Debug value Icnt,Iecp_cnt: ", Icnt,
     &                    Iecp_cnt
#endif
      Xc = Coord(1, Icnt)
      Yc = Coord(2, Icnt)
      Zc = Coord(3, Icnt)

#ifdef _DEBUG_LVLM
      Write(6,*) "Initialize debug xyz of C"
      xc=2.0
      yc=2.0
      zc=2.0
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of C : ", Xc, yc, Zc
#endif
C
C Build CA anb CB,(= C-A, C-B) vector components
C
      Xca = Xc - Xa
      Yca = Yc - Ya
      Zca = Zc - Za
      Ca2 = Xca**2 + Yca**2 + Zca**2

      if (Ca2 .Gt. 0.0D0) Then
         Ca = Dsqrt(Ca2)
         Lamau = Lap
         Xahat = -Xca/Ca
         Yahat = -Yca/Ca
         Zahat = -Zca/Ca
         CA_zero = .False.
      Else 
         Ca = 0.0D0
         Lamau = 0
         Xahat = 0
         Yahat = 0
         Zahat = 0
         CA_zero = .True.
      Endif
C
      Xcb = Xc - Xb
      Ycb = Yc - Yb
      Zcb = Zc - Zb
      Cb2 = Xcb**2 + Ycb**2 + Zcb**2

      if (Cb2 .Gt. 0.0D0) Then
          Cb = Dsqrt(Cb2)
          Lambu = Lb
          Xbhat = -Xcb/Cb
          Ybhat = -Ycb/Cb
          Zbhat = -Zcb/Cb
          CB_zero = .False.
      Else
          Cb = 0.0D0
          Lambu = 0
          Xbhat = 0
          Ybhat = 0
          Zbhat = 0
          CB_zero = .True.
      Endif
C
C Build PIn_i=n,,k_i=0...n_i}CA_i^^(n_i-k_i) i=x,y,z
C

      Call Make_xyz(Lap, Xca, ACS_xyz(0,1))
      Call Make_xyz(Lap, Yca, ACS_xyz(0,2))
      Call Make_xyz(Lap, Zca, ACS_xyz(0,3))

      Call Make_xyz(Lb, Xcb, BCS_xyz(0,1)) 
      Call Make_xyz(Lb, Ycb, BCS_xyz(0,2))
      Call Make_xyz(Lb, Zcb, BCS_xyz(0,3))

#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "ACS_xyz array from make_xyz"
      Write(6,"(3F10.6)") ((ACS_xyz(i,j), j=1, 3),i=0,la)

      Write(6,"(a)") "ACS_xyz array from make_xyz"
      Write(6,"(3F10.6)") ((BCS_xyz(i,j), j=1, 3),i=0,la)
#endif

C
C Get the common center of gaussian on A and B and the new
C multification factor (Fact_AB).
C
      Call Get_center(Xa, Ya, Za, Xb, Yb, Zb, Exp1, Exp2,
     &                Xp, Yp, Zp, Exp12, Fact_Ab)

      Xpc = Xp - Xc
      Ypc = Yp - Yc
      Zpc = Zp - Zc
       
      Pc2 = Xpc**2 + Ypc**2 + Zpc**2

      If (Pc2 .Gt. 0.0D0) Then
         Pc    = Dsqrt(Pc2)
         Lamu  = Ltot
         Xhat  = Xpc/pc
         Yhat  = Ypc/pc
         Zhat  = Zpc/pc
         Beta  = 2.0D0*Exp12*PC
         PC_Zero = .False.
      Else 
          Pc    = 0.0D0
          Lamu  = 0
          Beta  = 0.0D0 
          Xhat  = 0.0D0
          Yhat  = 0.0D0
          ZhAt  = 0.0D0
          PC_Zero = .True.
      Endif

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,"(a)") "At entry to Ecp_int_typ12"
      Write(6,"(a,4(1x,I2))" ) "La, Lb, Lamu and Ltot: ", La, Lb, 
     &                          Lamu, Ltot

      Write(6,"(a,3(1x,F10.6))" ) "Xc,Yc,Zc, Xhat,Yhat,Zhat: ", 
     &                             Xc,Yc,Zc
      Write(6,"(a,3(1x,F10.6))" ) "                          ",
     &                             Xhat,Yhat,Zhat
      Write(6,"(a,4(1x,F10.6))" ) "Exp12,Beta,Pc2,Fact_ab:   ", 
     &                             Exp12,Beta,Pc2,Fact_ab
      Write(6,"(a,6(1x,F10.6))" ) "Xah,Yah,Zah,Xbh,Ybh,Zbh:  ",
     &                             Xahat,Yahat,Zahat
      Write(6,"(a,3(1x,F10.6))" ) "                          ",
     &                             Xbhat,Ybhat,Zbhat
      Write(6,*) 
      Write(6,"(a)") "Entering Ecp_int_typ1" 
#endif
      Call Ecp_int_typ1(Iecp_cnt, Lamu, Ltot, La, Lb, Exp12, 
     &                  Xhat, Yhat, Zhat, Xp, Yp, Zp, Xc, Yc,
     &                  Zc, Acs_xyz, Bcs_xyz, Pc2, Fact_Ab,
     &                  PC_zero, Cint, Int, Rad1_zero, Grads)
#ifdef _DEBUG_LVL0
           Write(6,*) 
           Write(6,"(a)") "Entering Ecp_int_typ2"
#endif
      Call Ecp_int_typ2(Iecp_cnt, Lamau, Lambu, La, Lb, 
     &                  Exp1, Exp2, EXp12, Xahat, Yahat, Zahat, 
     &                  Xbhat, Ybhat, Zbhat, Xp, Yp, Zp, Xc, Yc,
     &                  Zc, Acs_xyz, Bcs_xyz, Ca, Cb, Pc2, 
     &                  Fact_Ab, CA_Zero, CB_Zero, Cint, 
     &                  Rad2_zero, Grads)

      Zero_int_cnt(Icnt) = Rad1_zero .AND. Rad2_zero 

#ifdef _DEBUG_LVL0
           Write(6,*) "Test for Zero integrals"
           Write(6,*) Zero_int_cnt(Icnt), Rad1_zero, Rad2_zero 
#endif

      Zero_int = .True. 
      Do Kcnt = 1, Natoms
         If (.NOT. Zero_int_cnt(Kcnt)) Then
             Zero_int = .False.
             Return
         Endif
      Enddo 
C
C Do the contractions. 
C
      Return
      End

      SUBROUTINE GETALL(Z,LENGTH,IRREPX,LSTNUM)
C
C THIS ROUTINE RETRIEVES ALL IRREPS OF A SYMMETRY PACKED DISTRIBUTION
C  AND PLACES THEM IN THE VECTOR Z.  LENGTH IS THE TOTAL LENGTH OF THE
C  LIST, LSTNUM IS THE NUMBER OF THE LIST ON THE MOINTS FILE.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION Z(LENGTH)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),DIRPRD(8,8)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),D(18)
C
C  LOOP OVER IRREPS.
C
      IOFF=1
      ILIST=LSTNUM
      DO 10 IRREPR=1,NIRREP
       IRREPL=DIRPRD(IRREPR,IRREPX)
C
C GET NUMBER OF DISTRIBUTIONS AND DISTRIBUTION SIZE.
C
       NUMDIS=IRPDPD(IRREPR,ISYTYP(2,ILIST))
       DISSIZ=IRPDPD(IRREPL,ISYTYP(1,ILIST))
C
C STUFF VECTOR INTO Z.
C
       IF(NUMDIS.EQ.0)GOTO 10
       if (ioff+dissiz*numdis.gt.length+1) then
          print *, '@GETALL: Assertion failed.'
          print *, '         need ',ioff+dissiz*numdis-1,' dbls'
          print *, '         have ',length
          call aces_exit(1)
       end if
       CALL GETLST(Z(IOFF),1,NUMDIS,1,IRREPR,LSTNUM)
       IOFF=IOFF+NUMDIS*DISSIZ
10    CONTINUE
      RETURN
      END

      function iblank(zeile)
      implicit double precision (a-h,o-z)
c
      integer iblank
      character*(*) zeile
c
c     --- delete leading blanks and equal signs ("=")
c
      n=len(zeile) 
c
      iblank=index(zeile,' ')
      if(iblank.eq.0) then
        iblank=n+1
        return
      endif
c
      i=0
  100 i=i+1
      if(i.gt.n) goto 200
      if(zeile(i:i).eq.' '.or.zeile(i:i).eq.'=') goto 100
  200 i=i-1
      if(i.eq.0) return
c
      do 400 j=1,n-i
  400   zeile(j:j)=zeile(i+j:i+j)
c
      if(i.lt.n) zeile(n-i+1:)=' '
c
      iblank=index(zeile,' ')
c
      return
      end

C ROUTINE ACCEPTS A SYMMETRIC MATRIX V, AND THEN RETURNS THE
C RESULT IN PACKED I.LE.J TRIANGULAR FORM.  THE DIAGONAL IS INCLUDED IF
C IDIAG IS SET TO 0, AND NOT INCLUDED IF IDIAG = 1.

      SUBROUTINE SQUEEZ(V,N,IDIAG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION V(N*N)

      if ((idiag.lt.0).or.(idiag.gt.1)) then
         print *, '@SQUEEZ: Assertion failed.'
         print *, '         idiag = ',idiag
         call errex
      end if

      if (n.lt.1) return
      IX = 0
      DO J = 1+IDIAG, N
         DO I = 1, J-IDIAG
            IX = IX + 1
            INDX = I + (J-1)*N
            V(IX) = V(INDX)
         END DO
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine copy_ff(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c
c   The elements of Array1 are put into Array2 for overlaping indeces. 
c
c   The instruction is executed as follows:
c   
c   execute copy_ff Array1 Array2
c
c   where Array1 is the full input matrix. 
c         Array2 is the same ar Array1 where indeces overlap.  
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      if (nindex .eq. 2) call copy2ff(x,x2,nindex,
     *                              bdim(1),edim(2),bdim(1),edim(2))
      return
      end

      subroutine copy2ff(array1,array2,nindex,na1,na2,nb1,nb2) 
      implicit none

      include 'int_gen_parms.h'
      include 'parallel_info.h'
      include 'trace.h'

c----------------------------------------------------------------------------
c
c The array1 is assumed to be of type alpha-alpha (VaD) or (SD). The elements 
c of the array1 are put into array2 with the FIRST index offset by the
c number of singly occupied orbitals. Array2 is of type beta-beta (VbD)  
c 
c----------------------------------------------------------------------------

      integer nindex, na1, na2, nb1, nb2  
      double precision array1(na1,na2)
      double precision array2(nb1,nb2)
      integer a, b, n1, n2, noff   

      n1 = max0(na1,nb1) 
      n2 = max0(na2,nb2) 

c      write(6,*) ' RANGE OF INDICES IN COPY2 PROC ',me,' LINE ',
c     *    current_line 
c      write(6,*) ' Array1 :', na1, na2   
c      write(6,*) ' Array2 :', nb1, nb2   

      noff = 0 ! This routine stricktly copies one array into another 

      if (na1 .ne. nb1) then 
          write(6,*) ' Error in copy_ff. Arrays have different sizes ',
     *                 na1, nb1  
         call abort_job()
      endif 

      if (na2 .ne. nb2) then 
          write(6,*) ' Error in copy_ff. Arrays have different sizes ',
     *                 na2, nb2 
         call abort_job()
      endif 

      if (n1 .ne. n2) then 
          write(6,*) ' Error in copy_ff. Arrays have different sizes ',
     *                 n1, n2 
         call abort_job()
      endif 

      do b = 1, n2  
         do a = 1, n1  
            array2(a,b) = array1(a,b)
c           write(6,*) ' COPYFF:', a+noff, b, array1(a,b), 
c    *                                        array2(a,b) 
         enddo
      enddo

100   continue 

      return
      end

C This routine expands a triangularly packed vector of numbers
C into a square matrix.
C
C  WPACK((NDIM*(NDIM+1))/2) ==> WFULL(NDIM,NDIM)

      SUBROUTINE EXPND2(WPACK,WFULL,NDIM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION WPACK((NDIM*(NDIM+1))/2),WFULL(NDIM,NDIM)
#ifdef _ASSERT
      if (ndim.lt.0) then
         print *, '@EXPND2: Assertion failed.'
         print *, '         ndim = ',ndim
         call errex
      end if
#endif /* _ASSERT */
      ITHRU = 0
      DO I = 1, NDIM
         DO J = 1, I
            ITHRU = ITHRU + 1
            WFULL(I,J) = WPACK(ITHRU)
            WFULL(J,I) = WPACK(ITHRU)
         END DO
      END DO
      RETURN
      END

C Computes chemical shieldings and anisotropies from the chemical shielding
C tensors.

C Also Print the total shielding tensor and the orientation of the 
C shielding tensor. Added by Ajith 04/96 in accordence with many pepole
C who extensively use ACESII NMR capabilities (Don Chesnut, Jim Franz, 
C Dewey Barich and Jim Haw...).

      SUBROUTINE NMR1(CSHIFT,SHIFT,ANISOT, RANGE, NREAL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      LOGICAL YESNO,PRINT
      DOUBLE PRECISION DWORK(8), DTMP(3)
      INTEGER ADD_I, ADD_J, NDX_I, NDX_J

#include "mxatms.par"
      DIMENSION CSHIFT(9,NREAL),SHIFT(NREAL),ANISOT(NREAL),
     &          RANGE(NREAL)
      DIMENSION NORD(MXATMS*2),BUF(9), TMP(3,3)
C     
#include "cbchar.com"
#include "coord.com"
C
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C     
      DATA THIRD /0.333333333333333D0/
      DATA HALF  /0.5D0/
C     
C Print the orientation of the molecule again for convenient 
C interpretation of NMR shielding tensors.
C
      IONE = 1 
C
      CALL GETREC(20, 'JOBARC', 'NREALATM', IONE, NREAL)
      CALL DUMPCORD(NREAL, Q, IATNUM)
C
      DO 2000 ITYPE = 1, 2
C     
         IF(ITYPE.EQ.1) THEN
            INQUIRE(FILE='CSHIFT', EXIST=YESNO)
         ELSE
            INQUIRE(FILE='CSHIFTSCF', EXIST=YESNO)
         ENDIF
C     
         PRINT=.FALSE.
         IF(IFLAGS(1).GE.10)PRINT=.TRUE.
C     
         IF (YESNO) THEN
C     
C GET INFORMATION ABOUT ATOMIC ORDERING
C     
            CALL GETREC(20,'JOBARC','DUMSTRIP',NATOMS,NORD)
            CALL GETREC(20,'JOBARC','MAP2ZMAT',NATOMS,NORD(NATOMS+1))

            IF(ITYPE.EQ.1) THEN
               OPEN(UNIT=90,FILE='CSHIFT',FORM='FORMATTED',
     &              STATUS='OLD')
            ELSE
               OPEN(UNIT=90,FILE='CSHIFTSCF',FORM='FORMATTED',
     &              STATUS='OLD')
            ENDIF
C     
C READ IN THE CHEMICAL SHIELDING TENSOR
C     
            JBOT=1
C
            DO 10 I = 1, NREAL
C
               JZ  = NORD(NATOMS + I)
               JZ0 = NORD(JZ)
C
               READ(90, '((3F20.10))') (CSHIFT(J,JZ0),J = 1, 9)
C     
C SYMMETRIZE MATRIX
C     
               CALL SYMMET2(CSHIFT(1,JZ0), 3)
C     
C COMPUTE ISOTROPIC CHEMICAL SHIELDING ( 1/3 TR)
C     
               SHIFT(JZ0) = THIRD*(CSHIFT(1,JZ0) + CSHIFT(5,JZ0) + 
     &                       CSHIFT(9,JZ0))
C     
C DIAGONALIZE TO GET ANISOTROPY
C
cYAU 20001127
c old:
c               CALL EIG2(BUF,CSHIFT(1,JZ0),3,3,-1)
c new:
               CALL DSYEV('V','L',3,CSHIFT(1,JZ0),3,BUF,DWORK,8,INFO)
               IF (INFO.NE.0) THEN
                  WRITE(*,*)
     & '@NMR1: There was a problem diagonalizing the matrix.'
                  CALL ERREX
               END IF
               DO NDX_I = 1, 2
                  DO NDX_J = NDX_I+1, 3
                     IF ( BUF(NDX_I) .LT. BUF(NDX_J) ) then
                        DTMP(1)    = BUF(NDX_I)
                        BUF(NDX_I) = BUF(NDX_J)
                        BUF(NDX_J) = DTMP(1)
                        ADD_I   = 3*NDX_I
                        DTMP(1) = CSHIFT(ADD_I-2,JZ0)
                        DTMP(2) = CSHIFT(ADD_I-1,JZ0)
                        DTMP(3) = CSHIFT(ADD_I  ,JZ0)
                        ADD_J               = 3*NDX_J
                        CSHIFT(ADD_I-2,JZ0) = CSHIFT(ADD_J-2,JZ0)
                        CSHIFT(ADD_I-1,JZ0) = CSHIFT(ADD_J-1,JZ0)
                        CSHIFT(ADD_I  ,JZ0) = CSHIFT(ADD_J  ,JZ0)
                        CSHIFT(ADD_J-2,JZ0) = DTMP(1)
                        CSHIFT(ADD_J-1,JZ0) = DTMP(2)
                        CSHIFT(ADD_J  ,JZ0) = DTMP(3)
                     END IF
                  END DO
               END DO
c :end
cYAU
C
               IF (ITYPE .EQ. 2) THEN
                  WRITE (6, 2005) 
               ELSE
                  WRITE (6, 2006)
               ENDIF           
C
C Write the principal values of the shielding tensor.
C     
               CALL ZERO(TMP, 9)
               DO 5 III = 1, 3
                  TMP(III, III) = BUF(III)
 5             CONTINUE
C
               CALL CSHIFTPRI(TMP(1,1), JZ0)
C     
               IF (ITYPE .EQ. 2) THEN
                  WRITE (6, 2008) 
               ELSE
                  WRITE (6, 2009)
               ENDIF           
C     
C Write orientation of the shielding tensor.
C
               CALL CSHIFTPRI(CSHIFT(1, JZ0), JZ0)
C     
               IF (PRINT) WRITE(6,2001) JZ0, BUF
C     
               ANISOT(JZ0) = BUF(1) - HALF*(BUF(2)+BUF(3))
               RANGE(JZ0) = BUF(1) - BUF(3)
C     
 10         CONTINUE
C     
            WRITE (6, 999)
C     
            WRITE (6,1000)
C
            IF (ITYPE.EQ.2) THEN
               WRITE(6,1001)
            ELSE
               IF(IFLAGS(2).EQ.0) THEN
                  WRITE(6,1001)
               ELSE IF(IFLAGS(2).EQ.1) THEN
                  WRITE(6,10001)
               ELSE IF(IFLAGS(2).EQ.2) THEN
                  WRITE(6,10011)
               ELSE IF(IFLAGS(2).EQ.3) THEN
                  WRITE(6,10013)
               ELSE IF(IFLAGS(2).EQ.4) THEN
                  WRITE(6,10014)
               ELSE IF(IFLAGS(2).EQ.8) THEN
                  WRITE(6,10015)
               ELSE IF(IFLAGS(2).EQ.23) THEN
                  WRITE(6,10016)
               ELSE IF(IFLAGS(2).EQ.10) THEN
                  WRITE(6,10017)
               ELSE
                  CALL ERREX
               ENDIF
            ENDIF

            WRITE(6,1000)
            WRITE(6,1002)
            WRITE(6,1000)
C
            IOFF=0
            DO 20 I=1,NREAL
C     
C SOMEWHAT A HASSLE TO GET THE CORRECT ATOMIC NUMBER, HOWEVER IT WORKS
C     
               WRITE(6,1003)I, ZSYM(I), SHIFT(I), ANISOT(I), RANGE(I)
C
 20         CONTINUE
C
            WRITE(6,1000)
            CLOSE(UNIT=90, STATUS='KEEP')
C
         ELSE
C
            IF (ITYPE .EQ. 1) THEN    
               WRITE(6,1004)
               CALL ERREX
            ENDIF
C
         ENDIF
C     
 2000 CONTINUE
C      
      RETURN
C     
 999  FORMAT(/)
 1000 FORMAT(T3,72('-'))
 1001 FORMAT(T6,'SCF Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10001 FORMAT(T4,'MBPT(2) Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10011 FORMAT(T4,'MBPT(3) Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10013 FORMAT(T4,'SDQ-MBPT(4) Nuclear Magnetic Resonance Shieldings ',
     &   'and Anisotropies')
10014 FORMAT(T4,'MBPT(4) Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10015 FORMAT(T4,'CCD Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10016 FORMAT(T4,'QCISD Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10017 FORMAT(T4,'CCSD Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
10012 FORMAT(T4,'CCSD-EH Nuclear Magnetic Resonance Shieldings and ',
     &   'Anisotropies')
 1002 FORMAT(T5,'Z-matrix',T19,'Atomic',T31,'Chemical Shielding',
     &   T53,'Anisotropy',T69, 'Range',/,T6,'Center',T19,'Symbol',
     &   T37,'(ppm)',T55,'(ppm)', T69, '(ppm)')
 1003 FORMAT(T7,I2,T21,A3,T33,F10.3,T51,F10.3, T65, F10.3)
 1004 FORMAT(T3,'@NMR1-F, File CSHIFT not found on disk.')
 2001 FORMAT(T3,I3,3F20.10)
C     
 2005 FORMAT(/,'  Principal values of the shielding tensor (SCF):',/)
 2006 FORMAT(/,'  Principal values of the shielding tensor (MBPT(2)):',
     &   /)
 2008 FORMAT(/,'  Orientation of the SCF shielding tensor:',/)
 2009 FORMAT(/,'  Orientation of the MBPT(2) shielding tensor:',/)
C     
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_SP2_PAIR_NBO
     +
     +                    ( NBAS,
     +                      P,
     +                      XVEC,
     +
     +                            HA,HB,
     +                            SA,PA,
     +                            SB,PB )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_SP2_PAIR_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine forms a pair of linear sp2 combinations
C                from two sets of three input NBOs (1 totally symmetric
C                s-type NBO and two p-type NBOs). The sp2 combinations
C                formed are as follows:
C
C
C                         ha1  =  m * sa + 2n * pax
C                         ha2  =  m * sa -  n * pax + q * pay
C                         ha3  =  m * sa -  n * pax - q * pay
C
C                         hb1  =  m * sb + 2n * pbx
C                         hb2  =  m * sb -  n * pbx + q * pby
C                         hb3  =  m * sb -  n * pbx - q * pby
C
C                where:
C                                 m = 1 / sqrt (3)
C                                 n = 1 / sqrt (6)
C                                 q = 1 / sqrt (2)
C
C
C                The final pair of sp2 combinations is such that their
C                main directional lobes corresponding to ha1 and hb1
C                are either eclipsed or in anti position. How is that
C                achieved? Suppose the incomming px and py functions
C                of both input NBO sets are already ordered such that
C                their lobes match and form rectangular angles between
C                them (px is labeled as 'x' and py is labeled as '*'):
C
C
C                                                  x
C                       x  *                       *
C                        x *    x                  x
C                         x* x                     *
C                    ******x******   ---->   x**x**x**x**x
C                        x *x                      *
C                     x    * x                     x
C                          *  x                    *
C                                                  x
C
C
C                For each of the px,py pairs there are thus 4 different
C                ways to form the main directional lobe hybrid (ha1 and
C                hb1), depending on where the sp2 lobe will point to:
C                +x axis, -x axis, +y axis and -y axis. Mathematically
C                this would correspond to a sign change and px <-> py
C                interchange when forming ha1 (or hb1):
C
C
C                     ha1  =  m * sa + 2n * pax
C                     ha1  =  m * sa - 2n * pax   (sign)
C                     ha1  =  m * sa + 2n * pyx   (px <-> py)
C                     ha1  =  m * sa - 2n * pyx   (sign and px <-> py)
C
C
C                We now form the occupation matrix element PH between
C                both ha1 and hb1. Of the total of 16 possible values
C                (4 x 4 for the 4 ha1 and 4 hb1 orientations), only
C                those corresponding to the eclipsed and anti positions
C                between ha1 and hb1 will occur only once. To get a
C                unique orientation we will thus look for the largest
C                absolute non-degenerate value among all 16 possible
C                PH values. Once identified we form the rest of the
C                corresponding sp2 hybrids (ha2,ha3,hb2,hb3).
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    P            =  full NBAS x NBAS occupation matrix
C                                    in AO basis.
C                    XVEC         =  flp scratch array of vector type.
C                    SA           =  s-type NBO coefficient vector in
C                                    AO basis for first NBO triplet.
C                    PA           =  NBAS x 2 px- and py-type NBO
C                                    coefficient matrix in AO basis
C                                    for first NBO triplet.
C                    SB           =  s-type NBO coefficient vector in
C                                    AO basis for second NBO triplet.
C                    PB           =  NBAS x 2 px- and py-type NBO
C                                    coefficient matrix in AO basis
C                                    for second NBO triplet.
C
C
C                  Output:
C
C                    HA           =  3 x 3 matrix, containing the
C                                    sp2 hybridization coefficients:
C                                    1st column defines ha1, 2nd column
C                                    defines ha2, 3rd column defines ha3
C                                    in basis (rows): sa,pax,pay
C                    HB           =  3 x 3 matrix, containing the
C                                    sp2 hybridization coefficients:
C                                    1st column defines hb1, 2nd column
C                                    defines hb2, 3rd column defines hb3
C                                    in basis (rows): sb,pbx,pby
C                    SA           =  main directional lobe hybrid NBO
C                                    coefficient vector in AO basis
C                                    for first NBO triplet.
C                    PA           =  NBAS x 2 second and third hybrid
C                                    NBO coefficient matrix in AO basis
C                                    for first NBO triplet.
C                    SB           =  main directional lobe hybrid NBO
C                                    coefficient vector in AO basis
C                                    for second NBO triplet.
C                    PB           =  NBAS x 2 second and third hybrid
C                                    NBO coefficient matrix in AO basis
C                                    for second NBO triplet.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ABORT
         LOGICAL     ALERT
         LOGICAL     EQUAL

         INTEGER     CASE
         INTEGER     K,L,M,N
         INTEGER     NBAS
         INTEGER     PXA,PXB,PYA,PYB

         INTEGER     HYB  (1:2 )
         INTEGER     POSA (1:16)
         INTEGER     POSB (1:16)

         DOUBLE PRECISION  E,F,G
         DOUBLE PRECISION  MA,NA,QA,MB,NB,QB
         DOUBLE PRECISION  PHK,PHL
         DOUBLE PRECISION  SGA,SGB
         DOUBLE PRECISION  SQR3TH,SQR6TH,SQR2TH
         DOUBLE PRECISION  SYMACC
         DOUBLE PRECISION  X,Y,Z
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  PARA (1:16  )
         DOUBLE PRECISION  PARB (1:16  )
         DOUBLE PRECISION  PH   (1:16  )
         DOUBLE PRECISION  SA   (1:NBAS)
         DOUBLE PRECISION  SB   (1:NBAS)
         DOUBLE PRECISION  XVEC (1:NBAS)

         DOUBLE PRECISION  HA   (1:3,1:3)
         DOUBLE PRECISION  HB   (1:3,1:3)

         DOUBLE PRECISION  P    (1:NBAS,1:NBAS)
         DOUBLE PRECISION  PA   (1:NBAS,1:2   )
         DOUBLE PRECISION  PB   (1:NBAS,1:2   )

         PARAMETER   (ZERO   = 0.D0                                   )
         PARAMETER   (SYMACC = 1.D-10                                 )
         PARAMETER   (SQR3TH = 0.57735026918962576450914878050195750D0)
         PARAMETER   (SQR6TH = 0.40824829046386301636621401245098191D0)
         PARAMETER   (SQR2TH = 0.70710678118654752440084436210484909D0)

         DATA  PARA  /+1.D0,+1.D0,+1.D0,+1.D0,+1.D0,+1.D0,+1.D0,+1.D0,
     +                -1.D0,-1.D0,-1.D0,-1.D0,-1.D0,-1.D0,-1.D0,-1.D0/
         DATA  POSA  /  1  ,  1  ,  1  ,  1  ,  2  ,  2  ,  2  ,  2  ,
     +                  1  ,  1  ,  1  ,  1  ,  2  ,  2  ,  2  ,  2  /
         DATA  PARB  /+1.D0,+1.D0,-1.D0,-1.D0,+1.D0,+1.D0,-1.D0,-1.D0,
     +                +1.D0,+1.D0,-1.D0,-1.D0,+1.D0,+1.D0,-1.D0,-1.D0/
         DATA  POSB  /  1  ,  2  ,  1  ,  2  ,  1  ,  2  ,  1  ,  2  ,
     +                  1  ,  2  ,  1  ,  2  ,  1  ,  2  ,  1  ,  2  /
C
C
C------------------------------------------------------------------------
C
C
C             ...form the 16 occupation matrix elements between
C                the main directional lobe hybrids.
C
C
         DO CASE = 1,16

            SGA = PARA (CASE)
            SGB = PARB (CASE)
            PXA = POSA (CASE)
            PXB = POSB (CASE)

            IF (MOD (CASE,4).EQ.1) THEN
                DO N = 1,NBAS
                   E = SQR3TH * SA (N)
                   F = SGA * SQR6TH * PA (N,PXA)
                   XVEC (N) = E + F + F
                END DO
            END IF

            Z = ZERO
            DO L = 1,NBAS
               X = ZERO
               DO K = 1,NBAS
                  X = X + XVEC (K) * P (K,L)
               END DO
               E = SQR3TH * SB (L)
               F = SGB * SQR6TH * PB (L,PXB)
               Y = E + F + F
               Z = Z + X * Y
            END DO

            PH (CASE) = Z

         END DO
C
C
C             ...identify those non-degenerate occupation matrix
C                elements corresponding to the eclipsed and anti
C                positions of the main directional lobe hybrids.
C
C
         M = 0

         DO K = 1,15
            PHK = PH (K)
            IF (PHK.NE.ZERO) THEN
                EQUAL = .FALSE.
                DO L = K+1,16
                   PHL = PH (L)
                   IF (ABS (PHK-PHL).LT.SYMACC) THEN
                       EQUAL = .TRUE.
                       PH (L) = ZERO
                   END IF
                END DO
                IF (.NOT.EQUAL) THEN
                    M = M + 1
                    HYB (M) = K
                END IF
            END IF
         END DO

         IF (PH (16).NE.ZERO) THEN
             M = M + 1
             HYB (M) = 16
         END IF
C
C
C             ...ideally only 2 out of the 16 occupation matrix
C                elements were found. If none were found, we have
C                an accidental degeneracy problem and we must stop.
C                If more than 2 were found, we have an accuracy
C                problem, but the program can still try to continue.
C
C
         ABORT = M .EQ. 0
         ALERT = M .GT. 2

         IF (ABORT) THEN
             WRITE (*,*) ' Problem in sp2 hybrid orientation! '
             WRITE (*,*) ' Cannot find unique orientation! '
             WRITE (*,*) ' nlo__form_sp2_pair_nbo '
             WRITE (1,*) ' Problem in sp2 hybrid orientation! '
             WRITE (1,*) ' Cannot find unique orientation! '
             WRITE (1,*) ' nlo__form_sp2_pair_nbo '
             STOP
         END IF

         IF (ALERT) THEN
             WRITE (*,*) ' Floppy sp2 hybrid orientation! '
             WRITE (*,*) ' Will proceed ... '
             WRITE (1,*) ' Floppy sp2 hybrid orientation! '
             WRITE (1,*) ' Will proceed ... '
         END IF

C         WRITE (*,*) ' Hybrids = ',(HYB(K),K=1,M)
C
C
C             ...the maximum of the surviving 2 occupation matrix
C                elements is chosen and the corresponding sign
C                changes and/or px <-> py interchanges determined.
C
C
         K = HYB (1)
         L = HYB (2)
         PHK = ABS (PH (K))
         PHL = ABS (PH (L))

         X = MAX (PHK,PHL)
         IF (X.EQ.PHK) THEN
             CASE = K
         ELSE
             CASE = L
         END IF

         SGA = PARA (CASE)
         SGB = PARB (CASE)
         PXA = POSA (CASE)
         PXB = POSB (CASE)

         MA = SQR3TH
         NA = SGA * SQR6TH
         QA = SGA * SQR2TH
         MB = SQR3TH
         NB = SGB * SQR6TH
         QB = SGB * SQR2TH
C
C
C             ...form the hybridization matrices.
C
C
         IF (PXA.EQ.1) THEN
             PYA = 2
             HA (1,1) = MA
             HA (2,1) = NA + NA
             HA (3,1) = ZERO
             HA (1,2) = MA
             HA (2,2) = - NA
             HA (3,2) = QA
             HA (1,3) = MA
             HA (2,3) = - NA
             HA (3,3) = - QA
         ELSE
             PYA = 1
             HA (1,1) = MA
             HA (2,1) = ZERO
             HA (3,1) = NA + NA
             HA (1,2) = MA
             HA (2,2) = QA
             HA (3,2) = - NA
             HA (1,3) = MA
             HA (2,3) = - QA
             HA (3,3) = - NA
         END IF

         IF (PXB.EQ.1) THEN
             PYB = 2
             HB (1,1) = MB
             HB (2,1) = NB + NB
             HB (3,1) = ZERO
             HB (1,2) = MB
             HB (2,2) = - NB
             HB (3,2) = QB
             HB (1,3) = MB
             HB (2,3) = - NB
             HB (3,3) = - QB
         ELSE
             PYB = 1
             HB (1,1) = MB
             HB (2,1) = ZERO
             HB (3,1) = NB + NB
             HB (1,2) = MB
             HB (2,2) = QB
             HB (3,2) = - NB
             HB (1,3) = MB
             HB (2,3) = - QB
             HB (3,3) = - NB
         END IF
C
C
C             ...form the final sp2 hybrid functions.
C
C
         DO N = 1,NBAS
            E = MA * SA (N)
            F = NA * PA (N,PXA)
            G = QA * PA (N,PYA)
            SA (N)   = E + F + F
            PA (N,1) = E - F + G
            PA (N,2) = E - F - G
         END DO

         DO N = 1,NBAS
            E = MB * SB (N)
            F = NB * PB (N,PXB)
            G = QB * PB (N,PYB)
            SB (N)   = E + F + F
            PB (N,1) = E - F + G
            PB (N,2) = E - F - G
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine prequest_block(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table,nblock_map_table,
     *                      op, instruction_timer, comm_timer, 
     *                      direct_flag)
c----------------------------------------------------------------------------
c   Handles processing of a "prequest" instruction (partial request of a 
c   block of a served array).  The form of this instruction is
c      
c   prequest T(a,i,b,j) = S(a,p,b,q), where
c      T(a,i,b,j) contains the requested data to be transferred from server.
c      S(a,p,b,q) is the server-resident block from which to get the data.
c      a,p,b,q are declared indices of the served array S.
c      i, j are declared as "index" and are used to select the slice of
c           data to be transferred.     
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_barrier_data.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry,
     *                           nblock_map_table)
      integer instruction_timer, comm_timer
      logical direct_flag

      integer i, j, k
      integer nind, nind2
      integer ierr, handle, source_array, status(MPI_STATUS_SIZE)
      integer response_req, request, get_block_request
      integer blk, blkndx, mgr
      integer blocksize
      integer*8 indblk, get_block_index
      integer stack
      integer find_block_destination
      integer ind(mx_array_index), seg(mx_array_index)
      integer ind2(mx_array_index), seg2(mx_array_index)
      integer saveseg(mx_array_index)

      integer msg(len_sip_server_prequest, mx_msg)
      integer imsg, find_free_msg_buffer
      integer mx_msg_used
      integer nseg2, jseg, source_type

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      integer nxt
      integer f_form_msg_tag2, tag
      integer flag

      save msg

      mx_msg_used = mx_msg
#ifdef ALTIX
      dptr = dshptr
c      mx_msg_used = min(mx_msg, 100)
#endif
      handle       = op(c_result_array)
      source_array = op(c_op1_array)
      source_type = array_table(c_array_type, source_array)
      if (source_type .ne. served_array) then
         print *,'Error: Source array in prequest must be a ',
     *           'served array.'
         call abort_job() 
      endif

c------------------------------------------------------------------------
c   Make sure the requested block exists.  create_current_block will
c   create the block if it does not exist, and simply return if the 
c   block is already present.
c------------------------------------------------------------------------

      call create_current_block(handle,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., direct_flag, blk, ierr)
      blkndx = ierr
 
c--------------------------------------------------------------------------
c   Check the block_request_outstanding_flag.
c   If a previous request instruction on this block has not been satisfied,
c   there is no need to process the current request.
c--------------------------------------------------------------------------

      call get_block_request_outstanding_flag(handle,blk, blkndx,
     *                                       flag)
      if (flag .ne. 0) return

c---------------------------------------------------------------------------
c   Check the block_persistence_flag.  If it is already turned on, the
c   block is available from a previous access, and there is no need to
c   request it again.
c---------------------------------------------------------------------------

      call get_block_persistence_flag(handle, blk, blkndx, flag)
      if (flag .ne. 0) then
         call set_opblock(handle, blk, blkndx, op)
         call set_block_computed_flag(handle, blk, blkndx, 1)
         return
      endif
      
c------------------------------------------------------------------------
c   Pick up the current indices and segments of the arrays.
c------------------------------------------------------------------------

      nind = array_table(c_nindex, handle)
      do i = 1, nind
         ind(i) = array_table(c_index_array1+i-1,handle)
         seg(i) = index_table(c_current_seg,ind(i))
      enddo

      nind2 = array_table(c_nindex, source_array)
      do i = 1, nind2
         ind2(i) = array_table(c_index_array1+i-1,source_array)
      enddo

      if (nind .ne. nind2) then
         print *,'Error in prequest: Arrays must have the same ',
     *           'number of indices.'
         print *,'Array 1 has ',nind,' indices, array 2 has ',
     *            nind2,' indices.'
         call abort_job()
      endif

c-----------------------------------------------------------------------
c  Find the non-matching indices of the 2 arrays.
c-----------------------------------------------------------------------

      do i = 1, nind
         saveseg(i) = index_table(c_current_seg,ind2(i)) ! save for later restoration.
         if (ind(i) .eq. ind2(i)) then
            seg2(i) = seg(i)
         else
            
c------------------------------------------------------------------------
c   Indices do not match.  Find the segment of the source array which 
c   contains the value of the segment for "handle".
c------------------------------------------------------------------------

            nseg2 = index_table(c_nsegments,ind2(i))
            do jseg = 1, nsegment_table
               if (segment_table(c_index,jseg) .eq. ind2(i)) then
                  k = jseg
                  go to 100
               endif
            enddo

  100       continue
            do j = k, k+nseg2-1
               if (segment_table(c_range1,j) .le. seg(i) .and.
     *             segment_table(c_range2,j) .ge. seg(i)) then
                  seg2(i) = segment_table(c_segment,j)
                  go to 200
               endif
            enddo 
  200       continue 
         endif
      enddo
 
c------------------------------------------------------------------------
c   Change the "current_seg" field of each index of the source array.
c------------------------------------------------------------------------

      do i = 1, nind2
         index_table(c_current_seg,ind2(i)) = seg2(i)
      enddo
      
c-------------------------------------------------------------------------
c   Find the served array block containing the indices of the target array.
c-------------------------------------------------------------------------

      mgr = find_block_destination(source_array,  
     *               array_table, narray_table, 
     *               index_table, nindex_table,
     *               block_map_table, nblock_map_table)

c--------------------------------------------------------------------------
c   Build and send the request message to the mgr.
c--------------------------------------------------------------------------

      imsg = find_free_msg_buffer(server_requests, mx_msg_used, 
     *                 instruction_timer, comm_timer)
      msg(1,imsg) = sip_server_prequest
      msg(2,imsg) = source_array
      msg(3,imsg) = nind
      tag    = f_form_msg_tag2()
      msg(4,imsg) = tag
      msg(5,imsg) = current_line
      msg(6,imsg) = op(c_server_stat_key)
      nxt = 7 
      do i = 1, mx_array_index
         if (i .le. nind) then
            msg(nxt,imsg) = ind(i)
         else
            msg(nxt,imsg) = 0
         endif
         nxt = nxt + 1
      enddo

      do i = 1, nind
         call get_index_segment(ind(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, msg(nxt,imsg), 
     *                             msg(nxt+1,imsg))
         nxt = nxt + 2
      enddo

      do i = nind+1, mx_array_index
         msg(nxt,imsg)   = 0
         msg(nxt+1,imsg) = 0
         nxt = nxt + 2
      enddo

      do i = 1, mx_array_index
         if (i .le. nind) then
            msg(nxt,imsg) = ind2(i)
         else
            msg(nxt,imsg) = 0
         endif
         nxt = nxt + 1
      enddo

      do i = 1, nind
         call get_index_segment(ind2(i), seg2(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, msg(nxt,imsg), 
     *                             msg(nxt+1,imsg))
         nxt = nxt + 2
      enddo

      do i = nind+1, mx_array_index
         msg(nxt,imsg)   = 0
         msg(nxt+1,imsg) = 0
         nxt = nxt + 2
      enddo

      call mpi_isend(msg(1,imsg), len_sip_server_prequest, mpi_integer,
     *               mgr, sip_server_message,
     *                 mpi_comm_world, server_requests(imsg), ierr)

c-------------------------------------------------------------------------
c   Post a recv for the block of data.
c   Check if the block is engaged in ongoing communication first.
c-------------------------------------------------------------------------

      call get_actual_blocksize(handle, blk, blkndx,
     *                  array_table, narray_table,
     *                  index_table, nindex_table, 
     *                  segment_table, nsegment_table, blocksize)
      stack  = array_table(c_array_stack,handle)
      indblk = get_block_index(handle, blk, stack, blkndx, x, .true.)

      request = get_block_request(handle, blk, blkndx)
      if (request .ne. MPI_REQUEST_NULL) 
     *   call wait_on_block(handle, blk, blkndx, served_array, request,
     *             instruction_timer, comm_timer)
 
      call mpi_irecv(x(indblk), blocksize, mpi_double_precision,
     *               mgr, tag, mpi_comm_world,
     *               request, ierr)
      call set_block_request(handle, blk, blkndx, request)
      if (request .ne. MPI_REQUEST_NULL) then
         call set_block_request_outstanding_flag(handle, blk, blkndx)
         call blkmgr_insert_block_in_list(comm_list_head, 
     *             comm_list_tail, blkndx, c_comm_list_ptr,
     *             .true.)
      endif

c----------------------------------------------------------------------------
c   Set the block_computed_flag.
c----------------------------------------------------------------------------

      call get_block_computed_flag(handle, blk, blkndx, flag)
      if (flag .eq. 0) then
         call get_block_created_flag(handle, blk, blkndx, flag)
         if (flag .eq. 0) then
            call set_opblock(handle, blk, blkndx, op)
            call set_block_computed_flag(handle, blk, blkndx, 1)

c--------------------------------------------------------------------------
c   Set the block_persistence_flag.  This guarantees that the block will
c   remain available as long as possible before having to do an actual
c   new request from it's "home" server.
c
c   Setting the flag also updates its age, which is used in the allocation
c   scheme.
c--------------------------------------------------------------------------

            call set_block_persistence_flag(handle, blk, blkndx, 1)
            call blkmgr_insert_block_in_list(persistent_list_head,
     *          persistent_list_tail, blkndx, c_persistent_ptr,
     *          .true.)

c--------------------------------------------------------------------------
c   Set the block request flag for possible monitoring.
c--------------------------------------------------------------------------

            call set_block_request_flag(handle, blk, blkndx, 1)
         endif
      endif

c--------------------------------------------------------------------------
c   Restore the original values of the source_array's indices.
c--------------------------------------------------------------------------

      do i = 1, nind2
         index_table(c_current_seg,ind2(i)) = saveseg(i)
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine f_strtoken(source, delim, token)
c--------------------------------------------------------------------------
c   Returns the next token delimited by the character "delim".
c   If no delimiter is found, the NULL character is returned 
c   in "token".
c---------------------------------------------------------------------------
      implicit none
      character*(*) source, token
      character delim

      integer i, istart, istart2 

      character*256 src_save
      integer iptr, nsave 

      save src_save, iptr, nsave

      if (source(1:1) .eq. char(0)) then
c         print *,'Start from src_save : ',src_save(istart:nsave)
         istart = iptr
      else
         src_save = source
         istart = 1
         nsave  = len(source)
      endif

      token = ' '   ! blank-fill return argument.

c---------------------------------------------------------------------------
c   Skip past beginning whitespace.
c---------------------------------------------------------------------------

      do i = istart, nsave
         if (src_save(i:i) .ne. ' ' .and.
     *       src_save(i:i) .ne. char(0)) then
            istart2 = i
            go to 100
         endif
      enddo

c---------------------------------------------------------------------------
c   No non-blank, non-null characters exist.  Return a null.
c---------------------------------------------------------------------------

c      print *,'Return NULL token (#1)'
      token(1:1) = char(0)
      return
      
  100 continue
      do i = istart2, nsave
         if (src_save(i:i) .eq. delim) then

c---------------------------------------------------------------------------
c   We have a match.  Store the data in "token".
c---------------------------------------------------------------------------

            if (istart2 .eq. i) then
               token(1:1) = char(0)
c               print *,'Return NULL token (#2)'
            else
               token(1:i-istart2) = src_save(istart2:i-1) 
            endif

            iptr = i + 1   ! Next starting string.
            return
         endif
      enddo

c---------------------------------------------------------------------------
c   No more tokens.  Return a NULL.
c---------------------------------------------------------------------------

      token(1:1) = char(0) 
c      print *,'Return NULL token (#3)'
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine joda_post_processing(jodadone)
c----------------------------------------------------------------------------
c   Performs post-gradient/hessian processing which was done in joda in the 
c   previous serial ACES II implementation.  Returns jodadone = 0 if 
c   convergence is not achieved, 1 if the process has converged (or if we
c   have a single-point energy calculation).
c----------------------------------------------------------------------------

      implicit none
      integer jodadone

      integer dummy, nforcecon

c      call aces_ja_init()
c      call iputrec(1,'JOBARC','FIRSTRUN',1,0)
c      call iputrec(1,'JOBARC','DIRTYFLG',1,1)
c      call geopt(jodadone)
c      call aces_ja_fin()

      call aces2_joda_main()
      call aces_ja_init()
      call igetrec(1, 'JOBARC', 'JODADONE',  1, jodadone)
c      if (jodadone .eq. 0) then

c--------------------------------------------------------------------------
c   For VIB_FINDIF=EXACT calculations, joda doesn't set the jodadone flag.
c   Instead, we check to see if the FORCECON record is on JOBARC.
c---------------------------------------------------------------------------

c         call igetrec(0, 'JOBARC', 'FORCECON', nforcecon, dummy)
c         if (nforcecon .gt. 0) jodadone = 1
c         print *,'JODA_POST_PROCESSING: nforcecon, jodadone ',
c     *       nforcecon, jodadone
c      endif

      call aces_ja_fin()
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE REFLECT(A,SCRATCH,NATOM,IPLANE)
C
C REFLECTS POINTS IN PLANE
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(3,NATOM),SCRATCH(3,NATOM)
C
      IX(I,J)=MIN(I,J)/MAX(I,J)
C
      DO 10 I=1,NATOM
         DO 10 J=1,3
 10         SCRATCH(J,I)=A(J,I)*(1.D0-2.D0*IX(IPLANE,J))
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__CTR_4INDEX_REORDER
     +
     +                    ( NXYZT,NCTR,
     +                      NCGTOR,NCGTOS,NCGTOT,NCGTOU,
     +                      IXOFFI,IXOFFJ,IXOFFK,IXOFFL,
     +                      X,
     +
     +                             Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__CTR_4INDEX_REORDER
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine reorders the contraction indices r,s,t,u:
C
C                        x (nxyzt,rstu) --> y (nxyzt,ijkl)
C
C                such that the contraction indices correspond to the
C                final ordering of the integral batch.
C
C                The trick used to do a very general permutational
C                reordering without the need to write specific routines
C                for all possible 4!=24 cases, is to use predefined
C                index offsets, which contain implicitly the permutation
C                information. These index offsets allow one to
C                calculate the target address for each rstu index
C                quadruple using a simple multiplication formula,
C                which of course is here transformed into a repeated
C                summation form to save cpu time.
C
C
C                  Input:
C
C                      NXYZT      =  total # of cartesian monomial
C                                    quadruplets (invariant indices)
C                      NCTR       =  total # of contraction indices
C                      NCGTOx     =  # of contractions for contraction
C                                    shells x=R,S,T,U
C                      IXOFFx     =  index offsets for contraction
C                                    shells x=I,J,K,L
C                      X          =  original integral batch with
C                                    contraction shells in RSTU order
C
C                  Output:
C
C                      Y          =  new integral batch with contraction
C                                    shells in IJKL order
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     IJKL,JKL,KL,L,N
         INTEGER     IXOFFI,IXOFFJ,IXOFFK,IXOFFL
         INTEGER     NCGTOR,NCGTOS,NCGTOT,NCGTOU
         INTEGER     NCTR
         INTEGER     NXYZT
         INTEGER     R,S,T,U
         INTEGER     RSTU

         DOUBLE PRECISION  X (1:NXYZT,1:NCTR)
         DOUBLE PRECISION  Y (1:NXYZT,1:NCTR)
C
C
C------------------------------------------------------------------------
C
C
C             ...do the reordering. Target index IJKL is evaluated
C                from each R,S,T,U index quadruple using summations
C                only!
C
C
         RSTU = 0

         L = - IXOFFL + 1
         DO 100 U = 1,NCGTOU
            L = L + IXOFFL
            KL = L - IXOFFK
            DO 200 T = 1,NCGTOT
               KL = KL + IXOFFK
               JKL = KL - IXOFFJ
               DO 300 S = 1,NCGTOS
                  JKL = JKL + IXOFFJ
                  IJKL = JKL - IXOFFI
                  DO 400 R = 1,NCGTOR
                     IJKL = IJKL + IXOFFI
                     RSTU = RSTU + 1

                     DO N = 1,NXYZT
                        Y (N,IJKL) = X (N,RSTU)
                     END DO

  400             CONTINUE
  300          CONTINUE
  200       CONTINUE
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_DERV_PCD_INTEGRALS
     +
     +                    ( SHELLP,SHELLC,SHELLD,
     +                      DERC,DERD,
     +                      NGQEXQ,
     +                      EXP2C,EXP2D,
     +                      INT2D,
     +
     +                               OUT2D )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_DERV_PCD_INTEGRALS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single derivation step on
C                the input 2D PCD integrals:
C
C             I'(n,p,c,d) = delta (DERC,1) *
C                           [-c*I(n,p,c-1,d) + 2*expc(n)*I(n,p,c+1,d)]
C                         + delta (DERD,1) *
C                           [-d*I(n,p,c,d-1) + 2*expd(n)*I(n,p,c,d+1)]
C
C
C                and returns the result in a separate array.
C
C                The derivatives of the 2D integrals are calculated for
C                all roots and the present set of exponent quadruplets.
C                The values of DERC and DERD can be only 1 or 0. If
C                both are 1, then centers C and D are equal.
C
C
C                  Input:
C
C                    SHELLx      =  maximum shell type for centers
C                                   x = P,C,D after differentiation
C                    DERx        =  indicator, if differentiation is
C                                   to be performed with respect to
C                                   centers x = C,D. Two possible
C                                   values: 0 = no differentiation,
C                                   1 = differentiate, i.e. d/dx
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    EXP2x       =  the NGQEXQ exponents x 2 for both
C                                   centers x = C,D in the appropriate
C                                   order.
C                    INT2D       =  all input 2D PCD integrals before
C                                   differentiation.
C
C
C                  Output:
C
C                    OUT2D       =  all differentiated 2D PCD integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   FIRST

         INTEGER   C,D,N,P
         INTEGER   CM,CP,DM,DP
         INTEGER   DERC,DERD
         INTEGER   NGQEXQ
         INTEGER   SHELLP,SHELLC,SHELLD

         DOUBLE PRECISION  F
         DOUBLE PRECISION  NEGONE,NEGTWO

         DOUBLE PRECISION  EXP2C (1:NGQEXQ)
         DOUBLE PRECISION  EXP2D (1:NGQEXQ)

         DOUBLE PRECISION  INT2D (1:NGQEXQ,0:SHELLP,
     +                                     0:SHELLC+DERC,
     +                                     0:SHELLD+DERD)
         DOUBLE PRECISION  OUT2D (1:NGQEXQ,0:SHELLP,
     +                                     0:SHELLC,
     +                                     0:SHELLD)
         PARAMETER  (NEGONE = -1.D0)
         PARAMETER  (NEGTWO = -2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...derivative on center C (if any).
C
C
         FIRST = .TRUE.

         IF (DERC.EQ.1) THEN

           IF (SHELLC.EQ.0) THEN

             DO 100 D = 0,SHELLD
             DO 100 P = 0,SHELLP
             DO 100 N = 1,NGQEXQ
                OUT2D (N,P,0,D) = EXP2C (N) * INT2D (N,P,1,D)
  100        CONTINUE

           ELSE IF (SHELLC.EQ.1) THEN

             DO 110 D = 0,SHELLD
                DO 112 P = 0,SHELLP
                DO 112 N = 1,NGQEXQ
                   OUT2D (N,P,0,D) = EXP2C (N) * INT2D (N,P,1,D)
  112           CONTINUE
                DO 114 P = 0,SHELLP
                DO 114 N = 1,NGQEXQ
                   OUT2D (N,P,1,D) = EXP2C (N) * INT2D (N,P,2,D)
     +                                         - INT2D (N,P,0,D)
  114           CONTINUE
  110        CONTINUE

           ELSE

             DO 120 D = 0,SHELLD
                DO 122 P = 0,SHELLP
                DO 122 N = 1,NGQEXQ
                   OUT2D (N,P,0,D) = EXP2C (N) * INT2D (N,P,1,D)
  122           CONTINUE
                DO 124 P = 0,SHELLP
                DO 124 N = 1,NGQEXQ
                   OUT2D (N,P,1,D) = EXP2C (N) * INT2D (N,P,2,D)
     +                                         - INT2D (N,P,0,D)
  124           CONTINUE
                F = NEGTWO
                DO 126 C = 2,SHELLC
                   CM = C - 1
                   CP = C + 1
                   DO 128 P = 0,SHELLP
                   DO 128 N = 1,NGQEXQ
                      OUT2D (N,P,C,D) = EXP2C (N) * INT2D (N,P,CP,D)
     +                                        + F * INT2D (N,P,CM,D)
  128              CONTINUE
                   F = F + NEGONE
  126           CONTINUE
  120        CONTINUE

           END IF

           FIRST = .FALSE.

         END IF
C
C
C             ...derivative on center D (if any).
C
C
         IF (DERD.EQ.1) THEN

           IF (FIRST) THEN

             IF (SHELLD.EQ.0) THEN

                 DO 200 C = 0,SHELLC
                 DO 200 P = 0,SHELLP
                 DO 200 N = 1,NGQEXQ
                    OUT2D (N,P,C,0) = EXP2D (N) * INT2D (N,P,C,1)
  200            CONTINUE

             ELSE IF (SHELLD.EQ.1) THEN

                 DO 210 C = 0,SHELLC
                 DO 210 P = 0,SHELLP
                 DO 210 N = 1,NGQEXQ
                    OUT2D (N,P,C,0) = EXP2D (N) * INT2D (N,P,C,1)
  210            CONTINUE
                 DO 212 C = 0,SHELLC
                 DO 212 P = 0,SHELLP
                 DO 212 N = 1,NGQEXQ
                    OUT2D (N,P,C,1) = EXP2D (N) * INT2D (N,P,C,2)
     +                                          - INT2D (N,P,C,0)
  212            CONTINUE

             ELSE

                 DO 220 C = 0,SHELLC
                 DO 220 P = 0,SHELLP
                 DO 220 N = 1,NGQEXQ
                    OUT2D (N,P,C,0) = EXP2D (N) * INT2D (N,P,C,1)
  220            CONTINUE
                 DO 222 C = 0,SHELLC
                 DO 222 P = 0,SHELLP
                 DO 222 N = 1,NGQEXQ
                    OUT2D (N,P,C,1) = EXP2D (N) * INT2D (N,P,C,2)
     +                                          - INT2D (N,P,C,0)
  222            CONTINUE
                 F = NEGTWO
                 DO 224 D = 2,SHELLD
                    DM = D - 1
                    DP = D + 1
                    DO 226 C = 0,SHELLC
                    DO 226 P = 0,SHELLP
                    DO 226 N = 1,NGQEXQ
                       OUT2D (N,P,C,D) = EXP2D (N) * INT2D (N,P,C,DP)
     +                                         + F * INT2D (N,P,C,DM)
  226               CONTINUE
                    F = F + NEGONE
  224            CONTINUE

             END IF

           ELSE

             IF (SHELLD.EQ.0) THEN

                 DO 230 C = 0,SHELLC
                 DO 230 P = 0,SHELLP
                 DO 230 N = 1,NGQEXQ
                    OUT2D (N,P,C,0) = OUT2D (N,P,C,0) +
     +                                EXP2D (N) * INT2D (N,P,C,1)
  230            CONTINUE

             ELSE IF (SHELLD.EQ.1) THEN

                 DO 240 C = 0,SHELLC
                 DO 240 P = 0,SHELLP
                 DO 240 N = 1,NGQEXQ
                    OUT2D (N,P,C,0) = OUT2D (N,P,C,0) +
     +                                EXP2D (N) * INT2D (N,P,C,1)
  240            CONTINUE
                 DO 242 C = 0,SHELLC
                 DO 242 P = 0,SHELLP
                 DO 242 N = 1,NGQEXQ
                       OUT2D (N,P,C,1) = OUT2D (N,P,C,1) +
     +                                   EXP2D (N) * INT2D (N,P,C,2)
     +                                             - INT2D (N,P,C,0)
  242            CONTINUE

             ELSE

                 DO 250 C = 0,SHELLC
                 DO 250 P = 0,SHELLP
                 DO 250 N = 1,NGQEXQ
                    OUT2D (N,P,C,0) = OUT2D (N,P,C,0) +
     +                                EXP2D (N) * INT2D (N,P,C,1)
  250            CONTINUE
                 DO 252 C = 0,SHELLC
                 DO 252 P = 0,SHELLP
                 DO 252 N = 1,NGQEXQ
                       OUT2D (N,P,C,1) = OUT2D (N,P,C,1) +
     +                                   EXP2D (N) * INT2D (N,P,C,2)
     +                                             - INT2D (N,P,C,0)
  252            CONTINUE
                 F = NEGTWO
                 DO 254 D = 2,SHELLD
                    DM = D - 1
                    DP = D + 1
                    DO 256 C = 0,SHELLC
                    DO 256 P = 0,SHELLP
                    DO 256 N = 1,NGQEXQ
                       OUT2D (N,P,C,D) = OUT2D (N,P,C,D) +
     +                                   EXP2D (N) * INT2D (N,P,C,DP)
     +                                         + F * INT2D (N,P,C,DM)
  256               CONTINUE
                    F = F + NEGONE
  254            CONTINUE

             END IF

           END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine stack_distribution(optable, noptable,
     *                    array_table, narray_table,
     *                    index_table, nindex_table,
     *                    segment_table, nsegment_table,
     *                    scalar_table, nscalar_table,
     *                    block_map_table, nblock_map_table,
     *                    proctab, scr, nscr, nblk_overhead,
     *                    stack_blocksizes, nstacks, stack_blocks,
     *                    stack_algorithm_type, ncompany_procs,
     *                    niocompany, ierr, error_print_flag)
      implicit none
      include 'interpreter.h'
      include 'machine_types.h'
      include 'blkmgr.h'
      include 'mpif.h' 
      include 'dbugcom.h'

      integer noptable, narray_table, nindex_table, nsegment_table,
     *        nscalar_table, nblock_map_table, nscr, nstacks
      integer nblk_overhead
      integer nbytes_per_blk, nbytes_per_group
      integer optable(loptable_entry,noptable)
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      double precision scalar_table(nscalar_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer proctab(2,*), scr(nstacks,*)
      integer stack_blocksizes(nstacks)
      integer stack_blocks(nstacks)
      integer stack_line(nstacks)
      integer stack_algorithm_type
      integer niocompany
      integer ierr
      logical error_print_flag

      integer me, nprocs, mpierr
      integer i, j,k, ncompany_procs, my_company_rank, comm
      integer pst_get_company_comm
      integer nleft, total_blocks
      integer*8 noverhead_bytes, i8temp
      integer noverhead_words
      integer ngroups, nwords_per_group, nblocks_per_stack
      integer maxblk, need, have, surplus

      integer nresidual, nresidual_blocks
      integer nresidual_old
      integer*8 nwadd, nbadd
      integer new_workers, nworkers
      integer*8 total_for_job, total_words 
      double precision weight

      ierr = 0
      call mpi_comm_rank(mpi_comm_world, me, mpierr)
      call mpi_comm_size(mpi_comm_world, nprocs, mpierr)
      if (dbg) print *,'Determine stack distribution for task ',me 
      comm =  pst_get_company_comm(me)
      call mpi_comm_rank(comm, my_company_rank, mpierr)

c--------------------------------------------------------------------------
c   Zero out the block counters.
c--------------------------------------------------------------------------

      if (nscr .lt. noptable*nstacks) then
          print *,'Error: insufficient scratch memory in ',
     *        'stack_distribution: nscr ',nscr,' need ',
     *         noptable*nstacks
          call abort_job()
      endif

      do j = 1, noptable
         do i = 1, nstacks
            scr(i,j) = 0
         enddo
      enddo

c---------------------------------------------------------------------------
c   Make a pass simulating the optable execution to get an estimate of 
c   number of blocks of each type needed at each instruction line.
c---------------------------------------------------------------------------

      call optable_loop_sim(optable, noptable, array_table,
     *                   narray_table,
     *                   index_table, nindex_table,
     *                   segment_table, nsegment_table, block_map_table,
     *                   nblock_map_table,
     *                   scalar_table, nscalar_table, proctab, 
     *                   stack_blocksizes, scr, nstacks)

c---------------------------------------------------------------------------
c   Determine the max number of blocks needed for each stack type.
c---------------------------------------------------------------------------

      total_blocks = 0
      do i = 1, nstacks
         stack_blocks(i) = 0
         stack_line(i)  = 0
         do j = 1, noptable
            if (scr(i,j) .gt. stack_blocks(i)) then
               stack_blocks(i) = scr(i,j)
               stack_line(i)   = optable(c_lineno,j)
c               print *,'Task ',me,' New max. for stack ',i,' instr. ',
c     *           j,' opcode ',optable(c_opcode,j),' line ',
c     *           optable(c_lineno,j),' blocks = ',stack_blocks(i)
            endif
         enddo 

         total_blocks = total_blocks + stack_blocks(i)
      enddo
   
c------------------------------------------------------------------------
c   Make sure each stack has at least 1 block available.
c------------------------------------------------------------------------

      do i = 1, nstacks
         if (stack_blocks(i) .eq. 0) then
            stack_blocks(i) = 1
            total_blocks = total_blocks + 1
         endif
      enddo
 
c-------------------------------------------------------------------------
c   Need 3 scratch blocks on the largest stack.
c-------------------------------------------------------------------------

      stack_blocks(nstacks) = stack_blocks(nstacks) + 3
      total_blocks = total_blocks + 3
      if (dbg) print *,'Task ',me,
     *     ' Stack distribution after optable_loop_sim: ',
     * (stack_blocks(i),i=1,nstacks),' total_blocks ',total_blocks

c---------------------------------------------------------------------------
c   Final recheck: Are there too many blocks?
c--------------------------------------------------------------------------

c      if (total_blocks .gt. max_blkmgr_blocks) then 
c        if (error_print_flag) then
c         print *,'Error: The current job parameters require a total',
c     *           ' of ',total_blocks,' which exceeds the limit of ',
c     *           max_blkmgr_blocks
c         print *,'Either different segmentation of occupied/virtual/AO',
c     *           ' indices must be used, or a larger number of ',
c     *           'processors is required to run this job.'
c         print *,'Another alternative is to choose a different SIAL',
c     *           ' algorithm.'
c         print *,'2D stack: ',stack_blocks(1),
c     *      ' blocks because of  line ',stack_line(1)
c         print *,'OOOO/OOOV: ',stack_blocks(2),
c     *      ' blocks because of  line ',stack_line(2)
c         print *,'OOOV/OOVV: ',stack_blocks(3),
c     *      ' blocks because of  line ',stack_line(3)
c         print *,'OOVV: ',stack_blocks(4),
c     *      ' blocks because of  line ',stack_line(4)
c         print *,'OOVV/OVVV: ',stack_blocks(5),
c     *      ' blocks because of  line ',stack_line(5)
c         print *,'OVVV: ',stack_blocks(6),
c     *      ' blocks because of  line ',stack_line(6)
c         print *,'VVVV: ',stack_blocks(7),
c     *      ' blocks because of  line ',stack_line(7)
c        endif
c        ierr = 1
c        return
c      endif

      if (dbg) print *,'Task ',me,' total_blocks, max_blkmgr_blocks ',
     *     total_blocks, max_blkmgr_blocks

c---------------------------------------------------------------------------
c  Do the blocks take up too much memory?
c---------------------------------------------------------------------------

      total_words = 0
      do i = 1, nstacks

c---------------------------------------------------------------------------
c   When computing total_words, we must use a 64-bit temporary variable in
c   order to avoid integer overflow due to a possibly large number.
c---------------------------------------------------------------------------

         i8temp = stack_blocksizes(i) + lblock_id_data
         i8temp = i8temp * stack_blocks(i)
         total_words = total_words + i8temp
      enddo

c---------------------------------------------------------------------------
c  Add the overhead due to block management.
c---------------------------------------------------------------------------

      noverhead_bytes = nblk_overhead * intsize * 
     *                   total_blocks
      noverhead_words = (noverhead_bytes + bytes_per_double - 1) /
     *                   bytes_per_double
      total_words = total_words + noverhead_words
      if (total_words .gt. nscr) then
        if (error_print_flag) then
         print *,'Error: The current job configuration will require ',
     *         'the following minimum configuration of stacks to run:'
         print *,'2D stack: ',stack_blocks(1),' blocks of ',
     *            stack_blocksizes(1),' words because of line ',
     *            stack_line(1)
         print *,'OOOO/OOOV: ',stack_blocks(2),' blocks of ',
     *            stack_blocksizes(2),' words because of line ',
     *            stack_line(2)
         print *,'OOOV/OOVV: ',stack_blocks(3),' blocks of ',
     *            stack_blocksizes(3),' words because of line ',
     *            stack_line(3)
         print *,'OOVV: ',stack_blocks(4),' blocks of ',
     *            stack_blocksizes(4),' words because of line ',
     *            stack_line(4)
         print *,'OOVV/OVVV: ',stack_blocks(5),' blocks of ',
     *            stack_blocksizes(5),' words because of line ',
     *            stack_line(5)
         print *,'OVVV: ',stack_blocks(6),' blocks of ',
     *            stack_blocksizes(6),' words because of line ',
     *            stack_line(6)
         print *,'VVVV: ',stack_blocks(7),' blocks of ',
     *            stack_blocksizes(7),' words because of line ',
     *            stack_line(7)
         print *,'Total words requred: ',total_words,
     *           ' actual number available: ',nscr
         print *,'Memory shortfall: Overhead',
     *         ((noverhead_words)*8)/(1024*1024),
     *          ' Mbytes'
         print *,'Memory shortfall: ',
     *         ((total_words-nscr)*8)/(1024*1024),
     *          ' Mbytes'
        endif

        ierr = 1
        return
      endif
      
      if (dbg) print *,'Task ',me,' total_words, nscr ',
     *                   total_words, nscr,' stack algorithm ',
     *                   stack_algorithm_type

      if (stack_algorithm_type .eq. 1) then

c--------------------------------------------------------------------------
c   Divide out any remaining blocks evenly among the different stacks.
c--------------------------------------------------------------------------

         nwords_per_group = 0
         do i = 1, nstacks ! VFL 2/26/13 
            nwords_per_group = nwords_per_group + stack_blocksizes(i) +
     *                      lblock_id_data
         enddo

         nbytes_per_group = nwords_per_group * bytes_per_double + 
     *                      nstacks * nblk_overhead * intsize
         nblocks_per_stack = (nscr-total_words) * bytes_per_double / 
     *                        nbytes_per_group

         if (dbg) print *,'Task ',me,' Adding ',nblocks_per_stack,
     *            ' to each stack'
         do i = 1, nstacks
            stack_blocks(i) = stack_blocks(i) + nblocks_per_stack
         enddo
      else if (stack_algorithm_type .eq. 2) then

c--------------------------------------------------------------------------
c   Memory is proportionally allocated among the non-zero stacks, from the
c   stack with the largest block_size down.
c   This is more useful for scf-type distributions.
c--------------------------------------------------------------------------

         nresidual = nscr - total_words
         nresidual_old = nresidual

         do i = nstacks, 1, -1 ! VFL 2/26/13 
            if (stack_blocks(i) .ne. 0 .and. 
     *          nresidual .gt. 0) then
               weight =float(stack_blocks(i)) / total_blocks
               i8temp  = weight * nresidual_old * bytes_per_double
               nwadd = i8temp
               nbytes_per_blk = (stack_blocksizes(i) + lblock_id_data) 
     *            *bytes_per_double + nblk_overhead * intsize
               nbadd  = i8temp / nbytes_per_blk 
               noverhead_words = (nblk_overhead * intsize* nbadd +
     *                       bytes_per_double - 1) / bytes_per_double
               nresidual = nresidual - nbadd * (stack_blocksizes(i) +
     *                     lblock_id_data) - noverhead_words
               if (nresidual .gt. 0) then
                  if (dbg) print *,'Task ',me,' Adding ',nbadd,
     *                 ' blocks to stack ',
     *                  i 
                  stack_blocks(i) = stack_blocks(i) + nbadd
               endif
            endif
         enddo 
      else
         print *,'Error: Invalid algorithm_type parameter in ',
     *       'stack_distribution routine.'
         print *,'Value is ',stack_algorithm_type
         call abort_job()
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,SHELLX,
     +                      SHELLA,SHELLB,
     +                      NGEXCEN,
     +                      WTS,
     +                      R1,R2,
     +                      AB,
     +                      WTAKE,
     +                      INTSCR,
     +
     +                               INT1D )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_1D_AB_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 1D AB
C                nuclear attraction integrals using the Rys vertical
C                recurrence scheme and the Rys horizontal transfer
C                scheme explained below.
C
C                Scheme:
C
C                    i) VRR => generate the (P,0) integrals
C                   ii) HRR => generate the (A,B) integrals
C
C                If WTAKE is set true, the Rys weight is being
C                multiplied to the 1D AB integrals to reduce overall
C                FLOP count. Note, that the Rys weight factor needs
C                to be introduced only two times for the starting
C                1D AB integrals for the VRR recurrence scheme,
C                namely to the (0,0) and (1,0) elements. The weight
C                factor is then automatically propagated through the
C                vertical and horizontal transfer equations (see below).
C
C
C                The recurrence schemes VRR and HRR is due to Rys,
C                Dupuis and King, J. Comp. Chem. 4, p.154-157 (1983).
C
C
C                 i) VRR Scheme:
C
C
C                   INT1D (0,0) = 1.D0    (* WEIGHT if WTAKE = .true.)
C                   INT1D (1,0) = R1      (* WEIGHT if WTAKE = .true.)
C
C                   For I = 1,...,SHELLP-1
C                       INT1D (I+1,0) = I * R2 * INT1D (I-1,0)
C                                         + R1 * INT1D (I,0)
C
C
C                ii) HRR Scheme:
C
C
C                   For J = 1,...,SHELLX  (SHELLX = Min (SHELLA,SHELLB)
C                   For I = SHELLP-J,...,0
C                       INT1D (I,J) =  +/- AB * INT1D (I,J-1)
C                                             + INT1D (I+1,J-1)
C
C
C                The 1D AB integrals are calculated for all nuclear
C                centers, all exponent pairs and all quadrature points
C                simultaneously and placed into a 3-dimensional array.
C
C                An important feature of this routine is that it can
C                be called with shell magnitudes A < B. If this case
C                happens, the VRR and HRR have to be processed
C                differently. If shell A < shell B, the HRR must be
C                defined such that P,0 -> B,A due to efficiency and
C                numerical stability reasons. This in turn needs a
C                redefinition of the R1 coefficients, which now must
C                be such that they are defined with the P shell
C                accumulated on center B instead of A. The R1
C                coefficients are (example x coordinate):
C
C                  i) P accumulated on center A:
C
C                        R1x = (Px - Ax) + term independent of Ax,Bx
C
C                 ii) P accumulated on center B:
C
C                        R1x = (Px - Bx) + term independent of Ax,Bx
C
C                When entering the present routine however, all we have
C                are the R1 values based on case i). If case ii)
C                applies, we have to form new R1 via:
C
C                          R1 -> R1 + (A - B) = R1 + AB
C
C                using the cartesian coordinate differences AB = A - B
C                between centers A and B. The constant AB is thus added
C                to all R1 values presently transmitted. The R2
C                coefficients are independent of Ax and Bx and thus
C                need not be modified.
C
C
C                  Input:
C
C                    SHELLP      =  maximum shell sum A+B
C                    SHELLX      =  minimum shell type between A and B
C                    SHELLx      =  shell type for csh x = A and B
C                    NGEXCEN     =  # of roots times # of primitive
C                                   exponent pairs times # of nuclear
C                                   attraction centers
C                    WTS         =  all quadrature Rys weights
C                    R1          =  cartesian coordinate dependent
C                                   VRR expansion coefficients based
C                                   on center A
C                    R2          =  the coordinate independent VRR
C                                   R2-coefficients
C                    AB          =  cartesian coordinate differences
C                                   A - B between sites A and B
C                    WTAKE       =  if true, the Rys weights will be
C                                   build into the 1D AB integrals;
C                                   if false, the Rys weights will not
C                                   be considered
C                    INTSCR      =  scratch array to perform the VRR
C                                   and HRR schemes
C
C
C                  Output:
C
C                    INT1D       =  all 1D AB integrals with reduced
C                                   PB -> AB dimensions
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   HRRBA
         LOGICAL   WTAKE

         INTEGER   CASE1D
         INTEGER   I,J,N
         INTEGER   I1,I2,J1,J2,IP1,JM1
         INTEGER   NGEXCEN
         INTEGER   SHELLA,SHELLB
         INTEGER   SHELLP,SHELLX

         DOUBLE PRECISION  AB
         DOUBLE PRECISION  F
         DOUBLE PRECISION  WEIGHT
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  R1  (1:NGEXCEN)
         DOUBLE PRECISION  R2  (1:NGEXCEN)
         DOUBLE PRECISION  WTS (1:NGEXCEN)

         DOUBLE PRECISION  INT1D  (1:NGEXCEN,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INTSCR (1:NGEXCEN,0:SHELLP,0:SHELLX)

         PARAMETER  (ONE   =  1.D0)
         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 4 different cases that can arise:
C
C                  A-shell = s- or higher angular momentum
C                  B-shell = s- or higher angular momentum
C
C                each leading to specific simplifications.
C
C
         CASE1D = 2 * MIN (1,SHELLA) + MIN (1,SHELLB) + 1

         GOTO (1,2,3,4) CASE1D
C
C
C             ...the case A = s-shell and B = s-shell (no HRR!).
C                i) VRR => Evaluate: I = 0
C                                    J = 0
C
C
    1    IF (WTAKE) THEN
             DO N = 1,NGEXCEN
                INT1D (N,0,0) = WTS (N)
             END DO
         ELSE
             DO N = 1,NGEXCEN
                INT1D (N,0,0) = ONE
            END DO
         END IF

         RETURN
C
C
C             ...the cases A = s-shell and B >= p-shell (no HRR!).
C                i) VRR => Evaluate: I = 0
C                                    J = 0,SHELLB
C
C
    2    IF (AB.NE.ZERO) THEN
             DO N = 1,NGEXCEN
                R1 (N) = R1 (N) + AB
             END DO
         END IF

         IF (WTAKE) THEN
             DO N = 1,NGEXCEN
                WEIGHT = WTS (N)
                INT1D (N,0,0) = WEIGHT
                INT1D (N,0,1) = R1 (N) * WEIGHT
             END DO
         ELSE
             DO N = 1,NGEXCEN
                INT1D (N,0,0) = ONE
                INT1D (N,0,1) = R1 (N)
             END DO
         END IF

         IF (SHELLB.GT.1) THEN
             F = ONE
             DO J = 2,SHELLB
                J1 = J - 1
                J2 = J - 2
                DO N = 1,NGEXCEN
                   INT1D (N,0,J) = F * R2 (N) * INT1D (N,0,J2)
     +                               + R1 (N) * INT1D (N,0,J1)
                END DO
                F = F + ONE
             END DO
         END IF

         RETURN
C
C
C             ...the cases A >= p-shell and B = s-shell (no HRR!).
C                i) VRR => Evaluate: I = 0,SHELLA
C
C
    3    IF (WTAKE) THEN
             DO N = 1,NGEXCEN
                WEIGHT = WTS (N)
                INT1D (N,0,0) = WEIGHT
                INT1D (N,1,0) = R1 (N) * WEIGHT
             END DO
         ELSE
             DO N = 1,NGEXCEN
                INT1D (N,0,0) = ONE
                INT1D (N,1,0) = R1 (N)
             END DO
         END IF

         IF (SHELLA.GT.1) THEN
             F = ONE
             DO I = 2,SHELLA
                I1 = I - 1
                I2 = I - 2
                DO N = 1,NGEXCEN
                   INT1D (N,I,0) = F * R2 (N) * INT1D (N,I2,0)
     +                               + R1 (N) * INT1D (N,I1,0)
                END DO
                F = F + ONE
             END DO
         END IF

         RETURN
C
C
C             ...the cases A >= p-shell and B >= p-shell.
C                i) VRR => Evaluate: I = 0,SHELLP
C                                    J = 0
C
C
    4    HRRBA = SHELLA .LT. SHELLB

         IF (HRRBA .AND. AB.NE.ZERO) THEN
             DO N = 1,NGEXCEN
                R1 (N) = R1 (N) + AB
             END DO
         END IF

         IF (WTAKE) THEN
             DO N = 1,NGEXCEN
                WEIGHT = WTS (N)
                INTSCR (N,0,0) = WEIGHT
                INTSCR (N,1,0) = R1 (N) * WEIGHT
             END DO
         ELSE
             DO N = 1,NGEXCEN
                INTSCR (N,0,0) = ONE
                INTSCR (N,1,0) = R1 (N)
             END DO
         END IF

         F = ONE
         DO I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO N = 1,NGEXCEN
               INTSCR (N,I,0) = F * R2 (N) * INTSCR (N,I2,0)
     +                            + R1 (N) * INTSCR (N,I1,0)
            END DO
            F = F + ONE
         END DO
C
C
C             ...ii) HRR => Evaluate: I = 0,SHELLP-SHELLA/SHELLB
C                                     J = 0,SHELLB/SHELLA
C                           and
C
C               iii) Copy INTSCR to INT1D: I = 0,SHELLA
C                                          J = 0,SHELLB
C
C
         IF (.NOT.HRRBA) THEN

             IF (AB.EQ.ZERO) THEN
                 DO J = 1,SHELLB
                    JM1 = J - 1
                    DO I = 0,SHELLP-J
                       IP1 = I + 1
                       DO N = 1,NGEXCEN
                          INTSCR (N,I,J) = INTSCR (N,IP1,JM1)
                       END DO
                    END DO
                 END DO
             ELSE
                 DO J = 1,SHELLB
                    JM1 = J - 1
                    DO I = 0,SHELLP-J
                       IP1 = I + 1
                       DO N = 1,NGEXCEN
                          INTSCR (N,I,J) = INTSCR (N,IP1,JM1)
     +                              + AB * INTSCR (N,I,JM1)
                       END DO
                    END DO
                 END DO
             END IF

             DO J = 0,SHELLB
             DO I = 0,SHELLA
             DO N = 1,NGEXCEN
                INT1D (N,I,J) = INTSCR (N,I,J)
             END DO
             END DO
             END DO

         ELSE

             IF (AB.EQ.ZERO) THEN
                 DO J = 1,SHELLA
                    JM1 = J - 1
                    DO I = 0,SHELLP-J
                       IP1 = I + 1
                       DO N = 1,NGEXCEN
                          INTSCR (N,I,J) = INTSCR (N,IP1,JM1)
                       END DO
                    END DO
                 END DO
             ELSE
                 DO J = 1,SHELLA
                    JM1 = J - 1
                    DO I = 0,SHELLP-J
                       IP1 = I + 1
                       DO N = 1,NGEXCEN
                          INTSCR (N,I,J) = INTSCR (N,IP1,JM1)
     +                              - AB * INTSCR (N,I,JM1)
                       END DO
                    END DO
                 END DO
             END IF

             DO J = 0,SHELLB
             DO I = 0,SHELLA
             DO N = 1,NGEXCEN
                INT1D (N,I,J) = INTSCR (N,J,I)
             END DO
             END DO
             END DO

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

#include "flags.h"
      subroutine Read_File_Main(Icore, Icrsiz)
c
      implicit double precision (a-h,o-z)
      parameter (mxcoef=30)
c
#include "machsp.com"
#include "jodaflags.com"
#include "mxatms.par"
#include "baslims.par"
C
      character*32 szFile
      logical bExist
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Nocc(16), Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Coord(3*Mxatms), Norbits_fullG(Mxatms), 
     &          NOrbits_compG(Mxatms),Nbsfns_4irrep(8)
      Dimension Icore(Icrsiz)
C
      Data Ione, Ieight /1, 8/
C
      Iuhf = 1
      If (iflags(h_IFLAGS_ref).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Mxangmom = Nht
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      
      Call Getrec(-1, 'JOBARC', 'NUMDROPA', Length, Ijunk)       
      If (Length .GT. 0) Then 
         Print*, "Frozen-core is not allowed density plots"
         Call Errex
      Endif
c 
      Call Getrec(-1, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(-1, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(-1, 'JOBARC', 'FULLNORB', Ione, Iful_unq_atoms)
      Call Getrec(-1, 'JOBARC', 'COMPNORB', Ione, Icmp_unq_atoms)
      Call Getrec(-1, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Coord)
      Call Getrec(-1, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(-1, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(-1, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(-1, 'JOBARC', 'OCCUPYA ', Nirrep, Nocc(1))
      Call Getrec(-1, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(-1, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(-1, 'JOBARC', 'NUMBASIR', Nirrep, Nbsfns_4irrep)
      Call Getrec(-1, 'JOBARC', 'FULLPOPV', Iful_unq_atoms, 
     &            Norbits_fullG)
      Call Getrec(-1, 'JOBARC', 'COMPPOPV', Icmp_unq_atoms, 
     &            Norbits_compG)
C
       Nvibs  = (3*Nreal_atoms- 6) 
       Iloc   = 1
       Iscr1  = Iloc   + 9*Nvibs*Nvibs
       INext  = IScr1  + 9*Nvibs*Nvibs
       Ilef   = Maxcor - Inext

       If (INext .ge. Maxcor) Call Insmem("Write_primt_main", Inext, 
     &                                     Maxcor)
C
       Call Read_filE(Nreal_atoms, Nvibs, Icore(Iloc), ICore(IScr1))
C
      Return
      End

      subroutine Read_File_Main(Icore, Icrsiz)
c
      implicit double precision (a-h,o-z)
      parameter (mxcoef=30)
c


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end










c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

C
      character*32 szFile
      logical bExist
      Character*4 Comp_pgrp, Full_pgrp
      Dimension Nocc(16), Atommass(Mxatms), Iatmchrg(Mxatms),  
     &          Coord(3*Mxatms), Norbits_fullG(Mxatms), 
     &          NOrbits_compG(Mxatms),Nbsfns_4irrep(8)
      Dimension Icore(Icrsiz)
C
      Data Ione, Ieight /1, 8/
C
      Iuhf = 1
      If (iflags(11).eq.0) iuhf = 0 
C
      Maxcor   = Icrsiz
      Mxangmom = Nht
      Length   = 0
c
c Read the JOBARC file for basic data of the molecule. 
c
      
      Call Getrec(-1, 'JOBARC', 'NUMDROPA', Length, Ijunk)       
      If (Length .GT. 0) Then 
         Print*, "Frozen-core is not allowed density plots"
         Call Errex
      Endif
c 
      Call Getrec(-1, 'JOBARC', 'NREALATM', Ione, Nreal_atoms)
      Call Getrec(-1, 'JOBARC', 'NATOMS  ', Ione, Natoms)
      Call Getrec(-1, 'JOBARC', 'FULLNORB', Ione, Iful_unq_atoms)
      Call Getrec(-1, 'JOBARC', 'COMPNORB', Ione, Icmp_unq_atoms)
      Call Getrec(-1, 'JOBARC', 'COORD   ', 3*Natoms*Iintfp, Coord)
      Call Getrec(-1, 'JOBARC', 'ATOMMASS', Natoms*Iintfp, Atommass)
      Call Getrec(-1, 'JOBARC', 'ATOMCHRG', Natoms, Iatmchrg)
      Call Getrec(-1, 'JOBARC', 'COMPNIRR', Ione, Nirrep)
      Call Getrec(-1, 'JOBARC', 'OCCUPYA ', Nirrep, Nocc(1))
      Call Getrec(-1, 'JOBARC', 'NBASTOT ', Ione, Nbfns)
      Call Getrec(-1, 'JOBARC', 'NAOBASFN', Ione, Naobfns)
      Call Getrec(-1, 'JOBARC', 'NUMBASIR', Nirrep, Nbsfns_4irrep)
      Call Getrec(-1, 'JOBARC', 'FULLPOPV', Iful_unq_atoms, 
     &            Norbits_fullG)
      Call Getrec(-1, 'JOBARC', 'COMPPOPV', Icmp_unq_atoms, 
     &            Norbits_compG)
C
       Nvibs  = (3*Nreal_atoms- 6) 
       Iloc   = 1
       Iscr1  = Iloc   + 9*Nvibs*Nvibs
       INext  = IScr1  + 9*Nvibs*Nvibs
       Ilef   = Maxcor - Inext

       If (INext .ge. Maxcor) Call Insmem("Write_primt_main", Inext, 
     &                                     Maxcor)
C
       Call Read_filE(Nreal_atoms, Nvibs, Icore(Iloc), ICore(IScr1))
C
      Return
      End

c---------------------------------------------------------------|
c  This subroutine is a superinstruction for the SIAL code      |
c  It performs construction of new approximations to |R> and    |
c  and <L| vectors using Davodson's vectors and eigenvectors    |
c  of the small matrix                                          |
c  Added by Denis Bokhan, Moscow Lomonosov State University,    |
c              Moscow, RUSSIAN FEDERATION                       |
c---------------------------------------------------------------|

      subroutine eomnewvec(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)

c---------------------------------------------------------------|
      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
      include 'daveom.h' 
#ifdef ALTIX
      include 'sheap.h'
#endif
c---------------------------------------------------------------|

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index
      integer stack
      integer nsend

      integer comm

      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(mx_array_index), findex(mx_array_index)
      integer type(mx_array_index)
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------|

c---------------------------------------------------------------|
c   Detrmine the parameters of the first array: c_result_array  |
c---------------------------------------------------------------|

      array = op(c_result_array)
      nindex = array_table(c_nindex, array)

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         sindex(i) = index
         call get_index_segment(index, seg, segment_table,
     *                           nsegment_table, index_table,
     *                           nindex_table, fop1(i), fop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk1 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk1 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif
c---------------------------------------------------------------|
c   Detrmine the parameters of the second array: c_op1_array    |
c---------------------------------------------------------------|
      array = op(c_op1_array)
      nindex = array_table(c_nindex, array)

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         findex(i) = index
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, sop1(i), sop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk2 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk2 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif
C---------------------------------------------------------------|
           
C--------------Check type of contraction------------------------|

c-----Contraction with 1 index-Davidson vectors contribution ---|
         if (chunk_type.eq.1) then 
         call make_eom_newvec_1( x(indblk1),fop1(1),fop2(1),
     & fop1(2),fop2(2),fop1(3),fop2(3),x(indblk2),
     & sop1(1),sop2(1),sop1(2),sop2(2) ) 
         endif 
c-----Contraction with 1 index-correction vectors contribution --|
         if (chunk_type.eq.2) then                   
         call make_eom_newvec_2( x(indblk1),fop1(1),fop2(1),
     & fop1(2),fop2(2),x(indblk2),sop1(1),sop2(1),sop1(2),sop2(2) )   
         endif
c-----Contraction with 3 indices- Davidson vectors contribution--|
         if (chunk_type.eq.3) then
       call make_eom_newvec_3( x(indblk1),fop1(1),fop2(1),
     & fop1(2),fop2(2),fop1(3),fop2(3),fop1(4),fop2(4),fop1(5),fop2(5),
     & x(indblk2),sop1(1),sop2(1),sop1(2),sop2(2),sop1(3),sop2(3),
     & sop1(4),sop2(4) ) 
         endif     
c-----Contraction with 3 indices- correction vectors contribution--|
         if (chunk_type.eq.4) then
       call make_eom_newvec_4( x(indblk1),fop1(1),fop2(1),
     & fop1(2),fop2(2),fop1(3),fop2(3),fop1(4),fop2(4),
     & x(indblk2),sop1(1),sop2(1),sop1(2),sop2(2),sop1(3),sop2(3),
     & sop1(4),sop2(4) )
         endif



       return
       end
C############################################################################
C############################################################################
c        One-index component                                                |
c---------------------------------------------------------------------------|
       subroutine make_eom_newvec_1(DAV_VEC,a1,a2,b1,b2,c1,c2,
     & DAV_NEWVEC,d1,d2,f1,f2 ) 
       implicit none
       include 'daveom.h'   
       integer a1,a2,b1,b2,c1,c2,d1,d2,f1,f2,i,j,a,kk,ll,zz,qq,ist,
     & izz
       double precision DAV_VEC(a1:a2,b1:b2,c1:c2),
     & DAV_NEWVEC(d1:d2,f1:f2)

       ist = nroots*iter
       izz = nroots*iter + nroots  
c--------Davidson's vectors contribution------------------------------------|
       
cccc           DO zz=1,izz !loop over roots of output array
            DO i=a1,a2 !loop over hole molecular index
             qq = 0
             DO ll=c1,c2 !loop over iterations
              DO kk=b1,b2 !loop over roots of input array
              qq = qq + 1
                 IF(RL.eq.1) then
              DAV_NEWVEC(i,aux_vec_num) = DAV_NEWVEC(i,zz) + 
     & DAV_VEC(i,kk,ll)*DavRvec(qq,aux_vec_num) 
                 ELSE
              DAV_NEWVEC(i,aux_vec_num) = DAV_NEWVEC(i,zz) +
     & DAV_VEC(i,kk,ll)*DavLvec(qq,aux_vec_num)
                 ENDIF
              ENDDO
             ENDDO 
            ENDDO
cccc           ENDDO
      
c---------------------------------------------------------------------------|
      return
      end   
C############################################################################
C############################################################################
       subroutine make_eom_newvec_2(DAV_VEC,a1,a2,b1,b2,DAV_NEWVEC,
     & d1,d2,f1,f2 )
       implicit none
       include 'daveom.h'
       integer a1,a2,b1,b2,c1,c2,d1,d2,f1,f2,i,j,a,kk,ll,zz,qq,ist,
     & izz
       double precision DAV_VEC(a1:a2,b1:b2),DAV_NEWVEC(d1:d2,f1:f2)

       ist = nroots*iter
       izz = nroots*iter + nroots
c--------Correction vectors contribution------------------------------------|
    
cccc           DO zz=1,izz !loop over roots of output array
            DO i=a1,a2 !loop over hole molecular index
             DO kk=b1,b2 !loop over roots of input array
                 IF(RL.eq.1) then
              DAV_NEWVEC(i,aux_vec_num) = DAV_NEWVEC(i,zz) +
     & DAV_VEC(i,kk)*DavRvec(kk+ist,aux_vec_num)
                 ELSE
              DAV_NEWVEC(i,aux_vec_num) = DAV_NEWVEC(i,zz) +
     & DAV_VEC(i,kk)*DavLvec(kk+ist,aux_vec_num)
                 ENDIF
             ENDDO
            ENDDO
cccc           ENDDO
       
c---------------------------------------------------------------------------|
      return
      end
C############################################################################
C############################################################################
c                Three-index component                                      |
c---------------------------------------------------------------------------|
       subroutine make_eom_newvec_3(DAV_VEC,a1,a2,b1,b2,c1,c2,d1,d2,
     & f1,f2,DAV_NEWVEC,g1,g2,h1,h2,k1,k2,l1,l2)
       implicit none
       include 'daveom.h'
       integer a1,a2,b1,b2,c1,c2,d1,d2,f1,f2,i,j,a,kk,ll,l1,l2,h1,h2,g1,
     & g2,k1,k2,zz,qq,izz
       double precision DAV_VEC(a1:a2,b1:b2,c1:c2,d1:d2,f1:f2),
     & DAV_NEWVEC(g1:g2,h1:h2,k1:k2,l1:l2)

       izz = nroots*iter + nroots
c--------Davidson's vectors contribution------------------------------------|

cccc           DO zz=1,izz !loop over roots of output array
            DO i=a1,a2 !loop over hole molecular index
            DO j=b1,b2 !loop over hole molecular index
            DO a=c1,c2 !loop over particle molecular index
             qq = 0
             DO ll=f1,f2 !loop over iterations
              DO kk=d1,d2 !loop over roots of input array
              qq = qq + 1
                 IF(RL.eq.1) then
              DAV_NEWVEC(i,j,a,aux_vec_num) = DAV_NEWVEC(i,j,a,zz) +
     & DAV_VEC(i,j,a,kk,ll)*DavRvec(qq,aux_vec_num)
                 ELSE
              DAV_NEWVEC(i,j,a,aux_vec_num) = DAV_NEWVEC(i,j,a,zz) +
     & DAV_VEC(i,j,a,kk,ll)*DavLvec(qq,aux_vec_num)
                 ENDIF
              ENDDO
             ENDDO
            ENDDO
            ENDDO
            ENDDO
cccc           ENDDO
c---------------------------------------------------------------------------|
      return
      end
C############################################################################
C############################################################################
c                Three-index component                                      |
c---------------------------------------------------------------------------|
       subroutine make_eom_newvec_4(DAV_VEC,a1,a2,b1,b2,c1,c2,d1,d2,
     & DAV_NEWVEC,g1,g2,h1,h2,k1,k2,l1,l2)
       implicit none
       include 'daveom.h'
       integer a1,a2,b1,b2,c1,c2,d1,d2,f1,f2,i,j,a,kk,ll,l1,l2,h1,h2,g1,
     & g2,k1,k2,ist,zz,izz
       double precision DAV_VEC(a1:a2,b1:b2,c1:c2,d1:d2),
     & DAV_NEWVEC(g1:g2,h1:h2,k1:k2,l1:l2)


       ist = nroots*iter
       izz = nroots*iter + nroots
c--------Correction vectors contribution--------------------------------------|

cccc           DO zz=1,izz !loop over roots of output array
            DO i=a1,a2 !loop over hole molecular index
            DO j=b1,b2 !loop over hole molecular index
            DO a=c1,c2 !loop over particle molecular index
              DO kk=d1,d2 !loop over roots of input array
                  IF(RL.eq.1) then
              DAV_NEWVEC(i,j,a,aux_vec_num) = DAV_NEWVEC(i,j,a,zz) +
     & DAV_VEC(i,j,a,kk)*DavRvec(kk+ist,aux_vec_num)
                  ELSE
              DAV_NEWVEC(i,j,a,aux_vec_num) = DAV_NEWVEC(i,j,a,zz) +
     & DAV_VEC(i,j,a,kk)*DavLvec(kk+ist,aux_vec_num)
                  ENDIF
              ENDDO
            ENDDO
            ENDDO
            ENDDO
cccc           ENDDO
c---------------------------------------------------------------------------|
      return
      end
c----------------------------------------------------------------------------

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_erd3C(a1,a2,b1,b2,c1,c2,scr,maxblk,
     *                        iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                        out, nsend)
c---------------------------------------------------------------------------
c   "Work" routine for the integral worker task.
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'

      integer a1, a2, b1, b2, c1, c2  
      integer aa1,aa2,bb1,bb2,cc1,cc2
      integer adim, bdim, cdim   
      integer m1, m2, n1, n2, r1, r2 
      integer i, j, n, m, r 
      integer a,b,c

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer me, ierr

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision out(a1:a2,b1:b2,c1:c2)
      double precision scr(*)   
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      save me,alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack

      call mpi_comm_rank(mpi_comm_world, me, ierr)

      adim = a2-a1+1
      bdim = b2-b1+1
      cdim = c2-c1+1

      l8true      = .true.
      spherical   = (ispherical .eq. 1)
      l8spherical = spherical
  
      nsend = adim*bdim*cdim
      if (nsend .lt. 0) then
         print *,'ERROR IN ERD3INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim,cdim = ',adim,bdim,cdim
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         out(a,b,c) = 0.d0
      enddo
      enddo
      enddo

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         call lookup_shell(end_nfps, nshells, a1, m1)
         call lookup_shell(end_nfps, nshells, a2, m2)
         call lookup_shell(end_nfps, nshells, b1, n1)
         call lookup_shell(end_nfps, nshells, b2, n2)
         call lookup_shell(end_nfps, nshells, c1, r1)
         call lookup_shell(end_nfps, nshells, c2, r2)

         do m = m1, m2
            if (m .eq. 1) then
               aa1 = 1
            else
               aa1 = end_nfps(m-1) + 1
            endif
            aa2 = end_nfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (n .eq. 1) then
               bb1 = 1
            else
               bb1 = end_nfps(n-1) + 1
            endif
            bb2 = end_nfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if (r .eq. 1) then
               cc1 = 1
            else
               cc1 = end_nfps(r-1) + 1
            endif
            cc2 = end_nfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)

            call pack_coeffs_ovl3c(alphas, ixalpha, coeffs, ixpcoef, 
     *                       ncfps, npfps, m, n, r,  
     *                       alpha_pack, nalpha_pack, 
     *                       pcoeff_pack, npcoeff_pack, 
     *                       ccbeg, ccend, indx_cc,
     *                       ccbeg_pack, ccend_pack)

c---------------------------------------------------------------------------
c   Calling sequence for ERD_3C.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) 

c                 call OED__GENER_OVL3C_BATCH(intmax, zmax,
c    *                nalpha_pack, npcoeff_pack, ncsum, 
c    *                ncfps(m),ncfps(n), ncfps(r), 
c    *                npfps(m),npfps(n), npfps(r), 
c    *                ivangmom(m), ivangmom(n), ivangmom(r), 
c    *                atom(m), atom(n), atom(r), x1,y1,z1,
c    *                x2,y2,z2,x3,y3,z3, alpha_pack,
c    *                pcoeff_pack, ccbeg_pack, ccend_pack,
c    *                spherical, .true., iscr, nints, 
c    *                nfirst, scr)    

c---------------------------------------------------------------------------
c   Move the integrals into the output block. 
c---------------------------------------------------------------------------

            if (nints .gt. 0) then
               
               call move_OVL3C(out,a1,a2,b1,b2,c1,c2, 
     *                             scr(nfirst), 
     *                             aa1,aa2,bb1,bb2,cc1,cc2) 
            endif

         enddo   ! r

         enddo   ! n
         enddo   ! m

      return
      end

      

C INITIALIZES TIMING INFORMATION FOR PROGRAM

      SUBROUTINE CHECKIN
      IMPLICIT INTEGER (A-Z)

#include "bwcc.com"
#include "timeinfo.com"

cjp to make the timer consistent in MR
      if ((.not.isbwcc).or.(iref.eq.myproc)) call zclock(0)

      RETURN
      END

c DO NOT USE THIS ROUTINE

c#define _VERBOSE_MEMSET
#define _ISCR_LEN 262144

      subroutine aces_list_memset(iLeft,iRight,iConst)
      implicit none

c ARGUMENTS
      integer iLeft, iRight, iConst

c INTERNAL VARIABLES
      integer iScr(_ISCR_LEN)
      integer iFileNum, iStat
      integer nRows, nCols
      integer iRec, iRecNdx, iTmp
      integer nLeft, nPut
#ifdef OPEN_LISTS_AS_NEEDED
#include "szfiles.dat"
      integer ihFile
      character*80 szFile
      integer      iLength
      logical bExist
#endif

c COMMON BLOCKS
#include "icore.com" /* for icore */
#include "lists.com" /* for moio info */
#include "machsp.com" /* for iintfp */
#include "filspc.com" /* for iprcwd */
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

c   o look up the dimensions of the list
      nRows = moiosz(iLeft,iRight)
      nCols = moiods(iLeft,iRight)

      if ((nRows.lt.1).or.(nCols.lt.1)) return

#ifdef _VERBOSE_MEMSET
      print *, '@ACES_LIST_MEMSET: flushing list ',iLeft,iRight,' with',
     &         iConst
#endif

c   o do a fast in-core memset to the auxiliary cache
      if (quikget(iLeft,iRight).ne.0) then
         iTmp = ifltln*nRows*nCols
         call c_memset(icore(quikget(iLeft,iRight)),iConst,iTmp)
         return
      end if

c   o memset the buffer array
      if (iprcwd.le._ISCR_LEN) then
         call c_memset(iScr,iConst,iprcln)
      else
         print *, '@ACES_LIST_MEMSET: buffer is not large enough'
         print *, '   iprcwd = ',iprcwd
         print *, '   buflen = ',_ISCR_LEN
         call aces_exit(1)
      end if

c   o determine which file this array lives in
      iFileNum = moiofl(iLeft,iRight)

#ifdef OPEN_LISTS_AS_NEEDED
c   o open the file that contains this array
      ihFile = 1+iFileNum-_FIRST_IO_LUN
      call gfname(szFiles(ihFile),szFile,iLength)
      inquire(file=szFile(1:iLength),exist=bExist,err=666,iostat=iStat)
      if (bExist) then
         call aces_io_open(ihFile)
      else
         print *, '@ACES_LIST_MEMSET: "',szFile(1:iLength),
     &                                   '" - file not found'
         call aces_exit(1)
      end if
#endif

c   o find the first record and integer index that point to the first element
      iRecNdx = moiowd(iLeft,iRight)
      iTmp    = (iRecNdx-1)/iprcwd
      iRec    = moio(iLeft,iRight) + iTmp
      iRecNdx = iRecNdx            - iTmp*iprcwd

c   o do the first partial record and then loop over whole records
c     which contain the remaining data
      nLeft = nRows*nCols*iintfp
      nPut  = min(nLeft,iprcwd+1-iRecNdx)
      call putlst_io(iScr,iFileNum,iRec,iRecNdx,nPut)
      nLeft = nLeft - nPut
      do while (nLeft.ne.0)
         nPut = min(nLeft,iprcwd)
         iRec = iRec + 1
         call putlst_io(iScr,iFileNum,iRec,1,nPut)
         nLeft = nLeft - nPut
      end do

#ifdef OPEN_LISTS_AS_NEEDED
c   o close the file
      close(unit=iFileNum,status='KEEP',err=666,iostat=iStat)
#endif

      return

c   o I/O error
 666  print *, '@ACES_LIST_MEMSET: I/O error'
      print *, '                   list = [',iLeft,',',iRight,']'
      print '(/)'
      call aces_io_error('ACES_LIST_MEMSET',iFileNum,iStat)

c     end subroutine aces_list_memset
      end

c DO NOT USE THIS ROUTINE

c#define _VERBOSE_MEMSET


      subroutine aces_list_memset(iLeft,iRight,iConst)
      implicit none

c ARGUMENTS
      integer iLeft, iRight, iConst

c INTERNAL VARIABLES
      integer iScr(262144)
      integer iFileNum, iStat
      integer nRows, nCols
      integer iRec, iRecNdx, iTmp
      integer nLeft, nPut








c COMMON BLOCKS


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end





c lists.com : begin

c These common blocks contain global information about the arrays in storage.
c Elements prepended with "bw" are for storing the file metadata while working
c on multiple references.






cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)



      external aces_bd_lists

c moio  (iGrp,iFam) : the physical record that contains the first element
c                     of the array (iGrp,iFam)
c moiowd(iGrp,iFam) : the integer-word index of the first element
c moiods(iGrp,iFam) : the number of columns in the array
c moiosz(iGrp,iFam) : the number of rows    in the array
c moiofl(iGrp,iFam) : the external file unit that contains the array

      integer          moio  (10,500),
     &                 moiowd(10,500),
     &                 moiosz(10,500),
     &                 moiods(10,500),
     &                 moiofl(10,500),
     &               bwmoio  (10,500,maxref),
     &               bwmoiowd(10,500,maxref),
     &               bwmoiosz(10,500,maxref),
     &               bwmoiods(10,500,maxref),
     &               bwmoiofl(10,500,maxref)
      common /lists/   moio,   moiowd,   moiosz,   moiods,   moiofl,
     &               bwmoio, bwmoiowd, bwmoiosz, bwmoiods, bwmoiofl
      save   /lists/

c moiomxsz(iGrp,iFam) : the original length of a one-dimensional array
c                       (This is shameful. Arrays should not be re-dimensioned
c                        at will during a job.)

      integer               moiomxsz(10,500),
     &                    bwmoiomxsz(10,500,maxref)
      common /lists_mxsz/   moiomxsz,
     &                    bwmoiomxsz
      save   /lists_mxsz/

c pRec(i)    : the index of the physical record in file i containing free space
c              (i is the internal unit number of the storage file.)
c iIntOff(i) : the integer offset from the beginning of the physical record
c              needed to address the free space

      integer            pRec   (5),
     &                   iIntOff(5),
     &                 bwpRec   (5,maxref),
     &                 bwiIntOff(5,maxref)
      common /io_ptrs/   pRec,   iIntOff,
     &                 bwpRec, bwiIntOff
      save   /io_ptrs/

c bIOUp  : a flag for bombing in get/putlst if aces_io_init has not been called
c bIOMod : a flag for updating the records in aces_io_fin

      logical           bIOUp, bIOMod
      common /io_flags/ bIOUp, bIOMod
      save   /io_flags/

c lists.com : end


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c filspc.com : begin

c This common block contains the dimensions of the physical records used by the
c MOIO storage files.

c iprcln : the    byte-length of a physical record
c iprcwd : the integer-length of a physical record
c iprcrl : the    recl-length of a physical record

      integer         iprcln, iprcwd, iprcrl
      common /filspc/ iprcln, iprcwd, iprcrl
      save   /filspc/

c filspc.com : end
c auxcache.com : begin

c The auxiliary cache is a programmer-controlled list cache. The dimensions are
c the same as those of the MOIO arrays. The programmer may load lists into icore
c memory and set quikget(?,?) to their icore addresses. When getlst and putlst
c operate on ANY list, quikget is checked to see if the list lives in icore.
c If so, the operation is performed on the in-core data instead of hitting the
c storage file(s).

c WARNING
c    There is no automatic updating of storage files with data in the auxiliary
c cache. If the memory-resident data is altered and must be stored to disk, then
c the quikget value must be destroyed (zeroed) and the actual location of the
c data must then be passed to putlst. The aces_auxcache_flush routine
c systematically stores the quikget values, calls putlst, and restores the
c quikget values.


      integer           quikget(10,500)
      common /auxcache/ quikget
      save   /auxcache/

c auxcache.com : end

c ----------------------------------------------------------------------

c   o look up the dimensions of the list
      nRows = moiosz(iLeft,iRight)
      nCols = moiods(iLeft,iRight)

      if ((nRows.lt.1).or.(nCols.lt.1)) return


c   o do a fast in-core memset to the auxiliary cache
      if (quikget(iLeft,iRight).ne.0) then
         iTmp = ifltln*nRows*nCols
         call c_memset(icore(quikget(iLeft,iRight)),iConst,iTmp)
         return
      end if

c   o memset the buffer array
      if (iprcwd.le.262144) then
         call c_memset(iScr,iConst,iprcln)
      else
         print *, '@ACES_LIST_MEMSET: buffer is not large enough'
         print *, '   iprcwd = ',iprcwd
         print *, '   buflen = ',262144
         call aces_exit(1)
      end if

c   o determine which file this array lives in
      iFileNum = moiofl(iLeft,iRight)


c   o find the first record and integer index that point to the first element
      iRecNdx = moiowd(iLeft,iRight)
      iTmp    = (iRecNdx-1)/iprcwd
      iRec    = moio(iLeft,iRight) + iTmp
      iRecNdx = iRecNdx            - iTmp*iprcwd

c   o do the first partial record and then loop over whole records
c     which contain the remaining data
      nLeft = nRows*nCols*iintfp
      nPut  = min(nLeft,iprcwd+1-iRecNdx)
      call putlst_io(iScr,iFileNum,iRec,iRecNdx,nPut)
      nLeft = nLeft - nPut
      do while (nLeft.ne.0)
         nPut = min(nLeft,iprcwd)
         iRec = iRec + 1
         call putlst_io(iScr,iFileNum,iRec,1,nPut)
         nLeft = nLeft - nPut
      end do


      return

c   o I/O error
 666  print *, '@ACES_LIST_MEMSET: I/O error'
      print *, '                   list = [',iLeft,',',iRight,']'
      print '(/)'
      call aces_io_error('ACES_LIST_MEMSET',iFileNum,iStat)

c     end subroutine aces_list_memset
      end

      SUBROUTINE TWOD2ONED(PUTIN,NUMROWS,NUMCOLS,OUTPUT)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
C     Takes a 2D matrix, reads down each column to
C     change it to a 1A array.
C     Ex: (1,1)->(2,1)->(3,1)->(1,2)->(2,2)->etc.
C           1      2      3      4      5
C
      DIMENSION PUTIN(NUMROWS,NUMCOLS)
      DIMENSION OUTPUT(NUMROWS*NUMCOLS)
C     
      DO 10 I=1,NUMROWS
         DO 20 II=(NUMCOLS-1),0,-1
            OUTPUT(I*NUMCOLS-II)=PUTIN(NUMCOLS-II,I)
            WRITE(*,*) "OUTPUT(",(I*NUMCOLS-II),")=PUTIN(",(NUMCOLS-II),
     $           ",",I,")=",PUTIN(NUMCOLS-II,I)
 20      CONTINUE
 10   CONTINUE
C     
      RETURN
      END SUBROUTINE TWOD2ONED
      
      
      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine parses a string, szData, and extracts integers for nIrrps
c up to dim1 in groups of up to dim2. If nIrrps is zero, then it is set to
c the number of irreps in the first group up to dim1. The elements are
c separated by dashes, elements can be enclosed by parentheses, and
c groups are separated by forward slashes. nSpins is returned, telling
c the caller how many groups were read. iArr is initialized to zero.

c EXAMPLE:
c    szData=' 1 - 2 - 3 - 4 / (-5) - (-6) - 7 - 8 '
c This string yields: { {1,2,3,4} {-5,-6,7,8} }

      subroutine parse_irp_iarr(szData,nIrrps,nSpins,iArr,dim1,dim2)
      implicit none

c ARGUMENTS
      character*(*) szData
      integer nIrrps, nSpins, dim1, dim2
      integer iArr(dim1,dim2)

c EXTERNAL FUNCTIONS
      integer fnblnk

c INTERNAL VARIABLES
      integer iIrp, iSpin, i, j
      integer iLength, pStart, iFirst, nChars, iErrPos
      character*(1) czData
      logical bDone

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iIrp = 0
c   o assert nIrrps is in [0,inf)
      if (nIrrps.lt.0) then
         print *, '@PARSE_IRP_IARR: The expected number of irreps ',
     &            'cannot be negative.'
         print *, '   nIrrps = ',nIrrps
         iIrp = -1
      end if
c   o assert dim1 and dim2 are natural
      if ((dim1.lt.1).or.(dim2.lt.1)) then
         print *, '@PARSE_IRP_IARR: The destination array is ',
     &            'ill-defined.'
         print *, '   dim1 = ',dim1
         print *, '   dim2 = ',dim2
         iIrp = -1
      end if
c   o assert dim1 is not less than nIrrps
      if (dim1.lt.nIrrps) then
         print *, '@PARSE_IRP_IARR: The destination array is ',
     &            'too small for the expected data.'
         print *, '   nIrrps = ',nIrrps
         print *, '   dim1   = ',dim1
         iIrp = -1
      end if
      if (iIrp.ne.0) then
         call errex
      end if
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o initialize the destination array
      do j = 1, dim2
      do i = 1, dim1
         iArr(i,j) = 0
      enddo
      enddo
      

c   o quit if the string is empty
      iFirst = fnblnk(szData)
      if (iFirst.eq.0) then
         nSpins = 0
         return
      end if

c   o initialize the iArr indices
      iIrp  = 1
      iSpin = 1

c   o start reading at the beginning and continue until nothing is left
      pStart  = iFirst
      iLength = len(szData)
      bDone   = .false.
      do while (.not.bDone)

c      o find a number
         nChars = 0
         if (pStart.le.iLength) then
            call parse_int(szData(pStart:),iArr(iIrp,iSpin),
     &                     nChars,iErrPos)
            if (iErrPos.ne.0) then
               print *, '@PARSE_SET_IARR: error near position ',
     &                  pStart - 1 + iErrPos
               print *, '"',szData,'"'
               call errex
            end if
            pStart = pStart + nChars
         end if
         if (nChars.eq.0) then
            print *, '@PARSE_SET_IARR: missing value at position ',
     &               pStart
            print *, '"',szData,'"'
            call errex
         end if

c      o point to the next character
         iFirst = 0
         if (pStart.le.iLength) iFirst = fnblnk(szData(pStart:))

         if (iFirst.ne.0) then
c         o process more text

            i = pStart - 1 + iFirst
            czData = szData(i:i)
            if (czData.ne.'-'.and.czData.ne.'/') then
               print *, '@PARSE_IRP_IARR: invalid delimiter at ',
     &                  'position ',i
               print *, '"',szData,'"'
               call errex
            end if
            pStart = i + 1

            if (czData.eq.'-') then
c            o read another irrep value
               if (iIrp.eq.dim1) then
                  print *, '@PARSE_IRP_IARR: number of irreps exceeds ',
     &                     'buffer near position ',pStart
                  print *, '"',szData,'"'
                  call errex
               end if
               iIrp = iIrp + 1
            else
c            o start a new spin column
               if (iSpin.eq.dim2) then
                  print *, '@PARSE_IRP_IARR: too many spin sets'
                  print *, '"',szData,'"'
                  call errex
               end if
               iSpin = iSpin + 1
               if (nIrrps.eq.0) nIrrps = iIrp
               if (iIrp.ne.nIrrps) then
                  print *, '@PARSE_IRP_IARR: number of irreps is ',
     &                     'inconsistent.'
                  print *, '                 ',nIrrps,' expected',
     &                     ' but read ',iIrp,' near position ',pStart
                  print *, '"',szData,'"'
                  call errex
               end if
               iIrp = 1
            end if

c        else if (iFirst.eq.0) then
         else
c         o no text left

            if (nIrrps.eq.0) nIrrps = iIrp
            if (iIrp.ne.nIrrps) then
               print *, '@PARSE_IRP_IARR: number of irreps is ',
     &                  'inconsistent.'
               print *, '                 ',nIrrps,' expected',
     &                  ' but read ',iIrp,' near position ',pStart
               print *, '"',szData,'"'
               call errex
            end if
            bDone = .true.

c        end if (iFirst)
         end if

c     end do while (.not.bDone)
      end do

c   o record the output
      nSpins = iSpin

      return
      end

      subroutine list_next_int(str,ptr,i,err)
      implicit none
      character*(*) str
      integer ptr,err,i
      integer l,pos
      integer  strlen,ncindex
      external strlen,ncindex
      err=0
      l=strlen(str)
      ptr=max(ptr,0)
      ptr=min(ptr,l+1)
      if (ptr.eq.l+1) then
         err=-1
         i=0
         return
      end if
      pos=ncindex(str,',',ptr)
      if (pos.eq.0) then
         call str2int(str(ptr+1:l),i,err)
         pos=l+1
      else
         call str2int(str(ptr+1:pos-1),i,err)
      end if
      if (err.eq.0) ptr=pos
      return
      end

      SUBROUTINE A2MAKE_WFN(DENSA, DENSB, NATORBA, NATORBB, EVECA,
     &                      EVECB, EIGVALA, EIGVALB, SCR1, SCR2,
     &                      OCCA, OCCB, NOCCA, NOCCB, MAXOCCA,
     &                      MAXOCCB, NAOBFNS, NBAS, IUHF, TENERGY)

      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c symm2.com : begin

c This is initialized in vscf/symsiz.

c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end
      integer nirrep,      nbfirr(8),   irpsz1(36),  irpsz2(28),
     &        irpds1(36),  irpds2(56),  irpoff(9),   ireps(9),
     &        dirprd(8,8), iwoff1(37),  iwoff2(29),
     &        inewvc(maxbasfn),         idxvec(maxbasfn),
     &        itriln(9),   itriof(8),   isqrln(9),   isqrof(8),
     &        mxirr2
      common /SYMM2/ nirrep, nbfirr, irpsz1, irpsz2, irpds1, irpds2,
     &               irpoff, ireps,  dirprd, iwoff1, iwoff2, inewvc,
     &               idxvec, itriln, itriof, isqrln, isqrof, mxirr2
c symm2.com : end







c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C
      DOUBLE PRECISION NATORBA, NATORBB, OCCA(NBAS), OCCB(NBAS)
      LOGICAL SCF, COR
      DIMENSION DENSA(NBAS*NBAS), DENSB(NBAS*NBAS), NOCC(16),
     &          NATORBA(NAOBFNS, NAOBFNS), NATORBB(NAOBFNS, NAOBFNS),
     &          EVECA(NBAS, NBAS), EVECB(NBAS, NBAS),
     &          EIGVALA(NBAS), EIGVALB(NBAS), 
     &          SCR1(NBAS*NBAS), SCR2(NBAS*NBAS)
C
      DATA ZILCH, ONE, HALF/ 0.0D0, 1.0D0, 0.50D0/
C
      SCF = (iflags(2) .eq.0)
      COR = (iflags(2) .gt.0)
C
      
      IF (SCF) THEN

         CALL GETREC(20,'JOBARC','SCFEVCA0',NBAS*NBAS*IINTFP, EVECA)
         CALL GETREC(20,'JOBARC','SCFEVLA0',NBAS*IINTFP, EVALA)
         DO IOCC = 1, NOCCA
            OCCA(IOCC) = 2.0D0
         ENDDO
         MAXOCCA = NOCCA
C
         CALL GETREC(20, "JOBARC", "KINETINT", NBAS*NBAS*IINTFP, SCR1)
         CALL GETREC(20, "JOBARC", "SCFDENSA", NBAS*NBAS*IINTFP, SCR2)
         TENERGYA = DDOT(NBAS*NBAS, SCR1, 1, SCR2, 1)
C
         IF (IUHF .EQ. 1) THEN
            CALL GETREC(20,'JOBARC','SCFEVCB0',NBAS*NBAS*IINTFP,
     &                  EVECB)
            CALL GETREC(20,'JOBARC','SCFEVLB0',NBAS*IINTFP, EVALB)
            Do IOCC = 1, NOCCA
               OCCA(IOCC) = 1.0D0
            Enddo
            Do IOCC = 1, NOCCB
                OCCB(IOCC) = 1.0D0
            ENDDO
            MAXOCCB = NOCCB
C
         CALL GETREC(20, "JOBARC", "SCFDENSB", NBAS*NBAS*IINTFP, SCR2)
         TENERGYB = DDOT(NBAS*NBAS, SCR1, 1, SCR2, 1)
C
         ENDIF
         TENERGY = TENERGYA + TENERGYB
      Write(6,*)
      Write(6,"(a,F10.5)") "The total kinetic energy = ", TENERGY
C
      ELSE IF (COR) THEN
C
         CALL GETREC(20,'JOBARC','RELDENSA',NBAS*NBAS*IINTFP,DENSA)
         CALL DCOPY(NBAS*NBAS, DENSA, 1, SCR2, 1)
         CALL MO2AO3(SCR2, DENSA, EVECA, SCR1, NBAS, NBAS, 1, 2)
         CALL GETREC(20, "JOBARC", "KINETINT", NBAS*NBAS*IINTFP, SCR1)
         TENERGYA = DDOT(NBAS*NBAS, DENSA, 1, SCR1, 1)
C
         CALL GETREC(20,'JOBARC','RELDENSA',NBAS*NBAS*IINTFP,DENSA)
C
C
         CALL EIG(DENSA, SCR1, 1, NBAS, -1)
C
         CALL DCOPY(NBAS, DENSA, NBAS+1, OCCA, 1)
         CALL DZERO(EVALA, NBAS)
         MAXOCCA = NBAS
         CALL GETREC(20,'JOBARC','SCFEVECA',NBAS*NBAS*IINTFP,DENSA)
         CALL XGEMM('N','N',NBAS,NBAS,NBAS,ONE,DENSA,NBAS,SCR1, 
     &               NBAS,ZILCH,EVECA,NBAS)
C
      Write(6,*) "The Alpha Natural orbitals AOxMO"
      call output(EVECA, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
C
        IF (IUHF.EQ.1) THEN
           CALL GETREC(20,'JOBARC','RELDENSB',NBAS*NBAS*IINTFP,DENSB)
           CALL DCOPY(NBAS*NBAS, DENSB, 1, SCR2, 1)
           CALL MO2AO3(SCR2, DENSB, EVECA, SCR1, NBAS, NBAS, 2, 2)
           CALL GETREC(20, "JOBARC", "KINETINT", NBAS*NBAS*IINTFP, SCR1)
           TENERGYB = DDOT(NBAS*NBAS, DENSB, 1, SCR1, 1)
C
           CALL GETREC(20,'JOBARC','RELDENSB',NBAS*NBAS*IINTFP,DENSB)
C
       Write(6,*) "The Beta Density read"
       call output(DENSB, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
           CALL EIG(DENSB, SCR1, 1, NBAS, -1)
           CALL DCOPY(NBAS, DENSB, NBAS+1, OCCB, 1)
           CALL DZERO(EVALB, NBAS)
           MAXOCCB = NBAS
           CALL GETREC(20,'JOBARC','SCFEVECB',NBAS*NBAS*IINTFP,DENSB)
           CALL XGEMM('N','N',NBAS,NBAS,NBAS,ONE,DENSB,NBAS,SCR1,
     &                 NBAS,ZILCH,EVECB,NBAS)
      Write(6,*) "The Beta Natural orbitals AOxMO"
      call output(EVECB, 1, NBAS, 1, NBAS, NBAS, NBAS, 1)
        ENDIF
        TENERGY = TENERGYA + TENERGYB

      Write(6,*)
      Write(6,"(a,F10.5)") "The total kinetic energy = ", TENERGY
C
      ENDIF
C
      CALL GETREC(20,'JOBARC','CMP2ZMAT', NBAS*NAOBFNS*IINTFP, SCR1)
      CALl XGEMM('N','N', NAOBFNS, NBAS, NBAS, ONE, SCR1, NAOBFNS, 
     &            EVECA, NBAS, ZILCH, NATORBA, NAOBFNS)
C
      Write(6,*)
      Write(6,*) "The Alpha Natural orbitals NAOBFNSxNMO"
      call output(NATORBA, 1, NAOBFNS, 1, NBAS, NAOBFNS,  NBAS, 1)
C
      IF (IUHF .EQ. 1) THEN
         CALL XGEMM('N','N', NAOBFNS, NBAS, NBAS, ONE, SCR1, NAOBFNS,
     &               EVECB, NBAS, ZILCH, NATORBB, NAOBFNS)
      ENDIF
  
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine fragment_orbitals(fend_nfps, fnshells, atoms) 
      implicit none 
      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'parallel_info.h'
      include 'frag_def.h'
      include 'dropmo.h'

      integer i, j, k, natoms, watom, nao, otemp    
      integer fnshells 
      integer fend_nfps(fnshells)
      integer atoms(fnshells) 

c     logical frag_calc 
c     integer nfrags, natoms_frag, watom_frag 
c     common /FRAGDEF/frag_calc, nfrags, natoms_frag(100), 
c    *                watom_frag(100,100) 

c     integer fragAO, n_occ, n_aocc, n_bocc, n_virt, n_avirt, n_bvirt
c     common /FORBS/fragAO(100), n_occ(100), n_aocc(100), n_bocc(100), 
c    *              n_virt(100), n_avirt(100), n_bvirt(100) 
      
c----------------------------------------------------------------------- 
c  Determine the number of AO's in each fragment 
c----------------------------------------------------------------------- 

      do j = 1, nfrags 
         fragAO(j) = 0 
      do k = 1, natoms_frag(j) 
      do i = 1, fnshells
         watom = atoms(i) 
         if (i .eq. 1) nao = fend_nfps(i) 
         if (i .gt. 1) nao = fend_nfps(i) - fend_nfps(i-1) 
         if (watom .eq. watom_frag(j,k)) fragAO(j) = fragAO(j) + nao  
      enddo 
      enddo 
      enddo 
      
c----------------------------------------------------------------------- 
c  Determine the number of occupied orbitals in each fragment.  
c----------------------------------------------------------------------- 

      do i = 1, nfrags 
         n_occ(i)   = 0 
         n_aocc(i)  = 0 
         n_bocc(i)  = 0 
         n_virt(i)  = 0 
         n_avirt(i) = 0 
         n_bvirt(i) = 0 
         otemp = 0 
      do j = 1, natoms_frag(i) 
         watom = watom_frag(i,j) 
      do k = 1, max_centers ! should ne natoms 
         if (k .eq. watom) then 
            otemp      = otemp + charge(k) ! charge(k)/2 
c           n_bocc(i)  = n_bocc(i) + otemp  
c           n_aocc(i)  = n_aocc(i) + charge(k) - otemp  
         endif 
      enddo 
      enddo 
         n_bocc(i)  = otemp /2  
         n_aocc(i)  = otemp - n_bocc(i)   
         n_avirt(i) = fragAO(i) - n_aocc(i) 
         n_bvirt(i) = fragAO(i) - n_bocc(i) 
      enddo 

c Check for dropmo calculation 
      write(6,*) ' FDROP :', fdrop_flag 
      if (fdrop_flag) then 
c         ndropmo_a = 5 
c         ndropmo_b = 5 
         write(6,*) ' NDROP :', ndropmo_a, ndropmo_b 
         n_aocc(1) = ndropmo_a  
         n_aocc(2) = nalpha_occupied - ndropmo_a  
         n_bocc(1) = ndropmo_b  
         n_bocc(2) = nbeta_occupied - ndropmo_b  
      endif 

c     go to 11 
      if (me .eq. 0) then 

      write(6,10) 
      write(6,20) nfrags  
      write(6,30)   
      write(6,40)  
      do i = 1, nfrags 
         write(6,50) i, natoms_frag(i)   
      do j = 1, natoms_frag(i) 
         write(6,60) watom_frag(i,j), watom_frag(i,j) 
      enddo 
      enddo 

      do i = 1, nfrags
         write(6,*) ' FRAGMENT = ', i 
         write(6,*) '    AO   = ', i, fragAO(i)  
         write(6,*) '    OCCA = ', i, n_aocc(i) 
         write(6,*) '    OCCB = ', i, n_bocc(i) 
         write(6,*) '   VIRTA = ', i, n_avirt(i) 
         write(6,*) '   VIRTB = ', i, n_bvirt(i) 
      enddo 

10    format('Parameters of Fragment calculation') 
20    format('Number of Fragments',I8) 
30    format('Atoms in Fragments') 
40    format(6x,'Frag',12x,'Natoms') 
50    format(6x,I8,10x,I8) 
60    format(4x,'ATOM LABEL',I8,10x,'ATOM',I8) 

      endif 
11    continue 

      end 

c This routine removes all the records in the JOBARC file at the specified
c record and offset. It does not decrease the size of the JOBARC file, it merely
c resets the lookup table data.

c Example:
c  - erase all records after NEXTGEOM
c    call aces_ja_truncate('NEXTGEOM',1)

c INPUT
c char*(*) SZRECORD : the name of the record to measure the offset from
c int      IOFFSET  : the offset from the record index to truncate at

      subroutine aces_ja_truncate(szRecord,iOffset)
      implicit none

c ARGUMENTS
      character*(*) szRecord
      integer iOffset

c EXTERNAL FUNCTIONS
      integer iszeq

c INTERNAL VARIABLES
      integer ndx, i

c COMMON BLOCKS
#include "jobarc.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert job archive subsystem is up
      if (.not.bJAUp) then
         print *, '@ACES_JA_TRUNCATE: Assertion failed.'
         print *, '   szRecord = ',szRecord
         print *, '   bJAUp    = ',bJAUp
         i = 1
      end if
c   o the record name must be between 1 and 8 characters
      if ((len(szRecord).lt.1).or.(len(szRecord).gt.8)) then
         print *, '@ACES_JA_TRUNCATE: Assertion failed.'
         print *, '   szRecord = ',szRecord
         i = 1
      end if
c   o the record cannot be named 'OPENSLOT'
      if (len(szRecord).eq.8) then
      if (szRecord.eq.'OPENSLOT') then
         print *, '@ACES_JA_TRUNCATE: Assertion failed.'
         print *, '   szRecord = ',szRecord
         i = 1
      end if
      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o get the index of the requested record
      ndx = iszeq(_MAX_JA_RECS,marker,1,szRecord)

c   o the record is not found or is at the last position
      if ((ndx.eq.0).or.(ndx.eq._MAX_JA_RECS)) return

c   o point to the truncation record
      ndx = ndx + iOffset

c   o the position is out of bounds
      if ((ndx.lt.1).or.(ndx.gt._MAX_JA_RECS)) return

c   o the record is already empty
      if (marker(ndx).eq.'OPENSLOT') return

c   o reset the remaining structures
      do i = ndx, _MAX_JA_RECS
         marker(i) = 'OPENSLOT'
      end do
      call izero(rloc(ndx), 1+_MAX_JA_RECS-ndx) 
      call izero(rsize(ndx),1+_MAX_JA_RECS-ndx) 

c   o mark JOBARC as modified
      bJAMod = .true.

      return
c     end subroutine aces_ja_truncate
      end

      SUBROUTINE RNABIJ(ICORE,MAXCOR,IUHF,TYPE)
C
C THIS SUBROUTINE DRIVES THE FORMATION OF THE RESORTED <Ab|Ij>
C  AND <AB||IJ> INTEGRALS OR T(Ab;Ij) AND T(AB;IJ) AMPLITUDES AND 
C  WRITES THEM TO DISK.
C
C    INPUT - TYPE (CHARACTER*1): 'W' FOR INTEGRAL RESORTS.
C                                'T' FOR T2 VECTOR RESORTS.
C                                'L' FOR L2 VECTOR RESORTS.
C                                'R' FOR T2 INCREMENT RESORTS.
C                                'C' FOR T2 INCREMENT RESORTS FROM
C                                    A DIFFERENT SET OF LISTS
C
C    FOR RHF, THE AI-bj, Aj-bI AND AI-BJ PACKED LISTS ARE WRITTEN.
C    FOR UHF(ROHF), THE bj-AI, bI-Aj AND ai-bj PACKED LISTS ARE ALSO
C        WRITTEN.
C
C   The 'C' option is only used for iterative MBPT, such as in ROHF
C   with standard orbitals.
C
CEND
      IMPLICIT INTEGER (A-Z)
      CHARACTER*4 SPCASE(2),SPCAS2,RERDTP
      CHARACTER*1 TYPE
      DIMENSION ICORE(MAXCOR),LIST(6)
      COMMON /MACHSP/ NSTART,NIRREP,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA SPCASE /'AABB','BBAA'/
      NNM1O2(I)=(I*(I-1))/2
      NOCA=NOCCO(1)
      NOCB=NOCCO(2)
      NVRTA=NVRTO(1)
      NVRTB=NVRTO(2)
      IF(TYPE.EQ.'W')THEN
       LIST(1)=18
       LIST(2)=17
       LIST(3)=21
       LIST(4)=22
       LIST(5)=19
       LIST(6)=20
       REFLST=16
       RERDTP='AIBJ'
      ELSEIF(TYPE.EQ.'R')THEN
       LIST(1)=37
       LIST(2)=36
       LIST(3)=39
       LIST(4)=38
       LIST(5)=34
       LIST(6)=35
       REFLST=63
       RERDTP='AJBI'
      ELSEIF(TYPE.EQ.'T')THEN
       LIST(1)=37
       LIST(2)=36
       LIST(3)=39
       LIST(4)=38
       LIST(5)=34
       LIST(6)=35
       REFLST=46
       RERDTP='AJBI'
      ELSEIF(TYPE.EQ.'C')THEN
       LIST(1)=37
       LIST(2)=36
       LIST(3)=39
       LIST(4)=38
       LIST(5)=34
       LIST(6)=35
       REFLST=96
       RERDTP='AJBI'
      ELSEIF(TYPE.EQ.'L') THEN
       LIST(1)=137
       LIST(2)=136
       LIST(3)=139
       LIST(4)=138
       LIST(5)=134
       LIST(6)=135
       REFLST=146
       RERDTP='AJBI'
      ENDIF
      ISZTOT=ISYMSZ(13,14)
      NSCRSZ=NOCA*NOCB+NVRTA*NVRTB+NVRTA*NOCA+NVRTB*NOCB
      ISZTAR=ISYMSZ(9,10)
      ISZTAR2=ISYMSZ(11,12)
      I000=1
      I010=I000+IINTFP*MAX(ISZTOT,ISZTAR,ISZTAR2)
      I020=I010+IINTFP*MAX(ISZTOT,ISZTAR,ISZTAR2)
      I030=I020+NSCRSZ
      IF(I030.GT.MAXCOR)CALL INSMEM('RNABIJ',I030,MAXCOR)
C
C WRITE AI-bj AND Aj-bI ORDERINGS AND bj-AI AND bI-Aj IF UHF.
C
      DO 20 I=1,1+IUHF
       CALL GETALL(ICORE(I000),ISZTOT,1,REFLST)
       CALL SST002(ICORE(I000),ICORE(I010),ISZTOT,ISZTAR,ICORE(I020),
     &             SPCASE(I))
       CALL PUTALL(ICORE(I010),ISZTAR,1,LIST(I))
       CALL SSTRNG(ICORE(I010),ICORE(I000),ISZTAR,ISZTAR2,ICORE(I020),
     &             SPCASE(I))
       CALL PUTALL(ICORE(I000),ISZTAR2,1,LIST(2+I))
20    CONTINUE
C
C WRITE AI-BJ INTEGRALS (ai-bj FOR UHF IF ISPIN=2)
C
      SPCAS2='AAAA'
      DO 30 ISPIN=1,1+IUHF
       ISZTOT=ISYMSZ(ISPIN,ISPIN+2)
       ISZTAR=ISYMSZ(8+ISPIN,8+ISPIN)
       NSCRSZ=NNM1O2(NVRTO(ISPIN))+NNM1O2(NOCCO(ISPIN))+
     &        NVRTO(ISPIN)*NOCCO(ISPIN)
       I000=1
       I010=I000+IINTFP*MAX(ISZTOT,ISZTAR)
       I020=I010+IINTFP*ISZTAR
       I030=I020+NSCRSZ
       IF(I030.GT.MAXCOR)CALL INSMEM('RNABIJ',I030,MAXCOR)
       CALL GETALL(ICORE(I000),ISZTOT,1,REFLST-3+ISPIN)
       CALL SST003(ICORE(I000),ICORE(I010),ISZTOT,ISZTAR,ICORE(I020),
     &             SPCAS2,RERDTP)
       CALL PUTALL(ICORE(I010),ISZTAR,1,LIST(4+ISPIN))
       SPCAS2='BBBB'
30    CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

#include "flags.h"

      subroutine aces2_joda_main()
      implicit none

#include "fnamelen.par" 
      character*(fnamelen)fname
      integer pass1, i, i_havegeom, ipost_vib, ilength, ijunk,
     &        i_havegrd, i_manfndf
      logical fd, geomopt, num_grad, vib_frqs, we_havegeom,
     &        optarc_presnt

      integer iMemMin, iMemInc, Popt_num_fd
      parameter (iMemMin=2097152)
      parameter (iMemInc=1048576)

      integer*8 malloced_previously
      integer*8 ixz
      integer*8 get_max_heap_usage
      integer*8 symcor_mem_bytes, maxheap_bytes
      integer*8 gentranmat_mem_bytes
      integer symcor_ints
      integer gentranmat_ints
 
      integer ishell
      external ishell

#include "icore.com"
#include "istart.com"
      logical ignore
      common /restart_com/ ignore
#include "jodaflags.com"
#include "mxatms.par"
      include 'machine_types.h'

      integer memreq, m, ierr
      double precision z(1)
      integer iz(1)
      equivalence (z, iz)
#ifdef ALTIX
      include 'sheap.h'
      pointer (dptr, z)
#else
#ifndef BLUEGENE
      common z
#endif
#endif

#ifdef _TRAPFPE
c   o since JODA does not call crapsi, have it turn on FPEs
      call trapfpe
#endif /* _TRAPFPE */

#ifdef ALTIX
      dptr = dshptr
#endif

c      m      = max(mxatms, maxredunco) chenged 3/5/2012 VFL  
       m      = max(3*mxatms, maxredunco) 
       memreq = 16*m*m + 34*m

c   o gather parallel statistics (needed by gfname in ja_init)
c      call aces_com_parallel_aces

c   o parse command line (overwrites rank and number of processes)
c      call parse_cli

c   o evaluate and repair the health of the current file set
      call dfiles(ignore)

c   o initialize the job archive subsystem
      call aces_ja_init

      if (.not.ignore) then
c      o this is the first joda run
         call iputrec(1,'JOBARC','FIRSTRUN',1,1)
         call iputrec(1,'JOBARC','DIRTYFLG',1,0)
         call iputrec(1,'JOBARC','JODADONE',1,0)
         call iputrec(1,'JOBARC','FNDFDONE',1,1)

c------------------------------------------------------------------------------
c   Allocate heap memory for GEOPT.
c------------------------------------------------------------------------------

         call mem_alloc(z, memreq, bytes_per_double, ixz, .true., ierr)
         if (ierr .ne. 0) then
            print *,'ACES2_JODA_MAIN: failure allocating Z array'
            print *,'memreq = ',memreq
            call abort_job()
         endif

         call geopt(z(ixz), memreq)
         call mem_alloc_reset()         ! release the memory.
      else
c      o load flags
         call igetrec(1,'JOBARC','IFLAGS', 100,iflags)
         call igetrec(1,'JOBARC','IFLAGS2',500,iflags2)
      end if
c
      call igetrec(-1,'JOBARC', 'HAVEGEOM',1, i_havegeom)
      call igetrec(-1, 'JOBARC', 'POSTOPFD', 1, popt_num_fd)
c
      call gfname('OPTARC', fname, ilength)
      inquire(file=fname(1:ilength), exist=optarc_presnt)
c
      If (i_havegeom .eq. 1) we_havegeom = .true.
      geomopt=(iflags2(h_IFLAGS2_geom_opt).ne.0) .and.
     &         .not. we_havegeom
      num_grad=(iflags2(h_IFLAGS2_grad_calc).eq.2)
      vib_frqs=(iflags(h_IFLAGS_vib).eq.3)
c
      fd = ((iflags(h_IFLAGS_vib).eq.3 .and. we_havegeom)
     &     .or. num_grad .or. (geomopt.and.num_grad))
c
#ifdef _DEBUG_LVL0
      Print*, "Finite diffs; ignore and geomopt vars:",
     &         ignore, geomopt
      Print*, "The vib calc. related varrs:"
      Print*, "iflags(h_IFLAGS_vib):", iflags(h_IFLAGS_vib)
      Print*, "The finite diffs:", fd
      Print*, "iflags2(h_IFLAGS2_geom_opt):",
     &         iflags2(h_IFLAGS2_geom_opt)
      Print*, "first run of popt num. frq:", popt_num_fd
 
#endif
c
C Following lines are added to mimic single point gradient
C calcualtions during manual parallel finte difference 
C vib. frq. calculations, Ajith Perera, 04/2011.

      Call igetrec(0,'JOBARC', 'GRADIENT',i_havegrd, ijunk)
      Call igetrec(0,'JOBARC', 'MANULFDS',i_manfndf, ijunk)
    
      If (i_havegrd .gt. 0 .and. i_manfndf .gt. 0 .and. fd) Then
         Write(6,"(a,a)") " Single point gradient calculation ",
     &                      "is completed"
         call aces_ja_fin
         call aces_exit(1)
      Endif

      if (fd) then
c         print *,'Finite differences are not currently supported.'
c         call errex()

c      o allocate memory for symcor
c         icrsiz = iflags(h_IFLAGS_mem)
          
c         do while ((iCore(1).eq.0).and.(icrsiz.gt.iMemMin))
c            call aces_malloc(icrsiz,iCore,i0, symcor_heap)
c            if (symcor_heap.eq.0) icrsiz = icrsiz - iMemInc
c         end do
c         if (symcor_heap.eq.0) then
c            print *, '@JODA: unable to allocate at least ',
c     &               iMemMin,' integers of memory'
c            call aces_exit(1)
c            call errex() 
c         end if
c
          if (ignore) then 
c         o mid-stream -> keep going
            call igetrec(1,'JOBARC','FNDFDONE',1,i)
            if (popt_num_fd .eq. 1) call post_opt_update
            if (i.eq.0) then

c------------------------------------------------------------------------
c   Set up heap for symcor.
c------------------------------------------------------------------------

               maxheap_bytes = get_max_heap_usage()
               call mem_alloc_query(malloced_previously)
               symcor_mem_bytes = maxheap_bytes - malloced_previously
               symcor_ints = symcor_mem_bytes / intsize 
               call mem_alloc(iz, symcor_ints, intsize, ixz, .true., 
     *                     ierr)
               if (ierr .ne. 0) then
                  print *,'SYMCOR MEM ALLOC ERROR'
                  print *,'maxheap_bytes, malloced_previously ', 
     *                     maxheap_bytes, malloced_previously
                  print *,'symcor_ints ',symcor_ints
                  call abort_job() 
               endif 
               call symcor(iz(ixz), symcor_ints)

c-------------------------------------------------------------------------
c   Undo the symcor heap.
c-------------------------------------------------------------------------

               call mem_alloc_reset()
            endif 
         else
c         o first run -> reset finite difference series
            if (geomopt) i=ishell('cp OPTARC OPTARCBK')
            call iputrec(1,'JOBARC','FNDFDONE',1,0)

c------------------------------------------------------------------------
c   Set up heap for symcor.
c------------------------------------------------------------------------

            maxheap_bytes = get_max_heap_usage()
            call mem_alloc_query(malloced_previously)
            symcor_mem_bytes = maxheap_bytes - malloced_previously
            symcor_ints      = symcor_mem_bytes / intsize 
            call mem_alloc(iz, symcor_ints, intsize, ixz, .true., 
     *                     ierr)
            if (ierr .ne. 0) then
               print *,'SYMCOR MEM ALLOC ERROR'
               print *,'maxheap_bytes, malloced_previously ',
     *              maxheap_bytes, malloced_previously
               print *,'symcor_ints ',symcor_ints
               call abort_job() 
            endif 
            call symcor(iz(ixz), symcor_ints)

c-------------------------------------------------------------------------
c   Undo the symcor heap.
c-------------------------------------------------------------------------

            call mem_alloc_reset()
            ignore=.true.
         end if

         call igetrec(1,'JOBARC','PASS1',1,pass1)
         if (pass1.ne.-1) then
c         o vib freqs w/ an grads -OR- geom opts w/ num grads
            call iputrec(1,'JOBARC','FIRSTRUN',1,0)
            call iputrec(1,'JOBARC','DIRTYFLG',1,1)
            if (geomopt.and.pass1.eq.0) then
               i=ishell('cp OPTARCBK OPTARC')

c------------------------------------------------------------------------------
c   Allocate heap memory for GEOPT.
c------------------------------------------------------------------------------

               call mem_alloc(z, memreq, bytes_per_double, ixz, 
     *                        .true., ierr)
               if (ierr .ne. 0) then
                  print *,'ACES2_JODA_MAIN: failure allocating Z array'
                  print *,'memreq = ',memreq
                  call abort_job()
               endif

               call geopt(z(ixz), memreq)
               call mem_alloc_reset()         ! release the memory.

               call igetrec(1,'JOBARC','JODADONE',1,i)
               if (i.ne.1) then
c               o new geom -> reset finite difference series
                  i=ishell('cp OPTARC OPTARCBK')
                  call iputrec(1,'JOBARC','FNDFDONE',1,0)
c------------------------------------------------------------------------
c   Set up heap for symcor.
c------------------------------------------------------------------------

                  maxheap_bytes = get_max_heap_usage()
                  call mem_alloc_query(malloced_previously)
                  symcor_mem_bytes = maxheap_bytes - malloced_previously
                  symcor_ints      = symcor_mem_bytes / intsize 
                  call mem_alloc(iz, symcor_ints, intsize, ixz, .true., 
     *                     ierr)
                  if (ierr .ne. 0) then
                     print *,'SYMCOR MEM ALLOC ERROR'
                     print *,'maxheap_bytes, malloced_previously ',
     *                    maxheap_bytes, malloced_previously
                     print *,'symcor_ints ',symcor_ints
                     call abort_job() 
                  endif 
                  call symcor(iz(ixz), symcor_ints)

c-------------------------------------------------------------------------
c   Undo the symcor heap.
c-------------------------------------------------------------------------

                  call mem_alloc_reset()

c------------------------------------------------------------------------------
c   Allocate heap memory for GEOPT.
c------------------------------------------------------------------------------

                  call mem_alloc(z, memreq, bytes_per_double, ixz,
     *                        .true., ierr)
                  if (ierr .ne. 0) then
                     print *,'ACES2_JODA_MAIN: failure allocating ',
     *                       'Z array'
                     print *,'memreq = ',memreq
                     call abort_job()
                  endif

                  call geopt(z(ixz), memreq)
                  call mem_alloc_reset()         ! release the memory.
               end if
            else if (vib_frqs .or. num_grad) then 
               if (we_havegeom .and. optarc_presnt) 
     &             i=ishell('rm OPTARC')
               call igetrec(1,'JOBARC','FNDFDONE',1,i)
c------------------------------------------------------------------------------
c   Allocate heap memory for GEOPT.
c------------------------------------------------------------------------------

               call mem_alloc(z, memreq, bytes_per_double, ixz,
     *                        .true., ierr)
               if (ierr .ne. 0) then
                  print *,'ACES2_JODA_MAIN: failure allocating Z array'
                  print *,'memreq = ',memreq
                  call abort_job()
               endif

               call geopt(z(ixz), memreq)
               call mem_alloc_reset()         ! release the memory.

               if (pass1.eq.0) call iputrec(1,'JOBARC','JODADONE',1,1)
               call igetrec(1,'JOBARC','FNDFDONE',1,i) 
            end if
         end if

      else

         if (ignore) then
c         o joda has run before
            call iputrec(1,'JOBARC','FIRSTRUN',1,0)
            call iputrec(1,'JOBARC','DIRTYFLG',1,1)
c------------------------------------------------------------------------------
c   Allocate heap memory for GEOPT.
c------------------------------------------------------------------------------

            call mem_alloc(z, memreq, bytes_per_double, ixz,
     *                        .true., ierr)
            if (ierr .ne. 0) then
               print *,'ACES2_JODA_MAIN: failure allocating Z array'
               print *,'memreq = ',memreq
               call abort_job()
            endif

            call geopt(z(ixz), memreq)
            call mem_alloc_reset()         ! release the memory.
         end if

      end if


      maxheap_bytes = get_max_heap_usage()
      call mem_alloc_query(malloced_previously)
      gentranmat_mem_bytes = maxheap_bytes - malloced_previously
      gentranmat_ints = gentranmat_mem_bytes / intsize
      call mem_alloc(iz, gentranmat_ints, intsize, ixz, .true.,
     *               ierr)
      if (ierr .ne. 0) then
         print *,'GENTRANMAT MEM ALLOC ERROR'
         print *,'maxheap_bytes, malloced_previously ',
     *            maxheap_bytes, malloced_previously
         print *,'gentranmat_ints ',gentranmat_ints
         call abort_job()
      endif

CSSS      call gentranmat(iz(ixz), gentranmat_ints)

c---------------------------------------------------------------------------
c   Free any heap memory that might have been used.  It must be made
c   available for the ACES III code's use.
c---------------------------------------------------------------------------

      call mem_alloc_reset()

c----------------------------------------------------------------------------
c   For vib_findif=exact, set jodadone flag to 1.
c----------------------------------------------------------------------------

      if (iflags(h_IFLAGS_vib) .eq. 1) then
         call iputrec(1,'JOBARC', 'JODADONE', 1, 1)
      endif

c   o finalize the job archive subsystem
      call aces_ja_fin

      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_1D_P_INTEGRALS
     +
     +                    ( SHELLP,
     +                      NGEXCEN,
     +                      WTS,
     +                      R1X,R1Y,R1Z,
     +                      R2,
     +
     +                               INT1DX,
     +                               INT1DY,
     +                               INT1DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_1D_P_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 1D P X,Y,Z
C                nuclear attraction integrals using the Rys vertical
C                recurrence scheme explained below.
C
C                The recurrence scheme is due to Rys, Dupuis and King,
C                J. Comp. Chem. 4, p.154-157 (1983).
C
C
C                   INT1D (0,0) = 1.D0    (* WEIGHT for the 1DX case)
C                   INT1D (1,0) = R1      (* WEIGHT for the 1DX case)
C
C                   For I = 1,...,SHELLP-1
C                       INT1D (I+1,0) = I * R2 * INT1D (I-1,0)
C                                         + R1 * INT1D (I,0)
C
C
C                The 1D P X,Y,Z integrals are calculated for all nuclear
C                centers, all exponent pairs and all quadrature points
C                simultaneously and placed into a 2-dimensional array.
C
C
C                  Input:
C
C                    SHELLP      =  maximum shell type A+B
C                    NGEXCEN     =  # of roots times # of primitive
C                                   exponent pairs times # of nuclear
C                                   attraction centers
C                    WTS         =  all quadrature weights
C                    R1x         =  the VRR R1-coefficients (individual
C                                   cartesian components x=X,Y,Z) for
C                                   shell expansion on center P
C                    R2          =  the coordinate independent VRR
C                                   R2-coefficients
C
C
C                  Output:
C
C                    INT1Dx      =  all 1D P nuclear attraction
C                                   integrals for each cartesian
C                                   component (x = X,Y,Z)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         INTEGER   I,N
         INTEGER   I1,I2
         INTEGER   NGEXCEN
         INTEGER   SHELLP

         DOUBLE PRECISION  F
         DOUBLE PRECISION  ONE
         DOUBLE PRECISION  R2N

         DOUBLE PRECISION  R1X  (1:NGEXCEN)
         DOUBLE PRECISION  R1Y  (1:NGEXCEN)
         DOUBLE PRECISION  R1Z  (1:NGEXCEN)
         DOUBLE PRECISION  R2   (1:NGEXCEN)
         DOUBLE PRECISION  WTS  (1:NGEXCEN)

         DOUBLE PRECISION  INT1DX (1:NGEXCEN,0:SHELLP)
         DOUBLE PRECISION  INT1DY (1:NGEXCEN,0:SHELLP)
         DOUBLE PRECISION  INT1DZ (1:NGEXCEN,0:SHELLP)

         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...initialize 1D nuclear attraction integrals.
C
C
         DO 100 N = 1,NGEXCEN
            INT1DX (N,0) = WTS (N)
            INT1DY (N,0) = ONE
            INT1DZ (N,0) = ONE
  100    CONTINUE

         IF (SHELLP.EQ.0) RETURN
C
C
C             ...proceed, if total shell is > s-shell.
C
C
         DO 200 N = 1,NGEXCEN
            INT1DX (N,1) = WTS (N) * R1X (N)
            INT1DY (N,1) = R1Y (N)
            INT1DZ (N,1) = R1Z (N)
  200    CONTINUE

         F = ONE
         DO 220 I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO 230 N = 1,NGEXCEN
               R2N = F * R2 (N)
               INT1DX (N,I) =       R2N * INT1DX (N,I2)
     +                        + R1X (N) * INT1DX (N,I1)
               INT1DY (N,I) =       R2N * INT1DY (N,I2)
     +                        + R1Y (N) * INT1DY (N,I1)
               INT1DZ (N,I) =       R2N * INT1DZ (N,I2)
     +                        + R1Z (N) * INT1DZ (N,I1)
  230       CONTINUE
            F = F + ONE
  220    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine remove_work_head(node)
c---------------------------------------------------------------------------
c   Removes the head node off the server's work list, and returns its
c   node index in "node".
c
c   If the list is empty, a negative value is returned.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      integer node

      if (server_work_list_head .lt. 1) then
         node = -1
      else
         node = server_work_list_head
         server_work_list_head = server_msg(c_server_list_ptr,node) 
         server_msg(c_server_list_ptr,node) = 0

         if (server_work_list_head .eq. 0) 
     *       server_work_list_tail = 0
      endif

      return
      end

      SUBROUTINE PROCESS_REDINTRNLS(Q, REDUNCO, IREDUNCO, IBNDTO, 
     &                              I_UNIQUE, PTGRP, TOTNOFBND, 
     &                              TOTNOFANG, TOTNOFDIH, TOTREDNCO,
     &                              NEQ, IEQUIV, NATOMS, IPLUS_MINUS,
     &                              IPRNT, EPSILON)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
C
      INTEGER TOTREDNCO, ORDER_PTGRP, TOTNOFBND, TOTNOFANG, 
     &        TOTNOFDIH
      LOGICAL SYMEQVLNT, SAME_BGN, I_UNIQUE(TOTREDNCO), SAME_END,
     &        SAME_MID, EQEV_MID, EQEV_BRDGE, SAME_TWO, ABELIAN,
     &        SAMEDIHS, SAMEBNDS, SAMEANGLS, SAME_PLANE(MXATMS),
     &        PM_PAIR, CHECK_PM_PAIR, PRV_USED
      CHARACTER*4 PTGRP

      DIMENSION IREDUNCO(4, TOTREDNCO), IBNDTO(NATOMS, NATOMS),
     &          Q(3*NATOMS), NEQ(MAXREDUNCO), REDUNCO(TOTREDNCO), 
     &          IEQUIV(3*MXATMS, 3*MXATMS), 
     &          IUNIQUE_OFFSET(MAXREDUNCO), IPLUS_MINUS(MAXREDUNCO),
     &          I_PAIR_FLAG(MAXREDUNCO)
C
      CALL IZERO(IBNDTO, NATOMS*NATOMS) 
      CALL IZERO(IPLUS_MINUS, MAXREDUNCO)
      ABELIAN = .FALSE. 

      IF (PTGRP .EQ. "C2v ") THEN
         ABELIAN     = .TRUE. 
         ORDER_PTGRP = 4
      ELSE IF (PTGRP .EQ. "D2h ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 8 
      ELSE IF (PTGRP .EQ. "D2  ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 4
      ELSE IF (PTGRP .EQ. "C2  ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 2
      ELSE IF (PTGRP .EQ. "C2h ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 4
      ELSE IF (PTGRP .EQ. "C s ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 2 
      ELSE IF (PTGRP .EQ. "C i ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 2 
      ELSE IF (PTGRP .EQ. "C1  ") THEN
         ABELIAN     = .TRUE.
         ORDER_PTGRP = 1  
      ENDIF 
C
C Let's get the permutation of atoms with highest order symmetry 
C operation, and the order of the highest rotation axis.
C
      IF (.NOT. ABELIAN) THEN
         CALL GETREC(20, "JOBARC", "SYMEQUIV", NATOMS, NEQ)
      ENDIF 
C
CSSS      WRITE(6,*) "The Permu. Array"
CSSS      WRITE(6,*) (NEQ(I), I= 1, NATOMS)
C
      IF (ABELIAN) THEN
         DO IATOM = 1, NATOMS  
            DO JATOM = 1, NATOMS
               IF (IATOM .NE. JATOM) THEN
                  CALL IDNTFY_SYMEQV_ATMS(PTGRP, ORDER_PTGRP, 
     &                                    Q((IATOM - 1)*3 + 1), 
     &                                    Q((JATOM - 1)*3 + 1),
     &                                    SYMEQVLNT)
                  IF (SYMEQVLNT) THEN 
                     IBNDTO(JATOM, IATOM) = 1
                  ENDIF 
               ENDIF
            ENDDO
         ENDDO
C
      ELSE
C
         DO IATOM = 1, NATOMS
C
            KATOM1 = NEQ(IATOM)
C
            DO JATOM = 1, IATOM - 1

               KATOM2 = NEQ(JATOM)

               IBNDTO(IATOM, KATOM1) = 1
               IBNDTO(KATOM1, IATOM) = 1
               IBNDTO(JATOM, KATOM2) = 1
               IBNDTO(KATOM2, JATOM) = 1
C
               IF (IATOM .EQ. KATOM2) THEN
                  IBNDTO(JATOM, KATOM1) = 1
                  IBNDTO(KATOM1, JATOM) = 1
               ENDIF
               IF (JATOM .EQ. KATOM1) THEN
                  IBNDTO(KATOM2, IATOM) = 1
                  IBNDTO(IATOM, KATOM2) = 1
               ENDIF
               IF (IBNDTO(JATOM, KATOM1) .EQ. 1) THEN
                  IBNDTO(KATOM2, IATOM) = 1
                  IBNDTO(IATOM, KATOM2) = 1
               ENDIF
               IF (IBNDTO(JATOM, KATOM2) .EQ. 1) THEN
                   IBNDTO(IATOM, KATOM1) = 1
                   IBNDTO(KATOM1, IATOM) = 1
               ENDIF
               IF (IBNDTO(IATOM, KATOM2) .EQ. 1) THEN
                  IBNDTO(JATOM, KATOM1) = 1
                  IBNDTO(KATOM1, JATOM) = 1
               ENDIF
               IF (IBNDTO(IATOM, KATOM1) .EQ. 1) THEN
                   IBNDTO(JATOM, KATOM2) = 1
                   IBNDTO(KATOM2, JATOM) = 1
               ENDIF
C
            ENDDO 
         ENDDO
C
      ENDIF
C
C Before we identify symmetry equivalent bonds, angles and dihedral
C angles, we need to some way to identify the atoms that can make 
C plus-minus dihedral pairs. At this point the logic is built on
C the condition that dihedral pairs arise when two symmetry identical
C atoms below or above (left or right) of a plane or axis of symmetry
C and three of the atoms that make the dihedral is on the plane or
C axis of symmetry. 
C
      IF (NATOMS .GE. 4 .AND. .NOT. PTGRP .EQ. "C1  " ) THEN
         CALL GETREC(20, "JOBARC", "SAMEPLNE", NATOMS, NEQ)
cSSS         WRITE(6,*) (NEQ(I), I=1,NATOMS)
         DO IATOM = 1, NATOMS
            IF (NEQ(IATOM) .EQ. IATOM) SAME_PLANE(IATOM) = .TRUE. 
         ENDDO
      ENDIF
C
CSSS      WRITE(6,*) "SAME PLANE ARRAY"
CSSS      WRITE(6,*) (SAME_PLANE(I), I=1, NATOMS)
C
C Identify the symmetry unique RIC bond coordinates.
C
CSSS      WRITE(6,*) "Symmetry Equivalent Atoms"
CSSS      WRITE(6,*) IBNDTO
cSSS      WRITE(6,*) TOTNOFBND, TOTNOFANG, TOTNOFDIH
      CALL IZERO(NEQ, MAXREDUNCO)
      IUNIQUE = 0 
      DO IBONDS = 1, TOTNOFBND
         IBGN = IREDUNCO(1, IBONDS)
         IEND = IREDUNCO(2, IBONDS) 
         DO JBONDS = 1, IBONDS - 1
            SAMEBNDS = (DABS(REDUNCO(IBONDS) - REDUNCO(JBONDS))
     &                  .LE. EPSILON)
            IF (SAMEBNDS) THEN
               IF (IBONDS .NE. JBONDS) THEN
                  SAME_BGN = .FALSE.
                  SAME_END = .FALSE. 
                  SAME_TWO = .FALSE.
                  JBGN = IREDUNCO(1, JBONDS)
                  JEND = IREDUNCO(2, JBONDS)
cSSS                  WRITE(6,*) IBONDS, JBONDS 
cSSS                  IF (IPRNT .GT. 10) WRITE(6,*) IBGN, IEND, JBGN, 
cSSS     &                               JEND, IUNIQUE
                  IF (IBGN .EQ. JBGN) SAME_BGN = .TRUE. 
                  IF ((IBNDTO(JEND, IEND) .NE. 0) .AND. (SAME_BGN))
     &               THEN 
                     IF (IUNIQUE_OFFSET(JBONDS) .NE. 0) THEN
                        IOFFSET = IUNIQUE_OFFSET(JBONDS)
                     ENDIF
                     NEQ(IOFFSET) = NEQ(IOFFSET) + 1 
                     IEQUIV(IOFFSET, NEQ(IOFFSET)) = IBONDS
cSSS            WRITE(6,*) IBONDS, JBONDS, NEQ(JBONDS)
cSSS            WRITE(6,*) IEQUIV(JBONDS, NEQ(JBONDS))
C
                     GO TO 10 
                  END IF
C
                  IF (IEND .EQ. JEND) SAME_END = .TRUE.
                  IF ((IBNDTO(JBGN, IBGN) .NE. 0) .AND. (SAME_END))
     &               THEN 
                     IF (IUNIQUE_OFFSET(JBONDS) .NE. 0) THEN
                        IOFFSET = IUNIQUE_OFFSET(JBONDS)
                     ENDIF
                     NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                     IEQUIV(IOFFSET, NEQ(IOFFSET)) = IBONDS
cSSS            WRITE(6,*) IBONDS, JBONDS, NEQ(JBONDS)
cSSS            WRITE(6,*) IEQUIV(JBONDS, NEQ(JBONDS))
C
                     GO TO 10
                  ENDIF
C
                  IF (IBGN .EQ. JEND) SAME_TWO = .TRUE.
                  IF ((IBNDTO(JBGN, IEND) .NE. 0) .AND. (SAME_TWO))
     &            THEN
                     IF (IUNIQUE_OFFSET(JBONDS) .NE. 0) THEN
                        IOFFSET = IUNIQUE_OFFSET(JBONDS)
                     ENDIF
                     NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                     IEQUIV(IOFFSET, NEQ(IOFFSET)) = IBONDS
cSSS            WRITE(6,*) IBONDS, JBONDS, NEQ(IUNIQUE)
cSSS            WRITE(6,*) IEQUIV(JBONDS, NEQ(JBONDS))
C
                     GO TO 10
                  ENDIF
C
                  IF (IEND .EQ. JBGN) SAME_TWO = .TRUE.
                  IF ((IBNDTO(JEND, IBGN) .NE. 0) .AND. (SAME_TWO))
     &            THEN
                     IF (IUNIQUE_OFFSET(JBONDS) .NE. 0) THEN
                        IOFFSET = IUNIQUE_OFFSET(JBONDS)
                     ENDIF
                     NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                     IEQUIV(IOFFSET, NEQ(IOFFSET)) = IBONDS
cSSS            WRITE(6,*) "I am Here"
cSSS            WRITE(6,*) IBONDS, JBONDS, NEQ(IUNIQUE)
cSSS            WRITE(6,*) IEQUIV(JBONDS, NEQ(JBONDS))
C
                     GO TO 10
                  ENDIF
C
                  IF ((IBNDTO(IBGN, JBGN) .NE. 0) .AND.
     &               (IBNDTO(IEND, JEND) .NE. 0) .OR.
     &               (IBNDTO(IBGN, JEND) .NE. 0) .AND.  
     &               (IBNDTO(IEND, JBGN) .NE. 0))
     &            THEN
                     IF (IUNIQUE_OFFSET(JBONDS) .NE. 0) THEN
                        IOFFSET = IUNIQUE_OFFSET(JBONDS)
                     ENDIF
                     NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                     IEQUIV(IOFFSET, NEQ(IOFFSET)) = IBONDS
cSSS            WRITE(6,*) IBONDS, JBONDS, NEQ(JBONDS)
cSSS            WRITE(6,*) IEQUIV(JBONDS, NEQ(JBONDS))
C
                     GO TO 10
                  ENDIF
C 
               ENDIF
            ENDIF
C
         END DO
C
         I_UNIQUE(IBONDS) = .TRUE. 
         IUNIQUE = IUNIQUE + 1
         IUNIQUE_OFFSET(IBONDS) = IUNIQUE
C
 10      CONTINUE
C
      END DO
C
C Identify the symmetry unique RIC angle coordinates. Also, this block 
C of code mark the bond angles that are constrained by symmetry. For
C exmple 60 degere bond angles in BF3 are symmetry constrained. 
C 
cSSS      WRITE(6,*) (IUNIQUE_OFFSET(J), J = 1, TOTNOFBND)
      DO IANGL = (TOTNOFBND + 1), (TOTNOFANG + TOTNOFBND)
         IBGN = IREDUNCO(1, IANGL)
         IMID = IREDUNCO(2, IANGL)
         IEND = IREDUNCO(3, IANGL)
         DO JANGL = (TOTNOFBND + 1), IANGL - 1 
            SAMEANGLS = (DABS(REDUNCO(IANGL) - REDUNCO(JANGL))
     &                  .LE. EPSILON)
            IF (SAMEANGLS) THEN
cSSS               WRITE(6,*) IANGL, JANGL
               SAME_MID = .FALSE.
               EQEV_MID = .FALSE. 
               JBGN = IREDUNCO(1, JANGL)
               JMID = IREDUNCO(2, JANGL)
               JEND = IREDUNCO(3, JANGL)
               IF (IANGL .NE. JANGL) THEN
                  IF (IMID .EQ. JMID)  SAME_MID = .TRUE.
                     IF (SAME_MID) THEN 
cSSS                     WRITE(6,*) "CHECKING SYM EQV ANGLES"
cSSS                     WRITE(6,*) IBGN, JBGN,IEND, JEND
cSSS                     WRITE(6,*) IBNDTO(IBGN, JBGN), IBNDTO(IEND, JEND),
cSSS     &                          IBNDTO(IEND, JBGN), IBNDTO(IBGN, JEND)
                         IF (IBGN .EQ. JBGN .AND. 
     &                      IBNDTO(IEND, JEND) .NE. 0) THEN 
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*)IANGL,JANGL,NEQ(IOFFSET),IOFFSET
                            GO TO 20
                         ENDIF
                         IF (IEND .EQ. JEND .AND. 
     &                      IBNDTO(IBGN, JBGN) .NE. 0) THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*)IANGL,JANGL,NEQ(IOFFSET),IOFFSET
                            GO TO 20
                         ENDIF
                         IF (IBGN .EQ. JEND .AND. 
     &                      IBNDTO(IEND, JBGN) .NE. 0) THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*)IANGL,JANGL,NEQ(IOFFSET),IOFFSET
                            GO TO 20
                         ENDIF
                         IF (IEND .EQ. JBGN .AND. 
     &                      IBNDTO(IBGN, JEND) .NE. 0) THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*) IANGL,JANGL, NEQ(IOFFSET),IOFFSET
                            GO TO 20
                         ENDIF
                         IF ((IBNDTO(IBGN, JBGN) .NE. 0) .AND. 
     &                      (IBNDTO(IEND, JEND) .NE. 0)  .OR. 
     &                      (IBNDTO(IBGN, JEND) .NE. 0)  .AND.
     &                      (IBNDTO(IEND, JBGN) .NE. 0))
     &                   THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*) IANGL,JANGL,NEQ(IOFFSET),IOFFSET
                            GO TO 20
                         ENDIF
                     ENDIF
C
                     IF (IBNDTO(IMID, JMID) .NE. 0) EQEV_MID = .TRUE. 
                     IF (EQEV_MID) THEN
                        IF (IBGN .EQ. JBGN .AND.
     &                      IBNDTO(IEND, JEND) .NE. 0) THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*)IANGL,JANGL,NEQ(IOFFSET),IOFFSET
                           GO TO 20
                        ENDIF
                        IF (IBGN .EQ. JEND .AND.
     &                      IBNDTO(IEND, JBGN) .NE. 0) THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*)IANGL,JANGL,NEQ(IOFFSET),IOFFSET
                            GO TO 20
                        ENDIF
                        IF (IEND .EQ. JBGN .AND.
     &                      IBNDTO(IBGN, JEND) .NE. 0) THEN
                            IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                               IOFFSET = IUNIQUE_OFFSET(JANGL)
                            ENDIF
                            NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                            IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                            WRITE(6,*) IANGL,JANGL, NEQ(IOFFSET),IOFFSET
                            GO TO 20
                         ENDIF
                         IF ((IBNDTO(IBGN, JBGN) .NE. 0) .AND.
     &                     (IBNDTO(IEND, JEND) .NE. 0)  .OR. 
     &                     (IBNDTO(IBGN, JEND) .NE. 0)  .AND.
     &                     (IBNDTO(IEND, JBGN) .NE. 0)) 
     &                   THEN
                           IF (IUNIQUE_OFFSET(JANGL) .NE. 0) THEN
                              IOFFSET = IUNIQUE_OFFSET(JANGL)
                           ENDIF
                           NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                           IEQUIV(IOFFSET, NEQ(IOFFSET)) = IANGL
cSSS                           WRITE(6,*) "WHY AM I HERE", IANGL, JANGL,
cSSS     &                     NEQ(IOFFSET), IOFFSET
                           GO TO 20
                     ENDIF
C
                  ENDIF
               ENDIF
            ENDIF
C
         ENDDO
C 
         I_UNIQUE(IANGL) = .TRUE.
         IUNIQUE = IUNIQUE + 1
         IUNIQUE_OFFSET(IANGL) = IUNIQUE
cSSS         WRITE(6,*) I_UNIQUE(IANGL), IUNIQUE_OFFSET(IANGL), IANGL
C
 20      CONTINUE
C
      ENDDO 
C
C Identify the symmetry unique RIC dihedral angle coordinates. Also,
C this block of code mark the dihedrals angles that are constrained 
C by symmetry. For exmple 180 dihedral angles and dihedral angle pairs.
C
      DO IDIHS = (TOTNOFANG + TOTNOFBND + 1),  TOTREDNCO
         IBGN = IREDUNCO(1, IDIHS)
         IMD1 = IREDUNCO(2, IDIHS)
         IMD2 = IREDUNCO(3, IDIHS)
         IEND = IREDUNCO(4, IDIHS)
         DO JDIHS = (TOTNOFANG + TOTNOFBND + 1), IDIHS - 1 
            SAMEDIHS = (DABS(REDUNCO(IDIHS) - REDUNCO(JDIHS)) 
     &                  .LE. EPSILON)
CSSS            WRITE(6,*) "THE SAME DIHEDRALS", SAMEDIHS
            IF (SAMEDIHS) THEN
                EQEV_BRDGE = .FALSE.  
                SAME_MID   = .FALSE. 
                JBGN = IREDUNCO(1, JDIHS)
                JMD1 = IREDUNCO(2, JDIHS)
                JMD2 = IREDUNCO(3, JDIHS)
                JEND = IREDUNCO(4, JDIHS)  
CSSS                WRITE(6,*) IPLUS_MINUS(JDIHS), I_PAIR_FLAG(IDIHS),
CSSS     &                     IDIHS, JDIHS
                PRV_USED = (IPLUS_MINUS(JDIHS) .NE. 0 .OR. 
     &                      I_PAIR_FLAG(JDIHS) .NE. 0)
C
                IF (IDIHS .NE. JDIHS .AND. .NOT. PRV_USED) THEN 
C                  
                   PM_PAIR  = .FALSE. 
                   IF ((IMD1 .EQ. JMD1 .AND. IMD2 .EQ. JMD2) .OR. 
     &                (IMD1 .EQ. JMD2 .AND. IMD2. EQ. JMD1)) 
     &                SAME_MID  = .TRUE.
C
                   IF ((IMD1 .EQ. JMD1 .AND. IBNDTO(IMD2, JMD2)
     &                 .NE. 0)) SAME_MID = .TRUE. 
C
                   IF ((IMD1 .EQ. JMD2 .AND. IBNDTO(IMD2, JMD1)    
     &                 .NE. 0)) SAME_MID = .TRUE. 
C
                   IF ((IMD2 .EQ. JMD1 .AND. IBNDTO(IMD1, JMD2)
     &                 .NE. 0)) SAME_MID = .TRUE.
C
                   IF ((IMD2 .EQ. JMD2 .AND. IBNDTO(IMD1, JMD1)
     &                 .NE. 0)) SAME_MID = .TRUE.
C
                   IF ((IBGN .EQ. JBGN .AND. IEND .EQ. JEND .AND. 
     &                  SAME_MID) .OR. (IBGN .EQ. JEND .AND. IEND
     &                  .EQ. JBGN .AND. SAME_MID)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
CSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
CSSS     &                           PM_PAIR, "I GOT HERE"
                      GO TO 30
                   END IF
C   
                   IF ((IBGN .EQ. JBGN .AND. SAME_MID .AND. 
     &                 IBNDTO(IEND, JEND) .NE. 0)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
CSSS                      WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
CSSS     &                           PM_PAIR
                      GO TO 30
                   END IF 
C
                   IF ((IEND .EQ. JEND .AND. SAME_MID .AND. 
     &                 IBNDTO(IBGN, JBGN) .NE. 0)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IEND, IMD1, IMD2,
     &                           IBGN, JBGN, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                      WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                           PM_PAIR
                      GO TO 30
                   END IF 

                   IF ((IBGN .EQ. JEND .AND. SAME_MID .AND.
     &                 IBNDTO(IEND, JBGN) .NE. 0)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JBGN, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                      WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                           PM_PAIR
                      GO TO 30
                   END IF

                   IF ((IEND .EQ. JBGN .AND. SAME_MID .AND.
     &                 IBNDTO(IBGN, JEND) .NE. 0)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IEND, IMD1, IMD2,
     &                           IBGN, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                            PM_PAIR
                       GO TO 30
                   END IF
                   IF ((IBGN .EQ. JBGN .AND. SAME_MID .AND.
     &                  IEND .EQ. JEND)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
CSSS                       WRITE(6,*)IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
CSSS     &                           PM_PAIR
                       GO TO 30
                   END IF
                   IF ((IBGN .EQ. JEND .AND. SAME_MID .AND.
     &                 IEND .EQ. JBGN)) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JBGN, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1  
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                            PM_PAIR
                       GO TO 30
                   END IF
                   IF ((SAME_MID .AND. IBNDTO(IBGN, JBGN)  
     &                  .NE. 0) .AND.
     &                  (IBNDTO(IEND, JEND) .NE. 0) .OR.
     &                  (IBNDTO(IBGN, JEND) .NE. 0) .AND.
     &                  (IBNDTO(IEND, JBGN) .NE. 0))
     &             THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JEND, SAME_PLANE, NATOMS)
                       IF (.NOT. (SAME_PLANE(IBGN) .AND. 
     &                            SAME_PLANE(IEND) .AND.  
     &                            SAME_PLANE(JBGN) .AND. 
     &                            SAME_PLANE(JEND)))
     &                            PM_PAIR = .TRUE.  

cSSS                       IF (.NOT. PM_PAIR) THEN 
cSSS                           PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1,
cSSS     &                               IMD2, IEND, JBGN, 
cSSS     &                               SAME_PLANE, NATOMS)
cSSS                       ENDIF
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
                       
cSSS                       WRITE(6,*)IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                           PM_PAIR,"I AM HERE", IBNDTO
cSSS     &                           (IEND,JEND), IBNDTO(IBGN,JBGN)
                       GO TO 30
                   END IF
C
                   IF ((IBNDTO(IMD1, JMD1) .NE. 0) .AND.
     &                (IBNDTO(IMD2, JMD2) .NE. 0)  .OR.
     &                (IBNDTO(IMD1, JMD2) .NE. 0)  .AND.
     &                (IBNDTO(IMD2, JMD1) .NE. 0)) 
     &                 EQEV_BRDGE = .TRUE. 
cSSS                   WRITE(6,*) "I see a EQUV BRIDGE", EQEV_BRDGE
C
                   IF (EQEV_BRDGE .AND. IEND .EQ. JEND .AND.
     &                 IBNDTO(IBGN, JBGN) .NE. 0) THEN
                       PM_PAIR = CHECK_PM_PAIR(IEND, IMD1, IMD2,
     &                           IBGN, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                            PM_PAIR
                       GO TO 30
                   ENDIF
C
                   IF (EQEV_BRDGE .AND. IBGN .EQ. JBGN .AND.
     &                 IBNDTO(IEND, JEND) .NE. 0) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                 PM_PAIR
                       GO TO 30
                   ENDIF
C   
                   IF (EQEV_BRDGE .AND. IBGN .EQ. JEND .AND.
     &                 IBNDTO(IEND, JBGN) .NE. 0) THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JBGN, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                      ENDIF
                      IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                      ENDIF
                      NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                      IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                      WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                PM_PAIR
                      GO TO 30
                   ENDIF
C
                   IF (EQEV_BRDGE .AND. IEND .EQ. JBGN .AND.
     &                 IBNDTO(IBGN, JEND) .NE. 0) THEN
                       PM_PAIR = CHECK_PM_PAIR(IEND, IMD1, IMD2,
     &                           IBGN, JEND, SAME_PLANE, NATOMS)
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                 PM_PAIR
                       GO TO 30
                   ENDIF
C
                   IF ((EQEV_BRDGE .AND. IBNDTO(IBGN, JBGN)
     &                  .NE. 0) .AND.
     &                  (IBNDTO(IEND, JEND) .NE. 0) .OR. 
     &                  (IBNDTO(IBGN, JEND) .NE. 0) .AND.
     &                  (IBNDTO(IEND, JBGN) .NE. 0)) 
     &             THEN
                       PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1, IMD2,
     &                           IEND, JEND, SAME_PLANE, NATOMS)
                       IF (.NOT. (SAME_PLANE(IBGN) .AND.
     &                            SAME_PLANE(IEND) .AND.
     &                            SAME_PLANE(JBGN) .AND.
     &                            SAME_PLANE(JEND)))
     &                            PM_PAIR = .TRUE.
cSSS                       IF (.NOT. PM_PAIR) THEN
cSSS                           PM_PAIR = CHECK_PM_PAIR(IBGN, IMD1,
cSSS     &                               IMD2, IEND, JBGN, 
cSSS     &                               SAME_PLANE, NATOMS)
cSSS                       ENDIF 
                       IF (IUNIQUE_OFFSET(JDIHS) .NE. 0) THEN
                          IOFFSET = IUNIQUE_OFFSET(JDIHS)
                       ENDIF 
                       IF (PM_PAIR) THEN
                          IPLUS_MINUS(JDIHS) = 1
                          I_PAIR_FLAG(IDIHS) = 1
                          GO TO 40
                       ENDIF
                       NEQ(IOFFSET) = NEQ(IOFFSET) + 1
                       IEQUIV(IOFFSET, NEQ(IOFFSET)) = IDIHS
cSSS                       WRITE(6,*) IDIHS,JDIHS,NEQ(IOFFSET),IOFFSET,
cSSS     &                 PM_PAIR
                       GO TO 30
                   END IF
C
                ENDIF
            ENDIF 
cSSS            I_UNIQUE(IDIHS) = .TRUE.
cSSS            IUNIQUE = IUNIQUE + 1
C
         ENDDO                
C
 40      CONTINUE
         I_UNIQUE(IDIHS) = .TRUE.
         IUNIQUE = IUNIQUE + 1
         IUNIQUE_OFFSET(IDIHS) = IUNIQUE
 30      CONTINUE
      ENDDO 
C
cSSS      WRITE(6,*) IUNIQUE_OFFSET(31), IUNIQUE_OFFSET(32),
cSSS     &           IUNIQUE_OFFSET(33), IUNIQUE_OFFSET(34)
cSSS      WRITE(6,*) I_UNIQUE
cSSS      WRITE(6,*) NEQ
cSSS      DO I = 1, IUNIQUE
cSSS         DO J =1, NEQ(I)
cSSS         WRITE(6,*) I, IEQUIV(I, J)
cSSS         ENDDO
cSSS      ENDDO
C
      RETURN
      END

#include "flags.h"
      Subroutine A3_ECP_grdint_main(Iecp, Natoms, Namat, Iqmstr,
     &                              Jcostr, Nucstr, Nrcstr, Jstrt, 
     &                              Jrs, Expa, Nalpha, Cont, Npcoef, 
     &                              Cord, Charge, IGenby, Spherical,
     &                              Ecpgrdint, Naobasis)
C
      Implicit Double Precision(A-H, O-Z)
C
#include "ecp.par"
#include "ecp.com"
C
      Logical Spherical
      Character*2 mtype(Max_centers)
      Character*80 Cnick(Max_centers)
      Character*80 Ecpnam(Max_centers)
      Character*4 namat(max_centers)

      Dimension iqmstr(Max_centers),jcostr(Max_centers,maxjco),
     &          nucstr(Max_centers,Maxang,Maxjco),
     &          nrcstr(Max_centers,Maxang,Maxjco),
     &          Jstrt(Max_shells),Jrs(Max_shells),Expa(Nalpha),
     &          Cont(Npcoef),Cord(3,Max_centers),
     &          Charge(Max_centers), IGenby(Max_centers)

      Dimension Ecpgrdint(Natoms, 3, *)
C
CSSS      Call A3_Ecp_set4_grdint(Iecp,Nmax,namat,iqmstr,jcostr,nucstr,
CSSS     &                        nrcstr, Jstrt, Jrs, Expa, Nalpha,
CSSS     &                        Cont, Npcoef, Cord, Charge)
CSSS
CSSS      Call prepareecp(Cord, Charge, Igenby, Natoms, Ntotatoms)
C
#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The symmetry equivalent atoms"
      Write(6,"(6(1x,I3))") (IGenby(i), i=1, Ntotatoms)
      Write(6,*)
      Do j=1, Ntotatoms
      Write(6, "(3(1x,F10.6))") (Coord(i,j), i=1, 3)
      Enddo
      Write(6,*)
#endif
C
      Ntotatoms = Natoms

cVFL start 
c     Open(Unit=62, File="decpint.dat", Form="unformatted")
c     Rewind(62)

c     Write(62) Ntotatoms
cVFL end  

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The ECP deriavative integrals" 
#endif
      Call Dzero(Ecpgrdint, Natoms*3*Naobasis*(Naobasis+1)/2)

      Call A3_ECP_grdint_driver(Ecpgrdint, Ntotatoms, Natoms, 
     &                          Iloc, Isoc, IGenby, Cord, .True.,
     &                          Spherical)

cVFL start 
c     close(62)
cVFL end  

      Nint = Iloc
      If (SPherical) Nint = Isoc 
      Call write_ecpgrdint_2disk(Ntotatoms, Nint, Ecpgrdint)

      Return
      End

C THIS ROUTINE DETERMINES THE NEXT POINT WHICH MUST BE RUN IN A
C FINITE DIFFERENCE CALCULATION AND THE TYPE OF CALCULATION
C (SINGLE POINT ENERGY OR GRADIENT) BY INSPECTING INFORMATION
C ON THE JOBARC FILE.

C DIMENSIONS BELOW ARE *MAXIMUM* POSSIBLE DIMENSIONS

CJDW May/June 1996. Dimensions extended to reflect the fact that
C                   number of points can be up to NSIZE**2.

c INPUT
c integer NATOM
c char*4  DOIT
c integer NDSCR

c OUTPUT
c integer IMORE
c double  ENGPT(9*NATOM*NATOM)
c double  GRDPT(3*NATOM,9*NATOM*NATOM)
c double  DIPPT(3,9*NATOM*NATOM)
c double  POLPT(9,9*NATOM*NATOM)
c integer IPTTYPE(9*NATOM*NATOM)
c double  DSCR(NDSCR)

c RECORDS
c get 'NUMPOINT'
c get 'FDCALCTP'
c get 'FDCOORDS'
c put 'NEXTGEOM'
c put 'FDCALCTP'
c get 'ENGPOINT'
c get 'TOTENERG'
c get 'TOTENER2'
c put 'ENGPOINT'
c get 'GRDPOINT'
c put 'GRDPOINT'
c get 'DIPPOINT'
c put 'DIPPOINT'
c get 'POLPOINT'
c put 'POLPOINT'

#include "flags.h"

      SUBROUTINE UPD_FD(NATOM,DOIT,IMORE,
     &                  ENGPT,GRDPT,DIPPT,POLPT,
     &                  IPTTYPE,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      CHARACTER*4 DOIT
      DIMENSION ENGPT(9*NATOM*NATOM),GRDPT(3*NATOM,9*NATOM*NATOM),
     &          DIPPT(3,9*NATOM*NATOM),POLPT(9,9*NATOM*NATOM)
      DIMENSION IPTTYPE(9*NATOM*NATOM),DSCR(NDSCR)

      DIMENSION DIPXYZ(3)
      DIMENSION POLXYZ(3,3)
      LOGICAL PRINTQ

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100)
#include "control.com"
#include "parallel_aces.com"

      PRINTQ=(IFLAGS(1).GE.10)
      NSIZE=3*NATOM

      CALL GETREC(20,'JOBARC','NUMPOINT',1,NPOINT)

c   o read point type record and the list of displacements
      CALL GETREC(20,'JOBARC','FDCALCTP',NPOINT,IPTTYPE)

c Point types can be one of the following:
c  > 0 : this point will be done (1+iRank will be done by this process)
c  = 0 : this point is skipped
c  < 0 : this point is done (-1-iRank was done by this process)

c   o find first entry which must be calculated
      inext = 1
      do while ((ipttype(inext).ne.1+irank).and.(inext.le.npoint))
         inext = inext + 1
      end do

c   o find last entry which was calculated
      ilast = inext-1
      do while ((ipttype(ilast).ne.-1-irank).and.(ilast.gt.0))
         ilast = ilast - 1
      end do

c   o prepare info for the next calculation
      IF (INEXT.NE.NPOINT+1) THEN
         CALL GETREC(20,'JOBARC','FDCOORDS',IINTFP*NSIZE*INEXT,DSCR)
         ILOC=1+(INEXT-1)*NSIZE
         CALL PUTREC(20,'JOBARC','NEXTGEOM',IINTFP*NSIZE,DSCR(ILOC))
         IPTTYPE(INEXT)=-IPTTYPE(INEXT)
         CALL PUTREC(20,'JOBARC','FDCALCTP',INEXT,IPTTYPE)
         IMORE=1
c      o tag the last displacement
         inext = inext+1
         do while ((ipttype(inext).ne.1+irank).and.(inext.le.npoint))
            inext = inext + 1
         end do
         if (inext.eq.npoint+1) then
            CALL PUTREC(20,'JOBARC','LASTGEOM',1,1)
         end if
      ELSE
         IF (GRADONLY) THEN
            CALL GETREC(20,'JOBARC','FDCOORDS',IINTFP*NSIZE*ILAST,DSCR)
         END IF
         IMORE=0
      END IF

c   o process info from the last calculation
      IF (ILAST.NE.0) THEN

c      o update energy vector
         CALL GETREC(20,'JOBARC','ENGPOINT',IINTFP*ILAST,ENGPT)
         IF (IFLAGS(h_IFLAGS_excite).EQ.0) THEN
            CALL GETREC(20,'JOBARC','TOTENERG',IINTFP,ENGPT(ILAST))
         ELSE
            CALL GETREC(20,'JOBARC','TOTENER2',IINTFP,ENGPT(ILAST))
         END IF
         CALL PUTREC(20,'JOBARC','ENGPOINT',IINTFP*ILAST,ENGPT)

         IF (GRADONLY) THEN

            lFREE = 1

c         o assign the indices, but move the last geom before using DSCR
            lGEOM = lFREE
            lFREE = lFREE + NSIZE
            lGRDXYZ = lFREE
            lFREE = lFREE + NSIZE
            lGRDINT = lFREE
            lFREE = lFREE + NSIZE
            lIMAP = lFREE
            lFREE = lFREE + (NATOM+IINTFP-1)/IINTFP
            NDSCRLFT = NDSCR+1-lFREE

            ILOC=1+(ILAST-1)*NSIZE
            call c_memmove(DSCR(lGEOM),DSCR(ILOC),IFLTLN*NSIZE)

            CALL GETGRD(NATOM,DOIT,DSCR(lGEOM),
     &                  DSCR(lGRDXYZ),DSCR(lGRDINT),DIPXYZ,POLXYZ,
     &                  DSCR(lIMAP),DSCR(lFREE),NDSCRLFT,PRINTQ)

c         o update the FD arrays
            CALL GETREC(20,'JOBARC','GRDPOINT',IINTFP*NSIZE*ILAST,GRDPT)
            CALL DCOPY(NSIZE,DSCR(lGRDINT),1,GRDPT(1,ILAST),1)
            CALL PUTREC(20,'JOBARC','GRDPOINT',IINTFP*NSIZE*ILAST,GRDPT)
            CALL GETREC(20,'JOBARC','DIPPOINT',IINTFP*3*ILAST,DIPPT)
            CALL DCOPY(3,DIPXYZ,1,DIPPT(1,ILAST),1)
            CALL PUTREC(20,'JOBARC','DIPPOINT',IINTFP*3*ILAST,DIPPT)
            CALL GETREC(20,'JOBARC','POLPOINT',IINTFP*9*ILAST,POLPT)
            CALL DCOPY(9,POLXYZ,1,POLPT(1,ILAST),1)
            CALL PUTREC(20,'JOBARC','POLPOINT',IINTFP*9*ILAST,POLPT)

c        END IF (GRADONLY)
         END IF

c     END IF (ILAST.NE.0)
      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
#ifdef ACES64
      integer*8 function idamax(n,dx,incx)
      integer*8 n, incx
#else
      integer function idamax(n,dx,incx)
      integer n, incx
#endif
      double precision dx(*)

      integer i, iii
      double precision x, xmx
   
      xmx = dabs(dx(1))
      iii = 1
      do i = 2, n
         x = dabs(dx(1+(i-1)*incx))
         if (x .gt.  xmx) then
            xmx = x
            iii = i
         endif
      enddo
      
      idamax = iii 
      return
      end


#ifdef ACES64
      integer*8 function isamax(n,dx,incx)
      integer*8 n, incx
#else
      integer function isamax(n,dx,incx)
      integer n, incx
#endif
      double precision dx(*)

      integer i, iii
      double precision x, xmx
   
      xmx = dabs(dx(1))
      iii = 1
      do i = 2, n
         x = dabs(dx(1+(i-1)*incx))
         if (x .gt.  xmx) then
            xmx = x
            iii = i
         endif
      enddo
      
      isamax = iii 
      return
      end

      SUBROUTINE SYMTRA2(IRREP,NUM1,NUM2,DIS,NUM,A,B)
C
C  THIS ROUTINE TRANSPOSES THE FIRST TWO INDICES OF A GIVEN MATRIX A
C
C     A(I,J,K,L) --> B(J,I,K,L)
C
C  THE TRANSPOSITION IS NOT DONE IN PLACE(SEE THEREFORE SYMTR3)
C
C  INPUT : IRREP .......  IRREP OF THE GIVEN PART OF A
C          NUM1 ........  POPULATION VECTOR FOR I
C          NUM2 ........  POPULATION VECTOR FOR J
C          DIS .........  DISTRIBUTION SIZE OF A
C          NUM .........  NUMBER OF DISTRIBUTION OF A
C          A ...........  INPUT MATRIX A
C
C  OUTPUT :
C          B ...........  TRANPOSED OUTPUT MATRIX B
C
CEND
C
C CODED JULY/90 JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIS,DIRPRD
      DIMENSION A(DIS,NUM),B(DIS,NUM),NUM1(8),NUM2(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      DIMENSION IPI(8),IPJ(8)
C
      IPI(1)=0
      IPJ(1)=0          
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IPJ(IRREPJ+1)=IPJ(IRREPJ)+NUM2(IRREPJ)*NUM1(IRREPI)
       IPI(IRREPJ+1)=IPI(IRREPJ)+NUM1(IRREPJ)*NUM2(IRREPI)
10    CONTINUE
       
C
      DO 20  IRREPJ=1,NIRREP
       NUMJ=NUM2(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUM1(IRREPI)
       DO 15 J=1,NUMJ
       DO 15 I=1,NUMI
        IND1=IPJ(IRREPJ)+(J-1)*NUMI+I
        IND2=IPI(IRREPI)+(I-1)*NUMJ+J
        DO 11 L=1,NUM
         B(IND2,L)=A(IND1,L)
11      CONTINUE
15     CONTINUE
20    CONTINUE
      RETURN
      END

C
      subroutine Make_Ftab

      Implicit Double Precision (A-H,O-Z)

#include "ecp.par"
#include "ecp.com"
C
C This routine set up the F-function table. F functions is the
C angula integal Int{domega x^iy^jz^k = 4Pi(i-1)!!(j-1)!!(k-1)!!/
C (i+j+k)!! for even i,j and k. 
C
      Call Dzero(Fijk, (4*Maxang+1)**3)

      Fijk(0,0,0) = Fpi

      Do I = 0, 4*Maxang, 2
         Do J = 0, 4*Maxang, 2
            Do K = 0, 4*Maxang, 2

                  If (I .NE. 0) Then

                     Fijk(I,J,K) = Fijk(I-2,J,K)*(I-1)/(I+J+K+1.0D0)

                  Elseif (J .NE. 0) Then

                     Fijk(I,J,K) = Fijk(I,J-2,K)*(J-1)/(I+J+K+1.0D0)

                  Elseif (K. NE. 0) Then

                     Fijk(I,J,K) = Fijk(I,J,K-2)*(K-1)/(I+J+K+1.0D0)

                  Endif

            Enddo
         Enddo
      Enddo

#ifdef _DEBUG_LVLM1
      Do i=0, 4*Maxang, 2
        Do j=0, 4*Maxang, 2
           Write(6,"(4F15.7)") (Fijk(i,j,k),k=0, 4*Maxang,2)
        Enddo
      Enddo
      Write(6,*)
#endif

      Return
      End

C THIS ROUTINE SERVES TWO FUNCTIONS.  FIRST, IT HANDLES THE VERY
C COMPLICATED SITUATIONS IN WHICH A DEGENERATE SET OF COORDINATES
C IS NOT RESOLVED INTO SEPARATE IRREPS OF THE ABELIAN SUBGROUP.

C THE ROUTINE ALSO DETERMINES IF ANY OPERATION IN THE POINT GROUP
C MAPS THE COORDINATE INTO ITS INVERSE.

c INPUT
c integer NATOM
c integer NIRREP
c integer IORDER
c integer NORBIT
c char*4  DOIT

c OUTPUT
c integer ISYMTYP(3*NATOM)
c double  SYMQ(9*NATOM*NATOM)
c double  SCR(9*NATOM)
c double  CHAR(IORDER,NIRREP)
c double  SYOP(9*IORDER)
c char*8  LABEL(NIRREP)
c integer ICENSUS(NATOM)
c integer IPTR(NATOM,IORDER)
c integer NBFATM(NATOM)
c integer ILCATM(NATOM)
c integer INVOP(3*NATOM)

c RECORDS
c get DOIT//'MEMB'
c get DOIT//'CHAR'
c get DOIT//'SYOP'
c get DOIT//'PERM'
c get DOIT//'LABL'
c get DOIT//'DEGN'
c get DOIT//'SYMQ'
c get 'ORIENTMT'
c get 'NVIBSYMF'
c get 'SBGRPSYM'
c put 'FULLSYMQ'
c put 'INVPSMAT'
c put 'SBGRPSYM'

      SUBROUTINE PRDEGEN(NATOM,NIRREP,IORDER,NORBIT,ISYMTYP,SYMQ,
     &                   SCR,CHAR,SYOP,LABEL,ICENSUS,IPTR,
     &                   NBFATM,ILCATM,INVOP,DOIT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION ISYMTYP(3*NATOM),SYMQ(9*NATOM*NATOM)
      DIMENSION SCR(9*NATOM),CHAR(IORDER,NIRREP),SYOP(9*IORDER)
      CHARACTER*8 LABEL(NIRREP)
      DIMENSION ICENSUS(NATOM),IPTR(NATOM,IORDER),NBFATM(NATOM)
      DIMENSION ILCATM(NATOM),INVOP(3*NATOM)
      CHARACTER*4 DOIT

      DIMENSION NVIBSYM(20),IDEGEN(20)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA ONE /1.0/
      DATA TOL /1.D-8/

      NSIZE=3*NATOM

      CALL GETREC(9,'JOBARC',DOIT//'MEMB',NATOM,ICENSUS)
      CALL GETREC(9,'JOBARC',DOIT//'CHAR',NIRREP*IORDER*IINTFP,CHAR)
      CALL GETREC(9,'JOBARC',DOIT//'SYOP',9*IORDER*IINTFP,SYOP)
      CALL GETREC(9,'JOBARC',DOIT//'PERM',NATOM*IORDER,IPTR)
      CALL GETREC(9,'JOBARC',DOIT//'LABL',NIRREP*IINTFP,LABEL)
      CALL GETREC(9,'JOBARC',DOIT//'DEGN',NIRREP,IDEGEN)
      CALL GETREC(9,'JOBARC','ORIENTMT',9*IINTFP,SCR)
      CALL GETREC(9,'JOBARC','NVIBSYMF',NIRREP,NVIBSYM)
      CALL GETREC(9,'JOBARC',DOIT//'SYMQ',NSIZE*NSIZE*IINTFP,SYMQ)
      CALL GETREC(9,'JOBARC','SBGRPSYM',NSIZE,ISYMTYP)

      IF (DOIT.EQ.'FULL') CALL TRNOPS(SYOP,SCR,IORDER)

c   o fill out length and offset vectors for image()
      I = 1
      DO IATOM=1,NATOM
         NBFATM(IATOM)=3
         ILCATM(IATOM)=I
         I = I+3
      END DO

c   o loop over irreps
      IPOSABS=1
      DO 10 IRREP=1,NIRREP
         NVIBTOT=NVIBSYM(IRREP)

c      o continue for degenerate irreps
         IDEG=IDEGEN(IRREP)
         IF (IDEG.GT.1) THEN
            IPOSTAR=1

c         o continue if there is more than one vibration of this type
            NVIBUNQ=NVIBSYM(IRREP)/IDEG
            IF (NVIBUNQ.GT.1) THEN

c            o make sure the first mode of this symmetry is an irrep by itself
               IF (ISYMTYP(IPOSABS).EQ.ISYMTYP(IPOSABS+NVIBUNQ)) THEN
                  IPOS0=1+(IPOSABS-1)*NSIZE

C FOR DEGENERACY LEVELS >2, CHECK TO SEE IF THERE IS AT LEAST ONE
C COMPONENT WHICH BELONGS TO A UNIQUE SUBGROUP IRREP

                  IF (IDEG.GT.2) THEN
                     IUSE=0
                     IMODE=IPOSABS+2*NVIBUNQ
                     DO ICOUNT=3,IDEG
                        IF (IUSE.EQ.0) THEN
                           IF (ICOUNT.EQ.IDEG) THEN
                              IF (ISYMTYP(IMODE).NE.
     &                            ISYMTYP(IMODE-NVIBUNQ)) IUSE=IMODE
                           ELSE
                              IF (ISYMTYP(IMODE).NE.
     &                            ISYMTYP(IMODE-NVIBUNQ).AND.
     &                            ISYMTYP(IMODE).NE.
     &                            ISYMTYP(IMODE+NVIBUNQ)) IUSE=IMODE
                           END IF
                           IF (IUSE.NE.0) THEN
c                           o we are in luck. simply swap modes.
                              IPOSABS1=IMODE
                              IPOS1=1+(IPOSABS1-1)*NSIZE
                              CALL DSWAP(NVIBUNQ*NSIZE,SYMQ(IPOS0),1,
     &                                                 SYMQ(IPOS1),1)
                              DO I=0,NVIBUNQ-1
                                 ITMP=ISYMTYP(IPOSABS+I)
                                 ISYMTYP(IPOSABS+I)=ISYMTYP(IPOSABS1+I)
                                 ISYMTYP(IPOSABS1+I)=ITMP
                              END DO
                           END IF
                           IMODE=IMODE+NVIBUNQ
                        END IF
                     END DO
                     IPOSABS=IPOSABS+NVIBTOT
                  END IF

                  IF (IUSE.NE.0) GOTO 10

                  write(6,501)label(irrep)
501               format(t3,'@PRDEGEN-I, Degenerate modes of symmetry ',
     &                   A,' map to same irrep of subgroup.')

c               o find a self-adjoint symmetry operation with a character of 0
                  DO ISYMOP=1,IORDER
                  IF (ABS(CHAR(ISYMOP,IRREP)).LT.TOL) THEN
                     CALL XGEMM('N','T',3,3,3,
     &                          ONE, SYOP(1+(ISYMOP-1)*9),3,
     &                               SYOP(1+(ISYMOP-1)*9),3,
     &                          0.d0,SCR,                 3)
                     TRACE=DSUM(3,SCR,4)
                     IF (ABS(TRACE-3.d0).LT.TOL) IDO=ISYMOP
                  END IF
                  END DO

c               o project this manifold onto -1 eigenstates of sym op ISYMOP
                  IOFFSCR=3*NSIZE+1
                  IOFFSYQ=IPOS0
                  ITHRU=0
                  IOFF=IOFFSYQ
                  CHRUSE=-1.d0
                  DO IBAS=1,NVIBSYM(IRREP)
                     CALL ZERO(SCR,3*NATOM)
                     CALL IMAGE(NATOM,3*NATOM,1,IDO,IPTR,NBFATM,ILCATM,
     &                          SYMQ(IOFF),SCR,SCR(NSIZE+1),1,3*NATOM,
     &                          SYOP,1)
c                    write(6,*)' character is ',ddot(nsize,symq(ioff),1,scr,1)
                     CALL DSCAL(NSIZE,CHRUSE,SCR,1)
                     CALL VADD(SCR(2*NSIZE+1),SYMQ(IOFF),SCR,NSIZE,ONE)
                     IOFF=IOFF+NSIZE
                     ZLEN=DNRM2(3*NATOM,SCR(2*NSIZE+1),1)
                     IF (ZLEN.GT.TOL) THEN
                        XX=1.d0/ZLEN
                        CALL DCOPY(NSIZE,SCR(2*NSIZE+1),1,SCR,1)
                        CALL DSCAL(3*NATOM,XX,SCR,1)
                        CALL GSCHMIDT(SCR,SCR(3*NSIZE+1),3*NATOM,ITHRU,
     &                                SCR(2*NSIZE+1),RESID,TOL)
                        IF (RESID.GT.TOL) THEN
                           ITHRU=ITHRU+1
                           CALL DCOPY(NSIZE,SCR,1,SCR(IOFFSCR),1)
                           IOFFSCR=IOFFSCR+NSIZE
                        END IF
                     END IF
                  END DO

c               o form complementary space
                  IOFF=IOFFSYQ
                  DO IBAS=1,NVIBSYM(IRREP)
                     CALL GSCHMIDT(SYMQ(IOFF),SCR(3*NSIZE+1),3*NATOM,
     &                             ITHRU,SCR(2*NSIZE+1),RESID,TOL)
                     IF (RESID.GT.TOL) THEN
                        CALL DCOPY(NSIZE,SYMQ(IOFF),1,SCR(IOFFSCR),1)
                        IOFFSCR=IOFFSCR+NSIZE
                        ITHRU=ITHRU+1
                     END IF
                     IOFF=IOFF+NSIZE
                  END DO

                  CALL XCOPY(NSIZE*NVIBSYM(IRREP),SCR(3*NSIZE+1),1,
     &                                            SYMQ(IOFFSYQ),1)

               END IF
            END IF
         END IF
         IPOSABS=IPOSABS+NVIBTOT
10    CONTINUE

c   o determine which op of the full pt grp (if any)
c     maps this coord into its negative
      IOFF=1
      DO ICOORD=1,NSIZE
         INVOP(ICOORD)=0
         DO IOP=1,IORDER
            CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &                 SYMQ(IOFF),SCR,SCR(NSIZE+1),1,3*NATOM,SYOP,1)
            CALL DAXPY(NSIZE,ONE,SYMQ(IOFF),1,SCR,1)
            X=DNRM2(NSIZE,SCR,1)
            IF (X*X.LT.TOL) INVOP(ICOORD)=IOP
              
         END DO
         IOFF=IOFF+NSIZE
      END DO

      CALL PUTREC(20,'JOBARC','FULLSYMQ',NSIZE*NSIZE*IINTFP,SYMQ)
      CALL PUTREC(20,'JOBARC','INVPSMAT',NSIZE,INVOP)
      CALL PUTREC(20,'JOBARC','SBGRPSYM',NSIZE,ISYMTYP)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine tester_MRT2(a1,a2,b1,b2,c1,c2,d1,d2,
     *                 der_flags, scr,maxblk,
     *                 iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 in, hess)
c---------------------------------------------------------------------------
c   "Work" routine for the integral worker task.
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'parallel_info.h'
      include 'hess.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2 
      integer der_flags(12)
      integer der_save(12)
      integer der_save1(12)
      integer der_test(12)
      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim  
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, k, l, n, m, r, s
      integer a,b,c,d
      integer wder, ncder, nder_first  

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision x1p,y1p,z1p
      double precision x2p,y2p,z2p
      double precision x3p,y3p,z3p
      double precision x4p,y4p,z4p

      integer ihess, jhess, icomponent, jcomponent 
      integer iatom, jatom, iflag, jflag   

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision out(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision temp(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision in(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision scr(*), eps, fact, y
      double precision hess(3*ncenters,3*ncenters)
      integer iscr(*)
      integer myder(4,3), mySder(4,3) 

      integer ccbeg(*), ccend(*)
      integer ccbeg_pack(2000), ccend_pack(2000)
      double precision alpha_pack(2000), pcoeff_pack(2000)
      save alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack

      adim = a2-a1+1
      bdim = b2-b1+1
      cdim = c2-c1+1
      ddim = d2-d1+1 
      l8true = .false. ! screening .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical
  
      nsend = adim*bdim*cdim*ddim
      if (nsend .lt. 0) then
         print *,'ERROR IN INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim,cdim,ddim = ',adim,bdim,cdim,ddim
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do d = d1,d2
      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         out(a,b,c,d) = 0.d0
      enddo
      enddo
      enddo
      enddo

c----------------------------------------------------------------------------
c   Set the flags array for the FIRST derivative.
c----------------------------------------------------------------------------

      do iflag = 1, 12 

         do jflag = 1, 12 
            der_flags(jflag) = 0 
            der_save(jflag)  = 0 
         enddo 

         der_flags(iflag) = 1 
         der_save(iflag)  = 1 

c----------------------------------------------------------------------------
c   Save the der_array.
c----------------------------------------------------------------------------

      do a = 1, 12 
         der_save(a) = der_flags(a) 
      enddo 

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         call lookup_shell(end_nfps, nshells, a1, m1)
         call lookup_shell(end_nfps, nshells, a2, m2)
         call lookup_shell(end_nfps, nshells, b1, n1)
         call lookup_shell(end_nfps, nshells, b2, n2)
         call lookup_shell(end_nfps, nshells, c1, r1)
         call lookup_shell(end_nfps, nshells, c2, r2)
         call lookup_shell(end_nfps, nshells, d1, s1)
         call lookup_shell(end_nfps, nshells, d2, s2)

         do m = m1, m2
            if (m .eq. 1) then
               aa1 = 1
            else
               aa1 = end_nfps(m-1) + 1
            endif
            aa2 = end_nfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (n .eq. 1) then
               bb1 = 1
            else
               bb1 = end_nfps(n-1) + 1
            endif
            bb2 = end_nfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if (r .eq. 1) then
               cc1 = 1
            else
               cc1 = end_nfps(r-1) + 1
            endif
            cc2 = end_nfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)
         do s = s1, s2
               x4 = coords(1,s)
               y4 = coords(2,s)
               z4 = coords(3,s)
               call pack_coeffs(alphas, ixalpha, coeffs, ixpcoef, 
     *                          ncfps, npfps, m, n, 
     *                          r, s, alpha_pack, nalpha_pack, 
     *                          pcoeff_pack, npcoeff_pack, 
     *                          ccbeg, ccend, indx_cc,
     *                          ccbeg_pack, ccend_pack)

c              write(6,*) 'SATOM :', atom(m),atom(n),atom(r),atom(s)

c----------------------------------------------------------------------------
c   Make sure the der_flags are set correctly for equivalent centers.
c----------------------------------------------------------------------------

               do a = 1, 12 
                  der_flags(a) = der_save(a) 
               enddo  

               if (atom(m) .eq. atom(n)) then 
                  if (der_flags(1) .eq. 1) der_flags(4) = 1 
                  if (der_flags(4) .eq. 1) der_flags(1) = 1 
                  if (der_flags(2) .eq. 1) der_flags(5) = 1 
                  if (der_flags(5) .eq. 1) der_flags(2) = 1 
                  if (der_flags(3) .eq. 1) der_flags(6) = 1 
                  if (der_flags(6) .eq. 1) der_flags(3) = 1 
               endif 

               if (atom(m) .eq. atom(r)) then 
                  if (der_flags(1) .eq. 1) der_flags(7) = 1 
                  if (der_flags(7) .eq. 1) der_flags(1) = 1 
                  if (der_flags(2) .eq. 1) der_flags(8) = 1 
                  if (der_flags(8) .eq. 1) der_flags(2) = 1 
                  if (der_flags(3) .eq. 1) der_flags(9) = 1 
                  if (der_flags(9) .eq. 1) der_flags(3) = 1 
               endif 

               if (atom(m) .eq. atom(s)) then 
                  if (der_flags(1) .eq. 1) der_flags(10) = 1 
                  if (der_flags(10).eq. 1) der_flags(1)  = 1 
                  if (der_flags(2) .eq. 1) der_flags(11) = 1 
                  if (der_flags(11).eq. 1) der_flags(2)  = 1 
                  if (der_flags(3 ).eq. 1) der_flags(12) = 1 
                  if (der_flags(12).eq. 1) der_flags(3)  = 1 
               endif 

               if (atom(n) .eq. atom(r)) then 
                  if (der_flags(4) .eq. 1) der_flags(7) = 1 
                  if (der_flags(7) .eq. 1) der_flags(4) = 1 
                  if (der_flags(5) .eq. 1) der_flags(8) = 1 
                  if (der_flags(8) .eq. 1) der_flags(5) = 1 
                  if (der_flags(6) .eq. 1) der_flags(9) = 1 
                  if (der_flags(9) .eq. 1) der_flags(6) = 1 
               endif 

               if (atom(n) .eq. atom(s)) then 
                  if (der_flags(4) .eq. 1) der_flags(10) = 1 
                  if (der_flags(10) .eq. 1) der_flags(4) = 1 
                  if (der_flags(5) .eq. 1) der_flags(11) = 1 
                  if (der_flags(11) .eq. 1) der_flags(5) = 1 
                  if (der_flags(6) .eq. 1) der_flags(12) = 1 
                  if (der_flags(12) .eq. 1) der_flags(6) = 1 
               endif 

               if (atom(r) .eq. atom(s)) then 
                  if (der_flags(7) .eq. 1) der_flags(10) = 1 
                  if (der_flags(10) .eq. 1) der_flags(7) = 1 
                  if (der_flags(8) .eq. 1) der_flags(11) = 1 
                  if (der_flags(11) .eq. 1) der_flags(8) = 1 
                  if (der_flags(9) .eq. 1) der_flags(12) = 1 
                  if (der_flags(12) .eq. 1) der_flags(9) = 1 
               endif 

c--------------------------------------------------------------------------
c   Set the hessian components of the first-derivative.
c--------------------------------------------------------------------------

               iatom = 0
               icomponent = 0

               do a = 1, 3
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(m)
                     icomponent = a
                     go to 33
                  endif
               enddo

               do a = 4, 6
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(n)
                     icomponent = a-3
                     go to 33
                  endif
               enddo 

               do a = 7, 9
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(r)
                     icomponent = a-6
                     go to 33
                  endif
               enddo 

               do a = 10, 12
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(s)
                     icomponent = a-9
                     go to 33
                  endif
               enddo 

33             continue 

               eps = 0.0000001d0 

c--------------------------------------------------------------------------
c   Set the perturbed arguments.
c--------------------------------------------------------------------------

               do jatom = 1, ncenters 

                  if ((jatom .ne. atom(m)) .and. (jatom .ne. atom(n))
     *            .and. (jatom .ne. atom(r)) .and. (jatom .ne. atom(s)))
     *            go to 555

               do jcomponent = 1, 3 

                  do jflag = 1, 12
                     der_test(jflag)  = der_save(jflag)
                  enddo 

c-------------------------------------------------------------------------
c
c XX integrals first.
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 1) then

                x1p = x1
                y1p = y1
                z1p = z1

                x2p = x2
                y2p = y2
                z2p = z2

                x3p = x3
                y3p = y3
                z3p = z3

                x4p = x4
                y4p = y4
                z4p = z4

                if (atom(m) .eq. jatom) then

                   x1p = x1 + eps
                   der_test(1) = der_test(1) + 1

                endif

                if (atom(n) .eq. jatom) then

                   x2p = x2 + eps
                   der_test(4) = der_test(4) + 1

                endif

                if (atom(r) .eq. jatom) then

                   x3p = x3 + eps
                   der_test(7) = der_test(7) + 1

                endif

                if (atom(s) .eq. jatom) then

                   x4p = x4 + eps
                   der_test(10) = der_test(10) + 1 

                endif

                go to 111

             endif
c
c-------------------------------------------------------------------------
c
c YY integrals first.
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 2) then

                x1p = x1
                y1p = y1
                z1p = z1

                x2p = x2
                y2p = y2
                z2p = z2

                x3p = x3
                y3p = y3
                z3p = z3

                x4p = x4
                y4p = y4
                z4p = z4

                if (atom(m) .eq. jatom) then

                   y1p = y1 + eps
                   der_test(2) = der_test(2) + 1

                endif

                if (atom(n) .eq. jatom) then

                   y2p = y2 + eps
                   der_test(5) = der_test(5) + 1

                endif

                if (atom(r) .eq. jatom) then

                   y3p = y3 + eps
                   der_test(8) = der_test(8) + 1

                endif

                if (atom(s) .eq. jatom) then

                   y4p = y4 + eps
                   der_test(11) = der_test(11) + 1

                endif

                go to 111

             endif
c
c-------------------------------------------------------------------------
c
c ZZ integrals next.
c
c-------------------------------------------------------------------------
c
             if (jcomponent .eq. 3) then

                x1p = x1
                y1p = y1
                z1p = z1

                x2p = x2
                y2p = y2
                z2p = z2

                x3p = x3
                y3p = y3
                z3p = z3

                x4p = x4
                y4p = y4
                z4p = z4

                if (atom(m) .eq. jatom) then

                   z1p = z1 + eps
                   der_test(3) = der_test(3) + 1

                endif

                if (atom(n) .eq. jatom) then

                   z2p = z2 + eps
                   der_test(6) = der_test(6) + 1

                endif

                if (atom(r) .eq. jatom) then

                   z3p = z3 + eps
                   der_test(9) = der_test(9) + 1 

                endif

                if (atom(s) .eq. jatom) then

                   z4p = z4 + eps
                   der_test(12) = der_test(12) + 1

                endif

                go to 111

             endif

                  do jflag = 1, 12
                     der_save1(jflag) = der_save(jflag)
                  enddo 
c
c-------------------------------------------------------------------------
c
c If you get to this point then no second-derivative can be taken so 
c skip computation. 
c
             go to 777 
c
111          continue

c---------------------------------------------------------------------------
c   Check if you want to calculate the integral batch.
c---------------------------------------------------------------------------

               ncder   = 0 
               k       = 0 
               wder    = 0 
               nfirst  = 0 
               do i = 1, 4  
                  do j = 1, 3  
                     k = k + 1 
                     myder(i,j)  = der_flags(k) 
                     mySder(i,j) = der_save(k) 
                     if (der_flags(k) .eq. 1) wder  = j  
                     if (der_flags(k) .eq. 1) ncder = ncder + 1 
                  enddo 
               enddo 
               
               if (ncder .eq. 2) then 
                  do i = 1, 4  
                     if (myder(i,wder) .ne. 0) then  
                        nfirst = i  
                        go to 10 
                     endif 
                  enddo 
10                continue 
                  if (mySder(nfirst,wder) .ne. 1) go to 777   
               endif ! ncder .eq. 2 
               
               if (ncder .eq. 4) then 
                  do i = 1, 4  
                     if (myder(i,wder) .ne. 0) then  
                        nfirst = i  
                        go to 12 
                     endif 
                  enddo 
12                continue 
                  if (mySder(nfirst,wder) .ne. 1) go to 777   
               endif ! ncder .eq. 4 
               
               if (ncder .eq. 3) then 
                  do i = 1, 4  
                     if (myder(i,wder) .ne. 0) then  
                        nfirst = i  
                        go to 11 
                     endif 
                  enddo 
11                continue 
                  if (mySder(nfirst,wder) .ne. 1) go to 777   
               endif ! ncder .eq. 3 

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

              do d = d1,d2
              do c = c1,c2
              do b = b1,b2
              do a = a1,a2
                 out(a,b,c,d) = 0.d0
              enddo
              enddo
              enddo
              enddo
               
c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2 stationary integrals.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

                  call ERD__GENER_ERI_DERV_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum, 
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n), 
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4, 
     *                der_flags(1), der_flags(2), der_flags(3),
     *                der_flags(4), der_flags(5), der_flags(6),
     *                der_flags(7), der_flags(8), der_flags(9),
     *                der_flags(10), der_flags(11), der_flags(12),
     *                alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints, 
     *                nfirst, scr)    

c---------------------------------------------------------------------------
c   Move the integrals into the output block.  
c---------------------------------------------------------------------------

            if (nints .gt. 0) then
               
               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)
 
               call move_integrals(out, a1,a2,b1,b2,c1,c2,d1,d2,
     *                             scr(nfirst), 
     *                             aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2)
             else 
                 go to 777 
            endif
               
c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2 perturbed integrals.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

                  call ERD__GENER_ERI_DERV_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum, 
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n), 
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4, 
     *                der_flags(1), der_flags(2), der_flags(3),
     *                der_flags(4), der_flags(5), der_flags(6),
     *                der_flags(7), der_flags(8), der_flags(9),
     *                der_flags(10), der_flags(11), der_flags(12),
     *                alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints, 
     *                nfirst, scr)    

c---------------------------------------------------------------------------
c   Add the integrals into the output block.  
c---------------------------------------------------------------------------

            if (nints .gt. 0) then
               
               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)
 
               fact = -1.0d0 
               call add_integrals(out, a1,a2,b1,b2,c1,c2,d1,d2,
     *                            scr(nfirst), 
     *                            aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2,fact)
c              write(6,*) 'SATOM :', atom(m),atom(n),atom(r),atom(s)
c              write(6,*) ' ATOM :', iatom,jatom
c              write(6,*) ' COMP :', icomponent, jcomponent
c              write(6,*) ' FLAGS:', (der_test(i),i=1,12)

c---------------------------------------------------------------------------
c   Contract with Intermediate block.
c---------------------------------------------------------------------------

c              y = 0.0d0
c              do l = dd1, dd2
c              do k = cc1, cc2
c              do j = bb1, bb2
c              do i = aa1, aa2
c                 write(6,*) i,j,k,l,out(i,j,k,l)/eps 
c                 y = y + in(i,j,k,l)*out(i,j,k,l)
c              enddo
c              enddo
c              enddo
c              enddo 

c---------------------------------------------------------------------------
c   Sum into the hessian.
c---------------------------------------------------------------------------

c              ihess = (iatom-1)*3 + icomponent
c              jhess = (jatom-1)*3 + jcomponent

c              hess(jhess,ihess) = hess(jhess,ihess) + y/eps 

            endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do d = d1,d2
      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         temp(a,b,c,d) = 0.d0
      enddo
      enddo
      enddo
      enddo

c           go to 777 

c----------------------------------------------------------------------------
c   Make sure the der_flags are set correctly for equivalent centers.
c----------------------------------------------------------------------------

               if (atom(m) .eq. atom(n)) then
                  if (der_test(1) .ne. 0) der_test(4) = der_test(1)
                  if (der_test(4) .ne. 0) der_test(1) = der_test(4)
                  if (der_test(2) .ne. 0) der_test(5) = der_test(2)
                  if (der_test(5) .ne. 0) der_test(2) = der_test(5)
                  if (der_test(3) .ne. 0) der_test(6) = der_test(3)
                  if (der_test(6) .ne. 0) der_test(3) = der_test(6)
               endif

               if (atom(m) .eq. atom(r)) then
                  if (der_test(1) .ne. 0) der_test(7) = der_test(1)
                  if (der_test(7) .ne. 0) der_test(1) = der_test(7)
                  if (der_test(2) .ne. 0) der_test(8) = der_test(2)
                  if (der_test(8) .ne. 0) der_test(2) = der_test(8)
                  if (der_test(3) .ne. 0) der_test(9) = der_test(3)
                  if (der_test(9) .ne. 0) der_test(3) = der_test(9)
               endif

               if (atom(m) .eq. atom(s)) then
                  if (der_test(1) .ne. 0) der_test(10) = der_test(1)
                  if (der_test(10).ne. 0) der_test(1)  = der_test(10)
                  if (der_test(2) .ne. 0) der_test(11) = der_test(2)
                  if (der_test(11).ne. 0) der_test(2)  = der_test(11)
                  if (der_test(3 ).ne. 0) der_test(12) = der_test(3)
                  if (der_test(12).ne. 0) der_test(3)  = der_test(12)
               endif

               if (atom(n) .eq. atom(r)) then
                  if (der_test(4) .ne. 0) der_test(7) = der_test(4)
                  if (der_test(7) .ne. 0) der_test(4) = der_test(7)
                  if (der_test(5) .ne. 0) der_test(8) = der_test(5)
                  if (der_test(8) .ne. 0) der_test(5) = der_test(8)
                  if (der_test(6) .ne. 0) der_test(9) = der_test(6)
                  if (der_test(9) .ne. 0) der_test(6) = der_test(9)
               endif

               if (atom(n) .eq. atom(s)) then
                  if (der_test(4)  .ne. 0) der_test(10) = der_test(4)
                  if (der_test(10) .ne. 0) der_test(4)  = der_test(10)
                  if (der_test(5)  .ne. 0) der_test(11) = der_test(5)
                  if (der_test(11) .ne. 0) der_test(5)  = der_test(11)
                  if (der_test(6)  .ne. 0) der_test(12) = der_test(6)
                  if (der_test(12) .ne. 0) der_test(6)  = der_test(12)
               endif

               if (atom(r) .eq. atom(s)) then
                  if (der_test(7)  .ne. 0) der_test(10) = der_test(7)
                  if (der_test(10) .ne. 0) der_test(7)  = der_test(10)
                  if (der_test(8)  .ne. 0) der_test(11) = der_test(8)
                  if (der_test(11) .ne. 0) der_test(8)  = der_test(11)
                  if (der_test(9)  .ne. 0) der_test(12) = der_test(9)
                  if (der_test(12) .ne. 0) der_test(9)  = der_test(12)
               endif

c -------------------------------------------------------------------------
c   Set the derivative flag arguments.
c--------------------------------------------------------------------------

c              write(6,*) '       ATOM :', iatom,jatom
c              write(6,*) '       COMP :', icomponent, jcomponent
c              write(6,*) '       FLAGS:', (der_test(a),a=1,12)

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

                  call ERD__GENER_ERI_DERV_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum,
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n),
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4,
     *                der_flags(1), der_flags(2), der_flags(3),
     *                der_flags(4), der_flags(5), der_flags(6),
     *                der_flags(7), der_flags(8), der_flags(9),
     *                der_flags(10), der_flags(11), der_flags(12),
     *                alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints,
     *                nfirst, scr)

               if (nints .gt. 0) then

               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)

               call move_integrals(temp, a1,a2,b1,b2,c1,c2,d1,d2,
     *                             scr(nfirst),
     *                             aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2)

c              go to 987 

               do l = dd1, dd2
               do k = cc1, cc2
               do j = bb1, bb2
               do i = aa1, aa2

               if (dabs(temp(i,j,k,l)-out(i,j,k,l)/eps) .gt. 
     *            0.000001d0) then 

               write(6,*) ' MISMATCH IN SECOND DERIVATIVE' 
               write(6,*) 'SATOM :', atom(m),atom(n),atom(r),atom(s)
               write(6,*) ' ATOM :', iatom,jatom
               write(6,*) ' COMP :', icomponent, jcomponent
               write(6,*) ' FLAGS:', (der_test(a),a=1,12)
               write(6,*) i, j, k, l, out(i,j,k,l)/eps, temp(i,j,k,l)

               endif 

               enddo
               enddo
               enddo
               enddo

987            continue 

c---------------------------------------------------------------------------
c   Contract with Intermediate block.
c---------------------------------------------------------------------------

               y = 0.0d0
               do l = dd1, dd2
               do k = cc1, cc2
               do j = bb1, bb2
               do i = aa1, aa2
                  y = y + in(i,j,k,l)*temp(i,j,k,l)
               enddo
               enddo
               enddo
               enddo

c---------------------------------------------------------------------------
c   Sum into the hessian.
c---------------------------------------------------------------------------

               ihess = (iatom-1)*3 + icomponent
               jhess = (jatom-1)*3 + jcomponent

               hess(jhess,ihess) = hess(jhess,ihess) + y

            endif

777         continue 

            enddo ! jatom = 1, ncenters 
555         continue
            enddo ! jcomponent = 1, 3 

            enddo  ! iflag = 1, 12 

         enddo   ! s
         enddo   ! r

         enddo   ! n
         enddo   ! m

      return
      end

      

C EMULATOR OF CRAY SCILIB ROUTINE. LOCATES FIRST ELEMENT OF AN INTEGER
C VECTOR (IA) EQUAL TO A PARTICULAR VALUE (TARGET).

c The UNICOS man page for isrcheq is appended to this file.
c NOTE: Since Cray computers always use 64-bit integers, the vendor's
c       isrcheq accepts both integers and floats in the array argument.
c       This version only accepts integer arrays.

      integer function isrcheq(n,ia,inc,target)
      implicit none
      integer n, ia(*), inc, target, i, ndx

      if (n.lt.0) then
         print *, '@ISRCHEQ: Assertion failed.'
         print *, '          n = ',n
         call errex
      end if

      if (n.lt.1) then
         isrcheq=0
         return
      end if
      if (inc.ge.0) then
         if (inc.eq.1) then
            do i=1,n
               if (ia(i).eq.target) go to 2
            end do
         else
            ndx=1
            do i=1,n
               if (ia(ndx).eq.target) go to 2
               ndx=ndx+inc
            end do
         end if
      else
         if (inc.eq.-1) then
            ndx=n
            do i=1,n
               if (ia(ndx).eq.target) go to 2
               ndx=ndx-1
            end do
         else
            ndx=1-(n-1)*inc
            do i=1,n
               if (ia(ndx).eq.target) go to 2
               ndx=ndx+inc
            end do
         end if
      end if
 2    isrcheq=i
      return
      end

c NAME
c      ISRCHEQ, ISRCHNE - Searches a vector for the first element equal or
c      not equal to a target
c
c SYNOPSIS
c      index = ISRCHEQ(n,x,incx,target)
c      index = ISRCHNE(n,x,incx,target)
c
c DESCRIPTION
c      ISRCHEQ searches a real or integer vector for the first element that
c      is equal to a real or integer target.
c
c      ISRCHNE searches a real or integer vector for the first element that
c      is not equal to a real or integer target.
c
c      When using the Cray Fortran compiler UNICOS systems, all arguments
c      must be of default kind unless documented otherwise.  On UNICOS
c      systems, default kind is KIND=8 for integer, real, complex, and
c      logical arguments.
c
c      These functions have the following arguments:
c
c      index  Integer.  (output)
c             Index of the first element equal or not equal to target.  If
c             target is not found, n+1 is returned.  If n <= 0, 0 is
c             returned.
c
c      n      Integer.  (input)
c             Number of elements to be searched.
c
c      x      Real or integer array of dimension (n-1)* |incx| + 1.  (input)
c             Array x contains the vector to be searched.
c
c      incx   Integer.  (input)
c             Increment between elements of the searched array.
c
c      target Real or integer.  (input)
c             Value for which to search in the array.
c
c      The Fortran equivalent code for ISRCHEQ is as follows:
c
c                FUNCTION ISRCHEQ(N,X,INCX,TARGET)
c                INTEGER X(*), TARGET
c                J=1
c                ISRCHEQ=0
c                IF(N.LE.0) RETURN
c                IF(INCX.LT.0) J=1-(N-1)*INCX
c                DO 100 I=1,N
c                   IF(X(J).EQ.TARGET) GO TO 200
c                   J=J+INCX
c            100 CONTINUE
c            200 ISRCHEQ=I
c                RETURN
c                END
c
c      Although used as integers internally, you can use real values of x and
c      target, because ISRCHEQ and ISRCHEQ are matching bit patterns.
c
c NOTES
c      ISRCHEQ replaces the ISEARCH routine, but it has an entry point named
c      ISEARCH as well as ISRCHEQ.
c
c      When scanning backward (incx < 0), each routine starts at the end of
c      the vector and moves backward, as follows:
c
c      x(1-incx*(n-1)), x(1-incx*(n-2)), ..., x(1)
c
c      The desired value is at:
c
c      x(1+(index-1)*incx) when incx > 0
c      x(1+(index-n)*incx) when incx < 0

c This routine returns .TRUE. if the two strings are NOT lexically equal.
c WARNING: Since Fortran pads the end of all strings with spaces,
c be sure to pass only the relevant substring.

      logical function lne(s1,s2)
      implicit none
      character*(*) s1, s2
      logical leq
      lne = .not.leq(s1,s2)
      return
      end

      SUBROUTINE IDNTFY_SYMEQV_ATMS(PGRP, IORDGP, QREF, QTAR,
     &                              SYMEQVLNT) 
C
      IMPLICIT NONE 
C
      CHARACTER*4 PGRP 
      LOGICAL SYMEQVLNT, QSAME
      Integer IOrdGp, MAXORDER, I, J
      PARAMETER(MAXORDER = 8)
      Double precision QREF(3),QGEN(3, MAXORDER), QTAR(3)
C
C Given one set of Cartesian coordinates produces all symmetry
C equivalent coordinates and marks the symmetry unique ones. 
C
      DO 10 I = 1, IORDGP-1
         CALL SCOPY(3, QREF, 1, QGEN(1,I), 1)
10    CONTINUE
C
      IF (PGRP(1:3).EQ.'C2v')THEN
         QGEN(1,1) = -QGEN(1,1)
         QGEN(2,2) = -QGEN(2,2)
         QGEN(1,3) = -QGEN(1,3)
         QGEN(2,3) = -QGEN(2,3)
      ELSEIF(PGRP(1:3).EQ.'C2h')THEN
         QGEN(3,1) = -QGEN(3,1)
         QGEN(1,2) = -QGEN(1,2)
         QGEN(2,2) = -QGEN(2,2)
         QGEN(1,3) = -QGEN(1,3)
         QGEN(2,3) = -QGEN(2,3)
         QGEN(3,3) = -QGEN(3,3)
      ELSEIF(PGRP(1:3).EQ.'D2 ')THEN 
         QGEN(1,1) = -QGEN(1,1)
         QGEN(2,1) = -QGEN(2,1)
         QGEN(1,2) = -QGEN(1,2)
         QGEN(3,2) = -QGEN(3,2)
         QGEN(2,3) = -QGEN(2,3)
         QGEN(3,3) = -QGEN(3,3)
      ELSEIF(PGRP(1:3).EQ.'C2 ')THEN
         QGEN(1,1) = -QGEN(1,1)
         QGEN(2,1) = -QGEN(2,1)
      ELSEIF(PGRP(1:3).EQ.'C s')THEN
         QGEN(3,1) = -QGEN(3,1)
      ELSEIF(PGRP(1:3).EQ.'C i')THEN
         QGEN(1,1) = -QGEN(1,1)
         QGEN(2,1) = -QGEN(2,1)
         QGEN(3,1) = -QGEN(3,1)
      ELSEIF(PGRP(1:3).EQ.'D2h')THEN
C
C THIS COULD WELL BE WRONG!!!! CHECK!!!
C
         QGEN(1,1) = -QGEN(1,1)
         QGEN(2,2) = -QGEN(2,2)
         QGEN(1,3) = -QGEN(1,3)
         QGEN(2,3) = -QGEN(2,3)
         QGEN(3,4) = -QGEN(3,4)
         QGEN(1,5) = -QGEN(1,5)
         QGEN(3,5) = -QGEN(3,5)
         QGEN(2,6) = -QGEN(2,6)
         QGEN(3,6) = -QGEN(3,6)
         QGEN(1,7) = -QGEN(1,7)
         QGEN(2,7) = -QGEN(2,7)
         QGEN(3,7) = -QGEN(3,7)
      ENDIF
C
C Check and see whether the generated center is identical to the 
C target center. If that is the case then the reference center
C must be symmetry equivalent to the target center. 
C
      SYMEQVLNT = .FALSE. 
C
      DO 20 I = 1, IORDGP-1
C
       IF(QSAME(QTAR, QGEN(1,I))) SYMEQVLNT = .TRUE.
       IF (SYMEQVLNT) RETURN

20    CONTINUE
C 
      RETURN
      END

c
      subroutine set_gradpoints(max_centers, Cord, Natoms, Displ, eps) 
      Implicit none 
      Integer Natoms 
      Double precision Displ(max_centers,3,2) 
      Integer i, j, k 
      Integer Max_centers 
      Double precision Cord(3,max_centers) 
      Double precision x, y, z, dx_p, dx_m, dy_p, dy_m, dz_p, dz_m 
      Double precision eps 

      eps = 1.0d-5  

10    format(2x,'Initial geometry ', 3F12.8) 

      do i = 1, natoms 

         write(6,10) (Cord(j,i), j=1, 3)  

         x = Cord(1,i) 
         y = Cord(2,i) 
         z = Cord(3,i) 

         dx_p = x + eps 
         dx_m = x - eps 

         dy_p = y + eps 
         dy_m = y - eps 

         dz_p = z + eps 
         dz_m = z - eps 

         Displ(i,1,1) = dx_p 
         Displ(i,1,2) = dx_m 

         Displ(i,2,1) = dy_p 
         Displ(i,2,2) = dy_m 

         Displ(i,3,1) = dz_p 
         Displ(i,3,2) = dz_m 

      enddo 

      write(6,100) 
      do i = 1, natoms 
         write(6,200) i, (Displ(i,1,k), k=1, 2) 
         write(6,300) i, (Displ(i,2,k), k=1, 2) 
         write(6,400) i, (Displ(i,3,k), k=1, 2) 
      enddo 

100   Format(2x,'CARTESIAN DISPLACEMENTS USED TO CONSTRUCT THE ECP 
     *       GRADIENTS')  

200   Format(2x, 'ATOM', I4, 2x, 'X+', F12.8, 2x, 'X-', F12.8) 
300   Format(2x, 'ATOM', I4, 2x, 'Y+', F12.8, 2x, 'Y-', F12.8) 
400   Format(2x, 'ATOM', I4, 2x, 'Z+', F12.8, 2x, 'Z-', F12.8) 
      return 
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_PQ_INTEGRALS
     +
     +                    ( SHELLP,SHELLQ,
     +                      NGQEXQ,
     +                      WTS,
     +                      B00,B01,B10,
     +                      C00X,C00Y,C00Z,
     +                      D00X,D00Y,D00Z,
     +                      CASE2D,
     +
     +                               INT2DX,
     +                               INT2DY,
     +                               INT2DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_PQ_INTEGRALS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 2D PQ X,Y,Z
C                integrals using the Rys vertical recurrence scheme
C                VRR explained below.
C
C                The Rys weight is multiplied to the 2DX PQ integral
C                to reduce overall FLOP count. Note, that the Rys weight
C                factor needs to be introduced only three times for the
C                starting 2DX PQ integrals for the recurrence scheme,
C                namely to the (0,0), (1,0) and (0,1) elements. The
C                weight factor is then automatically propagated
C                through the vertical transfer equations (see below).
C                The recurrence scheme VRR is due to Rys, Dupuis and
C                King, J. Comp. Chem. 4, p.154-157 (1983).
C
C
C                   INT2D (0,0) = 1.D0    (* WEIGHT for the 2DX case)
C                   INT2D (1,0) = C00     (* WEIGHT for the 2DX case)
C                   INT2D (0,1) = D00     (* WEIGHT for the 2DX case)
C
C                   For I = 1,...,SHELLP-1
C                       INT2D (I+1,0) = I * B10 * INT2D (I-1,0)
C                                         + C00 * INT2D (I,0)
C                   For K = 1,...,SHELLQ-1
C                       INT2D (0,K+1) = K * B01 * INT2D (0,K-1)
C                                         + D00 * INT2D (0,K)
C                   For I = 1,...,SHELLP
C                       INT2D (I,1)   = I * B00 * INT2D (I-1,0)
C                                         + D00 * INT2D (I,0)
C                   For K = 2,...,SHELLQ
C                       INT2D (1,K)   = K * B00 * INT2D (0,K-1)
C                                         + C00 * INT2D (0,K)
C                   For K = 2,...,SHELLQ
C                   For I = 2,...,SHELLP
C                       INT2D (I,K)   = (I-1) * B10 * INT2D (I-2,K)
C                                         + K * B00 * INT2D (I-1,K-1)
C                                             + C00 * INT2D (I-1,K)
C
C
C                The 2D PQ integrals are calculated for all roots (info
C                already present in transmitted VRR coefficients!) and
C                for all exponent quadruples simultaneously and placed
C                into a 3-dimensional array.
C
C
C                  Input:
C
C                    SHELLx      =  maximum shell type for electrons
C                                   1 and 2 (x = P,Q)
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    WTS         =  all quadrature weights
C                    B00,B01,B10 =  VRR expansion coefficients
C                                   (cartesian coordinate independent)
C                    C00x,D00x   =  cartesian coordinate dependent
C                                   VRR expansion coefficients
C                                   (x = X,Y,Z)
C                    CASE2D      =  logical flag for simplifications
C                                   in 2D integral evaluation for
C                                   low quantum numbers
C
C
C                  Output:
C
C                    INT2Dx      =  all 2D PQ integrals for each
C                                   cartesian component (x = X,Y,Z)
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         INTEGER   CASE2D
         INTEGER   I,K,N
         INTEGER   I1,I2,K1,K2
         INTEGER   NGQEXQ
         INTEGER   SHELLP,SHELLQ

         DOUBLE PRECISION  B0,B1
         DOUBLE PRECISION  F,F1,F2
         DOUBLE PRECISION  ONE
         DOUBLE PRECISION  WEIGHT

         DOUBLE PRECISION  B00  (1:NGQEXQ)
         DOUBLE PRECISION  B01  (1:NGQEXQ)
         DOUBLE PRECISION  B10  (1:NGQEXQ)
         DOUBLE PRECISION  C00X (1:NGQEXQ)
         DOUBLE PRECISION  C00Y (1:NGQEXQ)
         DOUBLE PRECISION  C00Z (1:NGQEXQ)
         DOUBLE PRECISION  D00X (1:NGQEXQ)
         DOUBLE PRECISION  D00Y (1:NGQEXQ)
         DOUBLE PRECISION  D00Z (1:NGQEXQ)
         DOUBLE PRECISION  WTS  (1:NGQEXQ)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP,0:SHELLQ)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP,0:SHELLQ)

         PARAMETER  (ONE = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 4 different cases that can arise:
C
C                  P-shell = s- or higher angular momentum
C                  Q-shell = s- or higher angular momentum
C
C                each leading to simplifications in the VRR formulas.
C                The case present has been evaluated outside this
C                routine and is transmitted via argument.
C
C
         GOTO (1,3,3,2,4,4,2,4,4) CASE2D
C
C
C             ...the case P = s-shell and Q = s-shell.
C
C
    1    DO 100 N = 1,NGQEXQ
            INT2DX (N,0,0) = WTS (N)
            INT2DY (N,0,0) = ONE
            INT2DZ (N,0,0) = ONE
  100    CONTINUE

         RETURN
C
C
C             ...the cases P = s-shell and Q >= p-shell.
C                Evaluate I=0 and K=0,1.
C
C
    2    DO 200 N = 1,NGQEXQ
            WEIGHT = WTS (N)
            INT2DX (N,0,0) = WEIGHT
            INT2DX (N,0,1) = D00X (N) * WEIGHT
            INT2DY (N,0,0) = ONE
            INT2DY (N,0,1) = D00Y (N)
            INT2DZ (N,0,0) = ONE
            INT2DZ (N,0,1) = D00Z (N)
  200    CONTINUE
C
C
C             ...evaluate I=0 and K=2,SHELLQ (if any).
C
C
         F = ONE
         DO 210 K = 2,SHELLQ
            K1 = K - 1
            K2 = K - 2
            DO 212 N = 1,NGQEXQ
               B1 = F * B01 (N)
               INT2DX (N,0,K) =        B1 * INT2DX (N,0,K2)
     +                         + D00X (N) * INT2DX (N,0,K1)
               INT2DY (N,0,K) =        B1 * INT2DY (N,0,K2)
     +                         + D00Y (N) * INT2DY (N,0,K1)
               INT2DZ (N,0,K) =        B1 * INT2DZ (N,0,K2)
     +                         + D00Z (N) * INT2DZ (N,0,K1)
  212       CONTINUE
            F = F + ONE
  210    CONTINUE

         RETURN
C
C
C             ...the cases P >= p-shell and Q = s-shell.
C                Evaluate I=0,1 and K=0.
C
C
    3    DO 300 N = 1,NGQEXQ
            WEIGHT = WTS (N)
            INT2DX (N,0,0) = WEIGHT
            INT2DX (N,1,0) = C00X (N) * WEIGHT
            INT2DY (N,0,0) = ONE
            INT2DY (N,1,0) = C00Y (N)
            INT2DZ (N,0,0) = ONE
            INT2DZ (N,1,0) = C00Z (N)
  300    CONTINUE
C
C
C             ...evaluate I=2,SHELLP (if any) and K=0.
C
C
         F = ONE
         DO 310 I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO 312 N = 1,NGQEXQ
               B1 = F * B10 (N)
               INT2DX (N,I,0) =        B1 * INT2DX (N,I2,0)
     +                         + C00X (N) * INT2DX (N,I1,0)
               INT2DY (N,I,0) =        B1 * INT2DY (N,I2,0)
     +                         + C00Y (N) * INT2DY (N,I1,0)
               INT2DZ (N,I,0) =        B1 * INT2DZ (N,I2,0)
     +                         + C00Z (N) * INT2DZ (N,I1,0)

  312       CONTINUE
            F = F + ONE
  310    CONTINUE

         RETURN
C
C
C             ...the cases P >= p-shell and Q >= p-shell.
C                Evaluate I=0,SHELLP       I=0
C                         K=0        and   K=0,SHELLQ
C
C
    4    DO 400 N = 1,NGQEXQ
            WEIGHT = WTS (N)
            INT2DX (N,0,0) = WEIGHT
            INT2DX (N,1,0) = C00X (N) * WEIGHT
            INT2DX (N,0,1) = D00X (N) * WEIGHT
            INT2DY (N,0,0) = ONE
            INT2DY (N,1,0) = C00Y (N)
            INT2DY (N,0,1) = D00Y (N)
            INT2DZ (N,0,0) = ONE
            INT2DZ (N,1,0) = C00Z (N)
            INT2DZ (N,0,1) = D00Z (N)
  400    CONTINUE

         F = ONE
         DO 410 I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO 412 N = 1,NGQEXQ
               B1 = F * B10 (N)
               INT2DX (N,I,0) =        B1 * INT2DX (N,I2,0)
     +                         + C00X (N) * INT2DX (N,I1,0)
               INT2DY (N,I,0) =        B1 * INT2DY (N,I2,0)
     +                         + C00Y (N) * INT2DY (N,I1,0)
               INT2DZ (N,I,0) =        B1 * INT2DZ (N,I2,0)
     +                         + C00Z (N) * INT2DZ (N,I1,0)

  412       CONTINUE
            F = F + ONE
  410    CONTINUE

         F = ONE
         DO 414 K = 2,SHELLQ
            K1 = K - 1
            K2 = K - 2
            DO 416 N = 1,NGQEXQ
               B1 = F * B01 (N)
               INT2DX (N,0,K) =        B1 * INT2DX (N,0,K2)
     +                         + D00X (N) * INT2DX (N,0,K1)
               INT2DY (N,0,K) =        B1 * INT2DY (N,0,K2)
     +                         + D00Y (N) * INT2DY (N,0,K1)
               INT2DZ (N,0,K) =        B1 * INT2DZ (N,0,K2)
     +                         + D00Z (N) * INT2DZ (N,0,K1)
  416       CONTINUE
            F = F + ONE
  414    CONTINUE
C
C
C             ...evaluate I=1,SHELLP and K=1,SHELLQ (if any)
C                in most economical way.
C
C
         IF (SHELLQ.LE.SHELLP) THEN

             F1 = ONE
             DO 420 K = 1,SHELLQ
                K1 = K - 1
                DO 421 N = 1,NGQEXQ
                   B0 = F1 * B00 (N)
                   INT2DX (N,1,K) =        B0 * INT2DX (N,0,K1)
     +                             + C00X (N) * INT2DX (N,0,K)
                   INT2DY (N,1,K) =        B0 * INT2DY (N,0,K1)
     +                             + C00Y (N) * INT2DY (N,0,K)
                   INT2DZ (N,1,K) =        B0 * INT2DZ (N,0,K1)
     +                             + C00Z (N) * INT2DZ (N,0,K)
  421           CONTINUE
                F2 = ONE
                DO 422 I = 2,SHELLP
                   I1 = I - 1
                   I2 = I - 2
                   DO 423 N = 1,NGQEXQ
                      B0 = F1 * B00 (N)
                      B1 = F2 * B10 (N)
                      INT2DX (N,I,K) =        B0 * INT2DX (N,I1,K1)
     +                                      + B1 * INT2DX (N,I2,K)
     +                                + C00X (N) * INT2DX (N,I1,K)
                      INT2DY (N,I,K) =        B0 * INT2DY (N,I1,K1)
     +                                      + B1 * INT2DY (N,I2,K)
     +                                + C00Y (N) * INT2DY (N,I1,K)
                      INT2DZ (N,I,K) =        B0 * INT2DZ (N,I1,K1)
     +                                      + B1 * INT2DZ (N,I2,K)
     +                                + C00Z (N) * INT2DZ (N,I1,K)
  423              CONTINUE
                   F2 = F2 + ONE
  422           CONTINUE
                F1 = F1 + ONE
  420        CONTINUE

         ELSE

             F1 = ONE
             DO 430 I = 1,SHELLP
                I1 = I - 1
                DO 431 N = 1,NGQEXQ
                   B0 = F1 * B00 (N)
                   INT2DX (N,I,1) =        B0 * INT2DX (N,I1,0)
     +                             + D00X (N) * INT2DX (N,I,0)
                   INT2DY (N,I,1) =        B0 * INT2DY (N,I1,0)
     +                             + D00Y (N) * INT2DY (N,I,0)
                   INT2DZ (N,I,1) =        B0 * INT2DZ (N,I1,0)
     +                             + D00Z (N) * INT2DZ (N,I,0)
  431           CONTINUE
                F2 = ONE
                DO 432 K = 2,SHELLQ
                   K1 = K - 1
                   K2 = K - 2
                   DO 433 N = 1,NGQEXQ
                      B0 = F1 * B00 (N)
                      B1 = F2 * B01 (N)
                      INT2DX (N,I,K) =        B0 * INT2DX (N,I1,K1)
     +                                      + B1 * INT2DX (N,I,K2)
     +                                + D00X (N) * INT2DX (N,I,K1)
                      INT2DY (N,I,K) =        B0 * INT2DY (N,I1,K1)
     +                                      + B1 * INT2DY (N,I,K2)
     +                                + D00Y (N) * INT2DY (N,I,K1)
                      INT2DZ (N,I,K) =        B0 * INT2DZ (N,I1,K1)
     +                                      + B1 * INT2DZ (N,I,K2)
     +                                + D00Z (N) * INT2DZ (N,I,K1)
  433              CONTINUE
                   F2 = F2 + ONE
  432           CONTINUE
                F1 = F1 + ONE
  430        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__SYMMETRIZE_NBO_ORBITALS
     +
     +                    ( NBAS,NATOM,NBOND,
     +                      NBOSIZE,ROTSIZE,
     +                      MXNBA,MXSHELL,
     +                      NCB,NLB,NBB,NEB,NAB,NYB,NRB,
     +                      NCA,NLA,NEA,NYA,NRA,
     +                      ATNCB,ATCIDX,ATCOFF,
     +                      ATNLB,ATLIDX,ATLOFF,
     +                      ATNEB,ATEIDX,ATEOFF,
     +                      ATNYB,ATYIDX,ATYOFF,
     +                      ATNRB,ATRIDX,ATROFF,
     +                      BASBEG,BASEND,
     +                      DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                      SYMMAP,SYMNBO,SYMCEN,
     +                      PLATONIC,
     +                      RING,NRING,RINGSZ,
     +                      NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                      PLATO,
     +                      BDNCEN,BDCEN,
     +                      ANGNHO,
     +                      HYB,ROT,
     +                      P,
     +                      DOMAT,
     +                      SHALF,
     +                      LOCAL,
     +                      SLTYPE,
     +                      IVEC,
     +                      XVEC,XMAT,
     +
     +                              NBOBD,
     +                              BDNBAS,BDBAS,
     +                              ANGNBO,
     +                              B,W,Q,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__SYMMETRIZE_NBO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine symmetrizes the sets of natural bond
C                orbitals (NBOs).
C
C
C                  Input:
C
C                    NBAS         =  total # of AOs in AO basis
C                    NATOM        =  total # of atomic centers
C                    NBOND        =  total # of bonds found in the NHB
C                                    part.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    ROTSIZE      =  maximum # of NHOs that will be
C                                    allowed to form NBO hybrids for
C                                    rotationally invariant atomic NBO
C                                    construction.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    MXSHELL      =  largest l-shell value
C                    NxB          =  total # of Core, Lone-pair, Bond,
C                                    Empty-pair, Antibond and Rydberg
C                                    NBOs determined (x=C,L,B,E,A,Y,R)
C                    NxA          =  total # of Core, Lone-pair,
C                                    Empty-pair and Rydberg atoms
C                                    (x=C,L,E,Y,R)
C                    ATNCB (A)    =  # of Core NBOs on core atom A.
C                    ATCIDX (A)   =  atomic index for core atom A.
C                    ATCOFF (A)   =  index offset for Core NBOs for
C                                    core atom A. This index is equal
C                                    to the total number of Core NBOs
C                                    on all core atoms preceeding
C                                    core atom A.
C                    ATNLB (A)    =  # of Lone-pair NBOs on Lone-pair
C                                    atom A.
C                    ATLIDX (A)   =  atomic index for Lone-pair atom A.
C                    ATLOFF (A)   =  index offset for Lone-pair NBOs for
C                                    Lone-pair atom A. This index is
C                                    equal to the total number of
C                                    Lone-pair NBOs on all Lone-pair
C                                    atoms preceeding Lone-pair atom A.
C                    ATNEB (A)    =  # of Empty-pair NBOs on Empty-pair
C                                    atom A.
C                    ATEIDX (A)   =  atomic index for Empty-pair atom A.
C                    ATEOFF (A)   =  index offset for Empty-pair NBOs for
C                                    Empty-pair atom A. This index is
C                                    equal to the total number of
C                                    Empty-pair NBOs on all Empty-pair
C                                    atoms preceeding Empty-pair atom A.
C                    ATNYB (A)    =  # of hybrid Rydberg NBOs on hybrid
C                                    Rydberg atom A.
C                    ATYIDX (A)   =  atomic index for hybrid Rydberg
C                                    atom A.
C                    ATYOFF (A)   =  index offset for hybrid Rydberg
C                                    NBOs for hybrid Rydberg atom A.
C                                    This index is equal to the total
C                                    number of hybrid Rydberg NBOs on
C                                    all hybrid Rydberg atoms preceeding
C                                    hybrid Rydberg atom A.
C                    ATNRB (A)    =  # of Rydberg NBOs on Rydberg atom A
C                    ATRIDX (A)   =  atomic index for Rydberg atom A.
C                    ATROFF (A)   =  index offset for Rydberg NBOs for
C                                    Rydberg atom A. This index is
C                                    equal to the total number of
C                                    Rydberg NBOs on all Rydberg atoms
C                                    preceeding Rydberg atom A.
C                    BASBEG (A)   =  first basis index number for atom A
C                    BASEND (A)   =  last basis index number for atom A
C                    DSYMACC      =  symmetry accuracy for distance
C                                    order matrix values
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    PSYMACC      =  symmetry accuracy for occupation
C                                    matrix values (including weights)
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    SYMMAP (A,B) =  has been set equal to 1 if atoms
C                                    A and B were found to be symmetry
C                                    related at the current stage of
C                                    calculation. A value of 0 indicates
C                                    no symmetry relation.
C                    SYMNBO       =  integer vector which will be used
C                                    to indicate which NBO is already
C                                    considered to be symmetry adapted
C                                    at the different stages of
C                                    symmetrization.
C                    SYMCEN       =  array that will be used to store
C                                    symmetry related atomic indices.
C                    PLATONIC     =  is true, if the complete set of
C                                    atomic centers possess one of the
C                                    possible 5 platonic symmetries.
C                    RING (A,B)   =  integer array containing all atomic
C                                    indices A of those symmetry related
C                                    sets that have equal distance from
C                                    center B and are of maximum size
C                    NRING (B)    =  integer vector containing the # of
C                                    sets of maximum size related to
C                                    center B.
C                    RINGSZ (B)   =  integer vector containing the
C                                    maximum size of the above found
C                                    sets related to center B.
C                    NTETRA       =  contains the # of tetrahedrally
C                                    related atomic center sets (size 4)
C                    NCUBE        =  contains the # of cubically
C                                    related atomic center sets (size 8)
C                    NOCTA        =  contains the # of octahedrally
C                                    related atomic center sets (size 6)
C                    NDODECA      =  contains the # of dodecahedrally
C                                    related atomic center sets
C                                    (size 20)
C                    NICOSA       =  contains the # of icosahedrally
C                                    related atomic center sets
C                                    (size 12)
C                    PLATO (A,P)  =  integer array containing all atomic
C                                    indices A for specific platonic
C                                    symmetry types as characterized by
C                                    the index P: P = 1 (four atoms
C                                    tetrahedrally arranged), P = 2
C                                    (eight atoms arranged in a cube),
C                                    P = 3 (six octahedral atoms), P = 4
C                                    (twenty atoms in a dodecahedron),
C                                    P = 5 (twelve icosahedral atoms)
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/
C                                    NRB. Note that the # of NHB-bonds
C                                    might be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for J-th
C                                    bond. The bond order is NHB-bonds/
C                                    NCB/NRB. Note that the # of
C                                    NHB-bonds might be < NHB size.
C                    ANGNHO (J,L) =  NBAS x (MXSHELL+1) matrix
C                                    containing the sum of the square
C                                    of the NAO coefficients per L-type
C                                    angular momentum for the J-th NHO.
C                                    The NHO order is NHB/NCB/NRB.
C                    HYB          =  will contain the NBO hybridization
C                                    matrix.
C                    ROT          =  will contain the NBO rotation
C                                    matrix.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    DOMAT (A,B)  =  distance order matrix containing
C                                    'distance' info between atoms A
C                                    and B. Will be used when attempting
C                                    NBO symmetrization.
C                    SHALF        =  full NBAS x NBAS square root of
C                                    the overlap matrix in AO basis.
C                    LOCAL        =  will hold NBO atomic localization
C                                    contents.
C                    SLTYPE (J)   =  will hold NBO smallest angular
C                                    momentum component.
C                    IVEC         =  int scratch array of vector type.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    NBOBD (I)    =  initial (before symmetrization)
C                                    bond index number for the I-th NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the bonds sitting in the arrays
C                                    BDNCEN,BDCEN,BDBAS and BDOCC. The
C                                    NBOBD elements are in NCB/NLB/NBB/
C                                    NEB/NAB/NYB/NRB order.
C                    BDNBAS (J)   =  initial (before symmetrization)
C                                    # of basis functions (NHOs) for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial (before symmetrization)
C                                    I-th global basis (NHO) index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    ANGNBO (J,L) =  initial (before symmetrization)
C                                    NBAS x (MXSHELL+1) matrix containing
C                                    the sum of the square of the NAO
C                                    coefficients per L-type angular
C                                    momentum for the J-th NBO. The NBO
C                                    order is NCB/NLB/NBB/NEB/NAB/NYB/
C                                    NRB.
C                    B (I,J)      =  initial (before symmetrization)
C                                    NBOSIZE x NBAS matrix containing
C                                    the J-th NBO expansion coefficients
C                                    in terms of the I-th atomic NHOs
C                                    forming the J-th NBO. The NBO
C                                    column index is in NCB/NLB/NBB/NEB/
C                                    NAB/NYB/NRB order.
C                    W            =  initial (before symmetrization)
C                                    NBO weight vector with elements in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C                    Q            =  initial (before symmetrization)
C                                    NBO occupation interaction order
C                                    vector with elements in NCB/NLB/
C                                    NBB/NEB/NAB/NYB/NRB order. These
C                                    interaction orders are given by
C                                    the square root of the sum of the
C                                    square offdiagonal occupation
C                                    matrix elements:
C
C                                      Q (I) = sqrt ( sum   P (I,K)**2 )
C                                                    K.ne.I
C
C                                    They will be used here to determine
C                                    degenerate NBOs during the NBO
C                                    symmetrization procedure.
C                    C            =  initial (before symmetrization)
C                                    full NBO coefficient matrix
C                                    in AO basis with columns in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C
C
C                  Output:
C
C                    NBOBD (I)    =  final (after symmetrization)
C                                    bond index number for the I-th NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the bonds sitting in the arrays
C                                    BDNCEN,BDCEN,BDBAS and BDOCC. The
C                                    NBOBD elements are in NCB/NLB/NBB/
C                                    NEB/NAB/NYB/NRB order.
C                    BDNBAS (J)   =  final (after symmetrization)
C                                    # of basis functions (NHOs) for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  final (after symmetrization)
C                                    I-th global basis (NHO) index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    ANGNBO (J,L) =  final (after symmetrization)
C                                    NBAS x (MXSHELL+1) matrix containing
C                                    the sum of the square of the NAO
C                                    coefficients per L-type angular
C                                    momentum for the J-th NBO. The NBO
C                                    order is NCB/NLB/NBB/NEB/NAB/NYB/
C                                    NRB.
C                    B (I,J)      =  final (after symmetrization)
C                                    NBOSIZE x NBAS matrix containing
C                                    the J-th NBO expansion coefficients
C                                    in terms of the I-th atomic NHOs
C                                    forming the J-th NBO. The NBO
C                                    column index is in NCB/NLB/NBB/NEB/
C                                    NAB/NYB/NRB order.
C                    W            =  final (after symmetrization)
C                                    NBO weight vector with elements in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C                    Q            =  final (after symmetrization)
C                                    NBO occupation interaction order
C                                    vector with elements in NCB/NLB/
C                                    NBB/NEB/NAB/NYB/NRB order. These
C                                    interaction orders are given by
C                                    the square root of the sum of the
C                                    square offdiagonal occupation
C                                    matrix elements:
C
C                                      Q (I) = sqrt ( sum   P (I,K)**2 )
C                                                    K.ne.I
C
C                                    They will be used here to determine
C                                    degenerate NBOs during the NBO
C                                    symmetrization procedure.
C                    C            =  final (after symmetrization)
C                                    full NBO coefficient matrix
C                                    in AO basis with columns in
C                                    NCB/NLB/NBB/NEB/NAB/NYB/NRB order.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     INITSYM,ATOMSYM,AXISSYM,HIGHSYM
         LOGICAL     PLATONIC
         LOGICAL     SKIP
         LOGICAL     TOTAL

         INTEGER     BOND
         INTEGER     I
         INTEGER     LTYPE
         INTEGER     MXNBA,MXSHELL
         INTEGER     NBAS,NATOM
         INTEGER     NBO
         INTEGER     NBOND
         INTEGER     NBOSIZE,ROTSIZE
         INTEGER     NCEN
         INTEGER     NTETRA,NCUBE,NOCTA,NDODECA,NICOSA
         INTEGER     NCB,NCA,NRB,NRA
         INTEGER     NHO,NNHO
         INTEGER     NLB,NLA,NBB,NEB,NEA,NAB,NYB,NYA
         INTEGER     OFFCR,OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR
         INTEGER     SYMSTEP

         INTEGER     ATNCB   (1:NCA   )
         INTEGER     ATNRB   (1:NRA   )
         INTEGER     ATNLB   (1:NLA   )
         INTEGER     ATNEB   (1:NEA   )
         INTEGER     ATNYB   (1:NYA   )
         INTEGER     ATCIDX  (1:NCA   )
         INTEGER     ATRIDX  (1:NRA   )
         INTEGER     ATLIDX  (1:NLA   )
         INTEGER     ATEIDX  (1:NEA   )
         INTEGER     ATYIDX  (1:NYA   )
         INTEGER     ATCOFF  (1:NCA   )
         INTEGER     ATROFF  (1:NRA   )
         INTEGER     ATLOFF  (1:NLA   )
         INTEGER     ATEOFF  (1:NEA   )
         INTEGER     ATYOFF  (1:NYA   )
         INTEGER     BASBEG  (1:NATOM )
         INTEGER     BASEND  (1:NATOM )
         INTEGER     BDNBAS  (1:NBAS  )
         INTEGER     BDNCEN  (1:NBAS  )
         INTEGER     COLMAP  (1:NBAS  )
         INTEGER     IVEC    (1:3*NBAS)
         INTEGER     NBOBD   (1:NBAS  )
         INTEGER     NRING   (1:NATOM )
         INTEGER     RINGSZ  (1:NATOM )
         INTEGER     SLTYPE  (1:NBAS  )
         INTEGER     SYMCEN  (1:NATOM )
         INTEGER     SYMNBO  (1:NBAS  )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS )
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS )
         INTEGER     PLATO   (1:NATOM  ,1:5    )
         INTEGER     RING    (1:NATOM  ,1:NATOM)
         INTEGER     SYMMAP  (1:NATOM  ,1:NATOM)

         DOUBLE PRECISION  ANGVAL
         DOUBLE PRECISION  CSQR
         DOUBLE PRECISION  DSYMACC,LSYMACC,PSYMACC,QSYMACC
         DOUBLE PRECISION  SYMCRIT
         DOUBLE PRECISION  ZERO,ONE,TINY

         DOUBLE PRECISION  LOCAL (1:NBAS     )
         DOUBLE PRECISION  Q     (1:NBAS     )
         DOUBLE PRECISION  W     (1:NBAS     )
         DOUBLE PRECISION  XVEC  (1:NBAS+NBAS)

         DOUBLE PRECISION  ANGNBO (1:NBAS   ,0:MXSHELL)
         DOUBLE PRECISION  ANGNHO (1:NBAS   ,0:MXSHELL)
         DOUBLE PRECISION  B      (1:NBOSIZE,1:NBAS   )
         DOUBLE PRECISION  C      (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  P      (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  HYB    (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  ROT    (1:ROTSIZE,1:ROTSIZE)
         DOUBLE PRECISION  SHALF  (1:NBAS   ,1:NBAS   )
         DOUBLE PRECISION  DOMAT  (1:NATOM  ,1:NATOM  )
         DOUBLE PRECISION  XMAT   (1:NBAS   ,1:NBAS   )

         PARAMETER  (ZERO  = 0.D0 )
         PARAMETER  (ONE   = 1.D0 )
         PARAMETER  (TINY  = 1.D-6)
C
C
C------------------------------------------------------------------------
C
C
C             ...attempt symmetrization (if necessary). 
C
C
         SKIP  =        (NCB.EQ.0)
     +            .AND. (NLB.EQ.0)
     +            .AND. (NEB.EQ.0)
     +            .AND. (NYB.EQ.0)
     +            .AND. (NRB.EQ.0)

         IF (SKIP) THEN
             RETURN
         END IF

         OFFCR = 0
         OFFLP = NCB
         OFFBD = OFFLP + NLB
         OFFEP = OFFBD + NBB
         OFFAB = OFFEP + NEB
         OFFRY = OFFAB + NAB
         OFFRR = OFFRY + NYB
C
C
C             ...determine all NBO total atomic localization contents.
C                These will assist together with the NBO interaction
C                orders in identifying symmetry equivalent NBOs.
C
C
         TOTAL = .TRUE.

         DO NBO = 1,NBAS

            BOND = NBOBD (NBO)
            NCEN = BDNCEN (BOND)

            CALL  NLO__EXTRACT_ATOMIC_CONTENT
     +
     +                 ( NBAS,NATOM,
     +                   NCEN,
     +                   BDCEN (1,BOND),
     +                   BASBEG,BASEND,
     +                   TOTAL,
     +                   C (1,NBO),
     +                   SHALF,
     +
     +                            XVEC (1) )
     +
     +
            LOCAL (NBO) = XVEC (1)

         END DO

         CALL    MAT__PRINT_A_FLOAT_18_NOZEROS
     +
     +                ( 6,
     +                  ' Locality vector (for symmetry use) ',
     +                  NBAS,1,
     +                  NBAS,1,
     +                  LOCAL )
     +
     +
C
C
C             ...for symmetrization we need to temporarily evaluate
C                the NBO smallest angular momentum vector, which will
C                possibly be changed during the symmetrization process.
C                Outermost loop is over the angular momentum type
C                in decreasing order!
C
C
         DO LTYPE = MXSHELL,0,-1
            DO NBO = 1,NBAS
               ANGVAL = ANGNBO (NBO,LTYPE)
               IF (ANGVAL.GT.TINY) THEN
                   SLTYPE (NBO) = LTYPE
               END IF
            END DO
         END DO
C
C
C             ...set initital values for array SYMNBO. Note, that
C                we use only bonds and anti-bonds of size 2 for
C                symmetrization. Larger sized bonds and anti-bonds
C                are not yet symmetry adapted and cannot be used
C                at this initial stage.
C
C
         DO I = 1,NBAS
            SYMNBO (I) = 0
         END DO

         DO I = 1,NBB
            NBO = OFFBD + I
            BOND = NBOBD (NBO)
            NCEN = BDNCEN (BOND)
            IF (NCEN.EQ.2) THEN
                SYMNBO (NBO) = 2
            END IF
         END DO

         DO I = 1,NAB
            NBO = OFFAB + I
            BOND = NBOBD (NBO)
            NCEN = BDNCEN (BOND)
            IF (NCEN.EQ.2) THEN
                SYMNBO (NBO) = 2
            END IF
         END DO
C
C
C             ...loop over all the symmetrization steps. The first
C                pass (steps 1-4) is done with a relatively high
C                symmetry interaction criterion, to avoid rotations
C                of degenerate NBOs using only possible computational
C                noise background. For the second pass this criterion
C                is set equal to the accuracy of the occupation matrix
C                to achieve symmetrization with all what we have at
C                hand by then.
C
C
         DO SYMSTEP = 1,6

            INITSYM = SYMSTEP.EQ.1
            ATOMSYM = SYMSTEP.EQ.2 .OR. SYMSTEP.EQ.5
            AXISSYM = SYMSTEP.EQ.3 .OR. SYMSTEP.EQ.6
            HIGHSYM = SYMSTEP.EQ.4

            IF (SYMSTEP.LE.4) THEN
                SYMCRIT = DSQRT (PSYMACC)
            ELSE
                SYMCRIT = PSYMACC
            END IF
C
C
C             ...Core NBO symmetrization (if necessary). 
C
C
            IF (NCB.GT.0) THEN

                CALL  NLO__SYMMETRIZE_ATOMIC_NBO
     +
     +                     ( NBAS,NATOM,
     +                       NBOSIZE,ROTSIZE,
     +                       MXNBA,
     +                       NCB,NCA,
     +                       OFFCR,
     +                       OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR,
     +                       ATNCB,ATCIDX,ATCOFF,IVEC (1),
     +                       BASBEG,BASEND,
     +                       COLMAP,SYMMAP,
     +                       IVEC (NBAS+1),
     +                       INITSYM,ATOMSYM,AXISSYM,HIGHSYM,
     +                       DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                       PLATONIC,
     +                       RING,NRING,RINGSZ,
     +                       NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                       PLATO,
     +                       SYMCEN,
     +                       BDNCEN,BDCEN,
     +                       HYB,
     +                       ROT,IVEC (2*NBAS+1),
     +                       SYMCRIT,
     +                       P,
     +                       DOMAT,
     +                       SHALF,
     +                       XVEC,
     +                       XMAT,
     +
     +                               SYMNBO,
     +                               SLTYPE,
     +                               NBOBD,
     +                               BDNBAS,
     +                               BDBAS,
     +                               LOCAL,
     +                               B,W,Q,C )
     +
     +
            END IF
C
C
C             ...Lone-pair NBO symmetrization (if necessary). 
C
C
            IF (NLB.GT.0) THEN

                CALL  NLO__SYMMETRIZE_ATOMIC_NBO
     +
     +                     ( NBAS,NATOM,
     +                       NBOSIZE,ROTSIZE,
     +                       MXNBA,
     +                       NLB,NLA,
     +                       OFFLP,
     +                       OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR,
     +                       ATNLB,ATLIDX,ATLOFF,IVEC (1),
     +                       BASBEG,BASEND,
     +                       COLMAP,SYMMAP,
     +                       IVEC (NBAS+1),
     +                       INITSYM,ATOMSYM,AXISSYM,HIGHSYM,
     +                       DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                       PLATONIC,
     +                       RING,NRING,RINGSZ,
     +                       NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                       PLATO,
     +                       SYMCEN,
     +                       BDNCEN,BDCEN,
     +                       HYB,
     +                       ROT,IVEC (2*NBAS+1),
     +                       SYMCRIT,
     +                       P,
     +                       DOMAT,
     +                       SHALF,
     +                       XVEC,
     +                       XMAT,
     +
     +                               SYMNBO,
     +                               SLTYPE,
     +                               NBOBD,
     +                               BDNBAS,
     +                               BDBAS,
     +                               LOCAL,
     +                               B,W,Q,C )
     +
     +
            END IF
C
C
C             ...Empty-pair NBO symmetrization (if necessary). 
C
C
            IF (NEB.GT.0) THEN

                CALL  NLO__SYMMETRIZE_ATOMIC_NBO
     +
     +                     ( NBAS,NATOM,
     +                       NBOSIZE,ROTSIZE,
     +                       MXNBA,
     +                       NEB,NEA,
     +                       OFFEP,
     +                       OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR,
     +                       ATNEB,ATEIDX,ATEOFF,IVEC (1),
     +                       BASBEG,BASEND,
     +                       COLMAP,SYMMAP,
     +                       IVEC (NBAS+1),
     +                       INITSYM,ATOMSYM,AXISSYM,HIGHSYM,
     +                       DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                       PLATONIC,
     +                       RING,NRING,RINGSZ,
     +                       NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                       PLATO,
     +                       SYMCEN,
     +                       BDNCEN,BDCEN,
     +                       HYB,
     +                       ROT,IVEC (2*NBAS+1),
     +                       SYMCRIT,
     +                       P,
     +                       DOMAT,
     +                       SHALF,
     +                       XVEC,
     +                       XMAT,
     +
     +                               SYMNBO,
     +                               SLTYPE,
     +                               NBOBD,
     +                               BDNBAS,
     +                               BDBAS,
     +                               LOCAL,
     +                               B,W,Q,C )
     +
     +
            END IF
C
C
C             ...Rydberg bond NBO symmetrization (if necessary). 
C
C
            IF (NYB.GT.0) THEN

                CALL  NLO__SYMMETRIZE_ATOMIC_NBO
     +
     +                     ( NBAS,NATOM,
     +                       NBOSIZE,ROTSIZE,
     +                       MXNBA,
     +                       NYB,NYA,
     +                       OFFRY,
     +                       OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR,
     +                       ATNYB,ATYIDX,ATYOFF,IVEC (1),
     +                       BASBEG,BASEND,
     +                       COLMAP,SYMMAP,
     +                       IVEC (NBAS+1),
     +                       INITSYM,ATOMSYM,AXISSYM,HIGHSYM,
     +                       DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                       PLATONIC,
     +                       RING,NRING,RINGSZ,
     +                       NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                       PLATO,
     +                       SYMCEN,
     +                       BDNCEN,BDCEN,
     +                       HYB,
     +                       ROT,IVEC (2*NBAS+1),
     +                       SYMCRIT,
     +                       P,
     +                       DOMAT,
     +                       SHALF,
     +                       XVEC,
     +                       XMAT,
     +
     +                               SYMNBO,
     +                               SLTYPE,
     +                               NBOBD,
     +                               BDNBAS,
     +                               BDBAS,
     +                               LOCAL,
     +                               B,W,Q,C )
     +
     +
            END IF
C
C
C             ...Rydberg NBO symmetrization (if necessary). 
C
C
            IF (NRB.GT.0) THEN

                CALL  NLO__SYMMETRIZE_ATOMIC_NBO
     +
     +                     ( NBAS,NATOM,
     +                       NBOSIZE,ROTSIZE,
     +                       MXNBA,
     +                       NRB,NRA,
     +                       OFFRR,
     +                       OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR,
     +                       ATNRB,ATRIDX,ATROFF,IVEC (1),
     +                       BASBEG,BASEND,
     +                       COLMAP,SYMMAP,
     +                       IVEC (NBAS+1),
     +                       INITSYM,ATOMSYM,AXISSYM,HIGHSYM,
     +                       DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                       PLATONIC,
     +                       RING,NRING,RINGSZ,
     +                       NTETRA,NCUBE,NOCTA,NDODECA,NICOSA,
     +                       PLATO,
     +                       SYMCEN,
     +                       BDNCEN,BDCEN,
     +                       HYB,
     +                       ROT,IVEC (2*NBAS+1),
     +                       SYMCRIT,
     +                       P,
     +                       DOMAT,
     +                       SHALF,
     +                       XVEC,
     +                       XMAT,
     +
     +                               SYMNBO,
     +                               SLTYPE,
     +                               NBOBD,
     +                               BDNBAS,
     +                               BDBAS,
     +                               LOCAL,
     +                               B,W,Q,C )
     +
     +
            END IF

         END DO
C
C
C             ...reevaluate the NBO angular momentum table.
C
C
         DO LTYPE = 0,MXSHELL

            DO NBO = 1,NBAS
               BOND = NBOBD (NBO)
               NNHO = BDNBAS (BOND)
               ANGVAL = ZERO

               DO I = 1,NNHO
                  NHO = BDBAS (I,BOND)
                  CSQR = B (I,NBO) ** 2
                  ANGVAL = ANGVAL + CSQR * ANGNHO (NHO,LTYPE)
               END DO

               ANGNBO (NBO,LTYPE) = ANGVAL

            END DO
         END DO
C
C
C             ...printout for checking. 
C
C
         CALL    MAT__PRINT_V_INTEGER_NOZEROS
     +
     +            ( 1,
     +              ' BDNBAS vector (after symmetrize) ',
     +              NBAS,
     +              NBAS,
     +              BDNBAS )
     +
     +
         CALL    MAT__PRINT_V_INTEGER_NOZEROS
     +
     +            ( 1,
     +              ' BDNCEN vector (after symmetrize) ',
     +              NBAS,
     +              NBAS,
     +              BDNCEN )
     +
     +
         CALL    MAT__PRINT_A_INTEGER_NOZEROS
     +
     +            ( 1,
     +              ' BDCEN array (after symmetrize) ',
     +              NBOSIZE,NBAS,
     +              NBOSIZE,NBAS,
     +              BDCEN )
     +
     +
         CALL    MAT__PRINT_A_INTEGER_NOZEROS
     +
     +            ( 1,
     +              ' BDBAS array (after symmetrize) ',
     +              NBOSIZE,NBAS,
     +              NBOSIZE,NBAS,
     +              BDBAS )
     +
     +
         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
     +
     +            ( 1,
     +              ' B matrix (after symmetrize) ',
     +              NBOSIZE,NBAS,
     +              NBOSIZE,NBAS,
     +              B )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__GENER_ERI_BATCH
     +
     +                    ( IMAX,ZMAX,
     +                      NALPHA,NCOEFF,NCSUM,
     +                      NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL2,SHELL3,SHELL4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      ALPHA,CC,CCBEG,CCEND,
     +                      SPHERIC,
     +                      SCREEN,
     +                      ICORE,
     +
     +                                NBATCH,
     +                                NFIRST,
     +                                ZCORE )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__GENER_ERI_BATCH
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__1111_CSGTO
C                ERD__CSGTO
C  DESCRIPTION : Main operation that drives the calculation of a batch
C                of contracted electron repulsion integrals.
C
C
C                  Input (x = 1,2,3 and 4):
C
C                    IMAX,ZMAX    =  maximum integer,flp memory
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCSUM        =  total # of contractions
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1,2,3 and 4
C                    ALPHA        =  primitive exponents for csh
C                                    1,2,3,4 in that order
C                    CC           =  contraction coefficient for csh
C                                    1,2,3,4 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction
C                    CC(BEG)END   =  (lowest)highest nonzero primitive
C                                    index for contractions for csh
C                                    1,2,3,4 in that order. They are
C                                    different from (1)NPGTOx only for
C                                    segmented contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C                    SCREEN       =  is true, if screening will be
C                                    done at primitive integral level
C                    ICORE        =  integer scratch space
C                    ZCORE (part) =  flp scratch space
C
C
C                  Output:
C
C                    NBATCH       =  # of integrals in batch
C                    NFIRST       =  first address location inside the
C                                    ZCORE array containing the first
C                                    integral
C                    ZCORE        =  full batch of contracted (12|34)
C                                    integrals over cartesian or
C                                    spherical gaussians starting at
C                                    ZCORE (NFIRST)
C
C
C
C                            !!! IMPORTANT !!!
C
C                For performance tuning, please see the include file
C                'erd__tuning.inc'.
C                
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INCLUDE     'erd__ftable.inc'
         INCLUDE     'erd__tuning.inc'

         LOGICAL     SCREEN
         LOGICAL     SPHERIC

         INTEGER     IMAX,ZMAX
         INTEGER     NALPHA,NCOEFF,NCSUM
         INTEGER     NBATCH,NFIRST
         INTEGER     NCGTO1,NCGTO2,NCGTO3,NCGTO4
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4
         INTEGER     SHELL1,SHELL2,SHELL3,SHELL4

         INTEGER     CCBEG (1:NCSUM)
         INTEGER     CCEND (1:NCSUM)
         INTEGER     ICORE (1:IMAX)

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
         DOUBLE PRECISION  ZCORE (1:ZMAX)
C
C
C------------------------------------------------------------------------
C
C
C             ...call special routine, if only s- and p-type integrals
C                are requested.
C
C
         IF (MAX (SHELL1,SHELL2,SHELL3,SHELL4).LT.2) THEN

             CALL  ERD__1111_CSGTO
     +
     +                  ( IMAX,ZMAX,
     +                    NALPHA,NCOEFF,NCSUM,
     +                    NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                    NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                    SHELL1,SHELL2,SHELL3,SHELL4,
     +                    X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                    ALPHA,CC,CCBEG,CCEND,
     +                    FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                    L1CACHE,TILE,NCTROW,
     +                    SCREEN,
     +                    ICORE,
     +
     +                              NBATCH,
     +                              NFIRST,
     +                              ZCORE )
     +
     +
         ELSE

             CALL  ERD__CSGTO
     +
     +                  ( IMAX,ZMAX,
     +                    NALPHA,NCOEFF,NCSUM,
     +                    NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                    NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                    SHELL1,SHELL2,SHELL3,SHELL4,
     +                    X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                    ALPHA,CC,CCBEG,CCEND,
     +                    FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                    L1CACHE,TILE,NCTROW,
     +                    SPHERIC,SCREEN,
     +                    ICORE,
     +
     +                              NBATCH,
     +                              NFIRST,
     +                              ZCORE )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE UNITRY(A,B,C,N)
C
C PERFORMS UNITARY TRANSFORMATION C = A(t) B A
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N,N),C(N,N)
      CALL MODMATMUL(C,B,A,N,N,N,N,N,N)
      CALL MTRAN2(A,N)
      CALL MODMATMUL(C,A,C,N,N,N,N,N,N)
      CALL MTRAN2(A,N)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pop_work_node(node)
c-------------------------------------------------------------------------
c   This subroutine pops a node off the stack of available message nodes.
c   The index of the node is returned in the "node" argument.
c
c   If no nodes are available, a negative value is returned.
c-------------------------------------------------------------------------
      implicit none
      include 'server.h'

      integer node
     
      if (server_node_ptr .lt. 1) then
         node = -1
         return
      else
         node = server_msg_node(server_node_ptr)
         server_node_ptr = server_node_ptr - 1
      endif

      return
      end

      SUBROUTINE FRMTAU(SCR,MAXCOR,IUHF,RLECYC,MAXORD,NEWT,IBOT,
     &                  SINGLE,RLETYP)
C
C FORMS THE TAU VECTOR USED TO EXTRAPOLATE THE AMPLITUDES.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION R,ECORR,DET,TOL,ERLE,SCR,ERLET2,FACT
      LOGICAL NEWT,SINGLE
      DIMENSION SCR(MAXCOR/2)
      COMMON /RMAT/ R(400)
cAP - 500 is the maximum number of CC iterations (not basis functions)
      COMMON /ENERGY/ ECORR(500,2),IXTRLE(500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/ IFLAGS(100)
C
C FORM AUGMENTED R MATRIX NOW
C
      IF(MOD(RLETYP,2).EQ.0)THEN
C
C RLE
C
       TOL=0.0
       IORDER=MIN(RLECYC-1,MAXORD)
       ISTART=MAXORD*IORDER+1
       LENGTH=MAXORD*IORDER+IORDER
       I000=1
       I010=I000+LENGTH
c YAU : old
c      CALL ICOPY(LENGTH*IINTFP,R,1,SCR,1)
c YAU : new
       CALL DCOPY(LENGTH,R,1,SCR,1)
c YAU : end
       IX=0
       DO 10 I=IORDER,1,-1
        IX=IX+1
        SCR(ISTART+I-1)=ECORR(IBOT+RLECYC-IORDER+IX-1,2)
10     CONTINUE
       CALL MINV(SCR,IORDER,MAXORD,SCR(I010),DET,TOL,1,0)
      ELSE
C
C RLE-1
C
       TOL=0.0
       NROWPHYR=MAXORD
       NROWPHYS=MAXORD+1
       NCOLPHYR=NROWPHYR
       NCOLPHYS=NROWPHYS
       NROWLOGR=MIN(RLECYC-1,MAXORD)
       NROWLOGS=MIN(RLECYC-1,MAXORD)+1
       IORDER=NROWLOGR
       ISTART=NROWPHYS*NROWLOGS+1
       CALL ZERO(SCR,NROWPHYS*NCOLPHYS)
       I010=1+2*NROWPHYS*NCOLPHYS
       IOFFR=1
       IOFFS=1
       DO 6 ICOL=1,NROWLOGR
c YAU : old
c       CALL ICOPY(IINTFP*NROWLOGR,R(IOFFR),1,SCR(IOFFS),1)
c YAU : new
        CALL DCOPY(NROWLOGR,R(IOFFR),1,SCR(IOFFS),1)
c YAU : end
        SCR(IOFFS+NROWLOGR)=-1.0
        IOFFR=IOFFR+NROWPHYR
        IOFFS=IOFFS+NROWPHYS
        SCR(NROWPHYS*NROWLOGR+ICOL)=-1.0
6      CONTINUE
       SCR(NROWPHYS*NCOLPHYS)=0.0
       DO 7 I=NROWLOGS,1,-1
        FACT=0.
        IF(I.EQ.NROWLOGS)FACT=-1.
        SCR(ISTART+I-1)=FACT
7      CONTINUE
       ISCR=NROWPHYS*(NCOLPHYS+1)
       CALL MINV(SCR,NROWLOGS,NROWPHYS,SCR(I010),DET,TOL,1,0)
      ENDIF
      IF(IFLAGS(1).GT.10)THEN
       WRITE(6,2000)(SCR(ISTART+J),J=0,IORDER-1)
2000   FORMAT(T3,'@FRMTAU-I, RLE expansion coefficients: ',/,
     &        ((5F12.8)))
      ENDIF
C
C SOLUTION VECTOR NOW RESIDES IN R(ISTART..ISTART+IORDER-1).
C
C
C FORM RLE ENERGY ESTIMATE.
C
      IEOFF=IBOT+RLECYC-IORDER+1
      IF(RLETYP.NE.2.AND.RLETYP.NE.3)THEN
        CALL FRMTAU_EXTRAP(ECORR(1,2),ECORR(IEOFF,1),ECORR(IEOFF,2),
     &              SCR(ISTART),ERLE,IORDER,SINGLE,RLETYP)
      ENDIF
      IF(NEWT.OR.RLETYP.EQ.2.OR.RLETYP.EQ.3)THEN
       WRITE(6,200)IORDER
200    FORMAT(T3,'@FRMTAU-I, Generating new solution vector from ',
     &           'previous ',I3,' iterates.')
       CALL RLEVEC(SCR(I010),MAXCOR-I010,IUHF,
     &             SCR(ISTART),IORDER,SINGLE,ERLE,RLETYP,MAXORD)
       ECORR(IBOT+RLECYC,2)=ERLE
       IXTRLE(IBOT+RLECYC)=1
       IF(RLETYP.NE.2.AND.RLETYP.NE.3)CALL ZERO(R,400)
      ENDIF 
      WRITE(6,100)ERLE
100   FORMAT(T3,'RLE <0|H (T2+T1)|0> energy estimator : ',F14.10,
     &          ' a.u.')
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE POWEL(V,H,SCRATCH,STEP,TBT, PHI)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

#include "io_units.par"
#include "fnamelen.par"
#include "jodaflags.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT

      DIMENSION V(NXM6),H(NXM6*NXM6),SCRATCH(NX*NX),TBT(3*NXM6*NXM6),
     $   STEP(NXM6)
C
C X = 1/DX{dot}DX where DX is the step size.
C
      X=1.D0/xdot(NXM6,STEP,1,STEP,1)

      N2=NXM6+1
      N3=2*NXM6+1
      N4=3*NXM6+1
C
C SCRATCH(N2) = HDX where H is the Hessian, SCRATCH(N3) = DG (gradient
C difference), SCRATCH(N4) = (DG - HDX)
C
      CALL MODMATMUL(SCRATCH(N2),H,STEP,NXM6,NXM6,1,NXM6,NXM6,1)
      CALL VADD(SCRATCH(N3),V,SCRATCH(1),NXM6,-1.D0)
      CALL VADD(SCRATCH(N4),SCRATCH(N3),SCRATCH(N2),NXM6,-1.D0)

      N2=NXM6*NXM6+1
      N3=NXM6*NXM6+N2
C
C TBT(1) = DXDX, TBT(N2) = (DG - HDX)DX
C
      CALL MODMATMUL(TBT(1),STEP,STEP,NXM6,1,NXM6,NXM6,1,NXM6)
      CALL MODMATMUL(TBT(N2),SCRATCH(N4),STEP,NXM6,1,NXM6,NXM6,1,
     &               NXM6)
C
C Take the transpose of (DG - HDX)DX, TBT(N3) = [(DG - HDX)DX]^{t}
C
      CALL MTRANSP(TBT(N2),TBT(N3),NXM6,NXM6,NXM6,NXM6)
C
C Built the (DG - HDX)dotDX and scale the DXDX, TBT(1) =
c [DXdot(DG - HDX)]DXDX
C
      dtmp = xdot(NXM6,SCRATCH(N4),1,STEP,1)
      CALL xscal(NXM6*NXM6,dtmp*X,TBT(1),1)
C
C TBT(N3) = (DG - HDX)DX + [(DG - HDX)DX]^{t} - [DXdot(DG - HDX)]DXDX/DX{dot}DX
C
      CALL VADD(TBT(N3),TBT(N3),TBT(N2),NXM6*NXM6,1.D0)
      CALL VADD(TBT(N3),TBT(N3),TBT(1),NXM6*NXM6,-1.D0)
C
C H(updated) = H(old) + [(DG - HDX)DX + [(DG - HDX)DX]^{t}]/DX{dot}DX +
C              DXdot(DG - HDX)]DXDX/[DX{dot}DX]^{2}
C
      CALL xscal(NXM6*NXM6,X,TBT(N3),1)
      CALL XDAXPY(NXM6*NXM6, PHI, TBT(N3), 1, H, 1)
C
C DON'T WRITE ENTIRE HESSIAN UNLESS SPECIFICALLY REQUESTED.  FOR
C NOW, JUST USE AN IN-CODE PARAMETER.
C
      IF (IFLAGS(1).GE.10) THEN
         Print*, "-----The Powel updated Hessian-----"
         CALL HESSOUT(H,NXM6,NXM6,0)
      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__BALANCE_SYMMETRIC_MATRIX
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDVECW,
     +                      N,
     +                      THRESH,
     +                      W,
     +
     +                              X )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__BALANCE_SYMMETRIC_MATRIX
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : Given a symmetric matrix X, this routine balances its
C                elements to within a threshold THRESH. By balancing
C                we mean setting all elements strictly equal that are
C                equal to within the threshold value.
C
C
C                Procedure:
C                ----------
C
C                  Loop over all matrix elements (lower triangle)
C                  column by column
C
C                      If element X(i,j) was not balanced:
C
C                    a)   Set SUM = X(i,j)
C                               M = 1
C
C                         Loop over all the rest of the X matrix
C
C                             If ABS (X(k,l)-X(i,j)) < THRESH, then
C                                SUM = SUM + X(k,l)
C                                  M = M + 1
C                             end if
C
C                         end do
C
C                         Form average XAV = SUM / M
C
C                         Set X(i,j) = XAV and go back to step a)
C
C                         Keep doing until value of M is stable, that
C                         is equal between two runs.
C
C                         If M = stable, rerun from step a) but this
C                         time place XAV into X(i,j) and all
C                         relevant X(k,l) and mark them as balanced.
C
C                      end if
C
C                  end do
C
C
C                  Input:
C
C                   DDROWX = row dimension for matrix X
C                   DDCOLX = column dimension for matrix X
C                   DDROWW = row dimension for working matrix W
C                   DDCOLW = column dimension for working matrix W
C                   DDVECD = dimension for vector D
C                        N = order of the matrix X to be balanced
C                        D = vector D that will contain the eigenvalues
C                            of X and later the updated transfomed
C                            diagonals
C                        X = matrix to be diagonally equalized
C
C                  Output:
C
C                        X = transformation matrix
C
C                Only the lower triangle of X needs to be supplied.
C
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   BALANCE
         LOGICAL   STABLE

         INTEGER   DDROWX,DDCOLX,DDVECW
         INTEGER   I,J,K,L,M,N
         INTEGER   ITER
         INTEGER   MOLD

         DOUBLE PRECISION   SUM
         DOUBLE PRECISION   THRESH
         DOUBLE PRECISION   XAV
         DOUBLE PRECISION   ZERO,ONE

         DOUBLE PRECISION   W (1:DDVECW)

         DOUBLE PRECISION   X (1:DDROWX,1:DDCOLX)

         PARAMETER   (ZERO = 0.D0)
         PARAMETER   (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check passed dimensions.
C
C
         IF (N.GT.DDROWX .OR. N.GT.DDCOLX) THEN
             WRITE (*,*) ' Dimension of matrix X too small: '
             WRITE (*,*) ' mat__balance_symmetric_matrix '
             WRITE (*,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
             WRITE (1,*) ' Dimension of matrix X too small: '
             WRITE (1,*) ' mat__balance_symmetric_matrix '
             WRITE (1,*) ' DDROWX,DDCOLX,N = ',DDROWX,DDCOLX,N
             STOP
         END IF

         IF (N.GT.DDVECW)  THEN
             WRITE (1,*) ' Dimension of vector W too small: '
             WRITE (1,*) ' mat__balance_symmetric_matrix '
             WRITE (1,*) ' DDVECW,N = ',DDVECW,N
             WRITE (*,*) ' Dimension of vector W too small: '
             WRITE (*,*) ' mat__balance_symmetric_matrix '
             WRITE (*,*) ' DDVECW,N = ',DDVECW,N
             STOP
         END IF
C
C
C             ...set upper triangle of X and W vector to zero,
C                to mark all elements of lower triangle of X as
C                unbalanced.
C
C
         DO J = 1,N
            W (J) = ZERO
            DO I = 1,J-1
               X (I,J) = ZERO
            END DO
         END DO
C
C
C             ...outer loop over all X matrix elements columnwise.
C
C
         DO J = 1,N
         DO I = J,N

            IF (I.NE.J) THEN
                BALANCE = X (J,I) .EQ. ZERO
            ELSE
                BALANCE = W (I) .EQ. ZERO
            END IF

            IF (BALANCE) THEN
                XAV = X (I,J)
                MOLD = 1
                ITER = 0

 1000           IF (ITER.GT.10) THEN
                    WRITE (*,*) ' # of balancing iterations > 10! '
                    WRITE (*,*) ' mat__balance_symmetric_matrix '
                    WRITE (1,*) ' # of balancing iterations > 10! '
                    WRITE (1,*) ' mat__balance_symmetric_matrix '
                    STOP
                END IF

                M = 1
                SUM = XAV
                DO K = I+1,N
                   IF (ABS (X (K,J) - XAV).LT.THRESH) THEN
                       M = M + 1
                       SUM = SUM + X (K,J)
                   END IF
                END DO
                DO L = J+1,N
                DO K = L,N
                   IF (ABS (X (K,J) - XAV).LT.THRESH) THEN
                       M = M + 1
                       SUM = SUM + X (K,J)
                   END IF
                END DO
                END DO

                XAV = SUM / DFLOAT (M)
                STABLE = M.EQ.MOLD

                IF (STABLE) THEN
                    X (I,J) = XAV
                    IF (I.NE.J) THEN
                        X (J,I) = ONE
                    ELSE
                        W (I) = ONE
                    END IF
                    DO K = I+1,N
                       IF (ABS (X (K,J) - XAV).LT.THRESH) THEN
                           X (K,J) = XAV
                           X (J,K) = ONE
                       END IF
                    END DO
                    DO L = J+1,N
                       IF (ABS (X (L,L) - XAV).LT.THRESH) THEN
                           X (L,L) = XAV
                           W (L) = ONE
                       END IF
                       DO K = L+1,N
                          IF (ABS (X (K,L) - XAV).LT.THRESH) THEN
                              X (K,L) = XAV
                              X (L,K) = ONE
                          END IF
                       END DO
                    END DO
                ELSE
                    MOLD = M
                    ITER = ITER + 1
                    GOTO 1000
                END IF

            END IF

         END DO
         END DO
C
C
C             ...finished!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine place_sval(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c   Usage: execute place_sval array scalar
c   
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      if (nindex .ne. 2) then
         print *,'Error: place_sval at line ',current_line
         print *,'First arg. must be a block of a 2-index array.'
         call abort_job()
      endif

      if (nindex2 .ne. 0) then
         print *,'Error: place_sval at line ',current_line,' not ',
     *           'called with scalar in 2nd arg.'
         call abort_job()      
      endif

      call doplace(x, x2,
     *             bval(1),eval(1),bval(2),eval(2))

      return 
      end 

      subroutine doplace(array1,sval,a1,a2,b1,b2) 

c---------------------------------------------------------------------------
c
c 
c---------------------------------------------------------------------------

      implicit none
      integer a, a1, a2, b, b1, b2   
      double precision array1(a1:a2,b1:b2), sval   

c     write(6,*) ' RANGE :', a1, a2, b1, b2, sval  
      do a = a1, a2 
      do b = b1, b2 
           array1(a,b) = sval  
c          write(6,*) ' ARRAY ', a, b, array1(a,b)  
      enddo ! b 
      enddo ! a 
c     write(6,*) ' Maximum density difference :', val 
c
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__INITIALIZE_RUN
     +
     +                    ( NBAS,NATOM,
     +                      MXSHELL,
     +                      MAXOCC,BONDSIZE,
     +                      NSHELLS,SHELLS,NBASAL,
     +                      SPHERIC,
     +                      MXCHOOSE,NCHOOSE,CHOOSE,
     +                      INDEX,
     +                      XYZ,ZATOM,
     +                      S,
     +                      XVEC,
     +                      XMAT,
     +
     +                            NO2CEN,
     +                            WPRERYD,WNAOVAL,WNAORYD,WNBOOCC,
     +                            WBDMIN,WSTMAX,WBDCRT,WSTEP,
     +                            DSYMACC,LSYMACC,PSYMACC,QSYMACC,
     +                            MXNBA,MXLSIZE,
     +                            LSIZE,
     +                            BASBEG,BASEND,
     +                            SYMMAP,
     +                            BDATOM,
     +                            GPOINT,
     +                            DOMAT,
     +                            SOMAT,
     +                            BOMAT,
     +                            PLATONIC,
     +                            D )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__INITIALIZE_RUN
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine initializes the present run. It generates
C                all data, which is needed several times later on.
C                Also transmitted data is checked for consistency and
C                the program is aborted, if any meaningless data is
C                found. Initialize appropriate arrays to zero.
C
C                This routine generates the distance order matrix, the
C                atomic overlap order matrix, the atomic bond order
C                matrix and the occupation matrix from the density
C                matrix (i.e. the expansion coefficients of the density
C                rho(r) in terms of basis function products) and the
C                overlap matrix. The occupation matrix is defined as a
C                matrix representation of the density rho(r) in terms
C                of the basis functions.
C
C                Procedure:
C
C                The definition of the density matrix with elements
C                D (i,j) in terms of the basis functions is:
C
C                       rho (r)  =  sum  D (i,j) * chi (i) * chi (j)
C                                    ij
C
C                The occupation matrix element P (k,l) is thus:
C
C                       P (k,l)  =  < chi (k) | rho (r) | chi (l) >
C
C                                =  sum  S (k,i) * D (i,j) * S (j,l)
C                                    ij
C
C                where S is the overlap matrix of the basis functions.
C
C                           ------------------------------
C
C                The atomic bond order matrix is defined as summations
C                of elements of D*S between atomic subblocks a and b:
C
C                    BOMAT (a,b) =  sum     sum    DS (i,j) * DS (j,i)
C                                 i in a  j in b
C
C                Note that the product D*S is needed for evaluation
C                of both matrices, hence the first step is the
C                generation of D*S. The atomic bond order matrix can
C                be used to decide initially if platonic symmetry is
C                present in the density matrix. Simply diagonalize
C                the atomic bond order matrix and check for the
C                resulting eigenvalues for degeneracies > 2.
C
C                           ------------------------------
C
C                The atomic overlap order matrix is finally defined as
C                summations of square elements of S between atomic
C                subblocks a and b:
C
C                    SOMAT (a,b) =  sum     sum    S (i,j) * S (i,j)
C                                 i in a  j in b
C
C                This matrix is further normalized such that all
C                diagonal elements become equal to 1 via:
C
C                                        _______________
C                     SOMAT' (a,b) =   \/ (1/SOMAT(a,a))
C                                        _______________
C                                    * \/ (1/SOMAT(b,b))
C
C                                    * SOMAT (a,b)
C
C
C                           ------------------------------
C
C                The distance order matrix is a matrix reflecting
C                the distances between atoms in the following way:
C
C                      i) The atom itself has a distance order
C                         of 1.
C
C                     ii) The distance order between those atoms
C                         which are most appart is set to 0.
C
C                This is achieved by defining the distance order
C                between atoms A and B as:
C
C                      DOMAT (A,B) = (dmax - d(AB)) / dmax
C
C                where dmax is the maximum distance in the complete
C                atomic set and d(AB) is the ordinary distance between
C                atoms A and B. The importance of the distance order
C                matrix lies in the fact that similar arrangements
C                of atoms differing only by all distances scaled by
C                a specific factor (i.e. imploded or exploded shapes
C                from the original geometry) lead to the same distance
C                order matrix. Also note that the distance orders are
C                independent of units used (Angstrom or Bohr).
C
C                           ------------------------------
C
C                Since the density matrix D is not needed later on,
C                the array D will be overwritten with the occupation
C                matrix.
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    MXSHELL      =  largest l-shell value
C                    MAXOCC       =  maximum orbital occupancy number
C                                    (can be only 1 or 2).
C                    BONDSIZE     =  maximum # of atomic centers that
C                                    are allowed to form a bond.
C                    NSHELLS (A)  =  # of l-shells for atom A.
C                    SHELLS (I,A) =  I-th l-shell type (s=0,p=1,etc...)
C                                    for atom A (in increasing order!).
C                    NBASAL (I,A) =  size of I-th atomic l-shell space
C                                    for atom A.
C                    SPHERIC      =  is true, if the l-shells are
C                                    spherical, false if they are
C                                    cartesian.
C                    MXCHOOSE     =  maximum # of bonds selected to
C                                    be chosen. The maximum is build
C                                    from all # of chosen bonds for all
C                                    bondsizes.
C                    NCHOOSE (B)  =  # of bonds to be chosen for bonds
C                                    of size B. Four cases:
C                                    1) = 9999 => skip search for bonds
C                                       of size B.
C                                    2) = 0 => complete search for all
C                                       possible bonds of size B will
C                                       be performed.
C                                    3) = -n => only n bonds of size B
C                                       will be searched between those
C                                       atomic indices as provided by
C                                       the CHOOSE array.
C                                    4) = +n => same as case 3) but
C                                       followed by a complete search
C                                       for all possible remaining
C                                       bonds of size B.
C                                    Priority level: 1) > 3) > 4) > 2).
C                    CHOOSE       =  element CHOOSE (I,N,B) contains
C                                    the I-th atomic index of the N-th
C                                    chosen bond of size B. The order
C                                    of the atomic indices is arbitrary.
C                    INDEX        =  will hold info about used atoms
C                    XYZ          =  x,y,z-coordinates for all the
C                                    atoms in 3 x NATOM matrix format.
C                    ZATOM (I)    =  atomic number for I-th atom.
C                    S            =  normalized overlap matrix
C                    XVEC         =  flp scratch vector
C                    XMAT         =  flp scratch matrix
C                    D            =  normalized density matrix
C
C                  Output:
C
C                    NO2CEN       =  2-center bond formation criterion
C                                    for analysis of the atomic bond
C                                    order matrix.
C                    WPRERYD      =  the initial Rydberg pre-NAO weight
C                                    threshold. This is the initial
C                                    Rydberg weight criterion for
C                                    pre-NAO construction.
C                    WNAOVAL      =  the Valence NAO weight threshold.
C                    WNAORYD      =  the Rydberg NAO weight threshold.
C                    WNBOOCC      =  the weight limit to decide when
C                                    a NBO is considered occupied or
C                                    virtual.
C                    WBDMIN       =  initial minimum accepted weight
C                                    for bond construction.
C                    WSTMAX       =  initial maximum accepted weight
C                                    for antibond construction.
C                    WBDCRT       =  critical weight limit for bond
C                                    construction.
C                    WSTEP        =  weight stepping size to decrease/
C                                    increase the bond/antibond weight
C                                    limits.
C                    DSYMACC      =  symmetry accuracy for distance
C                                    order matrix values
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    PSYMACC      =  symmetry accuracy for occupation
C                                    matrix values (including weights)
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    MXNBA        =  maximum # of AOs per atom
C                    MXLSIZE      =  maximum l-shell size, i.e. largest
C                                    m-subspace.
C                    LSIZE (I)    =  I-th l-shell size
C                    BASBEG (A)   =  first basis index number for
C                                    atom A.
C                    BASEND (A)   =  last basis index number for
C                                    atom A.
C                    SYMMAP (A,B) =  this matrix will contain the info,
C                                    if atoms A and B are symmetry
C                                    related (=1) or not (=0). Initially
C                                    we know that for sure A is symmetry
C                                    related to A, hence we initiallize
C                                    this matrix with a unit matrix.
C                    BDATOM       =  Natural localized orbital atomic
C                                    index map array. Will be set = 0.
C                    GPOINT       =  if the center of mass of the
C                                    atomic arrangement coincides with
C                                    one of the atoms, this variable
C                                    will contain the corresponding
C                                    atomic index. If no atom coincides
C                                    with the center of mass location
C                                    a value of 0 is transmitted.
C                    DOMAT        =  distance order matrix
C                    SOMAT        =  atomic overlap order matrix
C                    BOMAT        =  atomic bond order matrix
C                    PLATONIC     =  is true, if the diagonalization
C                                    of the atomic bond order matrix
C                                    gave eigenvalues of degeneracies
C                                    > 2, showing that the density
C                                    matrix might correspond to a
C                                    platonic symmetry (ruling out
C                                    accidential degeneracies!)
C                    D            =  occupation matrix in AO basis
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     PLATONIC
         LOGICAL     SPHERIC

         INTEGER     A,B,I,J,N
         INTEGER     ATOM
         INTEGER     BASNR
         INTEGER     BONDSIZE
         INTEGER     GPOINT
         INTEGER     IBEG,IEND,JBEG,JEND
         INTEGER     LTYPE
         INTEGER     MAXDEG
         INTEGER     MXCHOOSE
         INTEGER     MXLSIZE
         INTEGER     MXNBA
         INTEGER     MXSHELL
         INTEGER     NBAS,NATOM
         INTEGER     NDEG
         INTEGER     NLAST
         INTEGER     NSHELL
         INTEGER     NXBA

         INTEGER     BASBEG  (1:NATOM)
         INTEGER     BASEND  (1:NATOM)
         INTEGER     INDEX   (1:NATOM)
         INTEGER     LSIZE   (0:MXSHELL)
         INTEGER     NCHOOSE (1:BONDSIZE)
         INTEGER     NSHELLS (1:NATOM)
         INTEGER     ZATOM   (1:NATOM)

         INTEGER     BDATOM  (1:NBAS     ,1:BONDSIZE)
         INTEGER     NBASAL  (1:MXSHELL+1,1:NATOM   )
         INTEGER     SHELLS  (1:MXSHELL+1,1:NATOM   )
         INTEGER     SYMMAP  (1:NATOM    ,1:NATOM   )

         INTEGER     CHOOSE  (1:BONDSIZE,1:MXCHOOSE,1:BONDSIZE)

         DOUBLE PRECISION  DAB,DMAX
         DOUBLE PRECISION  DIFF
         DOUBLE PRECISION  DSYMACC,LSYMACC,PSYMACC,QSYMACC
         DOUBLE PRECISION  MASS,MOLMASS
         DOUBLE PRECISION  MAXOCC
         DOUBLE PRECISION  NO2CEN
         DOUBLE PRECISION  WBDMIN,WSTMAX,WBDCRT,WSTEP
         DOUBLE PRECISION  WPRERYD,WNAORYD,WNAOVAL,WNBOOCC
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         DOUBLE PRECISION  ZERO,ONE,SMALL,THRESH

         DOUBLE PRECISION  XVEC  (1:NATOM)

         DOUBLE PRECISION  BOMAT (1:NATOM,1:NATOM)
         DOUBLE PRECISION  D     (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  DOMAT (1:NATOM,1:NATOM)
         DOUBLE PRECISION  S     (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  SOMAT (1:NATOM,1:NATOM)
         DOUBLE PRECISION  XMAT  (1:NBAS ,1:NBAS )
         DOUBLE PRECISION  XYZ   (1:3    ,1:NATOM)

         PARAMETER    (ZERO    = 0.D0 )
         PARAMETER    (ONE     = 1.D0 )
         PARAMETER    (SMALL   = 1.D-6)
         PARAMETER    (THRESH  = 1.D-8)
C
C
C------------------------------------------------------------------------
C
C
C             ...set the weight limits and the symmetry accuracy
C                parameters.
C
C
         NO2CEN  = 0.025D0 * MAXOCC
         WPRERYD = 0.25D0  * MAXOCC
         WNAORYD = 0.050D0 * MAXOCC
         WNAOVAL = 0.99D0  * MAXOCC
         WNBOOCC = 0.500D0 * MAXOCC
         WBDMIN  = 0.975D0 * MAXOCC
         WSTMAX  = 0.05D0  * MAXOCC
         WBDCRT  = 0.75D0  * MAXOCC
         WSTEP   = 0.01D0  * MAXOCC

         DSYMACC = 1.D-10
         LSYMACC = 1.D-8
         PSYMACC = 1.D-10
         QSYMACC = 1.D-10
C
C
C             ...predetermine l-shell sizes needed and set maximum.
C
C
         LSIZE (0) = 1
         IF (SPHERIC) THEN
             DO LTYPE = 1,MXSHELL
                LSIZE (LTYPE) = LSIZE (LTYPE-1) + 2
             END DO
         ELSE
             WRITE (*,*) ' Cannot run with cartesian AO basis! '
             WRITE (*,*) ' SPHERIC = ',SPHERIC
             WRITE (*,*) ' nlo__initialize_run '
             WRITE (1,*) ' Cannot run with cartesian AO basis! '
             WRITE (1,*) ' SPHERIC = ',SPHERIC
             WRITE (1,*) ' nlo__initialize_run '
             STOP
         END IF

         MXLSIZE = LSIZE (MXSHELL)
C
C
C             ...determine atomic basis indices and maximum # of
C                AOs on for further use. Check here, if the l-shell
C                types are in increasing order, i.e. s,p,d,f,...
C
C
         MXNBA = 0
         BASNR = 0

         DO A = 1,NATOM
            BASBEG (A) = BASNR + 1
            NSHELL = NSHELLS (A)
            LTYPE = SHELLS (1,A)
            BASNR = BASNR + NBASAL (1,A) * LSIZE (LTYPE)

            DO N = 2,NSHELL
               IF (SHELLS (N,A).GE.LTYPE) THEN
                   LTYPE = SHELLS (N,A)
                   BASNR = BASNR + NBASAL (N,A) * LSIZE (LTYPE)
               ELSE
                   WRITE (*,*) ' L-shells not in increasing order! '
                   WRITE (*,*) ' For atom # ',A,' there is: '
                   WRITE (*,*) ' Shells # ',N-1,' is = ',LTYPE
                   WRITE (*,*) ' Shells # ',N,' is = ',SHELLS (N,A)
                   WRITE (*,*) ' nlo__initialize_run '
                   WRITE (1,*) ' L-shells not in increasing order! '
                   WRITE (1,*) ' For atom # ',A,' there is: '
                   WRITE (1,*) ' Shells # ',N-1,' is = ',LTYPE
                   WRITE (1,*) ' Shells # ',N,' is = ',SHELLS (N,A)
                   WRITE (1,*) ' nlo__initialize_run '
                   STOP
               END IF
            END DO

            BASEND (A) = BASNR
            NXBA = BASEND (A) - BASBEG (A) + 1
            MXNBA = MAX (MXNBA,NXBA)
         END DO
C
C
C             ...check the selected atomic indices for bond formation
C                (if any). Stop, if any inconsistencies are found.
C
C
         DO B = 1,BONDSIZE

            N = IABS (NCHOOSE (B))

            IF (N.NE.9999) THEN

                IF (N.GT.MXCHOOSE) THEN
                    WRITE (*,*) ' Dim for CHOOSE array too small! '
                    WRITE (*,*) ' B,N,MXCHOOSE = ',B,N,MXCHOOSE
                    WRITE (*,*) ' nlo__initialize_run '
                    WRITE (1,*) ' Dim for CHOOSE array too small! '
                    WRITE (1,*) ' B,N,MXCHOOSE = ',B,N,MXCHOOSE
                    WRITE (1,*) ' nlo__initialize_run '
                    STOP
                ELSE IF (N.GT.0) THEN

                    DO I = 1,N
                       DO ATOM = 1,NATOM
                          INDEX (ATOM) = 0
                       END DO
                       DO A = 1,B
                          ATOM = CHOOSE (A,I,B)
                          INDEX (ATOM) = INDEX (ATOM) + 1
                       END DO
                       DO ATOM = 1,NATOM
                          IF (INDEX (ATOM).GT.1) THEN
                              WRITE (*,*) ' Atom idx used > once! '
                              WRITE (*,*) ' ATOM,I,B = ',ATOM,I,B
                              WRITE (*,*) ' nlo__initialize_run '
                              WRITE (1,*) ' Atom idx used > once! '
                              WRITE (1,*) ' ATOM,I,B = ',ATOM,I,B
                              WRITE (1,*) ' nlo__initialize_run '
                              STOP
                          END IF
                       END DO
                    END DO

                END IF
            END IF
         END DO
C
C
C             ...set the initial atomic symmetry map matrix equal to
C                a unit matrix.
C
C
         DO B = 1,NATOM
            DO A = 1,NATOM
               SYMMAP (A,B) = 0
            END DO
            SYMMAP (B,B) = 1
         END DO
C
C
C             ...set natural localized orbital atomic index array
C                to zero.
C
C
         CALL  MAT__C_EQ_ZERO_INTEGER
     +
     +              ( NBAS,BONDSIZE,
     +                NBAS,BONDSIZE,
     +
     +                        BDATOM )
     +
     +
C
C
C             ...find out, if one of the atom locations coincides
C                with the center of mass location.
C
C
         XB = ZERO
         YB = ZERO
         ZB = ZERO
         MOLMASS = ZERO

         DO A = 1,NATOM
            XA = XYZ (1,A)
            YA = XYZ (2,A)
            ZA = XYZ (3,A)
            MASS = DFLOAT (ZATOM (A))
            XB = XB + MASS * XA
            YB = YB + MASS * YA
            ZB = ZB + MASS * ZA
            MOLMASS = MOLMASS + MASS
         END DO

         XB = XB / MOLMASS
         YB = YB / MOLMASS
         ZB = ZB / MOLMASS

         N = 0
         GPOINT = 0

         DO A = 1,NATOM
            XA = XYZ (1,A)
            YA = XYZ (2,A)
            ZA = XYZ (3,A)
            XC = XA - XB
            YC = YA - YB
            ZC = ZA - ZB
            DAB = DSQRT (XC*XC + YC*YC + ZC*ZC)
            IF (DAB.LT.SMALL) THEN
                N = N + 1
                IF (N.GT.1) THEN
                    WRITE (*,*) ' 2 atoms at center of mass! '
                    WRITE (*,*) ' Atom indices = ',GPOINT,A
                    WRITE (*,*) ' nlo__initialize_run '
                    WRITE (1,*) ' 2 atoms at center of mass! '
                    WRITE (1,*) ' Atom indices = ',GPOINT,A
                    WRITE (1,*) ' nlo__initialize_run '
                    STOP
                ELSE
                    GPOINT = A
                END IF
            END IF
         END DO
C
C
C             ...form D*S next.
C
C
         CALL  MAT__C_EQ_A_TIMES_B_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,NBAS,
     +                D,S,
     +
     +                         XMAT )
     +
     +
C
C
C             ...evaluate the atomic bond order matrix.
C
C
         CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +              ( NATOM,NATOM,
     +                NATOM,NATOM,
     +
     +                         BOMAT )
     +
     +
         DO B = 1,NATOM
            JBEG = BASBEG (B)
            JEND = BASEND (B)
            DO A = 1,NATOM
               IBEG = BASBEG (A)
               IEND = BASEND (A)

               DO I = IBEG,IEND
               DO J = JBEG,JEND
                  BOMAT (A,B) = BOMAT (A,B) + XMAT (I,J) * XMAT (J,I)
               END DO
               END DO

            END DO
         END DO
C
C
C             ...form occupation matrix P = S * DS overwriting D.
C
C
         CALL  MAT__C_EQ_A_TIMES_B_FLOAT
     +
     +              ( NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,
     +                NBAS,NBAS,NBAS,
     +                S,XMAT,
     +
     +                         D )
     +
     +
C         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
C     +
C     +                ( 1,
C     +                  'printing SPS with P the HF',
C     +                  NBAS,NBAS,
C     +                  NBAS,NBAS,
C     +                  D )
C     +
C     +
C
C
C             ...diagonalize the bond order matrix and determine
C                the maximum degeneracy of its eigenvalues. Use
C                the still undetermined DOMAT array for scratch.
C
C
         CALL    MAT__C_EQ_A_FLOAT
     +
     +                ( NATOM,NATOM,
     +                  NATOM,NATOM,
     +                  NATOM,NATOM,
     +                  BOMAT,
     +
     +                          DOMAT )
     +
     +
         CALL    MAT__DIAGONALIZE_REAL_SYMMETRIC
     +
     +                ( NATOM,NATOM,NATOM,
     +                  NATOM,
     +                  .TRUE.,
     +
     +                          XVEC,
     +                          DOMAT )
     +
     +
         NLAST = 1
         MAXDEG = 0

         DO N = 2,NATOM
            DIFF = ABS (XVEC (N-1) - XVEC (N))
            IF (DIFF.GT.DSYMACC) THEN
                NDEG = N - NLAST
                MAXDEG = MAX (MAXDEG,NDEG)
                NLAST = N
            END IF
         END DO
         NDEG = NATOM + 1 - NLAST
         MAXDEG = MAX (MAXDEG,NDEG)

         PLATONIC = MAXDEG .GT. 2
C
C
C             ...evaluate the distance order matrix.
C
C
         DMAX = ZERO

         DO B = 1,NATOM
            XB = XYZ (1,B)
            YB = XYZ (2,B)
            ZB = XYZ (3,B)
            DO A = B+1,NATOM
               XA = XYZ (1,A)
               YA = XYZ (2,A)
               ZA = XYZ (3,A)
               XC = XA - XB
               YC = YA - YB
               ZC = ZA - ZB
               DAB = DSQRT (XC*XC + YC*YC + ZC*ZC)
               DMAX = MAX (DAB,DMAX)
               DOMAT (A,B) = DAB
            END DO
         END DO

         DO B = 1,NATOM
            DOMAT (B,B) = ONE
            DO A = B+1,NATOM
               DOMAT (A,B) = (DMAX - DOMAT (A,B)) / DMAX
               DOMAT (B,A) = DOMAT (A,B)
            END DO
         END DO
C
C
C             ...evaluate the atomic overlap order matrix.
C
C
         CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +              ( NATOM,NATOM,
     +                NATOM,NATOM,
     +
     +                         SOMAT )
     +
     +
         DO B = 1,NATOM
            JBEG = BASBEG (B)
            JEND = BASEND (B)
            DO A = 1,NATOM
               IBEG = BASBEG (A)
               IEND = BASEND (A)

               DO I = IBEG,IEND
               DO J = JBEG,JEND
                  SOMAT (A,B) = SOMAT (A,B) + S (I,J) * S (I,J)
               END DO
               END DO

            END DO
         END DO

         DO A = 1,NATOM
            SOMAT (A,A) = ONE / DSQRT (SOMAT (A,A))
         END DO

         DO B = 1,NATOM
            XB = SOMAT (B,B)
            DO A = B+1,NATOM
               SOMAT (A,B) = SOMAT (A,A) * XB * SOMAT (A,B)
               SOMAT (B,A) = SOMAT (A,B)
            END DO
            SOMAT (B,B) = ONE
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE DRRLE(ICORE,MAXCOR,IUHF,RLECYC,LAMBDA)
C
C DRIVER FOR RLE EXTRAPOLATION ROUTINES.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION R
      LOGICAL NEWT,SINGLE,LAMBDA
      EQUIVALENCE (RLETYP,IFLAGS(21))
      DIMENSION ICORE(MAXCOR)
      COMMON /RMAT/ R(400)
      COMMON /FLAGS/ IFLAGS(100)
      SAVE IBOT
      MAXORD=IFLAGS(12)
      NEWT=.FALSE.
      SINGLE=.FALSE.
      IF(IFLAGS(2).GE.9)SINGLE=.TRUE.
      IF(RLECYC.LE.1)THEN
       CALL RLELST(ICORE,MAXCOR,IUHF,SINGLE,RLETYP)
       CALL ROLLT(ICORE,MAXCOR,IUHF,RLECYC,SINGLE,-1,RLETYP,LAMBDA,
     &            MAXORD)
       IF(RLECYC.EQ.0)THEN
        WRITE(6,1000)RLETYP+1,MAXORD
1000    FORMAT(T3,'@DRRLE-I, RLE method #',I1,' will be used to ',
     &            'accelerate convergence.',/,
     &         T13,'Maximum dimension of iterative subspace is ',I3,'.')
        IBOT=0
        RLECYC=1
       ENDIF
       RETURN
      ENDIF
      CALL ROLLT(ICORE,MAXCOR,IUHF,RLECYC,SINGLE,0,RLETYP,LAMBDA,
     &           MAXORD)
      CALL MAKER(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,IBOT,SINGLE,RLETYP)
      IF(MOD(RLECYC-1,MAXORD).EQ.0.OR.RLETYP.EQ.2.OR.RLETYP.EQ.3)THEN
       NEWT=.TRUE.
       CALL FRMTAU(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,NEWT,IBOT,SINGLE,
     &             RLETYP)
       IF(RLETYP.NE.2.AND.RLETYP.NE.3)THEN
        IBOT=IBOT+RLECYC-1
        RLECYC=1
       ELSE
        IBOT=IBOT
       ENDIF
       RETURN
      ENDIF
      CALL FRMTAU(ICORE,MAXCOR,IUHF,RLECYC,MAXORD,NEWT,IBOT,SINGLE,
     &            RLETYP)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ROTATE_TGROUP_NBO
     +
     +                    ( NBAS,
     +                      NBOSIZE,
     +                      NXB,NXA,NXBA,
     +                      ATXOFF,
     +                      LSYMACC,QSYMACC,
     +                      NPAIR,
     +                      IDXSYM,
     +                      NBOBD,
     +                      P,
     +                      LOCAL,
     +                      W,Q,
     +                      XVEC,
     +                      XMAT,
     +
     +                              SYMNBO,
     +                              SLTYPE,
     +                              BDNBAS,
     +                              BDBAS,
     +                              B,
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ROTATE_TGROUP_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine rotates a tetrahedral set (four) of
C                two-fold interaction order degenerate atomic NBOs,
C                such that they become equivalent under operations of
C                the tetrahedral groups T,Td and Th.
C
C                The first step is to divide the set into two pairs
C                and rotating each pair of degenerate atomic NBOs such
C                that their lobes match and form rectangular angles
C                between them (for the mathematics on how this is done,
C                please see the corresponding NBO pair rotation
C                routine):
C
C
C
C                                                  x
C                       x  *                       *
C                        x *    x                  x
C                         x* x                     *
C                    ******x******   ---->   x**x**x**x**x
C                        x *x                      *
C                     x    * x                     x
C                          *  x                    *
C                                                  x
C
C
C
C                In the tetrahedral case such an arrangement of the
C                lobes is always well defined, because of the existence
C                of a nonzero tilt angle between them. If the lobes
C                would be opposite then there is obviously an infinite
C                amount of such arrangements in space.
C
C                The second step tries to construct sp2 hybrids that
C                will transform properly under the four C3 axis of the
C                tetrahedral groups.
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    NXB          =  total # of atomic x-type NBOs.
C                    NXA          =  total # of atomic x-type NBO atoms.
C                    NXBA         =  # of atomic x-type NBOs on one of
C                                    the tetrahedrally related atoms.
C                    ATXOFF (A)   =  index offset for atomic NBOs for
C                                    x-type NBO atom A. This index is
C                                    equal to the total number of atomic
C                                    x-type NBOs on all x-type NBO atoms
C                                    preceeding x-type NBO atom A.
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    NPAIR        =  local atomic index of the two-fold
C                                    weight degenerate atomic NBOs.
C                                    For each atom the local atomic
C                                    indices for the degenerate pair
C                                    are NPAIR and NPAIR+1.
C                    IDXSYM       =  array that contains the four
C                                    tetrahedrally related x-type NBO
C                                    atomic indices.
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th atomic x-type NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs on one of the 4 atoms.
C                    W            =  NBO weight vector at present stage
C                                    of symmetrization for all NBOs
C                                    on one of the 4 atoms.
C                    Q            =  NBO interaction order vector at
C                                    present stage of symmetrization
C                                    for all NBOs on one of the 4 atoms.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    SYMNBO       =  initial integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  initial integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  initial # of basis functions (NHOs)
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  initial NBOSIZE x NXB matrix
C                                    containing the J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  initial NBAS x NXB section of the
C                                    NBO coefficient matrix in AO basis
C                                    before symmetrization corresponding
C                                    to the x-type NBOs treated here.
C
C
C                  Output:
C
C                    SYMNBO       =  updated integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  updated integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  modified # of basis functions
C                                    (NHOs) for J-th bond. The bond
C                                    order is NHB-bonds/NCB/NRB. Note
C                                    that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDBAS (I,J)  =  modified I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  modified NBOSIZE x NXB matrix
C                                    containing the J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  modified NBAS x NXB section of the
C                                    NBO coefficient matrix in AO basis
C                                    corresponding to the symmetrized
C                                    x-type NBOs treated here.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     HYBRID

         INTEGER     BDS1,BDS2,BDS3,BDS4
         INTEGER     BDP1X,BDP2X,BDP3X,BDP4X
         INTEGER     BDP1Y,BDP2Y,BDP3Y,BDP4Y
         INTEGER     NBAS
         INTEGER     NBOSIZE
         INTEGER     NHOS1,NHOS2,NHOS3,NHOS4
         INTEGER     NHOP1X,NHOP2X,NHOP3X,NHOP4X
         INTEGER     NHOP1Y,NHOP2Y,NHOP3Y,NHOP4Y
         INTEGER     NLO__ANGULAR_MOMENTUM_NBO
         INTEGER     NPAIR
         INTEGER     NXB,NXA,NXBA
         INTEGER     OFF1,OFF2,OFF3,OFF4
         INTEGER     P1,P2,P3,P4
         INTEGER     S1,S2,S3,S4
         INTEGER     TOTSYM

         INTEGER     ATXOFF  (1:NXA )
         INTEGER     BDNBAS  (1:NBAS)
         INTEGER     IDXSYM  (1:4   )
         INTEGER     NBOBD   (1:NXB )
         INTEGER     SLTYPE  (1:NXB )
         INTEGER     SYMNBO  (1:NXB )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS)

         DOUBLE PRECISION  COS1,COS2,COS3,COS4
         DOUBLE PRECISION  LSYMACC,QSYMACC
         DOUBLE PRECISION  SIN1,SIN2,SIN3,SIN4

         DOUBLE PRECISION  LOCAL (1:NXBA)
         DOUBLE PRECISION  Q     (1:NXBA)
         DOUBLE PRECISION  W     (1:NXBA)
         DOUBLE PRECISION  XVEC  (1:NBAS)

         DOUBLE PRECISION  HYB1  (1:3,1:3)
         DOUBLE PRECISION  HYB2  (1:3,1:3)
         DOUBLE PRECISION  HYB3  (1:3,1:3)
         DOUBLE PRECISION  HYB4  (1:3,1:3)

         DOUBLE PRECISION  B     (1:NBOSIZE,1:NXB )
         DOUBLE PRECISION  C     (1:NBAS   ,1:NXB )
         DOUBLE PRECISION  P     (1:NBAS   ,1:NBAS)
         DOUBLE PRECISION  XMAT  (1:NBAS   ,1:2   )
C
C
C------------------------------------------------------------------------
C
C
C             ...rotate first the pairs into appropriate positions
C                by calling twice the pair rotation routine.
C
C
         OFF1 = ATXOFF (IDXSYM (1))
         OFF2 = ATXOFF (IDXSYM (2))
         OFF3 = ATXOFF (IDXSYM (3))
         OFF4 = ATXOFF (IDXSYM (4))

         P1 = OFF1 + NPAIR
         P2 = OFF2 + NPAIR
         P3 = OFF3 + NPAIR
         P4 = OFF4 + NPAIR

         BDP1X = NBOBD (P1  )
         BDP1Y = NBOBD (P1+1)
         BDP2X = NBOBD (P2  )
         BDP2Y = NBOBD (P2+1)
         BDP3X = NBOBD (P3  )
         BDP3Y = NBOBD (P3+1)
         BDP4X = NBOBD (P4  )
         BDP4Y = NBOBD (P4+1)

         NHOP1X = BDBAS (1,BDP1X)
         NHOP1Y = BDBAS (1,BDP1Y)
         NHOP2X = BDBAS (1,BDP2X)
         NHOP2Y = BDBAS (1,BDP2Y)
         NHOP3X = BDBAS (1,BDP3X)
         NHOP3Y = BDBAS (1,BDP3Y)
         NHOP4X = BDBAS (1,BDP4X)
         NHOP4Y = BDBAS (1,BDP4Y)

         CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +              ( NBAS,
     +                P,
     +                XVEC,
     +                XMAT,
     +
     +                       COS1,SIN1,
     +                       COS2,SIN2,
     +                       C (1,P1),
     +                       C (1,P2) )
     +
     +
         CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +              ( NBAS,
     +                P,
     +                XVEC,
     +                XMAT,
     +
     +                       COS3,SIN3,
     +                       COS4,SIN4,
     +                       C (1,P3),
     +                       C (1,P4) )
     +
     +
         B (1,P1  ) =   COS1
         B (2,P1  ) = - SIN1
         B (1,P1+1) =   SIN1
         B (2,P1+1) =   COS1
         B (1,P2  ) =   COS2
         B (2,P2  ) = - SIN2
         B (1,P2+1) =   SIN2
         B (2,P2+1) =   COS2
         B (1,P3  ) =   COS3
         B (2,P3  ) = - SIN3
         B (1,P3+1) =   SIN3
         B (2,P3+1) =   COS3
         B (1,P4  ) =   COS4
         B (2,P4  ) = - SIN4
         B (1,P4+1) =   SIN4
         B (2,P4+1) =   COS4

         SYMNBO (P1  ) = 2
         SYMNBO (P1+1) = 2
         SYMNBO (P2  ) = 2
         SYMNBO (P2+1) = 2
         SYMNBO (P3  ) = 2
         SYMNBO (P3+1) = 2
         SYMNBO (P4  ) = 2
         SYMNBO (P4+1) = 2

         BDNBAS (BDP1X) = 2
         BDNBAS (BDP1Y) = 2
         BDNBAS (BDP2X) = 2
         BDNBAS (BDP2Y) = 2
         BDNBAS (BDP3X) = 2
         BDNBAS (BDP3Y) = 2
         BDNBAS (BDP4X) = 2
         BDNBAS (BDP4Y) = 2

         BDBAS (1,BDP1X) = NHOP1X
         BDBAS (2,BDP1X) = NHOP1Y
         BDBAS (1,BDP1Y) = NHOP1X
         BDBAS (2,BDP1Y) = NHOP1Y
         BDBAS (1,BDP2X) = NHOP2X
         BDBAS (2,BDP2X) = NHOP2Y
         BDBAS (1,BDP2Y) = NHOP2X
         BDBAS (2,BDP2Y) = NHOP2Y
         BDBAS (1,BDP3X) = NHOP3X
         BDBAS (2,BDP3X) = NHOP3Y
         BDBAS (1,BDP3Y) = NHOP3X
         BDBAS (2,BDP3Y) = NHOP3Y
         BDBAS (1,BDP4X) = NHOP4X
         BDBAS (2,BDP4X) = NHOP4Y
         BDBAS (1,BDP4Y) = NHOP4X
         BDBAS (2,BDP4Y) = NHOP4Y
C
C
C             ...attempt sp2 hybridization. At the moment we look
C                for totally symmetric NBOs in the vicinity of the
C                degenerate pair. If no such totally symmetric NBO
C                can be found, the hybridization is abandoned.
C
C
         TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                 ( NXBA,
     +                   SLTYPE (OFF1+1),
     +                   NPAIR,NPAIR+1,
     +                   0,
     +                   1,
     +                   QSYMACC,LSYMACC,
     +                   W,Q,
     +                   LOCAL )
     +
     +
         IF (TOTSYM.EQ.0) THEN

             TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                     ( NXBA,
     +                       SLTYPE (OFF1+1),
     +                       NPAIR,NPAIR+1,
     +                       1,
     +                       1,
     +                       QSYMACC,LSYMACC,
     +                       W,Q,
     +                       LOCAL )
     +
     +
         END IF

         IF (TOTSYM.EQ.0) THEN

             TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                     ( NXBA,
     +                       SLTYPE (OFF1+1),
     +                       NPAIR,NPAIR+1,
     +                       2,
     +                       1,
     +                       QSYMACC,LSYMACC,
     +                       W,Q,
     +                       LOCAL )
     +
     +
         END IF

         HYBRID = TOTSYM .NE. 0

         IF (HYBRID) THEN

             IF (NBOSIZE.LT.3) THEN
                 WRITE (*,*) ' Cannot form sp2 hybrids! '
                 WRITE (*,*) ' NBOSIZE = ',NBOSIZE,' (> 2 required!) '
                 WRITE (*,*) ' nlo__rotate_tgroup_nbo '
                 WRITE (1,*) ' Cannot form sp2 hybrids! '
                 WRITE (1,*) ' NBOSIZE = ',NBOSIZE,' (> 2 required!) '
                 WRITE (1,*) ' nlo__rotate_tgroup_nbo '
                 STOP
             END IF

             S1 = OFF1 + TOTSYM
             S2 = OFF2 + TOTSYM
             S3 = OFF3 + TOTSYM
             S4 = OFF4 + TOTSYM

             BDS1 = NBOBD (S1)
             BDS2 = NBOBD (S2)
             BDS3 = NBOBD (S3)
             BDS4 = NBOBD (S4)

             NHOS1 = BDBAS (1,BDS1)
             NHOS2 = BDBAS (1,BDS2)
             NHOS3 = BDBAS (1,BDS3)
             NHOS4 = BDBAS (1,BDS4)

             CALL  NLO__FORM_SP2_PAIR_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +
     +                           HYB1,HYB2,
     +                           C (1,S1),
     +                           C (1,P1),
     +                           C (1,S2),
     +                           C (1,P2) )
     +
     +
             CALL  NLO__FORM_SP2_PAIR_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +
     +                           HYB3,HYB4,
     +                           C (1,S3),
     +                           C (1,P3),
     +                           C (1,S4),
     +                           C (1,P4) )
     +
     +
             B (1,S1  ) =          HYB1 (1,1)
             B (2,S1  ) =   COS1 * HYB1 (2,1) + SIN1 * HYB1 (3,1)
             B (3,S1  ) = - SIN1 * HYB1 (2,1) + COS1 * HYB1 (3,1)
             B (1,P1  ) =          HYB1 (1,2)
             B (2,P1  ) =   COS1 * HYB1 (2,2) + SIN1 * HYB1 (3,2)
             B (3,P1  ) = - SIN1 * HYB1 (2,2) + COS1 * HYB1 (3,2)
             B (1,P1+1) =          HYB1 (1,3)
             B (2,P1+1) =   COS1 * HYB1 (2,3) + SIN1 * HYB1 (3,3)
             B (3,P1+1) = - SIN1 * HYB1 (2,3) + COS1 * HYB1 (3,3)

             B (1,S2  ) =          HYB2 (1,1)
             B (2,S2  ) =   COS2 * HYB2 (2,1) + SIN2 * HYB2 (3,1)
             B (3,S2  ) = - SIN2 * HYB2 (2,1) + COS2 * HYB2 (3,1)
             B (1,P2  ) =          HYB2 (1,2)
             B (2,P2  ) =   COS2 * HYB2 (2,2) + SIN2 * HYB2 (3,2)
             B (3,P2  ) = - SIN2 * HYB2 (2,2) + COS2 * HYB2 (3,2)
             B (1,P2+1) =          HYB2 (1,3)
             B (2,P2+1) =   COS2 * HYB2 (2,3) + SIN2 * HYB2 (3,3)
             B (3,P2+1) = - SIN2 * HYB2 (2,3) + COS2 * HYB2 (3,3)

             B (1,S3  ) =          HYB3 (1,1)
             B (2,S3  ) =   COS3 * HYB3 (2,1) + SIN3 * HYB3 (3,1)
             B (3,S3  ) = - SIN3 * HYB3 (2,1) + COS3 * HYB3 (3,1)
             B (1,P3  ) =          HYB3 (1,2)
             B (2,P3  ) =   COS3 * HYB3 (2,2) + SIN3 * HYB3 (3,2)
             B (3,P3  ) = - SIN3 * HYB3 (2,2) + COS3 * HYB3 (3,2)
             B (1,P3+1) =          HYB3 (1,3)
             B (2,P3+1) =   COS3 * HYB3 (2,3) + SIN3 * HYB3 (3,3)
             B (3,P3+1) = - SIN3 * HYB3 (2,3) + COS3 * HYB3 (3,3)

             B (1,S4  ) =          HYB4 (1,1)
             B (2,S4  ) =   COS4 * HYB4 (2,1) + SIN4 * HYB4 (3,1)
             B (3,S4  ) = - SIN4 * HYB4 (2,1) + COS4 * HYB4 (3,1)
             B (1,P4  ) =          HYB4 (1,2)
             B (2,P4  ) =   COS4 * HYB4 (2,2) + SIN4 * HYB4 (3,2)
             B (3,P4  ) = - SIN4 * HYB4 (2,2) + COS4 * HYB4 (3,2)
             B (1,P4+1) =          HYB4 (1,3)
             B (2,P4+1) =   COS4 * HYB4 (2,3) + SIN4 * HYB4 (3,3)
             B (3,P4+1) = - SIN4 * HYB4 (2,3) + COS4 * HYB4 (3,3)

             SYMNBO (S1) = 2
             SYMNBO (S2) = 2
             SYMNBO (S3) = 2
             SYMNBO (S4) = 2

             SLTYPE (S1  ) = -1
             SLTYPE (P1  ) = -1
             SLTYPE (P1+1) = -1
             SLTYPE (S2  ) = -1
             SLTYPE (P2  ) = -1
             SLTYPE (P2+1) = -1
             SLTYPE (S3  ) = -1
             SLTYPE (P3  ) = -1
             SLTYPE (P3+1) = -1
             SLTYPE (S4  ) = -1
             SLTYPE (P4  ) = -1
             SLTYPE (P4+1) = -1

             BDNBAS (BDS1 ) = 3
             BDNBAS (BDP1X) = 3
             BDNBAS (BDP1Y) = 3
             BDNBAS (BDS2 ) = 3
             BDNBAS (BDP2X) = 3
             BDNBAS (BDP2Y) = 3
             BDNBAS (BDS3 ) = 3
             BDNBAS (BDP3X) = 3
             BDNBAS (BDP3Y) = 3
             BDNBAS (BDS4 ) = 3
             BDNBAS (BDP4X) = 3
             BDNBAS (BDP4Y) = 3

             BDBAS (1,BDS1 ) = NHOS1
             BDBAS (2,BDS1 ) = NHOP1X
             BDBAS (3,BDS1 ) = NHOP1Y
             BDBAS (1,BDP1X) = NHOS1
             BDBAS (2,BDP1X) = NHOP1X
             BDBAS (3,BDP1X) = NHOP1Y
             BDBAS (1,BDP1Y) = NHOS1
             BDBAS (2,BDP1Y) = NHOP1X
             BDBAS (3,BDP1Y) = NHOP1Y
             BDBAS (1,BDS2 ) = NHOS2
             BDBAS (2,BDS2 ) = NHOP2X
             BDBAS (3,BDS2 ) = NHOP2Y
             BDBAS (1,BDP2X) = NHOS2
             BDBAS (2,BDP2X) = NHOP2X
             BDBAS (3,BDP2X) = NHOP2Y
             BDBAS (1,BDP2Y) = NHOS2
             BDBAS (2,BDP2Y) = NHOP2X
             BDBAS (3,BDP2Y) = NHOP2Y
             BDBAS (1,BDS3 ) = NHOS3
             BDBAS (2,BDS3 ) = NHOP3X
             BDBAS (3,BDS3 ) = NHOP3Y
             BDBAS (1,BDP3X) = NHOS3
             BDBAS (2,BDP3X) = NHOP3X
             BDBAS (3,BDP3X) = NHOP3Y
             BDBAS (1,BDP3Y) = NHOS3
             BDBAS (2,BDP3Y) = NHOP3X
             BDBAS (3,BDP3Y) = NHOP3Y
             BDBAS (1,BDS4 ) = NHOS4
             BDBAS (2,BDS4 ) = NHOP4X
             BDBAS (3,BDS4 ) = NHOP4Y
             BDBAS (1,BDP4X) = NHOS4
             BDBAS (2,BDP4X) = NHOP4X
             BDBAS (3,BDP4X) = NHOP4Y
             BDBAS (1,BDP4Y) = NHOS4
             BDBAS (2,BDP4Y) = NHOP4X
             BDBAS (3,BDP4Y) = NHOP4Y

         ELSE
C
C
C             ...no sp2 hybridization possible. Print info.
C
C
             WRITE (*,*) ' Cannot perform sp2 hybridization! '
             WRITE (*,*) ' T-symmetry reduction will result! '

         END IF

C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE RLELST(ICORE,MAXCOR,IUHF,SINGLE,RLETYP)
C
C THIS ROUTINE CREATES THE T AMPLITUDE LISTS USED BY THE 
C  RLE PROGRAM.
C
CEND
      IMPLICIT INTEGER (A-Z)
      LOGICAL SINGLE
      DIMENSION ICORE(MAXCOR)
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)
      COMMON /SYM/ POP(8,2),VRT(8,2),NTAA,NTBB,NF1AA,NF1BB,
     &             NF2AA,NF2BB
      NRLE=IFLAGS(12)+1
      DO 110 ISPIN=3,1,IUHF-2
       SIZE=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
       IF(SINGLE)THEN
        IF(ISPIN.EQ.1)SIZE=SIZE+NTAA
        IF(ISPIN.EQ.2)SIZE=SIZE+NTBB   
       ENDIF
       CALL UPDMOI(NRLE,SIZE,ISPIN,70,0,0)
       IF(RLETYP.EQ.2.OR.RLETYP.EQ.3)THEN
       CALL UPDMOI(NRLE,SIZE,ISPIN+3,70,0,0)
       ENDIF
110   CONTINUE
      DO 120 ISPIN=3,1,IUHF-2
       SIZE=ISYMSZ(ISYTYP(1,60+ISPIN),ISYTYP(2,60+ISPIN))
       IF(SINGLE)THEN
        IF(ISPIN.EQ.1)SIZE=SIZE+NTAA
        IF(ISPIN.EQ.2)SIZE=SIZE+NTBB   
       ENDIF
       CALL UPDMOI(1,SIZE,ISPIN,89,0,0)
120   CONTINUE
      RETURN
      END

c This routine reads in doubles from iUnit and compares them to doubles from
c szRecName (stored in dScr). It returns the next record line in iUnit.

c INPUT
c int iUnit
c char*(*) szRecName
c int iDimScr

c OUTPUT
c char*80 sz
c logical bCont
c double dScr(iDimScr)

#include "iachar.h"

      subroutine test_dbl(iUnit,sz,bCont,szRecName,dScr,iDimScr)
      implicit none

c ARGUMENT LIST
      integer iUnit
      character*80 sz
      logical bCont
      character*8 szRecName
      double precision dScr(*)
      integer iDimScr

c INTERNAL VARIABLES
      double precision dVal, dTol, dTmp
      integer iTmp, nDbls, ndx
      integer iStat, i, iFirst, iLast, length
      logical bVal, bAbs
      character*80 szVal
      character*1 czSpace, czTab, czNull

c EXTERNAL FUNCTIONS
      double precision c_atof
      external c_atof

c COMMON BLOCKS
      integer            iErrExit
      common /exit_stat/ iErrExit
      save   /exit_stat/
#include "machsp.com"

c ----------------------------------------------------------------------

c   o get the record length in integers
      call getrec(0,'JOBARC',szRecName,iTmp,dScr)

c   o make sure the record exists as a double
      if (iTmp.lt.iintfp) then
         print *, '@TEST_DBL: "',szRecName,'" is empty'
         call aces_exit(1)
      end if

c   o read it in
      nDbls = iTmp/iintfp
      if (nDbls.gt.iDimScr) then
         print *, '@TEST_DBL: There is not enough memory to hold the ',
     &            'record.'
         call aces_exit(1)
      end if
      call getrec(1,'JOBARC',szRecName,iTmp,dScr)

c   o constants
      czSpace = achar(_IACHAR_SPACE)
      czTab   = achar(_IACHAR_TAB)
      czNull  = achar(0)

c   o keep reading good data from iUnit until a new record or EOF
      ndx = 0
      bVal = .true.
      do while (bVal)
         read(unit=iUnit,fmt='(a)',end=100,err=9999,iostat=iStat) sz
c      o find the first token
         iFirst = 1
         do while ((sz(iFirst:iFirst).eq.czSpace.or.
     &              sz(iFirst:iFirst).eq.czTab).and.
     &             iFirst.le.80)
            iFirst = iFirst + 1
         end do
         iLast = iFirst
         do while ((sz(iLast:iLast).ne.czSpace.and.
     &              sz(iLast:iLast).ne.czTab).and.
     &             iLast.lt.80)
            iLast = iLast + 1
         end do
c      o process the token (skip blank lines)
         if (iFirst.le.80) then
            if (sz(iLast:iLast).eq.czSpace.or.
     &          sz(iLast:iLast).eq.czTab) iLast = iLast - 1
            length = iLast+1-iFirst
c         o check for absolute value
            if (length.gt.3) then
               bAbs = (sz(iFirst:iFirst+2).eq.'+/-')
               if (bAbs) then
                  iFirst = iFirst + 3
                  length = length - 3
               end if
            else
               bAbs = .false.
            end if
c         o normalize the exponential prefix to 'e'
            szVal = sz(iFirst:iLast)
            do i = 1, length
               if (szVal(i:i).eq.'d'.or.
     &             szVal(i:i).eq.'D'.or.
     &             szVal(i:i).eq.'E') szVal(i:i) = 'e'
            end do
            if (length.lt.80) then
               szVal(length+1:length+1) = achar(0)
            else
               szVal(80:80) = achar(0)
            end if
            dVal = c_atof(szVal)
c            print *,'DEBUG: "',szVal(1:length),'" ?= ',dVal
            if (dVal.eq.0.d0) then
c            o zeroes must be valid
               if (szVal(1:1).ne.'0'.and.szVal(1:1).ne.'.'.and.
     &             szVal(1:1).ne.'+'.and.szVal(1:1).ne.'-') bVal=.false.
               i = 2
               do while (szVal(i:i).ne.czNull.and.bVal.and.
     &                   szVal(i:i).ne.'d'.and.szVal(i:i).ne.'D'.and.
     &                   szVal(i:i).ne.'e'.and.szVal(i:i).ne.'E'
     &                  )
                  bVal = (szVal(1:1).eq.'0'.or.szVal(1:1).ne.'.')
                  i = i + 1
               end do
            end if
            if (bVal) then
               ndx = ndx + 1
               if (ndx.gt.nDbls) then
                  print *, '@TEST_DBL: There is less test data than ',
     &                     'good data'
                  call aces_exit(1)
               end if
c            o check for a second token and return the tolerance
               if (iLast.lt.80) then
                  call test_dbl_tol(szVal,dVal,sz(iLast+1:80),dTol)
               else
                  call test_dbl_tol(szVal,dVal,' ',dTol)
               end if
c            o check for agreement
               if (bAbs) dScr(ndx) = dabs(dScr(ndx))
               dTmp = dabs(dVal-dScr(ndx))
               if (dTmp.gt.dTol) then
                  print *, 'Double ',ndx,' of record "',szRecName,'"',
     &                     ' is not within tolerance.'
                  print '(a,e20.12,a,e11.2)',
     &                  '   good value = ',dVal,     '   +/-  ',dTol
                  print '(a,e20.12,a,e11.2)',
     &                  '   test value = ',dScr(ndx),' off by ',
     &                                     dScr(ndx)-dVal
                  iErrExit = iErrExit + 1
               end if
c           end if (bVal)
            end if
c        end if (iFirst.le.80)
         end if
c     end do while (bVal)
      end do

      if (ndx.ne.nDbls) then
         print *, '@TEST_DBL: WARNING: more test data than good data'
         if (nDbls.eq.1) then
            print *, '           "',szRecName,'" has 1 double'
         else
            print *, '           "',szRecName,'" has ',nDbls,' doubles'
         end if
         if (ndx.eq.1) then
            print *, '           Only 1 double was defined.'
         else
            print *, '           Only ',ndx,' doubles were defined.'
         end if
      end if

      return

 100  bCont = .false.
      return

 9999 call aces_io_error('TEST_DBL',iUnit,iStat)

c     end subroutine test_dbl
      end

c ----------------------------------------------------------------------

      subroutine test_dbl_tol(szVal,dVal,szTol,dTol)
      implicit none

c ARGUMENT LIST
      character*(*) szVal, szTol
      double precision dVal, dTol

c INTERNAL VARIABLES
      integer length, iFirst, iLast, i, iTmp
      character*81 szTmp
      character*1 czSpace, czTab, czNull

c EXTERNAL FUNCTIONS
      double precision c_atof
      external c_atof

c   o constants
      czSpace = achar(_IACHAR_SPACE)
      czTab   = achar(_IACHAR_TAB)
      czNull  = achar(0)
      length  = len(szTol)

c   o find the tolerance token
      iFirst = 1
      do while ((szTol(iFirst:iFirst).eq.czSpace.or.
     &           szTol(iFirst:iFirst).eq.czTab).and.
     &          iFirst.le.length)
         iFirst = iFirst + 1
      end do
      iLast = iFirst
      do while ((szTol(iLast:iLast).ne.czSpace.and.
     &           szTol(iLast:iLast).ne.czTab).and.
     &          iLast.lt.length)
         iLast = iLast + 1
      end do
c   o process the token
      if (iFirst.le.length) then
         if (szTol(iLast:iLast).eq.czSpace.or.
     &       szTol(iLast:iLast).eq.czTab) iLast = iLast - 1
c      o normalize the exponential prefix to 'e'
         szTmp = szTol(iFirst:iLast)//achar(0)
         do i = 1, iLast+1-iFirst
            if (szTmp(i:i).eq.'d'.or.
     &          szTmp(i:i).eq.'D'.or.
     &          szTmp(i:i).eq.'E') szTmp(i:i) = 'e'
         end do
         dTol = c_atof(szTmp)
         if (szTol(iLast:iLast).eq.'%') dTol = dVal*dTol*1.d-2
c     else if (no tolerance token)
      else
c      o base the tolerance on the rounding error of the good value
         i = 1
         do while (szVal(i:i).ne.'d'.and.szVal(i:i).ne.'D'.and.
     &             szVal(i:i).ne.'e'.and.szVal(i:i).ne.'E'.and.
     &             szVal(i:i).ne.czNull)
            iTmp = iachar(szVal(i:i))
            if (48.le.iTmp.and.iTmp.le.57) then
               szTmp(i:i) = '0'
            else
               szTmp(i:i) = szVal(i:i)
            end if
            i = i + 1
         end do
         szTmp(i:i) = '5'
         szTmp(i+1:81) = szVal(i:80)
         dTol = dabs(c_atof(szTmp))
c     end if (iFirst.le.length)
      end if
c      print '(a,e20.12,a,e20.12)', 'DEBUG: ',dVal,' +/- ',dTol

      return
c     end subroutine test_dbl_tol
      end

      SUBROUTINE DIS(IIPT,ATMCRD,NATOM,PTCRD,NPTS,APDR,APDX,
     $     APDY,APDZ)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION ATMCRD(3*NATOM),PTCRD((NPTS+1)*3)
      DIMENSION APDR(NATOM),APDX(NATOM),APDY(NATOM),
     $     APDZ(NATOM)
C
C Fill out the APDR,APDX,APDY,and APDZ vectors.
      DO 20 I=1,NATOM
         APDX(I)=PTCRD((3*IIPT-2))-ATMCRD((3*I-2))
         APDY(I)=PTCRD((3*IIPT-1))-ATMCRD((3*I-1))
         APDZ(I)=PTCRD((3*IIPT))-ATMCRD((3*I))
         APDR(I)=DSQRT((APDX(I))**2+(APDY(I))**2+(APDZ(I))**2)
C IF (IIPT.EQ.1) THEN
C WRITE(*,*) "X(",I,")=",ATMCRD((3*I-2))
C WRITE(*,*) "Y(",I,")=",ATMCRD((3*I-1))
C WRITE(*,*) "Z(",I,")=",ATMCRD((3*I))
C WRITE(*,*) "PX(",IIPT,")=",PTCRD(IIPT*3-2)
C WRITE(*,*) "PY(",IIPT,")=",PTCRD(IIPT*3-1)
C WRITE(*,*) "PZ(",IIPT,")=",PTCRD(IIPT*3)
C WRITE(*,*) "RX(",IIPT,",",I,")= n, APDX(I)
C WRITE(*,*) "RY(",IIPT,",",I,")=",APDY(I)
C WRITE(*,*) "RZ(",IIPT,",",I,")=",APDZ(I)
C WRITE(*,*) "RR(",IIPT,",",I,")=n ,APDR(I)
C END IF
 20   CONTINUE
C
      Return
      END SUBROUTINE DIS

c This routine initializes the job archive environment (via the JAINDX file)
c in order for getrec and putrec to work properly.







      subroutine aces_ja_init
      implicit none

c INTERNAL VARIABLES
      character*80 szJOBARC, szJAINDX
      integer       iJOBARC,  iJAINDX
      integer iBuf(128), i, iStat
      logical bExist, bOpened

c COMMON BLOCKS
c jobarc.com : begin

c This data tracks the contents of the JOBARC file. 'physical' records refer
c to direct I/O while 'logical' records refer to the ACES archive elements.


      external aces_bd_jobarc

c marker(i) : the name of logical record i
c rloc(i)   : the integer index in JOBARC that starts logical record i
c rsize(i)  : the integer-length of logical record i
c nrecs  : the number of physical records in the JOBARC file
c irecwd : the integer-length of a physical record
c irecln : the    recl-length of a physical record

      character*8     marker(1000)
      integer         rloc  (1000),
     &                rsize (1000),
     &                nrecs, irecwd, irecln
      common /jobarc/ marker,
     &                rloc,
     &                rsize,
     &                nrecs, irecwd, irecln
      save   /jobarc/

c bJAUp  : a flag for bombing in get/putrec if aces_ja_init has not been called
c bJAMod : a flag for updating JAINDX in aces_ja_fin

      logical           bJAUp, bJAMod
      common /ja_flags/ bJAUp, bJAMod
      save   /ja_flags/

c jobarc.com : end
c icdacc.com : begin
c Nevin 8-30-95 added record length common to facilitate change from
c Bytes to Words for SGI and DecAlpha
      integer         idaccm
      common /icdacc/ idaccm
c icdacc.com : end

c ----------------------------------------------------------------------

c   o die instead of silently return if the job archive subsystem is already up
      if (bJAUp) then
         print *, '@ACES_JA_INIT: The job archive subsystem is already',
     &            ' initialized.'
         call aces_exit(1)
      end if

c   o turn on the job archive subsystem flag
      bJAUp = .true.

c   o get the external JOBARC file name
      call gfname('JOBARC',szJOBARC,iJOBARC)

c   o initialize the jobarc common block
      call gfname('JAINDX',szJAINDX,iJAINDX)
      inquire(file=szJAINDX(1:iJAINDX),exist=bExist,
     &        err=666,iostat=iStat)
      if (bExist) then
c      o JOBARC had better exist
         inquire(file=szJOBARC(1:iJOBARC),exist=bExist,
     &           err=666,iostat=iStat)
         if (.not.bExist) then
            print *, '@ACES_JA_INIT: JOBARC does not exist'
            call aces_exit(1)
         end if
c      o process JAINDX
         open(unit=75,file=szJAINDX(1:iJAINDX),
     &        form='UNFORMATTED',status='OLD',err=666,iostat=iStat)
         rewind(75,err=666,iostat=iStat)
         read(75,err=666,iostat=iStat) marker, rloc, rsize, nrecs
         close(unit=75,status='KEEP',err=666,iostat=iStat)
      else
c      o reset the records
         do i = 1, 1000
            marker(i) = 'OPENSLOT'
         end do
         rloc(1) = 1
         nrecs   = 0
      end if
      irecwd = 128
      irecln = 128*idaccm

c   o condition the JOBARC file
      inquire(file=szJOBARC(1:iJOBARC),exist=bExist,opened=bOpened,
     &        err=666,iostat=iStat)
      if (bExist) then
c      o open the JOBARC file
         if (.not.bOpened) then
            open(unit=75,file=szJOBARC(1:iJOBARC),
     &           form='UNFORMATTED',access='DIRECT',
     &           status='OLD',recl=irecln,err=666,iostat=iStat)
         end if
      else
c      o write out one all-zero record (bug fix: Ajith 03/25/97)
         call izero(iBuf,128)
         open(unit=75,file=szJOBARC(1:iJOBARC),
     &        form='UNFORMATTED',access='DIRECT',
     &        status='NEW',recl=irecln,err=666,iostat=iStat)
         write(unit=75,rec=1,err=666,iostat=iStat) iBuf
      end if

c   o check if the job archive was properly closed and mark it as open
      call getrec(-1,'JOBARC','JADIRTY',1,i)
      if (i.ne.0) then
         print '(/)'
         print *, '@ACES_JA_INIT: WARNING - The job archive was not ',
     &            'finalized by the previous'
         print *, '               ACES Member Executable. Any records ',
     &            'added by that process have'
         print *, '               been lost.'
         print '(/)'
      else
         call putrec(1,'JOBARC','JADIRTY',1,1)
      end if

      return

c   o I/O error
 666  print *, '@ACES_JA_INIT: I/O error'
      print '(/)'
      call aces_io_error('ACES_JA_INIT',75,iStat)

c     end subroutine aces_ja_init
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine mark_block_dirty(iblock, server_table,nserver_table)
c----------------------------------------------------------------------------
c   Marks a block as "dirty".
c----------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'parallel_info.h'
      integer iblock, nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer ptr
      integer jblock
      integer save_flags

      ptr = server_table_ptr(iblock)

c----------------------------------------------------------------------------
c   If the block is already dirty, remove it from the dirty list, then
c   add it to the tail of the dirty list.  Since the algorithm to make free
c   blocks works by taking the oldest dirty block, this will tend to 
c   retain blocks in the server's memory longer.
c----------------------------------------------------------------------------

      if (and(server_table(c_server_flags,ptr),
     *        server_dirty_flag) .ne. 0) then 
         call remove_from_dirty_list(iblock, 
     *                               server_table,nserver_table) 
      endif

c---------------------------------------------------------------------------
c   Now turn on the dirty flag.
c---------------------------------------------------------------------------

      server_table(c_server_flags,ptr) = or(server_dirty_flag,
     *       server_table(c_server_flags,ptr))

c-----------------------------------------------------------------------------
c   Add to the dirty block list at the tail.
c-----------------------------------------------------------------------------

      if (dirty_list_tail .eq. 0) then
         dirty_list_tail = iblock
         dirty_list_head = iblock
      else
         ptr = dirty_list_tail
         dirty_list_tail = iblock
         dirty_list_ptr(ptr) = iblock
      endif

      dirty_list_ptr(iblock) = 0
      ndirty = ndirty + 1
      return
      end

c This routine retrieves NCOLS columns starting at column IFIRST
c of a stored double precision 2-dimensional array.

c OUTPUT
c double IDEST : the destination array
c                NOTE: Internally, this is treated as an integer array
c                      since a counter runs across both IDEST and ICORE.

c INPUT
c int IFIRST : the index of the first column to retrieve
c int NCOLS  : the number of columns to retrieve
c int XCACHE : (OBSOLETE) the cache buffer for the I/O operation
c              = 1; T amplitudes
c              = 2; integrals
c int ILEFT  : the left  (row) address index of the array [MOIO(ILEFT,IRIGHT)]
c int IRIGHT : the right (col) address index of the array [MOIO(ILEFT,IRIGHT)]

      subroutine getlst(iDest,iFirst,nCols,xCache,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iDest(*), iFirst, nCols, xCache, iLeft, iRight

c EXTERNAL FUNCTIONS
      double precision dnrm2, dTmp
      integer idamax

c INTERNAL VARIABLES
      integer iFileNum, iStat
      integer nRows
      integer iRec, iRecNdx, iTmp
      integer nLeft, nGet, iOff
      integer iPos
#ifdef OPEN_LISTS_AS_NEEDED
#include "szfiles.dat"
      integer ihFile
      character*80 szFile
      integer      iLength
      logical bExist
#endif

c COMMON BLOCKS
#include "icore.com" /* for icore */
#include "lists.com" /* for moio info */
#include "machsp.com" /* for iintfp */
#include "filspc.com" /* for iprcwd */
#include "auxcache.com" /* for quikget */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@GETLST: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iTmp = 1
      end if
c   o assert iFirst > 0 and nCols >= 0
      if ((iFirst.lt.1).or.(nCols.lt.0)) then
         print *, '@GETLST: Assertion failed.'
         print *, '   iFirst = ',iFirst
         print *, '   nCols  = ',nCols
         iTmp = 1
      end if
c   o assert iLeft and iRight are properly bound
      if ((iLeft .lt.1).or.(_MAX_IO_GRPS.lt.iLeft ).or.
     &    (iRight.lt.1).or.(_MAX_IO_FAMS.lt.iRight)    ) then
         print *, '@GETLST: Assertion failed.'
         print *, '   iRight = ',iRight
         print *, '   iLeft  = ',iLeft
         iTmp = 1
      end if
c   o assert the list was touched
      if (moio(iLeft,iRight).lt.1) then
         print *, '@GETLST: Assertion failed.'
         print *, '   List (',iLeft,',',iRight,') does not exist.'
         iTmp = 1
      end if
c   o temporary trap to gauge list reads
c
c      if (iRight .EQ. 17 .or. iRight .eq. 18 .or.
c     &    iRight .EQ. 19 .or. iRight .eq. 20 .or.
c     &    iRight .EQ. 21 .or. iRight .eq. 22) then
c           Print *, 'Reading Redundent lists'
c           iTmp = 1
c      endif 
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o look up the length of one column
      nRows = moiosz(iLeft,iRight)

      if ((nRows.lt.1).or.(nCols.lt.1)) return

c   o make sure the column range requested is properly bound
      iTmp = moiods(iLeft,iRight)
      if ((iFirst.lt.1).or.(iTmp.lt.iFirst).or.
     &    (iTmp.lt.(iFirst-1+nCols))           ) then
         print *, '@GETLST: Error reading list (',iLeft,',',iRight,')'
         print *, '         cols available = ',iTmp
         print *, '         cols requested = ',nCols
         print *, '         range start    = ',iFirst
         call aces_exit(1)
      end if

c   o do a fast in-core fetch from the auxiliary cache
      if (quikget(iLeft,iRight).ne.0) then
         iPos = quikget(iLeft,iRight) + nRows*(iFirst-1)*iintfp
         call xcopy(nRows*nCols,icore(iPos),1,iDest,1)
         return
      end if

c   o determine which file this array lives in
      iFileNum = moiofl(iLeft,iRight)

#ifdef OPEN_LISTS_AS_NEEDED
c   o open the file that contains this array
      ihFile = 1+iFileNum-_FIRST_IO_LUN
      call gfname(szFiles(ihFile),szFile,iLength)
      inquire(file=szFile(1:iLength),exist=bExist,err=666,iostat=iStat)
      if (bExist) then
         call aces_io_open(ihFile)
      else
         print *, '@GETLST: "',szFile(1:iLength),'" - file not found'
         call aces_exit(1)
      end if
#endif

c   o find the first record and integer index that point to the first element
      iRecNdx = moiowd(iLeft,iRight) + nRows*(iFirst-1)*iintfp
      iTmp    = (iRecNdx-1)/iprcwd
      iRec    = moio(iLeft,iRight) + iTmp
      iRecNdx = iRecNdx            - iTmp*iprcwd

c   o do the first partial record and then loop over whole records
c     which contain the remaining data
      nLeft = nRows*nCols*iintfp
      nGet  = min(nLeft,iprcwd+1-iRecNdx)
      call getlst_io(iDest,iFileNum,iRec,iRecNdx,nGet)
      iOff  = 1     + nGet
      nLeft = nLeft - nGet
      do while (nLeft.ne.0)
         nGet = min(nLeft,iprcwd)
         iRec = iRec + 1
         call getlst_io(iDest(iOff),iFileNum,iRec,1,nGet)
         iOff  = iOff  + nGet
         nLeft = nLeft - nGet
      end do

#ifdef OPEN_LISTS_AS_NEEDED
c   o close the file
      close(unit=iFileNum,status='KEEP',err=666,iostat=iStat)
#endif

#ifdef _DEBUG_ACES_IO
c    o trap for NaN
       do iTmp = 1, nRows*nCols*iintfp, iintfp
          call nan_abort(iDest(iTmp))
       end do
c       print *, '@GETLST: (DEBUG) inverse norm of list ',iLeft,iRight
c       print *, '         1/dnrm2 = ',1.d0/dnrm2(nRows*nCols,iDest,1)
c       print *, '@GETLST: (DEBUG) norm of list ',iLeft,iRight
c       print *, '         dnrm2 = ',dnrm2(nRows*nCols,iDest,1)
c       print *, '@GETLST: (DEBUG) max of list ',iLeft,iRight
c       iTmp = idamax(nRows*nCols,iDest,1)
c       dTmp = iDest(iintfp*(iTmp-1)+1)
c       call nan_abort(dTmp)
c      print *, '@GETLST: (args)',iFirst,nCols,' (',iLeft,iRight,')'
c      print *, '         (dims)',nRows,moiods(iLeft,iRight)
c      print *, '         (addr)',moio(iLeft,iRight),moiowd(iLeft,iRight)
c      call dmat_prt(iDest,nRows,nCols,nRows)
c      print *, '         (norm)',dnrm2(nRows*nCols,iDest,1)
#endif

      return

c   o I/O error
 666  print *, '@GETLST: I/O error'
      print *, '         list = [',iLeft,',',iRight,']'
      print '(/)'
      call aces_io_error('GETLST',iFileNum,iStat)

c     end subroutine getlst
      end

      SUBROUTINE UPFCM(FCM,FCM2,SCR1,SCR2,NCOORD,NIRREP,UPDATE)
C
CEND
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL UPDATE 
C
      DIMENSION FCM(NCOORD,NCOORD),FCM2(NCOORD,NCOORD),SCR1(1),SCR2(1)
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALOBE,IBITWD
C
      DATA ONE/1.D0/
C
      IF(NIRREP.NE.1) THEN
C 
       CALL ZERO(FCM2,NCOORD*NCOORD)
       CALL TRAHES(FCM,FCM2,SCR1,SCR2,NCOORD)
c YAU : old
c      CALL ICOPY(NCOORD*NCOORD*IINTFP,FCM2,1,FCM,1)
c YAU : new
       CALL DCOPY(NCOORD*NCOORD,FCM2,1,FCM,1)
c YAU : end
C
      ENDIF
C
      IF(UPDATE) THEN
 
       OPEN(UNIT=81,FILE='FCM',STATUS='OLD',FORM='FORMATTED')
       READ(81,3000) NATOMS,NATOMS6
       DO 2000 ICOORD=1,NCOORD
        READ(81,3001) (FCM2(ICOORD,J),J=1,NCOORD)
2000   CONTINUE
3000   FORMAT(2I5)
3001   FORMAT(3F20.10)
       CALL SAXPY(NCOORD*NCOORD,ONE,FCM2,1,FCM,1)
      ELSE
       OPEN(UNIT=81,FILE='FCM',STATUS='UNKNOWN',FORM='FORMATTED')
       NATOMS=0
       NATOMS6=0
      ENDIF
C
      REWIND(81)
      WRITE(81,3000) NATOMS,NATOMS6
      DO 2100 ICOORD=1,NCOORD
       WRITE(81,3001) (FCM(ICOORD,J),J=1,NCOORD)
2100  CONTINUE
      CLOSE(UNIT=81,STATUS='KEEP')
C
      CALL PUTREC(20,'JOBARC','HESSIANM',NCOORD*NCOORD*IINTFP,FCM)
C
      RETURN
      END

c This routine reads the MOL file and initializes data in /MOL/.
c It should be called only by sb_com_mol(), but its main purpose is
c to recast icore() addresses into convenient variables.
c
c Determines totprim, maxshlprim, maxshlorb, and maxshell.  It also
c fills the arrays nprimatom, nshellatom, and naoatom.

      subroutine sb_basis(comppopv,compmemb,nangatom,nshellatom,
     &                    nprimatom,naoatom)
      implicit none

#include "maxangshell.par"
#include "kscore.com"
#include "mol.com"

      integer comppopv(*),compmemb(*),nangatom(*),nshellatom(*),
     &        nprimatom(*),naoatom(*)

      integer
     &    iorbit,nshell,ishell,nsubshell(maxangshell),isub,natomprim,
     &    natomao,natomang,ishellang,ishellprim,ishellao,isubprim,
     &    isubao,nline,icount,ieqatm,j,iatom,iunit
      character*80 line,molfil

      integer maxorbit
      parameter (maxorbit=1000)
      integer orbitpop(maxorbit)

      call callstack_push('SB_BASIS')

c See mol.com for an explanation of this.  It will disappear soon.
      if (memknown.ne.1) then
         call getrec(0,'JOBARC','COMPPOPV',j,orbitpop)
         if (j.gt.maxorbit) then
            print *, '@SB_BASIS: hard limit exceeded; increase maxorbit'
            print *, '           dim(COMPPOPV) = ',j
            call errex
         end if
         call getrec(1,'JOBARC','COMPPOPV',natomsx,orbitpop)
      end if

      iunit=3
      call gfname('MOL',molfil,j)
      open(unit=iunit,file=molfil(1:j),form='formatted',status='old')
      rewind(iunit)
      read(iunit,'(a)') line
      read(iunit,'(a)') line
      read(iunit,'(a)') line
      read(iunit,'(a)') line
      read(iunit,'(a)') line

      icount=0
      totprim=0
      maxshlprim=0
      maxshlao=0
      maxshlorb=0
      maxshell=0
      maxangmom=0
      do iorbit=1,compnorb
         read(iunit,'(a25,12i5)') line,nshell,
     &                            (nsubshell(ishell),ishell=1,nshell)
         read(iunit,'(a)') line
         natomprim=0
         natomao=0
         natomang=0
         do ishell=1,nshell
c           ishellang= 1,3,6,10,...   (1s, 3p, 6d, 10f, ...)
            ishellang=rshift(ishell*(ishell+1),1)
            ishellprim=0
            ishellao=0
            do isub=1,nsubshell(ishell)
               read(iunit,'(2i5)') isubprim,isubao
               ishellprim=ishellprim+isubprim
               ishellao=ishellao+isubao

               nline=(isubao-3)/4
               if ((isubao-3).gt.(nline*4)) nline=nline+1
               nline=(nline+1)*isubprim
               do j=1,nline
                  read(iunit,'(a)') line
               end do
            end do
            natomao=natomao+ishellang*ishellao
            natomprim=natomprim+ishellang*ishellprim
            natomang=natomang+ishellang
            if (ishellprim.gt.maxshlprim) maxshlprim=ishellprim
            if (ishellao.gt.maxshlao) maxshlao=ishellao
            if ((ishellprim*ishellao).gt.maxshlorb)
     &         maxshlorb=ishellprim*ishellao
c        end do ishell=1,nshell
         end do
         if (natomang.gt.maxshell) maxshell=natomang
         if (nshell.gt.maxangmom) maxangmom=nshell
         if (memknown.ne.0) then
            do ieqatm=1,comppopv(iorbit)
               icount=icount+1
               iatom=compmemb(icount)
               nprimatom(iatom)=natomprim
               nshellatom(iatom)=natomang
               naoatom(iatom)=natomao
               nangatom(iatom)=nshell
            end do
         end if
         totprim=totprim+natomprim*orbitpop(iorbit)
c     end do iorbit=1,compnorb
      end do
      
      close(iunit)
      call callstack_pop
      return
      end

c This routine reads the MOL file and initializes data in /MOL/.
c It should be called only by sb_com_mol(), but its main purpose is
c to recast icore() addresses into convenient variables.
c
c Determines totprim, maxshlprim, maxshlorb, and maxshell.  It also
c fills the arrays nprimatom, nshellatom, and naoatom.

      subroutine sb_basis(comppopv,compmemb,nangatom,nshellatom,
     &                    nprimatom,naoatom)
      implicit none



c ***NOTE*** This is a genuine (though not serious) limit on what Aces3 can do.
c     12 => s,p,d,f,g,h,i,j,k,l,m,n
      integer maxangshell
      parameter (maxangshell=12)




c Two different "stacks" of memory will be available in the course of an
c Aces3 calculation.  Integer memory will be stored in icore.  Real memory
c will be stored in dcore.
c
c Memory allocation is done in one of two ways, dynamic or nondynamic.  This
c is controlled by the parameter dynmem.  If dynmem is 1, dynamic memory
c is used.  Otherwise, nondynamic memory is used.
c
c Two additional parameters nondynimem and nondyndmem control how much
c nondynamic memory is allocated initially in the icore and dcore stacks.
c If dynmem is 1, both of these parameters SHOULD be 1.

c Dynamic memory allocation is done in a fairly straighforward way.  The
c program runs through everything twice.  The first time is just to determine
c how much dynamic memory is required.  The second time is use to actually
c allocate the memory and use it.  In some cases, it may be difficult to
c determine how much memory to use in advance in each of the stacks.  To
c aid this, there is also the option of only running through a program a
c single time.  When this happens, both stacks are allocated initially and
c used throughout the program.  If the memory requirement for either stack
c is exceeded, the program crashes.
c
c Two parameters which are used in either case are memknown and maxicore.
c Both MUST be set in the calling program.
c
c   memknown : 0 if a dummy run is being done to determine memory usage
c              1 if the memory usage is known from a previous dummy run
c             -1 if no dummy run is done (only one run through the program)
c   maxicore : the maximum amount of icore to allocate (this MAY be
c              adjusted IF a dummy run detects that more is needed, but in
c              the case of a single run, this will be rigidly applied)
c
c This include file is required whenever calls to any of the memory functions
c (setptr and relptr) are called or when part of the execution depends on
c whether the first or second run is being performed.
c
c ***NOTE***
c It is important that icore be aligned on a floating point boundary.  One
c way which seems to insure this is to have icore the FIRST element in the
c common block.  So, make sure that no integer is ever inserted before icore
c in the common block declaration.

      integer dynmem,nondynimem,nondyndmem
      parameter (dynmem=1)
      parameter (nondynimem=1)
      parameter (nondyndmem=1)

      double precision   dcore(nondyndmem)
      common /dcore_com/ dcore
      save   /dcore_com/

      integer    kscore(nondynimem)
      common /kscore_mem / kscore

      integer            memknown,maxicore
      common /kscore_com/ memknown,maxicore
      save   /kscore_com/





c This common block contains the molecule and basis set information
c read in from the JOBARC file.  Since much of this information is
c used in a large number of modules, and since most of the information
c is relatively small compared to the other things held in memory,
c a large percentage of the data stored in the JOBARC file is stored
c here, even though some modules will not use all of it.

c   maxangshell - The maximum number of angular momentum shells.  Since this
c                 is used VERY infrequently, set it high enough to never
c                 cause a problem.
c   spinc(2)    - The characters 'A' and 'B' (useful for alpha/beta labels)
c   natoms      - The number of atoms in the Z-matrix (including X/GH).  After
c                 remove is called, natoms becomes equivalent to nrealatm.
c   natomsx     - The number of atoms in the Z-matrix (including X/GH).  This
c                 does not change.
c   nrealatm    - The number of atoms in the Z-matrix (including GH).
c   naobasfn    - The number of AOs in the basis
c   nbastot     - The number of symmetry adapted orbitals in the basis (the AO
c                 basis may be larger than the SO basis if spherical orbitals
c                 are used since harmonic contaminants are deleted)
c   linear      - 1 if the molecule is linear
c   orientmt    - 3x3 matrix which relates the computational and canonical
c                 orientations
c   nucrep      - Nuclear repulsion energy in a.u.
c   nmproton    - Number of protons in the molecule.
c
c   compptgp    - Point group
c   fullptgp    -
c   compordr    - Order of the point group
c   fullordr    -
c   compnirr    - Number of irreps in the point group
c   fullnirr    -
c   compnorb    - Number of unique atoms (orbits) in the point group
c   fullnorb    -
c   c1symmet    - 1 if the molecule is C1 symmetry
c   nirrep      - The same as compnirr (since nirrep is used so commonly,
c                 this is included for conveniance)
c                 ***NOTE*** nirrep is read in twice and is stored in /sym/
c                            so it is not actually included here
c   totprim     - Total number of primitive functions in the molecule
c   maxshlprim  - Largest number of primitives in a single shell
c   maxshlao    - Largest number of AOs in a single shell
c   maxshlorb   - Largest number of primitive orbitals (primitive functions
c                 times the number of AOs) in a single shell
c   maxangmom   - Largest angular momentum for any atom
c   maxshell    - Larges number of angular momentum shells for any atom
c   noccorb(2)  - The number of alpha and beta occupied orbitals
c   nvrtorb(2)  - The number of alpha and beta virtual orbitals

c The parameter maxorbit is needed because of how dynamic memory is used.
c Two runs of the program are needed.  The first to calculate memory usage,
c the second to use it.  In order to calculate totprim, we have to know the
c orbit population vector (the number of each type of atom).  BUT, this is
c stored in dynamic memory since we do not know how long this vector is.
c In the future, joda or vmol will write this information to JOBARC, and
c this problem will disappear.  In the meantime, we have to introduce a
c genuine limit on the size of the molecule.  It may have no more than
c maxorbit sets of unique atoms.  This limit is ONLY used in the subroutine
c basis, so it probably will disappear when the information in the MOL file
c is put in JOBARC.
c    maxorbit   - the number of symmetry unique atoms

c The following are pointers to real arrays
c
c   zatommass(natoms)  - Atomic mass of all atoms (X=0.0, GH=100.0)
c   zcoord(3,natoms)   - Coordinates of all atoms (computational orientation)
c   zalpha(totprim)    - The alpha for each primitive function
c   zprimcoef(totprim,naobasfn)
c                      - The primitive to AO coefficients
c
c The following are pointers to integer arrays
c
c   patomchrg(natoms)  - Atomic number of all atoms (X=0, GH=110)
c   pfullclss(fullordr)- Class type vector
c   pcompclss(compordr)-
c   pfullpopv(natoms)  - Number of atoms in each orbit
c   pcomppopv(natoms)  -
c   pfullmemb(natoms)  - Atoms sorted by point group orbits
c   pcompmemb(natoms)  -
c   pnprimatom(natoms) - Number of primitive functions for each atom
c   pnshellatom(natoms)- Number of different angular momentum shells for each
c                        atom (takes on values of 1,4,9,16, etc.)
c   pnangatom(natoms)  - The number of different angular momentum for each
c                        atom (takes on values of 1,2,3,4, etc.)
c   pnaoatom(natoms)   - Number of AOs for each atom
c   pnshellprim(maxshell,natoms)
c                      - The number of primitive functions in each shell
c                        of each atom
c   pnshellao(maxshell,natoms)
c                      - The number of AOs in each shell of each atom
c   pprimoff(maxshell,natoms)
c   paooff(maxshell,natoms)
c                      - The primcoef matrix is a block diagonal matrix.
c                        Each shell of each atom has a block.  If you have
c                        a list of all primitive functions, pprimoff(ishell,
c                        iatom) tells the location of the first primitive
c                        function in the block (ishell,iatom) and paooff
c                        contains similar information for the AOs.
c
c ***NOTE***  Because joda stores pfullpopv/pcomppopv as size natoms, we
c             do to, but they should be of size fullnorb/compnorb.  The
c             first ones have real values.  The remaining ones are 0.

      double precision orientmt(3,3),nucrep
      integer natoms,nrealatm,naobasfn,nbastot,linear,compnirr,
     &    fullnirr,compnorb,fullnorb,compordr,fullordr,nmproton,
     &    c1symmet,totprim,maxshlprim,maxshlorb,maxshell,noccorb(2),
     &    nvrtorb(2),maxshlao,maxangmom,natomsx
      integer patomchrg,zatommass,zcoord,pfullclss,pcompclss,
     &    pfullpopv,pcomppopv,pfullmemb,pcompmemb,pnprimatom,
     &    pnshellatom,pnaoatom,pnshellprim,pnshellao,
     &    zalpha,zprimcoef,pprimoff,paooff,pnangatom

      common /mol_com/ orientmt,nucrep,
     &    natoms,nrealatm,naobasfn,nbastot,linear,compnirr,
     &    fullnirr,compnorb,fullnorb,compordr,fullordr,nmproton,
     &    c1symmet,totprim,maxshlprim,maxshlorb,maxshell,noccorb,
     &    nvrtorb,maxshlao,maxangmom,natomsx,
     &    patomchrg,zatommass,zcoord,pfullclss,pcompclss,
     &    pfullpopv,pcomppopv,pfullmemb,pcompmemb,pnprimatom,
     &    pnshellatom,pnaoatom,pnshellprim,pnshellao,zalpha,
     &    zprimcoef,pprimoff,paooff,pnangatom
      save   /mol_com/

      character*4 compptgp,fullptgp
      character*1 spinc(2)
      common /molc_com/ compptgp,fullptgp,spinc
      save   /molc_com/



      integer comppopv(*),compmemb(*),nangatom(*),nshellatom(*),
     &        nprimatom(*),naoatom(*)

      integer
     &    iorbit,nshell,ishell,nsubshell(maxangshell),isub,natomprim,
     &    natomao,natomang,ishellang,ishellprim,ishellao,isubprim,
     &    isubao,nline,icount,ieqatm,j,iatom,iunit
      character*80 line,molfil

      integer maxorbit
      parameter (maxorbit=1000)
      integer orbitpop(maxorbit)

      call callstack_push('SB_BASIS')

c See mol.com for an explanation of this.  It will disappear soon.
      if (memknown.ne.1) then
         call getrec(0,'JOBARC','COMPPOPV',j,orbitpop)
         if (j.gt.maxorbit) then
            print *, '@SB_BASIS: hard limit exceeded; increase maxorbit'
            print *, '           dim(COMPPOPV) = ',j
            call errex
         end if
         call getrec(1,'JOBARC','COMPPOPV',natomsx,orbitpop)
      end if

      iunit=3
      call gfname('MOL',molfil,j)
      open(unit=iunit,file=molfil(1:j),form='formatted',status='old')
      rewind(iunit)
      read(iunit,'(a)') line
      read(iunit,'(a)') line
      read(iunit,'(a)') line
      read(iunit,'(a)') line
      read(iunit,'(a)') line

      icount=0
      totprim=0
      maxshlprim=0
      maxshlao=0
      maxshlorb=0
      maxshell=0
      maxangmom=0
      do iorbit=1,compnorb
         read(iunit,'(a25,12i5)') line,nshell,
     &                            (nsubshell(ishell),ishell=1,nshell)
         read(iunit,'(a)') line
         natomprim=0
         natomao=0
         natomang=0
         do ishell=1,nshell
c           ishellang= 1,3,6,10,...   (1s, 3p, 6d, 10f, ...)
            ishellang=rshift(ishell*(ishell+1),1)
            ishellprim=0
            ishellao=0
            do isub=1,nsubshell(ishell)
               read(iunit,'(2i5)') isubprim,isubao
               ishellprim=ishellprim+isubprim
               ishellao=ishellao+isubao

               nline=(isubao-3)/4
               if ((isubao-3).gt.(nline*4)) nline=nline+1
               nline=(nline+1)*isubprim
               do j=1,nline
                  read(iunit,'(a)') line
               end do
            end do
            natomao=natomao+ishellang*ishellao
            natomprim=natomprim+ishellang*ishellprim
            natomang=natomang+ishellang
            if (ishellprim.gt.maxshlprim) maxshlprim=ishellprim
            if (ishellao.gt.maxshlao) maxshlao=ishellao
            if ((ishellprim*ishellao).gt.maxshlorb)
     &         maxshlorb=ishellprim*ishellao
c        end do ishell=1,nshell
         end do
         if (natomang.gt.maxshell) maxshell=natomang
         if (nshell.gt.maxangmom) maxangmom=nshell
         if (memknown.ne.0) then
            do ieqatm=1,comppopv(iorbit)
               icount=icount+1
               iatom=compmemb(icount)
               nprimatom(iatom)=natomprim
               nshellatom(iatom)=natomang
               naoatom(iatom)=natomao
               nangatom(iatom)=nshell
            end do
         end if
         totprim=totprim+natomprim*orbitpop(iorbit)
c     end do iorbit=1,compnorb
      end do
      
      close(iunit)
      call callstack_pop
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine dputrec(iFlag,szArchive,szRecName,iRecLen,dSrc)
c-----------------------------------------------------------------------------
c   Writes double precision data to JOBARC file.
c
c   The iRecLen argument is the number of double precision words contained 
c   in dSrc.
c-----------------------------------------------------------------------------

      implicit none

      integer iFlag, iRecLen
      character*(*) szArchive, szRecName

      double precision dSrc(*) 
      integer i, iRecLen_int
      integer iconvert

#include "machsp.com"

      iconvert    = ifltln / 8
      iRecLen_int = iRecLen * iconvert
      call putrec(iFlag,szArchive,szRecName,iRecLen_int,dSrc)
      return
      end

      SUBROUTINE SYMTR1(IRREP,NUM1,NUM2,DISSIZE,A,SCR1,SCR2,ISCR)
C
C  THIS ROUTINE TRANSPOSES THE LAST TWO INDICES OF A FOUR INDEX ARRAY
C  WITHIN ONE GIVEN IRREP :
C
C   A(I,J,K,L) --> A(I,J,L,K)    WITH G(K)*G(L) = IRREP
C
C  THE TRANPOSITION IS DONE IN PLACE AND REQUIRES ONLY THREE SCRATCH
C  VECTORS OF LENGTH DISSIZE
C
C  INPUT :  IRREP  ...   IRREP OF   G(K)*G(L)
C           NUM1   ....  POPULATION VECTOR FOR K
C           NUM2   ....  POPULATION VECTOR FOR L
C           DISSIZE ...  DISTRIBUTION SIZE
C           A      ....  HOLDS THE MATRIX A         
C           SCR1,SCR2,ISCR ... THREE SCRATCH ARRAYS OF SIZE DISSIZE
C
C  OUTPUT :  A     ....  TRANSPOSED MATRIX
C
CEND
C
C  WRITTEN IN JUNE/90   JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL ICONT
      INTEGER DISSIZE,DIRPRD
      DIMENSION A(DISSIZE,1),SCR1(1),SCR2(1),ISCR(2),NUM1(8),NUM2(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
      DIMENSION IPI(8),IPJ(8)
C
      IPI(1)=0
      IPJ(1)=0          
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IPJ(IRREPJ+1)=IPJ(IRREPJ)+NUM2(IRREPJ)*NUM1(IRREPI)
       IPI(IRREPJ+1)=IPI(IRREPJ)+NUM1(IRREPJ)*NUM2(IRREPI)
10    CONTINUE
       
C
C  GET FIRST THE NEW ADDRESSES AND STORE THEM IN ISCR
C
      NTOTAL=0
      DO 20  IRREPJ=1,NIRREP
       NUMJ=NUM2(IRREPJ)
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMI=NUM1(IRREPI)
        NTOTAL=NTOTAL+NUMI*NUMJ
        DO 15 J=1,NUMJ
        DO 15 I=1,NUMI
         IND1=IPJ(IRREPJ)+(J-1)*NUMI+I
         IND2=IPI(IRREPI)+(I-1)*NUMJ+J
         ISCR(IND1)=IND2
15      CONTINUE
20      CONTINUE
C
C  NOW TRANSPOSE
C
      DO 100 IJ=1,NTOTAL
       IF(ISCR(IJ).EQ.0) GO TO 100
       INDNEW2=IJ
       DO 2 L=1,DISSIZE
        SCR1(L)=A(L,IJ)    
2      CONTINUE
1      CONTINUE
       INDOLD1=INDNEW2
       INDNEW1=ISCR(INDOLD1) 
       ISCR(INDOLD1)=0
       ICONT=.FALSE.  
       IF(ISCR(INDNEW1).NE.0) THEN
        DO 3 L=1,DISSIZE
         SCR2(L)=A(L,INDNEW1)
3       CONTINUE
        ICONT=.TRUE.
       ENDIF
       DO 4 L=1,DISSIZE
        A(L,INDNEW1)=SCR1(L)
4      CONTINUE
       IF(.NOT.ICONT) GO TO 100
       INDOLD2=INDNEW1
       INDNEW2=ISCR(INDOLD2)
       ISCR(INDOLD2)=0
       ICONT=.FALSE. 
       IF(ISCR(INDNEW2).NE.0) THEN
        DO 5 L=1,DISSIZE
         SCR1(L)=A(L,INDNEW2)
5       CONTINUE
        ICONT=.TRUE.
       ENDIF
       DO 6 L=1,DISSIZE
        A(L,INDNEW2)=SCR2(L)
6      CONTINUE
       IF(ICONT) GO TO 1
100   CONTINUE
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__get_free_unit
     +
     +                    ( unitid )
     +
c------------------------------------------------------------------------
c  operation   : ofh__get_free_unit
c  module      : output files handler
c  module-id   : ofh
c  description : This operation returns the unit number of the next free
c                I/O unit. If there is no more free I/O unit available,
c                processing is aborted. This routine sets those units
c                to 'used' which have been opened in the meantime by
c                other routines in the program.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include    'output_files.h'

         logical    unit_exists

         integer    i
         integer    unitid
c
c
c------------------------------------------------------------------------
c
c
c             ...search for possible 'used' I/O units.
c
c
         do i = 2,MAX_OUTPUT_FILES
            if (file_handle (i).eq.free) then
                inquire  (unit   = i,
     +                    exist  = unit_exists)
                if (unit_exists) then
                    file_handle (i) = used
                end if
            end if
         end do
c
c
c             ...search for next free I/O unit.
c
c
         do i = 2,MAX_OUTPUT_FILES
            if (file_handle (i).eq.free) then
                unitid = i
                file_handle (i) = used_by_ofh
                return
            end if
         end do
c
c
c             ...no more I/O units available within number range.
c
c
         write (*,*) ' No more I/O units available! '
         write (*,*) ' ofh__get_free_unit '
         write (1,*) ' No more I/O units available! '
         write (1,*) ' ofh__get_free_unit '

         call  ofh__stop
c
c
c             ...ready!
c
c
         end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compt3_a(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c  The (T 4v) calculation is performed.  
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'machine_types.h'
      include 'saved_data.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer array, array_type, nscalar_table, sind 
      integer index, nindex, seg 
      double precision scalar_table(nscalar_table), tind 
      integer*8 address_table(narray_table)
      integer*8 addr, get_index_from_base 
      integer*8 indblk, indblka(20), get_block_data_index, 
     *          get_block_index
      integer type(mx_array_index)

      integer Top1(mx_array_index), Top2(mx_array_index), 
     *        Tindex(mx_array_index),   
     *        Sindex(18,mx_array_index)  
      integer Sop1(20,mx_array_index), Sop2(20,mx_array_index) 
      integer S1, S2 

      integer Na, nsend, i, j, k
      integer flag, handle, ierr
      integer blk, blkndx, stack, find_current_block, block  

      integer shandle(20), istat
      integer allocate_scratch_block
      integer*8 iscr(20)
      integer*8 c_loc64 !, n

      double precision x(1)
      double precision y(1)
      double precision scr(1)
      integer t3ablocks  
      common /T3a_blocks/Na, t3ablocks(20) 


c     save shandle 
c     save iscr 

#ifdef ALTIX
      pointer (dptr, x)
      pointer (dptr, y)
#else
      common x
      common y
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c------------------------------------------------------------------------------
c  Determine the parameters of the output array T3(a,i,b,j,c,k): c_result_array
c------------------------------------------------------------------------------
      
      array  = op(c_result_array)
      nindex = array_table(c_nindex, array)

      if (nindex .ne. 6) then 
         write(6,*) ' Output from Ta must have six indeces, you have:', 
     *                nindex 
         call abort_job() 
      endif 
      
      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)
      
         Tindex(i) = index
         call get_index_segment(index, seg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, Top1(i), Top2(i))
      enddo
      
      block = find_current_block(array, array_table(1,array),
     *                           index_table, nindex_table,
     *                           segment_table, nsegment_table,
     *                           block_map_table, blkndx)
      
      stack  = array_table(c_array_stack,array)
      indblk = get_block_index(array, block, stack,
     *                         blkndx, y, .true.)

c------------------------------------------------------------------------------
c  Determine the parameters of the input/contracted arrays.
c------------------------------------------------------------------------------

      do i = 1, 12 
         array = t3ablocks(i) 
         nindex = array_table(c_nindex, array)

         if (nindex .ne. 4) then 
            write(6,*) ' Input arrays to Ta must have four indeces, 
     *                   you have:', nindex 
            call abort_job() 
         endif 
      
         do j = 1, nindex
            index   = array_table(c_index_array1+j-1,array)
            type(j) = index_table(c_index_type, index)
            seg     = index_table(c_current_seg,index)
      
            Sindex(i,j) = index
            call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, S1, S2)
            Sop1(i,j) = S1 
            Sop2(i,j) = S2 
         enddo

         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack = array_table(c_array_stack,array)
         indblka(i) = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      enddo

c------------------------------------------------------------------------
c   Allocate scratch blocks used to store the sorted 4-index arrays.  
c------------------------------------------------------------------------
         
       do i = 1, 15 
         istat = allocate_scratch_block(scr, iscr(i), shandle(i),
     *                           array_table, narray_table,
     *                           index_table, nindex_table,
     *                           block_map_table)
         if (istat .ne. 0) then
            print *,'Error: Unable to allocate scratch blocks for T.'
            call abort_job()
         endif
      enddo 

c------------------------------------------------------------------------
c   Perform the actual calculation.  
c------------------------------------------------------------------------

      call do_compt3_a1(y(indblk), Top1, Top2, 
     *                 x(indblka(1)),     
     *             Sop1(1,1), Sop1(1,2), Sop1(1,3), Sop1(1,4),
     *             Sop2(1,1), Sop2(1,2), Sop2(1,3), Sop2(1,4),
c
     *                 x(indblka(2)),   
     *             Sop1(2,1), Sop1(2,2), Sop1(2,3), Sop1(2,4),
     *             Sop2(2,1), Sop2(2,2), Sop2(2,3), Sop2(2,4),
c
     *                 x(indblka(3)),   
     *             Sop1(3,1), Sop1(3,2), Sop1(3,3), Sop1(3,4),
     *             Sop2(3,1), Sop2(3,2), Sop2(3,3), Sop2(3,4),
c
     *                 x(indblka(4)),   
     *             Sop1(4,1), Sop1(4,2), Sop1(4,3), Sop1(4,4),
     *             Sop2(4,1), Sop2(4,2), Sop2(4,3), Sop2(4,4),
c
     *                 x(indblka(5)),   
     *             Sop1(5,1), Sop1(5,2), Sop1(5,3), Sop1(5,4),
     *             Sop2(5,1), Sop2(5,2), Sop2(5,3), Sop2(5,4),
c
     *                 x(indblka(6)),   
     *             Sop1(6,1), Sop1(6,2), Sop1(6,3), Sop1(6,4),
     *             Sop2(6,1), Sop2(6,2), Sop2(6,3), Sop2(6,4),
c
     *                 x(indblka(7)),   
     *             Sop1(7,1), Sop1(7,2), Sop1(7,3), Sop1(7,4),
     *             Sop2(7,1), Sop2(7,2), Sop2(7,3), Sop2(7,4),
c
     *                 x(indblka(8)),   
     *             Sop1(8,1), Sop1(8,2), Sop1(8,3), Sop1(8,4),
     *             Sop2(8,1), Sop2(8,2), Sop2(8,3), Sop2(8,4),
c
     *                 x(indblka(9)),   
     *             Sop1(9,1), Sop1(9,2), Sop1(9,3), Sop1(9,4),
     *             Sop2(9,1), Sop2(9,2), Sop2(9,3), Sop2(9,4),
c
     *                 x(indblka(10)),   
     *             Sop1(10,1), Sop1(10,2), Sop1(10,3), Sop1(10,4),
     *             Sop2(10,1), Sop2(10,2), Sop2(10,3), Sop2(10,4),
c
     *                 x(indblka(11)),   
     *             Sop1(11,1), Sop1(11,2), Sop1(11,3), Sop1(11,4),
     *             Sop2(11,1), Sop2(11,2), Sop2(11,3), Sop2(11,4),
c
     *                 x(indblka(12)),   
     *             Sop1(12,1), Sop1(12,2), Sop1(12,3), Sop1(12,4),
     *             Sop2(12,1), Sop2(12,2), Sop2(12,3), Sop2(12,4),
c
     *             Sindex, scr(iscr(1)), scr(iscr(2)), scr(iscr(3)), 
     *             scr(iscr(4)), scr(iscr(5)), scr(iscr(6)), 
     *             scr(iscr(7)), scr(iscr(8)), scr(iscr(9)), 
     *             scr(iscr(10)), scr(iscr(11)), scr(iscr(12)), 
c 
     *             nsend)

      do i = 1, 15 
         call free_scratch_block(shandle(i)) 
      enddo 

      return
      end

      subroutine do_compt3_a1(x, Top1, Top2, 
     *         LT001aa   , e1, f1, g1, h1, e1f, f1f, g1f, h1f, 
     *         LVS122aaai, e2, f2, g2, h2, e2f, f2f, g2f, h2f, 
c
     *         LT201aa   , e3, f3, g3, h3, e3f, f3f, g3f, h3f, 
     *         LVS102aaai, e4, f4, g4, h4, e4f, f4f, g4f, h4f, 
c
     *         LT101aa   , e5, f5, g5, h5, e5f, f5f, g5f, h5f, 
     *         LVS022aaai, e6, f6, g6, h6, e6f, f6f, g6f, h6f, 
c
     *         LT021aa   , e7, f7, g7, h7, e7f, f7f, g7f, h7f, 
     *         LVS120aaai, e8, f8, g8, h8, e8f, f8f, g8f, h8f, 
c
     *         LT002aa   , e9, f9, g9, h9, e9f, f9f, g9f, h9f, 
     *         LVS121aaai, e10, f10, g10, h10, e10f, f10f, g10f, h10f, 
c
     *         LT121aa   , e11, f11, g11, h11, e11f, f11f, g11f, h11f, 
     *         LVS020aaai, e12, f12, g12, h12, e12f, f12f, g12f, h12f, 
c
     *         Sindex, scr1, scr2, scr3, scr4, scr5, scr6, scr7, 
     *         scr8, scr9, scr10, scr11, scr12,  
     *         nsend)
c 
      implicit none
c     include 'interpreter.h'
c     include 'trace.h'
c     include 'mpif.h'
      include 'maxdim.h'
c     include 'saved_data.h'
c 
      integer e1, f1, g1, h1, e1f, f1f, g1f, h1f 
      integer e2, f2, g2, h2, e2f, f2f, g2f, h2f 
c
      integer e3, f3, g3, h3, e3f, f3f, g3f, h3f 
      integer e4, f4, g4, h4, e4f, f4f, g4f, h4f 
c
      integer e5, f5, g5, h5, e5f, f5f, g5f, h5f 
      integer e6, f6, g6, h6, e6f, f6f, g6f, h6f 
c
      integer e7, f7, g7, h7, e7f, f7f, g7f, h7f 
      integer e8, f8, g8, h8, e8f, f8f, g8f, h8f 
c
      integer e9, f9, g9, h9, e9f, f9f, g9f, h9f 
      integer e10, f10, g10, h10, e10f, f10f, g10f, h10f 
c
      integer e11, f11, g11, h11, e11f, f11f, g11f, h11f 
      integer e12, f12, g12, h12, e12f, f12f, g12f, h12f 
c
      integer a, b, c, i, j, k, a3, a3_s, a3_f  
      integer a1, b1, c1, i1, j1, k1  
      integer a2, b2, c2, i2, j2, k2  
      integer aa, aa1, aa2, ii, ii1, ii2 
      integer aa_range, ii_range, aa1_range, ii1_range, ii2_range, 
     *        aa2_range, a3_range   
      integer Top1(mx_array_index), Top2(mx_array_index) 
      integer ycount, ytemp, nsend,
     *        Sindex(18,mx_array_index)  
      integer y1, y2, y3, y4, y5, y6, y7, y8, y9, y10, y11, y12 
      integer y0, z0, z1, z2, z3, z4, z5, z6 
c
      double precision x(*), etemp, etemp1                      
  
      double precision LT001aa   ( e1:e1f, f1:f1f, g1:g1f, h1:h1f) 
      double precision LVS122aaai( e2:e2f, f2:f2f, g2:g2f, h2:h2f) 
c
      double precision LT201aa   ( e3:e3f, f3:f3f, g3:g3f, h3:h3f) 
      double precision LVS102aaai( e4:e4f, f4:f4f, g4:g4f, h4:h4f) 
c
      double precision LT101aa   ( e5:e5f, f5:f5f, g5:g5f, h5:h5f) 
      double precision LVS022aaai( e6:e6f, f6:f6f, g6:g6f, h6:h6f) 
c
      double precision LT021aa   ( e7:e7f, f7:f7f, g7:g7f, h7:h7f) 
      double precision LVS120aaai( e8:e8f, f8:f8f, g8:g8f, h8:h8f) 
c
      double precision LT002aa   ( e9:e9f, f9:f9f, g9:g9f, h9:h9f) 
      double precision LVS121aaai( e10:e10f,f10:f10f,g10:g10f,h10:h10f) 
c
      double precision LT121aa   ( e11:e11f,f11:f11f,g11:g11f,h11:h11f) 
      double precision LVS020aaai( e12:e12f,f12:f12f,g12:g12f,h12:h12f) 
c
      double precision scr1(*)  
      double precision scr2(*)  
      double precision scr3(*)  
      double precision scr4(*)  
      double precision scr5(*)  
      double precision scr6(*)  
      double precision scr7(*)  
      double precision scr8(*)  
      double precision scr9(*)  
      double precision scr10(*)  
      double precision scr11(*)  
      double precision scr12(*)  
c
c ------------------------------------------------------------------------- 
c     Set output array's ranges 
c ------------------------------------------------------------------------- 
c 
      a1 = Top1(1) 
      a2 = Top2(1) 
c 
      i1 = Top1(2) 
      i2 = Top2(2) 
c 
      b1 = Top1(3) 
      b2 = Top2(3) 
c 
      j1 = Top1(4) 
      j2 = Top2(4) 
c 
      c1 = Top1(5) 
      c2 = Top2(5) 
c 
      k1 = Top1(6) 
      k2 = Top2(6) 
c
c ------------------------------------------------------------------------- 
c     Determine the contracted index ranges 
c ------------------------------------------------------------------------- 
c
      do i = 1, 4 
      do j = 1, 4 
         if (Sindex(1,i) .eq. Sindex(2,j)) then 
            if (i .eq. 1) then 
               a3_s = e1  
               a3_f = e1f  
               go to 100 
            endif 
            if (i .eq. 2) then 
               a3_s = f1  
               a3_f = f1f  
               go to 100 
            endif 
            if (i .eq. 3) then 
               a3_s = g1  
               a3_f = g1f  
               go to 100 
            endif 
            if (i .eq. 4) then 
               a3_s = h1  
               a3_f = h1f  
               go to 100 
            endif 
         endif 
      enddo 
      enddo 
100   continue 
c
c ------------------------------------------------------------------------- 
c Put arrays into scratch arrays to be used sequentially 
c ------------------------------------------------------------------------- 
c
      aa_range  = a2-a1+1 
      ii_range  = i2-i1+1 
      aa1_range = b2-b1+1 
      ii1_range = j2-j1+1 
      aa2_range = c2-c1+1 
      ii2_range = k2-k1+1 
      a3_range  = a3_f-a3_s+1 

c     go to 33 
c
      ycount = 0 
      do ii1 = j1, j2 
      do ii  = i1, i2 
      do aa  = a1, a2 

         do a3 = a3_s, a3_f 
            ycount = ycount + 1 

         y1 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *      + (ii-i1)*aa_range*a3_range  
     *      + (ii1-j1)*ii_range*aa_range*a3_range 

            scr1(y1) = LT001aa(aa,ii,a3,ii1)

            if (y1 .ne. ycount) then 
            write(6,*) 'y1', y1, ycount, a3, aa, ii, ii1  
            endif 

         enddo 
      enddo 
      enddo 
      enddo 

      ycount = 0 
      do ii2 = k1, k2 
      do aa2 = c1, c2 
      do aa1 = b1, b2 
         do a3 = a3_s, a3_f 
            ycount = ycount + 1 

            y2 = (a3-a3_s+1) + (aa1-b1)*a3_range   
     *         + (aa2-c1)*aa1_range*a3_range  
     *         + (ii2-k1)*aa2_range*aa1_range*a3_range 

            if (y2 .ne. ycount) then 
            write(6,*) 'Y2', y2, ycount, a3, aa, ii, ii1  
            endif 

            scr2(y2) = LVS122aaai(aa1,a3,aa2,ii2)
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa1 = b1, b2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y4 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (aa1-b1)*aa_range*a3_range  
     *         + (ii2-k1)*aa1_range*aa_range*a3_range 
            scr4(y4) = LVS102aaai(aa1,a3,aa,ii2)

            ycount = ycount + 1 
            if (y4 .ne. ycount) then 
            write(6,*) 'Y4', y4, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do aa2 = c1, c2 
      do ii1 = j1, j2 
      do ii  = i1, i2 
         do a3 = a3_s, a3_f 
            y3 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (ii1-j1)*ii_range*a3_range  
     *         + (aa2-c1)*ii1_range*ii_range*a3_range 
            scr3(y3) = LT201aa(aa2,ii,a3,ii1)

            ycount = ycount + 1 
            if (y3 .ne. ycount) then 
            write(6,*) 'Y3', y3, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa2 = c1, c2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y6 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (aa2-c1)*aa_range*a3_range  
     *         + (ii2-k1)*aa2_range*aa_range*a3_range 

            scr6(y6) = LVS022aaai(aa,a3,aa2,ii2)

            ycount = ycount + 1 
            if (y6 .ne. ycount) then 
            write(6,*) 'Y6', y6, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii1 = j1, j2 
      do aa1 = b1, b2 
      do ii  = i1, i2 
         do a3 = a3_s, a3_f 
            y5 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa1-b1)*ii_range*a3_range  
     *         + (ii1-j1)*aa1_range*ii_range*a3_range 

            scr5(y5) = LT101aa(aa1,ii,a3,ii1)

            ycount = ycount + 1 
            if (y5 .ne. ycount) then 
            write(6,*) 'Y5', y5, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do ii1 = j1, j2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y7 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii1-j1)*aa_range*a3_range  
     *         + (ii2-k1)*ii1_range*aa_range*a3_range 

            scr7(y7) = LT021aa(aa,ii2,a3,ii1)

            ycount = ycount + 1 
            if (y7 .ne. ycount) then 
            write(6,*) 'Y7', y7, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do aa2 = c1, c2 
      do aa1 = b1, b2 
      do ii  = i1, i2 
         do a3 = a3_s, a3_f 
            y8 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa1-b1)*ii_range*a3_range  
     *         + (aa2-c1)*aa1_range*ii_range*a3_range 

            scr8(y8) = LVS120aaai(aa1,a3,aa2,ii)

            ycount = ycount + 1 
            if (y8 .ne. ycount) then 
            write(6,*) 'Y8', y8, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do ii  = i1, i2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y9 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii-i1)*aa_range*a3_range  
     *         + (ii2-k1)*ii_range*aa_range*a3_range 

            scr9(y9) = LT002aa(aa,ii,a3,ii2)

            ycount = ycount + 1 
            if (y9 .ne. ycount) then 
            write(6,*) 'Y9', y9, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do aa2 = c1, c2 
      do ii1 = j1, j2 
      do aa1 = b1, b2 
         do a3 = a3_s, a3_f 
            y10 = (a3-a3_s+1) + (aa1-b1)*a3_range   
     *         + (ii1-j1)*aa1_range*a3_range  
     *         + (aa2-c1)*ii1_range*aa1_range*a3_range 

            scr10(y10) = LVS121aaai(aa1,a3,aa2,ii1)

            ycount = ycount + 1 
            if (y10 .ne. ycount) then 
            write(6,*) 'Y10', y10, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do aa2 = c1, c2 
      do ii  = i1, i2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y12 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii-i1)*aa_range*a3_range  
     *         + (aa2-c1)*ii_range*aa_range*a3_range 
c
             scr12(y12) = LVS020aaai(aa,a3,aa2,ii)

            ycount = ycount + 1 
            if (y12 .ne. ycount) then 
            write(6,*) 'Y12', y12, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do ii1 = j1, j2 
      do aa1 = b1, b2 
         do a3 = a3_s, a3_f 
            y11 = (a3-a3_s+1) + (aa1-b1)*a3_range   
     *         + (ii1-j1)*aa1_range*a3_range  
     *         + (ii2-k1)*ii1_range*aa1_range*a3_range 
c
            scr11(y11) = LT121aa(aa1,ii2,a3,ii1)

            ycount = ycount + 1 
            if (y11 .ne. ycount) then 
            write(6,*) 'Y11', y11, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 

33    continue 
c
c ------------------------------------------------------------------------- 
c Perform calculation  
c ------------------------------------------------------------------------- 
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa2 = c1, c2 
      do ii1 = j1, j2 
      do aa1 = b1, b2 
      do ii  = i1, i2 
      do aa  = a1, a2 

         etemp  = 0 
         ycount = ycount + 1 
c
         do a3 = a3_s, a3_f 
c
            y1 = (a3-a3_s+1) 
     *         + (aa-a1)*a3_range   
     *         + (ii-i1)*aa_range*a3_range  
     *         + (ii1-j1)*ii_range*aa_range*a3_range 

            y2 = (a3-a3_s+1) + (aa1-b1)*a3_range   
     *         + (aa2-c1)*aa1_range*a3_range  
     *         + (ii2-k1)*aa2_range*aa1_range*a3_range 

            y4 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (aa1-b1)*aa_range*a3_range  
     *         + (ii2-k1)*aa1_range*aa_range*a3_range 

            y3 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (ii1-j1)*ii_range*a3_range  
     *         + (aa2-c1)*ii1_range*ii_range*a3_range 

            y6 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (aa2-c1)*aa_range*a3_range  
     *         + (ii2-k1)*aa2_range*aa_range*a3_range 

            y5 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa1-b1)*ii_range*a3_range  
     *         + (ii1-j1)*aa1_range*ii_range*a3_range 

            y7 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii1-j1)*aa_range*a3_range  
     *         + (ii2-k1)*ii1_range*aa_range*a3_range 

            y8 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa1-b1)*ii_range*a3_range  
     *         + (aa2-c1)*aa1_range*ii_range*a3_range 

            y9 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii-i1)*aa_range*a3_range  
     *         + (ii2-k1)*ii_range*aa_range*a3_range 

            y10 = (a3-a3_s+1) + (aa1-b1)*a3_range   
     *         + (ii1-j1)*aa1_range*a3_range  
     *         + (aa2-c1)*ii1_range*aa1_range*a3_range 

            y12 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii-i1)*aa_range*a3_range  
     *         + (aa2-c1)*ii_range*aa_range*a3_range 
c
            y11 = (a3-a3_s+1) + (aa1-b1)*a3_range   
     *         + (ii1-j1)*aa1_range*a3_range  
     *         + (ii2-k1)*ii1_range*aa1_range*a3_range 

            etemp = etemp 
c    *        + LT001aa(aa,ii,a3,ii1)*LVS122aaai(aa1,a3,aa2,ii2)
     *        + scr1(y1)*scr2(y2)

c    *        - LVS102aaai(aa1,a3,aa,ii2)*LT201aa(aa2,ii,a3,ii1)
     *        - scr3(y3)*scr4(y4)

c    *        - LVS022aaai(aa,a3,aa2,ii2)*LT101aa(aa1,ii,a3,ii1)
     *        - scr5(y5)*scr6(y6)

c    *        - LT021aa(aa,ii2,a3,ii1)*LVS120aaai(aa1,a3,aa2,ii)
     *        - scr7(y7)*scr8(y8)

c    *        - LT002aa(aa,ii,a3,ii2)*LVS121aaai(aa1,a3,aa2,ii1)
     *        - scr9(y9)*scr10(y10)

c    *        + LVS020aaai(aa,a3,aa2,ii)*LT121aa(aa1,ii2,a3,ii1)
     *        + scr11(y11)*scr12(y12)
c
         enddo 

         x(ycount) = etemp   

      enddo 
      enddo 
      enddo 
      enddo 
      enddo 
      enddo 

      nsend = aa_range*ii_range*aa1_range*ii1_range*ii2_range*aa2_range    
c
c       etemp = etemp + LT001aa(aa,ii,a3,ii1)*LVS122aaai(aa1,a3,aa2,ii2)
c       etemp = etemp - LVS102aaai(aa1,a3,aa,ii2)*LT201aa(aa2,ii,a3,ii1)
c       etemp = etemp - LVS022aaai(aa,a3,aa2,ii2)*LT101aa(aa1,ii,a3,ii1)
c       etemp = etemp - LT021aa(aa,ii2,a3,ii1)*LVS120aaai(aa1,a3,aa2,ii)
c       etemp = etemp - LT002aa(aa,ii,a3,ii2)*LVS121aaai(aa1,a3,aa2,ii1)
c       etemp = etemp + LVS020aaai(aa,a3,aa2,ii)*LT121aa(aa1,ii2,a3,ii1)
c       etemp = etemp + LVS021aaai(aa,a3,aa2,ii1)*LT102aa(aa1,ii,a3,ii2)
c       etemp = etemp + LVS100aaai(aa1,a3,aa,ii)*LT221aa(aa2,ii2,a3,ii1)
c       etemp = etemp + LVS101aaai(aa1,a3,aa,ii1)*LT202aa(aa2,ii,a3,ii2)

      return
      end

      subroutine do_compt3_a3(x, Top1, Top2, 
     *         LT102aa   , e13, f13, g13, h13, e13f, f13f, g13f, h13f, 
     *         LVS021aaai, e14, f14, g14, h14, e14f, f14f, g14f, h14f, 
c
     *         LT221aa   , e15, f15, g15, h15, e15f, f15f, g15f, h15f, 
     *         LVS100aaai, e16, f16, g16, h16, e16f, f16f, g16f, h16f, 
c
     *         LT202aa   , e17, f17, g17, h17, e17f, f17f, g17f, h17f, 
     *         LVS101aaai, e18, f18, g18, h18, e18f, f18f, g18f, h18f, 
c
     *         Sindex, 
     *         scr13, scr14, scr15, 
     *         scr16, scr17, scr18,  
     *         nsend)
c 
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'saved_data.h'
c 
      integer e13, f13, g13, h13, e13f, f13f, g13f, h13f 
      integer e14, f14, g14, h14, e14f, f14f, g14f, h14f 
c
      integer e15, f15, g15, h15, e15f, f15f, g15f, h15f 
      integer e16, f16, g16, h16, e16f, f16f, g16f, h16f 
c
      integer e17, f17, g17, h17, e17f, f17f, g17f, h17f 
      integer e18, f18, g18, h18, e18f, f18f, g18f, h18f 
c
      integer a, b, c, i, j, k, a3, a3_s, a3_f  
      integer a1, b1, c1, i1, j1, k1  
      integer a2, b2, c2, i2, j2, k2  
      integer aa, aa1, aa2, ii, ii1, ii2 
      integer aa_range, ii_range, aa1_range, ii1_range, ii2_range, 
     *        aa2_range, a3_range   
      integer Top1(mx_array_index), Top2(mx_array_index) 
      integer ycount, ytemp, nsend,
     *        Sindex(18,mx_array_index)  
      integer y1, y2, y3, y4, y5, y6, y7, y8, y9, y10, y11, y12, 
     *        y13, y14, y15, y16, y17, y18 
      integer y0, z0, z1, z2, z3, z4, z5, z6 
c
      double precision x(*), etemp, etemp1                      
c
      double precision LT102aa   ( e13:e13f,f13:f13f,g13:g13f,h13:h13f) 
      double precision LVS021aaai( e14:e14f,f14:f14f,g14:g14f,h14:h14f) 
c
      double precision LT221aa   ( e15:e15f,f15:f15f,g15:g15f,h15:h15f) 
      double precision LVS100aaai( e16:e16f,f16:f16f,g16:g16f,h16:h16f) 
c
      double precision LT202aa   ( e17:e17f,f17:f17f,g17:g17f,h17:h17f) 
      double precision LVS101aaai( e18:e18f,f18:f18f,g18:g18f,h18:h18f) 
c 
      double precision scr13(*)  
      double precision scr14(*)  
      double precision scr15(*)  
      double precision scr16(*)  
      double precision scr17(*)  
      double precision scr18(*)  
c
c ------------------------------------------------------------------------- 
c     Set output array's ranges 
c ------------------------------------------------------------------------- 
c 
      a1 = Top1(1) 
      a2 = Top2(1) 
c 
      i1 = Top1(2) 
      i2 = Top2(2) 
c 
      b1 = Top1(3) 
      b2 = Top2(3) 
c 
      j1 = Top1(4) 
      j2 = Top2(4) 
c 
      c1 = Top1(5) 
      c2 = Top2(5) 
c 
      k1 = Top1(6) 
      k2 = Top2(6) 
c
c ------------------------------------------------------------------------- 
c     Determine the contracted index ranges 
c ------------------------------------------------------------------------- 
c
      do i = 1, 4 
      do j = 1, 4 
         if (Sindex(13,i) .eq. Sindex(14,j)) then 
            if (i .eq. 1) then 
               a3_s = e13  
               a3_f = e13f  
               go to 100 
            endif 
            if (i .eq. 2) then 
               a3_s = f13  
               a3_f = f13f  
               go to 100 
            endif 
            if (i .eq. 3) then 
               a3_s = g13  
               a3_f = g13f  
               go to 100 
            endif 
            if (i .eq. 4) then 
               a3_s = h13  
               a3_f = h13f  
               go to 100 
            endif 
         endif 
      enddo 
      enddo 
100   continue 
c
c ------------------------------------------------------------------------- 
c Put arrays into scratch arrays to be used sequentially 
c ------------------------------------------------------------------------- 
c
      aa_range  = a2-a1+1 
      ii_range  = i2-i1+1 
      aa1_range = b2-b1+1 
      ii1_range = j2-j1+1 
      aa2_range = c2-c1+1 
      ii2_range = k2-k1+1 
      a3_range  = a3_f-a3_s+1 
c
      ycount = 0 
      do aa2 = c1, c2 
      do ii1 = j1, j2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y14 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii1-j1)*aa_range*a3_range  
     *         + (aa2-c1)*ii1_range*aa_range*a3_range 

             scr14(y14) = LVS021aaai(aa,a3,aa2,ii1)

            ycount = ycount + 1 
            if (y14 .ne. ycount) then 
            write(6,*) 'Y14', y14, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa1 = b1, b2 
      do ii  = i1, i2 
         do a3 = a3_s, a3_f 
            y13 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa1-b1)*ii_range*a3_range  
     *         + (ii2-k1)*aa1_range*ii_range*a3_range 

             scr13(y13) = LT102aa(aa1,ii,a3,ii2)

            ycount = ycount + 1 
            if (y13 .ne. ycount) then 
            write(6,*) 'Y13', y13, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do aa1 = b1, b2 
      do ii  = i1, i2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y16 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *          + (ii-i1)*aa_range*a3_range  
     *          + (aa1-b1)*ii_range*aa_range*a3_range 

            scr16(y16) = LVS100aaai(aa1,a3,aa,ii)

            ycount = ycount + 1 
            if (y16 .ne. ycount) then 
            write(6,*) 'Y16', y16, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa2 = c1, c2 
      do ii1 = j1, j2 
         do a3 = a3_s, a3_f 
            y15 = (a3-a3_s+1) + (ii1-j1)*a3_range   
     *         + (aa2-c1)*ii1_range*a3_range  
     *         + (ii2-k1)*aa2_range*ii1_range*a3_range 

            scr15(y15) = LT221aa(aa2,ii2,a3,ii1)

            ycount = ycount + 1 
            if (y15 .ne. ycount) then 
            write(6,*) 'Y15', y15, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii1 = j1, j2 
      do aa1 = b1, b2 
      do aa  = a1, a2 
         do a3 = a3_s, a3_f 
            y18 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (aa1-b1)*aa_range*a3_range  
     *         + (ii1-j1)*aa1_range*aa_range*a3_range 

             scr18(y18) = LVS101aaai(aa1,a3,aa,ii1)

            ycount = ycount + 1 
            if (y18 .ne. ycount) then 
            write(6,*) 'Y18', y18, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa2 = c1, c2 
      do ii  = i1, i2 
         do a3 = a3_s, a3_f 
            ycount = ycount + 1 
            y17 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa2-c1)*ii_range*a3_range  
     *         + (ii2-k1)*aa2_range*ii_range*a3_range 

c            scr17(y17) = LT202aa(aa2,ii,a3,ii2)

            if (y17 .ne. ycount) then 
            write(6,*) 'Y17', y17, ycount, a3, aa, ii, ii1  
            endif 
         enddo 
      enddo 
      enddo 
      enddo 

33    continue 
c
c ------------------------------------------------------------------------- 
c Perform calculation  
c ------------------------------------------------------------------------- 
c
      ycount = 0 
      do ii2 = k1, k2 
      do aa2 = c1, c2 
      do ii1 = j1, j2 
      do aa1 = b1, b2 
      do ii  = i1, i2 
      do aa  = a1, a2 

         etemp1 = 0 
         ycount = ycount + 1 

         do a3 = a3_s, a3_f 
c
            y14 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii1-j1)*aa_range*a3_range  
     *         + (aa2-c1)*ii1_range*aa_range*a3_range 

            y13 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa1-b1)*ii_range*a3_range  
     *         + (ii2-k1)*aa1_range*ii_range*a3_range 

            y16 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (ii-i1)*aa_range*a3_range  
     *         + (aa1-b1)*ii_range*aa_range*a3_range 

            y15 = (a3-a3_s+1) + (ii1-j1)*a3_range   
     *         + (aa2-c1)*ii1_range*a3_range  
     *         + (ii2-k1)*aa2_range*ii1_range*a3_range 

            y18 = (a3-a3_s+1) + (aa-a1)*a3_range   
     *         + (aa1-b1)*aa_range*a3_range  
     *         + (ii1-j1)*aa1_range*aa_range*a3_range 

            y17 = (a3-a3_s+1) + (ii-i1)*a3_range   
     *         + (aa2-c1)*ii_range*a3_range  
     *         + (ii2-k1)*aa2_range*ii_range*a3_range 
c
            etemp1 = etemp1 
c -------------------------------------------------------------------- 
     *        + LVS021aaai(aa,a3,aa2,ii1)*LT102aa(aa1,ii,a3,ii2)
c    *        + scr13(y13)*scr14(y14)

     *        + LVS100aaai(aa1,a3,aa,ii)*LT221aa(aa2,ii2,a3,ii1)
c    *        + scr16(y16)*scr15(y15)
c -------------------------------------------------------------------- 

     *        + LVS101aaai(aa1,a3,aa,ii1)*LT202aa(aa2,ii,a3,ii2)
c    *        + scr17(y17)*scr18(y18)
c
         enddo 

         x(ycount) = x(ycount) + etemp1  

      enddo 
      enddo 
      enddo 
      enddo 
      enddo 
      enddo 

      nsend = aa_range*ii_range*aa1_range*ii1_range*ii2_range*aa2_range    
c
c       etemp = etemp + LT001aa(aa,ii,a3,ii1)*LVS122aaai(aa1,a3,aa2,ii2)
c       etemp = etemp - LVS102aaai(aa1,a3,aa,ii2)*LT201aa(aa2,ii,a3,ii1)
c       etemp = etemp - LVS022aaai(aa,a3,aa2,ii2)*LT101aa(aa1,ii,a3,ii1)
c       etemp = etemp - LT021aa(aa,ii2,a3,ii1)*LVS120aaai(aa1,a3,aa2,ii)
c       etemp = etemp - LT002aa(aa,ii,a3,ii2)*LVS121aaai(aa1,a3,aa2,ii1)
c       etemp = etemp + LVS020aaai(aa,a3,aa2,ii)*LT121aa(aa1,ii2,a3,ii1)
c       etemp = etemp + LVS021aaai(aa,a3,aa2,ii1)*LT102aa(aa1,ii,a3,ii2)
c       etemp = etemp + LVS100aaai(aa1,a3,aa,ii)*LT221aa(aa2,ii2,a3,ii1)
c       etemp = etemp + LVS101aaai(aa1,a3,aa,ii1)*LT202aa(aa2,ii,a3,ii2)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__GENER_NHO_ORBITALS
     +
     +                    ( NBAS,NATOM,
     +                      MXNHBA,MXNBA,MXSHELL,MXCOL,
     +                      BONDSIZE,NBOSIZE,
     +                      MAXOCC,
     +                      NHB,NCB,NRB,
     +                      NHA,NCA,NRA,
     +                      ATNHB,ATHVAL,ATHOFF,
     +                      ATNCB,ATCIDX,ATCOFF,
     +                      ATNRB,ATRIDX,ATROFF,
     +                      ATORD,ATHCEN,
     +                      HSHELL,CSHELL,RSHELL,
     +                      RYD2HYB,
     +                      COLMAP,
     +                      NHYB,
     +                      NWSTEP,
     +                      P,
     +                      SAH,
     +                      PH,PHSUB,PHDEP,
     +                      BOMAT,
     +                      WBDMIN,WSTMAX,WBDCRT,WSTEP,
     +                      MXCHOOSE,NCHOOSE,CHOOSE,
     +                      IVEC,XVEC,
     +                      XMAT,
     +
     +                             NBOND,
     +                             WBOND,WSTAR,
     +                             BDNCEN,
     +                             BDCEN,
     +                             BDNBAS,
     +                             BDBAS,
     +                             BDOCC,
     +                             BDATOM,
     +                             ANGNHO,
     +                             H,W,C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__GENER_NHO_ORBITALS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine generates the sets of natural hybrid
C                orbitals (NHO's) as a set of coefficients in terms
C                of the NHB Hybrid NAOs. The procedure by which all
C                NHB Hybrid NAOs are transformed into NHOs is as
C                follows:
C
C
C                   1) Calculate the NHB x NHB occupation matrix PH
C                      in the Hybrid NAO basis. This matrix will
C                      have the following structure:
C
C
C                             A     B     C     D
C                           -----------------------
C                          |     |     |     |     |
C                        A |     |     |     |     |
C                          |     |     |     |     |
C                           -----------------------
C                          |     |     |     |     |
C                        B |     |     |     |     |
C                          |     |     |     |     |
C                           -----------------------
C                          |     |     |     |     |
C                        C |     |     |     |     |
C                          |     |     |     |     |
C                           -----------------------
C                          |     |     |     |     |
C                        D |     |     |     |     |
C                          |     |     |     |     |
C                           -----------------------
C
C
C                      where A,B,C,D denote atoms.
C
C                   2) Perform the following loop, until the sets of
C                      NHOs found exhaust the NHB space:
C
C                          # of centers NHCEN = 1
C
C                          loop over all NHCEN atomic combinations
C
C                             for each NHCEN atomic combination:
C
C                               i) set up submatrix PHSUB of PH
C                                  by taking appropriate subblocks
C                                  of PH corresponding to the NHCEN
C                                  atomic combination
C
C                              ii) Diagonalize PHSUB and extract
C                                  those eigenfunctions which have
C                                  eigenvalues > Threshold value
C
C                             iii) Deplete PHSUB from those
C                                  eigenfunctions
C
C                              iv) Replace PHSUB section of PH
C                                  by PHSUB matrix
C
C                             if # of NHOs complete, exit
C
C                          continue
C
C                          remove all atomic sites which have by
C                          now a complete set of NHOs.
C
C                          if # of NHOs incomplete, NHCEN = NHCEN + 1
C                          and return to loop beginning
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    MXNHBA       =  maximum # of Hybrid NAOs per atom.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    MXSHELL      =  largest l-shell value
C                    MXCOL        =  maximum # of NBAS-sized columns
C                                    that are needed for the flp
C                                    scratch array XMAT (see below).
C                    BONDSIZE     =  maximum # of atomic centers that
C                                    are allowed to form a bond.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    MAXOCC       =  maximum orbital occupancy number
C                                    (can be only 1 or 2).
C                    NxB          =  total # of Hybrid, Core and
C                                    Rydberg NAOs (x=H,C,R)
C                    NxA          =  total # of hybrid, core and
C                                    Rydberg atoms (x=H,C,R)
C                    ATNHB (A)    =  # of Hybrid NAOs on hybrid atom A.
C                    ATHVAL (A)   =  # of Valence NAOs on hybrid atom A.
C                    ATHOFF (A)   =  index offset for Hybrid NAOs for
C                                    hybrid atom A. This index is equal
C                                    to the total number of Hybrid NAOs
C                                    on all hybrid atoms preceeding
C                                    hybrid atom A.
C                    ATNCB (A)    =  # of Core NAOs on core atom A.
C                    ATCIDX (A)   =  atomic index for core atom A.
C                    ATCOFF (A)   =  index offset for Core NAOs for
C                                    core atom A. This index is equal
C                                    to the total number of Core NAOs
C                                    on all core atoms preceeding
C                                    core atom A.
C                    ATNRB (A)    =  # of Rydberg NAOs on Rydberg
C                                    atom A.
C                    ATRIDX (A)   =  atomic index for Rydberg atom A.
C                    ATROFF (A)   =  index offset for Rydberg NAOs for
C                                    Rydberg atom A. This index is
C                                    equal to the total number of
C                                    Rydberg NAOs on all Rydberg atoms
C                                    preceeding Rydberg atom A.
C                    ATORD (I)    =  I-th atomic index of optimum
C                                    atomic index ordering array of
C                                    all hybrid atoms to be used for
C                                    bond/antibond formation search.
C                    ATHCEN (I)   =  will contain hybrid atomic labels
C                                    (indices) for a subset of all NHA
C                                    atomic hybrid centers
C                    HSHELL (I)   =  l-shell type for I-th Hybrid NAO.
C                    CSHELL (I)   =  l-shell type for I-th Core NAO.
C                    RSHELL (I)   =  l-shell type for I-th Rydberg NAO.
C                    RYD2HYB      =  is true, if the Rydberg NAO space
C                                    should be included next to the
C                                    Valence NAO space for natural 
C                                    hybrid orbital (NHO) construction.
C                                    If false, only the Valence NAO
C                                    space will be used.
C                    COLMAP (I)   =  column map in the active sense,
C                                    such that COLMAP (I) contains the
C                                    position index of I-th NAO, based
C                                    on atomic order, in the NHB/NCB/NRB
C                                    order.
C                    NHYB (A)     =  will contain total # of pre-NHOs
C                                    on each hybrid atom A at each stage
C                                    of the calculation.
C                    NWSTEP (x)   =  will contain the # of steps for
C                                    decreasing/increasing the weight
C                                    acceptance criterion for
C                                    bond/antibond formation for bonds
C                                    over x centers.
C                    P            =  full NBAS x NBAS occupation matrix
C                                    in original AO basis.
C                    SAH          =  will contain the atomic hybrid
C                                    overlap matrices between pre-NHOs.
C                    PH           =  will contain the (possibly depleted)
C                                    NHB x NHB hybrid occupation matrix
C                                    in NAO basis.
C                    PHSUB        =  will contain the submatrices of
C                                    the occupation matrix PH in NAO
C                                    basis for finding the NHOs.
C                    PHDEP        =  will be used for accumulation of
C                                    the depleted occupation matrix PH.
C                    BOMAT (A,B)  =  simplified bond order matrix
C                                    containing info if atoms A and B
C                                    are considered to be bonded or not
C                    WBDMIN       =  initial minimum accepted weight
C                                    for bond construction.
C                    WSTMAX       =  initial maximum accepted weight
C                                    for antibond construction.
C                    WBDCRT       =  critical weight limit for bond
C                                    construction.
C                    WSTEP        =  weight stepping size to decrease/
C                                    increase the bond/antibond weight
C                                    limits.
C                    MXCHOOSE     =  maximum # of bonds selected to
C                                    be chosen. The maximum is build
C                                    from all # of chosen bonds for all
C                                    bondsizes.
C                    NCHOOSE (B)  =  # of bonds to be chosen for bonds
C                                    of size B. Four cases:
C                                    1) = 9999 => skip search for bonds
C                                       of size B.
C                                    2) = 0 => complete search for all
C                                       possible bonds of size B will
C                                       be performed.
C                                    3) = -n => only n bonds of size B
C                                       will be searched between those
C                                       atomic indices as provided by
C                                       the CHOOSE array.
C                                    4) = +n => same as case 3) but
C                                       followed by a complete search
C                                       for all possible remaining
C                                       bonds of size B.
C                                    Priority level: 1) > 3) > 4) > 2).
C                    CHOOSE       =  element CHOOSE (I,N,B) contains
C                                    the I-th atomic index of the N-th
C                                    chosen bond of size B. The order
C                                    of the atomic indices is arbitrary.
C                    IVEC,XVEC    =  int/flp scratch array of vector
C                                    type.
C                    XMAT         =  flp scratch array of matrix type.
C                    BDATOM       =  NAO atomic index map.
C                    W            =  NAO weight vector in atomic order.
C                    C            =  NAO coefficient matrix in AO basis
C                                    with columns in atomic order.
C
C
C                  Output:
C
C                    NBOND        =  total # of bonds found in the NHB
C                                    part (that is, excluding the Core
C                                    and Rydberg 'bonds').
C                    WBOND (x)    =  will contain the weight acceptance
C                                    criterion for x-center bond
C                                    formation during the NHO search
C                                    process. The final values when
C                                    exiting this routine will be the
C                                    lowest for each x-center bond
C                                    that lead to the final complete
C                                    set of NHO.
C                    WSTAR (x)    =  will contain the weight acceptance
C                                    criterion for x-center antibond
C                                    formation during the NHO search
C                                    process. The final values when
C                                    exiting this routine will be the
C                                    highest for each x-center antibond
C                                    that lead to the final complete
C                                    set of NHO.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                                    The bond order is NHB-bonds/NCB/NRB.
C                                    Note that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDCEN (I,J)  =  I-th atomic center index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  I-th global basis (NHO) index for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDOCC (J)    =  # of occupied levels for J-th bond.
C                                    The bond order is NHB-bonds/NCB/NRB.
C                                    Note that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDATOM       =  NAO atomic index map in NHB/NCB/NRB
C                                    order.
C                    ANGNHO (J,L) =  NBAS x (MXSHELL+1) matrix
C                                    containing the sum of the square
C                                    of the NAO coefficients per L-type
C                                    angular momentum for the J-th NHO.
C                                    The NHO order is NHB/NCB/NRB.
C                    H (I,J)      =  MXNBA x NBAS matrix containing the
C                                    atomic NHOs. I is the local atomic
C                                    index labeling the atomic hybrid
C                                    NAOs from which the NHOs are
C                                    constructed. J is the global NHO
C                                    index running over all NHB/NCB/NRB
C                                    NHOs in that order, with all NHOs
C                                    belonging to a specific atomic
C                                    center being grouped together.
C                    W            =  NAO weight vector in NHB/NCB/NRB
C                                    order. The NAO weights in the NHB
C                                    part will have been overwritten
C                                    by the pre-NHO weights to determine
C                                    the NHB NHOs.
C                    C            =  NAO coefficient matrix in AO basis
C                                    with columns in NHB/NCB/NRB order.
C
C
C                  !!! IMPORTANT CONCEPT ABOUT BONDS AS DEFINED HERE!!!
C
C                  The concept of a bond is here synonymous with atomic
C                  center connectivity. That means that although a
C                  specific atomic center connection might lead to many
C                  occupied 'bonds' in the usual chemists point of view,
C                  all those occupied 'bonds' are treated here as one
C                  bond and its different occupied levels. As an example
C                  consider benzene C6H6. If BONDSIZE is set to 6, it
C                  will result in one! pi-bond involving the six carbon
C                  centers and this bond will have a total of 6 levels
C                  of which 3 are ocupied.
C
C                  Note also that the Core and Rydberg NHOs found here
C                  will be considered as bonds belonging to one atom
C                  with respective occupation level numbers 1 and 0.
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*16  STAGE

         LOGICAL     FAILED
         LOGICAL     LTRG,UTRG
         LOGICAL     MORE
         LOGICAL     NAO2NHO
         LOGICAL     RYD2HYB
         LOGICAL     SAVEP

         INTEGER     ATOM
         INTEGER     BONDSIZE,NBOSIZE
         INTEGER     I,J
         INTEGER     INCSIZE
         INTEGER     LTYPE
         INTEGER     MXCHOOSE
         INTEGER     MXNHBA,MXNBA,MXSHELL,MXCOL
         INTEGER     NAO,NHO
         INTEGER     NATOM,NHATOM
         INTEGER     NBAS
         INTEGER     NBOND
         INTEGER     NHB,NHA,NCB,NCA,NRB,NRA
         INTEGER     NHBA,NVBA,NCBA,NRBA
         INTEGER     NHCEN
         INTEGER     NSTEP,STEP
         INTEGER     OFF

         INTEGER     ATNCB   (1:NCA   )
         INTEGER     ATNHB   (1:NHA   )
         INTEGER     ATNRB   (1:NRA   )
         INTEGER     ATCIDX  (1:NCA   )
         INTEGER     ATRIDX  (1:NRA   )
         INTEGER     ATCOFF  (1:NCA   )
         INTEGER     ATHOFF  (1:NHA   )
         INTEGER     ATROFF  (1:NRA   )
         INTEGER     ATHCEN  (1:NHA   )
         INTEGER     ATHVAL  (1:NHA   )
         INTEGER     ATORD   (1:NHA   )
         INTEGER     BDATOM  (1:NBAS  )
         INTEGER     BDNBAS  (1:NBAS  )
         INTEGER     BDNCEN  (1:NBAS  )
         INTEGER     BDOCC   (1:NBAS  )
         INTEGER     COLMAP  (1:NBAS  )
         INTEGER     HSHELL  (1:NHB   )
         INTEGER     CSHELL  (1:NCB   )
         INTEGER     RSHELL  (1:NRB   )
         INTEGER     IVEC    (1:2*NBAS+2*NHB+2*NHA)
         INTEGER     NCHOOSE (1:BONDSIZE)
         INTEGER     NHYB    (1:NHA   )
         INTEGER     NWSTEP  (1:BONDSIZE)

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS)
         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS)

         INTEGER     CHOOSE  (1:BONDSIZE,1:MXCHOOSE,1:BONDSIZE)

         DOUBLE PRECISION  CSQR
         DOUBLE PRECISION  MAXOCC
         DOUBLE PRECISION  WBDMIN,WSTMAX,WBDCRT,WSTEP
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  W     (1:NBAS)
         DOUBLE PRECISION  WBOND (1:BONDSIZE)
         DOUBLE PRECISION  WSTAR (1:BONDSIZE)
         DOUBLE PRECISION  XVEC  (1:3*NBAS)

         DOUBLE PRECISION  ANGNHO (1:NBAS  ,0:MXSHELL)
         DOUBLE PRECISION  BOMAT  (1:NATOM ,1:NATOM  )
         DOUBLE PRECISION  C      (1:NBAS  ,1:NBAS   )
         DOUBLE PRECISION  P      (1:NBAS  ,1:NBAS   )
         DOUBLE PRECISION  H      (1:MXNBA ,1:NBAS   )
         DOUBLE PRECISION  PH     (1:NHB   ,1:NHB    )
         DOUBLE PRECISION  PHDEP  (1:NHB   ,1:NHB    )
         DOUBLE PRECISION  PHSUB  (1:NHB   ,1:NHB    )
         DOUBLE PRECISION  SAH    (1:MXNHBA,1:MXNHBA )
         DOUBLE PRECISION  XMAT   (1:NBAS  ,1:MXCOL  )

         PARAMETER  (ZERO  = 0.D0 )
C
C
C------------------------------------------------------------------------
C
C
C             ...reorder the NAO weights, the atomic index map and the
C                coefficient matrix from atomic to NHB/NCB/NRB order.
C
C
C         CALL    MAT__PRINT_V_INTEGER_NOZEROS
C     +
C     +                ( 1,
C     +                  ' COLMAP ',
C     +                  NBAS,
C     +                  NBAS,
C     +                  COLMAP )
C     +
C     +
         CALL    MAT__PRINT_A_INTEGER_NOZEROS
     +
     +                ( 1,
     +                  ' Hybrid atomic ordering vector ',
     +                  1,NHA,
     +                  1,NHA,
     +                  ATORD )
     +
     +
         CALL  MAT__REORDER_VECTOR_FLOAT
     +
     +              ( NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,
     +                COLMAP,
     +                XVEC,
     +
     +                        W )
     +
     +
C         CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
C     +
C     +                ( 6,
C     +                  ' Atomic reordered W vector ',
C     +                  NBAS,
C     +                  NBAS,
C     +                  W )
C     +
C     +
         CALL  MAT__REORDER_VECTOR_INTEGER
     +
     +              ( NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,
     +                COLMAP,
     +                IVEC,
     +
     +                        BDATOM )
     +
     +
         CALL  MAT__REORDER_MATRIX_COLUMNS
     +
     +              ( NBAS,NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,
     +                NBAS,NBAS,
     +                COLMAP,
     +                IVEC,
     +                XVEC,
     +
     +                        C )
     +
     +
C
C
C             ...initialize the # of bond/antibond weight limit steps.
C
C
         DO NHCEN = 1,BONDSIZE
            NWSTEP (NHCEN) = 1
         END DO

         INCSIZE = 0
C
C
C             ...start iterates on NHO search. Increase # of
C                bond/antibond weight limit steps for appropriate
C                bond size by + 1.
C
C
 1000    IF (INCSIZE.GT.BONDSIZE) THEN
             INCSIZE = 1
             NWSTEP (1) = NWSTEP (1) + 1
         ELSE IF (INCSIZE.GT.0) THEN
             NWSTEP (INCSIZE) = NWSTEP (INCSIZE) + 1
         END IF

         STAGE = 'start'

         CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +              ( STAGE,
     +                BONDSIZE,
     +                MAXOCC,
     +                NHCEN,
     +                NWSTEP,
     +                WBDMIN,WSTMAX,WSTEP,
     +                WBOND,WSTAR )
     +
     +
         LTRG  = .TRUE.
         UTRG  = .FALSE.
         SAVEP = .TRUE.

         CALL  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +              ( NBAS,NHB,
     +                NBAS,NBAS,
     +                NBAS,NHB,
     +                NHB,
     +                NHB,NBAS,
     +                0,
     +                SAVEP,LTRG,UTRG,
     +                C,
     +                P,
     +                XVEC,
     +
     +                        XMAT )
     +
     +
         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NBAS,NHB,
     +                NHB,NHB,
     +                NHB,NHB,
     +                XMAT,
     +
     +                        PH )
     +
     +
C         CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
C     +
C     +              ( NBAS,NHB,NHB,
C     +                NHB,
C     +                .TRUE.,
C     +
C     +                        XVEC,
C     +                        XMAT )
C     +
C     +
C         CALL    MAT__PRINT_A_FLOAT_5_NOZEROS
C     +
C     +                ( 1,
C     +                  ' PH matrix ',
C     +                  NHB,NHB,
C     +                  NHB,0,
C     +                  PH )
C     +
C     +
C         CALL    MAT__PRINT_V_FLOAT_5_NOZEROS
C     +
C     +                ( 1,
C     +                  ' Eigenvalues of PH matrix ',
C     +                  NHB,
C     +                  NHB,
C     +                  XVEC )
C     +
C     +
C
C
C             ...initialize search for pre-NHOs.
C
C
         CALL  MAT__W_EQ_ZERO_INTEGER  (NBAS,NBAS,BDNBAS)
         CALL  MAT__W_EQ_ZERO_INTEGER  (NBAS,NBAS,BDNCEN)
         CALL  MAT__W_EQ_ZERO_INTEGER  (NBAS,NBAS,BDOCC)
         CALL  MAT__C_EQ_ZERO_INTEGER  (NBOSIZE,NBAS,NBOSIZE,NBAS,BDBAS)
         CALL  MAT__C_EQ_ZERO_INTEGER  (NBOSIZE,NBAS,NBOSIZE,NBAS,BDCEN)
         CALL  MAT__C_EQ_ZERO_FLOAT    (MXNBA,NBAS,MXNBA,NBAS,H)
C
C
C             ...perform the loop over all allowed atomic hybrid
C                center combinations. Start with all hybrid atoms
C                in their optimum order using the optimum ordering
C                array. Copy initial PH matrix to the matrix that
C                will accumulate all depletions during a specific
C                bondsize run (if any). Keep going in reducing
C                the weight limits for each x-centered bond type
C                and check for pre-NHOs as long as that is still
C                possible.
C
C
         NBOND = 0

         NHATOM = 0
         DO I = 1,NHA
            ATOM = ATORD (I)
            NHATOM = NHATOM + 1
            ATHCEN (NHATOM) = ATOM
            NHYB (ATOM) = 0
         END DO

         CALL  MAT__C_EQ_A_FLOAT
     +
     +              ( NHB,NHB,
     +                NHB,NHB,
     +                NHB,NHB,
     +                PH,
     +
     +                        PHDEP )
     +
     +
         DO NHCEN = 1,BONDSIZE

            NSTEP = NWSTEP (NHCEN)
            WBOND (NHCEN) = WBDMIN
            WSTAR (NHCEN) = WSTMAX

            DO STEP = 1,NSTEP

               IF (NHATOM.GT.0 .AND. NHCEN.LE.NHATOM) THEN

                   CALL  NLO__CHECK_NHO_ALL_X_CENTERS
     +
     +                        ( NATOM,
     +                          BONDSIZE,NBOSIZE,
     +                          NHCEN,NHATOM,
     +                          MXNHBA,MXNBA,
     +                          ATHCEN,ATNHB,ATHVAL,ATHOFF,
     +                          RYD2HYB,
     +                          IVEC (1),IVEC (NHA+1),
     +                          NHB,NHA,
     +                          WBOND (NHCEN),WSTAR (NHCEN),
     +                          SAH,
     +                          PH,PHSUB,
     +                          BOMAT,
     +                          MXCHOOSE,NCHOOSE (NHCEN),
     +                          CHOOSE (1,1,NHCEN),
     +                          IVEC (2*NHA+1),
     +                          XVEC,XMAT,
     +
     +                                   FAILED,
     +                                   NBOND,
     +                                   NHYB,
     +                                   BDNCEN,
     +                                   BDCEN,
     +                                   BDNBAS,
     +                                   BDBAS,
     +                                   BDOCC,
     +                                   W,H,
     +                                   PHDEP )
     +
     +
                   IF (FAILED) THEN
                       STAGE = 'failure'
                       CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +                       ( STAGE,
     +                         BONDSIZE,
     +                         MAXOCC,
     +                         NHCEN,
     +                         NWSTEP,
     +                         WBDMIN,WSTMAX,WSTEP,
     +                         WBOND,WSTAR )
     +
     +
                       INCSIZE = INCSIZE + 1
                       GOTO 1000
                   END IF
C
C
C             ...check, if any hybrid atoms have a nonexhaustive bond
C                forming pre-NHO set. Determine their number and check
C                for more bond forming pre-NHO's. If there are more
C                allowed, update the PH matrix with all depletions
C                accumulated during the present bondsize run and
C                continue.
C
C
                   NHATOM = 0
                   DO I = 1,NHA
                      ATOM = ATORD (I)
                      IF (NHYB (ATOM) .LT. ATHVAL (ATOM)) THEN
                          NHATOM = NHATOM + 1
                          ATHCEN (NHATOM) = ATOM
                      END IF
                   END DO

                   CALL  MAT__C_EQ_A_FLOAT
     +
     +                        ( NHB,NHB,
     +                          NHB,NHB,
     +                          NHB,NHB,
     +                          PHDEP,
     +
     +                               PH )
     +
     +
               END IF

               IF (STEP.NE.NSTEP) THEN
                   WBOND (NHCEN) = WBOND (NHCEN) - WSTEP
                   WSTAR (NHCEN) = WSTAR (NHCEN) + WSTEP
               END IF

            END DO

         END DO
C
C
C             ...try to complete the present sets of bond forming
C                pre-NHOs on each atom with eventual Empty-pair
C                pre-NHOs and possibly Rydberg pre-NHOs. If the
C                routine is unable to do so, we have to retry the
C                the bond forming pre-NHO search with lower bond
C                weight limits. If the routine is successful, the
C                complete set of orthogonalized NHOs on each atom
C                have been obtained.
C
C
 2000    STAGE = 'complete'

         CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +              ( STAGE,
     +                BONDSIZE,
     +                MAXOCC,
     +                NHCEN,
     +                NWSTEP,
     +                WBDMIN,WSTMAX,WSTEP,
     +                WBOND,WSTAR )
     +
     +
         CALL  NLO__COMPLETE_NHO_SPACE
     +
     +              ( NBAS,NHATOM,
     +                NBOSIZE,
     +                MXNHBA,MXNBA,
     +                ATHCEN,ATNHB,ATHVAL,ATHOFF,
     +                IVEC (1),
     +                NHB,NHA,
     +                NHYB,
     +                WBDCRT,WSTAR (1),
     +                SAH,
     +                P,PH,PHSUB,
     +                W,C,
     +                IVEC (NHATOM+1),
     +                XVEC,XMAT,
     +
     +                        FAILED,
     +                        MORE,
     +                        NBOND,
     +                        BDNCEN,
     +                        BDCEN,
     +                        BDNBAS,
     +                        BDBAS,
     +                        BDOCC,
     +                        H )
     +
     +
         IF (FAILED) THEN
             STAGE = 'failure complete'
             CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +                  ( STAGE,
     +                    BONDSIZE,
     +                    MAXOCC,
     +                    NHCEN,
     +                    NWSTEP,
     +                    WBDMIN,WSTMAX,WSTEP,
     +                    WBOND,WSTAR )
     +
     +
             INCSIZE = INCSIZE + 1
             GOTO 1000
         END IF

         IF (MORE) THEN

             STAGE = 'more'

             CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +                  ( STAGE,
     +                    BONDSIZE,
     +                    MAXOCC,
     +                    NHCEN,
     +                    NWSTEP,
     +                    WBDMIN,WSTMAX,WSTEP,
     +                    WBOND,WSTAR )
     +
     +
             DO NHCEN = 1,BONDSIZE

                WBOND (NHCEN) = WBOND (NHCEN) - WSTEP
                WSTAR (NHCEN) = WSTAR (NHCEN) + WSTEP

                IF (NHATOM.GT.0 .AND. NHCEN.LE.NHATOM) THEN

                    CALL  NLO__CHECK_NHO_ALL_X_CENTERS
     +
     +                         ( NATOM,
     +                           BONDSIZE,NBOSIZE,
     +                           NHCEN,NHATOM,
     +                           MXNHBA,MXNBA,
     +                           ATHCEN,ATNHB,ATHVAL,ATHOFF,
     +                           RYD2HYB,
     +                           IVEC (1),IVEC (NHA+1),
     +                           NHB,NHA,
     +                           WBOND (NHCEN),WSTAR (NHCEN),
     +                           SAH,
     +                           PH,PHSUB,
     +                           BOMAT,
     +                           MXCHOOSE,NCHOOSE (NHCEN),
     +                           CHOOSE (1,1,NHCEN),
     +                           IVEC (2*NHA+1),
     +                           XVEC,XMAT,
     +
     +                                    FAILED,
     +                                    NBOND,
     +                                    NHYB,
     +                                    BDNCEN,
     +                                    BDCEN,
     +                                    BDNBAS,
     +                                    BDBAS,
     +                                    BDOCC,
     +                                    W,H,
     +                                    PHDEP )
     +
     +
                    IF (FAILED) THEN
                        STAGE = 'failure'
                        CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +                        ( STAGE,
     +                          BONDSIZE,
     +                          MAXOCC,
     +                          NHCEN,
     +                          NWSTEP,
     +                          WBDMIN,WSTMAX,WSTEP,
     +                          WBOND,WSTAR )
     +
     +
                        INCSIZE = INCSIZE + 1
                        GOTO 1000
                    END IF

                    NHATOM = 0
                    DO I = 1,NHA
                       ATOM = ATORD (I)
                       IF (NHYB (ATOM) .LT. ATHVAL (ATOM)) THEN
                           NHATOM = NHATOM + 1
                           ATHCEN (NHATOM) = ATOM
                       END IF
                    END DO

                    CALL  MAT__C_EQ_A_FLOAT
     +
     +                         ( NHB,NHB,
     +                           NHB,NHB,
     +                           NHB,NHB,
     +                           PHDEP,
     +
     +                                PH )
     +
     +
                END IF
            END DO
            GOTO 2000
         END IF

         STAGE = 'success'

         CALL  NLO__PRINT_NHO_SEARCH_INFO
     +
     +              ( STAGE,
     +                BONDSIZE,
     +                MAXOCC,
     +                NHCEN,
     +                NWSTEP,
     +                WBDMIN,WSTMAX,WSTEP,
     +                WBOND,WSTAR )
     +
     +
C
C
C             ...form now the Core and Rydberg NHO orbitals.
C
C
         NAO2NHO = .TRUE.

         CALL  NLO__FORM_ATOMIC_NONVALENCE_NHO
     +
     +              ( NBAS,MXNBA,
     +                NBOSIZE,
     +                ATNCB,ATCIDX,ATCOFF,
     +                NCB,NCA,
     +                1,NHB,
     +                NAO2NHO,
     +                P,
     +                C (1,NHB+1),
     +                IVEC (1),IVEC (MXNBA+1),
     +                XVEC,
     +                XMAT,
     +
     +                        BDNCEN (NHB+1),
     +                        BDCEN (1,NHB+1),
     +                        BDNBAS (NHB+1),
     +                        BDBAS (1,NHB+1),
     +                        BDOCC (NHB+1),
     +                        H (1,NHB+1))
     +
     +
         CALL  NLO__FORM_ATOMIC_NONVALENCE_NHO
     +
     +              ( NBAS,MXNBA,
     +                NBOSIZE,
     +                ATNRB,ATRIDX,ATROFF,
     +                NRB,NRA,
     +                0,NHB+NCB,
     +                NAO2NHO,
     +                P,
     +                C (1,NHB+NCB+1),
     +                IVEC (1),IVEC (MXNBA+1),
     +                XVEC,
     +                XMAT,
     +
     +                        BDNCEN (NHB+NCB+1),
     +                        BDCEN (1,NHB+NCB+1),
     +                        BDNBAS (NHB+NCB+1),
     +                        BDBAS (1,NHB+NCB+1),
     +                        BDOCC (NHB+NCB+1),
     +                        H (1,NHB+NCB+1))
     +
     +
         CALL    MAT__PRINT_V_INTEGER_NOZEROS
     +
     +                ( 1,
     +                  ' BDNBAS vector ',
     +                  NBAS,
     +                  NBAS,
     +                  BDNBAS )
     +
     +
         CALL    MAT__PRINT_V_INTEGER_NOZEROS
     +
     +                ( 1,
     +                  ' BDNCEN vector ',
     +                  NBAS,
     +                  NBAS,
     +                  BDNCEN )
     +
     +
         CALL    MAT__PRINT_V_INTEGER_NOZEROS
     +
     +                ( 1,
     +                  ' BDOCC vector ',
     +                  NBAS,
     +                  NBAS,
     +                  BDOCC )
     +
     +
         CALL    MAT__PRINT_A_INTEGER_NOZEROS
     +
     +                ( 1,
     +                  ' BDCEN array ',
     +                  NBOSIZE,NBAS,
     +                  NBOSIZE,NBAS,
     +                  BDCEN )
     +
     +
         CALL    MAT__PRINT_A_INTEGER_NOZEROS
     +
     +                ( 1,
     +                  ' BDBAS array ',
     +                  NBOSIZE,NBAS,
     +                  NBOSIZE,NBAS,
     +                  BDBAS )
     +
     +
C
C
C             ...calculate the matrix containing the sum of the
C                square of the NAO coefficients per L-type angular
C                momentum for all NHOs. The NHOs are analyzed in
C                the following sequence; valence, core, hybrid
C                Rydberg and Rydberg.
C
C
         CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +              ( NBAS,MXSHELL+1,
     +                NBAS,MXSHELL+1,
     +
     +                        ANGNHO )
     +
     +
         DO ATOM = 1,NHA
            OFF = ATHOFF (ATOM)
            NHBA = ATNHB (ATOM)
            NVBA = ATHVAL (ATOM)
            DO I = 1,NHBA
               NAO = OFF + I
               LTYPE = HSHELL (NAO)
               DO J = 1,NVBA
                  NHO = OFF + J
                  CSQR = H (I,NHO) ** 2
                  ANGNHO (NHO,LTYPE) = ANGNHO (NHO,LTYPE) + CSQR
               END DO
            END DO
         END DO

         DO ATOM = 1,NCA
            OFF = ATCOFF (ATOM)
            NCBA = ATNCB (ATOM)
            DO I = 1,NCBA
               NAO = OFF + I
               LTYPE = CSHELL (NAO)
               DO J = 1,NCBA
                  NHO = NHB + OFF + J
                  CSQR = H (I,NHO) ** 2
                  ANGNHO (NHO,LTYPE) = ANGNHO (NHO,LTYPE) + CSQR
               END DO
            END DO
         END DO

         IF (RYD2HYB) THEN
             DO ATOM = 1,NHA
                OFF = ATHOFF (ATOM)
                NHBA = ATNHB (ATOM)
                NVBA = ATHVAL (ATOM)
                NRBA = NHBA - NVBA
                DO I = 1,NHBA
                   NAO = OFF + I
                   LTYPE = HSHELL (NAO)
                   DO J = 1,NRBA
                      NHO = OFF + NVBA + J
                      CSQR = H (I,NHO) ** 2
                      ANGNHO (NHO,LTYPE) = ANGNHO (NHO,LTYPE) + CSQR
                   END DO
                END DO
             END DO
         END IF

         DO ATOM = 1,NRA
            OFF = ATROFF (ATOM)
            NRBA = ATNRB (ATOM)
            DO I = 1,NRBA
               NAO = OFF + I
               LTYPE = RSHELL (NAO)
               DO J = 1,NRBA
                  NHO = NHB + NCB + OFF + J
                  CSQR = H (I,NHO) ** 2
                  ANGNHO (NHO,LTYPE) = ANGNHO (NHO,LTYPE) + CSQR
               END DO
            END DO
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__CTR_3INDEX_BLOCK
     +
     +                    ( NPSIZE,NCSIZE,NWSIZE,
     +                      NXYZT,
     +                      MIJ,MK,MIJK,NRS,
     +                      NPR,NPS,NPT,
     +                      NCR,NCS,NCT,
     +                      MXPRIM,MNPRIM,
     +                      CCR,CCS,CCT,
     +                      CCBEGR,CCBEGS,CCBEGT,
     +                      CCENDR,CCENDS,CCENDT,
     +                      PRIMR,PRIMS,PRIMT,
     +                      L1CACHE,TILE,NCTROW,
     +                      EQUALRS,
     +                      SWAPRS,
     +                      PTRANS,
     +                      BLOCKED,
     +                      PUSED,PSAVE,PPAIR,
     +                      PBATCH,
     +                      WORK,
     +
     +                                CBATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__CTR_3INDEX_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__TRANSPOSE_BATCH
C                OED__CTR_SINGLE_NEW
C                OED__MAP_IJKL_TO_IKJL
C                OED__CTR_PAIR_NEW
C                OED__CTR_PAIR_UPDATE
C  DESCRIPTION : This operation performs a three-indexed contraction
C                from a block of one electron primitives to contracted
C                integrals:
C
C
C                    sum  [abc]      -->  (abc)
C                    ijk       ijk             rst
C
C                                               r = 1,NCR
C                                               s = 1,NCS
C                                               t = 1,NCT
C
C                For optimum performance of the contraction procedure,
C                the contraction routine is written to operate on the
C                batch block of primitive integrals ordered in the
C                following form:
C
C                                pbatch (nxyzt,ij,k)
C
C                where ij and k are the partial primitive index sets
C                being treated here. Their total numbers are MIJ and MK
C                and the individual i,j,k indices are sitting in
C                PRIMR,PRIMS,PRIMT. If on entry of this routine the
C                primitive integrals are ordered in the form
C                (ij,k,nxyzt), a transposition has to preceed the
C                actual contraction procedure. This is triggered by
C                the keyword PTRANS, which is set true, if such a
C                transposition is needed. The complete set of cartesian
C                monomial quadruplets is kept together for efficiency
C                through the entire contraction sequence.
C
C                STRATEGY:
C
C                Perform overall contraction in 2 contraction steps,
C                using an intermediate reordering:
C
C
C                 1) Contract over k-range of primitives:
C
C                    (nxyzt,ij,t) = cct (t,k) * (nxyzt,ij,k)
C
C                 2) Reorder ij <-> t (if needed):
C
C                    (nxyzt,ij,t) --> (nxyzt,t,ij)
C
C
C                 3) Contract over ij-range primitives and add result
C                    to the final contraction vector:
C
C                    (nxyzt,t,rs) = (nxyzt,t,rs)
C                                 + ccr (r,i) * ccs (s,j) * (nxyzt,t,ij)
C
C
C
C                  Input:
C
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays
C                    NXYZT        =  total # of cartesian monomial
C                                    quadruplets
C                    MIJ(K)       =  # of ij(k) primitive pairs and
C                                    indices to be transformed
C                    MIJK         =  total # of partial primitive
C                                    index triplets
C                    NRS          =  # of rs contraction pairs
C                    NPx          =  # of respective i,j,k primitives
C                                    for contractions x=R,S,T
C                    NCx          =  # of contractions for x=R,S,T
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i,j and k primitives,
C                                    i.e. = max (i,j,k)
C                    MNPRIM       =  the minimum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = min (i,j)
C                    CCx          =  full set (including zeros) of
C                                    contraction coefficients for
C                                    x=R,S,T contractions
C                    CCBEGx       =  lowest nonzero primitive i,j,k
C                                    index for x=R,S,T contractions
C                    CCENDx       =  highest nonzero primitive i,j,k
C                                    index for x=R,S,T contractions
C                    PRIMx        =  primitive i,j indices for the
C                                    x=R,S contractions
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    EQUALRS      =  is true, if only the lower
C                                    triangle of ij primitive indices
C                                    is present and consequently only
C                                    the lower triangle of the rs
C                                    contractions needs to be evaluated
C                    SWAPRS       =  if this is true, the 1st half pair
C                                    transformation will be over R
C                                    followed by the 2nd over S.
C                                    If false, the order will be
C                                    reversed: 1st over S then 2nd
C                                    over R
C                    PTRANS       =  if true, a necessary primitive
C                                    integral transposition needs to
C                                    be done in order to bring the ij
C                                    primitive indices to the far right
C                                    position
C                    BLOCKED      =  if false, only one call will be
C                                    made to the present contraction
C                                    routine. The contraction batch
C                                    has not! been initialized to zero
C                                    and there is no need to perform
C                                    an update of the contracted batch.
C                    Pxxxx        =  intermediate storage arrays for
C                                    primitive labels to bundle
C                                    contraction steps in do loops
C                                    (xxxx = USED,SAVE,PAIR)
C                    PBATCH       =  the batch of primitive integrals
C                                    to be contracted
C                    WORK         =  the working array for intermediate
C                                    storage
C                    CBATCH       =  the batch of contracted integrals
C                                    before contraction update
C
C                  Output:
C
C                    CBATCH       =  the update batch of contracted
C                                    integrals after contraction
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     BLOCKED
         LOGICAL     EQUALRS
         LOGICAL     INWORK
         LOGICAL     PTRANS
         LOGICAL     SWAPRS

         INTEGER     L1CACHE,L1FREE,L1USED
         INTEGER     MIJ,MK,MIJK,NRS
         INTEGER     MXPRIM,MNPRIM
         INTEGER     N
         INTEGER     NBLOCK
         INTEGER     NCOL,NROW
         INTEGER     NCR,NCS,NCT
         INTEGER     NCTROW
         INTEGER     NPR,NPS,NPT
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NXYZT
         INTEGER     TILE
         INTEGER     WROW

         INTEGER     CCBEGR (1:NCR)
         INTEGER     CCBEGS (1:NCS)
         INTEGER     CCBEGT (1:NCT)

         INTEGER     CCENDR (1:NCR)
         INTEGER     CCENDS (1:NCS)
         INTEGER     CCENDT (1:NCT)

         INTEGER     PRIMR  (1:MIJ)
         INTEGER     PRIMS  (1:MIJ)
         INTEGER     PRIMT  (1:MK)

         INTEGER     PPAIR  (1:MXPRIM)
         INTEGER     PSAVE  (1:MXPRIM)
         INTEGER     PUSED  (1:MNPRIM)

         DOUBLE PRECISION    CCR (1:NPR,1:NCR)
         DOUBLE PRECISION    CCS (1:NPS,1:NCS)
         DOUBLE PRECISION    CCT (1:NPT,1:NCT)

         DOUBLE PRECISION    CBATCH (1:NCSIZE)
         DOUBLE PRECISION    PBATCH (1:NPSIZE)
         DOUBLE PRECISION    WORK   (1:NWSIZE)
C
C
C------------------------------------------------------------------------
C
C
C             ...check, if a primitive batch transposition is needed:
C
C                        (ij,k,nxyzt) --> (nxyzt,ij,k)
C
C
         IF (PTRANS .AND. (MIJK.GT.1) .AND. (NXYZT.GT.1)) THEN

             CALL  OED__TRANSPOSE_BATCH
     +
     +                  ( MIJK,NXYZT,
     +                    TILE,
     +                    PBATCH,
     +
     +                            WORK )
     +
     +
             INWORK = .TRUE.
         ELSE
             INWORK = .FALSE.
         END IF
C
C
C             ...do contraction over single k index. Logical variable
C                INWORK controls where the actual significant data
C                (i.e. the integrals to be contracted) is residing.
C                If INWORK is true, then array WORK contains the
C                integrals, if false, they are in array PBATCH.
C
C
         N = NXYZT * MIJ

         IF (INWORK) THEN

             CALL  OED__CTR_SINGLE_NEW
     +
     +                  ( N,
     +                    MK,
     +                    NPT,NCT,
     +                    CCT,
     +                    CCBEGT,CCENDT,
     +                    PRIMT,
     +                    PSAVE,PPAIR,
     +                    WORK,
     +
     +                            PBATCH )
     +
     +
             INWORK = .FALSE.

         ELSE

             CALL  OED__CTR_SINGLE_NEW
     +
     +                  ( N,
     +                    MK,
     +                    NPT,NCT,
     +                    CCT,
     +                    CCBEGT,CCENDT,
     +                    PRIMT,
     +                    PSAVE,PPAIR,
     +                    PBATCH,
     +
     +                            WORK )
     +
     +
             INWORK = .TRUE.

         END IF
C
C
C             ...reorder ij <-> t , if needed.
C
C
         IF (MIJ.GT.1 .AND. NCT.GT.1) THEN

             IF (INWORK) THEN

                 CALL  OED__MAP_IJKL_TO_IKJL
     +
     +                  ( NXYZT,MIJ,NCT,1,
     +                    TILE,
     +                    WORK,
     +
     +                            PBATCH )
     +
     +
                 INWORK = .FALSE.

             ELSE

                 CALL  OED__MAP_IJKL_TO_IKJL
     +
     +                  ( NXYZT,MIJ,NCT,1,
     +                    TILE,
     +                    PBATCH,
     +
     +                            WORK )
     +
     +
                 INWORK = .TRUE.

             END IF
         END IF
C
C
C             ...prepare for contraction over ij.
C
C                One of the key variables to be determined here
C                is the blocking size of the invariant indices
C                such that the cache is used efficiently. The
C                blocking size has to be adapted also to the size
C                of the working space available. L1USED contains
C                the amount of data that will occupy the cache
C                besides the three main big arrays containing the
C                initial, quarter transformed and halftransformed
C                integrals. This extra data is the contraction
C                coefficients, their segmentation limits and the
C                primitive indices. L1FREE indicates the size of
C                the level 1 cache that is finally available for
C                the three big integral arrays.
C
C
         L1USED = MIJ + NCR + NCS + NPR + NPS + NPR*NCR + NPS*NCS
         L1FREE = (3*L1CACHE/4) - L1USED

         NCOL = MNPRIM + NRS + MIJ
         NROW = L1FREE / NCOL
C
C
C             ...do contraction over ij. If primitive integrals are
C                in working array, use original PBATCH array as
C                working array! Do not perform a contracted batch
C                update, if no contraction blocking is necessary.
C
C
         IF (INWORK) THEN

             WROW = NPSIZE / MNPRIM
             NBLOCK = MIN (NXYZT,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             IF (BLOCKED) THEN
                 CALL  OED__CTR_PAIR_UPDATE
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        WORK,PBATCH,
     +
     +                                CBATCH )
     +
     +
             ELSE
                 CALL  OED__CTR_PAIR_NEW
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        WORK,PBATCH,
     +
     +                                CBATCH )
     +
     +
             END IF

         ELSE

             WROW = NWSIZE / MNPRIM
             NBLOCK = MIN (NXYZT,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             IF (BLOCKED) THEN
                 CALL  OED__CTR_PAIR_UPDATE
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        PBATCH,WORK,
     +
     +                                CBATCH )
     +
     +
             ELSE
                 CALL  OED__CTR_PAIR_NEW
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        PBATCH,WORK,
     +
     +                                CBATCH )
     +
     +
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine norm_fac(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c
c The scalar2 is replaced by dsqrt(scalar1). 
c scalar1 is replaced by 1.0/scalar1
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'

      double precision x
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      x2 = dsqrt(x)
      x  = 1.0d0/x2

      return 
      end 

      SUBROUTINE CUBEFORM (DENSACUB,DENSBCUB,NPTS,
     $     DENSTCUB,TMOACUB,TMOBCUB,NBASP,IDORO,IAORBD,
     $     IAORBO,TMOOUT,NBASPEFF,NORBOUTA,NORBOUTB,
     $     IORBOUT,IDENOUT)
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION DENSACUB(NPTS+1)
      DIMENSION DENSBCUB(NPTS+1)
      DIMENSION DENSTCUB(NPTS+1)
      DIMENSION TMOACUB((NPTS+1)*NBASP)
      DIMENSION TMOBCUB((NPTS+1)*NBASP)
      DIMENSION TMOOUT((NPTS+1)*NBASPEFF)
C
C Calculate the Output density
      IF (IDORO.NE.1) THEN
         DO 10 I=1,(NPTS+1)
            IF (IAORBD.EQ.0) DENSTCUB(I)=DENSACUB(I)
            IF (IAORBD.EQ.1) DENSTCUB(I)=DENSBCUB(I)
            IF (IAORBD.EQ.2) DENSTCUB(I)=DENSACUB(I)+DENSBCUB(I)
C     WRITE(*,*) "output den #",I,"= ",DENSTCUB(I)
 10      CONTINUE
      END IF
C     
      NGRPS1=(NPTS+1)/6
      MODVAL1=MOD(NPTS+1,6)
      NGRPS2=(NPTS+1)*NBASPEFF/6
      MODVAL2=MOD((NPTS+1)*NBASPEFF,6)
C
C Write out the total density matrix
      IF (IDORO.NE.1) THEN
C
         DO 30 K=1,NGRPS1
            WRITE(IDENOUT,1000)
     $           (DENSTCUB((K-1)*6+JJ),JJ=1,6)
 1000       format(6(D13.5))
 30      CONTINUE
C     
         IF (MODVAL1.NE.0) THEN
            WRITE(IDENOUT,1001)
     $           (DENSTCUB(NGRPS1*6+JJ),JJ=1,MODVAL1)
 1001       format(6(D13.5))
         END IF
C     
      END IF
C     
C Construct the final orbital vector
      IF (IDORO.NE.0) THEN
C
         KK=0
         IF (IAORBO.EQ.0) THEN
           DO 50 K=1,((NPTS+1)*NBASP)
              TMOOUT(K)=TMOACUB(K)
 50        CONTINUE
        ELSE IF (IAORBO.EQ.1) THEN
           DO 51 K=1,((NPTS+1)*NBASP)
              TMOOUT(K)=TMOBCUB(K)
 51        CONTINUE
        ELSE
           DO 52 K=1,(NPTS+1)
              DO 53 KJ=1,NORBOUTA
                 KK=KK+1
                 TMOOUT(KK)=TMOACUB((K-1)*(NORBOUTA)+KJ)
 53           CONTINUE
C     
              DO 54 KJ=1,NORBOUTB
                 KK=KK+1
                 TMOOUT(KK)=TMOBCUB((K-1)*(NORBOUTB)+KJ)
 54           CONTINUE
 52        CONTINUE
        END IF
C
C     Write out the orbital coeffs.
        DO 60 K=1,NGRPS2
           WRITE(IORBOUT,1002)
     $          (TMOOUT((K-1)*6+JMO),JMO=1,6)
 1002      format(6(D13.5))
 60     CONTINUE
C     
        IF (MODVAL2.NE.0) THEN
           WRITE(IORBOUT,1003)
     $          (TMOOUT(NGRPS2*6+JMO),JMO=1,MODVAL2)
 1003      format(6(D13.5))
        END IF
C     
      END IF
C     WRITE(*,*)
C     WRITE(*,*)
C     
      RETURN
      END SUBROUTINE CUBEFORM

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine nuc_dipole_moment(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)

c--------------------------------------------------------------------------
c
c The scalar1 is raised to the scalar2 power and replaced. 
c
c scalar1 = scalar1**scalar2 
c   
c--------------------------------------------------------------------------

      implicit none
      include 'int_gen_parms.h'
      include 'interpreter.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer type(mx_array_index) 
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer natoms, imoment
      integer i, j, n1, n2, n3, n4  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer sind, xind, ind(mx_array_index)
      integer seg, index(mx_array_index), val1(mx_array_index), 
     *        val2(mx_array_index), junk

      integer block, blkndx
      integer find_current_block
      integer stack

      double precision DNUC,XCOORD,YCOORD,ZCOORD
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the scalar that tells whether X Y or Z nuclear dipole moment
c---------------------------------------------------------------------------

      array      = op(c_result_array)
      array_type = array_table(c_array_type, array)
      nindex     = array_table(c_nindex, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: The argument in nn_dipole_moment
     *            must be a scalar.'  
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
        print *,'Scalar table index out of range in nn_dipole_moment, ',
     *          'line ',current_line
        print *,'Index for array ',array,' is ',sind,' should be ',
     *          'between 1 and ',nscalar_table
        call abort_job()
      endif

c----------------------------------------------------------------------------
c   Locate the scalar that will hold the nuclear dipole moment
C
C   !!!  On input, this scalar has the number of atoms  !!!
c---------------------------------------------------------------------------

      evec_array  = op(c_op1_array)
      evec_type   = array_table(c_array_type, evec_array)
      nindex_evec = array_table(c_nindex, evec_array)

      xind =  array_table(c_scalar_index, evec_array)
      if (xind .lt. 1 .or. xind .gt. nscalar_table) then
        print *,'Scalar table index out of range in nn_dipole_moment, ',
     *          'line ',current_line
        print *,'Index for array ',evec_array,'is',xind,' should be ',
     *          'between 1 and ',nscalar_table
        call abort_job()
      endif
C
C
C   Compute the nuclear contribution to the dipole moment
C
C 
      if ( abs (scalar_table(sind) - 1) .LT. 0.0001 ) imoment = 1
      if ( abs (scalar_table(sind) - 2) .LT. 0.0001 ) imoment = 2
      if ( abs (scalar_table(sind) - 3) .LT. 0.0001 ) imoment = 3
      if ( abs (scalar_table(sind) - 4) .LT. 0.0001 ) imoment = 4
      if ( abs (scalar_table(sind) - 5) .LT. 0.0001 ) imoment = 5
      if ( abs (scalar_table(sind) - 6) .LT. 0.0001 ) imoment = 6
      if ( abs (scalar_table(sind) - 7) .LT. 0.0001 ) imoment = 7
      if ( abs (scalar_table(sind) - 8) .LT. 0.0001 ) imoment = 8
      if ( abs (scalar_table(sind) - 9) .LT. 0.0001 ) imoment = 9

      natoms = scalar_table(xind)
      scalar_table(xind) = 0.0D0
      DNUC = 0.0D0
      IF (imoment .EQ. 1) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            DNUC = DNUC + charge(I)*XCOORD
         ENDDO ! I
      ELSE IF (imoment .EQ. 2) THEN
         DO I = 1, natoms
            YCOORD = acenter(I,2)
            DNUC = DNUC + charge(I)*YCOORD
         ENDDO ! I
      ELSE IF (imoment .EQ. 3) THEN
         DO I = 1, natoms
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*ZCOORD
         ENDDO ! I
C XX
      ELSE IF (imoment .EQ. 4) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            YCOORD = acenter(I,2)
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*XCOORD*XCOORD
         ENDDO ! I
C YY
      ELSE IF (imoment .EQ. 5) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            YCOORD = acenter(I,2)
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*YCOORD*YCOORD
         ENDDO ! I
C ZZ
      ELSE IF (imoment .EQ. 6) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            YCOORD = acenter(I,2)
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*ZCOORD*ZCOORD
         ENDDO ! I
C XY
      ELSE IF (imoment .EQ. 7) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            YCOORD = acenter(I,2)
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*XCOORD*YCOORD
         ENDDO ! I
C XZ
      ELSE IF (imoment .EQ. 8) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            YCOORD = acenter(I,2)
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*XCOORD*ZCOORD
         ENDDO ! I
C YZ
      ELSE IF (imoment .EQ. 9) THEN
         DO I = 1, natoms
            XCOORD = acenter(I,1)
            YCOORD = acenter(I,2)
            ZCOORD = acenter(I,3)
            DNUC = DNUC + charge(I)*YCOORD*ZCOORD
         ENDDO ! I
      ELSE
         WRITE(*,*) "Wrong type of moment; should be 1-9,"
      ENDIF
      scalar_table(xind) = DNUC

      return 
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine clear_server_stats()
c--------------------------------------------------------------------------
c   Initialize server statistics to 0.
c--------------------------------------------------------------------------
      implicit none
      include 'server_stat.h'
      include 'mpif.h'

      integer i

      stat_key = 1
      next_stat_key = 0

      do i = 1, mx_stat_keys
         sstat_tprep(i) = 0.
         sstat_tprepsum(i) = 0.
         sstat_treq(i)    = 0.
         sstat_tpreq(i)    = 0.
         sstat_trestore(i) = 0.
         sstat_tbackup(i)  = 0.

         sstat_tprep2(i) = 0.
         sstat_tprepsum2(i) = 0.
         sstat_treq2(i)    = 0.
         sstat_tpreq2(i)    = 0.
         sstat_trestore2(i) = 0.
         sstat_tbackup2(i)  = 0.

         sstat_nprep(i) = 0
         sstat_nprepsum(i) = 0
         sstat_nreq(i)     = 0
         sstat_npreq(i)     = 0
         sstat_nrestore(i) = 0
         sstat_nbackup(i)  = 0
      enddo

      return
      end

C THIS ROUTINE SHOULD BE CALLED WHEN THERE IS INSUFFICIENT CORE TO
C CONTINUE THE CALCULATION.  PRINTS OUT A FATAL ERROR MESSAGE AND
C CALLS THE CRAPS EXIT HANDLER.
C
C INPUT:
C    ROUTINE - ROUTINE FROM WHICH INSMEM IS CALLED [CHARACTER*(*)]
C    INEED   - AMOUNT OF MEMORY REQUIRED.
C    IAVAIL  - AMOUNT OF MEMORY AVAILABLE.

      SUBROUTINE INSMEM(ROUTINE,INEED,IAVAIL)
      INTEGER INEED,IAVAIL
      CHARACTER*(*) ROUTINE

      double precision dneed, davail
      character*2 units(6)
      data units /' B','kB','MB','GB','TB','PB'/
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      dneed = 1.d0*ineed*iintln
      i = 1
      do while (dneed.gt.1000.d0)
         i = i+1
         dneed = dneed/1024.d0
      end do
      davail = 1.d0*iavail*iintln
      j = 1
      do while (davail.gt.1000.d0)
         j = j+1
         davail = davail/1024.d0
      end do

      WRITE(*,100) ROUTINE(1:linblnk(ROUTINE)),
     &             dneed,units(i),davail,units(j)
100   FORMAT(T3,'@',A,': Insufficient memory available.',/,
     &       T3,'  needed: ',F5.1,1x,A,', available: ',F5.1,1x,A,'.')
      CALL ERREX
      RETURN
      END

C MOVES LIST ISPFRM,LSTFRM TO ISPOUT,LSTOUT.  
C
C       T2  - SCRATCH USED FOR THE LIST.
C    NDSSIZ - THE DISTRIBUTION SIZE FOR THE LIST.
C    NUMDIS - THE NUMBER OF DISTRIBUTIONS IN THE LIST.
C    ICACH1 - THE I/O CACHE TO BE USED FOR THE GETLST OPERATION.
C    ICACH2 - THE I/O CACHE TO BE USED FOR THE PUTLST OPERATION.

      SUBROUTINE MVLIST(Z,NDSSIZ,NUMDIS,LSTFRM,LSTOUT,ISPFRM,
     &                  ISPOUT,ICACH1,ICACH2)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION Z(NDSSIZ,NUMDIS)
      CALL GETLST(Z,1,NUMDIS,ICACH1,ISPFRM,LSTFRM)
      CALL PUTLST(Z,1,NUMDIS,ICACH2,ISPOUT,LSTOUT)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine energy_product(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c   Multiplies each sample of the block given by the array argument by the
c   MP2 denominator
c       eps = epsilon(i)+epsilon(j)-epsilon(a)-epsilon(b)
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      if (nindex .eq. 4) then
         call eps_prod4(x, bval(1),eval(1),type(1),
     *                    bval(2),eval(2),type(2),
     *                    bval(3),eval(3),type(3),
     *                    bval(4),eval(4),type(4),
     *                   epsilon,epsilonb)
      else if (nindex .eq. 6) then
         call eps_prod6(x, bval(1),eval(1),type(1),
     *                   bval(2),eval(2),type(2),
     *                   bval(3),eval(3),type(3),
     *                   bval(4),eval(4),type(4),
     *                   bval(5),eval(5),type(5),
     *                   bval(6),eval(6),type(6),
     *                   epsilon,epsilonb)
      else if (nindex .eq. 2) then
         call eps_prod2(x, bval(1),eval(1),type(1),
     *                     bdim(1), edim(1),
     *                    bval(2),eval(2),type(2),bdim(2),edim(2),
     *                    epsilon,epsilonb)
      else
         print *,'Error in energy_product: Result array ',
     *      'must have either 4 or 2 indices.'
         print *,'array has ',nindex,' indices.'
         call abort_job()
      endif

      return
      end

      subroutine eps_prod4(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision eps, epsa, epsb, epsi, epsj
      double precision val

      do j = j1,j2
         if (jtype .eq. mobindex) then
            epsj = epsilonb(j)
         else
            epsj = epsilon(j)
         endif
      do b = b1,b2
         if (btype .eq. mobindex) then
            epsb = epsilonb(b)
         else
            epsb = epsilon(b)
         endif
      do i = i1, i2
         if (itype .eq. mobindex) then
            epsi = epsilonb(i)
         else
            epsi = epsilon(i)
         endif
      do a = a1,a2
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif
         val =  x(a,i,b,j)
         eps = epsi + epsj - epsa - epsb
         x(a,i,b,j) = val*eps
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine eps_prod6(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, c1, c2, ctype,
     *                      k1, k2, ktype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,c1,c2,i1,i2,j1,j2,k1,k2
      integer atype, itype, btype, jtype, ctype, ktype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2,c1:c2,k1:k2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,c,i,j,k
      double precision eps, epsa, epsb, epsc, epsi, epsj, epsk
      double precision val

c--------------------------------------------------------------------
c Set index types if necassary and perform simple check.
c--------------------------------------------------------------------

      if (atype .eq. simple_index) atype = itype
      if (itype .eq. simple_index) itype = atype

      if (btype .eq. simple_index) btype = jtype
      if (jtype .eq. simple_index) jtype = btype

      if (ctype .eq. simple_index) ctype = ktype
      if (ktype .eq. simple_index) ktype = ctype

      do k = k1,k2
         if (ktype .eq. mobindex) then
            epsk = epsilonb(k)
         else
            epsk = epsilon(k)
         endif
      do c = c1,c2
         if (ctype .eq. mobindex) then
            epsc = epsilonb(c)
         else
            epsc = epsilon(c)
         endif
      do j = j1,j2
         if (jtype .eq. mobindex) then
            epsj = epsilonb(j)
         else
            epsj = epsilon(j)
         endif
      do b = b1,b2
         if (btype .eq. mobindex) then
            epsb = epsilonb(b)
         else
            epsb = epsilon(b)
         endif
      do i = i1, i2
         if (itype .eq. mobindex) then
            epsi = epsilonb(i)
         else
            epsi = epsilon(i)
         endif
      do a = a1,a2
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif
         val =  x(a,i,b,j,c,k)
         eps = epsi + epsj + epsk - epsa - epsb - epsc
         x(a,i,b,j,c,k) = val*eps
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine eps_prod2(x, a1,a2,atype,na1,na2,i1,i2,itype,
     *                       ni1,ni2,epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,i1,i2
      integer atype, itype
      integer na1, na2, ni1, ni2
      double precision x(na1:na2,ni1:ni2)

      double precision epsilon(*), epsilonb(*),reg

      integer a,i
      double precision eps, epsa, epsi
      double precision val

      do i = i1, i2
         if (itype .eq. mobindex) then
            epsi = epsilonb(i)
         else
            epsi = epsilon(i)
         endif
      do a = a1,a2
         if (atype .eq. mobindex) then
            epsa = epsilonb(a)
         else
            epsa = epsilon(a)
         endif
         val =  x(a,i)
         eps = epsi - epsa
         x(a,i) = val*eps

      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NORMALIZE_CARTESIAN
     +
     +                    ( M,
     +                      NXYZ,
     +                      L,
     +                      NORM,
     +
     +                             BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NORMALIZE_CARTESIAN
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation normalizes a cartesian monomial part
C                of a batch of contracted cartesian gaussian integrals.
C                The normalization factors are xyz-exponent dependent
C                and are given for a specific monomial as:
C
C                                    ______________________
C                     l m n         /       2^(2L)
C                    x y z -->     / -----------------------
C                                \/ (2l-1)!!(2m-1)!!(2n-1)!!
C
C
C                where L = l+m+n. The best way to deal with these
C                factors for a complete set of monomials for fixed L
C                is to split up each factor into its l-,m- and n-
C                component:
C
C                       _______        _______        _______
C                      / 2^(2l)       / 2^(2m)       / 2^(2n)
C                     / -------  *   / -------  *   / -------
C                   \/ (2l-1)!!    \/ (2m-1)!!    \/ (2n-1)!!
C
C
C                These factors are passed in argument as NORM.
C
C
C                  Input:
C
C                    M           =  # of elements not involved in the
C                                   normalization (invariant indices)
C                    NXYZ        =  # of monomials for shell L
C                    L           =  the shell type for which the
C                                   normalization will be done
C                    NORM        =  individual normalization factors
C                                   for each monomial exponent
C                    BATCH       =  batch of unnormalized integrals
C
C                  Output:
C
C                    BATCH       =  batch of normalized integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,L,M,N,X,Y,Z
         INTEGER     NXYZ
         INTEGER     YBEG

         DOUBLE PRECISION  SCALAR
         DOUBLE PRECISION  XNORM

         DOUBLE PRECISION  NORM (0:L)

         DOUBLE PRECISION  BATCH (1:M,1:NXYZ)
C
C
C------------------------------------------------------------------------
C
C
C             ...generate monomial exponents lmn in appropriate
C                sequence and normalize integrals.
C
C
         N = 0

         DO 100 X = L,0,-1
            XNORM = NORM (X)
            YBEG = L - X
            DO 110 Y = YBEG,0,-1
               Z = YBEG - Y
               SCALAR = XNORM * NORM (Y) * NORM (Z)

               N = N + 1

               DO 120 I = 1,M
                  BATCH (I,N) = SCALAR * BATCH (I,N)
  120          CONTINUE

  110       CONTINUE
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

         SUBROUTINE  ERD__RYS_ROOTS_WEIGHTS_YUKAWA
     +
     +                    ( NT,NTGQP,
     +                      NGQP,NMOM,
     +                      TVAL,UVAL,RYSZERO,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      A,B,
     +                      MOM,
     +                      DIA,OFF,
     +                      ROW1,ROW2,
     +
     +                             RTS,
     +                             WTS )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__RYS_ROOTS_WEIGHTS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__RYS_1_ROOTS_WEIGHTS
C                ERD__RYS_2_ROOTS_WEIGHTS
C                ERD__RYS_3_ROOTS_WEIGHTS
C                ERD__RYS_4_ROOTS_WEIGHTS
C                ERD__RYS_5_ROOTS_WEIGHTS
C                ERD__RYS_X_ROOTS_WEIGHTS
C  DESCRIPTION : This routine calculates NGQP-point Gaussian quadrature
C                rules on [0,1] over the Rys weight functions:
C
C
C                                       exp(-T*x)+U*(1-1/x)
C                             W   (x) = -------------------
C                              Rys          2*sqrt(x)*x
C
C
c                          where U = (STGEXP^2)/4*rho
C                for a set of NT T-exponents. Special interpolation
C                routines are provided for low number of roots and
C                weigths (NGQP < 6). On exit, NT x NGQP = NTGQP roots
C                and weights have been produced.
C
C
C                  Input:
C
C                    NT           =  # of T-exponents
C                    NTGQP        =  # of roots times # of T-exponents
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    TVAL         =  the T-exponents
c                    UVAL         =  the U-exponents 
C                    RYSZERO      =  will hold the zeroth Rys moments
C                                    for all T-exponents
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    A,B          =  will contain the recurrence
C                                    coefficients for the auxillary
C                                    polynomials
C                    MOM          =  will contain the normed auxillary
C                                    polynomial modified moments
C                    DIA,OFF      =  will contain the diagonal and
C                                    offdiagonal elements of the
C                                    tridiagonal symmetric terminal
C                                    matrix
C                    ROW1,ROW2    =  first,second row intermediates.
C                                    Will be used to evaluate the
C                                    tridiagonal elements of the
C                                    symmetric terminal matrix in an
C                                    efficient way using Sack and
C                                    Donovan's method
C
C                  Output:
C
C                    RTS          =  the roots array
C                    WTS          =  the weights array
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    MGRID
         INTEGER    N,I,K,L
         INTEGER    NGQP
         INTEGER    NGRID
         INTEGER    NMOM
         INTEGER    NT,NTGQP
         INTEGER    TGRID

         DOUBLE PRECISION   DELTA,STGEXP
         DOUBLE PRECISION   T,TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION   ZERO,SIXTH,FIFTH,FOURTH,THIRD,HALF,ONE,PI

         DOUBLE PRECISION   A    (1:NMOM)
         DOUBLE PRECISION   B    (2:NMOM)
         DOUBLE PRECISION   MOM  (1:NMOM)
         DOUBLE PRECISION   DIA  (1:NGQP)
         DOUBLE PRECISION   OFF  (1:NGQP)
         DOUBLE PRECISION   ROW1 (1:NMOM)
         DOUBLE PRECISION   ROW2 (1:NMOM-1)

         DOUBLE PRECISION   RYSZERO (1:NT)
         DOUBLE PRECISION   TVAL    (1:NT)
         DOUBLE PRECISION   UVAL    (1:NT)

         DOUBLE PRECISION   RTS     (1:NTGQP)
         DOUBLE PRECISION   WTS     (1:NTGQP)

         DOUBLE PRECISION   FTABLE (0:MGRID,0:NGRID)

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (SIXTH   =  0.166666666666667D0)
         PARAMETER  (FIFTH   =  0.2D0)
         PARAMETER  (FOURTH  =  0.25D0)
         PARAMETER  (THIRD   =  0.333333333333333D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0)
         PARAMETER  (PI      =  3.141592653589793D0)
C
C
C------------------------------------------------------------------------
C
c         write(6,*) 'Number of roots and weights = ',NGQP
c         write(6,*) 'Total number of roots and weights for all T and U',
c     & NTGQP 
C
c         DO I=1,NT
c         UVAL(I) = 1.d-7
c         ENDDO

c------------Number of roots and weights equal to  1--------------------
         IF(NGQP.eq.1) then

c        CALL ERD__RYS_1_2_ROOTS_WEIGHTS_TENNO
c     +
c     +                    ( NT,NTGQP,
c     +                      NGQP,NMOM,
c     +                      TVAL,UVAL,RYSZERO,
c     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
c     +                      A,B,
c     +                      MOM,
c     +                      DIA,OFF,
c     +                      ROW1,ROW2,
c     +
c     +                                RTS,
c     +                                WTS )
c     +


         call root1(TVAL, UVAL, RTS, WTS, NT)

         ENDIF

         
c------------Number of roots and weights equal to  2--------------------
         IF(NGQP.eq.2) then
c         CALL ERD__RYS_1_2_ROOTS_WEIGHTS_TENNO
c     +
c     +                    ( NT,NTGQP,
c     +                      NGQP,NMOM,
c     +                      TVAL,UVAL,RYSZERO,
c     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
c     +                      A,B,
c     +                      MOM,
c     +                      DIA,OFF,
c     +                      ROW1,ROW2,
c     +
c     +                                RTS,
c     +                                WTS )
c     +
c
c          write(6,*) 'Ten-no roots and weights'



         call root2(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  3--------------------
         IF(NGQP.eq.3) then
         call root3(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  4--------------------
         IF(NGQP.eq.4) then
         call root4(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  5--------------------
         IF(NGQP.eq.5) then
         call root5(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  6--------------------
         IF(NGQP.eq.6) then
         call root6(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  7--------------------
         IF(NGQP.eq.7) then
         call root7(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  8--------------------
         IF(NGQP.eq.8) then
         call root8(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  9--------------------
         IF(NGQP.eq.9) then
         call root9(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  10--------------------
         IF(NGQP.eq.10) then
         call root10(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  11--------------------
         IF(NGQP.eq.11) then
         call root11(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  12--------------------
         IF(NGQP.eq.12) then
         call root12(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  13--------------------
         IF(NGQP.eq.13) then
         call root13(TVAL, UVAL, RTS, WTS, NT)
         ENDIF

c------------Number of roots and weights equal to  14--------------------
         IF(NGQP.eq.14) then
         call root14(TVAL, UVAL, RTS, WTS, NT)
         ENDIF


c------------------------------------------------------------------------
c            DO I=1,NTGQP

c            write(6,*) RTS(I), I
c            ENDDO

C
C             ...proceed according to the number of roots and weights
C                required.


c 6000    DO N = 1,NT
c            T = TVAL (N)
c            write(6,*) 'U=',UVAL(N)
c
c         END DO

c         CALL  ERD__RYS_X_ROOTS_WEIGHTS_YUKAWA
c     +
c     +              ( NT,NTGQP,
c     +                NGQP,NMOM,
c     +                TVAL,UVAL,RYSZERO,
c     +                A,B,
c     +                MOM,
c     +                DIA,OFF,
c     +                ROW1,ROW2,
c     +
c     +                          RTS,
c     +                          WTS )
c     +
c     +
c
C
C             ...ready!
C
C
         RETURN
         END

c This routine reads the command-line arguments and initializes the
c a2proc environment (and any other dependents).

      subroutine a2proc_init(module)
      implicit none

c ARGUMENT LIST
      character*80 module

c INTERNAL VARIABLES
      logical have_command
      character arg*80
      integer*4 i, iargc, num_args

c ----------------------------------------------------------------------

#ifdef _TRACE_A2PROC
      write(*,*) '@A2PROC: Entered file ', __FILE__
#endif

c ----------------------------------------------------------------------

c   o initialize module*80 and have_command
      module = ''
      have_command = .false.

c Make sure the integers are all of the same size. The Sun Pro 6 compilers,
c for example, require the index argument of getarg to be 4 bytes. This may
c be different with other compilers.
      num_args = iargc()
      if (1.gt.num_args) then
         write(*,*) '@INIT_A2PROC: This program requires an argument.\n'
         call exit(1)
      end if

c   o loop over arguments
      do i = 1, num_args
         if (.not.have_command) then
            call getarg(i,arg)

c         o help
            if ((arg(1:4).eq.'help').or.(arg(1:2).eq.'-h')) then
               module(1:4) = 'help'
               have_command = .true.
            end if

c         o MOLDEN
            if (arg(1:6).eq.'molden') then
               module(1:6) = 'molden'
               have_command = .true.
            end if

c         o GENNBO
            if (arg(1:6).eq.'gennbo') then
               module(1:6) = 'gennbo'
               have_command = .true.
            end if

c         o JOB ARCHIVE CONTROLLER
            if (arg(1:7).eq.'rmfiles') then
               module(1:7) = 'rmfiles'
               have_command = .true.
            end if

c         o JOB ARCHIVE CONTROLLER
            if (arg(1:5).eq.'jasum') then
               module(1:5) = 'jasum'
               have_command = .true.
            end if

c         o I/O CONTROLLER
            if (arg(1:5).eq.'iosum') then
               module(1:5) = 'iosum'
               have_command = .true.
            end if

c         o 2-particle tau intermediate (T2+T1T1)
            if (arg(1:4).eq.'tau2') then
               module(1:4) = 'tau2'
               have_command = .true.
            end if

c   o end loop over arguments
c        end if (.not.have_command)
         end if
c     end do i = 1, num_args
      end do

c   o stop if there is no command
      if (.not.have_command) then
         write(*,*) '@INIT_A2PROC: The supplied arguments are not ',
     &              'recognized.\n'
         call exit(1)
      end if

c ----------------------------------------------------------------------

c VERIFY CONSISTENCY

c for most modules, JOBARC must exist
      inquire(file='JOBARC',exist=have_command)
      if (.not.have_command) then
         write(*,*) '@INIT_A2PROC: There is no JOBARC file, which ',
     &              'probably means'
         write(*,*) '              ACES2 has not been run.\n'
         call exit(1)
      end if

#ifdef _DEBUG
#endif

c ----------------------------------------------------------------------

#ifdef _TRACE_A2PROC
      write(*,*) '@A2PROC: Leaving file ', __FILE__
#endif

      return
      end

c This routine initializes the sympop common block, but isytyp is loaded in
c aces_io_init.

      subroutine aces_com_sympop
      implicit none

c INTERNAL VARIABLES
      integer i
      character*8 symlst(22)
      data symlst /'SVAVA0X', 'SVBVB0X',
     &             'SOAOA0X', 'SOBOB0X',
     &             'SVAVA1X', 'SVBVB1X',
     &             'SOAOA1X', 'SOBOB1X',
     &             'SVAOA2X', 'SVBOB2X',
     &             'SOBVA2X', 'SVBOA2X',
     &             'SVAVB2X', 'SOAOB2X',
     &             'SVAVB2X', 'SOAVA2X',
     &             'SOBVB2X', 'SOAVB2X',
     &             'SVAVA2X', 'SVBVB2X',
     &             'SOAOA2X', 'SOBOB2X'/

c COMMON BLOCKS
#include "sympop.com"
#include "syminf.com" /* for nirrep */

c ----------------------------------------------------------------------

      do i = 1, 22
         call getrec(-1,'JOBARC',symlst(i),nirrep,irpdpd(1,i))
      end do

      return
c     end subroutine aces_com_sympop
      end

c This routine initializes the sympop common block, but isytyp is loaded in
c aces_io_init.

      subroutine aces_com_sympop
      implicit none

c INTERNAL VARIABLES
      integer i
      character*8 symlst(22)
      data symlst /'SVAVA0X', 'SVBVB0X',
     &             'SOAOA0X', 'SOBOB0X',
     &             'SVAVA1X', 'SVBVB1X',
     &             'SOAOA1X', 'SOBOB1X',
     &             'SVAOA2X', 'SVBOB2X',
     &             'SOBVA2X', 'SVBOA2X',
     &             'SVAVB2X', 'SOAOB2X',
     &             'SVAVB2X', 'SOAVA2X',
     &             'SOBVB2X', 'SOAVB2X',
     &             'SVAVA2X', 'SVBVB2X',
     &             'SOAOA2X', 'SOBOB2X'/

c COMMON BLOCKS
c sympop.com : begin
      integer         irpdpd(8,22), isytyp(2,500), id(18)
      common /sympop/ irpdpd,       isytyp,        id
c sympop.com : end
c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end

c ----------------------------------------------------------------------

      do i = 1, 22
         call getrec(-1,'JOBARC',symlst(i),nirrep,irpdpd(1,i))
      end do

      return
c     end subroutine aces_com_sympop
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine clear_static_data_requests()
c----------------------------------------------------------------------------
c   Remove any outstanding mpi requests from sending the static data.
c----------------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'parallel_info.h'
      include 'proto_events.h'

      integer pst_get_company
      integer i, mpierr
      integer status(MPI_STATUS_SIZE)
      logical flag

      if (me .eq. 0) then
         do i = 1, nprocs
            if (pst_get_company(i-1) .ne. io_company_id) then 
               if (scfa_req(i) .ne. mpi_request_null) then
                  call mpi_test(scfa_req(i), flag, status, mpierr)
                  if (.not. flag) 
     *               call mpi_request_free(scfa_req(i), mpierr)
               endif

               if (scfb_req(i) .ne. mpi_request_null) then
                   call mpi_test(scfb_req(i), flag, status, mpierr)
                   if (.not. flag) 
     *                call mpi_request_free(scfb_req(i), mpierr)
               endif

               if (focka_req(i) .ne. mpi_request_null) then
                   call mpi_test(focka_req(i), flag, status, mpierr)
                   if (.not. flag)  
     *                call mpi_request_free(focka_req(i), mpierr)
               endif

               if (fockb_req(i) .ne. mpi_request_null) then
                   call mpi_test(fockb_req(i), flag, status, mpierr)
                   if (.not. flag)
     *                call mpi_request_free(fockb_req(i), mpierr)
               endif

               if (epsa_req(i) .ne. mpi_request_null) then
                   call mpi_test(epsa_req(i), flag, status, mpierr)
                   if (.not. flag)
     *                call mpi_request_free(epsa_req(i), mpierr)
               endif

               if (epsb_req(i) .ne. mpi_request_null) then
                  call mpi_test(epsb_req(i), flag, status, mpierr)
                   if (.not. flag)
     *                call mpi_request_free(epsb_req(i), mpierr)
               endif
            endif
         enddo
      endif

      return
      end

c This program takes command-line arguments and executes subroutines
c accordingly. Essentially, it is a shell environment for processing
c data generated by ACES2.

c#define _DIMARGS 3 /* 3 args required by jarec */









































































































































































































































































































































































































































































































































      program main
      implicit none

c INTERNAL VARIABLES
      integer dimargs, iuhf
      character*80 module
      character*80 args(8)
      Logical OPTARC_EXIST

c COMMON BLOCKS


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end





c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end
c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c flags2.com : begin
      integer         iflags2(500)
      common /flags2/ iflags2
c flags2.com : end

c ----------------------------------------------------------------------

      dimargs = 8
      call a2proc_init(module,args,dimargs)

      if ((module(1:5).eq.'help ').or.(module(1:3).eq.'-h ')) then
         print '()'
         print *, 'ACESII PROCESSOR LIST OF USEABLE MODULES'
         print *, '----------------------------------------'
         print *, 'factor <numb> [ <numb> [ <numb> [ ... ]]]'
         print *, 'mem <amount>'
         print *, 'test <file> [ <file> [ <file> [ ... ]]]'
         print *, 'molden'
c         print *, 'gennbo'
         print *, 'hyperchem'
         print *, 'extrap (energy|gradient)'
         print *, 'statthermo'
         print *, 'parfd (update|updump|dump|load <file>)'
         print *, 'jarec datatype RECNAME dimension'
         print *, 'jareq datatype RECNAME dimension (the quiet version)'
         print *, 'jasum'
         print *, 'xyz'
         print *, 'iosum'
         print *, 'clrdirty'
         print *, 'zerorec RECNAME [ RECNAME [ RECNAME [ ... ]]]'
         print *, 'rmfiles'
         print '()'
         stop
      end if

c ----------------------------------------------------------------------

c These modules require nothing from ACES.

      if (module(1:7).eq.'factor ') then
         call factor(args,dimargs)
         goto 9999
      end if
c
      if (module(1:11).eq.'PES_scan ') then
CSSS         Streamin   = .true.
CSSS         Stationary = .true.
CSSS         Drive_IRC  = .true.
C These must be providded the calling program.
      
         call pes_scan_main(.False., .False., .True.)
         goto 9998
      endif

c ----------------------------------------------------------------------

c These modules require JOBARC, but do not require heap space or lists.

      call aces_init_rte
      call aces_com_parallel_aces
      call aces_ja_init
      call getrec(1,'JOBARC','IFLAGS', 100,iflags)
      call getrec(1,'JOBARC','IFLAGS2',500,iflags2)

      if (module(1:6).eq.'jasum ') then
         call aces_ja_summary
         goto 9999
      end if

      if (module(1:8).eq.'zerorec ') then
         call zerorec(args,dimargs)
         goto 9999
      end if

      if (module(1:9).eq.'clrdirty ') then
         call putrec(0,'JOBARC','DIRTYFLG',1,0)
         print *, '@A2PROC: The dirty flag is clear.'
         goto 9999
      end if

      if (module(1:4).eq.'xyz ') then
         call xyz
         goto 9999
      end if

      if (module(1:4).eq.'mem ') then
         call mem(args,dimargs)
         goto 9999
      end if

c ----------------------------------------------------------------------

c These modules require heap space, but do not require lists.

      icrsiz = iflags(36)
      icore(1) = 0
      do while ((icore(1).eq.0).and.(icrsiz.gt.1000000))
         call aces_malloc(icrsiz,icore,i0)
         if (icore(1).eq.0) icrsiz = icrsiz - 1000000
      end do
      if (icore(1).eq.0) then
         print *, '@MAIN: unable to allocate at least ',
     &            1000000,' integers of memory'
         call aces_exit(1)
      end if
C
C This call to xjoda (which should be in the directory where xaces3).
C In addition to the ACES_EXE_PATH usesrs must set the PATH to recignize
C the location of xjoda and xa2proc to do pre/post processing of 
C ACES III files set (JOBARC and JAINDX). 07/2013, Ajith Perera.
C
      Inquire(FILE='OPTARC',EXIST=OPTARC_EXIST)
      If (OPTARC_EXIST) Call runit("rm OPTARC")

      call runit("xjoda")
      call v2ja(icore(I0), icrsiz)

      if (module(1:5).eq.'test ') then
         call test(args,dimargs)
         goto 9998
      end if

      if (module(1:7).eq.'molden ') then
         call molden_main(args, dimargs)
         goto 9998
      end if

c This has not been audited.
      if (module(1:7).eq.'gennbo ') then
         call gennbo_main
         goto 9998
      end if

      if (module(1:10).eq.'hyperchem ') then
         call hyprchm_main
         goto 9998
      end if

      if (module(1:6).eq.'parfd ') then
         call parfd(args,dimargs)
         goto 9998
      end if

      if (module(1:6).eq.'jarec ') then
         call jarec(args,dimargs,.true.)
         goto 9998
      end if

      if (module(1:6).eq.'jareq ') then
         call jarec(args,dimargs,.false.)
         goto 9998
      end if

      if (module(1:7).eq.'extrap ') then
         call extrap_main(args, dimargs)
         goto 9998
      end if

      if (module(1:11).eq.'statthermo ') then
         call stat_thermo_main
         goto 9998
      endif 

      if (module(1:7).eq.'dplots ') then
         call den_plots_main(Icore(I0), icrsiz)
         goto 9998
      endif 
C
      if (module(1:7).eq.'a2rate ') then
         call a2rate_main(Icore(I0), icrsiz)
         goto 9998
      endif
C
      if (module(1:11).eq.'vrcoupling ') then
         call vib_rot_coupl(Icore(I0), icrsiz)
         goto 9998
      endif
C
      if (module(1:4).eq.'qta ') then
         call qntm_topl_main(Icore(I0), icrsiz)
         goto 9998
      endif
C      
      if (module(1:7).eq.'wrtprm ') then
         call Wrt_prim_main(Icore(I0), icrsiz)
         goto 9998
      endif
      
      if (module(1:8).eq.'rdfile ') then
         call read_file_main(Icore(I0), icrsiz)
         goto 9998
      endif

      if (module(1:9).eq.'symadapt ') then
         Write(6,*) "Entering sym-adaptation"
         call a3_symadapt_main(Icore(I0), icrsiz)
         goto 9998
      endif

C
C      if (module(1:8).eq.'polyrate') then
C         call polyrate_main(Icore(I0), icrsiz)
C         goto 9998
C      endif
c ----------------------------------------------------------------------

c These modules require lists.

      call aces_io_init(icore,i0,icrsiz,.true.)

      if (module(1:6).eq.'iosum ') then
         call aces_io_summary
         goto 9997
      end if

      if (module(1:8).eq.'rmfiles ') then
         call aces_io_remove(50,'MOINTS')
         call aces_io_remove(51,'GAMLAM')
         call aces_io_remove(52,'MOABCD')
         call aces_io_remove(53,'DERINT')
         call aces_io_remove(54,'DERGAM')
         print *, '@A2PROC: Successfully removed list files.'
         goto 9997
      end if
c
      if (module(1:8) .eq. 'recovery') then
          call aces_init_chemsys
          call aces_io_recovery
          goto 9997
      endif
c ----------------------------------------------------------------------

 9997 continue
      call aces_io_fin
 9998 continue
c      call c_free(icore)
 9999 continue
      call aces_ja_fin
C
      call c_exit(0)
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_NBO_X_CENTERS
     +
     +                    ( NBAS,NHCEN,NOCC,
     +                      BONDSIZE,NBOSIZE,
     +                      MXNBA,
     +                      ATNHB,ATHOFF,
     +                      NHB,NHA,
     +                      OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,
     +                      NHOCEN,NHOIDX,
     +                      WBOND,WSTAR,
     +                      WRYD,WOCC,
     +                      C,
     +                      PH,
     +                      H,
     +                      IVEC,
     +
     +                              NBO,
     +                              NLB,NBB,NEB,NAB,NYB,
     +                              COLMAP,
     +                              B,
     +                              W,
     +                              BDSIZE,
     +                              BDATOM,
     +                              CNBO )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_NBO_X_CENTERS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine combines a specific set of NHOs to form
C                the NBOs by diagonalizing the occupation submatrix part
C                of the hybrid occupation matrix PH in terms of the
C                selected NHO set. The dimension of this submatrix will
C                be equal to the dimension NHCEN of the chosen set of
C                NHOs. Diagonalization of the submatrix will generate a
C                set of highly occupied NBOs (bond orbitals) and a set
C                of lower occupied NBOs (anti-bond orbitals). The number
C                of bond orbitals on more than one center will be
C                checked against the expected one, and an error message
C                will be issued if they don't match.
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NHCEN        =  # of atomic hybrid centers to be
C                                    used for bond construction.
C                    NOCC         =  expected # of highly occupied NBOs.
C                    BONDSIZE     =  maximum # of atomic centers that
C                                    are allowed to form a bond.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    ATNHB (A)    =  # of Hybrid NAOs on hybrid atom A.
C                    ATHOFF (A)   =  index offset for Hybrid NAOs for
C                                    hybrid atom A. This index is equal
C                                    to the total number of Hybrid
C                                    NAOs on all hybrid atoms preceeding
C                                    hybrid atom A.
C                    NHB          =  total # of Hybrid NAOs
C                    NHA          =  total # of hybrid atoms
C                    OFFx         =  offsets to protect overwriting
C                                    of column map indices for the
C                                    Lone-pair, Bond, Empty-pair,
C                                    Antibond and Rydberg NBOs
C                                    (x=LP,BD,EP,AB,RY) in column
C                                    map array COLMAP.
C                    NHOCEN (I)   =  atomic center index for I-th NHO
C                                    of the set of NHCEN NHOs.
C                    NHOIDX (I)   =  global NHO index for I-th NHO
C                                    of the set of NHCEN NHOs.
C                    WBOND        =  lowest weight criterion for each
C                                    NHCEN-center bond.
C                    WSTAR        =  highest weight criterion for each
C                                    NHCEN-center antibond.
C                    WRYD         =  highest weight below which a one-
C                                    center bond is classified as an
C                                    atomic Rydberg NBO.
C                    WOCC         =  the weight limit to decide when
C                                    a NBO is considered occupied or
C                                    virtual.
C                    C            =  NBAS x NHB part of the NAO
C                                    coefficient matrix in AO basis.
C                    PH           =  NHB x NHB valence occupation matrix
C                                    over NAOs.
C                    H (I,J)      =  MXNBA x NHB matrix containing the
C                                    atomic NHOs. I is the local atomic
C                                    index labeling the atomic Hybrid
C                                    NAOs from which the NHOs are
C                                    constructed. J is the global NHO
C                                    index running over all NHB NHOs,
C                                    with all NHOs belonging to a
C                                    specific atomic center being
C                                    grouped together.
C                    IVEC         =  int scratch array of vector type
C
C
C                  Output:
C
C                    NBO          =  current total # of NBOs processed.
C                    NxB          =  current # of Lone-pair, Bond,
C                                    Empty-pair, Antibond and Rydberg
C                                    NBOs found (x=L,B,E,A,Y).
C                    COLMAP (I)   =  contains the current portion of the
C                                    column map in the active sense for
C                                    the NBO ordering NHB -> NLB/NBB/
C                                    NEB/NAB/NYB such that COLMAP (I)
C                                    contains the position index (with
C                                    added offsets for temporary
C                                    protection!) of the I-th NBO in
C                                    the NLB/NBB/NEB/NAB/NYB order.
C                    B (I,J)      =  NBOSIZE x NHCEN matrix containing
C                                    the J-th NBO expansion coefficients
C                                    in terms of the I-th atomic NHOs
C                                    forming the J-th NBO.
C                    W            =  NHCEN part of the NBO weights.
C                    BDSIZE       =  full NBO bond size vector, updated
C                                    by the current NHCEN part.
C                    BDATOM       =  full NBO atomic index map array,
C                                    updated by the current NHCEN part.
C                    CNBO         =  current NHCEN part of the NBO
C                                    coefficient matrix in AO basis.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     REVERS

         INTEGER     ATOM,ATOMI,ATOMJ
         INTEGER     BONDSIZE,NBOSIZE
         INTEGER     I,J,K,L,N
         INTEGER     KDIM,LDIM,DIM
         INTEGER     KOFF,LOFF,OFF
         INTEGER     MXNBA
         INTEGER     NAO,NBO
         INTEGER     NBAS
         INTEGER     NBBOLD
         INTEGER     NHO,NHOI,NHOJ
         INTEGER     NITER
         INTEGER     NLB,NBB,NEB,NAB,NYB
         INTEGER     NOCC
         INTEGER     NHB,NHA
         INTEGER     NHCEN
         INTEGER     OFFLP,OFFBD,OFFEP,OFFAB,OFFRY

         INTEGER     ATNHB   (1:NHA  )
         INTEGER     ATHOFF  (1:NHA  )
         INTEGER     BDSIZE  (1:NBAS )
         INTEGER     COLMAP  (1:NHB  )
         INTEGER     IVEC    (1:NHCEN)
         INTEGER     NHOCEN  (1:NHCEN)
         INTEGER     NHOIDX  (1:NHCEN)

         INTEGER     BDATOM  (1:NBAS,1:BONDSIZE)

         DOUBLE PRECISION  SUM,SUM1,SUM2
         DOUBLE PRECISION  WEIGHT,WBOND,WSTAR,WRYD,WOCC
         DOUBLE PRECISION  X,Y
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  W     (1:NHCEN )

         DOUBLE PRECISION  B     (1:NBOSIZE,1:NHCEN )
         DOUBLE PRECISION  C     (1:NBAS   ,1:NHB   )
         DOUBLE PRECISION  CNBO  (1:NBAS   ,1:NHCEN )
         DOUBLE PRECISION  H     (1:MXNBA  ,1:NHB   )
         DOUBLE PRECISION  PH    (1:NHB    ,1:NHB   )

         DATA  ONE      /1.D0/
         DATA  ZERO     /0.D0/
         DATA  REVERS   /.TRUE./
C
C
C------------------------------------------------------------------------
C
C
C             ...handle one-center case separately to obtain the
C                Lone-pairs, Empty-pairs and Rydberg NBOs.
C
C
         IF (NHCEN.EQ.1) THEN

             NHO = NHOIDX (1)
             ATOM = NHOCEN (1)
             DIM = ATNHB (ATOM)
             OFF = ATHOFF (ATOM)

             WEIGHT = ZERO
             DO L = 1,DIM
                SUM = ZERO
                DO K = 1,DIM
                   SUM = SUM + H (K,NHO) * PH (OFF+K,OFF+L)
                END DO
                WEIGHT = WEIGHT + SUM * H (L,NHO)
             END DO

             W (1) = WEIGHT
             B (1,1) = ONE

             NBO = NBO + 1
             BDSIZE (NBO) = 1
             BDATOM (NBO,1) = ATOM

             IF (WEIGHT.LT.WRYD) THEN
                 NYB = NYB + 1
                 COLMAP (NBO) = NYB + OFFRY
             ELSE IF (WEIGHT.LT.WSTAR) THEN
                 NEB = NEB + 1
                 COLMAP (NBO) = NEB + OFFEP
             ELSE IF (WEIGHT.LT.WOCC) THEN
                 WRITE (*,*) ' WARNING! High occupation Empty-pair! '
                 WRITE (*,*) ' WEIGHT = ',WEIGHT,' ( > ',WSTAR,' ) '
                 WRITE (1,*) ' WARNING! High occupation Empty-pair! '
                 WRITE (1,*) ' WEIGHT = ',WEIGHT,' ( > ',WSTAR,' ) '
                 NEB = NEB + 1
                 COLMAP (NBO) = NEB + OFFEP
             ELSE IF (WEIGHT.LT.WBOND) THEN
                 WRITE (*,*) ' WARNING! Low occupation Lone-pair! '
                 WRITE (*,*) ' WEIGHT = ',WEIGHT,' ( < ',WBOND,' ) '
                 WRITE (1,*) ' WARNING! Low occupation Lone-pair! '
                 WRITE (1,*) ' WEIGHT = ',WEIGHT,' ( < ',WBOND,' ) '
                 NLB = NLB + 1
                 COLMAP (NBO) = NLB + OFFLP
             ELSE
                 NLB = NLB + 1
                 COLMAP (NBO) = NLB + OFFLP
             END IF

             CALL  MAT__W_EQ_ZERO_FLOAT
     +
     +                  ( NBAS,
     +                    NBAS,
     +
     +                            CNBO (1,1) )
     +
     +
             DO K = 1,DIM
                NAO = OFF + K
                X = H (K,NHO)
                DO N = 1,NBAS
                   CNBO (N,1) = CNBO (N,1) + X * C (N,NAO)
                END DO
             END DO

         ELSE
C
C
C             ...the multicenter case to obtain Bonds and Antibonds.
C                Calculate lower triangle of B matrix in NHO basis
C                from the PH matrix in NAO basis. This B matrix will
C                hold temporarily the appropriate submatrix of PH.
C
C
             DO J = 1,NHCEN
                NHOJ = NHOIDX (J)
                ATOMJ = NHOCEN (J)
                LDIM = ATNHB (ATOMJ)
                LOFF = ATHOFF (ATOMJ)

                DO I = J,NHCEN
                   NHOI = NHOIDX (I)
                   ATOMI = NHOCEN (I)
                   KDIM = ATNHB (ATOMI)
                   KOFF = ATHOFF (ATOMI)

                   SUM1 = ZERO
                   DO L = 1,LDIM
                      SUM2 = ZERO
                      DO K = 1,KDIM
                         SUM2 = SUM2 + H (K,NHOI) * PH (KOFF+K,LOFF+L)
                      END DO
                      SUM1 = SUM1 + SUM2 * H (L,NHOJ)
                   END DO

                   B (I,J) = SUM1

                END DO
             END DO
C
C
C             ...diagonalize B matrix.
C
C
             CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                    ( 1,
     +                      ' B matrix ',
     +                      NBOSIZE,NHCEN,
     +                      NHCEN,0,
     +                      B )
     +
     +
             CALL  MAT__C_EQ_A_FLOAT
     +
     +                  ( NBOSIZE,NHCEN,
     +                    NBAS,NHCEN,
     +                    NHCEN,NHCEN,
     +                    B,
     +
     +                            CNBO )
     +
     +
             CALL  NLO__SYMMETRIC_JACOBI
     +
     +                  ( NBAS,NHCEN,
     +                    NBOSIZE,NHCEN,
     +                    NHCEN,
     +                    NHCEN,
     +                    1,NHCEN,
     +                    REVERS,
     +                    IVEC,
     +                    CNBO,
     +
     +                            NITER,
     +                            W,
     +                            B )
     +
     +
C             CALL  MAT__DIAGONALIZE_REAL_SYMMETRIC
C     +
C     +                  ( NBOSIZE,NHCEN,NHCEN,
C     +                    NHCEN,
C     +                    REVERS,
C     +
C     +                            W,
C     +                            B )
C     +
C     +
             CALL    MAT__PRINT_V_FLOAT_12_NOZEROS
     +
     +                    ( 1,
     +                      ' Eigenvalues of B matrix ',
     +                      NHCEN,
     +                      NHCEN,
     +                      W )
     +
     +
             CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                    ( 1,
     +                      ' Eigenfunctions of B matrix ',
     +                      NBOSIZE,NHCEN,
     +                      NHCEN,NHCEN,
     +                      B )
     +
     +
C
C
C             ...form the current Bonds/Antibonds set.
C
C
             NBBOLD = NBB

             CALL  MAT__C_EQ_ZERO_FLOAT
     +
     +                  ( NBAS,NHCEN,
     +                    NBAS,NHCEN,
     +
     +                            CNBO )
     +
     +
             DO J = 1,NHCEN
                NBO = NBO + 1
                BDSIZE (NBO) = NHCEN

                WEIGHT = W (J)

                IF (WEIGHT.LT.WSTAR) THEN
                    NAB = NAB + 1
                    COLMAP (NBO) = NAB + OFFAB
                ELSE IF (WEIGHT.LT.WOCC) THEN
                    WRITE (*,*) ' WARNING! High occupation Antibond! '
                    WRITE (*,*) ' WEIGHT = ',WEIGHT,' ( > ',WSTAR,' ) '
                    WRITE (1,*) ' WARNING! High occupation Antibond! '
                    WRITE (1,*) ' WEIGHT = ',WEIGHT,' ( > ',WSTAR,' ) '
                    NAB = NAB + 1
                    COLMAP (NBO) = NAB + OFFAB
                ELSE IF (WEIGHT.LT.WBOND) THEN
                    WRITE (*,*) ' WARNING! Low occupation Bond! '
                    WRITE (*,*) ' WEIGHT = ',WEIGHT,' ( < ',WBOND,' ) '
                    WRITE (1,*) ' WARNING! Low occupation Bond! '
                    WRITE (1,*) ' WEIGHT = ',WEIGHT,' ( < ',WBOND,' ) '
                    NBB = NBB + 1
                    COLMAP (NBO) = NBB + OFFBD
                ELSE
                    NBB = NBB + 1
                    COLMAP (NBO) = NBB + OFFBD
                END IF

                DO I = 1,NHCEN
                   NHO = NHOIDX (I)
                   ATOM = NHOCEN (I)
                   KDIM = ATNHB (ATOM)
                   KOFF = ATHOFF (ATOM)

                   X = B (I,J)
                   DO K = 1,KDIM
                      NAO = KOFF + K
                      Y = X * H (K,NHO)
                      DO N = 1,NBAS
                         CNBO (N,J) = CNBO (N,J) + Y * C (N,NAO)
                      END DO
                   END DO

                   BDATOM (NBO,I) = ATOM

                END DO
             END DO
C
C
C             ...check, if current # of NBO bonds matches the
C                expected results.
C
C
             IF ((NBB-NBBOLD).NE.NOCC) THEN
                 WRITE (*,*) ' # of Bond NBOs mismatch! '
                 WRITE (*,*) ' Current #, expected # = ',NBB-NBBOLD,NOCC
                 WRITE (*,*) ' nlo__form_nbo_x_centers '
                 WRITE (1,*) ' # of Bond NBOs mismatch! '
                 WRITE (1,*) ' Current #, expected # = ',NBB-NBBOLD,NOCC
                 WRITE (1,*) ' nlo__form_nbo_x_centers '
                 STOP
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c   is performed.
      subroutine contract_blocks(x1handle, x1_block, x1_ndx,
     *                      x2handle, x2_block, x2_ndx,
     *                      yhandle, y_block, y_ndx, cind, ncind,
     *                      array_table, narray_table,
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, block_map_table,
     *                      flopcount)
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'machine_types.h'
      include 'saved_data.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table
      integer nscalar_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table) 
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      integer block_map_table(*)
      integer ncind, cind(ncind)
      integer x1handle, x2handle, yhandle
      integer x1_block, x2_block, y_block 
      integer x1_ndx, x2_ndx, y_ndx
      integer flopcount
      integer iseq

      integer n1, n2, ny
      integer nw, iseg, range1, range2
      integer*8 iy, ix1, ix2, daddr
      integer*8 get_block_index, get_index_from_base
      integer ystack, x1stack, x2stack
      integer i, j, k
      integer ind(4,3)
      integer x1_type, x2_type, ytype
      integer nwblock
      double precision value

      double precision y(1), x1(1), x2(1)
#ifdef ALTIX
      pointer (yptr, y)
      pointer (x1ptr, x1)
      pointer (x2ptr, x2)
      pointer (scr_ptr, scr)
#else
      common y, x1, x2
#endif

      integer indy(mx_array_index), segy(mx_array_index), 
     *        ya(mx_array_index), yb(mx_array_index)
      integer indx1(mx_array_index), segx1(mx_array_index), 
     *        x1a(mx_array_index), x1b(mx_array_index)
      integer indx2(mx_array_index), segx2(mx_array_index), 
     *        x2a(mx_array_index), x2b(mx_array_index)
      integer nya(mx_array_index), nyb(mx_array_index), 
     *        nx1a(mx_array_index), nx1b(mx_array_index), 
     *        nx2a(mx_array_index), nx2b(mx_array_index)

      integer handle1, handle2, handle3, istat
      integer allocate_scratch_block
      integer*8 iscr1, iscr2, iscr3
      integer*8 c_loc64, n
      double precision scr(1)
      save handle1, handle2, handle3
      save iscr1, iscr2, iscr3

#ifdef ALTIX
      yptr = dshptr
      x1ptr = dshptr
      x2ptr = dshptr
      scr_ptr = dshptr
#endif

c     call check_stack_pop(array_table, narray_table, index_table, 
c    *                     nindex_table, block_map_table) 
      if (first_contract_blocks) then
         first_contract_blocks = .false.
 
c------------------------------------------------------------------------
c   Allocate 3 scratch blocks for the 2-index contraction routines.
c------------------------------------------------------------------------

         istat = allocate_scratch_block(scr, iscr1, handle1,
     *                           array_table, narray_table,
     *                           index_table, nindex_table, 
     *                           block_map_table)
         if (istat .ne. 0) then
            print *,'Error: Unable to allocate scratch blocks.'
            call abort_job()
         endif

         istat = allocate_scratch_block(scr, iscr2, handle2,
     *                           array_table, narray_table,
     *                           index_table, nindex_table,
     *                           block_map_table)
         if (istat .ne. 0) then
            print *,'Error: Unable to allocate scratch blocks.'
            call abort_job()
         endif

         istat = allocate_scratch_block(scr, iscr3, handle3,
     *                           array_table, narray_table,
     *                           index_table, nindex_table,
     *                           block_map_table)
         if (istat .ne. 0) then
            print *,'Error: Unable to allocate scratch blocks.'
            call abort_job()
         endif
      endif

c      print *,'CONTRACT_BLOCKS: x1 = ',x1handle,' x1_block = ',x1_block,
c     *        ' x2 = ',x2handle,' x2_block = ',x2_block,' y = ',yhandle,
c     *        ' y_block = ',y_block,' indices = ',(cind(i),i=1,ncind)

      if ((ytype.eq.scalar_value) .and. (x1_type.eq.scalar_value) .and. 
     *    (x2_type.eq.scalar_value)) then 
        write(6,*) 'Scalar only mult being skipped ' 
        return 
      endif 

      flopcount = 0

c------------------------------------------------------------------------
c   Chcek for any scalar operands.
c------------------------------------------------------------------------

      x1_type = array_table(c_array_type,x1handle)
      x2_type = array_table(c_array_type,x2handle)
      ytype   = array_table(c_array_type,yhandle)

      x1stack = array_table(c_array_stack,x1handle)
      x2stack = array_table(c_array_stack,x2handle)
      ystack  = array_table(c_array_stack,yhandle)

      if (x1_type .eq. scalar_value) then
         value = scalar_table(array_table(c_scalar_index,x1handle))

         if (x2_type .eq. static_array .or.
     *       ytype   .eq. static_array) then
            call multiply_static_block(x2handle, x2_block, x2_ndx,
     *                value, yhandle, y_block, y_ndx,
     *                array_table, narray_table,
     *                index_table, nindex_table, 
     *                segment_table, nsegment_table,
     *                address_table)
         else
            call get_actual_blocksize(x2handle, x2_block, x2_ndx,
     *              array_table, narray_table,
     *              index_table, nindex_table,
     *              segment_table, nsegment_table, nwblock)
            
            call multiply_block(x2handle, x2_block, x2stack, x2_ndx,  
     *                       value, yhandle, y_block, ystack, 
     *                       y_ndx, nwblock)
         endif
         return
      else if (x2_type .eq. scalar_value) then
         value = scalar_table(array_table(c_scalar_index,x2handle))
         if (x1_type .eq. static_array .or.
     *       ytype   .eq. static_array) then
            call multiply_static_block(x1handle, x1_block, x1_ndx,
     *                value, yhandle, y_block, y_ndx,
     *                array_table, narray_table,
     *                index_table, nindex_table,
     *                segment_table, nsegment_table,
     *                address_table)
         else
            call get_actual_blocksize(x1handle, x1_block, x1_ndx,
     *              array_table, narray_table,
     *              index_table, nindex_table,
     *              segment_table, nsegment_table, nwblock)
            call multiply_block(x1handle, x1_block, x1stack, x1_ndx,  
     *                       value, yhandle, y_block, ystack,
     *                       y_ndx, nwblock)
         endif
         return
      endif

c-------------------------------------------------------------------------
c   Block contraction operation.
c-------------------------------------------------------------------------

      n1 = array_table(c_nindex, x1handle)
      n2 = array_table(c_nindex, x2handle)
      ny = array_table(c_nindex, yhandle)

c---------------------------------------------------------------------------
c   Get the array segments and ranges of each block.
c---------------------------------------------------------------------------

      if (ytype .eq. scalar_value) go to 100

      do i = 1, ny
         indy(i) = array_table(c_index_array1+i-1, yhandle)
         segy(i) = index_table(c_current_seg,indy(i))
         call get_index_segment(indy(i), segy(i), segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, ya(i), yb(i))  
      enddo

      if (ytype .eq. static_array) then
         daddr = address_table(yhandle)
         if (daddr .eq. 0) then
            print *,'Error: Cannot form address for array ',yhandle,
     *                ' block ',y_block,'.'
            call dump_block_ids()
            call abort_job()
         endif

         iy = get_index_from_base(daddr, y, 2)

         do i = 1, ny
            nya(i) = array_table(c_index_range1+i-1,yhandle)
            nyb(i) = array_table(c_index_range2+i-1,yhandle)
         enddo
      else
         iy = get_block_index(yhandle, y_block, ystack, 
     *                        y_ndx, y, .true.)
         do i = 1, ny
            nya(i) = ya(i)
            nyb(i) = yb(i)
         enddo
      endif

  100 continue

      do i = 1, n1
         indx1(i) = array_table(c_index_array1+i-1, x1handle)
         segx1(i) = index_table(c_current_seg,indx1(i))
         call get_index_segment(indx1(i), segx1(i), segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, x1a(i), x1b(i))  
      enddo

      if (x1_type .eq. static_array) then
         daddr = address_table(x1handle)
         if (daddr .eq. 0) then
            print *,'Error: Cannot form address for array ',x1handle,
     *                ' block ',x1_block,'.'
            call dump_block_ids()
            call abort_job()
         endif

         ix1 = get_index_from_base(daddr, x1, 2)
         do i = 1, n1
            nx1a(i) = array_table(c_index_range1+i-1,x1handle)
            nx1b(i) = array_table(c_index_range2+i-1,x1handle)
         enddo
      else
         ix1 = get_block_index(x1handle, x1_block, x1stack,
     *                         x1_ndx, x1, .true.)
         do i = 1, n1
            nx1a(i) = x1a(i)
            nx1b(i) = x1b(i)
         enddo
      endif

      do i = 1, n2
         indx2(i) = array_table(c_index_array1+i-1, x2handle)
         segx2(i) = index_table(c_current_seg,indx2(i))
         call get_index_segment(indx2(i), segx2(i), segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, x2a(i), x2b(i))  
      enddo

      if (x2_type .eq. static_array) then
         daddr = address_table(x2handle)
         if (daddr .eq. 0) then
            print *,'Error: Cannot form address for array ',x2handle,
     *                ' block ',x2_block,'.'
            call dump_block_ids()
            call abort_job()
         endif

         ix2 = get_index_from_base(daddr, x2, 2)
         do i = 1, n2
            nx2a(i) = array_table(c_index_range1+i-1,x2handle)
            nx2b(i) = array_table(c_index_range2+i-1,x2handle)
         enddo
      else
         ix2 = get_block_index(x2handle, x2_block, x2stack,
     *                         x2_ndx, x2, .true.)
         do i = 1, n2
            nx2a(i) = x2a(i)
            nx2b(i) = x2b(i)
         enddo
      endif

c      print *,'Contract_blocks: '
c      print *,'indy: ',(indy(j),j=1,ny)
c      print *,'indx1: ',(indx1(j),j=1,n1)
c      print *,'indx2: ',(indx2(j),j=1,n2)
c      print *,'cind: ',(cind(j),j=1,ncind)

c----------------------------------------------------------------------------
c   Determine the array in which the first index of "y" is found.
c   This determines the order of the operand arrays in some of the
c   calls to low-order contraction routines.
c----------------------------------------------------------------------------

      iseq = 2
      do i = 1, n1
         if (indy(1) .eq. indx1(i)) iseq = 1
      enddo

      if (ny .eq. 2) then
         if (n1 .eq. 4 .and. n2 .eq. 2) then
            if (trace .and.
     *          and(tracelevel,contraction_trace) .ne. 0) 
     *          print *,'cwork2422 at instruction ',current_line

            call cwork2422(y(iy), nya(1), nyb(1), nya(2), nyb(2),
     *                     ya(1), yb(1), ya(2), yb(2),
     *                     indy(1), indy(2), x1(ix1), 
     *                     nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *                     nx1a(3), nx1b(3), nx1a(4), nx1b(4),
     *                     x1a(1),x1b(1),
     *                     x1a(2),x1b(2), x1a(3),x1b(3),x1a(4),x1b(4),
     *                     indx1,
     *                     x2(ix2),nx2a(1), nx2b(1), nx2a(2), nx2b(2), 
     *                     x2a(1), x2b(1), x2a(2), x2b(2), 
     *                     indx2(1), indx2(2),   
     *                     scr(iscr1), scr(iscr2), flopcount)


c-------------------------2311 contraction---------------------------------


         else if (n1 .eq. 3 .and. n2 .eq. 1) then

             call cwork2311(y(iy), nya(1), nyb(1), nya(2), nyb(2),
     *                     ya(1), yb(1), ya(2), yb(2),
     *                     indy(1), indy(2), x1(ix1),
     *                     nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *                     nx1a(3), nx1b(3),
     *                     x1a(1),x1b(1),
     *                     x1a(2),x1b(2), x1a(3),x1b(3),
     *                     indx1,
     *                     x2(ix2),nx2a(1), nx2b(1),
     *                     x2a(1), x2b(1),
     *                     indx2(1),
     *                     scr(iscr1), scr(iscr2), flopcount)

c---------------------------------------------------------------------------
c   Reverse the args, call cwork_2422.
c---------------------------------------------------------------------------

         else if (n1 .eq. 2 .and. n2 .eq. 4) then
            call cwork2422(y(iy), nya(1), nyb(1), nya(2), nyb(2),
     *                     ya(1), yb(1), ya(2), yb(2),
     *                     indy(1), indy(2), x2(ix2),
     *                     nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *                     nx2a(3), nx2b(3), nx2a(4), nx2b(4),
     *                     x2a(1),x2b(1),
     *                     x2a(2),x2b(2), x2a(3),x2b(3),x2a(4),x2b(4),
     *                     indx2,
     *                     x1(ix1),nx1a(1), nx1b(1), nx1a(2), nx1b(2),
     *                     x1a(1), x1b(1), x1a(2), x1b(2),
     *                     indx1(1), indx1(2),
     *                     scr(iscr1), scr(iscr2), flopcount)
         else if (n1 .eq. 2 .and. n2 .eq. 2 .and. ncind .eq. 1) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0) 
     *          print *,'cwork2221 at instruction ',current_line,
     *          ' iseq ',iseq
            if (iseq .eq. 1) then
               call cwork2221(y(iy), nya(1),nyb(1), nya(2),nyb(2),
     *              ya(1),yb(1), ya(2),yb(2),
     *              indy(1),indy(2),
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              x1a(1),x1b(1),x1a(2),x1b(2),
     *              indx1, x2(ix2), nx2a(1),
     *              nx2b(1),nx2a(2),nx2b(2),
     *              x2a(1), x2b(1), x2a(2),x2b(2), indx2(1),indx2(2), 
     *              scr(iscr1),scr(iscr2))
            else
               call cwork2221(y(iy), nya(1),nyb(1), nya(2),nyb(2),
     *              ya(1),yb(1), ya(2),yb(2),
     *              indy(1),indy(2),
     *              x2(ix2), nx2a(1),
     *              nx2b(1),nx2a(2),nx2b(2),
     *              x2a(1), x2b(1), x2a(2),x2b(2), indx2, 
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              x1a(1),x1b(1),x1a(2),x1b(2),indx1(1),indx1(2),
     *              scr(iscr1),scr(iscr2))
            endif

         else if (n1 .eq. 4 .and. n2 .eq. 4 .and. ncind .eq. 3) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork2443 at instruction ',current_line
            call cwork2443(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                     ya(1),yb(1),ya(2),yb(2),indy(1), indy(2),
     *                     x1(ix1),nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *                     nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *                     x1a(1),x1b(1),x1a(2),x1b(2),
     *                     x1a(3),x1b(3),x1a(4),x1b(4),indx1,
     *                     x2(ix2),nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *                     nx2a(3),nx2b(3),nx2a(4),nx2b(4),
     *                     x2a(1), x2b(1), x2a(2),x2b(2),
     *                     x2a(3), x2b(3), x2a(4),x2b(4),indx2,
     *                     flopcount,scr(iscr1),scr(iscr2))

         else if (n1 .eq. 6 .and. n2 .eq. 4 .and. ncind .eq. 4) then
c           return 
            call cwork2644(y(iy),nya(1),nyb(1),nya(2),nyb(2),
     *                     ya(1),yb(1),ya(2),yb(2),indy(1), indy(2),

     *                     x1(ix1),nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *                     nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *                     nx1a(5),nx1b(5),nx1a(6),nx1b(6),
     *                     x1a(1),x1b(1),x1a(2),x1b(2),
     *                     x1a(3),x1b(3),x1a(4),x1b(4),
     *                     x1a(5),x1b(5),x1a(6),x1b(6),indx1,

     *                     x2(ix2),nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *                     nx2a(3),nx2b(3),nx2a(4),nx2b(4),
     *                     x2a(1), x2b(1), x2a(2),x2b(2),
     *                     x2a(3), x2b(3), x2a(4),x2b(4),indx2,
     *                     cind, 
     *                     flopcount,scr(iscr1),scr(iscr2),scr(iscr3))


         else
            print *,'Error: Invalid contraction'
            print *,'ny, n1, n2, ncind = ',ny, n1, n2, ncind
            call abort_job()
         endif
      else if (ny .eq. 1) then
         if ((n1 .eq. 3) .and. (n2 .eq. 2)) then

            call cwork1322(y(iy), nya(1), nyb(1), ya(1), yb(1),
     *                     indy(1), x1(ix1),
     *                     nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *                     nx1a(3), nx1b(3),
     *                     x1a(1),x1b(1),
     *                     x1a(2),x1b(2), x1a(3),x1b(3),
     *                     indx1,
     *                     x2(ix2),nx2a(1), nx2b(1), nx2a(2), nx2b(2),
     *                     x2a(1), x2b(1), x2a(2), x2b(2),
     *                     indx2(1), indx2(2),
     *                     scr(iscr1), scr(iscr2), flopcount)
         endif
         if ((n1 .eq. 2) .and. (n2 .eq. 1) .and. (ncind .eq. 1)) then
c            write(6,*) ' PERFORMING 1211 VFL ' 
               call cwork1211(y(iy),nya(1),nyb(1),
     *              ya(1),yb(1), indy(1),
c 
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              x1a(1),x1b(1),x1a(2),x1b(2),
     *              indx1,
c 
     *              x2(ix2), nx2a(1),nx2b(1), x2a(1),x2b(1),
     *              indx2, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))
         endif
c
      else if (ny .eq. 3) then
         if ((n1 .eq. 3) .and. (n2 .eq. 2) .and. (ncind .eq. 1)) then
            call cwork3321(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),  
     *              ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),
     *              indy(1),indy(2),indy(3),
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              indx1, x2(ix2), nx2a(1), nx2b(1),
     *              nx2a(2), nx2b(2), x2a(1),
     *              x2b(1),x2a(2),x2b(2), indx2(1),indx2(2), cind, 
     *              flopcount, scr(iscr1), scr(iscr2))
         elseif ((n1 .eq. 4) .and.(n2 .eq. 1) .and. (ncind .eq. 1)) then
            call cwork3411(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),
     *              ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),
     *              indy(1),indy(2),indy(3),
     *
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4) ,
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4),
     *              indx1, x2(ix2), nx2a(1), nx2b(1),
     *              x2a(1),  x2b(1), indx2(1), cind,
     *              flopcount, scr(iscr1), scr(iscr2))
            return
         endif

      else if (ny .eq. 4) then

         if ((n1 .eq. 3) .and. (n2 .eq. 3) .and. (ncind .eq. 1)) then
            call cwork4331(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),nya(4),nyb(4),  
     *              ya(1),yb(1),ya(2),yb(2),ya(3),yb(3),ya(4),yb(4),
     *              indy(1),indy(2),indy(3),indy(4),
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              indx1, x2(ix2), nx2a(1), nx2b(1),
     *              nx2a(2), nx2b(2), nx2a(3), nx2b(3), x2a(1),
     *              x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),
     *              indx2(1),indx2(2),indx2(3), cind, 
     *              flopcount, scr(iscr1), scr(iscr2))

         elseif (n1 .eq. 6 .and. n2 .eq. 4 .and. ncind .eq. 3) then
c           return 
            call cwork4643(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),nya(4),nyb(4), 
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),indy(1),indy(2),indy(3),indy(4),
  
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              nx1a(5),nx1b(5),nx1a(6),nx1b(6),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4),x1a(5),x1b(5),x1a(6),x1b(6), 
     *              indx1, 
  
     *              x2(ix2), nx2a(1), nx2b(1),
     *              nx2a(2), nx2b(2), 
     *              nx2a(3), nx2b(3), 
     *              nx2a(4), nx2b(4), 
     *              x2a(1), x2b(1),x2a(2),x2b(2), 
     *              x2a(3), x2b(3),x2a(4),x2b(4), 
  
     *              indx2, cind, 
     *              flopcount, scr(iscr1), scr(iscr2), scr(iscr3))

         elseif (n1 .eq. 6 .and. n2 .eq. 2 .and. ncind .eq. 2) then
c           return 
            call cwork4622(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),nya(4),nyb(4), 
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),indy(1),indy(2),indy(3),indy(4),
  
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              nx1a(5),nx1b(5),nx1a(6),nx1b(6),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4),x1a(5),x1b(5),x1a(6),x1b(6), 
     *              indx1, 
  
     *              x2(ix2), nx2a(1), nx2b(1),
     *              nx2a(2), nx2b(2), 
     *              x2a(1), x2b(1),x2a(2),x2b(2), 
  
     *              indx2, cind, 
     *              flopcount, scr(iscr1), scr(iscr2), scr(iscr3))


c-------------------------------------------------------------------------
c   Contracting into a 4-index output array.
c-------------------------------------------------------------------------

         elseif (n1 .eq. 4 .and. n2 .eq. 2 .and. ncind .eq. 1) then
            if (trace .and. 
     *          and(tracelevel, contraction_trace) .ne. 0) 
     *         print *,'cwork4421 at instruction ',current_line

c VFL 
c Make sure that the first index of  x2 is contracted.  


            call cwork4421(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),nya(4),nyb(4), 
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),indy(1),indy(2),indy(3),indy(4),
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4), indx1, x2(ix2), nx2a(1), nx2b(1),
     *              nx2a(2), nx2b(2), x2a(1),
     *              x2b(1),x2a(2),x2b(2), indx2(1),indx2(2), cind, 
     *              flopcount, scr(iscr1), scr(iscr2))

c VFL 

         elseif (n1 .eq. 2 .and. n2 .eq. 4 .and. ncind .eq. 1) then
            if (trace .and. 
     *          and(tracelevel, contraction_trace) .ne. 0) 
     *         print *,'cwork4421 at instruction ',current_line

            call cwork4421(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3),nya(4),nyb(4), 
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),indy(1),indy(2),indy(3),indy(4),
     *              x2(ix2), nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *              nx2a(3),nx2b(3),nx2a(4),nx2b(4),
     *              x2a(1),x2b(1),x2a(2),x2b(2),x2a(3),x2b(3),
     *              x2a(4),x2b(4), indx2, 
     *              x1(ix1), nx1a(1), nx1b(1),
     *              nx1a(2), nx1b(2), x1a(1),
     *              x1b(1),x1a(2),x1b(2), indx1(1),indx1(2), cind, 
     *              flopcount, scr(iscr1), scr(iscr2))

         else if (n1 .eq. 4 .and. n2 .eq. 4 .and. ncind .eq. 2) then
             if (trace .and. 
     *           and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork4442 at instruction ',current_line

c--------------------------------------------------------------------------
c   The new cwork4442 always assumes the 1st index of "y" shows up in the
c   first operand array.  Therefore we must call it with the proper 
c   sequence of operands.
c--------------------------------------------------------------------------

            if (iseq .eq. 1) then
               call cwork4442(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),indy(1),indy(2),indy(3),indy(4),
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4), indx1, x2(ix2), 
     *              nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *              nx2a(4),nx2b(4),    
     *              x2a(1),
     *              x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),x2a(4),x2b(4),
     *              indx2, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))
            else
               call cwork4442(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),indy(1),indy(2),indy(3),indy(4),
     *              x2(ix2), nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *              nx2a(3),nx2b(3),nx2a(4),nx2b(4),
     *              x2a(1),x2b(1),x2a(2),x2b(2),x2a(3),x2b(3),
     *              x2a(4),x2b(4), indx2, x1(ix1),
     *              nx1a(1),nx1b(1),nx1a(2),nx1b(2),nx1a(3),nx1b(3),
     *              nx1a(4),nx1b(4),
     *              x1a(1),
     *              x1b(1),x1a(2),x1b(2), x1a(3),x1b(3),x1a(4),x1b(4),
     *              indx1, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))
            endif
         else
            print *,'Error: Invalid contraction'
            print *,'ny, n1, n2, ncind = ',ny, n1, n2, ncind
            call abort_job()
         endif
      else if (ny .eq. 6) then
         if (n1 .eq. 4 .and. n2 .eq. 4 .and. ncind .eq. 1) then
               call cwork6441(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4), nya(5),nyb(5),
     *              nya(6),nyb(6),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *              indy(1),indy(2),indy(3),indy(4),indy(5),indy(6),
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4), indx1, x2(ix2), 
     *              nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *              nx2a(4),nx2b(4),    
     *              x2a(1),
     *              x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),x2a(4),x2b(4),
     *              indx2, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))

         elseif (n1 .eq. 6 .and. n2 .eq. 4 .and. ncind .eq. 2) then
               call cwork6642(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4), nya(5),nyb(5),
     *              nya(6),nyb(6),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *              indy(1),indy(2),indy(3),indy(4),indy(5),indy(6),
c 
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              nx1a(5),nx1b(5),nx1a(6),nx1b(6),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4), x1a(5),x1b(5),
     *              x1a(6),x1b(6), indx1, 
c 
     *              x2(ix2), 
     *              nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *              nx2a(4),nx2b(4),    
     *              x2a(1),x2b(1),x2a(2),x2b(2),x2a(3),x2b(3),
     *              x2a(4),x2b(4),
     *              indx2, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))

         elseif (n1 .eq. 4 .and. n2 .eq. 6 .and. ncind .eq. 2) then
c         return 
               call cwork6642(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4), nya(5),nyb(5),
     *              nya(6),nyb(6),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *              indy(1),indy(2),indy(3),indy(4),indy(5),indy(6),
  
     *              x2(ix2), nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *              nx2a(3),nx2b(3),nx2a(4),nx2b(4),
     *              nx2a(5),nx2b(5),nx2a(6),nx2b(6),
     *              x2a(1),x2b(1),x2a(2),x2b(2),x2a(3),x2b(3),
     *              x2a(4),x2b(4), x2a(5),x2b(5),
     *              x2a(6),x2b(6), indx2, 
  
     *              x1(ix1), 
     *              nx1a(1),nx1b(1),nx1a(2),nx1b(2),nx1a(3),nx1b(3),
     *              nx1a(4),nx1b(4),    
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4),
     *              indx1, 
  
     *              cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))

         elseif (n1 .eq. 6 .and. n2 .eq. 2 .and. ncind .eq. 1) then
               call cwork6621(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4), nya(5),nyb(5),
     *              nya(6),nyb(6),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *              indy(1),indy(2),indy(3),indy(4),indy(5),indy(6),
c 
     *              x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *              nx1a(5),nx1b(5),nx1a(6),nx1b(6),
     *              x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *              x1a(4),x1b(4), x1a(5),x1b(5),
     *              x1a(6),x1b(6), indx1, 
c 
     *              x2(ix2), 
     *              nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *              x2a(1),x2b(1),x2a(2),x2b(2),
     *              indx2, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))

         elseif (n1 .eq. 2 .and. n2 .eq. 6 .and. ncind .eq. 1) then
               call cwork6621(y(iy),nya(1),nyb(1), nya(2),nyb(2),
     *              nya(3),nyb(3), nya(4),nyb(4), nya(5),nyb(5),
     *              nya(6),nyb(6),
     *              ya(1),yb(1), ya(2),yb(2),ya(3),yb(3),
     *              ya(4),yb(4),ya(5),yb(5),ya(6),yb(6),
     *              indy(1),indy(2),indy(3),indy(4),indy(5),indy(6),
c 
     *              x2(ix2), nx2a(1),nx2b(1),nx2a(2),nx2b(2),
     *              nx2a(3),nx2b(3),nx2a(4),nx2b(4),
     *              nx2a(5),nx2b(5),nx2a(6),nx2b(6),
     *              x2a(1),x2b(1),x2a(2),x2b(2),x2a(3),x2b(3),
     *              x2a(4),x2b(4), x2a(5),x2b(5),
     *              x2a(6),x2b(6), indx2, 
c 
     *              x1(ix1), 
     *              nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *              x1a(1),x1b(1),x1a(2),x1b(2),
     *              indx1, cind, flopcount, scr(iscr1), scr(iscr2),
     *              scr(iscr3))


         else
            print *,'Error: Invalid contraction'
            print *,'ny, n1, n2, ncind = ',ny, n1, n2, ncind
            call abort_job()
         endif
      else if (ytype .eq. scalar_value) then

c--------------------------------------------------------------------------
c   Contraction of all indices into a scalar result.
c   1. x1 and x2 must have the same number of indices.
c   2. All indices of x1, x2 must be contracted out (i.e., are present in 
c      array "cind".
c--------------------------------------------------------------------------

         if (n1 .ne. n2 .or. n1 .ne. ncind) then
            print *,'Error: Invalid contraction'
            print *,'   Indices must match for contraction ',
     *                  'into scalar'
            print *,'   Contracted arrays are ',x1handle,x2handle
            print *,'   Arrays have ',n1,n2,' indices'
            print *,'   Num. of contracted indices ',ncind
            call abort_job()
         endif 

         iy = array_table(c_scalar_index, yhandle)
         if (n1 .eq. 2) then
            if (trace .and. 
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork0222 at instruction ',current_line

            call cwork0222(scalar_table(iy), x1(ix1),
     *                  nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *                  x1a(1),x1b(1),
     *                  x1a(2),x1b(2),
     *                  indx1,
     *                  x2(ix2),nx2a(1), nx2b(1), nx2a(2), nx2b(2),
     *                  x2a(1), x2b(1), x2a(2), x2b(2),
     *                  indx2(1), indx2(2), flopcount)
         else if (n1 .eq. 4) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork0444 at instruction ',current_line
            call cwork0444(scalar_table(iy), 
     *           x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *           nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *           x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *           x1a(4),x1b(4), indx1, x2(ix2),
     *           nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *           nx2a(4),nx2b(4),
     *           x2a(1),
     *           x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),x2a(4),x2b(4),
     *           indx2, flopcount)
         else if (n1 .eq. 3) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork0333 at instruction ',current_line
            call cwork0333(scalar_table(iy),
     *           x1(ix1),nx1a(1),nx1b(1),nx1a(2),
     *           nx1b(2),nx1a(3),nx1b(3),
     *           x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *           indx1, x2(ix2),
     *           nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *           x2a(1),x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),
     *           indx2, flopcount)
         else if (n1 .eq. 1) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork0111 at instruction ',current_line
            call cwork0111(scalar_table(iy),
     *           x1(ix1),nx1a(1),nx1b(1),
     *           x1a(1),x1b(1),indx1, x2(ix2),
     *           nx2a(1),nx2b(1),x2a(1),x2b(1), 
     *           indx2, flopcount)
         else if (n1.eq.5) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork0555 at instruction ',current_line
            call cwork0555(scalar_table(iy),
     *           x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *           nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *           nx1a(5),nx1b(5),
     *           x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *           x1a(4),x1b(4),x1a(5),x1b(5),indx1,
     *           x2(ix2),
     *           nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *           nx2a(4),nx2b(4),nx2a(5),nx2b(5),
     *           x2a(1),x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),x2a(4),
     *           x2b(4),x2a(5),x2b(5), indx2, flopcount)
         else if (n1 .eq. 6) then
            if (trace .and.
     *          and(tracelevel, contraction_trace) .ne. 0)
     *          print *,'cwork0666 at instruction ',current_line
            call cwork0666(scalar_table(iy), 
     *           x1(ix1), nx1a(1),nx1b(1),nx1a(2),nx1b(2),
     *           nx1a(3),nx1b(3),nx1a(4),nx1b(4),
     *           nx1a(5),nx1b(5),nx1a(6),nx1b(6),
     *           x1a(1),x1b(1),x1a(2),x1b(2),x1a(3),x1b(3),
     *           x1a(4),x1b(4),x1a(5),x1b(5),x1a(6),x1b(6),indx1, 
     *           x2(ix2),
     *           nx2a(1),nx2b(1),nx2a(2),nx2b(2),nx2a(3),nx2b(3),
     *           nx2a(4),nx2b(4),nx2a(5),nx2b(5),nx2a(6),nx2b(6),
     *           x2a(1),
     *           x2b(1),x2a(2),x2b(2), x2a(3),x2b(3),x2a(4),x2b(4),
     *           x2a(5),x2b(5),x2a(6),x2b(6), 
     *           indx2, flopcount)
         else
            print *,'Error: Invalid scalar contraction'
            print *,'   n1, n2 = ',n1,n2
            call abort_job()
         endif

      else
         print *,'Error: Output of contraction must have 4 or less ',
     *           'indices, or be a scalar.'
         call abort_job()
      endif

      return
      end

      DOUBLE PRECISION FUNCTION ANGLE(A,B,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N),B(N)
      DTOR=DACOS(-1.D0)/180.D0
      Z = xdot(N,A,1,B,1)
C
C MAKE SURE A VALUE OF SLIGHTLY MORE THAN ONE DOES NOT GET PASSED
C  TO DACOS
C
      ANGLE=DACOSX(Z,1.D-10)/DTOR
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__XYZ_E0_DEF_BLOCKS
     +
     +                    ( ZMAX,
     +                      MOMENTX,MOMENTY,MOMENTZ,
     +                      NPGTOA,NPGTOB,
     +                      SHELLP,
     +                      NIJ,NRS,
     +                      NXYZT,
     +                      L1CACHE,NCTROW,
     +                      MEMORY,
     +
     +                              NIJBLK,
     +                              NPSIZE,NCSIZE,NWSIZE,
     +                              NINT1D,
     +                              MXPRIM,MNPRIM,
     +                              ZCBATCH,ZPBATCH,ZWORK,
     +                              ZNORMA,ZNORMB,
     +                              ZRHOAB,ZXP,ZYP,ZZP,
     +                              ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +                              ZINT1DX,ZINT1DY,ZINT1DZ,
     +                              ZSCRMX,ZSCRMY,ZSCRMZ,
     +                              ZXMINUS,ZYMINUS,ZZMINUS )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_E0_DEF_BLOCKS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the memory partitions for the
C                generation of the entire contracted (e|0) moment
C                batch. It determines the block size partitions (if any)
C                for the ij exponent paris of the whole primitive
C                [e|0] batch and returns pointers to the flp data
C                sections needed by the (e|0) generation.
C
C                The routine is also equipped with the possibility
C                of returning just the minimum / optimum flp memory
C                needed, without evaluating the (e|0) generation flp
C                pointers. This is useful for establishing just the
C                overall memory size needed for the (e|0) generation.
C                The keyword MEMORY has to be set true for this case
C                and obviously the value of ZMAX passed is irrelevant.
C
C
C                  Input:
C
C                    ZMAX         =  maximum flp memory
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x=A,B
C                    SHELLP       =  the shell sum A+B
C                    NIJ          =  total # of ij primitive index
C                                    pairs corresponding to the csh
C                                    pairs A,B
C                    NRS          =  total # of rs contraction index
C                                    pairs corresponding to the csh
C                                    pairs A,B
C                    NXYZT        =  total # of cartesian monomial
C                                    pairs
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    MOMENTx      =  if MOMENTx (x = X,Y,Z) is greater
C                                    than zero, then set aside memory
C                                    in SCRMTx
C                    MEMORY       =  if this keyword is true, the
C                                    routine will only determine the
C                                    minimum / optimum flp memory and
C                                    store these values into NPSIZE and
C                                    NCSIZE, respectively (see below)
C
C                  Output:
C
C                    NIJBLK       =  contains the block size for the
C                                    ij primitive indices in order to
C                                    perform efficient contractions.
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays.
C                                    If MEMORY is true, NPSIZE and
C                                    NCSIZE will contain respectively
C                                    the minimum and optimum flp memory
C                    NINT1D       =  space needed for the 1D X,Y,Z
C                                    integral arrays
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = max (i,j)
C                    MNPRIM       =  the minimum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = min (i,j)
C                    Z.....       =  pointers for space partition of
C                                    the flp array (see below)
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                 |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                   Zone 1: final (e|0) batch
C                   Zone 2: block [e|0]
C                   Zone 3 : complete set of A,B norms and complete
C                            set of AB exponential prefactors
C                   Zone 4 : i) scratch for block [e|0] generation
C                           ii) scratch for (e|0) generation
C
C
C                Memory allocation offsets for the primitive [e|0]
C                batches generation + contraction to (e|0):
C
C
C                  --- Zone 1 ---
C
C                   ZCBATCH = offset for contracted (e|0) batch
C
C                  --- Zone 2 ---
C
C                   ZPBATCH = offset for (blocked) [e|0] batch
C
C                  --- Zone 3 ---
C
C                   ZNORMA = offset for all A norms
C                   ZNORMB = offset for all B norms
C                   ZRHOAB = offset for all AB exponential prefactors
C
C                  --- Zone 4: for block [e|0] generation only ---
C
C                   ZPAX = offset for (blocked) PAX values
C                   ZPAY = offset for (blocked) PAY values
C                   ZPAZ = offset for (blocked) PAZ values
C                   ZPINVHF = offset for (blocked) 1/2P values
C                   ZSCALE = offset for (blocked) scale values
C
C                   ZINT1DX = offset for (blocked) 1DX integrals
C                   ZINT1DY = offset for (blocked) 1DY integrals
C                   ZINT1DZ = offset for (blocked) 1DZ integrals
C
C                   ZXP = offset for (blocked) XP values
C                   ZYP = offset for (blocked) YP values
C                   ZZP = offset for (blocked) ZP values
C
C                   ZXMINUS = offset for (blocked) previous integrals
C                   ZYMINUS = offset for (blocked) previous integrals
C                   ZZMINUS = offset for (blocked) previous integrals
C
C                   ZSCRMX = offset for (blocked) 1DX scratch integrals
C                   ZSCRMY = offset for (blocked) 1DY scratch integrals
C                   ZSCRMZ = offset for (blocked) 1DZ scratch integrals
C
C                  --- Zone 4: for contraction only ---
C
C                   ZWORK = offset for contraction working array
C
C
C
C  AUTHOR      : Norbert Flocke
C                  - Wrote original OED package
C
C  MODIFIED    : Thomas Watson Jr.                   p  q  r
C                  - Modified OED package to handle X, Y, Z integrals
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     MEMORY
         LOGICAL     CASEX,CASEY,CASEZ
         LOGICAL     CASE1,CASE2,CASE3

         INTEGER     IJDIV
         INTEGER     L1CACHE,NCTROW
         INTEGER     MOMENTX,MOMENTY,MOMENTZ
         INTEGER     N
         INTEGER     MIJ,MIJBIG
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSTEP
         INTEGER     NIJ,NIJBLK
         INTEGER     NINT1D
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NRS
         INTEGER     NXYZT
         INTEGER     PFACT
         INTEGER     POW2IJ
         INTEGER     SHELLP
         INTEGER     WCOL
         INTEGER     ZMAX
         INTEGER     ZONE12,ZONE3,ZONE4,ZONE4B,ZONE4C
         INTEGER     ZONEMIN,ZONEOPT
         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,ZRHOAB,
     +               ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCALE,
     +               ZINT1DX,ZINT1DY,ZINT1DZ,
     +               ZXP,ZYP,ZZP,ZSCRMX,ZSCRMY,ZSCRMZ,
     +               ZXMINUS,ZYMINUS,ZZMINUS,ZEND

         DOUBLE PRECISION   DLOG2

         PARAMETER  (DLOG2  =  0.6931471805599D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine optimum size of [e|0] blocks:
C
C                The next few lines of code are among the most
C                important for performance of the entire moment
C                integral package. Any badly chosen sizes for the
C                primitive blocks has a severe effect on the integral
C                evaluation timing. Two opposite effects have
C                to be considered:
C
C                1) Reuse level 1 cache data as much as possible,
C                   i.e. choose the primitive blocks in such a
C                   way that most of the heavy computational work
C                   is being done reusing data in each cache line.
C
C                2) Choose the size of the primitive blocks as
C                   large as possible observing point 1), to reduce
C                   subroutine call overheads as much as possible.
C
C                After some experimenting, the following procedure
C                was found to work best:
C
C                  i) The optimum [e|0] block size is assumed to
C                     be directly proportional to the level 1 cache
C                     size.
C
C                 ii) The proportionality factor PFACT has to be
C                     determined by 'experiment', running a real
C                     molecular case with fully contracted basis sets.
C
C
         PFACT = 4

         MIJ = PFACT * L1CACHE / NXYZT
         MIJ = MAX (1,MIJ)
         MIJ = MIN (MIJ,NIJ)
C
C
C             ...the optimum block size MIJ has been determined.
C                We have to see now how it fits with the rest of
C                the needed data into the maximum memory given.
C                If necessary subdivide the optimum MIJ block size
C                into convenient subblocks that fit into memory.
C
C                The subdivision of the MIJ block is done in such
C                a way that successive powers of 2 are checked as
C                divisors of MIJ. The maximum # of division steps
C                MXSTEP can thus be calculated beforehand by knowing
C                the fact that the smallest subdivided MIJ block
C                is of size 1. The succesive divisors are checked
C                in the following order:
C
C
C                            step  |  div of MIJ
C                           ----------------------
C                              1   |       1
C                              2   |       2
C                              3   |       4
C                              4   |       8
C                              5   |      16
C                             ...         ...
C
C                The routine stops, if even a MIJ block of minimum
C                size 1 cannot be accomodated into the memory.
C
C
C             ...Watson
C                 Determine the cases to see whether memory is set
C                 aside for scratch matrices for X, Y, Z integrals.
C
C
         CASEX = (MOMENTX .GT. 0)
         CASEY = (MOMENTY .GT. 0)
         CASEZ = (MOMENTZ .GT. 0)

         CASE1 = (CASEX .NEQV. CASEY .NEQV. CASEZ)
         CASE2 = (CASEX .AND. CASEY) .NEQV. (CASEX .AND.CASEZ) .NEQV.
     +           (CASEY .AND. CASEZ)
         CASE3 = (CASEX .AND. CASEY .AND. CASEZ)


         MXPRIM = MAX (NPGTOA,NPGTOB)
         MNPRIM = MIN (NPGTOA,NPGTOB)

         NCSIZE  = NXYZT * NRS

         ZONE3 = NPGTOA + NPGTOB + NIJ
C
C
C             ...if the MEMORY keyword is activated, the routine
C                will only determine the optimum and minimum flp
C                memory (in that order), place them respectively
C                into the NCSIZE and NPSIZE variables and exit.
C
C
         IF (MEMORY) THEN

             NINT1D  = MIJ * (SHELLP+1)
             NPSIZE  = NXYZT * MIJ
             WCOL    = MNPRIM
             NWSIZE  = NCTROW * WCOL
             NPSIZE  = MAX (NPSIZE,NWSIZE)
             NWSIZE  = NPSIZE
             ZONE12  = NPSIZE + NCSIZE

             IF (CASE1)  ZONE4B = 5 * MIJ + 4 * NINT1D + 4 * NIJ
             IF (CASE2)  ZONE4B = 5 * MIJ + 5 * NINT1D + 5 * NIJ
             IF (CASE3)  ZONE4B = 5 * MIJ + 6 * NINT1D + 6 * NIJ

             ZONE4C  = NWSIZE
             ZONE4   = MAX (ZONE4B,ZONE4C)

             ZONEOPT = ZONE12 + ZONE3 + ZONE4

             MIJ     = 1
             NINT1D  = MIJ * (SHELLP+1)
             NPSIZE  = NXYZT * MIJ
             WCOL    = MNPRIM
             NWSIZE  = NCTROW * WCOL
             NPSIZE  = MAX (NPSIZE,NWSIZE)
             NWSIZE  = NPSIZE
             ZONE12  = NPSIZE + NCSIZE

             IF (CASE1)  ZONE4B = 5 * MIJ + 4 * NINT1D + 4 * NIJ
             IF (CASE2)  ZONE4B = 5 * MIJ + 5 * NINT1D + 5 * NIJ
             IF (CASE3)  ZONE4B = 5 * MIJ + 6 * NINT1D + 6 * NIJ

             ZONE4C  = NWSIZE
             ZONE4   = MAX (ZONE4B,ZONE4C)

             ZONEMIN = ZONE12 + ZONE3 + ZONE4

             NPSIZE  = ZONEMIN
             NCSIZE  = ZONEOPT

             RETURN

         ELSE
C
C
C             ...the actual fitting into the maximum memory given.
C
C
             POW2IJ = DLOG ( DFLOAT (MIJ) ) / DLOG2
             MXSTEP = POW2IJ + 1

             IJDIV = 1
             MIJBIG = MIJ

             DO 100 N = 1,MXSTEP

                MIJ = MAX (1, MIJBIG / IJDIV )

                NINT1D  = MIJ * (SHELLP+1)
                NPSIZE  = NXYZT * MIJ
                WCOL    = MNPRIM
                NWSIZE  = NCTROW * WCOL
                NPSIZE  = MAX (NPSIZE,NWSIZE)
                NWSIZE  = NPSIZE
                ZONE12  = NPSIZE + NCSIZE
C
C
C             ...Watson
C                 ZONE4B changes depending on X,Y,or Z integrals
C
C
                IF (CASE1)  ZONE4B = 5 * MIJ + 4 * NINT1D + 4 * NIJ
                IF (CASE2)  ZONE4B = 5 * MIJ + 5 * NINT1D + 5 * NIJ
                IF (CASE3)  ZONE4B = 5 * MIJ + 6 * NINT1D + 6 * NIJ

                ZONE4C  = NWSIZE
                ZONE4   = MAX (ZONE4B,ZONE4C)

                IF (ZONE12+ZONE3+ZONE4.LE.ZMAX) THEN

                    NIJBLK = MIJ
                    NWSIZE = ZMAX - ZONE12 - ZONE3
C
C
C             ...generate the memory allocation pointers.
C
C
                    ZCBATCH = 1
                    ZPBATCH = NCSIZE + 1

                    ZNORMA = ZPBATCH + NPSIZE
                    ZNORMB = ZNORMA + NPGTOA
                    ZRHOAB = ZNORMB + NPGTOB

                    ZPAX = ZRHOAB + NIJ
                    ZPAY = ZPAX + MIJ
                    ZPAZ = ZPAY + MIJ
                    ZPINVHF = ZPAZ + MIJ
                    ZSCALE = ZPINVHF + MIJ

                    ZINT1DX = ZSCALE + MIJ
                    ZINT1DY = ZINT1DX + NINT1D
                    ZINT1DZ = ZINT1DY + NINT1D

                    ZXP = ZINT1DZ + NINT1D
                    ZYP = ZXP + NIJ
                    ZZP = ZYP + NIJ
C
C
C             ...Watson
C                Begin allocating memory for possible X,Y,Z
C                polynomial integrals.
C
C
                    ZSCRMX = ZZP + NIJ
                    IF (MOMENTX .GT. 0) THEN
                        ZXMINUS = ZSCRMX  + NINT1D
                        ZSCRMY  = ZXMINUS + NIJ
                    ELSE
                        ZXMINUS = ZSCRMX
                        ZSCRMY  = ZXMINUS
                    END IF

                    IF (MOMENTY .GT. 0) THEN
                        ZYMINUS = ZSCRMY  + NINT1D
                        ZSCRMZ  = ZYMINUS + NIJ
                    ELSE
                        ZYMINUS = ZSCRMY
                        ZSCRMZ  = ZYMINUS
                    END IF

                    IF (MOMENTZ .GT. 0) THEN
                        ZZMINUS = ZSCRMZ +  NINT1D
                        ZEND    = ZZMINUS + NIJ
                    ELSE
                        ZZMINUS = ZSCRMZ
                        ZEND    = ZZMINUS
                    END IF

                    ZWORK = ZPAX

                    RETURN
                END IF

                IJDIV = IJDIV + IJDIV

  100        CONTINUE

             WRITE (*,*) ' Memory allocation failed for (e|0) ! '
             WRITE (*,*) ' NIJ,MIJ = ',NIJ,MIJ
             WRITE (*,*) ' Increase flp memory! '
             WRITE (*,*) ' (oed__ovl_e0_def_blocks) '

             STOP

         END IF
C
C
C             ...ready!
C
C
         END

c Single-line parser of Z-matrix elements ONLY.

c INPUT
c    zline(80) : the Z-matrix line to parse

c OUTPUT
c    izl(2,7) : the beginning (1,*) and ending (2,*) indices of each
c               element (non-existent elements are at zline(0:0))
c               EXAMPLE:
c                  zline = '  X  1  R3  2  A2  3  D1   '
c                           123456789+123456789+1234567
c                  izl(1:2,1:7) = 3  6   9  13  16  20  23
c                                 3  6  10  13  17  20  24

#include "iachar.h"

      subroutine parsez(zline,izl)
      implicit none

#include "linelen.par"

      character*(linelen) zline
      integer izl(2,7)

      character*1 czTmp
      integer ndx, count
      logical find_char, not_done

c "parameters"
      character*1 achar, czTab, czSpace, czComment
      integer    max_cols
      parameter (max_cols = 80)

c ----------------------------------------------------------------------

      czTab     = achar(_IACHAR_TAB)
      czSpace   = achar(_IACHAR_SPACE)
      czComment = achar(_IACHAR_POUND)

      izl(1,1) = 0
      izl(2,1) = 0
      izl(1,2) = 0
      izl(2,2) = 0
      izl(1,3) = 0
      izl(2,3) = 0
      izl(1,4) = 0
      izl(2,4) = 0
      izl(1,5) = 0
      izl(2,5) = 0
      izl(1,6) = 0
      izl(2,6) = 0
      izl(1,7) = 0
      izl(2,7) = 0

c   o the zline pointer
      ndx = 1

c   o the izl pointer
      count = 1

c   o start looking for a char
      find_char = .true.

      not_done = .true.
      do while (not_done)

         czTmp = zline(ndx:ndx)
         if (find_char) then
            if ( (czTmp.ne.czSpace) .and.
     &           (czTmp.ne.czTab  )       ) then
               if (czTmp.eq.czComment) then
                  not_done = .false.
               else
                  izl(1,count) = ndx
                  find_char = .false.
               end if
            end if
         else
            if ( (czTmp.eq.czSpace).or.
     &           (czTmp.eq.czTab  )    ) then
               izl(2,count) = ndx - 1
               if (count.eq.7) then
                  return
               else
                  find_char = .true.
                  count = count + 1
               end if
            else
               if (czTmp.eq.czComment) then
                  izl(2,count) = ndx - 1
                  not_done = .false.
               end if
            end if
         end if

         if (not_done.and.(ndx.eq.max_cols)) then
            not_done = .false.
            if (.not.find_char) izl(2,count) = ndx
         else
            ndx = ndx + 1
         end if

c     end do while (not_done)
      end do

c      write(*,*) (izl(1,count),count=1,7)
c      write(*,*) (izl(2,count),count=1,7)

      return
      end

c This routine redistributes the array sizes for an MOIO family of arrays
c based on two-particle symmetry processing. It DOES NOT perform the resort,
c and it requires the groups to be 'packed' in the sense that aces_list_touch
c was not told to start each group on a physical record boundary (besides the
c first one). Although it updates the auxiliary cache addresses, every
c array in the family MUST be in memory with no spaces between them (just
c like the disk storage requirement).
c    This is really a shameful routine. The main idea is that a diagram
c like <Ab|Ij> is to be resorted and stored as <AI|bj>. The programmer
c does the resort with sstgen, calls this routine, and then calls putlst
c to update the disk records. People should consider better algorithms...

c INPUT
c int IRP_DIAG : the total symmetry of the diagram (normally 1)
c int IFAMNDX  : the family index of the arrays to redistribute
c int DISTTYPE_BRA : the distribution type (cf. disttype.h) of the bra (rows)
c int DISTTYPE_KET : the distribution type (cf. disttype.h) of the ket (cols)
c logical BUPDATE : a behavior flag
c                   = T;        update /sympop/isytyp(*,IFAMNDX)
c                   = F; do not update ...
c                   Note: This flag is so important that it is ignored
c                         and assumed to be true.

#include "lists.h" /* for MOIO dimensions */

c#define _DEBUG_ACES_FAMILY_REDIST

      subroutine aces_family_redist(irp_diag,iFamNdx,
     &                              DistType_bra,DistType_ket,
     &                              bUpdate)
      implicit none

c ARGUMENTS
      integer irp_diag, iFamNdx, DistType_bra, DistType_ket
      logical bUpdate

c INTERNAL VARIABLES
      integer irp_bra, irp_ket
      integer nRows, nCols, nWords
      integer iNumNew, iNumMax
      integer iRec, iWrdNdx
      integer quiktmp(_MAX_IO_GRPS)
      integer iTmp

c COMMON BLOCKS
#include "lists.com"
#include "filspc.com" /* for iprcwd */
#include "sympop.com" /* for irpdpd and isytyp */
#include "syminf.com" /* for nirrep and dirprd */
#include "auxcache.com" /* for quikget */
#include "machsp.com" /* for iintfp */

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_FAMILY_REDIST: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iTmp = 1
      end if
c   o assert irp_diag is in [1,nirrep]
      if ((irp_diag.lt.1).or.(nirrep.lt.irp_diag)) then
         print *, '@ACES_FAMILY_REDIST: Assertion failed.'
         print *, '   irp_diag = ',irp_diag
         print *, '   nirrep   = ',nirrep
         iTmp = 1
      end if
c   o assert iFamNdx is properly bound
      if ((iFamNdx.lt.1).or.(_MAX_IO_FAMS.lt.iFamNdx)) then
         print *, '@ACES_FAMILY_REDIST: Assertion failed.'
         print *, '   iFamNdx = ',iFamNdx
         print *, '   max ndx = ',_MAX_IO_FAMS
         iTmp = 1
      end if
c   o assert distribution types are in [1,22]
      if ((DistType_bra.lt.1).or.(22.lt.DistType_bra).or.
     &    (DistType_ket.lt.1).or.(22.lt.DistType_ket)    ) then
         print *, '@ACES_FAMILY_REDIST: Assertion failed.'
         print *, '   DistType_bra = ',DistType_bra
         print *, '   DistType_ket = ',DistType_ket
         print *, '   max type     = ',22
         iTmp = 1
      end if
c   o assert bUpdate is .true. (even though it's ignored)
      if (.not.bUpdate) then
         print *, '@ACES_FAMILY_REDIST: Assertion failed.'
         print *, '   bUpdate = ',bUpdate
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o process the first row/group/irrep (peeled off the do loop)
      irp_bra = dirprd(1,irp_diag)
      nRows   = irpdpd(irp_bra,DistType_bra)
      nCols   = irpdpd(1,      DistType_ket)
      iNumNew = nRows*nCols
      iNumMax = moiomxsz(1,iFamNdx)
      moiosz(1,iFamNdx) = nRows
      moiods(1,iFamNdx) = nCols

c   o process 'the others'
      if (nirrep.ne.1) then
         nWords = nRows*nCols*iintfp
         quiktmp(1) = nWords
         iWrdNdx = moiowd(1,iFamNdx) + nWords
         iTmp    = (iWrdNdx-1)/iprcwd
         iRec    = moio(1,iFamNdx) + iTmp
         iWrdNdx = iWrdNdx         - iTmp*iprcwd
         do irp_ket = 2, nirrep
            irp_bra = dirprd(irp_ket,irp_diag)
            nRows   = irpdpd(irp_bra,DistType_bra)
            nCols   = irpdpd(irp_ket,DistType_ket)
            iTmp    = nRows*nCols
            iNumNew = iNumNew + iTmp
            nWords  = iTmp*iintfp
            iNumMax = iNumMax + moiomxsz(irp_ket,iFamNdx)
            moiosz(irp_ket,iFamNdx) = nRows
            moiods(irp_ket,iFamNdx) = nCols
            moio  (irp_ket,iFamNdx) = iRec
            moiowd(irp_ket,iFamNdx) = iWrdNdx
            quiktmp(irp_ket) = nWords
            iWrdNdx = iWrdNdx + nWords
            iTmp    = (iWrdNdx-1)/iprcwd
            iRec    = iRec    + iTmp
            iWrdNdx = iWrdNdx - iTmp*iprcwd
         end do
         if (quikget(1,iFamNdx).ne.0) then
            do irp_ket = 2, nirrep
               quikget(irp_ket,iFamNdx) =   quikget(irp_ket-1,iFamNdx)
     &                                    + quiktmp(irp_ket-1)
            end do
         end if
c     end if (nirrep.ne.1)
      end if

cYAU - I don't think we should modify moiomxsz. Those elements are set in
c      aces_list_touch which also moves the free-space pointers.

c   o make sure programmers are not creating new data
      if (iNumNew.gt.iNumMax) then
#ifdef _DEBUG_ACES_FAMILY_REDIST
         print *, '@ACES_FAMILY_REDIST: The number of elements has ',
     &            'increased!'
         print *, '                     The original NEWTYP2 was ',
     &            'gracious enough to remove this'
         print *, '                     trap, but since we do not ',
     &            'trust our own programmers,'
         print *, '                     we have to complain.'
         print *, '                     The main problem is that the ',
     &            'new data overwrites the'
         print *, '                     next list family or that the ',
     &            'next list_touch will'
         print *, '                     overwrite the tail of this ',
     &            'family.'
         print *, '   array family index  = ',iFamNdx
         print *, '   maximum family size = ',iNumMax
         print *, '   new family size     = ',iNumNew
#endif
      end if

c   o update the type lookup table
      isytyp(1,iFamNdx) = DistType_bra
      isytyp(2,iFamNdx) = DistType_ket

c   o mark MOIO as modified
      bIOMod = .true.

      return
c     end subroutine aces_family_redist
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      function is_connected(atom1, atom2, connectiontable, natoms,
     &                      connectlist)
C
C Determines if two atoms are connected by constructing a full
C connection list and then searching it.
C
      implicit none
C
C Input Variables
C
      integer atom1,atom2,natoms,connectiontable(natoms,natoms)
C
C Function Variables
C
      logical is_connected
C
C Pre-allocated Local Variables
C
      integer connectlist(natoms), i
C
C External Procedures
C
      external followconnect

C Local Variables

      integer listatoms
      logical shortcircuit
C - - -- - - - - - - - - - - - - -- - - - - - - -- - - -  -- - 

      if (connectiontable(atom1,atom2).eq.1) then
         is_connected=.true.
         return
      else
         call izero(connectlist,natoms)
C
C Follow atom1 connections
C
         listatoms=0
         shortcircuit=.false.
         call followconnect(atom2,atom1,connectlist,listatoms,
     &      connectiontable,natoms,
     &      shortcircuit)
         is_connected=shortcircuit
      endif
C
#ifdef _DEBUG_LVLM1
      Print*, "The connectionlist in is_connected"
      Print*, "atom1 & atom2", (connectlist(i), i=1, natoms),
     &         atom1, atom2
#endif
c
      return
      end
C
      subroutine followconnect(atom,taratom,list,listatoms,
     &   connectiontable,natoms,
     &   shortcircuit)
C
C Constructs list of connections non-recursively
C
      implicit none
C Input Variables
      integer atom,natoms,connectiontable(natoms,natoms),taratom

C Input/Output Variables
      integer list(natoms),listatoms
      logical shortcircuit

C Local Variables
      integer ii, i, j, k
      integer paths(natoms,natoms)
      integer path_count(natoms)
      integer extension(natoms,natoms)
      integer extension_count(natoms)
      integer ipath, npaths, nextend
      

C - - - - - - -- - - - - - - - - - - - - - - -- - - - - - - - -- - -
      
      npaths = 0

c----------------------------------------------------------------------------
c   Find all paths of length 1.
c----------------------------------------------------------------------------

      do ii = 1, natoms
         if (connectiontable(ii,atom) .eq. 1) then

c----------------------------------------------------------------------------
c   Add this path.
c----------------------------------------------------------------------------

            npaths = npaths + 1
            paths(1,npaths) = ii    ! path is from iatom to ii.
            path_count(npaths) = 1  ! length of path is 1.
         endif
      enddo

      call remove_invalid_paths(paths, path_count, natoms, npaths, 
     *                          atom)
      call check_paths(paths, path_count, natoms, npaths, atom, 
     *                           taratom, list, listatoms, 
     *                           shortcircuit)
      if (npaths .eq. 0 .or. 
     *    shortcircuit) return

  100 continue
      nextend = 0
      do ipath = 1, npaths

c----------------------------------------------------------------------------
c   Extend paths if possible.
c----------------------------------------------------------------------------

         ii = paths(path_count(ipath),ipath)   ! last atom in path.
         do i = 1, natoms
            if (connectiontable(i,ii) .eq. 1) then
               nextend = nextend + 1
               if (nextend .gt. natoms) then
                  print *,'Error: followconnect: Attempting to create ',
     *               'more path extensions than natoms ',natoms
                  print *,'atom, taratom ',atom,taratom
                  print *,'connectiontable: ii ',ii
                  do j = 1, natoms
                     print *,'ATOM ',j
                     print 10101,(connectiontable(j,k),k=1,natoms)
10101 format(10(1x,i3))
                  enddo      
                  call abort_job()
               endif

               extension_count(nextend) = path_count(ipath)+1
               do j = 1, path_count(ipath)
                  extension(j,nextend) = paths(j,ipath)
               enddo
               extension(extension_count(nextend),nextend) = i
            endif
         enddo   ! i

c---------------------------------------------------------------------------
c   Cull out the invalid extensions.
c---------------------------------------------------------------------------

         call remove_invalid_paths(extension, extension_count, 
     *                          natoms, nextend,
     *                          atom) 
      enddo ! ipath

c---------------------------------------------------------------------------
c   Copy the extended paths into the paths array.
c---------------------------------------------------------------------------

      npaths = nextend
      do j = 1, npaths
         path_count(j) = extension_count(j)
         do i = 1, path_count(j)
            paths(i,j) = extension(i,j)
         enddo 
      enddo
      
      call remove_invalid_paths(paths, path_count, natoms, npaths,
     *                          atom)
      call check_paths(paths, path_count, natoms, npaths, atom,
     *                           taratom, list, listatoms,
     *                           shortcircuit)
      if (npaths .eq. 0 .or.
     *    shortcircuit) return
      go to 100

      return
      end

      subroutine remove_invalid_paths(paths, path_count, natoms, 
     *                          npaths, iatom)
c-----------------------------------------------------------------------------
c   Checks for degenerate paths in the "paths" array and removes them.
c   A degenerate path is one that has looped back to the iatom, or one 
c   which contains duplicate atoms.
c-----------------------------------------------------------------------------

      implicit none
      integer natoms, iatom, npaths
      integer paths(natoms,natoms) 
      integer path_count(natoms)
      integer i, j, k, nremove, remove(natoms)
      integer kpath, lenpath
      logical remove_this

      if (npaths .eq. 0) return   ! nothing to do.

      nremove = 0
      do j = 1, npaths
         lenpath = path_count(j)

         remove_this = .false.
         do i = 1, lenpath

c----------------------------------------------------------------------------
c   Check path for loopback to iatom.
c----------------------------------------------------------------------------

            if (paths(i,j) .eq. iatom) then
               remove_this = .true.
               nremove = nremove + 1
               remove(nremove) = j
            endif
         enddo 

         if (.not. remove_this) then

c----------------------------------------------------------------------------
c   Check for duplicate atoms in path.
c----------------------------------------------------------------------------

            do i = 1, lenpath
               do k = i+1, lenpath
                  if (paths(i,j) .eq. paths(k,j)) then
                     nremove = nremove + 1
                     remove(nremove) = j
                  endif
               enddo     ! k
            enddo        ! i
         endif           ! .not. remove_this
      enddo              ! j

c----------------------------------------------------------------------------
c   Remove all paths marked for removal.
c----------------------------------------------------------------------------

      if (nremove .gt. 0) then
         do j = nremove, 1, -1  ! must be removed in reverse order.
            k = remove(j)     ! index of path to be removed.

c---------------------------------------------------------------------------
c   Move paths k+1 through npaths to k, npaths-1.
c---------------------------------------------------------------------------

            do kpath = k+1, npaths
               lenpath = path_count(kpath)
               path_count(kpath-1) = lenpath

               do i = 1, lenpath
                  paths(i,kpath-1) = paths(i,kpath)
               enddo
            enddo

            npaths = npaths - 1
         enddo
      endif

      return
      end

      subroutine check_paths(paths, path_count, natoms, npaths, iatom,
     *                           taratom, list, listatoms,
     *                           found_connection)
c---------------------------------------------------------------------------
c   Checks all paths to determine if a connection between iatom and taratom
c   has been found.  Returns found_connection = .true. if found, .false.
c   otherwise.  If found_connection = .true., the actual path is returned
c   in list and the length of the path is returned in listatoms. 
c---------------------------------------------------------------------------
      implicit none
      integer natoms, npaths, iatom, taratom, listatoms
      integer paths(natoms, natoms)
      integer path_count(natoms)
      integer list(natoms)
      logical found_connection

      integer i, j, k

      found_connection = .false.

      do j = 1, npaths
         do i = 1, path_count(j)
            if (paths(i,j) .eq. taratom) then

c---------------------------------------------------------------------------
c   We found the connection.
c---------------------------------------------------------------------------

               found_connection = .true.
               listatoms = path_count(j)
               do k = 1, listatoms
                  list(k) = paths(k,j)
               enddo
               return
            endif
         enddo
      enddo

      return
      end

      SUBROUTINE WHAT2FOLLOW(HESMOD, DIAGHES, QSTLST_TANGENT,
     &                       SCRATCH, NX, NOPT, IMODE)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      DOUBLE PRECISION OVRLP

      PARAMETER (OVRLP_MIN = 8.0D-1)
      DATA ZERO /0.0D0/
      DATA TWO  /2.0D0/

      DIMENSION HESMOD(NOPT, NOPT), DIAGHES(NOPT, NOPT),
     &          SCRATCH(NX*NX),  QSTLST_TANGENT(NOPT)
C
C Let's get the eigenvector of the Hessian that has the largest overlap
C with the LST or QST tangent. If there is no eigenvector that has
C an overlap of larger than 10^(-8) or twice as big as the next
C largest overlap, then follow the eigenvector corresponding to
C the smallest eigenvalue. If the user wants to follow something
C other than said eigenvectors, then there is no point of doing
C LST or QST.
C
      ZOVRLP1 = ZERO
      ZOVRLP2 = ZERO

      DO 10 IOPT = 1, NOPT
         OVRLP = DDOT(NOPT,QSTLST_TANGENT,1,DIAGHES(1,IOPT),1)
         IF (DABS(OVRLP).GT.ZOVRLP1) THEN
            ZOVRLP2 = ZOVRLP1
            ZOVRLP1 = DABS(OVRLP)
            MEFOLOW = IOPT
         ELSE IF (DABS(OVRLP) .GT. ZOVRLP2) THEN
            ZOVRLP2 = DABS(OVRLP)
         END IF
 10   CONTINUE
C
c      Write(6,*) "The maximum overlaps = ", ZOVRLP1,ZOVRLP2,
c     &                                      MEFOLOW, OVRLP_MIN
C
      IF (ZOVRLP1 .GT. OVRLP_MIN .OR. ZOVRLP1 .GT. TWO*ZOVRLP2) THEN
         IMODE = MEFOLOW
C
C The pure eigenvector following logic. ie. follow the eiegenvector corresponds
C to the lowest eigenvalue (or user's choice). Find out the eigenvector
C for the lowest eigenvalue (IVEC=1). That is the default.
C
      ELSE

          DO 30 J = 1, NOPT
             SCRATCH(J) = HESMOD(J, J)
 30       CONTINUE
          Z = 100.D0
          DO 50 I = 1, NOPT
             IF (SCRATCH(I) .LT. Z) THEN
                IMODE = I
                Z = SCRATCH(I)
             END IF
 50       CONTINUE

      ENDIF

      RETURN
      END

C  Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
C  USA
         SUBROUTINE  OED__XYZ_DERV_INT1D_TO_AB
     +
     +                    ( SHELLA,SHELLB,
     +                      NEXP,
     +                      NXYZA,NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      CASEX,CASEY,CASEZ,             ! Watson Added
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_DERV_INT1D_TO_AB
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative overlap integrals [A|B].
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                1DX and 1DY integrals.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x = A and B
C                    NEXP        =  current # of exponent pairs
C                    NXYZx       =  # of cartesian monomials for
C                                   x = A and B shells
C                    INT1Dx      =  all current 1D AB derivative
C                                   nuclear attraction integrals for
C                                   each cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x = X,Y,Z
C                                   direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1D AB derivative integral products
C                    SCALE       =  the NEXP scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian [A|B]
C                                   derivative overlap integrals
C                                   corresponding to all current
C                                   exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C  MODIFIED    : Thomas Watson
C                   - Changed to do derivatives of moment integrals
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFX,DIFFY,DIFFZ
         LOGICAL     CASEX,CASEY,CASEZ                     ! Watson Added

         INTEGER     I,J,N
         INTEGER     NEXP
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB
         INTEGER     XA,YA,ZA,XB,YB,ZB
         INTEGER     XAP,XBP
         INTEGER     YAMAX,YBMAX

         DOUBLE PRECISION  SCALE (1:NEXP)
         DOUBLE PRECISION  TEMP1 (1:NEXP)
         DOUBLE PRECISION  TEMP2 (1:NEXP)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZA,1:NXYZB)

         DOUBLE PRECISION  INT1DX (1:NEXP,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT1DY (1:NEXP,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT1DZ (1:NEXP,0:SHELLA,0:SHELLB)
C
C
C------------------------------------------------------------------------
C
C
C             ...outer loops over x,x-pairs. Skip the multiplication
C                of x,x-contributions, if no x-coordinate derivative
C                was formed and we have a 0,0-pair, as then the 1DX
C                integrals are equal to 1.
C
C
             XBP = 0
             DO 100  XB = SHELLB,0,-1
                YBMAX = SHELLB - XB
                XAP = 0
                DO 110 XA = SHELLA,0,-1
                   YAMAX = SHELLA - XA

                   DO N = 1,NEXP
                      TEMP1 (N) = SCALE (N) * INT1DX (N,XA,XB)
                   END DO
 
                   J = XBP
                   DO 120 YB = YBMAX,0,-1
                      J = J + 1
                      ZB = YBMAX - YB
                      I = XAP
                      DO 130 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         DO N = 1,NEXP
                            TEMP2 (N) = TEMP1 (N) * INT1DY (N,YA,YB)
                         END DO

                         DO N = 1,NEXP
                            BATCH (N,I,J) = TEMP2 (N) * INT1DZ (N,ZA,ZB)
                         END DO
C
C
C             ...next z,z-pair and y,y-pair.
C
C
  130                 CONTINUE
  120              CONTINUE
C
C
C             ...next x,x-pair.
C
C
                   XAP = I
  110           CONTINUE
                XBP = J
  100        CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE SORTT2(ICORE,MAXCOR,ISPIN,ILIST,NTOP,TYPE)
C
C DRIVER FOR ROUTINE WHICH PICKS UP THE T2 VECTOR FROM DISK FOR A 
C  SPIN CASE AND FIND THE NTOP LARGEST ELEMENTS BY MAGNITUDE.  THESE ARE
C  PRINTED OUT AT THE END OF THE ROUTINE.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*8 LABEL1,LABEL2
      CHARACTER*1 TYPE
      DIMENSION ICORE(MAXCOR)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      NNM1O2(I)=(I*(I-1))/2
      NOCCA=NOCCO(1)
      NOCCB=NOCCO(2)
      NVRTA=NVRTO(1)
      NVRTB=NVRTO(2)
      IF(ISPIN.EQ.1)THEN
       NT2SIZ=ISYMSZ(ISPIN,ISPIN+2)
       NSMSZ1=NNM1O2(NVRTO(ISPIN))
       NSMSZ2=NNM1O2(NOCCO(ISPIN))
       LABEL1='SVAVA0  '
       LABEL2='SOAOA0  '
      ELSEIF(ISPIN.EQ.2)THEN
       NT2SIZ=ISYMSZ(ISPIN,ISPIN+2)
       NSMSZ1=NNM1O2(NVRTO(ISPIN))
       NSMSZ2=NNM1O2(NOCCO(ISPIN))
       LABEL1='SVBVB0  '
       LABEL2='SOBOB0  '
      ELSEIF(ISPIN.EQ.3)THEN
       NT2SIZ=ISYMSZ(13,14)
       NSMSZ1=NVRTO(1)*NVRTO(2)
       NSMSZ2=NOCCO(1)*NOCCO(2)
       LABEL1='SVAVB2  '
       LABEL2='SOAOB2  '
      ENDIF
C
C ALLOCATE CORE FOR T VECTOR, SYMMETRY VECTORS AND INDICES.
C
      I000=1
      I010=I000+IINTFP*NT2SIZ
      I020=I010+IINTFP*NTOP
      I030=I020+NSMSZ1
      I040=I030+NSMSZ2
      I050=I040+NTOP
      I060=I050+NTOP
      I070=I060+NTOP
      I080=I070+NTOP
      I090=I080+NTOP
      CALL GETREC(20,'JOBARC',LABEL1,NSMSZ1,ICORE(I020))
      CALL GETREC(20,'JOBARC',LABEL2,NSMSZ2,ICORE(I030))
      CALL TOPT2S(ISPIN,ILIST,NTOP,NT2SIZ,NOCCA,NOCCB,NVRTA,
     &            NVRTB,NSMSZ1,NSMSZ2,ICORE(I000),ICORE(I010),
     &            ICORE(I020),ICORE(I030),ICORE(I040),ICORE(I050),
     &            ICORE(I060),ICORE(I070),ICORE(I080),TYPE)
      RETURN
      END

C
C THIS ROUTINE DRIVES THE RESORT OF A LIST ON DISK.  
C
C INPUT :
C       ICORE - WORKING SCRATCH AREA USED IN THIS ROUTINE.  
C      MAXCOR - TOTAL WORKING AREA IN INTEGER WORDS
C        POP1 - POPULATION VECTOR FOR P
C        POP2 - POPULATION VECTOR FOR Q
C        POP3 - POPULATION VECTOR FOR R
C        POP4 - POPULATION VECTOR FOR S
C      IRREPX - THE OVERALL SYMMETRY OF THE LIST (USUALLY 1)
C    LISTFROM - THE LIST HOLDING THE PQRS QUANTITY
C     LISTOUT - THE LIST WHERE THE RESORTED QUANTITY IS WRITTEN
C      SYTYPL - LEFT SYMMETRY TYPE OF RESORTED QUANTITY
C      SYTYPR - RIGHT SYMMETRY TYPE OF RESORTED QUANTITY
C      LHSEXP - LOGICAL FLAG SET TO .TRUE. IF LEFT-HAND SIDE NEEDS
C               TO BE EXPANDED BEFORE RESORTING.
C      LFTTYP - LEFT HAND SYMMETRY TYPE [USED ONLY IF LHSEXP=.TRUE.]
C
      SUBROUTINE SSTLST(ICORE,MAXCOR,POP1,POP2,POP3,
     &                  POP4,IRREPX,TYPE,LISTFROM,
     &                  LISTOUT,SYTYPL,SYTYPR,LHSEXP,LFTTYP)
      IMPLICIT INTEGER (A-Z)
      CHARACTER*4 TYPE
      LOGICAL LHSEXP
      DIMENSION ICORE(MAXCOR)
      DIMENSION POP1(8),POP2(8),POP3(8),POP4(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRRVEC(255,2),DIRPRD(8,8)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYMPOP/ IRPDPD(8,22),ISYTYP(2,500),ID(18)

      if ((LFTTYP.lt.1).or.(22.lt.LFTTYP)) then
         print *, '@SSTLST: Assertion failed.'
         print *, '   LFTTYP  = ',LFTTYP
         print *, '   LISTOUT = ',LISTOUT
         call aces_exit(1)
      end if

C
C CALCULATE SIZE OF INPUT AND OUTPUT LISTS
C
      IF(.NOT.LHSEXP)THEN
       NSIZEIN=IDSYMSZ(IRREPX,ISYTYP(1,LISTFROM),ISYTYP(2,LISTFROM))
      ELSE
       NSIZEIN=IDSYMSZ(IRREPX,LFTTYP,ISYTYP(2,LISTFROM))
      ENDIF
      NSIZEOUT=IDSYMSZ(IRREPX,SYTYPL,SYTYPR)
C
      DO 10 I=1,NIRREP
       IF(.NOT.LHSEXP)THEN
        DSZIN =IRPDPD(I,ISYTYP(1,LISTFROM))
       ELSE
        DSZIN =IRPDPD(I,LFTTYP)
       ENDIF
       DSZOUT =IRPDPD(I,ISYTYP(1,SYTYPL))
       MAXDSZ=MAX(DSZOUT,DSZIN)
10    CONTINUE
C
C SEE IF THERE IS SUFFICIENT CORE TO DO THIS THE EASY WAY.
C
      ITOP=NSIZEIN+NSIZEOUT+MAXDSZ
      IF(ITOP.LE.MAXCOR/IINTFP.AND..NOT.LHSEXP)THEN
       WRITE(6,1000)LISTFROM
       I000=1
       I010=I000+IINTFP*NSIZEIN
       I020=I010+IINTFP*NSIZEOUT
       I030=I020+IINTFP*MAXDSZ
       CALL GETALL(ICORE(I000),NSIZEIN,IRREPX,LISTFROM)
       CALL SSTGEN(ICORE(I000),ICORE(I010),NSIZEIN,POP1,POP2,POP3,
     &                   POP4,ICORE(I020),IRREPX,TYPE)
       CALL NEWTYP(LISTOUT,SYTYPL,SYTYPR,.TRUE.)
       CALL PUTALL(ICORE(I010),NSIZEOUT,IRREPX,LISTOUT)
      ELSE
       I000=1
       I010=I000+IINTFP*MAXDSZ
       I020=I010+IINTFP*NSIZEOUT
       I030=I020+IINTFP*MAXDSZ
       IF(I030.GT.MAXCOR)THEN
        CALL INSMEM('SSTLST',I030,MAXCOR)
       ELSE
        WRITE(6,2000)LISTFROM
        CALL SSTDSK(ICORE(I000),ICORE(I010),NSIZEIN,POP1,POP2,POP3,
     &              POP4,ICORE(I020),IRREPX,TYPE,LISTFROM,
     &              LISTOUT,SYTYPL,SYTYPR,LHSEXP,LFTTYP)
       ENDIF
C
      ENDIF
C
1000  FORMAT(T3,'@SSTLST-I, Reordering list ',I3,' with in-core ',
     &          'algorithm.')
2000  FORMAT(T3,'@SSTLST-I, Reordering list ',I3,' with out-of-core ',
     &          'algorithm.')
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE JSD1(JSD,JSD2,NREAL)
C
C COMPUTES THE SD CONTRIBUTION TOn INDIRECT SPIN-SPIN
C NMR COUPLING CONSTANTS
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL YESNO,PRINT
      DOUBLE PRECISION JSD,JSD2
C
#include "mxatms.par"
      DIMENSION JSD(3*NREAL,3),JSD2(NREAL,NREAL)
      DIMENSION NORD(MXATMS*2)
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /FLAGS/ IFLAGS(100),IFLAGS2(500)
C
      DATA THIRD /0.333333333333333D0/
      DATA HALF  /0.5D0/
C
      DO 2000 ITYPE=1,2
C
      IF(ITYPE.EQ.1) THEN
       INQUIRE(FILE='JSD',EXIST=YESNO)
      ELSE
       INQUIRE(FILE='JSDSCF',EXIST=YESNO)
      ENDIF
C
      PRINT=.FALSE.
      IF(IFLAGS(1).GE.10)PRINT=.TRUE.
C
      IF(YESNO)THEN
C
C GET INFORMATION ABOUT ATOMIC ORDERING
C
       CALL IGETREC(20,'JOBARC','DUMSTRIP',NATOMS,NORD)
       CALL IGETREC(20,'JOBARC','MAP2ZMAT',NATOMS,NORD(NATOMS+1))

       IF(ITYPE.EQ.1) THEN
        OPEN(UNIT=90,FILE='JSD',FORM='FORMATTED',STATUS='OLD')
       ELSE
        OPEN(UNIT=90,FILE='JSDSCF',FORM='FORMATTED',STATUS='OLD')
       ENDIF
C
C READ IN THE CHEMICAL SHIELDING TENSOR
C
       JBOT=1
       DO 10 I=1,NREAL
C
        IZ=NORD(NATOMS+I)
        IZ0=NORD(IZ)
C
        READ(90,'((3F20.10))')(JSD(J,1),J=1,NREAL*3)
        READ(90,'((3F20.10))')(JSD(J,2),J=1,NREAL*3)
        READ(90,'((3F20.10))')(JSD(J,3),J=1,NREAL*3)
C
C COMPUTE FOR ALL ATOMS ISOTROPIC COUPLINGS
C
        I0=0
        DO 11 J=1,NREAL
C
        JZ=NORD(NATOMS+J)
        JZ0=NORD(JZ)
C
         JSD2(IZ0,JZ0)=THIRD*(JSD(I0+1,1)+JSD(I0+2,2)+JSD(I0+3,3))
         I0=I0+3
11      CONTINUE
C
10     CONTINUE
C
       WRITE(6,1000)
       IF(ITYPE.EQ.2) THEN
        WRITE(6,1001)
       ELSE
        IF(IFLAGS(2).EQ.0) THEN
         WRITE(6,1001)
        ELSE IF(IFLAGS(2).EQ.1) THEN
         WRITE(6,10001)
        ELSE IF(IFLAGS(2).EQ.2) THEN
         WRITE(6,10011)
         CALL ERREX
        ELSE IF(IFLAGS(2).EQ.10) THEN
         WRITE(6,10012)
        ELSE
         CALL ERREX
        ENDIF
       ENDIF
       WRITE(6,1000)
C
       JBOT=1
       NTIMES=1+(NREAL-1)/5
C
       DO 20 ICOUNT=1,NTIMES
        WRITE(6,*)
        WRITE(6,142)(ZSYM(ICN),ICN=JBOT,MIN(NREAL-1,JBOT+4))
        WRITE(6,144)(ICN,ICN=JBOT,MIN(NREAL-1,JBOT+4))
        DO 12 I=JBOT+1,NREAL
12      WRITE(6,143)ZSYM(I),I,(JSD2(I,J),J=JBOT
     & ,MIN(I-1,JBOT+4))
        JBOT=JBOT+5
20      CONTINUE
C
142    FORMAT(17X,A3,4(9X,A3))
143    FORMAT(T3,A3,'[',I2,']',5(2X,F10.5))
144    FORMAT(16X,:'[',I2,']',4(8X,:'[',I2,']'))

       WRITE(6,1000)
       CLOSE(UNIT=90,STATUS='KEEP')
      ELSE
       IF(ITYPE.EQ.1) THEN    
        WRITE(6,1004)
        CALL ERREX
       ENDIF
      ENDIF
C
2000  CONTINUE
      RETURN
C
1000  FORMAT(T3,67('-'))
1001  FORMAT(T5,'SCF Spin-Dipole NMR Coupling Constants (in Hz)')
10001 FORMAT(T3,'MBPT(2) Spin-Dipole NMR Coupling Constants (in Hz)')
10011 FORMAT(T3,'MBPT(3) Spin-Dipole NMR Coupling Constants (in Hz)')
10012 FORMAT(T3,'CCSD-EH Spin-Dipole NMR Coupling Constants (in Hz)')
1003  FORMAT(T7,I3,T20,I3,T33,F10.3,T51,F10.3)
1004  FORMAT(T3,'@JSD1-F, File JSD not found on disk.')
2001  FORMAT(T3,I3,3F20.10)
C
      END

      SUBROUTINE FETCH(ZLIST,FILE,RECNUM,IWRDOFF,NWORDS)
C
C THIS ROUTINE RETRIEVES LOGICAL RECORDS FROM LIST FILES.  IT IS
C  A PRIMITIVE ROUTINE CALLED BY PUTLST WHICH SHOULD NOT BE CALLED
C  DIRECTLY.
C
CEND
C
C SG 6/5/96 If a full record is being written, do not copy it to the cache.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION ZLIST(1)
      COMMON // ICORE(1)
      COMMON /CACHEINF/ CACHNUM,CACHNMP1,CACHDIR(100),CACHPOS(100),
     &                  CACHFILE(100),CACHMOD(100),OLDEST
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MACHSP2/MASK1,MASK2 ,ISHFSZ
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFF(2),LENREC
C
      IPACK(I,J)=IOR(J,ISHFT(I-49,ISHFSZ))
      UPACKR(I) =IAND(I,MASK1)
      UPACKF(I) =IAND(ISHFT(I,-ISHFSZ),MASK2)+49
C
C CHECK TO SEE IF THE RECORD IS IN THE CACHE.  IF IT IS, IIEQ WILL
C  RETURN A VALUE IN THE RANGE 1-CACHNUM.  
C
      ITEST=IPACK(FILE,RECNUM)
      ILOC=IIEQ(CACHNUM,CACHDIR,1,ITEST)
C
C IF THE CORRECT RECORD (FILE MUST MATCH AS WELL) IS IN THE CACHE,
C  THE JUST COPY IT TO ZLIST
C
      IF(ILOC.NE.0)THEN
       IADR=CACHPOS(ILOC)
       IPOS=IADR+IWRDOFF-1
C
c YAU : old
cC       CALL ICOPY(NWORDS,ICORE(IPOS),1,ZLIST,1)
c       CALL SCOPY(NWORDS/IINTFP,ICORE(IPOS),1,ZLIST,1)
c YAU : new
c Someone probably thought that by calling scopy/dcopy, it would be "faster"
c because there are fewer separate memory look-ups; however, what if NWORDS
c is not a multiple of IINTFP? Additionally, how much faster is it once
c you throw in a variable integer divide (it probably doesn't know that
c IINTFP is 1 or 2)?
       CALL ICOPY(NWORDS,ICORE(IPOS),1,ZLIST,1)
c YAU : end
C
       RETURN
      ELSEIF (NWORDS .EQ. LENREC) THEN
        CALL ACES_IO_READ(FILE,RECNUM,ZLIST,LENREC)
      ELSE
C
C THE RECORD MUST BE PICKED UP FROM DISK.  DUMP OLDEST SURVIVING RECORD
C  TO DISK IF IT HAS BEEN MODIFIED.  OTHERWISE, COPY OVER IT.
C
       IF(CACHMOD(OLDEST).NE.0)THEN
        IADR=CACHPOS(OLDEST)
        FILEOUT=UPACKF(CACHDIR(OLDEST))
        RECOUT =UPACKR(CACHDIR(OLDEST)) 
        CALL ACES_IO_WRITE(FILEOUT,RECOUT,ICORE(CACHPOS(OLDEST)),LENREC)
        CACHMOD(OLDEST)=0
       ENDIF
       CALL ACES_IO_READ(FILE,RECNUM,ICORE(CACHPOS(OLDEST)),LENREC)
       CACHMOD(OLDEST)=0
       CACHFILE(OLDEST)=FILE
       CACHDIR (OLDEST)=IPACK(FILE,RECNUM)
       IPOS=CACHPOS(OLDEST)+IWRDOFF-1
       CALL ICOPY(NWORDS,ICORE(IPOS),1,ZLIST,1)
       OLDEST=OLDEST+1
       IF(OLDEST.GT.CACHNUM)OLDEST=1
       RETURN
      ENDIF
C
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine prepare_block(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer)
c---------------------------------------------------------------------------
c   Client-side implementation of the prepare instruction.
c---------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'proto_events.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_barrier_data.h'
      include 'server_monitor.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer instruction_timer, comm_timer

      integer i, j, k
      integer handle, op1, op1_type, ierr
      integer comm_flag, whandle
      integer my_rank, wincomm, my_group, mpi_group_world
      integer nxt
      integer blkndx
      
      integer msg(len_sip_server_message,mx_msg)
      integer imsg, find_free_msg_buffer

      integer*8 indblk, get_block_index
      integer stack
      integer blk
      integer find_current_block
      integer find_block_destination
      integer request
      integer ind(mx_array_index), seg(mx_array_index)
      integer status(MPI_STATUS_SIZE)
      integer nind, blocksize
      integer get_block_request, block_map_lookup
      integer mgr
      integer f_form_msg_tag, tag
      integer mx_msg_used
      character*2 optype
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif
      save msg

      handle = op(c_result_array)
      op1    = op(c_op1_array)
      op1_type = array_table(c_array_type,op1)
      if (array_table(c_array_type,handle) .ne. served_array) then
         print *,'Error: prepare operation must use served array'
         print *,'Array = ',handle,' type = ',
     *            array_table(c_array_type,handle)
         print *,'Operation: ',(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      mx_msg_used = mx_msg
#ifdef ALTIX
      dptr = dshptr
c      mx_msg_used = min(mx_msg, 100)
#endif

c--------------------------------------------------------------------------
c   Set the "prepare" flag, indicating that the server_barrier should destroy
c   all local copies of the array's blocks.
c--------------------------------------------------------------------------

      array_table(c_prepare_flag,handle) = 1

c--------------------------------------------------------------------------
c   Get the segments of the array.
c--------------------------------------------------------------------------

      nind = array_table(c_nindex,handle)
      do i = 1, nind
         ind(i) = array_table(c_index_array1+i-1,handle)
         seg(i) = index_table(c_current_seg,ind(i))
      enddo

c---------------------------------------------------------------------------
c   Find the data to be sent to the I/O mgr.
c---------------------------------------------------------------------------

      blk = find_current_block(op1, array_table(1,op1),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)
      if (blk .lt. 0) then
         print *,'Task ',me,' Cannot find current block of',
     *      ' operand array in PREPARE instruction.'
         print *,'Array = ',op1,' current segments ',
     *         (seg(i),i=1,nind)
         call array_block_summary(array_table, narray_table)
         call dump_block_ids()
         call abort_job()
      endif

      mgr = find_block_destination(handle, array_table,
     *               narray_table, index_table, nindex_table,
     *               block_map_table, nblock_map_table)

      stack  = array_table(c_array_stack,op1)
      indblk = get_block_index(op1, blk, stack, blkndx, x, .true.)

c--------------------------------------------------------------------------
c   Build a prepare message.
c--------------------------------------------------------------------------

      call block_on_server_delay(mgr)
      imsg = find_free_msg_buffer(server_requests, mx_msg_used, 
     *              instruction_timer, comm_timer)

      if (op(c_opcode) .eq. prepare_op) then
         msg(1,imsg) = sip_server_prepare
         optype = 'p'
      else if (op(c_opcode) .eq. prepare_increment_op) then
         msg(1,imsg) = sip_server_prepare_increment
         optype = 'p+'
      else
         print *,'Error: Invalid opcode in prepare_block: ',op(c_opcode)
         call abort_job()
      endif
      msg(2,imsg) = handle
      msg(3,imsg) = nind
      tag    = f_form_msg_tag()
      msg(4,imsg) = tag
      msg(5,imsg) = current_line
      msg(6,imsg) = op(c_server_stat_key)
      nxt =  7
      do i = 1, mx_array_index
         if (i .le. nind) then
            msg(nxt,imsg) = ind(i)
         else
            msg(nxt,imsg) = 0
         endif
         nxt = nxt + 1
      enddo

      blocksize = 1
      do i = 1, nind
         call get_index_segment(ind(i), seg(i), segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, msg(nxt,imsg), 
     *                          msg(nxt+1,imsg))
         blocksize = blocksize * (msg(nxt+1,imsg)-msg(nxt,imsg)+1)
         nxt = nxt + 2
      enddo

      do i = nind+1, mx_array_index
         msg(nxt,imsg)   = 0
         msg(nxt+1,imsg) = 0
         nxt = nxt + 2
      enddo

      msg(7,imsg) = block_map_lookup(seg, nind, handle,
     *                         array_table(1,handle),
     *                         index_table, nindex_table)

      call mpi_isend(msg(1,imsg), len_sip_server_message, 
     *                 mpi_integer, mgr, sip_server_message,
     *                 mpi_comm_world, server_requests(imsg), ierr)

c----------------------------------------------------------------------------
c   Now send the data to be "prepared".
c----------------------------------------------------------------------------

      request = get_block_request(op1, blk, blkndx, request)

c----------------------------------------------------------------------------
c   If the block is engaged in communication from a previous request, 
c   we must wait for it to finish before continuing.
c----------------------------------------------------------------------------

      if (request .ne. MPI_REQUEST_NULL) then
         call wait_on_block(op1, blk, blkndx, op1_type, request,
     *             instruction_timer, comm_timer)
      endif

      call server_monitor_write_log(blkndx, optype, mgr)
      call mpi_isend(x(indblk), blocksize, mpi_double_precision,
     *                 mgr, tag,
     *                 mpi_comm_world, request, ierr) 

      call set_block_request(op1, blk, blkndx, request)
      if (request .ne. MPI_REQUEST_NULL) 
     *    call blkmgr_insert_block_in_list(comm_list_head, 
     *            comm_list_tail, blkndx, c_comm_list_ptr,
     *            .true.)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ANALYZE_RINGS
     +
     +                    ( N,
     +                      R,
     +                      X,Y,Z,
     +                      THRESH,
     +                      USED,
     +
     +                              PLANAR )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ANALYZE_RINGS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine checks, if the current ring R consists
C                of subrings of lesser size.
C
C                Procedure:
C
C                  a) Take the first point P1
C
C
C
C                  Input:
C
C                    N            =  size of ring
C                    R            =  ring atomic indices
C                    X,Y,Z        =  their x,y,z coordinates
C                    THRESH       =  threshold for determining
C                                    coplanarity
C
C
C                  Output:
C
C                    PLANAR       =  is true, if all points are
C                                    coplanar, false otherwise
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     LARGE
         LOGICAL     PLANAR

         INTEGER     I,K,N

         INTEGER     R    (1:N)
         INTEGER     USED (1:N)

         DOUBLE PRECISION  A,B,C,D
         DOUBLE PRECISION  DIFF
         DOUBLE PRECISION  M1,MI
         DOUBLE PRECISION  THRESH
         DOUBLE PRECISION  X1,Y1,Z1
         DOUBLE PRECISION  XC,YC,ZC
         DOUBLE PRECISION  XN
         DOUBLE PRECISION  XP,YP,ZP
         DOUBLE PRECISION  XI,YI,ZI
         DOUBLE PRECISION  ZERO,TWOPI

         DOUBLE PRECISION  COSINE,THETA

         DOUBLE PRECISION  F (1:100)
         DOUBLE PRECISION  X (1:N)
         DOUBLE PRECISION  Y (1:N)
         DOUBLE PRECISION  Z (1:N)

         PARAMETER  (TWOPI = 360.D0)
         PARAMETER  (ZERO  = 0.D0  )
#ifdef __GNUC__
         DOUBLE PRECISION DACOSD
         EXTERNAL DACOSD
#endif
C
C
C------------------------------------------------------------------------
C
C
C             ...check for coplanarity of ring members.
C
C
         CALL  NLO__CHECK_COPLANARITY
     +
     +              ( N,
     +                X,Y,Z,
     +                THRESH,
     +
     +                        PLANAR,
     +                        A,B,C,D )
     +
     +
C
C
C             ...if coplanar, decompose points into regular polygons.
C
C
         IF (PLANAR) THEN

             XC = ZERO
             YC = ZERO
             ZC = ZERO
             DO I = 1,N
                XC = XC + X (I)
                YC = YC + Y (I)
                ZC = ZC + Z (I)
                USED (I) = 0
             END DO
             XC = XC / DFLOAT (N)
             YC = YC / DFLOAT (N)
             ZC = ZC / DFLOAT (N)

             XN = DFLOAT (N)

             X1 = X (1) - XC
             Y1 = Y (1) - YC
             Z1 = Z (1) - ZC
             M1 = DSQRT (X1 * X1 + Y1 * Y1 + Z1 * Z1)
             F (1) = ZERO

             DO I = 2,N
                XI = X (I) - XC
                YI = Y (I) - YC
                ZI = Z (I) - ZC
                MI = DSQRT (XI * XI + YI * YI + ZI * ZI)
                XP = Y1 * ZI - Z1 * YI
                YP = Z1 * XI - X1 * ZI
                ZP = X1 * YI - Y1 * XI
                LARGE = (A*XP + B*YP + C*ZP) .LT. ZERO
                COSINE = (X1*XI + Y1*YI + Z1*ZI) / (M1*MI)
                THETA = DACOSD (COSINE)
                IF (LARGE) THEN
                    THETA = TWOPI - THETA
                END IF
                F (I) = XN * THETA / TWOPI
                K = NINT (F (I))
                DIFF = ABS (F (I) - DFLOAT (K))
                WRITE (*,*) ' Theta,F,DIFF = ',THETA,F(I),DIFF
             END DO



         END IF




C             DO I = 1,1
C                IF (USED (I).EQ.0) THEN
C                    XI = X (I) - XC
C                    YI = Y (I) - YC
C                    ZI = Z (I) - ZC
C                    MI = DSQRT (XI * XI + YI * YI + ZI * ZI)
C
C                    NSUB = 1
C                    RSUB (1) = R (I)
C
C                    DO J = I+1,N
C                       IF (USED (J).EQ.0) THEN
C                           XJ = X (J) - XC
C                           YJ = Y (J) - YC
C                           ZJ = Z (J) - ZC
C                           MJ = DSQRT (XJ * XJ + YJ * YJ + ZJ * ZJ)
C                           XP = YI * ZJ - ZI * YJ
C                           YP = ZI * XJ - XI * ZJ
C                           ZP = XI * YJ - YI * XJ
C                           LARGE = (A*XP + B*YP + C*ZP) .LT. ZERO
C                           COSINE = (XI*XJ + YI*YJ + ZI*ZJ) / (MI*MJ)
C                           THETA = DACOSD (COSINE)
C                           IF (LARGE) THEN
C                               THETA = TWOPI - THETA
C                           END IF
C                           F = XN * THETA / TWOPI
C                           K = NINT (F)
C                           DIFF = ABS (F - DFLOAT (K))
C                           WRITE (*,*) ' Theta,F,DIFF = ',THETA,F,DIFF
C                       END IF
C                    END DO
C                END IF
C             END DO
C         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_INT1D_TO_E0
     +
     +                    ( SHELLA,SHELLP,
     +                      ATOMIC,
     +                      NEXP,
     +                      NXYZET,NXYZP,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_INT1D_TO_E0
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                overlap integrals:
C
C                             [E|0] , E = A to P = A + B,
C
C                adding up all the contributions from all the 1D
C                integrals.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                1DX and 1DY integrals, which can be achieved by having
C                the outer loops run over all possible x and y monomial
C                parts and the inner loop over all allowed E shells.
C
C                For details of the algorithm used, especially how the
C                monomial basis is organized and how to find the batch
C                address for a specific x,y,z,E combination, see the
C                corresponding routine for the ERI evaluations.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A and csh sum P=A+B
C                    ATOMIC      =  indicates, if purely atomic [E|0]
C                                   integrals will be evaluated
C                    NEXP        =  current # of exponent pairs
C                    NXYZET      =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B
C                    NXYZP       =  # of cartesian monomials for the
C                                   P=A+B shell
C                    INT1Dx      =  all current 1D overlap integrals
C                                   for each cartesian component
C                                   x = X,Y,Z
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1D overlap integral products
C                    SCALE       =  the NEXP scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian [E|0]
C                                   overlap integrals corresponding
C                                   to all current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     I,N
         INTEGER     NEXP
         INTEGER     NXYZE,NXYZET,NXYZP
         INTEGER     SE,SEEND
         INTEGER     SHELLA,SHELLP
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX
         INTEGER     XEP,XYEP
         INTEGER     XYE
         INTEGER     YEEND

         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NEXP)
         DOUBLE PRECISION  TEMP1 (1:NEXP)
         DOUBLE PRECISION  TEMP2 (1:NEXP)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZET)

         DOUBLE PRECISION  INT1DX (1:NEXP,0:SHELLP)
         DOUBLE PRECISION  INT1DY (1:NEXP,0:SHELLP)
         DOUBLE PRECISION  INT1DZ (1:NEXP,0:SHELLP)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...the atomic case. Outer loop is over x contributions,
C                middle loop over y contributions and inner loop over
C                z contributions for different E shells. Skip
C                multiplications for x,y,z = 0, since the corresponding
C                1D integrals are equal to 1. Skip contributions if
C                x,y or z are odd, since the corresponding 1D integrals
C                are equal to 0.
C
C
         IF (ATOMIC) THEN

             DO I = 1,NXYZET
             DO N = 1,NEXP
                BATCH (N,I) = ZERO
             END DO
             END DO

             XEP = NXYZET + 3
             DO 100 XE = 0,SHELLP
                XEP = XEP + XE - 2
                XEMAX = XE * SHELLP
                YEEND = SHELLP - XE

                IF (MOD (XE,2).EQ.1) GOTO 100

                IF (XE.EQ.0) THEN
                    DO N = 1,NEXP
                       TEMP1 (N) = SCALE (N)
                    END DO
                ELSE
                    DO N = 1,NEXP
                       TEMP1 (N) = SCALE (N) * INT1DX (N,XE)
                    END DO
                END IF

                XYEP = XEP - XEMAX
                DO 200 YE = 0,YEEND
                   XYE = XE + YE
                   XYEP = XYEP - 1
                   SEEND = MAX0 (SHELLA,XYE)

                   IF (MOD (YE,2).EQ.1) GOTO 200

                   IF (YE.EQ.0) THEN
                       DO N = 1,NEXP
                          TEMP2 (N) = TEMP1 (N)
                       END DO
                   ELSE
                       DO N = 1,NEXP
                          TEMP2 (N) = TEMP1 (N) * INT1DY (N,YE)
                       END DO
                   END IF

                   I = XYEP
                   NXYZE = NXYZP
                   DO 300 SE = SHELLP,SEEND,-1
                      ZE = SE - XYE

                      IF (MOD (ZE,2).EQ.0) THEN
                          IF (ZE.EQ.0) THEN
                              DO N = 1,NEXP
                                 BATCH (N,I) = TEMP2 (N)
                              END DO
                          ELSE
                              DO N = 1,NEXP
                                 BATCH (N,I) = TEMP2 (N) * INT1DZ (N,ZE)
                              END DO
                          END IF
                      END IF

                      I = I - NXYZE + XE
                      NXYZE = NXYZE - SE - 1
  300              CONTINUE

  200           CONTINUE
  100        CONTINUE

         ELSE
C
C
C             ...the nonatomic case. Outer loop is over x contributions,
C                middle loop over y contributions and inner loop over
C                z contributions for different E shells. Skip
C                multiplications for x,y,z = 0, since the corresponding
C                1D integrals are equal to 1.
C
C
             XEP = NXYZET + 3
             DO 110 XE = 0,SHELLP
                XEP = XEP + XE - 2
                XEMAX = XE * SHELLP
                YEEND = SHELLP - XE

                IF (XE.EQ.0) THEN
                    DO N = 1,NEXP
                       TEMP1 (N) = SCALE (N)
                    END DO
                ELSE
                    DO N = 1,NEXP
                       TEMP1 (N) = SCALE (N) * INT1DX (N,XE)
                    END DO
                END IF

                XYEP = XEP - XEMAX
                DO 210 YE = 0,YEEND
                   XYE = XE + YE
                   XYEP = XYEP - 1
                   SEEND = MAX0 (SHELLA,XYE)

                   IF (YE.EQ.0) THEN
                       DO N = 1,NEXP
                          TEMP2 (N) = TEMP1 (N)
                       END DO
                   ELSE
                       DO N = 1,NEXP
                          TEMP2 (N) = TEMP1 (N) * INT1DY (N,YE)
                       END DO
                   END IF

                   I = XYEP
                   NXYZE = NXYZP
                   DO 310 SE = SHELLP,SEEND,-1
                      ZE = SE - XYE

                      IF (ZE.EQ.0) THEN
                          DO N = 1,NEXP
                             BATCH (N,I) = TEMP2 (N)
                          END DO
                      ELSE
                          DO N = 1,NEXP
                             BATCH (N,I) = TEMP2 (N) * INT1DZ (N,ZE)
                          END DO
                      END IF

                      I = I - NXYZE + XE
                      NXYZE = NXYZE - SE - 1
  310              CONTINUE

  210           CONTINUE
  110        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine der4_comp(x, nindex, type, bval,
     *                              eval, bdim, edim)
c-------------------------------------------------------------------------- 
      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      integer*8 integral_scr
      integer maxblk, nsend

      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      inter (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf
      equivalence (ibuf(1), dbuf(1))
#endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      if (nindex .ne. 4) then
         print *,'Error: der4_comp was called with an array ',
     *        ' which has ',nindex,' indices.'
         print *,'       This routine requires 4 indices.'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Compute the block of integrals.
c---------------------------------------------------------------------------

         if (intpkg .eq. flocke_package) then
            integral_scr = dpkgscr
            maxblk  = zmax
         else if (intpkg .eq. gamess_package .or.
     *            intpkg .eq. gamess_derivative_package) then
            integral_scr = i0wrk
            maxblk = 15**4    ! max. angular momentum for GAMESS is 15.
         endif

      if (.not. dryrun) 
     *   call compute_der2_batch(bval(1),eval(1), bval(2),eval(2),
     *                       bval(3),eval(3),bval(4),eval(4),
     *                 dbuf(integral_scr),maxblk, ibuf(ipkgscr),
     *                 dbuf(icoord),dbuf(ipcoeff),dbuf(ialpha), 
     *                 ibuf(iccbeg), ibuf(iccend), 
     *                 x, nsend)

      return
      end

      SUBROUTINE SETRHF(FAC, IOFFST, IP)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION IP(20), FAC(9, 9), IOFFST(15)
C
      IBTAND(I,J) = IAND(I,J)
      IBTOR(I,J)  = IOR(I,J)
      IBTXOR(I,J) = IEOR(I,J)
      IBTSHL(I,J) = ISHFT(I,J)
      IBTSHR(I,J) = ISHFT(I,-J)
      IBTNOT(I)   = NOT(I)
c
      IOFFST(1) = 0
      IOFFST(3) = 1
      IOFFST(6) = 4 
      IOFFST(10) = 10
      IOFFST(15) = 20
C
      CALL SETLMN
C
      FAC(1,1)=1.0
      FAC(2,1)=1.0
      FAC(2,2)=1.0
C
      DO  I=3,9
         FAC(I,1)=1.0
         FAC(I,I)=1.0
         JE=I-1
         DO J=2,JE
            FAC(I,J)=FAC(I-1,J-1)+FAC(I-1,J)
         ENDDO
      ENDDO
C
      IP(1)=0
      IP(2)=IBTSHL(1,20)
      IP(3)=IBTSHL(1,10)
      IP(4)=1
      IP(5)=IBTSHL(2,20)
      IP(6)=IBTSHL(2,10)
      IP(7)=2
      IP(8)=IBTOR(IBTSHL(1,20),IBTSHL(1,10))
      IP(9)=IBTOR(IBTSHL(1,20),1)
      IP(10)=IBTOR(IBTSHL(1,10),1)
      IP(11)=IBTSHL(3,20)
      IP(12)=IBTSHL(3,10)
      IP(13)=3
      IP(14)=IBTOR(IBTSHL(2,20),IBTSHL(1,10))
      IP(15)=IBTOR(IBTSHL(2,20),1)
      IP(16)=IBTOR(IBTSHL(1,20),IBTSHL(2,10))
      IP(17)=IBTOR(IBTSHL(2,10),1)
      IP(18)=IBTOR(IBTSHL(1,20),2)
      IP(19)=IBTOR(IBTSHL(1,10),2)
      IP(20)=IBTOR(IBTSHL(1,20),IBTOR(IBTSHL(1,10),1))
C
      RETURN
      END
C
      SUBROUTINE SETLMN
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXANG=7)
C
C....    SET ANGULAR QUANTUM NUMBERS AND COMPUTE CARTESIAN
C....    NORMALIZATION FACTORS
C
      COMMON /HIGHL/ LMNVAL(3,84), ANORM(84)
      DIMENSION FACS(0:MAXANG-1)
      DATA FACS /1.D0, 1.D0, 3.D0, 15.D0, 105.D0, 945.D0, 10395.D0/
      II = 0
      DO 10 LVAL = 0,MAXANG-1
         DO 20 L = LVAL,0,-1
            LEFT = LVAL - L
            DO 30 M = LEFT,0,-1
               N = LEFT - M
               II = II + 1
               LMNVAL(1,II) = L
               LMNVAL(2,II) = M
               LMNVAL(3,II) = N
               ANORM(II) = FACS(L)*FACS(M)*FACS(N)
 30         CONTINUE
 20      CONTINUE
 10   CONTINUE
      RETURN 
      END

c This routine prepares or loads data needed for parallel finite differences.
c The goto routine for what should be done is symcor/upd_fd.F

#include "flags.h"

      subroutine parfd(args,dimargs)
      implicit none

c ARGUMENT LIST
      integer dimargs
      character*80 args(*)

c INTERNAL VARIABLES
      double precision dDipXYZ(3), dPolXYZ(3,3), dTmp
      integer nAtom, nSize, nPoint, iOff, iLast, iTmp
      integer lFree, lGeom, lGrdXYZ, lGrdInt, lIMAP
      character*80 szRecName
      character*4 szType
      logical bUpdate, bDump, bAnGrad, bExist, bNotDone

c EXTERNAL FUNCTIONS
      integer  linblnk, atoi
      external linblnk, atoi

c COMMON BLOCKS
#include "machsp.com"
#include "icore.com"
#include "istart.com"
#include "parallel_aces.com"
#include "flags.com"
#include "flags2.com"

c ----------------------------------------------------------------------

c   o load system size and number of displacements
      call getrec(1,'JOBARC','NUMPOINT',1,nPoint)
      call getrec(1,'JOBARC','NATOMS',1,nAtom)
      nSize = 3*nAtom

c   o set action flags
      bUpdate = (args(1)(1:3).eq.'upd')
      bDump   = (args(1)(1:4).eq.'dump').or.(args(1)(1:6).eq.'updump')
      bAnGrad = iflags2(h_IFLAGS2_grad_calc).eq.1

c   o initialize the icore free space pointer
      lFree = i0

      if (bUpdate.or.bDump) then

c      o find last displacement which was calculated
         call getrec(1,'JOBARC','FDCALCTP',nPoint,icore(lFree))
         iOff = nPoint-1
         do while ((icore(lFree+iOff).ge.0).and.(iOff.ge.0))
            iOff = iOff - 1
         end do
         iLast = 1+iOff
         if (iLast.eq.0) return

c      o print the reference energy
         if (bDump) then
            call getrec(1,'JOBARC','REFENERG',iintfp,dTmp)
            if (dTmp.ne.0.d0) call ja_dump('REFENERG',iintfp,1,dTmp)
         end if

c      o print the energy vector
         call getrec(1,'JOBARC','ENGPOINT',iintfp*nPoint,icore(lFree))
         if (bUpdate) then
            if (iflags(h_IFLAGS_excite).eq.0) then
               call getrec(1,'JOBARC','TOTENERG',iintfp,
     &                     icore(lFree+iintfp*iOff))
            else
               call getrec(1,'JOBARC','TOTENER2',iintfp,
     &                     icore(lFree+iintfp*iOff))
            end if
            call putrec(1,'JOBARC','ENGPOINT',iintfp*iLast,icore(lFree))
         end if
         if (bDump) then
            call ja_dump('ENGPOINT',iintfp,nPoint,icore(lFree))
         end if

         if (bAnGrad) then

            if (bUpdate) then
c            o determine the scope of symmetry
               call getrec(-1,'JOBARC','DANGERUS',1,iTmp)
               if (iflags(h_IFLAGS_fd_usegroup).eq.0.and.iTmp.eq.0) then
                  szType='FULL'
               else
                  szType='COMP'
               end if
c            o assign indices
               lGrdInt = lFree
               lFree = lFree + iintfp*nSize
               lGrdXYZ = lFree
               lFree = lFree + iintfp*nSize
               lGeom = lFree
               lFree = lFree + iintfp*nSize
               lIMAP = lFree
               lFree = lFree + nAtom + iand(nAtom,1)
               iTmp = (icrsiz+i0-lFree)/iintfp
c            o load the original coordinates for the last displacement
               call getrec(1,'JOBARC','FDCOORDS',iintfp*nSize*iLast,
     &                     icore(lGeom))
               call c_memmove(icore(lGeom),
     &                        icore(lGeom+iintfp*nSize*iOff),
     &                        ifltln*nSize)
c            o load and rotate the derivatives
               call getgrd(nAtom,szType,icore(lGeom),
     &                     icore(lGrdXYZ),icore(lGrdInt),
     &                     dDipXYZ,dPolXYZ,icore(lIMAP),
     &                     icore(lFree),iTmp,.false.)
c            o reclaim scratch after GRDINT
               lFree = lGrdXYZ
            end if

c         o energy gradient
            call getrec(1,'JOBARC',
     &                  'GRDPOINT',iintfp*nSize*nPoint,icore(lFree))
            if (bUpdate) then
               call dcopy(nSize,icore(lGrdInt),1,
     &                          icore(lFree+iintfp*nSize*iOff),1)
               call putrec(1,'JOBARC',
     &                     'GRDPOINT',iintfp*nSize*iLast,icore(lFree))
            end if
            if (bDump) then
               Call ja_dump('GRDPOINT',iintfp*3,nAtom*nPoint,
     &                      icore(lFree))
            end if

c         o dipole
            call getrec(1,'JOBARC',
     &                  'DIPPOINT',iintfp*3*nPoint,icore(lFree))
            if (bUpdate) then
               call dcopy(3,dDipXYZ,1,icore(lFree+iintfp*3*iOff),1)
               call putrec(1,'JOBARC',
     &                     'DIPPOINT',iintfp*3*iLast,icore(lFree))
            end if
            if (bDump) then
               call ja_dump('DIPPOINT',iintfp*3,nPoint,
     &                      icore(lFree))
            end if

c         o polarizability
            call getrec(1,'JOBARC',
     &                  'POLPOINT',iintfp*9*nPoint,icore(lFree))
            if (bUpdate) then
               call dcopy(9,dPolXYZ,1,icore(lFree+iintfp*9*iOff),1)
               call putrec(1,'JOBARC',
     &                     'POLPOINT',iintfp*9*iLast,icore(lFree))
            end if
            if (bDump) then
               call ja_dump('POLPOINT',iintfp*3,3*nPoint,
     &                      icore(lFree))
            end if

c        end if (bAnGrad)
         end if

      else if (args(1)(1:4).eq.'load') then

c      o open the record file
         iLast = linblnk(args(2))
         inquire(file=args(2)(1:iLast),exist=bExist)
         if (bExist) then
            open(unit=10,file=args(2)(1:iLast),form='FORMATTED')
            rewind(10)
         else
            print *, '@PARFD: The record file does not exist.'
            print *, '        file = "',args(2)(1:iLast),'"'
            return
         end if

         bNotDone = .true.
         do while (bNotDone)

c         o read the record name
            read(10,fmt='(a)',end=100) szRecName

c         o branch on the record
            if      (szRecName(1:8).eq.'REFENERG') then
               call ja_load_dbl(10,szRecName(1:8),
     &                          1,1,icore(lFree))
            else if (szRecName(1:8).eq.'ENGPOINT') then
               call ja_load_dbl(10,szRecName(1:8),
     &                          1,nPoint,icore(lFree))
            else if (szRecName(1:8).eq.'GRDPOINT') then
               call ja_load_dbl(10,szRecName(1:8),
     &                          3,nAtom*nPoint,icore(lFree))
            else if (szRecName(1:8).eq.'DIPPOINT') then
               call ja_load_dbl(10,szRecName(1:8),
     &                          3,nPoint,icore(lFree))
            else if (szRecName(1:8).eq.'POLPOINT') then
               call ja_load_dbl(10,szRecName(1:8),
     &                          3,3*nPoint,icore(lFree))
            else
               bNotDone = .false.
            end if

         end do
 100     continue

c      o close the record file
         close(unit=10,status='KEEP')

      else

         print *, '@PARFD: The parfd module requires 1 or 2 arguments'
         print '()'
         print *, '  xa2proc parfd update'
         print *, '  xa2proc parfd (up)dump'
         print *, '  xa2proc parfd load <file>'
         call aces_exit(1)

      end if

      return
c     end subroutine parfd
      end

c ----------------------------------------------------------------------

      subroutine ja_dump(szRecName,nRows,nCols,icore)
      implicit none

      character*8 szRecName
      integer nRows, nCols
      integer icore(nRows,nCols)

      integer iRow, iCol

      if (nRows.eq.0.or.nCols.eq.0) return

      print '(a)', szRecName
      do iCol = 1, nCols
         print *, (icore(iRow,iCol),iRow=1,nRows)
      end do

      return
      end

c ----------------------------------------------------------------------

      subroutine ja_load_dbl(iUnit,szRecName,nRows,nCols,icore)
      implicit none

      integer iUnit
      character*8 szRecName
      integer nRows, nCols
      integer icore(*)

      integer iOff, iRow, iCol

#undef _MACHSP_COM_
#include "machsp.com"

      iOff = 0
      do iCol = 1, nCols
         read(10,fmt=*) (icore(iRow+iOff),iRow=1,iintfp*nRows)
         iOff = iOff + iintfp*nRows
      end do
C      print *, 'DEBUG: icore = ',(icore(iOff),iOff=1,iintfp*nRows*nCols)

      call getrec(1,'JOBARC',szRecName,iintfp*nRows*nCols,icore(1+iOff))
      call parfd_repl_nz(nRows*nCols,icore(1),icore(1+iOff))
      call putrec(1,'JOBARC',szRecName,iintfp*nRows*nCols,icore(1+iOff))

      return
      end

c ----------------------------------------------------------------------

      subroutine parfd_repl_nz(iNum,dSrc,dDest)
      implicit none
      integer iNum
      double precision dSrc(*), dDest(*)
      integer i
      do i = 1, iNum
         if (dSrc(i).ne.0.d0) dDest(i) = dSrc(i)
      end do
      return
      end

         SUBROUTINE  OED__NAI_DERV_INT1D_TO_00_F12
     +
     +                    ( NEXP,NGQPCEN,NGEXCEN,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,
     +                      SCALE,RTS,UVAL,STGEXP,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_DERV_INT1D_TO_00
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative nuclear attraction integrals [0|0], adding
C                up the contributions from all the 1D 00 integrals for
C                all nuclear centers.
C
C                Simplified version of the general AB routine to reduce
C                loop overheads for those cases where only s-shells
C                are involved. For comments and details see the general
C                AB routine.
C
C
C                  Input:
C
C                    NEXP        =  current # of exponent pairs
C                    NGQPCEN     =  product of # of gaussian quadrature
C                                   points (roots) times # of nuclear
C                                   attraction centers
C                    NGEXCEN     =  product of # of gaussian quadrature
C                                   points times # of exponent pairs
C                                   times # of nuclear attraction
C                                   centers
C                    INT1Dx      =  all current 1D 00 derivative
C                                   nuclear attraction integrals for
C                                   each cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1       =  scratch array holding intermediate
C                                   1D 00 derivative integral products
C                    SCALE       =  the NGEXCEN scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [0|0] derivative nuclear attraction
C                                   integrals corresponding to all
C                                   current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program OED
C
C    This routine is part of the integral program package OED and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routines of the
C    OED package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     K,M,N
         INTEGER     NEXP,NGQPCEN,NGEXCEN

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO,STGEXP,UVAL(1:NEXP),RTS(1:NGEXCEN) 

         DOUBLE PRECISION  SCALE (1:NGEXCEN)
         DOUBLE PRECISION  TEMP1 (1:NGEXCEN)

         DOUBLE PRECISION  BATCH (1:NEXP)

         DOUBLE PRECISION  INT1DX (1:NGEXCEN)
         DOUBLE PRECISION  INT1DY (1:NGEXCEN)
         DOUBLE PRECISION  INT1DZ (1:NGEXCEN)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...no skipping of 1DX integrals can be done here,
C                since the 1DX integrals carry the Rys weight!
C
C
c            write(6,*) '********++++++++++'

         DO N = 1,NGEXCEN
            TEMP1 (N) = SCALE (N) * INT1DX (N)
         END DO
C
C
C             ...skip the multiplication of 1DY integrals, if no
C                y-coordinate derivative was formed, as then the
C                1DY integrals are equal to 1. Same with the 1DZ
C                1DZ integrals.
C
C
         IF (.NOT.DIFFY .AND. .NOT.DIFFZ) THEN
             K = 0
             DO M = 1,NEXP
                SUM = ZERO
                DO N = 1,NGQPCEN
                   SUM = SUM + TEMP1 (K+N)*(1.d0-RTS(K+N) )
                END DO
                K = K + NGQPCEN
                BATCH (M) = SUM*(2.d0*UVAL(M)/STGEXP)
             END DO
         ELSE IF (.NOT.DIFFY) THEN
             K = 0
             DO M = 1,NEXP
                SUM = ZERO
                DO N = 1,NGQPCEN
                 SUM = SUM + TEMP1 (K+N) * INT1DZ (K+N)*(1.d0-RTS(K+N) )
                END DO
                K = K + NGQPCEN
                BATCH (M) = SUM*(2.d0*UVAL(M)/STGEXP)
             END DO
         ELSE IF (.NOT.DIFFZ) THEN
             K = 0
             DO M = 1,NEXP
                SUM = ZERO
                DO N = 1,NGQPCEN
                 SUM = SUM + TEMP1 (K+N) * INT1DY (K+N)*(1.d0-RTS(K+N) )
                END DO
                K = K + NGQPCEN
                BATCH (M) = SUM*(2.d0*UVAL(M)/STGEXP)
             END DO
         ELSE
             DO N = 1,NGEXCEN
                TEMP1 (N) = TEMP1 (N) * INT1DY (N)
             END DO
             K = 0
             DO M = 1,NEXP
                SUM = ZERO
                DO N = 1,NGQPCEN
                 SUM = SUM + TEMP1 (K+N) * INT1DZ (K+N)*(1.d0-RTS(K+N) )
                END DO
                K = K + NGQPCEN
                BATCH (M) = SUM*(2.d0*UVAL(M)/STGEXP)
             END DO
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__OVL_DERV_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      NEXP,
     +                      NXYZA,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__OVL_DERV_INT1D_TO_A0
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative overlap integrals [A|0] or [0|A].
C
C                Simplified version of the general AB routine to reduce
C                loop overheads for those cases where there is at least
C                one s-shell. For comments and details see the general
C                AB routine.
C
C
C                  Input:
C
C                    SHELLA      =  shell types for contraction shell A
C                    NEXP        =  current # of exponent pairs
C                    NXYZA       =  # of cartesian monomials for shell A
C                    INT1Dx      =  all current 1D A0/0A derivative
C                                   nuclear attraction integrals for
C                                   each cartesian component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x = X,Y,Z
C                                   direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1D A0/0A derivative integral
C                                   products
C                    SCALE       =  the NEXP scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [A|0] or [0|A] derivative overlap
C                                   integrals corresponding to all
C                                   current exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFX,DIFFY,DIFFZ

         INTEGER     I,N
         INTEGER     NEXP
         INTEGER     NXYZA
         INTEGER     SHELLA
         INTEGER     XA,YA,ZA
         INTEGER     YAMAX

         DOUBLE PRECISION  SCALE (1:NEXP)
         DOUBLE PRECISION  TEMP1 (1:NEXP)
         DOUBLE PRECISION  TEMP2 (1:NEXP)

         DOUBLE PRECISION  BATCH (1:NEXP,1:NXYZA)

         DOUBLE PRECISION  INT1DX (1:NEXP,0:SHELLA)
         DOUBLE PRECISION  INT1DY (1:NEXP,0:SHELLA)
         DOUBLE PRECISION  INT1DZ (1:NEXP,0:SHELLA)
C
C
C------------------------------------------------------------------------
C
C
C             ...outer loop over x-contribution. Skip the multiplication
C                of x-contributions, if no x-coordinate derivative was
C                formed and we have a 0-contribution, as then the 1DX
C                integrals are equal to 1.
C
C
         I = 0
         DO 100 XA = SHELLA,0,-1
            YAMAX = SHELLA - XA

            IF (.NOT.DIFFX .AND. XA.EQ.0) THEN
                DO N = 1,NEXP
                   TEMP1 (N) = SCALE (N)
                END DO
            ELSE
                DO N = 1,NEXP
                   TEMP1 (N) = SCALE (N) * INT1DX (N,XA)
                END DO
            END IF
C
C
C             ...inner loop over y-contribution. Skip the multiplication
C                of y-contributions, if no y-coordinate derivative
C                was formed and we have a 0-contribution, as then the
C                1DY integrals are equal to 1.
C
C
            DO 110 YA = YAMAX,0,-1
               I = I + 1
               ZA = YAMAX - YA

               IF (.NOT.DIFFY .AND. YA.EQ.0) THEN
                   DO N = 1,NEXP
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NEXP
                      TEMP2 (N) = TEMP1 (N) * INT1DY (N,YA)
                   END DO
               END IF
C
C
C             ...skip multiplication of z-contributions, if we
C                have a 0-type and no derivations were performed
C                on the z-coordinate, as then the 1DZ integrals
C                are equal to 1. All info concerning all three
C                x,y and z contributions have been collected for all
C                exponent pairs. Put the 1D X,Y,Z integral products
C                in the appropriate places of the [A|0] or [0|A] batch.
C
C
               IF (.NOT.DIFFZ .AND. ZA.EQ.0) THEN
                   DO N = 1,NEXP
                      BATCH (N,I) = TEMP2 (N)
                   END DO
               ELSE
                   DO N = 1,NEXP
                      BATCH (N,I) = TEMP2 (N) * INT1DZ (N,ZA)
                   END DO
               END IF
C
C
C             ...next z- and y-contributions.
C
C
  110       CONTINUE
C
C
C             ...next x-contribution.
C
C
  100    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

c NOTE: This routine was blatantly ripped from netlib/TOMS.
c       I, Anthony Yau, removed all those GOTO statements and
c       replaced them with DO WHILE loops and a minimum of
c       code replication.
c       (cf. http://www.netlib.org/toms/513)

c ---------------------------------------------
c --- TRANSPOSE A RECTANGULAR ARRAY IN SITU ---
c ---------------------------------------------

c CALL DXPOSE(A,M,N,ADIM,WORK,WORKDIM,IERR)
c
c A    = { double precision array of single dimension ADIM }
c        the double precision array to be transposed
c
c M, N = { integer }
c        the dimensions of A(M,N) before transposition
c        stored columnwise
c
c ADIM = { integer }
c        M*N
c
c WORK = { integer array }
c        a work array
c
c WORKDIM = { integer }
c           the dimension of WORK(), recommended to be (M+N)/2
c
c IERR = { integer }
c        a return code
c      = 0  := normal
c      = -1 := ADIM.NE.(M*N)
c      = -2 := WORKDIM.LE.0
c      > 0  := (rare) the final value of i when the search is
c              complete but some loops have not been moved
c              NOTE: work(i) will stay zero for fixed points

      subroutine dxpose(a,m,n,adim,work,workdim,ierr)
      implicit none

c ARGUMENT LIST
      integer m, n, adim
      double precision a(adim)
      integer workdim, work(workdim), ierr

c INTERNAL VARIABLES
      double precision b, c, d
      integer n1, ncount, max, im
      integer j, j1
      integer i, i1, i2, i1c, i2c
      integer k, kmi
      integer itmp, ir1, ir2
      logical still_going

c ----------------------------------------------------------------------

      ierr = 0
      if (adim.ne.m*n)  ierr = -1
      if (workdim.lt.1) ierr = -2
      if ((ierr.ne.0).or.(m.lt.2).or.(n.lt.2)) return

      if (m.eq.n) then
         n1 = n-1
         do i = 1, n1
            j1 = i+1
            do j = j1, n
               i1 = i + (j-1)*n
               i2 = j + (i-1)*m
               b     = a(i1)
               a(i1) = a(i2)
               a(i2) = b
            end do
         end do
         return
      end if

      ncount = 2
      k = adim-1
      do itmp = 1, workdim
         work(itmp) = 0
      end do

      if ((m.gt.2).and.(n.gt.2)) then
c      o calculate the number of fixed points using Euclid's algorithm
c        for GCD(m-1,n-1)
         ir2  = m-1
         ir1  = n-1
         itmp = 1
         do while (itmp.ne.0)
            itmp = mod(ir2,ir1)
            ir2  = ir1
            ir1  = itmp
         end do
         ncount = ir2+1
      end if

c     set initial values for search
      i  = 1
      im = m

c     we return only when ncount.ge.adim (or we error)
      do while (ncount.lt.adim)
         i1  = i
         kmi = k-i
         b   = a(i1+1)
         i1c = kmi
         c   = a(i1c+1)
         still_going = .true.
         do while (still_going)
c         o leave this line as is since k*(i1/n) recasts the product
            i2  = m*i1 - k*(i1/n)
            i2c = k-i2
            if (i1 .le.workdim) work(i1 ) = 1
            if (i1c.le.workdim) work(i1c) = 1
            ncount = ncount + 2
            if (i2.eq.i) then
               a(i1+1)  = b
               a(i1c+1) = c
               still_going = .false.
            else
               if (i2.eq.kmi) then
                  d = b
                  b = c
                  c = d
                  a(i1+1)  = b
                  a(i1c+1) = c
                  still_going = .false.
               else
                  a(i1+1)  = a(i2+1)
                  a(i1c+1) = a(i2c+1)
                  i1  = i2
                  i1c = i2c
c              end if (i2.eq.kmi)
               end if
c           end if (i2.eq.i)
            end if
c        end do while (still_going)
         end do
         if (ncount.lt.adim) then
            still_going = .true.
            do while (still_going)
               max = k-i
               i   = i+1
               if (i.gt.max) then
                  ierr = i
                  return
               end if
               if (im.gt.k) then
                  im = im-k
               else
                  im = im+m
               end if
               i2 = im
               if (i.ne.i2) then
                  if (i.gt.workdim) then
                     if ((i.lt.i2).and.(i2.lt.max)) then
                        do while ((i.lt.i2).and.(i2.lt.max))
                           i1 = i2
                           i2 = m*i1 - k*(i1/n)
                        end do
                     end if
c                     if (i2.eq.i) still_going = .false.
                     still_going = (i2.ne.i)
                  else
c                     if (work(i).eq.0) still_going = .false.
                     still_going = (work(i).ne.0)
                  end if
               end if
c           end do while (still_going)
            end do
c        end if (ncount.lt.adim)
         end if
c     end do while (ncount.lt.adim)
      end do

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine checkpoint(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'dbugcom.h'
      include 'checkpoint_data.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer status(MPI_STATUS_SIZE)
      integer msg(5)
      integer i
      integer ierr
      integer company_comm, pst_get_company_comm
      integer array, array_type

      integer pst_get_company
      integer niocompany
      integer request(10000)
      integer statuses(MPI_STATUS_SIZE,10000)

      character*40 ckpt_msg

      if (.not. mpi_io_support) return

      array = op(c_result_array)
      if (array .ne. 0) then
         array_type = array_table(c_array_type, array)
         if (array_type .ne. served_array .and. 
     *       array_type .ne. distributed_array) then
            print *,
     *       'Error: checkpoint instruction requires a served or ',
     *       'distributed array'
            call abort_job()
         endif
      else
         array_type = 0   ! no arg for checkpoint instruction
      endif
 
      if (me .eq. 0) then

c-------------------------------------------------------------------------
c   Send a checkpoint message to each I/O server.
c-------------------------------------------------------------------------

         if (array_type .eq. served_array) then
            niocompany = 0
            msg(1) = sip_server_checkpoint_signal
            msg(2) = array
            msg(3) = 0
            msg(4) = current_line   ! in the "tag" field of the msg.
            do i = 1, nprocs
               if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Send the checkpoint message.
c---------------------------------------------------------------------------

                  niocompany = niocompany + 1
                  call mpi_isend(msg, 4,
     *               MPI_INTEGER, i-1,
     *               sip_server_message, mpi_comm_world,
     *               request(niocompany), ierr)
               endif
            enddo

c---------------------------------------------------------------------------
c   Wait until all servers have received their checkpoint signal.
c---------------------------------------------------------------------------

            call mpi_waitall(niocompany, request,
     *                    statuses, ierr)
            call prt_time('All server ckpt signals were received.')

            niocompany = 0
            do i = 1, nprocs
               if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Receive the "checkpoint complete" message.
c   Each server will send a 1-word indicator message using the
c   sip_server_checkpoint_signal as the message tag.
c---------------------------------------------------------------------------

                  niocompany = niocompany + 1
                  call mpi_irecv(msg, 1,
     *               MPI_INTEGER, i-1,
     *               sip_server_checkpoint_signal, mpi_comm_world,
     *               request(niocompany), ierr)
               endif
            enddo

c-----------------------------------------------------------------------
c   Wait for all the acknowledgement messages.
c------------------------------------------------------------------------

            call mpi_waitall(niocompany, request, statuses,
     *                    ierr)
         endif   ! array_type .eq. served_array
      endif   ! me .eq. 0


      if (array_type .eq. distributed_array) then
         call checkpoint_distributed_array(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      endif

c--------------------------------------------------------------------------
c   Workers must wait at this barrier untile all have completed their task.
c--------------------------------------------------------------------------

      company_comm = pst_get_company_comm(me) 
      call mpi_barrier(company_comm, ierr)
      if (dbg) then
         print *,'Task ',me,' Passed checkpoint worker barrier'
         call c_flush_stdout()
      endif

      return
      end

      subroutine checkpoint_distributed_array(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c---------------------------------------------------------------------------
c   Performs a checkpoint of a distributed array in parallel using MPI-IO.
c---------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'dbugcom.h'
      include 'checkpoint_data.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer array
      integer company_comm, pst_get_company_comm
      integer fh, mode, ierr
      integer nblk, iblock, iblock_map
      integer ind(mx_array_index)
      integer seg(mx_array_index)
      integer i, k, size , nreq
      integer*8 offset

      integer mx_mpi_req
      parameter (mx_mpi_req = 10000)
      integer request(mx_mpi_req)
      integer statuses(MPI_STATUS_SIZE,mx_mpi_req) 
      integer blkndx, stack, nindex, val1, val2
      integer ientry
      integer*8 filelen
      integer*8 indblk, get_block_index

      logical new_array

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      array = op(c_result_array)
      nindex = array_table(c_nindex,array)
#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Determine if this array has previously been checkpointed.
c---------------------------------------------------------------------------

      new_array = .false.
      do i = 1, nckpt_arrays
         if (ckpt_arrays(i) .eq. array) then
            ientry = i
            go to 100
         endif
      enddo

c---------------------------------------------------------------------------
c   Add array to table of checkpointed arrays.
c---------------------------------------------------------------------------

      nckpt_arrays          = nckpt_arrays + 1
      ientry                = nckpt_arrays
      ckpt_arrays(ientry)   = array
      ckpt_diskaddr(ientry) = 0
      call determine_array_size(array, array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      disk_sizes(ientry))

      new_array             = .true.
 
  100 continue

c---------------------------------------------------------------------------
c   Open the checkpoint data file.
c---------------------------------------------------------------------------

      company_comm = pst_get_company_comm(me)
      mode = MPI_MODE_CREATE + MPI_MODE_WRONLY 
      call mpi_file_open(company_comm, 'CKPT_DIST', mode,
     *                   MPI_INFO_NULL, fh, ierr)
      offset = 0
      call mpi_file_set_view(fh, offset, MPI_DOUBLE_PRECISION,
     *                       MPI_DOUBLE_PRECISION, 'native', 
     *                       MPI_INFO_NULL, ierr)

      call mpi_file_get_size(fh, filelen, ierr)
      filelen = filelen / bytes_per_double
      call mpi_barrier(company_comm, ierr)

c---------------------------------------------------------------------------
c   Determine beginning array file offset to use for this array.
c---------------------------------------------------------------------------

      if (new_array) then

c---------------------------------------------------------------------------
c   Can we find free space to hold the array?
c---------------------------------------------------------------------------

         do i = 1, nfree_space
            if (free_space_sizes(i) .ge. disk_sizes(ientry)) then
               ckpt_diskaddr(ientry) = free_space(i)
               free_space(i) = -1
               free_space_sizes(i) = -1
               go to 150
            endif
         enddo
 
c---------------------------------------------------------------------------
c   No free space available is large enough.  Add to end of file.
c---------------------------------------------------------------------------

         ckpt_diskaddr(ientry) = filelen   
  150    continue
         offset = ckpt_diskaddr(ientry)  
      else
         
c---------------------------------------------------------------------------
c   Check for a free space entry large enough to hold the array.
c---------------------------------------------------------------------------

         do i = 1, nfree_space
            if (free_space_sizes(i) .ge. disk_sizes(ientry)) then
               offset = free_space(i)

c---------------------------------------------------------------------------
c   Add existing data entry to list of free space candidates.
c---------------------------------------------------------------------------

               nfree_space_candidates = nfree_space_candidates + 1
               free_space_candidates(nfree_space_candidates) = 
     *                          ckpt_diskaddr(ientry)
               candidate_sizes(nfree_space_candidates) = 
     *                          disk_sizes(ientry)

c---------------------------------------------------------------------------
c   Mark existing free space entry as used.
c---------------------------------------------------------------------------

               free_space(i)       = -1
               free_space_sizes(i) = -1
               ckpt_diskaddr(ientry) = offset
               go to 200
            endif
         enddo

c---------------------------------------------------------------------------
c   No free space entry was found that is large enough.  Add to the end of 
c   file, and use the existing copy of the array as a new free space 
c   candidate.  When the checkpoint is committed, the candidates become
c   actual free space entries.
c---------------------------------------------------------------------------

         nfree_space_candidates = nfree_space_candidates + 1
         if (nfree_space .gt. mx_ckpt_arrays) then
            print *,'Error: Checkpoint has run out of room ',
     *          'for free space entries.'
            call abort_job()
         endif
 
         offset                        = filelen
         free_space_candidates(nfree_space_candidates) = 
     *                ckpt_diskaddr(ientry)
         candidate_sizes(nfree_space_candidates) = disk_sizes(ientry)

         ckpt_diskaddr(ientry)         = offset
  200    continue
      endif

c---------------------------------------------------------------------------
c   Loop over the blocks of the array, writing them into the appropriate slot 
c   within the file.
c----------------------------------------------------------------------------

      nblk = array_table(c_numblks, array)
      iblock_map = array_table(c_block_map, array)
      nreq = 0
      do iblock = 1, nblk

c--------------------------------------------------------------------------
c   Determine block size in words.
c--------------------------------------------------------------------------

         size = 1
         do k = 1, nindex
            ind(k) = array_table(c_index_array1+k-1,array)
            seg(k) = block_map_table(c_block_map_seg+k-1,
     *                       iblock_map+iblock-1)
            call get_index_segment(ind(k), seg(k), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            size = size * (val2-val1+1)
         enddo

         blkndx = block_map_table(c_bmap_blkndx,iblock_map+iblock-1)
         if (block_map_table(c_processor,iblock_map+iblock-1) .eq.
     *          my_company_rank) then

c----------------------------------------------------------------------------
c   The block resides on this processor.   Write it to disk.
c----------------------------------------------------------------------------

            stack  = array_table(c_array_stack,array)
            indblk = get_block_index(array, iblock, stack, blkndx, 
     *                               x, .true.)
 
            if (nreq .eq. mx_mpi_req) then
               call mpi_waitall(nreq, request, statuses, ierr)
               nreq = 0
            endif

            nreq = nreq + 1
            call mpi_file_iwrite_at(fh, offset, x(indblk), size, 
     *                              MPI_DOUBLE_PRECISION, request(nreq),
     *                              ierr)
         endif   

         offset = offset + size
      enddo    ! iblock
    
c----------------------------------------------------------------------------
c   Wait on MPI requests to complete.
c---------------------------------------------------------------------------

      if (nreq .gt. 0) call mpi_waitall(nreq, request, statuses, ierr)

c----------------------------------------------------------------------------
c   Sync the data to the file, close file.
c----------------------------------------------------------------------------

      call mpi_file_sync(fh, ierr)
      call mpi_file_close(fh, ierr)

      return
      end

      subroutine determine_array_size(array, array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      size)
c---------------------------------------------------------------------------
c   Determines the size of an array (in words).
c   Only works for distributed and served arrays.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h' 

      integer array
      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer*8 size

      integer k, nindex, nblk, iblock_map
      integer iblock, ind, seg
      integer blksize, val1, val2

      nindex     = array_table(c_nindex,array)
      nblk       = array_table(c_numblks, array)
      iblock_map = array_table(c_block_map, array)

      size = 0
      do iblock = 1, nblk

c--------------------------------------------------------------------------
c   Determine block size in words.
c--------------------------------------------------------------------------

         blksize = 1
         do k = 1, nindex
            ind = array_table(c_index_array1+k-1,array)
            seg = block_map_table(c_block_map_seg+k-1,
     *                       iblock_map+iblock-1)
            call get_index_segment(ind, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            blksize = blksize * (val2-val1+1)
         enddo

         size = size + blksize 
      enddo   ! iblock

      return
      end
     

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine return_x(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c
c   return_x must be executed with the following syntax:
c   execute return_x x(mu,nu)
c
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      integer nsend

c---------------------------------------------------------------------------
c   Compute data block of integrals.
c---------------------------------------------------------------------------

      if (intpkg .eq.flocke_package) then
         call comp_return_x(x, bval(1), eval(1), bval(2), eval(2),
     *                       nsend)
      else
        write(6,*) ' MUST USE ERD IN RETURN_X!!! ' 
      endif 

      return
      end

      SUBROUTINE GETGSI(LEFTP,LENGTH,RIGHTP,NUMDIS,NIRREP,NUMIRR,IBUF)
C
C THIS ROUTINE RETURNS THE APPROPRIATE GATHER/SCATTER VECTORS NEEDED
C   TO READ IN A FULL DISTRIBUTION INTO A SYMMETRY-PACKED ARRAY.
C   THIS ROUTINE GETS THE INVERSE SYMMETRY VECTORS
C
C  INPUT:
C
C    LEFTP = STORAGE SCHEME FOR DISTRIBUTION MEMBERS (SEE JOBARC LIST).
C    LENGTH= DISTRIBUTION SIZE (IN FLOATING POINT WORDS).
C    RIGHTP= STORAGE SCHEME FOR DISTRIBUTIONS (SEE JOBARC LIST).
C    NUMDIS= NUMBER OF TOTAL DISTRIBUTIONS.
C    NIRREP= THE TOTAL NUMBER OF IRREDUCIBLE REPRESENTATIONS.
C
C  OUTPUT:
C
C    NUMIRR= POPULATION COUNT SYMMETRY VECTORS (SEE JOBARC LIST).
C             THE FIRST NIRREP ELEMENTS CORRESPOND TO THE DISTRIBUTIONS
C             WHILE THE LAST NIRREP ELEMENTS REFER TO THE DISTRIBUTION
C             MEMBERS.
C    IBUF  = SYMMETRY VECTORS (SEE JOBARC LIST).  
C             THE FIRST NUMDIS MEMBERS REFER TO THE DISTRIBUTIONS WHILE
C             THE LAST LENGTH MEMBERS REFER TO THE DISTRIBUTION MEMBERS.
C
CEND
      IMPLICIT INTEGER (A-Z)
      INTEGER RIGHTP,LEFTP
      CHARACTER*6 SYMLST(22)
      DIMENSION IBUF(NUMDIS+LENGTH),NUMIRR(2*NIRREP)
      DATA SYMLST /'SVAVA0','SVBVB0','SOAOA0','SOBOB0',
     &             'SVAVA1','SVBVB1','SOAOA1','SOBOB1',
     &             'SVAOA2','SVBOB2','SOBVA2','SVBOA2',
     &             'SVAVB2','SOAOB2','SVAVB2','SOAVA2',
     &             'SOBVB2','SOAVB2','SVAVA2','SVBVB2',
     &             'SOAOA2','SOBOB2'/
C
C PICK UP SYMMETRY VECTORS FOR RIGHTP (REFERS TO THE DISTRIBUTION
C    NUMBER, RATHER THAN THE MEMBERS OF THE DISTRIBUTION ITSELF).
C
      CALL GETREC(20,'JOBARC',SYMLST(RIGHTP)//'X ',NIRREP,NUMIRR)
      CALL GETREC(20,'JOBARC',SYMLST(RIGHTP)//'I ',NUMDIS,IBUF)
C
C PICK UP SYMMETRY VECTORS FOR LEFTP (REFERS TO THE INDIVIDUAL
C    MEMBERS OF THE DISTRIBUTION).
C
      CALL GETREC(20,'JOBARC',SYMLST(LEFTP)//'X ',NIRREP,
     &            NUMIRR(NIRREP+1))
      CALL GETREC(20,'JOBARC',SYMLST(LEFTP)//'I ',LENGTH,
     &IBUF(NUMDIS+1))
      RETURN
      END

C  Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
C  USA
         SUBROUTINE  OED__XYZ_1D_MOM_AB_INTEGRALS
     +
     +                    ( SHELLP,SHELLX,
     +                      SHELLA,SHELLB,
     +                      NEXP,
     +                      IP,                            ! Watson Added
     +                      PA,
     +                      PB,                            ! Watson Added
     +                      PINVHF,
     +                      AB,
     +                      OVRLP,                         ! Watson Added
     +                      INTSCR,
     +
     +                               INT1D )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_1D_AB_INTEGRALS
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation calculates a full table of 1D AB
C                overlap integrals using the Rys vertical recurrence
C                scheme and the Rys horizontal transfer scheme
C                explained below.
C
C                The recurrence schemes VRR and HRR is due to Rys,
C                Dupuis and King, J. Comp. Chem. 4, p.154-157 (1983).
C
C
C                 i) VRR Scheme:
C
C
C                   INT1D (0,0) = 1.D0
C                   INT1D (1,0) = PA
C
C                   For I = 1,...,SHELLP-1
C                       INT1D (I+1,0) = I * (1/2P) * INT1D (I-1,0)
C                                             + PA * INT1D (I,0)
C
C
C                ii) HRR Scheme:
C
C
C                   For J = 1,...,SHELLX  (SHELLX = Min (SHELLA,SHELLB)
C                   For I = SHELLP-J,...,0
C                       INT1D (I,J) =  +/- AB * INT1D (I,J-1)
C                                             + INT1D (I+1,J-1)
C
C
C                The 1D AB integrals are calculated for all exponent
C                pairs and placed into a 3-dimensional array.
C
C                An important feature of this routine is that it can
C                be called with shell magnitudes A < B. If this case
C                happens, the VRR and HRR have to be processed
C                differently. If shell A < shell B, the HRR must be
C                defined such that P,0 -> B,A due to efficiency and
C                numerical stability reasons. This in turn needs a
C                redefinition of the PA coefficients, which now must
C                be such that they are defined with the P shell
C                accumulated on center B instead of A. The PA
C                coefficients are (example x coordinate):
C
C                  i) P accumulated on center A:
C
C                          PA = (Px - Ax)
C
C                 ii) P accumulated on center B:
C
C                          PA = (Px - Bx)
C
C                When entering the present routine however, all we have
C                are the PA values based on case i). If case ii)
C                applies, we have to form new PA via:
C
C                          PA -> PA + (A - B) = PA + AB
C
C                using the cartesian coordinate differences AB = A - B
C                between centers A and B. The constant AB is thus added
C                to all PA values presently transmitted.
C
C
C                  Input:
C
C                    SHELLP      =  maximum shell sum A+B
C                    SHELLX      =  minimum shell type between A and B
C                    SHELLx      =  shell type for csh x = A and B
C                    NEXP        =  # of exponent pairs
C                    PA          =  current NEXP coordinate differences
C                                   P-A between centers P and A
C                    PINVHF      =  current NEXP values of 1/(2*P),
C                                   where P are the exponent sums
C                                   for contraction shells A and B
C                    AB          =  cartesian coordinate differences
C                                   A - B between sites A and B
C                    INTSCR      =  scratch array to perform the VRR
C                                   and HRR schemes
C
C
C                  Output:
C
C                    INT1D       =  all 1D AB integrals with reduced
C                                   PX -> AB dimensions
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   HRRBA

         INTEGER   CASE1D
         INTEGER   I,J,N
         INTEGER   I1,I2,J1,J2
         INTEGER   NEXP
         INTEGER   SHELLA,SHELLB
         INTEGER   SHELLP,SHELLX

         DOUBLE PRECISION  AB
         DOUBLE PRECISION  F,P1
         DOUBLE PRECISION  ZERO,ONE,TWO

         DOUBLE PRECISION  IP     (1:NEXP)                 ! Watson Added
         DOUBLE PRECISION  PA     (1:NEXP)
         DOUBLE PRECISION  PB     (1:NEXP)                 ! Watson Added
         DOUBLE PRECISION  PINVHF (1:NEXP)

         DOUBLE PRECISION  OVRLP  (1:NEXP,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INT1D  (1:NEXP,0:SHELLA,0:SHELLB)
         DOUBLE PRECISION  INTSCR (1:NEXP,0:SHELLP,0:SHELLX)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (ONE   =  1.D0)
         PARAMETER  (TWO   =  2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to the 4 different cases that can arise:
C
C                  A-shell = s- or higher angular momentum
C                  B-shell = s- or higher angular momentum
C
C                each leading to specific simplifications.
C
C
         CASE1D = 2 * MIN (1,SHELLA) + MIN (1,SHELLB) + 1

         GOTO (1,2,3,4) CASE1D
C
C
C             ...the case A = s-shell and B = s-shell (no HRR!).
C                i) VRR => Evaluate: I = 0
C                                    J = 0
C
C
    1    DO N = 1,NEXP
C            INT1D (N,0,0) = ONE                           ! Watson Changed
            INT1D (N,0,0) = IP (N)
         END DO

         RETURN
C
C
C             ...the cases A = s-shell and B >= p-shell (no HRR!).
C                i) VRR => Evaluate: I = 0
C                                    J = 0,SHELLB
C
C
    2    IF (AB.NE.ZERO) THEN
             DO N = 1,NEXP
                PA (N) = PA (N) + AB
             END DO
         END IF

         DO N = 1,NEXP
C            INT1D (N,0,0) = ONE
C            INT1D (N,0,1) = PA (N)
            INT1D (N,0,0) = IP (N)                         ! Watson Changed
            INT1D (N,0,1) = PA (N) * INT1D  (N,0,0)        ! Watson Changed
     +                             + PINVHF (N)
         END DO

         F = ONE
         DO J = 2,SHELLB
            J1 = J - 1
            J2 = J - 2
            DO N = 1,NEXP
               P1 = F * PINVHF (N)
               INT1D (N,0,J) =        P1     * INT1D (N,0,J2)
     +                          +     PA (N) * INT1D (N,0,J1)
     +                          + PINVHF (N) * OVRLP (N,0,J1)  ! Watson Added
            END DO
            F = F + ONE
         END DO

         RETURN
C
C
C             ...the cases A >= p-shell and B = s-shell (no HRR!).
C                i) VRR => Evaluate: I = 0,SHELLA
C                                    J = 0
C
C
    3    DO N = 1,NEXP
C            INT1D (N,0,0) = ONE
C            INT1D (N,1,0) = PA (N)
            INT1D (N,0,0) = IP (N)                         ! Watson Changed
            INT1D (N,1,0) = PA (N) * INT1D  (N,0,0)        ! Watson Changed
     +                             + PINVHF (N)
         END DO

         F = ONE
         DO I = 2,SHELLA
            I1 = I - 1
            I2 = I - 2
            DO N = 1,NEXP
               P1 = F * PINVHF (N)
               INT1D (N,I,0) =        P1     * INT1D (N,I2,0)
     +                          +     PA (N) * INT1D (N,I1,0)
     +                          + PINVHF (N) * OVRLP (N,I1,0)  ! Watson Added
            END DO
            F = F + ONE
         END DO

         RETURN
C
C
C             ...the cases A >= p-shell and B >= p-shell.
C
C                  i) VRR => Evaluate: I = 0,SHELLP
C                                      J = 0
C
C                 ii) HRR => Evaluate: I = 0,SHELLP-SHELLA/SHELLB
C                                      J = 0,SHELLB/SHELLA
C
C                iii) Copy INTSCR to INT1D: I = 0,SHELLA
C                                           J = 0,SHELLB
C
C
C
    4    HRRBA = SHELLA .LT. SHELLB

         IF (HRRBA .AND. AB.NE.ZERO) THEN
             DO N = 1,NEXP
                PA (N) = PA (N) + AB
             END DO
         END IF

         DO N = 1,NEXP
C            INTSCR (N,0,0) = ONE
C            INTSCR (N,1,0) = PA (N)
            INTSCR (N,0,0) = IP (N)                        ! Watson Changed
            INTSCR (N,1,0) = PA (N) * INTSCR (N,0,0)       ! Watson Changed
     +                              + PINVHF (N)
         END DO

         F = ONE
         DO I = 2,SHELLP
            I1 = I - 1
            I2 = I - 2
            DO N = 1,NEXP
               P1 = F * PINVHF (N)
               INTSCR (N,I,0) =       P1     * INTSCR (N,I2,0)
     +                           +    PA (N) * INTSCR (N,I1,0)
     +                           + PINVHF(N) * OVRLP  (N,I1,0)! Watson Added
            END DO
            F = F + ONE
         END DO

         IF (.NOT.HRRBA) THEN

             IF (AB.EQ.ZERO) THEN
                 DO J = 1,SHELLB
                    J1 = J - 1
                    DO I = 0,SHELLP-J
                       I1 = I + 1
                       DO N = 1,NEXP
                          INTSCR (N,I,J) = INTSCR (N,I1,J1)
                       END DO
                    END DO
                 END DO
             ELSE
                 DO J = 1,SHELLB
                    J1 = J - 1
                    DO I = 0,SHELLP-J
                       I1 = I + 1
                       DO N = 1,NEXP
                          INTSCR (N,I,J) =        INTSCR (N,I1,J1)
     +                                     + AB * INTSCR (N,I,J1)
                       END DO
                    END DO
                 END DO
             END IF

             DO J = 0,SHELLB
             DO I = 0,SHELLA
             DO N = 1,NEXP
                INT1D (N,I,J) = INTSCR (N,I,J)
             END DO
             END DO
             END DO

         ELSE

             IF (AB.EQ.ZERO) THEN
                 DO J = 1,SHELLA
                    J1 = J - 1
                    DO I = 0,SHELLP-J
                       I1 = I + 1
                       DO N = 1,NEXP
                          INTSCR (N,I,J) = INTSCR (N,I1,J1)
                       END DO
                    END DO
                 END DO
             ELSE
                 DO J = 1,SHELLA
                    J1 = J - 1
                    DO I = 0,SHELLP-J
                       I1 = I + 1
                       DO N = 1,NEXP
                          INTSCR (N,I,J) =        INTSCR (N,I1,J1)
     +                                     - AB * INTSCR (N,I,J1)
                       END DO
                    END DO
                 END DO
             END IF

             DO J = 0,SHELLB
             DO I = 0,SHELLA
             DO N = 1,NEXP
                INT1D (N,I,J) = INTSCR (N,J,I)
             END DO
             END DO
             END DO

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
c This program implements a worst fit bin packing algorithm. It searches
c over the number of possible bins and the range of maximum bin sizes and
c minimizes the group mass variance.

c isort and dependencies come from http://www.netlib.org/slatec/src/isort.f

      subroutine binpack(nShells,mass,ShlMax, ishells)
      implicit none

      integer nShells, mass(*), ishells(*), ShlMax

      integer nCells, MasLim
      integer TotMass, lrg, sml

      integer GrpMax, nGrps, pGrp0, SmlGrp

      integer m(nshells), GrpNdx(nshells), GrpMass(nshells)
      integer FinGrps, FinNdx(nshells), FinMass(nshells)

      double precision avg, FinAvg, var, FinVar, dTmp
      logical bValid
      logical bAccept

      integer i, j

c ----------------------------------------------------------------------

      nCells = nShells
      if (nCells.lt.1) then
         print *,'Error in binpack: nshells = ',nshells
         call abort_job()
      endif


      TotMass = 0
      lrg = 0
      sml = 2**30
      do i = 1, nCells
         if (mass(i).lt.1) then
            print *,'Error in binpack: Cells must have a mass > 0.'
            call abort_job()
         endif
         TotMass = TotMass + mass(i)
         lrg = max(lrg,mass(i))
         sml = min(sml,mass(i))
         m(i) = mass(i)
         ishells(i) = i
      end do

      MasLim = max(lrg,ShlMax) ! ShlMax ! VFL changed to accomadate larger shells 3/2013  
      ShlMax = max(lrg,ShlMax) ! ShlMax ! VFL changed to accomadate larger shells 3/2013  
      if (MasLim.lt.lrg) then
         print *,'Error in binpack: ',
     *           'The group limit is ',MasLim,
     *           ' which is less than the largest shell size (',
     *           lrg,').'
         call abort_job()
      endif

c   o sort the masses in descending order
      call isort(m,ishells,nCells,-2)

      do MasLim = lrg, ShlMax 
c   o initialize the final groups to the individual cells
      do i = 1, nCells
         FinNdx(i)  = i
         FinMass(i) = m(i)
      end do
      FinGrps = nCells
      call statx(FinMass,FinGrps,FinAvg,FinVar)

      do GrpMax = lrg, min(MasLim,TotMass)
         do nGrps = (TotMass+GrpMax-1)/GrpMax, nCells

c   o fill in the largest cells (pGrp0 points to the first group to scan from)
      pGrp0 = 1
      do i = 1, nGrps
         GrpNdx(i) = i
         GrpMass(i) = m(i)
         if (m(i).gt.GrpMax-sml) pGrp0 = pGrp0 + 1
      end do
      bValid=(pGrp0.le.nGrps.or.nGrps.eq.nCells)

c   o assign the remaining cells
      do i = nGrps+1, nCells
c      o find the smallest group
         SmlGrp = pGrp0
         do j = pGrp0+1, nGrps
            if (GrpMass(j).lt.GrpMass(SmlGrp)) SmlGrp = j
         end do
         GrpNdx(i) = SmlGrp
         GrpMass(SmlGrp) = GrpMass(SmlGrp) + m(i)
         if (GrpMass(SmlGrp).gt.GrpMax) bValid = .false.
      end do

      if (bValid) then

c      o find the variance of the group masses
         call statx(GrpMass,nGrps,avg,var)

         bAccept = .false.
         if (nGrps .eq. FinGrps .and.
     *       var .lt. FinVar) bAccept = .true.
         if (nGrps .lt. FinGrps) bAccept = .true.

c      o compare this grouping with the best known grouping
         if (bAccept) then
c            print *, '> lower var at ',nGrps,' groups under ',GrpMax
            do i = 1, nCells
               FinNdx(i)  = GrpNdx(i)
               FinMass(i) = GrpMass(i)
            end do
            FinAvg = avg
            FinVar = var
            FinGrps = nGrps
         end if
      end if

         end do
      end do
      enddo

 1000 continue

      call isort(FinNdx,ishells,nCells,2)
      do i = 1, nCells
         m(i) = mass(ishells(i))
      enddo

c   o print the original scheme
      call statx(m,nCells,avg,var)
      dTmp = (1.d0*lrg)/sml

c   o print the new results
      lrg = 0
      sml = 2**30
      do i = 1, FinGrps
         lrg = max(lrg,FinMass(i))
         sml = min(sml,FinMass(i))
      end do
      dTmp = (1.d0*lrg)/sml

      return
      end

c ----------------------------------------------------------------------

c m(1:n) is considered the population, not a sample.

      subroutine statx(m,n,avg,var)
      implicit none
      double precision avg, var, a, v, dTmp
      integer m(*), n, i
      if (n.eq.1) then
         avg = m(1)
         var = 0.d0
         return
      end if
      a = m(1)
      do i = 2, n
         dTmp = 1.d0/i
         a = a + (1.d0*m(i)-a)*dTmp
      end do
      dTmp = 1.d0*m(1)-a
      v = dTmp*dTmp
      do i = 2, n
         dTmp = 1.d0*m(i)-a
         v = v*(i-1)/i
         v = v + dTmp*dTmp/i
      end do
      var = v
      avg = a
      return
      end

      SUBROUTINE ISORT (IX, IY, N, KFLAG)
C***BEGIN PROLOGUE  ISORT
C***PURPOSE  Sort an array and optionally make the same interchanges in
C            an auxiliary array.  The array may be sorted in increasing
C            or decreasing order.  A slightly modified QUICKSORT
C            algorithm is used.
C***LIBRARY   SLATEC
C***CATEGORY  N6A2A
C***TYPE      INTEGER (SSORT-S, DSORT-D, ISORT-I)
C***KEYWORDS  SINGLETON QUICKSORT, SORT, SORTING
C***AUTHOR  Jones, R. E., (SNLA)
C           Kahaner, D. K., (NBS)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C   ISORT sorts array IX and optionally makes the same interchanges in
C   array IY.  The array IX may be sorted in increasing order or
C   decreasing order.  A slightly modified quicksort algorithm is used.
C
C   Description of Parameters
C      IX - integer array of values to be sorted
C      IY - integer array to be (optionally) carried along
C      N  - number of values in integer array IX to be sorted
C      KFLAG - control parameter
C            =  2  means sort IX in increasing order and carry IY along.
C            =  1  means sort IX in increasing order (ignoring IY)
C            = -1  means sort IX in decreasing order (ignoring IY)
C            = -2  means sort IX in decreasing order and carry IY along.
C
C***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
C                 for sorting with minimal storage, Communications of
C                 the ACM, 12, 3 (1969), pp. 185-187.
C***REVISION HISTORY  (YYMMDD)
C   761118  DATE WRITTEN
C   810801  Modified by David K. Kahaner.
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   901012  Declared all variables; changed X,Y to IX,IY. (M. McClain)
C   920501  Reformatted the REFERENCES section.  (DWL, WRB)
C   920519  Clarified error messages.  (DWL)
C   920801  Declarations section rebuilt and code restructured to use
C           IF-THEN-ELSE-ENDIF.  (RWC, WRB)
C***END PROLOGUE  ISORT
C     .. Scalar Arguments ..
      INTEGER KFLAG, N
C     .. Array Arguments ..
      INTEGER IX(*), IY(*)
C     .. Local Scalars ..
      REAL R
      INTEGER I, IJ, J, K, KK, L, M, NN, T, TT, TTY, TY
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C***FIRST EXECUTABLE STATEMENT  ISORT
      NN = N
      IF (NN .LT. 1) THEN
           print *,'ERROR in ISORT: ',
     *       ' The number of values to be sorted is not positive.'
         RETURN
      ENDIF
C
      KK = ABS(KFLAG)
      IF (KK.NE.1 .AND. KK.NE.2) THEN
         print *,'ERROR IN ISORT:',
     +      'The sort control parameter, K, is not 2, 1, -1, or -2.'
         RETURN
      ENDIF
C
C     Alter array IX to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 10 I=1,NN
            IX(I) = -IX(I)
   10    CONTINUE
      ENDIF
C
      IF (KK .EQ. 2) GO TO 100
C
C     Sort IX only
C
      M = 1
      I = 1
      J = NN
      R = 0.375E0
C
   20 IF (I .EQ. J) GO TO 60
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
   30 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = IX(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (IX(I) .GT. T) THEN
         IX(IJ) = IX(I)
         IX(I) = T
         T = IX(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than than T, interchange with T
C
      IF (IX(J) .LT. T) THEN
         IX(IJ) = IX(J)
         IX(J) = T
         T = IX(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (IX(I) .GT. T) THEN
            IX(IJ) = IX(I)
            IX(I) = T
            T = IX(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
   40 L = L-1
      IF (IX(L) .GT. T) GO TO 40
C
C     Find an element in the first half of the array which is greater
C     than T
C
   50 K = K+1
      IF (IX(K) .LT. T) GO TO 50
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = IX(L)
         IX(L) = IX(K)
         IX(K) = TT
         GO TO 40
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 70
C
C     Begin again on another portion of the unsorted array
C
   60 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
   70 IF (J-I .GE. 1) GO TO 30
      IF (I .EQ. 1) GO TO 20
      I = I-1
C
   80 I = I+1
      IF (I .EQ. J) GO TO 60
      T = IX(I+1)
      IF (IX(I) .LE. T) GO TO 80
      K = I
C
   90 IX(K+1) = IX(K)
      K = K-1
      IF (T .LT. IX(K)) GO TO 90
      IX(K+1) = T
      GO TO 80
C
C     Sort IX and carry IY along
C
  100 M = 1
      I = 1
      J = NN
      R = 0.375E0
C
  110 IF (I .EQ. J) GO TO 150
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
  120 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = IX(IJ)
      TY = IY(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (IX(I) .GT. T) THEN
         IX(IJ) = IX(I)
         IX(I) = T
         T = IX(IJ)
         IY(IJ) = IY(I)
         IY(I) = TY
         TY = IY(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than T, interchange with T
C
      IF (IX(J) .LT. T) THEN
         IX(IJ) = IX(J)
         IX(J) = T
         T = IX(IJ)
         IY(IJ) = IY(J)
         IY(J) = TY
         TY = IY(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (IX(I) .GT. T) THEN
            IX(IJ) = IX(I)
            IX(I) = T
            T = IX(IJ)
            IY(IJ) = IY(I)
            IY(I) = TY
            TY = IY(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
  130 L = L-1
      IF (IX(L) .GT. T) GO TO 130
C
C     Find an element in the first half of the array which is greater
C     than T
C
  140 K = K+1
      IF (IX(K) .LT. T) GO TO 140
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = IX(L)
         IX(L) = IX(K)
         IX(K) = TT
         TTY = IY(L)
         IY(L) = IY(K)
         IY(K) = TTY
         GO TO 130
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 160
C
C     Begin again on another portion of the unsorted array
C
  150 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
  160 IF (J-I .GE. 1) GO TO 120
      IF (I .EQ. 1) GO TO 110
      I = I-1
C
  170 I = I+1
      IF (I .EQ. J) GO TO 150
      T = IX(I+1)
      TY = IY(I+1)
      IF (IX(I) .LE. T) GO TO 170
      K = I
C
  180 IX(K+1) = IX(K)
      IY(K+1) = IY(K)
      K = K-1
      IF (T .LT. IX(K)) GO TO 180
      IX(K+1) = T
      IY(K+1) = TY
      GO TO 170
C
C     Clean up
C
  190 IF (KFLAG .LE. -1) THEN
         DO 200 I=1,NN
            IX(I) = -IX(I)
  200    CONTINUE
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE IRREPS(Q,PTGRP,NDEG,V,LENV,IRREP,SCRATCH)
C
C SUBROUTINE DETERMINES THE IRREDUCIBLE REPRESENTATION TO WHICH
C  VECTOR V BELONGS, GIVEN THE MOLECULAR POINT GROUP.
C  LENV IS EQUAL TO 3*NATOMS.  NDEG IS THE DEGENERACY OF THE PARTICULAR
C  NORMAL MODE, MAKING THE LENGTH OF THE V VECTOR EQUAL TO NDEG*LENV.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
#include "mxatms.par"
      PARAMETER (TOL = 1.D-2)
      CHARACTER*4 PTGRP
      CHARACTER*4 IRREP
      CHARACTER*2 GREEK(4)     
      DIMENSION V(NDEG*LENV),SCRATCH(3*LENV),NORD(2*MXATMS),Q(LENV)
      DATA GREEK /'SG','PI','DE','PH'/
      IRREP='    '
      NPOS=LENV/3
      RT2=DSQRT(2.D0)
      RT3=DSQRT(3.D0)
      C72=2.D0*DCOS(0.4*DACOS(-1.D0))
      C144=2.D0*DCOS(0.8*DACOS(-1.D0))
C
C   GET SORTED COORDINATE VECTOR FOR Q AND HOLD IN LOW END OF
C   SCRATCH VECTOR.  BOTTOM END OF NORD CONTAINS POSITIONING LIST
C   RETURNED BY SORTXYZ.  
C
       CALL ZERO(SCRATCH,3*LENV)
C
C Note that LENV is 3*NATOMS and SORTXYZ needs only the number of
C atoms. 06/2006, Ajith Perera.
C
       CALL SORTXYZ(Q,SCRATCH,NORD,LENV/3)
C
C ABELIAN GROUPS FIRST!
C
C DEAL WITH TRIVIAL CASE OF C1 SYMMETRY HERE AND DO EASY POINT GROUPS
C  WHICH HAVE ONLY ONE SYMMETRY OPERATION.
C
      IF(PTGRP(1:3).EQ.'C 1'.OR.PTGRP(1:3).EQ.'C1 ')THEN
       IRREP='   A'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C s')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IRREP=' A'' '
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP=' A'''''
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C i')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IRREP='  Ag'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  Au'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C2 ')THEN
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IRREP='   A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='   B'
       RETURN
C
C NOW DO ALL POINT GROUPS WITH JUST TWO OR THREE NONTRIVIAL OPERATIONS.
C
      ELSEIF(PTGRP(1:3).EQ.'C2h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IRREP='  Ag'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(3:3)='B'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C2v')THEN
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'P',0,0,2,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IRREP='  A1'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D2h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',2,1,2,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       IRREP='  Ag'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP2+1.D0).LT.TOL.AND.DABS(OVRLP3+1.D0).LT.TOL)
     &  IRREP(2:3)='B3'
       IF(DABS(OVRLP2+1.D0).LT.TOL.AND.DABS(OVRLP3-1.D0).LT.TOL)
     &  IRREP(2:3)='B2'
       IF(DABS(OVRLP2-1.D0).LT.TOL.AND.DABS(OVRLP3+1.D0).LT.TOL)
     &  IRREP(2:3)='B1'
       RETURN
C
C NOW DO GROUPS CONTAINING DOUBLY DEGENERATE REPRESENTATIONS.
C
       ELSEIF(PTGRP(1:3).EQ.'C3v')THEN
        CALL COMVEC(NDEG,'P',0,0,2,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  A1'
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  A2'
        IF(NDEG.EQ.2)IRREP='   E'
       RETURN
       ELSEIF(PTGRP(1:3).EQ.'C4v')THEN
        IRREP='  A1'
        CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        CALL COMVEC(NDEG,'P',0,0,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
        IF(NDEG.EQ.2)IRREP='   E'
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
        IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C5v')THEN
       CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'P',0,0,2,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP='  A1'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP='  A2'
       IF(ABS(OVRLP-C72).LT.TOL)IRREP='  E1'
       IF(ABS(OVRLP-C144).LT.TOL)IRREP='  E2'
      RETURN
      ELSEIF(PTGRP(1:3).EQ.'C6v')THEN
       CALL COMVEC(NDEG,'C',6,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'P',0,0,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  E1'
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  E2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C3h')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP=' A'''''
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP=' A'' '
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP+2.D0).LT.TOL)IRREP=' E'''''
        IF(DABS(OVRLP-2.D0).LT.TOL)IRREP=' E'' '
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C4h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP+2.D0).LT.TOL)IRREP='  Eu'
        IF(DABS(OVRLP-2.D0).LT.TOL)IRREP='  Eg'
       ENDIF       
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C5h')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:4)=''''''
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:4)=''' '
       IF(NDEG.EQ.1)IRREP(2:2)='A'
       IF(NDEG.EQ.2)THEN
        IRREP(1:1)='E'
        CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        IF(DABS(OVRLP-C72).LT.TOL)IRREP(3:3)='1'
        IF(DABS(OVRLP-C144).LT.TOL)IRREP(3:3)='2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C6h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',6,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP3-2.D0).LT.TOL)IRREP(2:3)='E2'
        IF(DABS(OVRLP3+2.D0).LT.TOL)IRREP(2:3)='E1'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D2d')THEN
       IF(NDEG.EQ.2)THEN
        IRREP='   E'
        RETURN
       ENDIF
       CALL COMVEC(NDEG,'S',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D3d')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:3)='A2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:3)='A1'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP+2.D0).LT.TOL)IRREP(3:4)='Eu'
        IF(DABS(OVRLP-2.D0).LT.TOL)IRREP(3:4)='Eg'
        RETURN
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D4d')THEN
       CALL COMVEC(NDEG,'S',8,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP-RT2).LT.TOL)IRREP='  E1'
        IF(DABS(OVRLP).LT.TOL)IRREP='  E2'
        IF(DABS(OVRLP+RT2).LT.TOL)IRREP='  E3'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D5d')THEN
       CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       IRREP=' A1g'
       OVRLP3=OVRLP3/FLOAT(NDEG)
       IF(DABS(OVRLP3+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP3-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:3)='A2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:3)='A1'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP-C144).LT.TOL)IRREP(2:3)='E2'
        IF(DABS(OVRLP+C144).LT.TOL)IRREP(2:3)='E1'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D6d')THEN
       CALL COMVEC(NDEG,'S',12,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP-RT3).LT.TOL)IRREP='  E1'
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  E2'
        IF(DABS(OVRLP).LT.TOL)IRREP='  E3'
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  E4'
        IF(DABS(OVRLP+RT3).LT.TOL)IRREP='  E5'
       ELSE
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
        IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
        IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(4:4)='1'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'S4 ')THEN
       CALL COMVEC(NDEG,'S',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='   A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='   B'
       IF(NDEG.EQ.2)IRREP='   E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'S6 ')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IRREP(3:3)='A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.2)IRREP(3:3)='E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'S8 ')THEN
       CALL COMVEC(NDEG,'S',8,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(NDEG.EQ.1)THEN
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:4)='A '
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:4)='B '
       ELSE
        IF(DABS(OVRLP-RT2).LT.TOL)IRREP(3:4)='E1'
        IF(DABS(OVRLP).LT.TOL)IRREP(3:4)='E2'
        IF(DABS(OVRLP+RT2).LT.TOL)IRREP(3:4)='E3'  
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D3h')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       OVRLP=OVRLP/FLOAT(NDEG)
       OVRLP2=OVRLP2/FLOAT(NDEG)
       IF(NDEG.EQ.1)IRREP(1:1)='A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:4)=''''''
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:4)=''' '
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='1'
       IF(NDEG.EQ.2)IRREP(2:2)='E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D4h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRL2)
       CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRL2-1.D0).LT.TOL)IRREP(3:3)='1'
       IF(DABS(OVRL2+1.D0).LT.TOL)IRREP(3:3)='2'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='A'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='B'
       IF(NDEG.EQ.2)IRREP(2:3)=' E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D5h')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLPP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       PDP=OVRLPP/FLOAT(NDEG)
       IF(NDEG.EQ.1)IRREP(1:1)='A'
       IF(DABS(PDP+1.D0).LT.TOL)IRREP(3:4)=''''''
       IF(DABS(PDP-1.D0).LT.TOL)IRREP(3:4)=''' '
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='1'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP-C72).LT.TOL)IRREP(1:2)='E1'
        IF(DABS(OVRLP-C144).LT.TOL)IRREP(1:2)='E2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D6h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',6,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(NDEG.EQ.1)THEN
        IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='A'
        IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='B'
        IF(DABS(OVRLP3-1.D0).LT.TOL)IRREP(3:3)='1'
        IF(DABS(OVRLP3+1.D0).LT.TOL)IRREP(3:3)='2'
       ELSE
        IRREP(2:2)='E'
        CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
        IF(DABS(OVRLP2-2.D0).LT.TOL)IRREP(3:3)='2'
        IF(DABS(OVRLP2+2.D0).LT.TOL)IRREP(3:3)='1'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D7h')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLPP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',7,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       PDP=OVRLPP/FLOAT(NDEG)
       IF(NDEG.EQ.1)IRREP(1:1)='A'
       IF(DABS(PDP+1.D0).LT.TOL)IRREP(3:4)=''''''
       IF(DABS(PDP-1.D0).LT.TOL)IRREP(3:4)=''' '
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='1'
       IF(NDEG.EQ.2)THEN
        A=2.0*DACOS(-1.D0)/7.0
        C1=2.D0*DCOS(A)
        C2=2.D0*DCOS(2.0*A)
        C3=2.D0*DCOS(4.0*A)
        IF(DABS(OVRLP-C1).LT.TOL)IRREP(1:2)='E1'
        IF(DABS(OVRLP-C2).LT.TOL)IRREP(1:2)='E2'
        IF(DABS(OVRLP-C3).LT.TOL)IRREP(1:2)='E3'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D8h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',8,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(NDEG.EQ.1)THEN
        IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='A'
        IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='B'
        IF(DABS(OVRLP3-1.D0).LT.TOL)IRREP(3:3)='1'
        IF(DABS(OVRLP3+1.D0).LT.TOL)IRREP(3:3)='2'
       ELSE
        IRREP(2:2)='E'
        A=2.0*DACOS(-1.D0)/8.0
        C1=2.D0*DCOS(A)
        C2=2.D0*DCOS(2.0*A)
        C3=2.D0*DCOS(4.0*A)
        IF(DABS(OVRLP2-C1).LT.TOL)IRREP(3:3)='1'
        IF(DABS(OVRLP2-C2).LT.TOL)IRREP(3:3)='2'
        IF(DABS(OVRLP2-C3).LT.TOL)IRREP(3:3)='3'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D9h')THEN
       CALL COMVEC(NDEG,'P',0,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLPP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',9,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       PDP=OVRLPP/FLOAT(NDEG)
       IF(NDEG.EQ.1)IRREP(1:1)='A'
       IF(DABS(PDP+1.D0).LT.TOL)IRREP(3:4)=''''''
       IF(DABS(PDP-1.D0).LT.TOL)IRREP(3:4)=''' '
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='1'
       IF(NDEG.EQ.2)THEN
        A=2.0*DACOS(-1.D0)/9.0
        C1=2.D0*DCOS(A)
        C2=2.D0*DCOS(2.0*A)
        C3=2.D0*DCOS(4.0*A)
        C4=2.D0*DCOS(6.0*A)
        IF(DABS(OVRLP-C1).LT.TOL)IRREP(1:2)='E1'
        IF(DABS(OVRLP-C2).LT.TOL)IRREP(1:2)='E2'
        IF(DABS(OVRLP-C3).LT.TOL)IRREP(1:2)='E3'
        IF(DABS(OVRLP-C4).LT.TOL)IRREP(1:2)='E4'
       ENDIF
       RETURN
      ELSEIF(PTGRP.EQ.'D10h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',10,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(NDEG.EQ.1)THEN
        IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(2:2)='A'
        IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(2:2)='B'
        IF(DABS(OVRLP3-1.D0).LT.TOL)IRREP(3:3)='1'
        IF(DABS(OVRLP3+1.D0).LT.TOL)IRREP(3:3)='2'
       ELSE
        IRREP(2:2)='E'
        C36=2.D0*DCOS(0.2*DACOS(-1.D0))
        C72=2.D0*DCOS(0.4*DACOS(-1.D0))
        C108=2.D0*DCOS(0.6*DACOS(-1.D0))
        C144=2.D0*DCOS(0.8*DACOS(-1.D0))
        IF(DABS(OVRLP2-C36).LT.TOL)IRREP(3:3)='1'
        IF(DABS(OVRLP2-C72).LT.TOL)IRREP(3:3)='2'
        IF(DABS(OVRLP2-C108).LT.TOL)IRREP(3:3)='3'
        IF(DABS(OVRLP2-C144).LT.TOL)IRREP(3:3)='4'
       ENDIF
       RETURN
C
C Dn AND Cn GROUPS
C
      ELSEIF(PTGRP(1:3).EQ.'D2 ')THEN
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLPZ)
       CALL COMVEC(NDEG,'C',2,1,2,NPOS,Q,SCRATCH,NORD,V,OVRLPY)
       IF(DABS(OVRLPZ-1.D0).LT.TOL.AND.DABS(OVRLPY-1.D0).LT.TOL)
     &   IRREP='   A'
       IF(DABS(OVRLPZ-1.D0).LT.TOL.AND.DABS(OVRLPY+1.D0).LT.TOL)
     &   IRREP='  B1'
       IF(DABS(OVRLPZ+1.D0).LT.TOL.AND.DABS(OVRLPY-1.D0).LT.TOL)
     &   IRREP='  B2'
       IF(DABS(OVRLPZ+1.D0).LT.TOL.AND.DABS(OVRLPY+1.D0).LT.TOL)
     &   IRREP='  B3'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D3 ')THEN
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  A2'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  A1'
       IF(NDEG.EQ.2)IRREP='   E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D4 ')THEN
       CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(NDEG.EQ.2)IRREP='   E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D5 ')THEN
       CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP='  A2'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP='  A1'
       IF(DABS(OVRLP-C72).LT.TOL)IRREP='  E1'
       IF(DABS(OVRLP-C144).LT.TOL)IRREP='  E2'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'D6 ')THEN
       CALL COMVEC(NDEG,'C',6,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',2,1,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='B'
       IF(DABS(OVRLP2-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(DABS(OVRLP2+1.D0).LT.TOL)IRREP(4:4)='2'
       IF(NDEG.EQ.2)THEN
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  E1'
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  E2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C2 ')THEN
       CALL COMVEC(NDEG,'C',2,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='   A'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='   B'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C3 ')THEN  
       IF(NDEG.EQ.1)IRREP='   A'
       IF(NDEG.EQ.2)IRREP='   E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C4 ')THEN
       CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='   A'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='   B'
       IF(NDEG.EQ.2)IRREP='   E'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C5 ')THEN
       IF(NDEG.EQ.1)IRREP='   A'
       IF(NDEG.EQ.2)THEN
        CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        IF(DABS(OVRLP-C72).LT.TOL)IRREP='  E1'
        IF(DABS(OVRLP-C144).LT.TOL)IRREP='  E2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'C6 ')THEN
       CALL COMVEC(NDEG,'C',6,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='   B'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='   A'
       IF(DABS(OVRLP+2.D0).LT.TOL)IRREP='  E2'
       IF(DABS(OVRLP-2.D0).LT.TOL)IRREP='  E1'
       RETURN
C
C BIG SCARY CUBIC GROUPS - MUST ASSUME SOME SORT OF STANDARD ORIENTATION
C  FOR THESE BEASTS.  
C
      ELSEIF(PTGRP(1:3).EQ.'T d')THEN
C
C Td PLACES SUCH THAT THE Z AXIS IS ONE OF THE C2'S.
C
       IF(NDEG.EQ.2)THEN
        IRREP='   E'
        RETURN
       ELSE
        CALL COMVEC(NDEG,'S',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        IF(NDEG.EQ.1)THEN
         IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  A2'
         IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  A1'
        ELSE
         IF(DABS(OVRLP+1.D0).LT.TOL)IRREP='  T2'
         IF(DABS(OVRLP-1.D0).LT.TOL)IRREP='  T1'
        ENDIF
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'O h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       Z=OVRLP/FLOAT(NDEG)
       IF(DABS(Z+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(Z-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.2)THEN
        IRREP(2:3)=' E'
        RETURN
       ENDIF
       CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,Z1)
       IF(DABS(Z1+1.D0).LT.TOL)IRREP(3:3)='2'
       IF(DABS(Z1-1.D0).LT.TOL)IRREP(3:3)='1'
       IF(NDEG.EQ.3)IRREP(2:2)='T'
       IF(NDEG.EQ.1)IRREP(2:2)='A'
       RETURN
C
C ESOTERIC CUBIC GROUPS.  THIS CODE WILL NEVER BE TOUCHED!
C
      ELSEIF(PTGRP(1:3).EQ.'O  ')THEN
       CALL COMVEC(NDEG,'C',4,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='1'
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='2'
       IF(NDEG.EQ.1)IRREP(3:3)='A'
       IF(NDEG.EQ.2)IRREP='   E'
       IF(NDEG.EQ.3)IRREP(3:3)='T'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'T  ')THEN
       IF(NDEG.EQ.1)IRREP='   A'
       IF(NDEG.EQ.2)IRREP='   E'
       IF(NDEG.EQ.3)IRREP='   T'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'T h')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.1)IRREP(1:3)='  A'
       IF(NDEG.EQ.2)IRREP(1:3)='  E'
       IF(NDEG.EQ.3)IRREP(1:3)='  T'
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'I h')THEN
C
C NOTE THAT THIS ASSUMES THAT THE C5 AXIS IS ALONG Z.
C
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       OVRLP=OVRLP/FLOAT(NDEG)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='u'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='g'
       IF(NDEG.EQ.1)IRREP(3:3)='A'
       IF(NDEG.EQ.4)IRREP(3:3)='G'
       IF(NDEG.EQ.5)IRREP(3:3)='H'
       IF(NDEG.EQ.3)THEN
        ETAP=0.5D0*(1.D0+DSQRT(5.D0))
        ETAM=0.5D0*(1.D0-DSQRT(5.D0))
        CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        IF(DABS(OVRLP-ETAP).LT.TOL)IRREP(2:3)='T1'
        IF(DABS(OVRLP-ETAM).LT.TOL)IRREP(2:3)='T2'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'I  ')THEN
       IF(NDEG.EQ.1)IRREP(4:4)='A'
       IF(NDEG.EQ.2)IRREP(4:4)='E'
       IF(NDEG.EQ.4)IRREP(4:4)='G'
       IF(NDEG.EQ.5)IRREP(4:4)='H'
       IF(NDEG.EQ.3)THEN
        ETAP=0.5D0*(1.D0+DSQRT(5.D0))
        ETAM=0.5D0*(1.D0-DSQRT(5.D0))
        CALL COMVEC(NDEG,'C',5,1,3,NPOS,Q,SCRATCH,NORD,V,OVRLP)
        IF(DABS(OVRLP-ETAP).LT.TOL)IRREP(3:4)='T1'
        IF(DABS(OVRLP-ETAM).LT.TOL)IRREP(3:4)='T2'
       ENDIF
       RETURN
C
C LINEAR MOLECULES!
C
      ELSEIF(PTGRP(1:3).EQ.'DXh')THEN
       CALL COMVEC(NDEG,'I',0,0,0,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'P',0,0,1,NPOS,Q,SCRATCH,NORD,V,OVRLP2)
       CALL COMVEC(NDEG,'C',16,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       IF(NDEG.EQ.1)IRREP(1:2)='SG'
       IF(NDEG.EQ.2)THEN
       IRREP(1:2)='PI'
        DO 3100 J=1,3
         Z=2.D0*DCOS(FLOAT(J)*DACOS(-1.D0)/8.D0)
         IF(DABS(OVRLP3-Z).LT.TOL)IRREP(1:2)=GREEK(J+1)
 3100   CONTINUE
       ENDIF
       OVRLP=OVRLP/FLOAT(NDEG)
       OVRLP2=OVRLP2/FLOAT(NDEG)
       IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(3:3)='u'
       IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(3:3)='g'
       IF(NDEG.EQ.1)THEN
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='-'
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='+'
       ENDIF
       RETURN
      ELSEIF(PTGRP(1:3).EQ.'CXv')THEN
       CALL COMVEC(NDEG,'P',0,0,1,NPOS,Q,SCRATCH,NORD,V,OVRLP)
       CALL COMVEC(NDEG,'C',16,0,3,NPOS,Q,SCRATCH,NORD,V,OVRLP3)
       IF(NDEG.EQ.1)THEN
        IRREP(2:3)='SG'
        IF(DABS(OVRLP+1.D0).LT.TOL)IRREP(4:4)='-'
        IF(DABS(OVRLP-1.D0).LT.TOL)IRREP(4:4)='+'
       ELSE
        IRREP(3:4)='PI'
        DO 3101 J=1,3
         Z=2.D0*DCOS(FLOAT(J)*DACOS(-1.D0)/8.D0)
         IF(DABS(OVRLP3-Z).LT.TOL)IRREP(3:4)=GREEK(J+1)
 3101   CONTINUE
       ENDIF
       ELSE
C
C
       WRITE(6,*)' DON''T KNOW HOW TO GENERATE IRREPS FOR ',PTGRP,
     &' LEAVE ME ALONE! '
      ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__MEMORY_SOI_DERV_CSGTO
     +
     +                    ( NALPHA,NCOEFF,
     +                      NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL2,SHELL3,SHELL4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      DER1X,DER1Y,DER1Z,
     +                      DER2X,DER2Y,DER2Z,
     +                      DER3X,DER3Y,DER3Z,
     +                      DER4X,DER4Y,DER4Z,
     +                      ALPHA,CC,
     +                      L1CACHE,NCTROW,
     +                      SPHERIC,
     +
     +                                IMIN,IOPT,
     +                                ZMIN,ZOPT )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__MEMORY_DERV_CSGTO
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__SET_DERV_ABCD
C                ERD__DERV_DEF_BLOCKS
C  DESCRIPTION : This operation calculates the minimum and optimum
C                integer/flp memory needed for evaluating a batch
C                of contracted derivative electron repulsion integrals
C                on up to four different centers between cartesian or
C                spherical gaussian type shells.
C
C
C                  Input (x = 1,2,3 and 4):
C
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1,2,3 and 4
C                    DERyp        =  the order of differentiation on
C                                    centers y = 1,2,3,4 with respect
C                                    to the p = x,y,z coordinates
C                    ALPHA        =  primitive exponents for csh
C                                    1,2,3,4 in that order
C                    CC           =  contraction coefficient for csh
C                                    1,2,3,4 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    SPHERIC      =  is true, if spherical integrals
C                                    are wanted, false if cartesian
C                                    ones are wanted
C
C                  Output:
C
C                    IMIN,IOPT    =  minimum/optimum integer memory
C                    ZMIN,ZOPT    =  minimum/optimum flp memory
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     EMPTY
         LOGICAL     EQUALAB,EQUALCD
         LOGICAL     MEMORY
         LOGICAL     SPHERIC

         LOGICAL     DUMMYL (1:14)

         CHARACTER*4   ANGMTYP
         CHARACTER*4   PRIMTYP

         INTEGER     DER1X,DER2X,DER3X,DER4X
         INTEGER     DER1Y,DER2Y,DER3Y,DER4Y
         INTEGER     DER1Z,DER2Z,DER3Z,DER4Z
         INTEGER     DERAX,DERBX,DERCX,DERDX
         INTEGER     DERAY,DERBY,DERCY,DERDY
         INTEGER     DERAZ,DERBZ,DERCZ,DERDZ
         INTEGER     DERPX,DERPY,DERPZ
         INTEGER     DERQX,DERQY,DERQZ
         INTEGER     IMIN,INEED,IOPT
         INTEGER     L1CACHE,NCTROW
         INTEGER     LCC1,LCC2,LCC3,LCC4
         INTEGER     LEXP1,LEXP2,LEXP3,LEXP4
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSHELL,MXSIZE
         INTEGER     NALPHA,NCOEFF
         INTEGER     NCGTO1,NCGTO2,NCGTO3,NCGTO4
         INTEGER     NCGTOA,NCGTOB,NCGTOC,NCGTOD,NCGTOAB,NCGTOCD
         INTEGER     NCOLHRR,NROTHRR,NXYZHRR
         INTEGER     NCTR
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NGQP,NMOM,NGQSCR
         INTEGER     NIJ,NKL
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4
         INTEGER     NPGTOA,NPGTOB,NPGTOC,NPGTOD,NPGTOAB,NPGTOCD
         INTEGER     NROTA,NROTB,NROTC,NROTD
         INTEGER     NROWA,NROWB,NROWC,NROWD
         INTEGER     NRYA,NRYB,NRYC,NRYD
         INTEGER     NXYZA,NXYZB,NXYZC,NXYZD
         INTEGER     NXYZT
         INTEGER     SHELL1,SHELL2,SHELL3,SHELL4
         INTEGER     SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER     SHELLP,SHELLQ,SHELLT
         INTEGER     ZMIN,ZNEED,ZOPT,ZOUT1,ZOUT2

         INTEGER     DUMMYI (1:56)

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)

         DOUBLE PRECISION  DUMMYR (1:21)
C
C
C------------------------------------------------------------------------
C
C
C             ...set initial memory values.
C
C
         IMIN = 0
         IOPT = 0
         ZMIN = 0
         ZOPT = 0
C
C
C             ...fix the A,B,C,D labels from the 1,2,3,4 ones.
C                Calculate the relevant data for the A,B,C,D batch of
C                derivative integrals. Most of this data is not needed
C                to evaluate the memory requirements and is dumped into
C                the DUMMYx arrays with x=I,R,L standing for integer,
C                real and logical, respectively.
C
C
         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LEXP3 = LEXP2 + NPGTO2
         LEXP4 = LEXP3 + NPGTO3

         LCC1 = 1
         LCC2 = LCC1 + NPGTO1 * NCGTO1
         LCC3 = LCC2 + NPGTO2 * NCGTO2
         LCC4 = LCC3 + NPGTO3 * NCGTO3

         CALL  ERD__SET_SOI_DERV_ABCD
     +
     +              ( NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                SHELL1,SHELL2,SHELL3,SHELL4,
     +                X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                ALPHA (LEXP1),ALPHA (LEXP2),
     +                ALPHA (LEXP3),ALPHA (LEXP4),
     +                CC (LCC1),CC (LCC2),CC (LCC3),CC (LCC4),
     +                DER1X,DER1Y,DER1Z,
     +                DER2X,DER2Y,DER2Z,
     +                DER3X,DER3Y,DER3Z,
     +                DER4X,DER4Y,DER4Z,
     +                SPHERIC,
     +
     +                            NCGTOA,NCGTOB,NCGTOC,NCGTOD,
     +                            NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                            SHELLA,SHELLB,SHELLC,SHELLD,
     +                            SHELLP,SHELLQ,SHELLT,
     +                            MXSHELL,
     +                            DUMMYR (1), DUMMYR (2), DUMMYR (3),
     +                            DUMMYR (4), DUMMYR (5), DUMMYR (6),
     +                            DUMMYR (7), DUMMYR (8), DUMMYR (9),
     +                            DUMMYR (10),DUMMYR (11),DUMMYR (12),
     +                            NDERX,NDERY,NDERZ,
     +                            DERAX,DERAY,DERAZ,
     +                            DERBX,DERBY,DERBZ,
     +                            DERCX,DERCY,DERCZ,
     +                            DERDX,DERDY,DERDZ,
     +                            DERPX,DERPY,DERPZ,
     +                            DERQX,DERQY,DERQZ,
     +                            DUMMYL (1), DUMMYL (2), DUMMYL (3),
     +                            DUMMYL (4), DUMMYL (5), DUMMYL (6),
     +                            DUMMYL (7),
     +                            DUMMYI (1),
     +                            DUMMYI (17),
     +                            DUMMYI (21),
     +                            PRIMTYP,ANGMTYP,
     +                            DUMMYL (8), DUMMYL (9),
     +                            EQUALAB,EQUALCD,
     +                            DUMMYR (13),DUMMYR (14),DUMMYR (15),
     +                            DUMMYR (16),DUMMYR (17),DUMMYR (18),
     +                            DUMMYI (25),
     +                            DUMMYR (19),DUMMYR (20),
     +                            DUMMYR (21),
     +                            DUMMYI (25),DUMMYI (26),DUMMYI (27),
     +                            NXYZT,
     +                            NXYZA,NXYZB,NXYZC,NXYZD,
     +                            NRYA,NRYB,NRYC,NRYD,
     +                            DUMMYI (28),DUMMYI (29),
     +                            DUMMYI (30),DUMMYI (31),
     +                            DUMMYL (10),DUMMYL (11),DUMMYL (12),
     +                            DUMMYL (13),DUMMYL (14),
     +                            DUMMYI (32),DUMMYI (33),DUMMYI (34),
     +                            DUMMYI (35),DUMMYI (36),DUMMYI (37),
     +                            DUMMYI (38),DUMMYI (39),DUMMYI (40),
     +                            DUMMYI (41),DUMMYI (42),DUMMYI (43),
     +                            NXYZHRR,NCOLHRR,NROTHRR,
     +                            EMPTY )
     +
     +
         IF (EMPTY) THEN
             RETURN
         END IF
C
C
C             ...simulate the cartesian contracted (e0|f0) batch
C                generation.
C
C
         IF (EQUALAB) THEN
             NPGTOAB = (NPGTOA*(NPGTOA+1))/2
             NCGTOAB = (NCGTOA*(NCGTOA+1))/2
         ELSE
             NPGTOAB = NPGTOA * NPGTOB
             NCGTOAB = NCGTOA * NCGTOB
         END IF

         IF (EQUALCD) THEN
             NPGTOCD = (NPGTOC*(NPGTOC+1))/2
             NCGTOCD = (NCGTOC*(NCGTOC+1))/2
         ELSE
             NPGTOCD = NPGTOC * NPGTOD
             NCGTOCD = NCGTOC * NCGTOD
         END IF

         NCTR = NCGTOAB * NCGTOCD
C
C
C             ...at this point we would determine the IJ and KL
C                exponent pairs necessay to evaluate the cartesian
C                contracted (e0|f0) batch after a possible screening
C                of the primitives. Since at the moment we do not
C                apply screening for memory determination, we use the
C                complete set of IJ and KL pairs. In any event this
C                will be changed in the future, this is where a memory
C                routine handling the IJ and KL pair determination
C                should be placed.
C
C
         NIJ = NPGTOAB
         NKL = NPGTOCD

         ZNEED = NPGTOAB + NPGTOCD
         INEED = 2 * ZNEED + NDERX + NDERY + NDERZ + 3

         IMIN = MAX (IMIN,INEED)
         IOPT = MAX (IOPT,INEED)
         ZMIN = MAX (ZMIN,ZNEED)
         ZOPT = MAX (ZOPT,ZNEED)
C
C
C             ...determine minimum and optimum flp needs for the
C                primitive (e0|cd) or (ab|cd) contracted derivative
C                batch generation.
C
C
         NGQP = 1 + (SHELLT + NDERX + NDERY + NDERZ) / 2
         NMOM = 2 * NGQP - 1
         NGQSCR = 5 * NMOM + 2 * NGQP - 2

         MEMORY = .TRUE.

         CALL  ERD__DERV_DEF_BLOCKS
     +
     +              ( 0,
     +                NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                SHELLA,SHELLB,SHELLC,SHELLD,
     +                SHELLP,SHELLQ,
     +                NIJ,NKL,
     +                NCGTOAB,NCGTOCD,NCTR,
     +                NGQP,NGQSCR,
     +                NXYZT,
     +                DERAX,DERAY,DERAZ,
     +                DERBX,DERBY,DERBZ,
     +                DERCX,DERCY,DERCZ,
     +                DERDX,DERDY,DERDZ,
     +                DERPX,DERPY,DERPZ,
     +                DERQX,DERQY,DERQZ,
     +                PRIMTYP,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                         ZOUT1,ZOUT2,
     +                         DUMMYI (1),DUMMYI (2),DUMMYI (3),
     +                         DUMMYI (4),DUMMYI (5),DUMMYI (6),
     +                         DUMMYI (7),
     +                         MXPRIM,MNPRIM,
     +                         DUMMYI (8) ,DUMMYI (9) ,DUMMYI (10),
     +                         DUMMYI (11),DUMMYI (12),DUMMYI (13),
     +                         DUMMYI (14),DUMMYI (15),DUMMYI (16),
     +                         DUMMYI (17),DUMMYI (18),DUMMYI (19),
     +                         DUMMYI (20),DUMMYI (21),DUMMYI (22),
     +                         DUMMYI (23),DUMMYI (24),DUMMYI (25),
     +                         DUMMYI (26),DUMMYI (27),DUMMYI (28),
     +                         DUMMYI (29),DUMMYI (30),DUMMYI (31),
     +                         DUMMYI (32),DUMMYI (33),DUMMYI (34),
     +                         DUMMYI (35),DUMMYI (36),DUMMYI (37),
     +                         DUMMYI (38),DUMMYI (39),DUMMYI (40),
     +                         DUMMYI (41),DUMMYI (42),DUMMYI (43),
     +                         DUMMYI (44),DUMMYI (45),DUMMYI (46),
     +                         DUMMYI (47),DUMMYI (48),DUMMYI (49),
     +                         DUMMYI (50),DUMMYI (51),DUMMYI (52),
     +                         DUMMYI (53),DUMMYI (54),DUMMYI (55),
     +                         DUMMYI (56) )
     +
     +
         INEED = INEED + 2 * MXPRIM + MNPRIM

         IMIN = MAX (IMIN,INEED)
         IOPT = MAX (IOPT,INEED)
         ZMIN = MAX (ZMIN,ZOUT1)
         ZOPT = MAX (ZOPT,ZOUT2)
C
C
C             ...determine the integer/flp memory needs for the next
C                steps:
C
C
C                1) expanding the contraction indices (if any)
C                2) reordering the contraction indices (if any)
C                3) transposing the contraction indices (if any)
C                4) HRR contraction (if any)
C                5) cartesian -> spherical transformation or
C                   cartesian normalization
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                 |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                 Zone 1 and 2:  2 batches of HRR maximum size
C
C                       Zone 3:  cart -> spher transformation data
C                                             or
C                                cartesian normalization factors
C
C                       Zone 4:  HRR contraction data
C
C
         NCTR = NCGTO1 * NCGTO2 * NCGTO3 * NCGTO4
         MXSIZE = NCTR * NXYZHRR
C
C
C             ...memory for Zone 1 and 2.
C
C
         INEED = 0
         ZNEED = 2 * MXSIZE
C
C
C             ...memory for Zone 3.
C
C
         IF (SPHERIC) THEN
             IF (MXSHELL.GT.1) THEN

                 IF (SHELLD.GT.1) THEN
                     NROWD = (SHELLD/2+1)*(SHELLD/2+2)/2
                     NROTD = NROWD * NRYD
                     INEED = INEED + NRYD + NROTD
                     ZNEED = ZNEED + NROTD + NXYZD
                 END IF

                 IF ((SHELLC.GT.1) .AND. (SHELLC.NE.SHELLD)) THEN
                     NROWC = (SHELLC/2+1)*(SHELLC/2+2)/2
                     NROTC = NROWC * NRYC
                     INEED = INEED + NRYC + NROTC
                     ZNEED = ZNEED + NROTC + NXYZC
                 END IF

                 IF ((SHELLB.GT.1) .AND. (SHELLB.NE.SHELLC)
     +                             .AND. (SHELLB.NE.SHELLD)) THEN
                     NROWB = (SHELLB/2+1)*(SHELLB/2+2)/2
                     NROTB = NROWB * NRYB
                     INEED = INEED + NRYB + NROTB
                     ZNEED = ZNEED + NROTB + NXYZB
                 END IF

                 IF ((SHELLA.GT.1) .AND. (SHELLA.NE.SHELLB)
     +                             .AND. (SHELLA.NE.SHELLC)
     +                             .AND. (SHELLA.NE.SHELLD)) THEN
                     NROWA = (SHELLA/2+1)*(SHELLA/2+2)/2
                     NROTA = NROWA * NRYA
                     INEED = INEED + NRYA + NROTA
                     ZNEED = ZNEED + NROTA + NXYZA
                 END IF

             END IF
         ELSE
             IF (MXSHELL.GT.1) THEN
                 ZNEED = ZNEED + MXSHELL + 1
             END IF
         END IF
C
C
C             ...memory for Zone 4.
C
C
         IF (PRIMTYP.EQ.'E0CD') THEN
             INEED = INEED + 4 * NCOLHRR + 2 * NROTHRR
             ZNEED = ZNEED + 2 * NROTHRR
         END IF

         IMIN = MAX0 (IMIN,INEED)
         IOPT = MAX0 (IOPT,INEED)
         ZMIN = MAX0 (ZMIN,ZNEED)
         ZOPT = MAX0 (ZOPT,ZNEED)
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__C_EQ_C_TIMES_A_FLOAT
     +
     +                    ( DDROWC,DDCOLC,
     +                      DDROWA,DDCOLA,
     +                      DDWORK1,DDWORK2,
     +                      ROW,SUM,COL,
     +                      WORK1,WORK2,
     +                      A,
     +
     +                              C )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__C_EQ_C_TIMES_A_FLOAT
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation multiplies the two-dimensional matrix C
C                by the two-dimensional matrix A and stores the result
C                in matrix C. Matrix is C is thus overwritten:
C
C                                C = C * A
C
C                All matrices must be of floating point type.
C
C                Elementwise we can write the multiplication as:
C
C                          C(ij)  =  sum  C(ik) * A(kj)
C                                     k
C
C                where the index ranges are:
C
C                           i index    ->   1 to ROW
C                           j index    ->   1 to COL
C                           k index    ->   1 to SUM
C
C                Thus overwriting matrix C makes only sense, if its
C                column dimension declared is not smaller than the
C                # of columns of matrix A, i.e. we must have:
C
C                               DDCOLC >= COL
C
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    DDROWA,DDCOLA
         INTEGER    DDROWC,DDCOLC
         INTEGER    DDWORK1,DDWORK2
         INTEGER    I,J,K
         INTEGER    ROW,SUM,COL

         DOUBLE PRECISION   X,ZERO

         DOUBLE PRECISION   WORK1 (1:DDWORK1)
         DOUBLE PRECISION   WORK2 (1:DDWORK2)

         DOUBLE PRECISION   A (1:DDROWA,1:DDCOLA)
         DOUBLE PRECISION   C (1:DDROWC,1:DDCOLC)

         PARAMETER  (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions for matrix A.
C
C
         IF  (SUM.GT.DDROWA .OR. COL.GT.DDCOLA)  THEN
              WRITE (*,*) ' Dimensions of matrix A too small! '
              WRITE (*,*) ' mat__c_eq_c_times_a_float '
              WRITE (*,*) ' DDROWA,DDCOLA,SUM,COL = ',
     +                      DDROWA,DDCOLA,SUM,COL
              WRITE (1,*) ' Dimensions of matrix A too small! '
              WRITE (1,*) ' mat__c_eq_c_times_a_float '
              WRITE (1,*) ' DDROWA,DDCOLA,SUM,COL = ',
     +                      DDROWA,DDCOLA,SUM,COL
              STOP
         END IF
C
C
C             ...check dimensions for matrix C.
C
C
         IF  (ROW.GT.DDROWC .OR. MAX0 (SUM,COL).GT.DDCOLC)  THEN
              WRITE (*,*) ' Dimensions of matrix C too small! '
              WRITE (*,*) ' mat__c_eq_c_times_a_float '
              WRITE (*,*) ' DDROWC,DDCOLC,ROW,SUM,COL = ',
     +                      DDROWC,DDCOLC,ROW,SUM,COL
              WRITE (1,*) ' Dimensions of matrix C too small! '
              WRITE (1,*) ' mat__c_eq_c_times_a_float '
              WRITE (1,*) ' DDROWC,DDCOLC,ROW,SUM,COL = ',
     +                      DDROWC,DDCOLC,ROW,SUM,COL
              STOP
         END IF
C
C
C             ...check dimensions for working vectors.
C
C
         IF  (SUM.GT.DDWORK1 .OR. COL.GT.DDWORK2)  THEN
              WRITE (*,*) ' Dimensions of working arrays too small! '
              WRITE (*,*) ' mat__c_eq_c_times_a_float '
              WRITE (*,*) ' DDWORK1,DDWORK2,SUM,COL = ',
     +                      DDWORK1,DDWORK2,SUM,COL
              WRITE (1,*) ' Dimensions of working arrays too small! '
              WRITE (1,*) ' mat__c_eq_c_times_a_float '
              WRITE (1,*) ' DDWORK1,DDWORK2,SUM,COL = ',
     +                      DDWORK1,DDWORK2,SUM,COL
              STOP
         END IF
C
C
C             ...proceed in most cache effective way.
C
C
         DO I = 1,ROW

            DO K = 1,SUM
               WORK1 (K) = C (I,K)
            END DO

            DO J = 1,COL
               X = ZERO
               DO K = 1,SUM
                  X = X + WORK1 (K) * A (K,J)
               END DO
               WORK2 (J) = X
            END DO

            DO J = 1,COL
               C (I,J) = WORK2 (J)
            END DO

         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

C ROUTINE TO PERFORM A GATHER OPERATION ON INTEGER VARIABLES

      SUBROUTINE IGATHER(N,A,B,INDEX)
      IMPLICIT INTEGER (A-Z)
      DIMENSION A(N),INDEX(N),B(1)
      if (n.lt.1) return
      DO I = 1, N
         A(I) = B(INDEX(I))
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine write_eig_data(ca, cb, focka, fockb, n, need_predef)
c---------------------------------------------------------------------------
c   Writes eigenvector/eigenvalue data to jobarc file.
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer n
      logical need_predef(*)
      double precision ca(n,n), cb(n,n), focka(n,n), fockb(n,n)
      double precision scr(n)

      integer i, j, ierd

      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      equivalence (ibuf(1), dbuf(1))
      common dbuf
#endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif
      if (intpkg .eq. flocke_package) then

c---------------------------------------------------------------------------
c   Transform the CA and CB data from ERD order/scaling to VMOL order/scaling.
c---------------------------------------------------------------------------

         go to 10 
         if (need_predef(1) .or.
     *       need_predef(2)) then
            do j = 1, n
               do i = 1, n
                  scr(i) = ca(i,j)
               enddo

               do i = 1, n
                  ierd = ibuf(ierdind+i-1)
                  ca(ierd,j) = scr(i)/dbuf(iscale_fac+ierd-1)
               enddo
            enddo   
         endif

         if (need_predef(3)) then 
            do j = 1, n
               do i = 1, n
                  scr(i) = cb(i,j)
               enddo

               do i = 1, n
                  ierd = ibuf(ierdind+i-1)
                  cb(ierd,j) = scr(i)/dbuf(iscale_fac+ierd-1)
               enddo
            enddo
         endif   
10       continue 

c---------------------------------------------------------------------------
c   Save the diagonals of the FOCKA array.
c---------------------------------------------------------------------------

         if (need_predef(9)) then
            do i = 1, n
               scr(i) = focka(i,i)
            enddo

c---------------------------------------------------------------------------
c   Unscramble the shells from the binpack'ed order.
c---------------------------------------------------------------------------

            call descramble_coefficients(ca, n, scr, nfps, ixshells, 
     *                                nshells)

            do i = 1, n
               focka(i,i) = scr(i)
            enddo
         endif   

c---------------------------------------------------------------------------
c   Save the diagonals of the FOCKB array.
c---------------------------------------------------------------------------

         if (need_predef(10)) then
            do i = 1, n
               scr(i) = fockb(i,i)
            enddo

c---------------------------------------------------------------------------
c   Unscramble the shells from the binpack'ed order.
c---------------------------------------------------------------------------

            call descramble_coefficients(cb, n, scr, nfps, ixshells,
     *                                nshells)

            do i = 1, n
               fockb(i,i) = scr(i)
            enddo
         endif  ! need_predef
      endif     ! flocke_package

c---------------------------------------------------------------------------
c   Write the eigenvector data to JOBARC.
c---------------------------------------------------------------------------

         if (need_predef(1) .or.
     *       need_predef(2)) then
            call dputrec(1,'JOBARC','SCFEVCA0',n*n, ca)
         endif

         if (need_predef(3)) then
            call dputrec(1,'JOBARC','SCFEVCB0',n*n, cb)
         endif

c---------------------------------------------------------------------------
c   Write the eigenvalue data to JOBARC.
c---------------------------------------------------------------------------

      if (need_predef(9)) then
         do i = 1, n
            scr(i) = focka(i,i)
         enddo

         call dputrec(1, 'JOBARC', 'SCFEVLA0',n, scr)
      endif

c---------------------------------------------------------------------------
c   Write the data to JOBARC.
c---------------------------------------------------------------------------

      if (need_predef(10)) then
         do i = 1, n
            scr(i) = fockb(i,i)
         enddo

         call dputrec(1, 'JOBARC', 'SCFEVLB0',n, scr)
      endif

c---------------------------------------------------------------------------
c   Write out OCCUPYA0, OCCUPYB0.
c---------------------------------------------------------------------------

      call iputrec(1, 'JOBARC', 'OCCUPYA0', 1, nalpha_occupied)
      call iputrec(1, 'JOBARC', 'OCCUPYB0', 1, nbeta_occupied)

c---------------------------------------------------------------------------
c   Write out the SCFOCCA and SCFOCCB values.
c---------------------------------------------------------------------------

      do i = 1, n
         if (i .le. nalpha_occupied) then
            scr(i) = 1.
         else
            scr(i) = 0.
         endif
      enddo

      call dputrec(1, 'JOBARC', 'SCFOCCA', nalpha_occupied, scr)

      do i = 1, n
         if (i .le. nbeta_occupied) then
            scr(i) = 1.
         else
            scr(i) = 0.
         endif
      enddo

      call dputrec(1, 'JOBARC', 'SCFOCCB', nbeta_occupied, scr)


      return
      end

      SUBROUTINE MATMULV(A,B,C,NA,NB,NC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NC,NA),B(NB,NA),C(NB,NC)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      CALL XGEMM('T','N',NC,NA,NB,ONE,C,NB,B,NB,ZILCH,A,NC)
c      DO 10 I=1,NA
c      DO 10 K=1,NC
c      Z=0.D0
c      DO 20 J=1,NB
c      Z=Z+B(J,I)*C(J,K)
c20    CONTINUE
c      A(K,I)=Z
c10    CONTINUE
       RETURN 
      END

       CHARACTER*(*) FUNCTION FILTSP (STRING)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose:      Filter spaces - reduce each run of whitespace to a 
C               single space character.
C
C Arguments:    STRING      character string (input only)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C $Log: filtsp.f,v $
C Revision 1.1.1.1  2003/04/02 19:21:35  aces
C INITIAL 2.4 IMPORT
C
c Revision 4.1  89/08/19  14:06:48  bernhold
c From the strings library, but this one works right!
c 
C    Revision 1.1  88/01/14  13:14:25  bernhold
C    Initial revision
C    
C
C System:       Standard FORTRAN 77
C 
C Copyright 1988 David E. Bernholdt
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       CHARACTER*(*) STRING
       INTEGER I, J
       CHARACTER*1 C
       LOGICAL INSPAC
C
C      I is position in input string, J is position in output string
C
       J = 1
       INSPAC = .FALSE.
       DO 100 I = 1, LEN(STRING)       
          C = STRING(I:I)
C
C         Whitespace is defined as in the routine ISSPAC, to be:
C            HT, LF, VT, FF, CR, or space
          IF ((LGE(C,CHAR(9)) .AND. LLE(C,CHAR(13))) .OR. C.EQ.' ')
     1    THEN
C
C            Copy only the first space in a run of them
             IF (INSPAC) THEN
                FILTSP(J:J) = ' '
                INSPAC = .TRUE.
                J = J + 1
             ENDIF
C
C         This isn't a space, so just copy it.
          ELSE
             INSPAC = .FALSE.
             FILTSP(J:J) = C
             J = J + 1
          ENDIF
  100  CONTINUE
C
       RETURN
       END

      SUBROUTINE GENTRANMAT(SCR, MAXCOR)
C
C MAXPRIM  - Maximum number of primitives in a shell (30).
C MAXFNC  - as above (apparently). Number of contracted functions in
C           a shell. Sometimes MAXPRIM is used instead.
C           [MAXPRIM and MAXFNC must keep same value the way things
C                are coded. It is desirable in any case to have them the
C                same so we can do large uncontracted calculations.
C                However, the allocation for READIN and dimensioning in
C                READIN are a bit sloppy, and should be improved.]
C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers (400).
C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers (800).
C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers (100).
C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions) (500).
C
C     /INDX/  :
C
C     KMAX          - Number of shells.
C     KHKT(7)       - KHKT(I) = I*(I+1)/2
C     NHKT(MXTNSH)  - L+1 value for each shell (1 for s, 2 for p, etc).
C     NUCO(MXTNSH)  - Number of primitives in each shell.
C     NRCO(MXTNSH)  - Number of contracted functions in each shell.
C
C     /DAT/   :
C
C     ALPHA(MXTNPR)   - Exponents of symmetry inequivalent centers.
C     CONT(MXTNCC)    - Coefficients of symmetry inequivalent centers.
C     CENT(3,MXTNSH ) - Coordinates of symmetry inequivalent shells.
C     CORD(100,3)     - Coordinates of symmetry inequivalent centers.
C     CHARGE(100)     - Nuclear charges of symmetry inequivalent centers.
C     FMULT(8)        - 
C     TLA             - A cutoff 10**-INTGRL_TOL.
C     TLC             - 0.1*TLA ?
C
C     /VMTASK/ :
C     
C     ITASK           -  0  NORMAL CALCULATION (DEFAULT)
C                     -  1  READIN ONLY
C                     -  2  READIN+ONEL+ONELH ONLY
C                     - >3  NORMAL CALCULATION.
C
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C-----------------------------------------------------------------------
C     Common block declarations (or at least some).
C-----------------------------------------------------------------------
      INTEGER NEWIND,MSTOLD
      DOUBLE PRECISION PC
      INTEGER DSTRT,NTAP,LU2,NRSS,NUCZ,ITAG,MAXLOP,MAXLOT,KMAX,NMAX,
     &        KHKT,MULT,ISYTYP,ITYPE,AND,OR,EOR,NPARSU,NPAR,MULNUC,
     &        NHKT,MUL,NUCO,NRCO,JSTRT,NSTRT,MST,JRS
      DOUBLE PRECISION ALPHA,CONT,CENT,CORD,CHARGE,FMULT,TLA,TLC
      DIMENSION SCR(MAXCOR)
C-----------------------------------------------------------------------
C     Parameters
C-----------------------------------------------------------------------

c These parameters are gathered from vmol and vdint and are used by ecp
c as well. It just so happens that the vmol parameters do not exist in
c vdint and vice versa. LET'S TRY TO KEEP IT THAT WAY!

c VMOL PARAMETERS ------------------------------------------------------

C     MAXPRIM - Maximum number of primitives for a given shell.
      INTEGER    MAXPRIM
      PARAMETER (MAXPRIM=72)

C     MAXFNC  - Maximum number of contracted functions for a given shell.
C               (vmol/readin requires this to be the same as MAXPRIM)
      INTEGER    MAXFNC
      PARAMETER (MAXFNC=MAXPRIM)

C     NHT     - Maximum angular momentum
      INTEGER    NHT
      PARAMETER (NHT=7)

C     MAXATM  - Maximum number of atoms
      INTEGER    MAXATM
      PARAMETER (MAXATM=100)

C     MXTNPR  - Maximum total number of primitives for all symmetry
C               inequivalent centers.
      INTEGER    MXTNPR
      PARAMETER (MXTNPR=MAXPRIM*MAXPRIM)

C     MXTNCC  - Maximum total number of contraction coefficients for
C               all symmetry inequivalent centers.
      INTEGER    MXTNCC
      PARAMETER (MXTNCC=180000)

C     MXTNSH  - Maximum total number of shells for all symmetry
C               inequivalent centers.
      INTEGER    MXTNSH
      PARAMETER (MXTNSH=200)

C     MXCBF   - Maximum number of Cartesian basis functions for the
C               whole system (NOT the number of contracted functions).
c mxcbf.par : begin

c MXCBF := the maximum number of Cartesian basis functions (limited by vmol)

c This parameter is the same as MAXBASFN. Do NOT change this without changing
c maxbasfn.par as well.

      INTEGER MXCBF
      PARAMETER (MXCBF=1000)
c mxcbf.par : end

c VDINT PARAMETERS -----------------------------------------------------

C     MXPRIM - Maximum number of primitives for all symmetry
C              inequivalent centers.
      INTEGER    MXPRIM
      PARAMETER (MXPRIM=MXTNPR)

C     MXSHEL - Maximum number of shells for all symmetry inequivalent centers.
      INTEGER    MXSHEL
      PARAMETER (MXSHEL=MXTNSH)

C     MXCORB - Maximum number of contracted basis functions.
      INTEGER    MXCORB
      PARAMETER (MXCORB=MXCBF)

C     MXORBT - Length of the upper or lower triangle length of MXCORB.
      INTEGER    MXORBT
      PARAMETER (MXORBT=MXCORB*(MXCORB+1)/2)

C     MXAOVC - Maximum number of subshells per center.
      INTEGER    MXAOVC,    MXAOSQ
      PARAMETER (MXAOVC=32, MXAOSQ=MXAOVC*MXAOVC)

c     MXCONT - ???
      INTEGER    MXCONT
      PARAMETER (MXCONT=MXAOVC)

      parameter (mxp2=maxprim*maxprim)
      parameter (khm=(nht*(nht+1))/2,nhl=mxp2*khm*khm)
      parameter (kwd=(nht+1)*(nht+2)*(nht+3)/6,nh4=4*nht-3)
C
      COMMON /TST/ TIM(40),IFREQ(40)
      COMMON /MMMM/ M2(12)
      COMMON /REP/ NEWIND(MXCBF) ,MSTOLD(8)
      COMMON /FLAGS/ IFLAGS(100)
C
      COMMON /INDX/ PC(512),DSTRT(8,MXCBF),NTAP,LU2,NRSS,NUCZ,ITAG,
     & MAXLOP,MAXLOT,KMAX,NMAX,KHKT(7),MULT(8),ISYTYP(3),ITYPE(7,28),
     & AND(8,8),OR(8,8),EOR(8,8),NPARSU(8),NPAR(8),MULNUC(100),
     & NHKT(MXTNSH),MUL(MXTNSH),NUCO(MXTNSH),NRCO(MXTNSH),JSTRT(MXTNSH),
     & NSTRT(MXTNSH),MST(MXTNSH),JRS(MXTNSH)
C
      COMMON /DAT/  ALPHA(MXTNPR),CONT(MXTNCC),CENT(3,MXTNSH),
     &              CORD(100,3),CHARGE(100),FMULT(8),TLA, TLC
C
      COMMON /SYMIND/ IBFS(MXCBF)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /MEMINF/ IJUNK(2),ITOTMEM,IHWM1,IHWM2
C-----------------------------------------------------------------------
C
      IPRINT = IFLAGS(1)
      INTES=0
      INTE53=0
      INTE32=0
      INTEF=4
C
      CALL ZERO(TIM,40)
      CALL IZERO(IFREQ,40)
      CALL  INITP
C
C ALLOCATE CORE FOR READIN ROUTINE
C
      I000 = 1
      I010 = I000 + MAXATM
      I020 = I010 + MXCBF*224
      I030 = I020 + MXTNCC
      I040 = I030 + MXTNCC
      I050 = I040 + MAXFNC*MAXFNC
      I060 = I050 + MAXFNC
      I070 = I060 + MAXFNC
      I080 = I070 + MAXFNC
      I090 = I080 + MXSHEL*28*15*8
      I100 = I090 + 50
      I110 = I100 + KWD*3
      I120 = I110 + NHT*MAXFNC
      I130 = I120 + NHT*MAXFNC
      I140 = I130 + 8
      I150 = I140 + 100*3
      I160 = I150 + 8*3
      I170 = I160 + MXTNCC
      I180 = I170 + NHT
      I190 = I180 + 8
      I200 = I190 + 18*8
      I210 = I200 + MXCBF
      I220 = I210 + MAXFNC*2
      I230 = I220 + MXCBF*224
      I240 = I230 + MXTNPR
      I250 = I240 + 100
      I260 = I250 + 100
      I270 = I260 + 3
      I280 = I270 + MXCBF
      I290 = I280 + MXCBF*224
      I300 = I290 + MXCBF*224
      ITOP = I300 + MXCBF*224
C
      IF(ITOP .GE. MAXCOR)THEN
         CALL INSMEM("GENTRANMAT", ITOP, MAXCOR)
      ENDIF
C
      CALL BLTAOTOSO(Scr(I000),Scr(I010),Scr(I020),Scr(I030),Scr(I040),
     &               Scr(I050),Scr(I060),Scr(I070),Scr(I080),Scr(I090),
     &               Scr(I100),Scr(I110),Scr(I120),Scr(I130),Scr(I140),
     &               Scr(I150),Scr(I160),Scr(I170),Scr(I180),Scr(I190),
     &               Scr(I200),Scr(I210),Scr(I220),Scr(I230),Scr(I240),
     &               Scr(I250),Scr(I260),Scr(I270),MAXFNC,
     &               NHT,KWD,NH4,Scr(I280),Scr(I290),Scr(I300))
C
      RETURN
      END

C  Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
C  USA
      subroutine form_fock_rohf(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block 

      integer array_type, nindex, inda(2), indb(2)    

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, farray, indblk, get_block_index
      integer*8 ibarray, fbarray 
      integer*8 integral_scr
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack

      double precision x(1)
      double precision dbuf(1), temp 
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Get the alpha Fock array.
c----------------------------------------------------------------------------

      array = 9 ! Fock_a for a placeholder   
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Fock arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: Fock array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      farray = get_index_from_base(address_table(array), x, 2)

c----------------------------------------------------------------------------
c   Get the beta Fock array.
c----------------------------------------------------------------------------

      array = 10 ! Fock_b for a placeholder   
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: Fock arrays in integral calc
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: Fock array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         indb(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      fbarray = get_index_from_base(address_table(array), x, 2)

      if (.not. dryrun) 
     *   call fock_rohf(1, indb(1), 1,indb(2), x(farray),x(fbarray))

      return
      end

      subroutine fock_rohf(s1,nend1,s2,nend2,Fapb,Famb) 
      implicit none
      include 'int_gen_parms.h'
      include 'parallel_info.h'

      integer s1, s2, nend1, nend2  
      integer i, j, k, l 
      integer nsingle, ndouble 
      double precision Fapb(1:nend1,1:nend2)   
      double precision Famb(1:nend1,1:nend2)   
      double precision Fa(1:nend1,1:nend2)   

      if (nalpha_occupied .eq. nbeta_occupied) then 
         ndouble = nalpha_occupied 
         nsingle = 0 
      else 
        ndouble = min(nalpha_occupied,nbeta_occupied) 
        nsingle = abs(nalpha_occupied-nbeta_occupied) 
      endif 
c
c Zero out the Fock_a(ROHF) array 
c
      DO I = 1, nbasis 
      DO J = 1, nbasis 
         FA(I,J) = 0.0d0  
      ENDDO 
      ENDDO 
c
c DOCC-DOCC block (arbitrary and it is set to -1/2FA + 3/2FB)
c
      Do I = 1, ndouble   
         Do J = 1, ndouble  
            FA(I,J) = (FAPB(I,J) + FAMB(I,J))/2.0d0 
         Enddo
      Enddo
c
cSOCC-SOCC block (arbitrary and it is set to 1/2FA + 1/2FB)
c
      Do I = ndouble+1, ndouble+nsingle  
         Do J = ndouble+1, ndouble+nsingle  
            FA(I,J) = (FAPB(I,J) + FAMB(I,J))/2.0d0 
         Enddo
      Enddo
c
cVIRT-VIRT block (arbitrary and it is set to 3/2FA - 1/2FB)
c
      Do I = ndouble+nsingle+1, nbasis  
         Do J = ndouble+nsingle+1, nbasis  
            FA(I,J) = (FAPB(I,J) + FAMB(I,J))/2.0d0 
         Enddo
      Enddo
c
cDOCC-SOCC block (arbitrary and it is set to FB)
c
      DO I = 1, ndouble  
         Do J = ndouble+1, ndouble+nsingle  
            FA(I,J) = FAMB(I,J)
         Enddo
      Enddo
c
      DO J = 1, ndouble  
         Do I = ndouble+1, ndouble+nsingle  
            FA(I,J) = FAMB(I,J)
         Enddo
      Enddo
c
cVIRT-DOCC block (arbitrary and it is set to 1/2(FB+FA))
c
      DO I = ndouble+nsingle+1, nbasis  
         Do J = 1, ndouble  
            FA(I,J) = (FAPB(I,J) + FAMB(I,J))/2.0d0 
         Enddo
      Enddo
c
      DO J = ndouble+nsingle+1, nbasis  
         Do I = 1, ndouble  
            FA(I,J) = (FAPB(I,J) + FAMB(I,J))/2.0d0 
         Enddo
      Enddo
c
cVIRT-SOCC block (arbitrary and it is set to FA)
c
      DO I = ndouble+nsingle+1, nbasis  
         Do J = ndouble+1, ndouble+nsingle  
            FA(I,J) = FAPB(I,J) 
         Enddo
      Enddo
c
      DO J = ndouble+nsingle+1, nbasis  
         Do I = ndouble+1, ndouble+nsingle  
            FA(I,J) = FAPB(I,J) 
         Enddo
      Enddo

100   continue 

      DO I = 1, nbasis 
      DO J = 1, nbasis 
         if (dabs(FA(I,J)) .GT. 100d0) 
     *       write(6,*) ' LARGE F ELEMENT', i,j,fa(i,j)
         FAMB(I,J) = FA(I,J) 
         FAPB(I,J) = FA(I,J) 
      ENDDO 
      ENDDO 
c     Do I = 1, nbasis    
c     Do J = 1, nbasis 
c        write(6,*) 'F', i, j, FAPB(I,J) , FAMB(I,J)  
c     enddo 
c     enddo 

      return 
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine proto_error_event(msg)
c--------------------------------------------------------------------------
c   Prints a message to stdout, and sends the master task an error
c   event, tirggering job termination.
c--------------------------------------------------------------------------
      implicit none

      include 'mpif.h'
      include 'proto_events.h'

      character*(*) msg

      integer master, me, ierr
      integer pst_get_master
      integer event 
      save event

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      print *,'ERROR on task ',me,': ',msg
      call c_flush_stdout()
 
      master = pst_get_master()
      event = mstr_error_event
      call mpi_send(event, 1, mpi_integer,
     *              master, master_event_tag, mpi_comm_world, ierr)
 
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__SORT_INT_VECTOR_ELEMENTS
     +
     +                    ( N,M,
     +                      FIRST,LAST,
     +                      ABSOLUT,INCRESE,
     +                      OFF,
     +                      VECTOR,
     +
     +                              SORT )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__SORT_INT_VECTOR_ELEMENTS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine returns those indices of a vector
C                containing integer elements, which correspond to
C                increasing (>=) or decreasing (=<) of (absolute)
C                vector values within a selected index range.
C                Schematically this can be shown by the following
C                picture:
C
C
C                    vector indices = 1 2 3 4 5 6 7 8 9 10 11 12
C
C                                           |            |
C                                         first         last
C
C                in which all vector values between index 4 and 10
C                will be sorted. The sorting technique used is
C                quicksort.
C
C
C                  Input:
C
C                    N            =  total # of vector elements
C                    M            =  total # of sorted vector indices
C                                    plus offset.
C                    FIRST,LAST   =  starting and ending indices
C                                    subjected to vector sorting.
C                    ABSOLUT      =  is true, if the absolute values
C                                    of the vector are to be taken
C                                    for ordering.
C                    INCRESE      =  is true, if the ordering is to
C                                    be performed according to
C                                    increasing (absolute) vector
C                                    values.
C                    OFF          =  offset value for placing sorted
C                                    vector indices.
C                    VECTOR (I)   =  the integer vector elements.
C                                    Range of I is 1 to N.
C
C
C                  Output:
C
C                    SORT (OFF+I) =  contains the I-th increasing or
C                                    decreasing vector index, with I
C                                    ranging from 1 to LAST-FIRST+1.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ABSOLUT
         LOGICAL     INCRESE

         INTEGER     DIFF
         INTEGER     FACTOR
         INTEGER     FIRST,LAST
         INTEGER     I,J,M,N
         INTEGER     JBEG,JEND
         INTEGER     LEFT,RIGHT
         INTEGER     MAXIDX
         INTEGER     OFF,RELOFF
         INTEGER     SORTJ
         INTEGER     ZERO

         INTEGER     SORT   (1:M)
         INTEGER     VECTOR (1:N)

         DATA  ZERO  /0/
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF  (N.LT.LAST)  THEN
              WRITE (*,*) ' Last order index exceeds vector dimension! '
              WRITE (*,*) ' nlo__sort_int_vector_elements '
              WRITE (*,*) ' N,LAST = ',N,LAST
              WRITE (1,*) ' Last order index exceeds vector dimension! '
              WRITE (1,*) ' nlo__sort_int_vector_elements '
              WRITE (1,*) ' N,LAST = ',N,LAST
              STOP
         END IF

         RELOFF = OFF - FIRST + 1
         MAXIDX = RELOFF + LAST

         IF  (MAXIDX.GT.M)  THEN
              WRITE (*,*) ' Sorted index vector dimension too small! '
              WRITE (*,*) ' nlo__sort_int_vector_elements '
              WRITE (*,*) ' largest index, dimension = ',MAXIDX,M
              WRITE (1,*) ' Sorted index vector dimension too small! '
              WRITE (1,*) ' nlo__sort_int_vector_elements '
              WRITE (1,*) ' largest index, dimension = ',MAXIDX,M
              STOP
         END IF
C
C
C             ...perform quicksort on vector index values:
C
C                i) based on absolute integer vector values.
C
C
         IF (INCRESE) THEN
             FACTOR = +1
         ELSE
             FACTOR = -1
         END IF

         IF (ABSOLUT) THEN

             DO 100 I = FIRST,LAST
                LEFT = FIRST
                RIGHT = I - 1
  110           IF (LEFT .GT. RIGHT) THEN
                    JBEG = RELOFF + LEFT
                    IF (I .GT. LEFT) THEN
                        JEND = RELOFF + I - 1
                        DO 120 J = JEND,JBEG,-1
                           SORT (J + 1) = SORT (J)
  120                   CONTINUE
                    END IF
                    SORT (JBEG) = I
                ELSE
                    J = (LEFT + RIGHT) / 2
                    SORTJ = SORT (RELOFF + J)
                    DIFF = IABS (VECTOR (I)) - IABS (VECTOR (SORTJ))
                    IF ((FACTOR * DIFF) .LT. ZERO) THEN
                        RIGHT = J - 1
                    ELSE
                        LEFT = J + 1
                    END IF
                    GOTO 110
                END IF
  100        CONTINUE

         ELSE
C
C
C              ii) based on original integer vector values.
C
C
             DO 200 I = FIRST,LAST
                LEFT = FIRST
                RIGHT = I - 1
  210           IF (LEFT .GT. RIGHT) THEN
                    JBEG = RELOFF + LEFT
                    IF (I .GT. LEFT) THEN
                        JEND = RELOFF + I - 1
                        DO 220 J = JEND,JBEG,-1
                           SORT (J + 1) = SORT (J)
  220                   CONTINUE
                    END IF
                    SORT (JBEG) = I
                ELSE
                    J = (LEFT + RIGHT) / 2
                    SORTJ = SORT (RELOFF + J)
                    DIFF = VECTOR (I) - VECTOR (SORTJ)
                    IF ((FACTOR * DIFF) .LT. ZERO) THEN
                        RIGHT = J - 1
                    ELSE
                        LEFT = J + 1
                    END IF
                    GOTO 210
                END IF
  200        CONTINUE

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FORM_NHO_HYBRID_PATTERN
     +
     +                    ( NSHELL,
     +                      W,
     +
     +                             LENGTH,
     +                             HYBRID )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FORM_NHO_HYBRID_PATTERN
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine forms the NHO hybridization pattern
C                from an input weight 'array' containing the sum of
C                the squares of the NHO expansion coefficients in
C                terms of NAOs for each angular momentum quantum
C                number. The pattern is formed as a long character
C                word and returned.
C
C                Procedure:
C
C                Consider the weight array W, where the component W (0)
C                has the sum of the squares of the NHO expansion
C                coefficients corresponding to the s-shell, W (1) the
C                one for the p-shell, ... and W (7) the one for all
C                shells > i. Our goal is to create the hybridization
C                pattern of the form:
C
C                      ab(x.xx)c(x.xx)d(x.xx)....
C
C                where the x.xx are the ratios of occurance of
C                the higher shells b,c,d,... in the NHO as compared
C                to the a-shell. The a-shell is defined as the
C                shell with the lowest weight > small threshold
C                weight. Hence all x.xx are >= 1.00. When choosing
C                the a-shell, it might happen that some of the
C                ratios x.xx are >= 10.00, in which case the above
C                pattern cannot be created. In this case we take
C                the maximum of all x.xx which have >= 10.00 and
C                define the a-shell as the one corresponding to
C                that maximum. The x.xx for the other shells are
C                then rescaled.
C
C                  Input:
C
C                    W       =  shell weight array
C
C                  Output:
C
C                    LENGTH  =  character length of hybridization
C                               pattern.
C                    HYBRID  =  character word containing hybridization
C                               pattern.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         CHARACTER*50   HYBRID
         CHARACTER*1    LMAIN

         CHARACTER*7   LRATIO  (1:7)
         CHARACTER*1   LSYMB   (0:7)

         LOGICAL     ABSOLUT
         LOGICAL     INCRESE

         INTEGER     I
         INTEGER     IBEG,IEND
         INTEGER     LENGTH
         INTEGER     NR
         INTEGER     NSHELL,SHELL

         INTEGER     SORT (1:8)

         DOUBLE PRECISION  WEIGHT,WLARGE,WSMALL,WLIMIT
         DOUBLE PRECISION  WMIN,WMAX
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  W (0:NSHELL)

         DATA  LSYMB   /'s','p','d','f','g','h','i','x'/

         PARAMETER  (ZERO   = 0.D0)
         PARAMETER  (ONE    = 1.D0)
         PARAMETER  (WLARGE = 1.D+1)
         PARAMETER  (WSMALL = 1.D-2)
         PARAMETER  (WLIMIT = 1.D-8)
C
C
C------------------------------------------------------------------------
C
C
C             ...find minimum weight > small limit threshold.
C
C
         WMIN = ONE
         DO 100 I = 0,NSHELL
            WEIGHT = W (I)
            IF (WEIGHT.GT.WLIMIT) THEN
                WMIN = DMIN1 (WMIN,WEIGHT)
            END IF
  100    CONTINUE
C
C
C             ...rescale the weights and find the maximum of all
C                rescaled weights >= 10.00.
C
C
         WMAX = ZERO
         DO 200 I = 0,NSHELL
            WEIGHT = W (I) / WMIN
            IF (WEIGHT.GE.WLARGE) THEN
                WMAX = DMAX1 (WMAX,WEIGHT)
            END IF
            W (I) = WEIGHT
  200    CONTINUE

         INCRESE = .TRUE.
C
C
C             ...if any rescaled weight >= 10.00 was found, rescale
C                weights once again.
C
C
         IF (WMAX.NE.ZERO) THEN
             DO 300 I = 0,NSHELL
                W (I) = W (I) / WMAX
  300        CONTINUE
             INCRESE = .FALSE.
         END IF
C
C
C             ...sort the shell indices appropriately.
C
C
         ABSOLUT = .FALSE.

         CALL  NLO__SORT_FLP_VECTOR_ELEMENTS
     +
     +              ( NSHELL+1,NSHELL+1,
     +                1,NSHELL+1,
     +                ABSOLUT,INCRESE,
     +                0,
     +                W,
     +
     +                        SORT )
     +
     +
C
C
C             ...eliminate those weights which are < WSMALL for
C                printing. These 'zeros' will be found at the
C                beginning or at the end of the sorting array,
C                depending on the ordering (increasing or decreasing)
C                of the weights.
C
C
         IF (INCRESE) THEN
             IBEG = 1
             IEND = NSHELL+1
             DO 400 I = 1,NSHELL+1
                SHELL = SORT (I) - 1
                WEIGHT = W (SHELL)
                IF (WEIGHT.LT.WSMALL) THEN
                    IBEG = IBEG + 1
                END IF
  400        CONTINUE
         ELSE
             IBEG = 1
             IEND = NSHELL+1
             DO 410 I = NSHELL+1,1,-1
                SHELL = SORT (I) - 1
                WEIGHT = W (SHELL)
                IF (WEIGHT.LT.WSMALL) THEN
                    IEND = IEND - 1
                END IF
  410        CONTINUE
         END IF
C
C
C             ...form the hybridization pattern. Remember, that
C                the sorted indices will be in the range 1 to NSHELL+1,
C                rather than 0 to NSHELL.
C
C
         SHELL = SORT (IBEG) - 1
         LMAIN = LSYMB (SHELL)

         NR = 0
         DO 500 I = IBEG+1,IEND
            SHELL = SORT (I) - 1
            WEIGHT = W (SHELL)
            NR = NR + 1
            WRITE (LRATIO (NR),9000) LSYMB (SHELL),'(',WEIGHT,')'
  500    CONTINUE

         WRITE (HYBRID,9100) LMAIN,(LRATIO(I),I=1,NR)

         LENGTH = 1 + 7 * NR
C
C
C             ...writing formats used.
C
C
 9000    FORMAT (A1,A1,F4.2,A1)
 9100    FORMAT (A1,7(A7))
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine defines the default values for the common blocks in
c aces_time.com.

      blockdata aces_bd_aces_time
      implicit none
#define NO_EXTERNAL
#include "aces_time.com"
      data ame_timed /.false./
      end

c This routine defines the default values for the common blocks in
c aces_time.com.

      blockdata aces_bd_aces_time
      implicit none
c aces_time.com : begin

c These six times hold the timing data from aces_init (*_in) to
c aces_fin (*_out). utime and stime count the total number of user
c and system seconds since the start of the process. rtime counts
c the total number of real seconds since 1 January 1970. ame_timed
c is a logical flag set in aces_init telling aces_fin to print out
c a timing summary.


      double precision   ame_utime_in,  ame_stime_in,  ame_rtime_in,
     &                   ame_utime_out, ame_stime_out, ame_rtime_out
      logical            ame_timed
      common /aces_time/ ame_utime_in,  ame_stime_in,  ame_rtime_in,
     &                   ame_utime_out, ame_stime_out, ame_rtime_out,
     &                   ame_timed
      save   /aces_time/

c aces_time.com : end
      data ame_timed /.false./
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_checkpoint_msg(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_checkpoint_msg message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_ckpt_data.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, j, n, istart, nsearch, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind, imsg
      integer msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile, nxt
      integer request, status(MPI_STATUS_SIZE)
      integer array, nindex, tag, f_form_msg_tag 
      integer msglen
      integer msg(100)

      integer nblk_file, header_entry, next
      integer*8 loc, index_file_diskloc, data_file_diskloc 
      integer*8 ndx_file_len, array_size
      integer str_trimlen
      logical created_file, match, flag

      integer index_file_entry_size
      parameter (index_file_entry_size = 3+mx_array_index*2)
      integer*8 index_file_entry(index_file_entry_size)

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif
      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then
         array = server_msg(c_msg_array,node)

c---------------------------------------------------------------------------
c   Locate the server_table entries for this array.
c---------------------------------------------------------------------------

         do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               istart = served_array_entry(i)
               nsearch = served_numblocks(i)
               go to 50
            endif
         enddo

c---------------------------------------------------------------------------
c   Array not found on this server.   We have nothing to do.
c---------------------------------------------------------------------------

	 server_msg(c_msg_state,node) = null_state
	 return
 
   50    continue
         indblk = get_index_from_base(base_mem_addr, x, 2)

c---------------------------------------------------------------------------
c   Calculate the index of the message buffer.
c--------------------------------------------------------------------------

         msgbuffer = server_msg(c_msg_msgbuffer,node)
         imsg = indblk + (msgbuffer-1)* server_mem_blocksize

c---------------------------------------------------------------------------
c   Open the checkpoint files.
c----------------------------------------------------------------------------

         n = str_trimlen(ckpt_ndx_filename)
         inquire (file = ckpt_ndx_filename(1:n), 
     *            exist=flag)
         if (flag) then
            call f_openfile(ckpt_ndx_filename(1:n) // char(0), 
     *                   ckpt_ndx_unit)
            created_file = .false.
         else
            call f_creatfile(ckpt_ndx_filename(1:n) // char(0), 
     *                        ckpt_ndx_unit)
            if (ckpt_ndx_unit .eq. -1) then
               print *,'Error: Server ',me,' cannot create checkpoint ',
     *                 'index file.'
               print *,'ckpt_ndx_filename = ',ckpt_ndx_filename
               call server_abort_job(server_table, nserver_table)
            else
               created_file = .true.
            endif
         endif 

         n = str_trimlen(ckpt_dat_filename)
         inquire (file = ckpt_dat_filename(1:n),
     *            exist=flag)
         if (flag) then
            call f_openfile(ckpt_dat_filename(1:n) // char(0), 
     *                   ckpt_dat_unit)
         else
            call f_creatfile(ckpt_dat_filename(1:n) // char(0),
     *                        ckpt_dat_unit)
            if (ckpt_dat_unit .eq. -1) then
               print *,'Error: Server ',me,' cannot create checkpoint ',
     *                 'data file.'
               print *,'ckpt_dat_filename = ',ckpt_dat_filename
               call server_abort_job(server_table, nserver_table)
            endif
         endif

c---------------------------------------------------------------------------
c   Determine the array size (in words) of all blocks of this array on the
c   current server.
c---------------------------------------------------------------------------

         array_size = 0
         do iblock = istart, istart+nsearch-1 
            array_size = array_size + 
     *           server_table(c_server_size,iblock)
         enddo

c---------------------------------------------------------------------------
c   Initialize the file header.
c---------------------------------------------------------------------------

         if (created_file) then
 
c---------------------------------------------------------------------------
c   File was opened for the first time.  Clear the file header.
c---------------------------------------------------------------------------

            do j = 1, mx_ckpt_arrays
               do i = 1, 4 
                  ndx_file_header(i,j) = 0
               enddo 

               data_file_sizes(j) = 0
            enddo 

            nblk_file          = 0
            header_entry       = 1
            data_file_diskloc  = 0
            ndx_file_header(1,header_entry) = array
            ndx_file_header(2,header_entry) = nsearch   ! num. of blocks
            ndx_file_header(3,header_entry) = -1
            ndx_file_header(4,header_entry) = -1
            data_file_sizes(header_entry)   = array_size
            data_file_location(header_entry) = -1

            commit_flag = .false.

c--------------------------------------------------------------------------
c   Initialize free space data structures.
c--------------------------------------------------------------------------

            nfree_space_ndx = 0
            nfree_space_dat = 0
            nfree_ndx_can = 0
            nfree_dat_can = 0
 
         else   ! created_file

c---------------------------------------------------------------------------
c   For each entry in the file header:
c   Word 1 = array
c   Word 2 = number of blocks checkpointed by this server.
c   Word 3 = disk pointer to index file data.
c   Word 4 = Number of array indices.
c---------------------------------------------------------------------------

            do i = 1, mx_ckpt_arrays
               if (ndx_file_header(1,i) .eq. array) then
                  header_entry = i   ! array was ckptd previously.
                  go to 200
               endif
 
               if (ndx_file_header(1,i) .eq. 0) then

c---------------------------------------------------------------------------
c   Array was never checkpointed.   Create a new header entry.
c---------------------------------------------------------------------------

                  header_entry = i

                  ndx_file_header(1,i) = array
                  ndx_file_header(2,i) = nsearch
                  ndx_file_header(3,i) = -1
                  ndx_file_header(4,i) = -1
                  data_file_location(i) = -1
                  data_file_sizes(i)   = array_size
                  go to 200
               endif 
            enddo
  200       continue

         endif   ! created_file

c---------------------------------------------------------------------------
c   Find locations on disk for the index file entries and data file entries.
c---------------------------------------------------------------------------

        call find_ckpt_disk_location(array, header_entry, 
     *                               array_size, nsearch) 
        index_file_diskloc = ndx_file_header(3,header_entry)
        data_file_diskloc  = data_file_location(header_entry) 

c---------------------------------------------------------------------------
c   Process each block of the array found in the server_table.
c---------------------------------------------------------------------------

         do iblock = istart, istart+nsearch-1
            if (server_table(c_server_array,iblock) .eq. array) then
               if (server_table(c_server_iblk,iblock) .eq. 
     *                               99999999) then
                  print *,'No message for iblock ',iblock
                  print *,(server_table(i,iblock),
     *                     i=1,lserver_table_entry)
                  call server_abort_job(server_table, nserver_table)
               endif

               if (server_table(c_server_memloc,iblock) .ne. 0) then
                  
c---------------------------------------------------------------------------
c   The data for this block is already in memory.
c---------------------------------------------------------------------------
   
                  j = server_table(c_server_memloc,iblock)
                  ind = indblk + (j-1) * server_mem_blocksize
                  size    = server_table(c_server_size,iblock)
               else if (server_table(c_server_diskloc,iblock) .gt. 
     *                      0) then 

c---------------------------------------------------------------------------
c   Read the data from disk into the node's message buffer.
c---------------------------------------------------------------------------

                  diskloc = server_table(c_server_diskloc,iblock)
                  size    = server_table(c_server_size,iblock)
                  ifile   = server_table(c_server_file, iblock)
                  call f_restoreram(server_unit(ifile), diskloc,
     *                           server_blocksizes(ifile),
     *                           x(imsg), size)
                  ind = imsg
               else
                  print *,'Server ',me,': Error in write_blocks_to_list'
                  print *,'   Array ',array,
     *                    ' erroneous server_table entry'
                  print *,(server_table(i,iblock),i=1,
     *                      lserver_table_entry)
                  call server_abort_job(server_table, nserver_table)
               endif
            endif

c-------------------------------------------------------------------------
c   Create the index file entry for this block.
c-------------------------------------------------------------------------

            index_file_entry(1) = server_table(c_server_iblk,iblock)
            index_file_entry(2) = server_table(c_server_size,iblock)
            index_file_entry(3) = data_file_diskloc
            next = 4
            do i = 1, mx_array_index
               index_file_entry(next) = 
     *                 server_table(c_server_bsegs+i-1,iblock)
               next = next + 1
            enddo

            do i = 1, mx_array_index
               index_file_entry(next) = 
     *                 server_table(c_server_esegs+i-1,iblock)
               next = next + 1
            enddo
 
c-------------------------------------------------------------------------
c   Write the index file entry for the block.
c-------------------------------------------------------------------------

            call f_write_disk(ckpt_ndx_unit, index_file_diskloc, 
     *                        index_file_entry, 
     *                        index_file_entry_size)
            index_file_diskloc = index_file_diskloc + 
     *                           index_file_entry_size

c-------------------------------------------------------------------------
c   Write the data for this block to the checkpoint file.
c-------------------------------------------------------------------------

            call f_write_disk(ckpt_dat_unit, data_file_diskloc,
     *                        x(ind), size)
            data_file_diskloc = data_file_diskloc + size

c--------------------------------------------------------------------------
c   Word 4 of file header entry contains the number of indices in the array.
c--------------------------------------------------------------------------

            ndx_file_header(4,header_entry) = 
     *                      server_table(c_server_nind,iblock) 
         enddo   ! iblock

 
c--------------------------------------------------------------------------
c   Close the checkpoint files.
c--------------------------------------------------------------------------

         call f_close_file(ckpt_ndx_unit)
         call f_close_file(ckpt_dat_unit)

c--------------------------------------------------------------------------
c   Send an acknowledgement to the master.  This tells him that the 
c   server has finished his checkpoint operation.
c   The message tag for the ack. msg is server_checkpoint_msg.
c--------------------------------------------------------------------------

            call mpi_isend(msg, 1,
     *            mpi_integer, 0, server_checkpoint_msg,
     *            mpi_comm_world,  server_msg(c_msg_request,node), 
     *            ierr)
            server_msg(c_msg_state,node) = wait_for_send_state
            return
      else if (state .eq. wait_for_send_state) then

c-------------------------------------------------------------------------
c   Test for completion of the send.
c-------------------------------------------------------------------------

         if (server_msg(c_msg_request,node) .eq.
     *                               MPI_REQUEST_NULL) then
            flag = .true.
         else
            call mpi_test(server_msg(c_msg_request,node), flag,
     *                 status, ierr)
         endif

         if (flag) then
               server_msg(c_msg_state,node) = null_state   ! done
         else
            return
         endif
      endif   ! state
      return
      end

      subroutine find_ckpt_disk_location(array, ientry, array_size, 
     *                                   array_nblks)
c----------------------------------------------------------------------------
c   Determines the locations on the index file and data file for an 
c   array.  Stores the resulting disk pointers in the ndx_file_header 
c   data structure, and manages the free space data structures.
c----------------------------------------------------------------------------
      implicit none
      include 'server_ckpt_data.h'
      include 'machine_types.h'
      include 'parallel_info.h'

      integer array, array_nblks
      integer*8 array_size

      integer i, j, ientry
      integer*8 index_file_diskloc, data_file_diskloc

      index_file_diskloc = ndx_file_header(3,ientry)
      data_file_diskloc  = data_file_location(ientry)

c---------------------------------------------------------------------------
c   Do we already have data in the ndx_file_header for this array?  If so 
c   (i. e. data_file_diskloc .gt. -1), we must move the existing entry to 
c   the list of free space candidates, as the data is old (from a previous
c   checkpoint).
c---------------------------------------------------------------------------

      if (data_file_diskloc .gt. -1) then
         nfree_ndx_can = nfree_ndx_can + 1
         if (nfree_ndx_can .gt. mx_ckpt_arrays) then
            print *,'Error: Out of free space candidates ',
     *                    'for checkpoint ndx file'
            call server_abort_job()
         endif

         free_space_ndx_candidate(1,nfree_ndx_can) =
     *                                 ndx_file_header(3,ientry)
         free_space_ndx_candidate(2,nfree_ndx_can) =
     *                          ndx_file_header(2,ientry)

         nfree_dat_can = nfree_dat_can + 1
         if (nfree_dat_can .gt. mx_ckpt_arrays) then
            print *,'Error: Out of free space candidates ',
     *              'for checkpoint dat file'
            call server_abort_job()
         endif

         free_space_dat_candidate(1,nfree_dat_can) =
     *                           ndx_file_header(4,ientry)
         free_space_dat_candidate(2,nfree_dat_can) =
     *                           data_file_sizes(ientry)
      endif

c----------------------------------------------------------------------------
c   Is there a block of free space available that is large enough?
c----------------------------------------------------------------------------

      do i = 1, nfree_space_ndx
         if (free_space_ndx(1,i) .ge. 0 .and.
     *       free_space_ndx(2,i) .ge. array_nblks) then

c-----------------------------------------------------------------------------
c   Use this block of free space for this array.
c-----------------------------------------------------------------------------

            ndx_file_header(2,ientry) = array_nblks
            ndx_file_header(3,ientry) = free_space_ndx(1,i)
            free_space_ndx(1,i) = -1
            free_space_ndx(2,i) = -1
            go to 1000 
         endif
      enddo

c----------------------------------------------------------------------------
c   Either there was no free space available, or there were no blocks 
c   large enough to hold this data.  Add to the end of file.
c----------------------------------------------------------------------------

      call get_filelen(ckpt_ndx_unit, index_file_diskloc)
      index_file_diskloc = index_file_diskloc / 8
      if (index_file_diskloc .eq. 0) 
     *      index_file_diskloc = index_file_header_size
      ndx_file_header(2,ientry) = array_nblks
      ndx_file_header(3,ientry) = index_file_diskloc
 
1000  continue

c----------------------------------------------------------------------------
c   Determine the data_file_diskloc.
c   Is there a block of free space available that is large enough?
c----------------------------------------------------------------------------

      do i = 1, nfree_space_dat
         if (free_space_dat(1,i) .ge. 0 .and.
     *       free_space_dat(2,i) .ge. array_size) then

c-----------------------------------------------------------------------------
c   Use this block of free space for this array.
c-----------------------------------------------------------------------------

            data_file_sizes(ientry) = array_size
            data_file_location(ientry) = free_space_dat(1,i)
            free_space_dat(1,i) = -1
            free_space_dat(2,i) = -1
            go to 2000 
         endif
      enddo

c----------------------------------------------------------------------------
c   Either there was no free space available, or there were no blocks 
c   large enough to hold this data.  Add to the end of file.
c----------------------------------------------------------------------------

      call get_filelen(ckpt_dat_unit, data_file_diskloc)
      data_file_diskloc = data_file_diskloc / bytes_per_double
      data_file_sizes(ientry) = array_size
      data_file_location(ientry) = data_file_diskloc
 
 2000 continue

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine vtdemo_init(optable, noptable, 
     *                       array_table, narray_table,
     *                       index_table, nindex_table,
     *                       segment_table, nsegment_table,
     *                       scalar_table, nscalar_table,
     *                       block_map_table, nblock_map_table,
     *                       proctab, address_table,
     *                       blocksize, end_nfps, nshells, scf_energy,
     *                       totenerg, damp_init, cc_conv, scf_conv,
     *                       stabvalue,
     *
     *                       excite, eom_tol, eom_roots, ! Watson Added
     *
     *                       io_company_id, niocompany, need_predef,
     *                       npre_defined, dryrun)
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'proto_events.h'
      include 'timerz.h'
      include 'machine_types.h'
      include 'where_table.h'
      include 'restrict_pardo.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer mx_proctab
      parameter (mx_proctab = 1000)

      integer*8 ixx
      integer nindex_table, narray_table, noptable, nsegment_table
      integer nscalar_table
      integer segment_table(lsegment_table_entry,nsegment_table)
      character*10 array_labels(narray_table)
      integer array_table(larray_table_entry, narray_table)
      integer*8 address_table(narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer optable(loptable_entry, noptable)
      integer nblock_map_table
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer proctab(2,mx_proctab)
      double precision scalar_table(nscalar_table)
      
      integer nshells
      integer end_nfps(nshells)
      integer segs(nshells)
      integer nsegs, first
      integer blocksize, nbasis
      integer next, next_server, next_worker
      integer proc_timer, target
      integer key, key1, key2, key3, key4, key5, key6, key7, key8

      integer i, j, k, n
      integer nproctab
      integer me, nprocs, ierr
      integer seg
      integer nprocs_job
      integer size
      integer lineno, nsial_lines
      integer*8 ixmem

      integer*8 ixc, ixfock_a, ixfock_b
      integer*8 ixfockrohf_a, ixfockrohf_b
      integer*8 ixoed_nai, ixoed_kin, ixoed_ovl
      integer*8 nbytes_static
      integer iproc
      integer bseg_arr(mx_array_index)
      integer eseg_arr(mx_array_index)
      integer nseg_arr(mx_array_index)
      integer ind_arr(mx_array_index)
      integer type
      integer nind, nblks
      integer segknt
      integer get_subroutine_handle
      integer op(loptable_entry)
      integer opcode
      integer bseg, eseg, bval1, bval2, eval1, eval2
      integer itotenerg
      integer master, pst_get_master, predef_req
      integer iscfeneg
      integer iscalar
      integer istabvalue
      integer iexcite, ieom_tol, ieom_roots ! Watson Added
      integer timertype
      integer index, val1, val2
      integer occ_index, index_type, ind, nindex
      integer result
      integer iop, max_batch
      integer ind_pardo(mx_array_index)
      double precision scf_energy, totenerg, stabvalue
      double precision damp_init, cc_conv, scf_conv
      double precision excite, eom_tol, eom_roots ! Watson Added

      double precision xxx(2)
#ifdef ALTIX
      pointer (dptr, xxx)
#endif

      character*12 get_operation_desc 
      integer      get_operation_timer_type
      character*12 opdesc 
      character*40 timerdesc
      character*1 typechar

      integer my_company_rank, ncworkers
      integer pst_get_company
      integer pst_get_company_rank
      integer pst_get_company_comm
      integer company_comm, iproc_company_rank
      integer io_company_id, niocompany
      integer ioproc(niocompany)

      integer iseg(mx_array_index)
      integer lookup, block_map_lookup
      integer stat_key
      logical debug, validate, doit
      logical dryrun

      integer npre_defined
      integer setline(npre_defined)
      logical need_predef(npre_defined)
      logical i_used_it
      integer*8 c_loc64

      integer push_do, pop_do
      save opdesc

      call mpi_comm_rank(mpi_comm_world, me, ierr)
      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      company_comm    = pst_get_company_comm(me)
      my_company_rank = pst_get_company_rank(me)
      call mpi_comm_size(company_comm, ncworkers, ierr)

#ifdef ALTIX
      dptr = dshptr
#endif

      nprocs_job = nprocs
      debug    = .false.
      validate = .false.

      size = bytes_per_double

c--------------------------------------------------------------------------
c   If an IOCOMPANY is used for served arrays, set up an array of process
c   ranks (relative to the MPI_COMM_WORLD communicator.
c--------------------------------------------------------------------------

      if (io_company_id .ne. 0) then
         do i = 1, nprocs
            if (pst_get_company(i-1) .eq. io_company_id) then
               iproc_company_rank = pst_get_company_rank(i-1)
               ioproc(iproc_company_rank+1) = i-1
            endif
         enddo
      endif

c---------------------------------------------------------------------------
c   Clear the address table.
c---------------------------------------------------------------------------

      do i = 1, narray_table
         address_table(i) = 0
         array_table(c_block_map,i) = 0
      enddo

c----------------------------------------------------------------------------
c   Find all pre-defined arrays that are used in specific instructions.
c----------------------------------------------------------------------------

      do i = 1, npre_defined
         need_predef(i) = .false.
         setline(i)     = 0
      enddo

      do i = 1, noptable
         if (optable(c_opcode,i) .lt. call_op .or.
     *       optable(c_opcode,i) .gt. sp_ldindex_op) then

            if (optable(c_op1_array,i) .gt. 0 .and.
     *          optable(c_op1_array,i) .le. npre_defined) then
               need_predef(optable(c_op1_array,i)) = .true.
               if (setline(optable(c_op1_array,i)) .eq. 0) 
     *           setline(optable(c_op1_array,i)) = optable(c_lineno,i)
            endif

            if (optable(c_op2_array,i) .gt. 0 .and.
     *          optable(c_op2_array,i) .le. npre_defined) then
               need_predef(optable(c_op2_array,i)) = .true.
               if (setline(optable(c_op2_array,i)) .eq. 0)
     *            setline(optable(c_op2_array,i)) = optable(c_lineno,i)
            endif

            if (optable(c_result_array,i) .gt. 0 .and.
     *          optable(c_result_array,i) .le. npre_defined) then
               need_predef(optable(c_result_array,i)) = .true.
               if (setline(optable(c_result_array,i)) .eq. 0)
     *            setline(optable(c_result_array,i)) = 
     *                              optable(c_lineno,i)
            endif
        endif 
      enddo

   10 continue
      if (me .eq. 0) then
         do i = 1, npre_defined
            if (need_predef(i)) 
     *         print *,'Static pre-defined array #',i,
     *             ' is first used on line ',setline(i)
         enddo

c----------------------------------------------------------------------------
c   Post the send for data needed to initialize static arrays from the
c   master to the other workers.
c----------------------------------------------------------------------------

c         if (.not. dryrun) 
c     *      call send_static_data(need_predef, npre_defined) 
      endif

c---------------------------------------------------------------------------
c   Set up a local array for C.
c---------------------------------------------------------------------------

      nbytes_static = 0
      if (need_predef(1) .or. 
     *    need_predef(2)) then   
         n = 1
         do j = 1, array_table(c_nindex,1)
            index = array_table(c_index_array1+j-1,1)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,1) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,1) = val2
            k = array_table(c_index_range2+j-1,1) - 
     *          array_table(c_index_range1+j-1,1) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixc, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating C array'
            call abort_job()
         endif

         address_table(1) = c_loc64(xxx, ixc, bytes_per_double)
         nbytes_static = nbytes_static + n * size

c---------------------------------------------------------------------------
c   Set up a local array for CA.
c---------------------------------------------------------------------------

         n = 1
         do j = 1, array_table(c_nindex,2)
            index = array_table(c_index_array1+j-1,2)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,2) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,2) = val2
            k = array_table(c_index_range2+j-1,2) -
     *          array_table(c_index_range1+j-1,2) + 1
            n = n * k
         enddo

         address_table(2) = address_table(1)

         op(c_result_array) = 1    ! C is array #1. 
         if (.not. dryrun) then 
           call init_c(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op)
         endif
      endif   ! need_predef

c---------------------------------------------------------------------------
c   Set up a local array for CB.
c---------------------------------------------------------------------------

      if (need_predef(3)) then
         n = 1
         do j = 1, array_table(c_nindex,3)
            index = array_table(c_index_array1+j-1,3)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,3) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,3) = val2
            k = array_table(c_index_range2+j-1,3) -
     *          array_table(c_index_range1+j-1,3) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixc, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating CB array'
            call abort_job()
         endif
         address_table(3) = c_loc64(xxx, ixc, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 3   ! CB is array #3
         if (.not. dryrun) then
            call init_c(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op)
         endif
      endif

      if (.not. dryrun) then
         call init_eps(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            op)
      endif

      iscfeneg = array_table(c_scalar_index, 4)   
      scalar_table(iscfeneg) = scf_energy
      itotenerg = array_table(c_scalar_index, 5)
      scalar_table(itotenerg) = totenerg

c---------------------------------------------------------------------------
c   Set up a local array for FOCK_A.  (Pre-defined array table entry 9)
c---------------------------------------------------------------------------

      if (need_predef(9)) then
         n = 1
         do j = 1, array_table(c_nindex,9)
            index = array_table(c_index_array1+j-1,9)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,9) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,9) = val2
            k = array_table(c_index_range2+j-1,9) -
     *          array_table(c_index_range1+j-1,9) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixfock_a, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating FOCKA array'
            call abort_job()
         endif
         address_table(9) = c_loc64(xxx, ixfock_a, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 9    ! FOCK_A is array #9.
         if (.not. dryrun) then 
            call init_fock(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op)
         endif
      endif

c---------------------------------------------------------------------------
c   Set up a local array for FOCK_B.  (Pre-defined array table entry 10)
c---------------------------------------------------------------------------

      if (need_predef(10)) then
         n = 1
         do j = 1, array_table(c_nindex,10)
            index = array_table(c_index_array1+j-1,10)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,10) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,10) = val2
            k = array_table(c_index_range2+j-1,10) -
     *          array_table(c_index_range1+j-1,10) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixfock_b, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating FOCKB array'
            call abort_job()
         endif
         address_table(10) = c_loc64(xxx, ixfock_b, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 10    ! FOCK_B is array #10.
         if (.not. dryrun) then
            call init_fock(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op)
         endif
      endif

c---------------------------------------------------------------------------
c   Set up a local array for oed_nai.  (Pre-defined array table entry 11)
c---------------------------------------------------------------------------

      if (need_predef(11)) then
         n = 1
         do j = 1, array_table(c_nindex,11)
            index = array_table(c_index_array1+j-1,11)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,11) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,11) = val2
            k = array_table(c_index_range2+j-1,11) -
     *          array_table(c_index_range1+j-1,11) + 1
            n = n * k
         enddo
   
         call mem_alloc(xxx, n, size, ixoed_nai, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating NAI integrals array'
            call abort_job()
         endif
         address_table(11) = c_loc64(xxx, ixoed_nai, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 11    ! ONE_NAI is array #11.
         if (.not. dryrun) then 
            call init_oed_integrals(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op, 1)
         endif
      endif

c---------------------------------------------------------------------------
c   Set up a local array for oed_kin.  (Pre-defined array table entry 12)
c---------------------------------------------------------------------------

      if (need_predef(12)) then
         n = 1
         do j = 1, array_table(c_nindex,12)
            index = array_table(c_index_array1+j-1,12)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,12) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,12) = val2
            k = array_table(c_index_range2+j-1,12) -
     *          array_table(c_index_range1+j-1,12) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixoed_kin, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating KINETIC integrals array'
            call abort_job()
         endif
         address_table(12) = c_loc64(xxx, ixoed_kin, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 12    ! ONE_KIN is array #12.
         if (.not. dryrun) then
            call init_oed_integrals(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op, 2)
         endif
      endif

c---------------------------------------------------------------------------
c   Set up a local array for oed_ovl.  (Pre-defined array table entry 13)
c---------------------------------------------------------------------------

      if (need_predef(13)) then
         n = 1
         do j = 1, array_table(c_nindex,13)
            index = array_table(c_index_array1+j-1,13)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,13) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,13) = val2
            k = array_table(c_index_range2+j-1,13) -
     *          array_table(c_index_range1+j-1,13) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixoed_ovl, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating OVERLAP integrals array'
            call abort_job()
         endif
         address_table(13) = c_loc64(xxx, ixoed_ovl, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 13    ! ONE_OVL is array #13.
         if (.not. dryrun) then
            call init_oed_integrals(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op, 3)
         endif
      endif

c---------------------------------------------------------------------------
c   Initialization of "damp" value.
c---------------------------------------------------------------------------

      iscalar = array_table(c_scalar_index, 14)
      scalar_table(iscalar) = damp_init

c---------------------------------------------------------------------------
c   Initialization of "cc_conv" value.
c---------------------------------------------------------------------------

      iscalar = array_table(c_scalar_index, 15)
      scalar_table(iscalar) = cc_conv

c---------------------------------------------------------------------------
c   Initialization of "scf_conv" value.
c---------------------------------------------------------------------------

      iscalar = array_table(c_scalar_index, 16)
      scalar_table(iscalar) = scf_conv

c---------------------------------------------------------------------------
c   Set up a local array for FOCKROHF_A.  (Pre-defined array table entry 17)
c---------------------------------------------------------------------------

      if (need_predef(17)) then
         n = 1
         do j = 1, array_table(c_nindex,17)
            index = array_table(c_index_array1+j-1,17)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,17) = val1
            call get_index_segment(index, eseg, segment_table,
     *         nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,17) = val2
            k = array_table(c_index_range2+j-1,17) -
     *          array_table(c_index_range1+j-1,17) + 1
            n = n * k
         enddo
         call mem_alloc(xxx, n, size, ixfockrohf_a, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating ROHFA array'
            call abort_job()
         endif
         address_table(17) = c_loc64(xxx, ixfockrohf_a, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 17    ! FOCKROHF_A is array #17.
         if (.not. dryrun) then
            call init_fockrohf(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op)
         endif    
      endif

c---------------------------------------------------------------------------
c   Set up a local array for FOCKROHF_B.  (Pre-defined array table entry 18)
c---------------------------------------------------------------------------

      if (need_predef(18)) then
         n = 1
         do j = 1, array_table(c_nindex,18)
            index = array_table(c_index_array1+j-1,18)
            bseg = index_table(c_bseg, index)
            eseg = index_table(c_eseg, index)
            call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range1+j-1,18) = val1
            call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
            array_table(c_index_range2+j-1,18) = val2
            k = array_table(c_index_range2+j-1,18) -
     *          array_table(c_index_range1+j-1,18) + 1
            n = n * k
         enddo

         call mem_alloc(xxx, n, size, ixfockrohf_b, .true., ierr)
         if (ierr .ne. 0) then
            print *,'Mem failure allocating ROHFB array'
            call abort_job()
         endif
         address_table(18) = c_loc64(xxx, ixfockrohf_b, size)
         nbytes_static = nbytes_static + n * size

         op(c_result_array) = 18    ! FOCKROHF_B is array #18.
         if (.not. dryrun) then
            call init_fockrohf(array_table, narray_table,
     *            index_table,
     *            nindex_table, segment_table, nsegment_table,
     *            block_map_table, nblock_map_table,
     *            address_table, op)
         endif
      endif

      istabvalue = array_table(c_scalar_index,19)
      scalar_table(istabvalue) = stabvalue
C
C Watson Added:
C
      ieom_tol = array_table(c_scalar_index,20)
      scalar_table(ieom_tol) = eom_tol

      ieom_roots = array_table(c_scalar_index,21)
      scalar_table(ieom_roots) = eom_roots

      iexcite = array_table(c_scalar_index,22)
      scalar_table(iexcite) = excite
C
C Watson
C
      next = 0
      next_server = 0
      next_worker = 0
      do i = 23, narray_table   ! 1st 19 arrays are pre-defined.
         type = array_table(c_array_type,i) ! Watson changed from 20 to 22
         if (type .eq. static_array) then

c---------------------------------------------------------------------------
c   Make sure the array is actually being used.
c---------------------------------------------------------------------------

            i_used_it = .false.
            do j = 1, noptable
               if (optable(c_opcode,j) .lt. call_op .or.
     *             optable(c_opcode,j) .gt. sp_ldindex_op) then
                  if (optable(c_op1_array,j) .eq. i) i_used_it = .true.
                  if (optable(c_op2_array,j) .eq. i) i_used_it = .true.
                  if (optable(c_result_array,j) .eq. i) 
     *                      i_used_it = .true.
                  if (i_used_it) go to 1200
               endif
            enddo

 1200       continue
            if (i_used_it) then
               n = 1
               do j = 1, array_table(c_nindex,i)
                  index = array_table(c_index_array1+j-1,i)
                  bseg = index_table(c_bseg, index)
                  eseg = index_table(c_eseg, index)
                  call get_index_segment(index, bseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
                  array_table(c_index_range1+j-1,i) = val1
                  call get_index_segment(index, eseg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1, val2)
                  array_table(c_index_range2+j-1,i) = val2
                  k = array_table(c_index_range2+j-1,i) -
     *                array_table(c_index_range1+j-1,i) + 1
                  n = n * k
               enddo

               call mem_alloc(xxx, n, size, ixc, .true., ierr)
               if (ierr .ne. 0) then
                  print *,'Mem failure allocating static array #',i
                  call abort_job()
               endif

               address_table(i) = c_loc64(xxx, ixc, size)
               nbytes_static = nbytes_static + n * size

c---------------------------------------------------------------------------
c   Zero out the memory for static arrays.
c---------------------------------------------------------------------------

               do j = 1, n
                  xxx(ixc+j-1) = 0.
               enddo
            endif   ! i_used_it
         endif 

         if (type .eq. local_array) then
c---------------------------------------------------------------------------
c   Save original array indices for use in later block lookups.
c---------------------------------------------------------------------------

            nind = array_table(c_nindex,i)
            do j = 1, nind
               array_table(c_index_original+j-1,i) =
     *               array_table(c_index_array1+j-1,i)
            enddo
         endif

         if (type .eq. distributed_array .or.
     *       type .eq. served_array) then

c-------------------------------------------------------------------------
c   Define the block_map_entry table for the array.
c-------------------------------------------------------------------------

            iproc = 0
            array_table(c_block_map,i) = next+1
            nind = array_table(c_nindex,i)

            nblks = 1
            do k = 1, nind
               ind_arr(k) = array_table(c_index_array1+k-1,i)
               bseg_arr(k) = index_table(c_bseg, ind_arr(k))
               eseg_arr(k) = index_table(c_eseg, ind_arr(k))
               nseg_arr(k) = eseg_arr(k) - bseg_arr(k) + 1 
               nblks = nblks * nseg_arr(k)
            enddo

            do k = nind+1,mx_array_index
               ind_arr(k) = 0
               bseg_arr(k) = 0
               eseg_arr(k) = 0
               nseg_arr(k) = 0
            enddo
 
            array_table(c_numblks,i)     = nblks
            array_table(c_create_flag,i) = 0

c---------------------------------------------------------------------------
c   Save original array indices for use in later block lookups.
c---------------------------------------------------------------------------

            do j = 1, nind
               array_table(c_index_original+j-1,i) = 
     *               array_table(c_index_array1+j-1,i)
            enddo

c----------------------------------------------------------------------------
c   Initialize iseg array.
c---------------------------------------------------------------------------

            do k = 1, nind
               iseg(k) = bseg_arr(k)
            enddo
         
c---------------------------------------------------------------------------
c   Fill in block_map_table info for each blocks of the array.
c---------------------------------------------------------------------------

            do k = 1, nblks
               next = block_map_lookup(iseg, nind, i, array_table(1,i),
     *                    index_table, nindex_table)

               if (type .eq. distributed_array) then
                  block_map_table(c_processor,next) =
     *                               mod(next_worker,ncworkers)
                  next_worker = next_worker + 1
               else
                  next_server = next_server + 1
                  iproc_company_rank = mod(next_server-1,niocompany)
                  block_map_table(c_processor,next) =
     *                           ioproc(iproc_company_rank+1)
               endif

               block_map_table(c_bmap_blkndx,next) = 0
               do j = 1, nind
                  block_map_table(c_block_map_seg+j-1,next) = iseg(j)
               enddo

               do j = nind+1,mx_array_index
                  block_map_table(c_block_map_seg+j-1,next) = 0
               enddo

               j = 1
  100          continue

c-------------------------------------------------------------------------
c   Increment the segment counter of the jth index.
c-------------------------------------------------------------------------

               iseg(j) = iseg(j) + 1
               if (iseg(j) .gt. eseg_arr(j)) then
                  iseg(j) = bseg_arr(j)   ! reset to beginning of index j.

c---------------------------------------------------------------------------
c   Bump the index, repeat if necessary.
c---------------------------------------------------------------------------

                  j = j + 1
                  if (j .le. nind) go to 100
               endif
            enddo   ! k
         endif 

         if (array_table(c_array_type,i) .eq. served_array) then
            if (io_company_id .eq. 0) then
               if (me .eq. 0) 
     *            print *,'Warning: SIAL program uses served arrays,',
     *           ' an IOCOMPANY may be required.'
            endif
         endif 
      enddo

c--------------------------------------------------------------------------
c   Initialize each PARDO instruction with the max. number of batches.
c--------------------------------------------------------------------------

      if (.not. dryrun) then
         call init_stack(noptable)  ! initialize instruction stack. 
         iwhere = 0
         nwhere = 0

         do iop = 1, noptable
            if (optable(c_opcode, iop) .eq. pardo_op) then
               do i = 1, mx_array_index
                  ind_arr(i) = optable(c_ind1+i-1,iop)
               enddo

c---------------------------------------------------------------------------
c   Save where conditions, get any new ones for this pardo.
c---------------------------------------------------------------------------

               ierr = push_do(iwhere, nwhere)
               if (ierr .lt. 0) then
                  print *,'Task ',me,
     *              ' Error in handle_call: stack overflow'
                  call abort_job()
               endif
               call get_where_conditionals(optable, iop, noptable)

               max_batch = 0
               call  lb_set_loop_incr_mapping(ind_arr, 
     *             index_table, nindex_table,
     *             segment_table, nsegment_table, 
     *             ind_pardo, bseg_arr, eseg_arr, nind, max_batch)
               optable(c_pardo_max_batch,iop) = max_batch
               
c---------------------------------------------------------------------------
c   Restore previous where conditions.
c---------------------------------------------------------------------------

            else if (optable(c_opcode,iop) .eq. do_op) then
               ierr = push_do(iwhere, nwhere) 
               if (ierr .lt. 0) then
                  print *,'Task ',me,
     *              ' Error in handle_call: stack overflow'
                  call abort_job()
               endif
 
               call get_where_conditionals(optable, iop, noptable) 
            else if (optable(c_opcode,iop) .eq. enddo_op .or.
     *               optable(c_opcode,iop) .eq. endpardo_op) then
               ierr = pop_do(iwhere, nwhere)
            endif
         enddo
      endif   ! .not. dryrun

      if (my_company_rank .eq. 0) then
         print *,'Allocated ',nbytes_static,' bytes for static arrays.'
      endif

      if (my_company_rank .eq. 0) then
c         print *,'INDEX_TABLE:'
c         do i = 1, nindex_table
c            print *,i,': ',(index_table(j,i),j=1,lindex_table_entry)
c         enddo

c         print *,'ARRAY TABLE:'
c         do i = 1, narray_table
c            print *,i,': ',(array_table(j,i),j=1,larray_table_entry)
c         enddo

c         print *,'BLOCK_MAP_TABLE: nblock_map_table ',
c     *           nblock_map_table
c         do i = 1, nblock_map_table
c            print 10101,i,(block_map_table(j,i),j=1,lblock_map_entry)
c         enddo
10101 format(' ',i6,': ',10(i6,1x))
 
c         print *,'OPTABLE:'
c         do i = 1, noptable
c            print *,i,': ',(optable(j,i),j=1,loptable_entry)
c         enddo
 
c         print *,'SEGMENT_TABLE:'
c         do i = 1, nsegment_table
c            print *,i,': ',(segment_table(j,i),j=1,lsegment_table_entry)
c         enddo

c         print *,'ADDRESS TABLE: '
c         do i = 1,narray_table 
c            if (address_table(i) .ne. 0) 
c     *          print *,'Entry ',i,': ',address_table(i)
c         enddo

c         print *,'Initial scalar table:'
c         do i = 1, nscalar_table
c            print *,'Scalar entry ',i,': ',scalar_table(i)
c         enddo
      endif

        call build_proctab(optable, noptable, proctab, nproctab)
	call init_stack(noptable)  ! initialize instruction stack.
      
c-------------------------------------------------------------------------
c   Set up a two timers for each pardo/endpardo:
c   The first is the timer for the pardo loop itself,
c   the second times the amount of block wait time in the pardo loop.
c------------------------------------------------------------------------

      do i = 1, noptable
         optable(c_instr_timer,i) = 0
      enddo

      stat_key = 0
      do i = 1, noptable
         if (optable(c_opcode,i) .eq. pardo_op) then
c Tot Pardo Time             
            timerdesc = ' '
            write (timerdesc,9200) optable(c_lineno,i)
            call register_timer(timerdesc, elapsed_time_timer, key1)
c Blkwait for Paro
            timerdesc = ' '
            write (timerdesc,9300) optable(c_lineno,i)
            call register_timer(timerdesc, elapsed_time_timer, key2)
c CPU Time for Pardo
            timerdesc = ' '
            write (timerdesc,9400) optable(c_lineno,i)
            call register_timer(timerdesc, elapsed_time_timer, key3)
#ifdef DETAILED_TIMERS
c Overhead for Pardo            
            timerdesc = ' '
            write (timerdesc,9550) optable(c_lineno,i)
            call register_timer(timerdesc, elapsed_time_timer, key4)
c Number of times Pardo was done 
            timerdesc = ' '
            write (timerdesc,9560) optable(c_lineno,i)
            call register_timer(timerdesc, times_exec_timer, key5)
#else
            key4 = key3 + 1
            key5 = key4 + 1
#endif
c---------------------------------------------------------------------
c     Timers to measure MPI Time (time spent in exec_thread_server)
c       and number of times each pardo is done
c---------------------------------------------------------------------
#ifdef VERY_DETAILED_TIMERS
c Time spent in exec_thread_server
            timerdesc = ' '
            write (timerdesc,9500) optable(c_lineno,i)
            call register_timer(timerdesc, elapsed_time_timer, key6)
#else
            key6 = key5 + 1
#endif

            call pack_pardo_timer(optable(c_instr_timer,i),
     *                                     key1,key2) 
            if (key1 .gt. max_timers .or. key1 .lt. 0 .or.
     *           key2 .gt. max_timers .or. key2 .lt. 0) then 
                print *, me, 'Error! with timer at line ',
     *           optable(c_lineno, i), ' key1 = ', key1,
     *           ' key2=', key2
            endif

            
               if (key1 + 1 .ne. key2 .or.
     *             key2 + 1 .ne. key3 .or.
     *             key3 + 1 .ne. key4 .or.
     *             key4 + 1 .ne. key5 .or.
     *             key5 + 1 .ne. key6) then
                   print *, "Error : Assumption about timer being",
     *                      " alloted sequentially failed"
                   call abort_job()
               endif

c            optable(c_pardo_act_timer,i) = key3
c            optable(c_pardo_tserver_timer,i) = key4
c            optable(c_pardo_ovrhead_timer,i) = key5

c            print *,"Overhead timer for pardo at ", optable(c_lineno,i),
c     *              " is ", optable(c_ovrhead_timer,i), "=", key3

c-------------------------------------------------------------------------
c  Set up a server stat_key.
c-------------------------------------------------------------------------

            call translate_key(optable(c_lineno,i), stat_key)
         endif

c-------------------------------------------------------------------------
c   Store the stat_key in the optable.
c   This key is used to sum the server statistics for the pardo.
c-------------------------------------------------------------------------

         optable(c_server_stat_key,i) = stat_key
      enddo


c-------------------------------------------------------------------------
c   Register the timer for optable, overhead
c-------------------------------------------------------------------------

      timerdesc = ' '
      write (timerdesc,9600)
      call register_timer(timerdesc, elapsed_time_timer, timer_optl)


      timerdesc = ' '
      write (timerdesc,9650)
      call register_timer(timerdesc, elapsed_time_timer, timer_ovrhead)


c-------------------------------------------------------------------------
c   Register the timers for each instruction.
c-------------------------------------------------------------------------

      do i = 1, noptable
         opcode = optable(c_opcode,i)

c-------------------------------------------------------------------------
c   Screen out certain opcodes that we don't want to track.  
c   1. assignment (with result type = scalar).
c-------------------------------------------------------------------------

         doit = .true.
         if (opcode .eq. assignment_op) then
            result = optable(c_result_array,i)
            if (array_table(c_array_type,result) .eq. 
     *          scalar_value) doit = .false.
         endif

         if (doit .and. opcode .ne. pardo_op) then
            opdesc = get_operation_desc(opcode)
            if (opdesc(1:1) .ne. ' ') then
               timerdesc = ' '
               write (timerdesc,9000) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, elapsed_time_timer, key1)
               if (key1 .gt. max_timers .or. key1 .lt. 0) then
                    print *, me, 'Error! with timer at line ',
     *                  optable(c_lineno, i), ' key1 = ', key1
               endif


               optable(c_instr_timer,i) = key1
               if (optable(c_instr_timer,i) .gt. max_timers .or. 
     *              optable(c_instr_timer,i) .lt. 0) then
                    print *, me, 'Error! stored wrong timer at line ',
     *                  optable(c_lineno, i), ' timer stored ', 
     *                   optable(c_instr_timer,i)
               endif
c----------------------------------------------------------------------
c   Important timers, always used
c----------------------------------------------------------------------
c Block Wait Time for Super-Instruction
               write (timerdesc,9010) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, elapsed_time_timer, key2)
c Number of times for SI               
               write (timerdesc,9040) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, times_exec_timer, key3)
c Average CPU time per call for super instruction               
               write (timerdesc,9060) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, average_unit_timer, key4)


c----------------------------------------------------------------------
c   Measures time spent in allocation (finding a block)
c----------------------------------------------------------------------
#ifdef DETAILED_TIMERS
c Time spent in trying to allocate block per SI
               write (timerdesc,9070) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, elapsed_time_timer, key5)
#else
               key5 = key4 + 1
#endif
c----------------------------------------------------------------------
c Measures num. calls to exec_thread_server, time spent in it & total
c----------------------------------------------------------------------
#ifdef VERY_DETAILED_TIMERS
c Time spent in exec_thread_server during SI
               write (timerdesc,9020) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, elapsed_time_timer, key6)
c Number of times exec_thread_server is called during SI               
               write (timerdesc,9050) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, times_exec_timer, key7)
c Total time spent at the super-instruction               
               write (timerdesc,9080) optable(c_lineno,i),opdesc
               call register_timer(timerdesc, elapsed_time_timer, key8)
#else
               key6 = key5 + 1
               key7 = key6 + 1
               key8 = key7 + 1

#endif               


               if (key1 + 1 .ne. key2 .or.
     *             key2 + 1 .ne. key3 .or.
     *             key3 + 1 .ne. key4 .or.
     *             key4 + 1 .ne. key5 .or.
     *             key5 + 1 .ne. key6 .or.
     *             key6 + 1 .ne. key7 .or.
     *             key7 + 1 .ne. key8) then
                   print *, "Error : Assumption about timer being",
     *                      " alloted sequentially failed"
                   call abort_job()
               endif
            endif
         endif
      enddo

c-------------------------------------------------------------------------
c   Register a timer for each procedure.  This timer is stored in the
c   "op1" field of each call instruction.
c-------------------------------------------------------------------------

      do i = 1, noptable
         if (optable(c_opcode,i) .eq. call_op) then
            timerdesc = ' '
            write(timerdesc,9100) optable(c_lineno, i)
            call register_timer(timerdesc, elapsed_time_timer, key)
            optable(c_op1_array,i) = key
         endif
      enddo
 
c-------------------------------------------------------------------------
c   Set the "lock index" field for each pardo instruction.  These will be
c   used in case the load-balancing pardo option is used.
c-------------------------------------------------------------------------

      next = 0
      do i = 1, noptable
         if (optable(c_opcode,i) .eq. pardo_op) then
            next = next + 1
            optable(c_pardo_lock_index,i) = next
         endif
      enddo

      do i = 1, noptable
c        print *, me, ';', optable(c_lineno, i),'=',
c     *                  optable(c_instr_timer,i)
        if (optable(c_opcode,i) .ne. call_op .and.
     *       optable(c_opcode, i) .ne. pardo_op) then
        if (optable(c_instr_timer ,i) .ge. max_timers
     *       .or. optable(c_instr_timer, i) .lt. 0)
     *       print *, me, 'Error! with timer at line ',
     *           optable(c_lineno, i), ' is ', 
     *           optable(c_instr_timer, i)
        endif
      enddo



c-------------------------------------------------------------------------
c   Initialize Pardo Restriction Tables
c-------------------------------------------------------------------------

      do i = 1, nprocs
         if (pst_get_company(i-1) .eq. io_company_id) then
            do_prestrict(i) = 0
         else
            do_prestrict(i) = 1
         endif
      enddo


c      if (my_company_rank .eq. 0) then
c         print *,'Processing Operation table:'
c         do i = 1, noptable
c            print *,'Op #',i,': ',(optable(j,i),j=1,loptable_entry)
c         enddo
c      endif


 9000 format('Line',i6,': ',a12)
 9010 format('Lblk',i6,': ',a12)
c     Lblk = Block suffered at line number
 9020 format('Lmpi',i6,': ',a12)
 9040 format('Lnum',i6,': ',a12)
 9050 format('Lmno',i6,': ',a12)
 9060 format('Luni',i6,': ',a12)
 9070 format('Lalo',i6,': ',a12)
 9080 format('Ltot',i6,': ',a12)
c     Lblk = MPI suffered at line number
 9100 format('Proc call at line ',i6)
 9200 format('Pardo at line ',i6)
 9300 format('Blkwait for pardo ',i6)
 9400 format('Actual pardo proc ',i6)
c     Time spent at  
 9500 format('MPItime for pardo ',i6)
 9550 format('Ovrhead for pardo ',i6)
 9560 format('Number time pardo ',i6)
 9600 format('Optable time ')
 9650 format('Overhead time ')
      return
      end

      subroutine dmat_prt(dmat,m,n,ld)
      implicit none
      double precision dmat(*)
      integer m, n, ld

      integer i, j, start, cols, doing

      if ((m.eq.0).or.(n.eq.0).or.(ld.lt.m)) return

      start = 1
      cols = n
      do while (cols.ne.0)
         doing = min(3,cols-1)
         do i = 0, m-1
c            print '(4F19.14)', (dmat(start+i+j*ld),j=0,doing)
            print '(4F19.12)', (dmat(start+i+j*ld),j=0,doing)
         end do
         print '(/)'
         doing = doing + 1
         cols = cols - doing
         start = start + ( ld * doing )
c     end do while (cols.ne.0)
      end do

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine find_oldest_dirty_block(iblock, server_table,
     *                  nserver_table)
c---------------------------------------------------------------------------
c   Finds the oldest dirty block in memory that is also not busy.
c   If none exists, returns iblock = -1.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      integer iblock
      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
 
      integer ptr

      if (dirty_list_head .eq. 0) then
         iblock = -1
         return
      endif

      iblock = dirty_list_head
  100 continue
      ptr = server_table_ptr(iblock)
      if (and(server_table(c_server_flags, ptr), server_busy_flag) .eq.
     *                 0) return
 
      iblock = dirty_list_ptr(iblock)
      if (iblock .ne. 0) go to 100

      iblock = -1
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine handle_fsp_op(op, array_table, narray_table,
     *                         scalar_table, nscalar_table_entries)
c--------------------------------------------------------------------------
c   Performs calculations on the "fscratchpad".
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'scratchpad.h'

      integer op(loptable_entry)
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer nscalar_table_entries
      double precision scalar_table(nscalar_table_entries)
      integer i, opcode, op1, op2, result, index
      double precision diff, eps

      opcode = op(c_opcode)
      op1    = op(c_op1_array)
      op2    = op(c_op2_array)
      result = op(c_result_array)
      
c---------------------------------------------------------------------------
c   result field must be a valid fscratchpad index.
c---------------------------------------------------------------------------

      if (result .lt. 1 .or.
     *    result .gt. mx_fscratchpad) then
         print *,'Error: Invalid fscratchpad address in operation.'
         print *,'Operation: ',(op(i),i=1,loptable_entry)
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Arithmetic operations:
c---------------------------------------------------------------------------

      if (opcode .eq. fl_add_op) then
         fscratchpad(result) = op1 + op2
         return
      else if (opcode .eq. fl_sub_op) then
         fscratchpad(result) = op1 - op2
         return
      else if (opcode .eq. fl_mult_op) then
         fscratchpad(result) = op1 * op2
         return
      else if (opcode .eq. fl_div_op) then
         if (op2 .eq. 0) then
            print *,'Error: Operation contains division by 0.'
            print *,'Operation: ',(op(i),i=1,loptable_entry)
            call abort_job()
         else
            fscratchpad(result) = op1 / op2
            return
         endif  
      endif
      
c---------------------------------------------------------------------
c   Logical comparison operations:
c---------------------------------------------------------------------

      eps = 1.d-10

      if (opcode .eq. fl_eq_op) then
         diff = dabs(fscratchpad(op1)-fscratchpad(op2))
         if (diff .lt. eps) then
            scratchpad(result) = 1
         else 
            scratchpad(result) = 0
         endif
         return
      else if (opcode .eq. fl_ne_op) then
         diff = dabs(fscratchpad(op1)-fscratchpad(op2))
         if (diff .gt. eps) then
            scratchpad(result) = 1
         else
            scratchpad(result) = 0
         endif
         return
      else if (opcode .eq. fl_ge_op) then
         if (fscratchpad(op1) .ge. fscratchpad(op2)) then
            scratchpad(result) = 1
         else
            scratchpad(result) = 0
         endif
         return
      else if (opcode .eq. fl_le_op) then
         if (fscratchpad(op1) .le. fscratchpad(op2)) then
            scratchpad(result) = 1
         else
            scratchpad(result) = 0
         endif
         return
      else if (opcode .eq. fl_gt_op) then
         if (fscratchpad(op1) .gt. fscratchpad(op2)) then
            scratchpad(result) = 1
         else
            scratchpad(result) = 0
         endif
         return
      else if (opcode .eq. fl_lt_op) then
         if (fscratchpad(op1) .lt. fscratchpad(op2)) then
            scratchpad(result) = 1
         else
            scratchpad(result) = 0
         endif
         return
      endif
 
c--------------------------------------------------------------------------
c   Load instructions:
c--------------------------------------------------------------------------

      if (opcode .eq. fl_load_value_op) then   ! load scalar value
         if (op1 .lt. 1 .or. 
     *       op1 .gt. narray_table) then
            print *,'Error: Operation contains invalid index.'
            print *,'Operation: ',(op(i),i=1,loptable_entry)
            print *,'Number of array table entries = ',narray_table
            call abort_job() 
         else
            if (array_table(c_array_type,op1) .ne. scalar_value) then
               print *,'Error: Scalar logic instruction uses a',
     *             ' non-scalar array type: array, type = ',
     *             op1, array_table(c_array_type,op1)
               call abort_job()
            endif

            index = array_table(c_scalar_index, op1)
            fscratchpad(result) = scalar_table(index)
            return
         endif
      endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE GET1E(LUINT, type, x, LDIM,ILNBUF)
C
      IMPLICIT none
C
      integer luint, type, ilnbuf
      integer int, i, j, ldim, nxt
      double precision x(ldim,ldim)
      double precision BUF(ILNBUF)
      double precision scr(ldim*(ldim+1)/2)
#ifdef ACES64
      integer*8 IBUF(ILNBUF)
      integer*8 nut
#else
      integer IBUF(ILNBUF)
      integer nut
#endif

      character*8 ctype

      do i = 1, ldim
         scr(i) = 0.
      enddo

      if (type .eq. 1) then
         return   ! summed in with kinetic
      else if (type .eq. 2) then
         ctype = 'ONEHAMIL'   ! sum of kinetic and attraction
      else
         ctype = 'OVERLAP '
      endif

      CALL LOCATE(LUINT, ctype)
      NUT = ILNBUF
      DO WHILE (NUT.EQ.ILNBUF)
         READ(LUINT) BUF, IBUF, NUT
         DO INT = 1, NUT
            scr(IBUF(INT)) = BUF(INT)
         END DO
      END DO

c------------------------------------------------------------------------
c   Expand the data to its full (symmetric) form.
c------------------------------------------------------------------------

      nxt = 0
      do j = 1, ldim
      do i = 1, j
         nxt = nxt + 1
         x(i,j) = scr(nxt)
         x(j,i) = scr(nxt)
      enddo
      enddo

      RETURN
      END


      subroutine locate(iunit,labels)

c Finds a label in a vmol integral file and positions pointer to the
c first record after the label.

      integer iunit
      character*(*) labels

      character*8 lab,label

      label=labels
      rewind (iunit)
   10 read (iunit,end=900,err=910) lab
      if (lab(1:2).ne.'**') goto 10
      read (iunit,end=900) lab
      if (lab.eq.label) return
      goto 10

  900 write (6,9000) label,iunit
 9000 format(t3,'@LOCATE-F, Label ',a8,' not found on unit ',i3,'.')
      call abort_job()
      return

  910 write (6,9010) iunit,label
 9010 format(t3,'@LOCATE-F, I/O error on unit ',i3,' looking for ',
     &    'label ',a8,'.')
      call abort_job()
      return
      end

      Subroutine Make_BC_PQ_xyz(Nkxyz, PQSxyz, TPQxyz)
C
c This routine compute sums; Sum_a,b{a,b=0,n_i,n_j}{fac(ni,a)CA_i^^(n_i-a)
C where i=x,y,z
C
      Implicit Double Precision (A-H, O-Z)
C
#include "ecp.par"
#include "ecp.com"
    
      Dimension TPQxyz(0:2*Maxang), PQSxyz(0:2*Maxang)

      Call Dzero(TPQxyz, 2*Maxang+1)   
      
      Do Ka = 0, Nkxyz

         Pre_Faca = Bcoefs(Nkxyz, Ka)

         TPQxyz(Ka) = TPQxyz(Ka) + Pre_Faca*PQSxyz(Nkxyz-Ka)

#ifdef _DEBUG_LVLM1
          Write(6,"((1x,i3),3(1x,F10.4))"), Ka,
     &            pre_faca, PQSxyz(Nkxyz-Ka),TPQxyz(kA+KB)
#endif

      Enddo
    
      Return
      End

c This routine adds an array DADD to an MOIO array in storage. DADD and the
c MOIO array must have the same number of elements.

c INPUT
c double DADD(*) : the vector of addends
c double DSCR(*) : scratch array to hold at least one column of the MOIO array
c int IDIMSCR : size of the scratch array
c int IJUNK   : (obsolete integer)
c int ILEFT   : the left  MOIO index
c int IRIGHT  : the right MOIO index

      subroutine sumsym2(dAdd,dScr,iDimScr,iJunk,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iDimScr, iJunk, iLeft, iRight
      double precision dAdd(*), dScr(iDimScr)

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer nRows, nCols, i
      integer iNdx, iTmp, iStart, nBatch, nRemain, nMax

c ----------------------------------------------------------------------

      nRows = aces_list_rows(iLeft,iRight)
      nCols = aces_list_cols(iLeft,iRight)
      if ((nRows.lt.1).or.(nCols.lt.1)) return

      if (iDimScr.lt.nRows) then
         print *, '@SUMSYM2: ERROR - There is not enough scratch space',
     &            ' for one column.'
         print *, '          MOIO list = ',iLeft,iRight
         print *, '          iDimScr   = ',iDimScr
         print *, '          nRows     = ',nRows
         call aces_exit(1)
      end if

      nRemain = nCols
      iStart  = 1
      iNdx = 1
      nMax = iDimScr/nRows
      do while (nRemain.gt.0)
         nBatch = min(nRemain,nMax)

         call getlst(dScr,iStart,nBatch,0,iLeft,iRight)
         iTmp = nRows*nBatch
         do i = 0, iTmp-1
            dScr(1+i) = dScr(1+i) + dAdd(iNdx+i)
         end do
         iNdx = iNdx + iTmp
         call putlst(dScr,iStart,nBatch,0,iLeft,iRight)

         nRemain = nRemain - nBatch
         iStart  = iStart  + nBatch
      end do

      return
c     end subroutine sumsym2
      end

c This routine transposes the dimensions of one MOIO array and optionally
c transposes the actual data (but not yet).

c INPUT
c int ILEFT  : the left  index in MOIO
c int IRIGHT : the right index in MOIO
c logical BXPOSE : a behavior flag
c                  = T;        transpose the data (not implemented yet)
c                  = F; do not transpose the data

      subroutine aces_list_xpose(iLeft,iRight,bXPose)
      implicit none

c ARGUMENTS
      integer iLeft, iRight
      logical bXPose

c INTERNAL VARIABLES
      integer iTmp

c COMMON BLOCKS
#include "lists.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_LIST_XPOSE: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         iTmp = 1
      end if
c   o assert iLeft and iRight are properly bound
      if ((iLeft .lt.1).or.(_MAX_IO_GRPS.lt.iLeft ).or.
     &    (iRight.lt.1).or.(_MAX_IO_FAMS.lt.iRight)    ) then
         print *, '@ACES_LIST_XPOSE: Assertion failed.'
         print *, '   iLeft  = ',iLeft
         print *, '   iRight = ',iRight
         print *, '   MOIO rows = ',_MAX_IO_GRPS
         print *, '   MOIO cols = ',_MAX_IO_FAMS
         iTmp = 1
      end if
c   o assert bXPose is false (for now)
      if (bXPose) then
         print *, '@ACES_LIST_XPOSE: Assertion failed.'
         print *, '   bXPose = ',bXPose
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o transpose the data
      if (bXPose) then
         print *, '@ACES_LIST_XPOSE: no physical transpose yet'
      end if

c   o transpose the dimensions
      iTmp                 = moiods(iLeft,iRight)
      moiods(iLeft,iRight) = moiosz(iLeft,iRight)
      moiosz(iLeft,iRight) = iTmp

cYAU - There should be an isytyp modifier here as well; however, isytyp
c      describes an entire family and not one array.
c      isytyp(1,iRight) = ???
c      isytyp(2,iRight) = ???

c   o mark MOIO as modified
      bIOMod = .true.

      return
c     end subroutine aces_list_xpose
      end

         SUBROUTINE  ERD__ATOM_INT2D_TO_E000_YUKAWA
     +
     +                    ( SHELLA,SHELLP,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZET,NXYZP,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,RTS,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__ATOM_INT2D_TO_E000
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of atomic batches of
C                cartesian eris:
C
C                        [E0|00] or [00|E0] , E = A to P
C
C                adding up all the contributions from all the
C                respective atomic 2D integrals:
C
C                                   P0 or 0P
C
C                Simplified version of the general E0F0 routine to
C                reduce loop overheads for those cases where there is
C                at least one s-shell on the bra or ket side. For
C                comments and details see the general E0F0 routine.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x=A and csh sum P=A+B
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZET      =  sum of # of cartesian monomials
C                                   for all shells in the range
C                                   E = A,...,P=A+B
C                    NXYZP       =  # of cartesian monomials for the
C                                   P=A+B shell
C                    INT2Dx      =  all current 2D P0/0P atomic
C                                   integrals for each cartesian
C                                   component (x = X,Y,Z)
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D P0/0P atomic integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of atomic primitive cartesian
C                                   [E0|00] integrals corresponding
C                                   to all current exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C                      >>>  COPYRIGHT NOTICE  <<<
C                             Program ERD
C
C    This routine is part of the integral program package ERD and as
C    such is copyrighted by N. Flocke, 2004; all rights reserved.
C    The full copyright notice is printed in the main routine of the
C    ERD package and all terms and conditions given therein are
C    incorporated here.
C
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,K,M,N
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZE,NXYZET,NXYZP
         INTEGER     SE,SEEND
         INTEGER     SHELLA,SHELLP
         INTEGER     XE,YE,ZE
         INTEGER     XEMAX
         INTEGER     XEP,XYEP
         INTEGER     XYE
         INTEGER     YEEND

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO,RTS(1:NGQEXQ)

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH (1:NEXQ,1:NXYZET)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,0:SHELLP)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,0:SHELLP)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,0:SHELLP)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...set first all integral batch elements equal to zero.
C                This is necessary, since not all elements of the
C                batch will be addressed inside the x,y,z loops.
C
C
         DO I = 1,NXYZET
         DO M = 1,NEXQ
            BATCH (M,I) = ZERO
         END DO
         END DO
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XEP = NXYZET + 3
         DO 100 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 100

            DO M = 1,NEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 110 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 110

               IF (YE.EQ.0) THEN
                   DO M = 1,NEXQ
                      TEMP2 (M) = TEMP1 (M)
                   END DO
               ELSE
                   DO M = 1,NEXQ
                      TEMP2 (M) = TEMP1 (M) * INT2DY (M,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 120 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          DO M = 1,NEXQ
                             BATCH (M,I) = TEMP2 (M) * RTS(M)
                          END DO
                      ELSE
                          DO M = 1,NEXQ
                      BATCH (M,I) = TEMP2 (M) * INT2DZ (M,ZE) * RTS(M)
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  120          CONTINUE

  110       CONTINUE
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XEP = NXYZET + 3
         DO 200 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 200

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 210 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 210

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 220 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
                             K = K + 2
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
                             K = K + 2
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  220          CONTINUE

  210       CONTINUE
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XEP = NXYZET + 3
         DO 300 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 300

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 310 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 310

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 320 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
                             K = K + 3
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     * INT2DZ (K+2,ZE)
                             K = K + 3
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  320          CONTINUE

  310       CONTINUE
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XEP = NXYZET + 3
         DO 400 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 400

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 410 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 410

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 420 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     + TEMP2 (K+3)*RTS(K+3)
                             K = K + 4
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)
     +                                     * INT2DZ (K,ZE)*RTS(K)
     +                                     + TEMP2 (K+1)
     +                                     * INT2DZ (K+1,ZE)*RTS(K+1)
     +                                     + TEMP2 (K+2)
     +                                     * INT2DZ (K+2,ZE)*RTS(K+2)
     +                                     + TEMP2 (K+3)
     +                                     * INT2DZ (K+3,ZE)*RTS(K+3)
                             K = K + 4
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  420          CONTINUE

  410       CONTINUE
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XEP = NXYZET + 3
         DO 500 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 500

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 510 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 510

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 520 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     + TEMP2 (K+4)*RTS(K+4)
                             K = K + 5
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     * INT2DZ (K+2,ZE)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     * INT2DZ (K+3,ZE)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     * INT2DZ (K+4,ZE)
                             K = K + 5
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  520          CONTINUE

  510       CONTINUE
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XEP = NXYZET + 3
         DO 600 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 600

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 610 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 610

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 620 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     + TEMP2 (K+5)*RTS(K+5)
                             K = K + 6
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     * INT2DZ (K+2,ZE)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     * INT2DZ (K+3,ZE)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     * INT2DZ (K+4,ZE)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     * INT2DZ (K+5,ZE)
                             K = K + 6
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  620          CONTINUE

  610       CONTINUE
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XEP = NXYZET + 3
         DO 700 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 700

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 710 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 710

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 720 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     + TEMP2 (K+6)*RTS(K+6)
                             K = K + 7
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     * INT2DZ (K+2,ZE)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     * INT2DZ (K+3,ZE)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     * INT2DZ (K+4,ZE)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     * INT2DZ (K+5,ZE)
     +                                     + TEMP2 (K+6)*RTS(K+6)
     +                                     * INT2DZ (K+6,ZE)
                             K = K + 7
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  720          CONTINUE

  710       CONTINUE
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XEP = NXYZET + 3
         DO 800 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 800

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 810 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 810

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 820 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     + TEMP2 (K+6)*RTS(K+6)
     +                                     + TEMP2 (K+7)*RTS(K+7)
                             K = K + 8
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     * INT2DZ (K+2,ZE)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     * INT2DZ (K+3,ZE)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     * INT2DZ (K+4,ZE)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     * INT2DZ (K+5,ZE)
     +                                     + TEMP2 (K+6)*RTS(K+6)
     +                                     * INT2DZ (K+6,ZE)
     +                                     + TEMP2 (K+7)*RTS(K+7)
     +                                     * INT2DZ (K+7,ZE)
                             K = K + 8
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  820          CONTINUE

  810       CONTINUE
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XEP = NXYZET + 3
         DO 900 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 900

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO

            XYEP = XEP - XEMAX
            DO 910 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 910

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF

               I = XYEP
               NXYZE = NXYZP
               DO 920 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE

                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     + TEMP2 (K+6)*RTS(K+6)
     +                                     + TEMP2 (K+7)*RTS(K+7)
     +                                     + TEMP2 (K+8)*RTS(K+8)
                             K = K + 9
                          END DO
                      ELSE
                          K = 1
                          DO M = 1,NEXQ
                             BATCH (M,I) =   TEMP2 (K)*RTS(K)
     +                                     * INT2DZ (K,ZE)
     +                                     + TEMP2 (K+1)*RTS(K+1)
     +                                     * INT2DZ (K+1,ZE)
     +                                     + TEMP2 (K+2)*RTS(K+2)
     +                                     * INT2DZ (K+2,ZE)
     +                                     + TEMP2 (K+3)*RTS(K+3)
     +                                     * INT2DZ (K+3,ZE)
     +                                     + TEMP2 (K+4)*RTS(K+4)
     +                                     * INT2DZ (K+4,ZE)
     +                                     + TEMP2 (K+5)*RTS(K+5)
     +                                     * INT2DZ (K+5,ZE)
     +                                     + TEMP2 (K+6)*RTS(K+6)
     +                                     * INT2DZ (K+6,ZE)
     +                                     + TEMP2 (K+7)*RTS(K+7)
     +                                     * INT2DZ (K+7,ZE)
     +                                     + TEMP2 (K+8)*RTS(K+8)
     +                                     * INT2DZ (K+8,ZE)
                             K = K + 9
                          END DO
                      END IF
                  END IF

                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
  920          CONTINUE

  910       CONTINUE
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x-contributions. No skipping of the
C                x-contributions of 0-type can be done here, since
C                the 2DX integrals carry the Rys weight!
C
C
   10    XEP = NXYZET + 3
         DO 1000 XE = 0,SHELLP
            XEP = XEP + XE - 2
            XEMAX = XE * SHELLP
            YEEND = SHELLP - XE

            IF (MOD (XE,2).EQ.1) GOTO 1000

            DO M = 1,NGQEXQ
               TEMP1 (M) = SCALE (M) * INT2DX (M,XE)
            END DO
C
C
C             ...middle loops over y-contributions. Skip multiplication
C                of y-contributions, if we have a 0-type, as then the
C                2DY integral is equal to 1.
C
C
            XYEP = XEP - XEMAX
            DO 1010 YE = 0,YEEND
               XYE = XE + YE
               XYEP = XYEP - 1
               SEEND = MAX (SHELLA,XYE)

               IF (MOD (YE,2).EQ.1) GOTO 1010

               IF (YE.EQ.0) THEN
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N)
                   END DO
               ELSE
                   DO N = 1,NGQEXQ
                      TEMP2 (N) = TEMP1 (N) * INT2DY (N,YE)
                   END DO
               END IF
C
C
C             ...inner loops over E-contributions. Skip multiplication
C                of z-contributions, if we have a 0-type, as then the
C                2DZ integral is equal to 1.
C
C
               I = XYEP
               NXYZE = NXYZP
               DO 1020 SE = SHELLP,SEEND,-1
                  ZE = SE - XYE
C
C
C             ...all info concerning all x-, y- and z-contributions
C                have been collected for all exponent quadruplets at
C                once. Sum up the 2D X,Y,Z integral products to the
C                appropriate place of the batch.
C
C
                  IF (MOD (ZE,2).EQ.0) THEN
                      IF (ZE.EQ.0) THEN
                          K = 0
                          DO M = 1,NEXQ
                             SUM = ZERO
                             DO N = 1,NGQP
                                SUM = SUM + TEMP2 (K+N)*RTS(K+N)
                             END DO
                             K = K + NGQP
                             BATCH (M,I) = SUM
                          END DO
                      ELSE
                          K = 0
                          DO M = 1,NEXQ
                             SUM = ZERO
                             DO N = 1,NGQP
                        SUM = SUM + TEMP2(K+N) * INT2DZ(K+N,ZE)*RTS(K+N)
                             END DO
                             K = K + NGQP
                             BATCH (M,I) = SUM
                          END DO
                      END IF
                  END IF
C
C
C             ...next z-contribution.
C
C
                  I = I - NXYZE + XE
                  NXYZE = NXYZE - SE - 1
 1020          CONTINUE
C
C
C             ...next y- and x-contribution.
C
C
 1010       CONTINUE
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE MODFY_HESSIAN(DIAGHES, HESMOD, HES, QSTLST_TANGENT,
     &                         SCRATCH, EIGVALUE, WEIGHT, NOPT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      DIMENSION HESMOD(NOPT, NOPT), QSTLST_TANGENT(NOPT),
     &          SCRATCH(NOPT*NOPT), DIAGHES(NOPT, NOPT),
     &          HES(NOPT, NOPT)
      DATA ONE /1.0D0/, TWO /2.0D0/
C
C Note that at the moment SCRATCH array contains the HxT. Let's label
C that product as A vector. As we can see the A vector is an arbitrary
C direction in the space of the eigenvectors of H.
C
      SCALED_WEIGHT = TWO*EIGVALUE*WEIGHT
      CALL XGEMM('T','N', NOPT, NOPT, 1, -WEIGHT, QSTLST_TANGENT,
     &            NOPT, SCRATCH, NOPT, ONE, HES, NOPT)
      CALL XGEMM('N','T', NOPT, NOPT, 1, -WEIGHT, QSTLST_TANGENT,
     &            NOPT, SCRATCH, NOPT, ONE, HES, NOPT)
      CALL XGEMM('T','N', NOPT, NOPT, 1, SCALED_WEIGHT,
     &            QSTLST_TANGENT, NOPT, QSTLST_TANGENT,
     &            NOPT, ONE, HES, NOPT)
C
C Diagonalize the modified Hessian and print the eigenvalues and
C vectors. These new vectors and the values dictate the climbing
C phase of the search.
C
      CALL DCOPY(NOPT*NOPT, HES, 1, HESMOD, 1)
      CALL EIG(HESMOD, DIAGHES, NOPT, NOPT, 1)

c      Write(6,*) "The new Eigen vectors"
c      Call output(DIAGHES, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
c      Write(6,*) "The new Eigen values"
c      Call output(HESMOD, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)

      RETURN
      END

      subroutine prepareecp(Coord, Charge, Idexatom, Natoms,
     &                      Ntotatoms)

      implicit Double Precision (a-h,o-z)                                      

#include "ecp.par"
#include "ecp.com"
#include "machsp.com"

      Dimension Coord(3, Max_centers), Charge(Max_centers),
     &          idexatom(Max_centers)
      
      double precision :: dist, x(3)                                 

      call getrec(20,'JOBARC','NATOMS  ', 1, ntotatoms)           
cSSS     call getrec(20,'JOBARC','COORD   ', 3*ntotatoms*iintfp, acoord)                 
      do i = 1, natoms 
         idexatom(i) = 0                                      
      enddo 
C
#ifdef _DEBUG_LVL0
      write(6,*) ' Number of atoms :', natoms 
      write(6,*) ' Total Number of atoms :', ntotatoms  
      write(6,*) ' ACOORD :', (coord(1,ja), ja=1,natoms)  
      write(6,*) ' ACOORD :', (coord(2,ja), ja=1,natoms)  
      write(6,*) ' ACOORD :', (coord(3,ja), ja=1,natoms)  
#endif

      do ia = 1, ntotatoms                                           
         do ja = 1, natoms                                           
            dist = 0.d0                                           
            do id = 1, 3                                          
               x(id) = coord(id, ja)
               dist = dist + (x(id)-coord(id,ia))**2             
            enddo                                                 

            dist = sqrt(dist)                                     
            if (dist<1.d-6) then                                  
                idexatom(ia) = ja                                  
                goto 100                                           
            endif                                                 

         enddo                                                       
 100     continue                                                    
      enddo                                                          
C--------------
C This block of code and the ishuffle common block in ecp.com 
C was created to use in the cartesian to  spherical transformation
C but it was not needed. Ajith Perera, 12/2012.
C 
#ifdef _NODISCARD

      Ioff    = 1
      Inao(1) = 1
      Do Icent = 1, Ntotatoms
         Do Ishell = 1, Nshell
            Iatom  = katom(ishell)
            If (Idexatom(Icent) .EQ. Iatom) Then
               Idegen = Ndegen(Ishell)
               Numcoi = Numcon(Ishell)
               Ioff   = Ioff + 1
               Inao(Ioff) = Inao(ioff-1) + Idegen*Numcoi
            Endif
         Enddo
      Enddo
C       
      Do Icent = 1, Ntotatoms
         Do Ishell = 1, Nshell
            Iatom  = katom(ishell)
            If (Idexatom(Icent) .EQ. Iatom) Then
               Idegen = Ndegen(Ishell)
               Numcoi = Numcon(Ishell)
               If (Numcoi .ne. 0) Then
                   Ioff = Inao(Ishell)
                   Do Ico = 1, Numcoi
CSSS                      Ifrom = Inao(Ishell) - 1 + Ico
                      Ifrom = Ico
                      Do Ixyz = 1, Idegen 
                         Iorder(Ioff) = Ifrom
                         Ifrom        = Ifrom + Numcoi
                         Ioff         = Ioff + 1
                      Enddo
                   Enddo
               Endif
            Endif
         Enddo
      Enddo

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The ang. momentum offset and reordering array"
      Write(6,"(8(1x,i3))") (INao(i), i=1, Nshell)
      Write(6,*)
      Write(6,"(8(1x,i3))") (Iorder(i), i=1, Nbf)
      Write(6,*)
#endif
#endif

CSSS      call putrec(20,'JOBARC','ATOMINDX', ntotatoms, idexatom)       

      return                                                         
      end                                                            

      SUBROUTINE ORBOUT(NBASP,NORBOUTA,NORBOUTB,PCOEFFA,
     $     PCOEFFB,IORBVECA,IORBVECB,ORDERMATA,ORDERMATB,
     $     ITFCT,NORBOUT,IORBVEC)
c     
C     This subroutine redefines the pcoeffa and pcoeffb
C     when only a few orbitals are going to be displayed.
C     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION PCOEFFA(ITFCT*NBASP),PCOEFFB(ITFCT*NBASP),
     $     IORBVECA(9),IORBVECB(9),ORDERMATA(9*ITFCT),
     $     ORDERMATB(9*ITFCT),IORBVEC(9)
C     
C     Divide the iorbvec into its alpha and beta components.
      IA=0
      IB=0
      DO 5 I=1,9
         IORBVECA(I)=0
         IORBVECB(I)=0
         IF (IORBVEC(I).GT.NBASP) THEN
            IORBVECB(IB+1)=IORBVEC(I)-NBASP
            IB=IB+1
         ELSEIF(IORBVEC(I).NE.O) THEN
            IORBVECA(IA+1)=IORBVEC(I)
            IA=IA+1
         END IF
 5    CONTINUE
C     
C     Fill in the temporary matrices with the choice orbitals
      DO 10 I=1,9
         IF (IORBVECA(I).NE.O) THEN
            DO 20 J=1,ITFCT
               ORDERMATA((I-1)*ITFCT+J)=PCOEFFA((IORBVECA(I)-1)*ITFCT+J)
 20         CONTINUE 
         END IF
C     
         IF (IORBVECB(I).NE.O) THEN
            DO 30 J=1,ITFCT
               ORDERMATB((I-1)*ITFCT+J)=PCOEFFB((IORBVECB(I)-1)*ITFCT+J)
 30         CONTINUE
         END IF
 10   CONTINUE
C     
      NORBOUTA=IA
      NORBOUTB=IB
      NORBOUT=NORBOUTA+NORBOUTB
C     
C     Now refill the hereafter useful part of pcoeffa and pcoeffb.
C     
      DO 40 I=1,ITFCT*NORBOUTA
         PCOEFFA(I)=ORDERMATA(I)
 40   CONTINUE
C     
      DO 50 I=1,ITFCT*NOR80UT8
         PCOEFFB(I)=ORDERMATB(I)
 50   CONTINUE
C     
      RETURN
      END SUBROUTINE ORBOUT
      

C THIS ROUTINE ACCEPTS AN INPUT NSIZE x NSIZE SQUARE MATRIX [VFULL]
C AND CONSTRUCTS THE PACKED LOWER TRIANGULAR MATRIX VPACK [LENGTH:
C (VFULL*VFULL+1)/2

      SUBROUTINE SQUEZ2(VFULL,VPACK,NSIZE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VFULL(NSIZE,NSIZE),VPACK(NSIZE*(NSIZE+1)/2)

      if (nsize.lt.0) then
         print *, '@SQUEZ2: Assertion failed.'
         print *, '         nsize = ',nsize
         call errex
      end if

      ITHRU = 0
      DO I = 1, NSIZE
         DO J = 1, I
            ITHRU = ITHRU + 1
            VPACK(ITHRU) = VFULL(I,J)
         END DO
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE simple_INSPECT_MOL(fname, MAX_ATOMS, max_shells,
     &                natoms, nshells, nspc, cartesian, ITFCT, LNP1,
     &                lnpo, nfct, nufct, nbasis, NAOBASIS, nCFpS, 
     &                nPFpS, NAOATM, angmom, atomic_label)
C
C   Simple version of Ajith Perera's INSPECT_MOL routine.  This version 
C   scans the MOL file to determine the number of atoms.  It also assumes
C   no reordering of centers and all atoms are symmetry-unique.
c
c   Mark Ponton 10/2/03
C
C     ----INPUT ARGUMENTS----
c FNAME       = Unix file name of the MOL file.
C MAX_ATOMS   = Maximum number of atoms allowed.
C MAX_SHELLS  = Maximum number of shells
C CARTESIAN   = True for Cartesian basis choice 
C 
C    ----OUTPUT ARGUMENTS----- 
C
C NATOMS    = The total number of atoms. 
c nshells   = total number of shells
c nspc      = Array containing the number of shells per center.
C ITFCT   = Total number of primitive functions.
C LNP1    = Largest possible value for number of contracted functions for
C           all shells.
C LNPO    = Largest possible value for the product of number of primitives
C           of contracted functions for all shells.
C NFCT    = The total number of  primitive functions on each atom.
C NAOATM  = The total number of contracted functions on each atom.
C NUFCT   = The total number of primitives on each sym. unique atom
C NAOUATM = The total number of contracted functions on each sym. 
C           unique atom.
C NBASIS  = Total number of basis functions (contracted)
C NAOBASIS = Total number of basis functions in Cartesian coordinates.
c nCFpS   = Number of contracted functions per shell.
c nPFpS   = Number of primitive functions per shell.
c angmom  = Anuglar momentum of each (sub)shell.
c atomic_label = Array of unique integer ids for the atom of each shell.
c vnn     = Nuclear-nuclear repulsion energy.

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'dbugcom.h'
C     
      CHARACTER*(*) FNAME
      CHARACTER*4 ATMNAM
      CHARACTER*80 XLINE
      LOGICAL CARTESIAN
C     
      DIMENSION NFCT(MAX_ATOMS), NAOATM(MAX_ATOMS),
     &          NUFCT(MAX_ATOMS), NAOUATM(MAX_ATOMS),
     &          COORD(3)

      INTEGER NAOUATM2(MAX_ATOMS)
      INTEGER NAOBASIS, NAOTMP2, NP22
      INTEGER ISHL(10)
      integer idosph, idum(8)
      integer nspc(max_atoms), nCFpS(max_shells), nPFpS(max_shells)
      integer angmom(max_shells)
      integer atomic_label(max_shells)
      double precision vnn, r3, r5 
      double precision nuclear_nuclear_repulsion_energy 
      character*52  dumstring

      integer ihess, jhess, iatom, jatom 
C
C Open MOL file for basis set information. The MOL file is created by
C joda by processing user input file and basis set library.
C
      OPEN(UNIT=10, FILE=FNAME, FORM='FORMATTED', STATUS='OLD')
      REWIND(10)
C     
C Read the first five lines. Information on those five lines 
C are not relevent in the presnt context. 
C
      read (10,'(a6,4x,9i5)') dumstring,(idum(i),i=1,8),icart
      if (icart .eq. 1) then
         cartesian = .true.
         if (dbg)
     *      print *,'*** MOL file contains Cartesian coordinates ***'
      else
         if (dbg)
     *      print *,'*** MOL file contains spherical coordinates ***'
         cartesian = .false.
      endif

      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
C     
      LNP1   = 0
      LNPO   = 0
      LTNP1  = 0
      LTNPO  = 0
C
      natoms = 0
      nshells = 0
      indx_shell = 0
      DO 10 IATM = 1, MAX_ATOMS
         READ (10, '(A80)') XLINE
         if (xline(1:6) .eq. 'FINISH') go to 2000
C
         natoms = natoms + 1
         READ(xline, 1110) ZNUC, IJUNK, NSHL,
     *       (ISHL(I),I=1,NSHL)
 1110    FORMAT(F20.1,10I5)
         nspc(iatm) = 0
C
         READ(10,1115) ATMNAM,(COORD(I),I=1,3)
 1115    FORMAT(A4,3F20.12)

c----------------------------------------------------------------------------
c   Save the geometry data 
c----------------------------------------------------------------------------

         call set_geometry(iatm, coord, znuc)
C
         NUFCT(IATM) = 0
         NAOTMP      = 0
         NAOTMP2     = 0
C
         DO 20 I = 1, NSHL
            NPT  = 0
            NAOT = 0
            iangmom = i - 1
C
            DO 21 I1 = 1, ISHL(I)
               nshells        = nshells + 1
               nspc(iatm)     = nspc(iatm) + 1
               angmom(nshells) = iangmom   ! same a. m. value for each subshell
               atomic_label(nshells) = iatm
C
               READ(10,1120) NP1, NAO
 1120          FORMAT(2I5)
C
               NPT  = NPT  + NP1
               NAOT = NAOT + NAO
C
               IF (CARTESIAN) THEN 
                  NP2 = I*(I + 1)/2 
                  NP22 = NP2
               ELSE
                  NP2 = 2*I - 1
                  NP22 = I*(I + 1)/2
               ENDIF
C
               NAOTMP = NAOTMP + NP2*NAO
               NAOTMP2 = NAOTMP2 + NP22 * NAO
               NUFCT(IATM) = NUFCT(IATM) + NP2*NP1
               nPFpS(nshells) = np1
               nCFpS(nshells) = nao
C
               NLN = (NAO-3)/4
               IF ((NAO-3) .GT. (NLN*4)) NLN = NLN + 1
               NLN = (NLN + 1)*NP1
C
               DO 30 J=1,NLN
                  READ(10,'(A)') XLINE
 30            CONTINUE
C
               IF(NPT .GT. LNP1) THEN
                  IF(NPT .GT. LTNP1) LTNP1 = NPT
               ENDIF
C
               ITMP = NPT*NAOT
               IF(ITMP .GT. LNPO) THEN
                  IF(ITMP .GT. LTNPO) LTNPO = ITMP
               ENDIF
C
 21         CONTINUE
 20      CONTINUE
C
         IF (LTNP1 .GT. LNP1) LNP1 = LTNP1
         IF (LTNPO .GT. LNPO) LNPO = LTNPO
C
         NAOUATM(IATM) = NAOTMP
         NAOUATM2(IATM) = NAOTMP2
C
 10   CONTINUE
C     
 2000 continue
      iuatms = natoms
      ITFCT = 0
      DO 110 IATM = 1, IUATMS
            ITFCT = ITFCT + NUFCT(IATM)
 110  CONTINUE
C     
C Fill out NFCT, NAOATM and NMOMFCT for all atoms.
C
      ICNT   = 0
      NBASIS = 0
      NAOBASIS = 0
      DO 1011 II = 1, IUATMS
C
C
            ICNT = ICNT + 1
            NFCT(ICNT) = NUFCT(II)
            NAOATM(ICNT)= NAOUATM(II)
            NBASIS = NBASIS + NAOUATM(II)
            NAOBASIS = NAOBASIS + NAOUATM2(II)
C
 1011 CONTINUE
C
C Compute the Nuclear-Nuclear repulsion energy
C --------------------------------------------
C
c     vnn = nuclear_nuclear_repulsion_energy(natoms)

      close(10)
      RETURN
      END


      SUBROUTINE INSPECT_MOL(IUATMS, NATOMS, NPOP, IREORDER, CARTESIAN,
     &                       ITFCT, LNP1, LNPO, NFCT, NUFCT, NBASIS, 
     &                       ATMNAM, COORD)
C
C Read the MOL file and assign the number of primitive functions on each 
C atom, NFCT(IATM), the largest number of contracted functions in a single
C shell, LNP1, the largest number of primitive orbitals,
C (number of primitive functions times the number of atomic orbitals),
C in a single shell, LNPO, and the total number of primitive functions,
C ITFCT, for the  molecule. The number of AOs for each atom NAOATM. 
C Ajith Perera, 09, 2003.
C
C     ----INPUT ARGUMENTS----
C
C IUATMS    = The number of symmetry unique atoms. 
C NATOMS    = The total number of atoms. 
C IREORDER  = If there is any reordering of centers, this should
C             give the corrspondence. Most often this is a unit vector.
C CARTESIAN = True for Cartesian basis choice 
C NPOP      = number of symmetry equivalent atom for given 
C             symmetry unique center
C 
C    ----OUTPUT ARGUMENTS----- 
C
C ITFCT   = Total number of primitive functions.
C LNP1    = Largest possible value for number of contracted functions for
C           all shells.
C LNPO    = Largest possible value for the product of number of primitives
C           of contracted functions for all shells.
C NFCT    = The total number of  primitive functions on each atom.
C NAOATM  = The total number of contracted functions on each atom.
C NUFCT   = The total number of primitives on each sym. unique atom
C NAOUATM = The total number of contracted functions on each sym. 
C           unique atom.
C COORD   = Cartesian Coordiantes of symm. unique atoms.
C ATMNAM  = Atomic Symbols
C NBASIS  = Total number of basis functions (contracted)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      CHARACTER*4 ATMNAM
      CHARACTER*80 XLINE
      LOGICAL CARTESIAN
C     
      DIMENSION IREORDER(NATOMS), NFCT(NATOMS), NAOATM(NATOMS),
     &          NUFCT(IUATMS), NPOP(IUATMS), NAOUATM(IUATMS),
     &          ATMNAM(IUATMS), COORD(3,IUATMS)
 
      INTEGER ISHL(10)
C
C Open MOL file for basis set information. The MOL file is created by
C joda by processing user input file and basis set library.
C
      OPEN(UNIT=10, FILE='MOL', FORM='FORMATTED', STATUS='OLD')
      REWIND(10)
C     
C Read the first five lines. Information on those five lines 
C are not relevent in the presnt context. 
C
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
C     
      LNP1   = 0
      LNPO   = 0
      LTNP1  = 0
      LTNPO  = 0
C
      DO 10 IATM = 1, IUATMS
C
         READ(10, 1110) ZNUC, IJUNK, NSHL,(ISHL(I),I=1,NSHL)
 1110    FORMAT(F20.1,10I5)
C
         READ(10,1115) ATMNAM(IATM),(COORD(I,IATM),I=1,3)
 1115    FORMAT(A4,3F20.12)
C
         NUFCT(IATM) = 0
         NAOTMP      = 0
C
         DO 20 I = 1, NSHL
            NPT  = 0
            NAOT = 0
C
            DO 21 I1 = 1, ISHL(I)
C
               READ(10,1120) NP1, NAO
 1120          FORMAT(2I5)
C
               NPT  = NPT  + NP1
               NAOT = NAOT + NAO
C
               IF (CARTESIAN) THEN 
                  NP2 = I*(I + 1)/2 
               ELSE
                  NP2 = 2*I - 1
               ENDIF
C
               NAOTMP = NAOTMP + NP2*NAO
               NUFCT(IATM) = NUFCT(IATM) + NP2*NP1
C
               NLN = (NAO-3)/4
               IF ((NAO-3) .GT. (NLN*4)) NLN = NLN + 1
               NLN = (NLN + 1)*NP1
C
               DO 30 J=1,NLN
                  READ(10,'(A)') XLINE
 30            CONTINUE
C
               IF(NPT .GT. LNP1) THEN
                  IF(NPT .GT. LTNP1) LTNP1 = NPT
               ENDIF
C
               ITMP = NPT*NAOT
               IF(ITMP .GT. LNPO) THEN
                  IF(ITMP .GT. LTNPO) LTNPO = ITMP
               ENDIF
C
 21         CONTINUE
 20      CONTINUE
C
         IF (LTNP1 .GT. LNP1) LNP1 = LTNP1
         IF (LTNPO .GT. LNPO) LNPO = LTNPO
C
         NAOUATM(IATM) = NAOTMP
C
 10   CONTINUE
C     
      ITFCT = 0
      DO 110 IATM = 1, IUATMS
         DO 120 IEQATM = 1, NPOP(IATM)
            ITFCT = ITFCT + NUFCT(IATM)
 120     CONTINUE
 110  CONTINUE
C     
C Fill out NFCT, NAOATM and NMOMFCT for all atoms.
C
      ICNT   = 0
      NBASIS = 0
      DO 1011 II = 1, IUATMS
C
         DO 1020 IJ = 1, NPOP(II)
C
            ICNT = ICNT + 1
            NFCT(IREORDER(ICNT)) = NUFCT(II)
            NAOATM(IREORDER(ICNT))= NAOUATM(II)
            NBASIS = NBASIS + NAOUATM(II)
C
 1020    CONTINUE
 1011 CONTINUE
C     
      RETURN
      END

C
      SUBROUTINE READ_BASIS_INFO(FNAME, IUATMS, NATOMS, NPOP, IREORDER, 
     &                           CARTESIAN, ITFCT, LNP1, LNPO, 
     &                           NFCT, NBASIS, ALPHA, IXALPHA,
     &                           PCOEFF, IXPCOEF,
     &                           ATMNAM, COORD, NAOATM)
C
C     ----INPUT ARGUMENTS----
C
C FNAME     = Unix file name of the MOL file.
C IUATMS    = The number of symmetry unique atoms.
C NATOMS    = The total number of atoms.
C IREORDER  = If there is any reordering of centers, this should
C             give the correspondence. Most often this is a unit vector.
C CARTESIAN = True for Cartesian basis choice.
C NPOP      = number of symmetry equivalent atom for given
C             symmetry unique center.
C NAOATM    = The total number of contracted functions on each atom.
C ITFCT     = Total number of primitive functions.
C LNP1      = Largest value for number of contracted functions for all
C             shells.
C LNPO      = Largest possible value for the product of number of primitives
C             of contracted functions for all shells.
C NFCT      = The total number of  primitive functions on each atom.
C
C     ----OUTPUT ARGUMENTS------
C
C ALPHA     = Exponents for basis functions
C IXALPHA   = Index array, each entry is the beginning of alpha's for the 
C             shell.
C PCOEFF    = The contraction coefficients.
C IXPCOEF   = Index array for PCOEF, each entry is the beginning of
C             pcoeff's for the shell.
C ATMNAM    = Array of Atom names
C COORD     = (x,y,z) coordinate of each shell.
C
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C     
      CHARACTER*(*) FNAME 
      CHARACTER*80 XLINE
      CHARACTER*4 ATMNAM(NATOMS)
      LOGICAL CARTESIAN
C     
      DIMENSION NPOP(IUATMS),IREORDER(NATOMS), NFCT(NATOMS), 
     &          NAOATM(NATOMS), PCOEFF(ITFCT*NBASIS), 
     &          ALPHA(ITFCT), SALPHA(LNP1), SPCOEF(LNPO),
     &          COORD(3,*)

      INTEGER IXALPHA(*), IXPCOEF(*)
 
      DOUBLE PRECISION X, Y, Z 
      INTEGER ISHL(10)

      integer nxt_alpha, nxt_pcoef
C     
      PI=DATAN(1.0D+00)*4.D+00
      PICNST=(0.5D+00/PI)**0.75D+00
C
C Open MOL file for basis set information. The MOL file is created by 
C joda by processing user input file and basis set library.
C
      OPEN(UNIT=10, FILE=FNAME, FORM='FORMATTED', STATUS='OLD')
      REWIND(10)
C
C For the prsent puupose we can ignore the first 5 line of the MOL file.
C
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
      READ(10,'(A)') XLINE
C
      INI    = 1
      MAXANG = 0

      ishell = 0
      nxt_alpha = 1
      nxt_pcoef = 1 
      DO 10 IATM = 1, IUATMS
C
         READ(10,1000) ZNUC, IJUNK, NSHL,(ISHL(I),I=1,NSHL)
 1000    FORMAT(F20.1,10I5)
C
         READ(10,1010) ATMNAM(IATM), X, Y, Z
 1010    FORMAT(A4,3F20.12)
C     
         IDGOFF = 0
         IOFF   = 0
         JOFF   = 0
         NUNQSHL= 0
C
         DO 28 LL = 1, NSHL
C
            NPT=0
            NAOT=0
C
            DO 30 II1 = 1, ISHL(LL)
               READ(10,1120) NP1, NAO
C
               ishell = ishell + 1
               coord(1, ishell) = x
               coord(2, ishell) = y
               coord(3, ishell) = z
               NPT  = NPT + NP1
               NAOT = NAOT + NAO
C
               IF (CARTESIAN) THEN
                  NP2 = LL*(LL + 1)/2
               ELSE
                  NP2 = 2*LL - 1
               ENDIF
C
               DO 32 I = 1, NP1
                  READ(10,1060) SALPHA(I),(SPCOEF((J-1)*NP1+I),J=1,NAO)
 32            CONTINUE
C     
C Renormalize the atomic orbitals. Multiply the renormalized
C coefficients by the appropriate normalization constants.
C     
               DO 34 INAO = 1, NAO
C
                  SUM = 0.D+00
C
                  DO 36 I = 1, NP1
                     DO 37 J = 1, I
C
                        AI=SALPHA(I)
                        AJ=SALPHA(J)
C
                        TMP=SPCOEF((INAO-1)*NP1+I)*SPCOEF((INAO-1)*
     &                      NP1+J)*(2.0D+00*DSQRT(AI*AJ)/
     &                     (AI+AJ))**(REAL(LL)+0.5D+00)
C
                        SUM = SUM + TMP
                        IF(I .NE. J) SUM = SUM + TMP
C
 37                  CONTINUE
 36               CONTINUE
C
                  XNORM=1.D+00/DSQRT(SUM)
C
                  DO 38 I = 1, NP1
c                    SPCOEF((INAO-1)*NP1+I)= SPCOEF((INAO-1)*NP1+I)*
c    &                                       XNORM*PICNST*
c    &                                       (4.D+00*SALPHA(I))**
c    &                                       (0.5D+00*REAL(LL)+
c    &                                        0.25D+00)
                     SPCOEF((INAO-1)*NP1+I)= SPCOEF((INAO-1)*NP1+I)*
     &                                       XNORM
 38               CONTINUE
 34            CONTINUE
C     
C Place the alpha's and coefficients in their appropriate place in 
C their respective matrices, ALPHA and PCOEFF.
C
CCCCC               DO 40 IPOP = INI, INI + NPOP(IATM) - 1
C
CCCCC                  IATMOFF = 0
CCCCC                  JATMOFF = 0
C
CCCCC                  DO 43 ITMP = 1, IREORDER(IPOP)-1
CCCCC                     IATMOFF = IATMOFF + NFCT(ITMP)
CCCCC                     JATMOFF = JATMOFF + NAOATM(ITMP)*ITFCT
CCCCC 43               CONTINUE
C
CCCCC                  DO 45 I = 1, NP1
CCCCC                     JSHOFF=0
CCCCC                     DO 46 I1 = 1, NP2
CCCCC                        ALPHA(I+IOFF+IATMOFF+(I1-1)*NP1) = SALPHA(I)
C
CCCCC                        DO 57 J=1,NAO
CCCCC                           PCOEFF(JATMOFF+(JOFF+JSHOFF)*ITFCT+I+IOFF+
CCCCC     $                     IATMOFF+(I1-1)*NP1 )= SPCOEF((J-1)*NP1+I)
CCCCC                           JSHOFF=JSHOFF+1
C
CCCCC 57                     CONTINUE
CCCCC 46                  CONTINUE
CCCCC 45               CONTINUE
CCCCC 40            CONTINUE
C
CCCCC               IOFF=IOFF+NP1*NP2
CCCCC               JOFF=JOFF+NP2*NAO
C

c---------------------------------------------------------------------------
c   Move alpha's and pcoef's into their packed return arrays.
c   Save pointers in the ixalpha, ixpcoef arrays so the data may be
c   more easily referenced later.
c---------------------------------------------------------------------------

               ixalpha(ishell) = nxt_alpha
               do i = 1, np1
                  alpha(nxt_alpha+i-1) = salpha(i)
               enddo
       
               nxt_alpha = nxt_alpha + np1

               ixpcoef(ishell) = nxt_pcoef
               do j = 1, nao
               do i = 1, np1
                  pcoeff(nxt_pcoef) = spcoef((j-1)*np1+i)
                  nxt_pcoef        = nxt_pcoef + 1
               enddo
               enddo

 30         CONTINUE
 28      CONTINUE
C
         INI = INI + NPOP(IATM)
         IF(NSHL .GT. MAXANG) MAXANG = NSHL
 10   CONTINUE
C
 1120 FORMAT(2I5)
 1060 FORMAT(4F18.10)
C
      close(10)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__CTR_2INDEX_BLOCK
     +
     +                    ( NPSIZE,NCSIZE,NWSIZE,
     +                      NXYZT,
     +                      MIJ,NRS,
     +                      NPR,NPS,
     +                      NCR,NCS,
     +                      MXPRIM,MNPRIM,
     +                      CCR,CCS,
     +                      CCBEGR,CCBEGS,
     +                      CCENDR,CCENDS,
     +                      PRIMR,PRIMS,
     +                      L1CACHE,TILE,NCTROW,
     +                      EQUALRS,
     +                      SWAPRS,
     +                      PTRANS,
     +                      BLOCKED,
     +                      PUSED,PSAVE,PPAIR,
     +                      PBATCH,
     +                      WORK,
     +
     +                                CBATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__CTR_2INDEX_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__TRANSPOSE_BATCH
C                OED__CTR_PAIR_NEW
C                OED__CTR_PAIR_UPDATE
C  DESCRIPTION : This operation performs a two-indexed contraction from
C                a block of one electron primitives to contracted
C                integrals:
C
C
C                      sum  [a|b]    -->  (a|b)
C                       ij       ij            rs
C
C                                                r = 1,NCR
C                                                s = 1,NCS
C
C                For optimum performance of the contraction procedure,
C                the contraction routine is written to operate on the
C                batch block of primitive integrals ordered in the
C                following form:
C
C                               pbatch (nxyzt,ij)
C
C                where ij are the partial primitive index pairs being
C                treated here. Their total numbers are MIJ and the
C                individual i,j indices are sitting in PRIMR,PRIMS.
C                If on entry of this routine the primitive integrals
C                are ordered in the form (ij,nxyzt), a transposition
C                has to preceed the actual contraction procedure.
C                This is triggered by the keyword PTRANS, which is
C                set true, if such a transposition is needed. The
C                complete set of cartesian monomial quadruplets is
C                kept together for efficiency through the entire
C                contraction sequence.
C
C                STRATEGY:
C
C                Perform overall contraction in one step:
C
C                  (nxyzt,rs) = (nxyzt,rs)
C                                + ccr (r,i) * ccs (s,j) * (nxyzt,ij)
C
C
C
C                  Input:
C
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays
C                    NXYZT        =  total # of cartesian monomial
C                                    quadruplets
C                    MIJ          =  # of ij primitive pairs to be
C                                    transformed
C                    NRS          =  # of rs contraction pairs
C                    NPx          =  # of respective i,j primitives
C                                    for contractions x=R,S
C                    NCx          =  # of contractions for x=R,S
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = max (i,j)
C                    MNPRIM       =  the minimum # of primitives
C                                    between all i and j primitives,
C                                    i.e. = min (i,j)
C                    CCx          =  full set (including zeros) of
C                                    contraction coefficients for
C                                    x=R,S contractions
C                    CCBEGx       =  lowest nonzero primitive i,j
C                                    index for x=R,S contractions
C                    CCENDx       =  highest nonzero primitive i,j
C                                    index for x=R,S contractions
C                    PRIMx        =  primitive i,j indices for the
C                                    x=R,S contractions
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    TILE         =  Number of rows and columns in
C                                    units of 8 Byte of level 1 cache
C                                    square tile array used for
C                                    performing optimum matrix
C                                    transpositions
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    EQUALRS      =  is true, if only the lower
C                                    triangle of ij primitive indices
C                                    is present and consequently only
C                                    the lower triangle of the rs
C                                    contractions needs to be evaluated
C                    SWAPRS       =  if this is true, the 1st half
C                                    transformation will be over R
C                                    followed by the 2nd over S.
C                                    If false, the order will be
C                                    reversed: 1st over S then 2nd
C                                    over R
C                    PTRANS       =  if true, a necessary primitive
C                                    integral transposition needs to
C                                    be done in order to bring the ij
C                                    primitive indices to the far right
C                                    position
C                    BLOCKED      =  if false, only one call will be
C                                    made to the present contraction
C                                    routine. The contraction batch
C                                    has not! been initialized to zero
C                                    and there is no need to perform
C                                    an update of the contracted batch.
C                    Pxxxx        =  intermediate storage arrays for
C                                    primitive labels to bundle
C                                    contraction steps in do loops
C                                    (xxxx = USED,SAVE,PAIR)
C                    PBATCH       =  the batch of primitive integrals
C                                    to be contracted
C                    WORK         =  the working array for intermediate
C                                    storage
C                    CBATCH       =  the batch of contracted integrals
C                                    before contraction update
C
C                  Output:
C
C                    CBATCH       =  the update batch of contracted
C                                    integrals after contraction
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     BLOCKED
         LOGICAL     EQUALRS
         LOGICAL     INWORK
         LOGICAL     PTRANS
         LOGICAL     SWAPRS

         INTEGER     L1CACHE,L1FREE,L1USED
         INTEGER     MIJ,NRS
         INTEGER     MXPRIM,MNPRIM
         INTEGER     NBLOCK
         INTEGER     NCOL,NROW
         INTEGER     NCR,NCS
         INTEGER     NCTROW
         INTEGER     NPR,NPS
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NXYZT
         INTEGER     TILE
         INTEGER     WROW

         INTEGER     CCBEGR (1:NCR)
         INTEGER     CCBEGS (1:NCS)

         INTEGER     CCENDR (1:NCR)
         INTEGER     CCENDS (1:NCS)

         INTEGER     PRIMR  (1:MIJ)
         INTEGER     PRIMS  (1:MIJ)

         INTEGER     PPAIR  (1:MXPRIM)
         INTEGER     PSAVE  (1:MXPRIM)
         INTEGER     PUSED  (1:MNPRIM)

         DOUBLE PRECISION    CCR (1:NPR,1:NCR)
         DOUBLE PRECISION    CCS (1:NPS,1:NCS)

         DOUBLE PRECISION    CBATCH (1:NCSIZE)
         DOUBLE PRECISION    PBATCH (1:NPSIZE)
         DOUBLE PRECISION    WORK   (1:NWSIZE)
C
C
C------------------------------------------------------------------------
C
C
C             ...check, if a primitive batch transposition is needed:
C
C                        (ij,nxyzt) --> (nxyzt,ij)
C
C
         IF (PTRANS .AND. (MIJ.GT.1) .AND. (NXYZT.GT.1)) THEN

             CALL  OED__TRANSPOSE_BATCH
     +
     +                  ( MIJ,NXYZT,
     +                    TILE,
     +                    PBATCH,
     +
     +                            WORK )
     +
     +
             INWORK = .TRUE.
         ELSE
             INWORK = .FALSE.
         END IF
C
C
C             ...prepare for contraction over ij. Logical variable
C                INWORK controls where the actual significant data
C                (i.e. the integrals to be contracted) is residing.
C                If INWORK is true, then array WORK contains the
C                integrals, if false, they are in array PBATCH.
C                One of the key variables to be determined here
C                is the blocking size of the invariant indices
C                such that the cache is used efficiently. The
C                blocking size has to be adapted also to the size
C                of the working space available. L1USED contains
C                the amount of data that will occupy the cache
C                besides the three main big arrays containing the
C                initial, quarter transformed and halftransformed
C                integrals. This extra data is the contraction
C                coefficients, their segmentation limits and the
C                primitive indices. L1FREE indicates the size of
C                the level 1 cache that is finally available for
C                the three big integral arrays.
C
C
         L1USED = MIJ + NCR + NCS + NPR + NPS + NPR*NCR + NPS*NCS
         L1FREE = (3*L1CACHE/4) - L1USED

         NCOL = MNPRIM + NRS + MIJ
         NROW = L1FREE / NCOL
C
C
C             ...do contraction over ij. If primitive integrals are
C                in working array, use original PBATCH array as
C                working array! Do not perform a contracted batch
C                update, if no contraction blocking is necessary.
C
C
         IF (INWORK) THEN

             WROW = NPSIZE / MNPRIM
             NBLOCK = MIN (NXYZT,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             IF (BLOCKED) THEN
                 CALL  OED__CTR_PAIR_UPDATE
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        WORK,PBATCH,
     +
     +                                CBATCH )
     +
     +
             ELSE
                 CALL  OED__CTR_PAIR_NEW
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        WORK,PBATCH,
     +
     +                                CBATCH )
     +
     +
             END IF

         ELSE

             WROW = NWSIZE / MNPRIM
             NBLOCK = MIN (NXYZT,NROW,WROW)
             NBLOCK = MAX (NBLOCK,NCTROW)

             IF (BLOCKED) THEN
                 CALL  OED__CTR_PAIR_UPDATE
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        PBATCH,WORK,
     +
     +                                CBATCH )
     +
     +
             ELSE
                 CALL  OED__CTR_PAIR_NEW
     +
     +                      ( NXYZT,
     +                        MXPRIM,MNPRIM,
     +                        MIJ,NRS,
     +                        NBLOCK,
     +                        NCR,NCS,
     +                        NPR,NPS,
     +                        CCR,CCS,
     +                        CCBEGR,CCBEGS,
     +                        CCENDR,CCENDS,
     +                        PRIMR,PRIMS,
     +                        EQUALRS,
     +                        SWAPRS,
     +                        PUSED,PSAVE,PPAIR,
     +                        PBATCH,WORK,
     +
     +                                CBATCH )
     +
     +
             END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine carves up the icore(i0) space for using setptr/relptr.
c It's clumsy, but you must communicate with this routine through
c sbcore.com by setting ineeded, dneeded, maxicore, etc.

c For dummy runs (when memknown=0), iSize sets maxmem.

c INPUT:
c int iHeap : the first integer in a heap (i.e. icore(i0) in ACES lingo)
c int iSize : the number of INTEGERS in the heap

      subroutine sb_mem_init(iHeap,iSize)
      implicit none















c Macros beginning with M_ are machine dependant macros.
c Macros beginning with B_ are blas/lapack routines.

c  M_REAL         set to either "real" or "double precision" depending on
c                 whether single or double precision math is done on this
c                 machine

c  M_IMPLICITNONE set iff the fortran compiler supports "implicit none"
c  M_TRACEBACK    set to the call which gets a traceback if supported by
c                 the compiler























cYAU - ACES3 stuff . . . we hope - #include <aces.par>






c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end





c Two different "stacks" of memory will be available in the course of an
c Aces3 calculation.  Integer memory will be stored in icore.  Real memory
c will be stored in dcore.
c
c Memory allocation is done in one of two ways, dynamic or nondynamic.  This
c is controlled by the parameter dynmem.  If dynmem is 1, dynamic memory
c is used.  Otherwise, nondynamic memory is used.
c
c Two additional parameters nondynimem and nondyndmem control how much
c nondynamic memory is allocated initially in the icore and dcore stacks.
c If dynmem is 1, both of these parameters SHOULD be 1.

c Dynamic memory allocation is done in a fairly straighforward way.  The
c program runs through everything twice.  The first time is just to determine
c how much dynamic memory is required.  The second time is use to actually
c allocate the memory and use it.  In some cases, it may be difficult to
c determine how much memory to use in advance in each of the stacks.  To
c aid this, there is also the option of only running through a program a
c single time.  When this happens, both stacks are allocated initially and
c used throughout the program.  If the memory requirement for either stack
c is exceeded, the program crashes.
c
c Two parameters which are used in either case are memknown and maxicore.
c Both MUST be set in the calling program.
c
c   memknown : 0 if a dummy run is being done to determine memory usage
c              1 if the memory usage is known from a previous dummy run
c             -1 if no dummy run is done (only one run through the program)
c   maxicore : the maximum amount of icore to allocate (this MAY be
c              adjusted IF a dummy run detects that more is needed, but in
c              the case of a single run, this will be rigidly applied)
c
c This include file is required whenever calls to any of the memory functions
c (setptr and relptr) are called or when part of the execution depends on
c whether the first or second run is being performed.
c
c ***NOTE***
c It is important that icore be aligned on a floating point boundary.  One
c way which seems to insure this is to have icore the FIRST element in the
c common block.  So, make sure that no integer is ever inserted before icore
c in the common block declaration.

      integer dynmem,nondynimem,nondyndmem
      parameter (dynmem=1)
      parameter (nondynimem=1)
      parameter (nondyndmem=1)
c      parameter (nondynimem=1000000)
c      parameter (nondyndmem=4000000)

      double precision   dcore(nondyndmem)
      common /dcore_com/ dcore
      save   /dcore_com/

      integer    icore(nondynimem)
      common / / icore

      integer             memknown,maxicore
      common /sbcore_com/ memknown,maxicore
      save   /sbcore_com/





c i0,i1    : The first element in icore that may be used and the first element
c            that may not be used.
c iptr     : The pointer to the current location in icore
c ineeded  : The size of icore needed for the calculation (determined by the
c            initial run).  This is only used when dynamic memory is used.
c
c In a dummy run, i0 starts at 1, iptr is incremented, and ineeded goes from
c 0 to ineeded.  i1 is initially set at maxicore.  These values are used if
c nondynamic memory is used.  Note that if dynamic memory is used, ineeded
c MAY exceed i1.  In this case (provided there dcore has not used all the
c remaining memory), the amount of memory given to icore is increased.  On
c the other hand, if icore does not need all that it was given, it gives
c the remaining to dcore.
c
c When memory is actually allocated, i0 is set to the beginning element,
c i1 is set to i0+ineeded, and iptr ranges from i0 to i1.
c
c d0,dpt,dneeded,d1
c          : Similar for dcore
c
c maxmem   : Maximum memory to allocate (set in ZMAT file)

      integer             i0,iptr,ineeded,i1,d0,dptr,dneeded,d1,maxmem
      common /ks_mem_com/ i0,iptr,ineeded,i1,d0,dptr,dneeded,d1,maxmem
      save   /ks_mem_com/



      integer iHeap(*), iSize
      INTEGER c_adr, zheap, ztmp
      external c_adr

      call callstack_push('SB_MEM_INIT')

      if (iSize.le.0) then
         print *, '@SB_MEM_INIT: Assertion failed.'
         print *, '              iSize = ',iSize
         call errex
      end if

      if (memknown.ne.0) then

         if (dynmem.eq.1) then
            maxmem=iSize
            if (memknown.eq.-1) then
               ineeded=maxicore
               dneeded=(maxmem-maxicore)/iintfp
            end if
            zheap = c_adr(iHeap)

c i0 is the icore index that addresses iHeap
c shift zheap up to a 64-bit boundary
            zheap = ifltln * ((zheap+ifltln-1)/ifltln)
            ztmp = (zheap-c_adr(icore(1)))/iintln
            i0 = 1 + ztmp
            if (i0.ne.1+ztmp) then
               print *, '@SB_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

c i1 is the first icore index that cannot be used (after the "icore" heap)
c (Yau: shift this up to 64-bit boundary)
            ztmp = ztmp + ineeded + iand(ineeded,iintfp-1)
            i1 = 1 + ztmp
            if (i1.ne.1+ztmp) then
               print *, '@SB_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

c repeat the process for dcore
            zheap = c_adr(icore(i1))

c d0 is the dcore index that addresses zheap
            ztmp = (zheap-c_adr(dcore(1)))/ifltln
            d0 = 1 + ztmp
            if (d0.ne.1+ztmp) then
               print *, '@SB_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

c d1 is the first dcore index that cannot be used (after the "dcore" heap)
            ztmp = ztmp + dneeded
            d1 = 1 + ztmp
            if (d1.ne.1+ztmp) then
               print *, '@SB_MEM_INIT: Integer overflow.'
               print *, '              The heap cannot be addressed.'
               call errex
            end if

         else
            maxmem=0
            maxicore=nondynimem
            ineeded=nondynimem
            dneeded=nondyndmem
            i0=1
            d0=1
            i1=nondynimem+1
            d1=nondyndmem+1
         end if
         iptr=i0
         dptr=d0
         call izero(icore(i0),ineeded)
         call dzero(dcore(d0),dneeded)

      else ! dummy run

         if (dynmem.eq.1) then
            maxmem=iSize
            i1=maxicore+1
            d1=(maxmem-maxicore)/iintfp+1
         else
            maxmem=0
            maxicore=nondynimem
            i1=nondynimem+1
            d1=nondyndmem+1
         end if
         i0=1
         d0=1
         iptr=1
         dptr=1
         ineeded=0
         dneeded=0

      end if

      call callstack_pop
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine com_shift(q, natoms, atmass, iprnt)
c-----------------------------------------------------------------------------
c   Performs center-of-mass trnanslation of a molecular system.
c-----------------------------------------------------------------------------
      implicit none
      integer natoms, iprnt
      double precision q(3*natoms), atmass(natoms)  

      integer i, j, luout, idegen
      double precision cmx, cmy, cmz, molwt
      double precision cm(3)
C
C TRANSLATE TO CENTER OF MASS
C
      LUOUT = 6
      IDEGEN=0
      IF(IPRNT.GE.3)WRITE(LUOUT,7733)(ATMASS(J),J = 1,NATOMS)
 7733 FORMAT(1X,F15.10)
      CMX=0.D0
      CMY=0.D0
      CMZ=0.D0
      MOLWT=0.D0
      DO 20 I = 1,NATOMS
        CMX = ATMASS(I)*Q(3*I-2)+CMX
        CMY = ATMASS(I)*Q(3*I-1)+CMY
        CMZ = ATMASS(I)*Q(3*I)+CMZ
   20 MOLWT = MOLWT+ATMASS(I)
      IF (MOLWT.LT.1.0D-8) THEN
         WRITE(LUOUT,*) '@com_shift: No real atoms in Z-matrix.'
         CALL ERREX
      END IF
      CM(1) = CMX/MOLWT
      CM(2) = CMY/MOLWT
      CM(3) = CMZ/MOLWT
      DO I = 1,NATOMS
        DO J = 0,2
          Q(3*I-J) = Q(3*I-J)-CM(3-J)
        ENDDO
      ENDDO 
      IF(IPRNT .GE. 4) THEN
           WRITE(LUOUT,*)
     &     'After translation to center of mass coordinates '
           WRITE(LUOUT,80)(Q(I),I = 1,NATOMS)
      ENDIF
   80 FORMAT((4X,3(2X,F16.12)))

      write(6,*) ' @symmetry-i, Coordinates after  COM shift '
      do i=1,natoms
        write(6,'(3F20.12)') q(3*i-2),q(3*i-1),q(3*i)
      enddo

      return 
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__CTR_SINGLE_UPDATE
     +
     +                    ( N,
     +                      MI,
     +                      NP,NC,
     +                      CC,
     +                      CCBEG,CCEND,
     +                      PRIM,
     +                      PCTR,PLOC,
     +                      X,
     +
     +                             Y )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__CTR_SINGLE_UPDATE
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single contraction step
C                on the incomming integrals over primitives in one
C                shot (nonblocked) over invariant indices n and
C                updates transformed integrals:
C
C                       y (n,r) = y (n,r) + sum  cc (r,i) * x (n,i)
C                                            i
C
C                where cc is the array containing the contraction
C                coefficients. The sum is over the i primitives which
C                are transmitted in array PRIM and may constitute only
C                a subset of the full range of these primitives.
C
C                        --- SEGMENTED CONTRACTIONS ---
C
C                Segmented contractions are those defined to be
C                within a certain consecutive i-range of primitives.
C                The segmented limits for the contraction are sitting
C                in CCBEG (lowest limit) and CCEND (highest limit)
C                and they determine which of the actual i's from the
C                PRIM list have to be considered for each contraction
C                index.
C
C                The code is written in such form that the i-order of
C                the primitive integrals is immaterial.
C
C                The code also allows efficient contractions in case
C                there is only one contraction coefficient present
C                in a certain contraction and its value is equal to 1.
C                In such cases we can save lots of multiplications by
C                1 and since these cases are quite common for certain
C                types of basis functions it is worth including an
C                extra IF inside the contraction loop to gain speed.
C
C
C                  Input:
C
C                    N            =  # of invariant indices
C                    MI           =  # of primitives to be transformed
C                    NP           =  total # of i primitives
C                    NC           =  # of contractions for the i -> R
C                                    primitives
C                    CC           =  full set (including zeros) of
C                                    contraction coefficients for the
C                                    R contractions
C                    CCBEG        =  lowest nonzero primitive i index
C                                    for R contractions
C                    CCEND        =  highest nonzero primitive i index
C                                    for R contractions
C                    PRIM         =  primitive i indices to be
C                                    transformed
C                    Pxxx         =  intermediate storage arrays for
C                                    primitive labels to bundle
C                                    contraction steps in do loops
C                                    (xxx = CTR,LOC)
C                    X            =  input array containing the
C                                    primitive integrals
C
C                  Output:
C
C                    Y            =  contains the updated transformed
C                                    integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     I,M,N,P,R
         INTEGER     MI,NI
         INTEGER     NC,NP
         INTEGER     NIBASE,NILEFT,NIREST,NISTEP
         INTEGER     P1,P2,P3,P4,P5,P6,P7,P8
         INTEGER     PMIN,PMAX

         INTEGER     CCBEG (1:NC)
         INTEGER     CCEND (1:NC)

         INTEGER     PRIM  (1:MI)
         INTEGER     PCTR  (1:NP)
         INTEGER     PLOC  (1:NP)

         DOUBLE PRECISION  C1,C2,C3,C4,C5,C6,C7,C8
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  CC (1:NP,1:NC)

         DOUBLE PRECISION  X (1:N,1:MI)
         DOUBLE PRECISION  Y (1:N,1:NC)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (ONE   =  1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...perform the single index contraction.
C
C
         DO 10 R = 1,NC
            PMIN = CCBEG (R)
            PMAX = CCEND (R)

            IF (PMIN.EQ.PMAX .AND. CC (PMIN,R).EQ.ONE) THEN
C
C
C             ...only one contraction coefficient equal to 1.0 is
C                present.
C
C
                DO M = 1,N
                   Y (M,R) = Y (M,R) + X (M,PMIN)
                END DO
            ELSE
C
C
C             ...the general contraction case with many coefficients.
C                Perform contractions for all primitives simultaneously.
C
C
                NI = 0
                DO 20 P = 1,MI
                   I = PRIM (P)
                   IF (I.GE.PMIN .AND. I.LE.PMAX) THEN
                       NI = NI + 1
                       PCTR (NI) = I
                       PLOC (NI) = P
                   END IF
   20           CONTINUE

                IF (NI.EQ.1) THEN
                    P1 = PLOC (1)
                    C1 = CC (PCTR (1),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
                    END DO
                ELSE IF (NI.EQ.2) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
                    END DO
                ELSE IF (NI.EQ.3) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
                    END DO
                ELSE IF (NI.EQ.4) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    P4 = PLOC (4)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    C4 = CC (PCTR (4),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
     +                                   + C4 * X (M,P4)
                    END DO
                ELSE IF (NI.EQ.5) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    P4 = PLOC (4)
                    P5 = PLOC (5)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    C4 = CC (PCTR (4),R)
                    C5 = CC (PCTR (5),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
     +                                   + C4 * X (M,P4)
     +                                   + C5 * X (M,P5)
                    END DO
                ELSE IF (NI.EQ.6) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    P4 = PLOC (4)
                    P5 = PLOC (5)
                    P6 = PLOC (6)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    C4 = CC (PCTR (4),R)
                    C5 = CC (PCTR (5),R)
                    C6 = CC (PCTR (6),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
     +                                   + C4 * X (M,P4)
     +                                   + C5 * X (M,P5)
     +                                   + C6 * X (M,P6)
                    END DO
                ELSE IF (NI.EQ.7) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    P4 = PLOC (4)
                    P5 = PLOC (5)
                    P6 = PLOC (6)
                    P7 = PLOC (7)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    C4 = CC (PCTR (4),R)
                    C5 = CC (PCTR (5),R)
                    C6 = CC (PCTR (6),R)
                    C7 = CC (PCTR (7),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
     +                                   + C4 * X (M,P4)
     +                                   + C5 * X (M,P5)
     +                                   + C6 * X (M,P6)
     +                                   + C7 * X (M,P7)
                    END DO
                ELSE IF (NI.EQ.8) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    P4 = PLOC (4)
                    P5 = PLOC (5)
                    P6 = PLOC (6)
                    P7 = PLOC (7)
                    P8 = PLOC (8)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    C4 = CC (PCTR (4),R)
                    C5 = CC (PCTR (5),R)
                    C6 = CC (PCTR (6),R)
                    C7 = CC (PCTR (7),R)
                    C8 = CC (PCTR (8),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
     +                                   + C4 * X (M,P4)
     +                                   + C5 * X (M,P5)
     +                                   + C6 * X (M,P6)
     +                                   + C7 * X (M,P7)
     +                                   + C8 * X (M,P8)
                    END DO
                ELSE IF (NI.GT.8) THEN
                    P1 = PLOC (1)
                    P2 = PLOC (2)
                    P3 = PLOC (3)
                    P4 = PLOC (4)
                    P5 = PLOC (5)
                    P6 = PLOC (6)
                    P7 = PLOC (7)
                    P8 = PLOC (8)
                    C1 = CC (PCTR (1),R)
                    C2 = CC (PCTR (2),R)
                    C3 = CC (PCTR (3),R)
                    C4 = CC (PCTR (4),R)
                    C5 = CC (PCTR (5),R)
                    C6 = CC (PCTR (6),R)
                    C7 = CC (PCTR (7),R)
                    C8 = CC (PCTR (8),R)
                    DO M = 1,N
                       Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                   + C2 * X (M,P2)
     +                                   + C3 * X (M,P3)
     +                                   + C4 * X (M,P4)
     +                                   + C5 * X (M,P5)
     +                                   + C6 * X (M,P6)
     +                                   + C7 * X (M,P7)
     +                                   + C8 * X (M,P8)
                    END DO

                    NIBASE = 8
                    NILEFT = NI - 8
                    NISTEP = NILEFT / 8
                    NIREST = MOD (NILEFT,8)

                    DO I = 1,NISTEP
                       P1 = PLOC (NIBASE+1)
                       P2 = PLOC (NIBASE+2)
                       P3 = PLOC (NIBASE+3)
                       P4 = PLOC (NIBASE+4)
                       P5 = PLOC (NIBASE+5)
                       P6 = PLOC (NIBASE+6)
                       P7 = PLOC (NIBASE+7)
                       P8 = PLOC (NIBASE+8)
                       C1 = CC (PCTR (NIBASE+1),R)
                       C2 = CC (PCTR (NIBASE+2),R)
                       C3 = CC (PCTR (NIBASE+3),R)
                       C4 = CC (PCTR (NIBASE+4),R)
                       C5 = CC (PCTR (NIBASE+5),R)
                       C6 = CC (PCTR (NIBASE+6),R)
                       C7 = CC (PCTR (NIBASE+7),R)
                       C8 = CC (PCTR (NIBASE+8),R)
                       DO M = 1,N
                          Y (M,R) = Y (M,R) + C1 * X (M,P1)
     +                                      + C2 * X (M,P2)
     +                                      + C3 * X (M,P3)
     +                                      + C4 * X (M,P4)
     +                                      + C5 * X (M,P5)
     +                                      + C6 * X (M,P6)
     +                                      + C7 * X (M,P7)
     +                                      + C8 * X (M,P8)
                       END DO
                       NIBASE = NIBASE + 8
                    END DO

                    DO I = 1,NIREST
                       P1 = PLOC (NIBASE+I)
                       C1 = CC (PCTR (NIBASE+I),R)
                       DO M = 1,N
                          Y (M,R) = Y (M,R) + C1 * X (M,P1)
                       END DO
                    END DO

                END IF

            END IF

   10    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

Ci  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine optable_loop(optable, noptable, array_table, 
     *                   narray_table,
     *                   array_labels, index_table, nindex_table, 
     *                   segment_table, nsegment_table, block_map_table,
     *                   nblock_map_table, 
     *                   scalar_table, nscalar_table, proctab,
     *                   address_table, 
     *                   debug, validate, comm, comm_timer)
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'server_barrier_data.h'
      include 'scratchpad.h'
      include 'dbugcom.h'
      include 'timerz.h'
      include 'where_table.h'
      include 'context.h'
      include 'checkpoint_data.h'
      include 'pst_functions.h'
      include 'restrict_pardo.h'
      include 'blkmgr.h'

      common /load_balance/load_balance
      logical load_balance

      include 'int_gen_parms.h'
       
      integer noptable, narray_table, nindex_table, nsegment_table
      integer nblock_map_table, nscalar_table
      integer comm
      integer optable(loptable_entry,noptable)
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer proctab(2,*)
      character*10 array_labels(narray_table)
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)
      
      integer ierr
      integer iopsave, iblk
      integer index, result_array, result_type
      integer block_map_entry(lblock_map_entry)
      integer op1_block_map_entry(lblock_map_entry)
      integer op2_block_map_entry(lblock_map_entry)
      integer opcode
      integer tmpop
      integer i, j, k, kstack
      integer instruction_timer

      integer instruction_blk_timer
      integer instruction_mpi_timer
      integer instruction_times_timer
      integer instruction_mpitimes_timer
      integer instruction_unit_timer
      integer instruction_allocate_timer
      integer instruction_total_timer
      integer pardo_tot_timer
      integer pardo_blk_timer

      integer doit

      integer icount, timer_count 

      integer iseg, jseg

      double precision blk_send_time
      double precision timeslice, t1, t2
      double precision t1_heartbeat, heartbeat_time
      double precision t1_blockcount, blockcount_time

      integer flopcount, blk_send_count
      integer comm_timer

      integer stack, need_stack(nblkmgr_stacks)

      logical debug, validate

      character*40 hbmsg

      call mpi_comm_size(mpi_comm_world, nprocs, ierr)
      call mpi_comm_rank(mpi_comm_world, me, ierr)
      call mpi_comm_rank(comm, my_company_rank, ierr)
      call mpi_comm_size(comm, my_company_size, ierr)

      trace = .false.

#ifdef DYNAMIC_LOAD_BALANCE
      load_balance = .true.
#else
      load_balance = .false.
#endif

      call determine_timeslice(timeslice, timer_count)

      iwhere = 0
      nwhere = 0

c--------------------------------------------------------------------------
c   Initialize the server barrier data requests.
c--------------------------------------------------------------------------

      do i = 1, mx_msg
         server_requests(i) = MPI_REQUEST_NULL
      enddo

c--------------------------------------------------------------------------
c   Initialize the array_table status values.
c--------------------------------------------------------------------------

      do i = 1, narray_table
         array_table(c_array_status,i) = 0
      enddo
c--------------------------------------------------------------------------
c   Set the current segments of each index in the index_table to an 
c   undefined value.  If an array is later referenced without having all
c   its indices defined, an error will be triggered.
c--------------------------------------------------------------------------

      do i = 1, nindex_table
         index_table(c_current_seg,i) = undefined_segment
      enddo
      
c--------------------------------------------------------------------------
c   Clear the scratchpad areas.
c--------------------------------------------------------------------------

      do i = 1, mx_scratchpad
         scratchpad(i) = 0
      enddo

      do i = 1, mx_fscratchpad
         fscratchpad(i) = 0.
      enddo

c--------------------------------------------------------------------------
c   Main processing loop.
c--------------------------------------------------------------------------


         call timer_start(timer_optl) !optable timer

         call set_program_context(1, 0, noptable)

         t1 = mpi_wtime()
         t1_heartbeat = t1
         t1_blockcount = t1
         heartbeat_time = 360.0  ! print every 6 minutes
         blockcount_time = 120.0 
         icount = 0

c---------------------------------------------------------------------------
c   Restart from a previous job if necessary.
c---------------------------------------------------------------------------

         call restart(array_table, narray_table,
     *                index_table,
     *                nindex_table, segment_table, nsegment_table,
     *                block_map_table, nblock_map_table,
     *                scalar_table, nscalar_table,
     *                address_table, optable(1,iop))

 1000    continue


            opcode = optable(c_opcode, iop)

            iopsave = iop
            current_op = iop  ! save operation pointer for debugging  purposes.
            current_line = optable(c_lineno,iop)

            
            call timer_start(timer_ovrhead)

c            if (trace .and. 
c     *          and(tracelevel, instruction_trace) .ne. 0) then
c               print *,'Task ',me,' Perform op = ',(optable(k,iop),
c     *           k=1,loptable_entry),' segments: ',
c     *            (index_table(c_current_seg,k),k=1,nindex_table),
c     *            ' start_op, end_op = ',start_op,end_op,' iop = ',
c     *            iop,' line ',optable(c_lineno,iop)
c            endif

            if (opcode .eq. call_op) then
               call handle_call(optable, noptable, proctab, debug,
     *                start_op, end_op, iop)
            else if (opcode .eq. return_op) then
               call handle_return(optable, noptable, debug,
     *                start_op, end_op, iop)
            else if (opcode .eq. go_to_op .or.
     *               opcode .eq. jz_op) then
               call handle_goto(optable, noptable, debug,
     *                start_op, end_op, iop)
            else if (opcode .eq. do_op .or.
     *               opcode .eq. enddo_op) then
               call doloop(optable, noptable, iop, index_table, 
     *                  nindex_table, array_table, narray_table,
     *                  block_map_table, segment_table,
     *                  nsegment_table, 
     *                  debug, .false.,
     *                  start_op, end_op)
            else if (opcode .eq. pardo_op .or.
     *               opcode .eq. endpardo_op) then
              

c---------------------------------------------------------------------------
c   Reset Pardo Restriction at the end of the pardo
c   Initialize (or shutdown) the timers at the beginning or end of
c   pardos.
c---------------------------------------------------------------------------
                 if (opcode .eq. endpardo_op) then
                    
                   call reset_do_prestrict() 

                   if (do_timer) then
                      call update_timer(pardo_act_timer)
#ifdef DETAILED_TIMERS                      
                      call update_timer(pardo_times_timer)
#endif                      
                      pardo_act_timer = 0
                      pardo_tserver_timer = 0
                      pardo_times_timer = 0
                   endif
                 endif
           
                tmpop = iop                
                if (do_timer) then
                 if (opcode .eq. pardo_op) then
                  call unpack_pardo_timer(optable(c_instr_timer,tmpop),
     *                   pardo_tot_timer, pardo_blk_timer)
                    if (pardo_tot_timer .ne. 0) then
c Some of these timers are used inside pardo_loop and pardo_loadb                      
                     pardo_act_timer = pardo_blk_timer + 1
                     pardo_ovrhead_timer = pardo_blk_timer + 2
                     pardo_times_timer = pardo_blk_timer + 3
                     pardo_tserver_timer = pardo_blk_timer + 4
                    endif
                   endif 
                endif
c---------------------------------------------------------------------------
c    Make sure the pardo starts out with enough blocks to work with 
c---------------------------------------------------------------------------

c---------------------------------------------------------------------------
c    Determine how many blocks are needed on eack stack for the given
c    pardo. 
c---------------------------------------------------------------------------
        go to 33 
               if (opcode .eq. pardo_op) then 
         do j = 1, 171
            stack  = array_table(c_array_stack, j)
            write(6,*) j, stack
         enddo
         STOP

               endif  

               if (opcode .eq. pardo_op) 
     *         call find_min_stack_op_pardo(optable, noptable,
     *                   array_table,
     *                   narray_table,
     *                   array_labels, index_table, nindex_table,
     *                   segment_table, nsegment_table, block_map_table,
     *                   nblock_map_table,
     *                   scalar_table, nscalar_table, proctab,
     *                   address_table,
     *                   iopsave, need_stack, nblkmgr_stacks)

c---------------------------------------------------------------------------
c    Count and scrub ALL the scrubbable blocks   
c---------------------------------------------------------------------------

             do kstack = 1, nblkmgr_stacks ! number of nstacks  
                       call count_scrubbable(kstack, array_table,
     *                 narray_table, index_table, nindex_table, 
     *                 block_map_table)
             enddo 

c---------------------------------------------------------------------------
c    Count and remove ALL the persistant blocks   
c---------------------------------------------------------------------------

             do kstack = 1, nblkmgr_stacks ! number of nstacks  
                 call reclaim_persistent_blocks_from_stack(kstack,
     *           array_table,narray_table, index_table, nindex_table,
     *           block_map_table)
             enddo 

c---------------------------------------------------------------------------
c    Perform the check and free blocks if needed 
c---------------------------------------------------------------------------

c           if (pst_get_company(me) .ne. io_company_id) then
c              call check_stack_pop(array_table, narray_table,
c    *                     index_table, nindex_table, block_map_table)
c           endif 

33          continue 

                 if (load_balance) then
                  call pardo_loadb(optable, noptable, iop, index_table,
     *                  nindex_table, array_table, narray_table,
     *                  block_map_table, segment_table,
     *                  nsegment_table,
     *                  comm, debug, .false.,
     *                  start_op, end_op)
                 else
                  call pardo_loop(optable, noptable, iop, index_table,
     *                  nindex_table, array_table, narray_table,
     *                  block_map_table, 
     *                  segment_table, nsegment_table,
     *                  comm, debug, .false.,
     *                  start_op, end_op)
                 endif
                
                 if (do_timer) then 
                   pardo_ovrhead_timer = 0 
                 endif

c---------------------------------------------------------------------------
c   Record time for stuff done in pardo
c---------------------------------------------------------------------------
             if (do_timer) then
                 if (opcode .eq. pardo_op) then
c Get rid of these, if the program works                   
c                  call unpack_pardo_timer(optable(c_instr_timer,tmpop),
c     *                     pardo_tot_timer, pardo_blk_timer)
c                  if (pardo_tot_timer .ne. 0) then
c                    pardo_act_timer = pardo_blk_timer + 1
c                    pardo_ovrhead_timer = pardo_blk_timer + 2
c                    pardo_times_timer = pardo_blk_timer + 3
c                    pardo_tserver_timer = pardo_blk_timer + 4
c                  endif

                    call timer_start(pardo_act_timer)
                  
#ifdef DETAILED_TIMERS
                    call timer_start(pardo_times_timer)
#endif                  

                  endif
               endif

            else if (opcode .eq. exit_op) then
               call handle_exit(optable, noptable, debug,
     *                array_table, narray_table,
     *                index_table, nindex_table, 
     *                block_map_table,    
     *                start_op, end_op, iop)

            else if (opcode .eq. cycle_op) then
               call handle_cycle(optable, noptable, debug,
     *                start_op, end_op, iop)
            endif

            call update_timer(timer_ovrhead)

            if (iop .gt. noptable) go to 2000
            if (iopsave .ne. iop) then
               go to 1000
            endif

            if (iop .lt. start_op .or.
     *          iop .gt. end_op) then 
                go to 900 
            endif

            current_op = iop  ! save operation pointer for debugging  purposes.
            current_line = optable(c_lineno,iop)

c---------------------------------------------------------------------------
c   Perform the operation.
c---------------------------------------------------------------------------

               t2 = mpi_wtime()

c           if (t2-t1_blockcount .gt. blockcount_time) then
c           if (pst_get_company(me) .ne. io_company_id) then 

c---------------------------------------------------------------------------
c   Check stack populations every t1_blockcount seconds . 
c---------------------------------------------------------------------------

c           if (me .eq. 0) 
c    *      write(6,*) 'Checking stack population at line:',
c    *                  current_line, 'on proc', me   
c                       call check_stack_pop(array_table, narray_table, 
c    *                       index_table, nindex_table, block_map_table)

c           endif 
c                 t1_blockcount = t2 
c           endif 

               if (t2-t1_heartbeat .gt. heartbeat_time) then
                  if (me .eq. 0) then
                     write (hbmsg, 2100) current_line
                     dbg = .true.
                     call prt_time(hbmsg)
                     dbg = .false.
                  endif
                  t1_heartbeat = t2 
               endif

               call update_timer(pardo_act_timer)
#ifdef VERY_DETAILED_TIMERS               
               call timer_start(pardo_tserver_timer)
#endif
               call timer_start(timer_ovrhead)
               call exec_thread_server(0)
               call update_timer(timer_ovrhead) 
#ifdef VERY_DETAILED_TIMERS               
               call update_timer(pardo_tserver_timer) 
#endif               
               call timer_start(pardo_act_timer)

                  t1 = mpi_wtime()   ! reset timer


            if (trace) then
               print *,'Task ',me,' line ',current_line,' iop ',
     *                 iop,' opcode = ',optable(c_opcode, iop)
               call c_flush_stdout()
            endif

            instruction_timer = 0
            instruction_blk_timer = 0
            instruction_mpi_timer = 0
            instruction_times_timer = 0
            instruction_mpitimes_timer = 0
            instruction_unit_timer = 0
            instruction_allocate_timer = 0
            instruction_total_timer = 0
            current_instr_timer = 0
            current_instr_blk_timer = 0
            current_instr_mpi_timer = 0
            current_instr_mpino_timer = 0
            current_instr_unit_timer = 0
            current_instr_allocate_timer = 0

            if (do_timer) then
               if (optable(c_opcode,iop) .ne. pardo_op) then
                  instruction_timer = optable(c_instr_timer,iop)
                  
                  if (instruction_timer .ne. 0) then
c  Neccesarry timers                    
                    instruction_blk_timer = instruction_timer + 1
                    instruction_times_timer = instruction_timer + 2
                    instruction_unit_timer = instruction_timer + 3
c Detailed timers
                    instruction_allocate_timer = instruction_timer + 4
c Very Detailed timers                    
                    instruction_mpi_timer = instruction_timer + 5
                    instruction_mpitimes_timer = 
     *                               instruction_timer + 6
                    instruction_total_timer = instruction_timer + 7
c Assigned to timers shared via a common block
                    current_instr_timer = instruction_timer
                    current_instr_blk_timer = instruction_blk_timer
                    current_instr_mpi_timer = instruction_mpi_timer
                    current_instr_mpino_timer = 
     *                                   instruction_mpitimes_timer
                    current_instr_unit_timer = instruction_unit_timer
                    current_instr_allocate_timer = 
     *                                      instruction_allocate_timer
                    current_instr_total_timer = 
     *                                      instruction_total_timer 

                  endif
#ifdef VERY_DETAILED_TIMERS
                  call timer_start(instruction_total_timer)
#endif                  
                  call timer_start(instruction_timer)
                  call timer_start(instruction_times_timer)
                  call timer_start(instruction_unit_timer)
               endif
            endif


	    call compute_block(optable(1,iop), array_table, 
     *                narray_table, index_table, nindex_table, 
     *                block_map_table, nblock_map_table,
     *                segment_table, nsegment_table,
     *                scalar_table, nscalar_table, address_table,
     *                debug, validate, 
     *                flopcount, comm, comm_timer, 
     *                instruction_timer)


             if (do_timer) then
                if (optable(c_opcode,iop) .ne. pardo_op) then
                    call update_timer(instruction_timer)
                    call update_timer(instruction_times_timer)
                    call update_timer(instruction_unit_timer)
#ifdef VERY_DETAILED_TIMERS
                    call update_timer(instruction_total_timer)
#endif
                    current_instr_timer = 0
                    current_instr_blk_timer = 0
                    current_instr_mpi_timer = 0
                    current_instr_mpino_timer = 0
                    current_instr_unit_timer = 0
                    current_instr_allocate_timer = 0
                    current_instr_total_timer = 0
                    instruction_times_timer = 0
                    instruction_timer=0
                    instruction_unit_timer=0
                    instruction_allocate_timer=0
                    instruction_total_timer=0
                endif
             endif 
  900    continue
         iop = iop + 1 
c            print *,'AT 900: iop, start_op, end_op = ',
c     *         iop, start_op, end_op
         if (start_op .ne. 0 .or. iop .le. noptable) then
            if (iop .gt. end_op)  iop = start_op
c            print *,'   BRANCH TO iop = ',iop
            if (iop .le. 0 .or. iop .gt. noptable) then
               print *,'ERROR: iop out of range: iop = ',iop
               call abort_job()
            endif
            go to 1000
         endif
         
 2000    continue
     
       
      call update_timer(timer_optl) ! Optable timer
     
      if (dbg) print *,'Processing of table is complete...'
      call server_takedown(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, optable )
      return
 2100 format('Heartbeat: line ',i6)
      end


      subroutine reset_do_prestrict()
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'pst_functions.h'
      include 'int_gen_parms.h'
      include 'restrict_pardo.h'

      integer i
 
      do i = 1, nprocs
          if (pst_get_company(i-1) .eq. io_company_id) then
              do_prestrict(i) = 0
          else
              do_prestrict(i) = 1
          endif
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_where_conditionals(optable, start_op, end_op)
c---------------------------------------------------------------------------
c   Add any "where" conditions within the loop structure to the where_table.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'where_table.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer start_op, end_op
      integer optable(loptable_entry, *)
      integer i, j, iwhere_save
 
c----------------------------------------------------------------------------
c   Search the instruction table for WHERE or ENDDO or ENDPARDO.
c   Also check for DO or PARDO to account for nested loops.
c----------------------------------------------------------------------------

      iwhere_save = nwhere 
      do i = start_op+1, end_op
         if (optable(c_opcode, i) .eq. do_op .or.
     *       optable(c_opcode, i) .eq. enddo_op .or.
     *       optable(c_opcode, i) .eq. pardo_op .or.
     *       optable(c_opcode, i) .eq. endpardo_op .or.
     *       optable(c_opcode, i) .eq. do_op) go to 100

         if (optable(c_opcode, i) .eq. where_op) then
            
c-----------------------------------------------------------------------------
c   Add the WHERE condition to the table.
c-----------------------------------------------------------------------------

            if (nwhere .eq. max_where_table) then
               print *,'Error: Too many where conditionals at line ',
     *                 current_line
               print *,'nwhere ',nwhere,' max_where_table ',
     *              max_where_table
               print *,' iwhere ',iwhere 
               print *,'where_table: '
               do j = 1, max_where_table
                  print *,where_table(j,c_where_ind1),
     *                     where_table(j,c_where_cond),
     *                     where_table(j,c_where_ind2)     
               enddo  
     
               call abort_job()
            endif

            nwhere = nwhere + 1
            where_table(nwhere,c_where_ind1) = optable(c_op1_array,i)
            where_table(nwhere,c_where_cond) = optable(c_op2_array,i)
            where_table(nwhere,c_where_ind2) = optable(c_result_array,i)
         endif
      enddo

c----------------------------------------------------------------------------
c   If we have added entries, pick up the beginning index so we can roll 
c   back at the end of the loop.
c----------------------------------------------------------------------------

  100 continue
      if (iwhere_save .ne. nwhere) iwhere = iwhere_save + 1
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE GEOMOUT
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
#include "io_units.par"
C
      WRITE(LuOut,80)
 80   FORMAT('         -----------------------------------------------'
     &,/,3x,'      Cartesian coordinates corresponding to internal '
     &,/,3x,      '              coordinate input (Angstroms) ')
      CALL DUMPCORD(NATOMS,Q,IATNUM)
c     &,/,3x,      '              coordinate input (Bohr) ',/
c     &,'      ------------------------------------------------------ ',/
c     &,'       Atomic                               ',/
c     &,'       Symbol            X             Y             Z ' )
c      WRITE(LuOut,*)
c     $ '       ------------------------------------------------------ '
C      DO 20 I=1,NX-2,3
C      WRITE(LuOut,90)ZSYM((I/3)+1),Q(I),Q(I+1),Q(I+2)
C90    FORMAT(9X,A,T18,3(F12.7,2X))
C  20  CONTINUE
C      WRITE(LuOut,*)
c     $ '       ------------------------------------------------------ '
c      WRITE(LuOut,*)' '
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine build_proctab(optable, noptable, proctab, nproctab)
c---------------------------------------------------------------------------
c   Builds entries for proctab (table used in proc calls.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'

      integer i, j, target, opcode, last
      integer noptable, nproctab
      integer optable(loptable_entry,noptable)
      integer proctab(2,*)

c---------------------------------------------------------------------------
c   First instruction is a jump past the procs.  This is used as the last 
c   range.
c---------------------------------------------------------------------------

      opcode = optable(c_opcode, 1)
      if (opcode .ne. go_to_op) return       ! no procs

      last = optable(c_result_array,1) - 1   ! jump target address.
      if (last .eq. 1) return                ! no procs 

c--------------------------------------------------------------------------
c   Procs are present.  Create an entry for each unique call.
c--------------------------------------------------------------------------
 
      nproctab = 0
      do i = 1, noptable
         if (optable(c_opcode,i) .eq. call_op) then
            target = optable(c_result_array,i)
     
c----------------------------------------------------------------------------
c   Search for previous entry with this target.
c----------------------------------------------------------------------------

            do j = 1, nproctab
               if (proctab(1,j) .eq. target) go to 100
            enddo

c--------------------------------------------------------------------------
c   This is a call to a new proc.  Add it to the proctab.
c--------------------------------------------------------------------------

            nproctab = nproctab + 1
            proctab(1,nproctab) = target
            proctab(2,nproctab)   = last
  100       continue
         endif
      enddo

      return
      end

      SUBROUTINE DCHECK(RREF,RVEC,ISIZE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RVEC(ISIZE),RREF(ISIZE)
      PI=DACOS(-1.D0)
      DO 55 I=6,ISIZE,3
       IF(DABS(RVEC(I)).GT.3.D0)THEN
        IF(SIGN(1.D0,RVEC(I)).NE.SIGN(1.D0,RREF(I)))
     &  RVEC(I)=SIGN(1.D0,RREF(I))*(2.D0*PI-DABS(RVEC(I)))
       ENDIF
 55   CONTINUE
      RETURN
      END

c This routine retrieves the transpose of a lower-left rectangular submatrix
c of an MOIO array. For a stored matrix dList(1:nRows,1:nCols) and given
c boundaries iRow and iCol, the output would be dDest(1:iCol,iRow:nRows).

c INPUT
c double DSCR(*) : scratch array to hold at least one column of the MOIO array
c int IROW   : first row    in the submatrix (column in the transpose)
c int ICOL   : last  column in the submatrix (row    in the transpose)
c int IJUNK  : (obsolete integer)
c int ILEFT  : the left  MOIO index
c int IRIGHT : the right MOIO index

c OUTPUT
c double DDEST(*) : the destination array for the transpose

      subroutine gettrn2(dDest,dScr,iRow,iCol,iJunk,iLeft,iRight)
      implicit none

c ARGUMENTS
      integer iRow, iCol, iJunk, iLeft, iRight
      double precision dDest(iCol,*), dScr(*)

c EXTERNAL FUNCTIONS
      integer aces_list_rows, aces_list_cols

c INTERNAL VARIABLES
      integer nRows, i, iTmp

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert dimensions are properly bound (zero cols returns)
      if ((iRow.lt.1).or.(iRow.gt.aces_list_rows(iLeft,iRight)).or.
     &    (iCol.lt.0).or.(iCol.gt.aces_list_cols(iLeft,iRight))
     &   ) then
         print *, '@GETTRN2: Assertion failed.'
         print *, '   MOIO list = ',iLeft,iRight
         print *, '   MOIO rows = ',aces_list_rows(iLeft,iRight)
         print *, '   MOIO cols = ',aces_list_cols(iLeft,iRight)
         print *, '   iRow = ',iRow
         print *, '   iCol = ',iCol
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif

c ----------------------------------------------------------------------

      nRows = aces_list_rows(iLeft,iRight)
      if ((iRow.gt.nRows).or.(iCol.lt.1)) return
      if (iRow.lt.1) then
         print *, '@GETTRN2: ERROR - the valid row domain is [ 1,',
     &                                                         nRows,']'
         print *, '   MOIO list = ',iLeft,iRight
         print *, '   MOIO rows = ',aces_list_rows(iLeft,iRight)
         print *, '   MOIO cols = ',aces_list_cols(iLeft,iRight)
         print *, '   iRow = ',iRow
         print *, '   iCol = ',iCol
         call aces_exit(1)
      end if

      iTmp = nRows+1-iRow
      do i = 1, iCol
         call getlst(dScr,i,1,0,iLeft,iRight)
         call dcopy(iTmp,dScr(iRow),1,dDest(i,1),iCol)
      end do

      return
c     end subroutine gettrn
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__C_EQ_ORTHOTRAN_DIAG
     +
     +                    ( DDROWA,DDCOLA,
     +                      DDROWB,DDCOLB,
     +                      DDROWC,DDCOLC,
     +                      DDWORK,
     +                      ROW,SUM,
     +                      ROWOFF,
     +                      SAVEB,LTRG,UTRG,
     +                      A,B,
     +
     +                              WORK,
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : MAT__C_EQ_ORTHOTRAN_DIAG
C  MODULE      : Matrix
C  MODULE-ID   : MAT
C  DESCRIPTION : This routine generates a diagonal block of the
C                orthogonally transformed matrix B:
C
C                              C = A(T) * B * A
C
C                for which we can write for each element:
C
C                          C(ij)  =  sum  A(ki) * B(kl) * A(lj)
C                                     kl
C
C                where the index ranges are:
C
C                           i index    ->   1 to ROW
C                           j index    ->   1 to ROW
C                         k=l indices  ->   1 to SUM
C
C
C                There are two possible paths the routine can take:
C
C
C                   i) If SAVEB = .false. is passed, the original B
C                      matrix can be overwritten. Note, that this is
C                      only possible, if DDCOLB >= ROW, because only
C                      then can the intermediate product B*A be copied
C                      to B. This option is provided at the moment
C                      for those cases in which the full product
C                      result is wanted and B can be wasted, as then
C                      we can invoke efficient full matrix multiply
C                      routines. Hence if at all possible, especially
C                      for large ROW and SUM values, try to use this
C                      case. Note also that here one does not need
C                      the working array WORK.
C
C                  ii) If SAVEB = .true. is passed, we have to save
C                      the original B matrix. This path is chosen
C                      whenever B contains data that should not be
C                      destroyed or any subset of the result is
C                      wanted (lower/upper triangle or only diagonals).
C
C
C                There is the option of placing the resulting square
C                matrix inside the transmitted C array. The final
C                transformed ROW x ROW matrix can be placed starting at
C                a specified row index with offset ROWOFF. Pictorially
C                this looks as follows inside the C array:
C
C
C                                   1          ROW
C
C                                    -----------
C                                   |           |
C                                   |           |
C                                   |           |
C                  ROWOFF + 1   ->  |-----------|
C                                   |/ / / / / /|
C                                   |/ / / / / /|
C                                   |/ C block /|
C                                   |/ / / / / /|
C                                   |/ / / / / /|
C                  ROWOFF + ROW ->  |-----------|
C                                   |           |
C                                   |           |
C                                   |           |
C                                    -----------
C
C
C                If for some reason one wants the C block to start at
C                the first row, simply pass ROWOFF = 0 in the argument.
C                Since the C matrix has to accomodate the intermediate
C                B*A result and the final ROW x ROW result at the
C                appropriate row index, the dimension requirements
C                for the C matrix are:
C
C                           MAX0 (SUM,ROW+ROWOFF) x ROW
C
C                If LTRG / UTRG are set true or false, the following
C                actions are being taken:
C
C
C                        LTRG | UTRG |    return on exit
C                      ------------------------------------------
C                          T  |   T  |        full matrix
C                          T  |   F  |  lower triangle of matrix
C                          F  |   T  |  upper triangle of matrix
C                          F  |   F  |      diagonal of matrix
C
C
C                In case only the diagonal part of the result is
C                wanted, the ROW elements will be placed directly
C                into the working array, hence WORK will contain
C                the desired result.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     SAVEB,LTRG,UTRG

         INTEGER     DDROWA,DDCOLA
         INTEGER     DDROWB,DDCOLB
         INTEGER     DDROWC,DDCOLC
         INTEGER     DDWORK
         INTEGER     I,J,K
         INTEGER     ROW,SUM
         INTEGER     ROWOFF

         DOUBLE PRECISION  X,ZERO

         DOUBLE PRECISION  WORK (1:DDWORK)

         DOUBLE PRECISION  A (1:DDROWA,1:DDCOLA)
         DOUBLE PRECISION  B (1:DDROWB,1:DDCOLB)
         DOUBLE PRECISION  C (1:DDROWC,1:DDCOLC)

         PARAMETER  (ZERO = 0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions for matrix B.
C
C
         IF  (SUM.GT.DDROWB .OR. SUM.GT.DDCOLB) THEN
              WRITE (*,*) ' Dimensions of matrix B too small! '
              WRITE (*,*) ' mat__c_eq_orthotran_diag '
              WRITE (*,*) ' DDROWB,DDCOLB,SUM = ',DDROWB,DDCOLB,SUM
              WRITE (1,*) ' Dimensions of matrix B too small! '
              WRITE (1,*) ' mat__c_eq_orthotran_diag '
              WRITE (1,*) ' DDROWB,DDCOLB,SUM = ',DDROWB,DDCOLB,SUM
              STOP
         END IF

         IF  (.NOT.SAVEB .AND. LTRG .AND. UTRG) THEN
              IF (ROW.GT.DDCOLB) THEN
                  WRITE (*,*) ' Cannot store B*A product into B! '
                  WRITE (*,*) ' mat__c_eq_orthotran_diag '
                  WRITE (*,*) ' DDCOLB,ROW = ',DDCOLB,ROW
                  WRITE (1,*) ' Cannot store B*A product into B! '
                  WRITE (1,*) ' mat__c_eq_orthotran_diag '
                  WRITE (1,*) ' DDCOLB,ROW = ',DDCOLB,ROW
                  STOP
              END IF
         END IF
C
C
C             ...check dimensions for matrix A.
C
C
         IF  (SUM.GT.DDROWA .OR. ROW.GT.DDCOLA) THEN
              WRITE (*,*) ' Dimensions of matrix A too small! '
              WRITE (*,*) ' mat__c_eq_orthotran_diag '
              WRITE (*,*) ' DDROWA,DDCOLA,ROW,SUM = ',
     +                      DDROWA,DDCOLA,ROW,SUM
              WRITE (1,*) ' Dimensions of matrix A too small! '
              WRITE (1,*) ' mat__c_eq_orthotran_diag '
              WRITE (1,*) ' DDROWA,DDCOLA,ROW,SUM = ',
     +                      DDROWA,DDCOLA,ROW,SUM
              STOP
         END IF
C
C
C             ...check dimensions for matrix C.
C
C
         IF  (MAX0 (SUM,ROW+ROWOFF).GT.DDROWC .OR. ROW.GT.DDCOLC) THEN
              WRITE (*,*) ' Dimensions of matrix C too small! '
              WRITE (*,*) ' mat__c_eq_orthotran_diag '
              WRITE (*,*) ' DDROWC,DDCOLC,ROW,ROWOFF,SUM = ',
     +                      DDROWC,DDCOLC,ROW,ROWOFF,SUM
              WRITE (1,*) ' Dimensions of matrix C too small! '
              WRITE (1,*) ' mat__c_eq_orthotran_diag '
              WRITE (1,*) ' DDROWC,DDCOLC,ROW,ROWOFF,SUM = ',
     +                      DDROWC,DDCOLC,ROW,ROWOFF,SUM
              STOP
         END IF
C
C
C             ...check dimensions for working array WORK (if needed).
C
C
         IF  (SAVEB .OR. (.NOT.LTRG) .OR. (.NOT.UTRG)) THEN
              IF  (ROW.GT.DDWORK) THEN
                   WRITE (*,*) ' Dimensions of array WORK too small! '
                   WRITE (*,*) ' mat__c_eq_orthotran_diag '
                   WRITE (*,*) ' DDWORK,ROW = ',DDWORK,ROW
                   WRITE (1,*) ' Dimensions of array WORK too small! '
                   WRITE (1,*) ' mat__c_eq_orthotran_diag '
                   WRITE (1,*) ' DDWORK,ROW = ',DDWORK,ROW
                   STOP
              END IF
         END IF
C
C
C             ...perform intermediate multiplication B * A for all
C                cases and store result in C.
C
C
         CALL    MAT__C_EQ_A_TIMES_B_FLOAT
     +
     +                ( DDROWB,DDCOLB,
     +                  DDROWA,DDCOLA,
     +                  DDROWC,DDCOLC,
     +                  SUM,SUM,ROW,
     +                  B,A,
     +
     +                          C )
     +
     +
         IF (LTRG.AND.UTRG) THEN

             IF (.NOT.SAVEB) THEN
C
C
C             ...copy intermediate result B*A sitting in C to B
C                and calculate full product A(T)*B*A.
C
C
                 CALL    MAT__C_EQ_A_FLOAT
     +
     +                        ( DDROWC,DDCOLC,
     +                          DDROWB,DDCOLB,
     +                          SUM,ROW,
     +                          C,
     +
     +                                  B )
     +
     +
                 CALL    MAT__C_EQ_AT_TIMES_B_FLOAT
     +
     +                        ( DDROWA,DDCOLA,
     +                          DDROWB,DDCOLB,
     +                          DDROWC,DDCOLC,
     +                          ROW,SUM,ROW,
     +                          A,B,
     +
     +                                  C )
     +
     +
                 IF (ROWOFF.NE.0) THEN
                     DO J = 1,ROW
                     DO I = 1,ROW
                        C (ROWOFF+I,J) = C (I,J)
                     END DO
                     END DO
                 END IF
             ELSE
C
C
C             ...calculate full product A(T)*B*A directly into C.
C
C
                 DO J = 1,ROW
                    DO I = 1,ROW
                       X = ZERO
                       DO K = 1,SUM
                          X = X + A (K,I) * C (K,J)
                       END DO
                       WORK (I) = X
                    END DO
                    DO I = 1,ROW
                       C (ROWOFF+I,J) = WORK (I)
                    END DO
                 END DO
             END IF

         ELSE IF (LTRG) THEN
C
C
C             ...calculate lower triangle of product A(T)*B*A directly
C                into C.
C
C
             DO J = 1,ROW
                DO I = J,ROW
                   X = ZERO
                   DO K = 1,SUM
                      X = X + A (K,I) * C (K,J)
                   END DO
                   WORK (I) = X
                END DO
                DO I = J,ROW
                   C (ROWOFF+I,J) = WORK (I)
                END DO
             END DO

         ELSE IF (UTRG) THEN
C
C
C             ...calculate upper triangle of product A(T)*B*A directly
C                into C.
C
C
             DO J = 1,ROW
                DO I = 1,J
                   X = ZERO
                   DO K = 1,SUM
                      X = X + A (K,I) * C (K,J)
                   END DO
                   WORK (I) = X
                END DO
                DO I = 1,J
                   C (ROWOFF+I,J) = WORK (I)
                END DO
             END DO

         ELSE
C
C
C             ...calculate diagonal of product A(T)*B*A and place
C                result into WORK.
C
C
             DO I = 1,ROW
                X = ZERO
                DO K = 1,SUM
                   X = X + A (K,I) * C (K,I)
                END DO
                WORK (I) = X
             END DO

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE MTRANSP(A,AT,NR,NC,NTR,NTC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NR,NC),AT(NC,NR)
      DO I=1,NTR
      DO J=1,NTC
         AT(J,I)=A(I,J)
      END DO
      END DO
      RETURN
      END

c This routine checks to see if any invalid keywords are left in line.

      subroutine nl_term
      implicit none
#include "namelist.com"
#include "callstack.com"
      integer i
      callstack_prev=callstack_curr
      callstack_curr='NL_TERM'
      if (prt_nl) call nl_prtbot
      if (nlnumline.ne.0) then
         write(*,*) '@NL_TERM: invalid namelist entries'
         write(*,*) '  Errors somewhere around '
         write(*,*)
         do i = 1, nlnumline
            write(*,*) nltext(i)
         end do
         call errex
      end if
      callstack_curr=callstack_prev
      return
      end

c This routine checks to see if any invalid keywords are left in line.

      subroutine nl_term
      implicit none


c This common block contains information about a namelist which is being
c parsed.

c   nlmaxline   : the maximum number of lines which can be in the namelist
c   nllinelen   : the maximum length of each line

c   nlnumline   : the number of lines in the namelist (blank lines are
c                 removed)
c   nltext      : the text in the namelist
c   prt_nl      : a logical which is read in from the namelist to see
c                 if the values read in are printed or not
c
      integer nlmaxline, nllinelen
      parameter(nlmaxline=64)
      parameter(nllinelen=132)

      character*(nllinelen) nltext(nlmaxline)
      integer nlnumline
      logical prt_nl

      common /namelistc/ nltext
      common /namelist/  nlnumline
      common /namelistl/ prt_nl
      save /namelist/
      save /namelistc/
      save /namelistl/




c This contains the global string for identifying the current subroutine
c or function (provided the programmer set it).  cf. tools/callstack.F
c BE GOOD AND RESET CURR ON EXIT!

      character*64                callstack_curr,callstack_prev
      common /callstack_curr_com/ callstack_curr,callstack_prev
      save   /callstack_curr_com/


      integer i
      callstack_prev=callstack_curr
      callstack_curr='NL_TERM'
      if (prt_nl) call nl_prtbot
      if (nlnumline.ne.0) then
         write(*,*) '@NL_TERM: invalid namelist entries'
         write(*,*) '  Errors somewhere around '
         write(*,*)
         do i = 1, nlnumline
            write(*,*) nltext(i)
         end do
         call errex
      end if
      callstack_curr=callstack_prev
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine read_density(watom,
     *                 scr, maxblk, iscr, coords, coeffs, alphas,
     *                 ccbeg, ccend,
     *                 nc1,nc2, nd1, nd2,
     *                 nai, kin, ovl,
     *                 fa,fb)
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'parallel_info.h'

      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, n, m, r, s
      integer a,b,c,d
      integer iatom, n_basis
      double precision watom

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst
      integer ierr
      integer nc1, nc2, nd1, nd2

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision nai(nc1:nc2,nd1:nd2)
      double precision kin(nc1:nc2,nd1:nd2)
      double precision ovl(nc1:nc2,nd1:nd2)
      double precision H0T(nc1:nc2,nd1:nd2)

      double precision ca(nc1:nc2,nc1:nc2)
      double precision cb(nc1:nc2,nc1:nc2)

      double precision fa(nc1:nc2,nc1:nc2)
      double precision fb(nc1:nc2,nc1:nc2)
      integer map(nc1:nc2)
      integer umap(nc1:nc2)
      integer beg_anfps(max_shells)
      integer end_anfps(max_shells)
      double precision scr(*)
      integer iscr(*)

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      integer*8 ccbeg_pack64(max_dim_coeff), ccend_pack64(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff),
     *                 pcoeff_pack(max_dim_coeff)
      integer*8 arg64(25)
      integer n_max, natoms
      logical aExist, bExist, breturn
      integer Ierror

      common /Imax_com/sz_max(max_shells,max_shells), delta
      double precision sz_max, delta
      double precision itol, bmax, dtemp, emax

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

      common /orbread/breturn

      save alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack,
     *     ccbeg_pack64, ccend_pack64

      open(66,file='summary.out')

c     call mpi_comm_rank(mpi_comm_world, me, ierr)

      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical

c-----------------------------------------------------------------------
c   Check if a guess file exists. If yes READ the orbitals, 
c   construct the density and finish.  
c-----------------------------------------------------------------------

      if (breturn) return

      nbasis = nalpha_occupied + nalpha_virtual
101   Format(5x,'Something wring with read orbitals. N read N correct',
     *       2I8)

      INQUIRE(file='ca.data',exist=aExist)
      INQUIRE(file='cb.data',exist=bExist)

      if (aexist .and. me .ne. 0) return
      if (bexist .and. me .ne. 0) return

      if (aexist) then
      if (bexist) then
      else

         if (me .eq. 0 .and. .not. breturn) then
            OPEN (135, File = 'ca.data',
     *            Status = 'Old', Iostat = Ierror)

            rewind 135
            read(135,*) n_basis
            write(66,*) ' Reading alpha orbitals'
                        if (n_basis .ne. nbasis)
     *                  write(66,101) n_basis, nbasis
            do a = 1, n_basis
            do b = 1, n_basis
               read(135,*) ca(a,b)
               cb(a,b) = ca(a,b)
            enddo
            enddo

            close (135)

            write(66,*) ' Computing the RHF HF density'
            call hfdensity(ca,cb,FA,FB,nbasis,nalpha_occupied,
     *                     nbeta_occupied)
            breturn = .true.
            watom   = 1.0
            return

         endif

      endif ! aexist  
      endif ! bexist 

      if (aexist .and. bexist) then

         if (me .eq. 0 .and. .not. breturn) then
            OPEN (135, File = 'ca.data',
     *            Status = 'Old', Iostat = Ierror)

            rewind 135
            read(135,*) n_basis
            write(66,*) ' Reading alpha orbitals'
                        if (n_basis .ne. nbasis)
     *                  write(66,101) n_basis, nbasis
            do a = 1, n_basis
            do b = 1, n_basis
               read(135,*) ca(a,b)
            enddo
            enddo

            close (135)
            OPEN (357, File = 'cb.data',
     *            Status = 'Old', Iostat = Ierror)

            rewind 357
            read(357,*) n_basis
            write(66,*) ' Reading beta orbitals'
                        if (n_basis .ne. nbasis)
     *                  write(66,101) n_basis, nbasis
            do a = 1, n_basis
            do b = 1, n_basis
               read(357,*) cb(a,b)
            enddo
            enddo
            close(357)

            write(66,*) ' Computing the UHF density'
            call hfdensity(ca,cb,FA,FB,nbasis,nalpha_occupied,
     *                     nbeta_occupied)
            breturn = .true.
            watom   = 1.0
            return

         endif

      endif ! aexist and bexist 

      if (breturn) return
c-----------------------------------------------------------------------
c   Done initial guess from file  
c-----------------------------------------------------------------------

      end

c This routine is the common exit handler for ACES.

      subroutine aces_exit(iStat)
      implicit none
      integer iStat, iErr
#include "mpif.h"
#include "parallel_aces.com"
      if (irank.eq.0) then
         if (iStat.eq.0) then
            print *,
     &          'The ACES Member Executable has completed successfully.'
         else
            print *, '@ACES_EXIT: An ACES error has occurred.'
            print *, '            return status = ',iStat
         end if
      end if
      if (nprocs.eq.1) then
#ifdef _UNICOS /* CRAY intrinsics */
         if (iStat.ne.0) then
#ifndef _CRAY_NV1
            call tracebk
            call trbk
#endif
            call abort
         end if
#endif /* _UNICOS */
         call c_exit(iStat)
      else
#ifdef _HAVE_MPI
         call MPW_Abort(MPI_COMM_WORLD,iStat,iErr)
#else
c      o this branch makes no sense (nprocs!=1 w/o MPI), but it hides
c        mpw from parallel builds that use serial ACES libraries
         call c_exit(iStat)
#endif
      end if
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__C_EQ_A_TIMES_B_FLOAT
     +
     +                    ( DDROWA,DDCOLA,
     +                      DDROWB,DDCOLB,
     +                      DDROWC,DDCOLC,
     +                      ROW,SUM,COL,
     +                      A,B,
     +
     +                              C )
     +
C-----------------------------------------------------------------------
C  OPERATION   : MAT__C_EQ_A_TIMES_B_FLOAT
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation multiplies the two-dimensional matrix A
C                by the two-dimensional matrix B. Matrices A and B need
C                not be distinct, but matrix C must be distinct from A
C                and B and all matrices must be of floating point type.
C
C  AUTHOR      : Norbert Flocke
C-----------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    DDROWA,DDCOLA
         INTEGER    DDROWB,DDCOLB
         INTEGER    DDROWC,DDCOLC
         INTEGER    ROW,SUM,COL

         DOUBLE PRECISION   A (1:DDROWA,1:DDCOLA)
         DOUBLE PRECISION   B (1:DDROWB,1:DDCOLB)
         DOUBLE PRECISION   C (1:DDROWC,1:DDCOLC)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF  (ROW.GT.DDROWA  .OR.  SUM.GT.DDCOLA)  THEN
              WRITE (1,*) ' Dimensions of matrix A too small: '
              WRITE (1,*) ' mat__c_eq_a_times_b_float '
              WRITE (1,*) ' DDROWA,DDCOLA,ROW,SUM = ',
     +                      DDROWA,DDCOLA,ROW,SUM
              WRITE (*,*) ' Dimensions of matrix A too small: '
              WRITE (*,*) ' mat__c_eq_a_times_b_float '
              WRITE (*,*) ' DDROWA,DDCOLA,ROW,SUM = ',
     +                      DDROWA,DDCOLA,ROW,SUM
              STOP
         END IF

         IF  (SUM.GT.DDROWB  .OR.  COL.GT.DDCOLB)  THEN
              WRITE (1,*) ' Dimensions of matrix B too small: '
              WRITE (1,*) ' mat__c_eq_a_times_b_float '
              WRITE (1,*) ' DDROWB,DDCOLB,SUM,COL = ',
     +                      DDROWB,DDCOLB,SUM,COL
              WRITE (*,*) ' Dimensions of matrix B too small: '
              WRITE (*,*) ' mat__c_eq_a_times_b_float '
              WRITE (*,*) ' DDROWB,DDCOLB,SUM,COL = ',
     +                      DDROWB,DDCOLB,SUM,COL
              STOP
         END IF

         IF  (ROW.GT.DDROWC  .OR.  COL .GT. DDCOLC)  THEN
              WRITE (1,*) ' Dimensions of matrix C too small: '
              WRITE (1,*) ' mat__c_eq_a_times_b_float '
              WRITE (1,*) ' DDROWC,DDCOLC,ROW,COL = ',
     +                      DDROWC,DDCOLC,ROW,COL
              WRITE (*,*) ' Dimensions of matrix C too small: '
              WRITE (*,*) ' mat__c_eq_a_times_b_float '
              WRITE (*,*) ' DDROWC,DDCOLC,ROW,COL = ',
     +                      DDROWC,DDCOLC,ROW,COL
              STOP
         END IF
C
C
C             ...highly optimized routine.
C
C
         CALL  MAT__DGEMM_C_EQ_AXB_FLOAT
     +
     +              ( DDROWA,DDCOLA,
     +                DDROWB,DDCOLB,
     +                DDROWC,DDCOLC,
     +                ROW,SUM,COL,
     +                A,B,
     +
     +                       C )
     +
     +
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine c1_full_print(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c   Prints C1 a and C1b vectors
c   execute c1a c1b
c 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'

      double precision x(*) 
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      integer i, n, i1, i2, a1, a2, j1, j2, b1, b2
 
      i1 = bdim(1)
      i2 = edim(1)
      a1 = bdim(2)
      a2 = edim(2)
      j1 = bdim2(1)
      j2 = edim2(1)
      b1 = bdim2(2)
      b2 = edim2(2)

      call uuu (x, x2, i1, i2, a1, a2, j1, j2, b1, b2)

      return
      end




      subroutine uuu (c1a, c1b, i1, i2, a1, a2, j1, j2, b1, b2)

      implicit none
      include 'mpif.h'
      include 'parallel_info.h'

      double precision stemp, sumb
      integer i, n, a, b, i1, i2, a1, a2, j1, j2, b1, b2
      double precision c1a (i1:i2,a1:a2), c1b (j1:j2,b1:b2)

10    FORMAT(2x,'Singles amplitudes above 0.1')
20    FORMAT(2x,60('-'))
30    FORMAT(2x,I8,x,I8,x,F16.8)
40    FORMAT(2x,'A',10x,'I',10x,'C1-Alpha (A,I)')
50    FORMAT(2x,'A',10x,'I',10x,'C1-Beta  (A,I)')

       open (unit=66,file="summary.out")
       if (me .eq. my_company_rank)then

         write(66,*) ' '
         write(66,10)
         write(66,20)
         write(66,40)
c
         do b = a1, a2
         do a = i1, i2
         stemp=dabs(c1a(a,b))
c
         if(stemp .gt. 1.0d-1)then
           write(66,30) a, b, c1a(a,b)
         endif

         enddo
         enddo

         write(66,20)
         sumb = 0.0d0
         do b = b1, b2
         do a = j1, j2
            sumb= sumb+dabs(c1b(a,b))
         enddo
         enddo 

         if (sumb .gt. 0.0d0) then
            write(66,50)

            do b = b1, b2
            do a = j1, j2
               stemp=dabs(c1b(a,b))
c
               if(stemp .gt. 1.0d-1)then
                  write(66,30) a, b, c1b(a,b)
               endif

            enddo
            enddo
         endif
         write(66,20)

c
       endif

       return
       end

C     A subroutine that calculates the determinant and inverse of
C          a matrix, as well as solving systems of linear equations.
C     Martin J. McBride.  11/25/85.
C     General Electric CRD, Information System Operation.
C
C  AB  - The matrix that need to inverted (or solved); It is done in place!
C   N  - The order of the matrix AB
C  LDA - Leading Dimension of the matrix AB
C  SCRATCH - scratch are of dimension n to hold pivot indices (integer)
C  DET - The determinat corresponding to AB matrix (output)
C  EPS - The tolerence to check the linear dependencies (1.0D-8 is recommended)
C  M   - Control whether you invert the matrix of solve linear equations AB*X=C
C      - 0 invert, 1 would solve linear eqns.
C MODE - is not used

C  THE COMMENTS ABOVE REFER TO AN OLD "SCIPORT" VERSION OF THIS ROUTINE,
C  PRESUMABLY WRITTEN BY MR. MC BRIDE.  UNFORTUNATELY, IT SEEMS THAT
C  HE IS A BAD PROGRAMMER AND THIS ROUTINE DID NOT WORK.  MINV IS NOW
C  A SIMPLE INTERFACE TO LINPACK ROUTINES WHICH *WORK*

c#include "aces.h"

      SUBROUTINE MINV(AB,N,LDA,SCRATCH,DET,EPS,M,MODE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION AB(LDA,1),SCRATCH(1)

      INFO = 0
      CALL DGETRF(N,N,AB,LDA,SCRATCH,INFO)
      IF (INFO.NE.0) THEN
	IF (INFO.GT.0) THEN
	  WRITE(6,*) "@MINV Singular Matrix"
        ELSE
          WRITE(6,*) "@MINV dgetrf argument ",-INFO," is illegal."
        ENDIF
        CALL ERREX
      ENDIF
      IF(M.EQ.1) CALL DGETRS('N',N,1,AB,LDA,SCRATCH,AB(1,N+1),LDA,INFO)
      IF(M.GT.1)THEN
       WRITE(6,1000)
1000   FORMAT(T3,'@MINV-F, Only one system can be solved at a time.')
       CALL ERREX
      ENDIF

      IOFF=1+N
      IF(M.EQ.0) CALL DGETRI(N,AB,LDA,SCRATCH,SCRATCH(IOFF),N,INFO)
C
C THIS IS WRONG, BUT WHO CARES? I care, Ajith 12/99
C
c     DET=X(1)*10**X(2)
C      IF (DET .LE. EPS) Then
      IF (INFO.NE.0) THEN
        IF (INFO.GT.0) THEN 
          WRITE(6,*) "@MINV Singular Matrix"
        ELSE
          WRITE(6,*) "@MINV dgetri argument ",-INFO," is illegal."
        ENDIF
        CALL ERREX
      ENDIF
      RETURN
      END

      SUBROUTINE A2GET_DEN(WORK, MAXCOR, IREORDER, DENSITY_TYPE, 
     &                     SPIN_D, NMBR_OF_PERTS, NBFNS, NAOBFNS, 
     &                     ISCF_TDEN, ICOR_TDEN, ISCF_DDEN, 
     &                     ICOR_DDEN, IBEGIN_P_DENS, IUHF) 
C     
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL SPHERICAL, SPIN_D
C
c maxbasfn.par : begin

c MAXBASFN := the maximum number of (Cartesian) basis functions

c This parameter is the same as MXCBF. Do NOT change this without changing
c mxcbf.par as well.

      INTEGER MAXBASFN
      PARAMETER (MAXBASFN=1000)
c maxbasfn.par : end
      CHARACTER*7 DENSITY_TYPE
      CHARACTER*8 LABELPSCF, LABELDSCF, LABELDENS, LABELSDEN,
     &            RECNAMEA, RECNAMEB
      DIMENSION WORK(MAXCOR), IREORDER(NAOBFNS), ISCR1(MAXBASFN)
C
      DATA IONE /1/
C


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end




c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end






























































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C
      SPHERICAL = (IFLAGS(62) .EQ. 1)
      LABELPSCF ='HFDENSTY'
      LABELDSCF ='HDDENSTY'
      LABELDENS ='TDENSITY'
      LABELSDEN ='DDENSITY'
      NAOBFNS2  = NAOBFNS*NAOBFNS
      NBFNS2    = NBFNS*NBFNS
C
      IBEGIN_P_DENS = IONE
      ISCF_TDEN     = IONE
      ISCF_DDEN     = IONE
      ICOR_TDEN     = IONE
      ICOR_DDEN     = IONE
C
      IF (DENSITY_TYPE .EQ. "0-ORDER") THEN
      
C
C Get the SCF and correlated (relaxed) density matirices in AO basis. For 
C open shell calculations, we also read the density diferences. Note that
C the "relaxed" density read here only contain the correlated contributions.
C
      ISCF_TDEN = IONE
      ICOR_TDEN = ISCF_TDEN + NAOBFNS2
      ISCR2     = ICOR_TDEN + NAOBFNS2
      INEXT     = ISCR2     + NAOBFNS
C
      IF (INEXT .GT. MAXCOR) CALL INSMEM("A2GET_DEN", INEXT, MAXCOR)

C
C Watson
C
      IF (SPHERICAL) THEN

        ISCFNB = INEXT
        ICMP2Z = ISCFNB + NBFNS2
        ISCR3  = ICMP2Z + NAOBFNS * NBFNS
        INEXT  = ISCR3  + NAOBFNS * NBFNS
        IF (INEXT .GT. MAXCOR) CALL INSMEM("A2GET_DEN", INEXT, MAXCOR)

        CALL GETREC(-20, 'JOBARC', LABELPSCF, NBFNS2*IINTFP,
     &               WORK(ISCFNB))
        call getrec(20,'JOBARC','CMP2ZMAT',
     +              NAOBFNS*NBFNS*IINTFP,WORK(ICMP2Z))

        CALL XGEMM('N','N',NAOBFNS,NBFNS,NBFNS,
     +                     ONE,WORK(ICMP2Z), NAOBFNS,
     +                         WORK(ISCFNB), NBFNS,
     &                   ZILCH,WORK(ISCR3),  NAOBFNS)

        call xgemm('n','t',naobfns,naobfns,nbfns,
     +                     one,WORK(ISCR3),naobfns,
     +                         WORK(ICMP2Z),nbfns,
     &                   zilch,WORK(ISCF_TDEN),naobfns)

      ELSE

         CALL GETREC(-20, 'JOBARC', LABELPSCF, NAOBFNS2*IINTFP,
     &                WORK(ISCF_TDEN))

      ENDIF

C      CALL GETREC(-20, 'JOBARC', LABELDENS, NBFNS2*IINTFP, 
C     &             WORK(ICOR_TDEN))
C      CALL GETREC(-20, 'JOBARC', LABELPSCF, NAOBFNS2*IINTFP,
C     &             WORK(ISCF_TDEN))
C      CALL GETREC(-20, 'JOBARC', LABELDENS, NAOBFNS2*IINTFP, 
C     &             WORK(ICOR_TDEN))

      Write(6,*) "The SCF and Cor. tot. density matrices in AO basis"
      CALL OUTPUT(WORK(ISCF_TDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      
      IF (SPIN_D .AND. (IUHF .GT. 0)) THEN
         
          ISCF_DDEN = INEXT
          ICOR_DDEN = ISCF_DDEN + NAOBFNS2
          INEXT     = ICOR_DDEN + NAOBFNS2
          IF (INEXT .GT. MAXCOR) CALL INSMEM("A2GET_DEN", INEXT, 
     &                                        MAXCOR)
 
          CALL GETREC(-20, 'JOBARC', LABELDSCF, NAOBFNS2*IINTFP, 
     &                 WORK(ISCF_DDEN))
          CALL GETREC(-20, 'JOBARC', LABELSDEN, NAOBFNS2*IINTFP, 
     &                 WORK(ICOR_DDEN))
      ENDIF
C      
      Write(6,*) "The SCF and Cor. tot. density matrices in AO basis"
      CALL OUTPUT(WORK(ISCF_TDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      Write(6,*)
C      CALL OUTPUT(WORK(ICOR_TDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
C     &            NAOBFNS, 1)
C      Write(6,*)
C
      IF (SPIN_D .AND. IUHF .GT. 0) THEN
      Write(6,*) "The SCF and Cor. spin. density matrices in AO basis"
      CALL OUTPUT(WORK(ISCF_DDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      Write(6,*)
      CALL OUTPUT(WORK(ICOR_DDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      Write(6,*)
      ENDIF
C
      ELSE IF (DENSITY_TYPE .EQ. "1-ORDER") THEN
C
           MAX_MEM_NEED = 2*NAOBFNS2*NMBR_OF_PERTS + 2*NAOBFNS2
           IF (MAXCOR .LE. MAX_MEM_NEED) CALL INSMEM("A2GET_DEN", 
     &                                                MAX_MEM_NEED, 
     &                                                MAXCOR)
C
           IKEEP_ONE_DENA = IONE 
           IKEEP_ONE_DENB = IKEEP_ONE_DENA + NAOBFNS2
           IKEEP_P_TDEN_N = IKEEP_ONE_DENB + NAOBFNS2
           IBEGIN_P_DENS  = IKEEP_P_TDEN_N  

           DO IPERT = 1, NMBR_OF_PERTS
C
              IKEEP_P_DDEN_N =  IKEEP_P_TDEN_N + NAOBFNS2
              INEXT          =  IKEEP_P_DDEN_N + NAOBFNS2
C
              WRITE(RECNAMEA, "(A,I2)") "PTDENA", IPERT
              CALL GETREC(-20, "JOBARC", RECNAMEA, NAOBFNS2*IINTFP, 
     &                    WORK(IKEEP_ONE_DENA))
C
              WRITE(RECNAMEB, "(A,I2)") "PTDENB", IPERT
              CALL GETREC(-20, "JOBARC", RECNAMEB, NAOBFNS2*IINTFP,
     &                     WORK(IKEEP_ONE_DENB))
C
              CALL ZERO(WORK(IKEEP_P_TDEN_N), NAOBFNS2)
              CALL ZERO(WORK(IKEEP_P_DDEN_N), NAOBFNS2)
C
C Build perturbed total density for n perturbation 
C
              CALL SAXPY(NAOBFNS2, 1.0D0, WORK(IKEEP_ONE_DENA), 1, 
     &                   WORK(IKEEP_P_TDEN_N), 1) 
              CALL SAXPY(NAOBFNS2, 1.0D0, WORK(IKEEP_ONE_DENB), 1, 
     &                   WORK(IKEEP_P_TDEN_N), 1) 
C
C Build perturbed spin density for n perturbation 
C
              CALL SAXPY(NAOBFNS2, 1.0D0, WORK(IKEEP_ONE_DENA), 1, 
     &                   WORK(IKEEP_P_DDEN_N), 1) 
              CALL SAXPY(NAOBFNS2, -1.0D0, WORK(IKEEP_ONE_DENB), 1, 
     &                   WORK(IKEEP_P_DDEN_N), 1) 
C
              IKEEP_P_TDEN_N =  INEXT
C
           ENDDO
C
C endif for density type
C
      ENDIF
C
C At this point we need to transform the density matrices to Cartesian
C basis in order to directly contract with the Cartesian AO integrals.
C 
C$$$      IF (SPHERICAL) THEN
C$$$         CALL GETREC(20, 'JOBARC','CMP2CART', NBAS*NBASP*IINTFP, 
C$$$     &               SPH2CART)

C$$$      Write(6,*) "The spherical to Cartesian transformation matrix"
C$$$      CALL OUTPUT(SPH2CART, 1, NBAS, 1, NBASP, NBAS, NBASP, 1)
C
C$$$         CALL TRANS_SPH2CART(SCFDEN, SPH2CART, TMP, NBAS, NBASP)
C$$$         CALL TRANS_SPH2CART(RELDEN, SPH2CART, TMP, NBAS, NBASP)
C$$$      ENDIF
C
C
      RETURN
      END

      SUBROUTINE A2GET_DEN(WORK, MAXCOR, IREORDER, DENSITY_TYPE, 
     &                     SPIN_D, NMBR_OF_PERTS, NBFNS, NAOBFNS, 
     &                     ISCF_TDEN, ICOR_TDEN, ISCF_DDEN, 
     &                     ICOR_DDEN, IBEGIN_P_DENS, IUHF) 
C     
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL SPHERICAL, SPIN_D
C
#include "maxbasfn.par"
      CHARACTER*7 DENSITY_TYPE
      CHARACTER*8 LABELPSCF, LABELDSCF, LABELDENS, LABELSDEN,
     &            RECNAMEA, RECNAMEB
      DIMENSION WORK(MAXCOR), IREORDER(NAOBFNS), ISCR1(MAXBASFN)
C
      DATA IONE /1/
C
#include "machsp.com"
#include "syminf.com"
#include "jodaflags.com"
C
      SPHERICAL = (IFLAGS(62) .EQ. 1)
      LABELPSCF ='HFDENSTY'
      LABELDSCF ='HDDENSTY'
      LABELDENS ='TDENSITY'
      LABELSDEN ='DDENSITY'
      NAOBFNS2  = NAOBFNS*NAOBFNS
      NBFNS2    = NBFNS*NBFNS
C
      IBEGIN_P_DENS = IONE
      ISCF_TDEN     = IONE
      ISCF_DDEN     = IONE
      ICOR_TDEN     = IONE
      ICOR_DDEN     = IONE
C
      IF (DENSITY_TYPE .EQ. "0-ORDER") THEN
      
C
C Get the SCF and correlated (relaxed) density matirices in AO basis. For 
C open shell calculations, we also read the density diferences. Note that
C the "relaxed" density read here only contain the correlated contributions.
C
      ISCF_TDEN = IONE
      ICOR_TDEN = ISCF_TDEN + NAOBFNS2
      ISCR2     = ICOR_TDEN + NAOBFNS2
      INEXT     = ISCR2     + NAOBFNS
C
#ifdef _DEBUG_LVLM2
      Print*, "Offsets for 0-order density"
      Write(*,'(4(1x,i5))') ISCF_TDEN, ICOR_TDEN, INEXT
      Write(6,*)
      Write(6,*) "The reordering array"
      Write(6,"(6I5)") (IREORDER(I), I=1, NAOBFNS)
#endif
      IF (INEXT .GT. MAXCOR) CALL INSMEM("A2GET_DEN", INEXT, MAXCOR)

C
C Watson
C
      IF (SPHERICAL) THEN

        ISCFNB = INEXT
        ICMP2Z = ISCFNB + NBFNS2
        ISCR3  = ICMP2Z + NAOBFNS * NBFNS
        INEXT  = ISCR3  + NAOBFNS * NBFNS
        IF (INEXT .GT. MAXCOR) CALL INSMEM("A2GET_DEN", INEXT, MAXCOR)

        CALL GETREC(-20, 'JOBARC', LABELPSCF, NBFNS2*IINTFP,
     &               WORK(ISCFNB))
        call getrec(20,'JOBARC','CMP2ZMAT',
     +              NAOBFNS*NBFNS*IINTFP,WORK(ICMP2Z))

        CALL XGEMM('N','N',NAOBFNS,NBFNS,NBFNS,
     +                     ONE,WORK(ICMP2Z), NAOBFNS,
     +                         WORK(ISCFNB), NBFNS,
     &                   ZILCH,WORK(ISCR3),  NAOBFNS)

        call xgemm('n','t',naobfns,naobfns,nbfns,
     +                     one,WORK(ISCR3),naobfns,
     +                         WORK(ICMP2Z),nbfns,
     &                   zilch,WORK(ISCF_TDEN),naobfns)

      ELSE

         CALL GETREC(-20, 'JOBARC', LABELPSCF, NAOBFNS2*IINTFP,
     &                WORK(ISCF_TDEN))

      ENDIF

C      CALL GETREC(-20, 'JOBARC', LABELDENS, NBFNS2*IINTFP, 
C     &             WORK(ICOR_TDEN))
C      CALL GETREC(-20, 'JOBARC', LABELPSCF, NAOBFNS2*IINTFP,
C     &             WORK(ISCF_TDEN))
C      CALL GETREC(-20, 'JOBARC', LABELDENS, NAOBFNS2*IINTFP, 
C     &             WORK(ICOR_TDEN))

#ifdef _DEBUG_LVL0
      Write(6,*) "The SCF and Cor. tot. density matrices in AO basis"
      CALL OUTPUT(WORK(ISCF_TDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
#endif
#ifdef _NOSKIP
      CALL MAT_REORDER(2, 1, NAOBFNS, NAOBFNS, WORK(ISCF_TDEN), 
     &                 WORK(ISCR2), ISCR1, IREORDER) 
C      CALL MAT_REORDER(2, 1, NAOBFNS, NAOBFNS, WORK(ICOR_TDEN), 
C     &                 WORK(ISCR2), ISCR1, IREORDER) 
#endif
      
      IF (SPIN_D .AND. (IUHF .GT. 0)) THEN
         
          ISCF_DDEN = INEXT
          ICOR_DDEN = ISCF_DDEN + NAOBFNS2
          INEXT     = ICOR_DDEN + NAOBFNS2
#ifdef _DEBUG_LVLM2
      Print*, "Offsets for 0-order density"
      Write(*,'(3(1x,i5))') ISCF_TDEN, ICOR_TDEN, INEXT 
      Write(6,*)
#endif
          IF (INEXT .GT. MAXCOR) CALL INSMEM("A2GET_DEN", INEXT, 
     &                                        MAXCOR)
 
          CALL GETREC(-20, 'JOBARC', LABELDSCF, NAOBFNS2*IINTFP, 
     &                 WORK(ISCF_DDEN))
          CALL GETREC(-20, 'JOBARC', LABELSDEN, NAOBFNS2*IINTFP, 
     &                 WORK(ICOR_DDEN))
#ifdef _NOSKIP 
          CALL MAT_REORDER(2, 1, NAOBFNS, NAOBFNS, WORK(ISCF_DDEN),
     &                     WORK(ISCR2), ISCR1 , IREORDER)
          CALL MAT_REORDER(2, 1, NAOBFNS, NAOBFNS, WORK(ICOR_DDEN), 
     &                     WORK(ISCR2), ISCR1, IREORDER,)
#endif
      ENDIF
C      
#ifdef _DEBUG_LVL0
      Write(6,*) "The SCF and Cor. tot. density matrices in AO basis"
      CALL OUTPUT(WORK(ISCF_TDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      Write(6,*)
C      CALL OUTPUT(WORK(ICOR_TDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
C     &            NAOBFNS, 1)
C      Write(6,*)
C
      IF (SPIN_D .AND. IUHF .GT. 0) THEN
      Write(6,*) "The SCF and Cor. spin. density matrices in AO basis"
      CALL OUTPUT(WORK(ISCF_DDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      Write(6,*)
      CALL OUTPUT(WORK(ICOR_DDEN), 1, NAOBFNS, 1, NAOBFNS, NAOBFNS, 
     &            NAOBFNS, 1)
      Write(6,*)
      ENDIF
#endif
C
      ELSE IF (DENSITY_TYPE .EQ. "1-ORDER") THEN
C
           MAX_MEM_NEED = 2*NAOBFNS2*NMBR_OF_PERTS + 2*NAOBFNS2
           IF (MAXCOR .LE. MAX_MEM_NEED) CALL INSMEM("A2GET_DEN", 
     &                                                MAX_MEM_NEED, 
     &                                                MAXCOR)
C
           IKEEP_ONE_DENA = IONE 
           IKEEP_ONE_DENB = IKEEP_ONE_DENA + NAOBFNS2
           IKEEP_P_TDEN_N = IKEEP_ONE_DENB + NAOBFNS2
           IBEGIN_P_DENS  = IKEEP_P_TDEN_N  

           DO IPERT = 1, NMBR_OF_PERTS
C
              IKEEP_P_DDEN_N =  IKEEP_P_TDEN_N + NAOBFNS2
              INEXT          =  IKEEP_P_DDEN_N + NAOBFNS2
C
#ifdef _DEBUG_LVLM2
      Print*, "Offsets for 1-order density" 
      Write(*,'(a,1x,i5)')  "The number of pert.", NMBR_OF_PERTS
      Write(*,'(4(1x,i5))') IKEEP_ONE_DENA, IKEEP_ONE_DENB, 
     &                         IKEEP_P_TDEN_N, IKEEP_P_DDEN_N
      Write(6,*)
#endif
              WRITE(RECNAMEA, "(A,I2)") "PTDENA", IPERT
              CALL GETREC(-20, "JOBARC", RECNAMEA, NAOBFNS2*IINTFP, 
     &                    WORK(IKEEP_ONE_DENA))
C
              WRITE(RECNAMEB, "(A,I2)") "PTDENB", IPERT
              CALL GETREC(-20, "JOBARC", RECNAMEB, NAOBFNS2*IINTFP,
     &                     WORK(IKEEP_ONE_DENB))
C
#ifdef _DEBUG_LVLM2
      Write(6,'(1x,a,a,1x,a)') "The record labels ", RECNAMEA, 
     &      RECNAMEB
      Write(6,*)
      Write(6,*) "The  1-st order alpha density matrices in AO basis"
      CALL OUTPUT(WORK(IKEEP_ONE_DENA), 1, NAOBFNS, 1, NAOBFNS,
     &            NAOBFNS, NAOBFNS, 1)
C   
      Write(6,*)
      Write(6,*) "The 1-st order beta density matrices in AO basis"
      CALL OUTPUT(WORK(IKEEP_ONE_DENB), 1, NAOBFNS, 1, NAOBFNS,
     &            NAOBFNS, NAOBFNS, 1)
           
#endif   
              CALL ZERO(WORK(IKEEP_P_TDEN_N), NAOBFNS2)
              CALL ZERO(WORK(IKEEP_P_DDEN_N), NAOBFNS2)
C
C Build perturbed total density for n perturbation 
C
              CALL SAXPY(NAOBFNS2, 1.0D0, WORK(IKEEP_ONE_DENA), 1, 
     &                   WORK(IKEEP_P_TDEN_N), 1) 
              CALL SAXPY(NAOBFNS2, 1.0D0, WORK(IKEEP_ONE_DENB), 1, 
     &                   WORK(IKEEP_P_TDEN_N), 1) 
C
C Build perturbed spin density for n perturbation 
C
              CALL SAXPY(NAOBFNS2, 1.0D0, WORK(IKEEP_ONE_DENA), 1, 
     &                   WORK(IKEEP_P_DDEN_N), 1) 
              CALL SAXPY(NAOBFNS2, -1.0D0, WORK(IKEEP_ONE_DENB), 1, 
     &                   WORK(IKEEP_P_DDEN_N), 1) 
C
#ifdef _DEBUG_LVLM2
      Write(6,*)
      Write(6,*) "The  1-st order tot. density matrices in AO basis"
      CALL OUTPUT(WORK(IKEEP_P_TDEN_N), 1, NAOBFNS, 1, NAOBFNS, 
     &            NAOBFNS, NAOBFNS, 1)
C    
      Write(6,*)
      Write(6,*) "The 1-st order spin. density matrices in AO basis"
      CALL OUTPUT(WORK(IKEEP_P_DDEN_N), 1, NAOBFNS, 1, NAOBFNS,
     &            NAOBFNS, NAOBFNS, 1)

#endif
              IKEEP_P_TDEN_N =  INEXT
C
           ENDDO
C
C endif for density type
C
      ENDIF
C
C At this point we need to transform the density matrices to Cartesian
C basis in order to directly contract with the Cartesian AO integrals.
C 
C$$$      IF (SPHERICAL) THEN
C$$$         CALL GETREC(20, 'JOBARC','CMP2CART', NBAS*NBASP*IINTFP, 
C$$$     &               SPH2CART)

C$$$      Write(6,*) "The spherical to Cartesian transformation matrix"
C$$$      CALL OUTPUT(SPH2CART, 1, NBAS, 1, NBASP, NBAS, NBASP, 1)
C
C$$$         CALL TRANS_SPH2CART(SCFDEN, SPH2CART, TMP, NBAS, NBASP)
C$$$         CALL TRANS_SPH2CART(RELDEN, SPH2CART, TMP, NBAS, NBASP)
C$$$      ENDIF
C
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__FIND_ROTATION_NBO_INDICES
     +
     +                    ( NBAS,NATOM,NDEG,
     +                      NBOSIZE,
     +                      OFFLP,OFFBD,OFFEP,
     +                      OFFAB,OFFRY,OFFRR,
     +                      CENTER,
     +                      SYMSIZE,SYMSETS,SYMCEN,
     +                      SYMNBO,
     +                      QSYMACC,LSYMACC,
     +                      BDNCEN,BDCEN,
     +                      NBOBD,
     +                      SYMCRIT,
     +                      PSUB,
     +                      LOCAL,
     +                      Q,
     +
     +                              ZEROSYM,
     +                              NROT,
     +                              ROTIDX )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__FIND_ROTATION_NBO_INDICES
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine determines those NBO indices which will
C                be used for reorientation of axial and central
C                degenerate atomic NBOs.
C
C                Procedure:
C
C                We will only use those NBOs for reorientation which
C                are actually marked as usable for that purpose in the
C                SYMNBO array (see below). The following algorithm
C                is applied:
C
C                1) Determination of NBO subset {NBO} for rotation
C
C                   Loop over all NBOs
C                     Check NBO => is SYMNBO (NBO) = 2 ?
C                       If yes, get NBO atomic indices NIDX
C                         If NIDX = 2 (2-cen bond or antibond) then 
C                           Is one atomic index = rotation center ?
C                             If yes, is second index member any
C                             of the symmetry center sets ?
C                                If yes, add present NBO to set {NBO}
C                         If NIDX = 1 (single atom NBO) then
C                           Is atomic index member any of the
C                           symmetry center sets ?
C                              If yes, add present NBO to set {NBO}
C                   continue
C
C                2) Determination of final NBO set [NBO] for rotation
C
C                      i) determine the largest absolute element NBOx
C                         of all NDEG degenerate PSUB vectors
C                         within the {NBO} subset determined
C                     ii) if this element < SYMCRIT, exit routine
C                         with ZEROSYM = .true.
C                    iii) determine the atomic NBO index IDX different
C                         from the rotation center to which that
C                         element NBOx belongs
C                     iv) determine what type of NBO it belongs to
C                         (Core, Lone-pair, 2-cen Bond, etc ...)
C                      v) determine all atomic index partners [IDX]
C                         corresponding to IDX and the symmetry
C                         center sets
C                     vi) determine all those NBO indices [NBO] which
C                         belong to [IDX], have the same type and are
C                         symmetry related to NBOx
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    NDEG         =  # of degenerate NBOs. Can only
C                                    be equal to 2,3,4 or 5.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    OFFxy        =  absolute offset indices for x-type
C                                    NBOs. These indices indicate the
C                                    totallity of x-type NBOs before the
C                                    x-type NBO set (xy:LP=Lone-pair,
C                                    BD=Bond, EP=Empty-pair, AB=Anti-
C                                    bond, RY,RR=Rydberg types)
C                    CENTER       =  atomic index on which NBO rotation
C                                    will be performed
C                    SYMSIZE      =  the size of the symmetry related
C                                    atomic index sets (rings or high
C                                    symmetry sets)
C                    SYMSETS      =  the # of symmetry related atomic
C                                    atomic index sets (rings or high
C                                    symmetry sets)
C                    SYMCEN (A)   =  all SYMSIZE * SYMSETS symmetry
C                                    related atomic indices A grouped
C                                    into sets of size SYMSIZE
C                    SYMNBO (I)   =  integer vector indicating if the
C                                    I-th NBO is considered to be used
C                                    for symmetry adaptation (=2 if to
C                                    be used).
C                    QSYMACC      =  threshold value for NBO interaction
C                                    order equalities.
C                    LSYMACC      =  threshold value for NBO locality
C                                    equalities.
C                    BDNCEN (J)   =  current # of atomic centers for
C                                    J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDCEN (I,J)  =  current I-th atomic center index
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th atomic x-type NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC.
C                    SYMCRIT      =  symmetry interaction criterion.
C                                    Any absolute occupation matrix
C                                    interaction element between
C                                    symmetrized NBOs and a degenerate
C                                    set of NBOs is assumed to be zero
C                                    if it falls below this value.
C                    PSUB         =  NBAS x NDEG section of the
C                                    occupation matrix.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs.
C                    Q            =  complete NBO interaction order
C                                    vector at present stage of
C                                    symmetrization.
C
C
C                  Output:
C
C                    ZEROSYM      =  is false, if the search has been
C                                    successful in the sense that at
C                                    least one occupation matrix
C                                    element was found to be larger or
C                                    equal than the symmetry interaction
C                                    criterion value SYMCRIT. If true,
C                                    then all occupation matrix elements
C                                    were < SYMCRIT, an indication
C                                    that the current set of NBOs passed
C                                    here have no symmetry interaction
C                                    with those NBOs currently available
C                                    for symmetry analysis.
C                    NROT         =  # of NBO indices that will be used
C                                    for rotation.
C                    ROTIDX       =  the rotation NBO indices.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     QSYM,LSYM
         LOGICAL     ZEROSYM

         INTEGER     ATX,ATX1,ATX2,ATXOLD,ATXMAX
         INTEGER     BOND
         INTEGER     CENTER
         INTEGER     J,N
         INTEGER     MROT,NROT
         INTEGER     NATOM
         INTEGER     NBAS
         INTEGER     NBO,NBO1ST,NBOLST,NBOBEG,NBOEND,NBOSIZE,NBOMAX
         INTEGER     NCEN
         INTEGER     NDEG
         INTEGER     NITER,MXITER
         INTEGER     NSYM,NSYMOLD
         INTEGER     NXBA
         INTEGER     OFF,OFFLP,OFFBD,OFFEP,OFFAB,OFFRY,OFFRR
         INTEGER     ROT
         INTEGER     SET,SETMAX
         INTEGER     SYM,SYM1ST,SYMLST,SYMSIZE,SYMSETS

         INTEGER     BDNCEN  (1:NBAS )
         INTEGER     NBOBD   (1:NBAS )
         INTEGER     ROTIDX  (1:NBAS )
         INTEGER     SYMCEN  (1:NATOM)
         INTEGER     SYMNBO  (1:NBAS )

         INTEGER     BDCEN   (1:NBOSIZE,1:NBAS )

         DOUBLE PRECISION  PMAX,PVAL
         DOUBLE PRECISION  QMAX,LMAX
         DOUBLE PRECISION  QNBO,LNBO
         DOUBLE PRECISION  QSYMACC,LSYMACC
         DOUBLE PRECISION  QTHRESH,LTHRESH
         DOUBLE PRECISION  SYMCRIT
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  LOCAL  (1:NBAS)
         DOUBLE PRECISION  Q      (1:NBAS)

         DOUBLE PRECISION  PSUB  (1:NBAS,1:NDEG)

         PARAMETER  (ZERO   = 0.D0)
         PARAMETER  (MXITER = 50  )
C
C
C------------------------------------------------------------------------
C
C
C             ...loop over all NBOs and determine the NBO, atomic and
C                symmetry set index leading to the maximum PSUB value.
C
C
         PMAX = ZERO
         ATXMAX = 0
         NBOMAX = 0

         DO NBO = 1,NBAS
            IF (SYMNBO (NBO).EQ.2) THEN

                BOND = NBOBD (NBO)
                NCEN = BDNCEN (BOND)

                IF (NCEN.EQ.1) THEN
                    ATX = BDCEN (1,BOND)
                ELSE IF (NCEN.EQ.2) THEN
                    ATX  = 0
                    ATX1 = BDCEN (1,BOND)
                    ATX2 = BDCEN (2,BOND)
                    IF (ATX1.EQ.CENTER) THEN
                        ATX = ATX2
                    ELSE IF (ATX2.EQ.CENTER) THEN
                        ATX = ATX1
                    END IF
                END IF

                IF (ATX.NE.0) THEN
                    N = 0
                    DO SET = 1,SYMSETS
                    DO SYM = 1,SYMSIZE
                       N = N + 1
                       IF (ATX.EQ.SYMCEN (N)) THEN
                           DO J = 1,NDEG
                              PVAL = ABS (PSUB (NBO,J))
                              IF (PVAL.GT.PMAX) THEN
                                  ATXMAX = ATX
                                  NBOMAX = NBO
                                  SETMAX = SET
                                  PMAX = PVAL
                              END IF
                           END DO
                       END IF
                    END DO
                    END DO
                END IF

            END IF
         END DO

         ZEROSYM = ABS (PMAX) .LT. SYMCRIT

         IF (ZEROSYM) THEN
             RETURN
         END IF
C
C
C             ...determine type of found NBO index by narrowing
C                search within the complete NBO set. Determine
C                also the symmetry set range.
C
C
         IF (NBOMAX.EQ.0) THEN
             WRITE (*,*) ' No NBO index! '
             WRITE (*,*) ' NBO = ',NBO
             WRITE (*,*) ' nlo__find_rotation_nbo_indices '
             WRITE (1,*) ' No NBO index! '
             WRITE (1,*) ' NBO = ',NBO
             WRITE (1,*) ' nlo__find_rotation_nbo_indices '
             STOP
         ELSE IF (NBOMAX.LE.OFFLP) THEN
             NBO1ST = 1
             NBOLST = OFFLP
             ATOMIC = .TRUE.
         ELSE IF (NBOMAX.LE.OFFBD) THEN
             NBO1ST = OFFLP + 1
             NBOLST = OFFBD
             ATOMIC = .TRUE.
         ELSE IF (NBOMAX.LE.OFFEP) THEN
             NBO1ST = OFFBD + 1
             NBOLST = OFFEP
             ATOMIC = .FALSE.
         ELSE IF (NBOMAX.LE.OFFAB) THEN
             NBO1ST = OFFEP + 1
             NBOLST = OFFAB
             ATOMIC = .TRUE.
         ELSE IF (NBOMAX.LE.OFFRY) THEN
             NBO1ST = OFFAB + 1
             NBOLST = OFFRY
             ATOMIC = .FALSE.
         ELSE IF (NBOMAX.LE.OFFRR) THEN
             NBO1ST = OFFRY + 1
             NBOLST = OFFRR
             ATOMIC = .TRUE.
         ELSE
             NBO1ST = OFFRR + 1
             NBOLST = NBAS
             ATOMIC = .TRUE.
         END IF

         SYMLST = SETMAX * SYMSIZE
         SYM1ST = SYMLST - SYMSIZE + 1
C
C
C             ...at this point we have narrowed down the NBO type
C                and we know to which symmetry set the NBO belongs.
C                Determine next the other corresponding NBOs from
C                the symmetry set. Two posibilities arise:
C
C                  i) Atomic (i.e. 1 center) NBOs
C                     ---------------------------
C                     Here we know that all NBOs are clustered
C                     according to atomic index and each type
C                     within each atomic set occurs at the same
C                     relative position. Hence, in this case we
C                     determine the relative index of NBOMAX and
C                     find the symmetry related partners using
C                     this index. After that we need to include
C                     those which have the same interaction order
C                     and locality in their immediate neighborhood.
C
C                 ii) Non-Atomic (i.e. 2 center) NBOs
C                     -------------------------------
C                     Here we must find all symmetry related
C                     bonds within the bond type found. These
C                     bonds must be present due to symmetry and
C                     they have to obey the following criteria:
C                     a) same # of centers (i.e. 2), b) same
C                     NBO interaction order, c) same localization
C                     content.
C
C
         QMAX = Q     (NBOMAX)
         LMAX = LOCAL (NBOMAX)

         WRITE (*,*) ' NBOMAX = ',NBOMAX
         WRITE (*,*) ' PMAX = ',PMAX
         WRITE (*,*) ' QMAX,LMAX = ',QMAX,LMAX

         IF (ATOMIC) THEN

             OFF = 0
             NXBA = 0
             NROT = 0
             ATXOLD = 0

             WRITE (*,*) ' NBO1ST,NBOLST = ',NBO1ST,NBOLST

             DO NBO = NBO1ST,NBOLST

                BOND = NBOBD (NBO)
                NCEN = BDNCEN (BOND)

                IF (NCEN.NE.1) THEN
                    WRITE (*,*) ' # of centers mismatch! '
                    WRITE (*,*) ' ATOMIC,NCEN = ',ATOMIC,NCEN
                    WRITE (*,*) ' nlo__find_rotation_nbo_indices '
                    WRITE (1,*) ' # of centers mismatch! '
                    WRITE (1,*) ' ATOMIC,NCEN = ',ATOMIC,NCEN
                    WRITE (1,*) ' nlo__find_rotation_nbo_indices '
                    STOP
                END IF

                ATX = BDCEN (1,BOND)

                IF (ATX.EQ.ATXMAX) THEN
                    NXBA = NXBA + 1
                    IF (NBO.LT.NBOMAX) THEN
                        OFF = OFF + 1
                    END IF
                END IF

                IF (ATX.NE.ATXOLD) THEN
                    DO SYM = SYM1ST,SYMLST
                       IF (ATX.EQ.SYMCEN (SYM)) THEN
                           NROT = NROT + 1
                           ROTIDX (NROT) = NBO
                       END IF
                    END DO
                    ATXOLD = ATX
                END IF

             END DO

             IF (NROT.NE.SYMSIZE) THEN
                 WRITE (*,*) ' Bad # of NBO rotation indices! '
                 WRITE (*,*) ' SYMSIZE,MROT = ',SYMSIZE,MROT
                 WRITE (*,*) ' nlo__find_rotation_nbo_indices '
                 WRITE (1,*) ' Bad # of NBO rotation indices! '
                 WRITE (1,*) ' SYMSIZE,MROT = ',SYMSIZE,MROT
                 WRITE (1,*) ' nlo__find_rotation_nbo_indices '
                 STOP
             END IF

             WRITE (*,*) ' OFF = ',OFF
             WRITE (*,*) ' NXBA = ',NXBA

             DO ROT = 1,NROT
                WRITE (*,*) ' Rot index (intermediate ) = ',ROTIDX (ROT)
             END DO

             CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                    ( 6,
     +                      ' Interaction order vector ',
     +                      NBAS,1,
     +                      NBAS,1,
     +                      Q )
     +
     +
             CALL    MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                    ( 6,
     +                      ' Locality vector ',
     +                      NBAS,1,
     +                      NBAS,1,
     +                      LOCAL )
     +
     +
C
C
C             ...determine the symmetry partners. A maximum of MXITER
C                attempts is beeing done, each time relaxing more and
C                more the symmetry accuracies involved. After each
C                try the QTHRESH and the LTHRESH settings are increased
C                by a factor QLSTEP with an appropriate message. If
C                all attempts do not produce the same amount of partners
C                for all symmetry related centers, the program stops
C                with a message.
C
C                Once a stable # of symmetry partners has been found,
C                the initial NROT rotation indices are expanded to
C                NSYM * NROT rotation indices during this process in
C                the following sequence, starting from the last of
C                NROT original rotation indices as shown in the
C                example below for NROT = 3 and NSYM = 4. The numbers
C                in the symmetry expanded column indicate the order
C                of evaluation, which is done such that the original
C                ROT indices are not overwritten until the very end.
C
C
C                      original ROT          symmetry expanded ROT
C
C
C                                                     1
C                                                     2
C                                                     3
C
C                                                     4
C                                                     5
C                                                     6
C
C                                                     7
C                                                     8
C                                                     9
C
C                          A                         10
C                          B                         11
C                          C                         12
C
C
C
             NITER = 0
             QTHRESH = QSYMACC
             LTHRESH = LSYMACC

 1000        NITER = NITER + 1

             IF (NITER.GT.MXITER) THEN
                 WRITE (*,*) ' Maximum # of iterations reached! '
                 WRITE (*,*) ' NITER = ',NITER
                 WRITE (*,*) ' Couldnt find set of NBO rot indices! '
                 WRITE (*,*) ' nlo__find_rotation_nbo_indices '
                 WRITE (1,*) ' Maximum # of iterations reached! '
                 WRITE (1,*) ' NITER = ',NITER
                 WRITE (1,*) ' Couldnt find set of NBO rot indices! '
                 WRITE (1,*) ' nlo__find_rotation_nbo_indices '
                 STOP
             END IF

             DO ROT = NROT,1,-1
                NBOBEG = ROTIDX (ROT)
                NBOEND = NBOBEG + NXBA - 1
                NBOMAX = NBOBEG + OFF

                NBO1ST = NBOMAX
                NBOLST = NBOMAX - 1

                DO NBO = NBOMAX,NBOBEG,-1
                   QNBO = Q     (NBO)
                   LNBO = LOCAL (NBO)
                   QSYM = DABS (QMAX - QNBO) .LT. QTHRESH
                   LSYM = DABS (LMAX - LNBO) .LT. LTHRESH
                   IF (QSYM.AND.LSYM) THEN
                       NBO1ST = NBO
                   END IF
                END DO

                DO NBO = NBOMAX,NBOEND
                   QNBO = Q     (NBO)
                   LNBO = LOCAL (NBO)
                   QSYM = DABS (QMAX - QNBO) .LT. QTHRESH
                   LSYM = DABS (LMAX - LNBO) .LT. LTHRESH
                   IF (QSYM.AND.LSYM) THEN
                       NBOLST = NBO
                   END IF
                END DO

                NSYM = NBOLST - NBO1ST + 1

                IF (NSYM.LT.1) THEN
                    WRITE (*,*) ' No Rot index defined! '
                    WRITE (*,*) ' NSYM = ',NSYM
                    WRITE (*,*) ' nlo__find_rotation_nbo_indices '
                    WRITE (1,*) ' No Rot index defined! '
                    WRITE (1,*) ' NSYM = ',NSYM
                    WRITE (1,*) ' nlo__find_rotation_nbo_indices '
                    STOP
                END IF

                IF (NSYM.GT.3) THEN
                    WRITE (*,*) ' Warning! # Rot indices > 3! '
                    WRITE (*,*) ' NSYM = ',NSYM
                    WRITE (*,*) ' nlo__find_rotation_nbo_indices '
                    WRITE (1,*) ' Warning! # Rot indices > 3! '
                    WRITE (1,*) ' NSYM = ',NSYM
                    WRITE (1,*) ' nlo__find_rotation_nbo_indices '
                END IF

                IF (ROT.EQ.NROT) THEN
                    NSYMOLD = NSYM
                ELSE
                    IF (NSYM.NE.NSYMOLD) THEN
                        QTHRESH = QTHRESH + QSYMACC
                        LTHRESH = LTHRESH + LSYMACC
                        WRITE (*,*) ' Bad # of Rot indices! '
                        WRITE (*,*) ' NSYM,NSYMOLD = ',NSYM,NSYMOLD
                        WRITE (*,*) ' Increasing thresholds ... '
                        WRITE (*,*) ' Q,L-thresh = ',QTHRESH,LTHRESH
                        WRITE (1,*) ' Bad # of Rot indices! '
                        WRITE (1,*) ' NSYM,NSYMOLD = ',NSYM,NSYMOLD
                        WRITE (1,*) ' Increasing thresholds ... '
                        WRITE (1,*) ' Q,L-thresh = ',QTHRESH,LTHRESH
                        GOTO 1000
                    END IF
                END IF
             END DO
C
C
C             ...the # of symmetry partners NSYM is stable. Run the
C                symmetry partner determination loop one more time
C                using the NSYM and final QTHRESH and LTHRESH values
C                and store all partner rotation indices.
C
C
             MROT = NSYM * NROT + 1

             DO ROT = NROT,1,-1
                NBOBEG = ROTIDX (ROT)
                NBOEND = NBOBEG + NXBA - 1
                NBOMAX = NBOBEG + OFF
                NBO1ST = NBOMAX
                NBOLST = NBOMAX - 1
                DO NBO = NBOMAX,NBOBEG,-1
                   QNBO = Q     (NBO)
                   LNBO = LOCAL (NBO)
                   QSYM = DABS (QMAX - QNBO) .LT. QTHRESH
                   LSYM = DABS (LMAX - LNBO) .LT. LTHRESH
                   IF (QSYM.AND.LSYM) THEN
                       NBO1ST = NBO
                   END IF
                END DO
                DO NBO = NBOMAX,NBOEND
                   QNBO = Q     (NBO)
                   LNBO = LOCAL (NBO)
                   QSYM = DABS (QMAX - QNBO) .LT. QTHRESH
                   LSYM = DABS (LMAX - LNBO) .LT. LTHRESH
                   IF (QSYM.AND.LSYM) THEN
                       NBOLST = NBO
                   END IF
                END DO
                DO NBO = NBOLST,NBO1ST,-1
                   MROT = MROT - 1
                   ROTIDX (MROT) = NBO
                END DO
             END DO

             NROT = NSYM * NROT

         ELSE
C
C
C             ...the non-atomic 2-center bonds and antibonds case.
C                Again the code provides for the option of performing
C                several iterations with respect to symmetry accuracy.
C
C
             NITER = 0
             QTHRESH = QSYMACC
             LTHRESH = LSYMACC

 2000        NITER = NITER + 1

             IF (NITER.GT.MXITER) THEN
                 WRITE (*,*) ' Maximum # of iterations reached! '
                 WRITE (*,*) ' NITER = ',NITER
                 WRITE (*,*) ' Couldnt find set of NBO rot indices! '
                 WRITE (*,*) ' nlo__find_rotation_nbo_indices '
                 WRITE (1,*) ' Maximum # of iterations reached! '
                 WRITE (1,*) ' NITER = ',NITER
                 WRITE (1,*) ' Couldnt find set of NBO rot indices! '
                 WRITE (1,*) ' nlo__find_rotation_nbo_indices '
                 STOP
             END IF

             NROT = 0

             DO NBO = NBO1ST,NBOLST

                BOND = NBOBD (NBO)
                NCEN = BDNCEN (BOND)

                IF (NCEN.EQ.2) THEN

                    ATX  = 0
                    ATX1 = BDCEN (1,BOND)
                    ATX2 = BDCEN (2,BOND)

                    IF (ATX1.EQ.CENTER) THEN
                        ATX = ATX2
                    ELSE IF (ATX2.EQ.CENTER) THEN
                        ATX = ATX1
                    END IF

                    IF (ATX.NE.0) THEN
                        DO SYM = SYM1ST,SYMLST
                           IF (ATX.EQ.SYMCEN (SYM)) THEN
                               QNBO = Q     (NBO)
                               LNBO = LOCAL (NBO)
                               QSYM = DABS (QMAX - QNBO).LT.QTHRESH
                               LSYM = DABS (LMAX - LNBO).LT.LTHRESH
                               IF (QSYM.AND.LSYM) THEN
                                   NROT = NROT + 1
                                   ROTIDX (NROT) = NBO
                               END IF
                           END IF
                        END DO
                    END IF

                END IF
             END DO

             IF (NROT.NE.SYMSIZE) THEN
                 QTHRESH = QTHRESH + QSYMACC
                 LTHRESH = LTHRESH + LSYMACC
                 WRITE (*,*) ' Bad # of Rot indices! '
                 WRITE (*,*) ' SYMSIZE,NROT = ',SYMSIZE,NROT
                 WRITE (*,*) ' Increasing thresholds ... '
                 WRITE (*,*) ' Q,L-thresh = ',QTHRESH,LTHRESH
                 WRITE (1,*) ' Bad # of Rot indices! '
                 WRITE (1,*) ' SYMSIZE,NROT = ',SYMSIZE,NROT
                 WRITE (1,*) ' Increasing thresholds ... '
                 WRITE (1,*) ' Q,L-thresh = ',QTHRESH,LTHRESH
                 GOTO 2000
             END IF

         END IF
C
C
C             ...printout of rotation indices for checking.
C
C
         DO ROT = 1,NROT
            WRITE (*,*) ' Rot index = ',ROTIDX (ROT)
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE PROCESTEP(SCRATCH, HES, GRAD, SCALE, STPMAG,
     &                     STEP, STPTOL, STPMAX, IQFIX, ISTCRT,
     &                     BEGN_TRUST_RAD, EPS, QSTLST_CLIMB, TS)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL TRUST_RADIUS, DELTXT_DELTX, ABSLT_LARGST, QSTLST_CLIMB
      LOGICAL TS
      DOUBLE PRECISION ONE
C
#include "mxatms.par"
#include "flags.h"
#include "jodaflags.com"
#include "machsp.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C
      DIMENSION SCRATCH(NX*NX), IQFIX(3*MXATMS, 3*MXATMS), AV(6),
     &          STEP(NXM6), GRAD(NOPT), HES(NOPT, NOPT), 
     &          ITIE(3*MXATMS)
      DATA ONE /1.0D0/, THREE /3.0D0/
C
C Convert to Internal from symmetry coordinates.
C
      DO 10 I = 1, NOPT
         SCRATCH(I+NOPT)=SCRATCH(I+NOPT)/DSQRT(DFLOAT(NEQ(NOPTI(I))+1))
 10   CONTINUE
C
C Filter step - Remove very small steps which might lead to broken
C symmetry.
C (STPTOL is set 10^(-12), note that STPTOL has nothing to do with STPMAX).
C
      CALL FILTER(SCRATCH(NOPT + 1), NOPT, STPTOL)
      IF (iFlags2(h_IFLAGS2_geom_opt) .EQ. 1) 
     &    CALL TIEDIHED(SCRATCH(NOPT+1), NOPT, ITIE)
C
C Step size control:
C    The old step size control algorithms were based on the largest
C absolute step size or the norm of the displacement vector (bearing
C some resemblance to the trust radius method). Improvements have been
C made to step size control based on the trust radius (Fletcher and Reeves,
C Comput. J. 13, 185 (1972)). The current implementation is based on
C P. Y. Ayala and B. S. Schlegel, JCP, 107, 375, 1997).
C
      TRUST_RADIUS = (IFLAGS(h_IFLAGS_stp_siz_ctl) .EQ. 0)
      DELTXT_DELTX = (IFLAGS(h_IFLAGS_stp_siz_ctl) .EQ. 1)
      ABSLT_LARGST = (IFLAGS(h_IFLAGS_stp_siz_ctl) .EQ. 2)
C
C Unpack the scratch array and regenerate the full STEP vector. Also
C unpack the step vector to avoid any problems with Hessian updates
C in the next cycle (this is repeated after the scaling is done below).
C I have a problem with employing symmetry-packed vectors for step size
C control as was done in the past. Only for trust radius updates am I
C undoing this. I will leave what was done in the past the way they were
C in order not to change too much. Ajith Perera, 11/2004.
C
      IF (TRUST_RADIUS) THEN
         DO J = 1, NOPT
            STEP(NOPTI(J)) = SCRATCH(J + NOPT)
            DO K=1, NEQ(NOPTI(J))
               STEP(IQFIX(NOPTI(J), K)) = SCRATCH(J + NOPT)
            END DO
         END DO
      END IF
C
#ifdef _DEBUG_LVLM1
      Write(6,"(a)") "@-PROCESTEP, The step after symm. expansion"
      Write(6,"(F10.5)")  (STEP(J), J=1, NOPT)
#endif
C
      IF (NCYCLE.GE.2) THEN

         IF (TRUST_RADIUS) THEN

            CALL GETREC(1,'JOBARC','T_RADIUS',IINTFP,TRUST_RAD)
            CALL GETREC(1,'JOBARC','PRDENCHN',IINTFP,PRD_ENRG_CHNG)
            CALL GETREC(1,'JOBARC','PRVIUTAU',IINTFP,DXDX)
            CALL GETREC(20, 'JOBARC', 'TOTENERG', IINTFP, CURR_ENRG)
            CALL GETREC(20, 'JOBARC', 'OLDENERG', IINTFP, PREV_ENRG)
            ACT_ENRG_CHNG = CURR_ENRG - PREV_ENRG 
C
#ifdef _DEBUG_LVL0
            Write(6,*)
            Write(6,"(x,a,F10.5)") "The initial trust rad:", 
     &                               TRUST_RAD
            Write(6,"(x,a,a,3F10.5)") "The predicted and actual", 
     &                             " energy change: ", 
     &                               PRD_ENRG_CHNG,ACT_ENRG_CHNG
            Write(6,"(x,a,F10.5)") "Ratio of change:",
     &                              PRD_ENRG_CHNG/ACT_ENRG_CHNG
#endif
            TAU = DSQRT(DDOT(NXM6, STEP, 1, STEP, 1))
            CALL TRUST_UPDATE(SCRATCH, GRAD, HES, TRUST_RAD,
     &                        PRD_ENRG_CHNG, DXDX, EPS, NX, NXM6,
     &                        NOPT, NCYCLE, TS)
#ifdef _DEBUG_LVL0
            WRITE(6,"(x,a,2F10.5)") "The new trust rad and TAU:", 
     &                             TRUST_RAD, TAU
#endif
            IF (TAU.GT.TRUST_RAD) THEN
                SCALE = TRUST_RAD/TAU
            ELSE
                SCALE = ONE
            END IF

         ELSE IF (DELTXT_DELTX) THEN

            dtmp = xdot(NOPT,SCRATCH(NOPT+1),1,SCRATCH(NOPT+1),1)
            STPMAG = DSQRT(dtmp)
            SCALE = MIN(STPMAX/MAX(STPMAG,1.0d-7), 1.0D0)

         ELSE IF (ABSLT_LARGST) THEN

            CALL VSTAT(SCRATCH(NOPT + 1), AV(1), NOPT)
            SCALE = MIN(STPMAX/MAX(AV(1), 1.0D-7), 1.0D0)
            STPMAG=MAX(1.0D-7, AV(1))

         END IF

C     ELSE IF (NCYCLE.LT.2) THEN
      ELSE

         IF (TRUST_RADIUS) THEN

            IF (NCYCLE.EQ.1) THEN
               CALL PUTREC(1,'JOBARC','T_RADIUS',IINTFP,BEGN_TRUST_RAD)
            END IF
            TAU = DSQRT(DDOT(NXM6, STEP, 1, STEP, 1))
            IF (TAU.GT.STPMAX) THEN
               SCALE = BEGN_TRUST_RAD/TAU
            ELSE
               SCALE = ONE
            END IF
            STPMAG = TAU
         ELSE IF (DELTXT_DELTX) THEN

            dtmp = xdot(NOPT,SCRATCH(NOPT+1),1,SCRATCH(NOPT+1),1)
            STPMAG = DSQRT(dtmp)
            SCALE = MIN(STPMAX/MAX(STPMAG,1.0d-7), 1.0D0)

         ELSE IF (ABSLT_LARGST) THEN

            CALL VSTAT(SCRATCH(NOPT + 1), AV(1), NOPT)
            SCALE = MIN(STPMAX/MAX(AV(1), 1.0D-7), 1.0D0)
            STPMAG=MAX(1.0D-7, AV(1))

         END IF

      END IF
C
C Update the R vector
C
      IF (SCALE .NE. 1.0D0) CALL xscal(NOPT,SCALE,SCRATCH(NOPT+1),1)
C
      CALL PUTREC(1,'JOBARC','OLDGEOMT',NXM6*IINTFP,SCRATCH(NOPT+1))
C
      CALL VADD(SCRATCH(1), SCRATCH(1), SCRATCH(NOPT+1), NOPT, 1.0D0)
C
C Unpak the scratch array and regenerate the full R vector. Also
C unpak the step vector to avoid any problems with Hessian updates
C in the next cycle. 
C
      DO 400 J = 1, NOPT
C
         R(NOPTI(J)) = SCRATCH(J)
         STEP(NOPTI(J)) = SCRATCH(J + NOPT)
C
         DO 410 K=1, NEQ(NOPTI(J))
C
            STEP(IQFIX(NOPTI(J), K)) = SCRATCH(J + NOPT)
            R(IQFIX(NOPTI(J), K)) = SCRATCH(J)
C
 410     CONTINUE
 400  CONTINUE
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      WRITE(6,*) "The scaling factor", scale
      Write(6,*) "The R vector to check I can have the old R"
      Write(6,"(5F13.7)"), (R(I), I =1, NXM6)
#endif
C
C
C Calculate the predicted energy change (Grad DeltaX + 1/2 DelatX H DeltaX)
C
      IF (TRUST_RADIUS) THEN

         CALL XGEMM('N','N',NOPT,1,NOPT,
     &              ONE, HES,              NOPT,
     &                   SCRATCH(1+NOPT),  NOPT,
     &              ZERO,SCRATCH(1+NOPT*2),NOPT)
C
C The predicted energy change.
C
         PRD_ENRG_CHNG = DDOT(NOPT, GRAD, 1, SCRATCH(NOPT + 1), 1) +
     &                   0.5d0*DDOT(NOPT, SCRATCH(2*NOPT + 1), 1,
     &                   SCRATCH(NOPT + 1), 1)
         TAU = DSQRT(DDOT(NXM6, STEP, 1, STEP, 1))
         STPMAG = TAU
CSSS         Write(6,*) "The abs step size in cycles :", TAU, STPMAX
         CALL PUTREC(1,'JOBARC','PRDENCHN',IINTFP,PRD_ENRG_CHNG)
         CALL PUTREC(1,'JOBARC','PRVIUTAU',IINTFP,TAU)

      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine der_int_setup(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c   Establishes the array indices for a derivative integral calculation.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'saved_data.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k
      integer flag, handle, index, nindex, ierr
      integer blk, blkndx

      integer dx1,dy1,dz1,dx2,dy2,dz2,dx3,dy3,dz3,dx4,dy4,dz4,
     *        derint_counter
      integer derint_array(12)
      common /derint/dx1,dy1,dz1,dx2,dy2,dz2,dx3,dy3,dz3,dx4,dy4,dz4,
     *               derint_counter
      equivalence (derint_array(1), dx1)

      if (first_der_int_setup) then
         derint_counter = 0
         first_der_int_setup = .false.
      endif
      
c-------------------------------------------------------------------------
c   Put the array index in the appropriate slot.
c-------------------------------------------------------------------------

      derint_counter = derint_counter + 1
      if (derint_counter .gt. 12) derint_counter = 1

      handle = op(c_result_array)
      derint_array(derint_counter) = handle

c------------------------------------------------------------------------
c   Make sure the requested block exists.  create_current_block will
c   create the block if it does not exist, and simply return if the
c   block is already present.
c------------------------------------------------------------------------
                                                                                
      call create_current_block(handle,array_table,
     *                 narray_table, index_table,
     *                 nindex_table, segment_table, nsegment_table,
     *                 block_map_table, nblock_map_table, op,
     *                 .true., .false., blk, ierr)
      blkndx = ierr
                                                                                
      call get_block_computed_flag(handle, blk, blkndx, flag)
      if (flag .eq. 0) then
         call set_opblock(handle, blk, blkndx, op)
         call set_block_computed_flag(handle, blk, blkndx, 1)
      endif

      return
      end

       SUBROUTINE GENRST(J,SCR,NTIME,NUMTIM,IORDGP,JX,CLSTYP)
C
C THIS SUBROUTINE GENERATES THE REMAINING TRANSFORMATION MATRICES
C  BELONGING TO A GIVEN CLASS BY SUCCESSIVELY APPLYING A PARTICULAR
C  TRANSFORMATION MATRIX.  PARTICULARLY USEFUL FOR NON-CUBIC GROUPS.
C
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DIMENSION SCR(9*IORDGP)
       INTEGER CLSTYP(IORDGP) 
       IP(I)=1+9*(I-1) 
       DO 10 I=1,NUMTIM
        NTIME=NTIME+1
        CALL UNITRY(SCR(IP(J)),SCR(IP(NTIME-1)),SCR(IP(NTIME)),3)
        CLSTYP(NTIME)=JX
10     CONTINUE
       RETURN
       END

C Compute a "new" gradient using the SCF gradient and the
C total (SCF + correlation) gradient. This can be considered
C as one (among a family) of gradient extrapolation schemes.
C See (???) for further details.

      SUBROUTINE EXTRAP_GRAD(SCF_GRAD, TOT_GRAD, NATOMS, STRING)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "machsp.com"
#include "flags.h"
#include "flags.com"
C
      DIMENSION SCF_GRAD(3*NATOMS), TOT_GRAD(3*NATOMS)
      LOGICAL bExist, bPrint
      CHARACTER*(*) STRING
C
      bPrint = (iflags(h_IFLAGS_print).GE.10)
C
C Takashi, extrapolation formula goes here, and the extrapolated
C gradient should be stored back into TOT_GRAD.
C
      INQUIRE(FILE='fact',EXIST=bExist)
      IF (bExist) THEN
c         OPEN(99,FILE='fact',FORM='UNFORMATTED', STATUS='OLD')
         OPEN(UNIT=99,FILE='fact',FORM='FORMATTED',STATUS='OLD')
         READ(99,*) FACT
         CLOSE(99)
c         write(*,*) FACT
      ELSE
         PRINT *, "@EXTRAP_GRAD: The formatted file 'fact' is missing."
         CALL ERREX
      END IF
C
      IF (STRING.EQ.'gradient') THEN
C
         CALL GETREC(1, "JOBARC", "SCF_GRAD", 3*NATOMS*IINTFP, SCF_GRAD)
         CALL GETREC(1, "JOBARC", "GRADIENT", 3*NATOMS*IINTFP, TOT_GRAD)
         IF (bPrint) THEN
            write(*,'(" SCF_GRAD:\n",3(F15.10))')
     &               (SCF_GRAD(J),J=1,3*NATOMS)
            write(*,'(" TOT_GRAD:\n",3(F15.10))')
     &               (TOT_GRAD(J),J=1,3*NATOMS)
         END IF
C
         DO I = 1,3*NATOMS
            TOT_GRAD(I) =   SCF_GRAD(I)
     &                    + (TOT_GRAD(I)-SCF_GRAD(I))/FACT
         END DO
         IF (bPrint) THEN
            PRINT *
            PRINT *, " The Extrapolated Total Gradients"
            CALL OUTPUT(TOT_GRAD, 1, NATOMS, 1, 3, NATOMS, 3, 0)
         END IF
C
         CALL PUTREC(1, "JOBARC", "GRADIENT", 3*NATOMS*IINTFP, TOT_GRAD)

      ELSE IF (STRING.EQ."energy") THEN
C
         CALL GETREC(1, "JOBARC", "SCFENEG ", IINTFP, SCF_ENEG)
         CALL GETREC(1, "JOBARC", "TOTENERG", IINTFP, ETOT)
         IF (bPrint) THEN
            write(*,'(" SCF_ENEG=",F16.10," a.u.")') SCF_ENEG
            write(*,'(" ETOT    =",F16.10," a.u.")') ETOT
         END IF
C
         ESAC = SCF_ENEG + (ETOT-SCF_ENEG)/FACT
         WRITE(6,2) ESAC
    2    FORMAT('  ','Total MBPT-SAC(2) energy =',F18.12,' a.u.')
C
         CALL PUTREC(1, "JOBARC", "TOTENERG", IINTFP, ESAC)
C
      ELSE

         print *, '@EXTRAP_GRAD: unknown argument'
         print *, '              TYPE = ',string(1:20)
         call errex

      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_E0_PCGTO_BLOCK
     +
     +                    ( NBATCH,NINT1D,
     +                      ATOMIC,
     +                      MIJ,NCEN,MIJCEN,
     +                      NIJ,NIJBEG,NIJEND,
     +                      NGQP,NMOM,NGQSCR,MGIJCEN,
     +                      NPGTOA,NPGTOB,
     +                      NXYZET,NXYZP,
     +                      SHELLA,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      NUCLEI,
     +                      XN,YN,ZN,NCHARGE,
     +                      NUCCEN,
     +                      ALPHAA,ALPHAB,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      PX,PY,PZ,PAX,PAY,PAZ,PINVHF,SCALE,
     +                      RTS,WTS,GQSCR,TVAL,
     +                      R1X,R1Y,R1Z,R2,
     +                      INT1DX,INT1DY,INT1DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_E0_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__RYS_ROOTS_WEIGHTS
C                OED__NAI_1D_COEFFICIENTS
C                OED__NAI_1D_P_INTEGRALS
C                OED__NAI_INT1D_TO_E0
C  DESCRIPTION : This operation calculates a batch of unnormed nuclear
C                attraction integrals between primitive cartesian
C                gaussians for the shell range:
C
C                              [E|0]   , E = A to T = A + B
C                                   ij
C
C                and the block of ij exponent pairs. The total number
C                of nuclear attraction integrals generated here is thus
C                given by the total number of cartesian monomials NXYZET
C                times the total number of exponent pairs MIJ in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyzet)
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    integral batch
C                    NINT1D       =  space needed for each of the 1D
C                                    X,Y,Z integral arrays
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NCEN         =  # of nuclear attraction centers
C                    MIJCEN       =  # of ij primitive index pairs
C                                    times # of nuclear attraction
C                                    centers
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    MGIJCEN      =  # of roots times # of ij primitive
C                                    index pairs times # of nuclear
C                                    attraction centers
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZET       =  sum of # of cartesian monomials
C                                    for all shells in the range
C                                    E = A,...,P=A+B
C                    NXYZP        =  # of cartesian monomials for
C                                    the P=A+B shell
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    NUCLEI       =  # of nuclear attraction centers
C                    XN,YN,ZN     =  the x,y,z-coordinates for all
C                                    nuclear attraction centers
C                    NCHARGE      =  the nuclear charges for all
C                                    nuclear attraction centers
C                    NUCCEN       =  contains those index labels of
C                                    the nuclear attraction centers
C                                    that survived the screening process
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=A+B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current distinct MIJCEN
C                                    (expanded to MGIJCEN) values of
C                                    scaling factors
C                    RTS          =  will hold all current MGIJCEN
C                                    quadrature roots
C                    WTS          =  will hold all current MGIJCEN
C                                    quadrature weights
C                    GQSCR        =  will be used as scratch space
C                                    for determining the quadrature
C                                    roots and weights
C                    TVAL         =  will hold current MIJCEN values
C                                    of T-exponents defining the Rys
C                                    weight functions
C                    R1x          =  will hold the current MGIJCEN
C                                    VRR R1-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    R2           =  will hold the current MGIJCEN
C                                    coordinate independent VRR
C                                    R2-coefficients
C                    INT1Dx       =  will hold all current 1D integrals
C                                    for each cartesian component
C                                    (x = X,Y,Z)
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian nuclear attraction
C                                    [E|0] integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     G000,G010,G020,G030,G040,G050,G060
         INTEGER     I,J,L,M,N
         INTEGER     IXC
         INTEGER     IJ
         INTEGER     MGRID,NGRID
         INTEGER     MIJ,MIJCEN
         INTEGER     NBATCH,NINT1D
         INTEGER     NC,NCEN
         INTEGER     NG,NGQP,NGQPCEN,NMOM,NGQSCR,MGIJCEN
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NUCLEI
         INTEGER     NXYZET,NXYZP
         INTEGER     SHELLA,SHELLP

         INTEGER     NUCCEN (1:NCEN)

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  P,PINV,PVAL
         DOUBLE PRECISION  PCX,PCY,PCZ
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL
         DOUBLE PRECISION  RNPCSQ
         DOUBLE PRECISION  SCALEM,SCALEN
         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,HALF,ONE

         DOUBLE PRECISION  XN      (1:NUCLEI)
         DOUBLE PRECISION  YN      (1:NUCLEI)
         DOUBLE PRECISION  ZN      (1:NUCLEI)
         DOUBLE PRECISION  NCHARGE (1:NUCLEI)

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  PX      (1:MIJ)
         DOUBLE PRECISION  PY      (1:MIJ)
         DOUBLE PRECISION  PZ      (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)

         DOUBLE PRECISION  GQSCR   (1:NGQSCR)
         DOUBLE PRECISION  TVAL    (1:MIJCEN)

         DOUBLE PRECISION  R1X     (1:MGIJCEN)
         DOUBLE PRECISION  R1Y     (1:MGIJCEN)
         DOUBLE PRECISION  R1Z     (1:MGIJCEN)
         DOUBLE PRECISION  R2      (1:MGIJCEN)
         DOUBLE PRECISION  RTS     (1:MGIJCEN)
         DOUBLE PRECISION  SCALE   (1:MGIJCEN)
         DOUBLE PRECISION  WTS     (1:MGIJCEN)

         DOUBLE PRECISION  INT1DX  (1:NINT1D)
         DOUBLE PRECISION  INT1DY  (1:NINT1D)
         DOUBLE PRECISION  INT1DZ  (1:NINT1D)

         DOUBLE PRECISION  FTABLE  (0:MGRID,0:NGRID)

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (HALF = 0.5D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D nuclear attraction integrals.
C
C
         IF (ATOMIC) THEN
             L = 0
             M = 0
             N = 0
             DO IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                P = ALPHAA (I) + ALPHAB (J)
                PX (M) = XA
                PY (M) = YA
                PZ (M) = ZA
                PINV = ONE / P
                PINVHF (M) = HALF * PINV
                SCALEM = PINV * NORMA (I) * NORMB (J)
                DO NC = 1,NCEN
                   N = N + 1
                   IXC = NUCCEN (NC)
                   PCX = XA - XN (IXC)
                   PCY = YA - YN (IXC)
                   PCZ = ZA - ZN (IXC)
                   RNPCSQ = PCX * PCX + PCY * PCY + PCZ * PCZ
                   TVAL (N) = P * RNPCSQ
                   SCALEN = SCALEM * NCHARGE (IXC)
                   DO NG = 1,NGQP
                      L = L + 1
                      SCALE (L) = SCALEN
                   END DO
                END DO
             END DO
         ELSE
             L = 0
             M = 0
             N = 0
             DO IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                P = EXPA + EXPB
                PINV = ONE / P
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PXVAL = PAX (M) + XA
                PYVAL = PAY (M) + YA
                PZVAL = PAZ (M) + ZA
                PX (M) = PXVAL
                PY (M) = PYVAL
                PZ (M) = PZVAL
                PINVHF (M) = HALF * PINV
                SCALEM = PINV * NORMA (I) * NORMB (J) * RHOAB (IJ)
                DO NC = 1,NCEN
                   N = N + 1
                   IXC = NUCCEN (NC)
                   PCX = PXVAL - XN (IXC)
                   PCY = PYVAL - YN (IXC)
                   PCZ = PZVAL - ZN (IXC)
                   RNPCSQ = PCX * PCX + PCY * PCY + PCZ * PCZ
                   TVAL (N) = P * RNPCSQ
                   SCALEN = SCALEM * NCHARGE (IXC)
                   DO NG = 1,NGQP
                      L = L + 1
                      SCALE (L) = SCALEN
                   END DO
                END DO
             END DO
         END IF
C
C
C             ...determine memory allocation offsets for the scratch
C                arrays used to calculate the quadrature roots +
C                weights:
C
C                   G000 = offset for A coefficients (Jacobi/Laguerre)
C                   G010 = offset for B coefficients (Jacobi/Laguerre)
C                   G020 = offset for moments (Jacobi/Laguerre)
C                   G030 = offset for diagonals of symmetric termat
C                   G040 = offset for offdiagonals of symmetric termat
C                   G050 = offset for first row intermediates during
C                          evaluation of symmetric termat
C                   G060 = offset for second row intermediates during
C                          evaluation of symmetric termat
C
C
         G000 = 1
         G010 = G000 + NMOM
         G020 = G010 + NMOM - 1
         G030 = G020 + NMOM
         G040 = G030 + NGQP
         G050 = G040 + NGQP
         G060 = G050 + NMOM
C
C
C             ...calculate all roots and weights for all ij pairs and
C                nuclear centers. Array R2 is passed as a scratch array.
C
C
         CALL    OED__RYS_ROOTS_WEIGHTS
     +
     +                ( MIJCEN,MGIJCEN,
     +                  NGQP,NMOM,
     +                  TVAL,R2,
     +                  FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                  GQSCR(G000),GQSCR(G010),
     +                  GQSCR(G020),
     +                  GQSCR(G030),GQSCR(G040),
     +                  GQSCR(G050),GQSCR(G060),
     +
     +                           RTS,
     +                           WTS )
     +
     +
C
C
C             ...perform the following steps:
C
C                1) construct all 1D x,y,z VRR coefficients for all
C                   ij pairs, nuclear centers and quadrature points.
C
C                2) construct all 1D x,y,z nuclear attraction integrals
C                   for all ij pairs, nuclear centers and quadrature
C                   points.
C
C                3) assemble the complete [E|0] overlap batch for all
C                   ij pairs using the 1D integrals. Arrays R1X and R1Y
C                   are passed as scratch arrays.
C
C
         CALL    OED__NAI_1D_COEFFICIENTS
     +
     +                ( NGQP,NCEN,
     +                  MIJ,MGIJCEN,
     +                  ATOMIC,
     +                  NUCLEI,
     +                  XN,YN,ZN,
     +                  NUCCEN,
     +                  PX,PY,PZ,
     +                  PAX,PAY,PAZ,
     +                  PINVHF,
     +                  RTS,
     +
     +                            R1X,R1Y,R1Z,
     +                            R2 )
     +
     +
         CALL    OED__NAI_1D_P_INTEGRALS
     +
     +                ( SHELLP,
     +                  MGIJCEN,
     +                  WTS,
     +                  R1X,R1Y,R1Z,
     +                  R2,
     +
     +                            INT1DX,
     +                            INT1DY,
     +                            INT1DZ )
     +
     +
         IF (SHELLP.EQ.0) THEN

             N = 0
             DO J = 1,MIJ
                SUM = ZERO
                DO I = 1,NCEN
                   SUM = SUM + SCALE (N+I) * INT1DX (N+I)
                END DO
                BATCH (J) = SUM
                N = N + NCEN
             END DO

         ELSE
             NGQPCEN = NGQP * NCEN

             CALL    OED__NAI_INT1D_TO_E0
     +
     +                    ( SHELLA,SHELLP,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZET,NXYZP,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      R1X,R1Y,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C
      Subroutine Coriolis_cc(Natom,Nreal,Nx,Nxm6,AtmMass,Coord,Bmat,
     &                       Gmat,Hess,vectors,vib_vectors,Btmp,Scr1,
     &                       Scr2,DM_matx,DM_maty,DM_matz,Iztov,iuhf)
C
      Implicit double precision (a-h,o-z)
C
#include "machsp.com"
#include "mxatms.par"
C
      PARAMETER(EPSILON = 1.0D-8)
      Logical FCM_EXIST
      Character*5 AtmLabel(Mxatms)
      Character*4 IrrepLabel(3*Mxatms)
C
      Dimension AtmMass(Natom),Coord(Natom*3),Bmat(Nxm6,Nx),
     &          Gmat(Nx,Nx),Gmat_inv(Nx*Nx),
     &          Hess(Nx,Nx),vectors(Nx*NX),vib_vectors(Nx*Nxm6),
     &          scr1(Nx,Nx),Btmp(Nx*Nxm6),Scr2(Nx,Nx),
     &          DM_matx(Nx,Nx),DM_maty(Nx,Nx),DM_matz(Nx,NX),
     &          Ivtoz(Natom)
C
      Double Precision M_subx(3,3),M_suby(3,3),M_subz(3,3),Mass

C     translation factor from bohr to angstrom
      Parameter (b2ang=1.889725989,wavens=5.14048D03)
C
      Call Getcrec(1,'JOBARC','ZSYM',5*Natom,AtmLabel)
      Call Getcrec(1,'JOBARC','VIB_SYMS',4*Nx,IrrepLabel)
      Call Getrec(20,'JOBARC','ATOMMASS',Natom*IINTFP,Btmp)
      Call Getrec(20,'JOBARC','COORD   ',3*Natom*IINTFP,Coord)
      Call Getrec(20,'JOBARC','BMATRIXC',NX*Nxm6*IINTFP, Bmat) 
      CALL Getrec(20,'JOBARC','CARTHESC',Nx*Nx*IINTFP,Hess)
      Call Getrec(20,'JOBARC','MAP2ZMAT',Natom,Ivtoz)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a,I3)") "The Number of Real Atoms: ", Nreal
      Write(6,"(a,I3)") "The Number of Atoms:", Natom
      Write(6 ,"(1x,a5)") (AtmLabel(i),i=1,Natom)
      Write(6,*) 
      Write(6,*) "The Cartesian Coordinate in comp order"
      Write(6,*)
      ioff = 1
      Do I = 1, Natom
         Write(6, "(3F10.5)") (Coord(ioff+j-1), J=1,3)
         ioff = ioff + 3
      Enddo
      Write(6,*)
      Write(6,*) "The Bmatrix"
      CALL OUTPUT(Bmat, 1, Nxm6, 1, Nx, Nxm6, Nx, 1)
      Write(6,*)
      Write(6,"(a)") "The Hessian matrix"
      CALL OUTPUT(Hess, 1, Nx, 1, Nx, Nx, Nx, 1)
#endif
C Remove dummyies from the atomic mass array
C
      Ireal = 0
      Do Iatom = 1, Natom
         If (.Not. (Btmp(Iatom) .lt. 0.50D0)) Then
            Ireal = Ireal + 1
            AtmMass(Ireal) = Btmp(Iatom)
         Endif
      Enddo 
C
#ifdef _NO_SKIP
      Ioff = 1
      Do Iatom = 1, Natom
         Izmat = Ivtoz(Iatom)
         Joff = (Izmat-1)*3 + 1
         Call Dcopy(3, Coord(Ioff), 1, Btmp(Joff), 1)
         Ioff = Ioff + 3
      Enddo
      Call Dcopy(Nx, Btmp, 1, Coord, 1)
C
#ifdef _DEBUG_LVL0
      Write(6,*) "The Cartesian Coordinate in comp order"
      ioff = 1
      Do I = 1, Natom
         Write(6, "(3F10.5)") (Coord(ioff-1+j), j=1,3)
         ioff = ioff + 3
      Enddo
#endif
#endif
C
C Mass weigh the B-Matrix.
C
      Do Iint = 1, Nxm6
         Ixyz  = 0
         Iatom = 0
C
         Do Icart = 1, Nx/3
            Iatom = Iatom + 1
            Do Jatom = 1, 3
               Ixyz = Ixyz + 1
#ifdef _DEBUG_LVLM1
               Write(6,"(2I2,F15.6)") ixyz, Iatom, AtmMass(Iatom)
#endif
               If (AtmMass(Iatom) .eq. 0.0D0) Then 
                  Bmat(Iint, Icart) = 0.0D0
               Else
                  Bmat(Iint, Icart) = (1.0D0/DSQRT(AtmMass(Iatom)))*
     &                              Bmat(Iint, Ixyz)
               Endif
            Enddo
         Enddo
      Enddo
C
C Mass weigh the Hessian and obtain the normal modes.
C
      Do Ideg = 1, Nx
         Do Jdeg = 1, Nx
            Mass = DSQRT(AtmMass(1+(Ideg-1)/3)*AtmMass(1+(Jdeg-1)/3))
            IF (Mass .lt. 1.0D-3) Then
               Hess(Ideg, Jdeg) = 0.0D0
            Else
               Hess(Ideg, Jdeg) = Hess(Ideg, Jdeg)/Mass
            Endif
         Enddo
      Enddo 
C
#ifdef _DEBUG_LVLM1
      Write(6,*) 
      Write(6,"(a)") "The mass weighted Hessian matrix"
      CALL OUTPUT(Hess, 1, Nx, 1, Nx, Nx, Nx, 1)
#endif
      Call Eig(Hess, vectors, Junk, Nx, 0)
      CALL Getrec(20, "JOBARC", "SYM_NMDS", Nx*Nx*IINTFP, Vectors) 
      Call Dcopy(Nxm6*Nx, vectors(6*Nx+1), 1, vib_vectors, 1)
C
      Do I = 1, NX
         IF (Hess(I,I) .Lt. 0.0D0 .and. (Dabs(Hess(I,I)) .gt.
     &       1.0D0)) Then
            Write(6,"(a,a)")" Imaginary eigenvlaues in the Hessian,",
     &                       " modifications to the code" 
            Write(6,"(a)")" need to be made to handle them"
            Call Errex
         Endif
      Enddo

#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a)") "The eig vectors of Hessian"
      CALL OUTPUT(vectors, 1, Nx, 1, Nx, Nx, Nx, 1)
      Write(6,*)
#endif
C
      Call print_coord(Coord, Atmlabel, B2ang, Natom)
      Call Header("The Normal modes", -1, 6)
      CALL OUTPUT(vib_vectors, 1, Nx, 1, Nxm6, Nx, Nxm6, 1)
      Write(6,*)
C
#ifdef _DEBUG_LVLM1
      Write(6,*) "Check for the sign convention using CH3+"
      Write(6,*) "Reverse the natural sign of mode 5" 
      Call Dscal(NX, -1.0D0, vib_vectors(4*Nx +1), 1)
      Call Header("The Normal modes with revese sign", -1, 6)
      CALL OUTPUT(vib_vectors, 1, Nx, 1, Nxm6, Nx, Nxm6, 1)
      Write(6,*)
      Write(6,*) "Check for the orthogonolity of modes"
      Call Xgemm("T", "N", NXM6, NXM6, NX, 1.0D0, vib_vectors, NX,
     &            Vib_vectors, NX, 0.0D0, Vectors, NX)
      CALL OUTPUT(vectors, 1, Nxm6, 1, Nxm6, Nx, Nx, 1)
#endif

      Call Header("The vibrational frequencies in cm^-1", -1, 6)
C
      Nleft = Mod(Nx, 5)
      istart = 1
      Iend   = 5
      Do Ivib = 1, Int(Nx/5)
         Write(6,"(11x,5(a,10x))") (IrrepLabel(I), I=Istart, Iend)
         Write(6,*)
         Write(6,"(5F15.5)") (wavens*DSQRT(DABS(Hess(i,i))),
     &         i=Istart, Iend)
         Write(6,*)
          istart = istart + 5
          Iend   = Iend   + 5
      Enddo
      If (Nleft .Ne. 0) Then
         Istart = Nx - Nleft + 1
         Iend   = Nx
         Write(6,"(11x,5(a,10x))") (IrrepLabel(I),I=Istart, Iend)
         Write(6,*)
         Write(6,"(5F15.5)") (wavens*DSQRT(DABS(Hess(i,i))),
     &         i=istart, iend)
      Endif
C
C Form the G^-1.
C
      Call Dcopy(Nx*NXm6, Bmat, 1, Btmp, 1)
C
      CALL XGEMM('N', 'T', Nxm6, Nxm6, Nx, 1.0D0, Bmat, Nxm6,
     &           Btmp, Nxm6, 0.0D0, Gmat, Nxm6)
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a)") "The G-Matrix:BB^t"
      CALL OUTPUT(Gmat, 1, Nxm6, 1, Nxm6, Nxm6, Nxm6, 1)
#endif

C
C The intermediate G matrix created above is linear dependent, hence
C there are eigenvalues that are zero. Invert the non-zero digonal
C elements to built the Lambda(-1) matrix.
C
      CALL EIG(Gmat, scr1, 1, Nxm6, 1)
C
      NULLEVAL = 0
      DO I = 1, Nxm6
         IF (Gmat(I, I) .LE. EPSILON) THEN
             NULLEVAL = NULLEVAL + 1
             Gmat(I, I) = 0.0D0
         ELSE
             Gmat(I, I) = 1.0D0/Gmat(I, I)
         ENDIF
      ENDDO
C
C Built the generalized inverse of G-matrix, what proceeded is generally
C known as singular value decomposition (ineversion of singular matrices)
C G^(-1) = [K L] Lambda^(-1)[K^(t) L^(t)]

      CALL XGEMM('N', 'N', Nxm6, Nxm6,  Nxm6, 1.0D0, Scr1, Nxm6,
     &           Gmat, Nxm6, 0.0D0, Scr2, Nxm6)
C
      CALL XGEMM('N', 'T', Nxm6, Nxm6, Nxm6, 1.0D0, Scr2, Nxm6,
     &            Scr1, Nxm6, 0.0D0, Gmat, Nxm6)
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,"(a)") "The G-1 matrix"
      CALL OUTPUT(Gmat, 1, Nxm6, 1, Nxm6, Nxm6, Nxm6, 1)
#endif
C
C Construct the M_sub and M_Mat for x, y and z directions.
C
      Call zero(M_Subx, 9)
      Call zero(M_suby, 9)
      Call zero(M_Subz, 9)
      
      M_subx(2,3) =  1.0D0
      M_Subx(3,2) = -1.0D0
      M_suby(1,3) = -1.0D0
      M_suby(3,1) =  1.0D0
      M_subz(1,2) =  1.0D0
      M_subz(2,1) = -1.0D0
C
      Call zero(DM_matx, Nx*NX)
      Call zero(DM_maty, Nx*Nx)
      Call zero(DM_matz, Nx*Nx)
   
      Do Iatom = 1, Nreal
         Do Jatom = 1, Nreal
            If (Iatom .EQ. Jatom) Then
                Ioff =  (Iatom-1)*3
                Joff =  (Jatom-1)*3
C
                Do I = 1, 3
                   Ioff = Ioff + 1
                   Do J = 1, 3
                      Joff = Joff + 1
C
                      DM_matx(Ioff, Joff) = M_subx(I, J)
                      DM_maty(Ioff, Joff) = M_suby(I, J)
                      DM_matz(Ioff, Joff) = M_subz(I, J)
C
                 Enddo
                 Joff = (Jatom-1)*3
               Enddo
           Endif
        Enddo
      Enddo
C
#ifdef _DEBUG_LVLM1
      Write(6,*)
      Write(6,*) "The MX Matrix"
      Call output(DM_mATX, 1, Nx, 1, Nx, Nx, Nx, 1)
      Write(6,*)
      Write(6,*) "The MY Matrx"
      Call output(DM_maty, 1, Nx, 1, Nx, Nx, Nx, 1)
      Write(6,*)
      Write(6,*) "The Mz Matrix"
      Call output(DM_matz, 1, Nx, 1, Nx, Nx, Nx, 1)
#endif
C X-Rotation
      call zero(scr2, Nx*Nx)
      CALL XGEMM('N', 'N', Nx, Nxm6, Nx, 1.0D0, DM_matx, Nx,
     &           Vib_Vectors, Nx, 0.0D0, Scr1, Nx)
C
      CALL XGEMM('T', 'N', Nxm6, Nxm6, Nx, 1.0D0, Vib_Vectors,
     &            Nx, Scr1, Nx, 0.0D0, Scr2, Nxm6)
C
      Call Header("The Coriolis Coupling Coefficients, Rotation on X",
     &             -1, 6)
      Call output(Scr2, 1, Nxm6, 1, Nxm6, Nxm6, Nxm6, 1)
      Write(6,*)
C Y-Rotation
      call zero(scr2, Nx*Nx)
      CALL XGEMM('N', 'N', Nx, Nxm6, Nx, 1.0D0, DM_maty, Nx,
     &           Vib_Vectors, Nx, 0.0D0, Scr1, Nx)
C
      CALL XGEMM('T', 'N', Nxm6, Nxm6, Nx, 1.0D0, Vib_Vectors,
     &            Nx, Scr1, Nx, 0.0D0, Scr2, Nxm6)
C
      Call Header("The Coriolis Coupling Coefficients, Rotation on Y", 
     &             -1, 6)
      Call output(Scr2, 1, Nxm6, 1, Nxm6, Nxm6, Nxm6, 1)
C Z-Rotation
      call zero(scr2, Nx*Nx)
      CALL XGEMM('N', 'N', Nx, Nxm6, Nx, 1.0D0, DM_matz, Nx,
     &           Vib_Vectors, Nx, 0.0D0, Scr1, Nx)
C
      CALL XGEMM('T', 'N', Nxm6, Nxm6, Nx, 1.0D0, Vib_Vectors,
     &            Nx, Scr1, Nx, 0.0D0, Scr2, Nxm6)
C
      Call Header("The Coriolis Coupling Coefficients, Rotation on Z", 
     &             -1, 6)
      Call output(Scr2, 1, Nxm6, 1, Nxm6, Nxm6, Nxm6, 1)

      Write(6,*) 
      Write(6,"(T2,a,a)") "Coriolis Coupling constants were",
     &                    " successfully computed" 
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      DOUBLE PRECISION FUNCTION XTRACE(A,N)
      IMPLICIT NONE
      INTEGER N, INC, I, ADD
      DOUBLE PRECISION A(N*N)
      XTRACE = A(1)
      INC = N + 1
      ADD = 1
      DO I = 1, N-1
         ADD = ADD + INC
         XTRACE = XTRACE + A(ADD)
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine temp_x(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c-------------------------------------------------------------------------- 
      implicit none
      include 'mpif.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table, array 
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table), get_index_from_base
      integer*8 get_block_data_index
      integer find_current_block, block 

      integer array_type, nindex, inda(2), indb(2)    

      logical direct_flag

      integer i, j, k
      integer nind, nsend
      integer ierr, handle
      integer blk, blkndx, maxblk
      integer*8 iarray, dens_array, indblk, get_block_index
      integer*8 ibarray, fbarray 
      integer ind, seg, val1(mx_array_index), val2(mx_array_index)
      integer msg(len_sip_server_message)
      integer flag
      integer stack
      integer sind,type  

      double precision x(1)
      double precision dbuf(1), temp 
      integer ibuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
      pointer (xptr, x)
      pointer (iptr, ibuf)
#else
      common dbuf, x
      equivalence (ibuf(1), dbuf(1))
#endif

      common /d2int_com/jatom, jx, jcenter
      integer jatom, jx, jcenter

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
      xptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Get the density array
c----------------------------------------------------------------------------

      array = op(c_result_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. static_array) then
         print *,'Error: density array must be static in ',
     *           'dens2jobarc'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)

      if (nindex .ne. 2) then
         print *,'Error: DENS array must have ',
     *           'two indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         inda(i) = index_table(c_index_size, na)  ! pick up length of index
      enddo

      dens_array = get_index_from_base(address_table(array), x, 2)

c----------------------------------------------------------------------------
c   Get the type of density
c----------------------------------------------------------------------------
      array       = op(c_op1_array)
      array_type  = array_table(c_array_type, array)
      nindex      = array_table(c_nindex, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: scalar not sent in dens2jobarc.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      sind =  array_table(c_scalar_index, array)
      if (sind .lt. 1 .or. sind .gt. nscalar_table) then
         print *,'Scalar table index out of range in dens2jobarc, ',
     *           'line ',current_line
         print *,'Index for array ',array,' is ',sind,' should be ',
     *           'between 1 and ',nscalar_table
         call abort_job()
      endif
      type = INT (scalar_table(sind))

      CALL  DO_THE_WRITING (x(dens_array),inda(1),inda(2),type,
     +                      ibuf,dbuf)

      return
      end
c---------------------------------------------------------------------------

      SUBROUTINE  DO_THE_WRITING (DENS,NDIM1,NDIM2,TYPE,ibuf,dbuf)

      IMPLICIT    NONE

      INCLUDE 'interpreter.h'
      INCLUDE 'int_gen_parms.h'
      INCLUDE 'parallel_info.h'

      INTEGER    NDIM,NDIM1,NDIM2,MU,NU
      INTEGER    ierd,ierd1,ierd2
      INTEGER    TYPE
      INTEGER    ibuf (*)

      CHARACTER*8  JALABEL

      DOUBLE PRECISION  dscale

      DOUBLE PRECISION  DENS (1:NDIM1,1:NDIM2)
      DOUBLE PRECISION  SCR  (1:NDIM1,1:NDIM2)
      DOUBLE PRECISION  SCR1 (1:NDIM1)
      DOUBLE PRECISION  dbuf (*)

      IF (me .EQ. 0) THEN

         IF      (type .EQ.  0) THEN
            JALABEL='HFDENSTY'
         ELSE IF (type .EQ.  1) THEN
            JALABEL='TDENSITY'

         ELSE IF (type .EQ.  2) THEN
            JALABEL='REOMDN01'
         ELSE IF (type .EQ.  3) THEN
            JALABEL='LEOMDN01'
         ELSE IF (type .EQ.  4) THEN
            JALABEL='EXCDEN01'

         ELSE IF (type .EQ.  5) THEN
            JALABEL='REOMDN02'
         ELSE IF (type .EQ.  6) THEN
            JALABEL='LEOMDN02'
         ELSE IF (type .EQ.  7) THEN
            JALABEL='EXCDEN02'

         ELSE IF (type .EQ.  8) THEN
            JALABEL='REOMDN03'
         ELSE IF (type .EQ.  9) THEN
            JALABEL='LEOMDN03'
         ELSE IF (type .EQ. 10) THEN
            JALABEL='EXCDEN03'

         ELSE IF (type .EQ. 11) THEN
            JALABEL='REOMDN04'
         ELSE IF (type .EQ. 12) THEN
            JALABEL='LEOMDN04'
         ELSE IF (type .EQ. 13) THEN
            JALABEL='EXCDEN04'

         ELSE IF (type .EQ. 14) THEN
            JALABEL='REOMDN05'
         ELSE IF (type .EQ. 15) THEN
            JALABEL='LEOMDN05'
         ELSE IF (type .EQ. 16) THEN
            JALABEL='EXCDEN05'

         ELSE IF (type .EQ. 17) THEN
            JALABEL='REOMDN06'
         ELSE IF (type .EQ. 18) THEN
            JALABEL='LEOMDN06'
         ELSE IF (type .EQ. 19) THEN
            JALABEL='EXCDEN06'

         ELSE IF (type .EQ. 20) THEN
            JALABEL='REOMDN07'
         ELSE IF (type .EQ. 21) THEN
            JALABEL='LEOMDN07'
         ELSE IF (type .EQ. 22) THEN
            JALABEL='EXCDEN07'

         ELSE IF (type .EQ. 23) THEN
            JALABEL='REOMDN08'
         ELSE IF (type .EQ. 24) THEN
            JALABEL='LEOMDN08'
         ELSE IF (type .EQ. 25) THEN
            JALABEL='EXCDEN08'

         ELSE IF (type .EQ. 26) THEN
            JALABEL='REOMDN09'
         ELSE IF (type .EQ. 27) THEN
            JALABEL='LEOMDN09'
         ELSE IF (type .EQ. 28) THEN
            JALABEL='EXCDEN09'

         ELSE IF (type .EQ. 29) THEN
            JALABEL='REOMDN10'
         ELSE IF (type .EQ. 30) THEN
            JALABEL='LEOMDN10'
         ELSE IF (type .EQ. 31) THEN
            JALABEL='EXCDEN10'

         ELSE IF (type .EQ. 32) THEN
            JALABEL='REOMDN11'
         ELSE IF (type .EQ. 33) THEN
            JALABEL='LEOMDN11'
         ELSE IF (type .EQ. 34) THEN
            JALABEL='EXCDEN11'

         ELSE IF (type .EQ. 35) THEN
            JALABEL='REOMDN12'
         ELSE IF (type .EQ. 36) THEN
            JALABEL='LEOMDN12'
         ELSE IF (type .EQ. 37) THEN
            JALABEL='EXCDEN12'

         ELSE IF (type .EQ. -1) THEN ! Special for now 5-2011
            JALABEL='AOOVRLAP'
            WRITE (*,*)
            WRITE (*,*) ' Writing atomic overlap integrals to JOBARC '
            WRITE (*,*)

         ELSE

            WRITE (*,*)
            WRITE (*,*) ' No density for this integer label! '
            RETURN

         ENDIF

         IF (intpkg .eq. flocke_package) THEN

             do nu = 1, ndim2
             do mu = 1, ndim1
                scr(mu,nu) = dens(mu,nu)
             enddo
             enddo

          if (type .eq. -1) then 
             do nu = 1, ndim2
             do mu = 1, ndim1
                ierd1 = ibuf (ierdind+mu-1)
                ierd2 = ibuf (ierdind+nu-1)
                dscale = dbuf(iscale_fac+ierd1-1) * 
     *                   dbuf(iscale_fac+ierd2-1)
                dens(ierd1,ierd2) = scr(mu,nu) * dscale
             enddo
             enddo
          else 
             do nu = 1, ndim2
             do mu = 1, ndim1
                ierd1 = ibuf (ierdind+mu-1)
                ierd2 = ibuf (ierdind+nu-1)
                dscale = dbuf(iscale_fac+ierd1-1) * 
     *                   dbuf(iscale_fac+ierd2-1)
                dens(ierd1,ierd2) = scr(mu,nu) / dscale
             enddo
             enddo
          endif 
C
c            do nu = 1, ndim2
c
c               do mu = 1, ndim1
c                  scr1(mu) = dens (mu,nu)
c               enddo
c
c               do mu = 1, ndim1
c                  ierd = ibuf (ierdind+mu-1)
c                  dens (ierd,mu) = scr1(mu) / dbuf (iscale_fac+ierd-1)
c               enddo
c
c            enddo
c
c            do mu = 1, ndim1
c
c               do nu = 1, ndim2
c                  scr1(nu)= dens (mu,nu)
c               enddo
c
c               do nu = 1, ndim2
c                  ierd = ibuf (ierdind+nu-1)
c                  dens (nu,ierd) = scr1(nu) / dbuf (iscale_fac+ierd-1)
c               enddo
c
c            enddo

         ENDIF

         CALL  DESCRAMBLE_MATRIX
     +
     +               (DENS,NDIM1,NFPS,IXSHELLS,NSHELLS)
     +
     +
         NDIM = NDIM1 * NDIM2
         CALL  DPUTREC (1, 'JOBARC', JALABEL, NDIM,DENS)

      ENDIF

      RETURN
      END

C
CJDW  6/ 6/95. Add JFS new improved version of PDSWAP.
C
      SUBROUTINE PDSWAP(EVEC,IANGBF,SCR,NAO, NBAS)
      Integer NAO, NBas
      Double precision EVEC(NAO,NBAS),SCR(NAO,NBAS)
      Integer IANGBF(NAO),junk(10000)
cAP - 500 is the maximum number of shells (not basis functions)
      dimension nshlang(500),nshlnum(500)
      Integer MaxAng, IOne, ICnt, IJump, i, j, ik, iq, INew
      PARAMETER (MAXANG = 7)
      Integer ISIZ(MAXANG)
C
      Integer LUIn, LuOut, LuErr
      Parameter (LuIn = 5, LuOut = 6, LuErr = 0)
      integer iintln, ifltln, iintfp, ialone, ibitwd
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
C
      DATA IONE /1/
      DATA ISIZ /1,3,6,10,15,21,28/
C
C READ IN SHELL INFORMATION
C
      CALL GETREC(20,'JOBARC','FULSHLNM',1,NSHELL)
      if (nshell.gt.500) then
         print *, '@PDSWAP: Assertion failed.'
         print *, '         maximum number of shells = 500'
         print *, '         nshell = ',nshell
         call errex
      end if
      CALL GETREC(20,'JOBARC','FULSHLTP',NSHELL,NSHLANG)
      CALL GETREC(20,'JOBARC','FULSHLSZ',NSHELL,NSHLNUM)
      CALL ZERO(SCR,NAO*NBAS)
C
C LOOP OVER NUMBER OF SHELLS
C
      ISTART=1
      DO 10 ISHELL=1,NSHELL
       IANGMOM=NSHLANG(ISHELL)
       NFUNC  =NSHLNUM(ISHELL)
       ISIZE=ISIZ(IANGMOM+1)*NFUNC
       IF(IANGMOM.GE.1.AND.NFUNC.GT.1)THEN
C
C SWAPPING IS REQUIRED.  DO IT.
C
        DO 100 J=ISTART,ISTART+ISIZE-1
         INEW=MOD(J-ISTART,NFUNC)*ISIZ(IANGMOM+1)+((J-ISTART)/NFUNC)+
     &        ISTART
         CALL SCOPY(NBAS,EVEC(J,1),NAO,SCR(INEW,1),NAO)
100     CONTINUE
       ELSE
C
C NO SWAPPING NEEDED FOR THIS SHELL.  JUST COPY EVEC INTO SCR.
C
        IPOS=ISTART
        DO 200 I=1,ISIZE
         CALL SCOPY(NBAS,EVEC(IPOS+I-1,1),NAO,SCR(IPOS+I-1,1),NAO)
200     CONTINUE
C
       ENDIF
C
       ISTART=ISTART+ISIZE
C
10    CONTINUE
C
c YAU : old
c     CALL ICOPY(NAO*NBAS*IINTFP,SCR,1,EVEC,1)
c YAU : new
      CALL DCOPY(NAO*NBAS,SCR,1,EVEC,1)
c YAU : end
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__ORTHOTRAN_MINIMAX_1_NORM
     +
     +                    ( DDROWX,DDCOLX,
     +                      DDROWT,DDCOLT,
     +                      DDW1,DDW2,
     +                      ROW,COL,
     +                      NORMLZE,
     +                      MAXIMZE,
     +                      X,
     +                      W1,W2,
     +
     +                              NITER,
     +                              T )
     +
C------------------------------------------------------------------------
C  OPERATION   : MAT__ORTHOTRAN_MINIMAX_1_NORM
C  MODULE      : Matrix
C  MODULE-ID   : MAT
C  DESCRIPTION : This routine finds the orthogonal rotation matrix T
C                that will lead to a minimization or maximization of
C                the 1-norm of a set of vectors X:
C
C                         X' = X * T     ||X'||  = minimum or maximum
C                                              1
C                Theory:
C                ------
C
C                Consider first a pair of vectors X1 and X2. Then we
C                need to find the orthogonal 2x2 rotation matrix given
C                by the two rotation angles C = cos (theta) and
C                S = sin (theta) with condition C*C + S*S = 1:
C
C                                      C   S
C
C                                     -S   C
C
C                         (X1   X2)  (X1'  X2')
C
C                Thus we need to find either C or S that minimize or
C                maximize the expression for the overall 1-norm:
C
C                       ||C*X1 - S*X2||  + ||S*X1 + C*X2||
C                                      1                  1
C
C                Maximization of this expression will lead (after
C                differentiation) to a discontinous function in X1
C                and X2 components possessing 1st derivative jumps.
C                Hence we reformulate the problem and, assuming the
C                X1 and X2 are normalized (i.e. all their components
C                =< 1), we can state the problem as maximizing or
C                minimizing the sum of all 4th powers of the resulting
C                rotated vector components in X1' and X2':
C
C                     sum    (C * X1 (k) - S * X2 (k)) ** 4
C                      k   + (S * X1 (k) + C * X2 (k)) ** 4
C
C                When differentiating this sum with respect to either
C                C or S and making the variable substitution Z = S / C
C                we obtain after some manipulation a 4th order
C                polynomial equation in Z:
C
C                   Z**4 - (B/A) Z**3 - 6 (Z**2) + (B/A)*Z + 1 = 0
C
C                where the two values of A and B are given by:
C
C                 A  =  sum  X2(k) * X1(k)**3 - X1(k) * X2(k)**3
C                        k
C
C                 B  =  sum  X1(k)**4 + X2(k)**4 - 6 * (X1(k)*X2(k))**2
C                        k
C
C                which can be factored into two quadratic equations:
C
C                    (Z**2 + P * Z - 1) (Z**2 + Q * Z - 1) = 0
C
C                Multiplying the factors out and equating coefficients
C                with the 4-th order polynomial equation in Z we arrive
C                at the two equations in P and Q:
C
C                              P + Q = - (B/A)
C
C                                 PQ = - 4
C
C                leading to quadratic equations with the P,Q pair
C                solution:
C
C                             - (B/A) + SQRT ((B/A)**2 + 16)
C                         P = ------------------------------
C                                           2
C
C                             - (B/A) - SQRT ((B/A)**2 + 16)
C                         Q = ------------------------------
C                                           2
C
C                A total of 4 solutions of Z are thus possible, of
C                which 2 will characterize the maximum and minimum
C                rotation angle. The first two solutions come from
C                the P-quadratic equation, giving:
C
C
C
C                Note that the absolute value of A determines how
C                large the rotation angle will be. If |A| is very
C                close to zero, then the two vectors X1 and X2 are
C                already very close to their minimum or maximum 1-norm
C                form.
C
C                Procedure:
C                ---------
C
C                If more than two vectors are present in X, i.e. if
C                we have COL > 2, we adopt the following procedure:
C
C                   1) Determine the pair of vectors which give the
C                      largest |A| value.
C
C                   2) If largest |A| value < threshold, we are done
C                      => exit.
C
C                   3) Find 2x2 rotation matrix elements C and S
C                      that minimizes the sum of the 4-th powers
C                      according to the theory outlined above.
C
C                   4) Accumulate C and S to the final COL x COL
C                      orthogonal rotation matrix T.
C
C                   5) Return to 1)
C
C
C
C                  Input:
C
C                    DDROWX,DDCOLX  =  declared dimensions of vectors X.
C                    DDROWT,DDCOLT  =  declared dimensions of rotation
C                                      matrix T.
C                    DDW1,DDW2      =  declared dimensions of working
C                                      arrays W1 and W2.
C                    ROW,COL        =  actual dimensions of vectors X.
C                    NORMLZE        =  if true, the initial vectors X
C                                      will be normalized.
C                    MAXIMZE        =  if true, the 1-norm will be
C                                      maximized, otherwise the 1-norm
C                                      will be minimized.
C                    X              =  initial ROW x COL vectors X.
C                    W1,W2          =  working arrays.
C
C
C                  Output:
C
C                    NITER          =  # of iterations performed.
C                    T              =  orthogonal rotation matrix.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE
C         IMPLICIT    DOUBLE PRECISION (A-H,O-Z)

         LOGICAL     MAXIMZE
         LOGICAL     NORMLZE
         LOGICAL     ROTATE

         INTEGER     DDROWT,DDCOLT
         INTEGER     DDROWX,DDCOLX
         INTEGER     DDW1,DDW2
         INTEGER     I,J,K,L,N
         INTEGER     NITER,MXITER
         INTEGER     ROW,COL

         DOUBLE PRECISION  A,B,C,D,R
         DOUBLE PRECISION  AMAX
         DOUBLE PRECISION  C1,S1,C2,S2
         DOUBLE PRECISION  ROOT1,ROOT2
         DOUBLE PRECISION  SMALL,VSMALL,CONVGED
         DOUBLE PRECISION  SUM1,SUM2
         DOUBLE PRECISION  XKK,XKL,XLL
         DOUBLE PRECISION  ZERO,HALF,ONE,TWO,FOUR,SIX,SIXTEEN

         DOUBLE PRECISION  W1 (1:DDW1)
         DOUBLE PRECISION  W2 (1:DDW2)

         DOUBLE PRECISION  T (1:DDROWT,1:DDCOLT)
         DOUBLE PRECISION  X (1:DDROWX,1:DDCOLX)

         PARAMETER  (ZERO    = 0.D0)
         PARAMETER  (ONE     = 1.D0)
         PARAMETER  (TWO     = 2.D0)
         PARAMETER  (FOUR    = 4.D0)
         PARAMETER  (SIX     = 6.D0)
         PARAMETER  (SIXTEEN = 16.D0)
         PARAMETER  (HALF    = 0.5D0)
         PARAMETER  (MXITER  = 1000)
         PARAMETER  (SMALL   = 1.D-6)
         PARAMETER  (VSMALL  = 1.D-9)
         PARAMETER  (CONVGED = 1.D-14)
C
C
C------------------------------------------------------------------------
C
C
C             ...return immediately, if COL = 1.
C
C
         IF (COL.EQ.1) THEN
             NITER = 1
             T (1,1) = ONE
             RETURN
         END IF
C
C
C             ...check dimensions for:
C
C                      i) vectors X
C                     ii) final rotation matrix T
C                    iii) working vectors W1 and W2
C
C
         IF  (ROW.GT.DDROWX .OR. COL.GT.DDCOLX) THEN
              WRITE (*,*) ' Dimensions of vectors X too small! '
              WRITE (*,*) ' mat__orthotran_minimax_1_norm '
              WRITE (*,*) ' DDROWX,DDCOLX,ROW,COL = ',
     +                      DDROWX,DDCOLX,ROW,COL
              WRITE (1,*) ' Dimensions of vectors X too small! '
              WRITE (1,*) ' mat__orthotran_minimax_1_norm '
              WRITE (1,*) ' DDROWX,DDCOLX,ROW,COL = ',
     +                      DDROWX,DDCOLX,ROW,COL
              STOP
         END IF

         IF  (COL.GT.DDROWT .OR. COL.GT.DDCOLT) THEN
              WRITE (*,*) ' Dimensions of rot matrix T too small! '
              WRITE (*,*) ' mat__orthotran_minimax_1_norm '
              WRITE (*,*) ' DDROWT,DDCOLT,COL = ',DDROWT,DDCOLT,COL
              WRITE (1,*) ' Dimensions of rot matrix T too small! '
              WRITE (1,*) ' mat__orthotran_minimax_1_norm '
              WRITE (1,*) ' DDROWT,DDCOLT,COL = ',DDROWT,DDCOLT,COL
              STOP
         END IF

         IF  (ROW.GT.DDW1 .OR. ROW.GT.DDW2) THEN
              WRITE (*,*) ' Dimensions of vectors W1 or W2 too small! '
              WRITE (*,*) ' mat__orthotran_minimax_1_norm '
              WRITE (*,*) ' DDW1,DDW2,ROW = ',DDW1,DDW2,ROW
              WRITE (1,*) ' Dimensions of vectors W1 or W2 too small! '
              WRITE (1,*) ' mat__orthotran_minimax_1_norm '
              WRITE (1,*) ' DDW1,DDW2,ROW = ',DDW1,DDW2,ROW
              STOP
         END IF
C
C
C             ...normalize the vectors in X (if wanted). If the maximum
C                norm difference is greater than 10-4 percent of the
C                minimum norm, the routine issues a warning! 
C
C
         IF (NORMLZE) THEN

             B = ZERO
             DO N = 1,ROW
                B = B + X (N,1) * X (N,1)
             END DO
             B = ONE / DSQRT (B)
             DO N = 1,ROW
                X (N,1) = B * X (N,1)
             END DO

             A = ZERO
             C = ZERO
             DO K = 2,COL
                D = ZERO
                DO N = 1,ROW
                   D = D + X (N,K) * X (N,K)
                END DO
                D = ONE / DSQRT (D)
                DO N = 1,ROW
                   X (N,K) = D * X (N,K)
                END DO
                A = MIN (A,D-B)
                C = MAX (C,D-B)
             END DO
             D = B + A
             B = C - A
             A = B / D

             IF (A.GT.1.D-6) THEN
                 WRITE (*,*) ' WARNING! Norms too different! '
                 WRITE (*,*) ' mat__orthotran_minimax_1_norm '
                 WRITE (*,*) ' Minimum norm            = ',D
                 WRITE (*,*) ' Maximum norm difference = ',B
                 WRITE (*,*) ' Proceeding ... '
                 WRITE (1,*) ' WARNING! Norms too different! '
                 WRITE (1,*) ' mat__orthotran_minimax_1_norm '
                 WRITE (1,*) ' Minimum norm            = ',D
                 WRITE (1,*) ' Maximum norm difference = ',B
                 WRITE (1,*) ' Proceeding ... '
             END IF

         END IF
C
C
C             ...initialize rotation matrix T.
C
C
         DO J = 1,COL
            DO I = 1,COL
               T (I,J) = ZERO
            END DO
            T (J,J) = ONE
         END DO
C
C
C             ...prepare for small perturbed rotation on pair of
C                vectors possessing already converged value of |A|.
C
C
         C1 = DSQRT (ONE - SMALL)
         S1 = DSQRT (SMALL)

         DO K = 1,COL
         DO L = K+1,COL
            A = ZERO
            B = ZERO
            C = ZERO
            D = ZERO
            DO N = 1,ROW
               XKK = X (N,K) * X (N,K)
               XKL = X (N,K) * X (N,L)
               XLL = X (N,L) * X (N,L)
               A = A + XKK * XKL
               B = B + XKK * XKK + XLL * XLL
               C = C + XKL * XLL
               D = D + XKL * XKL
            END DO
            A = A - C
            B = B - SIX * D

            WRITE (*,*) ' A , B (seed) = ',A,B
            ROTATE = DABS (A).LT.CONVGED .AND.
     +               DABS (B).GT.VSMALL

            IF (ROTATE) THEN
                DO N = 1,ROW
                   A = C1 * X (N,K) - S1 * X (N,L)
                   C = S1 * X (N,K) + C1 * X (N,L)
                   X (N,K) = A
                   X (N,L) = C
                END DO
                DO N = 1,COL
                   A = C1 * T (N,K) - S1 * T (N,L)
                   C = S1 * T (N,K) + C1 * T (N,L)
                   T (N,K) = A
                   T (N,L) = C
                END DO
            END IF
         END DO
         END DO
C
C
C             ...perform iterates.
C
C
         DO NITER = 1,MXITER

            AMAX = CONVGED
C
C
C             ...find I,J pair of X vectors possessing largest |A|
C                value.
C
C
            DO K = 1,COL
            DO L = K+1,COL
               A = ZERO
               B = ZERO
               C = ZERO
               D = ZERO
               DO N = 1,ROW
                  XKK = X (N,K) * X (N,K)
                  XKL = X (N,K) * X (N,L)
                  XLL = X (N,L) * X (N,L)
                  A = A + XKK * XKL
                  B = B + XKK * XKK + XLL * XLL
                  C = C + XKL * XLL
                  D = D + XKL * XKL
               END DO
               A = A - C
               B = B - SIX * D
               WRITE (*,*) ' A , B (iter) = ',A,B
               C = DABS (A)
               IF (C.GT.AMAX) THEN
                   I = K
                   J = L
                   R = B / A
                   AMAX = C
               END IF
            END DO
            END DO

            WRITE (*,*) ' AMAX = ',AMAX
C
C
C             ...check, if convergence was achieved (largest |A|
C                below convergence threshold) and exit if the case.
C
C
            IF (AMAX.EQ.CONVGED) THEN
                WRITE (*,*) ' Converged after ',NITER,' iterations! '
                CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
     +
     +                     ( 6,
     +                       ' Final set of vectors ',
     +                       DDROWX,DDCOLX,
     +                       ROW,COL,
     +                       X )
     +
c                CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
c     +
c     +                     ( 6,
c     +                       ' Rotation matrix ',
c     +                       DDROWT,DDCOLT,
c     +                       COL,COL,
c     +                       T )
c     +
                RETURN
            END IF

c            WRITE (*,*) ' Processing columns ',I,J
C
C
C             ...start rotation of I,J vector pair. Calculate the
C                2 minimax roots.
C
C
            IF (R.GE.ZERO) THEN
                ROOT2 = - HALF * (R + DSQRT (R*R + SIXTEEN))
                ROOT1 = - ONE / ROOT2
            ELSE
                ROOT1 = - HALF * (R - DSQRT (R*R + SIXTEEN))
                ROOT2 = - ONE / ROOT1
            END IF

c            WRITE (*,*) ' Root 1 , Root 2 = ',ROOT1,ROOT2
C
C
C             ...calculate both sets of C1,S1 and C2,S2 values for
C                both roots ROOT1 and ROOT2, avoiding loss of accuracy
C                as much as possible for small angles.
C
C
            A = ONE / (ROOT1 * ROOT1 + FOUR)
            B = ONE / (ROOT2 * ROOT2 + FOUR)

            IF (A.LT.SMALL) THEN
                A = A + A * A
            ELSE
                A = (ONE - DSQRT (ONE - FOUR * A)) * HALF
            END IF

            IF (B.LT.SMALL) THEN
                B = B + B * B
            ELSE
                B = (ONE - DSQRT (ONE - FOUR * B)) * HALF
            END IF

            S1 = DSQRT (A)
            C1 = DSQRT (ONE - A)
            C2 = DSQRT (B)
            S2 = DSQRT (ONE - B)
C
C
C             ...calculate both 4th power summations for both roots.
C                Near the middle to the end of convergence, the largest
C                of the absolute root values is the one leading to the
C                right direction of minimization or maximization. Hence
C                the rotated I,J vector pair are overwritten by the
C                rotated results which correspond to the largest
C                absolute root value. Only in case (during the beginning
C                few iterations) the smallest absolute root value is
C                the one leading to the right direction we copy the
C                rotated vector pair results stored in W1 and W2 for
C                the smallest root back to the original vector pair
C                memory.
C
C
            SUM1 = ZERO
            SUM2 = ZERO

            IF (DABS (ROOT1) .GT. DABS (ROOT2)) THEN

                DO N = 1,ROW
                   A = C1 * X (N,I) - S1 * X (N,J)
                   B = S1 * X (N,I) + C1 * X (N,J)
                   C = C2 * X (N,I) - S2 * X (N,J)
                   D = S2 * X (N,I) + C2 * X (N,J)
                   X (N,I) = A
                   X (N,J) = B
                   W1 (N)  = C
                   W2 (N)  = D
                   A = A * A
                   B = B * B
                   C = C * C
                   D = D * D
                   SUM1 = SUM1 + (A * A) + (B * B)
                   SUM2 = SUM2 + (C * C) + (D * D)
                END DO

                IF (MAXIMZE) THEN
                    IF (SUM2.LT.SUM1) THEN
                        C1 = C2
                        S1 = S2
                        DO N = 1,ROW
                           X (N,I) = W1 (N)
                           X (N,J) = W2 (N)
                        END DO
                    END IF
                ELSE
                    IF (SUM2.GT.SUM1) THEN
                        C1 = C2
                        S1 = S2
                        DO N = 1,ROW
                           X (N,I) = W1 (N)
                           X (N,J) = W2 (N)
                        END DO
                    END IF
                END IF

            ELSE

                DO N = 1,ROW
                   A = C1 * X (N,I) - S1 * X (N,J)
                   B = S1 * X (N,I) + C1 * X (N,J)
                   C = C2 * X (N,I) - S2 * X (N,J)
                   D = S2 * X (N,I) + C2 * X (N,J)
                   X (N,I) = C
                   X (N,J) = D
                   W1 (N)  = A
                   W2 (N)  = B
                   A = A * A
                   B = B * B
                   C = C * C
                   D = D * D
                   SUM1 = SUM1 + (A * A) + (B * B)
                   SUM2 = SUM2 + (C * C) + (D * D)
                END DO

                IF (MAXIMZE) THEN
                    IF (SUM1.LT.SUM2) THEN
                        DO N = 1,ROW
                           X (N,I) = W1 (N)
                           X (N,J) = W2 (N)
                        END DO
                    ELSE
                        C1 = C2
                        S1 = S2
                    END IF
                ELSE
                    IF (SUM1.GT.SUM2) THEN
                        DO N = 1,ROW
                           X (N,I) = W1 (N)
                           X (N,J) = W2 (N)
                        END DO
                    ELSE
                        C1 = C2
                        S1 = S2
                    END IF
                END IF

            END IF

c            WRITE (*,*) ' Sum 1 , Sum 2 = ',SUM1,SUM2
c            CALL  MAT__PRINT_A_FLOAT_12_NOZEROS
c     +
c     +                 ( 6,
c     +                   ' Intermediate set of vectors ',
c     +                   DDROWX,DDCOLX,
c     +                   ROW,COL,
c     +                   X )
c     +
C
C
C             ...update rotation matrix T with proper rotation elements
C                C1 and S1.
C
C
            DO N = 1,COL
               A = C1 * T (N,I) - S1 * T (N,J)
               C = S1 * T (N,I) + C1 * T (N,J)
               T (N,I) = A
               T (N,J) = C
            END DO
C
C
C             ...next iteration.
C
C
         END DO
C
C
C             ...Maximum # of iterations exceeded. Print info.
C
C
         WRITE (*,*) ' Minimax of 1-norm did not converge! '
         WRITE (*,*) ' Maximum # of iterations performed = ',MXITER
         WRITE (*,*) ' mat__orthotran_minimax_1_norm '
         WRITE (1,*) ' Minimax of 1-norm did not converge! '
         WRITE (1,*) ' Maximum # of iterations performed = ',MXITER
         WRITE (1,*) ' mat__orthotran_minimax_1_norm '
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine scf_init(vnn)
c-------------------------------------------------------------------------
c   Handles most set-up chores for a run which begins with no JOBARC
c   in existence.  It is assumed that we must start with an SCF to begin
c   such a job.
c-------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'mxatms.par' 
      include 'scflindep.h'

      integer ierr
      common /flags/ iflags
      integer iflags(100)

      integer nproton, icharg, imult, iuhfx, nrhs, ialpex, numel
      integer nallproton, noff  
      integer dummy, i, nocc_present
      logical*8 l8false
      integer ECP, NATOMS, ICRCOR(MxAtms) 
      integer nallalpha_occupied, nallbeta_occupied 
      double precision vnn 
      double precision nuclear_nuclear_repulsion_energy

      double precision dbuf(1)
      common dbuf

      logical is_open
 
      inquire (file='JOBARC', exist=jobarc_exists)
      if (.not. jobarc_exists) then
         print *,'Running initial xjoda...'
         call c_flush_stdout()

         call joda_main()
         print *,'Initial xjoda is complete...'
         call c_flush_stdout()
      else 

c Sets the linear dependence tolerance in cases when JOBARC exists so that 
c it does not become 1.0!! 
c      lindep_tol = 9 

      endif

c---------------------------------------------------------------------------
c   Initialize ACES routines.
c---------------------------------------------------------------------------
                                                                                
      call aces_init_rte()
      call aces_ja_init()

c----------------------------------------------------------------------------
c   xjoda sometimes destroys the OCCUPYA0, OCCUPYB0 data on JOBARC for 
c   some obscure reason.  To guard against that possibility, we must 
c   check to see if it is available now.  If not, we calculate it from
c   ourselves and write it to JOBARC.
c----------------------------------------------------------------------------

      call igetrec(0, 'JOBARC', 'OCCUPYA0', nocc_present, dummy)
      if (nocc_present .gt. 0) then

c---------------------------------------------------------------------
c   Go ahead and read the occupied values off JOBARC.
c---------------------------------------------------------------------

         call igetrec(1, 'JOBARC', 'OCCUPYA0', 1, nalpha_occupied)
         call igetrec(1, 'JOBARC', 'OCCUPYB0', 1, nbeta_occupied)

         return
      endif

c---------------------------------------------------------------------------
c   OCCUPYA0/OCCUPYB0 will not exist until after the SCF.  So we have to 
c   calculate the number of occupied alpha and beta spin electrons.
c---------------------------------------------------------------------------

      CALL IGETREC(20,'JOBARC','IFLAGS  ', 100, iflags)
      CALL IGETREC(20,'JOBARC','NMPROTON',1,NPROTON)

C--------------------------------------------------------------------------
c   If this is an ECP calculation then we must modify NPROTON to obtain
c   correct number of occupied orbitals. Why is this not done earlier??   
C--------------------------------------------------------------------------

      ECP = iflags(71) 
      IF (ECP .EQ. 1) THEN 
         NallPROTON = NPROTON 

         CALL SET_ECP_CHARGES(MAX_CENTERS,NATOMS,ICRCOR) 
         CALL IGETREC(20,'JOBARC','ATOMCHRG',NATOMS,ICRCOR)
c 
c        do i = 1, natoms 
c           write(6,*) 'ATOMCHRG  ', i, icrcor(i) 
c        enddo 

c        natoms = 2
c        write(6,*) ' Natoms = ', natoms 

         nproton = 0 
         do i = 1, natoms 
#ifdef _DEBUG_LVL0
            write(6,*) '  ', i, icrcor(i) 
#endif
            nproton = nproton + icrcor(i) 
         enddo 

c        icrcor(1) = 7 
c        icrcor(2) = 7 

         do i = 1, natoms 
            charge(i) = icrcor(i) 
         enddo 

c        nproton = 14 

         noff = NallPROTON - NPROTON 
#ifdef _DEBUG_LVL0
         write(6,*) ' Nproton = ', nallproton, nproton, noff  
#endif 
      ELSE 
      ENDIF 

      ICHARG=IFLAGS(28)
      IMULT=IFLAGS(29)

C--------------------------------------------------------------------------
c   Determine alpha and beta occupied from charge and multiplicity.
C--------------------------------------------------------------------------

      NUMEL=NPROTON-ICHARG
      IALPEX=IMULT-1
      NRHS=NUMEL-IALPEX
      IF(MOD(NRHS,2).NE.0)THEN
         print *,'Error: Specified charge and multiplicity are ',
     &           'impossible.   Try again.'
         call abort_job()
      ENDIF
      nbeta_occupied=NRHS/2
      nalpha_occupied = nbeta_occupied + ialpex
      if (nalpha_occupied .eq. 0) call abort_job()

c     IF (ECP .EQ. 1) THEN 

c        NUMEL=NallPROTON-ICHARG
c        IALPEX=IMULT-1
c        NRHS=NUMEL-IALPEX
c        IF(MOD(NRHS,2).NE.0)THEN
c           print *,'Error: Specified charge and multiplicity are ',
c    &              'impossible.   Try again.'
c           call abort_job()
c        ENDIF
c        nallbeta_occupied=NRHS/2
c        nallalpha_occupied = nallbeta_occupied + ialpex
c        if (nallalpha_occupied .eq. 0) call abort_job()

c     ENDIF 
      
c-------------------------------------------------------------------------
c   Write the values to JOBARC.
c-------------------------------------------------------------------------

      call iputrec(1, 'JOBARC', 'OCCUPYA0', 1, nalpha_occupied)
      call iputrec(1, 'JOBARC', 'OCCUPYB0', 1, nbeta_occupied)

      return
      end

c This routine removes all traces of a storage unit.

c INPUT
c int      IUNIT  : the external file unit to destroy
c char*(*) SZFILE : the internal name of the file to destroy
c                   NOTE: This is only used if the external unit is closed.

c#define _DEBUG_ACES_IO_REMOVE

      subroutine aces_io_remove(iUnit,szFile)
      implicit none

c ARGUMENTS
      integer iUnit
      character*(*) szFile

c INTERNAL VARIABLES
      integer i, iStat
      character*80 szExt
      integer      iLength
      integer ihFile, iFamNdx, iStorLen
      logical bExist, bOpened

c COMMON BLOCKS
#include "lists.com"
#include "cache.com"
#include "sympop.com"

c ----------------------------------------------------------------------

#ifdef _ASSERT
      i = 0
c   o assert I/O subsystem is up
      if (.not.bIOUp) then
         print *, '@ACES_IO_REMOVE: Assertion failed.'
         print *, '   bIOUp = ',bIOUp
         i = 1
      end if
c   o assert iUnit is properly bound
      if ((iUnit.lt._FIRST_IO_LUN).or.
     &    (_FIRST_IO_LUN-1+_MAX_IO_LUNS.lt.iUnit)) then
         print *, '@ACES_IO_REMOVE: Assertion failed.'
         print *, '   iUnit = ',iUnit
         i = 1
      end if
      if (i.ne.0) call aces_exit(i)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

c   o delete the unit and/or file
      inquire(unit=iUnit,opened=bOpened,err=666,iostat=iStat)
      if (bOpened) then
#ifdef _DEBUG_ACES_IO_REMOVE
         print *, '@ACES_IO_REMOVE: deleting unit ',iUnit,' / ',szFile
#endif
         close(unit=iUnit,status='DELETE',err=666,iostat=iStat)
c      o destroy the relevant cache slots
         do i = 1, cachnum
            if (cachfil(i).eq.iUnit) then
               cachfil(i)  = 0
               cachrec(i)  = 0
               cachmod(i)  = 0
               lrustats(i) = 0
            end if
         end do
      else
         call gfname(szFile,szExt,iLength)
         inquire(file=szExt(1:iLength),exist=bExist,
     &           err=666,iostat=iStat)
         if (bExist) then
#ifdef _DEBUG_ACES_IO_REMOVE
            print *, '@ACES_IO_REMOVE: deleting file ',szExt(1:iLength)
#endif
#ifdef _UNICOS
            call pxfunlink(szExt(1:iLength),iLength,iStat)
            if (iStat.ne.0) goto 666
#else
            call f_remove(szExt(1:iLength))
#endif
         end if
      end if

c   o get the internal unit index and the first family index
      ihFile  = 1 + iUnit - _FIRST_IO_LUN
      iFamNdx = 1 + (ihFile-1)*_FAMS_PER_FILE
#ifdef _DEBUG_ACES_IO_REMOVE
      print *, '@ACES_IO_REMOVE: deleting list families ',
     &         iFamNdx,' through ',iFamNdx-1+_FAMS_PER_FILE
#endif

c   o reset the list stats
      iStorLen = _MAX_IO_GRPS*_FAMS_PER_FILE
      call izero(moio  (1,iFamNdx),iStorLen)
      call izero(moiowd(1,iFamNdx),iStorLen)
      call izero(moiods(1,iFamNdx),iStorLen)
      call izero(moiosz(1,iFamNdx),iStorLen)
      call izero(moiofl(1,iFamNdx),iStorLen)
      call izero(moiomxsz(1,iFamNdx),iStorLen)

cYAU - There is so much bad programming related to this array that we cannot
c      destroy it.
cc   o reset the distribution types
c      call izero(isytyp(1,iFamNdx),2*_FAMS_PER_FILE)

c   o reset the free-space pointers
      pRec(ihFile)    = 1
      iIntOff(ihFile) = 0

c   o mark MOIO as modified
      bIOMod = .true.

      return

c   o I/O error
 666  print *, '@ACES_IO_REMOVE: I/O error'
      print *, '                 file = "',szFile,'"'
      print '(/)'
      call aces_io_error('ACES_IO_REMOVE',iUnit,iStat)

c     end subroutine aces_io_remove
      end

C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
C      This source file should not be edited.  Make
C      any necessary changes to the individual source
C      or include files.  This file has been produced
C      with 'make vmol2ja.f' from the original sources.
C      It is NOT the original source code itself.
C WARNING WARNING WARNING WARNING WARNING WARNING WARNING
      Subroutine ISctr ( NZ, X, INDX, Y)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: isctr.f,v 1.1.1.1 2003/04/02 19:21:47 aces Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     isctr -- Scatter elements of a vector into another
C
C SYNOPSIS
      Integer NZ, INDX (NZ), Y(*), X(NZ)
C
C ARGUMENTS
C     NZ      Number of elements to be gathered (input)
C     X       Source vector (input)
C     Indx    Vector of indices of Y to put elements of X into (input)
C     Y       Source vector (input)
C
C DESCRIPTION
C     Performs the operation Y( Indx(i) ) = X(i) for i = 1, NZ.
C     Only elements of Y listed in Indx are accessed.
C
C NOTES
C     This is the integer analog to [DS]Sctr of the Dodson, Lewis, and
C     Grimes Sparse-BLAS1 proposal.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     LOCAL VARIABLES
C
      INTEGER             I
C
      IF  ( NZ .LE. 0 )  RETURN
C
      DO 10 I = 1, NZ
         Y(INDX(I)) = X(I)
   10 CONTINUE
C
      RETURN
      END

C THIS ROUTINE PRINTS OUT A SUMMARY OF THE SYMMETRY ADAPTED COORDINATES.

c This routine was essentially the same as the old DUMPCORD routine but had
c a few extra print statements. The BFLAG argument controls that extra
c printing. Whether or not we need both options is for someone else to decide,
c but functionally, the program is the same as before minus the existence
c of DUMPCORD.

c INPUT
c integer NATOM
c integer NIRREP
c integer NIRREPC
c char*4  DOIT
c logical BFLAG

c OUTPUT
c double  DSCR(*)
c integer ISCR(*)
c char*8  LABEL(NIRREP+NIRREPC)

c RECORDS
c get DOIT//'SYMQ'
c get DOIT//'SYQT'
c get DOIT//'LABL'
c get 'NUMVIBRT'
c get 'LINEAR  '
c get 'SBGRPSYM'
c get 'COMPLABL'
c get DOIT//'PTGP'
c get 'COMPPTGP'

      SUBROUTINE PRTCOORD(NATOM,NIRREP,NIRREPC,DSCR,ISCR,
     &                    LABEL,DOIT,BFLAG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION DSCR(*),ISCR(*)
      CHARACTER*8 LABEL(NIRREP+NIRREPC)
      CHARACTER*4 DOIT
      LOGICAL BFLAG

      CHARACTER*4 FPGRP,CPGRP

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      LOGICAL          ENERONLY,GRADONLY,ROTPROJ,RAMAN,GMTRYOPT,
     &                 SNPTGRAD
      COMMON /CONTROL/ ENERONLY,GRADONLY,ROTPROJ,RAMAN,GMTRYOPT,
     &                 SNPTGRAD 

      NSIZE=3*NATOM

      CALL GETREC(20,'JOBARC',DOIT//'SYMQ',NSIZE*NSIZE*IINTFP,DSCR)
      CALL GETREC(20,'JOBARC',DOIT//'SYQT',NSIZE,ISCR)
      CALL GETREC(20,'JOBARC',DOIT//'LABL',NIRREP*IINTFP,LABEL)
      CALL GETREC(20,'JOBARC','NUMVIBRT',1,NMODE)
      CALL GETREC(20,'JOBARC','LINEAR  ',1,ILINEAR)
      IF (BFLAG) THEN
      CALL GETREC(20,'JOBARC','SBGRPSYM',NSIZE,ISCR(NSIZE+1))
      CALL GETREC(20,'JOBARC','COMPLABL',NIRREPC*IINTFP,LABEL(NIRREP+1))
      CALL GETCREC(20,'JOBARC',DOIT//'PTGP',4,FPGRP)
      CALL GETCREC(20,'JOBARC','COMPPTGP',  4,CPGRP)
      END IF

      IOFF=1
      WRITE(6,1000)
1000  FORMAT(T3,' *** TABLE OF SYMMETRY COORDINATES *** ')
      IF (BFLAG) THEN
      WRITE(6,1010)
1010  FORMAT(T3,'                                       ')
      IF (ROTPROJ) THEN
         WRITE(6,1020)
1020     FORMAT(T3,' Eckart rotations and translations projected ',
     &             'from vibrational coordinates')
      ELSE
         WRITE(6,1021)
1021     FORMAT(T3,' Translations projected from vibrational ',
     &             'coordinates')
      END IF
      WRITE(6,1030)FPGRP,CPGRP
1030  FORMAT(T3,' Point group used : ',A,' ; Abelian subgroup : ',A)
      WRITE(6,1031)DOIT
1031  FORMAT(T3,'Coordinate type : ',A)
c     END IF (BFLAG)
      END IF
      DO IMODE=1,NMODE
         IF (BFLAG) THEN
         WRITE(6,1003)IMODE,LABEL(ISCR(IMODE)),
     &                LABEL(NIRREP+ISCR(NSIZE+IMODE))
1003     FORMAT(T3,' Mode : ',I3,' Symmetry : ',A,' Subgroup symm : ',A)
         ELSE
         WRITE(6,1001)IMODE,LABEL(ISCR(IMODE))
1001     FORMAT(T3,' Mode : ',I3,' Symmetry : ',A)
         END IF
         WRITE(6,1004)
1004     FORMAT(T11,'ATOM',T26,'X',T40,'Y',T54,'Z')
         DO IATOM=1,NATOM
            WRITE(6,1005)IATOM,(DSCR(J),J=IOFF,IOFF+2)
            IOFF=IOFF+3
1005        FORMAT(T11,I3,T19,F13.10,T33,F13.10,T47,F13.10)
         END DO
         WRITE(6,*)
      END DO

      IF (ROTPROJ) THEN
         WRITE(6,2000)
2000     FORMAT(T3,'@PRTCOORD: Rotational coordinates (x,y,z)')
         DO IXYZ=1,3-ILINEAR
            WRITE(6,1004)
            DO IATOM=1,NATOM
               WRITE(6,1005)IATOM,(DSCR(J),J=IOFF,IOFF+2)
               IOFF=IOFF+3
            END DO
         END DO
      END IF

      WRITE(6,3000)
3000  FORMAT(T3,'@PRTCOORD: Translational coordinates (x,y,z)')
      DO IXYZ=1,3
         WRITE(6,1004)
         DO IATOM=1,NATOM
            WRITE(6,1005)IATOM,(DSCR(J),J=IOFF,IOFF+2)
            IOFF=IOFF+3
         END DO
      END DO

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_commit_msg(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_checkpoint_msg message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'server_ckpt_data.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer node
      integer i, j, n, istart, nsearch, iblock
      integer*8 indblk, get_index_from_base
      integer*8 ind, imsg
      integer msgbuffer, state, ierr
      integer memloc, diskloc, size, ifile, nxt
      integer request, status(MPI_STATUS_SIZE)
      integer array, nindex, tag, f_form_msg_tag 
      integer msglen
      integer msg(100)

      integer ckpt_ndx, ckpt_dat
      integer nblk_file, header_entry, next
      integer*8 loc, index_file_diskloc, data_file_diskloc 
      integer*8 ndx_file_len, array_size
      integer str_trimlen
      logical created_file, match, flag

      integer index_file_entry_size
      parameter (index_file_entry_size = 3+mx_array_index*2)
      integer*8 index_file_entry(index_file_entry_size)

      double precision xxx,xsum

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif
      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then

c--------------------------------------------------------------------------
c   Open the checkpoint index file.
c--------------------------------------------------------------------------

         n = str_trimlen(ckpt_ndx_filename)
         call f_openfile(ckpt_ndx_filename(1:n) // char(0), ckpt_ndx)
         if (ckpt_ndx .eq. -1) then
            print *,'Error: Server ',me,' failed to open checkpoint',
     *              ' index file during commit operation.'
            call server_abort_job(server_table, nserver_table)
         endif

c---------------------------------------------------------------------------
c   Write out the new ndx_file_header.  Once this is written to disk, the
c   disk pointers point to the last copy of the array written to disk, and
c   any previously written copies become free for reuse.  
c---------------------------------------------------------------------------

         loc = 0
         call f_write_disk(ckpt_ndx, loc, ndx_file_header, 
     *                     index_file_header_size) 

c--------------------------------------------------------------------------
c   Close the checkpoint file.
c--------------------------------------------------------------------------

         call f_close_file(ckpt_ndx)

c--------------------------------------------------------------------------
c   Update the free space structures.
c   Any free space candidates are now moved to the free space list, and 
c   the candidate list is cleared.
c--------------------------------------------------------------------------

         do i = 1, nfree_ndx_can
            do j = 1, nfree_space_ndx
               if (free_space_ndx(1,j) .eq. -1 .and.
     *             free_space_ndx(2,j) .eq. -1) then

c----------------------------------------------------------------------------
c   Use existing free space entry.
c----------------------------------------------------------------------------

                  free_space_ndx(1,j) = free_space_ndx_candidate(1,i)
                  free_space_ndx(2,j) = free_space_ndx_candidate(2,i)
                  go to 100
               endif 
            enddo
 
c----------------------------------------------------------------------------
c   Add to free space list.
c----------------------------------------------------------------------------

            nfree_space_ndx = nfree_space_ndx + 1
            if (nfree_space_ndx .gt. mx_ckpt_arrays) then
                print *,'Error: Free space entries are exhausted.'
                call server_abort_job(server_table, nserver_table)
            endif

            free_space_ndx(1,nfree_space_ndx) = 
     *                  free_space_ndx_candidate(1,i)
            free_space_ndx(2,nfree_space_ndx) = 
     *                  free_space_ndx_candidate(2,i)
  100       continue
         enddo

         nfree_ndx_can = 0

         do i = 1, nfree_dat_can
            do j = 1, nfree_space_dat
               if (free_space_dat(1,j) .eq. -1 .and.
     *             free_space_dat(2,j) .eq. -1) then

c----------------------------------------------------------------------------
c   Use existing free space entry.
c----------------------------------------------------------------------------

                  free_space_dat(1,j) = free_space_dat_candidate(1,i)
                  free_space_dat(2,j) = free_space_dat_candidate(2,i)
                  go to 200
               endif 
            enddo
 
c----------------------------------------------------------------------------
c   Add to free space list.
c----------------------------------------------------------------------------

            nfree_space_dat = nfree_space_dat + 1
            if (nfree_space_dat .gt. mx_ckpt_arrays) then
                print *,'Error: Free space data entries are exhausted.'
                call server_abort_job(server_table, nserver_table)
            endif

            free_space_dat(1,nfree_space_dat) = 
     *                  free_space_dat_candidate(1,i)
            free_space_dat(2,nfree_space_dat) = 
     *                  free_space_dat_candidate(2,i)
  200       continue
         enddo

         nfree_dat_can = 0

c--------------------------------------------------------------------------
c   Send an acknowledgement to the master.  This tells him that the 
c   server has finished his checkpoint operation.
c   The message tag for the ack. msg is server_checkpoint_msg.
c--------------------------------------------------------------------------

            call mpi_isend(msg, 1,
     *            mpi_integer, 0, server_commit_msg,
     *            mpi_comm_world,  server_msg(c_msg_request,node), 
     *            ierr)
            server_msg(c_msg_state,node) = wait_for_send_state
            return
      else if (state .eq. wait_for_send_state) then

c-------------------------------------------------------------------------
c   Test for completion of the send.
c-------------------------------------------------------------------------

         if (server_msg(c_msg_request,node) .eq.
     *                               MPI_REQUEST_NULL) then
            flag = .true.
         else
            call mpi_test(server_msg(c_msg_request,node), flag,
     *                 status, ierr)
         endif

         if (flag) then
               server_msg(c_msg_state,node) = null_state   ! done
         else
            return
         endif
      endif   ! state
      return
      end

      Subroutine SymEqv (Ntotatoms, IGenBy)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Prepares IGENBY list in a much less cumbersome way
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IMPLICIT INTEGER (A-Z)

#include "mxatms.par"
C
      DIMENSION MEMBER(MXATMS),ORBPOP(MXATMS),IGENBY(Ntotatoms)
C
C INITIALIZE GENBY TO 999.  THIS WILL TAKE CARE OF DUMMY ATOMS.
C
      DO 20 I=1,NTOTATOMS
         IGENBY(I)=999
20    CONTINUE
C
C GET MEMBER AND ORBPOP VECTORS FROM JOBARC.
C
      ISIZE=1
      CALL GETREC(20,'JOBARC','COMPNORB',ISIZE,IORBIT)
      CALL GETREC(20,'JOBARC','COMPMEMB',NTOTATOMS,MEMBER)
C
      CALL GETREC(20,'JOBARC','COMPPOPV',IORBIT,ORBPOP)
C
C LOOP OVER ORBITS AND ZERO OUT POSITION OF FIRST MEMBER OF EACH ORBIT
C   IN GENBY LIST.
C
      IOFF=1
      DO 50 I=1,IORBIT
         IGENBY(MEMBER(IOFF))= I 
         DO 51 J=1,ORBPOP(I)-1
            IGENBY(MEMBER(IOFF+J))=MEMBER(IOFF)
51       CONTINUE
         IOFF=IOFF+ORBPOP(I)
50    CONTINUE
      
      RETURN
      END

C FORMS A=B+FACTOR*C FOR THE FIRST LEN ELEMENTS OF VECTORS A, B, AND C.

      SUBROUTINE VADD(A,B,C,LEN,FACTOR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LEN),B(LEN),C(LEN)
      if (len.lt.1) return
      DO I = 1, LEN
         A(I) = B(I) + ( FACTOR * C(I) )
      END DO
      RETURN
      END

      SUBROUTINE SETUP2(ICORE,ICRSIZ,I010,I020,I030,LIST1,LIST2,
     &                  NUMDIS,NDSSIZ)
C
C THIS ROUTINE RETURNS THE SYMMETRY INFORMATION ABOUT THE LIST
C   ON MOIO(LISTT1,LISTT2),ALONG WITH
C   OFFSETS INTO THE CORE ARRAY WHERE THESE LISTS BEGIN.
C
C       ICORE - CORE VECTOR (PASSED IN)
C       ICRSIZ- SIZE OF WORKING AREA.
C       I010  - OFFSET TO BEGINNING OF THE POPULATION COUNT VECTOR FOR
C                THE LIST.
C       I020  - OFFSET TO BEGINNING OF THE SYMMETRY VECTOR FOR
C                THE LIST.
C       I030  - TOTAL CORE REQUIRED FOR SYMMETRY INFORMATION.
C       LIST1 - THE SYMMETRY TYPE FOR THE LIST "SPIN CASE".
C       LIST2 - THE SYMMETRY TYPE FOR THE LIST DISTRIBUTION TYPE.
C       NUMDIS- TOTAL NUMBER OF DISTRIBUTIONS (IN C1).
C       NDSSIZ- SIZE OF DISTRIBUTIONS (IN C1).
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION ICORE(ICRSIZ)
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      DISTPL=LIST1
      DISTPR=LIST2
      I010=1
      I020=I010+2*NIRREP
      I030=I020+NUMDIS+NDSSIZ
      IF(MOD(I030,2).EQ.0)I030=I030+1
C
C FETCH POINTERS.
C
      CALL GETGSV(DISTPL,NDSSIZ,DISTPR,NUMDIS,NIRREP,
     &             ICORE(I010),ICORE(I020))
      RETURN
      END

#include "flags.h"
C
      subroutine aces_io_recovery
      
      Implicit None
      Integer maxcor, length, iuhf, ioff
C
C Read list IO files to extract T, L or C amplitudes. 
C
#include "icore.com"
#include "machsp.com"
#include "istart.com"
#include "flags.com"
#include "flags2.com"
#include "istart.com"
c
      iuhf = 0
      if (iflags(h_IFLAGS_ref).ne.0) iuhf = 1
      maxcor=icrsiz
      ioff = 0
c
      call read_tlc_amps(icore(i0), maxcor, ioff, length, iuhf)
      call write_tlc_amps(icore(i0), length, "TGUESS  ")
      
      Return
      End 

C
      subroutine aces_io_recovery
      
      Implicit None
      Integer maxcor, length, iuhf, ioff
C
C Read list IO files to extract T, L or C amplitudes. 
C


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end







c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end
c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c flags2.com : begin
      integer         iflags2(500)
      common /flags2/ iflags2
c flags2.com : end
c
      iuhf = 0
      if (iflags(11).ne.0) iuhf = 1
      maxcor=icrsiz
      ioff = 0
c
      call read_tlc_amps(icore(i0), maxcor, ioff, length, iuhf)
      call write_tlc_amps(icore(i0), length, "TGUESS  ")
      
      Return
      End 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      double precision function dsum(n,dx,incx)
c
c     takes the sum of the values.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c     modified 11/4/03, dasum->dsum conversion
c
      double precision dx(*),dtemp
#ifdef ACES64
      integer*8 incx, n
#else
      integer incx, n
#endif
      integer i,m,mp1,nincx
c
      dsum = 0.0d0
      dtemp = 0.0d0
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dtemp = dtemp + dx(i)
   10 continue
      dsum = dtemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dx(i)
   30 continue
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,6
        dtemp = dtemp + dx(i) + dx(i + 1) + dx(i + 2)
     *  + dx(i + 3) + dx(i + 4) + dx(i + 5)
   50 continue
   60 dsum = dtemp
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine get_block_map_entry(array_table_entry, block, 
     *                               block_map_table, nblock_map_table,
     *                               block_map_entry)
      implicit none
      include 'interpreter.h'

      integer array_table_entry(larray_table_entry)
      integer nblock_map_table
      integer block_map_table(lblock_map_entry,nblock_map_table)
      integer block
      integer block_map_entry(lblock_map_entry)

      integer i, iblock_map

c------------------------------------------------------------------------
c   Get the block map entry and move it into the return argument.
c------------------------------------------------------------------------

      iblock_map = array_table_entry(c_block_map) + block - 1
      if (iblock_map .gt. nblock_map_table) then
         print *,'GET_BLOCK_MAP_ENTRY: Block_map_table has ',
     *            nblock_map_table,' but attempted reference for ',
     *            'block ',iblock_map
         print *,'Array_table pointer = ',
     *            array_table_entry(c_block_map),
     *           ' block in arg. list = ',block
         call abort_job()
      endif

      do i = 1, lblock_map_entry
         block_map_entry(i) = block_map_table(i,iblock_map)
      enddo
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine block_end_of_loop(array, block, blkndx,
     *             array_table, narray_table,
     *             index_table, nindex_table, block_map_table)
c--------------------------------------------------------------------------
c   Handles setting of flags at the end of a DO or PARDO loop.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blkmgr.h'

      integer array, block, blkndx
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer block_map_table(lblock_map_entry,*)
      integer create_flag, flag
      integer get_block_request

c-------------------------------------------------------------------------
c   Check that this block is not the result of a CREATE instruction.  If it
c   is, it can only be released by DELETE'ing it.
c--------------------------------------------------------------------------

      call get_block_created_flag(array, block, blkndx, create_flag)
      if (create_flag .eq. 0) then
         call get_block_persistence_flag(array, block, blkndx,
     *                                   flag)
         call clear_block_computed_flag(array, block, blkndx)
         call set_block_busy_flag(array, block, blkndx, 0)

c---------------------------------------------------------------------------
c   This block is not a "persistent" block.
c---------------------------------------------------------------------------
            
         if (get_block_request(array, block, blkndx) .ne. 
     *                      MPI_REQUEST_NULL) then

c---------------------------------------------------------------------------
c   Mark the block as "scrubbable".  It will be freed later after its
c   communication is complete.
c---------------------------------------------------------------------------

            call set_block_scrub_flag(array, block, blkndx, 1)
c            call get_blk_header(flag, blkndx, c_block_flags)
c            print 10101,me,current_line,blkndx,flag
c10101 format('Task ',me,' line ',current_line,' blkndx, flag ',
c     *           2(i5,1x))
         else

c-------------------------------------------------------------------------
c   Free the block (if it is NOT a persistent block).
c-------------------------------------------------------------------------

            call_marker = 90909
            if (flag .eq. 0) 
     *         call free_block(array, block, blkndx, array_table,
     *                  narray_table, index_table, nindex_table,
     *                  block_map_table)
         endif
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  cart2sphtran
     +
     +                    ( NXYZ,NRY,NROWMX,
     +                      L,
     +                      TEMP,
     +
     +                            NROW,
     +                            ROW,
     +                            TMAT )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__XYZ_TO_RY_MATRIX
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation generates the transformation matrix for
C                performing a primitive gaussian integral batch
C                transformation from cartesian to spherical gaussian
C                type orbitals.
C
C                Input:
C
C                     NXYZ = dimension of xyz-monomial basis
C                            corresponding to the specified shell
C                            quantum number L.
C                            Must at least be equal to (L+1)*(L+2)/2.
C
C                      NRY = dimension of ry-spherical basis
C                            corresponding to the specified shell
C                            quantum number L.
C                            Must at least be equal to 2L+1.
C
C                   NROWMX = maximum number of xyz-monomials in one
C                            ry-solid harmonic function corresponding
C                            to the specified shell quantum number L.
C                            Must at least be equal to (L/2+1)*(L/2+2)/2.
C
C                        L = Shell quantum number.
C
C                     TEMP = temporary scratch array.
C
C
C                Output:
C
C                     NROW (I) = Number of xyz-monomials contributing
C                                to the I-th ry-component.
C
C                    ROW (K,I) = K-th xyz-monomial position number
C                                containing nonzero contribution to
C                                the I-th ry-component.
C
C                   TMAT (K,I) = K-th nonzero xyz-monomial coefficient
C                                to the I-th ry-component.
C
C
C                Each ry-component for a specific shell type corresponds
C                to a sherical harmonic function Y (L,M) with M ranging
C                from -L to +L. The TMAT matrix ry-component indices are
C                ordered such that +L corresponds to the 1st index and
C                -L to the last one.
C
C                For the ordering of the xyz-monomials used in the
C                expansion of the ry-components we use the usual
C                preference ordering p>q>r in the x-,y- and z-exponents
C                of x^p y^q z^r. For L=3 we would thus have the 10
C                monomials arranged as follows:
C
C                                #  |  x  y  z
C                              -----------------
C                                1  |  3  0  0
C                                2  |  2  1  0
C                                3  |  2  0  1
C                                4  |  1  2  0
C                                5  |  1  1  1
C                                6  |  1  0  2
C                                7  |  0  3  0
C                                8  |  0  2  1
C                                9  |  0  1  2
C                               10  |  0  0  3
C
C                This ordering is also assumed when evaluating batches
C                of cartesian gaussian integrals, hence the present
C                routine and the cartesian gaussian integral generation
C                routines go hand in hand and must be viewed together
C                when performing xyz-monomial basis ordering changes!
C
C                The ultimate goal of using the present routine is
C                to achieve achieve a transformation matrix T relating
C                cartesian gaussian functions to spherical ones.
C                At his stage it is convenient to introduce all
C                factors independent! of the gaussian exponents that
C                enter the final normalization constant for each
C                spherical gaussian function. Such a function is given
C                by the following expression:
C
C                    LM                     L    LM                2
C                 GTO  (r,t,p) = N (L,a) * r  * Y  (t,p) * exp (-ar )
C                    a
C
C                where t = theta and p = phi and N (L,a) denotes a
C                normalization factor such that
C
C                              LM       *    LM
C                 integral {GTO  (r,t,p)  GTO  (r,t,p) dr dt dp} = 1
C                              a             a
C
C                Since the spherical harmonics are normalized, we can
C                integrate out over the angles t and p and arrive at
C                the following defining expression for N (L,a):
C
C                        2  r=oo  2L+2          2
C                 N (L,a)   int  r     exp (-2ar ) dr  =  1
C                           r=0
C
C                which leads to:
C
C                               ____________________________
C                              / 2^(2L+3+1/2) * a^((2L+3)/2)
C                 N (L,a) =   / -----------------------------
C                           \/     (2L+1)!! * sqrt (pi)
C
C
C                The following part of N (L,a) has already been
C                taken care of during the cartesian integrals
C                generation:
C
C                               ____________________________
C                              / 2^(1+1/2) * a^((2L+3)/2)
C                 N (L,a) =   / -----------------------------
C                           \/          sqrt (pi)
C
C
C                hence we are left only with the following part
C                of N (L,a) to deal with here:
C
C                                   __________
C                                  / 2^(2L+2)
C                                 / -----------
C                               \/   (2L+1)!!
C
C                which is designated RNORM (to reflect its origin)
C                and is being calculated in logarithmic form to avoid
C                integer overflow for the double factorial. The
C                normalization constant for the spherical harmonic
C                part, depending on both L and M quantum numbers,
C                is designated YNORM and is evaluated stepwise
C                from its base value at M = -L or L downwards to
C                -1 or 0. Note, that YNORM should also include a factor
C                in terms of pi, namely 1/sqrt(pi), but this has also
C                already been incorporated into the cartesian integrals
C                evaluation routine.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I,K,L,M,P,T,V
         INTEGER    KEND,PEND
         INTEGER    PP,TT,VV
         INTEGER    LMM,LPM
         INTEGER    NRY,NXYZ,NROWMX
         INTEGER    RY,XYZ

         INTEGER    NROW (1:NRY)

         INTEGER    ROW (1:NROWMX,1:NRY)

         DOUBLE PRECISION   A,B,C,D,X
         DOUBLE PRECISION   RNORM,YNORM,RYNORM
         DOUBLE PRECISION   XCOL
         DOUBLE PRECISION   XM,XK,XL,XT,XV
         DOUBLE PRECISION   XKK,XLL,XPP
         DOUBLE PRECISION   XLMM,XLPM
         DOUBLE PRECISION   ZERO,HALF,ONE,TWO,TEN

         DOUBLE PRECISION   TEMP (1:NXYZ)

         DOUBLE PRECISION   TMAT (1:NROWMX,1:NRY)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (HALF  =  0.5D0)
         PARAMETER  (ONE   =  1.D0)
         PARAMETER  (TWO   =  2.D0)
         PARAMETER  (TEN   =  10.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the RNORM and the initial value of
C                YNORM at M = -L. Form initial combined norm RYNORM.
C
C
c         RNORM = DFLOAT (2*L+2) * DLOG10 (TWO)
c         DO 10 I = 1,L
c           RNORM = RNORM - DLOG10 (DFLOAT (I+I+1))
c   10    CONTINUE
c         RNORM = TEN ** (HALF*RNORM)
c---------------------------------------------------------------------------|
c  Normalization of all the spherical functions are done withing the        |
c  subroutine which calls this one, so we don't do it here                  |
c---------------------------------------------------------------------------|
            RNORM=1.d0 
c----------------------------------------------------------------------------

         YNORM = HALF
         DO 20 I = 1,L
            YNORM = YNORM * DFLOAT (I+I+1) / DFLOAT (I+I)
   20    CONTINUE
         YNORM = DSQRT (YNORM)

         RYNORM = RNORM * YNORM
c---------------------------------------------------------------------------|
c  Normalization of all the spherical functions are done withing the        |
c  subroutine which calls this one, so we don't do it here                  |
c---------------------------------------------------------------------------|
c----------------------------------------------------------------------------


C
C
C             ...evaluate monomial expansion for spherical harmonics
C                Y(L,M) for the cases M < 0. Note that the loop below
C                uses M, which goes from L down to 1. This M represents
C                in fact the absolute value of M, i.e. |M|.
C
C                There are two ways of coding this:
C
C                    1) symbolically, in which the nominators and
C                       denominators of all fractions are handled
C                       separately, performing common divisor cuts
C                       at every single step. This procedure is
C                       slower than the direct evaluation but more
C                       accurate. Also the symbollic procedure suffers
C                       from integer overflow at about L = 16, so
C                       there is a limit on the shell size one can
C                       safely handle.
C
C                    2) the direct mode, in which all fractions are
C                       multiplied together as flp's.
C
C                This routine uses the direct mode.
C
C
         XL = DFLOAT (L)
         XLL = XL + XL

         DO 100 M = L,1,-1

            DO 110 XYZ = 1,NXYZ
               TEMP (XYZ) = ZERO
  110       CONTINUE

            LMM = L - M
            LPM = L + M
            XM = DFLOAT (M)
            XLPM = DFLOAT (LPM)
            XLMM = DFLOAT (LMM)
            KEND = LMM / 2
            PEND = (M - 1) / 2
            
            IF (M.EQ.L) THEN
                A = XL
            ELSE
                IF (MOD(LMM,2).EQ.0) THEN
                    X = XLMM / (XLPM + ONE)
                    RYNORM = RYNORM * DSQRT (X)
                    A = A * (XM/(XM+ONE)) / X
                ELSE
                    RYNORM = RYNORM * DSQRT (XLMM * (XLPM + ONE))
                    A = A * (XM/(XM+ONE)) / XLMM
                END IF
            END IF

            B = A
            DO 120 K = 0,KEND
               IF (K.NE.0) THEN
                   XK = DFLOAT (K)
                   XKK = XK + XK
                   X = XLMM - XKK + ONE
                   B = - B * (X/(XLL-XKK+ONE)) * ((X+ONE)/TWO)
               END IF

               C = B
               DO 130 P = 0,PEND
                  PP = P + P
                  IF (P.NE.0) THEN
                      XPP = DFLOAT (PP)
                      X = XM - XPP
                      C = - C * (X/XPP) * ((X+ONE)/(XPP+ONE))
                  END IF

                  D = C
                  DO 140 T = K,0,-1
                     TT = T + T
                     XT = DFLOAT (T)
                     IF (T.NE.K) THEN
                         D = D / (XK - XT)
                     END IF

                     XCOL = D
                     DO 150 V = 0,T
                        VV = V + V
                        IF (V.EQ.0) THEN
                            DO 160 I = 2,T
                               XCOL = XCOL / DFLOAT (I)
  160                       CONTINUE
                        ELSE
                            XV = DFLOAT (V)
                            XCOL = XCOL * ((XT-XV+ONE)/XV)
                        END IF

                        XYZ = (LMM-VV+PP+2)*(LMM-VV+PP+1)/2 + LMM-TT+1

                        TEMP (XYZ) = TEMP (XYZ) + XCOL

  150                CONTINUE
  140             CONTINUE
  130          CONTINUE
  120       CONTINUE

            RY = LPM+1

            I = 0
            DO 170 XYZ = 1,NXYZ
               IF (TEMP (XYZ).NE.ZERO)  THEN
                   I = I + 1
                   ROW (I,RY) = XYZ
c                   write(6,*) ROW (I,RY),I,RY,'<<----' 
                   TMAT (I,RY) = RYNORM * TEMP (XYZ)
               END IF
  170       CONTINUE
            NROW (RY) = I

  100    CONTINUE
C
C
C             ...evaluate monomial expansion for spherical harmonics
C                Y(L,M) for the cases M >= 0.
C
C
         RYNORM = RNORM * YNORM

         DO 200 M = L,0,-1

            DO 210 XYZ = 1,NXYZ
               TEMP (XYZ) = ZERO
  210       CONTINUE

            LMM = L - M
            LPM = L + M
            XM = DFLOAT (M)
            XLPM = DFLOAT (LPM)
            XLMM = DFLOAT (LMM)
            KEND = LMM / 2
            PEND = M / 2
            
            IF (M.EQ.0) THEN
                RYNORM = RYNORM / DSQRT (TWO)
            END IF

            IF (M.EQ.L) THEN
                A = ONE
            ELSE
                IF (MOD(LMM,2).EQ.0) THEN
                    X = XLMM / (XLPM + ONE)
                    RYNORM = RYNORM * DSQRT (X)
                    A = A / X
                ELSE
                    RYNORM = RYNORM * DSQRT (XLMM * (XLPM + ONE))
                    A = A / XLMM
                END IF
            END IF

            B = A
            DO 220 K = 0,KEND
               IF (K.NE.0) THEN
                   XK = DFLOAT (K)
                   XKK = XK + XK
                   X = XLMM - XKK + ONE
                   B = - B * (X/(XLL-XKK+ONE)) * ((X+ONE)/TWO)
               END IF

               C = B
               DO 230 P = 0,PEND
                  PP = P + P
                  IF (P.NE.0) THEN
                      XPP = DFLOAT (PP)
                      X = XM - XPP + ONE
                      C = - C * (X/XPP) * ((X+ONE)/(XPP-ONE))
                  END IF

                  D = C
                  DO 240 T = K,0,-1
                     TT = T + T
                     XT = DFLOAT (T)
                     IF (T.NE.K) THEN
                         D = D / (XK - XT)
                     END IF

                     XCOL = D
                     DO 250 V = 0,T
                        VV = V + V
                        IF (V.EQ.0) THEN
                            DO 260 I = 2,T
                               XCOL = XCOL / DFLOAT (I)
  260                       CONTINUE
                        ELSE
                            XV = DFLOAT (V)
                            XCOL = XCOL * ((XT-XV+ONE)/XV)
                        END IF

                        XYZ = (LMM-VV+PP+1)*(LMM-VV+PP)/2 + LMM-TT+1
 
                        TEMP (XYZ) = TEMP (XYZ) + XCOL

  250                CONTINUE
  240             CONTINUE
  230          CONTINUE
  220       CONTINUE

            RY = LMM+1

            I = 0
            DO 270 XYZ = 1,NXYZ
               IF (TEMP (XYZ).NE.0)  THEN
                   I = I + 1
                   ROW (I,RY) = XYZ
c                   write(6,*) ROW (I,RY),I,RY,'<<===='
                   TMAT (I,RY) = RYNORM * TEMP (XYZ)
               END IF
  270       CONTINUE
            NROW (RY) = I

  200    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      program aces3
c      subroutine beta()
      implicit none

      include 'mpif.h'
      include 'aces3_version.h'
      include 'int_gen_parms.h'
      include 'proto_defines.h'
      include 'proto_events.h'
      include 'maxdim.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'machine_types.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'hess.h'
      include 'server_monitor.h'
      include 'timerz.h'
      include 'sial_config_params.h'
      include 'checkpoint_data.h'
      include 'F12.h'
      include 'eominit.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer ierr, mpierr, istat
      integer mstr_is_wrkr
      integer id, platoon_id, nwrkr, mem_wrkr
      integer instance, sial_program_instance
      integer next
      integer i, j, x, y, z, n, dummy
      integer n1, n2
      integer proto_driver
      integer str_trimlen
      integer rank, company, pst_get_company
      integer my_company
      integer pst_get_company_rank
      integer company_comm, pst_get_company_comm
      integer master, pst_get_master
      integer nworkers_needed, nworkers_min
      integer check_malloc
      integer sheap_flag
      integer auto_seg_switch
      integer status(MPI_STATUS_SIZE)
      integer company_id
      integer saveocc, savevirt, saveao
      integer ndim 
      integer Iostat, Ierror 

      character*20 logfile
      character*80 sial_program
      character*80 company_string
      character*80 package
      character*80 tracetype
      character*80 erd_fast_memcalc
      character*80 debug_print
      character*80 restart_program
      character*80 auto_seg_algorithm
      character*80 timer_param
      character*80 ctrip_str
      character*80 ihess_str
      character*80 jhess_str
      character*80 sub_str
      character*80 jobflow  

      logical company_defined
      logical is_file_open
      logical*8 l8false
      integer jodadone
      logical first
      logical instab
      logical really_ignore_dropmo
      logical scfskip
      logical dryrun_abort
      logical do_restart, file_exist
      logical flag
      logical do_write 
      logical do_ecp  

      double precision t1, t2
      double precision vnn, diff, avg
      double precision dbuf(1)

      integer i1, i2
      integer*8 mpierr8, nprocs8

      common /flags/ iflags
      integer iflags(100) 
      integer iflags2(500)

      integer istg,n_ipeomcc_roots(1)

#ifdef ALTIX
      pointer (dptr, dbuf)
#else
      common dbuf
#endif

      call init_machine_types()
      call aces_init_rte()
      call mpi_init(ierr)

#ifdef ALTIX
      sheap_flag = 1
#else
      sheap_flag = 0
#endif

      call mpi_comm_size(mpi_comm_world, nprocs, mpierr)
      call mpi_comm_rank(mpi_comm_world, me, mpierr)

c---------------------------------------------------------------------------
c   Scan the ZMAT file for the MAXMEM parameter.  This is needed to set
c   up the heap memory that will be used.
c---------------------------------------------------------------------------

      if (me .eq. 0) then
         call init_params('ZMAT')
         maxmem = 0
         call igetparam('MAXMEM', 1, maxmem)
      endif

c---------------------------------------------------------------------------
c   Set the summary print flag to true  
c---------------------------------------------------------------------------

         do_write = .true.

c---------------------------------------------------------------------------
c   Initial call to set up memory.
c---------------------------------------------------------------------------

      call mpi_bcast(maxmem, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      if (maxmem .eq. 0) maxmem = check_malloc() * 0.8
999   continue 
      call mem_alloc_init(maxmem, sheap_flag, ierr)
      if (ierr .lt. 0) then
         call abort_job()
      else 
         print *,'MEMORY ALLOCATION Sucessfull: maxmem = ',maxmem, 
     *           'PROC', me 
      endif
#ifdef ALTIX
      dptr = dshptr    ! set dbuf pointer to shared mem.
#endif

      dryrun_abort = .false.
      if (me .eq. 0) then
         print *,'ACESIII version, ',aces3_version,
     *            ' is run on ',nprocs,' processors.'
c         call prt_time('Program start')

c-------------------------------------------------------------------------
c   Do we have an existing JOBARC file?  If not, we are doing an SCF
c   from scratch.
c-------------------------------------------------------------------------

         call scf_init(vnn)

c-------------------------------------------------------------------------
c   Verify that we have valid combinations of parameters from the *ACES2
c   section of the ZMAT file.
c-------------------------------------------------------------------------

        call verify_aces2_params()

c-------------------------------------------------------------------------
c   Create a ZMAT.AUTO file from the user's ZMAT, adding the defaulted
c   parameters in the *SIP section.
c-------------------------------------------------------------------------

         call write_zmat_auto(jobflow)
         call aces_ja_fin()   ! close JOBARC subsystem

c--------------------------------------------------------------------------
c   Initialize the parameter decoding routines.
c--------------------------------------------------------------------------

         call init_params('ZMAT.AUTO')

c-------------------------------------------------------------------------
c   Scan all sio files to determine whether second derivative integrals
c   are needed.
c-------------------------------------------------------------------------
         stabvalue = 0.0d0
         instab = .true.
         scfskip = .false.
         really_ignore_dropmo = .false.
         sial_program_instance = 1
         first = .true.
   10    continue
         sial_program = ' '
         call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                  sial_program)
         if (sial_program .ne. ' ') then
            call get_sial_config_params(sial_program)
            if (.not. use_2der_integrals) then
               sial_program_instance = sial_program_instance + 1
	       go to 10
            endif
         endif
         print *,'USE_2DER_INTEGRALS = ',use_2der_integrals
      endif

      call mpi_barrier(mpi_comm_world, mpierr)

      calc_2der_integrals = use_2der_integrals

      sial_program_instance = 0
      jodadone = 0
      dryrun   = .true.   ! 1st pass through SIAL code is a dryrun
      simulator = .false.
      nworkers_min = 0
      server_monitor_on = .false.

c-----------------------------------------------------------------------
c   Check for existence of the restart file.
c-----------------------------------------------------------------------

      restart_file        = 94
      inquire (file='aces3.restart', exist = do_restart)

c------------------------------------------------------------------------
c   Initialize checkpoint_data common block.
c------------------------------------------------------------------------

      master_ckpt_unit    = 93
      nckpt_arrays        = 0
      nactive_allocate_table = 0
      nactive_create_table   = 0
      nfree_space            = 0
      nfree_space_candidates = 0
      restart_job = do_restart

      call mpi_barrier(mpi_comm_world, mpierr)

   50 continue
      call reset_internal_system_data()   ! restore system flags
      write_hess = .false.
      t1 =  mpi_wtime()

      if (me .eq. 0) then

c---------------------------------------------------------------------
c   Set parameter defaults.
c---------------------------------------------------------------------

         mstr_is_wrkr   = 1
         package        = 'ERD'
         molfile     = 'MOL'
         local_path     = '.'
         tracetype      = ' '
         sial_program   = ' '
         erd_fast_memcalc    = 'NO'
         debug_print         = 'NO'
         restart_program = ' '
         auto_seg_algorithm = 'SEGMENT_OPTIMIZED'
         timer_param        = 'NO'
         aat_database = ' '
         ctrip_str    = ' '
         ihess_str    = ' '
         jhess_str    = ' '
         sub_str      = ' '

         nworkthread = 20
         sip_mx_ao_segsize   = 0
         sip_mx_occ_segsize  = 0
         sip_mx_virt_segsize = 0
         sip_sub_segsize     = 5
         sip_sub_occ_segsize = 5
         sip_sub_virt_segsize = 5
         sip_sub_ao_segsize   = 5
         reg = 0.0d0

c---------------------------------------------------------------------
c   Read parameters.
c---------------------------------------------------------------------

         call igetparam('MASTER_IS_WORKER', 1, mstr_is_wrkr)
         call igetparam('SIP_MX_SEGSIZE', 1, sip_mx_ao_segsize)
         call igetparam('SIP_MX_OCC_SEGSIZE', 1, sip_mx_occ_segsize)
         call igetparam('SIP_MX_VIRT_SEGSIZE', 1, sip_mx_virt_segsize)
         call cgetparam('INTEGRAL_PACKAGE', 1, package)
         call cgetparam('MOLFILE', 1, molfile)
         call cgetparam('LOCAL_PATH', 1, local_path)
         call cgetparam('TRACE', 1, tracetype)
         call cgetparam('FAST_ERD_MEMCALC', 1, erd_fast_memcalc)
         call cgetparam('DEBUG_PRINT', 1, debug_print)
         call igetparam('NWORKTHREAD', 1, nworkthread)
         call cgetparam('AUTO_SEG_ALGORITHM', 1, auto_seg_algorithm)
         call cgetparam('AAT_DATABASE', 1, aat_database)
         call cgetparam('ITRIP', 1, ctrip_str)
         call cgetparam('IHESS', 1, ihess_str)
         call cgetparam('JHESS', 1, jhess_str)
         call cgetparam('SUB', 1, sub_str)
         call igetparam('SIP_SUB_SEGSIZE', 1, sip_sub_segsize)
         call igetparam('SIP_SUB_OCC_SEGSIZE', 1, sip_sub_occ_segsize)
         call igetparam('SIP_SUB_VIRT_SEGSIZE', 1, sip_sub_virt_segsize)
         call igetparam('SIP_SUB_AO_SEGSIZE', 1, sip_sub_ao_segsize)
         call rgetparam('REGULARIZER',1,reg)


         call decode_fmo_params()

c-------------------------------------------------------------------------
c   Strip any embedded nulls out of molfile name.
c-------------------------------------------------------------------------

         do i = 1, len(molfile)
            if (molfile(i:i) .eq. char(0)) molfile(i:i) = ' '
         enddo

         ierr = 0
         if (debug_print(1:1) .eq. 'Y') then
            dbg = .true.
         else if (debug_print(1:1) .eq. 'N') then
           dbg = .false.
         else
           print *,'====>> Invalid value for DEBUG_PRINT'
           ierr = ierr + 1
         endif

c-----------------------------------------------------------------------
c   Open the restart file.
c-----------------------------------------------------------------------

         open (unit=restart_file, file = 'aces3.restart')

         if (first) then
            maxmem = 0
            call igetparam('MAXMEM', 1, maxmem)
            if (do_restart) then
               read (restart_file, *) restart_program

               if (restart_program(1:1) .ne. ' ') then
                  n1 = str_trimlen(restart_program)
                  print *,'***** Restarting job on ',
     *                 restart_program(1:n1),'*****'
                  dryrun     = .false.    ! skip dryrun pass on restart

c---------------------------------------------------------------------------
c   Find the restart_program in the list of SIAL_PROGRAMs.
c---------------------------------------------------------------------------

                  do i = 1, 100
                     sial_program = ' '
                     call cgetparam('SIAL_PROGRAM', i,
     *                     sial_program)
                     if (sial_program(1:1) .eq. ' ') then
                        print *,'Error: RESTART program not found in ',
     *                    'list of SIAL_PROGRAM parameters.'
                        call abort_job()
                     else
                        n2 = str_trimlen(sial_program)
                        if (sial_program(1:n2) .eq.
     *                      restart_program(1:n1)) then
                           sial_program_instance = i - 1 ! step back one program
                           go to 60
                        endif
                     endif
                  enddo
  60              continue
               endif    ! restart_program
             endif      ! do_restart
         endif          ! first

c---------------------------------------------------------------------------
c   Get the next instance of the SIAL_PROGRAM parameter.
c---------------------------------------------------------------------------
         if (instab .and. (.not. dryrun) ) then
c Check to see if there is an instability to follow
C Check to see if we just ran the instability sial program
           sial_program = ' '
           call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                    sial_program)
           if ((sial_program(1:6) .eq. 'instab') .or.
     *         (sial_program(1:6) .eq. 'INSTAB')) then
             sial_program_instance = 1
C If we just ran instab and there was no negative eigenvalue,
C then stop checking
             if (stabvalue .ge. 0.0d0) instab = .false.
             scfskip = .true.
           endif
C turn off the really_ignore_dropmo flag before we check to see if we need it
           really_ignore_dropmo = .false.
         endif
         sial_program_instance = sial_program_instance + 1
         sial_program = ' '
         call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                  sial_program)
         if (instab) then
           if ((sial_program(1:4) .eq. 'tran') .or.
     *         (sial_program(1:4) .eq. 'TRAN')) then
C If the next program is an integral transform and then AFTER that an instability
C check, then make sure NOT to drop mos (turn really_ignore_dropmo = .true.)
               sial_program = ' '
               call cgetparam('SIAL_PROGRAM', sial_program_instance+1,
     *                        sial_program)
             if ((sial_program(1:6) .eq. 'instab') .or.
     *           (sial_program(1:6) .eq. 'INSTAB'))
     *           really_ignore_dropmo = .true.
             sial_program = ' '
             call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                      sial_program)
           endif
         endif
         if ((.not. instab).and. (.not. dryrun) ) then
C If we have stopped checking for instabilities and the instab program is
C called, ignore it
           if ((sial_program(1:6) .eq. 'instab') .or.
     *         (sial_program(1:6) .eq. 'INSTAB')) then
             sial_program_instance = sial_program_instance + 1
             sial_program = ' '
             call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                      sial_program)
           endif
         endif
         if (sial_program(1:1) .eq. ' ') then
            if (dryrun) then
               if (dryrun_abort) then
                  print *,'Job requires at least ',nworkers_min,
     *              ' processors in COMPANY parameter to run.'
                  print *,'----- Aborting due to dryrun errors. ----'
                  jodadone = 1
               endif

               dryrun = .false.
               scfskip = .false.
            else

c---------------------------------------------------------------------------
c   We have looped over the number of SIAL_PROGRAM instances.  Now we
c   must let xjoda do its processing, checking the JODADONE flag to
c   determine whether the job is complete.
c---------------------------------------------------------------------------

               if (vib_freq_calc .or. geom_opt) then
                  call mem_alloc_reset()            ! geopt may use some heap
                  call check_jodadone(jodadone)
                  if (sial_program_instance .eq. 1) then
                     print *,'Error: No SIAL_PROGRAM parameter'
                     call abort_job()
                  endif
                  if (jodadone .eq. 0) instab = .true.
               else
                  jodadone = 1
               endif   ! vib_freq

            endif   ! dryrun
         endif   ! sial_program
      endif    ! me .eq. 0

c----------------------------------------------------------------------------
c   Send jodadone flag to all processors, check for end of job.
c---------------------------------------------------------------------------

      call c_flush_stdout()  ! flush joda print to stdout
      call mpi_bcast(jodadone, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      call mpi_barrier(mpi_comm_world,mpierr)
      if (jodadone .ne. 0) then
         if (me .eq. 0) then
            call prt_time('Program stop')

c----------------------------------------------------------------------------
c   Remove the restart file.
c----------------------------------------------------------------------------

            close (restart_file)
            call f_deletefile('aces3.restart' // char(0), -1)
         endif

         call mpi_finalize(ierr)
         stop
c         return
      endif

c--------------------------------------------------------------------------
c   Set up memory allocation subsystem.
c--------------------------------------------------------------------------

      call mpi_bcast(maxmem, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      if (maxmem .eq. 0) maxmem = check_malloc() * 0.8
c      call mem_alloc_init(maxmem, sheap_flag, ierr)
      if (ierr .lt. 0) then
         print *,'MEMORY ALLOCATION ERROR: maxmem = ',maxmem
         call abort_job()
      endif
#ifdef ALTIX
      dptr = dshptr    ! set dbuf pointer to shared mem.
#endif

c--------------------------------------------------------------------------
c   Resume parameter checking on process 0.
c--------------------------------------------------------------------------

      if (me .eq. 0) then
         if (sial_program(1:1) .eq. ' ') then
            sial_program_instance = 1
            call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                  sial_program)
            if ((sial_program(1:3) .eq. 'scf') .or.
     *          (sial_program(1:3) .eq. 'SCF')) then
                if (scfskip) then
                  sial_program_instance = sial_program_instance + 1
                  call cgetparam('SIAL_PROGRAM', sial_program_instance,
     *                           sial_program)
                endif
            endif
         endif

         if (sial_program(1:1) .eq. ' ') then
            print *,'====>> SIAL_PROGRAM parameter is required.'
            ierr = ierr + 1
         else
            print *,'Next SIAL program: ',trim(sial_program)
         endif

c--------------------------------------------------------------------------
c   Read program-specific parameters from the config file.
c--------------------------------------------------------------------------

         call get_sial_config_params(sial_program)
         if (really_ignore_dropmo) ignore_dropmo = .true.

c------------------------------------------------------------------------
c   Write current sial_program into the restart file.
c------------------------------------------------------------------------

         rewind (restart_file)
         write (restart_file,*) sial_program
         close (restart_file)

         if (mstr_is_wrkr .eq. 0) then
            master_is_worker = .false.
         else
            master_is_worker = .true.
         endif

         managers_are_workers = .true.

c----------------------------------------------------------------------
c   Set up companies.
c----------------------------------------------------------------------

         call init_company
         company_defined = .false.
         instance = 1

  100   continue
        company_string = ' '
        call cgetparam('COMPANY', instance, company_string)

        if (company_string(1:1) .ne. ' ') then
           read (company_string, *) id, platoon_id, nwrkr,
     *                               mem_wrkr
           if (mem_wrkr .eq. 0) mem_wrkr = maxmem

           if (no_servers) then
              print *,'Overriding COMPANY parameter, using ',
     *            nprocs,' processes as workers.'
              nwrkr = nprocs
           endif

           call build_company_platoon(id, platoon_id,
     *                      nwrkr, mem_wrkr, .false., sial_program)
           if (dbg) print *,'Built company ',id,' platoon ',platoon_id,
     *                       '...'
           instance = instance + 1
           company_defined = .true.
           go to 100
        endif

        if (.not. company_defined) then
           print *,'====>> COMPANY parameter was not specified.'
           ierr = ierr + 1
        endif

        company_string = ' '
        io_company_id = 0

        if (.not. no_servers) then
           call cgetparam('IOCOMPANY', 1, company_string)
           n = str_trimlen(company_string)
           if (n .gt. 0) then
              read (company_string, *) id, platoon_id, nwrkr,
     *                               mem_wrkr
              if (mem_wrkr .eq. 0) mem_wrkr = maxmem
              call build_company_platoon(id, platoon_id,
     *                      nwrkr, mem_wrkr, .true., ' ')
              io_company_id = id
           endif
        endif

        if (package(1:3) .eq. 'ERD') then
           intpkg = flocke_package
        else
           print *,'====>> Invalid integral package: ',package
           ierr = ierr + 1
        endif

        if (erd_fast_memcalc(1:1) .eq. 'Y') then
           fast_erd_memcalc = .true.
        else if (erd_fast_memcalc(1:1) .eq. 'N') then
           fast_erd_memcalc = .false.
        else
           print *,'====>> Invalid value for FAST_ERD_MEMCALC'
           ierr = ierr + 1
        endif

        if (auto_seg_algorithm(1:16) .eq. 'MEMORY_OPTIMIZED') then
           auto_seg_switch = 1
        else if (auto_seg_algorithm(1:17) .eq.
     *                                     'SEGMENT_OPTIMIZED') then
           auto_seg_switch = 2
        else
           print *,'====>> Invalid value for AUTO_SEG_ALGORITHM'
           ierr = ierr + 1
        endif

c----------------------------------------------------------------------------
c   Check timer parameter.  The values can be either 'YES', 'NO' or a
c   sial program.
c----------------------------------------------------------------------------

        next = 0
        n = str_trimlen(sial_program)
  200   continue
        timer_param = ' '
        next = next + 1
        call cgetparam('TIMERS', next, timer_param)
        n2 = str_trimlen(timer_param)

        do_timer = .false.
        if (timer_param(1:1) .eq. 'Y') then
           do_timer = .true.
        else if (timer_param(1:1) .ne. ' ') then

c---------------------------------------------------------------------------
c   Does the timer_param match the sial_program?
c---------------------------------------------------------------------------

           if (timer_param(1:n2) .eq. sial_program(1:n)) then
              do_timer = .true.
           else
              go to 200   ! check next possible value.
           endif
        endif

        tracelevel = 0
        if (tracetype(1:12) .eq. 'CONTRACTIONS') then
           tracelevel = contraction_trace
        else if (tracetype(1:12) .eq. 'INSTRUCTIONS') then
           tracelevel = instruction_trace
        else if (tracetype(1:5) .eq. 'PROCS') then
           tracelevel = proc_trace
        endif

        iworker_type = direct_integral_worker
        cworker_type = sip_contraction_worker
        algorithm_flag = 3

c-------------------------------------------------------------------
c   Read basis data from the molfile.
c-------------------------------------------------------------------

         if (sial_program(1:3) .eq. 'scf' .or.
     *       sial_program(1:3) .eq. 'SCF') then
            if_scf = .true.
#ifdef AIX
            stack_algorithm_type = 1   ! avoids comm subsystem mem exhaustion
#else
            stack_algorithm_type = 2
#endif
         else
            if_scf = .false.
            stack_algorithm_type = 1
         endif

         if (sial_program(1:5) .eq. 'guess' .or.
     &        sial_program(1:5) .eq. 'GUESS') then
           init_scf = .true.
#ifdef AIX
            stack_algorithm_type = 1   ! avoids comm subsystem mem exhaustion
#else
            stack_algorithm_type = 2
#endif
         else
           init_scf = .false.
           stack_algorithm_type = 1
         endif

C JNB
         if (sial_program(1:3) .eq. 'fno' .or.
     *       sial_program(1:3) .eq. 'FNO') then
            if_fno = .true.
         else
             if_fno = .false.
         endif

c-------------------------------------------------------------------
c Always set the stack_algorithm_typr to 2 -> extra blocks allocated 
c based on usage.  
c-------------------------------------------------------------------

c        stack_algorithm_type = 2

         first = .false.
         call init_data()
         call joda_prep()

         if (sip_mx_occ_segsize.lt.1.or.
     &       sip_mx_virt_segsize.lt.1.or.
     &       sip_mx_ao_segsize.lt.1) then
c         o This will crash if it cannot find segment sizes.
           saveocc  = sip_mx_occ_segsize
           savevirt = sip_mx_virt_segsize
           saveao   = sip_mx_ao_segsize
           call det_segsizes(auto_seg_switch, nprocs)
           if (saveocc .gt. 0) sip_mx_occ_segsize = saveocc
           if (savevirt .gt. 0) sip_mx_virt_segsize = savevirt
           if (saveao .gt. 0) sip_mx_ao_segsize = saveao
         end if

c----------------------------------------------------------------------
c   Define some SIAL-accessible parameter values.
c----------------------------------------------------------------------

         if (ctrip_str .eq. ' ') then
            itrips = 1
            itripe = max(nalpha_occupied, nbeta_occupied)
         else
            read (ctrip_str, *) i1, i2
            itrips = i1
            itripe = i2
         endif

         if (ihess_str .eq. ' ') then
            ihess1 = 1
            ihess2 = ncenters
         else
            read (ihess_str, *) i1, i2
            ihess1 = i1
            ihess2 = i2
         endif

         if (jhess_str .eq. ' ') then
            jhess1 = 1
            jhess2 = ncenters
         else
            read (jhess_str, *) i1, i2
            jhess1 = i1
            jhess2 = i2
         endif

         if (sub_str .eq. ' ') then
            subb = -1
            sube = -1
         else
            read (sub_str, *) i1, i2
            subb = i1
            sube = i2
         endif

c----------------------------------------------------------------------
c   Additional error checking on parameter values.
c----------------------------------------------------------------------

        if (ncenters .gt. max_centers) then
           print *,'Number of centers is ',ncenters,', greater than ',
     *             ' the limit of ',max_centers
           ierr = ierr + 1
        endif

        if (nshells .gt. max_shells) then
           print *,'Number of shells is ',nshells,', greater than ',
     *             ' the limit of ',max_shells
           ierr = ierr + 1
        endif

        if (ierr .gt. 0) then
           print *,'Task ',me,
     *           ' ====>> Aborting due to parameter errors...'
           call c_flush_stdout()
           call mpi_abort(mpi_comm_world, 1, mpierr)
        else

           call int_gen_init()
cVFL  
c          go to 333 
           if (if_scf) then !  .eq. .true.) then

           if (.not. dryrun .and. do_write) then

              open(66,file='summary.out')
              write(66,*) ' '
              write(66,99) aces3_version, nprocs   
              if (iuhf .eq. 0) write(66,101)
              if (iuhf .eq. 1) write(66,102)
              write(66,*) ' '
              write(66,103) jobflow
              write(66,104) nalpha_occupied+nbeta_occupied
              write(66,105) end_nfps(nshells)

99         FORMAT(5x,'ACESIII version,',2x,A10,2x,
     *            'is run on',2x,I8,2x,'processors.')
101        FORMAT(5x,'REFERENCE = RHF ')
102        FORMAT(5x,'REFERENCE = UHF ')
103        FORMAT(5x,'CALCULATION TYPE =',2x,A80)
104        FORMAT(5x,'Number of electrons =',2x,I8)
105        FORMAT(5x,'Number of basis functions =',2x,I8)

              do_write = .false.
           endif
           endif

           print *,'----------- Parameter Summary ----------------'
           print *,'DRYRUN...........................',dryrun
           print *,'INTEGRAL_PACKAGE.................',package
           print *,'MOLFILE..........................',molfile
           print *,'MAXMEM...........................',maxmem
           print *,'OCCUPIED.........................',noccupied
           print *,'ALPHA_OCCUPIED...................',nalpha_occupied
           print *,'BETA_OCCUPIED....................',nbeta_occupied
           print *,'AO SEGMENT SIZE..................',
     *                     sip_mx_ao_segsize
           print *,'OCCUPIED SEGMENT SIZE............',
     *                     sip_mx_occ_segsize
           print *,'VIRTUAL SEGMENT SIZE.............',
     *                     sip_mx_virt_segsize
           print *,'Local scratch directory..........',local_path
           print *,'Number of centers................',ncenters
           print *,'Number of shells.................',nshells
           print *,'Number of basis functions........',
     *                 end_nfps(nshells)
           print *,'NO_SERVERS.......................',no_servers
           print *,'IGNORE DROPMO PARAMETERS.........',
     *                                        ignore_dropmo
           print *,'ITRIP............................',itrips,itripe
           print *,'IHESS............................',ihess1,ihess2
           print *,'JHESS............................',jhess1,jhess2
           print *,'SIP_SUB_SEGSIZE..................',sip_sub_segsize
           print *,'SIP_SUB_OCC_SEGSIZE..............',
     *                                            sip_sub_occ_segsize
           print *,'SIP_SUB_VIRT_SEGSIZE.............',
     *                                            sip_sub_virt_segsize
           print *,'SIP_SUB_AO_SEGSIZE...............',
     *                                            sip_sub_ao_segsize
           print *,'REGULARIZER......................',reg
           if (subb .ne. -1 .or. sube .ne. -1)
     *        print *,'SUB..............................',subb,sube
           if (do_timer)
     *        print *,'An instruction timer report will be printed'
           print *,' '
           if (dbg) then
              print *,'end_nfps: ',(end_nfps(i),i=1,nshells)
           endif

        endif
      else
         call aces_init_rte()     ! initialize some aces common blocks
      endif

      if (me .eq. 0) then
         WRITE(6,*) 'VFL NAME :', sial_program 
         WRITE(6,*) 'VFL NAME :', dryrun  
      if (sial_program(1:10) .eq. 'scf_aguess') then
      if (dryrun) then
         write(6,*) ' Skipping Calling ECP main ' 

      else 

         if (iflags(71) .eq. 1) then 
            write(6,*) ' Calling ECP main ' 
            call ecpmain() 
            write(6,*) ' Out Of Calling ECP main ' 
         endif 

      endif 
      endif 
      endif 

c----------------------------------------------------------------------
c   Wait for rank 0 before proceeding.
c----------------------------------------------------------------------

      call mpi_barrier(mpi_comm_world, mpierr)

c---------------------------------------------------------------------
c   Distribute the common block to all processors.
c---------------------------------------------------------------------

      call int_send_common()

c---------------------------------------------------------------------
c   Make sure the tracelevel is set on all procs.
c---------------------------------------------------------------------

      call mpi_bcast(tracelevel, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      call mpi_bcast(dryrun, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      call mpi_bcast(dbg, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      call mpi_bcast(do_timer, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)
      call mpi_bcast(vvvi_stack, 1, mpi_integer, 0,
     *               mpi_comm_world, mpierr)

c--------------------------------------------------------------------
c   Do the event processing.
c--------------------------------------------------------------------

      call build_pst(nprocs, master_is_worker, managers_are_workers,
     *               maxmem, io_company_id)
      if (me .eq. 0) then

c--------------------------------------------------------------------------
c   Send the basis function data to each worker.
c   Send the transformation coeffs and eigenvalues to each non-I/O company
c   worker.
c--------------------------------------------------------------------------

         my_company = pst_get_company(me)
         company_comm = pst_get_company_comm(me)
         my_company_rank = pst_get_company_rank(me)

         do i = 1, nprocs
            company      = pst_get_company(i-1)
            rank = pst_get_company_rank(i-1)
            if (company .eq. my_company .and.
     *          rank .ne. my_company_rank) then
               call mpi_isend(dbuf(master_icoord), nalloc_pkg,
     *                  mpi_double_precision, rank,
     *                  basis_function_request_event,
     *                  company_comm, dummy, mpierr)
               call enter_request(dummy)
            endif
         enddo
      else

c------------------------------------------------------------------------
c   Zero the gradient and hessian on all except the master.
c------------------------------------------------------------------------

         do i = 1, 3*ncenters
            gradient_data(i) = 0.
         enddo


         call mem_alloc(dbuf, 9*ncenters*ncenters,
     *               bytes_per_double, ix_hess,
     *               .true., ierr)
         if (ierr .ne. 0) then
            print *,'Error attempting to malloc hessian data.'
            call mpi_abort(mpi_comm_world, 1, ierr)
         endif

         do i = 1, 9*ncenters*ncenters
            dbuf(ix_hess+i-1)   = 0.d0
         enddo
      endif

c--------------------------------------------------------------------------
c   Compile the SIAL program(s) on the master processor, distribute them
c   to the appropriate companies.
c--------------------------------------------------------------------------

#ifdef HP
      call sial_compile_and_send_tables()
#else
      call sial_compile_and_send_tables1()
#endif

      call mpi_barrier(mpi_comm_world, mpierr)
      call worker_init(istat, nworkers_needed)
      if (istat .ne. 0)
     *   nworkers_min = max(nworkers_min, nworkers_needed)
      call prt_time('Returned from worker_init')
      call worker_work()
      call prt_time('Returned from worker_work')
      call worker_termination()
      call prt_time('Returned from worker_termination')

c--------------------------------------------------------------------------
c   Print out the Nuclear-Nuclear gradient and determine the symmetry
c   equivalence of atoms.
c--------------------------------------------------------------------------

      if (me .eq. 0)  then
         if (dryrun) then
            if (istat .eq. 0) then
               print *,'*** COMPLETED DRYRUN PASS FOR ',
     *           sial_program
            else
               print *,'*** FAILED IN DRYRUN FOR STEP ',
     *           sial_program
               dryrun_abort = .true.
            endif
            call aces_ja_fin()
            go to 1000  ! skip this if dryrun
         endif

        call handle_gradient()
        if (write_hess)
     *   call handle_hessian(dbuf(ix_hess), dbuf(ix_nnhess),
     *                       ncenters, write_hess)

C
C Explicitly correlated contribution
c
            istg=0
            call getrec(1,'JOBARC', 'STGF12', 1, istg)
            if(istg.eq.1) then 
            write(6,*) 
     & 'Explicitly-correlated calculation
     &  with slater-type  geminals will be performed'
            call getrec(1,'JOBARC','F12GAMMA',1,F12GAMMA)
            write(6,*) 'Exponential parameter is',F12GAMMA
              if(.not.dryrun) then
            write(6,*) 'Construction of the grid for calculation 
     &of 3 and 4-electron integrals'
              call F12_grid()
              endif
            endif
            if(istg.eq.0) write(6,*) 
     & 'Lame calculation - slater-type geminals are not included'
c---------------------------------------------------------------------------
c---------------------------------------------------------------------------
           call igetrec(1,'JOBARC','IFLAGS2',500,iflags2)    
           n_ip_roots = 0
           if(iflags2(114).eq.5) then
           call igetrec(20,'JOBARC','IPSYM_A',1,n_ipeomcc_roots) 
           n_ip_roots = n_ipeomcc_roots(1)
           write(6,*) 'IP-EOMCC calculation:'
     & ,n_ip_roots,' roots requested'
            endif

c---------------------------------------------------------------------------
c   Write SCFENEG, TOTENERG, GRADIENT, and HESSIAN data to JOBARC.
c   Clear the dirty flag on JOBARC, and close the JOBARC files.
c---------------------------------------------------------------------------

            call dputrec(1,'JOBARC', 'SCFENEG', 1, scf_energy)
            call dputrec(1,'JOBARC', 'TOTENERG', 1, totenerg)
            call dputrec(1, 'JOBARC', 'GRADIENT', 3*ncenters,
     *                   gradient_data)
            call iputrec(1, 'JOBARC', 'NAOBASFN', 1, naobasis)
            call iputrec(1, 'JOBARC', 'NBASTOT', 1, nbasis)
            call iputrec(1, 'JOBARC', 'AIIIJARC', 1, 1)
            if (write_hess) then
               call dputrec(1, 'JOBARC', 'HESSIANM',
     *            (3*ncenters)*(3*ncenters),
     *            dbuf(ix_hess))
               print *,'WRITE HESSIANM TO JOBARC: LENGTH = ',
     *          (3*ncenters)*(3*ncenters)
            endif
            call iputrec(1,'JOBARC','DIRTYFLG',1,0)

            call aces_ja_fin()
            if (dbg) print *, 'CALLED ACES_JA_FIN'

            if (dbg) print *,
     *         '----------- Normal termination of beta -----------'
            t2 = mpi_wtime()
            print *,'Elapsed time = ',t2-t1,' seconds.'

            write(66,*) ' ' 
            write(66,113) t2-t1  
113         FORMAT(5x,'AcesIII has finished in',2x,F12.2,2x,'seconds') 
            write(66,*) ' ' 

c---------------------------------------------------------------------
c   Receive timer data, print reports.
c---------------------------------------------------------------------

            if (pst_get_company(me) .ne. io_company_id)
     *             call free_all_blocks()
            call mem_alloc_reset()
            call tmanal(sial_program, io_company_id)
      endif

1000  continue
      call mpi_barrier(mpi_comm_world, mpierr)

c--------------------------------------------------------------------------
c   Clear any leftover MPI requests that were made earlier.
c--------------------------------------------------------------------------

c      if (me .eq. 0 .and. .not. dryrun)
c     *      call clear_static_data_requests()

      if (pst_get_company(me) .ne. io_company_id)
     *           call free_all_blocks()
      call mem_alloc_reset()
      call mpi_barrier(mpi_comm_world, mpierr)
      call free_mpi_data()
      call c_flush_stdout()

c----------------------------------------------------------------------------
c   Remove checkpoint files if they exist.
c----------------------------------------------------------------------------

      if (me .eq. 0 .and. .not. dryrun) then
         inquire (file='master_ckpt_file', exist = file_exist)
         if (file_exist) 
     *      call f_deletefile('master_ckpt_file'//char(0),-1)
         inquire (file='CKPT_DIST',exist = file_exist)
         if (file_exist)
     *      call f_deletefile('CKPT_DIST'//char(0),-1)
      endif
      call mpi_barrier(mpi_comm_world, mpierr)
      go to 50

      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__RYS_X_ROOTS_WEIGHTS
     +
     +                    ( NT,NTGQP,
     +                      NGQP,NMOM,
     +                      TVAL,RYSZERO,
     +                      A,B,
     +                      MOM,
     +                      DIA,OFF,
     +                      ROW1,ROW2,
     +
     +                                RTS,
     +                                WTS )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__RYS_X_ROOTS_WEIGHTS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : Master routine to evaluate roots and weights in the
C                interval [0,1] over the Rys weight function:
C
C
C                                       exp(-T*x)
C                             W   (x) = ---------
C                              Rys      2*sqrt(x)
C
C
C                using the general Gaussian Quadrature technique
C                consisting of the following basic steps:
C
C                   1) Calculate the auxillary polynomial moments
C                   2) Calculate the auxillary polynomial coefficients
C                   3) Set up the tridiagonal symmetric terminal
C                      matrix
C                   4) Solve the tridiagonal symmetric terminal
C                      matrix for roots and weights.
C
C                In this routine all T-values are treated all at once.
C                The value of the T-parameter dictates which type of
C                auxillary set of polynomials is to be used for the
C                modified Chebyshev algorithm. The auxillary polynomials
C                are often chosen (as is the case here) to be orthogonal
C                relative to some classical weight function.
C
C                The classical weights used to establish the auxillary
C                polynomials are the following (notation according to
C                M.Abramowitz and I.A.Stegun, Handbook of Mathematical
C                Functions, 1964):
C
C
C                i) Range of validity: 0 =< T =< 30
C
C                   Here we use shifted Jacobi weights and polynomials:
C
C
C                        W      (p,q,x)  =  (1-x)^(p-q) * x^(q-1)
C                         Jacobi
C
C                        i-th Jacobi polynomial  =  G (p,q,x)
C                                                    i
C
C                   with conditions: x in interval [0,1]
C                                    p-q > -1 , q > 0
C                                    i = 0,1,2,...
C
C
C                ii) Range of validity: 1 < T =< oo (infinity)
C
C                   Here we use generalized Laguerre weights and
C                   polynomials:
C
C
C                        W        (a,x)  =  exp^(-x) * x^a
C                         Laguerre
C
C                        i-th Laguerre polynomial  =  L (a,x)
C                                                      i
C
C                   with conditions: x in interval [0,inf]
C                                    a > -1
C                                    i = 0,1,2,...
C
C
C                Range of validity means that for all the specified
C                T's within the range the resulting moment integrals
C                are accurate to within 1.D-16.
C
C
C                  Input:
C
C                    NT           =  # of T-values
C                    NTGQP        =  # of roots times # of T-values
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    TVAL         =  the T-values
C                    RYSZERO      =  the zeroth Rys moments for all
C                                    T-values
C                    A,B          =  will contain the recurrence
C                                    coefficients for the auxillary
C                                    polynomials
C                    MOM          =  will contain the normed auxillary
C                                    polynomial modified moments
C                    DIA,OFF      =  will contain the diagonal and
C                                    offdiagonal elements of the
C                                    tridiagonal symmetric terminal
C                                    matrix
C                    ROW1,ROW2    =  will be used to evaluate the
C                                    tridiagonal elements of the
C                                    symmetric terminal matrix in an
C                                    efficient way using Sack and
C                                    Donovan's method
C
C                  Output:
C
C                    RTS          =  the roots array
C                    WTS          =  the weights array
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INCLUDE    'erd__jacobi.inc'

         INTEGER    I,J,M,N
         INTEGER    IMAX,JMAX
         INTEGER    IP1,JP1
         INTEGER    ITER
         INTEGER    MOMMAX
         INTEGER    MXITER
         INTEGER    NGQP
         INTEGER    NMOM
         INTEGER    NRTS
         INTEGER    NT,NTGQP

         DOUBLE PRECISION   C,D,F,G,P,R,S
         DOUBLE PRECISION   BINC,SINC
         DOUBLE PRECISION   LIM1,LIM2,LIM3
         DOUBLE PRECISION   MOMI,MOMIM1,MOMIP1,MOMZERO
         DOUBLE PRECISION   R1
         DOUBLE PRECISION   ROOT
         DOUBLE PRECISION   SCALE
         DOUBLE PRECISION   SIGMA,THETA
         DOUBLE PRECISION   T,TINV,TINV2,TINVHF,TINVSQ,TEXP,TPOWER
         DOUBLE PRECISION   TEST1,TEST2
         DOUBLE PRECISION   ZMOM,ZINV
         DOUBLE PRECISION   ZERO,EXTREM,VSMALL,SMALL,TENTH,
     +                      HALF,ONE,ONEP5,TWO,THREE,TEN,TLIMIT

         DOUBLE PRECISION   A       (1:NMOM)
         DOUBLE PRECISION   B       (2:NMOM)
         DOUBLE PRECISION   MOM     (1:NMOM)
         DOUBLE PRECISION   DIA     (1:NGQP)
         DOUBLE PRECISION   OFF     (1:NGQP)
         DOUBLE PRECISION   ROW1    (1:NMOM)
         DOUBLE PRECISION   ROW2    (1:NMOM-1)

         DOUBLE PRECISION   RYSZERO (1:NT)
         DOUBLE PRECISION   TVAL    (1:NT)

         DOUBLE PRECISION   RTS     (1:NTGQP)
         DOUBLE PRECISION   WTS     (1:NTGQP)

         PARAMETER  (ZERO    =  0.D0)
         PARAMETER  (EXTREM  =  1.0D-300)
         PARAMETER  (VSMALL  =  1.0D-16)
         PARAMETER  (SMALL   =  1.0D-6)
         PARAMETER  (TENTH   =  0.1D0)
         PARAMETER  (HALF    =  0.5D0)
         PARAMETER  (ONE     =  1.D0)
         PARAMETER  (ONEP5   =  1.5D0)
         PARAMETER  (TWO     =  2.D0)
         PARAMETER  (THREE   =  3.D0)
         PARAMETER  (TEN     =  10.D0)
         PARAMETER  (TLIMIT  =  15.D0)

         PARAMETER  (MOMMAX  =  30)
         PARAMETER  (MXITER  =  30)
C
C
C------------------------------------------------------------------------
C
C
C             ...main loop over all T values. Check which T case
C                applies.
C
C
         NRTS = 0

         DO 1000 N = 1,NT

            T = TVAL (N)
            MOMZERO = RYSZERO (N)

            IF (T.LE.TLIMIT) THEN
C
C
C             ...The Jacobi section. Check first, if the number of
C                moments wanted is within limits for the Jacobi case.
C                If ok, we proceed by calculating two steps at the
C                same time:
C
C                1) normed shifted Jacobi modified moments defined as
C                   integrals on [0,1] over the Rys weight function:
C
C                                        exp(-Tx)
C                             W   (x) = ---------
C                              Rys      2*sqrt(x)
C
C                   and shifted Jacobi polynomials:
C
C                                G (0.5,0.5,x)
C                                 i
C
C                   A 3-term recursion relation can be given for these
C                   moments as follows:
C
C                       MOM (i+1) = R * MOM (i)  +  S * MOM (i-1)
C
C                   where
C
C                      R  =  (2i+1)/2T  +  (2i+1)/(4i-1)(4i+3)
C                      S  =  2i(2i+1)(2i-1)**2 / (4i-3)(4i+1)(4i-1)**2
C
C                   However, in order to evaluate the moments to the
C                   required accuracy, a downward recursion must be
C                   applied starting with some tiny seed values for
C                   MOM (i+1) and MOM (i):
C
C                       MOM (i-1) = 1/S * ( MOM (i+1) - R * MOM (i))
C
C                   The sequence of moments thus obtained is not
C                   normalized. Hence the downward recursion is
C                   performed down to the zeroth moment ZMOM and the
C                   relevant moments are normalized by subsequent
C                   division with ZMOM.
C
C                   The above downward recursion technique is extremely
C                   unstable if T is very small, in which case even the
C                   small seed values are not small enough to prevent
C                   overflow of the lowest not normalized moments.
C                   In such a case it is better to build the normed
C                   sequence starting with the first moment after the
C                   following considerations. An expansion of MOM (i)
C                   in terms of powers of T shows that the leading
C                   term is in the i-th power of T, i.e.
C
C                                    inf           k
C                       MOM (i)  =   sum  c (i,k) T
C                                   k = i
C
C                   with leading coefficient c (i,i) getting smaller
C                   with increasing i. Hence for very small T it is
C                   sufficient to set:
C
C                                             i
C                       MOM (i)  =   c (i,i) T     (for T very small)
C
C
C                   an equation which is valid in terms of computer
C                   accuray if T is less or equal to the minimum
C                   possible nonzero number within the precision of
C                   the mantissa allowed (here in the present code
C                   this is double precision, hence T less or equal
C                   1.D-16). Rather than evaluating each leading
C                   coefficient c (i,i) individualy (they are given
C                   by very! complicated expressions in terms of sums
C                   of double factorials), the procedure adopted here
C                   was to predetermine each c (i,i) numerically by
C                   running the routine with T = 1.D-16 and presetting
C                   the resulting coefficients in a data array CSMALL
C                   to be used whenever T =< 1.D-16.
C
C                   If T is in the range 1.D-16 to TMAX = 30.D0, then
C                   the routine was calibrated such that the mantissa
C                   of the resulting moments are accurate to the 16th
C                   decimal place. Calibration in this context means the
C                   predetermination of the maximum moment (controled
C                   in the code by its index IMAX) that has to be
C                   generated to perform the downward recurrence
C                   relation starting with the tiny seeds. Hence the
C                   calibration depends on four things:
C
C                       i) The total maximum number MOMMAX of normed
C                          moments wanted.
C
C                      ii) The mantissa accuray wanted for the normed
C                          moments.
C
C                     iii) The tiny values of the two seeds (the nonzero
C                          seed should correpond to the smallest
C                          possible nonzero number representable on
C                          the present computer).
C
C                      iv) T range. Each T range requires a different
C                          maximum moment (i.e. a different IMAX value)
C                          to start with.
C
C                   In order to perform a calibration for a different
C                   machine, one has to write a separate small program
C                   using this routine with different seeds, T- and IMAX
C                   values. Once the seeds have been set, this little
C                   program should recalculate the MOMMAX normed
C                   moments for increasing IMAX values starting with
C                   IMAX= MOMMAX. The IMAX value finally taken for a
C                   particular T-value should then obey the following
C                   inequality:
C
C
C                   | MOM (i,IMAX) - MOM (i,IMAX-1)|
C                   | -----------------------------| < mantissa accuracy
C                   |         MOM (i,IMAX-1)       |
C
C
C                       COMMENTS FOR FAST EVALUATION OF THE MOMENTS
C                      ---------------------------------------------
C                   As can be seen from the downward recursion formula
C                   for the moments, all we need are the values of the R
C                   and 1/S recursion parameters, which are conveniently
C                   precomputed (with R being split as R = R1/2T + R2)
C                   and supplied via an include table 'erd__jacobi.inc'.
C                   Hence 'erd__jacobi.inc' will have the values of the
C                   complicated R2 and SINV = 1/S expressions in the
C                   range from i = 1 to 100. The R1 values are simply
C                   calculated by using the appropriate decrement value
C                   of 2. The include file 'erd__jacobi.inc' will also
C                   contain the CSMALL array for the moments of very
C                   small T's.
C
C
C                2) recurrence coefficients for the shifted Jacobi
C                   polynomials G (0.5,0.5,x), denoted simply by G (x):
C
C
C                         G (x)  =  1
C                          0
C
C                         G (x)  =  (x - A )
C                          1              1
C
C                         G   (x)  =  (x - A   ) * G (x) - B   G   (x)
C                          i+1              i+1     i       i+1 i-1
C
C
C                   The result consists of the recurrence coefficients:
C
C                               A (I) , I = 1,NMOM
C                               B (I) , I = 2,NMOM
C
C                   whose values are given by the following expressions:
C
C
C                        A (i+1) = 4i*(2i+1)-1 / (4i+3)(4i-1)
C
C                        B (i+1) = (4i**2)((4i**2)-4i+1) /
C                                  (4i-3)(4i+1)((4i-1)**2)
C
C                   Since these are complicated and time consuming
C                   expressions, they are precalculated and included
C                   into the include file 'erd__jacobi.inc'.
C
C
C
                IF (NMOM.GT.MOMMAX) THEN
                    WRITE (*,*) ' # of Jacobi moments exceeded! '
                    WRITE (*,*) ' NMOM = ',NMOM
                    WRITE (*,*) ' Maximum value = ',MOMMAX
                    WRITE (*,*) ' erd__rys_x_roots_weights '
                    STOP
                END IF
C
C
C             ...the very small T case.
C
C
                IF (T .LE. VSMALL) THEN

                    IMAX = MIN0 (NMOM,16)
                    A (1) = AJAC (1)
                    MOM (1) = CSMALL (1) * T

                    TPOWER = T
                    DO I = 2,IMAX
                       TPOWER = TPOWER * T
                       A (I) = AJAC (I)
                       B (I) = BJAC (I)
                       MOM (I) = CSMALL (I) * TPOWER
                    END DO

                    DO I = IMAX+1,NMOM
                       A (I) = AJAC (I)
                       B (I) = BJAC (I)
                       MOM (I) = ZERO
                    END DO

                ELSE
C
C
C             ...the general Jacobi case. Set maximum number of moments
C                necessary to get required moments to an accuracy of
C                at least 1.D-16. See above in the routine description
C                for details and calibration of the setting.
C
C
                    IF (NMOM.LE.5) THEN
                        IF (T.LT.SMALL) THEN
                            IMAX = NMOM + 1
                        ELSE IF (T.LT.TENTH) THEN
                            IMAX = NMOM + 3
                        ELSE IF (T.LT.TWO) THEN
                            IMAX = NMOM + 7
                        ELSE IF (T.LT.TEN) THEN
                            IMAX = NMOM + 13
                        ELSE
                            IMAX = NMOM + 22
                        END IF
                    ELSE
                        IF (T.LT.SMALL) THEN
                            IMAX = NMOM
                        ELSE IF (T.LT.TENTH) THEN
                            IMAX = NMOM + 2
                        ELSE IF (T.LT.TWO) THEN
                            IMAX = NMOM + 4
                        ELSE IF (T.LT.TEN) THEN
                            IMAX = NMOM + 8
                        ELSE
                            IMAX = NMOM + 16
                        END IF
                    END IF
C
C
C             ...proceed by setting seed values for downward recursion
C                to obtain minimal solution and start recursive
C                evaluation for all Jacobi moments down to first moment
C                (two loops are necessary here due to calculation of
C                higher moments than actually needed later on).
C
C
                    MOMI = EXTREM
                    MOMIP1 = ZERO

                    TINVHF = HALF / T
                    R1 = DFLOAT (2*IMAX+5)

                    DO I = IMAX+1,NMOM+2,-1
                       R1 = R1 - TWO
                       R = R1 * TINVHF  +  R2 (I)
                       MOMIM1  =  SINV (I) * (MOMIP1 - R * MOMI)
                       MOMIP1 = MOMI
                       MOMI = MOMIM1
                    END DO

                    DO I = NMOM+1,2,-1
                       R1 = R1 - TWO
                       R = R1 * TINVHF  +  R2 (I)
                       MOMIM1  =  SINV (I) * (MOMIP1 - R * MOMI)
                       MOM (I-1) = MOMIM1
                       MOMIP1 = MOMI
                       MOMI = MOMIM1
                    END DO
C
C
C             ...evaluate zeroth moment and normalize sequence.
C                If the absolute zeroth moment is less than the
C                approximate absolute nonzero minimum (set here
C                equal to 1.D-300), the normalization looses its
C                meaning and the calculation must be stopped.
C                Set also here the recurrence relation coefficients
C                A and B for the shifted Jacobi polynomials.
C
C
                    R = THREE * TINVHF  +  R2 (1)
                    ZMOM  =  SINV (1) * (MOMIP1 - R * MOMI)

                    IF (DABS (ZMOM) .LT. EXTREM) THEN
                        WRITE (*,*) ' 0th Jacobi moment found to be 0! '
                        WRITE (*,*) ' ZMOM = ',ZMOM
                        WRITE (*,*) ' Recalibrate maximum settings! '
                        WRITE (*,*) ' erd__rys_x_roots_weights '
                        STOP
                    END IF

                    A (1) = AJAC (1)
                    ZINV = ONE / ZMOM
                    MOM (1) = MOM (1) * ZINV

                    DO I = 2,NMOM
                       A (I) = AJAC (I)
                       B (I) = BJAC (I)
                       MOM (I) = MOM (I) * ZINV
                    END DO

                END IF

            ELSE
C
C
C             ...The Laguerre section. As for the Jacobi case,
C                we calculate two steps at the same time:
C
C                1) normed Laguerre modified moments defined as
C                   integrals on [0,1] over the Rys weight function:
C
C                                        exp(-Tx)
C                             W   (x) = ---------
C                              Rys      2*sqrt(x)
C
C                   and monic generalized 'scaled' Laguerre polynomials:
C
C                                L (-0.5,Tx)
C                                 i
C
C                   A closed formula can be given for these moments in
C                   terms of monic generalized 'scaled' Laguerre
C                   polynomials with generalization +0.5:
C
C                       MOM (i) = SCALE * L   (+0.5,T)
C                                          i-1
C                   where
C
C                               - exp(-T)
C                       SCALE = ---------   ;  F0(T) = Rys zero moment
C                                2T*F0(T)
C
C                   The recursion relation for the +0.5 polynomials is:
C
C
C                     L   (+0.5,T) = R * L   (+0.5,T) - S * L   (+0.5,T)
C                      i-1                i-2                i-3
C
C                   where
C
C                          R  =  (T - 2i + 5/2) / T
C                          S  =  (i - 2)(i - 3/2) / T*T
C
C
C                   All moments MOM (i);i=1,2,...NMOM using the above
C                   outlined algorithm are evaluated.
C
C
C                2) recurrence coefficients for T-scaled generalized
C                   monic Laguerre polynomials L (-0.5,Tx), denoted
C                   simply by L (Tx):
C
C
C                       L (Tx)    =   1
C                        0
C
C                       L (Tx)    =   (x - A )
C                        1                  1
C
C                       L   (Tx)  =   (x - A   ) * L (Tx) - B   L   (Tx)
C                        i+1                i+1     i        i+1 i-1
C
C
C                   The result consists of the recurrence coefficients:
C
C                             A (I) , I = 1,NMOM
C                             B (I) , I = 2,NMOM
C
C                   whose values are given by the following expressions:
C
C                           A (1) = 1 / 2T
C
C                         A (i+1) = (2i+1/2) / T
C
C                         B (i+1) = i*(i-1/2) / (T*T)
C
C
C
                TEXP = DEXP (-T)
                TINV = ONE / T
                TINV2 = TWO * TINV
                TINVHF = HALF * TINV
                TINVSQ = TINV * TINV

                SCALE  =  - TINVHF * TEXP / MOMZERO

                IF (NMOM.EQ.1) THEN
                    A (1) = TINVHF
                    MOM (1) = SCALE
                ELSE
                    A (1) = TINVHF
                    A (2) = TINVHF + TINV2
                    B (2) = HALF * TINVSQ
                    MOM (1) = SCALE
                    R = ONE - (ONEP5 * TINV)
                    MOM (2) = SCALE * R

                    S = ZERO
                    BINC = HALF
                    SINC = - HALF
                    LIM2 = R
                    LIM3 = ONE

                    DO I = 3,NMOM
                       BINC = BINC + TWO
                       A (I) = A (I-1) + TINV2
                       B (I) = B (I-1) + BINC * TINVSQ
                       SINC = SINC + TWO
                       R = R - TINV2
                       S = S + SINC * TINVSQ
                       LIM1 = R * LIM2 - S * LIM3
                       MOM (I) = SCALE * LIM1
                       LIM3 = LIM2
                       LIM2 = LIM1
                    END DO

                END IF

            END IF
C
C
C             ...This section calculates a symmetric terminal matrix
C                using the normed modified moments MOM and related
C                recurrence coefficients A and B of monic polynomials
C                established in the previous section. The algorithm is
C                a transcription of the LQMD algorithm described by Sack
C                and Donovan in Numer. Mathematik 18, 465-478 (1972).
C
C                The needed data is as follows (NMOM = 2*NGQP-1):
C
C                   1) Normed modified moments: MOM (I),I=1,NMOM
C
C                   2) Recurrence coefficients of the corresponding
C                      monic polynomials: A (I),I=1,NMOM and B (I),
C                      I=2,NMOM. The recurrence relation for the monic
C                      polynomials is defined as:
C
C                         P (x)  =  1
C                          0
C
C                         P (x)  =  (x - A )
C                          1              1
C
C                         P   (x)  =  (x - A   ) * P (x) - B   P   (x)
C                          i+1              i+1     i       i+1 i-1
C
C                The result will consist in the diagonal and offdiagonal
C                parts of the symmetric terminal matrix:
C
C                            DIA (I) , I = 1,NGQP
C                            OFF (I) , I = 1,NGQP-1
C
C                Proceed now with Sack and Donovan's algorithm.
C                Handle low number (1 or 2) of quadrature points first.
C
C
C
            IF (NGQP.EQ.1) THEN
                DIA (1) = MOM (1) + A (1)
            ELSE IF (NGQP.EQ.2) THEN
                SIGMA = MOM (1) + A (1)
                DIA (1) = SIGMA
                THETA = (A (2) - SIGMA) * MOM (1) + MOM (2) + B (2)
                OFF (1) = DSQRT (THETA)
                DIA (2) = (((A(3)-SIGMA)*MOM(2)+MOM(3)+B(3)*MOM(1))
     +                    /THETA) - MOM(1)+A(2)
            ELSE
C
C
C             ...Handle case for number of quadrature points > 2.
C                Set maximum values for I and J and evaluate first
C                diagonal element.
C
C
                IMAX = NGQP - 1
                JMAX = NGQP + IMAX
                DO J = 1,JMAX
                   ROW1 (J) = MOM (J)
                END DO
                SIGMA = ROW1 (1) + A (1)
                DIA (1) = SIGMA
C
C
C             ...evaluate 2nd row of terminal matrix.
C
C
                ROW2 (1) = (A (2) - SIGMA) * ROW1 (1) + ROW1 (2) + B (2)
                THETA = ROW2 (1)
                OFF (1) = DSQRT (THETA)
                JMAX = JMAX - 1
                DO J = 2,JMAX
                   JP1 = J + 1
                   ROW2 (J) = (A (JP1) - SIGMA) * ROW1 (J) + ROW1 (JP1)
     +                        + B (JP1) * ROW1 (J-1)
                END DO
                SIGMA = (ROW2 (2) / THETA) - ROW1 (1) + A (2)
                DIA (2) = SIGMA
C
C
C             ...proceed with higher rows.
C
C
                DO 200 I = 2,IMAX
                   IP1 = I + 1
                   JMAX = JMAX - 1

                   IF ( MOD (I,2) .EQ. 0 ) THEN
                        DO J = I,JMAX
                           JP1 = J + 1
                           ROW1 (J) = (A (JP1) - SIGMA) * ROW2 (J)
     +                              + ROW2 (JP1) + B (JP1) * ROW2 (J-1)
     +                              - THETA * ROW1 (J)
                        END DO
                        SIGMA = A (IP1) - (ROW2 (I) / ROW2 (I-1))
     +                                  + (ROW1 (IP1) / ROW1 (I))
                        THETA = ROW1 (I) / ROW2 (I-1)
                   ELSE
                        DO J = I,JMAX
                           JP1 = J + 1
                           ROW2 (J) = (A (JP1) - SIGMA) * ROW1 (J)
     +                              + ROW1 (JP1) + B (JP1) * ROW1 (J-1)
     +                              - THETA * ROW2 (J)
                        END DO
                        SIGMA = A (IP1) - (ROW1 (I) / ROW1 (I-1))
     +                                  + (ROW2 (IP1) / ROW2 (I))
                        THETA = ROW2 (I) / ROW1 (I-1)
                   END IF

                   DIA (IP1) = SIGMA
                   OFF (I) = DSQRT (THETA)

  200           CONTINUE
            END IF
C
C
C             ...The last section computes the gaussian quadrature roots
C                and weights from a previously established symmetric
C                terminal matrix by the Golub-Welsch algorithm (see
C                G.H. Golub and J.H. Welsch, Math. of Computation 23,
C                p. 221-230 and A1-A10, 1969), which is based on
C                a result of Wilf (see H.S. Wilf, Mathematics for the
C                Physical Sciences, New York: Wiley, Problem 9, p. 80).
C
C                Wilf has shown that if Z (K,I) is the K-th element of
C                the I-th normalized eigenvector of the terminal matrix
C                corresponding to the I-th eigenvalue D (I), then the
C                roots RTS (i.e. the zeros of the N-th orthogonal
C                monic polynomial) and weights WTS to be used for the
C                gaussian quadrature are given by:
C
C                           RTS (I) = D (I)
C                           WTS (I) = MOMZERO * (Z (1,I)**2)
C
C                where MOMZERO is the value of the definite integral
C                over the weight function W (x) alone. In our case
C                it is equal to the value of the zeroth Rys moment.
C
C                The present section performs hence a diagonalization
C                of the tridiagonal symmetric terminal matrix keeping
C                only the first component of the eigenvectors and sets
C                the roots and weights equal to the above relations.
C                The diagonalization code was derived from the routine
C                IMTQL2 in the EISPACK collection and uses the implicit
C                QL method.
C
C                Note, that the original diagonals DIA and offdiagonals
C                OFF of the terminal matrix are destroyed during the
C                diagonalization process !!!
C
C                Handle special case, if order of terminal matrix is 1.
C
C
C
            IF (NGQP.EQ.1) THEN
                NRTS = NRTS + 1
                RTS (NRTS) = DIA (1)
                WTS (NRTS) = MOMZERO
            ELSE
C
C
C             ...initialize vector for collecting first component
C                of eigenvectors. To save space, array A is used,
C                which can be done safely, since its dimension NMOM
C                (# of moments) is always >= # of roots NGQP.
C
C
                A (1) = ONE
                DO J = 2,NGQP
                   A (J) = ZERO
                END DO
C
C
C             ...QL iterations.
C
C
                OFF (NGQP) = ZERO

                DO 300 J = 1,NGQP

                   ITER = 0

 3000              DO M = J,NGQP
                      IF (M.EQ.NGQP) GOTO 3300
                      TEST1 = DABS (DIA (M))  +  DABS (DIA (M+1))
                      TEST2 = TEST1 + DABS (OFF (M))
                      IF (TEST2 .EQ. TEST1) GOTO 3300
                   END DO

 3300              P = DIA (J)
                   IF (M.EQ.J) GOTO 300
                   IF (ITER.EQ.MXITER) THEN
                       WRITE (*,*) ' Root number ',J,' not converged! '
                       WRITE (*,*) ' Program bug? More iterations? '
                       WRITE (*,*) ' erd__rys_x_roots_weights '
                       STOP
                   END IF
                   ITER = ITER + 1

                   G = (DIA (J+1) - P) / (TWO * OFF (J))
                   R = DSQRT (G*G + ONE)
                   G = DIA (M) - P + OFF (J) / (G + DSIGN (R,G))
                   S = ONE
                   C = ONE
                   P = ZERO

                   DO I = M-1,J,-1
                      F = S * OFF (I)
                      D = C * OFF (I)
                      R = DSQRT (F*F + G*G)
                      OFF (I+1) = R
                      IF (R .EQ. ZERO) THEN
                          DIA (I+1) = DIA (I+1) - P
                          OFF (M) = ZERO
                          GOTO 3000
                      END IF
                      S = F / R
                      C = G / R
                      G = DIA (I+1) - P
                      R = (DIA (I) - G) * S + TWO * C * D
                      P = S * R
                      DIA (I+1) = G + P
                      G = C * R - D
                      F = A (I+1)
                      A (I+1) = S * A (I) + C * F
                      A (I) = C * A (I) - S * F
                   END DO

                   DIA (J) = DIA (J) - P
                   OFF (J) = G
                   OFF (M) = ZERO
                   GOTO 3000

  300           CONTINUE
C
C
C             ...calculate roots and weights. Since it is known that
C                the roots must lay between 0 and 1, a check is
C                made on them to see if they are actually within this
C                range.
C
C
                DO I = 1,NGQP
                   ROOT = DIA (I)
                   IF (ROOT.LT.ZERO .OR. ROOT.GT.ONE) THEN
                       WRITE (*,*) ' Quadrature root not in range 0-1! '
                       WRITE (*,*) ' I,I-th Root = ',I,ROOT
                       WRITE (*,*) ' erd__rys_x_roots_weights '
                   STOP
                   END IF
                   RTS (NRTS+I) = ROOT
                   WTS (NRTS+I) = MOMZERO * (A (I)**2)
                END DO

                NRTS = NRTS + NGQP

            END IF
C
C
C             ...next T-value
C
C
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine symm_force_a(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c The diagonal elements of a four index array are extracted. 
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      if (nindex .eq. 4) then
         call dosymmforce(x, bval(1),eval(1),type(1),
     *                   bval(2),eval(2),type(2),
     *                   bval(3),eval(3),type(3),
     *                   bval(4),eval(4),type(4), 
     *                   epsilon,epsilonb)
      else
         print *,'Error in symm_force_a: Result array ',
     *      'must have 4 indices.'
         print *,'array has ',nindex,' indices.'
         call abort_job()
      endif
      
      return
      end

      subroutine dosymmforce(x, a1,a2,atype,
     *                      i1,i2,itype,b1,b2,btype,
     *                      j1,j2, jtype, epsilon, epsilonb)
      implicit none
      include 'interpreter.h'

      integer a1,a2,b1,b2,i1,i2,j1,j2
      integer atype, itype, btype, jtype
      double precision x(a1:a2,i1:i2,b1:b2,j1:j2)

      double precision epsilon(*), epsilonb(*)

      integer a,b,i,j
      double precision val
c
      if (i1 .eq. 1 .and. i2 .eq. 1) then 
         do a = a1,a2
         do b = b1,b2
            do i = i1,i2
            do j = j1,j2
               if (a .lt. b)then
                  val = x(a,i,b,j)
                  x(b,i,a,j)= val*(-1.0d0)
               endif
               if (a .eq. b)then
                  val = 0.0 
                  x(b,i,a,j)= val*(-1.0d0)
               endif
            enddo
            enddo
         enddo
         enddo
         return 
      endif 
c
      do b = b1,b2
      do a = a1,a2
         do j = j1,j2
         do i = i1,i2
            if (a .lt. b)then
               val = x(a,i,b,j)
               x(b,i,a,j)= val*(-1.0d0)
            endif
         enddo
         enddo
      enddo
      enddo
c
      val = 0.0d0 
      do b = b1,b2
      do a = a1,a2
         do j = j1,j2
         do i = i1,i2
         if(i .eq. j .or. a .eq. b)then
               x(a,i,b,j)= val
         endif
         enddo
         enddo
      enddo
      enddo
c
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE BULT_ANGCRD(CARTCOORD, BMATRX, ANGL, ICON1, ICON2, 
     &                       ICON3, IANGS, TOTREDNCO, NRATMS)
C         
C Setup the bond angle bending B-matrix elements. 
C Given r_i = r_ba and r_j = r_bc then CosG_ij = Sum (x_a-x_b)*(x_c-x_b)/R_i*R_j
C                                          x,y,z
C B(*,a,*,*)(x,y,z) = {CosG_ij*(x_a-x_b)/R_ba -(x_a-x_c)/R_ac}R_ba*SinG_ij
C B(*,*,*,c)(x,y,z) = {CosG_ij*(x_c-x_b)/R_bc -(x_a-x_b)/R_ab}R_bc*SinG_ij
C B(*,*,b,*)(x,y,z) = B(*,a,*,*) - B(*,*,*,c)
C
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      DOUBLE PRECISION COSGAMA ,DISTBA ,DISTBC ,DISTAC, ANGL,
     &                 LEN_N2AC
      INTEGER TOTREDNCO
C
      DIMENSION CARTCOORD(3*NRATMS), BMATRX(TOTREDNCO,3*NRATMS),
     &          VECBA(3), VECBC(3), VECBAD(3), VECN2AC(3),
     &          VECBN2A(3), VECBN2B(3)
C
      DATA ONE /1.0D0/
C
      COSGAMA = 0.0D00
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0  
C
      DISTBA = DIST(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON2 - 2))
      DISTBC = DIST(CARTCOORD(3*ICON3 - 2), CARTCOORD(3*ICON2 - 2))
      DISTAC = DIST(CARTCOORD(3*ICON1 - 2), CARTCOORD(3*ICON3 - 2))
C
      CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON3 - 2), 
     &         VECBC, 1)
C 
      CALL VEC(CARTCOORD(3*ICON2 - 2), CARTCOORD(3*ICON1 - 2), 
     &         VECBA, 1)
C
      ANGL    = ANGLE(VECBC, VECBA, 3)*DINVPI
      SINGAMA = DSIN(ANGL)
      COSGAMA = DCOS(ANGL)
C
      IF (ANGL/DINVPI .LT. 175.0D0) THEN
C
         DO 20 IXYZ = 1, 3 
            BMATRX(IANGS, (3*ICON1 - 3) + IXYZ) = 
     &                    (COSGAMA*VECBA(IXYZ) - VECBC(IXYZ))
     &                                /(SINGAMA*DISTBA)
            BMATRX(IANGS, (3*ICON3 - 3) + IXYZ) = 
     &                   (COSGAMA*VECBC(IXYZ) - VECBA(IXYZ))
     &                                /(SINGAMA*DISTBC)
            BMATRX(IANGS, (3*ICON2 - 3) + IXYZ) = 
     &                - (BMATRX(IANGS, (3*ICON1 - 3) + IXYZ))
     &                - BMATRX(IANGS, (3*ICON3 - 3) + IXYZ)

 20      CONTINUE
C
      ELSE
#ifdef _DEBUG_LVL0 
          Write(6,*)
          Write(6, "(a)") "Entering the regular linear angle block"
#endif
C
          CALL NORMAL(VECBC, 3)
          CALL NORMAL(VECBA, 3)
          CALL CROSS(VECBC, VECBA, VECN2AC, 0)
C
          LEN_N2AC = DSQRT(DABS(XDOT(3, VECN2AC, 1, VECN2AC, 1)))
          IF (LEN_N2AC .LE. 1.0D-8) THEN
             VECN2AC(1) =  VECBC(2) + VECBC(3)
             VECN2AC(2) =  VECBC(1) - VECBC(3)
             VECN2AC(3) = -VECBC(1) - VECBC(2)
          ENDIF
C
#ifdef _DEBUG_LVL0
          Write(6, *)
          Write(6, *) "The unit vectors"
          Write(6, "(a, 3F10.4)") "VECN2AC", (VECN2AC(I), I=1,3)
#endif
C
          LEN_N2AC = DSQRT(DABS(XDOT(3, VECN2AC, 1, VECN2AC, 1)))
          IF (LEN_N2AC .LE. 1.0D-8) THEN
             VECN2AC(1) =  VECBC(2) - VECBC(3)
             VECN2AC(2) =  VECBC(1) + VECBC(3)
             VECN2AC(3) =  VECBC(1) + VECBC(2)
          ENDIF
C
#ifdef _DEBUG_LVL0
          Write(6, *)
          Write(6, *) "The unit vectors"
          Write(6, "(a, 3F10.4)") "VECN2AC", (VECN2AC(I), I=1,3)
#endif
C
          CALL NORMAL(VECN2AC, 3)
          CALL CROSS(VECBC, VECN2AC, VECBN2A, 1)
          CALL CROSS(VECN2AC, VECBA, VECBN2B, 1)
C
#ifdef _DEBUG_LVL0
          Write(6, *) 
          Write(6, *) "The basis vctors for regular angles"
          Write(6, "(a, 3F10.4)") "VECBN2A", (VECBN2A(I), I=1,3)
          Write(6, "(a, 3F10.4)") "VECBN2B", (VECBN2B(I), I=1,3)
          Write(6,*)
#endif
C
          DO IXYZ = 1, 3
             BMATRX(IANGS, (3*ICON3 - 3) + IXYZ) = 
     &                                   VECBN2A(IXYZ)/DISTBC
             BMATRX(IANGS, (3*ICON2 - 3) + IXYZ) = 
     &                                  - VECBN2A(IXYZ)/DISTBC 
     &                                  - VECBN2B(IXYZ)/DISTBA
             BMATRX(IANGS, (3*ICON1 - 3) + IXYZ) = 
     &                                  VECBN2B(IXYZ)/DISTBA
          ENDDO
      ENDIF 
C
      RETURN
      END
      

      SUBROUTINE SPINAD3(IRREP,NUM1,DIS,NUM,A,SCR,ISCR)
C
C THIS ROUTINE SPIN ADAPTS A MATRIX A BY
C
C  A(J,I,K,L) ----> 2*A(J,I,K,L)-A(I,J,K,L) 
C
C NOTE THAT THE SPIN ADAPTION IS CARRIED OUT HERE IN PLACE AND
C ONLY TWO ADDITIONAL ARRAYS OF SIZE NUM ARE REQUIRED
C
C INPUT : IRREP .......... IRREP OF THE GIVEN PAR OF A
C         NUM1 ........... POPULATION VECTOR OF I AND J
C         DIS ............ DISTRIBUTION SIZE OF A
C         NUM ............ NUMBER OF DISTRIBUTIONS IN A
C         A .............. INPUT MATRIX A
C         SCR,ISCR ....... TWO SCRATCH ARRAYS OF DIMENSION NUM
C
C  OUTPUT : A ............ SPIN ADAPTED MATRIX A
C 
CEND
C
C CODED SEPTEMBER/90  JG
C
C The SCR array is no longer needed, but the reference is kept for
C   compatibility.
C SG 6/95
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DIS,DIRPRD
      DIMENSION A(DIS,NUM),SCR(1),ISCR(2),NUM1(8),IP(8)
      COMMON /SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &DIRPRD(8,8)
C
      DATA TWO /2.0D+00/
C
      IP(1)=0
      DO 10 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       IP(IRREPJ+1)=IP(IRREPJ)+NUM1(IRREPJ)*NUM1(IRREPI)
10    CONTINUE
       
C
C  GET FIRST THE NEW ADDRESSES AND STORE THEM IN ISCR
C
C  The addresses will be stored in ISCR in the order IJ(1), IJTR(1),
C    IJ(2), IJTR(2), ...  So, for each IJ, its transpose will be the next
C    location in ISCR.  Each memory location will appear once at most.
C
      INDX = 0
      DO 20  IRREPJ=1,NIRREP
        NUMJ=NUM1(IRREPJ)
        IRREPI=DIRPRD(IRREP,IRREPJ)
        NUMI=NUM1(IRREPI)
        DO 16 J=1,NUMJ
          DO 15 I=1,NUMI
            IND1=IP(IRREPJ)+(J-1)*NUMI+I
            IND2=IP(IRREPI)+(I-1)*NUMJ+J
            IF (IND1 .LT. IND2) THEN
              ISCR(INDX+1) = IND1
              ISCR(INDX+2) = IND2
              INDX = INDX + 2
            ENDIF
 15       CONTINUE
 16     CONTINUE
 20   CONTINUE
C
C  NOW SPIN ADAPT A
C  SPIN ADAPT A(IJ,L) and A(IJTR,L)
C
      DO 100 L = 1,NUM
CDIR$ IVDEP
*VOCL LOOP,NOVREC
        DO 5 M = 1,INDX,2
          IJ = ISCR(M)
          IJTR = ISCR(M+1)
          TEMP = A(IJ,L)
          A(IJ,L) = TWO*A(IJ,L) - A(IJTR,L)
          A(IJTR,L) = TWO*A(IJTR,L) - TEMP
 5      CONTINUE
C
C ALL DONE FOR IJ AND IJTR
C
 100  CONTINUE 
C
      RETURN
      END

      SUBROUTINE TRADIP(SDIPDR,CDIPDR,TRSTOC,NCOOR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION SDIPDR(3,1),CDIPDR(3,1),TRSTOC(1)
      PARAMETER (AZERO=0.0D0)
      PARAMETER (ONE  =1.0D0)
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/PERT/NTPERT,NPERT(8),IPERT(8),IXYZ(3)       
      CALL GETREC(20,'JOBARC','SYMCOORD',IINTFP*NCOOR*NCOOR,TRSTOC)
      CALL XGEMM('N','T',3,NCOOR,NCOOR,
     &           ONE,  SDIPDR,3,
     &                 TRSTOC,NCOOR,
     &           AZERO,CDIPDR,3)
      RETURN
      END

c This routine initializes the parallel_aces common block.

      subroutine aces_com_parallel_aces
      implicit none

#include "mpif.h"

c INTERNAL VARIABLES
      integer iErr
      logical bMPIUp

c COMMON BLOCKS
#include "parallel_aces.com"

c ----------------------------------------------------------------------

#ifdef _HAVE_MPI
c   o return if MPI is not initialized
      call MPW_Initialized(bMPIUp,iErr)
      if (iErr.ne.0) then
         print *, '@ACES_COM_PARALLEL_ACES: ',
     &            'unable to determine MPI initialization status'
         call aces_exit(1)
      end if
      if (.not.bMPIUp) return

c   o update the number of MPI processes
      call MPW_Comm_size(MPI_COMM_WORLD,nprocs,iErr)
      if (iErr.ne.0) then
         print *, '@ACES_COM_PARALLEL_ACES: ',
     &            'unable to determine MPI comm size'
         call aces_exit(1)
      end if

c   o update the process rank
      call MPW_Comm_rank(MPI_COMM_WORLD,irank,iErr)
      if (iErr.ne.0) then
         print *, '@ACES_COM_PARALLEL_ACES: ',
     &            'unable to determine MPI comm rank'
         call aces_exit(1)
      end if

c   o bomb if the hard-coded limit has been exceeded
      if (nprocs.gt._PA_MAX_PROCS) then
         if (irank.eq.0) then
         print *, '@ACES_COM_PARALLEL_ACES: The maximum number of ',
     &            'processes allowed by the'
         print *, '                         ACES subsystem has been ',
     &            'exceeded. Either reduce'
         print *, '                         the requested number to at',
     &            ' most ',_PA_MAX_PROCS
         print *, '                         or recompile the source ',
     &            'with a higher limit.'
         end if
c      o make sure the root has a chance to print the error
         call MPW_Barrier(MPI_COMM_WORLD,iErr)
         call aces_exit(1)
      end if

c   o update the machine name (essentially `uname -n`)
      call MPW_Get_processor_name(szcpuname,icpuname,iErr)
      if (iErr.ne.0) then
         print *, '@ACES_COM_PARALLEL_ACES: ',
     &            'unable to determine MPI processor name'
         call aces_exit(1)
      end if
#endif /* _HAVE_MPI */

#ifdef _DEBUG
      if (nprocs.ne.1) then
         print *, '@ACES_COM_PARALLEL_ACES: ',
     &            'irank = ',irank,'; nprocs = ',nprocs,
     &            '; processor name = "',szcpuname(1:icpuname),'"'
      end if
#endif

      return
c     end subroutine aces_com_parallel_aces
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine prt_time(msg)
c-----------------------------------------------------------------------
c   Prints the current time and date, with a text message.
c-----------------------------------------------------------------------

      implicit none
      include 'mpif.h'
      include 'dbugcom.h'

      character*(*) msg
      integer me, ierr
      character*8 dt
      character*10 tm

#ifdef HP
      character*24 ctime
      integer system_time
      integer time
      external time
      external ctime
#endif

      if (.not. dbg) return
      call mpi_comm_rank(mpi_comm_world, me, ierr)

#ifdef HP
      system_time = time()
      print *,'Task ',me,' ',ctime(system_time),' ',msg 
#else
      call date_and_time(dt, tm)

      print *,'TASK ',me,tm(1:2),':',tm(3:4),':',tm(5:6),' ',
     *     msg
#endif
      call c_flush_stdout()
      return
      end

      SUBROUTINE F2TAU(T2,T1A,T1B,DISSYT,NUMSYT,POP1,POP2,
     &               VRT1,VRT2,IRREP,FACT,ITYPE)
C
C THIS SUBROUTINE FORMS THE SYMMETRY PACKED TAU(AB,IJ) 
C AMPLITUDES FOR CCSD GIVEN THE SYMMETRY PACKED T2(AB,IJ)
C AND T1(A,I) AMPLITUDES. TAU(AB,IJ) IS DEFINED AS
C
C  TAU(AB,IJ) = T2(AB,IJ) + T1(A,I)*T1(B,J)*FACT
C
C NOTE THAT SYMMETRY PACKING IS USED AND THAT THE
C SYMMETRY INFORMATION IS ALSO USED IN ORDER TO
C DECIDE IF THERE ARE ANY SINGLE CONTRIBUTION OR NOT.
C FOR THE ABAB SPIN CASE, THERE ARE ONLY CONTRIBUTIONS
C WHEN THE IRREP OF A IS EQUAL TO THE IRREP OF I (AND
C IRREPB EQUAL TO IRREPJ, WHICH IS FORCED BY THE REQUIREMENT
C THAT THE T2 AMPLITUDES ARE TOTAL SYMMETRIC) IN THE AAAA
C AND BBBB SPIN CASES, THERE ARE CONTRIBUTIONS IF EITHERE
C IRREPA EQUALS IRREPI (FIRST TERM) OR IRREPA EQUALS IRREPJ 
C (SECOND TERM)
C
C INPUT :
C       T2 ............... T2 LIST
C       T1A .............. FIRST T1 LIST
C       T1B .............. SECOND T1 LIST
C       DISSYT, NUMSYT ... DIMENSIONING OF T2
C       POP1,VRT1 ........ POPULATION VECTORS FOR T1A
C       POP2, VRT2 ....... POPULATION VECTOR FOR T1B
C       IRREP ............ IRREP OF T2 LIST
C       FACT ............. MULTIPLICATION FACTOR FOR T1**2 CONTRIBUTION
C
C OUTPUT :
C       T2 ............... TAU ARRAY
CEND 
C
C CODED JULY/90 JG
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL LINCC,CICALC
      CHARACTER*4 ITYPE
      INTEGER POP1,POP2,VRT1,VRT2,DIRPRD,DISSYT
      DIMENSION T2(DISSYT,NUMSYT),T1A(1),T1B(1)
      DIMENSION POP1(8),POP2(8),VRT1(8),VRT2(8)
      DIMENSION IOFFTOV(8),IOFFT1A(8),
     &          IOFFT1B(8)
C
      COMMON /SYMINF/ NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &                DIRPRD(8,8)
      COMMON /LINEAR/ LINCC,CICALC
C
      IF(LINCC)RETURN
C
      IF(ITYPE.EQ.'AAAA'.OR.ITYPE.EQ.'BBBB') THEN
C
C  GET FIRST OFFSETS OF T1 AND T2
C
       IOFFTOV(1)=0
       IOFFT1A(1)=0
       DO 101 IRREPI=1,NIRREP-1
        IRREPJ=DIRPRD(IRREPI,IRREP)
        IOFFTOV(IRREPI+1)=IOFFTOV(IRREPI)+POP1(IRREPI)*VRT1(IRREPJ)
        IOFFT1A(IRREPI+1)=IOFFT1A(IRREPI)+POP1(IRREPI)*VRT1(IRREPI)
101    CONTINUE
C
       INDBI=0
       DO 200 IRREPI=1,NIRREP

        NUMI=POP1(IRREPI)
        NUMA=VRT1(IRREPI)
C
        IRREPJ=DIRPRD(IRREP,IRREPI)
        NUMB=VRT1(IRREPJ)
        NUMJ=POP1(IRREPJ)
C
        IOFFT1=IOFFT1A(IRREPI)
        IOFFT2=IOFFT1A(IRREPJ)
        DO 210 I=1,NUMI
        DO 210 IB=1,NUMB
         INDBI=INDBI+1
         INDAJ=IOFFTOV(IRREPJ)
         DO 220 J=1,NUMJ
         INDBJ=IOFFT2+IB+(J-1)*NUMB 
         DO 220 IA=1,NUMA
          INDAI=IOFFT1+IA+(I-1)*NUMA
          INDAJ=INDAJ+1
          T2(INDAJ,INDBI)=T2(INDAJ,INDBI)+FACT*T1A(INDAI)*T1A(INDBJ)
220      CONTINUE
210     CONTINUE
200    CONTINUE
      ELSE IF(ITYPE.EQ.'AABB'.OR.ITYPE.EQ.'BBAA') THEN
C
       IF(IRREP.NE.1) RETURN
C
C  GET FIRST OFFSETS OF T1 AND T2
C
       IOFFTOV(1)=0
       IOFFT1A(1)=0
       IOFFT1B(1)=0
       DO 1101 IRREPJ=1,NIRREP-1
        IRREPI=DIRPRD(IRREPJ,IRREP)
        IOFFTOV(IRREPJ+1)=IOFFTOV(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPI)
        IOFFT1A(IRREPJ+1)=IOFFT1A(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPJ)
        IOFFT1B(IRREPJ+1)=IOFFT1B(IRREPJ)+POP2(IRREPJ)*VRT2(IRREPJ)
1101    CONTINUE
C
       INDBJ=0
       DO 1200 IRREPJ=1,NIRREP

        NUMJ=POP2(IRREPJ)
        NUMB=VRT2(IRREPJ)
C
        IOFFT2=IOFFT1B(IRREPJ)
C
        DO 1210 J=1,NUMJ
        DO 1210 IB=1,NUMB
         INDBJ=INDBJ+1
         IND1BJ=IOFFT2+IB+(J-1)*NUMB
         INDAI=0
         DO 1215 IRREPI=1,NIRREP 
         NUMA=VRT1(IRREPI)
         NUMI=POP1(IRREPI)
         IOFFT1=IOFFT1A(IRREPI)
         DO 1220 I=1,NUMI
         DO 1220 IA=1,NUMA
          IND1AI=IOFFT1+IA+(I-1)*NUMA
          INDAI=INDAI+1
          T2(INDAI,INDBJ)=T2(INDAI,INDBJ)+FACT*T1A(IND1AI)*T1B(IND1BJ)
1220      CONTINUE
1215     CONTINUE
1210     CONTINUE
1200    CONTINUE
       ELSE IF(ITYPE.EQ.'ABAB'.OR.ITYPE.EQ.'BABA') THEN
C
C  GET FIRST OFFSETS OF T1 AND T2
C
       IOFFTOV(1)=0
       IOFFT1A(1)=0
       IOFFT1B(1)=0
       DO 2101 IRREPJ=1,NIRREP-1
        IRREPI=DIRPRD(IRREPJ,IRREP)
        IOFFTOV(IRREPJ+1)=IOFFTOV(IRREPJ)+POP2(IRREPJ)*VRT1(IRREPI)
        IOFFT1A(IRREPJ+1)=IOFFT1A(IRREPJ)+POP1(IRREPJ)*VRT1(IRREPJ)
        IOFFT1B(IRREPJ+1)=IOFFT1B(IRREPJ)+POP2(IRREPJ)*VRT2(IRREPJ)
2101    CONTINUE
C
       INDBI=0
       DO 2200 IRREPI=1,NIRREP

        NUMI=POP1(IRREPI)
        NUMA=VRT1(IRREPI)
C
        IOFFT1=IOFFT1A(IRREPI)
        IRREPJ=DIRPRD(IRREP,IRREPI)
        IOFFT2=IOFFT1B(IRREPJ)
        NUMJ=POP2(IRREPJ)
        NUMB=VRT2(IRREPJ)
C
        DO 2210 I=1,NUMI
        DO 2210 IB=1,NUMB
         INDBI=INDBI+1
         INDAJ=IOFFTOV(IRREPJ)
         DO 2220 J=1,NUMJ
         INDBJ=IOFFT2+IB+(J-1)*NUMB
         DO 2220 IA=1,NUMA
          INDAI=IOFFT1+IA+(I-1)*NUMA
          INDAJ=INDAJ+1
          T2(INDAJ,INDBI)=T2(INDAJ,INDBI)+FACT*T1A(INDAI)*T1B(INDBJ)
2220      CONTINUE
2210     CONTINUE
2200    CONTINUE
       ENDIF
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__DERV_INT2D_TO_ABCD
     +
     +                    ( SHELLA,SHELLB,SHELLC,SHELLD,
     +                      NGQP,NEXQ,NGQEXQ,
     +                      NXYZA,NXYZB,NXYZC,NXYZD,
     +                      INT2DX,INT2DY,INT2DZ,
     +                      DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__DERV_INT2D_TO_ABCD
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                derivative eris [AB|CD], adding up the contributions
C                from all the derivative 2D ABCD integrals.
C
C                The routine uses the reduced Rys multiplication scheme
C                as suggested in R.Lindh, U.Ryu and B.Liu, JCP 95, 5889.
C                This scheme reuses intermediate products between
C                2DX and 2DY integrals.
C
C                Due to the very computational intensive steps inside
C                the x,y,z loops, special sections of identical x,y,z
C                loop structures have been given for each # of roots
C                =< 9, thus saving considerable computing time over the
C                general case.
C
C                For comments on how the x,y,z loop structures are
C                coded please refer to the general root case.
C
C
C                  Input:
C
C                    SHELLx      =  shell types for individual csh
C                                   x = A,B,C,D
C                    NGQP        =  # of gaussian quadrature points
C                                   (roots)
C                    NEXQ        =  current # of exponent quadruplets
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    NXYZx       =  # of cartesian monomials for
C                                   x = A,B,C,D shells
C                    INT2Dx      =  all current 2D ABCD derivative
C                                   integrals for each cartesian
C                                   component (x = X,Y,Z)
C                    DIFFx       =  is true, if differentiation was
C                                   performed along the x=Y,Z direction
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   2D ABCD derivative integral products
C                    SCALE       =  the NGQEXQ scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian
C                                   [AB|CD] derivative integrals
C                                   corresponding to all current
C                                   exponent quadruplets
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFY,DIFFZ

         INTEGER     I,J,K,L,M,N,R
         INTEGER     NGQP,NEXQ,NGQEXQ
         INTEGER     NXYZA,NXYZB,NXYZC,NXYZD
         INTEGER     SHELLA,SHELLB,SHELLC,SHELLD
         INTEGER     XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD
         INTEGER     XAP,XBP,XCP,XDP
         INTEGER     YAMAX,YBMAX,YCMAX,YDMAX

         DOUBLE PRECISION  SUM
         DOUBLE PRECISION  ZERO

         DOUBLE PRECISION  SCALE (1:NGQEXQ)
         DOUBLE PRECISION  TEMP1 (1:NGQEXQ)
         DOUBLE PRECISION  TEMP2 (1:NGQEXQ)

         DOUBLE PRECISION  BATCH  (1:NEXQ,
     +                             1:NXYZA,1:NXYZB,1:NXYZC,1:NXYZD)

         DOUBLE PRECISION  INT2DX (1:NGQEXQ,
     +                             0:SHELLA,0:SHELLB,0:SHELLC,0:SHELLD)
         DOUBLE PRECISION  INT2DY (1:NGQEXQ,
     +                             0:SHELLA,0:SHELLB,0:SHELLC,0:SHELLD)
         DOUBLE PRECISION  INT2DZ (1:NGQEXQ,
     +                             0:SHELLA,0:SHELLB,0:SHELLC,0:SHELLD)

         PARAMETER  (ZERO  =  0.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...jump according to number of roots.
C
C
         GOTO  (1,2,3,4,5,6,7,8,9,10)  MIN (NGQP,10)
C
C
C                       ********************
C                       *  # of roots = 1  *
C                       ********************
C
C
    1    XDP = 0
         DO 100 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 102 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 104  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 106 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 110 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 112 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 114 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 116 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO M = 1,NEXQ
                                TEMP2 (M) = TEMP1 (M)
                             END DO
                         ELSE
                             DO M = 1,NEXQ
                                TEMP2 (M) = TEMP1 (M)
     +                                    * INT2DY (M,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) = TEMP2 (M)
                             END DO
                         ELSE
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                           TEMP2 (M)
     +                                         * INT2DZ (M,ZA,ZB,ZC,ZD)
                             END DO
                         END IF

  116                  CONTINUE
  114                CONTINUE
  112              CONTINUE
  110            CONTINUE
                 XAP = I
  106          CONTINUE
               XBP = J
  104        CONTINUE
             XCP = K
  102      CONTINUE
           XDP = L
  100    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 2  *
C                       ********************
C
C
    2    XDP = 0
         DO 200 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 202 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 204  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 206 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 210 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 212 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 214 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 216 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
                                R = R + 2
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
                                R = R + 2
                             END DO
                         END IF

  216                  CONTINUE
  214                CONTINUE
  212              CONTINUE
  210            CONTINUE
                 XAP = I
  206          CONTINUE
               XBP = J
  204        CONTINUE
             XCP = K
  202      CONTINUE
           XDP = L
  200    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 3  *
C                       ********************
C
C
    3    XDP = 0
         DO 300 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 302 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 304  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 306 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 310 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 312 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 314 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 316 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
                                R = R + 3
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
                                R = R + 3
                             END DO
                         END IF

  316                  CONTINUE
  314                CONTINUE
  312              CONTINUE
  310            CONTINUE
                 XAP = I
  306          CONTINUE
               XBP = J
  304        CONTINUE
             XCP = K
  302      CONTINUE
           XDP = L
  300    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 4  *
C                       ********************
C
C
    4    XDP = 0
         DO 400 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 402 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 404  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 406 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 410 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 412 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 414 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 416 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
     +                                              + TEMP2 (R+3)
                                R = R + 4
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+3)
     +                                       * INT2DZ (R+3,ZA,ZB,ZC,ZD)
                                R = R + 4
                             END DO
                         END IF

  416                  CONTINUE
  414                CONTINUE
  412              CONTINUE
  410            CONTINUE
                 XAP = I
  406          CONTINUE
               XBP = J
  404        CONTINUE
             XCP = K
  402      CONTINUE
           XDP = L
  400    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 5  *
C                       ********************
C
C
    5    XDP = 0
         DO 500 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 502 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 504  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 506 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 510 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 512 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 514 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 516 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
     +                                              + TEMP2 (R+3)
     +                                              + TEMP2 (R+4)
                                R = R + 5
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+3)
     +                                       * INT2DZ (R+3,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+4)
     +                                       * INT2DZ (R+4,ZA,ZB,ZC,ZD)
                                R = R + 5
                             END DO
                         END IF

  516                  CONTINUE
  514                CONTINUE
  512              CONTINUE
  510            CONTINUE
                 XAP = I
  506          CONTINUE
               XBP = J
  504        CONTINUE
             XCP = K
  502      CONTINUE
           XDP = L
  500    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 6  *
C                       ********************
C
C
    6    XDP = 0
         DO 600 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 602 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 604  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 606 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 610 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 612 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 614 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 616 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
     +                                              + TEMP2 (R+3)
     +                                              + TEMP2 (R+4)
     +                                              + TEMP2 (R+5)
                                R = R + 6
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+3)
     +                                       * INT2DZ (R+3,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+4)
     +                                       * INT2DZ (R+4,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+5)
     +                                       * INT2DZ (R+5,ZA,ZB,ZC,ZD)
                                R = R + 6
                             END DO
                         END IF

  616                  CONTINUE
  614                CONTINUE
  612              CONTINUE
  610            CONTINUE
                 XAP = I
  606          CONTINUE
               XBP = J
  604        CONTINUE
             XCP = K
  602      CONTINUE
           XDP = L
  600    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 7  *
C                       ********************
C
C
    7    XDP = 0
         DO 700 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 702 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 704  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 706 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 710 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 712 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 714 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 716 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
     +                                              + TEMP2 (R+3)
     +                                              + TEMP2 (R+4)
     +                                              + TEMP2 (R+5)
     +                                              + TEMP2 (R+6)
                                R = R + 7
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+3)
     +                                       * INT2DZ (R+3,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+4)
     +                                       * INT2DZ (R+4,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+5)
     +                                       * INT2DZ (R+5,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+6)
     +                                       * INT2DZ (R+6,ZA,ZB,ZC,ZD)
                                R = R + 7
                             END DO
                         END IF

  716                  CONTINUE
  714                CONTINUE
  712              CONTINUE
  710            CONTINUE
                 XAP = I
  706          CONTINUE
               XBP = J
  704        CONTINUE
             XCP = K
  702      CONTINUE
           XDP = L
  700    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 8  *
C                       ********************
C
C
    8    XDP = 0
         DO 800 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 802 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 804  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 806 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 810 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 812 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 814 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 816 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
     +                                              + TEMP2 (R+3)
     +                                              + TEMP2 (R+4)
     +                                              + TEMP2 (R+5)
     +                                              + TEMP2 (R+6)
     +                                              + TEMP2 (R+7)
                                R = R + 8
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+3)
     +                                       * INT2DZ (R+3,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+4)
     +                                       * INT2DZ (R+4,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+5)
     +                                       * INT2DZ (R+5,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+6)
     +                                       * INT2DZ (R+6,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+7)
     +                                       * INT2DZ (R+7,ZA,ZB,ZC,ZD)
                                R = R + 8
                             END DO
                         END IF

  816                  CONTINUE
  814                CONTINUE
  812              CONTINUE
  810            CONTINUE
                 XAP = I
  806          CONTINUE
               XBP = J
  804        CONTINUE
             XCP = K
  802      CONTINUE
           XDP = L
  800    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots = 9  *
C                       ********************
C
C
    9    XDP = 0
         DO 900 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 902 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 904  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 906 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO

                 L = XDP
                 DO 910 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 912 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 914 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 916 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF

                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =   TEMP2 (R)
     +                                              + TEMP2 (R+1)
     +                                              + TEMP2 (R+2)
     +                                              + TEMP2 (R+3)
     +                                              + TEMP2 (R+4)
     +                                              + TEMP2 (R+5)
     +                                              + TEMP2 (R+6)
     +                                              + TEMP2 (R+7)
     +                                              + TEMP2 (R+8)
                                R = R + 9
                             END DO
                         ELSE
                             R = 1
                             DO M = 1,NEXQ
                                BATCH (M,I,J,K,L) =
     +                                         TEMP2 (R)
     +                                       * INT2DZ (R,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+1)
     +                                       * INT2DZ (R+1,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+2)
     +                                       * INT2DZ (R+2,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+3)
     +                                       * INT2DZ (R+3,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+4)
     +                                       * INT2DZ (R+4,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+5)
     +                                       * INT2DZ (R+5,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+6)
     +                                       * INT2DZ (R+6,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+7)
     +                                       * INT2DZ (R+7,ZA,ZB,ZC,ZD)
     +                                       + TEMP2 (R+8)
     +                                       * INT2DZ (R+8,ZA,ZB,ZC,ZD)
                                R = R + 9
                             END DO
                         END IF

  916                  CONTINUE
  914                CONTINUE
  912              CONTINUE
  910            CONTINUE
                 XAP = I
  906          CONTINUE
               XBP = J
  904        CONTINUE
             XCP = K
  902      CONTINUE
           XDP = L
  900    CONTINUE

         RETURN
C
C
C                       ********************
C                       *  # of roots > 9  *
C                       ********************
C
C             ...outer loops over x,x,x,x-quadruples. No skipping of
C                x,x,x,x-contribution of 0,0,0,0-type can be done here,
C                since the 2DX integrals carry the Rys weight!
C
C
   10    XDP = 0
         DO 1000 XD = SHELLD,0,-1
           YDMAX = SHELLD - XD
           XCP = 0
           DO 1002 XC = SHELLC,0,-1
             YCMAX = SHELLC - XC
             XBP = 0
             DO 1004  XB = SHELLB,0,-1
               YBMAX = SHELLB - XB
               XAP = 0
               DO 1006 XA = SHELLA,0,-1
                 YAMAX = SHELLA - XA

                 DO M = 1,NGQEXQ
                    TEMP1 (M) = SCALE (M) * INT2DX (M,XA,XB,XC,XD)
                 END DO
C
C
C             ...inner loops over y,y,y,y-quadruples. Skip the
C                multiplication of y,y,y,y-contributions, if no
C                y-coordinate derivative was formed and we have a
C                0,0,0,0-quadruple, as then the 2DY ABCD integrals
C                are equal to 1.
C
C
                 L = XDP
                 DO 1010 YD = YDMAX,0,-1
                   L = L + 1
                   ZD = YDMAX - YD
                   K = XCP
                   DO 1012 YC = YCMAX,0,-1
                     K = K + 1
                     ZC = YCMAX - YC
                     J = XBP
                     DO 1014 YB = YBMAX,0,-1
                       J = J + 1
                       ZB = YBMAX - YB
                       I = XAP
                       DO 1016 YA = YAMAX,0,-1
                         I = I + 1
                         ZA = YAMAX - YA

                         IF (.NOT.DIFFY .AND. YA+YB+YC+YD.EQ.0) THEN
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
                             END DO
                         ELSE
                             DO N = 1,NGQEXQ
                                TEMP2 (N) = TEMP1 (N)
     +                                    * INT2DY (N,YA,YB,YC,YD)
                             END DO
                         END IF
C
C
C             ...skip multiplication of z,z,z,z-contributions, if we
C                have a 0,0,0,0-quadruple and no derivations were
C                performed on the z-coordinate, as then the 2DZ ABCD
C                integrals are equal to 1. All info concerning all
C                three x,x,x,x-, y,y,y,y- and z,z,z,z-quadruples have
C                been collected for all exponent quadruplets at once.
C                Sum up the 2D X,Y,Z integral products to the
C                appropriate places of the [AB|CD] batch.
C
C
                         IF (.NOT.DIFFZ .AND. ZA+ZB+ZC+ZD.EQ.0) THEN
                             R = 0
                             DO M = 1,NEXQ
                                SUM = ZERO
                                DO N = 1,NGQP
                                   SUM = SUM + TEMP2 (R+N)
                                END DO
                                R = R + NGQP
                                BATCH (M,I,J,K,L) = SUM
                             END DO
                         ELSE
                             R = 0
                             DO M = 1,NEXQ
                                SUM = ZERO
                                DO N = 1,NGQP
                                   SUM = SUM + TEMP2 (R+N)
     +                                      * INT2DZ (R+N,ZA,ZB,ZC,ZD)
                                END DO
                                R = R + NGQP
                                BATCH (M,I,J,K,L) = SUM
                             END DO
                         END IF
C
C
C             ...next z,z,z,z-quadruple and y,y,y,y-quadruple.
C
C
 1016                  CONTINUE
 1014                CONTINUE
 1012              CONTINUE
 1010            CONTINUE
C
C
C             ...next x,x,x,x-quadruple.
C
C
                 XAP = I
 1006          CONTINUE
               XBP = J
 1004        CONTINUE
             XCP = K
 1002      CONTINUE
           XDP = L
 1000    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE WRITE_WARN_LOG(WARN_STRING)
 
      IMPLICIT NONE
      CHARACTER*80 WARN_STRING
      INTEGER IUNIT

      PARAMETER(IUNIT=10)

      OPEN(UNIT=IUNIT, FILE='WARN.LOG', FORM='FORMATTED')
     
      IF (WARN_STRING .EQ. 'INVALID SUBGROUP') THEN
          WRITE(IUNIT) 'Warning:'
      ENDIF
   
      CLOSE (IUNIT) 
      RETURN
      END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C THIS SUBROUTINE DETERMINES THE INFORMATION ABOUT THE
C LOCATION OF VARIOUS FILES (DEFAULT IS OF COURSE
C THE WORKING DIRECTORY) IN AN ACES2 RUN. THIS OPTION
C IS PARTICULARLY USEFUL FOR WORKSTATIONS, BUT HAS
C SOME BENEFITS ON SUPER COMPUTERS WITH TMPDIR DISKS.
C
C IF A FILE IS INTENDED NOT TO BE IN THE WORKING
C DIRECTORY, THE FULL PATH NAME CAN BE GIVEN IN THE
C FOLLOWING WAY IN THE ZMAT FILE PRIOR TO THE TITLE
C
C  %MOINTS=/work/username/test1/MOINTS
C
C WHICH MEANS THAT MOINTS IS NOW IN THE DIRECTORY
C /work/username/test1. THERE IS ALSO THE POSSIBILITY
C TO RENAME FILES BUT THAT SHOULD BE USED WITH
C COME CAUTION, IN ORDER NOT TO MESS UP THINGS.
C
C JG GOETEBORG SEPT/92

c Yau : 01/2003
c This routine was altered to create FILES only if the user specifies
c a file mapping. Oh, and it was rewritten for more robust parsing.

c Yau : 02/2003
c A special file directive SAVEDIR was created to allow the user to
c specify a location (absolute or relative to the ACES working directory)
c in which precious files will be stored for [finite displacement] restarts.

#include "flags.h"

      SUBROUTINE DFILES(IGNORE)
      IMPLICIT NONE

#include "io_units.par"
#include "linelen.par"

      LOGICAL IGNORE

      character*1 achar
      logical leq
      external leq

      integer i, j
      integer iErr, iFlags(100), iFlags2(500)
      integer iStart1, iEnd1, iStart2, iEnd2, LINENO
      logical bVerbose, bExist, bNoTitle, bSaveDir, bBackup, bRestore
      integer iJOBARC
      CHARACTER*(linelen) A, szSaveDir, szJOBARC
      character*1 czNull, czSpace, czTab

c ----------------------------------------------------------------------

      czNull  = achar(0)
      czTab   = achar(9)
      czSpace = achar(32)

c   o assume SAVEDIR=SAVEDIR (bSaveDir is the user-override flag)
      szSaveDir = 'SAVEDIR'//czNull
      bSaveDir  = .false.

c   o remove FILES (it may be contaminated on a restart)
c      INQUIRE(FILE='FILES',EXIST=bExist)
       bexist = .false.
      if (bExist) then
         call f_remove('FILES')
         bVerbose = .false.
      else
         bVerbose = .true.
      end if

c   o open ZMAT
c      INQUIRE(FILE=ZFIL,EXIST=bExist)
      bexist = .true.
      IF (bExist) THEN
         OPEN(UNIT=LUZ,FILE=ZFIL,FORM='FORMATTED',STATUS='OLD',ERR=666)
         REWIND(LUZ)
      ELSE
         WRITE(*,*) '@DFILES: ZMAT file does not exist.'
         CALL ERREX
      END IF

c   o scan the header until the job title is found
c     (i.e., first non-white character is not '%' or '#')
      bNoTitle = .true.
      bExist   = .false.
      LINENO   = 0
      do while (bNoTitle)

         read(LUZ,'(a)',end=9999,err=666) a
         LINENO = LINENO + 1

c      o scan for the first character
         i = 1
         do while ((i.lt.linelen).and.
     &             ((a(i:i).eq.czSpace).or.(a(i:i).eq.czTab))
     &            )
            i = i + 1
         end do

c      o branch on the first character
         if (a(i:i).ne.'%') then

            bNoTitle = (a(i:i).eq.czSpace).or.
     &                 (a(i:i).eq.czTab).or.
     &                 (a(i:i).eq.'#')

c        else if ([file directive])
         else

c         o scan for a '#' comment delim
            j = i + 1
            do while ((j.lt.linelen).and.(a(j:j).ne.'#'))
               j = j + 1
            end do
            if (a(j:j).eq.'#') j = j - 1

c         o skip white space
            i = i + 1
            do while ((i.lt.j).and.
     &                ((a(i:i).eq.czSpace).or.(a(i:i).eq.czTab))
     &               )
               i = i + 1
            end do

c         o find white space or '=' delim
            iStart1 = i
            do while ((i.lt.j).and.
     &                ((a(i:i).ne.czSpace).and.(a(i:i).ne.czTab).and.
     &                 (a(i:i).ne.'='))
     &               )
               i = i + 1
            end do
            iEnd1 = i - 1

c         o skip white space and '=' delim
            do while ((i.lt.j).and.
     &                ((a(i:i).eq.czSpace).or.(a(i:i).eq.czTab).or.
     &                 (a(i:i).eq.'='))
     &               )
               i = i + 1
            end do

c         o find white space up to j
            iStart2 = i
            do while ((i.lt.j).and.
     &                ((a(i:i).ne.czSpace).and.(a(i:i).ne.czTab))
     &               )
               i = i + 1
            end do
            iEnd2 = i - 1

c         o verify integrity of substrings
            if ((iStart1.eq.iEnd1+1).or.
     &          (iStart2.eq.iEnd2+1)    ) then
               print *, '@DFILES: DEFECT IN FILE DIRECTIVE ON LINE ',
     &                  LINENO, ' OF ZMAT FILE'
               call errex
            end if

            if (leq(a(iStart1:iEnd1),'SAVEDIR')) then
               szSaveDir = a(iStart2:iEnd2)//czNull
               bSaveDir  = .true.
            else
c            o create FILES
               if (.not.bExist) then
                  OPEN(UNIT=LuFiles,FILE='FILES',FORM='FORMATTED',
     &                 STATUS='NEW')
                  REWIND(LuFiles)
                  bExist = .true.
                  if (bVerbose) then
                     print '()'
                     print *, '@DFILES: FILE MAPPING FROM ZMAT HEADER:'
                  end if
               end if
c            o write to FILES
               WRITE(LuFiles,'(a,x,a)')A(ISTART1:IEND1),A(ISTART2:IEND2)
               if (bVerbose) then
                  print *, A(ISTART1:IEND1), ' -> ', A(ISTART2:IEND2)
               end if
            end if

c        end if ([not file directive])
         end if

c     end do while (bNoTitle)
      end do

c   o add SAVEDIR to FILES only when the user overrides it
      if (bSaveDir) then
         if (.not.bExist) then
            OPEN(UNIT=LuFiles,FILE='FILES',FORM='FORMATTED',
     &           STATUS='NEW')
            REWIND(LuFiles)
            bExist = .true.
            if (bVerbose) then
               print '()'
               print *, '@DFILES: Archive directory:'
            end if
         end if
         i = 1
         do while (szSaveDir(i:i).ne.czNull)
            i = i + 1
         end do
         i = i - 1
         write(LuFiles,'(a,a)')'SAVEDIR ',szSaveDir(1:i)
         if (bVerbose) then
            print *, 'SAVEDIR == ', szSaveDir(1:i)
         end if
      end if

c   o close FILES
      if (bExist) then
         if (bVerbose) write(*,*)
         WRITE(LuFiles,*)
         CLOSE(LuFiles)
      end if

c   o close ZMAT
      CLOSE(LUZ)

c   o assume the current file set is good
      call gfname('JOBARC',szJOBARC,iJOBARC)
      inquire(file=szJOBARC(1:iJOBARC),exist=ignore)

c   o backup or restore the precious files
c      if (bSaveDir) then
      if (.true.) then
         bRestore = .true.
         bBackup  = .false.
         if (ignore) then
c         o limit coarse backups to clean geometry optimizations and vib freqs
            call aces_ja_init
            call igetrec(1,'JOBARC','IFLAGS',100,iFlags)
            call igetrec(1,'JOBARC','DIRTYFLG',1,i)
            if (i.eq.0) then
c            o JOBARC is clean
               bRestore = .false.
               if (iFlags(h_IFLAGS_restart).ne.0) then
                  call igetrec(1,'JOBARC','IFLAGS2',500,iFlags2)
                  bBackup = (iFlags2(h_IFLAGS2_geom_opt).ne.0).or.
     &                      (iFlags(h_IFLAGS_vib).eq.3)
               end if
            else
c            o JOBARC is dirty
               bRestore = (iFlags(h_IFLAGS_restart).ne.0)
            end if
            call aces_ja_fin
c        end if (JOBARC exists)
         end if
         if (bRestore) then
            i = 1
            do while (szSaveDir(i:i).ne.czNull)
               i = i + 1
            end do
            i = i - 1
            if (ignore) then
               print *, '@DFILES: The current file set is contaminated.'
               print *, '         Joda will attempt to recover from ',
     &                  szSaveDir(1:i)
            end if
            call coarse_restore(szSaveDir,iErr)
            if (iErr.ne.0) call errex()
            if (.not.ignore) then
               inquire(file=szJOBARC(1:iJOBARC),exist=ignore)
               if (ignore) then
                  print *, ' '
                  print *, '@DFILES: The ACES II file set was missing,',
     &                     ' but joda was able to recover'
                  print *, '         a checkpoint from ',szSaveDir(1:i)
                  print *, '         If this calculation should not',
     &                     ' have been restarted, then remove'
                  print *, '         the CURRENT and/or OLD',
     &                     ' directories in the checkpoint directory.'
                  print *, ' '
               end if
            end if
            bBackup = .false.
         end if
         if (bBackup) then
            call coarse_backup(szSaveDir,iErr)
            if (iErr.ne.0) call errex()
         end if
c     end if (bSaveDir)
      end if

      RETURN

 666  print '()'
      print *, '@DFILES: An error was encountered while attempting to ',
     &         'open or read ZMAT.'
      call errex

 9999 print '()'
      print *, '@DFILES: The ZMAT file is empty.'
      call errex

      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__NAI_DERV_3CEN_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      NINT1DX,NINT1DY,NINT1DZ,
     +                      ATOMIC,
     +                      MIJ,NCEN,MIJCEN,
     +                      NIJ,NIJBEG,NIJEND,
     +                      NGQP,NMOM,NGQSCR,MGIJCEN,
     +                      NPGTOA,NPGTOB,
     +                      NXYZA,NXYZB,
     +                      SHELLA,SHELLB,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      NUCLEI,
     +                      XN,YN,ZN,NCHARGE,
     +                      NUCCEN,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DERCX,DERCY,DERCZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      DIFFA,DIFFB,DIFFC,
     +                      IXAEQB,
     +                      ALPHAA,ALPHAB,
     +                      FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      PX,PY,PZ,PAX,PAY,PAZ,PINVHF,SCALE,
     +                      RTS,WTS,GQSCR,TVAL,
     +                      R1X,R1Y,R1Z,R2,
     +                      EXP2A,EXP2B,EXP2AB,
     +                      INT1DX,INT1DY,INT1DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__NAI_DERV_3CEN_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__RYS_ROOTS_WEIGHTS
C                OED__NAI_1D_COEFFICIENTS
C                OED__NAI_1D_AB_INTEGRALS
C                OED__NAI_1D_CENDERV_INTEGRALS
C                OED__NAI_1D_SHDERV_INTEGRALS
C                OED__NAI_DERV_INT1D_TO_00
C                OED__NAI_DERV_INT1D_TO_A0
C                OED__NAI_DERV_INT1D_TO_AB
C  DESCRIPTION : This operation calculates a batch of derivated unnormed
C                3-center nuclear attraction integrals between cartesian
C                gaussians
C
C                              sum  [A|C|B]
C                               C          ij
C
C                for a block of ij exponent pairs and a set of nuclear
C                attraction centers C different from the shell centers
C                A and B. Differentiation is possible on both A and B
C                shell centers and eventually on a specific nuclear
C                attraction center C. Note, that the atomic case A = B
C                is allowed here and is still considered to be a
C                3-center case.
C
C                After differentiation the total number of nuclear
C                attraction integrals generated here is thus given by
C                the total number of cartesian monomials NXYZA * NXYZB
C                times the total number of exponent pairs MIJ in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyza*nxyzb)
C
C
C                  Input:
C
C                    NBATCH       =  size of the array that will hold
C                                    the final primitive cartesian
C                                    derivative integral batch as well
C                                    as intermediate differentiated
C                                    1D integrals
C                    NINT1Dx      =  space needed for each of the 1D
C                                    x = X,Y,Z integral arrays (they
C                                    might be different due to different
C                                    orders of differentiation for
C                                    each cartesian component)
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NCEN         =  # of nuclear attraction centers
C                    MIJCEN       =  # of ij primitive index pairs
C                                    times # of nuclear attraction
C                                    centers
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NMOM         =  # of necessary moment integrals
C                                    to calculate the quadrature roots
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    MGIJCEN      =  # of roots times # of ij primitive
C                                    index pairs times # of nuclear
C                                    attraction centers
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZx        =  # of cartesian monomials for
C                                    each contraction shell x = A,B
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    NUCLEI       =  # of nuclear attraction centers
C                    XN,YN,ZN     =  the x,y,z-coordinates for all
C                                    nuclear attraction centers
C                    NCHARGE      =  the nuclear charges for all
C                                    nuclear attraction centers
C                    NUCCEN       =  contains those index labels of
C                                    the nuclear attraction centers
C                                    that survived the screening process
C                    DERyp        =  the order of differentiation on
C                                    centers y = A,B and possibly a
C                                    nuclear attraction center C with
C                                    respect to the p = x,y,z
C                                    coordinates
C                    DIFFy        =  is true, if differentiation will
C                                    be performed on centers y = A and B
C                                    and at least on one of the nuclear
C                                    attraction centers y = C different
C                                    from A and B and if differentiation
C                                    will be performed at least once
C                                    one on each of the y = x,y,z
C                                    coordinates
C                    IXAEQB       =  is an index = 0 or 1, depending
C                                    on if center A is different or
C                                    equal from center B, respectively
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    FTABLE       =  Fm (T) table for interpolation
C                                    in low T region
C                    MGRID        =  maximum m in Fm (T) table
C                    NGRID        =  # of T's for which Fm (T) table
C                                    was set up
C                    TMAX         =  maximum T in Fm (T) table
C                    TSTEP        =  difference between two consecutive
C                                    T's in Fm (T) table
C                    TVSTEP       =  Inverse of TSTEP
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    Px           =  will hold current MIJ coordinates
C                                    x=X,Y,Z for the gaussian product
C                                    centers P=A+B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current distinct MIJCEN
C                                    (expanded to MGIJCEN) values of
C                                    scaling factors
C                    RTS          =  will hold all current MGIJCEN
C                                    quadrature roots
C                    WTS          =  will hold all current MGIJCEN
C                                    quadrature weights
C                    GQSCR        =  will be used as scratch space
C                                    for determining the quadrature
C                                    roots and weights
C                    TVAL         =  will hold current MIJCEN values
C                                    of T-exponents defining the Rys
C                                    weight functions
C                    R1x          =  will hold the current MGIJCEN
C                                    VRR R1-coefficients (individual
C                                    cartesian components x=X,Y,Z) for
C                                    shell expansion on center P
C                    R2           =  will hold the current MGIJCEN
C                                    coordinate independent VRR
C                                    R2-coefficients
C                    EXP2x        =  will hold current double primitive
C                                    exponent values in MIJ order
C                                    (expanded to MGIJCEN) for each
C                                    contracted shell x = A,B
C                    EXP2AB       =  will hold current double primitive
C                                    exponent sum values in MIJ order
C                                    between both contracted shells
C                                    A and B
C                    INT1Dx       =  will hold all current derivated
C                                    1D integrals for each cartesian
C                                    component (x = X,Y,Z) during all
C                                    stages of differentiation
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    derivative cartesian nuclear
C                                    attraction [A|B] integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC
         LOGICAL     DIFFA,DIFFB,DIFFC
         LOGICAL     DIFFX,DIFFY,DIFFZ
         LOGICAL     PROCEED

         INTEGER     CENTER
         INTEGER     DERA,DERB
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DERCX,DERCY,DERCZ
         INTEGER     G000,G010,G020,G030,G040,G050,G060
         INTEGER     I,J,L,M,N
         INTEGER     IJ
         INTEGER     IXC,IXAEQB
         INTEGER     MGRID,NGRID
         INTEGER     MIJ,MIJCEN,MGIJCEN
         INTEGER     NBATCH
         INTEGER     NC,NCEN
         INTEGER     NG,NGQP,NGQPCEN,NMOM,NGQSCR
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NINT,NINT1DX,NINT1DY,NINT1DZ
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NUCLEI
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB,SHELLP

         INTEGER     NUCCEN (1:NCEN)

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  P,PINV,PVAL
         DOUBLE PRECISION  PCX,PCY,PCZ
         DOUBLE PRECISION  PXVAL,PYVAL,PZVAL
         DOUBLE PRECISION  RNPCSQ
         DOUBLE PRECISION  SCALEM,SCALEN
         DOUBLE PRECISION  TEMP
         DOUBLE PRECISION  TMAX,TSTEP,TVSTEP
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB,XC,YC,ZC
         DOUBLE PRECISION  ZERO,HALF,ONE

         DOUBLE PRECISION  XN      (1:NUCLEI)
         DOUBLE PRECISION  YN      (1:NUCLEI)
         DOUBLE PRECISION  ZN      (1:NUCLEI)
         DOUBLE PRECISION  NCHARGE (1:NUCLEI)

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  EXP2AB  (1:MIJ)
         DOUBLE PRECISION  PX      (1:MIJ)
         DOUBLE PRECISION  PY      (1:MIJ)
         DOUBLE PRECISION  PZ      (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)

         DOUBLE PRECISION  GQSCR   (1:NGQSCR)
         DOUBLE PRECISION  TVAL    (1:MIJCEN)

         DOUBLE PRECISION  R1X     (1:MGIJCEN)
         DOUBLE PRECISION  R1Y     (1:MGIJCEN)
         DOUBLE PRECISION  R1Z     (1:MGIJCEN)
         DOUBLE PRECISION  R2      (1:MGIJCEN)
         DOUBLE PRECISION  EXP2A   (1:MGIJCEN)
         DOUBLE PRECISION  EXP2B   (1:MGIJCEN)
         DOUBLE PRECISION  RTS     (1:MGIJCEN)
         DOUBLE PRECISION  SCALE   (1:MGIJCEN)
         DOUBLE PRECISION  WTS     (1:MGIJCEN)

         DOUBLE PRECISION  INT1DX  (1:NINT1DX)
         DOUBLE PRECISION  INT1DY  (1:NINT1DY)
         DOUBLE PRECISION  INT1DZ  (1:NINT1DZ)

         DOUBLE PRECISION  FTABLE  (0:MGRID,0:NGRID)

         PARAMETER  (ZERO = 0.D0)
         PARAMETER  (HALF = 0.5D0)
         PARAMETER  (ONE  = 1.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D nuclear attraction integrals.
C
C
         IF (ATOMIC) THEN
             L = 0
             M = 0
             N = 0
             DO IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                P = ALPHAA (I) + ALPHAB (J)
                PX (M) = XA
                PY (M) = YA
                PZ (M) = ZA
                PINV = ONE / P
                PINVHF (M) = HALF * PINV
                SCALEM = PINV * NORMA (I) * NORMB (J)
                DO NC = 1,NCEN
                   N = N + 1
                   IXC = NUCCEN (NC)
                   PCX = XA - XN (IXC)
                   PCY = YA - YN (IXC)
                   PCZ = ZA - ZN (IXC)
                   RNPCSQ = PCX * PCX + PCY * PCY + PCZ * PCZ
                   TVAL (N) = P * RNPCSQ
                   SCALEN = SCALEM * NCHARGE (IXC)
                   DO NG = 1,NGQP
                      L = L + 1
                      SCALE (L) = SCALEN
                   END DO
                END DO
             END DO
         ELSE
             L = 0
             M = 0
             N = 0
             DO IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                P = EXPA + EXPB
                PINV = ONE / P
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PXVAL = PAX (M) + XA
                PYVAL = PAY (M) + YA
                PZVAL = PAZ (M) + ZA
                PX (M) = PXVAL
                PY (M) = PYVAL
                PZ (M) = PZVAL
                PINVHF (M) = HALF * PINV
                SCALEM = PINV * NORMA (I) * NORMB (J) * RHOAB (IJ)
                DO NC = 1,NCEN
                   N = N + 1
                   IXC = NUCCEN (NC)
                   PCX = PXVAL - XN (IXC)
                   PCY = PYVAL - YN (IXC)
                   PCZ = PZVAL - ZN (IXC)
                   RNPCSQ = PCX * PCX + PCY * PCY + PCZ * PCZ
                   TVAL (N) = P * RNPCSQ
                   SCALEN = SCALEM * NCHARGE (IXC)
                   DO NG = 1,NGQP
                      L = L + 1
                      SCALE (L) = SCALEN
                   END DO
                END DO
             END DO
         END IF
C
C
C             ...determine memory allocation offsets for the scratch
C                arrays used to calculate the quadrature roots +
C                weights:
C
C                   G000 = offset for A coefficients (Jacobi/Laguerre)
C                   G010 = offset for B coefficients (Jacobi/Laguerre)
C                   G020 = offset for moments (Jacobi/Laguerre)
C                   G030 = offset for diagonals of symmetric termat
C                   G040 = offset for offdiagonals of symmetric termat
C                   G050 = offset for first row intermediates during
C                          evaluation of symmetric termat
C                   G060 = offset for second row intermediates during
C                          evaluation of symmetric termat
C
C
         G000 = 1
         G010 = G000 + NMOM
         G020 = G010 + NMOM - 1
         G030 = G020 + NMOM
         G040 = G030 + NGQP
         G050 = G040 + NGQP
         G060 = G050 + NMOM
C
C
C             ...calculate all roots and weights for all ij pairs and
C                nuclear centers. Array R2 is passed as a scratch array.
C
C
         CALL    OED__RYS_ROOTS_WEIGHTS
     +
     +                ( MIJCEN,MGIJCEN,
     +                  NGQP,NMOM,
     +                  TVAL,R2,
     +                  FTABLE,MGRID,NGRID,TMAX,TSTEP,TVSTEP,
     +                  GQSCR(G000),GQSCR(G010),
     +                  GQSCR(G020),
     +                  GQSCR(G030),GQSCR(G040),
     +                  GQSCR(G050),GQSCR(G060),
     +
     +                           RTS,
     +                           WTS )
     +
     +
C
C
C             ...calculate the derivative 1D integral coefficents
C                (if needed). These are the double exponent values
C                for differentiation on centers A and/or B and the
C                double exponent sum values between centers A and B.
C
C
         NGQPCEN = NGQP * NCEN

         IF (DIFFA) THEN
             M = 0
             DO IJ = 1,MIJ
                I = PRIMA (IJ)
                EXPA = ALPHAA (I) + ALPHAA (I)
                DO N = 1,NGQPCEN
                   EXP2A (M+N) = EXPA
                END DO
                M = M + NGQPCEN
             END DO
         END IF

         IF (DIFFB) THEN
             M = 0
             DO IJ = 1,MIJ
                J = PRIMB (IJ)
                EXPB = ALPHAB (J) + ALPHAB (J)
                DO N = 1,NGQPCEN
                   EXP2B (M+N) = EXPB
                END DO
                M = M + NGQPCEN
             END DO
         END IF

         IF (DIFFC) THEN
             DO IJ = 1,MIJ
                I = PRIMA (IJ)
                J = PRIMB (IJ)
                P = ALPHAA (I) + ALPHAB (J)
                EXP2AB (IJ) = P + P
             END DO
         END IF
C
C
C             ...generate all VRR coefficients.
C
C
         CALL    OED__NAI_1D_COEFFICIENTS
     +
     +                ( NGQP,NCEN,
     +                  MIJ,MGIJCEN,
     +                  ATOMIC,
     +                  NUCLEI,
     +                  XN,YN,ZN,
     +                  NUCCEN,
     +                  PX,PY,PZ,
     +                  PAX,PAY,PAZ,
     +                  PINVHF,
     +                  RTS,
     +
     +                            R1X,R1Y,R1Z,
     +                            R2 )
     +
     +
C
C
C             ...start assembling the 1D AB nuclear attraction
C                integrals and their differentiation. Assemble first
C                the 1DX AB integrals and perform differentiation
C                sequence, if necessary.
C
C
C         WRITE (*,*) ' ATOMIC = ',ATOMIC
C         WRITE (*,*) ' NCEN = ',NCEN
C         WRITE (*,*) ' NGQP = ',NGQP
C         WRITE (*,*) ' IXAEQB = ',IXAEQB
C         WRITE (*,*) ' DIFFA,DIFFB,DIFFC = ',DIFFA,DIFFB,DIFFC
C         WRITE (*,*) ' DIFFX,DIFFY,DIFFZ = ',DIFFX,DIFFY,DIFFZ
C         WRITE (*,*) ' DERAX,DERAY,DERAZ = ',DERAX,DERAY,DERAZ
C         WRITE (*,*) ' DERBX,DERBY,DERBZ = ',DERBX,DERBY,DERBZ
C         WRITE (*,*) ' DERCX,DERCY,DERCZ = ',DERCX,DERCY,DERCZ

         IF (DIFFX) THEN

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERAX+DERBX,
     +                      MIN (SHELLA+DERAX,SHELLB+DERBX),
     +                      SHELLA+DERAX,SHELLB+DERBX,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1X,R2,
     +                      ABX,
     +                      .TRUE.,
     +                      BATCH,
     +
     +                                INT1DX )
     +
     +
C
C
C             ...apply (if any) differentiation of the 1DX AB integrals
C                on a nuclear attraction center different from shell
C                centers A and B.
C
C
             PROCEED = DIFFC .AND. (DERCX.GT.0)

             IF (PROCEED) THEN
                 IXC = NUCCEN (1)
                 XC = XN (IXC)
                 NINT = MGIJCEN * (SHELLA+DERAX+1) * (SHELLB+DERBX+1)
                 DO N = 1,DERCX
                    IF (N.GT.1) THEN
                        DO M = 1,NINT
                           TEMP = BATCH (M)
                           BATCH (M) = INT1DX (M)
                           INT1DX (M) = TEMP
                        END DO
                    ELSE
                        DO M = 1,NINT
                           BATCH (M) = INT1DX (M)
                        END DO
                    END IF

                    CALL    OED__NAI_1D_CENDERV_INTEGRALS
     +
     +                           ( MIJ,MGIJCEN,
     +                             NGQP,
     +                             SHELLA+DERAX,SHELLB+DERBX,
     +                             EXP2AB,
     +                             PX,XC,
     +                             N,
     +                             RTS,
     +                             R1X,
     +                             BATCH,
     +
     +                                      INT1DX )
     +
     +
                 END DO
             END IF
C
C
C             ...perform differentiation (if any) of the 1DX AB
C                integrals on shell center A (and simultaneously on
C                shell center B, if atomic).
C
C
             PROCEED = DIFFA .AND. (DERAX.GT.0)

             IF (PROCEED) THEN
                 DERA = DERAX
                 DERB = DERBX
                 DO N = 1,DERAX
                    NINT = MGIJCEN * (SHELLA+DERA+1) * (SHELLB+DERB+1)
                    DO M = 1,NINT
                       BATCH (M) = INT1DX (M)
                    END DO

                    DERA = DERA - 1
                    DERB = DERB - IXAEQB

                    IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                        WRITE (*,*) ' Problems forming x-derivatives! '
                        WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                        WRITE (*,*) ' oed__nai_derv_3cen_pcgto_block '
                        STOP
                    END IF

                    CALL    OED__NAI_1D_SHDERV_INTEGRALS
     +
     +                           ( MGIJCEN,
     +                             SHELLA+DERA,SHELLB+DERB,
     +                             1,IXAEQB,
     +                             EXP2A,EXP2B,
     +                             BATCH,
     +
     +                                      INT1DX )
     +
     +
                 END DO
             END IF
C
C
C             ...if not atomic, perform differentiation (if any) of
C                the 1DX AB integrals on the remaining shell center B.
C
C
             PROCEED = (.NOT.ATOMIC) .AND. DIFFB .AND. (DERBX.GT.0)

             IF (PROCEED) THEN
                 DERB = DERBX
                 DO N = 1,DERBX
                    NINT = MGIJCEN * (SHELLA+1) * (SHELLB+DERB+1)
                    DO M = 1,NINT
                       BATCH (M) = INT1DX (M)
                    END DO

                    DERB = DERB - 1

                    IF (DERB.LT.0) THEN
                        WRITE (*,*) ' Problems forming x-derivatives! '
                        WRITE (*,*) ' DERB = ',DERB
                        WRITE (*,*) ' oed__nai_derv_3cen_pcgto_block '
                        STOP
                    END IF

                    CALL    OED__NAI_1D_SHDERV_INTEGRALS
     +
     +                           ( MGIJCEN,
     +                             SHELLA,SHELLB+DERB,
     +                             0,1,
     +                             EXP2A,EXP2B,
     +                             BATCH,
     +
     +                                      INT1DX )
     +
     +
                 END DO
             END IF

         ELSE

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,MIN (SHELLA,SHELLB),
     +                      SHELLA,SHELLB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1X,R2,
     +                      ABX,
     +                      .TRUE.,
     +                      BATCH,
     +
     +                                INT1DX )
     +
     +
         END IF
C
C
C             ...assemble next the 1DY AB integrals and perform
C                differentiation sequence, if necessary.
C
C
         IF (DIFFY) THEN

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERAY+DERBY,
     +                      MIN (SHELLA+DERAY,SHELLB+DERBY),
     +                      SHELLA+DERAY,SHELLB+DERBY,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Y,R2,
     +                      ABY,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DY )
     +
     +
C
C
C             ...apply (if any) differentiation of the 1DY AB integrals
C                on a nuclear attraction center different from shell
C                centers A and B.
C
C
             PROCEED = DIFFC .AND. (DERCY.GT.0)

             IF (PROCEED) THEN
                 IXC = NUCCEN (1)
                 YC = YN (IXC)
                 NINT = MGIJCEN * (SHELLA+DERAY+1) * (SHELLB+DERBY+1)
                 DO N = 1,DERCY
                    IF (N.GT.1) THEN
                        DO M = 1,NINT
                           TEMP = BATCH (M)
                           BATCH (M) = INT1DY (M)
                           INT1DY (M) = TEMP
                        END DO
                    ELSE
                        DO M = 1,NINT
                           BATCH (M) = INT1DY (M)
                        END DO
                    END IF

                    CALL    OED__NAI_1D_CENDERV_INTEGRALS
     +
     +                           ( MIJ,MGIJCEN,
     +                             NGQP,
     +                             SHELLA+DERAY,SHELLB+DERBY,
     +                             EXP2AB,
     +                             PY,YC,
     +                             N,
     +                             RTS,
     +                             R1Y,
     +                             BATCH,
     +
     +                                      INT1DY )
     +
     +
                 END DO
             END IF
C
C
C             ...perform differentiation (if any) of the 1DY AB
C                integrals on shell center A (and simultaneously on
C                shell center B, if atomic).
C
C
             PROCEED = DIFFA .AND. (DERAY.GT.0)

             IF (PROCEED) THEN
                 DERA = DERAY
                 DERB = DERBY
                 DO N = 1,DERAY
                    NINT = MGIJCEN * (SHELLA+DERA+1) * (SHELLB+DERB+1)
                    DO M = 1,NINT
                       BATCH (M) = INT1DY (M)
                    END DO

                    DERA = DERA - 1
                    DERB = DERB - IXAEQB

                    IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                        WRITE (*,*) ' Problems forming y-derivatives! '
                        WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                        WRITE (*,*) ' oed__nai_derv_3cen_pcgto_block '
                        STOP
                    END IF

                    CALL    OED__NAI_1D_SHDERV_INTEGRALS
     +
     +                           ( MGIJCEN,
     +                             SHELLA+DERA,SHELLB+DERB,
     +                             1,IXAEQB,
     +                             EXP2A,EXP2B,
     +                             BATCH,
     +
     +                                      INT1DY )
     +
     +
                 END DO
             END IF
C
C
C             ...if not atomic, perform differentiation (if any) of
C                the 1DY AB integrals on the remaining shell center B.
C
C
             PROCEED = (.NOT.ATOMIC) .AND. DIFFB .AND. (DERBY.GT.0)

             IF (PROCEED) THEN
                 DERB = DERBY
                 DO N = 1,DERBY
                    NINT = MGIJCEN * (SHELLA+1) * (SHELLB+DERB+1)
                    DO M = 1,NINT
                       BATCH (M) = INT1DY (M)
                    END DO

                    DERB = DERB - 1

                    IF (DERB.LT.0) THEN
                        WRITE (*,*) ' Problems forming y-derivatives! '
                        WRITE (*,*) ' DERB = ',DERB
                        WRITE (*,*) ' oed__nai_derv_3cen_pcgto_block '
                        STOP
                    END IF

                    CALL    OED__NAI_1D_SHDERV_INTEGRALS
     +
     +                           ( MGIJCEN,
     +                             SHELLA,SHELLB+DERB,
     +                             0,1,
     +                             EXP2A,EXP2B,
     +                             BATCH,
     +
     +                                      INT1DY )
     +
     +
                 END DO
             END IF

         ELSE

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,MIN (SHELLA,SHELLB),
     +                      SHELLA,SHELLB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Y,R2,
     +                      ABY,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DY )
     +
     +
         END IF
C
C
C             ...assemble finally the 1DZ AB integrals and perform
C                differentiation sequence, if necessary.
C
C
         IF (DIFFZ) THEN

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP+DERAZ+DERBZ,
     +                      MIN (SHELLA+DERAZ,SHELLB+DERBZ),
     +                      SHELLA+DERAZ,SHELLB+DERBZ,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Z,R2,
     +                      ABZ,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DZ )
     +
     +
C
C
C             ...apply (if any) differentiation of the 1DZ AB integrals
C                on a nuclear attraction center different from shell
C                centers A and B.
C
C
             PROCEED = DIFFC .AND. (DERCZ.GT.0)

             IF (PROCEED) THEN
                 IXC = NUCCEN (1)
                 ZC = ZN (IXC)
                 NINT = MGIJCEN * (SHELLA+DERAZ+1) * (SHELLB+DERBZ+1)
                 DO N = 1,DERCZ
                    IF (N.GT.1) THEN
                        DO M = 1,NINT
                           TEMP = BATCH (M)
                           BATCH (M) = INT1DZ (M)
                           INT1DZ (M) = TEMP
                        END DO
                    ELSE
                        DO M = 1,NINT
                           BATCH (M) = INT1DZ (M)
                        END DO
                    END IF

                    CALL    OED__NAI_1D_CENDERV_INTEGRALS
     +
     +                           ( MIJ,MGIJCEN,
     +                             NGQP,
     +                             SHELLA+DERAZ,SHELLB+DERBZ,
     +                             EXP2AB,
     +                             PZ,ZC,
     +                             N,
     +                             RTS,
     +                             R1Z,
     +                             BATCH,
     +
     +                                      INT1DZ )
     +
     +
                 END DO
             END IF
C
C
C             ...perform differentiation (if any) of the 1DZ AB
C                integrals on shell center A (and simultaneously on
C                shell center B, if atomic).
C
C
             PROCEED = DIFFA .AND. (DERAZ.GT.0)

             IF (PROCEED) THEN
                 DERA = DERAZ
                 DERB = DERBZ
                 DO N = 1,DERAZ
                    NINT = MGIJCEN * (SHELLA+DERA+1) * (SHELLB+DERB+1)
                    DO M = 1,NINT
                       BATCH (M) = INT1DZ (M)
                    END DO

                    DERA = DERA - 1
                    DERB = DERB - IXAEQB

                    IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                        WRITE (*,*) ' Problems forming z-derivatives! '
                        WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                        WRITE (*,*) ' oed__nai_derv_3cen_pcgto_block '
                        STOP
                    END IF

                    CALL    OED__NAI_1D_SHDERV_INTEGRALS
     +
     +                           ( MGIJCEN,
     +                             SHELLA+DERA,SHELLB+DERB,
     +                             1,IXAEQB,
     +                             EXP2A,EXP2B,
     +                             BATCH,
     +
     +                                      INT1DZ )
     +
     +
                 END DO
             END IF
C
C
C             ...if not atomic, perform differentiation (if any) of
C                the 1DZ AB integrals on the remaining shell center B.
C
C
             PROCEED = (.NOT.ATOMIC) .AND. DIFFB .AND. (DERBZ.GT.0)

             IF (PROCEED) THEN
                 DERB = DERBZ
                 DO N = 1,DERBZ
                    NINT = MGIJCEN * (SHELLA+1) * (SHELLB+DERB+1)
                    DO M = 1,NINT
                       BATCH (M) = INT1DZ (M)
                    END DO

                    DERB = DERB - 1

                    IF (DERB.LT.0) THEN
                        WRITE (*,*) ' Problems forming z-derivatives! '
                        WRITE (*,*) ' DERB = ',DERB
                        WRITE (*,*) ' oed__nai_derv_3cen_pcgto_block '
                        STOP
                    END IF

                    CALL    OED__NAI_1D_SHDERV_INTEGRALS
     +
     +                           ( MGIJCEN,
     +                             SHELLA,SHELLB+DERB,
     +                             0,1,
     +                             EXP2A,EXP2B,
     +                             BATCH,
     +
     +                                      INT1DZ )
     +
     +
                 END DO
             END IF

         ELSE

             CALL    OED__NAI_1D_AB_INTEGRALS
     +
     +                    ( SHELLP,MIN (SHELLA,SHELLB),
     +                      SHELLA,SHELLB,
     +                      MGIJCEN,
     +                      WTS,
     +                      R1Z,R2,
     +                      ABZ,
     +                      .FALSE.,
     +                      BATCH,
     +
     +                                INT1DZ )
     +
     +
         END IF
C
C
C             ...assemble the 1D AB integrals to the [A|B] batch.
C
C
         IF (SHELLP.EQ.0) THEN

             CALL    OED__NAI_DERV_INT1D_TO_00
     +
     +                    ( MIJ,NGQPCEN,MGIJCEN,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLB.EQ.0) THEN

             CALL    OED__NAI_DERV_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZA,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,R1Y,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLA.EQ.0) THEN

             CALL    OED__NAI_DERV_INT1D_TO_A0
     +
     +                    ( SHELLB,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,R1Y,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE

             CALL    OED__NAI_DERV_INT1D_TO_AB
     +
     +                    ( SHELLA,SHELLB,
     +                      MIJ,NGQPCEN,MGIJCEN,
     +                      NXYZA,NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFY,DIFFZ,
     +                      R1X,R1Y,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine destroy_instruction(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      op, instruction_timer, comm_timer)
c--------------------------------------------------------------------------
c   Broadcast a server_delete message to all servers in the IOCOMPANY.
c   Format of command is :
c
c   destroy array
c
c   Should be executed after a server_barrier to insure that all messages 
c   referring to this array have been processed by all servers.  Otherwise
c   inconsistency of data may result.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'int_gen_parms.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer instruction_timer, comm_timer

      integer i, j, ii, array, company, comm, ierr
      integer array_type
      integer temp
      integer msg(len_sip_server_message)
      integer status(MPI_STATUS_SIZE) 
      integer pst_get_company
      integer pst_get_company_comm

      array = op(c_result_array)
      comm = pst_get_company_comm(me)

c--------------------------------------------------------------------------
c   The array must be a served array.
c--------------------------------------------------------------------------
      
      array_type = array_table(c_array_type,array)

      if (array_type .ne. served_array) then
         print *,'Error: Array type for destroy must be served'
         print *,'op ',(op(i),i=1,loptable_entry)
         print *,'array ' ,array
         print *,'Array table entry: ',(array_table(i,array),
     *     i = 1, larray_table_entry)
         call abort_job()
      endif

      if (me .ne. 0) go to 1000  

c-------------------------------------------------------------------------
c   Build the server message.
c-------------------------------------------------------------------------

      do i = 1, len_sip_server_message
         msg(i) = 0
      enddo

      msg(1) = sip_server_delete_message
      msg(2) = array

c-------------------------------------------------------------------------
c   Send the message to each server.
c-------------------------------------------------------------------------

      do i = 1, nprocs
         company = pst_get_company(i-1)
         if (company .eq. io_company_id) then
            call mpi_send(msg, len_sip_server_message, mpi_integer,
     *               i-1, sip_server_message,
     *               mpi_comm_world, status, ierr)
         endif 
      enddo

 1000 continue

c--------------------------------------------------------------------------
c   Free the persistent blocks of the array.
c--------------------------------------------------------------------------

      call free_persistent_blocks(array, array_table,
     *                    narray_table, index_table, nindex_table,
     *                    block_map_table)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine f_acquire_pardo_lock(my_lock)
      implicit none
      include 'parallel_info.h'
     
      integer my_lock
       
      call acquire_pardo_lock(my_lock)   
      return
      end

      subroutine f_release_pardo_lock(my_lock)
      implicit none
      include 'parallel_info.h'

      integer my_lock

      call release_pardo_lock(my_lock)
      return
      end

      subroutine pardo_loadb_get_next_batch(comm, iop, index_table,
     *                        next_batch, last_batch)
      implicit none
      include 'mpif.h'
      include 'interpreter.h' 
      include 'trace.h'
      include 'parallel_info.h'
      include 'machine_types.h'
      include 'sip_tables.h'
      include 'timerz.h'
#ifdef ALTIX
      include 'sheap.h'
#endif
 
      integer comm, iop, next_batch, last_batch
      integer msg(4)
      integer i, ierr
      integer pardo_line
      integer request, request2
      integer status(MPI_STATUS_SIZE)
      integer*8 addr, indaddr, get_index_from_base
      integer optable_entry(loptable_entry)
      integer index_table(lindex_table_entry, *)
      integer my_batch_zero, my_last_batch_zero
      integer loop_init
      integer my_lock, batch_data(2)
      integer pardo_master, get_pardo_master
      integer cluster_size, get_pardo_cluster_size
      integer nclusters

      logical flag1, flag2

      integer icom(1)
#ifdef ALTIX
      pointer (iptr, icom)
#else
      common icom
#endif

c---------------------------------------------------------------------------
c   Send a job request to rank the pardo_master.
c---------------------------------------------------------------------------

      addr = optable_base + loptable_entry *(iop-1)*intsize
#ifdef ALTIX
      iptr = ishptr
#endif
      indaddr = get_index_from_base(addr, icom, 1)
      pardo_line = icom(indaddr+c_lineno-1)
      my_lock    = icom(indaddr+c_pardo_lock_index-1)

      msg(1) = pardo_job_request_tag
      msg(2) = pardo_line
      msg(3) = iop
      msg(4) = my_lock
      pardo_master = get_pardo_master()
      call mpi_isend(msg, 4, mpi_integer, pardo_master,
     *                     pardo_job_tag,
     *                     comm, request, ierr)

c--------------------------------------------------------------------------
c   Post a recv for the response from the thread server on proc 0.
c--------------------------------------------------------------------------

      call mpi_irecv(batch_data, 2, mpi_integer, pardo_master,
     *               pardo_job_request_tag, comm, request2,
     *               ierr)

c--------------------------------------------------------------------------
c   Clear the request on the send and recv.
c--------------------------------------------------------------------------

#ifdef VERY_DETAILED_TIMERS
      call timer_start (pardo_tserver_timer)   
#endif
  100 continue

      call mpi_test(request,  flag1, status, ierr)
      if (.not. flag1) then
         call exec_thread_server(0)
         go to 100
      endif
  200 continue

      call mpi_test(request2, flag2, status, ierr)
      if (.not. flag2) then
         call exec_thread_server(0)
         go to 200
      endif
#ifdef VERY_DETAILED_TIMERS
      call update_timer (pardo_tserver_timer)
#endif

      next_batch = batch_data(1) 
      last_batch = batch_data(2)

      return
      end

c This routine was the array (list) creation utility, but that function has been
c transferred to aces_list_touch. This routine is now kept for compatibility.

c NOTE: We cannot get rid of it yet. Calling updmoi with IENTER=1 would attempt
c to reset the free-space pointers of the respective storage file. This action
c is no longer allowed, and although reasonable effort has been made to find any
c residual reset calls, it is possible some may still exist. After some time has
c passed, we can ignore IENTER entirely.

      subroutine updmoi(lstdis,dissiz,lstspn,lstnum,ienter,ioff)
      implicit none

c ARGUMENTS
      integer lstdis, dissiz, lstspn, lstnum, ienter, ioff

c INTERNAL VARIABLES
      integer iTmp

c ----------------------------------------------------------------------

#ifdef _ASSERT
      iTmp = 0
c   o assert ienter=0
      if (ienter.ne.0) then
         print *, '@UPDMOI: Assertion failed.'
         print *, '   ienter = ',ienter
         iTmp = 1
      end if
      if (iTmp.ne.0) call aces_exit(iTmp)
#endif /* _ASSERT */

c ----------------------------------------------------------------------

      call aces_list_touch(lstdis,dissiz,lstspn,lstnum,ioff)

      return
c     end subroutine updmoi
      end

      Subroutine Set_rst(Nx, Ny, Nz)

      Implicit Integer (A-z)

#include "ecp.par"
#include "ecp.com"
C
      Dimension Rstval(3,84)
C
      Indx = 0
      Nxx = Nx + 1
      Nyy = Ny + 1
      Nzz = Nz + 1
      
      Nxyz = Nxx + Nyy + Nzz
     
      Do N = 1, Nxyz
         Do Rx = 1, Nxx
            Do Sy = 1, Nyy
               Do Tz = 1, Nzz

                  If (Rx+Sy+Tz .EQ. (N+2)) Then
                     Ndx = 1 
                     Rstval(1, Indx) = Rx - 1
                     Rstval(2, Indx) = Sy - 1
                     Rstval(3, Indx) = Tz - 1
                  Endif

               Enddo
             Enddo
         Enddo
      Enddo
C     
#ifdef _DEBUG_LVL0     
      Write(6,"(a)") "The rst values"
      Do i=1, 3
         Write(6,"(10I3)") (rstval(i, i1),i1=1,84)
         Write(6,*)
      Enddo
#endif
c     
      Return
      End

      SUBROUTINE PROJDPD(NATOM,NIRREP,IORDER,ATMASS,DPD,DPDSCR,
     &                   SYOP,IPTR,NBFATM,ILCATM,SCR)
C
C THIS ROUTINE PROJECTS THE TOTALLY SYMMETRIC COMPONENT FROM A
C "PETITE" CARTESIAN FORCE CONSTANT MATRIX USING THE SYMMETRY
C OPERATIONS OF THE FULL POINT GROUP.
C
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL YESNO
      DIMENSION DPD(3*NATOM,3),SCR(1),DPDSCR(3*NATOM,3)
      DIMENSION SYOP(9*IORDER),IPTR(NATOM,IORDER),NBFATM(NATOM)
      DIMENSION ILCATM(NATOM),ATMASS(NATOM)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FLAGS/  IFLAGS(100),IFLAGS2(500)
      DATA ONE /1.0/
      DATA ZILCH /0.0/
      DATA ONEM /-1.0/
C
      INQUIRE(FILE='DIPDER',EXIST=YESNO)
      IF(.NOT.YESNO)RETURN
C
      IF(IFLAGS(1).GE.1)THEN
       WRITE(6,1000)
      ENDIF
      ININE=9
C
      OPEN(UNIT=51,FILE='DIPDER',FORM='FORMATTED',STATUS='OLD')
      REWIND(51)
      CALL ZERO(DPD,3*NATOM)
      DO 10 IXYZ=1,3
       IOFF=1
       READ(51,*)
       DO 11 IATOM=1,NATOM
        IF(ATMASS(IATOM).NE.ZILCH)THEN
         READ(51,'(4F20.10)')ZJUNK,(DPD(J,IXYZ),J=IOFF,IOFF+2)
        ENDIF
        IOFF=IOFF+3
11     CONTINUE
10    CONTINUE
      CLOSE(UNIT=51,STATUS='KEEP')
C
C GET SOME INFORMATION FROM JOBARC
C
      call filter(dpd,9*natom,1.0d-8)
      CALL GETREC(20,'JOBARC','FULLSYOP',9*IORDER*IINTFP,SYOP)
      CALL GETREC(20,'JOBARC','FULLPERM',NATOM*IORDER,IPTR)
      CALL GETREC(20,'JOBARC','ORIENTMT',ININE*IINTFP,SCR)
      CALL TRNOPS(SYOP,SCR,IORDER)
C
C FILL BASIS VECTOR.  SKIP DUMMY ATOMS.
C
      DO 5 IATOM=1,NATOM
       NBFATM(IATOM)=3
       ILCATM(IATOM)=3*(IATOM-1)+1
5     CONTINUE
C
      ZNORM=ONE/DFLOAT(IORDER)
C
C HALF-PROJECT CARTESIAN DPD
C
C LOOP OVER CARTESIAN DIRECTIONS
C
      IOFFS=18*NATOM+1
      CALL ZERO(DPDSCR,9*NATOM)
      DO 30 IOP=1,IORDER
       ITMP=IPTR(IOP,1)
       CALL SCOPY(9*NATOM,DPD,1,SCR,1)
       IOFFA=1
       IOFFB=9*NATOM+1
       DO 20 IBAS=1,3
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &             SCR(IOFFA),SCR(IOFFB),SCR(IOFFS),1,3*NATOM,
     &             SYOP,0)
         IOFFA=IOFFA+3*NATOM
         IOFFB=IOFFB+3*NATOM
20      CONTINUE 
        CALL TRANSP(SCR(9*NATOM+1),SCR(18*NATOM+1),3,3*NATOM)
        CALL SCOPY(9*NATOM,SCR(18*NATOM+1),1,SCR(9*NATOM+1),1)
        IOFFA=9*NATOM+1
        IOFFB=1
        IPTR(IOP,1)=1
        DO 21 IBAS=1,3*NATOM
         CALL IMAGE(1,3,1,IOP,IPTR,NBFATM,ILCATM,
     &             SCR(IOFFA),SCR(IOFFB),SCR(IOFFS),1,3,
     &             SYOP,0)
         IOFFA=IOFFA+3
         IOFFB=IOFFB+3
21      CONTINUE

        IPTR(IOP,1)=ITMP
       CALL SAXPY(9*NATOM,ONE,SCR,1,DPDSCR,1)
30    CONTINUE
C
C
      CALL SSCAL(9*NATOM,ZNORM,DPDSCR,1)
      CALL TRANSP(DPDSCR,SCR,3*NATOM,3)
      CALL SAXPY(9*NATOM,ONEM,SCR,1,DPD,1)
      ILOC=ISAMAX(9*NATOM,DPD,1)
      DIFMAX=DPD(ILOC,1)
      IF(IFLAGS(1).GE.1)WRITE(6,1001)DIFMAX
      IF(DIFMAX.GT.1.D-4)THEN
       WRITE(6,1002)
      ENDIF
      CALL TRANSP(DPDSCR,DPD,3*NATOM,3)
C
      OPEN(UNIT=51,FILE='DIPDER',FORM='FORMATTED',STATUS='OLD')
      REWIND(51)
      ZJUNK=0.0D0
      DO 12 IXYZ=1,3
       IOFF=1
       WRITE(51,'(I5)')IXYZ
       DO 13 IATOM=1,NATOM
        IF(ATMASS(IATOM).NE.ZILCH)THEN
         WRITE(51,'(4F20.10)')ZJUNK,(DPD(J,IXYZ),J=IOFF,IOFF+2)
        ENDIF
        IOFF=IOFF+3
13     CONTINUE
12    CONTINUE
      CLOSE(UNIT=51,STATUS='KEEP')
C
      RETURN
1000  FORMAT(T3,'@PROJDPD-I, Projecting dipole derivatives onto ',
     &          'totally symmetric subspace.')
1001  FORMAT(T3,'Largest difference between matrix elements of ',
     &          'symmetrized',/,T3,'and unsymmetrized DPD : ',F15.10,
     &          '.')
1002  FORMAT(T3,'@PROJDPD-W, The input DPD was not totally symmetric.')
      END

      SUBROUTINE SQSYM(IRREP,NUM,DSZA,DSZB,NUMSIZ,A,B)
C
C     THIS ROUTINE SQUEEZES A SYMMETRY PACKED ARRAY
C
C     A(AB,IJ) = B(AB,IJ)  A<B IN A AND A,B IN B
C
C     B IS AN ARRAY WITH ALL A,B ELEMENTS STORED
C     A AN ARRAY WITH ALL A<B ELEMENTS STORED
C
C     INPUT : IRREP = IRREP OF (A,B) BLOCK
C             NUM = POPULATION IN EACH IRREP FOR I AND J
C             DSZA = DISTRIBUTION SIZE IN OUTPUT ARRAY
C             DSZB = DISTRIBUTION SIZE IN INPUT ARRAY
C             NUMSIZ = NUMBER OF DISTRIBUTIONS IN A AND B
C             B = INPUT ARRAY WITh ELEMENTS TO BE ANTISYMMTRIZED
C     OUTPUT : A = ANTISYMMETRIZED OUTPUT ARRAY
C
CEND
C
C   CODED JUNE/90  JG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER DSZA,DSZB,DIRPRD
      DIMENSION A(DSZA,NUMSIZ),B(DSZB,NUMSIZ),NUM(8)
      DIMENSION IP(8),IPFULL(8)
C
      COMMON/SYMINF/NSTART,NIRREP,IRREPA(255),IRREPB(255),
     &              DIRPRD(8,8)
C
C     TAKE CARE, IF WE ARE HANDLING IRREP = 1 OR
C     SOMETHING ELSE
C
      IF(IRREP.EQ.1) THEN
C
C     GET FIRST POINTERS FOR OLD AND NEW INDICES
C
       IPFULL(1)=0
       IP(1)=0
       DO 10 IRREPJ=1,NIRREP-1
        IP(IRREPJ+1)=IP(IRREPJ)+NUM(IRREPJ)*(NUM(IRREPJ)-1)/2
        IPFULL(IRREPJ+1)=IPFULL(IRREPJ)+NUM(IRREPJ)**2
10     CONTINUE
C
C     NOW LOOP OVER ALL IRREPS
C
       DO 1 IRREPJ=1,NIRREP
        NUMJ=NUM(IRREPJ)
        IND=IP(IRREPJ)
        IPF=IPFULL(IRREPJ)
C
C     LOOP OVER ORBITALS
C
        DO 2 J=2,NUMJ 
        DO 2 I=1,J-1
         IND=IND+1
         IND1=IPF+(J-1)*NUMJ+I
         DO 3 L=1,NUMSIZ
          A(IND,L)=B(IND1,L)
3        CONTINUE
2       CONTINUE
1      CONTINUE
      ELSE
C
C     IRREP NE 1
C
C     FILL FIRST POINTERS
C
      IP(1)=0
      IPFULL(1)=0
      DO 1001 IRREPJ=1,NIRREP-1
       IRREPI=DIRPRD(IRREP,IRREPJ)
       NUMJ=NUM(IRREPJ)
       NUMI=NUM(IRREPI)
       IPFULL(IRREPJ+1)=IPFULL(IRREPJ)+NUMJ*NUMI
       IF(IRREPI.LT.IRREPJ) THEN
        IP(IRREPJ+1)=IP(IRREPJ)+NUMJ*NUMI
       ELSE
        IP(IRREPJ+1)=IP(IRREPJ)
       ENDIF
1001  CONTINUE
C
C     NOW LOOP OVER ALL IRREPS
C
      DO 1002 IRREPJ=1,NIRREP
      IRREPI=DIRPRD(IRREPJ,IRREP)
      IF(IRREPI.LT.IRREPJ) THEN
C
       NUMJ=NUM(IRREPJ)
       NUMI=NUM(IRREPI)
C
       IPNEW=IP(IRREPJ)
       IPJ=IPFULL(IRREPJ)
C
C      LOOP OVER ORBITALS
C
       DO 1003 J=1,NUMJ
        DO 1003 I=1,NUMI
         IND=IPNEW+(J-1)*NUMI+I
         IND1=IPJ+(J-1)*NUMI+I
         DO 1004 L=1,NUMSIZ
          A(IND,L)=B(IND1,L)
1004     CONTINUE
1003   CONTINUE
      ENDIF
1002  CONTINUE
      ENDIF
C
C    ALL DONE
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork0444(y, x1,
     *                     ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,
     *                     e1,e2,f1,f2,g1,g2,h1,h2,
     *                     indx1, x2,
     *                     ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,
     *                     i1,i2,j1,j2,k1,k2,l1,l2,
     *                     indx2, flopcount)
c-------------------------------------------------------------------------
c   Performs a "0444" contraction: 
c      0 index output array
c      4 index operand array
c      4 index operand array
c      4 index contraction.
c
c   I. e., contract all 4 indices of the 2nd operand array with the
c   first operand array, storing the result in a scalar. 
c--------------------------------------------------------------------------
      implicit none

      integer ne1,ne2,nf1,nf2,
     *        ng1,ng2,nh1,nh2,
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2
      integer e1,e2,f1,f2,g1,g2,h1,h2,
     *        i1,i2,j1,j2,k1,k2,l1,l2
      integer indx1(4), indx2(4), indi, indj
      integer flopcount

      double precision xddot
      double precision y
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2)

      integer ii,ij,ik,il
      integer i, j, k, l, ix(4)
      integer one, n

      flopcount = 0

c---------------------------------------------------------------------------
c   Find which indices of the "x1" operand match the various x2 
c   indices.
c---------------------------------------------------------------------------

      do i = 1, 4
         if (indx1(i) .eq. indx2(1)) ii = i
         if (indx1(i) .eq. indx2(2)) ij = i
         if (indx1(i) .eq. indx2(3)) ik = i
         if (indx1(i) .eq. indx2(4)) il = i
      enddo

      flopcount = 2*(i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(l2-l1+1)

      if (ii .ne. 1 .or.
     *    ij .ne. 2 .or.
     *    ik .ne. 3 .or.
     *    il .ne. 4) then

c--------------------------------------------------------------------------
c   Use mapping array to perform contraction via indirect addressing.
c--------------------------------------------------------------------------

         y = 0.

         do l = l1, l2
            ix(il) = l
         do k = k1, k2
            ix(ik) = k
         do j = j1, j2
            ix(ij) = j 
         do i = i1, i2 
            ix(ii) = i
            y = y + x2(i,j,k,l)*x1(ix(1),ix(2),ix(3),ix(4))
         enddo
         enddo
         enddo
         enddo

      else

c--------------------------------------------------------------------------
c   Indices of x1, x2 line up exactly.  Use optimized contraction loop.
c--------------------------------------------------------------------------

         n = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(l2-l1+1)
         one = 1
         y = xddot(n, x1(i1,j1,k1,l1), one, x2(i1,j1,k1,l1), one)
      endif

      return
      end

      SUBROUTINE MSP_PSB(V, H, SCRATCH, STEP, TBT, TOLRNCE,
     &                   POWEL_DONE, MSPORPSB)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      LOGICAL POWEL_DONE
      CHARACTER*6 MSPORPSB

#include "io_units.par"
#include "fnamelen.par"
#include "jodaflags.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      DIMENSION V(NXM6),H(NXM6*NXM6),SCRATCH(NX*NX),TBT(3*NXM6*NXM6),
     $          STEP(NXM6)
      DATA ONE /1.00D0/
C
C Murtagh-Sargent update. Note that there are conflicting formulas
C MS update. The conflicts are about the scaling factors and I
C doubt that they can cause major problems.
C
      N2 = NXM6 + 1
      N3 = 2*NXM6+1
      N4 = 3*NXM6+1

C SCRATCH(N2) = HDX where H is the Hessian
C SCRATCH(N3) = DG (gradient difference)
C SCRATCH(N4) = (DG - HDX)

      DDXDX  = DDOT(NXM6, STEP, 1, STEP, 1)
      DDXDX2 = DDXDX**2
      DHDXDG = DDOT(NXM6, SCRATCH(N4), 1, SCRATCH(N4), 1)
      DHDXDX = DDOT(NXM6, SCRATCH(N4), 1, STEP, 1)

      IF (MSPORPSB .EQ. "BOFILL") THEN
         IF (DABS(DHDXDG).GT.TOLRNCE.AND.
     &       DABS(DHDXDX).GT.TOLRNCE) THEN
            COEF    = (DHDXDX**2)/(DDXDX*DHDXDG)
            PHI_INT = ONE/DHDXDX
         ELSE
            COEF    = ONE
            PHI_INT = ONE
         END IF
      ELSE IF (MSPORPSB .EQ. "MSP   ") THEN
         PHI_INT =  ONE/DHDXDX
      ELSE IF (MSPORPSB .EQ. "PSB   ") THEN
         PHI_INT = DHDXDX/DDXDX2
      END IF

      N2 = NXM6*NXM6+1
      N3 = NXM6*NXM6+N2
C
C Form (DG - HDX)o(DG - HDX) and put it in SCRATCH(N2)
C
      CALL MODMATMUL(SCRATCH(N2), SCRATCH(N4), SCRATCH(N4), NXM6, 1,
     &               NXM6, NXM6, 1, NXM6)

      IF (MSPORPSB .EQ. "BOFILL") THEN
         CALL ZERO(TBT(N3), NXM6*NXM6)
         CALL DAXPY(NXM6*NXM6, PHI_INT, SCRATCH(N2), 1, TBT(N3), 1)
         CALL DAXPY(NXM6*NXM6, COEF, TBT(N3), 1, H, 1)
      ELSE IF (MSPORPSB .EQ. "MSP   ") THEN
         CALL DAXPY(NXM6*NXM6, PHI_INT, SCRATCH(N2), 1, H,  1)
      END IF

      IF (.NOT. POWEL_DONE .AND. (MSPORPSB .EQ. "PSB   ")) THEN
C        Form DXoDX in TBT(1)
         CALL MODMATMUL(TBT(1),STEP,STEP,NXM6,1,NXM6,NXM6,1,
     &                  NXM6)
C        Form (DG - HDX)DX in TBT(N2)
         CALL MODMATMUL(TBT(N2),SCRATCH(N4),STEP,NXM6,1,NXM6,
     &                  NXM6,1,NXM6)
C        TBT(N3) = TBT(N2)^{trnsp}
         CALL MTRANSP(TBT(N2),TBT(N3),NXM6,NXM6,NXM6,NXM6)
C        TBT(N3) = (DG - HDX)DX + ((DG - HDX)DX)^{trnsp}
         CALL VADD(TBT(N3),TBT(N3),TBT(N2),NXM6*NXM6,1.D0)
         CALL DSCAL(NXM6*NXM6, ONE/DDXDX, TBT(N3), 1)
         CALL DAXPY(NXM6*NXM6, -PHI_INT, TBT(1), 1, TBT(N3), 1)
         CALL DAXPY(NXM6*NXM6, ONE, TBT(N3), 1, H, 1)
      END IF

      IF (IFLAGS(1).GE.10) THEN
         IF (MSPORPSB .EQ. "BOFILL") THEN
             Print*, "-----The Bofill updated Hessian-----"
         ELSE IF (MSPORPSB .EQ. "PSB   ")  THEN
             Print*, "-----The PSB updated Hessian-----"
         ELSE IF (MSPORPSB .EQ. "MSP   ") THEN
             Print*, "-----The MSP updated Hessian-----"
         ENDIF
         CALL HESSOUT(H,NXM6,NXM6,0)
      END IF

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__MEMORY_1111_CSGTO
     +
     +                    ( NALPHA,NCOEFF,
     +                      NCGTO1,NCGTO2,NCGTO3,NCGTO4,
     +                      NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                      SHELL1,SHELL2,SHELL3,SHELL4,
     +                      X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,
     +                      ALPHA,CC,
     +                      L1CACHE,NCTROW,
     +
     +                                IMIN,IOPT,
     +                                ZMIN,ZOPT )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__MEMORY_1111_CSGTO
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__MEMORY_1111_BLOCKS
C  DESCRIPTION : This operation calculates the minimum and optimum
C                integer/flp memory needed for evaluating a batch
C                of contracted electron repulsion integrals on up to
C                four different centers involving s- and p-type shells
C                only!
C
C
C                  Input (x = 1,2,3 and 4):
C
C                    NALPHA       =  total # of exponents
C                    NCOEFF       =  total # of contraction coeffs
C                    NCGTOx       =  # of contractions for csh x
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x
C                    SHELLx       =  the shell type for csh x
C                    Xy,Yy,Zy     =  the x,y,z-coordinates for centers
C                                    y = 1,2,3 and 4
C                    ALPHA        =  primitive exponents for csh
C                                    1,2,3,4 in that order
C                    CC           =  contraction coefficient for csh
C                                    1,2,3,4 in that order, for each
C                                    csh individually such that an
C                                    (I,J) element corresponds to the
C                                    I-th primitive and J-th contraction.
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C
C                  Output:
C
C                    IMIN,IOPT    =  minimum/optimum integer memory
C                    ZMIN,ZOPT    =  minimum/optimum flp memory
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC,ATOM12,ATOM34,ATOM23
         LOGICAL     EQUAL12,EQUAL34
         LOGICAL     MEMORY

         INTEGER     I,J,K,L
         INTEGER     IMIN,INEED,IOPT
         INTEGER     L1CACHE,NCTROW
         INTEGER     LCC1,LCC2,LCC3,LCC4
         INTEGER     LEXP1,LEXP2,LEXP3,LEXP4
         INTEGER     MXPRIM,MNPRIM
         INTEGER     NALPHA,NCOEFF
         INTEGER     NCGTO1,NCGTO2,NCGTO3,NCGTO4,NCGTO12,NCGTO34
         INTEGER     NCTR
         INTEGER     NIJ,NKL
         INTEGER     NPGTO1,NPGTO2,NPGTO3,NPGTO4,NPGTO12,NPGTO34
         INTEGER     NXYZ1,NXYZ2,NXYZ3,NXYZ4,NXYZT
         INTEGER     SHELL1,SHELL2,SHELL3,SHELL4,SHELLP,SHELLT
         INTEGER     ZMIN,ZNEED,ZOPT,ZOUT1,ZOUT2

         INTEGER     DUMMYI (1:22)

         DOUBLE PRECISION  X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4

         DOUBLE PRECISION  ALPHA (1:NALPHA)
         DOUBLE PRECISION  CC    (1:NCOEFF)
C
C
C------------------------------------------------------------------------
C
C
C             ...set initial memory values.
C
C
         IMIN = 0
         IOPT = 0
         ZMIN = 0
         ZOPT = 0
C
C
C             ...simulate the cartesian contracted (12|34) batch
C                generation.
C
C
         SHELLP = SHELL1 + SHELL2
         SHELLT = SHELLP + SHELL3 + SHELL4

         ATOM12 = (X1.EQ.X2) .AND. (Y1.EQ.Y2) .AND. (Z1.EQ.Z2)
         ATOM23 = (X2.EQ.X3) .AND. (Y2.EQ.Y3) .AND. (Z2.EQ.Z3)
         ATOM34 = (X3.EQ.X4) .AND. (Y3.EQ.Y4) .AND. (Z3.EQ.Z4)

         ATOMIC = (ATOM12 .AND. ATOM34 .AND. ATOM23)

         IF (ATOMIC .AND. (MOD(SHELLT,2).EQ.1)) THEN
             RETURN
         END IF

         LEXP1 = 1
         LEXP2 = LEXP1 + NPGTO1
         LEXP3 = LEXP2 + NPGTO2
         LEXP4 = LEXP3 + NPGTO3

         LCC1 = 1
         LCC2 = LCC1 + NPGTO1 * NCGTO1
         LCC3 = LCC2 + NPGTO2 * NCGTO2
         LCC4 = LCC3 + NPGTO3 * NCGTO3
C
C
C             ...determine csh equality between center pairs 1,2
C                and 3,4 in increasing order of complexity:
C
C                 centers -> shells -> exponents -> ctr coefficients
C
C
         EQUAL12 = ATOM12

         IF (EQUAL12) THEN
             EQUAL12 =     (SHELL1 .EQ. SHELL2)
     +               .AND. (NPGTO1 .EQ. NPGTO2)
     +               .AND. (NCGTO1 .EQ. NCGTO2)
             IF (EQUAL12) THEN
               K = LEXP1 - 1
               L = LEXP2 - 1
               DO 100 I = 1,NPGTO1
                  EQUAL12 = EQUAL12 .AND. (ALPHA (K+I).EQ.ALPHA (L+I))
  100          CONTINUE
               IF (EQUAL12) THEN
                 K = LCC1 - 1
                 L = LCC2 - 1
                 DO 110 J = 1,NCGTO1
                    IF (EQUAL12) THEN
                      DO 120 I = 1,NPGTO1
                         EQUAL12 = EQUAL12 .AND. (CC (K+I).EQ.CC (L+I))
  120                 CONTINUE
                      K = K + NPGTO1
                      L = L + NPGTO1
                    END IF
  110            CONTINUE
               END IF
             END IF
         END IF

         EQUAL34 = ATOM34

         IF (EQUAL34) THEN
             EQUAL34 =     (SHELL3 .EQ. SHELL4)
     +               .AND. (NPGTO3 .EQ. NPGTO4)
     +               .AND. (NCGTO3 .EQ. NCGTO4)
             IF (EQUAL34) THEN
               K = LEXP3 - 1
               L = LEXP4 - 1
               DO 130 I = 1,NPGTO3
                  EQUAL34 = EQUAL34 .AND. (ALPHA (K+I).EQ.ALPHA (L+I))
  130          CONTINUE
               IF (EQUAL34) THEN
                 K = LCC3 - 1
                 L = LCC4 - 1
                 DO 140 J = 1,NCGTO3
                    IF (EQUAL34) THEN
                      DO 150 I = 1,NPGTO3
                         EQUAL34 = EQUAL34 .AND. (CC (K+I).EQ.CC (L+I))
  150                 CONTINUE
                      K = K + NPGTO3
                      L = L + NPGTO3
                    END IF
  140            CONTINUE
               END IF
             END IF
         END IF
C
C
C             ...calculate relevant data for the [12|34] batch of
C                integrals, such as dimensions, total # of integrals
C                to be expected, etc...
C
C
         NXYZ1  = SHELL1 + SHELL1 + 1
         NXYZ2  = SHELL2 + SHELL2 + 1
         NXYZ3  = SHELL3 + SHELL3 + 1
         NXYZ4  = SHELL4 + SHELL4 + 1

         NXYZT  = NXYZ1 * NXYZ2 * NXYZ3 * NXYZ4

         IF (EQUAL12) THEN
             NPGTO12 = (NPGTO1*(NPGTO1+1))/2
             NCGTO12 = (NCGTO1*(NCGTO1+1))/2
         ELSE
             NPGTO12 = NPGTO1 * NPGTO2
             NCGTO12 = NCGTO1 * NCGTO2
         END IF

         IF (EQUAL34) THEN
             NPGTO34 = (NPGTO3*(NPGTO3+1))/2
             NCGTO34 = (NCGTO3*(NCGTO3+1))/2
         ELSE
             NPGTO34 = NPGTO3 * NPGTO4
             NCGTO34 = NCGTO3 * NCGTO4
         END IF

         NCTR = NCGTO12 * NCGTO34
C
C
C             ...at this point we would determine the IJ and KL
C                exponent pairs necessay to evaluate the cartesian
C                contracted (12|34) batch after a possible screening
C                of the primitives. Since at the moment we do not
C                apply screening for memory determination, we use the
C                complete set of IJ and KL pairs. In any event this
C                will be changed in the future, this is where a memory
C                routine handling the IJ and KL pair determination
C                should be placed.
C
C
         NIJ = NPGTO12
         NKL = NPGTO34

         ZNEED = NPGTO12 + NPGTO34
         INEED = 2 * ZNEED

         IMIN = MAX0 (IMIN,INEED)
         IOPT = MAX0 (IOPT,INEED)
         ZMIN = MAX0 (ZMIN,ZNEED)
         ZOPT = MAX0 (ZOPT,ZNEED)
C
C
C             ...determine minimum and optimum flp needs for the
C                unnormalized cartesian (12|34) contracted batch
C                generation.
C
C
         MEMORY = .TRUE.

         CALL  ERD__1111_DEF_BLOCKS
     +
     +              ( 0,
     +                NPGTO1,NPGTO2,NPGTO3,NPGTO4,
     +                NIJ,NKL,
     +                NCGTO12,NCGTO34,NCTR,
     +                NXYZT,
     +                L1CACHE,NCTROW,
     +                MEMORY,
     +
     +                          ZOUT1,ZOUT2,
     +                          DUMMYI (1),DUMMYI (2),DUMMYI (3),
     +                          MXPRIM,MNPRIM,
     +                          DUMMYI (4) ,DUMMYI (5) ,DUMMYI (6) ,
     +                          DUMMYI (7) ,DUMMYI (8) ,DUMMYI (9) ,
     +                          DUMMYI (10),DUMMYI (11),DUMMYI (12),
     +                          DUMMYI (13),DUMMYI (14),DUMMYI (15),
     +                          DUMMYI (16),DUMMYI (17),DUMMYI (18),
     +                          DUMMYI (19),DUMMYI (20),DUMMYI (21),
     +                          DUMMYI (22) )
     +
     +
         INEED = INEED + 2 * MXPRIM + MNPRIM

         IMIN = MAX (IMIN,INEED)
         IOPT = MAX (IOPT,INEED)
         ZMIN = MAX (ZMIN,ZOUT1)
         ZOPT = MAX (ZOPT,ZOUT2)
C
C
C             ...determine the integer/flp memory needs for the next
C                steps:
C
C                1) expanding the contraction indices (if any)
C                2) reordering the contraction indices (if any)
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                         |  Zone 1  |  Zone 2  |
C
C
C                 Zone 1 and 2:  2 batches of final (12|34) size
C
C
         NCTR = NCGTO1 * NCGTO2 * NCGTO3 * NCGTO4

         ZNEED = 2 * NCTR * NXYZT

         ZMIN = MAX0 (ZMIN,ZNEED)
         ZOPT = MAX0 (ZOPT,ZNEED)
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine corchr(cnick,iatnr,nelecp,natoms)

      implicit double precision (a-h,o-z)
c
c --- <corchr> reads the number of core-electrons from the
c ---          file ECPDATA
c
c     cnick    : nicknames of ecp's        (input)
c     iatr     : atomic number of atoms    (input)
c     nelecp   : number of core electrons  (output)
c     natoms   : number of atoms in ZMAT   (input)
c
      character*80 filnam,zeile
      character*80 cnick(natoms)
      dimension nelecp(natoms),iatnr(natoms)
c
c-----------------------------------------------------------------------
c     ecp data:
c-----------------------------------------------------------------------
      iunit=99
      filnam='ECPDATA'
c-----------------------------------------------------------------------
c
c     --- now we are ready for reading
c
      lenfil=index(filnam,' ')-1
      open(unit=iunit,file=filnam(1:lenfil),form='formatted')
      do 400 iecp=1,natoms
        call getstr(iunit,1,igotit,zeile,cnick(iecp))
c --- check if atom has no ecp!
        indi=index(cnick(iecp),'NONE')
c --- or is a dummyatom!
        if (indi.ge.1.or.iatnr(iecp).lt.1) then
          nelecp(iecp)=0
          goto 400
        endif              
c
        if(igotit.le.0) then
          write(6,4091) cnick(iecp),filnam(1:lenfil)
 4091     format(/,1x,' ECPGET ABEND : ECP SET WITH NICKNAME ',A,/,
     1             1x,' IS NOT CONTAINED WITHIN FILE ',A,/)
          goto 999
        endif
c
  11    call getstr(iunit,-1,ifound,zeile,'*')
c     '*' has to be the first character in the line :
        if(ifound.gt.1) goto 11
        if(ifound.gt.0) call rdcchr(iunit,nelecp(iecp),igotit)
c
        if(igotit.le.0.or.ifound.le.0) then
          write(6,4092) cnick(iecp)
 4092     format(/,1x,' ecpget abend : ecp set with nickname ',a,/,
     1             1x,' cannot be read in properly ',/)
          goto 999
        endif
c
  400 continue
c
      close(iunit)
      return
c
  999 continue
      write(6,901)
  901 format(/,1x,' <CORCHR> : CANNOT ASSIGN ECP DATA ',/)
      close(iunit)
      CALL ERREX
      end

      SUBROUTINE PUTLST(ZLIST,NFIRST,NBLOCK,USECXN,ISPIN,ITYPE)
C
C THIS SUBROUTINE RETRIEVES NBLOCK DISTRIBUTIONS OF A PARTICULAR INTEGRA
C  LIST, BEGINNING WITH DISTRIBUTION NFIRST.  THE VALUES ARE RETURNED IN
C  VECTOR ZLIST.
C
C   OUTPUT:
C
C         ZLIST - THE TARGET VECTOR USED IN I/O OPERATIONS.
C
C   INPUT PARAMETERS:
C
C         NFIRST- THE NUMBER OF THE FIRST DISTRIBUTION WHICH WILL BE
C                 WRITTEN TO OR READ FROM DISK.
C         NBLOCK- THE NUMBER OF DISTRIBUTIONS WHICH WILL BE HANDLED.
C         USECIN- THE CACHE BUFFER WHICH IS TO BE USED FOR I/O OPERATION
C                 BEST PERFORMANCE IS ACHIEVED IF THIS IS SET TO 1 FOR
C                 T AMPLITUDE I/O AND 2 FOR INTEGRAL I/O.
C         ISPIN - THE LEFT-HAND INDEX OF THE LIST [MOIO(ISPIN,ITYPE)].
C         ITYPE - THE RIGHT-HAND INDEX OF THE LIST [MOIO(ISPIN,ITYPE)].
C
C  MOIO PARAMETERS (FROM COMMON BLOCK /LISTS/):
C
C        >>>ALL OF THESE VALUES ARE COMPUTED BY ROUTINE UPDMOI<<<
C
C         MOIO(ISPIN,ITYPE)  - THE PHYSICAL RECORD NUMBER ON WHICH
C                              LIST ITYPE[ISPIN] BEGINS.
C         MOIOWD(ISPIN,ITYPE)- THE WORD ADDRESS AT WHICH LIST
C                              ITYPE[ISPIN] BEGINS.
C         MOIODS(ISPIN,ITYPE)- THE NUMBER OF TOTAL DISTRIBUTIONS
C                              IN LIST ITYPE[ISPIN].
C         MOIOSZ(ISPIN,ITYPE)- THE SIZE OF THE INDIVIDUAL DISTRIBUTIONS
C                              IN LIST ITYPE[ISPIN] (IN *FLOATING-POINT*
C                              WORDS.
C         MOIOFL(ISPIN,ITYPE)- THE FILE ON WHICH THE LIST RESIDES.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DIMENSION ZLIST(1)
      COMMON / / ICORE(1)
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /FILES/ LUOUT,MOINTS
      COMMON /FILSPC/ ILNBUF,IPRCLN,IPRCWD
      COMMON /IOPOS/ ICRSIZ,ICHCSZ,IOFFX(2),LENREC
      COMMON /FLAGS/ IFLAGS(100)
      COMMON /AUXCACHE/ QUIKGET(10,500)
C
cjp
#include "bwcc.com"
      if(bwgossip) write(6,*)'debug PUTLST iref',iref,' : ',
     +         nfirst,nblock,usecxn,ispin,itype,' file: '
     +    ,moiofl(ispin,itype)
      IF(QUIKGET(ISPIN,ITYPE).NE.0)THEN
       CALL PUTFAST(ZLIST,NFIRST,NBLOCK,ISPIN,ITYPE)
       RETURN
      ENDIF
C
C MAKE SURE THAT THE LAST DISTRIBUTION REQUESTED IS NOT BEYOND THE
C  END OF THE LIST.
C
      IF(NFIRST+NBLOCK-1.GT.MOIODS(ISPIN,ITYPE))THEN
       WRITE(LUOUT,2000)ISPIN,ITYPE,NFIRST+NBLOCK-1,MOIODS(ISPIN,ITYPE)
2000   FORMAT(T3,'@PUTLST-F, Error reading list [',I2,',',I3,']',/,
     &        T3,'           Distribution ',I9,' requested, but ',
     &           'only ',I9,' are available.')
       CALL ERREX
      ENDIF
C
C DETERMINE WHICH FILE THIS LIST LIVES ON
C
      FILE=MOIOFL(ISPIN,ITYPE)
C
C COMPUTE THE NUMBER OF WORDS ASKED FOR.
C
      NWORDS=NBLOCK*MOIOSZ(ISPIN,ITYPE)*IINTFP
C
C FIND ADDRESS OF THE FIRST ELEMENT OF THE LIST.
C
      NRECST=MOIO(ISPIN,ITYPE)
      NWRDST=MOIOWD(ISPIN,ITYPE)
C
C FIND WORD OFFSET TO THE FIRST ELEMENT THAT WE WANT.
C
      NRECF=NRECST
      NOFFF=(NFIRST-1)*MOIOSZ(ISPIN,ITYPE)*IINTFP
      NWRDF=NWRDST+NOFFF
      IF(NWRDF.GT.IPRCWD)THEN
       INCREM=(NWRDF-1)/IPRCWD
       NWRDF=NWRDF-IPRCWD*INCREM
       NRECF=NRECST+INCREM
      ENDIF
C
C LOOP OVER THE RECORDS WHICH ARE TO CONTAIN THE DISTRIBUTIONS IN ZLIST
C  AND DUMP THEM.
C
      IREC=NRECF
      IOFF=1
1     NGET=MIN(NWORDS,IPRCWD-NWRDF+1)
cjp debug
c	if(bwgossip.and.ioff.gt.1) write(6,*)'putlst more phys records'
      CALL DUMP(ZLIST(IOFF),FILE,IREC,NWRDF,NGET)
      IREC=IREC+1
      NWORDS=NWORDS-NGET
      NWRDF=1
      IOFF=IOFF+NGET
      IF(NWORDS.NE.0)GOTO 1
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__2D_DERV_ABCD_INTEGRALS
     +
     +                    ( SHELLA,SHELLB,SHELLC,SHELLD,
     +                      DERA,DERB,DERC,DERD,
     +                      NGQEXQ,
     +                      EXP2A,EXP2B,EXP2C,EXP2D,
     +                      INT2D,
     +
     +                               OUT2D )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__2D_DERV_ABCD_INTEGRALS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This operation performs a single derivation step on
C                the input 2D ABCD integrals:
C
C         I'(n,a,b,c,d) = delta (DERA,1) *
C                         [-a*I(n,a-1,b,c,d) + 2*expa(n)*I(n,a+1,b,c,d)]
C                       + delta (DERB,1) *
C                         [-b*I(n,a,b-1,c,d) + 2*expb(n)*I(n,a,b+1,c,d)]
C                       + delta (DERC,1) *
C                         [-c*I(n,a,b,c-1,d) + 2*expc(n)*I(n,a,b,c+1,d)]
C                       + delta (DERD,1) *
C                         [-d*I(n,a,b,c,d-1) + 2*expd(n)*I(n,a,b,c,d+1)]
C
C                and returns the result in a separate array.
C
C                The derivatives of the 2D integrals are calculated for
C                all roots and the present set of exponent quadruplets.
C                The values of DERA,DERB,DERC and DERD can be only 1
C                or 0. A set of 1's among these variables indicates
C                that these centers were identified as equal.
C
C
C                  Input:
C
C                    SHELLx      =  maximum shell type for centers
C                                   x = A,B,C,D after differentiation
C                    DERx        =  indicator, if differentiation is
C                                   to be performed with respect to
C                                   centers x = A,B,C,D. Two possible
C                                   values: 0 = no differentiation,
C                                   1 = differentiate, i.e. d/dx
C                    NGQEXQ      =  product of # of gaussian quadrature
C                                   points times exponent quadruplets
C                    EXP2x       =  the NGQEXQ exponents x 2 for all
C                                   centers x = A,B,C,D in the
C                                   appropriate order.
C                    INT2D       =  all input 2D ABCD integrals before
C                                   differentiation.
C
C
C                  Output:
C
C                    OUT2D       =  all differentiated 2D ABCD
C                                   integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT  NONE

         LOGICAL   FIRST

         INTEGER   A,B,C,D,N
         INTEGER   AM,AP,BM,BP,CM,CP,DM,DP
         INTEGER   DERA,DERB,DERC,DERD
         INTEGER   NGQEXQ
         INTEGER   SHELLA,SHELLB,SHELLC,SHELLD

         DOUBLE PRECISION  F
         DOUBLE PRECISION  NEGONE,NEGTWO

         DOUBLE PRECISION  EXP2A (1:NGQEXQ)
         DOUBLE PRECISION  EXP2B (1:NGQEXQ)
         DOUBLE PRECISION  EXP2C (1:NGQEXQ)
         DOUBLE PRECISION  EXP2D (1:NGQEXQ)

         DOUBLE PRECISION  INT2D (1:NGQEXQ,0:SHELLA+DERA,
     +                                     0:SHELLB+DERB,
     +                                     0:SHELLC+DERC,
     +                                     0:SHELLD+DERD)
         DOUBLE PRECISION  OUT2D (1:NGQEXQ,0:SHELLA,
     +                                     0:SHELLB,
     +                                     0:SHELLC,
     +                                     0:SHELLD)
         PARAMETER  (NEGONE = -1.D0)
         PARAMETER  (NEGTWO = -2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...derivative on center A (if any).
C
C
         FIRST = .TRUE.

         IF (DERA.EQ.1) THEN

           IF (SHELLA.EQ.0) THEN

             DO 100 D = 0,SHELLD
             DO 100 C = 0,SHELLC
             DO 100 B = 0,SHELLB
             DO 100 N = 1,NGQEXQ
                OUT2D (N,0,B,C,D) = EXP2A (N) * INT2D (N,1,B,C,D)
  100        CONTINUE

           ELSE IF (SHELLA.EQ.1) THEN

             DO 110 D = 0,SHELLD
             DO 110 C = 0,SHELLC
             DO 110 B = 0,SHELLB
             DO 110 N = 1,NGQEXQ
                OUT2D (N,0,B,C,D) = EXP2A (N) * INT2D (N,1,B,C,D)
                OUT2D (N,1,B,C,D) = EXP2A (N) * INT2D (N,2,B,C,D)
     +                                        - INT2D (N,0,B,C,D)
  110        CONTINUE

           ELSE

             DO 120 D = 0,SHELLD
             DO 120 C = 0,SHELLC
             DO 120 B = 0,SHELLB
                DO 122 N = 1,NGQEXQ
                   OUT2D (N,0,B,C,D) = EXP2A (N) * INT2D (N,1,B,C,D)
                   OUT2D (N,1,B,C,D) = EXP2A (N) * INT2D (N,2,B,C,D)
     +                                           - INT2D (N,0,B,C,D)
  122           CONTINUE
                F = NEGTWO
                DO 124 A = 2,SHELLA
                   AM = A - 1
                   AP = A + 1
                   DO 126 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = EXP2A (N) * INT2D (N,AP,B,C,D)
     +                                          + F * INT2D (N,AM,B,C,D)
  126              CONTINUE
                   F = F + NEGONE
  124           CONTINUE
  120        CONTINUE

           END IF

           FIRST = .FALSE.

         END IF
C
C
C             ...derivative on center B (if any).
C
C
         IF (DERB.EQ.1) THEN

          IF (FIRST) THEN

           IF (SHELLB.EQ.0) THEN

             DO 200 D = 0,SHELLD
             DO 200 C = 0,SHELLC
             DO 200 A = 0,SHELLA
             DO 200 N = 1,NGQEXQ
                OUT2D (N,A,0,C,D) = EXP2B (N) * INT2D (N,A,1,C,D)
  200        CONTINUE

           ELSE IF (SHELLB.EQ.1) THEN

             DO 210 D = 0,SHELLD
             DO 210 C = 0,SHELLC
                DO 212 A = 0,SHELLA
                DO 212 N = 1,NGQEXQ
                   OUT2D (N,A,0,C,D) = EXP2B (N) * INT2D (N,A,1,C,D)
  212           CONTINUE
                DO 214 A = 0,SHELLA
                DO 214 N = 1,NGQEXQ
                   OUT2D (N,A,1,C,D) = EXP2B (N) * INT2D (N,A,2,C,D)
     +                                           - INT2D (N,A,0,C,D)
  214           CONTINUE
  210        CONTINUE

           ELSE

             DO 220 D = 0,SHELLD
             DO 220 C = 0,SHELLC
                DO 222 A = 0,SHELLA
                DO 222 N = 1,NGQEXQ
                   OUT2D (N,A,0,C,D) = EXP2B (N) * INT2D (N,A,1,C,D)
  222           CONTINUE
                DO 224 A = 0,SHELLA
                DO 224 N = 1,NGQEXQ
                   OUT2D (N,A,1,C,D) = EXP2B (N) * INT2D (N,A,2,C,D)
     +                                           - INT2D (N,A,0,C,D)
  224           CONTINUE
                F = NEGTWO
                DO 226 B = 2,SHELLB
                   BM = B - 1
                   BP = B + 1
                   DO 228 A = 0,SHELLA
                   DO 228 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = EXP2B (N) * INT2D (N,A,BP,C,D)
     +                                          + F * INT2D (N,A,BM,C,D)
  228              CONTINUE
                   F = F + NEGONE
  226           CONTINUE
  220        CONTINUE

           END IF

           FIRST = .FALSE.

          ELSE
 
           IF (SHELLB.EQ.0) THEN

             DO 230 D = 0,SHELLD
             DO 230 C = 0,SHELLC
             DO 230 A = 0,SHELLA
             DO 230 N = 1,NGQEXQ
                OUT2D (N,A,0,C,D) = OUT2D (N,A,0,C,D) +
     +                              EXP2B (N) * INT2D (N,A,1,C,D)
  230        CONTINUE

           ELSE IF (SHELLB.EQ.1) THEN

             DO 240 D = 0,SHELLD
             DO 240 C = 0,SHELLC
                DO 242 A = 0,SHELLA
                DO 242 N = 1,NGQEXQ
                   OUT2D (N,A,0,C,D) = OUT2D (N,A,0,C,D) +
     +                                 EXP2B (N) * INT2D (N,A,1,C,D)
  242           CONTINUE
                DO 244 A = 0,SHELLA
                DO 244 N = 1,NGQEXQ
                   OUT2D (N,A,1,C,D) = OUT2D (N,A,1,C,D) +
     +                                 EXP2B (N) * INT2D (N,A,2,C,D)
     +                                           - INT2D (N,A,0,C,D)
  244           CONTINUE
  240        CONTINUE

           ELSE

             DO 250 D = 0,SHELLD
             DO 250 C = 0,SHELLC
                DO 252 A = 0,SHELLA
                DO 252 N = 1,NGQEXQ
                   OUT2D (N,A,0,C,D) = OUT2D (N,A,0,C,D) +
     +                                 EXP2B (N) * INT2D (N,A,1,C,D)
  252           CONTINUE
                DO 254 A = 0,SHELLA
                DO 254 N = 1,NGQEXQ
                   OUT2D (N,A,1,C,D) = OUT2D (N,A,1,C,D) +
     +                                 EXP2B (N) * INT2D (N,A,2,C,D)
     +                                           - INT2D (N,A,0,C,D)
  254           CONTINUE
                F = NEGTWO
                DO 256 B = 2,SHELLB
                   BM = B - 1
                   BP = B + 1
                   DO 258 A = 0,SHELLA
                   DO 258 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = OUT2D (N,A,B,C,D) +
     +                                    EXP2B (N) * INT2D (N,A,BP,C,D)
     +                                          + F * INT2D (N,A,BM,C,D)
  258              CONTINUE
                   F = F + NEGONE
  256           CONTINUE
  250        CONTINUE

           END IF

          END IF

         END IF
C
C
C             ...derivative on center C (if any).
C
C
         IF (DERC.EQ.1) THEN

          IF (FIRST) THEN

           IF (SHELLC.EQ.0) THEN

             DO 300 D = 0,SHELLD
             DO 300 B = 0,SHELLB
             DO 300 A = 0,SHELLA
             DO 300 N = 1,NGQEXQ
                OUT2D (N,A,B,0,D) = EXP2C (N) * INT2D (N,A,B,1,D)
  300        CONTINUE

           ELSE IF (SHELLC.EQ.1) THEN

             DO 310 D = 0,SHELLD
                DO 312 B = 0,SHELLB
                DO 312 A = 0,SHELLA
                DO 312 N = 1,NGQEXQ
                   OUT2D (N,A,B,0,D) = EXP2C (N) * INT2D (N,A,B,1,D)
  312           CONTINUE
                DO 314 B = 0,SHELLB
                DO 314 A = 0,SHELLA
                DO 314 N = 1,NGQEXQ
                   OUT2D (N,A,B,1,D) = EXP2C (N) * INT2D (N,A,B,2,D)
     +                                           - INT2D (N,A,B,0,D)
  314           CONTINUE
  310        CONTINUE

           ELSE

             DO 320 D = 0,SHELLD
                DO 322 B = 0,SHELLB
                DO 322 A = 0,SHELLA
                DO 322 N = 1,NGQEXQ
                   OUT2D (N,A,B,0,D) = EXP2C (N) * INT2D (N,A,B,1,D)
  322           CONTINUE
                DO 324 B = 0,SHELLB
                DO 324 A = 0,SHELLA
                DO 324 N = 1,NGQEXQ
                   OUT2D (N,A,B,1,D) = EXP2C (N) * INT2D (N,A,B,2,D)
     +                                           - INT2D (N,A,B,0,D)
  324           CONTINUE
                F = NEGTWO
                DO 326 C = 2,SHELLC
                   CM = C - 1
                   CP = C + 1
                   DO 328 B = 0,SHELLB
                   DO 328 A = 0,SHELLA
                   DO 328 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = EXP2C (N) * INT2D (N,A,B,CP,D)
     +                                          + F * INT2D (N,A,B,CM,D)
  328              CONTINUE
                   F = F + NEGONE
  326           CONTINUE
  320        CONTINUE

           END IF

           FIRST = .FALSE.

          ELSE

           IF (SHELLC.EQ.0) THEN

             DO 330 D = 0,SHELLD
             DO 330 B = 0,SHELLB
             DO 330 A = 0,SHELLA
             DO 330 N = 1,NGQEXQ
                OUT2D (N,A,B,0,D) = OUT2D (N,A,B,0,D) +
     +                              EXP2C (N) * INT2D (N,A,B,1,D)
  330        CONTINUE

           ELSE IF (SHELLC.EQ.1) THEN

             DO 340 D = 0,SHELLD
                DO 342 B = 0,SHELLB
                DO 342 A = 0,SHELLA
                DO 342 N = 1,NGQEXQ
                   OUT2D (N,A,B,0,D) = OUT2D (N,A,B,0,D) +
     +                                 EXP2C (N) * INT2D (N,A,B,1,D)
  342           CONTINUE
                DO 344 B = 0,SHELLB
                DO 344 A = 0,SHELLA
                DO 344 N = 1,NGQEXQ
                   OUT2D (N,A,B,1,D) = OUT2D (N,A,B,1,D) +
     +                                 EXP2C (N) * INT2D (N,A,B,2,D)
     +                                           - INT2D (N,A,B,0,D)
  344           CONTINUE
  340        CONTINUE

           ELSE

             DO 350 D = 0,SHELLD
                DO 352 B = 0,SHELLB
                DO 352 A = 0,SHELLA
                DO 352 N = 1,NGQEXQ
                   OUT2D (N,A,B,0,D) = OUT2D (N,A,B,0,D) +
     +                                 EXP2C (N) * INT2D (N,A,B,1,D)
  352           CONTINUE
                DO 354 B = 0,SHELLB
                DO 354 A = 0,SHELLA
                DO 354 N = 1,NGQEXQ
                   OUT2D (N,A,B,1,D) = OUT2D (N,A,B,1,D) +
     +                                 EXP2C (N) * INT2D (N,A,B,2,D)
     +                                           - INT2D (N,A,B,0,D)
  354           CONTINUE
                F = NEGTWO
                DO 356 C = 2,SHELLC
                   CM = C - 1
                   CP = C + 1
                   DO 358 B = 0,SHELLB
                   DO 358 A = 0,SHELLA
                   DO 358 N = 1,NGQEXQ
                      OUT2D (N,A,B,C,D) = OUT2D (N,A,B,C,D) +
     +                                    EXP2C (N) * INT2D (N,A,B,CP,D)
     +                                          + F * INT2D (N,A,B,CM,D)
  358              CONTINUE
                   F = F + NEGONE
  356           CONTINUE
  350        CONTINUE

           END IF

          END IF

         END IF
C
C
C             ...derivative on center D (if any).
C
C
         IF (DERD.EQ.1) THEN

          IF (FIRST) THEN

           IF (SHELLD.EQ.0) THEN

             DO 400 C = 0,SHELLC
             DO 400 B = 0,SHELLB
             DO 400 A = 0,SHELLA
             DO 400 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = EXP2D (N) * INT2D (N,A,B,C,1)
  400        CONTINUE

           ELSE IF (SHELLD.EQ.1) THEN

             DO 410 C = 0,SHELLC
             DO 410 B = 0,SHELLB
             DO 410 A = 0,SHELLA
             DO 410 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = EXP2D (N) * INT2D (N,A,B,C,1)
  410        CONTINUE
             DO 412 C = 0,SHELLC
             DO 412 B = 0,SHELLB
             DO 412 A = 0,SHELLA
             DO 412 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = EXP2D (N) * INT2D (N,A,B,C,2)
     +                                        - INT2D (N,A,B,C,0)
  412        CONTINUE

           ELSE

             DO 420 C = 0,SHELLC
             DO 420 B = 0,SHELLB
             DO 420 A = 0,SHELLA
             DO 420 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = EXP2D (N) * INT2D (N,A,B,C,1)
  420        CONTINUE
             DO 422 C = 0,SHELLC
             DO 422 B = 0,SHELLB
             DO 422 A = 0,SHELLA
             DO 422 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = EXP2D (N) * INT2D (N,A,B,C,2)
     +                                        - INT2D (N,A,B,C,0)
  422        CONTINUE
             F = NEGTWO
             DO 424 D = 2,SHELLD
                DM = D - 1
                DP = D + 1
                DO 426 C = 0,SHELLC
                DO 426 B = 0,SHELLB
                DO 426 A = 0,SHELLA
                DO 426 N = 1,NGQEXQ
                   OUT2D (N,A,B,C,D) = EXP2D (N) * INT2D (N,A,B,C,DP)
     +                                       + F * INT2D (N,A,B,C,DM)
  426           CONTINUE
                F = F + NEGONE
  424        CONTINUE

           END IF

          ELSE

           IF (SHELLD.EQ.0) THEN

             DO 430 C = 0,SHELLC
             DO 430 B = 0,SHELLB
             DO 430 A = 0,SHELLA
             DO 430 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = OUT2D (N,A,B,C,0) +
     +                              EXP2D (N) * INT2D (N,A,B,C,1)
  430        CONTINUE

           ELSE IF (SHELLD.EQ.1) THEN

             DO 440 C = 0,SHELLC
             DO 440 B = 0,SHELLB
             DO 440 A = 0,SHELLA
             DO 440 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = OUT2D (N,A,B,C,0) +
     +                              EXP2D (N) * INT2D (N,A,B,C,1)
  440        CONTINUE
             DO 442 C = 0,SHELLC
             DO 442 B = 0,SHELLB
             DO 442 A = 0,SHELLA
             DO 442 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = OUT2D (N,A,B,C,1) +
     +                              EXP2D (N) * INT2D (N,A,B,C,2)
     +                                        - INT2D (N,A,B,C,0)
  442        CONTINUE

           ELSE

             DO 450 C = 0,SHELLC
             DO 450 B = 0,SHELLB
             DO 450 A = 0,SHELLA
             DO 450 N = 1,NGQEXQ
                OUT2D (N,A,B,C,0) = OUT2D (N,A,B,C,0) +
     +                              EXP2D (N) * INT2D (N,A,B,C,1)
  450        CONTINUE
             DO 452 C = 0,SHELLC
             DO 452 B = 0,SHELLB
             DO 452 A = 0,SHELLA
             DO 452 N = 1,NGQEXQ
                OUT2D (N,A,B,C,1) = OUT2D (N,A,B,C,1) +
     +                              EXP2D (N) * INT2D (N,A,B,C,2)
     +                                        - INT2D (N,A,B,C,0)
  452        CONTINUE
             F = NEGTWO
             DO 454 D = 2,SHELLD
                DM = D - 1
                DP = D + 1
                DO 456 C = 0,SHELLC
                DO 456 B = 0,SHELLB
                DO 456 A = 0,SHELLA
                DO 456 N = 1,NGQEXQ
                   OUT2D (N,A,B,C,D) = OUT2D (N,A,B,C,D) +
     +                                 EXP2D (N) * INT2D (N,A,B,C,DP)
     +                                       + F * INT2D (N,A,B,C,DM)
  456           CONTINUE
                F = F + NEGONE
  454        CONTINUE

           END IF

          END IF

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pop_clean_block(iblock, server_table, nserver_table)
c------------------------------------------------------------------------
c   Pops a block off the clean block stack.  Returns iblock = -1 if
c   the stack is empty.
c-------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'parallel_info.h'

      integer iblock, nserver_table
      integer server_table(lserver_table_entry,nserver_table)

      integer i, j, jblock, flagval, ptr

c--------------------------------------------------------------------------
c   Search backwards through the clean block "stack" until we find one that is
c   not busy.  
c--------------------------------------------------------------------------

      iblock = -1

      if (clean_block_ptr .lt. 1) go to 200 

      flagval = or(server_busy_flag, server_dirty_flag)

      do i = clean_block_ptr, 1, -1
         jblock = clean_blocks(i)
         ptr    = server_table_ptr(jblock)
         if (ptr .eq. 0 .or.
     *      (ptr .gt. 0 .and.
     *       and(flagval, server_table(c_server_flags,ptr)) .eq.
     *                           0)) then
            iblock = jblock
            j      = i
            go to 100
         endif
      enddo

c---------------------------------------------------------------------------
c   There are no clean blocks that are not busy.  
c---------------------------------------------------------------------------

      go to 200     

  100 continue

c----------------------------------------------------------------------------
c   Remove iblock from the list of clean blocks.
c----------------------------------------------------------------------------

      do i = j+1, clean_block_ptr
         clean_blocks(i-1) = clean_blocks(i) 
      enddo

      clean_blocks(clean_block_ptr) = 0
      clean_block_ptr = clean_block_ptr - 1
      nclean_blocks = nclean_blocks - 1

  200 continue
      return
      end

#include "flags.h"
      subroutine a2rate_main
      implicit double precision (a-h,o-z)
C
#include "icore.com"
#include "machsp.com"
#include "flags.com"
#include "flags2.com"
#include "istart.com"
C-----------------------------------------------------------------------
      if (iflags(h_IFLAGS_ref).eq.0) iuhf = 0
      maxcor=icrsiz
C
      Call Getrec(20,'JOBARC','NREALATM',1,Nreals)
      Call Getrec(20,'JOBARC','ZMATATMS',1,Natoms)

      iocc   = i0
      iatmMass = iocc + 16
      icoord   = iatmMass + 3*Natoms*iintfp 
      ivgrad   = icoord   + 3*NAtoms*iintfp
      izgrad   = ivgrad   + 3*Nreals*iintfp
      ihess    = izgrad   + 3*Nreals*iintfp
      ifreq    = ihess    + 9*Natoms*Natoms*iintfp
      imap     = ifreq    + 3*Nreals*iintfp
      iord     = imap     + Nreals
      inext    = iord     + Nreals 

      if(inext-i0.gt.maxcor)call insmem('a2rate_main',inext-i0,maxcor)

      call a2rate_wrte(.true.,.true.,.true.,.true.,natoms,nreals,
     &                 icore(iocc),icore(iatmMass),icore(icoord),
     &                 icore(ivgrad),icore(izgrad),icore(ihess),
     &                 icore(ifreq),icore(imap),icore(iord),iuhf)
c ----------------------------------------------------------------------

      return
      end

      subroutine a2rate_main
      implicit double precision (a-h,o-z)
C


c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end







c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end
c flags2.com : begin
      integer         iflags2(500)
      common /flags2/ iflags2
c flags2.com : end
c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end
C-----------------------------------------------------------------------
      if (iflags(11).eq.0) iuhf = 0
      maxcor=icrsiz
C
      Call Getrec(20,'JOBARC','NREALATM',1,Nreals)
      Call Getrec(20,'JOBARC','ZMATATMS',1,Natoms)

      iocc   = i0
      iatmMass = iocc + 16
      icoord   = iatmMass + 3*Natoms*iintfp 
      ivgrad   = icoord   + 3*NAtoms*iintfp
      izgrad   = ivgrad   + 3*Nreals*iintfp
      ihess    = izgrad   + 3*Nreals*iintfp
      ifreq    = ihess    + 9*Natoms*Natoms*iintfp
      imap     = ifreq    + 3*Nreals*iintfp
      iord     = imap     + Nreals
      inext    = iord     + Nreals 

      if(inext-i0.gt.maxcor)call insmem('a2rate_main',inext-i0,maxcor)

      call a2rate_wrte(.true.,.true.,.true.,.true.,natoms,nreals,
     &                 icore(iocc),icore(iatmMass),icore(icoord),
     &                 icore(ivgrad),icore(izgrad),icore(ihess),
     &                 icore(ifreq),icore(imap),icore(iord),iuhf)
c ----------------------------------------------------------------------

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine shells_to_segments(end_nfps, nshells, mx_seg_size,
     *                        segs, nsegs, atom_based, atoms)
c---------------------------------------------------------------------------
c   Fit the shells into index segments, based on the maximum segment size.
c
c   If the "atom_based" flag is .true., we will use a segmentation scheme 
c   that forces the segments to occur on atomic boundaries.  Otherwise,
c   the shells are arranged for most efficient packing within the segment
c   boundaries.
c---------------------------------------------------------------------------
      implicit none
      include 'parallel_info.h'

      integer nshells, mx_seg_size, nsegs
      integer end_nfps(nshells), segs(nshells)
      integer atoms(nshells), last_atom
      logical atom_based

      integer i, ishell, nsh, sum 

      ishell = 1
      nsegs  = 0
      nsh    = end_nfps(1)
      sum = 0
      last_atom = atoms(1)
  100 continue
      if (nsh .gt. mx_seg_size) then
         print *,'Error: Shell ',ishell,' > max. seg. size of ',
     *           mx_seg_size
         print *,'   Shell contains ',nsh,' functions.'
         call abort_job()
	endif

      if (atom_based) then
         if (atoms(ishell) .ne. last_atom) then

c-----------------------------------------------------------------------------
c   This is the boundary of a new atom.  Force a segment at this point.
c-----------------------------------------------------------------------------

            last_atom   = atoms(ishell)   ! thsi is the atom for the next seg.
            ishell      = ishell - 1
            nsegs       = nsegs + 1
            segs(nsegs) = end_nfps(ishell) 
            sum         = 0
            go to 150
         endif
      endif

      sum = sum + nsh
      if (sum .gt. mx_seg_size) then
         last_atom   = atoms(ishell)
         ishell      = ishell - 1
         nsegs       = nsegs + 1         ! increment the number of segments
         segs(nsegs) = end_nfps(ishell)  ! set the segment size
         sum         = 0                 ! reset counter
      else if (sum .eq. mx_seg_size) then
         nsegs       = nsegs + 1         ! increment the number of segments
         segs(nsegs) = end_nfps(ishell)  ! set the segment size
         sum         = 0                 ! reset counter
      endif

  150 continue
      ishell    = ishell + 1
      if (ishell .gt. nshells) then
         if (sum .gt. 0) then
            nsegs = nsegs + 1
            segs(nsegs) = end_nfps(nshells)
         endif
         go to 200
      endif
      nsh = end_nfps(ishell) - end_nfps(ishell-1)
      go to 100

  200 continue

      return
      end

      Subroutine Binomial_coefs

      Implicit Double Precision (A-H, O-Z)

#include "ecp.par"
#include "ecp.com"

      Bcoefs(0, 0) = 1.0D0

      Do I1 = 1, 2*Maxang

           J2 = 0
           Bcoefs(I1, J2) = 1.D0

           Do J1 = 2,  I1
              J2 = J2 + 1
              Bcoefs(I1, J2) = Bcoefs(I1-1,J2-1) + Bcoefs(I1-1,J2)
           Enddo

              J2 = J2 + 1
              Bcoefs(I1, J2) = 1.D0

      Enddo

      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine read_list_to_blocks_no_mpi_io(array_table,
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table,  op)
c--------------------------------------------------------------------------
c   Reads block data from a list file and distributes them to their owners.
c   This version does not use MPI_IO.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'blockdata_list.h' 
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k, n
      integer array, index(mx_array_index), nindex, ierr
      integer block, seg(mx_array_index)
      integer blkndx, get_block_number
      integer saveseg(mx_array_index)
      integer*8 indblk, get_block_data_index
      integer stack
      integer f_form_msg_tag
      integer datatag
      integer type, kreq, ireq, nreq
      
      integer desc_msg(2)

      integer my_comm_rank, comm
      integer home, iblk
      integer val1(mx_array_index), val2(mx_array_index)
      double precision x(1)
    
      integer nb, proc, map, company_comm
      integer tag
      integer pst_get_company_comm, pst_get_company_rank
      integer status(MPI_STATUS_SIZE)
      integer iarray

      company_comm    = pst_get_company_comm(me)
      proc  = pst_get_company_rank(me)
      if (proc .eq. 0) then
         call master_list_to_blocks(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, op)
         return
      endif

  100 continue

c---------------------------------------------------------------------------
c   Receive a block_list_array_tag message.  This contains the data for the 
c   next array to be processed.
c---------------------------------------------------------------------------

      if (dbg) print *,'Task ',me,
     *             ' LIST_TO_BLOCKS: wait for array data '

      call mpi_recv(array, 1, mpi_integer, 0,
     *                     block_list_array_tag,
     *                     company_comm, status, ierr)
      if (dbg) print *,'Task ',me,'   Received array message: array = ',
     *          array

c---------------------------------------------------------------------------
c   Check the array data and determine its type.
c---------------------------------------------------------------------------

      if (array .eq. -1) then          ! this is a "quit" signal
         if (dbg) print *,'LIST_TO_BLOCKS: task ',me,
     *               ' completed processing'
         narray_list = 0
         return 
      else if (array .lt. 1 .or. array .gt. narray_table) then  ! out of range
         print *,'Task ',me,' LIST_TO_BLOCKS: received array ',array,
     *      ' which is out of range.'
         call abort_job()
      else
         type = array_table(c_array_type,array)
         if (dbg) print *,'Task ',me,' LIST_TO_BLOCKS: begin array ',
     *         array,' type ',type 
      endif

c---------------------------------------------------------------------------
c   Find the indices of the array block.
c---------------------------------------------------------------------------
       
      if (type .eq. served_array) go to 100   ! master handles this.

      nb = array_table(c_numblks, array)
      map = array_table(c_block_map, array)

      nindex = array_table(c_nindex, array)

c---------------------------------------------------------------------------
c   Pick up the array's indices, and save the current segments of each.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         saveseg(i) = index_table(c_current_seg,index(i))
      enddo

  200 continue

c-------------------------------------------------------------------------
c   Receive a block_descriptor message.  If a descriptor contains a -1,
c   that indicates processing for this array is complete.
c-------------------------------------------------------------------------

      call mpi_recv(desc_msg, 2, MPI_INTEGER,
     *                    0, block_list_descriptor_tag,
     *                    company_comm, status,ierr)

c-------------------------------------------------------------------------
c   Unpack the descriptor message.
c-------------------------------------------------------------------------

         iblk    = desc_msg(1)
         datatag = desc_msg(2)

         if (datatag .eq. -1) then    ! thru with this array
            if (dbg) print *,'Task ',me,' LIST_TO_BLOCKS recvd ',
     *                  ' array complete msg for array ',array
            go to 100
         endif

c-------------------------------------------------------------------------
c   Make sure this is the block's "home" processor.
c-------------------------------------------------------------------------

         home = block_map_table(c_processor, map+iblk-1)
         if (home .ne. proc) then
            print *,'Error: array ',array,' block ',iblk,
     *          ' resides on ',
     *          'proc ',home,' but is being processed on ',me
            call abort_job()
         endif

c-------------------------------------------------------------------------
c   Find the block's memory location.
c-------------------------------------------------------------------------

         blkndx = get_block_number(array, iblk)
         stack  = array_table(c_array_stack,array)
         indblk = get_block_data_index(array, iblk, stack, blkndx, x)
         call get_actual_blocksize(array, iblk, blkndx,
     *              array_table, narray_table,
     *              index_table, nindex_table,
     *              segment_table, nsegment_table, n)

c--------------------------------------------------------------------------
c   Post a recv for the block.
c--------------------------------------------------------------------------

         call mpi_recv(x(indblk), n, mpi_double_precision, 0,
     *                     datatag,
     *                     company_comm, status, ierr)
      go to 200   ! process another block.

      return
      end

      subroutine master_list_to_blocks(array_table, narray_table, 
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, op)
c--------------------------------------------------------------------------
c   Reads the blocks of an array from a list file and distributes them to 
c   their owners.
c   This routine handles the master's role.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'blkmgr.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'saved_data.h'
      include 'blockdata_list.h'
      include 'machine_types.h'
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)

      integer i, j, k, n
      integer array, index(mx_array_index), nindex, ierr
      integer block, seg(mx_array_index)
      integer dblock, dnindex, dseg(mx_array_index)
      integer*8 iscr
      integer*8 indblk
      integer*8 get_block_data_index
      integer stack, blkndx
      integer allocate_scratch_block
      integer type
      
      integer my_comm_rank, comm
      integer home, iblk
      integer val1(mx_array_index), val2(mx_array_index)
      integer dval1(mx_array_index), dval2(mx_array_index)
      integer index_type(mx_array_index)
      integer dindex_type(mx_array_index)
      double precision x(1)
    
      integer nb, proc, map, company_comm
      integer pst_get_company_comm, pst_get_company_rank
      integer list_unit, data_unit, ios
      integer datatag, handle
      integer icall, nrec

      integer request, drequest
      integer msg(len_sip_server_message)
      integer f_form_msg_tag
      integer darray, next_array
      integer tag, nxt, mgr
      integer status(MPI_STATUS_SIZE)
      integer iarray
      logical is_file_open
      logical dist_flag
      integer*8 data_ptr
      integer block_map_lookup

      double precision esum, block_energy

      company_comm    = pst_get_company_comm(me)
      proc  = pst_get_company_rank(me)
      if (proc .ne. 0) then
         print *,'ERROR: master_block_to_list called on non-master'
         call abort_job()
         return
      endif

c---------------------------------------------------------------------------
c   Allocate a scratch block.
c---------------------------------------------------------------------------
   
      ierr = allocate_scratch_block(x, iscr, handle,
     *                                array_table, narray_table,
     *                              index_table, nindex_table,
     *                              block_map_table)
      if (ierr .ne. 0) then
         print *,'Error: Cannot allocate a scratch block'
         call array_block_summary(array_table, narray_table)
         call dump_block_ids()
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Open the files.
c--------------------------------------------------------------------------

      list_unit = 29
      inquire (unit = list_unit, opened=is_file_open)
      if (is_file_open) then
         rewind list_unit
      else
         open (unit = list_unit, file='BLOCK_INDEX',err = 1000, 
     *      iostat=ios, access='SEQUENTIAL', form='UNFORMATTED',
     *      status='OLD')
      endif

      call f_openfile('BLOCKDATA' // char(0), data_unit)
      data_ptr = 0

c---------------------------------------------------------------------------
c   Find the indices of the array.
c---------------------------------------------------------------------------
       
      dist_flag = .false.

      do iarray = 1, narray_list
      esum = 0.
      array = array_list(iarray)
      type  = array_table(c_array_type,array)
      if (dbg) then
         print *,'Task ',me,' LIST_TO_BLOCKS: Reading array ',array,
     *             ' type ',type
         call prt_time('Worker time')
      endif
      if (type .ne. distributed_array .and.
     *    type .ne. served_array) then
         print *,'Error: LIST_TO_BLOCKS array must be either ',
     *           'a distributed or served array.'
         print *,'Array ',array,' has type = ',type
         call abort_job()
      endif

      nb = array_table(c_numblks, array)
      map = array_table(c_block_map, array)
      nindex = array_table(c_nindex, array)

      if (type .eq. served_array) then

c--------------------------------------------------------------------------
c   Set the "prepared" flag in the array_table, indicating that a PREPARE
c   has been executed on this array.
c--------------------------------------------------------------------------

         array_table(c_prepare_flag, array) = 1
      else

c--------------------------------------------------------------------------
c   Send the array signal to each processor in the company.
c--------------------------------------------------------------------------

         do i = 1, my_company_size
            if (i-1 .ne. my_company_rank) then
               call mpi_send(array, 1, MPI_INTEGER, i-1, 
     *                     block_list_array_tag, company_comm,
     *                     status, ierr)
               if (dbg) print *,'Task ',me,' Sent array message to ',
     *               i-1,' array = ',array
            endif
         enddo
      endif

c---------------------------------------------------------------------------
c   Pick up the array's indices, and save the current segments of each.
c---------------------------------------------------------------------------

      do i = 1, nindex
         index(i) = array_table(c_index_array1+i-1,array)
         index_type(i) = index_table(c_index_type, index(i))
      enddo

c-------------------------------------------------------------------------
c   Main processing loop.
c-------------------------------------------------------------------------

      request = MPI_REQUEST_NULL
      drequest = MPI_REQUEST_NULL

      do iblk = 1, nb

c-------------------------------------------------------------------------
c   Read a descriptor record from the BLOCK_INDEX file.
c-------------------------------------------------------------------------

         read (list_unit) darray, dblock, dnindex, n,
     *                       (dindex_type(i),i=1,nindex),
     *                       (dseg(i),i=1,nindex),
     *                       (dval1(i),i=1,nindex),
     *                       (dval2(i),i=1,nindex)

c--------------------------------------------------------------------------
c   Make sure the indices match with respect to number and type.
c--------------------------------------------------------------------------

         ierr = 0
         if (dnindex .ne. nindex) ierr = 1
         do i = 1, nindex
            if (dindex_type(i) .ne. index_type(i)) ierr = 1
         enddo 

c---------------------------------------------------------------------------
c   Make sure the segment values match the segment values on disk.
c---------------------------------------------------------------------------

         do i = 1, nindex
            seg(i) = block_map_table(c_block_map_seg+i-1,map+dblock-1)
            if (seg(i) .ne. dseg(i)) ierr = 1

            call get_index_segment(index(i), seg(i), segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, val1(i), val2(i))
            if (dval1(i) .ne. val1(i)) ierr = 1
            if (dval2(i) .ne. val2(i)) ierr = 1
         enddo

         if (ierr .eq. 1) then
            print *,'Error in LIST_TO_BLOCKS: ',
     *               'Index data does not match data ',
     *              'for current job.'
            print *,'nindex ',nindex,' dnindex ',dnindex
            print *,'index_type: ',(index_type(i),i=1,nindex),
     *               ' dindex_type: ',(dindex_type(i),i=1,nindex)
            print *,'seg: ',(seg(i),i=1,nindex),' dseg ',
     *              (dseg(i),i=1,nindex)
            print *,'val1: ',(val1(i),i=1,nindex),' dval1: ',
     *                (dval1(i),i=1,nindex)
            print *,'val2: ',(val2(i),i=1,nindex),' dval2: ',
     *                (dval2(i),i=1,nindex)
            call abort_job()
         endif

c--------------------------------------------------------------------------
c   Wait for a previous descriptor message to complete.
c--------------------------------------------------------------------------

         if (request .ne. MPI_REQUEST_NULL) 
     *      call mpi_wait(request, status, ierr)

         if (type .eq. distributed_array) then
            home = block_map_table(c_processor, map+dblock-1)
            if (home .ne. proc) then

c--------------------------------------------------------------------------
c   Send a descriptor message to the block's owner.
c--------------------------------------------------------------------------

               datatag = f_form_msg_tag() 

               msg(1) = dblock
               msg(2) = datatag
               call mpi_isend(msg, 2, mpi_integer, home,
     *                     block_list_descriptor_tag,
     *                     company_comm, request, ierr)
            endif
         else

c---------------------------------------------------------------------------
c   Post a PREPARE descriptor to the I/O server.
c---------------------------------------------------------------------------

            mgr = block_map_table(c_processor, map+dblock-1)

            msg(1) = sip_server_prepare
            msg(2) = array
            msg(3) = nindex
            tag    = f_form_msg_tag()
            msg(4) = tag
            msg(5) = current_line
            msg(6) = op(c_server_stat_key)
            nxt = 7 
            do i = 1, mx_array_index
               if (i .le. nindex) then
                  msg(nxt) = index(i)
               else
                  msg(nxt) = 0
               endif
               nxt = nxt + 1
            enddo

            n = 1
            do i = 1, nindex
               call get_index_segment(index(i), seg(i), 
     *                  segment_table, nsegment_table, index_table,
     *                  nindex_table, msg(nxt), msg(nxt+1))
               n = n * (msg(nxt+1)-msg(nxt)+1)
               nxt = nxt + 2
            enddo

            do i = nindex+1, mx_array_index
               msg(nxt)   = 0
               msg(nxt+1) = 0
               nxt = nxt + 2
            enddo

            msg(7) = block_map_lookup(seg, nindex, array,
     *                         array_table(1,array),
     *                         index_table, nindex_table)

            call mpi_isend(msg, len_sip_server_message, mpi_integer,
     *                 mgr, sip_server_message,
     *                 mpi_comm_world, request, ierr)
         endif

c---------------------------------------------------------------------------
c   Read the data block into the scratch area.
c---------------------------------------------------------------------------

         if (drequest .ne. MPI_REQUEST_NULL) 
     *       call mpi_wait(drequest, status, ierr)

c--------------------------------------------------------------------------
c   Send the data in scratch to its owner.
c--------------------------------------------------------------------------

         if (type .eq. distributed_array) then
            dist_flag = .true.
            if (home .eq. proc) then

c--------------------------------------------------------------------------
c   The block is owned by the master.  Simply read it into its block,
c   which should already exist due to a previous CREATE instruction.
c--------------------------------------------------------------------------

               stack = array_table(c_array_stack,array)
               blkndx = block_map_table(c_bmap_blkndx,map+dblock-1)
               indblk = get_block_data_index(array, dblock, stack, 
     *                                       blkndx, x)
c               read (data_unit) (x(indblk+i-1), i=1,n) 
               call f_read_disk(data_unit, data_ptr, x(indblk), n)
               data_ptr = data_ptr + n 

c               call check_orbital_ind(x(indblk),index_type, val1, 
c     *                           val2, nindex) 
               if (dbg) esum = esum + block_energy(x(indblk), n)
            else

c--------------------------------------------------------------------------
c   Disributed array, not owned by master.
c--------------------------------------------------------------------------

c               read (data_unit) (x(iscr+i-1),i=1,n)
               call f_read_disk(data_unit, data_ptr, x(iscr), n)
               data_ptr = data_ptr + n

c               call check_orbital_ind(x(iscr),index_type, val1,
c     *                           val2, nindex)
               if (dbg) esum = esum + block_energy(x(iscr), n)
               call mpi_isend(x(iscr), n, mpi_double_precision, home,
     *                     datatag,
     *                     company_comm, drequest, ierr)
            endif   
         else

c--------------------------------------------------------------------------
c   Served array.
c--------------------------------------------------------------------------

            call f_read_disk(data_unit, data_ptr, x(iscr), n)
            data_ptr = data_ptr + n 
c            call check_orbital_ind(x(iscr),index_type, val1,
c     *                           val2, nindex)
            if (dbg) esum = esum + block_energy(x(iscr), n)
            call mpi_isend(x(iscr), n, mpi_double_precision,
     *                     mgr, tag,
     *                     mpi_comm_world, drequest, ierr)
         endif
      enddo

c--------------------------------------------------------------------------
c   Do the final waits if necessary.
c--------------------------------------------------------------------------

      call mpi_wait(request, status, ierr)
      call mpi_wait(drequest, status, ierr)

      if (dbg) print *,'LIST_TO_BLOCKS array ',array,' at line ',
     *    current_line,' esum ',esum

c---------------------------------------------------------------------------
c   Send a descriptor message with a -1 for the tag as a signal that we are
c   through with the current array.
c---------------------------------------------------------------------------

         if (type .ne. served_array) then
            msg(1) = -1
            msg(2) = -1
            do i = 1, my_company_size
               if (i-1 .ne. me) then
                  call mpi_send(msg, 2, MPI_INTEGER, i-1,
     *                    block_list_descriptor_tag,
     *                    company_comm, status,ierr)
               endif
            enddo
         endif

      enddo   ! iarray

c--------------------------------------------------------------------------
c   Send an array signal with a -1 to each non-server process.
c   This functions as a quit signal.
c--------------------------------------------------------------------------

      msg(1) = -1
      do i = 1, my_company_size
         if (i-1 .ne. me) then
            call mpi_send(msg, 1, MPI_INTEGER, i-1,
     *                    block_list_array_tag,
     *                    company_comm, status,ierr)
            if (dbg) print *,'Task ',me,' Sent quit signal to ',
     *                         i-1
         endif
      enddo

c---------------------------------------------------------------------------
c   Close the files, release the scratch block.
c---------------------------------------------------------------------------

      close(list_unit)
      call f_close_file(data_unit)
      call free_scratch_block(handle) 
      narray_list = 0
      call prt_time('END OF LIST_TO_BLOCKS')
      
      return

 1000 continue
      print *,'Cannot open BLOCK_INDEX or BLOCKDATA files.'
      print *,'I/O status = ',ios
      call abort_job()
      end

      subroutine check_orbital_ind(x,index_type, val1, val2, nindex)
      implicit none
      include 'interpreter.h'
      include 'dropmo.h'
      integer*8 x(*)

      integer nindex
      integer index_type(nindex), val1(nindex), val2(nindex)

      integer i, j, k, next, nzero
      integer orb(4), match(4)
      integer*8 data, save_data
      integer*8 unpackit(4), shift1, shift2, shift3

      logical mismatch, printit

      next = 0

      do i = 1, nindex
         orb(i) = val1(i)
      enddo
 
      shift1 = 2**16

  100 continue
      next = next + 1
      data = x(next)
      save_data = data

      do i = 1, 4
         unpackit(i) = -1
      enddo

      mismatch = .false.
      nzero = 0
      do i = 1, 4
         match(i) = orb(i)
         if (index_type(i) .eq. moindex .or. 
     *       index_type(i) .eq. moaindex) then
            do k = 1, ndropmo_a
               if (orb(i) .eq. modrop_a(k)) then
                  match(i) = 0
                  nzero = nzero + 1
               endif
            enddo
         else if (index_type(i) .eq. mobindex) then
            do k = 1, ndropmo_b
               if (orb(i) .eq. modrop_b(k)) then
                  match(i) = 0
                  nzero = nzero + 1
               endif
            enddo
         endif
      enddo

c      print 101,(orb(k),k=1,4),(match(k),k=1,4),data,nzero
c  101 format(' orb ',4(i4,1x),' match ',4(i4,1x),z16,' nzero ',i4)
 
      if (nzero .eq. 0) then
         unpackit(1) = data - data / shift1 * shift1
         data        = data / shift1
         unpackit(2) = data - data / shift1 * shift1
         data        = data / shift1
         unpackit(3) = data - data / shift1 * shift1
         unpackit(4) = data / shift1
      
         do i = 1, 4
            if (unpackit(i) .ne. match(i) ) mismatch = .true.
         enddo 
      else
         if (save_data .ne. 0) mismatch = .true.
      endif

      if (mismatch) then
         print *,'Error: data mismatch at sample ',(orb(k),
     *           k=1,4)
         print 102,(unpackit(k),k=1,4),(match(k),k=1,4),save_data
  102 format(' data is ',4(i4,1x),' should be ',4(i4,1x),' raw data ',
     *        z16)
      endif

      j = 1
  200 continue
      orb(j) = orb(j) + 1
      if (orb(j) .gt. val2(j)) then
         orb(j) = val1(j)
         j = j + 1
         if (j .gt. nindex) return
         go to 200
      else
        go to 100
      endif

      return
      end

      subroutine calcexcit(erank,efrom,eto,espin,jr,ir,norb)

      implicit none
#include "bwcc.com"
      integer norb,erank,efrom,eto,espin,jr,ir,i,is,erankfrom,erankto
      dimension efrom(maxexcit), eto(maxexcit),espin(maxexcit)
      dimension norb(2)

      erank=0
      if(ir.eq.jr) return

cjp spin loop
      do is=1,2
      erankfrom=erank
      erankto=erank
cjp find all differences in occupations
      do i=1,norb(is)
      if(iocc(i,ir,is).ne.iocc(i,jr,is)) then
          if(iocc(i,ir,is) .eq. 1 ) then
              erankfrom=erankfrom+1
              efrom(erankfrom) = iphnum(i,ir,is)
          else
              erankto=erankto+1
              eto(erankto) = iphnum(i,ir,is)
          endif
      endif
      enddo

      if(erankfrom.ne.erankto) then
         write(6,*) 'inconsistent number of electrons in refs. ',ir,jr
         stop 'inconsistent number of electrons in references'
      endif
cjp sort indices
      if(erankfrom-erank.gt.1) then
         call sortint(erankfrom-erank,efrom(erank+1))
         call sortint(erankfrom-erank,eto(erank+1))
      endif
cjp store spin
      do i=erank+1,erankfrom
      espin(i)=is
      enddo
cjp increase erank
      erank=erankfrom
cjp
      enddo
cjp spin loop

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

C THIS ROUTINE SYMMETRIZES A GIVEN MATRIX A
C
C   A(PQ) = 1/2 ( A(PQ)+A(QP))
C
C WHERE A IS A SYMMETRY PACKED MATRIX AND
C NUM THE CORRESPONDING POPULATION VECTOR
C
C THE SYMMETRIZATION IS HERE COMPLETELY DONE IN PLACE
C
C CODED AUGUST/90 JG

      SUBROUTINE SYMMET2(A,NUM)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(NUM,NUM)

      if (num.lt.2) return

C SYMMETRIZE FIRST HALF OF A
      DO I = 2, NUM
         DO J = 1, I-1
            A(I,J) = 0.5d0*(A(I,J)+A(J,I))
         END DO
      END DO

C FILL SECOND HALF OF A
      DO I = 2, NUM
         DO J = 1, I-1
            A(J,I) = A(I,J)
         END DO
      END DO

      RETURN
      END

      SUBROUTINE DOMORSEZMT(SCRATCH, NOPT, NX, LUOUT)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
C     Maximum number of atoms currently allowed
#include "mxatms.par"
#include "cbchar.com"
#include "coord.com"
C
      DIMENSION SCRATCH(NX*NX)
C
      DO 1452 I = 1, NOPT
C
         IIN = 0
C     
         DO 1453 IJ = 1, NATOMS
C
C NOPTI(I) gives "SQUASHED" position - need unsquashed for connectivity
C
            IK = NOPTI(I) + 6 - 3/NOPTI(I)
            IF(IJ*3 + 1 .EQ. IK) IIN = IK
C
 1453    CONTINUE
C
         IF (IIN .NE. 0) THEN
            IAT = 1 + (IIN - 1)/3
            JAT = NCON(IIN)
            NA = IATNUM(IAT)
            NB = IATNUM(JAT)
C
            CALL MORSEA(NA, NB, A)
C     
            IF(A.EQ.0.D0)THEN
               WRITE(LUOUT,1474)ZSYM(IAT),ZSYM(JAT)
 1474          FORMAT(T3,'@EFOL-I, No Morse constant available',
     &                'for ',A5, '-',A5,'.  Default used.')
            ENDIF
C
C Scale factor calculated from internal coordinates (not
C symmetry coordinate increment)
C
            Z = SCRATCH(NOPT + I)/DSQRT(DFLOAT(NEQ(NOPTI(I)) + 1))
C
            IF (DABS(Z) .GT. 0.75D0) THEN
               WRITE(LUOUT, 7208) VARNAM(IK)
 7208          FORMAT(T3,' NR step for ',A5,' too large.  MANR ',
     &                'scaling not done.')
            ELSE
               CORR = 1.D0 + 1.5D0*A*Z+2.3333333D0*(A*Z)**2
               WRITE(LUOUT, 7201)CORR,VARNAM(IK)
 7201          FORMAT(T3,' MANR scale factor for NR step is ',
     &                F5.3,' for ', A5,'.')
               SCRATCH(NOPT + I) = SCRATCH(NOPT + I)*CORR
            ENDIF
C     
         ENDIF
C
 1452 CONTINUE
C
      RETURN
      END

        SUBROUTINE PIKSR3(N,ARR,NLIST)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION ARR(N),NLIST(N)
        DO J=2,N
           A=ARR(J)
           NLST=NLIST(J)
           DO I=J-1,1,-1
              IF(ARR(I).GE.A)GOTO 10
              ARR(I+1)=ARR(I)
              NLIST(I+1)=NLIST(I)
           END DO
           I=0
   10      ARR(I+1)=A
           NLIST(I+1)=NLST
        END DO
        RETURN
        END

C THIS ROUTINE NEGATES THE FIRST LEN ELEMENTS OF A VECTOR V.

      SUBROUTINE VMINUS(V,LEN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION V(LEN)
      if (len.lt.1) return
      DO I = 1, LEN
         V(I) = -V(I)
      END DO
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c INPUT
c integer IORDER
c char*4  TYPE

c OUTPUT
c double  SYOPS(9*IORDER)
c double  REGREP(9*IORDER*IORDER)
c double  DIST(IORDER,IORDER)
c double  CHAR(IORDER,IORDER)
c integer ISCR(3*IORDER)
c integer IPTR(IORDER,IORDER)
c integer IDEGEN(IORDER)
c char*8  IRRNM(IORDER)
c double  SCR(3)
c double  DSCR(3*IORDER)

c RECORDS
c get TYPE//'PTGP'
c get TYPE//'SYOP'
c put TYPE//'CHAR'
c put TYPE//'DEGN'
c put TYPE//'LABL'
c put TYPE//'NIRX'

      SUBROUTINE CHRTABLE(IORDER,SYOPS,REGREP,DIST,CHAR,ISCR,IPTR,
     &                    IDEGEN,IRRNM,SCR,TYPE,DSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SYOPS(9*IORDER),REGREP(9*IORDER*IORDER)
      DIMENSION DIST(IORDER,IORDER),CHAR(IORDER,IORDER),ISCR(3*IORDER)
      DIMENSION IPTR(IORDER,IORDER),IDEGEN(IORDER)
      CHARACTER*8 IRRNM(IORDER)
      DIMENSION SCR(3)
      CHARACTER*4 TYPE
      DIMENSION DSCR(3*IORDER)

      CHARACTER*4 PTGRP

      COMMON /FLAGS/ IFLAGS(100)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWd

      DATA TOL  /1.D-8/
      DATA TOL2 /1.D-5/

      CALL GETCREC(20,'JOBARC',TYPE//'PTGP',4,PTGRP)

c   o pick an arbitrary point
      SCR(1)=SQRT(3.432)
      SCR(2)=SQRT(4.920)
      SCR(3)=SQRT(13.25626)

c   o read all symmetry operations
      CALL DGETREC(20,'JOBARC',TYPE//'SYOP',IORDER*9,SYOPS)

c   o apply all operations of the group to the reference point
c     (operation N maps the reference atom into atom N)
      IOFFOPS=1
      IOFFREP=1
      DO I=1,IORDER
         CALL XGEMM('N','N',3,1,3,1.d0,SYOPS(IOFFOPS),3,SCR,3,
     &              0.d0,REGREP(IOFFREP),3)
         IOFFREP=IOFFREP+3
         IOFFOPS=IOFFOPS+9
      END DO

c   o sort coordinates to facilitate construction of permutation vector
      DO I=1,IORDER
         ISCR(I)=I
      END DO
      CALL SORT2(REGREP,SCR,ISCR,IORDER)

C NOW COMPUTE PERMUTATION VECTOR WHICH RELATES ALL POSITIONS
C TO THEIR IMAGE UNDER THE TRANSFORMATION

      IOFFOPS=1
      IOFFS=3*IORDER+1
      DO I=1,IORDER
         CALL XGEMM('N','N',3,IORDER,3,1.d0,SYOPS(IOFFOPS),3,REGREP,3,
     &              0.d0,SCR,3)
         CALL SORT2(SCR,SCR(IOFFS),ISCR(IORDER+1),IORDER)
         CALL STPTR(IORDER,ISCR,ISCR(IORDER+1),IPTR(1,I))
         IOFFOPS=IOFFOPS+9
      END DO

c   o construct distance matrix for points in regrep
      CALL ZERO(DIST,IORDER*IORDER)
      DO I=2,IORDER
         DO J=1,I-1
            IOFFI=3*(I-1)+1
            IOFFJ=3*(J-1)+1
            CALL VADD(SCR,REGREP(IOFFI),REGREP(IOFFJ),3,-1.d0)
            X=DNRM2(3,SCR,1)
            DIST(I,J)=X
            DIST(J,I)=X
         END DO
      END DO

c   o diagonalize distance matrix
      CALL DSYEV('V','L',IORDER,DIST,IORDER,SCR,DSCR,3*IORDER,INFO)
      IF (INFO.NE.0) THEN
         WRITE(*,*)
     &        '@CHRTABLE: There was a problem diagonalizing the matrix.'
         CALL ERREX
      END IF
      DO I = 1, IORDER-1
         DO J = I+1, IORDER
            IF ( SCR(I) .LT. SCR(J) ) then
               DTMP   = SCR(I)
               SCR(I) = SCR(J)
               SCR(J) = DTMP
               CALL XDSWAP(IORDER,DIST(1,I),1,DIST(1,J),1)
            END IF
         END DO
      END DO

c   o collect sets of nondegenerate eigenvectors
      XTEST=-9999999.
      IOFF=1
      NIRREP=0
      IDEG=0
      DO I=1,IORDER
         Z=ABS(SCR(I+1)-XTEST)
         XTEST=SCR(I+1)
         IF (Z.GT.TOL.OR.I.EQ.IORDER) THEN
            ILOC1=I-IDEG
            LENGTH=(IDEG+1)*IORDER
            NIRREP=NIRREP+1
C NOW PERMUTE THE ATOMS ACCORDING TO THE PERMUTATION IMPLIED BY THE
C OPERATION AND COMPUTE THE OVERLAP.  THIS IS THE CHARACTER.
            DO IOP=1,IORDER
               IOFF=IORDER
               IPOS=ILOC1
               DO IVEC=1,IDEG+1
                  DO IPOSIN=1,IORDER
                     IPOSOUT=IPTR(IPOSIN,IOP)
                     SCR(IPOSOUT+IOFF)=DIST(IPOSIN,IPOS)
                  END DO
                  IOFF=IOFF+IORDER
                  IPOS=IPOS+1
               END DO
               CHAR(IOP,NIRREP)=XDOT(LENGTH,DIST(1,ILOC1),1,
     &                                      SCR(IORDER+1),1)
               IDEGEN(NIRREP)=IDEG+1
            END DO
            IDEG=0
         ELSE
            IDEG=IDEG+1
         END IF
      END DO

c   o squeeze out redundant irreps
      IRRUNQ=1
      DO I=2,NIRREP
         X=0.
         DO J=1,IRRUNQ
            X=X+XDOT(IORDER,CHAR(1,I),1,CHAR(1,J),1)
         END DO
         IF (ABS(X).LT.TOL2) THEN
            IRRUNQ=IRRUNQ+1
            CALL XDCOPY(IORDER,CHAR(1,I),1,CHAR(1,IRRUNQ),1)
            IDEGEN(IRRUNQ)=IDEGEN(I)
         END IF
      END DO

      WRITE(6,1000)IRRUNQ
1000  FORMAT(T3,'@CHRTABLE-I, There are ',I3,' unique irreducible ',
     &          'representations.')
      IF (IFLAGS(1).GE.1) THEN
         WRITE(6,2000)
2000     FORMAT(T3,'             Expanded character table follows ')
      END IF
      DO I=1,IRRUNQ
         CALL ASSIRR(PTGRP,CHAR(1,I),IDEGEN(I),IRRNM(I)(1:4))
         IF (IFLAGS(1).GE.1) THEN
            WRITE(6,110)I,IRRNM(I)(1:4),IDEGEN(I)
110         FORMAT(T3,' Irrep : ',I3,/,
     &             T3,' Label : ',A ,/,
     &             T3,' Degen : ',I1)
            WRITE(6,'((12F6.3))')(CHAR(J,I),J=1,IORDER)
         END IF
      END DO

      CALL DPUTREC(20,'JOBARC',TYPE//'CHAR',IRRUNQ*IORDER,CHAR)
      CALL IPUTREC(20,'JOBARC',TYPE//'DEGN',IRRUNQ,IDEGEN)
      CALL DPUTREC(20,'JOBARC',TYPE//'LABL',IRRUNQ,IRRNM)
      CALL IPUTREC(20,'JOBARC',TYPE//'NIRX',1,IRRUNQ)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine ecp_to_erd(nfps, iangular, nshells, ispherical,
     *                      erd_index, scalars) 
c-----------------------------------------------------------------------------
c   Using the shell angular momentum and basis function information, this
c   subroutine calculates an array which maps the ACES integral order to 
c   the ERD integral order.  This array may be used to re-order a block 
c   of integrals calculated by the ERD package into a format corresponding
c   to the ACES (VMOL-based) integrals.
c
c   Arguments:
c      nfps		Number of basis functions per shell.
c      iangular		Shell type (based on angular momentum) per shell.
c			(i. e. an S shell = 0, P = 1, etc.)
c      nshells		Number of shells contained in nfps and iangular.
c      ispherical       1 = spherical coordinates, 0 = Cartesian
c      erd_index	An array (output) of nbasis indices.  The ith
c			value of erd_index is the index in the ERD-based 
c        		system corresponding to index "i" in the ACES-based
c			system.
c      scalars          An array (output) of scale factors to adjust the
c                       ERD integrals to match VMOL integrals.
c-----------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'saved_data.h'
c     include 'int_gen_parms.h'

      integer n, nshells, ispherical
      integer nfps(nshells), iangular(nshells)
      integer erd_index(*)
      double precision scalars(*)
      double precision d_scale(5)
      double precision f_scale(7)
      double precision g_scale(9)
      double precision h_scale(11)
      double precision i_scale(13)

      integer istart, iend, ishell
      integer i, j, ierd
      integer nctr, nsh_coords
  
      double precision x_scale(0:6,1:28) 

      common /flags/ iflags
      integer iflags(100)

      Istart = 1
      Ierd   = 1
     
      If (iSpherical .Eq. 1) Then

         d_scale(1) = 1.0d0 / 2.0D0
         d_scale(2) = 1.d0
         d_scale(3) = 1.0d0 /Dsqrt(3.0d0)
         d_scale(4) = 1.0D0
         d_scale(5) = 1.0D0 / 2.0D0

         f_scale(1) = 1.0d0 / Dsqrt(24.0d0)
         f_scale(2) = 1.0d0 / dsqrt(4.0d0)
         f_scale(3) = 1.0d0 / dsqrt(10.0d0)
         f_scale(4) = dsqrt(6.0d0) / dsqrt(10.0d0)
         f_scale(5) = 1.0d0 / dsqrt(10.0d0)
         f_scale(6) = 1.0d0 / dsqrt(4.0d0)
         f_scale(7) = 1.0d0 / dsqrt(24.0d0)

         g_scale(1) = 1.0d0 / dsqrt(192.0d0)
         g_scale(2) = 1.0d0 / dsqrt(24.0d0)
         g_scale(3) = 1.0d0 / dsqrt(84.0d0)
         g_scale(4) = Dsqrt(18.0d0) / dsqrt(84.0d0)
         g_scale(5) = Dsqrt(3.0d0) / dsqrt(35.0D0)
         g_scale(6) = Dsqrt(18.0d0) / dsqrt(84.0d0)
         g_scale(7) = 1.0d0 / dsqrt(84.0d0)
         g_scale(8) = 1.0d0 / dsqrt(24.0d0)
         g_scale(9) = 1.0d0 / dsqrt(192.0d0)

         h_scale(1) = 1.0D0 / dsqrt(1920.0d0)
         h_scale(2) = 1.0d0 / dsqrt(192.0d0)
         h_scale(3) = 1.0d0 / dsqrt(864.0d0)
         h_scale(4) = 1.0d0 / dsqrt(36.0d0)
         h_scale(5) = 1.d0 / dsqrt(63.0d0)
         h_scale(6) = 1.d0 / dsqrt(4.20d0)
         h_scale(7) = 1.0d0 / dsqrt(63.0d0)
         h_scale(8) = 1.0d0 / dsqrt(36.d0)
         h_scale(9) = 1.0d0 / dsqrt(864.0d0)
         h_scale(10) = 1.0d0 / dsqrt(192.0d0)
         h_scale(11) = 1.0D0 / dsqrt(1920.0d0)

         i_scale(1) = 1.0d0 / dsqrt(23040.0d0)
         i_scale(2) = 1.0d0 / dsqrt(1920.0d0)
         i_scale(3) = 1.0d0 / dsqrt(10560.0d0)
         i_scale(4) = 1.0d0 / dsqrt(352.0d0)
         i_scale(5) = 1.0d0 / dsqrt(792.0d0)
         i_scale(6) = 1.0d0 / dsqrt(19.80d0)
         i_scale(7) = 1.0d0 / dsqrt(46.20d0)
         i_scale(8) =  1.0d0 / dsqrt(19.80d0)
         i_scale(9) =  1.0d0 / dsqrt(792.0d0)
         i_scale(10) = 1.0d0 / dsqrt(352.0d0)
         i_scale(11) = 1.0d0 / dsqrt(10560.0d0)
         i_scale(12) = 1.0d0 / dsqrt(1920.0d0)
         i_scale(13) = 1.0d0 / dsqrt(23040.0d0)
C
c--------------------------------------------------------------------------
c   Spherical coordinates.
c--------------------------------------------------------------------------

         do ishell = 1, nshells
            iend = istart + nfps(ishell) - 1

c---------------------------------------------------------------------------
c   Angular momentum of the shell determines the number of shell components.
c---------------------------------------------------------------------------

            nsh_coords = 2 * iangular(ishell) + 1
            nctr      = nfps(ishell) / nsh_coords

            if (nsh_coords .eq. 1) then 
               do i = istart, iend
                  erd_index(ierd) = ierd
                  scalars(ierd)   = 1.d0
                  ierd = ierd + 1
               enddo
            else

c----------------------------------------------------------------------------
c   Calculate indices for all elements of the current shell.
c----------------------------------------------------------------------------
         
            if (iangular(ishell) .eq. 1) then    ! p shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (j-1)*nctr + i - 1
                     scalars(ierd) = 1.d0
                     ierd = ierd + 1
                  enddo
               enddo

            else if (iangular(ishell) .eq. 2) then    ! d shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (j-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do i = 1, nctr
                  do j = 1, nsh_coords
                     scalars(ierd) =  d_scale(j)
                     ierd = ierd + 1
                  enddo
               enddo

            else if (iangular(ishell) .eq. 3) then    ! f shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (j-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do i = 1, nctr
                  do j = 1, nsh_coords
                     scalars(ierd) = f_scale(j)

                     ierd = ierd + 1
                  enddo
               enddo

            else if (iangular(ishell) .eq. 4) then   ! g shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (j-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do i = 1, nctr
                  do j = 1, nsh_coords
                     scalars(ierd) = g_scale(j)

                     ierd = ierd + 1
                  enddo
               enddo

            else if (iangular(ishell) .eq. 5) then   ! h shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (j-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart
               do i = 1, nctr
                  do j = 1, nsh_coords
                     scalars(ierd) = h_scale(j)

                     ierd = ierd + 1
                  enddo
               enddo

            else if (iangular(ishell) .eq. 6) then   ! i shell
               do i = 1, nctr
                  do j = 1, nsh_coords
                     erd_index(ierd) = istart + 
     *                                 (j-1)*nctr + i - 1
                     ierd = ierd + 1
                  enddo
               enddo

               ierd = istart

               do i = 1, nctr
                  do j = 1, nsh_coords
                     scalars(ierd) = i_scale(j)

                     ierd = ierd + 1
                  enddo
               enddo
            else
               print *,'Cannot have shell types > i.'
               call abort_job()
            endif 
C
            Endif

            istart = istart + nfps(ishell)
         enddo

         return

      Else
C
c---------------------------------------------------------------------------
c   Cartesian coordinates.
c---------------------------------------------------------------------------

c --- s-functions --- 
         x_scale(0,1) = 1.0 
c --- p-functions --- 
         do i = 1, 3 
            x_scale(1,i) = 1.0 
         enddo 

c --- d-functions --- 
         x_scale(2,1) = 1.0/dsqrt(3.0d0)  
         x_scale(2,2) = 1.0 
         x_scale(2,3) = 1.0 
         x_scale(2,4) = 1.0/dsqrt(3.0d0)  
         x_scale(2,5) = 1.0 
         x_scale(2,6) = 1.0/dsqrt(3.0d0)  
   
c --- f-functions --- 
         x_scale(3, 1) = 1.0/dsqrt(15.0d0) 
         x_scale(3, 2) = 1.0/dsqrt(3.0d0) 
         x_scale(3, 3) = 1.0/dsqrt(3.0d0) 
         x_scale(3, 4) = 1.0/dsqrt(3.0d0) 
         x_scale(3, 5) = 1.0/dsqrt(1.0d0) 
         x_scale(3, 6) = 1.0/dsqrt(3.0d0) 
         x_scale(3, 7) = 1.0/dsqrt(15.0d0) 
         x_scale(3, 8) = 1.0/dsqrt(3.0d0) 
         x_scale(3, 9) = 1.0/dsqrt(3.0d0) 
         x_scale(3, 10) = 1.0/dsqrt(15.0d0)

c --- g-functions --- 
         x_scale(4, 1) = 1.0/dsqrt(105.0d0) 
         x_scale(4, 2) = 1.0/dsqrt(15.0d0) 
         x_scale(4, 3) = 1.0/dsqrt(15.0d0) 
         x_scale(4, 4) = 1.0/dsqrt(9.0d0) 
         x_scale(4, 5) = 1.0/dsqrt(3.0d0) 
         x_scale(4, 6) = 1.0/dsqrt(9.0d0) 
         x_scale(4, 7) = 1.0/dsqrt(15.0d0) 
         x_scale(4, 8) = 1.0/dsqrt(8.0d0) 
         x_scale(4, 9) = 1.0/dsqrt(3.0d0) 
         x_scale(4, 10) = 1.0/dsqrt(15.0d0) 
         x_scale(4, 11) = 1.0/dsqrt(105.0d0) 
         x_scale(4, 12) = 1.0/dsqrt(15.0d0) 
         x_scale(4, 13) = 1.0/dsqrt(9.0d0) 
         x_scale(4, 14) = 1.0/dsqrt(15.0d0) 
         x_scale(4, 15) = 1.0/dsqrt(105.0d0) 

c --- h-functions --- 
         x_scale(5, 1) = 1.0/dsqrt(945.0d0) 
         x_scale(5, 2) = 1.0/dsqrt(105.0d0) 
         x_scale(5, 3) = 1.0/dsqrt(105.0d0) 
         x_scale(5, 4) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 5) = 1.0/dsqrt(15.0d0) 
         x_scale(5, 6) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 7) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 8) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 9) = 1.0/dsqrt(9.0d0) 
         x_scale(5, 10) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 11) = 1.0/dsqrt(105.0d0) 
         x_scale(5, 12) = 1.0/dsqrt(15.0d0) 
         x_scale(5, 13) = 1.0/dsqrt(9.0d0) 
         x_scale(5, 14) = 1.0/dsqrt(15.0d0) 
         x_scale(5, 15) = 1.0/dsqrt(105.0d0) 
         x_scale(5, 16) = 1.0/dsqrt(945.0d0) 
         x_scale(5, 17) = 1.0/dsqrt(105.0d0) 
         x_scale(5, 18) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 19) = 1.0/dsqrt(45.0d0) 
         x_scale(5, 20) = 1.0/dsqrt(105.0d0) 
         x_scale(5, 21) = 1.0/dsqrt(945.0d0) 

c --- i-functions --- 
         x_scale(6, 1) = 1.0/dsqrt(10395.0d0) 
         x_scale(6, 2) = 1.0/dsqrt(945.0d0) 
         x_scale(6, 3) = 1.0/dsqrt(945.0d0) 
         x_scale(6, 4) = 1.0/dsqrt(315.0d0) 
         x_scale(6, 5) = 1.0/dsqrt(105.0d0) 
         x_scale(6, 6) = 1.0/dsqrt(315.0d0) 
         x_scale(6, 7) = 1.0/dsqrt(225.0d0) 
         x_scale(6, 8) = 1.0/dsqrt(45.0d0) 
         x_scale(6, 9) = 1.0/dsqrt(45.0d0) 
         x_scale(6, 10) = 1.0/dsqrt(225.0d0) 
         x_scale(6, 11) = 1.0/dsqrt(315.0d0) 
         x_scale(6, 12) = 1.0/dsqrt(45.0d0) 
         x_scale(6, 13) = 1.0/dsqrt(27.0d0) 
         x_scale(6, 14) = 1.0/dsqrt(45.0d0) 
         x_scale(6, 15) = 1.0/dsqrt(315.0d0) 
         x_scale(6, 16) = 1.0/dsqrt(945.0d0) 
         x_scale(6, 17) = 1.0/dsqrt(105.0d0) 
         x_scale(6, 18) = 1.0/dsqrt(45.0d0) 
         x_scale(6, 19) = 1.0/dsqrt(45.0d0) 
         x_scale(6, 20) = 1.0/dsqrt(105.0d0) 
         x_scale(6, 21) = 1.0/dsqrt(945.0d0) 
         x_scale(6, 22) = 1.0/dsqrt(10395.0d0) 
         x_scale(6, 23) = 1.0/dsqrt(945.0d0) 
         x_scale(6, 24) = 1.0/dsqrt(315.0d0) 
         x_scale(6, 25) = 1.0/dsqrt(225.0d0) 
         x_scale(6, 26) = 1.0/dsqrt(315.0d0) 
         x_scale(6, 27) = 1.0/dsqrt(945.0d0) 
         x_scale(6, 28) = 1.0/dsqrt(10395.0d0) 


         do ishell = 1, nshells
            iend = istart + nfps(ishell) - 1

c---------------------------------------------------------------------------
c   Angular momentum of the shell determines the number of shell components.
c---------------------------------------------------------------------------

            nsh_coords = (iangular(ishell)+1)*(iangular(ishell)+2)/2
            nctr      = nfps(ishell) / nsh_coords

            if (iangular(ishell) .lt. 2) then 

               do i = 1, nctr
               do j = 1, nsh_coords
                  erd_index(ierd) = istart + (j-1)*nctr + i - 1
                  scalars(ierd)   = 1.d0 
                 ierd = ierd + 1
               enddo
              enddo

            endif 

            if (iangular(ishell) .ge. 2) then 

               do i = 1, nctr
               do j = 1, nsh_coords
                  erd_index(ierd) = istart + (j-1)*nctr + i - 1
                  scalars(ierd)   = x_scale(iangular(ishell),j)  
                  ierd = ierd + 1
               enddo
               enddo

            endif 

            istart = istart + nfps(ishell)
 
         enddo

         return

      Endif

      return
      end

C This routine loads lists into ICORE(I0), increments I0, and decrements
C ICRSIZ. I0 and ICRSIZ do not have to point to the /ISTART/ common
C block, but they must be relative to ICORE(1) in the blank common
C block. The logic is also reentrant, so it will not load lists that are
C already in memory.

#include "disttype.h"

      SUBROUTINE INCOR_GEN(I0,ICRSIZ,IUHF)
      IMPLICIT NONE
      INTEGER I0,ICRSIZ,IUHF
#include "icore.com"
#include "machsp.com"
#include "flags.com"
#include "sympop.com"
      integer           quikget(10,500)
      common /auxcache/ quikget
      integer iLim, iGrp, iFam, nRows, nCols, nDbls, nInts
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols

      IF (IFLAGS(35).EQ.0) RETURN

      IF (IFLAGS(35).EQ.6) THEN
         CALL ACES_AUXCACHE_LDBLK(I0,ICRSIZ,1,10,1,1,500,1)
         RETURN
      END IF

      iLim = 0
      IF (IFLAGS(35).EQ.1) THEN
c      o NOABCD
         iLim=max(iLim,irpdpd(1,h_DistType_Ab)*irpdpd(1,h_DistType_Ai))
         iLim=max(iLim,irpdpd(1,h_DistType_Ab)*irpdpd(1,h_DistType_Ia))
         iLim=max(iLim,irpdpd(1,h_DistType_AB)*irpdpd(1,h_DistType_AI))
         iLim=max(iLim,irpdpd(1,h_DistType_ab)*irpdpd(1,h_DistType_ai))
      ELSE IF (IFLAGS(35).EQ.4) THEN
c      o NOABCI
         iLim=max(iLim,irpdpd(1,h_DistType_AI)*irpdpd(1,h_DistType_ai))
         iLim=max(iLim,irpdpd(1,h_DistType_AI)*irpdpd(1,h_DistType_AI))
         iLim=max(iLim,irpdpd(1,h_DistType_ai)*irpdpd(1,h_DistType_ai))
      ELSE IF (IFLAGS(35).EQ.5) THEN
c      o NOABIJ
         iLim=max(iLim,irpdpd(1,h_DistType_Ij)*irpdpd(1,h_DistType_Ia))
         iLim=max(iLim,irpdpd(1,h_DistType_Ij)*irpdpd(1,h_DistType_Ai))
         iLim=max(iLim,irpdpd(1,h_DistType_IJ)*irpdpd(1,h_DistType_IA))
         iLim=max(iLim,irpdpd(1,h_DistType_ij)*irpdpd(1,h_DistType_ia))
      END IF
      IF (iLim.eq.0) RETURN
      iLim = iintfp*iLim

      do iFam = 1, 500
      do iGrp = 1, 10
         if (quikget(iGrp,iFam).eq.0) then
            nCols = aces_list_cols(iGrp,iFam)
            nRows = aces_list_rows(iGrp,iFam)
            nInts = iintfp*nRows*nCols
            if (0.lt.nInts.and.nInts.le.iLim.and.nInts.lt.iCrSiz) then
c               print *, '@INCOR_GEN: Loading ',iGrp,iFam
               call getlst(icore(i0),1,nCols,1,iGrp,iFam)
               quikget(iGrp,iFam) = i0
               i0     = i0     + nInts
               iCrSiz = iCrSiz - nInts
            end if
         end if
      end do
      end do

      RETURN
      END

C This routine loads lists into ICORE(I0), increments I0, and decrements
C ICRSIZ. I0 and ICRSIZ do not have to point to the /ISTART/ common
C block, but they must be relative to ICORE(1) in the blank common
C block. The logic is also reentrant, so it will not load lists that are
C already in memory.












































      SUBROUTINE INCOR_GEN(I0,ICRSIZ,IUHF)
      IMPLICIT NONE
      INTEGER I0,ICRSIZ,IUHF







c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end



























c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end














c flags.com : begin
      integer        iflags(100)
      common /flags/ iflags
c flags.com : end





c sympop.com : begin
      integer         irpdpd(8,22), isytyp(2,500), id(18)
      common /sympop/ irpdpd,       isytyp,        id
c sympop.com : end


      integer           quikget(10,500)
      common /auxcache/ quikget
      integer iLim, iGrp, iFam, nRows, nCols, nDbls, nInts
      integer  aces_list_rows, aces_list_cols
      external aces_list_rows, aces_list_cols

      IF (IFLAGS(35).EQ.0) RETURN

      IF (IFLAGS(35).EQ.6) THEN
         CALL ACES_AUXCACHE_LDBLK(I0,ICRSIZ,1,10,1,1,500,1)
         RETURN
      END IF

      iLim = 0
      IF (IFLAGS(35).EQ.1) THEN
c      o NOABCD
         iLim=max(iLim,irpdpd(1,13)*irpdpd(1,11))
         iLim=max(iLim,irpdpd(1,13)*irpdpd(1,18))
         iLim=max(iLim,irpdpd(1,19)*irpdpd(1,9))
         iLim=max(iLim,irpdpd(1,20)*irpdpd(1,10))
      ELSE IF (IFLAGS(35).EQ.4) THEN
c      o NOABCI
         iLim=max(iLim,irpdpd(1,9)*irpdpd(1,10))
         iLim=max(iLim,irpdpd(1,9)*irpdpd(1,9))
         iLim=max(iLim,irpdpd(1,10)*irpdpd(1,10))
      ELSE IF (IFLAGS(35).EQ.5) THEN
c      o NOABIJ
         iLim=max(iLim,irpdpd(1,14)*irpdpd(1,18))
         iLim=max(iLim,irpdpd(1,14)*irpdpd(1,11))
         iLim=max(iLim,irpdpd(1,21)*irpdpd(1,16))
         iLim=max(iLim,irpdpd(1,22)*irpdpd(1,17))
      END IF
      IF (iLim.eq.0) RETURN
      iLim = iintfp*iLim

      do iFam = 1, 500
      do iGrp = 1, 10
         if (quikget(iGrp,iFam).eq.0) then
            nCols = aces_list_cols(iGrp,iFam)
            nRows = aces_list_rows(iGrp,iFam)
            nInts = iintfp*nRows*nCols
            if (0.lt.nInts.and.nInts.le.iLim.and.nInts.lt.iCrSiz) then
c               print *, '@INCOR_GEN: Loading ',iGrp,iFam
               call getlst(icore(i0),1,nCols,1,iGrp,iFam)
               quikget(iGrp,iFam) = i0
               i0     = i0     + nInts
               iCrSiz = iCrSiz - nInts
            end if
         end if
      end do
      end do

      RETURN
      END

      Subroutine Write_ecpgrdint_2disk(Ntotatoms, Nint, Ecpgrdint)

      Implicit Double Precision (A-H, O-Z)

      Dimension Ecpgrdint(Ntotatoms, 3, *)

      Ldim = Nint*(Nint+1)/2
      Open(Unit=62, File="decpint.dat", Form="unformatted")
      Rewind(62)

      Write(62) Ntotatoms

#ifdef _DEBUG_LVL0
      Write(6,"(a)") "The ECP deriavative integrals"
      Do Icent = 1, Ntotatoms

         Do Ixyz = 1, 3
            w = 0.0D0
            Write(6, "(a,1X,I4,a,i2)") "Atom: ", Icent, "XYZ :", Ixyz
            Write(6, "(7(1x,F15.7))") (Ecpgrdint(Icent,Ixyz,jj),
     &                                  jj =1, Ldim)
            do jj=1, Ldim
            w = w + Ecpgrdint(Icent,Ixyz,jj)*Ecpgrdint(Icent,Ixyz,jj)
            enddo
            Write(6, "(a,(1x,F20.13))") "The int. check sum = ", w
         Enddo
      Enddo
#endif
      Do Icent = 1, Ntotatoms

         Do Ixyz = 1, 3
            Do I = 1, Nint
               Ecpgrdint(Icent,Ixyz,i*(i+1)/2) = 2.0D0*Ecpgrdint(Icent,
     &                                        Ixyz,i*(i+1)/2)
            Enddo
            Write(62) Nint
            Write(62) (Ecpgrdint(Icent,Ixyz,jj), JJ=1, Ldim)
         Enddo
      Enddo
C
      Close(62)

      Return
      End

cjp for management of multiple moio information for multiple references

      subroutine storemoio
      IMPLICIT INTEGER (A-Z)

#include "lists.com"
#include "bwcc.com"

      iLenMOIO = _MAX_IO_GRPS * _MAX_IO_FAMS
      call icopy(iLenMOIO, moio  (1,1), 1, bwmoio  (1,1,iref), 1)
      call icopy(iLenMOIO, moiowd(1,1), 1, bwmoiowd(1,1,iref), 1)
      call icopy(iLenMOIO, moiosz(1,1), 1, bwmoiosz(1,1,iref), 1)
      call icopy(iLenMOIO, moiods(1,1), 1, bwmoiods(1,1,iref), 1)
      call icopy(iLenMOIO, moiofl(1,1), 1, bwmoiofl(1,1,iref), 1)
      call icopy(iLenMOIO, moiomxsz(1,1), 1, bwmoiomxsz(1,1,iref), 1)
      do i = 1, _MAX_IO_LUNS
         bwpRec(i,iref) = pRec(i) 
         bwiIntOff(i,iref) = iIntOff(i) 
      end do

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine returns the index of the first non-blank character in sz.

#include "iachar.h"

       integer function fnblnk(sz)
       implicit none

       character*(*) sz
       character*1 achar, czSpace, czTab
       integer i, length

       length = len(sz)
       if (length.ne.0) then

          czSpace = achar(_IACHAR_SPACE)
          czTab   = achar(_IACHAR_TAB)

          do i = 1, length
c          o return at the first non-blank character
             if ((sz(i:i).ne.czSpace).and.
     &           (sz(i:i).ne.czTab  )     ) then
                fnblnk = i
                return
             end if
          end do

       end if

       fnblnk = 0
       return
       end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine assign_block(xhandle, x_block, xndx,
     *                      yhandle, y_block, yndx,
     *                      array_table, narray_table, 
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table, 
     *                      scalar_table, nscalar_table,
     *                      address_table, flopcount)
c--------------------------------------------------------------------------
c   Transfers the data elements of block x_block of array xhandle into 
c   block y_block of array yhandle.  The indices of both arrays must
c   match, but need not be in the same order.  If the indices are out of 
c   order, the data is transposed instead of simply moved.
c--------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nscalar_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      double precision scalar_table(nscalar_table)
      integer nsegment_table 
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer*8 address_table(narray_table)
      integer xhandle, yhandle
      integer x_block, y_block 
      integer xndx, yndx
      integer flopcount

      integer nx, ny
      integer nw, nwx, iseg 
      integer yrange1(mx_array_index), yrange2(mx_array_index)
      integer xrange1(mx_array_index), xrange2(mx_array_index)
      integer ydim1(mx_array_index), ydim2(mx_array_index)
      integer xdim1(mx_array_index), xdim2(mx_array_index)
      integer*8 indy, indx, daddr
      integer*8 get_block_data_index
      integer stack
      integer*8 get_index_from_base
      integer get_blkmgr_blocksize
      integer i, j, k
      integer xind(mx_array_index), yind(mx_array_index)
      integer blkmgr_blocksize
      integer xtype, ytype
      integer index, seg, nindex

      logical match, transpose, slice_insert
      logical ysub_lookup(mx_array_index), xsub_lookup(mx_array_index)

      double precision y(1), x(1)
#ifdef ALTIX
      pointer (xptr, x)
      pointer (yptr, y)
#else
      common y, x
#endif
      double precision xval

#ifdef ALTIX
      xptr = dshptr
      yptr = dshptr
#endif

      xtype = array_table(c_array_type, xhandle)
      ytype = array_table(c_array_type, yhandle)

      if (ytype .ne. scalar_value) then

c---------------------------------------------------------------------------
c   Check array indices for slice/insertion operation using subindices.
c   First, check the type of the array table index against that of the 
c   underlying data block.
c---------------------------------------------------------------------------

         nindex = array_table(c_nindex, yhandle)
         if (ytype .eq. static_array) then
            do i = 1, nindex
               yind(i) = array_table(c_index_original+i-1, yhandle)
            enddo
         else
            call get_block_indices(yndx, yind)
         endif

         slice_insert = .false.
         do i = 1, nindex
            index = array_table(c_index_array1+i-1,yhandle)
            if (index_table(c_index_type, index) .eq. subindex .and.
     *          index_table(c_index_type, yind(i)) .ne. subindex) then
               ysub_lookup(i) = .true.
               slice_insert = .true.
            else
               ysub_lookup(i) = .false. 
            endif 
         enddo

         if (xtype .ne. scalar_value) then
            if (xtype .eq. static_array) then
               do i = 1, nindex
                  xind(i) = array_table(c_index_original+i-1,xhandle)
               enddo 
            else
               call get_block_indices(xndx, xind)
            endif

            do i = 1, nindex
               index = array_table(c_index_array1+i-1,xhandle)
               if (index_table(c_index_type, index) .eq. subindex .and.
     *          index_table(c_index_type, xind(i)) .ne. subindex) then
                  xsub_lookup(i) = .true.
                  slice_insert = .true.  
               else
                  xsub_lookup(i) = .false.
               endif
            enddo
         endif   ! xtype .ne. scalar_value

c----------------------------------------------------------------------------
c   Slices and insertions are handled separately by subroutine 
c   slice_insert_block.
c----------------------------------------------------------------------------

         if (slice_insert) then
            call slice_insert_block(xhandle, x_block, xndx,
     *                      yhandle, y_block, yndx,
     *                      array_table, narray_table,
     *                      index_table, nindex_table,
     *                      segment_table, nsegment_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, yind, xind, 
     *                      ysub_lookup, xsub_lookup, ytype, xtype)
            return
         endif
      endif   ! ytype .ne. scalar_value

      if (xtype .eq. scalar_value) then
         i = array_table(c_scalar_index, xhandle)
         xval = scalar_table(i)

         if (ytype .eq. scalar_value) then
         
c--------------------------------------------------------------------------
c   Scalar-to-scalar assignment.
c--------------------------------------------------------------------------
 
            i = array_table(c_scalar_index,yhandle)
            scalar_table(i) = xval
            return
         else

c---------------------------------------------------------------------------
c   Scalar-to-block assignment.  Fill block with copies of xval.
c---------------------------------------------------------------------------

           if (ytype .eq. static_array) then
              daddr = address_table(yhandle)
              indy  = get_index_from_base(daddr, y, 2)
              nindex = array_table(c_nindex, yhandle)
              do i = 1, nindex
                 index = array_table(c_index_array1+i-1,yhandle)
                 seg   = index_table(c_current_seg, index)
                 call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, yrange1(i),
     *                             yrange2(i))
                 ydim1(i) = array_table(c_index_range1+i-1,yhandle)
                 ydim2(i) = array_table(c_index_range2+i-1,yhandle)
              enddo

              if (nindex .eq. 4) then
                 call fill_static_block4(y(indy),yrange1(1),yrange2(1), 
     *                     yrange1(2), yrange2(2),
     *                     yrange1(3), yrange2(3),
     *                     yrange1(4), yrange2(4),
     *                     ydim1(1),ydim2(1),ydim1(2),ydim2(2),
     *                     ydim1(3),ydim2(3),ydim1(4),ydim2(4),xval)
              else if (nindex .eq. 2) then
                 call fill_static_block2(y(indy),yrange1(1),yrange2(1),
     *                     yrange1(2), yrange2(2), 
     *                     ydim1(1),ydim2(1),ydim1(2),ydim2(2),
     *                     xval)
              else
                print *,'Error: assign scalar must have a target ',
     *                  'array of 2 or 4 indices.'
                call abort_job()    
                 
              endif
           else
              stack = array_table(c_array_stack,yhandle)
              call fill_block(yhandle, y_block, stack, yndx, xval)
           endif
           return
         endif 
      endif
 
      nx = array_table(c_nindex, xhandle)
      ny = array_table(c_nindex, yhandle)

      flopcount = 0

c-----------------------------------------------------------------------
c   Match the operand indices with that of the result.
c-----------------------------------------------------------------------

      do i = 1, ny
         yind(i) = array_table(c_index_array1+i-1,yhandle)
      enddo

      do i = 1, nx
         xind(i) = array_table(c_index_array1+i-1,xhandle)
      enddo

      if (ny .lt. nx) then ! VFL 
         
c--------------------------------------------------------------------------
c   Final indices of y must all be of type "index".
c--------------------------------------------------------------------------

         do i = ny+1, nx
            if (index_table(c_index_type, xind(i)) .ne. 
     *                                      simple_index) then
               print *,'Error: Final indices of destination array ',
     *                 'must all be of type index'
               write(6,*) ' Indices of Y:', (yind(k), k=1, ny) 
               write(6,*) ' Indices of X:', (xind(k), k=1, nx) 
               call abort_job() 
            endif
         enddo

         do i = 1, ny
            if (yind(i) .ne. xind(i)) then
               print *,'Error: First ',nx,' indices of arrays must ',
     *             ' match in assign statement'
               call abort_job()
            endif
         enddo
      else if (ny .gt. nx) then ! VFL 
         do i = nx+1, ny
            if (index_table(c_index_type, yind(i)) .ne.
     *                                      simple_index) then
               print *,'Error: Final indices of source array ',
     *                 'must all be of type index'
               write(6,*) ' Indices of Y:', (yind(k), k=1, ny) 
               write(6,*) ' Indices of X:', (xind(k), k=1, nx) 
               call abort_job()
            endif
         enddo

         do i = 1, nx
            if (yind(i) .ne. xind(i)) then
               print *,'Error: First ',ny,' indices of arrays must ',
     *             ' match in assign statement'
               call abort_job()
            endif
         enddo
      else   
         do i = 1, ny
            match = .false.
            do j = 1, nx
               if (yind(i) .eq. xind(j)) match = .true.
            enddo

            if (.not. match) then
               print *,'Error in assign_block: Non-matching indices ',
     *                  ' for arrays ',yhandle,' and ',xhandle 
               print *,'Array ',yhandle,' indices: ',
     *                   (yind(j),j=1,ny)
               print *,'Array ',xhandle,' indices: ',
     *                   (xind(j),j=1,nx)
               call abort_job()
            endif
         enddo
      endif

c--------------------------------------------------------------------------
c   Indices match ok, check for a straight copy or transpose.
c--------------------------------------------------------------------------

      transpose = .false.
      do i = 1, min(nx,ny)
         if (yind(i) .ne. xind(i) .and.
     *       .not. transpose) transpose = .true.
      enddo

      if (transpose .and. (nx .ne. ny)) then ! VFL 
         print *,'Transpose not allowed in assign_block if nx .ne. ny '
         call abort_job()
      endif

c--------------------------------------------------------------------------
c   Pick up the segment ranges, compute block size.
c--------------------------------------------------------------------------

      nw = 1
      do i = 1, ny
         iseg = index_table(c_current_seg,yind(i))
         call get_index_segment(yind(i), iseg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, yrange1(i), yrange2(i))
         nw = nw * (yrange2(i)-yrange1(i)+1)
      enddo

      nwx = 1 
      do i = 1, nx
         iseg = index_table(c_current_seg,xind(i))
         call get_index_segment(xind(i), iseg, segment_table,
     *                          nsegment_table, index_table,
     *                          nindex_table, xrange1(i), xrange2(i))
         nwx = nwx * (xrange2(i)-xrange1(i)+1)
      enddo
      if (nw .ne. nwx) then 
         print *,'Number of elements being transfered in assign block
     *            incorrect', nw, nwx 
         call abort_job()
      endif

      if (ytype .eq. static_array) then
         do i = 1, ny
            ydim1(i) = array_table(c_index_range1+i-1,yhandle) 
            ydim2(i) = array_table(c_index_range2+i-1,yhandle)
         enddo

         daddr = address_table(yhandle)
         indy = get_index_from_base(daddr, y, 2) 
      else
         do i = 1, ny
            ydim1(i) = yrange1(i)
            ydim2(i) = yrange2(i)
         enddo
         stack = array_table(c_array_stack,yhandle)
         indy = get_block_data_index(yhandle, y_block, stack, yndx, y) 
      endif

      if (xtype .eq. static_array) then
         do i = 1, nx
            xdim1(i) = array_table(c_index_range1+i-1,xhandle)
            xdim2(i) = array_table(c_index_range2+i-1,xhandle)
         enddo

         daddr = address_table(xhandle)
         indx = get_index_from_base(daddr, x, 2) 
      else
         do i = 1, nx
            xdim1(i) = xrange1(i)
            xdim2(i) = xrange2(i)
         enddo
         stack = array_table(c_array_stack,xhandle)
         indx = get_block_data_index(xhandle, x_block, stack,
     *                               xndx, x) 
      endif

      if (transpose) then
         if (ny .eq. 4) then
            call transpose_4index(y(indy),
     *                   yrange1(1),yrange2(1), yrange1(2),yrange2(2),
     *                   yrange1(3),yrange2(3), yrange1(4),yrange2(4),
     *                   ydim1(1), ydim2(1),ydim1(2),ydim2(2),
     *                   ydim1(3), ydim2(3),ydim1(4),ydim2(4),
     *                x(indx),   
     *                   xrange1(1),xrange2(1), xrange1(2),xrange2(2),
     *                   xrange1(3),xrange2(3), xrange1(4),xrange2(4),
     *                   xdim1(1), xdim2(1),xdim1(2),xdim2(2),
     *                   xdim1(3), xdim2(3),xdim1(4),xdim2(4),
     *                 yind, xind)
      else if (ny .eq. 3) then
            call transpose_3index(y(indy),
     *                   yrange1(1),yrange2(1), yrange1(2),yrange2(2),
     *                   yrange1(3),yrange2(3), 
     *                   ydim1(1), ydim2(1),ydim1(2),ydim2(2),
     *                   ydim1(3), ydim2(3),
     *                x(indx),
     *                   xrange1(1),xrange2(1), xrange1(2),xrange2(2),
     *                   xrange1(3),xrange2(3), 
     *                   xdim1(1), xdim2(1),xdim1(2),xdim2(2),
     *                   xdim1(3), xdim2(3),
     *                 yind, xind)
      else if (ny .eq. 2) then

c------------------------------------------------------------------------
c   2 index array.
c------------------------------------------------------------------------

            call transpose_2index(y(indy),
     *                yrange1(1),yrange2(1), yrange1(2),yrange2(2),
     *                ydim1(1), ydim2(1),ydim1(2),ydim2(2),
     *                x(indx),
     *                xrange1(1),xrange2(1), xrange1(2),xrange2(2),
     *                xdim1(1), xdim2(1),xdim1(2),xdim2(2),
     *                yind, xind)
      else if (ny .eq. 6) then
            call transpose_6index(y(indy),
     *                   yrange1(1),yrange2(1), yrange1(2),yrange2(2),
     *                   yrange1(3),yrange2(3), yrange1(4),yrange2(4),
     *                   yrange1(5),yrange2(5), yrange1(6),yrange2(6),
     *                   ydim1(1), ydim2(1),ydim1(2),ydim2(2),
     *                   ydim1(3), ydim2(3),ydim1(4),ydim2(4),
     *                   ydim1(5), ydim2(5),ydim1(6),ydim2(6),
     *                x(indx),
     *                   xrange1(1),xrange2(1), xrange1(2),xrange2(2),
     *                   xrange1(3),xrange2(3), xrange1(4),xrange2(4),
     *                   xrange1(5),xrange2(5), xrange1(6),xrange2(6),
     *                   xdim1(1), xdim2(1),xdim1(2),xdim2(2),
     *                   xdim1(3), xdim2(3),xdim1(4),xdim2(4),
     *                   xdim1(5), xdim2(5),xdim1(6),xdim2(6),
     *                 yind, xind) 
         else
            print *,'Error: Incorrect number of indices for assign'
            call abort_job()
         endif
      else    ! .not. transpose
         if (ny .eq. 2) then
            call transpose_2index(y(indy),
     *                yrange1(1),yrange2(1), yrange1(2),yrange2(2),
     *                ydim1(1), ydim2(1),ydim1(2),ydim2(2),
     *                x(indx),
     *                xrange1(1),xrange2(1), xrange1(2),xrange2(2),
     *                xdim1(1), xdim2(1),xdim1(2),xdim2(2),
     *                yind, xind)
         else

c---------------------------------------------------------------------------
c   Straight copy.  Move the block.
c---------------------------------------------------------------------------

            do i = 1, nw
               y(indy+i-1) = x(indx+i-1)
            enddo
         endif
      endif

      return
      end

      subroutine transpose_4index(
     *                y, ya1,ya2,yb1,yb2,yc1,yc2,yd1,yd2,
     *                nya1,nya2,nyb1,nyb2,nyc1,nyc2,nyd1,nyd2,  
     *                x, xa1,xa2,xb1,xb2,xc1,xc2,xd1,xd2,
     *                nxa1,nxa2,nxb1,nxb2,nxc1,nxc2,nxd1,nxd2, 
     *                yind, xind) 
c--------------------------------------------------------------------------
c   Transposes data into from one array into another, using the block 
c   ranges in yrange and xrange.
c--------------------------------------------------------------------------
      implicit none

      integer ya1,ya2,yb1,yb2,yc1,yc2,yd1,yd2
      integer nya1,nya2,nyb1,nyb2,nyc1,nyc2,nyd1,nyd2
      integer xa1,xa2,xb1,xb2,xc1,xc2,xd1,xd2
      integer nxa1,nxa2,nxb1,nxb2,nxc1,nxc2,nxd1,nxd2
      double precision y(nya1:nya2,nyb1:nyb2,nyc1:nyc2,nyd1:nyd2)
      double precision x(nxa1:nxa2,nxb1:nxb2,nxc1:nxc2,nxd1:nxd2)
      integer yind(4), xind(4)

      integer i, j, n
      integer a,b,c,d
      integer xval(4), map(4)

      do i = 1, 4
         do j = 1, 4
            if (yind(i) .eq. xind(j)) map(j) = i
         enddo
      enddo

c--------------------------------------------------------------------------
c   Optimized transposes.
c--------------------------------------------------------------------------


c 1243 
      if (map(1) .eq. 1 .and. map(2) .eq. 2 .and. 
     *    map(3) .eq. 4 .and. map(4) .eq. 3) then
         n = (ya2-ya1+1)*(yb2-yb1+1)
         do d = yd1, yd2
         do c = yc1, yc2
            do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(a,b,d,c)
            enddo
            enddo
         enddo
         enddo
         return
      endif

c 2134 
      if (map(1) .eq. 2 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 4) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(b,a,c,d)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 2143 
      if (map(1) .eq. 2 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 4 .and. map(4) .eq. 3) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(b,a,d,c)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 1432 
      if (map(1) .eq. 1 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(a,d,c,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 1342 
      if (map(1) .eq. 1 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 4 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(a,c,d,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 1432 
      if (map(1) .eq. 1 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(a,d,c,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 1423 
      if (map(1) .eq. 1 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 3) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(a,d,b,c)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 3124 
      if (map(1) .eq. 3 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 4) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(c,a,b,d)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 3142 
      if (map(1) .eq. 3 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 4 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(c,a,d,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 3214 
      if (map(1) .eq. 3 .and. map(2) .eq. 2 .and.
     *    map(3) .eq. 1 .and. map(4) .eq. 4) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(c,b,a,d)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 3241 
      if (map(1) .eq. 3 .and. map(2) .eq. 2 .and.
     *    map(3) .eq. 4 .and. map(4) .eq. 1) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(c,b,d,a)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 3412 
      if (map(1) .eq. 3 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 1 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(c,d,a,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 3421 
      if (map(1) .eq. 3 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 1) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(c,d,b,a)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 4123 
      if (map(1) .eq. 4 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 3) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(d,a,b,c)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 4132 
      if (map(1) .eq. 4 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(d,a,c,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 4213 
      if (map(1) .eq. 4 .and. map(2) .eq. 2 .and.
     *    map(3) .eq. 1 .and. map(4) .eq. 3) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(d,b,a,c)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 4231 
      if (map(1) .eq. 4 .and. map(2) .eq. 2 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 1) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(d,b,c,a)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 4312 
      if (map(1) .eq. 4 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 1 .and. map(4) .eq. 2) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(d,c,a,b)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c 4321 
      if (map(1) .eq. 4 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 1) then
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d) = x(d,c,b,a)
            enddo
         enddo
         enddo
         enddo

         return
      endif

c--------------------------------------------------------------------------
c   Generic 4-dimensional transpose.
c--------------------------------------------------------------------------

      do i = 1, 4
         do j = 1, 4
            if (yind(i) .eq. xind(j)) map(i) = j
         enddo
      enddo

10101 continue
      do d = yd1, yd2
         xval(map(4)) = d 
      do c = yc1, yc2
         xval(map(3)) = c
      do b = yb1, yb2
         xval(map(2)) = b
      do a = ya1, ya2
         xval(map(1)) = a
         y(a,b,c,d) = x(xval(1), xval(2), xval(3), xval(4))
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine transpose_3index(
     *                y, ya1,ya2,yb1,yb2,yc1,yc2,
     *                nya1,nya2,nyb1,nyb2,nyc1,nyc2,  
     *                x, xa1,xa2,xb1,xb2,xc1,xc2,
     *                nxa1,nxa2,nxb1,nxb2,nxc1,nxc2,
     *                yind, xind) 
c--------------------------------------------------------------------------
c   Transposes data into from one array into another, using the block 
c   ranges in yrange and xrange.
c--------------------------------------------------------------------------
      implicit none

      integer ya1,ya2,yb1,yb2,yc1,yc2
      integer nya1,nya2,nyb1,nyb2,nyc1,nyc2
      integer xa1,xa2,xb1,xb2,xc1,xc2
      integer nxa1,nxa2,nxb1,nxb2,nxc1,nxc2
      double precision y(nya1:nya2,nyb1:nyb2,nyc1:nyc2)
      double precision x(nxa1:nxa2,nxb1:nxb2,nxc1:nxc2)
      integer yind(3), xind(3)

      integer i, j, n
      integer a,b,c,d
      integer xval(3), map(3)

      do i = 1, 3
         do j = 1, 3
            if (yind(i) .eq. xind(j)) map(j) = i ! map(i) = j
         enddo
      enddo

c--------------------------------------------------------------------------
c   Optimized transposes.
c--------------------------------------------------------------------------

      if (map(1) .eq. 2 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 3) then
         do c = yc1, yc2
         do b = yb1, yb2
         do a = ya1, ya2
               y(a,b,c) = x(b,a,c)
         enddo
         enddo
         enddo
         return
      endif

      if (map(1) .eq. 1 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 2) then
         do c = yc1, yc2
         do b = yb1, yb2
         do a = ya1, ya2
               y(a,b,c) = x(a,c,b)
         enddo
         enddo
         enddo
         return
      endif

      if (map(1) .eq. 2 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 1) then
         do c = yc1, yc2
         do b = yb1, yb2
         do a = ya1, ya2
               y(a,b,c) = x(b,c,a)
         enddo
         enddo
         enddo
         return
      endif

      if (map(1) .eq. 3 .and. map(2) .eq. 2 .and.
     *    map(3) .eq. 1) then
         do c = yc1, yc2
         do b = yb1, yb2
         do a = ya1, ya2
               y(a,b,c) = x(c,b,a)
         enddo
         enddo
         enddo
         return
      endif

      if (map(1) .eq. 3 .and. map(2) .eq. 1 .and.
     *    map(3) .eq. 2) then
         do c = yc1, yc2
         do b = yb1, yb2
         do a = ya1, ya2
               y(a,b,c) = x(c,a,b)
         enddo
         enddo
         enddo
         return
      endif

      do i = 1, 3
         do j = 1, 3
            if (yind(i) .eq. xind(j)) map(i) = j
         enddo
      enddo

10101 continue
      do c = yc1, yc2
         xval(map(3)) = c
      do b = yb1, yb2
         xval(map(2)) = b
      do a = ya1, ya2
         xval(map(1)) = a
         y(a,b,c) = x(xval(1), xval(2), xval(3))
      enddo
      enddo
      enddo

      return
      end

      subroutine transpose_6index(
     *                y, ya1,ya2,yb1,yb2,yc1,yc2,yd1,yd2,
     *                   ye1,ye2,yf1,yf2,
     *                nya1,nya2,nyb1,nyb2,nyc1,nyc2,nyd1,nyd2,  
     *                nye1,nye2,nyf1,nyf2,
     *                x, xa1,xa2,xb1,xb2,xc1,xc2,xd1,xd2,
     *                   xe1,xe2,xf1,xf2,
     *                nxa1,nxa2,nxb1,nxb2,nxc1,nxc2,nxd1,nxd2, 
     *                nxe1,nxe2,nxf1,nxf2,
     *                yind, xind) 
c--------------------------------------------------------------------------
c   Transposes data into from one array into another, using the block 
c   ranges in yrange and xrange.
c--------------------------------------------------------------------------
      implicit none
      include 'trace.h'

      integer ya1,ya2,yb1,yb2,yc1,yc2,yd1,yd2,ye1,ye2,yf1,yf2
      integer nya1,nya2,nyb1,nyb2,nyc1,nyc2,nyd1,nyd2
      integer nye1,nye2,nyf1,nyf2
      integer xa1,xa2,xb1,xb2,xc1,xc2,xd1,xd2,xe1,xe2,xf1,xf2
      integer nxa1,nxa2,nxb1,nxb2,nxc1,nxc2,nxd1,nxd2
      integer nxe1,nxe2,nxf1,nxf2
      double precision 
     *   y(nya1:nya2,nyb1:nyb2,nyc1:nyc2,nyd1:nyd2,nye1:nye2,nyf1:nyf2)
      double precision 
     *   x(nxa1:nxa2,nxb1:nxb2,nxc1:nxc2,nxd1:nxd2,nxe1:nxe2,nxf1:nxf2)
      integer yind(6), xind(6)

      integer i, j, n
      integer a,b,c,d,e,f
      integer xval(6), map(6), map1, map2, map3, map4, map5, map6 

c--------------------------------------------------------------------------
c   'Optimized' 6-dimensional transpose.
c--------------------------------------------------------------------------

      do i = 1, 6
         do j = 1, 6
            if (yind(i) .eq. xind(j)) map(j) = i
         enddo
      enddo

c 142536  
      if (map(1) .eq. 1 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 5 .and. 
     *    map(5) .eq. 3 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,d,b,e,c,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 152634  
      if (map(1) .eq. 1 .and. map(2) .eq. 5 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 6 .and. 
     *    map(5) .eq. 3 .and. map(6) .eq. 4) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,e,b,f,c,d)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 162534  
      if (map(1) .eq. 1 .and. map(2) .eq. 6 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 5 .and. 
     *    map(5) .eq. 3 .and. map(6) .eq. 4) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,f,b,e,c,d)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 135624  
      if (map(1) .eq. 1 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 5 .and. map(4) .eq. 6 .and. 
     *    map(5) .eq. 2 .and. map(6) .eq. 4) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,c,e,f,b,d)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 341526  
      if (map(1) .eq. 3 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 1 .and. map(4) .eq. 5 .and. 
     *    map(5) .eq. 2 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(c,d,a,e,b,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 123564  
      if (map(1) .eq. 1 .and. map(2) .eq. 2 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 5 .and. 
     *    map(5) .eq. 6 .and. map(6) .eq. 4) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,b,c,e,f,b)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 142536  
      if (map(1) .eq. 1 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 5 .and. 
     *    map(5) .eq. 3 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,d,b,e,c,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 142635  
      if (map(1) .eq. 1 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 6 .and. 
     *    map(5) .eq. 3 .and. map(6) .eq. 5) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,d,b,f,c,e)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 342615  
      if (map(1) .eq. 3 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 6 .and. 
     *    map(5) .eq. 1 .and. map(6) .eq. 5) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(c,d,b,f,a,e)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 342516  
      if (map(1) .eq. 3 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 2 .and. map(4) .eq. 5 .and. 
     *    map(5) .eq. 1 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(c,d,b,e,a,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 341625  
      if (map(1) .eq. 3 .and. map(2) .eq. 4 .and.
     *    map(3) .eq. 1 .and. map(4) .eq. 6 .and. 
     *    map(5) .eq. 2 .and. map(6) .eq. 5) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(c,d,a,f,b,e)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 253416  
      if (map(1) .eq. 2 .and. map(2) .eq. 5 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 4 .and. 
     *    map(5) .eq. 1 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(b,e,c,d,a,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 163425  
      if (map(1) .eq. 1 .and. map(2) .eq. 6 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 4 .and. 
     *    map(5) .eq. 2 .and. map(6) .eq. 5) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,f,c,d,b,e)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 153426  
      if (map(1) .eq. 1 .and. map(2) .eq. 5 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 4 .and. 
     *    map(5) .eq. 2 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,e,c,d,b,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 263415  
      if (map(1) .eq. 2 .and. map(2) .eq. 6 .and.
     *    map(3) .eq. 3 .and. map(4) .eq. 4 .and. 
     *    map(5) .eq. 1 .and. map(6) .eq. 5) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(b,f,c,d,a,e)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 135246  
      if (map(1) .eq. 1 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 5 .and. map(4) .eq. 2 .and. 
     *    map(5) .eq. 4 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,c,e,b,d,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c 135426  
      if (map(1) .eq. 1 .and. map(2) .eq. 3 .and.
     *    map(3) .eq. 5 .and. map(4) .eq. 4 .and. 
     *    map(5) .eq. 2 .and. map(6) .eq. 6) then

         do f = yf1, yf2
         do e = ye1, ye2
         do d = yd1, yd2
         do c = yc1, yc2
         do b = yb1, yb2
            do a = ya1, ya2
               y(a,b,c,d,e,f) = x(a,c,e,d,b,f)
            enddo
         enddo
         enddo
         enddo
         enddo
         enddo

         return
      endif

c--------------------------------------------------------------------------
c   Generic 6-dimensional transpose.
c--------------------------------------------------------------------------

      do i = 1, 6
         do j = 1, 6
            if (yind(i) .eq. xind(j)) map(j) = i
         enddo
      enddo
      map1 = map(1) 
      map2 = map(2) 
      map3 = map(3) 
      map4 = map(4) 
      map5 = map(5) 
      map6 = map(6) 

c     perm 123456 -> abcdef  
      if ((map1.eq.1) .and. (map2.eq.2) .and. (map3.eq.3) .and.  
     *    (map4.eq.4) .and. (map5.eq.5) .and. (map6.eq.6)) then    
      do f = yf1, yf2
      do e = ye1, ye2
      do d = yd1, yd2
      do c = yc1, yc2
      do b = yb1, yb2
      do a = ya1, ya2
         y(a,b,c,d,e,f) = x(a,b,c,d,e,f) 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      endif 

c     perm 213456 -> bacdef  
      if ((map1.eq.2) .and. (map2.eq.1) .and. (map3.eq.3) .and.  
     *    (map4.eq.4) .and. (map5.eq.5) .and. (map6.eq.6)) then    
      do f = yf1, yf2
      do e = ye1, ye2
      do d = yd1, yd2
      do c = yc1, yc2
      do b = yb1, yb2
      do a = ya1, ya2
         y(a,b,c,d,e,f) = x(b,a,c,d,e,f) 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      endif 

c     perm 231456 -> bacdef  
      if ((map1.eq.2) .and. (map2.eq.3) .and. (map3.eq.1) .and.  
     *    (map4.eq.4) .and. (map5.eq.5) .and. (map6.eq.6)) then    
      do f = yf1, yf2
      do e = ye1, ye2
      do d = yd1, yd2
      do c = yc1, yc2
      do b = yb1, yb2
      do a = ya1, ya2
         y(a,b,c,d,e,f) = x(b,c,a,d,e,f) 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      endif 

c     perm 132456 -> bacdef  
      if ((map1.eq.1) .and. (map2.eq.3) .and. (map3.eq.2) .and.  
     *    (map4.eq.4) .and. (map5.eq.5) .and. (map6.eq.6)) then    
      do f = yf1, yf2
      do e = ye1, ye2
      do d = yd1, yd2
      do c = yc1, yc2
      do b = yb1, yb2
      do a = ya1, ya2
         y(a,b,c,d,e,f) = x(a,c,b,d,e,f) 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      endif 

c     perm 312456 -> bacdef  
      if ((map1.eq.3) .and. (map2.eq.1) .and. (map3.eq.2) .and.  
     *    (map4.eq.4) .and. (map5.eq.5) .and. (map6.eq.6)) then    
      do f = yf1, yf2
      do e = ye1, ye2
      do d = yd1, yd2
      do c = yc1, yc2
      do b = yb1, yb2
      do a = ya1, ya2
         y(a,b,c,d,e,f) = x(c,a,b,d,e,f) 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      endif 

c     perm 321456 -> bacdef  
      if ((map1.eq.3) .and. (map2.eq.2) .and. (map3.eq.1) .and.  
     *    (map4.eq.4) .and. (map5.eq.5) .and. (map6.eq.6)) then    
      do f = yf1, yf2
      do e = ye1, ye2
      do d = yd1, yd2
      do c = yc1, yc2
      do b = yb1, yb2
      do a = ya1, ya2
         y(a,b,c,d,e,f) = x(c,b,a,d,e,f) 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      endif 



      write(6,*) 'Unoptimized permutation at line#', current_line 
      write(6,*) ' MAP :', (map(i), i=1, 6) 

      do i = 1, 6
         do j = 1, 6
            if (yind(i) .eq. xind(j)) map(i) = j
         enddo
      enddo
      map1 = map(1) 
      map2 = map(2) 
      map3 = map(3) 
      map4 = map(4) 
      map5 = map(5) 
      map6 = map(6) 

10101 continue
      do f = yf1, yf2
         xval(map6) = f
      do e = ye1, ye2
         xval(map5) = e
      do d = yd1, yd2
         xval(map4) = d 
      do c = yc1, yc2
         xval(map3) = c
      do b = yb1, yb2
         xval(map2) = b
      do a = ya1, ya2
         xval(map1) = a
         y(a,b,c,d,e,f) = x(xval(1), xval(2), xval(3), xval(4), 
     *                      xval(5), xval(6))
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine transpose_2index(
     *                y, ya1,ya2,yb1,yb2,
     *                nya1,nya2,nyb1,nyb2,
     *                x, xa1,xa2,xb1,xb2,
     *                nxa1,nxa2,nxb1,nxb2,
     *                yind, xind) 
c--------------------------------------------------------------------------
c   Transposes data into from one array into another, using the block 
c   ranges in yrange and xrange.
c--------------------------------------------------------------------------
      implicit none

      integer ya1,ya2,yb1,yb2
      integer nya1,nya2,nyb1,nyb2
      integer xa1,xa2,xb1,xb2
      integer nxa1,nxa2,nxb1,nxb2
      double precision y(nya1:nya2,nyb1:nyb2)
      double precision x(nxa1:nxa2,nxb1:nxb2)
      integer yind(2), xind(2)

      integer i, j
      integer a,b,c,d
      integer xval(2), map(2)

      do i = 1, 2
         do j = 1, 2
            if (yind(i) .eq. xind(j)) map(i) = j
         enddo
      enddo

      if (map(1) .eq. 1 .and. map(2) .eq. 2) then
         do b = yb1, yb2
         do a = ya1, ya2
            y(a,b) = x(a,b)
         enddo
         enddo
      else
         do a = ya1, ya2
         do b = yb1, yb2
            y(a,b) = x(b,a)
         enddo
         enddo

      endif

      return
      end

      subroutine fill_static_block4(y, a1,a2,b1,b2,c1,c2,d1,d2,
     *                             na1,na2,nb1,nb2,nc1,nc2,nd1,nd2,
     *                             xval)
      integer a1,a2,b1,b2,c1,c2,d1,d2
      integer na1,na2,nb1,nb2,nc1,nc2,nd1,nd2
      double precision y(na1:na2,nb1:nb2,nc1:nc2,nd1:nd2)
      double precision xval

      integer a,b,c,d

      do d = d1,d2
      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         y(a,b,c,d) = xval
      enddo
      enddo
      enddo
      enddo

      return
      end

      subroutine fill_static_block2(y, a1,a2,b1,b2,
     *                             na1,na2,nb1,nb2,
     *                             xval)
      integer a1,a2,b1,b2
      integer na1,na2,nb1,nb2
      double precision y(na1:na2,nb1:nb2)
      double precision xval

      integer a,b

      do b = b1,b2
      do a = a1,a2
         y(a,b) = xval
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine find_seg(nocci,nvirti,norbi,nproci,o_seg,v_seg,n_seg) 
c
      Implicit none 
      integer nocci, nvirti, norbi, nproci  
      real*8 nocc, nvirt, norb, nproc  

      integer k, nmin, nmax, nb, wb(1000)  
      integer nseg, neff, rem, best, rem_min   
      integer o_seg,v_seg,n_seg 

      nocc = nocci
      nvirt = nvirti
      norb = norbi
      nproc = nproci
c
c norb segmentation
c ----------------- 
c
      nmin = 20 
      nmax = 40 

c----------------------------------------------------------------------------
c   Handle tiny jobs appropriately.
c----------------------------------------------------------------------------

      if (norb .le. nmin) then
         o_seg = norb
         v_seg = norb
         n_seg = norb
         return
      endif
c
c make sure range is applicable 
c ----------------------------- 
c
1     continue 
      if (nmin .ge. norb) then 
         nmin = norb/2 
         go to 1  
         else 
      endif 
c
2     continue 
      if (nmax .ge. norb) then 
         nmax = norb-1  
         go to 2  
         else 
      endif 
c 
      rem_min = nmax 
      best = nmax 
      nb = 0 
c
      do k = nmin, nmax 
c
         nseg = norb/k 
         neff = nseg*k 
         rem = norb - neff 
         if (rem .le. rem_min) then 
            rem_min = rem 
         endif 
c
      enddo 
c
      do k = nmax, nmin, -1  
c
         nseg = norb/k 
         neff = nseg*k 
         rem = norb - neff 
         if (rem .le. rem_min) then 
            nb = nb + 1 
            wb(nb) = k 
            rem_min = rem 
            go to 20 
         endif 
c
      enddo 
20    continue 
c
c ckeck if you like the result 
c ---------------------------- 
c
      do k = wb(1), wb(1) + nmax 
         nseg = norb/wb(1)  
         neff = nseg*k 
         rem = norb - neff  
         if (rem .le. 0) then 
            wb(1) = k 
            n_seg = k 
            go to 200 
         endif 
      enddo 

200   continue 
c
c nvirt segmentation
c ------------------ 
c
      nmin    = 22 
      nmax    = 40 
c
c make sure range is applicable 
c ----------------------------- 
c
3     continue 
      if (nmin .ge. nvirt) then 
         nmin = nvirt/2 
         go to 3 
         else 
      endif 
c
4     continue 
      if (nmax .ge. nvirt) then 
         nmax = nvirt-1  
         go to 4  
         else 
      endif 
c 
      rem_min = nmax 
      best    = nmax 
      nb      = 0 
c
      do k = nmin, nmax 
c
         nseg = nvirt/k 
         neff = nseg*k 
         rem  = nvirt - neff 
         if (rem .le. rem_min) then 
            rem_min = rem 
         endif 
c
      enddo 
c
      do k = nmax, nmin, -1  
c
         nseg = nvirt/k 
         neff = nseg*k 
         rem  = nvirt - neff 
         if (rem .le. rem_min) then 
            nb = nb + 1 
            wb(nb) = k 
            rem_min = rem 
            go to 10 
         endif 
c
      enddo 
10    continue 
c
c ckeck if you like the result 
c ---------------------------- 
c
      do k = wb(1), wb(1) + nmax 
         nseg = nvirt/wb(1)  
         neff = nseg*k 
         rem = nvirt - neff  
         if (rem .le. 0) then 
            wb(1) = k 
            v_seg = k 
            go to 100 
         endif 
      enddo 

100   continue 
c
c nocc segmentation
c ------------------ 
c
      nmin    = 10 
      nmax    = 40  
c
c make sure range is applicable 
c ----------------------------- 
c
5     continue 
      if (nmin .ge. nocc) then 
         nmin = nocc/2 
         go to 5 
         else 
      endif 
c
6     continue 
      if (nmax .ge. nocc) then 
         nmax = nocc-1  
         go to 6  
         else 
      endif 
c 
      rem_min = nmax 
      best    = nmax 
      nb      = 0 
c
      do k = nmax, nmin, -1  
c
         nseg = nocc/k 
         neff = nseg*k 
         rem  = nocc - neff 
         if (rem .le. rem_min) then 
            rem_min = rem 
         endif 
c
      enddo 
c
      do k = nmax, nmin, -1  
c
         nseg = nocc/k 
         neff = nseg*k 
         rem  = nocc - neff 
         if (rem .le. rem_min) then 
            nb = nb + 1 
            wb(nb) = k 
            rem_min = rem 
            go to 30 
         endif 
c
      enddo 
30    continue 
c
c ckeck if you like the result 
c ---------------------------- 
c
      do k = wb(1), wb(1) + nmax 
         nseg = nocc/wb(1)  
         neff = nseg*k 
         rem = nocc - neff  
         if (rem .le. 0) then 
            wb(1) = k 
            o_seg = k 
            go to 300 
         endif 
      enddo 

300   continue 
c
c   Attempt to improve segmentation.
c
      call refine_segs(nocci, 20, 35, o_seg)
      call refine_segs(nvirti, 20, 35, v_seg)
      call refine_segs(norbi, 20, 35, n_seg)

      return
      end 

      subroutine refine_segs(n, min_size, max_size, segsize)
c---------------------------------------------------------------------------
c   Attempts to improve the segmentation after the initial estimate.
c   Checks to determine if there is a smaller number of segments with a
c   better fit to the problem size.
c
c   Arguments:
c      n        Number of orbitals in either AO, virtual, or occupied space.
c      min_size Min. allowable segment size.
c      max_size Max. allowable segment size.
c      segsize  Initial segment size.
c
c   If a better fit is determined, the "segsize" argument is overwritten 
c   with the new value.
c---------------------------------------------------------------------------

      implicit none  
      integer n, min_size, max_size, segsize
      integer iseg, iseg1, iseg2, nseg 
      integer misfit, my_misfit
      integer total
      integer isize, my_size

c      print *,'Problem size ',n,' Original segsize ',
c     *           segsize
      nseg = (n +segsize - 1) / segsize
      if (nseg .eq. 1) return   ! pathologically small case
      if (n .lt. max_size) return

      total = nseg*segsize
      misfit = total - n

      iseg1 = (n + max_size - 1) / max_size
      iseg2 = (n + min_size - 1) / min_size
 
      if (misfit .gt. 0) then
         my_size = segsize
         do iseg = iseg1, iseg2

c--------------------------------------------------------------------------
c   Find the smallest segment size for with the smallest misfit for the 
c   problem size.
c--------------------------------------------------------------------------

            do isize = min_size, max_size
               total = isize * iseg
               my_misfit = total - n
               
               if (my_misfit .ge. 0 .and.
     *             my_misfit .lt. misfit) then 
                  misfit = my_misfit
                  my_size = isize
               endif
            enddo

            if (my_size .ne. segsize) then
c               print *,'New segsize ',
c     *            my_size,' for iseg ',iseg,' misfit = ',misfit
               segsize = my_size
               return
            endif
         enddo
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_ijk_aaa(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c---------------------------------------------------------------------------
c----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'frag_def.h' 

      common /d2int_com/jatom, jx, jcenter
      common /Occ_ijk/NT, Xijk(10000,7) 
      integer jatom, jx, jcenter
      double precision flags_value

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer ierr, array, array_type, ind, nind
      integer i, nseg, bseg, eseg, start(100), end(100), maxi   

      integer Nt, np(10), ns(100,10), Xijk,i_start,j_start
      integer e, j, k, ii, jj, is, ie, js, je, istart    

      array = op(c_result_array)
      if (array .lt. 1 .or. array .gt. narray_table) then
         print *,'Error: Invalid array in set_ijk, line ',
     *     current_line
         print *,'Array index is ',array,' Allowable values are ',
     *      ' 1 through ',narray_table
         call abort_job()
      endif

      nind = array_table(c_nindex, array)
      if (nind .ne. 1) then
         print *,'Error: set_ijk requires a 1-index array.'
         call abort_job()
      endif

c-----------------------------------------------------------------------
c------------------------------------------------------------------------

c     maxi  = 8 ! HARD CODED VFL 
      maxi = sip_sub_occ_segsize
c     write(6,*) ' MAXI IN SET_IJK_AAA = ', maxi
 
c-----------------------------------------------------------------------
c Determine the index 
c------------------------------------------------------------------------
 
      ind   = array_table(c_index_array1,array)

      nseg = index_table(c_nsegments,ind) 
      bseg = index_table(c_bseg,ind) 
      eseg = index_table(c_eseg,ind) 

c     write(6,*) ' ------------------------------- '  
c     write(6,*) ' IND :', ind, nseg 
 
c-----------------------------------------------------------------------
c Determine the index ranges  
c np(i) = number of partitions of segment i 
c ns(i,k) =  
c------------------------------------------------------------------------

      do i = 1, nseg 
         call get_index_segment(ind, i, segment_table,
     *                     nsegment_table, index_table,
     *                     nindex_table, start(i), end(i)) 
      enddo 
c     write(6,*) '   ', ((start(i),end(i)), i=1,nseg) 

      do i = 1, nseg 
         np(i) = (end(i) - start(i) + 1)/maxi 
         if (maxi*np(i) .lt. end(i) - start(i) + 1)
     *       np(i) = np(i) + 1 
      enddo 

c     write(6,*) ' N(I):', (np(i), i=1,nseg) 

      istart = 1 
      if (frag_calc) then 
         istart = n_aocc(1) + 1 
      endif

      i_start = 0  
      j_start = 0  
      if (frag_calc) then 
c        i_start = 1  
c        j_start = 1  
         do i=1,istart-1
          i_start = i_start + (eaocc_frag(1,i) - baocc_frag(1,i)) + 1 
         enddo 
         j_start = i_start
      endif

      do i = istart, nseg 
         e = 0 
         do k = 1, np(i) - 1 
            ns(i,k) = (end(i) - start(i) + 1)/np(i) 
            e = e + ns(i,k) 
         enddo 
         ns(i,np(i)) = (end(i) - start(i) + 1) - e 
      enddo 

      Nt = 0 
      ie = i_start 
      do i = istart, nseg 
      do ii = 1, np(i) 

         is = ie + 1 
         ie = is + ns(i,ii) - 1 

          je = j_start 
          do j = istart, nseg 
          do jj = 1, np(j) 

             js = je + 1 
             je = js + ns(j,jj) - 1 

          if (i .le. j) then 
             do k = istart, nseg 
             if (j .le. k) then 

                Nt = Nt + 1 
                Xijk(Nt,1) = i 
                Xijk(Nt,2) = is  
                Xijk(Nt,3) = ie  
                Xijk(Nt,4) = j 
                Xijk(Nt,5) = js 
                Xijk(Nt,6) = je
                Xijk(Nt,7) = k 

             endif 
             enddo 
           endif 
     
           enddo 
           enddo 

       enddo 
       enddo 

       do i = 1, 7 
       Xijk(Nt+1,i) = -1 
       enddo 

      if (me .eq. 0) write(6,*) ' Total number of combinations:', Nt 
      do k = 1, Nt 
      write(6,*) '  ', (Xijk(k,i), i=1, 7) 
      enddo 

c-----------------------------------------------------------------------
c Determine the number 
c-----------------------------------------------------------------------

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__finish
c------------------------------------------------------------------------
c  operation   : ofh__finish
c  module      : output files handler
c  module-id   : ofh
c  description : This operation finishes the output files handler.
c                The following is done in this routine:
c
c                       1) the logfile is closed.
c                       2) all current open units are closed.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
         include 'output_files.h'
c
c
c------------------------------------------------------------------------
c
c
c             ...close the logfile and all units.
c
c
         if (logfile_exists) then
             call  ofh__close_logfile
         end if

         call  ofh__close_all_units
c
c
c             ...print information on screen.
c
c
         write (*,*) ' Logfile and all units closed! '
c
c
c             ...ready!
c
c
         return
         end

C THIS ROUTINE CALCULATES THE SYMMETRY SPECIES OF VIBRATIONS,
C ROTATIONS AND TRANSLATIONS.

c INPUT
c integer NATOM
c integer NIRREP
c integer IORDER
c char*4  TYPE

c OUTPUT
c double  COORD(3,NATOM)
c double  VREF(NATOM*3)
c double  VIMAGE(NATOM*3)
c double  CHAR(IORDER,NIRREP)
c double  SYOP(9*IORDER)
c char*8  LABEL(NIRREP)
c integer ICENSUS(NATOM)
c integer IPTR(NATOM,IORDER)
c integer NBFATM(NATOM)
c integer ILCATM(NATOM)
c double  SCR(*)

c RECORDS
c get TYPE//'MEMB'
c get TYPE//'CHAR'
c get TYPE//'SYOP'
c get TYPE//'PERM'
c get TYPE//'LABL'
c get 'ATOMCHRG'
c get 'COORD   '
c get 'ORIENTMT'
c get 'LINEAR  '
c put 'ROTVECX '
c put 'ROTVECY '
c put 'ROTVECZ '

      SUBROUTINE VIBINF(NATOM,NIRREP,IORDER,COORD,VREF,
     &                  VIMAGE,CHAR,SYOP,LABEL,ICENSUS,IPTR,
     &                  NBFATM,ILCATM,SCR,TYPE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION COORD(3,NATOM),VREF(NATOM*3),VIMAGE(NATOM*3)
      DIMENSION CHAR(IORDER,NIRREP),SYOP(9*IORDER)
      CHARACTER*8 LABEL(NIRREP)
      DIMENSION ICENSUS(NATOM),IPTR(NATOM,IORDER)
      DIMENSION NBFATM(NATOM),ILCATM(NATOM),SCR(*)
      CHARACTER*4 TYPE

      DIMENSION IATNUM(100)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA ONE /1.0/

      CALL ZERO(VREF,3*NATOM)

      CALL GETREC(20,'JOBARC',TYPE//'MEMB',NATOM,ICENSUS)
      CALL GETREC(20,'JOBARC',TYPE//'CHAR',NIRREP*IORDER*IINTFP,CHAR)
      CALL GETREC(20,'JOBARC',TYPE//'SYOP',9*IORDER*IINTFP,SYOP)
      CALL GETREC(20,'JOBARC',TYPE//'PERM',NATOM*IORDER,IPTR)
      CALL GETREC(20,'JOBARC',TYPE//'LABL',NIRREP*IINTFP,LABEL)
      CALL GETREC(20,'JOBARC','ATOMCHRG',NATOM,IATNUM)
      CALL GETREC(20,'JOBARC','COORD   ',3*NATOM*IINTFP,COORD)
      CALL GETREC(20,'JOBARC','ORIENTMT',9*IINTFP,SCR)
      CALL GETREC(20,'JOBARC','LINEAR  ',1,ILINEAR)

      IF (TYPE.EQ.'FULL') CALL TRNOPS(SYOP,SCR,IORDER)

c   o compute Rx, Ry, and Rz rotational normalization factors
      IOFF=0
      RX=0.0
      RY=0.0
      RZ=0.0
      DO IATOM=1,NATOM
         IF (IATNUM(IATOM).NE.0) THEN
            RX=RX+COORD(3,IATOM)*COORD(3,IATOM)+
     &            COORD(2,IATOM)*COORD(2,IATOM)
            RY=RY+COORD(3,IATOM)*COORD(3,IATOM)+
     &            COORD(1,IATOM)*COORD(1,IATOM)
            RZ=RZ+COORD(1,IATOM)*COORD(1,IATOM)+
     &            COORD(2,IATOM)*COORD(2,IATOM)
         END IF
         IOFF=IOFF+3
      END DO
      FX=ONE/SQRT(RX)
      FY=ONE/SQRT(RY)
      IF (ILINEAR.NE.0) THEN
         FZ=0.d0
      ELSE
         FZ=ONE/SQRT(RZ)
      END IF

      DO IATOM=1,NATOM
         NBFATM(IATOM)=3
         ILCATM(IATOM)=3*(IATOM-1)+1
      END DO

      ZNORM=ONE/DFLOAT(IORDER)

C FIRST COMPUTE REDUCIBLE REPRESENTATION FOR VIBRATIONS,
C TRANSLATIONS AND ROTATIONS AND DECOMPOSE IT

      DO IOP=1,IORDER

         CALL ZERO(VREF,3*NATOM)
         DO IPOS=1,3*NATOM
            IATOM=1+(IPOS-1)/3
            IF(IATNUM(IATOM).NE.0)VREF(IPOS)=ONE
         END DO
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &              VREF,VIMAGE,SCR,1,3*NATOM,SYOP,0)
         IOFF=1
         DO I=1,NATOM
            IF(IPTR(I,IOP).NE.I)CALL ZERO(VIMAGE(IOFF),3)
            IOFF=IOFF+3
         END DO
         SCR(3*NATOM+IOP)=DDOT(3*NATOM,VIMAGE,1,VREF,1)

c      o translations
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &              VREF,VIMAGE,SCR,1,3*NATOM,SYOP,1)
         SCR(3*NATOM+IORDER+IOP)=DDOT(3*NATOM,VIMAGE,1,VREF,1)*3.0

c      o Rx
         CALL ZERO(VREF,3*NATOM)
         IOFF=0
         DO IATOM=1,NATOM
            IF (IATNUM(IATOM).NE.0) THEN
               VREF(IOFF+2)=FX*COORD(3,IATOM)
               VREF(IOFF+3)=-FX*COORD(2,IATOM)
            END IF
            IOFF=IOFF+3
         END DO
         CALL PUTREC(20,'JOBARC','ROTVECX ',3*NATOM*IINTFP,VREF)
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &              VREF,VIMAGE,SCR,1,3*NATOM,SYOP,0)
         ZTMPX=DDOT(3*NATOM,VIMAGE,1,VREF,1)

c      o Ry
         CALL ZERO(VREF,3*NATOM)
         IOFF=0
         DO IATOM=1,NATOM
            IF (IATNUM(IATOM).NE.0) THEN
               VREF(IOFF+1)=FY*COORD(3,IATOM)
               VREF(IOFF+3)=-FY*COORD(1,IATOM)
            END IF
            IOFF=IOFF+3
         END DO
         CALL PUTREC(20,'JOBARC','ROTVECY ',3*NATOM*IINTFP,VREF)
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &              VREF,VIMAGE,SCR,1,3*NATOM,SYOP,0)
         ZTMPY=DDOT(3*NATOM,VIMAGE,1,VREF,1)

c      o Rz
         CALL ZERO(VREF,3*NATOM)
         IOFF=0
         DO IATOM=1,NATOM
            IF (IATNUM(IATOM).NE.0) THEN
               VREF(IOFF+1)=FZ*COORD(2,IATOM)
               VREF(IOFF+2)=-FZ*COORD(1,IATOM)
            END IF
            IOFF=IOFF+3
         END DO
         IF (ILINEAR.EQ.0) THEN
            CALL PUTREC(20,'JOBARC','ROTVECZ ',3*NATOM*IINTFP,VREF)
         END IF
         CALL IMAGE(NATOM,3*NATOM,1,IOP,IPTR,NBFATM,ILCATM,
     &              VREF,VIMAGE,SCR,1,3*NATOM,SYOP,0)
         ZTMPZ=DDOT(3*NATOM,VIMAGE,1,VREF,1)

         SCR(3*NATOM+2*IORDER+IOP)=ZTMPX+ZTMPY+ZTMPZ

      END DO

1001  FORMAT(T3,'@VIBINF-I, Symmetries species for nuclear motions:')
1002  FORMAT(T3,'Irrep',T13,'Label ',T21,' Total ',T31,'Vibrations',
     &       T46,'Translations',T63,'Rotations' )
1000  FORMAT(T4,I2,T14,A,T22,F5.2,T33,F5.2,T49,F5.2,T65,F5.2)
      WRITE(6,1001)
      WRITE(6,1002)
      IOFF=3*NATOM
      DO IRREP=1,NIRREP
         XTOT=DDOT(IORDER,SCR(IOFF+1),1,CHAR(1,IRREP),1)*ZNORM
         XTRA=DDOT(IORDER,SCR(IOFF+IORDER+1),1,CHAR(1,IRREP),1)*ZNORM
         XROT=DDOT(IORDER,SCR(IOFF+2*IORDER+1),1,CHAR(1,IRREP),1)*ZNORM
         WRITE(6,1000)IRREP,LABEL(IRREP)(1:4),XTOT,XTOT-XTRA-XROT,
     &                XTRA,XROT
      END DO

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine pardo_loop(optable, noptable, iop, index_table, 
     *                  nindex_table, array_table, narray_table,
     *                  block_map_table,
     *                  segment_table, nsegment_table,
     *                  comm, debug, prt_flag,
     *                  start_op, end_op)

      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'where_table.h'

      integer iblk

      integer noptable, iop, start_op, end_op
      integer optable(loptable_entry,noptable)
      integer nindex_table
      integer index_table(lindex_table_entry,nindex_table)
      integer narray_table
      integer array_table(larray_table_entry,narray_table)
      integer block_map_table(lblock_map_entry,*)
      integer nsegment_table
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer comm

      integer i, j, opcode, index, nseg, istat
      integer result_array
      integer ind(mx_array_index), segm(mx_array_index)
      integer indx(mx_array_index), bseg(mx_array_index),
     *        eseg(mx_array_index), max_batch, nind
      integer next_seg(mx_array_index)
      integer first_batch, last_batch, current_batch

c      integer pardo_overhead_timer

      integer nsegm
      logical debug, prt_flag

      integer push_do, pop_do

      save indx, bseg, eseg, max_batch, nind 
      save first_batch, last_batch, current_batch

      opcode = optable(c_opcode, iop)
      if (iop .gt. noptable) then
         print *,'PARDO_LOOP: Called with iop = ',iop,' noptable = ',
     *           noptable
         call abort_job()
      endif

      if (iop .lt. start_op .or. iop .gt. end_op) return

      if (opcode .eq. pardo_op) then
c         print *,'PARDO at line ',current_line

c--------------------------------------------------------------------------
c   PARDO operation
c   Update the "current_seg" fields of all loop indices.
c--------------------------------------------------------------------------

         do i = 1, mx_array_index
            ind(i) = optable(c_ind1+i-1,iop)
         enddo

         call set_prefetch_context(ind, mx_array_index)

         if (optable(c_oploop,iop) .eq. 1) then

c---------------------------------------------------------------------------
c   Find the segments corresponding to the next "batch" of work to process.
c---------------------------------------------------------------------------
 
            current_batch = current_batch + 1
            call get_current_loop_set(current_batch, first_batch,
     *                                last_batch, indx, bseg, eseg,
     *                                nind, index_table, nindex_table, 
     *                                segm)

c---------------------------------------------------------------------------
c   Store the set of index segments in the "current_seg" field of the 
c   index table.
c---------------------------------------------------------------------------

            do i = 1, nind
               index = indx(i)
               if (index .gt. 0) 
     *             index_table(c_current_seg,index) = segm(i)
            enddo

c---------------------------------------------------------------------------
c   Check to see if we have any work to do?
c---------------------------------------------------------------------------

            nsegm = 0
            do i = 1,nind
               if (segm(i) .gt. 0) nsegm = nsegm + 1
            enddo
c            print *,'Pardo new batch segm ',(segm(i),i=1,mx_array_index)

c            print *,'Task ',me,' current_batch ',current_batch,
c     *        ' segm ',(segm(i),i=1,nind)

            if (nsegm .gt. 0) then

c---------------------------------------------------------------------------
c   We have a legitimate set of segments for processing.  Now look at the
c   next batch and set up the next_seg field of the index_table as 
c   prefetch segments.
c---------------------------------------------------------------------------

               call get_current_loop_set(current_batch+1, first_batch,
     *                                last_batch, indx, bseg, eseg,
     *                                nind, index_table, nindex_table, 
     *                                next_seg)
               do i = 1, nind
                  index_table(c_next_seg, indx(i)) = next_seg(i)
               enddo
            else
               print *,'Error: PARDO at line ',current_line,
     *             ' has no valid segments to process.'
               print *,'   Task me = ',me,' segm = ',
     *                     (segm(i),i=1,mx_array_index)
               call abort_job()
            endif
         else

c----------------------------------------------------------------------------
c   LOOP INITIALIZATION:
c   Push the start_op and end_op indices on the instruction stack.
c----------------------------------------------------------------------------

            istat = push_do(start_op, end_op)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *           ' Error in pardo_loop: stack overflow'
               call abort_job()
            endif

c---------------------------------------------------------------------------
c   Push the data for the WHERE conditionals.
c---------------------------------------------------------------------------

            istat = push_do(iwhere, nwhere)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *           ' Error in pardo_loop: stack overflow while ',
     *           'pushing wheres'
               call abort_job()
            endif

c---------------------------------------------------------------------------
c   Unpack the current pardo timers and start the timer.
c---------------------------------------------------------------------------

            call unpack_pardo_timer(optable(c_instr_timer,iop),
     *                  pardo_timer, pardo_block_wait_timer)
            
c            print *, "pardo_timer =", pardo_timer, 
c     *               "pardo_block_wait_timer =", pardo_block_wait_timer

            call timer_start(pardo_timer)

c---------------------------------------------------------------------------
c   Set the new values of start_op, end_op
c---------------------------------------------------------------------------

c            print *,'Old start_op, end_op ',start_op,end_op 
            start_op = iop
            do j = iop+1,noptable
               if (optable(c_opcode,j) .eq. endpardo_op) then
                  end_op = j
                  go to 100
               endif
            enddo
  100       continue
c            print *,'Task ',me,' PARDO_INIT code: new iop = ',
c     *              iop,' start_op, end_op = ',start_op,end_op

c----------------------------------------------------------------------------
c   Get the WHERE conditionals for the current loop.
c----------------------------------------------------------------------------

            call get_where_conditionals(optable, start_op, end_op)

c---------------------------------------------------------------------------
c   Entering loop for the first iteration: set up the mapping for 
c   incrementing the indices, then pull out the first index set.
c---------------------------------------------------------------------------

            optable(c_oploop,iop) = 1

            max_batch = -1 
            call lb_set_loop_incr_mapping(ind, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      indx, bseg, eseg, nind,
     *                      max_batch)
            max_batch = optable(c_pardo_max_batch,iop)
            call set_loop_incr_mapping(first_batch, last_batch,
     *                                 max_batch) 
            current_batch = first_batch
            call get_current_loop_set(current_batch, first_batch, 
     *                                last_batch, indx, bseg, eseg, 
     *                                nind, index_table, nindex_table, 
     *                                segm)

c---------------------------------------------------------------------------
c   Store the set of index segments in the "current_seg" field of the 
c   index table.
c---------------------------------------------------------------------------

            nsegm = 0
            do i = 1, nind
               if (segm(i) .gt. 0) then
                  nsegm = nsegm + 1
                  index = indx(i)
                  if (index .gt. 0) 
     *                index_table(c_current_seg,index) = segm(i)
               endif
            enddo

c---------------------------------------------------------------------------
c   If we got a real set of segments to process, set the "next_seg"
c   field used for prefetching data.
c---------------------------------------------------------------------------

            if (nsegm .gt. 0) then
               call get_current_loop_set(current_batch+1, first_batch,
     *                                last_batch, indx, bseg, eseg,
     *                                nind, index_table, nindex_table,
     *                                next_seg)
               do i = 1, nind
                  index_table(c_next_seg, indx(i)) = next_seg(i)
               enddo
            else
c               if (me .eq. 0) print *,'PARDO line ',current_line,
c     *              ' END OF BATCH'
               do i = 1, nind
                  if (indx(i) .gt. 0) 
     *               index_table(c_next_seg, indx(i)) = 0
               enddo

c---------------------------------------------------------------------------
c   No work for this processor.  Set iop to point to the "endpardo" 
c   instruction and return.  This is equivalent to an unconditional 
c   jump to the end of the loop.
c---------------------------------------------------------------------------

               optable(c_oploop,iop) = 0   ! reset loop init flag
               current_batch = last_batch
               iop = end_op
    
               return
            endif   ! nsegm .gt. 0
         endif      ! pardo loop init code
      endif         ! pardo_op

      if (opcode .eq. endpardo_op) then
         
         call unset_prefetch_context()

c-------------------------------------------------------------------------
c   Reset any temp blocks created in this loop.
c-------------------------------------------------------------------------

         do i = start_op, end_op

c-------------------------------------------------------------------------
c   If a PUT was executed, set the flag in the array_table.
c-------------------------------------------------------------------------
                                                                                
            if (optable(c_opcode,i) .eq. put_op .or.
     *          optable(c_opcode,i) .eq. put_replace_op) then
               result_array = optable(c_result_array,i)
               array_table(c_put_flag,result_array) = 1
            endif

c-------------------------------------------------------------------------
c   If a PREPARE was executed, set the flag in the array_table.
c-------------------------------------------------------------------------
                                                                                
            if (optable(c_opcode,i) .eq. prepare_op .or.
     *          optable(c_opcode,i) .eq. prepare_increment_op) then
               result_array = optable(c_result_array,i)
               array_table(c_prepare_flag,result_array) = 1
            endif

            if (optable(c_opblock,i) .ne. 0) then

c-------------------------------------------------------------------------
c   Only clear the block_computed_flag if the array is managed by
c   blkmgr.
c-------------------------------------------------------------------------

               result_array = optable(c_result_array,i)
               if (array_table(c_array_type, result_array) .ne.
     *             static_array) then

c-------------------------------------------------------------------------
c   Only reset the block's flags if this is NOT the result of a CREATE
c   instruction.  Only a DELETE can reset the flags otherwise.
c-------------------------------------------------------------------------

                 call block_end_of_loop(result_array,
     *                 optable(c_opblock,i), optable(c_opblkndx,i),
     *                 array_table, narray_table, index_table,
     *                 nindex_table, block_map_table)
               endif
               optable(c_opblock,i) = 0
               optable(c_opblkndx,i) = 0
            endif
         enddo

         if (current_batch .eq. last_batch) then
c
c-----------------------------------------------------------------------
c   Reset the loop indices to "undefined".
c-----------------------------------------------------------------------

         do i = 1, nind
            if (indx(i) .ge. 1 .and. 
     *          indx(i) .le. nindex_table) then
               index_table(c_current_seg,indx(i)) = undefined_segment
               index_table(c_next_seg,indx(i))    = 0
            endif
         enddo

c--------------------------------------------------------------------------
c   Final pass of the loop.  Pop a new set of iwhere, nwhere values off the
c   stack.
c--------------------------------------------------------------------------

            istat = pop_do(iwhere, nwhere)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *          ' Error in pardo_loop: stack underflow'
               call abort_job()
            endif

c--------------------------------------------------------------------------
c   Final pass of the loop.  Turn off the pardo_timer and pop a new set 
c   of start, end values off the stack.
c--------------------------------------------------------------------------

            optable(c_oploop,start_op) = 0   ! reset loop init flag

            call update_timer(pardo_timer)

            istat = pop_do(start_op, end_op)
            if (istat .lt. 0) then
               print *,'Task ',me,
     *          ' Error in pardo_loop: stack underflow'
               call abort_job()
            endif
     
            if (start_op .gt. noptable .or. 
     *          start_op .lt. 0 .or.
     *          end_op .gt. noptable .or.
     *          end_op .lt. 0) call abort_job()
         endif
      endif
    
      return
      end

      subroutine set_loop_incr_mapping(first_batch, last_batch, 
     *                                 nbatch_total)
c--------------------------------------------------------------------------
c   Defines a new parallel mapping of the loop indices in array "ind", 
c   based on the index_table.
c--------------------------------------------------------------------------
      implicit none
      include 'mpif.h'
      include 'parallel_info.h'
      include 'trace.h'
      include 'where_table.h'
      include 'restrict_pardo.h'

      integer ierr

      integer i
      integer my_proc, first_batch, last_batch, nbatch
      integer nbatch_total, nbatch_proc, nbatch_left
      integer next_batch, current_batch
      integer restricted_company_rank
      integer restricted_company_size

      restricted_company_rank = 0
      restricted_company_size = 0 

      do i=1, me
          if (do_prestrict(i) .eq. 1) then
              restricted_company_rank = restricted_company_rank + 1
          endif
      enddo

      do i=1, nprocs
          if (do_prestrict(i) .eq. 1) then
              restricted_company_size = restricted_company_size + 1
          endif
      enddo

      my_proc = restricted_company_rank

      nbatch_proc = nbatch_total / restricted_company_size
      nbatch_left = nbatch_total - restricted_company_size * nbatch_proc 

      if (my_proc .lt. nbatch_left) then

c-------------------------------------------------------------------------
c   The first "nbatch_left" procs have 1 extra batch to do.
c-------------------------------------------------------------------------

         first_batch = my_proc * (nbatch_proc + 1) + 1
         last_batch  = first_batch + nbatch_proc
      else

c--------------------------------------------------------------------------
c   Procs "nbatch_left" to "my_company_size" have only nbatch_proc batches 
c   to do.
c--------------------------------------------------------------------------

         first_batch = my_proc * nbatch_proc + 
     *                  nbatch_left + 1
         last_batch = first_batch + nbatch_proc - 1
      endif

c Disables processing of the pardo if this worker is
c not part of the restriction
      if (do_prestrict(me+1) .eq. 0)  then
         last_batch = 1
         first_batch = last_batch + 1
      endif
 
          
c     nbatch = last_batch - first_batch + 1
      return
      end

      subroutine get_current_loop_set(current_batch, first_batch,
     *                                last_batch, ind, bseg, eseg,
     *                                nind, index_table, nindex_table,
     *                                segm)
      implicit none
      include 'where_table.h'
      
      integer current_batch, first_batch, last_batch
      integer i, ibatch, nind
      integer ind(nind), bseg(nind), eseg(nind), segm(nind)
      integer index_table, nindex_table

      logical check_where_conditions
 
c--------------------------------------------------------------------------
c   Breaks down the next set of loop coordinates, returns them in "seg".
c   If the current_batch > last_batch, the segm argument is returned
c   with all 0's.  Otherwise the segments of the batch are returned in 
c   "segm".
c--------------------------------------------------------------------------

      if (current_batch > last_batch) then
         do i = 1, nind
            segm(i) = 0
         enddo
 
         return
      endif

c---------------------------------------------------------------------------
c  Initialize the segm array to the bseg for each index.
c---------------------------------------------------------------------------

      do i = 1, nind
         segm(i) = bseg(i)
      enddo
      segm(1) = segm(1) - 1

c---------------------------------------------------------------------------
c   Cycle the indices to "current_batch".
c---------------------------------------------------------------------------

      do ibatch = 1, current_batch
   50    continue
         do i = 1, nind
            segm(i) = segm(i) + 1
            if (segm(i) .le. eseg(i)) then
               go to 100
            else
               segm(i) = bseg(i)
            endif
         enddo
  100    continue

c--------------------------------------------------------------------------
c   If there are any "where" conditions, make sure they are satisfied.
c--------------------------------------------------------------------------

         if (nwhere .gt. 0) then
            if (.not. check_where_conditions(ind, segm, nind,
     *                                 index_table, nindex_table))
     *            go to 50
         endif
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_AB_PCGTO_BLOCK
     +
     +                    ( NBATCH,NKIN1D,NOVL1D,
     +                      ATOMIC,
     +                      MIJ,NIJ,NIJBEG,NIJEND,
     +                      NPGTOA,NPGTOB,
     +                      NXYZA,NXYZB,
     +                      SHELLA,SHELLB,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      ALPHAA,ALPHAB,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      EA,EB,E2AB,
     +                      PAX,PAY,PAZ,PINVHF,SCALE,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_AB_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__OVL_1D_INTEGRALS
C                OED__KIN_1D_INTEGRALS
C                OED__KIN_INT1D_TO_A0
C                OED__KIN_INT1D_TO_AB
C  DESCRIPTION : This operation calculates a batch of unnormed kinetic
C                integrals between primitive cartesian gaussians for
C                shells A and B:
C
C                                   [A|B]
C                                        ij
C
C                and the block of ij exponent pairs. The total number
C                of kinetic integrals generated here is thus given by
C                the total number of cartesian monomials NXYZA*NXYZB
C                times the total number of exponent pairs MIJ in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyza,nxyzb)
C
C
C                  Input:
C
C                    NBATCH       =  size of the primitive cartesian
C                                    integral batch
C                    NKIN1D       =  space needed for each of the
C                                    kinetic 1D X,Y,Z integral arrays
C                    NOVL1D       =  space needed for each of the
C                                    kinetic 1D X,Y,Z integral arrays
C                    ATOMIC       =  indicates, if purely atomic
C                                    integrals will be evaluated
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZx        =  # of cartesian monomials for
C                                    contraction shells x = A,B
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    Ex           =  will hold current MIJ exponents
C                                    from centers x = A,B
C                    E2AB         =  will hold current MIJ double
C                                    exponent products between centers
C                                    A and B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current MIJ values of
C                                    scaling factors
C                    KIN1Dx       =  will hold all current kinetic
C                                    1D integrals for each cartesian
C                                    component (x = X,Y,Z)
C                    OVL1Dx       =  will hold all current overlap
C                                    1D integrals for each cartesian
C                                    component (x = X,Y,Z)
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    cartesian kinetic [A|B] integrals
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ATOMIC

         INTEGER     I,J,M
         INTEGER     IJ
         INTEGER     MIJ
         INTEGER     NBATCH,NKIN1D,NOVL1D
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB,SHELLP

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  PINV,PVAL
         DOUBLE PRECISION  X,Y,Z
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  HALF,ONE,ONEP5,TWO

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  EA      (1:MIJ)
         DOUBLE PRECISION  EB      (1:MIJ)
         DOUBLE PRECISION  E2AB    (1:MIJ)
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)
         DOUBLE PRECISION  SCALE   (1:MIJ)

         DOUBLE PRECISION  KIN1DX  (1:NKIN1D)
         DOUBLE PRECISION  KIN1DY  (1:NKIN1D)
         DOUBLE PRECISION  KIN1DZ  (1:NKIN1D)
         DOUBLE PRECISION  OVL1DX  (1:NOVL1D)
         DOUBLE PRECISION  OVL1DY  (1:NOVL1D)
         DOUBLE PRECISION  OVL1DZ  (1:NOVL1D)

         PARAMETER  (HALF  = 0.5D0)
         PARAMETER  (ONE   = 1.D0)
         PARAMETER  (ONEP5 = 1.5D0)
         PARAMETER  (TWO   = 2.D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D overlap and kinetic integrals.
C
C
         IF (ATOMIC) THEN
             M = 0
             DO 100 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                EA (M) = EXPA
                EB (M) = EXPB
                E2AB (M) = TWO * EXPA * EXPB
                PINV = ONE / (EXPA + EXPB)
                PINVHF (M) = HALF * PINV
                SCALE  (M) = (PINV ** ONEP5) * NORMA (I) * NORMB (J)
  100        CONTINUE
         ELSE
             M = 0
             DO 110 IJ = NIJBEG,NIJEND
                M = M + 1
                I = PRIMA (M)
                J = PRIMB (M)
                EXPA = ALPHAA (I)
                EXPB = ALPHAB (J)
                EA (M) = EXPA
                EB (M) = EXPB
                E2AB (M) = TWO * EXPA * EXPB
                PINV = ONE / (EXPA + EXPB)
                PVAL = - EXPB * PINV
                PAX (M) = PVAL * ABX
                PAY (M) = PVAL * ABY
                PAZ (M) = PVAL * ABZ
                PINVHF (M) = HALF * PINV
                SCALE  (M) = (PINV ** ONEP5)
     +                       * NORMA (I) * NORMB (J) * RHOAB (IJ)
  110        CONTINUE
         END IF
C
C
C             ...perform the following steps:
C
C                1) construct all 1D x,y,z overlap integrals for
C                   all ij pairs for up to shells SHELLA+1 and
C                   SHELLB+1.
C
C                2) using the 1D x,y,z overlap integrals construct
C                   all 1D x,y,z kinetic integrals for all ij pairs.
C
C                3) assemble the complete [A|B] kinetic batch for all
C                   ij pairs using the 1D kinetic and overlap integrals.
C                   Arrays EA and EB are passed as scratch arrays.
C
C
         CALL    OED__OVL_1D_INTEGRALS
     +
     +                ( SHELLP+2,SHELLB+1,
     +                  ATOMIC,
     +                  MIJ,
     +                  PAX,PAY,PAZ,
     +                  PINVHF,
     +                  ABX,ABY,ABZ,
     +
     +                            OVL1DX,
     +                            OVL1DY,
     +                            OVL1DZ )
     +
     +
         CALL    OED__KIN_1D_INTEGRALS
     +
     +                ( SHELLA,SHELLB,SHELLP,
     +                  ATOMIC,
     +                  MIJ,
     +                  EA,EB,E2AB,
     +                  OVL1DX,OVL1DY,OVL1DZ,
     +
     +                            KIN1DX,
     +                            KIN1DY,
     +                            KIN1DZ )
     +
     +
         IF (SHELLP.EQ.0) THEN

             DO M = 1,MIJ
                X = KIN1DX (M)
                Y = KIN1DY (M)
                Z = KIN1DZ (M)
                BATCH (M) = SCALE (M) * (X + Y + Z)
             END DO

         ELSE IF (SHELLB.EQ.0) THEN

             CALL    OED__KIN_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      ATOMIC,
     +                      MIJ,
     +                      NXYZA,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      EA,EB,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE
             CALL    OED__KIN_INT1D_TO_AB
     +
     +                    ( SHELLA,SHELLB,SHELLP,
     +                      ATOMIC,
     +                      MIJ,
     +                      NXYZA,NXYZB,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      EA,EB,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE TOPT2S(ISPIN,ILIST,NTOP,NT2SIZ,NOCCA,NOCCB,
     &                  NVRTA,NVRTB,NSMSZ1,NSMSZ2,T,TOPT2,
     &                  SYVEC1,SYVEC2,ITOPT2,I,J,A,B,TYPE)
C
C THIS ROUTINE PICKS UP A T2 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT1 AND THEIR ASSOCIATED INDICES
C  IN THE I AND A VECTORS.
C
C INPUT:
C       ISPIN - THE LIST SUBTYPE
C       ILIST - THE LIST NUMBER
C       NTOP  - THE NUMBER OF LARGEST AMPLITUDES (BY ABSOLUTE VALUE)
C               WHICH ARE TO BE FOUND
C       NT2SIZ- THE TOTAL SIZE OF THE T2 VECTOR
C       NOCCA - THE NUMBER OF ALPHA OCCUPIED ORBITALS
C       NOCCB - THE NUMBER OF BETA OCCUPIED ORBITALS
C       NVRTA - THE NUMBER OF ALPHA VIRTUAL ORBITALS
C       NVRTB - THE NUMBER OF BETA VIRTUAL ORBITALS
C       NSMSZ1- THE TOTAL SIZE OF THE A,B SYMMETRY VECTOR
C               FOR THIS SPIN CASE (NVRTA*(NVRTA-1))/2 FOR
C               ISPIN=1, NVRTA*NVRTB FOR ISPIN=3, ETC.)
C       NSMSZ2- THE TOTAL SIZE OF THE I,J SYMMETRY VECTOR
C               FOR THIS SPIN CASE (NOCCA*(NOCCA-1))/2 FOR
C               ISPIN=1, NOCCA*NOCCB FOR ISPIN=3, ETC.)
C       SYVEC1- THE A,B SYMMETRY VECTOR
C       SYVEC2- THE I,J SYMMETRY VECTOR
C       TYPE  - ???????
C
C OUTPUT:
C       TOPT2 - THE NTOP LARGEST ELEMENTS IN THE T2 VECTOR
C               SORTED BY ABSOLUTE VALUE
C       I     - THE I INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       J     - THE J INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       A     - THE A INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       B     - THE B INDICES CORRESPONDING TO THE VALUES IN TOPT1
C
C SCRATCH:
C
C       T     - USED TO HOLD THE SYMMETRY-PACKED T VECTOR
C       ITOPT2- USED TO HOLD THE OFFSETS CORRESPONDING TO THE
C               ELEMENTS IN TOPT2
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A(NTOP),B(NTOP),SYVEC1(NSMSZ1),SYVEC2(NSMSZ2)
cjp
      integer itrue, jtrue,atrue,btrue
      CHARACTER*2 SPCASE(3)
      CHARACTER*1 TYPE
      DIMENSION T(NT2SIZ),TOPT2(NTOP),ITOPT2(NTOP),I(NTOP),
     &          J(NTOP)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA SPCASE /'AA','BB','AB'/
cjp
#include "bwcc.com"
C
C THIS ROUTINE PICKS UP A T2 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT2 AND THEIR ASSOCIATED INDICES
C  IN THE I,J,A AND B VECTORS.
C
C
C STATEMENT FUNCTIONS
C
      ILRG(INTX)=INT(0.5D0*(1.D0+SQRT(8.0*INTX-7)))+1
      NNM1O2(IX)=(IX*(IX-1))/2
C
      IF(NT2SIZ.EQ.0)RETURN
C
      CALL GETALL(T,NT2SIZ,1,ILIST)
C
C COMPUTE NORM OF T2 VECTOR
C
      X=SNRM2(NT2SIZ,T,1)
      T2NORM=X
C
C PUT NTOP LARGEST ELEMENTS INTO TOPT2 AND THEIR ASSOCIATED INDICES INTO
C   ITOPT2.
C
      CALL SCANVC(T,TOPT2,ITOPT2,NTOP,NT2SIZ)
C
C BRANCH HERE FOR DIFFERENT SPIN CASES, BECAUSE INDICES HAVE TO BE
C   FIRURED OUT FROM ITOPT2.
C
      DO 10 IRANK=1,NTOP
       CALL PCKIND(ITOPT2(IRANK),ISPIN,SYVEC1,SYVEC2,NSMSZ1,NSMSZ2,
     &             I(IRANK),J(IRANK),A(IRANK),B(IRANK))
10    CONTINUE
cjp
      if(isbwcc) then
cjp prepare spin indices according to ispin case
        if(ispin.eq.1) then
          isp1=1
          isp2=1
        else
          if(ispin.eq.2) then
            isp1=2
            isp2=2
          else
            isp1=1
            isp2=2
          endif
        endif
        write(*,202)type,SPCASE(ISPIN),iref
        else
      WRITE(*,200)TYPE,SPCASE(ISPIN)
        endif
200   FORMAT(T3,' Largest ',A1,'2 amplitudes for spin case ',A2,':')
202   format(T3,' Largest ',A1,'2 amplitudes for spin case ',A2,
     &    ' of reference no.: ',i3)
      IF(ISPIN.EQ.3)WRITE(*,299)
      WRITE(*,300)
299   FORMAT(3X,3(' ',3X,'_',3X,' ',3X,'_',13X))
300   FORMAT(3X,3('i',3X,'j',3X,'a',3X,'b',13X))
      WRITE(*,400)
400   FORMAT(77('-'))
cjp
      if(isbwcc) then
cjp ... this is not OK for uhf-cc, ignore for now
       if(bwgossip) then
      write(*,502) (irank,i(irank),j(irank),a(irank),b(irank),
     &   invhnum(i(irank),iref,isp1),
     & invhnum(j(irank),iref,isp2),invpnum(a(irank)-nocca,iref,isp1),
     & invpnum(b(irank)-nocca,iref,isp2),topt2(irank),irank=1,ntop)
        else
        write(*,500) (invhnum(i(irank),iref,isp1),invhnum(j(irank),
     &  iref,isp2),invpnum(a(irank)-nocca,iref,isp1),
     & invpnum(b(irank)-nocca,iref,isp2),topt2(irank),irank=1,ntop)
        endif
      else
      WRITE(*,500)(I(IRANK),J(IRANK),A(IRANK),B(IRANK),
     &                 TOPT2(IRANK),IRANK=1,NTOP)
      endif
      WRITE(*,400)
      WRITE(*,600)TYPE,SPCASE(ISPIN),NT2SIZ,T2NORM
      WRITE(*,400)
cpn
      if(isbwcc.and.bwgossip) then
c This will print all the amplitudes and their indexes in order
      write(*,203)type,spcase(ispin),iref
 203  format(t3,' List of all ',A1,'2 amplitudes for spin case ',A2,
     &    ' of reference no.: ',i3)
      if(ispin.eq.3)write(*,299)
      write(*,300)
      write(*,400)
      do 11 irank = 1, nt2siz
         call pckind(irank,ispin,syvec1,syvec2,nsmsz1,nsmsz2,
     &        i(1),j(1),a(1),b(1))
         itrue=invhnum(i(1),iref,isp1)
         jtrue=invhnum(j(1),iref,isp2)
cjp ... this is not OK for uhf-cc, ignore for now
         atrue=invpnum(a(1)-nocca,iref,isp1)
         btrue=invpnum(b(1)-nocca,iref,isp2)
         write(*,502)irank,i(1),j(1),a(1),b(1),itrue,jtrue,atrue,
     &         btrue,t(irank)
 11   continue
 502  format(3x,i5,6x,4i5,': true ind : ',4i5,':',f12.8)
      endif
cpn end
600   FORMAT(T3,' Norm of ',A1,'2',A2,' vector (',I9,
     &       ' symmetry allowed elements):',F14.10,'.')
500   FORMAT((2('[',I3,1X,I3,1X,I3,1X,I3,']',F8.5,1X),'[',I3,1X,
     &I3,1X,I3,1X,I3,']',F8.5))
      RETURN
      END

      SUBROUTINE TOPT2S(ISPIN,ILIST,NTOP,NT2SIZ,NOCCA,NOCCB,
     &                  NVRTA,NVRTB,NSMSZ1,NSMSZ2,T,TOPT2,
     &                  SYVEC1,SYVEC2,ITOPT2,I,J,A,B,TYPE)
C
C THIS ROUTINE PICKS UP A T2 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT1 AND THEIR ASSOCIATED INDICES
C  IN THE I AND A VECTORS.
C
C INPUT:
C       ISPIN - THE LIST SUBTYPE
C       ILIST - THE LIST NUMBER
C       NTOP  - THE NUMBER OF LARGEST AMPLITUDES (BY ABSOLUTE VALUE)
C               WHICH ARE TO BE FOUND
C       NT2SIZ- THE TOTAL SIZE OF THE T2 VECTOR
C       NOCCA - THE NUMBER OF ALPHA OCCUPIED ORBITALS
C       NOCCB - THE NUMBER OF BETA OCCUPIED ORBITALS
C       NVRTA - THE NUMBER OF ALPHA VIRTUAL ORBITALS
C       NVRTB - THE NUMBER OF BETA VIRTUAL ORBITALS
C       NSMSZ1- THE TOTAL SIZE OF THE A,B SYMMETRY VECTOR
C               FOR THIS SPIN CASE (NVRTA*(NVRTA-1))/2 FOR
C               ISPIN=1, NVRTA*NVRTB FOR ISPIN=3, ETC.)
C       NSMSZ2- THE TOTAL SIZE OF THE I,J SYMMETRY VECTOR
C               FOR THIS SPIN CASE (NOCCA*(NOCCA-1))/2 FOR
C               ISPIN=1, NOCCA*NOCCB FOR ISPIN=3, ETC.)
C       SYVEC1- THE A,B SYMMETRY VECTOR
C       SYVEC2- THE I,J SYMMETRY VECTOR
C       TYPE  - ???????
C
C OUTPUT:
C       TOPT2 - THE NTOP LARGEST ELEMENTS IN THE T2 VECTOR
C               SORTED BY ABSOLUTE VALUE
C       I     - THE I INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       J     - THE J INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       A     - THE A INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       B     - THE B INDICES CORRESPONDING TO THE VALUES IN TOPT1
C
C SCRATCH:
C
C       T     - USED TO HOLD THE SYMMETRY-PACKED T VECTOR
C       ITOPT2- USED TO HOLD THE OFFSETS CORRESPONDING TO THE
C               ELEMENTS IN TOPT2
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A(NTOP),B(NTOP),SYVEC1(NSMSZ1),SYVEC2(NSMSZ2)
cjp
      integer itrue, jtrue,atrue,btrue
      CHARACTER*2 SPCASE(3)
      CHARACTER*1 TYPE
      DIMENSION T(NT2SIZ),TOPT2(NTOP),ITOPT2(NTOP),I(NTOP),
     &          J(NTOP)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      DATA SPCASE /'AA','BB','AB'/
cjp


cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)


C
C THIS ROUTINE PICKS UP A T2 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT2 AND THEIR ASSOCIATED INDICES
C  IN THE I,J,A AND B VECTORS.
C
C
C STATEMENT FUNCTIONS
C
      ILRG(INTX)=INT(0.5D0*(1.D0+SQRT(8.0*INTX-7)))+1
      NNM1O2(IX)=(IX*(IX-1))/2
C
      IF(NT2SIZ.EQ.0)RETURN
C
      CALL GETALL(T,NT2SIZ,1,ILIST)
C
C COMPUTE NORM OF T2 VECTOR
C
      X=SNRM2(NT2SIZ,T,1)
      T2NORM=X
C
C PUT NTOP LARGEST ELEMENTS INTO TOPT2 AND THEIR ASSOCIATED INDICES INTO
C   ITOPT2.
C
      CALL SCANVC(T,TOPT2,ITOPT2,NTOP,NT2SIZ)
C
C BRANCH HERE FOR DIFFERENT SPIN CASES, BECAUSE INDICES HAVE TO BE
C   FIRURED OUT FROM ITOPT2.
C
      DO 10 IRANK=1,NTOP
       CALL PCKIND(ITOPT2(IRANK),ISPIN,SYVEC1,SYVEC2,NSMSZ1,NSMSZ2,
     &             I(IRANK),J(IRANK),A(IRANK),B(IRANK))
10    CONTINUE
cjp
      if(isbwcc) then
cjp prepare spin indices according to ispin case
        if(ispin.eq.1) then
          isp1=1
          isp2=1
        else
          if(ispin.eq.2) then
            isp1=2
            isp2=2
          else
            isp1=1
            isp2=2
          endif
        endif
        write(*,202)type,SPCASE(ISPIN),iref
        else
      WRITE(*,200)TYPE,SPCASE(ISPIN)
        endif
200   FORMAT(T3,' Largest ',A1,'2 amplitudes for spin case ',A2,':')
202   format(T3,' Largest ',A1,'2 amplitudes for spin case ',A2,
     &    ' of reference no.: ',i3)
      IF(ISPIN.EQ.3)WRITE(*,299)
      WRITE(*,300)
299   FORMAT(3X,3(' ',3X,'_',3X,' ',3X,'_',13X))
300   FORMAT(3X,3('i',3X,'j',3X,'a',3X,'b',13X))
      WRITE(*,400)
400   FORMAT(77('-'))
cjp
      if(isbwcc) then
cjp ... this is not OK for uhf-cc, ignore for now
       if(bwgossip) then
      write(*,502) (irank,i(irank),j(irank),a(irank),b(irank),
     &   invhnum(i(irank),iref,isp1),
     & invhnum(j(irank),iref,isp2),invpnum(a(irank)-nocca,iref,isp1),
     & invpnum(b(irank)-nocca,iref,isp2),topt2(irank),irank=1,ntop)
        else
        write(*,500) (invhnum(i(irank),iref,isp1),invhnum(j(irank),
     &  iref,isp2),invpnum(a(irank)-nocca,iref,isp1),
     & invpnum(b(irank)-nocca,iref,isp2),topt2(irank),irank=1,ntop)
        endif
      else
      WRITE(*,500)(I(IRANK),J(IRANK),A(IRANK),B(IRANK),
     &                 TOPT2(IRANK),IRANK=1,NTOP)
      endif
      WRITE(*,400)
      WRITE(*,600)TYPE,SPCASE(ISPIN),NT2SIZ,T2NORM
      WRITE(*,400)
cpn
      if(isbwcc.and.bwgossip) then
c This will print all the amplitudes and their indexes in order
      write(*,203)type,spcase(ispin),iref
 203  format(t3,' List of all ',A1,'2 amplitudes for spin case ',A2,
     &    ' of reference no.: ',i3)
      if(ispin.eq.3)write(*,299)
      write(*,300)
      write(*,400)
      do 11 irank = 1, nt2siz
         call pckind(irank,ispin,syvec1,syvec2,nsmsz1,nsmsz2,
     &        i(1),j(1),a(1),b(1))
         itrue=invhnum(i(1),iref,isp1)
         jtrue=invhnum(j(1),iref,isp2)
cjp ... this is not OK for uhf-cc, ignore for now
         atrue=invpnum(a(1)-nocca,iref,isp1)
         btrue=invpnum(b(1)-nocca,iref,isp2)
         write(*,502)irank,i(1),j(1),a(1),b(1),itrue,jtrue,atrue,
     &         btrue,t(irank)
 11   continue
 502  format(3x,i5,6x,4i5,': true ind : ',4i5,':',f12.8)
      endif
cpn end
600   FORMAT(T3,' Norm of ',A1,'2',A2,' vector (',I9,
     &       ' symmetry allowed elements):',F14.10,'.')
500   FORMAT((2('[',I3,1X,I3,1X,I3,1X,I3,']',F8.5,1X),'[',I3,1X,
     &I3,1X,I3,1X,I3,']',F8.5))
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

      SUBROUTINE DDIH(CARTCOORD,N,P,O,M,IDIHS,TOTREDNCO,
     &                NRATMS,IREDUNCO,MAXREDUNCO,DERBMAT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      DOUBLE PRECISION VECU,VECW,VECV,LU,LV,LW
      INTEGER A,B,I,J,TOTREDNCO,M,N,O,P,NRATMS
      DIMENSION CARTCOORD(3*NRATMS), IREDUNCO(4,MAXREDUNCO),
     &          VECU(3),VECW(3),VECV(3),PRODUW(3),PRODVW(3),
     &          DERBMAT(3*NRATMS,3*NRATMS*TOTREDNCO)
C
      DINVPI = (ATAN(DFLOAT(1))*DFLOAT(4))/180.0D0

CSSS      Write(6,"(4I5)") N, P, O, M
CSSS      Write(6,*)
      CALL VEC(CARTCOORD(3*O - 2),CARTCOORD(3*M - 2),VECV,1)
      CALL VEC(CARTCOORD(3*P - 2),CARTCOORD(3*O - 2),VECW,1)
      CALL VEC(CARTCOORD(3*P - 2),CARTCOORD(3*N - 2),VECU,1)
C
      ANGLUW = ANGLE(VECU, VECW, 3)
      ANGLVW = ANGLE(VECV, VECW, 3) 

CSSS       Write(6, "(2F10.5)") ANGLUW, ANGLVW 
       IF ((ANGLUW .EQ. 0.0D0 .OR. ANGLUW .GT. 175.0D0) .OR. 
     &     (ANGLVW .EQ. 0.0D0 .OR. ANGLWV .GT. 175.0D0)) RETURN
C
c      print *,'vecu',vecu(1),vecu(2),vecu(3)
c      print *,'vecv',vecv(1),vecv(2),vecv(3)
c      print *,'vecw',vecw(1),vecw(2),vecw(3)

      LU = DIST(CARTCOORD(3*O - 2), CARTCOORD(3*M - 2))
      LW = DIST(CARTCOORD(3*O - 2), CARTCOORD(3*P - 2))
      LV = DIST(CARTCOORD(3*P - 2), CARTCOORD(3*N - 2))

      CPHIU = DDOT(3,VECU,1,VECW,1)
      SPHIU2 =1.0D0-CPHIU*CPHIU
      CPHIV = DDOT(3,VECV,1,VECW,1)
      SPHIV2 =1.0D0-CPHIV*CPHIV

      CALL CROSS(VECU,VECW,PRODUW,0)
      CALL CROSS(VECV,VECW,PRODVW,0)

      D1 = (LU**2)*SPHIU2**2
      D2 = (LV**2)*SPHIV2**2
      D3 = 2.0D0*LU*LW*SPHIU2**2
      D4 = 2.0D0*LV*LW*SPHIV2**2
      D5 = 2.0D0*(LW**2)*SPHIU2**2
      D6 = 2.0D0*(LW**2)*SPHIV2**2
      D7 = LU*LW*SPHIU2
      D8 = LV*LW*SPHIV2

      DO 40 I=1,3
      DO 50 J=1,3
         T1I1 = (PRODUW(I)*(VECW(J)*CPHIU-VECU(J)))/D1
         T1I2 = (PRODUW(J)*(VECW(I)*CPHIU-VECU(I)))/D1
         T1   = T1I1+T1I2

         T2I1 = (PRODVW(I)*(VECW(J)*CPHIV-VECV(J)))/D2
         T2I2 = (PRODVW(J)*(VECW(I)*CPHIV-VECV(I)))/D2
         T2   = (T2I1+T2I2)

         T3I1 = PRODUW(I)*(VECW(J)-2.0D0*VECU(J)*
     &          CPHIU+VECW(J)*CPHIU**2)/D3
         T3I2 = PRODUW(J)*(VECW(I)-2.0D0*VECU(I)*
     &          CPHIU+VECW(I)*CPHIU**2)/D3
         T3   = (T3I1+T3I2)


         T4I1 = PRODVW(I)*(VECW(J)-2.0D0*VECV(J)*
     &          CPHIV+VECW(J)*CPHIV**2)/D4
         T4I2 = PRODVW(J)*(VECW(I)-2.0D0*VECV(I)*
     &          CPHIV+VECW(I)*CPHIV**2)/D4
         T4   = (T4I1+T4I2)

         T5I1 = (PRODUW(I)*(VECU(J)+(VECU(J)*CPHIU**2)-
     &          (3.0D0*VECW(J)*CPHIU)+(VECW(J)*CPHIU**3)))/D5
         T5I2 = (PRODUW(J)*(VECU(I)+(VECU(I)*CPHIU**2)-
     &          (3.0D0*VECW(I)*CPHIU)+(VECW(I)*CPHIU**3)))/D5
         T5   = (T5I1+T5I2)

         T6I1 = (PRODVW(I)*(VECV(J)+(VECV(J)*CPHIV**2)-
     &          (3.0D0*VECW(J)*CPHIV)+(VECW(J)*CPHIV**3)))/D6
         T6I2 = (PRODVW(J)*(VECV(I)+(VECV(I)*CPHIV**2)-
     &          (3.0D0*VECW(I)*CPHIV)+(VECW(I)*CPHIV**3)))/D6
         T6   = (T6I1+T6I2)

         K=0
         IF (I.NE.J) THEN
            IF      (I+J.EQ.3) THEN
               K = 3
            ELSE IF (I+J.EQ.4) THEN
               K = 2
            ELSE IF (I+J.EQ.5) THEN
               K = 1
            END IF
         END IF

         GAMMIJ = (J-I)*(-0.5D0)**(ABS(J-I))

         T7FACT=GAMMIJ
         T8FACT=GAMMIJ

         T7I = (VECW(K)*CPHIU-VECU(K))/D7
         T8I = (VECW(K)*CPHIV-VECV(K))/D8
         T7  = T7FACT*T7I
         T8  = T8FACT*T8I

C  DIAGONAL TERMS
C  11
       DERBMAT((O-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)=
     &   -t2-2.0D0*t4-t5+t6
C  22
       DERBMAT((P-1)*3+I,3*NRATMS*(IDIHS-1)+(P-1)*3+J)=
     &   t1-2.0D0*t3-t5+t6
C  33
       DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(N-1)*3+J)=
     &   t1
C  44
       DERBMAT((M-1)*3+I,3*NRATMS*(IDIHS-1)+(M-1)*3+J)=
     &   -t2

C  OFFDIAGONAL TERMS
C  21
       DERBMAT((P-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)=
     &    t3+t4+t5-t6+t7-t8

      DERBMAT((O-1)*3+J,3*NRATMS*(IDIHS-1)+(P-1)*3+I)=
     & DERBMAT((P-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)

C  31
       DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)=
     &    -t3-t7

       DERBMAT((O-1)*3+J,3*NRATMS*(IDIHS-1)+(N-1)*3+I)=
     & DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)

C  41
       DERBMAT((M-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)=
     &    t2+t4+t8

       DERBMAT((O-1)*3+J,3*NRATMS*(IDIHS-1)+(M-1)*3+I)=
     & DERBMAT((M-1)*3+I,3*NRATMS*(IDIHS-1)+(O-1)*3+J)

C  32
       DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(P-1)*3+J)=
     &    -t1+t3+t7

       DERBMAT((P-1)*3+J,3*NRATMS*(IDIHS-1)+(N-1)*3+I)=
     & DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(P-1)*3+J)

C  42
       DERBMAT((M-1)*3+I,3*NRATMS*(IDIHS-1)+(P-1)*3+J)=
     &    -t4-t8

       DERBMAT((P-1)*3+J,3*NRATMS*(IDIHS-1)+(M-1)*3+I)=
     & DERBMAT((M-1)*3+I,3*NRATMS*(IDIHS-1)+(P-1)*3+J)

C  34
       DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(M-1)*3+J)=
     &    0.0D0

c      DERBMAT((M-1)*3+J,3*NRATMS*(IDIHS-1)+(N-1)*3+I)=
c    & DERBMAT((N-1)*3+I,3*NRATMS*(IDIHS-1)+(M-1)*3+J)

c      PRINT *,'I,J,K',I,J,K
c      print *,'33',t1 - 2.0D0*t3 - t5 + t6
c      PRINT *,'23',-t1 + t3 + GAMMIJ*t7I
c      print *,'34',t3 + t4 + t5 - t6
c    &                      + GAMMIJ*(t7I-T8I)
c      print *,'44',-t2 - 2.0D0*t4 + t6 - t5
c      print *,'24',-t3 - GAMMIJ*t7I
c      print *,'53',-t4 - GAMMIJ*T8I
c      print *,'54',t2 + t4 + GAMMIJ*T8I
c      print *,'55',-t2
c      PRINT *,'22',t1

50    CONTINUE
40    CONTINUE

CSSS      PRINT *,'DERIVATIVE OF THE BMAT FOR ATOMS',N,P,O,M
CSSS      CALL OUTPUT(DERBMAT,1,3*NRATMS,3*NRATMS*(IDIHS-1)+1,
CSSS     &              3*NRATMS*(IDIHS-1)+3*NRATMS,3*NRATMS,
CSSS     &              3*NRATMS*TOTREDNCO,1)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ENER2FCM(NDIM,ENERGY,FCM,INVOP,STPSIZ,E0,DSCR,NDSCR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION ENERGY(*),FCM(NDIM,NDIM)
      double precision dscr(ndim,*)

      LOGICAL ONEGRD,PRINTQ

      COMMON /FLAGS/ IFLAGS(100)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA FACT /5.14048D03/

      PRINTQ=(IFLAGS(1).GE.1)

C IF THE REPRESENTATION IS TOTALLY SYMMETRIC, THEN WE HAVE DONE ONLY
C ONE DISPLACEMENT FOR EACH DEGREE OF FREEDOM.

      ONEGRD=(INVOP.GT.0)

      IF (ONEGRD) THEN

c      o evaluate diagonal force constant matrix elements
         DTMP=2.d0/(STPSIZ*STPSIZ)
         E00=-DTMP*E0
         IOFFT=1
         DO IDIM=1,NDIM
            FCM(IDIM,IDIM)=E00+DTMP*ENERGY(IOFFT)
            IOFFT=IOFFT+IDIM+1
         END DO

c      o compute off-diagonal upper triangle force constants
         DTMP=0.5d0*DTMP
         E00=-DTMP*E0
         IOFFT0=2
         DO IDIM1=2,NDIM
            Z=E00-0.5d0*FCM(IDIM1,IDIM1)
            IOFFT=IOFFT0
            DO IDIM2=1,IDIM1-1
               FCM(IDIM2,IDIM1)=Z+DTMP*ENERGY(IOFFT)
     &                           -0.5d0*FCM(IDIM2,IDIM2)
               IOFFT=IOFFT+1
            END DO
            IOFFT0=IOFFT0+IDIM1
         END DO

      ELSE

c      o evaluate diagonal force constant matrix elements
         DTMP=1.d0/(STPSIZ*STPSIZ)
         E00=-2.d0*DTMP*E0
         IOFFT=1
         DO IDIM=1,NDIM
            FCM(IDIM,IDIM)=E00+DTMP*(ENERGY(IOFFT)+ENERGY(IOFFT+1))
            IOFFT=IOFFT+2*(IDIM+1)
         END DO

c      o compute off-diagonal upper triangle force constants
         E00=-DTMP*E0
         DTMP=0.5d0*DTMP
         IOFFT0=3
         DO IDIM1=2,NDIM
            Z=E00-0.5d0*FCM(IDIM1,IDIM1)
            IOFFT=IOFFT0
            DO IDIM2=1,IDIM1-1
               FCM(IDIM2,IDIM1)=Z+DTMP*(ENERGY(IOFFT)+ENERGY(IOFFT+1))
     &                           -0.5d0*FCM(IDIM2,IDIM2)
               IOFFT=IOFFT+2
            END DO
            IOFFT0=IOFFT0+2*IDIM1
         END DO

      END IF

      if (ndscr.lt.ndim*(4+ndim)) then
         print *, '@ENER2FCM: Insufficient memory.'
         print *, '           need ',ndim*(4+ndim),' doubles'
         print *, '           have ',ndscr,' doubles'
         call aces_exit(1)
      end if

c   o reflect upper triangle into lower triangle (make a copy for DSYEV)
      DO IDIM2=1,NDIM-1
         DSCR(IDIM2,1+IDIM2)=FCM(IDIM2,IDIM2)
         DO IDIM1=IDIM2+1,NDIM
            FCM(IDIM1,IDIM2)=FCM(IDIM2,IDIM1)
            DSCR(IDIM1,1+IDIM2)=FCM(IDIM2,IDIM1)
         END DO
      END DO
      DSCR(NDIM,1+NDIM)=FCM(NDIM,NDIM)

      IF (PRINTQ) THEN
         WRITE(6,1010)
1010     FORMAT(T3,'Force constant matrix : ')
         WRITE(6,1011)((I,J,FCM(I,J),J=1,NDIM),I=1,NDIM)
1011     FORMAT(3('[',I3,',',I3,']',1X,F9.6,1X),'[',I3,',',I3,']',1X,
     &          F9.6)
      END IF

c   o diagonalize force constant matrix
      LWORK = ndscr - ndim*(ndim+1)
      CALL DSYEV('N','L',NDIM,DSCR(1,2),NDIM,DSCR(1,1),
     &                   DSCR(1,NDIM+2),LWORK,I)
      if (i.ne.0) then
         print *, '@ENER2FCM: Eigensolver failed.'
         print *, '           dsyev returned error ',i
         call aces_exit(i)
      end if

c   o print the frequencies
      WRITE(6,1000)
1000  FORMAT(T3,'Vibrational frequencies  (cm-1) :')
      DO IMODE=1,NDIM
         X=DSCR(IMODE,1)
         IF (X.LT.0.d0) THEN
            WRITE(6,1001)IMODE,SQRT(-X)*FACT
1001        FORMAT(T3,I5,1X,F10.5,'i')
         ELSE
            WRITE(6,1002)IMODE,SQRT(X)*FACT
1002        FORMAT(T3,I5,1X,F10.5)
         END IF
      END DO

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine index_match(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
c--------------------------------------------------------------------------
c  In this routine the first array is copied into the second.  
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
      include 'mpif.h'
      include 'epsilon.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table, array_type
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i, j, k, sind 
      integer array, index, nindex, ierr
      integer block, blkndx, seg
      integer find_current_block
      integer*8 indblk1, indblk2, get_block_index
      integer stack
      integer nsend 

      integer comm

      integer fop1(mx_array_index), fop2(mx_array_index)
      integer sop1(mx_array_index), sop2(mx_array_index)
      integer sindex(mx_array_index), findex(mx_array_index) 
      integer type(mx_array_index) 
      integer na1, na2, ni1, ni2
      integer*8 addr, get_index_from_base
      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

#ifdef ALTIX
      dptr = dshptr
#endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the first array: c_result_array 
c---------------------------------------------------------------------------

      array = op(c_result_array)
      nindex = array_table(c_nindex, array) 

      if (nindex .ne. 2) then 
         print *,'ERROR: The array in index match MUST have two 
     *            indeces, yours has', nindex
         call abort_job() 
      endif 

      do i = 1, nindex
         index   = array_table(c_index_array1+i-1,array)
         type(i) = index_table(c_index_type, index)
         seg     = index_table(c_current_seg,index)

         sindex(i) = index 
         call get_index_segment(index, seg, segment_table,
     *                             nsegment_table, index_table,
     *                             nindex_table, fop1(i), fop2(i))
      enddo


      if (array_table(c_array_type,array) .eq. static_array) then
         addr    = address_table(array)
         indblk1 = get_index_from_base(addr, x, 2)
      else
         block = find_current_block(array, array_table(1,array),
     *                             index_table, nindex_table,
     *                             segment_table, nsegment_table,
     *                             block_map_table, blkndx)

         stack   = array_table(c_array_stack,array)
         indblk1 = get_block_index(array, block, stack,
     *                            blkndx, x, .true.)
      endif

c---------------------------------------------------------------------------
c   Detrmine the parameters of the second array: c_op1_array 
c---------------------------------------------------------------------------

      array = op(c_op1_array)
      array_type = array_table(c_array_type, array)

      if (array_type .ne. scalar_value) then
         print *,'Error: Second array in index_match must be a scalar.'
         call abort_job()
      endif

      sind = array_table(c_scalar_index, array)
  
      scalar_table(sind) = 0.0 
      do i = fop1(2), fop2(2) 
         if (i .eq. fop1(1)) scalar_table(sind) = 1.0 
      enddo 

c     write(6,*) 'INDEX_MATCH:', fop1(1), fop1(2), fop1(2), fop2(2), 
c    *            scalar_table(sind)  

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine process_server_delete_message(node, server_table,
     *                                   nserver_table)
c---------------------------------------------------------------------------
c   This subroutine handles the processing and manages state transitions
c   of a server_delete message.
c---------------------------------------------------------------------------
      implicit none
      include 'server.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'dbugcom.h'
      include 'server_stat.h'

      integer nserver_table
      integer server_table(lserver_table_entry,nserver_table)
      integer i, j, k, n
      integer node
      integer state
      integer array, iblock, istart, nsearch

      state = server_msg(c_msg_state,node)
      if (state .eq. begin_state) then
         array = server_msg(c_msg_array, node) 

c---------------------------------------------------------------------------
c   Search the server_table for entries pertaining to this array.
c---------------------------------------------------------------------------

          do i = 1, nserved_arrays
            if (served_array_table(i) .eq. array) then
               istart = served_array_entry(i)
               nsearch = served_numblocks(i)
               go to 50
            endif
         enddo

c-----------------------------------------------------------------------------
c   There is no data for this array on the server.  Probably this is a tiny 
c   job run on more servers than necessary.  We have nothing to do.
c-----------------------------------------------------------------------------

         istart = 0
         nsearch = 0

c         print *,'Error: Cannot find array ',array,
c     *       ' in served array table'
c         call server_abort_job(server_table, nserver_table)
   50    continue

         do i = istart, istart + nsearch - 1
            if (server_table(c_server_diskloc,i) .gt. 0) then

c---------------------------------------------------------------------------
c   Negate the diskloc.  This indicates that the block is "up for grabs".
c---------------------------------------------------------------------------

               server_table(c_server_diskloc,i) = 
     *              -server_table(c_server_diskloc,i)
            endif

c---------------------------------------------------------------------------
c   Remove any references to the data in memory.
c---------------------------------------------------------------------------

            iblock = server_table(c_server_memloc,i)
            if (iblock .gt. 0) then
               if (and(server_table(c_server_flags,i),
     *                 server_dirty_flag) .ne. 0) then
                 call mark_block_clean(iblock, server_table,
     *                                  nserver_table)
               endif

               server_table(c_server_memloc,i) = 0
               server_table_ptr(iblock) = 0
            endif

c---------------------------------------------------------------------------
c   Clear the server flags for the block.
c---------------------------------------------------------------------------

            server_table(c_server_flags,i) = 0
         enddo

         server_msg(c_msg_state,node) = null_state
      endif

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_data() 
      implicit none
      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'hess.h'
      include 'machine_types.h'
      include 'dbugcom.h'
      include 'trace.h'
      include 'dropmo.h'
      include 'sial_config_params.h'
      include 'frag_def.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer*8 c_loc64
      integer moa, mob
      integer ntemp

      integer i, j, n, ierr
      integer nalpha, npcoef
      integer dummy
      integer lnp1, lnpo
      integer ione
      integer          nfct(max_centers), nufct(max_centers)
      integer          naoatm(max_centers)
      integer          npop(max_centers)
      integer          ireorder(max_centers) 
      integer          natoms
      integer          nscfa_fock, nscfb_fock
      integer          ieom_temprt, ieom_roots, iexcite  ! Watson Added
      character*4      atmnam(max_centers)
      logical          cartesian
      logical          uhf
      logical dropit 
      integer          ijunk(500)
      logical*8        l8false
      double precision dbuf(1)
#ifdef ALTIX
      pointer (dptr, dbuf)
#else
      common dbuf
#endif
      double precision vnn, nuclear_nuclear_repulsion_energy

#ifdef ALTIX
      dptr = dshptr   ! set dbuf ptr to shared memory.
#endif

c-------------------------------------------------------------------------
c   scf_init() initializes the ACES II I/O subsystem so that JOBARC may 
c   be read.
c-------------------------------------------------------------------------

      call scf_init(vnn)

c-------------------------------------------------------------------------
c   Read original MOL file, create a new one with the subshells split.
c   The new MOL file will be named CHSSI.MOL, and we will work from
c   CHSSI.MOL from this point on.
c
c   This will allow us to perform finer segmentation of the AO indices 
c   later on.
c-------------------------------------------------------------------------

c      call segment_mol(molfile, 'CHSSI.MOL', 12, 13, iErr)
c      if (ierr .ne. 0) then
c         print *,'Error: Cannot process ',molfile
c         print *,'Error code ',ierr
c         call abort_job()
c      endif

c-------------------------------------------------------------------------
c   Inspect the MOL file to determine problem size.  Contraction 
c   coefficients and exponents are not read in at this stage.
c-------------------------------------------------------------------------

CDEBUG      call simple_inspect_mol('CHSSI.MOL', max_centers, max_shells, 
      call simple_inspect_mol('MOL', max_centers, max_shells, 
     *           ncenters, nshells, nspc, 
     *           cartesian, ITFCT, LNP1, LNPO, Nfct,
     *           nufct, nbasis, naobasis, nCFPS, nPFpS,
     *           naoatm, ivAngMom, atom)

      write(6,*) ' NBASIS AFTER SIMPLE_INSPECT ', nbasis  
      if (cartesian) then
         ispherical = 0
      else
         ispherical = 1
      endif

      do i = 1, ncenters
         npop(i)     = 1
         ireorder(i) = i
      enddo

c---------------------------------------------------------------------------
C Compute the gradient of the Nuclear-Nuclear repulsion energy
C---------------------------------------------------------------------------

      call mem_alloc(dbuf, 9*ncenters*ncenters, bytes_per_double, 
     *               ix_hess, .true., ierr)
      if (ierr .ne. 0) then
         print *,'Error attempting to malloc hessian.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif 

      call mem_alloc(dbuf,  9*ncenters*ncenters, bytes_per_double, 
     *               ix_nnhess, .true., ierr)
      if (ierr .ne. 0) then
         print *,'Error attempting to malloc nuclear-nuclear hessian.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif 

      call nuclear_nuclear_gradient(dbuf(ix_hess), dbuf(ix_NNhess), 
     *                              ncenters)

c--------------------------------------------------------------------------
c   Allocate memory for exponents, coordinates, and basis functions.
c--------------------------------------------------------------------------

      nalpha = 0
      npcoef = 0
      do i = 1, nshells
         nalpha = nalpha + npfps(i)
         npcoef = npcoef + npfps(i) * ncfps(i)
      enddo

      nalloc_pkg = 3*nshells + nalpha + npcoef 
      call mem_alloc(dbuf, nalloc_pkg, bytes_per_double, master_icoord, 
     *               .true., ierr)
      if (ierr .ne. 0) then
         print *,'Error attempting to malloc basis data.'
         call mpi_abort(mpi_comm_world, 1, ierr)
      endif

      ialpha  = master_icoord + 3*nshells
      ipcoeff = ialpha + nalpha

c-------------------------------------------------------------------------
c   Read orbital values from JOBARC.
c-------------------------------------------------------------------------

      ione = 1

      if ((.not. if_scf) .and. .not. dryrun) then
         call igetrec(1, 'JOBARC', 'OCCUPYA0', 1, nalpha_occupied)
         call dgetrec(1, 'JOBARC', 'SCFENEG',  ione, scf_energy)
         call dgetrec(1, 'JOBARC', 'TOTENERG',  ione, totenerg)
      else
         scf_energy = 0.
         totenerg = 0.
      endif
      noccupied       = nalpha_occupied

      call igetrec(1,'JOBARC','IFLAGS',100,iJunk)

c------------------------------------------------------------------------
c   Retrieve flags parameters.
c------------------------------------------------------------------------

      iuhf = ijunk(11)
      if (dbg) print *,'IUHF = ',iuhf
      damp_init = ijunk(15) * .01
      scf_conv = 10.0d0**(-ijunk(5))
      cc_conv  = 10.0d0**(-ijunk(4))

      cc_iter = ijunk(7)
      if (cc_iter .eq. 0) then
         print *,'WARNING: ACES has defaulted cc_maxcyc to 0, ',
     *     ' resetting to 100.'
         cc_iter = 100
      endif

      cc_hist = ijunk(12)
      if (cc_hist .eq. 0) then
         print *,'WARNING: ACES has defaulted cc_exporder to 0,',
     *      ' resetting to 5.'
         cc_hist = 5
      endif

      cc_beg  = 2
      scf_iter = ijunk(16)
      scf_hist = ijunk(20)
      scf_beg  = ijunk(40)

c     Kluggy way of dealing with this VFL 1/2/2013 
      if (scf_beg .ge. 8) then 
         write(6,*) ' Resetting scf_beg to 2 '
         scf_beg = 2 
      endif 

      vib_freq_calc = .false. 
      if (ijunk(54) .ne. 0) vib_freq_calc = .true.
      vib_exact = .false.
      if (ijunk(54) .eq. 1) vib_exact = .true.
C
C Watson Added: For EOM calcs.
C
      iexcite = 0
      iexcite = ijunk(87)
      if (iexcite .gt. 0) then
         excite = DBLE(iexcite)
         eom_tol = 10.0d0**(-ijunk(98))
         call igetrec(-1, 'JOBARC', 'EESYMINF', 1, ieom_roots)
         write(*,*) ' ieom_roots: ', ieom_roots
         if (ieom_roots .eq. 0) then
            print *,'WARNING: ACES has defaulted ESTATE_SYM to 0, ',
     *        ' resetting to 4.'
            ieom_roots = 4
         endif
         eom_roots = DBLE(ieom_roots)
         ieom_temprt = ieom_roots
      endif
      if (iexcite .eq. 0) ieom_temprt = 0
C
C Watson
C

c-------------------------------------------------------------------------
c   Read IFLAGS2 off JOBARC.
c-------------------------------------------------------------------------

      call igetrec(1,'JOBARC','IFLAGS2',500,iJunk)

      geom_opt = .false.
      if (ijunk(5) .ne. 0) geom_opt = .true.

c------------------------------------------------------------------------
c   Allocate memory for the scf coefficient arrays, and read them in from
c   the ACES II JOBARC file.
c------------------------------------------------------------------------

      if ((.not. if_scf) .and. .not. dryrun) then
         call dgetrec(0,'JOBARC', 'SCFEVCA0', nscfa, dummy)   ! get reclen

         if (nscfa .lt. 0) then
            print *,'Error: ACES JOBARC file does not contain ',
     *           'SCFEVCA0 data'
            call abort_job()
         endif

         if (dbg) write(6,*) ' IUHF in init :', iuhf
         if (iuhf .eq. 2) then    ! ROHF
            call dgetrec(0,'JOBARC', 'FOCKA', nscfa_fock, dummy)

            if (nscfa_fock .lt. 0) then
               print *,'Error: ACES JOBARC file does not contain ',
     *           'FOCKA data'
               call abort_job()
            endif

            if (nscfa_fock .ne. nscfa) then
               print *,'Error: FOCKA has ',nscfa_fock,' elements, ',
     *            'should match SCFEVCA0 ',nscfa
               call abort_job()
            endif
         endif ! ROHF
      else
         nscfa = nbasis * nbasis 
      endif   

c---------------------------------------------------------------------------
c   If the gradient has been previously calculated (partially), read it 
c   from the JOBARC.
c---------------------------------------------------------------------------

      call dgetrec(0,'JOBARC', 'GRADIENT', n, dummy)

      if (n .gt. 0) then
          call dgetrec(1,'JOBARC', 'GRADIENT', n, gradient_data)
      else
         do i = 1, 3*ncenters
            gradient_data(i) = 0.
         enddo
      endif 
      
      call mem_alloc(dbuf, nscfa, bytes_per_double, iscfa, 
     *               .true., ierr)
      if (ierr .ne. 0) then
         print *,'mem_alloc for eigenvectors failed: nscfa = ',
     *     nscfa
         call abort_job()
      endif

      if ((.not. if_scf) .and. .not. dryrun) then
         call dgetrec(1, 'JOBARC', 'SCFEVCA0', nscfa, dbuf(iscfa))

c-------------------------------------------------------------------------
c   For ROHF, read in the FOCKA array.
c-------------------------------------------------------------------------

         if (iuhf .eq. 2) then   ! ROHF
            call mem_alloc(dbuf, nscfa, bytes_per_double,
     *                               ifockrohfa, .true., ierr)
            call dgetrec(1,'JOBARC','FOCKA', nscfa, dbuf(ifockrohfa))
         endif   ! ROHF
      endif

      if ((.not. if_scf) .and. .not. dryrun) then
         call dgetrec(0, 'JOBARC', 'SCFEVLA0', nepsa, dummy) 

         if (nepsa .lt. 0) then
             print *,'Error: ACES JOBARC file does not contain ',
     *          'SCFEVLA0 data.'
             call abort_job()
         endif
      else
         nepsa = nbasis
      endif

      call mem_alloc(dbuf, nepsa, bytes_per_double, iepsa, 
     *               .true., ierr)
      if (ierr .ne. 0) then
         print *,'mem_alloc for eigenvalues failed: nscfa = ',nscfa
         call abort_job()
      endif
     
      if ((.not. if_scf) .and. .not. dryrun) then
         call dgetrec(1, 'JOBARC', 'SCFEVLA0', nepsa, dbuf(iepsa))
      endif

c---------------------------------------------------------------------------
c   Look for beta spin data.
c---------------------------------------------------------------------------

      if (iuhf .eq. 0) then
         nscfb = -1
      else
         if ((.not. if_scf) .and. .not. dryrun) then
            call dgetrec(0,'JOBARC', 'SCFEVCB0', nscfb, dummy)   ! get reclen

            if (iuhf .eq. 2) then   ! ROHF
               call dgetrec(0,'JOBARC', 'FOCKB', nscfb_fock, dummy)

               if (nscfb_fock .le. 0) then
                  print *,'Error: FOCKB data is not on JOBARC'
                  call abort_job()
               endif

               if (nscfb_fock .ne. nscfb) then
                  print *,'Error: FOCKB has ',nscfb_fock,' elements,',
     *               ' should match SCFEVCB0 ',nscfb
                  call abort_job()
               endif
            endif   ! ROHF
         else
            nscfb = nbasis * nbasis
         endif
      endif

      if (nscfb .lt. 0) then

c-----------------------------------------------------------------------------
c   If ACES is telling us this is RHF, we must run a true RHF version of
c   the SCF SIAL code, then copy over the alpha-spin eigenvalue data into the
c   beta-spin eigenvalues.
c-----------------------------------------------------------------------------

         uhf = .false.
         nbeta_occupied = nalpha_occupied
         nscfb = nscfa
         print *,'*** WARNING: ACES has specified a RHF run. ',
     *      ' Either use REF=UHF in ACES or run a true RHF SIAL code.',
     *       '***'
      else
         uhf = .true.
      endif

      call mem_alloc(dbuf, nscfb, bytes_per_double, iscfb, 
     *                 .true., ierr)
      if (ierr .ne. 0) then
         print *,'mem_alloc for beta eigenvectors fialed: nscfb ',
     *     nscfb
         call abort_job()
      endif

      if (iuhf .eq. 2)
     *     call mem_alloc(dbuf, nscfb, bytes_per_double,
     *                                ifockrohfb, .true., ierr)

      if ((.not. if_scf) .and. uhf .and. .not. dryrun) then

c--------------------------------------------------------------------------
c  Read beta eigenvectors from JOBARC.
c--------------------------------------------------------------------------

         call dgetrec(1, 'JOBARC', 'SCFEVCB0', nscfb, dbuf(iscfb))

         if (iuhf .eq. 2) then   ! ROHF
            call dgetrec(1,'JOBARC','FOCKB', nscfb, dbuf(ifockrohfb))
         endif    ! ROHF
      else

c--------------------------------------------------------------------------
c   Copy alpha eigenvectors into the beta eigenvectors.
c--------------------------------------------------------------------------

         do i = 1, nscfa
            dbuf(iscfb+i-1) = dbuf(iscfa+i-1)
         enddo
      endif

      if ((.not. if_scf) .and. uhf .and. .not. dryrun) then

c---------------------------------------------------------------------------
c   Read number of beta eigenvalues from JOBARC.
c---------------------------------------------------------------------------

         call dgetrec(0, 'JOBARC', 'SCFEVLB0', nepsb, dummy)

         if (nepsb .lt. 0) then
             print *,'Error: ACES JOBARC file does not contain ',
     *           'SCFEVLB0 data.'
             call abort_job()
         endif
      else
         nepsb = nbasis 
      endif

      call mem_alloc(dbuf, nepsb, bytes_per_double, iepsb, 
     *                  .true., ierr)
      if (ierr .ne. 0) then
         print *,'mem_alloc for beta eigenvalues failed: nscfb ',nscfb
         call abort_job()
      endif

      if ((.not. if_scf) .and. uhf .and. .not. dryrun) then

c---------------------------------------------------------------------------
c   Read actual beta-spin eigenvalues from JOBARC.
c---------------------------------------------------------------------------

         call dgetrec(1, 'JOBARC', 'SCFEVLB0', nepsb, dbuf(iepsb))
      else

c--------------------------------------------------------------------------
c   Copy alpha-spin eigenvalues into beta-spin eigenvalues.
c--------------------------------------------------------------------------

         do i = 1, nepsb
            dbuf(iepsb+i-1) = dbuf(iepsa+i-1)
         enddo
      endif

      if ((.not. if_scf) .and. uhf .and. .not. dryrun) then
         call igetrec(1, 'JOBARC', 'OCCUPYB0', 1, nbeta_occupied)
      endif

CDEBUG      call read_basis_info('CHSSI.MOL', ncenters, ncenters, npop, 
      call read_basis_info('MOL', ncenters, ncenters, npop, 
     *           ireorder, cartesian, itfct, lnp1, lnpo, nfct, 
     *           nbasis, dbuf(ialpha), ixalpha, 
     *           dbuf(ipcoeff), ixpcoef, atmnam, 
     *           dbuf(master_icoord), naoatm)
 
c-------------------------------------------------------------------------
c   If the SCF has already been performed check if MOs are to be dropped.
c-------------------------------------------------------------------------

      nalpha_virtual = nbasis - nalpha_occupied 
      nbeta_virtual  = nbasis - nbeta_occupied 

      write(6,*) ' NALPHA_VIRT =' , nalpha_virtual 
      write(6,*) ' NBETA_VIRT =' , nbeta_virtual 
      

C--------------------------------------------------------------------------
c   Check if any MO's are to be dropped.
C--------------------------------------------------------------------------

      CALL IGETREC(20,'JOBARC','NUMDROPA',1,NDROPMO_A)
      if (ndropmo_a .gt. 0) 
     *    CALL IGETREC(20,'JOBARC','MODROPA',NDROPMO_A,MODROP_A)

      ndropmo_b = ndropmo_a

      if (.not. ignore_dropmo) then

      if (ndropmo_a .gt. 0) then 

c----------------------------------------------------------------------------
c   Check to see if NUMDROPB is defined.  For RHF jobs, joda does not set it,
c   so we must copy over the alpha dropmo's in that case.
c----------------------------------------------------------------------------

         CALL IGETREC(0,'JOBARC','NUMDROPB',dummy, ndropmo_b)
         if (dummy .gt. 0) then   ! NUMDROPB is set.
            CALL IGETREC(20,'JOBARC','NUMDROPB',1,NDROPMO_B)
            if (ndropmo_b .gt. 0) 
     *         CALL IGETREC(20,'JOBARC','MODROPB',NDROPMO_B,MODROP_B)
         else   ! NUMDROPB is not set.

c-----------------------------------------------------------------------------
c   Copy over the alpha DROPMO values.
c-----------------------------------------------------------------------------

            ndropmo_b = ndropmo_a
            do i = 1, ndropmo_b
               modrop_b(i) = modrop_a(i)
            enddo
         endif
      endif

      if ((ndropmo_a .gt. 0 .or. ndropmo_b .gt. 0) .and. 
     *    .not. ignore_dropmo) then 

C--------------------------------------------------------------------------
c   Reset the alpha eigenvectors if DROPMO. 
C--------------------------------------------------------------------------

         do j = 1, nbasis
            moamap(j) = 0
            mobmap(j) = 0 
         enddo

         moa = 0
         do j = 1, nbasis
            dropit = .false.

            do i = 1, ndropmo_a
               if (modrop_a(i) .eq. j) then
                  dropit = .true.
                  go to 11
               endif
            enddo

            moa = moa +1 
   11       continue

c------------------------------------------------------------------------
c   Move data for eigenvalue/eigenvector "j" to "moa".
c------------------------------------------------------------------------

            if (j .ne. moa .and. .not. dropit) then
               dbuf(iepsa+moa-1) = dbuf(iepsa+j-1)
               moamap(moa) = j 

               do i = 1, nbasis
                  dbuf(iscfa+nbasis*(moa-1)+i-1) = 
     *                 dbuf(iscfa+(j-1)*nbasis+i-1) 
               enddo
            endif
         enddo

C--------------------------------------------------------------------------
c   Reset the beta eigenvectors if DROPMO. 
C--------------------------------------------------------------------------

         if (ndropmo_b .gt. 0) then
            mob = 0 
            do j = 1, nbasis
               dropit = .false.

               do i = 1, ndropmo_b
                  if (modrop_b(i) .eq. j) then
                     dropit = .true.
                     go to 10
                  endif  
               enddo

               mob = mob +1 
   10          continue

c------------------------------------------------------------------------
c   Move data for eigenvalue/eigenvector "j" to "mob".
c------------------------------------------------------------------------

               if (j .ne. mob .and. .not. dropit) then
                  dbuf(iepsb+mob-1) = dbuf(iepsb+j-1)
                  mobmap(mob) = j 

                  do i = 1, nbasis
                     dbuf(iscfb+nbasis*(mob-1)+i-1) = 
     *                 dbuf(iscfb+(j-1)*nbasis+i-1) 
                  enddo
               endif
            enddo
         endif

C--------------------------------------------------------------------------
c   Reset the number of virtual orbitals if they were dropped. 
C--------------------------------------------------------------------------
c
C JNB: do not do virtual drop for fno sial program. 
         if(.not. if_fno) then
         nalpha_virtual = nbasis - nalpha_occupied    
         enalpha_virtual = nalpha_virtual
         do i = 1, ndropmo_a 
            if (modrop_a(i) .gt. nalpha_occupied) 
     *         nalpha_virtual = nalpha_virtual - 1  
         enddo 
c
         nbeta_virtual = nbasis - nbeta_occupied    
         enbeta_virtual = nbeta_virtual
         do i = 1, ndropmo_b 
            if (modrop_b(i) .gt. nbeta_occupied) 
     *      nbeta_virtual = nbeta_virtual - 1  
         enddo 
         endif
c
C--------------------------------------------------------------------------
c   Reset the number of occupied orbitals if they were dropped. 
C--------------------------------------------------------------------------
c
         enalpha_occupied = nalpha_occupied
         ntemp = nalpha_occupied 
         do i = 1, ndropmo_a 
            if (modrop_a(i) .le. nalpha_occupied) ntemp = ntemp - 1  
         enddo 
         nalpha_occupied = ntemp  
         nepsa           = nbasis - ndropmo_a   
c
         enbeta_occupied = nbeta_occupied
         ntemp = nbeta_occupied 
         do i = 1, ndropmo_b 
            if (modrop_b(i) .le. nbeta_occupied) ntemp = ntemp - 1  
         enddo 
         nbeta_occupied = ntemp  
         nepsb           = nbasis - ndropmo_b  

         write(6,*) ' Number of alpha virtuals = ', nalpha_virtual 
         write(6,*) ' Number of beta virtuals = ', nbeta_virtual 
         write(6,*) ' Number of alpha occupied = ',nalpha_occupied 
         write(6,*) ' Number of beta occupied = ',nbeta_occupied 

c
      endif ! ndropmo > 0 
c
      endif ! ((.not. ignore_dropmo then

c-------------------------------------------------------------------------
c   If we are running a SCF job, reset the energy variables and gradient
c   accumulation to 0.  The assumption is that this is the beginning of
c   a new gradient accumulation cycle.
c-------------------------------------------------------------------------

      if (if_scf .or. init_scf) then
         scf_energy = 0.
         totenerg   = 0.
         
         do i = 1, 3*ncenters
            gradient_data(i) = 0.
         enddo
      endif

      if (scf_energy .eq. 0.d0) then
C
C Compute the Nuclear-Nuclear repulsion energy
C --------------------------------------------
C
         vnn = nuclear_nuclear_repulsion_energy(nCenters)

         scf_energy = vnn
         print *,'SCF ENERGY IS INITIALIZED FROM ',
     *       'NUCLEAR-NUCLEAR REPULSION ENERGY: ',scf_energy
      endif

      print *,'--------- Required data from MOL file -----------'
      print *,'Number of centers.....................',nCenters
      print *,'Number of shells......................',nShells
      print *,'Cartesian flag........................',cartesian
      print *,'Total number of basis functions.......',nbasis
      print *,'Total number of primitive functions...',nalpha
      print *,'Initial SCF energy....................',scf_energy
      print *,'SCF damping factor....................',damp_init
      print *,'SCF convergence tolerance.............',scf_conv
      print *,'Number of SCF iterations..............',scf_iter
      print *,'Number of SCF histories for DIIS......',scf_hist
      print *,'Beginning iteration for SCF DIIS......',scf_beg
      print *,'CCSD convergence tolerance............',cc_conv
      print *,'Number of CCSD iterations.............',cc_iter
      print *,'Number of CCSD histories for DIIS.....',cc_hist
      print *,'Beginning iteration for CCSD DIIS.....',cc_beg
      print *,'Excited state computation.............',iexcite .gt. 0
      print *,'EOM-CCSD converged tolerance..........',eom_tol ! Watson added
      print *,'Number of EOM-CCSD roots to find......',ieom_temprt
      print *,'Geometry optimization calc............',geom_opt
      print *,'Vibrational frequency calc............',
     *                                  vib_freq_calc
  
      print *,'  Shell     Contracted fns.   Primitive Fns. '
      print *,'  -----     ---------------   --------------' 

      do i = 1, nshells
         print 200,i, nCFpS(i),nPFpS(i),
     *        (dbuf(master_icoord+(i-1)*3+j-1) ,j=1,3)
      enddo

      return
  100 format (1x,a4,3(2x,d14.6))
  200 format(2x,i4,12x,i3,15x,i3,3(1x,d20.12))

c     end subroutine init_data
      end

C THIS ROUTINE TRANSFORMS THE SYMMETRY COORDINATE GRADIENT VECTOR
C TO THE CARTESIAN REPRESENTATION.

c INPUT
c integer NATOM           : number of atoms
c double  SYMGRD(3*NATOM) : symmetry coordinate gradient
c integer NDSCR           : the amount of double scratch at DSCR
c char*4  TYPE            : (FULL|COMP) point group
c logical PRINTQ          : verbose printing flag

c OUTPUT
c double CARTGRD(3*NATOM) : cartesian gradient
c double DSCR(NDSCR)      : double scratch

c RECORDS
c get TYPE//'SYMQ'
c get 'ATOMMASS'

      SUBROUTINE TRNGRD(NATOM,SYMGRD,CARTGRD,DSCR,NDSCR,TYPE,PRINTQ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DOUBLE PRECISION DSCR(NDSCR)
      DOUBLE PRECISION SYMGRD(3*NATOM),CARTGRD(3*NATOM)
      CHARACTER*4 TYPE
      LOGICAL PRINTQ

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      NSIZE=3*NATOM

      IF (NDSCR.LT.NSIZE*NSIZE) THEN
         print *, '@TRNGRD: Insufficient memory to load ',TYPE,'SYMQ'
         print *, '         have ',NDSCR,' doubles'
         print *, '         need ',NSIZE*NSIZE,' doubles'
         call aces_exit(1)
      END IF

c   o transform to mass-weighted cartesian coordinates
      CALL GETREC(20,'JOBARC',TYPE//'SYMQ',NSIZE*NSIZE*IINTFP,DSCR)
      CALL XGEMM('N','N',NSIZE,1,NSIZE,
     &           1.d0,DSCR,   NSIZE,
     &                SYMGRD, NSIZE,
     &           0.d0,CARTGRD,NSIZE)

c   o remove mass weighting
      CALL GETREC(20,'JOBARC','ATOMMASS',NATOM*IINTFP,DSCR)
      IOFF=1
      DO IATOM=1,NATOM
         X=SQRT(DSCR(IATOM))
         CARTGRD(IOFF+0)=X*CARTGRD(IOFF+0)
         CARTGRD(IOFF+1)=X*CARTGRD(IOFF+1)
         CARTGRD(IOFF+2)=X*CARTGRD(IOFF+2)
         IOFF=IOFF+3
      END DO

      IF (PRINTQ) THEN
         write(6,*)' Gradient before transformation:'
         write(6,'((3f20.10))')(symgrd(i),i=1,nsize)
         write(6,*)' Numerical Cartesian gradient:'
         write(6,'((3f20.10))')(cartgrd(i),i=1,nsize)
      END IF

      RETURN
      END

      Subroutine Built_Reord_Vec(Nreal_atoms, Nprim_4shl, Iangmom,
     &                           IShell_4atm, Itot_prim, Nshls,
     &                           Inatural_order)

      Implicit integer(A-Z)
C
#include <mxatms.par>
C
      Dimension Nprim_4shl(Nreal_atoms*NShls),
     &          Iangmom(Nreal_atoms*Nshls), IShell_4atm(Nreal_atoms),
     &          Inatural_order(Itot_prim), Ispdfgh_4atm(mxatms,7),
     &          Ifwd_4shell(mxatms,7),Ihigh(mxatms),
     &          Ibwd_4shell(mxatms,7),Isavei(mxatms),
     &          Isavep(mxatms), Inprims_4atm(mxatms,7),
     &          Ifwd_4prims(mxatms,7), Ibwd_4prims(mxatms,7),
     &          Iprims(0:6), Nprims(mxatms),Isaven(mxatms,mxatms),
     &          Ioff(8)
     
      Data (Iprims(I), I=0, 6) /1, 3, 6, 10, 15, 21, 36/
      Data (Ioff(I), I=1, 8) /0, 0, 2, 7, 19, 34, 55, 91/
C      
      Icount   = 0
      Iatm_off = 0
C
      Do Iatm = 1, Nreal_atoms
C
         Isfun  = 0
         Ipfun  = 0
         Idfun  = 0
         Iffun  = 0
         Ihfun  = 0
         Ilfun  = 0
C
C
         Isprm  = 0
         Ipprm  = 0
         Idprm  = 0
         Ifprm  = 0
         Ihprm  = 0
         Ilprm  = 0
         Iprmc  = 0
         
         Iprmc = Iatm_off
C
         Do Ishell = 1, IShell_4atm(Iatm)
C
            Iang  = Iangmom(Iatm_off+ishell)
            Iprmc = Iprmc + 1
C
            If (Iang .Eq. 1)  Then
                Isfun = Isfun + 1
                Isprm = Isprm + Nprim_4shl(Iprmc)
                Ispdfgh_4atm(Iatm, 1) = Isfun
                Inprims_4atm(Iatm, 1) = Isprm
                Ihigh(Iatm) = 1
            Elseif (Iang .Eq. 3) Then
                Ipfun = Ipfun + 1
                Ipprm = Ipprm + Nprim_4shl(Iprmc)*3
                Ispdfgh_4atm(Iatm, 2) = Ipfun
                Inprims_4atm(Iatm, 2) = Ipprm
                Ihigh(Iatm) = 2
            Elseif (Iang .Eq. 6) Then
                Idfun = Idfun + 1
                Idprm = Idprm + Nprim_4shl(Iprmc)*6
                Ispdfgh_4atm(Iatm, 3) = Idfun
                Inprims_4atm(Iatm, 3) = Idprm
                Ihigh(Iatm) = 3
            Elseif (Iang .Eq. 10) Then
                Iffun = Iffun + 1
                Ifprm = Ifprm + Nprim_4shl(Iprmc)*10
                Ispdfgh_4atm(Iatm, 4) = Iffun
                Inprims_4atm(Iatm, 4) = Ifprm
                Ihigh(Iatm) = 4
            Elseif (Iang .Eq. 15) Then
                Igfun = Igfun + 1
                Igprm = Igprm + Nprim_4shl(Iprmc)*15
                Ispdfgh_4atm(Iatm, 5) = Igfun
                Inprims_4atm(Iatm, 5) = Igprm
                Ihigh(Iatm) = 5
            Elseif (Iang .Eq. 21) Then
                Ihfun = Ihfun + 1
                Ihprm = Ihprm + Nprim_4shl(Iprmc)*21
                Ispdfgh_4atm(Iatm, 6) = Ihfun
                Inprims_4atm(Iatm, 6) = Ihprm
                Ihigh(Iatm) = 6 
            Elseif (Iang .Eq. 36) Then
                Ilfun = Ilfun + 1
                Ilprm = Ilprm + Nprim_4shl(Iprmc)*36
                Ispdfgh_4atm(Iatm, 7) = Ilfun
                Inprims_4atm(Iatm, 7) = Ilprm
                Ihigh(Iatm) = 7
            Elseif (Iang .Gt. 36) Then
                Write(6, "(a,a,a)") "The WFN file is only ",
     &                   "available for up to L angular ",
     &                   "momentum."
                Call Errex
            Endif
C
            Do Iang =1,  Iangmom(Iatm_off)
C
               Do Iprim = 1, Nprim_4shl(Ishell)

                  Icount = Icount + 1

                  Inatural_order(Icount) = Icount             
           
               Enddo
            Enddo
         Enddo
         Iatm_off = Iatm_off + IShell_4atm(Iatm)
      Enddo
 
      Nprims(1) = 0
      Do Iatm = 2, Nreal_atoms 
         Nprims(Iatm) = 0
         Do Ishell = 1, 7
            Nprims(Iatm) = Nprims(Iatm) + Inprims_4atm(iatm-1,Ishell)
         Enddo
      Enddo
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "Natural order"
      Write(6,"(6(1x,i3))")(Inatural_order(i),i=1,Itot_prim)
      Write(6,*)
      Write(6,*) "The # of s,p,d..shells per atom"
      do i=1, Nreal_atoms
      Write(6,"(7(1x,i2))")(Ispdfgh_4atm(i,j), j=1,Ihigh(i))
      enddo 
      Write(6,*)
      Write(6,*) "The # of s,p,d.. primitives per atom"
      do i=1, Nreal_atoms
      Write(6,"(7(1x,i2))")(Inprims_4atm(i,j), j=1,Ihigh(i))
      enddo 
      Write(6,*)
      Write(6,"(6(1x,i2))")(Nprims(i), i=1, Nreal_atoms)
#endif
          
      Do Iatm = 1, Nreal_atoms
         Ifwd_4shell(Iatm, 1) = Ispdfgh_4atm(Iatm, 1) 
         Ifwd_4prims(Iatm, 1) = Inprims_4atm(Iatm, 1) + Nprims(Iatm)
         Do Ishell = 2, Ihigh(Iatm)
            Ifwd_4shell(Iatm,Ishell) = Ifwd_4shell(Iatm, Ishell-1) + 
     &                                 Ispdfgh_4atm(Iatm,Ishell) - 1
            Ifwd_4prims(Iatm,Ishell) = Ifwd_4prims(Iatm, Ishell-1) +
     &                                 Inprims_4atm(Iatm,Ishell) - 
     &                                 Iprims(Ishell-1) 
         Enddo                 
C
         Ibwd_4shell(Iatm,Ihigh(Iatm))=Ispdfgh_4atm(Iatm,Ihigh(Iatm)) 
         Ibwd_4prims(Iatm,Ihigh(Iatm))= Inprims_4atm(Iatm,Ihigh(Iatm))
         Do Jshell = Ihigh(Iatm)-1, 1, -1
            Ibwd_4shell(Iatm,Jshell) = Ibwd_4shell(Iatm,Jshell+1) 
     &                                  + Ispdfgh_4atm(Iatm,Jshell)
            Ibwd_4prims(Iatm,Jshell) = Ibwd_4prims(Iatm,Jshell+1) 
     &                                  + Inprims_4atm(Iatm,Jshell)
         Enddo
C
CSSS         Ifwd_4shell(Iatm,Ihigh(Iatm))=Ifwd_4shell(Iatm,Ihigh(Iatm))+1
      Enddo
      

#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*) "The fwd and bwd offset for Ang. Moms. and Prims"
      do i=1, Nreal_atoms
      Write(6,"(7(1x,i2))")(Ifwd_4shell(i,j), j=1,Ihigh(i))
      Write(6,"(7(1x,i3))")(Ifwd_4prims(i,j), j=1,Ihigh(i))
      enddo
      Write(6,*)
      do i=1, Nreal_atoms
      Write(6,"(7(1x,i2))")(Ibwd_4shell(i,j), j=1,Ihigh(i))
      Write(6,"(7(1x,i2))")(Ibwd_4prims(i,j), j=1,Ihigh(i))
      enddo
#endif
C
      Iatm_off = 0
      Do Iatm = 1, Nreal_atoms
C
         Isavei(1)=Iangmom(Iatm_off+Ifwd_4shell(Iatm,1))
         Isavep(1)=Nprim_4shl(Iatm_off+Ifwd_4shell(Iatm, 1))
C
         Do Ishell = 2, Ihigh(Iatm)
C
            Isavei(Ishell)=Iangmom(Iatm_off+Ifwd_4shell(Iatm,Ishell)
     &                             +Ishell-1)
            Isavep(Ishell)=Nprim_4shl(Iatm_off+Ifwd_4shell(Iatm,
     &                                Ishell)+Ishell-1)
            Write(6,*) Isavep(Ishell)
         Enddo

         Do Ishell = 1, Ihigh(Iatm)
C
            Do Jshell = 1, Ibwd_4shell(Iatm, Ishell+1)-1
                Iangmom(Iatm_off+Ifwd_4shell(Iatm,Ishell)+Jshell-1)= 
     &          Iangmom(Iatm_off+Ifwd_4shell(Iatm,Ishell)+Jshell)
C
                Nprim_4shl(Iatm_off+Ifwd_4shell(Iatm,Ishell)+
     &                     Jshell-1) = Nprim_4shl(Iatm_off+Ifwd_4shell
     &                                        (Iatm,Ishell)+Jshell)
CSSS             Write(6,*) Nprim_4shl(Iatm_off+Ifwd_4shell(Iatm,Ishell)+
CSSS     &                  Jshell-1)

C
            Enddo
         Enddo
C
         Do Ishell = 1, Ihigh(Iatm)
            Iangmom(Iatm_off + Ifwd_4shell(Iatm,Ihigh(Iatm))+Ishell-1)
     &              = Isavei(Ishell)
C
            Nprim_4shl(Iatm_off + Ifwd_4shell(Iatm,Ihigh(Iatm))+
     &                 Ishell-1) = Isavep(Ishell)
C
         Enddo
         iatm_off = iatm_off + IShell_4atm(Iatm)
      Enddo
      
      Iatm_off = 0
      Do Iatm = 1, Nreal_atoms
C
         Do Ishell = 1, Ihigh(Iatm)

            Do Jshell = 1, Iprims(Ishell-1)
            Isaven(Ishell,Jshell)=Inatural_order(Iatm_off+
     &                            Ifwd_4prims(Iatm, Ishell)+Jshell-1)
            Enddo 
C
            Do Kshell = 1, Iprims(Ishell-1)
               Do Jshell = 1, Ibwd_4prims(Iatm, Ishell+1)+
     &                                    Iprims(Ishell-1)
                  Inatural_order(Iatm_off+Ifwd_4prims(Iatm,Ishell)+
     &                           Jshell-1) = Inatural_order(Iatm_off +
     &                                               Ifwd_4prims(Iatm,
     &                                               Ishell)+Jshell)
               Enddo
            Enddo
         Enddo
C
         Do Ishell = 1, Ihigh(Iatm)

            Ioffst = Ioff(Ishell)
            Do Jshell = 1, Iprims(Ishell-1)
               Inatural_order(Iatm_off+Ifwd_4prims(Iatm,Ihigh(Iatm))+
     &                        Ishell-1+Jshell-1+ioffst) = 
     &                        Isaven(Ishell,Jshell)
            Enddo 
        
         Enddo
      Enddo
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a)") "The reordered Ang. Moms. array"
      joff = 0
      Do I= 1, Nreal_atoms
      Write(6, "(4(1x,I3))") (Iangmom(joff+J), J=1,Ishell_4atm(I))
      joff = joff + IShell_4atm(I) 
      Enddo
      Write(6,*)
      Write(6,"(a)") "The reordered primitive array"
      joff = 0
      Do I= 1, Nreal_atoms
      Write(6, "(4(1x,I3))") (Nprim_4shl(joff+J), J=1,Ishell_4atm(I))
      joff = joff + IShell_4atm(I)
      Enddo 
      Write(6,*)
      Write(6,"(a)") "The reordered Natural order array"
      Write(6, "(10(1x,I3))") (Inatural_order(J), J=1,
     &                        Itot_prim)
#endif
C
      Return
      End 

      integer function ishell(string)
      character*(*) string
      character*1 achar
      integer c_system
      external c_system
      character*80 cmd
      if ( len(string) .lt. 80 ) then
         cmd = string//achar(0)
         ishell = c_system(cmd)
      else
         print *, '@ISHELL: The command buffer is only 80 characters.'
         print *, '         exiting while trying to execute: ',
     &            '(string between arrows)'
         print '(3a)', '-->',string,'<--'
         call c_exit(1)
      end if
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         subroutine  ofh__backspace_unit
     +
     +                    ( unitid )
     +
c------------------------------------------------------------------------
c  operation   : ofh__backspace_unit
c  module      : output files handler
c  module-id   : ofh
c  description : This operation performs a backspace command on the
c                unit specified by its unit id.
c
c  author      : Norbert Flocke
c------------------------------------------------------------------------
c
c
c             ...include files and declare variables.
c
c
         include       'output_files.h'

         logical       is_open

         character*10  access_type

         integer       unitid
c
c
c------------------------------------------------------------------------
c
c
c             ...inquire the access type and open status of the unit.
c
c
         inquire (unit   = unitid,
     +            access = access_type,
     +            opened = is_open)
c
c
c             ...abort calling program, if file is not of the right
c                type.
c
c
         if (access_type.ne.'sequential') then
             write (*,*) ' Wrong file type! '
             write (*,*) ' access type = ',access_type
             write (*,*) ' ofh__backspace_unit '
             write (1,*) ' Wrong file type! '
             write (1,*) ' access type = ',access_type
             write (1,*) ' ofh__backspace_unit '
             call  ofh__stop
         end if
c
c
c             ...proceed if unit is open and file is being used.
c
c
         if (is_open .and. file_handle (unitid).eq.used) then
             backspace (unit = unitid)
         else
             write (*,*) ' Unit not connected! '
             write (*,*) ' ofh__backspace_unit '
             write (1,*) ' Unit not connected! '
             write (1,*) ' ofh__backspace_unit '
             call  ofh__stop
         end if
c
c
c             ...ready!
c
c
         return
         end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  MAT__C_EQ_ZERO_INTEGER
     +
     +                    ( DDROW,DDCOL,
     +                      ROW,COL,
     +
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : MAT__C_EQ_ZERO_INTEGER
C  MODULE      : MATRIX
C  MODULE-ID   : MAT
C  DESCRIPTION : This operation builds a two-dimensional zero matrix C
C                of integer type.
C
C                The zero matrix need not to be a square matrix.
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    DDROW,DDCOL
         INTEGER    I,J
         INTEGER    ROW,COL
         INTEGER    ZERO

         INTEGER    C (1:DDROW,1:DDCOL)

         PARAMETER  (ZERO = 0)
C
C
C------------------------------------------------------------------------
C
C
C             ...check dimensions.
C
C
         IF  (ROW.GT.DDROW  .OR.  COL.GT.DDCOL)  THEN
              WRITE (1,*) ' Dimensions of matrix C too small: '
              WRITE (1,*) ' mat__c_eq_zero_integer '
              WRITE (1,*) ' DDROW,DDCOL,ROW,COL = ',
     +                      DDROW,DDCOL,ROW,COL
              WRITE (*,*) ' Dimensions of matrix C too small: '
              WRITE (*,*) ' mat__c_eq_zero_integer '
              WRITE (*,*) ' DDROW,DDCOL,ROW,COL = ',
     +                      DDROW,DDCOL,ROW,COL
              STOP
         END IF
C
C
C             ...build zero matrix.
C
C
         DO J = 1,COL
         DO I = 1,ROW  
            C (I,J) = ZERO
         END DO
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      Integer Function NrTSRV ( PtGrp )
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C Purpose:
C     Return the number of rotations and vibrations in the totally
C     symmetric irrep.
C
C Arguments:
C     PtGrp    String containing the Schoenflies symbol for the
C              group of interest. (input)
C              The order must begin with the second character of PtGrp.
C              The last non-blank character is taken to be the "modifier"
C              in the group symbol. It may be in upper- or lowercase.
C              A group of infinite order is denoted with an 'X' for the
C              order.
C
C Dependents:
C     linblnk   Returns the index of the last non-blank character
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Implicit Integer (A-Z)
      Character*(*) PtGrp
      Integer linblnk
C
C     PGMod is the "modifier" lifted from the name
C
      Character*1 PGMod
C
C     Get the "modifier" from the end of the symbol
C
      i = linblnk(PtGrp)
      PGMod = PtGrp(i:i)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     D groups and cubic groups
C
      If (PtGrp(1:1) .eq. 'D' .OR. PtGrp(1:1) .eq. 'T' .OR.
     $   PtGrp(1:1) .eq. 'O' .OR. PtGrp(1:1) .eq. 'I' .OR.
     $      PtGrp(1:1) .eq. 'K') then
         NrTSRV = 0
C
C     S groups
C
      ElseIf (PtGrp(1:1) .eq. 'S') then
         NrTSRV = 1
C
C     C groups: C1 => 6; Cs & Ci => 3; Cnh & Cnv => 1; Cn => 2
C
      ElseIf (PtGrp(1:1) .eq. 'C') then
         If (PtGrp(2:linblnk(PtGrp)) .eq. '1') then
            NrTSRV = 6
         ElseIf (PGMod .eq. 's' .OR. PGMod .eq. 'S' .OR. PGMod .eq. 'i'
     $      .OR. PGMod .eq. 'I') then
            NrTSRV = 3
         ElseIf (PGMod .eq. 'v' .OR. PGMod .eq. 'V' .OR. PGMod .eq. 'h'
     $      .OR. PGMod .eq. 'H') then
            NrTSRV = 1
         Else
            NrTSRV = 2
         EndIF
C
C     It isn't a group we recognize
C
      Else
         NrTSRV = -1
      EndIf
C
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__HRR_MATRIX
     +
     +                    ( NROTHRR,NCOLHRR,
     +                      NXYZET,NXYZA,NXYZP,
     +                      SHELLA,SHELLB,SHELLP,
     +                      NABCOOR,
     +                      ABX,ABY,ABZ,
     +                      WORK,
     +
     +                               IN1,IN2,
     +                               NROWOUT,
     +                               NROW,
     +                               ROW,
     +                               T )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__HRR_MATRIX
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : ERD__HRR_STEP
C  DESCRIPTION : This operation constructs the whole HRR transformation
C                matrix T, which will contain the information for
C                the complete transformation in xyz-basis:
C
C                             (e0| --> (ab|  ;  e = a+b ; a>=b
C
C                The matrix is constructed stepwise, starting from
C                a unit matrix and operating on its columns with
C                elementary HRR steps.
C
C
C                  Input:
C
C                    NROTHRR   = maximum # of elements of T and ROW
C                                matrix expected during construction
C                                of final T and ROW
C                    NCOLHRR   = maximum # of columns of T and ROW
C                                matrix expected during construction
C                                of final T and ROW
C                    NXYZET    = monomial dimension of the (e0| part.
C                    NXYZA     = monomial dimension for shell a
C                    NXYZP     = monomial dimension for shell p=a+b
C                    SHELLx    = shell types for x=a,b,p
C                    NABCOOR   = # of nonzero coordinate differences
C                                between nuclear centers A and B
C                    ABx       = the coordinate differences between
C                                nuclear centers A and B for x=X,Y,Z
C                    WORK      = scratch space used for assembly of
C                                final NROW vector and T and ROW
C                                matrices
C
C                  Output:
C
C                    IN1,IN2   = starting index position of final
C                                NROW vector (IN1) and final T and
C                                ROW matrices (IN2) in the big NROW
C                                T and ROW arrays (which are 2x the
C                                maximum size)
C                    NROWOUT   = maximum # of nonzero row labels
C                                of matrix T and ROW
C                    NROW      = vector containing # of nonzero
C                                entries in columns of T and ROW matrix
C                    ROW       = the nonzero row labels of matrix T
C                    T         = the HRR transformation matrix
C
C
C                The xyz-basis for the a- and b-parts in columns
C                of matrix T will be ordered such that a preceeds b.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         INTEGER     BASE1,BASE2
         INTEGER     I,J,L,M,N
         INTEGER     IN1,IN2,OUT1,OUT2
         INTEGER     NABCOOR
         INTEGER     NCOLHRR,NROTHRR
         INTEGER     NGH,NGHO
         INTEGER     NROWIN,NROWOUT
         INTEGER     NXYZGO,NXYZHO
         INTEGER     NXYZA,NXYZP,NXYZG,NXYZH,NXYZI,NXYZET
         INTEGER     SHELLA,SHELLB,SHELLG,SHELLH,SHELLP
         INTEGER     TLEAP

         INTEGER     ADD  (0:2)
         INTEGER     NROW (1:NCOLHRR+NCOLHRR)
         INTEGER     WORK (1:NCOLHRR+NCOLHRR)

         INTEGER     ROW  (1:NROTHRR+NROTHRR)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  ZERO,ONE

         DOUBLE PRECISION  T (1:NROTHRR+NROTHRR)

         PARAMETER  (ZERO  =  0.D0)
         PARAMETER  (ONE   =  1.D0)

         DATA  ADD  /0,0,1/
C
C
C------------------------------------------------------------------------
C
C
C             ...accumulate T.
C
C
         IN1 = 1
         IN2 = 1

         OUT1 = IN1 + NCOLHRR
         OUT2 = IN2 + NROTHRR
C
C
C             ...form initial 'unit' T.
C
C
         DO 10 I = 1,NXYZET
            NROW (I) = 1
            ROW (I) = I
            T (I) = ONE
   10    CONTINUE
C
C
C             ...build up the HRR transformation matrix + data.
C
C
         NGH = NXYZET
         NXYZG = NXYZET
         NXYZH = 1
         NXYZGO = NXYZET
         NXYZHO = 1
         NXYZI = NXYZP
         SHELLG = SHELLP
         NROWIN = 1
         NROWOUT = 1

         DO 20 SHELLH = 1,SHELLB

            NXYZGO = NXYZGO - NXYZI
            NXYZHO = NXYZHO + SHELLH + 1
            NGHO   = NXYZGO * NXYZHO

            IF (NABCOOR.EQ.3) THEN
                M = 1 + SHELLH/3
                NROWOUT = NROWOUT + M*(M + ADD (MOD(SHELLH,3)))
            ELSE IF (NABCOOR.EQ.2) THEN
                NROWOUT = NROWOUT + SHELLH/2 + 1
            ELSE IF (NABCOOR.EQ.1) THEN
                NROWOUT = NROWOUT + 1
            END IF

            CALL  ERD__HRR_STEP
     +
     +                 ( NGH,NGHO,NROWIN,NROWOUT,
     +                   NXYZA,NXYZI,NXYZG,NXYZH,NXYZGO,
     +                   SHELLA,SHELLG,SHELLH-1,
     +                   ABX,ABY,ABZ,
     +                   WORK,
     +                   NROW (IN1), ROW (IN2),
     +                   T (IN2),
     +
     +                           NROW (OUT1), ROW (OUT2),
     +                           T (OUT2) )
     +
     +
            NXYZH  = NXYZHO

            IF (SHELLH.NE.SHELLB) THEN
                NGH = NGHO
                NXYZG  = NXYZGO
                NXYZI  = NXYZI - SHELLG - 1
                SHELLG = SHELLG - 1
                NROWIN = NROWOUT
            END IF

            I = IN1
            IN1 = OUT1
            OUT1 = I
            I = IN2
            IN2 = OUT2
            OUT2 = I

   20    CONTINUE
C
C
C             ...the resulting T matrix of dimension NROWOUT x (NXYZA
C                x NXYZH) has the following structure: the columns
C                are such that they come in NXYZA identical copies
C                NXYZH times. Hence we can condense the T matrix into
C                only NROWOUT x NXYZH distinct elements. The same
C                applies to the array NROW of size NXYZA x NXYZH, which
C                also allows for condensation into only NXYZH elements.
C
C
         L = 1
         M = 0
         N = 0

         BASE1 = IN1 - 1
         BASE2 = IN2 - 1

         TLEAP = NROWOUT * NXYZA

         DO 30 J = 1,NXYZH
            NROW (BASE1+J) = NROW (BASE1+L)
            DO 40 I = 1,NROWOUT
               T (BASE2+M+I) = T (BASE2+N+I)
   40       CONTINUE
            L = L + NXYZA
            M = M + NROWOUT
            N = N + TLEAP
   30    CONTINUE
C
C
C             ...ready!
C
C
         RETURN
         END

c This routine flushes any modified cache slots in the automatic file cache.
c The operation is also called a "write-back". This routine DOES NOT zero
c (destroy) the contents of the cache.

      subroutine aces_cache_flush
      implicit none

c INTERNAL VARIABLES
      integer i, iFile, iRec, iNdx

c COMMON BLOCKS
#include "cache.com"
#include "filspc.com" /* for iprcwd */

c ----------------------------------------------------------------------

c   o write out changed records and reset the modification flags
      if (bCacheUp) then
      do i = 1, cachnum
         if (cachmod(i).ne.0) then
            iFile = cachfil(i)
            iRec  = cachrec(i)
            iNdx  = cachndx(i)
            call aces_io_write(iFile,iRec,icache(iNdx),iprcwd)
            cachmod(i) = 0
         end if
      end do
      end if

      return
c     end subroutine aces_cache_flush
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  ERD__E0F0_DEF_BLOCKS
     +
     +               ( ZMAX,
     +                 NPGTOA,NPGTOB,NPGTOC,NPGTOD,
     +                 SHELLP,SHELLQ,
     +                 NIJ,NKL,
     +                 NRS,NTU,NRSTU,
     +                 NGQP,NGQSCR,
     +                 NXYZT,
     +                 L1CACHE,NCTROW,
     +                 MEMORY,
     +
     +                     NIJBLK,NKLBLK,
     +                     NPSIZE,NCSIZE,NWSIZE,
     +                     NINT2D,
     +                     MXPRIM,MNPRIM,
     +                     ZCBATCH,ZPBATCH,ZWORK,
     +                     ZNORMA,ZNORMB,ZNORMC,ZNORMD,
     +                     ZRHOAB,ZRHOCD,
     +                     ZP,ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCPK2,
     +                     ZQ,ZQX,ZQY,ZQZ,ZQCX,ZQCY,ZQCZ,ZQINVHF,ZSCQK2,
     +                     ZRTS,ZWTS,ZGQSCR,ZTVAL,ZPQPINV,ZSCPQK4,
     +                     ZB00,ZB01,ZB10,
     +                     ZC00X,ZC00Y,ZC00Z,ZD00X,ZD00Y,ZD00Z,
     +                     ZINT2DX,ZINT2DY,ZINT2DZ )
     +
C------------------------------------------------------------------------
C  OPERATION   : ERD__E0F0_DEF_BLOCKS
C  MODULE      : ELECTRON REPULSION INTEGRALS DIRECT
C  MODULE-ID   : ERD
C  SUBROUTINES : none
C  DESCRIPTION : This routine handles the memory partitions for the
C                generation of the entire contracted (e0|f0) batch.
C                It determines the block size partitions (if any) for
C                the ij and kl exponent paris of the whole primitive
C                [e0|f0] batch and returns pointers to the flp data
C                sections needed by the (e0|f0) generation.
C
C                The routine is also equipped with the possibility
C                of returning just the minimum / optimum flp memory
C                needed, without evaluating the (e0|f0) generation flp
C                pointers. This is useful for establishing just the
C                overall memory size needed for the (e0|f0) generation.
C                The keyword MEMORY has to be set true for this case
C                and obviously the value of ZMAX passed is irrelevant.
C
C
C                  Input:
C
C                    ZMAX         =  maximum flp memory
C                    NPGTOx       =  # of primitives per contraction
C                                    for csh x=A,B,C,D
C                    SHELLP(Q)    =  the shell sums for csh: A+B (C+D)
C                    NIJ(KL)      =  total # of ij(kl) primitive
C                                    index pairs corresponding to
C                                    the csh pairs A,B(C,D)
C                    NRS(TU)      =  total # of rs(tu) contraction
C                                    index pairs corresponding to
C                                    the csh pairs A,B(C,D)
C                    NRSTU        =  total # of rstu contraction
C                                    index quadruplets (= NRS*NTU)
C                    NGQP         =  # of gaussian quadrature points
C                                    (roots)
C                    NGQSCR       =  size of gaussian quadrature
C                                    scratch space needed to calculate
C                                    all the quadrature roots
C                    NXYZT        =  total # of cartesian monomial
C                                    quadruplets
C                    L1CACHE      =  Size of level 1 cache in units of
C                                    8 Byte
C                    NCTROW       =  minimum # of rows that are
C                                    accepted for blocked contractions
C                    MEMORY       =  if this keyword is true, the
C                                    routine will only determine the
C                                    minimum / optimum flp memory and
C                                    store these values into NIJBLK and
C                                    NKLBLK, respectively (see below)
C
C                  Output:
C
C                    NIJ(KL)BLK   =  if MEMORY is false, they contain
C                                    the block sizes for the ij(kl)
C                                    primitive indices in order to
C                                    perform efficient contractions.
C                                    if MEMORY is true, they will have
C                                    the values for the minimum /
C                                    optimum flp memory
C                    NxSIZE       =  size of the primitive integral
C                                    block (x=P), contracted integrals
C                                    (x=C) and working (x=W) arrays
C                    NINT2D       =  space needed for the 2D X,Y,Z
C                                    integral arrays
C                    MXPRIM       =  the maximum # of primitives
C                                    between all i,j,k,l primitives,
C                                    i.e. = max (i,j,k,l)
C                    MNPRIM       =  the minimum # of primitives
C                                    between i and j primitives and
C                                    k and l primitives and form the
C                                    maximum between these two values,
C                                    i.e. = max (min(i,j),min(k,l))
C                    Z.....       =  pointers for space partition of
C                                    the flp array (see below)
C
C
C                The space partitioning of the flp array will be
C                as follows:
C
C
C                 |  Zone 1  |  Zone 2  |  Zone 3  |  Zone 4  |
C
C
C                   Zone 1 : final (e0|f0) batch
C                   Zone 2 : block [e0|f0] and half transformed (e0|f0)
C                   Zone 3 : complete set of A,B,C,D norms and
C                            complete set of AB and CD exponential
C                            prefactors 
C                   Zone 4 : i) scratch for block [e0|f0] generation
C                           ii) scratch for partial (e0|f0) generation
C
C
C                Memory allocation offsets for the primitive [e0|f0]
C                batches generation + contraction to (e0|f0):
C
C
C                  --- Zone 1 ---
C
C                   ZCBATCH = offset for contracted (e0|f0) batch
C
C                  --- Zone 2 ---
C
C                   ZPBATCH = offset for (blocked) [e0|f0] batch (K4)
C
C                  --- Zone 3 ---
C
C                   ZNORMA = offset for all A norms
C                   ZNORMB = offset for all B norms
C                   ZNORMC = offset for all C norms
C                   ZNORMD = offset for all D norms
C
C                   ZRHOAB = offset for all AB exponential prefactors
C                   ZRHOCD = offset for all CD exponential prefactors
C
C                  --- Zone 4: for block [e0|f0] generation only ---
C
C                   ZP = offset for (blocked) P values (K2)
C                   ZPX = offset for (blocked) PX values (K2)
C                   ZPY = offset for (blocked) PY values (K2)
C                   ZPZ = offset for (blocked) PZ values (K2)
C                   ZPAX = offset for (blocked) PAX values (K2)
C                   ZPAY = offset for (blocked) PAY values (K2
C                   ZPAZ = offset for (blocked) PAZ values (K2)
C                   ZPINVHF = offset for (blocked) 1/2P values (K2)
C                   ZSCPK2 = offset for (blocked) P scale values (K2)
C
C                   ZQ = offset for (blocked) Q values (K2)
C                   ZQX = offset for (blocked) QX values (K2)
C                   ZQY = offset for (blocked) QY values (K2)
C                   ZQZ = offset for (blocked) QZ values (K2)
C                   ZQCX = offset for (blocked) QCX values (K2)
C                   ZQCY = offset for (blocked) QCY values (K2
C                   ZQCZ = offset for (blocked) QCZ values (K2)
C                   ZQINVHF = offset for (blocked) 1/2Q values (K2)
C                   ZSCQK2 = offset for (blocked) Q scale values (K2)
C
C                   ZRTS = offset for (blocked) quad roots (K4)
C                   ZWTS = offset for (blocked) quad weights (K4)
C                   ZGQSCR = offset for (blocked) quad scratch (K4)
C                   ZTVAL = offset for (blocked) T exponents (K4)
C                   ZPQPINV = offset for (blocked) 1/(P+Q) values (K4)
C                   ZSCPQK4 = offset for (blocked) PQ scale values (K4)
C
C                   ZB00 = offset for (blocked) VRR coeff B00 (K4)
C                   ZB01 = offset for (blocked) VRR coeff B01 (K4)
C                   ZB10 = offset for (blocked) VRR coeff B10 (K4)
C                   ZC00X = offset for (blocked) VRR coeff C00X (K4)
C                   ZC00Y = offset for (blocked) VRR coeff C00Y (K4)
C                   ZC00Z = offset for (blocked) VRR coeff C00Z (K4)
C                   ZD00X = offset for (blocked) VRR coeff D00X (K4)
C                   ZD00Y = offset for (blocked) VRR coeff D00Y (K4)
C                   ZD00Z = offset for (blocked) VRR coeff D00Z (K4)
C
C                   ZINT2DX = offset for (blocked) 2DX integrals (K4)
C                   ZINT2DY = offset for (blocked) 2DY integrals (K4)
C                   ZINT2DZ = offset for (blocked) 2DZ integrals (K4)
C
C                  --- Zone 4: for contraction only ---
C
C                   ZWORK = offset for contraction working array
C
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     MEMORY

         INTEGER     IJDIV,KLDIV
         INTEGER     L1CACHE,NCTROW
         INTEGER     M,N
         INTEGER     MIJ,MKL,MIJKL,MRSKL
         INTEGER     MIJBIG,MKLBIG
         INTEGER     MXPRIM,MNPRIM
         INTEGER     MXSTEP
         INTEGER     NIJ,NKL
         INTEGER     NIJBLK,NKLBLK
         INTEGER     NINT2D
         INTEGER     NGQP,NGQSCR,MGQIJKL
         INTEGER     NPGTOA,NPGTOB,NPGTOC,NPGTOD
         INTEGER     NPMINRS,NPMINTU
         INTEGER     NPSIZE,NCSIZE,NWSIZE
         INTEGER     NRS,NTU,NRSTU
         INTEGER     NXYZT
         INTEGER     PFACT
         INTEGER     POW2IJ,POW2KL
         INTEGER     SHELLP,SHELLQ
         INTEGER     WCOL
         INTEGER     ZONE12,ZONE3,ZONE4,ZONE4B,ZONE4C
         INTEGER     ZMAX
         INTEGER     ZCBATCH,ZPBATCH,ZWORK,
     +               ZNORMA,ZNORMB,ZNORMC,ZNORMD,
     +               ZRHOAB,ZRHOCD,
     +               ZP,ZPX,ZPY,ZPZ,ZPAX,ZPAY,ZPAZ,ZPINVHF,ZSCPK2,
     +               ZQ,ZQX,ZQY,ZQZ,ZQCX,ZQCY,ZQCZ,ZQINVHF,ZSCQK2,
     +               ZRTS,ZWTS,ZGQSCR,ZTVAL,ZPQPINV,ZSCPQK4,
     +               ZB00,ZB01,ZB10,
     +               ZC00X,ZC00Y,ZC00Z,ZD00X,ZD00Y,ZD00Z,
     +               ZINT2DX,ZINT2DY,ZINT2DZ

         DOUBLE PRECISION   DLOG2

         PARAMETER  (DLOG2  =  0.6931471805599D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...determine optimum size of [e0|f0] blocks:
C
C                The next few lines of code are among the most
C                important for performance of the entire integral
C                package. Any badly chosen sizes for the primitive
C                blocks has a severe effect on the integral
C                evaluation timing. Two opposite effects have
C                to be considered:
C
C                1) Reuse level 1 cache data as much as possible,
C                   i.e. choose the primitive blocks in such a
C                   way that most of the heavy computational work
C                   is being done reusing data in each cache line.
C
C                2) Choose the size of the primitive blocks as
C                   large as possible observing point 1), to reduce
C                   subroutine call overheads as much as possible.
C
C                After some experimenting, the following procedure
C                was found to work best:
C
C                  i) The optimum [e0|f0] block size is assumed to
C                     be directly proportional to the level 1 cache
C                     size.
C
C                 ii) The proportionality factor PFACT has to be
C                     determined by 'experiment', running a real
C                     molecular case with fully contracted basis sets.
C
C                iii) After having found the optimum # of exponent
C                     quadruplets per [e0|f0] block, it is best
C                     to choose the IJ-part as large as possible,
C                     keeping the KL-part size to a minimum. The
C                     reason behind this is that a KL-part size
C                     of 1 does not trigger an intermediate IJ <-> KL
C                     transposition during the contraction procedure.
C
C
         PFACT = 4

         MIJKL = PFACT * L1CACHE / NXYZT
         MIJKL = MAX (1,MIJKL)

         MIJ = MIN (MIJKL,    NIJ)
         MKL = MIN (MIJKL/MIJ,NKL)
C
C
C
C             ...the optimum block sizes MIJ x MKL have been found.
C                We have to see now how it fits with the rest of
C                the needed data into the maximum memory given.
C                If necessary subdivide the optimum MIJ x MKL block
C                size into convenient subblocks that fit into memory.
C                Note, that the primitive array must also hold the
C                intermediate halftransformed contracted integrals.
C
C                The subdivision of the MIJ x MKL block is done in
C                such a way that successive powers of 2 are checked
C                as divisors of MIJ and MKL. Only one of the divisors
C                is incremented in each trial step. The maximum #
C                of steps MXSTEP can thus be calculated beforehand
C                by knowing the fact that the smallest subdivided
C                MIJ x MKL block is of size 1 x 1. The succesive
C                divisors are checked in the following order:
C
C
C                        step  |  div of MIJ  |  div of MKL
C                       ------------------------------------
C                          1   |       1      |      1
C                          2   |       1      |      2
C                          3   |       2      |      2
C                          4   |       2      |      4
C                          5   |       4      |      4
C                          6   |       4      |      8
C                          7   |       8      |      8
C                         ...         ...           ...
C
C                The routine stops with a diagnostic, if even a
C                MIJ x MKL block of minimum size 1 x 1 cannot be
C                accomodated into the memory.
C
C
C
         NPMINRS = MIN (NPGTOA,NPGTOB)
         NPMINTU = MIN (NPGTOC,NPGTOD)

         NCSIZE = NXYZT * NRSTU

         MXPRIM = MAX (NPGTOA,NPGTOB,NPGTOC,NPGTOD)
         MNPRIM = MAX (NPMINRS,NPMINTU)

         ZONE3 = NPGTOA + NPGTOB + NPGTOC + NPGTOD + NIJ + NKL
C
C
C             ...if the MEMORY keyword is activated, the routine
C                will only determine the optimum and minimum flp
C                memory (in that order), place them respectively
C                into the NKLBLK and NIJBLK variables and exit.
C
C
         IF (MEMORY) THEN

             MIJKL   = MIJ * MKL
             MGQIJKL = NGQP * MIJKL
             NINT2D  = MGQIJKL * (SHELLP+1) * (SHELLQ+1)
             MRSKL   = NRS * MKL
             NPSIZE  = NXYZT * MAX (MIJKL,MRSKL)
             NWSIZE  = NPSIZE
             ZONE12  = NPSIZE + NCSIZE
             ZONE4B  = NGQSCR + 2*MIJKL+9*(MIJ+MKL)+12*MGQIJKL+3*NINT2D
             WCOL    = MNPRIM
             ZONE4C  = NWSIZE + NCTROW * WCOL
             ZONE4   = MAX (ZONE4B,ZONE4C)

             NKLBLK  = ZONE12 + ZONE3 + ZONE4

             MIJ     = 1
             MKL     = 1
             MIJKL   = MIJ * MKL
             MGQIJKL = NGQP * MIJKL
             NINT2D  = MGQIJKL * (SHELLP+1) * (SHELLQ+1)
             MRSKL   = NRS * MKL
             NPSIZE  = NXYZT * MAX (MIJKL,MRSKL)
             NWSIZE  = NPSIZE
             ZONE12  = NPSIZE + NCSIZE
             ZONE4B  = NGQSCR + 2*MIJKL+9*(MIJ+MKL)+12*MGQIJKL+3*NINT2D
             WCOL    = MNPRIM
             ZONE4C  = NWSIZE + NCTROW * WCOL
             ZONE4   = MAX (ZONE4B,ZONE4C)

             NIJBLK  = ZONE12 + ZONE3 + ZONE4

             RETURN

         ELSE
C
C
C             ...the actual fitting into the maximum memory given.
C
C
             POW2IJ = DLOG ( DFLOAT (MIJ) ) / DLOG2
             POW2KL = DLOG ( DFLOAT (MKL) ) / DLOG2

             MXSTEP = 2*MIN (POW2IJ,POW2KL) + ABS (POW2IJ - POW2KL) + 1

             MIJBIG = MIJ
             MKLBIG = MKL

             IJDIV = 1
             KLDIV = 1

             DO 20 N = 1,MXSTEP

                MIJ = MAX (1, MIJBIG / IJDIV )
                MKL = MAX (1, MKLBIG / KLDIV )

                MIJKL   = MIJ * MKL
                MGQIJKL = NGQP * MIJKL
                NINT2D  = MGQIJKL * (SHELLP+1) * (SHELLQ+1)
                MRSKL   = NRS * MKL
                NPSIZE  = NXYZT * MAX (MIJKL,MRSKL)
                NWSIZE  = NPSIZE
                ZONE12  = NPSIZE + NCSIZE
                ZONE4B  = NGQSCR + 2*MIJKL + 9*(MIJ+MKL) + 12*MGQIJKL
     +                           + 3*NINT2D
                WCOL    = MNPRIM
                ZONE4C  = NWSIZE + NCTROW * WCOL
                ZONE4   = MAX (ZONE4B,ZONE4C)

                IF (ZONE12+ZONE3+ZONE4.LE.ZMAX) THEN

                    NIJBLK = MIJ
                    NKLBLK = MKL
                    NWSIZE = ZMAX - ZONE12 - ZONE3
C
C
C             ...generate the memory allocation pointers.
C
C
                    ZCBATCH = 1
                    ZPBATCH = NCSIZE + 1

                    ZNORMA = ZPBATCH + NPSIZE
                    ZNORMB = ZNORMA + NPGTOA
                    ZNORMC = ZNORMB + NPGTOB
                    ZNORMD = ZNORMC + NPGTOC

                    ZRHOAB = ZNORMD + NPGTOD
                    ZRHOCD = ZRHOAB + NIJ

                    ZP = ZRHOCD + NKL
                    ZPX = ZP + MIJ
                    ZPY = ZPX + MIJ
                    ZPZ = ZPY + MIJ
                    ZPAX = ZPZ + MIJ
                    ZPAY = ZPAX + MIJ
                    ZPAZ = ZPAY + MIJ
                    ZPINVHF = ZPAZ + MIJ
                    ZSCPK2 = ZPINVHF + MIJ

                    ZQ = ZSCPK2 + MIJ
                    ZQX = ZQ + MKL
                    ZQY = ZQX + MKL
                    ZQZ = ZQY + MKL
                    ZQCX = ZQZ + MKL
                    ZQCY = ZQCX + MKL
                    ZQCZ = ZQCY + MKL
                    ZQINVHF = ZQCZ + MKL
                    ZSCQK2 = ZQINVHF + MKL

                    ZRTS = ZSCQK2 + MKL
                    ZWTS = ZRTS + MGQIJKL
                    ZGQSCR = ZWTS + MGQIJKL
                    ZTVAL = ZGQSCR + NGQSCR
                    ZPQPINV = ZTVAL + MIJKL
                    ZSCPQK4 = ZPQPINV + MIJKL

                    ZB00 = ZSCPQK4 + MGQIJKL
                    ZB01 = ZB00 + MGQIJKL
                    ZB10 = ZB01 + MGQIJKL
                    ZC00X = ZB10 + MGQIJKL
                    ZC00Y = ZC00X + MGQIJKL
                    ZC00Z = ZC00Y + MGQIJKL
                    ZD00X = ZC00Z + MGQIJKL
                    ZD00Y = ZD00X + MGQIJKL
                    ZD00Z = ZD00Y + MGQIJKL

                    ZINT2DX = ZD00Z + MGQIJKL
                    ZINT2DY = ZINT2DX + NINT2D
                    ZINT2DZ = ZINT2DY + NINT2D

                    ZWORK = ZP

                    RETURN
                END IF

                IF (MIJ.EQ.1) THEN
                    KLDIV = KLDIV * 2
                ELSE IF (MKL.EQ.1) THEN
                    IJDIV = IJDIV * 2
                ELSE
                    M = MOD (N+1,2)
                    IJDIV = IJDIV * (M+1)
                    KLDIV = KLDIV * (2-M)
                END IF

   20        CONTINUE

             WRITE (*,*) ' Memory allocation failed for (e0|f0) ! '
             WRITE (*,*) ' NIJ,NKL,MIJ,MKL = ',NIJ,NKL,MIJ,MKL
             WRITE (*,*) ' Increase flp memory! '
             WRITE (*,*) ' (erd__e0f0_def_blocks) '

             STOP

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine copy_ab(array_table, 
     *                      narray_table, index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c--------------------------------------------------------------------------
c
c   The elements of Array1 are put into Array2 for overlaping indeces. 
c
c   The instruction is executed as follows:
c   
c   execute copy_ab Array1 Array2
c
c   where Array1 is the full input matrix. 
c         Array2 is the same ar Array1 where indeces overlap.  
c
c   Both Array1 and Array2 must be "static" arrays.
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'trace.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table, 
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer*8 iarray, ievec, get_index_from_base
      integer i, j, na, nb  
      integer array, evec_array
      integer array_type, evec_type
      integer nindex, nindex_evec
      integer inda(mx_array_index)
      integer indb(mx_array_index)
      integer junk

      double precision x(1)
#ifdef ALTIX
      pointer (dptr, x)
#else
      common x
#endif

      if (dryrun) return
#ifdef ALTIX
      dptr = dshptr
#endif

c----------------------------------------------------------------------------
c   Locate the data for the input matrix.
c---------------------------------------------------------------------------

      array      = op(c_result_array)
      evec_array = op(c_op1_array)

      if (array .eq. 0 .or. evec_array .eq. 0) then
         print *,'Error: remove_diagonal routine requires 2 
     *            array arguments.'
         print *,(op(i),i=1,loptable_entry)
         call abort_job()
      endif

      array_type = array_table(c_array_type, array)
      evec_type  = array_table(c_array_type, evec_array)

      if (array_type .ne. static_array .or. 
     *    evec_type .ne. static_array) then
         print *,'Error: Both arrays in remove_diagonal routine 
     *            must be static.'
         call abort_job()
      endif

      nindex      = array_table(c_nindex, array)
      nindex_evec = array_table(c_nindex, evec_array)

      if (nindex .ne. nindex_evec) then
         print *,'Error: Both arrays in remove_diagonal must use ',
     *           'the same number of indices.'
         print *,'First array has ',nindex,' indices.'
         print *,'Second array has ',nindex_evec,' indices.'
         call abort_job()
      endif

      do i = 1, nindex
         na = array_table(c_index_array1+i-1,array)
         nb = array_table(c_index_array1+i-1,evec_array)

         inda(i) = index_table(c_index_size, na)  ! pick up length of index
         indb(i) = index_table(c_index_size, nb)  ! pick up length of index
 
      enddo

c---------------------------------------------------------------------------
c   Look up each array's address.
c---------------------------------------------------------------------------

      iarray = get_index_from_base(address_table(array), x, 2)
      ievec  = get_index_from_base(address_table(evec_array), x, 2)

c     na = index_table(c_index_size, ind(1))  ! pick up length of index
c     nb = index_table(c_index_size, ind(1))  ! pick up length of index

      if (nindex .eq. 2) call copy2ab(x(iarray),x(ievec),nindex,
     *                              inda(1),inda(2),indb(1),indb(2)) 

      return 
      end 

      subroutine copy2ab(array1,array2,nindex,na1,na2,nb1,nb2) 
      implicit none

      include 'int_gen_parms.h'

c----------------------------------------------------------------------------
c
c The array1 is assumed to be of type alpha-alpha (VaD) or (SD). The elements 
c of the array1 are put into array2 with the FIRST index offset by the
c number of singly occupied orbitals. Array2 is of type beta-beta (VbD)  
c 
c----------------------------------------------------------------------------

      integer nindex, na1, na2, nb1, nb2  
      double precision array1(na1,na2)
      double precision array2(nb1,nb2)
      integer a, b, n1, n2, noff   

      n1 = min0(na1,nb1) 
      n2 = min0(na2,nb2) 

      write(6,*) ' RANGE OF INDICES IN COPY2 ' 
      write(6,*) ' Array1 :', na1, na2   
      write(6,*) ' Array2 :', nb1, nb2   

      noff = nalpha_occupied - nbeta_occupied 
c     noff = 0 ! This routine stricktly copies one array into another 

      write(6,*) ' NOFF = ', noff 

      if (na1 .eq. nalpha_occupied) then  

         noff = nbeta_occupied  
c        write(6,*) ' NOFF = ', noff 

         do b = 1, n2   
            do a = 1, nalpha_occupied - nbeta_occupied    
               array2(a,b) = array2(a,b) + array1(a+noff,b)
c              write(6,*) ' COPY2 :', a, b, array1(a+noff,b), 
c    *                                      array2(a,b) 
            enddo
         enddo

         go to 100 

      endif 

      do b = 1, n2  
         do a = 1, noff 
            array2(a,b) = 0.0d0 
         enddo 
         do a = 1, n1  
            array2(a+noff,b) = array2(a+noff,b) + array1(a,b)
c           write(6,*) ' COPY2 :', a+noff, b, array1(a,b), 
c    *                                        array2(a,b) 
         enddo
      enddo

100   continue 

      return
      end

      SUBROUTINE UPPOL(POLAR,POLAR2,UPDATE)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL UPDATE
      DIMENSION POLAR(3,3),POLAR2(3,3)

      IF (UPDATE) THEN
         OPEN(UNIT=83,FILE='POLAR',STATUS='OLD',FORM='FORMATTED')
         READ(83,3000) (POLAR2(I,1),I=1,3)
         READ(83,3000) (POLAR2(I,2),I=1,3)
         READ(83,3000) (POLAR2(I,3),I=1,3)
3000     FORMAT(3F20.10)
         CALL SAXPY(9,1.0d0,POLAR2,1,POLAR,1)
      ELSE
         OPEN(UNIT=83,FILE='POLAR',STATUS='OLD',FORM='FORMATTED')
      END IF

      REWIND(83)
      WRITE(83,3000) (POLAR(I,1),I=1,3)
      WRITE(83,3000) (POLAR(I,2),I=1,3)
      WRITE(83,3000) (POLAR(I,3),I=1,3)

      CLOSE(UNIT=83,STATUS='KEEP')

      RETURN
      END

      SUBROUTINE CONVQ(A,FC,FI,IX,ISYM)
C
C CONVERTS FORCES IN CARTESIAN COORDINATES TO INTERNAL COORDINATES (IX=0
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL XYZIN, NWFINDIF
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)









































































































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/




C coord.com : begin
C
      DOUBLE PRECISION Q, R, ATMASS
      INTEGER NCON, NR, ISQUASH, IATNUM, IUNIQUE, NEQ, IEQUIV,
     &        NOPTI, NATOMS
      COMMON /COORD/ Q(3*MXATMS), R(MAXREDUNCO), NCON(MAXREDUNCO),
     &     NR(MXATMS),ISQUASH(MAXREDUNCO),IATNUM(MXATMS),
     &     ATMASS(MXATMS),IUNIQUE(MAXREDUNCO),NEQ(MAXREDUNCO),
     &     IEQUIV(MAXREDUNCO,MAXREDUNCO),
     &     NOPTI(MAXREDUNCO), NATOMS

C coord.com : end



      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
      DIMENSION A(3*NATOMS,NXM6),FC(NX),FI(NXM6)
C
C
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
C
      IF(IX.EQ.0)THEN
         DO 10 I=1,NXM6
            Z=0.D0
            DO 20 J=1,NX
               Z=FC(J)*A(J,I)+Z
 20         CONTINUE
            FI(I)=Z
 10      CONTINUE

C

         Write(6,*)
         Write(6,*) "@-CONVQF,  The outgoing internal gradients"
         WRITE(6,"(3F13.7)") (FI(IJL), IJL = 1, NXM6)
         Write(6,*)
C
C
C SYMMETRIZE THE GRADIENT IF NECESSARY
C
         IF (ISYM.EQ.1)THEN
            IF (XYZIN) THEN
               IF (IFLAGS(60).EQ. 2) THEN
                  CALL GETREC(20, 'JOBARC', 'PLSMINSP', NXM6, NCON)
               END IF
               DO I = 1, NUNIQUE
                  IP = IUNIQUE(I)
cSSS                  WRITE(6,*) "The IP =", IP, NEQ(IP),FI(IP) 
                  Z  = FI(IP)
C
                  DO J = 1, NEQ(IP)
                     IF (NCON(IEQUIV(I, J)) .EQ. 1) THEN
                        SIGN = -1.0D0
                     ELSE
                        SIGN =  1.0D0
                     ENDIF
cSSS                     WRITE(6,*) FI(IEQUIV(I,J)), IEQUIV(I,J),SIGN
                     Z = Z + SIGN*FI(IEQUIV(I, J))
                  ENDDO
C
                  FIAVE=Z/(NEQ(IP)+1)
cSSS                  WRITE(6,*) FIAVE
                  DIFF=DABS(FI(IP)-FIAVE)
                  IF(DIFF.GT.1D-7)WRITE(LuOut,72)DIFF,IP
C
 72               FORMAT(T3,'@CONVQ-W, Nominally equivalent',
     $            'internal coordinate gradients vary by at least ',
     $            e10.5,'.'/
     $            T3,' Problem with gradients equivalent to ',
     $            'parameter [',I3,'].')
                  FI(IP) = FIAVE
C
                  DO J = 1, NEQ(IP)
                     IF (NCON(IEQUIV(I, J)) .EQ. 1) THEN
                        SIGN = -1.0D0
                     ELSE
                        SIGN = 1.0D0
                     ENDIF
                     FI(IEQUIV(I, J))= SIGN*FIAVE
cSSS                     WRITE(6,*) "The IP =", IEQUIV(I,J),FI(IEQUIV(I, J))
                  ENDDO
               ENDDO
               CALL FILTER(FI, NXM6, 1.0D-6) 
               RETURN
            ELSE
               DO 100 I=1,NUNIQUE
                  IP=IUNIQUE(I)
                  Z=FI(IP)
                  DO 102 J=1,NEQ(IP)
 102                 Z=Z+FI(IEQUIV(I,J))
                     FIAVE=Z/(NEQ(IP)+1)
                     DIFF=DABS(FI(IP)-FIAVE)
                     IF(DIFF.GT.1D-7)WRITE(LuOut,71)DIFF,IP
 71                 FORMAT(T3,'@CONVQ-W, Nominally equivalent',
     $             'internal coordinate gradients vary by at least ',
     $              e10.5,'.'/
     $              T3,' Problem with gradients equivalent to ',
     $              'parameter [',I3,'].')
                    FI(IP)=FIAVE
C
                    DO J = 1, NEQ(IP)
                       FI(IEQUIV(I,J))= FIAVE
                    ENDDO
C
 100             CONTINUE
            ENDIF
            RETURN
         ENDIF
      ELSE
         DO 30 I=1,NX
            Z=0.D0
            DO 40 J=1,NXM6
 40            Z=A(I,J)*FI(J)+Z
            FC(I)=Z
 30      CONTINUE
         RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE CONVQ(A,FC,FI,IX,ISYM)
C
C CONVERTS FORCES IN CARTESIAN COORDINATES TO INTERNAL COORDINATES (IX=0
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL XYZIN, NWFINDIF
#include "mxatms.par"
#include "flags.h"
#include "jodaflags.com"
#include "coord.com"

      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /INPTYP/ XYZIN,NWFINDIF
C
      DIMENSION A(3*NATOMS,NXM6),FC(NX),FI(NXM6)
C
#ifdef _TEST_RED
      DIMENSION TMP1(MAXREDUNCO*MAXREDUNCO),TMP2(MAXREDUNCO)
#endif
C
#include "io_units.par"
C
#ifdef _DEBUG_LVLM1
         Write(6,*)
         Write(6,*) "@-CONVQF, The incoming Cartesian gradients"
         WRITE(6,"(3F13.7)") (FC(IJL), IJL = 1, NX)
         Write(6,*) "@-CONVQF, The A matrix"
         CALL OUTPUT(A, 1,3*NATOMS, 1, NXM6, 3*NATOMS, NXM6, 1)
#endif
      IF(IX.EQ.0)THEN
         DO 10 I=1,NXM6
            Z=0.D0
            DO 20 J=1,NX
               Z=FC(J)*A(J,I)+Z
 20         CONTINUE
            FI(I)=Z
 10      CONTINUE

#ifdef _TEST_RED
C This requires defining TMP1 and TMP2 arrays.
      CALL GETREC(20,'JOBARC','NUMREDCO', 1, NULLEVAL)
      CALL GETREC(20,'JOBARC','REDEVECS',NULLEVAL*NXM6*IINTFP,
     &            TMP1)
      CALL XGEMM('T', 'N', NULLEVAL, 1, NXM6, 1.0D0,
     &            TMP1, NXM6, FI, NXM6,
     &               0.0D0, TMP2, NULLEVAL)
      Write(6,*) "Check for the redundencies in gradient"
      Write(6,"(6F13.7)") (tmp2(i), i=1, NULLEVAL)
#endif
C

#ifdef _DEBUG_LVL0
         Write(6,*)
         Write(6,*) "@-CONVQF,  The outgoing internal gradients"
         WRITE(6,"(3F13.7)") (FI(IJL), IJL = 1, NXM6)
         Write(6,*)
#endif
C
C
C SYMMETRIZE THE GRADIENT IF NECESSARY
C
         IF (ISYM.EQ.1)THEN
            IF (XYZIN) THEN
               IF (IFLAGS(h_IFLAGS_symmetry).EQ. 2) THEN
                  CALL GETREC(20, 'JOBARC', 'PLSMINSP', NXM6, NCON)
               END IF
               DO I = 1, NUNIQUE
                  IP = IUNIQUE(I)
cSSS                  WRITE(6,*) "The IP =", IP, NEQ(IP),FI(IP) 
                  Z  = FI(IP)
C
                  DO J = 1, NEQ(IP)
                     IF (NCON(IEQUIV(I, J)) .EQ. 1) THEN
                        SIGN = -1.0D0
                     ELSE
                        SIGN =  1.0D0
                     ENDIF
cSSS                     WRITE(6,*) FI(IEQUIV(I,J)), IEQUIV(I,J),SIGN
                     Z = Z + SIGN*FI(IEQUIV(I, J))
                  ENDDO
C
                  FIAVE=Z/(NEQ(IP)+1)
cSSS                  WRITE(6,*) FIAVE
                  DIFF=DABS(FI(IP)-FIAVE)
                  IF(DIFF.GT.1D-7)WRITE(LuOut,72)DIFF,IP
C
 72               FORMAT(T3,'@CONVQ-W, Nominally equivalent',
     $            'internal coordinate gradients vary by at least ',
     $            e10.5,'.'/
     $            T3,' Problem with gradients equivalent to ',
     $            'parameter [',I3,'].')
                  FI(IP) = FIAVE
C
                  DO J = 1, NEQ(IP)
                     IF (NCON(IEQUIV(I, J)) .EQ. 1) THEN
                        SIGN = -1.0D0
                     ELSE
                        SIGN = 1.0D0
                     ENDIF
                     FI(IEQUIV(I, J))= SIGN*FIAVE
cSSS                     WRITE(6,*) "The IP =", IEQUIV(I,J),FI(IEQUIV(I, J))
                  ENDDO
               ENDDO
               CALL FILTER(FI, NXM6, 1.0D-6) 
               RETURN
            ELSE
               DO 100 I=1,NUNIQUE
                  IP=IUNIQUE(I)
                  Z=FI(IP)
                  DO 102 J=1,NEQ(IP)
 102                 Z=Z+FI(IEQUIV(I,J))
                     FIAVE=Z/(NEQ(IP)+1)
                     DIFF=DABS(FI(IP)-FIAVE)
                     IF(DIFF.GT.1D-7)WRITE(LuOut,71)DIFF,IP
 71                 FORMAT(T3,'@CONVQ-W, Nominally equivalent',
     $             'internal coordinate gradients vary by at least ',
     $              e10.5,'.'/
     $              T3,' Problem with gradients equivalent to ',
     $              'parameter [',I3,'].')
                    FI(IP)=FIAVE
C
                    DO J = 1, NEQ(IP)
                       FI(IEQUIV(I,J))= FIAVE
                    ENDDO
C
 100             CONTINUE
            ENDIF
            RETURN
         ENDIF
      ELSE
         DO 30 I=1,NX
            Z=0.D0
            DO 40 J=1,NXM6
 40            Z=A(I,J)*FI(J)+Z
            FC(I)=Z
 30      CONTINUE
         RETURN
      ENDIF
      RETURN
      END

      Subroutine ExtInt (XTol, NrX, AtNrX, QX, NrI, AtNrI, QI,
     $   XtoI, IStat)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose: Determine the set of pointers (XtoI) which will take a center
C          in the external representation of the list of centers and
C          "point to" the correct center in the internal list.
C
C Modified 7/91 to write pointer list to JOBARC by JFS
C
C Arguments:
C     NrX     Number of external centers (input)
C     AtNrX   Atomic number list for the external set (input)
C     QX      Cartesian coordinates for the external set (input)
C     NrI     Number of internal centers (input)
C     AtNrI   Atomic number list for the internal set (input)
C     QI      Cartesian coordinates for the internal set (input)
C     Tol     Accuracy required of "identical" coordinates (input)
C     XtoI    External to internal permutation list (output)
C             Each element gives the internal rep. center number
C             corresponding to the external rep. center number.
C     IStat    Returns success or error in finding XtoI (output)
C             = 0  Successfully computed permutation list.
C             = 1  Mismatch in number of (non-dummy) centers.
C             = 3  Mismatch in coordinates.
C Scratch arguments:
C     Scr     Space to work on coordinates (scratch)
C             (Room for 3 sets of cartesian coordinates)
C     OrdX    Work space for permutation list (scratch)
C     OrdI    Work space for permutation list (scratch)
C
C Dependents:
C     SortC   Sort cartesian coordinates, weight with at. number
C     SAXPY   SCIPORT BLAS routine (double precision, despite the name)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C $Log: extint.F,v $
C Revision 1.1.1.1  2003/04/02 19:21:35  aces
C INITIAL 2.4 IMPORT
C
C Revision 4.0  89/03/14  01:14:18  bernhold
C Baseline for Sun & VAX prior to porting everywhere
C
C Revision 3.5  89/02/16  14:32:44  bernhold
C Initial version
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Integer NrX, AtNrX(NrX)
      Integer NrI, AtNrI(NrI)
      Integer XtoI(NrX), IStat
      Double precision QX(3*NrX), QI(3*NrI)
      Double precision Tol,XTol
C
C     Scratch arguments - should eventually use ED's dynamic alloc.
C
C MXATMS     : Maximum number of atoms currently allowed
C MAXCNTVS   : Maximum number of connectivites per center
C MAXREDUNCO : Maximum number of redundant coordinates.
C
      INTEGER MXATMS, MAXCNTVS, MAXREDUNCO
      PARAMETER (MXATMS=200, MAXCNTVS = 10, MAXREDUNCO = 3*MXATMS)
      PARAMETER (TOL=1.D-4)
      Integer OrdX(MxAtms), OrdI(MxAtms)
      Double precision Scr(3*3*MxAtms)
C
C     Define the "Standard I/O" units to use throughout the code
      Parameter (LuIn  = 5)
      Parameter (LuOut = 6)
      Parameter (LuErr = 6)
C
      Integer i
C
C     Sort both sets of coordinates
C
      Call SortC (NrX, QX, AtNrX, Scr(1),       OrdX, Scr(6*NrI+1) )
      Call SortC (NrI, QI, AtNrI, Scr(3*NrI+1), OrdI, Scr(6*NrI+1) )
C
C     Check to make sure they're the same coordinates!
C     First, be sure that the only things missing from X are dummies.
C
      Do 10 i = NrX+1, NrI
         If ( AtNrI(OrdI(i)) .ne. 0) then
            IStat = 1
            Write (LuErr, 9910)
            Return
         EndIf
 10   Continue
 9910 Format (' @EXTINT-F, Number of internal and external centers ',
     $   'do not match.')
C
C     Second, be sure the coordinates themselves match.
C
      Call SAXPY (3*NrX, -1.0d0, Scr(3*NrI+1), 1, Scr(1), 1)
      Do 20 i = 1, 3*NrX
         DIFF=SCR(I)
         If (DIFF.GT.TOL)THEN
            IStat = 3
            Write (LuErr, 9940)
            Write (LuErr, 9935) (j, AtNrX(j), QX(3*(j-1)+1),
     $         QX(3*(j-1)+2), QX(3*(j-1)+3), j = 1, NrX)
            Write (LuErr, 9945)
            Write (LuErr, 9935) (j, AtNrI(j), QI(3*(j-1)+1),
     $         QI(3*(j-1)+2), QI(3*(j-1)+3), j = 1, NrI)
            Write (LuErr, 9930)
            Return
         EndIf
 20   Continue
 9930 Format (' @EXTINT-F, External and internal cartesian',
     $   ' coordinates do not match.')
 9935 Format (' Center',3X,'At. Nr.',3X,19X,'X',19X,'Y',19X,'Z'/
     $   (I7,3X,I7,3X,3F20.10))
 9940 Format (/' External cartesian coordinates:')
 9945 Format (/' Internal cartesian coordinates:')
C
C     Now make the permutation list
C
      Do 100 i = 1, NrX
         XtoI(OrdX(i)) = OrdI(i)
 100  Continue
C
      CALL PUTREC(20,'JOBARC','EXTINTVC',NRX,XTOI)
      Return
      End

C  Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
C  USA
         SUBROUTINE  OED__XYZ_DERV_PCGTO_BLOCK
     +
     +                    ( NBATCH,
     +                      NOVRLP,NOVRSCR,                ! Watson Added
     +                      NINT1DX,NINT1DY,NINT1DZ,
     +                      MIJ,NIJ,NIJBEG,NIJEND,
     +                      NPGTOA,NPGTOB,
     +                      NXYZA,NXYZB,
     +                      SHELLA,SHELLB,SHELLP,
     +                      XA,YA,ZA,XB,YB,ZB,
     +                      ABX,ABY,ABZ,
     +                      XMOMD,YMOMD,ZMOMD,             ! Watson Added
     +                      NDERX,NDERY,NDERZ,
     +                      DERAX,DERAY,DERAZ,
     +                      DERBX,DERBY,DERBZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      DIFFA,DIFFB,
     +                      ALPHAA,ALPHAB,
     +                      CENSQX,CENSQY,CENSQZ,
     +                      PRIMA,PRIMB,
     +                      NORMA,NORMB,
     +                      RHOAB,
     +                      PAX,PAY,PAZ,
     +                      PINVHF,SCALE,
     +                      PINVA,PINVB,                   ! Watson Added
     +                      EXP2A,EXP2B,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      IP,OVRLP,OVRSCR,               ! Watson Added
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__XYZ_E0_PCGTO_BLOCK
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : OED__XYZ_1D_OVL_MOM_INTEGRALS
C                OED__OVL_1D_AB_INTEGRALS
C                OED__OVL_1D_DERV_INTEGRALS
C                OED__OVL_DERV_INT1D_TO_00
C                OED__OVL_DERV_INT1D_TO_A0
C                OED__OVL_DERV_INT1D_TO_AB
C  DESCRIPTION : This operation calculates a batch of derivated unnormed
C                moment integrals between primitive cartesian gaussians
C
C                                  [A|B]
C                                       ij
C
C                for a block of ij exponent pairs. The total number
C                of overlap integrals generated here is thus given by
C                the total number of cartesian monomials NXYZA * NXYZB
C                times the total number of exponent pairs MIJ in the
C                present block.
C
C                On exit, the batch elements will be stored as:
C
C                             batch (ij,nxyza*nxyzb)
C
C
C                  Input:
C
C                    NBATCH       =  size of the array that will hold
C                                    the final primitive cartesian
C                                    derivative integral batch as well
C                                    as intermediate differentiated
C                                    1D integrals
C                    NINT1Dx      =  space needed for each of the 1D
C                                    x = X,Y,Z integral arrays (they
C                                    might be different due to different
C                                    orders of differentiation for
C                                    each cartesian component)
C                    MIJ          =  current # of ij primitive index
C                                    pairs corresponding to the
C                                    contracted shell pairs A,B
C                    NIJ          =  total # of ij primitive index
C                                    pairs for the contracted shell
C                                    pair A,B
C                    NIJBEG(END)  =  first(last) ij primitive index
C                                    defining the ij block
C                    NPGTOx       =  # of primitives per contraction
C                                    for contraction shells x = A,B
C                    NXYZx        =  # of cartesian monomials for
C                                    each contraction shell x = A,B
C                    SHELLx       =  the shell type for contraction
C                                    shells x = A,B and P=A+B
C                    Xx,Yx,Zx     =  the x,y,z-coordinates for centers
C                                    x = A,B
C                    xMOMD        =  type of moment integral to be
C                                    differentiated. x = X, Y, or Z
C                    ABm          =  the m=x,y,z-coordinate differences
C                                    between centers A and B
C                    NDERp        =  the total order of differentiation
C                                    with respect to the p = x,y,z
C                                    coordinates
C                    DERxp        =  the order of differentiation on
C                                    centers x = A,B with respect to
C                                    the p = x,y,z coordinates
C                    DIFFp        =  is true, if differentiation will
C                                    be performed on centers p = A,B
C                                    involving the p = x,y,z coordinates
C                    ALPHAx       =  the primitive exponents for
C                                    contraction shells x = A,B
C                    CENSQp       =  derivative center sequence array
C                                    for the p = x,y,z coordinates
C                    PRIMx        =  i,j labels of primitives for the
C                                    respective contraction shells
C                                    x = A,B
C                    NORMx        =  the normalization factors due to
C                                    the primitive exponents for the
C                                    contraction shells x = A,B
C                    RHOAB        =  the complete set of NIJ exponential
C                                    prefactors between contraction
C                                    shells A and B
C                    PAx          =  will hold current MIJ coordinate
C                                    x=X,Y,Z differences P-A between
C                                    centers P and A
C                    PINVHF       =  will hold current MIJ values of
C                                    1/(2*P), where P are the exponent
C                                    sums for contraction shells A
C                                    and B
C                    SCALE        =  will hold current MIJ values of
C                                    scaling factors
C                    EXP2x        =  will hold current double primitive
C                                    exponent values in MIJ order for
C                                    each contracted shell x = A,B
C                    INT1Dx       =  will hold all current derivated
C                                    1D integrals for each cartesian
C                                    component (x = X,Y,Z) during all
C                                    stages of differentiation
C
C                  Output:
C
C                    BATCH        =  current batch of primitive
C                                    derivative cartesian overlap
C                                    [A|B] integrals
C
C
C  AUTHOR      : Norbert Flocke
C  MODIFIED    : Thomas Watson
C                   - Changed to do derivatives of moment integrals
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     CASEX,CASEY,CASEZ                     ! Watson Added
         LOGICAL     ATOMIC                                ! Watson Added
         LOGICAL     DIFFA,DIFFB
         LOGICAL     DIFFX,DIFFY,DIFFZ

         INTEGER     XMOMD,YMOMD,ZMOMD                     ! Watson Added
         INTEGER     CENTER
         INTEGER     DERA,DERB
         INTEGER     DERAX,DERAY,DERAZ
         INTEGER     DERBX,DERBY,DERBZ
         INTEGER     DEROPA,DEROPB
         INTEGER     I,J,M,N
         INTEGER     IJ
         INTEGER     MIJ
         INTEGER     NBATCH
         INTEGER     NOVRLP,NOVRSCR                        ! Watson Added
         INTEGER     NDERX,NDERY,NDERZ
         INTEGER     NIJ,NIJBEG,NIJEND
         INTEGER     NINT,NINT1DX,NINT1DY,NINT1DZ
         INTEGER     NPGTOA,NPGTOB
         INTEGER     NXYZA,NXYZB
         INTEGER     SHELLA,SHELLB,SHELLP

         INTEGER     CENSQX (0:NDERX)
         INTEGER     CENSQY (0:NDERY)
         INTEGER     CENSQZ (0:NDERZ)

         INTEGER     PRIMA (1:MIJ)
         INTEGER     PRIMB (1:MIJ)

         DOUBLE PRECISION  ABX,ABY,ABZ
         DOUBLE PRECISION  EXPA,EXPB
         DOUBLE PRECISION  PINV,PVAL
         DOUBLE PRECISION  XA,YA,ZA,XB,YB,ZB
         DOUBLE PRECISION  ZERO,HALF,ONE,ONEP5

         DOUBLE PRECISION  ALPHAA  (1:NPGTOA)
         DOUBLE PRECISION  ALPHAB  (1:NPGTOB)

         DOUBLE PRECISION  NORMA   (1:NPGTOA)
         DOUBLE PRECISION  NORMB   (1:NPGTOB)

         DOUBLE PRECISION  RHOAB   (1:NIJ)

         DOUBLE PRECISION  BATCH   (1:NBATCH)

         DOUBLE PRECISION  IP      (1:MIJ)                 !
         DOUBLE PRECISION  PINVA   (1:MIJ)                 ! Watson Added
         DOUBLE PRECISION  PINVB   (1:MIJ)                 !
         DOUBLE PRECISION  PAX     (1:MIJ)
         DOUBLE PRECISION  PAY     (1:MIJ)
         DOUBLE PRECISION  PAZ     (1:MIJ)
         DOUBLE PRECISION  PINVHF  (1:MIJ)
         DOUBLE PRECISION  SCALE   (1:MIJ)
         DOUBLE PRECISION  EXP2A   (1:MIJ)
         DOUBLE PRECISION  EXP2B   (1:MIJ)

         DOUBLE PRECISION  INT1DX  (1:NINT1DX)
         DOUBLE PRECISION  INT1DY  (1:NINT1DY)
         DOUBLE PRECISION  INT1DZ  (1:NINT1DZ)

         DOUBLE PRECISION  OVRLP   (1:NOVRLP)              ! Watson Added
         DOUBLE PRECISION  OVRSCR  (1:NOVRSCR)

         PARAMETER  (ZERO  = 0.D0)
         PARAMETER  (HALF  = 0.5D0)
         PARAMETER  (ONE   = 1.D0)
         PARAMETER  (ONEP5 = 1.5D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...calculate the quantities needed to establish the
C                1D overlap integrals.
C
C
C             ...Watson...
C
C                - Added the following cases to get the right 
C                  coordinates in.
C
C
         ATOMIC = .FALSE.

         CASEX = (XMOMD .GT. 0)
         CASEY = (YMOMD .GT. 0)
         CASEZ = (ZMOMD .GT. 0)

         M = 0
         DO IJ = NIJBEG,NIJEND
            M = M + 1
            I = PRIMA (M)
            J = PRIMB (M)
            EXPA = ALPHAA (I)
            EXPB = ALPHAB (J)
            PINV = ONE / (EXPA + EXPB)

            IF (CASEX) IP (M) = PINV * (EXPA * XA  +  EXPB * XB) !
            IF (CASEY) IP (M) = PINV * (EXPA * YA  +  EXPB * YB) ! Watson Added
            IF (CASEZ) IP (M) = PINV * (EXPA * ZA  +  EXPB * ZB) !

            PINVA (M) = EXPA * PINV
            PINVB (M) = EXPB * PINV

            PVAL = - EXPB * PINV
            PAX (M) = PVAL * ABX
            PAY (M) = PVAL * ABY
            PAZ (M) = PVAL * ABZ

            PINVHF (M) = HALF * PINV
            SCALE  (M) = (PINV ** ONEP5)
     +                   * NORMA (I) * NORMB (J) * RHOAB (IJ)
         END DO
C
C
C             ...calculate the derivative 1D integral coefficents
C                (if needed). These are the double exponent values
C                for differentiation on centers A and/or B.
C
C
         IF (DIFFA) THEN
             DO IJ = 1,MIJ
                I = PRIMA (IJ)
                EXP2A (IJ) = ALPHAA (I) + ALPHAA (I)
             END DO
         END IF

         IF (DIFFB) THEN
             DO IJ = 1,MIJ
                J = PRIMB (IJ)
                EXP2B (IJ) = ALPHAB (J) + ALPHAB (J)
             END DO
         END IF
C
C
C             ...start assembling the 1D AB overlap integrals and
C                their differentiation. Assemble first the 1DX AB
C                integrals and perform differentiation sequence,
C                if necessary.
C
C
C             ...Watson...
C
C                - For now I'll do X derivatives only and see if it
C                  works.  Then I'll extend to Y and Z deriv. integrals.
C
C
         DO I = 1, NINT1DX
            INT1DX (I) = ZERO
         END DO

         DO I = 1, NINT1DY
            INT1DY (I) = ZERO
         END DO

         DO I = 1, NINT1DZ
            INT1DZ (I) = ZERO
         END DO

         DO I = 1, NOVRLP
            OVRLP  (I) = ZERO
         END DO

         DO I = 1, NOVRSCR
            OVRSCR (I) = ZERO
         END DO

         IF (DIFFX) THEN

             DERA = DERAX
             DERB = DERBX

             IF (CASEX) THEN

                 CALL    OED__XYZ_1D_OVL_MOM_AB_INTEGRALS
     +
     +                        ( SHELLP+DERA+DERB,
     +                          MIN (SHELLA+DERA,SHELLB+DERB),
     +                          SHELLA+DERA,SHELLB+DERB,
     +                          MIJ,
     +                          IP,                            ! Watson Added
     +                          PAX,
     +                          PINVHF,
     +                          ABX,
     +                          OVRLP,                         ! Watson Added
     +                          OVRSCR,
     +                          BATCH,
     +
     +                                    INT1DX )
     +
     +
             ELSE

                 CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                        ( SHELLP+DERA+DERB,
     +                          MIN (SHELLA+DERA,SHELLB+DERB),
     +                          SHELLA+DERA,SHELLB+DERB,
     +                          MIJ,
     +                          PAX,
     +                          PINVHF,
     +                          ABX,
     +                          BATCH,
     +
     +                                    INT1DX )
     +
     +
             END IF

             DO N = 1,NDERX

                NINT = MIJ * (SHELLA+DERA+1) * (SHELLB+DERB+1)

                DO M = 1,NINT
                   BATCH (M) = INT1DX (M)
                END DO

                CENTER = CENSQX (N)

                IF (CENTER.EQ.1) THEN
                    DEROPA = 1
                    DEROPB = 0
                ELSE
                    DEROPA = 0
                    DEROPB = 1
                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB

                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming x-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__ovl_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__OVL_1D_DERV_INTEGRALS
     +              
     +                       ( SHELLA+DERA,SHELLB+DERB,
     +                         DEROPA,DEROPB,
     +                         MIJ,
     +                         EXP2A,EXP2B,
     +                         BATCH,
     +
     +                                  INT1DX )
     +
     +
             END DO

         ELSE

             IF (CASEX) THEN

                 CALL    OED__XYZ_1D_OVL_MOM_AB_INTEGRALS
     +
     +                        ( SHELLP,MIN (SHELLA,SHELLB),
     +                          SHELLA,SHELLB,
     +                          MIJ,
     +                          IP,                            ! Watson Added
     +                          PAX,
     +                          PINVHF,
     +                          ABX,
     +                          OVRLP,                         ! Watson Added
     +                          OVRSCR,
     +                          BATCH,
     +
     +                                    INT1DX )
     +
     +
             ELSE

                 CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                        ( SHELLP,MIN (SHELLA,SHELLB),
     +                          SHELLA,SHELLB,
     +                          MIJ,
     +                          PAX,
     +                          PINVHF,
     +                          ABX,
     +                          BATCH,
     +
     +                                    INT1DX )
     +
     +
             END IF

         END IF
C
C
C             ...assemble the 1DY AB integrals and perform
C                differentiation sequence, if necessary.
C
C
         IF (DIFFY) THEN

             DERA = DERAY
             DERB = DERBY

             IF (CASEY) THEN

                 CALL    OED__XYZ_1D_OVL_MOM_AB_INTEGRALS
     +
     +                        ( SHELLP+DERA+DERB,
     +                          MIN (SHELLA+DERA,SHELLB+DERB),
     +                          SHELLA+DERA,SHELLB+DERB,
     +                          MIJ,
     +                          IP,                            ! Watson Added
     +                          PAY,
     +                          PINVHF,
     +                          ABY,
     +                          OVRLP,                         ! Watson Added
     +                          OVRSCR,
     +                          BATCH,
     +
     +                                    INT1DY )
     +
     +
             ELSE

                 CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                        ( SHELLP+DERA+DERB,
     +                          MIN (SHELLA+DERA,SHELLB+DERB),
     +                          SHELLA+DERA,SHELLB+DERB,
     +                          MIJ,
     +                          PAY,
     +                          PINVHF,
     +                          ABY,
     +                          BATCH,
     +
     +                                    INT1DY )
     +
     +
             END IF

             DO N = 1,NDERY

                NINT = MIJ * (SHELLA+DERA+1) * (SHELLB+DERB+1)

                DO M = 1,NINT
                   BATCH (M) = INT1DY (M)
                END DO

                CENTER = CENSQY (N)

                IF (CENTER.EQ.1) THEN
                    DEROPA = 1
                    DEROPB = 0
                ELSE
                    DEROPA = 0
                    DEROPB = 1
                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB

                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming y-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__ovl_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__OVL_1D_DERV_INTEGRALS
     +
     +                       ( SHELLA+DERA,SHELLB+DERB,
     +                         DEROPA,DEROPB,
     +                         MIJ,
     +                         EXP2A,EXP2B,
     +                         BATCH,
     +
     +                                  INT1DY )
     +
     +
             END DO

         ELSE

             IF (CASEY) THEN

                 CALL    OED__XYZ_1D_OVL_MOM_AB_INTEGRALS
     +
     +                        ( SHELLP,MIN (SHELLA,SHELLB),
     +                          SHELLA,SHELLB,
     +                          MIJ,
     +                          IP,                            ! Watson Added
     +                          PAY,
     +                          PINVHF,
     +                          ABY,
     +                          OVRLP,                         ! Watson Added
     +                          OVRSCR,
     +                          BATCH,
     +
     +                                    INT1DY )
     +
     +
             ELSE

                 CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                        ( SHELLP,MIN (SHELLA,SHELLB),
     +                          SHELLA,SHELLB,
     +                          MIJ,
     +                          PAY,
     +                          PINVHF,
     +                          ABY,
     +                          BATCH,
     +
     +                                    INT1DY )
     +
     +
             END IF

         END IF
C
C
C             ...assemble the 1DZ AB integrals and perform
C                differentiation sequence, if necessary.
C
C
         IF (DIFFZ) THEN

             DERA = DERAZ
             DERB = DERBZ

             IF (CASEZ) THEN

                 CALL    OED__XYZ_1D_OVL_MOM_AB_INTEGRALS
     +
     +                        ( SHELLP+DERA+DERB,
     +                          MIN (SHELLA+DERA,SHELLB+DERB),
     +                          SHELLA+DERA,SHELLB+DERB,
     +                          MIJ,
     +                          IP,                            ! Watson Added
     +                          PAZ,
     +                          PINVHF,
     +                          ABZ,
     +                          OVRLP,                         ! Watson Added
     +                          OVRSCR,
     +                          BATCH,
     +
     +                                    INT1DZ )
     +
     +
             ELSE

                 CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                        ( SHELLP+DERA+DERB,
     +                          MIN (SHELLA+DERA,SHELLB+DERB),
     +                          SHELLA+DERA,SHELLB+DERB,
     +                          MIJ,
     +                          PAZ,
     +                          PINVHF,
     +                          ABZ,
     +                          BATCH,
     +
     +                                    INT1DZ )
     +
     +
             END IF

             DO N = 1,NDERZ

                NINT = MIJ * (SHELLA+DERA+1) * (SHELLB+DERB+1)

                DO M = 1,NINT
                   BATCH (M) = INT1DZ (M)
                END DO

                CENTER = CENSQZ (N)

                IF (CENTER.EQ.1) THEN
                    DEROPA = 1
                    DEROPB = 0
                ELSE
                    DEROPA = 0
                    DEROPB = 1
                END IF

                DERA = DERA - DEROPA
                DERB = DERB - DEROPB

                IF (DERA.LT.0 .OR. DERB.LT.0) THEN
                    WRITE (*,*) ' Problems forming z-derivatives! '
                    WRITE (*,*) ' DERA,DERB = ',DERA,DERB
                    WRITE (*,*) ' oed__ovl_derv_pcgto_block '
                    STOP
                END IF

                CALL    OED__OVL_1D_DERV_INTEGRALS
     +
     +                       ( SHELLA+DERA,SHELLB+DERB,
     +                         DEROPA,DEROPB,
     +                         MIJ,
     +                         EXP2A,EXP2B,
     +                         BATCH,
     +
     +                                  INT1DZ )
     +
     +
             END DO

         ELSE

             IF (CASEZ) THEN

                 CALL    OED__XYZ_1D_OVL_MOM_AB_INTEGRALS
     +
     +                        ( SHELLP,MIN (SHELLA,SHELLB),
     +                          SHELLA,SHELLB,
     +                          MIJ,
     +                          IP,                            ! Watson Added
     +                          PAZ,
     +                          PINVHF,
     +                          ABZ,
     +                          OVRLP,                         ! Watson Added
     +                          OVRSCR,
     +                          BATCH,
     +
     +                                    INT1DZ )
     +
     +
             ELSE

                 CALL    OED__OVL_1D_AB_INTEGRALS
     +
     +                        ( SHELLP,MIN (SHELLA,SHELLB),
     +                          SHELLA,SHELLB,
     +                          MIJ,
     +                          PAZ,
     +                          PINVHF,
     +                          ABZ,
     +                          BATCH,
     +
     +                                    INT1DZ )
     +
     +
             END IF

         END IF
C
C
C             ...assemble the 1D AB integrals to the [A|B] batch.
C
C
         IF (SHELLP.EQ.0) THEN

             CALL    OED__XYZ_DERV_INT1D_TO_00
     +
     +                    ( MIJ,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      CASEX,CASEY,CASEZ,             ! Watson Added
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLB.EQ.0) THEN

             CALL    OED__XYZ_DERV_INT1D_TO_A0
     +
     +                    ( SHELLA,
     +                      MIJ,
     +                      NXYZA,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      CASEX,CASEY,CASEZ,             ! Watson Added
     +                      PAX,PAY,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE IF (SHELLA.EQ.0) THEN

             CALL    OED__XYZ_DERV_INT1D_TO_A0
     +
     +                    ( SHELLB,
     +                      MIJ,
     +                      NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      CASEX,CASEY,CASEZ,             ! Watson Added
     +                      PAX,PAY,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         ELSE

             CALL    OED__XYZ_DERV_INT1D_TO_AB
     +
     +                    ( SHELLA,SHELLB,
     +                      MIJ,
     +                      NXYZA,NXYZB,
     +                      INT1DX,INT1DY,INT1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      CASEX,CASEY,CASEZ,             ! Watson Added
     +                      PAX,PAY,
     +                      SCALE,
     +
     +                                BATCH )
     +
     +
         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__CHECK_NHO_ALL_X_CENTERS
     +
     +                    ( NATOM,
     +                      BONDSIZE,NBOSIZE,
     +                      NHCEN,NHATOM,
     +                      MXNHBA,MXNBA,
     +                      ATHCEN,ATNHB,ATHVAL,ATHOFF,
     +                      RYD2HYB,
     +                      ATHIDX,INDEX,
     +                      NHB,NHA,
     +                      WBOND,WSTAR,
     +                      SAH,
     +                      PH,PHSUB,
     +                      BOMAT,
     +                      MXCHOOSE,NCHOOSE,CHOOSE,
     +                      IVEC,
     +                      XVEC,XMAT,
     +
     +                              FAILED,
     +                              NBOND,
     +                              NHYB,
     +                              BDNCEN,
     +                              BDCEN,
     +                              BDNBAS,
     +                              BDBAS,
     +                              BDOCC,
     +                              W,H,
     +                              PHDEP )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__CHECK_NHO_ALL_X_CENTERS
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine checks, if bond forming pre-NHO orbitals
C                can be constructed over NHCEN atomic hybrid centers
C                from the present hybrid occupation matrix PH. The
C                occupation matrix PH may already have been depleted of
C                several large eigenvalues corresponding to occupied
C                bond orbitals.
C
C                The procedure loops over all distinct! NHCEN atomic
C                hybrid center combinations and tries each out for
C                possible bond forming pre-NHO construction. If, at
C                any stage of this process, a failure in the bond
C                forming pre-NHO generation is issued by the calling
C                subroutines, the routine returns immediately.
C
C                Since 2-center bonds play such a fundamental role,
C                the routine considers this special case in a different
C                way. Rather than looping by brute force over all
C                atomic pairs indiscriminantly, the loop is only over
C                those atomic pairs which were found to have the
C                largest atomic bond orders. By imposing that order
C                for the 2-center bond search we eliminate all possible
C                'surprise' bonds between two centers that might pop
C                up during the brute force search, preventing 2-center
C                bonds to be formed where they actually should be. The
C                'surprise' bonds can form when the weight criterion
C                for bond formation is low and they prevent true bond
C                formation later on because they remove the bond
C                content from the occupation matrix.
C
C
C                  Input:
C
C                    NATOM        =  total # of atomic centers
C                    BONDSIZE     =  maximum # of atomic centers that
C                                    are allowed to form a bond.
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    NHCEN        =  current # of atomic hybrid centers
C                                    to be checked for NHCEN centered
C                                    bond construction.
C                    NHATOM       =  current total # of atomic hybrid
C                                    centers left for checking.
C                    MXNHBA       =  maximum # of Hybrid NAOs per atom.
C                    MXNBA        =  overall maximum between the
C                                    maximum # of Hybrid, Core and
C                                    Rydberg NAOs per atom.
C                    ATHCEN (I)   =  current hybrid atomic labels
C                                    (indices) for I-th atomic hybrid
C                                    center within the set of NHATOM
C                                    atomic hybrid centers.
C                    ATNHB (A)    =  # of Hybrid NAOs on hybrid atom A.
C                    ATHVAL (A)   =  # of Valence NAOs on hybrid atom A.
C                    ATHOFF (A)   =  index offset for Hybrid NAOs for
C                                    hybrid atom A. This index is equal
C                                    to the total number of Hybrid NAOs
C                                    on all hybrid atoms preceeding
C                                    hybrid atom A.
C                    RYD2HYB      =  is true, if the Rydberg NAO space
C                                    should be included next to the
C                                    Valence NAO space for natural 
C                                    hybrid orbital (NHO) construction.
C                                    If false, only the Valence NAO
C                                    space will be used.
C                    ATHIDX (I)   =  will contain NHCEN atomic labels
C                                    out of the pool of the NHATOM
C                                    atomic labels present in array
C                                    ATHCEN.
C                    INDEX (I)    =  simple index array that will hold
C                                    index numbers from 1 to NHCEN in
C                                    strictly increasing order.
C                    NHB          =  total # of Hybrid NAOs.
C                    NHA          =  total # of hybrid atoms.
C                    WBOND        =  lowest weight above which a
C                                    NHCEN-centered bond formation
C                                    is accepted.
C                    WSTAR        =  highest weight below which a
C                                    NHCEN-centered antibond formation
C                                    is accepted.
C                    SAH          =  will contain the atomic hybrid
C                                    overlap matrices between pre-NHOs.
C                    PH           =  current (possibly frequently large
C                                    eigenvalue depleted) NHB x NHB
C                                    hybrid occupation matrix.
C                    PHSUB        =  will contain the submatrix of
C                                    the occupation matrix PH
C                                    corresponding to a specific
C                                    NHCEN atomic hybrid center
C                                    combination.
C                    BOMAT (A,B)  =  simplified bond order matrix
C                                    containing info if atoms A and B
C                                    are considered to be bonded or not
C                    MXCHOOSE     =  maximum # of bonds selected to
C                                    be chosen. The maximum is build
C                                    from all # of chosen bonds for all
C                                    bondsizes.
C                    NCHOOSE      =  # of bonds to be chosen for bonds
C                                    of size NHCEN. Four cases:
C                                    1) = 9999 => skip search for bonds
C                                       of size NHCEN.
C                                    2) = 0 => complete search for all
C                                       possible bonds of size NHCEN
C                                       will be performed.
C                                    3) = -n => only n bonds of size
C                                       NHCEN will be searched between
C                                       those atomic indices as
C                                       provided by the CHOOSE array.
C                                    4) = +n => same as case 3) but
C                                       followed by a complete search
C                                       for all possible remaining
C                                       bonds of size NHCEN.
C                                    Priority level: 1) > 3) > 4) > 2).
C                    CHOOSE (I,N) =  contains the I-th atomic index of
C                                    the N-th chosen bond of size NHCEN.
C                                    The order of the atomic indices
C                                    is arbitrary.
C                    IVEC         =  int scratch array of vector type
C                    XVEC         =  flp scratch array of vector type
C                    XMAT         =  flp scratch array of matrix type
C                              
C
C
C                  Output:
C
C                    FAILED       =  is true, if any problems were
C                                    found such that the present
C                                    and subordinate routines cannot
C                                    proceed.
C                    NBOND        =  current total # of bonds.
C                    NHYB (A)     =  current total # of pre-NHO's on
C                                    each hybrid atom A.
C                    BDNCEN (J)   =  # of atomic centers for J-th bond.
C                    BDCEN (I,J)  =  I-th atomic center index for
C                                    J-th bond.
C                    BDNBAS (J)   =  # of basis functions (NHOs) for
C                                    J-th bond.
C                    BDBAS (I,J)  =  I-th global basis (NHO) index for
C                                    J-th bond.
C                    BDOCC (J)    =  # of occupied levels for J-th bond.
C                    W            =  pre-NHO weight vector to accumulate
C                                    the weights for WSW procedure.
C                    H (I,J)      =  MXNBA x NHB matrix containing the
C                                    current found set of pre-NHOs for
C                                    each hybrid atom. I is the local
C                                    atomic index labeling the atomic
C                                    hybrid NAOs from which the NHOs are
C                                    constructed. J is the global NHO
C                                    index running over all NHB space
C                                    pre-NHOs in that order, with all
C                                    pre-NHOs belonging to a specific
C                                    atomic center being grouped
C                                    together.
C                    PHDEP        =  used for accumulation of the 
C                                    depleted occupation matrix PH.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ABSOLUT
         LOGICAL     ACCEPT
         LOGICAL     CHOOSED
         LOGICAL     FAILED
         LOGICAL     INCRESE
         LOGICAL     NLO__ACCEPT_ATOMS_BOND_SEARCH
         LOGICAL     RYD2HYB

         INTEGER     BONDSIZE,NBOSIZE
         INTEGER     I,K,N
         INTEGER     IXPOS
         INTEGER     MXCHOOSE
         INTEGER     MXNHBA,MXNBA
         INTEGER     NATOM
         INTEGER     NBOND
         INTEGER     NCHOOSE
         INTEGER     NHCEN
         INTEGER     NHATOM
         INTEGER     NHB,NHA

         INTEGER     ATNHB   (1:NHA   )
         INTEGER     ATHCEN  (1:NHATOM)
         INTEGER     ATHIDX  (1:NHCEN )
         INTEGER     ATHOFF  (1:NHA   )
         INTEGER     ATHVAL  (1:NHA   )
         INTEGER     BDNBAS  (1:NHB   )
         INTEGER     BDNCEN  (1:NHB   )
         INTEGER     BDOCC   (1:NHB   )
         INTEGER     INDEX   (1:NHCEN )
         INTEGER     IVEC    (1:2*NHB+NHA)
         INTEGER     NHYB    (1:NHA   )

         INTEGER     BDBAS   (1:NBOSIZE,1:NHB)
         INTEGER     BDCEN   (1:NBOSIZE,1:NHB)
         INTEGER     CHOOSE  (1:BONDSIZE,1:MXCHOOSE)

         DOUBLE PRECISION  WBOND,WSTAR

         DOUBLE PRECISION  W    (1:NHB)
         DOUBLE PRECISION  XVEC (1:2*NHB)

         DOUBLE PRECISION  BOMAT (1:NATOM ,1:NATOM )
         DOUBLE PRECISION  H     (1:MXNBA ,1:NHB   )
         DOUBLE PRECISION  PH    (1:NHB   ,1:NHB   )
         DOUBLE PRECISION  PHDEP (1:NHB   ,1:NHB   )
         DOUBLE PRECISION  PHSUB (1:NHB   ,1:NHB   )
         DOUBLE PRECISION  SAH   (1:MXNHBA,1:MXNHBA)
         DOUBLE PRECISION  XMAT  (1:NHB   ,1:NHB   )
C
C
C------------------------------------------------------------------------
C
C
C             ...if bonds of size NHCEN should be skipped, return.
C
C
         IF (NCHOOSE.EQ.9999) THEN
             RETURN
         END IF
C
C
C             ...if bonds of size NHCEN have been choosen, do these
C                first.
C
C
         CHOOSED = .FALSE.

         N = IABS (NCHOOSE)

         IF (N.GT.0) THEN

             ABSOLUT = .FALSE.
             INCRESE = .TRUE.

             DO K = 1,N

                ACCEPT = NLO__ACCEPT_ATOMS_BOND_SEARCH
     +
     +                        ( NATOM,
     +                          BONDSIZE,
     +                          NHCEN,NHA,
     +                          CHOOSE (1,K),ATHVAL,
     +                          NHYB,
     +                          BOMAT,
     +                          CHOOSED,
     +                          MXCHOOSE,NCHOOSE,CHOOSE,
     +                          IVEC )
     +
     +
                IF (ACCEPT) THEN

                    CALL  NLO__SORT_INT_VECTOR_ELEMENTS
     +
     +                         ( NHCEN,NHCEN,
     +                           1,NHCEN,
     +                           ABSOLUT,INCRESE,
     +                           0,
     +                           CHOOSE (1,K),
     +
     +                                    IVEC )
     +
     +
                    DO I = 1,NHCEN
                       ATHIDX (I) = CHOOSE (IVEC (I),K)
                    END DO

                    CALL  NLO__CHECK_NHO_X_CENTERS
     +
     +                         ( NHCEN,
     +                           NBOSIZE,
     +                           MXNHBA,MXNBA,
     +                           ATHIDX,ATNHB,ATHVAL,ATHOFF,
     +                           RYD2HYB,
     +                           NHB,NHA,
     +                           WBOND,WSTAR,
     +                           SAH,
     +                           PH,PHSUB,
     +                           IVEC (1),IVEC (NHB+1),IVEC (2*NHB+1),
     +                           XVEC (1),
     +                           XVEC (NHB+1),XMAT,
     +
     +                                    FAILED,
     +                                    NBOND,
     +                                    NHYB,
     +                                    BDNCEN,
     +                                    BDCEN,
     +                                    BDNBAS,
     +                                    BDBAS,
     +                                    BDOCC,
     +                                    W,H,
     +                                    PHDEP )
     +
     +
                    IF (FAILED) THEN
                        RETURN
                    END IF
                END IF

             END DO

             IF (NCHOOSE.LT.0) THEN
                 RETURN
             END IF

             CHOOSED = .TRUE.

         END IF
C
C
C             ...the complete search for all bonds of size NHCEN.
C                Handle special situation for 1-center bonds.
C
C
         IF (NHCEN.EQ.1) THEN

             DO K = 1,NHATOM

                ATHIDX (1) = ATHCEN (K)

                CALL  NLO__CHECK_NHO_X_CENTERS
     +
     +                     ( 1,
     +                       NBOSIZE,
     +                       MXNHBA,MXNBA,
     +                       ATHIDX,ATNHB,ATHVAL,ATHOFF,
     +                       RYD2HYB,
     +                       NHB,NHA,
     +                       WBOND,WSTAR,
     +                       SAH,
     +                       PH,PHSUB,
     +                       IVEC (1),IVEC (NHB+1),IVEC (2*NHB+1),
     +                       XVEC (1),
     +                       XVEC (NHB+1),XMAT,
     +
     +                                FAILED,
     +                                NBOND,
     +                                NHYB,
     +                                BDNCEN,
     +                                BDCEN,
     +                                BDNBAS,
     +                                BDBAS,
     +                                BDOCC,
     +                                W,H,
     +                                PHDEP )
     +
     +
                IF (FAILED) THEN
                    RETURN
                END IF

             END DO

             RETURN

         END IF
C
C
C             ...the general case for bond with >= 2 centers. Set
C                initial atomic hybrid center index combination:
C                1 2 3 4 5 ...
C
C
         ABSOLUT = .FALSE.
         INCRESE = .TRUE.

         DO I = 1,NHCEN
            IVEC (I) = ATHCEN (I)
            INDEX (I) = I
         END DO

         ACCEPT = NLO__ACCEPT_ATOMS_BOND_SEARCH
     +
     +                 ( NATOM,
     +                   BONDSIZE,
     +                   NHCEN,NHA,
     +                   IVEC,ATHVAL,
     +                   NHYB,
     +                   BOMAT,
     +                   CHOOSED,
     +                   MXCHOOSE,NCHOOSE,CHOOSE,
     +                   IVEC (NHCEN+1) )
     +
     +
         IF (ACCEPT) THEN

             CALL  NLO__SORT_INT_VECTOR_ELEMENTS
     +
     +                  ( NHCEN,NHCEN,
     +                    1,NHCEN,
     +                    ABSOLUT,INCRESE,
     +                    0,
     +                    IVEC,
     +
     +                             IVEC (NHCEN+1) )
     +
     +
             DO I = 1,NHCEN
                ATHIDX (I) = IVEC (IVEC (NHCEN+I))
             END DO

             CALL  NLO__CHECK_NHO_X_CENTERS
     +
     +                  ( NHCEN,
     +                    NBOSIZE,
     +                    MXNHBA,MXNBA,
     +                    ATHIDX,ATNHB,ATHVAL,ATHOFF,
     +                    RYD2HYB,
     +                    NHB,NHA,
     +                    WBOND,WSTAR,
     +                    SAH,
     +                    PH,PHSUB,
     +                    IVEC (1),IVEC (NHB+1),IVEC (2*NHB+1),
     +                    XVEC (1),
     +                    XVEC (NHB+1),XMAT,
     +
     +                             FAILED,
     +                             NBOND,
     +                             NHYB,
     +                             BDNCEN,
     +                             BDCEN,
     +                             BDNBAS,
     +                             BDBAS,
     +                             BDOCC,
     +                             W,H,
     +                             PHDEP )
     +
     +
             IF (FAILED) THEN
                 RETURN
             END IF
         END IF

         K = 0
C
C
C             ...find all combinations of the NHCEN index numbers
C                such that each index number is greater than the
C                preceeding one. If we encounter an index combination
C                that gives us a hybrid atom combination involving
C                at least one atom with an already complete bond forming
C                pre-NHO set, that index combination is not accepted
C                for x-center bond search, and we move to the next
C                possible one. The same, if the index combination
C                indicates isolated (not bonded) atoms, as judged by
C                the simplified bond order matrix.
C
C
 1000    IXPOS = NHCEN - K
         INDEX (IXPOS) = INDEX (IXPOS) + 1

         IF (INDEX (IXPOS) .LE. (NHATOM-K)) THEN

             DO I = 1,K
                INDEX (IXPOS+I) = INDEX (IXPOS) + I
             END DO

             DO I = 1,NHCEN
                IVEC (I) = ATHCEN (INDEX (I))
             END DO

             ACCEPT = NLO__ACCEPT_ATOMS_BOND_SEARCH
     +
     +                     ( NATOM,
     +                       BONDSIZE,
     +                       NHCEN,NHA,
     +                       IVEC,ATHVAL,
     +                       NHYB,
     +                       BOMAT,
     +                       CHOOSED,
     +                       MXCHOOSE,NCHOOSE,CHOOSE,
     +                       IVEC (NHCEN+1) )
     +
     +
C
C
C             ...if the current atomic index pattern is found to
C                be accepted, reorder the atomic indices such that
C                indices i,j,k,... will be ordered in ascending
C                order i<j<k<...to allow easy construction of the
C                corresponding density submatrix. Note, that the
C                atomic index vector ATHIDX is being overwritten
C                by this reordering.
C
C
             IF (ACCEPT) THEN

                 CALL  NLO__SORT_INT_VECTOR_ELEMENTS
     +
     +                      ( NHCEN,NHCEN,
     +                        1,NHCEN,
     +                        ABSOLUT,INCRESE,
     +                        0,
     +                        IVEC,
     +
     +                                 IVEC (NHCEN+1) )
     +
     +
                 DO I = 1,NHCEN
                    ATHIDX (I) = IVEC (IVEC (NHCEN+I))
                 END DO

                 CALL  NLO__CHECK_NHO_X_CENTERS
     +
     +                      ( NHCEN,
     +                        NBOSIZE,
     +                        MXNHBA,MXNBA,
     +                        ATHIDX,ATNHB,ATHVAL,ATHOFF,
     +                        RYD2HYB,
     +                        NHB,NHA,
     +                        WBOND,WSTAR,
     +                        SAH,
     +                        PH,PHSUB,
     +                        IVEC (1),IVEC (NHB+1),IVEC (2*NHB+1),
     +                        XVEC (1),
     +                        XVEC (NHB+1),XMAT,
     +
     +                                 FAILED,
     +                                 NBOND,
     +                                 NHYB,
     +                                 BDNCEN,
     +                                 BDCEN,
     +                                 BDNBAS,
     +                                 BDBAS,
     +                                 BDOCC,
     +                                 W,H,
     +                                 PHDEP )
     +
     +
                 IF (FAILED) THEN
                     RETURN
                 END IF
             END IF

             K = 0
         ELSE
             K = K + 1
             IF (K .GT. (NHCEN-1)) THEN
                 RETURN
             END IF
         END IF

         GOTO 1000
C
C
C             ...ready!
C
C
         END 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine sleep_wrapper(nsecs)
c---------------------------------------------------------------------------
c   Wrapper routine for machine-dependent sleep routines.
c---------------------------------------------------------------------------
      implicit none
      integer nsecs
      integer*4 i4sleep,i4junk,i4err
#ifdef __crayx1
      i4sleep = nsecs
      call pxfsleep(i4sleep,i4junk,i4err)
#else
      call sleep(nsecs)
#endif
      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine server_barrier(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'int_gen_parms.h'
      include 'server_barrier_data.h'
      include 'dbugcom.h'

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer i
      integer ierr
      integer company_comm, pst_get_company_comm
      integer pst_get_company
      integer niocompany
      integer request(max_procsx)
      integer msg(5)
      integer statuses(MPI_STATUS_SIZE,max_procsx)
      integer status(MPI_STATUS_SIZE)

      if (dbg) then
         print *,'Task ',me,
     *    ' is waiting at Server barrier: line number ',
     *   current_line
         call prt_time('Worker time')
         call c_flush_stdout()
      endif

      company_comm = pst_get_company_comm(me)
      if (my_company_size .ne. 1) then 

c---------------------------------------------------------------------------
c   First, we do a sip_barrier.  This guarantees that no more request/prepare
c   instructions will be submitted from the workers.
c---------------------------------------------------------------------------

         call sip_barrier(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table,
     *                      address_table, op)
      endif   ! my_company_size .ne. 1

c--------------------------------------------------------------------------
c   Wait until the servers have received all the descriptor messages that
c   have been sent.
c--------------------------------------------------------------------------

      call mpi_waitall(mx_msg, server_requests, 
     *                    statuses, ierr)
      if (dbg) print *,'Task ',me,' Completed waitall at line ',
     *     current_line 

c-------------------------------------------------------------------------
c   Send a barrier message to each I/O server from each worker of this company.
c-------------------------------------------------------------------------

      niocompany = 0
      msg(1) = sip_server_barrier_signal
      msg(4) = current_line   ! in the "tag" field of the msg.
      do i = me+1, nprocs
         if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Send the barrier message.
c---------------------------------------------------------------------------

            niocompany = niocompany + 1
            call mpi_isend(msg, 4,
     *               MPI_INTEGER, i-1,
     *               sip_server_message, mpi_comm_world,
     *               request(niocompany), ierr)
         endif
      enddo
      do i = 1, me
         if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Send the barrier message.
c---------------------------------------------------------------------------

            niocompany = niocompany + 1
            call mpi_isend(msg, 4,
     *               MPI_INTEGER, i-1,
     *               sip_server_message, mpi_comm_world,
     *               request(niocompany), ierr)
         endif
      enddo

c---------------------------------------------------------------------------
c   Wait until all servers have received their barrier signal.
c---------------------------------------------------------------------------

      call mpi_waitall(niocompany, request, 
     *                    statuses, ierr)
      call prt_time('All server barrier signals were received.')

c---------------------------------------------------------------------------
c   Wait for a response from each server acknowledging receipt.
c---------------------------------------------------------------------------

      if (my_company_rank .eq. 0) then
         niocompany = 0
         do i = me+1, nprocs
            if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Receive the barrier message.
c   Each server will send a 1-word indicator message using the 
c   sip_server_barrier_signal as the message tag.
c---------------------------------------------------------------------------

               niocompany = niocompany + 1
               call mpi_irecv(msg, 1,
     *               MPI_INTEGER, i-1,
     *               sip_server_barrier_signal, mpi_comm_world,
     *               request(niocompany), ierr)
            endif
         enddo

         do i = 1, me
            if (pst_get_company(i-1) .eq. io_company_id) then

c---------------------------------------------------------------------------
c   Proc i-1 is a server.  Receive the barrier message.
c   Each server will send a 1-word indicator message using the 
c   sip_server_barrier_signal as the message tag.
c---------------------------------------------------------------------------

               niocompany = niocompany + 1
               call mpi_irecv(msg, 1,
     *               MPI_INTEGER, i-1,
     *               sip_server_barrier_signal, mpi_comm_world,
     *               request(niocompany), ierr)
            endif
         enddo
c-----------------------------------------------------------------------
c   Wait for all the acknowledgement messages.
c------------------------------------------------------------------------

         call mpi_waitall(niocompany, request, statuses, 
     *                    ierr)
      endif 
      if (dbg) print *,'Task ',me,' Completed server response at line ',
     *     current_line 

c---------------------------------------------------------------------------
c   Reset all persistent blocks  of all arrays which have had a "PREPARE"
c   since the last barrier.
c   This is done to insure data integrity.
c---------------------------------------------------------------------------

      do i = 1, narray_table
         if (array_table(c_prepare_flag,i) .ne. 0) then
            array_table(c_prepare_flag,i) = 0
            call free_persistent_blocks(i, array_table, narray_table,
     *               index_table, nindex_table, block_map_table)
         endif
      enddo
      if (dbg) print *,'Task ',me,' Completed free persistnt blocks at 
     *                  line ', current_line 

c--------------------------------------------------------------------------
c   Force all processors to await acknowledgement that the servers have
c   received the barrier signal.
c--------------------------------------------------------------------------

      call mpi_barrier(company_comm, ierr)
      call prt_time('Passed the server barrier.')

c--------------------------------------------------------------------------
c   Dont proceed unless there are enough free blocks.  
c               EXPERIMENTAL 
c--------------------------------------------------------------------------

c     call check_stack_pop(array_table, narray_table, index_table,
c    *                           nindex_table, block_map_table)

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.

c This routine allocates a heap for processing RICs and creates pointers
c into the heap for various arrays.

      subroutine init_ric_heap
      implicit none

#include "machsp.com"
#include "ric_heap.com"
#include "mxatms.par"
#include "coord.com"

      integer iNeed 
      integer*8 ndx
      integer s_DerBMat, s_BMat, s_GMat, s_BTGInv
      integer ierr
      integer i,sheap_flag
      integer totrednco

c   o don't allocate memory more than once
      if (heapptr.ne.0) return

      iNeed = 0
      CALL IGETREC(20, 'JOBARC', 'REDNCORD', 1, TOTREDNCO)

c   o DerBMat: The derivative of the B-matrix for transforming the
c              Hessian between RICs and Cartesians.
C      s_DerBMat = 9*mxatms*mxatms*maxredunco
      s_DerBMat = 9*natoms*natoms*totrednco
      iNeed = iNeed + s_DerBMat

c   o BMat: The B-matrix for RIC/Cartesian transformations.
      s_BMat = 9*totrednco*natoms
c      s_BMat = 9*mxatms*mxatms
      iNeed = iNeed + s_BMat

c   o GMat: The G-matrix for RIC/Cartesian gradient transformations.
      s_GMat = totrednco*max(totrednco,3*natoms)
C      s_GMat = 9*mxatms*mxatms
      iNeed = iNeed + s_GMat

c   o BTGInv: inv(trans(B)*G) required for transforming the Hessian.
      s_BTGInv = 3*natoms*totrednco
C      s_BTGInv = 3*mxatms*maxredunco
      iNeed = iNeed + s_BTGInv

c      ndx = iintfp*iNeed
c      print *,'INIT_RIC_HEAP: iintfp, iNeed, ndx ',iintfp, iNeed, ndx
c      call aces_malloc(ndx,dRICHeap,z_RICHeap, heapptr)
c      if (heapptr .eq. 0) then
c         print *, '@INIT_RIC_HEAP: Failed to allocate memory.'
c         print *, '                need ',iNeed/1024/1024,' MB'
c         call errex
c      end if

c      print *,'AFTER ACES_MALLOC: heapptr = ',heapptr,' z_RICHeap ',
c     *   z_RICHeap
c      z_RICHeap = (z_RICHeap+iintfp-1)/iintfp

#ifdef ALTIX
      sheap_flag = 1
#else
      sheap_flag = 0
#endif

      call mem_alloc(dRICHeap, iNeed, ifltln,
     *               z_RICHeap, .true., ierr)
      if (ierr .ne. 0) then
         print *,'ERROR in INIT_RIC_HEAP: Cannot alloc ',iNeed,
     *      ' words of double precision data'
         call errex() 
      endif

      ndx = z_RICHeap
#ifdef _DEBUG
      call c_memset(dRICHeap(z_RICHeap),255,ifltln*iNeed)
#endif

c   o DerBMat location
      z_DerBMat = ndx
      ndx = ndx + s_DerBMat

c   o BMat location
      z_BMat = ndx
      ndx = ndx + s_BMat

c   o GMat location
      z_GMat = ndx
      ndx = ndx + s_GMat

c   o BTGInv location
      z_BTGInv = ndx
      ndx = ndx + s_BTGInv

c      print *, '@INIT_RIC_HEAP: RIC HEAP INDICES'
c      print *, '                z_RICHeap = ',z_RICHeap
c      print *, '                z_DerBMat = ',z_DerBMat
c      print *, '                z_BMat    = ',z_BMat
c      print *, '                z_GMat    = ',z_GMat
c      print *, '                z_BTGInv  = ',z_BTGInv

      return
c     end subroutine init_ric_heap
      end

C THIS ROUTINE SETS ALL VALUES IN A VECTOR A TO ZERO IF
C THEY ARE BELOW A SPECIFIED TOLERANCE (TOL).

      SUBROUTINE FILTER(A,LENGTH,TOL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LENGTH)
      if (length.lt.1) return
      DO I = 1, LENGTH
         X = ABS(A(I))
         IF (X.LT.TOL) A(I) = 0.0
      END DO
      RETURN
      END

      SUBROUTINE MKDEN(COEF,DENS,NBFP,
     $     NOCC,IFLG,ICORR,DENRELN,DENSCF,COEF2,TEMPMAT,IUHF,
     $     NDFT)
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION COEF(NBFP*NBFP),DENS(NBFP*NBFP),
     $     NOCC(16),DENRELN(NBFP*NBFP),DENSCF(NBFP*NBFP),
     $     COEF2(NBFP*NBFP),TEMPMAT(NBFP*NBFP)
C     
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /IPAR/ LUOUT
      COMMON /ISYMINF/ NIRREP,NSOIRP(8)
C     
      NBAS2=NBFP*NBFP
C     
      FACTOR=0.5
      IF (IUHF.NE.0) FACTOR=1.0
C     
      CALL ZERO(DENSCF,NBAS2)
C
      IF(IFLG.EQ.0) THEN
C
C Get the matrix of alpha MO's
C
C Get the scf mo in the scf order
         IF (NDFT.EQ.0) THEN
            CALL GETREC(20,'JOBARC','SCFEVCAS',IINTFP*NBAS2,COEF)
         ELSE
            CALL GETREC(20,'JOBARC','SCFEVCA0',IINTFP*NBAS2,COEF)
         END IF
         ISOFF=0
         WRITE(*,*) " scf mo to so transformation"
         CALL PRINTMAT(COEF,NBFP,NBFP)
C
      ELSE
C Get the matrix of beta MO's
         IF (NDFT.EQ.0) THEN
            if (iuhf.eq.0) then
            else
               CALL GETREC(20,'JOBARC','SCFEVCBS',IINTFP*NBAS2,COEF)
            end if
         ELSE
            CALL GETREC(20,'JOBARC','SCFEVCB0',IINTFP*NBAS2,COEF)
         END IF
         ISOFF=8
         WRITE(*,*) " scf mo to so transformation"
         CALL PRINTMAT(COEF,NBFP,NBFP)
C     
         ENDIF
C     
         IF (ICORR.EQ.0) THEN
C     
C     Calculate the SCF density
            IOFF=0
            IOFF2=0
            DO 10 ISYM=1,NIRREP
               NOCCT=NOCC(ISOFF+ISYM)
               DO 20 IOCC=1,NOCCT
                  DO 30 I=1,NSOIRP(ISYM)
                     DO 40 J=1,NSOIRP(ISYM)
C     scf density
                        DENSCF((IOFF+I-1)*NBFP+IOFF+J)=
     $                       DENSCF((IOFF+I-1)*NBFP+IOFF+J)+
     $                       COEF((IOFF+IOCC-1)*NBFP+IOFF+I)
     $                       *COEF((IOFF+IOCC-1)*NBFP+IOFF+J)
C     
 40                  CONTINUE
 30               CONTINUE
 20            CONTINUE
               IOFF=IOFF+NSOIRP(ISYM)
               IOFF2=IOFF2+NOCCT*NBAS2
 10         CONTINUE
C     
            DO 50 I=1,NBAS2
               DENS(I)=DENSCF(I)
 50         CONTINUE
         ELSE
C     
            IF (IFLG.EQ.0) THEN
               CALL GETREC(20,'JOBARC','RELDENSA',IINTFP*NBAS2,DENRELN)
               WRITE(*,*) "correlated density matrix in mo basis"
               CALL PRINTMAT(DENRELN,NBFP,NBFP)
               CALL GETREC(20,'JOBARC','SCFEVCA0',IINTFP*NBAS2,COEF2)
               WRITE(*,*) "mo->ao trasformation"
               CALL PRINTMAT(COEF2,NBFP,NBFP)
            ELSE
               CALL GETREC(20,'JOBARC','RELDENSB',IINTFP*NBAS2,DENRELN)
               WRITE(*,*) "correlated density matrix in mo basis"
               CALL PRINTMAT(DENRELN,NBFP,NBFP)
               CALL GETREC(20,'JOBARC','SCFEVCB0',IINTFP*NBAS2,COEF2)
               WRITE(*,*) "mo->ao trasformation"
               CALL PRINTMAT(COEF2,NBFP,NBFP)
            END IF
C     
C     Transform the correlated density from the scf-mo basis to the scf-so basis
C     
            CALL XGEMM('N','N',NBFP,NBFP,NBFP,1.0D+00,COEF2,
     $           NBFP,DENRELN,NBFP,0.0D+00,TEMPMAT,NBFP)
            CALL XGEMM('N','T',NBFP,NBFP,NBFP,10.D+00,TEMPMAT,
     $           NBFP,COEF2,NBFP,0.0D+00,DENS,NBFP)
C     
            DO 60 I=1,NBAS2
               DENS(I)=FACTOR*DENS(I)
               DENRELN(I)=FACTOR*DENRELN(I)
 60         CONTINUE
C     
         WRITE(*,*) "SO based correlated density"
         CALL PRINTMAT(DENS,NBFP,NBFP)
C     WRITE(*,*) "DENRELN"
C     CALL PRINTMAT(DENRELN,NBFP,NBFP)
      END IF
C     
      RETURN
      END
      

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine init_oed_integrals(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table, 
     *                      address_table, op, type)
c---------------------------------------------------------------------------
c   Generates one-electron integrals of a particular type in the memory
c   allocated for the array in the array of "op".
c
c   type = 1  --> NAI integrals
c          2  --> KIN integrals
c          3  --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'parallel_info.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer*8 address_table(narray_table)
      integer type

      integer array
      integer*8 addr, ixarray, get_index_from_base
      double precision xxx(1)
#ifdef ALTIX
      pointer (dptr, xxx)
#else
      common xxx
#endif

c-------------------------------------------------------------------------
c   Locate array address in array_table.
c-------------------------------------------------------------------------

#ifdef ALTIX
      dptr = dshptr
#endif

      array    = op(c_result_array)
      addr     = address_table(array)
      ixarray  = get_index_from_base(addr, xxx, 2)

      call compute_oed_integrals(type, xxx(ixarray))

      return
      end

      SUBROUTINE SETD2XYZ(NATOM,Q,ATMASS,STRING1,STRING2,IERROR)
C
C SELECT PROPER C2 AXES TO WRITE TO MOL FILE.  THIS ROUTINE IS
C NECESSARY BECAUSE VMOL CRASHES WHEN THE TWO OPERATIONS IN THE
C MOL FILE MAP ANY OF THE ATOMS TO THE SAME LOCATION.  THIS IS
C NOT A PROBLEM FOR C2H AND C2V, BUT CAN CAUSE SEVERE FRUSTRATION
C FOR D2.
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION Q(3,NATOM),ATMASS(NATOM)
      LOGICAL ATOMONX,ATOMONY,ATOMONZ,XATOM,YATOM,ZATOM
      CHARACTER*3 STRING1,STRING2
      PARAMETER (TOL=1.D-6)
      ATOMONX=.FALSE.
      ATOMONY=.FALSE.
      ATOMONZ=.FALSE.
      IERROR=0
      DO 10 IATOM=1,NATOM
       IF(ATMASS(IATOM).NE.0.0D0)THEN
        XATOM=DABS(Q(1,IATOM)).GT.TOL
        YATOM=DABS(Q(2,IATOM)).GT.TOL
        ZATOM=DABS(Q(3,IATOM)).GT.TOL
        IF(XATOM.AND..NOT.YATOM.AND..NOT.ZATOM)ATOMONX=.TRUE.
        IF(YATOM.AND..NOT.XATOM.AND..NOT.ZATOM)ATOMONY=.TRUE.
        IF(ZATOM.AND..NOT.YATOM.AND..NOT.XATOM)ATOMONZ=.TRUE.
       ENDIF
10    CONTINUE
      IF(.NOT.ATOMONX)THEN
       STRING1=' XY'
       STRING2=' XZ'
       ITYPE = 1
      ELSEIF(.NOT.ATOMONY)THEN
       STRING1=' XY'
       STRING2=' YZ'
       ITYPE = 2
      ELSEIF(.NOT.ATOMONZ)THEN
       STRING1=' XZ'
       STRING2=' YZ'
       ITYPE = 3
      ELSE
       WRITE(6,1000)
       IERROR=1   
       ITYPE = 0
       CALL ERREX
      ENDIF
C
C We need to know the type of D2 axis to make the correct map from vmol
C to zmat in vmol2ja. Otherwise all of the geometry optimizations and
C Freq. for D2 point group are going to suffer. 01/2006, Ajith Perera.
C
      CALL PUTREC(20, 'JOBARC', 'D2TYPXYZ', 1, ITYPE)
C
      RETURN
1000  FORMAT(T3,'@SETD2XYZ-I, The integral program is unable to use ',
     &          'D2 symmetry for this case.')
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_oed_integrals(type, z)
c---------------------------------------------------------------------------
c  Computes the set of OED integrals matching "type" and returns them in 
c  array Z.
c
c   type = 1 --> NAI integrals
c          2 --> KIN integrals
c          3 --> OVL integrals
c---------------------------------------------------------------------------
      implicit none
      include 'int_gen_parms.h'
      include 'machine_types.h'
#ifdef ALTIX
      include 'sheap.h'
#endif

      integer type
      double precision z(*)
      double precision dbuf(1)
      integer ibuf(1)
#ifdef ALTIX
      pointer (iptr, ibuf)
      pointer (dptr, dbuf)
#else
      common dbuf
      equivalence (ibuf, dbuf)
#endif
      integer i, m, n, nfirst, nints, nalpha, ncoeff, iatom, ncsum
       integer j
      integer a1,a2,b1,b2,lastao
      logical spherical
   
      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      double precision xn(max_centers), yn(max_centers), 
     *                 zn(max_centers)
      double precision x1,y1,z1,x2,y2,z2

      if (type .lt. 1 .or. type .gt. 3) then
         print *,'Error: Invalid type argument in compute_oed_integrals'
         print *,'type = ',type
         call abort_job()
      endif

#ifdef ALTIX
      iptr = ishptr
      dptr = dshptr
#endif

      spherical = (ispherical .eq. 1)
      lastao    = end_nfps(nshells)

      do i = 1, lastao*lastao
        z(i) = 0.
      enddo

c-------------------------------------------------------------------------
c   Build an array of coordinates per atom.
c-------------------------------------------------------------------------

      do m = 1, nshells
         iatom = atom(m)
         xn(iatom) = dbuf(icoord+3*(m-1))
         yn(iatom) = dbuf(icoord+3*(m-1)+1)
         zn(iatom) = dbuf(icoord+3*(m-1)+2)
      enddo

c---------------------------------------------------------------------------
c   Calculate each shell block.
c---------------------------------------------------------------------------

      do m = 1, nshells
      do n = 1, nshells
         ncsum = ncfps(m) + ncfps(n) 
         x1 = dbuf(icoord+3*(m-1))
         y1 = dbuf(icoord+3*(m-1)+1)
         z1 = dbuf(icoord+3*(m-1)+2)
 
         x2 = dbuf(icoord+3*(n-1))
         y2 = dbuf(icoord+3*(n-1)+1)
         z2 = dbuf(icoord+3*(n-1)+2)

         call pack_coeffs_oed(dbuf(ialpha), ixalpha, dbuf(ipcoeff), 
     *                       ixpcoef, ncfps, npfps, m, n,
     *                       alpha_pack, nalpha, pcoeff_pack,
     *                       ncoeff, ibuf(iccbeg), ibuf(iccend), 
     *                       indx_cc,
     *                       ccbeg_pack, ccend_pack,
     *                       max_dim_coeff)

            if (type .eq. 1) then
               call oed__gener_nai_batch(intmax, zmax, nalpha, ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 ncenters, xn,yn,zn, charge, alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst, 
     *                 dbuf(dpkgscr))     
            else if (type .eq. 2) then
               call oed__gener_kin_batch(intmax, zmax, nalpha, ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,
     *                 spherical, .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
            else if (type .eq. 3) then
               call oed__gener_ovl_batch(intmax, zmax, nalpha, ncoeff,
     *                 ncsum, ncfps(m), ncfps(n), npfps(m),npfps(n),
     *                 ivangmom(m), ivangmom(n), x1,y1,z1,x2,y2,z2,
     *                 alpha_pack,
     *                 pcoeff_pack, ccbeg_pack, ccend_pack,spherical,
     *                 .true., ibuf(ipkgscr), nints, nfirst,
     *                 dbuf(dpkgscr))
            endif

         if (nints .gt. 0) then
            a2 = end_nfps(m)
            if (m .eq. 1) then
               a1 = 1
            else
               a1 = end_nfps(m-1)+1
            endif

            b2 = end_nfps(n)
            if (n .eq. 1) then
               b1 = 1
            else
               b1 = end_nfps(n-1)+1
            endif

            call move_integrals2(z, 1,lastao,1,lastao,
     *             dbuf(dpkgscr+nfirst-1),a1,a2,b1,b2)
         endif
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine set_index(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table,
     *                      scalar_table, nscalar_table, 
     *                      address_table, op)
c---------------------------------------------------------------------------
c   Sets the indices of a 4-d static array in common block values.
c   The four indeces will be used as flags indicating which index to 
c   truncate. These indices are stored in the SINDEX common block. 
c
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'
      include 'dbugcom.h'

      common /SINDEX/index1, index2, index3, index4 
      integer index1, index2, index3, index4  
      double precision flags_value

      integer narray_table, nindex_table, nsegment_table,
     *        nblock_map_table
      integer op(loptable_entry)
      integer array_table(larray_table_entry, narray_table)
      integer index_table(lindex_table_entry, nindex_table)
      integer segment_table(lsegment_table_entry, nsegment_table)
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer nscalar_table
      double precision scalar_table(nscalar_table)
      integer*8 address_table(narray_table)

      integer ierr, array, array_type, ind, nind
      integer i

      array = op(c_result_array)
      if (array .lt. 1 .or. array .gt. narray_table) then
         print *,'Error: Invalid array in set_flags, line ',
     *     current_line
         print *,'Array index is ',array,' Allowable values are ',
     *      ' 1 through ',narray_table
         call abort_job()
      endif

      nind = array_table(c_nindex, array)
      if (nind .ne. 4) then
         print *,'Error: set_index requires a 4-index array.'
         call abort_job()
      endif

c-----------------------------------------------------------------------
c   Index1-4 are determined from the c_current_seg
c   field of the 1st, 2nd, 3rd and 4th index of the array.
c------------------------------------------------------------------------

      ind    = array_table(c_index_array1,array)
      index1 = index_table(c_current_seg, ind)

      ind    = array_table(c_index_array1+1,array)
      index2 = index_table(c_current_seg, ind)

      ind    = array_table(c_index_array1+2,array)
      index3 = index_table(c_current_seg, ind)

      ind    = array_table(c_index_array1+3,array)
      index4 = index_table(c_current_seg, ind)

      if (dbg) 
     *  write(6,*) 'Task ',me,' RINDEX :', index1, index2, 
     *              index3, index4 

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE XTOR(RCURVY,IPRT)
C
c TAKES CARTESIAN COORDINATES AND CONVERTS TO CURVILINEAR INTERNAL
C  COORDINATES; USED ONLY IN THE TRANSFORMATION BETWEEN RECTILINEAR
C  AND CURVILINEAR HESSIAN ELEMENTS, WHICH FOR NOW IS DONE SLOPPILY
C  (NUMERICALLY).
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
      CHARACTER*5 ZSYM, VARNAM, PARNAM
      COMMON /CBCHAR/ ZSYM(MXATMS), VARNAM(3*MXATMS),
     1     PARNAM(3*MXATMS)
#include "coord.com"

C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON /OPTCTL/ IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     $   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     $   XYZTol
 
 
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
#include "io_units.par"
      DIMENSION RCURVY(NX),AVECBA(3),AVECBC(3)
      DIMENSION VECAB(3),VECBC(3),VECCD(3)
      DIMENSION ABXBC(3),BCXCD(3)
      IND(I,J)=I*3-2+J
      DTOR=ACOS(-1.D0)/180.D0
C
C
C CALCULATE BOND LENGTHS
C
      DO I = 4, NATOMS*3-2, 3
         RCURVY(I) = DIST(Q(I),Q(IND(NCON(I),0)))
      END DO
C
C CALCULATE BOND ANGLES (RADIANS)
C
      DO I = 8, NATOMS*3-1, 3
         IA = I-1
         IB = IND(NCON(I-1),0)
         IC = IND(NCON(I),0)
         CALL VEC(Q(IB),Q(IA),AVECBA,1)
         CALL VEC(Q(IB),Q(IC),AVECBC,1)
         dtmp = ddot(3,AVECBA,1,AVECBC,1)
         RCURVY(I) = DACOS(dtmp)
      END DO
C
C CALCULATE DIHEDRAL ANGLES (RADIANS)
C
      DO 30 I=12,NATOMS*3,3
      IA = I - 2
      IB=IND(NCON(I-2),0)
      IC=IND(NCON(I-1),0)
      ID=IND(NCON(I),0)
      CALL VEC(Q(IC),Q(ID),VECCD,1)
      CALL VEC(Q(IA),Q(IB),VECAB,1)
      CALL VEC(Q(IB),Q(IC),VECBC,1)
      S2=DSIN(DTOR*(180.D0-ANGLE(VECBC,VECAB,3)))
      S3=DSIN(DTOR*(180.D0-ANGLE(VECCD,VECBC,3)))
      CALL CROSS(VECAB,VECBC,ABXBC,0)
      CALL CROSS(VECBC,VECCD,BCXCD,0)
C
C DETERMINE "SIGN" AND MAGNITUDE OF DIHEDRAL ANGLE NOW.
C
      AZZO = ddot(3,ABXBC,1,BCXCD,1)
      AZZO = AZZO / (S2*S3)
      IF(DABS(DABS(AZZO)-1.D0).LT.1.D-10)AZZO=SIGN(1.D0,AZZO)
C
C PUT IN FILTER TO GET RID OF DACOS(1.000000000000002) PROBLEMS
C   1/31/89:JFS
C
      IF((DABS(AZZO)-1.D0).GT.1.D-4)WRITE(6,711)AZZO
 711  FORMAT(T3,'***SOMETHING IS VERY WRONG.  VALUE OF ',F8.5,
     &' SENT TO DACOS FUNCTION IN XTOR.')
      IF(DABS(AZZO).GT.1.D0)AZZO=SIGN(1.D0,AZZO)
      A1=DACOS(AZZO)
      P = ddot(3,VECAB,1,BCXCD,1)
      P = P / (S2*S3)
      RCURVY(I)=SIGN(A1,P)
 30   CONTINUE
 
      IF(IPRT.EQ.1)THEN
       DO 90 IC2=1,NXM6
        IC=ISQUASH(IC2)
        IF(MOD(IC,3).EQ.1)THEN
         FACT=1.0D0
        ELSE
         FACT=180.0D0/DACOS(-1.0D0)
        ENDIF
        RCURVY(IC)=RCURVY(IC)*FACT
        WRITE(LUOUT,722)VARNAM(IC)(1:linblnk(VARNAM(IC))),
     &                  RCURVY(IC)
90     CONTINUE
      ENDIF
C
C SQUASH R VECTOR.
C
      CALL SQUSH(RCURVY,NX)
721   FORMAT(T3,' Internal coordinates generated by XTOR: ')
722   FORMAT(A,'=',F20.12)
      RETURN
      END

      SUBROUTINE SYMTR1(IRREP,NUM1,NUM2,DISSIZE,A,SCR1,SCR2,ISCR)
C
C  THIS ROUTINE TRANSPOSES THE LAST TWO INDICES OF A FOUR INDEX ARRAY
C  WITHIN ONE GIVEN IRREP :
C
C   A(I,J,K,L) --> A(I,J,L,K)    WITH G(K)*G(L) = IRREP
C
C  THE TRANPOSITION IS DONE IN PLACE AND REQUIRES ONLY TWO SCRATCH
C  VECTORS OF LENGTH DISSIZE (ONE DOUBLES AND ONE INTEGERS)
C
C  INPUT :  IRREP     ...  IRREP OF G(K)*G(L)
C           NUM1      ...  POPULATION VECTOR FOR K
C           NUM2      ...  POPULATION VECTOR FOR L
C           DISSIZE   ...  DISTRIBUTION SIZE
C           A         ...  HOLDS THE MATRIX A         
C           SCR1,ISCR ...  TWO SCRATCH ARRAYS OF SIZE DISSIZE
C           SCR2      ...  (IGNORED)
C
C  OUTPUT :  A     ....  TRANSPOSED MATRIX
C
CEND
C
C  WRITTEN IN JUNE/90   JG
C  SENT THE DATA AND INDEX ARRAY TO RESORT_COLS_TO_INDEX 4/2005 ADY
C
      IMPLICIT NONE
      INTEGER IRREP,NUM1(*),NUM2(*),DISSIZE,ISCR(*)
      DOUBLE PRECISION A(DISSIZE,*),SCR1(*),SCR2(*)
c syminf.com : begin
      integer nstart, nirrep, irrepa(255), irrepb(255), dirprd(8,8)
      common /syminf/ nstart, nirrep, irrepa, irrepb, dirprd
c syminf.com : end
      INTEGER iOffLK(8),iOffKL(8)
      INTEGER IRREPI,I
      INTEGER IRREPJ,J
      INTEGER IRREPK,K,NUMK
      INTEGER IRREPL,L,NUML
      INTEGER NTOTAL,IND1,IND2,IERR
      LOGICAL ICONT
      INTEGER    c_adr
      external c_adr

      if (.false.) then
         print *, '@SYMTR1: Argument analysis'
         print *, '         KL irrep ',irrep
         print *, '         K pop = ',(NUM1(K),K=1,nirrep)
         print *, '         L pop = ',(NUM2(L),L=1,nirrep)
         print *, '         lda   = ',DISSIZE
         print *, '         &A    = ',c_adr(a)
         print *, '         &SCR1 = ',c_adr(SCR1)
         print *, '         &SCR2 = ',c_adr(SCR2)
         print *, '         &ISCR = ',c_adr(ISCR)
      end if
C
      NTOTAL=0
      iOffLK(1)=0
      iOffKL(1)=0          
      DO IRREPJ=1,NIRREP-1
         IRREPI=DIRPRD(IRREPJ,IRREP)
         iOffLK(IRREPJ+1)=iOffLK(IRREPJ)+NUM2(IRREPI)*NUM1(IRREPJ)
         iOffKL(IRREPJ+1)=iOffKL(IRREPJ)+NUM1(IRREPI)*NUM2(IRREPJ)
         NTOTAL=NTOTAL+NUM1(IRREPI)*NUM2(IRREPJ)
      END DO
      IRREPJ=NIRREP
      IRREPI=DIRPRD(IRREPJ,IRREP)
      NTOTAL=NTOTAL+NUM1(IRREPI)*NUM2(IRREPJ)
      do i = 1, ntotal
         iscr(i) = i
      end do
C
C  GET FIRST THE NEW ADDRESSES AND STORE THEM IN ISCR
C
      DO 20 IRREPL=1,NIRREP
         IRREPK=DIRPRD(IRREPL,IRREP)
         NUML=NUM2(IRREPL)
         NUMK=NUM1(IRREPK)
         DO 15 L=0,NUML-1
         DO 15 K=0,NUMK-1
            IND1=1+iOffKL(IRREPL)+L*NUMK+K
            IND2=1+iOffLK(IRREPK)+K*NUML+L
            if (ind1.gt.ntotal.or.ind2.gt.ntotal) then
               print *, 'writing out of bounds: iscr(',ind1,')=',ind2
            end if
            ISCR(IND2)=IND1
15       CONTINUE
20    CONTINUE

c      print *, 'symtr1 in:  iScr = ',(iScr(i),i=1,nTotal)
      call sort_cols_from_index(dissize,ntotal,a,dissize,scr1,iscr,iErr)
c      print *, 'symtr1 out: iScr = ',(iScr(i),i=1,nTotal)
      if (iErr.ne.0) then
         print *, '@SYMTR1: sort failed'
         print *, '         iErr = ',iErr
         call errex
      end if

      return
c     end subroutine symtr1
      end

C RETURNS THE SPARSITY LEVEL OF THE FIRST LEN ELEMENTS OF VEC, EXPRESSED
C AS A DECIMAL FRACTION. TOLERANCE IS SET BY TOL.

      SUBROUTINE SPSTST(VEC,LEN,TOL,SPARSE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VEC(LEN)

      if (len.lt.0) then
         print *, '@SPSTST: Assertion failed.'
         print *, '         len = ',len
         call errex
      end if

      IZRO = 0
      DO I = 1, LEN
         IF (DABS(VEC(I)).LT.TOL) IZRO = IZRO + 1
      END DO
      SPARSE = FLOAT(IZRO) / FLOAT(LEN)
      RETURN
      END

      subroutine A3_ecp_basis_init_4grd(Natoms, Namat, Iqmstr,
     &                                  Jcostr, Nucstr, Nrcstr, Jstrt, 
     &                                  Jrs, Expa, Nalpha, Cont, Npcoef,
     &                                  Nharm)
c
c-----------------------------------------------------------------------      
c     subroutine ECP_basis_init fills the common-blocks for subroutine 
c     version for general contracted basissets
C
c     input:
c     namstr: names of the atoms (strange storage as integer!)
c     iqmstr: max. l-quantum-number+1 of a shell
c     jcostr: number of shells
c     nucstr: number of the uncontracted functions of the shells > NUCO
c             (exponents)
c     nrcstr: number of blocks(general contracted) > NRCO
c             (contractions)
c-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
C
      integer eor,and,or,dstrt
C-----------------------------------------------------------------------
#include "ecp.par"
#include "ecp.com"
C-----------------------------------------------------------------------
      character*4 namat(Max_centers)
      logical nharm

      Dimension iqmstr(Max_centers),jcostr(Max_centers,maxjco),
     &          nucstr(Max_centers,Maxang,Maxjco),
     &          nrcstr(Max_centers,Maxang,Maxjco),
     &          Jstrt(Max_shells),Jrs(Max_shells),Expa(Nalpha),
     &          Cont(Npcoef)
C
      Dimension
     &          ipeoff(Max_centers,Maxang,Maxjco),
     &          iccoff(Max_centers,Maxang,Maxjco),
     &          newoff(Max_centers,Maxang,Maxjco),
     &          numpri(Max_centers,Maxang,Maxjco),
     &          imin(Maxang),imax(Maxang),nfcts(Maxang),
     &          ifeld(Max_centers)
C
c-----------------------------------------------------------------------
c     gout                : intbatch
c     ipeoff              : offset for primitive exponents
c     iccoff              : offset for contraction coefficients
c     newoff              : offsets for primitives
c     numpri              : number of primitive functions of a shell
c     imin,imax           : lower(upper) offset of a cartesian component
c     nfcts               : number of types of a cartesian component 
c     ifeld               : checkarray 
c-----------------------------------------------------------------------
CSSS      common /infoa / natoms
CSSS      common /symshe/ mulsh(Mxtnsh)
CSSS      common /modez / zetm(Mxtnsh)
CSSS      common /pairij/ ipq(ndi4+1)
CSSS      common /typinf/ ltmax,ltdrv,nftnft,nftdrv
CSSS      common /powers/ jx(nftmax),jy(nftmax),jz(nftmax),
CSSS     1                ix(nftmax),iy(nftmax),iz(nftmax)
C------------------------------------------------------------------------
c Create offsets of primitive exponents and contraction coefficients
C The NMax refers 
C
      icount=0
      call izero(ifeld,Mxatms)
CSSS      call izero(ipeoff,Mxatms*Maxang*Mxshel)  
CSSS      call izero(iccoff,Mxatms*Maxang*Mxshel)  

      do  iat=1,Natoms
        do  ilq=1,iqmstr(iat)
          do  ijco=1,jcostr(iat,ilq)

              icount=icount+1
C
              if (ifeld(iat).ne.1) then

                 ipeoff(iat,ilq,ijco)=jstrt(icount)
                 iccoff(iat,ilq,ijco)=nstrt(icount)
#ifdef _DEBUG_LVL0
      write(*,1) iat,ilq,ijco,ipeoff(iat,ilq,ijco)
   1  format('iat: ',i3,'ilq: ',i3,' ijco: ',i3,' ipeoff: ',i3)
      write(*,2) iat,ilq,ijco,iccoff(iat,ilq,ijco)
   2  format('iat: ',i3,'ilq: ',i3,' ijco: ',i3,' iccoff: ',i3)
#endif
              endif
          enddo
        enddo 
C
        ifeld(iat)=1 
C
      enddo

C create shell-structure and arrays expnt and contr

CSSS      call zero(expnt,Mxtnpr)
CSSS      call zero(contr,Mxtnpr*Mxtnpr)
CSSS      call izero(numpri,Mxatms*Maxang*Maxprim)

      icount=0
      kcount=0
      ncount=0

      do iat=1,Natoms
        do ilq=1,iqmstr(iat)
          do  ijco=1,jcostr(iat,ilq)
C
            ncount=ncount+1

            do inuco=1,nucstr(iat,ilq,ijco)

              icount=icount+1

              do inrco=1,nrcstr(iat,ilq,ijco)
C
                 contr(icount,inrco)=CONT(ipeoff(iat,ilq,ijco)+inuco+
     &                               nucstr(iat,ilq,ijco)*(inrco-1))

#ifdef _DEBUG_LVL0
      write(*,3) icount,inrco,contr(icount,inrco)
   3  format('icount: ',i3,' inrco: ',i3,' contr: ',f12.8)
#endif
              enddo

              expnt(icount)=EXPA(ipeoff(iat,ilq,ijco)+inuco)

#ifdef _DEBUG_LVL0
      write(*,4) icount,expnt(icount)
   4  format('icount: ',i3,' expnt: ',f12.8)
#endif
              kcount=kcount+1

            enddo

c           numpri(iat,ilq,ijco)=numpri(iat,ilq,ijco)+kcount
            numpri(iat,ilq,ijco)=kcount

#ifdef _DEBUG_LVL0
      write(*,5) iat,ilq,ijco,numpri(iat,ilq,ijco)
   5  format('iat: ',i3,' ilq: ',i3,' ijco: ',i3,' numpri: ',i3)
#endif
            kcount=0
            numcon(ncount)=nrcstr(iat,ilq,ijco)

#ifdef _DEBUG_LVL0
      write(*,6) ncount,numcon(ncount)
   6  format('ncount: ',i3,' numcon: ',i3)
#endif
          enddo

c         numpri(iat,ilq)=numpri(iat,ilq)+kcount
c         write(*,5) iat,ilq,numpri(iat,ilq)
c5        format('iat: ',i3,' ilq: ',i3,' numpri: ',i3)
c         lcount=lcount+1
c         kcount=0

        enddo

c       lcount=0

      enddo
C
c create new offsets of primitive exponents
C
CSSS      call izero(newoff,Mxatms*Maxang,Maxprim)

      khelp=1

      do iat=1,NMAX
        do  ilq=1,iqmstr(iat)
          do ijco=1,jcostr(iat,ilq)

            newoff(iat,ilq,ijco)=khelp

#ifdef _DEBUG_LVL0
      write(*,99) iat,ilq,ijco,newoff(iat,ilq,ijco)
  99  format('iat: ',i3,' ilq: ',i3,' ijco: ',i3,' newoff: ',i3)
#endif
            khelp=khelp+numpri(iat,ilq,ijco)

          enddo
        enddo
      enddo

c-----------------------------------------------------------------------
c     fill in common infoa
c-----------------------------------------------------------------------

CSSS      call zero(xyz,3*Mxatms)

      natoms=NMAX

CSSS      do  i=1,natoms
CSSS        do  j=1,3
CSSS          xyz(j,i)=CORD(i,j)
CSSS        enddo
CSSS      enddo

CSSS      do  i=1,natoms
CSSS        charg(i)=CHARGE(i)
CSSS      enddo
c-----------------------------------------------------------------------
c     fill in common /typinf/
c-----------------------------------------------------------------------

      ltmax=1
      do 10 iat=1,NMAX
        if (ltmax.le.iqmstr(iat)) then 
            ltmax=iqmstr(iat)
        endif  
   10 continue      

      nftdrv=ltmax*(ltmax+1)*(ltmax+2)/6

c-----------------------------------------------------------------------
c     fill in common /nshell/
c-----------------------------------------------------------------------

c Doing the k's from common nshel
      
      do l=1,Maxang
         imin(l)=(l-1)*l*(l+1)/6+1
         imax(l)=l*(l+1)*(l+2)/6 
         nfcts(l)=l*(l+1)/2
      enddo
      nbf=0
      nshll=0
      indsh=0
C
c loop over atoms

      do iat=1,NMAX

c loop over l-quantum-numbers

        do ilq=1,iqmstr(iat)

c loop over contracted basisfunctions

          do ijco=1,jcostr(iat,ilq)

             indsh=indsh+1
             mulilq=ISTBAO(indsh)
             nshll=nshll+1
             katom(nshll)=iat
             ktype(nshll)=ilq
             kmini(nshll)=imin(ilq)
             kmaxi(nshll)=imax(ilq)
             ndegen(nshll)=nfcts(ilq)             
             kbfn(nshll)=nbf+1
             nprims(nshll)=numpri(iat,ilq,ijco)
             kprim(nshll)=newoff(iat,ilq,ijco)
             nbf=nbf+ndegen(nshll)*fmult(mulilq)

          Enddo
        Enddo
      Enddo

      nshell=nshll

#ifdef _DEBUG_LVL0
      write(*,*)
      do  i=1,nshell
         write(*,*) 'nshell=',i
         write(*,3913) i,katom(i),i,ktype(i)
3913     format('katom<',i2,'>  ',i2,' ktype<',i2,'>  ',i2)
         write(*,3914) i,kprim(i),i,kbfn(i)
3914     format('kprim<',i2,'>  ',i2,' kbfn<',i2,'>   ',i2)
         write(*,3915) i,nprims(i),i,ndegen(i)
3915     format('nprims<',i2,'> ',i2,' ndegen<',i2,'> ',i2)
         write(*,3916) i,kmini(i),i,kmaxi(i)
3916     format('kmini<',i2,'>  ',i2,' kmaxi<',i2,'>  ',i2)
         write(*,3917) i, mulsh(i)
3917     format('mulsh<',i2,'>  ',i2)
         write(*,*)
      enddo
      write(*,*) 'nbf=',nbf
      write(*,*)
#endif

c-----------------------------------------------------------------------
c     fill in common modez
c-----------------------------------------------------------------------

CSSS      do ii=1,nshell
CSSS        zetm(ii)=expnt(kprim(ii))
CSSS        do ipr=kprim(ii)+1,kprim(ii)+nprims(ii)-1
CSSS          zetm(ii)=min(expnt(ipr),zetm(ii))
CSSS        enddo
CSSS      enddo
c-----------------------------------------------------------------------
c     fill in common pairij
c-----------------------------------------------------------------------

CSSS      call setipq(ipq,ndi4)

c-----------------------------------------------------------------------
c     fill in common pairij
c-----------------------------------------------------------------------

CSSS      call monom(ltmax,nft,jx,jy,jz,iadr,nftmax,1,0)

c-----------------------------------------------------------------------
c     fill common /palcal/
c-----------------------------------------------------------------------
CSS      nshdim=nshell
c      TLA=1.0d-12
c      toll=-log10(TLA)+8.0
CSSS       toll=25.0    
C
      return
      end 

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine handle_return(optable, noptable, debug,
     *                start_op, end_op, iop)
c----------------------------------------------------------------------------
c   handle_return: Replaces start_op, end_op and iop with values pulled 
c                  from the stack.  This is equivalent to a procedure
c                  return.
c
c   Arguments:
c      optable		Operation table
c      noptable		Number of instructions in optable
c      debug		Debug flag
c      start_op         Input/output argument
c      end_op		Input/output argument
c      iop		Input/output argument
c 
c-----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer noptable, start_op, end_op, iop
      integer optable(loptable_entry, noptable)
  
      integer ierr, istat, timer
      integer pop_do 
      logical debug 
      
      if (optable(c_opcode, iop) .ne. return_op) return

      if (trace .and. and(tracelevel, proc_trace) .ne. 0) then
         print *,'Task ',me,' Return from proc at line ',
     *            optable(c_lineno,iop)
      endif

c---------------------------------------------------------------------------
c   We have a return_op.  Find the return address.
c---------------------------------------------------------------------------

      istat = pop_do(iop, timer)
      if (istat .lt. 0) then
         print *,'Task ',me,
     *      ' Error in handle_return: stack underflow'
         call abort_job()
      endif

      istat = pop_do(start_op, end_op)
      if (istat .lt. 0) then
         print *,'Task ',me,
     *      ' Error in handle_return: stack underflow'
         call abort_job()
      endif

c---------------------------------------------------------------------------
c   Stop the procedure timer.
c---------------------------------------------------------------------------

      if (timer .lt. 1) then
         print *,'Task ',me,' Timer for iop ',iop,' is ',timer
         call abort_job()
      endif  
      call update_timer(timer)

      return
      end

      SUBROUTINE SETUP(HES, GRD, HESMOD, GRDMOD, IQFIX, STPMAX, LUOUT)
C
C Build the Hessian and Gradient vectors symmetry coordintes (
C only those internal that are optimized is taking in to account)
C Also do all other initializations.
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
#include "mxatms.par"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
      COMMON /OPTCTL/ IPRNT, INR, IVEC, IDIE, ICURVY, IMXSTP, ISTCRT, 
     &                IVIB, ICONTL, IRECAL, INTTYP, IDISFD, IGRDFD, 
     &                ICNTYP, ISYM, IBASIS, XYZTol

C
      DIMENSION HES(NXM6, NXM6), GRD(NXM6), HESMOD(NOPT, NOPT),
     &          GRDMOD(NOPT), IQFIX(3*MXATMS, 3*MXATMS)
C
C Let's update the number of cycles right away!
C
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The number of opt. cycles:", NCYCLE 
#endif
C
      NCYCLE = NCYCLE + 1 
C
      DO 311 I=1, NUNIQUE
         DO 312 J=1, NEQ(IUNIQUE(I))
            IQFIX(IUNIQUE(I), J)=IEQUIV(I,J)
 312     CONTINUE
 311  CONTINUE
C  
      DO 19 I=1, NOPT
         DO 20 J=1, NOPT
C
            HESMOD(I,J)=HES(NOPTI(I), NOPTI(J))
C
            DO 29 K=1, NEQ(NOPTI(I))
               HESMOD(I,J)=HESMOD(I,J)+HES(IQFIX(NOPTI(I),K),NOPTI(J))
 29         CONTINUE
C
            DO 39 L=1, NEQ(NOPTI(J))
               HESMOD(I,J)=HESMOD(I,J)+HES(NOPTI(I),IQFIX(NOPTI(J),L))
 39         CONTINUE
C
            DO 49 K=1, NEQ(NOPTI(I))
               DO 50 L=1, NEQ(NOPTI(J))
                  HESMOD(I, J)=HESMOD(I, J) + HES(IQFIX(NOPTI(I), K),
     &                        IQFIX(NOPTI(J), L))
 50            CONTINUE
 49         CONTINUE
C
            ZD=DSQRT(DFLOAT((NEQ(NOPTI(I))+1)*(NEQ(NOPTI(J))+1)))
            HESMOD(I,J)=HESMOD(I,J)/ZD
C
 20      CONTINUE
 19   CONTINUE
C
#ifdef _DEBUG_LVLM1
          Write(6,*)
          WRITE(LUOUT,115)
 115      FORMAT(T3,' Hessian matrix in totally symmetric symmetry ',
     &      'coordinates: ')
          IF(ICURVY.EQ.1) WRITE(LuOut,117)
 117      FORMAT(T3,'            (Curvilinear representation) ')
          CALL OUTPUT(HESMOD, 1, NOPT, 1, NOPT, NOPT, NOPT, 1)
#endif
C     
C Form modified Gradient vector and symmetrize it. 
C
      DO 1177 I=1, NOPT
         GRDMOD(I)=DSQRT(DFLOAT(NEQ(NOPTI(I))+1))*GRD(NOPTI(I))
 1177 CONTINUE
C
#ifdef _DEBUG_LVL0
      Write(6,*) 
      Write(6,*)  "The gradients in sym. adapted coordinates"
      Write(6, "(6F10.5)") (GRDMOD(I), I=1, NOPT)
      Write(6,*)
#endif
C
C The maximum step size can be controlled by the user by setting
C the flag MAX_STEP. The default value for maximum is set 300.
C IMXSTP is first set in mkvmol.F (strange!). We need to move
C these things into a one place that is visible to the developers.
      IF (IMXSTP .EQ. 0) IMXSTP = 300
      STPMAX = DBLE(IMXSTP)/1000.D0
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine allocate_instruction(array_table, narray_table,
     *                      index_table,
     *                      nindex_table, segment_table, nsegment_table,
     *                      block_map_table, nblock_map_table, op)
c---------------------------------------------------------------------------
c   Runtime implementation code for the ALLOCATE instruction.
c---------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'parallel_info.h'
      include 'blkmgr.h'
      include 'trace.h'
      include 'checkpoint_data.h'

      integer narray_table, nindex_table, nsegment_table
      integer array_table(larray_table_entry,narray_table)
      integer index_table(lindex_table_entry,nindex_table)
      integer segment_table(lsegment_table_entry,nsegment_table)
      integer nblock_map_table
      integer block_map_table(lblock_map_entry, nblock_map_table)
      integer op(loptable_entry)

      integer array, type, size, nind
      integer i, iblock, nblock, nwild
      integer blkndx
      integer ierr, block, dummy
      integer allocate_block
      integer ind(mx_array_index)
      integer ind_save(mx_array_index)
      integer seg(mx_array_index)
      integer nseg(mx_array_index)
      integer bseg(mx_array_index)
      integer eseg(mx_array_index)
      integer iwild(mx_array_index)
      integer iseg(mx_array_index)
      integer stack

      array = op(c_result_array)
      type  = array_table(c_array_type,array)
      nind = array_table(c_nindex, array)
      if (type .ne. local_array) then
         print *,'Error: Allocate instruction requires a local_array'
         print *,'Array, type = ',array,type
         call abort_job()
      endif

c      print *,'Task ',me,' ALLOC at line ',current_line,' op ',
c     *   (op(c_ind1+i-1),i=1,mx_array_index)

c----------------------------------------------------------------------------
c   Switch the array's indices to the indices used in its SIAL reference,
c   which are the indices passed in on the current instruction.
c   Wildcard indices use the indices used in the original array declaration.
c----------------------------------------------------------------------------

      do i = 1, nind
         ind_save(i) = array_table(c_index_array1+i-1,array) 
         if (op(c_ind1+i-1) .eq. wildcard_indicator) then ! wild card index
            array_table(c_index_array1+i-1,array) =
     *             array_table(c_index_original+i-1,array)
         else
            array_table(c_index_array1+i-1,array) = op(c_ind1+i-1)
         endif
      enddo

c----------------------------------------------------------------------------
c   Determine the indices to use.
c----------------------------------------------------------------------------

      nblock = 1
      nwild  = 0
      do i = 1, nind
         ind(i) = array_table(c_index_array1+i-1,array)
         if (ind(i) .lt. 1 .or. ind(i) .gt. nindex_table) then
            print *,'Task ',me,' Error in ALLOCATE at line ',
     *           current_line
            print *,'Invalid index: ',ind(i)
            call abort_job()
         endif

         seg(i) = index_table(c_current_seg,ind(i))
         nseg(i) = index_table(c_nsegments, ind(i))
         bseg(i) = index_table(c_bseg, ind(i))
         eseg(i) = index_table(c_eseg, ind(i))

         if (op(c_ind1+i-1) .eq. wildcard_indicator) then
            nblock = nblock*nseg(i)
            nwild = nwild + 1
            iwild(nwild) = i
            iseg(iwild(nwild)) = bseg(iwild(nwild)) 
         endif
      enddo

c      print *,'Task ',me,' iwild ',(iwild(i),i=1,nwild)
c      print *,'Task ',me,' iseg ',(iseg(i),i=1,mx_array_index)

c VFL skip to allow nwild = 0 
c     if (nwild .eq. 0) then
c        print *,'Error: No wildcard index in allocate at line ',
c    *          current_line
c        call abort_job()
c     endif
c ENDVFL skip to allow nwild = 0 

      do iblock = 1, nblock
         
c---------------------------------------------------------------------------
c   Set the "current segment" field in the index table, for each wildcard
c   index.
c--------------------------------------------------------------------------

         if (nwild .gt. 0) then 
         do i = 1, nwild
            index_table(c_current_seg,ind(iwild(i))) = iseg(iwild(i))
         enddo
         endif 

c-------------------------------------------------------------------------
c   Determine the blocksize to be allocated based on the index and segment 
c   data.
c-------------------------------------------------------------------------

c         print 10101,me,iblock,(ind(i),
c     *          index_table(c_current_seg,ind(i)),i=1,nind)
c10101 format(' Task ',i2,' iblock ',i3,' ind, curseg: ',
c     *      4(i3,1x,i6,1x))
         call determine_current_block_size(ind, nind,
     *        index_table, nindex_table,
     *        segment_table, nsegment_table, size)

c----------------------------------------------------------------------------
c   Release any blocks that are eligible to be freed up.
c----------------------------------------------------------------------------

c         call release_blocks(array_table, narray_table,
c     *                       index_table, nindex_table,
c     *                       block_map_table, nblock_map_table)

c----------------------------------------------------------------------------
c   Attempt to set up the new block.
c----------------------------------------------------------------------------

         ierr = allocate_block(array, iblock, size, array_table, 
     *                         narray_table, index_table, 
     *                         nindex_table, block_map_table)
         if (ierr .le. 0) then
            print *,'Error: During allocate operation.'
            print *,'Cannot allocate a block for ',
     *            'array',array,' block number ',iblock,
     *            ' on processor ',me
            call array_block_summary(array_table,
     *                               narray_table)
            call dump_block_ids()
            call abort_job()
         else
            blkndx = ierr
	    endif

         call blkmgr_insert_block_in_list(
     *                 array_table(c_block_list,array),
     *                 dummy, blkndx, c_block_list_ptr, .false.)
         call set_block_indices(array, iblock, blkndx,
     *                          array_table(1,array))
         call set_block_segments(array, iblock, blkndx, index_table,
     *                      nindex_table)

c-------------------------------------------------------------------------
c   Set the block_computed_flag so the data will be preserved until
c   a delete occurs.
c-------------------------------------------------------------------------

         call set_block_computed_flag(array, iblock, blkndx, 1)
         call set_block_created_flag(array, iblock, blkndx, 1)

c---------------------------------------------------------------------------
c   Clear the block.  Only the actual extent of the block's data is zeroed.
c---------------------------------------------------------------------------

         stack = array_table(c_array_stack,array)
         call clear_block(array, iblock, stack, blkndx, size)

c--------------------------------------------------------------------------
c   Increment the "wildcard" segments.
c--------------------------------------------------------------------------

         if (nwild .gt. 0) then 
         iseg(iwild(1)) = iseg(iwild(1)) + 1
         do i = 2, nwild
            if (iseg(iwild(i-1)) .le. eseg(iwild(i-1))) go to 100
            iseg(iwild(i-1)) = bseg(iwild(i-1))
            iseg(iwild(i))   = iseg(iwild(i)) + 1
         enddo
  100    continue
         endif 

      enddo

c-----------------------------------------------------------------------------
c   Restore the "current segment" fields of the index_table.
c   Restore the array's indices to those at the beginning of the instruction.
c-----------------------------------------------------------------------------

      do i = 1, nind
         index_table(c_current_seg,ind(i)) = seg(i)
c         if (ind_save(i) .gt. 0)
c     *       array_table(c_index_array1+i-1,array) = ind_save(i)
      enddo

c-------------------------------------------------------------------------
c   Remember this allocate for the checkpoint data.
c-------------------------------------------------------------------------

      if (.not. restart_job) then
         do i = 1, nactive_allocate_table
            if (active_allocate_table(i) .eq. array .and. 
     *          active_allocate_op(i) .eq. current_op) go to 200
         enddo      

         nactive_allocate_table   = nactive_allocate_table + 1
         active_allocate_table(nactive_allocate_table) = array
         active_allocate_op(nactive_allocate_table)    = current_op 
      endif
  200 continue

      return
      end

      

C THIS PROJECTS THE ROTATIONAL MODES FROM THE SYMMETRY
C ADAPTED COORDINATES

c INPUT
c integer NATOM

c OUTPUT
c double TPROJ(*)
c double SCR(*)
c double SYMQ(*)
c double ATMASS(*)

c RECORDS
c get 'LINEAR  '
c get 'ATOMMASS'
c get ROTREC(IXYZ)
c put ROTREC(IXYZ)
c get 'COMPNSYQ'
c get 'COMPSYMQ'
c put 'COMPSYMQ'

      SUBROUTINE ROTPRJ(NATOM,TPROJ,SCR,SYMQ,ATMASS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION SCR(*),SYMQ(*),TPROJ(*),ATMASS(*)

      CHARACTER*8 ROTREC(3)

      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD

      DATA ONE /1.0/
      DATA TOL /1.D-8/
      DATA ROTREC /'ROTVECX ','ROTVECY ','ROTVECZ '/

      CALL GETREC(20,'JOBARC','LINEAR  ',1,ILINEAR)

C CONSTRUCT THE ROTATIONAL PROJECTOR = 1 - SUM |Rq><Rq|
C                                          xyz

      NSIZE=3*NATOM
      CALL ZERO(TPROJ,NSIZE*NSIZE)
      CALL GETREC(20,'JOBARC','ATOMMASS',NATOM*IINTFP,ATMASS)
      IOFF=1
      DO I=1,NSIZE
         TPROJ(IOFF)=ONE
         IOFF=IOFF+NSIZE+1
      END DO
      DO IXYZ=1,3-ILINEAR
c      o mass-weight and write back to disk
         CALL GETREC(20,'JOBARC',ROTREC(IXYZ),NSIZE*IINTFP,SCR)
         IOFF=1
         DO I=1,NATOM
            Z=SQRT(ATMASS(I))
            CALL DSCAL(3,Z,SCR(IOFF),1)
            IOFF=IOFF+3
         END DO
         Z=DNRM2(NSIZE,SCR,1)
         FACT=ONE/Z
         CALL DSCAL(NSIZE,FACT,SCR,1)
         CALL PUTREC(20,'JOBARC',ROTREC(IXYZ),NSIZE*IINTFP,SCR)
         CALL XGEMM('N','N',NSIZE,NSIZE,1,
     &              -1.d0,SCR,  NSIZE,
     &                    SCR,  1,
     &              ONE,  TPROJ,NSIZE)
      END DO

c   o hit symmetry adapted coordinates with projector
      CALL GETREC(20,'JOBARC','COMPNSYQ',1,NSYMOLD)
      CALL GETREC(20,'JOBARC','COMPSYMQ',NSYMOLD*NSIZE*IINTFP,SCR)
      CALL XGEMM('N','N',NSIZE,NSYMOLD,NSIZE,ONE,TPROJ,NSIZE,
     &           SCR,NSIZE,0.d0,SYMQ,NSIZE)

c   o renormalize
      IOFF=1
      DO I=1,NSYMOLD
         X=DNRM2(NSIZE,SYMQ(IOFF),1)
         IF (ABS(X).GT.TOL) THEN
            Z=ONE/X
            CALL DSCAL(NSIZE,Z,SYMQ(IOFF),1)
         END IF
         IOFF=IOFF+NSIZE
      END DO

      CALL PUTREC(20,'JOBARC','COMPSYMQ',NSIZE*NSYMOLD*IINTFP,SYMQ)

      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine form_iad(x,nindex, type, bval,
     *                              eval, bdim, edim,
     *                      x2, nindex2, type2, bval2,
     *                              eval2, bdim2, edim2)
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)
      double precision x2(*)
      integer nindex2, type2(*), bval2(*), eval2(*)
      integer bdim2(*), edim2(*)

      integer na1, na2, nb1, nb2

      na1 = edim(1)-bdim(1) + 1
      na2 = edim(2)-bdim(2) + 1
      nb1 = edim2(1)-bdim2(1) + 1
      nb2 = edim2(2)-bdim2(2) + 1
      call do_formiad(x,x2,nindex,na1,na2,nb1,nb2)

      return 
      end 

      subroutine do_formiad(array1,array2,nindex,na1,na2,nb1,nb2) 
      implicit none

      include 'int_gen_parms.h'

c----------------------------------------------------------------------------
c
c----------------------------------------------------------------------------

      integer nindex, na1, na2, nb1, nb2  
      double precision array1(na1,na2)
      double precision array2(nb1,nb2)
      double precision etemp  
      integer a, b, p, n1, n2, noff   

      n1 = min0(na1,nb1) 
      n2 = min0(na2,nb2) 

c     write(6,*) ' RANGE OF INDICES IN FORM_AID ' 
c     write(6,*) ' Array1 :', na1, na2   
c     write(6,*) ' Array2 :', nb1, nb2   

      do a = 1, n2   
      do b = 1, n2   
            etemp = 0.0 
            do p = 1, nalpha_occupied + nbeta_occupied  
               etemp = etemp + array1(a,p)*array1(b,p) 
            enddo
            array2(a,b) = 1.0*etemp  
c     write(6,*) ' a, b', a, b, array2(a,b) 
      enddo
      enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  OED__KIN_DERV_INT1D_TO_00
     +
     +                    ( NEXP,
     +                      KIN1DX,KIN1DY,KIN1DZ,
     +                      OVL1DX,OVL1DY,OVL1DZ,
     +                      DIFFX,DIFFY,DIFFZ,
     +                      TEMP1,TEMP2,
     +                      SCALE,
     +
     +                                BATCH )
     +
C------------------------------------------------------------------------
C  OPERATION   : OED__KIN_DERV_INT1D_TO_00
C  MODULE      : ONE ELECTRON INTEGRALS DIRECT
C  MODULE-ID   : OED
C  SUBROUTINES : none
C  DESCRIPTION : This routine assembles the set of batches of cartesian
C                kinetic derivative integrals [0|0], adding up all
C                contributions from all the kinetic and overlap 1D
C                derivative integrals:
C
C                        X = KIN (x) * OVL (y) * OVL (z)
C                        Y = OVL (x) * KIN (y) * OVL (z)
C                        Z = OVL (x) * OVL (y) * KIN (z)
C
C                       [0|0] = [x=0,y=0,z=0] = X + Y + Z
C
C
C                  Input:
C
C                    NEXP        =  current # of exponent pairs
C                    KIN1Dx      =  all current kinetic 1D derivative
C                                   integrals for each cartesian
C                                   component x = X,Y,Z
C                    OVL1Dx      =  all current overlap 1D derivative
C                                   integrals for each cartesian
C                                   component x = X,Y,Z
C                    DIFFp       =  is true, if differentiation was
C                                   performed on the p = x,y,z
C                                   coordinates
C                    TEMP1(2)    =  scratch arrays holding intermediate
C                                   1DX kinetic and overlap integral
C                                   times scaling factor products
C                    SCALE       =  the NEXP scaling factors
C
C
C                  Output:
C
C                    BATCH       =  batch of primitive cartesian [0|0]
C                                   kinetic derivative integrals
C                                   corresponding to all current
C                                   exponent pairs
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     DIFFX,DIFFY,DIFFZ

         INTEGER     N
         INTEGER     NEXP

         DOUBLE PRECISION  X,Y,Z

         DOUBLE PRECISION  SCALE (1:NEXP)
         DOUBLE PRECISION  TEMP1 (1:NEXP)
         DOUBLE PRECISION  TEMP2 (1:NEXP)

         DOUBLE PRECISION  BATCH (1:NEXP)

         DOUBLE PRECISION  KIN1DX (1:NEXP)
         DOUBLE PRECISION  KIN1DY (1:NEXP)
         DOUBLE PRECISION  KIN1DZ (1:NEXP)

         DOUBLE PRECISION  OVL1DX (1:NEXP,0:1,0:1)
         DOUBLE PRECISION  OVL1DY (1:NEXP,0:1,0:1)
         DOUBLE PRECISION  OVL1DZ (1:NEXP,0:1,0:1)
C
C
C------------------------------------------------------------------------
C
C
C             ...skip multiplications by 1 comming from original
C                (not derivated) 1D pure s-type overlap integrals.
C
C
         IF (DIFFX) THEN
             DO N = 1,NEXP
                TEMP1 (N) = SCALE (N) * KIN1DX (N)
                TEMP2 (N) = SCALE (N) * OVL1DX (N,0,0)
             END DO
         ELSE
             DO N = 1,NEXP
                TEMP1 (N) = SCALE (N) * KIN1DX (N)
                TEMP2 (N) = SCALE (N)
             END DO
         END IF

         IF (DIFFY .AND. DIFFZ) THEN

             DO N = 1,NEXP
                X = TEMP1 (N) * OVL1DY (N,0,0)
     +                        * OVL1DZ (N,0,0)
                Y = TEMP2 (N) * KIN1DY (N)
     +                        * OVL1DZ (N,0,0)
                Z = TEMP2 (N) * OVL1DY (N,0,0)
     +                        * KIN1DZ (N)
                BATCH (N) = X + Y + Z
             END DO

         ELSE IF (DIFFY) THEN

             DO N = 1,NEXP
                X = TEMP1 (N) * OVL1DY (N,0,0)
                Y = TEMP2 (N) * KIN1DY (N)
                Z = TEMP2 (N) * OVL1DY (N,0,0)
     +                        * KIN1DZ (N)
                BATCH (N) = X + Y + Z
             END DO

         ELSE IF (DIFFZ) THEN

             DO N = 1,NEXP
                X = TEMP1 (N) * OVL1DZ (N,0,0)
                Y = TEMP2 (N) * KIN1DY (N)
     +                        * OVL1DZ (N,0,0)
                Z = TEMP2 (N) * KIN1DZ (N)
                BATCH (N) = X + Y + Z
             END DO

         ELSE

             DO N = 1,NEXP
                X = TEMP1 (N)
                Y = TEMP2 (N) * KIN1DY (N)
                Z = TEMP2 (N) * KIN1DZ (N)
                BATCH (N) = X + Y + Z
             END DO

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      subroutine joda_main()

      integer pass1, i
      logical fd, geomopt, num_grad

      integer iMemMin, iMemInc
      parameter (iMemMin=2097152)
      parameter (iMemInc=1048576)

      integer ishell
      external ishell



c icore.com : begin

c icore(1) is an anchor in memory that allows subroutines to address memory
c allocated with malloc. This system will fail if the main memory is segmented
c or parallel processes are not careful in how they allocate memory.

      integer icore(1)
      common / / icore

c icore.com : end












c istart.com : begin
      integer         i0, icrsiz
      common /istart/ i0, icrsiz
      save   /istart/
c istart.com : end
      logical ignore
      common /restart_com/ ignore






































































































































































































































































































































































































































































































c This common block contains the IFLAGS and IFLAGS2 arrays for JODA ROUTINES
c ONLY! The reason is that it contains both arrays back-to-back. If the
c preprocessor define MONSTER_FLAGS is set, then the arrays are compressed
c into one large (currently) 600 element long array; otherwise, they are
c split into IFLAGS(100) and IFLAGS2(500).

c iflags(100)  ASVs reserved for Stanton, Gauss, and Co.
c              (Our code is already irrevocably split, why bother anymore?)
c iflags2(500) ASVs for everyone else

      integer        iflags(100), iflags2(500)
      common /flags/ iflags,      iflags2
      save   /flags/






c   o initialize the runtime environment
      call aces_init_rte

c   o gather parallel statistics (needed by gfname in ja_init)
      call aces_com_parallel_aces

c   o parse command line (overwrites rank and number of processes)
      call parse_cli

c   o evaluate and repair the health of the current file set
      call dfiles(ignore)

c   o initialize the job archive subsystem
      call aces_ja_init

      if (.not.ignore) then
c      o this is the first joda run
         call putrec(1,'JOBARC','FIRSTRUN',1,1)
         call putrec(1,'JOBARC','DIRTYFLG',1,0)
         call putrec(1,'JOBARC','JODADONE',1,0)
         call putrec(1,'JOBARC','FNDFDONE',1,1)
         call geopt
      else
c      o load flags
         call getrec(1,'JOBARC','IFLAGS', 100,iflags)
         call getrec(1,'JOBARC','IFLAGS2',500,iflags2)
      end if

      geomopt=(iflags2(5).ne.0)
      num_grad=(iflags2(138).eq.1)
      fd = (iflags(54).eq.3.or.(geomopt.and.num_grad))

      if (fd) then

c      o allocate memory for symcor
         icrsiz = iflags(36)
         iCore(1) = 0
         do while ((iCore(1).eq.0).and.(icrsiz.gt.iMemMin))
            call aces_malloc(icrsiz,iCore,i0)
            if (iCore(1).eq.0) icrsiz = icrsiz - iMemInc
         end do
         if (iCore(1).eq.0) then
            print *, '@JODA: unable to allocate at least ',
     &               iMemMin,' integers of memory'
            call aces_exit(1)
         end if

         if (ignore) then
c         o mid-stream -> keep going
            call getrec(1,'JOBARC','FNDFDONE',1,i)
            if (i.eq.0) call symcor(icore(i0),icrsiz)
         else
c         o first run -> reset finite difference series
            if (geomopt) i=ishell('cp OPTARC OPTARCBK')
            call putrec(1,'JOBARC','FNDFDONE',1,0)
            call symcor(icore(i0),icrsiz)
            ignore=.true.
         end if

         call getrec(1,'JOBARC','PASS1',1,pass1)
         if (pass1.ne.-1) then
c         o vib freqs w/ an grads -OR- geom opts w/ num grads
            call putrec(1,'JOBARC','FIRSTRUN',1,0)
            call putrec(1,'JOBARC','DIRTYFLG',1,1)
            if (geomopt.and.pass1.eq.0) then
               i=ishell('cp OPTARCBK OPTARC')
               call geopt
               call getrec(1,'JOBARC','JODADONE',1,i)
               if (i.ne.1) then
c               o new geom -> reset finite difference series
                  i=ishell('cp OPTARC OPTARCBK')
                  call putrec(1,'JOBARC','FNDFDONE',1,0)
                  call symcor(icore(i0),icrsiz)
                  call geopt
               end if
            else
               call geopt
               if (pass1.eq.0) call putrec(1,'JOBARC','JODADONE',1,1)
            end if
         end if

      else

         if (ignore) then
c         o joda has run before
            call putrec(1,'JOBARC','FIRSTRUN',1,0)
            call putrec(1,'JOBARC','DIRTYFLG',1,1)
            call geopt
         end if

      end if

c   o finalize the job archive subsystem
      call aces_ja_fin

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine compute_erd_2e_Sderv_integrals(a1,a2,b1,b2,c1,c2,d1,d2,
     *                 der_flags,
     *                 scr,maxblk,
     *                 iscr, coords,coeffs,alphas, ccbeg, ccend,
     *                 in, hess)
c---------------------------------------------------------------------------
c   "Work" routine for the integral worker task.
c---------------------------------------------------------------------------

      implicit none

      include 'mpif.h'
      include 'int_gen_parms.h'
      include 'machine_types.h'
      include 'hess.h'

      integer a1, a2, b1, b2, c1, c2, d1, d2 
      integer der_flags(12)
      integer der_save(12)
      integer iatom, jatom, icomponent, jcomponent, ihess, jhess   
      integer aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2
      integer adim, bdim, cdim, ddim  
      integer m1, m2, n1, n2, r1, r2, s1, s2
      integer i, j, k, l, n, m, r, s
      integer a,b,c,d
      integer ix, jx 
      integer wder, ncder, nder_first  
      integer nflags,iflags(256,12) 

      integer num_to_do, nsend
      integer nints, maxblk
      integer nalpha_pack, npcoeff_pack
      integer ncsum, next, nfirst, ifirst, jfirst, kfirst 
      integer me, ierr

      integer imin, zmin, iblk, zblk

      logical skip
      logical mn_symmetry
      logical rs_symmetry
      logical mn_rs_symmetry
      logical*8 l8true, l8spherical
      logical spherical

      double precision x1,y1,z1
      double precision x2,y2,z2
      double precision x3,y3,z3
      double precision x4,y4,z4

      double precision coords(3,*), coeffs(*), alphas(*)
      double precision out(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision in(a1:a2,b1:b2,c1:c2,d1:d2)
      double precision scr(*), y, fact
      double precision hess(3*ncenters,3*ncenters)
      integer iscr(*)
      integer myder(4,3), mySder(4,3), satom(4)  
      integer ncder1, ncder2, wder1, wder2, nfirst1, nfirst2   

      integer ccbeg(*), ccend(*)

      integer max_dim_coeff
      parameter (max_dim_coeff = 5000)
      integer ccbeg_pack(max_dim_coeff), ccend_pack(max_dim_coeff)
      double precision alpha_pack(max_dim_coeff), 
     *                 pcoeff_pack(max_dim_coeff)
      save me,alpha_pack, pcoeff_pack, ccbeg_pack, ccend_pack

      call mpi_comm_rank(mpi_comm_world, me, ierr)
c      print *,'Task ',me,' computing integrals for ',a1,a2,b1,b2,
c     *     c1,c2,d1,d2

      adim = a2-a1+1
      bdim = b2-b1+1
      cdim = c2-c1+1
      ddim = d2-d1+1 
      l8true = .true.
      spherical = (ispherical .eq. 1)
      l8spherical = spherical
  
      nsend = adim*bdim*cdim*ddim
      if (nsend .lt. 0) then
         print *,'ERROR IN INTEGRAL WORKER ',me,' nsend = ',nsend
         print *,'adim,bdim,cdim,ddim = ',adim,bdim,cdim,ddim
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Clear the output array.
c----------------------------------------------------------------------------

      do d = d1,d2
      do c = c1,c2
      do b = b1,b2
      do a = a1,a2
         out(a,b,c,d) = 0.d0
      enddo
      enddo
      enddo
      enddo

c----------------------------------------------------------------------------
c   Save the der_array.
c----------------------------------------------------------------------------

      do a = 1, 12 
         der_save(a) = der_flags(a) 
      enddo 

c-----------------------------------------------------------------------
c   Find the shell blocks for which we shall loop through.
c-----------------------------------------------------------------------

         call lookup_shell(end_nfps, nshells, a1, m1)
         call lookup_shell(end_nfps, nshells, a2, m2)
         call lookup_shell(end_nfps, nshells, b1, n1)
         call lookup_shell(end_nfps, nshells, b2, n2)
         call lookup_shell(end_nfps, nshells, c1, r1)
         call lookup_shell(end_nfps, nshells, c2, r2)
         call lookup_shell(end_nfps, nshells, d1, s1)
         call lookup_shell(end_nfps, nshells, d2, s2)

         do m = m1, m2
            if (m .eq. 1) then
               aa1 = 1
            else
               aa1 = end_nfps(m-1) + 1
            endif
            aa2 = end_nfps(m)

            x1 = coords(1,m)
            y1 = coords(2,m)
            z1 = coords(3,m)
         do n = n1, n2
            if (n .eq. 1) then
               bb1 = 1
            else
               bb1 = end_nfps(n-1) + 1
            endif
            bb2 = end_nfps(n)

            x2 = coords(1,n)
            y2 = coords(2,n)
            z2 = coords(3,n)
         do r = r1, r2
            if (r .eq. 1) then
               cc1 = 1
            else
               cc1 = end_nfps(r-1) + 1
            endif
            cc2 = end_nfps(r)

            x3 = coords(1,r)
            y3 = coords(2,r)
            z3 = coords(3,r)
         do s = s1, s2
            if (intpkg .eq. flocke_package) then
               x4 = coords(1,s)
               y4 = coords(2,s)
               z4 = coords(3,s)
               call pack_coeffs(alphas, ixalpha, coeffs, ixpcoef, 
     *                          ncfps, npfps, m, n, 
     *                          r, s, alpha_pack, nalpha_pack, 
     *                          pcoeff_pack, npcoeff_pack, 
     *                          ccbeg, ccend, indx_cc,
     *                          ccbeg_pack, ccend_pack)

c----------------------------------------------------------------------------
c   Check if the integral is atomic. 
c----------------------------------------------------------------------------

           if ((atom(m) .eq. atom(n)) .and. 
     *         (atom(m) .eq. atom(r)) .and.    
     *         (atom(m) .eq. atom(s))) go to 777   

c----------------------------------------------------------------------------
c   Determine the flags for this quad. 
c----------------------------------------------------------------------------

            satom(1) = atom(m) 
            satom(2) = atom(n) 
            satom(3) = atom(r) 
            satom(4) = atom(s) 

            call setflag(m,n,r,s,satom,nflags,iflags) 
            if (nflags .eq. 0) go to 777 

            do ix = 1, nflags     

               do a = 1, 12 
                  der_save(a)  = iflags(ix,a)   
                  der_flags(a) = iflags(ix,a)   
               enddo  

c----------------------------------------------------------------------------
c   Make sure the der_flags are set correctly for equivalent centers.
c----------------------------------------------------------------------------

               iatom = 0 
               jatom = 0 
               icomponent = 0 
               jcomponent = 0 

               do a = 1, 3  
                  if (der_flags(a) .eq. 2) then  
                     iatom = atom(m)  
                     jatom = atom(m)  
                     icomponent = a 
                     jcomponent = a 
                     go to 33 
                  endif 
               enddo  

               do a = 4, 6  
                  if (der_flags(a) .eq. 2) then  
                     iatom = atom(n)  
                     jatom = atom(n)  
                     icomponent = a-3  
                     jcomponent = a-3  
                     go to 33 
                  endif 
               enddo  

               do a = 7, 9  
                  if (der_flags(a) .eq. 2) then  
                     iatom = atom(r)  
                     jatom = atom(r)  
                     icomponent = a-6  
                     jcomponent = a-6  
                     go to 33 
                  endif 
               enddo  

               do a = 10, 12  
                  if (der_flags(a) .eq. 2) then  
                     iatom = atom(s)  
                     jatom = atom(s)  
                     icomponent = a-9  
                     jcomponent = a-9  
                     go to 33 
                  endif 
               enddo  

               do a = 1, 3
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(m)
                     icomponent = a
                     kfirst = a  
                     go to 66
                  endif
               enddo

               do a = 4, 6
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(n)
                     icomponent = a-3 
                     kfirst = a  
                     go to 66
                  endif
               enddo

               do a = 7, 9  
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(r)
                     icomponent = a-6  
                     kfirst = a  
                     go to 66
                  endif
               enddo

               do a = 10, 12  
                  if (der_flags(a) .eq. 1) then
                     iatom = atom(s)
                     icomponent = a-9  
                     kfirst = a  
                     go to 66
                  endif
               enddo

66             continue

               do a = 1, 3
                  if ((der_flags(a) .eq. 1).and.(a .gt. kfirst)) then
                     jatom = atom(m)
                     jcomponent = a
                     go to 33
                  endif
               enddo

               do a = 4, 6
                  if ((der_flags(a) .eq. 1).and.(a .gt. kfirst)) then
                     jatom = atom(n)
                     jcomponent = a-3 
                     go to 33
                  endif
               enddo

               do a = 7, 9  
                  if ((der_flags(a) .eq. 1).and.(a .gt. kfirst)) then
                     jatom = atom(r)
                     jcomponent = a-6  
                     go to 33
                  endif
               enddo

               do a = 10, 12  
                  if ((der_flags(a) .eq. 1).and.(a .gt. kfirst)) then
                     jatom = atom(s)
                     jcomponent = a-9  
                     go to 33
                  endif
               enddo

33             continue 

               kfirst = 0
               do k = 1, 12
                  if(der_flags(k) .eq. 2) kfirst = 2
                  if(der_flags(k) .eq. 1) kfirst = 1
               enddo

               if (kfirst .eq. 0) then 
                  write(6,*) ' NO DER_FLAGS SET! ' 
                  stop 
               endif  

               if (atom(m) .eq. atom(n)) then 
                 if (der_flags(1) .ne. 0) der_flags(4) = der_flags(1)  
                 if (der_flags(4) .ne. 0) der_flags(1) = der_flags(4)  
                 if (der_flags(2) .ne. 0) der_flags(5) = der_flags(2)  
                 if (der_flags(5) .ne. 0) der_flags(2) = der_flags(5) 
                 if (der_flags(3) .ne. 0) der_flags(6) = der_flags(3) 
                 if (der_flags(6) .ne. 0) der_flags(3) = der_flags(6) 
               endif 

               if (atom(m) .eq. atom(r)) then 
                 if (der_flags(1) .ne. 0) der_flags(7) = der_flags(1) 
                 if (der_flags(7) .ne. 0) der_flags(1) = der_flags(7) 
                 if (der_flags(2) .ne. 0) der_flags(8) = der_flags(2)  
                 if (der_flags(8) .ne. 0) der_flags(2) = der_flags(8) 
                 if (der_flags(3) .ne. 0) der_flags(9) = der_flags(3) 
                 if (der_flags(9) .ne. 0) der_flags(3) = der_flags(9) 
               endif 

               if (atom(m) .eq. atom(s)) then 
                 if (der_flags(1) .ne. 0) der_flags(10) = der_flags(1) 
                 if (der_flags(10).ne. 0) der_flags(1)  = der_flags(10) 
                 if (der_flags(2) .ne. 0) der_flags(11) = der_flags(2) 
                 if (der_flags(11).ne. 0) der_flags(2)  = der_flags(11) 
                 if (der_flags(3) .ne. 0) der_flags(12) = der_flags(3) 
                 if (der_flags(12).ne. 0) der_flags(3)  = der_flags(12) 
               endif 

               if (atom(n) .eq. atom(r)) then 
                 if (der_flags(4) .ne. 0) der_flags(7) = der_flags(4) 
                 if (der_flags(7) .ne. 0) der_flags(4) = der_flags(7) 
                 if (der_flags(5) .ne. 0) der_flags(8) = der_flags(5) 
                 if (der_flags(8) .ne. 0) der_flags(5) = der_flags(8) 
                 if (der_flags(6) .ne. 0) der_flags(9) = der_flags(6) 
                 if (der_flags(9) .ne. 0) der_flags(6) = der_flags(9) 
               endif 

               if (atom(n) .eq. atom(s)) then 
                 if (der_flags(4)  .ne. 0) der_flags(10) = der_flags(4) 
                 if (der_flags(10) .ne. 0) der_flags(4)  = der_flags(10) 
                 if (der_flags(5)  .ne. 0) der_flags(11) = der_flags(5) 
                 if (der_flags(11) .ne. 0) der_flags(5)  = der_flags(11) 
                 if (der_flags(6)  .ne. 0) der_flags(12) = der_flags(6) 
                 if (der_flags(12) .ne. 0) der_flags(6)  = der_flags(12) 
               endif 

               if (atom(r) .eq. atom(s)) then 
                 if (der_flags(7)  .ne. 0) der_flags(10) = der_flags(7) 
                 if (der_flags(10) .ne. 0) der_flags(7)  = der_flags(10) 
                 if (der_flags(8)  .ne. 0) der_flags(11) = der_flags(8) 
                 if (der_flags(11) .ne. 0) der_flags(8)  = der_flags(11) 
                 if (der_flags(9)  .ne. 0) der_flags(12) = der_flags(9) 
                 if (der_flags(12) .ne. 0) der_flags(9)  = der_flags(12) 
               endif 

c----------------------------------------------------------------------------
c              Clear the output array.
c----------------------------------------------------------------------------

               do d = d1,d2
               do c = c1,c2
               do b = b1,b2
               do a = a1,a2
                  out(a,b,c,d) = 0.d0
               enddo
               enddo
               enddo
               enddo

c---------------------------------------------------------------------------
c   Calling sequence for ERD version 2.
c---------------------------------------------------------------------------

               ncsum = ncfps(m) + ncfps(n) + ncfps(r) + ncfps(s)

                  call ERD__GENER_ERI_DERV_BATCH(intmax, zmax,
     *                nalpha_pack, npcoeff_pack, ncsum, 
     *                ncfps(m),ncfps(n), ncfps(r), ncfps(s),
     *                npfps(m),npfps(n), npfps(r), npfps(s),
     *                ivangmom(m), ivangmom(n), 
     *                ivangmom(r), ivangmom(s), x1,y1,z1,
     *                x2,y2,z2,x3,y3,z3,x4,y4,z4, 
     *                der_flags(1), der_flags(2), der_flags(3),
     *                der_flags(4), der_flags(5), der_flags(6),
     *                der_flags(7), der_flags(8), der_flags(9),
     *                der_flags(10), der_flags(11), der_flags(12),
     *                alpha_pack,
     *                pcoeff_pack, ccbeg_pack, ccend_pack,
     *                spherical, .true., iscr, nints, 
     *                nfirst, scr)    

c---------------------------------------------------------------------------
c   Move the integrals into the output block.  
c---------------------------------------------------------------------------

            if (nints .gt. 0) then
               
               if (s .eq. 1) then
                  dd1 = 1
               else
                  dd1 = end_nfps(s-1) + 1
               endif
               dd2 = end_nfps(s)
 
               call move_integrals(out, a1,a2,b1,b2,c1,c2,d1,d2,
     *                             scr(nfirst), 
     *                             aa1,aa2,bb1,bb2,cc1,cc2,dd1,dd2)

c---------------------------------------------------------------------------
c   Contract with Intemediate block.
c---------------------------------------------------------------------------

               y = 0.0d0  
               do i = aa1, aa2 
               do j = bb1, bb2 
               do k = cc1, cc2 
               do l = dd1, dd2 
                  y = y + in(i,j,k,l)*out(i,j,k,l) 
               enddo  
               enddo  
               enddo  
               enddo  

c---------------------------------------------------------------------------
c   Sum into the hessian.
c---------------------------------------------------------------------------

              ihess = (iatom-1)*3 + icomponent
              jhess = (jatom-1)*3 + jcomponent

              if (ihess .eq. jhess)
     *        hess(jhess,ihess) = hess(jhess,ihess) + y

c---------------------------------------------------------------------------
c   Symmetrize the hessian if necassary??? Why???
c---------------------------------------------------------------------------
 
              if (ihess .ne. jhess) then 
                 y = 0.5d0*y  
                 hess(ihess,jhess) = hess(ihess,jhess) + y
                 hess(jhess,ihess) = hess(jhess,ihess) + y
              endif 

            endif

            enddo !ix = 1, 12 

777         continue 

            endif ! (intpkg .eq. flocke_package) then
         enddo   ! s
         enddo   ! r

         enddo   ! n
         enddo   ! m

      return
      end

      
      subroutine setflag(m,n,r,s,satom,nflags,iflags) 

      implicit none
      integer i,j,k,kmin,nmin,wmin,map(4),satom(4),xtype  
      integer ix,jx,ic,jc,jf,nflags,iflags(256,12) 
      integer m,n,r,s 

c------------------------------------------------------------------------------
c Determine which flags to set.  
c------------------------------------------------------------------------------

      nflags = 0 

c------------------------------------------------------------------------------
c (AB|CD) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .ne. satom(2)) .and. (satom(1) .ne. satom(3)) .and.  
     *    (satom(1) .ne. satom(4)) .and. (satom(2) .ne. satom(3)) .and.  
     *    (satom(2) .ne. satom(4)) .and. (satom(3) .ne. satom(4))) then   

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = ic, 4  
            do jx = ix, 3  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AA|BB) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(2)) .and. (satom(3) .eq. satom(4)) .and. 
     *    (satom(1) .ne. satom(3))) then 

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4   
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 11  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 1
     *                                      .and. ic .ne. 2) go to 11  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

11             continue 

            enddo 
            enddo 

         enddo 
         enddo 

c        endif 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AA|BC) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(2)) .and. (satom(3) .ne. satom(4)) .and. 
     *    (satom(1) .ne. satom(3)) .and. (satom(1) .ne. satom(4))) then 

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 12  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 1
     *                                      .and. ic .ne. 2) go to 12  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

12             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (BC|AA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(3) .eq. satom(4)) .and. (satom(1) .ne. satom(2)) .and. 
     *    (satom(3) .ne. satom(1)) .and. (satom(3) .ne. satom(2))) then 

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 13  
               if (satom(ic) .ne. satom(jc) .and. jc .ne. 3
     *                                      .and. jc .ne. 4) go to 13  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

13             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AB|AB) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(3)) .and. (satom(2) .eq. satom(4))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 14  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 1
     *                                      .and. ic .ne. 3) go to 14  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

14             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AB|BA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(4)) .and. (satom(2) .eq. satom(3))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 15  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 1
     *                                      .and. ic .ne. 4) go to 15  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

15             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AB|AC) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(3)) .and. (satom(2) .ne. satom(4)) .and.  
     *    (satom(1) .ne. satom(2)) .and. (satom(1) .ne. satom(4))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 24  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 1
     *                                      .and. ic .ne. 3) go to 24   

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

24             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AB|CA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(4)) .and. (satom(1) .ne. satom(2)) .and.    
     *    (satom(1) .ne. satom(3)) .and. (satom(2) .ne. satom(3))) then    

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 34  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 1
     *                                      .and. ic .ne. 4) go to 34   

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

34             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (BA|CA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(2) .eq. satom(4)) .and. (satom(1) .ne. satom(2)) .and.    
     *    (satom(1) .ne. satom(3)) .and. (satom(2) .ne. satom(3))) then    

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 44  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 2
     *                                      .and. ic .ne. 4) go to 44   

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

44             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (BA|AC) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(2) .eq. satom(3)) .and. (satom(1) .ne. satom(2)) .and.    
     *    (satom(1) .ne. satom(4)) .and. (satom(2) .ne. satom(4))) then    

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 54  
               if (satom(ic) .ne. satom(jc) .and. ic .ne. 2
     *                                      .and. ic .ne. 3) go to 54   

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

54             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c     go to 300 
200   continue 

c------------------------------------------------------------------------------
c (AA|AB) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(2)) .and. (satom(1) .eq. satom(3)) .and. 
     *    (satom(1) .ne. satom(4))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4   
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

c Omit duplicate loops. 
c --------------------- 

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 16  

               if ((satom(ic) .eq. satom(jc)) .and. (ix .eq. jx) .and. 
     *             ((ic .ne. 4)  .and. (ic .ne. 1))) go to 16  

               if ((satom(ic)  .ne. satom(jc))   .and. 
     *            ((ic .ne. 1) .or. (jc .ne. 4)) .and. 
     *            ((ic .ne. 4) .or. (jc .ne. 1))) go to 16  

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

16             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AA|BA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(2)) .and. (satom(1) .eq. satom(4)) .and. 
     *    (satom(1) .ne. satom(3))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

c Omit duplicate loops. 
c --------------------- 

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 17  

               if ((satom(ic) .eq. satom(jc)) .and. (ix .eq. jx) .and. 
     *             (ic .ne. 1)  .and. (ic .ne. 3)) go to 17  

               if ((ix .eq. jx) .and. (satom(ic) .ne. satom(jc)) .and. 
     *            ((ic .ne. 1) .or. (jc .ne. 3)) .and.  
     *            ((ic .ne. 3) .or. (jc .ne. 1))) go to 17 

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

17             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (AB|AA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(1) .eq. satom(3)) .and. (satom(1) .eq. satom(4)) .and. 
     *    (satom(1) .ne. satom(2))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

c Omit duplicate loops. 
c --------------------- 

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 18  

               if ((satom(ic) .eq. satom(jc)) .and. (ix .eq. jx) .and. 
     *             (ic .ne. 1)  .and. (ic .ne. 2)) go to 18  

               if ((ix .eq. jx) .and. (satom(ic) .ne. satom(jc)) .and. 
     *            ((ic .ne. 2) .or. (jc .ne. 1)) .and.  
     *            ((ic .ne. 1) .or. (jc .ne. 2))) go to 18 

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

18             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

c------------------------------------------------------------------------------
c (BA|AA) TYPE. 
c------------------------------------------------------------------------------

      if ((satom(2) .eq. satom(3)) .and. (satom(2) .eq. satom(4)) .and. 
     *    (satom(1) .ne. satom(2))) then  

         do ix = 1, 256 
         do jx = 1, 12 
            iflags(ix,jx) = 0 
         enddo 
         enddo 

         jf = 0 

         do ic = 1, 4 
         do ix = 1, 3 

            i = 3*(ic-1) + ix 

            do jc = 1, 4  
            do jx = 1, 3  

c Omit duplicate loops. 
c --------------------- 

               if (satom(ic) .eq. satom(jc) .and. ix .eq. jx
     *                                      .and. ic .ne. jc) go to 19  

               if ((satom(ic) .eq. satom(jc)) .and. (ix .eq. jx) .and. 
     *             (ic .ne. 1)  .and. (ic .ne. 4)) go to 19  

               if ((ix .eq. jx) .and. (satom(ic) .ne. satom(jc)) .and. 
     *            ((ic .ne. 4) .or. (jc .ne. 1)) .and.  
     *            ((ic .ne. 1) .or. (jc .ne. 4))) go to 19 

               j = 3*(jc-1) + jx 

               jf = jf + 1 

               iflags(jf,i) = 1 
               iflags(jf,j) = iflags(jf,j) + 1 

19             continue 

            enddo 
            enddo 

         enddo 
         enddo 

         nflags = jf 
         go to 300 
            
      endif 

300   continue 

c     if (nflags .eq. 0) then 
c        write(6,*) ' No flags set in compute_erd_2e_Sderv_integrals '
c        STOP 
c     endif  

      return 
      end 
 

c This routine reads in integers from iUnit and compares them to ints from
c szRecName (stored in iScr). It returns the next record line in iUnit.

c INPUT
c int iUnit
c char*(*) szRecName
c int iDimScr

c OUTPUT
c char*80 sz
c logical bCont
c int iScr(iDimScr)




      subroutine test_int(iUnit,sz,bCont,szRecName,iScr,iDimScr)
      implicit none

c ARGUMENT LIST
      integer iUnit
      character*80 sz
      logical bCont
      character*8 szRecName
      integer iScr(*), iDimScr

c INTERNAL VARIABLES
      integer nInts, ndx, iFirst, iLast, iVal, i
      integer iStat
      logical bVal
      character*80 szVal
      character*1 czSpace, czTab

c EXTERNAL FUNCTIONS
      integer c_atol
      external c_atol

c COMMON BLOCKS
      integer            iErrExit
      common /exit_stat/ iErrExit
      save   /exit_stat/

c ----------------------------------------------------------------------

c   o get the record length
      call getrec(0,'JOBARC',szRecName,nInts,iScr)

c   o make sure the record exists
      if (nInts.lt.1) then
         print *, '@TEST_INT: "',szRecName,'" is empty'
         call aces_exit(1)
      end if

c   o read it in
      if (nInts.gt.iDimScr) then
         print *, '@TEST_INT: There is not enough memory to hold the ',
     &            'record.'
         call aces_exit(1)
      end if
      call getrec(1,'JOBARC',szRecName,nInts,iScr)

c   o constants
      czSpace = achar(32)
      czTab   = achar(9)

c   o keep reading good data from iUnit until a new record or EOF
      ndx = 0
      bVal = .true.
      do while (bVal)
         read(unit=iUnit,fmt='(a)',end=100,err=9999,iostat=iStat) sz
c      o find the first token
         iFirst = 1
         do while ((sz(iFirst:iFirst).eq.czSpace.or.
     &              sz(iFirst:iFirst).eq.czTab).and.
     &             iFirst.le.80)
            iFirst = iFirst + 1
         end do
         iLast = iFirst
         do while ((sz(iLast:iLast).ne.czSpace.and.
     &              sz(iLast:iLast).ne.czTab).and.
     &             iLast.lt.80)
            iLast = iLast + 1
         end do
c      o process the token (skip blank lines)
         if (iFirst.le.80) then
            if (sz(iLast:iLast).eq.czSpace.or.
     &          sz(iLast:iLast).eq.czTab) iLast = iLast - 1
            szVal = sz(iFirst:iLast)//achar(0)
            iVal = c_atol(szVal)
c         o zeroes must be entered exactly as '0'
            bVal = (iVal.ne.0.or.sz(iFirst:iLast).eq.'0')
            if (bVal) then
               ndx = ndx + 1
               if (ndx.gt.nInts) then
                  print *, '@TEST_INT: There is less test data than ',
     &                     'good data'
                  call aces_exit(1)
               end if
               if (iVal.ne.iScr(ndx)) then
                  print *, 'Integer ',ndx,' of record "',szRecName,'"',
     &                     ' does not match.'
                  print *, '   good value = ',iVal
                  print *, '   test value = ',iScr(ndx)
                  iErrExit = iErrExit + 1
               end if
c           end if (bVal)
            end if
c        end if (iFirst.le.80)
         end if
c     end do while (bVal)
      end do

      if (ndx.ne.nInts) then
         print *, '@TEST_INT: WARNING: more test data than good data'
         if (nInts.eq.1) then
            print *, '           "',szRecName,'" has 1 integer'
         else
            print *, '           "',szRecName,'" has ',nInts,' integers'
         end if
         if (ndx.eq.1) then
            print *, '           Only 1 integer was defined.'
         else
            print *, '           Only ',ndx,' integers were defined.'
         end if
      end if

      return

 100  bCont = .false.
      return

 9999 call aces_io_error('TEST_INT',iUnit,iStat)

c     end subroutine test_int
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine cwork0555( y, x1,
     *             ne1,ne2,nf1,nf2,ng1,ng2,nh1,nh2,nm1,nm2, 
     *             e1,e2,f1,f2,g1,g2,h1,h2,m1,m2, 
     *             indx1, x2,
     *             ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2,no1,no2, 
     *             i1,i2,j1,j2,k1,k2,l1,l2,n1,n2,
     *             indx2, flopcount )
c-------------------------------------------------------------------------
c   Performs a "0555" contraction: 
c      0 index output array
c      5 index operand array
c      5 index operand array
c      5 index contraction.
c
c   I. e., contract all 4 innices of the 2nd operand array with the
c   first operand array, storing the result in a scalar. 
c--------------------------------------------------------------------------
      implicit none
       include 'parallel_info.h'

      integer ne1,ne2,nf1,nf2,
     *        ng1,ng2,nh1,nh2,
     *        ni1,ni2,nj1,nj2,nk1,nk2,nl1,nl2, 
     *        nm1,nm2,nn1,nn2,
     *        no1,no2,np1,np2 
      integer e1,e2,f1,f2,g1,g2,h1,h2,
     *        i1,i2,j1,j2,k1,k2,l1,l2, 
     *        m1,m2,n1,n2,i5,j5,i6,j6  
      integer indx1(4), indx2(4), indi, indj
      integer flopcount

      double precision xddot
      double precision y
      double precision x1(ne1:ne2,nf1:nf2,ng1:ng2,nh1:nh2,
     *                    nm1:nm2)
      double precision x2(ni1:ni2,nj1:nj2,nk1:nk2,nl1:nl2,
     *                    no1:no2)

      integer ii,ij,ik,il
      integer i, j, k, l, m, n, ix(4)
      integer one 

      flopcount = 0
      y = 0.0d0 

c--------------------------------------------------------------------------
c   Indices of x1, x2 line up exactly.  Use optimized contraction loop.
c--------------------------------------------------------------------------

c         n = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(l2-l1+1)
c     *      *(j5-i5+1)
c         one = 1
c         y = xddot(n, x1(i1,j1,k1,l1,i5,i6), one, 
c     *                x2(i1,j1,k1,l1,i5,i6), one)


c       if(me.eq.0) write(6,*) i1,i2,'---',l1,l2,'--',n1,n2 
 
       y = 0.0d0 
      do i = i1, i2 
      do j = j1, j2 
      do k = k1, k2 
      do l = l1, l2 
      do m = n1, n2
        y = y + x1(i,j,k,l,m)*x2(i,j,k,l,m) 
      enddo 
      enddo 
      enddo 
      enddo 
      enddo 

      return
      end

#include <flags.h>
      Subroutine Pes_scan_main(Streaming, Stationary, Drive_IRC)
      Implicit Double Precision (A-H, O-Z) 
C
#include <icore.com>
#include <machsp.com>
#include <mxatms.par>
#include <jodaflags.com>
C
      Double Precision Norm_coords, Omega, Lamsearch_Tol, 
     &                 Ln_Intrp_Tol
      Character*80 Fname, Direction
      Character*80 tmp
      Character*5 AtmLabel(Mxatms), Constr_Min
      Character*4 SymLabel(3*Mxatms), Units
      Character*12 Grid_file
      Character*11 Vib_Type(3*Mxatms)

C
C     Conversion factors from bohr to angstrom and atomic units to cm-1
C
      Parameter (B2ang=1.889725989, Au2Invcm=5.14048D03)
C
      Logical ZMT_Present, GBS_Present, JARC_Present, JNDX_Present,
     &        Can_Do_Aces, Ref_done, User_input, Direct, 
     &        Grid_file_Present, Drive_IRC, Trans_state, 
     &        Get_Hess, More_pts_left, End_point, Begin_IRC,
     &        Forward, Get_grad, Mass_Weigh_nm, Mass_Weigh_gr,
     &        New_IRC, Look4_IRC

      Logical FlgACESGeom,FlgACESElec,FlgACESGrad,FlgACESHess,
     &        FRQARC_EXIST, Streaming, Stationary, Wrt_extrnls
C 
      Dimension VCoords(Mxatms*3), A2grad(Mxatms*3), Rgrad(Mxatms*3),
     &          A2hess(Mxatms*Mxatms*9), Imap(Mxatms), IOrd(Mxatms),
     &          AtmMass(Mxatms), Rhess(Mxatms*Mxatms*9),
     &          Norm_coords(9*Mxatms*Mxatms), Omega(3*Mxatms),
     &          Vomega(3*Mxatms),Btmp(3*Mxatms), Deltaq(3*Mxatms),
     &          Deltax(3*Mxatms), Coords(Mxatms*3), 
     &          Coords_K0O(Mxatms*3), Coords_K1C(Mxatms*3),  
     &          Coords_K1P(Mxatms*3), Coords_K1CM(Mxatms*3),
     &          Work(50*Mxatms*Mxatms),Grad_K0O(3*Mxatms),
     &          Vec_K1C0(Mxatms*3), Grad_on_K0O(Mxatms*3), 
     &          Grad_on_K1C(Mxatms*3), Vec_K0O(Mxatms*3), 
     &          Steep_Dpath(3*Mxatms), Grad_K1CM(3*Mxatms),
     &          Vec_K1C1(Mxatms*3),Grad_K0OM(3*Mxatms), Grad_stat(6)
c
c First check whether JOBARC/JAINDX present in the current directory.
c
      Call Gfname('ZMAT',   Fname, Length)
      Inquire(FILE=Fname(1:Length), EXIST=ZMT_Present)
      Call Gfname('GENBAS', Fname, Length)
      Inquire(FILE=Fname(1:Length), EXIST=GBS_Present)
  
      Call Gfname('JOBARC', Fname, Length)
      Inquire(FILE=Fname(1:Length), EXIST=JARC_Present) 
      Call Gfname('JAINDX', Fname, Length)
      Inquire(FILE=Fname(1:Length), EXIST=JNDX_Present)
      If (ZMT_Present .And. GBS_Present)   Can_Do_Aces = .True.
      If (JARC_Present .And. JNDX_Present) Ref_done    = .True. 
c 
      FlgACESGeom = .TRUE.
      Wrt_Extrnls = .TRUE.
      FlgACESElec = .FALSE.
      FlgACESGrad = .FALSE.
      FlgACESHess = .FALSE.
C

      If (Can_Do_Aces .And. .Not. Ref_done) Then
c 
c There is a reference ZMAT and GENBAS (minimum requiremnt for 
c an ACES calculations) Lets run the reference point. For PES scans
c on a user defined grid, the reference run is a single point 
c energy or gradient calculation. 
c
         Call Runit("runaces2a")
         call aces_init_rte
         call aces_com_parallel_aces
         call aces_ja_init
C
      Else if (Ref_done) Then
C
         Call aces_init_rte
         Call aces_com_parallel_aces
         Call aces_ja_init
C
      Endif 
C
      call getrec(1,'JOBARC','IFLAGS',   100,iflags)
      call getrec(1,'JOBARC','IFLAGS2',  500,iflags2)
      call getrec(1,'JOBARC','NREALATM', 1,  Nreals)
      Call Getrec(1,'JOBARC','ZMATATMS', 1,  Natoms)
      Call Getrec(1,'JOBARC','ATOMMASS', Natoms*IINTFP,AtmMass)
      Call Getrec(1,'JOBARC','UHFRHF  ', 1,iUHF)
      Call Getrec(1,'JOBARC','NIRREP  ', 1,NIrRep)
      Call Getrec(1,'JOBARC','MAP2ZMAT', Natoms,Imap)
      Call Getrec(20, 'JOBARC', 'LINEAR  ', 1, Iamlinear)
      Call Getcrec(1,'JOBARC','ZSYM',5*Natoms,AtmLabel)
C
      If (Iamlinear .EQ. 1) Then
         Nvibs = 3*Nreals - 5
      Else
         Nvibs = 3*Nreals - 6 
      Endif
c
CSSS      Call a2_reset_jarc()
C
      If (streaming) Then
C
C This is for direct dynamics runs. The reference point has alredy
C been run and the geometry of the point that need to be done is 
C pass from the dynamics program. 
c
         Call a2_reset_jarc()
C
#ifdef _DEBUG_LVL0
         Call Getrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP, 
     &               Coords)
         Write(6, "(3F10.5)") (Coords(i),i=1,3*Natoms)
C
         Ioff = 1
         Do Iatm = 1, 2
            Do Ixyz = 1, 3
               Coords(ioff) = (Coords(ioff)) + 0.01
               ioff = ioff + 1
            Enddo
         Enddo
         Write(6,*)
         Write(6, "(3F10.5)") (Coords(i),i=1,3*Natoms)
         Wrt_Extrnl = .True.
#endif
C
C Write the new incomming geometry. The next calculation is performed
C at this geometry.
C
         Call Putrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP,
     &               Coords)
         Call aces_ja_fin
C
C Run the point and read the energy and the gradients and Hessians
C if available. 
C
         Call Runit("runaces2b")
         Call aces_ja_init
C
#ifdef _DYNAMIC_MEMORY
         icrsiz = iflags(h_IFLAGS_mem)
         icore(1) = 0
         do while ((icore(1).eq.0).and.(icrsiz.gt.1000000))
            call aces_malloc(icrsiz,icore,i0)
            if (icore(1).eq.0) icrsiz = icrsiz - 1000000
         end do
         if (icore(1).eq.0) then
             print *, '@MAIN: unable to allocate at least ',
     &                 1000000,' integers of memory'
            call aces_exit(1)
         end if
         iatmMass = iocc + 16
         icoord   = iatmMass + 3*Natoms*iintfp
         ivgrad   = icoord   + 3*NAtoms*iintfp
         izgrad   = ivgrad   + 3*Nreals*iintfp
         ihess    = izgrad   + 3*Nreals*iintfp
         ifreq    = ihess    + 9*Natoms*Natoms*iintfp
         inex     = ifreq    + 3*Nreals*iintfp
#endif
C
         Call Get_flags(FlgACESElec, FlgACESGrad,  FlgACESHess,
     &                  FlgACESForc)
C
         Call A2read_Jarc(FlgACESGeom, FlgACESElec, FlgACESGrad,
     &                    FlgACESHess, FlgACESForc, Natoms, Nreals, 
     &                    Imap, Coords, A2Ener, AtmMass, AtmLabel, 
     &                    Rgrad, A2grad, Rhess, A2hess, Vomega, 
     &                    Omega, Iuhf, Nirrep, Nvibs, B2ang, 
     &                    Au2Invcm, Wrt_extrnls)
C
         Call a2_reset_jarc()
C
      Else if (Stationary) Then 
C
C This is primarily reserved for running single points calculations 
C on a grid. The grid can be given in a file or can be genrerated.
C The GIRD file (if not automatic) must be formatted file of Cartesian 
C coordinates. 
C
         Call A2get_gridnmlist(Grid_file, Nmbrof_gridpts)

C 1. GIRD can be user defined. If user defined, give the number
C    numbers of atoms (as in the reference ZMAT) whose coordinates
C    are changing (others are kept at the reference values).
C
C 2. Automatically generated on normal modes. The refence point
C    must be a frequency calculations. 
C
         If (Grid_file .NE. "NORMAL_MODES") Then

            Inquire(FILE=Grid_file,EXIST=Grid_file_Present)

            If (Grid_file_Present) Then
                Open(Unit=13, File=Grid_file, Form="FORMATTED",
     &               Status="OLD")
            Else
                Write(6, "(a,1x,a,a)") "The file", Grid_file, 
     &                                     "does not exsist." 
                Call Errex
            Endif 
C
            Call a2_reset_jarc()
            Do Ipts = 1, Nmbrof_gridpts 
C
C Get the point and write the JOBARC record
C
               Read(13, *, End=20)
               Do Iatm = 1, Natoms
                  Ioff = 3*(Iatm - 1)
                  Read(13,*,End=20) (Coords(Ioff + I), I=1, 3)
               Enddo
C       
#ifdef _DEBUG_LVL0
                Write(6,*)
                Write(6, "(a)") "Grid points read from Grid_file"
                Write(6, "(3F10.5)") (Coords(i),i=1,3*Natoms)
#endif
    
               Call Putrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP, 
     &                    Coords)
               Call aces_ja_fin
C
C Run the point and read the energy and the gradients 
C
               Call Runit("runaces2b")
               Call aces_ja_init
C
               Call Get_flags(FlgACESElec, FlgACESGrad,  FlgACESHess,
     &                        FlgACESForc)
C
C Extract the energy, gradients and Hessians (if they are in JOBARC).
C
               Call A2read_Jarc(FlgACESGeom, FlgACESElec, 
     &                          FlgACESGrad, FlgACESHess, 
     &                          FlgACESForc, Natoms, 
     &                          Nreals, Imap, Coords, A2Ener, 
     &                          AtmMass, AtmLabel, Rgrad, A2grad, 
     &                          Rhess, A2hess, Vomega, Omega, Iuhf, 
     &                          Nirrep, Nvibs, B2ang, Au2Invcm, 
     &                          Wrt_extrnls)
               Call a2_reset_jarc()
            Enddo
  20        Close(13)
C
         Else 
C
C This block handles scan along normal modes. The requirement is that
C refrence job is a vibrational frequency calculation. The displacement
C size and the length must be provided in PES_SCAN namelist.
C 
            Trans_state   = .False.
            Mass_weigh_nm = .True. 
            Mass_weigh_gr = .False. 
            Get_Hess      = .False.
            Get_Grad      = .False.
            Call Get_refvib_data(Coords, Norm_coords, Vomega, Omega,
     &                           AtmMass, AtmLabel, SymLabel, Coords,  
     &                           Btmp, A2grad, Rgrad, A2Hess, Rhess, 
     &                           Imap, Vib_Type, Nreals, Natoms, 
     &                           Nvibs, B2ang, Au2invcm, Trans_state, 
     &                           Mass_Weigh_nm, Mass_Weigh_gr, 
     &                           Get_hess, Get_Grad)

#ifdef _OBSOLETE
            Call Getrec(20, "JOBARC", "COORD  ", Natoms*3*IINTFP, 
     &                  Coords)
            Call Getrec(20, "JOBARC", "NORMCORD", 3*Nreals*3*Nreals*
     &                  IINTFP, Norm_coords)
            Call Getrec(20, "JOBARC", 'FORCECON', 3*Nreals*IINTFP, 
     &                  VOmega)
            Ivib = 0 
            Do Imode = 1, 3*Nreals
C        
               If (Vomega(Imode) .lt. 0.0D0) Then
                   Vomega(Imode) = - DSQRT(DABS(Vomega(Imode)))*
     &                             Au2Invcm
               Else
                   Vomega(Imode) = DSQRT(Vomega(Imode))*Au2Invcm
               Endif
C        
               If (DABS(Vomega(Imode)) .GT. 1.0D0) Then
                  Ivib = Ivib + 1
                  Omega(Ivib) = Vomega(Imode)
               Endif
C     
            Enddo
            Call Getcrec(20, "JOBARC", "VIB_SYMS", 3*Nreals*4, SymLabel)
C
            Call Dcopy(Natoms, AtmMass, 1, Btmp, 1)
            Ireal = 0
            Icord = 1
            Jcord = 1
            Do Iatom = 1, Natoms
               Icord = Icord + (Iatom - 1)*3 
               If (.Not. (Btmp(Iatom) .lt. 0.50D0)) Then
                  Ireal = Ireal + 1
                  Jcord = Jcord + (Ireal - 1)*3
                  AtmMass(Ireal) = Btmp(Iatom)
                  Call Dcopy(3, Coords(Icord), 1, Deltax(Jcord), 1)
             Endif
             Icord = 1
             Jcord = 1
            Enddo
C
            Do Iatom = 1, 3*Nreals
               SymLabel(Iatom) = SymLabel(6+Iatom)
            Enddo
            Ioff = (3*Nreals - Nvibs)*3*Nreals
            Do Imodes = 1, NVibs*3*Nreals
               Norm_coords(Imodes) = Norm_coords(Ioff + Imodes)
            Enddo 
C
            Ioff = 1
            Do Imodes = 1, Nvibs
               Do Iatoms = 1, Nreals
                  Sqrtmass = Dsqrt(AtmMass(Iatoms))
                  Do Ixyz = 1, 3
                    Norm_coords(Ioff) = Norm_coords(Ioff)*Sqrtmass
                    Ioff = Ioff + 1 
                  Enddo
               Enddo
            Enddo
#endif
C
            Call a2_reset_jarc()
C 
#ifdef _DEBUG_LVL0
            Write(6,*) 
            Write(6,*) "The vibrational frequencies and symmetries"
            Write(6, "(4F12.5,1x)") (Omega(I), I = 1, Nvibs)
            Write(6,*)
            Write(6, "(4a4)") (SymLabel(I), I = 1, Nvibs)
            Write(6,*)
            Write(6,*) "The reference geometry"
            Write(6, "(3F10.5)") (Coords(i),i=1,3*Natoms)
            Write(6,*) "Normal modes"
            Do I = 1, Nvibs
               Ioff = (I-1)*3*Nvibs
                  Write(6,"(3F10.5)") (Norm_coords(Ioff + k), k=1, 
     &                                 3*Nreals)
                  Write(6,*)
            Enddo
#endif
C
C The vibrational SCF, averaging etc and many other post electronic
C structure calcualtions depends on having PES on normal modes.
C
C V(q_1,q_2, ...,q_n) = E_0(q_1(0), q_2(0)..) + Sum_i(DE/dq_i)q_i + C                    Sum_ij(DE^2/dq_idq_j)q_iq_j + Sum_ijk(D^3E/dq_idq_jdq_k) C                    q_iq_jq_k + Sum_ijkl(D^4E/dq_idq_jdq_kdq_l)q_iq_jq_kq_l
C
C The curveture dependent dimensionless step size (JCP, 121, 1383. 2004).
C 
           
            Delx = 0.50D0
            Call Stpsize(Omega, Deltaq, Delx, Nvibs)
C
#ifdef _DEBUG_LVL0
         Write(6,"(a)") "Dimensionless step size will be"
         Write(6, "(4F15.5)") (Deltaq(I), I=1, Nvibs)
#endif
C
            Call Dscal(Nvibs, 0.0D0, Deltaq, 1)
            Call Dcopy(3*Nreals, Coords, 1, Deltax, 1)
            Call Run_ref(Deltaq, Deltax, Norm_coords, Nreals, 
     &                   Nvibs) 
C
            Call Get_flags(FlgACESElec, FlgACESGrad,  FlgACESHess,
     &                    FlgACESForc)

            Call A2read_Jarc(FlgACESGeom, FlgACESElec,
     &                       FlgACESGrad, FlgACESHess,
     &                       FlgACESForc, Natoms,
     &                       Nreals, Imap, Coords, A2Ener,
     &                       AtmMass, AtmLabel, Rgrad, A2grad,
     &                       Rhess, A2hess, Vomega, Omega, Iuhf, 
     &                       Nirrep, Nvibs, B2ang, Au2Invcm, 
     &                       Wrt_extrnls)
            Call a2_reset_jarc()

C
CSSS               Call Run_1st(Deltaq, Norm_coords, Nvibs)
       
CSSS               Call Run_2nd(Deltaq, Norm_coords, Nvibs)

         Endif
C
      Else If (Drive_IRC) Then
C
C If the starting point is the transition state, the fist pivot point 
C is half distance from the steepest decent path. The reference calculation
C is a vibrational frequnecy calculation of the transition state.
C
C **** Nature of the starting point must be read from the IRC namelist***
C
           Call Read_IRCnmlist(Stride, Trans_state, Direction, 
     &                         Max_IRC_Step)
           
           Forward = .TRUE.
           If (Direction .EQ. "REVERSE") Forward = .False.
C
           Mass_weigh_nm = .False. 
           Mass_weigh_gr = .True. 
           Get_Hess      = .True.
           Get_Grad      = .True. 
           Call Get_refvib_data(VCoords, Norm_coords, Vomega, Omega,
     &                          AtmMass, AtmLabel, SymLabel, Coords, 
     &                          Btmp, A2grad, Grad_K1CM, A2hess, Rhess, 
     &                          Imap, Vib_Type, Nreals, Natoms, Nvibs,  
     &                          B2ang, Au2Invcm, Trans_state, 
     &                          Mass_weigh_nm, Mass_weigh_gr, 
     &                          Get_hess, Get_grad)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,*) "The Hessian @-PES_scan"
      Call output(Rhess, 1, 3*Nreals, 1, 3*Nreals, 3*Nreals,
     &            3*Nreals, 1)
#endif
#ifdef _DEBUG_LVL0 
            Write(6,*)             
            Write(6,*) "The vibrational frequencies and symmetries"
            Write(6, "(4F12.5,1x)") (Omega(I), I = 1, Nvibs)
            Write(6,*)
            Write(6, "(4a4)") (SymLabel(I), I = 1, Nvibs)
            Write(6,*)
            Write(6,*) "The reference geometry"
            Write(6, "(3F10.5)") (Coords(i),i=1,3*Natoms)
            Write(6,*) "Normal modes"
            Do I = 1, Nvibs
               Ioff = (I-1)*3*Nvibs
                  Write(6,"(3F17.13)") (Norm_coords(Ioff + k), k=1, 
     &                                 3*Nreals)
                  Write(6,*)
            Enddo 
#endif      
C           
           Call Getrec(20,'JOBARC','TOTENERG', IINTFP, E_refrence)
           Call a2_reset_jarc()
C 
C The eigenvector corresponding to the negative eigenvalue (no longer
C mass weighted). Generate the pivot point: that is 1/2stride of 
C the steepest decent eigenvector (when the hessian is availabe). 
C Otherwise choose the largest gradient 
C
           N_Irc_step    = 0
           More_pts_left = .True.
           End_point     = .False.
           Begin_IRC     = .True.
           Opt_tol       = Iflags2(h_IFLAGS_convergence)
           Max_Cycles    = Iflags(h_IFLAGS_opt_maxcyc)
           Stride_total  = 0.0D0
           Stride_Tol    = 1.0D-04
           Ln_Intrp_Tol  = 5.0D0
           Hess_Eval_Tol = 1.0D-09
           Delta         = 5.0D-02
           lamsearch_TOl = 1.0D-16
           Binsearch_Tol = 1.0D-08
           Small         = 1.0D-05
           G_Cutoff      = 1.0D-04*(Stride/0.30D0)
           R_Cutoff      = 1.0D-03*(Stride/0.30D0)
           Units         = "Bohr"
           Halfs         = 0.50D0*Stride
C
           Do while (More_pts_left .AND. .NOT. End_point) 
C
              If (Begin_IRC) Then
C
                  If (Trans_state) Then 
                     Call Dcopy(3*Nreals, Norm_Coords, 1, 
     &                         Steep_DPath, 1)
C
                     Dpath_Norm = 0.0D0
                     Ioff       = 1
                     Do Iatom = 1, Nreals
                        Sqrtmass = Dsqrt(AtmMass(Iatom))
                        Do Ixyz = 1, 3
                           Dlen       = Steep_DPath(Ioff)*Sqrtmass
                           Dpath_Norm = Dlen*Dlen + Dpath_Norm 
                           Ioff = Ioff + 1 
                        Enddo
                     Enddo
#ifdef _DEBUG_LVL0   
            Write(6,*) 
            Write(6,*) "@-PES_scan The steepest decent path"
            Write(6, "(3F17.13)") (Steep_DPath(i),i=1,3*Nreals)
#endif
                     Dpath_Norm = DSqrt(Dpath_Norm)
C
                     If (Dpath_Norm .LT. Small) Then
                         Write(6,"(a,a,a)") "Norm of the ",
     &                                   " mass-weighted steepest",
     &                                   " decent path is too small."
                          Call Errex
                     Endif
C
                     Call Dscal(3*Nreals, 1.0D0/Dpath_Norm, 
     &                          Steep_DPath, 1)
C
                  Else
#ifdef _DEBUG_LVL0
            Write(6,*)
            Write(6,*) "Gradients for non saddle starting point"
            Write(6, "(3F17.13)") (Grad_K1CM(i),i=1,3*Nreals)
#endif
                     Grad_Norm = Ddot(3*Nreals, Grad_K1CM, 1, 
     &                                Grad_K1CM, 1)
C
                     Grad_Norm = Dsqrt(Grad_Norm)

                     If (Grad_norm .LT. Small/3.0D00) Then
                        Write(6,"(a,a,a,/,a)") " Gradient norm is too",
     &                                   " small, can not start from",
     &                                   " a stationary point except",
     &                                   " the transition state."
                         Call Errex
                     Endif 
C
                     Call Dscal(3*Nreals, -0.5D0*Stride/Grad_Norm, 
     &                          Grad_K1CM, 1)
#ifdef _DEBUG_LVL0
            Write(6,"(a,a)") "Normalized and scalled mass weighted ",
     &                      "Gradients for non saddle starting point"
            Write(6, "(3F17.13)") (Grad_K1CM(i),i=1,3*Nreals)
#endif
                     Ioff = 1
                     Do Iatom = 1, Nreals
                        Sqrtmass = Dsqrt(AtmMass(Iatom))
                        Do Ixyz = 1, 3
                           Grad_K1CM(Ioff) = Grad_K1CM(Ioff)/Sqrtmass
                           Ioff = Ioff + 1
                        Enddo
                     Enddo
#ifdef _DEBUG_LVL0
            Write(6,"(a,a)") "Normalized and scalled Gradients for ",
     &                       "non saddle starting point"
            Write(6, "(3F17.13)") (Grad_K1CM(i),i=1,3*Nreals)
#endif
C
                  Endif 
C                  
                  Step = 0.5D0*Stride
C
                  Imax = Idamax(3*Nreals, Steep_Dpath, 1)
C
                  If (Forward .AND. Steep_Dpath(Imax) .LT. 0.0D0) 
     &               Step = -1.0D0*Stride
                  If (.NOT. Forward .AND. Steep_Dpath(Imax) .GT.
     &               0.0D0)
     &               Step = -1.0D0*Stride
C
C _K0O is the pevious point, _K1P is the pivot point and _K1C is the 
C current point.
C
                  Call Dcopy(3*Nreals,        Coords,    1, 
     &                       Coords_K0O, 1)
                  Call Dcopy(3*Nreals,        Coords,    1, 
     &                       Coords_K1P, 1)
                  Call Dcopy(3*Nreals,        Coords,    1, 
     &                       Coords_K1C, 1)
C
                  If (Trans_state) Then
                      Call Daxpy(3*Nreals, Step,   Steep_DPath, 1, 
     &                           Coords_K1P, 1)
                      Call Daxpy(3*Nreals, 2.0D0*step, Steep_DPath,  
     &                           1, Coords_K1C, 1)
                      Call Dcopy(3*Nreals,        Coords_K1C,    1, 
     &                          Coords_K1CM, 1)
                  Else
                      Call Daxpy(3*Nreals, 1.0D0, Grad_K1CM, 1, 
     &                           Coords_K1P, 1)
                      Call Daxpy(3*Nreals, 2.0D0, Grad_K1CM, 1, 
     &                           Coords_K1C, 1)
                      Call Dcopy(3*Nreals,        Coords_K1C,    1, 
     &                           Coords_K1CM, 1)
                  Endif
 
#ifdef _DEBUG_LVL0
            Write(6,*)
            Write(6,*) "The current geometry"
            Write(6, "(3F17.13)") (Coords_K1C(i),i=1,3*Natoms)
            Write(6,*) "The pivot point geometry"
            Write(6, "(3F17.13)") (Coords_K1P(i),i=1,3*Natoms)
            Write(6,*) "The previous geometry"
            Write(6, "(3F17.13)") (Coords_K0O(i),i=1,3*Natoms)
#endif  
C
                  Ncycles    = 1 
                  N_IRC_Step = 1
                  Constr_Min = "Null "

                  Do While (.NOT. (Constr_Min .EQ. "Found") .AND.
     &                             Ncycles .Lt. Max_Cycles)
C
                           Call Constr_search(Coords_K0O, Coords_K1C, 
     &                                        Coords_K1P, Vcoords,
     &                                        Coords, Coords_K1CM, 
     &                                        A2grad, Grad_K1CM,  
     &                                        Grad_K0O, Grad_K0OM,
     &                                        A2Hess, Rhess, AtmMAss, 
     &                                        Vec_K1C0, Vec_K1C1,
     &                                        Vec_K0O, Grad_on_K0O, 
     &                                        Grad_on_K1C,
     &                                        Work, B2ang, Units,
     &                                        Stride, Delta, 
     &                                        Begin_IRC, New_IRC,
     &                                        Look4_IRC, Constr_Min,
     &                                        Imap, Ncycles, Nreals, 
     &                                        Natoms, Opt_Tol,
     &                                        Stride_Total, 
     &                                        Stride_Tol,  
     &                                        Ln_Intrp_Tol, 
     &                                        Hess_Eval_Tol, 
     &                                        Lamsearch_Tol,
     &                                        Binsearch_Tol,
     &                                        G_cutoff, R_Cutoff,
     &                                        E_currnt) 

#ifdef _DEBUG_LVL0
            Write(6,*) Ncycles, Constr_Min
            Write(6,*) "@-pes_scan, updated geoemtries"
            Write(6,*) "The previous geometry"
            Write(6, "(3F17.13)") (Coords_K0O(i),i=1,3*Nreals)
            Write(6,*) "The current geometry"
            Write(6, "(3F17.13)") (Coords_K1CM(i),i=1,3*Nreals)
            Write(6,*) "The pivot point geometry"
            Write(6, "(3F17.13)") (Coords_K1P(i),i=1,3*Nreals)
            Write(6,*) "The M.W. current gradient "
            Write(6, "(3F17.13)") (Grad_K1CM(i),i=1,3*Nreals)
            Write(6,*) "The N.M.W. current gradient "
            Write(6, "(3F17.13)") (A2grad(i),i=1,3*Nreals)
            Write(6, "(2F17.13)") E_refrence, E_currnt

#endif
                           Begin_IRC  = .False.
                           New_IRC    = .False.
                           Look4_IRC  = .True.
                           Ncycles    = Ncycles + 1
                  Enddo 
C
                  If (E_currnt .GT. E_refrence) Then
                      Write(6, "(a,a)") "Energy can not rise during a",
     &                              " downhill IRC search."
                      Call Errex
                  Else
                      E_refrence = E_currnt
                  Endif  

                  Begin_IRC  = .False.
                  New_IRC    = .True.
                  Look4_IRC  = .False.
              Else
C
C First check to make sure that we are not at a stationary point.
C
                  Call Vstat(A2grad, Grad_stat, 3*Nreals)

                  If (Grad_stat(1) .LT. Opt_tol .AND. 
     &                Grad_stat(5) .LT. Opt_tol/3.0D00) Then
                      Write(6,"(a,a,a,a)")"The RMS Gradient is below",
     &                                     "the tolerence. The last ",
     &                                     "IRC point is closer to  ",
     &                                     "a stationary point"
                        
                      End_point = .TRUE.
                  End if 
C 
C Generate the new pivot point using the gradient. Note that only the
C first step we have an exact Hessian. 
C 
                  Call Dcopy(3*Nreals, Coords_K1C, 1, Coords_K0O, 1)

                  Grad_length = Ddot(3*Nreals, Grad_K1CM, 1, 
     &                               Grad_K1CM, 1)
                  Call Dcopy(3*Nreals, Grad_K1CM, 1, Work, 1)
                  Call Dscal(3*Nreals, 1.0D0/Dsqrt(Grad_length), 
     &                       Work, 1)
#ifdef _DEBUG_LVL0
           Write(6,*) "The normalized M.W. current gradient"
           Write(6, "(3F17.13)") (Work(i),i=1,3*Nreals)
#endif
                  Ioff = 1
                  Do Iatom = 1, Nreals
                     Sqrtmass = Dsqrt(AtmMass(Iatom)) 
                     Do Ixyz = 1, 3
                        Work(Ioff) = Work(Ioff)/Sqrtmass
                        Ioff = Ioff + 1
                     Enddo
                  Enddo
C
                  Call Dscal(3*Nreals, -Halfs, Work, 1)
C
#ifdef _DEBUG_LVL0
           Write(6,*) "The gradient update"
           Write(6, "(3F17.13)") (Work(i),i=1,3*Nreals)
#endif
C
                  Call Dcopy(3*Nreals, Coords_K1C, 1, Coords_K1P, 1)
                  Call Daxpy(3*Nreals, 1.0D0, Work, 1, Coords_K1P, 1)
                  Call Dcopy(3*Nreals, Coords_K1P, 1, Coords_K1C, 1)
                  Call Daxpy(3*Nreals, 1.0D0, Work, 1, Coords_K1C, 1)
                  Call Dcopy(3*Nreals, Coords_K1C, 1, Coords_K1CM, 1)
C
#ifdef _DEBUG_LVL0
            Write(6,*) "The current geometry"
            Write(6, "(3F17.13)") (Coords_K1C(i),i=1,3*Nreals)
            Write(6,*) "The pivot point geometry"
            Write(6, "(3F17.13)") (Coords_K1P(i),i=1,3*Nreals)
            Write(6,*) "previous geometry"
            Write(6, "(3F17.13)") (Coords_K0O(i),i=1,3*Nreals)
#endif
C
                  N_IRC_Step = N_IRC_Step + 1
                  Ncycles    = 1
                  Constr_Min = "Null "

                  Do While (.NOT. (Constr_Min .EQ. "Found") .AND.
     &                             Ncycles .Lt. Max_Cycles)
C
                           Call Constr_search(Coords_K0O, Coords_K1C,
     &                                        Coords_K1P, Vcoords,
     &                                        Coords, Coords_K1CM,
     &                                        A2grad, Grad_K1CM,
     &                                        Grad_K0O, Grad_K0OM, 
     &                                        A2Hess, Rhess, AtmMAss,
     &                                        Vec_K1C0, Vec_K1C1, 
     &                                        Vec_K0O, Grad_on_K0O,
     &                                        Grad_on_K1C,
     &                                        Work, B2ang, Units,  
     &                                        Stride, Delta, 
     &                                        Begin_IRC, New_IRC,
     &                                        Look4_IRC, Constr_Min, 
     &                                        Imap, Ncycles, Nreals,
     &                                        Natoms, Opt_Tol,
     &                                        Stride_Total,
     &                                        Stride_Tol,
     &                                        Ln_Intrp_Tol,
     &                                        Hess_Eval_Tol,
     &                                        Lamsearch_Tol,
     &                                        Binsearch_Tol,
     &                                        G_Cutoff, R_Cutoff,
     &                                        E_currnt)
C
                           Begin_IRC  = .False.
                           New_IRC    = .False.
                           Look4_IRC  = .True.
                           Ncycles    = Ncycles + 1
                  Enddo
C
                  If (E_currnt .GT. E_refrence) Then
                      Write(6, "(a,a)") "Energy can not rise during a",
     &                              " downhill IRC search."
                      Call Errex
                  Else
                      E_refrence = E_currnt
                  Endif
C
                  Begin_IRC  = .False.
                  New_IRC    = .True.
                  Look4_IRC  = .False.      
C
                  If (N_IRC_Step .GT. Max_IRC_Step) 
     &                More_pts_left = .False.
C       
              Endif
C
           Enddo                     
C
      Endif
C
      Return
      End

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine read_grad(x, nindex, type, bval,
     *                              eval, bdim, edim)
c--------------------------------------------------------------------------
c   Divides each sample of the block given by the array argument by the 
c       eps = f_alpha(i)+f_beta(i)-f_alpha(a)-f_beta(a)
c--------------------------------------------------------------------------

      implicit none
      include 'interpreter.h'
      include 'epsilon.h'

      double precision x(*)
      integer nindex, type(*), bval(*), eval(*)
      integer bdim(*), edim(*)

      if (nindex .ne. 2) then
         print *,'Error in read_grad: ',
     *      'Gradient must be a 2-index array!.'
         print *,'array has ',nindex,' indices.'
         call abort_job()
      endif

      call add_grad(x,bval(1),eval(1),bval(2),eval(2))
      
      return
      end


      subroutine add_grad(x,iatoms,iatome,icomponents,icomponente)
      implicit none
      include 'parallel_info.h'
      include 'interpreter.h'
      include 'int_gen_parms.h'

      integer i,j,igrad  
      integer iatoms,iatome,icomponents,icomponente  
      double precision x(iatoms:iatome,icomponents:icomponente)

      if (me .ne. 0) return  

      igrad = (iatoms-1)*3 + icomponents 

      gradient_data(igrad) = gradient_data(igrad)+ x(iatoms,icomponents) 

      write(6,*) ' GRAD :', iatoms,icomponents,igrad 

33    format(3F16.8)

      return
      end

#define _IIII
#define _IIJJ
#define _IJIJ
c#define _ADD_H_AT_THE_VERY_END
c#define _PRINTCRAP

c THIS ROUTINE LOADS THE AO INTEGRALS FROM THE CORRESPONDING
c INTEGRAL FILE AND CONSTRUCTS THE FOCK MATRIX (ARRAY F) USING
c THE DENSITY MATRIX SUPPLIED IN D (UHF VERSION).
c
c COLOUMB TERMS:
c
c    FA(I,J) = FA(I,J) + DT(K,L) (IJ|KL)
c    FA(K,L) = FA(K,L) + DT(I,J) (IJ|KL)
c
c    FB(I,J) = FB(I,J) + DT(K,L) (IJ|KL)
c    FB(K,L) = FB(K,L) + DT(I,J) (IJ|KL)
c
c EXCHANGE TERMS:
c
c    FA(I,K) = FA(I,K) - 1/2 DA(J,L) (IJ|KL)
c    FA(J,L) = FA(J,L) - 1/2 DA(I,K) (IJ|KL)
c    FA(I,L) = FA(I,L) - 1/2 DA(J,K) (IJ|KL)
c    FA(J,K) = FA(J,K) - 1/2 DA(I,L) (IJ|KL)
c
c    FB(I,K) = FB(I,K) - 1/2 DB(J,L) (IJ|KL)
c    FB(J,L) = FB(J,L) - 1/2 DB(I,K) (IJ|KL)
c    FB(I,L) = FB(I,L) - 1/2 DB(J,K) (IJ|KL)
c    FB(J,K) = FB(J,K) - 1/2 DB(I,L) (IJ|KL)
c
c  J. GAUSS AND J.F. STANTON, QTP 1993
c  A. YAU AND A. PERERA, 2000 - MOLCAS integral file support

      SUBROUTINE MKUHFF(FA,FB,DA,DB,DT,H,BUF,IBUF,NTOTAL,
     &                  NBAST,NBAS,IMAP,ILNBUF,LUINT,ADDH,
     &                  naobasfn,iuhf,scfks,scfksexact,
     &                  scfkslastiter,
     &                  V,z1,ksa,ksb,
     &                  screxc,scr,scr2,
     &                  valao,valgradao,totwt,
     &                  max_angpts,natoms,
     &                  intnumradpts,ncount,kshf)

c   FA - SYMMETRY BLOCKED FOCK MATRIX (ALPHA)
c   FB - SYMMETRY BLOCKED FOCK MATRIX (BETA)
c   DA - SYMMETRY BLOCKED DENSITY MATRIX (ALPHA)
c   DB - SYMMETRY BLOCKED DENSITY MATRIX (BETA)
c   H  - SYMMETRY BLOCKED ONE-ELECTRON INTEGRALS
c
c   SEWARD:
c      BUF  - square-packed, unscaled density matrix
c             (vs. scaled, triangular-packed in D)
c      IBUF - work buffer for doubles, used like the array Work in
c             MOLCAS/ftwo.f
c             BEWARE: The compiler addresses this array as integers, so
c                     all the offset counters must be scaled by iintfp.
c                     In addition, you cannot (meaningfully) address any
c                     one element in the array, you must pass the
c                     address to a subroutine.
c      IMAP - NOT USED!!!
c      ILNBUF - maximum number of doubles that will fit in IBUF
c               (plug-in for GetMem(...,'MAX',...))
c   .NOT.SEWARD:
c      BUF  - BUFFER OF SIZE ILNBUF*IINTFP FOR INTEGRALS
c      IBUF - BUFFER OF SIZE ILNBUF FOR INDICES
c      IMAP - SYMMETRY VECTOR (FULL ARRAY -> SYMMETRY BLOCKED)
c      ILNBUF - BUFFER LENGTH
c
c   NTOTAL  - TOTAL LENGTH OF D AND F
c   NBAST   - TOTAL NUMBER OF BASIS FUNCTIONS
c   NBAS(I) - NUMBER OF BASIS FUNCTIONS IN IRREP I
c
c   LUINT - UNIT NUMBER FOR INTEGRAL FILE
c
c   ADDH - LOGICAL SWITCH FOR ADDING H TO F

c      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      IMPLICIT NONE
c
c ARGUMENT LIST
      INTEGER NTOTAL, NBAST, NBAS(8), ILNBUF, LUINT
      DOUBLE PRECISION FA(NTOTAL), FB(NTOTAL)
      DOUBLE PRECISION DA(NTOTAL), DB(NTOTAL), DT(NTOTAL)
      DOUBLE PRECISION H(NTOTAL), BUF(ILNBUF)
      INTEGER IBUF(ILNBUF), IMAP(NBAST,NBAST)
      LOGICAL ADDH
c
c---------------------------------------------------------------
#include<aces.h>
#include<intgrtflags.com>
c
       integer iuhf,naobasfn,ncount,natoms,max_angpts,
     &         intnumradpts
       logical scfks,scfksexact,scfkslastiter,kshf
       integer z1(naobasfn,2)
       double precision V(naobasfn,naobasfn,iuhf+1),   
     &                  ksa(NTOTAL),ksb(ntotal),
     &                  screxc(naobasfn,naobasfn),
     &                  scr(naobasfn,naobasfn,iuhf+1),
     &                  scr2(nbast,nbast),coef_nonloc,
     &                  valao(naobasfn,intnumradpts,
     &                        max_angpts,ncount),
     &                  valgradao(naobasfn,intnumradpts,
     &                            max_angpts,ncount,3),
     &                  totwt(ncount,intnumradpts,max_angpts)
c------------------------------------------------------------------
c INTERNAL VARIABLES FOR/FROM VMOL
      DOUBLE PRECISION X
      INTEGER I, J, K, L, IOFF, IOFFT
      INTEGER IJ, IK, IL, JK, JL, KL, INDI, INDJ, INDK, INDL
      INTEGER IRREP, INDS, ILENGTH
      INTEGER NAOBUF, NUMINT, NUT
      CHARACTER*80 FNAME
c INTERNAL VARIABLES FOR/FROM MOLCAS
      double precision DDot, Temp
      integer nSym, BetaOff,
     &        iSym, kSym, nBs, iBs, jBs, kBs, mBs,
     &        iRc, iOpt, lbuf, nSub,
     &        ijPairs, klPairs, nInts, lw2,
     &        ipInts, ipTri, ipSqr, jpTri, jpSqr, kpTri, kpSqr

c PARAMETERS
      DOUBLE PRECISION TWOM, ONEM, HALFM, ZERO, FOURTH, HALF, ONE, TWO
      PARAMETER (TWOM=-2.0D0, ONEM=-1.0D0)
      PARAMETER (HALFM=-0.5D0)
      PARAMETER (ZERO=0.0D0)
      PARAMETER (FOURTH=0.25D0, HALF=0.5D0)
      PARAMETER (ONE=1.0D0, TWO=2.0D0)

c COMMON BLOCKS
#include "molcas.com"
#include "machsp.com"
#include "flags.com"
cwc1
#include "icore.com"
      common /GMSdirect/ dirscf,fdiff,schwrz,pople,i011,i012,i013
      logical dirscf,fdiff,schwrz,pople
      integer i011,i012,i013
cwc0
#include "symm2.com" /* for nirrep and isqrln */
      INTEGER ITER
      COMMON /LOGBLOCK/ ITER

c FUNCTION DEFINITIONS
      INTEGER IAND,IOR,ISHFT
      INTEGER INT, IUPKI, IUPKJ, IUPKK, IUPKL, IPACK, INDX
      IUPKI(INT)=IAND(INT,IALONE)
      IUPKJ(INT)=IAND(ISHFT(INT,-IBITWD),IALONE)
      IUPKK(INT)=IAND(ISHFT(INT,-2*IBITWD),IALONE)
      IUPKL(INT)=IAND(ISHFT(INT,-3*IBITWD),IALONE)
      IPACK(I,J,K,L)=IOR(IOR(IOR(I,ISHFT(J,IBITWD)),
     &                             ISHFT(K,2*IBITWD)),
     &                             ISHFT(L,3*IBITWD))
      INDX(I,J)=J+(I*(I-1))/2

c---------------------------------------------------------------------
c prakash 23/04
           if ( scfks) then
               call dzero(ksa,ntotal)
               call dzero(ksb,ntotal)
            end if
c ----------------------------------------------------------------------

      if (petite_list) then
         nSym = NIRREP
c      o MOLCAS integrals are stored in upper-triangular, packed
c        form. Lucky for us, we too store the density and build the
c        Fock matrices in upper-packed form. A few notes:
c         1) At the end of VMOL integral processing, we scale the
c            whole Fock matrix up by 2 and then the on-diagonal
c            elements down by 1/2. Given the succinct way Seward
c            stores its integrals, we can accomplish all this work in
c            one (or two) fell swoop(s).
c         2) The exchange contributions use square density blocks
c            while the coulomb contributions use triangular-packed
c            blocks. Watch out for this if you intend on changing
c            stuff around.
c         3) I threw out the threshold processing found in the Molcas
c            SCF. If someone ever decides to put it back, then look
c            at $MOLCAS/src/scf/ftwo.f as a reference.
c      o In order to accomodate both Alpha and Beta square-packed
c        densities, we need to put them one-after-the-other in Buf().
c        The BetaOff variable USED WITH ANOTHER POINTER will accurately
c        point to elements in the square Beta density.
         BetaOff = ISQRLN(NIRREP+1)
         Do iSym = 1,nSym
            nBs = nBas(iSym)
            If (nBs.ne.0) Then
               ijPairs = ishft((nBs*(nBs+1)),-1)
c            o ALPHA
               Do i = 0,(ijPairs-1)
                  Buf(ipMat(iSym,lBBS)+i)=DA(ipMat(iSym,lBBT)+i)
               End Do
               Call SP2Sy(nBs,Buf(ipMat(iSym,lBBS)),nBs,'U',iOff)
               If (iOff.ne.0) Then
                  write(*,*) '@MKUHFF: There was a problem unpacking ',
     &                       'the alpha density.'
                  Call ErrEx
                  Stop 1
               End If
c            o BETA
               Do i = 0,(ijPairs-1)
                  Buf(BetaOff+ipMat(iSym,lBBS)+i)=DB(ipMat(iSym,lBBT)+i)
               End Do
               Call SP2Sy(nBs,Buf(BetaOff+ipMat(iSym,lBBS)),
     &                    nBs,'U',iOff)
               If (iOff.ne.0) Then
                  write(*,*) '@MKUHFF: There was a problem unpacking ',
     &                       'the beta density.'
                  Call ErrEx
                  Stop 1
               End If
            End If
         End Do
c      o collect DA and DB into DT
         Do i=1,ntotal
            DT(i)=DA(i)+DB(i)
         End Do
c      o initialize the Fock matrix
#ifdef _ADD_H_AT_THE_VERY_END
         Do i=1,ntotal
            FA(i)=ZERO
         End Do
         Do i=1,ntotal
            FB(i)=ZERO
         End Do
#else
         If (addh) Then
            Do i=1,ntotal
               FA(i)=H(i)
            End Do
            Do i=1,ntotal
               FB(i)=H(i)
            End Do
         Else
            Do i=1,ntotal
               FA(i)=ZERO
            End Do
            Do i=1,ntotal
               FB(i)=ZERO
            End Do
         End If
#endif /* _ADD_H_AT_THE_VERY_END */
      else
c      o initialize IMAP
         CALL IZERO(IMAP,NBAST*NBAST)
         IOFF=0
         IOFFT=0
         DO IRREP=1,NIRREP
            DO I=1,NBAS(IRREP)
               DO J=1,NBAS(IRREP)
                  INDS=INDX(MAX(I,J),MIN(I,J))+IOFFT
                  IMAP(I+IOFF,J+IOFF)=INDS
               END DO
            END DO
            IOFF=IOFF+NBAS(IRREP)
            IOFFT=IOFFT+NBAS(IRREP)*(NBAS(IRREP)+1)/2
         END DO
c      o initialize the Fock matrix
         DO I = 1,NTOTAL
            FA(I)=ZERO
         END DO
         DO I = 1,NTOTAL
            FB(I)=ZERO
         END DO
         CALL VADD(DT,DA,DB,NTOTAL,ONE)
cwc1
         if (dirscf) call SCFINT (.false.,FA,FB,DA,DB,icore(i013),
     >                 imap,nbast,ntotal,icore(i011),icore(i012))
cwc0
c     end if (seward)
      end if
c ----------------------------------------------------------------------

      if (petite_list) then

ccccccccccccccccccccccccccc
c START SEWARD PROCESSING c
ccccccccccccccccccccccccccc

c   o This stuff is ONLY for Coulomb contributions. It is unclear whether
c     the calling program uses the total density on output, so we will
c     unscale the array at the end to be safe.
      Do iSym = 1,nSym
         Call dDiagScal_SP('U','O',nBas(iSym),TWO,DT(ipMat(iSym,lBBT)))
      End Do

#ifdef _IIII
c   o (ii|ii) integrals
      Do iSym=1,nSym
         nBs=nBas(iSym)
         ijPairs=nBs*(nBs+1)/2
         klPairs=ijPairs
         nInts=ijPairs*klPairs
         If ( nInts.ne.0 ) Then
            lw2=(nBs*nBs+1)*iintfp
            lBuf=MIN(iLnBuf,nInts+1)
            lBuf=MAX(lBuf,klPairs+1)
            iOpt=1
            Call RdOrd(iRc,iOpt,iSym,iSym,iSym,iSym,
     &                 iBuf(lw2),lBuf,nSub)
            iOpt=2
            ipInts=0
            ipTri=ipMat(iSym,lBBT)
            ipSqr=ipMat(iSym,lBBS)
            Do iBs=1,nBs
               jpTri=ipMat(iSym,lBBT)
               jpSqr=ipMat(iSym,lBBS)
               Do jBs=1,iBs
                  If ( nSub.eq.0 ) Then
                     Call RdOrd(iRc,iOpt,iSym,iSym,iSym,iSym,
     &                          iBuf(lw2),lBuf,nSub)
                     ipInts=0
                  End If
                  iOff=ipTri+jBs-1
                  Temp=DDot(klPairs,iBuf(lw2+ipInts),1,
     &                              DT(ipMat(iSym,lBBT)),1)
                  Call Square(iBuf(lw2+ipInts),iBuf(1),1,nBs,nBs)
c               o ALPHA
                  FA(iOff)=FA(iOff)+Temp
                  Call DGeMV('N',jBs,nBs,
     &                       ONEM,iBuf(1),nBs,
     &                            Buf(ipSqr),1,
     &                       ONE, FA(jpTri),1)
                  If ( iBs.ne.jBs ) Call
     &               DGeMV('N',iBs,nBs,
     &                     ONEM,iBuf(1),nBs,
     &                          Buf(jpSqr),1,
     &                     ONE, FA(ipTri),1)
c               o BETA
                  FB(iOff)=FB(iOff)+Temp
                  Call DGeMV('N',jBs,nBs,
     &                       ONEM,iBuf(1),nBs,
     &                            Buf(BetaOff+ipSqr),1,
     &                       ONE, FB(jpTri),1)
                  If ( iBs.ne.jBs ) Call
     &               DGeMV('N',iBs,nBs,
     &                     ONEM,iBuf(1),nBs,
     &                          Buf(BetaOff+jpSqr),1,
     &                     ONE, FB(ipTri),1)
                  nSub=nSub-1
                  ipInts=ipInts+klPairs*iintfp
                  jpTri=jpTri+jBs
                  jpSqr=jpSqr+nBs
c              End Do jBs=1,iBs
               End Do
               ipTri=ipTri+iBs
               ipSqr=ipSqr+nBs
c           End Do iBs=1,nBs
            End Do
c        End If ( nInts.ne.0 )
         End If
c     End Do iSym=1,nSym
      End Do
#endif /* _IIII */

#ifdef _IIJJ
c   o (ii|jj) integrals, i>j
      Do iSym=2,nSym
         nBs=nBas(iSym)
         ijPairs=ishft((nBs*(nBs+1)),-1)
         Do kSym=1,iSym-1
            mBs=nBas(kSym)
            klPairs=ishft((mBs*(mBs+1)),-1)
            nInts=ijPairs*klPairs
            If ( nInts.ne.0 ) Then
               lBuf=MIN(iLnBuf,nInts+1)
               lBuf=MAX(lBuf,klPairs+1)
               iOpt=1
               Call RdOrd(iRc,iOpt,iSym,iSym,kSym,kSym,
     &                    iBuf(1),lBuf,nSub)
               iOpt=2
               ipInts=0
               ipTri=ipMat(iSym,lBBT)
               Do iBs=1,nBs
                  Do jBs=1,iBs
                     iOff=ipTri+jBs-1
                     If ( nSub.eq.0 ) Then
                        Call RdOrd(iRc,iOpt,iSym,iSym,kSym,kSym,
     &                             iBuf(1),lBuf,nSub)
                        ipInts=0
                     End If
                     Temp=DDot(klPairs,iBuf(1+ipInts),1,
     &                                 DT(ipMat(kSym,lBBT)),1)
                     FA(iOff)=FA(iOff)+Temp
                     FB(iOff)=FB(iOff)+Temp
                     Temp=DT(iOff)
                     Call dAXPY(klPairs,Temp,
     &                          iBuf(1+ipInts),1,
     &                          FA(ipMat(kSym,lBBT)),1)
                     Call dAXPY(klPairs,Temp,
     &                          iBuf(1+ipInts),1,
     &                          FB(ipMat(kSym,lBBT)),1)
                     nSub=nSub-1
                     ipInts=ipInts+klPairs*iintfp
                  End Do
                  ipTri=ipTri+iBs
               End Do
c           End If ( nInts.ne.0 )
            End If
c        End Do kSym=1,iSym-1
         End Do
c     End Do iSym=2,nSym
      End Do
#endif /* _IIJJ */

c   o Now that the Coulomb contributions are done, we "fix" the density.
c     I am not sure if we even need to do this since DT is never used
c     again in vscf, but there is no statement (such as INTENT=OUT)
c     that would suggest DT's permanence.
      Do iSym = 1,nSym
         Call dDiagScal_SP('U','O',nBas(iSym),HALF,DT(ipMat(iSym,lBBT)))
      End Do

#ifdef _IJIJ
c   o (ij|ij) integrals, i>j
      Do iSym=2,nSym
         nBs=nBas(iSym)
         Do kSym=1,iSym-1
            mBs=nBas(kSym)
            ijPairs=nBs*mBs
            klPairs=ijPairs
            nInts=ijPairs*klPairs
            If ( nInts.ne.0 ) Then
               lBuf=MIN(iLnBuf,nInts+1)
               lBuf=MAX(lBuf,klPairs+1)
               iOpt=1
               Call RdOrd(iRc,iOpt,iSym,kSym,iSym,kSym,
     &                    iBuf(1),lBuf,nSub)
               iOpt=2
               ipInts=0
               ipSqr=ipMat(iSym,lBBS)
               ipTri=ipMat(iSym,lBBT)
               Do iBs=1,nBs
                  kpSqr=ipMat(kSym,lBBS)
                  kpTri=ipMat(kSym,lBBT)
                  Do kBs=1,mBs
                     If ( nSub.eq.0 ) Then
                        Call RdOrd(iRc,iOpt,iSym,kSym,iSym,kSym,
     &                             iBuf(1),lBuf,nSub)
                        ipInts=0
                     End If
c                  o ALPHA
#ifdef _PRINTCRAP
      if (iter.ge.2) call
     &   dgemv_prt('N',kBs,nBs,
     &             ONEM,iBuf(1+ipInts),mBs,
     &                  Buf(ipSqr),1,
     &             ONE, FA(kpTri),1,
     &             'IJIJ(dgemv1):','FA',kpTri,1)
#endif /* _PRINTCRAP */
                     Call DGeMV('N',kBs,nBs,
     &                          ONEM,iBuf(1+ipInts),mBs,
     &                               Buf(ipSqr),1,
     &                          ONE, FA(kpTri),1)
#ifdef _PRINTCRAP
      if (iter.ge.2) call
     &   dgemv_prt('T',mBs,iBs,
     &             ONEM,iBuf(1+ipInts),mBs,
     &                  Buf(kpSqr),1,
     &             ONE, FA(ipTri),1,
     &             'IJIJ(dgemv2):','FA',ipTri,1)
#endif /* _PRINTCRAP */
                     Call DGeMV('T',mBs,iBs,
     &                          ONEM,iBuf(1+ipInts),mBs,
     &                               Buf(kpSqr),1,
     &                          ONE, FA(ipTri),1)
c                  o BETA
                     Call DGeMV('N',kBs,nBs,
     &                          ONEM,iBuf(1+ipInts),mBs,
     &                               Buf(BetaOff+ipSqr),1,
     &                          ONE, FB(kpTri),1)
                     Call DGeMV('T',mBs,iBs,
     &                          ONEM,iBuf(1+ipInts),mBs,
     &                               Buf(BetaOff+kpSqr),1,
     &                          ONE, FB(ipTri),1)
                     nSub=nSub-1
                     ipInts=ipInts+klPairs*iintfp
                     kpSqr=kpSqr+mBs
                     kpTri=kpTri+kBs
                  End Do
                  ipSqr=ipSqr+nBs
                  ipTri=ipTri+iBs
               End Do
c           End If ( nInts.ne.0 )
            End If
c        End Do kSym=1,iSym-1
         End Do
c     End Do iSym=2,nSym
      End Do
#endif /* _IJIJ */

c   o This is only for collecting terms from a parallel process.
c      Call GAdsum(F,NTOTAL)

ccccccccccccccccccccccccc
c END SEWARD PROCESSING c
ccccccccccccccccccccccccc

      else
cwc1
         if (dirscf) goto 999
cwc0

ccccccccccccccccccccccccc
c START VMOL PROCESSING c
ccccccccccccccccccccccccc

#ifdef _IIII
c IIII CONTRIBUTES TO BOTH COLOUMB AND EXCHANGE INTEGRALS
      CALL GFNAME('IIII    ',FNAME,ILENGTH)
      OPEN(UNIT=LUINT,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
     &     ACCESS='SEQUENTIAL')
      NAOBUF=0
      NUMINT=0
      CALL LOCATE(LUINT,'TWOELSUP')
 1    CONTINUE
         READ(LUINT) BUF, IBUF, NUT
         NAOBUF=NAOBUF+1
         DO INT=1,NUT
            X=BUF(INT)
            INDI=IUPKI(IBUF(INT))
            INDJ=IUPKJ(IBUF(INT))
            INDK=IUPKK(IBUF(INT))
            INDL=IUPKL(IBUF(INT))
            IJ=IMAP(INDJ,INDI)
            KL=IMAP(INDL,INDK)
            IK=IMAP(INDK,INDI)
            JL=IMAP(INDL,INDJ)
            IL=IMAP(INDL,INDI)
            JK=IMAP(INDJ,INDK)
            IF (INDI.EQ.INDJ) X=X*HALF
            IF (INDK.EQ.INDL) X=X*HALF
            IF (IJ.EQ.KL)     X=X*HALF
            FA(IJ)=FA(IJ)+DT(KL)*X
            FA(KL)=FA(KL)+DT(IJ)*X
            FB(IJ)=FB(IJ)+DT(KL)*X
            FB(KL)=FB(KL)+DT(IJ)*X

             if (scfks.AND. .not.scfkslastiter) then
                if(kshf) then
                   coef_pot_nonlocal=0.d0
                end if
                 if(coef_pot_nonlocal .ne.0.d0)then
                    coef_nonloc=coef_pot_nonlocal
                 else
                    goto 50
                 end if
             else
                 coef_nonloc=1.D0
            end if
 
            FA(IK)=FA(IK)+coef_nonloc*HALFM*DA(JL)*X
            FA(JL)=FA(JL)+coef_nonloc*HALFM*DA(IK)*X
            FA(IL)=FA(IL)+coef_nonloc*HALfM*DA(JK)*X
            FA(JK)=FA(JK)+coef_nonloc*HALFM*DA(IL)*X
            FB(IK)=FB(IK)+coef_nonloc*HALFM*DB(JL)*X
            FB(JL)=FB(JL)+coef_nonloc*HALFM*DB(IK)*X
            FB(IL)=FB(IL)+coef_nonloc*HALfM*DB(JK)*X
            FB(JK)=FB(JK)+coef_nonloc*HALFM*DB(IL)*X

  50     continue

         END DO
         NUMINT=NUMINT+NUT
      IF (NUT.NE.-1) GOTO 1
      CLOSE(UNIT=LUINT,STATUS='KEEP')
#endif /* _IIII */

c FOR NIRREP > 1, READ ALSO IIJJ AND IJIJ INTEGRAL FILES
      IF (NIRREP.GT.1) THEN

#ifdef _IIJJ
c IIJJ CONTRIBUTES ONLY TO COLOUMB INTEGRALS
         CALL GFNAME('IIJJ    ',FNAME,ILENGTH)
         OPEN(UNIT=LUINT,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
     &        ACCESS='SEQUENTIAL')
         NAOBUF=0
         NUMINT=0
         CALL LOCATE(LUINT,'TWOELSUP')
 101     CONTINUE
            READ(LUINT) BUF, IBUF, NUT
            NAOBUF=NAOBUF+1
            DO INT=1,NUT
               X=BUF(INT)
               INDI=IUPKI(IBUF(INT))
               INDJ=IUPKJ(IBUF(INT))
               INDK=IUPKK(IBUF(INT))
               INDL=IUPKL(IBUF(INT))
               IJ=IMAP(INDJ,INDI)
               KL=IMAP(INDL,INDK)
               IF (INDI.EQ.INDJ) X=X*HALF
               IF (INDK.EQ.INDL) X=X*HALF
               FA(IJ)=FA(IJ)+DT(KL)*X
               FA(KL)=FA(KL)+DT(IJ)*X
               FB(IJ)=FB(IJ)+DT(KL)*X
               FB(KL)=FB(KL)+DT(IJ)*X
            END DO
            NUMINT=NUMINT+NUT
         IF (NUT.NE.-1) GOTO 101
         CLOSE(UNIT=LUINT,STATUS='KEEP')
#endif /* _IIJJ */

#ifdef _IJIJ
c IJIJ CONTRIBUTES ONLY TO EXCHANGE
         CALL GFNAME('IJIJ    ',FNAME,ILENGTH)
         OPEN(UNIT=LUINT,FILE=FNAME(1:ILENGTH),FORM='UNFORMATTED',
     &        ACCESS='SEQUENTIAL')
         NAOBUF=0
         NUMINT=0
         CALL LOCATE(LUINT,'TWOELSUP')
 201     CONTINUE
            READ(LUINT) BUF, IBUF, NUT
            NAOBUF=NAOBUF+1
            DO INT=1,NUT
               X=BUF(INT)
               INDI=IUPKI(IBUF(INT))
               INDJ=IUPKJ(IBUF(INT))
               INDK=IUPKK(IBUF(INT))
               INDL=IUPKL(IBUF(INT))
               IJ=INDX(MAX(INDJ,INDI),MIN(INDJ,INDI))
               KL=INDX(MAX(INDL,INDK),MIN(INDL,INDK))
               IK=IMAP(INDK,INDI)
               JL=IMAP(INDL,INDJ)
#ifdef _PRINTCRAP
               TEMP=ONE
               IF (IJ.EQ.KL) TEMP=HALF
               if (iter.eq.2) write(*,'(A,I2,3(A,F10.6))')
     &              "FA(",IK,") += ",X,' * ',DA(JL)," * ",-TEMP
               if (iter.eq.2) write(*,'(A,I2,3(A,F10.6))')
     &              "FA(",JL,") += ",X,' * ',DA(IK)," * ",-TEMP
               X=X*TEMP
#else
               IF (IJ.EQ.KL) X=X*HALF
#endif /* _PRINTCRAP */

C____________________________________________________________________
                if (scfks  .and. .not. scfkslastiter) then
                   if(kshf) then
                     coef_pot_nonlocal=0.d0
                   end if           
                   if (coef_pot_nonlocal .ne.0d0) then
                       coef_nonloc=coef_pot_nonlocal
                   else
                       goto 60
                   end if
                else
                   coef_nonloc=1.d0
                end if

               FA(IK)=FA(IK)+coef_nonloc*HALFM*DA(JL)*X
               FA(JL)=FA(JL)+coef_nonloc*HALFM*DA(IK)*X
               FB(IK)=FB(IK)+coef_nonloc*HALFM*DB(JL)*X
               FB(JL)=FB(JL)+coef_nonloc*HALFM*DB(IK)*X

   60        continue
 
            END DO
            NUMINT=NUMINT+NUT
         IF (NUT.NE.-1) GOTO 201
         CLOSE(UNIT=LUINT,STATUS='KEEP')
#endif /* _IJIJ */

c     END IF (NIRREP.GT.1)
      END IF
cwc1
 999  continue

cwc0
c SCALE DIAGONAL PARTS OF F BY A FACTOR OF TWO
      CALL SCALEF(FA,NTOTAL,NBAS)
      CALL SCALEF(FB,NTOTAL,NBAS)
      CALL XSCAL(NTOTAL,TWO,FA,1)
      CALL XSCAL(NTOTAL,TWO,FB,1)


C-----------------------------------------------------------------
C ks terms
         if(scfks.AND. .not. scfkslastiter) then
         if(iter.gt.1)then
           call dzero(V,naobasfn*naobasfn*(1+iuhf))
           call integxc(V,z1,screxc,scr,scfkslastiter,
     &                valao,valgradao,totwt,
     &       intnumradpts,max_angpts,ncount,kshf)
           call mat_trans(MAT_FULL,MAT_TRI,v(1,1,1),ksa,0)
           call mat_trans(MAT_FULL,MAT_TRI,v(1,1,2),ksb,0)
           call B_AXPY(NTOTAL,one,ksa,1,FA,1)
           call B_AXPY(NTOTAL,one,ksb,1,FB,1)
         end if
         end if
C end prakash
C________________________________________________________________

#ifndef _ADD_H_AT_THE_VERY_END
c ADD THE 1-ELECTRON CONTRIBUTION
      IF (ADDH) THEN
         CALL XAXPY(NTOTAL,ONE,H,1,FA,1)
         CALL XAXPY(NTOTAL,ONE,H,1,FB,1)
      END IF
#endif /* _ADD_H_AT_THE_VERY_END */

ccccccccccccccccccccccc
c END VMOL PROCESSING c
ccccccccccccccccccccccc

c     end if (seward)
      end if

#ifdef _PRINTCRAP
      if (seward) then
         call realprt(buf,betaoff)
     end if
      write(*,*) "The alpha density matrix:"
      call realprt(DA,ntotal)
      write(*,*) "The beta density matrix:"
      call realprt(DB,ntotal)
      write(*,*) "The alpha Fock matrix:"
      call realprt(FA,ntotal)
      write(*,*) "The beta Fock matrix:"
      call realprt(FB,ntotal)
#endif /* _PRINTCRAP */

c      if (ITER.eq.2) stop 1

#ifdef _ADD_H_AT_THE_VERY_END


c ADD THE 1-ELECTRON CONTRIBUTION
      IF (ADDH) THEN
         CALL XAXPY(NTOTAL,ONE,H,1,FA,1)
         CALL XAXPY(NTOTAL,ONE,H,1,FB,1)
      END IF
#endif /* _ADD_H_AT_THE_VERY_END */
c
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
         SUBROUTINE  NLO__ROTATE_OGROUP_NBO
     +
     +                    ( NBAS,NATOM,NSYM,
     +                      NBOSIZE,
     +                      NXB,NXA,NXBA,
     +                      ATXIDX,ATXOFF,
     +                      DSYMACC,LSYMACC,QSYMACC,
     +                      NPAIR,
     +                      IDXSYM,
     +                      C3AXIS,C4AXIS,
     +                      NBOBD,
     +                      P,
     +                      LOCAL,
     +                      W,Q,
     +                      DOMAT,
     +                      XVEC,
     +                      XMAT,
     +
     +                              SYMNBO,
     +                              SLTYPE,
     +                              BDNBAS,
     +                              BDBAS,
     +                              B,
     +                              C )
     +
C------------------------------------------------------------------------
C  OPERATION   : NLO__ROTATE_OGROUP_NBO
C  MODULE      : Natural Localized Orbitals
C  MODULE-ID   : NLO
C  DESCRIPTION : This routine rotates an octahedral set (six or eight)
C                of two-fold interaction order degenerate atomic NBOs,
C                such that they become equivalent under operations of
C                the octahedral groups O and Oh.
C
C                The first step is to divide the set into three (if on
C                C4 axis) or four (if on C3 axis) pairs and rotating
C                each pair of degenerate atomic NBOs such that their
C                lobes match and form rectangular angles between them
C                (for the mathematics on how this is done, please see
C                the corresponding NBO pair rotation routine):
C
C
C
C                                                  x
C                       x  *                       *
C                        x *    x                  x
C                         x* x                     *
C                    ******x******   ---->   x**x**x**x**x
C                        x *x                      *
C                     x    * x                     x
C                          *  x                    *
C                                                  x
C
C
C
C                In the octahedral case such an arrangement of the lobes
C                is well defined, as long as the pair of degenerate
C                NBOs is not sitting opposite to each other. If they
C                would be opposite then there is obviously an infinite
C                amount of such arrangements in space.
C
C                For both cases (C3 and C4 axis) we have to choose
C                the pairs such that they all are on neighboring atomic
C                centers, which can be done by using the 'distance'
C                criterion transmitted via the distance order matrix.
C
C                Consider the C3 case. Here we know that the 8 atomic
C                centers are sitting on the vertices of a cube:
C
C
C
C                                   1---------2
C                                  /|        /|
C                                 / |       / |
C                                /  |      /  |
C                               5---------6   |
C                               |   |     |   |
C                               |   3-----|---4
C                               |  /      |  /
C                               | /       | /
C                               |/        |/
C                               7---------8
C
C
C                Permissible sets of atomic center pairs would be:
C
C                        (1 2) , (3 4) , (5 6) , (7 8)
C
C                                      or
C
C                        (1 5) , (2 6) , (3 7) , (4 8)
C
C                The algorithm used here to establish such a set is
C                as follows:
C
C                    i) Pick any center, say  # 4
C                   ii) Find one nearest neighbor, say # 8
C                  iii) Find all nearest neighbors for the pair (4 8)
C                       -> # 2,3,6,7
C                   iv) Among the set 2,3,6,7 find the nearest neighbor
C                       to # 2 -> # 6. Thus we have the pairs (2 6)
C                       and (3 7)
C                    v) The remaining # 1 and # 5 form the last pair
C                       (1 5)
C
C
C                For the C4 case we know that the 6 atomic centers are
C                sitting on the vertices of an octahedron (looking
C                from above, # 6 hidden):
C
C
C                               1-------------------2
C                               |*        |        *|
C                               |  *      |      *  |
C                               |    *    |    *    |
C                               |      *  |  *      |
C                               |        *|*        |
C                               |---------3---------|
C                               |        *|*        |
C                               |      *  |  *      |
C                               |    *    |    *    |
C                               |  *      |      *  |
C                               |*        |        *|
C                               4-------------------5
C
C
C                A slightly different algorithm must be used to
C                establish the 3 nearest neighbor pairs:
C
C                    i) Pick any center, say # 3
C                   ii) Find one nearest neighbor, say # 5,
C                       thus having the first pair (3 5)
C                  iii) Choose any nearest neighbor of # 5
C                       but excluding the center opposite (farthest
C                       away) to # 3, say # 2
C                   iv) Find any nearest neighbor of # 2, say # 6,
C                       thus having the second pair (2 6)
C                    v) The remaining # 1 and # 5 form the last pair
C                       (1 4)
C      
C
C                For the C4 case the story ends here, as the rotated
C                pairs of degenerate atomic NBOs transform properly
C                under C4. For the C3 case however we need to proceed
C                further and try to construct sp2 hybrids that will
C                transform properly under C3.
C
C
C
C                  Input:
C
C                    NBAS         =  total # of AO's in AO basis
C                    NATOM        =  total # of atomic centers
C                    NSYM         =  # of atomic centers related
C                                    by symmetry
C                    NBOSIZE      =  maximum # of NHOs that will
C                                    participate in forming a NBO.
C                    NXB          =  total # of atomic x-type NBOs.
C                    NXA          =  total # of atomic x-type NBO atoms.
C                    NXBA         =  # of atomic x-type NBOs on one of
C                                    the octahedrally related atoms.
C                    ATXIDX (A)   =  atomic index for x-type NBO atom A.
C                    ATXOFF (A)   =  index offset for atomic NBOs for
C                                    x-type NBO atom A. This index is
C                                    equal to the total number of atomic
C                                    x-type NBOs on all x-type NBO atoms
C                                    preceeding x-type NBO atom A.
C                    DSYMACC      =  symmetry accuracy for distance
C                                    order matrix values
C                    LSYMACC      =  symmetry accuracy for orbital
C                                    localization contents
C                    QSYMACC      =  symmetry accuracy for orbital
C                                    interaction order values (sum of
C                                    squares of offdiagonal occupation
C                                    matrix elements for one orbital)
C                    NPAIR        =  local atomic index of the two-fold
C                                    weight degenerate atomic NBOs.
C                                    For each atom the local atomic
C                                    indices for the degenerate pair
C                                    are NPAIR and NPAIR+1.
C                    IDXSYM       =  array that contains the six or
C                                    eight octahedrally related x-type
C                                    NBO atomic indices.
C                    CxAXIS       =  is true, if the symmetry related
C                                    atomic centers are sitting on a
C                                    rotational Cx axis (x=3 or 4)
C                    NBOBD (I)    =  contains the NHO bond index number
C                                    for the I-th atomic x-type NBO.
C                                    This array is the handle for
C                                    accessing and modifying info of
C                                    the NHO bonds sitting in the
C                                    arrays BDNCEN,BDCEN,BDBAS and
C                                    BDOCC.
C                    P            =  full NBAS x NBAS occupation matrix.
C                    LOCAL        =  atomic localization content for
C                                    all NBOs on one of the 6 or 8
C                                    atoms.
C                    W            =  NBO weight vector at present stage
C                                    of symmetrization for all NBOs
C                                    on one of the 6 or 8 atoms.
C                    Q            =  NBO interaction order vector at
C                                    present stage of symmetrization
C                                    for all NBOs on one of the 6 or
C                                    8 atoms.
C                    DOMAT (A,B)  =  distance order matrix containing
C                                    'distance' info between atoms A
C                                    and B.
C                    XVEC         =  flp scratch array of vector type.
C                    XMAT         =  flp scratch array of matrix type.
C                    SYMNBO       =  initial integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  initial integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  initial # of basis functions (NHOs)
C                                    for J-th bond. The bond order is
C                                    NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    BDBAS (I,J)  =  initial I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  initial NBOSIZE x NXB matrix
C                                    containing the J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  initial NBAS x NXB section of the
C                                    NBO coefficient matrix in AO basis
C                                    before symmetrization corresponding
C                                    to the x-type NBOs treated here.
C
C
C                  Output:
C
C                    SYMNBO       =  updated integer vector indicating
C                                    the different symmetry stages of
C                                    each NBO (=0 means no symmetry
C                                    adaptation, =1 means hybridization
C                                    was performed, =2 means symmetry
C                                    adapted in final form). This array
C                                    is extremely useful for deciding
C                                    which NBOs can be used for the
C                                    symmetry adaptation at different
C                                    stages. Note that only NBOs with
C                                    SYMNBO = 2 can be considered for
C                                    that purpose.
C                    SLTYPE       =  updated integer vector indicating
C                                    the smallest angular momentum
C                                    component present in the NBOs.
C                                    Useful for deciding which atomic
C                                    NBOs to use for hybrid formation.
C                                    Once an atomic NBO has been used
C                                    for hybrid formation, a -1 will
C                                    be placed at the corresponding
C                                    vector position and the NBO cannot
C                                    be used again for hybrid formation.
C                    BDNBAS (J)   =  modified # of basis functions
C                                    (NHOs) for J-th bond. The bond
C                                    order is NHB-bonds/NCB/NRB. Note
C                                    that the # of NHB-bonds might
C                                    be < NHB size.
C                    BDBAS (I,J)  =  modified I-th global basis (NHO)
C                                    index for J-th bond. The bond order
C                                    is NHB-bonds/NCB/NRB. Note that the
C                                    # of NHB-bonds might be < NHB size.
C                    B (I,J)      =  modified NBOSIZE x NXB matrix
C                                    containing the J-th symmetry
C                                    adapted x-type NBO expansion
C                                    coefficients in terms of the I-th
C                                    atomic NHOs forming the J-th
C                                    symmetry adapted x-type NBO.
C                    C            =  modified NBAS x NXB section of the
C                                    NBO coefficient matrix in AO basis
C                                    corresponding to the symmetrized
C                                    x-type NBOs treated here.
C
C
C  AUTHOR      : Norbert Flocke
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT    NONE

         LOGICAL     ALARM
         LOGICAL     C3AXIS,C4AXIS
         LOGICAL     HYBRID

         INTEGER     ATOM1,ATOM2,ATOM3,ATOM4,ATOM5,ATOM6,ATOM7,ATOM8
         INTEGER     BDS1,BDS2,BDS3,BDS4,BDS5,BDS6,BDS7,BDS8
         INTEGER     BDP1X,BDP2X,BDP3X,BDP4X,BDP5X,BDP6X,BDP7X,BDP8X
         INTEGER     BDP1Y,BDP2Y,BDP3Y,BDP4Y,BDP5Y,BDP6Y,BDP7Y,BDP8Y
         INTEGER     I
         INTEGER     INDEX
         INTEGER     NBAS,NATOM,NSYM
         INTEGER     NBOSIZE
         INTEGER     NHOS1,NHOS2,NHOS3,NHOS4,NHOS5,NHOS6,NHOS7,NHOS8
         INTEGER     NHOP1X,NHOP2X,NHOP3X,NHOP4X,
     +               NHOP5X,NHOP6X,NHOP7X,NHOP8X
         INTEGER     NHOP1Y,NHOP2Y,NHOP3Y,NHOP4Y,
     +               NHOP5Y,NHOP6Y,NHOP7Y,NHOP8Y
         INTEGER     NLEFT
         INTEGER     NLO__ANGULAR_MOMENTUM_NBO
         INTEGER     NPAIR
         INTEGER     NXB,NXA,NXBA
         INTEGER     OFF1,OFF2,OFF3,OFF4,OFF5,OFF6,OFF7,OFF8
         INTEGER     P1,P2,P3,P4,P5,P6,P7,P8
         INTEGER     S1,S2,S3,S4,S5,S6,S7,S8
         INTEGER     TOTSYM

         INTEGER     ATXIDX  (1:NXA )
         INTEGER     ATXOFF  (1:NXA )
         INTEGER     BDNBAS  (1:NBAS)
         INTEGER     IDXSYM  (1:NSYM)
         INTEGER     LEFT    (1:4   )
         INTEGER     NBOBD   (1:NXB )
         INTEGER     SLTYPE  (1:NXB )
         INTEGER     SYMNBO  (1:NXB )

         INTEGER     BDBAS   (1:NBOSIZE,1:NBAS)

         DOUBLE PRECISION  COS1,COS2,COS3,COS4,COS5,COS6,COS7,COS8
         DOUBLE PRECISION  D1,D2,D3,D4
         DOUBLE PRECISION  DMAX,DMIN,DIFF
         DOUBLE PRECISION  DSYMACC,LSYMACC,QSYMACC
         DOUBLE PRECISION  SIN1,SIN2,SIN3,SIN4,SIN5,SIN6,SIN7,SIN8
         DOUBLE PRECISION  ZERO,SQR2TH

         DOUBLE PRECISION  LOCAL (1:NXBA)
         DOUBLE PRECISION  Q     (1:NXBA)
         DOUBLE PRECISION  W     (1:NXBA)
         DOUBLE PRECISION  XVEC  (1:NBAS)

         DOUBLE PRECISION  HYB1  (1:3,1:3)
         DOUBLE PRECISION  HYB2  (1:3,1:3)
         DOUBLE PRECISION  HYB3  (1:3,1:3)
         DOUBLE PRECISION  HYB4  (1:3,1:3)
         DOUBLE PRECISION  HYB5  (1:3,1:3)
         DOUBLE PRECISION  HYB6  (1:3,1:3)
         DOUBLE PRECISION  HYB7  (1:3,1:3)
         DOUBLE PRECISION  HYB8  (1:3,1:3)

         DOUBLE PRECISION  B     (1:NBOSIZE,1:NXB  )
         DOUBLE PRECISION  C     (1:NBAS   ,1:NXB  )
         DOUBLE PRECISION  P     (1:NBAS   ,1:NBAS )
         DOUBLE PRECISION  DOMAT (1:NATOM  ,1:NATOM)
         DOUBLE PRECISION  XMAT  (1:NBAS   ,1:2    )

         PARAMETER  (ZERO   = 0.D0)
         PARAMETER  (SQR2TH = 0.70710678118654752440084436210484909D0)
C
C
C------------------------------------------------------------------------
C
C
C             ...decide on the case.
C
C
         IF (C3AXIS) THEN
C
C
C             ...the C3 axis (cubical background) case. Establish the
C                four nearest neighbor atomic center pairs (P1 P2),
C                (P3 P4), (P5 P6), (P7 P8).
C
C
             P1 = IDXSYM (1)
             P2 = 0
             P3 = 0
             P4 = 0
             P5 = 0
             P6 = 0
             P7 = 0
             P8 = 0

             ATOM1 = ATXIDX (P1)

             DMAX = ZERO
             DMIN = DOMAT (ATOM1,ATOM1)
             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                ATOM2 = ATXIDX (INDEX)
                DMAX = MAX (DOMAT (ATOM2,ATOM1),DMAX)
                DMIN = MIN (DOMAT (ATOM2,ATOM1),DMIN)
             END DO

             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                ATOM2 = ATXIDX (INDEX)
                DIFF = ABS (DMAX - DOMAT (ATOM2,ATOM1))
                IF (DIFF.LT.DSYMACC) THEN
                    P2 = INDEX
                END IF
             END DO

             ATOM2 = ATXIDX (P2)

             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                IF (INDEX.NE.P2) THEN
                    ATOM3 = ATXIDX (INDEX)
                    DIFF = ABS (DMIN - DOMAT (ATOM3,ATOM1))
                    IF (DIFF.LT.DSYMACC) THEN
                        P7 = INDEX
                    END IF
                    DIFF = ABS (DMIN - DOMAT (ATOM3,ATOM2))
                    IF (DIFF.LT.DSYMACC) THEN
                        P8 = INDEX
                    END IF
                END IF
             END DO

             ATOM7 = ATXIDX (P7)
             ATOM8 = ATXIDX (P8)

             NLEFT = 0
             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                IF (INDEX.NE.P2.AND.INDEX.NE.P7.AND.INDEX.NE.P8) THEN
                    NLEFT = NLEFT + 1
                    LEFT (NLEFT) = INDEX
                END IF
             END DO

             P3 = LEFT (1)
             ATOM3 = ATXIDX (P3)

             DO I = 2,NLEFT
                INDEX = LEFT (I)
                ATOM4 = ATXIDX (INDEX)
                DIFF = ABS (DMAX - DOMAT (ATOM4,ATOM3))
                IF (DIFF.LT.DSYMACC) THEN
                    P4 = INDEX
                END IF
             END DO

             ATOM4 = ATXIDX (P4)

             DO I = 2,NLEFT
                INDEX = LEFT (I)
                IF (INDEX.NE.P4) THEN
                    ATOM5 = ATXIDX (INDEX)
                    DIFF = ABS (DMIN - DOMAT (ATOM5,ATOM3))
                    IF (DIFF.LT.DSYMACC) THEN
                        P5 = INDEX
                    END IF
                    DIFF = ABS (DMIN - DOMAT (ATOM5,ATOM4))
                    IF (DIFF.LT.DSYMACC) THEN
                        P6 = INDEX
                    END IF
                END IF
             END DO

             ATOM5 = ATXIDX (P5)
             ATOM6 = ATXIDX (P6)

             D1 = DOMAT (ATOM1,ATOM2)
             D2 = DOMAT (ATOM3,ATOM4)
             D3 = DOMAT (ATOM5,ATOM6)
             D4 = DOMAT (ATOM7,ATOM8)

             ALARM = (P1.EQ.0) .OR. (P2.EQ.0) .OR.
     +               (P3.EQ.0) .OR. (P4.EQ.0) .OR.
     +               (P5.EQ.0) .OR. (P6.EQ.0) .OR.
     +               (P7.EQ.0) .OR. (P8.EQ.0) .OR.
     +               (ABS (DMAX - D1).GT.DSYMACC) .OR.
     +               (ABS (DMAX - D2).GT.DSYMACC) .OR.
     +               (ABS (DMAX - D3).GT.DSYMACC) .OR.
     +               (ABS (DMAX - D4).GT.DSYMACC)

             IF (ALARM) THEN
                 WRITE (*,*) ' Problems finding octahedral C3 pairs! '
                 WRITE (*,*) ' P1,P2,P3,P4,P5,P6,P7,P8 = ',
     +                         P1,P2,P3,P4,P5,P6,P7,P8
                 WRITE (*,*) ' Overlap orders #1,2,3,4,max = ',
     +                         D1,D2,D3,D4,DMAX
                 WRITE (*,*) ' nlo__rotate_ogroup_nbo '
                 WRITE (1,*) ' Problems finding octahedral C3 pairs! '
                 WRITE (1,*) ' P1,P2,P3,P4,P5,P6,P7,P8 = ',
     +                         P1,P2,P3,P4,P5,P6,P7,P8
                 WRITE (1,*) ' Overlap orders #1,2,3,4,max = ',
     +                         D1,D2,D3,D4,DMAX
                 WRITE (1,*) ' nlo__rotate_ogroup_nbo '
                 STOP
             END IF
C
C
C             ...rotate the four pairs into appropriate positions
C                by calling four times the pair rotation routine.
C
C
             OFF1 = ATXOFF (P1)
             OFF2 = ATXOFF (P2)
             OFF3 = ATXOFF (P3)
             OFF4 = ATXOFF (P4)
             OFF5 = ATXOFF (P5)
             OFF6 = ATXOFF (P6)
             OFF7 = ATXOFF (P7)
             OFF8 = ATXOFF (P8)

             P1 = OFF1 + NPAIR
             P2 = OFF2 + NPAIR
             P3 = OFF3 + NPAIR
             P4 = OFF4 + NPAIR
             P5 = OFF5 + NPAIR
             P6 = OFF6 + NPAIR
             P7 = OFF7 + NPAIR
             P8 = OFF8 + NPAIR

             BDP1X = NBOBD (P1  )
             BDP1Y = NBOBD (P1+1)
             BDP2X = NBOBD (P2  )
             BDP2Y = NBOBD (P2+1)
             BDP3X = NBOBD (P3  )
             BDP3Y = NBOBD (P3+1)
             BDP4X = NBOBD (P4  )
             BDP4Y = NBOBD (P4+1)
             BDP5X = NBOBD (P5  )
             BDP5Y = NBOBD (P5+1)
             BDP6X = NBOBD (P6  )
             BDP6Y = NBOBD (P6+1)
             BDP7X = NBOBD (P7  )
             BDP7Y = NBOBD (P7+1)
             BDP8X = NBOBD (P8  )
             BDP8Y = NBOBD (P8+1)

             NHOP1X = BDBAS (1,BDP1X)
             NHOP1Y = BDBAS (1,BDP1Y)
             NHOP2X = BDBAS (1,BDP2X)
             NHOP2Y = BDBAS (1,BDP2Y)
             NHOP3X = BDBAS (1,BDP3X)
             NHOP3Y = BDBAS (1,BDP3Y)
             NHOP4X = BDBAS (1,BDP4X)
             NHOP4Y = BDBAS (1,BDP4Y)
             NHOP5X = BDBAS (1,BDP5X)
             NHOP5Y = BDBAS (1,BDP5Y)
             NHOP6X = BDBAS (1,BDP6X)
             NHOP6Y = BDBAS (1,BDP6Y)
             NHOP7X = BDBAS (1,BDP7X)
             NHOP7Y = BDBAS (1,BDP7Y)
             NHOP8X = BDBAS (1,BDP8X)
             NHOP8Y = BDBAS (1,BDP8Y)

             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS1,SIN1,
     +                           COS2,SIN2,
     +                           C (1,P1),
     +                           C (1,P2) )
     +
     +
             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS3,SIN3,
     +                           COS4,SIN4,
     +                           C (1,P3),
     +                           C (1,P4) )
     +
     +
             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS5,SIN5,
     +                           COS6,SIN6,
     +                           C (1,P5),
     +                           C (1,P6) )
     +
     +
             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS7,SIN7,
     +                           COS8,SIN8,
     +                           C (1,P7),
     +                           C (1,P8) )
     +
     +
C
C
C             ...attempt sp2 hybridization. At the moment we look
C                for totally symmetric NBOs in the vicinity of the
C                degenerate pair. If no such totally symmetric NBO
C                can be found, the hybridization is abandoned.
C
C
             TOTSYM = NLO__ANGULAR_MOMENTUM_NBO
     +
     +                     ( NXBA,
     +                       SLTYPE (OFF1+1),
     +                       NPAIR,NPAIR+1,
     +                       0,
     +                       1,
     +                       QSYMACC,LSYMACC,
     +                       W,Q,
     +                       LOCAL )
     +
     +
             HYBRID = TOTSYM .NE. 0

             IF (HYBRID) THEN

                 IF (NBOSIZE.LT.3) THEN
                     WRITE (*,*) ' Cannot form sp2 hybrids! '
                     WRITE (*,*) ' NBOSIZE = ',NBOSIZE,' (> 2 required)'
                     WRITE (*,*) ' nlo__rotate_ogroup_nbo '
                     WRITE (1,*) ' Cannot form sp2 hybrids! '
                     WRITE (1,*) ' NBOSIZE = ',NBOSIZE,' (> 2 required)'
                     WRITE (1,*) ' nlo__rotate_ogroup_nbo '
                     STOP
                 END IF

                 S1 = OFF1 + TOTSYM
                 S2 = OFF2 + TOTSYM
                 S3 = OFF3 + TOTSYM
                 S4 = OFF4 + TOTSYM
                 S5 = OFF5 + TOTSYM
                 S6 = OFF6 + TOTSYM
                 S7 = OFF7 + TOTSYM
                 S8 = OFF8 + TOTSYM

                 BDS1 = NBOBD (S1)
                 BDS2 = NBOBD (S2)
                 BDS3 = NBOBD (S3)
                 BDS4 = NBOBD (S4)
                 BDS5 = NBOBD (S5)
                 BDS6 = NBOBD (S6)
                 BDS7 = NBOBD (S7)
                 BDS8 = NBOBD (S8)

                 NHOS1 = BDBAS (1,BDS1)
                 NHOS2 = BDBAS (1,BDS2)
                 NHOS3 = BDBAS (1,BDS3)
                 NHOS4 = BDBAS (1,BDS4)
                 NHOS5 = BDBAS (1,BDS5)
                 NHOS6 = BDBAS (1,BDS6)
                 NHOS7 = BDBAS (1,BDS7)
                 NHOS8 = BDBAS (1,BDS8)

                 CALL  NLO__FORM_SP2_PAIR_NBO
     +
     +                      ( NBAS,
     +                        P,
     +                        XVEC,
     +
     +                               HYB1,HYB2,
     +                               C (1,S1),
     +                               C (1,P1),
     +                               C (1,S2),
     +                               C (1,P2) )
     +
     +
                 CALL  NLO__FORM_SP2_PAIR_NBO
     +
     +                      ( NBAS,
     +                        P,
     +                        XVEC,
     +
     +                               HYB3,HYB4,
     +                               C (1,S3),
     +                               C (1,P3),
     +                               C (1,S4),
     +                               C (1,P4) )
     +
     +
                 CALL  NLO__FORM_SP2_PAIR_NBO
     +
     +                      ( NBAS,
     +                        P,
     +                        XVEC,
     +
     +                               HYB5,HYB6,
     +                               C (1,S5),
     +                               C (1,P5),
     +                               C (1,S6),
     +                               C (1,P6) )
     +
     +
                 CALL  NLO__FORM_SP2_PAIR_NBO
     +
     +                      ( NBAS,
     +                        P,
     +                        XVEC,
     +
     +                               HYB7,HYB8,
     +                               C (1,S7),
     +                               C (1,P7),
     +                               C (1,S8),
     +                               C (1,P8) )
     +
     +
                 B (1,S1  ) =          HYB1 (1,1)
                 B (2,S1  ) =   COS1 * HYB1 (2,1) + SIN1 * HYB1 (3,1)
                 B (3,S1  ) = - SIN1 * HYB1 (2,1) + COS1 * HYB1 (3,1)
                 B (1,P1  ) =          HYB1 (1,2)
                 B (2,P1  ) =   COS1 * HYB1 (2,2) + SIN1 * HYB1 (3,2)
                 B (3,P1  ) = - SIN1 * HYB1 (2,2) + COS1 * HYB1 (3,2)
                 B (1,P1+1) =          HYB1 (1,3)
                 B (2,P1+1) =   COS1 * HYB1 (2,3) + SIN1 * HYB1 (3,3)
                 B (3,P1+1) = - SIN1 * HYB1 (2,3) + COS1 * HYB1 (3,3)

                 B (1,S2  ) =          HYB2 (1,1)
                 B (2,S2  ) =   COS2 * HYB2 (2,1) + SIN2 * HYB2 (3,1)
                 B (3,S2  ) = - SIN2 * HYB2 (2,1) + COS2 * HYB2 (3,1)
                 B (1,P2  ) =          HYB2 (1,2)
                 B (2,P2  ) =   COS2 * HYB2 (2,2) + SIN2 * HYB2 (3,2)
                 B (3,P2  ) = - SIN2 * HYB2 (2,2) + COS2 * HYB2 (3,2)
                 B (1,P2+1) =          HYB2 (1,3)
                 B (2,P2+1) =   COS2 * HYB2 (2,3) + SIN2 * HYB2 (3,3)
                 B (3,P2+1) = - SIN2 * HYB2 (2,3) + COS2 * HYB2 (3,3)

                 B (1,S3  ) =          HYB3 (1,1)
                 B (2,S3  ) =   COS3 * HYB3 (2,1) + SIN3 * HYB3 (3,1)
                 B (3,S3  ) = - SIN3 * HYB3 (2,1) + COS3 * HYB3 (3,1)
                 B (1,P3  ) =          HYB3 (1,2)
                 B (2,P3  ) =   COS3 * HYB3 (2,2) + SIN3 * HYB3 (3,2)
                 B (3,P3  ) = - SIN3 * HYB3 (2,2) + COS3 * HYB3 (3,2)
                 B (1,P3+1) =          HYB3 (1,3)
                 B (2,P3+1) =   COS3 * HYB3 (2,3) + SIN3 * HYB3 (3,3)
                 B (3,P3+1) = - SIN3 * HYB3 (2,3) + COS3 * HYB3 (3,3)

                 B (1,S4  ) =          HYB4 (1,1)
                 B (2,S4  ) =   COS4 * HYB4 (2,1) + SIN4 * HYB4 (3,1)
                 B (3,S4  ) = - SIN4 * HYB4 (2,1) + COS4 * HYB4 (3,1)
                 B (1,P4  ) =          HYB4 (1,2)
                 B (2,P4  ) =   COS4 * HYB4 (2,2) + SIN4 * HYB4 (3,2)
                 B (3,P4  ) = - SIN4 * HYB4 (2,2) + COS4 * HYB4 (3,2)
                 B (1,P4+1) =          HYB4 (1,3)
                 B (2,P4+1) =   COS4 * HYB4 (2,3) + SIN4 * HYB4 (3,3)
                 B (3,P4+1) = - SIN4 * HYB4 (2,3) + COS4 * HYB4 (3,3)

                 B (1,S5  ) =          HYB5 (1,1)
                 B (2,S5  ) =   COS5 * HYB5 (2,1) + SIN5 * HYB5 (3,1)
                 B (3,S5  ) = - SIN5 * HYB5 (2,1) + COS5 * HYB5 (3,1)
                 B (1,P5  ) =          HYB5 (1,2)
                 B (2,P5  ) =   COS5 * HYB5 (2,2) + SIN5 * HYB5 (3,2)
                 B (3,P5  ) = - SIN5 * HYB5 (2,2) + COS5 * HYB5 (3,2)
                 B (1,P5+1) =          HYB5 (1,3)
                 B (2,P5+1) =   COS5 * HYB5 (2,3) + SIN5 * HYB5 (3,3)
                 B (3,P5+1) = - SIN5 * HYB5 (2,3) + COS5 * HYB5 (3,3)

                 B (1,S6  ) =          HYB6 (1,1)
                 B (2,S6  ) =   COS6 * HYB6 (2,1) + SIN6 * HYB6 (3,1)
                 B (3,S6  ) = - SIN6 * HYB6 (2,1) + COS6 * HYB6 (3,1)
                 B (1,P6  ) =          HYB6 (1,2)
                 B (2,P6  ) =   COS6 * HYB6 (2,2) + SIN6 * HYB6 (3,2)
                 B (3,P6  ) = - SIN6 * HYB6 (2,2) + COS6 * HYB6 (3,2)
                 B (1,P6+1) =          HYB6 (1,3)
                 B (2,P6+1) =   COS6 * HYB6 (2,3) + SIN6 * HYB6 (3,3)
                 B (3,P6+1) = - SIN6 * HYB6 (2,3) + COS6 * HYB6 (3,3)

                 B (1,S7  ) =          HYB7 (1,1)
                 B (2,S7  ) =   COS7 * HYB7 (2,1) + SIN7 * HYB7 (3,1)
                 B (3,S7  ) = - SIN7 * HYB7 (2,1) + COS7 * HYB7 (3,1)
                 B (1,P7  ) =          HYB7 (1,2)
                 B (2,P7  ) =   COS7 * HYB7 (2,2) + SIN7 * HYB7 (3,2)
                 B (3,P7  ) = - SIN7 * HYB7 (2,2) + COS7 * HYB7 (3,2)
                 B (1,P7+1) =          HYB7 (1,3)
                 B (2,P7+1) =   COS7 * HYB7 (2,3) + SIN7 * HYB7 (3,3)
                 B (3,P7+1) = - SIN7 * HYB7 (2,3) + COS7 * HYB7 (3,3)

                 B (1,S8  ) =          HYB8 (1,1)
                 B (2,S8  ) =   COS8 * HYB8 (2,1) + SIN8 * HYB8 (3,1)
                 B (3,S8  ) = - SIN8 * HYB8 (2,1) + COS8 * HYB8 (3,1)
                 B (1,P8  ) =          HYB8 (1,2)
                 B (2,P8  ) =   COS8 * HYB8 (2,2) + SIN8 * HYB8 (3,2)
                 B (3,P8  ) = - SIN8 * HYB8 (2,2) + COS8 * HYB8 (3,2)
                 B (1,P8+1) =          HYB8 (1,3)
                 B (2,P8+1) =   COS8 * HYB8 (2,3) + SIN8 * HYB8 (3,3)
                 B (3,P8+1) = - SIN8 * HYB8 (2,3) + COS8 * HYB8 (3,3)

                 SYMNBO (S1)   = 2
                 SYMNBO (P1  ) = 2
                 SYMNBO (P1+1) = 2
                 SYMNBO (S2)   = 2
                 SYMNBO (P2  ) = 2
                 SYMNBO (P2+1) = 2
                 SYMNBO (S3)   = 2
                 SYMNBO (P3  ) = 2
                 SYMNBO (P3+1) = 2
                 SYMNBO (S4)   = 2
                 SYMNBO (P4  ) = 2
                 SYMNBO (P4+1) = 2
                 SYMNBO (S5)   = 2
                 SYMNBO (P5  ) = 2
                 SYMNBO (P5+1) = 2
                 SYMNBO (S6)   = 2
                 SYMNBO (P6  ) = 2
                 SYMNBO (P6+1) = 2
                 SYMNBO (S7)   = 2
                 SYMNBO (P7  ) = 2
                 SYMNBO (P7+1) = 2
                 SYMNBO (S8)   = 2
                 SYMNBO (P8  ) = 2
                 SYMNBO (P8+1) = 2

                 SLTYPE (S1)   = -1
                 SLTYPE (P1  ) = -1
                 SLTYPE (P1+1) = -1
                 SLTYPE (S2)   = -1
                 SLTYPE (P2  ) = -1
                 SLTYPE (P2+1) = -1
                 SLTYPE (S3)   = -1
                 SLTYPE (P3  ) = -1
                 SLTYPE (P3+1) = -1
                 SLTYPE (S4)   = -1
                 SLTYPE (P4  ) = -1
                 SLTYPE (P4+1) = -1
                 SLTYPE (S5)   = -1
                 SLTYPE (P5  ) = -1
                 SLTYPE (P5+1) = -1
                 SLTYPE (S6)   = -1
                 SLTYPE (P6  ) = -1
                 SLTYPE (P6+1) = -1
                 SLTYPE (S7)   = -1
                 SLTYPE (P7  ) = -1
                 SLTYPE (P7+1) = -1
                 SLTYPE (S8)   = -1
                 SLTYPE (P8  ) = -1
                 SLTYPE (P8+1) = -1

                 BDNBAS (BDS1 ) = 3
                 BDNBAS (BDP1X) = 3
                 BDNBAS (BDP1Y) = 3
                 BDNBAS (BDS2 ) = 3
                 BDNBAS (BDP2X) = 3
                 BDNBAS (BDP2Y) = 3
                 BDNBAS (BDS3 ) = 3
                 BDNBAS (BDP3X) = 3
                 BDNBAS (BDP3Y) = 3
                 BDNBAS (BDS4 ) = 3
                 BDNBAS (BDP4X) = 3
                 BDNBAS (BDP4Y) = 3
                 BDNBAS (BDS5 ) = 3
                 BDNBAS (BDP5X) = 3
                 BDNBAS (BDP5Y) = 3
                 BDNBAS (BDS6 ) = 3
                 BDNBAS (BDP6X) = 3
                 BDNBAS (BDP6Y) = 3
                 BDNBAS (BDS7 ) = 3
                 BDNBAS (BDP7X) = 3
                 BDNBAS (BDP7Y) = 3
                 BDNBAS (BDS8 ) = 3
                 BDNBAS (BDP8X) = 3
                 BDNBAS (BDP8Y) = 3

                 BDBAS (1,BDS1 ) = NHOS1
                 BDBAS (2,BDS1 ) = NHOP1X
                 BDBAS (3,BDS1 ) = NHOP1Y
                 BDBAS (1,BDP1X) = NHOS1
                 BDBAS (2,BDP1X) = NHOP1X
                 BDBAS (3,BDP1X) = NHOP1Y
                 BDBAS (1,BDP1Y) = NHOS1
                 BDBAS (2,BDP1Y) = NHOP1X
                 BDBAS (3,BDP1Y) = NHOP1Y
                 BDBAS (1,BDS2 ) = NHOS2
                 BDBAS (2,BDS2 ) = NHOP2X
                 BDBAS (3,BDS2 ) = NHOP2Y
                 BDBAS (1,BDP2X) = NHOS2
                 BDBAS (2,BDP2X) = NHOP2X
                 BDBAS (3,BDP2X) = NHOP2Y
                 BDBAS (1,BDP2Y) = NHOS2
                 BDBAS (2,BDP2Y) = NHOP2X
                 BDBAS (3,BDP2Y) = NHOP2Y
                 BDBAS (1,BDS3 ) = NHOS3
                 BDBAS (2,BDS3 ) = NHOP3X
                 BDBAS (3,BDS3 ) = NHOP3Y
                 BDBAS (1,BDP3X) = NHOS3
                 BDBAS (2,BDP3X) = NHOP3X
                 BDBAS (3,BDP3X) = NHOP3Y
                 BDBAS (1,BDP3Y) = NHOS3
                 BDBAS (2,BDP3Y) = NHOP3X
                 BDBAS (3,BDP3Y) = NHOP3Y
                 BDBAS (1,BDS4 ) = NHOS4
                 BDBAS (2,BDS4 ) = NHOP4X
                 BDBAS (3,BDS4 ) = NHOP4Y
                 BDBAS (1,BDP4X) = NHOS4
                 BDBAS (2,BDP4X) = NHOP4X
                 BDBAS (3,BDP4X) = NHOP4Y
                 BDBAS (1,BDP4Y) = NHOS4
                 BDBAS (2,BDP4Y) = NHOP4X
                 BDBAS (3,BDP4Y) = NHOP4Y
                 BDBAS (1,BDS5 ) = NHOS5
                 BDBAS (2,BDS5 ) = NHOP5X
                 BDBAS (3,BDS5 ) = NHOP5Y
                 BDBAS (1,BDP5X) = NHOS5
                 BDBAS (2,BDP5X) = NHOP5X
                 BDBAS (3,BDP5X) = NHOP5Y
                 BDBAS (1,BDP5Y) = NHOS5
                 BDBAS (2,BDP5Y) = NHOP5X
                 BDBAS (3,BDP5Y) = NHOP5Y
                 BDBAS (1,BDS6 ) = NHOS6
                 BDBAS (2,BDS6 ) = NHOP6X
                 BDBAS (3,BDS6 ) = NHOP6Y
                 BDBAS (1,BDP6X) = NHOS6
                 BDBAS (2,BDP6X) = NHOP6X
                 BDBAS (3,BDP6X) = NHOP6Y
                 BDBAS (1,BDP6Y) = NHOS6
                 BDBAS (2,BDP6Y) = NHOP6X
                 BDBAS (3,BDP6Y) = NHOP6Y
                 BDBAS (1,BDS7 ) = NHOS7
                 BDBAS (2,BDS7 ) = NHOP7X
                 BDBAS (3,BDS7 ) = NHOP7Y
                 BDBAS (1,BDP7X) = NHOS7
                 BDBAS (2,BDP7X) = NHOP7X
                 BDBAS (3,BDP7X) = NHOP7Y
                 BDBAS (1,BDP7Y) = NHOS7
                 BDBAS (2,BDP7Y) = NHOP7X
                 BDBAS (3,BDP7Y) = NHOP7Y
                 BDBAS (1,BDS8 ) = NHOS8
                 BDBAS (2,BDS8 ) = NHOP8X
                 BDBAS (3,BDS8 ) = NHOP8Y
                 BDBAS (1,BDP8X) = NHOS8
                 BDBAS (2,BDP8X) = NHOP8X
                 BDBAS (3,BDP8X) = NHOP8Y
                 BDBAS (1,BDP8Y) = NHOS8
                 BDBAS (2,BDP8Y) = NHOP8X
                 BDBAS (3,BDP8Y) = NHOP8Y

             ELSE
C
C
C             ...no sp2 hybridization possible. Print info.
C
C
                 WRITE (*,*) ' Cannot perform sp2 hybridization! '
                 WRITE (*,*) ' O-symmetry reduction will result! '

                 B (1,P1  ) =   COS1
                 B (2,P1  ) = - SIN1
                 B (1,P1+1) =   SIN1
                 B (2,P1+1) =   COS1
                 B (1,P2  ) =   COS2
                 B (2,P2  ) = - SIN2
                 B (1,P2+1) =   SIN2
                 B (2,P2+1) =   COS2
                 B (1,P3  ) =   COS3
                 B (2,P3  ) = - SIN3
                 B (1,P3+1) =   SIN3
                 B (2,P3+1) =   COS3
                 B (1,P4  ) =   COS4
                 B (2,P4  ) = - SIN4
                 B (1,P4+1) =   SIN4
                 B (2,P4+1) =   COS4
                 B (1,P5  ) =   COS5
                 B (2,P5  ) = - SIN5
                 B (1,P5+1) =   SIN5
                 B (2,P5+1) =   COS5
                 B (1,P6  ) =   COS6
                 B (2,P6  ) = - SIN6
                 B (1,P6+1) =   SIN6
                 B (2,P6+1) =   COS6
                 B (1,P7  ) =   COS7
                 B (2,P7  ) = - SIN7
                 B (1,P7+1) =   SIN7
                 B (2,P7+1) =   COS7
                 B (1,P8  ) =   COS8
                 B (2,P8  ) = - SIN8
                 B (1,P8+1) =   SIN8
                 B (2,P8+1) =   COS8

                 SYMNBO (P1  ) = 2
                 SYMNBO (P1+1) = 2
                 SYMNBO (P2  ) = 2
                 SYMNBO (P2+1) = 2
                 SYMNBO (P3  ) = 2
                 SYMNBO (P3+1) = 2
                 SYMNBO (P4  ) = 2
                 SYMNBO (P4+1) = 2
                 SYMNBO (P5  ) = 2
                 SYMNBO (P5+1) = 2
                 SYMNBO (P6  ) = 2
                 SYMNBO (P6+1) = 2
                 SYMNBO (P7  ) = 2
                 SYMNBO (P7+1) = 2
                 SYMNBO (P8  ) = 2
                 SYMNBO (P8+1) = 2

                 BDNBAS (BDP1X) = 2
                 BDNBAS (BDP1Y) = 2
                 BDNBAS (BDP2X) = 2
                 BDNBAS (BDP2Y) = 2
                 BDNBAS (BDP3X) = 2
                 BDNBAS (BDP3Y) = 2
                 BDNBAS (BDP4X) = 2
                 BDNBAS (BDP4Y) = 2
                 BDNBAS (BDP5X) = 2
                 BDNBAS (BDP5Y) = 2
                 BDNBAS (BDP6X) = 2
                 BDNBAS (BDP6Y) = 2
                 BDNBAS (BDP7X) = 2
                 BDNBAS (BDP7Y) = 2
                 BDNBAS (BDP8X) = 2
                 BDNBAS (BDP8Y) = 2

                 BDBAS (1,BDP1X) = NHOP1X
                 BDBAS (2,BDP1X) = NHOP1Y
                 BDBAS (1,BDP1Y) = NHOP1X
                 BDBAS (2,BDP1Y) = NHOP1Y
                 BDBAS (1,BDP2X) = NHOP2X
                 BDBAS (2,BDP2X) = NHOP2Y
                 BDBAS (1,BDP2Y) = NHOP2X
                 BDBAS (2,BDP2Y) = NHOP2Y
                 BDBAS (1,BDP3X) = NHOP3X
                 BDBAS (2,BDP3X) = NHOP3Y
                 BDBAS (1,BDP3Y) = NHOP3X
                 BDBAS (2,BDP3Y) = NHOP3Y
                 BDBAS (1,BDP4X) = NHOP4X
                 BDBAS (2,BDP4X) = NHOP4Y
                 BDBAS (1,BDP4Y) = NHOP4X
                 BDBAS (2,BDP4Y) = NHOP4Y
                 BDBAS (1,BDP5X) = NHOP5X
                 BDBAS (2,BDP5X) = NHOP5Y
                 BDBAS (1,BDP5Y) = NHOP5X
                 BDBAS (2,BDP5Y) = NHOP5Y
                 BDBAS (1,BDP6X) = NHOP6X
                 BDBAS (2,BDP6X) = NHOP6Y
                 BDBAS (1,BDP6Y) = NHOP6X
                 BDBAS (2,BDP6Y) = NHOP6Y
                 BDBAS (1,BDP7X) = NHOP7X
                 BDBAS (2,BDP7X) = NHOP7Y
                 BDBAS (1,BDP7Y) = NHOP7X
                 BDBAS (2,BDP7Y) = NHOP7Y
                 BDBAS (1,BDP8X) = NHOP8X
                 BDBAS (2,BDP8X) = NHOP8Y
                 BDBAS (1,BDP8Y) = NHOP8X
                 BDBAS (2,BDP8Y) = NHOP8Y

             END IF

         ELSE IF (C4AXIS) THEN
C
C
C             ...the C4 axis case. Establish the three nearest neighbor
C                atomic center pairs (P1 P2), (P3 P4), (P5 P6).
C
C
             P1 = IDXSYM (1)
             P2 = 0
             P3 = 0
             P4 = 0
             P5 = 0
             P6 = 0

             ATOM1 = ATXIDX (P1)

             DMAX = ZERO
             DMIN = DOMAT (ATOM1,ATOM1)
             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                ATOM2 = ATXIDX (INDEX)
                DMAX = MAX (DOMAT (ATOM2,ATOM1),DMAX)
                DMIN = MIN (DOMAT (ATOM2,ATOM1),DMIN)
             END DO

             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                ATOM2 = ATXIDX (INDEX)
                DIFF = ABS (DMAX - DOMAT (ATOM2,ATOM1))
                IF (DIFF.LT.DSYMACC) THEN
                    P2 = INDEX
                END IF
                DIFF = ABS (DMIN - DOMAT (ATOM2,ATOM1))
                IF (DIFF.LT.DSYMACC) THEN
                    ATOM4 = ATOM2
                END IF
             END DO

             ATOM2 = ATXIDX (P2)

             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                ATOM3 = ATXIDX (INDEX)
                IF (INDEX.NE.P2 .AND. ATOM3.NE.ATOM4) THEN
                    DIFF = ABS (DMAX - DOMAT (ATOM3,ATOM2))
                    IF (DIFF.LT.DSYMACC) THEN
                        P3 = INDEX
                    END IF
                END IF
             END DO

             ATOM3 = ATXIDX (P3)

             NLEFT = 0
             DO I = 2,NSYM
                INDEX = IDXSYM (I)
                IF (INDEX.NE.P2.AND.INDEX.NE.P3) THEN
                    NLEFT = NLEFT + 1
                    LEFT (NLEFT) = INDEX
                END IF
             END DO

             DO I = 1,NLEFT
                INDEX = LEFT (I)
                ATOM4 = ATXIDX (INDEX)
                DIFF = ABS (DMAX - DOMAT (ATOM4,ATOM3))
                IF (DIFF.LT.DSYMACC) THEN
                    P4 = INDEX
                END IF
             END DO

             DO I = 1,NLEFT
                INDEX = LEFT (I)
                IF (INDEX.NE.P4) THEN
                    P5 = INDEX
                END IF
             END DO

             DO I = 1,NLEFT
                INDEX = LEFT (I)
                IF (INDEX.NE.P4.AND.INDEX.NE.P5) THEN
                    P6 = INDEX
                END IF
             END DO

             ATOM4 = ATXIDX (P4)
             ATOM5 = ATXIDX (P5)
             ATOM6 = ATXIDX (P6)

             D1 = DOMAT (ATOM1,ATOM2)
             D2 = DOMAT (ATOM3,ATOM4)
             D3 = DOMAT (ATOM5,ATOM6)

             ALARM = (P1.EQ.0) .OR. (P2.EQ.0) .OR.
     +               (P3.EQ.0) .OR. (P4.EQ.0) .OR.
     +               (P5.EQ.0) .OR. (P6.EQ.0) .OR.
     +               (ABS (DMAX - D1).GT.DSYMACC) .OR.
     +               (ABS (DMAX - D2).GT.DSYMACC) .OR.
     +               (ABS (DMAX - D3).GT.DSYMACC)

             IF (ALARM) THEN
                 WRITE (*,*) ' Problems finding octahedral C4 pairs! '
                 WRITE (*,*) ' P1,P2,P3,P4,P5,P6 = ',
     +                         P1,P2,P3,P4,P5,P6
                 WRITE (*,*) ' Overlap orders #1,2,3,max = ',
     +                         D1,D2,D3,DMAX
                 WRITE (*,*) ' nlo__rotate_ogroup_nbo '
                 WRITE (1,*) ' Problems finding octahedral C4 pairs! '
                 WRITE (1,*) ' P1,P2,P3,P4,P5,P6 = ',
     +                         P1,P2,P3,P4,P5,P6
                 WRITE (1,*) ' Overlap orders #1,2,3,max = ',
     +                         D1,D2,D3,DMAX
                 WRITE (1,*) ' nlo__rotate_ogroup_nbo '
                 STOP
             END IF
C
C
C             ...rotate the three pairs into appropriate positions
C                by calling three times the pair rotation routine.
C
C
             OFF1 = ATXOFF (P1)
             OFF2 = ATXOFF (P2)
             OFF3 = ATXOFF (P3)
             OFF4 = ATXOFF (P4)
             OFF5 = ATXOFF (P5)
             OFF6 = ATXOFF (P6)

             P1 = OFF1 + NPAIR
             P2 = OFF2 + NPAIR
             P3 = OFF3 + NPAIR
             P4 = OFF4 + NPAIR
             P5 = OFF5 + NPAIR
             P6 = OFF6 + NPAIR

             BDP1X = NBOBD (P1  )
             BDP1Y = NBOBD (P1+1)
             BDP2X = NBOBD (P2  )
             BDP2Y = NBOBD (P2+1)
             BDP3X = NBOBD (P3  )
             BDP3Y = NBOBD (P3+1)
             BDP4X = NBOBD (P4  )
             BDP4Y = NBOBD (P4+1)
             BDP5X = NBOBD (P5  )
             BDP5Y = NBOBD (P5+1)
             BDP6X = NBOBD (P6  )
             BDP6Y = NBOBD (P6+1)

             NHOP1X = BDBAS (1,BDP1X)
             NHOP1Y = BDBAS (1,BDP1Y)
             NHOP2X = BDBAS (1,BDP2X)
             NHOP2Y = BDBAS (1,BDP2Y)
             NHOP3X = BDBAS (1,BDP3X)
             NHOP3Y = BDBAS (1,BDP3Y)
             NHOP4X = BDBAS (1,BDP4X)
             NHOP4Y = BDBAS (1,BDP4Y)
             NHOP5X = BDBAS (1,BDP5X)
             NHOP5Y = BDBAS (1,BDP5Y)
             NHOP6X = BDBAS (1,BDP6X)
             NHOP6Y = BDBAS (1,BDP6Y)

             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS1,SIN1,
     +                           COS2,SIN2,
     +                           C (1,P1),
     +                           C (1,P2) )
     +
     +
             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS3,SIN3,
     +                           COS4,SIN4,
     +                           C (1,P3),
     +                           C (1,P4) )
     +
     +
             CALL  NLO__ROTATE_PAIR_DEGENERATE_NBO
     +
     +                  ( NBAS,
     +                    P,
     +                    XVEC,
     +                    XMAT,
     +
     +                           COS5,SIN5,
     +                           COS6,SIN6,
     +                           C (1,P5),
     +                           C (1,P6) )
     +
     +
C
C
C             ...rotate the three pairs 45 degrees (not needed!).
C
C
C             DO N = 1,NBAS
C                X = SQR2TH * C (N,P1) - SQR2TH * C (N,P1+1)
C                Y = SQR2TH * C (N,P1) + SQR2TH * C (N,P1+1)
C                C (N,P1  ) = X
C                C (N,P1+1) = Y
C                X = SQR2TH * C (N,P2) - SQR2TH * C (N,P2+1)
C                Y = SQR2TH * C (N,P2) + SQR2TH * C (N,P2+1)
C                C (N,P2  ) = X
C                C (N,P2+1) = Y
C                X = SQR2TH * C (N,P3) - SQR2TH * C (N,P3+1)
C                Y = SQR2TH * C (N,P3) + SQR2TH * C (N,P3+1)
C                C (N,P3  ) = X
C                C (N,P3+1) = Y
C                X = SQR2TH * C (N,P4) - SQR2TH * C (N,P4+1)
C                Y = SQR2TH * C (N,P4) + SQR2TH * C (N,P4+1)
C                C (N,P4  ) = X
C                C (N,P4+1) = Y
C                X = SQR2TH * C (N,P5) - SQR2TH * C (N,P5+1)
C                Y = SQR2TH * C (N,P5) + SQR2TH * C (N,P5+1)
C                C (N,P5  ) = X
C                C (N,P5+1) = Y
C                X = SQR2TH * C (N,P6) - SQR2TH * C (N,P6+1)
C                Y = SQR2TH * C (N,P6) + SQR2TH * C (N,P6+1)
C                C (N,P6  ) = X
C                C (N,P6+1) = Y
C             END DO
C
C             B (1,P1  ) =   SQR2TH * (COS1 - SIN1)
C             B (2,P1  ) = - SQR2TH * (SIN1 + COS1)
C             B (1,P1+1) =   SQR2TH * (COS1 + SIN1)
C             B (2,P1+1) =   SQR2TH * (COS1 - SIN1)
C
C             B (1,P2  ) =   SQR2TH * (COS2 - SIN2)
C             B (2,P2  ) = - SQR2TH * (SIN2 + COS2)
C             B (1,P2+1) =   SQR2TH * (COS2 + SIN2)
C             B (2,P2+1) =   SQR2TH * (COS2 - SIN2)
C
C             B (1,P3  ) =   SQR2TH * (COS3 - SIN3)
C             B (2,P3  ) = - SQR2TH * (SIN3 + COS3)
C             B (1,P3+1) =   SQR2TH * (COS3 + SIN3)
C             B (2,P3+1) =   SQR2TH * (COS3 - SIN3)
C
C             B (1,P4  ) =   SQR2TH * (COS4 - SIN4)
C             B (2,P4  ) = - SQR2TH * (SIN4 + COS4)
C             B (1,P4+1) =   SQR2TH * (COS4 + SIN4)
C             B (2,P4+1) =   SQR2TH * (COS4 - SIN4)
C
C             B (1,P5  ) =   SQR2TH * (COS5 - SIN5)
C             B (2,P5  ) = - SQR2TH * (SIN5 + COS5)
C             B (1,P5+1) =   SQR2TH * (COS5 + SIN5)
C             B (2,P5+1) =   SQR2TH * (COS5 - SIN5)
C
C             B (1,P6  ) =   SQR2TH * (COS6 - SIN6)
C             B (2,P6  ) = - SQR2TH * (SIN6 + COS6)
C             B (1,P6+1) =   SQR2TH * (COS6 + SIN6)
C             B (2,P6+1) =   SQR2TH * (COS6 - SIN6)

             B (1,P1  ) =   COS1
             B (2,P1  ) = - SIN1
             B (1,P1+1) =   SIN1
             B (2,P1+1) =   COS1
             B (1,P2  ) =   COS2
             B (2,P2  ) = - SIN2
             B (1,P2+1) =   SIN2
             B (2,P2+1) =   COS2
             B (1,P3  ) =   COS3
             B (2,P3  ) = - SIN3
             B (1,P3+1) =   SIN3
             B (2,P3+1) =   COS3
             B (1,P4  ) =   COS4
             B (2,P4  ) = - SIN4
             B (1,P4+1) =   SIN4
             B (2,P4+1) =   COS4
             B (1,P5  ) =   COS5
             B (2,P5  ) = - SIN5
             B (1,P5+1) =   SIN5
             B (2,P5+1) =   COS5
             B (1,P6  ) =   COS6
             B (2,P6  ) = - SIN6
             B (1,P6+1) =   SIN6
             B (2,P6+1) =   COS6

             SYMNBO (P1  ) = 2
             SYMNBO (P1+1) = 2
             SYMNBO (P2  ) = 2
             SYMNBO (P2+1) = 2
             SYMNBO (P3  ) = 2
             SYMNBO (P3+1) = 2
             SYMNBO (P4  ) = 2
             SYMNBO (P4+1) = 2
             SYMNBO (P5  ) = 2
             SYMNBO (P5+1) = 2
             SYMNBO (P6  ) = 2
             SYMNBO (P6+1) = 2

             BDNBAS (BDP1X) = 2
             BDNBAS (BDP1Y) = 2
             BDNBAS (BDP2X) = 2
             BDNBAS (BDP2Y) = 2
             BDNBAS (BDP3X) = 2
             BDNBAS (BDP3Y) = 2
             BDNBAS (BDP4X) = 2
             BDNBAS (BDP4Y) = 2
             BDNBAS (BDP5X) = 2
             BDNBAS (BDP5Y) = 2
             BDNBAS (BDP6X) = 2
             BDNBAS (BDP6Y) = 2

             BDBAS (1,BDP1X) = NHOP1X
             BDBAS (2,BDP1X) = NHOP1Y
             BDBAS (1,BDP1Y) = NHOP1X
             BDBAS (2,BDP1Y) = NHOP1Y
             BDBAS (1,BDP2X) = NHOP2X
             BDBAS (2,BDP2X) = NHOP2Y
             BDBAS (1,BDP2Y) = NHOP2X
             BDBAS (2,BDP2Y) = NHOP2Y
             BDBAS (1,BDP3X) = NHOP3X
             BDBAS (2,BDP3X) = NHOP3Y
             BDBAS (1,BDP3Y) = NHOP3X
             BDBAS (2,BDP3Y) = NHOP3Y
             BDBAS (1,BDP4X) = NHOP4X
             BDBAS (2,BDP4X) = NHOP4Y
             BDBAS (1,BDP4Y) = NHOP4X
             BDBAS (2,BDP4Y) = NHOP4Y
             BDBAS (1,BDP5X) = NHOP5X
             BDBAS (2,BDP5X) = NHOP5Y
             BDBAS (1,BDP5Y) = NHOP5X
             BDBAS (2,BDP5Y) = NHOP5Y
             BDBAS (1,BDP6X) = NHOP6X
             BDBAS (2,BDP6X) = NHOP6Y
             BDBAS (1,BDP6Y) = NHOP6X
             BDBAS (2,BDP6Y) = NHOP6Y

         END IF
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE ASSIGN_DIHLS(IBNDTO, IREDUNCO, TOTREDNCO, TOTNOFBND, 
     &                        TOTNOFANG, NRATMS, TOTNOFDIH, MAXREDUNCO)
C
C This routine setup the connectivity array to define dihedral angles. This
C array is dimensioned to (4, MAXREDUNCO).
C 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      INTEGER TOTREDNCO, TOTNOFBND, TOTNOFANG, TOTNOFDIH
      LOGICAL YESLINR1, YESLINR2
C
      DIMENSION IREDUNCO(4, MAXREDUNCO), IBNDTO(NRATMS, NRATMS)
C
      DATA IZERO /0/
C


      TOTNOFDIH = IZERO
      
      DO 10 ICON2 = 2, NRATMS
         DO 20 ICON3 = 1, (ICON2 - 1)
C
            IF (IBNDTO(ICON3, ICON2) .GT. 0) THEN
               DO 30 IBNDS = 1, TOTNOFBND
                  
                  IF (IREDUNCO(2, IBNDS) .GT. IZERO) THEN
C
                     ICON1 = IZERO
C
                     IF (IREDUNCO(1, IBNDS) .EQ. ICON2) 
     &                    ICON1 = IREDUNCO(2, IBNDS)
                     IF (IREDUNCO(2, IBNDS) .EQ. ICON2) 
     &                    ICON1 = IREDUNCO(1, IBNDS)
C
                     IF (ICON1 .NE. IZERO .AND. ICON1 .NE. ICON3) THEN
                        
                        DO 40 JBNDS =1 , TOTNOFBND
                           
                           IF (IREDUNCO(2, JBNDS) .GT. IZERO) THEN

                              ICON4 = IZERO

                              IF (IREDUNCO(1, JBNDS) .EQ. ICON3) 
     &                             ICON4 = IREDUNCO(2, JBNDS)
                              IF (IREDUNCO(2, JBNDS) .EQ. ICON3) 
     &                             ICON4 = IREDUNCO(1, JBNDS)
C
                              IF (ICON4 .NE. IZERO .AND. ICON4 .NE.
     &                            ICON1 .AND. ICON4 .NE. ICON2) THEN
C
                                 YESLINR1 = (IBNDTO(ICON3, ICON1) .EQ. 
     &                                      -99 .OR. 
     &                                      (IBNDTO(ICON3, ICON1) .NE.
     &                                       IZERO .AND.
     &                                       IBNDTO(ICON3, ICON2) .EQ.
     &                                      -99))
                                 YESLINR2 = (IBNDTO(ICON2, ICON4) .EQ. 
     &                                       -99 .OR. 
     &                                       IBNDTO(ICON2, ICON4) .NE.
     &                                       IZERO .AND.
     &                                       IBNDTO(ICON3, ICON2) .EQ.
     &                                       -99)
                              IF (ICON1 .LT. ICON3)
     &                           YESLINR1 = (IBNDTO(ICON1, ICON3) .EQ. 
     &                                      -99 .OR. 
     &                                      (IBNDTO(ICON1, ICON3) .NE.
     &                                       IZERO .AND.
     &                                       IBNDTO(ICON3, ICON2) .EQ.
     &                                      -99))
                              IF (ICON4 .LT. ICON2)
     &                           YESLINR2 = (IBNDTO(ICON4, ICON2) .EQ. 
     &                                       -99 .OR. 
     &                                       IBNDTO(ICON4, ICON2) .NE.
     &                                       IZERO .AND.
     &                                       IBNDTO(ICON3, ICON2) .EQ.
     &                                       -99)

                                 IF (.NOT. YESLINR1 .AND. .NOT. 
     &                               YESLINR2) THEN
C
                                    TOTNOFDIH = TOTNOFDIH + 1
                                    IREDUNCO(1, TOTREDNCO + TOTNOFDIH) =
     &                                       ICON1
                                    IREDUNCO(2, TOTREDNCO + TOTNOFDIH) =
     &                                       ICON2
                                    IREDUNCO(3, TOTREDNCO + TOTNOFDIH) =
     &                                       ICON3
                                    IREDUNCO(4, TOTREDNCO + TOTNOFDIH) =
     &                                       ICON4
                                  ENDIF
                                 ENDIF
C                              ENDIF
                           ENDIF
C
 40                     CONTINUE
C
                     ENDIF
                  ENDIF
C     
 30            CONTINUE
C
            ENDIF
C
 20      CONTINUE
 10   CONTINUE
C
      TOTREDNCO = TOTREDNCO + TOTNOFDIH
C
      IF (TOTREDNCO .GE. MAXREDUNCO) THEN
        WRITE(6, 99) TOTREDNCO, MAXREDUNCO
 99     FORMAT(T3,'Maximum No. of redundant coordinates allowed',
     &         ' exceeded.',/,
     &         T3,'Required:',I3,' Current Maximum:',I3)
        Write(6,*)
        CALL ERREX
      ENDIF
C
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
*DECK XDSYR2
      SUBROUTINE XDSYR2 (UPLO, N, ALPHA, X, INCX, Y, INCY, A, LDA)
C***BEGIN PROLOGUE  XDSYR2
C***PURPOSE  Perform the symmetric rank 2 operation.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1B4
C***TYPE      DOUBLE PRECISION (SSYR2-S, XDSYR2-D, CSYR2-C)
C***KEYWORDS  LEVEL 2 BLAS, LINEAR ALGEBRA
C***AUTHOR  Dongarra, J. J., (ANL)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  XDSYR2  performs the symmetric rank 2 operation
C
C     A := alpha*x*y' + alpha*y*x' + A,
C
C  where alpha is a scalar, x and y are n element vectors and A is an n
C  by n symmetric matrix.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the upper or lower
C           triangular part of the array A is to be referenced as
C           follows:
C
C              UPLO = 'U' or 'u'   Only the upper triangular part of A
C                                  is to be referenced.
C
C              UPLO = 'L' or 'l'   Only the lower triangular part of A
C                                  is to be referenced.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1)*abs( INCX)).
C           Before entry, the incremented array X must contain the n
C           element vector x.
C           Unchanged on exit.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C  Y      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCY ) ).
C           Before entry, the incremented array Y must contain the n
C           element vector y.
C           Unchanged on exit.
C
C  INCY   - INTEGER.
C           On entry, INCY specifies the increment for the elements of
C           Y. INCY must not be zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular part of the symmetric matrix and the strictly
C           lower triangular part of A is not referenced. On exit, the
C           upper triangular part of the array A is overwritten by the
C           upper triangular part of the updated matrix.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular part of the symmetric matrix and the strictly
C           upper triangular part of A is not referenced. On exit, the
C           lower triangular part of the array A is overwritten by the
C           lower triangular part of the updated matrix.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C***REFERENCES  Dongarra, J. J., Du Croz, J., Hammarling, S., and
C                 Hanson, R. J.  An extended set of Fortran basic linear
C                 algebra subprograms.  ACM TOMS, Vol. 14, No. 1,
C                 pp. 1-17, March 1988.
C***ROUTINES CALLED  LSAME, XERBLA
C***REVISION HISTORY  (YYMMDD)
C   861022  DATE WRITTEN
C   910605  Modified to meet SLATEC prologue standards.  Only comment
C           lines were modified.  (BKS)
C***END PROLOGUE  XDSYR2
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, INCY, LDA, N
      CHARACTER*1        UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP1, TEMP2
      INTEGER            I, INFO, IX, IY, J, JX, JY, KX, KY
C     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
C     .. External Subroutines ..
      EXTERNAL           XERBLA
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C***FIRST EXECUTABLE STATEMENT  XDSYR2
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.LSAME( UPLO, 'U' ).AND.
     $         .NOT.LSAME( UPLO, 'L' )      )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'XDSYR2 ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
C
C     Set up the start points in X and Y if the increments are not both
C     unity.
C
      IF( ( INCX.NE.1 ).OR.( INCY.NE.1 ) )THEN
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( N - 1 )*INCX
         END IF
         IF( INCY.GT.0 )THEN
            KY = 1
         ELSE
            KY = 1 - ( N - 1 )*INCY
         END IF
         JX = KX
         JY = KY
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through the triangular part
C     of A.
C
      IF( LSAME( UPLO, 'U' ) )THEN
C
C        Form  A  when A is stored in the upper triangle.
C
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 20, J = 1, N
               IF( ( X( J ).NE.ZERO ).OR.( Y( J ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( J )
                  TEMP2 = ALPHA*X( J )
                  DO 10, I = 1, J
                     A( I, J ) = A( I, J ) + X( I )*TEMP1 + Y( I )*TEMP2
   10             CONTINUE
               END IF
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               IF( ( X( JX ).NE.ZERO ).OR.( Y( JY ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( JY )
                  TEMP2 = ALPHA*X( JX )
                  IX    = KX
                  IY    = KY
                  DO 30, I = 1, J
                     A( I, J ) = A( I, J ) + X( IX )*TEMP1
     $                                     + Y( IY )*TEMP2
                     IX        = IX        + INCX
                     IY        = IY        + INCY
   30             CONTINUE
               END IF
               JX = JX + INCX
               JY = JY + INCY
   40       CONTINUE
         END IF
      ELSE
C
C        Form  A  when A is stored in the lower triangle.
C
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 60, J = 1, N
               IF( ( X( J ).NE.ZERO ).OR.( Y( J ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( J )
                  TEMP2 = ALPHA*X( J )
                  DO 50, I = J, N
                     A( I, J ) = A( I, J ) + X( I )*TEMP1 + Y( I )*TEMP2
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( ( X( JX ).NE.ZERO ).OR.( Y( JY ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( JY )
                  TEMP2 = ALPHA*X( JX )
                  IX    = JX
                  IY    = JY
                  DO 70, I = J, N
                     A( I, J ) = A( I, J ) + X( IX )*TEMP1
     $                                     + Y( IY )*TEMP2
                     IX        = IX        + INCX
                     IY        = IY        + INCY
   70             CONTINUE
               END IF
               JX = JX + INCX
               JY = JY + INCY
   80       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of XDSYR2 .
C
      END

c This routine reserves space at iCore(i0) for an I/O cache.

c The address of iCore(i0) is saved before returning; therefore, there is no
c significance placed on these two variables besides pointing to the usable
c memory heap.

c INPUT
c int ICORE(*) : the memory anchor used to place the cache

c INTPUT/OUTPUT
c int I0 : on input, this is the ICORE index that places the cache
c        : on output, this points to the first integer after the cache
c int IMEM : the amount of usable memory at ICORE(I0)
c int NPRCWD : the desired/actual integer-length of a physical record
c int NSLOTS : the desired/actual number of cache slots

#include "f_types.h"
c#define _DEBUG_ACES_CACHE_INIT

      subroutine aces_cache_init(iCore,i0,iMem,nPRcWd,nSlots)
      implicit none

c ARGUMENTS
      integer iCore(*), i0, iMem, nPRcWd, nSlots

c EXTERNAL FUNCTIONS
      F_ADR c_adr
      external c_adr

c INTERNAL VARIABLES
      double precision dTmp
      F_ADR zTmp
      integer i, ndx, iTmp

c COMMON BLOCKS
#include "cache.com"
#include "filspc.com"
#include "machsp.com" /* for iintln and ifltln */
#include "icdacc.com" /* for idaccm */

c ----------------------------------------------------------------------

c   o the cache subsystem never turns off
      if (bCacheUp) return

c   o turn on the cache subsystem flag
      bCacheUp = .true.

c   o make sure iMem is natural
      if (iMem.lt.1) then
         print *, '@ACES_CACHE_INIT: There is no place for the cache.'
         print *, '   iMem = ',iMem
         call aces_exit(1)
      end if

c   o initialize the filspc common block
c     (set the length of a physical record and cache slot)
      if (nPRcWd.lt.1) then
         print *, '@ACES_CACHE_INIT: The length of a cache slot must ',
     &            'be at least 1 integer long.'
         print *, '                  requested length = ',nPRcWd
         call aces_exit(1)
      end if
      iprcln = nPRcWd*iintln
      iprcwd = nPRcWd
      iprcrl = nPRcWd*idaccm
      if (iand(iprcln,ifltln-1).ne.0) then
         print '(/)'
         print *, '@ACES_CACHE_INIT: WARNING - The length of a cache ',
     &            'slot is not a whole multiple'
         print *, '                  of floating-point numbers. This ',
     &            'will negatively impact'
         print *, '                  performance.'
         print '(/)'
      end if

c   o set the number of cache slots
      if (nSlots.lt.1) then
         print *, '@ACES_CACHE_INIT: There must be at least 1 cache ',
     &            'slot.'
         print *, '                  requested number = ',nSlots
         call aces_exit(1)
      end if
      if (nSlots.gt._MAX_CACHE_SLOTS) then
         print *, '@ACES_CACHE_INIT: There can be at most ',
     &            _MAX_CACHE_SLOTS,' cache slots.'
         print *, '                  requested number = ',nSlots
         print *, '                  resetting to ',_MAX_CACHE_SLOTS
         nSlots = _MAX_CACHE_SLOTS
      end if
      cachnum = nSlots

c   o use ndx to point to the first double boundary in iCore(i0)
#ifdef _PTRS_ARE_WORDS
      zTmp = 1 + c_adr(iCore(i0)) - c_adr(icache(1))
#else
      zTmp = c_adr(iCore(i0))
      if (iand(zTmp,ifltln-1).ne.0) then
         i0 = i0 + 1
         zTmp = c_adr(iCore(i0))
         if (iand(zTmp,ifltln-1).ne.0) then
            print *, '@ACES_CACHE_INIT: The core memory is not aligned.'
            print *, '   &icore[0] = ',c_adr(iCore(1))
            call aces_exit(1)
         end if
         iMem = iMem - 1
      end if
      zTmp = zTmp - c_adr(icache(1))
      if (iand(zTmp,iintln-1).ne.0) then
         print *, '@ACES_CACHE_INIT: The cache anchor is not aligned.'
         print *, '   &icache[0] = ',c_adr(icache(1))
         call aces_exit(1)
      end if
      zTmp = 1+(zTmp/iintln)
#endif /* _PTRS_ARE_WORDS */
      ndx = zTmp
      if (ndx.ne.zTmp) then
         print *, '@ACES_CACHE_INIT: Assertion failed.'
         print *, '                  The I/O cache is not addressable.'
         call aces_exit(1)
      end if
      do i = 1, cachnum
         cachndx(i) = ndx
         ndx = ndx + iprcwd
      end do
#ifdef _DEBUG
      print *, '@ACES_CACHE_INIT: allocated >=',
     &         ishft(iprcln*cachnum,-20),
     &         ' MB of cache from core memory'
#endif

c   o move i0 to a double boundary and decrease iMem
      i = iprcwd * cachnum
      i0 = i0 + i
      zTmp = c_adr(iCore(i0))
#ifdef _PTRS_ARE_WORDS
      if (iand(zTmp,iintfp-1).ne.0) then
         i0 = i0 + 1
         iMem = iMem - 1
      end if
#else
      if (iand(zTmp,ifltln-1).ne.0) then
         i0 = i0 + 1
         iMem = iMem - 1
      end if
#endif /* _PTRS_ARE_WORDS */
      iMem = iMem - i
      if (iMem.lt.1) then
         print *, '@ACES_CACHE_INIT: The total cache size must be less',
     &            ' than the total core size.'
         print *, '                  cache slots = ',cachnum
         print *, '                  slot size   = ',iprcwd,' integers'
         print *, '                  core size   = ',iMem,' integers'
         call aces_exit(1)
      end if

c   o (re)set the cache statistics
      call aces_cache_reset

#ifdef _DEBUG_ACES_CACHE_INIT
      print *, '@ACES_CACHE_INIT: /filspc/ iprcln = ',iprcln,
     &                                  ', iprcwd = ',iprcwd,
     &                                  ', iprcrl = ',iprcrl
      print *, '                  /cache/ cachnum = ',cachnum,
     &                                 ', cachndx = ',cachndx
#endif

      return
c     end subroutine aces_cache_init
      end

c This routine reserves space at iCore(i0) for an I/O cache.

c The address of iCore(i0) is saved before returning; therefore, there is no
c significance placed on these two variables besides pointing to the usable
c memory heap.

c INPUT
c int ICORE(*) : the memory anchor used to place the cache

c INTPUT/OUTPUT
c int I0 : on input, this is the ICORE index that places the cache
c        : on output, this points to the first integer after the cache
c int IMEM : the amount of usable memory at ICORE(I0)
c int NPRCWD : the desired/actual integer-length of a physical record
c int NSLOTS : the desired/actual number of cache slots








c#define _DEBUG_ACES_CACHE_INIT

      subroutine aces_cache_init(iCore,i0,iMem,nPRcWd,nSlots)
      implicit none

c ARGUMENTS
      integer iCore(*), i0, iMem, nPRcWd, nSlots

c EXTERNAL FUNCTIONS
      INTEGER c_adr
      external c_adr

c INTERNAL VARIABLES
      double precision dTmp
      INTEGER zTmp
      integer i, ndx, iTmp

c COMMON BLOCKS
c cache.com : begin

c These common blocks contain global information about the automatic file cache.
c getlst and putlst REQUIRE a cache, hence the term 'automatic' (compared to the
c auxiliary cache controlled by /auxcache/quikget).

c#define _CACHE_BYPASS /* bypasses cache on reading/writing of full records */
c#define _CACHE_HIST
c#define _CACHE_HIST_VERBOSE

      external aces_bd_cache

c icache     : the anchor used to address each cache slot
c cachnum    : the number of usable cache slots
c cachrec(i) : the index of the physical record cached by the data in slot i
c cachfil(i) : the external file unit number that stores the data in slot i
c cachndx(i) : the icache index of slot i
c cachmod(i) : a modification flag used to trigger a writeback

c cachetime   : a cache-event counter
c lrustats(i) : the last 'time' slot i was accessed

      integer        icache(1), cachnum,
     &               cachrec(128),
     &               cachfil(128),
     &               cachndx(128),
     &               cachmod(128)
      common /cache/ icache, cachnum,
     &               cachrec,
     &               cachfil,
     &               cachndx,
     &               cachmod
      save   /cache/

      integer           cachetime, lrustats(128)
      common /cachelru/ cachetime, lrustats
      save   /cachelru/

c cachemiss      : measures cache misses
c cacheskip      : measures read and write bypasses
c cacheread      : measures read hits
c cachewrite     : measures write hits
c cachewriteback : measures writes-back of dirty slots

      integer             cachemiss, cacheskip,
     &                    cacheread, cachewrite, cachewriteback
      common /cache_hist/ cachemiss, cacheskip,
     &                    cacheread, cachewrite, cachewriteback
      save   /cache_hist/

c bCacheUp : a flag for bombing in get/putlst if there is no I/O cache

      logical              bCacheUp
      common /cache_flags/ bCacheUp
      save   /cache_flags/

c cache.com : end
c filspc.com : begin

c This common block contains the dimensions of the physical records used by the
c MOIO storage files.

c iprcln : the    byte-length of a physical record
c iprcwd : the integer-length of a physical record
c iprcrl : the    recl-length of a physical record

      integer         iprcln, iprcwd, iprcrl
      common /filspc/ iprcln, iprcwd, iprcrl
      save   /filspc/

c filspc.com : end


c machsp.com : begin

c This data is used to measure byte-lengths and integer ratios of variables.

c iintln : the byte-length of a default integer
c ifltln : the byte-length of a double precision float
c iintfp : the number of integers in a double precision float
c ialone : the bitmask used to filter out the lowest fourth bits in an integer
c ibitwd : the number of bits in one-fourth of an integer

      integer         iintln, ifltln, iintfp, ialone, ibitwd
      common /machsp/ iintln, ifltln, iintfp, ialone, ibitwd
      save   /machsp/

c machsp.com : end



c icdacc.com : begin
c Nevin 8-30-95 added record length common to facilitate change from
c Bytes to Words for SGI and DecAlpha
      integer         idaccm
      common /icdacc/ idaccm
c icdacc.com : end

c ----------------------------------------------------------------------

c   o the cache subsystem never turns off
      if (bCacheUp) return

c   o turn on the cache subsystem flag
      bCacheUp = .true.

c   o make sure iMem is natural
      if (iMem.lt.1) then
         print *, '@ACES_CACHE_INIT: There is no place for the cache.'
         print *, '   iMem = ',iMem
         call aces_exit(1)
      end if

c   o initialize the filspc common block
c     (set the length of a physical record and cache slot)
      if (nPRcWd.lt.1) then
         print *, '@ACES_CACHE_INIT: The length of a cache slot must ',
     &            'be at least 1 integer long.'
         print *, '                  requested length = ',nPRcWd
         call aces_exit(1)
      end if
      iprcln = nPRcWd*iintln
      iprcwd = nPRcWd
      iprcrl = nPRcWd*idaccm
      if (iand(iprcln,ifltln-1).ne.0) then
         print '(/)'
         print *, '@ACES_CACHE_INIT: WARNING - The length of a cache ',
     &            'slot is not a whole multiple'
         print *, '                  of floating-point numbers. This ',
     &            'will negatively impact'
         print *, '                  performance.'
         print '(/)'
      end if

c   o set the number of cache slots
      if (nSlots.lt.1) then
         print *, '@ACES_CACHE_INIT: There must be at least 1 cache ',
     &            'slot.'
         print *, '                  requested number = ',nSlots
         call aces_exit(1)
      end if
      if (nSlots.gt.128) then
         print *, '@ACES_CACHE_INIT: There can be at most ',
     &            128,' cache slots.'
         print *, '                  requested number = ',nSlots
         print *, '                  resetting to ',128
         nSlots = 128
      end if
      cachnum = nSlots

c   o use ndx to point to the first double boundary in iCore(i0)
      zTmp = c_adr(iCore(i0))
      if (iand(zTmp,ifltln-1).ne.0) then
         i0 = i0 + 1
         zTmp = c_adr(iCore(i0))
         if (iand(zTmp,ifltln-1).ne.0) then
            print *, '@ACES_CACHE_INIT: The core memory is not aligned.'
            print *, '   &icore[0] = ',c_adr(iCore(1))
            call aces_exit(1)
         end if
         iMem = iMem - 1
      end if
      zTmp = zTmp - c_adr(icache(1))
      if (iand(zTmp,iintln-1).ne.0) then
         print *, '@ACES_CACHE_INIT: The cache anchor is not aligned.'
         print *, '   &icache[0] = ',c_adr(icache(1))
         call aces_exit(1)
      end if
      zTmp = 1+(zTmp/iintln)
      ndx = zTmp
      if (ndx.ne.zTmp) then
         print *, '@ACES_CACHE_INIT: Assertion failed.'
         print *, '                  The I/O cache is not addressable.'
         call aces_exit(1)
      end if
      do i = 1, cachnum
         cachndx(i) = ndx
         ndx = ndx + iprcwd
      end do

c   o move i0 to a double boundary and decrease iMem
      i = iprcwd * cachnum
      i0 = i0 + i
      zTmp = c_adr(iCore(i0))
      if (iand(zTmp,ifltln-1).ne.0) then
         i0 = i0 + 1
         iMem = iMem - 1
      end if
      iMem = iMem - i
      if (iMem.lt.1) then
         print *, '@ACES_CACHE_INIT: The total cache size must be less',
     &            ' than the total core size.'
         print *, '                  cache slots = ',cachnum
         print *, '                  slot size   = ',iprcwd,' integers'
         print *, '                  core size   = ',iMem,' integers'
         call aces_exit(1)
      end if

c   o (re)set the cache statistics
      call aces_cache_reset


      return
c     end subroutine aces_cache_init
      end

cjp for management of multiple moio information for multiple references

      subroutine loadmoio
      IMPLICIT INTEGER (A-Z)
#include "bwcc.com"
      COMMON /LISTS/ MOIO(10,500),MOIOWD(10,500),MOIOSZ(10,500),
     &               MOIODS(10,500),MOIOFL(10,500)
      common/io_ptrs/TOTREC(5),TOTWRD(5)

      call icopy(5000, bwmoio  (1,1,iref), 1, moio  (1,1), 1)
      call icopy(5000, bwmoiowd(1,1,iref), 1, moiowd(1,1), 1)
      call icopy(5000, bwmoiosz(1,1,iref), 1, moiosz(1,1), 1)
      call icopy(5000, bwmoiods(1,1,iref), 1, moiods(1,1), 1)
      call icopy(5000, bwmoiofl(1,1,iref), 1, moiofl(1,1), 1)

      call icopy(5,bwtotrec(1,iref),1,totrec(1),1)
      call icopy(5,bwtotwrd(1,iref),1,totwrd(1),1)

      return
      end

      SUBROUTINE ROTT1(ICORE,MAXCOR,IUHF)
C
C THIS ROUTINE ROTATES THE MOLECULAR ORBITALS BY THE T1-LIKE
C  AMPLITUDES ON LISTS 3,90 (AND 4,90 FOR UHF) CALCULATIONS.  THIS
C  ROUTINE GENERATES A NEW SET OF ORTHONORMALIZED MOLECULAR ORBITALS.
C
C Extended to work with dropmo. Ajith Perera, 07/2005.
C
CEND
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION ONE,ONEM,ZILCH
      CHARACTER*1 ISP(2)
      DIMENSION ICORE(MAXCOR)
      DIMENSION NOCC_EXPND(8,2),NVRT_EXPND(8,2),
     &          NOCCO_EXPND(2),NVRTO_EXPND(2)
      COMMON /SYMINF/NSTART,NIRREP,IRREPS(255,2),DIRPRD(8,8)
      COMMON /INFO/ NOCCO(2),NVRTO(2)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /SYM/ POP(8,2),VRT(8,2),NT(2),NF(4)
      COMMON /FLAGS/ IFLAGS(100)
C
      DATA ONE  /1.0/
      DATA ZILCH/0.0/
      DATA ONEM /-1.0/
      DATA ISP /'A','B'/
C
      CALL GETREC(20, "JOBARC", 'NUMDROPA', 1, NDROPMO)
      NBAS=NOCCO(1)+NVRTO(1)
      NBAS2=NBAS*NBAS
      IF (NDROPMO.GT.0) THEN
         NBAS_DROP = NOCCO(1)+NVRTO(1)
         CALL FILL_DROP_MOS(NIRREP, IUHF, NOCC_EXPND, NVRT_EXPND,
     &                      NBAS_FULL, NOCCO_EXPND, NVRTO_EXPND)
         NBAS  = NBAS_FULL
         NBAS2 = NBAS_FULL*NBAS_FULL
      END IF
C
C NOCC_EXPND, POP = The # of occ per irrep in the full and reduced spaces.
C NVRT_EXPND, VRT = The # of vrt per irrep in the full and reduced spaces.
C NOCCO_EXPND, NOCCO = The # of occ in the full and reduced spaces.
C NVRTO_EXPND, NVRTO = The # of vrt in the full and reduced spaces.
C NBAS = The number of basis functions in the full space.
C
      DO 10 ISPIN=1,1+IUHF
       NOCC=NOCCO(ISPIN)
       NVRT=NVRTO(ISPIN)
       IF (NDROPMO.GT.0) THEN
          NOCC=NOCCO_EXPND(ISPIN)
          NVRT=NVRTO_EXPND(ISPIN)
       END IF
       I000=1
       I010=I000+NBAS2*IINTFP
       I020=I010+NBAS2*IINTFP
       I030=I020+NOCC*NVRT*IINTFP
       I040=I030+NOCC*NVRT*IINTFP
       IOFF=IINTFP*(NBAS*NOCC)
C
C GET MO COEFFICIENTS AND T1 VECTOR
C (Always read the MO vectors in the full space.)
C
       IF (NDROPMO.GT.0) THEN
          CALL GETREC(20,'JOBARC','SCFEVC'//ISP(ISPIN)//'0',
     &                NBAS2*IINTFP,ICORE(I000))
       ELSE
          CALL GETREC(20,'JOBARC','SCFEVEC'//ISP(ISPIN),
     &                NBAS2*IINTFP,ICORE(I000))
       END IF
       CALL SCOPY (NBAS2,ICORE(I000),1,ICORE(I010),1)
       CALL GETLST(ICORE(I020),1,1,1,2+ISPIN,90)
C
       IF (NDROPMO.GT.0) THEN
          CALL EXPAND_T1(ICORE(I030),ICORE(I020),NIRREP,
     &                   NOCC_EXPND(1,ISPIN),NVRT_EXPND(1,ISPIN),
     &                   NOCCO(ISPIN),NVRTO(ISPIN),
     &                   NOCCO_EXPND(ISPIN),NVRTO_EXPND(ISPIN),
     &                   SYMP_OVFUL)
          CALL DCOPY(SYMP_OVFUL, ICORE(I030), 1, ICORE(I020), 1)
       END IF
C
C EXPAND T1 VECTOR TO FULL SIZE 
C
       CALL EXPT1(ICORE(I020),ICORE(I030),NOCC,NVRT,
     &            NOCC_EXPND,NVRT_EXPND,NOCCO_EXPND,NVRTO_EXPND,
     &            NDROPMO,ISPIN)
C
C DO ORBITAL ROTATIONS - FIRST GENERATE NEW VIRTUAL ORBITALS
C
       CALL XGEMM ('N','T',NBAS,NVRT,NOCC,ONEM,ICORE(I000),
     &             NBAS,ICORE(I020),NVRT,ONE,
     &             ICORE(I010+IOFF),NBAS)
C
C NOW GENERATE NEW OCCUPIED ORBITALS
C
       CALL XGEMM('N','N',NBAS,NOCC,NVRT,ONE,ICORE(IOFF+I000),
     &            NBAS,ICORE(I020),NVRT,ONE,ICORE(I010),NBAS)
       CALL PUTREC(20,'JOBARC','SCFEVEC'//ISP(ISPIN),NBAS2*IINTFP,
     &             ICORE(I010))
C
C THESE ORBITALS ARE NOT ORTHONORMAL, AND NOW NEED TO BE ORTHONORMALIZED.
C  USE LOWDIN ORTHONORMALIZATION.
C
C
C GET AO OVERLAP MATRIX AND TRANSFORM TO MO BASIS
C
       CALL GETREC(20,'JOBARC','AOOVRLAP',NBAS2*IINTFP,ICORE(I000))
       CALL AO2MO2(ICORE(I000),ICORE(I000),ICORE(I010),ICORE(I020),
     &             NBAS,NBAS,ISPIN)
C
C NOW FORM S**(-1/2) IN THE MO BASIS
C
       CALL EIG(ICORE(I000),ICORE(I010),NBAS,NBAS,0)
       CALL INVSQT(ICORE(I000),NBAS+1,NBAS)
       CALL XGEMM('N','N',NBAS,NBAS,NBAS,ONE,ICORE(I010),NBAS,
     &            ICORE(I000),NBAS,ZILCH,ICORE(I020),NBAS)
       CALL XGEMM('N','T',NBAS,NBAS,NBAS,ONE,ICORE(I020),NBAS,
     &            ICORE(I010),NBAS,ZILCH,ICORE(I000),NBAS)
C
C NOW TRANSFORM MO VECTOR TO ORTHONORMAL REPRESENTATION
C
       CALL GETREC(20,'JOBARC','SCFEVEC'//ISP(ISPIN),NBAS2*IINTFP,
     &             ICORE(I010))
       CALL XGEMM('N','N',NBAS,NBAS,NBAS,ONE,ICORE(I010),NBAS,
     &            ICORE(I000),NBAS,ZILCH,ICORE(I020),NBAS)
C
C REORDER MO COEFFICIENTS SO THAT SCF CAN READ THEM
C
       CALL PUTREC(20,'JOBARC','SCFEVC'//ISP(ISPIN)//'0',
     &             NBAS2*IINTFP,ICORE(I020))
       IF(IUHF.EQ.0)THEN
        CALL PUTREC(20,'JOBARC','SCFEVCB0',
     &             NBAS2*IINTFP,ICORE(I020))
       ENDIF
C
10    CONTINUE
C
C Restore the occupation to the full mo basis. The records OCCUPY(A0|B0)
C are saved in vtran/dropvc.F and contain the original full occupation.
C The same goes for MODROPA0 and REORDEA0. See dropvc for further info.
C
      IF (NDROPMO.GT.0) THEN
cSSS         CALL GETREC(20,'JOBARC','OCCUPYA0',NIRREP,ICORE)
cSSS         CALL PUTREC(20,'JOBARC','OCCUPYA0',NIRREP,ICORE)
cSSS         IF (IUHF.GT.0) THEN
cSSS            CALL GETREC(20,'JOBARC','OCCUPYB0',NIRREP,ICORE)
cSSS            CALL PUTREC(20,'JOBARC','OCCUPYB0',NIRREP,ICORE)
cSSS         END IF
      ELSE
         CALL GETREC(20,'JOBARC','OCCUPYA ',NIRREP,ICORE)
         CALL PUTREC(20,'JOBARC','OCCUPYA0',NIRREP,ICORE)
         IF (IUHF.GT.0) THEN
            CALL GETREC(20,'JOBARC','OCCUPYB ',NIRREP,ICORE)
            CALL PUTREC(20,'JOBARC','OCCUPYB0',NIRREP,ICORE)
         END IF
      END IF
      IF (NDROPMO.GT.0) THEN
         CALL GETREC(20,'JOBARC','MODROPA0',NDROPMO,ICORE(I000))
         CALL PUTREC(20,'JOBARC','MODROPA ',NDROPMO,ICORE(I000))
         CALL GETREC(20,'JOBARC','REORDEA0',NBAS,ICORE(I000))
         CALL PUTREC(20,'JOBARC','REORDERA',NBAS,ICORE(I000))
         IF (IUHF.GT.0) THEN
            CALL GETREC(20,'JOBARC','MODROPB0',NDROPMO,ICORE(I000))
            CALL PUTREC(20,'JOBARC','MODROPB ',NDROPMO,ICORE(I000))
            CALL GETREC(20,'JOBARC','REORDEB0',NBAS,ICORE(I000))
            CALL PUTREC(20,'JOBARC','REORDERB',NBAS,ICORE(I000))
         END IF
      END IF
      CALL PUTREC(20,'JOBARC','IFLAGS  ',100,IFLAGS)
C
      RETURN
      END

      Subroutine A3_Ecp_grdint_driver(Ecpgrdint, Ntotatoms, Natoms, 
     &                                Iloc, Isoc, IGenby, Coord, 
     &                                Grads, Spherical)

c----------------------------------------------------------------------
c     Ecp_int_driver drives the calculation of 1e-matrices in the basis of
c     cartesian atomic orbitals using subroutine ecp_int.
c----------------------------------------------------------------------
c     tol    = integral cutoff (ints to be neglected, if value expected
c              to be < exp(-tol)(i)
c     Cint   = 1e-integral array ('batch') of dimension nfij
c       
c----------------------------------------------------------------------
      implicit double precision (a-h,o-z)
C-----------------------------------------------------------------------
#include "ecp.par"
#include "ecp.com"
C Ecpints need to be (2*Maxang+1)**2 times the square of the 
C maximum number of contracted functions per shell (currently
C set at 20 for ECP integrals). The current Max_cbf is 1000. 

C Modification to compute ECP integrals in a suitable form
C for ACES III parallel implementation. Since ACES III disregard
C symmetry, all the logic relating to symmtery is removed (the
C reason that symmetry logic there in the first place is that
C this code is written to use both in ACES II and III. 08/2013,
C Ajith Perera.
C
      Logical Grads, Zero_int, Spherical

      dimension Cint(Maxmem_a3), Ecpint_4Shell(Maxints_4shell),
     &          Ecpgrd_x(Maxints_4shell), Ecpgrd_y(Maxints_4shell), 
     &          Ecpgrd_z(Maxints_4shell),
     &          IGenby(Ntotatoms), Coord(3,Ntotatoms),
     &          Ecpgrdint(Ntotatoms,3,*)
C
#ifdef _DEBUG_LVL0
CSS      Nshell = 2
      Write(6,"(a,2I3)") "The Debug value for Nshell: ", Nshell,
     &                    Ntotatoms
      do  i=1,nshell
         write(*,*) 'nshell=',i
         write(*,3913) i,katom(i),i,ktype(i)
3913     format('katom<',i2,'>  ',i2,' ktype<',i2,'>  ',i2)
         write(*,3914) i,kprim(i),i,kbfn(i)
3914     format('kprim<',i2,'>  ',i2,' kbfn<',i2,'>   ',i2)
         write(*,3915) i,nprims(i),i,ndegen(i)
3915     format('nprims<',i2,'> ',i2,' ndegen<',i2,'> ',i2)
         write(*,3916) i,kmini(i),i,kmaxi(i)
3916     format('kmini<',i2,'>  ',i2,' kmaxi<',i2,'>  ',i2)
         write(*,*)
      enddo
#endif
C
      Iloc   = 0
      Isoc   = 0
C
CSSS      Do Icent = 1, Ntotatoms 

      do ishell = 1, Nshell

CSSS      do ishell = 1, 1
C
        iatom  = katom(ishell)

CSSS        If (IGenby(Icent) .EQ. Iatom) Then

        xa = Coord(1,Iatom)
        ya = Coord(2,Iatom)
        za = Coord(3,Iatom)
        la = ktype(ishell) - 1

        kprimi=kprim(ishell)-1
        idegen=ndegen(ishell)
        idegen_grd=Ideg_grd(la)
        numcoi=numcon(ishell)

C begin loop jshell 
 
        Jloc = 0
        Jsoc = 0

CSSS        Do Jcent = 1, Ntotatoms

        do jshell=1, Nshell

CSSS        do jshell=1, 1

C
C get symmetry infor regarding shell j
C
          jatom=katom(jshell)
          lb = ktype(jshell) - 1
          Jdegen=ndegen(jshell)
C
CSSS          If (IGenby(Jcent) .EQ. Jatom) Then
 
          xb=Coord(1,Jatom)
          yb=Coord(2,Jatom)
          zb=Coord(3,Jatom)

          kprimj=kprim(jshell)-1
          numcoj=numcon(jshell)

C Get the density for this shell pair.
     
CSSS          Call Dzero(Dens_4shell, Maxints_4shell)
CSSS          Call Get_shell_den(Dens_fao, Dens_4shell, Naobfns, La, Lb,
CSSS     &                       Iloc, Jloc, Numcoi, Numcoj)

          Do iprim = 1, nprims(ishell)
CSSS          Do iprim =1, 1

             exp1 = expnt(kprim(ishell)+iprim-1)
             Indnpri = Kprimi + Iprim
                     
            Do jprim = 1, nprims(jshell)
CSSS            Do jprim = 1, 1 

CSS                Call Dzero(Ecpint_4shell, Maxints_4shell)
CSS                Call Dzero(Cint, Maxmem_a3)

                exp2 = expnt(kprim(jshell)+jprim-1)
                Indnprj = Kprimj + Jprim
C
#ifdef _DEBUG_LVL0
      Write(6, "(a, 4(1x,I2))") "The Ishell, Jshell, La, Lb: ", 
     &                           Ishell, Jshell, La, Lb
      Write(6, "(a, 4(1x,I2))") "The prim. pair; Iprim, Jprim",
     &                           Iprim, Jprim
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of A : ", Xa, ya, Za
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of B : ", Xb, yb, Zb
      Write(6, "(a, 2(1x,F10.6))") "The Primtive pair: ", Exp1, Exp2
      Write(6,*)
      Write(6,*) "Initilize debug data"
#endif 
#ifdef _DEBUG_LVLM
      Write(6,"(a)") "Initilize debug xyz of A and B"
      xa = 1.0
      ya = 1.0
      za = 1.0
      xb = -1.0
      yb = -1.0
      zb = -1.0
      exp1 = 1.5
      exp2 = 1.5 
      La = 2
      Lb = 2
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of A : ", Xa, ya, Za
      Write(6, "(a, 3(1x,F10.6))") "The XYZ of B : ", Xb, yb, Zb
      Write(6, "(a, 2(1x,F10.6))") "The Primtive pair: ", Exp1, Exp2
      Write(6,*)
#endif
                Do Icnt = 1,  Ntotatoms

CSSS                   Isym_unq_cnt = IGenby(Icnt)
                   Isym_unq_cnt = Icnt

                   If (Ipseux(Icnt) .NE. 0) Then
                      
CSSS                      If (.NOT. (Grads .AND. Icent .EQ. Icnt)) Then
CSSS                         Iecp_cnt = Isym_unq_cnt

                      If (.NOT. (Grads .AND. Iatom .EQ. Icnt)) Then
                          Iecp_cnt = Icnt
C
                         Call Dzero(Ecpint_4shell, Maxints_4shell)
                         Call Dzero(Cint, Maxmem_a3)
 
                         Call Ecp_grdint_4prim(Xa, Ya, Za, Xb, Yb, 
     &                                         Zb, La, Lb, Coord, Exp1,
     &                                         Exp2, Natoms, Ntotatoms, 
     &                                         Cint, Int, Zero_int, 
     &                                         Icnt, Iecp_cnt, Grads)

                         If (.NOT. Zero_int)
     &                   Call ecp_int_4shell(Cint, Ecpint_4shell, 
     &                                       La, Lb, Numcoi, Numcoj, 
     &                                       Indnpri, Indnprj, Iprim,
     &                                       Jprim, Jnt, Grads)
#ifdef _DEBUG_LVL0
      Write(6,*)
      Write(6,"(a,6(1x,I2))")
     &"The Contracted integral for shell pair", Ishell, JShell, Iprim,
     & Jprim, Idegen_grd, Jdegen
       Do I = 1, Idegen_grd
          Write(6,"(4(1x,F20.13))")(Ecpint_4shell((I-1)*Jdegen+J),
     &                                 J=1,Jdegen)
      Enddo
#endif

                         Call A3_Ecpgrd_int(Ecpint_4shell, La, Lb, 
     &                                      Idegen_grd, Idegen,
     &                                      Jdegen, Numcoi, Numcoj,
     &                                      Iprim, Jprim, Exp1, Exp2,
     &                                      Ecpgrd_x, Ecpgrd_y, 
     &                                      Ecpgrd_z, Ntotatoms, 
     &                                      Iatom, ICnt)
                        
                         Call Ecp_grdint(Ecpgrdint, Ecpgrd_X, Ecpgrd_Y,
     &                                   Ecpgrd_Z, La, Lb, Iloc, Jloc, 
     &                                   Isoc, Jsoc, Numcoi, Numcoj, 
     &                                   Iatom, Icnt, Ntotatoms,
     &                                   Spherical)

                      Endif
                   Endif 
C
                Enddo
C
             Enddo
          Enddo        

          Jloc = Jloc + (Lb+1)*(Lb+2)*Numcoj/2
          Jsoc = Jsoc + (2*Lb+1)*NUmcoj

CSSS        Endif 
        Enddo
CSSS        Enddo
        Iloc = Iloc + (La+1)*(La+2)*Numcoi/2
        Isoc = Isoc + (2*La+1)*Numcoi

CSSS      Endif 

      Enddo 

#ifdef _DEBUG_LVL0
       Nint = Iloc
       If (SPherical) Nint = Isoc 
       Write(6, "(a)") "The ECP derivative integral atom:xyz:int"
       Do icent = 1, Ntotatoms 
          w=0.0d0
          DO Ixyz = 1, 3 
                Write(6, "(6(1x,F12.6))") (Ecpgrdint(Icent,Ixyz,I),
     &                                    i=1, Nint)
             DO I = 1, Nint 
                w = w+Ecpgrdint(Icent,Ixyz,I)*Ecpgrdint(Icent,Ixyz,I)
             Enddo
          Enddo
       Write(6, "(a,(1x,F20.13))") "The ecpgrdint. check sum = ", w 
       Enddo 
#endif 
  
CSSS      Enddo

      return
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE ROTM( IAXIS, ANG, IX, RT )
C
C     FORMS THREE DIMENSIONAL ROTATION MATRIX (IX=0 IF ANG IN RADS,
c     IX=1 IF DEG,  ADD 10 TO IX TO GET TRANSPOSE)
cend
*mdc*if cray
*      implicit none
*mdc*endif
      implicit double precision (a-h,o-z)
      dimension rt(3,3)
      integer ix
c      double precision ang, RT(3,3)
c
      integer iaxis, iaxis1, iaxis2
c      double precision sign, tang
C     
c
      CALL ZERO(RT,9)
      TANG=ANG
      IF ( mod(IX,10) .EQ. 1 ) TANG = ANG * DACOS(-1.D0)/180.D0
c
      sign = 1.0 d0
      if ( ix/10 .gt. 0 ) sign = -sign
c
c     next two axes
c     --  really mod( (iaxis-1)+1, 3 ) + 1 (clock, not mod, arithmetic)
      iaxis1 = mod(iaxis ,3)+1
      iaxis2 = mod(iaxis1,3)+1
c
      rt(iaxis,iaxis) = 1.0 d0
      RT(iaxis1, iaxis1) = COS(TANG)
      RT(iaxis2, iaxis2) = COS(TANG)
c
      rt(iaxis1,iaxis2) = sin(tang) * sign
      rt(iaxis2,iaxis1) = -rt(iaxis1,iaxis2)
c
      RETURN
      END

c This subroutine reserves NUM elements on the stack and returns the index
c where they may be stored.

c OUTPUT
c int INDX : the stack index
c             = -1; the stack is exhausted
c            != -1; upward and onward

c INPUT
c int ID  : the stack handle (from LIFO_NEW)
c int NUM : the number of elements to reserve (0 is a valid value)

      subroutine lifo_get(id,indx,num)
      implicit none

      integer id, indx, num



      integer           lifo(4,100), nStacks
      common /lifo_com/ lifo, nStacks
      save   /lifo_com/



      if (num.lt.0) then
         print *, '@LIFO_GET: Assertion failed.'
         print *, '           num = ',num
         call c_exit(1)
      end if
      if (id.lt.1.or.nStacks.lt.id) then
         print *, '@LIFO_GET: Invalid stack id ',id
         print *, '           Must be between 1 and ',nStacks
         call c_exit(1)
      end if
      if (lifo(2,id).eq.-1) then
         print *, '@LIFO_GET: stack ',id,' is invalid'
         call c_exit(1)
      end if

      indx = lifo(2,id)
      if (num.lt.1) return

      lifo(2,id) = lifo(2,id)+num
      if (lifo(1,id).le.lifo(4,id).and.lifo(4,id)+1.lt.lifo(2,id)) then
         lifo(2,id) = lifo(2,id)-num
         indx = -1
      end if
      lifo(3,id) = max(lifo(2,id),lifo(3,id))

      return
c     end subroutine lifo_get
      end

c This function returns the first sensical integral value of the string, sz.
c It ignores whitespace before the first character and between the sign,
c if any, and the first digit. WARNING, it will return zero if the string
c is empty.

      integer function atoi(sz)
      implicit none

      character*(*) sz

      integer fnblnk, f_strpbrk, iachar

      integer ndx, iLength
      integer iInt, iTmp
      logical bNeg, bTmp

c   o quit if the string is empty
      ndx = fnblnk(sz)
      if (ndx.eq.0) then
         atoi = 0
         return
      end if
      iLength = len(sz)

c   o iInt will be the local atoi value
      iInt = 0

c   o record a sign
      bNeg = (sz(ndx:ndx).eq.'-')
      iTmp = f_strpbrk('-+',sz(ndx:ndx))
      if (iTmp.gt.0) then
         if (ndx.eq.iLength) then
            atoi = 0
            return
         end if
         iTmp = fnblnk(sz(ndx+1:))
         ndx  = ndx + iTmp
      end if

c   o scan the digits
      bTmp = .true.
      do while (bTmp)
         iTmp = iachar(sz(ndx:ndx)) - 48
         if (iTmp.ge.0.and.iTmp.le.9) then
            iInt = 10*iInt + iTmp
            ndx  = ndx + 1
            bTmp = (ndx.le.iLength)
         else
            bTmp = .false.
         end if
      end do

C   o negate the result if necessary and assign atoi
      if (bNeg) iInt = -iInt
      atoi = iInt

      return
      end

C    Routine on VAX to emulate CRAY SCILIB routine, MXM p. 4-22
C         LIBRARY manual, implemented in VAX single precision.
C
C This routine replaces the brain dead matrix multiply used here with
C   a call to the blas routine.
C SG 4/96

      SUBROUTINE MXM(A,NAR,B,NAC,C,NBC)
      INTEGER NAR,NAC,NBC
      DOUBLE PRECISION A(NAR,*),B(NAC,*),C(NAR,*)
      DOUBLE PRECISION ONE,ZILCH
      PARAMETER (ONE=1.0D0, ZILCH=0.0D0)
      CALL XGEMM('N','N',NAR,NBC,NAC,
     &           ONE,  A,NAR,
     &                 B,NAC,
     &           ZILCH,C,NAR)
      RETURN
      END

c NAME
c      MXM - Computes matrix-times-matrix product (unit increments)
c
c SYNOPSIS
c      CALL MXM(a,nra,b,nca,c,ncb)
c
c DESCRIPTION
c      MXM computes the nra-by-ncb matrix product C = AB of the nra-by-nca
c      matrix A and the nca-by-ncb matrix B.
c
c      This routine has the following arguments:
c
c      a      Real array of dimension (nra,nca).  (input)
c             Matrix A, the first factor.
c
c      nra    Integer.  (input)
c             Number of rows in A (same as number of rows in C).
c
c      b      Real array of dimension (nca,ncb).  (input)
c             Matrix B, the second factor.
c
c      nca    Integer.  (input)
c             Number of columns in A (same as number of rows in B).
c
c      c      Real array of dimension (nra,ncb).  (output)
c             Matrix C, the product AB.
c
c      ncb    Integer.  (input)
c             Number of columns in B (same as number of columns in C).
c
c NOTES
c      You should use the Level 3 Basic Linear Algebra Subprogram (Level 3
c      BLAS) SGEMM(3S) rather than MXM.  BLAS routines are preferred because
c      they are the de facto standard linear algebra interface.  Using Level
c      3 BLAS routines will enhance your program's portability, and also
c      should enhance its performance portability.
c
c      For example,
c
c           CALL MXM(A,NRA,B,NCA,C,NCB)
c
c      is equivalent to,
c
c           CALL SGEMM('N','N',NRA,NCB,NCA,1.0,A,NRA,B,NCA,0.0,C,NRA)
c
c      MXM is restricted to multiplying matrices that have elements stored by
c      columns in successive memory locations.  MXMA(3S) is a general
c      subroutine for multiplying matrices that can be used to multiply
c      matrices that do not satisfy the requirements of MXM (although SGEMM
c      also supersedes MXMA).  If B and C have only one column, MXV(3S) or
c      MXVA(3S) (both superseded by Level 2 BLAS routine SGEMV, see
c      SGEMV(3S)) are similar subroutines, each of which computes the product
c      of a matrix and a vector.
c
c CAUTIONS
c      The product must not overwrite either factor.  For example, the
c      following call will not (in general) assign the product AB to A:
c
c           CALL MXM(A,NRA,B,NCA,A,NCA)

      SUBROUTINE CURVE(SCRATCH, EHESS, CURVTRE, NDIM, NX)
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C
      DIMENSION SCRATCH(NX*NX), EHESS(NDIM, NDIM)
C
      DATA SUM1 /0.0D0/, SUM2 /0.0D0/, SUM3 /0.0D0/
      
      DO 10 I = 1, NDIM
C
         SUM1 = SUM1 + EHESS(I, I)**4*SCRATCH(I + 2*NDIM)**2
         SUM2 = SUM2 + EHESS(I, I)**2*SCRATCH(I + 2*NDIM)**2
         SUM3 = SUM3 + EHESS(I, I)**3*SCRATCH(I + 2*NDIM)**2
C
 10   CONTINUE
      
      CURVTRE = DSQRT(DABS(SUM1*SUM2 - SUM3**2))/DSQRT(DABS((SUM2**3)))
C
      RETURN
      END

c dy(i) += da*dx(i)

      subroutine xaxpy(n,da,dx,incx,dy,incy)
      implicit none
      double precision dx(*),dy(*),da
      integer i,incx,incy,ix,iy,p,n

      if (n.le.0 .or. da.eq.0.d0) return

      if (incx.eq.1.and.incy.eq.1) then






         p = iand(n,3)
         do i = 1, p
            dy(i) = dy(i) + da*dx(i)
         end do
         do i = 1+p, n, 4
            dy(i)   = dy(i)   + da*dx(i)
            dy(i+1) = dy(i+1) + da*dx(i+1)
            dy(i+2) = dy(i+2) + da*dx(i+2)
            dy(i+3) = dy(i+3) + da*dx(i+3)
         end do


      else

         ix = 1
         iy = 1
         if (incx.lt.0) ix = 1 + (-n+1)*incx
         if (incy.lt.0) iy = 1 + (-n+1)*incy
         do i = 1, n
            dy(iy) = dy(iy) + da*dx(ix)
            ix = ix + incx
            iy = iy + incy
         end do

      end if

      return
c     end subroutine xaxpy
      end

      SUBROUTINE TOPT1S(ISPIN,ILIST,NTOP,NT1SIZ,NOCC,
     &                  NVRT,NSMSZ,T,TOPT1,
     &                  SYVEC,ITOPT1,I,A,TYPE)
C
C THIS ROUTINE PICKS UP A T1 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT1 AND THEIR ASSOCIATED INDICES
C  IN THE I AND A VECTORS.
C
C INPUT:
C       ISPIN - THE LIST SUBTYPE
C       ILIST - THE LIST NUMBER
C       NTOP  - THE NUMBER OF LARGEST AMPLITUDES (BY ABSOLUTE VALUE)
C               WHICH ARE TO BE FOUND
C       NT1SIZ- THE TOTAL SIZE OF THE T1 VECTOR
C       NOCC  - THE NUMBER OF OCCUPIED ORBITALS OF THIS SPIN TYPE
C       NVRT  - THE NUMBER OF VIRTUAL ORBITALS OF THIS SPIN TYPE
C       NSMSZ - THE TOTAL SIZE OF THE SYMMETRY VECTOR (NOCC*NVRT)
C       SYVEC - THE SYMMETRY VECTOR FOR THE A,I OR a,i LIST
C       TYPE  - ???????????
C
C OUTPUT:
C       TOPT1 - THE NTOP LARGEST ELEMENTS IN THE T1 VECTOR
C               SORTED BY ABSOLUTE VALUE
C       I     - THE I INDICES CORRESPONDING TO THE VALUES IN TOPT1
C       A     - THE A INDICES CORRESPONDING TO THE VALUES IN TOPT1
C
C SCRATCH:
C
C       T     - USED TO HOLD THE SYMMETRY-PACKED T VECTOR
C       ITOPT1- USED TO HOLD THE OFFSETS CORRESPONDING TO THE
C               ELEMENTS IN TOPT1
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A(NTOP),SYVEC(NSMSZ)
      CHARACTER*2 SPCASE(3)
      CHARACTER*1 TYPE
      DIMENSION T(NT1SIZ),TOPT1(NTOP),ITOPT1(NTOP),I(NTOP)
      COMMON /MACHSP/ IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON /INFO/ NOCCO(2),NVRTO(2)
cjp





cjp
cjp data for multireference state specific Brillouin-Wigner CC method
cjp coded by Jiri Pittner 1998-2000
cjp
      logical isbwcc,masik,isactive,bwgossip,useeq429,scfrefread
      logical bwwarning
      character*256 bwwarntext
      real*8 ecorrbw0,ecorrbw,epsilon0,fockcontr,denomblow,fockcd
      real*8 heff,heffevalr,heffevali,heffevecl,heffevecr,hdiagcontr
      real*8 fock2elcontr,enerscf,hcore,lambdahomotop,hfakt,diishonset
      real*8 fock2elcontr0,enerscf0,cbwstate,totmaxdenom,heffevecrold
      real*8 intruder,hfaktmax
      integer maxorb,maxref,nref, iref, iocc,iocc0
      integer iphnum,invpnum,invhnum,nbwstates,ibwstate
      integer ibwconvg,internfrom,internto,internnum,internindex
      integer ibwpass
      integer nactive,numactive,ihubaccorr,ihomotop
      integer internfrom1,internto1,internindex1,internnum1
      integer ihefferank, iheffefrom, iheffeto, iheffespin, maxexcit
      integer correctiontype
      integer maxbwwarnings, nproc, myproc
c
      parameter(maxorb=512,maxref=32,maxexcit=9,maxbwwarnings=10)
c      NOTE!!! change of maxorb parameter requires format change
c              and character* change in bwread routine!!!
      parameter(denomblow=1d250)
c

cjp common has been splitted in order to avoid problems
cjp with padding on different 32 and 64 bit architectures

      common/bwccint/isbwcc, masik, nref, iref,iocc(maxorb,maxref,2),
     +     iphnum(maxorb,maxref,2),invpnum(maxorb,maxref,2),
     +     invhnum(maxorb,maxref,2),
     +     isactive(maxorb,2),nbwstates,ibwstate(maxref+1),
     +     internfrom(maxref*(maxref-1)/2,maxref,3),
     +     internto(maxref*(maxref-1)/2,maxref,3),
     +     internindex(maxref*(maxref-1)/2,maxref,3),
     +     internnum(maxref,3),
     +     internfrom1(maxref*(maxref-1)/2,maxref,2),
     +     internto1(maxref*(maxref-1)/2,maxref,2),
     +     internindex1(maxref*(maxref-1)/2,maxref,2),
     +     internnum1(maxref,2),
     +     ibwpass,ibwconvg(maxref),bwgossip,useeq429,
     +     nactive(2),numactive(maxorb,2),ihubaccorr, ihomotop,
     +     iocc0(maxorb,2),scfrefread,
     +     ihefferank(maxref,maxref),iheffefrom(maxexcit,maxref,maxref),
     +     iheffeto(maxexcit,maxref,maxref),
     +     iheffespin(maxexcit,maxref,maxref),
     +     correctiontype,bwwarning(maxbwwarnings),
     +     bwwarntext(maxbwwarnings),nproc,myproc

      common/bwccreal/ecorrbw,epsilon0,cbwstate(maxref+1),
     +     fockcontr(maxorb*(maxorb+1)/2,2),fockcd(maxorb,maxref,2),
     +     heff(maxref,maxref),heffevalr(maxref),heffevali(maxref),
     +     heffevecl(maxref,maxref),heffevecr(maxref,maxref),
     +     hdiagcontr(maxref), fock2elcontr(maxorb,2),
     +     enerscf(maxref), hcore(maxorb,2),
     +     lambdahomotop,hfakt,diishonset,enerscf0,
     +     fock2elcontr0(maxorb,2),ecorrbw0,totmaxdenom,
     +     heffevecrold(maxref,maxref),intruder,hfaktmax

c
c
cjp BRIEF DESCRIPTION OF VARIABLES INTRODUCED FOR THE MR-BWCC ROUTINES
cjp IN FACT, A LOT OF THAT COULD BE USEFUL FOR ANY HILBERT-SPACE MR-CC
c
c
c isbwcc ... flag for doing bwcc calculation
c maxbwwarnings, bwwarning, bwwarntext ... serious warnings will be
c    summarized at the end of xvcc output for the user's' convenience
c ihefferank(jref,iref) ... degree of excitation between jref and iref
c iheffefrom(maxexcit,jref,iref) , iheffeto, iheffespin ... list of
c    indices of that excitation, sorted according to spin and then the
c    indices, numbers stored are defined as effective particle-hole
c    indices of reference iref
c ihomotop ... whether to use homotopic transition to the
c    size-extensivity correction, after which iteration (if .ne.0)
c lambdahomotop scaling factor of the geometrical series of
c    lambda 1->0 transition
c hfakt ... current value of the homotopy parameter
c hfaktmax ... maximal homotopy parameter allowed to consider cc
c    equations converged
c diishonset ... at which value of hfact restart diis convergence acceleration
c masik ... prepare sorted integral file for the program by Masik and stop
c nref ... number of reference configurations
c iref ... current reference configuration and fermi vacuum
c bwgossip ... switch on debugging output
c ibwpass ... routines like newt2 have to be splitted in two passes -
c    construction of Heff and amplitude update after heff is diagonalized
c    for backw. compatibility, instead of introducing a new routine
c    the same routine does different things being called twice with
c    different ibwpass value
c ecorrbw ... correlation energy from BWCC - Heff(iref,iref) ...
c    denominator correction
c ecorrbw0 .... ecorrbw, but not scaled by the homotopic factor hfact
c denomblow ... huge number to cause division underflow - used for
c    zeroing out the internal amplitudes automatically
c nactive(spin): total count of active spinorbitals
c numactive(i=1..nactive,spin): number of i-th active spinorbital
c    in sequential numbering
c isactive(maxorb,spin): belongs given orbital to the active space?
c    for RHF, the beta ones must be initialized to be identical with alpha ones
c iocc(maxorb,1..nref,spin): defines the nref reference configurations
c    for both RHF and UHF:  iocc(i,iref,spin)=0 or 1
c iphnum(orbital no, iref, spin): gives the effective number of orbital
c    (both particle and hole ones are counted starting from 1)
c invpnum(eff.p.orb.,iref,spin): gives true orbital no. from the
c    effective particle one
c invhnum(eff.h.orb.,iref,spin): gives true orbital no. from the
c    effective hole one
c    all these three ones must be in RHF case initialised to be equal in the
c    alpha and beta parts to keep the code unique and simple
c internfrom(sequence counter n,iref,ispin) is for the ab spin case, the
c    other ones have to be iuhf-indexed
c    internfrom, internto: they are first and second index of n-th internal
c    excitation when processing reference given by second index to the array
c
c internindex(sequence counter,iref,ispin) is the position of
c    corresponding denominator in the denominator list
c internnum(iref,ispin) - number of internal excitation in that
c    category = max sequence counter here ispin=1,2,3 for AA,BB,AB
c internfrom1 etc. are analogous quantities for monoexcitations, here
c    ispin =1,2 note for later: all intern.... quantities are irrep-specific!
c fockcontr(findex(i,j),ispin) ... addition to the fock matrix of
c    reference no.1 to obtain the fock matrix of current reference
c    (fermi vacuum)
c fockcd(i,iref,ispin) ... diagonal part of that correction for ref. no. iref.
c hcore(i,ispin) ... one electron diagonal hamiltonian elements
c fock2elcontr(i,ispin) ... 2el contribution to the diagonal fock element
c    used temporarily
c hdiagcontr(iref) ... contribution of differences of HF energies of
c    different Fermi vacua to diagonal Heff elements
c enerscf(iref) ... HF energy of iref-th fermi vacuum
c ihubaccorr ... =1 ... calculate the size extenzivity correction for BWCC
c                =2,3 ... second and third pass of that calculation
c iocc0(maxorb,2) ... like iocc, but for dummy reference configuration
c    corresponding to SCF WF
c fock2elcontr0(maxorb,2) ... like fock2elcontr0 but for dummy reference
c    configuration
c enerscf0 ... like enerscf, but for dummy reference config
c scfrefread ... tells to bwprep that SCF reference has been read from input
c    and should not be generated automatically from nocc(ispin)
c nbwstates ... how many states to average
c ibwstates(1..nbwstates),cbwstates() ... their numbers and coefficients
c correctiontype ... 0=DC,L T2 term is removed/scaled, 1=DC/L term is not
c    removed/scaled
c totmaxdenom ... max 1/denom found for given reference's' fermi vacuum -
c    as indication of possible intruder problem
c intruder ... limit of 1/denom to be considered intruder and its
c    amplitude zeroed
c for parallelization
c nproc ... number of processors (counted from 1)
c myproc ... number of the processor currently executing the code
c    (counted from 1)



      DATA SPCASE /'AA','BB','AB'/
C
C THIS ROUTINE PICKS UP A T1 VECTOR FROM MOIO(ISPIN,ILIST) AND RETURNS
C  THE NTOP LARGEST ELEMENTS IN TOPT1 AND THEIR ASSOCIATED INDICES
C  IN THE I AND A VECTORS.
C
C
C STATEMENT FUNCTIONS
C
      IGETI(IX,NUMA)=1+(IX-1)/NUMA
      IGETA(IX,NUMA)=IX-(IGETI(IX,NUMA)-1)*NUMA
      NNM1O2(IX)=(IX*(IX-1))/2
C
      IF(NT1SIZ.EQ.0)RETURN
C
      CALL GETLST(T,1,1,1,ISPIN,ILIST)
C
C COMPUTE NORM OF T1 VECTOR
C
      X=SNRM2(NT1SIZ,T,1)
      T1NORM=X
C
C PUT NTOP LARGEST ELEMENTS INTO TOPT1 AND THEIR ASSOCIATED INDICES INTO
C   ITOPT1.
C
      CALL SCANVC(T,TOPT1,ITOPT1,NTOP,NT1SIZ)
      DO 10 IRANK=1,NTOP
       IUNPK=SYVEC(ITOPT1(IRANK))
       A(IRANK)=IGETA(IUNPK,NVRT)+NOCCO(ISPIN)
       I(IRANK)=IGETI(IUNPK,NVRT)
10    CONTINUE
cjp
      if(isbwcc) then
        write(*,201)type,SPCASE(ISPIN),iref
        else
      WRITE(*,200)TYPE,SPCASE(ISPIN)
        endif
200   FORMAT(T3,' Largest ',A1,'1 amplitudes for spin case ',A2,':')
201   format(T3,' Largest ',A1,'1 amplitudes for spin case ',A2,
     +   ' of reference no.: ',i3)
      IF(ISPIN.EQ.3)WRITE(*,299)
      WRITE(*,300)
299   FORMAT(3X,3(' ',3X,'_',3X,' ',3X,'_',13X))
300   FORMAT(3X,3('i',3X,' ',3X,'a',3X,' ',13X))
      WRITE(*,400)
400   FORMAT(77('-'))
      if(isbwcc) then
      if(bwgossip) then
        write(*,501) (irank,i(irank),a(irank),
     &         invhnum(i(irank),iref,ispin),
     &        invpnum(a(irank)-nocco(ispin),iref,ispin),
     &         topt1(irank),irank=1,ntop)
        else
         write(*,500)(invhnum(i(irank),iref,ispin),
     &      invpnum(a(irank)-nocco(ispin),iref,ispin),
     &              topt1(irank),irank=1,ntop)
        endif
      else
      WRITE(*,500)(I(IRANK),A(IRANK),
     &                 TOPT1(IRANK),IRANK=1,NTOP)
      endif
      WRITE(*,400)
      WRITE(*,600)TYPE,SPCASE(ISPIN),NT1SIZ,T1NORM
      WRITE(*,400)
600   FORMAT(T3,' Norm of ',A1,'1',A2,' vector (',I9,
     &        ' symmetry allowed elements):',F14.10,'.')
500   FORMAT((2('[',I3,1X,3X,1X,I3,1X,3X,']',F8.5,1X),'[',I3,1X,
     &3X,1X,I3,1X,3X,']',F8.5))
cjp
501    format(i4,':',i4,1x,i4,':true indices:',i4,1x,i4,' : ',f12.8)
      RETURN
      END

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      subroutine handle_call(optable, noptable, proctab, debug,
     *                start_op, end_op, iop)
c----------------------------------------------------------------------------
c   handle_call: Saves the current start_op, end_op and iop on the stack,
c                then determines a new start_op, end_op corresponding to 
c                target proc.  Finally, the new value of iop is set to 
c                the first instruction of the target proc.
c
c   Arguments:
c      optable		Operation table
c      noptable		Number of instructions in optable
c      debug		Debug flag
c      start_op         Input/output argument
c      end_op		Input/output argument
c      iop		Input/output argument
c 
c-----------------------------------------------------------------------------
      implicit none
      include 'interpreter.h'
      include 'mpif.h'
      include 'trace.h'
      include 'parallel_info.h'

      integer noptable, start_op, end_op, iop
      integer optable(loptable_entry, noptable)
      integer proctab(2,*)
      integer timer
  
      integer i, ierr, istat, target
      integer push_do 
      logical debug 
      
      if (optable(c_opcode, iop) .ne. call_op) return

c----------------------------------------------------------------------------
c   Start the procedure timer.
c----------------------------------------------------------------------------

      timer = optable(c_op1_array,iop)
      call timer_start(timer)

c---------------------------------------------------------------------------
c   We have a call_op.  Find the target.
c---------------------------------------------------------------------------

      target = optable(c_result_array,iop)
      if (trace .and. and(tracelevel, proc_trace) .ne. 0) then
         print *,'Task ',me,' Calling procedure at line ',
     *       optable(c_lineno,target),' from line ',
     *       optable(c_lineno,iop) 
      endif

c----------------------------------------------------------------------------
c   Save return values on stack.
c----------------------------------------------------------------------------

      istat = push_do(start_op, end_op)
      if (istat .lt. 0) then
         print *,'Task ',me,
     *       ' Error in handle_call: stack overflow'
         call abort_job()
      endif

      istat = push_do(iop+1, timer)
      if (istat .lt. 0) then
         print *,'Task ',me,
     *       ' Error in handle_call: stack overflow'
         call abort_job()
      endif

c----------------------------------------------------------------------------
c   Determine the new program range.
c----------------------------------------------------------------------------

      start_op = target
      end_op   = proctab(2,1)
      iop      = start_op

      return
      end

         SUBROUTINE  A2B__WRITE_NEW
     +
     +                    ( UNEW,TITLE1,TITLE2,
     +                      NSHELL,MAXCNTR,MAXPRIM,
     +                      LANGSH,NCNTSH,NPRMSH,
     +                      ISCR,MEXP,MCEF,EXPNT,COEFS )
     +
     +
C-----------------------------------------------------------------------
C  OPERATION   : A2B__WRITE_NEW
C  MODULE      : ACESII BASIS CONVERTER
C  MODULE-ID   : A2B
C  SUBROUTINES : none
C  DESCRIPTION : This routine will analyze the given exponents and
C                coefficients, organize and map them, and then generate
C                a new ZMAT.BAS (ZMAT.NEW).
C
C                Input:
C
C                     UACES   = The unit number for the ZMAT.BAS
C                     TITLE1  = The first line of the ZMAT.BAS,
C                               i.e. the atom and basis set name
C                     TITLE2  = The second line of the ZMAT.BAS,
C                               i.e. where the basis set was obtained
C                     NSHELL  = The number of shells in the ZMAT.BAS
C                     MAXCNTR = The maximum number of contracted
C                               functions in the basis set
C                     MAXPRIM = The maximum number of primitive
C                               functions in the basis set
C                     LANGSH  = An array of angular momentum numbers
C                     NCNTSH  = An array of the number of contracted
C                               functions for a given angular momenta
C                     NPRMSH  = An array of the number of primitive
C                               functions for a given angular momenta
C                     ISCR    = An integer scratch array
C                     MEXP    = A modified exponent matrix
C                     MCEF    = A modified coefficient matrix that matches
C                               MEXP
C                     EXPNT   = A matrix of the exponents for a given
C                               angular momenta 
C                     COEFS   = A matrix of the coefficients for a 
C                               given angular momenta and contracted
C
C                Output:
C
C                     There is NO output for this routine in terms of
C                     variables!  A new file is generated though.
C
C
C  AUTHOR      : Thomas Watson Jr.
C------------------------------------------------------------------------
C
C
C             ...include files and declare variables.
C
C
         IMPLICIT   NONE

         INTEGER    I,J,K,L,KK,IANG,JUNK
         INTEGER    ISTART,IEND,PART,LOOP
         INTEGER    IPRIM,ICNTR,ICNT,IOFF,ICOUNT
         INTEGER    UNEW,ACESEXP,ACESCNT,ACESSH
         INTEGER    NSHELL,MAXCNTR,MAXPRIM,TOTSH

         CHARACTER*(*)  TITLE1,TITLE2

         DOUBLE PRECISION  DCHECK
         DOUBLE PRECISION  ZERO,CTHRESH

         INTEGER    LANGSH (1:NSHELL)
         INTEGER    NCNTSH (1:NSHELL)
         INTEGER    NPRMSH (1:NSHELL)

         DOUBLE PRECISION  EXPNT (1:NSHELL,1:MAXPRIM)
         DOUBLE PRECISION  COEFS (1:NSHELL,1:MAXCNTR,1:MAXPRIM)

         INTEGER           ISCR  (1:NSHELL*MAXPRIM*MAXCNTR)
         DOUBLE PRECISION  MEXP  (1:NSHELL,1:MAXCNTR,1:MAXPRIM)
         DOUBLE PRECISION  MCEF  (1:NSHELL,1:MAXCNTR,1:MAXPRIM)

         PARAMETER  ( ZERO    = 0.0D0   )
         PARAMETER  ( CTHRESH = 0.1D-06 )
         PARAMETER  ( ACESEXP = 5       )
         PARAMETER  ( ACESCNT = 7       )
         PARAMETER  ( ACESSH  = 14      )
C
C
C------------------------------------------------------------------------
C
C
C             ...Zero out the appropriate arrays!
C
C
         DO I = 1, NSHELL
         DO J = 1, MAXCNTR
         DO K = 1, MAXPRIM

            MEXP (I,J,K) = ZERO
            MCEF (I,J,K) = ZERO

         END DO
         END DO
         END DO
C
C
C             ...Write out the titles!
C
C
         WRITE (UNEW,'(A)')  TITLE1
         WRITE (UNEW,'(A)')  TITLE2
         WRITE (UNEW,  *  )  ''
C
C
C             ...Write out the newly formatted 'number' of shells and
C                angular momentum line!
C
C
         TOTSH = 0
         IOFF  = 0
         DO I = 1, NSHELL
            ICNT  = NCNTSH (I)
            IANG  = LANGSH (I)
            TOTSH = TOTSH + ICNT
            DO J = 1, ICNT
               ISCR (IOFF + J) = IANG
            END DO
            IOFF = IOFF + ICNT
         END DO

         WRITE (UNEW,'(I3)') TOTSH

         IF (TOTSH .GT. ACESSH) THEN

            PART = MOD (TOTSH,ACESSH)
            LOOP = (TOTSH - PART) / ACESSH
            ISTART = 1
            IEND   = ISTART + ACESSH - 1
            DO I = 1, LOOP
               WRITE (UNEW,'(14I5)') (ISCR (J), J = ISTART, IEND)
               ISTART = ISTART + ACESSH
               IF ((TOTSH - IEND) .GT. ACESSH) THEN
                  IEND = IEND + ACESSH
               ELSE
                  IEND = TOTSH
               ENDIF
            END DO

            IF (PART .GT. 0) THEN
               WRITE (UNEW,'(14I5)') (ISCR (J), J = ISTART, IEND)
            END IF

         ELSE
            WRITE (UNEW,'(14I5)') (ISCR (J), J = 1, TOTSH)
         END IF
C
C
C             ...This is the easy part.  Since each contracted function
C                is written out in all its glory, the number of 
C                contracted functions is 1!
C
C
         IOFF  = 0
         DO I = 1, NSHELL
            ICNT  = NCNTSH (I)
            DO J = 1, ICNT
               ISCR (IOFF + J) = 1
            END DO
            IOFF = IOFF + ICNT
         END DO

         IF (TOTSH .GT. ACESSH) THEN

            PART = MOD (TOTSH,ACESSH)
            LOOP = (TOTSH - PART) / ACESSH
            ISTART = 1
            IEND   = ISTART + ACESSH - 1
            DO I = 1, LOOP
               WRITE (UNEW,'(14I5)') (ISCR (J), J = ISTART, IEND)
               ISTART = ISTART + ACESSH
               IF ((TOTSH - IEND) .GT. ACESSH) THEN
                  IEND = IEND + ACESSH
               ELSE
                  IEND = TOTSH
               ENDIF
            END DO

            IF (PART .GT. 0) THEN
               WRITE (UNEW,'(14I5)') (ISCR (J), J = ISTART, IEND)
            END IF

         ELSE
            WRITE (UNEW,'(14I5)') (ISCR (J), J = 1, TOTSH)
         END IF
C
C
C             ...Now write out the the number of primitive functions
C                for that contracted orbital of given angular momenta!
C
C
         IOFF = 0
         DO I = 1, NSHELL
            ICNTR = NCNTSH (I)
            IPRIM = NPRMSH (I)
            DO J = 1, ICNTR

               ICOUNT = 0
               KK     = 0
               DO K = 1, IPRIM
                  DCHECK = DABS (COEFS (I,J,K))
                  IF (DCHECK .GT. CTHRESH) THEN
                     ICOUNT = ICOUNT + 1
                     KK     = KK + 1
                     MEXP (I,J,KK) = EXPNT (I,K)
                     MCEF (I,J,KK) = COEFS (I,J,K)
                  END IF
               END DO

               ISCR (IOFF + J) = ICOUNT

            END DO
            IOFF = IOFF + ICNTR
         END DO

         IF (TOTSH .GT. ACESSH) THEN

            PART = MOD (TOTSH,ACESSH)
            LOOP = (TOTSH - PART) / ACESSH
            ISTART = 1
            IEND   = ISTART + ACESSH - 1
            DO I = 1, LOOP
               WRITE (UNEW,'(14I5)') (ISCR (J), J = ISTART, IEND)
               ISTART = ISTART + ACESSH
               IF ((TOTSH - IEND) .GT. ACESSH) THEN
                  IEND = IEND + ACESSH
               ELSE
                  IEND = TOTSH
               ENDIF
            END DO

            IF (PART .GT. 0) THEN
               WRITE (UNEW,'(14I5)') (ISCR (J), J = ISTART, IEND)
            END IF

         ELSE
            WRITE (UNEW,'(14I5)') (ISCR (J), J = 1, TOTSH)
         END IF

         WRITE (UNEW,  *  )  ''
C
C
C             ...To summarize so far:
C
C                  ISCR contains the number of primitives per contracted
C                  function.
C
C                  MEXP contains the exponents of the contracted function
C                  all moved to the top.
C
C                  MCEF contains the coefficients matched with the exponents
C                  in MEXP.
C
C             ...All we have to do now is loop over and write the file!
C
C
         IOFF = 0
         DO I = 1, NSHELL
            ICNTR = NCNTSH (I)
            DO J = 1, ICNTR
               IPRIM = ISCR (IOFF + J)
               WRITE (UNEW,'(5F14.6)')  (MEXP (I,J,K), K = 1, IPRIM)
               WRITE (UNEW,*) ''
               DO K = 1, IPRIM
                  WRITE (UNEW,'(F10.7,1X)') MCEF (I,J,K)
               END DO
               WRITE (UNEW,*) ''
            END DO
            IOFF = IOFF + ICNTR
         END DO
C
C
C             ...ready!
C
C
         RETURN
         END

      SUBROUTINE NUCDIP(Q,ICHRG,NATOMS)
C
C SUBROUTINE COMPUTES NUCLEAR CONTRIBUTION TO DIPOLE MOMENT AND WRITES
C  RESULT TO DISK FILE 'NUCDIP'.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL YESNO
      DIMENSION Q(3*NATOMS),ICHRG(NATOMS),DIPNUC(3)
#include "io_units.par"
C
C COMPUTE X Y AND Z COMPONENTS.
C
      CALL ZERO(DIPNUC,3)
      DO 10 I=1,3
       DO 15 J=1,NATOMS
        DIPNUC(I)=DIPNUC(I)+FLOAT(ICHRG(J))*Q(3*(J-1)+I)
 15    CONTINUE
 10   CONTINUE
C
C CHECK TO SEE IF NUCDIP IS THERE.  IF IT IS, THEN VERY CAREFULLY
C  GET RID OF IT.
C
      INQUIRE(FILE=NDFil,EXIST=YESNO)
      IF(YESNO)THEN
       INQUIRE(FILE=NDFil,OPENED=YESNO,NUMBER=LUOLD)
       IF(YESNO)THEN
        CLOSE(LUOLD,STATUS='DELETE')
       ELSE
        OPEN(UNIT=LUNucD,FILE=NDFil,FORM='UNFORMATTED',
     &   STATUS='OLD')
        CLOSE(LUNucD,STATUS='DELETE')
       ENDIF
      ENDIF
C
C OPEN NUCDIP AND WRITE OUT THE X Y AND Z COMPONENTS.
C
      OPEN(UNIT=LUNucD,FILE=NDFil,FORM='UNFORMATTED',
     &  STATUS='NEW')
      WRITE(81)DIPNUC
      CLOSE(UNIT=LUNucD,STATUS='KEEP')
      RETURN
      END

      SUBROUTINE NUCDIP(Q,ICHRG,NATOMS)
C
C SUBROUTINE COMPUTES NUCLEAR CONTRIBUTION TO DIPOLE MOMENT AND WRITES
C  RESULT TO DISK FILE 'NUCDIP'.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      LOGICAL YESNO
      DIMENSION Q(3*NATOMS),ICHRG(NATOMS),DIPNUC(3)
c io_units.par : begin

      integer    LuOut
      parameter (LuOut = 6)

      integer    LuErr
      parameter (LuErr = 6)

      integer    LuBasL
      parameter (LuBasL = 1)
      character*(*) BasFil
      parameter    (BasFil = 'BASINF')

      integer    LuVMol
      parameter (LuVMol = 3)
      character*(*) MolFil
      parameter    (MolFil = 'MOL')
      integer    LuAbi
      parameter (LuAbi = 3)
      character*(*) AbiFil
      parameter    (AbiFil = 'INP')
      integer    LuCad
      parameter (LuCad = 3)
      character*(*) CadFil
      parameter    (CadFil = 'CAD')

      integer    LuZ
      parameter (LuZ = 4)
      character*(*) ZFil
      parameter    (ZFil = 'ZMAT')

      integer    LuGrd
      parameter (LuGrd = 7)
      character*(*) GrdFil
      parameter    (GrdFil = 'GRD')

      integer    LuHsn
      parameter (LuHsn = 8)
      character*(*) HsnFil
      parameter    (HsnFil = 'FCM')

      integer    LuFrq
      parameter (LuFrq = 78)
      character*(*) FrqFil
      parameter    (FrqFil = 'FRQARC')

      integer    LuDone
      parameter (LuDone = 80)
      character*(*) DonFil
      parameter    (DonFil = 'JODADONE')

      integer    LuNucD
      parameter (LuNucD = 81)
      character*(*) NDFil
      parameter    (NDFil = 'NUCDIP')

      integer LuFiles
      parameter (LuFiles = 90)

c io_units.par : end
C
C COMPUTE X Y AND Z COMPONENTS.
C
      CALL ZERO(DIPNUC,3)
      DO 10 I=1,3
       DO 15 J=1,NATOMS
        DIPNUC(I)=DIPNUC(I)+FLOAT(ICHRG(J))*Q(3*(J-1)+I)
 15    CONTINUE
 10   CONTINUE
C
C CHECK TO SEE IF NUCDIP IS THERE.  IF IT IS, THEN VERY CAREFULLY
C  GET RID OF IT.
C
      INQUIRE(FILE=NDFil,EXIST=YESNO)
      IF(YESNO)THEN
       INQUIRE(FILE=NDFil,OPENED=YESNO,NUMBER=LUOLD)
       IF(YESNO)THEN
        CLOSE(LUOLD,STATUS='DELETE')
       ELSE
        OPEN(UNIT=LUNucD,FILE=NDFil,FORM='UNFORMATTED',
     &   STATUS='OLD')
        CLOSE(LUNucD,STATUS='DELETE')
       ENDIF
      ENDIF
C
C OPEN NUCDIP AND WRITE OUT THE X Y AND Z COMPONENTS.
C
      OPEN(UNIT=LUNucD,FILE=NDFil,FORM='UNFORMATTED',
     &  STATUS='NEW')
      WRITE(81)DIPNUC
      CLOSE(UNIT=LUNucD,STATUS='KEEP')
      RETURN
      END

      SUBROUTINE GETPTSPQR(SCRATCH, EHESS, EIGVH, DMR1, DMR2, HVALUE, 
     &                     EPS, NX, NDIM)
C
C Do a simple binary root seacrh for F(u) = hvalue in the range 
C of U_UPPER < u < U_LOWER. The EPS is the tolerance. 
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C

      PARAMETER (MAXTRY = 40, LUOUT = 6)
      LOGICAL UPDATE, NWTONRPSON, NEGEVAL, GENSTPSZ
C
      DIMENSION SCRATCH(NX*NX), EHESS(NDIM, NDIM), DMR1(NDIM, NDIM), 
     &          DMR2(NDIM, NDIM), EIGVH(NDIM, NDIM)
C
      DATA ZERO /0.0D0/, PTO5 /0.5d0/
C
      U_UPPER = 1.0d0
      U_LOWER = 0.0d0
      UNEW    = 0.0d0
      CURVTRE = 0.0d0
      UPDATE  = .FALSE.
      NWTONRPSON = .FALSE.
      GENSTPSZ   = .FALSE.
C
      IF (EHESS(1, 1) .LT. ZERO) THEN
C
         NEGEVAL = .TRUE.
         CALL QSDLINE(SCRATCH, EHESS, EIGVH, DMR1, DMR2, UNEW,
     &                U_UPPER, U_LOWER, HVALUE, CURVTRE, NDIM, NX,
     &                UPDATE, NWTONRPSON, NEGEVAL, GENSTPSZ)

         NEGEVAL = .FALSE. 
C
      ENDIF
C
 10   CONTINUE
C
      UNEW   = (U_UPPER + U_LOWER)/2.0d0
C
      CALL QSDLINE(SCRATCH, EHESS, EIGVH, DMR1, DMR2, UNEW, U_UPPER, 
     &             U_LOWER, HVALUE, CURVTRE, NDIM, NX, UPDATE, 
     &             NWTONRPSON, NEGEVAL, GENSTPSZ)
C
      IF (NWTONRPSON) RETURN
C
      CALL VADD(SCRATCH(1 + 3*NDIM), SCRATCH(1 + 5*NDIM), 
     &          SCRATCH(1 + 4*NDIM), NDIM, -1.00d0)
C
      dtmp = xdot(NDIM,SCRATCH(1 + 3*NDIM),1,SCRATCH(1 + 3*NDIM),1)
      DELTAX = DSQRT(dtmp)
C     
      IF (DABS(DELTAX) .GT. EPS) GO TO 10

C Now calculate the new point!
C
      UPDATE = .TRUE.
      UOLD   = (U_UPPER + U_LOWER)/2.0d0
C
      CALL QSDLINE(SCRATCH, EHESS, EIGVH, DMR1, DMR2, UOLD, U_UPPER,
     &             U_LOWER, HVALUE, CURVTRE, NDIM, NX, UPDATE,
     &             NWTONRPSON, NEGEVAL, GENSTPSZ)
C
      RETURN
      END

      SUBROUTINE PRINTMAT(VECNAM,NUMROWS,NUMCOLS)
C     
C     Designed to print out a double-precision
c     matrix from its vector form
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     
      DIMENSION VECNAM(NUMROWS*NUMCOLS)
C     
C     DO 20 I=1,(NUMROWS*NUMCOLS)
C        WRITE(*,*) VECNAM(I)
C     20 CONTINUE
C     
      NGRPS=NUMCOLS/5 
      MODVAL=MOD(NUMCOLS,5)
      DO 5 J=0,(NGRPS-1)
         DO 10 I=1,NUMROWS
            WRITE(*,"(5 4D12.4)") (VECNAM(J*
     $           NUMROWS*5+NUMROWS*II+I),II=0,4)
 10      CONTINUE
         WRITE(*,*)
         WRITE(*,*)
 5    CONTINUE
      IF (MODVAL.NE.0) THEN
         DO 20 I=1,NUMROWS
            WRITE(*,"(5 4D12.4)") (VECNAM(NGRPS*
     $           NUMROWS*5+NUMROWS*II+I),II=0,
     $           MODVAL-1)
 20      CONTINUE
         WRITE(*,*)
         WRITE(*,*)
      END IF
C     
      END SUBROUTINE PRINTMAT
      

c This routine performs all the symmetry analysis needed to generate the grid
c of displacements. It is essentially a method that uses and updates JOBARC
c records. NENER is returned solely to tell symcor that there are points to
c start working on (or not).

c INPUT
c char*4  DOIT
c integer NATOM
c integer ICRSIZ
c logical BPRINT

c OUTPUT
c integer ICORE(ICRSIZ)
c integer NENER

c RECORDS
c get DOIT//'ORDR'
c get DOIT//'NORB'
c get DOIT//'NIRX'
c get 'COMPORDR'
c get 'COMPNORB'
c get 'COMPNIRX'

#include "flags.h"

      subroutine init_fd(doit,natom,icore,icrsiz,nener,bprint)
      implicit none

      character*4 doit
      integer natom, icore(*), icrsiz, nener
      logical bprint

      integer iorder, iorderf, iorderc
      integer norbit, norbitf, norbitc
      integer nirrep, nirrepf, nirrepc
      integer I000, I010, I020, I030, I040, I050, I060, I070, I080, I090
      integer I100, I110, I120, I130, I140, I150, I160, I170, I180, I190
      integer I200, I0
      character*8 irrnm(32), label(32)

#include "control.com" /* for ROTPROJ */
#include "machsp.com"

      CALL GETREC(20,'JOBARC',DOIT//'ORDR',1,IORDERF)
      CALL GETREC(20,'JOBARC',DOIT//'NORB',1,NORBITF)
      CALL GETREC(20,'JOBARC','COMPORDR',1,IORDERC)
      CALL GETREC(20,'JOBARC','COMPNORB',1,NORBITC)
      IORDER=MAX(IORDERF,IORDERC)
      NORBIT=MAX(NORBITF,NORBITC)

      I0 = 1

      I000=I0
      I010=I000 + IINTFP*IORDER*9
      I020=I010 + IINTFP*IORDER*IORDER*9
      I030=I020 + IINTFP*IORDER*IORDER
      I040=I030 + IINTFP*IORDER*IORDER
      I050=I040 + 3*IORDER
      I060=I050 + IORDER*IORDER
      I080=I060 + IORDER + IAND(IORDER,1)
      I090=I080 + 6*IORDER
      I100=I090 + IINTFP*3*IORDER

      CALL CHRTABLE(IORDERF,ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030),ICORE(I040),ICORE(I050),ICORE(I060),
     &              IRRNM,ICORE(I080),DOIT,ICORE(I090))
      CALL CHRTABLE(IORDERC,ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030),ICORE(I040),ICORE(I050),ICORE(I060),
     &              IRRNM,ICORE(I080),'COMP',ICORE(I090))

      CALL GETREC(-1,'JOBARC',DOIT//'NIRX',1,NIRREPF)
      CALL GETREC(-1,'JOBARC','COMPNIRX',1,NIRREPC)
      NIRREP=MAX(NIRREPF,NIRREPC)

      I010=I000 + IINTFP*NATOM*NATOM*9
      I020=I010 + IINTFP*NATOM*NATOM*9
      I030=I020 + IINTFP*NATOM*NATOM*9
      I040=I030 + IINTFP*MAX(3*NATOM,NIRREPF*IORDER)
      I050=I040 + IINTFP*MAX(6*NATOM,9*IORDER)
      I060=I050 + IINTFP*MAX(6*NATOM,NIRREPF)
      I060=I050
      I070=I060 + IINTFP*9*NATOM*NATOM*3*NATOM
      I080=I070 + MAX(MAX(2,IORDER)*NATOM,9*NATOM*NATOM)
      I090=I080 + NATOM
      I100=I090 + NATOM + IAND(NATOM,1)
      I110=I100 + IINTFP*NATOM*NATOM*MAX(18,IORDER)
      I120=I110 + IINTFP*NATOM*NATOM*18
      I130=I120 + IINTFP*NATOM*NATOM*18
      BPRINT =.TRUE.

      CALL VIBINF(NATOM,NIRREPF,IORDERF,ICORE(I000),
     &            ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &            LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &            ICORE(I090),ICORE(I100),DOIT)
      CALL SYMADQ(NATOM,NIRREPC,IORDERC,NORBITC,ICORE(I000),
     &            ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &            LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &            ICORE(I090),ICORE(I100),ICORE(I110),ICORE(I120),
     &            ICORE(I130),'COMP',1)

      CALL TRAPRJ(NATOM,ICORE(I000),ICORE(I010),ICORE(I020),
     &            ICORE(I030))

      IF (ROTPROJ) THEN
         CALL ROTPRJ(NATOM,ICORE(I000),ICORE(I010),ICORE(I020),
     &              ICORE(I030))
      END IF

      CALL SCHMIDT(NATOM,ICORE(I010),ICORE(I020))

      CALL COLLECT(NATOM,NIRREPC,ICORE(I000),
     &             ICORE(I010),ICORE(I020),ICORE(I030),LABEL,
     &             'COMP')

      IF (BPRINT) THEN
         CALL PRTCOORD(NATOM,NIRREPC,0,ICORE(I000),ICORE(I010),
     &                 LABEL,'COMP',.FALSE.)
      END IF

      CALL SYMADQ(NATOM,NIRREPF,IORDERF,NORBITF,ICORE(I000),
     &            ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &            LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &            ICORE(I090),ICORE(I100),ICORE(I110),ICORE(I120),
     &            ICORE(I130),DOIT,2)
      CALL PRDEGEN(NATOM,NIRREPF,IORDERF,NORBITF,ICORE(I000),
     &             ICORE(I010),ICORE(I020),ICORE(I030),ICORE(I040),
     &             LABEL,ICORE(I060),ICORE(I070),ICORE(I080),
     &             ICORE(I090),ICORE(I100),DOIT)

      IF (BPRINT) THEN
         CALL PRTCOORD(NATOM,NIRREPF,NIRREPC,ICORE(I000),ICORE(I010),
     &                 LABEL,DOIT,.TRUE.)
      END IF

      I010=I000
      I020=I010 + 3*NATOM
      I030=I020 + 9*NATOM*NATOM
      I040=I030 + 3*NATOM + IAND(NATOM,1)
      I200=I040 + IINTFP*9*NATOM*NATOM*3*NATOM
#ifdef _DEBUG_LVL0
      Print*, "Entering set points"
#endif
      CALL SETPTS(NATOM,NIRREPF,DOIT,
     &            NENER,IRRNM,ICORE(I010),ICORE(I020),ICORE(I030),
     &            ICORE(I040),ICORE(I200),(ICRSIZ-I200+I0)/IINTFP)

      return
c     end subroutine init_fd
      end

C  Copyright (c) 2003-2010 University of Florida
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.

C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  The GNU General Public License is included in this distribution
C  in the file COPYRIGHT.
      SUBROUTINE PREVIB(NRX,H,SCRATCH,GRAD)
C
C FRONT END TO NORMAL COORDINATE CALCULATION.  COMPRESSES DUMMY
C   ATOMS OUT OF VECTORS PASSED THROUGH COMMON (VARIABLE NAMES,
C   ATOMIC MASSES, COORDINATES) AND RETURNS THE NUMBER OF REAL
C   ATOMS * 3.  ALSO CALCULATE VECTOR WHICH RELATES ABSOLUTE
C   Z-MATRIX POSITION WITH "REAL ATOM" POSITION.
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
#include "mxatms.par"
      PARAMETER (TOL = 1.D-3)
      DIMENSION IREPOS(MXATMS)
C     Labels used throughout the program:
C     ZSYM    Atomic symbol given for each line of the Z-matrix
C     VARNAM  Symbols of all variable parameters
C     PARNAM  Symbols of all variables *and* (fixed) parameters
C
#include "cbchar.com"
#include "coord.com"
C
      COMMON /USINT/ NX, NXM6, IARCH, NCYCLE, NUNIQUE, NOPT
C     Main OPTIM control data
C     IPRNT   Print level - not used yet by most routines
C     INR     Step-taking algorithm to use
C     IVEC    Eigenvector to follow (TS search)
C     IDIE    Ignore negative eigenvalues
C     ICURVY  Hessian is in curviliniear coordinates
C     IMXSTP  Maximum step size in millibohr
C     ISTCRT  Controls scaling of step
C     IVIB    Controls vibrational analysis
C     ICONTL  Negative base 10 log of convergence criterion.
C     IRECAL  Tells whether Hessian is recalculated on each cyc
C     INTTYP  Tells which integral program is to be used
C              = 0 Pitzer
C              = 1 VMol
C     XYZTol  Tolerance for comparison of cartesian coordinates
C
      COMMON/MACHSP/IINTLN,IFLTLN,IINTFP,IALONE,IBITWD
      COMMON/OPTCTL/IPRNT,INR,IVEC,IDIE,ICURVY,IMXSTP,ISTCRT,IVIB,
     &   ICONTL,IRECAL,INTTYP,IDISFD,IGRDFD,ICNTYP,ISYM,IBASIS,
     &   XYZTOL
      COMMON/FLAGS/IFLAGS(100),IFLAGS2(500)
      COMMON/ORIENT/ORIENT(3,3)
#include "io_units.par"
      CHARACTER*5 JUNK(MXATMS)
      DIMENSION SCRATCH(3*NX),H(NX,NX),GRAD(NX)
C
C DETERMINE NUMBER OF REAL ATOMS (NOT DUMMIES).  THIS
C  DETERMINES THE RANK OF THE HESSIAN.  ALSO, SIMULTANEOUSLY
C  REMOVE DUMMY ATOM ENTRIES FROM Q,ATMASS AND ZSYM VECTORS.
C
C
C FIRST GENERATE A COMPRESSED HESSIAN.  REMOVE DUMMY ATOM COLUMNS
C  FIRST. CODED SO THAT THE ARRAY CAN SUBSEQUENTLY BE PASSED INTO
C  VIB1 AS A NRX X NRX ARRAY.
C
      IX=0
      JX=1
      DO 100 J=1,NX
      DO 100 I=1,NX
       INK=1+(I-0.1)/3
       JNK=1+(J-0.1)/3
       IF(ATMASS(INK).GT.0.1.AND.ATMASS(JNK).GT.0.1)THEN
       IX=IX+1
       H(IX,JX)=H(I,J)
       IF(IX.EQ.NX)IX=0
       IF(IX.EQ.0)JX=JX+1
      ENDIF
100   CONTINUE
C
      Call igetrec(20,'JOBARC','NREALATM',1,Nreals)
      NRX = 3*NREALS
C
C The Cartesian Hessian ordered according to the input and without dummy
C atom contributions. Used in Coriolis Coupling modlue in a2proc.
C Ajith Perera, 02/2009
c
      CALL DPUTREC(20,'JOBARC','CARTHESC',NRX*NRX,H)
      CALL ZERO(SCRATCH,3*NX)
C
#ifdef _DEBUG_LVL0
C      Write(6,*) "@-previb, The Hessian"
       CALL output(h, 1, NRX, 1, NRX, NRX, NRX, 1)
       Write(6,*)
       Write(6,*) "@-previb, The griadients"
       Write(6, "(3F10.5)") (GRAD(I), I=1,NX)
#endif
C
C
C NOW COMPRESS THE VARIOUS ARRAYS.
C
 
      NREAL=0
      NRX=0
      CALL ZERO(SCRATCH,3*NX)
      CALL IZERO(IREPOS,NATOMS)
      DO 3 I=1,NATOMS
      IF(ATMASS(I).GE.0.5D0)THEN
       NREAL=NREAL+1
       IREPOS(I)=NREAL
       SCRATCH(NREAL)=ATMASS(I)
       JUNK(NREAL)=ZSYM(I)
       CALL XDCOPY(3,GRAD(3*I-2),1,GRAD(3*NREAL-2),1)
       CALL VADD(SCRATCH(NX+3*NREAL-2),SCRATCH(NX+3*NREAL-2)
     &,Q(3*I-2),3,1.D0)
      ENDIF
 3    CONTINUE
      CALL ZERO(Q,NX)
      CALL ZERO(ATMASS,NATOMS)
      NRX=3*NREAL
      CALL VADD(Q,Q,SCRATCH(NX+1),NRX,1.D0)
      CALL VADD(ATMASS,ATMASS,SCRATCH,NREAL,1.D0)
      DO 10 I=1,NREAL
      ZSYM(I)=JUNK(I)
 10   CONTINUE
      DO 11 I=NREAL+1,NATOMS
      ZSYM(I)='     '
 11   CONTINUE
      IF(NREAL.EQ.0)THEN
       WRITE(LUOUT,8702)
 8702  FORMAT(T3,'@PREVIB-F, No real atoms found in ATMASS string.')
       Call ErrEx
      ENDIF
      CALL IPUTREC(20,'JOBARC','DUMSTRIP',NATOMS,IREPOS)
C
C COMPRESS DUMMY ATOM STUFF OUT OF BMATRIX
C
      IF(IFLAGS(68).NE.1) THEN
C
       CALL DGETREC(20,'JOBARC','BMATRIX ',NX*NXM6,SCRATCH)
       IX=0
       JX=0
       DO 110 I=1,NX
        INK=1+(I-0.1)/3
        JX=JX+1
        IF(IREPOS(INK).NE.0)THEN
         IX=IX+1
         IF(IX.NE.JX)THEN
          IOFF=1+(IX-1)*NXM6
          JOFF=1+(JX-1)*NXM6
          CALL XDCOPY(NXM6,SCRATCH(JOFF),1,SCRATCH(IOFF),1)
         ENDIF
        ENDIF
110    CONTINUE
       CALL DPUTREC(20,'JOBARC','BMATRIXC',3*NREAL*NXM6,SCRATCH)
C
      ENDIF
C
      RETURN
      END
